/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `band`
--

DROP TABLE IF EXISTS `band`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `band` (
  `day_of_week` varchar(10) NOT NULL,
  `start_time` time NOT NULL,
  `end_time` time NOT NULL,
  `zone` varchar(2) NOT NULL,
  KEY `start_time` (`start_time`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `band`
--

LOCK TABLES `band` WRITE;
/*!40000 ALTER TABLE `band` DISABLE KEYS */;
INSERT INTO `band` VALUES ('Monday','08:00:00','18:59:59','F1'),('Tuesday','08:00:00','18:59:59','F1'),('Wednesday','08:00:00','18:59:59','F1'),('Thursday','08:00:00','18:59:59','F1'),('Friday','08:00:00','18:59:59','F1'),('Monday','07:00:00','07:59:59','F2'),('Tuesday','07:00:00','07:59:59','F2'),('Wednesday','07:00:00','07:59:59','F2'),('Thursday','07:00:00','07:59:59','F2'),('Friday','07:00:00','07:59:59','F2'),('Monday','19:00:00','22:59:59','F2'),('Tuesday','19:00:00','22:59:59','F2'),('Wednesday','19:00:00','22:59:59','F2'),('Thursday','19:00:00','22:59:59','F2'),('Friday','19:00:00','22:59:59','F2'),('Saturday','07:00:00','22:59:59','F2'),('Monday','00:00:00','06:59:59','F3'),('Tuesday','00:00:00','06:59:59','F3'),('Wednesday','00:00:00','06:59:59','F3'),('Thursday','00:00:00','06:59:59','F3'),('Friday','00:00:00','06:59:59','F3'),('Saturday','00:00:00','06:59:59','F3'),('Monday','23:00:00','23:59:59','F3'),('Tuesday','23:00:00','23:59:59','F3'),('Wednesday','23:00:00','23:59:59','F3'),('Thursday','23:00:00','23:59:59','F3'),('Friday','23:00:00','23:59:59','F3'),('Saturday','23:00:00','23:59:59','F3'),('Sunday','00:00:00','23:59:59','F3');
/*!40000 ALTER TABLE `band` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `classes`
--

DROP TABLE IF EXISTS `classes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `classes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `classes`
--

LOCK TABLES `classes` WRITE;
/*!40000 ALTER TABLE `classes` DISABLE KEYS */;
INSERT INTO `classes` VALUES (1,'single run devices'),(2,'heating/cooling/ambient devices'),(3,'e-car'),(4,'smart meter'),(5,'continuous running'),(7,'No class');
/*!40000 ALTER TABLE `classes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `device_list`
--

DROP TABLE IF EXISTS `device_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `device_list` (
  `device_id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `name` varchar(45) NOT NULL,
  `template` int(11) NOT NULL,
  PRIMARY KEY (`device_id`),
  KEY `fk_device_list_1_idx` (`template`),
  CONSTRAINT `fk_device_list_1` FOREIGN KEY (`template`) REFERENCES `templates` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=1303 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `device_list`
--

LOCK TABLES `device_list` WRITE;
/*!40000 ALTER TABLE `device_list` DISABLE KEYS */;
INSERT INTO `device_list` VALUES (1,1,'user1',1),(2,1,'user1',45),(3,1,'user1',72),(4,1,'user1',71),(756,3,'user3',1),(757,3,'user3',71),(911,3,'user3',80),(1026,25,'Smart Meter',50),(1045,5,'wmtest',78),(1046,5,'wmtest',78),(1047,5,'wmtest',78),(1048,5,'wmtest',78),(1049,5,'wmtest',78),(1080,25,'mydw',74),(1120,7,'Lenmore Kitchen',74),(1121,7,'Lenmore Kitchen',74),(1131,8,'Lenmore Kitchen',74),(1179,3,'user3',44),(1180,3,'user3',28),(1212,100,'Solar Panel',1),(1213,100,'Smart Meter',45),(1214,100,'Refrigerator',60),(1270,100,'washingmachine',79),(1281,2,'Refrigerator',60),(1282,2,'Bulb',70),(1283,100,'zero',87),(1302,25,'lgtest',74);
/*!40000 ALTER TABLE `device_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `device_parameter`
--

DROP TABLE IF EXISTS `device_parameter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `device_parameter` (
  `device_type` int(11) NOT NULL,
  `parameter` varchar(30) NOT NULL,
  `value` varchar(45) NOT NULL,
  PRIMARY KEY (`device_type`,`parameter`),
  KEY `device_type` (`device_type`),
  KEY `parameter` (`parameter`),
  CONSTRAINT `fk_device_type` FOREIGN KEY (`device_type`) REFERENCES `device_type` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `device_parameter`
--

LOCK TABLES `device_parameter` WRITE;
/*!40000 ALTER TABLE `device_parameter` DISABLE KEYS */;
INSERT INTO `device_parameter` VALUES (1,'energyLevel',''),(1,'energy_max',''),(1,'lastTime',''),(1,'max_power_in',''),(1,'max_power_out',''),(1,'power_in',''),(1,'power_out',''),(2,'power_in',''),(2,'state',''),(5,'startedon',''),(5,'status',''),(5,'stoppedon','');
/*!40000 ALTER TABLE `device_parameter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `device_parameter_value`
--

DROP TABLE IF EXISTS `device_parameter_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `device_parameter_value` (
  `incremental` int(11) NOT NULL AUTO_INCREMENT,
  `id_device` int(11) NOT NULL,
  `parameter` varchar(30) NOT NULL,
  `value` varchar(30) NOT NULL,
  PRIMARY KEY (`incremental`),
  KEY `parameter` (`parameter`),
  KEY `fk_device_parameter_value_1_idx` (`id_device`),
  CONSTRAINT `deviceParameterConstraint` FOREIGN KEY (`parameter`) REFERENCES `device_parameter` (`parameter`),
  CONSTRAINT `fk_device_parameter_value_1` FOREIGN KEY (`id_device`) REFERENCES `device_list` (`device_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=50 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `device_parameter_value`
--

LOCK TABLES `device_parameter_value` WRITE;
/*!40000 ALTER TABLE `device_parameter_value` DISABLE KEYS */;
INSERT INTO `device_parameter_value` VALUES (42,1270,'startedon','2014-11-10 18:54:00'),(48,1282,'power_in','2014-11-10 18:54:00'),(49,1282,'state','2014-11-10 18:54:00');
/*!40000 ALTER TABLE `device_parameter_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `device_type`
--

DROP TABLE IF EXISTS `device_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `device_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(30) NOT NULL,
  `behaviour` int(11) NOT NULL DEFAULT '0',
  `superclassid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `type_UNIQUE` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `device_type`
--

LOCK TABLES `device_type` WRITE;
/*!40000 ALTER TABLE `device_type` DISABLE KEYS */;
INSERT INTO `device_type` VALUES (1,'Battery',2,7),(2,'Bulb',0,7),(3,'Solar Panel',1,7),(4,'Household Workload',0,5),(5,'Dishwasher',0,1),(6,'Refrigerator',0,5),(7,'Freezer',0,5),(8,'Boiler',0,5),(9,'TV',0,7),(10,'Video',0,7),(11,'PC',0,7),(12,'Washing machine',0,1),(16,'Clothes Dryer',0,1),(18,'Air Conditioner',0,5),(19,'Water Heater',0,5),(20,'Oven',0,1),(21,'Smart Meter',0,4);
/*!40000 ALTER TABLE `device_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devicestate`
--

DROP TABLE IF EXISTS `devicestate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devicestate` (
  `id` varchar(30) NOT NULL,
  `state` varchar(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devicestate`
--

LOCK TABLES `devicestate` WRITE;
/*!40000 ALTER TABLE `devicestate` DISABLE KEYS */;
INSERT INTO `devicestate` VALUES ('bulb','OFF');
/*!40000 ALTER TABLE `devicestate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hour_consumption`
--

DROP TABLE IF EXISTS `hour_consumption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hour_consumption` (
  `hour` time NOT NULL,
  `month` int(11) NOT NULL,
  `consumption` float NOT NULL,
  PRIMARY KEY (`hour`,`month`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hour_consumption`
--

LOCK TABLES `hour_consumption` WRITE;
/*!40000 ALTER TABLE `hour_consumption` DISABLE KEYS */;
INSERT INTO `hour_consumption` VALUES ('00:00:00',1,0),('00:00:00',2,0),('00:00:00',3,0),('00:00:00',4,0),('00:00:00',5,0),('00:00:00',6,0),('00:00:00',7,0),('00:00:00',8,0),('00:00:00',9,0),('00:00:00',10,0),('00:00:00',11,0),('00:00:00',12,0),('01:00:00',1,0),('01:00:00',2,0),('01:00:00',3,0),('01:00:00',4,0),('01:00:00',5,0),('01:00:00',6,0),('01:00:00',7,0),('01:00:00',8,0),('01:00:00',9,0),('01:00:00',10,0),('01:00:00',11,0),('01:00:00',12,0),('02:00:00',1,0),('02:00:00',2,0),('02:00:00',3,0),('02:00:00',4,0),('02:00:00',5,0),('02:00:00',6,0),('02:00:00',7,0),('02:00:00',8,0),('02:00:00',9,0),('02:00:00',10,0),('02:00:00',11,0),('02:00:00',12,0),('03:00:00',1,0),('03:00:00',2,0),('03:00:00',3,0),('03:00:00',4,0),('03:00:00',5,0),('03:00:00',6,0),('03:00:00',7,0),('03:00:00',8,0),('03:00:00',9,0),('03:00:00',10,0),('03:00:00',11,0),('03:00:00',12,0),('04:00:00',1,0),('04:00:00',2,0),('04:00:00',3,0),('04:00:00',4,0),('04:00:00',5,0),('04:00:00',6,0),('04:00:00',7,0),('04:00:00',8,0),('04:00:00',9,0),('04:00:00',10,0),('04:00:00',11,0),('04:00:00',12,0),('05:00:00',1,0),('05:00:00',2,0),('05:00:00',3,0),('05:00:00',4,0),('05:00:00',5,0.00806465),('05:00:00',6,0.0122506),('05:00:00',7,0.00867961),('05:00:00',8,0.00208179),('05:00:00',9,0),('05:00:00',10,0),('05:00:00',11,0),('05:00:00',12,0),('06:00:00',1,0),('06:00:00',2,0),('06:00:00',3,0.00672237),('06:00:00',4,0.0248809),('06:00:00',5,0.0325401),('06:00:00',6,0.033548),('06:00:00',7,0.0307864),('06:00:00',8,0.0252373),('06:00:00',9,0.0116052),('06:00:00',10,0),('06:00:00',11,0),('06:00:00',12,0),('07:00:00',1,0.00536395),('07:00:00',2,0.0266405),('07:00:00',3,0.0458255),('07:00:00',4,0.0532298),('07:00:00',5,0.0555755),('07:00:00',6,0.0553707),('07:00:00',7,0.0541183),('07:00:00',8,0.052045),('07:00:00',9,0.0467795),('07:00:00',10,0.0324275),('07:00:00',11,0.0104933),('07:00:00',12,0),('08:00:00',1,0.0672764),('08:00:00',2,0.0746864),('08:00:00',3,0.0762999),('08:00:00',4,0.0753684),('08:00:00',5,0.0735571),('08:00:00',6,0.0726352),('08:00:00',7,0.0729464),('08:00:00',8,0.0740488),('08:00:00',9,0.0750801),('08:00:00',10,0.0736084),('08:00:00',11,0.0693155),('08:00:00',12,0.0629387),('09:00:00',1,0.105877),('09:00:00',2,0.101075),('09:00:00',3,0.0958261),('09:00:00',4,0.0909475),('09:00:00',5,0.0874786),('09:00:00',6,0.0865044),('09:00:00',7,0.0879482),('09:00:00',8,0.0906038),('09:00:00',9,0.0944968),('09:00:00',10,0.0993655),('09:00:00',11,0.104447),('09:00:00',12,0.107369),('10:00:00',1,0.125825),('10:00:00',2,0.117545),('10:00:00',3,0.109713),('10:00:00',4,0.102593),('10:00:00',5,0.0979161),('10:00:00',6,0.0969027),('10:00:00',7,0.0991957),('10:00:00',8,0.103016),('10:00:00',9,0.108731),('10:00:00',10,0.11662),('10:00:00',11,0.123842),('10:00:00',12,0.128653),('11:00:00',1,0.137567),('11:00:00',2,0.127395),('11:00:00',3,0.118019),('11:00:00',4,0.109557),('11:00:00',5,0.104158),('11:00:00',6,0.103121),('11:00:00',7,0.105922),('11:00:00',8,0.110439),('11:00:00',9,0.117244),('11:00:00',10,0.12694),('11:00:00',11,0.135372),('11:00:00',12,0.140962),('12:00:00',1,0.140617),('12:00:00',2,0.129954),('12:00:00',3,0.120177),('12:00:00',4,0.111367),('12:00:00',5,0.10578),('12:00:00',6,0.104737),('12:00:00',7,0.10767),('12:00:00',8,0.112367),('12:00:00',9,0.119456),('12:00:00',10,0.12962),('12:00:00',11,0.138368),('12:00:00',12,0.144159),('13:00:00',1,0.134768),('13:00:00',2,0.125047),('13:00:00',3,0.116039),('13:00:00',4,0.107897),('13:00:00',5,0.10267),('13:00:00',6,0.101639),('13:00:00',7,0.104319),('13:00:00',8,0.108669),('13:00:00',9,0.115215),('13:00:00',10,0.12448),('13:00:00',11,0.132624),('13:00:00',12,0.138028),('14:00:00',1,0.120417),('14:00:00',2,0.113009),('14:00:00',3,0.105889),('14:00:00',4,0.0993856),('14:00:00',5,0.0950416),('14:00:00',6,0.0940389),('14:00:00',7,0.0960981),('14:00:00',8,0.0995974),('14:00:00',9,0.104811),('14:00:00',10,0.111868),('14:00:00',11,0.118532),('14:00:00',12,0.122985),('15:00:00',1,0.0982574),('15:00:00',2,0.0946605),('15:00:00',3,0.0904172),('15:00:00',4,0.0864119),('15:00:00',5,0.0834134),('15:00:00',6,0.0824544),('15:00:00',7,0.0835675),('15:00:00',8,0.0857695),('15:00:00',9,0.0889528),('15:00:00',10,0.0926451),('15:00:00',11,0.0969483),('15:00:00',12,0.0994161),('16:00:00',1,0.0595434),('16:00:00',2,0.0673175),('16:00:00',3,0.0697738),('16:00:00',4,0.0698174),('16:00:00',5,0.0685782),('16:00:00',6,0.067675),('16:00:00',7,0.0675812),('16:00:00',8,0.0681281),('16:00:00',9,0.0683354),('16:00:00',10,0.0657126),('16:00:00',11,0.0613403),('16:00:00',12,0.0554884),('17:00:00',1,0.0044883),('17:00:00',2,0.0226681),('17:00:00',3,0.0398022),('17:00:00',4,0.0474785),('17:00:00',5,0.0501846),('17:00:00',6,0.0499338),('17:00:00',7,0.0482665),('17:00:00',8,0.0457732),('17:00:00',9,0.040172),('17:00:00',10,0.026713),('17:00:00',11,0.00871728),('17:00:00',12,0),('18:00:00',1,0),('18:00:00',2,0),('18:00:00',3,0.00549588),('18:00:00',4,0.0210662),('18:00:00',5,0.0278206),('18:00:00',6,0.0285874),('18:00:00',7,0.0255355),('18:00:00',8,0.0202791),('18:00:00',9,0.0091204),('18:00:00',10,0),('18:00:00',11,0),('18:00:00',12,0),('19:00:00',1,0),('19:00:00',2,0),('19:00:00',3,0),('19:00:00',4,0),('19:00:00',5,0.00722067),('19:00:00',6,0.0106015),('19:00:00',7,0.00736555),('19:00:00',8,0.00194474),('19:00:00',9,0),('19:00:00',10,0),('19:00:00',11,0),('19:00:00',12,0),('20:00:00',1,0),('20:00:00',2,0),('20:00:00',3,0),('20:00:00',4,0),('20:00:00',5,0),('20:00:00',6,0),('20:00:00',7,0),('20:00:00',8,0),('20:00:00',9,0),('20:00:00',10,0),('20:00:00',11,0),('20:00:00',12,0),('21:00:00',1,0),('21:00:00',2,0),('21:00:00',3,0),('21:00:00',4,0),('21:00:00',5,0),('21:00:00',6,0),('21:00:00',7,0),('21:00:00',8,0),('21:00:00',9,0),('21:00:00',10,0),('21:00:00',11,0),('21:00:00',12,0),('22:00:00',1,0),('22:00:00',2,0),('22:00:00',3,0),('22:00:00',4,0),('22:00:00',5,0),('22:00:00',6,0),('22:00:00',7,0),('22:00:00',8,0),('22:00:00',9,0),('22:00:00',10,0),('22:00:00',11,0),('22:00:00',12,0),('23:00:00',1,0),('23:00:00',2,0),('23:00:00',3,0),('23:00:00',4,0),('23:00:00',5,0),('23:00:00',6,0),('23:00:00',7,0),('23:00:00',8,0),('23:00:00',9,0),('23:00:00',10,0),('23:00:00',11,0),('23:00:00',12,0);
/*!40000 ALTER TABLE `hour_consumption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irradiation`
--

DROP TABLE IF EXISTS `irradiation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irradiation` (
  `day` int(11) NOT NULL,
  `month` int(11) NOT NULL,
  `year` int(11) NOT NULL,
  `total_irradiation` float NOT NULL,
  PRIMARY KEY (`day`,`month`,`year`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irradiation`
--

LOCK TABLES `irradiation` WRITE;
/*!40000 ALTER TABLE `irradiation` DISABLE KEYS */;
INSERT INTO `irradiation` VALUES (1,1,2013,0.0333),(1,2,2013,0.0421),(1,3,2013,0.0328),(1,4,2013,0.0509),(1,5,2013,0.0309515),(1,6,2013,0.0421552),(1,7,2013,0.0330825),(1,8,2013,0.0306453),(1,9,2013,0.035758),(1,10,2013,0.0619252),(1,11,2013,0.0434405),(1,12,2013,0.0451888),(2,1,2013,0.0254),(2,2,2013,0.0073),(2,3,2013,0.0334),(2,4,2013,0.0347),(2,5,2013,0.0283889),(2,6,2013,0.0396608),(2,7,2013,0.0314633),(2,8,2013,0.0309304),(2,9,2013,0.0424654),(2,10,2013,0.0450303),(2,11,2013,0.0163143),(2,12,2013,0.04324),(3,1,2013,0.034),(3,2,2013,0.0353),(3,3,2013,0.0342),(3,4,2013,0.036),(3,5,2013,0.034912),(3,6,2013,0.0413356),(3,7,2013,0.0263835),(3,8,2013,0.0335673),(3,9,2013,0.0345796),(3,10,2013,0.00790245),(3,11,2013,0.0543489),(3,12,2013,0.0437272),(4,1,2013,0.0338),(4,2,2013,0.0413),(4,3,2013,0.0343),(4,4,2013,0.0349),(4,5,2013,0.0334476),(4,6,2013,0.043046),(4,7,2013,0.033654),(4,8,2013,0.029505),(4,9,2013,0.0333107),(4,10,2013,0.0197561),(4,11,2013,0.019693),(4,12,2013,0.0429963),(5,1,2013,0.0333),(5,2,2013,0.0339),(5,3,2013,0.0355),(5,4,2013,0.0241686),(5,5,2013,0.0280893),(5,6,2013,0.0396608),(5,7,2013,0.0320983),(5,8,2013,0.0316431),(5,9,2013,0.0325855),(5,10,2013,0.0309967),(5,11,2013,0.0445024),(5,12,2013,0.0384896),(6,1,2013,0.0371),(6,2,2013,0.0385),(6,3,2013,0.016),(6,4,2013,0.043414),(6,5,2013,0.0329817),(6,6,2013,0.036133),(6,7,2013,0.0309236),(6,8,2013,0.0334604),(6,9,2013,0.0329934),(6,10,2013,0.0341304),(6,11,2013,0.0474949),(6,12,2013,0.0420219),(7,1,2013,0.0345),(7,2,2013,0.0447),(7,3,2013,0.0219),(7,4,2013,0.0469051),(7,5,2013,0.0377409),(7,6,2013,0.0344582),(7,7,2013,0.0380671),(7,8,2013,0.0338168),(7,9,2013,0.0359393),(7,10,2013,0.048164),(7,11,2013,0.0488464),(7,12,2013,0.0412911),(8,1,2013,0.0312),(8,2,2013,0.0289),(8,3,2013,0.0145),(8,4,2013,0.0079667),(8,5,2013,0.0432988),(8,6,2013,0.0363468),(8,7,2013,0.0377814),(8,8,2013,0.0239818),(8,9,2013,0.0383413),(8,10,2013,0.0393079),(8,11,2013,0.044792),(8,12,2013,0.0409257),(9,1,2013,0.0305),(9,2,2013,0.0369),(9,3,2013,0.0387),(9,4,2013,0.0391622),(9,5,2013,0.0378407),(9,6,2013,0.0253002),(9,7,2013,0.0370511),(9,8,2013,0.0390193),(9,9,2013,0.0353501),(9,10,2013,0.0388991),(9,11,2013,0.0298291),(9,12,2013,0.0198538),(10,1,2013,0.0328),(10,2,2013,0.0378),(10,3,2013,0.0406),(10,4,2013,0.0370586),(10,5,2013,0.010883),(10,6,2013,0.0430816),(10,7,2013,0.0394641),(10,8,2013,0.0305741),(10,9,2013,0.0399275),(10,10,2013,0.0173718),(10,11,2013,0.0203688),(10,12,2013,0.0393423),(11,1,2013,0.0398),(11,2,2013,0.0085),(11,3,2013,0.045),(11,4,2013,0.0369691),(11,5,2013,0.0400706),(11,6,2013,0.0355272),(11,7,2013,0.0302569),(11,8,2013,0.0380929),(11,9,2013,0.0378427),(11,10,2013,0.0412153),(11,11,2013,0.0418959),(11,12,2013,0.0389769),(12,1,2013,0.0359),(12,2,2013,0.0394),(12,3,2013,0.0324),(12,4,2013,0.043056),(12,5,2013,0.0353779),(12,6,2013,0.037594),(12,7,2013,0.0290186),(12,8,2013,0.0313937),(12,9,2013,0.0435985),(12,10,2013,0.0480278),(12,11,2013,0.0395791),(12,12,2013,0.0429963),(13,1,2013,0.0258),(13,2,2013,0.0392),(13,3,2013,0.0376),(13,4,2013,0.037909),(13,5,2013,0.034679),(13,6,2013,0.0318213),(13,7,2013,0.0310823),(13,8,2013,0.0301821),(13,9,2013,0.0353048),(13,10,2013,0.0160774),(13,11,2013,0.0405445),(13,12,2013,0.0392205),(14,1,2013,0.029),(14,2,2013,0.039),(14,3,2013,0.0394),(14,4,2013,0.0361187),(14,5,2013,0.0392385),(14,6,2013,0.03428),(14,7,2013,0.0287964),(14,8,2013,0.0350283),(14,9,2013,0.0382506),(14,10,2013,0.0358335),(14,11,2013,0.0136114),(14,12,2013,0.0392205),(15,1,2013,0.0209),(15,2,2013,0.039),(15,3,2013,0.038),(15,4,2013,0.0356264),(15,5,2013,0.0268579),(15,6,2013,0.0343156),(15,7,2013,0.0289551),(15,8,2013,0.0367744),(15,9,2013,0.0124179),(15,10,2013,0.0378091),(15,11,2013,0.0213341),(15,12,2013,0.0393423),(16,1,2013,0.0151),(16,2,2013,0.0406),(16,3,2013,0.0388),(16,4,2013,0.0357159),(16,5,2013,0.0119479),(16,6,2013,0.0342087),(16,7,2013,0.0284154),(16,8,2013,0.0292556),(16,9,2013,0.0331294),(16,10,2013,0.0386947),(16,11,2013,0.0382276),(16,12,2013,0.0384896),(17,1,2013,0.0455),(17,2,2013,0.0272),(17,3,2013,0.0123),(17,4,2013,0.0363425),(17,5,2013,0.0326489),(17,6,2013,0.0328903),(17,7,2013,0.0365432),(17,8,2013,0.0325696),(17,9,2013,0.0340358),(17,10,2013,0.0380816),(17,11,2013,0.0521286),(17,12,2013,0.0406821),(18,1,2013,0.0391),(18,2,2013,0.0405),(18,3,2013,0.0089),(18,4,2013,0.0351788),(18,5,2013,0.0383067),(18,6,2013,0.0461818),(18,7,2013,0.0333048),(18,8,2013,0.0292556),(18,9,2013,0.0331294),(18,10,2013,0.0382179),(18,11,2013,0.0199826),(18,12,2013,0.0257004),(19,1,2013,0.0136),(19,2,2013,0.0415),(19,3,2013,0.0406),(19,4,2013,0.0354921),(19,5,2013,0.0375745),(19,6,2013,0.0462887),(19,7,2013,0.0372099),(19,8,2013,0.0369526),(19,9,2013,0.0319511),(19,10,2013,0.0349479),(19,11,2013,0.0109084),(19,12,2013,0.00487211),(20,1,2013,0.0028),(20,2,2013,0.0445),(20,3,2013,0.0271),(20,4,2013,0.00729535),(20,5,2013,0.040237),(20,6,2013,0),(20,7,2013,0.0386069),(20,8,2013,0.0295763),(20,9,2013,0.0305914),(20,10,2013,0.0101506),(20,11,2013,0.0275123),(20,12,2013,0.0130329),(21,1,2013,0.0176),(21,2,2013,0.0174),(21,3,2013,0.0403),(21,4,2013,0.0303003),(21,5,2013,0.0387726),(21,6,2013,0),(21,7,2013,0.0335905),(21,8,2013,0.0291131),(21,9,2013,0.035622),(21,10,2013,0.0472784),(21,11,2013,0.0123564),(21,12,2013,0.0155907),(22,1,2013,0.027),(22,2,2013,0.041),(22,3,2013,0.0402),(22,4,2013,0.0459652),(22,5,2013,0.0272573),(22,6,2013,0),(22,7,2013,0.0281297),(22,8,2013,0.0283648),(22,9,2013,0.0326762),(22,10,2013,0.0145105),(22,11,2013,0.0369727),(22,12,2013,0.0216809),(23,1,2013,0.0405),(23,2,2013,0.0392),(23,3,2013,0.041),(23,4,2013,0.0558564),(23,5,2013,0.0371418),(23,6,2013,0),(23,7,2013,0.0287964),(23,8,2013,0.0310729),(23,9,2013,0.0395196),(23,10,2013,0.00490497),(23,11,2013,0.0324356),(23,12,2013,0.0192448),(24,1,2013,0.0415),(24,2,2013,0.0187),(24,3,2013,0.012),(24,4,2013,0.0379985),(24,5,2013,0.011715),(24,6,2013,0.0437231),(24,7,2013,0.0380036),(24,8,2013,0.0345295),(24,9,2013,0.0306821),(24,10,2013,0.0246611),(24,11,2013,0.0385172),(24,12,2013,0.0152253),(25,1,2013,0.0417),(25,2,2013,0.0402),(25,3,2013,0.0322),(25,4,2013,0.0371481),(25,5,2013,0.0362099),(25,6,2013,0.0416563),(25,7,2013,0.0327015),(25,8,2013,0.0381641),(25,9,2013,0.0284614),(25,10,2013,0.0299067),(25,11,2013,0.0369727),(25,12,2013,0.00255786),(26,1,2013,0.0421),(26,2,2013,0.0452),(26,3,2013,0.0051),(26,4,2013,0.0176342),(26,5,2013,0.0416681),(26,6,2013,0.0486049),(26,7,2013,0.0293679),(26,8,2013,0.0368457),(26,9,2013,0.0366644),(26,10,2013,0.0431228),(26,11,2013,0.03649),(26,12,2013,0.0205847),(27,1,2013,0.0421),(27,2,2013,0.0535),(27,3,2013,0.0496),(27,4,2013,0.0225574),(27,5,2013,0.0321163),(27,6,2013,0.038271),(27,7,2013,0.0280027),(27,8,2013,0.0300752),(27,9,2013,0.0347156),(27,10,2013,0.0420328),(27,11,2013,0.0354281),(27,12,2013,0.0395859),(28,1,2013,0.0234),(28,2,2013,0.0387),(28,3,2013,0.0371),(28,4,2013,0.0354921),(28,5,2013,0.0215329),(28,6,2013,0.0464669),(28,7,2013,0.0291774),(28,8,2013,0.0319282),(28,9,2013,0.0338545),(28,10,2013,0.0402616),(28,11,2013,0.0347524),(28,12,2013,0.0409257),(29,1,2013,0.0419),(29,3,2013,0.0527),(29,4,2013,0.00841427),(29,5,2013,0.0375745),(29,6,2013,0.0301465),(29,7,2013,0.033654),(29,8,2013,0.0371307),(29,9,2013,0.0121006),(29,10,2013,0.0124668),(29,11,2013,0.0344628),(29,12,2013,0.0231425),(30,1,2013,0.0429),(30,3,2013,0.0101),(30,4,2013,0.0137851),(30,5,2013,0.025094),(30,6,2013,0.0368457),(30,7,2013,0.0284154),(30,8,2013,0.0290062),(30,9,2013,0.0242012),(30,10,2013,0.0406022),(30,11,2013,0.0262574),(30,12,2013,0.0409257),(31,1,2013,0.0457),(31,3,2013,0.0576),(31,5,2013,0.0354445),(31,7,2013,0.0280027),(31,8,2013,0.0275452),(31,10,2013,0.0177124),(31,12,2013,0.0409257);
/*!40000 ALTER TABLE `irradiation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `modes`
--

DROP TABLE IF EXISTS `modes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `modes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `template` int(11) NOT NULL,
  `template_alt` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `modes`
--

LOCK TABLES `modes` WRITE;
/*!40000 ALTER TABLE `modes` DISABLE KEYS */;
INSERT INTO `modes` VALUES (1,'PermPress',79,78),(2,'Delicates',78,79),(3,'Delicates',79,79),(4,'PermPress',78,78),(5,'Regular',74,74),(6,'Regular',78,74),(7,'Regular',79,74),(8,'PermPress',74,78),(9,'Delicates',74,79);
/*!40000 ALTER TABLE `modes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `produced_energy`
--

DROP TABLE IF EXISTS `produced_energy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `produced_energy` (
  `user_id` varchar(30) NOT NULL,
  `month` int(11) NOT NULL,
  `year` int(11) NOT NULL,
  `total` float NOT NULL,
  PRIMARY KEY (`user_id`,`month`,`year`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `produced_energy`
--

LOCK TABLES `produced_energy` WRITE;
/*!40000 ALTER TABLE `produced_energy` DISABLE KEYS */;
INSERT INTO `produced_energy` VALUES ('CS1',1,2013,218),('CS1',2,2013,235),('CS1',3,2013,367),('CS1',4,2013,432),('CS1',5,2013,466),('CS1',6,2013,471),('CS1',7,2013,489),('CS1',8,2013,474),('CS1',9,2013,407),('CS1',10,2013,357),('CS1',11,2013,245),('CS1',12,2013,200),('CS14',1,2013,233),('CS14',2,2013,276),('CS14',3,2013,356),('CS14',4,2013,397),('CS14',5,2013,443),('CS14',6,2013,451),('CS14',7,2013,497),('CS14',8,2013,477),('CS14',9,2013,389),('CS14',10,2013,328),('CS14',11,2013,235),('CS14',12,2013,229),('CS15',1,2013,190),('CS15',2,2013,205),('CS15',3,2013,315),('CS15',4,2013,371),('CS15',5,2013,400),('CS15',6,2013,405),('CS15',7,2013,422),('CS15',8,2013,411),('CS15',9,2013,354),('CS15',10,2013,312),('CS15',11,2013,214),('CS15',12,2013,176),('CS16',1,2013,218),('CS16',2,2013,235),('CS16',3,2013,367),('CS16',4,2013,432),('CS16',5,2013,466),('CS16',6,2013,471),('CS16',7,2013,489),('CS16',8,2013,474),('CS16',9,2013,407),('CS16',10,2013,357),('CS16',11,2013,245),('CS16',12,2013,200),('CS17',1,2013,266),('CS17',2,2013,314),('CS17',3,2013,402),('CS17',4,2013,447),('CS17',5,2013,501),('CS17',6,2013,508),('CS17',7,2013,559),('CS17',8,2013,541),('CS17',9,2013,439),('CS17',10,2013,372),('CS17',11,2013,266),('CS17',12,2013,261),('CS18',1,2013,218),('CS18',2,2013,235),('CS18',3,2013,367),('CS18',4,2013,432),('CS18',5,2013,466),('CS18',6,2013,471),('CS18',7,2013,489),('CS18',8,2013,474),('CS18',9,2013,407),('CS18',10,2013,357),('CS18',11,2013,245),('CS18',12,2013,200),('CS19',1,2013,218),('CS19',2,2013,235),('CS19',3,2013,367),('CS19',4,2013,432),('CS19',5,2013,466),('CS19',6,2013,471),('CS19',7,2013,489),('CS19',8,2013,474),('CS19',9,2013,407),('CS19',10,2013,357),('CS19',11,2013,245),('CS19',12,2013,200),('CS2',1,2013,218),('CS2',2,2013,235),('CS2',3,2013,367),('CS2',4,2013,432),('CS2',5,2013,466),('CS2',6,2013,471),('CS2',7,2013,489),('CS2',8,2013,474),('CS2',9,2013,407),('CS2',10,2013,357),('CS2',11,2013,245),('CS2',12,2013,200),('CS20',1,2013,218),('CS20',2,2013,235),('CS20',3,2013,367),('CS20',4,2013,432),('CS20',5,2013,466),('CS20',6,2013,471),('CS20',7,2013,489),('CS20',8,2013,474),('CS20',9,2013,407),('CS20',10,2013,357),('CS20',11,2013,245),('CS20',12,2013,200),('CS3',1,2013,218),('CS3',2,2013,235),('CS3',3,2013,367),('CS3',4,2013,432),('CS3',5,2013,466),('CS3',6,2013,471),('CS3',7,2013,489),('CS3',8,2013,474),('CS3',9,2013,407),('CS3',10,2013,357),('CS3',11,2013,245),('CS3',12,2013,200),('CS4',1,2013,218),('CS4',2,2013,235),('CS4',3,2013,367),('CS4',4,2013,432),('CS4',5,2013,466),('CS4',6,2013,471),('CS4',7,2013,489),('CS4',8,2013,474),('CS4',9,2013,407),('CS4',10,2013,357),('CS4',11,2013,245),('CS4',12,2013,200),('CS5',1,2013,218),('CS5',2,2013,235),('CS5',3,2013,367),('CS5',4,2013,432),('CS5',5,2013,466),('CS5',6,2013,471),('CS5',7,2013,489),('CS5',8,2013,474),('CS5',9,2013,407),('CS5',10,2013,357),('CS5',11,2013,245),('CS5',12,2013,200),('CS6',1,2013,218),('CS6',2,2013,235),('CS6',3,2013,367),('CS6',4,2013,432),('CS6',5,2013,466),('CS6',6,2013,471),('CS6',7,2013,489),('CS6',8,2013,474),('CS6',9,2013,407),('CS6',10,2013,357),('CS6',11,2013,245),('CS6',12,2013,200),('CS7',1,2013,266),('CS7',2,2013,314),('CS7',3,2013,402),('CS7',4,2013,447),('CS7',5,2013,501),('CS7',6,2013,508),('CS7',7,2013,559),('CS7',8,2013,541),('CS7',9,2013,439),('CS7',10,2013,372),('CS7',11,2013,266),('CS7',12,2013,261),('CS8',1,2013,266),('CS8',2,2013,314),('CS8',3,2013,402),('CS8',4,2013,447),('CS8',5,2013,501),('CS8',6,2013,508),('CS8',7,2013,559),('CS8',8,2013,541),('CS8',9,2013,439),('CS8',10,2013,372),('CS8',11,2013,266),('CS8',12,2013,261),('CS9',1,2013,14200),('CS9',2,2013,17400),('CS9',3,2013,23000),('CS9',4,2013,26700),('CS9',5,2013,31000),('CS9',6,2013,31900),('CS9',7,2013,35000),('CS9',8,2013,32900),('CS9',9,2013,25700),('CS9',10,2013,20900),('CS9',11,2013,14400),('CS9',12,2013,13600);
/*!40000 ALTER TABLE `produced_energy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `samples`
--

DROP TABLE IF EXISTS `samples`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `samples` (
  `number` int(11) NOT NULL,
  `value` varchar(45) DEFAULT NULL,
  `template` int(11) DEFAULT NULL,
  KEY `fk_samples_id_idx` (`template`),
  CONSTRAINT `fk_samples_id` FOREIGN KEY (`template`) REFERENCES `templates` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `samples`
--

LOCK TABLES `samples` WRITE;
/*!40000 ALTER TABLE `samples` DISABLE KEYS */;
INSERT INTO `samples` VALUES (1,'0',43),(2,'0.1',43),(3,'0.3',43),(4,'0.2',43),(5,'0.2',43),(6,'0.3',43),(7,'0.3',43),(8,'0.1',43),(9,'0.2',43),(10,'0.2',43),(11,'0.1',43),(12,'0',43),(13,'0.1',43),(14,'1.2',43),(15,'1.1',43),(16,'0.9',43),(17,'1.2',43),(18,'1.1',43),(19,'1.1',43),(20,'0.9',43),(21,'1.1',43),(22,'1.1',43),(23,'0.4',43),(24,'0.2',43),(25,'0.2',43),(26,'0.2',43),(27,'0.2',43),(28,'0.2',43),(29,'0.2',43),(30,'0.2',43),(31,'0.2',43),(32,'0.2',43),(33,'0.2',43),(34,'0.2',43),(35,'0.2',43),(36,'0.2',43),(37,'0.2',43),(38,'0.2',43),(39,'0.2',43),(40,'0.2',43),(41,'0.2',43),(42,'0.2',43),(43,'0.2',43),(44,'0.2',43),(45,'0.2',43),(46,'0.2',43),(47,'0.2',43),(48,'0.3',43),(49,'0.2',43),(50,'0',43),(51,'0.1',43),(52,'0',43),(53,'0',43),(54,'1',43),(55,'1.1',43),(56,'1.1',43),(57,'1.1',43),(58,'1.1',43),(59,'1.1',43),(60,'1.1',43),(61,'1.1',43),(62,'1.1',43),(63,'1.1',43),(64,'1.1',43),(65,'1.1',43),(66,'0.7',43),(67,'0.3',43),(68,'0.3',43),(69,'0.3',43),(70,'0.3',43),(71,'0.2',43),(72,'0.2',43),(73,'0.2',43),(74,'0.2',43),(75,'0.2',43),(76,'0.2',43),(77,'0',43),(78,'0',43),(79,'0',43),(80,'0',43),(81,'0',43),(82,'0',43),(83,'0',43),(84,'0.8',43),(85,'0.6',43),(86,'0.6',43),(87,'0.6',43),(88,'0.6',43),(89,'0.6',43),(90,'0',43),(91,'0.6',43),(92,'0.6',43),(93,'0.6',43),(94,'0.6',43),(95,'0.6',43),(96,'0',43),(97,'0',43),(98,'0.3',43),(99,'0.6',43),(100,'0.6',43),(101,'0.6',43),(102,'0.3',43),(103,'0',43),(104,'0',43),(105,'0',43),(106,'0',43),(107,'0',43),(108,'0',43),(109,'0',43),(110,'0',43),(1,'2.85',73),(2,'2.95',73),(3,'2.94',73),(4,'2.93',73),(5,'2.9',73),(6,'2.89',73),(7,'2.89',73),(8,'2.9',73),(9,'2.9',73),(10,'2.88',73),(11,'2.88',73),(12,'2.88',73),(13,'2.88',73),(14,'2.87',73),(15,'2.88',73),(16,'2.88',73),(17,'2.86',73),(18,'2.85',73),(19,'2.86',73),(20,'0.45',73),(21,'0.2',73),(22,'0.2',73),(23,'1.48',73),(24,'2.91',73),(25,'2.91',73),(26,'2.9',73),(27,'1.68',73),(28,'0.19',73),(29,'0.19',73),(30,'0.19',73),(31,'0.19',73),(32,'1.97',73),(33,'2.89',73),(34,'2.88',73),(35,'0.78',73),(36,'0.19',73),(37,'0.19',73),(38,'0.19',73),(39,'0.19',73),(40,'0.19',73),(41,'1.85',73),(42,'2.9',73),(43,'1.71',73),(44,'0.19',73),(45,'0.19',73),(46,'0.19',73),(47,'0.19',73),(48,'0.19',73),(49,'0.19',73),(50,'0.19',73),(51,'0.19',73),(52,'0.19',73),(53,'0.19',73),(54,'0.15',73),(55,'0',73),(56,'0',73),(57,'0',73),(58,'0',73),(59,'0',73),(60,'0',73),(1,'2.9',75),(2,'3.01',75),(3,'2.99',75),(4,'2.98',75),(5,'2.98',75),(6,'2.98',75),(7,'2.97',75),(8,'2.97',75),(9,'3.02',75),(10,'3.03',75),(11,'3.02',75),(12,'2.99',75),(13,'2.98',75),(14,'2.99',75),(15,'2.98',75),(16,'2.99',75),(17,'0.51',75),(18,'0.19',75),(19,'2.95',75),(20,'2.96',75),(21,'2.67',75),(22,'0.19',75),(23,'0.19',75),(24,'2.31',75),(25,'2.97',75),(26,'0.99',75),(27,'0.19',75),(28,'0.19',75),(29,'2.54',75),(30,'2.73',75),(31,'0.19',75),(32,'0.19',75),(33,'0.19',75),(34,'2.02',75),(35,'2.62',75),(36,'0.19',75),(37,'0.18',75),(38,'0.19',75),(39,'2.19',75),(40,'2.56',75),(41,'0.19',75),(42,'0.19',75),(43,'0.19',75),(44,'0.19',75),(45,'0.19',75),(46,'0.19',75),(47,'0.19',75),(48,'0.19',75),(49,'0.19',75),(50,'0.19',75),(51,'0.19',75),(52,'0.19',75),(53,'0.19',75),(54,'0.19',75),(55,'0.19',75),(56,'0.19',75),(57,'0.19',75),(58,'0,00',75),(59,'0,00',75),(60,'0,00',75),(1,'2.82',76),(2,'2.94',76),(3,'2.94',76),(4,'2.93',76),(5,'2.93',76),(6,'2.93',76),(7,'2.96',76),(8,'2.96',76),(9,'2.97',76),(10,'2.97',76),(11,'2.95',76),(12,'2.95',76),(13,'2.96',76),(14,'2.94',76),(15,'2.93',76),(16,'2.92',76),(17,'2.93',76),(18,'0.28',76),(19,'0.18',76),(20,'1.47',76),(21,'2.93',76),(22,'2.94',76),(23,'2.93',76),(24,'2.81',76),(25,'0.18',76),(26,'0.18',76),(27,'0.18',76),(28,'1.87',76),(29,'2.94',76),(30,'2.95',76),(31,'0.88',76),(32,'0.18',76),(33,'0.18',76),(34,'0.18',76),(35,'0.18',76),(36,'0.18',76),(37,'0.18',76),(38,'0.18',76),(39,'0.18',76),(40,'0.18',76),(41,'0.18',76),(42,'0.18',76),(43,'0.18',76),(44,'0.1',76),(45,'0,00',76),(46,'0,00',76),(47,'0,00',76),(48,'0,00',76),(49,'0,00',76),(50,'0,00',76),(51,'0,00',76),(52,'0,00',76),(53,'0,00',76),(54,'0,00',76),(55,'0,00',76),(56,'0,00',76),(57,'0,00',76),(58,'0,00',76),(59,'0,00',76),(60,'0,00',76),(1,'17.2',74),(2,'13.77',74),(3,'33.16',74),(4,'42.66',74),(5,'65.36',74),(6,'56.6',74),(7,'55.12',74),(8,'55.01',74),(9,'59.11',74),(10,'67.08',74),(11,'65.16',74),(12,'57.88',74),(13,'55.4',74),(14,'66.07',74),(15,'66.42',74),(16,'68.81',74),(17,'22.76',74),(18,'18.28',74),(19,'30.65',74),(20,'56.37',74),(21,'45.87',74),(22,'68.3',74),(23,'133.37',74),(24,'209.99',74),(25,'198.31',74),(26,'104.95',74),(27,'14.97',74),(28,'32.65',74),(29,'94.06',74),(30,'100.85',74),(31,'113.96',74),(32,'113.82',74),(33,'64.19',74),(34,'53.1',74),(35,'63.88',74),(36,'112.12',74),(37,'65.45',74),(38,'65.16',74),(39,'212.86',74),(40,'216.91',74),(41,'158.99',74),(42,'22.58',74),(43,'33.26',74),(44,'85.39',74),(45,'95.39',74),(46,'85.33',74),(47,'87.43',74),(48,'89.73',74),(49,'40.75',74),(50,'105.26',74),(51,'142.99',74),(52,'223.39',74),(53,'212.43',74),(54,'201.03',74),(55,'227.01',74),(56,'221.43',74),(57,'253.43',74),(58,'278.28',74),(59,'269.83',74),(60,'51.45   ',74),(1,'13.44',78),(2,'16.18',78),(3,'26.1',78),(4,'63.29',78),(5,'61.79',78),(6,'57.28',78),(7,'54.45',78),(8,'55.79',78),(9,'60.15',78),(10,'60.1',78),(11,'55.04',78),(12,'55.93',78),(13,'57.63',78),(14,'59.98',78),(15,'63.34',78),(16,'62.33',78),(17,'56.52',78),(18,'58.84',78),(19,'60.01',78),(20,'55.92',78),(21,'44.79',78),(22,'17.83',78),(23,'27.92',78),(24,'35.22',78),(25,'41.51',78),(26,'125.56',78),(27,'202.32',78),(28,'201.93',78),(29,'48.02',78),(30,'18.73',78),(31,'39.24',78),(32,'61.25',78),(33,'66.57',78),(34,'68.87',78),(35,'55.96',78),(36,'65.87',78),(37,'34.67',78),(38,'190.87',78),(39,'208.61',78),(40,'146.31',78),(41,'19.34',78),(42,'32.53',78),(43,'51.57',78),(44,'71.82',78),(45,'64.92',78),(46,'65.92',78),(47,'63.77',78),(48,'36.66',78),(49,'168.42',78),(50,'228.74',78),(51,'199.58',78),(52,'186.65',78),(53,'187.83',78),(54,'171.27',78),(55,'170.72',78),(56,'153.36',78),(57,'14.03',78),(58,'2.32',78),(59,'0,00',78),(60,'0,00',78),(1,'12',79),(2,'15.41',79),(3,'30.53',79),(4,'85.79',79),(5,'71.81',79),(6,'108.34',79),(7,'71.32',79),(8,'63.4',79),(9,'100.03',79),(10,'67.45',79),(11,'75.44',79),(12,'84.72',79),(13,'142.76',79),(14,'63.21',79),(15,'85.19',79),(16,'68.71',79),(17,'57.77',79),(18,'48.08',79),(19,'18.14',79),(20,'27.62',79),(21,'27.97',79),(22,'108.31',79),(23,'82.72',79),(24,'62.65',79),(25,'84.08',79),(26,'52.97',79),(27,'59.23',79),(28,'27.83',79),(29,'88.54',79),(30,'83.69',79),(31,'72.62',79),(32,'62.17',79),(33,'69.85',79),(34,'64.26',79),(35,'47.24',79),(36,'75.95',79),(37,'58.61',79),(38,'108.55',79),(39,'204.68',79),(40,'194.1',79),(41,'100.7',79),(42,'8.64',79),(43,'0',79),(44,'0',79),(45,'0',79),(46,'0',79),(47,'0',79),(48,'0',79),(49,'0',79),(50,'0',79),(51,'0',79),(52,'0',79),(53,'0',79),(54,'0',79),(55,'0',79),(56,'0',79),(57,'0',79),(58,'0',79),(59,'0',79),(60,'0',79),(1,'0',81),(2,'0',81),(3,'0',81),(4,'0',81),(5,'0',81),(6,'0',81),(7,'0',81),(8,'0',81),(9,'0',81),(10,'0',81),(11,'0',81),(12,'0',81),(13,'0',81),(14,'0',81),(15,'0',81),(16,'0',81),(17,'0',81),(18,'0',81),(19,'0',81),(20,'0',81),(21,'0',81),(22,'0',81),(23,'0',81),(24,'0',81),(25,'0',81),(26,'0',81),(27,'2.4',81),(28,'2',81),(29,'2.1',81),(30,'2.1',81),(31,'2.1',81),(32,'1.4',81),(33,'0',81),(34,'0',81),(35,'0',81),(36,'0',81),(37,'0',81),(38,'0',81),(39,'0',81),(40,'0',81),(41,'0',81),(42,'0',81),(43,'0',81),(44,'0',81),(45,'0',81),(46,'0',81),(47,'0',81),(48,'0',81),(49,'0',81),(50,'0',81),(51,'0',81),(52,'0',81),(53,'0',81),(54,'0',81),(55,'0',81),(56,'0',81),(57,'0',81),(58,'0',81),(59,'0',81),(60,'0',81),(61,'0',81),(62,'0',81),(63,'0',81),(64,'0',81),(65,'0',81),(66,'0',81),(67,'0',81),(68,'0',81),(69,'0',81),(70,'0',81),(71,'0',81),(72,'2.5',81),(73,'2.1',81),(74,'2.2',81),(75,'2.2',81),(76,'2.2',81),(77,'0.8',81),(78,'0',81),(79,'0',81),(80,'0',81),(81,'0',81),(82,'0',81),(83,'0',81),(84,'0',81),(85,'0',81),(86,'0',81),(87,'0',81),(88,'0',81),(89,'0',81),(90,'0',81),(91,'0',81),(92,'0',81),(93,'0',81),(94,'0',81),(95,'0',81),(96,'0',81),(97,'0',81),(98,'0',81),(99,'0',81),(100,'0',81),(101,'0',81),(102,'0',81),(103,'0',81),(104,'0',81),(105,'0',81),(106,'0',81),(107,'0',81),(108,'0',81),(109,'0',81),(110,'0',81),(111,'0',81),(112,'0.1',81),(113,'2.3',81),(114,'2.2',81),(115,'2.2',81),(116,'2.2',81),(117,'2.2',81),(118,'0.7',81),(119,'0',81),(120,'0',81),(121,'0',81),(122,'0',81),(123,'0',81),(124,'0',81),(125,'0',81),(126,'0',81),(127,'0',81),(128,'0',81),(129,'0',81),(130,'0',81),(131,'0',81),(132,'0',81),(133,'0',81),(134,'0',81),(135,'0',81),(136,'0',81),(137,'0',81),(138,'0',81),(139,'0',81),(140,'0',81),(141,'0',81),(142,'0',81),(143,'0',81),(144,'0',81),(145,'0',81),(146,'0',81),(147,'0',81),(148,'0',81),(149,'0',81),(150,'0',81),(151,'0',81),(152,'0',81),(153,'0',81),(154,'0',81),(155,'0',81),(156,'0',81),(157,'0',81),(158,'0',81),(159,'0',81),(160,'0',81),(161,'0',81),(162,'0',81),(163,'0',81),(164,'0',81),(165,'0',81),(166,'0',81),(167,'0',81),(168,'0',81),(169,'0',81),(170,'0',81),(171,'1.9',81),(172,'2.2',81),(173,'2.2',81),(174,'2.2',81),(175,'2.2',81),(176,'2.2',81),(177,'2.2',81),(178,'1.5',81),(179,'0',81),(180,'0',81),(181,'0',81),(182,'0',81),(183,'0',81),(184,'0',81),(185,'0',81),(186,'0',81),(187,'0',81),(188,'0',81),(189,'0',81),(190,'0',81),(191,'0',81),(192,'0',81),(193,'0',81),(194,'0',81),(195,'0',81),(196,'0',81),(197,'0',81),(198,'0',81),(199,'0',81),(200,'0',81),(201,'0',81),(202,'0',81),(203,'0',81),(204,'0',81),(205,'0',81),(206,'0',81),(207,'0',81),(208,'0',81),(209,'0',81),(210,'0',81),(211,'0',81),(212,'0',81),(213,'0',81),(214,'0',81),(215,'0',81),(216,'0',81),(217,'0',81),(218,'0',81),(219,'0.7',81),(220,'2.2',81),(221,'2.2',81),(222,'2.2',81),(223,'2.2',81),(224,'2.2',81),(225,'2.2',81),(226,'2.1',81),(227,'2.1',81),(228,'0.1',81),(229,'0',81),(230,'0',81),(231,'0',81),(232,'0',81),(233,'0',81),(234,'0',81),(235,'0',81),(236,'0',81),(237,'0',81),(238,'0',81),(239,'0',81),(240,'0',81),(241,'0',81),(242,'0',81),(243,'0',81),(244,'0',81),(245,'0',81),(246,'0',81),(247,'0',81),(248,'0',81),(249,'0',81),(250,'0',81),(251,'0',81),(252,'0',81),(253,'0',81),(254,'0',81),(255,'0',81),(256,'0',81),(257,'0',81),(258,'0',81),(259,'0',81),(260,'0',81),(261,'0',81),(262,'0',81),(263,'0',81),(264,'0',81),(265,'0',81),(266,'0',81),(267,'0',81),(268,'0',81),(269,'0',81),(270,'0',81),(271,'0',81),(272,'0',81),(273,'0',81),(274,'0',81),(275,'0',81),(276,'2.3',81),(277,'2.2',81),(278,'2.2',81),(279,'2.2',81),(280,'2.2',81),(281,'2.2',81),(282,'0',81),(283,'0',81),(284,'0',81),(285,'0',81),(286,'0',81),(287,'0',81),(288,'0',81),(289,'0',81),(290,'0',81),(291,'0',81),(292,'0',81),(293,'0',81),(294,'0',81),(295,'0',81),(296,'0',81),(297,'0',81),(298,'0',81),(299,'0',81),(300,'0',81),(301,'0',81),(302,'0',81),(303,'0',81),(304,'0',81),(305,'0',81),(306,'0',81),(307,'0',81),(308,'0',81),(309,'0',81),(310,'0',81),(311,'0',81),(312,'0',81),(313,'0',81),(314,'0',81),(315,'0',81),(316,'0',81),(317,'0',81),(318,'0',81),(319,'0',81),(320,'0',81),(321,'1.4',81),(322,'2.1',81),(323,'2.2',81),(324,'2.2',81),(325,'2.2',81),(326,'2.2',81),(327,'0.1',81),(328,'0',81),(329,'0',81),(330,'0',81),(331,'0',81),(332,'0',81),(333,'0',81),(334,'0',81),(335,'0',81),(336,'0',81),(337,'0',81),(338,'0',81),(339,'0',81),(340,'0',81),(341,'0',81),(342,'0',81),(343,'0',81),(344,'0',81),(345,'0',81),(346,'0',81),(347,'0',81),(348,'0',81),(349,'0',81),(350,'0',81),(351,'0',81),(352,'0',81),(353,'0',81),(354,'1.9',81),(355,'2.1',81),(356,'2.2',81),(357,'2.2',81),(358,'2.2',81),(359,'2.1',81),(360,'2.1',81),(361,'2.1',81),(362,'0.8',81),(363,'0',81),(364,'0',81),(365,'0',81),(366,'0',81),(367,'0',81),(368,'0',81),(369,'0',81),(370,'0',81),(371,'0',81),(372,'0',81),(373,'0',81),(374,'0',81),(375,'0',81),(376,'0',81),(377,'0',81),(378,'0',81),(379,'0',81),(380,'0',81),(381,'0',81),(382,'0',81),(383,'0',81),(384,'0',81),(385,'0',81),(386,'0',81),(387,'0',81),(388,'0',81),(389,'0',81),(390,'0',81),(391,'0',81),(392,'0',81),(393,'0',81),(394,'0',81),(395,'0',81),(396,'0',81),(397,'0',81),(398,'0',81),(399,'0',81),(400,'0.9',81),(401,'2.1',81),(402,'2',81),(403,'2.1',81),(404,'2.1',81),(405,'2.1',81),(406,'0.8',81),(407,'0',81),(408,'0',81),(409,'0',81),(410,'0',81),(411,'0',81),(412,'0',81),(413,'0',81),(414,'0',81),(415,'0',81),(416,'0',81),(417,'0',81),(418,'0',81),(419,'0',81),(420,'0',81),(421,'0',81),(422,'0',81),(423,'0',81),(424,'0',81),(425,'0',81),(426,'0',81),(427,'0',81),(428,'0',81),(429,'0',81),(430,'0',81),(431,'0',81),(432,'0',81),(433,'0',81),(434,'0',81),(435,'0',81),(436,'0',81),(437,'0',81),(438,'0',81),(439,'0',81),(440,'0',81),(441,'0',81),(442,'0',81),(443,'0',81),(444,'1.6',81),(445,'2.1',81),(446,'2',81),(447,'2.1',81),(448,'2.1',81),(449,'2.1',81),(450,'2.1',81),(451,'0.1',81),(452,'0',81),(453,'0',81),(454,'0',81),(455,'0',81),(456,'0',81),(457,'0',81),(458,'0',81),(459,'0',81),(460,'0',81),(461,'0',81),(462,'0',81),(463,'0',81),(464,'0',81),(465,'0',81),(466,'0',81),(467,'0',81),(468,'0',81),(469,'0',81),(470,'0',81),(471,'0',81),(472,'0',81),(473,'0',81),(474,'0',81),(475,'0',81),(476,'0',81),(477,'0',81),(478,'0',81),(479,'0',81),(480,'0',81),(481,'2.1',81),(482,'2',81),(483,'2',81),(484,'2',81),(485,'2.1',81),(486,'0.8',81),(487,'0',81),(488,'0',81),(489,'0',81),(490,'0',81),(491,'0',81),(492,'0',81),(493,'0',81),(494,'0',81),(495,'0',81),(496,'0',81),(497,'0',81),(498,'0',81),(499,'0',81),(500,'0',81),(501,'0',81),(502,'0',81),(503,'0',81),(504,'0',81),(505,'0',81),(506,'0',81),(507,'0',81),(508,'0',81),(509,'0',81),(510,'0',81),(511,'0',81),(512,'0',81),(513,'0.5',81),(514,'2',81),(515,'2',81),(516,'2',81),(517,'2',81),(518,'2',81),(519,'2',81),(520,'2.1',81),(521,'2.1',81),(522,'0.2',81),(523,'0',81),(524,'0',81),(525,'0',81),(526,'0',81),(527,'0',81),(528,'0',81),(529,'0',81),(530,'0',81),(531,'0',81),(532,'0',81),(533,'0',81),(534,'0',81),(535,'0',81),(536,'0',81),(537,'0',81),(538,'0',81),(539,'0',81),(540,'0',81),(541,'0',81),(542,'0',81),(543,'0',81),(544,'0',81),(545,'0',81),(546,'0',81),(547,'0',81),(548,'0',81),(549,'0.3',81),(550,'2',81),(551,'2',81),(552,'2',81),(553,'2',81),(554,'2',81),(555,'2',81),(556,'2.1',81),(557,'2.1',81),(558,'0',81),(559,'0',81),(560,'0',81),(561,'0',81),(562,'0',81),(563,'0',81),(564,'0',81),(565,'0',81),(566,'0',81),(567,'0',81),(568,'0',81),(569,'0',81),(570,'0',81),(571,'0',81),(572,'0',81),(573,'0',81),(574,'0',81),(575,'0',81),(576,'0',81),(577,'0',81),(578,'0',81),(579,'0',81),(580,'0',81),(581,'0',81),(582,'0',81),(583,'0',81),(584,'0',81),(585,'0',81),(586,'0',81),(587,'0',81),(588,'0',81),(589,'0',81),(590,'0',81),(591,'0',81),(592,'0',81),(593,'0',81),(594,'0.8',81),(595,'2',81),(596,'2',81),(597,'2',81),(598,'2',81),(599,'2',81),(600,'0.8',81),(601,'0',81),(602,'0',81),(603,'0',81),(604,'0',81),(605,'0',81),(606,'0',81),(607,'0',81),(608,'0',81),(609,'0',81),(610,'0',81),(611,'0',81),(612,'0',81),(613,'0',81),(614,'0',81),(615,'0',81),(616,'0',81),(617,'0',81),(618,'0',81),(619,'0',81),(620,'0',81),(621,'0',81),(622,'0',81),(623,'0',81),(624,'0',81),(625,'0',81),(626,'0',81),(627,'0',81),(628,'0',81),(629,'0',81),(630,'0',81),(631,'0',81),(632,'0',81),(633,'1.3',81),(634,'1.9',81),(635,'1.9',81),(636,'1.9',81),(637,'2',81),(638,'2',81),(639,'0.7',81),(640,'0',81),(641,'0',81),(642,'0',81),(643,'0',81),(644,'0',81),(645,'0',81),(646,'0',81),(647,'0',81),(648,'0',81),(649,'0',81),(650,'0',81),(651,'0',81),(652,'0',81),(653,'0',81),(654,'0',81),(655,'0',81),(656,'0',81),(657,'0',81),(658,'0',81),(659,'0',81),(660,'0',81),(661,'0',81),(662,'0',81),(663,'0',81),(664,'0',81),(665,'0',81),(666,'0',81),(667,'0',81),(668,'0',81),(669,'0',81),(670,'0',81),(671,'0.1',81),(672,'2.2',81),(673,'1.9',81),(674,'1.9',81),(675,'1.9',81),(676,'1.9',81),(677,'2',81),(678,'0',81),(679,'0',81),(680,'0',81),(681,'0',81),(682,'0',81),(683,'0',81),(684,'0',81),(685,'0',81),(686,'0',81),(687,'0',81),(688,'0',81),(689,'0',81),(690,'0',81),(691,'0',81),(692,'0',81),(693,'0',81),(694,'0',81),(695,'0',81),(696,'0',81),(697,'0',81),(698,'0',81),(699,'0',81),(700,'0',81),(701,'0',81),(702,'0',81),(703,'0',81),(704,'0',81),(705,'0',81),(706,'0',81),(707,'0',81),(708,'0',81),(709,'0',81),(710,'0.9',81),(711,'1.9',81),(712,'1.9',81),(713,'1.9',81),(714,'1.6',81),(715,'0',81),(716,'0',81),(717,'0',81),(718,'0',81),(719,'0',81),(720,'0',81),(1,'825.9',82),(2,'1147.9',82),(3,'1188',82),(4,'1222.3',82),(5,'1244.7',82),(6,'1253.7',82),(7,'1264.5',82),(8,'1270.7',82),(9,'1277.8',82),(10,'1268.9',82),(11,'1269.3',82),(12,'1269.8',82),(13,'1272.1',82),(14,'1262.5',82),(15,'1269.2',82),(16,'1269.9',82),(17,'1264.3',82),(18,'1267.9',82),(19,'1276.4',82),(20,'1277.6',82),(21,'1274.9',82),(22,'1272',82),(23,'1273.9',82),(24,'1267.2',82),(25,'1269.9',82),(26,'1270.1',82),(27,'1267.9',82),(28,'1267.8',82),(29,'1271.3',82),(30,'1271.6',82),(31,'1267',82),(32,'1261',82),(33,'1259.5',82),(34,'1249.2',82),(35,'1242.1',82),(36,'1235.5',82),(37,'1225.6',82),(38,'1212.1',82),(39,'1203.5',82),(40,'1205.4',82),(41,'1202.9',82),(42,'1205.7',82),(43,'1196.4',82),(44,'1195.6',82),(45,'1197.9',82),(46,'1198.5',82),(47,'1190.6',82),(48,'1191.6',82),(49,'1192.4',82),(50,'1193',82),(51,'1189.9',82),(52,'1188',82),(53,'1189.5',82),(54,'1182.8',82),(55,'1181.8',82),(56,'1186',82),(57,'1184.9',82),(58,'1185.5',82),(59,'1176.9',82),(60,'1179.4',82),(61,'1183.5',82),(62,'1180.6',82),(63,'1185.3',82),(64,'1178.3',82),(65,'1182.6',82),(66,'1183.3',82),(67,'1185.9',82),(68,'1180.6',82),(69,'1182',82),(70,'1176.9',82),(71,'1182.6',82),(72,'1178.6',82),(73,'1173.1',82),(74,'1169',82),(75,'1170.2',82),(76,'1171.8',82),(77,'1169.9',82),(78,'1174.4',82),(79,'1167.9',82),(80,'1168.8',82),(81,'1172.2',82),(82,'1170.5',82),(83,'1166.3',82),(84,'1168.4',82),(85,'1167.6',82),(86,'1172.1',82),(87,'1170.2',82),(88,'1170.6',82),(89,'1172.1',82),(90,'1162.8',82),(91,'1165.7',82),(92,'1165.7',82),(93,'1163.1',82),(94,'1165.2',82),(95,'1169.7',82),(96,'1157.5',82),(97,'1155.7',82),(98,'1152.2',82),(99,'1159.4',82),(100,'1158.4',82),(101,'1155.5',82),(102,'1148.6',82),(103,'1153.6',82),(104,'1151.2',82),(105,'1151.8',82),(106,'1151.9',82),(107,'1151.1',82),(108,'1154.6',82),(109,'1155',82),(110,'1148.9',82),(111,'1154.9',82),(112,'1152.8',82),(113,'1153.9',82),(114,'1153',82),(115,'1153.5',82),(116,'1153.6',82),(117,'1150.6',82),(118,'1153.3',82),(119,'1149.3',82),(120,'1150.6',82),(121,'1147.9',82),(122,'1148.7',82),(123,'1153.7',82),(124,'1146.6',82),(125,'1139.7',82),(126,'1145.5',82),(127,'1145.9',82),(128,'1143',82),(129,'1146',82),(130,'1143',82),(131,'1142.5',82),(132,'1145.5',82),(133,'1143.1',82),(134,'1140.8',82),(135,'1142.8',82),(136,'1141.6',82),(137,'1137.7',82),(138,'1139.1',82),(139,'1138.2',82),(140,'1138.2',82),(141,'1144',82),(142,'1139.1',82),(143,'1139.9',82),(144,'1141.3',82),(145,'1139.4',82),(146,'1145.1',82),(147,'1143.5',82),(148,'1143.2',82),(149,'1146.3',82),(150,'1145.2',82),(151,'1142.2',82),(152,'1142.5',82),(153,'1145.3',82),(154,'1141.1',82),(155,'1142.7',82),(156,'1144',82),(157,'1142.7',82),(158,'1136.7',82),(159,'1138.6',82),(160,'1137.3',82),(161,'1134.3',82),(162,'1140.2',82),(163,'1137.8',82),(164,'1143.1',82),(165,'1144.7',82),(166,'1149.8',82),(167,'1148',82),(168,'1147.2',82),(169,'1142.6',82),(170,'1139.7',82),(171,'1141.6',82),(172,'1136.4',82),(173,'1138.5',82),(174,'1135.9',82),(175,'1136.2',82),(176,'1134.5',82),(177,'1128.4',82),(178,'1129.5',82),(179,'1127.6',82),(180,'1126.8',82),(181,'1128.9',82),(182,'1129.6',82),(183,'1130.4',82),(184,'1126.4',82),(185,'1123.8',82),(186,'1126.3',82),(187,'1125.3',82),(188,'1126.3',82),(189,'1125.5',82),(190,'1122.8',82),(191,'1123.2',82),(192,'1127.3',82),(193,'1125.8',82),(194,'1121.1',82),(195,'1121.4',82),(196,'1122.9',82),(197,'1127.4',82),(198,'1125.8',82),(199,'1126.5',82),(200,'1121.1',82),(201,'1125.9',82),(202,'1126.8',82),(203,'1123.2',82),(204,'363.3',82),(205,'0.9',82),(206,'24.9',82),(207,'41.4',82),(208,'0.8',82),(209,'20.8',82),(210,'41.6',82),(211,'0.8',82),(212,'23.1',82),(213,'43.2',82),(214,'0.8',82),(215,'20.9',82),(216,'44.1',82),(217,'0.8',82),(218,'20.8',82),(219,'46.9',82),(220,'0.8',82),(221,'20.8',82),(222,'46',82),(223,'0.8',82),(224,'18.8',82),(225,'48.7',82),(226,'0.8',82),(227,'17.1',82),(228,'314.1',82),(229,'1050.9',82),(230,'1114.6',82),(231,'1140.9',82),(232,'1150.3',82),(233,'1158.7',82),(234,'1159.3',82),(235,'1164.8',82),(236,'1169',82),(237,'1166',82),(238,'1169.9',82),(239,'1164.5',82),(240,'1168.6',82),(241,'1163.8',82),(242,'1162.8',82),(243,'1154.5',82),(244,'1148.2',82),(245,'1143.9',82),(246,'1136.8',82),(247,'1133.3',82),(248,'1128',82),(249,'1129.4',82),(250,'1125.2',82),(251,'1126.7',82),(252,'1121.6',82),(253,'1120.9',82),(254,'1119.6',82),(255,'1119.8',82),(256,'1120.1',82),(257,'1117.1',82),(258,'1119.3',82),(259,'1119.8',82),(260,'1117.4',82),(261,'1118.1',82),(262,'1123',82),(263,'1118.5',82),(264,'1120.2',82),(265,'1119',82),(266,'1121.5',82),(267,'1124.4',82),(268,'1126.4',82),(269,'1048.4',82),(270,'1.2',82),(271,'0.9',82),(272,'66.9',82),(273,'0.8',82),(274,'0.8',82),(275,'65.6',82),(276,'0.8',82),(277,'0.8',82),(278,'65.9',82),(279,'0.8',82),(280,'0.8',82),(281,'66.4',82),(282,'0.8',82),(283,'0.8',82),(284,'67',82),(285,'0.8',82),(286,'0.8',82),(287,'67.8',82),(288,'0.9',82),(289,'0.8',82),(290,'67.2',82),(291,'1.3',82),(292,'0.8',82),(293,'65.8',82),(294,'4.8',82),(295,'0.8',82),(296,'64.8',82),(297,'2.9',82),(298,'0.8',82),(299,'63',82),(300,'604.5',82),(301,'1059.8',82),(302,'1115.9',82),(303,'1137.9',82),(304,'1148',82),(305,'1155.5',82),(306,'1157.6',82),(307,'1159.8',82),(308,'1162',82),(309,'1167.1',82),(310,'1170.6',82),(311,'1166.6',82),(312,'1167.5',82),(313,'1164',82),(314,'1161.3',82),(315,'1157.1',82),(316,'1151.1',82),(317,'1137.3',82),(318,'1133',82),(319,'1127.7',82),(320,'1120.6',82),(321,'1118.1',82),(322,'1120.4',82),(323,'1112.9',82),(324,'1112.2',82),(325,'501.8',82),(326,'0.9',82),(327,'12.9',82),(328,'56.2',82),(329,'0.8',82),(330,'12.3',82),(331,'56.6',82),(332,'0.8',82),(333,'10.2',82),(334,'56.7',82),(335,'0.8',82),(336,'8.1',82),(337,'57.5',82),(338,'0.8',82),(339,'3.2',82),(340,'58.8',82),(341,'0.8',82),(342,'5.6',82),(343,'59.6',82),(344,'0.8',82),(345,'5.5',82),(346,'61.6',82),(347,'0.8',82),(348,'3.4',82),(349,'63.6',82),(350,'0.8',82),(351,'2.2',82),(352,'64',82),(353,'0.8',82),(354,'1.1',82),(355,'66.6',82),(356,'0.8',82),(357,'0.8',82),(358,'67.4',82),(359,'0.8',82),(360,'0.8',82),(361,'195.3',82),(362,'1019.4',82),(363,'1082.2',82),(364,'1120.9',82),(365,'1136.7',82),(366,'1141.9',82),(367,'1143.8',82),(368,'1152.2',82),(369,'1148.6',82),(370,'1154.4',82),(371,'1156',82),(372,'1152.3',82),(373,'1154.6',82),(374,'1158.3',82),(375,'1151.6',82),(376,'1152.1',82),(377,'1142.1',82),(378,'1134.7',82),(379,'837.3',82),(380,'1',82),(381,'0.9',82),(382,'63.9',82),(383,'0.8',82),(384,'0.8',82),(385,'64.9',82),(386,'0.8',82),(387,'0.8',82),(388,'66.3',82),(389,'0.8',82),(390,'0.8',82),(391,'66.5',82),(392,'0.8',82),(393,'0.8',82),(394,'66.6',82),(395,'0.8',82),(396,'0.8',82),(397,'65.3',82),(398,'0.8',82),(399,'0.8',82),(400,'67',82),(401,'0.8',82),(402,'0.8',82),(403,'66.3',82),(404,'0.8',82),(405,'0.8',82),(406,'68.8',82),(407,'0.8',82),(408,'0.8',82),(409,'67.4',82),(410,'0.8',82),(411,'0.8',82),(412,'66.4',82),(413,'0.8',82),(414,'0.8',82),(415,'67.7',82),(416,'0.8',82),(417,'0.8',82),(418,'62.9',82),(419,'923.1',82),(420,'1048.1',82),(421,'1090.8',82),(422,'1112.5',82),(423,'1121',82),(424,'1125',82),(425,'1132.7',82),(426,'1132.6',82),(427,'1136.2',82),(428,'1135.6',82),(429,'1134.9',82),(430,'1132.5',82),(431,'1133.5',82),(432,'799',82),(433,'1',82),(434,'0.9',82),(435,'68.6',82),(436,'0.8',82),(437,'0.8',82),(438,'67.8',82),(439,'0.8',82),(440,'0.8',82),(441,'66.5',82),(442,'0.8',82),(443,'0.8',82),(444,'65.3',82),(445,'0.8',82),(446,'0.8',82),(447,'62.4',82),(448,'0.8',82),(449,'0.8',82),(450,'63.4',82),(451,'0.8',82),(452,'0.8',82),(453,'64.3',82),(454,'0.8',82),(455,'0.8',82),(456,'65.7',82),(457,'0.8',82),(458,'0.8',82),(459,'64.8',82),(460,'0.8',82),(461,'0.8',82),(462,'65.7',82),(463,'0.8',82),(464,'0.8',82),(465,'66.8',82),(466,'0.8',82),(467,'0.8',82),(468,'66.1',82),(469,'871.5',82),(470,'1038.7',82),(471,'1082.8',82),(472,'1102.5',82),(473,'1113.5',82),(474,'1119.6',82),(475,'1123',82),(476,'1123.4',82),(477,'1127',82),(478,'1126.4',82),(479,'1126.6',82),(480,'1127.6',82),(481,'1123.8',82),(482,'1112.5',82),(483,'1099.2',82),(484,'1091.4',82),(485,'1083.8',82),(486,'345.8',82),(487,'0.9',82),(488,'27.7',82),(489,'41.5',82),(490,'0.8',82),(491,'25.4',82),(492,'40.6',82),(493,'0.8',82),(494,'21.1',82),(495,'42.2',82),(496,'0.8',82),(497,'23.6',82),(498,'43.8',82),(499,'0.8',82),(500,'22.6',82),(501,'44.2',82),(502,'0.8',82),(503,'21.6',82),(504,'45.7',82),(505,'0.8',82),(506,'20.7',82),(507,'46.1',82),(508,'0.8',82),(509,'19.8',82),(510,'47.8',82),(511,'0.8',82),(512,'18.8',82),(513,'50.1',82),(514,'0.8',82),(515,'17.7',82),(516,'52',82),(517,'0.8',82),(518,'16.7',82),(519,'52',82),(520,'0.8',82),(521,'15',82),(522,'52.3',82),(523,'0.8',82),(524,'13',82),(525,'55.2',82),(526,'0.8',82),(527,'12.4',82),(528,'55.2',82),(529,'0.8',82),(530,'8.3',82),(531,'275',82),(532,'975.5',82),(533,'1033.6',82),(534,'1068.8',82),(535,'1086.1',82),(536,'1096.6',82),(537,'1103.3',82),(538,'1111.9',82),(539,'1113.1',82),(540,'1114.4',82),(541,'1120.7',82),(542,'172.2',82),(543,'0.9',82),(544,'44.8',82),(545,'20.5',82),(546,'0.8',82),(547,'43.7',82),(548,'21.8',82),(549,'0.8',82),(550,'43.8',82),(551,'23.3',82),(552,'0.8',82),(553,'42.4',82),(554,'24',82),(555,'0.8',82),(556,'41.7',82),(557,'27.2',82),(558,'0.8',82),(559,'40.3',82),(560,'27.2',82),(561,'0.8',82),(562,'39.8',82),(563,'28.4',82),(564,'0.8',82),(565,'38.6',82),(566,'29.9',82),(567,'0.8',82),(568,'37.3',82),(569,'31.5',82),(570,'0.8',82),(571,'33.6',82),(572,'31.3',82),(573,'0.8',82),(574,'32.4',82),(575,'32.3',82),(576,'0.8',82),(577,'33',82),(578,'33.3',82),(579,'0.8',82),(580,'33.2',82),(581,'35.5',82),(582,'0.8',82),(583,'31.5',82),(584,'36',82),(585,'0.8',82),(586,'29.8',82),(587,'403',82),(588,'982.9',82),(589,'1042.6',82),(590,'1068.1',82),(591,'1083.7',82),(592,'1092.6',82),(593,'1097.7',82),(594,'1100.1',82),(595,'1105',82),(596,'1105.2',82),(597,'1107',82),(598,'12',82),(599,'0.9',82),(600,'66.7',82),(601,'2.7',82),(602,'0.8',82),(603,'63.5',82),(604,'1.1',82),(605,'0.8',82),(606,'63.5',82),(607,'2.8',82),(608,'0.8',82),(609,'61.8',82),(610,'3.8',82),(611,'0.8',82),(612,'60.8',82),(613,'4.8',82),(614,'0.8',82),(615,'59',82),(616,'5.8',82),(617,'0.8',82),(618,'57.2',82),(619,'7',82),(620,'0.8',82),(621,'57.7',82),(622,'7.9',82),(623,'0.8',82),(624,'58.1',82),(625,'9.5',82),(626,'0.8',82),(627,'56.2',82),(628,'11.9',82),(629,'0.8',82),(630,'56.2',82),(631,'12.8',82),(632,'0.8',82),(633,'54',82),(634,'13.3',82),(635,'0.8',82),(636,'52.9',82),(637,'14.9',82),(638,'0.8',82),(639,'51.3',82),(640,'15.2',82),(641,'0.8',82),(642,'49.3',82),(643,'15.5',82),(644,'0.8',82),(645,'47.5',82),(646,'17.4',82),(647,'0.8',82),(648,'47.7',82),(649,'578',82),(650,'995.3',82),(651,'1047.3',82),(652,'1074.2',82),(653,'1094.1',82),(654,'1095.3',82),(655,'1106.7',82),(656,'1116.8',82),(657,'1120.7',82),(658,'1116.8',82),(659,'1090.8',82),(660,'1.3',82),(661,'0.9',82),(662,'65.9',82),(663,'0.9',82),(664,'0.8',82),(665,'65.3',82),(666,'0.9',82),(667,'0.8',82),(668,'65.3',82),(669,'0.9',82),(670,'0.8',82),(671,'63.4',82),(672,'1.2',82),(673,'0.8',82),(674,'63.6',82),(675,'3',82),(676,'0.8',82),(677,'63.4',82),(678,'3.5',82),(679,'0.8',82),(680,'62.1',82),(681,'7',82),(682,'0.8',82),(683,'61.5',82),(684,'7.1',82),(685,'0.8',82),(686,'59.3',82),(687,'7.3',82),(688,'0.4',82),(689,'0.4',82),(690,'0.4',82),(691,'0.4',82),(692,'37.1',82),(693,'803.6',82),(694,'1027.3',82),(695,'388',82),(696,'0.4',82),(697,'0.4',82),(698,'0.4',82),(699,'0.4',82),(700,'0.4',82),(701,'0.4',82),(702,'0.4',82),(703,'0.4',82),(704,'0.4',82),(705,'0.4',82),(706,'0.4',82),(707,'0.4',82),(708,'0.4',82),(709,'0.4',82),(710,'0.4',82),(711,'0.4',82),(712,'0.4',82),(713,'0.4',82),(714,'0.4',82),(715,'0.4',82),(716,'0.4',82),(717,'0.4',82),(718,'0.4',82),(719,'0.4',82),(720,'0.4',82),(1,'0',83),(2,'0',83),(3,'0',83),(4,'0',83),(5,'0',83),(6,'0',83),(7,'0',83),(8,'0',83),(9,'0',83),(10,'0',83),(11,'0',83),(12,'0',83),(13,'0',83),(14,'0',83),(15,'0',83),(16,'0',83),(17,'0.1',83),(18,'4.5',83),(19,'4.5',83),(20,'4.5',83),(21,'4.4',83),(22,'0',83),(23,'0',83),(24,'0',83),(25,'0',83),(26,'0',83),(27,'0',83),(28,'0',83),(29,'0',83),(30,'0',83),(31,'0',83),(32,'0',83),(33,'0',83),(34,'0',83),(35,'0',83),(36,'1',83),(37,'4.5',83),(38,'4.5',83),(39,'4.5',83),(40,'4.5',83),(41,'4.6',83),(42,'4.6',83),(43,'4.5',83),(44,'4.6',83),(45,'4.5',83),(46,'0',83),(47,'0',83),(48,'0',83),(49,'0',83),(50,'0',83),(51,'0',83),(52,'0',83),(53,'0',83),(54,'0',83),(55,'0',83),(56,'0',83),(57,'0',83),(58,'0',83),(59,'0',83),(60,'0',83),(61,'0',83),(62,'0',83),(63,'0',83),(64,'0',83),(65,'0',83),(66,'0',83),(67,'0',83),(68,'0',83),(69,'0',83),(70,'0',83),(71,'0',83),(72,'0',83),(73,'0',83),(74,'0',83),(75,'0',83),(76,'0',83),(77,'0',83),(78,'0',83),(79,'0',83),(80,'0',83),(81,'0',83),(82,'0',83),(83,'0',83),(84,'0',83),(85,'0',83),(86,'0',83),(87,'0',83),(88,'0',83),(89,'0',83),(90,'0',83),(91,'0',83),(92,'0',83),(93,'0',83),(94,'0',83),(95,'0',83),(96,'0',83),(97,'0',83),(98,'0',83),(99,'0',83),(100,'0',83),(101,'0',83),(102,'0',83),(103,'0',83),(104,'0',83),(105,'0',83),(106,'0',83),(107,'0',83),(108,'0',83),(109,'0',83),(110,'0',83),(111,'0',83),(112,'0',83),(113,'0',83),(114,'0',83),(115,'0',83),(116,'0',83),(117,'0',83),(118,'0',83),(119,'0',83),(120,'0',83),(121,'0',83),(122,'0',83),(123,'0',83),(124,'0',83),(125,'0',83),(126,'0',83),(127,'0',83),(128,'0',83),(129,'0',83),(130,'0',83),(131,'0',83),(132,'0',83),(133,'0',83),(134,'0',83),(135,'0',83),(136,'0',83),(137,'0',83),(138,'0',83),(139,'0',83),(140,'0',83),(141,'0',83),(142,'0',83),(143,'0',83),(144,'0',83),(145,'0',83),(146,'0',83),(147,'0',83),(148,'0',83),(149,'0',83),(150,'0',83),(151,'0',83),(152,'0',83),(153,'0',83),(154,'0',83),(155,'0',83),(156,'1',83),(157,'4.5',83),(158,'4.5',83),(159,'4.5',83),(160,'4.5',83),(161,'4.6',83),(162,'4.6',83),(163,'1.3',83),(164,'0',83),(165,'0',83),(166,'0',83),(167,'0',83),(168,'0',83),(169,'0',83),(170,'0',83),(171,'0',83),(172,'0',83),(173,'0',83),(174,'0',83),(175,'0',83),(176,'0',83),(177,'0',83),(178,'0',83),(179,'0',83),(180,'0',83),(181,'0',83),(182,'0',83),(183,'0',83),(184,'0',83),(185,'0',83),(186,'0',83),(187,'0',83),(188,'0',83),(189,'0',83),(190,'0',83),(191,'0',83),(192,'0',83),(193,'0',83),(194,'0',83),(195,'0',83),(196,'0',83),(197,'0',83),(198,'0',83),(199,'0',83),(200,'0',83),(201,'0',83),(202,'0',83),(203,'0',83),(204,'0',83),(205,'0',83),(206,'0',83),(207,'0',83),(208,'0',83),(209,'0',83),(210,'0',83),(211,'0',83),(212,'0',83),(213,'0',83),(214,'0',83),(215,'0',83),(216,'0',83),(217,'0',83),(218,'0',83),(219,'0',83),(220,'0',83),(221,'0',83),(222,'0',83),(223,'0',83),(224,'0',83),(225,'0',83),(226,'0',83),(227,'0',83),(228,'0',83),(229,'0',83),(230,'0',83),(231,'0',83),(232,'0',83),(233,'0',83),(234,'0',83),(235,'0',83),(236,'0',83),(237,'0',83),(238,'0',83),(239,'0',83),(240,'0',83),(241,'0',83),(242,'0',83),(243,'0',83),(244,'0',83),(245,'0',83),(246,'0',83),(247,'0',83),(248,'0',83),(249,'0',83),(250,'0',83),(251,'0',83),(252,'0',83),(253,'0',83),(254,'0',83),(255,'0',83),(256,'0',83),(257,'0',83),(258,'0',83),(259,'0',83),(260,'0',83),(261,'0',83),(262,'0',83),(263,'0',83),(264,'0',83),(265,'0',83),(266,'0',83),(267,'0',83),(268,'0',83),(269,'0',83),(270,'0',83),(271,'0',83),(272,'0',83),(273,'0',83),(274,'0',83),(275,'0',83),(276,'0',83),(277,'0',83),(278,'0',83),(279,'0',83),(280,'0',83),(281,'0',83),(282,'0',83),(283,'0',83),(284,'0',83),(285,'0',83),(286,'0',83),(287,'0',83),(288,'0',83),(289,'0',83),(290,'0',83),(291,'0',83),(292,'0',83),(293,'0',83),(294,'0',83),(295,'0',83),(296,'0',83),(297,'0',83),(298,'0',83),(299,'0',83),(300,'0',83),(301,'0',83),(302,'0',83),(303,'0',83),(304,'0',83),(305,'0',83),(306,'0',83),(307,'0',83),(308,'0',83),(309,'0',83),(310,'0',83),(311,'0',83),(312,'0',83),(313,'0',83),(314,'0',83),(315,'0',83),(316,'0',83),(317,'0',83),(318,'0',83),(319,'0',83),(320,'0',83),(321,'0',83),(322,'0',83),(323,'0',83),(324,'0',83),(325,'0',83),(326,'0',83),(327,'0',83),(328,'0',83),(329,'0',83),(330,'0',83),(331,'0',83),(332,'0',83),(333,'0',83),(334,'0',83),(335,'0',83),(336,'0',83),(337,'0',83),(338,'0',83),(339,'0',83),(340,'0',83),(341,'0',83),(342,'0',83),(343,'0',83),(344,'0',83),(345,'0',83),(346,'0',83),(347,'0',83),(348,'0',83),(349,'0',83),(350,'0',83),(351,'0',83),(352,'0',83),(353,'0',83),(354,'0',83),(355,'0',83),(356,'0',83),(357,'0',83),(358,'0',83),(359,'0',83),(360,'0',83),(361,'0',83),(362,'0',83),(363,'0',83),(364,'0',83),(365,'0',83),(366,'0',83),(367,'0',83),(368,'0',83),(369,'0',83),(370,'0',83),(371,'0',83),(372,'0',83),(373,'0',83),(374,'0',83),(375,'0',83),(376,'0',83),(377,'0',83),(378,'0',83),(379,'0',83),(380,'0',83),(381,'0',83),(382,'0',83),(383,'0',83),(384,'0',83),(385,'0',83),(386,'0',83),(387,'0',83),(388,'0',83),(389,'0',83),(390,'0',83),(391,'0',83),(392,'0',83),(393,'0',83),(394,'0',83),(395,'0',83),(396,'0',83),(397,'0',83),(398,'0',83),(399,'0',83),(400,'0',83),(401,'0',83),(402,'0',83),(403,'0',83),(404,'0',83),(405,'0',83),(406,'0',83),(407,'0',83),(408,'0',83),(409,'0',83),(410,'0',83),(411,'0',83),(412,'0',83),(413,'0',83),(414,'0',83),(415,'0',83),(416,'0',83),(417,'0',83),(418,'0',83),(419,'0',83),(420,'0',83),(421,'0',83),(422,'0',83),(423,'0',83),(424,'0',83),(425,'0',83),(426,'0',83),(427,'0',83),(428,'0',83),(429,'0',83),(430,'0',83),(431,'0',83),(432,'0',83),(433,'0',83),(434,'0',83),(435,'0',83),(436,'0',83),(437,'0',83),(438,'0',83),(439,'0',83),(440,'0',83),(441,'0',83),(442,'0',83),(443,'0',83),(444,'0',83),(445,'0',83),(446,'0',83),(447,'0',83),(448,'0',83),(449,'0',83),(450,'0',83),(451,'0',83),(452,'0',83),(453,'0',83),(454,'0',83),(455,'0',83),(456,'0',83),(457,'0',83),(458,'0',83),(459,'0',83),(460,'0',83),(461,'0',83),(462,'0',83),(463,'0.1',83),(464,'4.5',83),(465,'4.5',83),(466,'4.5',83),(467,'4.5',83),(468,'4.5',83),(469,'4.4',83),(470,'0',83),(471,'0',83),(472,'0',83),(473,'0',83),(474,'0',83),(475,'0',83),(476,'0',83),(477,'0',83),(478,'0',83),(479,'0',83),(480,'0',83),(481,'0',83),(482,'0',83),(483,'0',83),(484,'0',83),(485,'0',83),(486,'0',83),(487,'0',83),(488,'0',83),(489,'0',83),(490,'0',83),(491,'0',83),(492,'0',83),(493,'0',83),(494,'0',83),(495,'0',83),(496,'0',83),(497,'0',83),(498,'0',83),(499,'0',83),(500,'0',83),(501,'0',83),(502,'0',83),(503,'0',83),(504,'0',83),(505,'0',83),(506,'0',83),(507,'0',83),(508,'0',83),(509,'0',83),(510,'0',83),(511,'0',83),(512,'0',83),(513,'0',83),(514,'0',83),(515,'0',83),(516,'0',83),(517,'0',83),(518,'0',83),(519,'0',83),(520,'0',83),(521,'0',83),(522,'0',83),(523,'0',83),(524,'0',83),(525,'0',83),(526,'0',83),(527,'0',83),(528,'0',83),(529,'0',83),(530,'0',83),(531,'0',83),(532,'0',83),(533,'0',83),(534,'0',83),(535,'0',83),(536,'0',83),(537,'0',83),(538,'0',83),(539,'0',83),(540,'0',83),(541,'0',83),(542,'0',83),(543,'0',83),(544,'0',83),(545,'0',83),(546,'0',83),(547,'0',83),(548,'0',83),(549,'0',83),(550,'0',83),(551,'0',83),(552,'0',83),(553,'0',83),(554,'0',83),(555,'0',83),(556,'0',83),(557,'0',83),(558,'0',83),(559,'0',83),(560,'0',83),(561,'0',83),(562,'0',83),(563,'0',83),(564,'0',83),(565,'0',83),(566,'0',83),(567,'0',83),(568,'0',83),(569,'0',83),(570,'0',83),(571,'0',83),(572,'0',83),(573,'0',83),(574,'0',83),(575,'0',83),(576,'0',83),(577,'0',83),(578,'0',83),(579,'0',83),(580,'0',83),(581,'0',83),(582,'0',83),(583,'0',83),(584,'0',83),(585,'0',83),(586,'0',83),(587,'0',83),(588,'0',83),(589,'0',83),(590,'0',83),(591,'0',83),(592,'0',83),(593,'0',83),(594,'0',83),(595,'0',83),(596,'0',83),(597,'0',83),(598,'0',83),(599,'0',83),(600,'0',83),(601,'0',83),(602,'0',83),(603,'0',83),(604,'0',83),(605,'0',83),(606,'0',83),(607,'0',83),(608,'0',83),(609,'0',83),(610,'0',83),(611,'0',83),(612,'0',83),(613,'0',83),(614,'0',83),(615,'0',83),(616,'0',83),(617,'0',83),(618,'0',83),(619,'0',83),(620,'0',83),(621,'0',83),(622,'0',83),(623,'0',83),(624,'0',83),(625,'0',83),(626,'0',83),(627,'0',83),(628,'0',83),(629,'0',83),(630,'0',83),(631,'0',83),(632,'0',83),(633,'0',83),(634,'0',83),(635,'0',83),(636,'0',83),(637,'0',83),(638,'0',83),(639,'0',83),(640,'0',83),(641,'0',83),(642,'0',83),(643,'0',83),(644,'0',83),(645,'0',83),(646,'0',83),(647,'0',83),(648,'0',83),(649,'0',83),(650,'0',83),(651,'0',83),(652,'0',83),(653,'0',83),(654,'0',83),(655,'0',83),(656,'0',83),(657,'0',83),(658,'0',83),(659,'0',83),(660,'0',83),(661,'0',83),(662,'0',83),(663,'0',83),(664,'0',83),(665,'0',83),(666,'0',83),(667,'0',83),(668,'0',83),(669,'0',83),(670,'0',83),(671,'0',83),(672,'0',83),(673,'0',83),(674,'0',83),(675,'0',83),(676,'0',83),(677,'0',83),(678,'0',83),(679,'0',83),(680,'0',83),(681,'0',83),(682,'0',83),(683,'0',83),(684,'0',83),(685,'0',83),(686,'0',83),(687,'0',83),(688,'0',83),(689,'0',83),(690,'0',83),(691,'0',83),(692,'0',83),(693,'0',83),(694,'0',83),(695,'0',83),(696,'0',83),(697,'0',83),(698,'0',83),(699,'0',83),(700,'0',83),(701,'0',83),(702,'0',83),(703,'0',83),(704,'0',83),(705,'0',83),(706,'0',83),(707,'0',83),(708,'0',83),(709,'0',83),(710,'0',83),(711,'0',83),(712,'0.2',83),(713,'4.6',83),(714,'4.6',83),(715,'2.5',83),(716,'0',83),(717,'0',83),(718,'0',83),(719,'0',83),(720,'0',83),(721,'0',83),(722,'0',83),(723,'0',83),(724,'0',83),(725,'0',83),(726,'0',83),(727,'0',83),(728,'0',83),(729,'0',83),(730,'0',83),(731,'0',83),(732,'0',83),(733,'0',83),(734,'0',83),(735,'0',83),(736,'0',83),(737,'0',83),(738,'0',83),(739,'0',83),(740,'0',83),(741,'0',83),(742,'0',83),(743,'0',83),(744,'0',83),(745,'0',83),(746,'0',83),(747,'0',83),(748,'0',83),(749,'0',83),(750,'0',83),(751,'0',83),(752,'0',83),(753,'0',83),(754,'0',83),(755,'0',83),(756,'0',83),(757,'0',83),(758,'0',83),(759,'0',83),(760,'0',83),(761,'0',83),(762,'0',83),(763,'0',83),(764,'0',83),(765,'0',83),(766,'0',83),(767,'0',83),(768,'0',83),(769,'0',83),(770,'0',83),(771,'0',83),(772,'0',83),(773,'0',83),(774,'0',83),(775,'0',83),(776,'0',83),(777,'0',83),(778,'0',83),(779,'0',83),(780,'0',83),(781,'0',83),(782,'0',83),(783,'0',83),(784,'0',83),(785,'0',83),(786,'0',83),(787,'0',83),(788,'0',83),(789,'0',83),(790,'0',83),(791,'0',83),(792,'0',83),(793,'0',83),(794,'3.1',83),(795,'4.5',83),(796,'4.5',83),(797,'4.5',83),(798,'4.5',83),(799,'4.5',83),(800,'4.5',83),(801,'0.1',83),(802,'0',83),(803,'0',83),(804,'0',83),(805,'0',83),(806,'0',83),(807,'0',83),(808,'0',83),(809,'0',83),(810,'0',83),(811,'0',83),(812,'0',83),(813,'0',83),(814,'0',83),(815,'0',83),(816,'0',83),(817,'0',83),(818,'0',83),(819,'0',83),(820,'0',83),(821,'0',83),(822,'0',83),(823,'0',83),(824,'0',83),(825,'0',83),(826,'0',83),(827,'0',83),(828,'0',83),(829,'0',83),(830,'3.3',83),(831,'4.4',83),(832,'4.4',83),(833,'4.4',83),(834,'4.4',83),(835,'4.4',83),(836,'4.5',83),(837,'4.2',83),(838,'0',83),(839,'0',83),(840,'0',83),(841,'0',83),(842,'0',83),(843,'0',83),(844,'0',83),(845,'0',83),(846,'0',83),(847,'0',83),(848,'0',83),(849,'0',83),(850,'0',83),(851,'0',83),(852,'0',83),(853,'0',83),(854,'0',83),(855,'0',83),(856,'0',83),(857,'0',83),(858,'0',83),(859,'0',83),(860,'0',83),(861,'0',83),(862,'0',83),(863,'0.8',83),(864,'4.5',83),(865,'4.5',83),(866,'4.5',83),(867,'4.5',83),(868,'4.5',83),(869,'4.5',83),(870,'4.5',83),(871,'4.5',83),(872,'4.5',83),(873,'4.5',83),(874,'4.5',83),(875,'2.8',83),(876,'0',83),(877,'0',83),(878,'0',83),(879,'0',83),(880,'0',83),(881,'0',83),(882,'0',83),(883,'0',83),(884,'0',83),(885,'0',83),(886,'0',83),(887,'0',83),(888,'0',83),(889,'0',83),(890,'0',83),(891,'0',83),(892,'0',83),(893,'0',83),(894,'0',83),(895,'0',83),(896,'0',83),(897,'0',83),(898,'0',83),(899,'0',83),(900,'0',83),(901,'0',83),(902,'0',83),(903,'0',83),(904,'0',83),(905,'0',83),(906,'0',83),(907,'0',83),(908,'0',83),(909,'0',83),(910,'0',83),(911,'0',83),(912,'0',83),(913,'0',83),(914,'0',83),(915,'0',83),(916,'0',83),(917,'0',83),(918,'0',83),(919,'0',83),(920,'0',83),(921,'0',83),(922,'0',83),(923,'0',83),(924,'0',83),(925,'0',83),(926,'0',83),(927,'0',83),(928,'0',83),(929,'0',83),(930,'0',83),(931,'0',83),(932,'0',83),(933,'0',83),(934,'0',83),(935,'0',83),(936,'0',83),(937,'0',83),(938,'0',83),(939,'0',83),(940,'0',83),(941,'0',83),(942,'0',83),(943,'0',83),(944,'0',83),(945,'0',83),(946,'2.6',83),(947,'4.5',83),(948,'4.5',83),(949,'4.5',83),(950,'4.5',83),(951,'4.5',83),(952,'1.9',83),(953,'0',83),(954,'0',83),(955,'0',83),(956,'0',83),(957,'0',83),(958,'0',83),(959,'0',83),(960,'0',83),(1,'1202.3',84),(2,'1284',84),(3,'1028.5',84),(4,'827.4',84),(5,'825.9',84),(6,'710.6',84),(7,'707',84),(8,'680',84),(9,'625.9',84),(10,'888',84),(11,'870.5',84),(12,'788.7',84),(13,'863.9',84),(14,'737.4',84),(15,'2',84),(16,'74.1',84),(17,'227.9',84),(18,'168',84),(19,'170',84),(20,'832.9',84),(21,'513.9',84),(22,'0.8',84),(23,'0',84),(24,'0',84),(25,'0',84),(26,'0',84),(27,'0',84),(28,'0',84),(29,'0',84),(30,'0',84),(1,'2253.7',85),(2,'2351.8',85),(3,'2353.7',85),(4,'2351.8',85),(5,'2344.2',85),(6,'2337.3',85),(7,'2199',85),(8,'1959',85),(9,'2139.2',85),(10,'1958.6',85),(11,'1324.6',85),(12,'998',85),(13,'1031.9',85),(14,'1228.9',85),(15,'1348.3',85),(16,'864.7',85),(17,'3.8',85),(18,'2',85),(19,'401.5',85),(20,'168.8',85),(21,'210.4',85),(22,'350.9',85),(23,'265.2',85),(24,'204',85),(25,'206.5',85),(26,'161.9',85),(27,'0',85),(28,'0',85),(29,'0',85),(30,'0',85),(1,'940.6',86),(2,'479.6',86),(3,'2814.3',86),(4,'2815.6',86),(5,'2755',86),(6,'2799.9',86),(7,'2765.7',86),(8,'2805.4',86),(9,'2729.1',86),(10,'2771.8',86),(11,'2838.3',86),(12,'2793.1',86),(13,'2849.6',86),(14,'2795.1',86),(15,'2848.9',86),(16,'2758.8',86),(17,'2849.2',86),(18,'2776.1',86),(19,'2605.5',86),(20,'32',86),(21,'32',86),(22,'1480',86),(23,'2847.2',86),(24,'2762.8',86),(25,'2516.6',86),(26,'31.8',86),(27,'31.7',86),(28,'2351.2',86),(29,'2613.1',86),(30,'0',86);
/*!40000 ALTER TABLE `samples` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `solarlog`
--

DROP TABLE IF EXISTS `solarlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `solarlog` (
  `user` varchar(10) NOT NULL,
  `data` date NOT NULL,
  `time` time NOT NULL,
  `power` float NOT NULL,
  KEY `idxuser` (`user`),
  KEY `idxdata` (`data`),
  KEY `idxtime` (`time`),
  KEY `user` (`user`),
  KEY `data` (`data`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `solarlog`
--

LOCK TABLES `solarlog` WRITE;
/*!40000 ALTER TABLE `solarlog` DISABLE KEYS */;
INSERT INTO `solarlog` VALUES ('10318','2014-05-05','07:10:00',1.03),('10318','2014-05-05','07:15:00',1.71),('10318','2014-05-05','07:20:00',2.07),('10318','2014-05-05','07:25:00',2.07),('10318','2014-05-05','07:30:00',2.46),('10318','2014-05-05','07:35:00',2.92),('10318','2014-05-05','07:40:00',1.96),('10318','2014-05-05','07:45:00',1.42),('10318','2014-05-05','07:50:00',3.67),('10318','2014-05-05','07:55:00',3.79),('10318','2014-05-05','08:00:00',4.11),('10318','2014-05-05','08:05:00',4.32),('10318','2014-05-05','08:10:00',4.54),('10318','2014-05-05','08:15:00',4.77),('10318','2014-05-05','08:20:00',4.97),('10318','2014-05-05','08:25:00',5.18),('10318','2014-05-05','08:30:00',5.38),('10318','2014-05-05','08:35:00',5.58),('10318','2014-05-05','08:40:00',5.77),('10318','2014-05-05','08:45:00',5.99),('10318','2014-05-05','08:50:00',6.2),('10318','2014-05-05','08:55:00',6.35),('10318','2014-05-05','09:00:00',6.56),('10318','2014-05-05','09:05:00',6.72),('10318','2014-05-05','09:10:00',6.83),('10318','2014-05-05','09:15:00',7.06),('10318','2014-05-05','09:20:00',7.15),('10318','2014-05-05','09:25:00',7.31),('10318','2014-05-05','09:30:00',7.12),('10318','2014-05-05','09:35:00',7.68),('10318','2014-05-05','09:40:00',7.68),('10318','2014-05-05','09:45:00',7.95),('10318','2014-05-05','09:50:00',8.07),('10318','2014-05-05','09:55:00',8.21),('10318','2014-05-05','10:00:00',8.3),('10318','2014-05-05','10:05:00',8.42),('10318','2014-05-05','10:10:00',8.58),('10318','2014-05-05','10:15:00',8.68),('10318','2014-05-05','10:20:00',8.84),('10318','2014-05-05','10:25:00',9.06),('10318','2014-05-05','10:30:00',9.14),('10318','2014-05-05','10:35:00',9.38),('10318','2014-05-05','10:40:00',9.26),('10318','2014-05-05','10:45:00',9.01),('10318','2014-05-05','10:50:00',9.4),('10318','2014-05-05','10:55:00',9.27),('10318','2014-05-05','11:00:00',9.49),('10318','2014-05-05','11:05:00',9.54),('10318','2014-05-05','11:10:00',9.6),('10318','2014-05-05','11:15:00',7.72),('10318','2014-05-05','11:20:00',9.43),('10318','2014-05-05','11:25:00',9.97),('10318','2014-05-05','11:30:00',10.35),('10318','2014-05-05','11:35:00',9.9),('10318','2014-05-05','11:40:00',9.9),('10318','2014-05-05','11:45:00',10.21),('10318','2014-05-05','11:50:00',10.48),('10318','2014-05-05','11:55:00',10.72),('10318','2014-05-05','12:00:00',10.42),('10318','2014-05-05','12:05:00',9.04),('10318','2014-05-05','12:10:00',9.1),('10318','2014-05-05','12:15:00',8.47),('10318','2014-05-05','12:20:00',10.8),('10318','2014-05-05','12:25:00',10.33),('10318','2014-05-05','12:30:00',7.95),('10318','2014-05-05','12:35:00',5.62),('10318','2014-05-05','12:40:00',5.8),('10318','2014-05-05','12:45:00',10.54),('10318','2014-05-05','12:50:00',10.47),('10318','2014-05-05','12:55:00',10.57),('10318','2014-05-05','13:00:00',9.97),('10318','2014-05-05','13:05:00',10.07),('10318','2014-05-05','13:10:00',9.92),('10318','2014-05-05','13:15:00',10),('10318','2014-05-05','13:20:00',9.4),('10318','2014-05-05','13:25:00',5.29),('10318','2014-05-05','13:30:00',1.93),('10318','2014-05-05','13:35:00',8.22),('10318','2014-05-05','13:40:00',8.37),('10318','2014-05-05','13:45:00',3.3),('10318','2014-05-05','13:50:00',5.18),('10318','2014-05-05','13:55:00',8.75),('10318','2014-05-05','14:00:00',10.27),('10318','2014-05-05','14:05:00',9.79),('10318','2014-05-05','14:10:00',8.76),('10318','2014-05-05','14:15:00',8.86),('10318','2014-05-05','14:20:00',7.94),('10318','2014-05-05','14:25:00',9.59),('10318','2014-05-05','14:30:00',6.79),('10318','2014-05-05','14:35:00',4.05),('10318','2014-05-05','14:40:00',8.69),('10318','2014-05-05','14:45:00',10.33),('10318','2014-05-05','14:50:00',6.38),('10318','2014-05-05','14:55:00',4.25),('10318','2014-05-05','15:00:00',7.59),('10318','2014-05-05','15:05:00',7.71),('10318','2014-05-05','15:10:00',7.96),('10318','2014-05-05','15:15:00',8.81),('10318','2014-05-05','15:20:00',8.7),('10318','2014-05-05','15:25:00',6.26),('10318','2014-05-05','15:30:00',8),('10318','2014-05-05','15:35:00',8.06),('10318','2014-05-05','15:40:00',8.11),('10318','2014-05-05','15:45:00',4.28),('10318','2014-05-05','15:50:00',7.74),('10318','2014-05-05','15:55:00',5.79),('10318','2014-05-05','16:00:00',6.43),('10318','2014-05-05','16:05:00',6.23),('10318','2014-05-05','16:10:00',2.76),('10318','2014-05-05','16:15:00',5.59),('10318','2014-05-05','16:20:00',4.79),('10318','2014-05-05','16:25:00',6.37),('10318','2014-05-05','16:30:00',6.42),('10318','2014-05-05','16:35:00',5.83),('10318','2014-05-05','16:40:00',5.68),('10318','2014-05-05','16:45:00',5.29),('10318','2014-05-05','16:50:00',5.16),('10318','2014-05-05','16:55:00',5.02),('10318','2014-05-05','17:00:00',4.64),('10318','2014-05-05','17:05:00',4.26),('10318','2014-05-05','17:10:00',4.27),('10318','2014-05-05','17:15:00',4.09),('10318','2014-05-05','17:20:00',3.83),('10318','2014-05-05','17:25:00',3.61),('10318','2014-05-05','17:30:00',3.35),('10318','2014-05-05','17:35:00',3.06),('10318','2014-05-05','17:40:00',2.96),('10318','2014-05-05','17:45:00',2.82),('10318','2014-05-05','17:50:00',2.62),('10318','2014-05-05','17:55:00',2.41),('10318','2014-05-05','18:00:00',2.24),('10318','2014-05-05','18:05:00',2.09),('10318','2014-05-05','18:10:00',1.91),('10318','2014-05-05','18:15:00',1.73),('10318','2014-05-05','18:20:00',1.55),('10318','2014-05-05','18:25:00',1.44),('10318','2014-05-05','18:30:00',1.31),('10318','2014-05-05','18:35:00',1.17),('10318','2014-05-05','18:40:00',1),('10318','2014-04-26','07:50:00',1.12),('10318','2014-04-26','07:55:00',1.17),('10318','2014-04-26','08:00:00',1.28),('10318','2014-04-26','08:05:00',1.33),('10318','2014-04-26','08:10:00',1.43),('10318','2014-04-26','08:15:00',1.57),('10318','2014-04-26','08:20:00',1.6),('10318','2014-04-26','08:25:00',1.62),('10318','2014-04-26','08:30:00',1.48),('10318','2014-04-26','08:35:00',1.43),('10318','2014-04-26','08:40:00',1.65),('10318','2014-04-26','08:45:00',1.83),('10318','2014-04-26','08:50:00',1.82),('10318','2014-04-26','08:55:00',2.03),('10318','2014-04-26','09:00:00',2.04),('10318','2014-04-26','09:05:00',2.14),('10318','2014-04-26','09:10:00',1.95),('10318','2014-04-26','09:15:00',1.73),('10318','2014-04-26','09:20:00',1.8),('10318','2014-04-26','09:25:00',1.81),('10318','2014-04-26','09:30:00',1.72),('10318','2014-04-26','09:35:00',1.75),('10318','2014-04-26','09:40:00',1.91),('10318','2014-04-26','09:45:00',1.84),('10318','2014-04-26','09:50:00',1.88),('10318','2014-04-26','09:55:00',2.71),('10318','2014-04-26','10:00:00',3.59),('10318','2014-04-26','10:05:00',3.61),('10318','2014-04-26','10:10:00',2.98),('10318','2014-04-26','10:15:00',3.06),('10318','2014-04-26','10:20:00',3.38),('10318','2014-04-26','10:25:00',3.66),('10318','2014-04-26','10:30:00',3.95),('10318','2014-04-26','10:35:00',4.27),('10318','2014-04-26','10:40:00',3.89),('10318','2014-04-26','10:45:00',4.19),('10318','2014-04-26','10:50:00',5.74),('10318','2014-04-26','10:55:00',8.65),('10318','2014-04-26','11:00:00',7.71),('10318','2014-04-26','11:05:00',9.25),('10318','2014-04-26','11:10:00',8.43),('10318','2014-04-26','11:15:00',8.32),('10318','2014-04-26','11:20:00',8.43),('10318','2014-04-26','11:25:00',7.84),('10318','2014-04-26','11:30:00',7.79),('10318','2014-04-26','11:35:00',7.22),('10318','2014-04-26','11:40:00',7.52),('10318','2014-04-26','11:45:00',7.64),('10318','2014-04-26','11:50:00',7.53),('10318','2014-04-26','11:55:00',8.3),('10318','2014-04-26','12:00:00',7.21),('10318','2014-04-26','12:05:00',7.55),('10318','2014-04-26','12:10:00',7.24),('10318','2014-04-26','12:15:00',4.46),('10318','2014-04-26','12:20:00',6.12),('10318','2014-04-26','12:25:00',6.65),('10318','2014-04-26','12:30:00',6),('10318','2014-04-26','12:35:00',4.74),('10318','2014-04-26','12:40:00',4.73),('10318','2014-04-26','12:45:00',6.15),('10318','2014-04-26','12:50:00',5.88),('10318','2014-04-26','12:55:00',8.23),('10318','2014-04-26','13:00:00',10.31),('10318','2014-04-26','13:05:00',7.95),('10318','2014-04-26','13:10:00',9.4),('10318','2014-04-26','13:15:00',9.34),('10318','2014-04-26','13:20:00',9.48),('10318','2014-04-26','13:25:00',8.22),('10318','2014-04-26','13:30:00',8.03),('10318','2014-04-26','13:35:00',7.32),('10318','2014-04-26','13:40:00',5.53),('10318','2014-04-26','13:45:00',5.86),('10318','2014-04-26','13:50:00',9.58),('10318','2014-04-26','13:55:00',4.41),('10318','2014-04-26','14:00:00',1.95),('10318','2014-04-26','14:05:00',1.28),('10318','2014-04-26','14:10:00',1.07),('10318','2014-04-26','14:20:00',1.6),('10318','2014-04-26','14:25:00',2.25),('10318','2014-04-26','14:30:00',1.74),('10318','2014-04-26','14:35:00',1.84),('10318','2014-04-26','14:40:00',1.67),('10318','2014-04-26','14:45:00',1.44),('10318','2014-04-26','14:50:00',1.07),('10318','2014-04-26','15:10:00',1.19),('10318','2014-04-26','15:45:00',1.07),('10318','2014-04-26','17:40:00',1.23),('10318','2014-04-26','17:45:00',1.63),('10318','2014-04-26','17:50:00',1.91),('10318','2014-04-26','17:55:00',1.71),('10318','2014-04-26','18:00:00',1.2),('10318','2014-04-26','18:25:00',1.01),('10318','2014-04-26','18:30:00',1.24),('10318','2014-04-26','18:35:00',1.48),('10318','2014-04-26','18:40:00',1.67),('10318','2014-04-26','18:45:00',1.7),('10318','2014-04-26','18:50:00',1.29),('10318','2014-04-25','07:20:00',1.05),('10318','2014-04-25','07:25:00',1.27),('10318','2014-04-25','07:30:00',1.67),('10318','2014-04-25','07:35:00',1.92),('10318','2014-04-25','07:40:00',1.87),('10318','2014-04-25','07:45:00',2.78),('10318','2014-04-25','07:50:00',2.91),('10318','2014-04-25','07:55:00',3),('10318','2014-04-25','08:00:00',3.24),('10318','2014-04-25','08:05:00',3.49),('10318','2014-04-25','08:10:00',3.67),('10318','2014-04-25','08:15:00',3.93),('10318','2014-04-25','08:20:00',4.39),('10318','2014-04-25','08:25:00',4.51),('10318','2014-04-25','08:30:00',4.69),('10318','2014-04-25','08:35:00',4.84),('10318','2014-04-25','08:40:00',5.01),('10318','2014-04-25','08:45:00',5.22),('10318','2014-04-25','08:50:00',5.45),('10318','2014-04-25','08:55:00',5.66),('10318','2014-04-25','09:00:00',6.07),('10318','2014-04-25','09:05:00',5.05),('10318','2014-04-25','09:10:00',5.43),('10318','2014-04-25','09:15:00',7.7),('10318','2014-04-25','09:20:00',7.34),('10318','2014-04-25','09:25:00',6.53),('10318','2014-04-25','09:30:00',4.49),('10318','2014-04-25','09:35:00',4.49),('10318','2014-04-25','09:40:00',3.66),('10318','2014-04-25','09:45:00',4.54),('10318','2014-04-25','09:50:00',3.27),('10318','2014-04-25','09:55:00',2.34),('10318','2014-04-25','10:00:00',2.35),('10318','2014-04-25','10:05:00',2.16),('10318','2014-04-25','10:10:00',2.07),('10318','2014-04-25','10:15:00',2.22),('10318','2014-04-25','10:20:00',2.99),('10318','2014-04-25','10:25:00',4.65),('10318','2014-04-25','10:30:00',3.48),('10318','2014-04-25','10:35:00',2.46),('10318','2014-04-25','10:40:00',2.12),('10318','2014-04-25','10:45:00',2.53),('10318','2014-04-25','10:50:00',3.14),('10318','2014-04-25','10:55:00',3.32),('10318','2014-04-25','11:00:00',6.62),('10318','2014-04-25','11:05:00',8.42),('10318','2014-04-25','11:10:00',8.18),('10318','2014-04-25','11:15:00',5.66),('10318','2014-04-25','11:20:00',8.15),('10318','2014-04-25','11:25:00',9.87),('10318','2014-04-25','11:30:00',8.11),('10318','2014-04-25','11:35:00',7.71),('10318','2014-04-25','11:40:00',8.68),('10318','2014-04-25','11:45:00',3.26),('10318','2014-04-25','11:50:00',3.73),('10318','2014-04-25','11:55:00',3.83),('10318','2014-04-25','12:00:00',4.79),('10318','2014-04-25','12:05:00',4.66),('10318','2014-04-25','12:10:00',10.41),('10318','2014-04-25','12:15:00',10.26),('10318','2014-04-25','12:20:00',6.62),('10318','2014-04-25','12:25:00',5.59),('10318','2014-04-25','12:30:00',9.7),('10318','2014-04-25','12:35:00',6.44),('10318','2014-04-25','12:40:00',5.13),('10318','2014-04-25','12:45:00',8.35),('10318','2014-04-25','12:50:00',6.31),('10318','2014-04-25','12:55:00',4.19),('10318','2014-04-25','13:00:00',5.67),('10318','2014-04-25','13:05:00',2.83),('10318','2014-04-25','13:10:00',7.41),('10318','2014-04-25','13:15:00',4.84),('10318','2014-04-25','13:20:00',5.48),('10318','2014-04-25','13:25:00',2.93),('10318','2014-04-25','13:30:00',8.36),('10318','2014-04-25','13:35:00',2.91),('10318','2014-04-25','13:40:00',4.58),('10318','2014-04-25','13:45:00',4.42),('10318','2014-04-25','13:50:00',7.93),('10318','2014-04-25','13:55:00',8.37),('10318','2014-04-25','14:00:00',3.27),('10318','2014-04-25','14:05:00',4.66),('10318','2014-04-25','14:10:00',10.25),('10318','2014-04-25','14:15:00',9.71),('10318','2014-04-25','14:20:00',9.67),('10318','2014-04-25','14:25:00',8.97),('10318','2014-04-25','14:30:00',8.79),('10318','2014-04-25','14:35:00',8.56),('10318','2014-04-25','14:40:00',8.34),('10318','2014-04-25','14:45:00',8.31),('10318','2014-04-25','14:50:00',8.22),('10318','2014-04-25','14:55:00',8.18),('10318','2014-04-25','15:00:00',8.06),('10318','2014-04-25','15:05:00',7.81),('10318','2014-04-25','15:10:00',7.77),('10318','2014-04-25','15:15:00',7.7),('10318','2014-04-25','15:20:00',7.47),('10318','2014-04-25','15:25:00',7.37),('10318','2014-04-25','15:30:00',7.13),('10318','2014-04-25','15:35:00',7.11),('10318','2014-04-25','15:40:00',6.9),('10318','2014-04-25','15:45:00',6.54),('10318','2014-04-25','15:50:00',6.51),('10318','2014-04-25','15:55:00',6.53),('10318','2014-04-25','16:00:00',6.35),('10318','2014-04-25','16:05:00',6.09),('10318','2014-04-25','16:10:00',5.75),('10318','2014-04-25','16:15:00',5.47),('10318','2014-04-25','16:20:00',4.81),('10318','2014-04-25','16:25:00',5.46),('10318','2014-04-25','16:30:00',5.32),('10318','2014-04-25','16:35:00',5.3),('10318','2014-04-25','16:40:00',5.25),('10318','2014-04-25','16:45:00',5),('10318','2014-04-25','16:50:00',4.44),('10318','2014-04-25','16:55:00',3.68),('10318','2014-04-25','17:00:00',3.85),('10318','2014-04-25','17:05:00',3.96),('10318','2014-04-25','17:10:00',3.58),('10318','2014-04-25','17:15:00',3.31),('10318','2014-04-25','17:20:00',2.45),('10318','2014-04-25','17:25:00',2.01),('10318','2014-04-25','17:30:00',2.36),('10318','2014-04-25','17:35:00',2.23),('10318','2014-04-25','17:40:00',2.1),('10318','2014-04-25','17:45:00',1.77),('10318','2014-04-25','17:50:00',1.7),('10318','2014-04-25','17:55:00',1.62),('10318','2014-04-25','18:00:00',1.52),('10318','2014-04-25','18:05:00',1.53),('10318','2014-04-25','18:10:00',1.43),('10318','2014-04-25','18:15:00',1.29),('10318','2014-04-25','18:20:00',1.29),('10318','2014-04-25','18:25:00',1.14),('10318','2014-04-25','18:30:00',1.12),('10318','2014-04-25','18:35:00',1.06),('10318','2014-04-25','18:40:00',1),('10318','2014-04-24','07:25:00',1.16),('10318','2014-04-24','07:30:00',1.83),('10318','2014-04-24','07:35:00',2.24),('10318','2014-04-24','07:40:00',2.53),('10318','2014-04-24','07:45:00',2.83),('10318','2014-04-24','07:50:00',3.1),('10318','2014-04-24','07:55:00',3.31),('10318','2014-04-24','08:00:00',3.51),('10318','2014-04-24','08:05:00',3.74),('10318','2014-04-24','08:10:00',3.91),('10318','2014-04-24','08:15:00',4.2),('10318','2014-04-24','08:20:00',4.41),('10318','2014-04-24','08:25:00',4.6),('10318','2014-04-24','08:30:00',4.77),('10318','2014-04-24','08:35:00',4.99),('10318','2014-04-24','08:40:00',5.18),('10318','2014-04-24','08:45:00',5.35),('10318','2014-04-24','08:50:00',5.54),('10318','2014-04-24','08:55:00',5.73),('10318','2014-04-24','09:00:00',5.88),('10318','2014-04-24','09:05:00',6.05),('10318','2014-04-24','09:10:00',6.21),('10318','2014-04-24','09:15:00',6.36),('10318','2014-04-24','09:20:00',6.54),('10318','2014-04-24','09:25:00',6.69),('10318','2014-04-24','09:30:00',6.85),('10318','2014-04-24','09:35:00',6.92),('10318','2014-04-24','09:40:00',7.12),('10318','2014-04-24','09:45:00',7.25),('10318','2014-04-24','09:50:00',7.39),('10318','2014-04-24','09:55:00',7.5),('10318','2014-04-24','10:00:00',7.52),('10318','2014-04-24','10:05:00',7.72),('10318','2014-04-24','10:10:00',7.81),('10318','2014-04-24','10:15:00',7.95),('10318','2014-04-24','10:20:00',8.07),('10318','2014-04-24','10:25:00',8.15),('10318','2014-04-24','10:30:00',8.19),('10318','2014-04-24','10:35:00',8.28),('10318','2014-04-24','10:40:00',8.34),('10318','2014-04-24','10:45:00',8.43),('10318','2014-04-24','10:50:00',8.54),('10318','2014-04-24','10:55:00',8.6),('10318','2014-04-24','11:00:00',8.62),('10318','2014-04-24','11:05:00',8.67),('10318','2014-04-24','11:10:00',8.78),('10318','2014-04-24','11:15:00',8.85),('10318','2014-04-24','11:20:00',8.87),('10318','2014-04-24','11:25:00',9.03),('10318','2014-04-24','11:30:00',8.96),('10318','2014-04-24','11:35:00',9.01),('10318','2014-04-24','11:40:00',8.42),('10318','2014-04-24','11:45:00',4.6),('10318','2014-04-24','11:50:00',8.92),('10318','2014-04-24','11:55:00',4.5),('10318','2014-04-24','12:00:00',8.39),('10318','2014-04-24','12:05:00',9.48),('10318','2014-04-24','12:10:00',9.71),('10318','2014-04-24','12:15:00',9.61),('10318','2014-04-24','12:20:00',9.36),('10318','2014-04-24','12:25:00',9.42),('10318','2014-04-24','12:30:00',9.53),('10318','2014-04-24','12:35:00',7.71),('10318','2014-04-24','12:40:00',2.99),('10318','2014-04-24','12:45:00',8.87),('10318','2014-04-24','12:50:00',6.28),('10318','2014-04-24','12:55:00',4.27),('10318','2014-04-24','13:00:00',2.22),('10318','2014-04-24','13:05:00',1.92),('10318','2014-04-24','13:10:00',3.03),('10318','2014-04-24','13:15:00',9.57),('10318','2014-04-24','13:20:00',5.46),('10318','2014-04-24','13:25:00',3.09),('10318','2014-04-24','13:30:00',9.08),('10318','2014-04-24','13:35:00',9.58),('10318','2014-04-24','13:40:00',3.92),('10318','2014-04-24','13:45:00',2.57),('10318','2014-04-24','13:50:00',4.64),('10318','2014-04-24','13:55:00',6.78),('10318','2014-04-24','14:00:00',9.14),('10318','2014-04-24','14:05:00',9.66),('10318','2014-04-24','14:10:00',9.71),('10318','2014-04-24','14:15:00',9.43),('10318','2014-04-24','14:20:00',9.07),('10318','2014-04-24','14:25:00',9.51),('10318','2014-04-24','14:30:00',7.19),('10318','2014-04-24','14:35:00',8.8),('10318','2014-04-24','14:40:00',6.47),('10318','2014-04-24','14:45:00',8.67),('10318','2014-04-24','14:50:00',9.76),('10318','2014-04-24','14:55:00',9.09),('10318','2014-04-24','15:00:00',8.82),('10318','2014-04-24','15:05:00',9.05),('10318','2014-04-24','15:10:00',7.19),('10318','2014-04-24','15:15:00',9.57),('10318','2014-04-24','15:20:00',5.38),('10318','2014-04-24','15:25:00',6.54),('10318','2014-04-24','15:30:00',8.82),('10318','2014-04-24','15:35:00',7.5),('10318','2014-04-24','15:40:00',7.53),('10318','2014-04-24','15:45:00',6.53),('10318','2014-04-24','15:50:00',6.11),('10318','2014-04-24','15:55:00',8.18),('10318','2014-04-24','16:00:00',6.95),('10318','2014-04-24','16:05:00',7),('10318','2014-04-24','16:10:00',5.41),('10318','2014-04-24','16:15:00',4.36),('10318','2014-04-24','16:20:00',3.86),('10318','2014-04-24','16:25:00',4.44),('10318','2014-04-24','16:30:00',4.7),('10318','2014-04-24','16:35:00',4),('10318','2014-04-24','16:40:00',6.76),('10318','2014-04-24','16:45:00',4.52),('10318','2014-04-24','16:50:00',2.85),('10318','2014-04-24','16:55:00',2.66),('10318','2014-04-24','17:00:00',2.93),('10318','2014-04-24','17:05:00',2.91),('10318','2014-04-24','17:10:00',2.77),('10318','2014-04-24','17:15:00',2.68),('10318','2014-04-24','17:20:00',2.36),('10318','2014-04-24','17:25:00',2.51),('10318','2014-04-24','17:30:00',2.29),('10318','2014-04-24','17:35:00',1.96),('10318','2014-04-24','17:40:00',1.6),('10318','2014-04-24','17:45:00',1.22),('10318','2014-04-24','17:50:00',1.06),('10318','2014-04-24','18:10:00',1.01),('10318','2014-04-23','10:20:00',1.05),('10318','2014-04-23','10:25:00',1.24),('10318','2014-04-23','10:30:00',1.16),('10318','2014-04-23','10:35:00',1.3),('10318','2014-04-23','10:40:00',1.6),('10318','2014-04-23','10:45:00',1.67),('10318','2014-04-23','10:50:00',1.72),('10318','2014-04-23','10:55:00',1.58),('10318','2014-04-23','11:00:00',1.36),('10318','2014-04-23','11:05:00',1.3),('10318','2014-04-23','11:10:00',1.22),('10318','2014-04-23','11:15:00',1.41),('10318','2014-04-23','11:20:00',1.35),('10318','2014-04-23','11:25:00',1.13),('10318','2014-04-23','11:30:00',1.05),('10318','2014-04-23','11:35:00',1.27),('10318','2014-04-23','11:40:00',1.37),('10318','2014-04-23','11:45:00',1.45),('10318','2014-04-23','11:50:00',1.28),('10318','2014-04-23','11:55:00',1.08),('10318','2014-04-23','12:20:00',1.04),('10318','2014-04-23','12:25:00',1.14),('10318','2014-04-23','12:30:00',1.11),('10318','2014-04-23','12:35:00',1.25),('10318','2014-04-23','12:40:00',1.34),('10318','2014-04-23','12:45:00',1.27),('10318','2014-04-23','12:50:00',1.29),('10318','2014-04-23','12:55:00',1.33),('10318','2014-04-23','13:00:00',1.37),('10318','2014-04-23','13:05:00',1.51),('10318','2014-04-23','13:10:00',1.76),('10318','2014-04-23','13:15:00',2.1),('10318','2014-04-23','13:20:00',2.47),('10318','2014-04-23','13:25:00',2.73),('10318','2014-04-23','13:30:00',3.09),('10318','2014-04-23','13:35:00',3.27),('10318','2014-04-23','13:40:00',3.47),('10318','2014-04-23','13:45:00',3.62),('10318','2014-04-23','13:50:00',3.61),('10318','2014-04-23','13:55:00',3.69),('10318','2014-04-23','14:00:00',3.63),('10318','2014-04-23','14:05:00',3.59),('10318','2014-04-23','14:10:00',3.47),('10318','2014-04-23','14:15:00',3.09),('10318','2014-04-23','14:20:00',2.75),('10318','2014-04-23','14:25:00',2.42),('10318','2014-04-23','14:30:00',2.22),('10318','2014-04-23','14:35:00',2.1),('10318','2014-04-23','14:40:00',2.06),('10318','2014-04-23','14:45:00',2.07),('10318','2014-04-23','14:50:00',2.26),('10318','2014-04-23','14:55:00',2.53),('10318','2014-04-23','15:00:00',2.94),('10318','2014-04-23','15:05:00',3.26),('10318','2014-04-23','15:10:00',3.41),('10318','2014-04-23','15:15:00',3.52),('10318','2014-04-23','15:20:00',3.3),('10318','2014-04-23','15:25:00',3.23),('10318','2014-04-23','15:30:00',2.99),('10318','2014-04-23','15:35:00',2.7),('10318','2014-04-23','15:40:00',2.52),('10318','2014-04-23','15:45:00',2.27),('10318','2014-04-23','15:50:00',2.13),('10318','2014-04-23','15:55:00',2.11),('10318','2014-04-23','16:00:00',1.89),('10318','2014-04-23','16:05:00',1.73),('10318','2014-04-23','16:10:00',1.64),('10318','2014-04-23','16:15:00',1.37),('10318','2014-04-23','16:20:00',1.2),('10318','2014-04-23','16:25:00',1),('10318','2014-04-22','07:20:00',1.04),('10318','2014-04-22','07:25:00',1.27),('10318','2014-04-22','07:30:00',1.6),('10318','2014-04-22','07:35:00',1.94),('10318','2014-04-22','07:40:00',2.19),('10318','2014-04-22','07:45:00',2.49),('10318','2014-04-22','07:50:00',2.77),('10318','2014-04-22','07:55:00',3.02),('10318','2014-04-22','08:00:00',3.24),('10318','2014-04-22','08:05:00',3.44),('10318','2014-04-22','08:10:00',3.7),('10318','2014-04-22','08:15:00',3.92),('10318','2014-04-22','08:20:00',4.1),('10318','2014-04-22','08:25:00',4.31),('10318','2014-04-22','08:30:00',4.51),('10318','2014-04-22','08:35:00',4.62),('10318','2014-04-22','08:40:00',4.92),('10318','2014-04-22','08:45:00',4.98),('10318','2014-04-22','08:50:00',5.08),('10318','2014-04-22','08:55:00',5.46),('10318','2014-04-22','09:00:00',5.54),('10318','2014-04-22','09:05:00',6.01),('10318','2014-04-22','09:10:00',5.39),('10318','2014-04-22','09:15:00',5.4),('10318','2014-04-22','09:20:00',6.34),('10318','2014-04-22','09:25:00',6.53),('10318','2014-04-22','09:30:00',6.4),('10318','2014-04-22','09:35:00',7.01),('10318','2014-04-22','09:40:00',6.58),('10318','2014-04-22','09:45:00',7.4),('10318','2014-04-22','09:50:00',5.26),('10318','2014-04-22','09:55:00',3.33),('10318','2014-04-22','10:00:00',3.29),('10318','2014-04-22','10:05:00',3.5),('10318','2014-04-22','10:10:00',4.66),('10318','2014-04-22','10:15:00',4.54),('10318','2014-04-22','10:20:00',7.86),('10318','2014-04-22','10:25:00',5.17),('10318','2014-04-22','10:30:00',8.49),('10318','2014-04-22','10:35:00',6.85),('10318','2014-04-22','10:40:00',6.7),('10318','2014-04-22','10:45:00',9.05),('10318','2014-04-22','10:50:00',9.32),('10318','2014-04-22','10:55:00',7.36),('10318','2014-04-22','11:00:00',5.38),('10318','2014-04-22','11:05:00',5.82),('10318','2014-04-22','11:10:00',4.02),('10318','2014-04-22','11:15:00',3.28),('10318','2014-04-22','11:20:00',3),('10318','2014-04-22','11:25:00',2.67),('10318','2014-04-22','11:30:00',2.52),('10318','2014-04-22','11:35:00',2.42),('10318','2014-04-22','11:40:00',2.19),('10318','2014-04-22','11:45:00',1.99),('10318','2014-04-22','11:50:00',2.19),('10318','2014-04-22','11:55:00',2.08),('10318','2014-04-22','12:00:00',2.37),('10318','2014-04-22','12:05:00',2.78),('10318','2014-04-22','12:10:00',2.63),('10318','2014-04-22','12:15:00',2.74),('10318','2014-04-22','12:20:00',2.81),('10318','2014-04-22','12:25:00',2.99),('10318','2014-04-22','12:30:00',3.23),('10318','2014-04-22','12:35:00',2.7),('10318','2014-04-22','12:40:00',2.18),('10318','2014-04-22','12:45:00',1.85),('10318','2014-04-22','12:50:00',1.62),('10318','2014-04-22','12:55:00',1.57),('10318','2014-04-22','13:00:00',1.63),('10318','2014-04-22','13:05:00',1.87),('10318','2014-04-22','13:10:00',2.27),('10318','2014-04-22','13:15:00',3.26),('10318','2014-04-22','13:20:00',4.27),('10318','2014-04-22','13:25:00',5.34),('10318','2014-04-22','13:30:00',5.44),('10318','2014-04-22','13:35:00',5.75),('10318','2014-04-22','13:40:00',6.84),('10318','2014-04-22','13:45:00',5.79),('10318','2014-04-22','13:50:00',4.42),('10318','2014-04-22','13:55:00',3.31),('10318','2014-04-22','14:00:00',3.16),('10318','2014-04-22','14:05:00',6.52),('10318','2014-04-22','14:10:00',8.81),('10318','2014-04-22','14:15:00',6.31),('10318','2014-04-22','14:20:00',7.37),('10318','2014-04-22','14:25:00',4.2),('10318','2014-04-22','14:30:00',4.6),('10318','2014-04-22','14:35:00',5.86),('10318','2014-04-22','14:40:00',8.75),('10318','2014-04-22','14:45:00',7.61),('10318','2014-04-22','14:50:00',6.6),('10318','2014-04-22','14:55:00',4.94),('10318','2014-04-22','15:00:00',2.71),('10318','2014-04-22','15:05:00',2.7),('10318','2014-04-22','15:10:00',2.7),('10318','2014-04-22','15:15:00',2.74),('10318','2014-04-22','15:20:00',3),('10318','2014-04-22','15:25:00',3.05),('10318','2014-04-22','15:30:00',4.08),('10318','2014-04-22','15:35:00',4.41),('10318','2014-04-22','15:40:00',4.06),('10318','2014-04-22','15:45:00',4.72),('10318','2014-04-22','15:50:00',4.59),('10318','2014-04-22','15:55:00',4.14),('10318','2014-04-22','16:00:00',4.65),('10318','2014-04-22','16:05:00',3.7),('10318','2014-04-22','16:10:00',3.31),('10318','2014-04-22','16:15:00',3.09),('10318','2014-04-22','16:20:00',3.62),('10318','2014-04-22','16:25:00',2.55),('10318','2014-04-22','16:30:00',3.16),('10318','2014-04-22','16:35:00',3.32),('10318','2014-04-22','16:40:00',3.78),('10318','2014-04-22','16:45:00',3.22),('10318','2014-04-22','16:50:00',2.74),('10318','2014-04-22','16:55:00',2.58),('10318','2014-04-22','17:00:00',3.02),('10318','2014-04-22','17:05:00',3.03),('10318','2014-04-22','17:10:00',2.63),('10318','2014-04-22','17:15:00',2.12),('10318','2014-04-22','17:20:00',1.62),('10318','2014-04-22','17:25:00',1.41),('10318','2014-04-22','17:30:00',1.35),('10318','2014-04-22','17:35:00',1.7),('10318','2014-04-22','17:40:00',1.68),('10318','2014-04-22','17:45:00',1.44),('10318','2014-04-22','17:50:00',1.23),('10318','2014-04-21','08:10:00',1.04),('10318','2014-04-21','08:15:00',1.08),('10318','2014-04-21','08:20:00',1.19),('10318','2014-04-21','08:25:00',1.42),('10318','2014-04-21','08:30:00',1.74),('10318','2014-04-21','08:35:00',1.88),('10318','2014-04-21','08:40:00',2.34),('10318','2014-04-21','08:45:00',2.37),('10318','2014-04-21','08:50:00',2.44),('10318','2014-04-21','08:55:00',2.36),('10318','2014-04-21','09:00:00',2.96),('10318','2014-04-21','09:05:00',2.75),('10318','2014-04-21','09:10:00',2.43),('10318','2014-04-21','09:15:00',3.55),('10318','2014-04-21','09:20:00',3.7),('10318','2014-04-21','09:25:00',3.34),('10318','2014-04-21','09:30:00',1.4),('10318','2014-04-21','09:35:00',1.9),('10318','2014-04-21','09:40:00',2.97),('10318','2014-04-21','09:45:00',2.48),('10318','2014-04-21','09:50:00',2.6),('10318','2014-04-21','09:55:00',2.68),('10318','2014-04-21','10:00:00',2.97),('10318','2014-04-21','10:05:00',3.95),('10318','2014-04-21','10:10:00',4.13),('10318','2014-04-21','10:15:00',7.37),('10318','2014-04-21','10:20:00',8.33),('10318','2014-04-21','10:25:00',8.13),('10318','2014-04-21','10:30:00',8.15),('10318','2014-04-21','10:35:00',8.18),('10318','2014-04-21','10:40:00',8.25),('10318','2014-04-21','10:45:00',8.33),('10318','2014-04-21','10:50:00',8.4),('10318','2014-04-21','10:55:00',8.46),('10318','2014-04-21','11:00:00',8.51),('10318','2014-04-21','11:05:00',8.57),('10318','2014-04-21','11:10:00',8.64),('10318','2014-04-21','11:15:00',8.68),('10318','2014-04-21','11:20:00',8.74),('10318','2014-04-21','11:25:00',8.79),('10318','2014-04-21','11:30:00',8.82),('10318','2014-04-21','11:35:00',8.83),('10318','2014-04-21','11:40:00',8.92),('10318','2014-04-21','11:45:00',8.99),('10318','2014-04-21','11:50:00',8.99),('10318','2014-04-21','11:55:00',9.09),('10318','2014-04-21','12:00:00',9.15),('10318','2014-04-21','12:05:00',9.16),('10318','2014-04-21','12:10:00',9.24),('10318','2014-04-21','12:15:00',9.23),('10318','2014-04-21','12:20:00',9.28),('10318','2014-04-21','12:25:00',9.3),('10318','2014-04-21','12:30:00',9.34),('10318','2014-04-21','12:35:00',9.31),('10318','2014-04-21','12:40:00',9.34),('10318','2014-04-21','12:45:00',9.34),('10318','2014-04-21','12:50:00',9.32),('10318','2014-04-21','12:55:00',9.3),('10318','2014-04-21','13:00:00',9.28),('10318','2014-04-21','13:05:00',9.26),('10318','2014-04-21','13:10:00',9.25),('10318','2014-04-21','13:15:00',9.25),('10318','2014-04-21','13:20:00',9.18),('10318','2014-04-21','13:25:00',9.11),('10318','2014-04-21','13:30:00',9.17),('10318','2014-04-21','13:35:00',9.16),('10318','2014-04-21','13:40:00',9.14),('10318','2014-04-21','13:45:00',9.06),('10318','2014-04-21','13:50:00',9.03),('10318','2014-04-21','13:55:00',8.86),('10318','2014-04-21','14:00:00',8.97),('10318','2014-04-21','14:05:00',8.92),('10318','2014-04-21','14:10:00',8.87),('10318','2014-04-21','14:15:00',8.79),('10318','2014-04-21','14:20:00',8.71),('10318','2014-04-21','14:25:00',8.62),('10318','2014-04-21','14:30:00',8.49),('10318','2014-04-21','14:35:00',8.43),('10318','2014-04-21','14:40:00',8.34),('10318','2014-04-21','14:45:00',8.24),('10318','2014-04-21','14:50:00',8.14),('10318','2014-04-21','14:55:00',8.06),('10318','2014-04-21','15:00:00',7.97),('10318','2014-04-21','15:05:00',7.85),('10318','2014-04-21','15:10:00',7.57),('10318','2014-04-21','15:15:00',7.52),('10318','2014-04-21','15:20:00',7.42),('10318','2014-04-21','15:25:00',7.29),('10318','2014-04-21','15:30:00',7.14),('10318','2014-04-21','15:35:00',7.01),('10318','2014-04-21','15:40:00',6.87),('10318','2014-04-21','15:45:00',6.75),('10318','2014-04-21','15:50:00',6.59),('10318','2014-04-21','15:55:00',6.45),('10318','2014-04-21','16:00:00',6.31),('10318','2014-04-21','16:05:00',6.19),('10318','2014-04-21','16:10:00',6.05),('10318','2014-04-21','16:15:00',6.08),('10318','2014-04-21','16:20:00',5.66),('10318','2014-04-21','16:25:00',5.56),('10318','2014-04-21','16:30:00',5.45),('10318','2014-04-21','16:35:00',5.18),('10318','2014-04-21','16:40:00',4.97),('10318','2014-04-21','16:45:00',4.79),('10318','2014-04-21','16:50:00',4.6),('10318','2014-04-21','16:55:00',4.36),('10318','2014-04-21','17:00:00',4.23),('10318','2014-04-21','17:05:00',4.07),('10318','2014-04-21','17:10:00',3.88),('10318','2014-04-21','17:15:00',3.69),('10318','2014-04-21','17:20:00',3.53),('10318','2014-04-21','17:25:00',3.34),('10318','2014-04-21','17:30:00',3.15),('10318','2014-04-21','17:35:00',2.95),('10318','2014-04-21','17:40:00',2.75),('10318','2014-04-21','17:45:00',2.58),('10318','2014-04-21','17:50:00',2.4),('10318','2014-04-21','17:55:00',2.22),('10318','2014-04-21','18:00:00',2.06),('10318','2014-04-21','18:05:00',1.9),('10318','2014-04-21','18:10:00',1.75),('10318','2014-04-21','18:15:00',1.56),('10318','2014-04-21','18:20:00',1.42),('10318','2014-04-21','18:25:00',1.26),('10318','2014-04-21','18:30:00',1.11),('10318','2014-04-20','07:40:00',2.23),('10318','2014-04-20','07:45:00',2.91),('10318','2014-04-20','07:50:00',2.79),('10318','2014-04-20','07:55:00',2.24),('10318','2014-04-20','08:00:00',3.27),('10318','2014-04-20','08:05:00',3.66),('10318','2014-04-20','08:10:00',4.33),('10318','2014-04-20','08:15:00',4.66),('10318','2014-04-20','08:20:00',3.33),('10318','2014-04-20','08:25:00',1.05),('10318','2014-04-20','08:30:00',1.14),('10318','2014-04-20','08:35:00',3.64),('10318','2014-04-20','08:40:00',1.68),('10318','2014-04-20','08:45:00',1.42),('10318','2014-04-20','08:50:00',2.48),('10318','2014-04-20','08:55:00',5.67),('10318','2014-04-20','09:00:00',5.78),('10318','2014-04-20','09:05:00',5.4),('10318','2014-04-20','09:10:00',6.76),('10318','2014-04-20','09:15:00',5.98),('10318','2014-04-20','09:20:00',6.41),('10318','2014-04-20','09:25:00',5.97),('10318','2014-04-20','09:30:00',3.7),('10318','2014-04-20','09:35:00',8.57),('10318','2014-04-20','09:40:00',6.51),('10318','2014-04-20','09:45:00',4.21),('10318','2014-04-20','09:50:00',4.22),('10318','2014-04-20','09:55:00',4.8),('10318','2014-04-20','10:00:00',5.73),('10318','2014-04-20','10:05:00',7.22),('10318','2014-04-20','10:10:00',6.18),('10318','2014-04-20','10:15:00',7.23),('10318','2014-04-20','10:20:00',8.14),('10318','2014-04-20','10:25:00',6.43),('10318','2014-04-20','10:30:00',5.76),('10318','2014-04-20','10:35:00',6.27),('10318','2014-04-20','10:40:00',6.12),('10318','2014-04-20','10:45:00',6.48),('10318','2014-04-20','10:50:00',7.62),('10318','2014-04-20','10:55:00',7.42),('10318','2014-04-20','11:00:00',8.49),('10318','2014-04-20','11:05:00',8.89),('10318','2014-04-20','11:10:00',8.66),('10318','2014-04-20','11:15:00',8.97),('10318','2014-04-20','11:20:00',9.12),('10318','2014-04-20','11:25:00',9.69),('10318','2014-04-20','11:30:00',9.85),('10318','2014-04-20','11:35:00',9.19),('10318','2014-04-20','11:40:00',9.68),('10318','2014-04-20','11:45:00',9.68),('10318','2014-04-20','11:50:00',9.79),('10318','2014-04-20','11:55:00',9.87),('10318','2014-04-20','12:00:00',9.78),('10318','2014-04-20','12:05:00',9.54),('10318','2014-04-20','12:10:00',9.91),('10318','2014-04-20','12:15:00',8.76),('10318','2014-04-20','12:20:00',10.37),('10318','2014-04-20','12:25:00',8.15),('10318','2014-04-20','12:30:00',5.89),('10318','2014-04-20','12:35:00',8.84),('10318','2014-04-20','12:40:00',8.67),('10318','2014-04-20','12:45:00',10.18),('10318','2014-04-20','12:50:00',10.41),('10318','2014-04-20','12:55:00',10.28),('10318','2014-04-20','13:00:00',9.97),('10318','2014-04-20','13:05:00',9.93),('10318','2014-04-20','13:10:00',9.72),('10318','2014-04-20','13:15:00',9.76),('10318','2014-04-20','13:20:00',9.52),('10318','2014-04-20','13:25:00',9.5),('10318','2014-04-20','13:30:00',9.52),('10318','2014-04-20','13:35:00',9.57),('10318','2014-04-20','13:40:00',9.54),('10318','2014-04-20','13:45:00',9.47),('10318','2014-04-20','13:50:00',9.41),('10318','2014-04-20','13:55:00',9.37),('10318','2014-04-20','14:00:00',9.26),('10318','2014-04-20','14:05:00',9.12),('10318','2014-04-20','14:10:00',9.22),('10318','2014-04-20','14:15:00',8.9),('10318','2014-04-20','14:20:00',6.86),('10318','2014-04-20','14:25:00',6.35),('10318','2014-04-20','14:30:00',6.15),('10318','2014-04-20','14:35:00',5.26),('10318','2014-04-20','14:40:00',5.29),('10318','2014-04-20','14:45:00',5.71),('10318','2014-04-20','14:50:00',5.67),('10318','2014-04-20','14:55:00',6.52),('10318','2014-04-20','15:00:00',8.96),('10318','2014-04-20','15:05:00',8.12),('10318','2014-04-20','15:10:00',8.16),('10318','2014-04-20','15:15:00',7.84),('10318','2014-04-20','15:20:00',7.6),('10318','2014-04-20','15:25:00',7.45),('10318','2014-04-20','15:30:00',7.35),('10318','2014-04-20','15:35:00',7.37),('10318','2014-04-20','15:40:00',7.39),('10318','2014-04-20','15:45:00',5.55),('10318','2014-04-20','15:50:00',6.4),('10318','2014-04-20','15:55:00',6.76),('10318','2014-04-20','16:00:00',6.53),('10318','2014-04-20','16:05:00',6.35),('10318','2014-04-20','16:10:00',6.21),('10318','2014-04-20','16:15:00',6.12),('10318','2014-04-20','16:20:00',6.08),('10318','2014-04-20','16:25:00',5.42),('10318','2014-04-20','16:30:00',5.15),('10318','2014-04-20','16:35:00',5.5),('10318','2014-04-20','16:40:00',4.72),('10318','2014-04-20','16:45:00',3.97),('10318','2014-04-20','16:50:00',4.89),('10318','2014-04-20','16:55:00',4.84),('10318','2014-04-20','17:00:00',4.5),('10318','2014-04-20','17:05:00',4.21),('10318','2014-04-20','17:10:00',3.95),('10318','2014-04-20','17:15:00',3.74),('10318','2014-04-20','17:20:00',3.51),('10318','2014-04-20','17:25:00',3.33),('10318','2014-04-20','17:30:00',3.12),('10318','2014-04-20','17:35:00',2.93),('10318','2014-04-20','17:40:00',2.75),('10318','2014-04-20','17:45:00',2.56),('10318','2014-04-20','17:50:00',2.38),('10318','2014-04-20','17:55:00',2.22),('10318','2014-04-20','18:00:00',2.05),('10318','2014-04-20','18:05:00',1.88),('10318','2014-04-20','18:10:00',1.72),('10318','2014-04-20','18:15:00',1.54),('10318','2014-04-20','18:20:00',1.03),('10318','2014-04-20','18:30:00',1.13),('10318','2014-04-20','18:35:00',1.16),('10318','2013-11-23','08:15:00',1.19),('10318','2013-11-23','08:20:00',1.69),('10318','2013-11-23','08:25:00',1.46),('10318','2013-11-23','08:30:00',1.01),('10318','2013-11-23','08:35:00',1.56),('10318','2013-11-23','08:40:00',1.66),('10318','2013-11-23','08:45:00',1.14),('10318','2013-11-23','09:55:00',1.18),('10318','2013-11-23','10:00:00',1.37),('10318','2013-11-23','10:05:00',1.46),('10318','2013-11-23','10:10:00',1.51),('10318','2013-11-23','10:15:00',2.7),('10318','2013-11-23','10:20:00',3),('10318','2013-11-23','10:25:00',4.73),('10318','2013-11-23','10:30:00',6.25),('10318','2013-11-23','10:35:00',5.16),('10318','2013-11-23','10:40:00',3.57),('10318','2013-11-23','11:15:00',1.03),('10318','2013-11-23','11:25:00',1.43),('10318','2013-11-23','11:30:00',1.06),('10318','2013-11-23','11:40:00',1.49),('10318','2013-11-23','11:45:00',1.43),('10318','2013-11-23','11:50:00',1.28),('10318','2013-11-22','09:20:00',1.09),('10318','2013-11-22','09:25:00',1.13),('10318','2013-11-22','09:30:00',1.26),('10318','2013-11-22','09:35:00',1.17),('10318','2013-11-22','09:40:00',1),('10318','2013-11-22','09:45:00',1.01),('10318','2013-11-22','09:55:00',1.07),('10318','2013-11-22','10:00:00',1.4),('10318','2013-11-22','10:05:00',1.34),('10318','2013-11-22','10:10:00',1.08),('10318','2013-11-22','12:15:00',1.04),('10318','2013-11-22','12:20:00',1.06),('10318','2013-11-21','08:00:00',1.54),('10318','2013-11-21','08:05:00',2.82),('10318','2013-11-21','08:10:00',3.68),('10318','2013-11-21','08:15:00',3.4),('10318','2013-11-21','09:05:00',1.66),('10318','2013-11-21','09:10:00',2.91),('10318','2013-11-21','09:15:00',2.02),('10318','2013-11-21','09:20:00',2.69),('10318','2013-11-21','09:25:00',2.8),('10318','2013-11-21','09:30:00',2.1),('10318','2013-11-21','09:35:00',2.35),('10318','2013-11-21','09:40:00',2.37),('10318','2013-11-21','09:45:00',4.41),('10318','2013-11-21','09:50:00',6.22),('10318','2013-11-21','09:55:00',4.4),('10318','2013-11-21','10:00:00',3.72),('10318','2013-11-21','10:05:00',3.67),('10318','2013-11-21','10:10:00',5.47),('10318','2013-11-21','10:15:00',6.88),('10318','2013-11-21','10:20:00',4.42),('10318','2013-11-21','10:25:00',4.09),('10318','2013-11-21','10:30:00',7.06),('10318','2013-11-21','10:35:00',7.27),('10318','2013-11-21','10:40:00',5.53),('10318','2013-11-21','10:45:00',1.94),('10318','2013-11-21','10:50:00',1.54),('10318','2013-11-21','10:55:00',1.37),('10318','2013-11-21','11:00:00',2.11),('10318','2013-11-21','11:05:00',2.33),('10318','2013-11-21','11:10:00',1.85),('10318','2013-11-21','11:15:00',4.61),('10318','2013-11-21','11:20:00',7.1),('10318','2013-11-21','11:25:00',7.46),('10318','2013-11-21','11:30:00',5.96),('10318','2013-11-21','11:35:00',6.23),('10318','2013-11-21','11:40:00',7.16),('10318','2013-11-21','11:45:00',7.02),('10318','2013-11-21','11:50:00',7.13),('10318','2013-11-21','11:55:00',4.42),('10318','2013-11-21','12:00:00',6.83),('10318','2013-11-21','12:05:00',3.99),('10318','2013-11-21','12:10:00',2.09),('10318','2013-11-21','12:15:00',5.25),('10318','2013-11-21','12:20:00',4.75),('10318','2013-11-21','12:25:00',5.99),('10318','2013-11-21','12:30:00',7.63),('10318','2013-11-21','12:35:00',7.73),('10318','2013-11-21','12:40:00',5.78),('10318','2013-11-21','12:45:00',6.04),('10318','2013-11-21','12:50:00',7.6),('10318','2013-11-21','12:55:00',6.36),('10318','2013-11-21','13:00:00',4.28),('10318','2013-11-21','13:05:00',1.47),('10318','2013-11-21','13:10:00',3.68),('10318','2013-11-21','13:15:00',2.92),('10318','2013-11-21','13:20:00',1.36),('10318','2013-11-21','13:25:00',1.04),('10318','2013-11-21','13:35:00',2.23),('10318','2013-11-21','13:40:00',5.93),('10318','2013-11-21','13:45:00',5.67),('10318','2013-11-21','13:50:00',5.88),('10318','2013-11-21','13:55:00',5.02),('10318','2013-11-21','14:00:00',1.69),('10318','2013-11-21','14:05:00',1.07),('10318','2013-11-21','14:10:00',3.67),('10318','2013-11-21','14:15:00',3.82),('10318','2013-11-21','14:20:00',1.47),('10318','2013-11-21','14:25:00',2.93),('10318','2013-11-21','14:30:00',4.03),('10318','2013-11-21','14:35:00',3.83),('10318','2013-11-21','14:40:00',3.68),('10318','2013-11-21','14:45:00',3.48),('10318','2013-11-21','14:50:00',3.37),('10318','2013-11-21','14:55:00',3.21),('10318','2013-11-21','15:00:00',3.05),('10318','2013-11-21','15:05:00',2.88),('10318','2013-11-21','15:10:00',1.8),('10318','2013-11-21','15:30:00',1.86),('10318','2013-11-21','15:35:00',2.49),('10318','2013-11-21','15:40:00',1.21),('10318','2013-11-20','08:10:00',1.6),('10318','2013-11-20','08:15:00',3.69),('10318','2013-11-20','08:20:00',1.64),('10318','2013-11-20','08:50:00',2.08),('10318','2013-11-20','08:55:00',2.01),('10318','2013-11-20','09:00:00',4.73),('10318','2013-11-20','09:05:00',5.02),('10318','2013-11-20','09:10:00',5.04),('10318','2013-11-20','09:15:00',5.12),('10318','2013-11-20','09:20:00',5.59),('10318','2013-11-20','09:25:00',3.94),('10318','2013-11-20','09:30:00',3.36),('10318','2013-11-20','09:35:00',1.86),('10318','2013-11-20','09:45:00',1.02),('10318','2013-11-20','09:50:00',1.19),('10318','2013-11-20','09:55:00',2),('10318','2013-11-20','10:00:00',1.49),('10318','2013-11-20','10:10:00',1.11),('10318','2013-11-20','10:15:00',1.02),('10318','2013-11-20','10:20:00',1.25),('10318','2013-11-20','10:25:00',1.81),('10318','2013-11-20','10:30:00',2.46),('10318','2013-11-20','10:35:00',1.55),('10318','2013-11-20','10:40:00',1.3),('10318','2013-11-20','10:45:00',1.86),('10318','2013-11-20','10:50:00',1.99),('10318','2013-11-20','10:55:00',1.46),('10318','2013-11-20','11:00:00',1.45),('10318','2013-11-20','11:05:00',1.47),('10318','2013-11-20','11:10:00',1.25),('10318','2013-11-20','11:15:00',1.51),('10318','2013-11-20','11:20:00',2.61),('10318','2013-11-20','11:25:00',3.16),('10318','2013-11-20','11:30:00',3.38),('10318','2013-11-20','11:35:00',3.36),('10318','2013-11-20','11:40:00',5.89),('10318','2013-11-20','11:45:00',3.24),('10318','2013-11-20','11:50:00',3.33),('10318','2013-11-20','11:55:00',1.34),('10318','2013-11-20','12:00:00',1.08),('10318','2013-11-20','12:05:00',1.87),('10318','2013-11-20','12:10:00',1.64),('10318','2013-11-20','12:15:00',3.2),('10318','2013-11-20','12:20:00',6.4),('10318','2013-11-20','12:25:00',3.4),('10318','2013-11-20','12:30:00',1.42),('10318','2013-11-20','12:35:00',1.4),('10318','2013-11-20','12:40:00',2.07),('10318','2013-11-20','12:45:00',3.24),('10318','2013-11-20','12:50:00',4.42),('10318','2013-11-20','12:55:00',3.13),('10318','2013-11-20','13:00:00',2.74),('10318','2013-11-20','13:05:00',3.01),('10318','2013-11-20','13:10:00',2.07),('10318','2013-11-20','13:15:00',2.73),('10318','2013-11-20','13:20:00',2.48),('10318','2013-11-20','13:25:00',2.59),('10318','2013-11-20','13:30:00',2.41),('10318','2013-11-20','13:35:00',4.73),('10318','2013-11-20','13:40:00',2.43),('10318','2013-11-20','13:45:00',2.98),('10318','2013-11-20','13:50:00',3.74),('10318','2013-11-20','13:55:00',1.89),('10318','2013-11-20','14:00:00',1.96),('10318','2013-11-20','14:05:00',1.71),('10318','2013-11-20','14:10:00',1.73),('10318','2013-11-20','14:15:00',1.89),('10318','2013-11-20','14:20:00',2.32),('10318','2013-11-20','14:25:00',1.72),('10318','2013-11-20','14:30:00',2.07),('10318','2013-11-20','14:35:00',1.42),('10318','2013-11-20','14:40:00',2.58),('10318','2013-11-20','14:45:00',1.5),('10318','2013-11-20','14:55:00',1.65),('10318','2013-11-20','15:00:00',3.47),('10318','2013-11-20','15:05:00',2.73),('10318','2013-11-20','15:10:00',1.72),('10318','2013-11-20','15:15:00',1.82),('10318','2013-11-20','15:20:00',1.13),('10318','2013-11-20','15:25:00',1.03),('10318','2013-11-20','15:30:00',1.13),('10318','2013-11-20','15:40:00',1.03),('10318','2013-11-19','08:10:00',1.56),('10318','2013-11-19','08:15:00',1.02),('10318','2013-11-19','08:30:00',1.39),('10318','2013-11-19','08:35:00',1.18),('10318','2013-11-19','09:00:00',1.35),('10318','2013-11-19','09:05:00',1.22),('10318','2013-11-19','09:15:00',1.07),('10318','2013-11-19','09:30:00',1.06),('10318','2013-11-19','09:35:00',5.5),('10318','2013-11-19','09:40:00',5.51),('10318','2013-11-19','09:45:00',5.77),('10318','2013-11-19','09:50:00',4),('10318','2013-11-19','09:55:00',3.08),('10318','2013-11-19','10:00:00',3.15),('10318','2013-11-19','10:05:00',3.9),('10318','2013-11-19','10:10:00',2.79),('10318','2013-11-19','10:15:00',2.06),('10318','2013-11-19','10:20:00',2.1),('10318','2013-11-19','10:25:00',1.16),('10318','2013-11-19','10:50:00',1),('10318','2013-11-19','10:55:00',1.05),('10318','2013-11-19','11:00:00',1.03),('10318','2013-11-19','11:05:00',1.09),('10318','2013-11-19','11:10:00',1.76),('10318','2013-11-19','11:15:00',3.09),('10318','2013-11-19','11:20:00',3.97),('10318','2013-11-19','11:25:00',7.31),('10318','2013-11-19','11:30:00',2.29),('10318','2013-11-19','11:35:00',7.43),('10318','2013-11-19','11:40:00',6.55),('10318','2013-11-19','11:45:00',6.57),('10318','2013-11-19','11:50:00',6.47),('10318','2013-11-19','11:55:00',6.42),('10318','2013-11-19','12:00:00',6.42),('10318','2013-11-19','12:05:00',6.4),('10318','2013-11-19','12:10:00',6.32),('10318','2013-11-19','12:15:00',5.39),('10318','2013-11-19','12:20:00',5.9),('10318','2013-11-19','12:25:00',1.87),('10318','2013-11-19','12:30:00',1.57),('10318','2013-11-19','12:35:00',1.45),('10318','2013-11-19','12:40:00',5.81),('10318','2013-11-19','12:45:00',5.72),('10318','2013-11-19','12:50:00',3.05),('10318','2013-11-19','12:55:00',4.81),('10318','2013-11-19','13:00:00',2.36),('10318','2013-11-19','13:05:00',1.79),('10318','2013-11-19','13:10:00',1.82),('10318','2013-11-19','13:15:00',2.38),('10318','2013-11-19','13:20:00',1.21),('10318','2013-11-19','13:30:00',1.52),('10318','2013-11-19','13:35:00',1.77),('10318','2013-11-19','14:25:00',1.18),('10318','2013-11-19','14:30:00',2.35),('10318','2013-11-19','14:35:00',2.04),('10318','2013-11-19','14:40:00',2.09),('10318','2013-11-19','14:45:00',1.45),('10318','2013-11-19','14:50:00',1.43),('10318','2013-11-19','14:55:00',1.33),('10318','2013-11-19','15:20:00',1.28),('10318','2013-11-19','15:25:00',2.74),('10318','2013-11-19','15:30:00',3.51),('10318','2013-11-19','15:35:00',2.53),('10318','2013-11-19','15:40:00',2.11),('10318','2013-11-19','15:45:00',1.83),('10318','2013-11-19','15:50:00',1.54),('10318','2013-11-19','15:55:00',1.2),('10318','2013-11-18','07:35:00',1.1),('10318','2013-11-18','07:40:00',1.16),('10318','2013-11-18','07:50:00',1.61),('10318','2013-11-18','07:55:00',1.91),('10318','2013-11-18','08:00:00',2.11),('10318','2013-11-18','08:05:00',3.4),('10318','2013-11-18','08:10:00',2.54),('10318','2013-11-18','08:15:00',2.77),('10318','2013-11-18','08:20:00',2.74),('10318','2013-11-18','08:25:00',3.07),('10318','2013-11-18','08:30:00',3.15),('10318','2013-11-18','08:35:00',3.44),('10318','2013-11-18','08:40:00',2.82),('10318','2013-11-18','08:45:00',2.77),('10318','2013-11-18','08:50:00',2.54),('10318','2013-11-18','08:55:00',2.6),('10318','2013-11-18','09:00:00',2.36),('10318','2013-11-18','09:05:00',2.1),('10318','2013-11-18','09:10:00',2.1),('10318','2013-11-18','09:15:00',3.23),('10318','2013-11-18','09:20:00',3.98),('10318','2013-11-18','09:25:00',4.48),('10318','2013-11-18','09:30:00',4.53),('10318','2013-11-18','09:35:00',5.72),('10318','2013-11-18','09:40:00',3.66),('10318','2013-11-18','09:45:00',2.69),('10318','2013-11-18','09:50:00',2.47),('10318','2013-11-18','09:55:00',2.51),('10318','2013-11-18','10:00:00',2.83),('10318','2013-11-18','10:05:00',3.54),('10318','2013-11-18','10:10:00',4.43),('10318','2013-11-18','10:15:00',4.3),('10318','2013-11-18','10:20:00',3.52),('10318','2013-11-18','10:25:00',2.92),('10318','2013-11-18','10:30:00',2.71),('10318','2013-11-18','10:35:00',2.78),('10318','2013-11-18','10:40:00',2.95),('10318','2013-11-18','10:45:00',2.99),('10318','2013-11-18','10:50:00',2.83),('10318','2013-11-18','10:55:00',2.42),('10318','2013-11-18','11:00:00',2.17),('10318','2013-11-18','11:05:00',1.97),('10318','2013-11-18','11:10:00',1.78),('10318','2013-11-18','11:15:00',1.69),('10318','2013-11-18','11:20:00',1.9),('10318','2013-11-18','11:25:00',2.24),('10318','2013-11-18','11:30:00',2.5),('10318','2013-11-18','11:35:00',2.64),('10318','2013-11-18','11:40:00',2.68),('10318','2013-11-18','11:45:00',2.75),('10318','2013-11-18','11:50:00',2.92),('10318','2013-11-18','11:55:00',3.15),('10318','2013-11-18','12:00:00',3.3),('10318','2013-11-18','12:05:00',3.36),('10318','2013-11-18','12:10:00',3.34),('10318','2013-11-18','12:15:00',3.54),('10318','2013-11-18','12:20:00',3.99),('10318','2013-11-18','12:25:00',4.42),('10318','2013-11-18','12:30:00',3.81),('10318','2013-11-18','12:35:00',3.15),('10318','2013-11-18','12:40:00',2.54),('10318','2013-11-18','12:45:00',2.26),('10318','2013-11-18','12:50:00',2.08),('10318','2013-11-18','12:55:00',2.01),('10318','2013-11-18','13:00:00',2),('10318','2013-11-18','13:05:00',2.08),('10318','2013-11-18','13:10:00',2.5),('10318','2013-11-18','13:15:00',2.08),('10318','2013-11-18','13:20:00',1.93),('10318','2013-11-18','13:25:00',1.81),('10318','2013-11-18','13:30:00',2.04),('10318','2013-11-18','13:35:00',2.41),('10318','2013-11-18','13:40:00',2.59),('10318','2013-11-18','13:45:00',2.55),('10318','2013-11-18','13:50:00',2.15),('10318','2013-11-18','13:55:00',2),('10318','2013-11-18','14:00:00',1.7),('10318','2013-11-18','14:05:00',1.44),('10318','2013-11-18','14:10:00',1.29),('10318','2013-11-18','14:15:00',1.06),('10318','2013-11-18','14:25:00',1.1),('10318','2013-11-18','14:30:00',1.08),('10318','2013-11-18','14:35:00',1.01),('10318','2013-11-18','14:40:00',1.01),('10318','2013-11-18','14:45:00',1.02),('10318','2013-11-18','14:50:00',1.02),('10318','2014-04-19','07:25:00',1.33),('10318','2014-04-19','07:30:00',1.71),('10318','2014-04-19','07:35:00',2.36),('10318','2014-04-19','07:40:00',2.29),('10318','2014-04-19','07:45:00',1.81),('10318','2014-04-19','07:50:00',3.71),('10318','2014-04-19','07:55:00',4.91),('10318','2014-04-19','08:00:00',2.54),('10318','2014-04-19','08:05:00',2.79),('10318','2014-04-19','08:10:00',3.73),('10318','2014-04-19','08:15:00',3.1),('10318','2014-04-19','08:20:00',3.43),('10318','2014-04-19','08:25:00',5.12),('10318','2014-04-19','08:30:00',4.38),('10318','2014-04-19','08:35:00',3.62),('10318','2014-04-19','08:40:00',4.92),('10318','2014-04-19','08:45:00',3.64),('10318','2014-04-19','08:50:00',2.74),('10318','2014-04-19','08:55:00',1.7),('10318','2014-04-19','09:00:00',1.25),('10318','2014-04-19','09:05:00',1.21),('10318','2014-04-19','09:10:00',1.55),('10318','2014-04-19','09:15:00',2.14),('10318','2014-04-19','09:20:00',2.84),('10318','2014-04-19','09:25:00',4.19),('10318','2014-04-19','09:30:00',6.25),('10318','2014-04-19','09:35:00',3.27),('10318','2014-04-19','09:40:00',2.16),('10318','2014-04-19','09:45:00',1.74),('10318','2014-04-19','09:50:00',1.59),('10318','2014-04-19','09:55:00',1.53),('10318','2014-04-19','10:00:00',1.43),('10318','2014-04-19','10:05:00',1.1),('10318','2014-04-19','10:10:00',1.21),('10318','2014-04-19','10:15:00',1.55),('10318','2014-04-19','10:20:00',1.67),('10318','2014-04-19','10:25:00',1.86),('10318','2014-04-19','10:30:00',2.03),('10318','2014-04-19','10:35:00',2.56),('10318','2014-04-19','10:40:00',2.91),('10318','2014-04-19','10:45:00',2.87),('10318','2014-04-19','10:50:00',3.41),('10318','2014-04-19','10:55:00',4.09),('10318','2014-04-19','11:00:00',3.22),('10318','2014-04-19','11:05:00',2.81),('10318','2014-04-19','11:10:00',3.42),('10318','2014-04-19','11:15:00',5.15),('10318','2014-04-19','11:20:00',6.53),('10318','2014-04-19','11:25:00',6.61),('10318','2014-04-19','11:30:00',4.92),('10318','2014-04-19','11:35:00',5.44),('10318','2014-04-19','11:40:00',7.34),('10318','2014-04-19','11:45:00',4.47),('10318','2014-04-19','11:50:00',3.01),('10318','2014-04-19','11:55:00',2.13),('10318','2014-04-19','12:00:00',1.83),('10318','2014-04-19','12:05:00',1.32),('10318','2014-04-19','12:10:00',1.02),('10318','2014-04-19','12:15:00',1.02),('10318','2014-04-19','13:15:00',2.05),('10318','2014-04-19','13:20:00',2.72),('10318','2014-04-19','13:25:00',1.49),('10318','2014-04-19','13:30:00',1.57),('10318','2014-04-19','13:35:00',2.3),('10318','2014-04-19','13:40:00',1.9),('10318','2014-04-19','13:45:00',1.34),('10318','2014-04-19','13:50:00',1.72),('10318','2014-04-19','13:55:00',1.88),('10318','2014-04-19','14:00:00',1.4),('10318','2014-04-19','14:10:00',1.38),('10318','2014-04-19','14:15:00',1.49),('10318','2014-04-19','14:20:00',1.11),('10318','2014-04-19','14:25:00',1.86),('10318','2014-04-19','14:30:00',3.61),('10318','2014-04-19','14:35:00',2.69),('10318','2014-04-19','14:40:00',4.04),('10318','2014-04-19','14:45:00',4.26),('10318','2014-04-19','14:50:00',2.83),('10318','2014-04-19','14:55:00',2.35),('10318','2014-04-19','15:00:00',3.6),('10318','2014-04-19','15:05:00',3.02),('10318','2014-04-19','15:10:00',1.17),('10318','2014-04-19','15:20:00',1.53),('10318','2014-04-19','15:25:00',2.76),('10318','2014-04-19','15:30:00',1.91),('10318','2014-04-19','15:35:00',1.22),('10318','2014-04-19','15:40:00',2.59),('10318','2014-04-19','15:45:00',4.14),('10318','2014-04-19','15:50:00',4.33),('10318','2014-04-19','15:55:00',5.35),('10318','2014-04-19','16:00:00',6.18),('10318','2014-04-19','16:05:00',4.46),('10318','2014-04-19','16:10:00',3.61),('10318','2014-04-19','16:15:00',4.47),('10318','2014-04-19','16:20:00',4),('10318','2014-04-19','16:25:00',4.57),('10318','2014-04-19','16:30:00',5.54),('10318','2014-04-19','16:35:00',2.88),('10318','2014-04-19','16:40:00',2.75),('10318','2014-04-19','16:45:00',2.5),('10318','2014-04-19','16:50:00',1.72),('10318','2014-04-19','16:55:00',1.36),('10318','2014-04-19','17:00:00',1.88),('10318','2014-04-19','17:05:00',2.85),('10318','2014-04-19','17:10:00',2.18),('10318','2014-04-19','17:15:00',3.44),('10318','2014-04-19','17:20:00',3.43),('10318','2014-04-19','17:25:00',2.43),('10318','2014-04-19','17:30:00',2.29),('10318','2014-04-19','17:35:00',1.91),('10318','2014-04-19','17:40:00',1.32),('10318','2014-04-19','17:45:00',1.24),('10318','2014-04-19','17:50:00',1.05),('10318','2013-11-17','08:35:00',1.29),('10318','2013-11-17','08:40:00',1.41),('10318','2013-11-17','08:45:00',1.53),('10318','2013-11-17','08:50:00',3.65),('10318','2013-11-17','08:55:00',5.87),('10318','2013-11-17','09:00:00',5.56),('10318','2013-11-17','09:05:00',5.28),('10318','2013-11-17','09:10:00',5.55),('10318','2013-11-17','09:15:00',5.02),('10318','2013-11-17','09:20:00',5.33),('10318','2013-11-17','09:25:00',4.51),('10318','2013-11-17','09:30:00',5.56),('10318','2013-11-17','09:35:00',5.96),('10318','2013-11-17','09:40:00',6.07),('10318','2013-11-17','09:45:00',6.08),('10318','2013-11-17','09:50:00',6.11),('10318','2013-11-17','09:55:00',6.2),('10318','2013-11-17','10:00:00',6.27),('10318','2013-11-17','10:05:00',6.35),('10318','2013-11-17','10:10:00',6.35),('10318','2013-11-17','10:15:00',6.49),('10318','2013-11-17','10:20:00',6.57),('10318','2013-11-17','10:25:00',6.6),('10318','2013-11-17','10:30:00',6.65),('10318','2013-11-17','10:35:00',6.67),('10318','2013-11-17','10:40:00',6.7),('10318','2013-11-17','10:45:00',6.75),('10318','2013-11-17','10:50:00',6.78),('10318','2013-11-17','10:55:00',6.8),('10318','2013-11-17','11:00:00',6.78),('10318','2013-11-17','11:05:00',6.78),('10318','2013-11-17','11:10:00',6.75),('10318','2013-11-17','11:15:00',6.82),('10318','2013-11-17','11:20:00',6.78),('10318','2013-11-17','11:25:00',6.72),('10318','2013-11-17','11:30:00',6.73),('10318','2013-11-17','11:35:00',6.73),('10318','2013-11-17','11:40:00',6.7),('10318','2013-11-17','11:45:00',6.7),('10318','2013-11-17','11:50:00',6.66),('10318','2013-11-17','11:55:00',6.59),('10318','2013-11-17','12:00:00',6.58),('10318','2013-11-17','12:05:00',6.52),('10318','2013-11-17','12:10:00',6.48),('10318','2013-11-17','12:15:00',6.37),('10318','2013-11-17','12:20:00',6.31),('10318','2013-11-17','12:25:00',6.25),('10318','2013-11-17','12:30:00',6.02),('10318','2013-11-17','12:35:00',6.1),('10318','2013-11-17','12:40:00',6.11),('10318','2013-11-17','12:45:00',6.01),('10318','2013-11-17','12:50:00',5.94),('10318','2013-11-17','12:55:00',5.88),('10318','2013-11-17','13:00:00',5.81),('10318','2013-11-17','13:05:00',5.7),('10318','2013-11-17','13:10:00',5.52),('10318','2013-11-17','13:15:00',5.54),('10318','2013-11-17','13:20:00',5.47),('10318','2013-11-17','13:25:00',5.4),('10318','2013-11-17','13:30:00',5.32),('10318','2013-11-17','13:35:00',5.23),('10318','2013-11-17','13:40:00',5.14),('10318','2013-11-17','13:45:00',5.01),('10318','2013-11-17','13:50:00',4.76),('10318','2013-11-17','13:55:00',1.07),('10318','2013-11-17','14:05:00',1.81),('10318','2013-11-17','14:10:00',4.47),('10318','2013-11-17','14:15:00',4.06),('10318','2013-11-17','14:20:00',3.88),('10318','2013-11-17','14:25:00',3.85),('10318','2013-11-17','14:30:00',3.68),('10318','2013-11-17','14:35:00',3.49),('10318','2013-11-17','14:40:00',3.33),('10318','2013-11-17','14:45:00',3.13),('10318','2013-11-17','14:50:00',1.91),('10318','2013-11-17','14:55:00',1.55),('10318','2013-11-17','15:05:00',1.01),('10318','2013-11-17','15:10:00',2.63),('10318','2013-11-17','15:15:00',2.77),('10318','2013-11-17','15:20:00',2.75),('10318','2013-11-17','15:25:00',2.56),('10318','2013-11-17','15:30:00',2.17),('10318','2013-11-17','15:35:00',1.93),('10318','2013-11-17','15:40:00',1.74),('10318','2013-11-17','15:45:00',1.57),('10318','2013-11-17','15:50:00',1.4),('10318','2013-11-17','15:55:00',1.34),('10318','2013-11-17','16:00:00',1.18),('10318','2013-11-17','16:05:00',1.04),('10318','2013-11-16','12:45:00',1.24),('10318','2013-11-16','12:50:00',1.97),('10318','2013-11-16','12:55:00',2.12),('10318','2013-11-16','13:00:00',2.42),('10318','2013-11-16','13:05:00',2.48),('10318','2013-11-16','13:10:00',2.28),('10318','2013-11-16','13:15:00',1.83),('10318','2013-11-16','13:20:00',1.49),('10318','2013-11-16','13:25:00',1.33),('10318','2013-11-16','13:30:00',1.3),('10318','2013-11-16','13:35:00',1.13),('10318','2013-11-16','13:45:00',1.03),('10318','2013-11-16','13:50:00',1.16),('10318','2013-11-16','13:55:00',1.21),('10318','2013-11-16','14:00:00',1.19),('10318','2013-11-16','14:05:00',1.09),('10318','2013-11-15','08:10:00',1.94),('10318','2013-11-15','08:15:00',1.58),('10318','2013-11-15','08:40:00',1.11),('10318','2013-11-15','08:45:00',1.3),('10318','2013-11-15','08:50:00',1.28),('10318','2013-11-15','08:55:00',1.36),('10318','2013-11-15','09:00:00',1.61),('10318','2013-11-15','09:05:00',1.87),('10318','2013-11-15','09:10:00',2.45),('10318','2013-11-15','09:15:00',3.09),('10318','2013-11-15','09:20:00',2.88),('10318','2013-11-15','09:25:00',2.39),('10318','2013-11-15','09:30:00',2.68),('10318','2013-11-15','09:35:00',3.44),('10318','2013-11-15','09:40:00',2.81),('10318','2013-11-15','09:45:00',2.21),('10318','2013-11-15','09:50:00',1.73),('10318','2013-11-15','09:55:00',1.76),('10318','2013-11-15','10:00:00',1.8),('10318','2013-11-15','10:05:00',1.91),('10318','2013-11-15','10:10:00',2.46),('10318','2013-11-15','10:15:00',3.53),('10318','2013-11-15','10:20:00',3.11),('10318','2013-11-15','10:25:00',2.62),('10318','2013-11-15','10:30:00',2.35),('10318','2013-11-15','10:35:00',1.98),('10318','2013-11-15','10:40:00',1.83),('10318','2013-11-15','10:45:00',1.74),('10318','2013-11-15','10:50:00',1.99),('10318','2013-11-15','10:55:00',2.44),('10318','2013-11-15','11:00:00',2.76),('10318','2013-11-15','11:05:00',2.88),('10318','2013-11-15','11:10:00',2.98),('10318','2013-11-15','11:15:00',2.91),('10318','2013-11-15','11:20:00',3.38),('10318','2013-11-15','11:25:00',3.51),('10318','2013-11-15','11:30:00',3.57),('10318','2013-11-15','11:35:00',3.66),('10318','2013-11-15','11:40:00',3.65),('10318','2013-11-15','11:45:00',3.38),('10318','2013-11-15','11:50:00',2.9),('10318','2013-11-15','11:55:00',2.58),('10318','2013-11-15','12:00:00',2.49),('10318','2013-11-15','12:05:00',2.44),('10318','2013-11-15','12:10:00',2.25),('10318','2013-11-15','12:15:00',2.46),('10318','2013-11-15','12:20:00',3.19),('10318','2013-11-15','12:25:00',3.56),('10318','2013-11-15','12:30:00',2.9),('10318','2013-11-15','12:35:00',2.53),('10318','2013-11-15','12:40:00',2.47),('10318','2013-11-15','12:45:00',2.4),('10318','2013-11-15','12:50:00',2.54),('10318','2013-11-15','12:55:00',2.93),('10318','2013-11-15','13:00:00',3.08),('10318','2013-11-15','13:05:00',2.74),('10318','2013-11-15','13:10:00',2.47),('10318','2013-11-15','13:15:00',2.28),('10318','2013-11-15','13:20:00',1.97),('10318','2013-11-15','13:25:00',1.91),('10318','2013-11-15','13:30:00',1.99),('10318','2013-11-15','13:35:00',2.3),('10318','2013-11-15','13:40:00',2.48),('10318','2013-11-15','13:45:00',2.43),('10318','2013-11-15','13:50:00',2.53),('10318','2013-11-15','13:55:00',3.29),('10318','2013-11-15','14:00:00',2.64),('10318','2013-11-15','14:05:00',2.26),('10318','2013-11-15','14:10:00',1.7),('10318','2013-11-15','14:15:00',1.37),('10318','2013-11-15','14:20:00',1.11),('10318','2013-11-14','08:10:00',2.89),('10318','2013-11-14','08:15:00',2.76),('10318','2013-11-14','08:20:00',1.7),('10318','2013-11-14','08:25:00',3.19),('10318','2013-11-14','08:30:00',2.06),('10318','2013-11-14','08:35:00',2.9),('10318','2013-11-14','08:40:00',2.16),('10318','2013-11-14','08:45:00',1.25),('10318','2013-11-14','08:50:00',3.12),('10318','2013-11-14','08:55:00',4.68),('10318','2013-11-14','09:00:00',4.15),('10318','2013-11-14','09:05:00',4.85),('10318','2013-11-14','09:10:00',4.07),('10318','2013-11-14','09:15:00',5.61),('10318','2013-11-14','09:20:00',5.57),('10318','2013-11-14','09:25:00',5.56),('10318','2013-11-14','09:30:00',5.56),('10318','2013-11-14','09:35:00',5.74),('10318','2013-11-14','09:40:00',5.88),('10318','2013-11-14','09:45:00',5.93),('10318','2013-11-14','09:50:00',6.02),('10318','2013-11-14','09:55:00',6.16),('10318','2013-11-14','10:00:00',6.22),('10318','2013-11-14','10:05:00',6.15),('10318','2013-11-14','10:10:00',6.3),('10318','2013-11-14','10:15:00',6.36),('10318','2013-11-14','10:20:00',6.38),('10318','2013-11-14','10:25:00',6.31),('10318','2013-11-14','10:30:00',6.41),('10318','2013-11-14','10:35:00',6.06),('10318','2013-11-14','10:40:00',6.35),('10318','2013-11-14','10:45:00',6.5),('10318','2013-11-14','10:50:00',6.58),('10318','2013-11-14','10:55:00',6.65),('10318','2013-11-14','11:00:00',6.84),('10318','2013-11-14','11:05:00',6.82),('10318','2013-11-14','11:10:00',6.97),('10318','2013-11-14','11:15:00',7.03),('10318','2013-11-14','11:20:00',7.14),('10318','2013-11-14','11:25:00',7.21),('10318','2013-11-14','11:30:00',6.73),('10318','2013-11-14','11:35:00',5.91),('10318','2013-11-14','11:40:00',5.77),('10318','2013-11-14','11:45:00',5.54),('10318','2013-11-14','11:50:00',5.41),('10318','2013-11-14','11:55:00',6.48),('10318','2013-11-14','12:00:00',3.25),('10318','2013-11-14','12:05:00',4.48),('10318','2013-11-14','12:10:00',5.34),('10318','2013-11-14','12:15:00',3.61),('10318','2013-11-14','12:20:00',2.96),('10318','2013-11-14','12:25:00',2.41),('10318','2013-11-14','12:30:00',2.58),('10318','2013-11-14','12:35:00',2.72),('10318','2013-11-14','12:40:00',2.69),('10318','2013-11-14','12:45:00',2.66),('10318','2013-11-14','12:50:00',2.56),('10318','2013-11-14','12:55:00',2.51),('10318','2013-11-14','13:00:00',2.39),('10318','2013-11-14','13:05:00',2.22),('10318','2013-11-14','13:10:00',2.1),('10318','2013-11-14','13:15:00',2.09),('10318','2013-11-14','13:20:00',1.97),('10318','2013-11-14','13:25:00',2.11),('10318','2013-11-14','13:30:00',2.46),('10318','2013-11-14','13:35:00',2.49),('10318','2013-11-14','13:40:00',2.72),('10318','2013-11-14','13:45:00',2.55),('10318','2013-11-14','13:50:00',3.3),('10318','2013-11-14','13:55:00',3.55),('10318','2013-11-14','14:00:00',3.05),('10318','2013-11-14','14:05:00',2.49),('10318','2013-11-14','14:10:00',2.29),('10318','2013-11-14','14:15:00',1.86),('10318','2013-11-14','14:20:00',1.75),('10318','2013-11-14','14:25:00',1.66),('10318','2013-11-14','14:30:00',1.49),('10318','2013-11-14','14:35:00',1.48),('10318','2013-11-14','14:40:00',1.3),('10318','2013-11-14','14:45:00',1.18),('10318','2013-11-14','14:50:00',1.2),('10318','2013-11-14','14:55:00',1.2),('10318','2013-11-14','15:00:00',1.18),('10318','2013-11-14','15:05:00',1.14),('10318','2013-11-14','15:10:00',1.04),('10318','2013-11-13','08:20:00',1.07),('10318','2013-11-13','08:25:00',1.27),('10318','2013-11-13','08:30:00',1.2),('10318','2013-11-13','08:35:00',1),('10318','2013-11-13','09:55:00',1.14),('10318','2013-11-13','10:00:00',1.84),('10318','2013-11-13','10:05:00',4.01),('10318','2013-11-13','10:10:00',2.79),('10318','2013-11-13','10:15:00',2.68),('10318','2013-11-13','10:20:00',5.9),('10318','2013-11-13','10:25:00',4.78),('10318','2013-11-13','10:30:00',6.69),('10318','2013-11-13','10:35:00',7.52),('10318','2013-11-13','10:40:00',4.47),('10318','2013-11-13','10:45:00',3.58),('10318','2013-11-13','10:50:00',2.41),('10318','2013-11-13','10:55:00',1.94),('10318','2013-11-13','11:00:00',1.67),('10318','2013-11-13','11:05:00',1.94),('10318','2013-11-13','11:10:00',2.06),('10318','2013-11-13','11:15:00',2.2),('10318','2013-11-13','11:20:00',2.42),('10318','2013-11-13','11:25:00',2.28),('10318','2013-11-13','11:30:00',2.33),('10318','2013-11-13','11:35:00',2.03),('10318','2013-11-13','11:40:00',1.95),('10318','2013-11-13','11:45:00',2.23),('10318','2013-11-13','11:50:00',2.61),('10318','2013-11-13','11:55:00',2.57),('10318','2013-11-13','12:00:00',2.33),('10318','2013-11-13','12:05:00',2.03),('10318','2013-11-13','12:10:00',2.25),('10318','2013-11-13','12:15:00',2.13),('10318','2013-11-13','12:20:00',2.13),('10318','2013-11-13','12:25:00',1.91),('10318','2013-11-13','12:30:00',1.52),('10318','2013-11-13','12:35:00',1.31),('10318','2013-11-13','12:40:00',1.58),('10318','2013-11-13','12:45:00',1.78),('10318','2013-11-13','12:50:00',1.82),('10318','2013-11-13','12:55:00',2.2),('10318','2013-11-13','13:00:00',2.45),('10318','2013-11-13','13:05:00',2.66),('10318','2013-11-13','13:10:00',2.56),('10318','2013-11-13','13:15:00',2.55),('10318','2013-11-13','13:20:00',2.17),('10318','2013-11-13','13:25:00',1.81),('10318','2013-11-13','13:30:00',1.8),('10318','2013-11-13','13:35:00',1.98),('10318','2013-11-13','13:40:00',2.3),('10318','2013-11-13','13:45:00',2.37),('10318','2013-11-13','13:50:00',2),('10318','2013-11-13','13:55:00',3.1),('10318','2013-11-13','14:00:00',3.76),('10318','2013-11-13','14:05:00',3.83),('10318','2013-11-13','14:10:00',4.02),('10318','2013-11-13','14:15:00',3.57),('10318','2013-11-13','14:20:00',3.46),('10318','2013-11-13','14:25:00',3.44),('10318','2013-11-13','14:30:00',3.69),('10318','2013-11-13','14:35:00',2.86),('10318','2013-11-13','14:40:00',2.23),('10318','2013-11-13','14:45:00',1.81),('10318','2013-11-13','14:50:00',1.59),('10318','2013-11-13','14:55:00',1.06),('10318','2013-11-13','15:00:00',1.26),('10318','2013-11-13','15:05:00',1.18),('10318','2013-11-12','09:15:00',1.18),('10318','2013-11-12','09:20:00',1.02),('10318','2013-11-12','09:30:00',1.13),('10318','2013-11-12','09:35:00',1.23),('10318','2013-11-12','09:40:00',1.18),('10318','2013-11-12','10:00:00',1.52),('10318','2013-11-12','10:05:00',1.54),('10318','2013-11-12','10:45:00',1.15),('10318','2013-11-12','10:50:00',1.32),('10318','2013-11-12','10:55:00',1.51),('10318','2013-11-12','11:00:00',1.71),('10318','2013-11-12','11:05:00',1.55),('10318','2013-11-12','11:10:00',1.8),('10318','2013-11-12','11:15:00',1.81),('10318','2013-11-12','11:20:00',1.81),('10318','2013-11-12','11:25:00',3.28),('10318','2013-11-12','11:30:00',2.02),('10318','2013-11-12','11:35:00',2.31),('10318','2013-11-12','11:40:00',5.33),('10318','2013-11-12','11:45:00',2.59),('10318','2013-11-12','11:50:00',3.54),('10318','2013-11-12','11:55:00',2.29),('10318','2013-11-12','12:00:00',5.59),('10318','2013-11-12','12:05:00',4.11),('10318','2013-11-12','12:10:00',1.79),('10318','2013-11-12','12:15:00',1.78),('10318','2013-11-12','12:20:00',2.13),('10318','2013-11-12','12:25:00',1.88),('10318','2013-11-12','12:30:00',7.76),('10318','2013-11-12','12:35:00',8.57),('10318','2013-11-12','12:40:00',5.04),('10318','2013-11-12','12:45:00',4.54),('10318','2013-11-12','12:50:00',3.88),('10318','2013-11-12','12:55:00',5.58),('10318','2013-11-12','13:00:00',4.63),('10318','2013-11-12','13:05:00',6.55),('10318','2013-11-12','13:10:00',6.15),('10318','2013-11-12','13:15:00',8.55),('10318','2013-11-12','13:20:00',7.81),('10318','2013-11-12','13:25:00',6.04),('10318','2013-11-12','13:30:00',5.4),('10318','2013-11-12','13:35:00',4.96),('10318','2013-11-12','13:40:00',6.5),('10318','2013-11-12','13:45:00',4.05),('10318','2013-11-12','13:50:00',3.3),('10318','2013-11-12','13:55:00',3.99),('10318','2013-11-12','14:00:00',5.16),('10318','2013-11-12','14:05:00',5.75),('10318','2013-11-12','14:10:00',6.61),('10318','2013-11-12','14:15:00',6.11),('10318','2013-11-12','14:20:00',3.8),('10318','2013-11-12','14:25:00',2.36),('10318','2013-11-12','14:30:00',3.43),('10318','2013-11-12','14:35:00',4.64),('10318','2013-11-12','14:40:00',4.1),('10318','2013-11-12','14:45:00',3.9),('10318','2013-11-12','14:50:00',1.57),('10318','2013-11-12','14:55:00',1.38),('10318','2013-11-12','15:00:00',1.77),('10318','2013-11-12','15:05:00',2.49),('10318','2013-11-12','15:10:00',1.9),('10318','2013-11-12','15:15:00',2.14),('10318','2013-11-12','15:20:00',1.45),('10318','2013-11-11','09:30:00',1.21),('10318','2013-11-11','09:45:00',1.01),('10318','2013-11-11','09:50:00',1.91),('10318','2013-11-11','09:55:00',2.26),('10318','2013-11-11','10:00:00',2.18),('10318','2013-11-11','10:05:00',2.15),('10318','2013-11-11','10:10:00',1.87),('10318','2013-11-11','10:15:00',2.5),('10318','2013-11-11','10:20:00',2.38),('10318','2013-11-11','10:25:00',3.86),('10318','2013-11-11','10:30:00',3.16),('10318','2013-11-11','10:35:00',2.63),('10318','2013-11-11','10:40:00',1.99),('10318','2013-11-11','10:45:00',1.43),('10318','2013-11-11','10:50:00',1.51),('10318','2013-11-11','10:55:00',1.86),('10318','2013-11-11','11:00:00',1.56),('10318','2013-11-11','11:05:00',2.95),('10318','2013-11-11','11:10:00',5.94),('10318','2013-11-11','11:15:00',9.87),('10318','2013-11-11','11:20:00',8.31),('10318','2013-11-11','11:25:00',4.71),('10318','2013-11-11','11:30:00',4.04),('10318','2013-11-11','11:35:00',6.57),('10318','2013-11-11','11:40:00',7.37),('10318','2013-11-11','11:45:00',4.96),('10318','2013-11-11','11:50:00',7.92),('10318','2013-11-11','11:55:00',9.32),('10318','2013-11-11','12:00:00',8.36),('10318','2013-11-11','12:05:00',7.92),('10318','2013-11-11','12:10:00',7.27),('10318','2013-11-11','12:15:00',7.41),('10318','2013-11-11','12:20:00',7.4),('10318','2013-11-11','12:25:00',7.77),('10318','2013-11-11','12:30:00',3.83),('10318','2013-11-11','12:35:00',5.38),('10318','2013-11-11','12:40:00',6),('10318','2013-11-11','12:45:00',6.16),('10318','2013-11-11','12:50:00',6.19),('10318','2013-11-11','12:55:00',3.66),('10318','2013-11-11','13:00:00',3.96),('10318','2013-11-11','13:05:00',5.55),('10318','2013-11-11','13:10:00',2.1),('10318','2013-11-11','13:15:00',5.73),('10318','2013-11-11','13:20:00',2.42),('10318','2013-11-11','13:25:00',1.03),('10318','2013-11-11','13:30:00',1.37),('10318','2013-11-11','13:35:00',1.71),('10318','2013-11-11','13:40:00',2.27),('10318','2013-11-11','13:45:00',5.08),('10318','2013-11-11','13:50:00',1.65),('10318','2013-11-11','13:55:00',1.48),('10318','2013-11-11','14:00:00',3.31),('10318','2013-11-11','14:05:00',6.27),('10318','2013-11-11','14:10:00',4.49),('10318','2013-11-11','14:15:00',1.76),('10318','2013-11-11','14:20:00',2.02),('10318','2013-11-11','14:25:00',4.53),('10318','2013-11-11','14:30:00',4.72),('10318','2013-11-11','14:35:00',4.26),('10318','2013-11-11','14:40:00',4.12),('10318','2013-11-11','14:45:00',2.81),('10318','2013-11-11','14:50:00',2.2),('10318','2013-11-11','14:55:00',1.85),('10318','2013-11-11','15:00:00',1.58),('10318','2013-11-11','15:05:00',1.4),('10318','2013-11-10','07:30:00',1.46),('10318','2013-11-10','07:35:00',1.94),('10318','2013-11-10','07:40:00',2.12),('10318','2013-11-10','07:45:00',2.74),('10318','2013-11-10','07:50:00',3.08),('10318','2013-11-10','07:55:00',3.3),('10318','2013-11-10','08:00:00',3.84),('10318','2013-11-10','08:05:00',2.6),('10318','2013-11-10','08:10:00',1.71),('10318','2013-11-10','08:15:00',1.96),('10318','2013-11-10','08:20:00',2.74),('10318','2013-11-10','08:25:00',3.01),('10318','2013-11-10','08:30:00',3.67),('10318','2013-11-10','08:35:00',3.67),('10318','2013-11-10','08:40:00',2.29),('10318','2013-11-10','08:45:00',3.86),('10318','2013-11-10','08:50:00',3.51),('10318','2013-11-10','08:55:00',3.06),('10318','2013-11-10','09:00:00',4.8),('10318','2013-11-10','09:05:00',3),('10318','2013-11-10','09:10:00',3.4),('10318','2013-11-10','09:15:00',4.74),('10318','2013-11-10','09:20:00',5.38),('10318','2013-11-10','09:25:00',5.87),('10318','2013-11-10','09:30:00',5.13),('10318','2013-11-10','09:35:00',5.33),('10318','2013-11-10','09:40:00',5.73),('10318','2013-11-10','09:45:00',4.2),('10318','2013-11-10','09:50:00',6.63),('10318','2013-11-10','09:55:00',6.17),('10318','2013-11-10','10:00:00',5.87),('10318','2013-11-10','10:05:00',7.44),('10318','2013-11-10','10:10:00',7.2),('10318','2013-11-10','10:15:00',6.85),('10318','2013-11-10','10:20:00',5.81),('10318','2013-11-10','10:25:00',4.44),('10318','2013-11-10','10:30:00',7.05),('10318','2013-11-10','10:35:00',7.92),('10318','2013-11-10','10:40:00',7.12),('10318','2013-11-10','10:45:00',4.19),('10318','2013-11-10','10:50:00',2.56),('10318','2013-11-10','10:55:00',5.51),('10318','2013-11-10','11:00:00',4.2),('10318','2013-11-10','11:05:00',3.97),('10318','2013-11-10','11:10:00',1.04),('10318','2013-11-10','11:15:00',1.62),('10318','2013-11-10','11:20:00',3.1),('10318','2013-11-10','11:25:00',2.36),('10318','2013-11-10','11:30:00',2.92),('10318','2013-11-10','11:35:00',2.96),('10318','2013-11-10','11:40:00',3.42),('10318','2013-11-10','11:45:00',3.5),('10318','2013-11-10','11:50:00',2),('10318','2013-11-10','11:55:00',2.99),('10318','2013-11-10','12:00:00',2.46),('10318','2013-11-10','12:05:00',5.9),('10318','2013-11-10','12:10:00',6.92),('10318','2013-11-10','12:15:00',7.13),('10318','2013-11-10','12:20:00',7.55),('10318','2013-11-10','12:25:00',5.83),('10318','2013-11-10','12:30:00',2.42),('10318','2013-11-10','12:35:00',3.61),('10318','2013-11-10','12:40:00',4.6),('10318','2013-11-10','12:45:00',7.09),('10318','2013-11-10','12:50:00',3.58),('10318','2013-11-10','12:55:00',2.52),('10318','2013-11-10','13:00:00',2.71),('10318','2013-11-10','13:05:00',2.3),('10318','2013-11-10','13:10:00',2.06),('10318','2013-11-10','13:15:00',1.32),('10318','2013-11-10','13:20:00',1),('10318','2013-11-10','13:30:00',1.73),('10318','2013-11-10','13:35:00',2.02),('10318','2013-11-10','13:40:00',1.85),('10318','2013-11-10','13:45:00',2.26),('10318','2013-11-10','13:50:00',5.38),('10318','2013-11-10','13:55:00',2.15),('10318','2013-11-10','14:15:00',1.37),('10318','2013-11-10','14:20:00',1.64),('10318','2013-11-10','14:25:00',1.29),('10318','2013-11-10','14:30:00',2.13),('10318','2013-11-10','14:50:00',1.12),('10318','2013-11-10','15:00:00',1.07),('10318','2013-11-10','15:05:00',1.08),('10318','2013-11-09','09:05:00',1.55),('10318','2013-11-09','09:10:00',2.53),('10318','2013-11-09','09:15:00',1.25),('10318','2013-11-09','09:25:00',1.78),('10318','2013-11-09','09:30:00',2.35),('10318','2013-11-09','09:35:00',1.47),('10318','2013-11-09','09:40:00',5.27),('10318','2013-11-09','09:45:00',7.82),('10318','2013-11-09','09:50:00',7.82),('10318','2013-11-09','09:55:00',7.25),('10318','2013-11-09','10:00:00',6.99),('10318','2013-11-09','10:05:00',5.24),('10318','2013-11-09','10:10:00',4.38),('10318','2013-11-09','10:15:00',5.61),('10318','2013-11-09','10:20:00',5.48),('10318','2013-11-09','10:25:00',3.53),('10318','2013-11-09','10:30:00',2.53),('10318','2013-11-09','10:35:00',2.95),('10318','2013-11-09','10:40:00',3.62),('10318','2013-11-09','10:45:00',5.59),('10318','2013-11-09','10:50:00',5.57),('10318','2013-11-09','10:55:00',5.33),('10318','2013-11-09','11:00:00',3.91),('10318','2013-11-09','11:05:00',2.52),('10318','2013-11-09','11:10:00',4.52),('10318','2013-11-09','11:15:00',3.68),('10318','2013-11-09','11:20:00',4.3),('10318','2013-11-09','11:25:00',9.17),('10318','2013-11-09','11:30:00',7.26),('10318','2013-11-09','11:35:00',5.86),('10318','2013-11-09','11:40:00',4.1),('10318','2013-11-09','11:45:00',3.36),('10318','2013-11-09','11:50:00',3.34),('10318','2013-11-09','11:55:00',5.12),('10318','2013-11-09','12:00:00',5.89),('10318','2013-11-09','12:05:00',5.88),('10318','2013-11-09','12:10:00',2.25),('10318','2013-11-09','12:15:00',3.06),('10318','2013-11-09','12:20:00',2.51),('10318','2013-11-09','12:25:00',3.95),('10318','2013-11-09','12:30:00',4.17),('10318','2013-11-09','12:35:00',3.59),('10318','2013-11-09','12:40:00',7),('10318','2013-11-09','12:45:00',5.76),('10318','2013-11-09','12:50:00',7.58),('10318','2013-11-09','12:55:00',5.56),('10318','2013-11-09','13:00:00',5.48),('10318','2013-11-09','13:05:00',3.18),('10318','2013-11-09','13:10:00',6.42),('10318','2013-11-09','13:15:00',7.14),('10318','2013-11-09','13:20:00',3.25),('10318','2013-11-09','13:25:00',4.46),('10318','2013-11-09','13:30:00',5.32),('10318','2013-11-09','13:35:00',6.23),('10318','2013-11-09','13:40:00',5.8),('10318','2013-11-09','13:45:00',5.44),('10318','2013-11-09','13:50:00',5.44),('10318','2013-11-09','13:55:00',5.35),('10318','2013-11-09','14:00:00',4.42),('10318','2013-11-09','14:05:00',2.89),('10318','2013-11-09','14:10:00',2.02),('10318','2013-11-09','14:15:00',3.86),('10318','2013-11-09','14:20:00',4.13),('10318','2013-11-09','14:25:00',3.11),('10318','2013-11-09','14:30:00',1.52),('10318','2013-11-09','14:35:00',3.33),('10318','2013-11-09','14:40:00',3.61),('10318','2013-11-09','14:45:00',2.99),('10318','2013-11-09','14:50:00',2.88),('10318','2013-11-09','15:20:00',2.49),('10318','2013-11-09','15:25:00',2.54),('10318','2013-11-09','15:30:00',2.27),('10318','2013-11-09','15:35:00',2.43),('10318','2013-11-09','15:40:00',1.94),('10318','2013-11-09','15:45:00',1.46),('10318','2013-11-09','15:50:00',1.38),('10318','2013-11-09','15:55:00',1.08),('10318','2013-11-08','08:40:00',1.04),('10318','2013-11-08','08:55:00',1.57),('10318','2013-11-08','09:00:00',2.41),('10318','2013-11-08','09:05:00',2.85),('10318','2013-11-08','09:10:00',4.06),('10318','2013-11-08','09:15:00',6.59),('10318','2013-11-08','09:20:00',3.62),('10318','2013-11-08','09:25:00',5.74),('10318','2013-11-08','09:30:00',2.27),('10318','2013-11-08','09:35:00',1.69),('10318','2013-11-08','09:40:00',4.26),('10318','2013-11-08','09:45:00',4.42),('10318','2013-11-08','09:50:00',5.13),('10318','2013-11-08','09:55:00',4.13),('10318','2013-11-08','10:00:00',1.77),('10318','2013-11-08','10:05:00',1.27),('10318','2013-11-08','10:10:00',1.15),('10318','2013-11-08','10:15:00',1.12),('10318','2013-11-08','10:20:00',4.02),('10318','2013-11-08','10:25:00',7.02),('10318','2013-11-08','10:30:00',6.95),('10318','2013-11-08','10:35:00',7.15),('10318','2013-11-08','10:40:00',4.94),('10318','2013-11-08','10:45:00',4.1),('10318','2013-11-08','10:50:00',7.07),('10318','2013-11-08','10:55:00',7.96),('10318','2013-11-08','11:00:00',7.31),('10318','2013-11-08','11:05:00',6.5),('10318','2013-11-08','11:10:00',2.41),('10318','2013-11-08','11:15:00',5.57),('10318','2013-11-08','11:20:00',8.53),('10318','2013-11-08','11:25:00',8.18),('10318','2013-11-08','11:30:00',8.07),('10318','2013-11-08','11:35:00',6.89),('10318','2013-11-08','11:40:00',2.83),('10318','2013-11-08','11:45:00',2.06),('10318','2013-11-08','11:50:00',6.75),('10318','2013-11-08','11:55:00',7.24),('10318','2013-11-08','12:00:00',7.09),('10318','2013-11-08','12:05:00',6.93),('10318','2013-11-08','12:10:00',6.85),('10318','2013-11-08','12:15:00',6.82),('10318','2013-11-08','12:20:00',6.79),('10318','2013-11-08','12:25:00',6.76),('10318','2013-11-08','12:30:00',6.73),('10318','2013-11-08','12:35:00',1.49),('10318','2013-11-08','12:40:00',1.3),('10318','2013-11-08','12:45:00',4.41),('10318','2013-11-08','12:50:00',3.13),('10318','2013-11-08','12:55:00',1.79),('10318','2013-11-08','13:00:00',4.01),('10318','2013-11-08','13:05:00',7.15),('10318','2013-11-08','13:10:00',6.99),('10318','2013-11-08','13:15:00',6.83),('10318','2013-11-08','13:20:00',6.52),('10318','2013-11-08','13:25:00',6.39),('10318','2013-11-08','13:30:00',4.51),('10318','2013-11-08','13:35:00',5.66),('10318','2013-11-08','13:40:00',3.55),('10318','2013-11-08','13:45:00',1.21),('10318','2013-11-08','13:50:00',1.35),('10318','2013-11-08','13:55:00',5.47),('10318','2013-11-08','14:00:00',5.31),('10318','2013-11-08','14:05:00',5.26),('10318','2013-11-08','14:10:00',5.12),('10318','2013-11-08','14:15:00',4.25),('10318','2013-11-08','14:20:00',3.78),('10318','2013-11-08','14:25:00',3.85),('10318','2013-11-08','14:30:00',4.39),('10318','2013-11-08','14:35:00',3.44),('10318','2013-11-08','14:40:00',3.74),('10318','2013-11-08','14:50:00',2.33),('10318','2013-11-08','14:55:00',2.4),('10318','2013-11-08','15:00:00',3.21),('10318','2013-11-08','15:05:00',2.96),('10318','2013-11-08','15:10:00',2.48),('10318','2013-11-08','15:15:00',2.67),('10318','2013-11-08','15:20:00',2.52),('10318','2013-11-08','15:25:00',2.35),('10318','2013-11-08','15:30:00',2.18),('10318','2013-11-08','15:35:00',2.09),('10318','2013-11-08','15:40:00',1.98),('10318','2013-11-08','15:45:00',1.83),('10318','2013-11-08','15:50:00',1.62),('10318','2013-11-08','15:55:00',1.42),('10318','2013-11-08','16:00:00',1.25),('10318','2013-11-08','16:05:00',1.06),('10318','2014-04-18','07:40:00',1.18),('10318','2014-04-18','07:45:00',1.39),('10318','2014-04-18','07:50:00',1.14),('10318','2014-04-18','07:55:00',1.23),('10318','2014-04-18','08:00:00',1.55),('10318','2014-04-18','08:05:00',3.49),('10318','2014-04-18','08:10:00',4.2),('10318','2014-04-18','08:15:00',2.62),('10318','2014-04-18','08:20:00',2.04),('10318','2014-04-18','08:25:00',1.7),('10318','2014-04-18','08:30:00',1.88),('10318','2014-04-18','08:35:00',2.58),('10318','2014-04-18','08:40:00',4.72),('10318','2014-04-18','08:45:00',3.21),('10318','2014-04-18','08:50:00',3.4),('10318','2014-04-18','08:55:00',2.45),('10318','2014-04-18','09:00:00',2.54),('10318','2014-04-18','09:05:00',5.51),('10318','2014-04-18','09:10:00',8.38),('10318','2014-04-18','09:15:00',7.84),('10318','2014-04-18','09:20:00',7.25),('10318','2014-04-18','09:25:00',2.93),('10318','2014-04-18','09:30:00',7.53),('10318','2014-04-18','09:35:00',3.77),('10318','2014-04-18','09:40:00',2.9),('10318','2014-04-18','09:45:00',7.2),('10318','2014-04-18','09:50:00',7.14),('10318','2014-04-18','09:55:00',7.56),('10318','2014-04-18','10:00:00',5.14),('10318','2014-04-18','10:05:00',3.39),('10318','2014-04-18','10:10:00',3.24),('10318','2014-04-18','10:15:00',3.09),('10318','2014-04-18','10:20:00',3.58),('10318','2014-04-18','10:25:00',3.97),('10318','2014-04-18','10:30:00',2.86),('10318','2014-04-18','10:35:00',2.77),('10318','2014-04-18','10:40:00',3.67),('10318','2014-04-18','10:45:00',6.67),('10318','2014-04-18','10:50:00',8.06),('10318','2014-04-18','10:55:00',8.23),('10318','2014-04-18','11:00:00',4.67),('10318','2014-04-18','11:05:00',4.12),('10318','2014-04-18','11:10:00',3.94),('10318','2014-04-18','11:15:00',5.68),('10318','2014-04-18','11:20:00',4.27),('10318','2014-04-18','11:25:00',3.36),('10318','2014-04-18','11:30:00',3.65),('10318','2014-04-18','11:35:00',3.92),('10318','2014-04-18','11:40:00',4.18),('10318','2014-04-18','11:45:00',4.24),('10318','2014-04-18','11:50:00',5.27),('10318','2014-04-18','11:55:00',4.92),('10318','2014-04-18','12:00:00',5.63),('10318','2014-04-18','12:05:00',7.29),('10318','2014-04-18','12:10:00',5.71),('10318','2014-04-18','12:15:00',8.93),('10318','2014-04-18','12:20:00',9.43),('10318','2014-04-18','12:25:00',7.18),('10318','2014-04-18','12:30:00',10.31),('10318','2014-04-18','12:35:00',10.51),('10318','2014-04-18','12:40:00',10.06),('10318','2014-04-18','12:45:00',8.06),('10318','2014-04-18','12:50:00',8.65),('10318','2014-04-18','12:55:00',8.72),('10318','2014-04-18','13:00:00',9.41),('10318','2014-04-18','13:05:00',8.85),('10318','2014-04-18','13:10:00',10.05),('10318','2014-04-18','13:15:00',9.98),('10318','2014-04-18','13:20:00',7.81),('10318','2014-04-18','13:25:00',3.6),('10318','2014-04-18','13:30:00',2.72),('10318','2014-04-18','13:35:00',3.18),('10318','2014-04-18','13:40:00',3.42),('10318','2014-04-18','13:45:00',3.04),('10318','2014-04-18','13:50:00',3.17),('10318','2014-04-18','13:55:00',4.68),('10318','2014-04-18','14:00:00',4.56),('10318','2014-04-18','14:05:00',4.07),('10318','2014-04-18','14:10:00',3.66),('10318','2014-04-18','14:15:00',3.51),('10318','2014-04-18','14:20:00',3.93),('10318','2014-04-18','14:25:00',4.69),('10318','2014-04-18','14:30:00',5.04),('10318','2014-04-18','14:35:00',5.9),('10318','2014-04-18','14:40:00',5.32),('10318','2014-04-18','14:45:00',6.49),('10318','2014-04-18','14:50:00',8.67),('10318','2014-04-18','14:55:00',8.96),('10318','2014-04-18','15:00:00',9.18),('10318','2014-04-18','15:05:00',8.12),('10318','2014-04-18','15:10:00',3.8),('10318','2014-04-18','15:15:00',4.07),('10318','2014-04-18','15:20:00',4.82),('10318','2014-04-18','15:25:00',8.81),('10318','2014-04-18','15:30:00',4.52),('10318','2014-04-18','15:35:00',6.71),('10318','2014-04-18','15:40:00',8.2),('10318','2014-04-18','15:45:00',6.28),('10318','2014-04-18','15:50:00',5.19),('10318','2014-04-18','15:55:00',5.08),('10318','2014-04-18','16:00:00',7.36),('10318','2014-04-18','16:05:00',5.79),('10318','2014-04-18','16:10:00',5.21),('10318','2014-04-18','16:15:00',3.39),('10318','2014-04-18','16:20:00',3.88),('10318','2014-04-18','16:25:00',5.38),('10318','2014-04-18','16:30:00',4.75),('10318','2014-04-18','16:35:00',6.81),('10318','2014-04-18','16:40:00',5.65),('10318','2014-04-18','16:45:00',5.23),('10318','2014-04-18','16:50:00',5.26),('10318','2014-04-18','16:55:00',6.09),('10318','2014-04-18','17:00:00',4.78),('10318','2014-04-18','17:05:00',4.2),('10318','2014-04-18','17:10:00',3.31),('10318','2014-04-18','17:15:00',1.44),('10318','2014-04-18','17:20:00',3.06),('10318','2014-04-18','17:25:00',3.51),('10318','2014-04-18','17:30:00',3.17),('10318','2014-04-18','17:35:00',2.98),('10318','2014-04-18','17:40:00',2.77),('10318','2014-04-18','17:45:00',2.59),('10318','2014-04-18','17:50:00',2.43),('10318','2014-04-18','17:55:00',2.3),('10318','2014-04-18','18:00:00',2.2),('10318','2014-04-18','18:05:00',1.86),('10318','2014-04-18','18:10:00',1.71),('10318','2014-04-18','18:15:00',1.54),('10318','2014-04-18','18:20:00',1.4),('10318','2014-04-18','18:25:00',1.17),('10318','2013-11-07','07:25:00',1.15),('10318','2013-11-07','07:30:00',1.35),('10318','2013-11-07','07:35:00',1.62),('10318','2013-11-07','07:40:00',2.16),('10318','2013-11-07','07:45:00',2.46),('10318','2013-11-07','07:50:00',2.77),('10318','2013-11-07','07:55:00',3.17),('10318','2013-11-07','08:00:00',3.37),('10318','2013-11-07','08:05:00',3.57),('10318','2013-11-07','08:10:00',3.75),('10318','2013-11-07','08:15:00',3.94),('10318','2013-11-07','08:20:00',4.11),('10318','2013-11-07','08:25:00',4.28),('10318','2013-11-07','08:30:00',4.45),('10318','2013-11-07','08:35:00',4.64),('10318','2013-11-07','08:40:00',4.79),('10318','2013-11-07','08:45:00',4.96),('10318','2013-11-07','08:50:00',5.1),('10318','2013-11-07','08:55:00',5.24),('10318','2013-11-07','09:00:00',5.37),('10318','2013-11-07','09:05:00',5.42),('10318','2013-11-07','09:10:00',5.61),('10318','2013-11-07','09:15:00',5.71),('10318','2013-11-07','09:20:00',5.83),('10318','2013-11-07','09:25:00',5.85),('10318','2013-11-07','09:30:00',5.64),('10318','2013-11-07','09:35:00',5.96),('10318','2013-11-07','09:40:00',6.12),('10318','2013-11-07','09:45:00',6.2),('10318','2013-11-07','09:50:00',6.25),('10318','2013-11-07','09:55:00',6.31),('10318','2013-11-07','10:00:00',6.32),('10318','2013-11-07','10:05:00',6.39),('10318','2013-11-07','10:10:00',6.44),('10318','2013-11-07','10:15:00',6.49),('10318','2013-11-07','10:20:00',6.53),('10318','2013-11-07','10:25:00',6.64),('10318','2013-11-07','10:30:00',6.72),('10318','2013-11-07','10:35:00',6.74),('10318','2013-11-07','10:40:00',6.74),('10318','2013-11-07','10:45:00',6.78),('10318','2013-11-07','10:50:00',6.78),('10318','2013-11-07','10:55:00',6.65),('10318','2013-11-07','11:00:00',6.78),('10318','2013-11-07','11:05:00',6.75),('10318','2013-11-07','11:10:00',6.77),('10318','2013-11-07','11:15:00',6.74),('10318','2013-11-07','11:20:00',6.7),('10318','2013-11-07','11:25:00',6.65),('10318','2013-11-07','11:30:00',6.69),('10318','2013-11-07','11:35:00',6.67),('10318','2013-11-07','11:40:00',6.64),('10318','2013-11-07','11:45:00',6.62),('10318','2013-11-07','11:50:00',6.61),('10318','2013-11-07','11:55:00',6.58),('10318','2013-11-07','12:00:00',6.56),('10318','2013-11-07','12:05:00',6.52),('10318','2013-11-07','12:10:00',6.39),('10318','2013-11-07','12:15:00',6.33),('10318','2013-11-07','12:20:00',6.26),('10318','2013-11-07','12:25:00',6.04),('10318','2013-11-07','12:30:00',6.06),('10318','2013-11-07','12:35:00',5.68),('10318','2013-11-07','12:40:00',6.13),('10318','2013-11-07','12:45:00',6.79),('10318','2013-11-07','12:50:00',4.82),('10318','2013-11-07','12:55:00',3.85),('10318','2013-11-07','13:00:00',2.35),('10318','2013-11-07','13:05:00',3.17),('10318','2013-11-07','13:10:00',3.66),('10318','2013-11-07','13:15:00',5.66),('10318','2013-11-07','13:20:00',7.07),('10318','2013-11-07','13:25:00',6.63),('10318','2013-11-07','13:30:00',6.17),('10318','2013-11-07','13:35:00',4.24),('10318','2013-11-07','13:40:00',5.49),('10318','2013-11-07','13:45:00',5.21),('10318','2013-11-07','13:50:00',5.21),('10318','2013-11-07','13:55:00',3.63),('10318','2013-11-07','14:00:00',4.94),('10318','2013-11-07','14:05:00',5.81),('10318','2013-11-07','14:10:00',5.73),('10318','2013-11-07','14:15:00',5.09),('10318','2013-11-07','14:20:00',4.57),('10318','2013-11-07','14:25:00',4.09),('10318','2013-11-07','14:30:00',4),('10318','2013-11-07','14:35:00',3.9),('10318','2013-11-07','14:40:00',3.71),('10318','2013-11-07','14:45:00',3.55),('10318','2013-11-07','14:50:00',3.39),('10318','2013-11-07','14:55:00',3.26),('10318','2013-11-07','15:00:00',3.1),('10318','2013-11-07','15:05:00',2.94),('10318','2013-11-07','15:10:00',2.82),('10318','2013-11-07','15:15:00',2.62),('10318','2013-11-07','15:20:00',2.56),('10318','2013-11-07','15:25:00',2.41),('10318','2013-11-07','15:30:00',2.26),('10318','2013-11-07','15:35:00',2.09),('10318','2013-11-07','15:40:00',1.92),('10318','2013-11-07','15:45:00',1.77),('10318','2013-11-07','15:50:00',1.6),('10318','2013-11-07','15:55:00',1.43),('10318','2013-11-07','16:00:00',1.27),('10318','2013-11-07','16:05:00',1.09),('10318','2013-11-06','07:55:00',1.48),('10318','2013-11-06','08:00:00',2.97),('10318','2013-11-06','08:05:00',2.69),('10318','2013-11-06','08:10:00',4.11),('10318','2013-11-06','08:15:00',4.52),('10318','2013-11-06','08:20:00',3.33),('10318','2013-11-06','08:25:00',1.71),('10318','2013-11-06','08:30:00',1.94),('10318','2013-11-06','08:35:00',4.89),('10318','2013-11-06','08:40:00',5),('10318','2013-11-06','08:45:00',5.16),('10318','2013-11-06','08:50:00',5.47),('10318','2013-11-06','08:55:00',4.73),('10318','2013-11-06','09:00:00',3.69),('10318','2013-11-06','09:05:00',4.22),('10318','2013-11-06','09:10:00',5.07),('10318','2013-11-06','09:15:00',5.09),('10318','2013-11-06','09:20:00',5.7),('10318','2013-11-06','09:25:00',6.17),('10318','2013-11-06','09:30:00',6.26),('10318','2013-11-06','09:35:00',6.32),('10318','2013-11-06','09:40:00',6.39),('10318','2013-11-06','09:45:00',6.43),('10318','2013-11-06','09:50:00',6.41),('10318','2013-11-06','09:55:00',6.54),('10318','2013-11-06','10:00:00',6.59),('10318','2013-11-06','10:05:00',6.72),('10318','2013-11-06','10:10:00',6.77),('10318','2013-11-06','10:15:00',6.83),('10318','2013-11-06','10:20:00',6.91),('10318','2013-11-06','10:25:00',6.9),('10318','2013-11-06','10:30:00',6.94),('10318','2013-11-06','10:35:00',6.94),('10318','2013-11-06','10:40:00',7.04),('10318','2013-11-06','10:45:00',7.06),('10318','2013-11-06','10:50:00',7.12),('10318','2013-11-06','10:55:00',7.13),('10318','2013-11-06','11:00:00',7.14),('10318','2013-11-06','11:05:00',7.11),('10318','2013-11-06','11:10:00',7.12),('10318','2013-11-06','11:15:00',7.12),('10318','2013-11-06','11:20:00',7.15),('10318','2013-11-06','11:25:00',7.16),('10318','2013-11-06','11:30:00',7.14),('10318','2013-11-06','11:35:00',7.16),('10318','2013-11-06','11:40:00',6.97),('10318','2013-11-06','11:45:00',7.1),('10318','2013-11-06','11:50:00',7.06),('10318','2013-11-06','11:55:00',7.03),('10318','2013-11-06','12:00:00',7),('10318','2013-11-06','12:05:00',6.96),('10318','2013-11-06','12:10:00',6.92),('10318','2013-11-06','12:15:00',6.86),('10318','2013-11-06','12:20:00',6.81),('10318','2013-11-06','12:25:00',6.76),('10318','2013-11-06','12:30:00',6.72),('10318','2013-11-06','12:35:00',6.63),('10318','2013-11-06','12:40:00',6.54),('10318','2013-11-06','12:45:00',6.46),('10318','2013-11-06','12:50:00',6.35),('10318','2013-11-06','12:55:00',6.27),('10318','2013-11-06','13:00:00',6.21),('10318','2013-11-06','13:05:00',6.13),('10318','2013-11-06','13:10:00',6.03),('10318','2013-11-06','13:15:00',5.95),('10318','2013-11-06','13:20:00',5.84),('10318','2013-11-06','13:25:00',5.62),('10318','2013-11-06','13:30:00',5.66),('10318','2013-11-06','13:35:00',5.55),('10318','2013-11-06','13:40:00',5.39),('10318','2013-11-06','13:45:00',5.22),('10318','2013-11-06','13:50:00',5.12),('10318','2013-11-06','13:55:00',5.03),('10318','2013-11-06','14:00:00',4.93),('10318','2013-11-06','14:05:00',4.81),('10318','2013-11-06','14:10:00',4.64),('10318','2013-11-06','14:15:00',4.51),('10318','2013-11-06','14:20:00',4.38),('10318','2013-11-06','14:25:00',4.23),('10318','2013-11-06','14:30:00',4.08),('10318','2013-11-06','14:35:00',3.93),('10318','2013-11-06','14:40:00',3.78),('10318','2013-11-06','14:45:00',3.63),('10318','2013-11-06','14:50:00',3.49),('10318','2013-11-06','14:55:00',3.34),('10318','2013-11-06','15:00:00',3.2),('10318','2013-11-06','15:05:00',3.06),('10318','2013-11-06','15:10:00',2.88),('10318','2013-11-06','15:15:00',2.72),('10318','2013-11-06','15:20:00',2.6),('10318','2013-11-06','15:25:00',2.43),('10318','2013-11-06','15:30:00',2.29),('10318','2013-11-06','15:35:00',2.13),('10318','2013-11-06','15:40:00',1.97),('10318','2013-11-06','15:45:00',1.83),('10318','2013-11-06','15:50:00',1.68),('10318','2013-11-06','15:55:00',1.47),('10318','2013-11-06','16:00:00',1.34),('10318','2013-11-06','16:05:00',1.18),('10318','2013-11-05','08:15:00',1.75),('10318','2013-11-05','08:20:00',2.02),('10318','2013-11-05','08:25:00',1.83),('10318','2013-11-05','08:30:00',3.06),('10318','2013-11-05','08:35:00',4.21),('10318','2013-11-05','08:40:00',2.7),('10318','2013-11-05','08:45:00',2.65),('10318','2013-11-05','08:50:00',1.67),('10318','2013-11-05','08:55:00',1.24),('10318','2013-11-05','09:35:00',1.02),('10318','2013-11-05','09:40:00',1.15),('10318','2013-11-05','09:45:00',1.16),('10318','2013-11-05','09:50:00',1.14),('10318','2013-11-05','09:55:00',1.25),('10318','2013-11-05','10:00:00',1.62),('10318','2013-11-05','10:05:00',1.62),('10318','2013-11-05','10:10:00',1.54),('10318','2013-11-05','10:15:00',2.11),('10318','2013-11-05','10:20:00',2.9),('10318','2013-11-05','10:25:00',3.92),('10318','2013-11-05','10:30:00',3.22),('10318','2013-11-05','10:35:00',3.27),('10318','2013-11-05','10:40:00',3.6),('10318','2013-11-05','10:45:00',3.28),('10318','2013-11-05','10:50:00',2.99),('10318','2013-11-05','10:55:00',2.35),('10318','2013-11-05','11:00:00',1.83),('10318','2013-11-05','11:05:00',1.36),('10318','2013-11-05','11:10:00',1.11),('10318','2013-11-05','11:15:00',1.22),('10318','2013-11-05','11:20:00',1.45),('10318','2013-11-05','11:25:00',1.75),('10318','2013-11-05','11:30:00',2.04),('10318','2013-11-05','11:35:00',2.66),('10318','2013-11-05','11:40:00',3.45),('10318','2013-11-05','11:45:00',3.17),('10318','2013-11-05','11:50:00',2.94),('10318','2013-11-05','11:55:00',2.59),('10318','2013-11-05','12:00:00',2.43),('10318','2013-11-05','12:05:00',3.04),('10318','2013-11-05','12:10:00',3.46),('10318','2013-11-05','12:15:00',3.71),('10318','2013-11-05','12:20:00',4.83),('10318','2013-11-05','12:25:00',4.82),('10318','2013-11-05','12:30:00',4.83),('10318','2013-11-05','12:35:00',2.48),('10318','2013-11-05','12:40:00',2.18),('10318','2013-11-05','12:45:00',2.19),('10318','2013-11-05','12:50:00',1.77),('10318','2013-11-05','12:55:00',1.74),('10318','2013-11-05','13:00:00',1.56),('10318','2013-11-05','13:05:00',1.37),('10318','2013-11-05','13:10:00',1.32),('10318','2013-11-05','13:15:00',1.38),('10318','2013-11-05','13:20:00',2.08),('10318','2013-11-05','13:25:00',2.84),('10318','2013-11-05','13:30:00',3.59),('10318','2013-11-05','13:35:00',5.82),('10318','2013-11-05','13:40:00',5.73),('10318','2013-11-05','13:45:00',4.64),('10318','2013-11-05','13:50:00',5.41),('10318','2013-11-05','13:55:00',4.63),('10318','2013-11-05','14:00:00',6.65),('10318','2013-11-05','14:05:00',4.48),('10318','2013-11-05','14:10:00',5.8),('10318','2013-11-05','14:15:00',5.21),('10318','2013-11-05','14:20:00',5.48),('10318','2013-11-05','14:25:00',3.81),('10318','2013-11-05','14:30:00',5.2),('10318','2013-11-05','14:35:00',3.68),('10318','2013-11-05','14:40:00',4.31),('10318','2013-11-05','14:45:00',3.25),('10318','2013-11-05','14:50:00',3.97),('10318','2013-11-05','14:55:00',2.06),('10318','2013-11-05','15:00:00',1.09),('10318','2013-11-05','15:05:00',1.71),('10318','2013-11-05','15:10:00',1.38),('10318','2013-11-05','15:25:00',1.79),('10318','2013-11-05','15:30:00',1.45),('10318','2013-11-05','15:40:00',1.26),('10318','2013-11-05','15:45:00',2.33),('10318','2013-11-05','15:50:00',2.05),('10318','2013-11-05','16:00:00',1.74),('10318','2013-11-05','16:05:00',1.7),('10318','2013-11-05','16:10:00',1.32),('10318','2013-11-04','07:50:00',2.32),('10318','2013-11-04','07:55:00',3.1),('10318','2013-11-04','08:00:00',3.36),('10318','2013-11-04','08:05:00',3.53),('10318','2013-11-04','08:10:00',3.63),('10318','2013-11-04','08:15:00',3.81),('10318','2013-11-04','08:20:00',3.88),('10318','2013-11-04','08:25:00',4.28),('10318','2013-11-04','08:30:00',4.33),('10318','2013-11-04','08:35:00',4.84),('10318','2013-11-04','08:40:00',5.48),('10318','2013-11-04','08:45:00',3.31),('10318','2013-11-04','08:55:00',1.25),('10318','2013-11-04','09:00:00',2.72),('10318','2013-11-04','09:05:00',5.41),('10318','2013-11-04','09:10:00',5.42),('10318','2013-11-04','09:15:00',2.44),('10318','2013-11-04','09:20:00',1.55),('10318','2013-11-04','09:45:00',3.26),('10318','2013-11-04','09:50:00',6.57),('10318','2013-11-04','09:55:00',6.8),('10318','2013-11-04','10:00:00',7.16),('10318','2013-11-04','10:05:00',7.37),('10318','2013-11-04','10:10:00',7.59),('10318','2013-11-04','10:15:00',7.77),('10318','2013-11-04','10:20:00',7.89),('10318','2013-11-04','10:25:00',8.53),('10318','2013-11-04','10:30:00',6.24),('10318','2013-11-04','10:35:00',3.23),('10318','2013-11-04','10:40:00',2.07),('10318','2013-11-04','10:45:00',2.07),('10318','2013-11-04','10:50:00',1.54),('10318','2013-11-04','10:55:00',1.39),('10318','2013-11-04','11:00:00',1.25),('10318','2013-11-04','11:05:00',1.33),('10318','2013-11-04','11:10:00',1.13),('10318','2013-11-04','11:15:00',1.17),('10318','2013-11-04','11:25:00',1.42),('10318','2013-11-04','11:30:00',4.3),('10318','2013-11-04','11:35:00',2.28),('10318','2013-11-04','11:40:00',1.99),('10318','2013-11-04','11:45:00',3.13),('10318','2013-11-04','11:50:00',6.94),('10318','2013-11-04','11:55:00',7.43),('10318','2013-11-04','12:00:00',7.93),('10318','2013-11-04','12:05:00',6.08),('10318','2013-11-04','12:10:00',6.02),('10318','2013-11-04','12:15:00',7.75),('10318','2013-11-04','12:20:00',7.31),('10318','2013-11-04','12:25:00',7.22),('10318','2013-11-04','12:30:00',7.32),('10318','2013-11-04','12:35:00',7.34),('10318','2013-11-04','12:40:00',6.18),('10318','2013-11-04','12:45:00',7),('10318','2013-11-04','12:50:00',6.71),('10318','2013-11-04','12:55:00',6.72),('10318','2013-11-04','13:00:00',6.63),('10318','2013-11-04','13:05:00',6.43),('10318','2013-11-04','13:10:00',5.77),('10318','2013-11-04','13:15:00',5.57),('10318','2013-11-04','13:20:00',3.8),('10318','2013-11-04','13:25:00',3.84),('10318','2013-11-04','13:30:00',6.09),('10318','2013-11-04','13:35:00',5.69),('10318','2013-11-04','13:40:00',2.13),('10318','2013-11-04','13:45:00',1.78),('10318','2013-11-04','13:50:00',3.03),('10318','2013-11-04','13:55:00',5.84),('10318','2013-11-04','14:00:00',4.67),('10318','2013-11-04','14:05:00',5.11),('10318','2013-11-04','14:10:00',3.6),('10318','2013-11-04','14:15:00',3),('10318','2013-11-04','14:20:00',3.02),('10318','2013-11-04','14:25:00',5.56),('10318','2013-11-04','14:30:00',4.67),('10318','2013-11-04','14:35:00',3.72),('10318','2013-11-04','14:40:00',2.58),('10318','2013-11-04','14:45:00',3.54),('10318','2013-11-04','14:50:00',3.01),('10318','2013-11-04','14:55:00',3.48),('10318','2013-11-04','15:00:00',3.39),('10318','2013-11-04','15:05:00',3.57),('10318','2013-11-04','15:10:00',3.27),('10318','2013-11-04','15:15:00',3.01),('10318','2013-11-04','15:20:00',2.73),('10318','2013-11-04','15:25:00',2.54),('10318','2013-11-04','15:30:00',2.51),('10318','2013-11-04','15:35:00',1.21),('10318','2013-11-04','15:40:00',1.31),('10318','2013-11-04','15:45:00',2.11),('10318','2013-11-04','15:50:00',1.24),('10318','2013-11-03','07:25:00',1.09),('10318','2013-11-03','07:30:00',1.89),('10318','2013-11-03','07:35:00',2.35),('10318','2013-11-03','07:40:00',2.81),('10318','2013-11-03','07:45:00',3.11),('10318','2013-11-03','07:50:00',2.98),('10318','2013-11-03','07:55:00',2.78),('10318','2013-11-03','08:00:00',1.54),('10318','2013-11-03','08:05:00',1.18),('10318','2013-11-03','08:10:00',1.11),('10318','2013-11-03','08:15:00',2.66),('10318','2013-11-03','08:20:00',2.74),('10318','2013-11-03','08:25:00',1.14),('10318','2013-11-03','08:30:00',1.64),('10318','2013-11-03','08:35:00',4.29),('10318','2013-11-03','08:40:00',1.74),('10318','2013-11-03','08:45:00',4.07),('10318','2013-11-03','08:50:00',4.25),('10318','2013-11-03','08:55:00',3.53),('10318','2013-11-03','09:00:00',3.52),('10318','2013-11-03','09:05:00',1.78),('10318','2013-11-03','09:10:00',1.07),('10318','2013-11-03','09:30:00',2.26),('10318','2013-11-03','09:35:00',5.47),('10318','2013-11-03','09:40:00',3.74),('10318','2013-11-03','09:45:00',1.71),('10318','2013-11-03','09:50:00',1.76),('10318','2013-11-03','10:00:00',1.3),('10318','2013-11-03','10:05:00',3.18),('10318','2013-11-03','10:10:00',1.17),('10318','2013-11-03','10:15:00',1.25),('10318','2013-11-03','10:20:00',1.17),('10318','2013-11-03','10:25:00',4.74),('10318','2013-11-03','10:30:00',7.19),('10318','2013-11-03','10:35:00',4.73),('10318','2013-11-03','10:40:00',1.05),('10318','2013-11-03','10:45:00',1.05),('10318','2013-11-03','10:50:00',1.12),('10318','2013-11-03','11:00:00',1.13),('10318','2013-11-03','11:05:00',1.91),('10318','2013-11-03','11:10:00',4.07),('10318','2013-11-03','11:15:00',6.56),('10318','2013-11-03','11:20:00',6.42),('10318','2013-11-03','11:25:00',1.23),('10318','2013-11-03','11:30:00',3.1),('10318','2013-11-03','11:35:00',4.6),('10318','2013-11-03','11:40:00',2.72),('10318','2013-11-03','11:45:00',4.89),('10318','2013-11-03','11:50:00',3.3),('10318','2013-11-03','11:55:00',2.88),('10318','2013-11-03','12:00:00',8.86),('10318','2013-11-03','12:05:00',8.6),('10318','2013-11-03','12:10:00',8.75),('10318','2013-11-03','12:15:00',6.29),('10318','2013-11-03','12:20:00',7.67),('10318','2013-11-03','12:25:00',7.39),('10318','2013-11-03','12:30:00',3.46),('10318','2013-11-03','12:35:00',2.37),('10318','2013-11-03','12:40:00',2.51),('10318','2013-11-03','12:45:00',2.24),('10318','2013-11-03','12:50:00',3.12),('10318','2013-11-03','12:55:00',2.8),('10318','2013-11-03','13:00:00',2.49),('10318','2013-11-03','13:05:00',2.32),('10318','2013-11-03','13:10:00',2.28),('10318','2013-11-03','13:15:00',2.31),('10318','2013-11-03','13:20:00',2.27),('10318','2013-11-03','13:25:00',2.8),('10318','2013-11-03','13:30:00',4.14),('10318','2013-11-03','13:35:00',3.55),('10318','2013-11-03','13:40:00',2.62),('10318','2013-11-03','13:45:00',1.82),('10318','2013-11-03','13:50:00',3.53),('10318','2013-11-03','13:55:00',2.74),('10318','2013-11-03','14:00:00',3.14),('10318','2013-11-03','14:05:00',3.29),('10318','2013-11-03','14:10:00',4.42),('10318','2013-11-03','14:15:00',2.79),('10318','2013-11-03','14:20:00',3.6),('10318','2013-11-03','14:25:00',3.03),('10318','2013-11-03','14:30:00',3.56),('10318','2013-11-03','14:35:00',2.65),('10318','2013-11-03','14:40:00',3.51),('10318','2013-11-03','14:45:00',1.79),('10318','2013-11-03','14:50:00',1.86),('10318','2013-11-03','14:55:00',1.91),('10318','2013-11-03','15:00:00',2.13),('10318','2013-11-03','15:05:00',1.95),('10318','2013-11-03','15:10:00',1.77),('10318','2013-11-03','15:15:00',1.39),('10318','2013-11-03','15:20:00',1.67),('10318','2013-11-03','15:25:00',1.39),('10318','2013-11-03','15:30:00',1.8),('10318','2013-11-03','15:55:00',1.01),('10318','2013-11-03','16:00:00',1.08),('10318','2013-11-02','07:45:00',1.91),('10318','2013-11-02','07:50:00',2.49),('10318','2013-11-02','07:55:00',2.78),('10318','2013-11-02','08:00:00',3.14),('10318','2013-11-02','08:05:00',3.35),('10318','2013-11-02','08:10:00',3.51),('10318','2013-11-02','08:15:00',3.72),('10318','2013-11-02','08:20:00',3.88),('10318','2013-11-02','08:25:00',4.07),('10318','2013-11-02','08:30:00',4.25),('10318','2013-11-02','08:35:00',4.35),('10318','2013-11-02','08:40:00',4.55),('10318','2013-11-02','08:45:00',4.7),('10318','2013-11-02','08:50:00',4.86),('10318','2013-11-02','08:55:00',4.9),('10318','2013-11-02','09:00:00',5.27),('10318','2013-11-02','09:05:00',5.49),('10318','2013-11-02','09:10:00',3.31),('10318','2013-11-02','09:15:00',3.21),('10318','2013-11-02','09:20:00',6.16),('10318','2013-11-02','09:25:00',5.9),('10318','2013-11-02','09:30:00',5.89),('10318','2013-11-02','09:35:00',5.44),('10318','2013-11-02','09:40:00',5.99),('10318','2013-11-02','09:45:00',4.12),('10318','2013-11-02','09:50:00',4.66),('10318','2013-11-02','09:55:00',5.57),('10318','2013-11-02','10:00:00',6.72),('10318','2013-11-02','10:05:00',6.47),('10318','2013-11-02','10:10:00',2.57),('10318','2013-11-02','10:15:00',2.12),('10318','2013-11-02','10:20:00',1.59),('10318','2013-11-02','10:25:00',1.22),('10318','2013-11-02','10:40:00',1.06),('10318','2013-11-02','10:45:00',1.39),('10318','2013-11-02','10:50:00',1.75),('10318','2013-11-02','10:55:00',2.53),('10318','2013-11-02','11:00:00',2.69),('10318','2013-11-02','11:05:00',3.7),('10318','2013-11-02','11:10:00',3.3),('10318','2013-11-02','11:15:00',2.44),('10318','2013-11-02','11:20:00',1.75),('10318','2013-11-02','11:25:00',1.62),('10318','2013-11-02','11:30:00',1.6),('10318','2013-11-02','11:35:00',1.54),('10318','2013-11-02','11:40:00',2.07),('10318','2013-11-02','11:45:00',2.2),('10318','2013-11-02','11:50:00',3.21),('10318','2013-11-02','11:55:00',8.37),('10318','2013-11-02','12:00:00',7.35),('10318','2013-11-02','12:05:00',2.86),('10318','2013-11-02','12:10:00',2.23),('10318','2013-11-02','12:15:00',8.41),('10318','2013-11-02','12:20:00',6.13),('10318','2013-11-02','12:25:00',3.51),('10318','2013-11-02','12:30:00',7.41),('10318','2013-11-02','12:35:00',8.15),('10318','2013-11-02','12:40:00',7.67),('10318','2013-11-02','12:45:00',6.89),('10318','2013-11-02','12:50:00',3.75),('10318','2013-11-02','12:55:00',3.48),('10318','2013-11-02','13:00:00',2.3),('10318','2013-11-02','13:05:00',2.96),('10318','2013-11-02','13:10:00',2.96),('10318','2013-11-02','13:15:00',3.05),('10318','2013-11-02','13:20:00',6.07),('10318','2013-11-02','13:25:00',5.12),('10318','2013-11-02','13:30:00',3.75),('10318','2013-11-02','13:35:00',4.55),('10318','2013-11-02','13:40:00',7.29),('10318','2013-11-02','13:45:00',6.5),('10318','2013-11-02','13:50:00',6.41),('10318','2013-11-02','13:55:00',4.48),('10318','2013-11-02','14:00:00',5.85),('10318','2013-11-02','14:05:00',5.22),('10318','2013-11-02','14:10:00',4.27),('10318','2013-11-02','14:15:00',3.7),('10318','2013-11-02','14:20:00',4.76),('10318','2013-11-02','14:25:00',3.6),('10318','2013-11-02','14:30:00',2.7),('10318','2013-11-02','14:35:00',4.19),('10318','2013-11-02','14:40:00',3.55),('10318','2013-11-02','14:45:00',3.8),('10318','2013-11-02','14:50:00',2.49),('10318','2013-11-02','14:55:00',1.62),('10318','2013-11-02','15:00:00',3.03),('10318','2013-11-02','15:05:00',2.93),('10318','2013-11-02','15:10:00',2.33),('10318','2013-11-02','15:15:00',1.61),('10318','2013-11-02','15:20:00',2.48),('10318','2013-11-02','15:25:00',2.82),('10318','2013-11-02','15:30:00',2.2),('10318','2013-11-02','15:35:00',1.03),('10318','2013-11-02','15:40:00',1.93),('10318','2013-11-02','15:45:00',1.3),('10318','2013-11-02','15:50:00',1.15),('10318','2013-11-02','15:55:00',1.61),('10318','2013-11-02','16:00:00',1.48),('10318','2013-11-02','16:05:00',1.16),('10318','2013-11-02','16:10:00',1.24),('10318','2013-11-02','16:15:00',1.16),('10318','2013-11-01','07:20:00',1.08),('10318','2013-11-01','07:25:00',1.24),('10318','2013-11-01','07:30:00',1.52),('10318','2013-11-01','07:35:00',1.88),('10318','2013-11-01','07:40:00',2.15),('10318','2013-11-01','07:45:00',2.47),('10318','2013-11-01','07:50:00',2.68),('10318','2013-11-01','07:55:00',2.74),('10318','2013-11-01','08:00:00',2.67),('10318','2013-11-01','08:05:00',2.59),('10318','2013-11-01','08:10:00',2.43),('10318','2013-11-01','08:15:00',3.03),('10318','2013-11-01','08:20:00',3.05),('10318','2013-11-01','08:25:00',3.58),('10318','2013-11-01','08:30:00',3.85),('10318','2013-11-01','08:35:00',4.34),('10318','2013-11-01','08:40:00',4.51),('10318','2013-11-01','08:45:00',4.23),('10318','2013-11-01','08:50:00',4.34),('10318','2013-11-01','08:55:00',4.57),('10318','2013-11-01','09:00:00',4.97),('10318','2013-11-01','09:05:00',5.27),('10318','2013-11-01','09:10:00',5.21),('10318','2013-11-01','09:15:00',5.38),('10318','2013-11-01','09:20:00',5.74),('10318','2013-11-01','09:25:00',5.85),('10318','2013-11-01','09:30:00',5.91),('10318','2013-11-01','09:35:00',6.03),('10318','2013-11-01','09:40:00',6.14),('10318','2013-11-01','09:45:00',6.24),('10318','2013-11-01','09:50:00',6.36),('10318','2013-11-01','09:55:00',6.46),('10318','2013-11-01','10:00:00',6.53),('10318','2013-11-01','10:05:00',6.62),('10318','2013-11-01','10:10:00',6.71),('10318','2013-11-01','10:15:00',6.65),('10318','2013-11-01','10:20:00',6.83),('10318','2013-11-01','10:25:00',6.88),('10318','2013-11-01','10:30:00',6.87),('10318','2013-11-01','10:35:00',6.71),('10318','2013-11-01','10:40:00',6.8),('10318','2013-11-01','10:45:00',6.63),('10318','2013-11-01','10:50:00',6.68),('10318','2013-11-01','10:55:00',6.9),('10318','2013-11-01','11:00:00',6.84),('10318','2013-11-01','11:05:00',6.55),('10318','2013-11-01','11:10:00',5.89),('10318','2013-11-01','11:15:00',6.11),('10318','2013-11-01','11:20:00',6.66),('10318','2013-11-01','11:25:00',7.05),('10318','2013-11-01','11:30:00',6.88),('10318','2013-11-01','11:35:00',6.45),('10318','2013-11-01','11:40:00',6.88),('10318','2013-11-01','11:45:00',7.33),('10318','2013-11-01','11:50:00',7.17),('10318','2013-11-01','11:55:00',6.41),('10318','2013-11-01','12:00:00',6.49),('10318','2013-11-01','12:05:00',7.16),('10318','2013-11-01','12:10:00',6.85),('10318','2013-11-01','12:15:00',6.8),('10318','2013-11-01','12:20:00',6.78),('10318','2013-11-01','12:25:00',6.43),('10318','2013-11-01','12:30:00',6.19),('10318','2013-11-01','12:35:00',3.2),('10318','2013-11-01','12:40:00',1.63),('10318','2013-11-01','12:45:00',1.51),('10318','2013-11-01','12:50:00',1.81),('10318','2013-11-01','12:55:00',1.82),('10318','2013-11-01','13:00:00',1.83),('10318','2013-11-01','13:05:00',3.34),('10318','2013-11-01','13:10:00',2.65),('10318','2013-11-01','13:15:00',3.82),('10318','2013-11-01','13:20:00',3.05),('10318','2013-11-01','13:25:00',2.24),('10318','2013-11-01','13:30:00',2),('10318','2013-11-01','13:35:00',2.78),('10318','2013-11-01','13:40:00',2.54),('10318','2013-11-01','13:45:00',1.56),('10318','2013-11-01','13:50:00',1.33),('10318','2013-11-01','13:55:00',1.28),('10318','2013-11-01','14:00:00',1.41),('10318','2013-11-01','14:05:00',1.59),('10318','2013-11-01','14:10:00',1.66),('10318','2013-11-01','14:15:00',1.67),('10318','2013-11-01','14:20:00',1.55),('10318','2013-11-01','14:25:00',1.32),('10318','2013-11-01','14:30:00',1.13),('10318','2013-10-31','08:00:00',1.46),('10318','2013-10-31','08:05:00',1.9),('10318','2013-10-31','08:10:00',2.46),('10318','2013-10-31','08:15:00',3.37),('10318','2013-10-31','08:20:00',3.46),('10318','2013-10-31','08:25:00',3.49),('10318','2013-10-31','08:30:00',3.43),('10318','2013-10-31','08:35:00',4.14),('10318','2013-10-31','08:40:00',4.7),('10318','2013-10-31','08:45:00',4.95),('10318','2013-10-31','08:50:00',5.29),('10318','2013-10-31','08:55:00',4.79),('10318','2013-10-31','09:00:00',3.78),('10318','2013-10-31','09:05:00',4.15),('10318','2013-10-31','09:10:00',3.73),('10318','2013-10-31','09:15:00',3.77),('10318','2013-10-31','09:20:00',2.47),('10318','2013-10-31','09:25:00',2.69),('10318','2013-10-31','09:30:00',2.82),('10318','2013-10-31','09:35:00',4.07),('10318','2013-10-31','09:40:00',4.82),('10318','2013-10-31','09:45:00',4.83),('10318','2013-10-31','09:50:00',5.01),('10318','2013-10-31','09:55:00',5.3),('10318','2013-10-31','10:00:00',5.38),('10318','2013-10-31','10:05:00',5.41),('10318','2013-10-31','10:10:00',5.35),('10318','2013-10-31','10:15:00',5.03),('10318','2013-10-31','10:20:00',5.07),('10318','2013-10-31','10:25:00',5),('10318','2013-10-31','10:30:00',4.81),('10318','2013-10-31','10:35:00',4.74),('10318','2013-10-31','10:40:00',5.38),('10318','2013-10-31','10:45:00',4.99),('10318','2013-10-31','10:50:00',4.64),('10318','2013-10-31','10:55:00',5),('10318','2013-10-31','11:00:00',5.3),('10318','2013-10-31','11:05:00',5.43),('10318','2013-10-31','11:10:00',6.24),('10318','2013-10-31','11:15:00',5.11),('10318','2013-10-31','11:20:00',6.56),('10318','2013-10-31','11:25:00',6.1),('10318','2013-10-31','11:30:00',5.63),('10318','2013-10-31','11:35:00',6.13),('10318','2013-10-31','11:40:00',6.37),('10318','2013-10-31','11:45:00',6.65),('10318','2013-10-31','11:50:00',6.75),('10318','2013-10-31','11:55:00',6.76),('10318','2013-10-31','12:00:00',6.73),('10318','2013-10-31','12:05:00',6.71),('10318','2013-10-31','12:10:00',6.64),('10318','2013-10-31','12:15:00',6.55),('10318','2013-10-31','12:20:00',6.44),('10318','2013-10-31','12:25:00',6.29),('10318','2013-10-31','12:30:00',6.15),('10318','2013-10-31','12:35:00',5.98),('10318','2013-10-31','12:40:00',5.96),('10318','2013-10-31','12:45:00',6.33),('10318','2013-10-31','12:50:00',6.44),('10318','2013-10-31','12:55:00',6.48),('10318','2013-10-31','13:00:00',6.32),('10318','2013-10-31','13:05:00',6.13),('10318','2013-10-31','13:10:00',6),('10318','2013-10-31','13:15:00',5.85),('10318','2013-10-31','13:20:00',5.75),('10318','2013-10-31','13:25:00',5.61),('10318','2013-10-31','13:30:00',5.47),('10318','2013-10-31','13:35:00',5.29),('10318','2013-10-31','13:40:00',5.15),('10318','2013-10-31','13:45:00',5.09),('10318','2013-10-31','13:50:00',4.88),('10318','2013-10-31','13:55:00',4.51),('10318','2013-10-31','14:00:00',4.34),('10318','2013-10-31','14:05:00',4.39),('10318','2013-10-31','14:10:00',4.27),('10318','2013-10-31','14:15:00',4.12),('10318','2013-10-31','14:20:00',3.43),('10318','2013-10-31','14:25:00',1.31),('10318','2013-10-31','14:30:00',1.03),('10318','2013-10-31','14:45:00',1.41),('10318','2013-10-31','14:50:00',2.49),('10318','2013-10-31','14:55:00',2.5),('10318','2013-10-31','15:00:00',2.51),('10318','2013-10-31','15:05:00',2.27),('10318','2013-10-31','15:10:00',2.21),('10318','2013-10-31','15:15:00',2.09),('10318','2013-10-31','15:20:00',2.03),('10318','2013-10-31','15:25:00',2),('10318','2013-10-31','15:30:00',1.88),('10318','2013-10-31','15:35:00',1.85),('10318','2013-10-31','15:40:00',1.71),('10318','2013-10-31','15:45:00',1.57),('10318','2013-10-31','15:50:00',1.49),('10318','2013-10-31','15:55:00',1.36),('10318','2013-10-31','16:00:00',1.13),('10318','2013-10-30','07:25:00',1.05),('10318','2013-10-30','07:30:00',1.2),('10318','2013-10-30','07:35:00',1.33),('10318','2013-10-30','07:40:00',1.52),('10318','2013-10-30','07:45:00',2.01),('10318','2013-10-30','07:50:00',2.24),('10318','2013-10-30','07:55:00',2.45),('10318','2013-10-30','08:00:00',2.65),('10318','2013-10-30','08:05:00',2.86),('10318','2013-10-30','08:10:00',3.02),('10318','2013-10-30','08:15:00',3.12),('10318','2013-10-30','08:20:00',3.3),('10318','2013-10-30','08:25:00',3.47),('10318','2013-10-30','08:30:00',3.52),('10318','2013-10-30','08:35:00',3.84),('10318','2013-10-30','08:40:00',4.16),('10318','2013-10-30','08:45:00',4.45),('10318','2013-10-30','08:50:00',4.52),('10318','2013-10-30','08:55:00',4.4),('10318','2013-10-30','09:00:00',4.65),('10318','2013-10-30','09:05:00',5.04),('10318','2013-10-30','09:10:00',5.16),('10318','2013-10-30','09:15:00',5.25),('10318','2013-10-30','09:20:00',5.53),('10318','2013-10-30','09:25:00',5.61),('10318','2013-10-30','09:30:00',5.76),('10318','2013-10-30','09:35:00',5.78),('10318','2013-10-30','09:40:00',5.84),('10318','2013-10-30','09:45:00',5.63),('10318','2013-10-30','09:50:00',5.63),('10318','2013-10-30','09:55:00',5.68),('10318','2013-10-30','10:00:00',5.11),('10318','2013-10-30','10:05:00',3.77),('10318','2013-10-30','10:10:00',4.32),('10318','2013-10-30','10:15:00',2.79),('10318','2013-10-30','10:20:00',3.86),('10318','2013-10-30','10:25:00',6.19),('10318','2013-10-30','10:30:00',7.06),('10318','2013-10-30','10:35:00',5.68),('10318','2013-10-30','10:40:00',4.64),('10318','2013-10-30','10:45:00',4.3),('10318','2013-10-30','10:50:00',4.83),('10318','2013-10-30','10:55:00',7.05),('10318','2013-10-30','11:00:00',6.65),('10318','2013-10-30','11:05:00',6.9),('10318','2013-10-30','11:10:00',6.94),('10318','2013-10-30','11:15:00',6.39),('10318','2013-10-30','11:20:00',5.67),('10318','2013-10-30','11:25:00',3.74),('10318','2013-10-30','11:30:00',2.2),('10318','2013-10-30','11:35:00',3.38),('10318','2013-10-30','11:40:00',4.07),('10318','2013-10-30','11:45:00',4.87),('10318','2013-10-30','11:50:00',4.9),('10318','2013-10-30','11:55:00',5.16),('10318','2013-10-30','12:00:00',6.01),('10318','2013-10-30','12:05:00',3.73),('10318','2013-10-30','12:10:00',3.7),('10318','2013-10-30','12:15:00',3.9),('10318','2013-10-30','12:20:00',6.34),('10318','2013-10-30','12:25:00',6),('10318','2013-10-30','12:30:00',3.67),('10318','2013-10-30','12:35:00',5.28),('10318','2013-10-30','12:40:00',6.65),('10318','2013-10-30','12:45:00',4.7),('10318','2013-10-30','12:50:00',2.65),('10318','2013-10-30','12:55:00',4.21),('10318','2013-10-30','13:00:00',3.63),('10318','2013-10-30','13:05:00',3.83),('10318','2013-10-30','13:10:00',3.15),('10318','2013-10-30','13:15:00',2.46),('10318','2013-10-30','13:20:00',2.33),('10318','2013-10-30','13:25:00',2.58),('10318','2013-10-30','13:30:00',4.19),('10318','2013-10-30','13:35:00',3.67),('10318','2013-10-30','13:40:00',3.27),('10318','2013-10-30','13:45:00',2.27),('10318','2013-10-30','13:50:00',4.76),('10318','2013-10-30','13:55:00',4.67),('10318','2013-10-30','14:00:00',2.08),('10318','2013-10-30','14:05:00',1.42),('10318','2013-10-30','14:10:00',1.41),('10318','2013-10-30','14:15:00',1.74),('10318','2013-10-30','14:20:00',1.91),('10318','2013-10-30','14:25:00',1.95),('10318','2013-10-30','14:30:00',1.24),('10318','2013-10-30','14:40:00',1.12),('10318','2013-10-30','14:45:00',1.11),('10318','2013-10-30','14:50:00',1.93),('10318','2013-10-30','14:55:00',3.18),('10318','2013-10-30','15:00:00',2.91),('10318','2013-10-30','15:05:00',2.3),('10318','2013-10-30','15:10:00',1.81),('10318','2013-10-30','15:15:00',1.52),('10318','2013-10-30','15:20:00',1.3),('10318','2013-10-30','15:25:00',2.06),('10318','2013-10-30','15:30:00',1.77),('10318','2013-10-30','15:35:00',1.52),('10318','2013-10-30','15:40:00',1.04),('10318','2013-10-30','15:50:00',1.24),('10318','2013-10-30','15:55:00',1.44),('10318','2013-10-30','16:00:00',1.33),('10318','2013-10-30','16:05:00',1.12),('10318','2013-10-29','07:50:00',1.13),('10318','2013-10-29','07:55:00',1.38),('10318','2013-10-29','08:00:00',1.58),('10318','2013-10-29','08:05:00',2.93),('10318','2013-10-29','08:10:00',2.38),('10318','2013-10-29','08:15:00',2.66),('10318','2013-10-29','08:20:00',2.33),('10318','2013-10-29','08:25:00',1.94),('10318','2013-10-29','08:30:00',2.24),('10318','2013-10-29','08:35:00',4.21),('10318','2013-10-29','08:40:00',4.48),('10318','2013-10-29','08:45:00',4.32),('10318','2013-10-29','08:50:00',4.79),('10318','2013-10-29','08:55:00',5),('10318','2013-10-29','09:00:00',5.2),('10318','2013-10-29','09:05:00',5.29),('10318','2013-10-29','09:10:00',5.37),('10318','2013-10-29','09:15:00',5.53),('10318','2013-10-29','09:20:00',5.64),('10318','2013-10-29','09:25:00',5.64),('10318','2013-10-29','09:30:00',5.85),('10318','2013-10-29','09:35:00',5.94),('10318','2013-10-29','09:40:00',6.17),('10318','2013-10-29','09:45:00',6.34),('10318','2013-10-29','09:50:00',5.28),('10318','2013-10-29','09:55:00',5.43),('10318','2013-10-29','10:00:00',5.77),('10318','2013-10-29','10:05:00',6.51),('10318','2013-10-29','10:10:00',6.78),('10318','2013-10-29','10:15:00',6.04),('10318','2013-10-29','10:20:00',5.09),('10318','2013-10-29','10:25:00',5.52),('10318','2013-10-29','10:30:00',7.29),('10318','2013-10-29','10:35:00',7.2),('10318','2013-10-29','10:40:00',7.06),('10318','2013-10-29','10:45:00',6.29),('10318','2013-10-29','10:50:00',6.97),('10318','2013-10-29','10:55:00',6.95),('10318','2013-10-29','11:00:00',7.13),('10318','2013-10-29','11:05:00',7.2),('10318','2013-10-29','11:10:00',7.44),('10318','2013-10-29','11:15:00',7.47),('10318','2013-10-29','11:20:00',7.24),('10318','2013-10-29','11:25:00',7.43),('10318','2013-10-29','11:30:00',7.43),('10318','2013-10-29','11:35:00',7.23),('10318','2013-10-29','11:40:00',7.25),('10318','2013-10-29','11:45:00',7.25),('10318','2013-10-29','11:50:00',7.06),('10318','2013-10-29','11:55:00',6.74),('10318','2013-10-29','12:00:00',6.42),('10318','2013-10-29','12:05:00',6.33),('10318','2013-10-29','12:10:00',6.5),('10318','2013-10-29','12:15:00',6.61),('10318','2013-10-29','12:20:00',6.6),('10318','2013-10-29','12:25:00',6.46),('10318','2013-10-29','12:30:00',6.37),('10318','2013-10-29','12:35:00',6.21),('10318','2013-10-29','12:40:00',6.04),('10318','2013-10-29','12:45:00',6.19),('10318','2013-10-29','12:50:00',6.18),('10318','2013-10-29','12:55:00',6.09),('10318','2013-10-29','13:00:00',5.81),('10318','2013-10-29','13:05:00',5.87),('10318','2013-10-29','13:10:00',5.87),('10318','2013-10-29','13:15:00',5.81),('10318','2013-10-29','13:20:00',5.69),('10318','2013-10-29','13:25:00',5.44),('10318','2013-10-29','13:30:00',5.37),('10318','2013-10-29','13:35:00',4.99),('10318','2013-10-29','13:40:00',5.17),('10318','2013-10-29','13:45:00',4.76),('10318','2013-10-29','13:50:00',4.98),('10318','2013-10-29','13:55:00',5.22),('10318','2013-10-29','14:00:00',4.91),('10318','2013-10-29','14:05:00',4.59),('10318','2013-10-29','14:10:00',4.42),('10318','2013-10-29','14:15:00',3.98),('10318','2013-10-29','14:20:00',4.17),('10318','2013-10-29','14:25:00',4.09),('10318','2013-10-29','14:30:00',3.95),('10318','2013-10-29','14:35:00',3.76),('10318','2013-10-29','14:40:00',3.62),('10318','2013-10-29','14:45:00',3.47),('10318','2013-10-29','14:50:00',3.24),('10318','2013-10-29','14:55:00',3.15),('10318','2013-10-29','15:00:00',2.98),('10318','2013-10-29','15:05:00',2.88),('10318','2013-10-29','15:10:00',2.75),('10318','2013-10-29','15:15:00',2.59),('10318','2013-10-29','15:20:00',2.37),('10318','2013-10-29','15:25:00',2.26),('10318','2013-10-29','15:30:00',2.12),('10318','2013-10-29','15:35:00',1.98),('10318','2013-10-29','15:40:00',1.82),('10318','2013-10-29','15:45:00',1.66),('10318','2013-10-29','15:50:00',1.5),('10318','2013-10-29','15:55:00',1.37),('10318','2013-10-29','16:00:00',1.21),('10318','2013-10-29','16:05:00',1.07),('10318','2014-04-17','07:50:00',2.03),('10318','2014-04-17','07:55:00',3.02),('10318','2014-04-17','08:00:00',3.66),('10318','2014-04-17','08:05:00',3.9),('10318','2014-04-17','08:10:00',4.06),('10318','2014-04-17','08:15:00',4.35),('10318','2014-04-17','08:20:00',4.47),('10318','2014-04-17','08:25:00',4.75),('10318','2014-04-17','08:30:00',4.99),('10318','2014-04-17','08:35:00',5.16),('10318','2014-04-17','08:40:00',5.4),('10318','2014-04-17','08:45:00',5.61),('10318','2014-04-17','08:50:00',5.85),('10318','2014-04-17','08:55:00',5.15),('10318','2014-04-17','09:00:00',6.08),('10318','2014-04-17','09:05:00',6.37),('10318','2014-04-17','09:10:00',6.67),('10318','2014-04-17','09:15:00',6.84),('10318','2014-04-17','09:20:00',6.97),('10318','2014-04-17','09:25:00',7.19),('10318','2014-04-17','09:30:00',7.35),('10318','2014-04-17','09:35:00',7.37),('10318','2014-04-17','09:40:00',7.69),('10318','2014-04-17','09:45:00',7.85),('10318','2014-04-17','09:50:00',8.01),('10318','2014-04-17','09:55:00',8.19),('10318','2014-04-17','10:00:00',8.39),('10318','2014-04-17','10:05:00',6.57),('10318','2014-04-17','10:10:00',5.97),('10318','2014-04-17','10:15:00',5.59),('10318','2014-04-17','10:20:00',9.02),('10318','2014-04-17','10:25:00',9.03),('10318','2014-04-17','10:30:00',9.22),('10318','2014-04-17','10:35:00',9.61),('10318','2014-04-17','10:40:00',9),('10318','2014-04-17','10:45:00',8.75),('10318','2014-04-17','10:50:00',5.9),('10318','2014-04-17','10:55:00',5.71),('10318','2014-04-17','11:00:00',8.17),('10318','2014-04-17','11:05:00',6.83),('10318','2014-04-17','11:10:00',7.51),('10318','2014-04-17','11:15:00',6.25),('10318','2014-04-17','11:20:00',7.64),('10318','2014-04-17','11:25:00',7.3),('10318','2014-04-17','11:30:00',5.16),('10318','2014-04-17','11:35:00',4.47),('10318','2014-04-17','11:40:00',5.78),('10318','2014-04-17','11:45:00',8.95),('10318','2014-04-17','11:50:00',9.77),('10318','2014-04-17','11:55:00',9.14),('10318','2014-04-17','12:00:00',7.6),('10318','2014-04-17','12:05:00',5.81),('10318','2014-04-17','12:10:00',5.55),('10318','2014-04-17','12:15:00',5.56),('10318','2014-04-17','12:20:00',6.65),('10318','2014-04-17','12:25:00',8.57),('10318','2014-04-17','12:30:00',7.04),('10318','2014-04-17','12:35:00',9.1),('10318','2014-04-17','12:40:00',10.04),('10318','2014-04-17','12:45:00',10.1),('10318','2014-04-17','12:50:00',10.2),('10318','2014-04-17','12:55:00',10.25),('10318','2014-04-17','13:00:00',10.12),('10318','2014-04-17','13:05:00',10.13),('10318','2014-04-17','13:10:00',10.21),('10318','2014-04-17','13:15:00',10.36),('10318','2014-04-17','13:20:00',10.55),('10318','2014-04-17','13:25:00',10.36),('10318','2014-04-17','13:30:00',8.55),('10318','2014-04-17','13:35:00',2.14),('10318','2014-04-17','13:40:00',3.98),('10318','2014-04-17','13:45:00',10.54),('10318','2014-04-17','13:50:00',7.93),('10318','2014-04-17','13:55:00',4.67),('10318','2014-04-17','14:00:00',7.26),('10318','2014-04-17','14:05:00',4.91),('10318','2014-04-17','14:10:00',7.21),('10318','2014-04-17','14:15:00',5.81),('10318','2014-04-17','14:20:00',4.34),('10318','2014-04-17','14:25:00',3.98),('10318','2014-04-17','14:30:00',7.03),('10318','2014-04-17','14:35:00',5.21),('10318','2014-04-17','14:40:00',3.62),('10318','2014-04-17','14:45:00',2.62),('10318','2014-04-17','14:50:00',1.71),('10318','2014-04-17','14:55:00',1.42),('10318','2014-04-17','15:00:00',1.4),('10318','2014-04-17','15:05:00',1.36),('10318','2014-04-17','15:10:00',1.36),('10318','2014-04-17','15:15:00',1.79),('10318','2014-04-17','15:20:00',2.55),('10318','2014-04-17','15:25:00',3.27),('10318','2014-04-17','15:30:00',4.9),('10318','2014-04-17','15:35:00',5.83),('10318','2014-04-17','15:40:00',4.23),('10318','2014-04-17','15:45:00',2.99),('10318','2014-04-17','15:50:00',2.96),('10318','2014-04-17','15:55:00',2.96),('10318','2014-04-17','16:00:00',2.36),('10318','2014-04-17','16:05:00',2.26),('10318','2014-04-17','16:10:00',2.23),('10318','2014-04-17','16:15:00',2.08),('10318','2014-04-17','16:20:00',2.25),('10318','2014-04-17','16:25:00',2.74),('10318','2014-04-17','16:30:00',2.38),('10318','2014-04-17','16:35:00',2.44),('10318','2014-04-17','16:40:00',3.08),('10318','2014-04-17','16:45:00',5.62),('10318','2014-04-17','16:50:00',3.58),('10318','2014-04-17','16:55:00',3.32),('10318','2014-04-17','17:00:00',2.38),('10318','2014-04-17','17:05:00',2.07),('10318','2014-04-17','17:10:00',2.03),('10318','2014-04-17','17:15:00',2.39),('10318','2014-04-17','17:20:00',2.36),('10318','2014-04-17','17:25:00',2.13),('10318','2014-04-17','17:30:00',2.62),('10318','2014-04-17','17:35:00',2.88),('10318','2014-04-17','17:40:00',2.45),('10318','2014-04-17','17:45:00',2.08),('10318','2014-04-17','17:50:00',1.65),('10318','2014-04-17','17:55:00',1.54),('10318','2014-04-17','18:00:00',1.26),('10318','2013-10-28','07:20:00',1.34),('10318','2013-10-28','07:25:00',1.23),('10318','2013-10-28','07:30:00',1.25),('10318','2013-10-28','07:35:00',1.62),('10318','2013-10-28','08:00:00',1.07),('10318','2013-10-28','08:05:00',1.39),('10318','2013-10-28','08:10:00',1.31),('10318','2013-10-28','08:15:00',1.46),('10318','2013-10-28','08:20:00',1.26),('10318','2013-10-28','08:25:00',1.28),('10318','2013-10-28','08:30:00',1.6),('10318','2013-10-28','08:35:00',1.85),('10318','2013-10-28','08:40:00',2.91),('10318','2013-10-28','08:45:00',4.74),('10318','2013-10-28','08:50:00',4.95),('10318','2013-10-28','08:55:00',5.52),('10318','2013-10-28','09:00:00',5.96),('10318','2013-10-28','09:05:00',4.15),('10318','2013-10-28','09:10:00',5.59),('10318','2013-10-28','09:15:00',5.99),('10318','2013-10-28','09:20:00',5.36),('10318','2013-10-28','09:25:00',3.75),('10318','2013-10-28','09:30:00',5.91),('10318','2013-10-28','09:35:00',2.72),('10318','2013-10-28','09:40:00',2.46),('10318','2013-10-28','09:45:00',3.61),('10318','2013-10-28','09:50:00',3.02),('10318','2013-10-28','09:55:00',2.06),('10318','2013-10-28','10:00:00',1.81),('10318','2013-10-28','10:05:00',1.81),('10318','2013-10-28','10:10:00',1.84),('10318','2013-10-28','10:15:00',1.88),('10318','2013-10-28','10:20:00',1.94),('10318','2013-10-28','10:25:00',1.93),('10318','2013-10-28','10:30:00',1.87),('10318','2013-10-28','10:35:00',1.31),('10318','2013-10-28','10:40:00',2.53),('10318','2013-10-28','10:45:00',7.46),('10318','2013-10-28','10:50:00',7.24),('10318','2013-10-28','10:55:00',7.25),('10318','2013-10-28','11:00:00',7.22),('10318','2013-10-28','11:05:00',7.22),('10318','2013-10-28','11:10:00',7.16),('10318','2013-10-28','11:15:00',7.14),('10318','2013-10-28','11:20:00',7.18),('10318','2013-10-28','11:25:00',7.14),('10318','2013-10-28','11:30:00',7.14),('10318','2013-10-28','11:35:00',7.16),('10318','2013-10-28','11:40:00',7.07),('10318','2013-10-28','11:45:00',7.11),('10318','2013-10-28','11:50:00',5.26),('10318','2013-10-28','11:55:00',7.05),('10318','2013-10-28','12:00:00',7.15),('10318','2013-10-28','12:05:00',7.16),('10318','2013-10-28','12:10:00',7.18),('10318','2013-10-28','12:15:00',7.34),('10318','2013-10-28','12:20:00',7.23),('10318','2013-10-28','12:25:00',3.55),('10318','2013-10-28','12:30:00',6.97),('10318','2013-10-28','12:35:00',6.27),('10318','2013-10-28','12:40:00',5.28),('10318','2013-10-28','12:45:00',6.74),('10318','2013-10-28','12:50:00',6.65),('10318','2013-10-28','12:55:00',6.52),('10318','2013-10-28','13:00:00',6.42),('10318','2013-10-28','13:05:00',6.3),('10318','2013-10-28','13:10:00',6.23),('10318','2013-10-28','13:15:00',6.06),('10318','2013-10-28','13:20:00',5.98),('10318','2013-10-28','13:25:00',5.85),('10318','2013-10-28','13:30:00',5.88),('10318','2013-10-28','13:35:00',5.95),('10318','2013-10-28','13:40:00',5.64),('10318','2013-10-28','13:45:00',4.63),('10318','2013-10-28','13:50:00',5.29),('10318','2013-10-28','13:55:00',2.81),('10318','2013-10-28','14:00:00',5.27),('10318','2013-10-28','14:05:00',5.04),('10318','2013-10-28','14:10:00',4.05),('10318','2013-10-28','14:15:00',4.09),('10318','2013-10-28','14:20:00',4.68),('10318','2013-10-28','14:25:00',4.29),('10318','2013-10-28','14:30:00',4.4),('10318','2013-10-28','14:35:00',2.21),('10318','2013-10-28','14:40:00',4.22),('10318','2013-10-28','14:45:00',3.66),('10318','2013-10-28','14:50:00',1.24),('10318','2013-10-28','14:55:00',3.41),('10318','2013-10-28','15:00:00',3.42),('10318','2013-10-28','15:05:00',3.28),('10318','2013-10-28','15:10:00',2.72),('10318','2013-10-28','15:15:00',2.51),('10318','2013-10-28','15:20:00',2.65),('10318','2013-10-28','15:25:00',2.78),('10318','2013-10-28','15:30:00',2.61),('10318','2013-10-28','15:35:00',1.85),('10318','2013-10-28','15:40:00',1.48),('10318','2013-10-28','15:45:00',2.08),('10318','2013-10-28','15:50:00',1.91),('10318','2013-10-28','15:55:00',1.65),('10318','2013-10-28','16:00:00',1.44),('10318','2013-10-28','16:05:00',1.26),('10318','2013-10-28','16:10:00',1.03),('10318','2013-10-27','08:10:00',1.01),('10318','2013-10-27','08:25:00',1.03),('10318','2013-10-27','08:30:00',1.22),('10318','2013-10-27','08:35:00',1.59),('10318','2013-10-27','08:40:00',1.55),('10318','2013-10-27','08:45:00',1.43),('10318','2013-10-27','08:50:00',1.31),('10318','2013-10-27','08:55:00',1.15),('10318','2013-10-27','09:00:00',1.06),('10318','2013-10-27','09:05:00',1.1),('10318','2013-10-27','09:10:00',1.07),('10318','2013-10-27','09:15:00',1.07),('10318','2013-10-27','09:20:00',1.28),('10318','2013-10-27','09:25:00',1.52),('10318','2013-10-27','09:30:00',1.75),('10318','2013-10-27','09:35:00',1.85),('10318','2013-10-27','09:40:00',1.87),('10318','2013-10-27','09:45:00',2.06),('10318','2013-10-27','09:50:00',2.22),('10318','2013-10-27','09:55:00',2.45),('10318','2013-10-27','10:00:00',2.24),('10318','2013-10-27','10:05:00',2.46),('10318','2013-10-27','10:10:00',2.7),('10318','2013-10-27','10:15:00',2.83),('10318','2013-10-27','10:20:00',2.6),('10318','2013-10-27','10:25:00',2.72),('10318','2013-10-27','10:30:00',2.79),('10318','2013-10-27','10:35:00',2.96),('10318','2013-10-27','10:40:00',3.41),('10318','2013-10-27','10:45:00',3.48),('10318','2013-10-27','10:50:00',2.9),('10318','2013-10-27','10:55:00',3.64),('10318','2013-10-27','11:00:00',2.79),('10318','2013-10-27','11:05:00',2.29),('10318','2013-10-27','11:10:00',2.04),('10318','2013-10-27','11:15:00',2.13),('10318','2013-10-27','11:20:00',2.32),('10318','2013-10-27','11:25:00',2.67),('10318','2013-10-27','11:30:00',5.34),('10318','2013-10-27','11:35:00',4.22),('10318','2013-10-27','11:40:00',3.53),('10318','2013-10-27','11:45:00',3.29),('10318','2013-10-27','11:50:00',2.72),('10318','2013-10-27','11:55:00',3.08),('10318','2013-10-27','12:00:00',2.64),('10318','2013-10-27','12:05:00',2.78),('10318','2013-10-27','12:10:00',4.9),('10318','2013-10-27','12:15:00',6.25),('10318','2013-10-27','12:20:00',4.01),('10318','2013-10-27','12:25:00',4.68),('10318','2013-10-27','12:30:00',4.35),('10318','2013-10-27','12:35:00',4.92),('10318','2013-10-27','12:40:00',2.09),('10318','2013-10-27','12:45:00',1.75),('10318','2013-10-27','12:50:00',1.9),('10318','2013-10-27','12:55:00',2.28),('10318','2013-10-27','13:00:00',4.3),('10318','2013-10-27','13:05:00',3.7),('10318','2013-10-27','13:10:00',5.64),('10318','2013-10-27','13:15:00',4.84),('10318','2013-10-27','13:20:00',4.52),('10318','2013-10-27','13:25:00',4.49),('10318','2013-10-27','13:30:00',1.95),('10318','2013-10-27','13:35:00',1.91),('10318','2013-10-27','13:40:00',1.77),('10318','2013-10-27','13:45:00',2),('10318','2013-10-27','13:50:00',3.16),('10318','2013-10-27','13:55:00',4.38),('10318','2013-10-27','14:00:00',4.67),('10318','2013-10-27','14:05:00',4.84),('10318','2013-10-27','14:10:00',2.67),('10318','2013-10-27','14:15:00',5.56),('10318','2013-10-27','14:20:00',4.63),('10318','2013-10-27','14:25:00',3.71),('10318','2013-10-27','14:30:00',2.69),('10318','2013-10-27','14:35:00',2.64),('10318','2013-10-27','14:40:00',4.15),('10318','2013-10-27','14:45:00',4.02),('10318','2013-10-27','14:50:00',4.06),('10318','2013-10-27','14:55:00',3.7),('10318','2013-10-27','15:00:00',3.4),('10318','2013-10-27','15:05:00',3),('10318','2013-10-27','15:10:00',2.89),('10318','2013-10-27','15:15:00',2.79),('10318','2013-10-27','15:20:00',2.61),('10318','2013-10-27','15:30:00',1.63),('10318','2013-10-27','15:35:00',2.04),('10318','2013-10-27','15:40:00',1.52),('10318','2013-10-27','15:50:00',1.46),('10318','2013-10-27','15:55:00',1.61),('10318','2013-10-27','16:00:00',1.44),('10318','2013-10-27','16:05:00',1.26),('10318','2013-10-27','16:10:00',1.12),('10318','2013-10-26','08:20:00',1.16),('10318','2013-10-26','08:25:00',1.42),('10318','2013-10-26','08:30:00',1.8),('10318','2013-10-26','08:35:00',2.08),('10318','2013-10-26','08:40:00',2.42),('10318','2013-10-26','08:45:00',2.78),('10318','2013-10-26','08:50:00',2.95),('10318','2013-10-26','08:55:00',3.15),('10318','2013-10-26','09:00:00',3.34),('10318','2013-10-26','09:05:00',3.52),('10318','2013-10-26','09:10:00',3.63),('10318','2013-10-26','09:15:00',3.88),('10318','2013-10-26','09:20:00',4.06),('10318','2013-10-26','09:25:00',4.24),('10318','2013-10-26','09:30:00',4.43),('10318','2013-10-26','09:35:00',4.58),('10318','2013-10-26','09:40:00',4.72),('10318','2013-10-26','09:45:00',4.87),('10318','2013-10-26','09:50:00',5.01),('10318','2013-10-26','09:55:00',5.17),('10318','2013-10-26','10:00:00',5.32),('10318','2013-10-26','10:05:00',5.46),('10318','2013-10-26','10:10:00',5.6),('10318','2013-10-26','10:15:00',5.68),('10318','2013-10-26','10:20:00',5.77),('10318','2013-10-26','10:25:00',5.86),('10318','2013-10-26','10:30:00',5.97),('10318','2013-10-26','10:35:00',6.06),('10318','2013-10-26','10:40:00',6.05),('10318','2013-10-26','10:45:00',6.24),('10318','2013-10-26','10:50:00',6.36),('10318','2013-10-26','10:55:00',6.39),('10318','2013-10-26','11:00:00',6.48),('10318','2013-10-26','11:05:00',6.57),('10318','2013-10-26','11:10:00',6.66),('10318','2013-10-26','11:15:00',6.77),('10318','2013-10-26','11:20:00',6.8),('10318','2013-10-26','11:25:00',6.82),('10318','2013-10-26','11:30:00',6.84),('10318','2013-10-26','11:35:00',6.92),('10318','2013-10-26','11:40:00',6.95),('10318','2013-10-26','11:45:00',6.97),('10318','2013-10-26','11:50:00',6.95),('10318','2013-10-26','11:55:00',6.97),('10318','2013-10-26','12:00:00',6.95),('10318','2013-10-26','12:05:00',6.89),('10318','2013-10-26','12:10:00',6.7),('10318','2013-10-26','12:15:00',6.98),('10318','2013-10-26','12:20:00',6.99),('10318','2013-10-26','12:25:00',7.02),('10318','2013-10-26','12:30:00',6.88),('10318','2013-10-26','12:35:00',6.83),('10318','2013-10-26','12:40:00',6.77),('10318','2013-10-26','12:45:00',6.94),('10318','2013-10-26','12:50:00',6.88),('10318','2013-10-26','12:55:00',6.81),('10318','2013-10-26','13:00:00',6.56),('10318','2013-10-26','13:05:00',6.92),('10318','2013-10-26','13:10:00',6.76),('10318','2013-10-26','13:15:00',6.75),('10318','2013-10-26','13:20:00',6.4),('10318','2013-10-26','13:25:00',6.45),('10318','2013-10-26','13:30:00',5.77),('10318','2013-10-26','13:35:00',6.36),('10318','2013-10-26','13:40:00',5.82),('10318','2013-10-26','13:45:00',4.29),('10318','2013-10-26','13:50:00',6.07),('10318','2013-10-26','13:55:00',6.02),('10318','2013-10-26','14:00:00',5.8),('10318','2013-10-26','14:05:00',5.83),('10318','2013-10-26','14:10:00',5.28),('10318','2013-10-26','14:15:00',5.48),('10318','2013-10-26','14:20:00',5.8),('10318','2013-10-26','14:25:00',4.8),('10318','2013-10-26','14:30:00',4.82),('10318','2013-10-26','14:35:00',5.35),('10318','2013-10-26','14:40:00',4.65),('10318','2013-10-26','14:45:00',4.55),('10318','2013-10-26','14:50:00',4.94),('10318','2013-10-26','14:55:00',4.9),('10318','2013-10-26','15:00:00',4.82),('10318','2013-10-26','15:05:00',3.44),('10318','2013-10-26','15:10:00',3.82),('10318','2013-10-26','15:15:00',4.28),('10318','2013-10-26','15:20:00',4.06),('10318','2013-10-26','15:25:00',4.14),('10318','2013-10-26','15:30:00',4.01),('10318','2013-10-26','15:35:00',4.01),('10318','2013-10-26','15:40:00',3.74),('10318','2013-10-26','15:45:00',3.42),('10318','2013-10-26','15:50:00',3.19),('10318','2013-10-26','15:55:00',3.09),('10318','2013-10-26','16:00:00',2.9),('10318','2013-10-26','16:05:00',2.88),('10318','2013-10-26','16:10:00',2.66),('10318','2013-10-26','16:15:00',2.58),('10318','2013-10-26','16:20:00',2.34),('10318','2013-10-26','16:25:00',2.3),('10318','2013-10-26','16:30:00',2.12),('10318','2013-10-26','16:35:00',1.93),('10318','2013-10-26','16:40:00',1.82),('10318','2013-10-26','16:45:00',1.68),('10318','2013-10-26','16:50:00',1.59),('10318','2013-10-26','16:55:00',1.43),('10318','2013-10-26','17:00:00',1.29),('10318','2013-10-26','17:05:00',1.14),('10318','2013-10-25','08:15:00',1.04),('10318','2013-10-25','08:20:00',1.19),('10318','2013-10-25','08:25:00',1.43),('10318','2013-10-25','08:30:00',1.79),('10318','2013-10-25','08:35:00',2.09),('10318','2013-10-25','08:40:00',2.5),('10318','2013-10-25','08:45:00',2.76),('10318','2013-10-25','08:50:00',2.91),('10318','2013-10-25','08:55:00',3.03),('10318','2013-10-25','09:00:00',3.26),('10318','2013-10-25','09:05:00',3.48),('10318','2013-10-25','09:10:00',3.68),('10318','2013-10-25','09:15:00',3.9),('10318','2013-10-25','09:20:00',4.1),('10318','2013-10-25','09:25:00',4.3),('10318','2013-10-25','09:30:00',4.55),('10318','2013-10-25','09:35:00',4.71),('10318','2013-10-25','09:40:00',4.8),('10318','2013-10-25','09:45:00',4.94),('10318','2013-10-25','09:50:00',5.07),('10318','2013-10-25','09:55:00',5.23),('10318','2013-10-25','10:00:00',5.33),('10318','2013-10-25','10:05:00',5.47),('10318','2013-10-25','10:10:00',5.57),('10318','2013-10-25','10:15:00',5.73),('10318','2013-10-25','10:20:00',5.85),('10318','2013-10-25','10:25:00',5.96),('10318','2013-10-25','10:30:00',6.07),('10318','2013-10-25','10:35:00',6.14),('10318','2013-10-25','10:40:00',6.29),('10318','2013-10-25','10:45:00',6.42),('10318','2013-10-25','10:50:00',6.4),('10318','2013-10-25','10:55:00',6.55),('10318','2013-10-25','11:00:00',6.53),('10318','2013-10-25','11:05:00',6.63),('10318','2013-10-25','11:10:00',6.84),('10318','2013-10-25','11:15:00',6.9),('10318','2013-10-25','11:20:00',6.91),('10318','2013-10-25','11:25:00',6.95),('10318','2013-10-25','11:30:00',7.02),('10318','2013-10-25','11:35:00',7.03),('10318','2013-10-25','11:40:00',7.06),('10318','2013-10-25','11:45:00',7.12),('10318','2013-10-25','11:50:00',7.12),('10318','2013-10-25','11:55:00',7.09),('10318','2013-10-25','12:00:00',7.22),('10318','2013-10-25','12:05:00',7.21),('10318','2013-10-25','12:10:00',7.19),('10318','2013-10-25','12:15:00',7.23),('10318','2013-10-25','12:20:00',7.21),('10318','2013-10-25','12:25:00',7.22),('10318','2013-10-25','12:30:00',7.21),('10318','2013-10-25','12:35:00',7.19),('10318','2013-10-25','12:40:00',7.15),('10318','2013-10-25','12:45:00',7.13),('10318','2013-10-25','12:50:00',7.09),('10318','2013-10-25','12:55:00',7.08),('10318','2013-10-25','13:00:00',7.04),('10318','2013-10-25','13:05:00',6.97),('10318','2013-10-25','13:10:00',6.81),('10318','2013-10-25','13:15:00',6.87),('10318','2013-10-25','13:20:00',6.77),('10318','2013-10-25','13:25:00',6.74),('10318','2013-10-25','13:30:00',6.69),('10318','2013-10-25','13:35:00',6.57),('10318','2013-10-25','13:40:00',6.48),('10318','2013-10-25','13:45:00',6.41),('10318','2013-10-25','13:50:00',6.36),('10318','2013-10-25','13:55:00',6.32),('10318','2013-10-25','14:00:00',6.25),('10318','2013-10-25','14:05:00',6.15),('10318','2013-10-25','14:10:00',6.05),('10318','2013-10-25','14:15:00',6.01),('10318','2013-10-25','14:20:00',5.89),('10318','2013-10-25','14:25:00',5.81),('10318','2013-10-25','14:30:00',5.75),('10318','2013-10-25','14:35:00',5.62),('10318','2013-10-25','14:40:00',5.45),('10318','2013-10-25','14:45:00',5.34),('10318','2013-10-25','14:50:00',5.21),('10318','2013-10-25','14:55:00',4.9),('10318','2013-10-25','15:00:00',4.93),('10318','2013-10-25','15:05:00',4.85),('10318','2013-10-25','15:10:00',4.58),('10318','2013-10-25','15:15:00',4.49),('10318','2013-10-25','15:20:00',4.36),('10318','2013-10-25','15:25:00',4.22),('10318','2013-10-25','15:30:00',4.08),('10318','2013-10-25','15:35:00',3.92),('10318','2013-10-25','15:40:00',3.8),('10318','2013-10-25','15:45:00',3.69),('10318','2013-10-25','15:50:00',3.54),('10318','2013-10-25','15:55:00',3.4),('10318','2013-10-25','16:00:00',3.26),('10318','2013-10-25','16:05:00',3.15),('10318','2013-10-25','16:10:00',3),('10318','2013-10-25','16:15:00',2.87),('10318','2013-10-25','16:20:00',2.74),('10318','2013-10-25','16:25:00',2.59),('10318','2013-10-25','16:30:00',2.45),('10318','2013-10-25','16:35:00',2.32),('10318','2013-10-25','16:40:00',2.16),('10318','2013-10-25','16:45:00',1.96),('10318','2013-10-25','16:50:00',1.88),('10318','2013-10-25','16:55:00',1.71),('10318','2013-10-25','17:00:00',1.56),('10318','2013-10-25','17:05:00',1.36),('10318','2013-10-25','17:10:00',1.22),('10318','2013-10-25','17:15:00',1.03),('10318','2013-10-24','08:20:00',1.28),('10318','2013-10-24','08:25:00',1.11),('10318','2013-10-24','08:45:00',1.02),('10318','2013-10-24','08:50:00',1.34),('10318','2013-10-24','08:55:00',2.27),('10318','2013-10-24','09:00:00',3.05),('10318','2013-10-24','09:05:00',3.19),('10318','2013-10-24','09:10:00',4),('10318','2013-10-24','09:15:00',4.19),('10318','2013-10-24','09:20:00',2.15),('10318','2013-10-24','09:25:00',2.17),('10318','2013-10-24','09:30:00',2.36),('10318','2013-10-24','09:35:00',2.5),('10318','2013-10-24','09:40:00',2.57),('10318','2013-10-24','09:45:00',2.68),('10318','2013-10-24','09:50:00',2.73),('10318','2013-10-24','09:55:00',2.64),('10318','2013-10-24','10:00:00',2.46),('10318','2013-10-24','10:05:00',2.38),('10318','2013-10-24','10:10:00',2.17),('10318','2013-10-24','10:15:00',2.16),('10318','2013-10-24','10:20:00',1.92),('10318','2013-10-24','10:25:00',1.68),('10318','2013-10-24','10:30:00',3.12),('10318','2013-10-24','10:35:00',4.11),('10318','2013-10-24','10:40:00',6.29),('10318','2013-10-24','10:45:00',4.52),('10318','2013-10-24','10:50:00',5.33),('10318','2013-10-24','10:55:00',5.82),('10318','2013-10-24','11:00:00',7.16),('10318','2013-10-24','11:05:00',7.52),('10318','2013-10-24','11:10:00',3.28),('10318','2013-10-24','11:15:00',3.47),('10318','2013-10-24','11:20:00',4.07),('10318','2013-10-24','11:25:00',3.19),('10318','2013-10-24','11:30:00',2.56),('10318','2013-10-24','11:35:00',2.76),('10318','2013-10-24','11:40:00',3.06),('10318','2013-10-24','11:45:00',3.74),('10318','2013-10-24','11:50:00',8.23),('10318','2013-10-24','11:55:00',4.99),('10318','2013-10-24','12:00:00',3.34),('10318','2013-10-24','12:05:00',3.03),('10318','2013-10-24','12:10:00',3.06),('10318','2013-10-24','12:15:00',3.16),('10318','2013-10-24','12:20:00',3.82),('10318','2013-10-24','12:25:00',3.84),('10318','2013-10-24','12:30:00',4.23),('10318','2013-10-24','12:35:00',4.24),('10318','2013-10-24','12:40:00',4.21),('10318','2013-10-24','12:45:00',4.35),('10318','2013-10-24','12:50:00',4.53),('10318','2013-10-24','12:55:00',6.4),('10318','2013-10-24','13:00:00',7.39),('10318','2013-10-24','13:05:00',5.32),('10318','2013-10-24','13:10:00',3.61),('10318','2013-10-24','13:15:00',4.72),('10318','2013-10-24','13:20:00',3.56),('10318','2013-10-24','13:25:00',3.04),('10318','2013-10-24','13:30:00',2.86),('10318','2013-10-24','13:35:00',2.86),('10318','2013-10-24','13:40:00',2.89),('10318','2013-10-24','13:45:00',2.99),('10318','2013-10-24','13:50:00',5.12),('10318','2013-10-24','13:55:00',4.8),('10318','2013-10-24','14:00:00',3.14),('10318','2013-10-24','14:05:00',2.95),('10318','2013-10-24','14:10:00',2.95),('10318','2013-10-24','14:15:00',3.03),('10318','2013-10-24','14:20:00',3.63),('10318','2013-10-24','14:25:00',3.88),('10318','2013-10-24','14:30:00',4.16),('10318','2013-10-24','14:35:00',4.55),('10318','2013-10-24','14:40:00',6.53),('10318','2013-10-24','14:45:00',6.65),('10318','2013-10-24','14:50:00',3.31),('10318','2013-10-24','14:55:00',1.62),('10318','2013-10-24','15:00:00',2.26),('10318','2013-10-24','15:05:00',3.43),('10318','2013-10-24','15:10:00',2.83),('10318','2013-10-24','15:15:00',2.35),('10318','2013-10-24','15:20:00',2.17),('10318','2013-10-24','15:25:00',2.18),('10318','2013-10-24','15:30:00',3.65),('10318','2013-10-24','15:35:00',4.95),('10318','2013-10-24','15:40:00',4.73),('10318','2013-10-24','15:45:00',4.65),('10318','2013-10-24','15:50:00',2.22),('10318','2013-10-24','15:55:00',1.71),('10318','2013-10-24','16:00:00',1.61),('10318','2013-10-24','16:05:00',1.57),('10318','2013-10-24','16:10:00',1.56),('10318','2013-10-24','16:15:00',1.56),('10318','2013-10-24','16:20:00',1.48),('10318','2013-10-24','16:25:00',1.23),('10318','2013-10-24','16:30:00',1.1),('10318','2013-10-23','09:35:00',1.37),('10318','2013-10-23','09:40:00',1.62),('10318','2013-10-23','09:45:00',1.46),('10318','2013-10-23','09:50:00',1.5),('10318','2013-10-23','09:55:00',1.45),('10318','2013-10-23','10:00:00',1.49),('10318','2013-10-23','10:05:00',1.62),('10318','2013-10-23','10:10:00',1.96),('10318','2013-10-23','10:15:00',2.42),('10318','2013-10-23','10:20:00',2.6),('10318','2013-10-23','10:25:00',2.37),('10318','2013-10-23','10:30:00',2.42),('10318','2013-10-23','10:35:00',2.39),('10318','2013-10-23','10:40:00',3.02),('10318','2013-10-23','10:45:00',3.74),('10318','2013-10-23','10:50:00',4.14),('10318','2013-10-23','10:55:00',4.08),('10318','2013-10-23','11:00:00',2.94),('10318','2013-10-23','11:05:00',3.86),('10318','2013-10-23','11:10:00',5.19),('10318','2013-10-23','11:15:00',7.29),('10318','2013-10-23','11:20:00',6.15),('10318','2013-10-23','11:25:00',6.89),('10318','2013-10-23','11:30:00',6.88),('10318','2013-10-23','11:35:00',7.02),('10318','2013-10-23','11:40:00',6.82),('10318','2013-10-23','11:45:00',6.82),('10318','2013-10-23','11:50:00',6.87),('10318','2013-10-23','11:55:00',6.99),('10318','2013-10-23','12:00:00',6.87),('10318','2013-10-23','12:05:00',6.7),('10318','2013-10-23','12:10:00',6.45),('10318','2013-10-23','12:15:00',6.84),('10318','2013-10-23','12:20:00',6.66),('10318','2013-10-23','12:25:00',6.72),('10318','2013-10-23','12:30:00',6.48),('10318','2013-10-23','12:35:00',6.52),('10318','2013-10-23','12:40:00',5.08),('10318','2013-10-23','12:45:00',5.66),('10318','2013-10-23','12:50:00',6.45),('10318','2013-10-23','12:55:00',6.39),('10318','2013-10-23','13:00:00',6.64),('10318','2013-10-23','13:05:00',6.72),('10318','2013-10-23','13:10:00',6.76),('10318','2013-10-23','13:15:00',6.7),('10318','2013-10-23','13:20:00',6.38),('10318','2013-10-23','13:25:00',6.37),('10318','2013-10-23','13:30:00',6.26),('10318','2013-10-23','13:35:00',6.24),('10318','2013-10-23','13:40:00',6.15),('10318','2013-10-23','13:45:00',6.09),('10318','2013-10-23','13:50:00',6.32),('10318','2013-10-23','13:55:00',6.12),('10318','2013-10-23','14:00:00',5.97),('10318','2013-10-23','14:05:00',5.9),('10318','2013-10-23','14:10:00',5.85),('10318','2013-10-23','14:15:00',5.66),('10318','2013-10-23','14:20:00',5.58),('10318','2013-10-23','14:25:00',5.56),('10318','2013-10-23','14:30:00',5.26),('10318','2013-10-23','14:35:00',5.06),('10318','2013-10-23','14:40:00',5.11),('10318','2013-10-23','14:45:00',4.75),('10318','2013-10-23','14:50:00',4.75),('10318','2013-10-23','14:55:00',4.59),('10318','2013-10-23','15:00:00',4.62),('10318','2013-10-23','15:05:00',4.43),('10318','2013-10-23','15:10:00',4.42),('10318','2013-10-23','15:15:00',4.4),('10318','2013-10-23','15:20:00',4.57),('10318','2013-10-23','15:25:00',4.38),('10318','2013-10-23','15:30:00',3.74),('10318','2013-10-23','15:35:00',3.6),('10318','2013-10-23','15:40:00',4.1),('10318','2013-10-23','15:45:00',4.02),('10318','2013-10-23','15:50:00',3.61),('10318','2013-10-23','15:55:00',2.96),('10318','2013-10-23','16:00:00',2.25),('10318','2013-10-23','16:05:00',1.82),('10318','2013-10-23','16:10:00',1.85),('10318','2013-10-23','16:15:00',1.43),('10318','2013-10-23','16:20:00',1.56),('10318','2013-10-23','16:25:00',1.97),('10318','2013-10-23','16:30:00',2.22),('10318','2013-10-23','16:35:00',2.38),('10318','2013-10-23','16:40:00',2.32),('10318','2013-10-23','16:45:00',1.99),('10318','2013-10-23','16:50:00',1.64),('10318','2013-10-23','16:55:00',1.58),('10318','2013-10-23','17:00:00',1.43),('10318','2013-10-23','17:05:00',1.17),('10318','2013-10-22','08:15:00',1.06),('10318','2013-10-22','08:20:00',1.22),('10318','2013-10-22','08:25:00',1.41),('10318','2013-10-22','08:30:00',1.6),('10318','2013-10-22','08:35:00',2.01),('10318','2013-10-22','08:40:00',2.46),('10318','2013-10-22','08:45:00',2.66),('10318','2013-10-22','08:50:00',2.85),('10318','2013-10-22','08:55:00',3.08),('10318','2013-10-22','09:00:00',3.28),('10318','2013-10-22','09:05:00',3.51),('10318','2013-10-22','09:10:00',3.69),('10318','2013-10-22','09:15:00',3.85),('10318','2013-10-22','09:20:00',4.02),('10318','2013-10-22','09:25:00',4.2),('10318','2013-10-22','09:30:00',4.39),('10318','2013-10-22','09:35:00',4.44),('10318','2013-10-22','09:40:00',4.72),('10318','2013-10-22','09:45:00',4.86),('10318','2013-10-22','09:50:00',5),('10318','2013-10-22','09:55:00',5.1),('10318','2013-10-22','10:00:00',5.24),('10318','2013-10-22','10:05:00',5.36),('10318','2013-10-22','10:10:00',5.48),('10318','2013-10-22','10:15:00',5.61),('10318','2013-10-22','10:20:00',5.73),('10318','2013-10-22','10:25:00',5.8),('10318','2013-10-22','10:30:00',5.87),('10318','2013-10-22','10:35:00',5.96),('10318','2013-10-22','10:40:00',6.05),('10318','2013-10-22','10:45:00',6.12),('10318','2013-10-22','10:50:00',6.14),('10318','2013-10-22','10:55:00',6.21),('10318','2013-10-22','11:00:00',6.28),('10318','2013-10-22','11:05:00',6.41),('10318','2013-10-22','11:10:00',6.51),('10318','2013-10-22','11:15:00',6.54),('10318','2013-10-22','11:20:00',6.51),('10318','2013-10-22','11:25:00',6.63),('10318','2013-10-22','11:30:00',6.66),('10318','2013-10-22','11:35:00',6.57),('10318','2013-10-22','11:40:00',6.63),('10318','2013-10-22','11:45:00',6.73),('10318','2013-10-22','11:50:00',6.77),('10318','2013-10-22','11:55:00',6.8),('10318','2013-10-22','12:00:00',6.82),('10318','2013-10-22','12:05:00',6.86),('10318','2013-10-22','12:10:00',6.86),('10318','2013-10-22','12:15:00',6.92),('10318','2013-10-22','12:20:00',6.87),('10318','2013-10-22','12:25:00',6.77),('10318','2013-10-22','12:30:00',6.78),('10318','2013-10-22','12:35:00',6.67),('10318','2013-10-22','12:40:00',6.83),('10318','2013-10-22','12:45:00',6.81),('10318','2013-10-22','12:50:00',6.71),('10318','2013-10-22','12:55:00',6.68),('10318','2013-10-22','13:00:00',6.62),('10318','2013-10-22','13:05:00',6.57),('10318','2013-10-22','13:10:00',6.64),('10318','2013-10-22','13:15:00',6.52),('10318','2013-10-22','13:20:00',6.55),('10318','2013-10-22','13:25:00',6.46),('10318','2013-10-22','13:30:00',6.34),('10318','2013-10-22','13:35:00',6.25),('10318','2013-10-22','13:40:00',6.11),('10318','2013-10-22','13:45:00',5.9),('10318','2013-10-22','13:50:00',5.68),('10318','2013-10-22','13:55:00',6.23),('10318','2013-10-22','14:00:00',6.14),('10318','2013-10-22','14:05:00',6.42),('10318','2013-10-22','14:10:00',6.55),('10318','2013-10-22','14:15:00',5.78),('10318','2013-10-22','14:20:00',6.35),('10318','2013-10-22','14:25:00',6.05),('10318','2013-10-22','14:30:00',5.78),('10318','2013-10-22','14:35:00',5.44),('10318','2013-10-22','14:40:00',4.92),('10318','2013-10-22','14:45:00',5.07),('10318','2013-10-22','14:50:00',4.92),('10318','2013-10-22','14:55:00',4.73),('10318','2013-10-22','15:00:00',4.75),('10318','2013-10-22','15:05:00',4.67),('10318','2013-10-22','15:10:00',4.61),('10318','2013-10-22','15:15:00',4.02),('10318','2013-10-22','15:20:00',3.85),('10318','2013-10-22','15:25:00',4.11),('10318','2013-10-22','15:30:00',4.06),('10318','2013-10-22','15:35:00',3.85),('10318','2013-10-22','15:40:00',3.81),('10318','2013-10-22','15:45:00',3.55),('10318','2013-10-22','15:50:00',3.49),('10318','2013-10-22','15:55:00',3.26),('10318','2013-10-22','16:00:00',3.15),('10318','2013-10-22','16:05:00',3.03),('10318','2013-10-22','16:10:00',2.84),('10318','2013-10-22','16:15:00',2.7),('10318','2013-10-22','16:20:00',2.57),('10318','2013-10-22','16:25:00',2.46),('10318','2013-10-22','16:30:00',2.32),('10318','2013-10-22','16:35:00',2.17),('10318','2013-10-22','16:40:00',2.04),('10318','2013-10-22','16:45:00',1.91),('10318','2013-10-22','16:50:00',1.73),('10318','2013-10-22','16:55:00',1.6),('10318','2013-10-22','17:00:00',1.47),('10318','2013-10-22','17:05:00',1.32),('10318','2013-10-22','17:10:00',1.14),('10318','2013-10-22','17:15:00',1.01),('10318','2013-10-21','08:05:00',1.11),('10318','2013-10-21','08:10:00',1.25),('10318','2013-10-21','08:15:00',1.36),('10318','2013-10-21','08:20:00',1.58),('10318','2013-10-21','08:25:00',1.67),('10318','2013-10-21','08:30:00',1.96),('10318','2013-10-21','08:35:00',1.96),('10318','2013-10-21','08:40:00',2.38),('10318','2013-10-21','08:45:00',2.36),('10318','2013-10-21','08:50:00',2.09),('10318','2013-10-21','08:55:00',2.24),('10318','2013-10-21','09:00:00',1.99),('10318','2013-10-21','09:05:00',2.69),('10318','2013-10-21','09:10:00',3.63),('10318','2013-10-21','09:15:00',4.11),('10318','2013-10-21','09:20:00',4.49),('10318','2013-10-21','09:25:00',4.25),('10318','2013-10-21','09:30:00',4.05),('10318','2013-10-21','09:35:00',4.44),('10318','2013-10-21','09:40:00',4.28),('10318','2013-10-21','09:45:00',4.25),('10318','2013-10-21','09:50:00',4.27),('10318','2013-10-21','09:55:00',4.66),('10318','2013-10-21','10:00:00',4.95),('10318','2013-10-21','10:05:00',5.64),('10318','2013-10-21','10:10:00',5.56),('10318','2013-10-21','10:15:00',5.85),('10318','2013-10-21','10:20:00',5.88),('10318','2013-10-21','10:25:00',6.12),('10318','2013-10-21','10:30:00',5.99),('10318','2013-10-21','10:35:00',5.82),('10318','2013-10-21','10:40:00',5.96),('10318','2013-10-21','10:45:00',6.07),('10318','2013-10-21','10:50:00',6.4),('10318','2013-10-21','10:55:00',6.65),('10318','2013-10-21','11:00:00',6.61),('10318','2013-10-21','11:05:00',5.65),('10318','2013-10-21','11:10:00',6.93),('10318','2013-10-21','11:15:00',6.96),('10318','2013-10-21','11:20:00',6.62),('10318','2013-10-21','11:25:00',6.78),('10318','2013-10-21','11:30:00',7.03),('10318','2013-10-21','11:35:00',6.73),('10318','2013-10-21','11:40:00',6.95),('10318','2013-10-21','11:45:00',7.05),('10318','2013-10-21','11:50:00',7.09),('10318','2013-10-21','11:55:00',7.12),('10318','2013-10-21','12:00:00',7.29),('10318','2013-10-21','12:05:00',7.34),('10318','2013-10-21','12:10:00',7.31),('10318','2013-10-21','12:15:00',7.26),('10318','2013-10-21','12:20:00',7.2),('10318','2013-10-21','12:25:00',6.97),('10318','2013-10-21','12:30:00',6.95),('10318','2013-10-21','12:35:00',6.93),('10318','2013-10-21','12:40:00',6.94),('10318','2013-10-21','12:45:00',7.07),('10318','2013-10-21','12:50:00',7.09),('10318','2013-10-21','12:55:00',7.01),('10318','2013-10-21','13:00:00',6.84),('10318','2013-10-21','13:05:00',6.48),('10318','2013-10-21','13:10:00',6.29),('10318','2013-10-21','13:15:00',6.37),('10318','2013-10-21','13:20:00',6.17),('10318','2013-10-21','13:25:00',6.69),('10318','2013-10-21','13:30:00',6.77),('10318','2013-10-21','13:35:00',6.63),('10318','2013-10-21','13:40:00',6.58),('10318','2013-10-21','13:45:00',6.37),('10318','2013-10-21','13:50:00',6.3),('10318','2013-10-21','13:55:00',5.97),('10318','2013-10-21','14:00:00',6.21),('10318','2013-10-21','14:05:00',6.2),('10318','2013-10-21','14:10:00',6.13),('10318','2013-10-21','14:15:00',6.06),('10318','2013-10-21','14:20:00',6),('10318','2013-10-21','14:25:00',5.84),('10318','2013-10-21','14:30:00',5.74),('10318','2013-10-21','14:35:00',5.67),('10318','2013-10-21','14:40:00',5.39),('10318','2013-10-21','14:45:00',5.17),('10318','2013-10-21','14:50:00',5.1),('10318','2013-10-21','14:55:00',5),('10318','2013-10-21','15:00:00',4.88),('10318','2013-10-21','15:05:00',4.74),('10318','2013-10-21','15:10:00',4.67),('10318','2013-10-21','15:15:00',4.6),('10318','2013-10-21','15:20:00',4.5),('10318','2013-10-21','15:25:00',4.13),('10318','2013-10-21','15:30:00',4),('10318','2013-10-21','15:35:00',4.06),('10318','2013-10-21','15:40:00',3.94),('10318','2013-10-21','15:45:00',3.76),('10318','2013-10-21','15:50:00',3.59),('10318','2013-10-21','15:55:00',3.42),('10318','2013-10-21','16:00:00',3.33),('10318','2013-10-21','16:05:00',3.27),('10318','2013-10-21','16:10:00',3.07),('10318','2013-10-21','16:15:00',2.91),('10318','2013-10-21','16:20:00',2.73),('10318','2013-10-21','16:25:00',2.58),('10318','2013-10-21','16:30:00',2.38),('10318','2013-10-21','16:35:00',2.29),('10318','2013-10-21','16:40:00',2.17),('10318','2013-10-21','16:45:00',2.05),('10318','2013-10-21','16:50:00',1.84),('10318','2013-10-21','16:55:00',1.61),('10318','2013-10-21','17:00:00',1.44),('10318','2013-10-21','17:05:00',1.45),('10318','2013-10-21','17:10:00',1.36),('10318','2013-10-21','17:15:00',1.22),('10318','2013-10-20','08:15:00',1.44),('10318','2013-10-20','08:20:00',1.8),('10318','2013-10-20','08:25:00',2.09),('10318','2013-10-20','08:30:00',2.24),('10318','2013-10-20','08:35:00',2.83),('10318','2013-10-20','08:40:00',2.99),('10318','2013-10-20','08:45:00',3.1),('10318','2013-10-20','08:50:00',3.28),('10318','2013-10-20','08:55:00',3.44),('10318','2013-10-20','09:00:00',3.61),('10318','2013-10-20','09:05:00',3.87),('10318','2013-10-20','09:10:00',4.09),('10318','2013-10-20','09:15:00',4.31),('10318','2013-10-20','09:20:00',4.5),('10318','2013-10-20','09:25:00',4.68),('10318','2013-10-20','09:30:00',4.81),('10318','2013-10-20','09:35:00',4.95),('10318','2013-10-20','09:40:00',5.05),('10318','2013-10-20','09:45:00',5.17),('10318','2013-10-20','09:50:00',5.41),('10318','2013-10-20','09:55:00',5.56),('10318','2013-10-20','10:00:00',5.71),('10318','2013-10-20','10:05:00',5.82),('10318','2013-10-20','10:10:00',5.94),('10318','2013-10-20','10:15:00',6.06),('10318','2013-10-20','10:20:00',6.05),('10318','2013-10-20','10:25:00',6.26),('10318','2013-10-20','10:30:00',6.4),('10318','2013-10-20','10:35:00',6.46),('10318','2013-10-20','10:40:00',6.52),('10318','2013-10-20','10:45:00',6.63),('10318','2013-10-20','10:50:00',6.71),('10318','2013-10-20','10:55:00',6.76),('10318','2013-10-20','11:00:00',6.85),('10318','2013-10-20','11:05:00',6.94),('10318','2013-10-20','11:10:00',7.01),('10318','2013-10-20','11:15:00',7.11),('10318','2013-10-20','11:20:00',7.18),('10318','2013-10-20','11:25:00',7.18),('10318','2013-10-20','11:30:00',7.2),('10318','2013-10-20','11:35:00',7.14),('10318','2013-10-20','11:40:00',7.24),('10318','2013-10-20','11:45:00',7.35),('10318','2013-10-20','11:50:00',7.37),('10318','2013-10-20','11:55:00',7.31),('10318','2013-10-20','12:00:00',7.39),('10318','2013-10-20','12:05:00',7.44),('10318','2013-10-20','12:10:00',7.39),('10318','2013-10-20','12:15:00',7.3),('10318','2013-10-20','12:20:00',4.98),('10318','2013-10-20','12:25:00',4.59),('10318','2013-10-20','12:30:00',4.2),('10318','2013-10-20','12:35:00',2.44),('10318','2013-10-20','12:40:00',3.57),('10318','2013-10-20','12:45:00',5.02),('10318','2013-10-20','12:50:00',5.12),('10318','2013-10-20','12:55:00',5.48),('10318','2013-10-20','13:00:00',8.45),('10318','2013-10-20','13:05:00',4.08),('10318','2013-10-20','13:10:00',2.27),('10318','2013-10-20','13:15:00',3.22),('10318','2013-10-20','13:20:00',3.98),('10318','2013-10-20','13:25:00',3.71),('10318','2013-10-20','13:30:00',2.73),('10318','2013-10-20','13:35:00',4.03),('10318','2013-10-20','13:40:00',2.14),('10318','2013-10-20','13:45:00',2.14),('10318','2013-10-20','13:50:00',1.94),('10318','2013-10-20','13:55:00',1.74),('10318','2013-10-20','14:00:00',1.87),('10318','2013-10-20','14:05:00',1.73),('10318','2013-10-20','14:10:00',1.31),('10318','2013-10-20','14:15:00',1.18),('10318','2013-10-20','14:20:00',1.19),('10318','2013-10-20','14:25:00',1.17),('10318','2013-10-20','14:30:00',1.03),('10318','2013-10-20','14:35:00',1.07),('10318','2013-10-20','14:40:00',1.14),('10318','2013-10-20','14:45:00',1.11),('10318','2013-10-20','14:50:00',1.17),('10318','2013-10-20','14:55:00',1.28),('10318','2013-10-20','15:00:00',1.32),('10318','2013-10-20','15:05:00',1.19),('10318','2013-10-20','15:10:00',1.14),('10318','2013-10-20','15:15:00',1.06),('10318','2013-10-20','15:35:00',1.07),('10318','2013-10-20','15:40:00',1.11),('10318','2013-10-20','15:45:00',1.21),('10318','2013-10-20','15:50:00',1.04),('10318','2013-10-20','15:55:00',1.15),('10318','2013-10-20','16:00:00',1.23),('10318','2013-10-20','16:05:00',1.25),('10318','2013-10-20','16:10:00',1.25),('10318','2013-10-20','16:15:00',3.07),('10318','2013-10-20','16:20:00',3.64),('10318','2013-10-20','16:25:00',3.87),('10318','2013-10-20','16:30:00',3.68),('10318','2013-10-20','16:35:00',3.52),('10318','2013-10-20','16:40:00',3.24),('10318','2013-10-20','16:45:00',2.95),('10318','2013-10-20','16:50:00',2.63),('10318','2013-10-20','16:55:00',2.36),('10318','2013-10-20','17:00:00',2.21),('10318','2013-10-20','17:05:00',1.86),('10318','2013-10-20','17:10:00',1.55),('10318','2013-10-20','17:15:00',1.33),('10318','2013-10-20','17:20:00',1.13),('10318','2013-10-19','08:15:00',1.05),('10318','2013-10-19','08:20:00',1.93),('10318','2013-10-19','08:25:00',2.07),('10318','2013-10-19','08:30:00',2.49),('10318','2013-10-19','08:35:00',3.29),('10318','2013-10-19','08:40:00',3.62),('10318','2013-10-19','08:45:00',3.81),('10318','2013-10-19','08:50:00',4.1),('10318','2013-10-19','08:55:00',3.55),('10318','2013-10-19','09:00:00',4.4),('10318','2013-10-19','09:05:00',3.28),('10318','2013-10-19','09:10:00',4.7),('10318','2013-10-19','09:15:00',5.23),('10318','2013-10-19','09:20:00',5.38),('10318','2013-10-19','09:25:00',5.42),('10318','2013-10-19','09:30:00',5.4),('10318','2013-10-19','09:35:00',5.63),('10318','2013-10-19','09:40:00',5.85),('10318','2013-10-19','09:45:00',5.95),('10318','2013-10-19','09:50:00',6.29),('10318','2013-10-19','09:55:00',6.35),('10318','2013-10-19','10:00:00',6.36),('10318','2013-10-19','10:05:00',6.21),('10318','2013-10-19','10:10:00',6.76),('10318','2013-10-19','10:15:00',6.85),('10318','2013-10-19','10:20:00',7.13),('10318','2013-10-19','10:25:00',7.07),('10318','2013-10-19','10:30:00',7.2),('10318','2013-10-19','10:35:00',7.23),('10318','2013-10-19','10:40:00',7.19),('10318','2013-10-19','10:45:00',7.19),('10318','2013-10-19','10:50:00',7.33),('10318','2013-10-19','10:55:00',7.55),('10318','2013-10-19','11:00:00',6.52),('10318','2013-10-19','11:05:00',5.34),('10318','2013-10-19','11:10:00',2.88),('10318','2013-10-19','11:15:00',3.86),('10318','2013-10-19','11:20:00',8.64),('10318','2013-10-19','11:25:00',8.24),('10318','2013-10-19','11:30:00',8.11),('10318','2013-10-19','11:35:00',7.73),('10318','2013-10-19','11:40:00',7.53),('10318','2013-10-19','11:45:00',7.52),('10318','2013-10-19','11:50:00',6.79),('10318','2013-10-19','11:55:00',8.21),('10318','2013-10-19','12:00:00',8.06),('10318','2013-10-19','12:05:00',7.92),('10318','2013-10-19','12:10:00',7.85),('10318','2013-10-19','12:15:00',8.03),('10318','2013-10-19','12:20:00',7.42),('10318','2013-10-19','12:25:00',7.83),('10318','2013-10-19','12:30:00',7.7),('10318','2013-10-19','12:35:00',7.99),('10318','2013-10-19','12:40:00',8.21),('10318','2013-10-19','12:45:00',8.46),('10318','2013-10-19','12:50:00',8.04),('10318','2013-10-19','12:55:00',8.6),('10318','2013-10-19','13:00:00',6.74),('10318','2013-10-19','13:05:00',6.74),('10318','2013-10-19','13:10:00',7.82),('10318','2013-10-19','13:15:00',7.11),('10318','2013-10-19','13:20:00',7.83),('10318','2013-10-19','13:25:00',8.04),('10318','2013-10-19','13:30:00',6.72),('10318','2013-10-19','13:35:00',5.86),('10318','2013-10-19','13:40:00',6.21),('10318','2013-10-19','13:45:00',7.35),('10318','2013-10-19','13:50:00',8.01),('10318','2013-10-19','13:55:00',7.7),('10318','2013-10-19','14:00:00',6.69),('10318','2013-10-19','14:05:00',6.01),('10318','2013-10-19','14:10:00',5.65),('10318','2013-10-19','14:15:00',4.34),('10318','2013-10-19','14:20:00',4.59),('10318','2013-10-19','14:25:00',6.15),('10318','2013-10-19','14:30:00',6.97),('10318','2013-10-19','14:35:00',6.66),('10318','2013-10-19','14:40:00',5.72),('10318','2013-10-19','14:45:00',6.56),('10318','2013-10-19','14:50:00',6.15),('10318','2013-10-19','14:55:00',5.91),('10318','2013-10-19','15:00:00',5.77),('10318','2013-10-19','15:05:00',5.62),('10318','2013-10-19','15:10:00',5.55),('10318','2013-10-19','15:15:00',5.14),('10318','2013-10-19','15:20:00',5.05),('10318','2013-10-19','15:25:00',4.74),('10318','2013-10-19','15:30:00',4.66),('10318','2013-10-19','15:35:00',4.38),('10318','2013-10-19','15:40:00',3.71),('10318','2013-10-19','15:45:00',3.62),('10318','2013-10-19','15:50:00',4.05),('10318','2013-10-19','15:55:00',3.4),('10318','2013-10-19','16:00:00',3.91),('10318','2013-10-19','16:05:00',3.6),('10318','2013-10-19','16:10:00',3.68),('10318','2013-10-19','16:15:00',3.61),('10318','2013-10-19','16:20:00',2.39),('10318','2013-10-19','16:25:00',2.93),('10318','2013-10-19','16:30:00',3.24),('10318','2013-10-19','16:35:00',3.11),('10318','2013-10-19','16:40:00',2.97),('10318','2013-10-19','16:45:00',2.82),('10318','2013-10-19','16:50:00',2.42),('10318','2013-10-19','16:55:00',1.46),('10318','2013-10-19','17:00:00',1.2),('10318','2013-10-19','17:05:00',1.51),('10318','2013-10-19','17:15:00',1.48),('10318','2013-10-19','17:20:00',1.3),('10318','2014-05-04','07:15:00',1.37),('10318','2014-05-04','07:20:00',1.16),('10318','2014-05-04','07:25:00',1.63),('10318','2014-05-04','07:30:00',2.79),('10318','2014-05-04','07:35:00',1.79),('10318','2014-05-04','07:40:00',2.6),('10318','2014-05-04','07:45:00',3.71),('10318','2014-05-04','07:50:00',3.87),('10318','2014-05-04','07:55:00',4.07),('10318','2014-05-04','08:00:00',4.3),('10318','2014-05-04','08:05:00',4.58),('10318','2014-05-04','08:10:00',4.72),('10318','2014-05-04','08:15:00',4.81),('10318','2014-05-04','08:20:00',5.1),('10318','2014-05-04','08:25:00',5.19),('10318','2014-05-04','08:30:00',4.64),('10318','2014-05-04','08:35:00',2.8),('10318','2014-05-04','08:40:00',4.11),('10318','2014-05-04','08:45:00',5.3),('10318','2014-05-04','08:50:00',2.33),('10318','2014-05-04','08:55:00',2.45),('10318','2014-05-04','09:00:00',2.67),('10318','2014-05-04','09:05:00',3.76),('10318','2014-05-04','09:10:00',4.53),('10318','2014-05-04','09:15:00',5.18),('10318','2014-05-04','09:20:00',4.11),('10318','2014-05-04','09:25:00',9.24),('10318','2014-05-04','09:30:00',5.85),('10318','2014-05-04','09:35:00',2.7),('10318','2014-05-04','09:40:00',3.48),('10318','2014-05-04','09:45:00',6.05),('10318','2014-05-04','09:50:00',4.44),('10318','2014-05-04','09:55:00',9.41),('10318','2014-05-04','10:00:00',8.23),('10318','2014-05-04','10:05:00',7.59),('10318','2014-05-04','10:10:00',7.51),('10318','2014-05-04','10:15:00',4.57),('10318','2014-05-04','10:20:00',3.93),('10318','2014-05-04','10:25:00',3.81),('10318','2014-05-04','10:30:00',4.35),('10318','2014-05-04','10:35:00',4.1),('10318','2014-05-04','10:40:00',4.65),('10318','2014-05-04','10:45:00',5.4),('10318','2014-05-04','10:50:00',4.85),('10318','2014-05-04','10:55:00',5.28),('10318','2014-05-04','11:00:00',4.78),('10318','2014-05-04','11:05:00',7.72),('10318','2014-05-04','11:10:00',10.45),('10318','2014-05-04','11:15:00',10.77),('10318','2014-05-04','11:20:00',10.64),('10318','2014-05-04','11:25:00',10.4),('10318','2014-05-04','11:30:00',8.41),('10318','2014-05-04','11:35:00',9.1),('10318','2014-05-04','11:40:00',7.89),('10318','2014-05-04','11:45:00',6.85),('10318','2014-05-04','11:50:00',7.81),('10318','2014-05-04','11:55:00',10.23),('10318','2014-05-04','12:00:00',6.86),('10318','2014-05-04','12:05:00',5.15),('10318','2014-05-04','12:10:00',6.81),('10318','2014-05-04','12:15:00',5.62),('10318','2014-05-04','12:20:00',6.83),('10318','2014-05-04','12:25:00',6.89),('10318','2014-05-04','12:30:00',7.89),('10318','2014-05-04','12:35:00',8.43),('10318','2014-05-04','12:40:00',8.42),('10318','2014-05-04','12:45:00',6.57),('10318','2014-05-04','12:50:00',7.53),('10318','2014-05-04','12:55:00',4.58),('10318','2014-05-04','13:00:00',2.56),('10318','2014-05-04','13:05:00',2.85),('10318','2014-05-04','13:10:00',2.54),('10318','2014-05-04','13:15:00',2.4),('10318','2014-05-04','13:20:00',2.45),('10318','2014-05-04','13:25:00',2.55),('10318','2014-05-04','13:30:00',2.72),('10318','2014-05-04','13:35:00',3.03),('10318','2014-05-04','13:40:00',3.18),('10318','2014-05-04','13:45:00',3.04),('10318','2014-05-04','13:50:00',3.08),('10318','2014-05-04','13:55:00',3.2),('10318','2014-05-04','14:00:00',3.51),('10318','2014-05-04','14:05:00',3.46),('10318','2014-05-04','14:10:00',3.27),('10318','2014-05-04','14:15:00',2),('10318','2014-05-04','14:20:00',1.44),('10318','2014-05-04','14:25:00',1.34),('10318','2014-05-04','14:30:00',1.44),('10318','2014-05-04','14:35:00',1.67),('10318','2014-05-04','14:40:00',1.86),('10318','2014-05-04','14:45:00',2.17),('10318','2014-05-04','14:50:00',3.41),('10318','2014-05-04','14:55:00',4.63),('10318','2014-05-04','15:00:00',4.94),('10318','2014-05-04','15:05:00',4.5),('10318','2014-05-04','15:10:00',5.44),('10318','2014-05-04','15:15:00',4.92),('10318','2014-05-04','15:20:00',7.66),('10318','2014-05-04','15:25:00',8.7),('10318','2014-05-04','15:30:00',3.43),('10318','2014-05-04','15:35:00',2.22),('10318','2014-05-04','15:40:00',2.06),('10318','2014-05-04','15:45:00',2.4),('10318','2014-05-04','15:50:00',2.21),('10318','2014-05-04','15:55:00',2.16),('10318','2014-05-04','16:00:00',2.21),('10318','2014-05-04','16:05:00',2.34),('10318','2014-05-04','16:10:00',2.53),('10318','2014-05-04','16:15:00',2.31),('10318','2014-05-04','16:20:00',1.86),('10318','2014-05-04','16:25:00',1.42),('10318','2014-05-04','16:30:00',1.17),('10318','2014-05-04','16:35:00',1.01),('10318','2014-05-04','16:40:00',1.03),('10318','2014-05-04','16:45:00',1.05),('10318','2014-05-04','16:50:00',1.21),('10318','2014-05-04','16:55:00',1.23),('10318','2014-05-04','17:00:00',1.04),('10318','2014-05-04','17:20:00',1.43),('10318','2014-05-04','17:25:00',2.08),('10318','2014-05-04','17:30:00',2.64),('10318','2014-05-04','17:35:00',2.4),('10318','2014-05-04','17:40:00',2.05),('10318','2014-05-04','17:45:00',1.49),('10318','2014-05-04','17:50:00',1.23),('10318','2014-05-04','17:55:00',1.08),('10318','2014-05-04','18:00:00',1.18),('10318','2014-05-04','18:05:00',1.29),('10318','2014-05-04','18:10:00',1.19),('10318','2014-05-04','18:15:00',1.03),('10318','2014-05-04','18:20:00',1.03),('10318','2014-04-16','07:35:00',1.35),('10318','2014-04-16','07:40:00',2.05),('10318','2014-04-16','07:45:00',2.65),('10318','2014-04-16','07:50:00',2.99),('10318','2014-04-16','07:55:00',3.23),('10318','2014-04-16','08:00:00',3.52),('10318','2014-04-16','08:05:00',3.79),('10318','2014-04-16','08:10:00',4.06),('10318','2014-04-16','08:15:00',4.33),('10318','2014-04-16','08:20:00',4.54),('10318','2014-04-16','08:25:00',4.27),('10318','2014-04-16','08:30:00',2.63),('10318','2014-04-16','08:35:00',2.29),('10318','2014-04-16','08:40:00',2.73),('10318','2014-04-16','08:45:00',3.34),('10318','2014-04-16','08:50:00',5.66),('10318','2014-04-16','08:55:00',6.13),('10318','2014-04-16','09:00:00',6.3),('10318','2014-04-16','09:05:00',6.32),('10318','2014-04-16','09:10:00',6.6),('10318','2014-04-16','09:15:00',6.79),('10318','2014-04-16','09:20:00',6.96),('10318','2014-04-16','09:25:00',7.1),('10318','2014-04-16','09:30:00',4.28),('10318','2014-04-16','09:35:00',4.71),('10318','2014-04-16','09:40:00',2.09),('10318','2014-04-16','09:45:00',5.94),('10318','2014-04-16','09:50:00',4.97),('10318','2014-04-16','09:55:00',8.29),('10318','2014-04-16','10:00:00',8.44),('10318','2014-04-16','10:05:00',8.52),('10318','2014-04-16','10:10:00',8.56),('10318','2014-04-16','10:15:00',8.73),('10318','2014-04-16','10:20:00',8.94),('10318','2014-04-16','10:25:00',9.1),('10318','2014-04-16','10:30:00',9.21),('10318','2014-04-16','10:35:00',9.3),('10318','2014-04-16','10:40:00',9.4),('10318','2014-04-16','10:45:00',9.57),('10318','2014-04-16','10:50:00',9.79),('10318','2014-04-16','10:55:00',8.08),('10318','2014-04-16','11:00:00',5.32),('10318','2014-04-16','11:05:00',6.28),('10318','2014-04-16','11:10:00',5.74),('10318','2014-04-16','11:15:00',4.63),('10318','2014-04-16','11:20:00',8.71),('10318','2014-04-16','11:25:00',11.09),('10318','2014-04-16','11:30:00',11.01),('10318','2014-04-16','11:35:00',9.92),('10318','2014-04-16','11:40:00',8.38),('10318','2014-04-16','11:45:00',9.8),('10318','2014-04-16','11:50:00',10.81),('10318','2014-04-16','11:55:00',10.93),('10318','2014-04-16','12:00:00',9.76),('10318','2014-04-16','12:05:00',8.84),('10318','2014-04-16','12:10:00',8.43),('10318','2014-04-16','12:15:00',9.15),('10318','2014-04-16','12:20:00',5.5),('10318','2014-04-16','12:25:00',5.35),('10318','2014-04-16','12:30:00',2.44),('10318','2014-04-16','12:35:00',2.79),('10318','2014-04-16','12:40:00',2.47),('10318','2014-04-16','12:45:00',7.03),('10318','2014-04-16','12:50:00',9.48),('10318','2014-04-16','12:55:00',10.69),('10318','2014-04-16','13:00:00',9.55),('10318','2014-04-16','13:05:00',3.25),('10318','2014-04-16','13:10:00',2.24),('10318','2014-04-16','13:15:00',2.1),('10318','2014-04-16','13:20:00',2.99),('10318','2014-04-16','13:25:00',3.71),('10318','2014-04-16','13:30:00',2.69),('10318','2014-04-16','13:35:00',4.02),('10318','2014-04-16','13:40:00',9.06),('10318','2014-04-16','13:45:00',9.78),('10318','2014-04-16','13:50:00',10.46),('10318','2014-04-16','13:55:00',8.44),('10318','2014-04-16','14:00:00',4.02),('10318','2014-04-16','14:05:00',5.96),('10318','2014-04-16','14:10:00',8.8),('10318','2014-04-16','14:15:00',7.58),('10318','2014-04-16','14:20:00',5.83),('10318','2014-04-16','14:25:00',8.2),('10318','2014-04-16','14:30:00',9.81),('10318','2014-04-16','14:35:00',9.64),('10318','2014-04-16','14:40:00',9.3),('10318','2014-04-16','14:45:00',7.84),('10318','2014-04-16','14:50:00',5.75),('10318','2014-04-16','14:55:00',3.16),('10318','2014-04-16','15:00:00',8.42),('10318','2014-04-16','15:05:00',6.5),('10318','2014-04-16','15:10:00',6.98),('10318','2014-04-16','15:15:00',3.02),('10318','2014-04-16','15:20:00',1.58),('10318','2014-04-16','15:25:00',2.91),('10318','2014-04-16','15:30:00',5.88),('10318','2014-04-16','15:35:00',8.17),('10318','2014-04-16','15:40:00',7.96),('10318','2014-04-16','15:45:00',8.18),('10318','2014-04-16','15:50:00',4.21),('10318','2014-04-16','15:55:00',6.06),('10318','2014-04-16','16:00:00',7.16),('10318','2014-04-16','16:05:00',6.82),('10318','2014-04-16','16:10:00',6.57),('10318','2014-04-16','16:15:00',6.4),('10318','2014-04-16','16:20:00',6.24),('10318','2014-04-16','16:25:00',6.04),('10318','2014-04-16','16:30:00',5.85),('10318','2014-04-16','16:35:00',5.63),('10318','2014-04-16','16:40:00',5.39),('10318','2014-04-16','16:45:00',5.2),('10318','2014-04-16','16:50:00',4.99),('10318','2014-04-16','16:55:00',4.81),('10318','2014-04-16','17:00:00',4.58),('10318','2014-04-16','17:05:00',4.34),('10318','2014-04-16','17:10:00',4.13),('10318','2014-04-16','17:15:00',3.95),('10318','2014-04-16','17:20:00',3.72),('10318','2014-04-16','17:25:00',3.43),('10318','2014-04-16','17:30:00',3.32),('10318','2014-04-16','17:35:00',3.13),('10318','2014-04-16','17:40:00',2.91),('10318','2014-04-16','17:45:00',2.75),('10318','2014-04-16','17:50:00',2.57),('10318','2014-04-16','17:55:00',2.11),('10318','2014-04-16','18:00:00',2.31),('10318','2014-04-16','18:05:00',2.13),('10318','2014-04-16','18:10:00',2.03),('10318','2014-04-16','18:15:00',1.74),('10318','2014-04-16','18:20:00',1.51),('10318','2014-04-16','18:25:00',1.06),('10318','2014-04-16','18:30:00',1.19),('10318','2014-04-16','18:35:00',1.1),('10318','2014-04-16','18:40:00',1.05),('10318','2014-04-16','18:45:00',1.09),('10318','2014-04-16','18:50:00',1.09),('10318','2013-10-18','08:00:00',1.1),('10318','2013-10-18','08:05:00',1.3),('10318','2013-10-18','08:10:00',1.45),('10318','2013-10-18','08:15:00',1.55),('10318','2013-10-18','08:20:00',1.66),('10318','2013-10-18','08:25:00',1.79),('10318','2013-10-18','08:30:00',2.28),('10318','2013-10-18','08:35:00',2.9),('10318','2013-10-18','08:40:00',3.26),('10318','2013-10-18','08:45:00',3.52),('10318','2013-10-18','08:50:00',3.55),('10318','2013-10-18','08:55:00',3.7),('10318','2013-10-18','09:00:00',4.18),('10318','2013-10-18','09:05:00',4.49),('10318','2013-10-18','09:10:00',4.74),('10318','2013-10-18','09:15:00',4.76),('10318','2013-10-18','09:20:00',5.19),('10318','2013-10-18','09:25:00',5.23),('10318','2013-10-18','09:30:00',5.51),('10318','2013-10-18','09:35:00',5.68),('10318','2013-10-18','09:40:00',5.84),('10318','2013-10-18','09:45:00',5.96),('10318','2013-10-18','09:50:00',6.11),('10318','2013-10-18','09:55:00',6.24),('10318','2013-10-18','10:00:00',6.34),('10318','2013-10-18','10:05:00',6.53),('10318','2013-10-18','10:10:00',6.6),('10318','2013-10-18','10:15:00',6.7),('10318','2013-10-18','10:20:00',6.73),('10318','2013-10-18','10:25:00',6.88),('10318','2013-10-18','10:30:00',6.94),('10318','2013-10-18','10:35:00',7.04),('10318','2013-10-18','10:40:00',7.12),('10318','2013-10-18','10:45:00',7.18),('10318','2013-10-18','10:50:00',7.22),('10318','2013-10-18','10:55:00',7.31),('10318','2013-10-18','11:00:00',7.21),('10318','2013-10-18','11:05:00',6.8),('10318','2013-10-18','11:10:00',7.12),('10318','2013-10-18','11:15:00',7.3),('10318','2013-10-18','11:20:00',7.56),('10318','2013-10-18','11:25:00',7.54),('10318','2013-10-18','11:30:00',7.51),('10318','2013-10-18','11:35:00',7.71),('10318','2013-10-18','11:40:00',7.85),('10318','2013-10-18','11:45:00',7.65),('10318','2013-10-18','11:50:00',7.7),('10318','2013-10-18','11:55:00',7.77),('10318','2013-10-18','12:00:00',7.74),('10318','2013-10-18','12:05:00',7.75),('10318','2013-10-18','12:10:00',7.73),('10318','2013-10-18','12:15:00',7.5),('10318','2013-10-18','12:20:00',7.56),('10318','2013-10-18','12:25:00',7.78),('10318','2013-10-18','12:30:00',7.78),('10318','2013-10-18','12:35:00',7.61),('10318','2013-10-18','12:40:00',7.55),('10318','2013-10-18','12:45:00',7.38),('10318','2013-10-18','12:50:00',7.46),('10318','2013-10-18','12:55:00',7.51),('10318','2013-10-18','13:00:00',7.42),('10318','2013-10-18','13:05:00',7.18),('10318','2013-10-18','13:10:00',6.97),('10318','2013-10-18','13:15:00',7.27),('10318','2013-10-18','13:20:00',7.3),('10318','2013-10-18','13:25:00',7.37),('10318','2013-10-18','13:30:00',7.32),('10318','2013-10-18','13:35:00',7.22),('10318','2013-10-18','13:40:00',7.25),('10318','2013-10-18','13:45:00',7.06),('10318','2013-10-18','13:50:00',7.04),('10318','2013-10-18','13:55:00',6.82),('10318','2013-10-18','14:00:00',6.23),('10318','2013-10-18','14:05:00',6.55),('10318','2013-10-18','14:10:00',6.44),('10318','2013-10-18','14:15:00',6.58),('10318','2013-10-18','14:20:00',6.45),('10318','2013-10-18','14:25:00',6.35),('10318','2013-10-18','14:30:00',6.2),('10318','2013-10-18','14:35:00',5.97),('10318','2013-10-18','14:40:00',5.98),('10318','2013-10-18','14:45:00',5.72),('10318','2013-10-18','14:50:00',5.63),('10318','2013-10-18','14:55:00',5.59),('10318','2013-10-18','15:00:00',4.53),('10318','2013-10-18','15:05:00',4.64),('10318','2013-10-18','15:10:00',4.92),('10318','2013-10-18','15:15:00',4.95),('10318','2013-10-18','15:20:00',4.93),('10318','2013-10-18','15:25:00',4.63),('10318','2013-10-18','15:30:00',4.55),('10318','2013-10-18','15:35:00',4.41),('10318','2013-10-18','15:40:00',4.23),('10318','2013-10-18','15:45:00',3.65),('10318','2013-10-18','15:50:00',3.74),('10318','2013-10-18','15:55:00',3.54),('10318','2013-10-18','16:00:00',3.54),('10318','2013-10-18','16:05:00',3.36),('10318','2013-10-18','16:10:00',3.13),('10318','2013-10-18','16:15:00',2.8),('10318','2013-10-18','16:20:00',2.77),('10318','2013-10-18','16:25:00',2.29),('10318','2013-10-18','16:30:00',2.19),('10318','2013-10-18','16:35:00',2.01),('10318','2013-10-18','16:40:00',1.67),('10318','2013-10-18','16:45:00',1.53),('10318','2013-10-18','16:50:00',1.51),('10318','2013-10-18','16:55:00',1.74),('10318','2013-10-18','17:00:00',1.42),('10318','2013-10-18','17:05:00',1.3),('10318','2013-10-18','17:10:00',1.36),('10318','2013-10-18','17:15:00',1.12),('10318','2013-10-17','08:05:00',1.12),('10318','2013-10-17','08:10:00',1.33),('10318','2013-10-17','08:15:00',1.49),('10318','2013-10-17','08:20:00',1.67),('10318','2013-10-17','08:25:00',1.85),('10318','2013-10-17','08:30:00',2.77),('10318','2013-10-17','08:35:00',3.29),('10318','2013-10-17','08:40:00',3.49),('10318','2013-10-17','08:45:00',3.69),('10318','2013-10-17','08:50:00',3.9),('10318','2013-10-17','08:55:00',4.12),('10318','2013-10-17','09:00:00',4.23),('10318','2013-10-17','09:05:00',4.53),('10318','2013-10-17','09:10:00',4.71),('10318','2013-10-17','09:15:00',4.92),('10318','2013-10-17','09:20:00',5.1),('10318','2013-10-17','09:25:00',5.29),('10318','2013-10-17','09:30:00',5.45),('10318','2013-10-17','09:35:00',5.62),('10318','2013-10-17','09:40:00',5.76),('10318','2013-10-17','09:45:00',5.92),('10318','2013-10-17','09:50:00',6.05),('10318','2013-10-17','09:55:00',6.18),('10318','2013-10-17','10:00:00',6.31),('10318','2013-10-17','10:05:00',6.44),('10318','2013-10-17','10:10:00',6.59),('10318','2013-10-17','10:15:00',6.72),('10318','2013-10-17','10:20:00',6.81),('10318','2013-10-17','10:25:00',6.92),('10318','2013-10-17','10:30:00',7),('10318','2013-10-17','10:35:00',7.08),('10318','2013-10-17','10:40:00',7.19),('10318','2013-10-17','10:45:00',7.12),('10318','2013-10-17','10:50:00',7.36),('10318','2013-10-17','10:55:00',7.48),('10318','2013-10-17','11:00:00',7.56),('10318','2013-10-17','11:05:00',7.62),('10318','2013-10-17','11:10:00',7.68),('10318','2013-10-17','11:15:00',7.75),('10318','2013-10-17','11:20:00',7.78),('10318','2013-10-17','11:25:00',7.79),('10318','2013-10-17','11:30:00',7.83),('10318','2013-10-17','11:35:00',7.89),('10318','2013-10-17','11:40:00',7.93),('10318','2013-10-17','11:45:00',7.95),('10318','2013-10-17','11:50:00',7.95),('10318','2013-10-17','11:55:00',7.95),('10318','2013-10-17','12:00:00',7.77),('10318','2013-10-17','12:05:00',7.95),('10318','2013-10-17','12:10:00',7.98),('10318','2013-10-17','12:15:00',7.99),('10318','2013-10-17','12:20:00',7.96),('10318','2013-10-17','12:25:00',7.95),('10318','2013-10-17','12:30:00',7.82),('10318','2013-10-17','12:35:00',7.99),('10318','2013-10-17','12:40:00',8.03),('10318','2013-10-17','12:45:00',7.92),('10318','2013-10-17','12:50:00',7.9),('10318','2013-10-17','12:55:00',7.86),('10318','2013-10-17','13:00:00',7.73),('10318','2013-10-17','13:05:00',7.67),('10318','2013-10-17','13:10:00',7.65),('10318','2013-10-17','13:15:00',7.63),('10318','2013-10-17','13:20:00',7.59),('10318','2013-10-17','13:25:00',7.58),('10318','2013-10-17','13:30:00',7.52),('10318','2013-10-17','13:35:00',7.49),('10318','2013-10-17','13:40:00',7.4),('10318','2013-10-17','13:45:00',7.21),('10318','2013-10-17','13:50:00',7.2),('10318','2013-10-17','13:55:00',7.15),('10318','2013-10-17','14:00:00',7.08),('10318','2013-10-17','14:05:00',6.98),('10318','2013-10-17','14:10:00',6.86),('10318','2013-10-17','14:15:00',6.78),('10318','2013-10-17','14:20:00',6.75),('10318','2013-10-17','14:25:00',6.57),('10318','2013-10-17','14:30:00',6.47),('10318','2013-10-17','14:35:00',6.38),('10318','2013-10-17','14:40:00',6.27),('10318','2013-10-17','14:45:00',6.15),('10318','2013-10-17','14:50:00',6.04),('10318','2013-10-17','14:55:00',5.87),('10318','2013-10-17','15:00:00',5.71),('10318','2013-10-17','15:05:00',5.57),('10318','2013-10-17','15:10:00',5.45),('10318','2013-10-17','15:15:00',5.28),('10318','2013-10-17','15:20:00',5.16),('10318','2013-10-17','15:25:00',5.03),('10318','2013-10-17','15:30:00',4.8),('10318','2013-10-17','15:35:00',4.71),('10318','2013-10-17','15:40:00',4.55),('10318','2013-10-17','15:45:00',4.37),('10318','2013-10-17','15:50:00',4.18),('10318','2013-10-17','15:55:00',4.01),('10318','2013-10-17','16:00:00',3.85),('10318','2013-10-17','16:05:00',3.71),('10318','2013-10-17','16:10:00',3.57),('10318','2013-10-17','16:15:00',3.45),('10318','2013-10-17','16:20:00',3.29),('10318','2013-10-17','16:25:00',3.11),('10318','2013-10-17','16:30:00',2.92),('10318','2013-10-17','16:35:00',2.78),('10318','2013-10-17','16:40:00',2.64),('10318','2013-10-17','16:45:00',2.5),('10318','2013-10-17','16:50:00',2.36),('10318','2013-10-17','16:55:00',2.21),('10318','2013-10-17','17:00:00',2.04),('10318','2013-10-17','17:05:00',1.89),('10318','2013-10-17','17:10:00',1.67),('10318','2013-10-17','17:15:00',1.49),('10318','2013-10-17','17:20:00',1.33),('10318','2013-10-17','17:25:00',1.17),('10318','2013-10-16','08:30:00',1.22),('10318','2013-10-16','09:30:00',1.02),('10318','2013-10-16','09:35:00',1.21),('10318','2013-10-16','09:40:00',1.73),('10318','2013-10-16','09:45:00',3.95),('10318','2013-10-16','09:50:00',1.99),('10318','2013-10-16','09:55:00',2.02),('10318','2013-10-16','10:00:00',2.21),('10318','2013-10-16','10:05:00',1.02),('10318','2013-10-16','11:00:00',1.13),('10318','2013-10-16','11:05:00',2.63),('10318','2013-10-16','11:10:00',2.59),('10318','2013-10-16','11:15:00',2.98),('10318','2013-10-16','11:20:00',1.19),('10318','2013-10-16','11:25:00',1.39),('10318','2013-10-16','11:45:00',1.28),('10318','2013-10-16','11:50:00',2.01),('10318','2013-10-16','11:55:00',3.26),('10318','2013-10-16','12:00:00',1.08),('10318','2013-10-16','12:05:00',1.45),('10318','2013-10-16','12:10:00',6.43),('10318','2013-10-16','12:15:00',4.11),('10318','2013-10-16','12:20:00',4.57),('10318','2013-10-16','12:25:00',2.05),('10318','2013-10-16','12:30:00',2.59),('10318','2013-10-16','12:35:00',6.2),('10318','2013-10-16','12:40:00',5.35),('10318','2013-10-16','12:45:00',3.15),('10318','2013-10-16','12:50:00',2.32),('10318','2013-10-16','12:55:00',3.5),('10318','2013-10-16','13:00:00',5.15),('10318','2013-10-16','13:05:00',5.04),('10318','2013-10-16','13:10:00',7.02),('10318','2013-10-16','13:15:00',8.14),('10318','2013-10-16','13:20:00',7.08),('10318','2013-10-16','13:25:00',7.03),('10318','2013-10-16','13:30:00',7.07),('10318','2013-10-16','13:35:00',7.21),('10318','2013-10-16','13:40:00',6.1),('10318','2013-10-16','13:45:00',7.28),('10318','2013-10-16','13:50:00',7.45),('10318','2013-10-16','13:55:00',7.68),('10318','2013-10-16','14:00:00',5.27),('10318','2013-10-16','14:05:00',7.67),('10318','2013-10-16','14:10:00',7.18),('10318','2013-10-16','14:15:00',6.94),('10318','2013-10-16','14:20:00',6.19),('10318','2013-10-16','14:25:00',6.48),('10318','2013-10-16','14:30:00',6.38),('10318','2013-10-16','14:35:00',6.35),('10318','2013-10-16','14:40:00',4.45),('10318','2013-10-16','14:45:00',6.46),('10318','2013-10-16','14:50:00',6.55),('10318','2013-10-16','14:55:00',6.05),('10318','2013-10-16','15:00:00',5.98),('10318','2013-10-16','15:05:00',5.88),('10318','2013-10-16','15:10:00',5.92),('10318','2013-10-16','15:15:00',5.55),('10318','2013-10-16','15:20:00',3.8),('10318','2013-10-16','15:25:00',2.49),('10318','2013-10-16','15:30:00',4.95),('10318','2013-10-16','15:35:00',4.98),('10318','2013-10-16','15:40:00',4.52),('10318','2013-10-16','15:45:00',4.42),('10318','2013-10-16','15:50:00',4.26),('10318','2013-10-16','15:55:00',4.12),('10318','2013-10-16','16:00:00',3.95),('10318','2013-10-16','16:05:00',3.73),('10318','2013-10-16','16:10:00',3.62),('10318','2013-10-16','16:15:00',3.42),('10318','2013-10-16','16:20:00',3.28),('10318','2013-10-16','16:25:00',3.12),('10318','2013-10-16','16:30:00',3.01),('10318','2013-10-16','16:35:00',2.86),('10318','2013-10-16','16:40:00',2.67),('10318','2013-10-16','16:45:00',2.51),('10318','2013-10-16','16:50:00',2.34),('10318','2013-10-16','16:55:00',2.23),('10318','2013-10-16','17:00:00',2.07),('10318','2013-10-16','17:05:00',1.92),('10318','2013-10-16','17:10:00',1.75),('10318','2013-10-16','17:15:00',1.54),('10318','2013-10-16','17:20:00',1.38),('10318','2013-10-16','17:25:00',1.23),('10318','2013-10-16','17:30:00',1.05),('10318','2013-10-15','08:20:00',1.15),('10318','2013-10-15','08:25:00',1.29),('10318','2013-10-15','08:30:00',1.36),('10318','2013-10-15','08:35:00',1.44),('10318','2013-10-15','08:40:00',1.44),('10318','2013-10-15','08:45:00',1.36),('10318','2013-10-15','08:50:00',1.21),('10318','2013-10-15','08:55:00',1.39),('10318','2013-10-15','09:00:00',2.02),('10318','2013-10-15','09:05:00',2.18),('10318','2013-10-15','09:10:00',2.33),('10318','2013-10-15','09:15:00',2.23),('10318','2013-10-15','09:20:00',2.55),('10318','2013-10-15','09:25:00',3.5),('10318','2013-10-15','09:30:00',3.48),('10318','2013-10-15','09:35:00',3.45),('10318','2013-10-15','09:40:00',3.96),('10318','2013-10-15','09:45:00',5.55),('10318','2013-10-15','09:50:00',6.24),('10318','2013-10-15','09:55:00',6.07),('10318','2013-10-15','10:00:00',6.03),('10318','2013-10-15','10:05:00',6.02),('10318','2013-10-15','10:10:00',4.19),('10318','2013-10-15','10:15:00',2.88),('10318','2013-10-15','10:20:00',3.12),('10318','2013-10-15','10:25:00',5.07),('10318','2013-10-15','10:30:00',4.71),('10318','2013-10-15','10:35:00',4.58),('10318','2013-10-15','10:40:00',5.6),('10318','2013-10-15','10:45:00',5.99),('10318','2013-10-15','10:50:00',4.62),('10318','2013-10-15','10:55:00',4.6),('10318','2013-10-15','11:00:00',4.34),('10318','2013-10-15','11:05:00',5.51),('10318','2013-10-15','11:10:00',6.87),('10318','2013-10-15','11:15:00',6.7),('10318','2013-10-15','11:20:00',6.91),('10318','2013-10-15','11:25:00',6.27),('10318','2013-10-15','11:30:00',6.43),('10318','2013-10-15','11:35:00',5.18),('10318','2013-10-15','11:40:00',3.84),('10318','2013-10-15','11:45:00',3.48),('10318','2013-10-15','11:50:00',3.44),('10318','2013-10-15','11:55:00',3.21),('10318','2013-10-15','12:00:00',3.32),('10318','2013-10-15','12:05:00',3.15),('10318','2013-10-15','12:10:00',3.18),('10318','2013-10-15','12:15:00',3.06),('10318','2013-10-15','12:20:00',3.22),('10318','2013-10-15','12:25:00',2.87),('10318','2013-10-15','12:30:00',2.88),('10318','2013-10-15','12:35:00',2.89),('10318','2013-10-15','12:40:00',3.1),('10318','2013-10-15','12:45:00',3.22),('10318','2013-10-15','12:50:00',2.92),('10318','2013-10-15','12:55:00',2.69),('10318','2013-10-15','13:00:00',2.81),('10318','2013-10-15','13:05:00',3.96),('10318','2013-10-15','13:10:00',3.97),('10318','2013-10-15','13:15:00',4.8),('10318','2013-10-15','13:20:00',6.98),('10318','2013-10-15','13:25:00',6.15),('10318','2013-10-15','13:30:00',4.27),('10318','2013-10-15','13:35:00',3.48),('10318','2013-10-15','13:40:00',3.72),('10318','2013-10-15','13:45:00',3.58),('10318','2013-10-15','13:50:00',3.22),('10318','2013-10-15','13:55:00',2.76),('10318','2013-10-15','14:00:00',2.57),('10318','2013-10-15','14:05:00',2.63),('10318','2013-10-15','14:10:00',3),('10318','2013-10-15','14:15:00',4.45),('10318','2013-10-15','14:20:00',4.44),('10318','2013-10-15','14:25:00',5.48),('10318','2013-10-15','14:30:00',3.93),('10318','2013-10-15','14:35:00',3.49),('10318','2013-10-15','14:40:00',4.92),('10318','2013-10-15','14:45:00',5.39),('10318','2013-10-15','14:50:00',5.31),('10318','2013-10-15','14:55:00',3.45),('10318','2013-10-15','15:00:00',2.86),('10318','2013-10-15','15:05:00',3.13),('10318','2013-10-15','15:10:00',3.05),('10318','2013-10-15','15:15:00',2.67),('10318','2013-10-15','15:20:00',2.37),('10318','2013-10-15','15:25:00',2.15),('10318','2013-10-15','15:30:00',2.17),('10318','2013-10-15','15:35:00',2.3),('10318','2013-10-15','15:40:00',2.37),('10318','2013-10-15','15:45:00',2.21),('10318','2013-10-15','15:50:00',1.94),('10318','2013-10-15','15:55:00',1.71),('10318','2013-10-15','16:00:00',1.6),('10318','2013-10-15','16:05:00',1.66),('10318','2013-10-15','16:10:00',1.67),('10318','2013-10-15','16:15:00',1.58),('10318','2013-10-15','16:20:00',1.7),('10318','2013-10-15','16:25:00',2.19),('10318','2013-10-15','16:30:00',2.57),('10318','2013-10-15','16:35:00',2.41),('10318','2013-10-15','16:40:00',2.08),('10318','2013-10-15','16:45:00',1.64),('10318','2013-10-15','16:50:00',1.44),('10318','2013-10-15','16:55:00',1.6),('10318','2013-10-15','17:00:00',1.4),('10318','2013-10-15','17:05:00',1.26),('10318','2013-10-15','17:10:00',1.08),('10318','2013-10-14','08:00:00',1.07),('10318','2013-10-14','08:05:00',1.39),('10318','2013-10-14','08:10:00',1.47),('10318','2013-10-14','08:15:00',1.24),('10318','2013-10-14','08:20:00',1.93),('10318','2013-10-14','08:25:00',2.21),('10318','2013-10-14','08:30:00',2.88),('10318','2013-10-14','08:35:00',3.12),('10318','2013-10-14','08:40:00',2.83),('10318','2013-10-14','08:45:00',3.41),('10318','2013-10-14','08:50:00',3.14),('10318','2013-10-14','08:55:00',3.51),('10318','2013-10-14','09:00:00',3.13),('10318','2013-10-14','09:05:00',3.49),('10318','2013-10-14','09:10:00',2.31),('10318','2013-10-14','09:15:00',2.54),('10318','2013-10-14','09:20:00',3.74),('10318','2013-10-14','09:25:00',4.85),('10318','2013-10-14','09:30:00',5.41),('10318','2013-10-14','09:35:00',4.47),('10318','2013-10-14','09:40:00',4.64),('10318','2013-10-14','09:45:00',4.16),('10318','2013-10-14','09:50:00',5.21),('10318','2013-10-14','09:55:00',5.28),('10318','2013-10-14','10:00:00',5.78),('10318','2013-10-14','10:05:00',6.07),('10318','2013-10-14','10:10:00',6.29),('10318','2013-10-14','10:15:00',6.31),('10318','2013-10-14','10:20:00',6.46),('10318','2013-10-14','10:25:00',6.55),('10318','2013-10-14','10:30:00',6.64),('10318','2013-10-14','10:35:00',6.65),('10318','2013-10-14','10:40:00',6.47),('10318','2013-10-14','10:45:00',6.71),('10318','2013-10-14','10:50:00',6.93),('10318','2013-10-14','10:55:00',7),('10318','2013-10-14','11:00:00',7.07),('10318','2013-10-14','11:05:00',7.02),('10318','2013-10-14','11:10:00',7.32),('10318','2013-10-14','11:15:00',7.1),('10318','2013-10-14','11:20:00',7.28),('10318','2013-10-14','11:25:00',7.45),('10318','2013-10-14','11:30:00',7.55),('10318','2013-10-14','11:35:00',7.47),('10318','2013-10-14','11:40:00',7.42),('10318','2013-10-14','11:45:00',7.4),('10318','2013-10-14','11:50:00',7.44),('10318','2013-10-14','11:55:00',7.42),('10318','2013-10-14','12:00:00',7.4),('10318','2013-10-14','12:05:00',7.51),('10318','2013-10-14','12:10:00',7.65),('10318','2013-10-14','12:15:00',7.35),('10318','2013-10-14','12:20:00',6.81),('10318','2013-10-14','12:25:00',7.56),('10318','2013-10-14','12:30:00',7.64),('10318','2013-10-14','12:35:00',7.56),('10318','2013-10-14','12:40:00',7.55),('10318','2013-10-14','12:45:00',7.52),('10318','2013-10-14','12:50:00',7.47),('10318','2013-10-14','12:55:00',7.46),('10318','2013-10-14','13:00:00',7.4),('10318','2013-10-14','13:05:00',7.37),('10318','2013-10-14','13:10:00',7.33),('10318','2013-10-14','13:15:00',7.3),('10318','2013-10-14','13:20:00',7.24),('10318','2013-10-14','13:25:00',7.17),('10318','2013-10-14','13:30:00',7.08),('10318','2013-10-14','13:35:00',7.01),('10318','2013-10-14','13:40:00',6.96),('10318','2013-10-14','13:45:00',6.82),('10318','2013-10-14','13:50:00',6.83),('10318','2013-10-14','13:55:00',6.75),('10318','2013-10-14','14:00:00',6.69),('10318','2013-10-14','14:05:00',6.59),('10318','2013-10-14','14:10:00',6.49),('10318','2013-10-14','14:15:00',6.38),('10318','2013-10-14','14:20:00',6.31),('10318','2013-10-14','14:25:00',6.2),('10318','2013-10-14','14:30:00',6.1),('10318','2013-10-14','14:35:00',5.96),('10318','2013-10-14','14:40:00',5.88),('10318','2013-10-14','14:45:00',5.75),('10318','2013-10-14','14:50:00',5.64),('10318','2013-10-14','14:55:00',5.52),('10318','2013-10-14','15:00:00',5.38),('10318','2013-10-14','15:05:00',5.23),('10318','2013-10-14','15:10:00',5.05),('10318','2013-10-14','15:15:00',4.91),('10318','2013-10-14','15:20:00',4.79),('10318','2013-10-14','15:25:00',4.66),('10318','2013-10-14','15:30:00',4.46),('10318','2013-10-14','15:35:00',4.36),('10318','2013-10-14','15:40:00',3.85),('10318','2013-10-14','15:45:00',3.12),('10318','2013-10-14','15:50:00',3.82),('10318','2013-10-14','15:55:00',2.71),('10318','2013-10-14','16:00:00',2.87),('10318','2013-10-14','16:05:00',2.35),('10318','2013-10-14','16:10:00',2.3),('10318','2013-10-14','16:15:00',1.91),('10318','2013-10-14','16:20:00',2.22),('10318','2013-10-14','16:25:00',2.75),('10318','2013-10-14','16:30:00',1.59),('10318','2013-10-14','16:35:00',1.16),('10318','2013-10-14','16:40:00',1.37),('10318','2013-10-14','16:45:00',2.25),('10318','2013-10-14','16:50:00',1.48),('10318','2013-10-14','17:10:00',1.16),('10318','2013-10-14','17:15:00',1.11),('10318','2013-10-13','08:10:00',1.06),('10318','2013-10-13','08:15:00',1.13),('10318','2013-10-13','08:20:00',1.26),('10318','2013-10-13','08:25:00',1.47),('10318','2013-10-13','08:30:00',1.72),('10318','2013-10-13','08:35:00',2.03),('10318','2013-10-13','08:40:00',2.14),('10318','2013-10-13','08:45:00',2.19),('10318','2013-10-13','08:50:00',2.48),('10318','2013-10-13','08:55:00',3.01),('10318','2013-10-13','09:00:00',3.25),('10318','2013-10-13','09:05:00',3.04),('10318','2013-10-13','09:10:00',3.62),('10318','2013-10-13','09:15:00',4.88),('10318','2013-10-13','09:20:00',5.07),('10318','2013-10-13','09:25:00',3.87),('10318','2013-10-13','09:30:00',2.74),('10318','2013-10-13','09:35:00',3.54),('10318','2013-10-13','09:40:00',5.17),('10318','2013-10-13','09:45:00',6.38),('10318','2013-10-13','09:50:00',6.62),('10318','2013-10-13','09:55:00',6.2),('10318','2013-10-13','10:00:00',4.19),('10318','2013-10-13','10:05:00',4.13),('10318','2013-10-13','10:10:00',5.8),('10318','2013-10-13','10:15:00',5.4),('10318','2013-10-13','10:20:00',4.43),('10318','2013-10-13','10:25:00',4.77),('10318','2013-10-13','10:30:00',6.7),('10318','2013-10-13','10:35:00',7.98),('10318','2013-10-13','10:40:00',7.95),('10318','2013-10-13','10:45:00',8.11),('10318','2013-10-13','10:50:00',7.79),('10318','2013-10-13','10:55:00',6.42),('10318','2013-10-13','11:00:00',7.51),('10318','2013-10-13','11:05:00',5.44),('10318','2013-10-13','11:10:00',7.77),('10318','2013-10-13','11:15:00',7.6),('10318','2013-10-13','11:20:00',7.52),('10318','2013-10-13','11:25:00',7.4),('10318','2013-10-13','11:30:00',7.57),('10318','2013-10-13','11:35:00',7.45),('10318','2013-10-13','11:40:00',7.42),('10318','2013-10-13','11:45:00',7.47),('10318','2013-10-13','11:50:00',7.54),('10318','2013-10-13','11:55:00',7.42),('10318','2013-10-13','12:00:00',7.6),('10318','2013-10-13','12:05:00',7.61),('10318','2013-10-13','12:10:00',7.57),('10318','2013-10-13','12:15:00',7.64),('10318','2013-10-13','12:20:00',7.57),('10318','2013-10-13','12:25:00',7.3),('10318','2013-10-13','12:30:00',7.59),('10318','2013-10-13','12:35:00',7.62),('10318','2013-10-13','12:40:00',7.58),('10318','2013-10-13','12:45:00',7.47),('10318','2013-10-13','12:50:00',7.42),('10318','2013-10-13','12:55:00',7.35),('10318','2013-10-13','13:00:00',7.3),('10318','2013-10-13','13:05:00',7.32),('10318','2013-10-13','13:10:00',7.4),('10318','2013-10-13','13:15:00',7.49),('10318','2013-10-13','13:20:00',7.43),('10318','2013-10-13','13:25:00',6.43),('10318','2013-10-13','13:30:00',6.91),('10318','2013-10-13','13:35:00',6.58),('10318','2013-10-13','13:40:00',5.33),('10318','2013-10-13','13:45:00',6.09),('10318','2013-10-13','13:50:00',7.3),('10318','2013-10-13','13:55:00',5.11),('10318','2013-10-13','14:00:00',6.72),('10318','2013-10-13','14:05:00',6.91),('10318','2013-10-13','14:10:00',7.12),('10318','2013-10-13','14:15:00',5.84),('10318','2013-10-13','14:20:00',6.11),('10318','2013-10-13','14:25:00',6.99),('10318','2013-10-13','14:30:00',6.15),('10318','2013-10-13','14:35:00',4.55),('10318','2013-10-13','14:40:00',5.67),('10318','2013-10-13','14:45:00',4.56),('10318','2013-10-13','14:50:00',4.02),('10318','2013-10-13','14:55:00',4.28),('10318','2013-10-13','15:00:00',5.69),('10318','2013-10-13','15:05:00',5.37),('10318','2013-10-13','15:10:00',4.12),('10318','2013-10-13','15:15:00',3.93),('10318','2013-10-13','15:20:00',4.8),('10318','2013-10-13','15:25:00',3.92),('10318','2013-10-13','15:30:00',3.94),('10318','2013-10-13','15:35:00',3.51),('10318','2013-10-13','15:40:00',3.09),('10318','2013-10-13','15:45:00',2.82),('10318','2013-10-13','15:50:00',3.01),('10318','2013-10-13','15:55:00',3.04),('10318','2013-10-13','16:00:00',3.53),('10318','2013-10-13','16:05:00',3.46),('10318','2013-10-13','16:10:00',3.11),('10318','2013-10-13','16:15:00',3.02),('10318','2013-10-13','16:20:00',3.27),('10318','2013-10-13','16:25:00',3.36),('10318','2013-10-13','16:30:00',3.25),('10318','2013-10-13','16:35:00',3.01),('10318','2013-10-13','16:40:00',2),('10318','2013-10-13','16:45:00',1.86),('10318','2013-10-13','16:50:00',2),('10318','2013-10-13','16:55:00',1.47),('10318','2013-10-13','17:00:00',1.13),('10318','2013-10-13','17:05:00',1.08),('10318','2013-10-13','17:15:00',1.11),('10318','2013-10-13','17:20:00',1.53),('10318','2013-10-13','17:25:00',1.73),('10318','2013-10-13','17:30:00',1.23),('10318','2013-10-13','17:35:00',1.3),('10318','2013-10-13','17:40:00',1.05),('10318','2013-10-12','10:40:00',1.13),('10318','2013-10-12','10:45:00',1.24),('10318','2013-10-12','10:50:00',1.31),('10318','2013-10-12','10:55:00',1.47),('10318','2013-10-12','11:00:00',1.67),('10318','2013-10-12','11:05:00',1.73),('10318','2013-10-12','11:10:00',1.85),('10318','2013-10-12','11:15:00',2.11),('10318','2013-10-12','11:20:00',2.47),('10318','2013-10-12','11:25:00',2.65),('10318','2013-10-12','11:30:00',3.45),('10318','2013-10-12','11:35:00',5.72),('10318','2013-10-12','11:40:00',5.45),('10318','2013-10-12','11:45:00',3.21),('10318','2013-10-12','11:50:00',3.16),('10318','2013-10-12','11:55:00',2.45),('10318','2013-10-12','12:00:00',1.66),('10318','2013-10-12','12:05:00',1.49),('10318','2013-10-12','12:10:00',1.98),('10318','2013-10-12','12:15:00',2.72),('10318','2013-10-12','12:20:00',6.14),('10318','2013-10-12','12:25:00',6.68),('10318','2013-10-12','12:30:00',5.97),('10318','2013-10-12','12:35:00',6.81),('10318','2013-10-12','12:40:00',8.24),('10318','2013-10-12','12:45:00',6.77),('10318','2013-10-12','12:50:00',7.19),('10318','2013-10-12','12:55:00',5.78),('10318','2013-10-12','13:00:00',5.31),('10318','2013-10-12','13:05:00',1.72),('10318','2013-10-12','13:10:00',1.66),('10318','2013-10-12','13:15:00',2.7),('10318','2013-10-12','13:20:00',2.88),('10318','2013-10-12','13:25:00',4.38),('10318','2013-10-12','13:30:00',7.84),('10318','2013-10-12','13:35:00',2.07),('10318','2013-10-12','13:50:00',1.06),('10318','2013-10-12','13:55:00',1.71),('10318','2013-10-12','14:00:00',1.29),('10318','2013-10-12','15:05:00',1.22),('10318','2013-10-12','15:10:00',1.32),('10318','2013-10-12','15:15:00',1.49),('10318','2013-10-12','15:20:00',1.64),('10318','2013-10-12','15:25:00',1.82),('10318','2013-10-12','15:30:00',1.86),('10318','2013-10-12','15:35:00',1.71),('10318','2013-10-12','15:40:00',1.54),('10318','2013-10-12','15:45:00',1.52),('10318','2013-10-12','15:50:00',1.71),('10318','2013-10-12','15:55:00',2.1),('10318','2013-10-12','16:00:00',2.35),('10318','2013-10-12','16:05:00',2.3),('10318','2013-10-12','16:10:00',2.44),('10318','2013-10-12','16:15:00',3.43),('10318','2013-10-12','16:20:00',3.39),('10318','2013-10-12','16:25:00',2.76),('10318','2013-10-12','16:30:00',2.17),('10318','2013-10-12','16:35:00',1.24),('10318','2013-10-12','17:00:00',1.81),('10318','2013-10-12','17:05:00',1.04),('10318','2013-10-12','17:20:00',1.03),('10318','2013-10-12','17:25:00',1.36),('10318','2013-10-11','08:05:00',1.13),('10318','2013-10-11','08:10:00',1.48),('10318','2013-10-11','08:15:00',1.63),('10318','2013-10-11','08:20:00',1.82),('10318','2013-10-11','08:25:00',2.48),('10318','2013-10-11','08:30:00',2.93),('10318','2013-10-11','08:35:00',3.29),('10318','2013-10-11','08:40:00',3.47),('10318','2013-10-11','08:45:00',2.77),('10318','2013-10-11','08:50:00',2.72),('10318','2013-10-11','08:55:00',2.67),('10318','2013-10-11','09:00:00',4.28),('10318','2013-10-11','09:05:00',4.06),('10318','2013-10-11','09:10:00',4.37),('10318','2013-10-11','09:15:00',4.73),('10318','2013-10-11','09:20:00',5),('10318','2013-10-11','09:25:00',5.18),('10318','2013-10-11','09:30:00',5.47),('10318','2013-10-11','09:35:00',5.64),('10318','2013-10-11','09:40:00',5.81),('10318','2013-10-11','09:45:00',5.97),('10318','2013-10-11','09:50:00',6.1),('10318','2013-10-11','09:55:00',6.23),('10318','2013-10-11','10:00:00',6.43),('10318','2013-10-11','10:05:00',6.21),('10318','2013-10-11','10:10:00',5.57),('10318','2013-10-11','10:15:00',5.56),('10318','2013-10-11','10:20:00',5.43),('10318','2013-10-11','10:25:00',7.08),('10318','2013-10-11','10:30:00',6.48),('10318','2013-10-11','10:35:00',8.27),('10318','2013-10-11','10:40:00',9.44),('10318','2013-10-11','10:45:00',7.64),('10318','2013-10-11','10:50:00',1.9),('10318','2013-10-11','10:55:00',1.74),('10318','2013-10-11','11:00:00',2.63),('10318','2013-10-11','11:05:00',2.17),('10318','2013-10-11','11:10:00',2.58),('10318','2013-10-11','11:15:00',1.88),('10318','2013-10-11','11:20:00',2.05),('10318','2013-10-11','11:25:00',1.37),('10318','2013-10-11','11:30:00',1.17),('10318','2013-10-11','11:35:00',1.43),('10318','2013-10-11','11:40:00',4.25),('10318','2013-10-11','11:45:00',2.93),('10318','2013-10-11','11:50:00',3.07),('10318','2013-10-11','11:55:00',3.25),('10318','2013-10-11','12:00:00',3.24),('10318','2013-10-11','12:05:00',6.2),('10318','2013-10-11','12:10:00',5.72),('10318','2013-10-11','12:15:00',3.04),('10318','2013-10-11','12:20:00',5.52),('10318','2013-10-11','12:25:00',4.94),('10318','2013-10-11','12:30:00',3.88),('10318','2013-10-11','12:35:00',1.29),('10318','2013-10-11','13:05:00',1.11),('10318','2013-10-11','13:10:00',3),('10318','2013-10-11','13:15:00',3.95),('10318','2013-10-11','13:20:00',1.83),('10318','2013-10-11','13:25:00',2.27),('10318','2013-10-11','13:30:00',6.76),('10318','2013-10-11','13:35:00',2.37),('10318','2013-10-11','13:40:00',6.48),('10318','2013-10-11','13:45:00',9.23),('10318','2013-10-11','13:50:00',2.35),('10318','2013-10-11','13:55:00',1.31),('10318','2013-10-11','14:00:00',1.03),('10318','2013-10-11','14:05:00',1.13),('10318','2013-10-11','15:25:00',1.11),('10318','2013-10-11','15:30:00',4.62),('10318','2013-10-11','15:35:00',3.24),('10318','2013-10-11','15:40:00',4.3),('10318','2013-10-11','15:45:00',2.04),('10318','2013-10-11','15:50:00',1.56),('10318','2013-10-11','15:55:00',1.84),('10318','2013-10-11','16:00:00',1.52),('10318','2013-10-11','16:05:00',1.68),('10318','2013-10-11','16:10:00',1.61),('10318','2013-10-11','16:15:00',1.73),('10318','2013-10-11','16:20:00',1.18),('10318','2013-10-11','16:30:00',1.81),('10318','2013-10-11','16:35:00',1.91),('10318','2013-10-11','16:40:00',1.03),('10318','2013-10-11','17:00:00',1.2),('10318','2013-10-11','17:05:00',2.53),('10318','2013-10-11','17:10:00',1.56),('10318','2013-10-11','17:15:00',2.45),('10318','2013-10-11','17:20:00',1.3),('10318','2013-10-10','08:00:00',1.07),('10318','2013-10-10','08:05:00',1.23),('10318','2013-10-10','08:10:00',1.36),('10318','2013-10-10','08:15:00',1.59),('10318','2013-10-10','08:20:00',1.97),('10318','2013-10-10','08:25:00',2.85),('10318','2013-10-10','08:30:00',3.25),('10318','2013-10-10','08:35:00',3.37),('10318','2013-10-10','08:40:00',1.92),('10318','2013-10-10','08:45:00',1.05),('10318','2013-10-10','08:50:00',2.03),('10318','2013-10-10','08:55:00',3.12),('10318','2013-10-10','09:00:00',4.6),('10318','2013-10-10','09:05:00',4.05),('10318','2013-10-10','09:10:00',4.85),('10318','2013-10-10','09:15:00',4.68),('10318','2013-10-10','09:20:00',5.06),('10318','2013-10-10','09:25:00',5.3),('10318','2013-10-10','09:30:00',5.43),('10318','2013-10-10','09:35:00',5.57),('10318','2013-10-10','09:40:00',5.81),('10318','2013-10-10','09:45:00',5.94),('10318','2013-10-10','09:50:00',6.09),('10318','2013-10-10','09:55:00',6.28),('10318','2013-10-10','10:00:00',6.33),('10318','2013-10-10','10:05:00',6.44),('10318','2013-10-10','10:10:00',6.92),('10318','2013-10-10','10:15:00',6.87),('10318','2013-10-10','10:20:00',7.03),('10318','2013-10-10','10:25:00',5.54),('10318','2013-10-10','10:30:00',7.36),('10318','2013-10-10','10:35:00',7.53),('10318','2013-10-10','10:40:00',7.72),('10318','2013-10-10','10:45:00',8.07),('10318','2013-10-10','10:50:00',8.22),('10318','2013-10-10','10:55:00',8.46),('10318','2013-10-10','11:00:00',8.45),('10318','2013-10-10','11:05:00',8.56),('10318','2013-10-10','11:10:00',8.15),('10318','2013-10-10','11:15:00',8.08),('10318','2013-10-10','11:20:00',3.23),('10318','2013-10-10','11:25:00',4.83),('10318','2013-10-10','11:30:00',6.53),('10318','2013-10-10','11:35:00',9.1),('10318','2013-10-10','11:40:00',8.62),('10318','2013-10-10','11:45:00',8.21),('10318','2013-10-10','11:50:00',4.66),('10318','2013-10-10','11:55:00',9.29),('10318','2013-10-10','12:00:00',9.23),('10318','2013-10-10','12:05:00',3.9),('10318','2013-10-10','12:10:00',4.69),('10318','2013-10-10','12:15:00',6.24),('10318','2013-10-10','12:20:00',9.43),('10318','2013-10-10','12:25:00',9.74),('10318','2013-10-10','12:30:00',8.28),('10318','2013-10-10','12:35:00',6.89),('10318','2013-10-10','12:40:00',9.55),('10318','2013-10-10','12:45:00',7.74),('10318','2013-10-10','12:50:00',7.69),('10318','2013-10-10','12:55:00',5.7),('10318','2013-10-10','13:00:00',2.84),('10318','2013-10-10','13:05:00',5.8),('10318','2013-10-10','13:10:00',6.44),('10318','2013-10-10','13:15:00',2.21),('10318','2013-10-10','13:20:00',4.04),('10318','2013-10-10','13:25:00',2.6),('10318','2013-10-10','13:30:00',3.68),('10318','2013-10-10','13:35:00',2.54),('10318','2013-10-10','13:40:00',6.21),('10318','2013-10-10','13:45:00',5.8),('10318','2013-10-10','13:50:00',6.86),('10318','2013-10-10','13:55:00',5.25),('10318','2013-10-10','14:00:00',5.78),('10318','2013-10-10','14:05:00',5.8),('10318','2013-10-10','14:10:00',2.02),('10318','2013-10-10','14:15:00',2.82),('10318','2013-10-10','14:20:00',4.03),('10318','2013-10-10','14:25:00',3.92),('10318','2013-10-10','14:30:00',2.23),('10318','2013-10-10','14:35:00',7.29),('10318','2013-10-10','14:40:00',6.52),('10318','2013-10-10','14:45:00',5.25),('10318','2013-10-10','14:50:00',6.89),('10318','2013-10-10','14:55:00',5.85),('10318','2013-10-10','15:00:00',2.28),('10318','2013-10-10','15:05:00',2.03),('10318','2013-10-10','15:10:00',3.24),('10318','2013-10-10','15:15:00',4.17),('10318','2013-10-10','15:20:00',1.79),('10318','2013-10-10','15:25:00',1.88),('10318','2013-10-10','15:30:00',3.47),('10318','2013-10-10','15:35:00',1.93),('10318','2013-10-10','15:40:00',3.72),('10318','2013-10-10','15:45:00',5.48),('10318','2013-10-10','15:50:00',3.76),('10318','2013-10-10','15:55:00',2.55),('10318','2013-10-10','16:00:00',3.75),('10318','2013-10-10','16:05:00',5.44),('10318','2013-10-10','16:10:00',5.28),('10318','2013-10-10','16:15:00',3.78),('10318','2013-10-10','16:20:00',1.76),('10318','2013-10-10','16:25:00',2.38),('10318','2013-10-10','16:30:00',2.01),('10318','2013-10-10','16:35:00',3.01),('10318','2013-10-10','16:40:00',1.17),('10318','2013-10-10','16:45:00',1.28),('10318','2013-10-10','16:55:00',1.39),('10318','2013-10-10','17:00:00',1.92),('10318','2013-10-10','17:15:00',1.36),('10318','2013-10-10','17:20:00',1.18),('10318','2013-10-09','08:05:00',1.1),('10318','2013-10-09','08:10:00',1.41),('10318','2013-10-09','08:20:00',1.13),('10318','2013-10-09','08:25:00',3.11),('10318','2013-10-09','08:30:00',3.44),('10318','2013-10-09','08:35:00',3.2),('10318','2013-10-09','08:40:00',3.53),('10318','2013-10-09','08:45:00',3.55),('10318','2013-10-09','08:50:00',4.13),('10318','2013-10-09','08:55:00',4.34),('10318','2013-10-09','09:00:00',4.51),('10318','2013-10-09','09:05:00',4.76),('10318','2013-10-09','09:10:00',5),('10318','2013-10-09','09:15:00',4.1),('10318','2013-10-09','09:20:00',5.24),('10318','2013-10-09','09:25:00',5.44),('10318','2013-10-09','09:30:00',5.82),('10318','2013-10-09','09:35:00',6.07),('10318','2013-10-09','09:40:00',6.36),('10318','2013-10-09','09:45:00',6.46),('10318','2013-10-09','09:50:00',6.18),('10318','2013-10-09','09:55:00',6.45),('10318','2013-10-09','10:00:00',6.88),('10318','2013-10-09','10:05:00',5.07),('10318','2013-10-09','10:10:00',2.75),('10318','2013-10-09','10:15:00',2.23),('10318','2013-10-09','10:20:00',1.99),('10318','2013-10-09','10:25:00',2.19),('10318','2013-10-09','10:30:00',2.3),('10318','2013-10-09','10:35:00',1.99),('10318','2013-10-09','10:40:00',2.48),('10318','2013-10-09','10:45:00',4.23),('10318','2013-10-09','10:50:00',4.38),('10318','2013-10-09','10:55:00',8.4),('10318','2013-10-09','11:00:00',2.42),('10318','2013-10-09','11:05:00',1.99),('10318','2013-10-09','11:10:00',3.67),('10318','2013-10-09','11:15:00',6.44),('10318','2013-10-09','11:20:00',2.6),('10318','2013-10-09','11:25:00',4.3),('10318','2013-10-09','11:30:00',2.34),('10318','2013-10-09','11:35:00',2.01),('10318','2013-10-09','11:40:00',3.09),('10318','2013-10-09','11:45:00',3.94),('10318','2013-10-09','11:50:00',7.24),('10318','2013-10-09','11:55:00',9.24),('10318','2013-10-09','12:00:00',8.28),('10318','2013-10-09','12:05:00',6.86),('10318','2013-10-09','12:10:00',5.6),('10318','2013-10-09','12:15:00',5.53),('10318','2013-10-09','12:20:00',6.24),('10318','2013-10-09','12:25:00',5.1),('10318','2013-10-09','12:30:00',4.36),('10318','2013-10-09','12:35:00',4.11),('10318','2013-10-09','12:40:00',2.66),('10318','2013-10-09','12:45:00',1.64),('10318','2013-10-09','12:50:00',1.51),('10318','2013-10-09','12:55:00',1.31),('10318','2013-10-09','13:00:00',1.35),('10318','2013-10-09','13:05:00',1.41),('10318','2013-10-09','13:10:00',1.66),('10318','2013-10-09','13:15:00',5.59),('10318','2013-10-09','13:20:00',7.75),('10318','2013-10-09','13:25:00',3.42),('10318','2013-10-09','13:30:00',2.55),('10318','2013-10-09','13:35:00',3.91),('10318','2013-10-09','13:40:00',6.54),('10318','2013-10-09','13:45:00',6.64),('10318','2013-10-09','13:50:00',4.76),('10318','2013-10-09','13:55:00',3.43),('10318','2013-10-09','14:00:00',3),('10318','2013-10-09','14:05:00',7.27),('10318','2013-10-09','14:10:00',6.73),('10318','2013-10-09','14:15:00',5.03),('10318','2013-10-09','14:20:00',1.21),('10318','2013-10-09','14:25:00',1.4),('10318','2013-10-09','14:30:00',1.6),('10318','2013-10-09','14:35:00',1.59),('10318','2013-10-09','14:40:00',1.32),('10318','2013-10-09','14:45:00',1.73),('10318','2013-10-09','14:50:00',5.72),('10318','2013-10-09','14:55:00',6.65),('10318','2013-10-09','15:00:00',7.02),('10318','2013-10-09','15:05:00',6.48),('10318','2013-10-09','15:10:00',6.54),('10318','2013-10-09','15:15:00',6.41),('10318','2013-10-09','15:20:00',6.37),('10318','2013-10-09','15:25:00',6.07),('10318','2013-10-09','15:30:00',5.12),('10318','2013-10-09','15:35:00',2.51),('10318','2013-10-09','15:40:00',1.89),('10318','2013-10-09','15:45:00',4.29),('10318','2013-10-09','15:50:00',2.67),('10318','2013-10-09','15:55:00',2.83),('10318','2013-10-09','16:00:00',3.68),('10318','2013-10-09','16:05:00',2.08),('10318','2013-10-09','16:10:00',2.11),('10318','2013-10-09','16:15:00',3.24),('10318','2013-10-09','16:20:00',2.89),('10318','2013-10-09','16:25:00',2.13),('10318','2013-10-09','16:30:00',2.76),('10318','2013-10-09','16:35:00',2.47),('10318','2013-10-09','16:40:00',3.04),('10318','2013-10-09','16:45:00',2.5),('10318','2013-10-09','17:25:00',1.23),('10318','2013-10-09','17:30:00',1.63),('10318','2013-10-09','17:35:00',1.88),('10318','2013-10-09','17:40:00',1.37),('10318','2013-10-09','17:45:00',1.31),('10318','2014-04-15','07:55:00',1.63),('10318','2014-04-15','08:00:00',1.6),('10318','2014-04-15','08:05:00',1.14),('10318','2014-04-15','08:50:00',1.44),('10318','2014-04-15','08:55:00',3.36),('10318','2014-04-15','09:00:00',3.9),('10318','2014-04-15','09:05:00',6.31),('10318','2014-04-15','09:10:00',6.47),('10318','2014-04-15','09:15:00',5.59),('10318','2014-04-15','09:20:00',6.72),('10318','2014-04-15','09:25:00',6.63),('10318','2014-04-15','09:30:00',5.16),('10318','2014-04-15','09:35:00',2.31),('10318','2014-04-15','09:40:00',1.97),('10318','2014-04-15','09:45:00',3.05),('10318','2014-04-15','09:50:00',2.18),('10318','2014-04-15','09:55:00',1.74),('10318','2014-04-15','10:00:00',2.88),('10318','2014-04-15','10:05:00',4.02),('10318','2014-04-15','10:10:00',4),('10318','2014-04-15','10:15:00',5.9),('10318','2014-04-15','10:20:00',6.05),('10318','2014-04-15','10:25:00',4.16),('10318','2014-04-15','10:30:00',7.68),('10318','2014-04-15','10:35:00',4.26),('10318','2014-04-15','10:40:00',4.44),('10318','2014-04-15','10:45:00',8.49),('10318','2014-04-15','10:50:00',5.15),('10318','2014-04-15','10:55:00',3.36),('10318','2014-04-15','11:00:00',6.37),('10318','2014-04-15','11:05:00',6.48),('10318','2014-04-15','11:10:00',5.25),('10318','2014-04-15','11:15:00',3.86),('10318','2014-04-15','11:20:00',3.33),('10318','2014-04-15','11:25:00',4.61),('10318','2014-04-15','11:30:00',2.92),('10318','2014-04-15','11:35:00',2.36),('10318','2014-04-15','11:40:00',1.56),('10318','2014-04-15','11:45:00',2.23),('10318','2014-04-15','11:50:00',2.56),('10318','2014-04-15','11:55:00',2.03),('10318','2014-04-15','12:00:00',1.34),('10318','2014-04-15','12:05:00',2.42),('10318','2014-04-15','12:10:00',3.31),('10318','2014-04-15','12:15:00',4.4),('10318','2014-04-15','12:20:00',3.09),('10318','2014-04-15','12:25:00',1.88),('10318','2014-04-15','12:30:00',1.52),('10318','2014-04-15','12:35:00',1.62),('10318','2014-04-15','12:40:00',1.28),('10318','2014-04-15','13:05:00',1.23),('10318','2014-04-15','13:10:00',2.58),('10318','2014-04-15','13:15:00',4.46),('10318','2014-04-15','13:20:00',4.34),('10318','2014-04-15','13:25:00',2.97),('10318','2014-04-15','13:30:00',2.6),('10318','2014-04-15','13:35:00',5.96),('10318','2014-04-15','13:40:00',4.48),('10318','2014-04-15','13:45:00',2.5),('10318','2014-04-15','13:50:00',3.12),('10318','2014-04-15','13:55:00',3.83),('10318','2014-04-15','14:00:00',7),('10318','2014-04-15','14:05:00',5.9),('10318','2014-04-15','14:10:00',6.59),('10318','2014-04-15','14:15:00',6.01),('10318','2014-04-15','14:20:00',5.77),('10318','2014-04-15','14:25:00',3.85),('10318','2014-04-15','14:30:00',4.28),('10318','2014-04-15','14:35:00',7.01),('10318','2014-04-15','14:40:00',7.1),('10318','2014-04-15','14:45:00',7.67),('10318','2014-04-15','14:50:00',7.13),('10318','2014-04-15','14:55:00',7.34),('10318','2014-04-15','15:00:00',4.24),('10318','2014-04-15','15:05:00',4.95),('10318','2014-04-15','15:10:00',6.83),('10318','2014-04-15','15:15:00',8.66),('10318','2014-04-15','15:20:00',8.71),('10318','2014-04-15','15:25:00',4.96),('10318','2014-04-15','15:30:00',4.55),('10318','2014-04-15','15:35:00',3.84),('10318','2014-04-15','15:40:00',3.45),('10318','2014-04-15','15:45:00',3.56),('10318','2014-04-15','15:50:00',3.8),('10318','2014-04-15','15:55:00',3.23),('10318','2014-04-15','16:00:00',3.16),('10318','2014-04-15','16:05:00',2.7),('10318','2014-04-15','16:10:00',1.89),('10318','2014-04-15','16:15:00',1.49),('10318','2014-04-15','16:20:00',1.12),('10318','2013-10-08','08:00:00',1.25),('10318','2013-10-08','08:05:00',2.07),('10318','2013-10-08','08:10:00',2.62),('10318','2013-10-08','08:15:00',2.8),('10318','2013-10-08','08:20:00',2.66),('10318','2013-10-08','08:25:00',1.54),('10318','2013-10-08','08:30:00',1.53),('10318','2013-10-08','09:25:00',1.01),('10318','2013-10-08','09:45:00',1.1),('10318','2013-10-08','09:50:00',1.26),('10318','2013-10-08','09:55:00',2.04),('10318','2013-10-08','10:00:00',2.94),('10318','2013-10-08','10:05:00',2.52),('10318','2013-10-08','10:10:00',3.63),('10318','2013-10-08','10:15:00',3.71),('10318','2013-10-08','10:20:00',1.4),('10318','2013-10-08','10:25:00',1.05),('10318','2013-10-08','10:55:00',1.4),('10318','2013-10-08','11:00:00',1.81),('10318','2013-10-08','11:05:00',1.69),('10318','2013-10-08','11:10:00',1.7),('10318','2013-10-08','11:15:00',3.13),('10318','2013-10-08','11:20:00',8.11),('10318','2013-10-08','11:25:00',8.07),('10318','2013-10-08','11:30:00',4.41),('10318','2013-10-08','11:35:00',2.48),('10318','2013-10-08','11:40:00',2.81),('10318','2013-10-08','11:45:00',1.85),('10318','2013-10-08','11:50:00',1.03),('10318','2013-10-08','12:05:00',1.02),('10318','2013-10-08','12:10:00',1.6),('10318','2013-10-08','12:15:00',1.46),('10318','2013-10-08','12:20:00',2.94),('10318','2013-10-08','12:25:00',3.58),('10318','2013-10-08','12:30:00',5.27),('10318','2013-10-08','12:35:00',3.97),('10318','2013-10-08','12:40:00',3.62),('10318','2013-10-08','12:45:00',5.97),('10318','2013-10-08','12:50:00',8.35),('10318','2013-10-08','12:55:00',9.77),('10318','2013-10-08','13:00:00',7.83),('10318','2013-10-08','13:05:00',4.67),('10318','2013-10-08','13:10:00',4.68),('10318','2013-10-08','13:15:00',2.74),('10318','2013-10-08','13:20:00',2.7),('10318','2013-10-08','13:25:00',2.92),('10318','2013-10-08','13:30:00',6.59),('10318','2013-10-08','13:35:00',4.55),('10318','2013-10-08','13:40:00',2.97),('10318','2013-10-08','13:45:00',2.75),('10318','2013-10-08','13:50:00',2),('10318','2013-10-08','13:55:00',1.63),('10318','2013-10-08','14:00:00',1.51),('10318','2013-10-08','14:05:00',1.42),('10318','2013-10-08','14:10:00',1.75),('10318','2013-10-08','14:15:00',3.48),('10318','2013-10-08','14:20:00',5),('10318','2013-10-08','14:25:00',5.26),('10318','2013-10-08','14:30:00',4.75),('10318','2013-10-08','14:35:00',4.69),('10318','2013-10-08','14:40:00',4.11),('10318','2013-10-08','14:45:00',4.97),('10318','2013-10-08','14:50:00',7.03),('10318','2013-10-08','14:55:00',6.61),('10318','2013-10-08','15:00:00',6.41),('10318','2013-10-08','15:05:00',6.34),('10318','2013-10-08','15:10:00',4.37),('10318','2013-10-08','15:15:00',5.63),('10318','2013-10-08','15:20:00',5.31),('10318','2013-10-08','15:25:00',3.86),('10318','2013-10-08','15:30:00',4.94),('10318','2013-10-08','15:35:00',3.15),('10318','2013-10-08','15:40:00',2.25),('10318','2013-10-08','15:45:00',2.22),('10318','2013-10-08','15:50:00',3.44),('10318','2013-10-08','15:55:00',3.16),('10318','2013-10-08','16:00:00',2.22),('10318','2013-10-08','16:05:00',1.04),('10318','2013-10-08','16:30:00',1.09),('10318','2013-10-08','16:35:00',1.38),('10318','2013-10-08','16:40:00',1.22),('10318','2013-10-08','16:45:00',1.19),('10318','2013-10-08','16:50:00',1.16),('10318','2013-10-07','07:55:00',1.11),('10318','2013-10-07','08:00:00',1.29),('10318','2013-10-07','08:05:00',1.44),('10318','2013-10-07','08:10:00',1.58),('10318','2013-10-07','08:15:00',1.46),('10318','2013-10-07','08:20:00',2.17),('10318','2013-10-07','08:25:00',3.06),('10318','2013-10-07','08:30:00',3.5),('10318','2013-10-07','08:35:00',2.76),('10318','2013-10-07','08:45:00',1.29),('10318','2013-10-07','08:50:00',1.21),('10318','2013-10-07','08:55:00',2.83),('10318','2013-10-07','09:00:00',2.61),('10318','2013-10-07','09:05:00',5.7),('10318','2013-10-07','09:10:00',5.22),('10318','2013-10-07','09:15:00',5.13),('10318','2013-10-07','09:20:00',5.24),('10318','2013-10-07','09:25:00',5.43),('10318','2013-10-07','09:30:00',5.58),('10318','2013-10-07','09:35:00',5.75),('10318','2013-10-07','09:40:00',5.88),('10318','2013-10-07','09:45:00',5.99),('10318','2013-10-07','09:50:00',6.1),('10318','2013-10-07','09:55:00',6.26),('10318','2013-10-07','10:00:00',6.34),('10318','2013-10-07','10:05:00',6.48),('10318','2013-10-07','10:10:00',6.62),('10318','2013-10-07','10:15:00',6.74),('10318','2013-10-07','10:20:00',6.87),('10318','2013-10-07','10:25:00',7.01),('10318','2013-10-07','10:30:00',7.09),('10318','2013-10-07','10:35:00',3.73),('10318','2013-10-07','10:40:00',7.51),('10318','2013-10-07','10:45:00',7.52),('10318','2013-10-07','10:50:00',7.5),('10318','2013-10-07','10:55:00',7.49),('10318','2013-10-07','11:00:00',6.97),('10318','2013-10-07','11:05:00',5.25),('10318','2013-10-07','11:10:00',7.8),('10318','2013-10-07','11:15:00',7.89),('10318','2013-10-07','11:20:00',7.85),('10318','2013-10-07','11:25:00',7.78),('10318','2013-10-07','11:30:00',7.97),('10318','2013-10-07','11:35:00',8.06),('10318','2013-10-07','11:40:00',7.13),('10318','2013-10-07','11:45:00',8.18),('10318','2013-10-07','11:50:00',8.24),('10318','2013-10-07','11:55:00',8.24),('10318','2013-10-07','12:00:00',7.55),('10318','2013-10-07','12:05:00',5.18),('10318','2013-10-07','12:10:00',9.24),('10318','2013-10-07','12:15:00',8.43),('10318','2013-10-07','12:20:00',7.73),('10318','2013-10-07','12:25:00',5.75),('10318','2013-10-07','12:30:00',8.76),('10318','2013-10-07','12:35:00',8.8),('10318','2013-10-07','12:40:00',7.89),('10318','2013-10-07','12:45:00',8.91),('10318','2013-10-07','12:50:00',5.25),('10318','2013-10-07','12:55:00',8.31),('10318','2013-10-07','13:00:00',8.93),('10318','2013-10-07','13:05:00',2.8),('10318','2013-10-07','13:10:00',2.67),('10318','2013-10-07','13:15:00',3.28),('10318','2013-10-07','13:20:00',3.19),('10318','2013-10-07','13:25:00',2.76),('10318','2013-10-07','13:30:00',3.15),('10318','2013-10-07','13:35:00',2.14),('10318','2013-10-07','13:40:00',2.15),('10318','2013-10-07','13:45:00',2.32),('10318','2013-10-07','13:50:00',2.22),('10318','2013-10-07','13:55:00',4.46),('10318','2013-10-07','14:00:00',5.22),('10318','2013-10-07','14:05:00',9.61),('10318','2013-10-07','14:10:00',6.94),('10318','2013-10-07','14:15:00',6.71),('10318','2013-10-07','14:20:00',3.37),('10318','2013-10-07','14:25:00',8.28),('10318','2013-10-07','14:30:00',3.74),('10318','2013-10-07','14:35:00',6.4),('10318','2013-10-07','14:40:00',6.88),('10318','2013-10-07','14:45:00',7.23),('10318','2013-10-07','14:50:00',5.57),('10318','2013-10-07','14:55:00',6.32),('10318','2013-10-07','15:00:00',5.22),('10318','2013-10-07','15:05:00',5.85),('10318','2013-10-07','15:10:00',5.26),('10318','2013-10-07','15:15:00',6.18),('10318','2013-10-07','15:20:00',6.2),('10318','2013-10-07','15:25:00',6.09),('10318','2013-10-07','15:30:00',5.99),('10318','2013-10-07','15:35:00',5.51),('10318','2013-10-07','15:40:00',2.93),('10318','2013-10-07','15:45:00',1.41),('10318','2013-10-07','15:50:00',4.23),('10318','2013-10-07','15:55:00',4.1),('10318','2013-10-07','16:00:00',3.04),('10318','2013-10-07','16:05:00',4.32),('10318','2013-10-07','16:10:00',4.14),('10318','2013-10-07','16:15:00',4.11),('10318','2013-10-07','16:20:00',2.32),('10318','2013-10-07','16:25:00',4),('10318','2013-10-07','16:30:00',3.85),('10318','2013-10-07','16:35:00',3.81),('10318','2013-10-07','16:40:00',3.62),('10318','2013-10-07','16:45:00',2.13),('10318','2013-10-07','16:50:00',2.95),('10318','2013-10-07','16:55:00',2.73),('10318','2013-10-07','17:00:00',2.47),('10318','2013-10-07','17:05:00',2.26),('10318','2013-10-07','17:10:00',2.08),('10318','2013-10-07','17:15:00',1.77),('10318','2013-10-07','17:20:00',1.71),('10318','2013-10-07','17:25:00',1.59),('10318','2013-10-07','17:30:00',1.42),('10318','2013-10-07','17:35:00',1.24),('10318','2013-10-07','17:40:00',1.08),('10318','2013-10-06','08:45:00',1.03),('10318','2013-10-06','08:50:00',1.36),('10318','2013-10-06','08:55:00',1.61),('10318','2013-10-06','09:00:00',1.8),('10318','2013-10-06','09:05:00',3.76),('10318','2013-10-06','09:10:00',2.51),('10318','2013-10-06','09:15:00',1.34),('10318','2013-10-06','09:20:00',1.5),('10318','2013-10-06','09:25:00',2.27),('10318','2013-10-06','09:30:00',4.12),('10318','2013-10-06','09:35:00',5.13),('10318','2013-10-06','09:40:00',4.57),('10318','2013-10-06','09:45:00',3.81),('10318','2013-10-06','09:50:00',5.87),('10318','2013-10-06','09:55:00',6.24),('10318','2013-10-06','10:00:00',7.27),('10318','2013-10-06','10:05:00',6.42),('10318','2013-10-06','10:10:00',5.02),('10318','2013-10-06','10:15:00',6.18),('10318','2013-10-06','10:20:00',6.49),('10318','2013-10-06','10:25:00',7.26),('10318','2013-10-06','10:30:00',6.88),('10318','2013-10-06','10:35:00',6.4),('10318','2013-10-06','10:40:00',3.5),('10318','2013-10-06','10:45:00',3.66),('10318','2013-10-06','10:50:00',5.22),('10318','2013-10-06','10:55:00',5.58),('10318','2013-10-06','11:00:00',6.68),('10318','2013-10-06','11:05:00',6.52),('10318','2013-10-06','11:10:00',7.16),('10318','2013-10-06','11:15:00',6.97),('10318','2013-10-06','11:20:00',7.04),('10318','2013-10-06','11:25:00',6.83),('10318','2013-10-06','11:30:00',6.87),('10318','2013-10-06','11:35:00',6.24),('10318','2013-10-06','11:40:00',3.88),('10318','2013-10-06','11:45:00',3.68),('10318','2013-10-06','11:50:00',5.67),('10318','2013-10-06','11:55:00',6.69),('10318','2013-10-06','12:00:00',6.56),('10318','2013-10-06','12:05:00',4.69),('10318','2013-10-06','12:10:00',8.34),('10318','2013-10-06','12:15:00',6.57),('10318','2013-10-06','12:20:00',3.91),('10318','2013-10-06','12:25:00',3.4),('10318','2013-10-06','12:30:00',6.51),('10318','2013-10-06','12:35:00',6.71),('10318','2013-10-06','12:40:00',6.76),('10318','2013-10-06','12:45:00',6.86),('10318','2013-10-06','12:50:00',7.48),('10318','2013-10-06','12:55:00',7.6),('10318','2013-10-06','13:00:00',7.58),('10318','2013-10-06','13:05:00',7.81),('10318','2013-10-06','13:10:00',6.8),('10318','2013-10-06','13:15:00',4.28),('10318','2013-10-06','13:20:00',3.27),('10318','2013-10-06','13:25:00',5.56),('10318','2013-10-06','13:30:00',2.06),('10318','2013-10-06','13:35:00',1.64),('10318','2013-10-06','13:40:00',2.01),('10318','2013-10-06','13:45:00',6.58),('10318','2013-10-06','13:50:00',8),('10318','2013-10-06','13:55:00',6.92),('10318','2013-10-06','14:00:00',7.37),('10318','2013-10-06','14:05:00',6.44),('10318','2013-10-06','14:10:00',5.1),('10318','2013-10-06','14:15:00',4.85),('10318','2013-10-06','14:20:00',4.01),('10318','2013-10-06','14:25:00',4.41),('10318','2013-10-06','14:30:00',5.16),('10318','2013-10-06','14:35:00',4.51),('10318','2013-10-06','14:40:00',5.24),('10318','2013-10-06','14:45:00',4.44),('10318','2013-10-06','14:50:00',4.33),('10318','2013-10-06','14:55:00',4.42),('10318','2013-10-06','15:00:00',4.18),('10318','2013-10-06','15:05:00',4.19),('10318','2013-10-06','15:10:00',2.91),('10318','2013-10-06','15:15:00',2.56),('10318','2013-10-06','15:20:00',2.18),('10318','2013-10-06','15:25:00',1.87),('10318','2013-10-06','15:30:00',1.84),('10318','2013-10-06','15:35:00',1.73),('10318','2013-10-06','15:40:00',1.6),('10318','2013-10-06','15:45:00',1.52),('10318','2013-10-06','15:50:00',1.4),('10318','2013-10-06','15:55:00',1.45),('10318','2013-10-06','16:00:00',1.63),('10318','2013-10-06','16:05:00',1.44),('10318','2013-10-06','16:10:00',1.19),('10318','2013-10-06','16:15:00',1.04),('10318','2013-10-06','16:20:00',1.06),('10318','2013-10-06','17:00:00',1.01),('10318','2013-10-06','17:05:00',1.12),('10318','2013-10-06','17:10:00',1.32),('10318','2013-10-06','17:15:00',1.58),('10318','2013-10-06','17:20:00',1.82),('10318','2013-10-06','17:25:00',1.37),('10318','2013-10-06','17:30:00',1.09),('10318','2013-10-06','17:35:00',1.01),('10318','2013-10-05','08:35:00',1.24),('10318','2013-10-05','08:40:00',1.18),('10318','2013-10-05','08:45:00',1.06),('10318','2013-10-05','08:50:00',1.14),('10318','2013-10-05','14:20:00',1.02),('10318','2013-10-05','14:25:00',1.07),('10318','2013-10-05','14:35:00',1.11),('10318','2013-10-05','14:40:00',1.36),('10318','2013-10-05','14:45:00',1.46),('10318','2013-10-05','14:50:00',1.28),('10318','2013-10-05','14:55:00',1.2),('10318','2013-10-05','15:00:00',1.3),('10318','2013-10-05','15:05:00',1.27),('10318','2013-10-05','15:10:00',1.23),('10318','2013-10-05','15:15:00',1.24),('10318','2013-10-05','15:20:00',1.3),('10318','2013-10-05','15:25:00',1.34),('10318','2013-10-05','15:30:00',1.36),('10318','2013-10-05','15:35:00',1.56),('10318','2013-10-05','15:40:00',1.71),('10318','2013-10-05','15:45:00',1.75),('10318','2013-10-05','15:50:00',1.84),('10318','2013-10-05','15:55:00',2.04),('10318','2013-10-05','16:00:00',2.35),('10318','2013-10-05','16:05:00',2.78),('10318','2013-10-05','16:10:00',2.5),('10318','2013-10-05','16:15:00',2.39),('10318','2013-10-05','16:20:00',2.41),('10318','2013-10-05','16:25:00',2.15),('10318','2013-10-05','16:30:00',1.95),('10318','2013-10-05','16:35:00',1.96),('10318','2013-10-05','16:40:00',2.04),('10318','2013-10-05','16:45:00',2.01),('10318','2013-10-05','16:50:00',1.97),('10318','2013-10-05','16:55:00',1.83),('10318','2013-10-05','17:00:00',1.87),('10318','2013-10-05','17:05:00',1.54),('10318','2013-10-05','17:10:00',1.5),('10318','2013-10-05','17:15:00',1.55),('10318','2013-10-05','17:20:00',1.19),('10318','2013-10-05','17:25:00',1),('10318','2013-10-04','08:15:00',1.17),('10318','2013-10-04','08:20:00',1.03),('10318','2013-10-04','08:25:00',1.1),('10318','2013-10-04','08:30:00',1.49),('10318','2013-10-04','08:35:00',1.43),('10318','2013-10-04','08:40:00',1.77),('10318','2013-10-04','08:45:00',1.93),('10318','2013-10-04','08:50:00',1.49),('10318','2013-10-04','08:55:00',1.7),('10318','2013-10-04','09:00:00',1.47),('10318','2013-10-04','09:05:00',1.6),('10318','2013-10-04','09:10:00',1.87),('10318','2013-10-04','09:15:00',1.61),('10318','2013-10-04','09:20:00',1.96),('10318','2013-10-04','09:25:00',2.51),('10318','2013-10-04','09:30:00',2.55),('10318','2013-10-04','09:35:00',2.7),('10318','2013-10-04','09:40:00',2.59),('10318','2013-10-04','09:45:00',2.9),('10318','2013-10-04','09:50:00',4.23),('10318','2013-10-04','09:55:00',5.48),('10318','2013-10-04','10:00:00',4.1),('10318','2013-10-04','10:05:00',3.35),('10318','2013-10-04','10:10:00',3.64),('10318','2013-10-04','10:15:00',3.89),('10318','2013-10-04','10:20:00',4.27),('10318','2013-10-04','10:25:00',4.91),('10318','2013-10-04','10:30:00',6.76),('10318','2013-10-04','10:35:00',5.28),('10318','2013-10-04','10:40:00',7.66),('10318','2013-10-04','10:45:00',8.64),('10318','2013-10-04','10:50:00',4.76),('10318','2013-10-04','10:55:00',5.66),('10318','2013-10-04','11:00:00',4.16),('10318','2013-10-04','11:05:00',3.81),('10318','2013-10-04','11:10:00',5.21),('10318','2013-10-04','11:15:00',6.18),('10318','2013-10-04','11:20:00',6.63),('10318','2013-10-04','11:25:00',7.59),('10318','2013-10-04','11:30:00',7.2),('10318','2013-10-04','11:35:00',7.56),('10318','2013-10-04','11:40:00',8.79),('10318','2013-10-04','11:45:00',8.38),('10318','2013-10-04','11:50:00',8.26),('10318','2013-10-04','11:55:00',8.29),('10318','2013-10-04','12:00:00',8.17),('10318','2013-10-04','12:05:00',8.34),('10318','2013-10-04','12:10:00',8.25),('10318','2013-10-04','12:15:00',7.74),('10318','2013-10-04','12:20:00',8.55),('10318','2013-10-04','12:25:00',8.5),('10318','2013-10-04','12:30:00',8.63),('10318','2013-10-04','12:35:00',8.31),('10318','2013-10-04','12:40:00',8.04),('10318','2013-10-04','12:45:00',8.08),('10318','2013-10-04','12:50:00',7.86),('10318','2013-10-04','12:55:00',7.94),('10318','2013-10-04','13:00:00',8.05),('10318','2013-10-04','13:05:00',8.05),('10318','2013-10-04','13:10:00',8.2),('10318','2013-10-04','13:15:00',8.32),('10318','2013-10-04','13:20:00',7.92),('10318','2013-10-04','13:25:00',7.74),('10318','2013-10-04','13:30:00',8.25),('10318','2013-10-04','13:35:00',7.94),('10318','2013-10-04','13:40:00',7.71),('10318','2013-10-04','13:45:00',7.48),('10318','2013-10-04','13:50:00',7.49),('10318','2013-10-04','13:55:00',7.4),('10318','2013-10-04','14:00:00',7.39),('10318','2013-10-04','14:05:00',7.11),('10318','2013-10-04','14:10:00',6.16),('10318','2013-10-04','14:15:00',5.59),('10318','2013-10-04','14:20:00',7.07),('10318','2013-10-04','14:25:00',6.54),('10318','2013-10-04','14:30:00',5.66),('10318','2013-10-04','14:35:00',3.76),('10318','2013-10-04','14:40:00',3.61),('10318','2013-10-04','14:45:00',4.61),('10318','2013-10-04','14:50:00',5.72),('10318','2013-10-04','14:55:00',4.74),('10318','2013-10-04','15:00:00',4.68),('10318','2013-10-04','15:05:00',4.88),('10318','2013-10-04','15:10:00',3.88),('10318','2013-10-04','15:15:00',3.4),('10318','2013-10-04','15:20:00',3.39),('10318','2013-10-04','15:25:00',5.41),('10318','2013-10-04','15:30:00',3.34),('10318','2013-10-04','15:35:00',2.45),('10318','2013-10-04','15:40:00',1.92),('10318','2013-10-04','15:45:00',1.72),('10318','2013-10-04','15:50:00',1.7),('10318','2013-10-04','15:55:00',2),('10318','2013-10-04','16:00:00',2.41),('10318','2013-10-04','16:05:00',2.57),('10318','2013-10-04','16:10:00',2.16),('10318','2013-10-04','16:15:00',1.91),('10318','2013-10-04','16:20:00',1.59),('10318','2013-10-04','16:25:00',1.39),('10318','2013-10-04','16:30:00',1.34),('10318','2013-10-04','16:35:00',1.36),('10318','2013-10-04','16:40:00',1.26),('10318','2013-10-04','16:45:00',1.24),('10318','2013-10-04','16:50:00',1.28),('10318','2013-10-04','16:55:00',1.14),('10318','2013-10-04','17:00:00',1.12),('10318','2013-10-04','17:05:00',1.11),('10318','2013-10-03','07:55:00',1.07),('10318','2013-10-03','08:00:00',1.27),('10318','2013-10-03','08:05:00',1.45),('10318','2013-10-03','08:10:00',1.27),('10318','2013-10-03','08:15:00',2.55),('10318','2013-10-03','08:20:00',3.11),('10318','2013-10-03','08:25:00',3.42),('10318','2013-10-03','08:30:00',3.66),('10318','2013-10-03','08:35:00',3.89),('10318','2013-10-03','08:40:00',4.11),('10318','2013-10-03','08:45:00',4.32),('10318','2013-10-03','08:50:00',4.54),('10318','2013-10-03','08:55:00',4.64),('10318','2013-10-03','09:00:00',4.96),('10318','2013-10-03','09:05:00',5.15),('10318','2013-10-03','09:10:00',5.34),('10318','2013-10-03','09:15:00',5.54),('10318','2013-10-03','09:20:00',5.75),('10318','2013-10-03','09:25:00',5.9),('10318','2013-10-03','09:30:00',6.08),('10318','2013-10-03','09:35:00',6.25),('10318','2013-10-03','09:40:00',6.42),('10318','2013-10-03','09:45:00',6.57),('10318','2013-10-03','09:50:00',6.72),('10318','2013-10-03','09:55:00',6.87),('10318','2013-10-03','10:00:00',7),('10318','2013-10-03','10:05:00',7.16),('10318','2013-10-03','10:10:00',7.3),('10318','2013-10-03','10:15:00',7.46),('10318','2013-10-03','10:20:00',7.59),('10318','2013-10-03','10:25:00',7.69),('10318','2013-10-03','10:30:00',7.8),('10318','2013-10-03','10:35:00',7.84),('10318','2013-10-03','10:40:00',7.94),('10318','2013-10-03','10:45:00',7.84),('10318','2013-10-03','10:50:00',8.11),('10318','2013-10-03','10:55:00',8.2),('10318','2013-10-03','11:00:00',8.27),('10318','2013-10-03','11:05:00',8.34),('10318','2013-10-03','11:10:00',8.4),('10318','2013-10-03','11:15:00',8.43),('10318','2013-10-03','11:20:00',8.48),('10318','2013-10-03','11:25:00',8.56),('10318','2013-10-03','11:30:00',8.61),('10318','2013-10-03','11:35:00',8.66),('10318','2013-10-03','11:40:00',8.73),('10318','2013-10-03','11:45:00',8.75),('10318','2013-10-03','11:50:00',8.77),('10318','2013-10-03','11:55:00',8.78),('10318','2013-10-03','12:00:00',8.81),('10318','2013-10-03','12:05:00',8.76),('10318','2013-10-03','12:10:00',8.8),('10318','2013-10-03','12:15:00',8.87),('10318','2013-10-03','12:20:00',8.92),('10318','2013-10-03','12:25:00',8.85),('10318','2013-10-03','12:30:00',8.65),('10318','2013-10-03','12:35:00',8.9),('10318','2013-10-03','12:40:00',8.87),('10318','2013-10-03','12:45:00',8.88),('10318','2013-10-03','12:50:00',8.86),('10318','2013-10-03','12:55:00',8.79),('10318','2013-10-03','13:00:00',8.73),('10318','2013-10-03','13:05:00',8.63),('10318','2013-10-03','13:10:00',8.68),('10318','2013-10-03','13:15:00',8.59),('10318','2013-10-03','13:20:00',8.52),('10318','2013-10-03','13:25:00',8.39),('10318','2013-10-03','13:30:00',8.42),('10318','2013-10-03','13:35:00',8.37),('10318','2013-10-03','13:40:00',8.3),('10318','2013-10-03','13:45:00',8.23),('10318','2013-10-03','13:50:00',8.14),('10318','2013-10-03','13:55:00',8.03),('10318','2013-10-03','14:00:00',8),('10318','2013-10-03','14:05:00',7.96),('10318','2013-10-03','14:10:00',7.83),('10318','2013-10-03','14:15:00',7.68),('10318','2013-10-03','14:20:00',7.65),('10318','2013-10-03','14:25:00',7.54),('10318','2013-10-03','14:30:00',7.42),('10318','2013-10-03','14:35:00',7.28),('10318','2013-10-03','14:40:00',7.13),('10318','2013-10-03','14:45:00',7.02),('10318','2013-10-03','14:50:00',6.91),('10318','2013-10-03','14:55:00',6.75),('10318','2013-10-03','15:00:00',6.59),('10318','2013-10-03','15:05:00',6.46),('10318','2013-10-03','15:10:00',6.31),('10318','2013-10-03','15:15:00',6.14),('10318','2013-10-03','15:20:00',6.01),('10318','2013-10-03','15:25:00',5.88),('10318','2013-10-03','15:30:00',5.62),('10318','2013-10-03','15:35:00',5.59),('10318','2013-10-03','15:40:00',5.39),('10318','2013-10-03','15:45:00',5.22),('10318','2013-10-03','15:50:00',5.06),('10318','2013-10-03','15:55:00',4.89),('10318','2013-10-03','16:00:00',4.71),('10318','2013-10-03','16:05:00',4.54),('10318','2013-10-03','16:10:00',4.36),('10318','2013-10-03','16:15:00',4.17),('10318','2013-10-03','16:20:00',3.99),('10318','2013-10-03','16:25:00',3.8),('10318','2013-10-03','16:30:00',3.62),('10318','2013-10-03','16:35:00',3.45),('10318','2013-10-03','16:40:00',3.28),('10318','2013-10-03','16:45:00',3.11),('10318','2013-10-03','16:50:00',2.93),('10318','2013-10-03','16:55:00',2.77),('10318','2013-10-03','17:00:00',2.61),('10318','2013-10-03','17:05:00',2.45),('10318','2013-10-03','17:10:00',2.27),('10318','2013-10-03','17:15:00',2.08),('10318','2013-10-03','17:20:00',1.95),('10318','2013-10-03','17:25:00',1.79),('10318','2013-10-03','17:30:00',1.61),('10318','2013-10-03','17:35:00',1.46),('10318','2013-10-03','17:40:00',1.3),('10318','2013-10-03','17:45:00',1.14),('10318','2013-10-02','08:15:00',1.07),('10318','2013-10-02','08:20:00',1.32),('10318','2013-10-02','08:25:00',1.31),('10318','2013-10-02','08:30:00',2.95),('10318','2013-10-02','08:35:00',3.7),('10318','2013-10-02','08:40:00',3.71),('10318','2013-10-02','08:45:00',4.05),('10318','2013-10-02','08:50:00',4.33),('10318','2013-10-02','08:55:00',4.5),('10318','2013-10-02','09:00:00',4.72),('10318','2013-10-02','09:05:00',4.9),('10318','2013-10-02','09:10:00',5.12),('10318','2013-10-02','09:15:00',5.27),('10318','2013-10-02','09:20:00',5.48),('10318','2013-10-02','09:25:00',5.63),('10318','2013-10-02','09:30:00',5.82),('10318','2013-10-02','09:35:00',5.95),('10318','2013-10-02','09:40:00',6.12),('10318','2013-10-02','09:45:00',6.25),('10318','2013-10-02','09:50:00',6.42),('10318','2013-10-02','09:55:00',6.53),('10318','2013-10-02','10:00:00',6.66),('10318','2013-10-02','10:05:00',6.76),('10318','2013-10-02','10:10:00',6.91),('10318','2013-10-02','10:15:00',6.82),('10318','2013-10-02','10:20:00',7.15),('10318','2013-10-02','10:25:00',7.25),('10318','2013-10-02','10:30:00',7.41),('10318','2013-10-02','10:35:00',7.5),('10318','2013-10-02','10:40:00',7.6),('10318','2013-10-02','10:45:00',7.65),('10318','2013-10-02','10:50:00',7.75),('10318','2013-10-02','10:55:00',7.83),('10318','2013-10-02','11:00:00',7.94),('10318','2013-10-02','11:05:00',7.99),('10318','2013-10-02','11:10:00',8.05),('10318','2013-10-02','11:15:00',8.06),('10318','2013-10-02','11:20:00',8.14),('10318','2013-10-02','11:25:00',8.22),('10318','2013-10-02','11:30:00',8.25),('10318','2013-10-02','11:35:00',8.27),('10318','2013-10-02','11:40:00',8.33),('10318','2013-10-02','11:45:00',8.36),('10318','2013-10-02','11:51:00',8.4),('10318','2013-10-02','11:55:00',8.46),('10318','2013-10-02','12:00:00',8.23),('10318','2013-10-02','12:05:00',8.52),('10318','2013-10-02','12:10:00',8.55),('10318','2013-10-02','12:15:00',8.53),('10318','2013-10-02','12:20:00',8.53),('10318','2013-10-02','12:25:00',8.54),('10318','2013-10-02','12:30:00',8.51),('10318','2013-10-02','12:35:00',8.47),('10318','2013-10-02','12:40:00',8.47),('10318','2013-10-02','12:45:00',8.48),('10318','2013-10-02','12:50:00',8.47),('10318','2013-10-02','12:55:00',8.46),('10318','2013-10-02','13:00:00',8.44),('10318','2013-10-02','13:05:00',8.36),('10318','2013-10-02','13:10:00',8.34),('10318','2013-10-02','13:15:00',8.25),('10318','2013-10-02','13:20:00',8.2),('10318','2013-10-02','13:25:00',8.16),('10318','2013-10-02','13:30:00',8.1),('10318','2013-10-02','13:35:00',8.06),('10318','2013-10-02','13:40:00',8.02),('10318','2013-10-02','13:45:00',7.77),('10318','2013-10-02','13:50:00',7.84),('10318','2013-10-02','13:55:00',7.8),('10318','2013-10-02','14:00:00',7.7),('10318','2013-10-02','14:05:00',7.59),('10318','2013-10-02','14:10:00',7.54),('10318','2013-10-02','14:15:00',7.4),('10318','2013-10-02','14:20:00',7.27),('10318','2013-10-02','14:25:00',7.18),('10318','2013-10-02','14:30:00',7.08),('10318','2013-10-02','14:35:00',6.99),('10318','2013-10-02','14:40:00',6.89),('10318','2013-10-02','14:45:00',6.8),('10318','2013-10-02','14:50:00',6.66),('10318','2013-10-02','14:55:00',6.58),('10318','2013-10-02','15:00:00',6.33),('10318','2013-10-02','15:05:00',6.32),('10318','2013-10-02','15:10:00',6.12),('10318','2013-10-02','15:15:00',6.03),('10318','2013-10-02','15:20:00',5.86),('10318','2013-10-02','15:25:00',5.72),('10318','2013-10-02','15:30:00',5.54),('10318','2013-10-02','15:35:00',5.38),('10318','2013-10-02','15:40:00',5.24),('10318','2013-10-02','15:45:00',5.11),('10318','2013-10-02','15:50:00',4.97),('10318','2013-10-02','15:55:00',4.81),('10318','2013-10-02','16:00:00',4.61),('10318','2013-10-02','16:05:00',4.42),('10318','2013-10-02','16:10:00',4.25),('10318','2013-10-02','16:15:00',4.07),('10318','2013-10-02','16:20:00',3.88),('10318','2013-10-02','16:25:00',3.72),('10318','2013-10-02','16:30:00',3.54),('10318','2013-10-02','16:35:00',3.37),('10318','2013-10-02','16:40:00',3.2),('10318','2013-10-02','16:45:00',2.96),('10318','2013-10-02','16:50:00',2.86),('10318','2013-10-02','16:55:00',2.68),('10318','2013-10-02','17:00:00',2.51),('10318','2013-10-02','17:05:00',2.36),('10318','2013-10-02','17:10:00',2.2),('10318','2013-10-02','17:15:00',1.99),('10318','2013-10-02','17:20:00',1.8),('10318','2013-10-02','17:25:00',1.57),('10318','2013-10-02','17:30:00',1.52),('10318','2013-10-02','17:35:00',1.38),('10318','2013-10-02','17:40:00',1.12),('10318','2013-10-01','08:00:00',1.38),('10318','2013-10-01','08:05:00',1.56),('10318','2013-10-01','08:10:00',1.35),('10318','2013-10-01','08:15:00',1.47),('10318','2013-10-01','08:20:00',2.96),('10318','2013-10-01','08:25:00',2.9),('10318','2013-10-01','08:30:00',3.36),('10318','2013-10-01','08:35:00',3.62),('10318','2013-10-01','08:40:00',3.89),('10318','2013-10-01','08:45:00',4.06),('10318','2013-10-01','08:50:00',4.32),('10318','2013-10-01','08:55:00',4.49),('10318','2013-10-01','09:00:00',4.71),('10318','2013-10-01','09:05:00',4.84),('10318','2013-10-01','09:10:00',5.06),('10318','2013-10-01','09:15:00',5.2),('10318','2013-10-01','09:20:00',5.32),('10318','2013-10-01','09:25:00',5.46),('10318','2013-10-01','09:30:00',5.5),('10318','2013-10-01','09:35:00',5.79),('10318','2013-10-01','09:40:00',5.93),('10318','2013-10-01','09:45:00',6.1),('10318','2013-10-01','09:50:00',6.24),('10318','2013-10-01','09:55:00',6.36),('10318','2013-10-01','10:00:00',6.42),('10318','2013-10-01','10:05:00',6.55),('10318','2013-10-01','10:10:00',6.66),('10318','2013-10-01','10:15:00',6.76),('10318','2013-10-01','10:20:00',6.9),('10318','2013-10-01','10:25:00',7.11),('10318','2013-10-01','10:30:00',7.28),('10318','2013-10-01','10:35:00',5.99),('10318','2013-10-01','10:40:00',7.65),('10318','2013-10-01','10:45:00',7.85),('10318','2013-10-01','10:50:00',8.02),('10318','2013-10-01','10:55:00',7.81),('10318','2013-10-01','11:00:00',8.01),('10318','2013-10-01','11:05:00',5.39),('10318','2013-10-01','11:10:00',3.75),('10318','2013-10-01','11:15:00',6.6),('10318','2013-10-01','11:20:00',8.23),('10318','2013-10-01','11:25:00',8.24),('10318','2013-10-01','11:30:00',7.51),('10318','2013-10-01','11:35:00',4.76),('10318','2013-10-01','11:40:00',6.94),('10318','2013-10-01','11:45:00',8.4),('10318','2013-10-01','11:50:00',8.46),('10318','2013-10-01','11:55:00',8.56),('10318','2013-10-01','12:00:00',7.77),('10318','2013-10-01','12:05:00',8.68),('10318','2013-10-01','12:10:00',7.92),('10318','2013-10-01','12:15:00',7),('10318','2013-10-01','12:20:00',9.13),('10318','2013-10-01','12:25:00',3.26),('10318','2013-10-01','12:30:00',7.16),('10318','2013-10-01','12:35:00',9.3),('10318','2013-10-01','12:40:00',2.7),('10318','2013-10-01','12:45:00',7.37),('10318','2013-10-01','12:50:00',2.08),('10318','2013-10-01','12:55:00',2.89),('10318','2013-10-01','13:00:00',8.77),('10318','2013-10-01','13:05:00',8.86),('10318','2013-10-01','13:10:00',8.99),('10318','2013-10-01','13:15:00',9.03),('10318','2013-10-01','13:20:00',5.7),('10318','2013-10-01','13:25:00',9.07),('10318','2013-10-01','13:30:00',8.95),('10318','2013-10-01','13:35:00',8.78),('10318','2013-10-01','13:40:00',8.28),('10318','2013-10-01','13:45:00',7.95),('10318','2013-10-01','13:50:00',7.76),('10318','2013-10-01','13:55:00',7.64),('10318','2013-10-01','14:00:00',7.44),('10318','2013-10-01','14:05:00',7.41),('10318','2013-10-01','14:10:00',7.51),('10318','2013-10-01','14:15:00',7.51),('10318','2013-10-01','14:20:00',7.14),('10318','2013-10-01','14:25:00',7.12),('10318','2013-10-01','14:30:00',7.03),('10318','2013-10-01','14:35:00',7.07),('10318','2013-10-01','14:40:00',7.06),('10318','2013-10-01','14:45:00',7.28),('10318','2013-10-01','14:50:00',7.31),('10318','2013-10-01','14:55:00',6.95),('10318','2013-10-01','15:00:00',6.53),('10318','2013-10-01','15:05:00',6.31),('10318','2013-10-01','15:10:00',6.12),('10318','2013-10-01','15:15:00',6.02),('10318','2013-10-01','15:20:00',5.88),('10318','2013-10-01','15:25:00',5.72),('10318','2013-10-01','15:30:00',5.52),('10318','2013-10-01','15:35:00',5.37),('10318','2013-10-01','15:40:00',5.22),('10318','2013-10-01','15:45:00',5.05),('10318','2013-10-01','15:50:00',4.89),('10318','2013-10-01','15:55:00',4.71),('10318','2013-10-01','16:00:00',4.53),('10318','2013-10-01','16:05:00',4.29),('10318','2013-10-01','16:10:00',4.23),('10318','2013-10-01','16:15:00',4.09),('10318','2013-10-01','16:20:00',3.9),('10318','2013-10-01','16:25:00',3.74),('10318','2013-10-01','16:30:00',3.55),('10318','2013-10-01','16:35:00',3.37),('10318','2013-10-01','16:40:00',3.2),('10318','2013-10-01','16:45:00',3.04),('10318','2013-09-29','08:20:00',1.09),('10318','2013-09-29','08:25:00',1.12),('10318','2013-09-29','08:30:00',1.16),('10318','2013-09-29','08:35:00',1.46),('10318','2013-09-29','08:40:00',2.13),('10318','2013-09-29','08:45:00',2.45),('10318','2013-09-29','08:50:00',2.81),('10318','2013-09-29','08:55:00',2.6),('10318','2013-09-29','09:00:00',2.18),('10318','2013-09-29','09:05:00',1.82),('10318','2013-09-29','09:10:00',2.05),('10318','2013-09-29','09:15:00',2.19),('10318','2013-09-29','09:20:00',2.03),('10318','2013-09-29','09:25:00',2.1),('10318','2013-09-29','09:30:00',1.98),('10318','2013-09-29','09:35:00',1.88),('10318','2013-09-29','09:40:00',1.94),('10318','2013-09-29','09:45:00',2.19),('10318','2013-09-29','09:50:00',2.38),('10318','2013-09-29','09:55:00',2.75),('10318','2013-09-29','10:00:00',4.12),('10318','2013-09-29','10:05:00',4.42),('10318','2013-09-29','10:10:00',5.6),('10318','2013-09-29','10:15:00',6.46),('10318','2013-09-29','10:20:00',5.3),('10318','2013-09-29','10:25:00',4.95),('10318','2013-09-29','10:30:00',6.36),('10318','2013-09-29','10:35:00',6.5),('10318','2013-09-29','10:40:00',6.67),('10318','2013-09-29','10:45:00',6.92),('10318','2013-09-29','10:50:00',6.74),('10318','2013-09-29','10:55:00',6.95),('10318','2013-09-29','11:00:00',6.83),('10318','2013-09-29','11:05:00',6.45),('10318','2013-09-29','11:10:00',6.55),('10318','2013-09-29','11:15:00',7.06),('10318','2013-09-29','11:20:00',6.87),('10318','2013-09-29','11:25:00',6.76),('10318','2013-09-29','11:30:00',7.15),('10318','2013-09-29','11:35:00',6.9),('10318','2013-09-29','11:40:00',7.24),('10318','2013-09-29','11:45:00',7.5),('10318','2013-09-29','11:50:00',7.38),('10318','2013-09-29','11:55:00',7.68),('10318','2013-09-29','12:00:00',7.79),('10318','2013-09-29','12:05:00',7.75),('10318','2013-09-29','12:10:00',8.26),('10318','2013-09-29','12:15:00',7.08),('10318','2013-09-29','12:20:00',3.28),('10318','2013-09-29','12:25:00',3.28),('10318','2013-09-29','12:30:00',3.97),('10318','2013-09-29','12:35:00',3.64),('10318','2013-09-29','12:40:00',2.6),('10318','2013-09-29','12:45:00',2.49),('10318','2013-09-29','12:50:00',2.65),('10318','2013-09-29','12:55:00',2.63),('10318','2013-09-29','13:00:00',2.25),('10318','2013-09-29','13:05:00',2.1),('10318','2013-09-29','13:10:00',1.79),('10318','2013-09-29','13:15:00',1.41),('10318','2013-09-29','13:20:00',1.97),('10318','2013-09-29','13:25:00',2.88),('10318','2013-09-29','13:30:00',3.64),('10318','2013-09-29','13:35:00',5.59),('10318','2013-09-29','13:40:00',4.6),('10318','2013-09-29','13:45:00',4.75),('10318','2013-09-29','13:50:00',5.2),('10318','2013-09-29','13:55:00',3.8),('10318','2013-09-29','14:00:00',4.86),('10318','2013-09-29','14:05:00',4.83),('10318','2013-09-29','14:10:00',2.77),('10318','2013-09-29','14:15:00',3.16),('10318','2014-04-14','07:35:00',1.12),('10318','2014-04-14','07:40:00',1.75),('10318','2014-04-14','07:45:00',2.2),('10318','2014-04-14','07:50:00',2.72),('10318','2014-04-14','07:55:00',3),('10318','2014-04-14','08:00:00',3.22),('10318','2014-04-14','08:05:00',3.56),('10318','2014-04-14','08:10:00',3.79),('10318','2014-04-14','08:15:00',4.03),('10318','2014-04-14','08:20:00',4.24),('10318','2014-04-14','08:25:00',4.39),('10318','2014-04-14','08:30:00',4.68),('10318','2014-04-14','08:35:00',4.89),('10318','2014-04-14','08:40:00',5.1),('10318','2014-04-14','08:45:00',5.3),('10318','2014-04-14','08:50:00',5.47),('10318','2014-04-14','08:55:00',5.64),('10318','2014-04-14','09:00:00',5.84),('10318','2014-04-14','09:05:00',6.04),('10318','2014-04-14','09:10:00',6.22),('10318','2014-04-14','09:15:00',6.4),('10318','2014-04-14','09:20:00',6.55),('10318','2014-04-14','09:25:00',6.69),('10318','2014-04-14','09:30:00',6.86),('10318','2014-04-14','09:35:00',7),('10318','2014-04-14','09:40:00',7.16),('10318','2014-04-14','09:45:00',7.3),('10318','2014-04-14','09:50:00',7.44),('10318','2014-04-14','09:55:00',7.57),('10318','2014-04-14','10:00:00',7.71),('10318','2014-04-14','10:05:00',7.8),('10318','2014-04-14','10:10:00',7.76),('10318','2014-04-14','10:15:00',7.98),('10318','2014-04-14','10:20:00',8.07),('10318','2014-04-14','10:25:00',8.18),('10318','2014-04-14','10:30:00',8.28),('10318','2014-04-14','10:35:00',8.45),('10318','2014-04-14','10:40:00',8.47),('10318','2014-04-14','10:45:00',8.62),('10318','2014-04-14','10:50:00',8.71),('10318','2014-04-14','10:55:00',8.77),('10318','2014-04-14','11:00:00',8.86),('10318','2014-04-14','11:05:00',8.94),('10318','2014-04-14','11:10:00',9.02),('10318','2014-04-14','11:15:00',9.17),('10318','2014-04-14','11:20:00',9.19),('10318','2014-04-14','11:25:00',9.23),('10318','2014-04-14','11:30:00',9.26),('10318','2014-04-14','11:35:00',9.31),('10318','2014-04-14','11:40:00',9.38),('10318','2014-04-14','11:45:00',9.4),('10318','2014-04-14','11:50:00',9.4),('10318','2014-04-14','11:55:00',9.36),('10318','2014-04-14','12:00:00',9.49),('10318','2014-04-14','12:05:00',9.49),('10318','2014-04-14','12:10:00',9.52),('10318','2014-04-14','12:15:00',9.58),('10318','2014-04-14','12:20:00',9.59),('10318','2014-04-14','12:25:00',9.49),('10318','2014-04-14','12:30:00',9.54),('10318','2014-04-14','12:35:00',9.54),('10318','2014-04-14','12:40:00',9.58),('10318','2014-04-14','12:45:00',9.59),('10318','2014-04-14','12:50:00',9.63),('10318','2014-04-14','12:55:00',9.6),('10318','2014-04-14','13:00:00',9.54),('10318','2014-04-14','13:05:00',9.53),('10318','2014-04-14','13:10:00',9.49),('10318','2014-04-14','13:15:00',9.54),('10318','2014-04-14','13:20:00',9.51),('10318','2014-04-14','13:25:00',9.51),('10318','2014-04-14','13:30:00',9.48),('10318','2014-04-14','13:35:00',9.39),('10318','2014-04-14','13:40:00',9.11),('10318','2014-04-14','13:45:00',9.33),('10318','2014-04-14','13:50:00',9.34),('10318','2014-04-14','13:55:00',9.28),('10318','2014-04-14','14:00:00',9.2),('10318','2014-04-14','14:05:00',9.19),('10318','2014-04-14','14:10:00',9.08),('10318','2014-04-14','14:15:00',9),('10318','2014-04-14','14:20:00',8.87),('10318','2014-04-14','14:25:00',8.85),('10318','2014-04-14','14:30:00',8.74),('10318','2014-04-14','14:35:00',8.64),('10318','2014-04-14','14:40:00',8.56),('10318','2014-04-14','14:45:00',8.5),('10318','2014-04-14','14:50:00',8.41),('10318','2014-04-14','14:55:00',8.24),('10318','2014-04-14','15:00:00',8.14),('10318','2014-04-14','15:05:00',8.04),('10318','2014-04-14','15:10:00',7.95),('10318','2014-04-14','15:15:00',7.83),('10318','2014-04-14','15:20:00',7.72),('10318','2014-04-14','15:25:00',7.52),('10318','2014-04-14','15:30:00',7.39),('10318','2014-04-14','15:35:00',7.25),('10318','2014-04-14','15:40:00',7.11),('10318','2014-04-14','15:45:00',6.96),('10318','2014-04-14','15:50:00',6.82),('10318','2014-04-14','15:55:00',6.63),('10318','2014-04-14','16:00:00',6.49),('10318','2014-04-14','16:05:00',6.32),('10318','2014-04-14','16:10:00',6.17),('10318','2014-04-14','16:15:00',5.98),('10318','2014-04-14','16:20:00',5.82),('10318','2014-04-14','16:25:00',5.62),('10318','2014-04-14','16:30:00',5.43),('10318','2014-04-14','16:35:00',5.23),('10318','2014-04-14','16:40:00',4.95),('10318','2014-04-14','16:45:00',4.84),('10318','2014-04-14','16:50:00',4.65),('10318','2014-04-14','16:55:00',4.46),('10318','2014-04-14','17:00:00',4.24),('10318','2014-04-14','17:05:00',4.04),('10318','2014-04-14','17:10:00',3.85),('10318','2014-04-14','17:15:00',3.65),('10318','2014-04-14','17:20:00',3.47),('10318','2014-04-14','17:25:00',3.27),('10318','2014-04-14','17:30:00',3.05),('10318','2014-04-14','17:35:00',2.87),('10318','2014-04-14','17:40:00',2.69),('10318','2014-04-14','17:45:00',2.51),('10318','2014-04-14','17:50:00',2.33),('10318','2014-04-14','17:55:00',2.15),('10318','2014-04-14','18:00:00',2),('10318','2014-04-14','18:05:00',1.83),('10318','2014-04-14','18:10:00',1.66),('10318','2014-04-14','18:15:00',1.49),('10318','2014-04-14','18:20:00',1.36),('10318','2014-04-14','18:25:00',1.18),('10318','2014-04-14','18:30:00',1.01),('10318','2013-09-28','07:55:00',1.12),('10318','2013-09-28','08:00:00',1.3),('10318','2013-09-28','08:05:00',1.47),('10318','2013-09-28','08:10:00',1.8),('10318','2013-09-28','08:15:00',2.08),('10318','2013-09-28','08:20:00',1.92),('10318','2013-09-28','08:25:00',1.65),('10318','2013-09-28','08:30:00',2.87),('10318','2013-09-28','08:35:00',3.29),('10318','2013-09-28','08:40:00',3.49),('10318','2013-09-28','08:45:00',3.69),('10318','2013-09-28','08:50:00',3.87),('10318','2013-09-28','08:55:00',4.09),('10318','2013-09-28','09:00:00',4.31),('10318','2013-09-28','09:05:00',4.47),('10318','2013-09-28','09:10:00',4.72),('10318','2013-09-28','09:15:00',4.91),('10318','2013-09-28','09:20:00',5.1),('10318','2013-09-28','09:25:00',5.19),('10318','2013-09-28','09:30:00',5.47),('10318','2013-09-28','09:35:00',5.67),('10318','2013-09-28','09:40:00',5.8),('10318','2013-09-28','09:45:00',5.83),('10318','2013-09-28','09:50:00',5.69),('10318','2013-09-28','09:55:00',5.22),('10318','2013-09-28','10:00:00',3.13),('10318','2013-09-28','10:05:00',4.8),('10318','2013-09-28','10:10:00',6.08),('10318','2013-09-28','10:15:00',3.79),('10318','2013-09-28','10:20:00',2.71),('10318','2013-09-28','10:25:00',3.49),('10318','2013-09-28','10:30:00',3.89),('10318','2013-09-28','10:35:00',2.31),('10318','2013-09-28','10:40:00',5.67),('10318','2013-09-28','10:45:00',2.23),('10318','2013-09-28','10:50:00',5.61),('10318','2013-09-28','10:55:00',7.78),('10318','2013-09-28','11:00:00',8.14),('10318','2013-09-28','11:05:00',6.79),('10318','2013-09-28','11:10:00',3.22),('10318','2013-09-28','11:15:00',2.29),('10318','2013-09-28','11:20:00',5.74),('10318','2013-09-28','11:25:00',8.34),('10318','2013-09-28','11:30:00',8.39),('10318','2013-09-28','11:35:00',8.64),('10318','2013-09-28','11:40:00',5.98),('10318','2013-09-28','11:45:00',3.07),('10318','2013-09-28','11:50:00',3.07),('10318','2013-09-28','11:55:00',6.09),('10318','2013-09-28','12:00:00',8.65),('10318','2013-09-28','12:05:00',8.32),('10318','2013-09-28','12:10:00',8.42),('10318','2013-09-28','12:15:00',8.49),('10318','2013-09-28','12:20:00',8.79),('10318','2013-09-28','12:25:00',9.05),('10318','2013-09-28','12:30:00',8.38),('10318','2013-09-28','12:35:00',4.71),('10318','2013-09-28','12:40:00',6.03),('10318','2013-09-28','12:45:00',8.19),('10318','2013-09-28','12:50:00',8.73),('10318','2013-09-28','12:55:00',2.84),('10318','2013-09-28','13:00:00',5.38),('10318','2013-09-28','13:05:00',9.13),('10318','2013-09-28','13:10:00',8.66),('10318','2013-09-28','13:15:00',7.14),('10318','2013-09-28','13:20:00',3.15),('10318','2013-09-28','13:25:00',3.73),('10318','2013-09-28','13:30:00',2.44),('10318','2013-09-28','13:35:00',3.02),('10318','2013-09-28','13:40:00',5.48),('10318','2013-09-28','13:45:00',8.76),('10318','2013-09-28','13:50:00',3.99),('10318','2013-09-28','13:55:00',2.77),('10318','2013-09-28','14:00:00',7.26),('10318','2013-09-28','14:05:00',5.74),('10318','2013-09-28','14:10:00',6.14),('10318','2013-09-28','14:15:00',7.75),('10318','2013-09-28','14:20:00',4.55),('10318','2013-09-28','14:25:00',5.6),('10318','2013-09-28','14:30:00',3.17),('10318','2013-09-28','14:35:00',2.67),('10318','2013-09-28','14:40:00',2.55),('10318','2013-09-28','14:45:00',3.56),('10318','2013-09-28','14:50:00',2.7),('10318','2013-09-28','14:55:00',5.91),('10318','2013-09-28','15:00:00',6.8),('10318','2013-09-28','15:05:00',6.41),('10318','2013-09-28','15:10:00',6.22),('10318','2013-09-28','15:15:00',6.11),('10318','2013-09-28','15:20:00',5.93),('10318','2013-09-28','15:25:00',5.46),('10318','2013-09-28','15:30:00',5.54),('10318','2013-09-28','15:35:00',5.3),('10318','2013-09-28','15:40:00',5.41),('10318','2013-09-28','15:45:00',5.23),('10318','2013-09-28','15:50:00',5),('10318','2013-09-28','15:55:00',4.73),('10318','2013-09-28','16:00:00',4.35),('10318','2013-09-28','16:05:00',4.52),('10318','2013-09-28','16:10:00',4.39),('10318','2013-09-28','16:15:00',4.06),('10318','2013-09-28','16:20:00',3.78),('10318','2013-09-28','16:25:00',2.85),('10318','2013-09-28','16:30:00',3.49),('10318','2013-09-28','16:35:00',3.36),('10318','2013-09-28','16:40:00',3.15),('10318','2013-09-28','16:45:00',3.01),('10318','2013-09-28','16:50:00',2.86),('10318','2013-09-27','07:55:00',1.16),('10318','2013-09-27','08:00:00',1.26),('10318','2013-09-27','08:05:00',1.44),('10318','2013-09-27','08:10:00',1.26),('10318','2013-09-27','08:15:00',1.18),('10318','2013-09-27','08:20:00',1.61),('10318','2013-09-27','08:25:00',2.3),('10318','2013-09-27','08:30:00',3.29),('10318','2013-09-27','08:35:00',3.04),('10318','2013-09-27','08:40:00',3.43),('10318','2013-09-27','08:45:00',3.43),('10318','2013-09-27','08:50:00',3.36),('10318','2013-09-27','08:55:00',2.03),('10318','2013-09-27','09:00:00',3.79),('10318','2013-09-27','09:05:00',3.15),('10318','2013-09-27','09:10:00',2.61),('10318','2013-09-27','09:15:00',2.29),('10318','2013-09-27','09:20:00',1.96),('10318','2013-09-27','09:25:00',1.77),('10318','2013-09-27','09:30:00',2.07),('10318','2013-09-27','09:35:00',2.23),('10318','2013-09-27','09:40:00',1.83),('10318','2013-09-27','09:45:00',2.46),('10318','2013-09-27','09:50:00',2.72),('10318','2013-09-27','09:55:00',2.38),('10318','2013-09-27','10:00:00',2.49),('10318','2013-09-27','10:05:00',2.63),('10318','2013-09-27','10:10:00',2.35),('10318','2013-09-27','10:15:00',4.31),('10318','2013-09-27','10:20:00',3.63),('10318','2013-09-27','10:25:00',2.58),('10318','2013-09-27','10:30:00',2.78),('10318','2013-09-27','10:35:00',2.45),('10318','2013-09-27','10:40:00',8.15),('10318','2013-09-27','10:45:00',5.22),('10318','2013-09-27','10:50:00',7.91),('10318','2013-09-27','10:55:00',7.41),('10318','2013-09-27','11:00:00',7.57),('10318','2013-09-27','11:05:00',7.59),('10318','2013-09-27','11:10:00',7.15),('10318','2013-09-27','11:15:00',6.76),('10318','2013-09-27','11:20:00',6.51),('10318','2013-09-27','11:25:00',7.46),('10318','2013-09-27','11:30:00',5.61),('10318','2013-09-27','11:35:00',4.11),('10318','2013-09-27','11:40:00',7.68),('10318','2013-09-27','11:45:00',5.05),('10318','2013-09-27','11:50:00',6.82),('10318','2013-09-27','11:55:00',3.99),('10318','2013-09-27','12:00:00',2.51),('10318','2013-09-27','12:05:00',1.56),('10318','2013-09-27','12:10:00',1.14),('10318','2013-09-27','12:15:00',1.32),('10318','2013-09-27','12:20:00',1.39),('10318','2013-09-27','12:25:00',1.34),('10318','2013-09-27','12:30:00',1.67),('10318','2013-09-27','12:35:00',2.47),('10318','2013-09-27','12:40:00',7.94),('10318','2013-09-27','12:45:00',8.38),('10318','2013-09-27','12:50:00',8.06),('10318','2013-09-27','12:55:00',6.44),('10318','2013-09-27','13:00:00',8.58),('10318','2013-09-27','13:05:00',5.99),('10318','2013-09-27','13:10:00',5.14),('10318','2013-09-27','13:15:00',2.48),('10318','2013-09-27','13:20:00',2.18),('10318','2013-09-27','13:25:00',3.42),('10318','2013-09-27','13:30:00',4.4),('10318','2013-09-27','13:35:00',9.15),('10318','2013-09-27','13:40:00',8.73),('10318','2013-09-27','13:45:00',8.28),('10318','2013-09-27','13:50:00',6.38),('10318','2013-09-27','13:55:00',7.99),('10318','2013-09-27','14:00:00',7.8),('10318','2013-09-27','14:05:00',5.09),('10318','2013-09-27','14:10:00',6.43),('10318','2013-09-27','14:15:00',4.72),('10318','2013-09-27','14:20:00',7.82),('10318','2013-09-27','14:25:00',7.39),('10318','2013-09-27','14:30:00',7.19),('10318','2013-09-27','14:35:00',7.03),('10318','2013-09-27','14:40:00',5.03),('10318','2013-09-27','14:45:00',7.03),('10318','2013-09-27','14:50:00',6.88),('10318','2013-09-27','14:55:00',6.8),('10318','2013-09-27','15:00:00',5.22),('10318','2013-09-27','15:05:00',3.64),('10318','2013-09-27','15:10:00',3.29),('10318','2013-09-27','15:15:00',1.43),('10318','2013-09-27','15:20:00',3.05),('10318','2013-09-27','15:25:00',6.22),('10318','2013-09-27','15:30:00',2.18),('10318','2013-09-27','15:35:00',2.69),('10318','2013-09-27','15:40:00',5.38),('10318','2013-09-27','15:45:00',4.93),('10318','2013-09-27','15:50:00',3.41),('10318','2013-09-27','15:55:00',3.8),('10318','2013-09-27','16:00:00',5.21),('10318','2013-09-27','16:05:00',4.78),('10318','2013-09-27','16:10:00',4.42),('10318','2013-09-27','16:15:00',4.2),('10318','2013-09-27','16:20:00',4.05),('10318','2013-09-27','16:25:00',3.71),('10318','2013-09-27','16:30:00',3.51),('10318','2013-09-27','16:35:00',3.43),('10318','2013-09-27','16:40:00',3.36),('10318','2013-09-27','16:45:00',3.12),('10318','2013-09-27','16:50:00',1.87),('10318','2013-09-27','16:55:00',3.09),('10318','2013-09-27','17:00:00',2.72),('10318','2013-09-27','17:05:00',2.49),('10318','2013-09-27','17:10:00',2.35),('10318','2013-09-27','17:15:00',2.22),('10318','2013-09-27','17:20:00',1.29),('10318','2013-09-27','17:25:00',1.8),('10318','2013-09-27','17:30:00',1.48),('10318','2013-09-26','07:55:00',1.39),('10318','2013-09-26','08:00:00',1.56),('10318','2013-09-26','08:05:00',1.52),('10318','2013-09-26','08:10:00',2.39),('10318','2013-09-26','08:15:00',2.72),('10318','2013-09-26','08:20:00',2.67),('10318','2013-09-26','08:25:00',3.24),('10318','2013-09-26','08:30:00',3.4),('10318','2013-09-26','08:35:00',3.71),('10318','2013-09-26','08:40:00',3.93),('10318','2013-09-26','08:45:00',4.09),('10318','2013-09-26','08:50:00',4.3),('10318','2013-09-26','08:55:00',4.48),('10318','2013-09-26','09:00:00',4.78),('10318','2013-09-26','09:05:00',4.96),('10318','2013-09-26','09:10:00',5.09),('10318','2013-09-26','09:15:00',5.24),('10318','2013-09-26','09:20:00',5.4),('10318','2013-09-26','09:25:00',5.51),('10318','2013-09-26','09:30:00',5.71),('10318','2013-09-26','09:35:00',5.89),('10318','2013-09-26','09:40:00',6),('10318','2013-09-26','09:45:00',6.11),('10318','2013-09-26','09:50:00',6.27),('10318','2013-09-26','09:55:00',6.4),('10318','2013-09-26','10:00:00',6.52),('10318','2013-09-26','10:05:00',6.64),('10318','2013-09-26','10:10:00',6.7),('10318','2013-09-26','10:15:00',6.73),('10318','2013-09-26','10:20:00',6.81),('10318','2013-09-26','10:25:00',6.92),('10318','2013-09-26','10:30:00',7.07),('10318','2013-09-26','10:35:00',7.12),('10318','2013-09-26','10:40:00',7.08),('10318','2013-09-26','10:45:00',7.09),('10318','2013-09-26','10:50:00',7.48),('10318','2013-09-26','10:55:00',7.25),('10318','2013-09-26','11:00:00',7.27),('10318','2013-09-26','11:05:00',7.61),('10318','2013-09-26','11:10:00',7.61),('10318','2013-09-26','11:15:00',7.53),('10318','2013-09-26','11:20:00',7.73),('10318','2013-09-26','11:25:00',7.92),('10318','2013-09-26','11:30:00',8.07),('10318','2013-09-26','11:35:00',8.26),('10318','2013-09-26','11:40:00',6.75),('10318','2013-09-26','11:45:00',4.68),('10318','2013-09-26','11:50:00',7.16),('10318','2013-09-26','11:55:00',7.8),('10318','2013-09-26','12:00:00',6.92),('10318','2013-09-26','12:05:00',6.71),('10318','2013-09-26','12:10:00',3.82),('10318','2013-09-26','12:15:00',4.71),('10318','2013-09-26','12:20:00',5.67),('10318','2013-09-26','12:25:00',6.63),('10318','2013-09-26','12:30:00',4.26),('10318','2013-09-26','12:35:00',4.26),('10318','2013-09-26','12:40:00',6.88),('10318','2013-09-26','12:45:00',5.86),('10318','2013-09-26','12:50:00',3.5),('10318','2013-09-26','12:55:00',5.96),('10318','2013-09-26','13:00:00',5.13),('10318','2013-09-26','13:05:00',6.67),('10318','2013-09-26','13:10:00',9.05),('10318','2013-09-26','13:15:00',9.34),('10318','2013-09-26','13:20:00',6.8),('10318','2013-09-26','13:25:00',6.62),('10318','2013-09-26','13:30:00',3.68),('10318','2013-09-26','13:35:00',3.26),('10318','2013-09-26','13:40:00',3.77),('10318','2013-09-26','13:45:00',5.75),('10318','2013-09-26','13:50:00',5.23),('10318','2013-09-26','13:55:00',4.09),('10318','2013-09-26','14:00:00',4.56),('10318','2013-09-26','14:05:00',5.13),('10318','2013-09-26','14:10:00',5.19),('10318','2013-09-26','14:15:00',7.9),('10318','2013-09-26','14:20:00',7.88),('10318','2013-09-26','14:25:00',7.66),('10318','2013-09-26','14:30:00',7),('10318','2013-09-26','14:35:00',4.49),('10318','2013-09-26','14:40:00',7.7),('10318','2013-09-26','14:45:00',7.98),('10318','2013-09-26','14:50:00',4.62),('10318','2013-09-26','14:55:00',3.06),('10318','2013-09-26','15:00:00',1.89),('10318','2013-09-26','15:05:00',2.18),('10318','2013-09-26','15:10:00',2.22),('10318','2013-09-26','15:15:00',6.42),('10318','2013-09-26','15:20:00',2.46),('10318','2013-09-26','15:25:00',4.36),('10318','2013-09-26','15:30:00',1.59),('10318','2013-09-26','15:35:00',5.05),('10318','2013-09-26','15:40:00',5.98),('10318','2013-09-26','15:45:00',4.28),('10318','2013-09-26','15:50:00',3.31),('10318','2013-09-26','15:55:00',4.08),('10318','2013-09-26','16:00:00',4.84),('10318','2013-09-26','16:05:00',4.49),('10318','2013-09-26','16:10:00',4.41),('10318','2013-09-26','16:15:00',3.95),('10318','2013-09-26','16:20:00',3.87),('10318','2013-09-26','16:25:00',3.94),('10318','2013-09-26','16:30:00',3.75),('10318','2013-09-26','16:35:00',3.53),('10318','2013-09-26','16:40:00',3.36),('10318','2013-09-26','16:45:00',3.18),('10318','2013-09-26','16:50:00',3.01),('10318','2013-09-26','16:55:00',2.83),('10318','2013-09-26','17:00:00',2.65),('10318','2013-09-26','17:05:00',2.54),('10318','2013-09-26','17:10:00',2.44),('10318','2013-09-26','17:15:00',1.47),('10318','2013-09-26','17:20:00',1.91),('10318','2013-09-26','17:25:00',2.08),('10318','2013-09-26','17:30:00',1.91),('10318','2013-09-26','17:35:00',1.59),('10318','2013-09-26','17:40:00',1.49),('10318','2013-09-26','17:45:00',1.31),('10318','2013-09-26','17:50:00',1.13),('10318','2013-09-25','08:00:00',1.15),('10318','2013-09-25','08:05:00',1.73),('10318','2013-09-25','08:10:00',2.43),('10318','2013-09-25','08:15:00',2.7),('10318','2013-09-25','08:20:00',2.68),('10318','2013-09-25','08:25:00',3.05),('10318','2013-09-25','08:30:00',3.13),('10318','2013-09-25','08:35:00',1.75),('10318','2013-09-25','08:40:00',2.03),('10318','2013-09-25','08:45:00',1.81),('10318','2013-09-25','08:50:00',1.98),('10318','2013-09-25','08:55:00',2.62),('10318','2013-09-25','09:00:00',2.85),('10318','2013-09-25','09:05:00',3.05),('10318','2013-09-25','09:10:00',2.71),('10318','2013-09-25','09:15:00',4.57),('10318','2013-09-25','09:20:00',3.24),('10318','2013-09-25','09:25:00',4.98),('10318','2013-09-25','09:30:00',4.75),('10318','2013-09-25','09:35:00',6.3),('10318','2013-09-25','09:40:00',4.93),('10318','2013-09-25','09:45:00',2.12),('10318','2013-09-25','09:50:00',2.7),('10318','2013-09-25','09:55:00',2.4),('10318','2013-09-25','10:00:00',2.64),('10318','2013-09-25','10:05:00',6.55),('10318','2013-09-25','10:10:00',3.62),('10318','2013-09-25','10:15:00',2.87),('10318','2013-09-25','10:20:00',2.63),('10318','2013-09-25','10:25:00',6.73),('10318','2013-09-25','10:30:00',7.48),('10318','2013-09-25','10:35:00',3.77),('10318','2013-09-25','10:40:00',4.24),('10318','2013-09-25','10:45:00',1.52),('10318','2013-09-25','10:50:00',1.13),('10318','2013-09-25','10:55:00',1.06),('10318','2013-09-25','11:00:00',1.15),('10318','2013-09-25','11:05:00',6.4),('10318','2013-09-25','11:10:00',8.42),('10318','2013-09-25','11:15:00',8.27),('10318','2013-09-25','11:20:00',8.3),('10318','2013-09-25','11:25:00',8.36),('10318','2013-09-25','11:30:00',6.83),('10318','2013-09-25','11:35:00',8.09),('10318','2013-09-25','11:40:00',2.28),('10318','2013-09-25','11:45:00',2.02),('10318','2013-09-25','11:50:00',5.98),('10318','2013-09-25','11:55:00',8.74),('10318','2013-09-25','12:00:00',9.12),('10318','2013-09-25','12:05:00',8.03),('10318','2013-09-25','12:10:00',7.25),('10318','2013-09-25','12:15:00',9.77),('10318','2013-09-25','12:20:00',8.38),('10318','2013-09-25','12:25:00',2.48),('10318','2013-09-25','12:30:00',2.13),('10318','2013-09-25','12:35:00',1.93),('10318','2013-09-25','12:40:00',2.97),('10318','2013-09-25','12:45:00',8.94),('10318','2013-09-25','12:50:00',9.3),('10318','2013-09-25','12:55:00',9.02),('10318','2013-09-25','13:00:00',4.63),('10318','2013-09-25','13:05:00',8.33),('10318','2013-09-25','13:10:00',3.88),('10318','2013-09-25','13:15:00',2.67),('10318','2013-09-25','13:20:00',2.94),('10318','2013-09-25','13:25:00',8.94),('10318','2013-09-25','13:30:00',4.88),('10318','2013-09-25','13:35:00',9.64),('10318','2013-09-25','13:40:00',9.07),('10318','2013-09-25','13:45:00',9.07),('10318','2013-09-25','13:50:00',7.57),('10318','2013-09-25','13:55:00',9.19),('10318','2013-09-25','14:00:00',8.75),('10318','2013-09-25','14:05:00',7.01),('10318','2013-09-25','14:10:00',4.8),('10318','2013-09-25','14:15:00',3.65),('10318','2013-09-25','14:20:00',2.3),('10318','2013-09-25','14:25:00',2.35),('10318','2013-09-25','14:30:00',4.93),('10318','2013-09-25','14:35:00',8.79),('10318','2013-09-25','14:40:00',7.35),('10318','2013-09-25','14:45:00',3.94),('10318','2013-09-25','14:50:00',5.1),('10318','2013-09-25','14:55:00',7.46),('10318','2013-09-25','15:00:00',7.37),('10318','2013-09-25','15:05:00',6.6),('10318','2013-09-25','15:10:00',3.59),('10318','2013-09-25','15:15:00',4.89),('10318','2013-09-25','15:20:00',6.12),('10318','2013-09-25','15:25:00',6.3),('10318','2013-09-25','15:30:00',5.66),('10318','2013-09-25','15:35:00',5.81),('10318','2013-09-25','15:40:00',3.9),('10318','2013-09-25','15:45:00',4.75),('10318','2013-09-25','15:50:00',4.58),('10318','2013-09-25','15:55:00',1.79),('10318','2013-09-25','16:00:00',5.6),('10318','2013-09-25','16:05:00',5.02),('10318','2013-09-25','16:10:00',3.4),('10318','2013-09-25','16:15:00',3.25),('10318','2013-09-25','16:20:00',3.52),('10318','2013-09-25','16:25:00',4.18),('10318','2013-09-25','16:30:00',3.95),('10318','2013-09-25','16:35:00',3.72),('10318','2013-09-25','16:40:00',3.56),('10318','2013-09-25','16:45:00',3.37),('10318','2013-09-25','16:50:00',3.23),('10318','2013-09-25','16:55:00',2.97),('10318','2013-09-25','17:00:00',2.83),('10318','2013-09-25','17:05:00',2.67),('10318','2013-09-25','17:10:00',2.49),('10318','2013-09-25','17:15:00',2.34),('10318','2013-09-25','17:20:00',2.19),('10318','2013-09-25','17:25:00',2.03),('10318','2013-09-25','17:30:00',1.82),('10318','2013-09-25','17:35:00',1.7),('10318','2013-09-25','17:40:00',1.54),('10318','2013-09-25','17:45:00',1.4),('10318','2013-09-25','17:50:00',1.25),('10318','2013-09-25','17:55:00',1.1),('10318','2013-09-24','07:50:00',1.13),('10318','2013-09-24','07:55:00',1.29),('10318','2013-09-24','08:00:00',1.45),('10318','2013-09-24','08:05:00',2.04),('10318','2013-09-24','08:10:00',2.82),('10318','2013-09-24','08:15:00',3.12),('10318','2013-09-24','08:20:00',3.41),('10318','2013-09-24','08:25:00',3.57),('10318','2013-09-24','08:30:00',3.81),('10318','2013-09-24','08:35:00',3.96),('10318','2013-09-24','08:40:00',4.18),('10318','2013-09-24','08:45:00',4.37),('10318','2013-09-24','08:50:00',4.62),('10318','2013-09-24','08:55:00',4.79),('10318','2013-09-24','09:00:00',4.99),('10318','2013-09-24','09:05:00',5.16),('10318','2013-09-24','09:10:00',5.36),('10318','2013-09-24','09:15:00',5.51),('10318','2013-09-24','09:20:00',5.71),('10318','2013-09-24','09:25:00',5.88),('10318','2013-09-24','09:30:00',6.07),('10318','2013-09-24','09:35:00',6.17),('10318','2013-09-24','09:40:00',6.34),('10318','2013-09-24','09:45:00',6.44),('10318','2013-09-24','09:50:00',6.57),('10318','2013-09-24','09:55:00',6.68),('10318','2013-09-24','10:00:00',6.79),('10318','2013-09-24','10:05:00',6.89),('10318','2013-09-24','10:10:00',7.02),('10318','2013-09-24','10:15:00',7.13),('10318','2013-09-24','10:20:00',7.24),('10318','2013-09-24','10:25:00',7.33),('10318','2013-09-24','10:30:00',7.45),('10318','2013-09-24','10:35:00',7.53),('10318','2013-09-24','10:40:00',7.59),('10318','2013-09-24','10:45:00',7.66),('10318','2013-09-24','10:50:00',7.76),('10318','2013-09-24','10:55:00',7.79),('10318','2013-09-24','11:00:00',7.86),('10318','2013-09-24','11:05:00',7.78),('10318','2013-09-24','11:10:00',7.94),('10318','2013-09-24','11:15:00',8),('10318','2013-09-24','11:20:00',8.07),('10318','2013-09-24','11:25:00',8.1),('10318','2013-09-24','11:30:00',8.16),('10318','2013-09-24','11:35:00',8.15),('10318','2013-09-24','11:40:00',8.26),('10318','2013-09-24','11:45:00',8.24),('10318','2013-09-24','11:50:00',8.29),('10318','2013-09-24','11:55:00',8.22),('10318','2013-09-24','12:00:00',8.29),('10318','2013-09-24','12:05:00',8.37),('10318','2013-09-24','12:10:00',8.38),('10318','2013-09-24','12:15:00',8.43),('10318','2013-09-24','12:20:00',8.4),('10318','2013-09-24','12:25:00',8.41),('10318','2013-09-24','12:30:00',8.46),('10318','2013-09-24','12:35:00',8.43),('10318','2013-09-24','12:40:00',8.51),('10318','2013-09-24','12:45:00',8.45),('10318','2013-09-24','12:50:00',8.33),('10318','2013-09-24','12:55:00',8.47),('10318','2013-09-24','13:00:00',8.41),('10318','2013-09-24','13:05:00',8.45),('10318','2013-09-24','13:10:00',8.33),('10318','2013-09-24','13:15:00',8.24),('10318','2013-09-24','13:20:00',8.11),('10318','2013-09-24','13:25:00',8.11),('10318','2013-09-24','13:30:00',8.13),('10318','2013-09-24','13:35:00',8.13),('10318','2013-09-24','13:40:00',8.07),('10318','2013-09-24','13:45:00',7.98),('10318','2013-09-24','13:50:00',7.94),('10318','2013-09-24','13:55:00',7.82),('10318','2013-09-24','14:00:00',7.78),('10318','2013-09-24','14:05:00',7.7),('10318','2013-09-24','14:10:00',7.67),('10318','2013-09-24','14:15:00',7.57),('10318','2013-09-24','14:20:00',7.46),('10318','2013-09-24','14:25:00',7.39),('10318','2013-09-24','14:30:00',7.31),('10318','2013-09-24','14:35:00',7.14),('10318','2013-09-24','14:40:00',7.01),('10318','2013-09-24','14:45:00',6.92),('10318','2013-09-24','14:50:00',6.9),('10318','2013-09-24','14:55:00',6.72),('10318','2013-09-24','15:00:00',6.61),('10318','2013-09-24','15:05:00',6.53),('10318','2013-09-24','15:10:00',6.35),('10318','2013-09-24','15:15:00',6.27),('10318','2013-09-24','15:20:00',6.14),('10318','2013-09-24','15:25:00',6.03),('10318','2013-09-24','15:30:00',5.92),('10318','2013-09-24','15:35:00',5.76),('10318','2013-09-24','15:40:00',5.62),('10318','2013-09-24','15:45:00',5.47),('10318','2013-09-24','15:50:00',5.28),('10318','2013-09-24','15:55:00',5.1),('10318','2013-09-24','16:00:00',4.97),('10318','2013-09-24','16:05:00',4.8),('10318','2013-09-24','16:10:00',4.61),('10318','2013-09-24','16:15:00',4.46),('10318','2013-09-24','16:20:00',4.3),('10318','2013-09-24','16:25:00',4.11),('10318','2013-09-24','16:30:00',3.98),('10318','2013-09-24','16:35:00',3.82),('10318','2013-09-24','16:40:00',3.61),('10318','2013-09-24','16:45:00',3.44),('10318','2013-09-24','16:50:00',3.24),('10318','2013-09-24','16:55:00',3.07),('10318','2013-09-24','17:00:00',2.91),('10318','2013-09-24','17:05:00',2.74),('10318','2013-09-24','17:10:00',2.58),('10318','2013-09-24','17:15:00',2.44),('10318','2013-09-24','17:20:00',2.27),('10318','2013-09-24','17:25:00',2.11),('10318','2013-09-24','17:30:00',1.94),('10318','2013-09-24','17:35:00',1.73),('10318','2013-09-24','17:40:00',1.54),('10318','2013-09-24','17:45:00',1.47),('10318','2013-09-24','17:50:00',1.32),('10318','2013-09-24','17:55:00',1.16),('10318','2013-09-24','18:00:00',1.03),('10318','2013-09-23','07:50:00',1.12),('10318','2013-09-23','07:55:00',1.27),('10318','2013-09-23','08:00:00',1.43),('10318','2013-09-23','08:05:00',2.15),('10318','2013-09-23','08:10:00',2.89),('10318','2013-09-23','08:15:00',3.16),('10318','2013-09-23','08:20:00',3.47),('10318','2013-09-23','08:25:00',3.67),('10318','2013-09-23','08:30:00',3.91),('10318','2013-09-23','08:35:00',4.09),('10318','2013-09-23','08:40:00',4.34),('10318','2013-09-23','08:45:00',4.52),('10318','2013-09-23','08:50:00',4.75),('10318','2013-09-23','08:55:00',4.91),('10318','2013-09-23','09:00:00',5.12),('10318','2013-09-23','09:05:00',5.28),('10318','2013-09-23','09:10:00',5.5),('10318','2013-09-23','09:15:00',5.62),('10318','2013-09-23','09:20:00',5.81),('10318','2013-09-23','09:25:00',5.93),('10318','2013-09-23','09:30:00',6.08),('10318','2013-09-23','09:35:00',6.21),('10318','2013-09-23','09:40:00',6.38),('10318','2013-09-23','09:45:00',6.51),('10318','2013-09-23','09:50:00',6.68),('10318','2013-09-23','09:55:00',6.81),('10318','2013-09-23','10:00:00',6.95),('10318','2013-09-23','10:05:00',7.04),('10318','2013-09-23','10:10:00',7.17),('10318','2013-09-23','10:15:00',7.25),('10318','2013-09-23','10:20:00',7.43),('10318','2013-09-23','10:25:00',7.51),('10318','2013-09-23','10:30:00',7.6),('10318','2013-09-23','10:35:00',7.66),('10318','2013-09-23','10:40:00',7.79),('10318','2013-09-23','10:45:00',7.87),('10318','2013-09-23','10:50:00',7.95),('10318','2013-09-23','10:55:00',7.98),('10318','2013-09-23','11:00:00',8.07),('10318','2013-09-23','11:05:00',7.88),('10318','2013-09-23','11:10:00',8.24),('10318','2013-09-23','11:15:00',8.31),('10318','2013-09-23','11:20:00',8.45),('10318','2013-09-23','11:25:00',8.49),('10318','2013-09-23','11:30:00',8.51),('10318','2013-09-23','11:35:00',8.51),('10318','2013-09-23','11:40:00',8.6),('10318','2013-09-23','11:45:00',8.63),('10318','2013-09-23','11:50:00',8.66),('10318','2013-09-23','11:55:00',8.61),('10318','2013-09-23','12:00:00',8.69),('10318','2013-09-23','12:05:00',8.72),('10318','2013-09-23','12:10:00',8.75),('10318','2013-09-23','12:15:00',8.79),('10318','2013-09-23','12:20:00',8.82),('10318','2013-09-23','12:25:00',8.78),('10318','2013-09-23','12:30:00',8.72),('10318','2013-09-23','12:35:00',8.73),('10318','2013-09-23','12:40:00',8.65),('10318','2013-09-23','12:45:00',8.61),('10318','2013-09-23','12:50:00',8.46),('10318','2013-09-23','12:55:00',8.58),('10318','2013-09-23','13:00:00',8.51),('10318','2013-09-23','13:05:00',8.45),('10318','2013-09-23','13:10:00',8.4),('10318','2013-09-23','13:15:00',8.34),('10318','2013-09-23','13:20:00',8.28),('10318','2013-09-23','13:25:00',8.25),('10318','2013-09-23','13:30:00',8.16),('10318','2013-09-23','13:35:00',8.11),('10318','2013-09-23','13:40:00',8.05),('10318','2013-09-23','13:45:00',8.03),('10318','2013-09-23','13:50:00',7.87),('10318','2013-09-23','13:55:00',7.86),('10318','2013-09-23','14:00:00',7.76),('10318','2013-09-23','14:05:00',7.71),('10318','2013-09-23','14:10:00',7.66),('10318','2013-09-23','14:15:00',7.7),('10318','2013-09-23','14:20:00',7.62),('10318','2013-09-23','14:25:00',7.44),('10318','2013-09-23','14:30:00',7.23),('10318','2013-09-23','14:35:00',7.11),('10318','2013-09-23','14:40:00',7.03),('10318','2013-09-23','14:45:00',6.95),('10318','2013-09-23','14:50:00',6.87),('10318','2013-09-23','14:55:00',6.81),('10318','2013-09-23','15:00:00',6.73),('10318','2013-09-23','15:05:00',6.66),('10318','2013-09-23','15:10:00',6.49),('10318','2013-09-23','15:15:00',6.32),('10318','2013-09-23','15:20:00',6.13),('10318','2013-09-23','15:25:00',6.01),('10318','2013-09-23','15:30:00',5.97),('10318','2013-09-23','15:35:00',5.78),('10318','2013-09-23','15:40:00',5.55),('10318','2013-09-23','15:45:00',5.38),('10318','2013-09-23','15:50:00',5.05),('10318','2013-09-23','15:55:00',5.06),('10318','2013-09-23','16:00:00',4.86),('10318','2013-09-23','16:05:00',4.73),('10318','2013-09-23','16:10:00',3.75),('10318','2013-09-23','16:15:00',4.45),('10318','2013-09-23','16:20:00',4.24),('10318','2013-09-23','16:25:00',4.04),('10318','2013-09-23','16:30:00',3.91),('10318','2013-09-23','16:35:00',3.7),('10318','2013-09-23','16:40:00',3.51),('10318','2013-09-23','16:45:00',3.34),('10318','2013-09-23','16:50:00',3.16),('10318','2013-09-23','16:55:00',3),('10318','2013-09-23','17:00:00',2.79),('10318','2013-09-23','17:05:00',2.64),('10318','2013-09-23','17:10:00',2.5),('10318','2013-09-23','17:15:00',2.37),('10318','2013-09-23','17:20:00',2.21),('10318','2013-09-23','17:25:00',2.05),('10318','2013-09-23','17:30:00',1.9),('10318','2013-09-23','17:35:00',1.75),('10318','2013-09-23','17:40:00',1.55),('10318','2013-09-23','17:45:00',1.42),('10318','2013-09-23','17:50:00',1.27),('10318','2013-09-23','17:55:00',1.13),('10318','2013-09-22','07:50:00',1.2),('10318','2013-09-22','07:55:00',1.36),('10318','2013-09-22','08:00:00',1.53),('10318','2013-09-22','08:05:00',1.13),('10318','2013-09-22','08:10:00',1.7),('10318','2013-09-22','08:15:00',3.12),('10318','2013-09-22','08:20:00',3.44),('10318','2013-09-22','08:25:00',3.58),('10318','2013-09-22','08:30:00',3.77),('10318','2013-09-22','08:35:00',3.93),('10318','2013-09-22','08:40:00',4.15),('10318','2013-09-22','08:45:00',4.31),('10318','2013-09-22','08:50:00',4.58),('10318','2013-09-22','08:55:00',4.75),('10318','2013-09-22','09:00:00',5),('10318','2013-09-22','09:05:00',5.16),('10318','2013-09-22','09:10:00',5.35),('10318','2013-09-22','09:15:00',5.53),('10318','2013-09-22','09:20:00',5.7),('10318','2013-09-22','09:25:00',5.87),('10318','2013-09-22','09:30:00',6.01),('10318','2013-09-22','09:35:00',6.15),('10318','2013-09-22','09:40:00',6.29),('10318','2013-09-22','09:45:00',6.48),('10318','2013-09-22','09:50:00',6.45),('10318','2013-09-22','09:55:00',6.73),('10318','2013-09-22','10:00:00',6.89),('10318','2013-09-22','10:05:00',7.05),('10318','2013-09-22','10:10:00',7.18),('10318','2013-09-22','10:15:00',7.34),('10318','2013-09-22','10:20:00',7.47),('10318','2013-09-22','10:25:00',7.57),('10318','2013-09-22','10:30:00',7.65),('10318','2013-09-22','10:35:00',7.74),('10318','2013-09-22','10:40:00',7.85),('10318','2013-09-22','10:45:00',7.94),('10318','2013-09-22','10:50:00',8),('10318','2013-09-22','10:55:00',8.04),('10318','2013-09-22','11:00:00',8.06),('10318','2013-09-22','11:05:00',8.06),('10318','2013-09-22','11:10:00',8.22),('10318','2013-09-22','11:15:00',8.47),('10318','2013-09-22','11:20:00',8.52),('10318','2013-09-22','11:25:00',8.6),('10318','2013-09-22','11:30:00',8.62),('10318','2013-09-22','11:35:00',8.67),('10318','2013-09-22','11:40:00',8.78),('10318','2013-09-22','11:45:00',8.79),('10318','2013-09-22','11:50:00',8.79),('10318','2013-09-22','11:55:00',8.78),('10318','2013-09-22','12:00:00',8.81),('10318','2013-09-22','12:05:00',8.8),('10318','2013-09-22','12:10:00',8.81),('10318','2013-09-22','12:15:00',8.89),('10318','2013-09-22','12:20:00',8.87),('10318','2013-09-22','12:25:00',8.85),('10318','2013-09-22','12:30:00',8.83),('10318','2013-09-22','12:35:00',8.81),('10318','2013-09-22','12:40:00',8.88),('10318','2013-09-22','12:45:00',8.89),('10318','2013-09-22','12:50:00',8.89),('10318','2013-09-22','12:55:00',8.71),('10318','2013-09-22','13:00:00',8.8),('10318','2013-09-22','13:05:00',8.75),('10318','2013-09-22','13:10:00',8.75),('10318','2013-09-22','13:15:00',8.66),('10318','2013-09-22','13:20:00',8.6),('10318','2013-09-22','13:25:00',8.57),('10318','2013-09-22','13:30:00',8.51),('10318','2013-09-22','13:35:00',8.47),('10318','2013-09-22','13:40:00',8.36),('10318','2013-09-22','13:45:00',8.28),('10318','2013-09-22','13:50:00',8.26),('10318','2013-09-22','13:55:00',8.34),('10318','2013-09-22','14:00:00',8.37),('10318','2013-09-22','14:05:00',8.48),('10318','2013-09-22','14:10:00',8.19),('10318','2013-09-22','14:15:00',5.99),('10318','2013-09-22','14:20:00',5.28),('10318','2013-09-22','14:25:00',4.14),('10318','2013-09-22','14:30:00',1.71),('10318','2013-09-22','14:35:00',5.99),('10318','2013-09-22','14:40:00',7.66),('10318','2013-09-22','14:45:00',6.79),('10318','2013-09-22','14:50:00',7.26),('10318','2013-09-22','14:55:00',7.1),('10318','2013-09-22','15:00:00',7.15),('10318','2013-09-22','15:05:00',7.21),('10318','2013-09-22','15:10:00',7.29),('10318','2013-09-22','15:15:00',6.4),('10318','2013-09-22','15:20:00',7.59),('10318','2013-09-22','15:25:00',3.66),('10318','2013-09-22','15:30:00',2.36),('10318','2013-09-22','15:35:00',6.38),('10318','2013-09-22','15:40:00',6.47),('10318','2013-09-22','15:45:00',5.74),('10318','2013-09-22','15:50:00',5.51),('10318','2013-09-22','15:55:00',5.59),('10318','2013-09-22','16:00:00',5.19),('10318','2013-09-22','16:05:00',6.06),('10318','2013-09-22','16:10:00',6.17),('10318','2013-09-22','16:15:00',4.59),('10318','2013-09-22','16:20:00',3.44),('10318','2013-09-22','16:25:00',2.42),('10318','2013-09-22','16:30:00',2.8),('10318','2013-09-22','16:35:00',2.13),('10318','2013-09-22','16:40:00',2.08),('10318','2013-09-22','16:45:00',2.87),('10318','2013-09-22','16:50:00',2.57),('10318','2013-09-22','16:55:00',4.16),('10318','2013-09-22','17:00:00',3.74),('10318','2013-09-22','17:05:00',2.41),('10318','2013-09-22','17:10:00',2.19),('10318','2013-09-22','17:15:00',1.1),('10318','2013-09-22','17:30:00',1.34),('10318','2013-09-22','17:35:00',1.62),('10318','2013-09-22','17:55:00',1.1),('10318','2013-09-22','18:00:00',1.09),('10318','2013-09-21','07:50:00',1.16),('10318','2013-09-21','07:55:00',1.31),('10318','2013-09-21','08:00:00',1.56),('10318','2013-09-21','08:05:00',2.32),('10318','2013-09-21','08:10:00',2.88),('10318','2013-09-21','08:15:00',3.05),('10318','2013-09-21','08:20:00',3.36),('10318','2013-09-21','08:25:00',3.58),('10318','2013-09-21','08:30:00',3.72),('10318','2013-09-21','08:35:00',4),('10318','2013-09-21','08:40:00',4.22),('10318','2013-09-21','08:45:00',4.39),('10318','2013-09-21','08:50:00',4.62),('10318','2013-09-21','08:55:00',4.78),('10318','2013-09-21','09:00:00',4.98),('10318','2013-09-21','09:05:00',5.14),('10318','2013-09-21','09:10:00',5.33),('10318','2013-09-21','09:15:00',5.46),('10318','2013-09-21','09:20:00',5.65),('10318','2013-09-21','09:25:00',5.79),('10318','2013-09-21','09:30:00',5.96),('10318','2013-09-21','09:35:00',6.1),('10318','2013-09-21','09:40:00',6.28),('10318','2013-09-21','09:45:00',6.41),('10318','2013-09-21','09:50:00',6.54),('10318','2013-09-21','09:55:00',6.67),('10318','2013-09-21','10:00:00',6.83),('10318','2013-09-21','10:05:00',6.93),('10318','2013-09-21','10:10:00',7.05),('10318','2013-09-21','10:15:00',7.13),('10318','2013-09-21','10:20:00',7.07),('10318','2013-09-21','10:25:00',7.32),('10318','2013-09-21','10:30:00',7.4),('10318','2013-09-21','10:35:00',7.5),('10318','2013-09-21','10:40:00',7.58),('10318','2013-09-21','10:45:00',7.64),('10318','2013-09-21','10:50:00',7.77),('10318','2013-09-21','10:55:00',7.86),('10318','2013-09-21','11:00:00',7.93),('10318','2013-09-21','11:05:00',7.99),('10318','2013-09-21','11:10:00',8.08),('10318','2013-09-21','11:15:00',8.14),('10318','2013-09-21','11:20:00',8.18),('10318','2013-09-21','11:25:00',8.19),('10318','2013-09-21','11:30:00',8.26),('10318','2013-09-21','11:35:00',8.37),('10318','2013-09-21','11:40:00',8.44),('10318','2013-09-21','11:45:00',8.47),('10318','2013-09-21','11:50:00',8.34),('10318','2013-09-21','11:55:00',8.33),('10318','2013-09-21','12:00:00',8.56),('10318','2013-09-21','12:05:00',8.56),('10318','2013-09-21','12:10:00',8.55),('10318','2013-09-21','12:15:00',8.67),('10318','2013-09-21','12:20:00',8.06),('10318','2013-09-21','12:25:00',8.39),('10318','2013-09-21','12:30:00',8.79),('10318','2013-09-21','12:35:00',8.33),('10318','2013-09-21','12:40:00',7.61),('10318','2013-09-21','12:45:00',8.19),('10318','2013-09-21','12:50:00',8.5),('10318','2013-09-21','12:55:00',8.6),('10318','2013-09-21','13:00:00',8.28),('10318','2013-09-21','13:05:00',8.3),('10318','2013-09-21','13:10:00',8.55),('10318','2013-09-21','13:15:00',7.55),('10318','2013-09-21','13:20:00',6.68),('10318','2013-09-21','13:25:00',8.04),('10318','2013-09-21','13:30:00',7.97),('10318','2013-09-21','13:35:00',7.63),('10318','2013-09-21','13:40:00',6.71),('10318','2013-09-21','13:45:00',7.06),('10318','2013-09-21','13:50:00',7.51),('10318','2013-09-21','13:55:00',7.34),('10318','2013-09-21','14:00:00',7.39),('10318','2013-09-21','14:05:00',7.61),('10318','2013-09-21','14:10:00',7.36),('10318','2013-09-21','14:15:00',7.65),('10318','2013-09-21','14:20:00',7.53),('10318','2013-09-21','14:25:00',7.39),('10318','2013-09-21','14:30:00',7.31),('10318','2013-09-21','14:35:00',7.25),('10318','2013-09-21','14:40:00',7.01),('10318','2013-09-21','14:45:00',7),('10318','2013-09-21','14:50:00',6.91),('10318','2013-09-21','14:55:00',6.8),('10318','2013-09-21','15:00:00',6.69),('10318','2013-09-21','15:05:00',6.44),('10318','2013-09-21','15:10:00',6.24),('10318','2013-09-21','15:15:00',6.3),('10318','2013-09-21','15:20:00',6.13),('10318','2013-09-21','15:25:00',5.91),('10318','2013-09-21','15:30:00',5.85),('10318','2013-09-21','15:35:00',5.68),('10318','2013-09-21','15:40:00',4.65),('10318','2013-09-21','15:45:00',5),('10318','2013-09-21','15:50:00',4.92),('10318','2013-09-21','15:55:00',4.87),('10318','2013-09-21','16:00:00',3.44),('10318','2013-09-21','16:05:00',2.79),('10318','2013-09-21','16:10:00',2.83),('10318','2013-09-21','16:15:00',3.45),('10318','2013-09-21','16:20:00',2.45),('10318','2013-09-21','16:25:00',1.86),('10318','2013-09-21','16:30:00',2.86),('10318','2013-09-21','16:35:00',2.6),('10318','2013-09-21','16:40:00',1.82),('10318','2013-09-21','16:45:00',1.72),('10318','2013-09-21','16:50:00',2.13),('10318','2013-09-21','16:55:00',1.75),('10318','2013-09-21','17:00:00',1.71),('10318','2013-09-21','17:05:00',2.27),('10318','2013-09-21','17:10:00',1.82),('10318','2013-09-21','17:15:00',2.1),('10318','2013-09-21','17:20:00',1.05),('10318','2013-09-21','17:25:00',1.14),('10318','2013-09-21','17:30:00',1.72),('10318','2013-09-21','17:35:00',1.56),('10318','2013-09-21','17:40:00',1.9),('10318','2013-09-21','17:45:00',1.66),('10318','2013-09-21','17:50:00',1.31),('10318','2013-09-21','17:55:00',1.23),('10318','2013-09-21','18:00:00',1.09),('10318','2013-09-20','08:10:00',1.08),('10318','2013-09-20','08:15:00',1.23),('10318','2013-09-20','08:20:00',1.35),('10318','2013-09-20','08:25:00',1.5),('10318','2013-09-20','08:30:00',2.82),('10318','2013-09-20','08:35:00',3.52),('10318','2013-09-20','08:40:00',5.2),('10318','2013-09-20','08:45:00',3.84),('10318','2013-09-20','08:50:00',2.35),('10318','2013-09-20','08:55:00',2.26),('10318','2013-09-20','09:00:00',2.45),('10318','2013-09-20','09:05:00',2.46),('10318','2013-09-20','09:10:00',2.24),('10318','2013-09-20','09:15:00',2.39),('10318','2013-09-20','09:20:00',2.68),('10318','2013-09-20','09:25:00',2.63),('10318','2013-09-20','09:30:00',2.49),('10318','2013-09-20','09:35:00',2.61),('10318','2013-09-20','09:40:00',3.22),('10318','2013-09-20','09:45:00',2.95),('10318','2013-09-20','09:50:00',3.08),('10318','2013-09-20','09:55:00',3.29),('10318','2013-09-20','10:00:00',3.62),('10318','2013-09-20','10:05:00',3.93),('10318','2013-09-20','10:10:00',4.38),('10318','2013-09-20','10:15:00',4.23),('10318','2013-09-20','10:20:00',5.68),('10318','2013-09-20','10:25:00',4.04),('10318','2013-09-20','10:30:00',3.96),('10318','2013-09-20','10:35:00',4.16),('10318','2013-09-20','10:40:00',6.67),('10318','2013-09-20','10:45:00',5.92),('10318','2013-09-20','10:50:00',4.92),('10318','2013-09-20','10:55:00',7.05),('10318','2013-09-20','11:00:00',6.44),('10318','2013-09-20','11:05:00',4.4),('10318','2013-09-20','11:10:00',4.38),('10318','2013-09-20','11:15:00',5.55),('10318','2013-09-20','11:20:00',6.67),('10318','2013-09-20','11:25:00',6.72),('10318','2013-09-20','11:30:00',9.06),('10318','2013-09-20','11:35:00',10.69),('10318','2013-09-20','11:40:00',8.71),('10318','2013-09-20','11:45:00',9.63),('10318','2013-09-20','11:50:00',8.98),('10318','2013-09-20','11:55:00',8.99),('10318','2013-09-20','12:00:00',8.74),('10318','2013-09-20','12:05:00',8.67),('10318','2013-09-20','12:10:00',8.69),('10318','2013-09-20','12:15:00',8.9),('10318','2013-09-20','12:20:00',8.83),('10318','2013-09-20','12:25:00',5.98),('10318','2013-09-20','12:30:00',7.86),('10318','2013-09-20','12:35:00',9.67),('10318','2013-09-20','12:40:00',9.52),('10318','2013-09-20','12:45:00',9.34),('10318','2013-09-20','12:50:00',8.89),('10318','2013-09-20','12:55:00',8.56),('10318','2013-09-20','13:00:00',8.5),('10318','2013-09-20','13:05:00',8.49),('10318','2013-09-20','13:10:00',8.52),('10318','2013-09-20','13:15:00',8.48),('10318','2013-09-20','13:20:00',8.37),('10318','2013-09-20','13:25:00',5.76),('10318','2013-09-20','13:30:00',7.92),('10318','2013-09-20','13:35:00',8.26),('10318','2013-09-20','13:40:00',8.02),('10318','2013-09-20','13:45:00',8.17),('10318','2013-09-20','13:50:00',7.54),('10318','2013-09-20','13:55:00',7.88),('10318','2013-09-20','14:00:00',8.02),('10318','2013-09-20','14:05:00',8.09),('10318','2013-09-20','14:10:00',8.11),('10318','2013-09-20','14:15:00',8.03),('10318','2013-09-20','14:20:00',4.64),('10318','2013-09-20','14:25:00',7.27),('10318','2013-09-20','14:30:00',4.9),('10318','2013-09-20','14:35:00',5.85),('10318','2013-09-20','14:40:00',4.06),('10318','2013-09-20','14:45:00',5.69),('10318','2013-09-20','14:50:00',7.65),('10318','2013-09-20','14:55:00',7.2),('10318','2013-09-20','15:00:00',6.17),('10318','2013-09-20','15:05:00',3.04),('10318','2013-09-20','15:10:00',4.01),('10318','2013-09-20','15:15:00',2.16),('10318','2013-09-20','15:20:00',1.86),('10318','2013-09-20','15:25:00',1.87),('10318','2013-09-20','15:30:00',5.49),('10318','2013-09-20','15:35:00',6.71),('10318','2013-09-20','15:40:00',6.02),('10318','2013-09-20','15:45:00',6.04),('10318','2013-09-20','15:50:00',6),('10318','2013-09-20','15:55:00',5.94),('10318','2013-09-20','16:00:00',5.9),('10318','2013-09-20','16:05:00',5.33),('10318','2013-09-20','16:10:00',4.36),('10318','2013-09-20','16:15:00',3.18),('10318','2013-09-20','16:20:00',2.9),('10318','2013-09-20','16:25:00',3.24),('10318','2013-09-20','16:30:00',2.06),('10318','2013-09-20','16:35:00',1.77),('10318','2013-09-20','16:40:00',1.82),('10318','2013-09-20','16:45:00',2.41),('10318','2013-09-20','16:50:00',3.1),('10318','2013-09-20','16:55:00',3.41),('10318','2013-09-20','17:00:00',3.83),('10318','2013-09-20','17:05:00',3.99),('10318','2013-09-20','17:10:00',4.16),('10318','2013-09-20','17:15:00',3.97),('10318','2013-09-20','17:20:00',3.92),('10318','2013-09-20','17:25:00',3.52),('10318','2013-09-20','17:30:00',3.29),('10318','2013-09-20','17:35:00',3.19),('10318','2013-09-20','17:40:00',2.72),('10318','2013-09-20','17:45:00',2.88),('10318','2013-09-20','17:50:00',2.58),('10318','2013-09-20','17:55:00',1.75),('10318','2013-09-20','18:00:00',1.91),('10318','2013-09-20','18:05:00',2.15),('10318','2013-09-20','18:10:00',1.86),('10318','2013-09-20','18:15:00',1.37),('10318','2013-09-20','18:20:00',1.07),('10318','2013-09-19','08:00:00',1.17),('10318','2013-09-19','08:05:00',1.38),('10318','2013-09-19','08:10:00',2.4),('10318','2013-09-19','08:15:00',2.55),('10318','2013-09-19','08:20:00',2.81),('10318','2013-09-19','08:25:00',3.2),('10318','2013-09-19','08:30:00',3.61),('10318','2013-09-19','08:35:00',3.61),('10318','2013-09-19','08:40:00',3.29),('10318','2013-09-19','08:45:00',3.67),('10318','2013-09-19','08:50:00',3.62),('10318','2013-09-19','08:55:00',3.03),('10318','2013-09-19','09:00:00',2.12),('10318','2013-09-19','09:05:00',2.4),('10318','2013-09-19','09:10:00',2.61),('10318','2013-09-19','09:15:00',2.37),('10318','2013-09-19','09:20:00',3.6),('10318','2013-09-19','09:25:00',2.31),('10318','2013-09-19','09:30:00',2.84),('10318','2013-09-19','09:35:00',2.73),('10318','2013-09-19','09:40:00',1.68),('10318','2013-09-19','09:45:00',5.19),('10318','2013-09-19','09:50:00',5.57),('10318','2013-09-19','09:55:00',4.7),('10318','2013-09-19','10:00:00',5.29),('10318','2013-09-19','10:05:00',7.78),('10318','2013-09-19','10:10:00',7.92),('10318','2013-09-19','10:15:00',5.33),('10318','2013-09-19','10:20:00',4.62),('10318','2013-09-19','10:25:00',2.47),('10318','2013-09-19','10:30:00',5.12),('10318','2013-09-19','10:35:00',3.21),('10318','2013-09-19','10:40:00',6.65),('10318','2013-09-19','10:45:00',8.98),('10318','2013-09-19','10:50:00',7.6),('10318','2013-09-19','10:55:00',5.13),('10318','2013-09-19','11:00:00',7.31),('10318','2013-09-19','11:05:00',2.46),('10318','2013-09-19','11:10:00',3.01),('10318','2013-09-19','11:15:00',8.94),('10318','2013-09-19','11:20:00',8.05),('10318','2013-09-19','11:25:00',4.32),('10318','2013-09-19','11:30:00',4.54),('10318','2013-09-19','11:35:00',3.24),('10318','2013-09-19','11:40:00',5.88),('10318','2013-09-19','11:45:00',9),('10318','2013-09-19','11:50:00',9.96),('10318','2013-09-19','11:55:00',6.76),('10318','2013-09-19','12:00:00',5.3),('10318','2013-09-19','12:05:00',6.76),('10318','2013-09-19','12:10:00',8.12),('10318','2013-09-19','12:15:00',10.1),('10318','2013-09-19','12:20:00',6.43),('10318','2013-09-19','12:25:00',5.62),('10318','2013-09-19','12:30:00',8.18),('10318','2013-09-19','12:35:00',9.3),('10318','2013-09-19','12:40:00',7.18),('10318','2013-09-19','12:45:00',9.65),('10318','2013-09-19','12:50:00',9.8),('10318','2013-09-19','12:55:00',6.64),('10318','2013-09-19','13:00:00',9.52),('10318','2013-09-19','13:05:00',6.47),('10318','2013-09-19','13:10:00',7.59),('10318','2013-09-19','13:15:00',4.08),('10318','2013-09-19','13:20:00',7.69),('10318','2013-09-19','13:25:00',7.82),('10318','2013-09-19','13:30:00',8.93),('10318','2013-09-19','13:35:00',4.18),('10318','2013-09-19','13:40:00',4.29),('10318','2013-09-19','13:45:00',4.54),('10318','2013-09-19','13:50:00',4.52),('10318','2013-09-19','13:55:00',5.5),('10318','2013-09-19','14:00:00',7.04),('10318','2013-09-19','14:05:00',8.55),('10318','2013-09-19','14:10:00',8.11),('10318','2013-09-19','14:15:00',8.19),('10318','2013-09-19','14:20:00',7.92),('10318','2013-09-19','14:25:00',7.76),('10318','2013-09-19','14:30:00',7.64),('10318','2013-09-19','14:35:00',7.56),('10318','2013-09-19','14:40:00',7.48),('10318','2013-09-19','14:45:00',6.37),('10318','2013-09-19','14:50:00',7.2),('10318','2013-09-19','14:55:00',7.06),('10318','2013-09-19','15:00:00',7.35),('10318','2013-09-19','15:05:00',7),('10318','2013-09-19','15:10:00',7.1),('10318','2013-09-19','15:15:00',7.26),('10318','2013-09-19','15:20:00',7.3),('10318','2013-09-19','15:25:00',6.17),('10318','2013-09-19','15:30:00',6.51),('10318','2013-09-19','15:35:00',6.05),('10318','2013-09-19','15:40:00',6.14),('10318','2013-09-19','15:45:00',5.21),('10318','2013-09-19','15:50:00',5.55),('10318','2013-09-19','15:55:00',5.44),('10318','2013-09-19','16:00:00',5.25),('10318','2013-09-19','16:05:00',3.47),('10318','2013-09-19','16:10:00',1.99),('10318','2013-09-19','16:15:00',3.79),('10318','2013-09-19','16:20:00',4.86),('10318','2013-09-19','16:25:00',4.58),('10318','2013-09-19','16:30:00',3.95),('10318','2013-09-19','16:35:00',3.97),('10318','2013-09-19','16:40:00',3.77),('10318','2013-09-19','16:45:00',3.69),('10318','2013-09-19','16:50:00',3.72),('10318','2013-09-19','16:55:00',3.38),('10318','2013-09-19','17:00:00',2.76),('10318','2013-09-19','17:05:00',2.89),('10318','2013-09-19','17:10:00',2.73),('10318','2013-09-19','17:15:00',2.69),('10318','2013-09-19','17:20:00',2.52),('10318','2013-09-19','17:25:00',2.26),('10318','2013-09-19','17:30:00',1.8),('10318','2013-09-19','17:35:00',1.74),('10318','2013-09-19','17:40:00',1.67),('10318','2013-09-19','17:45:00',1.62),('10318','2013-09-19','17:50:00',1.5),('10318','2013-09-19','17:55:00',1.23),('10318','2013-09-19','18:00:00',1.09),('10318','2014-04-13','08:00:00',1.05),('10318','2014-04-13','08:05:00',1.06),('10318','2014-04-13','08:15:00',1),('10318','2014-04-13','08:25:00',1.2),('10318','2014-04-13','08:30:00',1.4),('10318','2014-04-13','08:35:00',1.57),('10318','2014-04-13','08:40:00',1.7),('10318','2014-04-13','08:45:00',1.68),('10318','2014-04-13','08:50:00',1.58),('10318','2014-04-13','08:55:00',1.96),('10318','2014-04-13','09:00:00',2.3),('10318','2014-04-13','09:05:00',3.31),('10318','2014-04-13','09:10:00',2.89),('10318','2014-04-13','09:15:00',2.66),('10318','2014-04-13','09:20:00',3.1),('10318','2014-04-13','09:25:00',3.63),('10318','2014-04-13','09:30:00',4.68),('10318','2014-04-13','09:35:00',4.8),('10318','2014-04-13','09:40:00',3.61),('10318','2014-04-13','09:45:00',3.46),('10318','2014-04-13','09:50:00',3.73),('10318','2014-04-13','09:55:00',4.53),('10318','2014-04-13','10:00:00',6.12),('10318','2014-04-13','10:05:00',8.18),('10318','2014-04-13','10:10:00',6.65),('10318','2014-04-13','10:15:00',5.17),('10318','2014-04-13','10:20:00',5.62),('10318','2014-04-13','10:25:00',4.56),('10318','2014-04-13','10:30:00',7.63),('10318','2014-04-13','10:35:00',7.99),('10318','2014-04-13','10:40:00',7.95),('10318','2014-04-13','10:45:00',8.8),('10318','2014-04-13','10:50:00',6.48),('10318','2014-04-13','10:55:00',9.08),('10318','2014-04-13','11:00:00',8.76),('10318','2014-04-13','11:05:00',7.33),('10318','2014-04-13','11:10:00',9.49),('10318','2014-04-13','11:15:00',9.68),('10318','2014-04-13','11:20:00',6.27),('10318','2014-04-13','11:25:00',5.5),('10318','2014-04-13','11:30:00',8.21),('10318','2014-04-13','11:35:00',7.9),('10318','2014-04-13','11:40:00',8.99),('10318','2014-04-13','11:45:00',8.6),('10318','2014-04-13','11:50:00',7.48),('10318','2014-04-13','11:55:00',5.69),('10318','2014-04-13','12:00:00',5.25),('10318','2014-04-13','12:05:00',3.64),('10318','2014-04-13','12:10:00',3.28),('10318','2014-04-13','12:15:00',3.49),('10318','2014-04-13','12:20:00',2.96),('10318','2014-04-13','12:25:00',2.02),('10318','2014-04-13','12:30:00',1.41),('10318','2014-04-13','12:35:00',1.25),('10318','2014-04-13','12:40:00',1.15),('10318','2014-04-13','12:45:00',1.36),('10318','2014-04-13','12:50:00',1.6),('10318','2014-04-13','12:55:00',2.02),('10318','2014-04-13','13:00:00',2.74),('10318','2014-04-13','13:05:00',4.12),('10318','2014-04-13','13:10:00',5.19),('10318','2014-04-13','13:15:00',8.37),('10318','2014-04-13','13:20:00',8.8),('10318','2014-04-13','13:25:00',9.69),('10318','2014-04-13','13:30:00',9.3),('10318','2014-04-13','13:35:00',9.66),('10318','2014-04-13','13:40:00',5.38),('10318','2014-04-13','13:45:00',5.09),('10318','2014-04-13','13:50:00',8.23),('10318','2014-04-13','13:55:00',8.52),('10318','2014-04-13','14:00:00',8.01),('10318','2014-04-13','14:05:00',9.41),('10318','2014-04-13','14:10:00',8.67),('10318','2014-04-13','14:15:00',6.86),('10318','2014-04-13','14:20:00',3.5),('10318','2014-04-13','14:25:00',4.21),('10318','2014-04-13','14:30:00',5.17),('10318','2014-04-13','14:35:00',4.24),('10318','2014-04-13','14:40:00',3.82),('10318','2014-04-13','14:45:00',6.6),('10318','2014-04-13','14:50:00',8.7),('10318','2014-04-13','14:55:00',8.38),('10318','2014-04-13','15:00:00',7.46),('10318','2014-04-13','15:05:00',8.27),('10318','2014-04-13','15:10:00',7.71),('10318','2014-04-13','15:15:00',6.38),('10318','2014-04-13','15:20:00',7.39),('10318','2014-04-13','15:25:00',7.58),('10318','2014-04-13','15:30:00',5.08),('10318','2014-04-13','15:35:00',4.58),('10318','2014-04-13','15:40:00',4.83),('10318','2014-04-13','15:45:00',3.58),('10318','2014-04-13','15:50:00',4.65),('10318','2014-04-13','15:55:00',5.36),('10318','2014-04-13','16:00:00',5.36),('10318','2014-04-13','16:05:00',3.12),('10318','2014-04-13','16:10:00',2.53),('10318','2014-04-13','16:15:00',2.54),('10318','2014-04-13','16:20:00',3.6),('10318','2014-04-13','16:25:00',3.05),('10318','2014-04-13','16:30:00',3.07),('10318','2014-04-13','16:35:00',3.29),('10318','2014-04-13','16:40:00',5.67),('10318','2014-04-13','16:45:00',4.25),('10318','2014-04-13','16:50:00',3.94),('10318','2014-04-13','16:55:00',3.84),('10318','2014-04-13','17:00:00',3.16),('10318','2014-04-13','17:05:00',3.02),('10318','2014-04-13','17:10:00',2.47),('10318','2014-04-13','17:15:00',2.39),('10318','2014-04-13','17:20:00',2.19),('10318','2014-04-13','17:25:00',2.2),('10318','2014-04-13','17:30:00',2.23),('10318','2014-04-13','17:35:00',2.04),('10318','2014-04-13','17:40:00',2.23),('10318','2014-04-13','17:45:00',1.81),('10318','2014-04-13','17:50:00',1.93),('10318','2014-04-13','17:55:00',2.18),('10318','2014-04-13','18:00:00',2.22),('10318','2014-04-13','18:05:00',2.04),('10318','2014-04-13','18:10:00',1.4),('10318','2014-04-13','18:15:00',1.2),('10318','2014-04-13','18:20:00',1.11),('10318','2013-09-18','07:45:00',1.06),('10318','2013-09-18','07:50:00',1.28),('10318','2013-09-18','07:55:00',1.48),('10318','2013-09-18','08:00:00',1.79),('10318','2013-09-18','08:05:00',2.26),('10318','2013-09-18','08:10:00',2.6),('10318','2013-09-18','08:15:00',2.8),('10318','2013-09-18','08:20:00',2.94),('10318','2013-09-18','08:25:00',2.99),('10318','2013-09-18','08:30:00',2.83),('10318','2013-09-18','08:35:00',2.6),('10318','2013-09-18','08:40:00',1.66),('10318','2013-09-18','08:45:00',2.14),('10318','2013-09-18','08:50:00',2.15),('10318','2013-09-18','08:55:00',2.86),('10318','2013-09-18','09:00:00',1.85),('10318','2013-09-18','09:05:00',1.62),('10318','2013-09-18','09:10:00',2.86),('10318','2013-09-18','09:15:00',4.69),('10318','2013-09-18','09:20:00',5.17),('10318','2013-09-18','09:25:00',2.54),('10318','2013-09-18','09:30:00',4.73),('10318','2013-09-18','09:35:00',6.55),('10318','2013-09-18','09:40:00',5.78),('10318','2013-09-18','09:45:00',7.32),('10318','2013-09-18','09:50:00',6.93),('10318','2013-09-18','09:55:00',3.64),('10318','2013-09-18','10:00:00',6.89),('10318','2013-09-18','10:05:00',6.1),('10318','2013-09-18','10:10:00',6.96),('10318','2013-09-18','10:15:00',7.14),('10318','2013-09-18','10:20:00',7.24),('10318','2013-09-18','10:25:00',7.36),('10318','2013-09-18','10:30:00',7.4),('10318','2013-09-18','10:35:00',7.53),('10318','2013-09-18','10:40:00',7.64),('10318','2013-09-18','10:45:00',7.77),('10318','2013-09-18','10:50:00',7.91),('10318','2013-09-18','10:55:00',6.81),('10318','2013-09-18','11:00:00',7.22),('10318','2013-09-18','11:05:00',5.56),('10318','2013-09-18','11:10:00',8.73),('10318','2013-09-18','11:15:00',7.15),('10318','2013-09-18','11:20:00',4.84),('10318','2013-09-18','11:25:00',6.06),('10318','2013-09-18','11:30:00',7.49),('10318','2013-09-18','11:35:00',6.01),('10318','2013-09-18','11:40:00',9.05),('10318','2013-09-18','11:45:00',8.71),('10318','2013-09-18','11:50:00',8.71),('10318','2013-09-18','11:55:00',8.89),('10318','2013-09-18','12:00:00',9.07),('10318','2013-09-18','12:05:00',8.89),('10318','2013-09-18','12:10:00',7.9),('10318','2013-09-18','12:15:00',8.82),('10318','2013-09-18','12:20:00',8.61),('10318','2013-09-18','12:25:00',8.78),('10318','2013-09-18','12:30:00',5.44),('10318','2013-09-18','12:35:00',8.39),('10318','2013-09-18','12:40:00',9.67),('10318','2013-09-18','12:45:00',9.42),('10318','2013-09-18','12:50:00',8.89),('10318','2013-09-18','12:55:00',8.07),('10318','2013-09-18','13:00:00',7.72),('10318','2013-09-18','13:05:00',6.48),('10318','2013-09-18','13:10:00',9.21),('10318','2013-09-18','13:15:00',8.98),('10318','2013-09-18','13:20:00',9.1),('10318','2013-09-18','13:25:00',9.06),('10318','2013-09-18','13:30:00',8.89),('10318','2013-09-18','13:35:00',6.07),('10318','2013-09-18','13:40:00',2.29),('10318','2013-09-18','13:45:00',3.12),('10318','2013-09-18','13:50:00',5.42),('10318','2013-09-18','13:55:00',8.45),('10318','2013-09-18','14:00:00',8.71),('10318','2013-09-18','14:05:00',8.47),('10318','2013-09-18','14:10:00',8.52),('10318','2013-09-18','14:15:00',5.41),('10318','2013-09-18','14:20:00',8.19),('10318','2013-09-18','14:25:00',8.01),('10318','2013-09-18','14:30:00',7.73),('10318','2013-09-18','14:35:00',7.73),('10318','2013-09-18','14:40:00',7.67),('10318','2013-09-18','14:45:00',7.55),('10318','2013-09-18','14:50:00',4.77),('10318','2013-09-18','14:55:00',6.78),('10318','2013-09-18','15:00:00',7.36),('10318','2013-09-18','15:05:00',7.05),('10318','2013-09-18','15:10:00',6.57),('10318','2013-09-18','15:15:00',6.87),('10318','2013-09-18','15:20:00',7.18),('10318','2013-09-18','15:25:00',6.08),('10318','2013-09-18','15:30:00',6.4),('10318','2013-09-18','15:35:00',6.69),('10318','2013-09-18','15:40:00',5.24),('10318','2013-09-18','15:45:00',6),('10318','2013-09-18','15:50:00',5.31),('10318','2013-09-18','15:55:00',2.9),('10318','2013-09-18','16:00:00',4.19),('10318','2013-09-18','16:05:00',5.11),('10318','2013-09-18','16:10:00',3.47),('10318','2013-09-18','16:15:00',4.7),('10318','2013-09-18','16:20:00',4.51),('10318','2013-09-18','16:25:00',4),('10318','2013-09-18','16:30:00',4.01),('10318','2013-09-18','16:35:00',3.56),('10318','2013-09-18','16:40:00',3.81),('10318','2013-09-18','16:45:00',3.41),('10318','2013-09-18','16:50:00',3.21),('10318','2013-09-18','16:55:00',3.03),('10318','2013-09-18','17:00:00',3.04),('10318','2013-09-18','17:05:00',2.85),('10318','2013-09-18','17:10:00',2.83),('10318','2013-09-18','17:15:00',1.82),('10318','2013-09-18','17:20:00',1.85),('10318','2013-09-18','17:25:00',2.42),('10318','2013-09-18','17:30:00',2.19),('10318','2013-09-18','17:35:00',1.95),('10318','2013-09-18','17:40:00',1.83),('10318','2013-09-18','17:45:00',1.66),('10318','2013-09-18','17:50:00',1.52),('10318','2013-09-18','17:55:00',1.37),('10318','2013-09-18','18:00:00',1.05),('10318','2013-09-17','08:15:00',1.16),('10318','2013-09-17','08:25:00',1.05),('10318','2013-09-17','08:35:00',1.19),('10318','2013-09-17','08:40:00',1.56),('10318','2013-09-17','08:45:00',1.55),('10318','2013-09-17','08:50:00',1.42),('10318','2013-09-17','08:55:00',1.28),('10318','2013-09-17','09:00:00',1.62),('10318','2013-09-17','09:05:00',1.69),('10318','2013-09-17','09:10:00',1.78),('10318','2013-09-17','09:15:00',2.03),('10318','2013-09-17','09:20:00',2),('10318','2013-09-17','09:25:00',2.26),('10318','2013-09-17','09:30:00',2.21),('10318','2013-09-17','09:35:00',1.64),('10318','2013-09-17','09:40:00',4.29),('10318','2013-09-17','09:45:00',4.77),('10318','2013-09-17','09:50:00',4.63),('10318','2013-09-17','09:55:00',2.55),('10318','2013-09-17','10:00:00',3.64),('10318','2013-09-17','10:05:00',6.05),('10318','2013-09-17','10:10:00',3.27),('10318','2013-09-17','10:15:00',1.22),('10318','2013-09-17','10:20:00',3.22),('10318','2013-09-17','10:25:00',4.02),('10318','2013-09-17','10:30:00',5.71),('10318','2013-09-17','10:35:00',3.17),('10318','2013-09-17','10:40:00',2.6),('10318','2013-09-17','10:45:00',9.28),('10318','2013-09-17','10:50:00',8.02),('10318','2013-09-17','10:55:00',6.54),('10318','2013-09-17','11:00:00',5.17),('10318','2013-09-17','11:05:00',7.25),('10318','2013-09-17','11:10:00',8.53),('10318','2013-09-17','11:15:00',6.07),('10318','2013-09-17','11:20:00',5.08),('10318','2013-09-17','11:25:00',4.17),('10318','2013-09-17','11:30:00',4.69),('10318','2013-09-17','11:35:00',7.58),('10318','2013-09-17','11:40:00',7.47),('10318','2013-09-17','11:45:00',9.74),('10318','2013-09-17','11:50:00',5.37),('10318','2013-09-17','11:55:00',8.91),('10318','2013-09-17','12:00:00',8.52),('10318','2013-09-17','12:05:00',7.6),('10318','2013-09-17','12:10:00',3.59),('10318','2013-09-17','12:15:00',7.04),('10318','2013-09-17','12:20:00',8.84),('10318','2013-09-17','12:25:00',8.79),('10318','2013-09-17','12:30:00',5.2),('10318','2013-09-17','12:35:00',5.04),('10318','2013-09-17','12:40:00',7),('10318','2013-09-17','12:45:00',3.97),('10318','2013-09-17','12:50:00',5.39),('10318','2013-09-17','12:55:00',7.27),('10318','2013-09-17','13:00:00',5.56),('10318','2013-09-17','13:05:00',5.53),('10318','2013-09-17','13:10:00',5.59),('10318','2013-09-17','13:15:00',6.38),('10318','2013-09-17','13:20:00',4.3),('10318','2013-09-17','13:25:00',4.13),('10318','2013-09-17','13:30:00',6.14),('10318','2013-09-17','13:35:00',4.79),('10318','2013-09-17','13:40:00',7.01),('10318','2013-09-17','13:45:00',4.53),('10318','2013-09-17','13:50:00',3.37),('10318','2013-09-17','13:55:00',3.17),('10318','2013-09-17','14:00:00',2.78),('10318','2013-09-17','14:05:00',1.83),('10318','2013-09-17','14:10:00',2.26),('10318','2013-09-17','14:15:00',3.08),('10318','2013-09-17','14:20:00',1.71),('10318','2013-09-17','14:25:00',2.39),('10318','2013-09-17','14:30:00',2.29),('10318','2013-09-17','14:35:00',2.52),('10318','2013-09-17','14:40:00',1.74),('10318','2013-09-17','14:45:00',2.03),('10318','2013-09-17','14:50:00',2.98),('10318','2013-09-17','14:55:00',7.14),('10318','2013-09-17','15:00:00',7.1),('10318','2013-09-17','15:05:00',6.02),('10318','2013-09-17','15:10:00',5.86),('10318','2013-09-17','15:15:00',4.53),('10318','2013-09-17','15:20:00',4.8),('10318','2013-09-17','15:25:00',3.89),('10318','2013-09-17','15:30:00',3),('10318','2013-09-17','15:35:00',2.13),('10318','2013-09-17','15:40:00',1.48),('10318','2013-09-17','15:45:00',5.62),('10318','2013-09-17','15:50:00',4.3),('10318','2013-09-17','15:55:00',3.55),('10318','2013-09-17','16:00:00',4.85),('10318','2013-09-17','16:05:00',4.02),('10318','2013-09-17','16:10:00',3.65),('10318','2013-09-17','16:15:00',3.87),('10318','2013-09-17','16:20:00',1.99),('10318','2013-09-17','16:25:00',1.33),('10318','2013-09-17','16:30:00',1.15),('10318','2013-09-17','16:35:00',1.9),('10318','2013-09-17','16:40:00',2.9),('10318','2013-09-17','16:45:00',3.26),('10318','2013-09-17','16:50:00',2.49),('10318','2013-09-17','16:55:00',2.3),('10318','2013-09-17','17:00:00',3.19),('10318','2013-09-17','17:05:00',3.38),('10318','2013-09-17','17:10:00',3.18),('10318','2013-09-17','17:15:00',3.07),('10318','2013-09-17','17:20:00',2.76),('10318','2013-09-17','17:25:00',2.69),('10318','2013-09-17','17:30:00',2.65),('10318','2013-09-17','17:35:00',2.52),('10318','2013-09-17','17:40:00',1.71),('10318','2013-09-17','17:45:00',1.46),('10318','2013-09-17','17:50:00',1.5),('10318','2013-09-17','17:55:00',1.41),('10318','2013-09-17','18:00:00',1.14),('10318','2013-09-17','18:05:00',1.02),('10318','2013-09-16','08:00:00',1.28),('10318','2013-09-16','08:05:00',2.16),('10318','2013-09-16','08:10:00',2.99),('10318','2013-09-16','08:15:00',3.08),('10318','2013-09-16','08:20:00',3.3),('10318','2013-09-16','08:25:00',3.59),('10318','2013-09-16','08:30:00',3.78),('10318','2013-09-16','08:35:00',4.05),('10318','2013-09-16','08:40:00',4.23),('10318','2013-09-16','08:45:00',4.48),('10318','2013-09-16','08:50:00',4.54),('10318','2013-09-16','08:55:00',5.05),('10318','2013-09-16','09:00:00',3.92),('10318','2013-09-16','09:05:00',4.5),('10318','2013-09-16','09:10:00',2.89),('10318','2013-09-16','09:15:00',3.42),('10318','2013-09-16','09:20:00',5.42),('10318','2013-09-16','09:25:00',5.13),('10318','2013-09-16','09:30:00',6.09),('10318','2013-09-16','09:35:00',6.24),('10318','2013-09-16','09:40:00',6.35),('10318','2013-09-16','09:45:00',6.49),('10318','2013-09-16','09:50:00',6.59),('10318','2013-09-16','09:55:00',6.34),('10318','2013-09-16','10:00:00',6.35),('10318','2013-09-16','10:05:00',7.45),('10318','2013-09-16','10:10:00',2.87),('10318','2013-09-16','10:15:00',4.28),('10318','2013-09-16','10:20:00',7.5),('10318','2013-09-16','10:25:00',7.24),('10318','2013-09-16','10:30:00',8.36),('10318','2013-09-16','10:35:00',9.09),('10318','2013-09-16','10:40:00',9.16),('10318','2013-09-16','10:45:00',2.4),('10318','2013-09-16','10:50:00',1.23),('10318','2013-09-16','10:55:00',1.25),('10318','2013-09-16','11:00:00',2.96),('10318','2013-09-16','11:05:00',7.2),('10318','2013-09-16','11:10:00',3.04),('10318','2013-09-16','11:15:00',3.11),('10318','2013-09-16','11:20:00',4.02),('10318','2013-09-16','11:25:00',9.21),('10318','2013-09-16','11:30:00',7.8),('10318','2013-09-16','11:35:00',5.37),('10318','2013-09-16','11:40:00',9.64),('10318','2013-09-16','11:45:00',9.27),('10318','2013-09-16','11:50:00',8.18),('10318','2013-09-16','11:55:00',9.18),('10318','2013-09-16','12:00:00',9.26),('10318','2013-09-16','12:05:00',8.3),('10318','2013-09-16','12:10:00',4.96),('10318','2013-09-16','12:15:00',9.82),('10318','2013-09-16','12:20:00',9.32),('10318','2013-09-16','12:25:00',9.09),('10318','2013-09-16','12:30:00',9.11),('10318','2013-09-16','12:35:00',8.98),('10318','2013-09-16','12:40:00',10.11),('10318','2013-09-16','12:45:00',4.8),('10318','2013-09-16','12:50:00',6.68),('10318','2013-09-16','12:55:00',3.24),('10318','2013-09-16','13:00:00',6.38),('10318','2013-09-16','13:05:00',6.68),('10318','2013-09-16','13:10:00',9.44),('10318','2013-09-16','13:15:00',9.07),('10318','2013-09-16','13:20:00',8.85),('10318','2013-09-16','13:25:00',8.75),('10318','2013-09-16','13:30:00',8.71),('10318','2013-09-16','13:35:00',8.73),('10318','2013-09-16','13:40:00',8.76),('10318','2013-09-16','13:45:00',8.16),('10318','2013-09-16','13:50:00',4.52),('10318','2013-09-16','13:55:00',8.35),('10318','2013-09-16','14:00:00',8.44),('10318','2013-09-16','14:05:00',8.29),('10318','2013-09-16','14:10:00',8.11),('10318','2013-09-16','14:15:00',8.02),('10318','2013-09-16','14:20:00',7.79),('10318','2013-09-16','14:25:00',7.82),('10318','2013-09-16','14:30:00',7.73),('10318','2013-09-16','14:35:00',7.62),('10318','2013-09-16','14:40:00',7.48),('10318','2013-09-16','14:45:00',7.4),('10318','2013-09-16','14:50:00',7.33),('10318','2013-09-16','14:55:00',7.27),('10318','2013-09-16','15:00:00',7.19),('10318','2013-09-16','15:05:00',7.02),('10318','2013-09-16','15:10:00',6.93),('10318','2013-09-16','15:15:00',6.79),('10318','2013-09-16','15:20:00',6.62),('10318','2013-09-16','15:25:00',6.48),('10318','2013-09-16','15:30:00',6.3),('10318','2013-09-16','15:35:00',6.15),('10318','2013-09-16','15:40:00',6.01),('10318','2013-09-16','15:45:00',5.86),('10318','2013-09-16','15:50:00',5.72),('10318','2013-09-16','15:55:00',5.6),('10318','2013-09-16','16:00:00',5.7),('10318','2013-09-16','16:05:00',5.33),('10318','2013-09-16','16:10:00',5.08),('10318','2013-09-16','16:15:00',4.92),('10318','2013-09-16','16:20:00',4.76),('10318','2013-09-16','16:25:00',4.61),('10318','2013-09-16','16:30:00',4.42),('10318','2013-09-16','16:35:00',4.19),('10318','2013-09-16','16:40:00',4.02),('10318','2013-09-16','16:45:00',3.81),('10318','2013-09-16','16:50:00',3.65),('10318','2013-09-16','16:55:00',3.46),('10318','2013-09-16','17:00:00',3.25),('10318','2013-09-16','17:05:00',3.06),('10318','2013-09-16','17:10:00',2.94),('10318','2013-09-16','17:15:00',2.76),('10318','2013-09-16','17:20:00',2.56),('10318','2013-09-16','17:25:00',2.44),('10318','2013-09-16','17:30:00',2.36),('10318','2013-09-16','17:35:00',2),('10318','2013-09-16','17:40:00',1.98),('10318','2013-09-16','17:45:00',1.88),('10318','2013-09-16','17:50:00',1.61),('10318','2013-09-16','17:55:00',1.45),('10318','2013-09-16','18:00:00',1.29),('10318','2013-09-16','18:05:00',1.17),('10318','2013-09-15','07:45:00',1.16),('10318','2013-09-15','07:50:00',1.34),('10318','2013-09-15','07:55:00',1.8),('10318','2013-09-15','08:00:00',2.17),('10318','2013-09-15','08:05:00',2.73),('10318','2013-09-15','08:10:00',2.96),('10318','2013-09-15','08:15:00',3.27),('10318','2013-09-15','08:20:00',3.56),('10318','2013-09-15','08:25:00',3.8),('10318','2013-09-15','08:30:00',4),('10318','2013-09-15','08:35:00',4.24),('10318','2013-09-15','08:40:00',4.48),('10318','2013-09-15','08:45:00',4.7),('10318','2013-09-15','08:50:00',4.64),('10318','2013-09-15','08:55:00',4.55),('10318','2013-09-15','09:00:00',4.94),('10318','2013-09-15','09:05:00',5.09),('10318','2013-09-15','09:10:00',5.34),('10318','2013-09-15','09:15:00',5.8),('10318','2013-09-15','09:20:00',5.58),('10318','2013-09-15','09:25:00',5.82),('10318','2013-09-15','09:30:00',6.01),('10318','2013-09-15','09:35:00',6.22),('10318','2013-09-15','09:40:00',6.4),('10318','2013-09-15','09:45:00',6.46),('10318','2013-09-15','09:50:00',6.41),('10318','2013-09-15','09:55:00',6.86),('10318','2013-09-15','10:00:00',6.91),('10318','2013-09-15','10:05:00',7.04),('10318','2013-09-15','10:10:00',6.72),('10318','2013-09-15','10:15:00',6.82),('10318','2013-09-15','10:20:00',7.11),('10318','2013-09-15','10:25:00',7.32),('10318','2013-09-15','10:30:00',6.81),('10318','2013-09-15','10:35:00',7.15),('10318','2013-09-15','10:40:00',8.02),('10318','2013-09-15','10:45:00',7.74),('10318','2013-09-15','10:50:00',8.12),('10318','2013-09-15','10:55:00',7.94),('10318','2013-09-15','11:00:00',3.05),('10318','2013-09-15','11:05:00',4.97),('10318','2013-09-15','11:10:00',3.9),('10318','2013-09-15','11:15:00',9.04),('10318','2013-09-15','11:20:00',9.5),('10318','2013-09-15','11:25:00',6.07),('10318','2013-09-15','11:30:00',2.78),('10318','2013-09-15','11:35:00',3.15),('10318','2013-09-15','11:40:00',9.07),('10318','2013-09-15','11:45:00',4.49),('10318','2013-09-15','11:50:00',2.81),('10318','2013-09-15','11:55:00',2.56),('10318','2013-09-15','12:00:00',3.24),('10318','2013-09-15','12:05:00',4.21),('10318','2013-09-15','12:10:00',3.96),('10318','2013-09-15','12:15:00',3.99),('10318','2013-09-15','12:20:00',3.97),('10318','2013-09-15','12:25:00',4.26),('10318','2013-09-15','12:30:00',3.48),('10318','2013-09-15','12:35:00',2.96),('10318','2013-09-15','12:40:00',2.86),('10318','2013-09-15','12:45:00',2.19),('10318','2013-09-15','12:50:00',2.49),('10318','2013-09-15','12:55:00',2.4),('10318','2013-09-15','13:00:00',2.12),('10318','2013-09-15','13:05:00',1.85),('10318','2013-09-15','13:10:00',1.77),('10318','2013-09-15','13:15:00',2.28),('10318','2013-09-15','13:20:00',3.97),('10318','2013-09-15','13:25:00',3.85),('10318','2013-09-15','13:30:00',3.17),('10318','2013-09-15','13:35:00',3.06),('10318','2013-09-15','13:40:00',3.02),('10318','2013-09-15','13:45:00',6.97),('10318','2013-09-15','13:50:00',3.82),('10318','2013-09-15','13:55:00',2.93),('10318','2013-09-15','14:00:00',5.16),('10318','2013-09-15','14:05:00',4.02),('10318','2013-09-15','14:10:00',4.05),('10318','2013-09-15','14:15:00',4.06),('10318','2013-09-15','14:20:00',3.38),('10318','2013-09-15','14:25:00',3.14),('10318','2013-09-15','14:30:00',2.87),('10318','2013-09-15','14:35:00',2.48),('10318','2013-09-15','14:40:00',2.58),('10318','2013-09-15','14:45:00',2.52),('10318','2013-09-15','14:50:00',2.48),('10318','2013-09-15','14:55:00',2.41),('10318','2013-09-15','15:00:00',2.52),('10318','2013-09-15','15:05:00',2.57),('10318','2013-09-15','15:10:00',3.31),('10318','2013-09-15','15:15:00',4.81),('10318','2013-09-15','15:20:00',3.88),('10318','2013-09-15','15:25:00',2.91),('10318','2013-09-15','15:30:00',2.3),('10318','2013-09-15','15:35:00',2.39),('10318','2013-09-15','15:40:00',2.25),('10318','2013-09-15','15:45:00',2.1),('10318','2013-09-15','15:50:00',1.96),('10318','2013-09-15','15:55:00',1.83),('10318','2013-09-15','16:00:00',1.56),('10318','2013-09-15','16:05:00',1.88),('10318','2013-09-15','16:10:00',1.47),('10318','2013-09-15','16:15:00',1.17),('10318','2013-09-15','16:20:00',1.25),('10318','2013-09-15','16:25:00',1.3),('10318','2013-09-15','16:30:00',1.39),('10318','2013-09-15','16:35:00',1.42),('10318','2013-09-15','16:40:00',1.79),('10318','2013-09-15','16:45:00',1.55),('10318','2013-09-15','16:50:00',1.2),('10318','2013-09-15','16:55:00',1.04),('10318','2013-09-15','17:00:00',1.38),('10318','2013-09-15','17:05:00',1.3),('10318','2013-09-15','17:10:00',1.2),('10318','2013-09-15','17:15:00',1.42),('10318','2013-09-15','17:20:00',1.67),('10318','2013-09-15','17:25:00',1.26),('10318','2013-09-15','17:30:00',1.34),('10318','2013-09-15','17:35:00',1.11),('10318','2013-09-15','18:00:00',1.3),('10318','2013-09-14','07:45:00',1.03),('10318','2013-09-14','07:50:00',1.26),('10318','2013-09-14','07:55:00',1.74),('10318','2013-09-14','08:00:00',2.15),('10318','2013-09-14','08:05:00',2.47),('10318','2013-09-14','08:10:00',2.87),('10318','2013-09-14','08:15:00',3.12),('10318','2013-09-14','08:20:00',3.44),('10318','2013-09-14','08:25:00',3.61),('10318','2013-09-14','08:30:00',3.85),('10318','2013-09-14','08:35:00',4.08),('10318','2013-09-14','08:40:00',4.29),('10318','2013-09-14','08:45:00',4.5),('10318','2013-09-14','08:50:00',4.63),('10318','2013-09-14','08:55:00',4.81),('10318','2013-09-14','09:00:00',5.01),('10318','2013-09-14','09:05:00',5.19),('10318','2013-09-14','09:10:00',5.41),('10318','2013-09-14','09:15:00',5.56),('10318','2013-09-14','09:20:00',4.35),('10318','2013-09-14','09:25:00',4.44),('10318','2013-09-14','09:30:00',6.06),('10318','2013-09-14','09:35:00',6.22),('10318','2013-09-14','09:40:00',6.28),('10318','2013-09-14','09:45:00',6.51),('10318','2013-09-14','09:50:00',6.6),('10318','2013-09-14','09:55:00',6.81),('10318','2013-09-14','10:00:00',6.91),('10318','2013-09-14','10:05:00',6.63),('10318','2013-09-14','10:10:00',6.69),('10318','2013-09-14','10:15:00',6.8),('10318','2013-09-14','10:20:00',7.16),('10318','2013-09-14','10:25:00',7.12),('10318','2013-09-14','10:30:00',7.5),('10318','2013-09-14','10:35:00',7.5),('10318','2013-09-14','10:40:00',7.94),('10318','2013-09-14','10:45:00',6.78),('10318','2013-09-14','10:50:00',1.6),('10318','2013-09-14','10:55:00',1.2),('10318','2013-09-14','11:00:00',1.48),('10318','2013-09-14','11:05:00',6.81),('10318','2013-09-14','11:10:00',8.79),('10318','2013-09-14','11:15:00',8.38),('10318','2013-09-14','11:20:00',8.05),('10318','2013-09-14','11:25:00',8.8),('10318','2013-09-14','11:30:00',6.83),('10318','2013-09-14','11:35:00',9.01),('10318','2013-09-14','11:40:00',8.63),('10318','2013-09-14','11:45:00',6.16),('10318','2013-09-14','11:50:00',3.5),('10318','2013-09-14','11:55:00',5.43),('10318','2013-09-14','12:00:00',3.76),('10318','2013-09-14','12:05:00',9.84),('10318','2013-09-14','12:10:00',9.78),('10318','2013-09-14','12:15:00',9.57),('10318','2013-09-14','12:20:00',9.26),('10318','2013-09-14','12:25:00',9),('10318','2013-09-14','12:30:00',9.31),('10318','2013-09-14','12:35:00',4.73),('10318','2013-09-14','12:40:00',8.39),('10318','2013-09-14','12:45:00',9.21),('10318','2013-09-14','12:50:00',9.47),('10318','2013-09-14','12:55:00',9.5),('10318','2013-09-14','13:00:00',6.05),('10318','2013-09-14','13:05:00',7.77),('10318','2013-09-14','13:10:00',9.27),('10318','2013-09-14','13:15:00',9.19),('10318','2013-09-14','13:20:00',9.04),('10318','2013-09-14','13:25:00',9),('10318','2013-09-14','13:30:00',7.43),('10318','2013-09-14','13:35:00',7.84),('10318','2013-09-14','13:40:00',4.08),('10318','2013-09-14','13:45:00',8.66),('10318','2013-09-14','13:50:00',8.66),('10318','2013-09-14','13:55:00',8.99),('10318','2013-09-14','14:00:00',8.6),('10318','2013-09-14','14:05:00',8.27),('10318','2013-09-14','14:10:00',8.16),('10318','2013-09-14','14:15:00',7.97),('10318','2013-09-14','14:20:00',7.95),('10318','2013-09-14','14:25:00',7.68),('10318','2013-09-14','14:30:00',7.77),('10318','2013-09-14','14:35:00',7.71),('10318','2013-09-14','14:40:00',7.62),('10318','2013-09-14','14:45:00',7.47),('10318','2013-09-14','14:50:00',7.25),('10318','2013-09-14','14:55:00',7.21),('10318','2013-09-14','15:00:00',7.06),('10318','2013-09-14','15:05:00',6.95),('10318','2013-09-14','15:10:00',6.85),('10318','2013-09-14','15:15:00',6.71),('10318','2013-09-14','15:20:00',6.55),('10318','2013-09-14','15:25:00',6.38),('10318','2013-09-14','15:30:00',6.3),('10318','2013-09-14','15:35:00',6.05),('10318','2013-09-14','15:40:00',6.06),('10318','2013-09-14','15:45:00',5.85),('10318','2013-09-14','15:50:00',5.72),('10318','2013-09-14','15:55:00',5.54),('10318','2013-09-14','16:00:00',5.39),('10318','2013-09-14','16:05:00',5.25),('10318','2013-09-14','16:10:00',5.13),('10318','2013-09-14','16:15:00',4.91),('10318','2013-09-14','16:20:00',4.77),('10318','2013-09-14','16:25:00',4.57),('10318','2013-09-14','16:30:00',2.98),('10318','2013-09-14','16:35:00',3.71),('10318','2013-09-14','16:40:00',3.93),('10318','2013-09-14','16:45:00',3.9),('10318','2013-09-14','16:50:00',3.51),('10318','2013-09-14','16:55:00',3.17),('10318','2013-09-14','17:00:00',3.5),('10318','2013-09-14','17:05:00',3.18),('10318','2013-09-14','17:10:00',2.99),('10318','2013-09-14','17:15:00',2.82),('10318','2013-09-14','17:20:00',2.64),('10318','2013-09-14','17:25:00',2.46),('10318','2013-09-14','17:30:00',2.32),('10318','2013-09-14','17:35:00',2.12),('10318','2013-09-14','17:40:00',1.98),('10318','2013-09-14','17:45:00',1.82),('10318','2013-09-14','17:50:00',1.72),('10318','2013-09-14','17:55:00',1.55),('10318','2013-09-14','18:00:00',1.38),('10318','2013-09-14','18:05:00',1.25),('10318','2013-09-14','18:10:00',1.15),('10318','2013-09-13','08:10:00',1.1),('10318','2013-09-13','08:15:00',1.31),('10318','2013-09-13','08:20:00',1.45),('10318','2013-09-13','08:25:00',1.64),('10318','2013-09-13','08:30:00',1.53),('10318','2013-09-13','08:35:00',1.56),('10318','2013-09-13','08:40:00',1.76),('10318','2013-09-13','08:45:00',2),('10318','2013-09-13','08:50:00',2.29),('10318','2013-09-13','08:55:00',2.26),('10318','2013-09-13','09:00:00',2.13),('10318','2013-09-13','09:05:00',2.04),('10318','2013-09-13','09:10:00',1.94),('10318','2013-09-13','09:15:00',2.06),('10318','2013-09-13','09:20:00',2.29),('10318','2013-09-13','09:25:00',2.54),('10318','2013-09-13','09:30:00',2.69),('10318','2013-09-13','09:35:00',4.12),('10318','2013-09-13','09:40:00',3.07),('10318','2013-09-13','09:45:00',2.92),('10318','2013-09-13','09:50:00',3.18),('10318','2013-09-13','09:55:00',4.4),('10318','2013-09-13','10:00:00',4.58),('10318','2013-09-13','10:05:00',6.41),('10318','2013-09-13','10:10:00',8.86),('10318','2013-09-13','10:15:00',6.25),('10318','2013-09-13','10:20:00',3.09),('10318','2013-09-13','10:25:00',6.88),('10318','2013-09-13','10:30:00',5.98),('10318','2013-09-13','10:35:00',7.37),('10318','2013-09-13','10:40:00',7.7),('10318','2013-09-13','10:45:00',8.04),('10318','2013-09-13','10:50:00',8.06),('10318','2013-09-13','10:55:00',8.11),('10318','2013-09-13','11:00:00',8.17),('10318','2013-09-13','11:05:00',8.27),('10318','2013-09-13','11:10:00',8.29),('10318','2013-09-13','11:15:00',8.34),('10318','2013-09-13','11:20:00',8.4),('10318','2013-09-13','11:25:00',8.44),('10318','2013-09-13','11:30:00',8.44),('10318','2013-09-13','11:35:00',8.48),('10318','2013-09-13','11:40:00',8.59),('10318','2013-09-13','11:45:00',8.65),('10318','2013-09-13','11:50:00',8.72),('10318','2013-09-13','11:55:00',8.69),('10318','2013-09-13','12:00:00',8.58),('10318','2013-09-13','12:05:00',8.69),('10318','2013-09-13','12:10:00',8.9),('10318','2013-09-13','12:15:00',9.02),('10318','2013-09-13','12:20:00',9.03),('10318','2013-09-13','12:25:00',4.3),('10318','2013-09-13','12:30:00',8.68),('10318','2013-09-13','12:35:00',8.57),('10318','2013-09-13','12:40:00',2.97),('10318','2013-09-13','12:45:00',9.51),('10318','2013-09-13','12:50:00',9.33),('10318','2013-09-13','12:55:00',9.06),('10318','2013-09-13','13:00:00',8.96),('10318','2013-09-13','13:05:00',8.93),('10318','2013-09-13','13:10:00',8.77),('10318','2013-09-13','13:15:00',8.7),('10318','2013-09-13','13:20:00',8.72),('10318','2013-09-13','13:25:00',8.57),('10318','2013-09-13','13:30:00',8.5),('10318','2013-09-13','13:35:00',8.49),('10318','2013-09-13','13:40:00',8.49),('10318','2013-09-13','13:45:00',8.32),('10318','2013-09-13','13:50:00',8.33),('10318','2013-09-13','13:55:00',8.28),('10318','2013-09-13','14:00:00',8.26),('10318','2013-09-13','14:05:00',8.22),('10318','2013-09-13','14:10:00',8.01),('10318','2013-09-13','14:15:00',7.47),('10318','2013-09-13','14:20:00',7.77),('10318','2013-09-13','14:25:00',7.84),('10318','2013-09-13','14:30:00',7.75),('10318','2013-09-13','14:35:00',7.72),('10318','2013-09-13','14:40:00',7.45),('10318','2013-09-13','14:45:00',7.36),('10318','2013-09-13','14:50:00',7.35),('10318','2013-09-13','14:55:00',7.22),('10318','2013-09-13','15:00:00',7.12),('10318','2013-09-13','15:05:00',7.13),('10318','2013-09-13','15:10:00',6.97),('10318','2013-09-13','15:15:00',6.78),('10318','2013-09-13','15:20:00',6.67),('10318','2013-09-13','15:25:00',6.58),('10318','2013-09-13','15:30:00',6.28),('10318','2013-09-13','15:35:00',6.31),('10318','2013-09-13','15:40:00',6.14),('10318','2013-09-13','15:45:00',5.98),('10318','2013-09-13','15:50:00',5.86),('10318','2013-09-13','15:55:00',5.68),('10318','2013-09-13','16:00:00',5.51),('10318','2013-09-13','16:05:00',5.34),('10318','2013-09-13','16:10:00',5.19),('10318','2013-09-13','16:15:00',4.98),('10318','2013-09-13','16:20:00',4.78),('10318','2013-09-13','16:25:00',4.63),('10318','2013-09-13','16:30:00',4.44),('10318','2013-09-13','16:35:00',4.27),('10318','2013-09-13','16:40:00',4.09),('10318','2013-09-13','16:45:00',3.9),('10318','2013-09-13','16:50:00',3.68),('10318','2013-09-13','16:55:00',3.54),('10318','2013-09-13','17:00:00',3.37),('10318','2013-09-13','17:05:00',3.17),('10318','2013-09-13','17:10:00',2.99),('10318','2013-09-13','17:15:00',2.83),('10318','2013-09-13','17:20:00',2.63),('10318','2013-09-13','17:25:00',2.49),('10318','2013-09-13','17:30:00',2.32),('10318','2013-09-13','17:35:00',2.16),('10318','2013-09-13','17:40:00',2.02),('10318','2013-09-13','17:45:00',1.85),('10318','2013-09-13','17:50:00',1.68),('10318','2013-09-13','17:55:00',1.54),('10318','2013-09-13','18:00:00',1.39),('10318','2013-09-13','18:05:00',1.23),('10318','2013-09-13','18:10:00',1.09),('10318','2013-09-12','07:50:00',1.48),('10318','2013-09-12','07:55:00',2.02),('10318','2013-09-12','08:00:00',1.77),('10318','2013-09-12','08:05:00',1.9),('10318','2013-09-12','08:10:00',2.34),('10318','2013-09-12','08:15:00',2.29),('10318','2013-09-12','08:20:00',3.22),('10318','2013-09-12','08:25:00',4.27),('10318','2013-09-12','08:30:00',3.95),('10318','2013-09-12','08:35:00',2.42),('10318','2013-09-12','08:40:00',1.69),('10318','2013-09-12','08:45:00',1.82),('10318','2013-09-12','08:50:00',3.07),('10318','2013-09-12','08:55:00',4.73),('10318','2013-09-12','09:00:00',5.03),('10318','2013-09-12','09:05:00',3.64),('10318','2013-09-12','09:10:00',4.05),('10318','2013-09-12','09:15:00',4.86),('10318','2013-09-12','09:20:00',4.82),('10318','2013-09-12','09:25:00',5.47),('10318','2013-09-12','09:30:00',5.71),('10318','2013-09-12','09:35:00',4.51),('10318','2013-09-12','09:40:00',3.95),('10318','2013-09-12','09:45:00',4.46),('10318','2013-09-12','09:50:00',2.83),('10318','2013-09-12','09:55:00',2.16),('10318','2013-09-12','10:00:00',2.66),('10318','2013-09-12','10:05:00',4.71),('10318','2013-09-12','10:10:00',5.04),('10318','2013-09-12','10:15:00',4.56),('10318','2013-09-12','10:20:00',2.88),('10318','2013-09-12','10:25:00',3.53),('10318','2013-09-12','10:30:00',3.3),('10318','2013-09-12','10:35:00',2.52),('10318','2013-09-12','10:40:00',1.22),('10318','2013-09-12','10:45:00',2.24),('10318','2013-09-12','10:50:00',4.2),('10318','2013-09-12','10:55:00',5.89),('10318','2013-09-12','11:00:00',7.73),('10318','2013-09-12','11:05:00',9.69),('10318','2013-09-12','11:10:00',8.87),('10318','2013-09-12','11:15:00',2.62),('10318','2013-09-12','11:35:00',2.16),('10318','2013-09-12','11:40:00',3.1),('10318','2013-09-12','11:45:00',3.41),('10318','2013-09-12','11:50:00',8.13),('10318','2013-09-12','11:55:00',9.61),('10318','2013-09-12','12:00:00',8.38),('10318','2013-09-12','12:05:00',9.37),('10318','2013-09-12','12:10:00',10),('10318','2013-09-12','12:15:00',7.48),('10318','2013-09-12','12:20:00',3.56),('10318','2013-09-12','12:25:00',4.47),('10318','2013-09-12','12:30:00',7.09),('10318','2013-09-12','12:35:00',9.79),('10318','2013-09-12','12:40:00',5.21),('10318','2013-09-12','12:45:00',4.75),('10318','2013-09-12','12:50:00',7.46),('10318','2013-09-12','12:55:00',8),('10318','2013-09-12','13:00:00',9.81),('10318','2013-09-12','13:05:00',7.38),('10318','2013-09-12','13:10:00',7.59),('10318','2013-09-12','13:15:00',8.44),('10318','2013-09-12','13:20:00',8.92),('10318','2013-09-12','13:25:00',8.92),('10318','2013-09-12','13:30:00',10.02),('10318','2013-09-12','13:35:00',6.1),('10318','2013-09-12','13:40:00',9.53),('10318','2013-09-12','13:45:00',9.08),('10318','2013-09-12','13:50:00',8.45),('10318','2013-09-12','13:55:00',8.55),('10318','2013-09-12','14:00:00',7.64),('10318','2013-09-12','14:05:00',8.76),('10318','2013-09-12','14:10:00',7.95),('10318','2013-09-12','14:15:00',8.87),('10318','2013-09-12','14:20:00',8.58),('10318','2013-09-12','14:25:00',8.34),('10318','2013-09-12','14:30:00',7.85),('10318','2013-09-12','14:35:00',5.62),('10318','2013-09-12','14:40:00',7.69),('10318','2013-09-12','14:45:00',7.61),('10318','2013-09-12','14:50:00',7.78),('10318','2013-09-12','14:55:00',7.67),('10318','2013-09-12','15:00:00',6.06),('10318','2013-09-12','15:05:00',7.55),('10318','2013-09-12','15:10:00',7.19),('10318','2013-09-12','15:15:00',7.04),('10318','2013-09-12','15:20:00',6.85),('10318','2013-09-12','15:25:00',6.75),('10318','2013-09-12','15:30:00',6.59),('10318','2013-09-12','15:35:00',6.43),('10318','2013-09-12','15:40:00',6.27),('10318','2013-09-12','15:45:00',6.15),('10318','2013-09-12','15:50:00',4.88),('10318','2013-09-12','15:55:00',6.03),('10318','2013-09-12','16:00:00',5.75),('10318','2013-09-12','16:05:00',5.4),('10318','2013-09-12','16:10:00',5.74),('10318','2013-09-12','16:15:00',3.15),('10318','2013-09-12','16:20:00',4.44),('10318','2013-09-12','16:25:00',1.98),('10318','2013-09-12','16:30:00',4.43),('10318','2013-09-12','16:35:00',4.48),('10318','2013-09-12','16:40:00',3.7),('10318','2013-09-12','16:45:00',3.99),('10318','2013-09-12','16:50:00',4.14),('10318','2013-09-12','16:55:00',3.64),('10318','2013-09-12','17:00:00',4.04),('10318','2013-09-12','17:05:00',3.19),('10318','2013-09-12','17:10:00',3.48),('10318','2013-09-12','17:15:00',3.26),('10318','2013-09-12','17:20:00',2.88),('10318','2013-09-12','17:25:00',2.72),('10318','2013-09-12','17:30:00',2.46),('10318','2013-09-12','17:35:00',1.62),('10318','2013-09-12','17:40:00',1.82),('10318','2013-09-12','17:45:00',1.96),('10318','2013-09-12','17:50:00',1.79),('10318','2013-09-12','17:55:00',1.62),('10318','2013-09-12','18:00:00',1.39),('10318','2013-09-12','18:05:00',1.48),('10318','2013-09-12','18:10:00',1.37),('10318','2013-09-12','18:15:00',1.09),('10318','2013-09-11','08:00:00',2.74),('10318','2013-09-11','08:05:00',2.96),('10318','2013-09-11','08:10:00',1.93),('10318','2013-09-11','08:15:00',1.56),('10318','2013-09-11','08:20:00',1.34),('10318','2013-09-11','08:25:00',1.99),('10318','2013-09-11','08:30:00',1.85),('10318','2013-09-11','08:35:00',1.52),('10318','2013-09-11','08:40:00',1.35),('10318','2013-09-11','08:45:00',1.56),('10318','2013-09-11','08:50:00',1.77),('10318','2013-09-11','08:55:00',2.08),('10318','2013-09-11','09:00:00',3.56),('10318','2013-09-11','09:05:00',4.94),('10318','2013-09-11','09:10:00',5.66),('10318','2013-09-11','09:15:00',4.96),('10318','2013-09-11','09:20:00',4.82),('10318','2013-09-11','09:25:00',2.74),('10318','2013-09-11','09:30:00',2.72),('10318','2013-09-11','09:35:00',2.54),('10318','2013-09-11','09:40:00',1.7),('10318','2013-09-11','09:45:00',1.49),('10318','2013-09-11','09:50:00',1.73),('10318','2013-09-11','09:55:00',2.17),('10318','2013-09-11','10:00:00',2.32),('10318','2013-09-11','10:05:00',2.53),('10318','2013-09-11','10:10:00',5.57),('10318','2013-09-11','10:15:00',7.49),('10318','2013-09-11','10:20:00',7.49),('10318','2013-09-11','10:25:00',7.56),('10318','2013-09-11','10:30:00',7.87),('10318','2013-09-11','10:35:00',6.6),('10318','2013-09-11','10:40:00',8.37),('10318','2013-09-11','10:45:00',6.12),('10318','2013-09-11','10:50:00',7.18),('10318','2013-09-11','10:55:00',2.53),('10318','2013-09-11','11:00:00',2.23),('10318','2013-09-11','11:05:00',6.39),('10318','2013-09-11','11:10:00',9.39),('10318','2013-09-11','11:15:00',7.71),('10318','2013-09-11','11:20:00',8.45),('10318','2013-09-11','11:25:00',8.85),('10318','2013-09-11','11:30:00',8.28),('10318','2013-09-11','11:35:00',8.99),('10318','2013-09-11','11:40:00',8.71),('10318','2013-09-11','11:45:00',8.9),('10318','2013-09-11','11:50:00',9.15),('10318','2013-09-11','11:55:00',6.97),('10318','2013-09-11','12:00:00',9.57),('10318','2013-09-11','12:05:00',7.75),('10318','2013-09-11','12:10:00',5.23),('10318','2013-09-11','12:15:00',8.39),('10318','2013-09-11','12:20:00',8.21),('10318','2013-09-11','12:25:00',6.86),('10318','2013-09-11','12:30:00',9.04),('10318','2013-09-11','12:35:00',4.8),('10318','2013-09-11','12:40:00',2.66),('10318','2013-09-11','12:45:00',5.37),('10318','2013-09-11','12:50:00',2.46),('10318','2013-09-11','12:55:00',9.17),('10318','2013-09-11','13:00:00',8.11),('10318','2013-09-11','13:05:00',9.05),('10318','2013-09-11','13:10:00',5.29),('10318','2013-09-11','13:15:00',5.05),('10318','2013-09-11','13:20:00',8.93),('10318','2013-09-11','13:25:00',9.42),('10318','2013-09-11','13:30:00',6.53),('10318','2013-09-11','13:35:00',8.09),('10318','2013-09-11','13:40:00',5.3),('10318','2013-09-11','13:45:00',9.55),('10318','2013-09-11','13:50:00',7.95),('10318','2013-09-11','13:55:00',6.24),('10318','2013-09-11','14:00:00',8.9),('10318','2013-09-11','14:05:00',8.4),('10318','2013-09-11','14:10:00',8.37),('10318','2013-09-11','14:15:00',8.21),('10318','2013-09-11','14:20:00',8.38),('10318','2013-09-11','14:25:00',7.07),('10318','2013-09-11','14:30:00',8.36),('10318','2013-09-11','14:35:00',6.03),('10318','2013-09-11','14:40:00',4.45),('10318','2013-09-11','14:45:00',4.45),('10318','2013-09-11','14:50:00',8.12),('10318','2013-09-11','14:55:00',8.19),('10318','2013-09-11','15:00:00',3.95),('10318','2013-09-11','15:05:00',7.81),('10318','2013-09-11','15:10:00',4.31),('10318','2013-09-11','15:15:00',2.5),('10318','2013-09-11','15:20:00',8.17),('10318','2013-09-11','15:25:00',4.34),('10318','2013-09-11','15:30:00',2.13),('10318','2013-09-11','15:35:00',2.68),('10318','2013-09-11','15:40:00',4.49),('10318','2013-09-11','15:45:00',5.6),('10318','2013-09-11','15:50:00',5.2),('10318','2013-09-11','15:55:00',4.66),('10318','2013-09-11','16:00:00',3.09),('10318','2013-09-11','16:05:00',2.83),('10318','2013-09-11','16:10:00',3.12),('10318','2013-09-11','16:15:00',4.93),('10318','2013-09-11','16:20:00',5.12),('10318','2013-09-11','16:25:00',2.72),('10318','2013-09-11','16:30:00',1.75),('10318','2013-09-11','16:35:00',4.04),('10318','2013-09-11','16:40:00',1.51),('10318','2013-09-11','16:45:00',3.5),('10318','2013-09-11','16:50:00',3.62),('10318','2013-09-11','16:55:00',3.86),('10318','2013-09-11','17:00:00',2.77),('10318','2013-09-11','17:05:00',2.74),('10318','2013-09-11','17:10:00',3.11),('10318','2013-09-11','17:15:00',2.9),('10318','2013-09-11','17:20:00',2.72),('10318','2013-09-11','17:25:00',2.6),('10318','2013-09-11','17:30:00',1.3),('10318','2013-09-11','17:35:00',1.58),('10318','2013-09-11','17:40:00',1.34),('10318','2013-09-11','17:45:00',1.75),('10318','2013-09-11','17:50:00',1.87),('10318','2013-09-11','17:55:00',1.51),('10318','2013-09-11','18:00:00',1.46),('10318','2013-09-11','18:05:00',1.33),('10318','2013-09-11','18:10:00',1.13),('10318','2013-09-10','07:50:00',1.39),('10318','2013-09-10','07:55:00',1.84),('10318','2013-09-10','08:00:00',1.94),('10318','2013-09-10','08:10:00',2),('10318','2013-09-10','08:15:00',2.21),('10318','2013-09-10','08:20:00',1.87),('10318','2013-09-10','08:25:00',1.5),('10318','2013-09-10','08:30:00',1.54),('10318','2013-09-10','08:35:00',1.89),('10318','2013-09-10','08:40:00',1.51),('10318','2013-09-10','08:45:00',1.65),('10318','2013-09-10','08:50:00',3.61),('10318','2013-09-10','08:55:00',3.47),('10318','2013-09-10','09:00:00',4.66),('10318','2013-09-10','09:05:00',5.55),('10318','2013-09-10','09:10:00',6.17),('10318','2013-09-10','09:15:00',4.18),('10318','2013-09-10','09:20:00',3.99),('10318','2013-09-10','09:25:00',4.24),('10318','2013-09-10','09:30:00',7.1),('10318','2013-09-10','09:35:00',5.62),('10318','2013-09-10','09:40:00',3.32),('10318','2013-09-10','09:45:00',2.79),('10318','2013-09-10','09:50:00',2.73),('10318','2013-09-10','09:55:00',2.24),('10318','2013-09-10','10:00:00',1.52),('10318','2013-09-10','10:05:00',1.26),('10318','2013-09-10','10:10:00',1.29),('10318','2013-09-10','10:15:00',1.39),('10318','2013-09-10','10:20:00',1.99),('10318','2013-09-10','10:25:00',2.27),('10318','2013-09-10','10:30:00',2.12),('10318','2013-09-10','10:35:00',2.54),('10318','2013-09-10','10:40:00',3.53),('10318','2013-09-10','10:45:00',3.96),('10318','2013-09-10','10:50:00',2.72),('10318','2013-09-10','10:55:00',3.12),('10318','2013-09-10','11:00:00',4.17),('10318','2013-09-10','11:05:00',2.79),('10318','2013-09-10','11:10:00',2.95),('10318','2013-09-10','11:15:00',2.61),('10318','2013-09-10','11:20:00',2.7),('10318','2013-09-10','11:25:00',1.84),('10318','2013-09-10','11:30:00',2.04),('10318','2013-09-10','11:35:00',1.44),('10318','2013-09-10','11:40:00',1.87),('10318','2013-09-10','11:45:00',2.53),('10318','2013-09-10','11:50:00',2.71),('10318','2013-09-10','11:55:00',3.61),('10318','2013-09-10','12:00:00',3.53),('10318','2013-09-10','12:05:00',2.62),('10318','2013-09-10','12:10:00',2.68),('10318','2013-09-10','12:15:00',3.6),('10318','2013-09-10','12:20:00',3.27),('10318','2013-09-10','12:25:00',2.71),('10318','2013-09-10','12:30:00',2.23),('10318','2013-09-10','12:35:00',1.82),('10318','2013-09-10','12:40:00',1.26),('10318','2013-09-10','12:45:00',1.45),('10318','2013-09-10','12:50:00',1.51),('10318','2013-09-10','12:55:00',1.65),('10318','2013-09-10','13:00:00',1.8),('10318','2013-09-10','13:05:00',1.65),('10318','2013-09-10','13:10:00',1.6),('10318','2013-09-10','13:15:00',2.08),('10318','2013-09-10','13:20:00',2.08),('10318','2013-09-10','13:25:00',2.45),('10318','2013-09-10','13:30:00',2.18),('10318','2013-09-10','13:35:00',2.62),('10318','2013-09-10','13:40:00',4.37),('10318','2013-09-10','13:45:00',5.7),('10318','2013-09-10','13:50:00',4.08),('10318','2013-09-10','13:55:00',3.4),('10318','2013-09-10','14:00:00',2.66),('10318','2013-09-10','14:05:00',2.81),('10318','2013-09-10','14:10:00',2.99),('10318','2013-09-10','14:15:00',3.56),('10318','2013-09-10','14:20:00',3.67),('10318','2013-09-10','14:25:00',5.24),('10318','2013-09-10','14:30:00',4.33),('10318','2013-09-10','14:35:00',3.09),('10318','2013-09-10','14:40:00',3.54),('10318','2013-09-10','14:45:00',4.09),('10318','2013-09-10','14:50:00',4.96),('10318','2013-09-10','14:55:00',4.11),('10318','2013-09-10','15:00:00',5.53),('10318','2013-09-10','15:05:00',4.71),('10318','2013-09-10','15:10:00',4.54),('10318','2013-09-10','15:15:00',2.86),('10318','2013-09-10','15:20:00',3.92),('10318','2013-09-10','15:25:00',3.56),('10318','2013-09-10','15:30:00',4.68),('10318','2013-09-10','15:35:00',3.83),('10318','2013-09-10','15:40:00',2.68),('10318','2013-09-10','15:45:00',2.37),('10318','2013-09-10','15:50:00',2.41),('10318','2013-09-10','15:55:00',2.17),('10318','2013-09-10','16:00:00',2.03),('10318','2013-09-10','16:05:00',2.15),('10318','2013-09-10','16:10:00',2.92),('10318','2013-09-10','16:15:00',3.03),('10318','2013-09-10','16:20:00',2.09),('10318','2013-09-10','16:25:00',1.94),('10318','2013-09-10','16:30:00',1.6),('10318','2013-09-10','16:35:00',1.01),('10318','2013-09-10','16:40:00',1.05),('10318','2013-09-10','16:45:00',1.64),('10318','2013-09-10','16:50:00',1.91),('10318','2013-09-10','16:55:00',1.78),('10318','2013-09-10','17:00:00',1.54),('10318','2013-09-10','17:05:00',1.38),('10318','2013-09-10','17:10:00',1.36),('10318','2013-09-10','17:15:00',1.76),('10318','2013-09-10','17:20:00',1.68),('10318','2013-09-10','17:25:00',1.61),('10318','2013-09-10','17:30:00',1.45),('10318','2013-09-10','17:35:00',1.22),('10318','2013-09-10','17:40:00',1.28),('10318','2013-09-10','17:45:00',1.48),('10318','2013-09-10','17:50:00',1.61),('10318','2013-09-10','17:55:00',1.27),('10318','2013-09-10','18:00:00',1.09),('10318','2013-09-09','07:30:00',1.24),('10318','2013-09-09','07:35:00',1.65),('10318','2013-09-09','07:40:00',2.12),('10318','2013-09-09','07:45:00',2.22),('10318','2013-09-09','07:50:00',2.11),('10318','2013-09-09','07:55:00',2.09),('10318','2013-09-09','08:00:00',1.79),('10318','2013-09-09','08:05:00',1.23),('10318','2013-09-09','08:10:00',1.11),('10318','2013-09-09','08:15:00',1.17),('10318','2013-09-09','08:20:00',1.24),('10318','2013-09-09','08:25:00',1.28),('10318','2013-09-09','08:30:00',1.21),('10318','2013-09-09','08:35:00',1.26),('10318','2013-09-09','08:40:00',1.57),('10318','2013-09-09','08:45:00',1.94),('10318','2013-09-09','08:50:00',2.26),('10318','2013-09-09','08:55:00',2.65),('10318','2013-09-09','09:00:00',2.76),('10318','2013-09-09','09:05:00',2.43),('10318','2013-09-09','09:10:00',2.13),('10318','2013-09-09','09:15:00',1.65),('10318','2013-09-09','09:20:00',1.8),('10318','2013-09-09','09:30:00',1.62),('10318','2013-09-09','09:35:00',2.23),('10318','2013-09-09','09:40:00',1.57),('10318','2013-09-09','09:50:00',1.61),('10318','2013-09-09','09:55:00',2.44),('10318','2013-09-09','10:00:00',3.26),('10318','2013-09-09','10:05:00',3.82),('10318','2013-09-09','10:10:00',4),('10318','2013-09-09','10:15:00',3.92),('10318','2013-09-09','10:20:00',3.42),('10318','2013-09-09','10:25:00',2.81),('10318','2013-09-09','10:30:00',3.29),('10318','2013-09-09','10:35:00',4.03),('10318','2013-09-09','10:40:00',4.01),('10318','2013-09-09','10:45:00',4.03),('10318','2013-09-09','10:50:00',6.69),('10318','2013-09-09','10:55:00',5.95),('10318','2013-09-09','11:00:00',5.99),('10318','2013-09-09','11:05:00',4.09),('10318','2013-09-09','11:10:00',3.84),('10318','2013-09-09','11:15:00',4.67),('10318','2013-09-09','11:20:00',3.18),('10318','2013-09-09','11:25:00',3.06),('10318','2013-09-09','11:30:00',3.41),('10318','2013-09-09','11:35:00',5.27),('10318','2013-09-09','11:40:00',5.98),('10318','2013-09-09','11:45:00',3.08),('10318','2013-09-09','11:50:00',4.02),('10318','2013-09-09','11:55:00',7.49),('10318','2013-09-09','12:00:00',4.11),('10318','2013-09-09','12:05:00',2.8),('10318','2013-09-09','12:10:00',3.32),('10318','2013-09-09','12:15:00',2.97),('10318','2013-09-09','12:20:00',2.05),('10318','2013-09-09','12:25:00',1.83),('10318','2013-09-09','12:30:00',2.15),('10318','2013-09-09','12:35:00',2.59),('10318','2013-09-09','12:40:00',4.53),('10318','2013-09-09','12:45:00',3.23),('10318','2013-09-09','12:50:00',2.54),('10318','2013-09-09','12:55:00',2.46),('10318','2013-09-09','13:00:00',3.1),('10318','2013-09-09','13:05:00',5.88),('10318','2013-09-09','13:10:00',7.77),('10318','2013-09-09','13:15:00',6.63),('10318','2013-09-09','13:20:00',6.55),('10318','2013-09-09','13:25:00',6.24),('10318','2013-09-09','13:30:00',8.28),('10318','2013-09-09','13:35:00',8.69),('10318','2013-09-09','13:40:00',8.03),('10318','2013-09-09','13:45:00',8.7),('10318','2013-09-09','13:50:00',8.83),('10318','2013-09-09','13:55:00',6.95),('10318','2013-09-09','14:00:00',7.58),('10318','2013-09-09','14:05:00',7.58),('10318','2013-09-09','14:10:00',4.76),('10318','2013-09-09','14:15:00',5.18),('10318','2013-09-09','14:20:00',3.28),('10318','2013-09-09','14:25:00',2.91),('10318','2013-09-09','14:30:00',4.12),('10318','2013-09-09','14:35:00',5.54),('10318','2013-09-09','14:40:00',7.53),('10318','2013-09-09','14:45:00',4.56),('10318','2013-09-09','14:50:00',4.39),('10318','2013-09-09','14:55:00',5.79),('10318','2013-09-09','15:00:00',5.69),('10318','2013-09-09','15:05:00',6.2),('10318','2013-09-09','15:10:00',7.66),('10318','2013-09-09','15:15:00',6.9),('10318','2013-09-09','15:20:00',6.67),('10318','2013-09-09','15:25:00',3.6),('10318','2013-09-09','15:30:00',5.25),('10318','2013-09-09','15:35:00',4.25),('10318','2013-09-09','15:40:00',4.25),('10318','2013-09-09','15:45:00',3.1),('10318','2013-09-09','15:50:00',3.38),('10318','2013-09-09','15:55:00',2.84),('10318','2013-09-09','16:00:00',2.83),('10318','2013-09-09','16:05:00',2.75),('10318','2013-09-09','16:10:00',4.07),('10318','2013-09-09','16:15:00',3.02),('10318','2013-09-09','16:20:00',3.91),('10318','2013-09-09','16:25:00',2.2),('10318','2013-09-09','16:30:00',2.28),('10318','2013-09-09','16:35:00',2.86),('10318','2013-09-09','16:40:00',2.61),('10318','2013-09-09','16:45:00',3.06),('10318','2013-09-09','16:50:00',1.65),('10318','2013-09-09','16:55:00',1.43),('10318','2013-09-09','17:00:00',1.76),('10318','2013-09-09','17:05:00',1.72),('10318','2013-09-09','17:10:00',1.56),('10318','2013-09-09','17:15:00',1.24),('10318','2013-09-09','17:35:00',1.26),('10318','2013-09-09','17:40:00',1.23),('10318','2013-09-09','18:05:00',1.28),('10318','2013-09-09','18:10:00',1.85),('10318','2013-09-09','18:15:00',1.54),('10318','2013-09-09','18:20:00',1.33),('10318','2013-09-09','18:25:00',1.02),('10318','2014-04-12','07:20:00',1.06),('10318','2014-04-12','07:25:00',1.03),('10318','2014-04-12','07:40:00',1.07),('10318','2014-04-12','07:45:00',1.08),('10318','2014-04-12','08:30:00',1.05),('10318','2014-04-12','08:35:00',1.29),('10318','2014-04-12','08:40:00',1.49),('10318','2014-04-12','08:45:00',1.51),('10318','2014-04-12','08:50:00',1.7),('10318','2014-04-12','08:55:00',1.61),('10318','2014-04-12','09:00:00',1.68),('10318','2014-04-12','09:05:00',2.6),('10318','2014-04-12','09:10:00',3.45),('10318','2014-04-12','09:15:00',4.92),('10318','2014-04-12','09:20:00',4.96),('10318','2014-04-12','09:25:00',4.47),('10318','2014-04-12','09:30:00',4.42),('10318','2014-04-12','09:35:00',4.39),('10318','2014-04-12','09:40:00',3.8),('10318','2014-04-12','09:45:00',3.82),('10318','2014-04-12','09:50:00',3.96),('10318','2014-04-12','09:55:00',4.22),('10318','2014-04-12','10:00:00',4.47),('10318','2014-04-12','10:05:00',4.61),('10318','2014-04-12','10:10:00',4.75),('10318','2014-04-12','10:15:00',4.6),('10318','2014-04-12','10:20:00',4.81),('10318','2014-04-12','10:25:00',5.15),('10318','2014-04-12','10:30:00',4.95),('10318','2014-04-12','10:35:00',5.31),('10318','2014-04-12','10:40:00',4.69),('10318','2014-04-12','10:45:00',5.53),('10318','2014-04-12','10:50:00',5.96),('10318','2014-04-12','10:55:00',7.54),('10318','2014-04-12','11:00:00',9.25),('10318','2014-04-12','11:05:00',8.88),('10318','2014-04-12','11:10:00',6.52),('10318','2014-04-12','11:15:00',6.1),('10318','2014-04-12','11:20:00',8.51),('10318','2014-04-12','11:25:00',6.56),('10318','2014-04-12','11:30:00',8.19),('10318','2014-04-12','11:35:00',5.93),('10318','2014-04-12','11:40:00',8.39),('10318','2014-04-12','11:45:00',7.98),('10318','2014-04-12','11:50:00',3.4),('10318','2014-04-12','11:55:00',3.49),('10318','2014-04-12','12:00:00',6.64),('10318','2014-04-12','12:05:00',9.25),('10318','2014-04-12','12:10:00',7.79),('10318','2014-04-12','12:15:00',5.88),('10318','2014-04-12','12:20:00',5.47),('10318','2014-04-12','12:25:00',7.24),('10318','2014-04-12','12:30:00',6.34),('10318','2014-04-12','12:35:00',6.31),('10318','2014-04-12','12:40:00',6.85),('10318','2014-04-12','12:45:00',4.95),('10318','2014-04-12','12:50:00',9.17),('10318','2014-04-12','12:55:00',6.32),('10318','2014-04-12','13:00:00',5.14),('10318','2014-04-12','13:05:00',6.54),('10318','2014-04-12','13:10:00',5.94),('10318','2014-04-12','13:15:00',7.13),('10318','2014-04-12','13:20:00',4.06),('10318','2014-04-12','13:25:00',8.61),('10318','2014-04-12','13:30:00',5.63),('10318','2014-04-12','13:35:00',6.32),('10318','2014-04-12','13:40:00',4.18),('10318','2014-04-12','13:45:00',4.94),('10318','2014-04-12','13:50:00',4.75),('10318','2014-04-12','13:55:00',5.53),('10318','2014-04-12','14:00:00',7.72),('10318','2014-04-12','14:05:00',8.44),('10318','2014-04-12','14:10:00',7),('10318','2014-04-12','14:15:00',7.22),('10318','2014-04-12','14:20:00',7.39),('10318','2014-04-12','14:25:00',4.09),('10318','2014-04-12','14:30:00',2.8),('10318','2014-04-12','14:35:00',5.52),('10318','2014-04-12','14:40:00',7.43),('10318','2014-04-12','14:45:00',8.6),('10318','2014-04-12','14:50:00',9.08),('10318','2014-04-12','14:55:00',7.23),('10318','2014-04-12','15:00:00',7.51),('10318','2014-04-12','15:05:00',7.41),('10318','2014-04-12','15:10:00',7.72),('10318','2014-04-12','15:15:00',7.02),('10318','2014-04-12','15:20:00',6.28),('10318','2014-04-12','15:25:00',4.99),('10318','2014-04-12','15:30:00',4.85),('10318','2014-04-12','15:35:00',5.64),('10318','2014-04-12','15:40:00',6.3),('10318','2014-04-12','15:45:00',7.03),('10318','2014-04-12','15:50:00',7.03),('10318','2014-04-12','15:55:00',6.88),('10318','2014-04-12','16:00:00',6.78),('10318','2014-04-12','16:05:00',6.58),('10318','2014-04-12','16:10:00',6.24),('10318','2014-04-12','16:15:00',5.24),('10318','2014-04-12','16:20:00',4.92),('10318','2014-04-12','16:25:00',4.6),('10318','2014-04-12','16:30:00',4.84),('10318','2014-04-12','16:35:00',4.52),('10318','2014-04-12','16:40:00',5.49),('10318','2014-04-12','16:45:00',5.43),('10318','2014-04-12','16:50:00',5.5),('10318','2014-04-12','16:55:00',4.72),('10318','2014-04-12','17:00:00',4.02),('10318','2014-04-12','17:05:00',3.96),('10318','2014-04-12','17:10:00',3.87),('10318','2014-04-12','17:15:00',3.55),('10318','2014-04-12','17:20:00',3.1),('10318','2014-04-12','17:25:00',2.28),('10318','2014-04-12','17:30:00',2.67),('10318','2014-04-12','17:35:00',3.41),('10318','2014-04-12','17:40:00',3.42),('10318','2014-04-12','17:45:00',3.21),('10318','2014-04-12','17:50:00',2.33),('10318','2014-04-12','17:55:00',2.03),('10318','2014-04-12','18:00:00',2),('10318','2014-04-12','18:05:00',1.32),('10318','2014-04-12','18:10:00',1),('10318','2013-09-08','07:35:00',1.07),('10318','2013-09-08','07:40:00',1.43),('10318','2013-09-08','07:45:00',1.48),('10318','2013-09-08','07:50:00',1),('10318','2013-09-08','08:05:00',1.03),('10318','2013-09-08','08:10:00',1.48),('10318','2013-09-08','08:15:00',1.91),('10318','2013-09-08','08:20:00',2.02),('10318','2013-09-08','08:25:00',1.83),('10318','2013-09-08','08:30:00',1.79),('10318','2013-09-08','08:35:00',1.68),('10318','2013-09-08','08:40:00',1.56),('10318','2013-09-08','08:45:00',1.57),('10318','2013-09-08','08:50:00',1.57),('10318','2013-09-08','08:55:00',1.64),('10318','2013-09-08','09:00:00',1.79),('10318','2013-09-08','09:05:00',2.11),('10318','2013-09-08','09:10:00',2.7),('10318','2013-09-08','09:15:00',4.45),('10318','2013-09-08','09:20:00',5.24),('10318','2013-09-08','09:25:00',4.81),('10318','2013-09-08','09:30:00',5.4),('10318','2013-09-08','09:35:00',5.75),('10318','2013-09-08','09:40:00',5.86),('10318','2013-09-08','09:45:00',5.93),('10318','2013-09-08','09:50:00',5.96),('10318','2013-09-08','09:55:00',6.15),('10318','2013-09-08','10:00:00',6.23),('10318','2013-09-08','10:05:00',6.19),('10318','2013-09-08','10:10:00',6.55),('10318','2013-09-08','10:15:00',6.6),('10318','2013-09-08','10:20:00',6.61),('10318','2013-09-08','10:25:00',6.94),('10318','2013-09-08','10:30:00',7.11),('10318','2013-09-08','10:35:00',7.2),('10318','2013-09-08','10:40:00',7.17),('10318','2013-09-08','10:45:00',7.35),('10318','2013-09-08','10:50:00',7.38),('10318','2013-09-08','10:55:00',7.51),('10318','2013-09-08','11:00:00',7.51),('10318','2013-09-08','11:05:00',7.51),('10318','2013-09-08','11:10:00',7.61),('10318','2013-09-08','11:15:00',7.68),('10318','2013-09-08','11:20:00',7.68),('10318','2013-09-08','11:25:00',7.67),('10318','2013-09-08','11:30:00',7.64),('10318','2013-09-08','11:35:00',7.58),('10318','2013-09-08','11:40:00',7.66),('10318','2013-09-08','11:45:00',7.87),('10318','2013-09-08','11:50:00',7.79),('10318','2013-09-08','11:55:00',7.71),('10318','2013-09-08','12:00:00',7.52),('10318','2013-09-08','12:05:00',7.64),('10318','2013-09-08','12:10:00',7.69),('10318','2013-09-08','12:15:00',8.19),('10318','2013-09-08','12:20:00',8.19),('10318','2013-09-08','12:25:00',8.1),('10318','2013-09-08','12:30:00',8.1),('10318','2013-09-08','12:35:00',8.07),('10318','2013-09-08','12:40:00',7.72),('10318','2013-09-08','12:45:00',7.97),('10318','2013-09-08','12:50:00',7.95),('10318','2013-09-08','12:55:00',7.94),('10318','2013-09-08','13:00:00',8),('10318','2013-09-08','13:05:00',7.99),('10318','2013-09-08','13:10:00',7.62),('10318','2013-09-08','13:15:00',7.42),('10318','2013-09-08','13:20:00',7.72),('10318','2013-09-08','13:25:00',6.74),('10318','2013-09-08','13:30:00',7.11),('10318','2013-09-08','13:35:00',6.44),('10318','2013-09-08','13:40:00',4.57),('10318','2013-09-08','13:45:00',5.08),('10318','2013-09-08','13:50:00',5.75),('10318','2013-09-08','13:55:00',6.94),('10318','2013-09-08','14:00:00',7.14),('10318','2013-09-08','14:05:00',7.44),('10318','2013-09-08','14:10:00',7.73),('10318','2013-09-08','14:15:00',6.67),('10318','2013-09-08','14:20:00',7.6),('10318','2013-09-08','14:25:00',7.74),('10318','2013-09-08','14:30:00',7.5),('10318','2013-09-08','14:35:00',7.59),('10318','2013-09-08','14:40:00',7.32),('10318','2013-09-08','14:45:00',7.37),('10318','2013-09-08','14:50:00',7.21),('10318','2013-09-08','14:55:00',6.91),('10318','2013-09-08','15:00:00',6.93),('10318','2013-09-08','15:05:00',4.46),('10318','2013-09-08','15:10:00',4.15),('10318','2013-09-08','15:15:00',5.91),('10318','2013-09-08','15:20:00',6.57),('10318','2013-09-08','15:25:00',6.7),('10318','2013-09-08','15:30:00',6.43),('10318','2013-09-08','15:35:00',6),('10318','2013-09-08','15:40:00',5.77),('10318','2013-09-08','15:45:00',5.91),('10318','2013-09-08','15:50:00',5.15),('10318','2013-09-08','15:55:00',4.61),('10318','2013-09-08','16:00:00',4.81),('10318','2013-09-08','16:05:00',4.58),('10318','2013-09-08','16:10:00',4.24),('10318','2013-09-08','16:15:00',4.68),('10318','2013-09-08','16:20:00',4.45),('10318','2013-09-08','16:25:00',4.1),('10318','2013-09-08','16:30:00',4.25),('10318','2013-09-08','16:35:00',3.99),('10318','2013-09-08','16:40:00',2.62),('10318','2013-09-08','16:45:00',2.58),('10318','2013-09-08','16:50:00',2.22),('10318','2013-09-08','16:55:00',2.2),('10318','2013-09-08','17:00:00',2.84),('10318','2013-09-08','17:05:00',3.65),('10318','2013-09-08','17:10:00',3.31),('10318','2013-09-08','17:15:00',2.99),('10318','2013-09-08','17:20:00',2.61),('10318','2013-09-08','17:25:00',2.51),('10318','2013-09-08','17:30:00',2),('10318','2013-09-08','17:35:00',1.24),('10318','2013-09-08','17:40:00',1.62),('10318','2013-09-08','17:45:00',1.83),('10318','2013-09-08','17:50:00',1.77),('10318','2013-09-08','17:55:00',1.65),('10318','2013-09-08','18:00:00',1.43),('10318','2013-09-08','18:05:00',1.24),('10318','2013-09-08','18:10:00',1.12),('10318','2013-09-07','07:45:00',1.11),('10318','2013-09-07','07:50:00',1.51),('10318','2013-09-07','07:55:00',2.03),('10318','2013-09-07','08:00:00',2.38),('10318','2013-09-07','08:05:00',2.61),('10318','2013-09-07','08:10:00',2.87),('10318','2013-09-07','08:15:00',3.14),('10318','2013-09-07','08:20:00',3.3),('10318','2013-09-07','08:25:00',3.5),('10318','2013-09-07','08:30:00',3.7),('10318','2013-09-07','08:35:00',3.76),('10318','2013-09-07','08:40:00',4.06),('10318','2013-09-07','08:45:00',4.24),('10318','2013-09-07','08:50:00',4.43),('10318','2013-09-07','08:55:00',4.59),('10318','2013-09-07','09:00:00',4.75),('10318','2013-09-07','09:05:00',4.95),('10318','2013-09-07','09:10:00',5.16),('10318','2013-09-07','09:15:00',5.32),('10318','2013-09-07','09:20:00',5.47),('10318','2013-09-07','09:25:00',5.63),('10318','2013-09-07','09:30:00',5.76),('10318','2013-09-07','09:35:00',5.88),('10318','2013-09-07','09:40:00',6.02),('10318','2013-09-07','09:45:00',6.16),('10318','2013-09-07','09:50:00',6.25),('10318','2013-09-07','09:55:00',6.4),('10318','2013-09-07','10:00:00',6.52),('10318','2013-09-07','10:05:00',6.63),('10318','2013-09-07','10:10:00',6.74),('10318','2013-09-07','10:15:00',6.88),('10318','2013-09-07','10:20:00',7),('10318','2013-09-07','10:25:00',7.12),('10318','2013-09-07','10:30:00',7.23),('10318','2013-09-07','10:35:00',7.31),('10318','2013-09-07','10:40:00',7.39),('10318','2013-09-07','10:45:00',7.46),('10318','2013-09-07','10:50:00',7.53),('10318','2013-09-07','10:55:00',7.58),('10318','2013-09-07','11:00:00',7.6),('10318','2013-09-07','11:05:00',7.7),('10318','2013-09-07','11:10:00',7.79),('10318','2013-09-07','11:15:00',7.88),('10318','2013-09-07','11:20:00',7.84),('10318','2013-09-07','11:25:00',7.88),('10318','2013-09-07','11:30:00',7.96),('10318','2013-09-07','11:35:00',7.9),('10318','2013-09-07','11:40:00',8.05),('10318','2013-09-07','11:45:00',8.02),('10318','2013-09-07','11:50:00',8.02),('10318','2013-09-07','11:55:00',8.07),('10318','2013-09-07','12:00:00',8.12),('10318','2013-09-07','12:05:00',8.11),('10318','2013-09-07','12:10:00',8.03),('10318','2013-09-07','12:15:00',8.31),('10318','2013-09-07','12:20:00',8.36),('10318','2013-09-07','12:25:00',8.37),('10318','2013-09-07','12:30:00',8.35),('10318','2013-09-07','12:35:00',8.31),('10318','2013-09-07','12:40:00',8.2),('10318','2013-09-07','12:45:00',8.04),('10318','2013-09-07','12:50:00',8.05),('10318','2013-09-07','12:55:00',8.11),('10318','2013-09-07','13:00:00',8.23),('10318','2013-09-07','13:05:00',8.17),('10318','2013-09-07','13:10:00',8.24),('10318','2013-09-07','13:15:00',8.17),('10318','2013-09-07','13:20:00',7.95),('10318','2013-09-07','13:25:00',8.09),('10318','2013-09-07','13:30:00',7.99),('10318','2013-09-07','13:35:00',8.05),('10318','2013-09-07','13:40:00',7.99),('10318','2013-09-07','13:45:00',7.98),('10318','2013-09-07','13:50:00',7.74),('10318','2013-09-07','13:55:00',7.74),('10318','2013-09-07','14:00:00',7.81),('10318','2013-09-07','14:05:00',7.84),('10318','2013-09-07','14:10:00',7.91),('10318','2013-09-07','14:15:00',7.81),('10318','2013-09-07','14:20:00',7.76),('10318','2013-09-07','14:25:00',7.58),('10318','2013-09-07','14:30:00',7.52),('10318','2013-09-07','14:35:00',7.44),('10318','2013-09-07','14:40:00',7.38),('10318','2013-09-07','14:45:00',7.25),('10318','2013-09-07','14:50:00',7.12),('10318','2013-09-07','14:55:00',7.05),('10318','2013-09-07','15:00:00',6.91),('10318','2013-09-07','15:05:00',6.74),('10318','2013-09-07','15:10:00',6.72),('10318','2013-09-07','15:15:00',6.6),('10318','2013-09-07','15:20:00',6.51),('10318','2013-09-07','15:25:00',6.4),('10318','2013-09-07','15:30:00',6.24),('10318','2013-09-07','15:35:00',6.07),('10318','2013-09-07','15:40:00',5.94),('10318','2013-09-07','15:45:00',5.81),('10318','2013-09-07','15:50:00',5.65),('10318','2013-09-07','15:55:00',5.45),('10318','2013-09-07','16:00:00',5.29),('10318','2013-09-07','16:05:00',5.15),('10318','2013-09-07','16:10:00',5),('10318','2013-09-07','16:15:00',4.81),('10318','2013-09-07','16:20:00',4.65),('10318','2013-09-07','16:25:00',4.47),('10318','2013-09-07','16:30:00',4.32),('10318','2013-09-07','16:35:00',4.14),('10318','2013-09-07','16:40:00',3.98),('10318','2013-09-07','16:45:00',3.79),('10318','2013-09-07','16:50:00',3.54),('10318','2013-09-07','16:55:00',3.44),('10318','2013-09-07','17:00:00',3.29),('10318','2013-09-07','17:05:00',3.15),('10318','2013-09-07','17:10:00',3),('10318','2013-09-07','17:15:00',2.83),('10318','2013-09-07','17:20:00',2.65),('10318','2013-09-07','17:25:00',2.46),('10318','2013-09-07','17:30:00',2.28),('10318','2013-09-07','17:35:00',2.16),('10318','2013-09-07','17:40:00',2.03),('10318','2013-09-07','17:45:00',1.87),('10318','2013-09-07','17:50:00',1.75),('10318','2013-09-07','17:55:00',1.59),('10318','2013-09-07','18:00:00',1.44),('10318','2013-09-07','18:05:00',1.29),('10318','2013-09-07','18:10:00',1.16),('10318','2013-09-07','18:15:00',1.04),('10318','2013-09-06','07:45:00',1.11),('10318','2013-09-06','07:50:00',1.66),('10318','2013-09-06','07:55:00',2.03),('10318','2013-09-06','08:00:00',2.35),('10318','2013-09-06','08:05:00',2.64),('10318','2013-09-06','08:10:00',2.86),('10318','2013-09-06','08:15:00',3.14),('10318','2013-09-06','08:20:00',3.39),('10318','2013-09-06','08:25:00',3.6),('10318','2013-09-06','08:30:00',3.81),('10318','2013-09-06','08:35:00',4),('10318','2013-09-06','08:40:00',4.16),('10318','2013-09-06','08:45:00',4.37),('10318','2013-09-06','08:50:00',4.57),('10318','2013-09-06','08:55:00',4.75),('10318','2013-09-06','09:00:00',4.95),('10318','2013-09-06','09:05:00',5.1),('10318','2013-09-06','09:10:00',5.27),('10318','2013-09-06','09:15:00',5.4),('10318','2013-09-06','09:20:00',5.35),('10318','2013-09-06','09:25:00',5.56),('10318','2013-09-06','09:30:00',5.77),('10318','2013-09-06','09:35:00',5.97),('10318','2013-09-06','09:40:00',6.11),('10318','2013-09-06','09:45:00',6.18),('10318','2013-09-06','09:50:00',6.23),('10318','2013-09-06','09:55:00',6.41),('10318','2013-09-06','10:00:00',6.6),('10318','2013-09-06','10:05:00',6.75),('10318','2013-09-06','10:10:00',6.89),('10318','2013-09-06','10:15:00',6.98),('10318','2013-09-06','10:20:00',7.11),('10318','2013-09-06','10:25:00',7.26),('10318','2013-09-06','10:30:00',7.3),('10318','2013-09-06','10:35:00',7.4),('10318','2013-09-06','10:40:00',7.48),('10318','2013-09-06','10:45:00',7.64),('10318','2013-09-06','10:50:00',7.69),('10318','2013-09-06','10:55:00',7.75),('10318','2013-09-06','11:00:00',7.85),('10318','2013-09-06','11:05:00',7.81),('10318','2013-09-06','11:10:00',7.95),('10318','2013-09-06','11:15:00',7.97),('10318','2013-09-06','11:20:00',8.02),('10318','2013-09-06','11:25:00',8.03),('10318','2013-09-06','11:30:00',8.1),('10318','2013-09-06','11:35:00',8.18),('10318','2013-09-06','11:40:00',8.23),('10318','2013-09-06','11:45:00',8.27),('10318','2013-09-06','11:50:00',8.23),('10318','2013-09-06','11:55:00',8.33),('10318','2013-09-06','12:00:00',8.25),('10318','2013-09-06','12:05:00',8.27),('10318','2013-09-06','12:10:00',8.35),('10318','2013-09-06','12:15:00',8.39),('10318','2013-09-06','12:20:00',8.37),('10318','2013-09-06','12:25:00',8.38),('10318','2013-09-06','12:30:00',8.4),('10318','2013-09-06','12:35:00',8.38),('10318','2013-09-06','12:40:00',8.42),('10318','2013-09-06','12:45:00',8.38),('10318','2013-09-06','12:50:00',8.09),('10318','2013-09-06','12:55:00',8.37),('10318','2013-09-06','13:00:00',8.32),('10318','2013-09-06','13:05:00',8.25),('10318','2013-09-06','13:10:00',8.2),('10318','2013-09-06','13:15:00',8.13),('10318','2013-09-06','13:20:00',8.12),('10318','2013-09-06','13:25:00',8.14),('10318','2013-09-06','13:30:00',8.14),('10318','2013-09-06','13:35:00',8.12),('10318','2013-09-06','13:40:00',8.03),('10318','2013-09-06','13:45:00',7.92),('10318','2013-09-06','13:50:00',7.82),('10318','2013-09-06','13:55:00',7.73),('10318','2013-09-06','14:00:00',7.75),('10318','2013-09-06','14:05:00',7.69),('10318','2013-09-06','14:10:00',7.5),('10318','2013-09-06','14:15:00',7.4),('10318','2013-09-06','14:20:00',7.31),('10318','2013-09-06','14:25:00',6.84),('10318','2013-09-06','14:30:00',7.14),('10318','2013-09-06','14:35:00',7.01),('10318','2013-09-06','14:40:00',7.13),('10318','2013-09-06','14:45:00',6.99),('10318','2013-09-06','14:50:00',6.98),('10318','2013-09-06','14:55:00',6.93),('10318','2013-09-06','15:00:00',6.86),('10318','2013-09-06','15:05:00',6.73),('10318','2013-09-06','15:10:00',6.65),('10318','2013-09-06','15:15:00',6.5),('10318','2013-09-06','15:20:00',6.42),('10318','2013-09-06','15:25:00',6.35),('10318','2013-09-06','15:30:00',6.21),('10318','2013-09-06','15:35:00',6.01),('10318','2013-09-06','15:40:00',5.9),('10318','2013-09-06','15:45:00',5.78),('10318','2013-09-06','15:50:00',5.64),('10318','2013-09-06','15:55:00',5.51),('10318','2013-09-06','16:00:00',5.34),('10318','2013-09-06','16:05:00',5.16),('10318','2013-09-06','16:10:00',5.01),('10318','2013-09-06','16:15:00',4.8),('10318','2013-09-06','16:20:00',4.68),('10318','2013-09-06','16:25:00',4.51),('10318','2013-09-06','16:30:00',4.35),('10318','2013-09-06','16:35:00',4.24),('10318','2013-09-06','16:40:00',4.07),('10318','2013-09-06','16:45:00',3.9),('10318','2013-09-06','16:50:00',3.7),('10318','2013-09-06','16:55:00',3.54),('10318','2013-09-06','17:00:00',3.38),('10318','2013-09-06','17:05:00',3.23),('10318','2013-09-06','17:10:00',3.03),('10318','2013-09-06','17:15:00',2.86),('10318','2013-09-06','17:20:00',2.71),('10318','2013-09-06','17:25:00',2.49),('10318','2013-09-06','17:30:00',2.3),('10318','2013-09-06','17:35:00',2.16),('10318','2013-09-06','17:40:00',2.05),('10318','2013-09-06','17:45:00',1.9),('10318','2013-09-06','17:50:00',1.77),('10318','2013-09-06','17:55:00',1.61),('10318','2013-09-06','18:00:00',1.45),('10318','2013-09-06','18:05:00',1.31),('10318','2013-09-06','18:10:00',1.19),('10318','2013-09-06','18:15:00',1.08),('10318','2013-09-05','07:40:00',1.01),('10318','2013-09-05','07:45:00',1.33),('10318','2013-09-05','07:50:00',1.98),('10318','2013-09-05','07:55:00',2.35),('10318','2013-09-05','08:00:00',2.49),('10318','2013-09-05','08:05:00',2.94),('10318','2013-09-05','08:10:00',3.34),('10318','2013-09-05','08:15:00',3.59),('10318','2013-09-05','08:20:00',3.79),('10318','2013-09-05','08:25:00',3.98),('10318','2013-09-05','08:30:00',4.19),('10318','2013-09-05','08:35:00',4.39),('10318','2013-09-05','08:40:00',4.58),('10318','2013-09-05','08:45:00',4.72),('10318','2013-09-05','08:50:00',4.97),('10318','2013-09-05','08:55:00',5.16),('10318','2013-09-05','09:00:00',5.34),('10318','2013-09-05','09:05:00',5.51),('10318','2013-09-05','09:10:00',5.68),('10318','2013-09-05','09:15:00',5.82),('10318','2013-09-05','09:20:00',5.97),('10318','2013-09-05','09:25:00',6.11),('10318','2013-09-05','09:30:00',6.25),('10318','2013-09-05','09:35:00',6.35),('10318','2013-09-05','09:40:00',6.48),('10318','2013-09-05','09:45:00',6.6),('10318','2013-09-05','09:50:00',6.74),('10318','2013-09-05','09:55:00',6.85),('10318','2013-09-05','10:00:00',6.99),('10318','2013-09-05','10:05:00',7.1),('10318','2013-09-05','10:10:00',7.21),('10318','2013-09-05','10:15:00',7.3),('10318','2013-09-05','10:20:00',7.41),('10318','2013-09-05','10:25:00',7.52),('10318','2013-09-05','10:30:00',7.58),('10318','2013-09-05','10:35:00',7.68),('10318','2013-09-05','10:40:00',7.74),('10318','2013-09-05','10:45:00',7.81),('10318','2013-09-05','10:50:00',7.86),('10318','2013-09-05','10:55:00',7.95),('10318','2013-09-05','11:00:00',8.03),('10318','2013-09-05','11:05:00',8.08),('10318','2013-09-05','11:10:00',8.1),('10318','2013-09-05','11:15:00',8.14),('10318','2013-09-05','11:20:00',8.2),('10318','2013-09-05','11:25:00',8.25),('10318','2013-09-05','11:30:00',8.26),('10318','2013-09-05','11:35:00',8.32),('10318','2013-09-05','11:40:00',8.35),('10318','2013-09-05','11:45:00',8.34),('10318','2013-09-05','11:50:00',8.39),('10318','2013-09-05','11:55:00',8.46),('10318','2013-09-05','12:00:00',8.57),('10318','2013-09-05','12:05:00',8.58),('10318','2013-09-05','12:10:00',8.61),('10318','2013-09-05','12:15:00',8.61),('10318','2013-09-05','12:20:00',8.39),('10318','2013-09-05','12:25:00',8.52),('10318','2013-09-05','12:30:00',8.55),('10318','2013-09-05','12:35:00',8.57),('10318','2013-09-05','12:40:00',8.57),('10318','2013-09-05','12:45:00',8.5),('10318','2013-09-05','12:50:00',8.51),('10318','2013-09-05','12:55:00',8.54),('10318','2013-09-05','13:00:00',8.52),('10318','2013-09-05','13:05:00',8.53),('10318','2013-09-05','13:10:00',8.49),('10318','2013-09-05','13:15:00',8.44),('10318','2013-09-05','13:20:00',8.38),('10318','2013-09-05','13:25:00',8.29),('10318','2013-09-05','13:30:00',8.29),('10318','2013-09-05','13:35:00',8.14),('10318','2013-09-05','13:40:00',8.25),('10318','2013-09-05','13:45:00',8.18),('10318','2013-09-05','13:50:00',8.09),('10318','2013-09-05','13:55:00',8.03),('10318','2013-09-05','14:00:00',7.95),('10318','2013-09-05','14:05:00',7.92),('10318','2013-09-05','14:10:00',7.85),('10318','2013-09-05','14:15:00',7.77),('10318','2013-09-05','14:20:00',7.73),('10318','2013-09-05','14:25:00',7.71),('10318','2013-09-05','14:30:00',7.65),('10318','2013-09-05','14:35:00',7.45),('10318','2013-09-05','14:40:00',7.33),('10318','2013-09-05','14:45:00',7.28),('10318','2013-09-05','14:50:00',7.21),('10318','2013-09-05','14:55:00',7.11),('10318','2013-09-05','15:00:00',7.04),('10318','2013-09-05','15:05:00',6.91),('10318','2013-09-05','15:10:00',6.79),('10318','2013-09-05','15:15:00',6.73),('10318','2013-09-05','15:20:00',6.5),('10318','2013-09-05','15:25:00',6.42),('10318','2013-09-05','15:30:00',6.31),('10318','2013-09-05','15:35:00',6.18),('10318','2013-09-05','15:40:00',6.01),('10318','2013-09-05','15:45:00',5.89),('10318','2013-09-05','15:50:00',5.8),('10318','2013-09-05','15:55:00',5.67),('10318','2013-09-05','16:00:00',5.53),('10318','2013-09-05','16:05:00',5.42),('10318','2013-09-05','16:10:00',5.26),('10318','2013-09-05','16:15:00',5.11),('10318','2013-09-05','16:20:00',4.95),('10318','2013-09-05','16:25:00',4.79),('10318','2013-09-05','16:30:00',4.64),('10318','2013-09-05','16:35:00',4.52),('10318','2013-09-05','16:40:00',4.43),('10318','2013-09-05','16:45:00',4.33),('10318','2013-09-05','16:50:00',3.79),('10318','2013-09-05','16:55:00',3.04),('10318','2013-09-05','17:00:00',2.43),('10318','2013-09-05','17:05:00',2.46),('10318','2013-09-05','17:10:00',2.6),('10318','2013-09-05','17:15:00',2.25),('10318','2013-09-05','17:20:00',2.55),('10318','2013-09-05','17:25:00',2.59),('10318','2013-09-05','17:30:00',2.33),('10318','2013-09-05','17:35:00',2.63),('10318','2013-09-05','17:40:00',2.72),('10318','2013-09-05','17:45:00',2.37),('10318','2013-09-05','17:50:00',2.32),('10318','2013-09-05','17:55:00',1.86),('10318','2013-09-05','18:00:00',1.61),('10318','2013-09-05','18:05:00',1.4),('10318','2013-09-05','18:10:00',1.27),('10318','2013-09-05','18:15:00',1.24),('10318','2013-09-05','18:20:00',1.21),('10318','2013-09-05','18:25:00',1.09),('10318','2013-09-04','07:45:00',1.37),('10318','2013-09-04','07:50:00',1.94),('10318','2013-09-04','07:55:00',2.49),('10318','2013-09-04','08:00:00',2.66),('10318','2013-09-04','08:05:00',3),('10318','2013-09-04','08:10:00',3.34),('10318','2013-09-04','08:15:00',3.57),('10318','2013-09-04','08:20:00',3.77),('10318','2013-09-04','08:25:00',3.96),('10318','2013-09-04','08:30:00',4.16),('10318','2013-09-04','08:35:00',4.35),('10318','2013-09-04','08:40:00',4.55),('10318','2013-09-04','08:45:00',4.73),('10318','2013-09-04','08:50:00',4.93),('10318','2013-09-04','08:55:00',5.1),('10318','2013-09-04','09:00:00',5.29),('10318','2013-09-04','09:05:00',5.45),('10318','2013-09-04','09:10:00',5.59),('10318','2013-09-04','09:15:00',5.78),('10318','2013-09-04','09:20:00',5.97),('10318','2013-09-04','09:25:00',6.15),('10318','2013-09-04','09:30:00',6.13),('10318','2013-09-04','09:35:00',6.44),('10318','2013-09-04','09:40:00',6.6),('10318','2013-09-04','09:45:00',6.76),('10318','2013-09-04','09:50:00',6.89),('10318','2013-09-04','09:55:00',7.03),('10318','2013-09-04','10:00:00',7.15),('10318','2013-09-04','10:05:00',7.24),('10318','2013-09-04','10:10:00',7.33),('10318','2013-09-04','10:15:00',7.42),('10318','2013-09-04','10:20:00',7.52),('10318','2013-09-04','10:25:00',7.62),('10318','2013-09-04','10:30:00',7.74),('10318','2013-09-04','10:35:00',7.83),('10318','2013-09-04','10:40:00',7.89),('10318','2013-09-04','10:45:00',8.01),('10318','2013-09-04','10:50:00',8.14),('10318','2013-09-04','10:55:00',8.24),('10318','2013-09-04','11:00:00',8.35),('10318','2013-09-04','11:05:00',8.39),('10318','2013-09-04','11:10:00',8.44),('10318','2013-09-04','11:15:00',8.3),('10318','2013-09-04','11:20:00',8.49),('10318','2013-09-04','11:25:00',8.6),('10318','2013-09-04','11:30:00',8.65),('10318','2013-09-04','11:35:00',8.69),('10318','2013-09-04','11:40:00',8.73),('10318','2013-09-04','11:45:00',8.73),('10318','2013-09-04','11:50:00',8.79),('10318','2013-09-04','11:55:00',8.81),('10318','2013-09-04','12:00:00',8.79),('10318','2013-09-04','12:05:00',8.78),('10318','2013-09-04','12:10:00',8.79),('10318','2013-09-04','12:15:00',8.82),('10318','2013-09-04','12:20:00',8.82),('10318','2013-09-04','12:25:00',8.9),('10318','2013-09-04','12:30:00',8.83),('10318','2013-09-04','12:35:00',8.85),('10318','2013-09-04','12:40:00',8.8),('10318','2013-09-04','12:45:00',8.78),('10318','2013-09-04','12:50:00',8.82),('10318','2013-09-04','12:55:00',8.8),('10318','2013-09-04','13:00:00',8.71),('10318','2013-09-04','13:05:00',8.77),('10318','2013-09-04','13:10:00',8.76),('10318','2013-09-04','13:15:00',8.72),('10318','2013-09-04','13:20:00',8.72),('10318','2013-09-04','13:25:00',8.62),('10318','2013-09-04','13:30:00',8.58),('10318','2013-09-04','13:35:00',8.49),('10318','2013-09-04','13:40:00',8.46),('10318','2013-09-04','13:45:00',8.43),('10318','2013-09-04','13:50:00',8.36),('10318','2013-09-04','13:55:00',8.34),('10318','2013-09-04','14:00:00',8.32),('10318','2013-09-04','14:05:00',8.22),('10318','2013-09-04','14:10:00',8.11),('10318','2013-09-04','14:15:00',8.03),('10318','2013-09-04','14:20:00',7.86),('10318','2013-09-04','14:25:00',7.88),('10318','2013-09-04','14:30:00',7.84),('10318','2013-09-04','14:35:00',7.76),('10318','2013-09-04','14:40:00',7.68),('10318','2013-09-04','14:45:00',7.59),('10318','2013-09-04','14:50:00',7.47),('10318','2013-09-04','14:55:00',7.37),('10318','2013-09-04','15:00:00',7.23),('10318','2013-09-04','15:05:00',7.14),('10318','2013-09-04','15:10:00',7.03),('10318','2013-09-04','15:15:00',6.91),('10318','2013-09-04','15:20:00',6.75),('10318','2013-09-04','15:25:00',6.65),('10318','2013-09-04','15:30:00',6.54),('10318','2013-09-04','15:35:00',6.36),('10318','2013-09-04','15:40:00',6.21),('10318','2013-09-04','15:45:00',6.06),('10318','2013-09-04','15:50:00',5.93),('10318','2013-09-04','15:55:00',5.75),('10318','2013-09-04','16:00:00',5.56),('10318','2013-09-04','16:05:00',5.31),('10318','2013-09-04','16:10:00',5.27),('10318','2013-09-04','16:15:00',5.15),('10318','2013-09-04','16:20:00',5.05),('10318','2013-09-04','16:25:00',4.79),('10318','2013-09-04','16:30:00',4.57),('10318','2013-09-04','16:35:00',4.45),('10318','2013-09-04','16:40:00',4.28),('10318','2013-09-04','16:45:00',4.1),('10318','2013-09-04','16:50:00',3.91),('10318','2013-09-04','16:55:00',3.71),('10318','2013-09-04','17:00:00',3.52),('10318','2013-09-04','17:05:00',3.34),('10318','2013-09-04','17:10:00',3.18),('10318','2013-09-04','17:15:00',3.01),('10318','2013-09-04','17:20:00',2.84),('10318','2013-09-04','17:25:00',2.66),('10318','2013-09-04','17:30:00',2.48),('10318','2013-09-04','17:35:00',2.24),('10318','2013-09-04','17:40:00',2.08),('10318','2013-09-04','17:45:00',1.95),('10318','2013-09-04','17:50:00',1.78),('10318','2013-09-04','17:55:00',1.67),('10318','2013-09-04','18:00:00',1.54),('10318','2013-09-04','18:05:00',1.36),('10318','2013-09-04','18:10:00',1.23),('10318','2013-09-04','18:15:00',1.1),('10318','2013-09-03','07:40:00',1.06),('10318','2013-09-03','07:45:00',1.3),('10318','2013-09-03','07:50:00',1.82),('10318','2013-09-03','07:55:00',2.16),('10318','2013-09-03','08:00:00',2.4),('10318','2013-09-03','08:05:00',2.64),('10318','2013-09-03','08:10:00',2.9),('10318','2013-09-03','08:15:00',3.11),('10318','2013-09-03','08:20:00',3.3),('10318','2013-09-03','08:25:00',3.48),('10318','2013-09-03','08:30:00',3.7),('10318','2013-09-03','08:35:00',3.89),('10318','2013-09-03','08:40:00',4.1),('10318','2013-09-03','08:45:00',4.32),('10318','2013-09-03','08:50:00',4.51),('10318','2013-09-03','08:55:00',4.66),('10318','2013-09-03','09:00:00',4.79),('10318','2013-09-03','09:05:00',4.98),('10318','2013-09-03','09:10:00',5.15),('10318','2013-09-03','09:15:00',5.34),('10318','2013-09-03','09:20:00',5.53),('10318','2013-09-03','09:25:00',5.67),('10318','2013-09-03','09:30:00',5.83),('10318','2013-09-03','09:35:00',6),('10318','2013-09-03','09:40:00',6.22),('10318','2013-09-03','09:45:00',6.35),('10318','2013-09-03','09:50:00',6.48),('10318','2013-09-03','09:55:00',6.64),('10318','2013-09-03','10:00:00',6.7),('10318','2013-09-03','10:05:00',6.8),('10318','2013-09-03','10:10:00',6.95),('10318','2013-09-03','10:15:00',7.03),('10318','2013-09-03','10:20:00',7.18),('10318','2013-09-03','10:25:00',7.28),('10318','2013-09-03','10:30:00',7.41),('10318','2013-09-03','10:35:00',7.55),('10318','2013-09-03','10:40:00',7.69),('10318','2013-09-03','10:45:00',7.75),('10318','2013-09-03','10:50:00',7.81),('10318','2013-09-03','10:55:00',7.84),('10318','2013-09-03','11:00:00',7.91),('10318','2013-09-03','11:05:00',7.98),('10318','2013-09-03','11:10:00',8.07),('10318','2013-09-03','11:15:00',8.07),('10318','2013-09-03','11:20:00',8.1),('10318','2013-09-03','11:25:00',8.14),('10318','2013-09-03','11:30:00',8.3),('10318','2013-09-03','11:35:00',8.34),('10318','2013-09-03','11:40:00',8.32),('10318','2013-09-03','11:45:00',8.33),('10318','2013-09-03','11:50:00',8.46),('10318','2013-09-03','11:55:00',8.45),('10318','2013-09-03','12:00:00',8.47),('10318','2013-09-03','12:05:00',8.59),('10318','2013-09-03','12:10:00',8.62),('10318','2013-09-03','12:15:00',8.62),('10318','2013-09-03','12:20:00',8.63),('10318','2013-09-03','12:25:00',8.59),('10318','2013-09-03','12:30:00',8.62),('10318','2013-09-03','12:35:00',8.65),('10318','2013-09-03','12:40:00',8.69),('10318','2013-09-03','12:45:00',8.66),('10318','2013-09-03','12:50:00',8.61),('10318','2013-09-03','12:55:00',8.61),('10318','2013-09-03','13:00:00',8.59),('10318','2013-09-03','13:05:00',8.55),('10318','2013-09-03','13:10:00',8.55),('10318','2013-09-03','13:15:00',8.48),('10318','2013-09-03','13:20:00',8.47),('10318','2013-09-03','13:25:00',8.43),('10318','2013-09-03','13:30:00',8.28),('10318','2013-09-03','13:35:00',8.3),('10318','2013-09-03','13:40:00',8.25),('10318','2013-09-03','13:45:00',8.24),('10318','2013-09-03','13:50:00',8.06),('10318','2013-09-03','13:55:00',8.16),('10318','2013-09-03','14:00:00',8.11),('10318','2013-09-03','14:05:00',8.05),('10318','2013-09-03','14:10:00',7.93),('10318','2013-09-03','14:15:00',7.85),('10318','2013-09-03','14:20:00',7.8),('10318','2013-09-03','14:25:00',7.7),('10318','2013-09-03','14:30:00',7.69),('10318','2013-09-03','14:35:00',7.58),('10318','2013-09-03','14:40:00',7.59),('10318','2013-09-03','14:45:00',7.51),('10318','2013-09-03','14:50:00',7.33),('10318','2013-09-03','14:55:00',7.27),('10318','2013-09-03','15:00:00',7.2),('10318','2013-09-03','15:05:00',7.06),('10318','2013-09-03','15:10:00',6.91),('10318','2013-09-03','15:15:00',6.78),('10318','2013-09-03','15:20:00',6.67),('10318','2013-09-03','15:25:00',6.59),('10318','2013-09-03','15:30:00',6.46),('10318','2013-09-03','15:35:00',6.08),('10318','2013-09-03','15:40:00',6.17),('10318','2013-09-03','15:45:00',6.01),('10318','2013-09-03','15:50:00',5.83),('10318','2013-09-03','15:55:00',5.68),('10318','2013-09-03','16:00:00',5.55),('10318','2013-09-03','16:05:00',5.39),('10318','2013-09-03','16:10:00',5.3),('10318','2013-09-03','16:15:00',5.11),('10318','2013-09-03','16:20:00',4.93),('10318','2013-09-03','16:25:00',4.71),('10318','2013-09-03','16:30:00',4.57),('10318','2013-09-03','16:35:00',4.4),('10318','2013-09-03','16:40:00',4.26),('10318','2013-09-03','16:45:00',4.1),('10318','2013-09-03','16:50:00',3.91),('10318','2013-09-03','16:55:00',3.71),('10318','2013-09-03','17:00:00',3.54),('10318','2013-09-03','17:05:00',3.35),('10318','2013-09-03','17:10:00',3.2),('10318','2013-09-03','17:15:00',3.04),('10318','2013-09-03','17:20:00',2.87),('10318','2013-09-03','17:25:00',2.72),('10318','2013-09-03','17:30:00',2.55),('10318','2013-09-03','17:35:00',2.38),('10318','2013-09-03','17:40:00',2.22),('10318','2013-09-03','17:45:00',2),('10318','2013-09-03','17:50:00',1.73),('10318','2013-09-03','17:55:00',1.59),('10318','2013-09-03','18:00:00',1.48),('10318','2013-09-03','18:05:00',1.36),('10318','2013-09-03','18:10:00',1.25),('10318','2013-09-03','18:15:00',1.16),('10318','2013-09-03','18:20:00',1.03),('10318','2013-09-02','07:40:00',1.08),('10318','2013-09-02','07:45:00',1.45),('10318','2013-09-02','07:50:00',1.92),('10318','2013-09-02','07:55:00',2.22),('10318','2013-09-02','08:00:00',2.48),('10318','2013-09-02','08:05:00',2.74),('10318','2013-09-02','08:10:00',3.04),('10318','2013-09-02','08:15:00',3.26),('10318','2013-09-02','08:20:00',3.45),('10318','2013-09-02','08:25:00',3.65),('10318','2013-09-02','08:30:00',3.83),('10318','2013-09-02','08:35:00',4.09),('10318','2013-09-02','08:40:00',4.27),('10318','2013-09-02','08:45:00',4.48),('10318','2013-09-02','08:50:00',4.65),('10318','2013-09-02','08:55:00',4.82),('10318','2013-09-02','09:00:00',4.99),('10318','2013-09-02','09:05:00',5.17),('10318','2013-09-02','09:10:00',5.36),('10318','2013-09-02','09:15:00',5.52),('10318','2013-09-02','09:20:00',5.7),('10318','2013-09-02','09:25:00',5.84),('10318','2013-09-02','09:30:00',6.01),('10318','2013-09-02','09:35:00',6.15),('10318','2013-09-02','09:40:00',6.28),('10318','2013-09-02','09:45:00',6.31),('10318','2013-09-02','09:50:00',6.54),('10318','2013-09-02','09:55:00',6.66),('10318','2013-09-02','10:00:00',6.76),('10318','2013-09-02','10:05:00',6.89),('10318','2013-09-02','10:10:00',7.04),('10318','2013-09-02','10:15:00',7.17),('10318','2013-09-02','10:20:00',7.25),('10318','2013-09-02','10:25:00',7.37),('10318','2013-09-02','10:30:00',7.48),('10318','2013-09-02','10:35:00',7.61),('10318','2013-09-02','10:40:00',7.73),('10318','2013-09-02','10:45:00',7.82),('10318','2013-09-02','10:50:00',7.91),('10318','2013-09-02','10:55:00',7.95),('10318','2013-09-02','11:00:00',8.02),('10318','2013-09-02','11:05:00',8.13),('10318','2013-09-02','11:10:00',8.2),('10318','2013-09-02','11:15:00',8.22),('10318','2013-09-02','11:20:00',8.22),('10318','2013-09-02','11:25:00',8.29),('10318','2013-09-02','11:30:00',8.06),('10318','2013-09-02','11:35:00',8.39),('10318','2013-09-02','11:40:00',8.42),('10318','2013-09-02','11:45:00',8.48),('10318','2013-09-02','11:50:00',8.52),('10318','2013-09-02','11:55:00',8.57),('10318','2013-09-02','12:00:00',8.6),('10318','2013-09-02','12:05:00',8.63),('10318','2013-09-02','12:10:00',8.63),('10318','2013-09-02','12:15:00',8.69),('10318','2013-09-02','12:20:00',8.64),('10318','2013-09-02','12:25:00',8.67),('10318','2013-09-02','12:30:00',8.61),('10318','2013-09-02','12:35:00',8.59),('10318','2013-09-02','12:40:00',8.54),('10318','2013-09-02','12:45:00',8.54),('10318','2013-09-02','12:50:00',8.51),('10318','2013-09-02','12:55:00',8.47),('10318','2013-09-02','13:00:00',8.47),('10318','2013-09-02','13:05:00',8.49),('10318','2013-09-02','13:10:00',8.49),('10318','2013-09-02','13:15:00',8.3),('10318','2013-09-02','13:20:00',8.33),('10318','2013-09-02','13:25:00',8.38),('10318','2013-09-02','13:30:00',8.47),('10318','2013-09-02','13:35:00',8.41),('10318','2013-09-02','13:40:00',8.43),('10318','2013-09-02','13:45:00',8.3),('10318','2013-09-02','13:50:00',8.21),('10318','2013-09-02','13:55:00',8.03),('10318','2013-09-02','14:00:00',7.94),('10318','2013-09-02','14:05:00',7.99),('10318','2013-09-02','14:10:00',8.05),('10318','2013-09-02','14:15:00',8.01),('10318','2013-09-02','14:20:00',7.99),('10318','2013-09-02','14:25:00',8.03),('10318','2013-09-02','14:30:00',7.98),('10318','2013-09-02','14:35:00',7.64),('10318','2013-09-02','14:40:00',7.49),('10318','2013-09-02','14:45:00',7.54),('10318','2013-09-02','14:50:00',7.34),('10318','2013-09-02','14:55:00',3.67),('10318','2013-09-02','15:00:00',1.43),('10318','2013-09-02','15:05:00',5.54),('10318','2013-09-02','15:10:00',7.09),('10318','2013-09-02','15:15:00',6.88),('10318','2013-09-02','15:20:00',6.85),('10318','2013-09-02','15:25:00',6.74),('10318','2013-09-02','15:30:00',6.61),('10318','2013-09-02','15:35:00',6.51),('10318','2013-09-02','15:40:00',6.03),('10318','2013-09-02','15:45:00',5.96),('10318','2013-09-02','15:50:00',5.96),('10318','2013-09-02','15:55:00',5.79),('10318','2013-09-02','16:00:00',5.68),('10318','2013-09-02','16:05:00',5.46),('10318','2013-09-02','16:10:00',5.33),('10318','2013-09-02','16:15:00',5.09),('10318','2013-09-02','16:20:00',5.04),('10318','2013-09-02','16:25:00',4.84),('10318','2013-09-02','16:30:00',4.65),('10318','2013-09-02','16:35:00',4.47),('10318','2013-09-02','16:40:00',4.29),('10318','2013-09-02','16:45:00',4.15),('10318','2013-09-02','16:50:00',3.93),('10318','2013-09-02','16:55:00',3.7),('10318','2013-09-02','17:00:00',3.53),('10318','2013-09-02','17:05:00',3.35),('10318','2013-09-02','17:10:00',3.18),('10318','2013-09-02','17:15:00',3.05),('10318','2013-09-02','17:20:00',2.86),('10318','2013-09-02','17:25:00',2.71),('10318','2013-09-02','17:30:00',2.55),('10318','2013-09-02','17:35:00',2.39),('10318','2013-09-02','17:40:00',2.22),('10318','2013-09-02','17:45:00',2.06),('10318','2013-09-02','17:50:00',1.9),('10318','2013-09-02','17:55:00',1.76),('10318','2013-09-02','18:00:00',1.63),('10318','2013-09-02','18:05:00',1.46),('10318','2013-09-02','18:10:00',1.35),('10318','2013-09-02','18:15:00',1.21),('10318','2013-09-02','18:20:00',1.07),('10318','2013-09-01','07:40:00',1.15),('10318','2013-09-01','07:45:00',1.67),('10318','2013-09-01','07:50:00',2.13),('10318','2013-09-01','07:55:00',2.49),('10318','2013-09-01','08:00:00',2.65),('10318','2013-09-01','08:05:00',2.98),('10318','2013-09-01','08:10:00',3.25),('10318','2013-09-01','08:15:00',3.46),('10318','2013-09-01','08:20:00',3.66),('10318','2013-09-01','08:25:00',3.85),('10318','2013-09-01','08:30:00',4.02),('10318','2013-09-01','08:35:00',4.21),('10318','2013-09-01','08:40:00',4.41),('10318','2013-09-01','08:45:00',4.59),('10318','2013-09-01','08:50:00',4.75),('10318','2013-09-01','08:55:00',4.95),('10318','2013-09-01','09:00:00',5.04),('10318','2013-09-01','09:05:00',5.26),('10318','2013-09-01','09:10:00',5.46),('10318','2013-09-01','09:15:00',5.67),('10318','2013-09-01','09:20:00',5.83),('10318','2013-09-01','09:25:00',6),('10318','2013-09-01','09:30:00',6.14),('10318','2013-09-01','09:35:00',6.35),('10318','2013-09-01','09:40:00',6.47),('10318','2013-09-01','09:45:00',6.59),('10318','2013-09-01','09:50:00',6.75),('10318','2013-09-01','09:55:00',6.83),('10318','2013-09-01','10:00:00',6.98),('10318','2013-09-01','10:05:00',7.09),('10318','2013-09-01','10:10:00',7.18),('10318','2013-09-01','10:15:00',7.14),('10318','2013-09-01','10:20:00',7.36),('10318','2013-09-01','10:25:00',7.44),('10318','2013-09-01','10:30:00',7.54),('10318','2013-09-01','10:35:00',7.67),('10318','2013-09-01','10:40:00',7.77),('10318','2013-09-01','10:45:00',7.88),('10318','2013-09-01','10:50:00',7.98),('10318','2013-09-01','10:55:00',8.11),('10318','2013-09-01','11:00:00',8.2),('10318','2013-09-01','11:05:00',8.26),('10318','2013-09-01','11:10:00',8.3),('10318','2013-09-01','11:15:00',8.28),('10318','2013-09-01','11:20:00',8.31),('10318','2013-09-01','11:25:00',8.35),('10318','2013-09-01','11:30:00',8.45),('10318','2013-09-01','11:35:00',8.47),('10318','2013-09-01','11:40:00',8.54),('10318','2013-09-01','11:45:00',8.56),('10318','2013-09-01','11:50:00',8.61),('10318','2013-09-01','11:55:00',8.61),('10318','2013-09-01','12:00:00',8.53),('10318','2013-09-01','12:05:00',8.54),('10318','2013-09-01','12:10:00',8.65),('10318','2013-09-01','12:15:00',8.72),('10318','2013-09-01','12:20:00',8.73),('10318','2013-09-01','12:25:00',8.53),('10318','2013-09-01','12:30:00',8.67),('10318','2013-09-01','12:35:00',8.67),('10318','2013-09-01','12:40:00',8.72),('10318','2013-09-01','12:45:00',8.69),('10318','2013-09-01','12:50:00',8.63),('10318','2013-09-01','12:55:00',8.62),('10318','2013-09-01','13:00:00',8.58),('10318','2013-09-01','13:05:00',6.77),('10318','2013-09-01','13:10:00',8.66),('10318','2013-09-01','13:15:00',8.9),('10318','2013-09-01','13:20:00',7.57),('10318','2013-09-01','13:25:00',8.7),('10318','2013-09-01','13:30:00',8.69),('10318','2013-09-01','13:35:00',8.67),('10318','2013-09-01','13:40:00',8.45),('10318','2013-09-01','13:45:00',8.1),('10318','2013-09-01','13:50:00',7.79),('10318','2013-09-01','13:55:00',7.97),('10318','2013-09-01','14:00:00',7.61),('10318','2013-09-01','14:05:00',7.43),('10318','2013-09-01','14:10:00',6.9),('10318','2013-09-01','14:15:00',6.56),('10318','2013-09-01','14:20:00',6.78),('10318','2013-09-01','14:25:00',7.12),('10318','2013-09-01','14:30:00',6.29),('10318','2013-09-01','14:35:00',6.2),('10318','2013-09-01','14:40:00',6.87),('10318','2013-09-01','14:45:00',7.06),('10318','2013-09-01','14:50:00',6.53),('10318','2013-09-01','14:55:00',6.5),('10318','2013-09-01','15:00:00',6.48),('10318','2013-09-01','15:05:00',6.51),('10318','2013-09-01','15:10:00',6.48),('10318','2013-09-01','15:15:00',6.27),('10318','2013-09-01','15:20:00',6.2),('10318','2013-09-01','15:25:00',5.66),('10318','2013-09-01','15:30:00',4.86),('10318','2013-09-01','15:35:00',5.32),('10318','2013-09-01','15:40:00',5.46),('10318','2013-09-01','15:45:00',5.3),('10318','2013-09-01','15:50:00',4.7),('10318','2013-09-01','15:55:00',4.27),('10318','2013-09-01','16:00:00',4.86),('10318','2013-09-01','16:05:00',5.29),('10318','2013-09-01','16:10:00',5.04),('10318','2013-09-01','16:15:00',5.1),('10318','2013-09-01','16:20:00',5.13),('10318','2013-09-01','16:25:00',4.83),('10318','2013-09-01','16:30:00',4.95),('10318','2013-09-01','16:35:00',5.05),('10318','2013-09-01','16:40:00',4.55),('10318','2013-09-01','16:45:00',4.18),('10318','2013-09-01','16:50:00',3.97),('10318','2013-09-01','16:55:00',3.42),('10318','2013-09-01','17:00:00',3.22),('10318','2013-09-01','17:05:00',3.06),('10318','2013-09-01','17:10:00',2.71),('10318','2013-09-01','17:15:00',2.69),('10318','2013-09-01','17:20:00',2.73),('10318','2013-09-01','17:25:00',2.46),('10318','2013-09-01','17:30:00',2.55),('10318','2013-09-01','17:35:00',2.65),('10318','2013-09-01','17:40:00',2.45),('10318','2013-09-01','17:45:00',2.08),('10318','2013-09-01','17:50:00',2.14),('10318','2013-09-01','17:55:00',1.95),('10318','2013-09-01','18:00:00',1.94),('10318','2013-09-01','18:05:00',1.92),('10318','2013-09-01','18:10:00',1.87),('10318','2013-09-01','18:15:00',1.6),('10318','2013-09-01','18:20:00',1.45),('10318','2013-09-01','18:25:00',1.46),('10318','2013-09-01','18:30:00',1.26),('10318','2013-09-01','18:35:00',1.19),('10318','2013-09-01','18:40:00',1.13),('10318','2013-09-01','18:45:00',1.01),('10318','2013-08-31','07:25:00',1.02),('10318','2013-08-31','07:30:00',1.04),('10318','2013-08-31','07:35:00',1.01),('10318','2013-08-31','07:40:00',1.1),('10318','2013-08-31','07:45:00',1.21),('10318','2013-08-31','07:50:00',1.61),('10318','2013-08-31','07:55:00',1.9),('10318','2013-08-31','08:00:00',1.76),('10318','2013-08-31','08:05:00',1.79),('10318','2013-08-31','08:10:00',1.63),('10318','2013-08-31','08:15:00',2.54),('10318','2013-08-31','08:20:00',3.2),('10318','2013-08-31','08:25:00',3.81),('10318','2013-08-31','08:30:00',4.19),('10318','2013-08-31','08:35:00',4.3),('10318','2013-08-31','08:40:00',4.53),('10318','2013-08-31','08:45:00',4.83),('10318','2013-08-31','08:50:00',5.16),('10318','2013-08-31','08:55:00',5.55),('10318','2013-08-31','09:00:00',5.69),('10318','2013-08-31','09:05:00',4.99),('10318','2013-08-31','09:10:00',4),('10318','2013-08-31','09:15:00',5.68),('10318','2013-08-31','09:20:00',5.94),('10318','2013-08-31','09:25:00',6.39),('10318','2013-08-31','09:30:00',6.51),('10318','2013-08-31','09:35:00',6.74),('10318','2013-08-31','09:40:00',6.51),('10318','2013-08-31','09:45:00',6.26),('10318','2013-08-31','09:50:00',6.77),('10318','2013-08-31','09:55:00',6.92),('10318','2013-08-31','10:00:00',7.29),('10318','2013-08-31','10:05:00',7.15),('10318','2013-08-31','10:10:00',7.41),('10318','2013-08-31','10:15:00',7.51),('10318','2013-08-31','10:20:00',7.43),('10318','2013-08-31','10:25:00',7.56),('10318','2013-08-31','10:30:00',7.74),('10318','2013-08-31','10:35:00',7.69),('10318','2013-08-31','10:40:00',7.99),('10318','2013-08-31','10:45:00',8.09),('10318','2013-08-31','10:50:00',8.22),('10318','2013-08-31','10:55:00',8.32),('10318','2013-08-31','11:00:00',8.4),('10318','2013-08-31','11:05:00',8.43),('10318','2013-08-31','11:10:00',8.51),('10318','2013-08-31','11:15:00',8.59),('10318','2013-08-31','11:20:00',8.65),('10318','2013-08-31','11:25:00',8.72),('10318','2013-08-31','11:30:00',8.73),('10318','2013-08-31','11:35:00',8.77),('10318','2013-08-31','11:40:00',8.83),('10318','2013-08-31','11:45:00',8.88),('10318','2013-08-31','11:50:00',8.92),('10318','2013-08-31','11:55:00',8.95),('10318','2013-08-31','12:00:00',8.94),('10318','2013-08-31','12:05:00',8.94),('10318','2013-08-31','12:10:00',8.97),('10318','2013-08-31','12:15:00',8.93),('10318','2013-08-31','12:20:00',8.98),('10318','2013-08-31','12:25:00',8.71),('10318','2013-08-31','12:30:00',9.02),('10318','2013-08-31','12:35:00',8.99),('10318','2013-08-31','12:40:00',8.95),('10318','2013-08-31','12:45:00',8.91),('10318','2013-08-31','12:50:00',8.78),('10318','2013-08-31','12:55:00',8.87),('10318','2013-08-31','13:00:00',8.89),('10318','2013-08-31','13:05:00',8.71),('10318','2013-08-31','13:10:00',8.63),('10318','2013-08-31','13:15:00',8.75),('10318','2013-08-31','13:20:00',8.71),('10318','2013-08-31','13:25:00',8.63),('10318','2013-08-31','13:30:00',8.67),('10318','2013-08-31','13:35:00',8.44),('10318','2013-08-31','13:40:00',8.4),('10318','2013-08-31','13:45:00',8.33),('10318','2013-08-31','13:50:00',8.25),('10318','2013-08-31','13:55:00',8.18),('10318','2013-08-31','14:00:00',8.16),('10318','2013-08-31','14:05:00',8.11),('10318','2013-08-31','14:10:00',8.04),('10318','2013-08-31','14:15:00',7.97),('10318','2013-08-31','14:20:00',7.85),('10318','2013-08-31','14:25:00',7.79),('10318','2013-08-31','14:30:00',7.63),('10318','2013-08-31','14:35:00',7.39),('10318','2013-08-31','14:40:00',7.38),('10318','2013-08-31','14:45:00',7.31),('10318','2013-08-31','14:50:00',7.28),('10318','2013-08-31','14:55:00',7.12),('10318','2013-08-31','15:00:00',7.12),('10318','2013-08-31','15:05:00',7),('10318','2013-08-31','15:10:00',6.81),('10318','2013-08-31','15:15:00',6.69),('10318','2013-08-31','15:20:00',6.55),('10318','2013-08-31','15:25:00',6.33),('10318','2013-08-31','15:30:00',6.33),('10318','2013-08-31','15:35:00',6.19),('10318','2013-08-31','15:40:00',6.09),('10318','2013-08-31','15:45:00',5.87),('10318','2013-08-31','15:50:00',5.77),('10318','2013-08-31','15:55:00',5.57),('10318','2013-08-31','16:00:00',5.52),('10318','2013-08-31','16:05:00',5.42),('10318','2013-08-31','16:10:00',5.24),('10318','2013-08-31','16:15:00',4.99),('10318','2013-08-31','16:20:00',4.92),('10318','2013-08-31','16:25:00',4.63),('10318','2013-08-31','16:30:00',4.63),('10318','2013-08-31','16:35:00',4.51),('10318','2013-08-31','16:40:00',4.27),('10318','2013-08-31','16:45:00',4.01),('10318','2013-08-31','16:50:00',3.87),('10318','2013-08-31','16:55:00',3.62),('10318','2013-08-31','17:00:00',3.57),('10318','2013-08-31','17:05:00',3.45),('10318','2013-08-31','17:10:00',3.23),('10318','2013-08-31','17:15:00',3.12),('10318','2013-08-31','17:20:00',2.92),('10318','2013-08-31','17:25:00',2.74),('10318','2013-08-31','17:30:00',2.5),('10318','2013-08-31','17:35:00',2.35),('10318','2013-08-31','17:40:00',2.29),('10318','2013-08-31','17:45:00',2.12),('10318','2013-08-31','17:50:00',2.03),('10318','2013-08-31','17:55:00',1.55),('10318','2013-08-31','18:00:00',1.08),('10318','2013-08-31','18:05:00',1.02),('10318','2013-08-31','18:15:00',1.08),('10318','2013-08-31','18:20:00',1.09),('10318','2013-08-30','07:30:00',1.02),('10318','2013-08-30','07:35:00',1.31),('10318','2013-08-30','07:40:00',1.63),('10318','2013-08-30','07:45:00',1.88),('10318','2013-08-30','07:50:00',2.09),('10318','2013-08-30','07:55:00',2.32),('10318','2013-08-30','08:00:00',2.81),('10318','2013-08-30','08:05:00',3.32),('10318','2013-08-30','08:10:00',3.56),('10318','2013-08-30','08:15:00',3.23),('10318','2013-08-30','08:20:00',3.54),('10318','2013-08-30','08:25:00',3.61),('10318','2013-08-30','08:30:00',3.61),('10318','2013-08-30','08:35:00',3.82),('10318','2013-08-30','08:40:00',3.74),('10318','2013-08-30','08:45:00',3.29),('10318','2013-08-30','08:50:00',3.01),('10318','2013-08-30','08:55:00',3.13),('10318','2013-08-30','09:00:00',3.64),('10318','2013-08-30','09:05:00',3.7),('10318','2013-08-30','09:10:00',3.28),('10318','2013-08-30','09:15:00',2.99),('10318','2013-08-30','09:20:00',2.75),('10318','2013-08-30','09:25:00',3.23),('10318','2013-08-30','09:30:00',4.12),('10318','2013-08-30','09:35:00',4.13),('10318','2013-08-30','09:40:00',4.29),('10318','2013-08-30','09:45:00',4.25),('10318','2013-08-30','09:50:00',4.32),('10318','2013-08-30','09:55:00',4.56),('10318','2013-08-30','10:00:00',4.37),('10318','2013-08-30','10:05:00',4.36),('10318','2013-08-30','10:10:00',4.51),('10318','2013-08-30','10:15:00',4.87),('10318','2013-08-30','10:20:00',4.7),('10318','2013-08-30','10:25:00',4.65),('10318','2013-08-30','10:30:00',5.09),('10318','2013-08-30','10:35:00',4.9),('10318','2013-08-30','10:40:00',4.52),('10318','2013-08-30','10:45:00',4.46),('10318','2013-08-30','10:50:00',4.62),('10318','2013-08-30','10:55:00',4.51),('10318','2013-08-30','11:00:00',4.72),('10318','2013-08-30','11:05:00',5),('10318','2013-08-30','11:10:00',5.45),('10318','2013-08-30','11:15:00',5.33),('10318','2013-08-30','11:20:00',5.46),('10318','2013-08-30','11:25:00',5.58),('10318','2013-08-30','11:30:00',5.89),('10318','2013-08-30','11:35:00',5.7),('10318','2013-08-30','11:40:00',6.06),('10318','2013-08-30','11:45:00',5.99),('10318','2013-08-30','11:50:00',6.9),('10318','2013-08-30','11:55:00',5.87),('10318','2013-08-30','12:00:00',4.94),('10318','2013-08-30','12:05:00',4.66),('10318','2013-08-30','12:10:00',5.36),('10318','2013-08-30','12:15:00',5.48),('10318','2013-08-30','12:20:00',5.97),('10318','2013-08-30','12:25:00',7),('10318','2013-08-30','12:30:00',7.46),('10318','2013-08-30','12:35:00',6.93),('10318','2013-08-30','12:40:00',7.07),('10318','2013-08-30','12:45:00',7.01),('10318','2013-08-30','12:50:00',6.67),('10318','2013-08-30','12:55:00',6.09),('10318','2013-08-30','13:00:00',6.14),('10318','2013-08-30','13:05:00',5.93),('10318','2013-08-30','13:10:00',5.93),('10318','2013-08-30','13:15:00',6.58),('10318','2013-08-30','13:20:00',7.17),('10318','2013-08-30','13:25:00',8.44),('10318','2013-08-30','13:30:00',8.63),('10318','2013-08-30','13:35:00',8.29),('10318','2013-08-30','13:40:00',8.65),('10318','2013-08-30','13:45:00',7.92),('10318','2013-08-30','13:50:00',7.94),('10318','2013-08-30','13:55:00',8.32),('10318','2013-08-30','14:00:00',8.42),('10318','2013-08-30','14:05:00',8.22),('10318','2013-08-30','14:10:00',8.31),('10318','2013-08-30','14:15:00',7.95),('10318','2013-08-30','14:20:00',8.16),('10318','2013-08-30','14:25:00',7.97),('10318','2013-08-30','14:30:00',7.96),('10318','2013-08-30','14:35:00',8.01),('10318','2013-08-30','14:40:00',7.34),('10318','2013-08-30','14:45:00',6.48),('10318','2013-08-30','14:50:00',6.01),('10318','2013-08-30','14:55:00',5.82),('10318','2013-08-30','15:00:00',5.12),('10318','2013-08-30','15:05:00',4.7),('10318','2013-08-30','15:10:00',5.34),('10318','2013-08-30','15:15:00',5.63),('10318','2013-08-30','15:20:00',5.2),('10318','2013-08-30','15:25:00',4.61),('10318','2013-08-30','15:30:00',4.62),('10318','2013-08-30','15:35:00',3.85),('10318','2013-08-30','15:40:00',4.5),('10318','2013-08-30','15:45:00',5.01),('10318','2013-08-30','15:50:00',4.79),('10318','2013-08-30','15:55:00',4.57),('10318','2013-08-30','16:00:00',4.2),('10318','2013-08-30','16:05:00',3.66),('10318','2013-08-30','16:10:00',3.18),('10318','2013-08-30','16:15:00',3.35),('10318','2013-08-30','16:20:00',3.62),('10318','2013-08-30','16:25:00',3.51),('10318','2013-08-30','16:30:00',3.97),('10318','2013-08-30','16:35:00',4.62),('10318','2013-08-30','16:40:00',3.37),('10318','2013-08-30','16:45:00',3.51),('10318','2013-08-30','16:50:00',3.75),('10318','2013-08-30','16:55:00',4.07),('10318','2013-08-30','17:00:00',3.51),('10318','2013-08-30','17:05:00',2.48),('10318','2013-08-30','17:10:00',2.88),('10318','2013-08-30','17:15:00',2.58),('10318','2013-08-30','17:20:00',2.62),('10318','2013-08-30','17:25:00',2.63),('10318','2013-08-30','17:30:00',2.2),('10318','2013-08-30','17:35:00',2.83),('10318','2013-08-30','17:40:00',2.54),('10318','2013-08-30','17:45:00',2.34),('10318','2013-08-30','17:50:00',2.29),('10318','2013-08-30','17:55:00',2.39),('10318','2013-08-30','18:00:00',1.85),('10318','2013-08-30','18:05:00',1.04),('10318','2014-04-11','07:40:00',1.24),('10318','2014-04-11','07:45:00',1.77),('10318','2014-04-11','07:50:00',2.47),('10318','2014-04-11','07:55:00',1.87),('10318','2014-04-11','08:15:00',1.02),('10318','2014-04-11','08:20:00',1.11),('10318','2014-04-11','08:25:00',1.19),('10318','2014-04-11','08:30:00',4.33),('10318','2014-04-11','08:35:00',5.06),('10318','2014-04-11','08:40:00',5.33),('10318','2014-04-11','08:45:00',5.37),('10318','2014-04-11','08:50:00',5),('10318','2014-04-11','08:55:00',4.21),('10318','2014-04-11','09:00:00',5.56),('10318','2014-04-11','09:05:00',5.83),('10318','2014-04-11','09:10:00',6.04),('10318','2014-04-11','09:15:00',6.18),('10318','2014-04-11','09:20:00',6.39),('10318','2014-04-11','09:25:00',6.49),('10318','2014-04-11','09:30:00',6.67),('10318','2014-04-11','09:35:00',6.86),('10318','2014-04-11','09:40:00',7.02),('10318','2014-04-11','09:45:00',7.13),('10318','2014-04-11','09:50:00',7.31),('10318','2014-04-11','09:55:00',7.42),('10318','2014-04-11','10:00:00',7.59),('10318','2014-04-11','10:05:00',7.72),('10318','2014-04-11','10:10:00',7.85),('10318','2014-04-11','10:15:00',7.98),('10318','2014-04-11','10:20:00',8.14),('10318','2014-04-11','10:25:00',8.25),('10318','2014-04-11','10:30:00',8.31),('10318','2014-04-11','10:35:00',8.41),('10318','2014-04-11','10:40:00',8.48),('10318','2014-04-11','10:45:00',8.55),('10318','2014-04-11','10:50:00',8.75),('10318','2014-04-11','10:55:00',8.87),('10318','2014-04-11','11:00:00',8.97),('10318','2014-04-11','11:05:00',9.01),('10318','2014-04-11','11:10:00',9.16),('10318','2014-04-11','11:15:00',9.07),('10318','2014-04-11','11:20:00',9.22),('10318','2014-04-11','11:25:00',9.25),('10318','2014-04-11','11:30:00',9.31),('10318','2014-04-11','11:35:00',9.42),('10318','2014-04-11','11:40:00',9.51),('10318','2014-04-11','11:45:00',9.64),('10318','2014-04-11','11:50:00',9.69),('10318','2014-04-11','11:55:00',10.03),('10318','2014-04-11','12:00:00',9.96),('10318','2014-04-11','12:05:00',9.7),('10318','2014-04-11','12:10:00',9.46),('10318','2014-04-11','12:15:00',8.63),('10318','2014-04-11','12:20:00',9.56),('10318','2014-04-11','12:25:00',7.6),('10318','2014-04-11','12:30:00',6.04),('10318','2014-04-11','12:35:00',6.79),('10318','2014-04-11','12:40:00',7.28),('10318','2014-04-11','12:45:00',6.64),('10318','2014-04-11','12:50:00',4.75),('10318','2014-04-11','12:55:00',5.62),('10318','2014-04-11','13:00:00',10.27),('10318','2014-04-11','13:05:00',10.31),('10318','2014-04-11','13:10:00',10.21),('10318','2014-04-11','13:15:00',7.41),('10318','2014-04-11','13:20:00',9.04),('10318','2014-04-11','13:25:00',8.95),('10318','2014-04-11','13:30:00',9.89),('10318','2014-04-11','13:35:00',10.25),('10318','2014-04-11','13:40:00',8.21),('10318','2014-04-11','13:45:00',9.93),('10318','2014-04-11','13:50:00',9.04),('10318','2014-04-11','13:55:00',9.33),('10318','2014-04-11','14:00:00',8.55),('10318','2014-04-11','14:05:00',6.04),('10318','2014-04-11','14:10:00',6.14),('10318','2014-04-11','14:15:00',4.81),('10318','2014-04-11','14:20:00',7.03),('10318','2014-04-11','14:25:00',3.7),('10318','2014-04-11','14:30:00',7.14),('10318','2014-04-11','14:35:00',3.77),('10318','2014-04-11','14:40:00',9.64),('10318','2014-04-11','14:45:00',9.31),('10318','2014-04-11','14:50:00',8.91),('10318','2014-04-11','14:55:00',8.23),('10318','2014-04-11','15:00:00',8.4),('10318','2014-04-11','15:05:00',8.35),('10318','2014-04-11','15:10:00',8.22),('10318','2014-04-11','15:15:00',7.28),('10318','2014-04-11','15:20:00',8.05),('10318','2014-04-11','15:25:00',7.61),('10318','2014-04-11','15:30:00',7.36),('10318','2014-04-11','15:35:00',7.4),('10318','2014-04-11','15:40:00',7.12),('10318','2014-04-11','15:45:00',7.17),('10318','2014-04-11','15:50:00',6.97),('10318','2014-04-11','15:55:00',6.98),('10318','2014-04-11','16:00:00',5.74),('10318','2014-04-11','16:05:00',6.48),('10318','2014-04-11','16:10:00',6.27),('10318','2014-04-11','16:15:00',5.93),('10318','2014-04-11','16:20:00',5.57),('10318','2014-04-11','16:25:00',5.39),('10318','2014-04-11','16:30:00',5.3),('10318','2014-04-11','16:35:00',5.43),('10318','2014-04-11','16:40:00',5.08),('10318','2014-04-11','16:45:00',5.06),('10318','2014-04-11','16:50:00',5.14),('10318','2014-04-11','16:55:00',4.78),('10318','2014-04-11','17:00:00',3.45),('10318','2014-04-11','17:05:00',3.46),('10318','2014-04-11','17:10:00',3.5),('10318','2014-04-11','17:15:00',3.79),('10318','2014-04-11','17:20:00',3.5),('10318','2014-04-11','17:25:00',3.28),('10318','2014-04-11','17:30:00',3.39),('10318','2014-04-11','17:35:00',3.21),('10318','2014-04-11','17:40:00',2.61),('10318','2014-04-11','17:45:00',2.63),('10318','2014-04-11','17:50:00',2.34),('10318','2014-04-11','17:55:00',1.48),('10318','2014-04-11','18:00:00',1.88),('10318','2014-04-11','18:05:00',1.78),('10318','2014-04-11','18:10:00',1.66),('10318','2014-04-11','18:15:00',1.5),('10318','2014-04-11','18:20:00',1.38),('10318','2014-04-11','18:25:00',1.29),('10318','2014-04-11','18:30:00',1.25),('10318','2014-04-11','18:35:00',1.07),('10318','2013-08-29','07:35:00',1.26),('10318','2013-08-29','07:40:00',1.68),('10318','2013-08-29','07:45:00',2.01),('10318','2013-08-29','07:50:00',2.4),('10318','2013-08-29','07:55:00',2.72),('10318','2013-08-29','08:00:00',2.98),('10318','2013-08-29','08:05:00',3.19),('10318','2013-08-29','08:10:00',3.4),('10318','2013-08-29','08:15:00',3.75),('10318','2013-08-29','08:20:00',4.18),('10318','2013-08-29','08:25:00',4.59),('10318','2013-08-29','08:30:00',5.07),('10318','2013-08-29','08:35:00',4.38),('10318','2013-08-29','08:40:00',3.17),('10318','2013-08-29','08:45:00',2.58),('10318','2013-08-29','08:50:00',3.14),('10318','2013-08-29','08:55:00',3.59),('10318','2013-08-29','09:00:00',3.66),('10318','2013-08-29','09:05:00',3.34),('10318','2013-08-29','09:10:00',3.63),('10318','2013-08-29','09:15:00',3.71),('10318','2013-08-29','09:20:00',3.66),('10318','2013-08-29','09:25:00',3.52),('10318','2013-08-29','09:30:00',3.71),('10318','2013-08-29','09:35:00',4.13),('10318','2013-08-29','09:40:00',4.01),('10318','2013-08-29','09:45:00',3.38),('10318','2013-08-29','09:50:00',3.23),('10318','2013-08-29','09:55:00',3.33),('10318','2013-08-29','10:00:00',3.46),('10318','2013-08-29','10:05:00',3.31),('10318','2013-08-29','10:10:00',3.31),('10318','2013-08-29','10:15:00',3.34),('10318','2013-08-29','10:20:00',3.36),('10318','2013-08-29','10:25:00',3.38),('10318','2013-08-29','10:30:00',3.47),('10318','2013-08-29','10:35:00',3.19),('10318','2013-08-29','10:40:00',2.89),('10318','2013-08-29','10:45:00',2.74),('10318','2013-08-29','10:50:00',2.75),('10318','2013-08-29','10:55:00',3.16),('10318','2013-08-29','11:00:00',3.31),('10318','2013-08-29','11:05:00',3.49),('10318','2013-08-29','11:10:00',4.82),('10318','2013-08-29','11:15:00',4.72),('10318','2013-08-29','11:20:00',4.44),('10318','2013-08-29','11:25:00',3.67),('10318','2013-08-29','11:30:00',3.18),('10318','2013-08-29','11:35:00',3.03),('10318','2013-08-29','11:40:00',3.59),('10318','2013-08-29','11:45:00',4.08),('10318','2013-08-29','11:50:00',4.14),('10318','2013-08-29','11:55:00',3.85),('10318','2013-08-29','12:00:00',3.93),('10318','2013-08-29','12:05:00',4.57),('10318','2013-08-29','12:10:00',5.79),('10318','2013-08-29','12:15:00',6.27),('10318','2013-08-29','12:20:00',7.13),('10318','2013-08-29','12:25:00',6.36),('10318','2013-08-29','12:30:00',5.91),('10318','2013-08-29','12:35:00',7.34),('10318','2013-08-29','12:40:00',9.07),('10318','2013-08-29','12:45:00',8.62),('10318','2013-08-29','12:50:00',5.65),('10318','2013-08-29','12:55:00',6.62),('10318','2013-08-29','13:00:00',5.35),('10318','2013-08-29','13:05:00',5.65),('10318','2013-08-29','13:10:00',5.13),('10318','2013-08-29','13:15:00',5.21),('10318','2013-08-29','13:20:00',5.21),('10318','2013-08-29','13:25:00',4.23),('10318','2013-08-29','13:30:00',3.97),('10318','2013-08-29','13:35:00',3.8),('10318','2013-08-29','13:40:00',3.58),('10318','2013-08-29','13:45:00',3.3),('10318','2013-08-29','13:50:00',3.34),('10318','2013-08-29','13:55:00',4.47),('10318','2013-08-29','14:00:00',4.66),('10318','2013-08-29','14:05:00',3.41),('10318','2013-08-29','14:10:00',3.03),('10318','2013-08-29','14:15:00',2.52),('10318','2013-08-29','14:20:00',2.17),('10318','2013-08-29','14:25:00',1.98),('10318','2013-08-29','14:30:00',1.98),('10318','2013-08-29','14:35:00',2.04),('10318','2013-08-29','14:40:00',2.15),('10318','2013-08-29','14:45:00',2.39),('10318','2013-08-29','14:50:00',2.74),('10318','2013-08-29','14:55:00',3.21),('10318','2013-08-29','15:00:00',3.59),('10318','2013-08-29','15:05:00',3.94),('10318','2013-08-29','15:10:00',2.85),('10318','2013-08-29','15:15:00',2.62),('10318','2013-08-29','15:20:00',3.53),('10318','2013-08-29','15:25:00',4.3),('10318','2013-08-29','15:30:00',5.81),('10318','2013-08-29','15:35:00',4.36),('10318','2013-08-29','15:40:00',5.33),('10318','2013-08-29','15:45:00',4.06),('10318','2013-08-29','15:50:00',6.31),('10318','2013-08-29','15:55:00',6.08),('10318','2013-08-29','16:00:00',5.6),('10318','2013-08-29','16:05:00',7.01),('10318','2013-08-29','16:10:00',6.27),('10318','2013-08-29','16:15:00',5.78),('10318','2013-08-29','16:20:00',5.44),('10318','2013-08-29','16:25:00',5.23),('10318','2013-08-29','16:30:00',4.88),('10318','2013-08-29','16:35:00',4.81),('10318','2013-08-29','16:40:00',4.62),('10318','2013-08-29','16:45:00',4.38),('10318','2013-08-29','16:50:00',4.19),('10318','2013-08-29','16:55:00',4.03),('10318','2013-08-29','17:00:00',3.86),('10318','2013-08-29','17:05:00',3.69),('10318','2013-08-29','17:10:00',3.5),('10318','2013-08-29','17:15:00',3.3),('10318','2013-08-29','17:20:00',3.06),('10318','2013-08-29','17:25:00',2.88),('10318','2013-08-29','17:30:00',2.75),('10318','2013-08-29','17:35:00',2.57),('10318','2013-08-29','17:40:00',2.43),('10318','2013-08-29','17:45:00',2.25),('10318','2013-08-29','17:50:00',2.08),('10318','2013-08-29','17:55:00',1.93),('10318','2013-08-29','18:00:00',1.79),('10318','2013-08-29','18:05:00',1.64),('10318','2013-08-29','18:10:00',1.5),('10318','2013-08-29','18:15:00',1.36),('10318','2013-08-29','18:20:00',1.22),('10318','2013-08-29','18:25:00',1.06),('10318','2013-08-28','07:35:00',1.27),('10318','2013-08-28','07:40:00',1.43),('10318','2013-08-28','07:45:00',1.6),('10318','2013-08-28','07:50:00',1.87),('10318','2013-08-28','07:55:00',2.74),('10318','2013-08-28','08:00:00',2.59),('10318','2013-08-28','08:05:00',3.03),('10318','2013-08-28','08:10:00',3.34),('10318','2013-08-28','08:15:00',3.55),('10318','2013-08-28','08:20:00',3.7),('10318','2013-08-28','08:25:00',3.89),('10318','2013-08-28','08:30:00',4.06),('10318','2013-08-28','08:35:00',3.92),('10318','2013-08-28','08:40:00',4.18),('10318','2013-08-28','08:45:00',2.2),('10318','2013-08-28','08:50:00',2.06),('10318','2013-08-28','08:55:00',3.89),('10318','2013-08-28','09:00:00',5.17),('10318','2013-08-28','09:05:00',5.27),('10318','2013-08-28','09:10:00',5.28),('10318','2013-08-28','09:15:00',3.75),('10318','2013-08-28','09:20:00',2.9),('10318','2013-08-28','09:25:00',3.07),('10318','2013-08-28','09:30:00',6.15),('10318','2013-08-28','09:35:00',6.53),('10318','2013-08-28','09:40:00',6.6),('10318','2013-08-28','09:45:00',6.64),('10318','2013-08-28','09:50:00',6.76),('10318','2013-08-28','09:55:00',6.76),('10318','2013-08-28','10:00:00',7.03),('10318','2013-08-28','10:05:00',7.22),('10318','2013-08-28','10:10:00',7.11),('10318','2013-08-28','10:15:00',4.14),('10318','2013-08-28','10:20:00',7.76),('10318','2013-08-28','10:25:00',6.83),('10318','2013-08-28','10:30:00',3.71),('10318','2013-08-28','10:35:00',7.36),('10318','2013-08-28','10:40:00',5.87),('10318','2013-08-28','10:45:00',6.25),('10318','2013-08-28','10:50:00',8.86),('10318','2013-08-28','10:55:00',8.96),('10318','2013-08-28','11:00:00',7.32),('10318','2013-08-28','11:05:00',1.62),('10318','2013-08-28','11:10:00',6.35),('10318','2013-08-28','11:15:00',7.53),('10318','2013-08-28','11:20:00',9.29),('10318','2013-08-28','11:25:00',5.58),('10318','2013-08-28','11:30:00',8.65),('10318','2013-08-28','11:35:00',3.7),('10318','2013-08-28','11:40:00',7.63),('10318','2013-08-28','11:45:00',9.77),('10318','2013-08-28','11:50:00',7.9),('10318','2013-08-28','11:55:00',9.76),('10318','2013-08-28','12:00:00',9.84),('10318','2013-08-28','12:05:00',9.84),('10318','2013-08-28','12:10:00',9.43),('10318','2013-08-28','12:15:00',9.46),('10318','2013-08-28','12:20:00',6.55),('10318','2013-08-28','12:25:00',9.66),('10318','2013-08-28','12:30:00',9.52),('10318','2013-08-28','12:35:00',9.35),('10318','2013-08-28','12:40:00',5.06),('10318','2013-08-28','12:45:00',9.18),('10318','2013-08-28','12:50:00',9.27),('10318','2013-08-28','12:55:00',9.26),('10318','2013-08-28','13:00:00',8.43),('10318','2013-08-28','13:05:00',8.83),('10318','2013-08-28','13:10:00',9.21),('10318','2013-08-28','13:15:00',9.06),('10318','2013-08-28','13:20:00',9.21),('10318','2013-08-28','13:25:00',9.42),('10318','2013-08-28','13:30:00',8.39),('10318','2013-08-28','13:35:00',9.19),('10318','2013-08-28','13:40:00',7.63),('10318','2013-08-28','13:45:00',8.46),('10318','2013-08-28','13:50:00',9.03),('10318','2013-08-28','13:55:00',8.74),('10318','2013-08-28','14:00:00',8.53),('10318','2013-08-28','14:05:00',6.29),('10318','2013-08-28','14:10:00',8.88),('10318','2013-08-28','14:15:00',8.38),('10318','2013-08-28','14:20:00',8.55),('10318','2013-08-28','14:25:00',8.53),('10318','2013-08-28','14:30:00',8.61),('10318','2013-08-28','14:35:00',8.57),('10318','2013-08-28','14:40:00',8.28),('10318','2013-08-28','14:45:00',8.07),('10318','2013-08-28','14:50:00',7.91),('10318','2013-08-28','14:55:00',7.82),('10318','2013-08-28','15:00:00',7.73),('10318','2013-08-28','15:05:00',7.77),('10318','2013-08-28','15:10:00',7.82),('10318','2013-08-28','15:15:00',6.22),('10318','2013-08-28','15:20:00',7.57),('10318','2013-08-28','15:25:00',7.45),('10318','2013-08-28','15:30:00',5.09),('10318','2013-08-28','15:35:00',4.35),('10318','2013-08-28','15:40:00',7.01),('10318','2013-08-28','15:45:00',6.78),('10318','2013-08-28','15:50:00',6.73),('10318','2013-08-28','15:55:00',6.49),('10318','2013-08-28','16:00:00',6.33),('10318','2013-08-28','16:05:00',6.38),('10318','2013-08-28','16:10:00',6.15),('10318','2013-08-28','16:15:00',5.16),('10318','2013-08-28','16:20:00',4.79),('10318','2013-08-28','16:25:00',4.36),('10318','2013-08-28','16:30:00',5.37),('10318','2013-08-28','16:35:00',5.01),('10318','2013-08-28','16:40:00',4.82),('10318','2013-08-28','16:45:00',4.5),('10318','2013-08-28','16:50:00',4.35),('10318','2013-08-28','16:55:00',4.17),('10318','2013-08-28','17:00:00',4.01),('10318','2013-08-28','17:05:00',3.79),('10318','2013-08-28','17:10:00',3.04),('10318','2013-08-28','17:15:00',3.03),('10318','2013-08-28','17:20:00',1.29),('10318','2013-08-28','17:25:00',2.31),('10318','2013-08-28','17:30:00',2.6),('10318','2013-08-28','17:35:00',3),('10318','2013-08-28','17:40:00',2.36),('10318','2013-08-28','17:45:00',1.48),('10318','2013-08-28','17:50:00',1.51),('10318','2013-08-28','18:05:00',1.35),('10318','2013-08-28','18:10:00',1.72),('10318','2013-08-28','18:15:00',1.08),('10318','2013-08-28','18:20:00',1.45),('10318','2013-08-28','18:50:00',1.08),('10318','2013-08-27','08:00:00',1.12),('10318','2013-08-27','08:05:00',1.34),('10318','2013-08-27','08:10:00',1.62),('10318','2013-08-27','08:15:00',2.06),('10318','2013-08-27','08:20:00',2.88),('10318','2013-08-27','08:25:00',3.56),('10318','2013-08-27','08:30:00',3.41),('10318','2013-08-27','08:35:00',2.49),('10318','2013-08-27','08:40:00',2.61),('10318','2013-08-27','08:45:00',2.72),('10318','2013-08-27','08:50:00',2.47),('10318','2013-08-27','08:55:00',2.24),('10318','2013-08-27','09:00:00',2.54),('10318','2013-08-27','09:05:00',3.01),('10318','2013-08-27','09:10:00',3.71),('10318','2013-08-27','09:15:00',3.99),('10318','2013-08-27','09:20:00',4.41),('10318','2013-08-27','09:25:00',5.22),('10318','2013-08-27','09:30:00',5.82),('10318','2013-08-27','09:35:00',3.48),('10318','2013-08-27','09:40:00',2.73),('10318','2013-08-27','09:45:00',2.98),('10318','2013-08-27','09:50:00',3.33),('10318','2013-08-27','09:55:00',4.23),('10318','2013-08-27','10:00:00',5.29),('10318','2013-08-27','10:05:00',6.15),('10318','2013-08-27','10:10:00',7.06),('10318','2013-08-27','10:15:00',7.32),('10318','2013-08-27','10:20:00',7.39),('10318','2013-08-27','10:25:00',7.48),('10318','2013-08-27','10:30:00',7.52),('10318','2013-08-27','10:35:00',7.66),('10318','2013-08-27','10:40:00',7.72),('10318','2013-08-27','10:45:00',7.77),('10318','2013-08-27','10:50:00',7.8),('10318','2013-08-27','10:55:00',7.72),('10318','2013-08-27','11:00:00',7.85),('10318','2013-08-27','11:05:00',7.75),('10318','2013-08-27','11:10:00',7.46),('10318','2013-08-27','11:15:00',5.88),('10318','2013-08-27','11:20:00',8.19),('10318','2013-08-27','11:25:00',8.1),('10318','2013-08-27','11:30:00',8.18),('10318','2013-08-27','11:35:00',8.22),('10318','2013-08-27','11:40:00',7.58),('10318','2013-08-27','11:45:00',7.14),('10318','2013-08-27','11:50:00',5.89),('10318','2013-08-27','11:55:00',8.53),('10318','2013-08-27','12:00:00',8.11),('10318','2013-08-27','12:05:00',8.42),('10318','2013-08-27','12:10:00',5.05),('10318','2013-08-27','12:15:00',4.68),('10318','2013-08-27','12:20:00',8.46),('10318','2013-08-27','12:25:00',5.16),('10318','2013-08-27','12:30:00',4.32),('10318','2013-08-27','12:35:00',6.56),('10318','2013-08-27','12:40:00',9.5),('10318','2013-08-27','12:45:00',5.99),('10318','2013-08-27','12:50:00',4.44),('10318','2013-08-27','12:55:00',3.23),('10318','2013-08-27','13:00:00',2.43),('10318','2013-08-27','13:05:00',2.5),('10318','2013-08-27','13:10:00',3.75),('10318','2013-08-27','13:15:00',3.83),('10318','2013-08-27','13:20:00',4.17),('10318','2013-08-27','13:25:00',4.82),('10318','2013-08-27','13:30:00',4.79),('10318','2013-08-27','13:35:00',3.75),('10318','2013-08-27','13:40:00',3.49),('10318','2013-08-27','13:45:00',4.48),('10318','2013-08-27','13:50:00',5.13),('10318','2013-08-27','13:55:00',6.1),('10318','2013-08-27','14:00:00',7.59),('10318','2013-08-27','14:05:00',4.55),('10318','2013-08-27','14:10:00',4.52),('10318','2013-08-27','14:15:00',6.48),('10318','2013-08-27','14:20:00',5.3),('10318','2013-08-27','14:25:00',3.24),('10318','2013-08-27','14:30:00',2.64),('10318','2013-08-27','14:35:00',2.65),('10318','2013-08-27','14:40:00',3.12),('10318','2013-08-27','14:45:00',2.9),('10318','2013-08-27','14:50:00',2.34),('10318','2013-08-27','14:55:00',1.93),('10318','2013-08-27','15:00:00',2.06),('10318','2013-08-27','15:05:00',1.99),('10318','2013-08-27','15:10:00',1.91),('10318','2013-08-27','15:15:00',1.55),('10318','2013-08-27','15:20:00',1.17),('10318','2013-08-27','15:25:00',1.04),('10318','2013-08-27','15:30:00',1.36),('10318','2013-08-27','15:35:00',1.45),('10318','2013-08-27','15:40:00',1.34),('10318','2013-08-27','15:45:00',1.25),('10318','2013-08-27','15:50:00',1.72),('10318','2013-08-27','15:55:00',3.49),('10318','2013-08-27','16:00:00',5.06),('10318','2013-08-27','16:05:00',5.66),('10318','2013-08-27','16:10:00',6.96),('10318','2013-08-27','16:15:00',6.41),('10318','2013-08-27','16:20:00',3.62),('10318','2013-08-27','16:25:00',1.85),('10318','2013-08-27','16:30:00',3.29),('10318','2013-08-27','16:35:00',3.7),('10318','2013-08-27','16:40:00',2.14),('10318','2013-08-27','16:45:00',4.26),('10318','2013-08-27','16:50:00',3.41),('10318','2013-08-27','16:55:00',3.71),('10318','2013-08-27','17:00:00',1.84),('10318','2013-08-27','17:05:00',4.22),('10318','2013-08-27','17:10:00',4.02),('10318','2013-08-27','17:15:00',1.84),('10318','2013-08-27','17:20:00',2.22),('10318','2013-08-27','17:25:00',1.66),('10318','2013-08-27','17:30:00',1.45),('10318','2013-08-27','17:35:00',1.65),('10318','2013-08-27','17:40:00',1.55),('10318','2013-08-27','17:45:00',2.51),('10318','2013-08-27','17:50:00',2.44),('10318','2013-08-27','17:55:00',2.33),('10318','2013-08-27','18:00:00',2),('10318','2013-08-27','18:05:00',1.22),('10318','2013-08-26','07:25:00',1.15),('10318','2013-08-26','07:30:00',1.2),('10318','2013-08-26','07:35:00',1.36),('10318','2013-08-26','07:40:00',1.4),('10318','2013-08-26','07:45:00',1.68),('10318','2013-08-26','07:50:00',1.77),('10318','2013-08-26','07:55:00',1.52),('10318','2013-08-26','08:00:00',2.47),('10318','2013-08-26','08:05:00',3.25),('10318','2013-08-26','08:10:00',2.52),('10318','2013-08-26','08:15:00',2.72),('10318','2013-08-26','08:20:00',3.61),('10318','2013-08-26','08:25:00',2.94),('10318','2013-08-26','08:30:00',2.86),('10318','2013-08-26','08:35:00',4.33),('10318','2013-08-26','08:40:00',4.41),('10318','2013-08-26','08:45:00',4.68),('10318','2013-08-26','08:50:00',4.85),('10318','2013-08-26','08:55:00',5.02),('10318','2013-08-26','09:00:00',5.22),('10318','2013-08-26','09:05:00',5.37),('10318','2013-08-26','09:10:00',5.51),('10318','2013-08-26','09:15:00',5.64),('10318','2013-08-26','09:20:00',5.85),('10318','2013-08-26','09:25:00',6),('10318','2013-08-26','09:30:00',6.06),('10318','2013-08-26','09:35:00',6.25),('10318','2013-08-26','09:40:00',6.39),('10318','2013-08-26','09:45:00',6.5),('10318','2013-08-26','09:50:00',6.57),('10318','2013-08-26','09:55:00',6.7),('10318','2013-08-26','10:00:00',6.86),('10318','2013-08-26','10:05:00',7.01),('10318','2013-08-26','10:10:00',7.14),('10318','2013-08-26','10:15:00',7.22),('10318','2013-08-26','10:20:00',7.31),('10318','2013-08-26','10:25:00',7.43),('10318','2013-08-26','10:30:00',7.36),('10318','2013-08-26','10:35:00',7.6),('10318','2013-08-26','10:40:00',7.69),('10318','2013-08-26','10:45:00',7.77),('10318','2013-08-26','10:50:00',7.82),('10318','2013-08-26','10:55:00',7.94),('10318','2013-08-26','11:00:00',8.02),('10318','2013-08-26','11:05:00',8.11),('10318','2013-08-26','11:10:00',8.01),('10318','2013-08-26','11:15:00',8.11),('10318','2013-08-26','11:20:00',8.36),('10318','2013-08-26','11:25:00',8.39),('10318','2013-08-26','11:30:00',8.41),('10318','2013-08-26','11:35:00',8.42),('10318','2013-08-26','11:40:00',8.38),('10318','2013-08-26','11:45:00',8.53),('10318','2013-08-26','11:50:00',8.53),('10318','2013-08-26','11:55:00',8.51),('10318','2013-08-26','12:00:00',8.53),('10318','2013-08-26','12:05:00',8.61),('10318','2013-08-26','12:10:00',8.59),('10318','2013-08-26','12:15:00',8.61),('10318','2013-08-26','12:20:00',8.6),('10318','2013-08-26','12:25:00',8.53),('10318','2013-08-26','12:30:00',8.43),('10318','2013-08-26','12:35:00',8.53),('10318','2013-08-26','12:40:00',8.72),('10318','2013-08-26','12:45:00',8.75),('10318','2013-08-26','12:50:00',8.78),('10318','2013-08-26','12:55:00',8.66),('10318','2013-08-26','13:00:00',6.82),('10318','2013-08-26','13:05:00',6.74),('10318','2013-08-26','13:10:00',7.34),('10318','2013-08-26','13:15:00',7.86),('10318','2013-08-26','13:20:00',7),('10318','2013-08-26','13:25:00',7.33),('10318','2013-08-26','13:30:00',7.54),('10318','2013-08-26','13:35:00',8.22),('10318','2013-08-26','13:40:00',8.55),('10318','2013-08-26','13:45:00',8.56),('10318','2013-08-26','13:50:00',8.39),('10318','2013-08-26','13:55:00',5.4),('10318','2013-08-26','14:00:00',7.85),('10318','2013-08-26','14:05:00',7.49),('10318','2013-08-26','14:10:00',7.71),('10318','2013-08-26','14:15:00',7.58),('10318','2013-08-26','14:20:00',8.06),('10318','2013-08-26','14:25:00',7.85),('10318','2013-08-26','14:30:00',7.92),('10318','2013-08-26','14:35:00',7.75),('10318','2013-08-26','14:40:00',7.35),('10318','2013-08-26','14:45:00',5.37),('10318','2013-08-26','14:50:00',3.65),('10318','2013-08-26','14:55:00',3.65),('10318','2013-08-26','15:00:00',3.8),('10318','2013-08-26','15:05:00',2.83),('10318','2013-08-26','15:10:00',2.26),('10318','2013-08-26','15:15:00',1.99),('10318','2013-08-26','15:20:00',1.69),('10318','2013-08-26','15:25:00',1.63),('10318','2013-08-26','15:30:00',1.76),('10318','2013-08-26','15:35:00',2.28),('10318','2013-08-26','15:40:00',3.26),('10318','2013-08-26','15:45:00',3.38),('10318','2013-08-26','15:50:00',3.81),('10318','2013-08-26','15:55:00',3.11),('10318','2013-08-26','16:00:00',6.06),('10318','2013-08-26','16:05:00',6.4),('10318','2013-08-26','16:10:00',5.61),('10318','2013-08-26','16:15:00',5.37),('10318','2013-08-26','16:20:00',5.15),('10318','2013-08-26','16:25:00',4.94),('10318','2013-08-26','16:30:00',4.76),('10318','2013-08-26','16:35:00',4.69),('10318','2013-08-26','16:40:00',4.51),('10318','2013-08-26','16:45:00',4.36),('10318','2013-08-26','16:50:00',4.08),('10318','2013-08-26','16:55:00',3.93),('10318','2013-08-26','17:00:00',3.73),('10318','2013-08-26','17:05:00',3.46),('10318','2013-08-26','17:10:00',3.43),('10318','2013-08-26','17:15:00',3.22),('10318','2013-08-26','17:20:00',2.13),('10318','2013-08-26','17:25:00',1.4),('10318','2013-08-26','17:30:00',2.42),('10318','2013-08-26','17:35:00',2.03),('10318','2013-08-26','17:40:00',2.01),('10318','2013-08-26','17:45:00',2.27),('10318','2013-08-26','17:50:00',2.47),('10318','2013-08-26','17:55:00',2.36),('10318','2013-08-26','18:00:00',2.07),('10318','2013-08-26','18:05:00',1.77),('10318','2013-08-26','18:10:00',1.56),('10318','2013-08-26','18:15:00',1.39),('10318','2013-08-26','18:20:00',1.25),('10318','2013-08-26','18:25:00',1.12),('10318','2013-08-26','18:30:00',1.01),('10318','2013-08-25','07:30:00',1.02),('10318','2013-08-25','07:35:00',1.01),('10318','2013-08-25','07:40:00',1.38),('10318','2013-08-25','07:45:00',1.82),('10318','2013-08-25','07:50:00',2.19),('10318','2013-08-25','07:55:00',2.26),('10318','2013-08-25','08:00:00',2.33),('10318','2013-08-25','08:05:00',2.68),('10318','2013-08-25','08:10:00',2.48),('10318','2013-08-25','08:15:00',2.29),('10318','2013-08-25','08:20:00',3.04),('10318','2013-08-25','08:25:00',3.49),('10318','2013-08-25','08:30:00',2.83),('10318','2013-08-25','08:35:00',3.55),('10318','2013-08-25','08:40:00',3.79),('10318','2013-08-25','08:45:00',2.6),('10318','2013-08-25','08:50:00',2.74),('10318','2013-08-25','08:55:00',2.49),('10318','2013-08-25','09:05:00',2.09),('10318','2013-08-25','09:10:00',3.76),('10318','2013-08-25','09:15:00',3.99),('10318','2013-08-25','09:20:00',5.79),('10318','2013-08-25','09:25:00',5.95),('10318','2013-08-25','09:30:00',6.35),('10318','2013-08-25','09:35:00',6.62),('10318','2013-08-25','09:40:00',4.13),('10318','2013-08-25','09:45:00',3.91),('10318','2013-08-25','09:50:00',5.42),('10318','2013-08-25','09:55:00',6.29),('10318','2013-08-25','10:00:00',4.76),('10318','2013-08-25','10:05:00',2.82),('10318','2013-08-25','10:10:00',1.62),('10318','2013-08-25','10:15:00',1.43),('10318','2013-08-25','10:20:00',1.21),('10318','2013-08-25','10:25:00',1.05),('10318','2013-08-25','14:55:00',1.23),('10318','2013-08-25','15:00:00',1.68),('10318','2013-08-25','15:05:00',2.1),('10318','2013-08-25','15:10:00',2.31),('10318','2013-08-25','15:15:00',2.66),('10318','2013-08-25','15:20:00',3.17),('10318','2013-08-25','15:25:00',3.43),('10318','2013-08-25','15:30:00',5.49),('10318','2013-08-25','15:35:00',7.84),('10318','2013-08-25','15:40:00',4.98),('10318','2013-08-25','15:45:00',3.44),('10318','2013-08-25','15:50:00',4.36),('10318','2013-08-25','15:55:00',4.26),('10318','2013-08-25','16:00:00',5.55),('10318','2013-08-25','16:05:00',6.38),('10318','2013-08-25','16:10:00',6.02),('10318','2013-08-25','16:15:00',5.73),('10318','2013-08-25','16:20:00',5.5),('10318','2013-08-25','16:25:00',5.31),('10318','2013-08-25','16:30:00',5.17),('10318','2013-08-25','16:35:00',4.83),('10318','2013-08-25','16:40:00',3.54),('10318','2013-08-25','16:45:00',2.86),('10318','2013-08-25','16:50:00',4.3),('10318','2013-08-25','16:55:00',4.84),('10318','2013-08-25','17:00:00',4.25),('10318','2013-08-25','17:05:00',4.17),('10318','2013-08-25','17:10:00',3.76),('10318','2013-08-25','17:15:00',3.47),('10318','2013-08-25','17:20:00',3.28),('10318','2013-08-25','17:25:00',3.08),('10318','2013-08-25','17:30:00',2.87),('10318','2013-08-25','17:35:00',2.09),('10318','2013-08-25','17:40:00',2.25),('10318','2013-08-25','17:45:00',2.44),('10318','2013-08-25','17:50:00',2.16),('10318','2013-08-25','17:55:00',1.61),('10318','2013-08-25','18:00:00',1.52),('10318','2013-08-25','18:05:00',1.36),('10318','2013-08-25','18:10:00',1.61),('10318','2013-08-25','18:15:00',1.64),('10318','2013-08-25','18:20:00',1.49),('10318','2013-08-25','18:25:00',1.26),('10318','2013-08-24','07:30:00',1.02),('10318','2013-08-24','07:35:00',1.15),('10318','2013-08-24','07:40:00',1.59),('10318','2013-08-24','07:45:00',1.92),('10318','2013-08-24','07:50:00',2.11),('10318','2013-08-24','07:55:00',2.3),('10318','2013-08-24','08:00:00',2.53),('10318','2013-08-24','08:05:00',2.75),('10318','2013-08-24','08:10:00',2.96),('10318','2013-08-24','08:15:00',3.16),('10318','2013-08-24','08:20:00',3.27),('10318','2013-08-24','08:25:00',3.54),('10318','2013-08-24','08:30:00',3.74),('10318','2013-08-24','08:35:00',4.02),('10318','2013-08-24','08:40:00',3.61),('10318','2013-08-24','08:45:00',4.66),('10318','2013-08-24','08:50:00',4.86),('10318','2013-08-24','08:55:00',4.22),('10318','2013-08-24','09:00:00',1.63),('10318','2013-08-24','09:05:00',4.97),('10318','2013-08-24','09:10:00',5.32),('10318','2013-08-24','09:15:00',5.54),('10318','2013-08-24','09:20:00',5.49),('10318','2013-08-24','09:25:00',5.34),('10318','2013-08-24','09:30:00',5.98),('10318','2013-08-24','09:35:00',6.18),('10318','2013-08-24','09:40:00',6.2),('10318','2013-08-24','09:45:00',6.36),('10318','2013-08-24','09:50:00',6.53),('10318','2013-08-24','09:55:00',6.67),('10318','2013-08-24','10:00:00',6.08),('10318','2013-08-24','10:05:00',6.99),('10318','2013-08-24','10:10:00',7.04),('10318','2013-08-24','10:15:00',7.23),('10318','2013-08-24','10:20:00',7.34),('10318','2013-08-24','10:25:00',7.45),('10318','2013-08-24','10:30:00',7.54),('10318','2013-08-24','10:35:00',7.64),('10318','2013-08-24','10:40:00',7.71),('10318','2013-08-24','10:45:00',7.79),('10318','2013-08-24','10:50:00',7.85),('10318','2013-08-24','10:55:00',7.82),('10318','2013-08-24','11:00:00',8.03),('10318','2013-08-24','11:05:00',7.48),('10318','2013-08-24','11:10:00',8.16),('10318','2013-08-24','11:15:00',8.07),('10318','2013-08-24','11:20:00',8.18),('10318','2013-08-24','11:25:00',8.14),('10318','2013-08-24','11:30:00',8.42),('10318','2013-08-24','11:35:00',8.43),('10318','2013-08-24','11:40:00',8.44),('10318','2013-08-24','11:45:00',8.43),('10318','2013-08-24','11:50:00',8.59),('10318','2013-08-24','11:55:00',8.41),('10318','2013-08-24','12:00:00',8.31),('10318','2013-08-24','12:05:00',8.54),('10318','2013-08-24','12:10:00',8.62),('10318','2013-08-24','12:15:00',8.68),('10318','2013-08-24','12:20:00',8.69),('10318','2013-08-24','12:25:00',8.67),('10318','2013-08-24','12:30:00',8.66),('10318','2013-08-24','12:35:00',8.69),('10318','2013-08-24','12:40:00',8.66),('10318','2013-08-24','12:45:00',8.62),('10318','2013-08-24','12:50:00',8.6),('10318','2013-08-24','12:55:00',8.63),('10318','2013-08-24','13:00:00',8.54),('10318','2013-08-24','13:05:00',8.62),('10318','2013-08-24','13:10:00',8.39),('10318','2013-08-24','13:15:00',8.55),('10318','2013-08-24','13:20:00',8.5),('10318','2013-08-24','13:25:00',8.48),('10318','2013-08-24','13:30:00',8.46),('10318','2013-08-24','13:35:00',8.38),('10318','2013-08-24','13:40:00',8.38),('10318','2013-08-24','13:45:00',8.38),('10318','2013-08-24','13:50:00',8.3),('10318','2013-08-24','13:55:00',8.2),('10318','2013-08-24','14:00:00',8.17),('10318','2013-08-24','14:05:00',8.11),('10318','2013-08-24','14:10:00',8.07),('10318','2013-08-24','14:15:00',8.02),('10318','2013-08-24','14:20:00',7.94),('10318','2013-08-24','14:25:00',7.85),('10318','2013-08-24','14:30:00',7.8),('10318','2013-08-24','14:35:00',7.73),('10318','2013-08-24','14:40:00',7.69),('10318','2013-08-24','14:45:00',7.57),('10318','2013-08-24','14:50:00',7.47),('10318','2013-08-24','14:55:00',7.27),('10318','2013-08-24','15:00:00',7.31),('10318','2013-08-24','15:05:00',7.2),('10318','2013-08-24','15:10:00',7.13),('10318','2013-08-24','15:15:00',7.02),('10318','2013-08-24','15:20:00',6.88),('10318','2013-08-24','15:25:00',6.72),('10318','2013-08-24','15:30:00',6.63),('10318','2013-08-24','15:35:00',6.51),('10318','2013-08-24','15:40:00',6.38),('10318','2013-08-24','15:45:00',6.22),('10318','2013-08-24','15:50:00',6.08),('10318','2013-08-24','15:55:00',5.94),('10318','2013-08-24','16:00:00',5.8),('10318','2013-08-24','16:05:00',5.64),('10318','2013-08-24','16:10:00',5.53),('10318','2013-08-24','16:15:00',5.38),('10318','2013-08-24','16:20:00',5.21),('10318','2013-08-24','16:25:00',5.04),('10318','2013-08-24','16:30:00',4.9),('10318','2013-08-24','16:35:00',4.72),('10318','2013-08-24','16:40:00',4.42),('10318','2013-08-24','16:45:00',4.38),('10318','2013-08-24','16:50:00',4.2),('10318','2013-08-24','16:55:00',4.03),('10318','2013-08-24','17:00:00',3.87),('10318','2013-08-24','17:05:00',3.69),('10318','2013-08-24','17:10:00',3.51),('10318','2013-08-24','17:15:00',3.34),('10318','2013-08-24','17:20:00',3.17),('10318','2013-08-24','17:25:00',3),('10318','2013-08-24','17:30:00',2.83),('10318','2013-08-24','17:35:00',2.65),('10318','2013-08-24','17:40:00',2.48),('10318','2013-08-24','17:45:00',2.34),('10318','2013-08-24','17:50:00',2.18),('10318','2013-08-24','17:55:00',2.01),('10318','2013-08-24','18:00:00',1.87),('10318','2013-08-24','18:05:00',1.72),('10318','2013-08-24','18:10:00',1.58),('10318','2013-08-24','18:15:00',1.44),('10318','2013-08-24','18:20:00',1.3),('10318','2013-08-24','18:25:00',1.14),('10318','2013-08-24','18:30:00',1.05),('10318','2013-08-23','07:30:00',1.01),('10318','2013-08-23','07:35:00',1.13),('10318','2013-08-23','07:40:00',1.4),('10318','2013-08-23','07:45:00',1.64),('10318','2013-08-23','07:50:00',1.91),('10318','2013-08-23','07:55:00',2.12),('10318','2013-08-23','08:00:00',2.34),('10318','2013-08-23','08:05:00',2.5),('10318','2013-08-23','08:10:00',2.75),('10318','2013-08-23','08:15:00',2.99),('10318','2013-08-23','08:20:00',3.2),('10318','2013-08-23','08:25:00',3.07),('10318','2013-08-23','08:30:00',3.49),('10318','2013-08-23','08:35:00',3.68),('10318','2013-08-23','08:40:00',3.86),('10318','2013-08-23','08:45:00',4.05),('10318','2013-08-23','08:50:00',4.26),('10318','2013-08-23','08:55:00',4.47),('10318','2013-08-23','09:00:00',4.58),('10318','2013-08-23','09:05:00',4.75),('10318','2013-08-23','09:10:00',4.92),('10318','2013-08-23','09:15:00',5.06),('10318','2013-08-23','09:20:00',5.21),('10318','2013-08-23','09:25:00',5.31),('10318','2013-08-23','09:30:00',5.46),('10318','2013-08-23','09:35:00',5.61),('10318','2013-08-23','09:40:00',5.78),('10318','2013-08-23','09:45:00',5.89),('10318','2013-08-23','09:50:00',5.88),('10318','2013-08-23','09:55:00',6.09),('10318','2013-08-23','10:00:00',6.22),('10318','2013-08-23','10:05:00',6.36),('10318','2013-08-23','10:10:00',6.54),('10318','2013-08-23','10:15:00',6.66),('10318','2013-08-23','10:20:00',6.7),('10318','2013-08-23','10:25:00',6.72),('10318','2013-08-23','10:30:00',6.86),('10318','2013-08-23','10:35:00',6.97),('10318','2013-08-23','10:40:00',7.01),('10318','2013-08-23','10:45:00',6.9),('10318','2013-08-23','10:50:00',6.7),('10318','2013-08-23','10:55:00',3.61),('10318','2013-08-23','11:00:00',3.77),('10318','2013-08-23','11:05:00',7.68),('10318','2013-08-23','11:10:00',4.37),('10318','2013-08-23','11:15:00',6.24),('10318','2013-08-23','11:20:00',6.07),('10318','2013-08-23','11:25:00',7.86),('10318','2013-08-23','11:30:00',4.19),('10318','2013-08-23','11:35:00',3.81),('10318','2013-08-23','11:40:00',7.97),('10318','2013-08-23','11:45:00',8.74),('10318','2013-08-23','11:50:00',8.92),('10318','2013-08-23','11:55:00',4.06),('10318','2013-08-23','12:00:00',6),('10318','2013-08-23','12:05:00',9.31),('10318','2013-08-23','12:10:00',8.96),('10318','2013-08-23','12:15:00',9.09),('10318','2013-08-23','12:20:00',3.53),('10318','2013-08-23','12:25:00',6.99),('10318','2013-08-23','12:30:00',9.34),('10318','2013-08-23','12:35:00',7.43),('10318','2013-08-23','12:40:00',3.11),('10318','2013-08-23','12:45:00',6.56),('10318','2013-08-23','12:50:00',3.4),('10318','2013-08-23','12:55:00',9.43),('10318','2013-08-23','13:00:00',9.06),('10318','2013-08-23','13:05:00',8.29),('10318','2013-08-23','13:10:00',9.03),('10318','2013-08-23','13:15:00',8.33),('10318','2013-08-23','13:20:00',8.82),('10318','2013-08-23','13:25:00',8.49),('10318','2013-08-23','13:30:00',5.7),('10318','2013-08-23','13:35:00',5.27),('10318','2013-08-23','13:40:00',5.82),('10318','2013-08-23','13:45:00',9.07),('10318','2013-08-23','13:50:00',7.52),('10318','2013-08-23','13:55:00',8.66),('10318','2013-08-23','14:00:00',8.2),('10318','2013-08-23','14:05:00',8.39),('10318','2013-08-23','14:10:00',8.24),('10318','2013-08-23','14:15:00',8.18),('10318','2013-08-23','14:20:00',8.1),('10318','2013-08-23','14:25:00',8.01),('10318','2013-08-23','14:30:00',7.9),('10318','2013-08-23','14:35:00',7.82),('10318','2013-08-23','14:40:00',7.63),('10318','2013-08-23','14:45:00',7.64),('10318','2013-08-23','14:50:00',7.52),('10318','2013-08-23','14:55:00',7.37),('10318','2013-08-23','15:00:00',7.01),('10318','2013-08-23','15:05:00',7.05),('10318','2013-08-23','15:10:00',7.02),('10318','2013-08-23','15:15:00',6.76),('10318','2013-08-23','15:20:00',6.72),('10318','2013-08-23','15:25:00',6.85),('10318','2013-08-23','15:30:00',6.83),('10318','2013-08-23','15:35:00',6.13),('10318','2013-08-23','15:40:00',6.34),('10318','2013-08-23','15:45:00',5.89),('10318','2013-08-23','15:50:00',5.87),('10318','2013-08-23','15:55:00',5.74),('10318','2013-08-23','16:00:00',5.57),('10318','2013-08-23','16:05:00',4.75),('10318','2013-08-23','16:10:00',4.54),('10318','2013-08-23','16:15:00',5.3),('10318','2013-08-23','16:20:00',5.41),('10318','2013-08-23','16:25:00',4.69),('10318','2013-08-23','16:30:00',4.43),('10318','2013-08-23','16:35:00',4.98),('10318','2013-08-23','16:40:00',4.74),('10318','2013-08-23','16:45:00',4.53),('10318','2013-08-23','16:50:00',4.22),('10318','2013-08-23','16:55:00',4.08),('10318','2013-08-23','17:00:00',3.89),('10318','2013-08-23','17:05:00',3.69),('10318','2013-08-23','17:10:00',3.5),('10318','2013-08-23','17:15:00',3.37),('10318','2013-08-23','17:20:00',3.2),('10318','2013-08-23','17:25:00',3.04),('10318','2013-08-23','17:30:00',2.86),('10318','2013-08-23','17:35:00',2.65),('10318','2013-08-23','17:40:00',2.46),('10318','2013-08-23','17:45:00',2.3),('10318','2013-08-23','17:50:00',2.21),('10318','2013-08-23','17:55:00',2.06),('10318','2013-08-23','18:00:00',1.87),('10318','2013-08-23','18:05:00',1.75),('10318','2013-08-23','18:10:00',1.46),('10318','2013-08-23','18:15:00',1.4),('10318','2013-08-23','18:20:00',1.38),('10318','2013-08-23','18:25:00',1.26),('10318','2013-08-23','18:30:00',1.13),('10318','2013-08-23','18:35:00',1),('10318','2013-08-22','07:30:00',1.01),('10318','2013-08-22','07:35:00',1.25),('10318','2013-08-22','07:40:00',1.63),('10318','2013-08-22','07:45:00',1.94),('10318','2013-08-22','07:50:00',2.13),('10318','2013-08-22','07:55:00',2.34),('10318','2013-08-22','08:00:00',2.59),('10318','2013-08-22','08:05:00',2.74),('10318','2013-08-22','08:10:00',2.95),('10318','2013-08-22','08:15:00',3.09),('10318','2013-08-22','08:20:00',3.3),('10318','2013-08-22','08:25:00',3.52),('10318','2013-08-22','08:30:00',3.7),('10318','2013-08-22','08:35:00',3.89),('10318','2013-08-22','08:40:00',4.11),('10318','2013-08-22','08:45:00',4.34),('10318','2013-08-22','08:50:00',4.51),('10318','2013-08-22','08:55:00',4.74),('10318','2013-08-22','09:00:00',4.98),('10318','2013-08-22','09:05:00',5.32),('10318','2013-08-22','09:10:00',5.55),('10318','2013-08-22','09:15:00',5.75),('10318','2013-08-22','09:20:00',6.14),('10318','2013-08-22','09:25:00',6.29),('10318','2013-08-22','09:30:00',6.61),('10318','2013-08-22','09:35:00',5.16),('10318','2013-08-22','09:40:00',6.55),('10318','2013-08-22','09:45:00',6.34),('10318','2013-08-22','09:50:00',6.22),('10318','2013-08-22','09:55:00',6.39),('10318','2013-08-22','10:00:00',5.9),('10318','2013-08-22','10:05:00',7.44),('10318','2013-08-22','10:10:00',7.46),('10318','2013-08-22','10:15:00',7.28),('10318','2013-08-22','10:20:00',7.24),('10318','2013-08-22','10:25:00',7.37),('10318','2013-08-22','10:30:00',7.51),('10318','2013-08-22','10:35:00',7.54),('10318','2013-08-22','10:40:00',7.59),('10318','2013-08-22','10:45:00',7.66),('10318','2013-08-22','10:50:00',7.72),('10318','2013-08-22','10:55:00',7.77),('10318','2013-08-22','11:00:00',7.86),('10318','2013-08-22','11:05:00',7.91),('10318','2013-08-22','11:10:00',7.97),('10318','2013-08-22','11:15:00',8.09),('10318','2013-08-22','11:20:00',8.1),('10318','2013-08-22','11:25:00',8.2),('10318','2013-08-22','11:30:00',8.18),('10318','2013-08-22','11:35:00',8.12),('10318','2013-08-22','11:40:00',8.3),('10318','2013-08-22','11:45:00',8.31),('10318','2013-08-22','11:50:00',8.36),('10318','2013-08-22','11:55:00',8.4),('10318','2013-08-22','12:00:00',8.5),('10318','2013-08-22','12:05:00',8.49),('10318','2013-08-22','12:10:00',8.41),('10318','2013-08-22','12:15:00',8.44),('10318','2013-08-22','12:20:00',8.47),('10318','2013-08-22','12:25:00',8.46),('10318','2013-08-22','12:30:00',8.46),('10318','2013-08-22','12:35:00',8.42),('10318','2013-08-22','12:40:00',8.39),('10318','2013-08-22','12:45:00',8.38),('10318','2013-08-22','12:50:00',8.37),('10318','2013-08-22','12:55:00',8.38),('10318','2013-08-22','13:00:00',8.36),('10318','2013-08-22','13:05:00',8.36),('10318','2013-08-22','13:10:00',8.29),('10318','2013-08-22','13:15:00',8.22),('10318','2013-08-22','13:20:00',8.21),('10318','2013-08-22','13:25:00',8.06),('10318','2013-08-22','13:30:00',8.21),('10318','2013-08-22','13:35:00',8.15),('10318','2013-08-22','13:40:00',8.1),('10318','2013-08-22','13:45:00',8.06),('10318','2013-08-22','13:50:00',8.02),('10318','2013-08-22','13:55:00',7.91),('10318','2013-08-22','14:00:00',7.84),('10318','2013-08-22','14:05:00',7.78),('10318','2013-08-22','14:10:00',7.74),('10318','2013-08-22','14:15:00',7.76),('10318','2013-08-22','14:20:00',7.87),('10318','2013-08-22','14:25:00',7.79),('10318','2013-08-22','14:30:00',7.59),('10318','2013-08-22','14:35:00',3.88),('10318','2013-08-22','14:40:00',2.2),('10318','2013-08-22','14:45:00',2.45),('10318','2013-08-22','14:50:00',4.75),('10318','2013-08-22','14:55:00',7.47),('10318','2013-08-22','15:00:00',7.3),('10318','2013-08-22','15:05:00',7.13),('10318','2013-08-22','15:10:00',6.62),('10318','2013-08-22','15:15:00',6.83),('10318','2013-08-22','15:20:00',6.75),('10318','2013-08-22','15:25:00',6.57),('10318','2013-08-22','15:30:00',6.42),('10318','2013-08-22','15:35:00',6.26),('10318','2013-08-22','15:40:00',6.2),('10318','2013-08-22','15:45:00',6.05),('10318','2013-08-22','15:50:00',5.93),('10318','2013-08-22','15:55:00',5.8),('10318','2013-08-22','16:00:00',5.66),('10318','2013-08-22','16:05:00',5.54),('10318','2013-08-22','16:10:00',5.37),('10318','2013-08-22','16:15:00',5.22),('10318','2013-08-22','16:20:00',5.08),('10318','2013-08-22','16:25:00',4.91),('10318','2013-08-22','16:30:00',4.76),('10318','2013-08-22','16:35:00',4.6),('10318','2013-08-22','16:40:00',4.38),('10318','2013-08-22','16:45:00',4.19),('10318','2013-08-22','16:50:00',4.04),('10318','2013-08-22','16:55:00',3.85),('10318','2013-08-22','17:00:00',3.74),('10318','2013-08-22','17:05:00',3.57),('10318','2013-08-22','17:10:00',3.41),('10318','2013-08-22','17:15:00',3.24),('10318','2013-08-22','17:20:00',3.09),('10318','2013-08-22','17:25:00',2.9),('10318','2013-08-22','17:30:00',2.75),('10318','2013-08-22','17:35:00',2.62),('10318','2013-08-22','17:40:00',2.46),('10318','2013-08-22','17:45:00',2.28),('10318','2013-08-22','17:50:00',2.12),('10318','2013-08-22','17:55:00',2.01),('10318','2013-08-22','18:00:00',1.89),('10318','2013-08-22','18:05:00',1.79),('10318','2013-08-22','18:10:00',1.73),('10318','2013-08-22','18:15:00',1.74),('10318','2013-08-22','18:20:00',1.66),('10318','2013-08-22','18:25:00',1.39),('10318','2013-08-22','18:30:00',1.24),('10318','2013-08-22','18:35:00',1.05),('10318','2013-08-21','08:05:00',1.03),('10318','2013-08-21','08:10:00',1.12),('10318','2013-08-21','08:15:00',1.23),('10318','2013-08-21','08:20:00',1.45),('10318','2013-08-21','08:25:00',1.64),('10318','2013-08-21','08:30:00',1.8),('10318','2013-08-21','08:35:00',1.93),('10318','2013-08-21','08:40:00',1.9),('10318','2013-08-21','08:45:00',1.71),('10318','2013-08-21','08:50:00',1.57),('10318','2013-08-21','08:55:00',1.62),('10318','2013-08-21','09:00:00',2.17),('10318','2013-08-21','09:05:00',3.74),('10318','2013-08-21','09:10:00',4.96),('10318','2013-08-21','09:15:00',4.67),('10318','2013-08-21','09:20:00',6.06),('10318','2013-08-21','09:25:00',3.64),('10318','2013-08-21','09:30:00',1.92),('10318','2013-08-21','09:35:00',1.81),('10318','2013-08-21','09:40:00',2.13),('10318','2013-08-21','09:45:00',2.45),('10318','2013-08-21','09:50:00',3),('10318','2013-08-21','09:55:00',5.24),('10318','2013-08-21','10:00:00',8.43),('10318','2013-08-21','10:05:00',7.78),('10318','2013-08-21','10:10:00',7.47),('10318','2013-08-21','10:15:00',7.85),('10318','2013-08-21','10:20:00',7.75),('10318','2013-08-21','10:25:00',7.35),('10318','2013-08-21','10:30:00',7.69),('10318','2013-08-21','10:35:00',5.52),('10318','2013-08-21','10:40:00',5.8),('10318','2013-08-21','10:45:00',4.63),('10318','2013-08-21','10:50:00',8.1),('10318','2013-08-21','10:55:00',5.31),('10318','2013-08-21','11:00:00',4.94),('10318','2013-08-21','11:05:00',4.49),('10318','2013-08-21','11:10:00',3.74),('10318','2013-08-21','11:15:00',4.29),('10318','2013-08-21','11:20:00',5.61),('10318','2013-08-21','11:25:00',7.69),('10318','2013-08-21','11:30:00',9.03),('10318','2013-08-21','11:35:00',9.4),('10318','2013-08-21','11:40:00',9.25),('10318','2013-08-21','11:45:00',9.16),('10318','2013-08-21','11:50:00',9.16),('10318','2013-08-21','11:55:00',9.05),('10318','2013-08-21','12:00:00',9.02),('10318','2013-08-21','12:05:00',9.1),('10318','2013-08-21','12:10:00',9.04),('10318','2013-08-21','12:15:00',8.89),('10318','2013-08-21','12:20:00',8.74),('10318','2013-08-21','12:25:00',8.62),('10318','2013-08-21','12:30:00',6.71),('10318','2013-08-21','12:35:00',4.83),('10318','2013-08-21','12:40:00',7.31),('10318','2013-08-21','12:45:00',8.72),('10318','2013-08-21','12:50:00',8.06),('10318','2013-08-21','12:55:00',8.2),('10318','2013-08-21','13:00:00',8.14),('10318','2013-08-21','13:05:00',8.19),('10318','2013-08-21','13:10:00',8.44),('10318','2013-08-21','13:15:00',8.42),('10318','2013-08-21','13:20:00',8.53),('10318','2013-08-21','13:25:00',8.48),('10318','2013-08-21','13:30:00',8.28),('10318','2013-08-21','13:35:00',8.18),('10318','2013-08-21','13:40:00',7.99),('10318','2013-08-21','13:45:00',8.1),('10318','2013-08-21','13:50:00',8.22),('10318','2013-08-21','13:55:00',8),('10318','2013-08-21','14:00:00',8.18),('10318','2013-08-21','14:05:00',7.95),('10318','2013-08-21','14:10:00',7.96),('10318','2013-08-21','14:15:00',6.23),('10318','2013-08-21','14:20:00',6.74),('10318','2013-08-21','14:25:00',6.18),('10318','2013-08-21','14:30:00',5.59),('10318','2013-08-21','14:35:00',7.29),('10318','2013-08-21','14:40:00',7.24),('10318','2013-08-21','14:45:00',6.89),('10318','2013-08-21','14:50:00',6.81),('10318','2013-08-21','14:55:00',7.09),('10318','2013-08-21','15:00:00',7.05),('10318','2013-08-21','15:05:00',6.89),('10318','2013-08-21','15:10:00',6.61),('10318','2013-08-21','15:15:00',6.68),('10318','2013-08-21','15:20:00',6.6),('10318','2013-08-21','15:25:00',6.18),('10318','2013-08-21','15:30:00',5.86),('10318','2013-08-21','15:35:00',5.51),('10318','2013-08-21','15:40:00',5.76),('10318','2013-08-21','15:45:00',5.69),('10318','2013-08-21','15:50:00',5.36),('10318','2013-08-21','15:55:00',5.21),('10318','2013-08-21','16:00:00',5.11),('10318','2013-08-21','16:05:00',4.88),('10318','2013-08-21','16:10:00',4.81),('10318','2013-08-21','16:15:00',5.07),('10318','2013-08-21','16:20:00',4.96),('10318','2013-08-21','16:25:00',5.18),('10318','2013-08-21','16:30:00',5.18),('10318','2013-08-21','16:35:00',4.9),('10318','2013-08-21','16:40:00',4.73),('10318','2013-08-21','16:45:00',4.56),('10318','2013-08-21','16:50:00',4.4),('10318','2013-08-21','16:55:00',4.26),('10318','2013-08-21','17:00:00',4.18),('10318','2013-08-21','17:05:00',4.01),('10318','2013-08-21','17:10:00',3.83),('10318','2013-08-21','17:15:00',3.69),('10318','2013-08-21','17:20:00',3.6),('10318','2013-08-21','17:25:00',3.43),('10318','2013-08-21','17:30:00',3.32),('10318','2013-08-21','17:35:00',3.2),('10318','2013-08-21','17:40:00',3.05),('10318','2013-08-21','17:45:00',2.9),('10318','2013-08-21','17:50:00',2.78),('10318','2013-08-21','17:55:00',2.63),('10318','2013-08-21','18:00:00',2.49),('10318','2013-08-21','18:05:00',2.31),('10318','2013-08-21','18:10:00',2.16),('10318','2013-08-21','18:15:00',2.01),('10318','2013-08-21','18:20:00',1.83),('10318','2013-08-21','18:25:00',1.62),('10318','2013-08-21','18:30:00',1.31),('10318','2013-08-21','18:35:00',1.15),('10318','2013-08-21','18:40:00',1.1),('10318','2013-08-20','07:30:00',1.18),('10318','2013-08-20','07:35:00',1.38),('10318','2013-08-20','07:40:00',1.47),('10318','2013-08-20','07:45:00',1.54),('10318','2013-08-20','07:50:00',2.34),('10318','2013-08-20','07:55:00',3.32),('10318','2013-08-20','08:00:00',2.29),('10318','2013-08-20','08:05:00',1.56),('10318','2013-08-20','08:10:00',1.54),('10318','2013-08-20','08:15:00',1.49),('10318','2013-08-20','08:20:00',1.55),('10318','2013-08-20','08:25:00',1.62),('10318','2013-08-20','08:30:00',1.74),('10318','2013-08-20','08:35:00',1.79),('10318','2013-08-20','08:40:00',1.84),('10318','2013-08-20','08:45:00',2.06),('10318','2013-08-20','08:50:00',2.28),('10318','2013-08-20','08:55:00',2.54),('10318','2013-08-20','09:00:00',2.08),('10318','2013-08-20','09:05:00',1.88),('10318','2013-08-20','09:10:00',1.62),('10318','2013-08-20','09:15:00',2.11),('10318','2013-08-20','09:20:00',3.51),('10318','2013-08-20','09:25:00',5.66),('10318','2013-08-20','09:30:00',6.65),('10318','2013-08-20','09:35:00',5.89),('10318','2013-08-20','09:40:00',4.44),('10318','2013-08-20','09:45:00',3.83),('10318','2013-08-20','09:50:00',3.49),('10318','2013-08-20','09:55:00',4.68),('10318','2013-08-20','10:00:00',5.3),('10318','2013-08-20','10:05:00',2.81),('10318','2013-08-20','10:10:00',2.93),('10318','2013-08-20','10:15:00',2.8),('10318','2013-08-20','10:20:00',2),('10318','2013-08-20','10:25:00',2.57),('10318','2013-08-20','10:30:00',6.82),('10318','2013-08-20','10:35:00',4.9),('10318','2013-08-20','10:40:00',2.93),('10318','2013-08-20','10:45:00',3.39),('10318','2013-08-20','10:50:00',6.01),('10318','2013-08-20','10:55:00',3.12),('10318','2013-08-20','11:00:00',4.98),('10318','2013-08-20','11:05:00',3.17),('10318','2013-08-20','11:10:00',3.54),('10318','2013-08-20','11:15:00',9.72),('10318','2013-08-20','11:20:00',9.62),('10318','2013-08-20','11:25:00',9.33),('10318','2013-08-20','11:30:00',9.22),('10318','2013-08-20','11:35:00',9.46),('10318','2013-08-20','11:40:00',6.73),('10318','2013-08-20','11:45:00',3.37),('10318','2013-08-20','11:50:00',3.56),('10318','2013-08-20','11:55:00',5.76),('10318','2013-08-20','12:00:00',4.2),('10318','2013-08-20','12:05:00',3.57),('10318','2013-08-20','12:10:00',3.37),('10318','2013-08-20','12:15:00',2.74),('10318','2013-08-20','12:20:00',2.82),('10318','2013-08-20','12:25:00',3.34),('10318','2013-08-20','12:30:00',3.56),('10318','2013-08-20','12:35:00',3.91),('10318','2013-08-20','12:40:00',4.75),('10318','2013-08-20','12:45:00',4.24),('10318','2013-08-20','12:50:00',4.27),('10318','2013-08-20','12:55:00',4.56),('10318','2013-08-20','13:00:00',4.32),('10318','2013-08-20','13:05:00',3.63),('10318','2013-08-20','13:10:00',3.52),('10318','2013-08-20','13:15:00',3.57),('10318','2013-08-20','13:20:00',3.65),('10318','2013-08-20','13:25:00',3.87),('10318','2013-08-20','13:30:00',4.43),('10318','2013-08-20','13:35:00',5.27),('10318','2013-08-20','13:40:00',5.68),('10318','2013-08-20','13:45:00',5.28),('10318','2013-08-20','13:50:00',9.49),('10318','2013-08-20','13:55:00',8.96),('10318','2013-08-20','14:00:00',8.77),('10318','2013-08-20','14:05:00',8.66),('10318','2013-08-20','14:10:00',7.15),('10318','2013-08-20','14:15:00',7.32),('10318','2013-08-20','14:20:00',8.07),('10318','2013-08-20','14:25:00',5.97),('10318','2013-08-20','14:30:00',8.51),('10318','2013-08-20','14:35:00',8.24),('10318','2013-08-20','14:40:00',5.78),('10318','2013-08-20','14:45:00',8.51),('10318','2013-08-20','14:50:00',8.46),('10318','2013-08-20','14:55:00',6.8),('10318','2013-08-20','15:00:00',7.61),('10318','2013-08-20','15:05:00',7.84),('10318','2013-08-20','15:10:00',7.8),('10318','2013-08-20','15:15:00',7.67),('10318','2013-08-20','15:20:00',7.46),('10318','2013-08-20','15:25:00',7.38),('10318','2013-08-20','15:30:00',7.34),('10318','2013-08-20','15:35:00',7.41),('10318','2013-08-20','15:40:00',7.48),('10318','2013-08-20','15:45:00',7.39),('10318','2013-08-20','15:50:00',7.51),('10318','2013-08-20','15:55:00',7.43),('10318','2013-08-20','16:00:00',7.25),('10318','2013-08-20','16:05:00',7.16),('10318','2013-08-20','16:10:00',7.03),('10318','2013-08-20','16:15:00',6.96),('10318','2013-08-20','16:20:00',6.75),('10318','2013-08-20','16:25:00',6.56),('10318','2013-08-20','16:30:00',5.65),('10318','2013-08-20','16:35:00',5.44),('10318','2013-08-20','16:40:00',5.39),('10318','2013-08-20','16:45:00',5.35),('10318','2013-08-20','16:50:00',4.65),('10318','2013-08-20','16:55:00',4.71),('10318','2013-08-20','17:00:00',4.33),('10318','2013-08-20','17:05:00',4.15),('10318','2013-08-20','17:10:00',3.9),('10318','2013-08-20','17:15:00',3.67),('10318','2013-08-20','17:20:00',3.46),('10318','2013-08-20','17:25:00',3.31),('10318','2013-08-20','17:30:00',3.14),('10318','2013-08-20','17:35:00',3.03),('10318','2013-08-20','17:40:00',3.02),('10318','2013-08-20','17:45:00',2.71),('10318','2013-08-20','17:50:00',2.34),('10318','2013-08-20','17:55:00',2.12),('10318','2013-08-20','18:00:00',2.05),('10318','2013-08-20','18:05:00',1.84),('10318','2013-08-20','18:10:00',1.83),('10318','2013-08-20','18:15:00',1.87),('10318','2013-08-20','18:20:00',1.75),('10318','2013-08-20','18:25:00',1.76),('10318','2013-08-20','18:30:00',1.77),('10318','2013-08-20','18:35:00',1.52),('10318','2013-08-20','18:40:00',1.54),('10318','2013-08-20','18:45:00',1.5),('10318','2013-08-20','18:50:00',1.19),('10318','2013-08-20','18:55:00',1.27),('10318','2013-08-20','19:00:00',1.22),('10318','2013-08-20','19:05:00',1.03),('10318','2014-04-10','07:40:00',1.08),('10318','2014-04-10','07:45:00',1.65),('10318','2014-04-10','07:50:00',2.31),('10318','2014-04-10','07:55:00',2.84),('10318','2014-04-10','08:00:00',3.13),('10318','2014-04-10','08:05:00',3.48),('10318','2014-04-10','08:10:00',3.79),('10318','2014-04-10','08:15:00',4.03),('10318','2014-04-10','08:20:00',4.26),('10318','2014-04-10','08:25:00',4.5),('10318','2014-04-10','08:30:00',4.71),('10318','2014-04-10','08:35:00',4.93),('10318','2014-04-10','08:40:00',5.16),('10318','2014-04-10','08:45:00',5.37),('10318','2014-04-10','08:50:00',5.58),('10318','2014-04-10','08:55:00',5.74),('10318','2014-04-10','09:00:00',5.8),('10318','2014-04-10','09:05:00',6.16),('10318','2014-04-10','09:10:00',6.3),('10318','2014-04-10','09:15:00',6.36),('10318','2014-04-10','09:20:00',6.45),('10318','2014-04-10','09:25:00',6.85),('10318','2014-04-10','09:30:00',7.03),('10318','2014-04-10','09:35:00',7.19),('10318','2014-04-10','09:40:00',7.27),('10318','2014-04-10','09:45:00',7.43),('10318','2014-04-10','09:50:00',7.61),('10318','2014-04-10','09:55:00',7.73),('10318','2014-04-10','10:00:00',7.86),('10318','2014-04-10','10:05:00',8),('10318','2014-04-10','10:10:00',8.15),('10318','2014-04-10','10:15:00',8.14),('10318','2014-04-10','10:20:00',8.28),('10318','2014-04-10','10:25:00',8.36),('10318','2014-04-10','10:30:00',8.41),('10318','2014-04-10','10:35:00',8.75),('10318','2014-04-10','10:40:00',8.81),('10318','2014-04-10','10:45:00',8.56),('10318','2014-04-10','10:50:00',8.64),('10318','2014-04-10','10:55:00',8.92),('10318','2014-04-10','11:00:00',8.98),('10318','2014-04-10','11:05:00',9.16),('10318','2014-04-10','11:10:00',9.02),('10318','2014-04-10','11:15:00',9.13),('10318','2014-04-10','11:20:00',9.62),('10318','2014-04-10','11:25:00',9.66),('10318','2014-04-10','11:30:00',9.67),('10318','2014-04-10','11:35:00',9.77),('10318','2014-04-10','11:40:00',9.39),('10318','2014-04-10','11:45:00',9.75),('10318','2014-04-10','11:50:00',9.48),('10318','2014-04-10','11:55:00',9.71),('10318','2014-04-10','12:00:00',9.4),('10318','2014-04-10','12:05:00',8.94),('10318','2014-04-10','12:10:00',9.55),('10318','2014-04-10','12:15:00',9.48),('10318','2014-04-10','12:20:00',9.44),('10318','2014-04-10','12:25:00',8.99),('10318','2014-04-10','12:30:00',9.11),('10318','2014-04-10','12:35:00',9.76),('10318','2014-04-10','12:40:00',9.12),('10318','2014-04-10','12:45:00',9.22),('10318','2014-04-10','12:50:00',9.31),('10318','2014-04-10','12:55:00',9.42),('10318','2014-04-10','13:00:00',8.79),('10318','2014-04-10','13:05:00',9.05),('10318','2014-04-10','13:10:00',9.72),('10318','2014-04-10','13:15:00',9.18),('10318','2014-04-10','13:20:00',8.67),('10318','2014-04-10','13:25:00',9.36),('10318','2014-04-10','13:30:00',9.37),('10318','2014-04-10','13:35:00',9.47),('10318','2014-04-10','13:40:00',8.86),('10318','2014-04-10','13:45:00',9.22),('10318','2014-04-10','13:50:00',9.17),('10318','2014-04-10','13:55:00',9.12),('10318','2014-04-10','14:00:00',9.05),('10318','2014-04-10','14:05:00',8.76),('10318','2014-04-10','14:10:00',8.73),('10318','2014-04-10','14:15:00',8.85),('10318','2014-04-10','14:20:00',8.83),('10318','2014-04-10','14:25:00',8.71),('10318','2014-04-10','14:30:00',8.57),('10318','2014-04-10','14:35:00',8.56),('10318','2014-04-10','14:40:00',8.39),('10318','2014-04-10','14:45:00',7.4),('10318','2014-04-10','14:50:00',8.38),('10318','2014-04-10','14:55:00',8.19),('10318','2014-04-10','15:00:00',7.98),('10318','2014-04-10','15:05:00',7.84),('10318','2014-04-10','15:10:00',7.63),('10318','2014-04-10','15:15:00',7.56),('10318','2014-04-10','15:20:00',7.52),('10318','2014-04-10','15:25:00',7.25),('10318','2014-04-10','15:30:00',6.75),('10318','2014-04-10','15:35:00',6.34),('10318','2014-04-10','15:40:00',6.45),('10318','2014-04-10','15:45:00',6.53),('10318','2014-04-10','15:50:00',6.28),('10318','2014-04-10','15:55:00',6.27),('10318','2014-04-10','16:00:00',6.33),('10318','2014-04-10','16:05:00',6.21),('10318','2014-04-10','16:10:00',6.29),('10318','2014-04-10','16:15:00',6.22),('10318','2014-04-10','16:20:00',5.85),('10318','2014-04-10','16:25:00',5.72),('10318','2014-04-10','16:30:00',5.65),('10318','2014-04-10','16:35:00',5.31),('10318','2014-04-10','16:40:00',5.24),('10318','2014-04-10','16:45:00',5.11),('10318','2014-04-10','16:50:00',4.72),('10318','2014-04-10','16:55:00',4.58),('10318','2014-04-10','17:00:00',4.32),('10318','2014-04-10','17:05:00',4.19),('10318','2014-04-10','17:10:00',3.97),('10318','2014-04-10','17:15:00',3.71),('10318','2014-04-10','17:20:00',3.5),('10318','2014-04-10','17:25:00',3.3),('10318','2014-04-10','17:30:00',3.07),('10318','2014-04-10','17:35:00',2.85),('10318','2014-04-10','17:40:00',2.67),('10318','2014-04-10','17:45:00',2.49),('10318','2014-04-10','17:50:00',2.28),('10318','2014-04-10','17:55:00',2.12),('10318','2014-04-10','18:00:00',1.96),('10318','2014-04-10','18:05:00',1.78),('10318','2014-04-10','18:10:00',1.62),('10318','2014-04-10','18:15:00',1.45),('10318','2014-04-10','18:20:00',1.28),('10318','2014-04-10','18:25:00',1.14),('10318','2013-08-19','07:35:00',1.23),('10318','2013-08-19','07:40:00',1.81),('10318','2013-08-19','07:45:00',1.79),('10318','2013-08-19','07:50:00',1.99),('10318','2013-08-19','07:55:00',2.47),('10318','2013-08-19','08:00:00',2.75),('10318','2013-08-19','08:05:00',3.02),('10318','2013-08-19','08:10:00',3.24),('10318','2013-08-19','08:15:00',3.41),('10318','2013-08-19','08:20:00',3.59),('10318','2013-08-19','08:25:00',3.79),('10318','2013-08-19','08:30:00',4.02),('10318','2013-08-19','08:35:00',4.18),('10318','2013-08-19','08:40:00',4.36),('10318','2013-08-19','08:45:00',4.59),('10318','2013-08-19','08:50:00',4.83),('10318','2013-08-19','08:55:00',4.99),('10318','2013-08-19','09:00:00',5.15),('10318','2013-08-19','09:05:00',5.32),('10318','2013-08-19','09:10:00',5.48),('10318','2013-08-19','09:15:00',5.63),('10318','2013-08-19','09:20:00',5.8),('10318','2013-08-19','09:25:00',5.99),('10318','2013-08-19','09:30:00',6.05),('10318','2013-08-19','09:35:00',6.26),('10318','2013-08-19','09:40:00',6.34),('10318','2013-08-19','09:45:00',6.46),('10318','2013-08-19','09:50:00',6.62),('10318','2013-08-19','09:55:00',6.76),('10318','2013-08-19','10:00:00',6.88),('10318','2013-08-19','10:05:00',6.95),('10318','2013-08-19','10:10:00',7),('10318','2013-08-19','10:15:00',7.13),('10318','2013-08-19','10:20:00',7.22),('10318','2013-08-19','10:25:00',7.34),('10318','2013-08-19','10:30:00',7.51),('10318','2013-08-19','10:35:00',7.54),('10318','2013-08-19','10:40:00',7.63),('10318','2013-08-19','10:45:00',7.71),('10318','2013-08-19','10:50:00',7.84),('10318','2013-08-19','10:55:00',7.83),('10318','2013-08-19','11:00:00',7.92),('10318','2013-08-19','11:05:00',7.89),('10318','2013-08-19','11:10:00',8.04),('10318','2013-08-19','11:15:00',8.03),('10318','2013-08-19','11:20:00',8.13),('10318','2013-08-19','11:25:00',8.11),('10318','2013-08-19','11:30:00',8.16),('10318','2013-08-19','11:35:00',8.13),('10318','2013-08-19','11:40:00',8.19),('10318','2013-08-19','11:45:00',8.41),('10318','2013-08-19','11:50:00',8.54),('10318','2013-08-19','11:55:00',8.62),('10318','2013-08-19','12:00:00',8.56),('10318','2013-08-19','12:05:00',8.6),('10318','2013-08-19','12:10:00',8.57),('10318','2013-08-19','12:15:00',8.6),('10318','2013-08-19','12:20:00',8.63),('10318','2013-08-19','12:25:00',8.61),('10318','2013-08-19','12:30:00',8.66),('10318','2013-08-19','12:35:00',8.66),('10318','2013-08-19','12:40:00',8.68),('10318','2013-08-19','12:45:00',8.68),('10318','2013-08-19','12:50:00',8.76),('10318','2013-08-19','12:55:00',8.75),('10318','2013-08-19','13:00:00',8.74),('10318','2013-08-19','13:05:00',8.62),('10318','2013-08-19','13:10:00',8.78),('10318','2013-08-19','13:15:00',8.72),('10318','2013-08-19','13:20:00',8.67),('10318','2013-08-19','13:25:00',8.63),('10318','2013-08-19','13:30:00',8.58),('10318','2013-08-19','13:35:00',8.55),('10318','2013-08-19','13:40:00',8.47),('10318','2013-08-19','13:45:00',8.45),('10318','2013-08-19','13:50:00',8.38),('10318','2013-08-19','13:55:00',8.3),('10318','2013-08-19','14:00:00',8.27),('10318','2013-08-19','14:05:00',8.23),('10318','2013-08-19','14:10:00',8.22),('10318','2013-08-19','14:15:00',8.13),('10318','2013-08-19','14:20:00',8.08),('10318','2013-08-19','14:25:00',8.02),('10318','2013-08-19','14:30:00',8),('10318','2013-08-19','14:35:00',7.93),('10318','2013-08-19','14:40:00',7.87),('10318','2013-08-19','14:45:00',7.76),('10318','2013-08-19','14:50:00',7.55),('10318','2013-08-19','14:55:00',7.6),('10318','2013-08-19','15:00:00',7.52),('10318','2013-08-19','15:05:00',7.48),('10318','2013-08-19','15:10:00',7.38),('10318','2013-08-19','15:15:00',7.23),('10318','2013-08-19','15:20:00',7.05),('10318','2013-08-19','15:25:00',6.93),('10318','2013-08-19','15:30:00',6.86),('10318','2013-08-19','15:35:00',6.75),('10318','2013-08-19','15:40:00',6.61),('10318','2013-08-19','15:45:00',6.48),('10318','2013-08-19','15:50:00',6.32),('10318','2013-08-19','15:55:00',6.16),('10318','2013-08-19','16:00:00',6),('10318','2013-08-19','16:05:00',5.76),('10318','2013-08-19','16:10:00',5.74),('10318','2013-08-19','16:15:00',5.59),('10318','2013-08-19','16:20:00',5.43),('10318','2013-08-19','16:25:00',5.28),('10318','2013-08-19','16:30:00',5.11),('10318','2013-08-19','16:35:00',4.94),('10318','2013-08-19','16:40:00',4.78),('10318','2013-08-19','16:45:00',4.63),('10318','2013-08-19','16:50:00',4.46),('10318','2013-08-19','16:55:00',4.29),('10318','2013-08-19','17:00:00',4.12),('10318','2013-08-19','17:05:00',3.94),('10318','2013-08-19','17:10:00',3.77),('10318','2013-08-19','17:15:00',3.6),('10318','2013-08-19','17:20:00',3.41),('10318','2013-08-19','17:25:00',3.23),('10318','2013-08-19','17:30:00',3.06),('10318','2013-08-19','17:35:00',2.88),('10318','2013-08-19','17:40:00',2.72),('10318','2013-08-19','17:45:00',2.55),('10318','2013-08-19','17:50:00',2.31),('10318','2013-08-19','17:55:00',2.19),('10318','2013-08-19','18:00:00',2.04),('10318','2013-08-19','18:05:00',1.88),('10318','2013-08-19','18:10:00',1.74),('10318','2013-08-19','18:15:00',1.58),('10318','2013-08-19','18:20:00',1.43),('10318','2013-08-19','18:25:00',1.31),('10318','2013-08-19','18:30:00',1.17),('10318','2013-08-19','18:35:00',1.05),('10318','2013-08-18','07:30:00',1.29),('10318','2013-08-18','07:35:00',1.63),('10318','2013-08-18','07:40:00',2.05),('10318','2013-08-18','07:45:00',2.27),('10318','2013-08-18','07:50:00',2.39),('10318','2013-08-18','07:55:00',2.79),('10318','2013-08-18','08:00:00',3.01),('10318','2013-08-18','08:05:00',3.22),('10318','2013-08-18','08:10:00',3.43),('10318','2013-08-18','08:15:00',3.65),('10318','2013-08-18','08:20:00',3.83),('10318','2013-08-18','08:25:00',4.01),('10318','2013-08-18','08:30:00',4.2),('10318','2013-08-18','08:35:00',4.4),('10318','2013-08-18','08:40:00',4.57),('10318','2013-08-18','08:45:00',4.72),('10318','2013-08-18','08:50:00',4.88),('10318','2013-08-18','08:55:00',5.05),('10318','2013-08-18','09:00:00',5.22),('10318','2013-08-18','09:05:00',5.4),('10318','2013-08-18','09:10:00',5.59),('10318','2013-08-18','09:15:00',5.68),('10318','2013-08-18','09:20:00',5.93),('10318','2013-08-18','09:25:00',6.09),('10318','2013-08-18','09:30:00',6.21),('10318','2013-08-18','09:35:00',6.38),('10318','2013-08-18','09:40:00',6.39),('10318','2013-08-18','09:45:00',5.03),('10318','2013-08-18','09:50:00',6.48),('10318','2013-08-18','09:55:00',6.86),('10318','2013-08-18','10:00:00',5.65),('10318','2013-08-18','10:05:00',6.78),('10318','2013-08-18','10:10:00',7.23),('10318','2013-08-18','10:15:00',7.31),('10318','2013-08-18','10:20:00',7.39),('10318','2013-08-18','10:25:00',7.46),('10318','2013-08-18','10:30:00',7.48),('10318','2013-08-18','10:35:00',7.52),('10318','2013-08-18','10:40:00',7.56),('10318','2013-08-18','10:45:00',7.57),('10318','2013-08-18','10:50:00',7.61),('10318','2013-08-18','10:55:00',7.77),('10318','2013-08-18','11:00:00',7.75),('10318','2013-08-18','11:05:00',7.91),('10318','2013-08-18','11:10:00',7.96),('10318','2013-08-18','11:15:00',8.08),('10318','2013-08-18','11:20:00',8.17),('10318','2013-08-18','11:25:00',8.19),('10318','2013-08-18','11:30:00',8.09),('10318','2013-08-18','11:35:00',8.11),('10318','2013-08-18','11:40:00',8.3),('10318','2013-08-18','11:45:00',8.21),('10318','2013-08-18','11:50:00',7.91),('10318','2013-08-18','11:55:00',8.19),('10318','2013-08-18','12:00:00',8.58),('10318','2013-08-18','12:05:00',8.72),('10318','2013-08-18','12:10:00',7.79),('10318','2013-08-18','12:15:00',6.41),('10318','2013-08-18','12:20:00',4.8),('10318','2013-08-18','12:25:00',7.72),('10318','2013-08-18','12:30:00',3.64),('10318','2013-08-18','12:35:00',4.31),('10318','2013-08-18','12:40:00',8.55),('10318','2013-08-18','12:45:00',8.91),('10318','2013-08-18','12:50:00',9.07),('10318','2013-08-18','12:55:00',8.82),('10318','2013-08-18','13:00:00',8.68),('10318','2013-08-18','13:05:00',8.62),('10318','2013-08-18','13:10:00',8.3),('10318','2013-08-18','13:15:00',8.27),('10318','2013-08-18','13:20:00',8.54),('10318','2013-08-18','13:25:00',8.52),('10318','2013-08-18','13:30:00',8.61),('10318','2013-08-18','13:35:00',8.44),('10318','2013-08-18','13:40:00',8.46),('10318','2013-08-18','13:45:00',8.41),('10318','2013-08-18','13:50:00',8.42),('10318','2013-08-18','13:55:00',8.39),('10318','2013-08-18','14:00:00',8.31),('10318','2013-08-18','14:05:00',8.26),('10318','2013-08-18','14:10:00',8.18),('10318','2013-08-18','14:15:00',8.15),('10318','2013-08-18','14:20:00',8.09),('10318','2013-08-18','14:25:00',8.03),('10318','2013-08-18','14:30:00',7.93),('10318','2013-08-18','14:35:00',7.89),('10318','2013-08-18','14:40:00',7.83),('10318','2013-08-18','14:45:00',7.74),('10318','2013-08-18','14:50:00',7.66),('10318','2013-08-18','14:55:00',7.48),('10318','2013-08-18','15:00:00',7.39),('10318','2013-08-18','15:05:00',7.3),('10318','2013-08-18','15:10:00',7.22),('10318','2013-08-18','15:15:00',7.17),('10318','2013-08-18','15:20:00',7.1),('10318','2013-08-18','15:25:00',6.96),('10318','2013-08-18','15:30:00',6.85),('10318','2013-08-18','15:35:00',6.74),('10318','2013-08-18','15:40:00',6.59),('10318','2013-08-18','15:45:00',6.38),('10318','2013-08-18','15:50:00',6.3),('10318','2013-08-18','15:55:00',6.16),('10318','2013-08-18','16:00:00',6.06),('10318','2013-08-18','16:05:00',5.93),('10318','2013-08-18','16:10:00',5.76),('10318','2013-08-18','16:15:00',5.6),('10318','2013-08-18','16:20:00',5.33),('10318','2013-08-18','16:25:00',5.27),('10318','2013-08-18','16:30:00',5.12),('10318','2013-08-18','16:35:00',4.95),('10318','2013-08-18','16:40:00',4.79),('10318','2013-08-18','16:45:00',4.64),('10318','2013-08-18','16:50:00',4.48),('10318','2013-08-18','16:55:00',4.3),('10318','2013-08-18','17:00:00',4.12),('10318','2013-08-18','17:05:00',3.94),('10318','2013-08-18','17:10:00',3.77),('10318','2013-08-18','17:15:00',3.6),('10318','2013-08-18','17:20:00',3.42),('10318','2013-08-18','17:25:00',3.25),('10318','2013-08-18','17:30:00',3.07),('10318','2013-08-18','17:35:00',2.86),('10318','2013-08-18','17:40:00',2.72),('10318','2013-08-18','17:45:00',2.56),('10318','2013-08-18','17:50:00',2.39),('10318','2013-08-18','17:55:00',2.22),('10318','2013-08-18','18:00:00',2.06),('10318','2013-08-18','18:05:00',1.9),('10318','2013-08-18','18:10:00',1.76),('10318','2013-08-18','18:15:00',1.62),('10318','2013-08-18','18:20:00',1.48),('10318','2013-08-18','18:25:00',1.35),('10318','2013-08-18','18:30:00',1.21),('10318','2013-08-18','18:35:00',1.08),('10318','2013-08-17','07:30:00',1.41),('10318','2013-08-17','07:35:00',1.64),('10318','2013-08-17','07:40:00',2),('10318','2013-08-17','07:45:00',2.07),('10318','2013-08-17','07:50:00',2.48),('10318','2013-08-17','07:55:00',2.74),('10318','2013-08-17','08:00:00',2.95),('10318','2013-08-17','08:05:00',3.13),('10318','2013-08-17','08:10:00',3.33),('10318','2013-08-17','08:15:00',3.5),('10318','2013-08-17','08:20:00',3.7),('10318','2013-08-17','08:25:00',3.9),('10318','2013-08-17','08:30:00',4.12),('10318','2013-08-17','08:35:00',4.33),('10318','2013-08-17','08:40:00',4.53),('10318','2013-08-17','08:45:00',4.71),('10318','2013-08-17','08:50:00',4.9),('10318','2013-08-17','08:55:00',5.11),('10318','2013-08-17','09:00:00',5.14),('10318','2013-08-17','09:05:00',5.43),('10318','2013-08-17','09:10:00',5.58),('10318','2013-08-17','09:15:00',5.77),('10318','2013-08-17','09:20:00',5.92),('10318','2013-08-17','09:25:00',6.07),('10318','2013-08-17','09:30:00',6.18),('10318','2013-08-17','09:35:00',6.34),('10318','2013-08-17','09:40:00',6.46),('10318','2013-08-17','09:45:00',6.61),('10318','2013-08-17','09:50:00',6.72),('10318','2013-08-17','09:55:00',6.84),('10318','2013-08-17','10:00:00',6.96),('10318','2013-08-17','10:05:00',7.1),('10318','2013-08-17','10:10:00',7.2),('10318','2013-08-17','10:15:00',7.31),('10318','2013-08-17','10:20:00',7.41),('10318','2013-08-17','10:25:00',7.51),('10318','2013-08-17','10:30:00',7.58),('10318','2013-08-17','10:35:00',7.67),('10318','2013-08-17','10:40:00',7.76),('10318','2013-08-17','10:45:00',7.6),('10318','2013-08-17','10:50:00',7.88),('10318','2013-08-17','10:55:00',7.97),('10318','2013-08-17','11:00:00',8.03),('10318','2013-08-17','11:05:00',8.08),('10318','2013-08-17','11:10:00',8.11),('10318','2013-08-17','11:15:00',8.15),('10318','2013-08-17','11:20:00',8.17),('10318','2013-08-17','11:25:00',8.32),('10318','2013-08-17','11:30:00',8.4),('10318','2013-08-17','11:35:00',8.35),('10318','2013-08-17','11:40:00',8.43),('10318','2013-08-17','11:45:00',8.5),('10318','2013-08-17','11:50:00',8.55),('10318','2013-08-17','11:55:00',8.54),('10318','2013-08-17','12:00:00',8.32),('10318','2013-08-17','12:05:00',8.31),('10318','2013-08-17','12:10:00',8.62),('10318','2013-08-17','12:15:00',8.43),('10318','2013-08-17','12:20:00',8.48),('10318','2013-08-17','12:25:00',8.31),('10318','2013-08-17','12:30:00',8.53),('10318','2013-08-17','12:35:00',8.64),('10318','2013-08-17','12:40:00',8.58),('10318','2013-08-17','12:45:00',7.52),('10318','2013-08-17','12:50:00',5.73),('10318','2013-08-17','12:55:00',8.63),('10318','2013-08-17','13:00:00',8.73),('10318','2013-08-17','13:05:00',8.79),('10318','2013-08-17','13:10:00',8.65),('10318','2013-08-17','13:15:00',8.51),('10318','2013-08-17','13:20:00',8.62),('10318','2013-08-17','13:25:00',8.61),('10318','2013-08-17','13:30:00',8.82),('10318','2013-08-17','13:35:00',8.83),('10318','2013-08-17','13:40:00',8.53),('10318','2013-08-17','13:45:00',8.57),('10318','2013-08-17','13:50:00',8.75),('10318','2013-08-17','13:55:00',8.52),('10318','2013-08-17','14:00:00',6.47),('10318','2013-08-17','14:05:00',8.47),('10318','2013-08-17','14:10:00',8.4),('10318','2013-08-17','14:15:00',8.09),('10318','2013-08-17','14:20:00',8.1),('10318','2013-08-17','14:25:00',8.09),('10318','2013-08-17','14:30:00',7.92),('10318','2013-08-17','14:35:00',7.83),('10318','2013-08-17','14:40:00',7.84),('10318','2013-08-17','14:45:00',7.62),('10318','2013-08-17','14:50:00',7.58),('10318','2013-08-17','14:55:00',7.56),('10318','2013-08-17','15:00:00',7.46),('10318','2013-08-17','15:05:00',7.39),('10318','2013-08-17','15:10:00',7.24),('10318','2013-08-17','15:15:00',7.07),('10318','2013-08-17','15:20:00',7.06),('10318','2013-08-17','15:25:00',6.93),('10318','2013-08-17','15:30:00',6.83),('10318','2013-08-17','15:35:00',6.68),('10318','2013-08-17','15:40:00',6.55),('10318','2013-08-17','15:45:00',6.43),('10318','2013-08-17','15:50:00',6.3),('10318','2013-08-17','15:55:00',6.19),('10318','2013-08-17','16:00:00',6.11),('10318','2013-08-17','16:05:00',5.95),('10318','2013-08-17','16:10:00',5.83),('10318','2013-08-17','16:15:00',5.68),('10318','2013-08-17','16:20:00',5.52),('10318','2013-08-17','16:25:00',5.36),('10318','2013-08-17','16:30:00',5.21),('10318','2013-08-17','16:35:00',5.08),('10318','2013-08-17','16:40:00',4.91),('10318','2013-08-17','16:45:00',4.67),('10318','2013-08-17','16:50:00',4.51),('10318','2013-08-17','16:55:00',4.42),('10318','2013-08-17','17:00:00',4.26),('10318','2013-08-17','17:05:00',4.09),('10318','2013-08-17','17:10:00',3.68),('10318','2013-08-17','17:15:00',3.52),('10318','2013-08-17','17:20:00',3.46),('10318','2013-08-17','17:25:00',3.45),('10318','2013-08-17','17:30:00',3.3),('10318','2013-08-17','17:35:00',3.11),('10318','2013-08-17','17:40:00',2.93),('10318','2013-08-17','17:45:00',2.74),('10318','2013-08-17','17:50:00',2.55),('10318','2013-08-17','17:55:00',2.39),('10318','2013-08-17','18:00:00',2.22),('10318','2013-08-17','18:05:00',2.05),('10318','2013-08-17','18:10:00',1.9),('10318','2013-08-17','18:15:00',1.73),('10318','2013-08-17','18:20:00',1.59),('10318','2013-08-17','18:25:00',1.43),('10318','2013-08-17','18:30:00',1.28),('10318','2013-08-17','18:35:00',1.14),('10318','2013-08-17','18:40:00',1.01),('10318','2013-08-16','07:30:00',1.47),('10318','2013-08-16','07:35:00',1.76),('10318','2013-08-16','07:40:00',2.05),('10318','2013-08-16','07:45:00',2.28),('10318','2013-08-16','07:50:00',2.55),('10318','2013-08-16','07:55:00',2.79),('10318','2013-08-16','08:00:00',3),('10318','2013-08-16','08:05:00',3.21),('10318','2013-08-16','08:10:00',3.4),('10318','2013-08-16','08:15:00',3.59),('10318','2013-08-16','08:20:00',3.79),('10318','2013-08-16','08:25:00',4.02),('10318','2013-08-16','08:30:00',4.21),('10318','2013-08-16','08:35:00',4.44),('10318','2013-08-16','08:40:00',4.63),('10318','2013-08-16','08:45:00',4.81),('10318','2013-08-16','08:50:00',4.99),('10318','2013-08-16','08:55:00',5.11),('10318','2013-08-16','09:00:00',5.38),('10318','2013-08-16','09:05:00',5.56),('10318','2013-08-16','09:10:00',5.74),('10318','2013-08-16','09:15:00',5.94),('10318','2013-08-16','09:20:00',6.1),('10318','2013-08-16','09:25:00',6.25),('10318','2013-08-16','09:30:00',6.42),('10318','2013-08-16','09:35:00',6.57),('10318','2013-08-16','09:40:00',6.73),('10318','2013-08-16','09:45:00',6.87),('10318','2013-08-16','09:50:00',7),('10318','2013-08-16','09:55:00',7.13),('10318','2013-08-16','10:00:00',7.23),('10318','2013-08-16','10:05:00',7.36),('10318','2013-08-16','10:10:00',7.49),('10318','2013-08-16','10:15:00',7.59),('10318','2013-08-16','10:20:00',7.7),('10318','2013-08-16','10:25:00',7.78),('10318','2013-08-16','10:30:00',7.87),('10318','2013-08-16','10:35:00',7.98),('10318','2013-08-16','10:40:00',8.05),('10318','2013-08-16','10:45:00',8.07),('10318','2013-08-16','10:50:00',8.2),('10318','2013-08-16','10:55:00',8.29),('10318','2013-08-16','11:00:00',8.36),('10318','2013-08-16','11:05:00',8.41),('10318','2013-08-16','11:10:00',8.46),('10318','2013-08-16','11:15:00',8.5),('10318','2013-08-16','11:20:00',8.56),('10318','2013-08-16','11:25:00',8.6),('10318','2013-08-16','11:30:00',8.64),('10318','2013-08-16','11:35:00',8.7),('10318','2013-08-16','11:40:00',8.71),('10318','2013-08-16','11:45:00',8.72),('10318','2013-08-16','11:50:00',8.76),('10318','2013-08-16','11:55:00',8.82),('10318','2013-08-16','12:00:00',8.85),('10318','2013-08-16','12:05:00',8.87),('10318','2013-08-16','12:10:00',8.83),('10318','2013-08-16','12:15:00',8.86),('10318','2013-08-16','12:20:00',8.84),('10318','2013-08-16','12:25:00',8.83),('10318','2013-08-16','12:30:00',8.51),('10318','2013-08-16','12:35:00',8.81),('10318','2013-08-16','12:40:00',8.83),('10318','2013-08-16','12:45:00',8.81),('10318','2013-08-16','12:50:00',8.75),('10318','2013-08-16','12:55:00',8.75),('10318','2013-08-16','13:00:00',8.73),('10318','2013-08-16','13:05:00',8.74),('10318','2013-08-16','13:10:00',8.71),('10318','2013-08-16','13:15:00',8.61),('10318','2013-08-16','13:20:00',8.6),('10318','2013-08-16','13:25:00',8.56),('10318','2013-08-16','13:30:00',8.5),('10318','2013-08-16','13:35:00',8.47),('10318','2013-08-16','13:40:00',8.41),('10318','2013-08-16','13:45:00',8.4),('10318','2013-08-16','13:50:00',8.37),('10318','2013-08-16','13:55:00',8.32),('10318','2013-08-16','14:00:00',8.27),('10318','2013-08-16','14:05:00',8.22),('10318','2013-08-16','14:10:00',8.15),('10318','2013-08-16','14:15:00',8.01),('10318','2013-08-16','14:20:00',7.98),('10318','2013-08-16','14:25:00',7.93),('10318','2013-08-16','14:30:00',7.83),('10318','2013-08-16','14:35:00',7.72),('10318','2013-08-16','14:40:00',7.58),('10318','2013-08-16','14:45:00',7.47),('10318','2013-08-16','14:50:00',7.36),('10318','2013-08-16','14:55:00',7.26),('10318','2013-08-16','15:00:00',7.31),('10318','2013-08-16','15:05:00',7.27),('10318','2013-08-16','15:10:00',7.16),('10318','2013-08-16','15:15:00',7.07),('10318','2013-08-16','15:20:00',7.02),('10318','2013-08-16','15:25:00',6.97),('10318','2013-08-16','15:30:00',6.78),('10318','2013-08-16','15:35:00',6.71),('10318','2013-08-16','15:40:00',6.6),('10318','2013-08-16','15:45:00',6.46),('10318','2013-08-16','15:50:00',6.35),('10318','2013-08-16','15:55:00',6.2),('10318','2013-08-16','16:00:00',6.02),('10318','2013-08-16','16:05:00',5.91),('10318','2013-08-16','16:10:00',5.74),('10318','2013-08-16','16:15:00',5.58),('10318','2013-08-16','16:20:00',5.44),('10318','2013-08-16','16:25:00',5.29),('10318','2013-08-16','16:30:00',5.13),('10318','2013-08-16','16:35:00',4.99),('10318','2013-08-16','16:40:00',4.83),('10318','2013-08-16','16:45:00',4.66),('10318','2013-08-16','16:50:00',4.49),('10318','2013-08-16','16:55:00',4.32),('10318','2013-08-16','17:00:00',4.14),('10318','2013-08-16','17:05:00',3.96),('10318','2013-08-16','17:10:00',3.79),('10318','2013-08-16','17:15:00',3.54),('10318','2013-08-16','17:20:00',3.42),('10318','2013-08-16','17:25:00',3.26),('10318','2013-08-16','17:30:00',3.08),('10318','2013-08-16','17:35:00',2.91),('10318','2013-08-16','17:40:00',2.74),('10318','2013-08-16','17:45:00',2.55),('10318','2013-08-16','17:50:00',2.4),('10318','2013-08-16','17:55:00',2.24),('10318','2013-08-16','18:00:00',2.08),('10318','2013-08-16','18:05:00',1.92),('10318','2013-08-16','18:10:00',1.78),('10318','2013-08-16','18:15:00',1.64),('10318','2013-08-16','18:20:00',1.51),('10318','2013-08-16','18:25:00',1.36),('10318','2013-08-16','18:30:00',1.05),('10318','2013-08-15','07:45:00',1.05),('10318','2013-08-15','07:50:00',1.41),('10318','2013-08-15','07:55:00',1.57),('10318','2013-08-15','08:00:00',1.39),('10318','2013-08-15','08:05:00',1.66),('10318','2013-08-15','08:10:00',3.84),('10318','2013-08-15','08:15:00',3.75),('10318','2013-08-15','08:20:00',4.11),('10318','2013-08-15','08:25:00',4.28),('10318','2013-08-15','08:30:00',4.4),('10318','2013-08-15','08:35:00',4.56),('10318','2013-08-15','08:40:00',4.7),('10318','2013-08-15','08:45:00',4.86),('10318','2013-08-15','08:50:00',5.11),('10318','2013-08-15','08:55:00',4.83),('10318','2013-08-15','09:00:00',1.97),('10318','2013-08-15','09:05:00',3.98),('10318','2013-08-15','09:10:00',2.26),('10318','2013-08-15','09:15:00',2.87),('10318','2013-08-15','09:20:00',4.99),('10318','2013-08-15','09:25:00',6.46),('10318','2013-08-15','09:30:00',6.46),('10318','2013-08-15','09:35:00',6.57),('10318','2013-08-15','09:40:00',6.7),('10318','2013-08-15','09:45:00',6.82),('10318','2013-08-15','09:50:00',6.96),('10318','2013-08-15','09:55:00',7.11),('10318','2013-08-15','10:00:00',7.12),('10318','2013-08-15','10:05:00',7.33),('10318','2013-08-15','10:10:00',7.46),('10318','2013-08-15','10:15:00',7.54),('10318','2013-08-15','10:20:00',7.66),('10318','2013-08-15','10:25:00',7.77),('10318','2013-08-15','10:30:00',7.87),('10318','2013-08-15','10:35:00',8.03),('10318','2013-08-15','10:40:00',8.15),('10318','2013-08-15','10:45:00',8.28),('10318','2013-08-15','10:50:00',8.41),('10318','2013-08-15','10:55:00',8.54),('10318','2013-08-15','11:00:00',8.6),('10318','2013-08-15','11:05:00',8.41),('10318','2013-08-15','11:10:00',7.52),('10318','2013-08-15','11:15:00',6.66),('10318','2013-08-15','11:20:00',6.24),('10318','2013-08-15','11:25:00',5.44),('10318','2013-08-15','11:30:00',5.58),('10318','2013-08-15','11:35:00',7.18),('10318','2013-08-15','11:40:00',8.34),('10318','2013-08-15','11:45:00',8.7),('10318','2013-08-15','11:50:00',9.26),('10318','2013-08-15','11:55:00',9.24),('10318','2013-08-15','12:00:00',9.36),('10318','2013-08-15','12:05:00',9.1),('10318','2013-08-15','12:10:00',8.93),('10318','2013-08-15','12:15:00',8.95),('10318','2013-08-15','12:20:00',9.22),('10318','2013-08-15','12:25:00',9.18),('10318','2013-08-15','12:30:00',9.09),('10318','2013-08-15','12:35:00',9.13),('10318','2013-08-15','12:40:00',9.08),('10318','2013-08-15','12:45:00',8.99),('10318','2013-08-15','12:50:00',8.93),('10318','2013-08-15','12:55:00',9.01),('10318','2013-08-15','13:00:00',8.99),('10318','2013-08-15','13:05:00',8.84),('10318','2013-08-15','13:10:00',8.75),('10318','2013-08-15','13:15:00',8.76),('10318','2013-08-15','13:20:00',8.78),('10318','2013-08-15','13:25:00',8.8),('10318','2013-08-15','13:30:00',8.86),('10318','2013-08-15','13:35:00',8.78),('10318','2013-08-15','13:40:00',8.74),('10318','2013-08-15','13:45:00',8.68),('10318','2013-08-15','13:50:00',8.62),('10318','2013-08-15','13:55:00',8.54),('10318','2013-08-15','14:00:00',8.5),('10318','2013-08-15','14:05:00',8.44),('10318','2013-08-15','14:10:00',8.41),('10318','2013-08-15','14:15:00',8.33),('10318','2013-08-15','14:20:00',8.19),('10318','2013-08-15','14:25:00',8.06),('10318','2013-08-15','14:30:00',7.94),('10318','2013-08-15','14:35:00',7.91),('10318','2013-08-15','14:40:00',7.74),('10318','2013-08-15','14:45:00',7.65),('10318','2013-08-15','14:50:00',5.59),('10318','2013-08-15','14:55:00',7.45),('10318','2013-08-15','15:00:00',7.37),('10318','2013-08-15','15:05:00',7.27),('10318','2013-08-15','15:10:00',7.2),('10318','2013-08-15','15:15:00',7.07),('10318','2013-08-15','15:20:00',6.93),('10318','2013-08-15','15:25:00',6.85),('10318','2013-08-15','15:30:00',6.77),('10318','2013-08-15','15:35:00',6.65),('10318','2013-08-15','15:40:00',6.51),('10318','2013-08-15','15:45:00',6.33),('10318','2013-08-15','15:50:00',6.22),('10318','2013-08-15','15:55:00',6.06),('10318','2013-08-15','16:00:00',5.94),('10318','2013-08-15','16:05:00',5.69),('10318','2013-08-15','16:10:00',5.58),('10318','2013-08-15','16:15:00',5.44),('10318','2013-08-15','16:20:00',5.21),('10318','2013-08-15','16:25:00',5.21),('10318','2013-08-15','16:30:00',5.07),('10318','2013-08-15','16:35:00',4.93),('10318','2013-08-15','16:40:00',4.76),('10318','2013-08-15','16:45:00',4.59),('10318','2013-08-15','16:50:00',4.43),('10318','2013-08-15','16:55:00',4.27),('10318','2013-08-15','17:00:00',4.07),('10318','2013-08-15','17:05:00',3.81),('10318','2013-08-15','17:10:00',3.74),('10318','2013-08-15','17:15:00',3.63),('10318','2013-08-15','17:20:00',3.43),('10318','2013-08-15','17:25:00',3.21),('10318','2013-08-15','17:30:00',2.95),('10318','2013-08-15','17:35:00',2.89),('10318','2013-08-15','17:40:00',2.74),('10318','2013-08-15','17:45:00',2.59),('10318','2013-08-15','17:50:00',2.37),('10318','2013-08-15','17:55:00',2.26),('10318','2013-08-15','18:00:00',2.1),('10318','2013-08-15','18:05:00',1.98),('10318','2013-08-15','18:10:00',1.85),('10318','2013-08-15','18:15:00',1.72),('10318','2013-08-15','18:20:00',1.57),('10318','2013-08-15','18:25:00',1.45),('10318','2013-08-15','18:30:00',1.32),('10318','2013-08-15','18:35:00',1.2),('10318','2013-08-15','18:40:00',1.07),('10318','2013-08-14','07:25:00',1.04),('10318','2013-08-14','07:30:00',1.54),('10318','2013-08-14','07:35:00',1.8),('10318','2013-08-14','07:40:00',2.06),('10318','2013-08-14','07:45:00',2.24),('10318','2013-08-14','07:50:00',2.57),('10318','2013-08-14','07:55:00',2.79),('10318','2013-08-14','08:00:00',2.99),('10318','2013-08-14','08:05:00',3.17),('10318','2013-08-14','08:10:00',3.32),('10318','2013-08-14','08:15:00',3.55),('10318','2013-08-14','08:20:00',3.66),('10318','2013-08-14','08:25:00',3.53),('10318','2013-08-14','08:30:00',4.1),('10318','2013-08-14','08:35:00',4.26),('10318','2013-08-14','08:40:00',4.27),('10318','2013-08-14','08:45:00',4.63),('10318','2013-08-14','08:50:00',4.77),('10318','2013-08-14','08:55:00',4.94),('10318','2013-08-14','09:00:00',5.15),('10318','2013-08-14','09:05:00',5.39),('10318','2013-08-14','09:10:00',5.48),('10318','2013-08-14','09:15:00',5.7),('10318','2013-08-14','09:20:00',5.89),('10318','2013-08-14','09:25:00',5.81),('10318','2013-08-14','09:30:00',6.57),('10318','2013-08-14','09:35:00',4.21),('10318','2013-08-14','09:40:00',3.34),('10318','2013-08-14','09:45:00',2.06),('10318','2013-08-14','09:50:00',2.9),('10318','2013-08-14','09:55:00',7.42),('10318','2013-08-14','10:00:00',7.25),('10318','2013-08-14','10:05:00',6.65),('10318','2013-08-14','10:10:00',7.33),('10318','2013-08-14','10:15:00',2.7),('10318','2013-08-14','10:20:00',4.03),('10318','2013-08-14','10:25:00',6.42),('10318','2013-08-14','10:30:00',6.43),('10318','2013-08-14','10:35:00',5.78),('10318','2013-08-14','10:40:00',7.8),('10318','2013-08-14','10:45:00',8.08),('10318','2013-08-14','10:50:00',8.41),('10318','2013-08-14','10:55:00',8.15),('10318','2013-08-14','11:00:00',8.19),('10318','2013-08-14','11:05:00',8.38),('10318','2013-08-14','11:10:00',7.08),('10318','2013-08-14','11:15:00',8.04),('10318','2013-08-14','11:20:00',6.26),('10318','2013-08-14','11:25:00',3.28),('10318','2013-08-14','11:30:00',4.21),('10318','2013-08-14','11:35:00',9.39),('10318','2013-08-14','11:40:00',7),('10318','2013-08-14','11:45:00',2.96),('10318','2013-08-14','11:50:00',2.72),('10318','2013-08-14','11:55:00',2.78),('10318','2013-08-14','12:00:00',8.35),('10318','2013-08-14','12:05:00',7.02),('10318','2013-08-14','12:10:00',3.4),('10318','2013-08-14','12:15:00',3.88),('10318','2013-08-14','12:20:00',4.36),('10318','2013-08-14','12:25:00',4.1),('10318','2013-08-14','12:30:00',6.57),('10318','2013-08-14','12:35:00',9.14),('10318','2013-08-14','12:40:00',5.84),('10318','2013-08-14','12:45:00',2.75),('10318','2013-08-14','12:50:00',2.79),('10318','2013-08-14','12:55:00',3.25),('10318','2013-08-14','13:00:00',3.45),('10318','2013-08-14','13:05:00',3.31),('10318','2013-08-14','13:10:00',5.01),('10318','2013-08-14','13:15:00',7.86),('10318','2013-08-14','13:20:00',8.72),('10318','2013-08-14','13:25:00',9.35),('10318','2013-08-14','13:30:00',9.22),('10318','2013-08-14','13:35:00',8.42),('10318','2013-08-14','13:40:00',9.48),('10318','2013-08-14','13:45:00',9.53),('10318','2013-08-14','13:50:00',9.55),('10318','2013-08-14','13:55:00',8.21),('10318','2013-08-14','14:00:00',9.02),('10318','2013-08-14','14:05:00',8.96),('10318','2013-08-14','14:10:00',8.94),('10318','2013-08-14','14:15:00',8.92),('10318','2013-08-14','14:20:00',8.91),('10318','2013-08-14','14:25:00',8.5),('10318','2013-08-14','14:30:00',8.4),('10318','2013-08-14','14:35:00',7.72),('10318','2013-08-14','14:40:00',8.11),('10318','2013-08-14','14:45:00',8.01),('10318','2013-08-14','14:50:00',7.85),('10318','2013-08-14','14:55:00',7.83),('10318','2013-08-14','15:00:00',7.55),('10318','2013-08-14','15:05:00',7.42),('10318','2013-08-14','15:10:00',7.31),('10318','2013-08-14','15:15:00',7.26),('10318','2013-08-14','15:20:00',7.17),('10318','2013-08-14','15:25:00',7.07),('10318','2013-08-14','15:30:00',6.93),('10318','2013-08-14','15:35:00',6.77),('10318','2013-08-14','15:40:00',6.67),('10318','2013-08-14','15:45:00',6.33),('10318','2013-08-14','15:50:00',6.38),('10318','2013-08-14','15:55:00',6.3),('10318','2013-08-14','16:00:00',6.16),('10318','2013-08-14','16:05:00',6.02),('10318','2013-08-14','16:10:00',5.92),('10318','2013-08-14','16:15:00',5.71),('10318','2013-08-14','16:20:00',5.64),('10318','2013-08-14','16:25:00',5.46),('10318','2013-08-14','16:30:00',5.31),('10318','2013-08-14','16:35:00',5.11),('10318','2013-08-14','16:40:00',4.96),('10318','2013-08-14','16:45:00',4.82),('10318','2013-08-14','16:50:00',4.62),('10318','2013-08-14','16:55:00',4.42),('10318','2013-08-14','17:00:00',4.24),('10318','2013-08-14','17:05:00',4.08),('10318','2013-08-14','17:10:00',3.88),('10318','2013-08-14','17:15:00',3.7),('10318','2013-08-14','17:20:00',3.56),('10318','2013-08-14','17:25:00',3.38),('10318','2013-08-14','17:30:00',3.17),('10318','2013-08-14','17:35:00',3.04),('10318','2013-08-14','17:40:00',2.88),('10318','2013-08-14','17:45:00',2.71),('10318','2013-08-14','17:50:00',2.52),('10318','2013-08-14','17:55:00',2.37),('10318','2013-08-14','18:00:00',2.18),('10318','2013-08-14','18:05:00',2.08),('10318','2013-08-14','18:10:00',1.93),('10318','2013-08-14','18:15:00',1.81),('10318','2013-08-14','18:20:00',1.73),('10318','2013-08-14','18:25:00',1.73),('10318','2013-08-14','18:30:00',1.61),('10318','2013-08-14','18:35:00',1.37),('10318','2013-08-14','18:40:00',1.17),('10318','2013-08-14','18:45:00',1.11),('10318','2013-08-14','18:50:00',1.16),('10318','2013-08-14','18:55:00',1.14),('10318','2013-08-14','19:00:00',1.19),('10318','2013-08-14','19:05:00',1.06),('10318','2013-08-13','07:25:00',1.24),('10318','2013-08-13','07:30:00',1.53),('10318','2013-08-13','07:35:00',1.89),('10318','2013-08-13','07:40:00',2.12),('10318','2013-08-13','07:45:00',2.32),('10318','2013-08-13','07:50:00',2.54),('10318','2013-08-13','07:55:00',2.74),('10318','2013-08-13','08:00:00',3.01),('10318','2013-08-13','08:05:00',3.26),('10318','2013-08-13','08:10:00',3.37),('10318','2013-08-13','08:15:00',3.53),('10318','2013-08-13','08:20:00',3.79),('10318','2013-08-13','08:25:00',3.99),('10318','2013-08-13','08:30:00',4.16),('10318','2013-08-13','08:35:00',4.38),('10318','2013-08-13','08:40:00',4.53),('10318','2013-08-13','08:45:00',4.75),('10318','2013-08-13','08:50:00',4.94),('10318','2013-08-13','08:55:00',5.08),('10318','2013-08-13','09:00:00',5.32),('10318','2013-08-13','09:05:00',5.45),('10318','2013-08-13','09:10:00',5.65),('10318','2013-08-13','09:15:00',5.86),('10318','2013-08-13','09:20:00',5.95),('10318','2013-08-13','09:25:00',6.01),('10318','2013-08-13','09:30:00',6.14),('10318','2013-08-13','09:35:00',6.27),('10318','2013-08-13','09:40:00',6.55),('10318','2013-08-13','09:45:00',6.63),('10318','2013-08-13','09:50:00',6.79),('10318','2013-08-13','09:55:00',6.88),('10318','2013-08-13','10:00:00',3.79),('10318','2013-08-13','10:05:00',7.33),('10318','2013-08-13','10:10:00',7.34),('10318','2013-08-13','10:15:00',7.39),('10318','2013-08-13','10:20:00',7.37),('10318','2013-08-13','10:25:00',7.49),('10318','2013-08-13','10:30:00',7.58),('10318','2013-08-13','10:35:00',7.69),('10318','2013-08-13','10:40:00',7.18),('10318','2013-08-13','10:45:00',7.78),('10318','2013-08-13','10:50:00',7.86),('10318','2013-08-13','10:55:00',7.95),('10318','2013-08-13','11:00:00',8.17),('10318','2013-08-13','11:05:00',8.26),('10318','2013-08-13','11:10:00',8.06),('10318','2013-08-13','11:15:00',8.16),('10318','2013-08-13','11:20:00',8.08),('10318','2013-08-13','11:25:00',8.38),('10318','2013-08-13','11:30:00',8.41),('10318','2013-08-13','11:35:00',8.37),('10318','2013-08-13','11:40:00',8.17),('10318','2013-08-13','11:45:00',8.54),('10318','2013-08-13','11:50:00',7.64),('10318','2013-08-13','11:55:00',8.24),('10318','2013-08-13','12:00:00',8.88),('10318','2013-08-13','12:05:00',8.93),('10318','2013-08-13','12:10:00',9.1),('10318','2013-08-13','12:15:00',8.14),('10318','2013-08-13','12:20:00',8.16),('10318','2013-08-13','12:25:00',8.12),('10318','2013-08-13','12:30:00',9.55),('10318','2013-08-13','12:35:00',8.32),('10318','2013-08-13','12:40:00',3.49),('10318','2013-08-13','12:45:00',8.97),('10318','2013-08-13','12:50:00',4.17),('10318','2013-08-13','12:55:00',4.85),('10318','2013-08-13','13:00:00',7.73),('10318','2013-08-13','13:05:00',9.8),('10318','2013-08-13','13:10:00',9.08),('10318','2013-08-13','13:15:00',9.17),('10318','2013-08-13','13:20:00',8.85),('10318','2013-08-13','13:25:00',9.04),('10318','2013-08-13','13:30:00',9.32),('10318','2013-08-13','13:35:00',4.43),('10318','2013-08-13','13:40:00',3.41),('10318','2013-08-13','13:45:00',5.11),('10318','2013-08-13','13:50:00',9.96),('10318','2013-08-13','13:55:00',5.75),('10318','2013-08-13','14:00:00',9.24),('10318','2013-08-13','14:05:00',8.66),('10318','2013-08-13','14:10:00',8.59),('10318','2013-08-13','14:15:00',8.7),('10318','2013-08-13','14:20:00',8.48),('10318','2013-08-13','14:25:00',8.31),('10318','2013-08-13','14:30:00',8.69),('10318','2013-08-13','14:35:00',8.41),('10318','2013-08-13','14:40:00',8.06),('10318','2013-08-13','14:45:00',7.88),('10318','2013-08-13','14:50:00',7.89),('10318','2013-08-13','14:55:00',7.65),('10318','2013-08-13','15:00:00',7.7),('10318','2013-08-13','15:05:00',7.49),('10318','2013-08-13','15:10:00',7.4),('10318','2013-08-13','15:15:00',7.23),('10318','2013-08-13','15:20:00',7.16),('10318','2013-08-13','15:25:00',6.92),('10318','2013-08-13','15:30:00',5.82),('10318','2013-08-13','15:35:00',6.95),('10318','2013-08-13','15:40:00',6.67),('10318','2013-08-13','15:45:00',6.53),('10318','2013-08-13','15:50:00',6.41),('10318','2013-08-13','15:55:00',6.28),('10318','2013-08-13','16:00:00',6.05),('10318','2013-08-13','16:05:00',6.02),('10318','2013-08-13','16:10:00',5.86),('10318','2013-08-13','16:15:00',5.73),('10318','2013-08-13','16:20:00',5.57),('10318','2013-08-13','16:25:00',5.39),('10318','2013-08-13','16:30:00',5.26),('10318','2013-08-13','16:35:00',5.13),('10318','2013-08-13','16:40:00',4.98),('10318','2013-08-13','16:45:00',4.79),('10318','2013-08-13','16:50:00',4.63),('10318','2013-08-13','16:55:00',4.46),('10318','2013-08-13','17:00:00',4.26),('10318','2013-08-13','17:05:00',4.09),('10318','2013-08-13','17:10:00',3.92),('10318','2013-08-13','17:15:00',3.66),('10318','2013-08-12','07:25:00',1.29),('10318','2013-08-12','07:30:00',1.54),('10318','2013-08-12','07:35:00',1.86),('10318','2013-08-12','07:40:00',2.08),('10318','2013-08-12','07:45:00',2.36),('10318','2013-08-12','07:50:00',2.59),('10318','2013-08-12','07:55:00',2.74),('10318','2013-08-12','08:00:00',2.96),('10318','2013-08-12','08:05:00',3.16),('10318','2013-08-12','08:10:00',3.35),('10318','2013-08-12','08:15:00',3.55),('10318','2013-08-12','08:20:00',3.73),('10318','2013-08-12','08:25:00',3.9),('10318','2013-08-12','08:30:00',4.13),('10318','2013-08-12','08:35:00',4.33),('10318','2013-08-12','08:40:00',4.5),('10318','2013-08-12','08:45:00',4.69),('10318','2013-08-12','08:50:00',4.85),('10318','2013-08-12','08:55:00',5.02),('10318','2013-08-12','09:00:00',5.18),('10318','2013-08-12','09:05:00',5.32),('10318','2013-08-12','09:10:00',5.41),('10318','2013-08-12','09:15:00',5.65),('10318','2013-08-12','09:20:00',5.83),('10318','2013-08-12','09:25:00',5.98),('10318','2013-08-12','09:30:00',6.11),('10318','2013-08-12','09:35:00',6.26),('10318','2013-08-12','09:40:00',6.38),('10318','2013-08-12','09:45:00',6.52),('10318','2013-08-12','09:50:00',6.64),('10318','2013-08-12','09:55:00',6.76),('10318','2013-08-12','10:00:00',6.87),('10318','2013-08-12','10:05:00',6.97),('10318','2013-08-12','10:10:00',7.09),('10318','2013-08-12','10:15:00',7.2),('10318','2013-08-12','10:20:00',7.32),('10318','2013-08-12','10:25:00',7.4),('10318','2013-08-12','10:30:00',7.52),('10318','2013-08-12','10:35:00',7.59),('10318','2013-08-12','10:40:00',7.64),('10318','2013-08-12','10:45:00',7.76),('10318','2013-08-12','10:50:00',7.88),('10318','2013-08-12','10:55:00',7.72),('10318','2013-08-12','11:00:00',7.94),('10318','2013-08-12','11:05:00',8.01),('10318','2013-08-12','11:10:00',8.09),('10318','2013-08-12','11:15:00',8.12),('10318','2013-08-12','11:20:00',8.2),('10318','2013-08-12','11:25:00',8.19),('10318','2013-08-12','11:30:00',8.3),('10318','2013-08-12','11:35:00',8.13),('10318','2013-08-12','11:40:00',8.35),('10318','2013-08-12','11:45:00',8.48),('10318','2013-08-12','11:50:00',8.53),('10318','2013-08-12','11:55:00',8.54),('10318','2013-08-12','12:00:00',8.66),('10318','2013-08-12','12:05:00',5.53),('10318','2013-08-12','12:10:00',8.13),('10318','2013-08-12','12:15:00',9.18),('10318','2013-08-12','12:20:00',8.35),('10318','2013-08-12','12:25:00',7.51),('10318','2013-08-12','12:30:00',3.5),('10318','2013-08-12','12:35:00',8.36),('10318','2013-08-12','12:40:00',6.14),('10318','2013-08-12','12:45:00',2.09),('10318','2013-08-12','12:50:00',2.14),('10318','2013-08-12','12:55:00',4.45),('10318','2013-08-12','13:00:00',2.02),('10318','2013-08-12','13:05:00',3.39),('10318','2013-08-12','13:10:00',4.49),('10318','2013-08-12','13:15:00',6.54),('10318','2013-08-12','13:20:00',4.95),('10318','2013-08-12','13:25:00',3.27),('10318','2013-08-12','13:30:00',4.24),('10318','2013-08-12','13:35:00',9.88),('10318','2013-08-12','13:40:00',9.12),('10318','2013-08-12','13:45:00',6.18),('10318','2013-08-12','13:50:00',4.29),('10318','2013-08-12','13:55:00',3.29),('10318','2013-08-12','14:00:00',2.93),('10318','2013-08-12','14:05:00',3.84),('10318','2013-08-12','14:10:00',3),('10318','2013-08-12','14:15:00',2.35),('10318','2013-08-12','14:20:00',2.04),('10318','2013-08-12','14:25:00',2.68),('10318','2013-08-12','14:30:00',3.07),('10318','2013-08-12','14:35:00',3.84),('10318','2013-08-12','14:40:00',5.23),('10318','2013-08-12','14:45:00',9.09),('10318','2013-08-12','14:50:00',4.59),('10318','2013-08-12','14:55:00',5.62),('10318','2013-08-12','15:00:00',7.95),('10318','2013-08-12','15:05:00',8.24),('10318','2013-08-12','15:10:00',7.83),('10318','2013-08-12','15:15:00',7.56),('10318','2013-08-12','15:20:00',7.37),('10318','2013-08-12','15:25:00',7.24),('10318','2013-08-12','15:30:00',6.99),('10318','2013-08-12','15:35:00',2.94),('10318','2013-08-12','15:40:00',5.75),('10318','2013-08-12','15:45:00',6.23),('10318','2013-08-12','15:50:00',6.46),('10318','2013-08-12','15:55:00',6.37),('10318','2013-08-12','16:00:00',6.23),('10318','2013-08-12','16:05:00',5.7),('10318','2013-08-12','16:10:00',5.79),('10318','2013-08-12','16:15:00',5.64),('10318','2013-08-12','16:20:00',5.26),('10318','2013-08-12','16:25:00',5.18),('10318','2013-08-12','16:30:00',5.27),('10318','2013-08-12','16:35:00',5.16),('10318','2013-08-12','16:40:00',4.95),('10318','2013-08-12','16:45:00',4.74),('10318','2013-08-12','16:50:00',4.58),('10318','2013-08-12','16:55:00',4.45),('10318','2013-08-12','17:00:00',4.24),('10318','2013-08-12','17:05:00',4.1),('10318','2013-08-12','17:10:00',3.93),('10318','2013-08-12','17:15:00',3.7),('10318','2013-08-12','17:20:00',3.6),('10318','2013-08-12','17:25:00',3.42),('10318','2013-08-12','17:30:00',3.2),('10318','2013-08-12','17:35:00',3.1),('10318','2013-08-12','17:40:00',2.93),('10318','2013-08-12','17:45:00',2.74),('10318','2013-08-12','17:50:00',2.55),('10318','2013-08-12','17:55:00',2.36),('10318','2013-08-12','18:00:00',2.21),('10318','2013-08-12','18:05:00',2.07),('10318','2013-08-12','18:10:00',1.9),('10318','2013-08-12','18:15:00',1.76),('10318','2013-08-12','18:20:00',1.61),('10318','2013-08-12','18:25:00',1.49),('10318','2013-08-12','18:30:00',1.37),('10318','2013-08-12','18:35:00',1.26),('10318','2013-08-12','18:40:00',1.14),('10318','2013-08-12','18:45:00',1.03),('10318','2013-08-11','07:25:00',1.33),('10318','2013-08-11','07:30:00',1.55),('10318','2013-08-11','07:35:00',1.88),('10318','2013-08-11','07:40:00',2.13),('10318','2013-08-11','07:45:00',2.42),('10318','2013-08-11','07:50:00',2.69),('10318','2013-08-11','07:55:00',2.87),('10318','2013-08-11','08:00:00',3.11),('10318','2013-08-11','08:05:00',3.3),('10318','2013-08-11','08:10:00',3.47),('10318','2013-08-11','08:15:00',3.67),('10318','2013-08-11','08:20:00',3.86),('10318','2013-08-11','08:25:00',4.04),('10318','2013-08-11','08:30:00',4.27),('10318','2013-08-11','08:35:00',4.44),('10318','2013-08-11','08:40:00',4.64),('10318','2013-08-11','08:45:00',4.84),('10318','2013-08-11','08:50:00',5),('10318','2013-08-11','08:55:00',5.18),('10318','2013-08-11','09:00:00',5.37),('10318','2013-08-11','09:05:00',5.52),('10318','2013-08-11','09:10:00',5.67),('10318','2013-08-11','09:15:00',5.86),('10318','2013-08-11','09:20:00',5.97),('10318','2013-08-11','09:25:00',6.13),('10318','2013-08-11','09:30:00',6.28),('10318','2013-08-11','09:35:00',6.38),('10318','2013-08-11','09:40:00',6.51),('10318','2013-08-11','09:45:00',6.67),('10318','2013-08-11','09:50:00',6.79),('10318','2013-08-11','09:55:00',6.94),('10318','2013-08-11','10:00:00',7.05),('10318','2013-08-11','10:05:00',7.19),('10318','2013-08-11','10:10:00',7.27),('10318','2013-08-11','10:15:00',7.4),('10318','2013-08-11','10:20:00',7.47),('10318','2013-08-11','10:25:00',7.53),('10318','2013-08-11','10:30:00',7.63),('10318','2013-08-11','10:35:00',7.76),('10318','2013-08-11','10:40:00',7.83),('10318','2013-08-11','10:45:00',7.94),('10318','2013-08-11','10:50:00',8.03),('10318','2013-08-11','10:55:00',8.01),('10318','2013-08-11','11:00:00',8.18),('10318','2013-08-11','11:05:00',8.24),('10318','2013-08-11','11:10:00',8.34),('10318','2013-08-11','11:15:00',8.41),('10318','2013-08-11','11:20:00',8.45),('10318','2013-08-11','11:25:00',8.45),('10318','2013-08-11','11:30:00',8.51),('10318','2013-08-11','11:35:00',8.58),('10318','2013-08-11','11:40:00',8.6),('10318','2013-08-11','11:45:00',8.64),('10318','2013-08-11','11:50:00',8.67),('10318','2013-08-11','11:55:00',8.67),('10318','2013-08-11','12:00:00',8.7),('10318','2013-08-11','12:05:00',8.72),('10318','2013-08-11','12:10:00',8.73),('10318','2013-08-11','12:15:00',8.72),('10318','2013-08-11','12:20:00',8.77),('10318','2013-08-11','12:25:00',8.8),('10318','2013-08-11','12:30:00',8.78),('10318','2013-08-11','12:35:00',8.73),('10318','2013-08-11','12:40:00',8.53),('10318','2013-08-11','12:45:00',8.69),('10318','2013-08-11','12:50:00',8.73),('10318','2013-08-11','12:55:00',8.7),('10318','2013-08-11','13:00:00',8.67),('10318','2013-08-11','13:05:00',8.66),('10318','2013-08-11','13:10:00',8.64),('10318','2013-08-11','13:15:00',8.69),('10318','2013-08-11','13:20:00',8.65),('10318','2013-08-11','13:25:00',8.63),('10318','2013-08-11','13:30:00',8.54),('10318','2013-08-11','13:35:00',8.55),('10318','2013-08-11','13:40:00',8.51),('10318','2013-08-11','13:45:00',8.48),('10318','2013-08-11','13:50:00',8.46),('10318','2013-08-11','13:55:00',8.37),('10318','2013-08-11','14:00:00',8.35),('10318','2013-08-11','14:05:00',8.24),('10318','2013-08-11','14:10:00',8.11),('10318','2013-08-11','14:15:00',8.1),('10318','2013-08-11','14:20:00',8.08),('10318','2013-08-11','14:25:00',7.67),('10318','2013-08-11','14:30:00',7.88),('10318','2013-08-11','14:35:00',7.77),('10318','2013-08-11','14:40:00',7.66),('10318','2013-08-11','14:45:00',7.58),('10318','2013-08-11','14:50:00',7.5),('10318','2013-08-11','14:55:00',7.49),('10318','2013-08-11','15:00:00',7.42),('10318','2013-08-11','15:05:00',7.27),('10318','2013-08-11','15:10:00',7.15),('10318','2013-08-11','15:15:00',6.95),('10318','2013-08-11','15:20:00',5.11),('10318','2013-08-11','15:25:00',6.9),('10318','2013-08-11','15:30:00',6.84),('10318','2013-08-11','15:35:00',6.6),('10318','2013-08-11','15:40:00',6.57),('10318','2013-08-11','15:45:00',6.52),('10318','2013-08-11','15:50:00',6.39),('10318','2013-08-11','15:55:00',6.25),('10318','2013-08-11','16:00:00',6.11),('10318','2013-08-11','16:05:00',5.97),('10318','2013-08-11','16:10:00',5.62),('10318','2013-08-11','16:15:00',5.66),('10318','2013-08-11','16:20:00',5.49),('10318','2013-08-11','16:25:00',5.33),('10318','2013-08-11','16:30:00',5.16),('10318','2013-08-11','16:35:00',5.04),('10318','2013-08-11','16:40:00',4.89),('10318','2013-08-11','16:45:00',4.74),('10318','2013-08-11','16:50:00',4.57),('10318','2013-08-11','16:55:00',4.4),('10318','2013-08-11','17:00:00',4.24),('10318','2013-08-11','17:05:00',4.07),('10318','2013-08-11','17:10:00',3.9),('10318','2013-08-11','17:15:00',3.73),('10318','2013-08-11','17:20:00',3.55),('10318','2013-08-11','17:25:00',3.37),('10318','2013-08-11','17:30:00',3.2),('10318','2013-08-11','17:35:00',3.03),('10318','2013-08-11','17:40:00',2.86),('10318','2013-08-11','17:45:00',2.7),('10318','2013-08-11','17:50:00',2.53),('10318','2013-08-11','17:55:00',2.32),('10318','2013-08-11','18:00:00',2.2),('10318','2013-08-11','18:05:00',2.05),('10318','2013-08-11','18:10:00',1.9),('10318','2013-08-11','18:15:00',1.76),('10318','2013-08-11','18:20:00',1.61),('10318','2013-08-11','18:25:00',1.48),('10318','2013-08-11','18:30:00',1.34),('10318','2013-08-11','18:35:00',1.24),('10318','2013-08-11','18:40:00',1.1),('10318','2013-08-10','07:25:00',1.2),('10318','2013-08-10','07:30:00',1.6),('10318','2013-08-10','07:35:00',2),('10318','2013-08-10','07:40:00',2.23),('10318','2013-08-10','07:45:00',2.5),('10318','2013-08-10','07:50:00',2.78),('10318','2013-08-10','07:55:00',2.98),('10318','2013-08-10','08:00:00',3.18),('10318','2013-08-10','08:05:00',3.38),('10318','2013-08-10','08:10:00',3.52),('10318','2013-08-10','08:15:00',3.81),('10318','2013-08-10','08:20:00',4.02),('10318','2013-08-10','08:25:00',4.19),('10318','2013-08-10','08:30:00',4.38),('10318','2013-08-10','08:35:00',4.56),('10318','2013-08-10','08:40:00',4.73),('10318','2013-08-10','08:45:00',4.89),('10318','2013-08-10','08:50:00',5.08),('10318','2013-08-10','08:55:00',5.28),('10318','2013-08-10','09:00:00',5.42),('10318','2013-08-10','09:05:00',5.59),('10318','2013-08-10','09:10:00',5.74),('10318','2013-08-10','09:15:00',5.89),('10318','2013-08-10','09:20:00',6.08),('10318','2013-08-10','09:25:00',6.27),('10318','2013-08-10','09:30:00',6.41),('10318','2013-08-10','09:35:00',6.55),('10318','2013-08-10','09:40:00',6.65),('10318','2013-08-10','09:45:00',6.79),('10318','2013-08-10','09:50:00',6.92),('10318','2013-08-10','09:55:00',6.92),('10318','2013-08-10','10:00:00',7.14),('10318','2013-08-10','10:05:00',7.26),('10318','2013-08-10','10:10:00',7.4),('10318','2013-08-10','10:15:00',7.48),('10318','2013-08-10','10:20:00',7.55),('10318','2013-08-10','10:25:00',7.67),('10318','2013-08-10','10:30:00',7.75),('10318','2013-08-10','10:35:00',7.83),('10318','2013-08-10','10:40:00',7.94),('10318','2013-08-10','10:45:00',7.97),('10318','2013-08-10','10:50:00',8.08),('10318','2013-08-10','10:55:00',8.19),('10318','2013-08-10','11:00:00',8.38),('10318','2013-08-10','11:05:00',8.51),('10318','2013-08-10','11:10:00',8.38),('10318','2013-08-10','11:15:00',8.35),('10318','2013-08-10','11:20:00',8.85),('10318','2013-08-10','11:25:00',8.94),('10318','2013-08-10','11:30:00',8.8),('10318','2013-08-10','11:35:00',8.7),('10318','2013-08-10','11:40:00',8.49),('10318','2013-08-10','11:45:00',8.65),('10318','2013-08-10','11:50:00',8.82),('10318','2013-08-10','11:55:00',8.93),('10318','2013-08-10','12:00:00',8.98),('10318','2013-08-10','12:05:00',8.92),('10318','2013-08-10','12:10:00',8.93),('10318','2013-08-10','12:15:00',8.88),('10318','2013-08-10','12:20:00',8.88),('10318','2013-08-10','12:25:00',8.95),('10318','2013-08-10','12:30:00',9.03),('10318','2013-08-10','12:35:00',9.05),('10318','2013-08-10','12:40:00',9.11),('10318','2013-08-10','12:45:00',9.32),('10318','2013-08-10','12:50:00',9.62),('10318','2013-08-10','12:55:00',9.32),('10318','2013-08-10','13:00:00',9.02),('10318','2013-08-10','13:05:00',8.89),('10318','2013-08-10','13:10:00',9.23),('10318','2013-08-10','13:15:00',9.57),('10318','2013-08-10','13:20:00',3.65),('10318','2013-08-10','13:25:00',8.99),('10318','2013-08-10','13:30:00',2.39),('10318','2013-08-10','13:35:00',2.26),('10318','2013-08-10','13:40:00',2.32),('10318','2013-08-10','13:45:00',1.73),('10318','2013-08-10','13:50:00',2.88),('10318','2013-08-10','13:55:00',9.64),('10318','2013-08-10','14:00:00',9.4),('10318','2013-08-10','14:05:00',8.74),('10318','2013-08-10','14:10:00',9.23),('10318','2013-08-10','14:15:00',8.27),('10318','2013-08-10','14:20:00',2.87),('10318','2013-08-10','14:25:00',2.64),('10318','2013-08-10','14:30:00',2.42),('10318','2013-08-10','14:35:00',2.13),('10318','2013-08-10','14:40:00',1.96),('10318','2013-08-10','14:45:00',1.91),('10318','2013-08-10','14:50:00',1.82),('10318','2013-08-10','14:55:00',1.98),('10318','2013-08-10','15:00:00',2.23),('10318','2013-08-10','15:05:00',2.12),('10318','2013-08-10','15:10:00',2.21),('10318','2013-08-10','15:15:00',2.33),('10318','2013-08-10','15:20:00',2.39),('10318','2013-08-10','15:25:00',2.19),('10318','2013-08-10','15:30:00',2.32),('10318','2013-08-10','15:35:00',2.57),('10318','2013-08-10','15:40:00',2.55),('10318','2013-08-10','15:45:00',3.28),('10318','2013-08-10','15:50:00',3.72),('10318','2013-08-10','15:55:00',3.77),('10318','2013-08-10','16:00:00',5.18),('10318','2013-08-10','16:05:00',5.58),('10318','2013-08-10','16:10:00',3.8),('10318','2013-08-10','16:15:00',3.4),('10318','2013-08-10','16:20:00',3.03),('10318','2013-08-10','16:25:00',4.61),('10318','2013-08-10','16:30:00',4.24),('10318','2013-08-10','16:35:00',4.51),('10318','2013-08-10','16:40:00',3.72),('10318','2013-08-10','16:45:00',4),('10318','2013-08-10','16:50:00',5.09),('10318','2013-08-10','16:55:00',3.65),('10318','2013-08-10','17:00:00',1.51),('10318','2013-08-10','17:05:00',2.34),('10318','2013-08-10','17:10:00',3.55),('10318','2013-08-10','17:15:00',2.62),('10318','2013-08-10','17:20:00',2.48),('10318','2013-08-10','17:25:00',2.59),('10318','2013-08-10','17:30:00',2.05),('10318','2013-08-10','17:35:00',1.1),('10318','2013-08-10','18:20:00',1.06),('10318','2013-08-10','18:25:00',1.03),('10318','2014-04-09','07:35:00',1.08),('10318','2014-04-09','07:40:00',1.2),('10318','2014-04-09','07:45:00',1.29),('10318','2014-04-09','07:50:00',1.42),('10318','2014-04-09','07:55:00',1.99),('10318','2014-04-09','08:00:00',2.32),('10318','2014-04-09','08:05:00',2.79),('10318','2014-04-09','08:10:00',2.01),('10318','2014-04-09','08:15:00',3.12),('10318','2014-04-09','08:20:00',2.96),('10318','2014-04-09','08:25:00',2.04),('10318','2014-04-09','08:30:00',1.67),('10318','2014-04-09','08:50:00',1.71),('10318','2014-04-09','08:55:00',2.81),('10318','2014-04-09','09:00:00',2.19),('10318','2014-04-09','09:05:00',2.11),('10318','2014-04-09','09:10:00',1.96),('10318','2014-04-09','09:15:00',1.9),('10318','2014-04-09','09:20:00',2),('10318','2014-04-09','09:25:00',2.24),('10318','2014-04-09','09:30:00',2.08),('10318','2014-04-09','09:35:00',1.7),('10318','2014-04-09','09:40:00',1.76),('10318','2014-04-09','09:45:00',3.04),('10318','2014-04-09','09:50:00',7.6),('10318','2014-04-09','09:55:00',7.35),('10318','2014-04-09','10:00:00',7.29),('10318','2014-04-09','10:05:00',7.39),('10318','2014-04-09','10:10:00',6.43),('10318','2014-04-09','10:15:00',6.52),('10318','2014-04-09','10:20:00',8.76),('10318','2014-04-09','10:25:00',6.06),('10318','2014-04-09','10:30:00',5.02),('10318','2014-04-09','10:35:00',6.64),('10318','2014-04-09','10:40:00',9.69),('10318','2014-04-09','10:45:00',9.07),('10318','2014-04-09','10:50:00',9.42),('10318','2014-04-09','10:55:00',8.53),('10318','2014-04-09','11:00:00',10.13),('10318','2014-04-09','11:05:00',9.36),('10318','2014-04-09','11:10:00',3.44),('10318','2014-04-09','11:15:00',2.18),('10318','2014-04-09','11:20:00',1.95),('10318','2014-04-09','11:25:00',5.46),('10318','2014-04-09','11:30:00',9.99),('10318','2014-04-09','11:35:00',8.66),('10318','2014-04-09','11:40:00',8.56),('10318','2014-04-09','11:45:00',8.03),('10318','2014-04-09','11:50:00',3.54),('10318','2014-04-09','11:55:00',6.46),('10318','2014-04-09','12:00:00',6.39),('10318','2014-04-09','12:05:00',5),('10318','2014-04-09','12:10:00',4.28),('10318','2014-04-09','12:15:00',3.54),('10318','2014-04-09','12:20:00',2.45),('10318','2014-04-09','12:25:00',2.15),('10318','2014-04-09','12:30:00',2.14),('10318','2014-04-09','12:35:00',1.62),('10318','2014-04-09','12:40:00',1.35),('10318','2014-04-09','12:45:00',1.26),('10318','2014-04-09','12:50:00',1.25),('10318','2014-04-09','12:55:00',1.36),('10318','2014-04-09','13:00:00',1.76),('10318','2014-04-09','13:05:00',2.06),('10318','2014-04-09','13:10:00',2.49),('10318','2014-04-09','13:15:00',2.72),('10318','2014-04-09','13:20:00',2.81),('10318','2014-04-09','13:25:00',2.8),('10318','2014-04-09','13:30:00',2.72),('10318','2014-04-09','13:35:00',3.17),('10318','2014-04-09','13:40:00',3.21),('10318','2014-04-09','13:45:00',2.37),('10318','2014-04-09','13:50:00',2.37),('10318','2014-04-09','13:55:00',2.32),('10318','2014-04-09','14:00:00',2.43),('10318','2014-04-09','14:05:00',2.45),('10318','2014-04-09','14:10:00',3.63),('10318','2014-04-09','14:15:00',3.85),('10318','2014-04-09','14:20:00',4.35),('10318','2014-04-09','14:25:00',6.69),('10318','2014-04-09','14:30:00',3.41),('10318','2014-04-09','14:35:00',3.02),('10318','2014-04-09','14:40:00',3.58),('10318','2014-04-09','14:45:00',4.97),('10318','2014-04-09','14:50:00',6.74),('10318','2014-04-09','14:55:00',9.04),('10318','2014-04-09','15:00:00',4.22),('10318','2014-04-09','15:05:00',6.21),('10318','2014-04-09','15:10:00',5.45),('10318','2014-04-09','15:15:00',3.96),('10318','2014-04-09','15:20:00',4.45),('10318','2014-04-09','15:25:00',4.3),('10318','2014-04-09','15:30:00',3.61),('10318','2014-04-09','15:35:00',2.87),('10318','2014-04-09','15:40:00',2.67),('10318','2014-04-09','15:45:00',2.23),('10318','2014-04-09','15:50:00',1.99),('10318','2014-04-09','15:55:00',2.49),('10318','2014-04-09','16:00:00',5.15),('10318','2014-04-09','16:05:00',6.51),('10318','2014-04-09','16:10:00',6.2),('10318','2014-04-09','16:15:00',5.9),('10318','2014-04-09','16:20:00',6.12),('10318','2014-04-09','16:25:00',6.03),('10318','2014-04-09','16:30:00',5.93),('10318','2014-04-09','16:35:00',5.93),('10318','2014-04-09','16:40:00',5.74),('10318','2014-04-09','16:45:00',4.79),('10318','2014-04-09','16:50:00',3.04),('10318','2014-04-09','16:55:00',4.94),('10318','2014-04-09','17:00:00',4.65),('10318','2014-04-09','17:05:00',4.39),('10318','2014-04-09','17:10:00',3.78),('10318','2014-04-09','17:15:00',3.48),('10318','2014-04-09','17:20:00',3.24),('10318','2014-04-09','17:25:00',3.17),('10318','2014-04-09','17:30:00',2.62),('10318','2014-04-09','17:35:00',1.66),('10318','2014-04-09','17:40:00',1.87),('10318','2014-04-09','17:45:00',2.65),('10318','2014-04-09','17:50:00',2.16),('10318','2014-04-09','17:55:00',2.49),('10318','2014-04-09','18:00:00',2),('10318','2014-04-09','18:05:00',1.42),('10318','2014-04-09','18:10:00',1.48),('10318','2014-04-09','18:15:00',1.61),('10318','2014-04-09','18:20:00',1.35),('10318','2014-04-09','18:25:00',1.1),('10318','2013-08-09','07:20:00',1.2),('10318','2013-08-09','07:25:00',1.4),('10318','2013-08-09','07:30:00',1.18),('10318','2013-08-09','07:35:00',1.33),('10318','2013-08-09','07:40:00',1.13),('10318','2013-08-09','07:50:00',1.03),('10318','2013-08-09','07:55:00',1.44),('10318','2013-08-09','08:00:00',2.35),('10318','2013-08-09','08:05:00',2.61),('10318','2013-08-09','08:10:00',2.08),('10318','2013-08-09','08:15:00',1.76),('10318','2013-08-09','08:20:00',1.96),('10318','2013-08-09','08:25:00',1.88),('10318','2013-08-09','08:30:00',1.91),('10318','2013-08-09','08:35:00',3.26),('10318','2013-08-09','08:40:00',4.22),('10318','2013-08-09','08:45:00',4.22),('10318','2013-08-09','08:50:00',4.26),('10318','2013-08-09','08:55:00',4.83),('10318','2013-08-09','09:00:00',4.64),('10318','2013-08-09','09:05:00',5.1),('10318','2013-08-09','09:10:00',5.3),('10318','2013-08-09','09:15:00',3.97),('10318','2013-08-09','09:20:00',2.81),('10318','2013-08-09','09:25:00',4.19),('10318','2013-08-09','09:30:00',5.81),('10318','2013-08-09','09:35:00',5.87),('10318','2013-08-09','09:40:00',4.88),('10318','2013-08-09','09:45:00',4.61),('10318','2013-08-09','09:50:00',5.74),('10318','2013-08-09','09:55:00',2.7),('10318','2013-08-09','10:00:00',4.29),('10318','2013-08-09','10:05:00',5.42),('10318','2013-08-09','10:10:00',6.35),('10318','2013-08-09','10:15:00',6.73),('10318','2013-08-09','10:20:00',6.78),('10318','2013-08-09','10:25:00',6.93),('10318','2013-08-09','10:30:00',7),('10318','2013-08-09','10:35:00',6.96),('10318','2013-08-09','10:40:00',7.11),('10318','2013-08-09','10:45:00',7.05),('10318','2013-08-09','10:50:00',7.24),('10318','2013-08-09','10:55:00',7.54),('10318','2013-08-09','11:00:00',7.43),('10318','2013-08-09','11:05:00',7.52),('10318','2013-08-09','11:10:00',7.67),('10318','2013-08-09','11:15:00',7.64),('10318','2013-08-09','11:20:00',7.77),('10318','2013-08-09','11:25:00',7.84),('10318','2013-08-09','11:30:00',7.86),('10318','2013-08-09','11:35:00',7.79),('10318','2013-08-09','11:40:00',7.88),('10318','2013-08-09','11:45:00',7.99),('10318','2013-08-09','11:50:00',8.04),('10318','2013-08-09','11:55:00',8.03),('10318','2013-08-09','12:00:00',8.07),('10318','2013-08-09','12:05:00',8.2),('10318','2013-08-09','12:10:00',8.25),('10318','2013-08-09','12:15:00',8.32),('10318','2013-08-09','12:20:00',7.74),('10318','2013-08-09','12:25:00',8.5),('10318','2013-08-09','12:30:00',8.47),('10318','2013-08-09','12:35:00',5.03),('10318','2013-08-09','12:40:00',6.85),('10318','2013-08-09','12:45:00',9.39),('10318','2013-08-09','12:50:00',7.8),('10318','2013-08-09','12:55:00',5.95),('10318','2013-08-09','13:00:00',2.74),('10318','2013-08-09','13:05:00',1.82),('10318','2013-08-09','13:10:00',1.79),('10318','2013-08-09','13:15:00',2.4),('10318','2013-08-09','13:20:00',4.13),('10318','2013-08-09','13:25:00',4.34),('10318','2013-08-09','13:30:00',3.56),('10318','2013-08-09','13:35:00',3.18),('10318','2013-08-09','13:40:00',2.93),('10318','2013-08-09','13:45:00',2.79),('10318','2013-08-09','13:50:00',2.92),('10318','2013-08-09','13:55:00',2.9),('10318','2013-08-09','14:00:00',2.94),('10318','2013-08-09','14:05:00',2.56),('10318','2013-08-09','14:10:00',2.69),('10318','2013-08-09','14:15:00',2.09),('10318','2013-08-09','14:20:00',1.82),('10318','2013-08-09','14:25:00',1.87),('10318','2013-08-09','14:30:00',1.96),('10318','2013-08-09','14:35:00',1.78),('10318','2013-08-09','14:40:00',1.38),('10318','2013-08-09','14:45:00',1.09),('10318','2013-08-09','15:05:00',2.12),('10318','2013-08-09','15:10:00',5.01),('10318','2013-08-09','15:15:00',6.71),('10318','2013-08-09','15:20:00',3.71),('10318','2013-08-09','15:25:00',2.65),('10318','2013-08-09','15:30:00',2.42),('10318','2013-08-09','15:35:00',3.85),('10318','2013-08-09','15:40:00',5.16),('10318','2013-08-09','15:45:00',4.62),('10318','2013-08-09','15:50:00',3.46),('10318','2013-08-09','15:55:00',2.78),('10318','2013-08-09','16:00:00',2.36),('10318','2013-08-09','16:05:00',1.6),('10318','2013-08-09','16:10:00',1.31),('10318','2013-08-09','16:15:00',1.37),('10318','2013-08-09','16:20:00',1.48),('10318','2013-08-09','16:25:00',1.66),('10318','2013-08-09','16:30:00',1.39),('10318','2013-08-09','16:35:00',1.47),('10318','2013-08-09','16:40:00',1.63),('10318','2013-08-09','16:45:00',2.03),('10318','2013-08-09','16:50:00',3.12),('10318','2013-08-09','16:55:00',3.85),('10318','2013-08-09','17:00:00',2.31),('10318','2013-08-09','17:05:00',2.24),('10318','2013-08-09','17:10:00',1.96),('10318','2013-08-09','17:15:00',1.55),('10318','2013-08-09','17:20:00',1.37),('10318','2013-08-09','17:25:00',1.37),('10318','2013-08-09','17:30:00',1.65),('10318','2013-08-09','17:35:00',1.71),('10318','2013-08-09','17:40:00',1.72),('10318','2013-08-09','17:45:00',1.57),('10318','2013-08-09','17:50:00',1.25),('10318','2013-08-09','18:15:00',1.08),('10318','2013-08-09','18:20:00',1.02),('10318','2013-08-09','18:55:00',1.04),('10318','2013-08-09','19:00:00',1.36),('10318','2013-08-09','19:05:00',1.59),('10318','2013-08-09','19:10:00',1.66),('10318','2013-08-09','19:15:00',1.69),('10318','2013-08-09','19:20:00',1.96),('10318','2013-08-09','19:25:00',2.13),('10318','2013-08-09','19:30:00',1.25),('10318','2013-08-08','07:20:00',1.03),('10318','2013-08-08','07:25:00',1.29),('10318','2013-08-08','07:30:00',1.47),('10318','2013-08-08','07:35:00',1.69),('10318','2013-08-08','07:40:00',1.97),('10318','2013-08-08','07:45:00',2.2),('10318','2013-08-08','07:50:00',2.4),('10318','2013-08-08','07:55:00',2.58),('10318','2013-08-08','08:00:00',2.78),('10318','2013-08-08','08:05:00',2.92),('10318','2013-08-08','08:10:00',3.16),('10318','2013-08-08','08:15:00',3.34),('10318','2013-08-08','08:20:00',3.54),('10318','2013-08-08','08:25:00',3.72),('10318','2013-08-08','08:30:00',3.89),('10318','2013-08-08','08:35:00',4.04),('10318','2013-08-08','08:40:00',4.2),('10318','2013-08-08','08:45:00',4.36),('10318','2013-08-08','08:50:00',4.48),('10318','2013-08-08','08:55:00',4.72),('10318','2013-08-08','09:00:00',4.88),('10318','2013-08-08','09:05:00',5.05),('10318','2013-08-08','09:10:00',5.22),('10318','2013-08-08','09:15:00',5.34),('10318','2013-08-08','09:20:00',5.48),('10318','2013-08-08','09:25:00',5.66),('10318','2013-08-08','09:30:00',5.79),('10318','2013-08-08','09:35:00',5.95),('10318','2013-08-08','09:40:00',6.08),('10318','2013-08-08','09:45:00',6.23),('10318','2013-08-08','09:50:00',6.34),('10318','2013-08-08','09:55:00',6.46),('10318','2013-08-08','10:00:00',6.57),('10318','2013-08-08','10:05:00',6.67),('10318','2013-08-08','10:10:00',6.78),('10318','2013-08-08','10:15:00',6.9),('10318','2013-08-08','10:20:00',6.99),('10318','2013-08-08','10:25:00',7.08),('10318','2013-08-08','10:30:00',7.15),('10318','2013-08-08','10:35:00',7.1),('10318','2013-08-08','10:40:00',7.28),('10318','2013-08-08','10:45:00',7.39),('10318','2013-08-08','10:50:00',7.41),('10318','2013-08-08','10:55:00',7.45),('10318','2013-08-08','11:00:00',7.5),('10318','2013-08-08','11:05:00',7.59),('10318','2013-08-08','11:10:00',7.64),('10318','2013-08-08','11:15:00',7.75),('10318','2013-08-08','11:20:00',7.77),('10318','2013-08-08','11:25:00',7.78),('10318','2013-08-08','11:30:00',7.85),('10318','2013-08-08','11:35:00',7.85),('10318','2013-08-08','11:40:00',7.87),('10318','2013-08-08','11:45:00',7.94),('10318','2013-08-08','11:50:00',8.09),('10318','2013-08-08','11:55:00',8.05),('10318','2013-08-08','12:00:00',8.07),('10318','2013-08-08','12:05:00',8.12),('10318','2013-08-08','12:10:00',8.13),('10318','2013-08-08','12:15:00',8.04),('10318','2013-08-08','12:20:00',7.86),('10318','2013-08-08','12:25:00',8.21),('10318','2013-08-08','12:30:00',8.2),('10318','2013-08-08','12:35:00',8.21),('10318','2013-08-08','12:40:00',8.34),('10318','2013-08-08','12:45:00',8.37),('10318','2013-08-08','12:50:00',8.37),('10318','2013-08-08','12:55:00',8.29),('10318','2013-08-08','13:00:00',8.3),('10318','2013-08-08','13:05:00',8.27),('10318','2013-08-08','13:10:00',8.3),('10318','2013-08-08','13:15:00',8.29),('10318','2013-08-08','13:20:00',8.26),('10318','2013-08-08','13:25:00',8.22),('10318','2013-08-08','13:30:00',8.22),('10318','2013-08-08','13:35:00',8.16),('10318','2013-08-08','13:40:00',8.13),('10318','2013-08-08','13:45:00',8.11),('10318','2013-08-08','13:50:00',8.03),('10318','2013-08-08','13:55:00',8),('10318','2013-08-08','14:00:00',7.97),('10318','2013-08-08','14:05:00',7.9),('10318','2013-08-08','14:10:00',7.78),('10318','2013-08-08','14:15:00',7.8),('10318','2013-08-08','14:20:00',7.7),('10318','2013-08-08','14:25:00',7.62),('10318','2013-08-08','14:30:00',7.57),('10318','2013-08-08','14:35:00',7.51),('10318','2013-08-08','14:40:00',7.41),('10318','2013-08-08','14:45:00',7.32),('10318','2013-08-08','14:50:00',7.23),('10318','2013-08-08','14:55:00',7.14),('10318','2013-08-08','15:00:00',7.04),('10318','2013-08-08','15:05:00',6.95),('10318','2013-08-08','15:10:00',6.89),('10318','2013-08-08','15:15:00',6.77),('10318','2013-08-08','15:20:00',6.64),('10318','2013-08-08','15:25:00',6.47),('10318','2013-08-08','15:30:00',6.39),('10318','2013-08-08','15:35:00',6.3),('10318','2013-08-08','15:40:00',6.2),('10318','2013-08-08','15:45:00',6.07),('10318','2013-08-08','15:50:00',5.89),('10318','2013-08-08','15:55:00',5.74),('10318','2013-08-08','16:00:00',5.7),('10318','2013-08-08','16:05:00',5.6),('10318','2013-08-08','16:10:00',5.52),('10318','2013-08-08','16:15:00',5.38),('10318','2013-08-08','16:20:00',5.23),('10318','2013-08-08','16:25:00',5.11),('10318','2013-08-08','16:30:00',4.97),('10318','2013-08-08','16:35:00',4.79),('10318','2013-08-08','16:40:00',4.64),('10318','2013-08-08','16:45:00',4.47),('10318','2013-08-08','16:50:00',4.31),('10318','2013-08-08','16:55:00',4.13),('10318','2013-08-08','17:00:00',4),('10318','2013-08-08','17:05:00',3.86),('10318','2013-08-08','17:10:00',3.65),('10318','2013-08-08','17:15:00',3.53),('10318','2013-08-08','17:20:00',3.35),('10318','2013-08-08','17:25:00',3.19),('10318','2013-08-08','17:30:00',3.04),('10318','2013-08-08','17:35:00',2.87),('10318','2013-08-08','17:40:00',2.71),('10318','2013-08-08','17:45:00',2.57),('10318','2013-08-08','17:50:00',2.42),('10318','2013-08-08','17:55:00',2.27),('10318','2013-08-08','18:00:00',2.12),('10318','2013-08-08','18:05:00',1.96),('10318','2013-08-08','18:10:00',1.82),('10318','2013-08-08','18:15:00',1.69),('10318','2013-08-08','18:20:00',1.55),('10318','2013-08-08','18:25:00',1.43),('10318','2013-08-08','18:30:00',1.31),('10318','2013-08-08','18:35:00',1.2),('10318','2013-08-08','18:40:00',1.09),('10318','2013-08-07','07:20:00',1.16),('10318','2013-08-07','07:25:00',1.44),('10318','2013-08-07','07:30:00',1.67),('10318','2013-08-07','07:35:00',1.85),('10318','2013-08-07','07:40:00',2.08),('10318','2013-08-07','07:45:00',2.33),('10318','2013-08-07','07:50:00',2.56),('10318','2013-08-07','07:55:00',2.76),('10318','2013-08-07','08:00:00',2.91),('10318','2013-08-07','08:05:00',3.06),('10318','2013-08-07','08:10:00',3.27),('10318','2013-08-07','08:15:00',3.49),('10318','2013-08-07','08:20:00',3.67),('10318','2013-08-07','08:25:00',3.84),('10318','2013-08-07','08:30:00',3.99),('10318','2013-08-07','08:35:00',4.18),('10318','2013-08-07','08:40:00',4.38),('10318','2013-08-07','08:45:00',4.54),('10318','2013-08-07','08:50:00',4.71),('10318','2013-08-07','08:55:00',4.87),('10318','2013-08-07','09:00:00',5.05),('10318','2013-08-07','09:05:00',5.2),('10318','2013-08-07','09:10:00',5.32),('10318','2013-08-07','09:15:00',5.45),('10318','2013-08-07','09:20:00',5.52),('10318','2013-08-07','09:25:00',5.74),('10318','2013-08-07','09:30:00',5.91),('10318','2013-08-07','09:35:00',6.03),('10318','2013-08-07','09:40:00',6.12),('10318','2013-08-07','09:45:00',6.21),('10318','2013-08-07','09:50:00',6.27),('10318','2013-08-07','09:55:00',6.48),('10318','2013-08-07','10:00:00',6.64),('10318','2013-08-07','10:05:00',6.8),('10318','2013-08-07','10:10:00',6.91),('10318','2013-08-07','10:15:00',6.97),('10318','2013-08-07','10:20:00',7.05),('10318','2013-08-07','10:25:00',7.1),('10318','2013-08-07','10:30:00',7.17),('10318','2013-08-07','10:35:00',7.28),('10318','2013-08-07','10:40:00',7.33),('10318','2013-08-07','10:45:00',7.43),('10318','2013-08-07','10:50:00',7.48),('10318','2013-08-07','10:55:00',7.57),('10318','2013-08-07','11:00:00',7.62),('10318','2013-08-07','11:05:00',7.49),('10318','2013-08-07','11:10:00',7.75),('10318','2013-08-07','11:15:00',7.79),('10318','2013-08-07','11:20:00',7.82),('10318','2013-08-07','11:25:00',7.83),('10318','2013-08-07','11:30:00',7.9),('10318','2013-08-07','11:35:00',7.92),('10318','2013-08-07','11:40:00',7.92),('10318','2013-08-07','11:45:00',7.97),('10318','2013-08-07','11:50:00',8.03),('10318','2013-08-07','11:55:00',8.08),('10318','2013-08-07','12:00:00',8.1),('10318','2013-08-07','12:05:00',8.15),('10318','2013-08-07','12:10:00',8.12),('10318','2013-08-07','12:15:00',8.07),('10318','2013-08-07','12:20:00',7.97),('10318','2013-08-07','12:25:00',8.01),('10318','2013-08-07','12:30:00',8.04),('10318','2013-08-07','12:35:00',8.11),('10318','2013-08-07','12:40:00',8.27),('10318','2013-08-07','12:45:00',8.44),('10318','2013-08-07','12:50:00',7.98),('10318','2013-08-07','12:55:00',8.19),('10318','2013-08-07','13:00:00',8.2),('10318','2013-08-07','13:05:00',8.22),('10318','2013-08-07','13:10:00',8.19),('10318','2013-08-07','13:15:00',8.28),('10318','2013-08-07','13:20:00',8.21),('10318','2013-08-07','13:25:00',8.24),('10318','2013-08-07','13:30:00',8.21),('10318','2013-08-07','13:35:00',8.11),('10318','2013-08-07','13:40:00',8.21),('10318','2013-08-07','13:45:00',8.13),('10318','2013-08-07','13:50:00',8.16),('10318','2013-08-07','13:55:00',8.05),('10318','2013-08-07','14:00:00',8.03),('10318','2013-08-07','14:05:00',7.95),('10318','2013-08-07','14:10:00',7.83),('10318','2013-08-07','14:15:00',7.67),('10318','2013-08-07','14:20:00',7.64),('10318','2013-08-07','14:25:00',7.7),('10318','2013-08-07','14:30:00',7.65),('10318','2013-08-07','14:35:00',7.55),('10318','2013-08-07','14:40:00',7.59),('10318','2013-08-07','14:45:00',7.49),('10318','2013-08-07','14:50:00',7.35),('10318','2013-08-07','14:55:00',7.14),('10318','2013-08-07','15:00:00',7.08),('10318','2013-08-07','15:05:00',6.96),('10318','2013-08-07','15:10:00',6.97),('10318','2013-08-07','15:15:00',6.89),('10318','2013-08-07','15:20:00',6.73),('10318','2013-08-07','15:25:00',6.61),('10318','2013-08-07','15:30:00',6.55),('10318','2013-08-07','15:35:00',6.45),('10318','2013-08-07','15:40:00',6.35),('10318','2013-08-07','15:45:00',6.24),('10318','2013-08-07','15:50:00',6.08),('10318','2013-08-07','15:55:00',5.95),('10318','2013-08-07','16:00:00',5.84),('10318','2013-08-07','16:05:00',5.73),('10318','2013-08-07','16:10:00',5.57),('10318','2013-08-07','16:15:00',5.44),('10318','2013-08-07','16:20:00',5.26),('10318','2013-08-07','16:25:00',5.13),('10318','2013-08-07','16:30:00',4.99),('10318','2013-08-07','16:35:00',4.83),('10318','2013-08-07','16:40:00',4.68),('10318','2013-08-07','16:45:00',4.54),('10318','2013-08-07','16:50:00',4.35),('10318','2013-08-07','16:55:00',4.11),('10318','2013-08-07','17:00:00',3.94),('10318','2013-08-07','17:05:00',3.85),('10318','2013-08-07','17:10:00',3.75),('10318','2013-08-07','17:15:00',3.6),('10318','2013-08-07','17:20:00',3.44),('10318','2013-08-07','17:25:00',3.23),('10318','2013-08-07','17:30:00',3.09),('10318','2013-08-07','17:35:00',2.96),('10318','2013-08-07','17:40:00',2.82),('10318','2013-08-07','17:45:00',2.66),('10318','2013-08-07','17:50:00',2.49),('10318','2013-08-07','17:55:00',2.33),('10318','2013-08-07','18:00:00',2.12),('10318','2013-08-07','18:05:00',1.92),('10318','2013-08-07','18:10:00',1.86),('10318','2013-08-07','18:15:00',1.71),('10318','2013-08-07','18:20:00',1.6),('10318','2013-08-07','18:25:00',1.47),('10318','2013-08-07','18:30:00',1.36),('10318','2013-08-07','18:35:00',1.26),('10318','2013-08-07','18:40:00',1.13),('10318','2013-08-07','18:45:00',1.04),('10318','2013-08-06','07:20:00',1.09),('10318','2013-08-06','07:25:00',1.33),('10318','2013-08-06','07:30:00',1.59),('10318','2013-08-06','07:35:00',1.75),('10318','2013-08-06','07:40:00',1.99),('10318','2013-08-06','07:45:00',2.24),('10318','2013-08-06','07:50:00',2.43),('10318','2013-08-06','07:55:00',2.61),('10318','2013-08-06','08:00:00',2.79),('10318','2013-08-06','08:05:00',2.97),('10318','2013-08-06','08:10:00',3.17),('10318','2013-08-06','08:15:00',3.35),('10318','2013-08-06','08:20:00',3.53),('10318','2013-08-06','08:25:00',3.72),('10318','2013-08-06','08:30:00',3.91),('10318','2013-08-06','08:35:00',4.09),('10318','2013-08-06','08:40:00',4.27),('10318','2013-08-06','08:45:00',4.46),('10318','2013-08-06','08:50:00',4.54),('10318','2013-08-06','08:55:00',4.81),('10318','2013-08-06','09:00:00',4.96),('10318','2013-08-06','09:05:00',5.13),('10318','2013-08-06','09:10:00',5.28),('10318','2013-08-06','09:15:00',5.4),('10318','2013-08-06','09:20:00',5.53),('10318','2013-08-06','09:25:00',5.7),('10318','2013-08-06','09:30:00',5.81),('10318','2013-08-06','09:35:00',5.96),('10318','2013-08-06','09:40:00',6.07),('10318','2013-08-06','09:45:00',6.2),('10318','2013-08-06','09:50:00',6.32),('10318','2013-08-06','09:55:00',6.45),('10318','2013-08-06','10:00:00',6.53),('10318','2013-08-06','10:05:00',6.61),('10318','2013-08-06','10:10:00',6.74),('10318','2013-08-06','10:15:00',6.84),('10318','2013-08-06','10:20:00',6.91),('10318','2013-08-06','10:25:00',7.01),('10318','2013-08-06','10:30:00',7.08),('10318','2013-08-06','10:35:00',7.07),('10318','2013-08-06','10:40:00',7.29),('10318','2013-08-06','10:45:00',7.35),('10318','2013-08-06','10:50:00',7.39),('10318','2013-08-06','10:55:00',7.45),('10318','2013-08-06','11:00:00',7.56),('10318','2013-08-06','11:05:00',7.6),('10318','2013-08-06','11:10:00',7.67),('10318','2013-08-06','11:15:00',7.75),('10318','2013-08-06','11:20:00',7.82),('10318','2013-08-06','11:25:00',7.86),('10318','2013-08-06','11:30:00',7.93),('10318','2013-08-06','11:35:00',7.95),('10318','2013-08-06','11:40:00',8),('10318','2013-08-06','11:45:00',7.99),('10318','2013-08-06','11:50:00',8.01),('10318','2013-08-06','11:55:00',8.04),('10318','2013-08-06','12:00:00',8.04),('10318','2013-08-06','12:05:00',8.1),('10318','2013-08-06','12:10:00',8.12),('10318','2013-08-06','12:15:00',8.09),('10318','2013-08-06','12:20:00',7.85),('10318','2013-08-06','12:25:00',8.02),('10318','2013-08-06','12:30:00',8.1),('10318','2013-08-06','12:35:00',8.19),('10318','2013-08-06','12:40:00',8.21),('10318','2013-08-06','12:45:00',8.26),('10318','2013-08-06','12:50:00',8.38),('10318','2013-08-06','12:55:00',8.36),('10318','2013-08-06','13:00:00',8.39),('10318','2013-08-06','13:05:00',8.32),('10318','2013-08-06','13:10:00',8.38),('10318','2013-08-06','13:15:00',8.29),('10318','2013-08-06','13:20:00',8.26),('10318','2013-08-06','13:25:00',8.29),('10318','2013-08-06','13:30:00',8.27),('10318','2013-08-06','13:35:00',8.28),('10318','2013-08-06','13:40:00',8.3),('10318','2013-08-06','13:45:00',8.28),('10318','2013-08-06','13:50:00',8.23),('10318','2013-08-06','13:55:00',8.18),('10318','2013-08-06','14:00:00',8.16),('10318','2013-08-06','14:05:00',7.95),('10318','2013-08-06','14:10:00',8.08),('10318','2013-08-06','14:15:00',8.05),('10318','2013-08-06','14:20:00',8),('10318','2013-08-06','14:25:00',7.94),('10318','2013-08-06','14:30:00',7.85),('10318','2013-08-06','14:35:00',7.76),('10318','2013-08-06','14:40:00',7.7),('10318','2013-08-06','14:45:00',7.58),('10318','2013-08-06','14:50:00',7.56),('10318','2013-08-06','14:55:00',7.46),('10318','2013-08-06','15:00:00',7.35),('10318','2013-08-06','15:05:00',7.25),('10318','2013-08-06','15:10:00',7.18),('10318','2013-08-06','15:15:00',7.07),('10318','2013-08-06','15:20:00',6.98),('10318','2013-08-06','15:25:00',6.9),('10318','2013-08-06','15:30:00',6.8),('10318','2013-08-06','15:35:00',6.66),('10318','2013-08-06','15:40:00',6.51),('10318','2013-08-06','15:45:00',6.37),('10318','2013-08-06','15:50:00',6.24),('10318','2013-08-06','15:55:00',6.03),('10318','2013-08-06','16:00:00',5.98),('10318','2013-08-06','16:05:00',5.87),('10318','2013-08-06','16:10:00',5.73),('10318','2013-08-06','16:15:00',5.58),('10318','2013-08-06','16:20:00',5.43),('10318','2013-08-06','16:25:00',5.27),('10318','2013-08-06','16:30:00',5.14),('10318','2013-08-06','16:35:00',4.98),('10318','2013-08-06','16:40:00',4.84),('10318','2013-08-06','16:45:00',4.69),('10318','2013-08-06','16:50:00',4.52),('10318','2013-08-06','16:55:00',4.36),('10318','2013-08-06','17:00:00',4.21),('10318','2013-08-06','17:05:00',4.04),('10318','2013-08-06','17:10:00',3.8),('10318','2013-08-06','17:15:00',3.7),('10318','2013-08-06','17:20:00',3.55),('10318','2013-08-06','17:25:00',3.37),('10318','2013-08-06','17:30:00',3.19),('10318','2013-08-06','17:35:00',3.01),('10318','2013-08-06','17:40:00',2.84),('10318','2013-08-06','17:45:00',2.68),('10318','2013-08-06','17:50:00',2.53),('10318','2013-08-06','17:55:00',2.37),('10318','2013-08-06','18:00:00',2.23),('10318','2013-08-06','18:05:00',2.08),('10318','2013-08-06','18:10:00',1.93),('10318','2013-08-06','18:15:00',1.78),('10318','2013-08-06','18:20:00',1.64),('10318','2013-08-06','18:25:00',1.52),('10318','2013-08-06','18:30:00',1.38),('10318','2013-08-06','18:35:00',1.26),('10318','2013-08-06','18:40:00',1.12),('10318','2013-08-06','18:45:00',1),('10318','2013-08-05','07:20:00',1.18),('10318','2013-08-05','07:25:00',1.41),('10318','2013-08-05','07:30:00',1.67),('10318','2013-08-05','07:35:00',1.86),('10318','2013-08-05','07:40:00',2.11),('10318','2013-08-05','07:45:00',2.39),('10318','2013-08-05','07:50:00',2.59),('10318','2013-08-05','07:55:00',2.76),('10318','2013-08-05','08:00:00',2.93),('10318','2013-08-05','08:05:00',3.13),('10318','2013-08-05','08:10:00',3.33),('10318','2013-08-05','08:15:00',3.51),('10318','2013-08-05','08:20:00',3.69),('10318','2013-08-05','08:25:00',3.86),('10318','2013-08-05','08:30:00',4.02),('10318','2013-08-05','08:35:00',4.18),('10318','2013-08-05','08:40:00',4.31),('10318','2013-08-05','08:45:00',4.48),('10318','2013-08-05','08:50:00',4.68),('10318','2013-08-05','08:55:00',4.86),('10318','2013-08-05','09:00:00',5.02),('10318','2013-08-05','09:05:00',5.17),('10318','2013-08-05','09:10:00',5.35),('10318','2013-08-05','09:15:00',5.47),('10318','2013-08-05','09:20:00',5.58),('10318','2013-08-05','09:25:00',5.73),('10318','2013-08-05','09:30:00',5.87),('10318','2013-08-05','09:35:00',5.99),('10318','2013-08-05','09:40:00',6.14),('10318','2013-08-05','09:45:00',6.28),('10318','2013-08-05','09:50:00',6.28),('10318','2013-08-05','09:55:00',6.52),('10318','2013-08-05','10:00:00',6.64),('10318','2013-08-05','10:05:00',6.76),('10318','2013-08-05','10:10:00',6.88),('10318','2013-08-05','10:15:00',6.96),('10318','2013-08-05','10:20:00',7.08),('10318','2013-08-05','10:25:00',7.15),('10318','2013-08-05','10:30:00',7.3),('10318','2013-08-05','10:35:00',7.35),('10318','2013-08-05','10:40:00',7.44),('10318','2013-08-05','10:45:00',7.48),('10318','2013-08-05','10:50:00',7.59),('10318','2013-08-05','10:55:00',7.69),('10318','2013-08-05','11:00:00',7.79),('10318','2013-08-05','11:05:00',7.83),('10318','2013-08-05','11:10:00',7.91),('10318','2013-08-05','11:15:00',7.91),('10318','2013-08-05','11:20:00',7.94),('10318','2013-08-05','11:25:00',7.98),('10318','2013-08-05','11:30:00',8.05),('10318','2013-08-05','11:35:00',8.1),('10318','2013-08-05','11:40:00',8.17),('10318','2013-08-05','11:45:00',8.24),('10318','2013-08-05','11:50:00',8.27),('10318','2013-08-05','11:55:00',8.31),('10318','2013-08-05','12:00:00',8.3),('10318','2013-08-05','12:05:00',8.33),('10318','2013-08-05','12:10:00',8.36),('10318','2013-08-05','12:15:00',8.34),('10318','2013-08-05','12:20:00',8.4),('10318','2013-08-05','12:25:00',8.41),('10318','2013-08-05','12:30:00',8.34),('10318','2013-08-05','12:35:00',8.35),('10318','2013-08-05','12:40:00',8.46),('10318','2013-08-05','12:45:00',8.4),('10318','2013-08-05','12:50:00',8.34),('10318','2013-08-05','12:55:00',8.41),('10318','2013-08-05','13:00:00',8.3),('10318','2013-08-05','13:05:00',8.36),('10318','2013-08-05','13:10:00',8.24),('10318','2013-08-05','13:15:00',8.22),('10318','2013-08-05','13:20:00',7.98),('10318','2013-08-05','13:25:00',8.23),('10318','2013-08-05','13:30:00',8.29),('10318','2013-08-05','13:35:00',8.2),('10318','2013-08-05','13:40:00',8.16),('10318','2013-08-05','13:45:00',8.11),('10318','2013-08-05','13:50:00',8.07),('10318','2013-08-05','13:55:00',7.97),('10318','2013-08-05','14:00:00',8.01),('10318','2013-08-05','14:05:00',7.95),('10318','2013-08-05','14:10:00',7.91),('10318','2013-08-05','14:15:00',7.85),('10318','2013-08-05','14:20:00',7.8),('10318','2013-08-05','14:25:00',7.72),('10318','2013-08-05','14:30:00',7.61),('10318','2013-08-05','14:35:00',7.59),('10318','2013-08-05','14:40:00',7.53),('10318','2013-08-05','14:45:00',7.52),('10318','2013-08-05','14:50:00',7.41),('10318','2013-08-05','14:55:00',7.33),('10318','2013-08-05','15:00:00',7.2),('10318','2013-08-05','15:05:00',6.97),('10318','2013-08-05','15:10:00',7.03),('10318','2013-08-05','15:15:00',6.94),('10318','2013-08-05','15:20:00',6.85),('10318','2013-08-05','15:25:00',6.75),('10318','2013-08-05','15:30:00',6.73),('10318','2013-08-05','15:35:00',6.64),('10318','2013-08-05','15:40:00',6.47),('10318','2013-08-05','15:45:00',6.33),('10318','2013-08-05','15:50:00',6.18),('10318','2013-08-05','15:55:00',6.07),('10318','2013-08-05','16:00:00',5.96),('10318','2013-08-05','16:05:00',5.82),('10318','2013-08-05','16:10:00',5.71),('10318','2013-08-05','16:15:00',5.53),('10318','2013-08-05','16:20:00',5.32),('10318','2013-08-05','16:25:00',5.19),('10318','2013-08-05','16:30:00',5.06),('10318','2013-08-05','16:35:00',4.93),('10318','2013-08-05','16:40:00',4.78),('10318','2013-08-05','16:45:00',4.62),('10318','2013-08-05','16:50:00',4.4),('10318','2013-08-05','16:55:00',4.3),('10318','2013-08-05','17:00:00',4.12),('10318','2013-08-05','17:05:00',3.95),('10318','2013-08-05','17:10:00',3.8),('10318','2013-08-05','17:15:00',3.63),('10318','2013-08-05','17:20:00',3.48),('10318','2013-08-05','17:25:00',3.33),('10318','2013-08-05','17:30:00',3.17),('10318','2013-08-05','17:35:00',3.01),('10318','2013-08-05','17:40:00',2.83),('10318','2013-08-05','17:45:00',2.68),('10318','2013-08-05','17:50:00',2.5),('10318','2013-08-05','17:55:00',2.34),('10318','2013-08-05','18:00:00',2.19),('10318','2013-08-05','18:05:00',2.01),('10318','2013-08-05','18:10:00',1.9),('10318','2013-08-05','18:15:00',1.76),('10318','2013-08-05','18:20:00',1.63),('10318','2013-08-05','18:25:00',1.5),('10318','2013-08-05','18:30:00',1.38),('10318','2013-08-05','18:35:00',1.25),('10318','2013-08-05','18:40:00',1.15),('10318','2013-08-05','18:45:00',1.04),('10318','2013-08-04','07:20:00',1.27),('10318','2013-08-04','07:25:00',1.59),('10318','2013-08-04','07:30:00',1.91),('10318','2013-08-04','07:35:00',2.12),('10318','2013-08-04','07:40:00',2.39),('10318','2013-08-04','07:45:00',2.66),('10318','2013-08-04','07:50:00',2.87),('10318','2013-08-04','07:55:00',3.06),('10318','2013-08-04','08:00:00',3.26),('10318','2013-08-04','08:05:00',3.44),('10318','2013-08-04','08:10:00',3.63),('10318','2013-08-04','08:15:00',3.83),('10318','2013-08-04','08:20:00',4.02),('10318','2013-08-04','08:25:00',4.21),('10318','2013-08-04','08:30:00',4.35),('10318','2013-08-04','08:35:00',4.55),('10318','2013-08-04','08:40:00',4.72),('10318','2013-08-04','08:45:00',4.87),('10318','2013-08-04','08:50:00',5.02),('10318','2013-08-04','08:55:00',5.21),('10318','2013-08-04','09:00:00',5.37),('10318','2013-08-04','09:05:00',5.54),('10318','2013-08-04','09:10:00',5.68),('10318','2013-08-04','09:15:00',5.82),('10318','2013-08-04','09:20:00',5.96),('10318','2013-08-04','09:25:00',6.11),('10318','2013-08-04','09:30:00',6.24),('10318','2013-08-04','09:35:00',6.4),('10318','2013-08-04','09:40:00',6.51),('10318','2013-08-04','09:45:00',6.65),('10318','2013-08-04','09:50:00',6.74),('10318','2013-08-04','09:55:00',6.86),('10318','2013-08-04','10:00:00',6.96),('10318','2013-08-04','10:05:00',7.05),('10318','2013-08-04','10:10:00',7.16),('10318','2013-08-04','10:15:00',7.17),('10318','2013-08-04','10:20:00',7.36),('10318','2013-08-04','10:25:00',7.44),('10318','2013-08-04','10:30:00',7.48),('10318','2013-08-04','10:35:00',7.58),('10318','2013-08-04','10:40:00',7.64),('10318','2013-08-04','10:45:00',7.69),('10318','2013-08-04','10:50:00',7.78),('10318','2013-08-04','10:55:00',7.8),('10318','2013-08-04','11:00:00',7.88),('10318','2013-08-04','11:05:00',8),('10318','2013-08-04','11:10:00',8.14),('10318','2013-08-04','11:15:00',8.2),('10318','2013-08-04','11:20:00',8.22),('10318','2013-08-04','11:25:00',8.28),('10318','2013-08-04','11:30:00',8.37),('10318','2013-08-04','11:35:00',8.43),('10318','2013-08-04','11:40:00',8.48),('10318','2013-08-04','11:45:00',8.49),('10318','2013-08-04','11:50:00',8.53),('10318','2013-08-04','11:55:00',8.49),('10318','2013-08-04','12:00:00',8.55),('10318','2013-08-04','12:05:00',8.32),('10318','2013-08-04','12:10:00',8.53),('10318','2013-08-04','12:15:00',8.56),('10318','2013-08-04','12:20:00',8.53),('10318','2013-08-04','12:25:00',8.54),('10318','2013-08-04','12:30:00',8.58),('10318','2013-08-04','12:35:00',8.59),('10318','2013-08-04','12:40:00',8.62),('10318','2013-08-04','12:45:00',8.5),('10318','2013-08-04','12:50:00',8.51),('10318','2013-08-04','12:55:00',8.61),('10318','2013-08-04','13:00:00',8.62),('10318','2013-08-04','13:05:00',8.46),('10318','2013-08-04','13:10:00',8.51),('10318','2013-08-04','13:15:00',8.46),('10318','2013-08-04','13:20:00',8.49),('10318','2013-08-04','13:25:00',8.49),('10318','2013-08-04','13:30:00',8.47),('10318','2013-08-04','13:35:00',8.47),('10318','2013-08-04','13:40:00',8.45),('10318','2013-08-04','13:45:00',8.46),('10318','2013-08-04','13:50:00',8.2),('10318','2013-08-04','13:55:00',8.37),('10318','2013-08-04','14:00:00',8.3),('10318','2013-08-04','14:05:00',8.28),('10318','2013-08-04','14:10:00',8.23),('10318','2013-08-04','14:15:00',8.16),('10318','2013-08-04','14:20:00',8.14),('10318','2013-08-04','14:25:00',8.03),('10318','2013-08-04','14:30:00',7.98),('10318','2013-08-04','14:35:00',7.89),('10318','2013-08-04','14:40:00',7.82),('10318','2013-08-04','14:45:00',7.75),('10318','2013-08-04','14:50:00',7.62),('10318','2013-08-04','14:55:00',7.56),('10318','2013-08-04','15:00:00',7.5),('10318','2013-08-04','15:05:00',7.37),('10318','2013-08-04','15:10:00',7.26),('10318','2013-08-04','15:15:00',7.2),('10318','2013-08-04','15:20:00',7.08),('10318','2013-08-04','15:25:00',6.94),('10318','2013-08-04','15:30:00',6.84),('10318','2013-08-04','15:35:00',6.69),('10318','2013-08-04','15:40:00',6.61),('10318','2013-08-04','15:45:00',6.45),('10318','2013-08-04','15:50:00',6.09),('10318','2013-08-04','15:55:00',6.2),('10318','2013-08-04','16:00:00',6.23),('10318','2013-08-04','16:05:00',6.03),('10318','2013-08-04','16:10:00',5.88),('10318','2013-08-04','16:15:00',5.77),('10318','2013-08-04','16:20:00',5.62),('10318','2013-08-04','16:25:00',5.46),('10318','2013-08-04','16:30:00',5.28),('10318','2013-08-04','16:35:00',5.13),('10318','2013-08-04','16:40:00',4.98),('10318','2013-08-04','16:45:00',4.79),('10318','2013-08-04','16:50:00',4.61),('10318','2013-08-04','16:55:00',4.5),('10318','2013-08-04','17:00:00',4.31),('10318','2013-08-04','17:05:00',4.15),('10318','2013-08-04','17:10:00',3.96),('10318','2013-08-04','17:15:00',3.78),('10318','2013-08-04','17:20:00',3.57),('10318','2013-08-04','17:25:00',3.41),('10318','2013-08-04','17:30:00',3.24),('10318','2013-08-04','17:35:00',3.08),('10318','2013-08-04','17:40:00',2.91),('10318','2013-08-04','17:45:00',2.75),('10318','2013-08-04','17:50:00',2.56),('10318','2013-08-04','17:55:00',2.41),('10318','2013-08-04','18:00:00',2.23),('10318','2013-08-04','18:05:00',2.08),('10318','2013-08-04','18:10:00',1.93),('10318','2013-08-04','18:15:00',1.77),('10318','2013-08-04','18:20:00',1.62),('10318','2013-08-04','18:25:00',1.47),('10318','2013-08-04','18:30:00',1.34),('10318','2013-08-04','18:35:00',1.19),('10318','2013-08-04','18:40:00',1.1),('10318','2013-08-04','18:45:00',1.01),('10318','2013-08-03','07:15:00',1),('10318','2013-08-03','07:20:00',1.37),('10318','2013-08-03','07:25:00',1.59),('10318','2013-08-03','07:30:00',1.9),('10318','2013-08-03','07:35:00',2.05),('10318','2013-08-03','07:40:00',2.4),('10318','2013-08-03','07:45:00',2.66),('10318','2013-08-03','07:50:00',2.85),('10318','2013-08-03','07:55:00',3.04),('10318','2013-08-03','08:00:00',3.22),('10318','2013-08-03','08:05:00',3.42),('10318','2013-08-03','08:10:00',3.61),('10318','2013-08-03','08:15:00',3.72),('10318','2013-08-03','08:20:00',3.99),('10318','2013-08-03','08:25:00',4.17),('10318','2013-08-03','08:30:00',4.35),('10318','2013-08-03','08:35:00',4.53),('10318','2013-08-03','08:40:00',4.7),('10318','2013-08-03','08:45:00',4.87),('10318','2013-08-03','08:50:00',5.07),('10318','2013-08-03','08:55:00',5.2),('10318','2013-08-03','09:00:00',5.36),('10318','2013-08-03','09:05:00',5.52),('10318','2013-08-03','09:10:00',5.65),('10318','2013-08-03','09:15:00',5.79),('10318','2013-08-03','09:20:00',5.93),('10318','2013-08-03','09:25:00',6.06),('10318','2013-08-03','09:30:00',6.21),('10318','2013-08-03','09:35:00',6.29),('10318','2013-08-03','09:40:00',6.41),('10318','2013-08-03','09:45:00',6.53),('10318','2013-08-03','09:50:00',6.66),('10318','2013-08-03','09:55:00',6.76),('10318','2013-08-03','10:00:00',6.74),('10318','2013-08-03','10:05:00',6.95),('10318','2013-08-03','10:10:00',7.08),('10318','2013-08-03','10:15:00',7.14),('10318','2013-08-03','10:20:00',7.27),('10318','2013-08-03','10:25:00',7.4),('10318','2013-08-03','10:30:00',7.47),('10318','2013-08-03','10:35:00',7.53),('10318','2013-08-03','10:40:00',7.63),('10318','2013-08-03','10:45:00',7.84),('10318','2013-08-03','10:50:00',7.83),('10318','2013-08-03','10:55:00',7.91),('10318','2013-08-03','11:00:00',7.94),('10318','2013-08-03','11:05:00',8.01),('10318','2013-08-03','11:10:00',8.13),('10318','2013-08-03','11:15:00',8.13),('10318','2013-08-03','11:20:00',8.24),('10318','2013-08-03','11:25:00',8.23),('10318','2013-08-03','11:30:00',8.21),('10318','2013-08-03','11:35:00',8.29),('10318','2013-08-03','11:40:00',8.29),('10318','2013-08-03','11:45:00',8.24),('10318','2013-08-03','11:50:00',8.23),('10318','2013-08-03','11:55:00',8.3),('10318','2013-08-03','12:00:00',8.34),('10318','2013-08-03','12:05:00',8.33),('10318','2013-08-03','12:10:00',8.3),('10318','2013-08-03','12:15:00',8.37),('10318','2013-08-03','12:20:00',8.6),('10318','2013-08-03','12:25:00',8.52),('10318','2013-08-03','12:30:00',8.4),('10318','2013-08-03','12:35:00',8.51),('10318','2013-08-03','12:40:00',8.52),('10318','2013-08-03','12:45:00',8.39),('10318','2013-08-03','12:50:00',8.34),('10318','2013-08-03','12:55:00',8.35),('10318','2013-08-03','13:00:00',8.32),('10318','2013-08-03','13:05:00',8.31),('10318','2013-08-03','13:10:00',8.32),('10318','2013-08-03','13:15:00',8.23),('10318','2013-08-03','13:20:00',8.27),('10318','2013-08-03','13:25:00',8.28),('10318','2013-08-03','13:30:00',8.02),('10318','2013-08-03','13:35:00',8.32),('10318','2013-08-03','13:40:00',8.3),('10318','2013-08-03','13:45:00',8.2),('10318','2013-08-03','13:50:00',8.05),('10318','2013-08-03','13:55:00',7.95),('10318','2013-08-03','14:00:00',7.93),('10318','2013-08-03','14:05:00',7.79),('10318','2013-08-03','14:10:00',7.62),('10318','2013-08-03','14:15:00',7.66),('10318','2013-08-03','14:20:00',7.8),('10318','2013-08-03','14:25:00',7.87),('10318','2013-08-03','14:30:00',7.82),('10318','2013-08-03','14:35:00',7.74),('10318','2013-08-03','14:40:00',7.67),('10318','2013-08-03','14:45:00',7.64),('10318','2013-08-03','14:50:00',7.55),('10318','2013-08-03','14:55:00',7.47),('10318','2013-08-03','15:00:00',7.4),('10318','2013-08-03','15:05:00',7.32),('10318','2013-08-03','15:10:00',7.21),('10318','2013-08-03','15:15:00',7),('10318','2013-08-03','15:20:00',6.93),('10318','2013-08-03','15:25:00',6.83),('10318','2013-08-03','15:30:00',6.75),('10318','2013-08-03','15:35:00',6.63),('10318','2013-08-03','15:40:00',6.53),('10318','2013-08-03','15:45:00',6.45),('10318','2013-08-03','15:50:00',6.32),('10318','2013-08-03','15:55:00',6.2),('10318','2013-08-03','16:00:00',6.11),('10318','2013-08-03','16:05:00',5.96),('10318','2013-08-03','16:10:00',5.82),('10318','2013-08-03','16:15:00',5.65),('10318','2013-08-03','16:20:00',5.49),('10318','2013-08-03','16:25:00',5.36),('10318','2013-08-03','16:30:00',5.21),('10318','2013-08-03','16:35:00',4.96),('10318','2013-08-03','16:40:00',4.89),('10318','2013-08-03','16:45:00',4.73),('10318','2013-08-03','16:50:00',4.58),('10318','2013-08-03','16:55:00',4.44),('10318','2013-08-03','17:00:00',4.26),('10318','2013-08-03','17:05:00',4.07),('10318','2013-08-03','17:10:00',3.95),('10318','2013-08-03','17:15:00',3.77),('10318','2013-08-03','17:20:00',3.6),('10318','2013-08-03','17:25:00',3.43),('10318','2013-08-03','17:30:00',3.28),('10318','2013-08-03','17:35:00',3.1),('10318','2013-08-03','17:40:00',2.96),('10318','2013-08-03','17:45:00',2.78),('10318','2013-08-03','17:50:00',2.61),('10318','2013-08-03','17:55:00',2.43),('10318','2013-08-03','18:00:00',2.26),('10318','2013-08-03','18:05:00',2.11),('10318','2013-08-03','18:10:00',1.94),('10318','2013-08-03','18:15:00',1.8),('10318','2013-08-03','18:20:00',1.66),('10318','2013-08-03','18:25:00',1.53),('10318','2013-08-03','18:30:00',1.4),('10318','2013-08-03','18:35:00',1.28),('10318','2013-08-03','18:40:00',1.16),('10318','2013-08-03','18:45:00',1.04),('10318','2013-08-02','07:15:00',1.15),('10318','2013-08-02','07:20:00',1.5),('10318','2013-08-02','07:25:00',1.83),('10318','2013-08-02','07:30:00',1.86),('10318','2013-08-02','07:35:00',2.08),('10318','2013-08-02','07:40:00',2.57),('10318','2013-08-02','07:45:00',2.83),('10318','2013-08-02','07:50:00',3.03),('10318','2013-08-02','07:55:00',3.22),('10318','2013-08-02','08:00:00',3.4),('10318','2013-08-02','08:05:00',3.6),('10318','2013-08-02','08:10:00',3.79),('10318','2013-08-02','08:15:00',3.98),('10318','2013-08-02','08:20:00',4.17),('10318','2013-08-02','08:25:00',4.35),('10318','2013-08-02','08:30:00',4.47),('10318','2013-08-02','08:35:00',4.72),('10318','2013-08-02','08:40:00',4.9),('10318','2013-08-02','08:45:00',5.07),('10318','2013-08-02','08:50:00',5.24),('10318','2013-08-02','08:55:00',5.4),('10318','2013-08-02','09:00:00',5.56),('10318','2013-08-02','09:05:00',5.73),('10318','2013-08-02','09:10:00',5.87),('10318','2013-08-02','09:15:00',6.02),('10318','2013-08-02','09:20:00',6.17),('10318','2013-08-02','09:25:00',6.3),('10318','2013-08-02','09:30:00',6.41),('10318','2013-08-02','09:35:00',6.53),('10318','2013-08-02','09:40:00',6.63),('10318','2013-08-02','09:45:00',6.77),('10318','2013-08-02','09:50:00',6.87),('10318','2013-08-02','09:55:00',7),('10318','2013-08-02','10:00:00',7.1),('10318','2013-08-02','10:05:00',7.18),('10318','2013-08-02','10:10:00',7.27),('10318','2013-08-02','10:15:00',7.34),('10318','2013-08-02','10:20:00',7.45),('10318','2013-08-02','10:25:00',7.55),('10318','2013-08-02','10:30:00',7.65),('10318','2013-08-02','10:35:00',7.72),('10318','2013-08-02','10:40:00',7.79),('10318','2013-08-02','10:45:00',7.9),('10318','2013-08-02','10:50:00',7.99),('10318','2013-08-02','10:55:00',8.04),('10318','2013-08-02','11:00:00',8.08),('10318','2013-08-02','11:05:00',8.16),('10318','2013-08-02','11:10:00',8.23),('10318','2013-08-02','11:15:00',8.29),('10318','2013-08-02','11:20:00',8.39),('10318','2013-08-02','11:25:00',8.42),('10318','2013-08-02','11:30:00',8.4),('10318','2013-08-02','11:35:00',8.43),('10318','2013-08-02','11:40:00',8.42),('10318','2013-08-02','11:45:00',8.43),('10318','2013-08-02','11:50:00',8.47),('10318','2013-08-02','11:55:00',8.52),('10318','2013-08-02','12:00:00',8.54),('10318','2013-08-02','12:05:00',8.61),('10318','2013-08-02','12:10:00',8.6),('10318','2013-08-02','12:15:00',8.62),('10318','2013-08-02','12:20:00',8.67),('10318','2013-08-02','12:25:00',8.7),('10318','2013-08-02','12:30:00',8.68),('10318','2013-08-02','12:35:00',8.69),('10318','2013-08-02','12:40:00',8.66),('10318','2013-08-02','12:45:00',8.69),('10318','2013-08-02','12:50:00',8.68),('10318','2013-08-02','12:55:00',8.59),('10318','2013-08-02','13:00:00',8.58),('10318','2013-08-02','13:05:00',8.6),('10318','2013-08-02','13:10:00',8.7),('10318','2013-08-02','13:15:00',8.48),('10318','2013-08-02','13:20:00',8.62),('10318','2013-08-02','13:25:00',8.55),('10318','2013-08-02','13:30:00',8.42),('10318','2013-08-02','13:35:00',8.38),('10318','2013-08-02','13:40:00',8.37),('10318','2013-08-02','13:45:00',8.36),('10318','2013-08-02','13:50:00',8.34),('10318','2013-08-02','13:55:00',8.32),('10318','2013-08-02','14:00:00',8.32),('10318','2013-08-02','14:05:00',8.19),('10318','2013-08-02','14:10:00',8.13),('10318','2013-08-02','14:15:00',8.05),('10318','2013-08-02','14:20:00',7.97),('10318','2013-08-02','14:25:00',8.01),('10318','2013-08-02','14:30:00',7.91),('10318','2013-08-02','14:35:00',7.91),('10318','2013-08-02','14:40:00',7.88),('10318','2013-08-02','14:45:00',7.75),('10318','2013-08-02','14:50:00',7.63),('10318','2013-08-02','14:55:00',7.61),('10318','2013-08-02','15:00:00',7.31),('10318','2013-08-02','15:05:00',7.43),('10318','2013-08-02','15:10:00',7.3),('10318','2013-08-02','15:15:00',7.18),('10318','2013-08-02','15:20:00',7.09),('10318','2013-08-02','15:25:00',6.97),('10318','2013-08-02','15:30:00',6.93),('10318','2013-08-02','15:35:00',6.88),('10318','2013-08-02','15:40:00',6.74),('10318','2013-08-02','15:45:00',6.57),('10318','2013-08-02','15:50:00',6.46),('10318','2013-08-02','15:55:00',6.34),('10318','2013-08-02','16:00:00',6.15),('10318','2013-08-02','16:05:00',6.02),('10318','2013-08-02','16:10:00',5.88),('10318','2013-08-02','16:15:00',5.8),('10318','2013-08-02','16:20:00',5.67),('10318','2013-08-02','16:25:00',5.46),('10318','2013-08-02','16:30:00',5.3),('10318','2013-08-02','16:35:00',5.16),('10318','2013-08-02','16:40:00',5.03),('10318','2013-08-02','16:45:00',4.84),('10318','2013-08-02','16:50:00',4.73),('10318','2013-08-02','16:55:00',4.54),('10318','2013-08-02','17:00:00',4.38),('10318','2013-08-02','17:05:00',4.22),('10318','2013-08-02','17:10:00',4.02),('10318','2013-08-02','17:15:00',3.85),('10318','2013-08-02','17:20:00',3.7),('10318','2013-08-02','17:25:00',3.53),('10318','2013-08-02','17:30:00',3.36),('10318','2013-08-02','17:35:00',3.2),('10318','2013-08-02','17:40:00',3.02),('10318','2013-08-02','17:45:00',2.83),('10318','2013-08-02','17:50:00',2.66),('10318','2013-08-02','17:55:00',2.5),('10318','2013-08-02','18:00:00',2.3),('10318','2013-08-02','18:05:00',2.17),('10318','2013-08-02','18:10:00',2),('10318','2013-08-02','18:15:00',1.85),('10318','2013-08-02','18:20:00',1.7),('10318','2013-08-02','18:25:00',1.56),('10318','2013-08-02','18:30:00',1.43),('10318','2013-08-02','18:35:00',1.26),('10318','2013-08-02','18:40:00',1.17),('10318','2013-08-02','18:45:00',1.05),('10318','2013-08-01','07:15:00',1.24),('10318','2013-08-01','07:20:00',1.55),('10318','2013-08-01','07:25:00',1.82),('10318','2013-08-01','07:30:00',1.95),('10318','2013-08-01','07:35:00',2.09),('10318','2013-08-01','07:40:00',2.64),('10318','2013-08-01','07:45:00',2.85),('10318','2013-08-01','07:50:00',3.02),('10318','2013-08-01','07:55:00',3.18),('10318','2013-08-01','08:00:00',3.41),('10318','2013-08-01','08:05:00',3.61),('10318','2013-08-01','08:10:00',3.8),('10318','2013-08-01','08:15:00',3.98),('10318','2013-08-01','08:20:00',4.17),('10318','2013-08-01','08:25:00',4.34),('10318','2013-08-01','08:30:00',4.52),('10318','2013-08-01','08:35:00',4.7),('10318','2013-08-01','08:40:00',4.88),('10318','2013-08-01','08:45:00',5.09),('10318','2013-08-01','08:50:00',5.22),('10318','2013-08-01','08:55:00',5.38),('10318','2013-08-01','09:00:00',5.58),('10318','2013-08-01','09:05:00',5.76),('10318','2013-08-01','09:10:00',5.97),('10318','2013-08-01','09:15:00',6.1),('10318','2013-08-01','09:20:00',6.24),('10318','2013-08-01','09:25:00',6.4),('10318','2013-08-01','09:30:00',6.54),('10318','2013-08-01','09:35:00',6.65),('10318','2013-08-01','09:40:00',6.76),('10318','2013-08-01','09:45:00',6.91),('10318','2013-08-01','09:50:00',7.1),('10318','2013-08-01','09:55:00',7.23),('10318','2013-08-01','10:00:00',7.42),('10318','2013-08-01','10:05:00',7.57),('10318','2013-08-01','10:10:00',7.74),('10318','2013-08-01','10:15:00',7.84),('10318','2013-08-01','10:20:00',7.99),('10318','2013-08-01','10:25:00',8.12),('10318','2013-08-01','10:30:00',8.14),('10318','2013-08-01','10:35:00',8.28),('10318','2013-08-01','10:40:00',8.34),('10318','2013-08-01','10:45:00',8.4),('10318','2013-08-01','10:50:00',8.43),('10318','2013-08-01','10:55:00',8.55),('10318','2013-08-01','11:00:00',8.63),('10318','2013-08-01','11:05:00',8.72),('10318','2013-08-01','11:10:00',8.74),('10318','2013-08-01','11:15:00',8.84),('10318','2013-08-01','11:20:00',8.89),('10318','2013-08-01','11:25:00',8.96),('10318','2013-08-01','11:30:00',9.03),('10318','2013-08-01','11:35:00',9.06),('10318','2013-08-01','11:40:00',9.08),('10318','2013-08-01','11:45:00',9.16),('10318','2013-08-01','11:50:00',9.18),('10318','2013-08-01','11:55:00',9.16),('10318','2013-08-01','12:00:00',9.21),('10318','2013-08-01','12:05:00',9.22),('10318','2013-08-01','12:10:00',9.18),('10318','2013-08-01','12:15:00',8.91),('10318','2013-08-01','12:20:00',9.24),('10318','2013-08-01','12:25:00',9.02),('10318','2013-08-01','12:30:00',9.32),('10318','2013-08-01','12:35:00',9.26),('10318','2013-08-01','12:40:00',9.23),('10318','2013-08-01','12:45:00',8.62),('10318','2013-08-01','12:50:00',9.28),('10318','2013-08-01','12:55:00',9.27),('10318','2013-08-01','13:00:00',9.15),('10318','2013-08-01','13:05:00',9.32),('10318','2013-08-01','13:10:00',9.33),('10318','2013-08-01','13:15:00',9.37),('10318','2013-08-01','13:20:00',9.3),('10318','2013-08-01','13:25:00',9.22),('10318','2013-08-01','13:30:00',9.14),('10318','2013-08-01','13:35:00',9.13),('10318','2013-08-01','13:40:00',9.12),('10318','2013-08-01','13:45:00',9.1),('10318','2013-08-01','13:50:00',9.08),('10318','2013-08-01','13:55:00',9.03),('10318','2013-08-01','14:00:00',8.63),('10318','2013-08-01','14:05:00',8.71),('10318','2013-08-01','14:10:00',8.64),('10318','2013-08-01','14:15:00',8.66),('10318','2013-08-01','14:20:00',8.59),('10318','2013-08-01','14:25:00',8.47),('10318','2013-08-01','14:30:00',8.38),('10318','2013-08-01','14:35:00',8.38),('10318','2013-08-01','14:40:00',8.28),('10318','2013-08-01','14:45:00',8.2),('10318','2013-08-01','14:50:00',8.06),('10318','2013-08-01','14:55:00',7.81),('10318','2013-08-01','15:00:00',7.77),('10318','2013-08-01','15:05:00',7.73),('10318','2013-08-01','15:10:00',7.68),('10318','2013-08-01','15:15:00',7.59),('10318','2013-08-01','15:20:00',7.44),('10318','2013-08-01','15:25:00',7.3),('10318','2013-08-01','15:30:00',7.23),('10318','2013-08-01','15:35:00',7.1),('10318','2013-08-01','15:40:00',5.55),('10318','2013-08-01','15:45:00',6.51),('10318','2013-08-01','15:50:00',6.79),('10318','2013-08-01','15:55:00',6.62),('10318','2013-08-01','16:00:00',6.53),('10318','2013-08-01','16:05:00',6.37),('10318','2013-08-01','16:10:00',6.19),('10318','2013-08-01','16:15:00',6.02),('10318','2013-08-01','16:20:00',5.83),('10318','2013-08-01','16:25:00',5.69),('10318','2013-08-01','16:30:00',5.5),('10318','2013-08-01','16:35:00',5.33),('10318','2013-08-01','16:40:00',5.14),('10318','2013-08-01','16:45:00',4.96),('10318','2013-08-01','16:50:00',4.79),('10318','2013-08-01','16:55:00',4.61),('10318','2013-08-01','17:00:00',4.44),('10318','2013-08-01','17:05:00',4.24),('10318','2013-08-01','17:10:00',4.09),('10318','2013-08-01','17:15:00',3.94),('10318','2013-08-01','17:20:00',3.76),('10318','2013-08-01','17:25:00',3.56),('10318','2013-08-01','17:30:00',3.33),('10318','2013-08-01','17:35:00',3.22),('10318','2013-08-01','17:40:00',3.05),('10318','2013-08-01','17:45:00',2.87),('10318','2013-08-01','17:50:00',2.7),('10318','2013-08-01','17:55:00',2.52),('10318','2013-08-01','18:00:00',2.34),('10318','2013-08-01','18:05:00',2.19),('10318','2013-08-01','18:10:00',2.03),('10318','2013-08-01','18:15:00',1.87),('10318','2013-08-01','18:20:00',1.72),('10318','2013-08-01','18:25:00',1.57),('10318','2013-08-01','18:30:00',1.42),('10318','2013-08-01','18:35:00',1.29),('10318','2013-08-01','18:40:00',1.15),('10318','2013-08-01','18:45:00',1.03),('10318','2013-07-31','07:15:00',1.29),('10318','2013-07-31','07:20:00',1.56),('10318','2013-07-31','07:25:00',1.76),('10318','2013-07-31','07:30:00',2.05),('10318','2013-07-31','07:35:00',2.14),('10318','2013-07-31','07:40:00',2.69),('10318','2013-07-31','07:45:00',2.9),('10318','2013-07-31','07:50:00',3.1),('10318','2013-07-31','07:55:00',3.3),('10318','2013-07-31','08:00:00',3.53),('10318','2013-07-31','08:05:00',3.73),('10318','2013-07-31','08:10:00',3.9),('10318','2013-07-31','08:15:00',4.09),('10318','2013-07-31','08:20:00',4.29),('10318','2013-07-31','08:25:00',4.46),('10318','2013-07-31','08:30:00',4.63),('10318','2013-07-31','08:35:00',4.82),('10318','2013-07-31','08:40:00',4.98),('10318','2013-07-31','08:45:00',5.14),('10318','2013-07-31','08:50:00',5.29),('10318','2013-07-31','08:55:00',5.43),('10318','2013-07-31','09:00:00',5.64),('10318','2013-07-31','09:05:00',5.79),('10318','2013-07-31','09:10:00',5.86),('10318','2013-07-31','09:15:00',6.09),('10318','2013-07-31','09:20:00',6.22),('10318','2013-07-31','09:25:00',6.34),('10318','2013-07-31','09:30:00',6.45),('10318','2013-07-31','09:35:00',6.59),('10318','2013-07-31','09:40:00',6.71),('10318','2013-07-31','09:45:00',6.84),('10318','2013-07-31','09:50:00',6.96),('10318','2013-07-31','09:55:00',7.1),('10318','2013-07-31','10:00:00',7.2),('10318','2013-07-31','10:05:00',7.28),('10318','2013-07-31','10:10:00',7.41),('10318','2013-07-31','10:15:00',7.52),('10318','2013-07-31','10:20:00',7.69),('10318','2013-07-31','10:25:00',7.82),('10318','2013-07-31','10:30:00',7.77),('10318','2013-07-31','10:35:00',8.01),('10318','2013-07-31','10:40:00',8.05),('10318','2013-07-31','10:45:00',8.17),('10318','2013-07-31','10:50:00',8.18),('10318','2013-07-31','10:55:00',8.26),('10318','2013-07-31','11:00:00',8.49),('10318','2013-07-31','11:05:00',8.6),('10318','2013-07-31','11:10:00',8.64),('10318','2013-07-31','11:15:00',8.74),('10318','2013-07-31','11:20:00',8.81),('10318','2013-07-31','11:25:00',8.84),('10318','2013-07-31','11:30:00',8.89),('10318','2013-07-31','11:35:00',8.83),('10318','2013-07-31','11:40:00',8.86),('10318','2013-07-31','11:45:00',8.65),('10318','2013-07-31','11:50:00',8.87),('10318','2013-07-31','11:55:00',8.43),('10318','2013-07-31','12:00:00',8.97),('10318','2013-07-31','12:05:00',9),('10318','2013-07-31','12:10:00',9.17),('10318','2013-07-31','12:15:00',6.09),('10318','2013-07-31','12:20:00',8.81),('10318','2013-07-31','12:25:00',8.81),('10318','2013-07-31','12:30:00',8.2),('10318','2013-07-31','12:35:00',8.92),('10318','2013-07-31','12:40:00',6.21),('10318','2013-07-31','12:45:00',9.24),('10318','2013-07-31','12:50:00',9.67),('10318','2013-07-31','12:55:00',9.44),('10318','2013-07-31','13:00:00',9.37),('10318','2013-07-31','13:05:00',9.35),('10318','2013-07-31','13:10:00',9.28),('10318','2013-07-31','13:15:00',9.23),('10318','2013-07-31','13:20:00',7.39),('10318','2013-07-31','13:25:00',9.14),('10318','2013-07-31','13:30:00',9.17),('10318','2013-07-31','13:35:00',9.05),('10318','2013-07-31','13:40:00',8.94),('10318','2013-07-31','13:45:00',8.95),('10318','2013-07-31','13:50:00',9),('10318','2013-07-31','13:55:00',9.02),('10318','2013-07-31','14:00:00',8.85),('10318','2013-07-31','14:05:00',8.79),('10318','2013-07-31','14:10:00',8.79),('10318','2013-07-31','14:15:00',8.8),('10318','2013-07-31','14:20:00',8.65),('10318','2013-07-31','14:25:00',8.39),('10318','2013-07-31','14:30:00',7.78),('10318','2013-07-31','14:35:00',8.48),('10318','2013-07-31','14:40:00',8.45),('10318','2013-07-31','14:45:00',8.23),('10318','2013-07-31','14:50:00',8.19),('10318','2013-07-31','14:55:00',8.26),('10318','2013-07-31','15:00:00',8.07),('10318','2013-07-31','15:05:00',7.87),('10318','2013-07-31','15:10:00',7.7),('10318','2013-07-31','15:15:00',7.75),('10318','2013-07-31','15:20:00',7.55),('10318','2013-07-31','15:25:00',7.45),('10318','2013-07-31','15:30:00',7.25),('10318','2013-07-31','15:35:00',7.17),('10318','2013-07-31','15:40:00',7.08),('10318','2013-07-31','15:45:00',6.61),('10318','2013-07-31','15:50:00',6.61),('10318','2013-07-31','15:55:00',6.49),('10318','2013-07-31','16:00:00',6.35),('10318','2013-07-31','16:05:00',6.22),('10318','2013-07-31','16:10:00',6.15),('10318','2013-07-31','16:15:00',5.94),('10318','2013-07-31','16:20:00',5.9),('10318','2013-07-31','16:25:00',5.87),('10318','2013-07-31','16:30:00',5.64),('10318','2013-07-31','16:35:00',5.33),('10318','2013-07-31','16:40:00',5.19),('10318','2013-07-31','16:45:00',4.98),('10318','2013-07-31','16:50:00',4.86),('10318','2013-07-31','16:55:00',4.75),('10318','2013-07-31','17:00:00',4.24),('10318','2013-07-31','17:05:00',2.29),('10318','2013-07-31','17:10:00',1.77),('10318','2013-07-31','17:15:00',3.95),('10318','2013-07-31','17:20:00',3.86),('10318','2013-07-31','17:25:00',3.62),('10318','2013-07-31','17:30:00',3.37),('10318','2013-07-31','17:35:00',3.14),('10318','2013-07-31','17:40:00',3.06),('10318','2013-07-31','17:45:00',2.91),('10318','2013-07-31','17:50:00',2.71),('10318','2013-07-31','17:55:00',2.54),('10318','2013-07-31','18:00:00',2.35),('10318','2013-07-31','18:05:00',2.21),('10318','2013-07-31','18:10:00',2.07),('10318','2013-07-31','18:15:00',1.92),('10318','2013-07-31','18:20:00',1.76),('10318','2013-07-31','18:25:00',1.62),('10318','2013-07-31','18:30:00',1.47),('10318','2013-07-31','18:35:00',1.33),('10318','2013-07-31','18:40:00',1.2),('10318','2013-07-31','18:45:00',1.06),('10318','2014-04-08','07:45:00',1.52),('10318','2014-04-08','07:50:00',1.55),('10318','2014-04-08','07:55:00',1.47),('10318','2014-04-08','08:00:00',1.56),('10318','2014-04-08','08:05:00',1.62),('10318','2014-04-08','08:10:00',2.7),('10318','2014-04-08','08:15:00',3.35),('10318','2014-04-08','08:20:00',2.16),('10318','2014-04-08','08:25:00',3.89),('10318','2014-04-08','08:30:00',3.39),('10318','2014-04-08','08:35:00',2.94),('10318','2014-04-08','08:40:00',4.46),('10318','2014-04-08','08:45:00',4.4),('10318','2014-04-08','08:50:00',4.74),('10318','2014-04-08','08:55:00',5.07),('10318','2014-04-08','09:00:00',5.2),('10318','2014-04-08','09:05:00',5.4),('10318','2014-04-08','09:10:00',5.58),('10318','2014-04-08','09:15:00',5.74),('10318','2014-04-08','09:20:00',5.9),('10318','2014-04-08','09:25:00',6.07),('10318','2014-04-08','09:30:00',4.63),('10318','2014-04-08','09:35:00',6.23),('10318','2014-04-08','09:40:00',6.31),('10318','2014-04-08','09:45:00',6.53),('10318','2014-04-08','09:50:00',6.64),('10318','2014-04-08','09:55:00',6.76),('10318','2014-04-08','10:00:00',6.74),('10318','2014-04-08','10:05:00',6.94),('10318','2014-04-08','10:10:00',7.44),('10318','2014-04-08','10:15:00',7.52),('10318','2014-04-08','10:20:00',7.6),('10318','2014-04-08','10:25:00',7.71),('10318','2014-04-08','10:30:00',7.77),('10318','2014-04-08','10:35:00',7.87),('10318','2014-04-08','10:40:00',7.97),('10318','2014-04-08','10:45:00',8.09),('10318','2014-04-08','10:50:00',8.2),('10318','2014-04-08','10:55:00',8.26),('10318','2014-04-08','11:00:00',8.3),('10318','2014-04-08','11:05:00',8.26),('10318','2014-04-08','11:10:00',8.49),('10318','2014-04-08','11:15:00',8.48),('10318','2014-04-08','11:20:00',8.51),('10318','2014-04-08','11:25:00',8.36),('10318','2014-04-08','11:30:00',7.94),('10318','2014-04-08','11:35:00',8.54),('10318','2014-04-08','11:40:00',8.81),('10318','2014-04-08','11:45:00',8.78),('10318','2014-04-08','11:50:00',8.51),('10318','2014-04-08','11:55:00',9.03),('10318','2014-04-08','12:00:00',9),('10318','2014-04-08','12:05:00',8.51),('10318','2014-04-08','12:10:00',8.25),('10318','2014-04-08','12:15:00',7.82),('10318','2014-04-08','12:20:00',8.02),('10318','2014-04-08','12:25:00',8.29),('10318','2014-04-08','12:30:00',8.09),('10318','2014-04-08','12:35:00',8.64),('10318','2014-04-08','12:40:00',7.14),('10318','2014-04-08','12:45:00',7.67),('10318','2014-04-08','12:50:00',7.94),('10318','2014-04-08','12:55:00',9.08),('10318','2014-04-08','13:00:00',8.72),('10318','2014-04-08','13:05:00',9.09),('10318','2014-04-08','13:10:00',9.15),('10318','2014-04-08','13:15:00',9.28),('10318','2014-04-08','13:20:00',9.28),('10318','2014-04-08','13:25:00',9.23),('10318','2014-04-08','13:30:00',9.27),('10318','2014-04-08','13:35:00',9.24),('10318','2014-04-08','13:40:00',9.16),('10318','2014-04-08','13:45:00',8.99),('10318','2014-04-08','13:50:00',8.92),('10318','2014-04-08','13:55:00',8.88),('10318','2014-04-08','14:00:00',8.85),('10318','2014-04-08','14:05:00',8.66),('10318','2014-04-08','14:10:00',8.82),('10318','2014-04-08','14:15:00',8.73),('10318','2014-04-08','14:20:00',7.78),('10318','2014-04-08','14:25:00',8),('10318','2014-04-08','14:30:00',8.55),('10318','2014-04-08','14:35:00',8.04),('10318','2014-04-08','14:40:00',6.93),('10318','2014-04-08','14:45:00',7.94),('10318','2014-04-08','14:50:00',8.03),('10318','2014-04-08','14:55:00',8.03),('10318','2014-04-08','15:00:00',7.74),('10318','2014-04-08','15:05:00',7.61),('10318','2014-04-08','15:10:00',7.48),('10318','2014-04-08','15:15:00',7.31),('10318','2014-04-08','15:20:00',7.19),('10318','2014-04-08','15:25:00',7.31),('10318','2014-04-08','15:30:00',7.1),('10318','2014-04-08','15:35:00',6.93),('10318','2014-04-08','15:40:00',6.57),('10318','2014-04-08','15:45:00',6.44),('10318','2014-04-08','15:50:00',6.36),('10318','2014-04-08','15:55:00',6.21),('10318','2014-04-08','16:00:00',5.99),('10318','2014-04-08','16:05:00',5.96),('10318','2014-04-08','16:10:00',5.53),('10318','2014-04-08','16:15:00',5.36),('10318','2014-04-08','16:20:00',4.85),('10318','2014-04-08','16:25:00',5.13),('10318','2014-04-08','16:30:00',5.3),('10318','2014-04-08','16:35:00',4.86),('10318','2014-04-08','16:40:00',4.77),('10318','2014-04-08','16:45:00',4.52),('10318','2014-04-08','16:50:00',4.45),('10318','2014-04-08','16:55:00',4),('10318','2014-04-08','17:00:00',3.94),('10318','2014-04-08','17:05:00',3.8),('10318','2014-04-08','17:10:00',3.6),('10318','2014-04-08','17:15:00',3.4),('10318','2014-04-08','17:20:00',3.14),('10318','2014-04-08','17:25:00',2.89),('10318','2014-04-08','17:30:00',2.58),('10318','2014-04-08','17:35:00',2.51),('10318','2014-04-08','17:40:00',2.38),('10318','2014-04-08','17:45:00',2.32),('10318','2014-04-08','17:50:00',2.15),('10318','2014-04-08','17:55:00',1.89),('10318','2014-04-08','18:00:00',1.87),('10318','2014-04-08','18:05:00',1.73),('10318','2014-04-08','18:10:00',1.6),('10318','2014-04-08','18:15:00',1.49),('10318','2014-04-08','18:20:00',1.32),('10318','2014-04-08','18:25:00',1.05),('10318','2013-07-30','07:40:00',2.47),('10318','2013-07-30','07:45:00',2.98),('10318','2013-07-30','07:50:00',3.06),('10318','2013-07-30','07:55:00',3.11),('10318','2013-07-30','08:00:00',3.45),('10318','2013-07-30','08:05:00',3.77),('10318','2013-07-30','08:10:00',3.92),('10318','2013-07-30','08:15:00',4.13),('10318','2013-07-30','08:20:00',4.13),('10318','2013-07-30','08:25:00',4.25),('10318','2013-07-30','08:30:00',4.49),('10318','2013-07-30','08:35:00',4.56),('10318','2013-07-30','08:40:00',4.69),('10318','2013-07-30','08:45:00',5.14),('10318','2013-07-30','08:50:00',5.37),('10318','2013-07-30','08:55:00',5.7),('10318','2013-07-30','09:00:00',6.01),('10318','2013-07-30','09:05:00',6.11),('10318','2013-07-30','09:10:00',3.44),('10318','2013-07-30','09:15:00',5.33),('10318','2013-07-30','09:20:00',6.69),('10318','2013-07-30','09:25:00',6.8),('10318','2013-07-30','09:30:00',6.74),('10318','2013-07-30','09:35:00',6.97),('10318','2013-07-30','09:40:00',7.25),('10318','2013-07-30','09:45:00',7.48),('10318','2013-07-30','09:50:00',7.6),('10318','2013-07-30','09:55:00',7.62),('10318','2013-07-30','10:00:00',7.34),('10318','2013-07-30','10:05:00',7.91),('10318','2013-07-30','10:10:00',8.18),('10318','2013-07-30','10:15:00',8.29),('10318','2013-07-30','10:20:00',7.91),('10318','2013-07-30','10:25:00',8.12),('10318','2013-07-30','10:30:00',8.4),('10318','2013-07-30','10:35:00',8.24),('10318','2013-07-30','10:40:00',8.38),('10318','2013-07-30','10:45:00',6.26),('10318','2013-07-30','10:50:00',7.71),('10318','2013-07-30','10:55:00',8.54),('10318','2013-07-30','11:00:00',8.7),('10318','2013-07-30','11:05:00',8.49),('10318','2013-07-30','11:10:00',7.04),('10318','2013-07-30','11:15:00',8.57),('10318','2013-07-30','11:20:00',8.81),('10318','2013-07-30','11:25:00',8.72),('10318','2013-07-30','11:30:00',8.67),('10318','2013-07-30','11:35:00',8.75),('10318','2013-07-30','11:40:00',8.93),('10318','2013-07-30','11:45:00',8.99),('10318','2013-07-30','11:50:00',8.95),('10318','2013-07-30','11:55:00',8.34),('10318','2013-07-30','12:00:00',8.84),('10318','2013-07-30','12:05:00',6.82),('10318','2013-07-30','12:10:00',8.22),('10318','2013-07-30','12:15:00',8.81),('10318','2013-07-30','12:20:00',8.95),('10318','2013-07-30','12:25:00',6.63),('10318','2013-07-30','12:30:00',9.13),('10318','2013-07-30','12:35:00',9.23),('10318','2013-07-30','12:40:00',3.31),('10318','2013-07-30','12:45:00',4.04),('10318','2013-07-30','12:50:00',6.79),('10318','2013-07-30','12:55:00',2.59),('10318','2013-07-30','13:00:00',2.53),('10318','2013-07-30','13:05:00',2.88),('10318','2013-07-30','13:10:00',4.17),('10318','2013-07-30','13:15:00',5.35),('10318','2013-07-30','13:20:00',9.07),('10318','2013-07-30','13:25:00',9.53),('10318','2013-07-30','13:30:00',9.34),('10318','2013-07-30','13:35:00',9.31),('10318','2013-07-30','13:40:00',9.3),('10318','2013-07-30','13:45:00',9.49),('10318','2013-07-30','13:50:00',9.11),('10318','2013-07-30','13:55:00',8.89),('10318','2013-07-30','14:00:00',8.9),('10318','2013-07-30','14:05:00',8.67),('10318','2013-07-30','14:10:00',8.41),('10318','2013-07-30','14:15:00',8.41),('10318','2013-07-30','14:20:00',8.44),('10318','2013-07-30','14:25:00',8.46),('10318','2013-07-30','14:30:00',8.25),('10318','2013-07-30','14:35:00',8.15),('10318','2013-07-30','14:40:00',8.2),('10318','2013-07-30','14:45:00',7.83),('10318','2013-07-30','14:50:00',7.99),('10318','2013-07-30','14:55:00',7.84),('10318','2013-07-30','15:00:00',7.64),('10318','2013-07-30','15:05:00',7.49),('10318','2013-07-30','15:10:00',7.51),('10318','2013-07-30','15:15:00',7.36),('10318','2013-07-30','15:20:00',7.27),('10318','2013-07-30','15:25:00',7.17),('10318','2013-07-30','15:30:00',7.05),('10318','2013-07-30','15:35:00',6.92),('10318','2013-07-30','15:40:00',6.82),('10318','2013-07-30','15:45:00',6.7),('10318','2013-07-30','15:50:00',6.56),('10318','2013-07-30','15:55:00',6.36),('10318','2013-07-30','16:00:00',6.25),('10318','2013-07-30','16:05:00',6.12),('10318','2013-07-30','16:10:00',5.93),('10318','2013-07-30','16:15:00',5.77),('10318','2013-07-30','16:20:00',5.59),('10318','2013-07-30','16:25:00',5.43),('10318','2013-07-30','16:30:00',5.22),('10318','2013-07-30','16:35:00',5.18),('10318','2013-07-30','16:40:00',5.04),('10318','2013-07-30','16:45:00',4.89),('10318','2013-07-30','16:50:00',4.72),('10318','2013-07-30','16:55:00',4.57),('10318','2013-07-30','17:00:00',4.38),('10318','2013-07-30','17:05:00',4.24),('10318','2013-07-30','17:10:00',4.1),('10318','2013-07-30','17:15:00',3.89),('10318','2013-07-30','17:20:00',3.65),('10318','2013-07-30','17:25:00',3.53),('10318','2013-07-30','17:30:00',3.37),('10318','2013-07-30','17:35:00',3.18),('10318','2013-07-30','17:40:00',2.99),('10318','2013-07-30','17:45:00',2.81),('10318','2013-07-30','17:50:00',2.68),('10318','2013-07-30','17:55:00',2.51),('10318','2013-07-30','18:00:00',2.32),('10318','2013-07-30','18:05:00',2.16),('10318','2013-07-30','18:10:00',2.03),('10318','2013-07-30','18:15:00',1.88),('10318','2013-07-30','18:20:00',1.73),('10318','2013-07-30','18:25:00',1.6),('10318','2013-07-30','18:30:00',1.47),('10318','2013-07-30','18:35:00',1.32),('10318','2013-07-30','18:40:00',1.21),('10318','2013-07-30','18:45:00',1.11),('10318','2013-07-30','18:50:00',1.01),('10318','2013-07-29','07:15:00',1.18),('10318','2013-07-29','07:20:00',1.43),('10318','2013-07-29','07:25:00',1.62),('10318','2013-07-29','07:30:00',1.79),('10318','2013-07-29','07:35:00',2.05),('10318','2013-07-29','07:40:00',2.32),('10318','2013-07-29','07:45:00',2.49),('10318','2013-07-29','07:50:00',2.65),('10318','2013-07-29','07:55:00',2.84),('10318','2013-07-29','08:00:00',3.04),('10318','2013-07-29','08:05:00',3.25),('10318','2013-07-29','08:10:00',3.37),('10318','2013-07-29','08:15:00',3.6),('10318','2013-07-29','08:20:00',3.79),('10318','2013-07-29','08:25:00',3.96),('10318','2013-07-29','08:30:00',4.12),('10318','2013-07-29','08:35:00',4.31),('10318','2013-07-29','08:40:00',4.45),('10318','2013-07-29','08:45:00',4.6),('10318','2013-07-29','08:50:00',4.73),('10318','2013-07-29','08:55:00',4.87),('10318','2013-07-29','09:00:00',4.99),('10318','2013-07-29','09:05:00',5.16),('10318','2013-07-29','09:10:00',5.35),('10318','2013-07-29','09:15:00',5.46),('10318','2013-07-29','09:20:00',5.59),('10318','2013-07-29','09:25:00',5.66),('10318','2013-07-29','09:30:00',5.81),('10318','2013-07-29','09:35:00',6.06),('10318','2013-07-29','09:40:00',6.21),('10318','2013-07-29','09:45:00',6.35),('10318','2013-07-29','09:50:00',6.39),('10318','2013-07-29','09:55:00',6.53),('10318','2013-07-29','10:00:00',6.83),('10318','2013-07-29','10:05:00',6.9),('10318','2013-07-29','10:10:00',6.92),('10318','2013-07-29','10:15:00',7.08),('10318','2013-07-29','10:20:00',7.24),('10318','2013-07-29','10:25:00',7.34),('10318','2013-07-29','10:30:00',7.38),('10318','2013-07-29','10:35:00',7.46),('10318','2013-07-29','10:40:00',7.56),('10318','2013-07-29','10:45:00',7.57),('10318','2013-07-29','10:50:00',7.63),('10318','2013-07-29','10:55:00',7.7),('10318','2013-07-29','11:00:00',7.78),('10318','2013-07-29','11:05:00',7.81),('10318','2013-07-29','11:10:00',7.73),('10318','2013-07-29','11:15:00',8),('10318','2013-07-29','11:20:00',8.03),('10318','2013-07-29','11:25:00',8.07),('10318','2013-07-29','11:30:00',8.2),('10318','2013-07-29','11:35:00',8.22),('10318','2013-07-29','11:40:00',8.2),('10318','2013-07-29','11:45:00',8.16),('10318','2013-07-29','11:50:00',8.22),('10318','2013-07-29','11:55:00',8.34),('10318','2013-07-29','12:00:00',8.37),('10318','2013-07-29','12:05:00',8.45),('10318','2013-07-29','12:10:00',8.47),('10318','2013-07-29','12:15:00',8.52),('10318','2013-07-29','12:20:00',8.48),('10318','2013-07-29','12:25:00',8.47),('10318','2013-07-29','12:30:00',8.44),('10318','2013-07-29','12:35:00',8.35),('10318','2013-07-29','12:40:00',8.33),('10318','2013-07-29','12:45:00',8.32),('10318','2013-07-29','12:50:00',8.27),('10318','2013-07-29','12:55:00',8.33),('10318','2013-07-29','13:00:00',7.35),('10318','2013-07-29','13:05:00',8.58),('10318','2013-07-29','13:10:00',8.47),('10318','2013-07-29','13:15:00',8.43),('10318','2013-07-29','13:20:00',8.52),('10318','2013-07-29','13:25:00',8.46),('10318','2013-07-29','13:30:00',8.52),('10318','2013-07-29','13:35:00',8.52),('10318','2013-07-29','13:40:00',8.48),('10318','2013-07-29','13:45:00',8.48),('10318','2013-07-29','13:50:00',8.42),('10318','2013-07-29','13:55:00',8.39),('10318','2013-07-29','14:00:00',8.32),('10318','2013-07-29','14:05:00',8.27),('10318','2013-07-29','14:10:00',8.24),('10318','2013-07-29','14:15:00',8.19),('10318','2013-07-29','14:20:00',8.11),('10318','2013-07-29','14:25:00',8.02),('10318','2013-07-29','14:30:00',7.95),('10318','2013-07-29','14:35:00',7.84),('10318','2013-07-29','14:40:00',7.8),('10318','2013-07-29','14:45:00',7.56),('10318','2013-07-29','14:50:00',7.64),('10318','2013-07-29','14:55:00',7.54),('10318','2013-07-29','15:00:00',7.43),('10318','2013-07-29','15:05:00',7.34),('10318','2013-07-29','15:10:00',7.27),('10318','2013-07-29','15:15:00',7.06),('10318','2013-07-29','15:20:00',7.1),('10318','2013-07-29','15:25:00',6.99),('10318','2013-07-29','15:30:00',6.92),('10318','2013-07-29','15:35:00',6.85),('10318','2013-07-29','15:40:00',6.94),('10318','2013-07-29','15:45:00',5.64),('10318','2013-07-29','15:50:00',5.19),('10318','2013-07-29','15:55:00',3.5),('10318','2013-07-29','16:00:00',3.84),('10318','2013-07-29','16:05:00',6.68),('10318','2013-07-29','16:10:00',5.86),('10318','2013-07-29','16:15:00',5.38),('10318','2013-07-29','16:20:00',4.49),('10318','2013-07-29','16:25:00',5.21),('10318','2013-07-29','16:30:00',5.65),('10318','2013-07-29','16:35:00',4.64),('10318','2013-07-29','16:40:00',5.45),('10318','2013-07-29','16:45:00',5.33),('10318','2013-07-29','16:50:00',3.96),('10318','2013-07-29','16:55:00',2.94),('10318','2013-07-29','17:00:00',2.66),('10318','2013-07-29','17:05:00',3.9),('10318','2013-07-29','17:10:00',2.63),('10318','2013-07-29','17:15:00',3.24),('10318','2013-07-29','17:20:00',4),('10318','2013-07-29','17:25:00',2.98),('10318','2013-07-29','17:30:00',1.87),('10318','2013-07-29','17:35:00',1.44),('10318','2013-07-29','17:40:00',2.33),('10318','2013-07-29','17:45:00',3.24),('10318','2013-07-29','17:50:00',2.53),('10318','2013-07-29','17:55:00',2.12),('10318','2013-07-29','18:00:00',1.33),('10318','2013-07-29','18:05:00',1.72),('10318','2013-07-29','18:10:00',2.07),('10318','2013-07-29','18:15:00',1.77),('10318','2013-07-29','18:20:00',1.87),('10318','2013-07-29','18:25:00',1.89),('10318','2013-07-29','18:30:00',1.65),('10318','2013-07-29','18:35:00',1.43),('10318','2013-07-29','18:55:00',1.12),('10318','2013-07-29','19:00:00',1.24),('10318','2013-07-29','19:05:00',1.15),('10318','2013-07-28','07:15:00',1.21),('10318','2013-07-28','07:20:00',1.47),('10318','2013-07-28','07:25:00',1.68),('10318','2013-07-28','07:30:00',1.76),('10318','2013-07-28','07:35:00',2.06),('10318','2013-07-28','07:40:00',2.31),('10318','2013-07-28','07:45:00',2.47),('10318','2013-07-28','07:50:00',2.67),('10318','2013-07-28','07:55:00',2.86),('10318','2013-07-28','08:00:00',3.06),('10318','2013-07-28','08:05:00',3.23),('10318','2013-07-28','08:10:00',3.29),('10318','2013-07-28','08:15:00',3.58),('10318','2013-07-28','08:20:00',3.73),('10318','2013-07-28','08:25:00',3.92),('10318','2013-07-28','08:30:00',4.12),('10318','2013-07-28','08:35:00',4.32),('10318','2013-07-28','08:40:00',4.49),('10318','2013-07-28','08:45:00',4.67),('10318','2013-07-28','08:50:00',4.86),('10318','2013-07-28','08:55:00',5),('10318','2013-07-28','09:00:00',5.2),('10318','2013-07-28','09:05:00',5.35),('10318','2013-07-28','09:10:00',5.5),('10318','2013-07-28','09:15:00',5.65),('10318','2013-07-28','09:20:00',5.82),('10318','2013-07-28','09:25:00',5.97),('10318','2013-07-28','09:30:00',6.07),('10318','2013-07-28','09:35:00',6.17),('10318','2013-07-28','09:40:00',6.38),('10318','2013-07-28','09:45:00',6.44),('10318','2013-07-28','09:50:00',6.58),('10318','2013-07-28','09:55:00',6.56),('10318','2013-07-28','10:00:00',6.76),('10318','2013-07-28','10:05:00',6.87),('10318','2013-07-28','10:10:00',7.02),('10318','2013-07-28','10:15:00',7.11),('10318','2013-07-28','10:20:00',7.22),('10318','2013-07-28','10:25:00',7.28),('10318','2013-07-28','10:30:00',7.4),('10318','2013-07-28','10:35:00',7.51),('10318','2013-07-28','10:40:00',7.59),('10318','2013-07-28','10:45:00',7.63),('10318','2013-07-28','10:50:00',7.72),('10318','2013-07-28','10:55:00',7.83),('10318','2013-07-28','11:00:00',7.93),('10318','2013-07-28','11:05:00',8),('10318','2013-07-28','11:10:00',7.97),('10318','2013-07-28','11:15:00',8.05),('10318','2013-07-28','11:20:00',8.13),('10318','2013-07-28','11:25:00',8.13),('10318','2013-07-28','11:30:00',8.09),('10318','2013-07-28','11:35:00',8.05),('10318','2013-07-28','11:40:00',7.99),('10318','2013-07-28','11:45:00',8.08),('10318','2013-07-28','11:50:00',7.96),('10318','2013-07-28','11:55:00',8.24),('10318','2013-07-28','12:00:00',8.18),('10318','2013-07-28','12:05:00',8.22),('10318','2013-07-28','12:10:00',8.32),('10318','2013-07-28','12:15:00',8.5),('10318','2013-07-28','12:20:00',8.46),('10318','2013-07-28','12:25:00',8.38),('10318','2013-07-28','12:30:00',8.47),('10318','2013-07-28','12:35:00',8.56),('10318','2013-07-28','12:40:00',8.5),('10318','2013-07-28','12:45:00',8.56),('10318','2013-07-28','12:50:00',8.75),('10318','2013-07-28','12:55:00',8.66),('10318','2013-07-28','13:00:00',8.73),('10318','2013-07-28','13:05:00',8.54),('10318','2013-07-28','13:10:00',8.48),('10318','2013-07-28','13:15:00',8.48),('10318','2013-07-28','13:20:00',8.65),('10318','2013-07-28','13:25:00',8.58),('10318','2013-07-28','13:30:00',8.52),('10318','2013-07-28','13:35:00',8.47),('10318','2013-07-28','13:40:00',8.46),('10318','2013-07-28','13:45:00',8.35),('10318','2013-07-28','13:50:00',8.38),('10318','2013-07-28','13:55:00',8.33),('10318','2013-07-28','14:00:00',8.32),('10318','2013-07-28','14:05:00',8.25),('10318','2013-07-28','14:10:00',8.22),('10318','2013-07-28','14:15:00',8.14),('10318','2013-07-28','14:20:00',8.07),('10318','2013-07-28','14:25:00',7.99),('10318','2013-07-28','14:30:00',7.95),('10318','2013-07-28','14:35:00',7.82),('10318','2013-07-28','14:40:00',7.67),('10318','2013-07-28','14:45:00',7.7),('10318','2013-07-28','14:50:00',7.6),('10318','2013-07-28','14:55:00',7.52),('10318','2013-07-28','15:00:00',7.45),('10318','2013-07-28','15:05:00',7.29),('10318','2013-07-28','15:10:00',7.24),('10318','2013-07-28','15:15:00',7.16),('10318','2013-07-28','15:20:00',7.06),('10318','2013-07-28','15:25:00',6.95),('10318','2013-07-28','15:30:00',6.87),('10318','2013-07-28','15:35:00',6.72),('10318','2013-07-28','15:40:00',6.56),('10318','2013-07-28','15:45:00',6.48),('10318','2013-07-28','15:50:00',6.36),('10318','2013-07-28','15:55:00',6.26),('10318','2013-07-28','16:00:00',6.17),('10318','2013-07-28','16:05:00',6.07),('10318','2013-07-28','16:10:00',5.97),('10318','2013-07-28','16:15:00',5.83),('10318','2013-07-28','16:20:00',5.7),('10318','2013-07-28','16:25:00',5.54),('10318','2013-07-28','16:30:00',5.2),('10318','2013-07-28','16:35:00',5.21),('10318','2013-07-28','16:40:00',5.06),('10318','2013-07-28','16:45:00',4.89),('10318','2013-07-28','16:50:00',4.74),('10318','2013-07-28','16:55:00',4.58),('10318','2013-07-28','17:00:00',4.41),('10318','2013-07-28','17:05:00',4.27),('10318','2013-07-28','17:10:00',4.1),('10318','2013-07-28','17:15:00',3.92),('10318','2013-07-28','17:20:00',3.76),('10318','2013-07-28','17:25:00',3.59),('10318','2013-07-28','17:30:00',3.39),('10318','2013-07-28','17:35:00',3.25),('10318','2013-07-28','17:40:00',3.09),('10318','2013-07-28','17:45:00',2.91),('10318','2013-07-28','17:50:00',2.74),('10318','2013-07-28','17:55:00',2.56),('10318','2013-07-28','18:00:00',2.4),('10318','2013-07-28','18:05:00',2.24),('10318','2013-07-28','18:10:00',2.08),('10318','2013-07-28','18:15:00',1.91),('10318','2013-07-28','18:20:00',1.78),('10318','2013-07-28','18:25:00',1.64),('10318','2013-07-28','18:30:00',1.5),('10318','2013-07-28','18:35:00',1.37),('10318','2013-07-28','18:40:00',1.24),('10318','2013-07-28','18:45:00',1.12),('10318','2013-07-28','18:50:00',1.03),('10318','2013-07-27','07:10:00',1.04),('10318','2013-07-27','07:15:00',1.28),('10318','2013-07-27','07:20:00',1.48),('10318','2013-07-27','07:25:00',1.67),('10318','2013-07-27','07:30:00',1.79),('10318','2013-07-27','07:35:00',2.07),('10318','2013-07-27','07:40:00',2.31),('10318','2013-07-27','07:45:00',2.51),('10318','2013-07-27','07:50:00',2.7),('10318','2013-07-27','07:55:00',2.86),('10318','2013-07-27','08:00:00',3.08),('10318','2013-07-27','08:05:00',3.28),('10318','2013-07-27','08:10:00',3.47),('10318','2013-07-27','08:15:00',3.66),('10318','2013-07-27','08:20:00',3.83),('10318','2013-07-27','08:25:00',4.01),('10318','2013-07-27','08:30:00',4.2),('10318','2013-07-27','08:35:00',4.37),('10318','2013-07-27','08:40:00',4.48),('10318','2013-07-27','08:45:00',4.75),('10318','2013-07-27','08:50:00',4.94),('10318','2013-07-27','08:55:00',5.07),('10318','2013-07-27','09:00:00',5.26),('10318','2013-07-27','09:05:00',5.45),('10318','2013-07-27','09:10:00',5.66),('10318','2013-07-27','09:15:00',5.78),('10318','2013-07-27','09:20:00',5.9),('10318','2013-07-27','09:25:00',6.12),('10318','2013-07-27','09:30:00',6.25),('10318','2013-07-27','09:35:00',6.31),('10318','2013-07-27','09:40:00',6.39),('10318','2013-07-27','09:45:00',6.56),('10318','2013-07-27','09:50:00',6.7),('10318','2013-07-27','09:55:00',6.82),('10318','2013-07-27','10:00:00',6.96),('10318','2013-07-27','10:05:00',7.08),('10318','2013-07-27','10:10:00',7.25),('10318','2013-07-27','10:15:00',7.33),('10318','2013-07-27','10:20:00',7.37),('10318','2013-07-27','10:25:00',7.36),('10318','2013-07-27','10:30:00',7.55),('10318','2013-07-27','10:35:00',7.63),('10318','2013-07-27','10:40:00',7.77),('10318','2013-07-27','10:45:00',7.84),('10318','2013-07-27','10:50:00',7.9),('10318','2013-07-27','10:55:00',7.94),('10318','2013-07-27','11:00:00',7.98),('10318','2013-07-27','11:05:00',8),('10318','2013-07-27','11:10:00',8.08),('10318','2013-07-27','11:15:00',8.15),('10318','2013-07-27','11:20:00',8.22),('10318','2013-07-27','11:25:00',8.24),('10318','2013-07-27','11:30:00',8.31),('10318','2013-07-27','11:35:00',8.35),('10318','2013-07-27','11:40:00',8.37),('10318','2013-07-27','11:45:00',8.39),('10318','2013-07-27','11:50:00',8.39),('10318','2013-07-27','11:55:00',8.42),('10318','2013-07-27','12:00:00',8.45),('10318','2013-07-27','12:05:00',8.39),('10318','2013-07-27','12:10:00',8.39),('10318','2013-07-27','12:15:00',8.21),('10318','2013-07-27','12:20:00',8.69),('10318','2013-07-27','12:25:00',8.61),('10318','2013-07-27','12:30:00',8.44),('10318','2013-07-27','12:35:00',8.77),('10318','2013-07-27','12:40:00',8.75),('10318','2013-07-27','12:45:00',8.59),('10318','2013-07-27','12:50:00',8.67),('10318','2013-07-27','12:55:00',8.62),('10318','2013-07-27','13:00:00',8.71),('10318','2013-07-27','13:05:00',8.86),('10318','2013-07-27','13:10:00',8.74),('10318','2013-07-27','13:15:00',8.65),('10318','2013-07-27','13:20:00',8.59),('10318','2013-07-27','13:25:00',8.32),('10318','2013-07-27','13:30:00',8.51),('10318','2013-07-27','13:35:00',8.69),('10318','2013-07-27','13:40:00',8.59),('10318','2013-07-27','13:45:00',8.41),('10318','2013-07-27','13:50:00',8.35),('10318','2013-07-27','13:55:00',8.28),('10318','2013-07-27','14:00:00',8.21),('10318','2013-07-27','14:05:00',8.33),('10318','2013-07-27','14:10:00',8.18),('10318','2013-07-27','14:15:00',8.2),('10318','2013-07-27','14:20:00',8.08),('10318','2013-07-27','14:25:00',7.94),('10318','2013-07-27','14:30:00',7.92),('10318','2013-07-27','14:35:00',7.92),('10318','2013-07-27','14:40:00',7.81),('10318','2013-07-27','14:45:00',7.7),('10318','2013-07-27','14:50:00',7.64),('10318','2013-07-27','14:55:00',7.53),('10318','2013-07-27','15:00:00',7.47),('10318','2013-07-27','15:05:00',7.34),('10318','2013-07-27','15:10:00',7.14),('10318','2013-07-27','15:15:00',7.19),('10318','2013-07-27','15:20:00',7.09),('10318','2013-07-27','15:25:00',7.02),('10318','2013-07-27','15:30:00',6.92),('10318','2013-07-27','15:35:00',6.81),('10318','2013-07-27','15:40:00',6.66),('10318','2013-07-27','15:45:00',6.56),('10318','2013-07-27','15:50:00',6.46),('10318','2013-07-27','15:55:00',6.35),('10318','2013-07-27','16:00:00',6.21),('10318','2013-07-27','16:05:00',6.03),('10318','2013-07-27','16:10:00',5.88),('10318','2013-07-27','16:15:00',5.77),('10318','2013-07-27','16:20:00',5.64),('10318','2013-07-27','16:25:00',5.52),('10318','2013-07-27','16:30:00',5.39),('10318','2013-07-27','16:35:00',5.25),('10318','2013-07-27','16:40:00',5.09),('10318','2013-07-27','16:45:00',4.9),('10318','2013-07-27','16:50:00',4.76),('10318','2013-07-27','16:55:00',4.47),('10318','2013-07-27','17:00:00',4.45),('10318','2013-07-27','17:05:00',4.28),('10318','2013-07-27','17:10:00',4.12),('10318','2013-07-27','17:15:00',3.94),('10318','2013-07-27','17:20:00',3.76),('10318','2013-07-27','17:25:00',3.58),('10318','2013-07-27','17:30:00',3.42),('10318','2013-07-27','17:35:00',3.26),('10318','2013-07-27','17:40:00',3.09),('10318','2013-07-27','17:45:00',2.88),('10318','2013-07-27','17:50:00',2.71),('10318','2013-07-27','17:55:00',2.57),('10318','2013-07-27','18:00:00',2.42),('10318','2013-07-27','18:05:00',2.27),('10318','2013-07-27','18:10:00',2.13),('10318','2013-07-27','18:15:00',1.97),('10318','2013-07-27','18:20:00',1.81),('10318','2013-07-27','18:25:00',1.67),('10318','2013-07-27','18:30:00',1.55),('10318','2013-07-27','18:35:00',1.41),('10318','2013-07-27','18:40:00',1.26),('10318','2013-07-27','18:45:00',1.16),('10318','2013-07-27','18:50:00',1.04),('10318','2013-07-26','07:10:00',1.12),('10318','2013-07-26','07:15:00',1.4),('10318','2013-07-26','07:20:00',1.57),('10318','2013-07-26','07:25:00',1.77),('10318','2013-07-26','07:30:00',1.97),('10318','2013-07-26','07:35:00',2.1),('10318','2013-07-26','07:40:00',2.27),('10318','2013-07-26','07:45:00',2.47),('10318','2013-07-26','07:50:00',2.75),('10318','2013-07-26','07:55:00',3.01),('10318','2013-07-26','08:00:00',3.24),('10318','2013-07-26','08:05:00',3.39),('10318','2013-07-26','08:10:00',3.35),('10318','2013-07-26','08:15:00',3.12),('10318','2013-07-26','08:20:00',3.79),('10318','2013-07-26','08:25:00',3.93),('10318','2013-07-26','08:30:00',4.05),('10318','2013-07-26','08:35:00',4.27),('10318','2013-07-26','08:40:00',4.38),('10318','2013-07-26','08:45:00',4.67),('10318','2013-07-26','08:50:00',4.84),('10318','2013-07-26','08:55:00',4.94),('10318','2013-07-26','09:00:00',5.09),('10318','2013-07-26','09:05:00',5.31),('10318','2013-07-26','09:10:00',5.5),('10318','2013-07-26','09:15:00',5.64),('10318','2013-07-26','09:20:00',5.78),('10318','2013-07-26','09:25:00',5.96),('10318','2013-07-26','09:30:00',6.12),('10318','2013-07-26','09:35:00',6.31),('10318','2013-07-26','09:40:00',6.43),('10318','2013-07-26','09:45:00',6.5),('10318','2013-07-26','09:50:00',6.6),('10318','2013-07-26','09:55:00',6.75),('10318','2013-07-26','10:00:00',6.82),('10318','2013-07-26','10:05:00',6.94),('10318','2013-07-26','10:10:00',7.13),('10318','2013-07-26','10:15:00',7.17),('10318','2013-07-26','10:20:00',7.13),('10318','2013-07-26','10:25:00',7.25),('10318','2013-07-26','10:30:00',7.47),('10318','2013-07-26','10:35:00',7.62),('10318','2013-07-26','10:40:00',7.63),('10318','2013-07-26','10:45:00',7.74),('10318','2013-07-26','10:50:00',7.81),('10318','2013-07-26','10:55:00',7.81),('10318','2013-07-26','11:00:00',7.96),('10318','2013-07-26','11:05:00',8.01),('10318','2013-07-26','11:10:00',8.07),('10318','2013-07-26','11:15:00',8.15),('10318','2013-07-26','11:20:00',8.21),('10318','2013-07-26','11:25:00',8.21),('10318','2013-07-26','11:30:00',8.18),('10318','2013-07-26','11:35:00',8.18),('10318','2013-07-26','11:40:00',8.36),('10318','2013-07-26','11:45:00',8.47),('10318','2013-07-26','11:50:00',8.75),('10318','2013-07-26','11:55:00',8.49),('10318','2013-07-26','12:00:00',8.95),('10318','2013-07-26','12:05:00',8.7),('10318','2013-07-26','12:10:00',6.25),('10318','2013-07-26','12:15:00',5.32),('10318','2013-07-26','12:20:00',9.46),('10318','2013-07-26','12:25:00',9.06),('10318','2013-07-26','12:30:00',9.04),('10318','2013-07-26','12:35:00',7.59),('10318','2013-07-26','12:40:00',4.96),('10318','2013-07-26','12:45:00',3.29),('10318','2013-07-26','12:50:00',5.7),('10318','2013-07-26','12:55:00',6.7),('10318','2013-07-26','13:00:00',8.78),('10318','2013-07-26','13:05:00',9.35),('10318','2013-07-26','13:10:00',8.9),('10318','2013-07-26','13:15:00',8.31),('10318','2013-07-26','13:20:00',8.39),('10318','2013-07-26','13:25:00',8.29),('10318','2013-07-26','13:30:00',4.92),('10318','2013-07-26','13:35:00',5.07),('10318','2013-07-26','13:40:00',9.2),('10318','2013-07-26','13:45:00',9.09),('10318','2013-07-26','13:50:00',8.52),('10318','2013-07-26','13:55:00',8.58),('10318','2013-07-26','14:00:00',8.8),('10318','2013-07-26','14:05:00',8.36),('10318','2013-07-26','14:10:00',8.54),('10318','2013-07-26','14:15:00',8.52),('10318','2013-07-26','14:20:00',8.14),('10318','2013-07-26','14:25:00',8.18),('10318','2013-07-26','14:30:00',8.04),('10318','2013-07-26','14:35:00',7.98),('10318','2013-07-26','14:40:00',7.93),('10318','2013-07-26','14:45:00',7.72),('10318','2013-07-26','14:50:00',7.8),('10318','2013-07-26','14:55:00',7.68),('10318','2013-07-26','15:00:00',7.57),('10318','2013-07-26','15:05:00',7.49),('10318','2013-07-26','15:10:00',7.35),('10318','2013-07-26','15:15:00',7.27),('10318','2013-07-26','15:20:00',7.2),('10318','2013-07-26','15:25:00',7.07),('10318','2013-07-26','15:30:00',6.89),('10318','2013-07-26','15:35:00',6.84),('10318','2013-07-26','15:40:00',6.69),('10318','2013-07-26','15:45:00',6.65),('10318','2013-07-26','15:50:00',6.47),('10318','2013-07-26','15:55:00',6.36),('10318','2013-07-26','16:00:00',6.24),('10318','2013-07-26','16:05:00',6.1),('10318','2013-07-26','16:10:00',6),('10318','2013-07-26','16:15:00',5.86),('10318','2013-07-26','16:20:00',5.7),('10318','2013-07-26','16:25:00',5.56),('10318','2013-07-26','16:30:00',5.41),('10318','2013-07-26','16:35:00',5.25),('10318','2013-07-26','16:40:00',5.11),('10318','2013-07-26','16:45:00',4.95),('10318','2013-07-26','16:50:00',4.78),('10318','2013-07-26','16:55:00',4.61),('10318','2013-07-26','17:00:00',4.48),('10318','2013-07-26','17:05:00',4.33),('10318','2013-07-26','17:10:00',4.05),('10318','2013-07-26','17:15:00',3.97),('10318','2013-07-26','17:20:00',3.82),('10318','2013-07-26','17:25:00',3.63),('10318','2013-07-26','17:30:00',3.42),('10318','2013-07-26','17:35:00',3.27),('10318','2013-07-26','17:40:00',3.12),('10318','2013-07-26','17:45:00',2.92),('10318','2013-07-26','17:50:00',2.75),('10318','2013-07-26','17:55:00',2.5),('10318','2013-07-26','18:00:00',2.44),('10318','2013-07-26','18:05:00',2.24),('10318','2013-07-26','18:10:00',2.11),('10318','2013-07-26','18:15:00',1.97),('10318','2013-07-26','18:20:00',1.81),('10318','2013-07-26','18:25:00',1.69),('10318','2013-07-26','18:30:00',1.56),('10318','2013-07-26','18:35:00',1.43),('10318','2013-07-26','18:40:00',1.29),('10318','2013-07-26','18:45:00',1.19),('10318','2013-07-26','18:50:00',1.09),('10318','2013-07-25','07:10:00',1.08),('10318','2013-07-25','07:15:00',1.33),('10318','2013-07-25','07:20:00',1.51),('10318','2013-07-25','07:25:00',1.7),('10318','2013-07-25','07:30:00',1.86),('10318','2013-07-25','07:35:00',2.13),('10318','2013-07-25','07:40:00',2.34),('10318','2013-07-25','07:45:00',2.5),('10318','2013-07-25','07:50:00',2.67),('10318','2013-07-25','07:55:00',2.86),('10318','2013-07-25','08:00:00',3.04),('10318','2013-07-25','08:05:00',3.2),('10318','2013-07-25','08:10:00',3.45),('10318','2013-07-25','08:15:00',3.61),('10318','2013-07-25','08:20:00',3.75),('10318','2013-07-25','08:25:00',3.87),('10318','2013-07-25','08:30:00',4.07),('10318','2013-07-25','08:35:00',4.28),('10318','2013-07-25','08:40:00',4.33),('10318','2013-07-25','08:45:00',4.57),('10318','2013-07-25','08:50:00',4.83),('10318','2013-07-25','08:55:00',4.98),('10318','2013-07-25','09:00:00',5.18),('10318','2013-07-25','09:05:00',5.49),('10318','2013-07-25','09:10:00',5.59),('10318','2013-07-25','09:15:00',5.95),('10318','2013-07-25','09:20:00',6.41),('10318','2013-07-25','09:25:00',6.46),('10318','2013-07-25','09:30:00',5.13),('10318','2013-07-25','09:35:00',4.45),('10318','2013-07-25','09:40:00',3.64),('10318','2013-07-25','09:45:00',2.59),('10318','2013-07-25','09:50:00',5.37),('10318','2013-07-25','09:55:00',7.01),('10318','2013-07-25','10:00:00',6.92),('10318','2013-07-25','10:05:00',6.76),('10318','2013-07-25','10:10:00',7.35),('10318','2013-07-25','10:15:00',7.46),('10318','2013-07-25','10:20:00',7.58),('10318','2013-07-25','10:25:00',7.94),('10318','2013-07-25','10:30:00',7.06),('10318','2013-07-25','10:35:00',7.58),('10318','2013-07-25','10:40:00',7.14),('10318','2013-07-25','10:45:00',5.5),('10318','2013-07-25','10:50:00',5.33),('10318','2013-07-25','10:55:00',8.61),('10318','2013-07-25','11:00:00',8.37),('10318','2013-07-25','11:05:00',8.32),('10318','2013-07-25','11:10:00',8.23),('10318','2013-07-25','11:15:00',6.48),('10318','2013-07-25','11:20:00',6.75),('10318','2013-07-25','11:25:00',8.71),('10318','2013-07-25','11:30:00',8.57),('10318','2013-07-25','11:35:00',8.64),('10318','2013-07-25','11:40:00',5.16),('10318','2013-07-25','11:45:00',9.05),('10318','2013-07-25','11:50:00',8.45),('10318','2013-07-25','11:55:00',8.39),('10318','2013-07-25','12:00:00',8.74),('10318','2013-07-25','12:05:00',8.91),('10318','2013-07-25','12:10:00',8.64),('10318','2013-07-25','12:15:00',5.02),('10318','2013-07-25','12:20:00',3.14),('10318','2013-07-25','12:25:00',2.23),('10318','2013-07-25','12:30:00',1.9),('10318','2013-07-25','12:35:00',5.86),('10318','2013-07-25','12:40:00',9.5),('10318','2013-07-25','12:45:00',8.78),('10318','2013-07-25','12:50:00',8.42),('10318','2013-07-25','12:55:00',9.13),('10318','2013-07-25','13:00:00',9.04),('10318','2013-07-25','13:05:00',7.28),('10318','2013-07-25','13:10:00',8.84),('10318','2013-07-25','13:15:00',8.99),('10318','2013-07-25','13:20:00',9),('10318','2013-07-25','13:25:00',8.91),('10318','2013-07-25','13:30:00',8.88),('10318','2013-07-25','13:35:00',8.86),('10318','2013-07-25','13:40:00',8.84),('10318','2013-07-25','13:45:00',8.8),('10318','2013-07-25','13:50:00',8.76),('10318','2013-07-25','13:55:00',8.73),('10318','2013-07-25','14:00:00',8.73),('10318','2013-07-25','14:05:00',8.67),('10318','2013-07-25','14:10:00',8.58),('10318','2013-07-25','14:15:00',8.54),('10318','2013-07-25','14:20:00',8.51),('10318','2013-07-25','14:25:00',8.43),('10318','2013-07-25','14:30:00',8.29),('10318','2013-07-25','14:35:00',8.31),('10318','2013-07-25','14:40:00',8.2),('10318','2013-07-25','14:45:00',8.12),('10318','2013-07-25','14:50:00',7.97),('10318','2013-07-25','14:55:00',7.9),('10318','2013-07-25','15:00:00',7.8),('10318','2013-07-25','15:05:00',7.78),('10318','2013-07-25','15:10:00',7.7),('10318','2013-07-25','15:15:00',7.58),('10318','2013-07-25','15:20:00',7.46),('10318','2013-07-25','15:25:00',7.41),('10318','2013-07-25','15:30:00',7.28),('10318','2013-07-25','15:35:00',7.16),('10318','2013-07-25','15:40:00',7.09),('10318','2013-07-25','15:45:00',6.94),('10318','2013-07-25','15:50:00',6.75),('10318','2013-07-25','15:55:00',6.67),('10318','2013-07-25','16:00:00',6.58),('10318','2013-07-25','16:05:00',6.4),('10318','2013-07-25','16:10:00',6.27),('10318','2013-07-25','16:15:00',6.1),('10318','2013-07-25','16:20:00',5.95),('10318','2013-07-25','16:25:00',5.78),('10318','2013-07-25','16:30:00',5.65),('10318','2013-07-25','16:35:00',5.53),('10318','2013-07-25','16:40:00',5.34),('10318','2013-07-25','16:45:00',5.18),('10318','2013-07-25','16:50:00',5.03),('10318','2013-07-25','16:55:00',4.84),('10318','2013-07-25','17:00:00',4.66),('10318','2013-07-25','17:05:00',4.5),('10318','2013-07-25','17:10:00',4.3),('10318','2013-07-25','17:15:00',4.12),('10318','2013-07-25','17:20:00',3.94),('10318','2013-07-25','17:25:00',3.72),('10318','2013-07-25','17:30:00',3.55),('10318','2013-07-25','17:35:00',3.38),('10318','2013-07-25','17:40:00',3.24),('10318','2013-07-25','17:45:00',3.02),('10318','2013-07-25','17:50:00',2.87),('10318','2013-07-25','17:55:00',2.68),('10318','2013-07-25','18:00:00',2.54),('10318','2013-07-25','18:05:00',2.33),('10318','2013-07-25','18:10:00',2.14),('10318','2013-07-25','18:15:00',2.02),('10318','2013-07-25','18:20:00',1.88),('10318','2013-07-25','18:25:00',1.73),('10318','2013-07-25','18:30:00',1.55),('10318','2013-07-25','18:35:00',1.41),('10318','2013-07-25','18:40:00',1.29),('10318','2013-07-25','18:45:00',1.2),('10318','2013-07-25','18:50:00',1.08),('10318','2013-07-24','07:20:00',1.18),('10318','2013-07-24','07:25:00',1.71),('10318','2013-07-24','07:30:00',2.38),('10318','2013-07-24','07:35:00',1.89),('10318','2013-07-24','07:40:00',1.39),('10318','2013-07-24','07:45:00',1.34),('10318','2013-07-24','07:50:00',1.66),('10318','2013-07-24','07:55:00',1.83),('10318','2013-07-24','08:00:00',2.19),('10318','2013-07-24','08:05:00',2.71),('10318','2013-07-24','08:10:00',2.67),('10318','2013-07-24','08:15:00',3.77),('10318','2013-07-24','08:20:00',2.72),('10318','2013-07-24','08:25:00',2.38),('10318','2013-07-24','08:30:00',2.33),('10318','2013-07-24','08:35:00',2.85),('10318','2013-07-24','08:40:00',2.47),('10318','2013-07-24','08:45:00',4.11),('10318','2013-07-24','08:50:00',5.3),('10318','2013-07-24','08:55:00',4.38),('10318','2013-07-24','09:00:00',4.27),('10318','2013-07-24','09:05:00',5.16),('10318','2013-07-24','09:10:00',3.1),('10318','2013-07-24','09:15:00',3.65),('10318','2013-07-24','09:20:00',4.68),('10318','2013-07-24','09:25:00',4.23),('10318','2013-07-24','09:30:00',3.17),('10318','2013-07-24','09:35:00',6.95),('10318','2013-07-24','09:40:00',6.53),('10318','2013-07-24','09:45:00',3.12),('10318','2013-07-24','09:50:00',3.23),('10318','2013-07-24','09:55:00',3.63),('10318','2013-07-24','10:00:00',3.91),('10318','2013-07-24','10:05:00',8.25),('10318','2013-07-24','10:10:00',7.19),('10318','2013-07-24','10:15:00',6.12),('10318','2013-07-24','10:20:00',6.95),('10318','2013-07-24','10:25:00',6.28),('10318','2013-07-24','10:30:00',7.25),('10318','2013-07-24','10:35:00',4.5),('10318','2013-07-24','10:40:00',6.78),('10318','2013-07-24','10:45:00',3.66),('10318','2013-07-24','10:50:00',8.62),('10318','2013-07-24','10:55:00',8.53),('10318','2013-07-24','11:00:00',8.84),('10318','2013-07-24','11:05:00',9.07),('10318','2013-07-24','11:10:00',7.82),('10318','2013-07-24','11:15:00',8.74),('10318','2013-07-24','11:20:00',5.91),('10318','2013-07-24','11:25:00',3.48),('10318','2013-07-24','11:30:00',8.17),('10318','2013-07-24','11:35:00',9.02),('10318','2013-07-24','11:40:00',9.02),('10318','2013-07-24','11:45:00',9.21),('10318','2013-07-24','11:50:00',6.69),('10318','2013-07-24','11:55:00',3.04),('10318','2013-07-24','12:00:00',7.1),('10318','2013-07-24','12:05:00',3.93),('10318','2013-07-24','12:10:00',6.84),('10318','2013-07-24','12:15:00',9.99),('10318','2013-07-24','12:20:00',9.64),('10318','2013-07-24','12:25:00',9.43),('10318','2013-07-24','12:30:00',9.43),('10318','2013-07-24','12:35:00',9.56),('10318','2013-07-24','12:40:00',8.02),('10318','2013-07-24','12:45:00',6.7),('10318','2013-07-24','12:50:00',4.45),('10318','2013-07-24','12:55:00',9.08),('10318','2013-07-24','13:00:00',9.29),('10318','2013-07-24','13:05:00',9.07),('10318','2013-07-24','13:10:00',9.06),('10318','2013-07-24','13:15:00',9.24),('10318','2013-07-24','13:20:00',9.37),('10318','2013-07-24','13:25:00',9.13),('10318','2013-07-24','13:30:00',9.07),('10318','2013-07-24','13:35:00',8.99),('10318','2013-07-24','13:40:00',8.69),('10318','2013-07-24','13:45:00',8.88),('10318','2013-07-24','13:50:00',8.9),('10318','2013-07-24','13:55:00',8.81),('10318','2013-07-24','14:00:00',8.81),('10318','2013-07-24','14:05:00',8.93),('10318','2013-07-24','14:10:00',8.86),('10318','2013-07-24','14:15:00',8.81),('10318','2013-07-24','14:20:00',8.67),('10318','2013-07-24','14:25:00',8.73),('10318','2013-07-24','14:30:00',8.7),('10318','2013-07-24','14:35:00',8.63),('10318','2013-07-24','14:40:00',8.54),('10318','2013-07-24','14:45:00',8.46),('10318','2013-07-24','14:50:00',8.34),('10318','2013-07-24','14:55:00',8.23),('10318','2013-07-24','15:00:00',8.05),('10318','2013-07-24','15:05:00',7.89),('10318','2013-07-24','15:10:00',7.73),('10318','2013-07-24','15:15:00',7.7),('10318','2013-07-24','15:20:00',7.62),('10318','2013-07-24','15:25:00',7.35),('10318','2013-07-24','15:30:00',6.97),('10318','2013-07-24','15:35:00',7.25),('10318','2013-07-24','15:40:00',7.16),('10318','2013-07-24','15:45:00',6.8),('10318','2013-07-24','15:50:00',6.66),('10318','2013-07-24','15:55:00',6.67),('10318','2013-07-24','16:00:00',6.39),('10318','2013-07-24','16:05:00',6.25),('10318','2013-07-24','16:10:00',6.25),('10318','2013-07-24','16:15:00',6.42),('10318','2013-07-24','16:20:00',6.27),('10318','2013-07-24','16:25:00',6.01),('10318','2013-07-24','16:30:00',5.9),('10318','2013-07-24','16:35:00',5.8),('10318','2013-07-24','16:40:00',5.36),('10318','2013-07-24','16:45:00',5.39),('10318','2013-07-24','16:50:00',5.53),('10318','2013-07-24','16:55:00',5.37),('10318','2013-07-24','17:00:00',5.17),('10318','2013-07-24','17:05:00',4.82),('10318','2013-07-24','17:10:00',4.67),('10318','2013-07-24','17:15:00',4.4),('10318','2013-07-24','17:20:00',4.09),('10318','2013-07-24','17:25:00',3.89),('10318','2013-07-24','17:30:00',3.69),('10318','2013-07-24','17:35:00',3.47),('10318','2013-07-24','17:40:00',3.27),('10318','2013-07-24','17:45:00',3.09),('10318','2013-07-24','17:50:00',2.93),('10318','2013-07-24','17:55:00',2.72),('10318','2013-07-24','18:00:00',2.56),('10318','2013-07-24','18:05:00',2.38),('10318','2013-07-24','18:10:00',2.25),('10318','2013-07-24','18:15:00',2.09),('10318','2013-07-24','18:20:00',1.9),('10318','2013-07-24','18:25:00',1.7),('10318','2013-07-24','18:30:00',1.45),('10318','2013-07-24','18:35:00',1.11),('10318','2013-07-24','18:40:00',1.38),('10318','2013-07-24','18:45:00',1.25),('10318','2013-07-24','18:50:00',1.07),('10318','2013-07-23','07:10:00',1.25),('10318','2013-07-23','07:15:00',1.47),('10318','2013-07-23','07:20:00',1.77),('10318','2013-07-23','07:25:00',1.98),('10318','2013-07-23','07:30:00',2.2),('10318','2013-07-23','07:35:00',2.48),('10318','2013-07-23','07:40:00',2.69),('10318','2013-07-23','07:45:00',2.87),('10318','2013-07-23','07:50:00',3.05),('10318','2013-07-23','07:55:00',3.26),('10318','2013-07-23','08:00:00',3.44),('10318','2013-07-23','08:05:00',3.62),('10318','2013-07-23','08:10:00',3.81),('10318','2013-07-23','08:15:00',3.99),('10318','2013-07-23','08:20:00',4.18),('10318','2013-07-23','08:25:00',4.38),('10318','2013-07-23','08:30:00',4.55),('10318','2013-07-23','08:35:00',4.72),('10318','2013-07-23','08:40:00',4.91),('10318','2013-07-23','08:45:00',5.09),('10318','2013-07-23','08:50:00',5.25),('10318','2013-07-23','08:55:00',5.41),('10318','2013-07-23','09:00:00',5.57),('10318','2013-07-23','09:05:00',5.7),('10318','2013-07-23','09:10:00',5.83),('10318','2013-07-23','09:15:00',5.98),('10318','2013-07-23','09:20:00',6.06),('10318','2013-07-23','09:25:00',6.15),('10318','2013-07-23','09:30:00',6.3),('10318','2013-07-23','09:35:00',6.46),('10318','2013-07-23','09:40:00',6.56),('10318','2013-07-23','09:45:00',6.66),('10318','2013-07-23','09:50:00',6.77),('10318','2013-07-23','09:55:00',6.92),('10318','2013-07-23','10:00:00',7.03),('10318','2013-07-23','10:05:00',7.08),('10318','2013-07-23','10:10:00',7.16),('10318','2013-07-23','10:15:00',7.2),('10318','2013-07-23','10:20:00',7.32),('10318','2013-07-23','10:25:00',7.49),('10318','2013-07-23','10:30:00',7.68),('10318','2013-07-23','10:35:00',7.61),('10318','2013-07-23','10:40:00',7.85),('10318','2013-07-23','10:45:00',7.92),('10318','2013-07-23','10:50:00',8.04),('10318','2013-07-23','10:55:00',8.16),('10318','2013-07-23','11:00:00',8.17),('10318','2013-07-23','11:05:00',8.2),('10318','2013-07-23','11:10:00',8.38),('10318','2013-07-23','11:15:00',8.54),('10318','2013-07-23','11:20:00',8.52),('10318','2013-07-23','11:25:00',8.56),('10318','2013-07-23','11:30:00',8.7),('10318','2013-07-23','11:35:00',8.91),('10318','2013-07-23','11:40:00',9.18),('10318','2013-07-23','11:45:00',9.33),('10318','2013-07-23','11:50:00',9.14),('10318','2013-07-23','11:55:00',9.07),('10318','2013-07-23','12:00:00',9.17),('10318','2013-07-23','12:05:00',7.39),('10318','2013-07-23','12:10:00',2.82),('10318','2013-07-23','12:15:00',3.07),('10318','2013-07-23','12:20:00',3.09),('10318','2013-07-23','12:25:00',2.21),('10318','2013-07-23','12:30:00',2.03),('10318','2013-07-23','12:35:00',2.95),('10318','2013-07-23','12:40:00',9.68),('10318','2013-07-23','12:45:00',6.45),('10318','2013-07-23','12:50:00',1.83),('10318','2013-07-23','12:55:00',1.93),('10318','2013-07-23','13:00:00',1.86),('10318','2013-07-23','13:05:00',1.9),('10318','2013-07-23','13:10:00',1.31),('10318','2013-07-23','13:15:00',1.12),('10318','2013-07-23','13:20:00',5.44),('10318','2013-07-23','13:25:00',9.58),('10318','2013-07-23','13:30:00',3.81),('10318','2013-07-23','13:35:00',1.96),('10318','2013-07-23','13:40:00',8.93),('10318','2013-07-23','13:45:00',5.69),('10318','2013-07-23','13:50:00',1.49),('10318','2013-07-23','13:55:00',2.15),('10318','2013-07-23','14:00:00',3.87),('10318','2013-07-23','14:05:00',5.2),('10318','2013-07-23','14:10:00',8.55),('10318','2013-07-23','14:15:00',2.86),('10318','2013-07-23','14:20:00',2.58),('10318','2013-07-23','14:25:00',3.41),('10318','2013-07-23','14:30:00',6.92),('10318','2013-07-23','14:35:00',9.03),('10318','2013-07-23','14:40:00',3.65),('10318','2013-07-23','14:45:00',7.67),('10318','2013-07-23','14:50:00',8.98),('10318','2013-07-23','14:55:00',8.8),('10318','2013-07-23','15:00:00',8.5),('10318','2013-07-23','15:05:00',8.13),('10318','2013-07-23','15:10:00',8),('10318','2013-07-23','15:15:00',7.84),('10318','2013-07-23','15:20:00',7.53),('10318','2013-07-23','15:25:00',7.25),('10318','2013-07-23','15:30:00',7.2),('10318','2013-07-23','15:35:00',7.11),('10318','2013-07-23','15:40:00',6.85),('10318','2013-07-23','15:45:00',6.78),('10318','2013-07-23','15:50:00',6.62),('10318','2013-07-23','15:55:00',6.65),('10318','2013-07-23','16:00:00',6.37),('10318','2013-07-23','16:05:00',6.31),('10318','2013-07-23','16:10:00',6.21),('10318','2013-07-23','16:15:00',6.07),('10318','2013-07-23','16:20:00',5.9),('10318','2013-07-23','16:25:00',5.76),('10318','2013-07-23','16:30:00',5.54),('10318','2013-07-23','16:35:00',5.39),('10318','2013-07-23','16:40:00',5.25),('10318','2013-07-23','16:45:00',5.08),('10318','2013-07-23','16:50:00',4.93),('10318','2013-07-23','16:55:00',4.77),('10318','2013-07-23','17:00:00',4.6),('10318','2013-07-23','17:05:00',4.36),('10318','2013-07-23','17:10:00',4.26),('10318','2013-07-23','17:15:00',4.13),('10318','2013-07-23','17:20:00',3.97),('10318','2013-07-23','17:25:00',3.82),('10318','2013-07-23','17:30:00',3.64),('10318','2013-07-23','17:35:00',3.47),('10318','2013-07-23','17:40:00',3.35),('10318','2013-07-23','17:45:00',3.15),('10318','2013-07-23','17:50:00',2.95),('10318','2013-07-23','17:55:00',2.76),('10318','2013-07-23','18:00:00',2.62),('10318','2013-07-23','18:05:00',2.46),('10318','2013-07-23','18:10:00',2.3),('10318','2013-07-23','18:15:00',2.13),('10318','2013-07-23','18:20:00',1.95),('10318','2013-07-23','18:25:00',1.81),('10318','2013-07-23','18:30:00',1.67),('10318','2013-07-23','18:35:00',1.49),('10318','2013-07-23','18:40:00',1.05),('10318','2013-07-22','07:10:00',1.23),('10318','2013-07-22','07:15:00',1.44),('10318','2013-07-22','07:20:00',1.66),('10318','2013-07-22','07:25:00',1.86),('10318','2013-07-22','07:30:00',2.09),('10318','2013-07-22','07:35:00',2.36),('10318','2013-07-22','07:40:00',2.58),('10318','2013-07-22','07:45:00',2.76),('10318','2013-07-22','07:50:00',2.93),('10318','2013-07-22','07:55:00',3.13),('10318','2013-07-22','08:00:00',3.33),('10318','2013-07-22','08:05:00',3.52),('10318','2013-07-22','08:10:00',3.71),('10318','2013-07-22','08:15:00',3.91),('10318','2013-07-22','08:20:00',4.1),('10318','2013-07-22','08:25:00',4.29),('10318','2013-07-22','08:30:00',4.49),('10318','2013-07-22','08:35:00',4.66),('10318','2013-07-22','08:40:00',4.84),('10318','2013-07-22','08:45:00',5.01),('10318','2013-07-22','08:50:00',5.09),('10318','2013-07-22','08:55:00',5.37),('10318','2013-07-22','09:00:00',5.53),('10318','2013-07-22','09:05:00',5.68),('10318','2013-07-22','09:10:00',5.82),('10318','2013-07-22','09:15:00',5.97),('10318','2013-07-22','09:20:00',6.08),('10318','2013-07-22','09:25:00',6.24),('10318','2013-07-22','09:30:00',6.37),('10318','2013-07-22','09:35:00',6.5),('10318','2013-07-22','09:40:00',6.6),('10318','2013-07-22','09:45:00',6.75),('10318','2013-07-22','09:50:00',6.86),('10318','2013-07-22','09:55:00',7.01),('10318','2013-07-22','10:00:00',7.13),('10318','2013-07-22','10:05:00',7.21),('10318','2013-07-22','10:10:00',7.32),('10318','2013-07-22','10:15:00',7.46),('10318','2013-07-22','10:20:00',7.55),('10318','2013-07-22','10:25:00',7.61),('10318','2013-07-22','10:30:00',7.73),('10318','2013-07-22','10:35:00',7.67),('10318','2013-07-22','10:40:00',7.91),('10318','2013-07-22','10:45:00',7.95),('10318','2013-07-22','10:50:00',8.05),('10318','2013-07-22','10:55:00',8.17),('10318','2013-07-22','11:00:00',8.27),('10318','2013-07-22','11:05:00',8.31),('10318','2013-07-22','11:10:00',8.39),('10318','2013-07-22','11:15:00',8.43),('10318','2013-07-22','11:20:00',8.41),('10318','2013-07-22','11:25:00',8.46),('10318','2013-07-22','11:30:00',8.52),('10318','2013-07-22','11:35:00',8.59),('10318','2013-07-22','11:40:00',8.63),('10318','2013-07-22','11:45:00',8.7),('10318','2013-07-22','11:50:00',8.71),('10318','2013-07-22','11:55:00',8.72),('10318','2013-07-22','12:00:00',8.72),('10318','2013-07-22','12:05:00',8.71),('10318','2013-07-22','12:10:00',8.75),('10318','2013-07-22','12:15:00',8.83),('10318','2013-07-22','12:20:00',8.69),('10318','2013-07-22','12:25:00',8.83),('10318','2013-07-22','12:30:00',8.83),('10318','2013-07-22','12:35:00',8.84),('10318','2013-07-22','12:40:00',8.85),('10318','2013-07-22','12:45:00',8.85),('10318','2013-07-22','12:50:00',8.83),('10318','2013-07-22','12:55:00',8.89),('10318','2013-07-22','13:00:00',8.91),('10318','2013-07-22','13:05:00',8.85),('10318','2013-07-22','13:10:00',8.83),('10318','2013-07-22','13:15:00',8.82),('10318','2013-07-22','13:20:00',8.82),('10318','2013-07-22','13:25:00',8.77),('10318','2013-07-22','13:30:00',8.72),('10318','2013-07-22','13:35:00',8.63),('10318','2013-07-22','13:40:00',8.63),('10318','2013-07-22','13:45:00',8.56),('10318','2013-07-22','13:50:00',8.5),('10318','2013-07-22','13:55:00',8.45),('10318','2013-07-22','14:00:00',8.52),('10318','2013-07-22','14:05:00',8.12),('10318','2013-07-22','14:10:00',8.28),('10318','2013-07-22','14:15:00',8.24),('10318','2013-07-22','14:20:00',8.15),('10318','2013-07-22','14:25:00',8.06),('10318','2013-07-22','14:30:00',7.96),('10318','2013-07-22','14:35:00',7.8),('10318','2013-07-22','14:40:00',7.88),('10318','2013-07-22','14:45:00',7.91),('10318','2013-07-22','14:50:00',7.82),('10318','2013-07-22','14:55:00',7.73),('10318','2013-07-22','15:00:00',7.67),('10318','2013-07-22','15:05:00',7.54),('10318','2013-07-22','15:10:00',7.56),('10318','2013-07-22','15:15:00',7.46),('10318','2013-07-22','15:20:00',7.37),('10318','2013-07-22','15:25:00',7.33),('10318','2013-07-22','15:30:00',5.97),('10318','2013-07-22','15:35:00',6.84),('10318','2013-07-22','15:40:00',5.28),('10318','2013-07-22','15:45:00',4.02),('10318','2013-07-22','15:50:00',4.27),('10318','2013-07-22','15:55:00',5.56),('10318','2013-07-22','16:00:00',6.92),('10318','2013-07-22','16:05:00',6.99),('10318','2013-07-22','16:10:00',6.88),('10318','2013-07-22','16:15:00',6.65),('10318','2013-07-22','16:20:00',6.33),('10318','2013-07-22','16:25:00',6.1),('10318','2013-07-22','16:30:00',5.73),('10318','2013-07-22','16:35:00',5.47),('10318','2013-07-22','16:40:00',5.31),('10318','2013-07-22','16:45:00',5),('10318','2013-07-22','16:50:00',4.73),('10318','2013-07-22','16:55:00',4.62),('10318','2013-07-22','17:00:00',4.57),('10318','2013-07-22','17:05:00',4.28),('10318','2013-07-22','17:10:00',4.23),('10318','2013-07-22','17:15:00',4.06),('10318','2013-07-22','17:20:00',3.91),('10318','2013-07-22','17:25:00',3.75),('10318','2013-07-22','17:30:00',3.62),('10318','2013-07-22','17:35:00',3.45),('10318','2013-07-22','17:40:00',3.28),('10318','2013-07-22','17:45:00',3.22),('10318','2013-07-22','17:50:00',2.86),('10318','2013-07-22','17:55:00',2.41),('10318','2013-07-22','18:00:00',2.66),('10318','2013-07-22','18:05:00',2.47),('10318','2013-07-22','18:10:00',2.25),('10318','2013-07-22','18:15:00',2.1),('10318','2013-07-22','18:20:00',1.87),('10318','2013-07-22','18:25:00',1.64),('10318','2013-07-22','18:30:00',1.7),('10318','2013-07-22','18:35:00',1.58),('10318','2013-07-22','18:40:00',1.42),('10318','2013-07-22','18:45:00',1.25),('10318','2013-07-22','18:50:00',1.12),('10318','2013-07-22','18:55:00',1.02),('10318','2013-07-21','07:10:00',1.25),('10318','2013-07-21','07:15:00',1.46),('10318','2013-07-21','07:20:00',1.64),('10318','2013-07-21','07:25:00',1.83),('10318','2013-07-21','07:30:00',2.06),('10318','2013-07-21','07:35:00',2.35),('10318','2013-07-21','07:40:00',2.59),('10318','2013-07-21','07:45:00',2.82),('10318','2013-07-21','07:50:00',2.95),('10318','2013-07-21','07:55:00',3.08),('10318','2013-07-21','08:00:00',3.21),('10318','2013-07-21','08:05:00',3.32),('10318','2013-07-21','08:10:00',3.56),('10318','2013-07-21','08:15:00',3.74),('10318','2013-07-21','08:20:00',3.92),('10318','2013-07-21','08:25:00',4.12),('10318','2013-07-21','08:30:00',4.3),('10318','2013-07-21','08:35:00',4.47),('10318','2013-07-21','08:40:00',4.64),('10318','2013-07-21','08:45:00',4.79),('10318','2013-07-21','08:50:00',4.81),('10318','2013-07-21','08:55:00',5.16),('10318','2013-07-21','09:00:00',5.32),('10318','2013-07-21','09:05:00',5.48),('10318','2013-07-21','09:10:00',5.67),('10318','2013-07-21','09:15:00',5.83),('10318','2013-07-21','09:20:00',5.95),('10318','2013-07-21','09:25:00',6.06),('10318','2013-07-21','09:30:00',6.2),('10318','2013-07-21','09:35:00',6.34),('10318','2013-07-21','09:40:00',6.48),('10318','2013-07-21','09:45:00',6.6),('10318','2013-07-21','09:50:00',6.7),('10318','2013-07-21','09:55:00',6.85),('10318','2013-07-21','10:00:00',6.94),('10318','2013-07-21','10:05:00',7.08),('10318','2013-07-21','10:10:00',7.2),('10318','2013-07-21','10:15:00',7.27),('10318','2013-07-21','10:20:00',7.42),('10318','2013-07-21','10:25:00',7.54),('10318','2013-07-21','10:30:00',7.61),('10318','2013-07-21','10:35:00',7.7),('10318','2013-07-21','10:40:00',7.84),('10318','2013-07-21','10:45:00',7.94),('10318','2013-07-21','10:50:00',8.01),('10318','2013-07-21','10:55:00',8.01),('10318','2013-07-21','11:00:00',8.09),('10318','2013-07-21','11:05:00',8.17),('10318','2013-07-21','11:10:00',8.17),('10318','2013-07-21','11:15:00',8.19),('10318','2013-07-21','11:20:00',8.34),('10318','2013-07-21','11:25:00',8.45),('10318','2013-07-21','11:30:00',8.47),('10318','2013-07-21','11:35:00',8.48),('10318','2013-07-21','11:40:00',8.57),('10318','2013-07-21','11:45:00',8.59),('10318','2013-07-21','11:50:00',8.59),('10318','2013-07-21','11:55:00',8.71),('10318','2013-07-21','12:00:00',8.69),('10318','2013-07-21','12:05:00',8.63),('10318','2013-07-21','12:10:00',6.77),('10318','2013-07-21','12:15:00',8.03),('10318','2013-07-21','12:20:00',7.11),('10318','2013-07-21','12:25:00',7.18),('10318','2013-07-21','12:30:00',5.15),('10318','2013-07-21','12:35:00',5.28),('10318','2013-07-21','12:40:00',7.45),('10318','2013-07-21','12:45:00',4.41),('10318','2013-07-21','12:50:00',4.54),('10318','2013-07-21','12:55:00',4.28),('10318','2013-07-21','13:00:00',4.25),('10318','2013-07-21','13:05:00',3.97),('10318','2013-07-21','13:10:00',3.75),('10318','2013-07-21','13:15:00',4.55),('10318','2013-07-21','13:20:00',9.71),('10318','2013-07-21','13:25:00',7.05),('10318','2013-07-21','13:30:00',9.85),('10318','2013-07-21','13:35:00',9.11),('10318','2013-07-21','13:40:00',9.88),('10318','2013-07-21','13:45:00',9.43),('10318','2013-07-21','13:50:00',8.99),('10318','2013-07-21','13:55:00',5.91),('10318','2013-07-21','14:00:00',4.04),('10318','2013-07-21','14:05:00',3.34),('10318','2013-07-21','14:10:00',3.12),('10318','2013-07-21','14:15:00',2.99),('10318','2013-07-21','14:20:00',4.12),('10318','2013-07-21','14:25:00',6.27),('10318','2013-07-21','14:30:00',3.12),('10318','2013-07-21','14:35:00',2.54),('10318','2013-07-21','14:40:00',2.33),('10318','2013-07-21','14:45:00',2.54),('10318','2013-07-21','14:50:00',3.81),('10318','2013-07-21','14:55:00',5.07),('10318','2013-07-21','15:00:00',3.61),('10318','2013-07-21','15:05:00',3.76),('10318','2013-07-21','15:10:00',3.8),('10318','2013-07-21','15:15:00',3.46),('10318','2013-07-21','15:20:00',3.72),('10318','2013-07-21','15:25:00',3.44),('10318','2013-07-21','15:30:00',3.18),('10318','2013-07-21','15:35:00',3.37),('10318','2013-07-21','15:40:00',3.66),('10318','2013-07-21','15:45:00',4.1),('10318','2013-07-21','15:50:00',4.5),('10318','2013-07-21','15:55:00',3.33),('10318','2013-07-21','16:00:00',2.96),('10318','2013-07-21','16:05:00',2.26),('10318','2013-07-21','16:10:00',1.96),('10318','2013-07-21','16:15:00',1.72),('10318','2013-07-21','16:20:00',1.58),('10318','2013-07-21','16:25:00',1.56),('10318','2013-07-21','16:30:00',1.62),('10318','2013-07-21','16:35:00',1.87),('10318','2013-07-21','16:40:00',2.05),('10318','2013-07-21','16:45:00',2.13),('10318','2013-07-21','16:50:00',2.16),('10318','2013-07-21','16:55:00',2.32),('10318','2013-07-21','17:00:00',2.58),('10318','2013-07-21','17:05:00',3),('10318','2013-07-21','17:10:00',2.8),('10318','2013-07-21','17:15:00',2.34),('10318','2013-07-21','17:20:00',2.07),('10318','2013-07-21','17:25:00',1.85),('10318','2013-07-21','17:30:00',1.78),('10318','2013-07-21','17:35:00',1.71),('10318','2013-07-21','17:40:00',1.69),('10318','2013-07-21','17:45:00',1.67),('10318','2013-07-21','17:50:00',1.69),('10318','2013-07-21','17:55:00',1.71),('10318','2013-07-21','18:00:00',1.7),('10318','2013-07-21','18:05:00',1.61),('10318','2013-07-21','18:10:00',1.39),('10318','2013-07-21','18:15:00',1.23),('10318','2013-07-21','18:20:00',1.13),('10318','2013-07-21','18:25:00',1.03),('10318','2013-07-21','19:05:00',1.02),('10318','2014-04-07','07:35:00',1.05),('10318','2014-04-07','07:40:00',1.21),('10318','2014-04-07','07:45:00',1.22),('10318','2014-04-07','07:50:00',1.12),('10318','2014-04-07','07:55:00',1.2),('10318','2014-04-07','08:00:00',1.32),('10318','2014-04-07','08:05:00',1.59),('10318','2014-04-07','08:10:00',2.18),('10318','2014-04-07','08:15:00',2.3),('10318','2014-04-07','08:20:00',2.84),('10318','2014-04-07','08:25:00',2.72),('10318','2014-04-07','08:30:00',3.47),('10318','2014-04-07','08:35:00',3.44),('10318','2014-04-07','08:40:00',3.97),('10318','2014-04-07','08:45:00',3.36),('10318','2014-04-07','08:50:00',3.1),('10318','2014-04-07','08:55:00',2.71),('10318','2014-04-07','09:00:00',2.61),('10318','2014-04-07','09:05:00',2.7),('10318','2014-04-07','09:10:00',3.12),('10318','2014-04-07','09:15:00',2.73),('10318','2014-04-07','09:20:00',2.64),('10318','2014-04-07','09:25:00',2.57),('10318','2014-04-07','09:30:00',2.59),('10318','2014-04-07','09:35:00',2.63),('10318','2014-04-07','09:40:00',2.72),('10318','2014-04-07','09:45:00',2.91),('10318','2014-04-07','09:50:00',2.96),('10318','2014-04-07','09:55:00',2.96),('10318','2014-04-07','10:00:00',3.04),('10318','2014-04-07','10:05:00',3.01),('10318','2014-04-07','10:10:00',2.93),('10318','2014-04-07','10:15:00',2.91),('10318','2014-04-07','10:20:00',2.96),('10318','2014-04-07','10:25:00',2.99),('10318','2014-04-07','10:30:00',3.04),('10318','2014-04-07','10:35:00',3.14),('10318','2014-04-07','10:40:00',3.22),('10318','2014-04-07','10:45:00',3.4),('10318','2014-04-07','10:50:00',3.63),('10318','2014-04-07','10:55:00',3.94),('10318','2014-04-07','11:00:00',3.92),('10318','2014-04-07','11:05:00',4.06),('10318','2014-04-07','11:10:00',4.15),('10318','2014-04-07','11:15:00',4.45),('10318','2014-04-07','11:20:00',4.43),('10318','2014-04-07','11:25:00',4.21),('10318','2014-04-07','11:30:00',4.13),('10318','2014-04-07','11:35:00',4.3),('10318','2014-04-07','11:40:00',4.07),('10318','2014-04-07','11:45:00',3.94),('10318','2014-04-07','11:50:00',3.8),('10318','2014-04-07','11:55:00',3.8),('10318','2014-04-07','12:00:00',4.57),('10318','2014-04-07','12:05:00',5.05),('10318','2014-04-07','12:10:00',6.5),('10318','2014-04-07','12:15:00',8.41),('10318','2014-04-07','12:20:00',8.99),('10318','2014-04-07','12:25:00',6.87),('10318','2014-04-07','12:30:00',5.35),('10318','2014-04-07','12:35:00',5.07),('10318','2014-04-07','12:40:00',9.08),('10318','2014-04-07','12:45:00',9.5),('10318','2014-04-07','12:50:00',9.2),('10318','2014-04-07','12:55:00',9.03),('10318','2014-04-07','13:00:00',9.1),('10318','2014-04-07','13:05:00',9.02),('10318','2014-04-07','13:10:00',9.01),('10318','2014-04-07','13:15:00',8.96),('10318','2014-04-07','13:20:00',8.91),('10318','2014-04-07','13:25:00',8.89),('10318','2014-04-07','13:30:00',8.81),('10318','2014-04-07','13:35:00',8.76),('10318','2014-04-07','13:40:00',8.76),('10318','2014-04-07','13:45:00',8.67),('10318','2014-04-07','13:50:00',8.54),('10318','2014-04-07','13:55:00',8.57),('10318','2014-04-07','14:00:00',8.49),('10318','2014-04-07','14:05:00',8.41),('10318','2014-04-07','14:10:00',8.18),('10318','2014-04-07','14:15:00',8.34),('10318','2014-04-07','14:20:00',8.31),('10318','2014-04-07','14:25:00',8.19),('10318','2014-04-07','14:30:00',8.06),('10318','2014-04-07','14:35:00',7.93),('10318','2014-04-07','14:40:00',7.82),('10318','2014-04-07','14:45:00',7.97),('10318','2014-04-07','14:50:00',7.86),('10318','2014-04-07','14:55:00',7.79),('10318','2014-04-07','15:00:00',7.68),('10318','2014-04-07','15:05:00',7.29),('10318','2014-04-07','15:10:00',7.42),('10318','2014-04-07','15:15:00',7.43),('10318','2014-04-07','15:20:00',7.41),('10318','2014-04-07','15:25:00',7.27),('10318','2014-04-07','15:30:00',7.05),('10318','2014-04-07','15:35:00',6.89),('10318','2014-04-07','15:40:00',6.77),('10318','2014-04-07','15:45:00',6.8),('10318','2014-04-07','15:50:00',6.99),('10318','2014-04-07','15:55:00',7.02),('10318','2014-04-07','16:00:00',6.98),('10318','2014-04-07','16:05:00',6.46),('10318','2014-04-07','16:10:00',5.99),('10318','2014-04-07','16:15:00',5.7),('10318','2014-04-07','16:20:00',5.38),('10318','2014-04-07','16:25:00',5.05),('10318','2014-04-07','16:30:00',3.46),('10318','2014-04-07','16:35:00',2.53),('10318','2014-04-07','16:40:00',2.1),('10318','2014-04-07','16:45:00',1.99),('10318','2014-04-07','16:50:00',4.28),('10318','2014-04-07','16:55:00',4.78),('10318','2014-04-07','17:00:00',4.76),('10318','2014-04-07','17:05:00',4.62),('10318','2014-04-07','17:10:00',4.03),('10318','2014-04-07','17:15:00',3.89),('10318','2014-04-07','17:20:00',2.87),('10318','2014-04-07','17:25:00',2.4),('10318','2014-04-07','17:30:00',1.63),('10318','2014-04-07','17:35:00',1.35),('10318','2014-04-07','17:40:00',2.28),('10318','2014-04-07','17:45:00',2.45),('10318','2014-04-07','17:50:00',2.28),('10318','2014-04-07','17:55:00',2.06),('10318','2014-04-07','18:00:00',1.78),('10318','2014-04-07','18:05:00',1.72),('10318','2014-04-07','18:10:00',1.67),('10318','2014-04-07','18:15:00',1.62),('10318','2014-04-07','18:20:00',1.46),('10318','2014-04-07','18:25:00',1.28),('10318','2014-04-07','18:30:00',1.01),('10318','2013-07-20','07:10:00',1.02),('10318','2013-07-20','07:15:00',1.36),('10318','2013-07-20','07:20:00',1.61),('10318','2013-07-20','07:25:00',1.88),('10318','2013-07-20','07:30:00',2.22),('10318','2013-07-20','07:35:00',2.48),('10318','2013-07-20','07:40:00',2.66),('10318','2013-07-20','07:45:00',2.83),('10318','2013-07-20','07:50:00',3.05),('10318','2013-07-20','07:55:00',3.22),('10318','2013-07-20','08:00:00',3.38),('10318','2013-07-20','08:05:00',3.61),('10318','2013-07-20','08:10:00',3.82),('10318','2013-07-20','08:15:00',3.98),('10318','2013-07-20','08:20:00',4.18),('10318','2013-07-20','08:25:00',4.38),('10318','2013-07-20','08:30:00',4.58),('10318','2013-07-20','08:35:00',4.76),('10318','2013-07-20','08:40:00',4.95),('10318','2013-07-20','08:45:00',5.07),('10318','2013-07-20','08:50:00',5.28),('10318','2013-07-20','08:55:00',5.5),('10318','2013-07-20','09:00:00',5.63),('10318','2013-07-20','09:05:00',5.96),('10318','2013-07-20','09:10:00',6.15),('10318','2013-07-20','09:15:00',6.31),('10318','2013-07-20','09:20:00',6.35),('10318','2013-07-20','09:25:00',6.18),('10318','2013-07-20','09:30:00',6.29),('10318','2013-07-20','09:35:00',6.38),('10318','2013-07-20','09:40:00',6.63),('10318','2013-07-20','09:45:00',6.76),('10318','2013-07-20','09:50:00',6.48),('10318','2013-07-20','09:55:00',6.96),('10318','2013-07-20','10:00:00',7.07),('10318','2013-07-20','10:05:00',7.25),('10318','2013-07-20','10:10:00',7.35),('10318','2013-07-20','10:15:00',7.46),('10318','2013-07-20','10:20:00',7.58),('10318','2013-07-20','10:25:00',7.66),('10318','2013-07-20','10:30:00',7.72),('10318','2013-07-20','10:35:00',7.54),('10318','2013-07-20','10:40:00',7.89),('10318','2013-07-20','10:45:00',7.98),('10318','2013-07-20','10:50:00',7.97),('10318','2013-07-20','10:55:00',8.05),('10318','2013-07-20','11:00:00',8.19),('10318','2013-07-20','11:05:00',8.24),('10318','2013-07-20','11:10:00',8.33),('10318','2013-07-20','11:15:00',8.25),('10318','2013-07-20','11:20:00',8.33),('10318','2013-07-20','11:25:00',8.48),('10318','2013-07-20','11:30:00',8.58),('10318','2013-07-20','11:35:00',8.58),('10318','2013-07-20','11:40:00',8.66),('10318','2013-07-20','11:45:00',8.76),('10318','2013-07-20','11:50:00',8.5),('10318','2013-07-20','11:55:00',8.44),('10318','2013-07-20','12:00:00',9.09),('10318','2013-07-20','12:05:00',9.01),('10318','2013-07-20','12:10:00',8.88),('10318','2013-07-20','12:15:00',8.95),('10318','2013-07-20','12:20:00',8.91),('10318','2013-07-20','12:25:00',9.01),('10318','2013-07-20','12:30:00',8.61),('10318','2013-07-20','12:35:00',9.03),('10318','2013-07-20','12:40:00',9.25),('10318','2013-07-20','12:45:00',9.08),('10318','2013-07-20','12:50:00',9.04),('10318','2013-07-20','12:55:00',4.74),('10318','2013-07-20','13:00:00',7.91),('10318','2013-07-20','13:05:00',6.07),('10318','2013-07-20','13:10:00',3.89),('10318','2013-07-20','13:15:00',4.2),('10318','2013-07-20','13:20:00',9.09),('10318','2013-07-20','13:25:00',8.06),('10318','2013-07-20','13:30:00',7.33),('10318','2013-07-20','13:35:00',2.24),('10318','2013-07-20','13:40:00',2.67),('10318','2013-07-20','13:45:00',3.73),('10318','2013-07-20','13:50:00',9.93),('10318','2013-07-20','13:55:00',9.28),('10318','2013-07-20','14:00:00',8.93),('10318','2013-07-20','14:05:00',8.73),('10318','2013-07-20','14:10:00',8.68),('10318','2013-07-20','14:15:00',8.68),('10318','2013-07-20','14:20:00',8.38),('10318','2013-07-20','14:25:00',8.51),('10318','2013-07-20','14:30:00',7.97),('10318','2013-07-20','14:35:00',8.19),('10318','2013-07-20','14:40:00',8.14),('10318','2013-07-20','14:45:00',8.1),('10318','2013-07-20','14:50:00',8.05),('10318','2013-07-20','14:55:00',8.02),('10318','2013-07-20','15:00:00',7.91),('10318','2013-07-20','15:05:00',7.77),('10318','2013-07-20','15:10:00',7.57),('10318','2013-07-20','15:15:00',7.73),('10318','2013-07-20','15:20:00',7.32),('10318','2013-07-20','15:25:00',7.28),('10318','2013-07-20','15:30:00',7.28),('10318','2013-07-20','15:35:00',7.08),('10318','2013-07-20','15:40:00',6.99),('10318','2013-07-20','15:45:00',6.85),('10318','2013-07-20','15:50:00',6.74),('10318','2013-07-20','15:55:00',6.63),('10318','2013-07-20','16:00:00',6.48),('10318','2013-07-20','16:05:00',6.33),('10318','2013-07-20','16:10:00',6.22),('10318','2013-07-20','16:15:00',6.11),('10318','2013-07-20','16:20:00',5.91),('10318','2013-07-20','16:25:00',5.76),('10318','2013-07-20','16:30:00',5.65),('10318','2013-07-20','16:35:00',5.46),('10318','2013-07-20','16:40:00',5.32),('10318','2013-07-20','16:45:00',5.14),('10318','2013-07-20','16:50:00',4.97),('10318','2013-07-20','16:55:00',4.8),('10318','2013-07-20','17:00:00',4.64),('10318','2013-07-20','17:05:00',4.39),('10318','2013-07-20','17:10:00',4.3),('10318','2013-07-20','17:15:00',4.14),('10318','2013-07-20','17:20:00',3.95),('10318','2013-07-20','17:25:00',3.76),('10318','2013-07-20','17:30:00',3.61),('10318','2013-07-20','17:35:00',3.46),('10318','2013-07-20','17:40:00',3.29),('10318','2013-07-20','17:45:00',3.12),('10318','2013-07-20','17:50:00',2.95),('10318','2013-07-20','17:55:00',2.77),('10318','2013-07-20','18:00:00',2.62),('10318','2013-07-20','18:05:00',2.44),('10318','2013-07-20','18:10:00',2.28),('10318','2013-07-20','18:15:00',2.13),('10318','2013-07-20','18:20:00',1.96),('10318','2013-07-20','18:25:00',1.8),('10318','2013-07-20','18:30:00',1.64),('10318','2013-07-20','18:35:00',1.5),('10318','2013-07-20','18:40:00',1.38),('10318','2013-07-20','18:45:00',1.25),('10318','2013-07-20','18:50:00',1.11),('10318','2013-07-20','18:55:00',1.03),('10318','2013-07-19','07:05:00',1.08),('10318','2013-07-19','07:10:00',1.33),('10318','2013-07-19','07:15:00',1.49),('10318','2013-07-19','07:20:00',1.67),('10318','2013-07-19','07:25:00',1.86),('10318','2013-07-19','07:30:00',2.09),('10318','2013-07-19','07:35:00',2.34),('10318','2013-07-19','07:40:00',2.51),('10318','2013-07-19','07:45:00',2.68),('10318','2013-07-19','07:50:00',2.86),('10318','2013-07-19','07:55:00',3.02),('10318','2013-07-19','08:00:00',3.2),('10318','2013-07-19','08:05:00',3.41),('10318','2013-07-19','08:10:00',3.61),('10318','2013-07-19','08:15:00',3.79),('10318','2013-07-19','08:20:00',3.92),('10318','2013-07-19','08:25:00',4.1),('10318','2013-07-19','08:30:00',4.3),('10318','2013-07-19','08:35:00',4.5),('10318','2013-07-19','08:40:00',4.69),('10318','2013-07-19','08:45:00',4.8),('10318','2013-07-19','08:50:00',5.06),('10318','2013-07-19','08:55:00',5.17),('10318','2013-07-19','09:00:00',5.33),('10318','2013-07-19','09:05:00',5.49),('10318','2013-07-19','09:10:00',5.68),('10318','2013-07-19','09:15:00',5.72),('10318','2013-07-19','09:20:00',5.91),('10318','2013-07-19','09:25:00',5.99),('10318','2013-07-19','09:30:00',6.18),('10318','2013-07-19','09:35:00',6.18),('10318','2013-07-19','09:40:00',6.35),('10318','2013-07-19','09:45:00',6.47),('10318','2013-07-19','09:50:00',6.55),('10318','2013-07-19','09:55:00',6.66),('10318','2013-07-19','10:00:00',6.81),('10318','2013-07-19','10:05:00',6.87),('10318','2013-07-19','10:10:00',6.94),('10318','2013-07-19','10:15:00',7.11),('10318','2013-07-19','10:20:00',7.15),('10318','2013-07-19','10:25:00',7.24),('10318','2013-07-19','10:30:00',7.34),('10318','2013-07-19','10:35:00',7.27),('10318','2013-07-19','10:40:00',7.52),('10318','2013-07-19','10:45:00',7.62),('10318','2013-07-19','10:50:00',7.69),('10318','2013-07-19','10:55:00',7.75),('10318','2013-07-19','11:00:00',7.79),('10318','2013-07-19','11:05:00',7.87),('10318','2013-07-19','11:10:00',7.93),('10318','2013-07-19','11:15:00',7.97),('10318','2013-07-19','11:20:00',8.04),('10318','2013-07-19','11:25:00',8.12),('10318','2013-07-19','11:30:00',8.04),('10318','2013-07-19','11:35:00',7.72),('10318','2013-07-19','11:40:00',7.91),('10318','2013-07-19','11:45:00',7.79),('10318','2013-07-19','11:50:00',4.6),('10318','2013-07-19','11:55:00',7.3),('10318','2013-07-19','12:00:00',7.65),('10318','2013-07-19','12:05:00',6.22),('10318','2013-07-19','12:10:00',7.65),('10318','2013-07-19','12:15:00',8.75),('10318','2013-07-19','12:20:00',8.81),('10318','2013-07-19','12:25:00',9.08),('10318','2013-07-19','12:30:00',8.78),('10318','2013-07-19','12:35:00',8.61),('10318','2013-07-19','12:40:00',6.3),('10318','2013-07-19','12:45:00',8.77),('10318','2013-07-19','12:50:00',9.03),('10318','2013-07-19','12:55:00',9.02),('10318','2013-07-19','13:00:00',9.12),('10318','2013-07-19','13:05:00',8.93),('10318','2013-07-19','13:10:00',8.25),('10318','2013-07-19','13:15:00',6.53),('10318','2013-07-19','13:20:00',9.04),('10318','2013-07-19','13:25:00',8.92),('10318','2013-07-19','13:30:00',9.07),('10318','2013-07-19','13:35:00',8.87),('10318','2013-07-19','13:40:00',9),('10318','2013-07-19','13:45:00',9),('10318','2013-07-19','13:50:00',8.93),('10318','2013-07-19','13:55:00',8.89),('10318','2013-07-19','14:00:00',8.91),('10318','2013-07-19','14:05:00',8.74),('10318','2013-07-19','14:10:00',8.76),('10318','2013-07-19','14:15:00',8.66),('10318','2013-07-19','14:20:00',7.19),('10318','2013-07-19','14:25:00',8.69),('10318','2013-07-19','14:30:00',8.61),('10318','2013-07-19','14:35:00',8.49),('10318','2013-07-19','14:40:00',8.44),('10318','2013-07-19','14:45:00',8.01),('10318','2013-07-19','14:50:00',8.29),('10318','2013-07-19','14:55:00',7.27),('10318','2013-07-19','15:00:00',8.09),('10318','2013-07-19','15:05:00',6.62),('10318','2013-07-19','15:10:00',8.11),('10318','2013-07-19','15:15:00',3.26),('10318','2013-07-19','15:20:00',6.73),('10318','2013-07-19','15:25:00',7.65),('10318','2013-07-19','15:30:00',5.81),('10318','2013-07-19','15:35:00',7.33),('10318','2013-07-19','15:40:00',7.13),('10318','2013-07-19','15:45:00',7.22),('10318','2013-07-19','15:50:00',7.06),('10318','2013-07-19','15:55:00',6.86),('10318','2013-07-19','16:00:00',6.72),('10318','2013-07-19','16:05:00',6.56),('10318','2013-07-19','16:10:00',6.39),('10318','2013-07-19','16:15:00',6.34),('10318','2013-07-19','16:20:00',6.15),('10318','2013-07-19','16:25:00',6.04),('10318','2013-07-19','16:30:00',5.93),('10318','2013-07-19','16:35:00',5.84),('10318','2013-07-19','16:40:00',5.7),('10318','2013-07-19','16:45:00',5.63),('10318','2013-07-19','16:50:00',5.25),('10318','2013-07-19','16:55:00',5.7),('10318','2013-07-19','17:00:00',5.27),('10318','2013-07-19','17:05:00',5.09),('10318','2013-07-19','17:10:00',4.89),('10318','2013-07-19','17:15:00',3.36),('10318','2013-07-19','17:20:00',3.96),('10318','2013-07-19','17:25:00',3.43),('10318','2013-07-19','17:30:00',4.06),('10318','2013-07-19','17:35:00',4.02),('10318','2013-07-19','17:40:00',3.28),('10318','2013-07-19','17:45:00',2.9),('10318','2013-07-19','17:50:00',2.19),('10318','2013-07-19','17:55:00',1.78),('10318','2013-07-19','18:00:00',1.52),('10318','2013-07-19','18:05:00',1.4),('10318','2013-07-19','18:10:00',1.29),('10318','2013-07-19','18:15:00',1.04),('10318','2013-07-19','18:30:00',1.08),('10318','2013-07-19','18:35:00',1.14),('10318','2013-07-19','18:40:00',1.19),('10318','2013-07-19','18:45:00',1.19),('10318','2013-07-19','18:50:00',1.12),('10318','2013-07-19','18:55:00',1.12),('10318','2013-07-19','19:00:00',1.06),('10318','2013-07-18','07:05:00',1.13),('10318','2013-07-18','07:10:00',1.37),('10318','2013-07-18','07:15:00',1.55),('10318','2013-07-18','07:20:00',1.77),('10318','2013-07-18','07:25:00',1.99),('10318','2013-07-18','07:30:00',2.26),('10318','2013-07-18','07:35:00',2.52),('10318','2013-07-18','07:40:00',2.71),('10318','2013-07-18','07:45:00',2.93),('10318','2013-07-18','07:50:00',3.11),('10318','2013-07-18','07:55:00',3.29),('10318','2013-07-18','08:00:00',3.47),('10318','2013-07-18','08:05:00',3.65),('10318','2013-07-18','08:10:00',3.83),('10318','2013-07-18','08:15:00',3.91),('10318','2013-07-18','08:20:00',4.18),('10318','2013-07-18','08:25:00',4.37),('10318','2013-07-18','08:30:00',4.57),('10318','2013-07-18','08:35:00',4.74),('10318','2013-07-18','08:40:00',4.92),('10318','2013-07-18','08:45:00',5.08),('10318','2013-07-18','08:50:00',5.28),('10318','2013-07-18','08:55:00',5.44),('10318','2013-07-18','09:00:00',5.58),('10318','2013-07-18','09:05:00',5.75),('10318','2013-07-18','09:10:00',5.92),('10318','2013-07-18','09:15:00',6.07),('10318','2013-07-18','09:20:00',6.22),('10318','2013-07-18','09:25:00',6.34),('10318','2013-07-18','09:30:00',6.49),('10318','2013-07-18','09:35:00',6.58),('10318','2013-07-18','09:40:00',6.7),('10318','2013-07-18','09:45:00',6.83),('10318','2013-07-18','09:50:00',6.93),('10318','2013-07-18','09:55:00',7.06),('10318','2013-07-18','10:00:00',7.05),('10318','2013-07-18','10:05:00',7.29),('10318','2013-07-18','10:10:00',7.38),('10318','2013-07-18','10:15:00',7.5),('10318','2013-07-18','10:20:00',7.6),('10318','2013-07-18','10:25:00',7.72),('10318','2013-07-18','10:30:00',7.85),('10318','2013-07-18','10:35:00',7.96),('10318','2013-07-18','10:40:00',8.01),('10318','2013-07-18','10:45:00',8.07),('10318','2013-07-18','10:50:00',8.1),('10318','2013-07-18','10:55:00',8.12),('10318','2013-07-18','11:00:00',8.2),('10318','2013-07-18','11:05:00',8.25),('10318','2013-07-18','11:10:00',8.3),('10318','2013-07-18','11:15:00',8.28),('10318','2013-07-18','11:20:00',8.37),('10318','2013-07-18','11:25:00',8.44),('10318','2013-07-18','11:30:00',8.48),('10318','2013-07-18','11:35:00',8.53),('10318','2013-07-18','11:40:00',8.59),('10318','2013-07-18','11:45:00',8.65),('10318','2013-07-18','11:50:00',8.67),('10318','2013-07-18','11:55:00',8.74),('10318','2013-07-18','12:00:00',8.72),('10318','2013-07-18','12:05:00',8.74),('10318','2013-07-18','12:10:00',8.73),('10318','2013-07-18','12:15:00',8.66),('10318','2013-07-18','12:20:00',8.86),('10318','2013-07-18','12:25:00',8.89),('10318','2013-07-18','12:30:00',8.77),('10318','2013-07-18','12:35:00',8.92),('10318','2013-07-18','12:40:00',9.01),('10318','2013-07-18','12:45:00',8.99),('10318','2013-07-18','12:50:00',8.89),('10318','2013-07-18','12:55:00',8.81),('10318','2013-07-18','13:00:00',8.79),('10318','2013-07-18','13:05:00',8.9),('10318','2013-07-18','13:10:00',8.99),('10318','2013-07-18','13:15:00',9.04),('10318','2013-07-18','13:20:00',8.91),('10318','2013-07-18','13:25:00',8.83),('10318','2013-07-18','13:30:00',8.86),('10318','2013-07-18','13:35:00',8.92),('10318','2013-07-18','13:40:00',8.82),('10318','2013-07-18','13:45:00',8.81),('10318','2013-07-18','13:50:00',8.78),('10318','2013-07-18','13:55:00',8.65),('10318','2013-07-18','14:00:00',8.59),('10318','2013-07-18','14:05:00',8.62),('10318','2013-07-18','14:10:00',8.57),('10318','2013-07-18','14:15:00',8.58),('10318','2013-07-18','14:20:00',8.49),('10318','2013-07-18','14:25:00',8.4),('10318','2013-07-18','14:30:00',8.31),('10318','2013-07-18','14:35:00',8.17),('10318','2013-07-18','14:40:00',8.15),('10318','2013-07-18','14:45:00',8.1),('10318','2013-07-18','14:50:00',7.85),('10318','2013-07-18','14:55:00',7.85),('10318','2013-07-18','15:00:00',7.74),('10318','2013-07-18','15:05:00',7.65),('10318','2013-07-18','15:10:00',7.62),('10318','2013-07-18','15:15:00',7.47),('10318','2013-07-18','15:20:00',7.36),('10318','2013-07-18','15:25:00',7.28),('10318','2013-07-18','15:30:00',7.17),('10318','2013-07-18','15:35:00',7.01),('10318','2013-07-18','15:40:00',6.93),('10318','2013-07-18','15:45:00',6.74),('10318','2013-07-18','15:50:00',6.66),('10318','2013-07-18','15:55:00',6.49),('10318','2013-07-18','16:00:00',6.39),('10318','2013-07-18','16:05:00',6.28),('10318','2013-07-18','16:10:00',6.14),('10318','2013-07-18','16:15:00',5.96),('10318','2013-07-18','16:20:00',5.83),('10318','2013-07-18','16:25:00',5.69),('10318','2013-07-18','16:30:00',5.52),('10318','2013-07-18','16:35:00',5.2),('10318','2013-07-18','16:40:00',5.23),('10318','2013-07-18','16:45:00',5.03),('10318','2013-07-18','16:50:00',4.87),('10318','2013-07-18','16:55:00',4.74),('10318','2013-07-18','17:00:00',4.59),('10318','2013-07-18','17:05:00',4.34),('10318','2013-07-18','17:10:00',4.24),('10318','2013-07-18','17:15:00',4.1),('10318','2013-07-18','17:20:00',3.93),('10318','2013-07-18','17:25:00',3.75),('10318','2013-07-18','17:30:00',3.57),('10318','2013-07-18','17:35:00',3.36),('10318','2013-07-18','17:40:00',3.21),('10318','2013-07-18','17:45:00',2.96),('10318','2013-07-18','17:50:00',2.75),('10318','2013-07-18','17:55:00',2.31),('10318','2013-07-18','18:00:00',2.27),('10318','2013-07-18','18:05:00',2.07),('10318','2013-07-18','18:10:00',2.19),('10318','2013-07-18','18:15:00',1.96),('10318','2013-07-18','18:20:00',1.8),('10318','2013-07-18','18:25:00',1.56),('10318','2013-07-18','18:45:00',1.2),('10318','2013-07-18','18:50:00',1.36),('10318','2013-07-18','18:55:00',1.32),('10318','2013-07-18','19:00:00',1.25),('10318','2013-07-17','07:05:00',1.22),('10318','2013-07-17','07:10:00',1.47),('10318','2013-07-17','07:15:00',1.67),('10318','2013-07-17','07:20:00',1.88),('10318','2013-07-17','07:25:00',2.07),('10318','2013-07-17','07:30:00',2.38),('10318','2013-07-17','07:35:00',2.61),('10318','2013-07-17','07:40:00',2.8),('10318','2013-07-17','07:45:00',2.96),('10318','2013-07-17','07:50:00',3.17),('10318','2013-07-17','07:55:00',3.39),('10318','2013-07-17','08:00:00',3.59),('10318','2013-07-17','08:05:00',3.82),('10318','2013-07-17','08:10:00',3.96),('10318','2013-07-17','08:15:00',4.17),('10318','2013-07-17','08:20:00',4.36),('10318','2013-07-17','08:25:00',4.56),('10318','2013-07-17','08:30:00',4.8),('10318','2013-07-17','08:35:00',5),('10318','2013-07-17','08:40:00',5.15),('10318','2013-07-17','08:45:00',5.32),('10318','2013-07-17','08:50:00',5.51),('10318','2013-07-17','08:55:00',5.7),('10318','2013-07-17','09:00:00',5.74),('10318','2013-07-17','09:05:00',6),('10318','2013-07-17','09:10:00',6.15),('10318','2013-07-17','09:15:00',6.28),('10318','2013-07-17','09:20:00',6.43),('10318','2013-07-17','09:25:00',6.54),('10318','2013-07-17','09:30:00',6.68),('10318','2013-07-17','09:35:00',6.83),('10318','2013-07-17','09:40:00',6.99),('10318','2013-07-17','09:45:00',7.1),('10318','2013-07-17','09:50:00',7.18),('10318','2013-07-17','09:55:00',7.29),('10318','2013-07-17','10:00:00',7.38),('10318','2013-07-17','10:05:00',7.46),('10318','2013-07-17','10:10:00',7.59),('10318','2013-07-17','10:15:00',7.69),('10318','2013-07-17','10:20:00',7.82),('10318','2013-07-17','10:25:00',7.99),('10318','2013-07-17','10:30:00',8.09),('10318','2013-07-17','10:35:00',8.08),('10318','2013-07-17','10:40:00',8.15),('10318','2013-07-17','10:45:00',7.98),('10318','2013-07-17','10:50:00',8.28),('10318','2013-07-17','10:55:00',8.4),('10318','2013-07-17','11:00:00',8.47),('10318','2013-07-17','11:05:00',8.56),('10318','2013-07-17','11:10:00',8.69),('10318','2013-07-17','11:15:00',8.72),('10318','2013-07-17','11:20:00',8.79),('10318','2013-07-17','11:25:00',8.87),('10318','2013-07-17','11:30:00',8.89),('10318','2013-07-17','11:35:00',8.92),('10318','2013-07-17','11:40:00',9.01),('10318','2013-07-17','11:45:00',9.07),('10318','2013-07-17','11:50:00',9.11),('10318','2013-07-17','11:55:00',9.1),('10318','2013-07-17','12:00:00',9.1),('10318','2013-07-17','12:05:00',9.13),('10318','2013-07-17','12:10:00',9.1),('10318','2013-07-17','12:15:00',9.07),('10318','2013-07-17','12:20:00',9.22),('10318','2013-07-17','12:25:00',9.16),('10318','2013-07-17','12:30:00',9.12),('10318','2013-07-17','12:35:00',9.16),('10318','2013-07-17','12:40:00',9.19),('10318','2013-07-17','12:45:00',9.14),('10318','2013-07-17','12:50:00',9.23),('10318','2013-07-17','12:55:00',9.16),('10318','2013-07-17','13:00:00',9.1),('10318','2013-07-17','13:05:00',9.05),('10318','2013-07-17','13:10:00',9.14),('10318','2013-07-17','13:15:00',9.14),('10318','2013-07-17','13:20:00',9.08),('10318','2013-07-17','13:25:00',8.98),('10318','2013-07-17','13:30:00',8.84),('10318','2013-07-17','13:35:00',8.85),('10318','2013-07-17','13:40:00',8.86),('10318','2013-07-17','13:45:00',8.77),('10318','2013-07-17','13:50:00',8.72),('10318','2013-07-17','13:55:00',8.74),('10318','2013-07-17','14:00:00',8.64),('10318','2013-07-17','14:05:00',8.59),('10318','2013-07-17','14:10:00',8.56),('10318','2013-07-17','14:15:00',8.57),('10318','2013-07-17','14:20:00',8.54),('10318','2013-07-17','14:25:00',8.43),('10318','2013-07-17','14:30:00',8.41),('10318','2013-07-17','14:35:00',8.33),('10318','2013-07-17','14:40:00',8.34),('10318','2013-07-17','14:45:00',8.2),('10318','2013-07-17','14:50:00',8.08),('10318','2013-07-17','14:55:00',8.16),('10318','2013-07-17','15:00:00',7.75),('10318','2013-07-17','15:05:00',7.92),('10318','2013-07-17','15:10:00',7.66),('10318','2013-07-17','15:15:00',7.48),('10318','2013-07-17','15:20:00',7.65),('10318','2013-07-17','15:25:00',7.53),('10318','2013-07-17','15:30:00',7.21),('10318','2013-07-17','15:35:00',5.98),('10318','2013-07-17','15:40:00',4.32),('10318','2013-07-17','15:45:00',6.39),('10318','2013-07-17','15:50:00',3.56),('10318','2013-07-17','15:55:00',3.34),('10318','2013-07-17','16:00:00',3.89),('10318','2013-07-17','16:05:00',5.41),('10318','2013-07-17','16:10:00',4.9),('10318','2013-07-17','16:15:00',6.36),('10318','2013-07-17','16:20:00',6.05),('10318','2013-07-17','16:25:00',5.74),('10318','2013-07-17','16:30:00',5.64),('10318','2013-07-17','16:35:00',5.55),('10318','2013-07-17','16:40:00',5.44),('10318','2013-07-17','16:45:00',5.23),('10318','2013-07-17','16:50:00',5.09),('10318','2013-07-17','16:55:00',4.94),('10318','2013-07-17','17:00:00',4.77),('10318','2013-07-17','17:05:00',4.56),('10318','2013-07-17','17:10:00',4.39),('10318','2013-07-17','17:15:00',4.2),('10318','2013-07-17','17:20:00',3.96),('10318','2013-07-17','17:25:00',3.85),('10318','2013-07-17','17:30:00',3.71),('10318','2013-07-17','17:35:00',3.5),('10318','2013-07-17','17:40:00',3.28),('10318','2013-07-17','17:45:00',3.11),('10318','2013-07-17','17:50:00',2.97),('10318','2013-07-17','17:55:00',2.8),('10318','2013-07-17','18:00:00',2.61),('10318','2013-07-17','18:05:00',2.44),('10318','2013-07-17','18:10:00',2.26),('10318','2013-07-17','18:15:00',2.12),('10318','2013-07-17','18:20:00',1.97),('10318','2013-07-17','18:25:00',1.83),('10318','2013-07-17','18:30:00',1.68),('10318','2013-07-17','18:35:00',1.55),('10318','2013-07-17','18:40:00',1.41),('10318','2013-07-17','18:45:00',1.28),('10318','2013-07-17','18:50:00',1.16),('10318','2013-07-17','18:55:00',1.03),('10318','2013-07-16','07:05:00',1.25),('10318','2013-07-16','07:10:00',1.45),('10318','2013-07-16','07:15:00',1.67),('10318','2013-07-16','07:20:00',1.91),('10318','2013-07-16','07:25:00',2.15),('10318','2013-07-16','07:30:00',2.41),('10318','2013-07-16','07:35:00',2.63),('10318','2013-07-16','07:40:00',2.8),('10318','2013-07-16','07:45:00',2.9),('10318','2013-07-16','07:50:00',3.17),('10318','2013-07-16','07:55:00',3.36),('10318','2013-07-16','08:00:00',3.53),('10318','2013-07-16','08:05:00',3.72),('10318','2013-07-16','08:10:00',3.92),('10318','2013-07-16','08:15:00',4.08),('10318','2013-07-16','08:20:00',4.27),('10318','2013-07-16','08:25:00',4.43),('10318','2013-07-16','08:30:00',4.6),('10318','2013-07-16','08:35:00',4.78),('10318','2013-07-16','08:40:00',4.91),('10318','2013-07-16','08:45:00',5.08),('10318','2013-07-16','08:50:00',5.28),('10318','2013-07-16','08:55:00',5.47),('10318','2013-07-16','09:00:00',5.62),('10318','2013-07-16','09:05:00',5.73),('10318','2013-07-16','09:10:00',5.88),('10318','2013-07-16','09:15:00',5.96),('10318','2013-07-16','09:20:00',6.14),('10318','2013-07-16','09:25:00',6.33),('10318','2013-07-16','09:30:00',6.47),('10318','2013-07-16','09:35:00',6.62),('10318','2013-07-16','09:40:00',6.76),('10318','2013-07-16','09:45:00',6.9),('10318','2013-07-16','09:50:00',7.02),('10318','2013-07-16','09:55:00',7.13),('10318','2013-07-16','10:00:00',7.21),('10318','2013-07-16','10:05:00',7.31),('10318','2013-07-16','10:10:00',7.5),('10318','2013-07-16','10:15:00',7.62),('10318','2013-07-16','10:20:00',7.68),('10318','2013-07-16','10:25:00',7.78),('10318','2013-07-16','10:30:00',7.85),('10318','2013-07-16','10:35:00',7.95),('10318','2013-07-16','10:40:00',8.04),('10318','2013-07-16','10:45:00',8.02),('10318','2013-07-16','10:50:00',8.22),('10318','2013-07-16','10:55:00',8.31),('10318','2013-07-16','11:00:00',8.39),('10318','2013-07-16','11:05:00',8.48),('10318','2013-07-16','11:10:00',8.53),('10318','2013-07-16','11:15:00',8.64),('10318','2013-07-16','11:20:00',8.68),('10318','2013-07-16','11:25:00',8.69),('10318','2013-07-16','11:30:00',8.72),('10318','2013-07-16','11:35:00',8.7),('10318','2013-07-16','11:40:00',8.76),('10318','2013-07-16','11:45:00',8.76),('10318','2013-07-16','11:50:00',8.87),('10318','2013-07-16','11:55:00',8.98),('10318','2013-07-16','12:00:00',9.02),('10318','2013-07-16','12:05:00',9.06),('10318','2013-07-16','12:10:00',9.07),('10318','2013-07-16','12:15:00',9.11),('10318','2013-07-16','12:20:00',9.18),('10318','2013-07-16','12:25:00',9.19),('10318','2013-07-16','12:30:00',9.08),('10318','2013-07-16','12:35:00',9.22),('10318','2013-07-16','12:40:00',9.25),('10318','2013-07-16','12:45:00',9.27),('10318','2013-07-16','12:50:00',9.25),('10318','2013-07-16','12:55:00',9.28),('10318','2013-07-16','13:00:00',9.2),('10318','2013-07-16','13:05:00',9.16),('10318','2013-07-16','13:10:00',9.17),('10318','2013-07-16','13:15:00',9.07),('10318','2013-07-16','13:20:00',9.07),('10318','2013-07-16','13:25:00',9.02),('10318','2013-07-16','13:30:00',8.95),('10318','2013-07-16','13:35:00',8.96),('10318','2013-07-16','13:40:00',9),('10318','2013-07-16','13:45:00',9.06),('10318','2013-07-16','13:50:00',8.09),('10318','2013-07-16','13:55:00',7.63),('10318','2013-07-16','14:00:00',8.49),('10318','2013-07-16','14:05:00',6.27),('10318','2013-07-16','14:10:00',8.89),('10318','2013-07-16','14:15:00',8.65),('10318','2013-07-16','14:20:00',8.84),('10318','2013-07-16','14:25:00',8.65),('10318','2013-07-16','14:30:00',8.47),('10318','2013-07-16','14:35:00',8.4),('10318','2013-07-16','14:40:00',8.33),('10318','2013-07-16','14:45:00',8.22),('10318','2013-07-16','14:50:00',8.06),('10318','2013-07-16','14:55:00',7.98),('10318','2013-07-16','15:00:00',7.96),('10318','2013-07-16','15:05:00',7.86),('10318','2013-07-16','15:10:00',7.72),('10318','2013-07-16','15:15:00',7.61),('10318','2013-07-16','15:20:00',7.55),('10318','2013-07-16','15:25:00',7.5),('10318','2013-07-16','15:30:00',6.39),('10318','2013-07-16','15:35:00',5.8),('10318','2013-07-16','15:40:00',4.48),('10318','2013-07-16','15:45:00',5.53),('10318','2013-07-16','15:50:00',6.85),('10318','2013-07-16','15:55:00',6.66),('10318','2013-07-16','16:00:00',6.48),('10318','2013-07-16','16:05:00',6.6),('10318','2013-07-16','16:10:00',6.4),('10318','2013-07-16','16:15:00',6.04),('10318','2013-07-16','16:20:00',5.96),('10318','2013-07-16','16:25:00',5.31),('10318','2013-07-16','16:30:00',4.68),('10318','2013-07-16','16:35:00',3.16),('10318','2013-07-16','16:40:00',3.86),('10318','2013-07-16','16:45:00',4.88),('10318','2013-07-16','16:50:00',5.95),('10318','2013-07-16','16:55:00',4.34),('10318','2013-07-16','17:00:00',3.91),('10318','2013-07-16','17:05:00',3.89),('10318','2013-07-16','17:10:00',4.57),('10318','2013-07-16','17:15:00',3.88),('10318','2013-07-16','17:20:00',4.42),('10318','2013-07-16','17:25:00',4.48),('10318','2013-07-16','17:30:00',3.87),('10318','2013-07-16','17:35:00',3.88),('10318','2013-07-16','17:40:00',3.86),('10318','2013-07-16','17:45:00',3.24),('10318','2013-07-16','17:50:00',2.28),('10318','2013-07-16','17:55:00',2.83),('10318','2013-07-16','18:00:00',1.74),('10318','2013-07-16','18:05:00',2.46),('10318','2013-07-16','18:10:00',2.28),('10318','2013-07-16','18:15:00',2.15),('10318','2013-07-16','18:20:00',1.89),('10318','2013-07-16','18:25:00',1.86),('10318','2013-07-16','18:30:00',1.47),('10318','2013-07-16','18:35:00',1.62),('10318','2013-07-16','18:40:00',1.4),('10318','2013-07-16','18:45:00',1.33),('10318','2013-07-16','18:50:00',1.15),('10318','2013-07-16','18:55:00',1.01),('10318','2013-07-15','07:00:00',1.06),('10318','2013-07-15','07:05:00',1.34),('10318','2013-07-15','07:10:00',1.55),('10318','2013-07-15','07:15:00',1.76),('10318','2013-07-15','07:20:00',1.94),('10318','2013-07-15','07:25:00',2.23),('10318','2013-07-15','07:30:00',2.49),('10318','2013-07-15','07:35:00',2.72),('10318','2013-07-15','07:40:00',2.9),('10318','2013-07-15','07:45:00',3.08),('10318','2013-07-15','07:50:00',3.28),('10318','2013-07-15','07:55:00',3.47),('10318','2013-07-15','08:00:00',3.66),('10318','2013-07-15','08:05:00',3.87),('10318','2013-07-15','08:10:00',4.07),('10318','2013-07-15','08:15:00',4.26),('10318','2013-07-15','08:20:00',4.44),('10318','2013-07-15','08:25:00',4.63),('10318','2013-07-15','08:30:00',4.73),('10318','2013-07-15','08:35:00',5.02),('10318','2013-07-15','08:40:00',5.19),('10318','2013-07-15','08:45:00',5.36),('10318','2013-07-15','08:50:00',5.52),('10318','2013-07-15','08:55:00',5.69),('10318','2013-07-15','09:00:00',5.84),('10318','2013-07-15','09:05:00',6),('10318','2013-07-15','09:10:00',6.15),('10318','2013-07-15','09:15:00',6.3),('10318','2013-07-15','09:20:00',6.44),('10318','2013-07-15','09:25:00',6.63),('10318','2013-07-15','09:30:00',6.77),('10318','2013-07-15','09:35:00',6.89),('10318','2013-07-15','09:40:00',7.01),('10318','2013-07-15','09:45:00',7.09),('10318','2013-07-15','09:50:00',7.23),('10318','2013-07-15','09:55:00',7.36),('10318','2013-07-15','10:00:00',7.47),('10318','2013-07-15','10:05:00',7.56),('10318','2013-07-15','10:10:00',7.66),('10318','2013-07-15','10:15:00',7.51),('10318','2013-07-15','10:20:00',7.8),('10318','2013-07-15','10:25:00',7.9),('10318','2013-07-15','10:30:00',7.97),('10318','2013-07-15','10:35:00',8.04),('10318','2013-07-15','10:40:00',8.09),('10318','2013-07-15','10:45:00',8.19),('10318','2013-07-15','10:50:00',8.27),('10318','2013-07-15','10:55:00',8.32),('10318','2013-07-15','11:00:00',8.4),('10318','2013-07-15','11:05:00',8.46),('10318','2013-07-15','11:10:00',8.52),('10318','2013-07-15','11:15:00',8.61),('10318','2013-07-15','11:20:00',8.68),('10318','2013-07-15','11:25:00',8.74),('10318','2013-07-15','11:30:00',8.78),('10318','2013-07-15','11:35:00',8.83),('10318','2013-07-15','11:40:00',8.9),('10318','2013-07-15','11:45:00',8.93),('10318','2013-07-15','11:50:00',8.92),('10318','2013-07-15','11:55:00',8.95),('10318','2013-07-15','12:00:00',8.91),('10318','2013-07-15','12:05:00',8.91),('10318','2013-07-15','12:10:00',8.92),('10318','2013-07-15','12:15:00',9.02),('10318','2013-07-15','12:20:00',9.01),('10318','2013-07-15','12:25:00',8.97),('10318','2013-07-15','12:30:00',9),('10318','2013-07-15','12:35:00',9.01),('10318','2013-07-15','12:40:00',8.98),('10318','2013-07-15','12:45:00',8.92),('10318','2013-07-15','12:50:00',8.96),('10318','2013-07-15','12:55:00',9.05),('10318','2013-07-15','13:00:00',9.16),('10318','2013-07-15','13:05:00',8.67),('10318','2013-07-15','13:10:00',8.81),('10318','2013-07-15','13:15:00',8.87),('10318','2013-07-15','13:20:00',8.99),('10318','2013-07-15','13:25:00',9.28),('10318','2013-07-15','13:30:00',9.36),('10318','2013-07-15','13:35:00',8.45),('10318','2013-07-15','13:40:00',8.66),('10318','2013-07-15','13:45:00',6.63),('10318','2013-07-15','13:50:00',8.61),('10318','2013-07-15','13:55:00',8.11),('10318','2013-07-15','14:00:00',2.47),('10318','2013-07-15','14:05:00',5.8),('10318','2013-07-15','14:10:00',9.31),('10318','2013-07-15','14:15:00',6.15),('10318','2013-07-15','14:20:00',6.11),('10318','2013-07-15','14:25:00',3.79),('10318','2013-07-15','14:30:00',3.22),('10318','2013-07-15','14:35:00',2.41),('10318','2013-07-15','14:40:00',7.06),('10318','2013-07-15','14:45:00',7.18),('10318','2013-07-15','14:50:00',8.38),('10318','2013-07-15','14:55:00',8.24),('10318','2013-07-15','15:00:00',8.04),('10318','2013-07-15','15:05:00',8.01),('10318','2013-07-15','15:10:00',7.75),('10318','2013-07-15','15:15:00',7.61),('10318','2013-07-15','15:20:00',6.85),('10318','2013-07-15','15:25:00',3.3),('10318','2013-07-15','15:30:00',1.63),('10318','2013-07-15','15:35:00',2.31),('10318','2013-07-15','15:40:00',7.45),('10318','2013-07-15','15:45:00',6.29),('10318','2013-07-15','15:50:00',6.73),('10318','2013-07-15','15:55:00',6.84),('10318','2013-07-15','16:00:00',6.73),('10318','2013-07-15','16:05:00',6.43),('10318','2013-07-15','16:10:00',6.28),('10318','2013-07-15','16:15:00',6.1),('10318','2013-07-15','16:20:00',5.93),('10318','2013-07-15','16:25:00',5.83),('10318','2013-07-15','16:30:00',5.65),('10318','2013-07-15','16:35:00',5.48),('10318','2013-07-15','16:40:00',5.33),('10318','2013-07-15','16:45:00',5.06),('10318','2013-07-15','16:50:00',5.03),('10318','2013-07-15','16:55:00',4.89),('10318','2013-07-15','17:00:00',4.76),('10318','2013-07-15','17:05:00',4.56),('10318','2013-07-15','17:10:00',4.37),('10318','2013-07-15','17:15:00',4.19),('10318','2013-07-15','17:20:00',4.06),('10318','2013-07-15','17:25:00',3.89),('10318','2013-07-15','17:30:00',3.73),('10318','2013-07-15','17:35:00',3.53),('10318','2013-07-15','17:40:00',3.31),('10318','2013-07-15','17:45:00',3.14),('10318','2013-07-15','17:50:00',3),('10318','2013-07-15','17:55:00',2.81),('10318','2013-07-15','18:00:00',2.64),('10318','2013-07-15','18:05:00',2.51),('10318','2013-07-15','18:10:00',2.34),('10318','2013-07-15','18:15:00',2.18),('10318','2013-07-15','18:20:00',2),('10318','2013-07-15','18:25:00',1.88),('10318','2013-07-15','18:30:00',1.73),('10318','2013-07-15','18:35:00',1.54),('10318','2013-07-15','18:40:00',1.46),('10318','2013-07-15','18:45:00',1.33),('10318','2013-07-15','18:50:00',1.22),('10318','2013-07-15','18:55:00',1.12),('10318','2013-07-15','19:00:00',1.03),('10318','2013-07-14','07:35:00',1.46),('10318','2013-07-14','07:40:00',1.37),('10318','2013-07-14','07:45:00',1.93),('10318','2013-07-14','07:50:00',2.69),('10318','2013-07-14','07:55:00',3.08),('10318','2013-07-14','08:00:00',2.83),('10318','2013-07-14','08:05:00',2.94),('10318','2013-07-14','08:10:00',4.01),('10318','2013-07-14','08:15:00',3.71),('10318','2013-07-14','08:20:00',4.28),('10318','2013-07-14','08:25:00',2.15),('10318','2013-07-14','08:30:00',2.41),('10318','2013-07-14','08:35:00',2.84),('10318','2013-07-14','08:40:00',2.37),('10318','2013-07-14','08:45:00',2.2),('10318','2013-07-14','08:50:00',2.56),('10318','2013-07-14','08:55:00',2.72),('10318','2013-07-14','09:00:00',4.75),('10318','2013-07-14','09:05:00',3.27),('10318','2013-07-14','09:10:00',3.49),('10318','2013-07-14','09:15:00',4.15),('10318','2013-07-14','09:20:00',4.73),('10318','2013-07-14','09:25:00',6.6),('10318','2013-07-14','09:30:00',4.67),('10318','2013-07-14','09:35:00',5.19),('10318','2013-07-14','09:40:00',3.8),('10318','2013-07-14','09:45:00',3.71),('10318','2013-07-14','09:50:00',3.57),('10318','2013-07-14','09:55:00',3.84),('10318','2013-07-14','10:00:00',3.84),('10318','2013-07-14','10:05:00',4.12),('10318','2013-07-14','10:10:00',3.53),('10318','2013-07-14','10:15:00',4.24),('10318','2013-07-14','10:20:00',6.79),('10318','2013-07-14','10:25:00',8.41),('10318','2013-07-14','10:30:00',6.73),('10318','2013-07-14','10:35:00',6.93),('10318','2013-07-14','10:40:00',5.86),('10318','2013-07-14','10:45:00',9.65),('10318','2013-07-14','10:50:00',9.17),('10318','2013-07-14','10:55:00',8.9),('10318','2013-07-14','11:00:00',8.23),('10318','2013-07-14','11:05:00',7.52),('10318','2013-07-14','11:10:00',5.35),('10318','2013-07-14','11:15:00',8.4),('10318','2013-07-14','11:20:00',9.46),('10318','2013-07-14','11:25:00',9.55),('10318','2013-07-14','11:30:00',9.2),('10318','2013-07-14','11:35:00',8.97),('10318','2013-07-14','11:40:00',9.34),('10318','2013-07-14','11:45:00',9.67),('10318','2013-07-14','11:50:00',9.57),('10318','2013-07-14','11:55:00',9.37),('10318','2013-07-14','12:00:00',7.84),('10318','2013-07-14','12:05:00',2.53),('10318','2013-07-14','12:10:00',3.17),('10318','2013-07-14','12:15:00',4.88),('10318','2013-07-14','12:20:00',3.65),('10318','2013-07-14','12:25:00',9.63),('10318','2013-07-14','12:30:00',7.3),('10318','2013-07-14','12:35:00',3.95),('10318','2013-07-14','12:40:00',3.76),('10318','2013-07-14','12:45:00',7.37),('10318','2013-07-14','12:50:00',10.35),('10318','2013-07-14','12:55:00',8.45),('10318','2013-07-14','13:00:00',4.56),('10318','2013-07-14','13:05:00',4.98),('10318','2013-07-14','13:10:00',9.76),('10318','2013-07-14','13:15:00',8.11),('10318','2013-07-14','13:20:00',9.25),('10318','2013-07-14','13:25:00',9.28),('10318','2013-07-14','13:30:00',9.19),('10318','2013-07-14','13:35:00',9.16),('10318','2013-07-14','13:40:00',9.14),('10318','2013-07-14','13:45:00',9.19),('10318','2013-07-14','13:50:00',9.19),('10318','2013-07-14','13:55:00',9.2),('10318','2013-07-14','14:00:00',9.18),('10318','2013-07-14','14:05:00',9.12),('10318','2013-07-14','14:10:00',9.03),('10318','2013-07-14','14:15:00',8.96),('10318','2013-07-14','14:20:00',8.89),('10318','2013-07-14','14:25:00',8.85),('10318','2013-07-14','14:30:00',8.72),('10318','2013-07-14','14:35:00',8.59),('10318','2013-07-14','14:40:00',8.48),('10318','2013-07-14','14:45:00',8.43),('10318','2013-07-14','14:50:00',8.24),('10318','2013-07-14','14:55:00',7.93),('10318','2013-07-14','15:00:00',8.02),('10318','2013-07-14','15:05:00',7.91),('10318','2013-07-14','15:10:00',7.85),('10318','2013-07-14','15:15:00',7.69),('10318','2013-07-14','15:20:00',7.61),('10318','2013-07-14','15:25:00',7.44),('10318','2013-07-14','15:30:00',7.36),('10318','2013-07-14','15:35:00',7.21),('10318','2013-07-14','15:40:00',7.04),('10318','2013-07-14','15:45:00',6.94),('10318','2013-07-14','15:50:00',6.87),('10318','2013-07-14','15:55:00',6.76),('10318','2013-07-14','16:00:00',6.64),('10318','2013-07-14','16:05:00',6.33),('10318','2013-07-14','16:10:00',6.45),('10318','2013-07-14','16:15:00',5.24),('10318','2013-07-14','16:20:00',6.45),('10318','2013-07-14','16:25:00',6.45),('10318','2013-07-14','16:30:00',6.21),('10318','2013-07-14','16:35:00',4.4),('10318','2013-07-14','16:40:00',2.8),('10318','2013-07-14','16:45:00',4.1),('10318','2013-07-14','16:50:00',3.39),('10318','2013-07-14','16:55:00',4.74),('10318','2013-07-14','17:00:00',3.78),('10318','2013-07-14','17:05:00',5.01),('10318','2013-07-14','17:10:00',4.75),('10318','2013-07-14','17:15:00',2.77),('10318','2013-07-14','17:20:00',2.59),('10318','2013-07-14','17:25:00',3.62),('10318','2013-07-14','17:30:00',2.85),('10318','2013-07-14','17:35:00',4.06),('10318','2013-07-14','17:40:00',3.11),('10318','2013-07-14','17:45:00',3.14),('10318','2013-07-14','17:50:00',3.35),('10318','2013-07-14','17:55:00',1.62),('10318','2013-07-14','18:00:00',2.64),('10318','2013-07-14','18:05:00',2.17),('10318','2013-07-14','18:10:00',1.66),('10318','2013-07-14','18:35:00',1.2),('10318','2013-07-14','18:40:00',1.39),('10318','2013-07-14','18:45:00',1.57),('10318','2013-07-14','18:50:00',1.36),('10318','2013-07-14','18:55:00',1.18),('10318','2013-07-14','19:00:00',1.03),('10318','2013-07-14','19:05:00',1.22),('10318','2013-07-14','19:10:00',1.4),('10318','2013-07-14','19:15:00',1.6),('10318','2013-07-14','19:20:00',1.28),('10318','2013-07-13','07:15:00',1.15),('10318','2013-07-13','07:20:00',1.69),('10318','2013-07-13','07:25:00',2.12),('10318','2013-07-13','07:30:00',2.18),('10318','2013-07-13','07:35:00',2.35),('10318','2013-07-13','07:40:00',2.55),('10318','2013-07-13','07:45:00',2.73),('10318','2013-07-13','07:50:00',2.95),('10318','2013-07-13','07:55:00',3.15),('10318','2013-07-13','08:00:00',3.34),('10318','2013-07-13','08:05:00',3.54),('10318','2013-07-13','08:10:00',3.77),('10318','2013-07-13','08:15:00',3.99),('10318','2013-07-13','08:20:00',4.17),('10318','2013-07-13','08:25:00',4.33),('10318','2013-07-13','08:30:00',4.4),('10318','2013-07-13','08:35:00',4.69),('10318','2013-07-13','08:40:00',4.89),('10318','2013-07-13','08:45:00',5.03),('10318','2013-07-13','08:50:00',5.22),('10318','2013-07-13','08:55:00',5.4),('10318','2013-07-13','09:00:00',5.58),('10318','2013-07-13','09:05:00',5.77),('10318','2013-07-13','09:10:00',5.89),('10318','2013-07-13','09:15:00',6.05),('10318','2013-07-13','09:20:00',6.17),('10318','2013-07-13','09:25:00',6.23),('10318','2013-07-13','09:30:00',6.32),('10318','2013-07-13','09:35:00',6.43),('10318','2013-07-13','09:40:00',6.66),('10318','2013-07-13','09:45:00',6.83),('10318','2013-07-13','09:50:00',7.02),('10318','2013-07-13','09:55:00',7.06),('10318','2013-07-13','10:00:00',7.15),('10318','2013-07-13','10:05:00',7.31),('10318','2013-07-13','10:10:00',7.46),('10318','2013-07-13','10:15:00',7.41),('10318','2013-07-13','10:20:00',7.45),('10318','2013-07-13','10:25:00',7.85),('10318','2013-07-13','10:30:00',7.99),('10318','2013-07-13','10:35:00',8.13),('10318','2013-07-13','10:40:00',8.16),('10318','2013-07-13','10:45:00',8.24),('10318','2013-07-13','10:50:00',7.88),('10318','2013-07-13','10:55:00',8.91),('10318','2013-07-13','11:00:00',8.89),('10318','2013-07-13','11:05:00',5.66),('10318','2013-07-13','11:10:00',6.93),('10318','2013-07-13','11:15:00',8.9),('10318','2013-07-13','11:20:00',4.05),('10318','2013-07-13','11:25:00',9.5),('10318','2013-07-13','11:30:00',9.17),('10318','2013-07-13','11:35:00',9.47),('10318','2013-07-13','11:40:00',9.02),('10318','2013-07-13','11:45:00',8.87),('10318','2013-07-13','11:50:00',8.83),('10318','2013-07-13','11:55:00',4.75),('10318','2013-07-13','12:00:00',9.39),('10318','2013-07-13','12:05:00',9.52),('10318','2013-07-13','12:10:00',8.77),('10318','2013-07-13','12:15:00',9.49),('10318','2013-07-13','12:20:00',7.56),('10318','2013-07-13','12:25:00',7.1),('10318','2013-07-13','12:30:00',5.32),('10318','2013-07-13','12:35:00',5.75),('10318','2013-07-13','12:40:00',9.78),('10318','2013-07-13','12:45:00',9.7),('10318','2013-07-13','12:50:00',8.42),('10318','2013-07-13','12:55:00',5.35),('10318','2013-07-13','13:00:00',8.25),('10318','2013-07-13','13:05:00',9.75),('10318','2013-07-13','13:10:00',9.21),('10318','2013-07-13','13:15:00',8.95),('10318','2013-07-13','13:20:00',9.17),('10318','2013-07-13','13:25:00',9.21),('10318','2013-07-13','13:30:00',9.21),('10318','2013-07-13','13:35:00',9.14),('10318','2013-07-13','13:40:00',9.03),('10318','2013-07-13','13:45:00',9.08),('10318','2013-07-13','13:50:00',9.01),('10318','2013-07-13','13:55:00',8.91),('10318','2013-07-13','14:00:00',8.92),('10318','2013-07-13','14:05:00',8.81),('10318','2013-07-13','14:10:00',8.79),('10318','2013-07-13','14:15:00',8.71),('10318','2013-07-13','14:20:00',8.67),('10318','2013-07-13','14:25:00',8.58),('10318','2013-07-13','14:30:00',8.53),('10318','2013-07-13','14:35:00',8.47),('10318','2013-07-13','14:40:00',8.42),('10318','2013-07-13','14:45:00',8.31),('10318','2013-07-13','14:50:00',8.22),('10318','2013-07-13','14:55:00',8.2),('10318','2013-07-13','15:00:00',7.99),('10318','2013-07-13','15:05:00',7.83),('10318','2013-07-13','15:10:00',7.9),('10318','2013-07-13','15:15:00',7.86),('10318','2013-07-13','15:20:00',7.49),('10318','2013-07-13','15:25:00',7.82),('10318','2013-07-13','15:30:00',7.51),('10318','2013-07-13','15:35:00',7.54),('10318','2013-07-13','15:40:00',7.35),('10318','2013-07-13','15:45:00',7.21),('10318','2013-07-13','15:50:00',7.06),('10318','2013-07-13','15:55:00',6.89),('10318','2013-07-13','16:00:00',6.72),('10318','2013-07-13','16:05:00',6.56),('10318','2013-07-13','16:10:00',6.49),('10318','2013-07-13','16:15:00',6.13),('10318','2013-07-13','16:20:00',6.17),('10318','2013-07-13','16:25:00',6.03),('10318','2013-07-13','16:30:00',5.9),('10318','2013-07-13','16:35:00',5.71),('10318','2013-07-13','16:40:00',5.56),('10318','2013-07-13','16:45:00',5.41),('10318','2013-07-13','16:50:00',5.13),('10318','2013-07-13','16:55:00',5.02),('10318','2013-07-13','17:00:00',4.87),('10318','2013-07-13','17:05:00',4.62),('10318','2013-07-13','17:10:00',4.59),('10318','2013-07-13','17:15:00',4.4),('10318','2013-07-13','17:20:00',4.02),('10318','2013-07-13','17:25:00',4.09),('10318','2013-07-13','17:30:00',3.76),('10318','2013-07-13','17:35:00',3.64),('10318','2013-07-13','17:40:00',3.47),('10318','2013-07-13','17:45:00',3.36),('10318','2013-07-13','17:50:00',3.14),('10318','2013-07-13','17:55:00',3.05),('10318','2013-07-13','18:00:00',2.77),('10318','2013-07-13','18:05:00',2.55),('10318','2013-07-13','18:10:00',2.44),('10318','2013-07-13','18:15:00',2.31),('10318','2013-07-13','18:20:00',2.16),('10318','2013-07-13','18:25:00',2),('10318','2013-07-13','18:30:00',1.8),('10318','2013-07-13','18:35:00',1.46),('10318','2013-07-13','18:40:00',1.03),('10318','2013-07-13','18:50:00',1.29),('10318','2013-07-13','18:55:00',1.32),('10318','2013-07-13','19:00:00',1.14),('10318','2013-07-12','07:05:00',1.15),('10318','2013-07-12','07:10:00',1.26),('10318','2013-07-12','07:15:00',1.51),('10318','2013-07-12','07:20:00',1.46),('10318','2013-07-12','07:25:00',2.03),('10318','2013-07-12','07:30:00',1.6),('10318','2013-07-12','07:35:00',1.2),('10318','2013-07-12','07:40:00',1.48),('10318','2013-07-12','07:45:00',1.38),('10318','2013-07-12','07:50:00',1.19),('10318','2013-07-12','08:00:00',1.29),('10318','2013-07-12','08:05:00',1.6),('10318','2013-07-12','08:10:00',2.21),('10318','2013-07-12','08:15:00',2.47),('10318','2013-07-12','08:20:00',1.8),('10318','2013-07-12','08:25:00',1.8),('10318','2013-07-12','08:30:00',2.09),('10318','2013-07-12','08:35:00',2.56),('10318','2013-07-12','08:40:00',2.37),('10318','2013-07-12','08:45:00',1.97),('10318','2013-07-12','08:50:00',2.01),('10318','2013-07-12','08:55:00',1.79),('10318','2013-07-12','09:00:00',2.92),('10318','2013-07-12','09:05:00',5.68),('10318','2013-07-12','09:10:00',6.79),('10318','2013-07-12','09:15:00',4.7),('10318','2013-07-12','09:20:00',2.91),('10318','2013-07-12','09:25:00',3.8),('10318','2013-07-12','09:30:00',3.85),('10318','2013-07-12','09:35:00',4.38),('10318','2013-07-12','09:40:00',6.04),('10318','2013-07-12','09:45:00',6.86),('10318','2013-07-12','09:50:00',6.98),('10318','2013-07-12','09:55:00',6.86),('10318','2013-07-12','10:00:00',7.46),('10318','2013-07-12','10:05:00',7.87),('10318','2013-07-12','10:10:00',5.21),('10318','2013-07-12','10:15:00',3.61),('10318','2013-07-12','10:20:00',5.35),('10318','2013-07-12','10:25:00',7.77),('10318','2013-07-12','10:30:00',8.11),('10318','2013-07-12','10:35:00',8.27),('10318','2013-07-12','10:40:00',3.78),('10318','2013-07-12','10:45:00',3.2),('10318','2013-07-12','10:50:00',2.87),('10318','2013-07-12','10:55:00',2.9),('10318','2013-07-12','11:00:00',5.9),('10318','2013-07-12','11:05:00',4.3),('10318','2013-07-12','11:10:00',9.23),('10318','2013-07-12','11:15:00',6.12),('10318','2013-07-12','11:20:00',2.5),('10318','2013-07-12','11:25:00',3.66),('10318','2013-07-12','11:30:00',5.99),('10318','2013-07-12','11:35:00',10.11),('10318','2013-07-12','11:40:00',5.15),('10318','2013-07-12','11:45:00',5.72),('10318','2013-07-12','11:50:00',6.89),('10318','2013-07-12','11:55:00',5.02),('10318','2013-07-12','12:00:00',9.84),('10318','2013-07-12','12:05:00',9.61),('10318','2013-07-12','12:10:00',3.47),('10318','2013-07-12','12:15:00',6.18),('10318','2013-07-12','12:20:00',7.71),('10318','2013-07-12','12:25:00',4.96),('10318','2013-07-12','12:30:00',3.85),('10318','2013-07-12','12:35:00',6.12),('10318','2013-07-12','12:40:00',5.01),('10318','2013-07-12','12:45:00',10.35),('10318','2013-07-12','12:50:00',8.29),('10318','2013-07-12','12:55:00',8.36),('10318','2013-07-12','13:00:00',9.2),('10318','2013-07-12','13:05:00',8.51),('10318','2013-07-12','13:10:00',9.53),('10318','2013-07-12','13:15:00',8.36),('10318','2013-07-12','13:20:00',9.47),('10318','2013-07-12','13:25:00',8.16),('10318','2013-07-12','13:30:00',9.45),('10318','2013-07-12','13:35:00',9.12),('10318','2013-07-12','13:40:00',9.36),('10318','2013-07-12','13:45:00',9.36),('10318','2013-07-12','13:50:00',7.37),('10318','2013-07-12','13:55:00',7.9),('10318','2013-07-12','14:00:00',9.74),('10318','2013-07-12','14:05:00',7.77),('10318','2013-07-12','14:10:00',5.74),('10318','2013-07-12','14:15:00',9.48),('10318','2013-07-12','14:20:00',5.82),('10318','2013-07-12','14:25:00',8.33),('10318','2013-07-12','14:30:00',8.82),('10318','2013-07-12','14:35:00',8.59),('10318','2013-07-12','14:40:00',8.58),('10318','2013-07-12','14:45:00',8.08),('10318','2013-07-12','14:50:00',8.14),('10318','2013-07-12','14:55:00',8.02),('10318','2013-07-12','15:00:00',7.96),('10318','2013-07-12','15:05:00',7.93),('10318','2013-07-12','15:10:00',7.68),('10318','2013-07-12','15:15:00',6.32),('10318','2013-07-12','15:20:00',7.38),('10318','2013-07-12','15:25:00',7.52),('10318','2013-07-12','15:30:00',6.7),('10318','2013-07-12','15:35:00',6.98),('10318','2013-07-12','15:40:00',7.12),('10318','2013-07-12','15:45:00',7.07),('10318','2013-07-12','15:50:00',6.8),('10318','2013-07-12','15:55:00',6.72),('10318','2013-07-12','16:00:00',6.51),('10318','2013-07-12','16:05:00',6.46),('10318','2013-07-12','16:10:00',6.26),('10318','2013-07-12','16:15:00',6.13),('10318','2013-07-12','16:20:00',6.02),('10318','2013-07-12','16:25:00',5.79),('10318','2013-07-12','16:30:00',5.55),('10318','2013-07-12','16:35:00',5.48),('10318','2013-07-12','16:40:00',5.34),('10318','2013-07-12','16:45:00',5.22),('10318','2013-07-12','16:50:00',5.1),('10318','2013-07-12','16:55:00',4.9),('10318','2013-07-12','17:00:00',4.71),('10318','2013-07-12','17:05:00',4.58),('10318','2013-07-12','17:10:00',4.37),('10318','2013-07-12','17:15:00',4.2),('10318','2013-07-12','17:20:00',4.06),('10318','2013-07-12','17:25:00',3.86),('10318','2013-07-12','17:30:00',3.7),('10318','2013-07-12','17:35:00',3.51),('10318','2013-07-12','17:40:00',3.32),('10318','2013-07-12','17:45:00',3.15),('10318','2013-07-12','17:50:00',3.03),('10318','2013-07-12','17:55:00',2.85),('10318','2013-07-12','18:00:00',2.66),('10318','2013-07-12','18:05:00',2.53),('10318','2013-07-12','18:10:00',2.36),('10318','2013-07-12','18:15:00',2.16),('10318','2013-07-12','18:20:00',2.05),('10318','2013-07-12','18:25:00',1.94),('10318','2013-07-12','18:30:00',1.77),('10318','2013-07-12','18:35:00',1.6),('10318','2013-07-12','18:40:00',1.5),('10318','2013-07-12','18:45:00',1.36),('10318','2013-07-12','18:50:00',1.21),('10318','2013-07-12','18:55:00',1.12),('10318','2013-07-11','07:05:00',1.09),('10318','2013-07-11','07:10:00',1.31),('10318','2013-07-11','07:15:00',1.54),('10318','2013-07-11','07:20:00',1.74),('10318','2013-07-11','07:25:00',2.04),('10318','2013-07-11','07:30:00',2.24),('10318','2013-07-11','07:35:00',2.46),('10318','2013-07-11','07:40:00',2.63),('10318','2013-07-11','07:45:00',2.9),('10318','2013-07-11','07:50:00',3.08),('10318','2013-07-11','07:55:00',3.27),('10318','2013-07-11','08:00:00',3.42),('10318','2013-07-11','08:05:00',3.64),('10318','2013-07-11','08:10:00',3.8),('10318','2013-07-11','08:15:00',3.99),('10318','2013-07-11','08:20:00',4.2),('10318','2013-07-11','08:25:00',4.38),('10318','2013-07-11','08:30:00',4.51),('10318','2013-07-11','08:35:00',4.68),('10318','2013-07-11','08:40:00',4.89),('10318','2013-07-11','08:45:00',4.91),('10318','2013-07-11','08:50:00',5.14),('10318','2013-07-11','08:55:00',5.4),('10318','2013-07-11','09:00:00',5.54),('10318','2013-07-11','09:05:00',5.8),('10318','2013-07-11','09:10:00',5.99),('10318','2013-07-11','09:15:00',6.18),('10318','2013-07-11','09:20:00',6.2),('10318','2013-07-11','09:25:00',6.27),('10318','2013-07-11','09:30:00',6.68),('10318','2013-07-11','09:35:00',6.74),('10318','2013-07-11','09:40:00',7.08),('10318','2013-07-11','09:45:00',7.31),('10318','2013-07-11','09:50:00',6.83),('10318','2013-07-11','09:55:00',6.12),('10318','2013-07-11','10:00:00',7.9),('10318','2013-07-11','10:05:00',7.94),('10318','2013-07-11','10:10:00',8.05),('10318','2013-07-11','10:15:00',4.69),('10318','2013-07-11','10:20:00',3.13),('10318','2013-07-11','10:25:00',4.14),('10318','2013-07-11','10:30:00',5.95),('10318','2013-07-11','10:35:00',5.28),('10318','2013-07-11','10:40:00',8.8),('10318','2013-07-11','10:45:00',4.39),('10318','2013-07-11','10:50:00',2.46),('10318','2013-07-11','10:55:00',2.48),('10318','2013-07-11','11:00:00',2.93),('10318','2013-07-11','11:05:00',9.68),('10318','2013-07-11','11:10:00',6.32),('10318','2013-07-11','11:15:00',4.22),('10318','2013-07-11','11:20:00',3.28),('10318','2013-07-11','11:25:00',7.74),('10318','2013-07-11','11:30:00',10.11),('10318','2013-07-11','11:35:00',6.73),('10318','2013-07-11','11:40:00',6.22),('10318','2013-07-11','11:45:00',3.55),('10318','2013-07-11','11:50:00',5.16),('10318','2013-07-11','11:55:00',6.23),('10318','2013-07-11','12:00:00',9.04),('10318','2013-07-11','12:05:00',8.21),('10318','2013-07-11','12:10:00',3.12),('10318','2013-07-11','12:15:00',5.28),('10318','2013-07-11','12:20:00',8.73),('10318','2013-07-11','12:25:00',4.58),('10318','2013-07-11','12:30:00',7.98),('10318','2013-07-11','12:35:00',9.09),('10318','2013-07-11','12:40:00',10.11),('10318','2013-07-11','12:45:00',6.01),('10318','2013-07-11','12:50:00',9.97),('10318','2013-07-11','12:55:00',9.56),('10318','2013-07-11','13:00:00',9.48),('10318','2013-07-11','13:05:00',9.68),('10318','2013-07-11','13:10:00',7.16),('10318','2013-07-11','13:15:00',9.77),('10318','2013-07-11','13:20:00',9.53),('10318','2013-07-11','13:25:00',8.3),('10318','2013-07-11','13:30:00',8.89),('10318','2013-07-11','13:35:00',9.51),('10318','2013-07-11','13:40:00',9.44),('10318','2013-07-11','13:45:00',8.98),('10318','2013-07-11','13:50:00',9.09),('10318','2013-07-11','13:55:00',9.04),('10318','2013-07-11','14:00:00',8.88),('10318','2013-07-11','14:05:00',8.73),('10318','2013-07-11','14:10:00',8.78),('10318','2013-07-11','14:15:00',8.78),('10318','2013-07-11','14:20:00',8.67),('10318','2013-07-11','14:25:00',8.74),('10318','2013-07-11','14:30:00',8.65),('10318','2013-07-11','14:35:00',8.53),('10318','2013-07-11','14:40:00',8.44),('10318','2013-07-11','14:45:00',8.35),('10318','2013-07-11','14:50:00',8.33),('10318','2013-07-11','14:55:00',8.35),('10318','2013-07-11','15:00:00',7.31),('10318','2013-07-11','15:05:00',8.28),('10318','2013-07-11','15:10:00',8.11),('10318','2013-07-11','15:15:00',8.09),('10318','2013-07-11','15:20:00',7.87),('10318','2013-07-11','15:25:00',7.75),('10318','2013-07-11','15:30:00',7.43),('10318','2013-07-11','15:35:00',7.5),('10318','2013-07-11','15:40:00',7.34),('10318','2013-07-11','15:45:00',7.38),('10318','2013-07-11','15:50:00',7.35),('10318','2013-07-11','15:55:00',7.19),('10318','2013-07-11','16:00:00',7.17),('10318','2013-07-11','16:05:00',5.94),('10318','2013-07-11','16:10:00',6.67),('10318','2013-07-11','16:15:00',4.91),('10318','2013-07-11','16:20:00',5.34),('10318','2013-07-11','16:25:00',4.85),('10318','2013-07-11','16:30:00',5.99),('10318','2013-07-11','16:35:00',5.77),('10318','2013-07-11','16:40:00',5.24),('10318','2013-07-11','16:45:00',4.77),('10318','2013-07-11','16:50:00',5.37),('10318','2013-07-11','16:55:00',4.47),('10318','2013-07-11','17:00:00',4.75),('10318','2013-07-11','17:05:00',5.2),('10318','2013-07-11','17:10:00',4.19),('10318','2013-07-11','17:15:00',5.13),('10318','2013-07-11','17:20:00',4.6),('10318','2013-07-11','17:25:00',3.84),('10318','2013-07-11','17:30:00',4.1),('10318','2013-07-11','17:35:00',3.81),('10318','2013-07-11','17:40:00',3.07),('10318','2013-07-11','17:45:00',3.23),('10318','2013-07-11','17:50:00',3.16),('10318','2013-07-11','17:55:00',3.16),('10318','2013-07-11','18:00:00',3.29),('10318','2013-07-11','18:05:00',2.92),('10318','2013-07-11','18:10:00',2.55),('10318','2013-07-11','18:15:00',2.49),('10318','2013-07-11','18:20:00',2.41),('10318','2013-07-11','18:25:00',2.21),('10318','2013-07-11','18:30:00',1.29),('10318','2013-07-11','18:35:00',1.3),('10318','2013-07-11','18:40:00',1.13),('10318','2014-05-03','07:15:00',1.28),('10318','2014-05-03','07:20:00',2.03),('10318','2014-05-03','07:25:00',2.36),('10318','2014-05-03','07:30:00',2.63),('10318','2014-05-03','07:35:00',3.02),('10318','2014-05-03','07:40:00',3.31),('10318','2014-05-03','07:45:00',3.53),('10318','2014-05-03','07:50:00',3.76),('10318','2014-05-03','07:55:00',4.02),('10318','2014-05-03','08:00:00',4.56),('10318','2014-05-03','08:05:00',5.36),('10318','2014-05-03','08:10:00',4.95),('10318','2014-05-03','08:15:00',2.89),('10318','2014-05-03','08:20:00',4.15),('10318','2014-05-03','08:25:00',4.25),('10318','2014-05-03','08:30:00',4),('10318','2014-05-03','08:35:00',1.82),('10318','2014-05-03','08:40:00',6.17),('10318','2014-05-03','08:45:00',6.47),('10318','2014-05-03','08:50:00',6.1),('10318','2014-05-03','08:55:00',3.75),('10318','2014-05-03','09:00:00',2.21),('10318','2014-05-03','09:05:00',3.03),('10318','2014-05-03','09:10:00',6.21),('10318','2014-05-03','09:15:00',6.39),('10318','2014-05-03','09:20:00',2.71),('10318','2014-05-03','09:25:00',4.87),('10318','2014-05-03','09:30:00',7.15),('10318','2014-05-03','09:35:00',9.31),('10318','2014-05-03','09:40:00',9.22),('10318','2014-05-03','09:45:00',9.57),('10318','2014-05-03','09:50:00',7.81),('10318','2014-05-03','09:55:00',8.01),('10318','2014-05-03','10:00:00',8.61),('10318','2014-05-03','10:05:00',7.45),('10318','2014-05-03','10:10:00',7.01),('10318','2014-05-03','10:15:00',5.62),('10318','2014-05-03','10:20:00',1.93),('10318','2014-05-03','10:25:00',4.1),('10318','2014-05-03','10:30:00',9.86),('10318','2014-05-03','10:35:00',6.72),('10318','2014-05-03','10:40:00',3.72),('10318','2014-05-03','10:45:00',4.28),('10318','2014-05-03','10:50:00',11.26),('10318','2014-05-03','10:55:00',11.19),('10318','2014-05-03','11:00:00',10.78),('10318','2014-05-03','11:05:00',8.45),('10318','2014-05-03','11:10:00',5.82),('10318','2014-05-03','11:15:00',8.63),('10318','2014-05-03','11:20:00',6.53),('10318','2014-05-03','11:25:00',9.5),('10318','2014-05-03','11:30:00',5.81),('10318','2014-05-03','11:35:00',6.59),('10318','2014-05-03','11:40:00',6.02),('10318','2014-05-03','11:45:00',8.32),('10318','2014-05-03','11:50:00',7.84),('10318','2014-05-03','11:55:00',5.63),('10318','2014-05-03','12:00:00',4.77),('10318','2014-05-03','12:05:00',3.17),('10318','2014-05-03','12:10:00',2.68),('10318','2014-05-03','12:15:00',2.73),('10318','2014-05-03','12:20:00',2.66),('10318','2014-05-03','12:25:00',2.62),('10318','2014-05-03','12:30:00',2.97),('10318','2014-05-03','12:35:00',4.04),('10318','2014-05-03','12:40:00',4.75),('10318','2014-05-03','12:45:00',4.65),('10318','2014-05-03','12:50:00',3.86),('10318','2014-05-03','12:55:00',3.68),('10318','2014-05-03','13:00:00',4.66),('10318','2014-05-03','13:05:00',7.55),('10318','2014-05-03','13:10:00',8.95),('10318','2014-05-03','13:15:00',8.16),('10318','2014-05-03','13:20:00',6.7),('10318','2014-05-03','13:25:00',6.29),('10318','2014-05-03','13:30:00',5.64),('10318','2014-05-03','13:35:00',6.12),('10318','2014-05-03','13:40:00',5.99),('10318','2014-05-03','13:45:00',5.86),('10318','2014-05-03','13:50:00',5.5),('10318','2014-05-03','13:55:00',4.67),('10318','2014-05-03','14:00:00',4.57),('10318','2014-05-03','14:05:00',4.59),('10318','2014-05-03','14:10:00',5.19),('10318','2014-05-03','14:15:00',5.95),('10318','2014-05-03','14:20:00',6.66),('10318','2014-05-03','14:25:00',6.62),('10318','2014-05-03','14:30:00',7.77),('10318','2014-05-03','14:35:00',5.48),('10318','2014-05-03','14:40:00',2.31),('10318','2014-05-03','14:45:00',1.46),('10318','2014-05-03','14:55:00',1.07),('10318','2014-05-03','15:00:00',1.53),('10318','2014-05-03','15:05:00',1.28),('10318','2014-05-03','15:10:00',1.43),('10318','2014-05-03','15:15:00',1.26),('10318','2014-05-03','15:20:00',1.41),('10318','2014-05-03','15:25:00',1.6),('10318','2014-05-03','15:30:00',1.56),('10318','2014-05-03','15:35:00',1.36),('10318','2014-05-03','15:40:00',1.3),('10318','2014-05-03','15:45:00',1.21),('10318','2014-05-03','15:50:00',1.06),('10318','2014-05-03','16:25:00',1.17),('10318','2014-05-03','16:30:00',1.36),('10318','2014-05-03','16:35:00',1.53),('10318','2014-05-03','16:40:00',1.69),('10318','2014-05-03','16:45:00',1.82),('10318','2014-05-03','16:50:00',1.91),('10318','2014-05-03','16:55:00',2),('10318','2014-05-03','17:00:00',2.05),('10318','2014-05-03','17:05:00',2.08),('10318','2014-05-03','17:10:00',2.1),('10318','2014-05-03','17:15:00',2.09),('10318','2014-05-03','17:20:00',2.09),('10318','2014-05-03','17:25:00',2.13),('10318','2014-05-03','17:30:00',2.1),('10318','2014-05-03','17:35:00',2.11),('10318','2014-05-03','17:40:00',2.25),('10318','2014-05-03','17:45:00',2.5),('10318','2014-05-03','17:50:00',2.6),('10318','2014-05-03','17:55:00',2.38),('10318','2014-05-03','18:00:00',2.09),('10318','2014-05-03','18:05:00',1.77),('10318','2014-05-03','18:10:00',1.54),('10318','2014-05-03','18:15:00',1.3),('10318','2014-05-03','18:20:00',1.25),('10318','2014-05-03','18:25:00',1.06),('10318','2014-05-03','18:55:00',1.09),('10318','2014-04-06','07:55:00',1.6),('10318','2014-04-06','08:00:00',1.62),('10318','2014-04-06','08:05:00',2.46),('10318','2014-04-06','08:10:00',3.21),('10318','2014-04-06','08:15:00',3.5),('10318','2014-04-06','08:20:00',2.62),('10318','2014-04-06','08:25:00',1.1),('10318','2014-04-06','08:40:00',3.6),('10318','2014-04-06','08:45:00',5.12),('10318','2014-04-06','08:50:00',5.31),('10318','2014-04-06','08:55:00',5.07),('10318','2014-04-06','09:00:00',5.68),('10318','2014-04-06','09:05:00',6.02),('10318','2014-04-06','09:10:00',6.16),('10318','2014-04-06','09:15:00',5.14),('10318','2014-04-06','09:20:00',3.97),('10318','2014-04-06','09:25:00',3.84),('10318','2014-04-06','09:30:00',3.92),('10318','2014-04-06','09:35:00',4.19),('10318','2014-04-06','09:40:00',5),('10318','2014-04-06','09:45:00',4.41),('10318','2014-04-06','09:50:00',8.17),('10318','2014-04-06','09:55:00',8.87),('10318','2014-04-06','10:00:00',9.25),('10318','2014-04-06','10:05:00',8.52),('10318','2014-04-06','10:10:00',7.46),('10318','2014-04-06','10:15:00',4.84),('10318','2014-04-06','10:20:00',6.2),('10318','2014-04-06','10:25:00',4.29),('10318','2014-04-06','10:30:00',3.21),('10318','2014-04-06','10:35:00',3.35),('10318','2014-04-06','10:40:00',3.59),('10318','2014-04-06','10:45:00',3.91),('10318','2014-04-06','10:50:00',6.3),('10318','2014-04-06','10:55:00',9.66),('10318','2014-04-06','11:00:00',4.08),('10318','2014-04-06','11:05:00',4.12),('10318','2014-04-06','11:10:00',7.1),('10318','2014-04-06','11:15:00',10.26),('10318','2014-04-06','11:20:00',9.88),('10318','2014-04-06','11:25:00',9.76),('10318','2014-04-06','11:30:00',9.72),('10318','2014-04-06','11:35:00',4.96),('10318','2014-04-06','11:40:00',4.23),('10318','2014-04-06','11:45:00',3.76),('10318','2014-04-06','11:50:00',2.86),('10318','2014-04-06','11:55:00',5.32),('10318','2014-04-06','12:00:00',3.73),('10318','2014-04-06','12:05:00',7.19),('10318','2014-04-06','12:10:00',5.28),('10318','2014-04-06','12:15:00',7.57),('10318','2014-04-06','12:20:00',3.57),('10318','2014-04-06','12:25:00',2.46),('10318','2014-04-06','12:30:00',7.08),('10318','2014-04-06','12:35:00',4.41),('10318','2014-04-06','12:40:00',7.01),('10318','2014-04-06','12:45:00',3.68),('10318','2014-04-06','12:50:00',6.64),('10318','2014-04-06','12:55:00',8.64),('10318','2014-04-06','13:00:00',8.21),('10318','2014-04-06','13:05:00',9.53),('10318','2014-04-06','13:10:00',8.23),('10318','2014-04-06','13:15:00',9.7),('10318','2014-04-06','13:20:00',8.87),('10318','2014-04-06','13:25:00',8.77),('10318','2014-04-06','13:30:00',5.19),('10318','2014-04-06','13:35:00',4.69),('10318','2014-04-06','13:40:00',5.37),('10318','2014-04-06','13:45:00',10.12),('10318','2014-04-06','13:50:00',9.79),('10318','2014-04-06','13:55:00',2.35),('10318','2014-04-06','14:00:00',2.24),('10318','2014-04-06','14:05:00',6.25),('10318','2014-04-06','14:10:00',2.22),('10318','2014-04-06','14:15:00',3.43),('10318','2014-04-06','14:20:00',4.87),('10318','2014-04-06','14:25:00',4.3),('10318','2014-04-06','14:30:00',3.23),('10318','2014-04-06','14:35:00',2.89),('10318','2014-04-06','14:40:00',5.24),('10318','2014-04-06','14:45:00',8.54),('10318','2014-04-06','14:50:00',3.99),('10318','2014-04-06','14:55:00',4.32),('10318','2014-04-06','15:00:00',3.24),('10318','2014-04-06','15:05:00',6.13),('10318','2014-04-06','15:10:00',2.48),('10318','2014-04-06','15:15:00',2.51),('10318','2014-04-06','15:20:00',2.2),('10318','2014-04-06','15:25:00',2.21),('10318','2014-04-06','15:30:00',1.84),('10318','2014-04-06','15:35:00',1.52),('10318','2014-04-06','15:40:00',1.57),('10318','2014-04-06','15:45:00',1.99),('10318','2014-04-06','15:50:00',2.82),('10318','2014-04-06','15:55:00',6.92),('10318','2014-04-06','16:00:00',5.59),('10318','2014-04-06','16:05:00',7.65),('10318','2014-04-06','16:10:00',7.18),('10318','2014-04-06','16:15:00',3.84),('10318','2014-04-06','16:20:00',3.06),('10318','2014-04-06','16:25:00',2.56),('10318','2014-04-06','16:30:00',2.33),('10318','2014-04-06','16:35:00',2.42),('10318','2014-04-06','16:40:00',2.07),('10318','2014-04-06','16:45:00',5.45),('10318','2014-04-06','16:50:00',5.87),('10318','2014-04-06','16:55:00',4.94),('10318','2014-04-06','17:00:00',3.28),('10318','2014-04-06','17:05:00',1.74),('10318','2014-04-06','17:10:00',1.32),('10318','2014-04-06','17:15:00',1.24),('10318','2014-04-06','17:20:00',1.73),('10318','2014-04-06','17:25:00',2.97),('10318','2014-04-06','17:30:00',3.08),('10318','2014-04-06','17:35:00',1.36),('10318','2014-04-06','17:40:00',2.36),('10318','2014-04-06','17:45:00',2.83),('10318','2014-04-06','17:50:00',2.53),('10318','2014-04-06','17:55:00',2.37),('10318','2014-04-06','18:00:00',2.1),('10318','2014-04-06','18:05:00',1.88),('10318','2014-04-06','18:10:00',1.77),('10318','2014-04-06','18:15:00',1.77),('10318','2014-04-06','18:20:00',1.77),('10318','2014-04-06','18:25:00',1.61),('10318','2014-04-06','18:30:00',1.27),('10318','2013-07-10','07:00:00',1.25),('10318','2013-07-10','07:05:00',1.5),('10318','2013-07-10','07:10:00',1.71),('10318','2013-07-10','07:15:00',2.04),('10318','2013-07-10','07:20:00',2.62),('10318','2013-07-10','07:25:00',3.05),('10318','2013-07-10','07:30:00',3.41),('10318','2013-07-10','07:35:00',3.76),('10318','2013-07-10','07:40:00',4.03),('10318','2013-07-10','07:45:00',4.27),('10318','2013-07-10','07:50:00',4.53),('10318','2013-07-10','07:55:00',4.59),('10318','2013-07-10','08:00:00',3.43),('10318','2013-07-10','08:05:00',3.07),('10318','2013-07-10','08:10:00',3.27),('10318','2013-07-10','08:15:00',3.68),('10318','2013-07-10','08:20:00',4.72),('10318','2013-07-10','08:25:00',3.8),('10318','2013-07-10','08:30:00',3.97),('10318','2013-07-10','08:35:00',5.58),('10318','2013-07-10','08:40:00',5.99),('10318','2013-07-10','08:45:00',5.97),('10318','2013-07-10','08:50:00',5.91),('10318','2013-07-10','08:55:00',5.67),('10318','2013-07-10','09:00:00',5.88),('10318','2013-07-10','09:05:00',5.87),('10318','2013-07-10','09:10:00',4.89),('10318','2013-07-10','09:15:00',4.88),('10318','2013-07-10','09:20:00',5.81),('10318','2013-07-10','09:25:00',6.59),('10318','2013-07-10','09:30:00',6.76),('10318','2013-07-10','09:35:00',6.82),('10318','2013-07-10','09:40:00',6.89),('10318','2013-07-10','09:45:00',6.99),('10318','2013-07-10','09:50:00',7.08),('10318','2013-07-10','09:55:00',7.21),('10318','2013-07-10','10:00:00',7.29),('10318','2013-07-10','10:05:00',7.4),('10318','2013-07-10','10:10:00',7.59),('10318','2013-07-10','10:15:00',7.69),('10318','2013-07-10','10:20:00',7.78),('10318','2013-07-10','10:25:00',7.74),('10318','2013-07-10','10:30:00',7.94),('10318','2013-07-10','10:35:00',8.01),('10318','2013-07-10','10:40:00',8.08),('10318','2013-07-10','10:45:00',8.11),('10318','2013-07-10','10:50:00',8.19),('10318','2013-07-10','10:55:00',8.28),('10318','2013-07-10','11:00:00',8.33),('10318','2013-07-10','11:05:00',8.37),('10318','2013-07-10','11:10:00',8.48),('10318','2013-07-10','11:15:00',8.52),('10318','2013-07-10','11:20:00',8.54),('10318','2013-07-10','11:25:00',8.58),('10318','2013-07-10','11:30:00',8.64),('10318','2013-07-10','11:35:00',8.57),('10318','2013-07-10','11:40:00',8.67),('10318','2013-07-10','11:45:00',8.73),('10318','2013-07-10','11:50:00',8.71),('10318','2013-07-10','11:55:00',8.66),('10318','2013-07-10','12:00:00',8.79),('10318','2013-07-10','12:05:00',8.82),('10318','2013-07-10','12:10:00',8.76),('10318','2013-07-10','12:15:00',8.86),('10318','2013-07-10','12:20:00',9.05),('10318','2013-07-10','12:25:00',8.89),('10318','2013-07-10','12:30:00',9.04),('10318','2013-07-10','12:35:00',9.07),('10318','2013-07-10','12:40:00',9.03),('10318','2013-07-10','12:45:00',9.1),('10318','2013-07-10','12:50:00',9.12),('10318','2013-07-10','12:55:00',9.19),('10318','2013-07-10','13:00:00',9.17),('10318','2013-07-10','13:05:00',9.12),('10318','2013-07-10','13:10:00',9.14),('10318','2013-07-10','13:15:00',9.22),('10318','2013-07-10','13:20:00',9.1),('10318','2013-07-10','13:25:00',9.14),('10318','2013-07-10','13:30:00',9.04),('10318','2013-07-10','13:35:00',9.06),('10318','2013-07-10','13:40:00',9.06),('10318','2013-07-10','13:45:00',8.96),('10318','2013-07-10','13:50:00',8.97),('10318','2013-07-10','13:55:00',8.63),('10318','2013-07-10','14:00:00',8.94),('10318','2013-07-10','14:05:00',8.94),('10318','2013-07-10','14:10:00',8.84),('10318','2013-07-10','14:15:00',8.82),('10318','2013-07-10','14:20:00',8.74),('10318','2013-07-10','14:25:00',8.67),('10318','2013-07-10','14:30:00',8.59),('10318','2013-07-10','14:35:00',8.55),('10318','2013-07-10','14:40:00',8.46),('10318','2013-07-10','14:45:00',8.35),('10318','2013-07-10','14:50:00',8.23),('10318','2013-07-10','14:55:00',8.16),('10318','2013-07-10','15:00:00',8.1),('10318','2013-07-10','15:05:00',8.03),('10318','2013-07-10','15:10:00',7.94),('10318','2013-07-10','15:15:00',7.85),('10318','2013-07-10','15:20:00',7.76),('10318','2013-07-10','15:25:00',7.62),('10318','2013-07-10','15:30:00',7.46),('10318','2013-07-10','15:35:00',7.29),('10318','2013-07-10','15:40:00',7.17),('10318','2013-07-10','15:45:00',7.02),('10318','2013-07-10','15:50:00',6.96),('10318','2013-07-10','15:55:00',6.84),('10318','2013-07-10','16:00:00',6.7),('10318','2013-07-10','16:05:00',6.58),('10318','2013-07-10','16:10:00',6.41),('10318','2013-07-10','16:15:00',6.23),('10318','2013-07-10','16:20:00',6.12),('10318','2013-07-10','16:25:00',5.96),('10318','2013-07-10','16:30:00',5.79),('10318','2013-07-10','16:35:00',5.65),('10318','2013-07-10','16:40:00',5.5),('10318','2013-07-10','16:45:00',5.36),('10318','2013-07-10','16:50:00',5.26),('10318','2013-07-10','16:55:00',5.22),('10318','2013-07-10','17:00:00',5.16),('10318','2013-07-10','17:05:00',3.5),('10318','2013-07-10','17:10:00',2.76),('10318','2013-07-10','17:15:00',2.31),('10318','2013-07-10','17:20:00',1.9),('10318','2013-07-10','17:25:00',1.4),('10318','2013-07-10','17:30:00',1.16),('10318','2013-07-10','17:35:00',2.44),('10318','2013-07-10','17:40:00',3.76),('10318','2013-07-10','17:45:00',3.49),('10318','2013-07-10','17:50:00',3.29),('10318','2013-07-10','17:55:00',3.07),('10318','2013-07-10','18:00:00',2.96),('10318','2013-07-10','18:05:00',2.97),('10318','2013-07-10','18:10:00',2.26),('10318','2013-07-10','18:15:00',1.2),('10318','2013-07-10','18:20:00',1.13),('10318','2013-07-10','18:25:00',1.07),('10318','2013-07-10','18:30:00',1.12),('10318','2013-07-10','18:35:00',1.1),('10318','2013-07-10','18:40:00',1.07),('10318','2013-07-10','19:05:00',1.12),('10318','2013-07-10','19:10:00',1.02),('10318','2013-07-09','07:10:00',1.43),('10318','2013-07-09','07:15:00',1.86),('10318','2013-07-09','07:20:00',2.11),('10318','2013-07-09','07:25:00',2.34),('10318','2013-07-09','07:30:00',2.58),('10318','2013-07-09','07:35:00',2.8),('10318','2013-07-09','07:40:00',2.99),('10318','2013-07-09','07:45:00',3.16),('10318','2013-07-09','07:50:00',3.33),('10318','2013-07-09','07:55:00',3.5),('10318','2013-07-09','08:00:00',3.64),('10318','2013-07-09','08:05:00',3.8),('10318','2013-07-09','08:10:00',3.9),('10318','2013-07-09','08:15:00',4.16),('10318','2013-07-09','08:20:00',4.31),('10318','2013-07-09','08:25:00',4.46),('10318','2013-07-09','08:30:00',4.64),('10318','2013-07-09','08:35:00',4.83),('10318','2013-07-09','08:40:00',4.99),('10318','2013-07-09','08:45:00',5.17),('10318','2013-07-09','08:50:00',5.33),('10318','2013-07-09','08:55:00',5.52),('10318','2013-07-09','09:00:00',5.67),('10318','2013-07-09','09:05:00',5.82),('10318','2013-07-09','09:10:00',5.97),('10318','2013-07-09','09:15:00',6.12),('10318','2013-07-09','09:20:00',6.29),('10318','2013-07-09','09:25:00',6.41),('10318','2013-07-09','09:30:00',6.56),('10318','2013-07-09','09:35:00',6.71),('10318','2013-07-09','09:40:00',6.83),('10318','2013-07-09','09:45:00',6.92),('10318','2013-07-09','09:50:00',7.08),('10318','2013-07-09','09:55:00',7.06),('10318','2013-07-09','10:00:00',7.29),('10318','2013-07-09','10:05:00',7.37),('10318','2013-07-09','10:10:00',7.48),('10318','2013-07-09','10:15:00',7.56),('10318','2013-07-09','10:20:00',7.69),('10318','2013-07-09','10:25:00',7.74),('10318','2013-07-09','10:30:00',7.82),('10318','2013-07-09','10:35:00',7.91),('10318','2013-07-09','10:40:00',8.01),('10318','2013-07-09','10:45:00',8.1),('10318','2013-07-09','10:50:00',8.19),('10318','2013-07-09','10:55:00',8.31),('10318','2013-07-09','11:00:00',8.41),('10318','2013-07-09','11:05:00',8.21),('10318','2013-07-09','11:10:00',8.55),('10318','2013-07-09','11:15:00',8.68),('10318','2013-07-09','11:20:00',8.89),('10318','2013-07-09','11:25:00',7.93),('10318','2013-07-09','11:30:00',7.59),('10318','2013-07-09','11:35:00',9.37),('10318','2013-07-09','11:40:00',9.22),('10318','2013-07-09','11:45:00',9.61),('10318','2013-07-09','11:50:00',9.16),('10318','2013-07-09','11:55:00',9.55),('10318','2013-07-09','12:00:00',9.28),('10318','2013-07-09','12:05:00',8.71),('10318','2013-07-09','12:10:00',8.93),('10318','2013-07-09','12:15:00',8.25),('10318','2013-07-09','12:20:00',8.59),('10318','2013-07-09','12:25:00',8.88),('10318','2013-07-09','12:30:00',8.95),('10318','2013-07-09','12:35:00',8.97),('10318','2013-07-09','12:40:00',8.99),('10318','2013-07-09','12:45:00',9.09),('10318','2013-07-09','12:50:00',9.18),('10318','2013-07-09','12:55:00',9.06),('10318','2013-07-09','13:00:00',9.21),('10318','2013-07-09','13:05:00',9.25),('10318','2013-07-09','13:10:00',8.99),('10318','2013-07-09','13:15:00',9.14),('10318','2013-07-09','13:20:00',9.35),('10318','2013-07-09','13:25:00',9.33),('10318','2013-07-09','13:30:00',9.22),('10318','2013-07-09','13:35:00',9.23),('10318','2013-07-09','13:40:00',9.14),('10318','2013-07-09','13:45:00',7.65),('10318','2013-07-09','13:50:00',7.53),('10318','2013-07-09','13:55:00',8.83),('10318','2013-07-09','14:00:00',7.9),('10318','2013-07-09','14:05:00',7.44),('10318','2013-07-09','14:10:00',7.26),('10318','2013-07-09','14:15:00',7.92),('10318','2013-07-09','14:20:00',8.95),('10318','2013-07-09','14:25:00',6.41),('10318','2013-07-09','14:30:00',2.83),('10318','2013-07-09','14:35:00',2.19),('10318','2013-07-09','14:40:00',1.99),('10318','2013-07-09','14:45:00',1.63),('10318','2013-07-09','17:10:00',1.02),('10318','2013-07-09','17:15:00',1.03),('10318','2013-07-09','17:20:00',1.04),('10318','2013-07-09','17:25:00',1.12),('10318','2013-07-09','17:30:00',1.17),('10318','2013-07-09','17:35:00',1.17),('10318','2013-07-09','17:40:00',1.12),('10318','2013-07-09','17:45:00',1),('10318','2013-07-08','07:30:00',1.08),('10318','2013-07-08','07:35:00',1.94),('10318','2013-07-08','07:40:00',3.53),('10318','2013-07-08','07:45:00',3.41),('10318','2013-07-08','07:50:00',3.54),('10318','2013-07-08','07:55:00',3.09),('10318','2013-07-08','08:00:00',3.07),('10318','2013-07-08','08:05:00',3.58),('10318','2013-07-08','08:10:00',3.7),('10318','2013-07-08','08:15:00',4.12),('10318','2013-07-08','08:20:00',4.32),('10318','2013-07-08','08:25:00',4.52),('10318','2013-07-08','08:30:00',4.68),('10318','2013-07-08','08:35:00',4.86),('10318','2013-07-08','08:40:00',4.99),('10318','2013-07-08','08:45:00',5.2),('10318','2013-07-08','08:50:00',5.33),('10318','2013-07-08','08:55:00',5.47),('10318','2013-07-08','09:00:00',5.61),('10318','2013-07-08','09:05:00',5.82),('10318','2013-07-08','09:10:00',6.01),('10318','2013-07-08','09:15:00',6.14),('10318','2013-07-08','09:20:00',6.3),('10318','2013-07-08','09:25:00',6.36),('10318','2013-07-08','09:30:00',6.53),('10318','2013-07-08','09:35:00',6.65),('10318','2013-07-08','09:40:00',6.83),('10318','2013-07-08','09:45:00',6.9),('10318','2013-07-08','09:50:00',7.01),('10318','2013-07-08','09:55:00',7.01),('10318','2013-07-08','10:00:00',7.22),('10318','2013-07-08','10:05:00',7.33),('10318','2013-07-08','10:10:00',7.47),('10318','2013-07-08','10:15:00',7.53),('10318','2013-07-08','10:20:00',7.6),('10318','2013-07-08','10:25:00',4.63),('10318','2013-07-08','10:50:00',7.98),('10318','2013-07-08','10:55:00',8.11),('10318','2013-07-08','11:00:00',8.25),('10318','2013-07-08','11:05:00',8.3),('10318','2013-07-08','11:10:00',8.4),('10318','2013-07-08','11:15:00',8.52),('10318','2013-07-08','11:20:00',8.61),('10318','2013-07-08','11:25:00',8.58),('10318','2013-07-08','11:30:00',8.57),('10318','2013-07-08','11:45:00',3.1),('10318','2013-07-08','12:00:00',8.76),('10318','2013-07-08','12:05:00',9.03),('10318','2013-07-08','12:10:00',9.15),('10318','2013-07-08','12:15:00',9.25),('10318','2013-07-08','12:20:00',9.22),('10318','2013-07-08','12:25:00',8.07),('10318','2013-07-08','12:30:00',9.13),('10318','2013-07-08','12:35:00',9.19),('10318','2013-07-08','12:40:00',9.24),('10318','2013-07-08','12:45:00',9.28),('10318','2013-07-08','12:50:00',9.22),('10318','2013-07-08','12:55:00',9.43),('10318','2013-07-08','13:00:00',9.59),('10318','2013-07-08','13:05:00',9.7),('10318','2013-07-08','13:10:00',7.18),('10318','2013-07-08','13:15:00',3.23),('10318','2013-07-08','13:20:00',3.17),('10318','2013-07-08','13:25:00',2.48),('10318','2013-07-08','13:30:00',1.37),('10318','2013-07-08','13:55:00',1.06),('10318','2013-07-08','14:00:00',1.35),('10318','2013-07-08','14:05:00',1.76),('10318','2013-07-08','14:10:00',1.98),('10318','2013-07-08','14:15:00',1.99),('10318','2013-07-08','14:20:00',2),('10318','2013-07-08','14:25:00',2.11),('10318','2013-07-08','14:30:00',2.23),('10318','2013-07-08','14:35:00',2.74),('10318','2013-07-08','14:40:00',2.97),('10318','2013-07-08','14:45:00',2.84),('10318','2013-07-08','14:50:00',2.77),('10318','2013-07-08','14:55:00',2.69),('10318','2013-07-08','15:00:00',2.48),('10318','2013-07-08','15:05:00',2.27),('10318','2013-07-08','15:10:00',2.11),('10318','2013-07-08','15:15:00',1.86),('10318','2013-07-08','15:20:00',1.41),('10318','2013-07-08','15:25:00',1.2),('10318','2013-07-08','17:20:00',1.13),('10318','2013-07-08','17:25:00',1.52),('10318','2013-07-08','17:30:00',1.88),('10318','2013-07-08','17:35:00',2.09),('10318','2013-07-08','17:40:00',2.16),('10318','2013-07-08','17:45:00',2.1),('10318','2013-07-08','17:50:00',2.2),('10318','2013-07-08','17:55:00',2.11),('10318','2013-07-08','18:00:00',1.95),('10318','2013-07-08','18:05:00',1.78),('10318','2013-07-08','18:10:00',1.71),('10318','2013-07-08','18:15:00',1.71),('10318','2013-07-08','18:20:00',1.86),('10318','2013-07-08','18:25:00',1.88),('10318','2013-07-08','18:30:00',1.95),('10318','2013-07-08','18:35:00',2.14),('10318','2013-07-08','18:40:00',2.3),('10318','2013-07-08','18:45:00',1.97),('10318','2013-07-08','18:50:00',1.67),('10318','2013-07-08','18:55:00',1.42),('10318','2013-07-08','19:00:00',1.11),('10318','2013-07-07','07:00:00',1.27),('10318','2013-07-07','07:05:00',1.43),('10318','2013-07-07','07:10:00',1.73),('10318','2013-07-07','07:15:00',1.94),('10318','2013-07-07','07:20:00',2.21),('10318','2013-07-07','07:25:00',2.46),('10318','2013-07-07','07:30:00',2.71),('10318','2013-07-07','07:35:00',2.9),('10318','2013-07-07','07:40:00',3.09),('10318','2013-07-07','07:45:00',3.29),('10318','2013-07-07','07:50:00',3.47),('10318','2013-07-07','07:55:00',3.66),('10318','2013-07-07','08:00:00',3.87),('10318','2013-07-07','08:05:00',4.08),('10318','2013-07-07','08:10:00',4.27),('10318','2013-07-07','08:15:00',4.47),('10318','2013-07-07','08:20:00',3.76),('10318','2013-07-07','08:25:00',4.08),('10318','2013-07-07','08:30:00',4.74),('10318','2013-07-07','08:35:00',4.6),('10318','2013-07-07','08:40:00',2.89),('10318','2013-07-07','08:45:00',3.85),('10318','2013-07-07','08:50:00',4.1),('10318','2013-07-07','08:55:00',6.18),('10318','2013-07-07','09:00:00',6.41),('10318','2013-07-07','09:05:00',6.46),('10318','2013-07-07','09:10:00',5.85),('10318','2013-07-07','09:15:00',5.07),('10318','2013-07-07','09:20:00',5.77),('10318','2013-07-07','09:25:00',5.39),('10318','2013-07-07','09:30:00',5.89),('10318','2013-07-07','09:35:00',7.25),('10318','2013-07-07','09:40:00',6.8),('10318','2013-07-07','09:45:00',6.79),('10318','2013-07-07','09:50:00',7.61),('10318','2013-07-07','09:55:00',7.98),('10318','2013-07-07','10:00:00',7.84),('10318','2013-07-07','10:05:00',7.82),('10318','2013-07-07','10:10:00',6.78),('10318','2013-07-07','10:15:00',7.61),('10318','2013-07-07','10:20:00',7.53),('10318','2013-07-07','10:25:00',8.45),('10318','2013-07-07','10:30:00',6.99),('10318','2013-07-07','10:35:00',8),('10318','2013-07-07','10:40:00',8.59),('10318','2013-07-07','10:45:00',8.44),('10318','2013-07-07','10:50:00',8.56),('10318','2013-07-07','10:55:00',8.6),('10318','2013-07-07','11:00:00',8.68),('10318','2013-07-07','11:05:00',8.74),('10318','2013-07-07','11:10:00',8.8),('10318','2013-07-07','11:15:00',8.94),('10318','2013-07-07','11:20:00',7.97),('10318','2013-07-07','11:25:00',8.41),('10318','2013-07-07','11:30:00',8.15),('10318','2013-07-07','11:35:00',7.85),('10318','2013-07-07','11:40:00',8.02),('10318','2013-07-07','11:45:00',8.14),('10318','2013-07-07','11:50:00',8.3),('10318','2013-07-07','11:55:00',5.92),('10318','2013-07-07','12:00:00',6.53),('10318','2013-07-07','12:05:00',8.73),('10318','2013-07-07','12:10:00',8.49),('10318','2013-07-07','12:15:00',8.95),('10318','2013-07-07','12:20:00',6.69),('10318','2013-07-07','12:25:00',8.66),('10318','2013-07-07','12:30:00',8.59),('10318','2013-07-07','12:35:00',8.69),('10318','2013-07-07','12:40:00',9.03),('10318','2013-07-07','12:45:00',9.2),('10318','2013-07-07','12:50:00',9.33),('10318','2013-07-07','12:55:00',9.26),('10318','2013-07-07','13:00:00',9.26),('10318','2013-07-07','13:05:00',9.33),('10318','2013-07-07','13:10:00',9.28),('10318','2013-07-07','13:15:00',9.24),('10318','2013-07-07','13:20:00',9.16),('10318','2013-07-07','13:25:00',9.36),('10318','2013-07-07','13:30:00',9.17),('10318','2013-07-07','13:35:00',8.8),('10318','2013-07-07','13:40:00',9.19),('10318','2013-07-07','13:45:00',9.8),('10318','2013-07-07','13:50:00',9.96),('10318','2013-07-07','13:55:00',7.39),('10318','2013-07-07','14:00:00',7.42),('10318','2013-07-07','14:05:00',4.33),('10318','2013-07-07','14:10:00',4.29),('10318','2013-07-07','14:15:00',3.45),('10318','2013-07-07','14:20:00',3.56),('10318','2013-07-07','14:25:00',3.72),('10318','2013-07-07','14:30:00',2.98),('10318','2013-07-07','14:35:00',2.47),('10318','2013-07-07','14:40:00',2.17),('10318','2013-07-07','14:45:00',1.92),('10318','2013-07-07','14:50:00',1.82),('10318','2013-07-07','14:55:00',1.91),('10318','2013-07-07','15:00:00',2.22),('10318','2013-07-07','15:05:00',2.51),('10318','2013-07-07','15:10:00',1.77),('10318','2013-07-07','15:15:00',1.12),('10318','2013-07-07','15:20:00',1.25),('10318','2013-07-07','15:25:00',1.15),('10318','2013-07-07','16:40:00',1.01),('10318','2013-07-07','16:45:00',1.16),('10318','2013-07-07','16:50:00',1.42),('10318','2013-07-07','16:55:00',1.74),('10318','2013-07-07','17:00:00',2.01),('10318','2013-07-07','17:05:00',2.2),('10318','2013-07-07','17:10:00',2.31),('10318','2013-07-07','17:15:00',2.39),('10318','2013-07-07','17:20:00',2.43),('10318','2013-07-07','17:25:00',2.36),('10318','2013-07-07','17:30:00',2.39),('10318','2013-07-07','17:35:00',2.23),('10318','2013-07-07','17:40:00',2.06),('10318','2013-07-07','17:45:00',1.98),('10318','2013-07-07','17:50:00',1.94),('10318','2013-07-07','17:55:00',1.89),('10318','2013-07-07','18:00:00',1.82),('10318','2013-07-07','18:05:00',1.79),('10318','2013-07-07','18:10:00',1.68),('10318','2013-07-07','18:15:00',1.65),('10318','2013-07-07','18:20:00',1.67),('10318','2013-07-07','18:25:00',1.62),('10318','2013-07-07','18:30:00',1.53),('10318','2013-07-07','18:35:00',1.41),('10318','2013-07-07','18:40:00',1.31),('10318','2013-07-07','18:45:00',1.24),('10318','2013-07-07','18:50:00',1.25),('10318','2013-07-07','18:55:00',1.19),('10318','2013-07-07','19:00:00',1.08),('10318','2013-07-06','06:55:00',1.02),('10318','2013-07-06','07:00:00',1.3),('10318','2013-07-06','07:05:00',1.48),('10318','2013-07-06','07:10:00',1.66),('10318','2013-07-06','07:15:00',1.8),('10318','2013-07-06','07:20:00',2.14),('10318','2013-07-06','07:25:00',2.4),('10318','2013-07-06','07:30:00',2.6),('10318','2013-07-06','07:35:00',2.78),('10318','2013-07-06','07:40:00',2.94),('10318','2013-07-06','07:45:00',3.1),('10318','2013-07-06','07:50:00',3.32),('10318','2013-07-06','07:55:00',3.51),('10318','2013-07-06','08:00:00',3.7),('10318','2013-07-06','08:05:00',3.88),('10318','2013-07-06','08:10:00',4.07),('10318','2013-07-06','08:15:00',4.26),('10318','2013-07-06','08:20:00',4.42),('10318','2013-07-06','08:25:00',4.57),('10318','2013-07-06','08:30:00',4.78),('10318','2013-07-06','08:35:00',4.94),('10318','2013-07-06','08:40:00',5.08),('10318','2013-07-06','08:45:00',5.24),('10318','2013-07-06','08:50:00',5.39),('10318','2013-07-06','08:55:00',5.56),('10318','2013-07-06','09:00:00',5.73),('10318','2013-07-06','09:05:00',5.86),('10318','2013-07-06','09:10:00',6.04),('10318','2013-07-06','09:15:00',6.18),('10318','2013-07-06','09:20:00',6.25),('10318','2013-07-06','09:25:00',6.45),('10318','2013-07-06','09:30:00',6.58),('10318','2013-07-06','09:35:00',6.72),('10318','2013-07-06','09:40:00',6.86),('10318','2013-07-06','09:45:00',6.97),('10318','2013-07-06','09:50:00',7.06),('10318','2013-07-06','09:55:00',7.24),('10318','2013-07-06','10:00:00',7.38),('10318','2013-07-06','10:05:00',7.47),('10318','2013-07-06','10:10:00',7.57),('10318','2013-07-06','10:15:00',7.64),('10318','2013-07-06','10:20:00',7.75),('10318','2013-07-06','10:25:00',7.85),('10318','2013-07-06','10:30:00',7.94),('10318','2013-07-06','10:35:00',8.06),('10318','2013-07-06','10:40:00',8.23),('10318','2013-07-06','10:45:00',8.29),('10318','2013-07-06','10:50:00',8.4),('10318','2013-07-06','10:55:00',8.47),('10318','2013-07-06','11:00:00',8.54),('10318','2013-07-06','11:05:00',8.55),('10318','2013-07-06','11:10:00',8.48),('10318','2013-07-06','11:15:00',8.58),('10318','2013-07-06','11:20:00',8.59),('10318','2013-07-06','11:25:00',8.66),('10318','2013-07-06','11:30:00',8.67),('10318','2013-07-06','11:35:00',8.81),('10318','2013-07-06','11:40:00',8.88),('10318','2013-07-06','11:45:00',8.88),('10318','2013-07-06','11:50:00',8.91),('10318','2013-07-06','11:55:00',8.99),('10318','2013-07-06','12:00:00',9.12),('10318','2013-07-06','12:05:00',9.11),('10318','2013-07-06','12:10:00',9.19),('10318','2013-07-06','12:15:00',9.11),('10318','2013-07-06','12:20:00',9.16),('10318','2013-07-06','12:25:00',9.38),('10318','2013-07-06','12:30:00',9.29),('10318','2013-07-06','12:35:00',9.22),('10318','2013-07-06','12:40:00',9.31),('10318','2013-07-06','12:45:00',9.24),('10318','2013-07-06','12:50:00',9.19),('10318','2013-07-06','12:55:00',9.06),('10318','2013-07-06','13:00:00',9.16),('10318','2013-07-06','13:05:00',9.23),('10318','2013-07-06','13:10:00',9.15),('10318','2013-07-06','13:15:00',9.16),('10318','2013-07-06','13:20:00',9.22),('10318','2013-07-06','13:25:00',9.09),('10318','2013-07-06','13:30:00',9.19),('10318','2013-07-06','13:35:00',9.22),('10318','2013-07-06','13:40:00',9.3),('10318','2013-07-06','13:45:00',9.08),('10318','2013-07-06','13:50:00',8.98),('10318','2013-07-06','13:55:00',8.86),('10318','2013-07-06','14:00:00',8.8),('10318','2013-07-06','14:05:00',8.65),('10318','2013-07-06','14:10:00',8.74),('10318','2013-07-06','14:15:00',8.77),('10318','2013-07-06','14:20:00',8.74),('10318','2013-07-06','14:25:00',8.63),('10318','2013-07-06','14:30:00',8.4),('10318','2013-07-06','14:35:00',8.24),('10318','2013-07-06','14:40:00',8.04),('10318','2013-07-06','14:45:00',8.31),('10318','2013-07-06','14:50:00',8.34),('10318','2013-07-06','14:55:00',8.4),('10318','2013-07-06','15:00:00',8.21),('10318','2013-07-06','15:05:00',8.18),('10318','2013-07-06','15:10:00',7.93),('10318','2013-07-06','15:15:00',7.76),('10318','2013-07-06','15:20:00',7.88),('10318','2013-07-06','15:25:00',7.87),('10318','2013-07-06','15:30:00',4.01),('10318','2013-07-06','15:35:00',1.94),('10318','2013-07-06','15:40:00',1.45),('10318','2013-07-06','16:15:00',1.41),('10318','2013-07-06','16:20:00',1.4),('10318','2013-07-06','16:35:00',1.46),('10318','2013-07-06','16:40:00',2.02),('10318','2013-07-06','16:45:00',2),('10318','2013-07-06','16:50:00',5.05),('10318','2013-07-06','16:55:00',3.44),('10318','2013-07-06','17:00:00',2.64),('10318','2013-07-06','17:05:00',2.36),('10318','2013-07-06','17:10:00',3.2),('10318','2013-07-06','17:15:00',3.94),('10318','2013-07-06','17:20:00',2.88),('10318','2013-07-06','17:25:00',2.33),('10318','2013-07-06','17:30:00',2.31),('10318','2013-07-06','17:35:00',2.26),('10318','2013-07-06','17:40:00',2.06),('10318','2013-07-06','17:45:00',2.01),('10318','2013-07-06','17:50:00',1.85),('10318','2013-07-06','17:55:00',1.69),('10318','2013-07-06','18:00:00',1.53),('10318','2013-07-06','18:05:00',1.42),('10318','2013-07-06','18:10:00',1.36),('10318','2013-07-06','18:15:00',1.28),('10318','2013-07-06','18:20:00',1.23),('10318','2013-07-06','18:25:00',1.19),('10318','2013-07-06','18:30:00',1.12),('10318','2013-07-06','18:35:00',1.07),('10318','2013-07-06','18:40:00',1.02),('10318','2013-07-05','06:55:00',1.04),('10318','2013-07-05','07:00:00',1.31),('10318','2013-07-05','07:05:00',1.46),('10318','2013-07-05','07:10:00',1.64),('10318','2013-07-05','07:15:00',1.73),('10318','2013-07-05','07:20:00',2.11),('10318','2013-07-05','07:25:00',2.39),('10318','2013-07-05','07:30:00',2.4),('10318','2013-07-05','07:35:00',1.21),('10318','2013-07-05','07:40:00',2.43),('10318','2013-07-05','07:45:00',3.16),('10318','2013-07-05','07:50:00',3.34),('10318','2013-07-05','07:55:00',3.53),('10318','2013-07-05','08:00:00',3.7),('10318','2013-07-05','08:05:00',3.91),('10318','2013-07-05','08:10:00',4.12),('10318','2013-07-05','08:15:00',4.28),('10318','2013-07-05','08:20:00',4.42),('10318','2013-07-05','08:25:00',4.65),('10318','2013-07-05','08:30:00',4.81),('10318','2013-07-05','08:35:00',4.92),('10318','2013-07-05','08:40:00',5.13),('10318','2013-07-05','08:45:00',5.28),('10318','2013-07-05','08:50:00',5.46),('10318','2013-07-05','08:55:00',5.63),('10318','2013-07-05','09:00:00',5.8),('10318','2013-07-05','09:05:00',5.94),('10318','2013-07-05','09:10:00',6.05),('10318','2013-07-05','09:15:00',6.18),('10318','2013-07-05','09:20:00',6.34),('10318','2013-07-05','09:25:00',6.49),('10318','2013-07-05','09:30:00',6.65),('10318','2013-07-05','09:35:00',6.76),('10318','2013-07-05','09:40:00',6.88),('10318','2013-07-05','09:45:00',7),('10318','2013-07-05','09:50:00',7.11),('10318','2013-07-05','09:55:00',7.22),('10318','2013-07-05','10:00:00',7.33),('10318','2013-07-05','10:05:00',7.41),('10318','2013-07-05','10:10:00',7.54),('10318','2013-07-05','10:15:00',7.66),('10318','2013-07-05','10:20:00',7.64),('10318','2013-07-05','10:25:00',7.83),('10318','2013-07-05','10:30:00',7.91),('10318','2013-07-05','10:35:00',7.99),('10318','2013-07-05','10:40:00',8.09),('10318','2013-07-05','10:45:00',8.16),('10318','2013-07-05','10:50:00',8.24),('10318','2013-07-05','10:55:00',8.33),('10318','2013-07-05','11:00:00',8.37),('10318','2013-07-05','11:05:00',8.47),('10318','2013-07-05','11:10:00',8.54),('10318','2013-07-05','11:15:00',8.56),('10318','2013-07-05','11:20:00',8.6),('10318','2013-07-05','11:25:00',8.63),('10318','2013-07-05','11:30:00',8.75),('10318','2013-07-05','11:35:00',8.81),('10318','2013-07-05','11:40:00',8.84),('10318','2013-07-05','11:45:00',8.68),('10318','2013-07-05','11:50:00',8.82),('10318','2013-07-05','11:55:00',8.88),('10318','2013-07-05','12:00:00',8.76),('10318','2013-07-05','12:05:00',8.6),('10318','2013-07-05','12:10:00',8.6),('10318','2013-07-05','12:15:00',9.14),('10318','2013-07-05','12:20:00',9.13),('10318','2013-07-05','12:25:00',9.25),('10318','2013-07-05','12:30:00',9.5),('10318','2013-07-05','12:35:00',5.91),('10318','2013-07-05','12:40:00',8.71),('10318','2013-07-05','12:45:00',9.34),('10318','2013-07-05','12:50:00',9.24),('10318','2013-07-05','12:55:00',9.45),('10318','2013-07-05','13:00:00',9.71),('10318','2013-07-05','13:05:00',9.82),('10318','2013-07-05','13:10:00',8.41),('10318','2013-07-05','13:15:00',9.41),('10318','2013-07-05','13:20:00',9.43),('10318','2013-07-05','13:25:00',8.58),('10318','2013-07-05','13:30:00',8.35),('10318','2013-07-05','13:35:00',9.34),('10318','2013-07-05','13:40:00',9.2),('10318','2013-07-05','13:45:00',9.23),('10318','2013-07-05','13:50:00',8.3),('10318','2013-07-05','13:55:00',9.11),('10318','2013-07-05','14:00:00',8.31),('10318','2013-07-05','14:05:00',8.99),('10318','2013-07-05','14:10:00',6.8),('10318','2013-07-05','14:15:00',7.08),('10318','2013-07-05','14:20:00',8.86),('10318','2013-07-05','14:25:00',8.56),('10318','2013-07-05','14:30:00',8.56),('10318','2013-07-05','14:35:00',8.57),('10318','2013-07-05','14:40:00',8.45),('10318','2013-07-05','14:45:00',8.42),('10318','2013-07-05','14:50:00',8.34),('10318','2013-07-05','14:55:00',8.2),('10318','2013-07-05','15:00:00',8.17),('10318','2013-07-05','15:05:00',8.27),('10318','2013-07-05','15:10:00',7.97),('10318','2013-07-05','15:15:00',8),('10318','2013-07-05','15:20:00',7.88),('10318','2013-07-05','15:25:00',7.74),('10318','2013-07-05','15:30:00',7.6),('10318','2013-07-05','15:35:00',5.56),('10318','2013-07-05','15:40:00',6.15),('10318','2013-07-05','15:45:00',6.13),('10318','2013-07-05','15:50:00',7.22),('10318','2013-07-05','15:55:00',6.99),('10318','2013-07-05','16:00:00',6.7),('10318','2013-07-05','16:05:00',6.61),('10318','2013-07-05','16:10:00',6.39),('10318','2013-07-05','16:15:00',6.24),('10318','2013-07-05','16:20:00',6.17),('10318','2013-07-05','16:25:00',5.98),('10318','2013-07-05','16:30:00',5.82),('10318','2013-07-05','16:35:00',5.59),('10318','2013-07-05','16:40:00',5.43),('10318','2013-07-05','16:45:00',5.29),('10318','2013-07-05','16:50:00',5.14),('10318','2013-07-05','16:55:00',4.87),('10318','2013-07-05','17:00:00',4.75),('10318','2013-07-05','17:05:00',4.69),('10318','2013-07-05','17:10:00',4.54),('10318','2013-07-05','17:15:00',4.22),('10318','2013-07-05','17:20:00',4.1),('10318','2013-07-05','17:25:00',3.81),('10318','2013-07-05','17:30:00',3.75),('10318','2013-07-05','17:35:00',3.65),('10318','2013-07-05','17:40:00',3.43),('10318','2013-07-05','17:45:00',3.2),('10318','2013-07-05','17:50:00',2.99),('10318','2013-07-05','17:55:00',2.83),('10318','2013-07-05','18:00:00',2.71),('10318','2013-07-05','18:05:00',2.68),('10318','2013-07-05','18:10:00',2.57),('10318','2013-07-05','18:15:00',2.39),('10318','2013-07-05','18:20:00',2.16),('10318','2013-07-05','18:25:00',1.92),('10318','2013-07-05','18:30:00',1.81),('10318','2013-07-05','18:35:00',1.64),('10318','2013-07-05','18:40:00',1.46),('10318','2013-07-05','18:45:00',1.33),('10318','2013-07-05','18:50:00',1.2),('10318','2013-07-05','18:55:00',1.08),('10318','2013-07-04','07:50:00',1.02),('10318','2013-07-04','07:55:00',1.17),('10318','2013-07-04','08:00:00',1.18),('10318','2013-07-04','08:30:00',1.04),('10318','2013-07-04','08:35:00',1.05),('10318','2013-07-04','08:40:00',1.1),('10318','2013-07-04','08:45:00',1.37),('10318','2013-07-04','08:50:00',1.75),('10318','2013-07-04','08:55:00',1.96),('10318','2013-07-04','09:00:00',1.83),('10318','2013-07-04','09:05:00',1.52),('10318','2013-07-04','09:10:00',1.57),('10318','2013-07-04','09:15:00',1.58),('10318','2013-07-04','09:20:00',1.6),('10318','2013-07-04','09:25:00',1.7),('10318','2013-07-04','09:30:00',1.65),('10318','2013-07-04','09:35:00',1.41),('10318','2013-07-04','09:40:00',1.18),('10318','2013-07-04','09:45:00',1.04),('10318','2013-07-04','10:05:00',1.1),('10318','2013-07-04','10:10:00',1.34),('10318','2013-07-04','10:15:00',1.52),('10318','2013-07-04','10:20:00',1.59),('10318','2013-07-04','10:25:00',1.58),('10318','2013-07-04','10:30:00',1.64),('10318','2013-07-04','10:35:00',1.68),('10318','2013-07-04','10:40:00',1.54),('10318','2013-07-04','10:45:00',1.37),('10318','2013-07-04','10:50:00',1.33),('10318','2013-07-04','10:55:00',1.6),('10318','2013-07-04','11:00:00',1.89),('10318','2013-07-04','11:05:00',2.11),('10318','2013-07-04','11:10:00',2.4),('10318','2013-07-04','11:15:00',2.34),('10318','2013-07-04','11:20:00',2.38),('10318','2013-07-04','11:25:00',2.56),('10318','2013-07-04','11:30:00',2.82),('10318','2013-07-04','11:35:00',3.22),('10318','2013-07-04','11:40:00',3.43),('10318','2013-07-04','11:45:00',3.7),('10318','2013-07-04','11:50:00',3.69),('10318','2013-07-04','11:55:00',3.97),('10318','2013-07-04','12:00:00',4.3),('10318','2013-07-04','12:05:00',5.01),('10318','2013-07-04','12:10:00',6.24),('10318','2013-07-04','12:15:00',6.19),('10318','2013-07-04','12:20:00',4.39),('10318','2013-07-04','12:25:00',4.17),('10318','2013-07-04','12:30:00',3.44),('10318','2013-07-04','12:35:00',2.87),('10318','2013-07-04','12:40:00',2.3),('10318','2013-07-04','12:45:00',1.86),('10318','2013-07-04','12:50:00',1.54),('10318','2013-07-04','12:55:00',1.61),('10318','2013-07-04','13:00:00',1.9),('10318','2013-07-04','13:05:00',2.43),('10318','2013-07-04','13:10:00',3.64),('10318','2013-07-04','13:15:00',4.21),('10318','2013-07-04','13:20:00',4.15),('10318','2013-07-04','13:25:00',5.34),('10318','2013-07-04','13:30:00',5.85),('10318','2013-07-04','13:35:00',4.73),('10318','2013-07-04','13:40:00',7.66),('10318','2013-07-04','13:45:00',10.82),('10318','2013-07-04','13:50:00',10.46),('10318','2013-07-04','13:55:00',8.3),('10318','2013-07-04','14:00:00',5.74),('10318','2013-07-04','14:05:00',5.1),('10318','2013-07-04','14:10:00',4.43),('10318','2013-07-04','14:15:00',4.11),('10318','2013-07-04','14:20:00',3.92),('10318','2013-07-04','14:25:00',4.04),('10318','2013-07-04','14:30:00',3.93),('10318','2013-07-04','14:35:00',4.66),('10318','2013-07-04','14:40:00',4.83),('10318','2013-07-04','14:45:00',4.74),('10318','2013-07-04','14:50:00',5.81),('10318','2013-07-04','14:55:00',4.29),('10318','2013-07-04','15:00:00',4.74),('10318','2013-07-04','15:05:00',4.21),('10318','2013-07-04','15:10:00',7.57),('10318','2013-07-04','15:15:00',5.45),('10318','2013-07-04','15:20:00',5.33),('10318','2013-07-04','15:25:00',3.1),('10318','2013-07-04','15:30:00',4.26),('10318','2013-07-04','15:35:00',6.69),('10318','2013-07-04','15:40:00',5.51),('10318','2013-07-04','15:45:00',4.93),('10318','2013-07-04','15:50:00',5.43),('10318','2013-07-04','15:55:00',6.34),('10318','2013-07-04','16:00:00',6.43),('10318','2013-07-04','16:05:00',5.47),('10318','2013-07-04','16:10:00',3.69),('10318','2013-07-04','16:15:00',3.99),('10318','2013-07-04','16:20:00',4.56),('10318','2013-07-04','16:25:00',5.64),('10318','2013-07-04','16:30:00',4.29),('10318','2013-07-04','16:35:00',3.76),('10318','2013-07-04','16:40:00',3.29),('10318','2013-07-04','16:45:00',3.14),('10318','2013-07-04','16:50:00',3.17),('10318','2013-07-04','16:55:00',3.04),('10318','2013-07-04','17:00:00',2.79),('10318','2013-07-04','17:05:00',3.06),('10318','2013-07-04','17:10:00',4.24),('10318','2013-07-04','17:15:00',3.62),('10318','2013-07-04','17:20:00',5.39),('10318','2013-07-04','17:25:00',4.76),('10318','2013-07-04','17:30:00',4.15),('10318','2013-07-04','17:35:00',3.35),('10318','2013-07-04','17:40:00',4.03),('10318','2013-07-04','17:45:00',3.84),('10318','2013-07-04','17:50:00',3.42),('10318','2013-07-04','17:55:00',3.52),('10318','2013-07-04','18:00:00',3.38),('10318','2013-07-04','18:05:00',3.18),('10318','2013-07-04','18:10:00',3.03),('10318','2013-07-04','18:15:00',2.96),('10318','2013-07-04','18:20:00',2.67),('10318','2013-07-04','18:25:00',2.28),('10318','2013-07-04','18:30:00',1.7),('10318','2013-07-04','18:35:00',1.64),('10318','2013-07-04','18:40:00',1.44),('10318','2013-07-03','06:55:00',1.14),('10318','2013-07-03','07:00:00',1.43),('10318','2013-07-03','07:05:00',1.67),('10318','2013-07-03','07:10:00',1.8),('10318','2013-07-03','07:15:00',1.87),('10318','2013-07-03','07:20:00',2.33),('10318','2013-07-03','07:25:00',2.63),('10318','2013-07-03','07:30:00',2.81),('10318','2013-07-03','07:35:00',3),('10318','2013-07-03','07:40:00',3.2),('10318','2013-07-03','07:45:00',3.4),('10318','2013-07-03','07:50:00',3.58),('10318','2013-07-03','07:55:00',3.78),('10318','2013-07-03','08:00:00',3.98),('10318','2013-07-03','08:05:00',4.17),('10318','2013-07-03','08:10:00',4.35),('10318','2013-07-03','08:15:00',4.53),('10318','2013-07-03','08:20:00',4.69),('10318','2013-07-03','08:25:00',4.88),('10318','2013-07-03','08:30:00',5.07),('10318','2013-07-03','08:35:00',5.2),('10318','2013-07-03','08:40:00',5.41),('10318','2013-07-03','08:45:00',5.57),('10318','2013-07-03','08:50:00',5.72),('10318','2013-07-03','08:55:00',5.89),('10318','2013-07-03','09:00:00',6.02),('10318','2013-07-03','09:05:00',6.12),('10318','2013-07-03','09:10:00',6.31),('10318','2013-07-03','09:15:00',6.49),('10318','2013-07-03','09:20:00',6.63),('10318','2013-07-03','09:25:00',6.71),('10318','2013-07-03','09:30:00',6.85),('10318','2013-07-03','09:35:00',6.96),('10318','2013-07-03','09:40:00',7.11),('10318','2013-07-03','09:45:00',7.24),('10318','2013-07-03','09:50:00',7.35),('10318','2013-07-03','09:55:00',7.45),('10318','2013-07-03','10:00:00',7.46),('10318','2013-07-03','10:05:00',7.58),('10318','2013-07-03','10:10:00',7.82),('10318','2013-07-03','10:15:00',7.77),('10318','2013-07-03','10:20:00',7.75),('10318','2013-07-03','10:25:00',8.05),('10318','2013-07-03','10:30:00',8.13),('10318','2013-07-03','10:35:00',8.29),('10318','2013-07-03','10:40:00',8.45),('10318','2013-07-03','10:45:00',8.47),('10318','2013-07-03','10:50:00',8.5),('10318','2013-07-03','10:55:00',8.58),('10318','2013-07-03','11:00:00',8.58),('10318','2013-07-03','11:05:00',8.73),('10318','2013-07-03','11:10:00',8.67),('10318','2013-07-03','11:15:00',8.78),('10318','2013-07-03','11:20:00',8.85),('10318','2013-07-03','11:25:00',8.96),('10318','2013-07-03','11:30:00',9),('10318','2013-07-03','11:35:00',9.02),('10318','2013-07-03','11:40:00',8.87),('10318','2013-07-03','11:45:00',9.19),('10318','2013-07-03','11:50:00',9.17),('10318','2013-07-03','11:55:00',9.3),('10318','2013-07-03','12:00:00',9.29),('10318','2013-07-03','12:05:00',9.22),('10318','2013-07-03','12:10:00',9.33),('10318','2013-07-03','12:15:00',9.32),('10318','2013-07-03','12:20:00',9.37),('10318','2013-07-03','12:25:00',9.32),('10318','2013-07-03','12:30:00',9.34),('10318','2013-07-03','12:35:00',9.35),('10318','2013-07-03','12:40:00',9.32),('10318','2013-07-03','12:45:00',9.39),('10318','2013-07-03','12:50:00',9.38),('10318','2013-07-03','12:55:00',9.35),('10318','2013-07-03','13:00:00',9.34),('10318','2013-07-03','13:05:00',9.35),('10318','2013-07-03','13:10:00',9.29),('10318','2013-07-03','13:15:00',9.36),('10318','2013-07-03','13:20:00',9.35),('10318','2013-07-03','13:25:00',9.26),('10318','2013-07-03','13:30:00',9.21),('10318','2013-07-03','13:35:00',9.13),('10318','2013-07-03','13:40:00',9.13),('10318','2013-07-03','13:45:00',9.09),('10318','2013-07-03','13:50:00',9.03),('10318','2013-07-03','13:55:00',9.04),('10318','2013-07-03','14:00:00',8.99),('10318','2013-07-03','14:05:00',8.92),('10318','2013-07-03','14:10:00',8.91),('10318','2013-07-03','14:15:00',8.83),('10318','2013-07-03','14:20:00',8.84),('10318','2013-07-03','14:25:00',8.76),('10318','2013-07-03','14:30:00',8.65),('10318','2013-07-03','14:35:00',8.57),('10318','2013-07-03','14:40:00',8.53),('10318','2013-07-03','14:45:00',8.46),('10318','2013-07-03','14:50:00',8.39),('10318','2013-07-03','14:55:00',8.31),('10318','2013-07-03','15:00:00',8.25),('10318','2013-07-03','15:05:00',8.08),('10318','2013-07-03','15:10:00',8.08),('10318','2013-07-03','15:15:00',7.95),('10318','2013-07-03','15:20:00',7.85),('10318','2013-07-03','15:25:00',7.75),('10318','2013-07-03','15:30:00',7.62),('10318','2013-07-03','15:35:00',7.44),('10318','2013-07-03','15:40:00',7.39),('10318','2013-07-03','15:45:00',7.25),('10318','2013-07-03','15:50:00',7.09),('10318','2013-07-03','15:55:00',6.97),('10318','2013-07-03','16:00:00',6.84),('10318','2013-07-03','16:05:00',6.7),('10318','2013-07-03','16:10:00',6.57),('10318','2013-07-03','16:15:00',6.43),('10318','2013-07-03','16:20:00',6.24),('10318','2013-07-03','16:25:00',6.09),('10318','2013-07-03','16:30:00',5.95),('10318','2013-07-03','16:35:00',5.79),('10318','2013-07-03','16:40:00',5.67),('10318','2013-07-03','16:45:00',5.51),('10318','2013-07-03','16:50:00',5.35),('10318','2013-07-03','16:55:00',5.05),('10318','2013-07-03','17:00:00',5),('10318','2013-07-03','17:05:00',4.82),('10318','2013-07-03','17:10:00',4.65),('10318','2013-07-03','17:15:00',4.47),('10318','2013-07-03','17:20:00',4.27),('10318','2013-07-03','17:25:00',4.07),('10318','2013-07-03','17:30:00',3.92),('10318','2013-07-03','17:35:00',3.73),('10318','2013-07-03','17:40:00',3.56),('10318','2013-07-03','17:45:00',3.39),('10318','2013-07-03','17:50:00',3.19),('10318','2013-07-03','17:55:00',2.97),('10318','2013-07-03','18:00:00',2.8),('10318','2013-07-03','18:05:00',2.63),('10318','2013-07-03','18:10:00',2.45),('10318','2013-07-03','18:15:00',2.28),('10318','2013-07-03','18:20:00',2.11),('10318','2013-07-03','18:25:00',1.93),('10318','2013-07-03','18:30:00',1.77),('10318','2013-07-03','18:35:00',1.62),('10318','2013-07-03','18:40:00',1.41),('10318','2013-07-03','18:45:00',1.32),('10318','2013-07-03','18:50:00',1.18),('10318','2013-07-03','18:55:00',1.06),('10318','2013-07-02','06:55:00',1.11),('10318','2013-07-02','07:00:00',1.36),('10318','2013-07-02','07:05:00',1.61),('10318','2013-07-02','07:10:00',1.73),('10318','2013-07-02','07:15:00',1.99),('10318','2013-07-02','07:20:00',2.28),('10318','2013-07-02','07:25:00',2.54),('10318','2013-07-02','07:30:00',2.71),('10318','2013-07-02','07:35:00',2.86),('10318','2013-07-02','07:40:00',3.08),('10318','2013-07-02','07:45:00',3.28),('10318','2013-07-02','07:50:00',3.46),('10318','2013-07-02','07:55:00',3.65),('10318','2013-07-02','08:00:00',3.87),('10318','2013-07-02','08:05:00',4.03),('10318','2013-07-02','08:10:00',4.23),('10318','2013-07-02','08:15:00',4.44),('10318','2013-07-02','08:20:00',4.63),('10318','2013-07-02','08:25:00',4.82),('10318','2013-07-02','08:30:00',4.98),('10318','2013-07-02','08:35:00',5.17),('10318','2013-07-02','08:40:00',5.32),('10318','2013-07-02','08:45:00',5.5),('10318','2013-07-02','08:50:00',5.67),('10318','2013-07-02','08:55:00',5.82),('10318','2013-07-02','09:00:00',5.96),('10318','2013-07-02','09:05:00',6.13),('10318','2013-07-02','09:10:00',6.28),('10318','2013-07-02','09:15:00',6.39),('10318','2013-07-02','09:20:00',6.42),('10318','2013-07-02','09:25:00',6.67),('10318','2013-07-02','09:30:00',6.8),('10318','2013-07-02','09:35:00',6.88),('10318','2013-07-02','09:40:00',6.99),('10318','2013-07-02','09:45:00',7.09),('10318','2013-07-02','09:50:00',7.17),('10318','2013-07-02','09:55:00',7.25),('10318','2013-07-02','10:00:00',7.36),('10318','2013-07-02','10:05:00',7.45),('10318','2013-07-02','10:10:00',7.57),('10318','2013-07-02','10:15:00',7.68),('10318','2013-07-02','10:20:00',7.77),('10318','2013-07-02','10:25:00',7.84),('10318','2013-07-02','10:30:00',7.91),('10318','2013-07-02','10:35:00',7.98),('10318','2013-07-02','10:40:00',8.09),('10318','2013-07-02','10:45:00',8.22),('10318','2013-07-02','10:50:00',8.29),('10318','2013-07-02','10:55:00',8.31),('10318','2013-07-02','11:00:00',8.41),('10318','2013-07-02','11:05:00',8.36),('10318','2013-07-02','11:10:00',8.4),('10318','2013-07-02','11:15:00',8.44),('10318','2013-07-02','11:20:00',8.49),('10318','2013-07-02','11:25:00',8.4),('10318','2013-07-02','11:30:00',8.59),('10318','2013-07-02','11:35:00',8.49),('10318','2013-07-02','11:40:00',8.68),('10318','2013-07-02','11:45:00',8.71),('10318','2013-07-02','11:50:00',8.74),('10318','2013-07-02','11:55:00',8.86),('10318','2013-07-02','12:00:00',9.06),('10318','2013-07-02','12:05:00',9.12),('10318','2013-07-02','12:10:00',9.16),('10318','2013-07-02','12:15:00',9.13),('10318','2013-07-02','12:20:00',9.13),('10318','2013-07-02','12:25:00',9.32),('10318','2013-07-02','12:30:00',9.32),('10318','2013-07-02','12:35:00',9.04),('10318','2013-07-02','12:40:00',8.77),('10318','2013-07-02','12:45:00',8.79),('10318','2013-07-02','12:50:00',8.81),('10318','2013-07-02','12:55:00',9.38),('10318','2013-07-02','13:00:00',8.74),('10318','2013-07-02','13:05:00',9.27),('10318','2013-07-02','13:10:00',9.28),('10318','2013-07-02','13:15:00',9.26),('10318','2013-07-02','13:20:00',9.28),('10318','2013-07-02','13:25:00',9.15),('10318','2013-07-02','13:30:00',9.04),('10318','2013-07-02','13:35:00',9.03),('10318','2013-07-02','13:40:00',9.03),('10318','2013-07-02','13:45:00',8.93),('10318','2013-07-02','13:50:00',8.8),('10318','2013-07-02','13:55:00',8.72),('10318','2013-07-02','14:00:00',8.75),('10318','2013-07-02','14:05:00',8.74),('10318','2013-07-02','14:10:00',8.6),('10318','2013-07-02','14:15:00',8.58),('10318','2013-07-02','14:20:00',8.54),('10318','2013-07-02','14:25:00',8.48),('10318','2013-07-02','14:30:00',8.41),('10318','2013-07-02','14:35:00',8.32),('10318','2013-07-02','14:40:00',8.27),('10318','2013-07-02','14:45:00',8.21),('10318','2013-07-02','14:50:00',8.17),('10318','2013-07-02','14:55:00',8.09),('10318','2013-07-02','15:00:00',7.98),('10318','2013-07-02','15:05:00',7.85),('10318','2013-07-02','15:10:00',7.78),('10318','2013-07-02','15:15:00',7.67),('10318','2013-07-02','15:20:00',7.62),('10318','2013-07-02','15:25:00',7.57),('10318','2013-07-02','15:30:00',7.42),('10318','2013-07-02','15:35:00',7.25),('10318','2013-07-02','15:40:00',7.15),('10318','2013-07-02','15:45:00',7.06),('10318','2013-07-02','15:50:00',6.78),('10318','2013-07-02','15:55:00',6.8),('10318','2013-07-02','16:00:00',6.69),('10318','2013-07-02','16:05:00',6.54),('10318','2013-07-02','16:10:00',6.43),('10318','2013-07-02','16:15:00',6.27),('10318','2013-07-02','16:20:00',6.01),('10318','2013-07-02','16:25:00',5.97),('10318','2013-07-02','16:30:00',5.81),('10318','2013-07-02','16:35:00',5.65),('10318','2013-07-02','16:40:00',5.51),('10318','2013-07-02','16:45:00',5.36),('10318','2013-07-02','16:50:00',5.19),('10318','2013-07-02','16:55:00',5.01),('10318','2013-07-02','17:00:00',4.87),('10318','2013-07-02','17:05:00',4.7),('10318','2013-07-02','17:10:00',4.52),('10318','2013-07-02','17:15:00',4.33),('10318','2013-07-02','17:20:00',4.17),('10318','2013-07-02','17:25:00',3.99),('10318','2013-07-02','17:30:00',3.79),('10318','2013-07-02','17:35:00',3.62),('10318','2013-07-02','17:40:00',3.37),('10318','2013-07-02','17:45:00',3.25),('10318','2013-07-02','17:50:00',3.07),('10318','2013-07-02','17:55:00',2.9),('10318','2013-07-02','18:00:00',2.72),('10318','2013-07-02','18:05:00',2.55),('10318','2013-07-02','18:10:00',2.38),('10318','2013-07-02','18:15:00',2.23),('10318','2013-07-02','18:20:00',2.06),('10318','2013-07-02','18:25:00',1.89),('10318','2013-07-02','18:30:00',1.74),('10318','2013-07-02','18:35:00',1.59),('10318','2013-07-02','18:40:00',1.45),('10318','2013-07-02','18:45:00',1.32),('10318','2013-07-02','18:50:00',1.19),('10318','2013-07-02','18:55:00',1.08),('10318','2013-07-01','06:55:00',1.21),('10318','2013-07-01','07:00:00',1.41),('10318','2013-07-01','07:05:00',1.58),('10318','2013-07-01','07:10:00',1.78),('10318','2013-07-01','07:15:00',1.92),('10318','2013-07-01','07:20:00',2.32),('10318','2013-07-01','07:25:00',2.6),('10318','2013-07-01','07:30:00',2.78),('10318','2013-07-01','07:35:00',2.97),('10318','2013-07-01','07:40:00',3.14),('10318','2013-07-01','07:45:00',3.33),('10318','2013-07-01','07:50:00',3.52),('10318','2013-07-01','07:55:00',3.77),('10318','2013-07-01','08:00:00',3.97),('10318','2013-07-01','08:05:00',4.16),('10318','2013-07-01','08:10:00',4.35),('10318','2013-07-01','08:15:00',4.53),('10318','2013-07-01','08:20:00',4.73),('10318','2013-07-01','08:25:00',4.91),('10318','2013-07-01','08:30:00',5.08),('10318','2013-07-01','08:35:00',5.17),('10318','2013-07-01','08:40:00',5.42),('10318','2013-07-01','08:45:00',5.58),('10318','2013-07-01','08:50:00',5.75),('10318','2013-07-01','08:55:00',5.91),('10318','2013-07-01','09:00:00',6.09),('10318','2013-07-01','09:05:00',6.24),('10318','2013-07-01','09:10:00',6.42),('10318','2013-07-01','09:15:00',6.6),('10318','2013-07-01','09:20:00',6.71),('10318','2013-07-01','09:25:00',6.85),('10318','2013-07-01','09:30:00',7.01),('10318','2013-07-01','09:35:00',7.12),('10318','2013-07-01','09:40:00',7.22),('10318','2013-07-01','09:45:00',7.32),('10318','2013-07-01','09:50:00',7.34),('10318','2013-07-01','09:55:00',7.54),('10318','2013-07-01','10:00:00',7.61),('10318','2013-07-01','10:05:00',7.69),('10318','2013-07-01','10:10:00',7.8),('10318','2013-07-01','10:15:00',7.94),('10318','2013-07-01','10:20:00',8.05),('10318','2013-07-01','10:25:00',8.18),('10318','2013-07-01','10:30:00',8.31),('10318','2013-07-01','10:35:00',8.41),('10318','2013-07-01','10:40:00',8.53),('10318','2013-07-01','10:45:00',8.6),('10318','2013-07-01','10:50:00',8.66),('10318','2013-07-01','10:55:00',8.78),('10318','2013-07-01','11:00:00',8.84),('10318','2013-07-01','11:05:00',8.83),('10318','2013-07-01','11:10:00',8.87),('10318','2013-07-01','11:15:00',8.91),('10318','2013-07-01','11:20:00',8.95),('10318','2013-07-01','11:25:00',9.05),('10318','2013-07-01','11:30:00',9.14),('10318','2013-07-01','11:35:00',9.06),('10318','2013-07-01','11:40:00',9.16),('10318','2013-07-01','11:45:00',9.16),('10318','2013-07-01','11:50:00',9.19),('10318','2013-07-01','11:55:00',9.33),('10318','2013-07-01','12:00:00',9.32),('10318','2013-07-01','12:05:00',9.25),('10318','2013-07-01','12:10:00',9.19),('10318','2013-07-01','12:15:00',9.18),('10318','2013-07-01','12:20:00',9.24),('10318','2013-07-01','12:25:00',9.28),('10318','2013-07-01','12:30:00',9.29),('10318','2013-07-01','12:35:00',9.32),('10318','2013-07-01','12:40:00',9.36),('10318','2013-07-01','12:45:00',9.37),('10318','2013-07-01','12:50:00',9.38),('10318','2013-07-01','12:55:00',9.31),('10318','2013-07-01','13:00:00',9.29),('10318','2013-07-01','13:05:00',9.31),('10318','2013-07-01','13:10:00',9.3),('10318','2013-07-01','13:15:00',9.32),('10318','2013-07-01','13:20:00',9.19),('10318','2013-07-01','13:25:00',9.32),('10318','2013-07-01','13:30:00',9.31),('10318','2013-07-01','13:35:00',9.41),('10318','2013-07-01','13:40:00',9.25),('10318','2013-07-01','13:45:00',9.13),('10318','2013-07-01','13:50:00',9.01),('10318','2013-07-01','13:55:00',9.02),('10318','2013-07-01','14:00:00',8.91),('10318','2013-07-01','14:05:00',8.93),('10318','2013-07-01','14:10:00',8.88),('10318','2013-07-01','14:15:00',8.87),('10318','2013-07-01','14:20:00',8.84),('10318','2013-07-01','14:25:00',8.71),('10318','2013-07-01','14:30:00',8.56),('10318','2013-07-01','14:35:00',8.52),('10318','2013-07-01','14:40:00',8.44),('10318','2013-07-01','14:45:00',8.34),('10318','2013-07-01','14:50:00',8.22),('10318','2013-07-01','14:55:00',8.12),('10318','2013-07-01','15:00:00',7.98),('10318','2013-07-01','15:05:00',7.92),('10318','2013-07-01','15:10:00',7.73),('10318','2013-07-01','15:15:00',7.83),('10318','2013-07-01','15:20:00',7.68),('10318','2013-07-01','15:25:00',7.49),('10318','2013-07-01','15:30:00',7.37),('10318','2013-07-01','15:35:00',7.21),('10318','2013-07-01','15:40:00',7.15),('10318','2013-07-01','15:45:00',7.02),('10318','2013-07-01','15:50:00',6.87),('10318','2013-07-01','15:55:00',6.76),('10318','2013-07-01','16:00:00',6.61),('10318','2013-07-01','16:05:00',6.49),('10318','2013-07-01','16:10:00',6.3),('10318','2013-07-01','16:15:00',6.22),('10318','2013-07-01','16:20:00',6.04),('10318','2013-07-01','16:25:00',5.92),('10318','2013-07-01','16:30:00',5.74),('10318','2013-07-01','16:35:00',5.59),('10318','2013-07-01','16:40:00',5.43),('10318','2013-07-01','16:45:00',5.28),('10318','2013-07-01','16:50:00',5.13),('10318','2013-07-01','16:55:00',4.98),('10318','2013-07-01','17:00:00',4.79),('10318','2013-07-01','17:05:00',4.66),('10318','2013-07-01','17:10:00',4.51),('10318','2013-07-01','17:15:00',4.3),('10318','2013-07-01','17:20:00',4.1),('10318','2013-07-01','17:25:00',3.93),('10318','2013-07-01','17:30:00',3.75),('10318','2013-07-01','17:35:00',3.58),('10318','2013-07-01','17:40:00',3.41),('10318','2013-07-01','17:45:00',3.25),('10318','2013-07-01','17:50:00',3.08),('10318','2013-07-01','17:55:00',2.9),('10318','2013-07-01','18:00:00',2.63),('10318','2013-07-01','18:05:00',2.53),('10318','2013-07-01','18:10:00',2.29),('10318','2013-07-01','18:15:00',1.97),('10318','2013-07-01','18:20:00',2.1),('10318','2013-07-01','18:25:00',2.03),('10318','2013-07-01','18:30:00',1.88),('10318','2013-07-01','18:35:00',1.7),('10318','2013-07-01','18:40:00',1.47),('10318','2013-07-01','18:45:00',1.37),('10318','2013-07-01','18:50:00',1.2),('10318','2013-07-01','18:55:00',1.09),('10318','2013-07-01','19:00:00',1.03),('10318','2014-04-05','08:30:00',1.04),('10318','2014-04-05','08:35:00',1.52),('10318','2014-04-05','08:40:00',1.81),('10318','2014-04-05','08:45:00',1.71),('10318','2014-04-05','08:50:00',1.37),('10318','2014-04-05','08:55:00',1.14),('10318','2014-04-05','09:00:00',1.34),('10318','2014-04-05','09:05:00',1.55),('10318','2014-04-05','09:10:00',1.63),('10318','2014-04-05','09:15:00',1.99),('10318','2014-04-05','09:20:00',3.1),('10318','2014-04-05','09:25:00',3.79),('10318','2014-04-05','09:30:00',4.09),('10318','2014-04-05','09:35:00',4.93),('10318','2014-04-05','09:40:00',4.85),('10318','2014-04-05','09:45:00',5.81),('10318','2014-04-05','09:50:00',7.01),('10318','2014-04-05','09:55:00',5.7),('10318','2014-04-05','10:00:00',7.49),('10318','2014-04-05','10:05:00',4.54),('10318','2014-04-05','10:10:00',4.33),('10318','2014-04-05','10:15:00',4.51),('10318','2014-04-05','10:20:00',4.54),('10318','2014-04-05','10:25:00',6.72),('10318','2014-04-05','10:30:00',6.96),('10318','2014-04-05','10:35:00',7.97),('10318','2014-04-05','10:40:00',8.03),('10318','2014-04-05','10:45:00',7.4),('10318','2014-04-05','10:50:00',7.1),('10318','2014-04-05','10:55:00',7.91),('10318','2014-04-05','11:00:00',6.51),('10318','2014-04-05','11:05:00',6.79),('10318','2014-04-05','11:10:00',7.95),('10318','2014-04-05','11:15:00',8.45),('10318','2014-04-05','11:20:00',9),('10318','2014-04-05','11:25:00',9.98),('10318','2014-04-05','11:30:00',8.53),('10318','2014-04-05','11:35:00',7.6),('10318','2014-04-05','11:40:00',6.22),('10318','2014-04-05','11:45:00',5.23),('10318','2014-04-05','11:50:00',6.37),('10318','2014-04-05','11:55:00',7.61),('10318','2014-04-05','12:00:00',8.66),('10318','2014-04-05','12:05:00',9.05),('10318','2014-04-05','12:10:00',9.36),('10318','2014-04-05','12:15:00',6.8),('10318','2014-04-05','12:20:00',7.73),('10318','2014-04-05','12:25:00',8.2),('10318','2014-04-05','12:30:00',7.65),('10318','2014-04-05','12:35:00',7.38),('10318','2014-04-05','12:40:00',6.74),('10318','2014-04-05','12:45:00',7.5),('10318','2014-04-05','12:50:00',6.55),('10318','2014-04-05','12:55:00',7.52),('10318','2014-04-05','13:00:00',6.85),('10318','2014-04-05','13:05:00',6.38),('10318','2014-04-05','13:10:00',6.4),('10318','2014-04-05','13:15:00',7.65),('10318','2014-04-05','13:20:00',8.66),('10318','2014-04-05','13:25:00',6.99),('10318','2014-04-05','13:30:00',5.92),('10318','2014-04-05','13:35:00',8.42),('10318','2014-04-05','13:40:00',9.19),('10318','2014-04-05','13:45:00',9.86),('10318','2014-04-05','13:50:00',9.77),('10318','2014-04-05','13:55:00',9.69),('10318','2014-04-05','14:00:00',10.47),('10318','2014-04-05','14:05:00',9.31),('10318','2014-04-05','14:10:00',3.79),('10318','2014-04-05','14:15:00',1.44),('10318','2014-04-05','14:20:00',1.39),('10318','2014-04-05','14:25:00',1.86),('10318','2014-04-05','14:30:00',2.96),('10318','2014-04-05','14:35:00',2.11),('10318','2014-04-05','14:40:00',1.63),('10318','2014-04-05','14:45:00',1.8),('10318','2014-04-05','14:50:00',1.77),('10318','2014-04-05','14:55:00',5.77),('10318','2014-04-05','15:00:00',8.94),('10318','2014-04-05','15:05:00',8.66),('10318','2014-04-05','15:10:00',8.95),('10318','2014-04-05','15:15:00',7.58),('10318','2014-04-05','15:20:00',8.63),('10318','2014-04-05','15:25:00',6.65),('10318','2014-04-05','15:30:00',3.4),('10318','2014-04-05','15:35:00',4.91),('10318','2014-04-05','15:40:00',5.13),('10318','2014-04-05','15:45:00',4.72),('10318','2014-04-05','15:50:00',2.68),('10318','2014-04-05','15:55:00',2.54),('10318','2014-04-05','16:00:00',2.67),('10318','2014-04-05','16:05:00',2.85),('10318','2014-04-05','16:10:00',2.49),('10318','2014-04-05','16:15:00',2.7),('10318','2014-04-05','16:20:00',6.76),('10318','2014-04-05','16:25:00',6),('10318','2014-04-05','16:30:00',4.69),('10318','2014-04-05','16:35:00',3.34),('10318','2014-04-05','16:40:00',3.16),('10318','2014-04-05','16:45:00',5.08),('10318','2014-04-05','16:50:00',6.03),('10318','2014-04-05','16:55:00',5.36),('10318','2014-04-05','17:00:00',3.97),('10318','2014-04-05','17:05:00',4.11),('10318','2014-04-05','17:10:00',2.25),('10318','2014-04-05','17:15:00',3.35),('10318','2014-04-05','17:20:00',3.05),('10318','2014-04-05','17:25:00',2.91),('10318','2014-04-05','17:30:00',2.29),('10318','2014-04-05','17:35:00',1.54),('10318','2014-04-05','17:40:00',1.38),('10318','2014-04-05','17:45:00',1.41),('10318','2014-04-05','17:50:00',1.44),('10318','2014-04-05','17:55:00',1.67),('10318','2014-04-05','18:00:00',1.82),('10318','2014-04-05','18:05:00',1.82),('10318','2014-04-05','18:10:00',1.84),('10318','2014-04-05','18:15:00',1.73),('10318','2014-04-05','18:20:00',1.61),('10318','2014-04-05','18:25:00',1.32),('10318','2014-04-05','18:30:00',1.12),('10318','2013-06-30','06:55:00',1.26),('10318','2013-06-30','07:00:00',1.49),('10318','2013-06-30','07:05:00',1.8),('10318','2013-06-30','07:10:00',1.88),('10318','2013-06-30','07:15:00',2.09),('10318','2013-06-30','07:20:00',2.54),('10318','2013-06-30','07:25:00',2.83),('10318','2013-06-30','07:30:00',3.01),('10318','2013-06-30','07:35:00',3.18),('10318','2013-06-30','07:40:00',3.37),('10318','2013-06-30','07:45:00',3.56),('10318','2013-06-30','07:50:00',3.75),('10318','2013-06-30','07:55:00',3.95),('10318','2013-06-30','08:00:00',4.15),('10318','2013-06-30','08:05:00',4.34),('10318','2013-06-30','08:10:00',4.54),('10318','2013-06-30','08:15:00',4.75),('10318','2013-06-30','08:20:00',4.93),('10318','2013-06-30','08:25:00',5.11),('10318','2013-06-30','08:30:00',5.28),('10318','2013-06-30','08:35:00',5.45),('10318','2013-06-30','08:40:00',5.63),('10318','2013-06-30','08:45:00',5.8),('10318','2013-06-30','08:50:00',5.97),('10318','2013-06-30','08:55:00',6.12),('10318','2013-06-30','09:00:00',6.27),('10318','2013-06-30','09:05:00',6.4),('10318','2013-06-30','09:10:00',6.54),('10318','2013-06-30','09:15:00',6.68),('10318','2013-06-30','09:20:00',6.81),('10318','2013-06-30','09:25:00',6.96),('10318','2013-06-30','09:30:00',7.1),('10318','2013-06-30','09:35:00',7.22),('10318','2013-06-30','09:40:00',7.36),('10318','2013-06-30','09:45:00',7.49),('10318','2013-06-30','09:50:00',7.58),('10318','2013-06-30','09:55:00',7.68),('10318','2013-06-30','10:00:00',7.81),('10318','2013-06-30','10:05:00',7.93),('10318','2013-06-30','10:10:00',8.06),('10318','2013-06-30','10:15:00',8.16),('10318','2013-06-30','10:20:00',8.21),('10318','2013-06-30','10:25:00',8.31),('10318','2013-06-30','10:30:00',8.38),('10318','2013-06-30','10:35:00',8.49),('10318','2013-06-30','10:40:00',8.56),('10318','2013-06-30','10:45:00',8.62),('10318','2013-06-30','10:50:00',8.64),('10318','2013-06-30','10:55:00',8.73),('10318','2013-06-30','11:00:00',8.81),('10318','2013-06-30','11:05:00',8.9),('10318','2013-06-30','11:10:00',8.94),('10318','2013-06-30','11:15:00',9),('10318','2013-06-30','11:20:00',9.07),('10318','2013-06-30','11:25:00',9.13),('10318','2013-06-30','11:30:00',9.15),('10318','2013-06-30','11:35:00',8.91),('10318','2013-06-30','11:40:00',9.25),('10318','2013-06-30','11:45:00',9.31),('10318','2013-06-30','11:50:00',9.39),('10318','2013-06-30','11:55:00',9.34),('10318','2013-06-30','12:00:00',9.35),('10318','2013-06-30','12:05:00',9.32),('10318','2013-06-30','12:10:00',9.36),('10318','2013-06-30','12:15:00',9.4),('10318','2013-06-30','12:20:00',9.42),('10318','2013-06-30','12:25:00',9.37),('10318','2013-06-30','12:30:00',9.58),('10318','2013-06-30','12:35:00',9.38),('10318','2013-06-30','12:40:00',9.35),('10318','2013-06-30','12:45:00',9.34),('10318','2013-06-30','12:50:00',9.31),('10318','2013-06-30','12:55:00',9.44),('10318','2013-06-30','13:00:00',9.55),('10318','2013-06-30','13:05:00',9.53),('10318','2013-06-30','13:10:00',9.68),('10318','2013-06-30','13:15:00',9.69),('10318','2013-06-30','13:20:00',9.41),('10318','2013-06-30','13:25:00',9.67),('10318','2013-06-30','13:30:00',9.16),('10318','2013-06-30','13:35:00',8.99),('10318','2013-06-30','13:40:00',9.56),('10318','2013-06-30','13:45:00',8.69),('10318','2013-06-30','13:50:00',9.55),('10318','2013-06-30','13:55:00',9.5),('10318','2013-06-30','14:00:00',5.59),('10318','2013-06-30','14:05:00',9.59),('10318','2013-06-30','14:10:00',9.29),('10318','2013-06-30','14:15:00',9),('10318','2013-06-30','14:20:00',8.87),('10318','2013-06-30','14:25:00',8.86),('10318','2013-06-30','14:30:00',8.73),('10318','2013-06-30','14:35:00',8.57),('10318','2013-06-30','14:40:00',8.42),('10318','2013-06-30','14:45:00',8.41),('10318','2013-06-30','14:50:00',8.18),('10318','2013-06-30','14:55:00',8.19),('10318','2013-06-30','15:00:00',8.12),('10318','2013-06-30','15:05:00',7.8),('10318','2013-06-30','15:10:00',8.05),('10318','2013-06-30','15:15:00',7.91),('10318','2013-06-30','15:20:00',7.84),('10318','2013-06-30','15:25:00',7.74),('10318','2013-06-30','15:30:00',7.63),('10318','2013-06-30','15:35:00',7.53),('10318','2013-06-30','15:40:00',7.44),('10318','2013-06-30','15:45:00',7.2),('10318','2013-06-30','15:50:00',7.16),('10318','2013-06-30','15:55:00',7.05),('10318','2013-06-30','16:00:00',6.9),('10318','2013-06-30','16:05:00',6.81),('10318','2013-06-30','16:10:00',6.7),('10318','2013-06-30','16:15:00',6.6),('10318','2013-06-30','16:20:00',6.52),('10318','2013-06-30','16:25:00',6.41),('10318','2013-06-30','16:30:00',5.99),('10318','2013-06-30','16:35:00',5.93),('10318','2013-06-30','16:40:00',5.69),('10318','2013-06-30','16:45:00',5.44),('10318','2013-06-30','16:50:00',5.21),('10318','2013-06-30','16:55:00',5.13),('10318','2013-06-30','17:00:00',4.93),('10318','2013-06-30','17:05:00',4.74),('10318','2013-06-30','17:10:00',4.58),('10318','2013-06-30','17:15:00',4.43),('10318','2013-06-30','17:20:00',4.21),('10318','2013-06-30','17:25:00',4.05),('10318','2013-06-30','17:30:00',3.87),('10318','2013-06-30','17:35:00',3.68),('10318','2013-06-30','17:40:00',3.54),('10318','2013-06-30','17:45:00',3.37),('10318','2013-06-30','17:50:00',3.19),('10318','2013-06-30','17:55:00',2.93),('10318','2013-06-30','18:00:00',2.8),('10318','2013-06-30','18:05:00',2.6),('10318','2013-06-30','18:10:00',2.49),('10318','2013-06-30','18:15:00',2.32),('10318','2013-06-30','18:20:00',2.14),('10318','2013-06-30','18:25:00',2.01),('10318','2013-06-30','18:30:00',1.86),('10318','2013-06-30','18:35:00',1.71),('10318','2013-06-30','18:40:00',1.57),('10318','2013-06-30','18:45:00',1.44),('10318','2013-06-30','18:50:00',1.34),('10318','2013-06-30','18:55:00',1.21),('10318','2013-06-30','19:00:00',1.1),('10318','2013-06-29','07:15:00',1.16),('10318','2013-06-29','07:20:00',1.04),('10318','2013-06-29','07:25:00',2.18),('10318','2013-06-29','07:30:00',3.29),('10318','2013-06-29','07:35:00',4.02),('10318','2013-06-29','07:40:00',4.24),('10318','2013-06-29','07:45:00',4.31),('10318','2013-06-29','07:50:00',4.64),('10318','2013-06-29','07:55:00',5.07),('10318','2013-06-29','08:00:00',4.16),('10318','2013-06-29','08:05:00',3.61),('10318','2013-06-29','08:10:00',4.52),('10318','2013-06-29','08:15:00',3.24),('10318','2013-06-29','08:20:00',2.14),('10318','2013-06-29','08:25:00',4.83),('10318','2013-06-29','08:30:00',5.13),('10318','2013-06-29','08:35:00',5.56),('10318','2013-06-29','08:40:00',5.8),('10318','2013-06-29','08:45:00',5.83),('10318','2013-06-29','08:50:00',5.96),('10318','2013-06-29','08:55:00',6.11),('10318','2013-06-29','09:00:00',6.26),('10318','2013-06-29','09:05:00',6.37),('10318','2013-06-29','09:10:00',6.49),('10318','2013-06-29','09:15:00',6.54),('10318','2013-06-29','09:20:00',6.78),('10318','2013-06-29','09:25:00',6.9),('10318','2013-06-29','09:30:00',7.03),('10318','2013-06-29','09:35:00',7.16),('10318','2013-06-29','09:40:00',7.34),('10318','2013-06-29','09:45:00',7.4),('10318','2013-06-29','09:50:00',7.57),('10318','2013-06-29','09:55:00',7.68),('10318','2013-06-29','10:00:00',7.74),('10318','2013-06-29','10:05:00',7.86),('10318','2013-06-29','10:10:00',7.92),('10318','2013-06-29','10:15:00',8.05),('10318','2013-06-29','10:20:00',8.17),('10318','2013-06-29','10:25:00',8.25),('10318','2013-06-29','10:30:00',8.39),('10318','2013-06-29','10:35:00',8.48),('10318','2013-06-29','10:40:00',8.57),('10318','2013-06-29','10:45:00',8.68),('10318','2013-06-29','10:50:00',8.76),('10318','2013-06-29','10:55:00',8.93),('10318','2013-06-29','11:00:00',6.35),('10318','2013-06-29','11:05:00',5.43),('10318','2013-06-29','11:10:00',9.97),('10318','2013-06-29','11:15:00',8.89),('10318','2013-06-29','11:20:00',9.54),('10318','2013-06-29','11:25:00',9.15),('10318','2013-06-29','11:30:00',2.71),('10318','2013-06-29','11:35:00',2.43),('10318','2013-06-29','11:40:00',5.32),('10318','2013-06-29','11:45:00',6.41),('10318','2013-06-29','11:50:00',4.21),('10318','2013-06-29','11:55:00',4.85),('10318','2013-06-29','12:00:00',5.9),('10318','2013-06-29','12:05:00',10.27),('10318','2013-06-29','12:10:00',10.57),('10318','2013-06-29','12:15:00',3.61),('10318','2013-06-29','12:20:00',5.13),('10318','2013-06-29','12:25:00',3.5),('10318','2013-06-29','12:30:00',7.46),('10318','2013-06-29','12:35:00',9.36),('10318','2013-06-29','12:40:00',8.74),('10318','2013-06-29','12:45:00',4.7),('10318','2013-06-29','12:50:00',2.92),('10318','2013-06-29','12:55:00',5.59),('10318','2013-06-29','13:00:00',10.78),('10318','2013-06-29','13:05:00',7.37),('10318','2013-06-29','13:10:00',10.52),('10318','2013-06-29','13:15:00',10.3),('10318','2013-06-29','13:20:00',3.58),('10318','2013-06-29','13:25:00',3.01),('10318','2013-06-29','13:30:00',3.07),('10318','2013-06-29','13:35:00',2.98),('10318','2013-06-29','13:40:00',3.87),('10318','2013-06-29','13:45:00',5.84),('10318','2013-06-29','13:50:00',6.07),('10318','2013-06-29','13:55:00',10.48),('10318','2013-06-29','14:00:00',9.85),('10318','2013-06-29','14:05:00',9.85),('10318','2013-06-29','14:10:00',9.93),('10318','2013-06-29','14:15:00',4.23),('10318','2013-06-29','14:20:00',8.12),('10318','2013-06-29','14:25:00',9.92),('10318','2013-06-29','14:30:00',9.48),('10318','2013-06-29','14:35:00',9.39),('10318','2013-06-29','14:40:00',9.44),('10318','2013-06-29','14:45:00',9.51),('10318','2013-06-29','14:50:00',9.75),('10318','2013-06-29','14:55:00',8.29),('10318','2013-06-29','15:00:00',6.22),('10318','2013-06-29','15:05:00',5.73),('10318','2013-06-29','15:10:00',4.99),('10318','2013-06-29','15:15:00',7.37),('10318','2013-06-29','15:20:00',6.61),('10318','2013-06-29','15:25:00',3.54),('10318','2013-06-29','15:30:00',2.32),('10318','2013-06-29','15:35:00',1.34),('10318','2013-06-29','15:40:00',1.18),('10318','2013-06-29','15:45:00',1.15),('10318','2013-06-29','16:15:00',1.01),('10318','2013-06-29','16:20:00',1.44),('10318','2013-06-29','16:25:00',1.7),('10318','2013-06-29','16:30:00',1.99),('10318','2013-06-29','16:35:00',2.48),('10318','2013-06-29','16:40:00',3.32),('10318','2013-06-29','16:45:00',3.88),('10318','2013-06-29','16:50:00',3.2),('10318','2013-06-29','16:55:00',2.34),('10318','2013-06-29','17:00:00',2.94),('10318','2013-06-29','17:05:00',2.33),('10318','2013-06-29','17:10:00',2.25),('10318','2013-06-29','17:15:00',2.34),('10318','2013-06-29','17:20:00',3.5),('10318','2013-06-29','17:25:00',4.89),('10318','2013-06-29','17:30:00',4.63),('10318','2013-06-29','17:35:00',1.98),('10318','2013-06-29','17:40:00',2.27),('10318','2013-06-29','17:45:00',3.55),('10318','2013-06-29','17:50:00',2.03),('10318','2013-06-29','17:55:00',2.33),('10318','2013-06-29','18:00:00',1.83),('10318','2013-06-29','18:20:00',2.02),('10318','2013-06-29','18:25:00',1.78),('10318','2013-06-29','18:30:00',1.56),('10318','2013-06-29','18:35:00',1.29),('10318','2013-06-29','18:40:00',1.49),('10318','2013-06-29','19:05:00',1.2),('10318','2013-06-29','19:10:00',1.15),('10318','2013-06-28','06:55:00',1.18),('10318','2013-06-28','07:10:00',1.77),('10318','2013-06-28','07:15:00',2.19),('10318','2013-06-28','07:20:00',2.58),('10318','2013-06-28','07:25:00',2.83),('10318','2013-06-28','07:30:00',2.99),('10318','2013-06-28','07:35:00',2.99),('10318','2013-06-28','07:40:00',3.39),('10318','2013-06-28','07:45:00',3.7),('10318','2013-06-28','07:50:00',3.84),('10318','2013-06-28','07:55:00',3.94),('10318','2013-06-28','08:00:00',3.94),('10318','2013-06-28','08:05:00',4.22),('10318','2013-06-28','08:10:00',4.12),('10318','2013-06-28','08:15:00',4.59),('10318','2013-06-28','08:20:00',4.39),('10318','2013-06-28','08:25:00',4.88),('10318','2013-06-28','08:30:00',5.14),('10318','2013-06-28','08:35:00',5.37),('10318','2013-06-28','08:40:00',5.44),('10318','2013-06-28','08:45:00',5.54),('10318','2013-06-28','08:50:00',5.66),('10318','2013-06-28','08:55:00',5.25),('10318','2013-06-28','09:00:00',5.72),('10318','2013-06-28','09:05:00',5.23),('10318','2013-06-28','09:10:00',6.48),('10318','2013-06-28','09:15:00',6.77),('10318','2013-06-28','09:20:00',6.61),('10318','2013-06-28','09:25:00',6.09),('10318','2013-06-28','09:30:00',7.14),('10318','2013-06-28','09:35:00',5.95),('10318','2013-06-28','09:40:00',2.95),('10318','2013-06-28','09:45:00',8.05),('10318','2013-06-28','09:50:00',8.92),('10318','2013-06-28','09:55:00',8.01),('10318','2013-06-28','10:00:00',5.02),('10318','2013-06-28','10:05:00',8.73),('10318','2013-06-28','10:10:00',8.84),('10318','2013-06-28','10:15:00',9.03),('10318','2013-06-28','10:20:00',4.4),('10318','2013-06-28','10:25:00',2.64),('10318','2013-06-28','10:30:00',2.66),('10318','2013-06-28','10:35:00',2.36),('10318','2013-06-28','10:40:00',4.25),('10318','2013-06-28','10:45:00',4.08),('10318','2013-06-28','10:50:00',7.9),('10318','2013-06-28','10:55:00',3.79),('10318','2013-06-28','11:00:00',3.81),('10318','2013-06-28','11:05:00',6.04),('10318','2013-06-28','11:10:00',7.17),('10318','2013-06-28','11:15:00',6.95),('10318','2013-06-28','11:20:00',6.55),('10318','2013-06-28','11:25:00',4.56),('10318','2013-06-28','11:30:00',9.84),('10318','2013-06-28','11:35:00',6.84),('10318','2013-06-28','11:40:00',6.66),('10318','2013-06-28','11:45:00',10.68),('10318','2013-06-28','11:50:00',9.25),('10318','2013-06-28','11:55:00',8.66),('10318','2013-06-28','12:00:00',9.37),('10318','2013-06-28','12:05:00',8.28),('10318','2013-06-28','12:10:00',8.61),('10318','2013-06-28','12:15:00',7.16),('10318','2013-06-28','12:20:00',9.99),('10318','2013-06-28','12:25:00',9.46),('10318','2013-06-28','12:30:00',9.72),('10318','2013-06-28','12:35:00',9.88),('10318','2013-06-28','12:40:00',7.9),('10318','2013-06-28','12:45:00',10.08),('10318','2013-06-28','12:50:00',9.62),('10318','2013-06-28','12:55:00',9.9),('10318','2013-06-28','13:00:00',9.83),('10318','2013-06-28','13:05:00',7.26),('10318','2013-06-28','13:10:00',10.15),('10318','2013-06-28','13:15:00',9.29),('10318','2013-06-28','13:20:00',9.93),('10318','2013-06-28','13:25:00',8.33),('10318','2013-06-28','13:30:00',7.8),('10318','2013-06-28','13:35:00',9.72),('10318','2013-06-28','13:40:00',9.67),('10318','2013-06-28','13:45:00',6.42),('10318','2013-06-28','13:50:00',6.3),('10318','2013-06-28','13:55:00',8.18),('10318','2013-06-28','14:00:00',7.43),('10318','2013-06-28','14:05:00',8.09),('10318','2013-06-28','14:10:00',7.24),('10318','2013-06-28','14:15:00',7.53),('10318','2013-06-28','14:20:00',9.12),('10318','2013-06-28','14:25:00',8.45),('10318','2013-06-28','14:30:00',9.13),('10318','2013-06-28','14:35:00',9.44),('10318','2013-06-28','14:40:00',9.21),('10318','2013-06-28','14:45:00',6.9),('10318','2013-06-28','14:50:00',8.24),('10318','2013-06-28','14:55:00',4.99),('10318','2013-06-28','15:00:00',8),('10318','2013-06-28','15:05:00',8.68),('10318','2013-06-28','15:10:00',5.4),('10318','2013-06-28','15:15:00',5.25),('10318','2013-06-28','15:20:00',4.29),('10318','2013-06-28','15:25:00',8.94),('10318','2013-06-28','15:30:00',4.16),('10318','2013-06-28','15:35:00',6.25),('10318','2013-06-28','15:40:00',7.03),('10318','2013-06-28','15:45:00',8.81),('10318','2013-06-28','15:50:00',7.99),('10318','2013-06-28','15:55:00',7.8),('10318','2013-06-28','16:00:00',4.59),('10318','2013-06-28','16:05:00',4.06),('10318','2013-06-28','16:10:00',7.09),('10318','2013-06-28','16:15:00',2.34),('10318','2013-06-28','16:20:00',4.81),('10318','2013-06-28','16:25:00',4.98),('10318','2013-06-28','16:30:00',2.95),('10318','2013-06-28','16:35:00',3.88),('10318','2013-06-28','16:40:00',5.51),('10318','2013-06-28','16:45:00',2.9),('10318','2013-06-28','16:50:00',3.01),('10318','2013-06-28','16:55:00',3.5),('10318','2013-06-28','17:00:00',5.37),('10318','2013-06-28','17:05:00',4.51),('10318','2013-06-28','17:10:00',4.73),('10318','2013-06-28','17:15:00',4.67),('10318','2013-06-28','17:20:00',4.34),('10318','2013-06-28','17:25:00',3.95),('10318','2013-06-28','17:30:00',3.99),('10318','2013-06-28','17:35:00',3.8),('10318','2013-06-28','17:40:00',3.59),('10318','2013-06-28','17:45:00',3.44),('10318','2013-06-28','17:50:00',3.22),('10318','2013-06-28','17:55:00',3.07),('10318','2013-06-28','18:00:00',2.85),('10318','2013-06-28','18:05:00',2.66),('10318','2013-06-28','18:10:00',2.51),('10318','2013-06-28','18:15:00',2.34),('10318','2013-06-28','18:20:00',2.17),('10318','2013-06-28','18:25:00',2.07),('10318','2013-06-28','18:30:00',2.01),('10318','2013-06-28','18:35:00',1.89),('10318','2013-06-28','18:40:00',1.62),('10318','2013-06-28','18:45:00',1.51),('10318','2013-06-28','18:50:00',1.29),('10318','2013-06-28','18:55:00',1.15),('10318','2013-06-28','19:00:00',1.02),('10318','2013-06-27','07:15:00',1.55),('10318','2013-06-27','07:20:00',2.22),('10318','2013-06-27','07:25:00',2.51),('10318','2013-06-27','07:30:00',2.83),('10318','2013-06-27','07:35:00',3),('10318','2013-06-27','07:40:00',3.2),('10318','2013-06-27','07:45:00',3.45),('10318','2013-06-27','07:50:00',3.66),('10318','2013-06-27','07:55:00',3.9),('10318','2013-06-27','08:00:00',4.14),('10318','2013-06-27','08:05:00',4.35),('10318','2013-06-27','08:10:00',4.51),('10318','2013-06-27','08:15:00',4.7),('10318','2013-06-27','08:20:00',4.84),('10318','2013-06-27','08:25:00',5.04),('10318','2013-06-27','08:30:00',5.18),('10318','2013-06-27','08:35:00',5.28),('10318','2013-06-27','08:40:00',5.48),('10318','2013-06-27','08:45:00',5.66),('10318','2013-06-27','08:50:00',6.04),('10318','2013-06-27','08:55:00',6.53),('10318','2013-06-27','09:00:00',6.27),('10318','2013-06-27','09:05:00',5.86),('10318','2013-06-27','09:10:00',6.43),('10318','2013-06-27','09:15:00',6.68),('10318','2013-06-27','09:20:00',6.84),('10318','2013-06-27','09:25:00',7.05),('10318','2013-06-27','09:30:00',7.23),('10318','2013-06-27','09:35:00',7.35),('10318','2013-06-27','09:40:00',7.4),('10318','2013-06-27','09:45:00',7.45),('10318','2013-06-27','09:50:00',7.68),('10318','2013-06-27','09:55:00',7.2),('10318','2013-06-27','10:00:00',7.71),('10318','2013-06-27','10:05:00',8.06),('10318','2013-06-27','10:10:00',8.03),('10318','2013-06-27','10:15:00',8.15),('10318','2013-06-27','10:20:00',8.29),('10318','2013-06-27','10:25:00',8.33),('10318','2013-06-27','10:30:00',8.33),('10318','2013-06-27','10:35:00',7.3),('10318','2013-06-27','10:40:00',8.06),('10318','2013-06-27','10:45:00',9.37),('10318','2013-06-27','10:50:00',9.16),('10318','2013-06-27','10:55:00',9.19),('10318','2013-06-27','11:00:00',9.24),('10318','2013-06-27','11:05:00',5.16),('10318','2013-06-27','11:10:00',2.11),('10318','2013-06-27','11:15:00',7.48),('10318','2013-06-27','11:20:00',8.3),('10318','2013-06-27','11:25:00',4.83),('10318','2013-06-27','11:30:00',9.68),('10318','2013-06-27','11:35:00',10.14),('10318','2013-06-27','11:40:00',8.39),('10318','2013-06-27','11:45:00',4.82),('10318','2013-06-27','11:50:00',2.89),('10318','2013-06-27','11:55:00',4.82),('10318','2013-06-27','12:00:00',5.31),('10318','2013-06-27','12:05:00',3.88),('10318','2013-06-27','12:10:00',3.04),('10318','2013-06-27','12:15:00',2.73),('10318','2013-06-27','12:20:00',2.56),('10318','2013-06-27','12:25:00',2.51),('10318','2013-06-27','12:30:00',2.83),('10318','2013-06-27','12:35:00',2.39),('10318','2013-06-27','12:40:00',2.51),('10318','2013-06-27','12:45:00',2.67),('10318','2013-06-27','12:50:00',2.5),('10318','2013-06-27','12:55:00',2.78),('10318','2013-06-27','13:00:00',3.24),('10318','2013-06-27','13:05:00',7.09),('10318','2013-06-27','13:10:00',3.05),('10318','2013-06-27','13:15:00',3.1),('10318','2013-06-27','13:20:00',2.78),('10318','2013-06-27','13:25:00',2.72),('10318','2013-06-27','13:30:00',3.13),('10318','2013-06-27','13:35:00',3.58),('10318','2013-06-27','13:40:00',3.85),('10318','2013-06-27','13:45:00',7.96),('10318','2013-06-27','13:50:00',8.92),('10318','2013-06-27','13:55:00',5.84),('10318','2013-06-27','14:00:00',4.19),('10318','2013-06-27','14:05:00',5.6),('10318','2013-06-27','14:10:00',8.73),('10318','2013-06-27','14:15:00',8.28),('10318','2013-06-27','14:20:00',7.59),('10318','2013-06-27','14:25:00',8.49),('10318','2013-06-27','14:30:00',9.35),('10318','2013-06-27','14:35:00',8.95),('10318','2013-06-27','14:40:00',8.85),('10318','2013-06-27','14:45:00',8.62),('10318','2013-06-27','14:50:00',8.59),('10318','2013-06-27','14:55:00',8.26),('10318','2013-06-27','15:00:00',8.06),('10318','2013-06-27','15:05:00',7.98),('10318','2013-06-27','15:10:00',7.87),('10318','2013-06-27','15:15:00',7.78),('10318','2013-06-27','15:20:00',7.71),('10318','2013-06-27','15:25:00',7.62),('10318','2013-06-27','15:30:00',7.51),('10318','2013-06-27','15:35:00',7.37),('10318','2013-06-27','15:40:00',7.23),('10318','2013-06-27','15:45:00',7.11),('10318','2013-06-27','15:50:00',7.02),('10318','2013-06-27','15:55:00',6.77),('10318','2013-06-27','16:00:00',6.59),('10318','2013-06-27','16:05:00',6.48),('10318','2013-06-27','16:10:00',6.41),('10318','2013-06-27','16:15:00',6.33),('10318','2013-06-27','16:20:00',6.17),('10318','2013-06-27','16:25:00',6.04),('10318','2013-06-27','16:30:00',5.84),('10318','2013-06-27','16:35:00',5.3),('10318','2013-06-27','16:40:00',5.5),('10318','2013-06-27','16:45:00',5.4),('10318','2013-06-27','16:50:00',5.17),('10318','2013-06-27','16:55:00',5.04),('10318','2013-06-27','17:00:00',4.89),('10318','2013-06-27','17:05:00',4.63),('10318','2013-06-27','17:10:00',4.37),('10318','2013-06-27','17:15:00',4.28),('10318','2013-06-27','17:20:00',4.28),('10318','2013-06-27','17:25:00',4.01),('10318','2013-06-27','17:30:00',3.96),('10318','2013-06-27','17:35:00',3.8),('10318','2013-06-27','17:40:00',3.65),('10318','2013-06-27','17:45:00',3.44),('10318','2013-06-27','17:50:00',3.27),('10318','2013-06-27','17:55:00',3.03),('10318','2013-06-27','18:00:00',2.83),('10318','2013-06-27','18:05:00',2.66),('10318','2013-06-27','18:10:00',2.53),('10318','2013-06-27','18:15:00',2.35),('10318','2013-06-27','18:20:00',2.21),('10318','2013-06-27','18:25:00',2.16),('10318','2013-06-27','18:30:00',1.96),('10318','2013-06-27','18:35:00',1.75),('10318','2013-06-27','18:40:00',1.55),('10318','2013-06-27','18:45:00',1.43),('10318','2013-06-27','18:50:00',1.35),('10318','2013-06-27','18:55:00',1.23),('10318','2013-06-27','19:00:00',1.12),('10318','2013-06-26','06:50:00',1.06),('10318','2013-06-26','06:55:00',1.33),('10318','2013-06-26','07:00:00',1.5),('10318','2013-06-26','07:05:00',1.76),('10318','2013-06-26','07:10:00',1.95),('10318','2013-06-26','07:15:00',2.13),('10318','2013-06-26','07:20:00',2.53),('10318','2013-06-26','07:25:00',2.74),('10318','2013-06-26','07:30:00',2.93),('10318','2013-06-26','07:35:00',3.13),('10318','2013-06-26','07:40:00',3.33),('10318','2013-06-26','07:45:00',3.56),('10318','2013-06-26','07:50:00',3.77),('10318','2013-06-26','07:55:00',3.92),('10318','2013-06-26','08:00:00',4.09),('10318','2013-06-26','08:05:00',4.3),('10318','2013-06-26','08:10:00',4.52),('10318','2013-06-26','08:15:00',4.66),('10318','2013-06-26','08:20:00',4.81),('10318','2013-06-26','08:25:00',4.98),('10318','2013-06-26','08:30:00',5.18),('10318','2013-06-26','08:35:00',5.32),('10318','2013-06-26','08:40:00',5.47),('10318','2013-06-26','08:45:00',5.66),('10318','2013-06-26','08:50:00',5.81),('10318','2013-06-26','08:55:00',5.97),('10318','2013-06-26','09:00:00',6.1),('10318','2013-06-26','09:05:00',6.25),('10318','2013-06-26','09:10:00',6.39),('10318','2013-06-26','09:15:00',6.49),('10318','2013-06-26','09:20:00',6.66),('10318','2013-06-26','09:25:00',6.82),('10318','2013-06-26','09:30:00',6.95),('10318','2013-06-26','09:35:00',7.06),('10318','2013-06-26','09:40:00',7.16),('10318','2013-06-26','09:45:00',7.15),('10318','2013-06-26','09:50:00',7.36),('10318','2013-06-26','09:55:00',7.53),('10318','2013-06-26','10:00:00',7.61),('10318','2013-06-26','10:05:00',7.68),('10318','2013-06-26','10:10:00',7.82),('10318','2013-06-26','10:15:00',7.99),('10318','2013-06-26','10:20:00',8.03),('10318','2013-06-26','10:25:00',8.09),('10318','2013-06-26','10:30:00',8.16),('10318','2013-06-26','10:35:00',8.32),('10318','2013-06-26','10:40:00',8.4),('10318','2013-06-26','10:45:00',8.45),('10318','2013-06-26','10:50:00',8.49),('10318','2013-06-26','10:55:00',8.53),('10318','2013-06-26','11:00:00',8.63),('10318','2013-06-26','11:05:00',8.7),('10318','2013-06-26','11:10:00',8.76),('10318','2013-06-26','11:15:00',8.87),('10318','2013-06-26','11:20:00',8.99),('10318','2013-06-26','11:25:00',8.93),('10318','2013-06-26','11:30:00',8.97),('10318','2013-06-26','11:35:00',8.93),('10318','2013-06-26','11:40:00',9.14),('10318','2013-06-26','11:45:00',9.17),('10318','2013-06-26','11:50:00',9.31),('10318','2013-06-26','11:55:00',9.28),('10318','2013-06-26','12:00:00',9.26),('10318','2013-06-26','12:05:00',9.27),('10318','2013-06-26','12:10:00',9.29),('10318','2013-06-26','12:15:00',9.32),('10318','2013-06-26','12:20:00',9.32),('10318','2013-06-26','12:25:00',9.47),('10318','2013-06-26','12:30:00',9.43),('10318','2013-06-26','12:35:00',9.54),('10318','2013-06-26','12:40:00',9.53),('10318','2013-06-26','12:45:00',9.63),('10318','2013-06-26','12:50:00',9.68),('10318','2013-06-26','12:55:00',6.26),('10318','2013-06-26','13:00:00',8.58),('10318','2013-06-26','13:05:00',9.76),('10318','2013-06-26','13:10:00',8.75),('10318','2013-06-26','13:15:00',4.9),('10318','2013-06-26','13:20:00',5.19),('10318','2013-06-26','13:25:00',7.3),('10318','2013-06-26','13:30:00',8.41),('10318','2013-06-26','13:35:00',10.1),('10318','2013-06-26','13:40:00',9.9),('10318','2013-06-26','13:45:00',10.03),('10318','2013-06-26','13:50:00',9.96),('10318','2013-06-26','13:55:00',9.82),('10318','2013-06-26','14:00:00',9.36),('10318','2013-06-26','14:05:00',9.21),('10318','2013-06-26','14:10:00',9.19),('10318','2013-06-26','14:15:00',8.91),('10318','2013-06-26','14:20:00',8.6),('10318','2013-06-26','14:25:00',8.23),('10318','2013-06-26','14:30:00',8.93),('10318','2013-06-26','14:35:00',8.8),('10318','2013-06-26','14:40:00',8.72),('10318','2013-06-26','14:45:00',8.69),('10318','2013-06-26','14:50:00',8.6),('10318','2013-06-26','14:55:00',8.41),('10318','2013-06-26','15:00:00',8.2),('10318','2013-06-26','15:05:00',7.96),('10318','2013-06-26','15:10:00',7.88),('10318','2013-06-26','15:15:00',7.8),('10318','2013-06-26','15:20:00',7.61),('10318','2013-06-26','15:25:00',7.56),('10318','2013-06-26','15:30:00',7.51),('10318','2013-06-26','15:35:00',7.4),('10318','2013-06-26','15:40:00',7.33),('10318','2013-06-26','15:45:00',7.07),('10318','2013-06-26','15:50:00',6.96),('10318','2013-06-26','15:55:00',6.82),('10318','2013-06-26','16:00:00',6.68),('10318','2013-06-26','16:05:00',6.52),('10318','2013-06-26','16:10:00',6.46),('10318','2013-06-26','16:15:00',6.33),('10318','2013-06-26','16:20:00',6.21),('10318','2013-06-26','16:25:00',6.07),('10318','2013-06-26','16:30:00',5.93),('10318','2013-06-26','16:35:00',5.75),('10318','2013-06-26','16:40:00',5.59),('10318','2013-06-26','16:45:00',5.43),('10318','2013-06-26','16:50:00',5.26),('10318','2013-06-26','16:55:00',5.1),('10318','2013-06-26','17:00:00',4.93),('10318','2013-06-26','17:05:00',4.73),('10318','2013-06-26','17:10:00',4.57),('10318','2013-06-26','17:15:00',4.42),('10318','2013-06-26','17:20:00',4.23),('10318','2013-06-26','17:25:00',4.03),('10318','2013-06-26','17:30:00',3.89),('10318','2013-06-26','17:35:00',3.73),('10318','2013-06-26','17:40:00',3.51),('10318','2013-06-26','17:45:00',3.34),('10318','2013-06-26','17:50:00',3.14),('10318','2013-06-26','17:55:00',2.96),('10318','2013-06-26','18:00:00',2.8),('10318','2013-06-26','18:05:00',2.65),('10318','2013-06-26','18:10:00',3.02),('10318','2013-06-26','18:15:00',3.21),('10318','2013-06-26','18:20:00',2.38),('10318','2013-06-26','18:25:00',1.79),('10318','2013-06-26','18:30:00',1.37),('10318','2013-06-26','18:55:00',1.04),('10318','2013-06-26','19:00:00',1.05),('10318','2013-06-26','19:05:00',1.19),('10318','2013-06-26','19:10:00',1.08),('10318','2013-06-26','19:15:00',1.15),('10318','2013-06-26','19:20:00',1.04),('10318','2013-06-25','06:50:00',1.08),('10318','2013-06-25','06:55:00',1.33),('10318','2013-06-25','07:00:00',1.51),('10318','2013-06-25','07:05:00',1.73),('10318','2013-06-25','07:10:00',1.94),('10318','2013-06-25','07:15:00',2.08),('10318','2013-06-25','07:20:00',1.66),('10318','2013-06-25','07:25:00',2.41),('10318','2013-06-25','07:30:00',2.19),('10318','2013-06-25','07:35:00',1.7),('10318','2013-06-25','07:40:00',2.62),('10318','2013-06-25','07:45:00',3.58),('10318','2013-06-25','07:50:00',2.33),('10318','2013-06-25','07:55:00',4.06),('10318','2013-06-25','08:00:00',3.97),('10318','2013-06-25','08:05:00',2.93),('10318','2013-06-25','08:10:00',1.08),('10318','2013-06-25','08:15:00',1.03),('10318','2013-06-25','08:20:00',1.55),('10318','2013-06-25','08:25:00',5.35),('10318','2013-06-25','08:30:00',5.41),('10318','2013-06-25','08:35:00',5.45),('10318','2013-06-25','08:40:00',5.63),('10318','2013-06-25','08:45:00',5.78),('10318','2013-06-25','08:50:00',5.76),('10318','2013-06-25','08:55:00',6.02),('10318','2013-06-25','09:00:00',6.26),('10318','2013-06-25','09:05:00',6.36),('10318','2013-06-25','09:10:00',6.53),('10318','2013-06-25','09:15:00',6.58),('10318','2013-06-25','09:20:00',6.87),('10318','2013-06-25','09:25:00',7.2),('10318','2013-06-25','09:30:00',7.19),('10318','2013-06-25','09:35:00',7.38),('10318','2013-06-25','09:40:00',4.27),('10318','2013-06-25','09:45:00',1.8),('10318','2013-06-25','09:50:00',5.71),('10318','2013-06-25','09:55:00',8.39),('10318','2013-06-25','10:00:00',7.07),('10318','2013-06-25','10:05:00',2.43),('10318','2013-06-25','10:10:00',7.26),('10318','2013-06-25','10:15:00',6.43),('10318','2013-06-25','10:20:00',2.35),('10318','2013-06-25','10:25:00',4.28),('10318','2013-06-25','10:30:00',9.79),('10318','2013-06-25','10:35:00',9.54),('10318','2013-06-25','10:40:00',9.26),('10318','2013-06-25','10:45:00',9.26),('10318','2013-06-25','10:50:00',9.31),('10318','2013-06-25','10:55:00',9.31),('10318','2013-06-25','11:00:00',9.39),('10318','2013-06-25','11:05:00',9.79),('10318','2013-06-25','11:10:00',9.65),('10318','2013-06-25','11:15:00',9.62),('10318','2013-06-25','11:20:00',9.32),('10318','2013-06-25','11:25:00',6.5),('10318','2013-06-25','11:30:00',3.07),('10318','2013-06-25','11:35:00',4.34),('10318','2013-06-25','11:40:00',3.47),('10318','2013-06-25','11:45:00',8.9),('10318','2013-06-25','11:50:00',6.04),('10318','2013-06-25','11:55:00',4.75),('10318','2013-06-25','12:00:00',2.74),('10318','2013-06-25','12:05:00',6.53),('10318','2013-06-25','12:10:00',2.62),('10318','2013-06-25','12:15:00',2.64),('10318','2013-06-25','12:20:00',7.6),('10318','2013-06-25','12:25:00',8.96),('10318','2013-06-25','12:30:00',9.25),('10318','2013-06-25','12:35:00',9.39),('10318','2013-06-25','12:40:00',4.92),('10318','2013-06-25','12:45:00',4.17),('10318','2013-06-25','12:50:00',3.8),('10318','2013-06-25','12:55:00',8.89),('10318','2013-06-25','13:00:00',9.98),('10318','2013-06-25','13:05:00',9.94),('10318','2013-06-25','13:10:00',10.13),('10318','2013-06-25','13:15:00',10.03),('10318','2013-06-25','13:20:00',9.81),('10318','2013-06-25','13:25:00',9.69),('10318','2013-06-25','13:30:00',7.8),('10318','2013-06-25','13:35:00',9.17),('10318','2013-06-25','13:40:00',9.56),('10318','2013-06-25','13:45:00',9.37),('10318','2013-06-25','13:50:00',9.12),('10318','2013-06-25','13:55:00',9.19),('10318','2013-06-25','14:00:00',9.15),('10318','2013-06-25','14:05:00',9.14),('10318','2013-06-25','14:10:00',9.01),('10318','2013-06-25','14:15:00',9.01),('10318','2013-06-25','14:20:00',8.88),('10318','2013-06-25','14:25:00',8.83),('10318','2013-06-25','14:30:00',8.77),('10318','2013-06-25','14:35:00',8.65),('10318','2013-06-25','14:40:00',8.56),('10318','2013-06-25','14:45:00',8.51),('10318','2013-06-25','14:50:00',8.43),('10318','2013-06-25','14:55:00',8.3),('10318','2013-06-25','15:00:00',8.17),('10318','2013-06-25','15:05:00',7.96),('10318','2013-06-25','15:10:00',7.96),('10318','2013-06-25','15:15:00',7.89),('10318','2013-06-25','15:20:00',7.75),('10318','2013-06-25','15:25:00',7.61),('10318','2013-06-25','15:30:00',7.5),('10318','2013-06-25','15:35:00',7.38),('10318','2013-06-25','15:40:00',7.28),('10318','2013-06-25','15:45:00',7.12),('10318','2013-06-25','15:50:00',7),('10318','2013-06-25','15:55:00',6.86),('10318','2013-06-25','16:00:00',6.75),('10318','2013-06-25','16:05:00',6.58),('10318','2013-06-25','16:10:00',6.43),('10318','2013-06-25','16:15:00',6.26),('10318','2013-06-25','16:20:00',6.13),('10318','2013-06-25','16:25:00',5.96),('10318','2013-06-25','16:30:00',5.76),('10318','2013-06-25','16:35:00',5.62),('10318','2013-06-25','16:40:00',5.48),('10318','2013-06-25','16:45:00',5.31),('10318','2013-06-25','16:50:00',5.03),('10318','2013-06-25','16:55:00',5.03),('10318','2013-06-25','17:00:00',4.85),('10318','2013-06-25','17:05:00',4.69),('10318','2013-06-25','17:10:00',4.53),('10318','2013-06-25','17:15:00',4.35),('10318','2013-06-25','17:20:00',4.16),('10318','2013-06-25','17:25:00',3.98),('10318','2013-06-25','17:30:00',3.8),('10318','2013-06-25','17:35:00',3.62),('10318','2013-06-25','17:40:00',3.45),('10318','2013-06-25','17:45:00',3.28),('10318','2013-06-25','17:50:00',3.08),('10318','2013-06-25','17:55:00',2.92),('10318','2013-06-25','18:00:00',2.73),('10318','2013-06-25','18:05:00',2.55),('10318','2013-06-25','18:10:00',2.37),('10318','2013-06-25','18:15:00',2.21),('10318','2013-06-25','18:20:00',2.05),('10318','2013-06-25','18:25:00',1.9),('10318','2013-06-25','18:30:00',1.77),('10318','2013-06-25','18:35:00',1.59),('10318','2013-06-25','18:40:00',1.47),('10318','2013-06-25','18:45:00',1.34),('10318','2013-06-25','18:50:00',1.21),('10318','2013-06-25','18:55:00',1.1),('10318','2013-06-24','07:05:00',1.46),('10318','2013-06-24','07:10:00',2.3),('10318','2013-06-24','07:15:00',1.35),('10318','2013-06-24','07:20:00',1.47),('10318','2013-06-24','07:25:00',1.11),('10318','2013-06-24','07:30:00',1.2),('10318','2013-06-24','07:35:00',1.17),('10318','2013-06-24','07:45:00',1.21),('10318','2013-06-24','08:20:00',1.61),('10318','2013-06-24','08:25:00',5.42),('10318','2013-06-24','08:30:00',5.48),('10318','2013-06-24','08:35:00',5.05),('10318','2013-06-24','08:40:00',3.63),('10318','2013-06-24','08:45:00',5.97),('10318','2013-06-24','08:50:00',6.17),('10318','2013-06-24','08:55:00',6.67),('10318','2013-06-24','09:00:00',6.98),('10318','2013-06-24','09:05:00',6.06),('10318','2013-06-24','09:10:00',5.04),('10318','2013-06-24','09:15:00',7.65),('10318','2013-06-24','09:20:00',8.14),('10318','2013-06-24','09:25:00',2.92),('10318','2013-06-24','09:30:00',2.25),('10318','2013-06-24','09:35:00',7.21),('10318','2013-06-24','09:40:00',8.37),('10318','2013-06-24','09:45:00',3.91),('10318','2013-06-24','09:50:00',8.37),('10318','2013-06-24','09:55:00',7.62),('10318','2013-06-24','10:00:00',8.12),('10318','2013-06-24','10:05:00',6.5),('10318','2013-06-24','10:10:00',5.16),('10318','2013-06-24','10:15:00',9.13),('10318','2013-06-24','10:20:00',9.67),('10318','2013-06-24','10:25:00',4.75),('10318','2013-06-24','10:30:00',5.1),('10318','2013-06-24','10:35:00',9.04),('10318','2013-06-24','10:40:00',8.53),('10318','2013-06-24','10:45:00',6.74),('10318','2013-06-24','10:50:00',4.8),('10318','2013-06-24','10:55:00',7.72),('10318','2013-06-24','11:00:00',8.04),('10318','2013-06-24','11:05:00',4.86),('10318','2013-06-24','11:10:00',7.07),('10318','2013-06-24','11:15:00',5.23),('10318','2013-06-24','11:20:00',3.27),('10318','2013-06-24','11:25:00',2.92),('10318','2013-06-24','11:30:00',2.65),('10318','2013-06-24','11:35:00',3.18),('10318','2013-06-24','11:40:00',3.99),('10318','2013-06-24','11:45:00',4.61),('10318','2013-06-24','11:50:00',4.06),('10318','2013-06-24','11:55:00',3.56),('10318','2013-06-24','12:00:00',4.37),('10318','2013-06-24','12:05:00',9.26),('10318','2013-06-24','12:10:00',8.26),('10318','2013-06-24','12:15:00',5.9),('10318','2013-06-24','12:20:00',6.02),('10318','2013-06-24','12:25:00',4.94),('10318','2013-06-24','12:30:00',8.38),('10318','2013-06-24','12:35:00',9.55),('10318','2013-06-24','12:40:00',7.44),('10318','2013-06-24','12:45:00',10.92),('10318','2013-06-24','12:50:00',6.26),('10318','2013-06-24','12:55:00',9.85),('10318','2013-06-24','13:00:00',7.57),('10318','2013-06-24','13:05:00',6.29),('10318','2013-06-24','13:10:00',6.73),('10318','2013-06-24','13:15:00',9.72),('10318','2013-06-24','13:20:00',6.76),('10318','2013-06-24','13:25:00',10.33),('10318','2013-06-24','13:30:00',10.12),('10318','2013-06-24','13:35:00',10.35),('10318','2013-06-24','13:40:00',9.73),('10318','2013-06-24','13:45:00',5.99),('10318','2013-06-24','13:50:00',9),('10318','2013-06-24','13:55:00',9.74),('10318','2013-06-24','14:00:00',9.55),('10318','2013-06-24','14:05:00',9.46),('10318','2013-06-24','14:10:00',9.38),('10318','2013-06-24','14:15:00',9.41),('10318','2013-06-24','14:20:00',9.28),('10318','2013-06-24','14:25:00',9.24),('10318','2013-06-24','14:30:00',8.9),('10318','2013-06-24','14:35:00',8.29),('10318','2013-06-24','14:40:00',7.91),('10318','2013-06-24','14:45:00',9),('10318','2013-06-24','14:50:00',9.29),('10318','2013-06-24','14:55:00',9.35),('10318','2013-06-24','15:00:00',4.85),('10318','2013-06-24','15:05:00',5.38),('10318','2013-06-24','15:10:00',7.2),('10318','2013-06-24','15:15:00',5.79),('10318','2013-06-24','15:20:00',4.5),('10318','2013-06-24','15:25:00',7.62),('10318','2013-06-24','15:30:00',8.55),('10318','2013-06-24','15:35:00',3.98),('10318','2013-06-24','15:40:00',4.61),('10318','2013-06-24','15:45:00',8.92),('10318','2013-06-24','15:50:00',3.15),('10318','2013-06-24','15:55:00',2.6),('10318','2013-06-24','16:00:00',3.51),('10318','2013-06-24','16:05:00',6.9),('10318','2013-06-24','16:10:00',3.75),('10318','2013-06-24','16:15:00',5.15),('10318','2013-06-24','16:20:00',6.27),('10318','2013-06-24','16:25:00',7.71),('10318','2013-06-24','16:30:00',6.07),('10318','2013-06-24','16:35:00',6.39),('10318','2013-06-24','16:40:00',5.59),('10318','2013-06-24','16:45:00',2.64),('10318','2013-06-24','16:50:00',3.4),('10318','2013-06-24','16:55:00',3.53),('10318','2013-06-24','17:00:00',4.18),('10318','2013-06-24','17:05:00',2.32),('10318','2013-06-24','17:10:00',3.65),('10318','2013-06-24','17:15:00',1.93),('10318','2013-06-24','17:20:00',2.15),('10318','2013-06-24','17:25:00',2.17),('10318','2013-06-24','17:30:00',1.88),('10318','2013-06-24','17:35:00',2.05),('10318','2013-06-24','17:40:00',3.55),('10318','2013-06-24','17:45:00',3.12),('10318','2013-06-24','17:50:00',3.08),('10318','2013-06-24','17:55:00',2.13),('10318','2013-06-24','18:00:00',2.56),('10318','2013-06-24','18:05:00',2.66),('10318','2013-06-24','18:10:00',2.8),('10318','2013-06-24','18:15:00',2.51),('10318','2013-06-24','18:20:00',2.35),('10318','2013-06-24','18:25:00',2.08),('10318','2013-06-24','18:30:00',2.2),('10318','2013-06-24','18:35:00',1.89),('10318','2013-06-24','18:40:00',1.89),('10318','2013-06-24','18:45:00',1.56),('10318','2013-06-24','19:00:00',1.1),('10318','2013-06-24','19:05:00',1.02),('10318','2014-04-04','08:35:00',1.17),('10318','2014-04-04','08:40:00',1.64),('10318','2014-04-04','08:45:00',2),('10318','2014-04-04','08:50:00',2.37),('10318','2014-04-04','08:55:00',2.56),('10318','2014-04-04','09:00:00',3.21),('10318','2014-04-04','09:05:00',4.39),('10318','2014-04-04','09:10:00',4.92),('10318','2014-04-04','09:15:00',4.01),('10318','2014-04-04','09:20:00',2.23),('10318','2014-04-04','09:25:00',1.65),('10318','2014-04-04','09:30:00',1.71),('10318','2014-04-04','09:35:00',1.8),('10318','2014-04-04','09:40:00',1.7),('10318','2014-04-04','09:45:00',1.3),('10318','2014-04-04','09:50:00',1.06),('10318','2014-04-04','10:15:00',1.01),('10318','2014-04-04','10:40:00',1.08),('10318','2014-04-04','10:50:00',1.08),('10318','2014-04-04','10:55:00',1.23),('10318','2014-04-04','11:00:00',1.85),('10318','2014-04-04','11:05:00',1.96),('10318','2014-04-04','11:10:00',1.44),('10318','2014-04-04','11:15:00',1.73),('10318','2014-04-04','11:20:00',1.23),('10318','2014-04-04','12:15:00',1.03),('10318','2014-04-04','12:40:00',1.08),('10318','2014-04-04','12:45:00',1.35),('10318','2014-04-04','12:50:00',1.36),('10318','2014-04-04','12:55:00',1.29),('10318','2014-04-04','13:00:00',1.22),('10318','2014-04-04','13:05:00',2.32),('10318','2014-04-04','13:10:00',2.38),('10318','2014-04-04','13:15:00',2.97),('10318','2014-04-04','13:20:00',4.72),('10318','2014-04-04','13:25:00',4.41),('10318','2014-04-04','13:30:00',4.23),('10318','2014-04-04','13:35:00',7.65),('10318','2014-04-04','13:40:00',8.87),('10318','2014-04-04','13:45:00',8.75),('10318','2014-04-04','13:50:00',9.05),('10318','2014-04-04','13:55:00',8.3),('10318','2014-04-04','14:00:00',9.92),('10318','2014-04-04','14:05:00',9.9),('10318','2014-04-04','14:10:00',8.88),('10318','2014-04-04','14:15:00',9.08),('10318','2014-04-04','14:20:00',4.84),('10318','2014-04-04','14:25:00',6.89),('10318','2014-04-04','14:30:00',3.58),('10318','2014-04-04','14:35:00',7.88),('10318','2014-04-04','14:40:00',3.22),('10318','2014-04-04','14:45:00',6.6),('10318','2014-04-04','14:50:00',7.52),('10318','2014-04-04','14:55:00',6.1),('10318','2014-04-04','15:00:00',8.02),('10318','2014-04-04','15:05:00',4.94),('10318','2014-04-04','15:10:00',6.64),('10318','2014-04-04','15:15:00',6.49),('10318','2014-04-04','15:20:00',7.94),('10318','2014-04-04','15:25:00',3.59),('10318','2014-04-04','15:30:00',2.82),('10318','2014-04-04','15:35:00',3.01),('10318','2014-04-04','15:40:00',3.22),('10318','2014-04-04','15:45:00',3.97),('10318','2014-04-04','15:50:00',4.16),('10318','2014-04-04','15:55:00',6.52),('10318','2014-04-04','16:00:00',8.21),('10318','2014-04-04','16:05:00',5.1),('10318','2014-04-04','16:10:00',4.68),('10318','2014-04-04','16:15:00',3.69),('10318','2014-04-04','16:20:00',3.69),('10318','2014-04-04','16:25:00',3.22),('10318','2014-04-04','16:30:00',3.71),('10318','2014-04-04','16:35:00',5),('10318','2014-04-04','16:40:00',4.01),('10318','2014-04-04','16:45:00',5.2),('10318','2014-04-04','16:50:00',6.45),('10318','2014-04-04','16:55:00',5.64),('10318','2014-04-04','17:00:00',5.29),('10318','2014-04-04','17:05:00',3.35),('10318','2014-04-04','17:10:00',3.25),('10318','2014-04-04','17:15:00',2.38),('10318','2014-04-04','17:20:00',2.75),('10318','2014-04-04','17:25:00',4.16),('10318','2014-04-04','17:30:00',3.72),('10318','2014-04-04','17:35:00',2.46),('10318','2014-04-04','17:40:00',2.98),('10318','2014-04-04','17:45:00',1.6),('10318','2014-04-04','17:50:00',2.68),('10318','2014-04-04','17:55:00',2.37),('10318','2014-04-04','18:00:00',2),('10318','2014-04-04','18:05:00',1.21),('10318','2014-04-04','18:10:00',1.29),('10318','2014-04-04','18:15:00',1.41),('10318','2014-04-04','18:20:00',1.25),('10318','2014-04-04','18:25:00',1.18),('10318','2014-04-04','18:30:00',1.11),('10318','2013-06-20','06:50:00',1.03),('10318','2013-06-20','06:55:00',1.24),('10318','2013-06-20','07:00:00',1.42),('10318','2013-06-20','07:05:00',1.6),('10318','2013-06-20','07:10:00',1.8),('10318','2013-06-20','07:15:00',2),('10318','2013-06-20','07:20:00',2.28),('10318','2013-06-20','07:25:00',2.48),('10318','2013-06-20','07:30:00',2.67),('10318','2013-06-20','07:35:00',2.86),('10318','2013-06-20','07:40:00',3.04),('10318','2013-06-20','07:45:00',3.19),('10318','2013-06-20','07:50:00',3.38),('10318','2013-06-20','07:55:00',3.57),('10318','2013-06-20','08:00:00',3.72),('10318','2013-06-20','08:05:00',3.9),('10318','2013-06-20','08:10:00',4.11),('10318','2013-06-20','08:15:00',4.31),('10318','2013-06-20','08:20:00',4.48),('10318','2013-06-20','08:25:00',4.64),('10318','2013-06-20','08:30:00',4.76),('10318','2013-06-20','08:35:00',5.01),('10318','2013-06-20','08:40:00',5.2),('10318','2013-06-20','08:45:00',5.36),('10318','2013-06-20','08:50:00',5.48),('10318','2013-06-20','08:55:00',5.66),('10318','2013-06-20','09:00:00',5.8),('10318','2013-06-20','09:05:00',5.95),('10318','2013-06-20','09:10:00',6.09),('10318','2013-06-20','09:15:00',6.2),('10318','2013-06-20','09:20:00',6.32),('10318','2013-06-20','09:25:00',6.47),('10318','2013-06-20','09:30:00',6.56),('10318','2013-06-20','09:35:00',6.69),('10318','2013-06-20','09:40:00',6.87),('10318','2013-06-20','09:45:00',6.97),('10318','2013-06-20','09:50:00',7.08),('10318','2013-06-20','09:55:00',7.19),('10318','2013-06-20','10:00:00',7.27),('10318','2013-06-20','10:05:00',7.39),('10318','2013-06-20','10:10:00',7.47),('10318','2013-06-20','10:15:00',7.41),('10318','2013-06-20','10:20:00',7.63),('10318','2013-06-20','10:25:00',7.78),('10318','2013-06-20','10:30:00',7.82),('10318','2013-06-20','10:35:00',7.84),('10318','2013-06-20','10:40:00',7.99),('10318','2013-06-20','10:45:00',8.02),('10318','2013-06-20','10:50:00',8.08),('10318','2013-06-20','10:55:00',8.08),('10318','2013-06-20','11:00:00',8.16),('10318','2013-06-20','11:05:00',8.32),('10318','2013-06-20','11:10:00',8.33),('10318','2013-06-20','11:15:00',8.27),('10318','2013-06-20','11:20:00',8.3),('10318','2013-06-20','11:25:00',8.36),('10318','2013-06-20','11:30:00',8.31),('10318','2013-06-20','11:35:00',8.38),('10318','2013-06-20','11:40:00',8.38),('10318','2013-06-20','11:45:00',8.33),('10318','2013-06-20','11:50:00',8.28),('10318','2013-06-20','11:55:00',8.26),('10318','2013-06-20','12:00:00',8.32),('10318','2013-06-20','12:05:00',8.25),('10318','2013-06-20','12:10:00',8.33),('10318','2013-06-20','12:15:00',8.46),('10318','2013-06-20','12:20:00',8.4),('10318','2013-06-20','12:25:00',8.35),('10318','2013-06-20','12:30:00',8.36),('10318','2013-06-20','12:35:00',8.22),('10318','2013-06-20','12:40:00',8.47),('10318','2013-06-20','12:45:00',8.46),('10318','2013-06-20','12:50:00',8.5),('10318','2013-06-20','12:55:00',8.46),('10318','2013-06-20','13:00:00',8.49),('10318','2013-06-20','13:05:00',8.81),('10318','2013-06-20','13:10:00',8.62),('10318','2013-06-20','13:15:00',8.46),('10318','2013-06-20','13:20:00',8.75),('10318','2013-06-20','13:25:00',8.73),('10318','2013-06-20','13:30:00',8.67),('10318','2013-06-20','13:35:00',8.69),('10318','2013-06-20','13:40:00',8.75),('10318','2013-06-20','13:45:00',8.7),('10318','2013-06-20','13:50:00',8.74),('10318','2013-06-20','13:55:00',8.75),('10318','2013-06-20','14:00:00',8.76),('10318','2013-06-20','14:05:00',8.73),('10318','2013-06-20','14:10:00',8.69),('10318','2013-06-20','14:15:00',8.66),('10318','2013-06-19','06:50:00',1.02),('10318','2013-06-19','06:55:00',1.23),('10318','2013-06-19','07:00:00',1.4),('10318','2013-06-19','07:05:00',1.59),('10318','2013-06-19','07:10:00',1.81),('10318','2013-06-19','07:15:00',1.99),('10318','2013-06-19','07:20:00',2.29),('10318','2013-06-19','07:25:00',2.48),('10318','2013-06-19','07:30:00',2.63),('10318','2013-06-19','07:35:00',2.81),('10318','2013-06-19','07:40:00',2.99),('10318','2013-06-19','07:45:00',3.17),('10318','2013-06-19','07:50:00',3.34),('10318','2013-06-19','07:55:00',3.53),('10318','2013-06-19','08:00:00',3.71),('10318','2013-06-19','08:05:00',3.88),('10318','2013-06-19','08:10:00',4.02),('10318','2013-06-19','08:15:00',4.1),('10318','2013-06-19','08:20:00',4.31),('10318','2013-06-19','08:25:00',4.5),('10318','2013-06-19','08:30:00',4.68),('10318','2013-06-19','08:35:00',4.85),('10318','2013-06-19','08:40:00',5.01),('10318','2013-06-19','08:45:00',5.15),('10318','2013-06-19','08:50:00',5.33),('10318','2013-06-19','08:55:00',5.48),('10318','2013-06-19','09:00:00',5.65),('10318','2013-06-19','09:05:00',5.8),('10318','2013-06-19','09:10:00',5.94),('10318','2013-06-19','09:15:00',6.06),('10318','2013-06-19','09:20:00',6.21),('10318','2013-06-19','09:25:00',6.35),('10318','2013-06-19','09:30:00',6.46),('10318','2013-06-19','09:35:00',6.57),('10318','2013-06-19','09:40:00',6.68),('10318','2013-06-19','09:45:00',6.78),('10318','2013-06-19','09:50:00',6.88),('10318','2013-06-19','09:55:00',7),('10318','2013-06-19','10:00:00',7),('10318','2013-06-19','10:05:00',7.18),('10318','2013-06-19','10:10:00',7.28),('10318','2013-06-19','10:15:00',7.37),('10318','2013-06-19','10:20:00',7.45),('10318','2013-06-19','10:25:00',7.54),('10318','2013-06-19','10:30:00',7.59),('10318','2013-06-19','10:35:00',7.65),('10318','2013-06-19','10:40:00',7.68),('10318','2013-06-19','10:45:00',7.76),('10318','2013-06-19','10:50:00',7.83),('10318','2013-06-19','10:55:00',7.83),('10318','2013-06-19','11:00:00',7.89),('10318','2013-06-19','11:05:00',7.92),('10318','2013-06-19','11:10:00',7.97),('10318','2013-06-19','11:15:00',8.01),('10318','2013-06-19','11:20:00',8.09),('10318','2013-06-19','11:25:00',8.13),('10318','2013-06-19','11:30:00',8.22),('10318','2013-06-19','11:35:00',8.26),('10318','2013-06-19','11:40:00',8.26),('10318','2013-06-19','11:45:00',8.15),('10318','2013-06-19','11:50:00',8.39),('10318','2013-06-19','11:55:00',8.36),('10318','2013-06-19','12:00:00',8.41),('10318','2013-06-19','12:05:00',8.44),('10318','2013-06-19','12:10:00',8.51),('10318','2013-06-19','12:15:00',8.59),('10318','2013-06-19','12:20:00',8.6),('10318','2013-06-19','12:25:00',8.55),('10318','2013-06-19','12:30:00',8.55),('10318','2013-06-19','12:35:00',8.72),('10318','2013-06-19','12:40:00',8.71),('10318','2013-06-19','12:45:00',8.63),('10318','2013-06-19','12:50:00',8.7),('10318','2013-06-19','12:55:00',8.65),('10318','2013-06-19','13:00:00',8.61),('10318','2013-06-19','13:05:00',8.54),('10318','2013-06-19','13:10:00',8.59),('10318','2013-06-19','13:15:00',8.65),('10318','2013-06-19','13:20:00',8.6),('10318','2013-06-19','13:25:00',8.6),('10318','2013-06-19','13:30:00',8.57),('10318','2013-06-19','13:35:00',8.54),('10318','2013-06-19','13:40:00',8.5),('10318','2013-06-19','13:45:00',8.44),('10318','2013-06-19','13:50:00',8.47),('10318','2013-06-19','13:55:00',8.41),('10318','2013-06-19','14:00:00',8.35),('10318','2013-06-19','14:05:00',8.31),('10318','2013-06-19','14:10:00',8.28),('10318','2013-06-19','14:15:00',8.25),('10318','2013-06-19','14:20:00',8.19),('10318','2013-06-19','14:25:00',8.14),('10318','2013-06-19','14:30:00',8.06),('10318','2013-06-19','14:35:00',8),('10318','2013-06-19','14:40:00',7.98),('10318','2013-06-19','14:45:00',7.91),('10318','2013-06-19','14:50:00',7.8),('10318','2013-06-19','14:55:00',7.74),('10318','2013-06-19','15:00:00',7.63),('10318','2013-06-19','15:05:00',7.56),('10318','2013-06-19','15:10:00',7.46),('10318','2013-06-19','15:15:00',7.39),('10318','2013-06-19','15:20:00',7.27),('10318','2013-06-19','15:25:00',7.17),('10318','2013-06-19','15:30:00',7.04),('10318','2013-06-19','15:35:00',6.92),('10318','2013-06-19','15:40:00',6.78),('10318','2013-06-19','15:45:00',6.64),('10318','2013-06-19','15:50:00',6.49),('10318','2013-06-19','15:55:00',6.38),('10318','2013-06-19','16:00:00',6.26),('10318','2013-06-19','16:05:00',6.15),('10318','2013-06-19','16:10:00',6.01),('10318','2013-06-19','16:15:00',5.86),('10318','2013-06-19','16:20:00',5.69),('10318','2013-06-19','16:25:00',5.56),('10318','2013-06-19','16:30:00',5.42),('10318','2013-06-19','16:35:00',5.22),('10318','2013-06-19','16:40:00',5.15),('10318','2013-06-19','16:45:00',5.01),('10318','2013-06-19','16:50:00',4.83),('10318','2013-06-19','16:55:00',4.7),('10318','2013-06-19','17:00:00',4.56),('10318','2013-06-19','17:05:00',4.39),('10318','2013-06-19','17:10:00',4.24),('10318','2013-06-19','17:15:00',4.11),('10318','2013-06-19','17:20:00',3.93),('10318','2013-06-19','17:25:00',3.76),('10318','2013-06-19','17:30:00',3.6),('10318','2013-06-19','17:35:00',3.43),('10318','2013-06-19','17:40:00',3.27),('10318','2013-06-19','17:45:00',3.09),('10318','2013-06-19','17:50:00',2.91),('10318','2013-06-19','17:55:00',2.74),('10318','2013-06-19','18:00:00',2.57),('10318','2013-06-19','18:05:00',2.41),('10318','2013-06-19','18:10:00',2.26),('10318','2013-06-19','18:15:00',2.1),('10318','2013-06-19','18:20:00',1.9),('10318','2013-06-19','18:25:00',1.78),('10318','2013-06-19','18:30:00',1.6),('10318','2013-06-19','18:35:00',1.49),('10318','2013-06-19','18:40:00',1.36),('10318','2013-06-19','18:45:00',1.23),('10318','2013-06-19','18:50:00',1.08),('10318','2013-06-18','06:55:00',1.17),('10318','2013-06-18','07:00:00',1.34),('10318','2013-06-18','07:05:00',1.52),('10318','2013-06-18','07:10:00',1.76),('10318','2013-06-18','07:15:00',1.91),('10318','2013-06-18','07:20:00',2.22),('10318','2013-06-18','07:25:00',2.39),('10318','2013-06-18','07:30:00',2.5),('10318','2013-06-18','07:35:00',2.74),('10318','2013-06-18','07:40:00',2.92),('10318','2013-06-18','07:45:00',3.1),('10318','2013-06-18','07:50:00',3.28),('10318','2013-06-18','07:55:00',3.45),('10318','2013-06-18','08:00:00',3.6),('10318','2013-06-18','08:05:00',3.8),('10318','2013-06-18','08:10:00',3.97),('10318','2013-06-18','08:15:00',4.17),('10318','2013-06-18','08:20:00',4.34),('10318','2013-06-18','08:25:00',4.49),('10318','2013-06-18','08:30:00',4.66),('10318','2013-06-18','08:35:00',4.83),('10318','2013-06-18','08:40:00',5),('10318','2013-06-18','08:45:00',5.16),('10318','2013-06-18','08:50:00',5.32),('10318','2013-06-18','08:55:00',5.47),('10318','2013-06-18','09:00:00',5.6),('10318','2013-06-18','09:05:00',5.76),('10318','2013-06-18','09:10:00',5.91),('10318','2013-06-18','09:15:00',5.98),('10318','2013-06-18','09:20:00',6.17),('10318','2013-06-18','09:25:00',6.34),('10318','2013-06-18','09:30:00',6.45),('10318','2013-06-18','09:35:00',6.55),('10318','2013-06-18','09:40:00',6.66),('10318','2013-06-18','09:45:00',6.75),('10318','2013-06-18','09:50:00',6.87),('10318','2013-06-18','09:55:00',6.97),('10318','2013-06-18','10:00:00',7.07),('10318','2013-06-18','10:05:00',7.17),('10318','2013-06-18','10:10:00',7.25),('10318','2013-06-18','10:15:00',7.31),('10318','2013-06-18','10:20:00',7.42),('10318','2013-06-18','10:25:00',7.48),('10318','2013-06-18','10:30:00',7.55),('10318','2013-06-18','10:35:00',7.65),('10318','2013-06-18','10:40:00',7.74),('10318','2013-06-18','10:45:00',7.82),('10318','2013-06-18','10:50:00',7.87),('10318','2013-06-18','10:55:00',7.85),('10318','2013-06-18','11:00:00',7.82),('10318','2013-06-18','11:05:00',8.02),('10318','2013-06-18','11:10:00',8.08),('10318','2013-06-18','11:15:00',8.18),('10318','2013-06-18','11:20:00',8.22),('10318','2013-06-18','11:25:00',8.26),('10318','2013-06-18','11:30:00',8.31),('10318','2013-06-18','11:35:00',8.26),('10318','2013-06-18','11:40:00',8.3),('10318','2013-06-18','11:45:00',8.37),('10318','2013-06-18','11:50:00',8.36),('10318','2013-06-18','11:55:00',8.45),('10318','2013-06-18','12:00:00',8.46),('10318','2013-06-18','12:05:00',8.56),('10318','2013-06-18','12:10:00',8.48),('10318','2013-06-18','12:15:00',8.39),('10318','2013-06-18','12:20:00',8.36),('10318','2013-06-18','12:25:00',8.37),('10318','2013-06-18','12:30:00',8.35),('10318','2013-06-18','12:35:00',8.36),('10318','2013-06-18','12:40:00',8.33),('10318','2013-06-18','12:45:00',7.96),('10318','2013-06-18','12:50:00',8.19),('10318','2013-06-18','12:55:00',8.38),('10318','2013-06-18','13:00:00',8.61),('10318','2013-06-18','13:05:00',8.47),('10318','2013-06-18','13:10:00',3.65),('10318','2013-06-18','13:15:00',7.91),('10318','2013-06-18','13:20:00',8.84),('10318','2013-06-18','13:25:00',8.75),('10318','2013-06-18','13:30:00',8.64),('10318','2013-06-18','13:35:00',8.54),('10318','2013-06-18','13:40:00',8.36),('10318','2013-06-18','13:45:00',8.56),('10318','2013-06-18','13:50:00',8.52),('10318','2013-06-18','13:55:00',8.51),('10318','2013-06-18','14:00:00',8.79),('10318','2013-06-18','14:05:00',8.7),('10318','2013-06-18','14:10:00',8.56),('10318','2013-06-18','14:15:00',8.56),('10318','2013-06-18','14:20:00',8.49),('10318','2013-06-18','14:25:00',8.4),('10318','2013-06-18','14:30:00',8.47),('10318','2013-06-18','14:35:00',8.31),('10318','2013-06-18','14:40:00',8.44),('10318','2013-06-18','14:45:00',8.31),('10318','2013-06-18','14:50:00',8.04),('10318','2013-06-18','14:55:00',7.87),('10318','2013-06-18','15:00:00',7.73),('10318','2013-06-18','15:05:00',7.67),('10318','2013-06-18','15:10:00',7.57),('10318','2013-06-18','15:15:00',7.42),('10318','2013-06-18','15:20:00',7.36),('10318','2013-06-18','15:25:00',7.18),('10318','2013-06-18','15:30:00',7.07),('10318','2013-06-18','15:35:00',6.96),('10318','2013-06-18','15:40:00',6.89),('10318','2013-06-18','15:45:00',6.82),('10318','2013-06-18','15:50:00',6.73),('10318','2013-06-18','15:55:00',6.63),('10318','2013-06-18','16:00:00',6.49),('10318','2013-06-18','16:05:00',6.43),('10318','2013-06-18','16:10:00',6.35),('10318','2013-06-18','16:15:00',6.26),('10318','2013-06-18','16:20:00',6.04),('10318','2013-06-18','16:25:00',5.94),('10318','2013-06-18','16:30:00',5.61),('10318','2013-06-18','16:35:00',5.26),('10318','2013-06-18','16:40:00',5.29),('10318','2013-06-18','16:45:00',5.18),('10318','2013-06-18','16:50:00',4.96),('10318','2013-06-18','16:55:00',4.85),('10318','2013-06-18','17:00:00',4.69),('10318','2013-06-18','17:05:00',4.49),('10318','2013-06-18','17:10:00',4.32),('10318','2013-06-18','17:15:00',4.15),('10318','2013-06-18','17:20:00',3.99),('10318','2013-06-18','17:25:00',3.82),('10318','2013-06-18','17:30:00',3.61),('10318','2013-06-18','17:35:00',3.38),('10318','2013-06-18','17:40:00',3.28),('10318','2013-06-18','17:45:00',3.11),('10318','2013-06-18','17:50:00',2.94),('10318','2013-06-18','17:55:00',2.77),('10318','2013-06-18','18:00:00',2.63),('10318','2013-06-18','18:05:00',2.46),('10318','2013-06-18','18:10:00',2.32),('10318','2013-06-18','18:15:00',2.17),('10318','2013-06-18','18:20:00',2.03),('10318','2013-06-18','18:25:00',1.88),('10318','2013-06-18','18:30:00',1.73),('10318','2013-06-18','18:35:00',1.59),('10318','2013-06-18','18:40:00',1.46),('10318','2013-06-18','18:45:00',1.33),('10318','2013-06-18','18:50:00',1.21),('10318','2013-06-18','18:55:00',1.1),('10318','2013-06-17','06:50:00',1.08),('10318','2013-06-17','06:55:00',1.29),('10318','2013-06-17','07:00:00',1.49),('10318','2013-06-17','07:05:00',1.67),('10318','2013-06-17','07:10:00',1.93),('10318','2013-06-17','07:15:00',2.1),('10318','2013-06-17','07:20:00',2.41),('10318','2013-06-17','07:25:00',2.61),('10318','2013-06-17','07:30:00',2.79),('10318','2013-06-17','07:35:00',2.97),('10318','2013-06-17','07:40:00',3.14),('10318','2013-06-17','07:45:00',3.33),('10318','2013-06-17','07:50:00',3.53),('10318','2013-06-17','07:55:00',3.69),('10318','2013-06-17','08:00:00',3.88),('10318','2013-06-17','08:05:00',4.06),('10318','2013-06-17','08:10:00',4.25),('10318','2013-06-17','08:15:00',4.41),('10318','2013-06-17','08:20:00',4.6),('10318','2013-06-17','08:25:00',4.76),('10318','2013-06-17','08:30:00',4.94),('10318','2013-06-17','08:35:00',5.1),('10318','2013-06-17','08:40:00',5.28),('10318','2013-06-17','08:45:00',5.43),('10318','2013-06-17','08:50:00',5.57),('10318','2013-06-17','08:55:00',5.76),('10318','2013-06-17','09:00:00',5.83),('10318','2013-06-17','09:05:00',6.06),('10318','2013-06-17','09:10:00',6.22),('10318','2013-06-17','09:15:00',6.34),('10318','2013-06-17','09:20:00',6.45),('10318','2013-06-17','09:25:00',6.59),('10318','2013-06-17','09:30:00',6.71),('10318','2013-06-17','09:35:00',6.83),('10318','2013-06-17','09:40:00',6.98),('10318','2013-06-17','09:45:00',7.11),('10318','2013-06-17','09:50:00',7.2),('10318','2013-06-17','09:55:00',7.28),('10318','2013-06-17','10:00:00',7.39),('10318','2013-06-17','10:05:00',7.48),('10318','2013-06-17','10:10:00',7.58),('10318','2013-06-17','10:15:00',7.64),('10318','2013-06-17','10:20:00',7.76),('10318','2013-06-17','10:25:00',7.85),('10318','2013-06-17','10:30:00',7.92),('10318','2013-06-17','10:35:00',7.99),('10318','2013-06-17','10:40:00',8.05),('10318','2013-06-17','10:45:00',8.12),('10318','2013-06-17','10:50:00',8.21),('10318','2013-06-17','10:55:00',8.27),('10318','2013-06-17','11:00:00',8.29),('10318','2013-06-17','11:05:00',8.35),('10318','2013-06-17','11:10:00',8.36),('10318','2013-06-17','11:15:00',8.39),('10318','2013-06-17','11:20:00',8.45),('10318','2013-06-17','11:25:00',8.49),('10318','2013-06-17','11:30:00',8.58),('10318','2013-06-17','11:35:00',8.6),('10318','2013-06-17','11:40:00',8.68),('10318','2013-06-17','11:45:00',8.68),('10318','2013-06-17','11:50:00',8.65),('10318','2013-06-17','11:55:00',8.69),('10318','2013-06-17','12:00:00',8.61),('10318','2013-06-17','12:05:00',8.72),('10318','2013-06-17','12:10:00',8.69),('10318','2013-06-17','12:15:00',8.71),('10318','2013-06-17','12:20:00',8.68),('10318','2013-06-17','12:25:00',8.55),('10318','2013-06-17','12:30:00',8.69),('10318','2013-06-17','12:35:00',8.85),('10318','2013-06-17','12:40:00',8.91),('10318','2013-06-17','12:45:00',8.91),('10318','2013-06-17','12:50:00',8.86),('10318','2013-06-17','12:55:00',8.91),('10318','2013-06-17','13:00:00',8.82),('10318','2013-06-17','13:05:00',8.77),('10318','2013-06-17','13:10:00',8.8),('10318','2013-06-17','13:15:00',8.8),('10318','2013-06-17','13:20:00',8.77),('10318','2013-06-17','13:25:00',8.7),('10318','2013-06-17','13:30:00',8.66),('10318','2013-06-17','13:35:00',8.66),('10318','2013-06-17','13:40:00',8.61),('10318','2013-06-17','13:45:00',8.49),('10318','2013-06-17','13:50:00',8.52),('10318','2013-06-17','13:55:00',8.5),('10318','2013-06-17','14:00:00',8.45),('10318','2013-06-17','14:05:00',8.4),('10318','2013-06-17','14:10:00',8.37),('10318','2013-06-17','14:15:00',8.34),('10318','2013-06-17','14:20:00',8.28),('10318','2013-06-17','14:25:00',8.24),('10318','2013-06-17','14:30:00',8.15),('10318','2013-06-17','14:35:00',8.08),('10318','2013-06-17','14:40:00',7.99),('10318','2013-06-17','14:45:00',7.9),('10318','2013-06-17','14:50:00',7.83),('10318','2013-06-17','14:55:00',7.72),('10318','2013-06-17','15:00:00',7.63),('10318','2013-06-17','15:05:00',7.56),('10318','2013-06-17','15:10:00',7.46),('10318','2013-06-17','15:15:00',7.4),('10318','2013-06-17','15:20:00',7.32),('10318','2013-06-17','15:25:00',7.24),('10318','2013-06-17','15:30:00',6.98),('10318','2013-06-17','15:35:00',6.97),('10318','2013-06-17','15:40:00',6.86),('10318','2013-06-17','15:45:00',6.71),('10318','2013-06-17','15:50:00',6.64),('10318','2013-06-17','15:55:00',6.52),('10318','2013-06-17','16:00:00',6.4),('10318','2013-06-17','16:05:00',6.27),('10318','2013-06-17','16:10:00',6.13),('10318','2013-06-17','16:15:00',6.02),('10318','2013-06-17','16:20:00',5.86),('10318','2013-06-17','16:25:00',5.7),('10318','2013-06-17','16:30:00',5.55),('10318','2013-06-17','16:35:00',5.46),('10318','2013-06-17','16:40:00',5.31),('10318','2013-06-17','16:45:00',5.16),('10318','2013-06-17','16:50:00',5.01),('10318','2013-06-17','16:55:00',4.87),('10318','2013-06-17','17:00:00',4.73),('10318','2013-06-17','17:05:00',4.57),('10318','2013-06-17','17:10:00',4.41),('10318','2013-06-17','17:15:00',4.23),('10318','2013-06-17','17:20:00',4),('10318','2013-06-17','17:25:00',3.91),('10318','2013-06-17','17:30:00',3.77),('10318','2013-06-17','17:35:00',3.62),('10318','2013-06-17','17:40:00',3.46),('10318','2013-06-17','17:45:00',3.28),('10318','2013-06-17','17:50:00',3.1),('10318','2013-06-17','17:55:00',2.92),('10318','2013-06-17','18:00:00',2.75),('10318','2013-06-17','18:05:00',2.58),('10318','2013-06-17','18:10:00',2.45),('10318','2013-06-17','18:15:00',2.3),('10318','2013-06-17','18:20:00',2.13),('10318','2013-06-17','18:25:00',1.97),('10318','2013-06-17','18:30:00',1.76),('10318','2013-06-17','18:35:00',1.72),('10318','2013-06-17','18:40:00',1.51),('10318','2013-06-17','18:45:00',1.52),('10318','2013-06-17','18:50:00',1.4),('10318','2013-06-17','18:55:00',1.29),('10318','2013-06-17','19:00:00',1.18),('10318','2013-06-17','19:05:00',1.04),('10318','2013-06-16','06:50:00',1.13),('10318','2013-06-16','06:55:00',1.33),('10318','2013-06-16','07:00:00',1.54),('10318','2013-06-16','07:05:00',1.7),('10318','2013-06-16','07:10:00',1.96),('10318','2013-06-16','07:15:00',2.17),('10318','2013-06-16','07:20:00',2.42),('10318','2013-06-16','07:25:00',2.57),('10318','2013-06-16','07:30:00',2.8),('10318','2013-06-16','07:35:00',2.99),('10318','2013-06-16','07:40:00',3.18),('10318','2013-06-16','07:45:00',3.35),('10318','2013-06-16','07:50:00',3.56),('10318','2013-06-16','07:55:00',3.75),('10318','2013-06-16','08:00:00',3.95),('10318','2013-06-16','08:05:00',4.14),('10318','2013-06-16','08:10:00',4.35),('10318','2013-06-16','08:15:00',4.52),('10318','2013-06-16','08:20:00',4.69),('10318','2013-06-16','08:25:00',4.87),('10318','2013-06-16','08:30:00',5),('10318','2013-06-16','08:35:00',5.15),('10318','2013-06-16','08:40:00',5.33),('10318','2013-06-16','08:45:00',5.51),('10318','2013-06-16','08:50:00',5.69),('10318','2013-06-16','08:55:00',5.85),('10318','2013-06-16','09:00:00',6),('10318','2013-06-16','09:05:00',6.14),('10318','2013-06-16','09:10:00',6.32),('10318','2013-06-16','09:15:00',6.45),('10318','2013-06-16','09:20:00',6.56),('10318','2013-06-16','09:25:00',6.66),('10318','2013-06-16','09:30:00',6.8),('10318','2013-06-16','09:35:00',6.94),('10318','2013-06-16','09:40:00',7.12),('10318','2013-06-16','09:45:00',7.08),('10318','2013-06-16','09:50:00',7.31),('10318','2013-06-16','09:55:00',7.42),('10318','2013-06-16','10:00:00',7.52),('10318','2013-06-16','10:05:00',7.62),('10318','2013-06-16','10:10:00',7.68),('10318','2013-06-16','10:15:00',7.79),('10318','2013-06-16','10:20:00',7.86),('10318','2013-06-16','10:25:00',7.94),('10318','2013-06-16','10:30:00',8),('10318','2013-06-16','10:35:00',8.06),('10318','2013-06-16','10:40:00',8.17),('10318','2013-06-16','10:45:00',8.22),('10318','2013-06-16','10:50:00',8.28),('10318','2013-06-16','10:55:00',8.44),('10318','2013-06-16','11:00:00',8.51),('10318','2013-06-16','11:05:00',8.56),('10318','2013-06-16','11:10:00',8.59),('10318','2013-06-16','11:15:00',8.62),('10318','2013-06-16','11:20:00',8.69),('10318','2013-06-16','11:25:00',8.68),('10318','2013-06-16','11:30:00',8.6),('10318','2013-06-16','11:35:00',8.8),('10318','2013-06-16','11:40:00',8.88),('10318','2013-06-16','11:45:00',8.9),('10318','2013-06-16','11:50:00',8.98),('10318','2013-06-16','11:55:00',9.01),('10318','2013-06-16','12:00:00',9.05),('10318','2013-06-16','12:05:00',9.04),('10318','2013-06-16','12:10:00',9.03),('10318','2013-06-16','12:15:00',9.1),('10318','2013-06-16','12:20:00',9.01),('10318','2013-06-16','12:25:00',8.93),('10318','2013-06-16','12:30:00',9.04),('10318','2013-06-16','12:35:00',9.04),('10318','2013-06-16','12:40:00',9.08),('10318','2013-06-16','12:45:00',8.96),('10318','2013-06-16','12:50:00',9.08),('10318','2013-06-16','12:55:00',9.11),('10318','2013-06-16','13:00:00',9.08),('10318','2013-06-16','13:05:00',9.15),('10318','2013-06-16','13:10:00',9.15),('10318','2013-06-16','13:15:00',8.88),('10318','2013-06-16','13:20:00',9.1),('10318','2013-06-16','13:25:00',9.06),('10318','2013-06-16','13:30:00',8.99),('10318','2013-06-16','13:35:00',9.01),('10318','2013-06-16','13:40:00',8.96),('10318','2013-06-16','13:45:00',8.94),('10318','2013-06-16','13:50:00',8.91),('10318','2013-06-16','13:55:00',8.78),('10318','2013-06-16','14:00:00',8.79),('10318','2013-06-16','14:05:00',8.77),('10318','2013-06-16','14:10:00',8.74),('10318','2013-06-16','14:15:00',8.65),('10318','2013-06-16','14:20:00',8.59),('10318','2013-06-16','14:25:00',8.55),('10318','2013-06-16','14:30:00',8.43),('10318','2013-06-16','14:35:00',8.43),('10318','2013-06-16','14:40:00',8.29),('10318','2013-06-16','14:45:00',8.19),('10318','2013-06-16','14:50:00',8.12),('10318','2013-06-16','14:55:00',8.01),('10318','2013-06-16','15:00:00',7.85),('10318','2013-06-16','15:05:00',7.84),('10318','2013-06-16','15:10:00',7.75),('10318','2013-06-16','15:15:00',7.64),('10318','2013-06-16','15:20:00',7.55),('10318','2013-06-16','15:25:00',7.46),('10318','2013-06-16','15:30:00',7.29),('10318','2013-06-16','15:35:00',7.17),('10318','2013-06-16','15:40:00',7.06),('10318','2013-06-16','15:45:00',6.93),('10318','2013-06-16','15:50:00',6.81),('10318','2013-06-16','15:55:00',6.66),('10318','2013-06-16','16:00:00',6.5),('10318','2013-06-16','16:05:00',6.38),('10318','2013-06-16','16:10:00',6.24),('10318','2013-06-16','16:15:00',6.11),('10318','2013-06-16','16:20:00',5.94),('10318','2013-06-16','16:25:00',5.8),('10318','2013-06-16','16:30:00',5.65),('10318','2013-06-16','16:35:00',5.5),('10318','2013-06-16','16:40:00',5.34),('10318','2013-06-16','16:45:00',5.1),('10318','2013-06-16','16:50:00',5.03),('10318','2013-06-16','16:55:00',4.87),('10318','2013-06-16','17:00:00',4.7),('10318','2013-06-16','17:05:00',4.54),('10318','2013-06-16','17:10:00',4.37),('10318','2013-06-16','17:15:00',4.19),('10318','2013-06-16','17:20:00',4),('10318','2013-06-16','17:25:00',3.83),('10318','2013-06-16','17:30:00',3.65),('10318','2013-06-16','17:35:00',3.48),('10318','2013-06-16','17:40:00',3.3),('10318','2013-06-16','17:45:00',3.12),('10318','2013-06-16','17:50:00',2.94),('10318','2013-06-16','17:55:00',2.75),('10318','2013-06-16','18:00:00',2.59),('10318','2013-06-16','18:05:00',2.4),('10318','2013-06-16','18:10:00',2.27),('10318','2013-06-16','18:15:00',2.09),('10318','2013-06-16','18:20:00',1.92),('10318','2013-06-16','18:25:00',1.79),('10318','2013-06-16','18:30:00',1.62),('10318','2013-06-16','18:35:00',1.46),('10318','2013-06-16','18:40:00',1.35),('10318','2013-06-16','18:45:00',1.21),('10318','2013-06-16','18:50:00',1.09),('10318','2013-06-15','06:50:00',1.09),('10318','2013-06-15','06:55:00',1.28),('10318','2013-06-15','07:00:00',1.49),('10318','2013-06-15','07:05:00',1.66),('10318','2013-06-15','07:10:00',1.86),('10318','2013-06-15','07:15:00',2.05),('10318','2013-06-15','07:20:00',2.34),('10318','2013-06-15','07:25:00',2.51),('10318','2013-06-15','07:30:00',2.63),('10318','2013-06-15','07:35:00',2.86),('10318','2013-06-15','07:40:00',3.05),('10318','2013-06-15','07:45:00',3.22),('10318','2013-06-15','07:50:00',3.42),('10318','2013-06-15','07:55:00',3.59),('10318','2013-06-15','08:00:00',3.79),('10318','2013-06-15','08:05:00',3.98),('10318','2013-06-15','08:10:00',4.18),('10318','2013-06-15','08:15:00',4.37),('10318','2013-06-15','08:20:00',4.6),('10318','2013-06-15','08:25:00',4.85),('10318','2013-06-15','08:30:00',5.05),('10318','2013-06-15','08:35:00',5.16),('10318','2013-06-15','08:40:00',5.28),('10318','2013-06-15','08:45:00',5.76),('10318','2013-06-15','08:50:00',5.82),('10318','2013-06-15','08:55:00',6.07),('10318','2013-06-15','09:00:00',6.39),('10318','2013-06-15','09:05:00',4.41),('10318','2013-06-15','09:10:00',3.16),('10318','2013-06-15','09:15:00',6.16),('10318','2013-06-15','09:20:00',5.36),('10318','2013-06-15','09:25:00',6.68),('10318','2013-06-15','09:30:00',7.01),('10318','2013-06-15','09:35:00',7.05),('10318','2013-06-15','09:40:00',7.15),('10318','2013-06-15','09:45:00',7.18),('10318','2013-06-15','09:50:00',7.31),('10318','2013-06-15','09:55:00',7.54),('10318','2013-06-15','10:00:00',7.62),('10318','2013-06-15','10:05:00',7.73),('10318','2013-06-15','10:10:00',7.81),('10318','2013-06-15','10:15:00',7.69),('10318','2013-06-15','10:20:00',7.89),('10318','2013-06-15','10:25:00',7.79),('10318','2013-06-15','10:30:00',5.35),('10318','2013-06-15','10:35:00',5.81),('10318','2013-06-15','10:40:00',6.85),('10318','2013-06-15','10:45:00',8.11),('10318','2013-06-15','10:50:00',7.76),('10318','2013-06-15','10:55:00',8.63),('10318','2013-06-15','11:00:00',8.5),('10318','2013-06-15','11:05:00',8.71),('10318','2013-06-15','11:10:00',8.79),('10318','2013-06-15','11:15:00',8.77),('10318','2013-06-15','11:20:00',8.83),('10318','2013-06-15','11:25:00',8.87),('10318','2013-06-15','11:30:00',8.84),('10318','2013-06-15','11:35:00',8.93),('10318','2013-06-15','11:40:00',9),('10318','2013-06-15','11:45:00',9.06),('10318','2013-06-15','11:50:00',9.24),('10318','2013-06-15','11:55:00',9.05),('10318','2013-06-15','12:00:00',9.24),('10318','2013-06-15','12:05:00',9.18),('10318','2013-06-15','12:10:00',9.25),('10318','2013-06-15','12:15:00',9.23),('10318','2013-06-15','12:20:00',9.28),('10318','2013-06-15','12:25:00',9.18),('10318','2013-06-15','12:30:00',9.32),('10318','2013-06-15','12:35:00',9.28),('10318','2013-06-15','12:40:00',9.28),('10318','2013-06-15','12:45:00',9.31),('10318','2013-06-15','12:50:00',9.29),('10318','2013-06-15','12:55:00',9.31),('10318','2013-06-15','13:00:00',9.27),('10318','2013-06-15','13:05:00',9.3),('10318','2013-06-15','13:10:00',9.19),('10318','2013-06-15','13:15:00',9.14),('10318','2013-06-15','13:20:00',9.11),('10318','2013-06-15','13:25:00',9.12),('10318','2013-06-15','13:30:00',9.14),('10318','2013-06-15','13:35:00',9.08),('10318','2013-06-15','13:40:00',8.91),('10318','2013-06-15','13:45:00',8.93),('10318','2013-06-15','13:50:00',8.85),('10318','2013-06-15','13:55:00',8.79),('10318','2013-06-15','14:00:00',8.75),('10318','2013-06-15','14:05:00',8.64),('10318','2013-06-15','14:10:00',8.59),('10318','2013-06-15','14:15:00',8.55),('10318','2013-06-15','14:20:00',8.56),('10318','2013-06-15','14:25:00',8.39),('10318','2013-06-15','14:30:00',8.22),('10318','2013-06-15','14:35:00',8.36),('10318','2013-06-15','14:40:00',8.14),('10318','2013-06-15','14:45:00',8.17),('10318','2013-06-15','14:50:00',8.14),('10318','2013-06-15','14:55:00',8.05),('10318','2013-06-15','15:00:00',7.96),('10318','2013-06-15','15:05:00',7.82),('10318','2013-06-15','15:10:00',7.74),('10318','2013-06-15','15:15:00',7.67),('10318','2013-06-15','15:20:00',7.61),('10318','2013-06-15','15:25:00',7.46),('10318','2013-06-15','15:30:00',7.31),('10318','2013-06-15','15:35:00',7.2),('10318','2013-06-15','15:40:00',7.12),('10318','2013-06-15','15:45:00',6.84),('10318','2013-06-15','15:50:00',6.85),('10318','2013-06-15','15:55:00',6.69),('10318','2013-06-15','16:00:00',6.59),('10318','2013-06-15','16:05:00',6.44),('10318','2013-06-15','16:10:00',6.26),('10318','2013-06-15','16:15:00',6.1),('10318','2013-06-15','16:20:00',5.98),('10318','2013-06-15','16:25:00',5.83),('10318','2013-06-15','16:30:00',5.69),('10318','2013-06-15','16:35:00',5.53),('10318','2013-06-15','16:40:00',5.36),('10318','2013-06-15','16:45:00',5.2),('10318','2013-06-15','16:50:00',5.05),('10318','2013-06-15','16:55:00',4.9),('10318','2013-06-15','17:00:00',4.71),('10318','2013-06-15','17:05:00',4.53),('10318','2013-06-15','17:10:00',4.36),('10318','2013-06-15','17:15:00',4.2),('10318','2013-06-15','17:20:00',4.02),('10318','2013-06-15','17:25:00',3.83),('10318','2013-06-15','17:30:00',3.65),('10318','2013-06-15','17:35:00',3.38),('10318','2013-06-15','17:40:00',3.27),('10318','2013-06-15','17:45:00',3.13),('10318','2013-06-15','17:50:00',2.95),('10318','2013-06-15','17:55:00',2.75),('10318','2013-06-15','18:00:00',2.58),('10318','2013-06-15','18:05:00',2.41),('10318','2013-06-15','18:10:00',2.27),('10318','2013-06-15','18:15:00',2.14),('10318','2013-06-15','18:20:00',1.97),('10318','2013-06-15','18:25:00',1.81),('10318','2013-06-15','18:30:00',1.64),('10318','2013-06-15','18:35:00',1.49),('10318','2013-06-15','18:40:00',1.35),('10318','2013-06-15','18:45:00',1.25),('10318','2013-06-15','18:50:00',1.12),('10318','2013-06-15','18:55:00',1.02),('10318','2013-06-14','06:50:00',1.15),('10318','2013-06-14','06:55:00',1.34),('10318','2013-06-14','07:00:00',1.6),('10318','2013-06-14','07:05:00',1.81),('10318','2013-06-14','07:10:00',2.07),('10318','2013-06-14','07:15:00',2.39),('10318','2013-06-14','07:20:00',2.72),('10318','2013-06-14','07:25:00',2.92),('10318','2013-06-14','07:30:00',3.09),('10318','2013-06-14','07:35:00',3.3),('10318','2013-06-14','07:40:00',3.49),('10318','2013-06-14','07:45:00',3.69),('10318','2013-06-14','07:50:00',3.88),('10318','2013-06-14','07:55:00',4.07),('10318','2013-06-14','08:00:00',4.25),('10318','2013-06-14','08:05:00',4.47),('10318','2013-06-14','08:10:00',4.65),('10318','2013-06-14','08:15:00',4.84),('10318','2013-06-14','08:20:00',5.02),('10318','2013-06-14','08:25:00',5.19),('10318','2013-06-14','08:30:00',5.35),('10318','2013-06-14','08:35:00',5.51),('10318','2013-06-14','08:40:00',5.68),('10318','2013-06-14','08:45:00',5.71),('10318','2013-06-14','08:50:00',6.01),('10318','2013-06-14','08:55:00',6.15),('10318','2013-06-14','09:00:00',6.33),('10318','2013-06-14','09:05:00',6.47),('10318','2013-06-14','09:10:00',6.59),('10318','2013-06-14','09:15:00',6.69),('10318','2013-06-14','09:20:00',6.79),('10318','2013-06-14','09:25:00',6.9),('10318','2013-06-14','09:30:00',7),('10318','2013-06-14','09:35:00',7.21),('10318','2013-06-14','09:40:00',7.39),('10318','2013-06-14','09:45:00',7.46),('10318','2013-06-14','09:50:00',7.57),('10318','2013-06-14','09:55:00',7.66),('10318','2013-06-14','10:00:00',7.73),('10318','2013-06-14','10:05:00',7.8),('10318','2013-06-14','10:10:00',7.86),('10318','2013-06-14','10:15:00',8.08),('10318','2013-06-14','10:20:00',8.18),('10318','2013-06-14','10:25:00',8.32),('10318','2013-06-14','10:30:00',8.02),('10318','2013-06-14','10:35:00',8.58),('10318','2013-06-14','10:40:00',8.58),('10318','2013-06-14','10:45:00',8.57),('10318','2013-06-14','10:50:00',8.57),('10318','2013-06-14','10:55:00',8.55),('10318','2013-06-14','11:00:00',8.54),('10318','2013-06-14','11:05:00',8.75),('10318','2013-06-14','11:10:00',8.84),('10318','2013-06-14','11:15:00',8.89),('10318','2013-06-14','11:20:00',8.84),('10318','2013-06-14','11:25:00',9.09),('10318','2013-06-14','11:30:00',9.04),('10318','2013-06-14','11:35:00',9.02),('10318','2013-06-14','11:40:00',9.05),('10318','2013-06-14','11:45:00',8.94),('10318','2013-06-14','11:50:00',9.1),('10318','2013-06-14','11:55:00',9.14),('10318','2013-06-14','12:00:00',9.13),('10318','2013-06-14','12:05:00',9.13),('10318','2013-06-14','12:10:00',9.16),('10318','2013-06-14','12:15:00',9.22),('10318','2013-06-14','12:20:00',9.3),('10318','2013-06-14','12:25:00',9.31),('10318','2013-06-14','12:30:00',9.27),('10318','2013-06-14','12:35:00',9.21),('10318','2013-06-14','12:40:00',9.23),('10318','2013-06-14','12:45:00',9.19),('10318','2013-06-14','12:50:00',9.27),('10318','2013-06-14','12:55:00',9.33),('10318','2013-06-14','13:00:00',9.25),('10318','2013-06-14','13:05:00',9.14),('10318','2013-06-14','13:10:00',9.13),('10318','2013-06-14','13:15:00',9.08),('10318','2013-06-14','13:20:00',9.1),('10318','2013-06-14','13:25:00',9.16),('10318','2013-06-14','13:30:00',9.03),('10318','2013-06-14','13:35:00',9),('10318','2013-06-14','13:40:00',9.01),('10318','2013-06-14','13:45:00',9.03),('10318','2013-06-14','13:50:00',9.06),('10318','2013-06-14','13:55:00',8.98),('10318','2013-06-14','14:00:00',8.82),('10318','2013-06-14','14:05:00',8.71),('10318','2013-06-14','14:10:00',8.73),('10318','2013-06-14','14:15:00',8.68),('10318','2013-06-14','14:20:00',8.54),('10318','2013-06-14','14:25:00',8.53),('10318','2013-06-14','14:30:00',8.57),('10318','2013-06-14','14:35:00',8.5),('10318','2013-06-14','14:40:00',8.5),('10318','2013-06-14','14:45:00',8.43),('10318','2013-06-14','14:50:00',8.31),('10318','2013-06-14','14:55:00',8.16),('10318','2013-06-14','15:00:00',8.09),('10318','2013-06-14','15:05:00',7.99),('10318','2013-06-14','15:10:00',7.89),('10318','2013-06-14','15:15:00',7.56),('10318','2013-06-14','15:20:00',7.57),('10318','2013-06-14','15:25:00',7.52),('10318','2013-06-14','15:30:00',7.4),('10318','2013-06-14','15:35:00',7.32),('10318','2013-06-14','15:40:00',7.21),('10318','2013-06-14','15:45:00',7.1),('10318','2013-06-14','15:50:00',7),('10318','2013-06-14','15:55:00',6.85),('10318','2013-06-14','16:00:00',6.72),('10318','2013-06-14','16:05:00',6.58),('10318','2013-06-14','16:10:00',6.42),('10318','2013-06-14','16:15:00',6.24),('10318','2013-06-14','16:20:00',6.07),('10318','2013-06-14','16:25:00',5.89),('10318','2013-06-14','16:30:00',5.75),('10318','2013-06-14','16:35:00',5.61),('10318','2013-06-14','16:40:00',5.44),('10318','2013-06-14','16:45:00',5.28),('10318','2013-06-14','16:50:00',5.13),('10318','2013-06-14','16:55:00',4.95),('10318','2013-06-14','17:00:00',4.68),('10318','2013-06-14','17:05:00',4.51),('10318','2013-06-14','17:10:00',4.41),('10318','2013-06-14','17:15:00',4.23),('10318','2013-06-14','17:20:00',4.03),('10318','2013-06-14','17:25:00',3.83),('10318','2013-06-14','17:30:00',3.53),('10318','2013-06-14','17:35:00',3.53),('10318','2013-06-14','17:40:00',3.37),('10318','2013-06-14','17:45:00',3.2),('10318','2013-06-14','17:50:00',3),('10318','2013-06-14','17:55:00',2.82),('10318','2013-06-14','18:00:00',2.6),('10318','2013-06-14','18:05:00',2.47),('10318','2013-06-14','18:10:00',2.32),('10318','2013-06-14','18:15:00',2.15),('10318','2013-06-14','18:20:00',1.95),('10318','2013-06-14','18:25:00',1.81),('10318','2013-06-14','18:30:00',1.65),('10318','2013-06-14','18:35:00',1.49),('10318','2013-06-14','18:40:00',1.35),('10318','2013-06-14','18:45:00',1.24),('10318','2013-06-14','18:50:00',1.1),('10318','2013-06-13','06:50:00',1.16),('10318','2013-06-13','06:55:00',1.34),('10318','2013-06-13','07:00:00',1.64),('10318','2013-06-13','07:05:00',1.82),('10318','2013-06-13','07:10:00',2.04),('10318','2013-06-13','07:15:00',2.19),('10318','2013-06-13','07:20:00',2.7),('10318','2013-06-13','07:25:00',2.91),('10318','2013-06-13','07:30:00',3.12),('10318','2013-06-13','07:35:00',3.33),('10318','2013-06-13','07:40:00',3.53),('10318','2013-06-13','07:45:00',3.72),('10318','2013-06-13','07:50:00',3.95),('10318','2013-06-13','07:55:00',4.13),('10318','2013-06-13','08:00:00',4.32),('10318','2013-06-13','08:05:00',4.51),('10318','2013-06-13','08:10:00',4.7),('10318','2013-06-13','08:15:00',4.88),('10318','2013-06-13','08:20:00',5.07),('10318','2013-06-13','08:25:00',5.26),('10318','2013-06-13','08:30:00',5.32),('10318','2013-06-13','08:35:00',5.6),('10318','2013-06-13','08:40:00',5.75),('10318','2013-06-13','08:45:00',5.89),('10318','2013-06-13','08:50:00',6.06),('10318','2013-06-13','08:55:00',6.23),('10318','2013-06-13','09:00:00',6.38),('10318','2013-06-13','09:05:00',6.54),('10318','2013-06-13','09:10:00',6.72),('10318','2013-06-13','09:15:00',6.86),('10318','2013-06-13','09:20:00',7.01),('10318','2013-06-13','09:25:00',7.12),('10318','2013-06-13','09:30:00',7.3),('10318','2013-06-13','09:35:00',7.48),('10318','2013-06-13','09:40:00',7.63),('10318','2013-06-13','09:45:00',7.75),('10318','2013-06-13','09:50:00',7.89),('10318','2013-06-13','09:55:00',7.95),('10318','2013-06-13','10:00:00',8.09),('10318','2013-06-13','10:05:00',8.17),('10318','2013-06-13','10:10:00',8.26),('10318','2013-06-13','10:15:00',8.17),('10318','2013-06-13','10:20:00',8.45),('10318','2013-06-13','10:25:00',8.57),('10318','2013-06-13','10:30:00',8.58),('10318','2013-06-13','10:35:00',8.66),('10318','2013-06-13','10:40:00',8.75),('10318','2013-06-13','10:45:00',8.85),('10318','2013-06-13','10:50:00',8.86),('10318','2013-06-13','10:55:00',8.92),('10318','2013-06-13','11:00:00',8.97),('10318','2013-06-13','11:05:00',9.07),('10318','2013-06-13','11:10:00',9.1),('10318','2013-06-13','11:15:00',9.07),('10318','2013-06-13','11:20:00',9.13),('10318','2013-06-13','11:25:00',9.24),('10318','2013-06-13','11:30:00',9.23),('10318','2013-06-13','11:35:00',9.28),('10318','2013-06-13','11:40:00',9.36),('10318','2013-06-13','11:45:00',9.42),('10318','2013-06-13','11:50:00',9.36),('10318','2013-06-13','11:55:00',9.41),('10318','2013-06-13','12:00:00',9.34),('10318','2013-06-13','12:05:00',9.43),('10318','2013-06-13','12:10:00',9.32),('10318','2013-06-13','12:15:00',9.36),('10318','2013-06-13','12:20:00',9.38),('10318','2013-06-13','12:25:00',7.09),('10318','2013-06-13','12:30:00',9.51),('10318','2013-06-13','12:35:00',7.16),('10318','2013-06-13','12:40:00',9.49),('10318','2013-06-13','12:45:00',9.62),('10318','2013-06-13','12:50:00',9.6),('10318','2013-06-13','12:55:00',9.56),('10318','2013-06-13','13:00:00',9.55),('10318','2013-06-13','13:05:00',9.53),('10318','2013-06-13','13:10:00',9.51),('10318','2013-06-13','13:15:00',9.53),('10318','2013-06-13','13:20:00',9.48),('10318','2013-06-13','13:25:00',9.4),('10318','2013-06-13','13:30:00',9.36),('10318','2013-06-13','13:35:00',9.34),('10318','2013-06-13','13:40:00',9.2),('10318','2013-06-13','13:45:00',9.2),('10318','2013-06-13','13:50:00',8.9),('10318','2013-06-13','13:55:00',9.07),('10318','2013-06-13','14:00:00',9.13),('10318','2013-06-13','14:05:00',9.03),('10318','2013-06-13','14:10:00',9.03),('10318','2013-06-13','14:15:00',9),('10318','2013-06-13','14:20:00',8.85),('10318','2013-06-13','14:25:00',8.8),('10318','2013-06-13','14:30:00',8.79),('10318','2013-06-13','14:35:00',8.82),('10318','2013-06-13','14:40:00',8.67),('10318','2013-06-13','14:45:00',8.46),('10318','2013-06-13','14:50:00',8.35),('10318','2013-06-13','14:55:00',8.21),('10318','2013-06-13','15:00:00',8.1),('10318','2013-06-13','15:05:00',7.96),('10318','2013-06-13','15:10:00',7.87),('10318','2013-06-13','15:15:00',7.76),('10318','2013-06-13','15:20:00',7.67),('10318','2013-06-13','15:25:00',7.6),('10318','2013-06-13','15:30:00',7.5),('10318','2013-06-13','15:35:00',7.13),('10318','2013-06-13','15:40:00',7.25),('10318','2013-06-13','15:45:00',7.07),('10318','2013-06-13','15:50:00',6.89),('10318','2013-06-13','15:55:00',6.79),('10318','2013-06-13','16:00:00',6.66),('10318','2013-06-13','16:05:00',6.54),('10318','2013-06-13','16:10:00',6.4),('10318','2013-06-13','16:15:00',6.25),('10318','2013-06-13','16:20:00',6.06),('10318','2013-06-13','16:25:00',5.89),('10318','2013-06-13','16:30:00',5.71),('10318','2013-06-13','16:35:00',5.48),('10318','2013-06-13','16:40:00',5.28),('10318','2013-06-13','16:45:00',5.12),('10318','2013-06-13','16:50:00',5.04),('10318','2013-06-13','16:55:00',4.89),('10318','2013-06-13','17:00:00',4.71),('10318','2013-06-13','17:05:00',4.57),('10318','2013-06-13','17:10:00',4.4),('10318','2013-06-13','17:15:00',4.26),('10318','2013-06-13','17:20:00',4.11),('10318','2013-06-13','17:25:00',3.89),('10318','2013-06-13','17:30:00',3.72),('10318','2013-06-13','17:35:00',3.54),('10318','2013-06-13','17:40:00',3.35),('10318','2013-06-13','17:45:00',3.16),('10318','2013-06-13','17:50:00',2.93),('10318','2013-06-13','17:55:00',2.74),('10318','2013-06-13','18:00:00',2.6),('10318','2013-06-13','18:05:00',2.44),('10318','2013-06-13','18:10:00',2.25),('10318','2013-06-13','18:15:00',2.11),('10318','2013-06-13','18:20:00',1.92),('10318','2013-06-13','18:25:00',1.75),('10318','2013-06-13','18:30:00',1.59),('10318','2013-06-13','18:35:00',1.45),('10318','2013-06-13','18:40:00',1.28),('10318','2013-06-13','18:45:00',1.19),('10318','2013-06-13','18:50:00',1.08),('10318','2013-06-12','06:50:00',1.18),('10318','2013-06-12','06:55:00',1.37),('10318','2013-06-12','07:00:00',1.54),('10318','2013-06-12','07:05:00',1.82),('10318','2013-06-12','07:10:00',1.92),('10318','2013-06-12','07:15:00',2.48),('10318','2013-06-12','07:20:00',2.78),('10318','2013-06-12','07:25:00',2.98),('10318','2013-06-12','07:30:00',3.17),('10318','2013-06-12','07:35:00',3.36),('10318','2013-06-12','07:40:00',3.54),('10318','2013-06-12','07:45:00',3.66),('10318','2013-06-12','07:50:00',3.95),('10318','2013-06-12','07:55:00',4.15),('10318','2013-06-12','08:00:00',4.36),('10318','2013-06-12','08:05:00',4.55),('10318','2013-06-12','08:10:00',4.76),('10318','2013-06-12','08:15:00',4.93),('10318','2013-06-12','08:20:00',5.12),('10318','2013-06-12','08:25:00',5.3),('10318','2013-06-12','08:30:00',5.48),('10318','2013-06-12','08:35:00',5.66),('10318','2013-06-12','08:40:00',5.81),('10318','2013-06-12','08:45:00',5.95),('10318','2013-06-12','08:50:00',6.13),('10318','2013-06-12','08:55:00',6.31),('10318','2013-06-12','09:00:00',6.48),('10318','2013-06-12','09:05:00',6.66),('10318','2013-06-12','09:10:00',6.82),('10318','2013-06-12','09:15:00',6.97),('10318','2013-06-12','09:20:00',7.11),('10318','2013-06-12','09:25:00',7.24),('10318','2013-06-12','09:30:00',7.15),('10318','2013-06-12','09:35:00',7.53),('10318','2013-06-12','09:40:00',7.57),('10318','2013-06-12','09:45:00',7.69),('10318','2013-06-12','09:50:00',7.79),('10318','2013-06-12','09:55:00',7.87),('10318','2013-06-12','10:00:00',7.98),('10318','2013-06-12','10:05:00',8.09),('10318','2013-06-12','10:10:00',8.2),('10318','2013-06-12','10:15:00',8.35),('10318','2013-06-12','10:20:00',8.42),('10318','2013-06-12','10:25:00',8.57),('10318','2013-06-12','10:30:00',8.64),('10318','2013-06-12','10:35:00',8.75),('10318','2013-06-12','10:40:00',8.79),('10318','2013-06-12','10:45:00',8.88),('10318','2013-06-12','10:50:00',9.02),('10318','2013-06-12','10:55:00',9.14),('10318','2013-06-12','11:00:00',9.21),('10318','2013-06-12','11:05:00',9.18),('10318','2013-06-12','11:10:00',9.23),('10318','2013-06-12','11:15:00',9.27),('10318','2013-06-12','11:20:00',9.14),('10318','2013-06-12','11:25:00',9.43),('10318','2013-06-12','11:30:00',9.46),('10318','2013-06-12','11:35:00',9.5),('10318','2013-06-12','11:40:00',9.57),('10318','2013-06-12','11:45:00',9.55),('10318','2013-06-12','11:50:00',9.61),('10318','2013-06-12','11:55:00',9.64),('10318','2013-06-12','12:00:00',9.66),('10318','2013-06-12','12:05:00',9.66),('10318','2013-06-12','12:10:00',9.64),('10318','2013-06-12','12:15:00',9.65),('10318','2013-06-12','12:20:00',8.5),('10318','2013-06-12','12:25:00',9.94),('10318','2013-06-12','12:30:00',9.92),('10318','2013-06-12','12:35:00',9.76),('10318','2013-06-12','12:40:00',9.86),('10318','2013-06-12','12:45:00',10.02),('10318','2013-06-12','12:50:00',10.13),('10318','2013-06-12','12:55:00',9.24),('10318','2013-06-12','13:00:00',9.78),('10318','2013-06-12','13:05:00',9.51),('10318','2013-06-12','13:10:00',9.48),('10318','2013-06-12','13:15:00',9.34),('10318','2013-06-12','13:20:00',9.32),('10318','2013-06-12','13:25:00',9.36),('10318','2013-06-12','13:30:00',9.35),('10318','2013-06-12','13:35:00',9.32),('10318','2013-06-12','13:40:00',9.08),('10318','2013-06-12','13:45:00',9.24),('10318','2013-06-12','13:50:00',9.38),('10318','2013-06-12','13:55:00',9.36),('10318','2013-06-12','14:00:00',7.73),('10318','2013-06-12','14:05:00',3.29),('10318','2013-06-12','14:10:00',4.41),('10318','2013-06-12','14:15:00',7.42),('10318','2013-06-12','14:20:00',8.47),('10318','2013-06-12','14:25:00',9.15),('10318','2013-06-12','14:30:00',8.74),('10318','2013-06-12','14:35:00',8.94),('10318','2013-06-12','14:40:00',8.85),('10318','2013-06-12','14:45:00',8.74),('10318','2013-06-12','14:50:00',8.56),('10318','2013-06-12','14:55:00',8.52),('10318','2013-06-12','15:00:00',8.38),('10318','2013-06-12','15:05:00',6.24),('10318','2013-06-12','15:10:00',8.19),('10318','2013-06-12','15:15:00',8.33),('10318','2013-06-12','15:20:00',6.99),('10318','2013-06-12','15:25:00',7.86),('10318','2013-06-12','15:30:00',7.67),('10318','2013-06-12','15:35:00',7.2),('10318','2013-06-12','15:40:00',7.29),('10318','2013-06-12','15:45:00',7.27),('10318','2013-06-12','15:50:00',7.17),('10318','2013-06-12','15:55:00',6.72),('10318','2013-06-12','16:00:00',5.01),('10318','2013-06-12','16:05:00',6.8),('10318','2013-06-12','16:10:00',6.66),('10318','2013-06-12','16:15:00',5.6),('10318','2013-06-12','16:20:00',6.04),('10318','2013-06-12','16:25:00',6.35),('10318','2013-06-12','16:30:00',5.69),('10318','2013-06-12','16:35:00',4.73),('10318','2013-06-12','16:40:00',5.84),('10318','2013-06-12','16:45:00',4.62),('10318','2013-06-12','16:50:00',4.49),('10318','2013-06-12','16:55:00',5.12),('10318','2013-06-12','17:00:00',4.99),('10318','2013-06-12','17:05:00',4.79),('10318','2013-06-12','17:10:00',4.56),('10318','2013-06-12','17:15:00',4.36),('10318','2013-06-12','17:20:00',4.12),('10318','2013-06-12','17:25:00',3.99),('10318','2013-06-12','17:30:00',3.86),('10318','2013-06-12','17:35:00',3.71),('10318','2013-06-12','17:40:00',1.96),('10318','2013-06-12','17:45:00',1.89),('10318','2013-06-12','17:50:00',3.32),('10318','2013-06-12','17:55:00',2.12),('10318','2013-06-12','18:00:00',2.14),('10318','2013-06-12','18:05:00',2.59),('10318','2013-06-12','18:10:00',2.41),('10318','2013-06-12','18:15:00',2.38),('10318','2013-06-12','18:20:00',2.21),('10318','2013-06-12','18:25:00',1.84),('10318','2013-06-12','18:30:00',1.7),('10318','2013-06-12','18:35:00',1.52),('10318','2013-06-12','18:40:00',1.35),('10318','2013-06-12','18:45:00',1.21),('10318','2013-06-12','18:50:00',1.1),('10318','2013-06-11','06:55:00',1.01),('10318','2013-06-11','07:00:00',1.02),('10318','2013-06-11','07:05:00',1.05),('10318','2013-06-11','07:10:00',1.27),('10318','2013-06-11','07:15:00',1.59),('10318','2013-06-11','07:20:00',2.39),('10318','2013-06-11','07:25:00',2.56),('10318','2013-06-11','07:30:00',3.16),('10318','2013-06-11','07:35:00',3.27),('10318','2013-06-11','07:40:00',3.45),('10318','2013-06-11','07:45:00',3.56),('10318','2013-06-11','07:50:00',3.54),('10318','2013-06-11','07:55:00',2.78),('10318','2013-06-11','08:00:00',1.43),('10318','2013-06-11','08:05:00',4.56),('10318','2013-06-11','08:10:00',4.47),('10318','2013-06-11','08:15:00',3.8),('10318','2013-06-11','08:20:00',5.11),('10318','2013-06-11','08:25:00',5.22),('10318','2013-06-11','08:30:00',5.53),('10318','2013-06-11','08:35:00',5.54),('10318','2013-06-11','08:40:00',5.84),('10318','2013-06-11','08:45:00',6.02),('10318','2013-06-11','08:50:00',6.01),('10318','2013-06-11','08:55:00',6.37),('10318','2013-06-11','09:00:00',6.73),('10318','2013-06-11','09:05:00',6.77),('10318','2013-06-11','09:10:00',7.13),('10318','2013-06-11','09:15:00',7.32),('10318','2013-06-11','09:20:00',7.19),('10318','2013-06-11','09:25:00',7.32),('10318','2013-06-11','09:30:00',7.46),('10318','2013-06-11','09:35:00',6.77),('10318','2013-06-11','09:40:00',6.38),('10318','2013-06-11','09:45:00',4.73),('10318','2013-06-11','09:50:00',4.79),('10318','2013-06-11','09:55:00',7.88),('10318','2013-06-11','10:00:00',8.31),('10318','2013-06-11','10:05:00',8.16),('10318','2013-06-11','10:10:00',8.36),('10318','2013-06-11','10:15:00',6.72),('10318','2013-06-11','10:20:00',8.22),('10318','2013-06-11','10:25:00',9),('10318','2013-06-11','10:30:00',8.79),('10318','2013-06-11','10:35:00',9.09),('10318','2013-06-11','10:40:00',9.05),('10318','2013-06-11','10:45:00',9.02),('10318','2013-06-11','10:50:00',9.27),('10318','2013-06-11','10:55:00',9.78),('10318','2013-06-11','11:00:00',6.73),('10318','2013-06-11','11:05:00',9.03),('10318','2013-06-11','11:10:00',9.52),('10318','2013-06-11','11:15:00',9.45),('10318','2013-06-11','11:20:00',9.44),('10318','2013-06-11','11:25:00',9.41),('10318','2013-06-11','11:30:00',9.45),('10318','2013-06-11','11:35:00',9.52),('10318','2013-06-11','11:40:00',9.57),('10318','2013-06-11','11:45:00',9.63),('10318','2013-06-11','11:50:00',9.68),('10318','2013-06-11','11:55:00',9.69),('10318','2013-06-11','12:00:00',9.71),('10318','2013-06-11','12:05:00',9.82),('10318','2013-06-11','12:10:00',9.76),('10318','2013-06-11','12:15:00',9.83),('10318','2013-06-11','12:20:00',9.81),('10318','2013-06-11','12:25:00',9.79),('10318','2013-06-11','12:30:00',9.81),('10318','2013-06-11','12:35:00',9.89),('10318','2013-06-11','12:40:00',9.97),('10318','2013-06-11','12:45:00',9.84),('10318','2013-06-11','12:50:00',9.74),('10318','2013-06-11','12:55:00',9.56),('10318','2013-06-11','13:00:00',9.85),('10318','2013-06-11','13:05:00',9.69),('10318','2013-06-11','13:10:00',9.97),('10318','2013-06-11','13:15:00',9.79),('10318','2013-06-11','13:20:00',9.75),('10318','2013-06-11','13:25:00',9.79),('10318','2013-06-11','13:30:00',9.7),('10318','2013-06-11','13:35:00',9.66),('10318','2013-06-11','13:40:00',9.72),('10318','2013-06-11','13:45:00',9.6),('10318','2013-06-11','13:50:00',9.63),('10318','2013-06-11','13:55:00',9.54),('10318','2013-06-11','14:00:00',9.53),('10318','2013-06-11','14:05:00',9.26),('10318','2013-06-11','14:10:00',9.2),('10318','2013-06-11','14:15:00',9.08),('10318','2013-06-11','14:20:00',9.12),('10318','2013-06-11','14:25:00',9.06),('10318','2013-06-11','14:30:00',8.93),('10318','2013-06-11','14:35:00',8.58),('10318','2013-06-11','14:40:00',8.76),('10318','2013-06-11','14:45:00',8.63),('10318','2013-06-11','14:50:00',8.63),('10318','2013-06-11','14:55:00',8.56),('10318','2013-06-11','15:00:00',8.42),('10318','2013-06-11','15:05:00',8.29),('10318','2013-06-11','15:10:00',8.2),('10318','2013-06-11','15:15:00',8.07),('10318','2013-06-11','15:20:00',7.92),('10318','2013-06-11','15:25:00',7.8),('10318','2013-06-11','15:30:00',7.84),('10318','2013-06-11','15:35:00',7.9),('10318','2013-06-11','15:40:00',7.86),('10318','2013-06-11','15:45:00',7.4),('10318','2013-06-11','15:50:00',7.29),('10318','2013-06-11','15:55:00',7.39),('10318','2013-06-11','16:00:00',6.81),('10318','2013-06-11','16:05:00',6.54),('10318','2013-06-11','16:10:00',6.7),('10318','2013-06-11','16:15:00',6.54),('10318','2013-06-11','16:20:00',6.15),('10318','2013-06-11','16:25:00',6.23),('10318','2013-06-11','16:30:00',6.08),('10318','2013-06-11','16:35:00',5.95),('10318','2013-06-11','16:40:00',6.01),('10318','2013-06-11','16:45:00',6.19),('10318','2013-06-11','16:50:00',6.12),('10318','2013-06-11','16:55:00',5.68),('10318','2013-06-11','17:00:00',3.41),('10318','2013-06-11','17:05:00',2.79),('10318','2013-06-11','17:10:00',1.74),('10318','2013-06-11','17:15:00',1.56),('10318','2013-06-11','17:20:00',1.32),('10318','2013-06-11','19:15:00',1.21),('10318','2013-06-11','19:20:00',1.11),('10318','2013-06-11','19:25:00',1.09),('10318','2013-06-11','19:30:00',1.19),('10318','2014-04-03','08:00:00',1.04),('10318','2014-04-03','08:05:00',1.17),('10318','2014-04-03','08:10:00',1.28),('10318','2014-04-03','08:15:00',1.32),('10318','2014-04-03','08:20:00',1.39),('10318','2014-04-03','08:25:00',1.49),('10318','2014-04-03','08:30:00',1.62),('10318','2014-04-03','08:35:00',1.74),('10318','2014-04-03','08:40:00',1.95),('10318','2014-04-03','08:45:00',2.17),('10318','2014-04-03','08:50:00',2.43),('10318','2014-04-03','08:55:00',2.79),('10318','2014-04-03','09:00:00',3.01),('10318','2014-04-03','09:05:00',3.26),('10318','2014-04-03','09:10:00',3.11),('10318','2014-04-03','09:15:00',2.81),('10318','2014-04-03','09:20:00',2.84),('10318','2014-04-03','09:25:00',3.09),('10318','2014-04-03','09:30:00',3.68),('10318','2014-04-03','09:35:00',4.38),('10318','2014-04-03','09:40:00',4.48),('10318','2014-04-03','09:45:00',4.32),('10318','2014-04-03','09:50:00',4.29),('10318','2014-04-03','09:55:00',4.71),('10318','2014-04-03','10:00:00',5.79),('10318','2014-04-03','10:05:00',6.46),('10318','2014-04-03','10:10:00',6.95),('10318','2014-04-03','10:15:00',7.88),('10318','2014-04-03','10:20:00',6.97),('10318','2014-04-03','10:25:00',6.06),('10318','2014-04-03','10:30:00',6.68),('10318','2014-04-03','10:35:00',7.31),('10318','2014-04-03','10:40:00',5.93),('10318','2014-04-03','10:45:00',6.77),('10318','2014-04-03','10:50:00',5.49),('10318','2014-04-03','10:55:00',5.73),('10318','2014-04-03','11:00:00',4.62),('10318','2014-04-03','11:05:00',3.88),('10318','2014-04-03','11:10:00',3.59),('10318','2014-04-03','11:15:00',3.37),('10318','2014-04-03','11:20:00',3.16),('10318','2014-04-03','11:25:00',2.93),('10318','2014-04-03','11:30:00',2.94),('10318','2014-04-03','11:35:00',3.2),('10318','2014-04-03','11:40:00',3.52),('10318','2014-04-03','11:45:00',3.89),('10318','2014-04-03','11:50:00',4.79),('10318','2014-04-03','11:55:00',5.26),('10318','2014-04-03','12:00:00',5.16),('10318','2014-04-03','12:05:00',5.22),('10318','2014-04-03','12:10:00',4.94),('10318','2014-04-03','12:15:00',4.86),('10318','2014-04-03','12:20:00',5.85),('10318','2014-04-03','12:25:00',7.36),('10318','2014-04-03','12:30:00',9.5),('10318','2014-04-03','12:35:00',8.65),('10318','2014-04-03','12:40:00',8.06),('10318','2014-04-03','12:45:00',5.29),('10318','2014-04-03','12:50:00',6.33),('10318','2014-04-03','12:55:00',6.57),('10318','2014-04-03','13:00:00',5.22),('10318','2014-04-03','13:05:00',6.52),('10318','2014-04-03','13:10:00',5.74),('10318','2014-04-03','13:15:00',8.5),('10318','2014-04-03','13:20:00',5.29),('10318','2014-04-03','13:25:00',5.52),('10318','2014-04-03','13:30:00',7.07),('10318','2014-04-03','13:35:00',10.22),('10318','2014-04-03','13:40:00',8.05),('10318','2014-04-03','13:45:00',4.21),('10318','2014-04-03','13:50:00',4.8),('10318','2014-04-03','13:55:00',5.43),('10318','2014-04-03','14:00:00',6.99),('10318','2014-04-03','14:05:00',8.18),('10318','2014-04-03','14:10:00',6.61),('10318','2014-04-03','14:15:00',7.47),('10318','2014-04-03','14:20:00',8.05),('10318','2014-04-03','14:25:00',7.27),('10318','2014-04-03','14:30:00',7.71),('10318','2014-04-03','14:35:00',8.67),('10318','2014-04-03','14:40:00',7.87),('10318','2014-04-03','14:45:00',8.04),('10318','2014-04-03','14:50:00',7.95),('10318','2014-04-03','14:55:00',7.72),('10318','2014-04-03','15:00:00',7.55),('10318','2014-04-03','15:05:00',7.38),('10318','2014-04-03','15:10:00',7.31),('10318','2014-04-03','15:15:00',7.17),('10318','2014-04-03','15:20:00',7.08),('10318','2014-04-03','15:25:00',7),('10318','2014-04-03','15:30:00',6.9),('10318','2014-04-03','15:35:00',6.77),('10318','2014-04-03','15:40:00',6.7),('10318','2014-04-03','15:45:00',6.6),('10318','2014-04-03','15:50:00',6.5),('10318','2014-04-03','15:55:00',6.26),('10318','2014-04-03','16:00:00',6.33),('10318','2014-04-03','16:05:00',6.05),('10318','2014-04-03','16:10:00',6.01),('10318','2014-04-03','16:15:00',5.7),('10318','2014-04-03','16:20:00',5.32),('10318','2014-04-03','16:25:00',5.37),('10318','2014-04-03','16:30:00',5.12),('10318','2014-04-03','16:35:00',4.92),('10318','2014-04-03','16:40:00',4.8),('10318','2014-04-03','16:45:00',4.5),('10318','2014-04-03','16:50:00',4.05),('10318','2014-04-03','16:55:00',3.37),('10318','2014-04-03','17:00:00',2.61),('10318','2014-04-03','17:05:00',2.26),('10318','2014-04-03','17:10:00',2.07),('10318','2014-04-03','17:15:00',2.11),('10318','2014-04-03','17:20:00',2.42),('10318','2014-04-03','17:25:00',2.36),('10318','2014-04-03','17:30:00',2.44),('10318','2014-04-03','17:35:00',1.63),('10318','2014-04-03','17:40:00',1.35),('10318','2014-04-03','17:45:00',1.81),('10318','2014-04-03','17:50:00',2.35),('10318','2014-04-03','17:55:00',2.07),('10318','2014-04-03','18:00:00',1.86),('10318','2014-04-03','18:05:00',1.67),('10318','2014-04-03','18:10:00',1.5),('10318','2014-04-03','18:15:00',1.33),('10318','2014-04-03','18:20:00',1.15),('10318','2013-06-10','07:05:00',1.12),('10318','2013-06-10','07:10:00',1.4),('10318','2013-06-10','07:15:00',1.16),('10318','2013-06-10','07:20:00',1.37),('10318','2013-06-10','07:25:00',2.6),('10318','2013-06-10','07:30:00',3.78),('10318','2013-06-10','07:35:00',3.79),('10318','2013-06-10','07:40:00',1.91),('10318','2013-06-10','07:45:00',1.53),('10318','2013-06-10','07:50:00',1.61),('10318','2013-06-10','07:55:00',1.82),('10318','2013-06-10','08:00:00',3.95),('10318','2013-06-10','08:05:00',4.28),('10318','2013-06-10','08:10:00',3.41),('10318','2013-06-10','08:15:00',4.04),('10318','2013-06-10','08:20:00',2.65),('10318','2013-06-10','08:25:00',5.49),('10318','2013-06-10','08:30:00',3.72),('10318','2013-06-10','08:35:00',2.17),('10318','2013-06-10','08:40:00',2.69),('10318','2013-06-10','08:45:00',2.01),('10318','2013-06-10','08:50:00',3.62),('10318','2013-06-10','08:55:00',3.78),('10318','2013-06-10','09:00:00',3.48),('10318','2013-06-10','09:05:00',3.03),('10318','2013-06-10','09:10:00',3.21),('10318','2013-06-10','09:15:00',5.83),('10318','2013-06-10','09:20:00',4.85),('10318','2013-06-10','09:25:00',7.36),('10318','2013-06-10','09:30:00',7.02),('10318','2013-06-10','09:35:00',5.32),('10318','2013-06-10','09:40:00',4.12),('10318','2013-06-10','09:45:00',7.53),('10318','2013-06-10','09:50:00',8.48),('10318','2013-06-10','09:55:00',4.22),('10318','2013-06-10','10:00:00',4.89),('10318','2013-06-10','10:05:00',6.82),('10318','2013-06-10','10:10:00',8.91),('10318','2013-06-10','10:15:00',7.29),('10318','2013-06-10','10:20:00',5.67),('10318','2013-06-10','10:25:00',3.34),('10318','2013-06-10','10:30:00',3.02),('10318','2013-06-10','10:35:00',3.76),('10318','2013-06-10','10:40:00',5.85),('10318','2013-06-10','10:45:00',4.83),('10318','2013-06-10','10:50:00',6.65),('10318','2013-06-10','10:55:00',4.77),('10318','2013-06-10','11:00:00',4.99),('10318','2013-06-10','11:05:00',8.95),('10318','2013-06-10','11:10:00',7.19),('10318','2013-06-10','11:15:00',6.11),('10318','2013-06-10','11:20:00',8.59),('10318','2013-06-10','11:25:00',10.48),('10318','2013-06-10','11:30:00',2.96),('10318','2013-06-10','11:35:00',3.5),('10318','2013-06-10','11:40:00',4.57),('10318','2013-06-10','11:45:00',2.85),('10318','2013-06-10','11:50:00',2.5),('10318','2013-06-10','11:55:00',7.06),('10318','2013-06-10','12:00:00',4.68),('10318','2013-06-10','12:05:00',3.02),('10318','2013-06-10','12:10:00',8.71),('10318','2013-06-10','12:15:00',10.58),('10318','2013-06-10','12:20:00',8.63),('10318','2013-06-10','12:25:00',7.2),('10318','2013-06-10','12:30:00',7.8),('10318','2013-06-10','12:35:00',10.12),('10318','2013-06-10','12:40:00',8.15),('10318','2013-06-10','12:45:00',10.79),('10318','2013-06-10','12:50:00',6.84),('10318','2013-06-10','12:55:00',5.11),('10318','2013-06-10','13:00:00',7.6),('10318','2013-06-10','13:05:00',7.94),('10318','2013-06-10','13:10:00',5.53),('10318','2013-06-10','13:15:00',6),('10318','2013-06-10','13:20:00',3.13),('10318','2013-06-10','13:25:00',8.76),('10318','2013-06-10','13:30:00',10.42),('10318','2013-06-10','13:35:00',10.16),('10318','2013-06-10','13:40:00',8.76),('10318','2013-06-10','13:45:00',4.8),('10318','2013-06-10','13:50:00',4.09),('10318','2013-06-10','13:55:00',8.78),('10318','2013-06-10','14:00:00',4.87),('10318','2013-06-10','14:05:00',3.85),('10318','2013-06-10','14:10:00',9.42),('10318','2013-06-10','14:15:00',9.59),('10318','2013-06-10','14:20:00',9.14),('10318','2013-06-10','14:25:00',9.19),('10318','2013-06-10','14:30:00',8.88),('10318','2013-06-10','14:35:00',9.06),('10318','2013-06-10','14:40:00',8.83),('10318','2013-06-10','14:45:00',8.78),('10318','2013-06-10','14:50:00',8.42),('10318','2013-06-10','14:55:00',8.56),('10318','2013-06-10','15:00:00',8.44),('10318','2013-06-10','15:05:00',8.34),('10318','2013-06-10','15:10:00',8.22),('10318','2013-06-10','15:15:00',8.05),('10318','2013-06-10','15:20:00',8.07),('10318','2013-06-10','15:25:00',7.94),('10318','2013-06-10','15:30:00',7.85),('10318','2013-06-10','15:35:00',7.69),('10318','2013-06-10','15:40:00',7.61),('10318','2013-06-10','15:45:00',7.46),('10318','2013-06-10','15:50:00',7.32),('10318','2013-06-10','15:55:00',7.17),('10318','2013-06-10','16:00:00',7),('10318','2013-06-10','16:05:00',6.84),('10318','2013-06-10','16:10:00',6.74),('10318','2013-06-10','16:15:00',6.58),('10318','2013-06-10','16:20:00',6.38),('10318','2013-06-10','16:25:00',6.23),('10318','2013-06-10','16:30:00',6.06),('10318','2013-06-10','16:35:00',5.76),('10318','2013-06-10','16:40:00',5.73),('10318','2013-06-10','16:45:00',5.54),('10318','2013-06-10','16:50:00',5.37),('10318','2013-06-10','16:55:00',5.18),('10318','2013-06-10','17:00:00',5.05),('10318','2013-06-10','17:05:00',4.84),('10318','2013-06-10','17:10:00',4.65),('10318','2013-06-10','17:15:00',4.46),('10318','2013-06-10','17:20:00',4.26),('10318','2013-06-10','17:25:00',4.11),('10318','2013-06-10','17:30:00',3.91),('10318','2013-06-10','17:35:00',3.71),('10318','2013-06-10','17:40:00',3.51),('10318','2013-06-10','17:45:00',3.31),('10318','2013-06-10','17:50:00',3.07),('10318','2013-06-10','17:55:00',2.94),('10318','2013-06-10','18:00:00',2.73),('10318','2013-06-10','18:05:00',2.54),('10318','2013-06-10','18:10:00',2.38),('10318','2013-06-10','18:15:00',2.17),('10318','2013-06-10','18:20:00',1.97),('10318','2013-06-10','18:25:00',1.83),('10318','2013-06-10','18:30:00',1.66),('10318','2013-06-10','18:35:00',1.5),('10318','2013-06-10','18:40:00',1.34),('10318','2013-06-10','18:45:00',1.18),('10318','2013-06-10','18:50:00',1.04),('10318','2013-06-09','07:10:00',1.17),('10318','2013-06-09','07:15:00',1.08),('10318','2013-06-09','07:20:00',1.07),('10318','2013-06-09','07:25:00',1.71),('10318','2013-06-09','07:30:00',1.86),('10318','2013-06-09','07:35:00',3.02),('10318','2013-06-09','07:40:00',1.92),('10318','2013-06-09','07:45:00',1.33),('10318','2013-06-09','07:50:00',3.4),('10318','2013-06-09','07:55:00',3.36),('10318','2013-06-09','08:00:00',4.19),('10318','2013-06-09','08:05:00',4.25),('10318','2013-06-09','08:10:00',3.45),('10318','2013-06-09','08:15:00',4.09),('10318','2013-06-09','08:20:00',4.88),('10318','2013-06-09','08:25:00',4.84),('10318','2013-06-09','08:30:00',4.69),('10318','2013-06-09','08:35:00',4.54),('10318','2013-06-09','08:40:00',5.17),('10318','2013-06-09','08:45:00',5.51),('10318','2013-06-09','08:50:00',5.65),('10318','2013-06-09','08:55:00',5.87),('10318','2013-06-09','09:00:00',6.1),('10318','2013-06-09','09:05:00',6.32),('10318','2013-06-09','09:10:00',6.44),('10318','2013-06-09','09:15:00',6.5),('10318','2013-06-09','09:20:00',6.61),('10318','2013-06-09','09:25:00',6.79),('10318','2013-06-09','09:30:00',6.93),('10318','2013-06-09','09:35:00',6.98),('10318','2013-06-09','09:40:00',7.11),('10318','2013-06-09','09:45:00',7.29),('10318','2013-06-09','09:50:00',7.4),('10318','2013-06-09','09:55:00',7.54),('10318','2013-06-09','10:00:00',7.62),('10318','2013-06-09','10:05:00',7.71),('10318','2013-06-09','10:10:00',7.8),('10318','2013-06-09','10:15:00',7.89),('10318','2013-06-09','10:20:00',8.07),('10318','2013-06-09','10:25:00',8.14),('10318','2013-06-09','10:30:00',8.22),('10318','2013-06-09','10:35:00',8.22),('10318','2013-06-09','10:40:00',8.29),('10318','2013-06-09','10:45:00',8.4),('10318','2013-06-09','10:50:00',8.37),('10318','2013-06-09','10:55:00',8.5),('10318','2013-06-09','11:00:00',8.58),('10318','2013-06-09','11:05:00',8.63),('10318','2013-06-09','11:10:00',8.69),('10318','2013-06-09','11:15:00',8.69),('10318','2013-06-09','11:20:00',8.68),('10318','2013-06-09','11:25:00',8.67),('10318','2013-06-09','11:30:00',8.71),('10318','2013-06-09','11:35:00',8.79),('10318','2013-06-09','11:40:00',8.94),('10318','2013-06-09','11:45:00',8.86),('10318','2013-06-09','11:50:00',8.69),('10318','2013-06-09','11:55:00',8.8),('10318','2013-06-09','12:00:00',8.88),('10318','2013-06-09','12:05:00',9.13),('10318','2013-06-09','12:10:00',8.75),('10318','2013-06-09','12:15:00',9.13),('10318','2013-06-09','12:20:00',9.1),('10318','2013-06-09','12:25:00',8.76),('10318','2013-06-09','12:30:00',8.99),('10318','2013-06-09','12:35:00',9.05),('10318','2013-06-09','12:40:00',9.26),('10318','2013-06-09','12:45:00',7.47),('10318','2013-06-09','12:50:00',6.46),('10318','2013-06-09','12:55:00',9.63),('10318','2013-06-09','13:00:00',8.96),('10318','2013-06-09','13:05:00',9.2),('10318','2013-06-09','13:10:00',7.87),('10318','2013-06-09','13:15:00',8.91),('10318','2013-06-09','13:20:00',8.98),('10318','2013-06-09','13:25:00',5.26),('10318','2013-06-09','13:30:00',8.18),('10318','2013-06-09','13:35:00',9.05),('10318','2013-06-09','13:40:00',8.03),('10318','2013-06-09','13:45:00',9.33),('10318','2013-06-09','13:50:00',6.89),('10318','2013-06-09','13:55:00',7.27),('10318','2013-06-09','14:00:00',9.2),('10318','2013-06-09','14:05:00',8.78),('10318','2013-06-09','14:10:00',8.58),('10318','2013-06-09','14:15:00',8.95),('10318','2013-06-09','14:20:00',3.05),('10318','2013-06-09','14:25:00',2.39),('10318','2013-06-09','14:30:00',3.38),('10318','2013-06-09','14:35:00',8.14),('10318','2013-06-09','14:40:00',7.21),('10318','2013-06-09','14:45:00',8.71),('10318','2013-06-09','14:50:00',8.81),('10318','2013-06-09','14:55:00',8.54),('10318','2013-06-09','15:00:00',8.27),('10318','2013-06-09','15:05:00',8.12),('10318','2013-06-09','15:10:00',7.84),('10318','2013-06-09','15:15:00',7.7),('10318','2013-06-09','15:20:00',7.45),('10318','2013-06-09','15:25:00',7.65),('10318','2013-06-09','15:30:00',7.45),('10318','2013-06-09','15:35:00',7.68),('10318','2013-06-09','15:40:00',5.67),('10318','2013-06-09','15:45:00',5.92),('10318','2013-06-09','15:50:00',6.59),('10318','2013-06-09','15:55:00',7.35),('10318','2013-06-09','16:00:00',6.57),('10318','2013-06-09','16:05:00',6.08),('10318','2013-06-09','16:10:00',5.35),('10318','2013-06-09','16:15:00',5.61),('10318','2013-06-09','16:20:00',3.99),('10318','2013-06-09','16:25:00',4.95),('10318','2013-06-09','16:30:00',2.32),('10318','2013-06-09','16:35:00',2.09),('10318','2013-06-09','16:40:00',2.05),('10318','2013-06-09','16:45:00',2.07),('10318','2013-06-09','16:50:00',1.93),('10318','2013-06-09','16:55:00',1.84),('10318','2013-06-09','17:00:00',2),('10318','2013-06-09','17:05:00',2.06),('10318','2013-06-09','17:10:00',1.97),('10318','2013-06-09','17:15:00',1.66),('10318','2013-06-09','17:20:00',1.73),('10318','2013-06-09','17:25:00',1.36),('10318','2013-06-09','17:30:00',1.21),('10318','2013-06-09','17:35:00',1.38),('10318','2013-06-09','17:40:00',1.62),('10318','2013-06-09','17:45:00',1.54),('10318','2013-06-09','17:50:00',1.04),('10318','2013-06-09','17:55:00',1.23),('10318','2013-06-09','18:00:00',2.11),('10318','2013-06-09','18:05:00',1.85),('10318','2013-06-09','18:10:00',2.04),('10318','2013-06-09','18:15:00',1.21),('10318','2013-06-09','18:30:00',1.23),('10318','2013-06-09','18:35:00',1),('10318','2013-06-09','18:40:00',1.07),('10318','2013-06-09','18:45:00',1.17),('10318','2013-06-09','18:50:00',1.14),('10318','2013-06-08','06:50:00',1.07),('10318','2013-06-08','06:55:00',1.38),('10318','2013-06-08','07:00:00',1.65),('10318','2013-06-08','07:05:00',1.78),('10318','2013-06-08','07:10:00',1.84),('10318','2013-06-08','07:15:00',2.31),('10318','2013-06-08','07:20:00',2.59),('10318','2013-06-08','07:25:00',2.76),('10318','2013-06-08','07:30:00',2.89),('10318','2013-06-08','07:35:00',3.17),('10318','2013-06-08','07:40:00',3.32),('10318','2013-06-08','07:45:00',3.49),('10318','2013-06-08','07:50:00',3.69),('10318','2013-06-08','07:55:00',3.93),('10318','2013-06-08','08:00:00',4.14),('10318','2013-06-08','08:05:00',4.33),('10318','2013-06-08','08:10:00',4.5),('10318','2013-06-08','08:15:00',4.67),('10318','2013-06-08','08:20:00',4.86),('10318','2013-06-08','08:25:00',5.02),('10318','2013-06-08','08:30:00',5.17),('10318','2013-06-08','08:35:00',5.36),('10318','2013-06-08','08:40:00',5.55),('10318','2013-06-08','08:45:00',5.73),('10318','2013-06-08','08:50:00',5.89),('10318','2013-06-08','08:55:00',6.06),('10318','2013-06-08','09:00:00',6.16),('10318','2013-06-08','09:05:00',6.21),('10318','2013-06-08','09:10:00',6.47),('10318','2013-06-08','09:15:00',6.6),('10318','2013-06-08','09:20:00',6.8),('10318','2013-06-08','09:25:00',6.91),('10318','2013-06-08','09:30:00',7.04),('10318','2013-06-08','09:35:00',7.16),('10318','2013-06-08','09:40:00',7.24),('10318','2013-06-08','09:45:00',7.38),('10318','2013-06-08','09:50:00',7.5),('10318','2013-06-08','09:55:00',7.68),('10318','2013-06-08','10:00:00',7.81),('10318','2013-06-08','10:05:00',8.03),('10318','2013-06-08','10:10:00',8.2),('10318','2013-06-08','10:15:00',8.4),('10318','2013-06-08','10:20:00',8.82),('10318','2013-06-08','10:25:00',9.28),('10318','2013-06-08','10:30:00',8.83),('10318','2013-06-08','10:35:00',7.36),('10318','2013-06-08','10:40:00',4.61),('10318','2013-06-08','10:45:00',9.11),('10318','2013-06-08','10:50:00',9.58),('10318','2013-06-08','10:55:00',9.33),('10318','2013-06-08','11:00:00',6.84),('10318','2013-06-08','11:05:00',7.69),('10318','2013-06-08','11:10:00',6.25),('10318','2013-06-08','11:15:00',3.29),('10318','2013-06-08','11:20:00',7.73),('10318','2013-06-08','11:25:00',9.26),('10318','2013-06-08','11:30:00',5.65),('10318','2013-06-08','11:35:00',9.45),('10318','2013-06-08','11:40:00',8.34),('10318','2013-06-08','11:45:00',9.46),('10318','2013-06-08','11:50:00',10.05),('10318','2013-06-08','11:55:00',6.47),('10318','2013-06-08','12:00:00',10.09),('10318','2013-06-08','12:05:00',6.75),('10318','2013-06-08','12:10:00',5.39),('10318','2013-06-08','12:15:00',5.86),('10318','2013-06-08','12:20:00',6.16),('10318','2013-06-08','12:25:00',3.48),('10318','2013-06-08','12:30:00',9.6),('10318','2013-06-08','12:35:00',8.32),('10318','2013-06-08','12:40:00',8.56),('10318','2013-06-08','12:45:00',9.7),('10318','2013-06-08','12:50:00',9.81),('10318','2013-06-08','12:55:00',9.86),('10318','2013-06-08','13:00:00',9.55),('10318','2013-06-08','13:05:00',9.65),('10318','2013-06-08','13:10:00',9.58),('10318','2013-06-08','13:15:00',9.4),('10318','2013-06-08','13:20:00',9.6),('10318','2013-06-08','13:25:00',9.52),('10318','2013-06-08','13:30:00',4.93),('10318','2013-06-08','13:35:00',9.35),('10318','2013-06-08','13:40:00',9.57),('10318','2013-06-08','13:45:00',9.38),('10318','2013-06-08','13:50:00',9.26),('10318','2013-06-08','13:55:00',9.25),('10318','2013-06-08','14:00:00',8.99),('10318','2013-06-08','14:05:00',9.2),('10318','2013-06-08','14:10:00',9.1),('10318','2013-06-08','14:15:00',9.03),('10318','2013-06-08','14:20:00',8.96),('10318','2013-06-08','14:25:00',8.94),('10318','2013-06-08','14:30:00',8.81),('10318','2013-06-08','14:35:00',8.77),('10318','2013-06-08','14:40:00',8.61),('10318','2013-06-08','14:45:00',8.52),('10318','2013-06-08','14:50:00',8.51),('10318','2013-06-08','14:55:00',8.45),('10318','2013-06-08','15:00:00',8.27),('10318','2013-06-08','15:05:00',8.03),('10318','2013-06-08','15:10:00',7.34),('10318','2013-06-08','15:15:00',7.99),('10318','2013-06-08','15:20:00',8.08),('10318','2013-06-08','15:25:00',7.35),('10318','2013-06-08','15:30:00',7.81),('10318','2013-06-08','15:35:00',7.84),('10318','2013-06-08','15:40:00',7.49),('10318','2013-06-08','15:45:00',7.65),('10318','2013-06-08','15:50:00',7.57),('10318','2013-06-08','15:55:00',6.98),('10318','2013-06-08','16:00:00',7),('10318','2013-06-08','16:05:00',6.82),('10318','2013-06-08','16:10:00',6.88),('10318','2013-06-08','16:15:00',6.82),('10318','2013-06-08','16:20:00',6.63),('10318','2013-06-08','16:25:00',6.24),('10318','2013-06-08','16:30:00',5.95),('10318','2013-06-08','16:35:00',5.76),('10318','2013-06-08','16:40:00',5.56),('10318','2013-06-08','16:45:00',5.28),('10318','2013-06-08','16:50:00',4.33),('10318','2013-06-08','16:55:00',4.91),('10318','2013-06-08','17:00:00',4.58),('10318','2013-06-08','17:05:00',4.65),('10318','2013-06-08','17:10:00',5.13),('10318','2013-06-08','17:15:00',4.89),('10318','2013-06-08','17:20:00',4.48),('10318','2013-06-08','17:25:00',3.7),('10318','2013-06-08','17:30:00',2.39),('10318','2013-06-08','17:35:00',2.2),('10318','2013-06-08','17:40:00',3.84),('10318','2013-06-08','17:45:00',3.27),('10318','2013-06-08','17:50:00',3.48),('10318','2013-06-08','17:55:00',3.11),('10318','2013-06-08','18:00:00',2.51),('10318','2013-06-08','18:05:00',2.26),('10318','2013-06-08','18:10:00',1.96),('10318','2013-06-08','18:15:00',1.98),('10318','2013-06-08','18:20:00',1.8),('10318','2013-06-08','18:25:00',1.54),('10318','2013-06-08','18:30:00',1.19),('10318','2013-06-08','18:35:00',1.05),('10318','2013-06-07','06:50:00',1.09),('10318','2013-06-07','06:55:00',1.39),('10318','2013-06-07','07:00:00',1.63),('10318','2013-06-07','07:05:00',1.79),('10318','2013-06-07','07:10:00',1.84),('10318','2013-06-07','07:15:00',2.41),('10318','2013-06-07','07:20:00',2.71),('10318','2013-06-07','07:25:00',2.91),('10318','2013-06-07','07:30:00',3.1),('10318','2013-06-07','07:35:00',3.31),('10318','2013-06-07','07:40:00',3.53),('10318','2013-06-07','07:45:00',3.74),('10318','2013-06-07','07:50:00',3.94),('10318','2013-06-07','07:55:00',4.13),('10318','2013-06-07','08:00:00',4.24),('10318','2013-06-07','08:05:00',4.51),('10318','2013-06-07','08:10:00',4.7),('10318','2013-06-07','08:15:00',4.88),('10318','2013-06-07','08:20:00',5.07),('10318','2013-06-07','08:25:00',5.25),('10318','2013-06-07','08:30:00',5.44),('10318','2013-06-07','08:35:00',5.62),('10318','2013-06-07','08:40:00',5.8),('10318','2013-06-07','08:45:00',5.97),('10318','2013-06-07','08:50:00',6.15),('10318','2013-06-07','08:55:00',6.3),('10318','2013-06-07','09:00:00',6.44),('10318','2013-06-07','09:05:00',6.56),('10318','2013-06-07','09:10:00',6.69),('10318','2013-06-07','09:15:00',6.87),('10318','2013-06-07','09:20:00',7),('10318','2013-06-07','09:25:00',7.14),('10318','2013-06-07','09:30:00',7.28),('10318','2013-06-07','09:35:00',7.41),('10318','2013-06-07','09:40:00',7.55),('10318','2013-06-07','09:45:00',7.48),('10318','2013-06-07','09:50:00',7.8),('10318','2013-06-07','09:55:00',7.93),('10318','2013-06-07','10:00:00',8.06),('10318','2013-06-07','10:05:00',8.16),('10318','2013-06-07','10:10:00',8.26),('10318','2013-06-07','10:15:00',8.35),('10318','2013-06-07','10:20:00',8.45),('10318','2013-06-07','10:25:00',8.55),('10318','2013-06-07','10:30:00',8.6),('10318','2013-06-07','10:35:00',8.7),('10318','2013-06-07','10:40:00',8.74),('10318','2013-06-07','10:45:00',8.79),('10318','2013-06-07','10:50:00',8.89),('10318','2013-06-07','10:55:00',9.03),('10318','2013-06-07','11:00:00',9.11),('10318','2013-06-07','11:05:00',9.22),('10318','2013-06-07','11:10:00',9.31),('10318','2013-06-07','11:15:00',9.35),('10318','2013-06-07','11:20:00',9.33),('10318','2013-06-07','11:25:00',9.36),('10318','2013-06-07','11:30:00',9.29),('10318','2013-06-07','11:35:00',9.49),('10318','2013-06-07','11:40:00',9.5),('10318','2013-06-07','11:45:00',9.58),('10318','2013-06-07','11:50:00',9.62),('10318','2013-06-07','11:55:00',9.62),('10318','2013-06-07','12:00:00',9.62),('10318','2013-06-07','12:05:00',9.64),('10318','2013-06-07','12:10:00',9.67),('10318','2013-06-07','12:15:00',9.69),('10318','2013-06-07','12:20:00',9.68),('10318','2013-06-07','12:25:00',9.65),('10318','2013-06-07','12:30:00',9.68),('10318','2013-06-07','12:35:00',9.62),('10318','2013-06-07','12:40:00',9.58),('10318','2013-06-07','12:45:00',9.58),('10318','2013-06-07','12:50:00',9.59),('10318','2013-06-07','12:55:00',9.49),('10318','2013-06-07','13:00:00',9.47),('10318','2013-06-07','13:05:00',9.47),('10318','2013-06-07','13:10:00',9.43),('10318','2013-06-07','13:15:00',9.27),('10318','2013-06-07','13:20:00',9.44),('10318','2013-06-07','13:25:00',9.42),('10318','2013-06-07','13:30:00',9.25),('10318','2013-06-07','13:35:00',9.17),('10318','2013-06-07','13:40:00',9.2),('10318','2013-06-07','13:45:00',9.16),('10318','2013-06-07','13:50:00',9.05),('10318','2013-06-07','13:55:00',8.89),('10318','2013-06-07','14:00:00',8.9),('10318','2013-06-07','14:05:00',8.88),('10318','2013-06-07','14:10:00',7.53),('10318','2013-06-07','14:15:00',8.08),('10318','2013-06-07','14:20:00',8.65),('10318','2013-06-07','14:25:00',8.6),('10318','2013-06-07','14:30:00',8.6),('10318','2013-06-07','14:35:00',6.39),('10318','2013-06-07','14:40:00',8.37),('10318','2013-06-07','14:45:00',8.31),('10318','2013-06-07','14:50:00',8.11),('10318','2013-06-07','14:55:00',7.53),('10318','2013-06-07','15:00:00',2.11),('10318','2013-06-07','15:05:00',8.23),('10318','2013-06-07','15:10:00',8.11),('10318','2013-06-07','15:15:00',7.3),('10318','2013-06-07','15:20:00',7.76),('10318','2013-06-07','15:25:00',7.7),('10318','2013-06-07','15:30:00',7.6),('10318','2013-06-07','15:35:00',7.38),('10318','2013-06-07','15:40:00',7.21),('10318','2013-06-07','15:45:00',7.1),('10318','2013-06-07','15:50:00',6.96),('10318','2013-06-07','15:55:00',6.9),('10318','2013-06-07','16:00:00',6.76),('10318','2013-06-07','16:05:00',6.63),('10318','2013-06-07','16:10:00',6.62),('10318','2013-06-07','16:15:00',6.46),('10318','2013-06-07','16:20:00',6.16),('10318','2013-06-07','16:25:00',5.89),('10318','2013-06-07','16:30:00',5.67),('10318','2013-06-07','16:35:00',5.42),('10318','2013-06-07','16:40:00',5.53),('10318','2013-06-07','16:45:00',5.38),('10318','2013-06-07','16:50:00',5.2),('10318','2013-06-07','16:55:00',4.99),('10318','2013-06-07','17:00:00',4.79),('10318','2013-06-07','17:05:00',4.63),('10318','2013-06-07','17:10:00',4.44),('10318','2013-06-07','17:15:00',4.32),('10318','2013-06-07','17:20:00',4.12),('10318','2013-06-07','17:25:00',3.96),('10318','2013-06-07','17:30:00',3.81),('10318','2013-06-07','17:35:00',3.7),('10318','2013-06-07','17:40:00',3.57),('10318','2013-06-07','17:45:00',3.47),('10318','2013-06-07','17:50:00',3.14),('10318','2013-06-07','17:55:00',2.54),('10318','2013-06-07','18:00:00',2.74),('10318','2013-06-07','18:05:00',2.65),('10318','2013-06-07','18:10:00',2.41),('10318','2013-06-07','18:15:00',2.21),('10318','2013-06-07','18:20:00',2.02),('10318','2013-06-07','18:25:00',1.76),('10318','2013-06-07','18:30:00',1.62),('10318','2013-06-07','18:35:00',1.5),('10318','2013-06-07','18:40:00',1.33),('10318','2013-06-07','18:45:00',1.21),('10318','2013-06-07','18:50:00',1.1),('10318','2013-06-06','06:55:00',1.56),('10318','2013-06-06','07:00:00',2.28),('10318','2013-06-06','07:05:00',2.51),('10318','2013-06-06','07:10:00',2.54),('10318','2013-06-06','07:15:00',2.24),('10318','2013-06-06','07:20:00',2.03),('10318','2013-06-06','07:25:00',1.43),('10318','2013-06-06','07:30:00',1.47),('10318','2013-06-06','07:35:00',1.49),('10318','2013-06-06','07:40:00',1.93),('10318','2013-06-06','07:45:00',2.24),('10318','2013-06-06','07:50:00',4.05),('10318','2013-06-06','07:55:00',4.17),('10318','2013-06-06','08:00:00',4.08),('10318','2013-06-06','08:05:00',3.21),('10318','2013-06-06','08:10:00',3.92),('10318','2013-06-06','08:15:00',3.45),('10318','2013-06-06','08:20:00',4.85),('10318','2013-06-06','08:25:00',5.21),('10318','2013-06-06','08:30:00',5.31),('10318','2013-06-06','08:35:00',5.61),('10318','2013-06-06','08:40:00',5.69),('10318','2013-06-06','08:45:00',5.82),('10318','2013-06-06','08:50:00',6.06),('10318','2013-06-06','08:55:00',6.23),('10318','2013-06-06','09:00:00',6.35),('10318','2013-06-06','09:05:00',6.52),('10318','2013-06-06','09:10:00',6.72),('10318','2013-06-06','09:15:00',6.82),('10318','2013-06-06','09:20:00',6.99),('10318','2013-06-06','09:25:00',7.16),('10318','2013-06-06','09:30:00',7.3),('10318','2013-06-06','09:35:00',7.44),('10318','2013-06-06','09:40:00',7.58),('10318','2013-06-06','09:45:00',7.73),('10318','2013-06-06','09:50:00',7.81),('10318','2013-06-06','09:55:00',7.92),('10318','2013-06-06','10:00:00',7.93),('10318','2013-06-06','10:05:00',8.11),('10318','2013-06-06','10:10:00',8.22),('10318','2013-06-06','10:15:00',8.11),('10318','2013-06-06','10:20:00',8.42),('10318','2013-06-06','10:25:00',8.49),('10318','2013-06-06','10:30:00',8.56),('10318','2013-06-06','10:35:00',8.63),('10318','2013-06-06','10:40:00',8.68),('10318','2013-06-06','10:45:00',8.69),('10318','2013-06-06','10:50:00',8.76),('10318','2013-06-06','10:55:00',8.93),('10318','2013-06-06','11:00:00',8.89),('10318','2013-06-06','11:05:00',9.1),('10318','2013-06-06','11:10:00',9.15),('10318','2013-06-06','11:15:00',9.18),('10318','2013-06-06','11:20:00',9.16),('10318','2013-06-06','11:25:00',9.23),('10318','2013-06-06','11:30:00',9.27),('10318','2013-06-06','11:35:00',9.36),('10318','2013-06-06','11:40:00',9.37),('10318','2013-06-06','11:45:00',9.2),('10318','2013-06-06','11:50:00',9.18),('10318','2013-06-06','11:55:00',8.86),('10318','2013-06-06','12:00:00',9.36),('10318','2013-06-06','12:05:00',6.67),('10318','2013-06-06','12:10:00',2.59),('10318','2013-06-06','12:15:00',7.16),('10318','2013-06-06','12:20:00',9.58),('10318','2013-06-06','12:25:00',9.6),('10318','2013-06-06','12:30:00',9.42),('10318','2013-06-06','12:35:00',9.47),('10318','2013-06-06','12:40:00',9.51),('10318','2013-06-06','12:45:00',9.43),('10318','2013-06-06','12:50:00',9.66),('10318','2013-06-06','12:55:00',10),('10318','2013-06-06','13:00:00',5.19),('10318','2013-06-06','13:05:00',3.31),('10318','2013-06-06','13:10:00',4.31),('10318','2013-06-06','13:15:00',9.99),('10318','2013-06-06','13:20:00',9.8),('10318','2013-06-06','13:25:00',9.66),('10318','2013-06-06','13:30:00',9.53),('10318','2013-06-06','13:35:00',9.62),('10318','2013-06-06','13:40:00',9.95),('10318','2013-06-06','13:45:00',9.39),('10318','2013-06-06','13:50:00',7.15),('10318','2013-06-06','13:55:00',9.22),('10318','2013-06-06','14:00:00',9.09),('10318','2013-06-06','14:05:00',9.04),('10318','2013-06-06','14:10:00',9.01),('10318','2013-06-06','14:15:00',8.88),('10318','2013-06-06','14:20:00',8.66),('10318','2013-06-06','14:25:00',7.45),('10318','2013-06-06','14:30:00',7.53),('10318','2013-06-06','14:35:00',6.45),('10318','2013-06-06','14:40:00',8.41),('10318','2013-06-06','14:45:00',8.4),('10318','2013-06-06','14:50:00',8.55),('10318','2013-06-06','14:55:00',8.29),('10318','2013-06-06','15:00:00',8.09),('10318','2013-06-06','15:05:00',8.06),('10318','2013-06-06','15:10:00',8.01),('10318','2013-06-06','15:15:00',7.69),('10318','2013-06-06','15:20:00',7.67),('10318','2013-06-06','15:25:00',7.66),('10318','2013-06-06','15:30:00',7.34),('10318','2013-06-06','15:35:00',7.23),('10318','2013-06-06','15:40:00',6.99),('10318','2013-06-06','15:45:00',6.88),('10318','2013-06-06','15:50:00',6.89),('10318','2013-06-06','15:55:00',6.87),('10318','2013-06-06','16:00:00',6.66),('10318','2013-06-06','16:05:00',6.55),('10318','2013-06-06','16:10:00',6.24),('10318','2013-06-06','16:15:00',6.2),('10318','2013-06-06','16:20:00',6.02),('10318','2013-06-06','16:25:00',5.89),('10318','2013-06-06','16:30:00',5.77),('10318','2013-06-06','16:35:00',5.65),('10318','2013-06-06','16:40:00',5.51),('10318','2013-06-06','16:45:00',5.29),('10318','2013-06-06','16:50:00',5.07),('10318','2013-06-06','16:55:00',4.86),('10318','2013-06-06','17:00:00',4.67),('10318','2013-06-06','17:05:00',4.52),('10318','2013-06-06','17:10:00',4.34),('10318','2013-06-06','17:15:00',4.16),('10318','2013-06-06','17:20:00',3.98),('10318','2013-06-06','17:25:00',3.86),('10318','2013-06-06','17:30:00',3.68),('10318','2013-06-06','17:35:00',3.4),('10318','2013-06-06','17:40:00',3.3),('10318','2013-06-06','17:45:00',3.13),('10318','2013-06-06','17:50:00',2.94),('10318','2013-06-06','17:55:00',2.78),('10318','2013-06-06','18:00:00',2.57),('10318','2013-06-06','18:05:00',2.41),('10318','2013-06-06','18:10:00',2.26),('10318','2013-06-06','18:15:00',2.11),('10318','2013-06-06','18:20:00',1.96),('10318','2013-06-06','18:25:00',1.8),('10318','2013-06-06','18:30:00',1.65),('10318','2013-06-06','18:35:00',1.47),('10318','2013-06-06','18:40:00',1.36),('10318','2013-06-06','18:45:00',1.22),('10318','2013-06-06','18:50:00',1.1),('10318','2013-06-06','18:55:00',1.01),('10318','2013-06-05','06:55:00',1),('10318','2013-06-05','07:00:00',1.23),('10318','2013-06-05','07:05:00',1.49),('10318','2013-06-05','07:10:00',1.69),('10318','2013-06-05','07:15:00',1.79),('10318','2013-06-05','07:20:00',1.35),('10318','2013-06-05','07:25:00',1.03),('10318','2013-06-05','07:30:00',1.39),('10318','2013-06-05','07:35:00',3.12),('10318','2013-06-05','07:40:00',2.34),('10318','2013-06-05','07:45:00',3.58),('10318','2013-06-05','07:50:00',4.78),('10318','2013-06-05','07:55:00',4.61),('10318','2013-06-05','08:00:00',4.4),('10318','2013-06-05','08:05:00',4.36),('10318','2013-06-05','08:10:00',4.61),('10318','2013-06-05','08:15:00',4.78),('10318','2013-06-05','08:20:00',5.03),('10318','2013-06-05','08:25:00',5.21),('10318','2013-06-05','08:30:00',5.29),('10318','2013-06-05','08:35:00',5.52),('10318','2013-06-05','08:40:00',5.73),('10318','2013-06-05','08:45:00',5.89),('10318','2013-06-05','08:50:00',6.09),('10318','2013-06-05','08:55:00',6.33),('10318','2013-06-05','09:00:00',6.43),('10318','2013-06-05','09:05:00',6.73),('10318','2013-06-05','09:10:00',7.07),('10318','2013-06-05','09:15:00',7.23),('10318','2013-06-05','09:20:00',7.5),('10318','2013-06-05','09:25:00',7.72),('10318','2013-06-05','09:30:00',8.41),('10318','2013-06-05','09:35:00',7.81),('10318','2013-06-05','09:40:00',8.52),('10318','2013-06-05','09:45:00',8.03),('10318','2013-06-05','09:50:00',2.63),('10318','2013-06-05','09:55:00',3.15),('10318','2013-06-05','10:00:00',3.57),('10318','2013-06-05','10:05:00',2.82),('10318','2013-06-05','10:10:00',2.98),('10318','2013-06-05','10:15:00',6.65),('10318','2013-06-05','10:20:00',4.4),('10318','2013-06-05','10:25:00',5.07),('10318','2013-06-05','10:30:00',4.53),('10318','2013-06-05','10:35:00',8.99),('10318','2013-06-05','10:40:00',9.93),('10318','2013-06-05','10:45:00',9.86),('10318','2013-06-05','10:50:00',9.56),('10318','2013-06-05','10:55:00',9.73),('10318','2013-06-05','11:00:00',9.87),('10318','2013-06-05','11:05:00',9.06),('10318','2013-06-05','11:10:00',10.19),('10318','2013-06-05','11:15:00',10.18),('10318','2013-06-05','11:20:00',9.55),('10318','2013-06-05','11:25:00',10.62),('10318','2013-06-05','11:30:00',8.36),('10318','2013-06-05','11:35:00',8.59),('10318','2013-06-05','11:40:00',8.38),('10318','2013-06-05','11:45:00',4.29),('10318','2013-06-05','11:50:00',10.73),('10318','2013-06-05','11:55:00',10.32),('10318','2013-06-05','12:00:00',10.6),('10318','2013-06-05','12:05:00',10.6),('10318','2013-06-05','12:10:00',10.66),('10318','2013-06-05','12:15:00',3.98),('10318','2013-06-05','12:20:00',3.55),('10318','2013-06-05','12:25:00',5.16),('10318','2013-06-05','12:30:00',9.63),('10318','2013-06-05','12:35:00',4.16),('10318','2013-06-05','12:40:00',9.88),('10318','2013-06-05','12:45:00',8.43),('10318','2013-06-05','12:50:00',8.99),('10318','2013-06-05','12:55:00',7.08),('10318','2013-06-05','13:00:00',4.36),('10318','2013-06-05','13:05:00',7.25),('10318','2013-06-05','13:10:00',10.5),('10318','2013-06-05','13:15:00',10.8),('10318','2013-06-05','13:20:00',10.62),('10318','2013-06-05','13:25:00',8.04),('10318','2013-06-05','13:30:00',9.89),('10318','2013-06-05','13:35:00',8.84),('10318','2013-06-05','13:40:00',10.17),('10318','2013-06-05','13:45:00',10.01),('10318','2013-06-05','13:50:00',9.73),('10318','2013-06-05','13:55:00',9.42),('10318','2013-06-05','14:00:00',9.61),('10318','2013-06-05','14:05:00',9.57),('10318','2013-06-05','14:10:00',9.46),('10318','2013-06-05','14:15:00',9.31),('10318','2013-06-05','14:20:00',7.23),('10318','2013-06-05','14:25:00',6.86),('10318','2013-06-05','14:30:00',9.04),('10318','2013-06-05','14:35:00',8.96),('10318','2013-06-05','14:40:00',6.95),('10318','2013-06-05','14:45:00',8.91),('10318','2013-06-05','14:50:00',8.69),('10318','2013-06-05','14:55:00',8.56),('10318','2013-06-05','15:00:00',8.44),('10318','2013-06-05','15:05:00',8.31),('10318','2013-06-05','15:10:00',8.24),('10318','2013-06-05','15:15:00',8.22),('10318','2013-06-05','15:20:00',6.05),('10318','2013-06-05','15:25:00',8.76),('10318','2013-06-05','15:30:00',7.82),('10318','2013-06-05','15:35:00',4.55),('10318','2013-06-05','15:40:00',6.88),('10318','2013-06-05','15:45:00',7.38),('10318','2013-06-05','15:50:00',7.29),('10318','2013-06-05','15:55:00',5.36),('10318','2013-06-05','16:00:00',6.57),('10318','2013-06-05','16:05:00',6.77),('10318','2013-06-05','16:10:00',6.81),('10318','2013-06-05','16:15:00',6.64),('10318','2013-06-05','16:20:00',6.46),('10318','2013-06-05','16:25:00',6.34),('10318','2013-06-05','16:30:00',5.51),('10318','2013-06-05','16:35:00',5.93),('10318','2013-06-05','16:40:00',5.17),('10318','2013-06-05','16:45:00',4.03),('10318','2013-06-05','16:50:00',5.48),('10318','2013-06-05','16:55:00',3.06),('10318','2013-06-05','17:00:00',3),('10318','2013-06-05','17:05:00',4.66),('10318','2013-06-05','17:10:00',5.09),('10318','2013-06-05','17:15:00',4.55),('10318','2013-06-05','17:20:00',3.6),('10318','2013-06-05','17:25:00',3.61),('10318','2013-06-05','17:30:00',3.86),('10318','2013-06-05','17:35:00',3.72),('10318','2013-06-05','17:40:00',3.45),('10318','2013-06-05','17:45:00',3.2),('10318','2013-06-05','17:50:00',3),('10318','2013-06-05','17:55:00',2.83),('10318','2013-06-05','18:00:00',2.34),('10318','2013-06-05','18:05:00',1.93),('10318','2013-06-05','18:10:00',2.42),('10318','2013-06-05','18:15:00',2.47),('10318','2013-06-05','18:20:00',1.79),('10318','2013-06-05','18:25:00',1.86),('10318','2013-06-05','18:30:00',1.79),('10318','2013-06-05','18:35:00',1.61),('10318','2013-06-05','18:40:00',1.19),('10318','2013-06-05','18:45:00',1.54),('10318','2013-06-05','18:50:00',1.67),('10318','2013-06-05','18:55:00',1.45),('10318','2013-06-05','19:00:00',1.25),('10318','2013-06-04','07:00:00',1.52),('10318','2013-06-04','07:05:00',1.99),('10318','2013-06-04','07:10:00',2.13),('10318','2013-06-04','07:15:00',2.46),('10318','2013-06-04','07:20:00',2.52),('10318','2013-06-04','07:25:00',2.71),('10318','2013-06-04','07:30:00',3.05),('10318','2013-06-04','07:35:00',2.87),('10318','2013-06-04','07:40:00',2.1),('10318','2013-06-04','07:45:00',3.69),('10318','2013-06-04','07:50:00',4.28),('10318','2013-06-04','07:55:00',5.16),('10318','2013-06-04','08:00:00',5.52),('10318','2013-06-04','08:05:00',5.77),('10318','2013-06-04','08:10:00',5.77),('10318','2013-06-04','08:15:00',5.83),('10318','2013-06-04','08:20:00',5.88),('10318','2013-06-04','08:25:00',5.91),('10318','2013-06-04','08:30:00',4.12),('10318','2013-06-04','08:35:00',4.04),('10318','2013-06-04','08:40:00',4.25),('10318','2013-06-04','08:45:00',3.26),('10318','2013-06-04','08:50:00',3.05),('10318','2013-06-04','08:55:00',3.49),('10318','2013-06-04','09:00:00',3.75),('10318','2013-06-04','09:05:00',5.42),('10318','2013-06-04','09:10:00',7.56),('10318','2013-06-04','09:15:00',8.77),('10318','2013-06-04','09:20:00',5.49),('10318','2013-06-04','09:25:00',7.82),('10318','2013-06-04','09:30:00',5.51),('10318','2013-06-04','09:35:00',3.62),('10318','2013-06-04','09:40:00',4.2),('10318','2013-06-04','09:45:00',5),('10318','2013-06-04','09:50:00',4.03),('10318','2013-06-04','09:55:00',4.16),('10318','2013-06-04','10:00:00',6.21),('10318','2013-06-04','10:05:00',5.12),('10318','2013-06-04','10:10:00',3.8),('10318','2013-06-04','10:15:00',4.08),('10318','2013-06-04','10:20:00',4.48),('10318','2013-06-04','10:25:00',3.84),('10318','2013-06-04','10:30:00',3.71),('10318','2013-06-04','10:35:00',3.91),('10318','2013-06-04','10:40:00',5.09),('10318','2013-06-04','10:45:00',7.01),('10318','2013-06-04','10:50:00',6.96),('10318','2013-06-04','10:55:00',5.67),('10318','2013-06-04','11:00:00',6.17),('10318','2013-06-04','11:05:00',8.21),('10318','2013-06-04','11:10:00',8.24),('10318','2013-06-04','11:15:00',6.02),('10318','2013-06-04','11:20:00',5.4),('10318','2013-06-04','11:25:00',6.32),('10318','2013-06-04','11:30:00',6.75),('10318','2013-06-04','11:35:00',7.14),('10318','2013-06-04','11:40:00',7.83),('10318','2013-06-04','11:45:00',7.64),('10318','2013-06-04','11:50:00',10.3),('10318','2013-06-04','11:55:00',8.83),('10318','2013-06-04','12:00:00',5.36),('10318','2013-06-04','12:05:00',4.67),('10318','2013-06-04','12:10:00',7.22),('10318','2013-06-04','12:15:00',5.19),('10318','2013-06-04','12:20:00',6.12),('10318','2013-06-04','12:25:00',3.85),('10318','2013-06-04','12:30:00',4.68),('10318','2013-06-04','12:35:00',7.29),('10318','2013-06-04','12:40:00',5.16),('10318','2013-06-04','12:45:00',3.46),('10318','2013-06-04','12:50:00',4),('10318','2013-06-04','12:55:00',6.93),('10318','2013-06-04','13:00:00',5.04),('10318','2013-06-04','13:05:00',2.81),('10318','2013-06-04','13:10:00',2.55),('10318','2013-06-04','13:15:00',3.04),('10318','2013-06-04','13:20:00',3.95),('10318','2013-06-04','13:25:00',7.34),('10318','2013-06-04','13:30:00',11.06),('10318','2013-06-04','13:35:00',10.96),('10318','2013-06-04','13:40:00',9.14),('10318','2013-06-04','13:45:00',10.02),('10318','2013-06-04','13:50:00',6.88),('10318','2013-06-04','13:55:00',7.7),('10318','2013-06-04','14:00:00',10.48),('10318','2013-06-04','14:05:00',9.61),('10318','2013-06-04','14:10:00',5.41),('10318','2013-06-04','14:15:00',8.41),('10318','2013-06-04','14:20:00',6.53),('10318','2013-06-04','14:25:00',2.21),('10318','2013-06-04','14:30:00',2.45),('10318','2013-06-04','14:35:00',3.43),('10318','2013-06-04','14:40:00',4.49),('10318','2013-06-04','14:45:00',3.02),('10318','2013-06-04','14:50:00',5.9),('10318','2013-06-04','14:55:00',10.49),('10318','2013-06-04','15:00:00',7.13),('10318','2013-06-04','15:05:00',9.45),('10318','2013-06-04','15:10:00',6.84),('10318','2013-06-04','15:15:00',3.2),('10318','2013-06-04','15:20:00',4.45),('10318','2013-06-04','15:25:00',2.91),('10318','2013-06-04','15:30:00',1.77),('10318','2013-06-04','15:50:00',1.18),('10318','2013-06-04','15:55:00',1.03),('10318','2013-06-04','17:10:00',1.27),('10318','2013-06-04','17:15:00',1.69),('10318','2013-06-04','17:20:00',1.5),('10318','2013-06-04','17:25:00',1.21),('10318','2013-06-04','17:30:00',1.04),('10318','2013-06-04','17:35:00',1.3),('10318','2013-06-04','17:40:00',1.74),('10318','2013-06-04','17:45:00',1.5),('10318','2013-06-04','17:50:00',1.37),('10318','2013-06-04','17:55:00',1.46),('10318','2013-06-04','18:00:00',1.58),('10318','2013-06-04','18:05:00',1.77),('10318','2013-06-04','18:10:00',1.58),('10318','2013-06-04','18:15:00',1.46),('10318','2013-06-04','18:20:00',1.44),('10318','2013-06-04','18:25:00',1.24),('10318','2013-06-04','18:30:00',1.03),('10318','2013-06-04','18:35:00',1.13),('10318','2013-06-04','18:40:00',1.73),('10318','2013-06-04','18:45:00',1.64),('10318','2013-06-04','18:50:00',1.63),('10318','2013-06-04','18:55:00',1.34),('10318','2013-06-04','19:00:00',1.23),('10318','2013-06-04','19:05:00',1.07),('10318','2013-06-03','06:40:00',1.05),('10318','2013-06-03','06:45:00',1.65),('10318','2013-06-03','06:50:00',1.41),('10318','2013-06-03','06:55:00',1.22),('10318','2013-06-03','07:00:00',1.32),('10318','2013-06-03','07:05:00',1.68),('10318','2013-06-03','07:10:00',1.6),('10318','2013-06-03','07:15:00',2.27),('10318','2013-06-03','07:20:00',2.69),('10318','2013-06-03','07:25:00',2.94),('10318','2013-06-03','07:30:00',1.68),('10318','2013-06-03','07:35:00',2.12),('10318','2013-06-03','07:40:00',3.55),('10318','2013-06-03','07:45:00',3.61),('10318','2013-06-03','07:50:00',3.88),('10318','2013-06-03','07:55:00',4.03),('10318','2013-06-03','08:00:00',4.3),('10318','2013-06-03','08:05:00',4.42),('10318','2013-06-03','08:10:00',4.53),('10318','2013-06-03','08:15:00',4.81),('10318','2013-06-03','08:20:00',4.99),('10318','2013-06-03','08:25:00',5.2),('10318','2013-06-03','08:30:00',5.34),('10318','2013-06-03','08:35:00',5.45),('10318','2013-06-03','08:40:00',5.8),('10318','2013-06-03','08:45:00',6),('10318','2013-06-03','08:50:00',6.16),('10318','2013-06-03','08:55:00',6.18),('10318','2013-06-03','09:00:00',6.34),('10318','2013-06-03','09:05:00',6.61),('10318','2013-06-03','09:10:00',6.83),('10318','2013-06-03','09:15:00',7.04),('10318','2013-06-03','09:20:00',4.9),('10318','2013-06-03','09:25:00',3.32),('10318','2013-06-03','09:30:00',3.15),('10318','2013-06-03','09:35:00',3.3),('10318','2013-06-03','09:40:00',5.82),('10318','2013-06-03','09:45:00',8),('10318','2013-06-03','09:50:00',6.06),('10318','2013-06-03','09:55:00',4.24),('10318','2013-06-03','10:00:00',3.39),('10318','2013-06-03','10:05:00',2.7),('10318','2013-06-03','10:10:00',2.01),('10318','2013-06-03','10:15:00',1.65),('10318','2013-06-03','10:20:00',1.68),('10318','2013-06-03','10:25:00',2.06),('10318','2013-06-03','10:30:00',2.47),('10318','2013-06-03','10:35:00',2.9),('10318','2013-06-03','10:40:00',3.08),('10318','2013-06-03','10:45:00',3.22),('10318','2013-06-03','10:50:00',3.52),('10318','2013-06-03','10:55:00',4.17),('10318','2013-06-03','11:00:00',5.02),('10318','2013-06-03','11:05:00',8.75),('10318','2013-06-03','11:10:00',10.38),('10318','2013-06-03','11:15:00',7.18),('10318','2013-06-03','11:20:00',6.96),('10318','2013-06-03','11:25:00',6.82),('10318','2013-06-03','11:30:00',5.14),('10318','2013-06-03','11:35:00',8.6),('10318','2013-06-03','11:40:00',6.96),('10318','2013-06-03','11:45:00',3.4),('10318','2013-06-03','11:50:00',5.01),('10318','2013-06-03','11:55:00',3.6),('10318','2013-06-03','12:00:00',4.67),('10318','2013-06-03','12:05:00',5.32),('10318','2013-06-03','12:10:00',5.18),('10318','2013-06-03','12:15:00',2.78),('10318','2013-06-03','12:20:00',2.91),('10318','2013-06-03','12:25:00',2.99),('10318','2013-06-03','12:30:00',2.86),('10318','2013-06-03','12:35:00',2.5),('10318','2013-06-03','12:40:00',2.84),('10318','2013-06-03','12:45:00',3.8),('10318','2013-06-03','12:50:00',6.97),('10318','2013-06-03','12:55:00',10.77),('10318','2013-06-03','13:00:00',7.54),('10318','2013-06-03','13:05:00',6.23),('10318','2013-06-03','13:10:00',6.67),('10318','2013-06-03','13:15:00',4.87),('10318','2013-06-03','13:20:00',7.24),('10318','2013-06-03','13:25:00',10.19),('10318','2013-06-03','13:30:00',10.78),('10318','2013-06-03','13:35:00',6.36),('10318','2013-06-03','13:40:00',7.57),('10318','2013-06-03','13:45:00',10.38),('10318','2013-06-03','13:50:00',10.27),('10318','2013-06-03','13:55:00',9.3),('10318','2013-06-03','14:00:00',9.1),('10318','2013-06-03','14:05:00',5.85),('10318','2013-06-03','14:10:00',7.21),('10318','2013-06-03','14:15:00',4.33),('10318','2013-06-03','14:20:00',4.93),('10318','2013-06-03','14:25:00',8.75),('10318','2013-06-03','14:30:00',4.75),('10318','2013-06-03','14:35:00',8.54),('10318','2013-06-03','14:40:00',9.87),('10318','2013-06-03','14:45:00',6.34),('10318','2013-06-03','14:50:00',6.31),('10318','2013-06-03','14:55:00',7.64),('10318','2013-06-03','15:00:00',4.08),('10318','2013-06-03','15:05:00',5.31),('10318','2013-06-03','15:10:00',7.57),('10318','2013-06-03','15:15:00',8.14),('10318','2013-06-03','15:20:00',5.15),('10318','2013-06-03','15:25:00',5.01),('10318','2013-06-03','15:30:00',8.32),('10318','2013-06-03','15:35:00',7.88),('10318','2013-06-03','15:40:00',7.76),('10318','2013-06-03','15:45:00',7.59),('10318','2013-06-03','15:50:00',7.42),('10318','2013-06-03','15:55:00',7.27),('10318','2013-06-03','16:00:00',7.19),('10318','2013-06-03','16:05:00',7.06),('10318','2013-06-03','16:10:00',6.9),('10318','2013-06-03','16:15:00',6.19),('10318','2013-06-03','16:20:00',6.15),('10318','2013-06-03','16:25:00',6.2),('10318','2013-06-03','16:30:00',6.1),('10318','2013-06-03','16:35:00',5.77),('10318','2013-06-03','16:40:00',5.39),('10318','2013-06-03','16:45:00',4.87),('10318','2013-06-03','16:50:00',4.15),('10318','2013-06-03','16:55:00',4.3),('10318','2013-06-03','17:00:00',5.87),('10318','2013-06-03','17:05:00',5.92),('10318','2013-06-03','17:10:00',5.82),('10318','2013-06-03','17:15:00',4.75),('10318','2013-06-03','17:20:00',4.17),('10318','2013-06-03','17:25:00',3.65),('10318','2013-06-03','17:30:00',2.11),('10318','2013-06-03','17:35:00',1.72),('10318','2013-06-03','17:40:00',1.7),('10318','2013-06-03','17:45:00',1.4),('10318','2013-06-03','17:50:00',1.59),('10318','2013-06-03','17:55:00',1.54),('10318','2013-06-03','18:00:00',1.2),('10318','2013-06-03','18:05:00',1.06),('10318','2013-06-03','18:55:00',1),('10318','2013-06-03','19:00:00',1.16),('10318','2013-06-03','19:05:00',1.16),('10318','2013-06-02','06:45:00',1.19),('10318','2013-06-02','06:50:00',1.96),('10318','2013-06-02','06:55:00',2.49),('10318','2013-06-02','07:00:00',2.2),('10318','2013-06-02','07:05:00',1.99),('10318','2013-06-02','07:10:00',1.1),('10318','2013-06-02','07:15:00',1.15),('10318','2013-06-02','08:20:00',1.3),('10318','2013-06-02','08:25:00',1.63),('10318','2013-06-02','08:30:00',1.89),('10318','2013-06-02','08:35:00',2.15),('10318','2013-06-02','08:40:00',2.33),('10318','2013-06-02','08:45:00',2.74),('10318','2013-06-02','08:50:00',2.03),('10318','2013-06-02','08:55:00',2),('10318','2013-06-02','09:00:00',2.04),('10318','2013-06-02','09:05:00',2.26),('10318','2013-06-02','09:10:00',2.47),('10318','2013-06-02','09:15:00',2.69),('10318','2013-06-02','09:20:00',6.66),('10318','2013-06-02','09:25:00',7.17),('10318','2013-06-02','09:30:00',7.98),('10318','2013-06-02','09:35:00',7.86),('10318','2013-06-02','09:40:00',7.87),('10318','2013-06-02','09:45:00',7.95),('10318','2013-06-02','09:50:00',7.98),('10318','2013-06-02','09:55:00',8.17),('10318','2013-06-02','10:00:00',8.25),('10318','2013-06-02','10:05:00',8.44),('10318','2013-06-02','10:10:00',6.98),('10318','2013-06-02','10:15:00',8.69),('10318','2013-06-02','10:20:00',8.79),('10318','2013-06-02','10:25:00',8.3),('10318','2013-06-02','10:30:00',8.74),('10318','2013-06-02','10:35:00',5.52),('10318','2013-06-02','10:40:00',9.93),('10318','2013-06-02','10:45:00',8.01),('10318','2013-06-02','10:50:00',7.6),('10318','2013-06-02','10:55:00',9.96),('10318','2013-06-02','11:00:00',10.24),('10318','2013-06-02','11:05:00',10.57),('10318','2013-06-02','11:10:00',8.38),('10318','2013-06-02','11:15:00',3.42),('10318','2013-06-02','11:20:00',5.43),('10318','2013-06-02','11:25:00',5.94),('10318','2013-06-02','11:30:00',5.47),('10318','2013-06-02','11:35:00',6.23),('10318','2013-06-02','11:40:00',9.76),('10318','2013-06-02','11:45:00',8.68),('10318','2013-06-02','11:50:00',4.17),('10318','2013-06-02','11:55:00',8.69),('10318','2013-06-02','12:00:00',8.32),('10318','2013-06-02','12:05:00',11.14),('10318','2013-06-02','12:10:00',4.47),('10318','2013-06-02','12:15:00',6.16),('10318','2013-06-02','12:20:00',8.71),('10318','2013-06-02','12:25:00',10.65),('10318','2013-06-02','12:30:00',10.14),('10318','2013-06-02','12:35:00',10.57),('10318','2013-06-02','12:40:00',9.27),('10318','2013-06-02','12:45:00',8.22),('10318','2013-06-02','12:50:00',7.95),('10318','2013-06-02','12:55:00',4.37),('10318','2013-06-02','13:00:00',10.73),('10318','2013-06-02','13:05:00',9.71),('10318','2013-06-02','13:10:00',9.39),('10318','2013-06-02','13:15:00',10.07),('10318','2013-06-02','13:20:00',9.92),('10318','2013-06-02','13:25:00',9.79),('10318','2013-06-02','13:30:00',9.77),('10318','2013-06-02','13:35:00',9.64),('10318','2013-06-02','13:40:00',9.62),('10318','2013-06-02','13:45:00',9.57),('10318','2013-06-02','13:50:00',9.66),('10318','2013-06-02','13:55:00',9.51),('10318','2013-06-02','14:00:00',9.53),('10318','2013-06-02','14:05:00',9.26),('10318','2013-06-02','14:10:00',9.41),('10318','2013-06-02','14:15:00',9.28),('10318','2013-06-02','14:20:00',9.2),('10318','2013-06-02','14:25:00',9.1),('10318','2013-06-02','14:30:00',6.8),('10318','2013-06-02','14:35:00',9.09),('10318','2013-06-02','14:40:00',8.95),('10318','2013-06-02','14:45:00',8.79),('10318','2013-06-02','14:50:00',8.7),('10318','2013-06-02','14:55:00',8.58),('10318','2013-06-02','15:00:00',8.48),('10318','2013-06-02','15:05:00',6.35),('10318','2013-06-02','15:10:00',7.91),('10318','2013-06-02','15:15:00',5.43),('10318','2013-06-02','15:20:00',6.74),('10318','2013-06-02','15:25:00',6.34),('10318','2013-06-02','15:30:00',8.15),('10318','2013-06-02','15:35:00',7.83),('10318','2013-06-02','15:40:00',6.06),('10318','2013-06-02','15:45:00',7.38),('10318','2013-06-02','15:50:00',7.01),('10318','2013-06-02','15:55:00',6.62),('10318','2013-06-02','16:00:00',5.21),('10318','2013-06-02','16:05:00',6.24),('10318','2013-06-02','16:10:00',5.37),('10318','2013-06-02','16:15:00',6.07),('10318','2013-06-02','16:20:00',4.77),('10318','2013-06-02','16:25:00',3.83),('10318','2013-06-02','16:30:00',4.28),('10318','2013-06-02','16:35:00',6.27),('10318','2013-06-02','16:40:00',5.61),('10318','2013-06-02','16:45:00',5.61),('10318','2013-06-02','16:50:00',4.88),('10318','2013-06-02','16:55:00',3.69),('10318','2013-06-02','17:00:00',5.24),('10318','2013-06-02','17:05:00',4.66),('10318','2013-06-02','17:10:00',4.11),('10318','2013-06-02','17:15:00',3.8),('10318','2013-06-02','17:20:00',4.35),('10318','2013-06-02','17:25:00',3.89),('10318','2013-06-02','17:30:00',3.11),('10318','2013-06-02','17:35:00',3.62),('10318','2013-06-02','17:40:00',2.43),('10318','2013-06-02','17:45:00',2.36),('10318','2013-06-02','17:50:00',1.96),('10318','2013-06-02','17:55:00',1.67),('10318','2013-06-02','18:00:00',2.15),('10318','2013-06-02','18:05:00',1.78),('10318','2013-06-02','18:10:00',1.94),('10318','2013-06-02','18:15:00',2.25),('10318','2013-06-02','18:20:00',1.92),('10318','2013-06-02','18:25:00',1.62),('10318','2013-06-02','18:30:00',1.64),('10318','2013-06-02','18:35:00',1.57),('10318','2013-06-02','18:40:00',1.5),('10318','2013-06-02','18:45:00',1.68),('10318','2013-06-02','18:50:00',1.37),('10318','2013-06-02','19:05:00',1),('10318','2013-06-02','19:10:00',1.07),('10318','2013-06-01','06:50:00',1.13),('10318','2013-06-01','06:55:00',1.49),('10318','2013-06-01','07:00:00',1.63),('10318','2013-06-01','07:05:00',1.99),('10318','2013-06-01','07:10:00',2.19),('10318','2013-06-01','07:15:00',2.52),('10318','2013-06-01','07:20:00',2.82),('10318','2013-06-01','07:25:00',3.06),('10318','2013-06-01','07:30:00',3.3),('10318','2013-06-01','07:35:00',3.52),('10318','2013-06-01','07:40:00',3.75),('10318','2013-06-01','07:45:00',4.23),('10318','2013-06-01','07:50:00',4.28),('10318','2013-06-01','07:55:00',2.51),('10318','2013-06-01','08:00:00',1.67),('10318','2013-06-01','08:05:00',1.51),('10318','2013-06-01','08:10:00',2.72),('10318','2013-06-01','08:15:00',3.26),('10318','2013-06-01','08:20:00',1.51),('10318','2013-06-01','08:25:00',1.52),('10318','2013-06-01','08:30:00',3.05),('10318','2013-06-01','08:35:00',3.05),('10318','2013-06-01','08:40:00',1.65),('10318','2013-06-01','08:45:00',1.94),('10318','2013-06-01','08:50:00',2.15),('10318','2013-06-01','08:55:00',4.67),('10318','2013-06-01','09:00:00',4.84),('10318','2013-06-01','09:05:00',1.09),('10318','2013-06-01','09:35:00',1),('10318','2013-06-01','09:40:00',1.48),('10318','2013-06-01','09:45:00',2.19),('10318','2013-06-01','09:50:00',1.69),('10318','2013-06-01','09:55:00',1.38),('10318','2013-06-01','10:00:00',1.5),('10318','2013-06-01','10:05:00',1.65),('10318','2013-06-01','10:10:00',1.38),('10318','2013-06-01','10:15:00',1.08),('10318','2013-06-01','10:20:00',1.12),('10318','2013-06-01','10:25:00',1.98),('10318','2013-06-01','10:30:00',2.56),('10318','2013-06-01','10:35:00',3.37),('10318','2013-06-01','10:40:00',2.74),('10318','2013-06-01','10:45:00',3.91),('10318','2013-06-01','10:50:00',9.67),('10318','2013-06-01','10:55:00',3.14),('10318','2013-06-01','11:00:00',1.01),('10318','2013-06-01','11:05:00',1.49),('10318','2013-06-01','11:10:00',1.28),('10318','2013-06-01','11:45:00',1.59),('10318','2013-06-01','11:50:00',3.07),('10318','2013-06-01','11:55:00',5.36),('10318','2013-06-01','12:00:00',10.59),('10318','2013-06-01','12:05:00',8.73),('10318','2013-06-01','12:10:00',3.93),('10318','2013-06-01','12:15:00',2.56),('10318','2013-06-01','12:20:00',1.86),('10318','2013-06-01','12:25:00',2.98),('10318','2013-06-01','12:30:00',2.31),('10318','2013-06-01','12:35:00',1.97),('10318','2013-06-01','12:40:00',2.53),('10318','2013-06-01','12:45:00',4.04),('10318','2013-06-01','12:50:00',4.64),('10318','2013-06-01','12:55:00',4.93),('10318','2013-06-01','13:00:00',5.08),('10318','2013-06-01','13:05:00',4.87),('10318','2013-06-01','13:10:00',5.25),('10318','2013-06-01','13:15:00',5.46),('10318','2013-06-01','13:20:00',4.61),('10318','2013-06-01','13:25:00',3.98),('10318','2013-06-01','13:30:00',3.41),('10318','2013-06-01','13:35:00',2.6),('10318','2013-06-01','13:40:00',2.3),('10318','2013-06-01','13:45:00',2.34),('10318','2013-06-01','13:50:00',2.77),('10318','2013-06-01','13:55:00',3.51),('10318','2013-06-01','14:00:00',5.59),('10318','2013-06-01','14:05:00',5.44),('10318','2013-06-01','14:10:00',5.23),('10318','2013-06-01','14:15:00',4.92),('10318','2013-06-01','14:20:00',4.36),('10318','2013-06-01','14:25:00',3.68),('10318','2013-06-01','14:30:00',3.27),('10318','2013-06-01','14:35:00',3.03),('10318','2013-06-01','14:40:00',2.65),('10318','2013-06-01','14:45:00',2.35),('10318','2013-06-01','14:50:00',2.4),('10318','2013-06-01','14:55:00',2.01),('10318','2013-06-01','15:00:00',1.88),('10318','2013-06-01','15:05:00',1.6),('10318','2013-06-01','15:10:00',1.71),('10318','2013-06-01','15:15:00',1.77),('10318','2013-06-01','15:20:00',1.71),('10318','2013-06-01','15:25:00',1.6),('10318','2013-06-01','15:30:00',1.71),('10318','2013-06-01','15:35:00',1.87),('10318','2013-06-01','15:40:00',2.49),('10318','2013-06-01','15:45:00',2.68),('10318','2013-06-01','15:50:00',2.24),('10318','2013-06-01','15:55:00',2.93),('10318','2013-06-01','16:00:00',2.63),('10318','2013-06-01','16:05:00',2.35),('10318','2013-06-01','16:10:00',1.76),('10318','2013-06-01','16:15:00',2.03),('10318','2013-06-01','16:20:00',1.8),('10318','2013-06-01','16:25:00',1.62),('10318','2013-06-01','16:30:00',1.89),('10318','2013-06-01','16:35:00',1.92),('10318','2013-06-01','16:40:00',2.04),('10318','2013-06-01','16:45:00',1.85),('10318','2013-06-01','16:50:00',2.04),('10318','2013-06-01','16:55:00',1.89),('10318','2013-06-01','18:20:00',1.18),('10318','2013-06-01','18:25:00',2.04),('10318','2013-06-01','18:30:00',2.28),('10318','2013-06-01','18:35:00',1.72),('10318','2013-06-01','18:40:00',1.38),('10318','2013-06-01','18:45:00',1.55),('10318','2013-06-01','18:50:00',1.49),('10318','2013-06-01','18:55:00',2.06),('10318','2013-06-01','19:00:00',1.77),('10318','2013-06-01','19:05:00',1.16),('10318','2014-04-02','07:55:00',1.11),('10318','2014-04-02','08:00:00',1.15),('10318','2014-04-02','08:25:00',1.44),('10318','2014-04-02','08:30:00',2.06),('10318','2014-04-02','08:35:00',1.97),('10318','2014-04-02','08:40:00',1.66),('10318','2014-04-02','08:45:00',1.86),('10318','2014-04-02','08:50:00',1.66),('10318','2014-04-02','09:20:00',1.13),('10318','2014-04-02','09:25:00',1.22),('10318','2014-04-02','09:30:00',1.43),('10318','2014-04-02','09:35:00',1.45),('10318','2014-04-02','09:40:00',2.48),('10318','2014-04-02','09:45:00',6.16),('10318','2014-04-02','09:50:00',5.76),('10318','2014-04-02','09:55:00',4.04),('10318','2014-04-02','10:00:00',6.85),('10318','2014-04-02','10:05:00',3.6),('10318','2014-04-02','10:10:00',3.82),('10318','2014-04-02','10:15:00',4.49),('10318','2014-04-02','10:20:00',2.81),('10318','2014-04-02','10:25:00',2.21),('10318','2014-04-02','10:30:00',1.95),('10318','2014-04-02','10:35:00',2.19),('10318','2014-04-02','10:40:00',2.83),('10318','2014-04-02','10:45:00',2.97),('10318','2014-04-02','10:50:00',3.6),('10318','2014-04-02','10:55:00',3.24),('10318','2014-04-02','11:00:00',3.42),('10318','2014-04-02','11:05:00',8.4),('10318','2014-04-02','11:10:00',9.57),('10318','2014-04-02','11:15:00',10.41),('10318','2014-04-02','11:20:00',8.16),('10318','2014-04-02','11:25:00',8.99),('10318','2014-04-02','11:30:00',5.8),('10318','2014-04-02','11:35:00',6.83),('10318','2014-04-02','11:40:00',10.29),('10318','2014-04-02','11:45:00',10.58),('10318','2014-04-02','11:50:00',10.73),('10318','2014-04-02','11:55:00',5.36),('10318','2014-04-02','12:00:00',3.9),('10318','2014-04-02','12:05:00',10.07),('10318','2014-04-02','12:10:00',10.09),('10318','2014-04-02','12:15:00',7.13),('10318','2014-04-02','12:20:00',4.62),('10318','2014-04-02','12:25:00',3.07),('10318','2014-04-02','12:30:00',2.77),('10318','2014-04-02','12:35:00',2.54),('10318','2014-04-02','12:40:00',9.7),('10318','2014-04-02','12:45:00',10.1),('10318','2014-04-02','12:50:00',7.42),('10318','2014-04-02','12:55:00',8.54),('10318','2014-04-02','13:00:00',5.42),('10318','2014-04-02','13:05:00',8.96),('10318','2014-04-02','13:10:00',6.44),('10318','2014-04-02','13:15:00',4.52),('10318','2014-04-02','13:20:00',10.22),('10318','2014-04-02','13:25:00',9.82),('10318','2014-04-02','13:30:00',9.08),('10318','2014-04-02','13:35:00',7.78),('10318','2014-04-02','13:40:00',9.91),('10318','2014-04-02','13:45:00',7.67),('10318','2014-04-02','13:50:00',5.69),('10318','2014-04-02','13:55:00',7.08),('10318','2014-04-02','14:00:00',6.57),('10318','2014-04-02','14:05:00',9.59),('10318','2014-04-02','14:10:00',9.17),('10318','2014-04-02','14:15:00',7.03),('10318','2014-04-02','14:20:00',8.94),('10318','2014-04-02','14:25:00',8.69),('10318','2014-04-02','14:30:00',8.59),('10318','2014-04-02','14:35:00',7.96),('10318','2014-04-02','14:40:00',6.04),('10318','2014-04-02','14:45:00',8.57),('10318','2014-04-02','14:50:00',6.93),('10318','2014-04-02','14:55:00',7.74),('10318','2014-04-02','15:00:00',7.9),('10318','2014-04-02','15:05:00',7.78),('10318','2014-04-02','15:10:00',7.38),('10318','2014-04-02','15:15:00',7.35),('10318','2014-04-02','15:20:00',7.32),('10318','2014-04-02','15:25:00',7),('10318','2014-04-02','15:30:00',6.54),('10318','2014-04-02','15:35:00',6.36),('10318','2014-04-02','15:40:00',6.85),('10318','2014-04-02','15:45:00',6.78),('10318','2014-04-02','15:50:00',6.56),('10318','2014-04-02','15:55:00',5.72),('10318','2014-04-02','16:00:00',6.1),('10318','2014-04-02','16:05:00',5.91),('10318','2014-04-02','16:10:00',5.73),('10318','2014-04-02','16:15:00',5.49),('10318','2014-04-02','16:20:00',5.31),('10318','2014-04-02','16:25:00',5.3),('10318','2014-04-02','16:30:00',5.18),('10318','2014-04-02','16:35:00',4.89),('10318','2014-04-02','16:40:00',4.75),('10318','2014-04-02','16:45:00',4.51),('10318','2014-04-02','16:50:00',4.08),('10318','2014-04-02','16:55:00',4.19),('10318','2014-04-02','17:00:00',4.1),('10318','2014-04-02','17:05:00',3.62),('10318','2014-04-02','17:10:00',3.46),('10318','2014-04-02','17:15:00',3.13),('10318','2014-04-02','17:20:00',3.03),('10318','2014-04-02','17:25:00',2.87),('10318','2014-04-02','17:30:00',2.56),('10318','2014-04-02','17:35:00',2.52),('10318','2014-04-02','17:40:00',1.87),('10318','2014-04-02','17:45:00',1.98),('10318','2014-04-02','17:50:00',2.33),('10318','2014-04-02','17:55:00',1.93),('10318','2014-04-02','18:00:00',1.69),('10318','2014-04-02','18:05:00',1.15),('10318','2014-04-02','18:10:00',1.09),('10318','2014-04-02','18:15:00',1.08),('10318','2014-04-02','18:20:00',1.07),('10318','2013-05-31','06:50:00',1.15),('10318','2013-05-31','06:55:00',1.44),('10318','2013-05-31','07:00:00',1.67),('10318','2013-05-31','07:05:00',1.93),('10318','2013-05-31','07:10:00',2.14),('10318','2013-05-31','07:15:00',2.43),('10318','2013-05-31','07:20:00',2.75),('10318','2013-05-31','07:25:00',3.07),('10318','2013-05-31','07:30:00',3.28),('10318','2013-05-31','07:35:00',3.49),('10318','2013-05-31','07:40:00',3.67),('10318','2013-05-31','07:45:00',3.87),('10318','2013-05-31','07:50:00',4.08),('10318','2013-05-31','07:55:00',4.38),('10318','2013-05-31','08:00:00',4.57),('10318','2013-05-31','08:05:00',4.7),('10318','2013-05-31','08:10:00',4.93),('10318','2013-05-31','08:15:00',5.15),('10318','2013-05-31','08:20:00',5.4),('10318','2013-05-31','08:25:00',4.93),('10318','2013-05-31','08:30:00',5.9),('10318','2013-05-31','08:35:00',4.08),('10318','2013-05-31','08:40:00',4.92),('10318','2013-05-31','08:45:00',5.98),('10318','2013-05-31','08:50:00',5.24),('10318','2013-05-31','08:55:00',3.5),('10318','2013-05-31','09:00:00',2.78),('10318','2013-05-31','09:05:00',4.82),('10318','2013-05-31','09:10:00',5.23),('10318','2013-05-31','09:15:00',2.28),('10318','2013-05-31','09:20:00',2.13),('10318','2013-05-31','09:25:00',5.55),('10318','2013-05-31','09:30:00',3.41),('10318','2013-05-31','09:35:00',4.45),('10318','2013-05-31','09:40:00',8.9),('10318','2013-05-31','09:45:00',7.66),('10318','2013-05-31','09:50:00',8.31),('10318','2013-05-31','09:55:00',6.47),('10318','2013-05-31','10:00:00',7.9),('10318','2013-05-31','10:05:00',7.64),('10318','2013-05-31','10:10:00',7.34),('10318','2013-05-31','10:15:00',10.97),('10318','2013-05-31','10:20:00',2.35),('10318','2013-05-31','10:25:00',2.05),('10318','2013-05-31','10:30:00',6.67),('10318','2013-05-31','10:35:00',5.41),('10318','2013-05-31','10:40:00',8.01),('10318','2013-05-31','10:45:00',6.48),('10318','2013-05-31','10:50:00',3.02),('10318','2013-05-31','10:55:00',3.12),('10318','2013-05-31','11:00:00',3.6),('10318','2013-05-31','11:05:00',7.59),('10318','2013-05-31','11:10:00',6.74),('10318','2013-05-31','11:15:00',3.72),('10318','2013-05-31','11:20:00',6.6),('10318','2013-05-31','11:25:00',3.01),('10318','2013-05-31','11:30:00',2.71),('10318','2013-05-31','11:35:00',2.14),('10318','2013-05-31','11:40:00',5),('10318','2013-05-31','11:45:00',8.55),('10318','2013-05-31','11:50:00',7.56),('10318','2013-05-31','11:55:00',7.2),('10318','2013-05-31','12:00:00',7.15),('10318','2013-05-31','12:05:00',6.84),('10318','2013-05-31','12:10:00',5.08),('10318','2013-05-31','12:15:00',5.05),('10318','2013-05-31','12:20:00',8.04),('10318','2013-05-31','12:25:00',10.95),('10318','2013-05-31','12:30:00',3.84),('10318','2013-05-31','12:35:00',6.26),('10318','2013-05-31','12:40:00',8.49),('10318','2013-05-31','12:45:00',2.65),('10318','2013-05-31','12:50:00',3.27),('10318','2013-05-31','12:55:00',8.15),('10318','2013-05-31','13:00:00',9.21),('10318','2013-05-31','13:05:00',2.53),('10318','2013-05-31','13:10:00',1.5),('10318','2013-05-31','13:15:00',2.14),('10318','2013-05-31','13:20:00',5.11),('10318','2013-05-31','13:25:00',4.44),('10318','2013-05-31','13:30:00',6.77),('10318','2013-05-31','13:35:00',5.37),('10318','2013-05-31','13:40:00',4.11),('10318','2013-05-31','13:45:00',3.85),('10318','2013-05-31','13:50:00',3.41),('10318','2013-05-31','13:55:00',4.76),('10318','2013-05-31','14:00:00',3.18),('10318','2013-05-31','14:05:00',2.18),('10318','2013-05-31','14:10:00',1.38),('10318','2013-05-31','14:15:00',1.27),('10318','2013-05-31','14:20:00',1.88),('10318','2013-05-31','14:25:00',2.59),('10318','2013-05-31','14:30:00',2.32),('10318','2013-05-31','14:40:00',1.11),('10318','2013-05-31','14:45:00',2.05),('10318','2013-05-31','14:50:00',1.72),('10318','2013-05-31','14:55:00',1.24),('10318','2013-05-31','15:00:00',2.5),('10318','2013-05-31','15:05:00',3.52),('10318','2013-05-31','15:10:00',4.07),('10318','2013-05-31','15:15:00',7.34),('10318','2013-05-31','15:20:00',7.31),('10318','2013-05-31','15:25:00',6.51),('10318','2013-05-31','15:30:00',4.97),('10318','2013-05-31','15:35:00',4.46),('10318','2013-05-31','15:40:00',3.69),('10318','2013-05-31','15:45:00',4.37),('10318','2013-05-31','15:50:00',6.39),('10318','2013-05-31','15:55:00',5.22),('10318','2013-05-31','16:00:00',3.07),('10318','2013-05-31','16:05:00',2.49),('10318','2013-05-31','16:10:00',2.02),('10318','2013-05-31','16:15:00',1.83),('10318','2013-05-31','16:20:00',2.75),('10318','2013-05-31','16:25:00',3),('10318','2013-05-31','16:30:00',2.38),('10318','2013-05-31','16:35:00',2.26),('10318','2013-05-31','16:40:00',2.69),('10318','2013-05-31','16:45:00',2.47),('10318','2013-05-31','16:50:00',1.65),('10318','2013-05-31','16:55:00',1.3),('10318','2013-05-31','17:00:00',1.37),('10318','2013-05-31','17:05:00',1.37),('10318','2013-05-31','17:10:00',1.4),('10318','2013-05-31','17:15:00',1.45),('10318','2013-05-31','17:20:00',1.61),('10318','2013-05-31','17:25:00',1.76),('10318','2013-05-31','17:30:00',1.72),('10318','2013-05-31','17:35:00',1.56),('10318','2013-05-31','17:40:00',1.35),('10318','2013-05-31','17:45:00',1.19),('10318','2013-05-31','17:50:00',1.05),('10318','2013-05-31','18:05:00',1.08),('10318','2013-05-31','18:10:00',1.02),('10318','2013-05-31','18:30:00',1.27),('10318','2013-05-30','07:35:00',1.19),('10318','2013-05-30','07:40:00',2.83),('10318','2013-05-30','07:45:00',3.39),('10318','2013-05-30','07:50:00',2.06),('10318','2013-05-30','07:55:00',1.92),('10318','2013-05-30','08:00:00',1.57),('10318','2013-05-30','08:05:00',1.46),('10318','2013-05-30','08:10:00',1.89),('10318','2013-05-30','08:15:00',2.22),('10318','2013-05-30','08:20:00',2.05),('10318','2013-05-30','08:25:00',2.03),('10318','2013-05-30','08:30:00',1.68),('10318','2013-05-30','08:35:00',5.22),('10318','2013-05-30','08:40:00',6.41),('10318','2013-05-30','08:45:00',6.47),('10318','2013-05-30','08:50:00',6.58),('10318','2013-05-30','08:55:00',6.72),('10318','2013-05-30','09:00:00',6.86),('10318','2013-05-30','09:05:00',7.07),('10318','2013-05-30','09:10:00',7.19),('10318','2013-05-30','09:15:00',7.32),('10318','2013-05-30','09:20:00',7.68),('10318','2013-05-30','09:25:00',4.24),('10318','2013-05-30','09:30:00',8.28),('10318','2013-05-30','09:35:00',7.67),('10318','2013-05-30','09:40:00',7.49),('10318','2013-05-30','09:45:00',7.48),('10318','2013-05-30','09:50:00',6.65),('10318','2013-05-30','09:55:00',2.71),('10318','2013-05-30','10:00:00',2.23),('10318','2013-05-30','10:05:00',4.37),('10318','2013-05-30','10:10:00',5.49),('10318','2013-05-30','10:15:00',7.03),('10318','2013-05-30','10:20:00',4.85),('10318','2013-05-30','10:25:00',2.46),('10318','2013-05-30','10:30:00',2.26),('10318','2013-05-30','10:35:00',3.27),('10318','2013-05-30','10:40:00',8.58),('10318','2013-05-30','10:45:00',10.39),('10318','2013-05-30','10:50:00',7.54),('10318','2013-05-30','10:55:00',6.98),('10318','2013-05-30','11:00:00',4.78),('10318','2013-05-30','11:05:00',3.26),('10318','2013-05-30','11:10:00',4.59),('10318','2013-05-30','11:15:00',10.83),('10318','2013-05-30','11:20:00',5.04),('10318','2013-05-30','11:25:00',4.37),('10318','2013-05-30','11:30:00',9.64),('10318','2013-05-30','11:35:00',10.64),('10318','2013-05-30','11:40:00',4.12),('10318','2013-05-30','11:45:00',10.77),('10318','2013-05-30','11:50:00',8.02),('10318','2013-05-30','11:55:00',7.57),('10318','2013-05-30','12:00:00',11.01),('10318','2013-05-30','12:05:00',9.01),('10318','2013-05-30','12:10:00',4.98),('10318','2013-05-30','12:15:00',7.62),('10318','2013-05-30','12:20:00',5.93),('10318','2013-05-30','12:25:00',6.56),('10318','2013-05-30','12:30:00',9.64),('10318','2013-05-30','12:35:00',10.77),('10318','2013-05-30','12:40:00',8.71),('10318','2013-05-30','12:45:00',10.93),('10318','2013-05-30','12:50:00',10.23),('10318','2013-05-30','12:55:00',10.97),('10318','2013-05-30','13:00:00',7.89),('10318','2013-05-30','13:05:00',7.5),('10318','2013-05-30','13:10:00',7.64),('10318','2013-05-30','13:15:00',9.7),('10318','2013-05-30','13:20:00',5.32),('10318','2013-05-30','13:25:00',3.68),('10318','2013-05-30','13:30:00',4.21),('10318','2013-05-30','13:35:00',5.62),('10318','2013-05-30','13:40:00',8),('10318','2013-05-30','13:45:00',4.07),('10318','2013-05-30','13:50:00',3.47),('10318','2013-05-30','13:55:00',7.51),('10318','2013-05-30','14:00:00',6.36),('10318','2013-05-30','14:05:00',4.04),('10318','2013-05-30','14:10:00',7.36),('10318','2013-05-30','14:15:00',9.72),('10318','2013-05-30','14:20:00',8.17),('10318','2013-05-30','14:25:00',6.11),('10318','2013-05-30','14:30:00',9.97),('10318','2013-05-30','14:35:00',8.57),('10318','2013-05-30','14:40:00',5.24),('10318','2013-05-30','14:45:00',9.07),('10318','2013-05-30','14:50:00',8.99),('10318','2013-05-30','14:55:00',4.76),('10318','2013-05-30','15:01:00',9.72),('10318','2013-05-30','15:05:00',6.63),('10318','2013-05-30','15:10:00',6.88),('10318','2013-05-30','15:15:00',9.59),('10318','2013-05-30','15:20:00',9),('10318','2013-05-30','15:25:00',8.98),('10318','2013-05-30','15:30:00',9.19),('10318','2013-05-30','15:35:00',8.97),('10318','2013-05-30','15:40:00',8.33),('10318','2013-05-30','15:45:00',8.56),('10318','2013-05-30','15:50:00',7.95),('10318','2013-05-30','15:55:00',9.08),('10318','2013-05-30','16:00:00',8.45),('10318','2013-05-30','16:05:00',7.8),('10318','2013-05-30','16:10:00',7.42),('10318','2013-05-30','16:15:00',6.81),('10318','2013-05-30','16:20:00',3.97),('10318','2013-05-30','16:25:00',3.74),('10318','2013-05-30','16:30:00',2.06),('10318','2013-05-30','16:35:00',3.15),('10318','2013-05-30','16:40:00',2.14),('10318','2013-05-30','16:45:00',3.93),('10318','2013-05-30','16:50:00',4),('10318','2013-05-30','16:55:00',2.83),('10318','2013-05-30','17:00:00',4.04),('10318','2013-05-30','17:05:00',3.81),('10318','2013-05-30','17:10:00',2.03),('10318','2013-05-30','17:15:00',2.06),('10318','2013-05-30','17:20:00',1.84),('10318','2013-05-30','17:25:00',1.42),('10318','2013-05-30','17:30:00',1.8),('10318','2013-05-30','17:35:00',1.5),('10318','2013-05-30','17:40:00',1.02),('10318','2013-05-30','17:55:00',1.49),('10318','2013-05-30','18:00:00',2.35),('10318','2013-05-30','18:05:00',2.9),('10318','2013-05-30','18:10:00',1.99),('10318','2013-05-30','18:15:00',1.45),('10318','2013-05-30','18:20:00',1.63),('10318','2013-05-30','18:25:00',1.65),('10318','2013-05-30','18:30:00',2.31),('10318','2013-05-30','18:35:00',2.66),('10318','2013-05-30','18:40:00',2.75),('10318','2013-05-30','18:45:00',2.76),('10318','2013-05-30','18:50:00',2.04),('10318','2013-05-30','18:55:00',1.24),('10318','2013-05-30','19:00:00',1.21),('10318','2013-05-29','06:50:00',1.06),('10318','2013-05-29','06:55:00',1.31),('10318','2013-05-29','07:00:00',1.53),('10318','2013-05-29','07:05:00',1.86),('10318','2013-05-29','07:10:00',2.12),('10318','2013-05-29','07:15:00',2.41),('10318','2013-05-29','07:20:00',2.65),('10318','2013-05-29','07:25:00',3),('10318','2013-05-29','07:30:00',3.23),('10318','2013-05-29','07:35:00',3.41),('10318','2013-05-29','07:40:00',3.61),('10318','2013-05-29','07:45:00',3.81),('10318','2013-05-29','07:50:00',3.99),('10318','2013-05-29','07:55:00',4.19),('10318','2013-05-29','08:00:00',4.39),('10318','2013-05-29','08:05:00',4.62),('10318','2013-05-29','08:10:00',4.82),('10318','2013-05-29','08:15:00',5),('10318','2013-05-29','08:20:00',5.13),('10318','2013-05-29','08:25:00',5.37),('10318','2013-05-29','08:30:00',5.58),('10318','2013-05-29','08:35:00',5.74),('10318','2013-05-29','08:40:00',5.93),('10318','2013-05-29','08:45:00',6.09),('10318','2013-05-29','08:50:00',6.27),('10318','2013-05-29','08:55:00',6.47),('10318','2013-05-29','09:00:00',6.63),('10318','2013-05-29','09:05:00',6.64),('10318','2013-05-29','09:10:00',6.98),('10318','2013-05-29','09:15:00',7.11),('10318','2013-05-29','09:20:00',7.29),('10318','2013-05-29','09:25:00',7.46),('10318','2013-05-29','09:30:00',7.59),('10318','2013-05-29','09:35:00',7.72),('10318','2013-05-29','09:40:00',7.83),('10318','2013-05-29','09:45:00',7.94),('10318','2013-05-29','09:50:00',8.1),('10318','2013-05-29','09:55:00',8.23),('10318','2013-05-29','10:00:00',8.37),('10318','2013-05-29','10:05:00',8.39),('10318','2013-05-29','10:10:00',8.48),('10318','2013-05-29','10:15:00',8.66),('10318','2013-05-29','10:20:00',8.84),('10318','2013-05-29','10:25:00',8.92),('10318','2013-05-29','10:30:00',9),('10318','2013-05-29','10:35:00',9.19),('10318','2013-05-29','10:40:00',9.28),('10318','2013-05-29','10:45:00',9.4),('10318','2013-05-29','10:50:00',9.27),('10318','2013-05-29','10:55:00',9.56),('10318','2013-05-29','11:00:00',9.78),('10318','2013-05-29','11:05:00',9.73),('10318','2013-05-29','11:10:00',10.3),('10318','2013-05-29','11:15:00',10.6),('10318','2013-05-29','11:20:00',9.05),('10318','2013-05-29','11:25:00',8.62),('10318','2013-05-29','11:30:00',8.16),('10318','2013-05-29','11:35:00',8.13),('10318','2013-05-29','11:40:00',8.73),('10318','2013-05-29','11:45:00',6.81),('10318','2013-05-29','11:50:00',7.34),('10318','2013-05-29','11:55:00',7),('10318','2013-05-29','12:00:00',8.83),('10318','2013-05-29','12:05:00',9.24),('10318','2013-05-29','12:10:00',10.57),('10318','2013-05-29','12:15:00',10.54),('10318','2013-05-29','12:20:00',9.47),('10318','2013-05-29','12:25:00',10.48),('10318','2013-05-29','12:30:00',10.49),('10318','2013-05-29','12:35:00',9.22),('10318','2013-05-29','12:40:00',10.41),('10318','2013-05-29','12:45:00',9.76),('10318','2013-05-29','12:50:00',10),('10318','2013-05-29','12:55:00',10.27),('10318','2013-05-29','13:00:00',10.37),('10318','2013-05-29','13:05:00',10.47),('10318','2013-05-29','13:10:00',10.56),('10318','2013-05-29','13:15:00',10.36),('10318','2013-05-29','13:20:00',10.72),('10318','2013-05-29','13:25:00',8.45),('10318','2013-05-29','13:30:00',6),('10318','2013-05-29','13:35:00',7.57),('10318','2013-05-29','13:40:00',5.07),('10318','2013-05-29','13:45:00',8.46),('10318','2013-05-29','13:50:00',10.59),('10318','2013-05-29','13:55:00',10.32),('10318','2013-05-29','14:00:00',10.09),('10318','2013-05-29','14:05:00',9.36),('10318','2013-05-29','14:10:00',9.77),('10318','2013-05-29','14:15:00',9.7),('10318','2013-05-29','14:20:00',9.62),('10318','2013-05-29','14:25:00',9.61),('10318','2013-05-29','14:30:00',8.84),('10318','2013-05-29','14:35:00',8.32),('10318','2013-05-29','14:40:00',8.5),('10318','2013-05-29','14:45:00',9.55),('10318','2013-05-29','14:50:00',9.6),('10318','2013-05-29','14:55:00',8.76),('10318','2013-05-29','15:00:00',7.66),('10318','2013-05-29','15:05:00',7.26),('10318','2013-05-29','15:10:00',7.94),('10318','2013-05-29','15:15:00',7.17),('10318','2013-05-29','15:20:00',6.35),('10318','2013-05-29','15:25:00',5.82),('10318','2013-05-29','15:30:00',6.66),('10318','2013-05-29','15:35:00',7.13),('10318','2013-05-29','15:40:00',6.44),('10318','2013-05-29','15:45:00',4.86),('10318','2013-05-29','15:50:00',5.74),('10318','2013-05-29','15:55:00',5.99),('10318','2013-05-29','16:00:00',5.39),('10318','2013-05-29','16:05:00',5.21),('10318','2013-05-29','16:10:00',5.05),('10318','2013-05-29','16:15:00',4.87),('10318','2013-05-29','16:20:00',4.76),('10318','2013-05-29','16:25:00',5.42),('10318','2013-05-29','16:30:00',4.71),('10318','2013-05-29','16:35:00',4.62),('10318','2013-05-29','16:40:00',4.7),('10318','2013-05-29','16:45:00',4.23),('10318','2013-05-29','16:50:00',3.77),('10318','2013-05-29','16:55:00',3.16),('10318','2013-05-29','17:00:00',2.55),('10318','2013-05-29','17:05:00',1.53),('10318','2013-05-29','17:20:00',1.02),('10318','2013-05-29','17:25:00',1.26),('10318','2013-05-29','17:30:00',1.84),('10318','2013-05-29','17:35:00',2.63),('10318','2013-05-29','17:40:00',3.08),('10318','2013-05-29','17:45:00',2.26),('10318','2013-05-29','17:50:00',1.69),('10318','2013-05-29','17:55:00',1.63),('10318','2013-05-29','18:00:00',2.49),('10318','2013-05-29','18:05:00',2.68),('10318','2013-05-29','18:10:00',2.39),('10318','2013-05-29','18:15:00',2.76),('10318','2013-05-29','18:20:00',2.36),('10318','2013-05-29','18:25:00',1.29),('10318','2013-05-29','18:30:00',1.07),('10318','2013-05-29','18:35:00',1.06),('10318','2013-05-29','18:50:00',1.03),('10318','2013-05-29','19:00:00',1.25),('10318','2013-05-29','19:05:00',1.25),('10318','2013-05-29','19:10:00',1.16),('10318','2013-05-28','06:40:00',1.11),('10318','2013-05-28','06:45:00',1.31),('10318','2013-05-28','06:50:00',1.36),('10318','2013-05-28','06:55:00',1.31),('10318','2013-05-28','07:00:00',1.37),('10318','2013-05-28','07:05:00',1.38),('10318','2013-05-28','07:10:00',1.75),('10318','2013-05-28','07:15:00',2.59),('10318','2013-05-28','07:20:00',2.84),('10318','2013-05-28','07:25:00',2.93),('10318','2013-05-28','07:30:00',2.66),('10318','2013-05-28','07:35:00',2.14),('10318','2013-05-28','07:40:00',2.87),('10318','2013-05-28','07:45:00',3.13),('10318','2013-05-28','07:50:00',3.06),('10318','2013-05-28','07:55:00',3.08),('10318','2013-05-28','08:00:00',2.79),('10318','2013-05-28','08:05:00',3.23),('10318','2013-05-28','08:10:00',3.69),('10318','2013-05-28','08:15:00',4.41),('10318','2013-05-28','08:20:00',4.5),('10318','2013-05-28','08:25:00',3.94),('10318','2013-05-28','08:30:00',4.82),('10318','2013-05-28','08:35:00',4.42),('10318','2013-05-28','08:40:00',3.75),('10318','2013-05-28','08:45:00',3.58),('10318','2013-05-28','08:50:00',4.21),('10318','2013-05-28','08:55:00',3.2),('10318','2013-05-28','09:00:00',3.54),('10318','2013-05-28','09:05:00',4.53),('10318','2013-05-28','09:10:00',4.27),('10318','2013-05-28','09:15:00',4.16),('10318','2013-05-28','09:20:00',4.67),('10318','2013-05-28','09:25:00',5.02),('10318','2013-05-28','09:30:00',5.61),('10318','2013-05-28','09:35:00',6.01),('10318','2013-05-28','09:40:00',5.35),('10318','2013-05-28','09:45:00',5.19),('10318','2013-05-28','09:50:00',5.18),('10318','2013-05-28','09:55:00',5.43),('10318','2013-05-28','10:00:00',4.89),('10318','2013-05-28','10:05:00',5.12),('10318','2013-05-28','10:10:00',5.76),('10318','2013-05-28','10:15:00',6.13),('10318','2013-05-28','10:20:00',6.27),('10318','2013-05-28','10:25:00',6.17),('10318','2013-05-28','10:30:00',6.7),('10318','2013-05-28','10:35:00',6.73),('10318','2013-05-28','10:40:00',7.07),('10318','2013-05-28','10:45:00',6.41),('10318','2013-05-28','10:50:00',5.93),('10318','2013-05-28','10:55:00',6.38),('10318','2013-05-28','11:00:00',6.37),('10318','2013-05-28','11:05:00',6.78),('10318','2013-05-28','11:10:00',6.35),('10318','2013-05-28','11:15:00',5.71),('10318','2013-05-28','11:20:00',4.78),('10318','2013-05-28','11:25:00',7.08),('10318','2013-05-28','11:30:00',8.93),('10318','2013-05-28','11:35:00',8.99),('10318','2013-05-28','11:40:00',10.22),('10318','2013-05-28','11:45:00',8.19),('10318','2013-05-28','11:50:00',2.52),('10318','2013-05-28','11:55:00',3.23),('10318','2013-05-28','12:00:00',3.67),('10318','2013-05-28','12:05:00',4.66),('10318','2013-05-28','12:10:00',5.02),('10318','2013-05-28','12:15:00',5.24),('10318','2013-05-28','12:20:00',5.06),('10318','2013-05-28','12:25:00',5.56),('10318','2013-05-28','12:30:00',6.35),('10318','2013-05-28','12:35:00',5.76),('10318','2013-05-28','12:40:00',5.9),('10318','2013-05-28','12:45:00',5.76),('10318','2013-05-28','12:50:00',5.61),('10318','2013-05-28','12:55:00',5.97),('10318','2013-05-28','13:00:00',6.15),('10318','2013-05-28','13:05:00',6.89),('10318','2013-05-28','13:10:00',8),('10318','2013-05-28','13:15:00',5.61),('10318','2013-05-28','13:20:00',5.19),('10318','2013-05-28','13:25:00',4.13),('10318','2013-05-28','13:30:00',5.65),('10318','2013-05-28','13:35:00',5.65),('10318','2013-05-28','13:40:00',5.13),('10318','2013-05-28','13:45:00',4.58),('10318','2013-05-28','13:50:00',4.61),('10318','2013-05-28','13:55:00',4.33),('10318','2013-05-28','14:00:00',4.96),('10318','2013-05-28','14:05:00',5.81),('10318','2013-05-28','14:10:00',5.72),('10318','2013-05-28','14:15:00',7.18),('10318','2013-05-28','14:20:00',6.44),('10318','2013-05-28','14:25:00',5.29),('10318','2013-05-28','14:30:00',6.69),('10318','2013-05-28','14:35:00',6.02),('10318','2013-05-28','14:40:00',6.38),('10318','2013-05-28','14:45:00',7.15),('10318','2013-05-28','14:50:00',7.49),('10318','2013-05-28','14:55:00',8.3),('10318','2013-05-28','15:00:00',6.44),('10318','2013-05-28','15:05:00',5.13),('10318','2013-05-28','15:10:00',3.57),('10318','2013-05-28','15:15:00',5.06),('10318','2013-05-28','15:20:00',6.36),('10318','2013-05-28','15:25:00',4.74),('10318','2013-05-28','15:30:00',3.35),('10318','2013-05-28','15:35:00',3.45),('10318','2013-05-28','15:40:00',3.88),('10318','2013-05-28','15:45:00',7.44),('10318','2013-05-28','15:50:00',5.61),('10318','2013-05-28','15:55:00',4.16),('10318','2013-05-28','16:00:00',3.35),('10318','2013-05-28','16:05:00',2.89),('10318','2013-05-28','16:10:00',3.01),('10318','2013-05-28','16:15:00',3.78),('10318','2013-05-28','16:20:00',4.77),('10318','2013-05-28','16:25:00',4.78),('10318','2013-05-28','16:30:00',5.81),('10318','2013-05-28','16:35:00',5.98),('10318','2013-05-28','16:40:00',5.44),('10318','2013-05-28','16:45:00',5.18),('10318','2013-05-28','16:50:00',5.01),('10318','2013-05-28','16:55:00',4.81),('10318','2013-05-28','17:00:00',4.61),('10318','2013-05-28','17:05:00',4.41),('10318','2013-05-28','17:10:00',4.23),('10318','2013-05-28','17:15:00',3.98),('10318','2013-05-28','17:20:00',3.91),('10318','2013-05-28','17:25:00',3.68),('10318','2013-05-28','17:30:00',3.49),('10318','2013-05-28','17:35:00',3.32),('10318','2013-05-28','17:40:00',3.14),('10318','2013-05-28','17:45:00',2.96),('10318','2013-05-28','17:50:00',2.79),('10318','2013-05-28','17:55:00',2.63),('10318','2013-05-28','18:00:00',2.54),('10318','2013-05-28','18:05:00',2.39),('10318','2013-05-28','18:10:00',1.4),('10318','2013-05-28','18:15:00',1.41),('10318','2013-05-28','18:20:00',1.26),('10318','2013-05-28','18:25:00',1.28),('10318','2013-05-28','18:30:00',1.37),('10318','2013-05-28','18:35:00',1.38),('10318','2013-05-28','18:40:00',1.26),('10318','2013-05-28','18:45:00',1.14),('10318','2013-05-28','18:50:00',1.03),('10318','2013-05-27','06:45:00',1.01),('10318','2013-05-27','06:50:00',1.07),('10318','2013-05-27','06:55:00',1.01),('10318','2013-05-27','07:00:00',1.17),('10318','2013-05-27','07:05:00',1.11),('10318','2013-05-27','07:10:00',1.36),('10318','2013-05-27','07:15:00',2.25),('10318','2013-05-27','07:20:00',1.68),('10318','2013-05-27','07:25:00',2.51),('10318','2013-05-27','07:30:00',3.09),('10318','2013-05-27','07:35:00',3.1),('10318','2013-05-27','07:40:00',3.33),('10318','2013-05-27','07:45:00',3.56),('10318','2013-05-27','07:50:00',4.25),('10318','2013-05-27','07:55:00',2.62),('10318','2013-05-27','08:00:00',4.25),('10318','2013-05-27','08:05:00',5.34),('10318','2013-05-27','08:10:00',5.9),('10318','2013-05-27','08:15:00',5.31),('10318','2013-05-27','08:20:00',4.09),('10318','2013-05-27','08:25:00',5.72),('10318','2013-05-27','08:30:00',5.75),('10318','2013-05-27','08:35:00',5.95),('10318','2013-05-27','08:40:00',6.52),('10318','2013-05-27','08:45:00',5.34),('10318','2013-05-27','08:50:00',1.49),('10318','2013-05-27','08:55:00',7.09),('10318','2013-05-27','09:00:00',8.05),('10318','2013-05-27','09:05:00',7.82),('10318','2013-05-27','09:10:00',5.12),('10318','2013-05-27','09:15:00',8.63),('10318','2013-05-27','09:20:00',3.77),('10318','2013-05-27','09:25:00',6.96),('10318','2013-05-27','09:30:00',8),('10318','2013-05-27','09:35:00',8.04),('10318','2013-05-27','09:40:00',8.17),('10318','2013-05-27','09:45:00',8.33),('10318','2013-05-27','09:50:00',8.7),('10318','2013-05-27','09:55:00',7.4),('10318','2013-05-27','10:00:00',7.4),('10318','2013-05-27','10:05:00',8.75),('10318','2013-05-27','10:10:00',8.8),('10318','2013-05-27','10:15:00',9.21),('10318','2013-05-27','10:20:00',8.87),('10318','2013-05-27','10:25:00',9.83),('10318','2013-05-27','10:30:00',9.59),('10318','2013-05-27','10:35:00',7.07),('10318','2013-05-27','10:40:00',4.89),('10318','2013-05-27','10:45:00',7.09),('10318','2013-05-27','10:50:00',11.26),('10318','2013-05-27','10:55:00',8.01),('10318','2013-05-27','11:00:00',6.18),('10318','2013-05-27','11:05:00',9.28),('10318','2013-05-27','11:10:00',10.23),('10318','2013-05-27','11:15:00',9.28),('10318','2013-05-27','11:20:00',8.39),('10318','2013-05-27','11:25:00',3.47),('10318','2013-05-27','11:30:00',8.81),('10318','2013-05-27','11:35:00',10.62),('10318','2013-05-27','11:40:00',4.89),('10318','2013-05-27','11:45:00',4.44),('10318','2013-05-27','11:50:00',9.01),('10318','2013-05-27','11:55:00',4.8),('10318','2013-05-27','12:00:00',3.36),('10318','2013-05-27','12:05:00',10.34),('10318','2013-05-27','12:10:00',5.39),('10318','2013-05-27','12:15:00',8.09),('10318','2013-05-27','12:20:00',2.81),('10318','2013-05-27','12:25:00',8.86),('10318','2013-05-27','12:30:00',4.08),('10318','2013-05-27','12:35:00',10.1),('10318','2013-05-27','12:40:00',5.99),('10318','2013-05-27','12:45:00',10.75),('10318','2013-05-27','12:50:00',10.81),('10318','2013-05-27','12:55:00',10.61),('10318','2013-05-27','13:00:00',8.45),('10318','2013-05-27','13:05:00',3.54),('10318','2013-05-27','13:10:00',9.04),('10318','2013-05-27','13:15:00',9.69),('10318','2013-05-27','13:20:00',7.8),('10318','2013-05-27','13:25:00',8.25),('10318','2013-05-27','13:30:00',8.6),('10318','2013-05-27','13:35:00',9.68),('10318','2013-05-27','13:40:00',10.47),('10318','2013-05-27','13:45:00',10.27),('10318','2013-05-27','13:50:00',10.13),('10318','2013-05-27','13:55:00',9.82),('10318','2013-05-27','14:00:00',9.52),('10318','2013-05-27','14:05:00',9.88),('10318','2013-05-27','14:10:00',9.56),('10318','2013-05-27','14:15:00',9.55),('10318','2013-05-27','14:20:00',9.6),('10318','2013-05-27','14:25:00',9.48),('10318','2013-05-27','14:30:00',9.4),('10318','2013-05-27','14:35:00',9.38),('10318','2013-05-27','14:40:00',7.33),('10318','2013-05-27','14:45:00',6.87),('10318','2013-05-27','14:50:00',9.49),('10318','2013-05-27','14:55:00',7.39),('10318','2013-05-27','15:00:00',4.89),('10318','2013-05-27','15:05:00',6.59),('10318','2013-05-27','15:10:00',9.04),('10318','2013-05-27','15:15:00',6.41),('10318','2013-05-27','15:20:00',6.76),('10318','2013-05-27','15:25:00',7.27),('10318','2013-05-27','15:30:00',8.1),('10318','2013-05-27','15:35:00',8.19),('10318','2013-05-27','15:40:00',6.66),('10318','2013-05-27','15:45:00',6.69),('10318','2013-05-27','15:50:00',7.47),('10318','2013-05-27','15:55:00',5.06),('10318','2013-05-27','16:00:00',6.5),('10318','2013-05-27','16:05:00',5.16),('10318','2013-05-27','16:10:00',4.95),('10318','2013-05-27','16:15:00',5.23),('10318','2013-05-27','16:20:00',7.72),('10318','2013-05-27','16:25:00',6.89),('10318','2013-05-27','16:30:00',6.25),('10318','2013-05-27','16:35:00',4.62),('10318','2013-05-27','16:40:00',2.81),('10318','2013-05-27','16:45:00',2.67),('10318','2013-05-27','16:50:00',2.8),('10318','2013-05-27','16:55:00',3.01),('10318','2013-05-27','17:00:00',3.13),('10318','2013-05-27','17:05:00',3.29),('10318','2013-05-27','17:10:00',3.77),('10318','2013-05-27','17:15:00',3.07),('10318','2013-05-27','17:20:00',2.73),('10318','2013-05-27','17:25:00',2.58),('10318','2013-05-27','17:30:00',2.52),('10318','2013-05-27','17:35:00',2.29),('10318','2013-05-27','17:40:00',2.15),('10318','2013-05-27','17:45:00',2.05),('10318','2013-05-27','17:50:00',1.96),('10318','2013-05-27','17:55:00',2.03),('10318','2013-05-27','18:00:00',1.95),('10318','2013-05-27','18:05:00',1.79),('10318','2013-05-27','18:10:00',1.95),('10318','2013-05-27','18:15:00',2.02),('10318','2013-05-27','18:20:00',2.65),('10318','2013-05-27','18:25:00',3.05),('10318','2013-05-27','18:30:00',2.39),('10318','2013-05-27','18:35:00',1.55),('10318','2013-05-27','18:40:00',1.11),('10318','2013-05-27','18:45:00',1.3),('10318','2013-05-27','18:50:00',1.13),('10318','2013-05-27','18:55:00',1.58),('10318','2013-05-27','19:00:00',1.53),('10318','2013-05-27','19:05:00',1.4),('10318','2013-05-27','19:10:00',1.18),('10318','2013-05-26','07:15:00',1.17),('10318','2013-05-26','07:20:00',2.54),('10318','2013-05-26','07:25:00',1.46),('10318','2013-05-26','07:30:00',1.9),('10318','2013-05-26','07:35:00',1.94),('10318','2013-05-26','07:40:00',2.43),('10318','2013-05-26','07:45:00',4.51),('10318','2013-05-26','07:50:00',4.03),('10318','2013-05-26','08:00:00',4.28),('10318','2013-05-26','08:05:00',5.91),('10318','2013-05-26','08:10:00',2.09),('10318','2013-05-26','08:15:00',4.68),('10318','2013-05-26','08:20:00',5.03),('10318','2013-05-26','08:25:00',6.18),('10318','2013-05-26','08:30:00',5.1),('10318','2013-05-26','08:35:00',6.57),('10318','2013-05-26','08:40:00',4.02),('10318','2013-05-26','08:45:00',5.57),('10318','2013-05-26','08:50:00',2.03),('10318','2013-05-26','08:55:00',7.76),('10318','2013-05-26','09:00:00',3.41),('10318','2013-05-26','09:05:00',1.89),('10318','2013-05-26','09:10:00',6.88),('10318','2013-05-26','09:15:00',3.53),('10318','2013-05-26','09:20:00',2.05),('10318','2013-05-26','09:25:00',2.26),('10318','2013-05-26','09:30:00',2.83),('10318','2013-05-26','09:35:00',1.31),('10318','2013-05-26','09:40:00',4.92),('10318','2013-05-26','09:45:00',1.99),('10318','2013-05-26','09:50:00',1.61),('10318','2013-05-26','09:55:00',4.49),('10318','2013-05-26','10:00:00',4.18),('10318','2013-05-26','10:05:00',7.71),('10318','2013-05-26','10:10:00',8.26),('10318','2013-05-26','10:15:00',5.38),('10318','2013-05-26','10:20:00',8.16),('10318','2013-05-26','10:25:00',9.98),('10318','2013-05-26','10:30:00',9.59),('10318','2013-05-26','10:35:00',7.7),('10318','2013-05-26','10:40:00',9.43),('10318','2013-05-26','10:45:00',9.84),('10318','2013-05-26','10:50:00',10.03),('10318','2013-05-26','10:55:00',10.12),('10318','2013-05-26','11:00:00',10.15),('10318','2013-05-26','11:05:00',10.15),('10318','2013-05-26','11:10:00',10.19),('10318','2013-05-26','11:15:00',10.3),('10318','2013-05-26','11:20:00',10.36),('10318','2013-05-26','11:25:00',8.66),('10318','2013-05-26','11:30:00',10.48),('10318','2013-05-26','11:35:00',10.51),('10318','2013-05-26','11:40:00',10.62),('10318','2013-05-26','11:45:00',10.53),('10318','2013-05-26','11:50:00',10.6),('10318','2013-05-26','11:55:00',10.66),('10318','2013-05-26','12:00:00',10.68),('10318','2013-05-26','12:05:00',10.8),('10318','2013-05-26','12:10:00',10.81),('10318','2013-05-26','12:15:00',10.76),('10318','2013-05-26','12:20:00',9.88),('10318','2013-05-26','12:25:00',8.74),('10318','2013-05-26','12:30:00',9.7),('10318','2013-05-26','12:35:00',9.05),('10318','2013-05-26','12:40:00',6.6),('10318','2013-05-26','12:45:00',8.8),('10318','2013-05-26','12:50:00',9.5),('10318','2013-05-26','12:55:00',10.62),('10318','2013-05-26','13:00:00',9.96),('10318','2013-05-26','13:05:00',9.83),('10318','2013-05-26','13:10:00',10.1),('10318','2013-05-26','13:15:00',10.38),('10318','2013-05-26','13:20:00',10.52),('10318','2013-05-26','13:25:00',10.48),('10318','2013-05-26','13:30:00',10.43),('10318','2013-05-26','13:35:00',10.29),('10318','2013-05-26','13:40:00',10.29),('10318','2013-05-26','13:45:00',8.81),('10318','2013-05-26','13:50:00',9.76),('10318','2013-05-26','13:55:00',10.07),('10318','2013-05-26','14:00:00',10.01),('10318','2013-05-26','14:05:00',9.91),('10318','2013-05-26','14:10:00',9.77),('10318','2013-05-26','14:15:00',9.8),('10318','2013-05-26','14:20:00',9.72),('10318','2013-05-26','14:25:00',9.62),('10318','2013-05-26','14:30:00',9.54),('10318','2013-05-26','14:35:00',9.49),('10318','2013-05-26','14:40:00',9.35),('10318','2013-05-26','14:45:00',9.3),('10318','2013-05-26','14:50:00',9.23),('10318','2013-05-26','14:55:00',9.02),('10318','2013-05-26','15:00:00',8.94),('10318','2013-05-26','15:05:00',8.8),('10318','2013-05-26','15:10:00',8.67),('10318','2013-05-26','15:15:00',8.58),('10318','2013-05-26','15:20:00',8.47),('10318','2013-05-26','15:25:00',8.32),('10318','2013-05-26','15:30:00',8.18),('10318','2013-05-26','15:35:00',8.02),('10318','2013-05-26','15:40:00',7.9),('10318','2013-05-26','15:45:00',7.76),('10318','2013-05-26','15:50:00',7.65),('10318','2013-05-26','15:55:00',7.47),('10318','2013-05-26','16:00:00',7.29),('10318','2013-05-26','16:05:00',7.11),('10318','2013-05-26','16:10:00',6.94),('10318','2013-05-26','16:15:00',6.78),('10318','2013-05-26','16:20:00',6.63),('10318','2013-05-26','16:25:00',6.45),('10318','2013-05-26','16:30:00',6.29),('10318','2013-05-26','16:35:00',6.1),('10318','2013-05-26','16:40:00',5.89),('10318','2013-05-26','16:45:00',5.68),('10318','2013-05-26','16:50:00',5.52),('10318','2013-05-26','16:55:00',5.33),('10318','2013-05-26','17:00:00',5.11),('10318','2013-05-26','17:05:00',4.91),('10318','2013-05-26','17:10:00',4.71),('10318','2013-05-26','17:15:00',4.51),('10318','2013-05-26','17:20:00',4.3),('10318','2013-05-26','17:25:00',4.14),('10318','2013-05-26','17:30:00',3.93),('10318','2013-05-26','17:35:00',3.69),('10318','2013-05-26','17:40:00',3.48),('10318','2013-05-26','17:45:00',3.26),('10318','2013-05-26','17:50:00',3.07),('10318','2013-05-26','17:55:00',2.89),('10318','2013-05-26','18:00:00',2.61),('10318','2013-05-26','18:05:00',2.47),('10318','2013-05-26','18:10:00',2.26),('10318','2013-05-26','18:15:00',2.06),('10318','2013-05-26','18:20:00',1.9),('10318','2013-05-26','18:25:00',1.72),('10318','2013-05-26','18:30:00',1.53),('10318','2013-05-26','18:35:00',1.39),('10318','2013-05-26','18:40:00',1.27),('10318','2013-05-26','18:45:00',1.1),('10318','2013-05-25','07:10:00',1.13),('10318','2013-05-25','07:20:00',1.23),('10318','2013-05-25','07:25:00',3.27),('10318','2013-05-25','07:30:00',3.84),('10318','2013-05-25','07:35:00',4.27),('10318','2013-05-25','07:40:00',1.83),('10318','2013-05-25','07:45:00',3.68),('10318','2013-05-25','07:50:00',4.45),('10318','2013-05-25','07:55:00',5.36),('10318','2013-05-25','08:00:00',4.48),('10318','2013-05-25','08:05:00',3.29),('10318','2013-05-25','08:10:00',1.24),('10318','2013-05-25','08:15:00',2.8),('10318','2013-05-25','08:20:00',4.28),('10318','2013-05-25','08:25:00',7.28),('10318','2013-05-25','08:30:00',5.79),('10318','2013-05-25','08:35:00',2.4),('10318','2013-05-25','08:40:00',3.59),('10318','2013-05-25','08:45:00',2.54),('10318','2013-05-25','08:50:00',6.59),('10318','2013-05-25','08:55:00',7.66),('10318','2013-05-25','09:00:00',8.07),('10318','2013-05-25','09:05:00',8.23),('10318','2013-05-25','09:10:00',8.05),('10318','2013-05-25','09:15:00',4.24),('10318','2013-05-25','09:20:00',3.15),('10318','2013-05-25','09:25:00',5.71),('10318','2013-05-25','09:30:00',5.16),('10318','2013-05-25','09:35:00',7.26),('10318','2013-05-25','09:40:00',8.63),('10318','2013-05-25','09:45:00',7.72),('10318','2013-05-25','09:50:00',8.11),('10318','2013-05-25','09:55:00',3),('10318','2013-05-25','10:00:00',1.64),('10318','2013-05-25','10:05:00',2.29),('10318','2013-05-25','10:10:00',3.47),('10318','2013-05-25','10:15:00',1.58),('10318','2013-05-25','10:20:00',1.69),('10318','2013-05-25','10:25:00',1.63),('10318','2013-05-25','10:30:00',1.54),('10318','2013-05-25','10:35:00',2.31),('10318','2013-05-25','10:40:00',2.78),('10318','2013-05-25','10:45:00',2.46),('10318','2013-05-25','10:50:00',2.05),('10318','2013-05-25','10:55:00',1.59),('10318','2013-05-25','11:00:00',3.99),('10318','2013-05-25','11:05:00',9.54),('10318','2013-05-25','11:10:00',9.28),('10318','2013-05-25','11:15:00',7.04),('10318','2013-05-25','11:20:00',3.28),('10318','2013-05-25','11:25:00',1.14),('10318','2013-05-25','11:30:00',2.48),('10318','2013-05-25','11:35:00',5.95),('10318','2013-05-25','11:40:00',5.46),('10318','2013-05-25','11:45:00',4.5),('10318','2013-05-25','11:50:00',3.4),('10318','2013-05-25','11:55:00',3.3),('10318','2013-05-25','12:00:00',5.44),('10318','2013-05-25','12:05:00',7.85),('10318','2013-05-25','12:10:00',6.38),('10318','2013-05-25','12:15:00',3.27),('10318','2013-05-25','12:20:00',8.6),('10318','2013-05-25','12:25:00',6.5),('10318','2013-05-25','12:30:00',3.52),('10318','2013-05-25','12:35:00',7.27),('10318','2013-05-25','12:40:00',3.32),('10318','2013-05-25','12:45:00',2.6),('10318','2013-05-25','12:50:00',2.59),('10318','2013-05-25','12:55:00',2.54),('10318','2013-05-25','13:00:00',4.28),('10318','2013-05-25','13:05:00',3.46),('10318','2013-05-25','13:10:00',4.08),('10318','2013-05-25','13:15:00',4.33),('10318','2013-05-25','13:20:00',5.3),('10318','2013-05-25','13:25:00',6.93),('10318','2013-05-25','13:30:00',3.12),('10318','2013-05-25','13:35:00',4.34),('10318','2013-05-25','13:40:00',7.05),('10318','2013-05-25','13:45:00',9.24),('10318','2013-05-25','13:50:00',8.18),('10318','2013-05-25','13:55:00',8.75),('10318','2013-05-25','14:00:00',7.47),('10318','2013-05-25','14:05:00',9.61),('10318','2013-05-25','14:10:00',8.26),('10318','2013-05-25','14:15:00',6.39),('10318','2013-05-25','14:20:00',5.75),('10318','2013-05-25','14:25:00',8.51),('10318','2013-05-25','14:30:00',7.22),('10318','2013-05-25','14:35:00',9.79),('10318','2013-05-25','14:40:00',6.41),('10318','2013-05-25','14:45:00',10.18),('10318','2013-05-25','14:50:00',9.43),('10318','2013-05-25','14:55:00',5.74),('10318','2013-05-25','15:00:00',4.17),('10318','2013-05-25','15:05:00',4.23),('10318','2013-05-25','15:10:00',5.88),('10318','2013-05-25','15:15:00',4.11),('10318','2013-05-25','15:20:00',7.68),('10318','2013-05-25','15:25:00',8.99),('10318','2013-05-25','15:30:00',7),('10318','2013-05-25','15:35:00',5.84),('10318','2013-05-25','15:40:00',7.92),('10318','2013-05-25','15:45:00',5.8),('10318','2013-05-25','15:50:00',2.76),('10318','2013-05-25','15:55:00',8.51),('10318','2013-05-25','16:00:00',5.25),('10318','2013-05-25','16:05:00',7.35),('10318','2013-05-25','16:10:00',3.13),('10318','2013-05-25','16:15:00',6.68),('10318','2013-05-25','16:20:00',4.37),('10318','2013-05-25','16:25:00',5.51),('10318','2013-05-25','16:30:00',5.86),('10318','2013-05-25','16:35:00',2.81),('10318','2013-05-25','16:40:00',3.06),('10318','2013-05-25','16:45:00',4.35),('10318','2013-05-25','16:50:00',5.95),('10318','2013-05-25','16:55:00',6.19),('10318','2013-05-25','17:00:00',4.8),('10318','2013-05-25','17:05:00',3.8),('10318','2013-05-25','17:10:00',1.67),('10318','2013-05-25','17:15:00',3.62),('10318','2013-05-25','17:20:00',1.69),('10318','2013-05-25','17:25:00',1.41),('10318','2013-05-25','17:30:00',1.42),('10318','2013-05-25','17:35:00',2.17),('10318','2013-05-25','17:40:00',3.99),('10318','2013-05-25','17:45:00',2.53),('10318','2013-05-25','17:50:00',3.67),('10318','2013-05-25','17:55:00',2.09),('10318','2013-05-25','18:00:00',2.79),('10318','2013-05-25','18:05:00',2.11),('10318','2013-05-25','18:10:00',1.32),('10318','2013-05-25','18:15:00',1.28),('10318','2013-05-25','18:20:00',1.17),('10318','2013-05-25','18:35:00',1.24),('10318','2013-05-24','06:55:00',1.22),('10318','2013-05-24','07:00:00',1.99),('10318','2013-05-24','07:05:00',1.07),('10318','2013-05-24','07:30:00',1.1),('10318','2013-05-24','07:35:00',1.18),('10318','2013-05-24','07:40:00',1.51),('10318','2013-05-24','07:45:00',1.31),('10318','2013-05-24','07:50:00',1),('10318','2013-05-24','07:55:00',1.19),('10318','2013-05-24','08:00:00',2.61),('10318','2013-05-24','08:05:00',3.94),('10318','2013-05-24','08:10:00',2.77),('10318','2013-05-24','08:15:00',2.98),('10318','2013-05-24','08:20:00',1.92),('10318','2013-05-24','08:25:00',5.54),('10318','2013-05-24','08:30:00',5.35),('10318','2013-05-24','08:35:00',3.97),('10318','2013-05-24','08:40:00',6.16),('10318','2013-05-24','08:45:00',6.26),('10318','2013-05-24','08:50:00',6.45),('10318','2013-05-24','08:55:00',5.87),('10318','2013-05-24','09:00:00',7.34),('10318','2013-05-24','09:05:00',6.83),('10318','2013-05-24','09:10:00',1.1),('10318','2013-05-24','09:15:00',2.76),('10318','2013-05-24','09:20:00',2.24),('10318','2013-05-24','09:25:00',4.8),('10318','2013-05-24','09:30:00',4.4),('10318','2013-05-24','09:35:00',1.85),('10318','2013-05-24','09:40:00',3.07),('10318','2013-05-24','09:45:00',2.33),('10318','2013-05-24','09:50:00',3.71),('10318','2013-05-24','09:55:00',9.41),('10318','2013-05-24','10:00:00',6.44),('10318','2013-05-24','10:05:00',1.41),('10318','2013-05-24','10:10:00',1.02),('10318','2013-05-24','10:15:00',1.22),('10318','2013-05-24','10:20:00',3.72),('10318','2013-05-24','10:25:00',5.05),('10318','2013-05-24','10:30:00',9.95),('10318','2013-05-24','10:35:00',9.46),('10318','2013-05-24','10:40:00',9.55),('10318','2013-05-24','10:45:00',7.89),('10318','2013-05-24','10:50:00',9.46),('10318','2013-05-24','10:55:00',8.78),('10318','2013-05-24','11:00:00',6.72),('10318','2013-05-24','11:05:00',9.67),('10318','2013-05-24','11:10:00',9.48),('10318','2013-05-24','11:15:00',4.73),('10318','2013-05-24','11:20:00',9.66),('10318','2013-05-24','11:25:00',10.79),('10318','2013-05-24','11:30:00',10.36),('10318','2013-05-24','11:35:00',4.63),('10318','2013-05-24','11:40:00',2.17),('10318','2013-05-24','11:45:00',6.25),('10318','2013-05-24','11:50:00',6.78),('10318','2013-05-24','11:55:00',10.34),('10318','2013-05-24','12:00:00',8),('10318','2013-05-24','12:05:00',5.69),('10318','2013-05-24','12:10:00',5.65),('10318','2013-05-24','12:15:00',7.54),('10318','2013-05-24','12:20:00',7.27),('10318','2013-05-24','12:25:00',6.11),('10318','2013-05-24','12:30:00',5.94),('10318','2013-05-24','12:35:00',6.93),('10318','2013-05-24','12:40:00',5.1),('10318','2013-05-24','12:45:00',4.41),('10318','2013-05-24','12:50:00',6.24),('10318','2013-05-24','12:55:00',7.14),('10318','2013-05-24','13:00:00',8.56),('10318','2013-05-24','13:05:00',8.71),('10318','2013-05-24','13:10:00',6.82),('10318','2013-05-24','13:15:00',7.41),('10318','2013-05-24','13:20:00',7.54),('10318','2013-05-24','13:25:00',5.52),('10318','2013-05-24','13:30:00',6.81),('10318','2013-05-24','13:35:00',5.23),('10318','2013-05-24','13:40:00',3.31),('10318','2013-05-24','13:45:00',2.58),('10318','2013-05-24','13:50:00',3.16),('10318','2013-05-24','13:55:00',9.22),('10318','2013-05-24','14:00:00',5.64),('10318','2013-05-24','14:05:00',3.47),('10318','2013-05-24','14:10:00',6.97),('10318','2013-05-24','14:15:00',6.51),('10318','2013-05-24','14:20:00',4.19),('10318','2013-05-24','14:25:00',5.07),('10318','2013-05-24','14:30:00',8.16),('10318','2013-05-24','14:35:00',8.17),('10318','2013-05-24','14:40:00',7.86),('10318','2013-05-24','14:45:00',6.02),('10318','2013-05-24','14:50:00',5.96),('10318','2013-05-24','14:55:00',5.91),('10318','2013-05-24','15:00:00',4.76),('10318','2013-05-24','15:05:00',6.53),('10318','2013-05-24','15:10:00',7.84),('10318','2013-05-24','15:15:00',7.2),('10318','2013-05-24','15:20:00',8.32),('10318','2013-05-24','15:25:00',10.09),('10318','2013-05-24','15:30:00',8.94),('10318','2013-05-24','15:35:00',5.93),('10318','2013-05-24','15:40:00',5.58),('10318','2013-05-24','15:45:00',7.51),('10318','2013-05-24','15:50:00',6.74),('10318','2013-05-24','15:55:00',4.69),('10318','2013-05-24','16:00:00',4.44),('10318','2013-05-24','16:05:00',4.39),('10318','2013-05-24','16:10:00',4.83),('10318','2013-05-24','16:15:00',4.54),('10318','2013-05-24','16:20:00',4.94),('10318','2013-05-24','16:25:00',7.51),('10318','2013-05-24','16:30:00',3.83),('10318','2013-05-24','16:35:00',2.53),('10318','2013-05-24','16:40:00',1.55),('10318','2013-05-24','16:45:00',2.59),('10318','2013-05-24','16:50:00',3.81),('10318','2013-05-24','16:55:00',3.11),('10318','2013-05-24','17:00:00',2.88),('10318','2013-05-24','17:05:00',2.46),('10318','2013-05-24','17:10:00',2.05),('10318','2013-05-24','17:15:00',2.16),('10318','2013-05-24','17:20:00',2.49),('10318','2013-05-24','17:25:00',2.3),('10318','2013-05-24','17:30:00',2.13),('10318','2013-05-24','17:35:00',2.07),('10318','2013-05-24','17:40:00',2.07),('10318','2013-05-24','17:45:00',1.91),('10318','2013-05-24','17:50:00',1.49),('10318','2013-05-24','17:55:00',1.12),('10318','2013-05-24','18:00:00',1.11),('10318','2013-05-24','18:05:00',1.17),('10318','2013-05-24','18:10:00',1.05),('10318','2013-05-24','18:30:00',1.03),('10318','2013-05-23','07:00:00',1.35),('10318','2013-05-23','07:05:00',1.8),('10318','2013-05-23','07:10:00',1.66),('10318','2013-05-23','07:35:00',1.14),('10318','2013-05-23','07:40:00',1.38),('10318','2013-05-23','07:45:00',1.84),('10318','2013-05-23','07:50:00',2.24),('10318','2013-05-23','07:55:00',2.29),('10318','2013-05-23','08:00:00',2.6),('10318','2013-05-23','08:05:00',3.4),('10318','2013-05-23','08:10:00',2.12),('10318','2013-05-23','08:15:00',1.68),('10318','2013-05-23','08:20:00',1.26),('10318','2013-05-23','08:25:00',2.6),('10318','2013-05-23','08:30:00',4.56),('10318','2013-05-23','08:35:00',6.35),('10318','2013-05-23','08:40:00',6.86),('10318','2013-05-23','08:45:00',2.13),('10318','2013-05-23','08:55:00',1.63),('10318','2013-05-23','09:00:00',1.84),('10318','2013-05-23','09:15:00',3.78),('10318','2013-05-23','09:20:00',7.78),('10318','2013-05-23','09:25:00',4.86),('10318','2013-05-23','09:30:00',2.71),('10318','2013-05-23','09:35:00',5.89),('10318','2013-05-23','09:40:00',5.11),('10318','2013-05-23','09:45:00',7.46),('10318','2013-05-23','09:50:00',4.92),('10318','2013-05-23','09:55:00',5.85),('10318','2013-05-23','10:00:00',9.06),('10318','2013-05-23','10:05:00',5.84),('10318','2013-05-23','10:10:00',6.72),('10318','2013-05-23','10:15:00',7.58),('10318','2013-05-23','10:20:00',8.27),('10318','2013-05-23','10:25:00',9.13),('10318','2013-05-23','10:30:00',9),('10318','2013-05-23','10:35:00',5.61),('10318','2013-05-23','10:40:00',7.47),('10318','2013-05-23','10:45:00',9),('10318','2013-05-23','10:50:00',9.05),('10318','2013-05-23','10:55:00',4.79),('10318','2013-05-23','11:00:00',8.75),('10318','2013-05-23','11:05:00',5.57),('10318','2013-05-23','11:10:00',8.69),('10318','2013-05-23','11:15:00',8.8),('10318','2013-05-23','11:20:00',4.42),('10318','2013-05-23','11:25:00',8.48),('10318','2013-05-23','11:30:00',8.42),('10318','2013-05-23','11:35:00',10.87),('10318','2013-05-23','11:40:00',7.87),('10318','2013-05-23','11:45:00',3.55),('10318','2013-05-23','11:50:00',3),('10318','2013-05-23','11:55:00',7.36),('10318','2013-05-23','12:00:00',10.81),('10318','2013-05-23','12:05:00',10.05),('10318','2013-05-23','12:10:00',8.63),('10318','2013-05-23','12:15:00',8.25),('10318','2013-05-23','12:20:00',7.92),('10318','2013-05-23','12:25:00',3.41),('10318','2013-05-23','12:30:00',2.23),('10318','2013-05-23','12:35:00',4.59),('10318','2013-05-23','12:40:00',9.63),('10318','2013-05-23','12:45:00',8.41),('10318','2013-05-23','12:50:00',4.65),('10318','2013-05-23','12:55:00',7.21),('10318','2013-05-23','13:00:00',7.98),('10318','2013-05-23','13:05:00',9.35),('10318','2013-05-23','13:10:00',8.51),('10318','2013-05-23','13:15:00',10.59),('10318','2013-05-23','13:20:00',8.44),('10318','2013-05-23','13:25:00',6.54),('10318','2013-05-23','13:30:00',4.86),('10318','2013-05-23','13:35:00',7.86),('10318','2013-05-23','13:40:00',9.05),('10318','2013-05-23','13:45:00',6.3),('10318','2013-05-23','13:50:00',10.36),('10318','2013-05-23','13:55:00',7.14),('10318','2013-05-23','14:00:00',5.58),('10318','2013-05-23','14:05:00',4.71),('10318','2013-05-23','14:10:00',8.03),('10318','2013-05-23','14:15:00',6.64),('10318','2013-05-23','14:20:00',5.09),('10318','2013-05-23','14:25:00',4.55),('10318','2013-05-23','14:30:00',6.86),('10318','2013-05-23','14:35:00',5.65),('10318','2013-05-23','14:40:00',3.49),('10318','2013-05-23','14:45:00',5.02),('10318','2013-05-23','14:50:00',9.6),('10318','2013-05-23','14:55:00',7.07),('10318','2013-05-23','15:00:00',6.89),('10318','2013-05-23','15:05:00',5.73),('10318','2013-05-23','15:10:00',4.03),('10318','2013-05-23','15:15:00',8.41),('10318','2013-05-23','15:20:00',6.35),('10318','2013-05-23','15:25:00',9.5),('10318','2013-05-23','15:30:00',4.56),('10318','2013-05-23','15:35:00',5.69),('10318','2013-05-23','15:40:00',8.24),('10318','2013-05-23','15:45:00',4.66),('10318','2013-05-23','15:50:00',3.69),('10318','2013-05-23','15:55:00',7.47),('10318','2013-05-23','16:00:00',5.19),('10318','2013-05-23','16:05:00',4.72),('10318','2013-05-23','16:10:00',5.89),('10318','2013-05-23','16:15:00',7.43),('10318','2013-05-23','16:20:00',5.67),('10318','2013-05-23','16:25:00',4.18),('10318','2013-05-23','16:30:00',4.48),('10318','2013-05-23','16:35:00',4.9),('10318','2013-05-23','16:40:00',4.42),('10318','2013-05-23','16:45:00',4.06),('10318','2013-05-23','16:50:00',1.7),('10318','2013-05-23','16:55:00',1.33),('10318','2013-05-23','17:00:00',2.11),('10318','2013-05-23','17:05:00',4.67),('10318','2013-05-23','17:10:00',5.29),('10318','2013-05-23','17:15:00',1.87),('10318','2013-05-23','17:20:00',2.4),('10318','2013-05-23','17:25:00',1.66),('10318','2013-05-23','17:30:00',1.85),('10318','2013-05-23','17:35:00',1.93),('10318','2013-05-23','17:40:00',1.8),('10318','2013-05-23','17:45:00',2.02),('10318','2013-05-23','17:50:00',2.74),('10318','2013-05-23','17:55:00',2.85),('10318','2013-05-23','18:00:00',4.3),('10318','2013-05-23','18:05:00',2.19),('10318','2013-05-23','18:10:00',1.24),('10318','2013-05-23','18:35:00',1.07),('10318','2013-05-23','18:40:00',1.54),('10318','2013-05-23','18:45:00',1.91),('10318','2013-05-23','18:50:00',2.09),('10318','2013-05-23','18:55:00',1.83),('10318','2013-05-23','19:00:00',1.27),('10318','2013-05-22','07:10:00',1.06),('10318','2013-05-22','07:15:00',1.29),('10318','2013-05-22','07:20:00',1.39),('10318','2013-05-22','07:25:00',1.43),('10318','2013-05-22','07:30:00',1.29),('10318','2013-05-22','07:35:00',1.3),('10318','2013-05-22','07:40:00',1.5),('10318','2013-05-22','07:45:00',1.79),('10318','2013-05-22','07:50:00',2.28),('10318','2013-05-22','07:55:00',2.42),('10318','2013-05-22','08:00:00',2.67),('10318','2013-05-22','08:05:00',3.55),('10318','2013-05-22','08:10:00',3.94),('10318','2013-05-22','08:15:00',5.11),('10318','2013-05-22','08:20:00',3.38),('10318','2013-05-22','08:25:00',4.36),('10318','2013-05-22','08:30:00',5.71),('10318','2013-05-22','08:35:00',5.88),('10318','2013-05-22','08:40:00',2.89),('10318','2013-05-22','08:45:00',2.78),('10318','2013-05-22','08:50:00',1.24),('10318','2013-05-22','09:10:00',1.46),('10318','2013-05-22','09:15:00',2.02),('10318','2013-05-22','09:20:00',2.96),('10318','2013-05-22','09:25:00',5.07),('10318','2013-05-22','09:30:00',7.51),('10318','2013-05-22','09:35:00',7.36),('10318','2013-05-22','09:40:00',7.39),('10318','2013-05-22','09:45:00',7.4),('10318','2013-05-22','09:50:00',7.53),('10318','2013-05-22','09:55:00',7.49),('10318','2013-05-22','10:00:00',7.83),('10318','2013-05-22','10:05:00',7.94),('10318','2013-05-22','10:10:00',8),('10318','2013-05-22','10:15:00',8.1),('10318','2013-05-22','10:20:00',7.73),('10318','2013-05-22','10:25:00',6.55),('10318','2013-05-22','10:30:00',7.67),('10318','2013-05-22','10:35:00',8.63),('10318','2013-05-22','10:40:00',9.32),('10318','2013-05-22','10:45:00',8.95),('10318','2013-05-22','10:50:00',8.7),('10318','2013-05-22','10:55:00',8.7),('10318','2013-05-22','11:00:00',8.95),('10318','2013-05-22','11:05:00',7.97),('10318','2013-05-22','11:10:00',9.24),('10318','2013-05-22','11:15:00',9.25),('10318','2013-05-22','11:20:00',9.29),('10318','2013-05-22','11:25:00',9.05),('10318','2013-05-22','11:30:00',6.42),('10318','2013-05-22','11:35:00',9.53),('10318','2013-05-22','11:40:00',10.15),('10318','2013-05-22','11:45:00',8.23),('10318','2013-05-22','11:50:00',8.24),('10318','2013-05-22','11:55:00',5.1),('10318','2013-05-22','12:00:00',5.59),('10318','2013-05-22','12:05:00',5.54),('10318','2013-05-22','12:10:00',5.39),('10318','2013-05-22','12:15:00',6.2),('10318','2013-05-22','12:20:00',8.33),('10318','2013-05-22','12:25:00',8.36),('10318','2013-05-22','12:30:00',4.34),('10318','2013-05-22','12:35:00',3.95),('10318','2013-05-22','12:40:00',3.23),('10318','2013-05-22','12:45:00',1.78),('10318','2013-05-22','13:00:00',1.6),('10318','2013-05-22','13:05:00',6.93),('10318','2013-05-22','13:10:00',4.67),('10318','2013-05-22','13:15:00',5.56),('10318','2013-05-22','13:20:00',5.15),('10318','2013-05-22','13:25:00',2.46),('10318','2013-05-22','13:30:00',6.92),('10318','2013-05-22','13:35:00',8.66),('10318','2013-05-22','13:40:00',9.21),('10318','2013-05-22','13:45:00',7.78),('10318','2013-05-22','13:50:00',8),('10318','2013-05-22','13:55:00',9.66),('10318','2013-05-22','14:00:00',7.97),('10318','2013-05-22','14:05:00',7.47),('10318','2013-05-22','14:10:00',9.38),('10318','2013-05-22','14:15:00',9.15),('10318','2013-05-22','14:20:00',8.91),('10318','2013-05-22','14:25:00',8.76),('10318','2013-05-22','14:30:00',8.68),('10318','2013-05-22','14:35:00',8.61),('10318','2013-05-22','14:40:00',8.46),('10318','2013-05-22','14:45:00',8.4),('10318','2013-05-22','14:50:00',8.3),('10318','2013-05-22','14:55:00',8.18),('10318','2013-05-22','15:00:00',8.08),('10318','2013-05-22','15:05:00',7.95),('10318','2013-05-22','15:10:00',7.42),('10318','2013-05-22','15:15:00',7.56),('10318','2013-05-22','15:20:00',7.98),('10318','2013-05-22','15:25:00',5.48),('10318','2013-05-22','15:30:00',5.96),('10318','2013-05-22','15:35:00',4.1),('10318','2013-05-22','15:40:00',7.03),('10318','2013-05-22','15:45:00',7.24),('10318','2013-05-22','15:50:00',6.97),('10318','2013-05-22','15:55:00',6.7),('10318','2013-05-22','16:00:00',6.56),('10318','2013-05-22','16:05:00',6.33),('10318','2013-05-22','16:10:00',6.23),('10318','2013-05-22','16:15:00',6.06),('10318','2013-05-22','16:20:00',5.86),('10318','2013-05-22','16:25:00',5.73),('10318','2013-05-22','16:30:00',4.08),('10318','2013-05-22','16:35:00',4.67),('10318','2013-05-22','16:40:00',5.16),('10318','2013-05-22','16:45:00',4.03),('10318','2013-05-22','16:50:00',2.27),('10318','2013-05-22','16:55:00',1.64),('10318','2013-05-22','17:00:00',1.41),('10318','2013-05-22','17:05:00',1.45),('10318','2013-05-22','17:10:00',1.54),('10318','2013-05-22','17:15:00',2.58),('10318','2013-05-22','17:20:00',2.82),('10318','2013-05-22','17:25:00',2.78),('10318','2013-05-22','17:30:00',2.89),('10318','2013-05-22','17:35:00',3.44),('10318','2013-05-22','17:40:00',2.17),('10318','2013-05-22','17:45:00',1.06),('10318','2013-05-22','17:50:00',1.01),('10318','2013-05-22','17:55:00',2.55),('10318','2013-05-22','18:00:00',3.47),('10318','2013-05-22','18:05:00',2.87),('10318','2013-05-22','18:10:00',1.43),('10318','2013-05-22','18:15:00',1.28),('10318','2013-05-22','18:20:00',1.13),('10318','2013-05-22','18:25:00',1.43),('10318','2013-05-22','18:30:00',1.28),('10318','2013-05-22','18:40:00',1.05),('10318','2013-05-22','18:45:00',1.09),('10318','2013-05-22','19:05:00',1.04),('10318','2014-04-01','07:50:00',1.07),('10318','2014-04-01','07:55:00',1.35),('10318','2014-04-01','08:00:00',1.52),('10318','2014-04-01','08:05:00',2.22),('10318','2014-04-01','08:10:00',2.74),('10318','2014-04-01','08:15:00',2.93),('10318','2014-04-01','08:20:00',3.22),('10318','2014-04-01','08:25:00',3.59),('10318','2014-04-01','08:30:00',3.8),('10318','2014-04-01','08:35:00',4.03),('10318','2014-04-01','08:40:00',4.28),('10318','2014-04-01','08:45:00',4.54),('10318','2014-04-01','08:50:00',4.79),('10318','2014-04-01','08:55:00',4.99),('10318','2014-04-01','09:00:00',5.22),('10318','2014-04-01','09:05:00',5.41),('10318','2014-04-01','09:10:00',5.63),('10318','2014-04-01','09:15:00',5.79),('10318','2014-04-01','09:20:00',5.94),('10318','2014-04-01','09:25:00',6.1),('10318','2014-04-01','09:30:00',6.24),('10318','2014-04-01','09:35:00',6.51),('10318','2014-04-01','09:40:00',6.6),('10318','2014-04-01','09:45:00',6.67),('10318','2014-04-01','09:50:00',6.69),('10318','2014-04-01','09:55:00',7.08),('10318','2014-04-01','10:00:00',7.2),('10318','2014-04-01','10:05:00',7.63),('10318','2014-04-01','10:10:00',7.7),('10318','2014-04-01','10:15:00',4.62),('10318','2014-04-01','10:20:00',5.58),('10318','2014-04-01','10:25:00',8.31),('10318','2014-04-01','10:30:00',8.25),('10318','2014-04-01','10:35:00',8.22),('10318','2014-04-01','10:40:00',8.41),('10318','2014-04-01','10:45:00',8.44),('10318','2014-04-01','10:50:00',8.41),('10318','2014-04-01','10:55:00',8.47),('10318','2014-04-01','11:00:00',8.71),('10318','2014-04-01','11:05:00',8.85),('10318','2014-04-01','11:10:00',8.77),('10318','2014-04-01','11:15:00',8.83),('10318','2014-04-01','11:20:00',8.99),('10318','2014-04-01','11:25:00',9.12),('10318','2014-04-01','11:30:00',9.18),('10318','2014-04-01','11:35:00',8.96),('10318','2014-04-01','11:40:00',9.26),('10318','2014-04-01','11:45:00',9.47),('10318','2014-04-01','11:50:00',9.31),('10318','2014-04-01','11:55:00',9.51),('10318','2014-04-01','12:00:00',9.43),('10318','2014-04-01','12:05:00',9.5),('10318','2014-04-01','12:10:00',9.55),('10318','2014-04-01','12:15:00',9.62),('10318','2014-04-01','12:20:00',9.62),('10318','2014-04-01','12:25:00',9.7),('10318','2014-04-01','12:30:00',9.74),('10318','2014-04-01','12:35:00',9.76),('10318','2014-04-01','12:40:00',9.75),('10318','2014-04-01','12:45:00',9.71),('10318','2014-04-01','12:50:00',9.75),('10318','2014-04-01','12:55:00',9.85),('10318','2014-04-01','13:00:00',8.27),('10318','2014-04-01','13:05:00',9.88),('10318','2014-04-01','13:10:00',9.39),('10318','2014-04-01','13:15:00',9.41),('10318','2014-04-01','13:20:00',9.38),('10318','2014-04-01','13:25:00',8.79),('10318','2014-04-01','13:30:00',9.11),('10318','2014-04-01','13:35:00',9.72),('10318','2014-04-01','13:40:00',10.03),('10318','2014-04-01','13:45:00',9.75),('10318','2014-04-01','13:50:00',9.33),('10318','2014-04-01','13:55:00',9.27),('10318','2014-04-01','14:00:00',9.43),('10318','2014-04-01','14:05:00',9.25),('10318','2014-04-01','14:10:00',8.98),('10318','2014-04-01','14:15:00',9.02),('10318','2014-04-01','14:20:00',8.99),('10318','2014-04-01','14:25:00',9.01),('10318','2014-04-01','14:30:00',9),('10318','2014-04-01','14:35:00',8.88),('10318','2014-04-01','14:40:00',9.18),('10318','2014-04-01','14:45:00',7.93),('10318','2014-04-01','14:50:00',7.4),('10318','2014-04-01','14:55:00',8.41),('10318','2014-04-01','15:00:00',7.15),('10318','2014-04-01','15:05:00',7.1),('10318','2014-04-01','15:10:00',7.64),('10318','2014-04-01','15:15:00',8.07),('10318','2014-04-01','15:20:00',5.49),('10318','2014-04-01','15:25:00',5.49),('10318','2014-04-01','15:30:00',8.13),('10318','2014-04-01','15:35:00',6.58),('10318','2014-04-01','15:40:00',6.25),('10318','2014-04-01','15:45:00',6.95),('10318','2014-04-01','15:50:00',5.99),('10318','2014-04-01','15:55:00',6.4),('10318','2014-04-01','16:00:00',5.99),('10318','2014-04-01','16:05:00',5.76),('10318','2014-04-01','16:10:00',2.89),('10318','2014-04-01','16:15:00',5.65),('10318','2014-04-01','16:20:00',4.3),('10318','2014-04-01','16:25:00',2.5),('10318','2014-04-01','16:30:00',3.24),('10318','2014-04-01','16:35:00',4.84),('10318','2014-04-01','16:40:00',3.01),('10318','2014-04-01','16:45:00',4.54),('10318','2014-04-01','16:50:00',3.96),('10318','2014-04-01','16:55:00',3.71),('10318','2014-04-01','17:00:00',3.95),('10318','2014-04-01','17:05:00',3.95),('10318','2014-04-01','17:10:00',3.71),('10318','2014-04-01','17:15:00',3.53),('10318','2014-04-01','17:20:00',2.64),('10318','2014-04-01','17:25:00',3.08),('10318','2014-04-01','17:30:00',3),('10318','2014-04-01','17:35:00',2.77),('10318','2014-04-01','17:40:00',2.53),('10318','2014-04-01','17:45:00',2.4),('10318','2014-04-01','17:50:00',2.21),('10318','2014-04-01','17:55:00',1.97),('10318','2014-04-01','18:00:00',1.85),('10318','2014-04-01','18:05:00',1.33),('10318','2014-04-01','18:10:00',1.53),('10318','2014-04-01','18:15:00',1.32),('10318','2013-05-21','06:55:00',1.09),('10318','2013-05-21','07:00:00',1.39),('10318','2013-05-21','07:05:00',1.61),('10318','2013-05-21','07:10:00',1.82),('10318','2013-05-21','07:15:00',2.09),('10318','2013-05-21','07:20:00',2.33),('10318','2013-05-21','07:25:00',2.65),('10318','2013-05-21','07:30:00',3.09),('10318','2013-05-21','07:35:00',3.75),('10318','2013-05-21','07:40:00',4.13),('10318','2013-05-21','07:45:00',3.64),('10318','2013-05-21','07:50:00',2.47),('10318','2013-05-21','07:55:00',3.61),('10318','2013-05-21','08:00:00',2.37),('10318','2013-05-21','08:05:00',3.36),('10318','2013-05-21','08:10:00',5.32),('10318','2013-05-21','08:15:00',4.75),('10318','2013-05-21','08:20:00',3.68),('10318','2013-05-21','08:25:00',4.77),('10318','2013-05-21','08:30:00',3.03),('10318','2013-05-21','08:35:00',3.23),('10318','2013-05-21','08:40:00',3.62),('10318','2013-05-21','08:45:00',2.95),('10318','2013-05-21','08:50:00',3.32),('10318','2013-05-21','08:55:00',3.79),('10318','2013-05-21','09:00:00',3.31),('10318','2013-05-21','09:05:00',3.12),('10318','2013-05-21','09:10:00',3.79),('10318','2013-05-21','09:15:00',4.03),('10318','2013-05-21','09:20:00',4.8),('10318','2013-05-21','09:25:00',6.23),('10318','2013-05-21','09:30:00',4.78),('10318','2013-05-21','09:35:00',4.25),('10318','2013-05-21','09:40:00',4.3),('10318','2013-05-21','09:45:00',3.86),('10318','2013-05-21','09:50:00',3.99),('10318','2013-05-21','09:55:00',4.26),('10318','2013-05-21','10:00:00',4.58),('10318','2013-05-21','10:05:00',4.84),('10318','2013-05-21','10:10:00',4.87),('10318','2013-05-21','10:15:00',4.65),('10318','2013-05-21','10:20:00',4.37),('10318','2013-05-21','10:25:00',4.79),('10318','2013-05-21','10:30:00',4.1),('10318','2013-05-21','10:35:00',4.44),('10318','2013-05-21','10:40:00',5.72),('10318','2013-05-21','10:45:00',6.75),('10318','2013-05-21','10:50:00',5.41),('10318','2013-05-21','10:55:00',3.98),('10318','2013-05-21','11:00:00',4.21),('10318','2013-05-21','11:05:00',3.92),('10318','2013-05-21','11:10:00',5.7),('10318','2013-05-21','11:15:00',7.81),('10318','2013-05-21','11:20:00',9.45),('10318','2013-05-21','11:25:00',10.23),('10318','2013-05-21','11:30:00',8.56),('10318','2013-05-21','11:35:00',5.19),('10318','2013-05-21','11:40:00',5.49),('10318','2013-05-21','11:45:00',7.68),('10318','2013-05-21','11:50:00',5.83),('10318','2013-05-21','11:55:00',6.2),('10318','2013-05-21','12:00:00',7.3),('10318','2013-05-21','12:05:00',6.9),('10318','2013-05-21','12:10:00',6.52),('10318','2013-05-21','12:15:00',5.95),('10318','2013-05-21','12:20:00',6.35),('10318','2013-05-21','12:25:00',6.53),('10318','2013-05-21','12:30:00',8.61),('10318','2013-05-21','12:35:00',6.08),('10318','2013-05-21','12:40:00',8.04),('10318','2013-05-21','12:45:00',10.1),('10318','2013-05-21','12:50:00',6.05),('10318','2013-05-21','12:55:00',8.28),('10318','2013-05-21','13:00:00',6.47),('10318','2013-05-21','13:05:00',9.14),('10318','2013-05-21','13:10:00',6.28),('10318','2013-05-21','13:15:00',7.96),('10318','2013-05-21','13:20:00',8.18),('10318','2013-05-21','13:25:00',7.06),('10318','2013-05-21','13:30:00',4.39),('10318','2013-05-21','13:35:00',3.05),('10318','2013-05-21','13:40:00',1.84),('10318','2013-05-21','13:45:00',1.28),('10318','2013-05-21','14:00:00',1.3),('10318','2013-05-21','14:05:00',2.53),('10318','2013-05-21','14:10:00',3.54),('10318','2013-05-21','14:15:00',4.1),('10318','2013-05-21','14:20:00',3.71),('10318','2013-05-21','14:25:00',4.87),('10318','2013-05-21','14:30:00',5.71),('10318','2013-05-21','14:35:00',5.09),('10318','2013-05-21','14:40:00',4.3),('10318','2013-05-21','14:45:00',3.26),('10318','2013-05-21','14:50:00',1.86),('10318','2013-05-21','14:55:00',1.39),('10318','2013-05-21','15:00:00',1.08),('10318','2013-05-21','15:05:00',1.2),('10318','2013-05-21','15:10:00',1.53),('10318','2013-05-21','15:15:00',2.79),('10318','2013-05-21','15:20:00',3.48),('10318','2013-05-21','15:25:00',3.87),('10318','2013-05-21','15:30:00',4.79),('10318','2013-05-21','15:35:00',4.28),('10318','2013-05-21','15:40:00',3.93),('10318','2013-05-21','15:45:00',3.84),('10318','2013-05-21','15:50:00',2.7),('10318','2013-05-21','15:55:00',2.5),('10318','2013-05-21','16:00:00',2.36),('10318','2013-05-21','16:05:00',2.57),('10318','2013-05-21','16:10:00',2.85),('10318','2013-05-21','16:15:00',2.18),('10318','2013-05-21','16:20:00',2.03),('10318','2013-05-21','16:25:00',2.69),('10318','2013-05-21','16:30:00',3.41),('10318','2013-05-21','16:35:00',4.03),('10318','2013-05-21','16:40:00',3.93),('10318','2013-05-21','16:45:00',2.96),('10318','2013-05-21','16:50:00',2.28),('10318','2013-05-21','16:55:00',1.34),('10318','2013-05-21','17:00:00',1.3),('10318','2013-05-21','17:05:00',1.6),('10318','2013-05-21','17:10:00',1.35),('10318','2013-05-20','06:50:00',1.14),('10318','2013-05-20','06:55:00',1.3),('10318','2013-05-20','07:00:00',1.49),('10318','2013-05-20','07:05:00',1.69),('10318','2013-05-20','07:10:00',1.67),('10318','2013-05-20','07:15:00',2.4),('10318','2013-05-20','07:20:00',2.79),('10318','2013-05-20','07:25:00',2.72),('10318','2013-05-20','07:30:00',3),('10318','2013-05-20','07:35:00',3.62),('10318','2013-05-20','07:40:00',3.07),('10318','2013-05-20','07:45:00',2.15),('10318','2013-05-20','07:50:00',3.68),('10318','2013-05-20','07:55:00',4.09),('10318','2013-05-20','08:00:00',4.19),('10318','2013-05-20','08:05:00',2.75),('10318','2013-05-20','08:10:00',3.76),('10318','2013-05-20','08:15:00',5.09),('10318','2013-05-20','08:20:00',5.32),('10318','2013-05-20','08:25:00',3.19),('10318','2013-05-20','08:30:00',6.48),('10318','2013-05-20','08:35:00',3.05),('10318','2013-05-20','08:40:00',4.34),('10318','2013-05-20','08:45:00',2.87),('10318','2013-05-20','08:50:00',3.61),('10318','2013-05-20','08:55:00',3.24),('10318','2013-05-20','09:00:00',8.11),('10318','2013-05-20','09:05:00',7),('10318','2013-05-20','09:10:00',2.67),('10318','2013-05-20','09:15:00',1.57),('10318','2013-05-20','09:20:00',5.22),('10318','2013-05-20','09:25:00',7.38),('10318','2013-05-20','09:30:00',6.42),('10318','2013-05-20','09:35:00',4.49),('10318','2013-05-20','09:40:00',8.97),('10318','2013-05-20','09:45:00',8.78),('10318','2013-05-20','09:50:00',8.89),('10318','2013-05-20','09:55:00',9.57),('10318','2013-05-20','10:00:00',6.94),('10318','2013-05-20','10:05:00',5.9),('10318','2013-05-20','10:10:00',6.88),('10318','2013-05-20','10:15:00',3.29),('10318','2013-05-20','10:20:00',9.66),('10318','2013-05-20','10:25:00',4.32),('10318','2013-05-20','10:30:00',9.44),('10318','2013-05-20','10:35:00',10.53),('10318','2013-05-20','10:40:00',9.5),('10318','2013-05-20','10:45:00',8.46),('10318','2013-05-20','10:50:00',9.52),('10318','2013-05-20','10:55:00',6.55),('10318','2013-05-20','11:00:00',9.02),('10318','2013-05-20','11:05:00',4.67),('10318','2013-05-20','11:10:00',6.43),('10318','2013-05-20','11:15:00',10.23),('10318','2013-05-20','11:20:00',9.54),('10318','2013-05-20','11:25:00',3.53),('10318','2013-05-20','11:30:00',7.93),('10318','2013-05-20','11:35:00',5.1),('10318','2013-05-20','11:40:00',5.17),('10318','2013-05-20','11:45:00',6.87),('10318','2013-05-20','11:50:00',5.49),('10318','2013-05-20','11:55:00',4.04),('10318','2013-05-20','12:00:00',2.99),('10318','2013-05-20','12:05:00',3.57),('10318','2013-05-20','12:10:00',6.22),('10318','2013-05-20','12:15:00',3.25),('10318','2013-05-20','12:20:00',2.4),('10318','2013-05-20','12:25:00',2.9),('10318','2013-05-20','12:30:00',8.58),('10318','2013-05-20','12:35:00',10.01),('10318','2013-05-20','12:40:00',6.85),('10318','2013-05-20','12:45:00',10.69),('10318','2013-05-20','12:50:00',6.71),('10318','2013-05-20','12:55:00',9.66),('10318','2013-05-20','13:00:00',4.18),('10318','2013-05-20','13:05:00',6.12),('10318','2013-05-20','13:10:00',6.79),('10318','2013-05-20','13:15:00',4.57),('10318','2013-05-20','13:20:00',9.32),('10318','2013-05-20','13:25:00',4.95),('10318','2013-05-20','13:30:00',10.53),('10318','2013-05-20','13:35:00',6.76),('10318','2013-05-20','13:40:00',8.5),('10318','2013-05-20','13:45:00',7.45),('10318','2013-05-20','13:50:00',9.7),('10318','2013-05-20','13:55:00',10.19),('10318','2013-05-20','14:00:00',9.95),('10318','2013-05-20','14:05:00',9.97),('10318','2013-05-20','14:10:00',9.83),('10318','2013-05-20','14:15:00',9.64),('10318','2013-05-20','14:20:00',9.53),('10318','2013-05-20','14:25:00',9.4),('10318','2013-05-20','14:30:00',9.35),('10318','2013-05-20','14:35:00',9.23),('10318','2013-05-20','14:40:00',9.41),('10318','2013-05-20','14:45:00',8.85),('10318','2013-05-20','14:50:00',8.99),('10318','2013-05-20','14:55:00',9.12),('10318','2013-05-20','15:00:00',8.9),('10318','2013-05-20','15:05:00',8.88),('10318','2013-05-20','15:10:00',3.48),('10318','2013-05-20','15:15:00',3.9),('10318','2013-05-20','15:20:00',8.55),('10318','2013-05-20','15:25:00',4.36),('10318','2013-05-20','15:30:00',3.47),('10318','2013-05-20','15:35:00',7.66),('10318','2013-05-20','15:40:00',8.48),('10318','2013-05-20','15:45:00',8.21),('10318','2013-05-20','15:50:00',7.74),('10318','2013-05-20','15:55:00',4.78),('10318','2013-05-20','16:00:00',7.38),('10318','2013-05-20','16:05:00',7.05),('10318','2013-05-20','16:10:00',6.82),('10318','2013-05-20','16:15:00',6.69),('10318','2013-05-20','16:20:00',6.39),('10318','2013-05-20','16:25:00',6.22),('10318','2013-05-20','16:30:00',5.95),('10318','2013-05-20','16:35:00',5.82),('10318','2013-05-20','16:40:00',5.6),('10318','2013-05-20','16:45:00',5.12),('10318','2013-05-20','16:50:00',5.19),('10318','2013-05-20','16:55:00',4.96),('10318','2013-05-20','17:00:00',3.67),('10318','2013-05-20','17:05:00',4.25),('10318','2013-05-20','17:10:00',4.62),('10318','2013-05-20','17:15:00',3.08),('10318','2013-05-20','17:20:00',5.1),('10318','2013-05-20','17:25:00',4.89),('10318','2013-05-20','17:30:00',4.21),('10318','2013-05-20','17:35:00',3.54),('10318','2013-05-20','17:40:00',3.25),('10318','2013-05-20','17:45:00',3.06),('10318','2013-05-20','17:50:00',2.88),('10318','2013-05-20','17:55:00',2.68),('10318','2013-05-20','18:00:00',2.55),('10318','2013-05-20','18:05:00',2.44),('10318','2013-05-20','18:10:00',2.17),('10318','2013-05-20','18:15:00',2.23),('10318','2013-05-20','18:20:00',1.94),('10318','2013-05-20','18:25:00',1.68),('10318','2013-05-20','18:30:00',1.5),('10318','2013-05-20','18:35:00',1.3),('10318','2013-05-20','18:40:00',1.01),('10318','2013-05-20','18:45:00',1.07),('10318','2013-05-19','07:00:00',1.11),('10318','2013-05-19','07:05:00',1.14),('10318','2013-05-19','07:10:00',1.07),('10318','2013-05-19','07:15:00',1.08),('10318','2013-05-19','08:00:00',1.25),('10318','2013-05-19','08:10:00',1.19),('10318','2013-05-19','08:15:00',1.51),('10318','2013-05-19','08:20:00',1.36),('10318','2013-05-19','08:25:00',1.72),('10318','2013-05-19','08:30:00',2.15),('10318','2013-05-19','08:35:00',2.68),('10318','2013-05-19','08:40:00',3.01),('10318','2013-05-19','08:45:00',3.19),('10318','2013-05-19','08:50:00',2.49),('10318','2013-05-19','08:55:00',2.87),('10318','2013-05-19','09:00:00',2.86),('10318','2013-05-19','09:05:00',2.43),('10318','2013-05-19','09:10:00',2.68),('10318','2013-05-19','09:15:00',2.39),('10318','2013-05-19','09:20:00',1.27),('10318','2013-05-19','09:25:00',1.19),('10318','2013-05-19','09:30:00',1.77),('10318','2013-05-19','09:35:00',2.32),('10318','2013-05-19','09:40:00',2.14),('10318','2013-05-19','09:45:00',1.87),('10318','2013-05-19','09:50:00',2.43),('10318','2013-05-19','09:55:00',3.55),('10318','2013-05-19','10:00:00',3.83),('10318','2013-05-19','10:05:00',4.22),('10318','2013-05-19','10:10:00',6.24),('10318','2013-05-19','10:15:00',6.5),('10318','2013-05-19','10:20:00',7.03),('10318','2013-05-19','10:25:00',6.85),('10318','2013-05-19','10:30:00',7.32),('10318','2013-05-19','10:35:00',8.13),('10318','2013-05-19','10:40:00',8.43),('10318','2013-05-19','10:45:00',8.68),('10318','2013-05-19','10:50:00',8.73),('10318','2013-05-19','10:55:00',9.38),('10318','2013-05-19','11:00:00',9.25),('10318','2013-05-19','11:05:00',11.05),('10318','2013-05-19','11:10:00',10.01),('10318','2013-05-19','11:15:00',10.8),('10318','2013-05-19','11:20:00',10.4),('10318','2013-05-19','11:25:00',10.49),('10318','2013-05-19','11:30:00',10.19),('10318','2013-05-19','11:35:00',10.17),('10318','2013-05-19','11:40:00',9.88),('10318','2013-05-19','11:45:00',9.88),('10318','2013-05-19','11:50:00',10.05),('10318','2013-05-19','11:55:00',10.22),('10318','2013-05-19','12:00:00',10.26),('10318','2013-05-19','12:05:00',10.34),('10318','2013-05-19','12:10:00',10.41),('10318','2013-05-19','12:15:00',10.57),('10318','2013-05-19','12:20:00',8.05),('10318','2013-05-19','12:25:00',5.62),('10318','2013-05-19','12:30:00',5.03),('10318','2013-05-19','12:35:00',7.04),('10318','2013-05-19','12:40:00',6.18),('10318','2013-05-19','12:45:00',6.69),('10318','2013-05-19','12:50:00',6.53),('10318','2013-05-19','12:55:00',5.43),('10318','2013-05-19','13:00:00',8.75),('10318','2013-05-19','13:05:00',9.16),('10318','2013-05-19','13:10:00',10.21),('10318','2013-05-19','13:15:00',10.07),('10318','2013-05-19','13:20:00',10.5),('10318','2013-05-19','13:25:00',10.01),('10318','2013-05-19','13:30:00',10.01),('10318','2013-05-19','13:35:00',9.97),('10318','2013-05-19','13:40:00',9.96),('10318','2013-05-19','13:45:00',9.81),('10318','2013-05-19','13:50:00',9.72),('10318','2013-05-19','13:55:00',9.63),('10318','2013-05-19','14:00:00',9.31),('10318','2013-05-19','14:05:00',9.61),('10318','2013-05-19','14:10:00',9.58),('10318','2013-05-19','14:15:00',9.49),('10318','2013-05-19','14:20:00',9.39),('10318','2013-05-19','14:25:00',9.38),('10318','2013-05-19','14:30:00',9.34),('10318','2013-05-19','14:35:00',9.21),('10318','2013-05-19','14:40:00',9.03),('10318','2013-05-19','14:45:00',8.92),('10318','2013-05-19','14:50:00',8.88),('10318','2013-05-19','14:55:00',8.85),('10318','2013-05-19','15:00:00',8.68),('10318','2013-05-19','15:05:00',8.55),('10318','2013-05-19','15:10:00',8.48),('10318','2013-05-19','15:15:00',8.41),('10318','2013-05-19','15:20:00',8.2),('10318','2013-05-19','15:25:00',8.05),('10318','2013-05-19','15:30:00',7.89),('10318','2013-05-19','15:35:00',7.8),('10318','2013-05-19','15:40:00',7.7),('10318','2013-05-19','15:45:00',7.43),('10318','2013-05-19','15:50:00',7.38),('10318','2013-05-19','15:55:00',7.2),('10318','2013-05-19','16:00:00',7.04),('10318','2013-05-19','16:05:00',6.91),('10318','2013-05-19','16:10:00',6.77),('10318','2013-05-19','16:15:00',6.56),('10318','2013-05-19','16:20:00',6.38),('10318','2013-05-19','16:25:00',6.24),('10318','2013-05-19','16:30:00',6.08),('10318','2013-05-19','16:35:00',5.89),('10318','2013-05-19','16:40:00',5.7),('10318','2013-05-19','16:45:00',5.53),('10318','2013-05-19','16:50:00',5.35),('10318','2013-05-19','16:55:00',5.18),('10318','2013-05-19','17:00:00',5.02),('10318','2013-05-19','17:05:00',4.81),('10318','2013-05-19','17:10:00',4.57),('10318','2013-05-19','17:15:00',4.4),('10318','2013-05-19','17:20:00',4.18),('10318','2013-05-19','17:25:00',3.96),('10318','2013-05-19','17:30:00',3.71),('10318','2013-05-19','17:35:00',3.57),('10318','2013-05-19','17:40:00',3.37),('10318','2013-05-19','17:45:00',3.15),('10318','2013-05-19','17:50:00',2.98),('10318','2013-05-19','17:55:00',2.78),('10318','2013-05-19','18:00:00',2.57),('10318','2013-05-19','18:05:00',2.34),('10318','2013-05-19','18:10:00',2.16),('10318','2013-05-19','18:15:00',1.97),('10318','2013-05-19','18:20:00',1.81),('10318','2013-05-19','18:25:00',1.64),('10318','2013-05-19','18:30:00',1.48),('10318','2013-05-19','18:35:00',1.33),('10318','2013-05-19','18:40:00',1.19),('10318','2013-05-19','18:45:00',1.05),('10318','2013-05-18','06:55:00',1.05),('10318','2013-05-18','07:00:00',1.38),('10318','2013-05-18','07:05:00',1.61),('10318','2013-05-18','07:10:00',1.98),('10318','2013-05-18','07:15:00',2.23),('10318','2013-05-18','07:20:00',2.42),('10318','2013-05-18','07:25:00',2.74),('10318','2013-05-18','07:30:00',3),('10318','2013-05-18','07:35:00',3.22),('10318','2013-05-18','07:40:00',3.53),('10318','2013-05-18','07:45:00',3.85),('10318','2013-05-18','07:50:00',2.39),('10318','2013-05-18','07:55:00',3.21),('10318','2013-05-18','08:00:00',4.84),('10318','2013-05-18','08:05:00',3.45),('10318','2013-05-18','08:10:00',2.32),('10318','2013-05-18','08:15:00',2.38),('10318','2013-05-18','08:20:00',3.75),('10318','2013-05-18','08:25:00',6.32),('10318','2013-05-18','08:30:00',5.03),('10318','2013-05-18','08:35:00',5.77),('10318','2013-05-18','08:40:00',5.45),('10318','2013-05-18','08:45:00',5.96),('10318','2013-05-18','08:50:00',6.18),('10318','2013-05-18','08:55:00',6.35),('10318','2013-05-18','09:00:00',6.45),('10318','2013-05-18','09:05:00',6.66),('10318','2013-05-18','09:10:00',6.79),('10318','2013-05-18','09:15:00',6.93),('10318','2013-05-18','09:20:00',7.07),('10318','2013-05-18','09:25:00',7.21),('10318','2013-05-18','09:30:00',7.36),('10318','2013-05-18','09:35:00',7.49),('10318','2013-05-18','09:40:00',7.62),('10318','2013-05-18','09:45:00',7.7),('10318','2013-05-18','09:50:00',7.83),('10318','2013-05-18','09:55:00',7.96),('10318','2013-05-18','10:00:00',8),('10318','2013-05-18','10:05:00',8.13),('10318','2013-05-18','10:10:00',8.28),('10318','2013-05-18','10:15:00',8.35),('10318','2013-05-18','10:20:00',8.42),('10318','2013-05-18','10:25:00',8.46),('10318','2013-05-18','10:30:00',8.56),('10318','2013-05-18','10:35:00',8.64),('10318','2013-05-18','10:40:00',8.72),('10318','2013-05-18','10:45:00',8.83),('10318','2013-05-18','10:50:00',8.96),('10318','2013-05-18','10:55:00',9.12),('10318','2013-05-18','11:00:00',9.14),('10318','2013-05-18','11:05:00',9.11),('10318','2013-05-18','11:10:00',8.15),('10318','2013-05-18','11:15:00',10.19),('10318','2013-05-18','11:20:00',9.93),('10318','2013-05-18','11:25:00',10.13),('10318','2013-05-18','11:30:00',9.63),('10318','2013-05-18','11:35:00',9.68),('10318','2013-05-18','11:40:00',9.39),('10318','2013-05-18','11:45:00',9.31),('10318','2013-05-18','11:50:00',9.36),('10318','2013-05-18','11:55:00',6.19),('10318','2013-05-18','12:00:00',9.12),('10318','2013-05-18','12:05:00',9.5),('10318','2013-05-18','12:10:00',9.34),('10318','2013-05-18','12:15:00',9.32),('10318','2013-05-18','12:20:00',9.39),('10318','2013-05-18','12:25:00',9.42),('10318','2013-05-18','12:30:00',8.21),('10318','2013-05-18','12:35:00',9.42),('10318','2013-05-18','12:40:00',9.06),('10318','2013-05-18','12:45:00',9.4),('10318','2013-05-18','12:50:00',9.38),('10318','2013-05-18','12:55:00',9.29),('10318','2013-05-18','13:00:00',9.29),('10318','2013-05-18','13:05:00',9.23),('10318','2013-05-18','13:10:00',9.18),('10318','2013-05-18','13:15:00',9.22),('10318','2013-05-18','13:20:00',9.15),('10318','2013-05-18','13:25:00',9.09),('10318','2013-05-18','13:30:00',9.26),('10318','2013-05-18','13:35:00',9.27),('10318','2013-05-18','13:40:00',9.12),('10318','2013-05-18','13:45:00',9.05),('10318','2013-05-18','13:50:00',8.66),('10318','2013-05-18','13:55:00',6.37),('10318','2013-05-18','14:00:00',6.64),('10318','2013-05-18','14:05:00',7.44),('10318','2013-05-18','14:10:00',8.86),('10318','2013-05-18','14:15:00',6.54),('10318','2013-05-18','14:20:00',8.55),('10318','2013-05-18','14:25:00',9.21),('10318','2013-05-18','14:30:00',8.91),('10318','2013-05-18','14:35:00',6.63),('10318','2013-05-18','14:40:00',5.77),('10318','2013-05-18','14:45:00',4.42),('10318','2013-05-18','14:50:00',6.68),('10318','2013-05-18','14:55:00',7.96),('10318','2013-05-18','15:00:00',7.88),('10318','2013-05-18','15:05:00',7.64),('10318','2013-05-18','15:10:00',7.5),('10318','2013-05-18','15:15:00',7.35),('10318','2013-05-18','15:20:00',7.23),('10318','2013-05-18','15:25:00',7.09),('10318','2013-05-18','15:30:00',6.93),('10318','2013-05-18','15:35:00',6.82),('10318','2013-05-18','15:40:00',6.69),('10318','2013-05-18','15:45:00',6.51),('10318','2013-05-18','15:50:00',6.34),('10318','2013-05-18','15:55:00',6.2),('10318','2013-05-18','16:00:00',6.09),('10318','2013-05-18','16:05:00',5.91),('10318','2013-05-18','16:10:00',5.74),('10318','2013-05-18','16:15:00',5.61),('10318','2013-05-18','16:20:00',5.46),('10318','2013-05-18','16:25:00',5.32),('10318','2013-05-18','16:30:00',5.06),('10318','2013-05-18','16:35:00',5.02),('10318','2013-05-18','16:40:00',4.86),('10318','2013-05-18','16:45:00',4.71),('10318','2013-05-18','16:50:00',4.55),('10318','2013-05-18','16:55:00',4.35),('10318','2013-05-18','17:00:00',4.18),('10318','2013-05-18','17:05:00',4.02),('10318','2013-05-18','17:10:00',3.88),('10318','2013-05-18','17:15:00',3.72),('10318','2013-05-18','17:20:00',3.56),('10318','2013-05-18','17:25:00',3.39),('10318','2013-05-18','17:30:00',3.21),('10318','2013-05-18','17:35:00',3.07),('10318','2013-05-18','17:40:00',2.93),('10318','2013-05-18','17:45:00',2.77),('10318','2013-05-18','17:50:00',2.63),('10318','2013-05-18','17:55:00',2.5),('10318','2013-05-18','18:00:00',2.33),('10318','2013-05-18','18:05:00',2.17),('10318','2013-05-18','18:10:00',2.04),('10318','2013-05-18','18:15:00',1.88),('10318','2013-05-18','18:20:00',1.78),('10318','2013-05-18','18:25:00',1.64),('10318','2013-05-18','18:30:00',1.53),('10318','2013-05-18','18:35:00',1.4),('10318','2013-05-18','18:40:00',1.29),('10318','2013-05-18','18:45:00',1.15),('10318','2013-05-18','18:50:00',1.08),('10318','2013-05-17','06:55:00',1.06),('10318','2013-05-17','07:00:00',1.22),('10318','2013-05-17','07:05:00',2.11),('10318','2013-05-17','07:10:00',1.94),('10318','2013-05-17','07:15:00',1.88),('10318','2013-05-17','07:20:00',1.98),('10318','2013-05-17','07:25:00',1.14),('10318','2013-05-17','07:30:00',1.32),('10318','2013-05-17','07:35:00',3.02),('10318','2013-05-17','07:40:00',3.38),('10318','2013-05-17','07:45:00',3.7),('10318','2013-05-17','07:50:00',4.71),('10318','2013-05-17','07:55:00',4.61),('10318','2013-05-17','08:00:00',4.76),('10318','2013-05-17','08:05:00',4.04),('10318','2013-05-17','08:10:00',4.73),('10318','2013-05-17','08:15:00',5.59),('10318','2013-05-17','08:20:00',5.52),('10318','2013-05-17','08:25:00',3.45),('10318','2013-05-17','08:30:00',1.96),('10318','2013-05-17','08:35:00',1.25),('10318','2013-05-17','09:00:00',1.13),('10318','2013-05-17','09:05:00',1.46),('10318','2013-05-17','09:10:00',1.69),('10318','2013-05-17','09:15:00',1.15),('10318','2013-05-17','09:20:00',2.17),('10318','2013-05-17','09:25:00',1.78),('10318','2013-05-17','09:30:00',1.03),('10318','2013-05-17','10:05:00',1.03),('10318','2013-05-17','10:10:00',1.3),('10318','2013-05-17','10:15:00',1.73),('10318','2013-05-17','10:20:00',2.31),('10318','2013-05-17','10:25:00',3.11),('10318','2013-05-17','10:30:00',3.64),('10318','2013-05-17','10:35:00',2.86),('10318','2013-05-17','10:40:00',3.25),('10318','2013-05-17','10:45:00',3.77),('10318','2013-05-17','10:50:00',8.76),('10318','2013-05-17','10:55:00',5.99),('10318','2013-05-17','11:00:00',4.53),('10318','2013-05-17','11:05:00',3.88),('10318','2013-05-17','11:10:00',3.56),('10318','2013-05-17','11:15:00',8.91),('10318','2013-05-17','11:20:00',5.23),('10318','2013-05-17','11:25:00',3.94),('10318','2013-05-17','11:30:00',4.31),('10318','2013-05-17','11:35:00',4.82),('10318','2013-05-17','11:40:00',6.61),('10318','2013-05-17','11:45:00',9.33),('10318','2013-05-17','11:50:00',8.35),('10318','2013-05-17','11:55:00',9.35),('10318','2013-05-17','12:00:00',9.48),('10318','2013-05-17','12:05:00',8.07),('10318','2013-05-17','12:10:00',7.28),('10318','2013-05-17','12:15:00',6.72),('10318','2013-05-17','12:20:00',7.65),('10318','2013-05-17','12:25:00',7.87),('10318','2013-05-17','12:30:00',7.99),('10318','2013-05-17','12:35:00',8.99),('10318','2013-05-17','12:40:00',10.6),('10318','2013-05-17','12:45:00',10.75),('10318','2013-05-17','12:50:00',10.27),('10318','2013-05-17','12:55:00',10.52),('10318','2013-05-17','13:00:00',7.38),('10318','2013-05-17','13:05:00',10.45),('10318','2013-05-17','13:10:00',10.37),('10318','2013-05-17','13:15:00',7.9),('10318','2013-05-17','13:20:00',9.46),('10318','2013-05-17','13:25:00',9.46),('10318','2013-05-17','13:30:00',9.52),('10318','2013-05-17','13:35:00',9.21),('10318','2013-05-17','13:40:00',9.16),('10318','2013-05-17','13:45:00',9.54),('10318','2013-05-17','13:50:00',8.21),('10318','2013-05-17','13:55:00',8.99),('10318','2013-05-17','14:00:00',9.68),('10318','2013-05-17','14:05:00',9.53),('10318','2013-05-17','14:10:00',8.91),('10318','2013-05-17','14:15:00',9.66),('10318','2013-05-17','14:20:00',8.85),('10318','2013-05-17','14:25:00',6.5),('10318','2013-05-17','14:30:00',3.31),('10318','2013-05-17','14:35:00',7.38),('10318','2013-05-17','14:40:00',6.96),('10318','2013-05-17','14:45:00',4.33),('10318','2013-05-17','14:50:00',2.91),('10318','2013-05-17','14:55:00',5.21),('10318','2013-05-17','15:00:00',2.9),('10318','2013-05-17','15:05:00',3.11),('10318','2013-05-17','15:10:00',3.65),('10318','2013-05-17','15:15:00',8.2),('10318','2013-05-17','15:20:00',3.74),('10318','2013-05-17','15:25:00',7.75),('10318','2013-05-17','15:30:00',7.67),('10318','2013-05-17','15:35:00',8.95),('10318','2013-05-17','15:40:00',8.69),('10318','2013-05-17','15:45:00',7.51),('10318','2013-05-17','15:50:00',7.52),('10318','2013-05-17','15:55:00',6.61),('10318','2013-05-17','16:00:00',3.26),('10318','2013-05-17','16:05:00',2.77),('10318','2013-05-17','16:10:00',5.57),('10318','2013-05-17','16:15:00',5.77),('10318','2013-05-17','16:20:00',4.45),('10318','2013-05-17','16:25:00',5.1),('10318','2013-05-17','16:30:00',5.97),('10318','2013-05-17','16:35:00',5.36),('10318','2013-05-17','16:40:00',6.22),('10318','2013-05-17','16:45:00',5.11),('10318','2013-05-17','16:50:00',4.33),('10318','2013-05-17','16:55:00',5.12),('10318','2013-05-17','17:00:00',4.87),('10318','2013-05-17','17:05:00',4.65),('10318','2013-05-17','17:10:00',4.46),('10318','2013-05-17','17:15:00',4.25),('10318','2013-05-17','17:20:00',4.04),('10318','2013-05-17','17:25:00',3.83),('10318','2013-05-17','17:30:00',3.67),('10318','2013-05-17','17:35:00',3.38),('10318','2013-05-17','17:40:00',3.25),('10318','2013-05-17','17:45:00',3.06),('10318','2013-05-17','17:50:00',2.87),('10318','2013-05-17','17:55:00',2.65),('10318','2013-05-17','18:00:00',2.48),('10318','2013-05-17','18:05:00',2.2),('10318','2013-05-17','18:10:00',1.57),('10318','2013-05-17','18:15:00',1.93),('10318','2013-05-17','18:20:00',1.67),('10318','2013-05-17','18:25:00',1.09),('10318','2013-05-16','09:10:00',1.21),('10318','2013-05-16','09:15:00',2.07),('10318','2013-05-16','09:20:00',2.62),('10318','2013-05-16','09:25:00',3.71),('10318','2013-05-16','09:30:00',3.46),('10318','2013-05-16','09:35:00',4.47),('10318','2013-05-16','09:40:00',5.07),('10318','2013-05-16','09:45:00',6.8),('10318','2013-05-16','09:50:00',5.79),('10318','2013-05-16','09:55:00',2.77),('10318','2013-05-16','10:00:00',4.46),('10318','2013-05-16','10:05:00',3.29),('10318','2013-05-16','10:10:00',2.7),('10318','2013-05-16','10:15:00',3.56),('10318','2013-05-16','10:20:00',4.91),('10318','2013-05-16','10:25:00',3.44),('10318','2013-05-16','10:30:00',3.69),('10318','2013-05-16','10:35:00',3.02),('10318','2013-05-16','10:40:00',3.25),('10318','2013-05-16','10:45:00',3.19),('10318','2013-05-16','10:50:00',4.28),('10318','2013-05-16','10:55:00',4.11),('10318','2013-05-16','11:00:00',8.66),('10318','2013-05-16','11:05:00',9.23),('10318','2013-05-16','11:10:00',8.96),('10318','2013-05-16','11:15:00',8.93),('10318','2013-05-16','11:20:00',6.27),('10318','2013-05-16','11:25:00',3.14),('10318','2013-05-16','11:30:00',3.81),('10318','2013-05-16','11:35:00',8.92),('10318','2013-05-16','11:40:00',10.26),('10318','2013-05-16','11:45:00',10.24),('10318','2013-05-16','11:50:00',10.17),('10318','2013-05-16','11:55:00',9.33),('10318','2013-05-16','12:00:00',4.95),('10318','2013-05-16','12:05:00',3.61),('10318','2013-05-16','12:10:00',3.5),('10318','2013-05-16','12:15:00',5.29),('10318','2013-05-16','12:20:00',4.28),('10318','2013-05-16','12:25:00',4.41),('10318','2013-05-16','12:30:00',6.04),('10318','2013-05-16','12:35:00',8.01),('10318','2013-05-16','12:40:00',7.97),('10318','2013-05-16','12:45:00',8.06),('10318','2013-05-16','12:50:00',9.04),('10318','2013-05-16','12:55:00',7.6),('10318','2013-05-16','13:00:00',9.62),('10318','2013-05-16','13:05:00',9.28),('10318','2013-05-16','13:10:00',9.25),('10318','2013-05-16','13:15:00',9.2),('10318','2013-05-16','13:20:00',9.2),('10318','2013-05-16','13:25:00',9.09),('10318','2013-05-16','13:30:00',8.91),('10318','2013-05-16','13:35:00',8.78),('10318','2013-05-16','13:40:00',8.78),('10318','2013-05-16','13:45:00',8.77),('10318','2013-05-16','13:50:00',8.71),('10318','2013-05-16','13:55:00',8.64),('10318','2013-05-16','14:00:00',8.61),('10318','2013-05-16','14:05:00',8.47),('10318','2013-05-16','14:10:00',8.39),('10318','2013-05-16','14:15:00',8.28),('10318','2013-05-16','14:20:00',8.07),('10318','2013-05-16','14:25:00',7.67),('10318','2013-05-16','14:30:00',7.53),('10318','2013-05-16','14:35:00',7.9),('10318','2013-05-16','14:40:00',7.84),('10318','2013-05-16','14:45:00',7.84),('10318','2013-05-16','14:50:00',7.82),('10318','2013-05-16','14:55:00',7.68),('10318','2013-05-16','15:00:00',7.4),('10318','2013-05-16','15:05:00',7.3),('10318','2013-05-16','15:10:00',7.1),('10318','2013-05-16','15:15:00',6.48),('10318','2013-05-16','15:20:00',7.16),('10318','2013-05-16','15:25:00',6.68),('10318','2013-05-16','15:30:00',6.82),('10318','2013-05-16','15:35:00',6.58),('10318','2013-05-16','15:40:00',6.59),('10318','2013-05-16','15:45:00',6.4),('10318','2013-05-16','15:50:00',6.4),('10318','2013-05-16','15:55:00',6.21),('10318','2013-05-16','16:00:00',6.06),('10318','2013-05-16','16:05:00',5.61),('10318','2013-05-16','16:10:00',5.91),('10318','2013-05-16','16:15:00',5.26),('10318','2013-05-16','16:20:00',5.6),('10318','2013-05-16','16:25:00',5.51),('10318','2013-05-16','16:30:00',5.22),('10318','2013-05-16','16:35:00',5.16),('10318','2013-05-16','16:40:00',4.29),('10318','2013-05-16','16:45:00',3.16),('10318','2013-05-16','16:50:00',4.48),('10318','2013-05-16','16:55:00',2.82),('10318','2013-05-16','17:00:00',2.46),('10318','2013-05-16','17:05:00',1.75),('10318','2013-05-16','17:10:00',1.84),('10318','2013-05-16','17:15:00',2.69),('10318','2013-05-16','17:20:00',3.06),('10318','2013-05-16','17:25:00',3.24),('10318','2013-05-16','17:30:00',3.56),('10318','2013-05-16','17:35:00',2.81),('10318','2013-05-16','17:40:00',2.39),('10318','2013-05-16','17:45:00',2.04),('10318','2013-05-16','17:50:00',1.47),('10318','2013-05-16','17:55:00',1.08),('10318','2013-05-16','18:15:00',1.01),('10318','2013-05-16','18:20:00',1.17),('10318','2013-05-16','18:25:00',1.34),('10318','2013-05-16','18:30:00',1.53),('10318','2013-05-16','18:35:00',1.79),('10318','2013-05-16','18:40:00',1.88),('10318','2013-05-16','18:45:00',2.06),('10318','2013-05-16','18:50:00',2.09),('10318','2013-05-16','18:55:00',2.01),('10318','2013-05-16','19:00:00',1.98),('10318','2013-05-16','19:05:00',1.72),('10318','2013-05-16','19:10:00',1.45),('10318','2013-05-16','19:15:00',1.25),('10318','2013-05-16','19:20:00',1.06),('10318','2013-05-15','07:10:00',1.84),('10318','2013-05-15','07:15:00',2.15),('10318','2013-05-15','07:20:00',2.16),('10318','2013-05-15','07:25:00',2.69),('10318','2013-05-15','07:30:00',3.09),('10318','2013-05-15','07:35:00',3.25),('10318','2013-05-15','07:40:00',3.51),('10318','2013-05-15','07:45:00',3.87),('10318','2013-05-15','07:50:00',3.86),('10318','2013-05-15','07:55:00',3.88),('10318','2013-05-15','08:00:00',3.8),('10318','2013-05-15','08:05:00',3.88),('10318','2013-05-15','08:10:00',4.58),('10318','2013-05-15','08:15:00',4.81),('10318','2013-05-15','08:20:00',4.91),('10318','2013-05-15','08:25:00',5.02),('10318','2013-05-15','08:30:00',4.98),('10318','2013-05-15','08:35:00',5.38),('10318','2013-05-15','08:40:00',5.49),('10318','2013-05-15','08:45:00',5.91),('10318','2013-05-15','08:50:00',6.13),('10318','2013-05-15','08:55:00',6.26),('10318','2013-05-15','09:00:00',6.06),('10318','2013-05-15','09:05:00',6.35),('10318','2013-05-15','09:10:00',6.37),('10318','2013-05-15','09:15:00',6.53),('10318','2013-05-15','09:20:00',6.53),('10318','2013-05-15','09:25:00',6.87),('10318','2013-05-15','09:30:00',7.12),('10318','2013-05-15','09:35:00',7.16),('10318','2013-05-15','09:40:00',7.17),('10318','2013-05-15','09:45:00',7.43),('10318','2013-05-15','09:50:00',7.55),('10318','2013-05-15','09:55:00',7.62),('10318','2013-05-15','10:00:00',7.85),('10318','2013-05-15','10:05:00',7.95);
INSERT INTO `solarlog` VALUES ('10318','2013-05-15','10:10:00',7.95),('10318','2013-05-15','10:15:00',8.06),('10318','2013-05-15','10:20:00',8.28),('10318','2013-05-15','10:25:00',8.39),('10318','2013-05-15','10:30:00',8.35),('10318','2013-05-15','10:35:00',8.38),('10318','2013-05-15','10:40:00',8.51),('10318','2013-05-15','10:45:00',8.62),('10318','2013-05-15','10:50:00',8.68),('10318','2013-05-15','10:55:00',8.46),('10318','2013-05-15','11:00:00',8.55),('10318','2013-05-15','11:05:00',8.74),('10318','2013-05-15','11:10:00',8.99),('10318','2013-05-15','11:15:00',8.9),('10318','2013-05-15','11:20:00',8.64),('10318','2013-05-15','11:25:00',9.03),('10318','2013-05-15','11:30:00',9.28),('10318','2013-05-15','11:35:00',9.33),('10318','2013-05-15','11:40:00',7.04),('10318','2013-05-15','11:45:00',7.08),('10318','2013-05-15','11:50:00',5.77),('10318','2013-05-15','11:55:00',4.24),('10318','2013-05-15','12:00:00',5.82),('10318','2013-05-15','12:05:00',7.58),('10318','2013-05-15','12:10:00',9.23),('10318','2013-05-15','12:15:00',10.95),('10318','2013-05-15','12:20:00',9.95),('10318','2013-05-15','12:25:00',7.77),('10318','2013-05-15','12:30:00',7.77),('10318','2013-05-15','12:35:00',8.68),('10318','2013-05-15','12:40:00',8.22),('10318','2013-05-15','12:45:00',5.69),('10318','2013-05-15','12:50:00',5.42),('10318','2013-05-15','12:55:00',5.85),('10318','2013-05-15','13:00:00',5.73),('10318','2013-05-15','13:05:00',6.72),('10318','2013-05-15','13:10:00',5.45),('10318','2013-05-15','13:15:00',5.91),('10318','2013-05-15','13:20:00',5.81),('10318','2013-05-15','13:25:00',6.4),('10318','2013-05-15','13:30:00',5.83),('10318','2013-05-15','13:35:00',5.35),('10318','2013-05-15','13:40:00',6.51),('10318','2013-05-15','13:45:00',5.36),('10318','2013-05-15','13:50:00',4.64),('10318','2013-05-15','13:55:00',4.91),('10318','2013-05-15','14:00:00',4.13),('10318','2013-05-15','14:05:00',3.88),('10318','2013-05-15','14:10:00',4.19),('10318','2013-05-15','14:15:00',4),('10318','2013-05-15','14:20:00',4.54),('10318','2013-05-15','14:25:00',3.85),('10318','2013-05-15','14:30:00',3.34),('10318','2013-05-15','14:35:00',3.28),('10318','2013-05-15','14:40:00',3.48),('10318','2013-05-15','14:45:00',3.28),('10318','2013-05-15','14:50:00',3.22),('10318','2013-05-15','14:55:00',3.3),('10318','2013-05-15','15:00:00',3.19),('10318','2013-05-15','15:05:00',2.45),('10318','2013-05-15','15:10:00',1.94),('10318','2013-05-15','15:15:00',1.86),('10318','2013-05-15','15:20:00',1.79),('10318','2013-05-15','15:25:00',1.78),('10318','2013-05-15','15:30:00',1.88),('10318','2013-05-15','15:35:00',1.85),('10318','2013-05-15','15:40:00',2.02),('10318','2013-05-15','15:45:00',2.66),('10318','2013-05-15','15:50:00',3.53),('10318','2013-05-15','15:55:00',4.4),('10318','2013-05-15','16:00:00',4.17),('10318','2013-05-15','16:05:00',4.04),('10318','2013-05-15','16:10:00',3.69),('10318','2013-05-15','16:15:00',3.43),('10318','2013-05-15','16:20:00',3.53),('10318','2013-05-15','16:25:00',3.38),('10318','2013-05-15','16:30:00',2.88),('10318','2013-05-15','16:35:00',2.94),('10318','2013-05-15','16:40:00',2.79),('10318','2013-05-15','16:45:00',2.65),('10318','2013-05-15','16:50:00',2.89),('10318','2013-05-15','16:55:00',3.17),('10318','2013-05-15','17:00:00',3.79),('10318','2013-05-15','17:05:00',4.36),('10318','2013-05-15','17:10:00',4.54),('10318','2013-05-15','17:15:00',4.1),('10318','2013-05-15','17:20:00',2.52),('10318','2013-05-15','17:25:00',2.07),('10318','2013-05-15','17:30:00',2.39),('10318','2013-05-15','17:35:00',2.01),('10318','2013-05-15','17:40:00',1.89),('10318','2013-05-15','17:45:00',1.95),('10318','2013-05-15','17:50:00',1.92),('10318','2013-05-15','17:55:00',1.83),('10318','2013-05-15','18:00:00',1.59),('10318','2013-05-15','18:05:00',1.27),('10318','2013-05-15','18:20:00',1.02),('10318','2013-05-15','18:25:00',1.11),('10318','2013-05-14','07:00:00',1.12),('10318','2013-05-14','07:05:00',1.51),('10318','2013-05-14','07:10:00',1.96),('10318','2013-05-14','07:15:00',2.27),('10318','2013-05-14','07:20:00',2.42),('10318','2013-05-14','07:25:00',2.79),('10318','2013-05-14','07:30:00',3.16),('10318','2013-05-14','07:35:00',3.38),('10318','2013-05-14','07:40:00',3.6),('10318','2013-05-14','07:45:00',3.82),('10318','2013-05-14','07:50:00',4.04),('10318','2013-05-14','07:55:00',4.26),('10318','2013-05-14','08:00:00',4.47),('10318','2013-05-14','08:05:00',4.66),('10318','2013-05-14','08:10:00',4.87),('10318','2013-05-14','08:15:00',5.07),('10318','2013-05-14','08:20:00',5.29),('10318','2013-05-14','08:25:00',5.49),('10318','2013-05-14','08:30:00',5.56),('10318','2013-05-14','08:35:00',5.87),('10318','2013-05-14','08:40:00',6.04),('10318','2013-05-14','08:45:00',6.2),('10318','2013-05-14','08:50:00',6.37),('10318','2013-05-14','08:55:00',6.53),('10318','2013-05-14','09:00:00',6.68),('10318','2013-05-14','09:05:00',6.87),('10318','2013-05-14','09:10:00',7.01),('10318','2013-05-14','09:15:00',7.15),('10318','2013-05-14','09:20:00',7.29),('10318','2013-05-14','09:25:00',7.43),('10318','2013-05-14','09:30:00',7.56),('10318','2013-05-14','09:35:00',7.74),('10318','2013-05-14','09:40:00',7.81),('10318','2013-05-14','09:45:00',7.93),('10318','2013-05-14','09:50:00',8.09),('10318','2013-05-14','09:55:00',8.16),('10318','2013-05-14','10:00:00',8.34),('10318','2013-05-14','10:05:00',8.42),('10318','2013-05-14','10:10:00',8.56),('10318','2013-05-14','10:15:00',8.48),('10318','2013-05-14','10:20:00',8.71),('10318','2013-05-14','10:25:00',8.83),('10318','2013-05-14','10:30:00',8.93),('10318','2013-05-14','10:35:00',9.01),('10318','2013-05-14','10:40:00',9.07),('10318','2013-05-14','10:45:00',9.09),('10318','2013-05-14','10:50:00',9.17),('10318','2013-05-14','10:55:00',9.22),('10318','2013-05-14','11:00:00',9.26),('10318','2013-05-14','11:05:00',9.32),('10318','2013-05-14','11:10:00',9.35),('10318','2013-05-14','11:15:00',9.46),('10318','2013-05-14','11:20:00',9.48),('10318','2013-05-14','11:25:00',9.51),('10318','2013-05-14','11:30:00',9.54),('10318','2013-05-14','11:35:00',9.57),('10318','2013-05-14','11:40:00',9.66),('10318','2013-05-14','11:45:00',9.64),('10318','2013-05-14','11:50:00',9.66),('10318','2013-05-14','11:55:00',9.67),('10318','2013-05-14','12:00:00',9.54),('10318','2013-05-14','12:05:00',9.69),('10318','2013-05-14','12:10:00',9.77),('10318','2013-05-14','12:15:00',9.78),('10318','2013-05-14','12:20:00',9.71),('10318','2013-05-14','12:25:00',9.67),('10318','2013-05-14','12:30:00',9.65),('10318','2013-05-14','12:35:00',9.68),('10318','2013-05-14','12:40:00',9.64),('10318','2013-05-14','12:45:00',9.6),('10318','2013-05-14','12:50:00',9.67),('10318','2013-05-14','12:55:00',9.63),('10318','2013-05-14','13:00:00',9.64),('10318','2013-05-14','13:05:00',9.55),('10318','2013-05-14','13:10:00',9.45),('10318','2013-05-14','13:15:00',9.43),('10318','2013-05-14','13:20:00',9.44),('10318','2013-05-14','13:25:00',9.38),('10318','2013-05-14','13:30:00',9.33),('10318','2013-05-14','13:35:00',9.31),('10318','2013-05-14','13:40:00',9.24),('10318','2013-05-14','13:45:00',9.18),('10318','2013-05-14','13:50:00',9.18),('10318','2013-05-14','13:55:00',9.13),('10318','2013-05-14','14:00:00',9.12),('10318','2013-05-14','14:05:00',9.06),('10318','2013-05-14','14:10:00',8.98),('10318','2013-05-14','14:15:00',8.86),('10318','2013-05-14','14:20:00',8.77),('10318','2013-05-14','14:25:00',8.7),('10318','2013-05-14','14:30:00',8.61),('10318','2013-05-14','14:35:00',8.65),('10318','2013-05-14','14:40:00',8.66),('10318','2013-05-14','14:45:00',8.61),('10318','2013-05-14','14:50:00',8.53),('10318','2013-05-14','14:55:00',8.44),('10318','2013-05-14','15:00:00',8.31),('10318','2013-05-14','15:05:00',8.29),('10318','2013-05-14','15:10:00',8.16),('10318','2013-05-14','15:15:00',8.05),('10318','2013-05-14','15:20:00',7.89),('10318','2013-05-14','15:25:00',7.75),('10318','2013-05-14','15:30:00',7.62),('10318','2013-05-14','15:35:00',7.52),('10318','2013-05-14','15:40:00',7.43),('10318','2013-05-14','15:45:00',7.3),('10318','2013-05-14','15:50:00',7.1),('10318','2013-05-14','15:55:00',6.9),('10318','2013-05-14','16:00:00',6.75),('10318','2013-05-14','16:05:00',6.61),('10318','2013-05-14','16:10:00',6.42),('10318','2013-05-14','16:15:00',6.26),('10318','2013-05-14','16:20:00',6.1),('10318','2013-05-14','16:25:00',5.93),('10318','2013-05-14','16:30:00',5.77),('10318','2013-05-14','16:35:00',5.6),('10318','2013-05-14','16:40:00',5.42),('10318','2013-05-14','16:45:00',5.16),('10318','2013-05-14','16:50:00',5.04),('10318','2013-05-14','16:55:00',4.86),('10318','2013-05-14','17:00:00',4.67),('10318','2013-05-14','17:05:00',4.47),('10318','2013-05-14','17:10:00',4.28),('10318','2013-05-14','17:15:00',4.08),('10318','2013-05-14','17:20:00',3.88),('10318','2013-05-14','17:25:00',3.68),('10318','2013-05-14','17:30:00',3.48),('10318','2013-05-14','17:35:00',3.29),('10318','2013-05-14','17:40:00',3.1),('10318','2013-05-14','17:45:00',2.92),('10318','2013-05-14','17:50:00',2.73),('10318','2013-05-14','17:55:00',2.55),('10318','2013-05-14','18:00:00',2.36),('10318','2013-05-14','18:05:00',2.16),('10318','2013-05-14','18:10:00',1.99),('10318','2013-05-14','18:15:00',1.82),('10318','2013-05-14','18:20:00',1.66),('10318','2013-05-14','18:25:00',1.49),('10318','2013-05-14','18:30:00',1.36),('10318','2013-05-14','18:35:00',1.17),('10318','2013-05-14','18:40:00',1.09),('10318','2013-05-13','07:00:00',1.03),('10318','2013-05-13','07:05:00',1.16),('10318','2013-05-13','07:10:00',1.76),('10318','2013-05-13','07:15:00',1.62),('10318','2013-05-13','07:20:00',1.25),('10318','2013-05-13','07:25:00',1.47),('10318','2013-05-13','07:30:00',2.33),('10318','2013-05-13','07:35:00',2.95),('10318','2013-05-13','07:40:00',3.03),('10318','2013-05-13','07:45:00',3.41),('10318','2013-05-13','07:50:00',3.65),('10318','2013-05-13','07:55:00',3.99),('10318','2013-05-13','08:00:00',4.03),('10318','2013-05-13','08:05:00',4.16),('10318','2013-05-13','08:10:00',4.37),('10318','2013-05-13','08:15:00',4.6),('10318','2013-05-13','08:20:00',4.84),('10318','2013-05-13','08:25:00',5.05),('10318','2013-05-13','08:30:00',5.23),('10318','2013-05-13','08:35:00',5.38),('10318','2013-05-13','08:40:00',5.59),('10318','2013-05-13','08:45:00',5.78),('10318','2013-05-13','08:50:00',5.96),('10318','2013-05-13','08:55:00',6.09),('10318','2013-05-13','09:00:00',6.28),('10318','2013-05-13','09:05:00',6.43),('10318','2013-05-13','09:10:00',6.57),('10318','2013-05-13','09:15:00',6.74),('10318','2013-05-13','09:20:00',6.93),('10318','2013-05-13','09:25:00',7.07),('10318','2013-05-13','09:30:00',7.27),('10318','2013-05-13','09:35:00',7.35),('10318','2013-05-13','09:40:00',5.94),('10318','2013-05-13','09:45:00',7.62),('10318','2013-05-13','09:50:00',8.6),('10318','2013-05-13','09:55:00',7.83),('10318','2013-05-13','10:00:00',6.68),('10318','2013-05-13','10:05:00',4.6),('10318','2013-05-13','10:10:00',5.83),('10318','2013-05-13','10:15:00',8.69),('10318','2013-05-13','10:20:00',6.66),('10318','2013-05-13','10:25:00',6.98),('10318','2013-05-13','10:30:00',8.86),('10318','2013-05-13','10:35:00',8.38),('10318','2013-05-13','10:40:00',2.64),('10318','2013-05-13','10:45:00',4.84),('10318','2013-05-13','10:50:00',9.83),('10318','2013-05-13','10:55:00',6.96),('10318','2013-05-13','11:00:00',6.4),('10318','2013-05-13','11:05:00',3.49),('10318','2013-05-13','11:10:00',5.24),('10318','2013-05-13','11:15:00',4.13),('10318','2013-05-13','11:20:00',3.74),('10318','2013-05-13','11:25:00',4.51),('10318','2013-05-13','11:30:00',4.15),('10318','2013-05-13','11:35:00',6.25),('10318','2013-05-13','11:40:00',10.22),('10318','2013-05-13','11:45:00',10.67),('10318','2013-05-13','11:50:00',10.15),('10318','2013-05-13','11:55:00',6.24),('10318','2013-05-13','12:00:00',4.97),('10318','2013-05-13','12:05:00',3.86),('10318','2013-05-13','12:10:00',3.85),('10318','2013-05-13','12:15:00',2.73),('10318','2013-05-13','12:20:00',2.34),('10318','2013-05-13','12:25:00',2.63),('10318','2013-05-13','12:30:00',6.4),('10318','2013-05-13','12:35:00',10.81),('10318','2013-05-13','12:40:00',9.69),('10318','2013-05-13','12:45:00',10.78),('10318','2013-05-13','12:50:00',6.65),('10318','2013-05-13','12:55:00',3.75),('10318','2013-05-13','13:00:00',10.77),('10318','2013-05-13','13:05:00',7.78),('10318','2013-05-13','13:10:00',6.71),('10318','2013-05-13','13:15:00',10.58),('10318','2013-05-13','13:20:00',5.3),('10318','2013-05-13','13:25:00',2.55),('10318','2013-05-13','13:30:00',3.02),('10318','2013-05-13','13:35:00',8.67),('10318','2013-05-13','13:40:00',7.87),('10318','2013-05-13','13:45:00',5.99),('10318','2013-05-13','13:50:00',5.05),('10318','2013-05-13','13:55:00',8.24),('10318','2013-05-13','14:00:00',10.11),('10318','2013-05-13','14:05:00',9.96),('10318','2013-05-13','14:10:00',9.97),('10318','2013-05-13','14:15:00',8.57),('10318','2013-05-13','14:20:00',8.57),('10318','2013-05-13','14:25:00',7.03),('10318','2013-05-13','14:30:00',4.66),('10318','2013-05-13','14:35:00',1.62),('10318','2013-05-13','14:40:00',3.09),('10318','2013-05-13','14:45:00',9.62),('10318','2013-05-13','14:50:00',7.41),('10318','2013-05-13','14:55:00',7.15),('10318','2013-05-13','15:00:00',3.29),('10318','2013-05-13','15:05:00',2.89),('10318','2013-05-13','15:10:00',2.65),('10318','2013-05-13','15:15:00',2.21),('10318','2013-05-13','15:20:00',1.98),('10318','2013-05-13','15:25:00',1.78),('10318','2013-05-13','15:30:00',2.01),('10318','2013-05-13','15:35:00',2.21),('10318','2013-05-13','15:40:00',3.35),('10318','2013-05-13','15:45:00',3.39),('10318','2013-05-13','15:50:00',1.69),('10318','2013-05-13','15:55:00',1.51),('10318','2013-05-13','16:00:00',2.95),('10318','2013-05-13','16:05:00',4.37),('10318','2013-05-13','16:10:00',2.7),('10318','2013-05-13','16:15:00',2.99),('10318','2013-05-13','16:20:00',2.81),('10318','2013-05-13','16:25:00',3.13),('10318','2013-05-13','16:30:00',3.01),('10318','2013-05-13','16:35:00',2.49),('10318','2013-05-13','16:40:00',2.65),('10318','2013-05-13','16:45:00',2.2),('10318','2013-05-13','16:50:00',3.03),('10318','2013-05-13','16:55:00',5.55),('10318','2013-05-13','17:00:00',4.6),('10318','2013-05-13','17:05:00',2.31),('10318','2013-05-13','17:10:00',1.86),('10318','2013-05-13','17:15:00',1.9),('10318','2013-05-13','17:20:00',3.61),('10318','2013-05-13','17:25:00',4.97),('10318','2013-05-13','17:30:00',4.62),('10318','2013-05-13','17:35:00',4.51),('10318','2013-05-13','17:40:00',4.38),('10318','2013-05-13','17:45:00',4.06),('10318','2013-05-13','17:50:00',4.24),('10318','2013-05-13','17:55:00',4.28),('10318','2013-05-13','18:00:00',3.8),('10318','2013-05-13','18:05:00',3.23),('10318','2013-05-13','18:10:00',2.27),('10318','2013-05-13','18:15:00',2.52),('10318','2013-05-13','18:20:00',2.14),('10318','2013-05-13','18:25:00',1.39),('10318','2013-05-13','18:30:00',1.04),('10318','2013-05-13','18:40:00',1.16),('10318','2013-05-12','07:15:00',1.07),('10318','2013-05-12','07:20:00',1.14),('10318','2013-05-12','07:25:00',1.98),('10318','2013-05-12','07:30:00',2.44),('10318','2013-05-12','07:35:00',2.54),('10318','2013-05-12','07:40:00',3.66),('10318','2013-05-12','07:45:00',3.97),('10318','2013-05-12','07:50:00',4.19),('10318','2013-05-12','07:55:00',4.49),('10318','2013-05-12','08:00:00',4.47),('10318','2013-05-12','08:05:00',3.92),('10318','2013-05-12','08:10:00',2.43),('10318','2013-05-12','08:15:00',2.1),('10318','2013-05-12','08:20:00',2.23),('10318','2013-05-12','08:25:00',2.35),('10318','2013-05-12','08:30:00',2.09),('10318','2013-05-12','08:35:00',1.98),('10318','2013-05-12','08:40:00',2.42),('10318','2013-05-12','08:45:00',3.67),('10318','2013-05-12','08:50:00',2.51),('10318','2013-05-12','08:55:00',3.38),('10318','2013-05-12','09:00:00',5.24),('10318','2013-05-12','09:05:00',3.98),('10318','2013-05-12','09:10:00',5.9),('10318','2013-05-12','09:15:00',4.01),('10318','2013-05-12','09:20:00',3.57),('10318','2013-05-12','09:25:00',3.79),('10318','2013-05-12','09:30:00',5.63),('10318','2013-05-12','09:35:00',5.67),('10318','2013-05-12','09:40:00',4.71),('10318','2013-05-12','09:45:00',7.37),('10318','2013-05-12','09:50:00',8.53),('10318','2013-05-12','09:55:00',8.48),('10318','2013-05-12','10:00:00',8.45),('10318','2013-05-12','10:05:00',8.59),('10318','2013-05-12','10:10:00',8.64),('10318','2013-05-12','10:15:00',9.08),('10318','2013-05-12','10:20:00',9.36),('10318','2013-05-12','10:25:00',9.56),('10318','2013-05-12','10:30:00',8.78),('10318','2013-05-12','10:35:00',5.28),('10318','2013-05-12','10:40:00',7.05),('10318','2013-05-12','10:45:00',5.96),('10318','2013-05-12','10:50:00',8.68),('10318','2013-05-12','10:55:00',6.12),('10318','2013-05-12','11:00:00',10.32),('10318','2013-05-12','11:05:00',6.33),('10318','2013-05-12','11:10:00',2.9),('10318','2013-05-12','11:15:00',2.9),('10318','2013-05-12','11:20:00',3.11),('10318','2013-05-12','11:25:00',2.79),('10318','2013-05-12','11:30:00',2.61),('10318','2013-05-12','11:35:00',2.64),('10318','2013-05-12','11:40:00',2.74),('10318','2013-05-12','11:45:00',2.86),('10318','2013-05-12','11:50:00',3.58),('10318','2013-05-12','11:55:00',3.72),('10318','2013-05-12','12:00:00',3.3),('10318','2013-05-12','12:05:00',2.92),('10318','2013-05-12','12:10:00',2.48),('10318','2013-05-12','12:15:00',2.82),('10318','2013-05-12','12:20:00',3.55),('10318','2013-05-12','12:25:00',8.07),('10318','2013-05-12','12:30:00',10.76),('10318','2013-05-12','12:35:00',9.28),('10318','2013-05-12','12:40:00',8.41),('10318','2013-05-12','12:45:00',8.46),('10318','2013-05-12','12:50:00',10.2),('10318','2013-05-12','12:55:00',10.85),('10318','2013-05-12','13:00:00',10.14),('10318','2013-05-12','13:05:00',10.51),('10318','2013-05-12','13:10:00',10.22),('10318','2013-05-12','13:15:00',10.18),('10318','2013-05-12','13:20:00',7.87),('10318','2013-05-12','13:25:00',10.32),('10318','2013-05-12','13:30:00',10.26),('10318','2013-05-12','13:35:00',10.18),('10318','2013-05-12','13:40:00',9.97),('10318','2013-05-12','13:45:00',9.98),('10318','2013-05-12','13:50:00',9.94),('10318','2013-05-12','13:55:00',7.8),('10318','2013-05-12','14:00:00',10.29),('10318','2013-05-12','14:05:00',7.26),('10318','2013-05-12','14:10:00',6.03),('10318','2013-05-12','14:15:00',10.26),('10318','2013-05-12','14:20:00',7.87),('10318','2013-05-12','14:25:00',8.81),('10318','2013-05-12','14:30:00',9.62),('10318','2013-05-12','14:35:00',7.15),('10318','2013-05-12','14:40:00',6.74),('10318','2013-05-12','14:45:00',9.33),('10318','2013-05-12','14:50:00',6.96),('10318','2013-05-12','14:55:00',6.13),('10318','2013-05-12','15:00:00',9.45),('10318','2013-05-12','15:05:00',7.82),('10318','2013-05-12','15:10:00',7.33),('10318','2013-05-12','15:15:00',8.27),('10318','2013-05-12','15:20:00',8.35),('10318','2013-05-12','15:25:00',7.9),('10318','2013-05-12','15:30:00',7.7),('10318','2013-05-12','15:35:00',5.9),('10318','2013-05-12','15:40:00',7.33),('10318','2013-05-12','15:45:00',7.28),('10318','2013-05-12','15:50:00',7.1),('10318','2013-05-12','15:55:00',6.93),('10318','2013-05-12','16:00:00',6.77),('10318','2013-05-12','16:05:00',6.64),('10318','2013-05-12','16:10:00',6.41),('10318','2013-05-12','16:15:00',6.17),('10318','2013-05-12','16:20:00',6.05),('10318','2013-05-12','16:25:00',5.92),('10318','2013-05-12','16:30:00',5.53),('10318','2013-05-12','16:35:00',4.66),('10318','2013-05-12','16:40:00',4.98),('10318','2013-05-12','16:45:00',5.41),('10318','2013-05-12','16:50:00',6.6),('10318','2013-05-12','16:55:00',6.51),('10318','2013-05-12','17:00:00',6.22),('10318','2013-05-12','17:05:00',5.4),('10318','2013-05-12','17:10:00',6.14),('10318','2013-05-12','17:15:00',5.64),('10318','2013-05-12','17:20:00',4.75),('10318','2013-05-12','17:25:00',4.62),('10318','2013-05-12','17:30:00',4.33),('10318','2013-05-12','17:35:00',4.89),('10318','2013-05-12','17:40:00',4.13),('10318','2013-05-12','17:45:00',2.45),('10318','2013-05-12','17:50:00',2.02),('10318','2013-05-12','17:55:00',3.53),('10318','2013-05-12','18:00:00',3.77),('10318','2013-05-12','18:05:00',3.11),('10318','2013-05-12','18:10:00',3.98),('10318','2013-05-12','18:15:00',2.8),('10318','2013-05-12','18:20:00',2.8),('10318','2013-05-12','18:25:00',2.56),('10318','2013-05-12','18:30:00',2.82),('10318','2013-05-12','18:35:00',2.53),('10318','2013-05-12','18:40:00',2.28),('10318','2013-05-12','18:45:00',1.76),('10318','2013-05-12','18:50:00',1.49),('10318','2013-05-12','18:55:00',1.62),('10318','2013-05-12','19:00:00',1.74),('10318','2013-05-12','19:05:00',1.58),('10318','2013-05-12','19:10:00',1.64),('10318','2013-05-12','19:15:00',1.46),('10318','2013-05-12','19:25:00',1.02),('10318','2014-03-31','07:50:00',1.02),('10318','2014-03-31','07:55:00',1.35),('10318','2014-03-31','08:00:00',1.72),('10318','2014-03-31','08:05:00',2.25),('10318','2014-03-31','08:10:00',2.48),('10318','2014-03-31','08:15:00',2.91),('10318','2014-03-31','08:20:00',3.38),('10318','2014-03-31','08:25:00',3.7),('10318','2014-03-31','08:30:00',3.92),('10318','2014-03-31','08:35:00',4.11),('10318','2014-03-31','08:40:00',4.35),('10318','2014-03-31','08:45:00',4.57),('10318','2014-03-31','08:50:00',4.81),('10318','2014-03-31','08:55:00',5.02),('10318','2014-03-31','09:00:00',5.24),('10318','2014-03-31','09:05:00',5.43),('10318','2014-03-31','09:10:00',5.61),('10318','2014-03-31','09:15:00',5.73),('10318','2014-03-31','09:20:00',5.99),('10318','2014-03-31','09:25:00',6.16),('10318','2014-03-31','09:30:00',6.33),('10318','2014-03-31','09:35:00',6.53),('10318','2014-03-31','09:40:00',6.7),('10318','2014-03-31','09:45:00',6.82),('10318','2014-03-31','09:50:00',6.97),('10318','2014-03-31','09:55:00',7.12),('10318','2014-03-31','10:00:00',7.25),('10318','2014-03-31','10:05:00',7.36),('10318','2014-03-31','10:10:00',7.49),('10318','2014-03-31','10:15:00',7.62),('10318','2014-03-31','10:20:00',7.75),('10318','2014-03-31','10:25:00',7.83),('10318','2014-03-31','10:30:00',7.81),('10318','2014-03-31','10:35:00',8),('10318','2014-03-31','10:40:00',8.09),('10318','2014-03-31','10:45:00',8.18),('10318','2014-03-31','10:50:00',8.27),('10318','2014-03-31','10:55:00',8.4),('10318','2014-03-31','11:00:00',8.44),('10318','2014-03-31','11:05:00',8.53),('10318','2014-03-31','11:10:00',8.59),('10318','2014-03-31','11:15:00',8.66),('10318','2014-03-31','11:20:00',8.7),('10318','2014-03-31','11:25:00',8.77),('10318','2014-03-31','11:30:00',8.8),('10318','2014-03-31','11:35:00',8.85),('10318','2014-03-31','11:40:00',8.96),('10318','2014-03-31','11:45:00',8.99),('10318','2014-03-31','11:50:00',8.99),('10318','2014-03-31','11:55:00',9.11),('10318','2014-03-31','12:00:00',9.02),('10318','2014-03-31','12:05:00',9.07),('10318','2014-03-31','12:10:00',9.07),('10318','2014-03-31','12:15:00',9.13),('10318','2014-03-31','12:20:00',9.22),('10318','2014-03-31','12:25:00',9.17),('10318','2014-03-31','12:30:00',9.13),('10318','2014-03-31','12:35:00',9.13),('10318','2014-03-31','12:40:00',9.12),('10318','2014-03-31','12:45:00',9.12),('10318','2014-03-31','12:50:00',9.18),('10318','2014-03-31','12:55:00',9.26),('10318','2014-03-31','13:00:00',9.22),('10318','2014-03-31','13:05:00',9.17),('10318','2014-03-31','13:10:00',9.17),('10318','2014-03-31','13:15:00',9.17),('10318','2014-03-31','13:20:00',9.2),('10318','2014-03-31','13:25:00',9.14),('10318','2014-03-31','13:30:00',9.11),('10318','2014-03-31','13:35:00',9.14),('10318','2014-03-31','13:40:00',9.04),('10318','2014-03-31','13:45:00',8.94),('10318','2014-03-31','13:50:00',8.92),('10318','2014-03-31','13:55:00',8.82),('10318','2014-03-31','14:00:00',8.63),('10318','2014-03-31','14:05:00',8.73),('10318','2014-03-31','14:10:00',8.67),('10318','2014-03-31','14:15:00',8.6),('10318','2014-03-31','14:20:00',8.5),('10318','2014-03-31','14:25:00',8.48),('10318','2014-03-31','14:30:00',8.41),('10318','2014-03-31','14:35:00',8.32),('10318','2014-03-31','14:40:00',8.22),('10318','2014-03-31','14:45:00',8.11),('10318','2014-03-31','14:50:00',7.99),('10318','2014-03-31','14:55:00',7.92),('10318','2014-03-31','15:00:00',7.8),('10318','2014-03-31','15:05:00',7.67),('10318','2014-03-31','15:10:00',7.56),('10318','2014-03-31','15:15:00',7.43),('10318','2014-03-31','15:20:00',7.32),('10318','2014-03-31','15:25:00',7.21),('10318','2014-03-31','15:30:00',7.06),('10318','2014-03-31','15:35:00',6.88),('10318','2014-03-31','15:40:00',6.74),('10318','2014-03-31','15:45:00',6.58),('10318','2014-03-31','15:50:00',6.27),('10318','2014-03-31','15:55:00',6.19),('10318','2014-03-31','16:00:00',6.01),('10318','2014-03-31','16:05:00',5.81),('10318','2014-03-31','16:10:00',5.68),('10318','2014-03-31','16:15:00',5.5),('10318','2014-03-31','16:20:00',5.34),('10318','2014-03-31','16:25:00',5.15),('10318','2014-03-31','16:30:00',4.98),('10318','2014-03-31','16:35:00',4.8),('10318','2014-03-31','16:40:00',4.58),('10318','2014-03-31','16:45:00',4.41),('10318','2014-03-31','16:50:00',4.21),('10318','2014-03-31','16:55:00',4.06),('10318','2014-03-31','17:00:00',3.84),('10318','2014-03-31','17:05:00',3.64),('10318','2014-03-31','17:10:00',3.47),('10318','2014-03-31','17:15:00',3.31),('10318','2014-03-31','17:20:00',3.11),('10318','2014-03-31','17:25:00',2.96),('10318','2014-03-31','17:30:00',2.76),('10318','2014-03-31','17:35:00',2.54),('10318','2014-03-31','17:40:00',2.41),('10318','2014-03-31','17:45:00',2.25),('10318','2014-03-31','17:50:00',2.1),('10318','2014-03-31','17:55:00',1.95),('10318','2014-03-31','18:00:00',1.78),('10318','2014-03-31','18:05:00',1.63),('10318','2014-03-31','18:10:00',1.51),('10318','2014-03-31','18:15:00',1.42),('10318','2014-03-31','18:20:00',1.31),('10318','2014-03-31','18:25:00',1.19),('10318','2014-03-31','18:30:00',1.04),('10318','2013-05-11','07:10:00',1.04),('10318','2013-05-11','07:15:00',1.9),('10318','2013-05-11','07:20:00',2.05),('10318','2013-05-11','07:25:00',2.27),('10318','2013-05-11','07:30:00',2.67),('10318','2013-05-11','07:35:00',2.84),('10318','2013-05-11','07:40:00',3.12),('10318','2013-05-11','07:45:00',3.6),('10318','2013-05-11','07:50:00',4.05),('10318','2013-05-11','07:55:00',3.7),('10318','2013-05-11','08:00:00',3.7),('10318','2013-05-11','08:05:00',2.98),('10318','2013-05-11','08:10:00',2.21),('10318','2013-05-11','08:15:00',1.81),('10318','2013-05-11','08:20:00',1.15),('10318','2013-05-11','08:25:00',1.38),('10318','2013-05-11','08:30:00',1.34),('10318','2013-05-11','08:35:00',2.11),('10318','2013-05-11','08:40:00',2.71),('10318','2013-05-11','08:45:00',2.91),('10318','2013-05-11','08:50:00',2.53),('10318','2013-05-11','08:55:00',2.82),('10318','2013-05-11','09:00:00',6.5),('10318','2013-05-11','09:05:00',6.48),('10318','2013-05-11','09:10:00',3.7),('10318','2013-05-11','09:15:00',5.4),('10318','2013-05-11','09:20:00',4.23),('10318','2013-05-11','09:25:00',5.57),('10318','2013-05-11','09:30:00',4),('10318','2013-05-11','09:35:00',2.39),('10318','2013-05-11','09:40:00',3.17),('10318','2013-05-11','09:45:00',3.28),('10318','2013-05-11','09:50:00',3.76),('10318','2013-05-11','09:55:00',3.86),('10318','2013-05-11','10:00:00',2.21),('10318','2013-05-11','10:05:00',1.51),('10318','2013-05-11','10:10:00',1.53),('10318','2013-05-11','10:15:00',2.01),('10318','2013-05-11','10:20:00',2.75),('10318','2013-05-11','10:25:00',4.3),('10318','2013-05-11','10:30:00',4.56),('10318','2013-05-11','10:35:00',3.24),('10318','2013-05-11','10:40:00',6.34),('10318','2013-05-11','10:45:00',8.09),('10318','2013-05-11','10:50:00',9.69),('10318','2013-05-11','10:55:00',9.22),('10318','2013-05-11','11:00:00',10.24),('10318','2013-05-11','11:05:00',7.41),('10318','2013-05-11','11:10:00',3.18),('10318','2013-05-11','11:15:00',2.46),('10318','2013-05-11','11:20:00',2.48),('10318','2013-05-11','11:25:00',4.15),('10318','2013-05-11','11:30:00',3.34),('10318','2013-05-11','11:35:00',2.79),('10318','2013-05-11','11:40:00',3.98),('10318','2013-05-11','11:45:00',3.1),('10318','2013-05-11','11:50:00',4.1),('10318','2013-05-11','11:55:00',3.84),('10318','2013-05-11','12:00:00',6.21),('10318','2013-05-11','12:05:00',4.46),('10318','2013-05-11','12:10:00',3.27),('10318','2013-05-11','12:15:00',7.87),('10318','2013-05-11','12:20:00',10.83),('10318','2013-05-11','12:25:00',10.22),('10318','2013-05-11','12:30:00',10.13),('10318','2013-05-11','12:35:00',7.97),('10318','2013-05-11','12:40:00',8.74),('10318','2013-05-11','12:45:00',4.28),('10318','2013-05-11','12:50:00',3.73),('10318','2013-05-11','12:55:00',3.25),('10318','2013-05-11','13:00:00',3.14),('10318','2013-05-11','13:05:00',2.63),('10318','2013-05-11','13:10:00',2.16),('10318','2013-05-11','13:15:00',2.5),('10318','2013-05-11','13:20:00',4.04),('10318','2013-05-11','13:25:00',2.77),('10318','2013-05-11','13:30:00',3.03),('10318','2013-05-11','13:35:00',2.91),('10318','2013-05-11','13:40:00',1.86),('10318','2013-05-11','13:45:00',4.11),('10318','2013-05-11','13:50:00',7.72),('10318','2013-05-11','13:55:00',8.47),('10318','2013-05-11','14:00:00',7.64),('10318','2013-05-11','14:05:00',8.29),('10318','2013-05-11','14:10:00',7.64),('10318','2013-05-11','14:15:00',7.85),('10318','2013-05-11','14:20:00',6.77),('10318','2013-05-11','14:25:00',3.81),('10318','2013-05-11','14:30:00',3.8),('10318','2013-05-11','14:35:00',7.51),('10318','2013-05-11','14:40:00',5.1),('10318','2013-05-11','14:45:00',6.46),('10318','2013-05-11','14:50:00',4.2),('10318','2013-05-11','14:55:00',4.52),('10318','2013-05-11','15:00:00',7.58),('10318','2013-05-11','15:05:00',2.48),('10318','2013-05-11','15:10:00',3.67),('10318','2013-05-11','15:15:00',9),('10318','2013-05-11','15:20:00',5.24),('10318','2013-05-11','15:25:00',7.04),('10318','2013-05-11','15:30:00',5.44),('10318','2013-05-11','15:35:00',5.11),('10318','2013-05-11','15:40:00',6.25),('10318','2013-05-11','15:45:00',3.99),('10318','2013-05-11','15:50:00',4.94),('10318','2013-05-11','15:55:00',5.78),('10318','2013-05-11','16:00:00',7.18),('10318','2013-05-11','16:05:00',4.27),('10318','2013-05-11','16:10:00',5.06),('10318','2013-05-11','16:15:00',6.27),('10318','2013-05-11','16:20:00',5.97),('10318','2013-05-11','16:25:00',6.17),('10318','2013-05-11','16:30:00',5.26),('10318','2013-05-11','16:35:00',5.22),('10318','2013-05-11','16:40:00',4.18),('10318','2013-05-11','16:45:00',5.6),('10318','2013-05-11','16:50:00',5.47),('10318','2013-05-11','16:55:00',3.32),('10318','2013-05-11','17:00:00',2.6),('10318','2013-05-11','17:05:00',3.37),('10318','2013-05-11','17:10:00',4.79),('10318','2013-05-11','17:15:00',2.89),('10318','2013-05-11','17:20:00',3.85),('10318','2013-05-11','17:25:00',2.19),('10318','2013-05-11','17:30:00',2.29),('10318','2013-05-11','17:35:00',3.63),('10318','2013-05-11','17:40:00',3.17),('10318','2013-05-11','17:45:00',1.65),('10318','2013-05-11','17:50:00',1.27),('10318','2013-05-11','17:55:00',2.18),('10318','2013-05-11','18:00:00',3.11),('10318','2013-05-11','18:05:00',2.47),('10318','2013-05-11','18:10:00',1.67),('10318','2013-05-11','18:15:00',2.49),('10318','2013-05-11','18:20:00',2.26),('10318','2013-05-11','18:25:00',1.13),('10318','2013-05-11','18:30:00',1.94),('10318','2013-05-11','18:35:00',1.04),('10318','2013-05-11','18:40:00',1.27),('10318','2013-05-11','18:50:00',1.4),('10318','2013-05-11','18:55:00',1.05),('10318','2013-05-10','07:05:00',1.06),('10318','2013-05-10','07:10:00',1.41),('10318','2013-05-10','07:15:00',1.68),('10318','2013-05-10','07:20:00',2.33),('10318','2013-05-10','07:25:00',2.41),('10318','2013-05-10','07:30:00',2.76),('10318','2013-05-10','07:35:00',3.05),('10318','2013-05-10','07:40:00',3.11),('10318','2013-05-10','07:45:00',3.57),('10318','2013-05-10','07:50:00',3.92),('10318','2013-05-10','07:55:00',4.22),('10318','2013-05-10','08:00:00',2.74),('10318','2013-05-10','08:05:00',3.03),('10318','2013-05-10','08:10:00',4.11),('10318','2013-05-10','08:15:00',4.87),('10318','2013-05-10','08:20:00',5.07),('10318','2013-05-10','08:25:00',4.53),('10318','2013-05-10','08:30:00',5.27),('10318','2013-05-10','08:35:00',2.59),('10318','2013-05-10','08:40:00',1.51),('10318','2013-05-10','08:45:00',1.54),('10318','2013-05-10','08:50:00',1.55),('10318','2013-05-10','08:55:00',3.67),('10318','2013-05-10','09:00:00',5.94),('10318','2013-05-10','09:05:00',6.64),('10318','2013-05-10','09:10:00',6.78),('10318','2013-05-10','09:15:00',6.77),('10318','2013-05-10','09:20:00',5.6),('10318','2013-05-10','09:25:00',6.13),('10318','2013-05-10','09:30:00',7.61),('10318','2013-05-10','09:35:00',6.08),('10318','2013-05-10','09:40:00',6.41),('10318','2013-05-10','09:45:00',7.23),('10318','2013-05-10','09:50:00',8.01),('10318','2013-05-10','09:55:00',7.26),('10318','2013-05-10','10:00:00',7.05),('10318','2013-05-10','10:05:00',5.7),('10318','2013-05-10','10:10:00',6.27),('10318','2013-05-10','10:15:00',8.29),('10318','2013-05-10','10:20:00',8.75),('10318','2013-05-10','10:25:00',7.95),('10318','2013-05-10','10:30:00',5.82),('10318','2013-05-10','10:35:00',3.26),('10318','2013-05-10','10:40:00',9.14),('10318','2013-05-10','10:45:00',8.68),('10318','2013-05-10','10:50:00',7.87),('10318','2013-05-10','10:55:00',9.47),('10318','2013-05-10','11:00:00',9.01),('10318','2013-05-10','11:05:00',9.64),('10318','2013-05-10','11:10:00',9.86),('10318','2013-05-10','11:15:00',9.88),('10318','2013-05-10','11:20:00',6.72),('10318','2013-05-10','11:25:00',4.13),('10318','2013-05-10','11:30:00',3.31),('10318','2013-05-10','11:35:00',10.75),('10318','2013-05-10','11:40:00',5.15),('10318','2013-05-10','11:45:00',3),('10318','2013-05-10','11:50:00',3.46),('10318','2013-05-10','11:55:00',7.53),('10318','2013-05-10','12:00:00',7.11),('10318','2013-05-10','12:05:00',6.96),('10318','2013-05-10','12:10:00',7.17),('10318','2013-05-10','12:15:00',7.74),('10318','2013-05-10','12:20:00',5.99),('10318','2013-05-10','12:25:00',5.86),('10318','2013-05-10','12:30:00',6.42),('10318','2013-05-10','12:35:00',9.08),('10318','2013-05-10','12:40:00',10.64),('10318','2013-05-10','12:45:00',9.05),('10318','2013-05-10','12:50:00',9.63),('10318','2013-05-10','12:55:00',9.63),('10318','2013-05-10','13:00:00',9.66),('10318','2013-05-10','13:05:00',10.1),('10318','2013-05-10','13:10:00',10.53),('10318','2013-05-10','13:15:00',8.34),('10318','2013-05-10','13:20:00',7.14),('10318','2013-05-10','13:25:00',8.04),('10318','2013-05-10','13:30:00',8.81),('10318','2013-05-10','13:35:00',9.22),('10318','2013-05-10','13:40:00',9.69),('10318','2013-05-10','13:45:00',5.55),('10318','2013-05-10','13:50:00',4.68),('10318','2013-05-10','13:55:00',4.36),('10318','2013-05-10','14:00:00',4.39),('10318','2013-05-10','14:05:00',5.17),('10318','2013-05-10','14:10:00',5.9),('10318','2013-05-10','14:15:00',5.86),('10318','2013-05-10','14:20:00',5.74),('10318','2013-05-10','14:25:00',5.28),('10318','2013-05-10','14:30:00',6.57),('10318','2013-05-10','14:35:00',5.96),('10318','2013-05-10','14:40:00',4.57),('10318','2013-05-10','14:45:00',3.59),('10318','2013-05-10','14:50:00',3.04),('10318','2013-05-10','14:55:00',2.84),('10318','2013-05-10','15:00:00',3.1),('10318','2013-05-10','15:05:00',4.43),('10318','2013-05-10','15:10:00',7.57),('10318','2013-05-10','15:15:00',5.74),('10318','2013-05-10','15:20:00',4.44),('10318','2013-05-10','15:25:00',4.23),('10318','2013-05-10','15:30:00',4.39),('10318','2013-05-10','15:35:00',4.6),('10318','2013-05-10','15:40:00',4.44),('10318','2013-05-10','15:45:00',4.1),('10318','2013-05-10','15:50:00',3.8),('10318','2013-05-10','15:55:00',3.7),('10318','2013-05-10','16:00:00',3.72),('10318','2013-05-10','16:05:00',3.6),('10318','2013-05-10','16:10:00',3.37),('10318','2013-05-10','16:15:00',3.05),('10318','2013-05-10','16:20:00',3.03),('10318','2013-05-10','16:25:00',3.24),('10318','2013-05-10','16:30:00',3.55),('10318','2013-05-10','16:35:00',3.39),('10318','2013-05-10','16:40:00',3.1),('10318','2013-05-10','16:45:00',3.16),('10318','2013-05-10','16:50:00',2.71),('10318','2013-05-10','16:55:00',2.12),('10318','2013-05-10','17:00:00',2.07),('10318','2013-05-10','17:05:00',2.64),('10318','2013-05-10','17:10:00',3.59),('10318','2013-05-10','17:15:00',4.19),('10318','2013-05-10','17:20:00',4.64),('10318','2013-05-10','17:25:00',4.53),('10318','2013-05-10','17:30:00',5.58),('10318','2013-05-10','17:35:00',3.53),('10318','2013-05-10','17:40:00',2.87),('10318','2013-05-10','17:45:00',2.44),('10318','2013-05-10','17:50:00',2.2),('10318','2013-05-10','17:55:00',2.04),('10318','2013-05-10','18:00:00',1.96),('10318','2013-05-10','18:05:00',1.93),('10318','2013-05-10','18:10:00',1.72),('10318','2013-05-10','18:15:00',1.7),('10318','2013-05-10','18:20:00',1.59),('10318','2013-05-10','18:25:00',1.25),('10318','2013-05-09','07:05:00',1.09),('10318','2013-05-09','07:10:00',1.41),('10318','2013-05-09','07:15:00',1.86),('10318','2013-05-09','07:20:00',2.1),('10318','2013-05-09','07:25:00',2.45),('10318','2013-05-09','07:30:00',2.77),('10318','2013-05-09','07:35:00',2.98),('10318','2013-05-09','07:40:00',3.27),('10318','2013-05-09','07:45:00',3.47),('10318','2013-05-09','07:50:00',3.66),('10318','2013-05-09','07:55:00',3.87),('10318','2013-05-09','08:00:00',4.07),('10318','2013-05-09','08:05:00',4.28),('10318','2013-05-09','08:10:00',4.49),('10318','2013-05-09','08:15:00',4.7),('10318','2013-05-09','08:20:00',4.88),('10318','2013-05-09','08:25:00',5.07),('10318','2013-05-09','08:30:00',5.27),('10318','2013-05-09','08:35:00',5.45),('10318','2013-05-09','08:40:00',5.63),('10318','2013-05-09','08:45:00',5.82),('10318','2013-05-09','08:50:00',5.99),('10318','2013-05-09','08:55:00',6.17),('10318','2013-05-09','09:00:00',6.35),('10318','2013-05-09','09:05:00',6.5),('10318','2013-05-09','09:10:00',6.66),('10318','2013-05-09','09:15:00',6.81),('10318','2013-05-09','09:20:00',6.79),('10318','2013-05-09','09:25:00',7.12),('10318','2013-05-09','09:30:00',7.28),('10318','2013-05-09','09:35:00',7.42),('10318','2013-05-09','09:40:00',7.55),('10318','2013-05-09','09:45:00',7.65),('10318','2013-05-09','09:50:00',7.72),('10318','2013-05-09','09:55:00',7.9),('10318','2013-05-09','10:00:00',8.04),('10318','2013-05-09','10:05:00',8.14),('10318','2013-05-09','10:10:00',8.22),('10318','2013-05-09','10:15:00',8.31),('10318','2013-05-09','10:20:00',8.4),('10318','2013-05-09','10:25:00',8.57),('10318','2013-05-09','10:30:00',8.61),('10318','2013-05-09','10:35:00',8.69),('10318','2013-05-09','10:40:00',8.8),('10318','2013-05-09','10:45:00',8.81),('10318','2013-05-09','10:50:00',8.91),('10318','2013-05-09','10:55:00',8.96),('10318','2013-05-09','11:00:00',9.02),('10318','2013-05-09','11:05:00',9.12),('10318','2013-05-09','11:10:00',9.08),('10318','2013-05-09','11:15:00',9.25),('10318','2013-05-09','11:20:00',9.29),('10318','2013-05-09','11:25:00',9.32),('10318','2013-05-09','11:30:00',9.32),('10318','2013-05-09','11:35:00',9.38),('10318','2013-05-09','11:40:00',9.4),('10318','2013-05-09','11:45:00',9.4),('10318','2013-05-09','11:50:00',9.34),('10318','2013-05-09','11:55:00',9.41),('10318','2013-05-09','12:00:00',9.51),('10318','2013-05-09','12:05:00',9.57),('10318','2013-05-09','12:10:00',9.57),('10318','2013-05-09','12:15:00',9.6),('10318','2013-05-09','12:20:00',9.62),('10318','2013-05-09','12:25:00',9.63),('10318','2013-05-09','12:30:00',9.63),('10318','2013-05-09','12:35:00',9.55),('10318','2013-05-09','12:40:00',9.61),('10318','2013-05-09','12:45:00',9.57),('10318','2013-05-09','12:50:00',9.57),('10318','2013-05-09','12:55:00',9.47),('10318','2013-05-09','13:00:00',9.47),('10318','2013-05-09','13:05:00',9.29),('10318','2013-05-09','13:10:00',9.41),('10318','2013-05-09','13:15:00',9.55),('10318','2013-05-09','13:20:00',9.57),('10318','2013-05-09','13:25:00',9.5),('10318','2013-05-09','13:30:00',9.5),('10318','2013-05-09','13:35:00',9.61),('10318','2013-05-09','13:40:00',9.49),('10318','2013-05-09','13:45:00',6.62),('10318','2013-05-09','13:50:00',2.51),('10318','2013-05-09','13:55:00',2.16),('10318','2013-05-09','14:00:00',6.72),('10318','2013-05-09','14:05:00',8.87),('10318','2013-05-09','14:10:00',9.16),('10318','2013-05-09','14:15:00',8.58),('10318','2013-05-09','14:20:00',3.43),('10318','2013-05-09','14:25:00',9.52),('10318','2013-05-09','14:30:00',9.08),('10318','2013-05-09','14:35:00',8.83),('10318','2013-05-09','14:40:00',8.58),('10318','2013-05-09','14:45:00',8.46),('10318','2013-05-09','14:50:00',7.59),('10318','2013-05-09','14:55:00',8.25),('10318','2013-05-09','15:00:00',8.18),('10318','2013-05-09','15:05:00',8.15),('10318','2013-05-09','15:10:00',8.06),('10318','2013-05-09','15:15:00',7.96),('10318','2013-05-09','15:20:00',7.81),('10318','2013-05-09','15:25:00',7.57),('10318','2013-05-09','15:30:00',7.42),('10318','2013-05-09','15:35:00',7.36),('10318','2013-05-09','15:40:00',7.23),('10318','2013-05-09','15:45:00',7.13),('10318','2013-05-09','15:50:00',6.95),('10318','2013-05-09','15:55:00',6.7),('10318','2013-05-09','16:00:00',6.6),('10318','2013-05-09','16:05:00',6.42),('10318','2013-05-09','16:10:00',6.28),('10318','2013-05-09','16:15:00',6.1),('10318','2013-05-09','16:20:00',5.94),('10318','2013-05-09','16:25:00',5.74),('10318','2013-05-09','16:30:00',5.59),('10318','2013-05-09','16:35:00',5.39),('10318','2013-05-09','16:40:00',5.25),('10318','2013-05-09','16:45:00',5.06),('10318','2013-05-09','16:50:00',4.88),('10318','2013-05-09','16:55:00',4.69),('10318','2013-05-09','17:00:00',4.49),('10318','2013-05-09','17:05:00',4.28),('10318','2013-05-09','17:10:00',4.09),('10318','2013-05-09','17:15:00',3.91),('10318','2013-05-09','17:20:00',3.74),('10318','2013-05-09','17:25:00',3.55),('10318','2013-05-09','17:30:00',3.37),('10318','2013-05-09','17:35:00',3.19),('10318','2013-05-09','17:40:00',2.93),('10318','2013-05-09','17:45:00',2.79),('10318','2013-05-09','17:50:00',2.61),('10318','2013-05-09','17:55:00',2.44),('10318','2013-05-09','18:00:00',2.23),('10318','2013-05-09','18:05:00',2.09),('10318','2013-05-09','18:10:00',1.88),('10318','2013-05-09','18:15:00',1.76),('10318','2013-05-09','18:20:00',1.61),('10318','2013-05-09','18:25:00',1.46),('10318','2013-05-09','18:30:00',1.33),('10318','2013-05-09','18:35:00',1.17),('10318','2013-05-09','18:40:00',1.05),('10318','2013-05-08','07:55:00',3.08),('10318','2013-05-08','08:00:00',3.97),('10318','2013-05-08','08:05:00',4.12),('10318','2013-05-08','08:10:00',4.16),('10318','2013-05-08','08:15:00',4.79),('10318','2013-05-08','08:20:00',4.94),('10318','2013-05-08','08:25:00',5.03),('10318','2013-05-08','08:30:00',5.19),('10318','2013-05-08','08:35:00',5.36),('10318','2013-05-08','08:40:00',5.36),('10318','2013-05-08','08:45:00',5.63),('10318','2013-05-08','08:50:00',5.76),('10318','2013-05-08','08:55:00',4.86),('10318','2013-05-08','09:00:00',4.57),('10318','2013-05-08','09:05:00',6.71),('10318','2013-05-08','09:10:00',6.75),('10318','2013-05-08','09:15:00',6.9),('10318','2013-05-08','09:20:00',7.31),('10318','2013-05-08','09:25:00',7.8),('10318','2013-05-08','09:30:00',8.45),('10318','2013-05-08','09:35:00',8.36),('10318','2013-05-08','09:40:00',5.08),('10318','2013-05-08','09:45:00',6.27),('10318','2013-05-08','09:50:00',4.6),('10318','2013-05-08','09:55:00',9.26),('10318','2013-05-08','10:00:00',9.2),('10318','2013-05-08','10:05:00',8.74),('10318','2013-05-08','10:10:00',8.61),('10318','2013-05-08','10:15:00',9.62),('10318','2013-05-08','10:20:00',5.52),('10318','2013-05-08','10:25:00',1.76),('10318','2013-05-08','10:30:00',1.68),('10318','2013-05-08','10:35:00',1.66),('10318','2013-05-08','10:40:00',1.78),('10318','2013-05-08','10:45:00',2.13),('10318','2013-05-08','10:50:00',6.02),('10318','2013-05-08','10:55:00',10.21),('10318','2013-05-08','11:00:00',9.97),('10318','2013-05-08','11:05:00',9.89),('10318','2013-05-08','11:10:00',10.09),('10318','2013-05-08','11:15:00',10.48),('10318','2013-05-08','11:20:00',10.05),('10318','2013-05-08','11:25:00',9.98),('10318','2013-05-08','11:30:00',6.48),('10318','2013-05-08','11:35:00',6.4),('10318','2013-05-08','11:40:00',7.05),('10318','2013-05-08','11:45:00',8.19),('10318','2013-05-08','11:50:00',2.82),('10318','2013-05-08','11:55:00',2.62),('10318','2013-05-08','12:00:00',2.71),('10318','2013-05-08','12:05:00',2.74),('10318','2013-05-08','12:10:00',2.32),('10318','2013-05-08','12:15:00',4.45),('10318','2013-05-08','12:20:00',4.23),('10318','2013-05-08','12:25:00',2.2),('10318','2013-05-08','12:30:00',2.09),('10318','2013-05-08','12:35:00',1.86),('10318','2013-05-08','12:40:00',2.34),('10318','2013-05-08','12:45:00',2.95),('10318','2013-05-08','12:50:00',2.67),('10318','2013-05-08','12:55:00',2.93),('10318','2013-05-08','13:00:00',3.39),('10318','2013-05-08','13:05:00',5.1),('10318','2013-05-08','13:10:00',3.46),('10318','2013-05-08','13:15:00',2.29),('10318','2013-05-08','13:20:00',6.27),('10318','2013-05-08','13:25:00',6.42),('10318','2013-05-08','13:30:00',8.24),('10318','2013-05-08','13:35:00',10.49),('10318','2013-05-08','13:40:00',8.95),('10318','2013-05-08','13:45:00',4.59),('10318','2013-05-08','13:50:00',5.54),('10318','2013-05-08','13:55:00',9.68),('10318','2013-05-08','14:00:00',7.85),('10318','2013-05-08','14:05:00',5.25),('10318','2013-05-08','14:10:00',4.45),('10318','2013-05-08','14:15:00',3.82),('10318','2013-05-08','14:20:00',6.7),('10318','2013-05-08','14:25:00',10.03),('10318','2013-05-08','14:30:00',7.43),('10318','2013-05-08','14:35:00',8),('10318','2013-05-08','14:40:00',9.32),('10318','2013-05-08','14:45:00',8.84),('10318','2013-05-08','14:50:00',7.56),('10318','2013-05-08','14:55:00',4.81),('10318','2013-05-08','15:00:00',9.02),('10318','2013-05-08','15:05:00',8.69),('10318','2013-05-08','15:10:00',8.01),('10318','2013-05-08','15:15:00',7.99),('10318','2013-05-08','15:20:00',7.86),('10318','2013-05-08','15:25:00',7.77),('10318','2013-05-08','15:30:00',6.91),('10318','2013-05-08','15:35:00',7.55),('10318','2013-05-08','15:40:00',7.59),('10318','2013-05-08','15:45:00',7.41),('10318','2013-05-08','15:50:00',4.94),('10318','2013-05-08','15:55:00',6.17),('10318','2013-05-08','16:00:00',4.55),('10318','2013-05-08','16:05:00',5.44),('10318','2013-05-08','16:10:00',6.16),('10318','2013-05-08','16:15:00',6.58),('10318','2013-05-08','16:20:00',6.13),('10318','2013-05-08','16:25:00',6.2),('10318','2013-05-08','16:30:00',6.11),('10318','2013-05-08','16:35:00',5.92),('10318','2013-05-08','16:40:00',5.71),('10318','2013-05-08','16:45:00',5.45),('10318','2013-05-08','16:50:00',5.09),('10318','2013-05-08','16:55:00',4.82),('10318','2013-05-08','17:00:00',4.44),('10318','2013-05-08','17:05:00',4.5),('10318','2013-05-08','17:10:00',4.28),('10318','2013-05-08','17:15:00',3.73),('10318','2013-05-08','17:20:00',3.41),('10318','2013-05-08','17:25:00',3.6),('10318','2013-05-08','17:30:00',3.84),('10318','2013-05-08','17:35:00',3.84),('10318','2013-05-08','17:40:00',3.88),('10318','2013-05-08','17:45:00',3.81),('10318','2013-05-08','17:50:00',3.83),('10318','2013-05-08','17:55:00',3.56),('10318','2013-05-08','18:00:00',3.13),('10318','2013-05-08','18:05:00',2.84),('10318','2013-05-08','18:10:00',2.74),('10318','2013-05-08','18:15:00',2.52),('10318','2013-05-08','18:20:00',2.3),('10318','2013-05-08','18:25:00',1.94),('10318','2013-05-08','18:30:00',1.52),('10318','2013-05-08','18:35:00',1.31),('10318','2013-05-08','18:40:00',1.09),('10318','2013-05-07','07:10:00',1.43),('10318','2013-05-07','07:20:00',1.67),('10318','2013-05-07','07:25:00',2.39),('10318','2013-05-07','07:30:00',2.68),('10318','2013-05-07','07:35:00',3.02),('10318','2013-05-07','07:40:00',3.24),('10318','2013-05-07','07:45:00',3.34),('10318','2013-05-07','07:50:00',3.57),('10318','2013-05-07','07:55:00',3.8),('10318','2013-05-07','08:00:00',4.05),('10318','2013-05-07','08:05:00',4.25),('10318','2013-05-07','08:10:00',4.46),('10318','2013-05-07','08:15:00',4.64),('10318','2013-05-07','08:20:00',4.84),('10318','2013-05-07','08:25:00',5),('10318','2013-05-07','08:30:00',5.31),('10318','2013-05-07','08:35:00',5.54),('10318','2013-05-07','08:40:00',5.68),('10318','2013-05-07','08:45:00',5.64),('10318','2013-05-07','08:50:00',5.97),('10318','2013-05-07','08:55:00',6.57),('10318','2013-05-07','09:00:00',5.18),('10318','2013-05-07','09:05:00',4.69),('10318','2013-05-07','09:10:00',7.52),('10318','2013-05-07','09:15:00',7.57),('10318','2013-05-07','09:20:00',6.15),('10318','2013-05-07','09:25:00',2.06),('10318','2013-05-07','09:30:00',2.16),('10318','2013-05-07','09:35:00',2.73),('10318','2013-05-07','09:40:00',9.62),('10318','2013-05-07','09:45:00',6.71),('10318','2013-05-07','09:50:00',5.08),('10318','2013-05-07','09:55:00',2.3),('10318','2013-05-07','10:00:00',2.11),('10318','2013-05-07','10:05:00',1.52),('10318','2013-05-07','10:10:00',1.45),('10318','2013-05-07','10:15:00',1.57),('10318','2013-05-07','10:20:00',1.74),('10318','2013-05-07','10:25:00',1.93),('10318','2013-05-07','10:30:00',2.32),('10318','2013-05-07','10:35:00',2.68),('10318','2013-05-07','10:40:00',4),('10318','2013-05-07','10:45:00',10.99),('10318','2013-05-07','10:50:00',5.99),('10318','2013-05-07','10:55:00',3.24),('10318','2013-05-07','11:00:00',2.69),('10318','2013-05-07','11:05:00',2.25),('10318','2013-05-07','11:10:00',2.35),('10318','2013-05-07','11:15:00',2.76),('10318','2013-05-07','11:20:00',3.21),('10318','2013-05-07','11:25:00',1.49),('10318','2013-05-07','11:30:00',1.08),('10318','2013-05-07','11:35:00',1.36),('10318','2013-05-07','11:40:00',1.72),('10318','2013-05-07','11:45:00',6.69),('10318','2013-05-07','11:50:00',10.79),('10318','2013-05-07','11:55:00',10.81),('10318','2013-05-07','12:00:00',10.82),('10318','2013-05-07','12:05:00',10.86),('10318','2013-05-07','12:10:00',9.83),('10318','2013-05-07','12:15:00',3.73),('10318','2013-05-07','12:20:00',3.36),('10318','2013-05-07','12:25:00',3.13),('10318','2013-05-07','12:30:00',2.58),('10318','2013-05-07','12:35:00',2.9),('10318','2013-05-07','12:40:00',3.68),('10318','2013-05-07','12:45:00',3.22),('10318','2013-05-07','12:50:00',2.69),('10318','2013-05-07','12:55:00',2.58),('10318','2013-05-07','13:00:00',2.5),('10318','2013-05-07','13:05:00',3.39),('10318','2013-05-07','13:10:00',3.83),('10318','2013-05-07','13:15:00',3.22),('10318','2013-05-07','13:20:00',3.16),('10318','2013-05-07','13:25:00',6),('10318','2013-05-07','13:30:00',9.3),('10318','2013-05-07','13:35:00',8.92),('10318','2013-05-07','13:40:00',9.72),('10318','2013-05-07','13:45:00',8.9),('10318','2013-05-07','13:50:00',10.22),('10318','2013-05-07','13:55:00',9.09),('10318','2013-05-07','14:00:00',3.22),('10318','2013-05-07','14:05:00',5.6),('10318','2013-05-07','14:10:00',4.92),('10318','2013-05-07','14:15:00',5.04),('10318','2013-05-07','14:20:00',7.28),('10318','2013-05-07','14:25:00',10.35),('10318','2013-05-07','14:30:00',10.26),('10318','2013-05-07','14:35:00',9.95),('10318','2013-05-07','14:40:00',8.74),('10318','2013-05-07','14:45:00',9.31),('10318','2013-05-07','14:50:00',9.26),('10318','2013-05-07','14:55:00',8.13),('10318','2013-05-07','15:00:00',8.88),('10318','2013-05-07','15:05:00',8.57),('10318','2013-05-07','15:10:00',8.31),('10318','2013-05-07','15:15:00',8.41),('10318','2013-05-07','15:20:00',8.03),('10318','2013-05-07','15:25:00',5.58),('10318','2013-05-07','15:30:00',8.04),('10318','2013-05-07','15:35:00',5.62),('10318','2013-05-07','15:40:00',5.27),('10318','2013-05-07','15:45:00',4.21),('10318','2013-05-07','15:50:00',2.87),('10318','2013-05-07','15:55:00',4.66),('10318','2013-05-07','16:00:00',4.98),('10318','2013-05-07','16:05:00',6.39),('10318','2013-05-07','16:10:00',7.36),('10318','2013-05-07','16:15:00',7.66),('10318','2013-05-07','16:20:00',7.11),('10318','2013-05-07','16:25:00',7.41),('10318','2013-05-07','16:30:00',6.99),('10318','2013-05-07','16:35:00',5.23),('10318','2013-05-07','16:40:00',6.75),('10318','2013-05-07','16:45:00',5.96),('10318','2013-05-07','16:50:00',4.13),('10318','2013-05-07','16:55:00',4.35),('10318','2013-05-07','17:00:00',5.46),('10318','2013-05-07','17:05:00',4.06),('10318','2013-05-07','17:10:00',2.27),('10318','2013-05-07','17:15:00',2.31),('10318','2013-05-07','17:20:00',2.35),('10318','2013-05-07','17:25:00',2.55),('10318','2013-05-07','17:30:00',2.46),('10318','2013-05-07','17:35:00',2.24),('10318','2013-05-07','17:40:00',1.94),('10318','2013-05-07','17:45:00',1.7),('10318','2013-05-07','17:50:00',1.3),('10318','2013-05-07','17:55:00',1.11),('10318','2013-05-07','18:00:00',1.1),('10318','2013-05-07','18:05:00',1.01),('10318','2013-05-07','18:20:00',1.02),('10318','2013-05-07','18:25:00',1.07),('10318','2013-05-07','18:30:00',1.08),('10318','2013-05-07','18:35:00',1.21),('10318','2013-05-07','18:40:00',1.3),('10318','2013-05-07','18:45:00',1.44),('10318','2013-05-07','18:50:00',1.13),('10318','2013-05-06','08:10:00',1.25),('10318','2013-05-06','08:15:00',1.94),('10318','2013-05-06','08:20:00',2.5),('10318','2013-05-06','08:25:00',2.84),('10318','2013-05-06','08:30:00',2.52),('10318','2013-05-06','08:35:00',3.12),('10318','2013-05-06','08:40:00',3.93),('10318','2013-05-06','08:45:00',3.47),('10318','2013-05-06','08:50:00',3.53),('10318','2013-05-06','08:55:00',5.09),('10318','2013-05-06','09:00:00',4.6),('10318','2013-05-06','09:05:00',2.94),('10318','2013-05-06','09:10:00',2.73),('10318','2013-05-06','09:15:00',3.82),('10318','2013-05-06','09:20:00',5.86),('10318','2013-05-06','09:25:00',7.21),('10318','2013-05-06','09:30:00',2.57),('10318','2013-05-06','09:40:00',1.07),('10318','2013-05-06','09:45:00',2.14),('10318','2013-05-06','09:50:00',1.98),('10318','2013-05-06','09:55:00',2.37),('10318','2013-05-06','10:00:00',2.37),('10318','2013-05-06','10:05:00',2.15),('10318','2013-05-06','10:10:00',2.33),('10318','2013-05-06','10:15:00',2.98),('10318','2013-05-06','10:20:00',4.23),('10318','2013-05-06','10:25:00',4.91),('10318','2013-05-06','10:30:00',3.9),('10318','2013-05-06','10:35:00',3.93),('10318','2013-05-06','10:40:00',3.38),('10318','2013-05-06','10:45:00',3.32),('10318','2013-05-06','10:50:00',3.74),('10318','2013-05-06','10:55:00',3.98),('10318','2013-05-06','11:00:00',4.64),('10318','2013-05-06','11:05:00',3.58),('10318','2013-05-06','11:10:00',2.97),('10318','2013-05-06','11:15:00',3.1),('10318','2013-05-06','11:20:00',4.74),('10318','2013-05-06','11:25:00',3.16),('10318','2013-05-06','11:30:00',2.96),('10318','2013-05-06','11:35:00',4.57),('10318','2013-05-06','11:40:00',5.06),('10318','2013-05-06','11:45:00',4.95),('10318','2013-05-06','11:50:00',3.63),('10318','2013-05-06','11:55:00',3.39),('10318','2013-05-06','12:00:00',3.66),('10318','2013-05-06','12:05:00',4.64),('10318','2013-05-06','12:10:00',5.36),('10318','2013-05-06','12:15:00',7.23),('10318','2013-05-06','12:20:00',6.12),('10318','2013-05-06','12:25:00',10.82),('10318','2013-05-06','12:30:00',6.77),('10318','2013-05-06','12:35:00',4.25),('10318','2013-05-06','12:40:00',6.43),('10318','2013-05-06','12:45:00',9.32),('10318','2013-05-06','12:50:00',7.03),('10318','2013-05-06','12:55:00',5.9),('10318','2013-05-06','13:00:00',5.49),('10318','2013-05-06','13:05:00',9.08),('10318','2013-05-06','13:10:00',5.38),('10318','2013-05-06','13:15:00',10.21),('10318','2013-05-06','13:20:00',7.12),('10318','2013-05-06','13:25:00',6.85),('10318','2013-05-06','13:30:00',9.98),('10318','2013-05-06','13:35:00',8.56),('10318','2013-05-06','13:40:00',8.4),('10318','2013-05-06','13:45:00',9.43),('10318','2013-05-06','13:50:00',9.85),('10318','2013-05-06','13:55:00',5.74),('10318','2013-05-06','14:00:00',6.83),('10318','2013-05-06','14:05:00',4.9),('10318','2013-05-06','14:10:00',5.26),('10318','2013-05-06','14:15:00',5.11),('10318','2013-05-06','14:20:00',5.04),('10318','2013-05-06','14:25:00',5.54),('10318','2013-05-06','14:30:00',6.53),('10318','2013-05-06','14:35:00',7.74),('10318','2013-05-06','14:40:00',3.7),('10318','2013-05-06','14:45:00',6.42),('10318','2013-05-06','14:50:00',4.95),('10318','2013-05-06','14:55:00',4.69),('10318','2013-05-06','15:00:00',5.55),('10318','2013-05-06','15:05:00',5.98),('10318','2013-05-06','15:10:00',4.16),('10318','2013-05-06','15:15:00',4.19),('10318','2013-05-06','15:20:00',3.24),('10318','2013-05-06','15:25:00',6.66),('10318','2013-05-06','15:30:00',2.92),('10318','2013-05-06','15:35:00',7.23),('10318','2013-05-06','15:40:00',4.38),('10318','2013-05-06','15:45:00',5.77),('10318','2013-05-06','15:50:00',5.63),('10318','2013-05-06','15:55:00',6.84),('10318','2013-05-06','16:00:00',3.54),('10318','2013-05-06','16:05:00',3.01),('10318','2013-05-06','16:10:00',4.02),('10318','2013-05-06','16:15:00',4.89),('10318','2013-05-06','16:20:00',5.45),('10318','2013-05-06','16:25:00',3.61),('10318','2013-05-06','16:30:00',4.79),('10318','2013-05-06','16:35:00',6.14),('10318','2013-05-06','16:40:00',6.43),('10318','2013-05-06','16:45:00',3.65),('10318','2013-05-06','16:50:00',5.86),('10318','2013-05-06','16:55:00',1.47),('10318','2013-05-06','17:10:00',2.89),('10318','2013-05-06','17:15:00',5.31),('10318','2013-05-06','17:20:00',2.28),('10318','2013-05-06','17:25:00',3.58),('10318','2013-05-06','17:30:00',2.65),('10318','2013-05-06','17:35:00',2.99),('10318','2013-05-06','17:40:00',3.66),('10318','2013-05-06','17:45:00',3.56),('10318','2013-05-06','17:50:00',3.21),('10318','2013-05-06','17:55:00',3.15),('10318','2013-05-06','18:00:00',2.71),('10318','2013-05-06','18:05:00',2.4),('10318','2013-05-06','18:10:00',1.18),('10318','2013-05-06','18:15:00',1.44),('10318','2013-05-06','18:20:00',1.74),('10318','2013-05-05','07:10:00',1.17),('10318','2013-05-05','07:15:00',1.33),('10318','2013-05-05','07:20:00',1.58),('10318','2013-05-05','07:25:00',1.9),('10318','2013-05-05','07:30:00',1.93),('10318','2013-05-05','07:35:00',1.76),('10318','2013-05-05','07:40:00',1.37),('10318','2013-05-05','07:45:00',2.86),('10318','2013-05-05','07:50:00',3.12),('10318','2013-05-05','07:55:00',3.17),('10318','2013-05-05','08:00:00',3.46),('10318','2013-05-05','08:05:00',3.74),('10318','2013-05-05','08:10:00',3.99),('10318','2013-05-05','08:15:00',4.31),('10318','2013-05-05','08:20:00',4.8),('10318','2013-05-05','08:25:00',5.07),('10318','2013-05-05','08:30:00',5.58),('10318','2013-05-05','08:35:00',4.05),('10318','2013-05-05','08:40:00',4.38),('10318','2013-05-05','08:45:00',5.55),('10318','2013-05-05','08:50:00',3.11),('10318','2013-05-05','08:55:00',3.17),('10318','2013-05-05','09:00:00',3.37),('10318','2013-05-05','09:05:00',3.29),('10318','2013-05-05','09:10:00',3.73),('10318','2013-05-05','09:15:00',3.16),('10318','2013-05-05','09:20:00',3.02),('10318','2013-05-05','09:25:00',4.36),('10318','2013-05-05','09:30:00',7.36),('10318','2013-05-05','09:35:00',6.98),('10318','2013-05-05','09:40:00',8.27),('10318','2013-05-05','09:45:00',8.04),('10318','2013-05-05','09:50:00',7.8),('10318','2013-05-05','09:55:00',8.71),('10318','2013-05-05','10:00:00',9),('10318','2013-05-05','10:05:00',9.4),('10318','2013-05-05','10:10:00',9.3),('10318','2013-05-05','10:15:00',8.38),('10318','2013-05-05','10:20:00',7.19),('10318','2013-05-05','10:25:00',7.56),('10318','2013-05-05','10:30:00',6.62),('10318','2013-05-05','10:35:00',4.6),('10318','2013-05-05','10:40:00',4.21),('10318','2013-05-05','10:45:00',3.86),('10318','2013-05-05','10:50:00',3.1),('10318','2013-05-05','10:55:00',2.84),('10318','2013-05-05','11:00:00',3.31),('10318','2013-05-05','11:05:00',3.37),('10318','2013-05-05','11:10:00',3.23),('10318','2013-05-05','11:15:00',4.23),('10318','2013-05-05','11:20:00',6.35),('10318','2013-05-05','11:25:00',4.99),('10318','2013-05-05','11:30:00',7.29),('10318','2013-05-05','11:35:00',6.81),('10318','2013-05-05','11:40:00',6.66),('10318','2013-05-05','11:45:00',6.91),('10318','2013-05-05','11:50:00',9.62),('10318','2013-05-05','11:55:00',9.14),('10318','2013-05-05','12:00:00',7.3),('10318','2013-05-05','12:05:00',9.34),('10318','2013-05-05','12:10:00',8.72),('10318','2013-05-05','12:15:00',5.72),('10318','2013-05-05','12:20:00',7.92),('10318','2013-05-05','12:25:00',9.09),('10318','2013-05-05','12:30:00',5.23),('10318','2013-05-05','12:35:00',7.7),('10318','2013-05-05','12:40:00',5.82),('10318','2013-05-05','12:45:00',5.81),('10318','2013-05-05','12:50:00',10.67),('10318','2013-05-05','12:55:00',6.7),('10318','2013-05-05','13:00:00',6.02),('10318','2013-05-05','13:05:00',7.53),('10318','2013-05-05','13:10:00',6.6),('10318','2013-05-05','13:15:00',6.77),('10318','2013-05-05','13:20:00',5.55),('10318','2013-05-05','13:25:00',6.98),('10318','2013-05-05','13:30:00',8.7),('10318','2013-05-05','13:35:00',8.65),('10318','2013-05-05','13:40:00',10.09),('10318','2013-05-05','13:45:00',9.87),('10318','2013-05-05','13:50:00',6.36),('10318','2013-05-05','13:55:00',5.79),('10318','2013-05-05','14:00:00',6.73),('10318','2013-05-05','14:05:00',8.31),('10318','2013-05-05','14:10:00',9.63),('10318','2013-05-05','14:15:00',8.87),('10318','2013-05-05','14:20:00',7.61),('10318','2013-05-05','14:25:00',8.49),('10318','2013-05-05','14:30:00',8.3),('10318','2013-05-05','14:35:00',8.16),('10318','2013-05-05','14:40:00',7.83),('10318','2013-05-05','14:45:00',8.06),('10318','2013-05-05','14:50:00',7.95),('10318','2013-05-05','14:55:00',7.81),('10318','2013-05-05','15:00:00',7.7),('10318','2013-05-05','15:05:00',7.6),('10318','2013-05-05','15:10:00',7.45),('10318','2013-05-05','15:15:00',7.35),('10318','2013-05-05','15:20:00',7.21),('10318','2013-05-05','15:25:00',7.09),('10318','2013-05-05','15:30:00',6.98),('10318','2013-05-05','15:35:00',6.83),('10318','2013-05-05','15:40:00',6.75),('10318','2013-05-05','15:45:00',6.69),('10318','2013-05-05','15:50:00',6.6),('10318','2013-05-05','15:55:00',6.48),('10318','2013-05-05','16:00:00',6.32),('10318','2013-05-05','16:05:00',6.15),('10318','2013-05-05','16:10:00',6),('10318','2013-05-05','16:15:00',5.84),('10318','2013-05-05','16:20:00',5.67),('10318','2013-05-05','16:25:00',5.34),('10318','2013-05-05','16:30:00',5.36),('10318','2013-05-05','16:35:00',5.18),('10318','2013-05-05','16:40:00',5.03),('10318','2013-05-05','16:45:00',4.87),('10318','2013-05-05','16:50:00',4.69),('10318','2013-05-05','16:55:00',4.49),('10318','2013-05-05','17:00:00',4.3),('10318','2013-05-05','17:05:00',4.12),('10318','2013-05-05','17:10:00',3.94),('10318','2013-05-05','17:15:00',3.74),('10318','2013-05-05','17:20:00',3.57),('10318','2013-05-05','17:25:00',3.37),('10318','2013-05-05','17:30:00',3.16),('10318','2013-05-05','17:35:00',2.98),('10318','2013-05-05','17:40:00',2.82),('10318','2013-05-05','17:45:00',2.64),('10318','2013-05-05','17:50:00',2.49),('10318','2013-05-05','17:55:00',2.33),('10318','2013-05-05','18:00:00',2.13),('10318','2013-05-05','18:05:00',1.96),('10318','2013-05-05','18:10:00',1.8),('10318','2013-05-05','18:15:00',1.69),('10318','2013-05-05','18:20:00',1.54),('10318','2013-05-05','18:25:00',1.42),('10318','2013-05-05','18:30:00',1.3),('10318','2013-05-05','18:35:00',1.19),('10318','2013-05-05','18:40:00',1.09),('10318','2013-05-04','07:35:00',2.09),('10318','2013-05-04','07:40:00',2.86),('10318','2013-05-04','07:45:00',2.91),('10318','2013-05-04','07:50:00',2.49),('10318','2013-05-04','07:55:00',3.35),('10318','2013-05-04','08:00:00',3.64),('10318','2013-05-04','08:05:00',3.8),('10318','2013-05-04','08:10:00',4.02),('10318','2013-05-04','08:15:00',4.22),('10318','2013-05-04','08:20:00',4.4),('10318','2013-05-04','08:25:00',4.46),('10318','2013-05-04','08:30:00',4.77),('10318','2013-05-04','08:35:00',4.87),('10318','2013-05-04','08:40:00',5.08),('10318','2013-05-04','08:45:00',5.25),('10318','2013-05-04','08:50:00',5.43),('10318','2013-05-04','08:55:00',5.57),('10318','2013-05-04','09:00:00',5.73),('10318','2013-05-04','09:05:00',5.95),('10318','2013-05-04','09:10:00',6.04),('10318','2013-05-04','09:15:00',6.16),('10318','2013-05-04','09:20:00',6.4),('10318','2013-05-04','09:25:00',6.54),('10318','2013-05-04','09:30:00',6.69),('10318','2013-05-04','09:35:00',6.8),('10318','2013-05-04','09:40:00',7.04),('10318','2013-05-04','09:45:00',7.2),('10318','2013-05-04','09:50:00',7.36),('10318','2013-05-04','09:55:00',7.52),('10318','2013-05-04','10:00:00',7.74),('10318','2013-05-04','10:05:00',7.66),('10318','2013-05-04','10:10:00',7.69),('10318','2013-05-04','10:15:00',7.95),('10318','2013-05-04','10:20:00',8.06),('10318','2013-05-04','10:25:00',8.1),('10318','2013-05-04','10:30:00',8.22),('10318','2013-05-04','10:35:00',8.2),('10318','2013-05-04','10:40:00',8.18),('10318','2013-05-04','10:45:00',7.98),('10318','2013-05-04','10:50:00',7.96),('10318','2013-05-04','10:55:00',8.37),('10318','2013-05-04','11:00:00',8.29),('10318','2013-05-04','11:05:00',8.3),('10318','2013-05-04','11:10:00',7.93),('10318','2013-05-04','11:15:00',7.35),('10318','2013-05-04','11:20:00',7.74),('10318','2013-05-04','11:25:00',8.37),('10318','2013-05-04','11:30:00',7.87),('10318','2013-05-04','11:35:00',7.96),('10318','2013-05-04','11:40:00',7.92),('10318','2013-05-04','11:45:00',7.96),('10318','2013-05-04','11:50:00',8.02),('10318','2013-05-04','11:55:00',8.06),('10318','2013-05-04','12:00:00',8.19),('10318','2013-05-04','12:05:00',8.12),('10318','2013-05-04','12:10:00',8.31),('10318','2013-05-04','12:15:00',8.6),('10318','2013-05-04','12:20:00',8.66),('10318','2013-05-04','12:25:00',8.78),('10318','2013-05-04','12:30:00',8.75),('10318','2013-05-04','12:35:00',8.94),('10318','2013-05-04','12:40:00',8.79),('10318','2013-05-04','12:45:00',8.75),('10318','2013-05-04','12:50:00',8.57),('10318','2013-05-04','12:55:00',8.62),('10318','2013-05-04','13:00:00',8.39),('10318','2013-05-04','13:05:00',7.86),('10318','2013-05-04','13:10:00',8),('10318','2013-05-04','13:15:00',8.72),('10318','2013-05-04','13:20:00',8.97),('10318','2013-05-04','13:25:00',8.64),('10318','2013-05-04','13:30:00',8.46),('10318','2013-05-04','13:35:00',7.91),('10318','2013-05-04','13:40:00',8.27),('10318','2013-05-04','13:45:00',8.13),('10318','2013-05-04','13:50:00',7.32),('10318','2013-05-04','13:55:00',8.11),('10318','2013-05-04','14:00:00',8.05),('10318','2013-05-04','14:05:00',7.8),('10318','2013-05-04','14:10:00',7.59),('10318','2013-05-04','14:15:00',8),('10318','2013-05-04','14:20:00',7.48),('10318','2013-05-04','14:25:00',7.24),('10318','2013-05-04','14:30:00',7.55),('10318','2013-05-04','14:35:00',7.05),('10318','2013-05-04','14:40:00',7.18),('10318','2013-05-04','14:45:00',7.07),('10318','2013-05-04','14:50:00',6.76),('10318','2013-05-04','14:55:00',6.83),('10318','2013-05-04','15:00:00',7),('10318','2013-05-04','15:05:00',6.98),('10318','2013-05-04','15:10:00',6.61),('10318','2013-05-04','15:15:00',6.94),('10318','2013-05-04','15:20:00',6.84),('10318','2013-05-04','15:25:00',6.97),('10318','2013-05-04','15:30:00',6.88),('10318','2013-05-04','15:35:00',6.37),('10318','2013-05-04','15:40:00',6.69),('10318','2013-05-04','15:45:00',6.5),('10318','2013-05-04','15:50:00',6.32),('10318','2013-05-04','15:55:00',6.14),('10318','2013-05-04','16:00:00',5.99),('10318','2013-05-04','16:05:00',5.83),('10318','2013-05-04','16:10:00',5.67),('10318','2013-05-04','16:15:00',5.56),('10318','2013-05-04','16:20:00',5.4),('10318','2013-05-04','16:25:00',5.24),('10318','2013-05-04','16:30:00',5.05),('10318','2013-05-04','16:35:00',4.88),('10318','2013-05-04','16:40:00',4.63),('10318','2013-05-04','16:45:00',4.54),('10318','2013-05-04','16:50:00',4.36),('10318','2013-05-04','16:55:00',4.22),('10318','2013-05-04','17:00:00',4.08),('10318','2013-05-04','17:05:00',3.94),('10318','2013-05-04','17:10:00',3.29),('10318','2013-05-04','17:15:00',3.18),('10318','2013-05-04','17:20:00',3.48),('10318','2013-05-04','17:25:00',3.29),('10318','2013-05-04','17:30:00',3.06),('10318','2013-05-04','17:35:00',2.86),('10318','2013-05-04','17:40:00',2.37),('10318','2013-05-04','17:45:00',2.33),('10318','2013-05-04','17:50:00',2.46),('10318','2013-05-04','17:55:00',2.32),('10318','2013-05-04','18:00:00',2.14),('10318','2013-05-04','18:05:00',1.99),('10318','2013-05-04','18:10:00',1.52),('10318','2013-05-04','18:15:00',1.35),('10318','2013-05-04','18:20:00',1.07),('10318','2013-05-04','18:25:00',1.02),('10318','2013-05-03','07:25:00',1.07),('10318','2013-05-03','07:30:00',1.09),('10318','2013-05-03','07:35:00',1.09),('10318','2013-05-03','07:40:00',1.13),('10318','2013-05-03','07:45:00',1.28),('10318','2013-05-03','07:50:00',1.44),('10318','2013-05-03','07:55:00',1.63),('10318','2013-05-03','08:00:00',2.38),('10318','2013-05-03','08:05:00',3.44),('10318','2013-05-03','08:10:00',3.97),('10318','2013-05-03','08:15:00',4.45),('10318','2013-05-03','08:20:00',4.31),('10318','2013-05-03','08:25:00',4.81),('10318','2013-05-03','08:30:00',4.9),('10318','2013-05-03','08:35:00',4.78),('10318','2013-05-03','08:40:00',4.85),('10318','2013-05-03','08:45:00',4.79),('10318','2013-05-03','08:50:00',5.24),('10318','2013-05-03','08:55:00',5.51),('10318','2013-05-03','09:00:00',5.68),('10318','2013-05-03','09:05:00',6.11),('10318','2013-05-03','09:10:00',6.27),('10318','2013-05-03','09:15:00',6.49),('10318','2013-05-03','09:20:00',6.69),('10318','2013-05-03','09:25:00',6.79),('10318','2013-05-03','09:30:00',6.97),('10318','2013-05-03','09:35:00',7.09),('10318','2013-05-03','09:40:00',7.21),('10318','2013-05-03','09:45:00',7.38),('10318','2013-05-03','09:50:00',7.53),('10318','2013-05-03','09:55:00',7.67),('10318','2013-05-03','10:00:00',7.76),('10318','2013-05-03','10:05:00',7.89),('10318','2013-05-03','10:10:00',8.02),('10318','2013-05-03','10:15:00',8.07),('10318','2013-05-03','10:20:00',8.16),('10318','2013-05-03','10:25:00',8.25),('10318','2013-05-03','10:30:00',8.32),('10318','2013-05-03','10:35:00',8.36),('10318','2013-05-03','10:40:00',8.48),('10318','2013-05-03','10:45:00',8.61),('10318','2013-05-03','10:50:00',8.68),('10318','2013-05-03','10:55:00',8.71),('10318','2013-05-03','11:00:00',8.75),('10318','2013-05-03','11:05:00',8.81),('10318','2013-05-03','11:10:00',8.91),('10318','2013-05-03','11:15:00',8.94),('10318','2013-05-03','11:20:00',8.95),('10318','2013-05-03','11:25:00',9.01),('10318','2013-05-03','11:30:00',9.1),('10318','2013-05-03','11:35:00',9.13),('10318','2013-05-03','11:40:00',9.16),('10318','2013-05-03','11:45:00',9.2),('10318','2013-05-03','11:50:00',9.23),('10318','2013-05-03','11:55:00',9.32),('10318','2013-05-03','12:00:00',9.39),('10318','2013-05-03','12:05:00',9.35),('10318','2013-05-03','12:10:00',9.28),('10318','2013-05-03','12:15:00',9.26),('10318','2013-05-03','12:20:00',9.17),('10318','2013-05-03','12:25:00',9.19),('10318','2013-05-03','12:30:00',9.01),('10318','2013-05-03','12:35:00',9.17),('10318','2013-05-03','12:40:00',9.25),('10318','2013-05-03','12:45:00',8.95),('10318','2013-05-03','12:50:00',9.2),('10318','2013-05-03','12:55:00',9.24),('10318','2013-05-03','13:00:00',9.2),('10318','2013-05-03','13:05:00',9.15),('10318','2013-05-03','13:10:00',9.13),('10318','2013-05-03','13:15:00',9.09),('10318','2013-05-03','13:20:00',9.02),('10318','2013-05-03','13:25:00',9.03),('10318','2013-05-03','13:30:00',9.03),('10318','2013-05-03','13:35:00',8.8),('10318','2013-05-03','13:40:00',8.73),('10318','2013-05-03','13:45:00',8.82),('10318','2013-05-03','13:50:00',8.74),('10318','2013-05-03','13:55:00',8.65),('10318','2013-05-03','14:00:00',8.46),('10318','2013-05-03','14:05:00',8.08),('10318','2013-05-03','14:10:00',8.29),('10318','2013-05-03','14:15:00',8.07),('10318','2013-05-03','14:20:00',8.26),('10318','2013-05-03','14:25:00',8.18),('10318','2013-05-03','14:30:00',8.11),('10318','2013-05-03','14:35:00',8.12),('10318','2013-05-03','14:40:00',8.02),('10318','2013-05-03','14:45:00',7.89),('10318','2013-05-03','14:50:00',7.84),('10318','2013-05-03','14:55:00',7.63),('10318','2013-05-03','15:00:00',7.51),('10318','2013-05-03','15:05:00',7.46),('10318','2013-05-03','15:10:00',7.4),('10318','2013-05-03','15:15:00',7.33),('10318','2013-05-03','15:20:00',7.25),('10318','2013-05-03','15:25:00',7.14),('10318','2013-05-03','15:30:00',7.02),('10318','2013-05-03','15:35:00',6.91),('10318','2013-05-03','15:40:00',6.8),('10318','2013-05-03','15:45:00',6.67),('10318','2013-05-03','15:50:00',6.48),('10318','2013-05-03','15:55:00',6.3),('10318','2013-05-03','16:00:00',6.17),('10318','2013-05-03','16:05:00',5.86),('10318','2013-05-03','16:10:00',5.94),('10318','2013-05-03','16:15:00',5.71),('10318','2013-05-03','16:20:00',5.45),('10318','2013-05-03','16:25:00',5.32),('10318','2013-05-03','16:30:00',5.27),('10318','2013-05-03','16:35:00',5.1),('10318','2013-05-03','16:40:00',4.87),('10318','2013-05-03','16:45:00',4.7),('10318','2013-05-03','16:50:00',4.5),('10318','2013-05-03','16:55:00',4.32),('10318','2013-05-03','17:00:00',4.15),('10318','2013-05-03','17:05:00',3.98),('10318','2013-05-03','17:10:00',3.8),('10318','2013-05-03','17:15:00',3.62),('10318','2013-05-03','17:20:00',3.47),('10318','2013-05-03','17:25:00',3.27),('10318','2013-05-03','17:30:00',3.07),('10318','2013-05-03','17:35:00',2.86),('10318','2013-05-03','17:40:00',2.66),('10318','2013-05-03','17:45:00',2.48),('10318','2013-05-03','17:50:00',2.28),('10318','2013-05-03','17:55:00',2.17),('10318','2013-05-03','18:00:00',2),('10318','2013-05-03','18:05:00',1.88),('10318','2013-05-03','18:10:00',1.75),('10318','2013-05-03','18:15:00',1.61),('10318','2013-05-03','18:20:00',1.49),('10318','2013-05-03','18:25:00',1.37),('10318','2013-05-03','18:30:00',1.23),('10318','2013-05-03','18:35:00',1.14),('10318','2013-05-02','08:30:00',1.1),('10318','2013-05-02','08:35:00',1.69),('10318','2013-05-02','08:40:00',2.06),('10318','2013-05-02','08:45:00',1.84),('10318','2013-05-02','08:50:00',2.11),('10318','2013-05-02','08:55:00',3.3),('10318','2013-05-02','09:00:00',3.55),('10318','2013-05-02','09:05:00',2.11),('10318','2013-05-02','09:10:00',1.82),('10318','2013-05-02','09:15:00',1.99),('10318','2013-05-02','09:20:00',1.88),('10318','2013-05-02','09:25:00',4.87),('10318','2013-05-02','09:30:00',4.3),('10318','2013-05-02','09:35:00',4.01),('10318','2013-05-02','09:40:00',5.39),('10318','2013-05-02','09:45:00',5.92),('10318','2013-05-02','09:50:00',3.49),('10318','2013-05-02','09:55:00',2.69),('10318','2013-05-02','10:00:00',2.25),('10318','2013-05-02','10:05:00',3.38),('10318','2013-05-02','10:10:00',2.87),('10318','2013-05-02','10:15:00',4.68),('10318','2013-05-02','10:20:00',3.85),('10318','2013-05-02','10:25:00',4.2),('10318','2013-05-02','10:30:00',6.27),('10318','2013-05-02','10:35:00',8.65),('10318','2013-05-02','10:40:00',7.42),('10318','2013-05-02','10:45:00',8.14),('10318','2013-05-02','10:50:00',7.39),('10318','2013-05-02','10:55:00',8.71),('10318','2013-05-02','11:00:00',6.85),('10318','2013-05-02','11:05:00',7.98),('10318','2013-05-02','11:10:00',8.17),('10318','2013-05-02','11:15:00',5.34),('10318','2013-05-02','11:20:00',8.63),('10318','2013-05-02','11:25:00',7.94),('10318','2013-05-02','11:30:00',8.24),('10318','2013-05-02','11:35:00',9.24),('10318','2013-05-02','11:40:00',9.16),('10318','2013-05-02','11:45:00',9.18),('10318','2013-05-02','11:50:00',9.16),('10318','2013-05-02','11:55:00',9.12),('10318','2013-05-02','12:00:00',9.16),('10318','2013-05-02','12:05:00',9.14),('10318','2013-05-02','12:10:00',9.02),('10318','2013-05-02','12:15:00',9),('10318','2013-05-02','12:20:00',9),('10318','2013-05-02','12:25:00',9.1),('10318','2013-05-02','12:30:00',9.1),('10318','2013-05-02','12:35:00',9.06),('10318','2013-05-02','12:40:00',9.15),('10318','2013-05-02','12:45:00',9.36),('10318','2013-05-02','12:50:00',9.47),('10318','2013-05-02','12:55:00',9.45),('10318','2013-05-02','13:00:00',9.41),('10318','2013-05-02','13:05:00',9.36),('10318','2013-05-02','13:10:00',9.36),('10318','2013-05-02','13:15:00',9.33),('10318','2013-05-02','13:20:00',9.38),('10318','2013-05-02','13:25:00',9.25),('10318','2013-05-02','13:30:00',9.26),('10318','2013-05-02','13:35:00',9.21),('10318','2013-05-02','13:40:00',9.13),('10318','2013-05-02','13:45:00',9.12),('10318','2013-05-02','13:50:00',9.1),('10318','2013-05-02','13:55:00',9.09),('10318','2013-05-02','14:00:00',8.91),('10318','2013-05-02','14:05:00',8.71),('10318','2013-05-02','14:10:00',8.57),('10318','2013-05-02','14:15:00',8.54),('10318','2013-05-02','14:20:00',8.44),('10318','2013-05-02','14:25:00',8.35),('10318','2013-05-02','14:30:00',8.26),('10318','2013-05-02','14:35:00',8.11),('10318','2013-05-02','14:40:00',8.12),('10318','2013-05-02','14:45:00',7.98),('10318','2013-05-02','14:50:00',7.8),('10318','2013-05-02','14:55:00',7.69),('10318','2013-05-02','15:00:00',7.63),('10318','2013-05-02','15:05:00',7.53),('10318','2013-05-02','15:10:00',7.46),('10318','2013-05-02','15:15:00',7.36),('10318','2013-05-02','15:20:00',7.28),('10318','2013-05-02','15:25:00',7.17),('10318','2013-05-02','15:30:00',7.08),('10318','2013-05-02','15:35:00',6.93),('10318','2013-05-02','15:40:00',6.87),('10318','2013-05-02','15:45:00',6.71),('10318','2013-05-02','15:50:00',6.56),('10318','2013-05-02','15:55:00',6.47),('10318','2013-05-02','16:00:00',6.29),('10318','2013-05-02','16:05:00',6.12),('10318','2013-05-02','16:10:00',5.97),('10318','2013-05-02','16:15:00',5.84),('10318','2013-05-02','16:20:00',5.53),('10318','2013-05-02','16:25:00',5.48),('10318','2013-05-02','16:30:00',5.29),('10318','2013-05-02','16:35:00',5.15),('10318','2013-05-02','16:40:00',4.96),('10318','2013-05-02','16:45:00',4.8),('10318','2013-05-02','16:50:00',4.59),('10318','2013-05-02','16:55:00',4.4),('10318','2013-05-02','17:00:00',4.24),('10318','2013-05-02','17:05:00',4.07),('10318','2013-05-02','17:10:00',3.9),('10318','2013-05-02','17:15:00',3.72),('10318','2013-05-02','17:20:00',3.54),('10318','2013-05-02','17:25:00',3.35),('10318','2013-05-02','17:30:00',3.17),('10318','2013-05-02','17:35:00',2.98),('10318','2013-05-02','17:40:00',2.81),('10318','2013-05-02','17:45:00',2.63),('10318','2013-05-02','17:50:00',2.46),('10318','2013-05-02','17:55:00',2.31),('10318','2013-05-02','18:00:00',2.13),('10318','2013-05-02','18:05:00',1.93),('10318','2013-05-02','18:10:00',1.8),('10318','2013-05-02','18:15:00',1.66),('10318','2013-05-02','18:20:00',1.53),('10318','2013-05-02','18:25:00',1.4),('10318','2013-05-02','18:30:00',1.28),('10318','2013-05-02','18:35:00',1.13),('10318','2013-05-02','18:40:00',1.02),('10318','2014-03-30','07:45:00',1.17),('10318','2014-03-30','07:50:00',1.32),('10318','2014-03-30','07:55:00',1.63),('10318','2014-03-30','08:00:00',1.8),('10318','2014-03-30','08:05:00',1.9),('10318','2014-03-30','08:10:00',2.24),('10318','2014-03-30','08:15:00',2.68),('10318','2014-03-30','08:20:00',2.98),('10318','2014-03-30','08:25:00',3.39),('10318','2014-03-30','08:30:00',3.68),('10318','2014-03-30','08:35:00',3.61),('10318','2014-03-30','08:40:00',3.63),('10318','2014-03-30','08:45:00',3.64),('10318','2014-03-30','08:50:00',3.64),('10318','2014-03-30','08:55:00',3.68),('10318','2014-03-30','09:00:00',3.67),('10318','2014-03-30','09:05:00',3.76),('10318','2014-03-30','09:10:00',3.67),('10318','2014-03-30','09:15:00',4.16),('10318','2014-03-30','09:20:00',4.41),('10318','2014-03-30','09:25:00',4.61),('10318','2014-03-30','09:30:00',5.25),('10318','2014-03-30','09:35:00',5.49),('10318','2014-03-30','09:40:00',5.87),('10318','2014-03-30','09:45:00',6.27),('10318','2014-03-30','09:50:00',6.37),('10318','2014-03-30','09:55:00',6.25),('10318','2014-03-30','10:00:00',6.61),('10318','2014-03-30','10:05:00',6.83),('10318','2014-03-30','10:10:00',6.66),('10318','2014-03-30','10:15:00',6.38),('10318','2014-03-30','10:20:00',7.33),('10318','2014-03-30','10:25:00',7.74),('10318','2014-03-30','10:30:00',7.73),('10318','2014-03-30','10:35:00',7.64),('10318','2014-03-30','10:40:00',7.66),('10318','2014-03-30','10:45:00',7.7),('10318','2014-03-30','10:50:00',7.92),('10318','2014-03-30','10:55:00',7.81),('10318','2014-03-30','11:00:00',7.69),('10318','2014-03-30','11:05:00',7.84),('10318','2014-03-30','11:10:00',7.87),('10318','2014-03-30','11:15:00',7.64),('10318','2014-03-30','11:20:00',7.61),('10318','2014-03-30','11:25:00',7.86),('10318','2014-03-30','11:30:00',8.02),('10318','2014-03-30','11:35:00',8.46),('10318','2014-03-30','11:40:00',8.76),('10318','2014-03-30','11:45:00',8.85),('10318','2014-03-30','11:50:00',9.04),('10318','2014-03-30','11:55:00',8.89),('10318','2014-03-30','12:00:00',9.19),('10318','2014-03-30','12:05:00',9.29),('10318','2014-03-30','12:10:00',9.39),('10318','2014-03-30','12:15:00',9.69),('10318','2014-03-30','12:20:00',9.08),('10318','2014-03-30','12:25:00',9.17),('10318','2014-03-30','12:30:00',9.11),('10318','2014-03-30','12:35:00',9.15),('10318','2014-03-30','12:40:00',9.04),('10318','2014-03-30','12:45:00',9.25),('10318','2014-03-30','12:50:00',8.96),('10318','2014-03-30','12:55:00',9.3),('10318','2014-03-30','13:00:00',9.47),('10318','2014-03-30','13:05:00',9.37),('10318','2014-03-30','13:10:00',9.31),('10318','2014-03-30','13:15:00',9.23),('10318','2014-03-30','13:20:00',9.33),('10318','2014-03-30','13:25:00',9.32),('10318','2014-03-30','13:30:00',9.34),('10318','2014-03-30','13:35:00',9.25),('10318','2014-03-30','13:40:00',9.2),('10318','2014-03-30','13:45:00',9.15),('10318','2014-03-30','13:50:00',8.98),('10318','2014-03-30','13:55:00',8.98),('10318','2014-03-30','14:00:00',8.91),('10318','2014-03-30','14:05:00',8.81),('10318','2014-03-30','14:10:00',8.26),('10318','2014-03-30','14:15:00',7.75),('10318','2014-03-30','14:20:00',7.44),('10318','2014-03-30','14:25:00',6.49),('10318','2014-03-30','14:30:00',5.62),('10318','2014-03-30','14:35:00',4.72),('10318','2014-03-30','14:40:00',5.18),('10318','2014-03-30','14:45:00',5.55),('10318','2014-03-30','14:50:00',3.96),('10318','2014-03-30','14:55:00',3.99),('10318','2014-03-30','15:00:00',5.87),('10318','2014-03-30','15:05:00',6.45),('10318','2014-03-30','15:10:00',6.73),('10318','2014-03-30','15:15:00',6.72),('10318','2014-03-30','15:20:00',6.61),('10318','2014-03-30','15:25:00',6.58),('10318','2014-03-30','15:30:00',6.5),('10318','2014-03-30','15:35:00',6.69),('10318','2014-03-30','15:40:00',6.65),('10318','2014-03-30','15:45:00',6.44),('10318','2014-03-30','15:50:00',6.28),('10318','2014-03-30','15:55:00',5.74),('10318','2014-03-30','16:00:00',5.17),('10318','2014-03-30','16:05:00',5.2),('10318','2014-03-30','16:10:00',5.34),('10318','2014-03-30','16:15:00',5.16),('10318','2014-03-30','16:20:00',4.57),('10318','2014-03-30','16:25:00',4.49),('10318','2014-03-30','16:30:00',4.7),('10318','2014-03-30','16:35:00',4.3),('10318','2014-03-30','16:40:00',4.35),('10318','2014-03-30','16:45:00',4.39),('10318','2014-03-30','16:50:00',4.37),('10318','2014-03-30','16:55:00',4.24),('10318','2014-03-30','17:00:00',4.1),('10318','2014-03-30','17:05:00',3.81),('10318','2014-03-30','17:10:00',3.86),('10318','2014-03-30','17:15:00',3.58),('10318','2014-03-30','17:20:00',3.47),('10318','2014-03-30','17:25:00',3.11),('10318','2014-03-30','17:30:00',2.82),('10318','2014-03-30','17:35:00',2.54),('10318','2014-03-30','17:40:00',2.46),('10318','2014-03-30','17:45:00',2.38),('10318','2014-03-30','17:50:00',2.21),('10318','2014-03-30','17:55:00',1.67),('10318','2014-03-30','18:00:00',1.56),('10318','2014-03-30','18:05:00',1.17),('10318','2014-03-30','18:10:00',1.2),('10318','2014-03-30','18:15:00',1.33),('10318','2013-05-01','07:10:00',1.04),('10318','2013-05-01','07:15:00',1.17),('10318','2013-05-01','07:20:00',1.26),('10318','2013-05-01','07:25:00',1.41),('10318','2013-05-01','07:30:00',1.62),('10318','2013-05-01','07:35:00',1.89),('10318','2013-05-01','07:40:00',2.15),('10318','2013-05-01','07:45:00',2.38),('10318','2013-05-01','07:50:00',2.59),('10318','2013-05-01','07:55:00',2.82),('10318','2013-05-01','08:00:00',3.01),('10318','2013-05-01','08:05:00',3.15),('10318','2013-05-01','08:10:00',3.35),('10318','2013-05-01','08:15:00',3.63),('10318','2013-05-01','08:20:00',3.85),('10318','2013-05-01','08:25:00',4.09),('10318','2013-05-01','08:30:00',4.32),('10318','2013-05-01','08:35:00',4.43),('10318','2013-05-01','08:40:00',4.71),('10318','2013-05-01','08:45:00',4.9),('10318','2013-05-01','08:50:00',5.13),('10318','2013-05-01','08:55:00',5.33),('10318','2013-05-01','09:00:00',5.48),('10318','2013-05-01','09:05:00',5.63),('10318','2013-05-01','09:10:00',5.76),('10318','2013-05-01','09:15:00',5.86),('10318','2013-05-01','09:20:00',6.01),('10318','2013-05-01','09:25:00',6.08),('10318','2013-05-01','09:30:00',6.13),('10318','2013-05-01','09:35:00',6.35),('10318','2013-05-01','09:40:00',6.48),('10318','2013-05-01','09:45:00',6.7),('10318','2013-05-01','09:50:00',6.76),('10318','2013-05-01','09:55:00',6.91),('10318','2013-05-01','10:00:00',6.93),('10318','2013-05-01','10:05:00',7.01),('10318','2013-05-01','10:10:00',7.29),('10318','2013-05-01','10:15:00',7.38),('10318','2013-05-01','10:20:00',7.45),('10318','2013-05-01','10:25:00',7.64),('10318','2013-05-01','10:30:00',7.67),('10318','2013-05-01','10:35:00',8.03),('10318','2013-05-01','10:40:00',8.16),('10318','2013-05-01','10:45:00',8.29),('10318','2013-05-01','10:50:00',8.27),('10318','2013-05-01','10:55:00',8.36),('10318','2013-05-01','11:00:00',8.47),('10318','2013-05-01','11:05:00',8.5),('10318','2013-05-01','11:10:00',8.29),('10318','2013-05-01','11:15:00',8.31),('10318','2013-05-01','11:20:00',8.52),('10318','2013-05-01','11:25:00',7.83),('10318','2013-05-01','11:30:00',8.32),('10318','2013-05-01','11:35:00',6.47),('10318','2013-05-01','11:40:00',5.38),('10318','2013-05-01','11:45:00',5.6),('10318','2013-05-01','11:50:00',8.99),('10318','2013-05-01','11:55:00',8.98),('10318','2013-05-01','12:00:00',8.76),('10318','2013-05-01','12:05:00',8.65),('10318','2013-05-01','12:10:00',8.61),('10318','2013-05-01','12:15:00',8.55),('10318','2013-05-01','12:20:00',8.62),('10318','2013-05-01','12:25:00',8.69),('10318','2013-05-01','12:30:00',8.82),('10318','2013-05-01','12:35:00',8.93),('10318','2013-05-01','12:40:00',9.16),('10318','2013-05-01','12:45:00',6.85),('10318','2013-05-01','12:50:00',6.49),('10318','2013-05-01','12:55:00',3.24),('10318','2013-05-01','13:00:00',3.33),('10318','2013-05-01','13:05:00',5.46),('10318','2013-05-01','13:10:00',7.25),('10318','2013-05-01','13:15:00',9.26),('10318','2013-05-01','13:20:00',10.04),('10318','2013-05-01','13:25:00',7.89),('10318','2013-05-01','13:30:00',5.16),('10318','2013-05-01','13:35:00',7.48),('10318','2013-05-01','13:40:00',9.22),('10318','2013-05-01','13:45:00',9.24),('10318','2013-05-01','13:50:00',8.82),('10318','2013-05-01','13:55:00',8.45),('10318','2013-05-01','14:00:00',8.4),('10318','2013-05-01','14:05:00',8.34),('10318','2013-05-01','14:10:00',7.94),('10318','2013-05-01','14:15:00',7.69),('10318','2013-05-01','14:20:00',8.63),('10318','2013-05-01','14:25:00',8.41),('10318','2013-05-01','14:30:00',8.6),('10318','2013-05-01','14:35:00',7.94),('10318','2013-05-01','14:40:00',8.16),('10318','2013-05-01','14:45:00',7.24),('10318','2013-05-01','14:50:00',7.55),('10318','2013-05-01','14:55:00',5.56),('10318','2013-05-01','15:00:00',5.95),('10318','2013-05-01','15:05:00',7.11),('10318','2013-05-01','15:10:00',7.51),('10318','2013-05-01','15:15:00',7.08),('10318','2013-05-01','15:20:00',7.16),('10318','2013-05-01','15:25:00',5.83),('10318','2013-05-01','15:30:00',5.08),('10318','2013-05-01','15:35:00',4.59),('10318','2013-05-01','15:40:00',4.73),('10318','2013-05-01','15:45:00',4.59),('10318','2013-05-01','15:50:00',3.71),('10318','2013-05-01','15:55:00',3.67),('10318','2013-05-01','16:00:00',4.18),('10318','2013-05-01','16:05:00',3.86),('10318','2013-05-01','16:10:00',3.55),('10318','2013-05-01','16:15:00',3.37),('10318','2013-05-01','16:20:00',3.08),('10318','2013-05-01','16:25:00',2.48),('10318','2013-05-01','16:30:00',2.3),('10318','2013-05-01','16:35:00',2.36),('10318','2013-05-01','16:40:00',2.53),('10318','2013-05-01','16:45:00',2.34),('10318','2013-05-01','16:50:00',2.02),('10318','2013-05-01','16:55:00',1.94),('10318','2013-05-01','17:00:00',1.96),('10318','2013-05-01','17:05:00',1.99),('10318','2013-05-01','17:10:00',2.01),('10318','2013-05-01','17:15:00',1.95),('10318','2013-05-01','17:20:00',1.74),('10318','2013-05-01','17:25:00',1.49),('10318','2013-05-01','17:30:00',1.28),('10318','2013-05-01','17:35:00',1.15),('10318','2013-05-01','17:40:00',1.07),('10318','2013-04-30','08:20:00',1.19),('10318','2013-04-30','08:25:00',1.38),('10318','2013-04-30','08:30:00',1.74),('10318','2013-04-30','08:35:00',2.28),('10318','2013-04-30','08:40:00',1.98),('10318','2013-04-30','08:45:00',2.16),('10318','2013-04-30','08:50:00',2.86),('10318','2013-04-30','08:55:00',5.63),('10318','2013-04-30','09:00:00',5.08),('10318','2013-04-30','09:05:00',3.7),('10318','2013-04-30','09:10:00',4.74),('10318','2013-04-30','09:15:00',6.47),('10318','2013-04-30','09:20:00',6.35),('10318','2013-04-30','09:25:00',6.88),('10318','2013-04-30','09:30:00',6.79),('10318','2013-04-30','09:35:00',5.99),('10318','2013-04-30','09:40:00',4.31),('10318','2013-04-30','09:45:00',5.26),('10318','2013-04-30','09:50:00',6.51),('10318','2013-04-30','09:55:00',7.4),('10318','2013-04-30','10:00:00',8.05),('10318','2013-04-30','10:05:00',6.78),('10318','2013-04-30','10:10:00',5.89),('10318','2013-04-30','10:15:00',5.09),('10318','2013-04-30','10:20:00',4.24),('10318','2013-04-30','10:25:00',6.77),('10318','2013-04-30','10:30:00',5.58),('10318','2013-04-30','10:35:00',4.27),('10318','2013-04-30','10:40:00',4.19),('10318','2013-04-30','10:45:00',3.1),('10318','2013-04-30','10:50:00',3.17),('10318','2013-04-30','10:55:00',3.64),('10318','2013-04-30','11:00:00',4.07),('10318','2013-04-30','11:05:00',4.48),('10318','2013-04-30','11:10:00',4.48),('10318','2013-04-30','11:15:00',4.89),('10318','2013-04-30','11:20:00',5.44),('10318','2013-04-30','11:25:00',5.02),('10318','2013-04-30','11:30:00',5.17),('10318','2013-04-30','11:35:00',5.44),('10318','2013-04-30','11:40:00',4.47),('10318','2013-04-30','11:45:00',3.47),('10318','2013-04-30','11:50:00',3.56),('10318','2013-04-30','11:55:00',3.73),('10318','2013-04-30','12:00:00',3.98),('10318','2013-04-30','12:05:00',3.98),('10318','2013-04-30','12:10:00',3.75),('10318','2013-04-30','12:15:00',3.52),('10318','2013-04-30','12:20:00',3.4),('10318','2013-04-30','12:25:00',3.2),('10318','2013-04-30','12:30:00',3.32),('10318','2013-04-30','12:35:00',6.37),('10318','2013-04-30','12:40:00',10.2),('10318','2013-04-30','12:45:00',9.72),('10318','2013-04-30','12:50:00',9.61),('10318','2013-04-30','12:55:00',8.38),('10318','2013-04-30','13:00:00',9.23),('10318','2013-04-30','13:05:00',8.99),('10318','2013-04-30','13:10:00',9.11),('10318','2013-04-30','13:15:00',8.98),('10318','2013-04-30','13:20:00',8.89),('10318','2013-04-30','13:25:00',8.82),('10318','2013-04-30','13:30:00',8.6),('10318','2013-04-30','13:35:00',8.66),('10318','2013-04-30','13:40:00',8.57),('10318','2013-04-30','13:45:00',8.48),('10318','2013-04-30','13:50:00',8.35),('10318','2013-04-30','13:55:00',8.29),('10318','2013-04-30','14:00:00',8.19),('10318','2013-04-30','14:05:00',8.14),('10318','2013-04-30','14:10:00',8.04),('10318','2013-04-30','14:15:00',7.96),('10318','2013-04-30','14:20:00',7.86),('10318','2013-04-30','14:25:00',7.76),('10318','2013-04-30','14:30:00',7.66),('10318','2013-04-30','14:35:00',7.6),('10318','2013-04-30','14:40:00',7.56),('10318','2013-04-30','14:45:00',7.5),('10318','2013-04-30','14:50:00',7.35),('10318','2013-04-30','14:55:00',7.23),('10318','2013-04-30','15:00:00',7.11),('10318','2013-04-30','15:05:00',6.99),('10318','2013-04-30','15:10:00',6.87),('10318','2013-04-30','15:15:00',6.65),('10318','2013-04-30','15:20:00',6.64),('10318','2013-04-30','15:25:00',6.53),('10318','2013-04-30','15:30:00',6.43),('10318','2013-04-30','15:35:00',6.31),('10318','2013-04-30','15:40:00',6.19),('10318','2013-04-30','15:45:00',6.01),('10318','2013-04-30','15:50:00',5.84),('10318','2013-04-30','15:55:00',5.73),('10318','2013-04-30','16:00:00',5.64),('10318','2013-04-30','16:05:00',5.5),('10318','2013-04-30','16:10:00',5.35),('10318','2013-04-30','16:15:00',5.18),('10318','2013-04-30','16:20:00',5.04),('10318','2013-04-30','16:25:00',4.93),('10318','2013-04-30','16:30:00',4.41),('10318','2013-04-30','16:35:00',4.51),('10318','2013-04-30','16:40:00',4.39),('10318','2013-04-30','16:45:00',3.47),('10318','2013-04-30','16:50:00',2.62),('10318','2013-04-30','16:55:00',3.32),('10318','2013-04-30','17:00:00',3.45),('10318','2013-04-30','17:05:00',2.89),('10318','2013-04-30','17:10:00',2.35),('10318','2013-04-30','17:15:00',2),('10318','2013-04-30','17:20:00',2.89),('10318','2013-04-30','17:25:00',2.93),('10318','2013-04-30','17:30:00',2.73),('10318','2013-04-30','17:35:00',2.62),('10318','2013-04-30','17:40:00',2.49),('10318','2013-04-30','17:45:00',2.34),('10318','2013-04-30','17:50:00',2.19),('10318','2013-04-30','17:55:00',2.05),('10318','2013-04-30','18:00:00',1.91),('10318','2013-04-30','18:05:00',1.78),('10318','2013-04-30','18:10:00',1.65),('10318','2013-04-30','18:15:00',1.51),('10318','2013-04-30','18:20:00',1.43),('10318','2013-04-30','18:25:00',1.32),('10318','2013-04-30','18:30:00',1.21),('10318','2013-04-30','18:35:00',1.1),('10318','2013-04-29','07:10:00',1.09),('10318','2013-04-29','07:15:00',1.44),('10318','2013-04-29','07:20:00',1.73),('10318','2013-04-29','07:25:00',2.01),('10318','2013-04-29','07:30:00',2.04),('10318','2013-04-29','07:35:00',2.11),('10318','2013-04-29','07:40:00',1.94),('10318','2013-04-29','07:45:00',2.16),('10318','2013-04-29','07:50:00',2.48),('10318','2013-04-29','07:55:00',2.92),('10318','2013-04-29','08:00:00',3.31),('10318','2013-04-29','08:05:00',3.39),('10318','2013-04-29','08:10:00',3.13),('10318','2013-04-29','08:15:00',3.38),('10318','2013-04-29','08:20:00',3.74),('10318','2013-04-29','08:25:00',4.39),('10318','2013-04-29','08:30:00',4.94),('10318','2013-04-29','08:35:00',5.39),('10318','2013-04-29','08:40:00',5.21),('10318','2013-04-29','08:45:00',5.24),('10318','2013-04-29','08:50:00',5.05),('10318','2013-04-29','08:55:00',5.49),('10318','2013-04-29','09:00:00',4.68),('10318','2013-04-29','09:05:00',5.92),('10318','2013-04-29','09:10:00',6.4),('10318','2013-04-29','09:15:00',6.3),('10318','2013-04-29','09:20:00',6),('10318','2013-04-29','09:25:00',6.2),('10318','2013-04-29','09:30:00',6.2),('10318','2013-04-29','09:35:00',6.39),('10318','2013-04-29','09:40:00',6.4),('10318','2013-04-29','09:45:00',6.48),('10318','2013-04-29','09:50:00',6.69),('10318','2013-04-29','09:55:00',6.36),('10318','2013-04-29','10:00:00',6.84),('10318','2013-04-29','10:05:00',6.82),('10318','2013-04-29','10:10:00',6.51),('10318','2013-04-29','10:15:00',5.43),('10318','2013-04-29','10:20:00',6.68),('10318','2013-04-29','10:25:00',7.24),('10318','2013-04-29','10:30:00',7.76),('10318','2013-04-29','10:35:00',7.72),('10318','2013-04-29','10:40:00',7.67),('10318','2013-04-29','10:45:00',7.43),('10318','2013-04-29','10:50:00',7.44),('10318','2013-04-29','10:55:00',7.13),('10318','2013-04-29','11:00:00',7.61),('10318','2013-04-29','11:05:00',7.02),('10318','2013-04-29','11:10:00',6.61),('10318','2013-04-29','11:15:00',7.61),('10318','2013-04-29','11:20:00',8.48),('10318','2013-04-29','11:25:00',7.92),('10318','2013-04-29','11:30:00',8.26),('10318','2013-04-29','11:35:00',8.65),('10318','2013-04-29','11:40:00',8.98),('10318','2013-04-29','11:45:00',8.33),('10318','2013-04-29','11:50:00',8.88),('10318','2013-04-29','11:55:00',8.86),('10318','2013-04-29','12:00:00',9.17),('10318','2013-04-29','12:05:00',8.86),('10318','2013-04-29','12:10:00',8.76),('10318','2013-04-29','12:15:00',8.74),('10318','2013-04-29','12:20:00',8.78),('10318','2013-04-29','12:25:00',8.87),('10318','2013-04-29','12:30:00',8.97),('10318','2013-04-29','12:35:00',8.88),('10318','2013-04-29','12:40:00',8.85),('10318','2013-04-29','12:45:00',8.93),('10318','2013-04-29','12:50:00',8.74),('10318','2013-04-29','12:55:00',8.77),('10318','2013-04-29','13:00:00',8.81),('10318','2013-04-29','13:05:00',8.61),('10318','2013-04-29','13:10:00',8.46),('10318','2013-04-29','13:15:00',8.06),('10318','2013-04-29','13:20:00',8.81),('10318','2013-04-29','13:25:00',9.12),('10318','2013-04-29','13:30:00',8.77),('10318','2013-04-29','13:35:00',8.78),('10318','2013-04-29','13:40:00',8.49),('10318','2013-04-29','13:45:00',8.39),('10318','2013-04-29','13:50:00',8.09),('10318','2013-04-29','13:55:00',8.64),('10318','2013-04-29','14:00:00',8.08),('10318','2013-04-29','14:05:00',7.97),('10318','2013-04-29','14:10:00',8.5),('10318','2013-04-29','14:15:00',8.72),('10318','2013-04-29','14:20:00',8.51),('10318','2013-04-29','14:25:00',7.83),('10318','2013-04-29','14:30:00',7.78),('10318','2013-04-29','14:35:00',7.84),('10318','2013-04-29','14:40:00',7.28),('10318','2013-04-29','14:45:00',7.69),('10318','2013-04-29','14:50:00',7.93),('10318','2013-04-29','14:55:00',7.51),('10318','2013-04-29','15:00:00',7.13),('10318','2013-04-29','15:05:00',6.54),('10318','2013-04-29','15:10:00',6.71),('10318','2013-04-29','15:15:00',6.87),('10318','2013-04-29','15:20:00',7.03),('10318','2013-04-29','15:25:00',7.06),('10318','2013-04-29','15:30:00',6.49),('10318','2013-04-29','15:35:00',5.96),('10318','2013-04-29','15:40:00',5.57),('10318','2013-04-29','15:45:00',5.44),('10318','2013-04-29','15:50:00',5.6),('10318','2013-04-29','15:55:00',5.68),('10318','2013-04-29','16:00:00',5.84),('10318','2013-04-29','16:05:00',6.19),('10318','2013-04-29','16:10:00',5.96),('10318','2013-04-29','16:15:00',6.79),('10318','2013-04-29','16:20:00',5.67),('10318','2013-04-29','16:25:00',5.08),('10318','2013-04-29','16:30:00',5.03),('10318','2013-04-29','16:35:00',5.27),('10318','2013-04-29','16:40:00',5.15),('10318','2013-04-29','16:45:00',5.26),('10318','2013-04-29','16:50:00',5.32),('10318','2013-04-29','16:55:00',5.25),('10318','2013-04-29','17:00:00',4.87),('10318','2013-04-29','17:05:00',4.37),('10318','2013-04-29','17:10:00',4.18),('10318','2013-04-29','17:15:00',3.48),('10318','2013-04-29','17:20:00',3.09),('10318','2013-04-29','17:25:00',2.25),('10318','2013-04-29','17:30:00',2.74),('10318','2013-04-29','17:35:00',2.76),('10318','2013-04-29','17:40:00',2.45),('10318','2013-04-29','17:45:00',1.98),('10318','2013-04-29','17:50:00',2.55),('10318','2013-04-29','17:55:00',2.75),('10318','2013-04-29','18:00:00',2.56),('10318','2013-04-29','18:05:00',2.79),('10318','2013-04-29','18:10:00',2.41),('10318','2013-04-29','18:15:00',2.18),('10318','2013-04-29','18:20:00',1.84),('10318','2013-04-29','18:25:00',1.78),('10318','2013-04-29','18:30:00',1.5),('10318','2013-04-29','18:35:00',1.19),('10318','2013-04-28','07:20:00',1.48),('10318','2013-04-28','07:25:00',1.73),('10318','2013-04-28','07:30:00',2.08),('10318','2013-04-28','07:35:00',2.34),('10318','2013-04-28','07:40:00',2.68),('10318','2013-04-28','07:45:00',2.99),('10318','2013-04-28','07:50:00',3.14),('10318','2013-04-28','07:55:00',3.35),('10318','2013-04-28','08:00:00',3.53),('10318','2013-04-28','08:05:00',3.81),('10318','2013-04-28','08:10:00',4.04),('10318','2013-04-28','08:15:00',4.25),('10318','2013-04-28','08:20:00',4.48),('10318','2013-04-28','08:25:00',4.73),('10318','2013-04-28','08:30:00',4.88),('10318','2013-04-28','08:35:00',5.09),('10318','2013-04-28','08:40:00',5.28),('10318','2013-04-28','08:45:00',5.47),('10318','2013-04-28','08:50:00',5.62),('10318','2013-04-28','08:55:00',5.78),('10318','2013-04-28','09:00:00',5.97),('10318','2013-04-28','09:05:00',6.14),('10318','2013-04-28','09:10:00',6.32),('10318','2013-04-28','09:15:00',6.48),('10318','2013-04-28','09:20:00',6.66),('10318','2013-04-28','09:25:00',6.82),('10318','2013-04-28','09:30:00',6.94),('10318','2013-04-28','09:35:00',7.06),('10318','2013-04-28','09:40:00',7.25),('10318','2013-04-28','09:45:00',7.38),('10318','2013-04-28','09:50:00',7.51),('10318','2013-04-28','09:55:00',7.66),('10318','2013-04-28','10:00:00',7.73),('10318','2013-04-28','10:05:00',7.79),('10318','2013-04-28','10:10:00',7.97),('10318','2013-04-28','10:15:00',8),('10318','2013-04-28','10:20:00',8.2),('10318','2013-04-28','10:25:00',8.22),('10318','2013-04-28','10:30:00',7.68),('10318','2013-04-28','10:35:00',8.3),('10318','2013-04-28','10:40:00',7.69),('10318','2013-04-28','10:45:00',8.64),('10318','2013-04-28','10:50:00',8.59),('10318','2013-04-28','10:55:00',8.74),('10318','2013-04-28','11:00:00',8.75),('10318','2013-04-28','11:05:00',8.83),('10318','2013-04-28','11:10:00',8.81),('10318','2013-04-28','11:15:00',8.98),('10318','2013-04-28','11:20:00',8.94),('10318','2013-04-28','11:25:00',9.15),('10318','2013-04-28','11:30:00',9.18),('10318','2013-04-28','11:35:00',8.87),('10318','2013-04-28','11:40:00',8.94),('10318','2013-04-28','11:45:00',8.4),('10318','2013-04-28','11:50:00',8.68),('10318','2013-04-28','11:55:00',8.72),('10318','2013-04-28','12:00:00',7.86),('10318','2013-04-28','12:05:00',7.74),('10318','2013-04-28','12:10:00',8.57),('10318','2013-04-28','12:15:00',8.03),('10318','2013-04-28','12:20:00',8.26),('10318','2013-04-28','12:25:00',7.97),('10318','2013-04-28','12:30:00',8.18),('10318','2013-04-28','12:35:00',7.58),('10318','2013-04-28','12:40:00',7.03),('10318','2013-04-28','12:45:00',8.51),('10318','2013-04-28','12:50:00',9.08),('10318','2013-04-28','12:55:00',8.58),('10318','2013-04-28','13:00:00',8.99),('10318','2013-04-28','13:05:00',9.2),('10318','2013-04-28','13:10:00',8.87),('10318','2013-04-28','13:15:00',8.12),('10318','2013-04-28','13:20:00',7.57),('10318','2013-04-28','13:25:00',7.85),('10318','2013-04-28','13:30:00',8.83),('10318','2013-04-28','13:35:00',9.39),('10318','2013-04-28','13:40:00',9.33),('10318','2013-04-28','13:45:00',9.1),('10318','2013-04-28','13:50:00',9.11),('10318','2013-04-28','13:55:00',9.27),('10318','2013-04-28','14:00:00',8.99),('10318','2013-04-28','14:05:00',7.33),('10318','2013-04-28','14:10:00',7.03),('10318','2013-04-28','14:15:00',8.65),('10318','2013-04-28','14:20:00',8.4),('10318','2013-04-28','14:25:00',8.44),('10318','2013-04-28','14:30:00',8.36),('10318','2013-04-28','14:35:00',8.23),('10318','2013-04-28','14:40:00',7.99),('10318','2013-04-28','14:45:00',7.8),('10318','2013-04-28','14:50:00',7.73),('10318','2013-04-28','14:55:00',7.75),('10318','2013-04-28','15:00:00',7.67),('10318','2013-04-28','15:05:00',7.61),('10318','2013-04-28','15:10:00',7.49),('10318','2013-04-28','15:15:00',7.28),('10318','2013-04-28','15:20:00',7.13),('10318','2013-04-28','15:25:00',7.07),('10318','2013-04-28','15:30:00',6.95),('10318','2013-04-28','15:35:00',6.79),('10318','2013-04-28','15:40:00',6.64),('10318','2013-04-28','15:45:00',6.49),('10318','2013-04-28','15:50:00',6.34),('10318','2013-04-28','15:55:00',6.21),('10318','2013-04-28','16:00:00',6.13),('10318','2013-04-28','16:05:00',5.79),('10318','2013-04-28','16:10:00',5.8),('10318','2013-04-28','16:15:00',5.66),('10318','2013-04-28','16:20:00',5.51),('10318','2013-04-28','16:25:00',5.36),('10318','2013-04-28','16:30:00',5.19),('10318','2013-04-28','16:35:00',5.01),('10318','2013-04-28','16:40:00',4.83),('10318','2013-04-28','16:45:00',4.67),('10318','2013-04-28','16:50:00',4.5),('10318','2013-04-28','16:55:00',4.32),('10318','2013-04-28','17:00:00',4.15),('10318','2013-04-28','17:05:00',3.77),('10318','2013-04-28','17:10:00',3.68),('10318','2013-04-28','17:15:00',3.64),('10318','2013-04-28','17:20:00',3.45),('10318','2013-04-28','17:25:00',3.33),('10318','2013-04-28','17:30:00',2.78),('10318','2013-04-28','17:35:00',2.75),('10318','2013-04-28','17:40:00',2.62),('10318','2013-04-28','17:45:00',2.63),('10318','2013-04-28','17:50:00',2.35),('10318','2013-04-28','17:55:00',2.11),('10318','2013-04-28','18:00:00',2.08),('10318','2013-04-28','18:05:00',1.92),('10318','2013-04-28','18:10:00',1.17),('10318','2013-04-28','18:15:00',1.43),('10318','2013-04-28','18:20:00',1.74),('10318','2013-04-28','18:25:00',1.6),('10318','2013-04-28','18:30:00',1.28),('10318','2013-04-28','18:35:00',1.18),('10318','2013-04-28','18:40:00',1.08),('10318','2013-04-27','07:35:00',1.07),('10318','2013-04-27','07:40:00',1.07),('10318','2013-04-27','07:45:00',1),('10318','2013-04-27','11:40:00',1.05),('10318','2013-04-27','11:45:00',1.31),('10318','2013-04-27','11:50:00',1.54),('10318','2013-04-27','11:55:00',1.61),('10318','2013-04-27','12:00:00',1.69),('10318','2013-04-27','12:05:00',1.55),('10318','2013-04-27','12:10:00',1.31),('10318','2013-04-27','12:15:00',1.23),('10318','2013-04-27','12:20:00',1.22),('10318','2013-04-27','12:25:00',1.32),('10318','2013-04-27','12:30:00',1.41),('10318','2013-04-27','12:35:00',1.53),('10318','2013-04-27','12:40:00',1.87),('10318','2013-04-27','12:45:00',2.01),('10318','2013-04-27','12:50:00',2.39),('10318','2013-04-27','12:55:00',3.01),('10318','2013-04-27','13:00:00',3.01),('10318','2013-04-27','13:05:00',2.27),('10318','2013-04-27','13:10:00',2.7),('10318','2013-04-27','13:15:00',3.78),('10318','2013-04-27','13:20:00',3.94),('10318','2013-04-27','13:25:00',2.58),('10318','2013-04-27','13:30:00',2.67),('10318','2013-04-27','13:35:00',3),('10318','2013-04-27','13:40:00',2.94),('10318','2013-04-27','13:45:00',2.39),('10318','2013-04-27','13:50:00',2.32),('10318','2013-04-27','13:55:00',1.42),('10318','2013-04-27','14:00:00',1.07),('10318','2013-04-27','14:05:00',1.01),('10318','2013-04-27','14:20:00',1.06),('10318','2013-04-27','14:25:00',2.33),('10318','2013-04-27','14:30:00',4.76),('10318','2013-04-27','14:35:00',4.84),('10318','2013-04-27','14:40:00',2.64),('10318','2013-04-27','14:45:00',1.97),('10318','2013-04-27','14:50:00',1.39),('10318','2013-04-27','14:55:00',1.54),('10318','2013-04-27','15:00:00',1.61),('10318','2013-04-27','15:05:00',2.41),('10318','2013-04-27','15:10:00',2.81),('10318','2013-04-27','15:15:00',1.86),('10318','2013-04-27','15:20:00',1.13),('10318','2013-04-27','15:35:00',1.16),('10318','2013-04-27','15:40:00',1.29),('10318','2013-04-27','15:45:00',1.28),('10318','2013-04-27','15:50:00',1.45),('10318','2013-04-27','16:35:00',1.43),('10318','2013-04-27','16:40:00',3.69),('10318','2013-04-27','16:45:00',2.81),('10318','2013-04-27','16:50:00',3.94),('10318','2013-04-27','16:55:00',4.14),('10318','2013-04-27','17:00:00',3.55),('10318','2013-04-27','17:05:00',2.21),('10318','2013-04-27','17:10:00',1.58),('10318','2013-04-27','17:15:00',1.3),('10318','2013-04-27','17:20:00',1.91),('10318','2013-04-27','17:25:00',1.02),('10318','2013-04-27','17:30:00',1.08),('10318','2013-04-27','17:35:00',1.56),('10318','2013-04-27','17:40:00',2.15),('10318','2013-04-27','17:45:00',1.79),('10318','2013-04-27','17:50:00',1.05),('10318','2013-04-26','07:00:00',1.13),('10318','2013-04-26','07:05:00',1.25),('10318','2013-04-26','07:10:00',1.36),('10318','2013-04-26','07:15:00',1.42),('10318','2013-04-26','07:20:00',1.49),('10318','2013-04-26','07:25:00',1.51),('10318','2013-04-26','07:30:00',1.56),('10318','2013-04-26','07:35:00',1.38),('10318','2013-04-26','07:40:00',1.33),('10318','2013-04-26','07:45:00',1.47),('10318','2013-04-26','07:50:00',1.63),('10318','2013-04-26','07:55:00',1.73),('10318','2013-04-26','08:00:00',2.2),('10318','2013-04-26','08:05:00',2.91),('10318','2013-04-26','08:10:00',3.27),('10318','2013-04-26','08:15:00',3.51),('10318','2013-04-26','08:20:00',3.43),('10318','2013-04-26','08:25:00',3.66),('10318','2013-04-26','08:30:00',4.14),('10318','2013-04-26','08:35:00',4.27),('10318','2013-04-26','08:40:00',4.29),('10318','2013-04-26','08:45:00',4.63),('10318','2013-04-26','08:50:00',4.97),('10318','2013-04-26','08:55:00',4.68),('10318','2013-04-26','09:00:00',3.88),('10318','2013-04-26','09:05:00',3.51),('10318','2013-04-26','09:10:00',4.13),('10318','2013-04-26','09:15:00',3.7),('10318','2013-04-26','09:20:00',3.52),('10318','2013-04-26','09:25:00',4.56),('10318','2013-04-26','09:30:00',5.15),('10318','2013-04-26','09:35:00',4.32),('10318','2013-04-26','09:40:00',6.06),('10318','2013-04-26','09:45:00',5.4),('10318','2013-04-26','09:50:00',6.37),('10318','2013-04-26','09:55:00',4.97),('10318','2013-04-26','10:00:00',4.03),('10318','2013-04-26','10:05:00',6.31),('10318','2013-04-26','10:10:00',7.6),('10318','2013-04-26','10:15:00',7.81),('10318','2013-04-26','10:20:00',7.7),('10318','2013-04-26','10:25:00',7.87),('10318','2013-04-26','10:30:00',6.45),('10318','2013-04-26','10:35:00',8.33),('10318','2013-04-26','10:40:00',7.98),('10318','2013-04-26','10:45:00',5.34),('10318','2013-04-26','10:50:00',5.73),('10318','2013-04-26','10:55:00',8.4),('10318','2013-04-26','11:00:00',8.52),('10318','2013-04-26','11:05:00',8.34),('10318','2013-04-26','11:10:00',8.53),('10318','2013-04-26','11:15:00',7.49),('10318','2013-04-26','11:20:00',6.09),('10318','2013-04-26','11:25:00',6.33),('10318','2013-04-26','11:30:00',6.29),('10318','2013-04-26','11:35:00',9.19),('10318','2013-04-26','11:40:00',8.72),('10318','2013-04-26','11:45:00',8.97),('10318','2013-04-26','11:50:00',7.95),('10318','2013-04-26','11:55:00',6.03),('10318','2013-04-26','12:00:00',5.93),('10318','2013-04-26','12:05:00',6.14),('10318','2013-04-26','12:10:00',6.39),('10318','2013-04-26','12:15:00',5.92),('10318','2013-04-26','12:20:00',5.9),('10318','2013-04-26','12:25:00',3.94),('10318','2013-04-26','12:30:00',3.8),('10318','2013-04-26','12:35:00',4.58),('10318','2013-04-26','12:40:00',5.33),('10318','2013-04-26','12:45:00',5.79),('10318','2013-04-26','12:50:00',4.33),('10318','2013-04-26','12:55:00',3.43),('10318','2013-04-26','13:00:00',2.85),('10318','2013-04-26','13:05:00',2.79),('10318','2013-04-26','13:10:00',3.69),('10318','2013-04-26','13:15:00',5.28),('10318','2013-04-26','13:20:00',4.77),('10318','2013-04-26','13:25:00',7.19),('10318','2013-04-26','13:30:00',5.33),('10318','2013-04-26','13:35:00',8.2),('10318','2013-04-26','13:40:00',6.08),('10318','2013-04-26','13:45:00',5.79),('10318','2013-04-26','13:50:00',8.21),('10318','2013-04-26','13:55:00',6.49),('10318','2013-04-26','14:00:00',5.31),('10318','2013-04-26','14:05:00',8.15),('10318','2013-04-26','14:10:00',6.48),('10318','2013-04-26','14:15:00',5.37),('10318','2013-04-26','14:20:00',8.91),('10318','2013-04-26','14:25:00',8.28),('10318','2013-04-26','14:30:00',7.16),('10318','2013-04-26','14:35:00',4.77),('10318','2013-04-26','14:40:00',3.92),('10318','2013-04-26','14:45:00',3.01),('10318','2013-04-26','14:50:00',4.77),('10318','2013-04-26','14:55:00',8.75),('10318','2013-04-26','15:00:00',7.7),('10318','2013-04-26','15:05:00',5.82),('10318','2013-04-26','15:10:00',6.02),('10318','2013-04-26','15:15:00',6.38),('10318','2013-04-26','15:20:00',3.26),('10318','2013-04-26','15:25:00',3.64),('10318','2013-04-26','15:30:00',6.5),('10318','2013-04-26','15:35:00',4.31),('10318','2013-04-26','15:40:00',4.35),('10318','2013-04-26','15:45:00',5.3),('10318','2013-04-26','15:50:00',3.82),('10318','2013-04-26','15:55:00',2.05),('10318','2013-04-26','16:00:00',1.14),('10318','2013-04-26','16:35:00',1.24),('10318','2013-04-26','16:40:00',1.08),('10318','2013-04-25','07:30:00',1.13),('10318','2013-04-25','07:35:00',1.33),('10318','2013-04-25','07:40:00',1.47),('10318','2013-04-25','07:45:00',1.64),('10318','2013-04-25','07:50:00',1.73),('10318','2013-04-25','07:55:00',1.73),('10318','2013-04-25','08:00:00',1.99),('10318','2013-04-25','08:05:00',2.63),('10318','2013-04-25','08:10:00',2.68),('10318','2013-04-25','08:15:00',3.09),('10318','2013-04-25','08:20:00',2.59),('10318','2013-04-25','08:25:00',2.36),('10318','2013-04-25','08:30:00',2.44),('10318','2013-04-25','08:35:00',2.57),('10318','2013-04-25','08:40:00',2.78),('10318','2013-04-25','08:45:00',3.94),('10318','2013-04-25','08:50:00',5.54),('10318','2013-04-25','08:55:00',5.3),('10318','2013-04-25','09:00:00',3.7),('10318','2013-04-25','09:05:00',3.11),('10318','2013-04-25','09:10:00',3.16),('10318','2013-04-25','09:15:00',2.96),('10318','2013-04-25','09:20:00',3.33),('10318','2013-04-25','09:25:00',3.56),('10318','2013-04-25','09:30:00',3.72),('10318','2013-04-25','09:35:00',4.94),('10318','2013-04-25','09:40:00',5.93),('10318','2013-04-25','09:45:00',7.47),('10318','2013-04-25','09:50:00',7.66),('10318','2013-04-25','09:55:00',7.62),('10318','2013-04-25','10:00:00',7.4),('10318','2013-04-25','10:05:00',6.83),('10318','2013-04-25','10:10:00',6.32),('10318','2013-04-25','10:15:00',7.73),('10318','2013-04-25','10:20:00',8.05),('10318','2013-04-25','10:25:00',8.29),('10318','2013-04-25','10:30:00',8.26),('10318','2013-04-25','10:35:00',8.36),('10318','2013-04-25','10:40:00',8.31),('10318','2013-04-25','10:45:00',8.35),('10318','2013-04-25','10:50:00',7.47),('10318','2013-04-25','10:55:00',8.8),('10318','2013-04-25','11:00:00',8.83),('10318','2013-04-25','11:05:00',8.79),('10318','2013-04-25','11:10:00',8.79),('10318','2013-04-25','11:15:00',8.89),('10318','2013-04-25','11:20:00',8.95),('10318','2013-04-25','11:25:00',9.02),('10318','2013-04-25','11:30:00',8.52),('10318','2013-04-25','11:35:00',8.91),('10318','2013-04-25','11:40:00',9.27),('10318','2013-04-25','11:45:00',9.35),('10318','2013-04-25','11:50:00',9.36),('10318','2013-04-25','11:55:00',9.38),('10318','2013-04-25','12:00:00',9.19),('10318','2013-04-25','12:05:00',9.11),('10318','2013-04-25','12:10:00',9.3),('10318','2013-04-25','12:15:00',9.31),('10318','2013-04-25','12:20:00',9.21),('10318','2013-04-25','12:25:00',9.15),('10318','2013-04-25','12:30:00',9.11),('10318','2013-04-25','12:35:00',9.17),('10318','2013-04-25','12:40:00',9.14),('10318','2013-04-25','12:45:00',9.01),('10318','2013-04-25','12:50:00',9.04),('10318','2013-04-25','12:55:00',9.05),('10318','2013-04-25','13:00:00',9.15),('10318','2013-04-25','13:05:00',9.21),('10318','2013-04-25','13:10:00',9.18),('10318','2013-04-25','13:15:00',7.96),('10318','2013-04-25','13:20:00',8.59),('10318','2013-04-25','13:25:00',8.16),('10318','2013-04-25','13:30:00',6.42),('10318','2013-04-25','13:35:00',5.82),('10318','2013-04-25','13:40:00',5.1),('10318','2013-04-25','13:45:00',4.82),('10318','2013-04-25','13:50:00',4.64),('10318','2013-04-25','13:55:00',5.19),('10318','2013-04-25','14:00:00',5.38),('10318','2013-04-25','14:05:00',4.78),('10318','2013-04-25','14:10:00',5),('10318','2013-04-25','14:15:00',5.49),('10318','2013-04-25','14:20:00',6.27),('10318','2013-04-25','14:25:00',6.49),('10318','2013-04-25','14:30:00',7.5),('10318','2013-04-25','14:35:00',7.85),('10318','2013-04-25','14:40:00',7.44),('10318','2013-04-25','14:45:00',7.41),('10318','2013-04-25','14:50:00',6.81),('10318','2013-04-25','14:55:00',6.67),('10318','2013-04-25','15:00:00',6.61),('10318','2013-04-25','15:05:00',5.8),('10318','2013-04-25','15:10:00',6.22),('10318','2013-04-25','15:15:00',6.76),('10318','2013-04-25','15:20:00',6.97),('10318','2013-04-25','15:25:00',6.76),('10318','2013-04-25','15:30:00',6.59),('10318','2013-04-25','15:35:00',6.53),('10318','2013-04-25','15:40:00',5.79),('10318','2013-04-25','15:45:00',6.13),('10318','2013-04-25','15:50:00',4.99),('10318','2013-04-25','15:55:00',5.27),('10318','2013-04-25','16:00:00',5.09),('10318','2013-04-25','16:05:00',5.56),('10318','2013-04-25','16:10:00',4.81),('10318','2013-04-25','16:15:00',4.39),('10318','2013-04-25','16:20:00',5.38),('10318','2013-04-25','16:25:00',4.71),('10318','2013-04-25','16:30:00',5.16),('10318','2013-04-25','16:35:00',4.96),('10318','2013-04-25','16:40:00',5.14),('10318','2013-04-25','16:45:00',4.45),('10318','2013-04-25','16:50:00',3.76),('10318','2013-04-25','16:55:00',3.7),('10318','2013-04-25','17:00:00',4.3),('10318','2013-04-25','17:05:00',4.08),('10318','2013-04-25','17:10:00',3.37),('10318','2013-04-25','17:15:00',3.84),('10318','2013-04-25','17:20:00',3.75),('10318','2013-04-25','17:25:00',3.41),('10318','2013-04-25','17:30:00',3.22),('10318','2013-04-25','17:35:00',2.95),('10318','2013-04-25','17:40:00',2.59),('10318','2013-04-25','17:45:00',2.23),('10318','2013-04-25','17:50:00',1.92),('10318','2013-04-25','17:55:00',1.8),('10318','2013-04-25','18:00:00',1.64),('10318','2013-04-25','18:05:00',1.67),('10318','2013-04-25','18:10:00',1.48),('10318','2013-04-25','18:15:00',1.33),('10318','2013-04-25','18:20:00',1.23),('10318','2013-04-25','18:25:00',1.11),('10318','2013-04-25','18:30:00',1.04),('10318','2013-04-24','07:30:00',1.14),('10318','2013-04-24','07:35:00',1.65),('10318','2013-04-24','07:40:00',2.04),('10318','2013-04-24','07:45:00',2.28),('10318','2013-04-24','07:50:00',2.66),('10318','2013-04-24','07:55:00',3.04),('10318','2013-04-24','08:00:00',3.18),('10318','2013-04-24','08:05:00',3.33),('10318','2013-04-24','08:10:00',3.79),('10318','2013-04-24','08:15:00',4.17),('10318','2013-04-24','08:20:00',4.36),('10318','2013-04-24','08:25:00',4.7),('10318','2013-04-24','08:30:00',4.62),('10318','2013-04-24','08:35:00',4.47),('10318','2013-04-24','08:40:00',4.56),('10318','2013-04-24','08:45:00',4.81),('10318','2013-04-24','08:50:00',4.93),('10318','2013-04-24','08:55:00',5.03),('10318','2013-04-24','09:00:00',5.84),('10318','2013-04-24','09:05:00',6.31),('10318','2013-04-24','09:10:00',6.87),('10318','2013-04-24','09:15:00',5.34),('10318','2013-04-24','09:20:00',4.1),('10318','2013-04-24','09:25:00',5.21),('10318','2013-04-24','09:30:00',5.71),('10318','2013-04-24','09:35:00',6.37),('10318','2013-04-24','09:40:00',7.52),('10318','2013-04-24','09:45:00',6.89),('10318','2013-04-24','09:50:00',7.11),('10318','2013-04-24','09:55:00',8.06),('10318','2013-04-24','10:00:00',8.13),('10318','2013-04-24','10:05:00',8.15),('10318','2013-04-24','10:10:00',7.85),('10318','2013-04-24','10:15:00',7.99),('10318','2013-04-24','10:20:00',8.21),('10318','2013-04-24','10:25:00',8.02),('10318','2013-04-24','10:30:00',7.87),('10318','2013-04-24','10:35:00',7.84),('10318','2013-04-24','10:40:00',8.58),('10318','2013-04-24','10:45:00',8.72),('10318','2013-04-24','10:50:00',8.73),('10318','2013-04-24','10:55:00',8.96),('10318','2013-04-24','11:00:00',8.77),('10318','2013-04-24','11:05:00',8.91),('10318','2013-04-24','11:10:00',9.5),('10318','2013-04-24','11:15:00',9.48),('10318','2013-04-24','11:20:00',9.76),('10318','2013-04-24','11:25:00',10.09),('10318','2013-04-24','11:30:00',9.06),('10318','2013-04-24','11:35:00',7.54),('10318','2013-04-24','11:40:00',5.5),('10318','2013-04-24','11:45:00',5.79),('10318','2013-04-24','11:50:00',5.15),('10318','2013-04-24','11:55:00',5.81),('10318','2013-04-24','12:00:00',6.69),('10318','2013-04-24','12:05:00',6.48),('10318','2013-04-24','12:10:00',7.06),('10318','2013-04-24','12:15:00',8.17),('10318','2013-04-24','12:20:00',9.91),('10318','2013-04-24','12:25:00',8.01),('10318','2013-04-24','12:30:00',8.49),('10318','2013-04-24','12:35:00',8.33),('10318','2013-04-24','12:40:00',8.47),('10318','2013-04-24','12:45:00',9.14),('10318','2013-04-24','12:50:00',8.94),('10318','2013-04-24','12:55:00',8.97),('10318','2013-04-24','13:00:00',7.56),('10318','2013-04-24','13:05:00',8.31),('10318','2013-04-24','13:10:00',9.77),('10318','2013-04-24','13:15:00',8.15),('10318','2013-04-24','13:20:00',8.09),('10318','2013-04-24','13:25:00',8.83),('10318','2013-04-24','13:30:00',7.56),('10318','2013-04-24','13:35:00',7.52),('10318','2013-04-24','13:40:00',9.53),('10318','2013-04-24','13:45:00',5.89),('10318','2013-04-24','13:50:00',7.3),('10318','2013-04-24','13:55:00',8.81),('10318','2013-04-24','14:00:00',7.02),('10318','2013-04-24','14:05:00',6.01),('10318','2013-04-24','14:10:00',7.39),('10318','2013-04-24','14:15:00',8.28),('10318','2013-04-24','14:20:00',7.76),('10318','2013-04-24','14:25:00',8.21),('10318','2013-04-24','14:30:00',7.51),('10318','2013-04-24','14:35:00',6.55),('10318','2013-04-24','14:40:00',5.89),('10318','2013-04-24','14:45:00',6.15),('10318','2013-04-24','14:50:00',5.05),('10318','2013-04-24','14:55:00',5.18),('10318','2013-04-24','15:00:00',5.19),('10318','2013-04-24','15:05:00',5.16),('10318','2013-04-24','15:10:00',4.73),('10318','2013-04-24','15:15:00',4.96),('10318','2013-04-24','15:20:00',4.97),('10318','2013-04-24','15:25:00',4.04),('10318','2013-04-24','15:30:00',3.82),('10318','2013-04-24','15:35:00',3.7),('10318','2013-04-24','15:40:00',3.71),('10318','2013-04-24','15:45:00',3.81),('10318','2013-04-24','15:50:00',4.1),('10318','2013-04-24','15:55:00',4.79),('10318','2013-04-24','16:00:00',5.11),('10318','2013-04-24','16:05:00',5.41),('10318','2013-04-24','16:10:00',5.39),('10318','2013-04-24','16:15:00',6.23),('10318','2013-04-24','16:20:00',6.45),('10318','2013-04-24','16:25:00',5.02),('10318','2013-04-24','16:30:00',3.45),('10318','2013-04-24','16:35:00',4.38),('10318','2013-04-24','16:40:00',4.62),('10318','2013-04-24','16:45:00',4.77),('10318','2013-04-24','16:50:00',4.78),('10318','2013-04-24','16:55:00',5.29),('10318','2013-04-24','17:00:00',4.88),('10318','2013-04-24','17:05:00',4.71),('10318','2013-04-24','17:10:00',4.22),('10318','2013-04-24','17:15:00',3.03),('10318','2013-04-24','17:20:00',3.34),('10318','2013-04-24','17:25:00',2.48),('10318','2013-04-24','17:30:00',1.77),('10318','2013-04-24','17:35:00',1.35),('10318','2013-04-24','17:40:00',1.52),('10318','2013-04-24','17:45:00',1.75),('10318','2013-04-24','17:50:00',2.32),('10318','2013-04-24','17:55:00',2.43),('10318','2013-04-24','18:00:00',2.01),('10318','2013-04-24','18:05:00',2.05),('10318','2013-04-24','18:10:00',1.41),('10318','2013-04-24','18:15:00',1.21),('10318','2013-04-24','18:20:00',1.55),('10318','2013-04-24','18:25:00',1.43),('10318','2013-04-24','18:30:00',1.03),('10318','2013-04-23','07:25:00',1.18),('10318','2013-04-23','07:30:00',1.87),('10318','2013-04-23','07:35:00',2.3),('10318','2013-04-23','07:40:00',2.64),('10318','2013-04-23','07:45:00',3.05),('10318','2013-04-23','07:50:00',3.35),('10318','2013-04-23','07:55:00',3.6),('10318','2013-04-23','08:00:00',3.84),('10318','2013-04-23','08:05:00',4.05),('10318','2013-04-23','08:10:00',4.27),('10318','2013-04-23','08:15:00',4.48),('10318','2013-04-23','08:20:00',4.7),('10318','2013-04-23','08:25:00',4.93),('10318','2013-04-23','08:30:00',5.16),('10318','2013-04-23','08:35:00',5.37),('10318','2013-04-23','08:40:00',5.46),('10318','2013-04-23','08:45:00',5.79),('10318','2013-04-23','08:50:00',5.94),('10318','2013-04-23','08:55:00',6.13),('10318','2013-04-23','09:00:00',6.29),('10318','2013-04-23','09:05:00',6.48),('10318','2013-04-23','09:10:00',6.63),('10318','2013-04-23','09:15:00',6.78),('10318','2013-04-23','09:20:00',6.95),('10318','2013-04-23','09:25:00',7.11),('10318','2013-04-23','09:30:00',7.3),('10318','2013-04-23','09:35:00',7.5),('10318','2013-04-23','09:40:00',7.36),('10318','2013-04-23','09:45:00',5.92),('10318','2013-04-23','09:50:00',7.1),('10318','2013-04-23','09:55:00',8.02),('10318','2013-04-23','10:00:00',8.23),('10318','2013-04-23','10:05:00',8.27),('10318','2013-04-23','10:10:00',8.35),('10318','2013-04-23','10:15:00',8.46),('10318','2013-04-23','10:20:00',8.53),('10318','2013-04-23','10:25:00',8.6),('10318','2013-04-23','10:30:00',8.68),('10318','2013-04-23','10:35:00',8.81),('10318','2013-04-23','10:40:00',8.92),('10318','2013-04-23','10:45:00',8.77),('10318','2013-04-23','10:50:00',9.08),('10318','2013-04-23','10:55:00',9.14),('10318','2013-04-23','11:00:00',9.14),('10318','2013-04-23','11:05:00',9.17),('10318','2013-04-23','11:10:00',9.21),('10318','2013-04-23','11:15:00',9.26),('10318','2013-04-23','11:20:00',9.31),('10318','2013-04-23','11:25:00',9.33),('10318','2013-04-23','11:30:00',9.36),('10318','2013-04-23','11:35:00',9.45),('10318','2013-04-23','11:40:00',9.48),('10318','2013-04-23','11:45:00',9.47),('10318','2013-04-23','11:50:00',9.46),('10318','2013-04-23','11:55:00',9.44),('10318','2013-04-23','12:00:00',9.41),('10318','2013-04-23','12:05:00',9.45),('10318','2013-04-23','12:10:00',9.51),('10318','2013-04-23','12:15:00',9.59),('10318','2013-04-23','12:20:00',9.74),('10318','2013-04-23','12:25:00',9.76),('10318','2013-04-23','12:30:00',9.91),('10318','2013-04-23','12:35:00',7.03),('10318','2013-04-23','12:40:00',10.42),('10318','2013-04-23','12:45:00',10.57),('10318','2013-04-23','12:50:00',7.34),('10318','2013-04-23','12:55:00',10.45),('10318','2013-04-23','13:00:00',8.05),('10318','2013-04-23','13:05:00',8.41),('10318','2013-04-23','13:10:00',4.39),('10318','2013-04-23','13:15:00',3.43),('10318','2013-04-23','13:20:00',9.31),('10318','2013-04-23','13:25:00',7.62),('10318','2013-04-23','13:30:00',4.54),('10318','2013-04-23','13:35:00',8.51),('10318','2013-04-23','13:40:00',10.17),('10318','2013-04-23','13:45:00',8.19),('10318','2013-04-23','13:50:00',8.74),('10318','2013-04-23','13:55:00',10.18),('10318','2013-04-23','14:00:00',9.61),('10318','2013-04-23','14:05:00',9.62),('10318','2013-04-23','14:10:00',9.4),('10318','2013-04-23','14:15:00',8.87),('10318','2013-04-23','14:20:00',8.5),('10318','2013-04-23','14:25:00',3.53),('10318','2013-04-23','14:30:00',9.02),('10318','2013-04-23','14:35:00',8.3),('10318','2013-04-23','14:40:00',8.39),('10318','2013-04-23','14:45:00',6.72),('10318','2013-04-23','14:50:00',4.85),('10318','2013-04-23','14:55:00',4.53),('10318','2013-04-23','15:00:00',4.79),('10318','2013-04-23','15:05:00',5.58),('10318','2013-04-23','15:10:00',6.12),('10318','2013-04-23','15:15:00',6.22),('10318','2013-04-23','15:20:00',6.32),('10318','2013-04-23','15:25:00',5.34),('10318','2013-04-23','15:30:00',5.3),('10318','2013-04-23','15:35:00',5.83),('10318','2013-04-23','15:40:00',5.24),('10318','2013-04-23','15:45:00',4.61),('10318','2013-04-23','15:50:00',4.83),('10318','2013-04-23','15:55:00',4.24),('10318','2013-04-23','16:00:00',5.44),('10318','2013-04-23','16:05:00',5.27),('10318','2013-04-23','16:10:00',5.31),('10318','2013-04-23','16:15:00',4),('10318','2013-04-23','16:20:00',4.13),('10318','2013-04-23','16:25:00',3.91),('10318','2013-04-23','16:30:00',3.12),('10318','2013-04-23','16:35:00',2.51),('10318','2013-04-23','16:40:00',2.25),('10318','2013-04-23','16:45:00',2.25),('10318','2013-04-23','16:50:00',2.56),('10318','2013-04-23','16:55:00',2.83),('10318','2013-04-23','17:00:00',3.09),('10318','2013-04-23','17:05:00',2.96),('10318','2013-04-23','17:10:00',2.78),('10318','2013-04-23','17:15:00',2.26),('10318','2013-04-23','17:20:00',1.81),('10318','2013-04-23','17:25:00',1.72),('10318','2013-04-23','17:30:00',1.8),('10318','2013-04-23','17:35:00',2.02),('10318','2013-04-23','17:40:00',2.32),('10318','2013-04-23','17:45:00',2.76),('10318','2013-04-23','17:50:00',1.92),('10318','2013-04-23','17:55:00',1.4),('10318','2013-04-23','18:00:00',1.32),('10318','2013-04-23','18:05:00',1.16),('10318','2013-04-23','18:15:00',1.02),('10318','2013-04-23','18:20:00',1.08),('10318','2013-04-23','18:25:00',1.05),('10318','2013-04-22','08:40:00',1.07),('10318','2013-04-22','08:45:00',1.26),('10318','2013-04-22','08:55:00',1.3),('10318','2013-04-22','09:00:00',1.85),('10318','2013-04-22','09:05:00',1.58),('10318','2013-04-22','09:10:00',2.18),('10318','2013-04-22','09:15:00',1.68),('10318','2013-04-22','09:20:00',1.76),('10318','2013-04-22','09:25:00',2.36),('10318','2013-04-22','09:30:00',2.92),('10318','2013-04-22','09:35:00',2.28),('10318','2013-04-22','09:40:00',1.74),('10318','2013-04-22','09:45:00',1.39),('10318','2013-04-22','10:30:00',1.1),('10318','2013-04-22','10:35:00',8.07),('10318','2013-04-22','10:40:00',8.85),('10318','2013-04-22','10:45:00',7.21),('10318','2013-04-22','10:50:00',5.18),('10318','2013-04-22','10:55:00',4.17),('10318','2013-04-22','11:00:00',3.06),('10318','2013-04-22','11:05:00',4.62),('10318','2013-04-22','11:10:00',4.39),('10318','2013-04-22','11:15:00',3.8),('10318','2013-04-22','11:20:00',3.57),('10318','2013-04-22','11:25:00',3.76),('10318','2013-04-22','11:30:00',7.94),('10318','2013-04-22','11:35:00',10.35),('10318','2013-04-22','11:40:00',4.99),('10318','2013-04-22','11:45:00',8.06),('10318','2013-04-22','11:50:00',9.22),('10318','2013-04-22','11:55:00',10.72),('10318','2013-04-22','12:00:00',8.26),('10318','2013-04-22','12:05:00',8.52),('10318','2013-04-22','12:10:00',10.27),('10318','2013-04-22','12:15:00',10.77),('10318','2013-04-22','12:20:00',9.07),('10318','2013-04-22','12:25:00',7.83),('10318','2013-04-22','12:30:00',8.22),('10318','2013-04-22','12:35:00',8.77),('10318','2013-04-22','12:40:00',9.85),('10318','2013-04-22','12:45:00',6.31),('10318','2013-04-22','12:50:00',9.41),('10318','2013-04-22','12:55:00',10.39),('10318','2013-04-22','13:00:00',10.1),('10318','2013-04-22','13:05:00',8.4),('10318','2013-04-22','13:10:00',9.08),('10318','2013-04-22','13:15:00',6.34),('10318','2013-04-22','13:20:00',4.4),('10318','2013-04-22','13:25:00',9.09),('10318','2013-04-22','13:30:00',10.41),('10318','2013-04-22','13:35:00',6.22),('10318','2013-04-22','13:40:00',3.5),('10318','2013-04-22','13:45:00',4.38),('10318','2013-04-22','13:50:00',2.56),('10318','2013-04-22','13:55:00',2.01),('10318','2013-04-22','14:00:00',1.95),('10318','2013-04-22','14:05:00',2.65),('10318','2013-04-22','14:10:00',2.58),('10318','2013-04-22','14:15:00',6.89),('10318','2013-04-22','14:20:00',10.3),('10318','2013-04-22','14:25:00',9.92),('10318','2013-04-22','14:30:00',9.71),('10318','2013-04-22','14:35:00',7.28),('10318','2013-04-22','14:40:00',8.75),('10318','2013-04-22','14:45:00',8.08),('10318','2013-04-22','14:50:00',9.2),('10318','2013-04-22','14:55:00',9.5),('10318','2013-04-22','15:00:00',9.65),('10318','2013-04-22','15:05:00',4.82),('10318','2013-04-22','15:10:00',8.66),('10318','2013-04-22','15:15:00',9.8),('10318','2013-04-22','15:20:00',8.79),('10318','2013-04-22','15:25:00',7.29),('10318','2013-04-22','15:30:00',2.85),('10318','2013-04-22','15:35:00',3.15),('10318','2013-04-22','15:40:00',9.37),('10318','2013-04-22','15:45:00',8.51),('10318','2013-04-22','15:50:00',6.19),('10318','2013-04-22','15:55:00',5.54),('10318','2013-04-22','16:00:00',1.65),('10318','2013-04-22','16:05:00',1.69),('10318','2013-04-22','16:10:00',1.68),('10318','2013-04-22','16:15:00',1.47),('10318','2013-04-22','16:20:00',1.18),('10318','2013-04-22','16:40:00',1.33),('10318','2013-04-22','16:45:00',2.05),('10318','2013-04-22','16:50:00',2.76),('10318','2013-04-22','16:55:00',1.9),('10318','2013-04-22','17:00:00',1.64),('10318','2013-04-22','17:05:00',1.26),('10318','2013-04-22','17:10:00',1.51),('10318','2013-04-22','17:15:00',1.11),('10318','2013-04-22','17:20:00',1.37),('10318','2013-04-22','17:25:00',1.32),('10318','2013-04-22','17:30:00',1.44),('10318','2013-04-22','17:35:00',1.57),('10318','2013-04-22','17:40:00',1.19),('10318','2013-04-22','17:55:00',1.06),('10318','2013-04-22','18:00:00',1.77),('10318','2013-04-22','18:05:00',2.32),('10318','2013-04-22','18:10:00',1.34),('10318','2013-04-22','18:15:00',1.5),('10318','2013-04-22','18:20:00',1.67),('10318','2013-04-22','18:25:00',1.55),('10318','2013-04-22','18:30:00',1.3),('10318','2013-04-22','18:40:00',1.05),('10318','2014-03-29','06:55:00',1.2),('10318','2014-03-29','07:00:00',1.44),('10318','2014-03-29','07:05:00',1.85),('10318','2014-03-29','07:10:00',2.31),('10318','2014-03-29','07:15:00',2.65),('10318','2014-03-29','07:20:00',3),('10318','2014-03-29','07:25:00',3.32),('10318','2014-03-29','07:30:00',3.62),('10318','2014-03-29','07:35:00',3.85),('10318','2014-03-29','07:40:00',4.09),('10318','2014-03-29','07:45:00',4.33),('10318','2014-03-29','07:50:00',4.53),('10318','2014-03-29','07:55:00',4.76),('10318','2014-03-29','08:00:00',5.03),('10318','2014-03-29','08:05:00',5.27),('10318','2014-03-29','08:10:00',5.48),('10318','2014-03-29','08:15:00',5.68),('10318','2014-03-29','08:20:00',5.89),('10318','2014-03-29','08:25:00',6.12),('10318','2014-03-29','08:30:00',6.3),('10318','2014-03-29','08:35:00',6.46),('10318','2014-03-29','08:40:00',6.63),('10318','2014-03-29','08:45:00',6.75),('10318','2014-03-29','08:50:00',6.84),('10318','2014-03-29','08:55:00',6.99),('10318','2014-03-29','09:00:00',7.15),('10318','2014-03-29','09:05:00',7.03),('10318','2014-03-29','09:10:00',7.28),('10318','2014-03-29','09:15:00',7.38),('10318','2014-03-29','09:20:00',7.56),('10318','2014-03-29','09:25:00',7.68),('10318','2014-03-29','09:30:00',7.86),('10318','2014-03-29','09:35:00',7.99),('10318','2014-03-29','09:40:00',8.14),('10318','2014-03-29','09:45:00',8.18),('10318','2014-03-29','09:50:00',8.31),('10318','2014-03-29','09:55:00',8.41),('10318','2014-03-29','10:00:00',8.44),('10318','2014-03-29','10:05:00',8.6),('10318','2014-03-29','10:10:00',8.75),('10318','2014-03-29','10:15:00',8.86),('10318','2014-03-29','10:20:00',8.94),('10318','2014-03-29','10:25:00',8.97),('10318','2014-03-29','10:30:00',9.06),('10318','2014-03-29','10:35:00',9.11),('10318','2014-03-29','10:40:00',9.22),('10318','2014-03-29','10:45:00',9.24),('10318','2014-03-29','10:50:00',9.02),('10318','2014-03-29','10:55:00',9.26),('10318','2014-03-29','11:00:00',9.24),('10318','2014-03-29','11:05:00',9.17),('10318','2014-03-29','11:10:00',9.27),('10318','2014-03-29','11:15:00',9.31),('10318','2014-03-29','11:20:00',9.24),('10318','2014-03-29','11:25:00',9.29),('10318','2014-03-29','11:30:00',9.4),('10318','2014-03-29','11:35:00',9.16),('10318','2014-03-29','11:40:00',9.19),('10318','2014-03-29','11:45:00',9.32),('10318','2014-03-29','11:50:00',9.37),('10318','2014-03-29','11:55:00',9.28),('10318','2014-03-29','12:00:00',9.23),('10318','2014-03-29','12:05:00',9.26),('10318','2014-03-29','12:10:00',9.24),('10318','2014-03-29','12:15:00',9.27),('10318','2014-03-29','12:20:00',9.24),('10318','2014-03-29','12:25:00',9.2),('10318','2014-03-29','12:30:00',9.08),('10318','2014-03-29','12:35:00',8.72),('10318','2014-03-29','12:40:00',8.99),('10318','2014-03-29','12:45:00',8.93),('10318','2014-03-29','12:50:00',8.93),('10318','2014-03-29','12:55:00',8.8),('10318','2014-03-29','13:00:00',8.72),('10318','2014-03-29','13:05:00',8.63),('10318','2014-03-29','13:10:00',8.58),('10318','2014-03-29','13:15:00',8.58),('10318','2014-03-29','13:20:00',8.38),('10318','2014-03-29','13:25:00',8.2),('10318','2014-03-29','13:30:00',8.1),('10318','2014-03-29','13:35:00',7.98),('10318','2014-03-29','13:40:00',8.05),('10318','2014-03-29','13:45:00',7.94),('10318','2014-03-29','13:50:00',7.73),('10318','2014-03-29','13:55:00',7.68),('10318','2014-03-29','14:00:00',7.47),('10318','2014-03-29','14:05:00',7.42),('10318','2014-03-29','14:10:00',7.24),('10318','2014-03-29','14:15:00',7.09),('10318','2014-03-29','14:20:00',7.01),('10318','2014-03-29','14:25:00',6.91),('10318','2014-03-29','14:30:00',6.23),('10318','2014-03-29','14:35:00',6.58),('10318','2014-03-29','14:40:00',6.4),('10318','2014-03-29','14:45:00',6.49),('10318','2014-03-29','14:50:00',6.09),('10318','2014-03-29','14:55:00',6.13),('10318','2014-03-29','15:00:00',5.96),('10318','2014-03-29','15:05:00',5.87),('10318','2014-03-29','15:10:00',5.65),('10318','2014-03-29','15:15:00',5.41),('10318','2014-03-29','15:20:00',5.18),('10318','2014-03-29','15:25:00',4.95),('10318','2014-03-29','15:30:00',4.85),('10318','2014-03-29','15:35:00',4.68),('10318','2014-03-29','15:40:00',4.37),('10318','2014-03-29','15:45:00',4.3),('10318','2014-03-29','15:50:00',4.09),('10318','2014-03-29','15:55:00',3.91),('10318','2014-03-29','16:00:00',3.72),('10318','2014-03-29','16:05:00',3.54),('10318','2014-03-29','16:10:00',3.3),('10318','2014-03-29','16:15:00',3.15),('10318','2014-03-29','16:20:00',2.85),('10318','2014-03-29','16:25:00',2.84),('10318','2014-03-29','16:30:00',2.67),('10318','2014-03-29','16:35:00',2.4),('10318','2014-03-29','16:40:00',1.91),('10318','2014-03-29','16:45:00',1.76),('10318','2014-03-29','16:50:00',1.88),('10318','2014-03-29','16:55:00',1.81),('10318','2014-03-29','17:00:00',1.66),('10318','2014-03-29','17:05:00',1.5),('10318','2014-03-29','17:10:00',1.36),('10318','2014-03-29','17:15:00',1.22),('10318','2014-03-29','17:20:00',1.08),('10318','2013-04-21','07:45:00',1.06),('10318','2013-04-21','07:50:00',1.59),('10318','2013-04-21','07:55:00',2.01),('10318','2013-04-21','08:00:00',1.8),('10318','2013-04-21','08:05:00',1.99),('10318','2013-04-21','08:10:00',2.3),('10318','2013-04-21','08:15:00',2.21),('10318','2013-04-21','08:20:00',3.02),('10318','2013-04-21','08:25:00',2.85),('10318','2013-04-21','08:30:00',3.71),('10318','2013-04-21','08:35:00',3.44),('10318','2013-04-21','08:40:00',2.7),('10318','2013-04-21','08:45:00',2.56),('10318','2013-04-21','08:50:00',2.73),('10318','2013-04-21','08:55:00',3.48),('10318','2013-04-21','09:00:00',6.18),('10318','2013-04-21','09:05:00',5.04),('10318','2013-04-21','09:10:00',4.46),('10318','2013-04-21','09:15:00',4.29),('10318','2013-04-21','09:20:00',8.05),('10318','2013-04-21','09:25:00',7.13),('10318','2013-04-21','09:30:00',8.46),('10318','2013-04-21','09:35:00',7.78),('10318','2013-04-21','09:40:00',8.16),('10318','2013-04-21','09:45:00',6.04),('10318','2013-04-21','09:50:00',6.43),('10318','2013-04-21','09:55:00',5.39),('10318','2013-04-21','10:00:00',3.73),('10318','2013-04-21','10:05:00',2.8),('10318','2013-04-21','10:10:00',2.84),('10318','2013-04-21','10:15:00',2.94),('10318','2013-04-21','10:20:00',3.47),('10318','2013-04-21','10:25:00',3.35),('10318','2013-04-21','10:30:00',3.54),('10318','2013-04-21','10:35:00',3.9),('10318','2013-04-21','10:40:00',5.79),('10318','2013-04-21','10:45:00',4.56),('10318','2013-04-21','10:50:00',5.75),('10318','2013-04-21','10:55:00',9.36),('10318','2013-04-21','11:00:00',6.72),('10318','2013-04-21','11:05:00',6.4),('10318','2013-04-21','11:10:00',7.54),('10318','2013-04-21','11:15:00',7.47),('10318','2013-04-21','11:20:00',6.79),('10318','2013-04-21','11:25:00',6.36),('10318','2013-04-21','11:30:00',6.17),('10318','2013-04-21','11:35:00',7.02),('10318','2013-04-21','11:40:00',7.98),('10318','2013-04-21','11:45:00',8.11),('10318','2013-04-21','11:50:00',5.59),('10318','2013-04-21','11:55:00',6.26),('10318','2013-04-21','12:00:00',6.45),('10318','2013-04-21','12:05:00',5.27),('10318','2013-04-21','12:10:00',5.29),('10318','2013-04-21','12:15:00',4.7),('10318','2013-04-21','12:20:00',4.22),('10318','2013-04-21','12:25:00',4.35),('10318','2013-04-21','12:30:00',4.51),('10318','2013-04-21','12:35:00',4.82),('10318','2013-04-21','12:40:00',5.03),('10318','2013-04-21','12:45:00',4.75),('10318','2013-04-21','12:50:00',4.62),('10318','2013-04-21','12:55:00',4.69),('10318','2013-04-21','13:00:00',5.01),('10318','2013-04-21','13:05:00',6.81),('10318','2013-04-21','13:10:00',6.23),('10318','2013-04-21','13:15:00',5.31),('10318','2013-04-21','13:20:00',5.19),('10318','2013-04-21','13:25:00',5.22),('10318','2013-04-21','13:30:00',7.16),('10318','2013-04-21','13:35:00',9.32),('10318','2013-04-21','13:40:00',9.33),('10318','2013-04-21','13:45:00',10.31),('10318','2013-04-21','13:50:00',7.96),('10318','2013-04-21','13:55:00',8.65),('10318','2013-04-21','14:00:00',7.63),('10318','2013-04-21','14:05:00',9.52),('10318','2013-04-21','14:10:00',9.41),('10318','2013-04-21','14:15:00',9.57),('10318','2013-04-21','14:20:00',8.91),('10318','2013-04-21','14:25:00',7.39),('10318','2013-04-21','14:30:00',8.69),('10318','2013-04-21','14:35:00',8.86),('10318','2013-04-21','14:40:00',6.05),('10318','2013-04-21','14:45:00',7.13),('10318','2013-04-21','14:50:00',4.68),('10318','2013-04-21','14:55:00',8.85),('10318','2013-04-21','15:00:00',6.99),('10318','2013-04-21','15:05:00',7.81),('10318','2013-04-21','15:10:00',5.94),('10318','2013-04-21','15:15:00',4.98),('10318','2013-04-21','15:20:00',4.06),('10318','2013-04-21','15:25:00',4.41),('10318','2013-04-21','15:30:00',4.35),('10318','2013-04-21','15:35:00',3.62),('10318','2013-04-21','15:40:00',4.02),('10318','2013-04-21','15:45:00',2.79),('10318','2013-04-21','15:50:00',2.18),('10318','2013-04-21','15:55:00',1.74),('10318','2013-04-21','16:00:00',1.64),('10318','2013-04-21','16:05:00',1.45),('10318','2013-04-21','16:10:00',1.45),('10318','2013-04-21','16:15:00',1.36),('10318','2013-04-21','16:20:00',1.18),('10318','2013-04-21','16:30:00',1.05),('10318','2013-04-21','16:35:00',1.24),('10318','2013-04-21','16:40:00',1.21),('10318','2013-04-21','16:55:00',1.29),('10318','2013-04-21','17:00:00',1.58),('10318','2013-04-21','17:05:00',1.55),('10318','2013-04-21','17:10:00',1.58),('10318','2013-04-21','17:15:00',1.49),('10318','2013-04-21','17:20:00',1.26),('10318','2013-04-21','17:25:00',1.13),('10318','2013-04-21','17:30:00',1.05),('10318','2013-04-21','17:35:00',1.03),('10318','2013-04-21','17:40:00',1.01),('10318','2013-04-21','17:45:00',1.03),('10318','2013-04-20','07:20:00',1.18),('10318','2013-04-20','07:25:00',1.4),('10318','2013-04-20','07:30:00',1.74),('10318','2013-04-20','07:35:00',1.96),('10318','2013-04-20','07:40:00',1.96),('10318','2013-04-20','07:45:00',1.35),('10318','2013-04-20','07:50:00',1.66),('10318','2013-04-20','07:55:00',2.13),('10318','2013-04-20','08:00:00',2.68),('10318','2013-04-20','08:05:00',3.33),('10318','2013-04-20','08:10:00',3.49),('10318','2013-04-20','08:15:00',2.7),('10318','2013-04-20','08:20:00',3.18),('10318','2013-04-20','08:25:00',3.69),('10318','2013-04-20','08:30:00',4.38),('10318','2013-04-20','08:35:00',4.73),('10318','2013-04-20','08:40:00',5.03),('10318','2013-04-20','08:45:00',5.22),('10318','2013-04-20','08:50:00',5.3),('10318','2013-04-20','08:55:00',5.9),('10318','2013-04-20','09:00:00',6.04),('10318','2013-04-20','09:05:00',6.34),('10318','2013-04-20','09:10:00',4.17),('10318','2013-04-20','09:15:00',6.42),('10318','2013-04-20','09:20:00',5.62),('10318','2013-04-20','09:25:00',5.04),('10318','2013-04-20','09:30:00',2.62),('10318','2013-04-20','09:35:00',2.01),('10318','2013-04-20','09:40:00',1.67),('10318','2013-04-20','09:45:00',1.95),('10318','2013-04-20','09:50:00',1.79),('10318','2013-04-20','09:55:00',1.11),('10318','2013-04-20','10:20:00',1.1),('10318','2013-04-20','10:25:00',1.39),('10318','2013-04-20','10:30:00',1.76),('10318','2013-04-20','10:35:00',2.03),('10318','2013-04-20','10:40:00',2.91),('10318','2013-04-20','10:45:00',6.37),('10318','2013-04-20','10:50:00',7.27),('10318','2013-04-20','10:55:00',7.98),('10318','2013-04-20','11:00:00',7.7),('10318','2013-04-20','11:05:00',9.35),('10318','2013-04-20','11:10:00',5.69),('10318','2013-04-20','11:15:00',6.04),('10318','2013-04-20','11:20:00',7.16),('10318','2013-04-20','11:25:00',7.59),('10318','2013-04-20','11:30:00',7.17),('10318','2013-04-20','11:35:00',9.64),('10318','2013-04-20','11:40:00',8.24),('10318','2013-04-20','11:45:00',6.27),('10318','2013-04-20','11:50:00',7.55),('10318','2013-04-20','11:55:00',2.77),('10318','2013-04-20','12:00:00',7.25),('10318','2013-04-20','12:05:00',3.9),('10318','2013-04-20','12:10:00',4.67),('10318','2013-04-20','12:15:00',8.61),('10318','2013-04-20','12:20:00',9.42),('10318','2013-04-20','12:25:00',9.14),('10318','2013-04-20','12:30:00',10.51),('10318','2013-04-20','12:35:00',6.27),('10318','2013-04-20','12:40:00',8.07),('10318','2013-04-20','12:45:00',9.6),('10318','2013-04-20','12:50:00',7.83),('10318','2013-04-20','12:55:00',9.9),('10318','2013-04-20','13:00:00',9.68),('10318','2013-04-20','13:05:00',9.51),('10318','2013-04-20','13:10:00',9.65),('10318','2013-04-20','13:15:00',10.05),('10318','2013-04-20','13:20:00',6.18),('10318','2013-04-20','13:25:00',4.11),('10318','2013-04-20','13:30:00',10.25),('10318','2013-04-20','13:35:00',8.46),('10318','2013-04-20','13:40:00',5.63),('10318','2013-04-20','13:45:00',5.07),('10318','2013-04-20','13:50:00',6.67),('10318','2013-04-20','13:55:00',4.52),('10318','2013-04-20','14:00:00',8.55),('10318','2013-04-20','14:05:00',9.04),('10318','2013-04-20','14:10:00',9.55),('10318','2013-04-20','14:15:00',9.08),('10318','2013-04-20','14:20:00',8.43),('10318','2013-04-20','14:25:00',8.6),('10318','2013-04-20','14:30:00',8.4),('10318','2013-04-20','14:35:00',8.41),('10318','2013-04-20','14:40:00',8.29),('10318','2013-04-20','14:45:00',8.19),('10318','2013-04-20','14:50:00',8.18),('10318','2013-04-20','14:55:00',8.14),('10318','2013-04-20','15:00:00',8.11),('10318','2013-04-20','15:05:00',7.76),('10318','2013-04-20','15:10:00',6.41),('10318','2013-04-20','15:15:00',8.05),('10318','2013-04-20','15:20:00',6.49),('10318','2013-04-20','15:25:00',5.31),('10318','2013-04-20','15:30:00',2.56),('10318','2013-04-20','15:35:00',1.93),('10318','2013-04-20','15:40:00',1.89),('10318','2013-04-20','15:45:00',1.84),('10318','2013-04-20','15:50:00',1.71),('10318','2013-04-20','15:55:00',1.77),('10318','2013-04-20','16:00:00',2.18),('10318','2013-04-20','16:05:00',3.15),('10318','2013-04-20','16:10:00',5.12),('10318','2013-04-20','16:15:00',6.14),('10318','2013-04-20','16:20:00',5.88),('10318','2013-04-20','16:25:00',6.16),('10318','2013-04-20','16:30:00',6.24),('10318','2013-04-20','16:35:00',5.95),('10318','2013-04-20','16:40:00',5.95),('10318','2013-04-20','16:45:00',5.49),('10318','2013-04-20','16:50:00',4.97),('10318','2013-04-20','16:55:00',4.63),('10318','2013-04-20','17:00:00',4.31),('10318','2013-04-20','17:05:00',4.09),('10318','2013-04-20','17:10:00',3.9),('10318','2013-04-20','17:15:00',3.43),('10318','2013-04-20','17:20:00',3.4),('10318','2013-04-20','17:25:00',3.51),('10318','2013-04-20','17:30:00',3.51),('10318','2013-04-20','17:35:00',3.4),('10318','2013-04-20','17:40:00',2.29),('10318','2013-04-20','17:45:00',1.56),('10318','2013-04-20','17:50:00',2.36),('10318','2013-04-20','17:55:00',2.54),('10318','2013-04-20','18:00:00',1.89),('10318','2013-04-20','18:05:00',2.34),('10318','2013-04-20','18:10:00',2.31),('10318','2013-04-20','18:15:00',1.55),('10318','2013-04-19','07:40:00',1.35),('10318','2013-04-19','07:45:00',1.02),('10318','2013-04-19','07:50:00',1.19),('10318','2013-04-19','07:55:00',1.74),('10318','2013-04-19','08:00:00',1.99),('10318','2013-04-19','08:05:00',2.98),('10318','2013-04-19','08:10:00',3.44),('10318','2013-04-19','08:15:00',3.64),('10318','2013-04-19','08:20:00',3.87),('10318','2013-04-19','08:25:00',4.06),('10318','2013-04-19','08:30:00',4.36),('10318','2013-04-19','08:35:00',4.68),('10318','2013-04-19','08:40:00',4.76),('10318','2013-04-19','08:45:00',5.01),('10318','2013-04-19','08:50:00',5.29),('10318','2013-04-19','08:55:00',4.91),('10318','2013-04-19','09:00:00',5.55),('10318','2013-04-19','09:05:00',5.77),('10318','2013-04-19','09:10:00',5.93),('10318','2013-04-19','09:15:00',6.14),('10318','2013-04-19','09:20:00',6.14),('10318','2013-04-19','09:25:00',6.39),('10318','2013-04-19','09:30:00',6.49),('10318','2013-04-19','09:35:00',6.61),('10318','2013-04-19','09:40:00',6.64),('10318','2013-04-19','09:45:00',6.63),('10318','2013-04-19','09:50:00',6.87),('10318','2013-04-19','09:55:00',7.05),('10318','2013-04-19','10:00:00',7.13),('10318','2013-04-19','10:05:00',7.39),('10318','2013-04-19','10:10:00',7.5),('10318','2013-04-19','10:15:00',7.51),('10318','2013-04-19','10:20:00',7.81),('10318','2013-04-19','10:25:00',7.92),('10318','2013-04-19','10:30:00',7.69),('10318','2013-04-19','10:35:00',8.14),('10318','2013-04-19','10:40:00',7.06),('10318','2013-04-19','10:45:00',8.18),('10318','2013-04-19','10:50:00',8.22),('10318','2013-04-19','10:55:00',8.17),('10318','2013-04-19','11:00:00',8.31),('10318','2013-04-19','11:05:00',8.42),('10318','2013-04-19','11:10:00',8.49),('10318','2013-04-19','11:15:00',8.5),('10318','2013-04-19','11:20:00',8.49),('10318','2013-04-19','11:25:00',8.68),('10318','2013-04-19','11:30:00',8.58),('10318','2013-04-19','11:35:00',8.77),('10318','2013-04-19','11:40:00',8.8),('10318','2013-04-19','11:45:00',8.76),('10318','2013-04-19','11:50:00',8.76),('10318','2013-04-19','11:55:00',8.85),('10318','2013-04-19','12:00:00',8.93),('10318','2013-04-19','12:05:00',8.91),('10318','2013-04-19','12:10:00',8.85),('10318','2013-04-19','12:15:00',8.91),('10318','2013-04-19','12:20:00',8.98),('10318','2013-04-19','12:25:00',9.05),('10318','2013-04-19','12:30:00',8.88),('10318','2013-04-19','12:35:00',8.9),('10318','2013-04-19','12:40:00',8.86),('10318','2013-04-19','12:45:00',8.84),('10318','2013-04-19','12:50:00',9.19),('10318','2013-04-19','12:55:00',9.14),('10318','2013-04-19','13:00:00',9.08),('10318','2013-04-19','13:05:00',8.98),('10318','2013-04-19','13:10:00',8.94),('10318','2013-04-19','13:15:00',8.82),('10318','2013-04-19','13:20:00',9.02),('10318','2013-04-19','13:25:00',8.94),('10318','2013-04-19','13:30:00',8.78),('10318','2013-04-19','13:35:00',8.74),('10318','2013-04-19','13:40:00',8.77),('10318','2013-04-19','13:45:00',8.67),('10318','2013-04-19','13:50:00',8.51),('10318','2013-04-19','13:55:00',8.53),('10318','2013-04-19','14:00:00',8.46),('10318','2013-04-19','14:05:00',8.41),('10318','2013-04-19','14:10:00',8.32),('10318','2013-04-19','14:15:00',8.22),('10318','2013-04-19','14:20:00',8.15),('10318','2013-04-19','14:25:00',8.06),('10318','2013-04-19','14:30:00',7.89),('10318','2013-04-19','14:35:00',7.85),('10318','2013-04-19','14:40:00',7.76),('10318','2013-04-19','14:45:00',7.77),('10318','2013-04-19','14:50:00',7.66),('10318','2013-04-19','14:55:00',7.58),('10318','2013-04-19','15:00:00',7.21),('10318','2013-04-19','15:05:00',7.34),('10318','2013-04-19','15:10:00',7.26),('10318','2013-04-19','15:15:00',7.18),('10318','2013-04-19','15:20:00',7.06),('10318','2013-04-19','15:25:00',6.92),('10318','2013-04-19','15:30:00',6.86),('10318','2013-04-19','15:35:00',6.7),('10318','2013-04-19','15:40:00',6.54),('10318','2013-04-19','15:45:00',6.39),('10318','2013-04-19','15:50:00',6.21),('10318','2013-04-19','15:55:00',6.04),('10318','2013-04-19','16:00:00',5.86),('10318','2013-04-19','16:05:00',5.72),('10318','2013-04-19','16:10:00',5.58),('10318','2013-04-19','16:15:00',5.41),('10318','2013-04-19','16:20:00',5.21),('10318','2013-04-19','16:25:00',5.05),('10318','2013-04-19','16:30:00',4.92),('10318','2013-04-19','16:35:00',4.74),('10318','2013-04-19','16:40:00',4.53),('10318','2013-04-19','16:45:00',4.29),('10318','2013-04-19','16:50:00',4.06),('10318','2013-04-19','16:55:00',3.96),('10318','2013-04-19','17:00:00',3.8),('10318','2013-04-19','17:05:00',3.6),('10318','2013-04-19','17:10:00',3.4),('10318','2013-04-19','17:15:00',3.24),('10318','2013-04-19','17:20:00',3.06),('10318','2013-04-19','17:25:00',2.87),('10318','2013-04-19','17:30:00',2.74),('10318','2013-04-19','17:35:00',2.55),('10318','2013-04-19','17:40:00',2.37),('10318','2013-04-19','17:45:00',2.25),('10318','2013-04-19','17:50:00',2.09),('10318','2013-04-19','17:55:00',1.95),('10318','2013-04-19','18:00:00',1.81),('10318','2013-04-19','18:05:00',1.64),('10318','2013-04-19','18:10:00',1.56),('10318','2013-04-19','18:15:00',1.42),('10318','2013-04-19','18:20:00',1.33),('10318','2013-04-19','18:25:00',1.21),('10318','2013-04-19','18:30:00',1.11),('10318','2013-04-18','07:35:00',1.15),('10318','2013-04-18','07:40:00',1.25),('10318','2013-04-18','07:45:00',1.36),('10318','2013-04-18','07:50:00',1.57),('10318','2013-04-18','07:55:00',1.84),('10318','2013-04-18','08:00:00',2.1),('10318','2013-04-18','08:05:00',2.94),('10318','2013-04-18','08:10:00',3.32),('10318','2013-04-18','08:15:00',2.97),('10318','2013-04-18','08:20:00',3.16),('10318','2013-04-18','08:25:00',3.27),('10318','2013-04-18','08:30:00',3.53),('10318','2013-04-18','08:35:00',3.78),('10318','2013-04-18','08:40:00',3.52),('10318','2013-04-18','08:45:00',3.88),('10318','2013-04-18','08:50:00',4.19),('10318','2013-04-18','08:55:00',4.11),('10318','2013-04-18','09:00:00',4.59),('10318','2013-04-18','09:05:00',4.85),('10318','2013-04-18','09:10:00',5.47),('10318','2013-04-18','09:15:00',5.49),('10318','2013-04-18','09:20:00',5.11),('10318','2013-04-18','09:25:00',5.16),('10318','2013-04-18','09:30:00',5.24),('10318','2013-04-18','09:35:00',5.63),('10318','2013-04-18','09:40:00',6),('10318','2013-04-18','09:45:00',6.4),('10318','2013-04-18','09:50:00',6.68),('10318','2013-04-18','09:55:00',7.19),('10318','2013-04-18','10:00:00',6.52),('10318','2013-04-18','10:05:00',7.03),('10318','2013-04-18','10:10:00',7.35),('10318','2013-04-18','10:15:00',7.99),('10318','2013-04-18','10:20:00',8.13),('10318','2013-04-18','10:25:00',8.11),('10318','2013-04-18','10:30:00',8.05),('10318','2013-04-18','10:35:00',8.3),('10318','2013-04-18','10:40:00',8.37),('10318','2013-04-18','10:45:00',8.46),('10318','2013-04-18','10:50:00',8.53),('10318','2013-04-18','10:55:00',8.62),('10318','2013-04-18','11:00:00',8.7),('10318','2013-04-18','11:05:00',8.76),('10318','2013-04-18','11:10:00',8.78),('10318','2013-04-18','11:15:00',8.81),('10318','2013-04-18','11:20:00',8.82),('10318','2013-04-18','11:25:00',8.8),('10318','2013-04-18','11:30:00',8.7),('10318','2013-04-18','11:35:00',8.86),('10318','2013-04-18','11:40:00',8.95),('10318','2013-04-18','11:45:00',9.03),('10318','2013-04-18','11:50:00',9.2),('10318','2013-04-18','11:55:00',9.28),('10318','2013-04-18','12:00:00',9.09),('10318','2013-04-18','12:05:00',9.31),('10318','2013-04-18','12:10:00',9.29),('10318','2013-04-18','12:15:00',9.18),('10318','2013-04-18','12:20:00',9.32),('10318','2013-04-18','12:25:00',9.4),('10318','2013-04-18','12:30:00',9.34),('10318','2013-04-18','12:35:00',9.32),('10318','2013-04-18','12:40:00',9.34),('10318','2013-04-18','12:45:00',9.35),('10318','2013-04-18','12:50:00',9.38),('10318','2013-04-18','12:55:00',9.31),('10318','2013-04-18','13:00:00',9.27),('10318','2013-04-18','13:05:00',9.35),('10318','2013-04-18','13:10:00',9.31),('10318','2013-04-18','13:15:00',9.26),('10318','2013-04-18','13:20:00',9.19),('10318','2013-04-18','13:25:00',9.17),('10318','2013-04-18','13:30:00',8.94),('10318','2013-04-18','13:35:00',9.13),('10318','2013-04-18','13:40:00',9.09),('10318','2013-04-18','13:45:00',9.01),('10318','2013-04-18','13:50:00',8.94),('10318','2013-04-18','13:55:00',8.88),('10318','2013-04-18','14:00:00',8.85),('10318','2013-04-18','14:05:00',8.8),('10318','2013-04-18','14:10:00',8.74),('10318','2013-04-18','14:15:00',8.67),('10318','2013-04-18','14:20:00',8.61),('10318','2013-04-18','14:25:00',8.54),('10318','2013-04-18','14:30:00',8.43),('10318','2013-04-18','14:35:00',8.35),('10318','2013-04-18','14:40:00',8.25),('10318','2013-04-18','14:45:00',8.14),('10318','2013-04-18','14:50:00',8.04),('10318','2013-04-18','14:55:00',7.95),('10318','2013-04-18','15:00:00',7.8),('10318','2013-04-18','15:05:00',7.69),('10318','2013-04-18','15:10:00',7.56),('10318','2013-04-18','15:15:00',7.3),('10318','2013-04-18','15:20:00',7.28),('10318','2013-04-18','15:25:00',7.13),('10318','2013-04-18','15:30:00',6.98),('10318','2013-04-18','15:35:00',6.81),('10318','2013-04-18','15:40:00',6.66),('10318','2013-04-18','15:45:00',6.52),('10318','2013-04-18','15:50:00',6.41),('10318','2013-04-18','15:55:00',6.27),('10318','2013-04-18','16:00:00',6.07),('10318','2013-04-18','16:05:00',5.88),('10318','2013-04-18','16:10:00',5.77),('10318','2013-04-18','16:15:00',5.61),('10318','2013-04-18','16:20:00',5.42),('10318','2013-04-18','16:25:00',5.23),('10318','2013-04-18','16:30:00',5.06),('10318','2013-04-18','16:35:00',4.88),('10318','2013-04-18','16:40:00',4.72),('10318','2013-04-18','16:45:00',4.51),('10318','2013-04-18','16:50:00',4.32),('10318','2013-04-18','16:55:00',4.15),('10318','2013-04-18','17:00:00',3.91),('10318','2013-04-18','17:05:00',3.77),('10318','2013-04-18','17:10:00',3.59),('10318','2013-04-18','17:15:00',3.39),('10318','2013-04-18','17:20:00',3.21),('10318','2013-04-18','17:25:00',3.04),('10318','2013-04-18','17:30:00',2.85),('10318','2013-04-18','17:35:00',2.7),('10318','2013-04-18','17:40:00',2.52),('10318','2013-04-18','17:45:00',2.35),('10318','2013-04-18','17:50:00',2.17),('10318','2013-04-18','17:55:00',2.01),('10318','2013-04-18','18:00:00',1.82),('10318','2013-04-18','18:05:00',1.67),('10318','2013-04-18','18:10:00',1.52),('10318','2013-04-18','18:15:00',1.37),('10318','2013-04-18','18:20:00',1.24),('10318','2013-04-18','18:25:00',1.1),('10318','2013-04-17','07:35:00',1.58),('10318','2013-04-17','07:40:00',1.9),('10318','2013-04-17','07:45:00',2.51),('10318','2013-04-17','07:50:00',2.8),('10318','2013-04-17','07:55:00',3.07),('10318','2013-04-17','08:00:00',3.35),('10318','2013-04-17','08:05:00',3.58),('10318','2013-04-17','08:10:00',3.8),('10318','2013-04-17','08:15:00',4),('10318','2013-04-17','08:20:00',4.21),('10318','2013-04-17','08:25:00',4.42),('10318','2013-04-17','08:30:00',4.65),('10318','2013-04-17','08:35:00',4.84),('10318','2013-04-17','08:40:00',5.03),('10318','2013-04-17','08:45:00',5.23),('10318','2013-04-17','08:50:00',5.33),('10318','2013-04-17','08:55:00',5.59),('10318','2013-04-17','09:00:00',5.78),('10318','2013-04-17','09:05:00',5.98),('10318','2013-04-17','09:10:00',6.17),('10318','2013-04-17','09:15:00',6.32),('10318','2013-04-17','09:20:00',6.48),('10318','2013-04-17','09:25:00',6.66),('10318','2013-04-17','09:30:00',6.8),('10318','2013-04-17','09:35:00',6.94),('10318','2013-04-17','09:40:00',7.07),('10318','2013-04-17','09:45:00',7.19),('10318','2013-04-17','09:50:00',7.34),('10318','2013-04-17','09:55:00',7.48),('10318','2013-04-17','10:00:00',7.63),('10318','2013-04-17','10:05:00',7.71),('10318','2013-04-17','10:10:00',7.87),('10318','2013-04-17','10:15:00',7.93),('10318','2013-04-17','10:20:00',8.03),('10318','2013-04-17','10:25:00',8.17),('10318','2013-04-17','10:30:00',8.28),('10318','2013-04-17','10:35:00',8.11),('10318','2013-04-17','10:40:00',8.43),('10318','2013-04-17','10:45:00',8.53),('10318','2013-04-17','10:50:00',8.59),('10318','2013-04-17','10:55:00',8.65),('10318','2013-04-17','11:00:00',8.7),('10318','2013-04-17','11:05:00',8.79),('10318','2013-04-17','11:10:00',8.88),('10318','2013-04-17','11:15:00',8.94),('10318','2013-04-17','11:20:00',8.97),('10318','2013-04-17','11:25:00',9.03),('10318','2013-04-17','11:30:00',9.06),('10318','2013-04-17','11:35:00',9.11),('10318','2013-04-17','11:40:00',9.14),('10318','2013-04-17','11:45:00',9.15),('10318','2013-04-17','11:50:00',9.18),('10318','2013-04-17','11:55:00',9.2),('10318','2013-04-17','12:00:00',9.25),('10318','2013-04-17','12:05:00',9.31),('10318','2013-04-17','12:10:00',9.32),('10318','2013-04-17','12:15:00',9.33),('10318','2013-04-17','12:20:00',9.16),('10318','2013-04-17','12:25:00',9.35),('10318','2013-04-17','12:30:00',9.41),('10318','2013-04-17','12:35:00',9.34),('10318','2013-04-17','12:40:00',9.34),('10318','2013-04-17','12:45:00',9.32),('10318','2013-04-17','12:50:00',9.31),('10318','2013-04-17','12:55:00',9.35),('10318','2013-04-17','13:00:00',9.24),('10318','2013-04-17','13:05:00',9.3),('10318','2013-04-17','13:10:00',9.28),('10318','2013-04-17','13:15:00',9.21),('10318','2013-04-17','13:20:00',9.19),('10318','2013-04-17','13:25:00',9.23),('10318','2013-04-17','13:30:00',9.02),('10318','2013-04-17','13:35:00',9.1),('10318','2013-04-17','13:40:00',9.11),('10318','2013-04-17','13:45:00',8.54),('10318','2013-04-17','13:50:00',9.07),('10318','2013-04-17','13:55:00',8.32),('10318','2013-04-17','14:00:00',8.57),('10318','2013-04-17','14:05:00',9.28),('10318','2013-04-17','14:10:00',9.51),('10318','2013-04-17','14:15:00',9.33),('10318','2013-04-17','14:20:00',8.97),('10318','2013-04-17','14:25:00',8.97),('10318','2013-04-17','14:30:00',7.14),('10318','2013-04-17','14:35:00',8.34),('10318','2013-04-17','14:40:00',7.92),('10318','2013-04-17','14:45:00',8.34),('10318','2013-04-17','14:50:00',8),('10318','2013-04-17','14:55:00',8.7),('10318','2013-04-17','15:00:00',8.6),('10318','2013-04-17','15:05:00',8.63),('10318','2013-04-17','15:10:00',8.54),('10318','2013-04-17','15:15:00',7.65),('10318','2013-04-17','15:20:00',4.35),('10318','2013-04-17','15:25:00',3.56),('10318','2013-04-17','15:30:00',6.11),('10318','2013-04-17','15:35:00',6.91),('10318','2013-04-17','15:40:00',7.24),('10318','2013-04-17','15:45:00',7.2),('10318','2013-04-17','15:50:00',7.06),('10318','2013-04-17','15:55:00',6.97),('10318','2013-04-17','16:00:00',6.83),('10318','2013-04-17','16:05:00',5.4),('10318','2013-04-17','16:10:00',6.18),('10318','2013-04-17','16:15:00',6.06),('10318','2013-04-17','16:20:00',5.77),('10318','2013-04-17','16:25:00',5.56),('10318','2013-04-17','16:30:00',5.37),('10318','2013-04-17','16:35:00',5.19),('10318','2013-04-17','16:40:00',4.2),('10318','2013-04-17','16:45:00',4.88),('10318','2013-04-17','16:50:00',4.57),('10318','2013-04-17','16:55:00',4.31),('10318','2013-04-17','17:00:00',4.07),('10318','2013-04-17','17:05:00',3.81),('10318','2013-04-17','17:10:00',3.67),('10318','2013-04-17','17:15:00',3.47),('10318','2013-04-17','17:20:00',3.28),('10318','2013-04-17','17:25:00',3.09),('10318','2013-04-17','17:30:00',2.89),('10318','2013-04-17','17:35:00',2.7),('10318','2013-04-17','17:40:00',2.53),('10318','2013-04-17','17:45:00',2.33),('10318','2013-04-17','17:50:00',2.16),('10318','2013-04-17','17:55:00',1.99),('10318','2013-04-17','18:00:00',1.86),('10318','2013-04-17','18:05:00',1.68),('10318','2013-04-17','18:10:00',1.53),('10318','2013-04-17','18:15:00',1.41),('10318','2013-04-17','18:20:00',1.27),('10318','2013-04-17','18:25:00',1.13),('10318','2013-04-16','07:35:00',1.13),('10318','2013-04-16','07:40:00',1.63),('10318','2013-04-16','07:45:00',2.1),('10318','2013-04-16','07:50:00',2.34),('10318','2013-04-16','07:55:00',2.57),('10318','2013-04-16','08:00:00',2.88),('10318','2013-04-16','08:05:00',3.29),('10318','2013-04-16','08:10:00',3.8),('10318','2013-04-16','08:15:00',3.58),('10318','2013-04-16','08:20:00',1.82),('10318','2013-04-16','08:25:00',1.67),('10318','2013-04-16','08:30:00',1.97),('10318','2013-04-16','08:35:00',1.81),('10318','2013-04-16','08:40:00',1.83),('10318','2013-04-16','08:45:00',2.26),('10318','2013-04-16','08:50:00',2.62),('10318','2013-04-16','08:55:00',2.23),('10318','2013-04-16','09:00:00',1.93),('10318','2013-04-16','09:05:00',1.8),('10318','2013-04-16','09:10:00',4.62),('10318','2013-04-16','09:15:00',6.55),('10318','2013-04-16','09:20:00',5.13),('10318','2013-04-16','09:25:00',6.67),('10318','2013-04-16','09:30:00',4.25),('10318','2013-04-16','09:35:00',4.39),('10318','2013-04-16','09:40:00',4.5),('10318','2013-04-16','09:45:00',4.08),('10318','2013-04-16','09:50:00',3.54),('10318','2013-04-16','09:55:00',3.27),('10318','2013-04-16','10:00:00',3.01),('10318','2013-04-16','10:05:00',2.95),('10318','2013-04-16','10:10:00',3.18),('10318','2013-04-16','10:15:00',3.37),('10318','2013-04-16','10:20:00',3.5),('10318','2013-04-16','10:25:00',3.5),('10318','2013-04-16','10:30:00',3.48),('10318','2013-04-16','10:35:00',3.55),('10318','2013-04-16','10:40:00',3.56),('10318','2013-04-16','10:45:00',3.53),('10318','2013-04-16','10:50:00',3.51),('10318','2013-04-16','10:55:00',3.73),('10318','2013-04-16','11:00:00',3.95),('10318','2013-04-16','11:05:00',4.14),('10318','2013-04-16','11:10:00',4),('10318','2013-04-16','11:15:00',4.03),('10318','2013-04-16','11:20:00',4.12),('10318','2013-04-16','11:25:00',4.04),('10318','2013-04-16','11:30:00',3.93),('10318','2013-04-16','11:35:00',3.74),('10318','2013-04-16','11:40:00',4.16),('10318','2013-04-16','11:45:00',4.81),('10318','2013-04-16','11:50:00',5.36),('10318','2013-04-16','11:55:00',5.63),('10318','2013-04-16','12:00:00',6.09),('10318','2013-04-16','12:05:00',6.77),('10318','2013-04-16','12:10:00',6.47),('10318','2013-04-16','12:15:00',6.84),('10318','2013-04-16','12:20:00',6.49),('10318','2013-04-16','12:25:00',6.48),('10318','2013-04-16','12:30:00',6),('10318','2013-04-16','12:35:00',5.84),('10318','2013-04-16','12:40:00',6.28),('10318','2013-04-16','12:45:00',6.79),('10318','2013-04-16','12:50:00',6.54),('10318','2013-04-16','12:55:00',9.32),('10318','2013-04-16','13:00:00',9.2),('10318','2013-04-16','13:05:00',9.15),('10318','2013-04-16','13:10:00',8.65),('10318','2013-04-16','13:15:00',8.98),('10318','2013-04-16','13:20:00',8.99),('10318','2013-04-16','13:25:00',9.01),('10318','2013-04-16','13:30:00',8.76),('10318','2013-04-16','13:35:00',8.87),('10318','2013-04-16','13:40:00',8.7),('10318','2013-04-16','13:45:00',8.69),('10318','2013-04-16','13:50:00',8.73),('10318','2013-04-16','13:55:00',8.52),('10318','2013-04-16','14:00:00',8.69),('10318','2013-04-16','14:05:00',8.66),('10318','2013-04-16','14:10:00',8.55),('10318','2013-04-16','14:15:00',8.53),('10318','2013-04-16','14:20:00',8.67),('10318','2013-04-16','14:25:00',7.88),('10318','2013-04-16','14:30:00',8.08),('10318','2013-04-16','14:35:00',6.2),('10318','2013-04-16','14:40:00',7.92),('10318','2013-04-16','14:45:00',7.98),('10318','2013-04-16','14:50:00',7.67),('10318','2013-04-16','14:55:00',7.72),('10318','2013-04-16','15:00:00',7.43),('10318','2013-04-16','15:05:00',7.71),('10318','2013-04-16','15:10:00',7.64),('10318','2013-04-16','15:15:00',7.45),('10318','2013-04-16','15:20:00',6.11),('10318','2013-04-16','15:25:00',5.96),('10318','2013-04-16','15:30:00',6.6),('10318','2013-04-16','15:35:00',6.58),('10318','2013-04-16','15:40:00',6.65),('10318','2013-04-16','15:45:00',6.47),('10318','2013-04-16','15:50:00',6.23),('10318','2013-04-16','15:55:00',6.18),('10318','2013-04-16','16:00:00',6.03),('10318','2013-04-16','16:05:00',5.92),('10318','2013-04-16','16:10:00',5.43),('10318','2013-04-16','16:15:00',5.58),('10318','2013-04-16','16:20:00',5.4),('10318','2013-04-16','16:25:00',5.17),('10318','2013-04-16','16:30:00',5.06),('10318','2013-04-16','16:35:00',4.96),('10318','2013-04-16','16:40:00',4.78),('10318','2013-04-16','16:45:00',4.89),('10318','2013-04-16','16:50:00',4.54),('10318','2013-04-16','16:55:00',3.84),('10318','2013-04-16','17:00:00',4.04),('10318','2013-04-16','17:05:00',4),('10318','2013-04-16','17:10:00',3.87),('10318','2013-04-16','17:15:00',3.71),('10318','2013-04-16','17:20:00',2.98),('10318','2013-04-16','17:25:00',3.47),('10318','2013-04-16','17:30:00',3.16),('10318','2013-04-16','17:35:00',3.25),('10318','2013-04-16','17:40:00',2.92),('10318','2013-04-16','17:45:00',2.68),('10318','2013-04-16','17:50:00',2.41),('10318','2013-04-16','17:55:00',2.15),('10318','2013-04-16','18:00:00',1.97),('10318','2013-04-16','18:05:00',1.87),('10318','2013-04-16','18:10:00',1.66),('10318','2013-04-16','18:15:00',1.37),('10318','2013-04-16','18:20:00',1.12),('10318','2013-04-16','18:25:00',1.07),('10318','2013-04-15','07:35:00',1.2),('10318','2013-04-15','07:40:00',1.87),('10318','2013-04-15','07:45:00',2.44),('10318','2013-04-15','07:50:00',2.81),('10318','2013-04-15','07:55:00',3.03),('10318','2013-04-15','08:00:00',3.31),('10318','2013-04-15','08:05:00',3.54),('10318','2013-04-15','08:10:00',3.76),('10318','2013-04-15','08:15:00',3.97),('10318','2013-04-15','08:20:00',4.13),('10318','2013-04-15','08:25:00',4.38),('10318','2013-04-15','08:30:00',4.61),('10318','2013-04-15','08:35:00',4.78),('10318','2013-04-15','08:40:00',5.04),('10318','2013-04-15','08:45:00',5.24),('10318','2013-04-15','08:50:00',5.45),('10318','2013-04-15','08:55:00',5.67),('10318','2013-04-15','09:00:00',5.86),('10318','2013-04-15','09:05:00',6.03),('10318','2013-04-15','09:10:00',6.19),('10318','2013-04-15','09:15:00',6.35),('10318','2013-04-15','09:20:00',6.5),('10318','2013-04-15','09:25:00',6.66),('10318','2013-04-15','09:30:00',6.81),('10318','2013-04-15','09:35:00',6.9),('10318','2013-04-15','09:40:00',7.08),('10318','2013-04-15','09:45:00',7.22),('10318','2013-04-15','09:50:00',7.33),('10318','2013-04-15','09:55:00',7.44),('10318','2013-04-15','10:00:00',7.58),('10318','2013-04-15','10:05:00',7.7),('10318','2013-04-15','10:10:00',7.8),('10318','2013-04-15','10:15:00',7.95),('10318','2013-04-15','10:20:00',8.07),('10318','2013-04-15','10:25:00',8.16),('10318','2013-04-15','10:30:00',8.26),('10318','2013-04-15','10:35:00',8.35),('10318','2013-04-15','10:40:00',8.4),('10318','2013-04-15','10:45:00',8.47),('10318','2013-04-15','10:50:00',8.56),('10318','2013-04-15','10:55:00',8.65),('10318','2013-04-15','11:00:00',8.75),('10318','2013-04-15','11:05:00',8.81),('10318','2013-04-15','11:10:00',8.86),('10318','2013-04-15','11:15:00',8.91),('10318','2013-04-15','11:20:00',8.97),('10318','2013-04-15','11:25:00',8.87),('10318','2013-04-15','11:30:00',9.02),('10318','2013-04-15','11:35:00',9.06),('10318','2013-04-15','11:40:00',9.12),('10318','2013-04-15','11:45:00',9.15),('10318','2013-04-15','11:50:00',9.15),('10318','2013-04-15','11:55:00',9.17),('10318','2013-04-15','12:00:00',9.17),('10318','2013-04-15','12:05:00',9.2),('10318','2013-04-15','12:10:00',9.18),('10318','2013-04-15','12:15:00',9.16),('10318','2013-04-15','12:20:00',9.12),('10318','2013-04-15','12:25:00',9.16),('10318','2013-04-15','12:30:00',9.21),('10318','2013-04-15','12:35:00',9.27),('10318','2013-04-15','12:40:00',9.24),('10318','2013-04-15','12:45:00',9.22),('10318','2013-04-15','12:50:00',9.21),('10318','2013-04-15','12:55:00',9.23),('10318','2013-04-15','13:00:00',9.23),('10318','2013-04-15','13:05:00',9.17),('10318','2013-04-15','13:10:00',8.96),('10318','2013-04-15','13:15:00',9.16),('10318','2013-04-15','13:20:00',9.17),('10318','2013-04-15','13:25:00',9.1),('10318','2013-04-15','13:30:00',9.07),('10318','2013-04-15','13:35:00',9.02),('10318','2013-04-15','13:40:00',8.96),('10318','2013-04-15','13:45:00',8.93),('10318','2013-04-15','13:50:00',8.94),('10318','2013-04-15','13:55:00',9),('10318','2013-04-15','14:00:00',8.94),('10318','2013-04-15','14:05:00',8.86),('10318','2013-04-15','14:10:00',8.78),('10318','2013-04-15','14:15:00',8.73),('10318','2013-04-15','14:20:00',8.66),('10318','2013-04-15','14:25:00',8.52),('10318','2013-04-15','14:30:00',8.44),('10318','2013-04-15','14:35:00',8.4),('10318','2013-04-15','14:40:00',8.29),('10318','2013-04-15','14:45:00',8.16),('10318','2013-04-15','14:50:00',8.06),('10318','2013-04-15','14:55:00',7.73),('10318','2013-04-15','15:00:00',7.86),('10318','2013-04-15','15:05:00',7.72),('10318','2013-04-15','15:10:00',7.64),('10318','2013-04-15','15:15:00',7.53),('10318','2013-04-15','15:20:00',7.38),('10318','2013-04-15','15:25:00',7.23),('10318','2013-04-15','15:30:00',7.12),('10318','2013-04-15','15:35:00',6.96),('10318','2013-04-15','15:40:00',6.81),('10318','2013-04-15','15:45:00',6.65),('10318','2013-04-15','15:50:00',6.49),('10318','2013-04-15','15:55:00',6.34),('10318','2013-04-15','16:00:00',6.2),('10318','2013-04-15','16:05:00',6),('10318','2013-04-15','16:10:00',5.82),('10318','2013-04-15','16:15:00',5.64),('10318','2013-04-15','16:20:00',5.46),('10318','2013-04-15','16:25:00',5.3),('10318','2013-04-15','16:30:00',5.12),('10318','2013-04-15','16:35:00',4.93),('10318','2013-04-15','16:40:00',4.65),('10318','2013-04-15','16:45:00',4.54),('10318','2013-04-15','16:50:00',4.34),('10318','2013-04-15','16:55:00',4.19),('10318','2013-04-15','17:00:00',4.01),('10318','2013-04-15','17:05:00',3.82),('10318','2013-04-15','17:10:00',3.62),('10318','2013-04-15','17:15:00',3.45),('10318','2013-04-15','17:20:00',3.25),('10318','2013-04-15','17:25:00',3.05),('10318','2013-04-15','17:30:00',2.86),('10318','2013-04-15','17:35:00',2.67),('10318','2013-04-15','17:40:00',2.44),('10318','2013-04-15','17:45:00',2.29),('10318','2013-04-15','17:50:00',2.16),('10318','2013-04-15','17:55:00',2),('10318','2013-04-15','18:00:00',1.83),('10318','2013-04-15','18:05:00',1.7),('10318','2013-04-15','18:10:00',1.54),('10318','2013-04-15','18:15:00',1.38),('10318','2013-04-15','18:20:00',1.24),('10318','2013-04-15','18:25:00',1.11),('10318','2013-04-14','07:30:00',1.01),('10318','2013-04-14','07:35:00',1.19),('10318','2013-04-14','07:40:00',1.64),('10318','2013-04-14','07:45:00',2.13),('10318','2013-04-14','07:50:00',2.55),('10318','2013-04-14','07:55:00',2.8),('10318','2013-04-14','08:00:00',3),('10318','2013-04-14','08:05:00',3.19),('10318','2013-04-14','08:10:00',3.44),('10318','2013-04-14','08:15:00',3.71),('10318','2013-04-14','08:20:00',3.91),('10318','2013-04-14','08:25:00',4.12),('10318','2013-04-14','08:30:00',4.33),('10318','2013-04-14','08:35:00',4.52),('10318','2013-04-14','08:40:00',4.74),('10318','2013-04-14','08:45:00',4.94),('10318','2013-04-14','08:50:00',5.12),('10318','2013-04-14','08:55:00',5.3),('10318','2013-04-14','09:00:00',5.48),('10318','2013-04-14','09:05:00',5.69),('10318','2013-04-14','09:10:00',5.73),('10318','2013-04-14','09:15:00',6.03),('10318','2013-04-14','09:20:00',6.19),('10318','2013-04-14','09:25:00',6.34),('10318','2013-04-14','09:30:00',6.48),('10318','2013-04-14','09:35:00',6.65),('10318','2013-04-14','09:40:00',6.8),('10318','2013-04-14','09:45:00',6.93),('10318','2013-04-14','09:50:00',7.09),('10318','2013-04-14','09:55:00',7.27),('10318','2013-04-14','10:00:00',7.34),('10318','2013-04-14','10:05:00',7.47),('10318','2013-04-14','10:10:00',7.63),('10318','2013-04-14','10:15:00',7.77),('10318','2013-04-14','10:20:00',7.92),('10318','2013-04-14','10:25:00',8.02),('10318','2013-04-14','10:30:00',8.09),('10318','2013-04-14','10:35:00',8.2),('10318','2013-04-14','10:40:00',8.28),('10318','2013-04-14','10:45:00',8.36),('10318','2013-04-14','10:50:00',8.42),('10318','2013-04-14','10:55:00',8.32),('10318','2013-04-14','11:00:00',8.67),('10318','2013-04-14','11:05:00',8.7),('10318','2013-04-14','11:10:00',8.75),('10318','2013-04-14','11:15:00',8.84),('10318','2013-04-14','11:20:00',8.82),('10318','2013-04-14','11:25:00',8.92),('10318','2013-04-14','11:30:00',8.96),('10318','2013-04-14','11:35:00',9.04),('10318','2013-04-14','11:40:00',9.05),('10318','2013-04-14','11:45:00',9.05),('10318','2013-04-14','11:50:00',9.07),('10318','2013-04-14','11:55:00',9.09),('10318','2013-04-14','12:00:00',9.08),('10318','2013-04-14','12:05:00',9.09),('10318','2013-04-14','12:10:00',9.01),('10318','2013-04-14','12:15:00',8.99),('10318','2013-04-14','12:20:00',8.88),('10318','2013-04-14','12:25:00',9.19),('10318','2013-04-14','12:30:00',9.27),('10318','2013-04-14','12:35:00',9.27),('10318','2013-04-14','12:40:00',9.25),('10318','2013-04-14','12:45:00',9.35),('10318','2013-04-14','12:50:00',9.29),('10318','2013-04-14','12:55:00',9.2),('10318','2013-04-14','13:00:00',9.37),('10318','2013-04-14','13:05:00',9.23),('10318','2013-04-14','13:10:00',7.13),('10318','2013-04-14','13:15:00',9.37),('10318','2013-04-14','13:20:00',9.45),('10318','2013-04-14','13:25:00',9.22),('10318','2013-04-14','13:30:00',9.04),('10318','2013-04-14','13:35:00',9.1),('10318','2013-04-14','13:40:00',9.14),('10318','2013-04-14','13:45:00',7.34),('10318','2013-04-14','13:50:00',8.97),('10318','2013-04-14','13:55:00',8.73),('10318','2013-04-14','14:00:00',8.77),('10318','2013-04-14','14:05:00',8.75),('10318','2013-04-14','14:10:00',8.65),('10318','2013-04-14','14:15:00',8.55),('10318','2013-04-14','14:20:00',8.42),('10318','2013-04-14','14:25:00',8.34),('10318','2013-04-14','14:30:00',8.32),('10318','2013-04-14','14:35:00',8.33),('10318','2013-04-14','14:40:00',8.07),('10318','2013-04-14','14:45:00',7.32),('10318','2013-04-14','14:50:00',7.93),('10318','2013-04-14','14:55:00',6.4),('10318','2013-04-14','15:00:00',6.81),('10318','2013-04-14','15:05:00',6.68),('10318','2013-04-14','15:10:00',7.61),('10318','2013-04-14','15:15:00',7.46),('10318','2013-04-14','15:20:00',7.53),('10318','2013-04-14','15:25:00',7.06),('10318','2013-04-14','15:30:00',6.96),('10318','2013-04-14','15:35:00',7.05),('10318','2013-04-14','15:40:00',6.88),('10318','2013-04-14','15:45:00',6.95),('10318','2013-04-14','15:50:00',6.61),('10318','2013-04-14','15:55:00',6.29),('10318','2013-04-14','16:00:00',6),('10318','2013-04-14','16:05:00',5.85),('10318','2013-04-14','16:10:00',5.65),('10318','2013-04-14','16:15:00',5.6),('10318','2013-04-14','16:20:00',5.43),('10318','2013-04-14','16:25:00',5.16),('10318','2013-04-14','16:30:00',4.99),('10318','2013-04-14','16:35:00',4.77),('10318','2013-04-14','16:40:00',4.59),('10318','2013-04-14','16:45:00',4.45),('10318','2013-04-14','16:50:00',4.26),('10318','2013-04-14','16:55:00',4.07),('10318','2013-04-14','17:00:00',3.89),('10318','2013-04-14','17:05:00',3.67),('10318','2013-04-14','17:10:00',3.5),('10318','2013-04-14','17:15:00',3.33),('10318','2013-04-14','17:20:00',3.15),('10318','2013-04-14','17:25:00',2.93),('10318','2013-04-14','17:30:00',2.78),('10318','2013-04-14','17:35:00',2.61),('10318','2013-04-14','17:40:00',2.44),('10318','2013-04-14','17:45:00',2.29),('10318','2013-04-14','17:50:00',2.12),('10318','2013-04-14','17:55:00',1.94),('10318','2013-04-14','18:00:00',1.78),('10318','2013-04-14','18:05:00',1.62),('10318','2013-04-14','18:10:00',1.5),('10318','2013-04-14','18:15:00',1.37),('10318','2013-04-14','18:20:00',1.23),('10318','2013-04-14','18:25:00',1.11),('10318','2013-04-13','07:35:00',1.08),('10318','2013-04-13','07:40:00',1.31),('10318','2013-04-13','07:45:00',1.88),('10318','2013-04-13','07:50:00',2.32),('10318','2013-04-13','07:55:00',2.57),('10318','2013-04-13','08:00:00',2.77),('10318','2013-04-13','08:05:00',3.08),('10318','2013-04-13','08:10:00',3.3),('10318','2013-04-13','08:15:00',1.96),('10318','2013-04-13','08:20:00',1.36),('10318','2013-04-13','08:25:00',1.15),('10318','2013-04-13','08:30:00',1.65),('10318','2013-04-13','08:35:00',1.81),('10318','2013-04-13','08:40:00',1.6),('10318','2013-04-13','08:45:00',1.9),('10318','2013-04-13','08:50:00',2.35),('10318','2013-04-13','08:55:00',3.83),('10318','2013-04-13','09:00:00',1.92),('10318','2013-04-13','09:05:00',2.7),('10318','2013-04-13','09:10:00',6.26),('10318','2013-04-13','09:15:00',3.76),('10318','2013-04-13','09:20:00',6.16),('10318','2013-04-13','09:25:00',6.23),('10318','2013-04-13','09:30:00',6.41),('10318','2013-04-13','09:35:00',6.07),('10318','2013-04-13','09:40:00',6.54),('10318','2013-04-13','09:45:00',7.06),('10318','2013-04-13','09:50:00',7.17),('10318','2013-04-13','09:55:00',7.39),('10318','2013-04-13','10:00:00',6.88),('10318','2013-04-13','10:05:00',8.27),('10318','2013-04-13','10:10:00',5.47),('10318','2013-04-13','10:15:00',5.45),('10318','2013-04-13','10:20:00',3.56),('10318','2013-04-13','10:25:00',6.66),('10318','2013-04-13','10:30:00',9.21),('10318','2013-04-13','10:35:00',7.63),('10318','2013-04-13','10:40:00',8.93),('10318','2013-04-13','10:45:00',9.05),('10318','2013-04-13','10:50:00',7.3),('10318','2013-04-13','10:55:00',3.31),('10318','2013-04-13','11:00:00',5.23),('10318','2013-04-13','11:05:00',9.22),('10318','2013-04-13','11:10:00',9.2),('10318','2013-04-13','11:15:00',6.06),('10318','2013-04-13','11:20:00',6.24),('10318','2013-04-13','11:25:00',4.75),('10318','2013-04-13','11:30:00',5.16),('10318','2013-04-13','11:35:00',10.08),('10318','2013-04-13','11:40:00',9.65),('10318','2013-04-13','11:45:00',9.89),('10318','2013-04-13','11:50:00',9.09),('10318','2013-04-13','11:55:00',7.84),('10318','2013-04-13','12:00:00',5.65),('10318','2013-04-13','12:05:00',10.04),('10318','2013-04-13','12:10:00',9.04),('10318','2013-04-13','12:15:00',10.31),('10318','2013-04-13','12:20:00',9.75),('10318','2013-04-13','12:25:00',7.57),('10318','2013-04-13','12:30:00',10.17),('10318','2013-04-13','12:35:00',9.81),('10318','2013-04-13','12:40:00',9.56),('10318','2013-04-13','12:45:00',9.74),('10318','2013-04-13','12:50:00',9.43),('10318','2013-04-13','12:55:00',9.39),('10318','2013-04-13','13:00:00',9.3),('10318','2013-04-13','13:05:00',9.68),('10318','2013-04-13','13:10:00',9.59),('10318','2013-04-13','13:15:00',9.28),('10318','2013-04-13','13:20:00',9.09),('10318','2013-04-13','13:25:00',9.29),('10318','2013-04-13','13:30:00',8.95),('10318','2013-04-13','13:35:00',8.35),('10318','2013-04-13','13:40:00',8.11),('10318','2013-04-13','13:45:00',7.87),('10318','2013-04-13','13:50:00',7.8),('10318','2013-04-13','13:55:00',7.76),('10318','2013-04-13','14:00:00',7.57),('10318','2013-04-13','14:05:00',7.33),('10318','2013-04-13','14:10:00',5.3),('10318','2013-04-13','14:15:00',7.24),('10318','2013-04-13','14:20:00',6.2),('10318','2013-04-13','14:25:00',6.86),('10318','2013-04-13','14:30:00',8.01),('10318','2013-04-13','14:35:00',7.74),('10318','2013-04-13','14:40:00',7.59),('10318','2013-04-13','14:45:00',6.88),('10318','2013-04-13','14:50:00',7.34),('10318','2013-04-13','14:55:00',7.53),('10318','2013-04-13','15:00:00',6.9),('10318','2013-04-13','15:05:00',6.96),('10318','2013-04-13','15:10:00',6.55),('10318','2013-04-13','15:15:00',6.23),('10318','2013-04-13','15:20:00',6.01),('10318','2013-04-13','15:25:00',5.75),('10318','2013-04-13','15:30:00',5.76),('10318','2013-04-13','15:35:00',5.67),('10318','2013-04-13','15:40:00',5.83),('10318','2013-04-13','15:45:00',5.87),('10318','2013-04-13','15:50:00',5.78),('10318','2013-04-13','15:55:00',5.5),('10318','2013-04-13','16:00:00',5.53),('10318','2013-04-13','16:05:00',5.07),('10318','2013-04-13','16:10:00',4.96),('10318','2013-04-13','16:15:00',4.91),('10318','2013-04-13','16:20:00',4.74),('10318','2013-04-13','16:25:00',4.32),('10318','2013-04-13','16:30:00',4.11),('10318','2013-04-13','16:35:00',3.81),('10318','2013-04-13','16:40:00',3.62),('10318','2013-04-13','16:45:00',3.62),('10318','2013-04-13','16:50:00',3.53),('10318','2013-04-13','16:55:00',2.94),('10318','2013-04-13','17:00:00',2.56),('10318','2013-04-13','17:05:00',2.99),('10318','2013-04-13','17:10:00',3.82),('10318','2013-04-13','17:15:00',3.52),('10318','2013-04-13','17:20:00',3.18),('10318','2013-04-13','17:25:00',3.36),('10318','2013-04-13','17:30:00',2.97),('10318','2013-04-13','17:35:00',2.92),('10318','2013-04-13','17:40:00',2.59),('10318','2013-04-13','17:45:00',2.36),('10318','2013-04-13','17:50:00',2.09),('10318','2013-04-13','17:55:00',2.18),('10318','2013-04-13','18:00:00',1.72),('10318','2013-04-13','18:05:00',1.64),('10318','2013-04-13','18:10:00',1.55),('10318','2013-04-13','18:15:00',1.44),('10318','2013-04-13','18:20:00',1.43),('10318','2013-04-13','18:25:00',1.22),('10318','2013-04-13','18:30:00',1.1),('10318','2013-04-12','07:40:00',1.22),('10318','2013-04-12','07:45:00',1.15),('10318','2013-04-12','07:50:00',1.24),('10318','2013-04-12','07:55:00',1.82),('10318','2013-04-12','08:00:00',2.94),('10318','2013-04-12','08:05:00',2.94),('10318','2013-04-12','08:10:00',1.48),('10318','2013-04-12','08:15:00',1.31),('10318','2013-04-12','08:20:00',1.52),('10318','2013-04-12','08:25:00',1.36),('10318','2013-04-12','08:30:00',2.03),('10318','2013-04-12','08:35:00',2.38),('10318','2013-04-12','08:40:00',3.99),('10318','2013-04-12','08:45:00',3.09),('10318','2013-04-12','08:50:00',2.31),('10318','2013-04-12','08:55:00',2.71),('10318','2013-04-12','09:00:00',3.11),('10318','2013-04-12','09:05:00',2.69),('10318','2013-04-12','09:10:00',1.57),('10318','2013-04-12','09:15:00',2.32),('10318','2013-04-12','09:20:00',3.75),('10318','2013-04-12','09:25:00',3.05),('10318','2013-04-12','09:30:00',3.07),('10318','2013-04-12','09:35:00',3.18),('10318','2013-04-12','09:40:00',2.85),('10318','2013-04-12','09:45:00',3.21),('10318','2013-04-12','09:50:00',4.32),('10318','2013-04-12','09:55:00',5.96),('10318','2013-04-12','10:00:00',3.16),('10318','2013-04-12','10:05:00',7.02),('10318','2013-04-12','10:10:00',5.86),('10318','2013-04-12','10:15:00',7.71),('10318','2013-04-12','10:20:00',3.23),('10318','2013-04-12','10:25:00',1.92),('10318','2013-04-12','10:30:00',2.5),('10318','2013-04-12','10:35:00',3.28),('10318','2013-04-12','10:40:00',3.41),('10318','2013-04-12','10:45:00',4.18),('10318','2013-04-12','10:50:00',3.66),('10318','2013-04-12','10:55:00',5.62),('10318','2013-04-12','11:00:00',8.47),('10318','2013-04-12','11:05:00',7.96),('10318','2013-04-12','11:10:00',5.52),('10318','2013-04-12','11:15:00',5.7),('10318','2013-04-12','11:20:00',7.73),('10318','2013-04-12','11:25:00',7.03),('10318','2013-04-12','11:30:00',3.34),('10318','2013-04-12','11:35:00',5.75),('10318','2013-04-12','11:40:00',9.53),('10318','2013-04-12','11:45:00',9.42),('10318','2013-04-12','11:50:00',9.67),('10318','2013-04-12','11:55:00',9.62),('10318','2013-04-12','12:00:00',9.56),('10318','2013-04-12','12:05:00',9.32),('10318','2013-04-12','12:10:00',9.24),('10318','2013-04-12','12:15:00',9.95),('10318','2013-04-12','12:20:00',10.06),('10318','2013-04-12','12:25:00',10.08),('10318','2013-04-12','12:30:00',10.02),('10318','2013-04-12','12:35:00',9.92),('10318','2013-04-12','12:40:00',9.67),('10318','2013-04-12','12:45:00',9.65),('10318','2013-04-12','12:50:00',9.25),('10318','2013-04-12','12:55:00',9.57),('10318','2013-04-12','13:00:00',9.88),('10318','2013-04-12','13:05:00',7.12),('10318','2013-04-12','13:10:00',9.95),('10318','2013-04-12','13:15:00',9.68),('10318','2013-04-12','13:20:00',9.15),('10318','2013-04-12','13:25:00',9.37),('10318','2013-04-12','13:30:00',8.4),('10318','2013-04-12','13:35:00',9.48),('10318','2013-04-12','13:40:00',9.24),('10318','2013-04-12','13:45:00',8.32),('10318','2013-04-12','13:50:00',8.87),('10318','2013-04-12','13:55:00',8.38),('10318','2013-04-12','14:00:00',7.57),('10318','2013-04-12','14:05:00',9.12),('10318','2013-04-12','14:10:00',8.88),('10318','2013-04-12','14:15:00',8.76),('10318','2013-04-12','14:20:00',8.66),('10318','2013-04-12','14:25:00',8.55),('10318','2013-04-12','14:30:00',8.47),('10318','2013-04-12','14:35:00',8.42),('10318','2013-04-12','14:40:00',8.35),('10318','2013-04-12','14:45:00',8.22),('10318','2013-04-12','14:50:00',8.08),('10318','2013-04-12','14:55:00',8.01),('10318','2013-04-12','15:00:00',7.84),('10318','2013-04-12','15:05:00',7.73),('10318','2013-04-12','15:10:00',7.66),('10318','2013-04-12','15:15:00',7.46),('10318','2013-04-12','15:20:00',7.35),('10318','2013-04-12','15:25:00',7.21),('10318','2013-04-12','15:30:00',7.07),('10318','2013-04-12','15:35:00',6.9),('10318','2013-04-12','15:40:00',6.79),('10318','2013-04-12','15:45:00',6.61),('10318','2013-04-12','15:50:00',6.43),('10318','2013-04-12','15:55:00',6.28),('10318','2013-04-12','16:00:00',6.14),('10318','2013-04-12','16:05:00',5.95),('10318','2013-04-12','16:10:00',5.48),('10318','2013-04-12','16:15:00',4.7),('10318','2013-04-12','16:20:00',5.41),('10318','2013-04-12','16:25:00',4.65),('10318','2013-04-12','16:30:00',3.23),('10318','2013-04-12','16:35:00',3.79),('10318','2013-04-12','16:40:00',4.55),('10318','2013-04-12','16:45:00',4.42),('10318','2013-04-12','16:50:00',4.33),('10318','2013-04-12','16:55:00',4.09),('10318','2013-04-12','17:00:00',3.87),('10318','2013-04-12','17:05:00',3.76),('10318','2013-04-12','17:10:00',3.3),('10318','2013-04-12','17:15:00',3.23),('10318','2013-04-12','17:20:00',1.47),('10318','2013-04-12','17:25:00',1.8),('10318','2013-04-12','17:30:00',2.01),('10318','2013-04-12','17:35:00',1.48),('10318','2013-04-12','17:40:00',1.24),('10318','2013-04-12','17:50:00',1.78),('10318','2013-04-12','17:55:00',1.95),('10318','2013-04-12','18:00:00',1.81),('10318','2013-04-12','18:05:00',1.66),('10318','2013-04-12','18:10:00',1.49),('10318','2013-04-12','18:15:00',1.34),('10318','2013-04-12','18:20:00',1.07),('10318','2014-03-28','06:55:00',1.05),('10318','2014-03-28','07:00:00',1.33),('10318','2014-03-28','07:05:00',1.83),('10318','2014-03-28','07:10:00',2.49),('10318','2014-03-28','07:15:00',3.12),('10318','2014-03-28','07:20:00',3.31),('10318','2014-03-28','07:25:00',3.53),('10318','2014-03-28','07:30:00',3.89),('10318','2014-03-28','07:35:00',4.01),('10318','2014-03-28','07:40:00',4.45),('10318','2014-03-28','07:45:00',4.71),('10318','2014-03-28','07:50:00',4.84),('10318','2014-03-28','07:55:00',5.02),('10318','2014-03-28','08:00:00',5.23),('10318','2014-03-28','08:05:00',5.46),('10318','2014-03-28','08:10:00',5.65),('10318','2014-03-28','08:15:00',5.83),('10318','2014-03-28','08:20:00',6),('10318','2014-03-28','08:25:00',6.19),('10318','2014-03-28','08:30:00',6.39),('10318','2014-03-28','08:35:00',6.54),('10318','2014-03-28','08:40:00',6.67),('10318','2014-03-28','08:45:00',6.82),('10318','2014-03-28','08:50:00',7.07),('10318','2014-03-28','08:55:00',7.24),('10318','2014-03-28','09:00:00',7.48),('10318','2014-03-28','09:05:00',7.75),('10318','2014-03-28','09:10:00',7.9),('10318','2014-03-28','09:15:00',7.4),('10318','2014-03-28','09:20:00',7.97),('10318','2014-03-28','09:25:00',8.49),('10318','2014-03-28','09:30:00',8.68),('10318','2014-03-28','09:35:00',5.4),('10318','2014-03-28','09:40:00',4.54),('10318','2014-03-28','09:45:00',6.05),('10318','2014-03-28','09:50:00',8.56),('10318','2014-03-28','09:55:00',8.81),('10318','2014-03-28','10:00:00',8.83),('10318','2014-03-28','10:05:00',9.21),('10318','2014-03-28','10:10:00',7.73),('10318','2014-03-28','10:15:00',5.41),('10318','2014-03-28','10:20:00',7.91),('10318','2014-03-28','10:25:00',8.98),('10318','2014-03-28','10:30:00',8.65),('10318','2014-03-28','10:35:00',8.32),('10318','2014-03-28','10:40:00',7.72),('10318','2014-03-28','10:45:00',9.56),('10318','2014-03-28','10:50:00',9.28),('10318','2014-03-28','10:55:00',9),('10318','2014-03-28','11:00:00',5.77),('10318','2014-03-28','11:05:00',9.82),('10318','2014-03-28','11:10:00',8.45),('10318','2014-03-28','11:15:00',8.46),('10318','2014-03-28','11:20:00',3.56),('10318','2014-03-28','11:25:00',8.59),('10318','2014-03-28','11:30:00',4.95),('10318','2014-03-28','11:35:00',9.07),('10318','2014-03-28','11:40:00',5.89),('10318','2014-03-28','11:45:00',7.01),('10318','2014-03-28','11:50:00',4.76),('10318','2014-03-28','11:55:00',6.25),('10318','2014-03-28','12:00:00',4.24),('10318','2014-03-28','12:05:00',4.66),('10318','2014-03-28','12:10:00',7.78),('10318','2014-03-28','12:15:00',9.98),('10318','2014-03-28','12:20:00',8.18),('10318','2014-03-28','12:25:00',5),('10318','2014-03-28','12:30:00',4.33),('10318','2014-03-28','12:35:00',9.23),('10318','2014-03-28','12:40:00',9.75),('10318','2014-03-28','12:45:00',5.08),('10318','2014-03-28','12:50:00',7.62),('10318','2014-03-28','12:55:00',3.82),('10318','2014-03-28','13:00:00',4.44),('10318','2014-03-28','13:05:00',3.1),('10318','2014-03-28','13:10:00',4.58),('10318','2014-03-28','13:15:00',7.5),('10318','2014-03-28','13:20:00',5.38),('10318','2014-03-28','13:25:00',4.33),('10318','2014-03-28','13:30:00',4.7),('10318','2014-03-28','13:35:00',4.13),('10318','2014-03-28','13:40:00',5.11),('10318','2014-03-28','13:45:00',8.94),('10318','2014-03-28','13:50:00',8.48),('10318','2014-03-28','13:55:00',7.99),('10318','2014-03-28','14:00:00',8.21),('10318','2014-03-28','14:05:00',7.97),('10318','2014-03-28','14:10:00',7.88),('10318','2014-03-28','14:15:00',7.72),('10318','2014-03-28','14:20:00',7.57),('10318','2014-03-28','14:25:00',7.39),('10318','2014-03-28','14:30:00',7.25),('10318','2014-03-28','14:35:00',7.12),('10318','2014-03-28','14:40:00',6.98),('10318','2014-03-28','14:45:00',6.84),('10318','2014-03-28','14:50:00',6.67),('10318','2014-03-28','14:55:00',6.5),('10318','2014-03-28','15:00:00',6.43),('10318','2014-03-28','15:05:00',6.18),('10318','2014-03-28','15:10:00',6.01),('10318','2014-03-28','15:15:00',5.81),('10318','2014-03-28','15:20:00',5.63),('10318','2014-03-28','15:25:00',5.44),('10318','2014-03-28','15:30:00',5.25),('10318','2014-03-28','15:35:00',5.05),('10318','2014-03-28','15:40:00',4.78),('10318','2014-03-28','15:45:00',4.79),('10318','2014-03-28','15:50:00',4.57),('10318','2014-03-28','15:55:00',4.5),('10318','2014-03-28','16:00:00',4.68),('10318','2014-03-28','16:05:00',4.74),('10318','2014-03-28','16:10:00',4.4),('10318','2014-03-28','16:15:00',4.04),('10318','2014-03-28','16:20:00',3.4),('10318','2014-03-28','16:25:00',3.1),('10318','2014-03-28','16:30:00',1.93),('10318','2014-03-28','16:35:00',1.04),('10318','2014-03-28','16:40:00',2.14),('10318','2014-03-28','16:45:00',2.36),('10318','2014-03-28','16:50:00',1.15),('10318','2014-03-28','16:55:00',1.32),('10318','2014-03-28','17:00:00',1.88),('10318','2014-03-28','17:05:00',1.61),('10318','2014-03-28','17:10:00',1.51),('10318','2014-03-28','17:15:00',1.54),('10318','2014-03-28','17:20:00',1.54),('10318','2014-03-28','17:25:00',1.18),('10318','2014-03-28','17:30:00',1.29),('10318','2013-04-11','07:35:00',1.03),('10318','2013-04-11','07:40:00',1.19),('10318','2013-04-11','07:45:00',1.81),('10318','2013-04-11','07:50:00',2.33),('10318','2013-04-11','07:55:00',2.69),('10318','2013-04-11','08:00:00',2.93),('10318','2013-04-11','08:05:00',3.21),('10318','2013-04-11','08:10:00',3.49),('10318','2013-04-11','08:15:00',3.69),('10318','2013-04-11','08:20:00',3.91),('10318','2013-04-11','08:25:00',4.12),('10318','2013-04-11','08:30:00',4.34),('10318','2013-04-11','08:35:00',4.55),('10318','2013-04-11','08:40:00',4.75),('10318','2013-04-11','08:45:00',4.96),('10318','2013-04-11','08:50:00',5.16),('10318','2013-04-11','08:55:00',5.34),('10318','2013-04-11','09:00:00',5.44),('10318','2013-04-11','09:05:00',5.7),('10318','2013-04-11','09:10:00',5.88),('10318','2013-04-11','09:15:00',5.96),('10318','2013-04-11','09:20:00',6.12),('10318','2013-04-11','09:25:00',6.28),('10318','2013-04-11','09:30:00',6.57),('10318','2013-04-11','09:35:00',6.77),('10318','2013-04-11','09:40:00',6.96),('10318','2013-04-11','09:45:00',7.11),('10318','2013-04-11','09:50:00',7.01),('10318','2013-04-11','09:55:00',6.9),('10318','2013-04-11','10:00:00',7.83),('10318','2013-04-11','10:05:00',7.15),('10318','2013-04-11','10:10:00',5.91),('10318','2013-04-11','10:15:00',8.14),('10318','2013-04-11','10:20:00',8.4),('10318','2013-04-11','10:25:00',7.78),('10318','2013-04-11','10:30:00',9.11),('10318','2013-04-11','10:35:00',8.43),('10318','2013-04-11','10:40:00',6.04),('10318','2013-04-11','10:45:00',7.66),('10318','2013-04-11','10:50:00',9.1),('10318','2013-04-11','10:55:00',9.48),('10318','2013-04-11','11:00:00',8.5),('10318','2013-04-11','11:05:00',8.9),('10318','2013-04-11','11:10:00',9.77),('10318','2013-04-11','11:15:00',9.96),('10318','2013-04-11','11:20:00',7.97),('10318','2013-04-11','11:25:00',10.31),('10318','2013-04-11','11:30:00',6.12),('10318','2013-04-11','11:35:00',2.53),('10318','2013-04-11','11:40:00',5.45),('10318','2013-04-11','11:45:00',2.19),('10318','2013-04-11','11:50:00',2.17),('10318','2013-04-11','11:55:00',6.04),('10318','2013-04-11','12:00:00',8.9),('10318','2013-04-11','12:05:00',2.61),('10318','2013-04-11','12:10:00',10.54),('10318','2013-04-11','12:15:00',9.26),('10318','2013-04-11','12:20:00',8.9),('10318','2013-04-11','12:25:00',10.25),('10318','2013-04-11','12:30:00',10.27),('10318','2013-04-11','12:35:00',7.26),('10318','2013-04-11','12:40:00',10.48),('10318','2013-04-11','12:45:00',8.78),('10318','2013-04-11','12:50:00',3.74),('10318','2013-04-11','12:55:00',6.11),('10318','2013-04-11','13:00:00',10.07),('10318','2013-04-11','13:05:00',4.48),('10318','2013-04-11','13:10:00',10.15),('10318','2013-04-11','13:15:00',9.42),('10318','2013-04-11','13:20:00',9.81),('10318','2013-04-11','13:25:00',9.7),('10318','2013-04-11','13:30:00',5.18),('10318','2013-04-11','13:35:00',8.71),('10318','2013-04-11','13:40:00',6.64),('10318','2013-04-11','13:45:00',7.97),('10318','2013-04-11','13:50:00',9.38),('10318','2013-04-11','13:55:00',9.31),('10318','2013-04-11','14:00:00',9.17),('10318','2013-04-11','14:05:00',9.14),('10318','2013-04-11','14:10:00',8),('10318','2013-04-11','14:15:00',4.96),('10318','2013-04-11','14:20:00',9.52),('10318','2013-04-11','14:25:00',7.25),('10318','2013-04-11','14:30:00',5.22),('10318','2013-04-11','14:35:00',6.09),('10318','2013-04-11','14:40:00',8.81),('10318','2013-04-11','14:45:00',6.01),('10318','2013-04-11','14:50:00',8.28),('10318','2013-04-11','14:55:00',8.07),('10318','2013-04-11','15:00:00',7.75),('10318','2013-04-11','15:05:00',7.87),('10318','2013-04-11','15:10:00',7.84),('10318','2013-04-11','15:15:00',7.7),('10318','2013-04-11','15:20:00',7.56),('10318','2013-04-11','15:25:00',7.4),('10318','2013-04-11','15:30:00',7.22),('10318','2013-04-11','15:35:00',7.08),('10318','2013-04-11','15:40:00',6.88),('10318','2013-04-11','15:45:00',6.76),('10318','2013-04-11','15:50:00',6.6),('10318','2013-04-11','15:55:00',6.41),('10318','2013-04-11','16:00:00',6.2),('10318','2013-04-11','16:05:00',6.09),('10318','2013-04-11','16:10:00',5.84),('10318','2013-04-11','16:15:00',5.65),('10318','2013-04-11','16:20:00',5.42),('10318','2013-04-11','16:25:00',4.9),('10318','2013-04-11','16:30:00',5.06),('10318','2013-04-11','16:35:00',4.94),('10318','2013-04-11','16:40:00',4.78),('10318','2013-04-11','16:45:00',4.6),('10318','2013-04-11','16:50:00',4.16),('10318','2013-04-11','16:55:00',2.94),('10318','2013-04-11','17:00:00',3.96),('10318','2013-04-11','17:05:00',3.72),('10318','2013-04-11','17:10:00',3.31),('10318','2013-04-11','17:15:00',3.27),('10318','2013-04-11','17:20:00',3.13),('10318','2013-04-11','17:25:00',3.1),('10318','2013-04-11','17:30:00',2.84),('10318','2013-04-11','17:35:00',2.64),('10318','2013-04-11','17:40:00',2.5),('10318','2013-04-11','17:45:00',2.33),('10318','2013-04-11','17:50:00',2.14),('10318','2013-04-11','17:55:00',1.97),('10318','2013-04-11','18:00:00',1.77),('10318','2013-04-11','18:05:00',1.57),('10318','2013-04-11','18:10:00',1.37),('10318','2013-04-11','18:15:00',1.4),('10318','2013-04-11','18:20:00',1.31),('10318','2013-04-11','18:25:00',1.17),('10318','2013-04-10','08:10:00',1.27),('10318','2013-04-10','08:35:00',1.37),('10318','2013-04-10','08:40:00',1.83),('10318','2013-04-10','08:45:00',3.58),('10318','2013-04-10','08:50:00',5.3),('10318','2013-04-10','08:55:00',5.54),('10318','2013-04-10','09:00:00',5.91),('10318','2013-04-10','09:05:00',6.26),('10318','2013-04-10','09:10:00',6.51),('10318','2013-04-10','09:15:00',6.6),('10318','2013-04-10','09:20:00',6.5),('10318','2013-04-10','09:25:00',6.51),('10318','2013-04-10','09:30:00',6.75),('10318','2013-04-10','09:35:00',6.82),('10318','2013-04-10','09:40:00',7.09),('10318','2013-04-10','09:45:00',7.26),('10318','2013-04-10','09:50:00',7.49),('10318','2013-04-10','09:55:00',7.66),('10318','2013-04-10','10:00:00',7.9),('10318','2013-04-10','10:05:00',8.12),('10318','2013-04-10','10:10:00',8.42),('10318','2013-04-10','10:15:00',8.62),('10318','2013-04-10','10:20:00',8.76),('10318','2013-04-10','10:25:00',8.8),('10318','2013-04-10','10:30:00',8.88),('10318','2013-04-10','10:35:00',8.9),('10318','2013-04-10','10:40:00',8.97),('10318','2013-04-10','10:45:00',9.11),('10318','2013-04-10','10:50:00',8.34),('10318','2013-04-10','10:55:00',7.83),('10318','2013-04-10','11:00:00',8.78),('10318','2013-04-10','11:05:00',8.63),('10318','2013-04-10','11:10:00',8.79),('10318','2013-04-10','11:15:00',8.84),('10318','2013-04-10','11:20:00',8.7),('10318','2013-04-10','11:25:00',9.44),('10318','2013-04-10','11:30:00',9.59),('10318','2013-04-10','11:35:00',6.86),('10318','2013-04-10','11:40:00',9.67),('10318','2013-04-10','11:45:00',9.65),('10318','2013-04-10','11:50:00',5.55),('10318','2013-04-10','11:55:00',10.25),('10318','2013-04-10','12:00:00',5.95),('10318','2013-04-10','12:05:00',5.6),('10318','2013-04-10','12:10:00',10.49),('10318','2013-04-10','12:15:00',9.04),('10318','2013-04-10','12:20:00',10.49),('10318','2013-04-10','12:25:00',9.22),('10318','2013-04-10','12:30:00',7.65),('10318','2013-04-10','12:35:00',9.38),('10318','2013-04-10','12:40:00',10.39),('10318','2013-04-10','12:45:00',4.06),('10318','2013-04-10','12:50:00',6.53),('10318','2013-04-10','12:55:00',5.52),('10318','2013-04-10','13:00:00',10.01),('10318','2013-04-10','13:05:00',7.18),('10318','2013-04-10','13:10:00',8.96),('10318','2013-04-10','13:15:00',6.24),('10318','2013-04-10','13:20:00',8.31),('10318','2013-04-10','13:25:00',7.71),('10318','2013-04-10','13:30:00',5.94),('10318','2013-04-10','13:35:00',7.52),('10318','2013-04-10','13:40:00',7.44),('10318','2013-04-10','13:45:00',5.26),('10318','2013-04-10','13:50:00',8.75),('10318','2013-04-10','13:55:00',3.29),('10318','2013-04-10','14:00:00',10.09),('10318','2013-04-10','14:05:00',6.06),('10318','2013-04-10','14:10:00',8.85),('10318','2013-04-10','14:15:00',7.3),('10318','2013-04-10','14:20:00',5.86),('10318','2013-04-10','14:25:00',9.02),('10318','2013-04-10','14:30:00',9.4),('10318','2013-04-10','14:35:00',6.97),('10318','2013-04-10','14:40:00',6.14),('10318','2013-04-10','14:45:00',7.4),('10318','2013-04-10','14:50:00',6.7),('10318','2013-04-10','14:55:00',8.92),('10318','2013-04-10','15:00:00',8.45),('10318','2013-04-10','15:05:00',7.95),('10318','2013-04-10','15:10:00',7.79),('10318','2013-04-10','15:15:00',8.08),('10318','2013-04-10','15:20:00',7.63),('10318','2013-04-10','15:25:00',7.14),('10318','2013-04-10','15:30:00',7.34),('10318','2013-04-10','15:35:00',6.37),('10318','2013-04-10','15:40:00',7.06),('10318','2013-04-10','15:45:00',6.98),('10318','2013-04-10','15:50:00',5.13),('10318','2013-04-10','15:55:00',5.34),('10318','2013-04-10','16:00:00',5.94),('10318','2013-04-10','16:05:00',6.33),('10318','2013-04-10','16:10:00',5.58),('10318','2013-04-10','16:15:00',4.59),('10318','2013-04-10','16:20:00',5.78),('10318','2013-04-10','16:25:00',5.45),('10318','2013-04-10','16:30:00',5.17),('10318','2013-04-10','16:35:00',5.19),('10318','2013-04-10','16:40:00',5.15),('10318','2013-04-10','16:45:00',4.64),('10318','2013-04-10','16:50:00',3.34),('10318','2013-04-10','16:55:00',4.23),('10318','2013-04-10','17:00:00',4.07),('10318','2013-04-10','17:05:00',3.94),('10318','2013-04-10','17:10:00',2.36),('10318','2013-04-10','17:15:00',3.21),('10318','2013-04-10','17:20:00',3),('10318','2013-04-10','17:25:00',2.78),('10318','2013-04-10','17:30:00',3.08),('10318','2013-04-10','17:35:00',2.39),('10318','2013-04-10','17:40:00',1.69),('10318','2013-04-10','17:45:00',2),('10318','2013-04-10','17:50:00',2.53),('10318','2013-04-10','17:55:00',1.53),('10318','2013-04-10','18:00:00',1.86),('10318','2013-04-10','18:05:00',1.11),('10318','2013-04-09','07:30:00',1.06),('10318','2013-04-09','07:35:00',1.2),('10318','2013-04-09','07:40:00',1.03),('10318','2013-04-09','07:45:00',1.03),('10318','2013-04-09','07:50:00',1.8),('10318','2013-04-09','07:55:00',2.41),('10318','2013-04-09','08:00:00',1.18),('10318','2013-04-09','08:05:00',2.53),('10318','2013-04-09','08:10:00',3.36),('10318','2013-04-09','08:15:00',2.87),('10318','2013-04-09','08:20:00',3.09),('10318','2013-04-09','08:25:00',1.98),('10318','2013-04-09','08:30:00',1.96),('10318','2013-04-09','08:35:00',2.1),('10318','2013-04-09','08:40:00',2.46),('10318','2013-04-09','08:45:00',2.2),('10318','2013-04-09','08:50:00',2.04),('10318','2013-04-09','08:55:00',1.97),('10318','2013-04-09','09:00:00',1.88),('10318','2013-04-09','09:05:00',2.12),('10318','2013-04-09','09:10:00',2.28),('10318','2013-04-09','09:15:00',2.36),('10318','2013-04-09','09:20:00',2),('10318','2013-04-09','09:25:00',2.36),('10318','2013-04-09','09:30:00',1.54),('10318','2013-04-09','09:35:00',1.62),('10318','2013-04-09','09:40:00',4.72),('10318','2013-04-09','09:45:00',8),('10318','2013-04-09','09:50:00',8.43),('10318','2013-04-09','09:55:00',5.92),('10318','2013-04-09','10:00:00',1.98),('10318','2013-04-09','10:05:00',2.09),('10318','2013-04-09','10:10:00',3.57),('10318','2013-04-09','10:15:00',3.49),('10318','2013-04-09','10:20:00',2.94),('10318','2013-04-09','10:25:00',6.76),('10318','2013-04-09','10:30:00',9.18),('10318','2013-04-09','10:35:00',9.59),('10318','2013-04-09','10:40:00',5.51),('10318','2013-04-09','10:45:00',6.67),('10318','2013-04-09','10:50:00',7.11),('10318','2013-04-09','10:55:00',2.96),('10318','2013-04-09','11:00:00',8.31),('10318','2013-04-09','11:05:00',7.38),('10318','2013-04-09','11:10:00',3.2),('10318','2013-04-09','11:15:00',10.19),('10318','2013-04-09','11:20:00',7.17),('10318','2013-04-09','11:25:00',3.65),('10318','2013-04-09','11:30:00',6.66),('10318','2013-04-09','11:35:00',7.16),('10318','2013-04-09','11:40:00',8.28),('10318','2013-04-09','11:45:00',5.04),('10318','2013-04-09','11:50:00',2.17),('10318','2013-04-09','11:55:00',8.82),('10318','2013-04-09','12:00:00',9.42),('10318','2013-04-09','12:05:00',5.02),('10318','2013-04-09','12:10:00',4.38),('10318','2013-04-09','12:15:00',7.35),('10318','2013-04-09','12:20:00',10.35),('10318','2013-04-09','12:25:00',10.2),('10318','2013-04-09','12:30:00',8.02),('10318','2013-04-09','12:35:00',10.04),('10318','2013-04-09','12:40:00',9.57),('10318','2013-04-09','12:45:00',9.61),('10318','2013-04-09','12:50:00',7.27),('10318','2013-04-09','12:55:00',7.34),('10318','2013-04-09','13:00:00',4.71),('10318','2013-04-09','13:05:00',2.08),('10318','2013-04-09','13:10:00',3.54),('10318','2013-04-09','13:15:00',10.09),('10318','2013-04-09','13:20:00',7.02),('10318','2013-04-09','13:25:00',9.2),('10318','2013-04-09','13:30:00',8.78),('10318','2013-04-09','13:35:00',8.82),('10318','2013-04-09','13:40:00',6.19),('10318','2013-04-09','13:45:00',9.63),('10318','2013-04-09','13:50:00',9.1),('10318','2013-04-09','13:55:00',8.15),('10318','2013-04-09','14:00:00',8.62),('10318','2013-04-09','14:05:00',8.46),('10318','2013-04-09','14:10:00',7.85),('10318','2013-04-09','14:15:00',7.98),('10318','2013-04-09','14:20:00',7.31),('10318','2013-04-09','14:25:00',7.71),('10318','2013-04-09','14:30:00',6.58),('10318','2013-04-09','14:35:00',3.9),('10318','2013-04-09','14:40:00',8.37),('10318','2013-04-09','14:45:00',7.1),('10318','2013-04-09','14:50:00',8),('10318','2013-04-09','14:55:00',8.2),('10318','2013-04-09','15:00:00',8.56),('10318','2013-04-09','15:05:00',7.85),('10318','2013-04-09','15:10:00',6.89),('10318','2013-04-09','15:15:00',7.66),('10318','2013-04-09','15:20:00',7.34),('10318','2013-04-09','15:25:00',7.89),('10318','2013-04-09','15:30:00',7.68),('10318','2013-04-09','15:35:00',7.48),('10318','2013-04-09','15:40:00',7.26),('10318','2013-04-09','15:45:00',7.23),('10318','2013-04-09','15:50:00',6.86),('10318','2013-04-09','15:55:00',5.17),('10318','2013-04-09','16:00:00',5.61),('10318','2013-04-09','16:05:00',6.65),('10318','2013-04-09','16:10:00',6.26),('10318','2013-04-09','16:15:00',5.72),('10318','2013-04-09','16:20:00',5.2),('10318','2013-04-09','16:25:00',5.86),('10318','2013-04-09','16:30:00',5.32),('10318','2013-04-09','16:35:00',4.96),('10318','2013-04-09','16:40:00',3.51),('10318','2013-04-09','16:45:00',2.9),('10318','2013-04-09','16:50:00',3.25),('10318','2013-04-09','16:55:00',1.77),('10318','2013-04-09','17:00:00',3.21),('10318','2013-04-09','17:05:00',1.65),('10318','2013-04-09','17:10:00',1.63),('10318','2013-04-09','17:15:00',2.01),('10318','2013-04-09','17:20:00',2.33),('10318','2013-04-09','17:25:00',2.04),('10318','2013-04-09','17:30:00',1.87),('10318','2013-04-09','17:35:00',1.82),('10318','2013-04-09','17:40:00',1.31),('10318','2013-04-09','17:45:00',1.28),('10318','2013-04-09','17:50:00',1.07),('10318','2013-04-09','17:55:00',1.13),('10318','2013-04-09','18:00:00',1.34),('10318','2013-04-09','18:05:00',1.3),('10318','2013-04-09','18:10:00',1.16),('10318','2013-04-09','18:15:00',1.64),('10318','2013-04-09','18:20:00',1.32),('10318','2013-04-08','07:45:00',1.03),('10318','2013-04-08','07:50:00',1.02),('10318','2013-04-08','07:55:00',1.22),('10318','2013-04-08','08:00:00',1.37),('10318','2013-04-08','08:05:00',2.2),('10318','2013-04-08','08:10:00',2.24),('10318','2013-04-08','08:15:00',2.4),('10318','2013-04-08','08:20:00',2.03),('10318','2013-04-08','08:25:00',1.72),('10318','2013-04-08','08:30:00',1.78),('10318','2013-04-08','08:35:00',1.94),('10318','2013-04-08','08:40:00',4.02),('10318','2013-04-08','08:45:00',3.18),('10318','2013-04-08','08:50:00',4),('10318','2013-04-08','08:55:00',4.49),('10318','2013-04-08','09:00:00',3.88),('10318','2013-04-08','09:05:00',3.59),('10318','2013-04-08','09:10:00',6.41),('10318','2013-04-08','09:15:00',6.2),('10318','2013-04-08','09:20:00',5.08),('10318','2013-04-08','09:25:00',6.65),('10318','2013-04-08','09:30:00',7.07),('10318','2013-04-08','09:35:00',7.41),('10318','2013-04-08','09:40:00',7.43),('10318','2013-04-08','09:45:00',7.19),('10318','2013-04-08','09:50:00',4.01),('10318','2013-04-08','09:55:00',5.56),('10318','2013-04-08','10:00:00',8.12),('10318','2013-04-08','10:05:00',8.14),('10318','2013-04-08','10:10:00',8.14),('10318','2013-04-08','10:15:00',8.17),('10318','2013-04-08','10:20:00',8.24),('10318','2013-04-08','10:25:00',8.12),('10318','2013-04-08','10:30:00',7.81),('10318','2013-04-08','10:35:00',8.15),('10318','2013-04-08','10:40:00',8.46),('10318','2013-04-08','10:45:00',8.78),('10318','2013-04-08','10:50:00',8.95),('10318','2013-04-08','10:55:00',8.43),('10318','2013-04-08','11:00:00',8.53),('10318','2013-04-08','11:05:00',7.14),('10318','2013-04-08','11:10:00',6.98),('10318','2013-04-08','11:15:00',6.32),('10318','2013-04-08','11:20:00',5.02),('10318','2013-04-08','11:25:00',4.63),('10318','2013-04-08','11:30:00',5.84),('10318','2013-04-08','11:35:00',7.29),('10318','2013-04-08','11:40:00',6.87),('10318','2013-04-08','11:45:00',6.51),('10318','2013-04-08','11:50:00',5.7),('10318','2013-04-08','11:55:00',5.67),('10318','2013-04-08','12:00:00',5.08),('10318','2013-04-08','12:05:00',4.94),('10318','2013-04-08','12:10:00',5.62),('10318','2013-04-08','12:15:00',6.21),('10318','2013-04-08','12:20:00',6.53),('10318','2013-04-08','12:25:00',6.33),('10318','2013-04-08','12:30:00',7.07),('10318','2013-04-08','12:35:00',6.87),('10318','2013-04-08','12:40:00',6.94),('10318','2013-04-08','12:45:00',5.73),('10318','2013-04-08','12:50:00',5.07),('10318','2013-04-08','12:55:00',5.77),('10318','2013-04-08','13:00:00',4.94),('10318','2013-04-08','13:05:00',4.23),('10318','2013-04-08','13:10:00',4.14),('10318','2013-04-08','13:15:00',6.49),('10318','2013-04-08','13:20:00',8.22),('10318','2013-04-08','13:25:00',7.26),('10318','2013-04-08','13:30:00',6.69),('10318','2013-04-08','13:35:00',8.26),('10318','2013-04-08','13:40:00',7.82),('10318','2013-04-08','13:45:00',6.44),('10318','2013-04-08','13:50:00',8.71),('10318','2013-04-08','13:55:00',8.95),('10318','2013-04-08','14:00:00',6.18),('10318','2013-04-08','14:05:00',7.68),('10318','2013-04-08','14:10:00',7.64),('10318','2013-04-08','14:15:00',8.12),('10318','2013-04-08','14:20:00',7.07),('10318','2013-04-08','14:25:00',8.43),('10318','2013-04-08','14:30:00',8.18),('10318','2013-04-08','14:35:00',7.6),('10318','2013-04-08','14:40:00',8.2),('10318','2013-04-08','14:45:00',7.96),('10318','2013-04-08','14:50:00',8.18),('10318','2013-04-08','14:55:00',7.08),('10318','2013-04-08','15:00:00',5.95),('10318','2013-04-08','15:05:00',6.97),('10318','2013-04-08','15:10:00',7.63),('10318','2013-04-08','15:15:00',5.86),('10318','2013-04-08','15:20:00',6.97),('10318','2013-04-08','15:25:00',7.75),('10318','2013-04-08','15:30:00',7.5),('10318','2013-04-08','15:35:00',7.17),('10318','2013-04-08','15:40:00',7.03),('10318','2013-04-08','15:45:00',6.8),('10318','2013-04-08','15:50:00',6.68),('10318','2013-04-08','15:55:00',6.43),('10318','2013-04-08','16:00:00',6.08),('10318','2013-04-08','16:05:00',5.77),('10318','2013-04-08','16:10:00',5.59),('10318','2013-04-08','16:15:00',5.86),('10318','2013-04-08','16:20:00',5.66),('10318','2013-04-08','16:25:00',5.3),('10318','2013-04-08','16:30:00',5.22),('10318','2013-04-08','16:35:00',5.05),('10318','2013-04-08','16:40:00',4.88),('10318','2013-04-08','16:45:00',4.75),('10318','2013-04-08','16:50:00',4.56),('10318','2013-04-08','16:55:00',4.36),('10318','2013-04-08','17:00:00',4.19),('10318','2013-04-08','17:05:00',3.93),('10318','2013-04-08','17:10:00',3.69),('10318','2013-04-08','17:15:00',3.42),('10318','2013-04-08','17:20:00',3.3),('10318','2013-04-08','17:25:00',3.32),('10318','2013-04-08','17:30:00',2.98),('10318','2013-04-08','17:35:00',2.78),('10318','2013-04-08','17:40:00',2.4),('10318','2013-04-08','17:45:00',2.25),('10318','2013-04-08','17:50:00',1.79),('10318','2013-04-08','17:55:00',1.69),('10318','2013-04-08','18:00:00',1.66),('10318','2013-04-08','18:05:00',1.04),('10318','2013-04-08','18:10:00',1.02),('10318','2013-04-08','18:15:00',1.48),('10318','2013-04-08','18:20:00',2.02),('10318','2013-04-08','18:25:00',1.73),('10318','2013-04-07','08:00:00',1.25),('10318','2013-04-07','08:05:00',1.42),('10318','2013-04-07','08:10:00',1.69),('10318','2013-04-07','08:15:00',2),('10318','2013-04-07','08:20:00',2.32),('10318','2013-04-07','08:25:00',2.63),('10318','2013-04-07','08:30:00',2.96),('10318','2013-04-07','08:35:00',3.24),('10318','2013-04-07','08:40:00',3.42),('10318','2013-04-07','08:45:00',3.56),('10318','2013-04-07','08:50:00',3.75),('10318','2013-04-07','08:55:00',3.7),('10318','2013-04-07','09:00:00',3.69),('10318','2013-04-07','09:05:00',3.59),('10318','2013-04-07','09:10:00',3.53),('10318','2013-04-07','09:15:00',3.85),('10318','2013-04-07','09:20:00',4.42),('10318','2013-04-07','09:25:00',4.7),('10318','2013-04-07','09:30:00',4.68),('10318','2013-04-07','09:35:00',4.73),('10318','2013-04-07','09:40:00',4.66),('10318','2013-04-07','09:45:00',4.24),('10318','2013-04-07','09:50:00',4.17),('10318','2013-04-07','09:55:00',5.24),('10318','2013-04-07','10:00:00',5.58),('10318','2013-04-07','10:05:00',6.16),('10318','2013-04-07','10:10:00',6.87),('10318','2013-04-07','10:15:00',7.07),('10318','2013-04-07','10:20:00',7.15),('10318','2013-04-07','10:25:00',7.29),('10318','2013-04-07','10:30:00',7.53),('10318','2013-04-07','10:35:00',6.78),('10318','2013-04-07','10:40:00',6.58),('10318','2013-04-07','10:45:00',6.76),('10318','2013-04-07','10:50:00',6.64),('10318','2013-04-07','10:55:00',6.36),('10318','2013-04-07','11:00:00',5.91),('10318','2013-04-07','11:05:00',5.27),('10318','2013-04-07','11:10:00',4.83),('10318','2013-04-07','11:15:00',4.91),('10318','2013-04-07','11:20:00',6.25),('10318','2013-04-07','11:25:00',8.28),('10318','2013-04-07','11:30:00',8.98),('10318','2013-04-07','11:35:00',9.2),('10318','2013-04-07','11:40:00',8.64),('10318','2013-04-07','11:45:00',7.96),('10318','2013-04-07','11:50:00',6.17),('10318','2013-04-07','11:55:00',5.6),('10318','2013-04-07','12:00:00',6.03),('10318','2013-04-07','12:05:00',5.8),('10318','2013-04-07','12:10:00',5.77),('10318','2013-04-07','12:15:00',6.49),('10318','2013-04-07','12:20:00',6.14),('10318','2013-04-07','12:25:00',7.11),('10318','2013-04-07','12:30:00',7.48),('10318','2013-04-07','12:35:00',6.74),('10318','2013-04-07','12:40:00',7.14),('10318','2013-04-07','12:45:00',6.59),('10318','2013-04-07','12:50:00',6.02),('10318','2013-04-07','12:55:00',6.25),('10318','2013-04-07','13:00:00',6.25),('10318','2013-04-07','13:05:00',7.32),('10318','2013-04-07','13:10:00',7.17),('10318','2013-04-07','13:15:00',7.19),('10318','2013-04-07','13:20:00',6.51),('10318','2013-04-07','13:25:00',6.57),('10318','2013-04-07','13:30:00',6.86),('10318','2013-04-07','13:35:00',6.89),('10318','2013-04-07','13:40:00',7.17),('10318','2013-04-07','13:45:00',6.84),('10318','2013-04-07','13:50:00',5.45),('10318','2013-04-07','13:55:00',5.99),('10318','2013-04-07','14:00:00',6.48),('10318','2013-04-07','14:05:00',7.76),('10318','2013-04-07','14:10:00',8.01),('10318','2013-04-07','14:15:00',6.32),('10318','2013-04-07','14:20:00',3.35),('10318','2013-04-07','14:25:00',2.91),('10318','2013-04-07','14:30:00',3.1),('10318','2013-04-07','14:35:00',2.76),('10318','2013-04-07','14:40:00',2.99),('10318','2013-04-07','14:45:00',2.99),('10318','2013-04-07','14:50:00',3.21),('10318','2013-04-07','14:55:00',2.81),('10318','2013-04-07','15:00:00',2.96),('10318','2013-04-07','15:05:00',3.12),('10318','2013-04-07','15:10:00',4.3),('10318','2013-04-07','15:15:00',5.3),('10318','2013-04-07','15:20:00',5.43),('10318','2013-04-07','15:25:00',5.32),('10318','2013-04-07','15:30:00',5.44),('10318','2013-04-07','15:35:00',5.58),('10318','2013-04-07','15:40:00',5.56),('10318','2013-04-07','15:45:00',5.5),('10318','2013-04-07','15:50:00',5.28),('10318','2013-04-07','15:55:00',4.84),('10318','2013-04-07','16:00:00',4.2),('10318','2013-04-07','16:05:00',3.49),('10318','2013-04-07','16:10:00',3.28),('10318','2013-04-07','16:15:00',3.04),('10318','2013-04-07','16:20:00',2.82),('10318','2013-04-07','16:25:00',3.05),('10318','2013-04-07','16:30:00',3.59),('10318','2013-04-07','16:35:00',3.76),('10318','2013-04-07','16:40:00',4.43),('10318','2013-04-07','16:45:00',4.56),('10318','2013-04-07','16:50:00',3.54),('10318','2013-04-07','16:55:00',3.11),('10318','2013-04-07','17:00:00',3.26),('10318','2013-04-07','17:05:00',3.09),('10318','2013-04-07','17:10:00',3.23),('10318','2013-04-07','17:15:00',2.62),('10318','2013-04-07','17:20:00',3.33),('10318','2013-04-07','17:25:00',3.72),('10318','2013-04-07','17:30:00',3.44),('10318','2013-04-07','17:35:00',3.21),('10318','2013-04-07','17:40:00',3.01),('10318','2013-04-07','17:45:00',2.68),('10318','2013-04-07','17:50:00',2.56),('10318','2013-04-07','17:55:00',2.01),('10318','2013-04-07','18:00:00',1.43),('10318','2013-04-07','18:05:00',1.2),('10318','2013-04-07','18:10:00',1.15),('10318','2013-04-06','07:40:00',1.05),('10318','2013-04-06','07:45:00',1.24),('10318','2013-04-06','07:50:00',1.54),('10318','2013-04-06','07:55:00',2.2),('10318','2013-04-06','08:00:00',2.46),('10318','2013-04-06','08:05:00',2.73),('10318','2013-04-06','08:10:00',3.29),('10318','2013-04-06','08:15:00',3.57),('10318','2013-04-06','08:20:00',3.69),('10318','2013-04-06','08:25:00',4.03),('10318','2013-04-06','08:30:00',4.27),('10318','2013-04-06','08:35:00',4.46),('10318','2013-04-06','08:40:00',4.68),('10318','2013-04-06','08:45:00',4.87),('10318','2013-04-06','08:50:00',5.08),('10318','2013-04-06','08:55:00',5.29),('10318','2013-04-06','09:00:00',5.5),('10318','2013-04-06','09:05:00',5.7),('10318','2013-04-06','09:10:00',5.9),('10318','2013-04-06','09:15:00',6.08),('10318','2013-04-06','09:20:00',6.19),('10318','2013-04-06','09:25:00',6.4),('10318','2013-04-06','09:30:00',6.57),('10318','2013-04-06','09:35:00',6.54),('10318','2013-04-06','09:40:00',6.89),('10318','2013-04-06','09:45:00',7.04),('10318','2013-04-06','09:50:00',7.17),('10318','2013-04-06','09:55:00',7.3),('10318','2013-04-06','10:00:00',7.44),('10318','2013-04-06','10:05:00',7.42),('10318','2013-04-06','10:10:00',7.77),('10318','2013-04-06','10:15:00',7.93),('10318','2013-04-06','10:20:00',8.13),('10318','2013-04-06','10:25:00',8.26),('10318','2013-04-06','10:30:00',8.29),('10318','2013-04-06','10:35:00',8.29),('10318','2013-04-06','10:40:00',8.36),('10318','2013-04-06','10:45:00',8.47),('10318','2013-04-06','10:50:00',8.51),('10318','2013-04-06','10:55:00',8.51),('10318','2013-04-06','11:00:00',8.65),('10318','2013-04-06','11:05:00',8.8),('10318','2013-04-06','11:10:00',8.9),('10318','2013-04-06','11:15:00',8.93),('10318','2013-04-06','11:20:00',9.01),('10318','2013-04-06','11:25:00',9.1),('10318','2013-04-06','11:30:00',9.23),('10318','2013-04-06','11:35:00',6.88),('10318','2013-04-06','11:40:00',5.48),('10318','2013-04-06','11:45:00',9.55),('10318','2013-04-06','11:50:00',9.35),('10318','2013-04-06','11:55:00',9.18),('10318','2013-04-06','12:00:00',9.28),('10318','2013-04-06','12:05:00',9.41),('10318','2013-04-06','12:10:00',9.46),('10318','2013-04-06','12:15:00',9.57),('10318','2013-04-06','12:20:00',9.47),('10318','2013-04-06','12:25:00',8.57),('10318','2013-04-06','12:30:00',6.36),('10318','2013-04-06','12:35:00',9.44),('10318','2013-04-06','12:40:00',7.26),('10318','2013-04-06','12:45:00',7.87),('10318','2013-04-06','12:50:00',10.11),('10318','2013-04-06','12:55:00',10.15),('10318','2013-04-06','13:00:00',9.07),('10318','2013-04-06','13:05:00',4.82),('10318','2013-04-06','13:10:00',4.85),('10318','2013-04-06','13:15:00',9.31),('10318','2013-04-06','13:20:00',7.51),('10318','2013-04-06','13:25:00',7.6),('10318','2013-04-06','13:30:00',10.32),('10318','2013-04-06','13:35:00',9.77),('10318','2013-04-06','13:40:00',2.75),('10318','2013-04-06','13:45:00',3.84),('10318','2013-04-06','13:50:00',2.82),('10318','2013-04-06','13:55:00',3.18),('10318','2013-04-06','14:00:00',8.41),('10318','2013-04-06','14:05:00',3.13),('10318','2013-04-06','14:10:00',2.71),('10318','2013-04-06','14:15:00',4.2),('10318','2013-04-06','14:20:00',9.7),('10318','2013-04-06','14:25:00',8.96),('10318','2013-04-06','14:30:00',8.9),('10318','2013-04-06','14:35:00',8.7),('10318','2013-04-06','14:40:00',8.43),('10318','2013-04-06','14:45:00',8.4),('10318','2013-04-06','14:50:00',8.28),('10318','2013-04-06','14:55:00',8.2),('10318','2013-04-06','15:00:00',8.3),('10318','2013-04-06','15:05:00',7.77),('10318','2013-04-06','15:10:00',7.52),('10318','2013-04-06','15:15:00',7.4),('10318','2013-04-06','15:20:00',7.24),('10318','2013-04-06','15:25:00',7.05),('10318','2013-04-06','15:30:00',6.86),('10318','2013-04-06','15:35:00',6.79),('10318','2013-04-06','15:40:00',6.64),('10318','2013-04-06','15:45:00',6.47),('10318','2013-04-06','15:50:00',6.52),('10318','2013-04-06','15:55:00',6.43),('10318','2013-04-06','16:00:00',6.25),('10318','2013-04-06','16:05:00',5.96),('10318','2013-04-06','16:10:00',6.02),('10318','2013-04-06','16:15:00',5.74),('10318','2013-04-06','16:20:00',5.15),('10318','2013-04-06','16:25:00',4.42),('10318','2013-04-06','16:30:00',3.74),('10318','2013-04-06','16:35:00',3.68),('10318','2013-04-06','16:40:00',4.05),('10318','2013-04-06','16:45:00',4.88),('10318','2013-04-06','16:50:00',4.71),('10318','2013-04-06','16:55:00',4.38),('10318','2013-04-06','17:00:00',3.37),('10318','2013-04-06','17:05:00',2.67),('10318','2013-04-06','17:10:00',2.39),('10318','2013-04-06','17:15:00',2.18),('10318','2013-04-06','17:20:00',2.09),('10318','2013-04-06','17:25:00',2.05),('10318','2013-04-06','17:30:00',2.08),('10318','2013-04-06','17:35:00',2),('10318','2013-04-06','17:40:00',1.68),('10318','2013-04-06','17:45:00',1.57),('10318','2013-04-06','17:50:00',1.52),('10318','2013-04-06','17:55:00',1.39),('10318','2013-04-06','18:00:00',1.27),('10318','2013-04-06','18:05:00',1.2),('10318','2013-04-06','18:10:00',1.09),('10318','2013-04-05','07:45:00',1.28),('10318','2013-04-05','07:50:00',1.33),('10318','2013-04-05','07:55:00',1.74),('10318','2013-04-05','08:00:00',2.29),('10318','2013-04-05','08:05:00',2.93),('10318','2013-04-05','08:10:00',3.57),('10318','2013-04-05','08:15:00',4.39),('10318','2013-04-05','08:20:00',2.09),('10318','2013-04-05','08:25:00',1.34),('10318','2013-04-05','08:30:00',1.23),('10318','2013-04-05','08:35:00',1.06),('10318','2013-04-05','08:40:00',5.08),('10318','2013-04-05','08:45:00',4.66),('10318','2013-04-05','08:50:00',5),('10318','2013-04-05','08:55:00',3.94),('10318','2013-04-05','09:00:00',5.62),('10318','2013-04-05','09:05:00',2.64),('10318','2013-04-05','09:10:00',4.08),('10318','2013-04-05','09:15:00',5.02),('10318','2013-04-05','09:20:00',3.35),('10318','2013-04-05','09:25:00',2.02),('10318','2013-04-05','09:30:00',3.39),('10318','2013-04-05','09:35:00',4.9),('10318','2013-04-05','09:40:00',3.26),('10318','2013-04-05','09:45:00',4.35),('10318','2013-04-05','09:50:00',3.75),('10318','2013-04-05','09:55:00',5.13),('10318','2013-04-05','10:00:00',2.01),('10318','2013-04-05','10:05:00',3.06),('10318','2013-04-05','10:10:00',5.53),('10318','2013-04-05','10:15:00',5.94),('10318','2013-04-05','10:20:00',8.55),('10318','2013-04-05','10:25:00',8.23),('10318','2013-04-05','10:30:00',6.33),('10318','2013-04-05','10:35:00',4.91),('10318','2013-04-05','10:40:00',3.54),('10318','2013-04-05','10:45:00',5.38),('10318','2013-04-05','10:50:00',5.74),('10318','2013-04-05','10:55:00',8.97),('10318','2013-04-05','11:00:00',4.52),('10318','2013-04-05','11:05:00',8.78),('10318','2013-04-05','11:10:00',9.67),('10318','2013-04-05','11:15:00',9.96),('10318','2013-04-05','11:20:00',9.28),('10318','2013-04-05','11:25:00',9.65),('10318','2013-04-05','11:30:00',9.4),('10318','2013-04-05','11:35:00',8.31),('10318','2013-04-05','11:40:00',8.61),('10318','2013-04-05','11:45:00',9.94),('10318','2013-04-05','11:50:00',9.87),('10318','2013-04-05','11:55:00',10.35),('10318','2013-04-05','12:00:00',5.27),('10318','2013-04-05','12:05:00',6.57),('10318','2013-04-05','12:10:00',8.5),('10318','2013-04-05','12:15:00',6.39),('10318','2013-04-05','12:20:00',6.87),('10318','2013-04-05','12:25:00',6.95),('10318','2013-04-05','12:30:00',4.18),('10318','2013-04-05','12:35:00',3.88),('10318','2013-04-05','12:40:00',2.94),('10318','2013-04-05','12:45:00',5.32),('10318','2013-04-05','12:50:00',7.09),('10318','2013-04-05','12:55:00',10.43),('10318','2013-04-05','13:00:00',7.95),('10318','2013-04-05','13:05:00',5.61),('10318','2013-04-05','13:10:00',9.86),('10318','2013-04-05','13:15:00',9.25),('10318','2013-04-05','13:20:00',7.58),('10318','2013-04-05','13:25:00',10.13),('10318','2013-04-05','13:30:00',10.2),('10318','2013-04-05','13:35:00',6.53),('10318','2013-04-05','13:40:00',8.83),('10318','2013-04-05','13:45:00',8.76),('10318','2013-04-05','13:50:00',5.25),('10318','2013-04-05','13:55:00',6.88),('10318','2013-04-05','14:00:00',5.62),('10318','2013-04-05','14:05:00',8.31),('10318','2013-04-05','14:10:00',6.57),('10318','2013-04-05','14:15:00',4.99),('10318','2013-04-05','14:20:00',5.18),('10318','2013-04-05','14:25:00',6.88),('10318','2013-04-05','14:30:00',6.35),('10318','2013-04-05','14:35:00',9.02),('10318','2013-04-05','14:40:00',9.52),('10318','2013-04-05','14:45:00',8.15),('10318','2013-04-05','14:50:00',5.62),('10318','2013-04-05','14:55:00',4.09),('10318','2013-04-05','15:00:00',5.55),('10318','2013-04-05','15:05:00',4.16),('10318','2013-04-05','15:10:00',3.01),('10318','2013-04-05','15:15:00',3.65),('10318','2013-04-05','15:20:00',2.95),('10318','2013-04-05','15:25:00',2.77),('10318','2013-04-05','15:30:00',2.31),('10318','2013-04-05','15:35:00',2),('10318','2013-04-05','15:40:00',2.03),('10318','2013-04-05','15:45:00',2.52),('10318','2013-04-05','15:50:00',2.89),('10318','2013-04-05','15:55:00',2.97),('10318','2013-04-05','16:00:00',3.09),('10318','2013-04-05','16:05:00',3.22),('10318','2013-04-05','16:10:00',3.51),('10318','2013-04-05','16:15:00',2.88),('10318','2013-04-05','16:20:00',2.68),('10318','2013-04-05','16:25:00',2.65),('10318','2013-04-05','16:30:00',2.99),('10318','2013-04-05','16:35:00',2.68),('10318','2013-04-05','16:40:00',2.99),('10318','2013-04-05','16:45:00',5.45),('10318','2013-04-05','16:50:00',3.98),('10318','2013-04-05','16:55:00',4.23),('10318','2013-04-05','17:00:00',2.9),('10318','2013-04-05','17:05:00',3.69),('10318','2013-04-05','17:10:00',4.95),('10318','2013-04-05','17:15:00',2.79),('10318','2013-04-05','17:20:00',2.25),('10318','2013-04-05','17:25:00',4.01),('10318','2013-04-05','17:30:00',1.63),('10318','2013-04-05','17:35:00',2.6),('10318','2013-04-05','17:40:00',1.13),('10318','2013-04-05','17:45:00',2.17),('10318','2013-04-05','17:50:00',2.65),('10318','2013-04-05','17:55:00',2.44),('10318','2013-04-05','18:00:00',2.31),('10318','2013-04-05','18:05:00',1.57),('10318','2013-04-05','18:10:00',1.95),('10318','2013-04-05','18:15:00',1.07),('10318','2013-04-05','18:20:00',1.49),('10318','2013-04-05','18:25:00',1.16),('10318','2013-04-04','07:55:00',1.16),('10318','2013-04-04','08:00:00',1.46),('10318','2013-04-04','08:05:00',1.5),('10318','2013-04-04','08:10:00',1.31),('10318','2013-04-04','08:15:00',1.35),('10318','2013-04-04','08:20:00',1.44),('10318','2013-04-04','08:25:00',1.47),('10318','2013-04-04','08:30:00',1.71),('10318','2013-04-04','08:35:00',2.05),('10318','2013-04-04','08:40:00',1.89),('10318','2013-04-04','08:45:00',1.85),('10318','2013-04-04','08:50:00',2.47),('10318','2013-04-04','08:55:00',3.26),('10318','2013-04-04','09:00:00',5.35),('10318','2013-04-04','09:05:00',2.74),('10318','2013-04-04','09:10:00',2.91),('10318','2013-04-04','09:15:00',2.88),('10318','2013-04-04','09:20:00',3.04),('10318','2013-04-04','09:25:00',2.38),('10318','2013-04-04','09:30:00',4.48),('10318','2013-04-04','09:35:00',6.53),('10318','2013-04-04','09:40:00',4.83),('10318','2013-04-04','09:45:00',4.13),('10318','2013-04-04','09:50:00',2.5),('10318','2013-04-04','09:55:00',3.03),('10318','2013-04-04','10:00:00',4.76),('10318','2013-04-04','10:05:00',5.81),('10318','2013-04-04','10:10:00',4.86),('10318','2013-04-04','10:15:00',3.76),('10318','2013-04-04','10:20:00',4.31),('10318','2013-04-04','10:25:00',8.51),('10318','2013-04-04','10:30:00',6.52),('10318','2013-04-04','10:35:00',6.43),('10318','2013-04-04','10:40:00',8.29),('10318','2013-04-04','10:45:00',4.56),('10318','2013-04-04','10:50:00',6.95),('10318','2013-04-04','10:55:00',7.79),('10318','2013-04-04','11:00:00',3.87),('10318','2013-04-04','11:05:00',2.59),('10318','2013-04-04','11:10:00',2.59),('10318','2013-04-04','11:15:00',3.55),('10318','2013-04-04','11:20:00',2.78),('10318','2013-04-04','11:25:00',2.45),('10318','2013-04-04','11:30:00',2.72),('10318','2013-04-04','11:35:00',4.2),('10318','2013-04-04','11:40:00',7.04),('10318','2013-04-04','11:45:00',7.69),('10318','2013-04-04','11:50:00',8.92),('10318','2013-04-04','11:55:00',8.76),('10318','2013-04-04','12:00:00',7.53),('10318','2013-04-04','12:05:00',9.48),('10318','2013-04-04','12:10:00',9.01),('10318','2013-04-04','12:15:00',6.55),('10318','2013-04-04','12:20:00',4.79),('10318','2013-04-04','12:25:00',6.2),('10318','2013-04-04','12:30:00',7.77),('10318','2013-04-04','12:35:00',7.24),('10318','2013-04-04','12:40:00',9.84),('10318','2013-04-04','12:45:00',7.42),('10318','2013-04-04','12:50:00',7.64),('10318','2013-04-04','12:55:00',6.41),('10318','2013-04-04','13:00:00',4.04),('10318','2013-04-04','13:05:00',6.93),('10318','2013-04-04','13:10:00',9.53),('10318','2013-04-04','13:15:00',9.35),('10318','2013-04-04','13:20:00',9.13),('10318','2013-04-04','13:25:00',9.54),('10318','2013-04-04','13:30:00',8.94),('10318','2013-04-04','13:35:00',8.06),('10318','2013-04-04','13:40:00',7.38),('10318','2013-04-04','13:45:00',7.38),('10318','2013-04-04','13:50:00',6.98),('10318','2013-04-04','13:55:00',5.24),('10318','2013-04-04','14:00:00',6.12),('10318','2013-04-04','14:05:00',8.01),('10318','2013-04-04','14:10:00',8.79),('10318','2013-04-04','14:15:00',8.39),('10318','2013-04-04','14:20:00',8.22),('10318','2013-04-04','14:25:00',8.07),('10318','2013-04-04','14:30:00',8.17),('10318','2013-04-04','14:35:00',8.09),('10318','2013-04-04','14:40:00',8),('10318','2013-04-04','14:45:00',7.79),('10318','2013-04-04','14:50:00',7.7),('10318','2013-04-04','14:55:00',7.58),('10318','2013-04-04','15:00:00',7.5),('10318','2013-04-04','15:05:00',7.24),('10318','2013-04-04','15:10:00',6.48),('10318','2013-04-04','15:15:00',6.73),('10318','2013-04-04','15:20:00',6.72),('10318','2013-04-04','15:25:00',6.99),('10318','2013-04-04','15:30:00',6.76),('10318','2013-04-04','15:35:00',6.54),('10318','2013-04-04','15:40:00',6.35),('10318','2013-04-04','15:45:00',6.23),('10318','2013-04-04','15:50:00',6.06),('10318','2013-04-04','15:55:00',5.9),('10318','2013-04-04','16:00:00',5.73),('10318','2013-04-04','16:05:00',5.53),('10318','2013-04-04','16:10:00',5.22),('10318','2013-04-04','16:15:00',4.97),('10318','2013-04-04','16:20:00',4.61),('10318','2013-04-04','16:25:00',5.04),('10318','2013-04-04','16:30:00',4.32),('10318','2013-04-04','16:35:00',3.73),('10318','2013-04-04','16:40:00',4.12),('10318','2013-04-04','16:45:00',2.94),('10318','2013-04-04','16:50:00',3.44),('10318','2013-04-04','16:55:00',3.57),('10318','2013-04-04','17:00:00',3.32),('10318','2013-04-04','17:05:00',3.25),('10318','2013-04-04','17:10:00',2.61),('10318','2013-04-04','17:15:00',2.67),('10318','2013-04-04','17:20:00',2.05),('10318','2013-04-04','17:25:00',2.2),('10318','2013-04-04','17:30:00',1.53),('10318','2013-04-04','17:35:00',1.54),('10318','2013-04-04','17:40:00',1.74),('10318','2013-04-04','17:45:00',1.65),('10318','2013-04-04','17:50:00',1.84),('10318','2013-04-04','17:55:00',2.18),('10318','2013-04-04','18:00:00',2.01),('10318','2013-04-04','18:05:00',1.62),('10318','2013-04-03','07:45:00',1.03),('10318','2013-04-03','07:50:00',1.22),('10318','2013-04-03','07:55:00',1.44),('10318','2013-04-03','08:00:00',2.27),('10318','2013-04-03','08:05:00',2.73),('10318','2013-04-03','08:10:00',2.86),('10318','2013-04-03','08:15:00',3.61),('10318','2013-04-03','08:20:00',3.84),('10318','2013-04-03','08:25:00',3.99),('10318','2013-04-03','08:30:00',3.56),('10318','2013-04-03','08:35:00',3.53),('10318','2013-04-03','08:40:00',4.14),('10318','2013-04-03','08:45:00',4.98),('10318','2013-04-03','08:50:00',5.22),('10318','2013-04-03','08:55:00',5.41),('10318','2013-04-03','09:00:00',5.6),('10318','2013-04-03','09:05:00',5.94),('10318','2013-04-03','09:10:00',6.07),('10318','2013-04-03','09:15:00',5.04),('10318','2013-04-03','09:20:00',5.58),('10318','2013-04-03','09:25:00',7.61),('10318','2013-04-03','09:30:00',6.62),('10318','2013-04-03','09:35:00',6.05),('10318','2013-04-03','09:40:00',7.09),('10318','2013-04-03','09:45:00',6.43),('10318','2013-04-03','09:50:00',7.78),('10318','2013-04-03','09:55:00',6.54),('10318','2013-04-03','10:00:00',3.04),('10318','2013-04-03','10:05:00',2.95),('10318','2013-04-03','10:10:00',4.36),('10318','2013-04-03','10:15:00',3.54),('10318','2013-04-03','10:20:00',8.38),('10318','2013-04-03','10:25:00',5.79),('10318','2013-04-03','10:30:00',4.82),('10318','2013-04-03','10:35:00',4.18),('10318','2013-04-03','10:40:00',3.73),('10318','2013-04-03','10:45:00',5.29),('10318','2013-04-03','10:50:00',5.15),('10318','2013-04-03','10:55:00',9.11),('10318','2013-04-03','11:00:00',7.43),('10318','2013-04-03','11:05:00',10.09),('10318','2013-04-03','11:10:00',7.64),('10318','2013-04-03','11:15:00',6.13),('10318','2013-04-03','11:20:00',4.84),('10318','2013-04-03','11:25:00',3.43),('10318','2013-04-03','11:30:00',3.69),('10318','2013-04-03','11:35:00',2.66),('10318','2013-04-03','11:40:00',4.38),('10318','2013-04-03','11:45:00',6.19),('10318','2013-04-03','11:50:00',5.89),('10318','2013-04-03','11:55:00',4.4),('10318','2013-04-03','12:00:00',8.23),('10318','2013-04-03','12:05:00',5.28),('10318','2013-04-03','12:10:00',3.76),('10318','2013-04-03','12:15:00',7.09),('10318','2013-04-03','12:20:00',10.39),('10318','2013-04-03','12:25:00',8.19),('10318','2013-04-03','12:30:00',7.8),('10318','2013-04-03','12:35:00',7.47),('10318','2013-04-03','12:40:00',8.63),('10318','2013-04-03','12:45:00',9.15),('10318','2013-04-03','12:50:00',7.48),('10318','2013-04-03','12:55:00',9.43),('10318','2013-04-03','13:00:00',9.78),('10318','2013-04-03','13:05:00',5.07),('10318','2013-04-03','13:10:00',7.64),('10318','2013-04-03','13:15:00',7.2),('10318','2013-04-03','13:20:00',8.27),('10318','2013-04-03','13:25:00',8.56),('10318','2013-04-03','13:30:00',7.98),('10318','2013-04-03','13:35:00',8.27),('10318','2013-04-03','13:40:00',9.94),('10318','2013-04-03','13:45:00',10.09),('10318','2013-04-03','13:50:00',6.4),('10318','2013-04-03','13:55:00',8.06),('10318','2013-04-03','14:00:00',8.62),('10318','2013-04-03','14:05:00',9.82),('10318','2013-04-03','14:10:00',5.98),('10318','2013-04-03','14:15:00',4.75),('10318','2013-04-03','14:20:00',9.69),('10318','2013-04-03','14:25:00',8.14),('10318','2013-04-03','14:30:00',5.81),('10318','2013-04-03','14:35:00',9.33),('10318','2013-04-03','14:40:00',8.16),('10318','2013-04-03','14:45:00',8.3),('10318','2013-04-03','14:50:00',8.45),('10318','2013-04-03','14:55:00',8.84),('10318','2013-04-03','15:00:00',8.56),('10318','2013-04-03','15:05:00',8.79),('10318','2013-04-03','15:10:00',7.75),('10318','2013-04-03','15:15:00',6.84),('10318','2013-04-03','15:20:00',7.52),('10318','2013-04-03','15:25:00',6.7),('10318','2013-04-03','15:30:00',6.75),('10318','2013-04-03','15:35:00',6.44),('10318','2013-04-03','15:40:00',5.73),('10318','2013-04-03','15:45:00',3.43),('10318','2013-04-03','15:50:00',4.76),('10318','2013-04-03','15:55:00',7.35),('10318','2013-04-03','16:00:00',6.68),('10318','2013-04-03','16:05:00',6.42),('10318','2013-04-03','16:10:00',6.37),('10318','2013-04-03','16:15:00',6.2),('10318','2013-04-03','16:20:00',4.93),('10318','2013-04-03','16:25:00',4.86),('10318','2013-04-03','16:30:00',5.23),('10318','2013-04-03','16:35:00',4.64),('10318','2013-04-03','16:40:00',4.89),('10318','2013-04-03','16:45:00',4.83),('10318','2013-04-03','16:50:00',4.64),('10318','2013-04-03','16:55:00',4.45),('10318','2013-04-03','17:00:00',4.24),('10318','2013-04-03','17:05:00',4.08),('10318','2013-04-03','17:10:00',3.84),('10318','2013-04-03','17:15:00',3.54),('10318','2013-04-03','17:20:00',3.42),('10318','2013-04-03','17:25:00',3.19),('10318','2013-04-03','17:30:00',3),('10318','2013-04-03','17:35:00',2.79),('10318','2013-04-03','17:40:00',2.62),('10318','2013-04-03','17:45:00',2.44),('10318','2013-04-03','17:50:00',2.23),('10318','2013-04-03','17:55:00',2.04),('10318','2013-04-03','18:00:00',1.86),('10318','2013-04-03','18:05:00',1.54),('10318','2013-04-03','18:10:00',1.51),('10318','2013-04-03','18:15:00',1.37),('10318','2013-04-03','18:20:00',1.22),('10318','2013-04-03','18:25:00',1.07),('10318','2013-04-02','08:30:00',1.61),('10318','2013-04-02','08:35:00',1.85),('10318','2013-04-02','08:40:00',4.24),('10318','2013-04-02','08:45:00',4.98),('10318','2013-04-02','08:50:00',3.18),('10318','2013-04-02','08:55:00',2.56),('10318','2013-04-02','09:00:00',5.56),('10318','2013-04-02','09:05:00',5.81),('10318','2013-04-02','09:10:00',5.96),('10318','2013-04-02','09:15:00',6.22),('10318','2013-04-02','09:20:00',6.35),('10318','2013-04-02','09:25:00',6.6),('10318','2013-04-02','09:30:00',5.63),('10318','2013-04-02','09:35:00',5.81),('10318','2013-04-02','09:40:00',6.43),('10318','2013-04-02','09:45:00',5.38),('10318','2013-04-02','09:50:00',5.26),('10318','2013-04-02','09:55:00',7.31),('10318','2013-04-02','10:00:00',6.53),('10318','2013-04-02','10:05:00',3.87),('10318','2013-04-02','10:10:00',5.56),('10318','2013-04-02','10:15:00',3.26),('10318','2013-04-02','10:20:00',6.76),('10318','2013-04-02','10:25:00',7.24),('10318','2013-04-02','10:30:00',7.44),('10318','2013-04-02','10:35:00',9.05),('10318','2013-04-02','10:40:00',8.18),('10318','2013-04-02','10:45:00',2.68),('10318','2013-04-02','10:50:00',9.04),('10318','2013-04-02','10:55:00',2.64),('10318','2013-04-02','11:00:00',7.26),('10318','2013-04-02','11:05:00',6.44),('10318','2013-04-02','11:10:00',3.43),('10318','2013-04-02','11:15:00',3.03),('10318','2013-04-02','11:20:00',7.67),('10318','2013-04-02','11:25:00',7),('10318','2013-04-02','11:30:00',8.43),('10318','2013-04-02','11:35:00',6.02),('10318','2013-04-02','11:40:00',6.1),('10318','2013-04-02','11:45:00',4.43),('10318','2013-04-02','11:50:00',2.72),('10318','2013-04-02','11:55:00',1.71),('10318','2013-04-02','12:00:00',2.39),('10318','2013-04-02','12:05:00',6.68),('10318','2013-04-02','12:10:00',9.33),('10318','2013-04-02','12:15:00',4.38),('10318','2013-04-02','12:20:00',1.39),('10318','2013-04-02','12:25:00',1.29),('10318','2013-04-02','12:30:00',2.74),('10318','2013-04-02','12:35:00',7.07),('10318','2013-04-02','12:40:00',4.52),('10318','2013-04-02','12:45:00',5.89),('10318','2013-04-02','12:50:00',5.25),('10318','2013-04-02','12:55:00',7.46),('10318','2013-04-02','13:00:00',6.39),('10318','2013-04-02','13:05:00',7.36),('10318','2013-04-02','13:10:00',5.07),('10318','2013-04-02','13:15:00',5.81),('10318','2013-04-02','13:20:00',3.9),('10318','2013-04-02','13:25:00',4.56),('10318','2013-04-02','13:30:00',4.9),('10318','2013-04-02','13:35:00',4.87),('10318','2013-04-02','13:40:00',7.68),('10318','2013-04-02','13:45:00',5.6),('10318','2013-04-02','13:50:00',4.57),('10318','2013-04-02','13:55:00',3.59),('10318','2013-04-02','14:00:00',4.89),('10318','2013-04-02','14:05:00',5.97),('10318','2013-04-02','14:10:00',5.98),('10318','2013-04-02','14:15:00',5.85),('10318','2013-04-02','14:20:00',7.35),('10318','2013-04-02','14:25:00',8.76),('10318','2013-04-02','14:30:00',6.39),('10318','2013-04-02','14:35:00',4.6),('10318','2013-04-02','14:40:00',8.23),('10318','2013-04-02','14:45:00',7.07),('10318','2013-04-02','14:50:00',3.5),('10318','2013-04-02','14:55:00',3.44),('10318','2013-04-02','15:00:00',2.76),('10318','2013-04-02','15:05:00',1.84),('10318','2013-04-02','15:10:00',1.81),('10318','2013-04-02','15:15:00',2.32),('10318','2013-04-02','15:20:00',2.55),('10318','2013-04-02','15:25:00',1.05),('10318','2013-04-02','15:35:00',1.88),('10318','2013-04-02','15:40:00',2.12),('10318','2013-04-02','15:45:00',2.48),('10318','2013-04-02','15:50:00',1.95),('10318','2013-04-02','15:55:00',2.23),('10318','2013-04-02','16:00:00',2.65),('10318','2013-04-02','16:05:00',2.57),('10318','2013-04-02','16:10:00',1.93),('10318','2013-04-02','16:15:00',2.3),('10318','2013-04-02','16:20:00',2.09),('10318','2013-04-02','16:25:00',1.94),('10318','2013-04-02','16:30:00',2.18),('10318','2013-04-02','16:35:00',2.01),('10318','2013-04-02','16:40:00',1.95),('10318','2013-04-02','16:45:00',1.57),('10318','2013-04-02','16:55:00',1.32),('10318','2013-04-02','17:00:00',1.68),('10318','2013-04-02','17:05:00',1.39),('10318','2013-04-02','17:10:00',1.11),('10318','2013-04-02','17:15:00',1.03),('10318','2013-04-02','17:35:00',1.28),('10318','2013-04-02','17:40:00',1.78),('10318','2013-04-02','17:45:00',2.31),('10318','2014-05-02','07:05:00',1.08),('10318','2014-05-02','07:10:00',1.33),('10318','2014-05-02','07:30:00',1.18),('10318','2014-05-02','07:35:00',2.84),('10318','2014-05-02','07:40:00',3.14),('10318','2014-05-02','07:45:00',3.29),('10318','2014-05-02','07:50:00',3.8),('10318','2014-05-02','07:55:00',4.04),('10318','2014-05-02','08:00:00',3.9),('10318','2014-05-02','08:05:00',3.69),('10318','2014-05-02','08:10:00',3.07),('10318','2014-05-02','08:15:00',2.71),('10318','2014-05-02','08:20:00',1.79),('10318','2014-05-02','08:25:00',1.77),('10318','2014-05-02','08:30:00',1.64),('10318','2014-05-02','08:35:00',1.77),('10318','2014-05-02','08:40:00',2.69),('10318','2014-05-02','08:45:00',3.79),('10318','2014-05-02','08:50:00',1.93),('10318','2014-05-02','08:55:00',1.9),('10318','2014-05-02','09:00:00',2.33),('10318','2014-05-02','09:05:00',2.54),('10318','2014-05-02','09:10:00',2.73),('10318','2014-05-02','09:15:00',4.27),('10318','2014-05-02','09:20:00',4.94),('10318','2014-05-02','09:25:00',4.16),('10318','2014-05-02','09:30:00',4.16),('10318','2014-05-02','09:35:00',5.41),('10318','2014-05-02','09:40:00',5.27),('10318','2014-05-02','09:45:00',3.14),('10318','2014-05-02','09:50:00',3.39),('10318','2014-05-02','09:55:00',3.82),('10318','2014-05-02','10:00:00',5.72),('10318','2014-05-02','10:05:00',4.26),('10318','2014-05-02','10:10:00',2.81),('10318','2014-05-02','10:15:00',2.92),('10318','2014-05-02','10:20:00',2.47),('10318','2014-05-02','10:25:00',2.22),('10318','2014-05-02','10:30:00',2.13),('10318','2014-05-02','10:35:00',2.29),('10318','2014-05-02','10:40:00',2.54),('10318','2014-05-02','10:45:00',2.72),('10318','2014-05-02','10:50:00',2.37),('10318','2014-05-02','10:55:00',1.62),('10318','2014-05-02','11:00:00',1.46),('10318','2014-05-02','11:05:00',1.37),('10318','2014-05-02','11:10:00',1.3),('10318','2014-05-02','11:50:00',1.07),('10318','2014-05-02','12:15:00',1.24),('10318','2014-05-02','12:20:00',1.77),('10318','2014-05-02','12:25:00',2.15),('10318','2014-05-02','12:30:00',2.04),('10318','2014-05-02','12:35:00',2.49),('10318','2014-05-02','12:40:00',3.56),('10318','2014-05-02','12:45:00',4.23),('10318','2014-05-02','12:50:00',4.47),('10318','2014-05-02','12:55:00',4.22),('10318','2014-05-02','13:00:00',4.72),('10318','2014-05-02','13:05:00',4.91),('10318','2014-05-02','13:10:00',5.72),('10318','2014-05-02','13:15:00',9.3),('10318','2014-05-02','13:20:00',7.04),('10318','2014-05-02','13:25:00',9.35),('10318','2014-05-02','13:30:00',8.5),('10318','2014-05-02','13:35:00',7.25),('10318','2014-05-02','13:40:00',7.65),('10318','2014-05-02','13:45:00',6.63),('10318','2014-05-02','13:50:00',5.52),('10318','2014-05-02','13:55:00',6.52),('10318','2014-05-02','14:00:00',4.88),('10318','2014-05-02','14:05:00',5.75),('10318','2014-05-02','14:10:00',3.33),('10318','2014-05-02','14:15:00',2.19),('10318','2014-05-02','14:20:00',2.39),('10318','2014-05-02','14:25:00',2.89),('10318','2014-05-02','14:30:00',3.37),('10318','2014-05-02','14:35:00',5.03),('10318','2014-05-02','14:40:00',4.15),('10318','2014-05-02','14:45:00',2.5),('10318','2014-05-02','14:50:00',2.01),('10318','2014-05-02','14:55:00',4.45),('10318','2014-05-02','15:00:00',3.91),('10318','2014-05-02','15:05:00',5.7),('10318','2014-05-02','15:10:00',4.16),('10318','2014-05-02','15:15:00',4.66),('10318','2014-05-02','15:20:00',6.57),('10318','2014-05-02','15:25:00',5.73),('10318','2014-05-02','15:30:00',3.68),('10318','2014-05-02','15:35:00',4.06),('10318','2014-05-02','15:40:00',3.51),('10318','2014-05-02','15:45:00',1.89),('10318','2014-05-02','15:50:00',2.46),('10318','2014-05-02','15:55:00',3.48),('10318','2014-05-02','16:00:00',3.24),('10318','2014-05-02','16:05:00',2.94),('10318','2014-05-02','16:10:00',2.47),('10318','2014-05-02','16:15:00',2.72),('10318','2014-05-02','16:20:00',2.24),('10318','2014-05-02','16:25:00',1.74),('10318','2014-05-02','16:30:00',1.07),('10318','2014-05-02','16:50:00',1.35),('10318','2014-05-02','16:55:00',1.51),('10318','2014-05-02','17:10:00',1.09),('10318','2014-05-02','17:15:00',1.77),('10318','2014-05-02','17:20:00',1.9),('10318','2014-05-02','17:25:00',1.99),('10318','2014-05-02','17:30:00',1.63),('10318','2014-05-02','17:35:00',1.49),('10318','2014-05-02','17:40:00',1.38),('10318','2014-05-02','17:45:00',1.17),('10318','2014-05-02','18:00:00',1.01),('10318','2014-03-27','07:30:00',1.02),('10318','2014-03-27','07:35:00',1.04),('10318','2014-03-27','07:40:00',1.05),('10318','2014-03-27','07:45:00',1.36),('10318','2014-03-27','07:50:00',1.87),('10318','2014-03-27','07:55:00',2.32),('10318','2014-03-27','08:00:00',2.96),('10318','2014-03-27','08:05:00',3.24),('10318','2014-03-27','08:10:00',1.53),('10318','2014-03-27','09:05:00',1.12),('10318','2014-03-27','09:10:00',2.22),('10318','2014-03-27','09:15:00',2.54),('10318','2014-03-27','09:20:00',2.36),('10318','2014-03-27','09:25:00',2.16),('10318','2014-03-27','09:30:00',1.85),('10318','2014-03-27','09:35:00',1.44),('10318','2014-03-27','09:40:00',1.06),('10318','2014-03-27','09:50:00',1.05),('10318','2014-03-27','09:55:00',1.32),('10318','2014-03-27','10:00:00',2.08),('10318','2014-03-27','10:05:00',2.94),('10318','2014-03-27','10:10:00',3.16),('10318','2014-03-27','10:15:00',3.8),('10318','2014-03-27','10:20:00',5.2),('10318','2014-03-27','10:25:00',5.23),('10318','2014-03-27','10:30:00',5.49),('10318','2014-03-27','10:35:00',3.82),('10318','2014-03-27','10:40:00',2.81),('10318','2014-03-27','10:45:00',3.37),('10318','2014-03-27','10:50:00',2.49),('10318','2014-03-27','10:55:00',1.64),('10318','2014-03-27','11:00:00',1.4),('10318','2014-03-27','11:05:00',2.54),('10318','2014-03-27','11:10:00',5.59),('10318','2014-03-27','11:15:00',4.16),('10318','2014-03-27','11:20:00',2.37),('10318','2014-03-27','11:25:00',1.53),('10318','2014-03-27','11:45:00',1.7),('10318','2014-03-27','11:50:00',3.55),('10318','2014-03-27','11:55:00',4.4),('10318','2014-03-27','12:00:00',3.37),('10318','2014-03-27','12:05:00',2.72),('10318','2014-03-27','12:10:00',1.6),('10318','2014-03-27','12:15:00',1.23),('10318','2014-03-27','12:20:00',1.57),('10318','2014-03-27','12:25:00',1.13),('10318','2014-03-27','12:50:00',1.21),('10318','2014-03-27','12:55:00',1.82),('10318','2014-03-27','13:00:00',2.54),('10318','2014-03-27','13:05:00',3.08),('10318','2014-03-27','13:10:00',4.38),('10318','2014-03-27','13:15:00',5.99),('10318','2014-03-27','13:20:00',5.29),('10318','2014-03-27','13:25:00',5.78),('10318','2014-03-27','13:30:00',4.59),('10318','2014-03-27','13:35:00',4.4),('10318','2014-03-27','13:40:00',4.35),('10318','2014-03-27','13:45:00',3.67),('10318','2014-03-27','13:50:00',4.59),('10318','2014-03-27','13:55:00',5.7),('10318','2014-03-27','14:00:00',6.25),('10318','2014-03-27','14:05:00',4.04),('10318','2014-03-27','14:10:00',1.46),('10318','2014-03-27','14:15:00',3.24),('10318','2014-03-27','14:20:00',7.49),('10318','2014-03-27','14:25:00',5.22),('10318','2014-03-27','14:30:00',3.96),('10318','2014-03-27','14:35:00',5.87),('10318','2014-03-27','14:40:00',7.21),('10318','2014-03-27','14:45:00',4.36),('10318','2014-03-27','14:50:00',4),('10318','2014-03-27','14:55:00',5.95),('10318','2014-03-27','15:00:00',7.16),('10318','2014-03-27','15:05:00',1.72),('10318','2014-03-27','15:10:00',1.56),('10318','2014-03-27','15:15:00',1.16),('10318','2014-03-27','15:20:00',1.17),('10318','2014-03-27','15:25:00',3.02),('10318','2014-03-27','15:30:00',3.24),('10318','2014-03-27','15:35:00',2.61),('10318','2014-03-27','15:40:00',4.76),('10318','2014-03-27','15:45:00',1.46),('10318','2014-03-27','15:50:00',1.24),('10318','2014-03-27','15:55:00',1.4),('10318','2014-03-27','16:00:00',1.62),('10318','2014-03-27','16:05:00',1.66),('10318','2014-03-27','16:10:00',1.61),('10318','2014-03-27','16:15:00',1.6),('10318','2014-03-27','16:20:00',1.73),('10318','2014-03-27','16:25:00',2.48),('10318','2014-03-27','16:30:00',2.41),('10318','2014-03-27','16:35:00',1.98),('10318','2014-03-27','16:40:00',2.09),('10318','2014-03-27','16:45:00',2.27),('10318','2014-03-27','16:50:00',2.14),('10318','2014-03-27','16:55:00',2.64),('10318','2014-03-27','17:00:00',1.98),('10318','2014-03-27','17:05:00',1.69),('10318','2014-03-27','17:10:00',1.43),('10318','2014-03-27','17:15:00',1.28),('10318','2013-04-01','08:20:00',2.94),('10318','2013-04-01','08:25:00',4.31),('10318','2013-04-01','08:30:00',3.7),('10318','2013-04-01','08:35:00',1.79),('10318','2013-04-01','08:40:00',1.87),('10318','2013-04-01','08:45:00',1.46),('10318','2013-04-01','08:50:00',1.41),('10318','2013-04-01','08:55:00',3.88),('10318','2013-04-01','09:00:00',5.61),('10318','2013-04-01','09:05:00',5.84),('10318','2013-04-01','09:10:00',6.03),('10318','2013-04-01','09:15:00',5.9),('10318','2013-04-01','09:20:00',5.52),('10318','2013-04-01','09:25:00',5.9),('10318','2013-04-01','09:30:00',4.66),('10318','2013-04-01','09:35:00',7.07),('10318','2013-04-01','09:40:00',7.12),('10318','2013-04-01','09:45:00',6.35),('10318','2013-04-01','09:50:00',6.49),('10318','2013-04-01','09:55:00',6.61),('10318','2013-04-01','10:00:00',7.66),('10318','2013-04-01','10:05:00',7.79),('10318','2013-04-01','10:10:00',6.96),('10318','2013-04-01','10:15:00',7.36),('10318','2013-04-01','10:20:00',7.96),('10318','2013-04-01','10:25:00',8.03),('10318','2013-04-01','10:30:00',7.99),('10318','2013-04-01','10:35:00',7.58),('10318','2013-04-01','10:40:00',8.19),('10318','2013-04-01','10:45:00',8.12),('10318','2013-04-01','10:50:00',8.99),('10318','2013-04-01','10:55:00',7.52),('10318','2013-04-01','11:00:00',9.35),('10318','2013-04-01','11:05:00',7.2),('10318','2013-04-01','11:10:00',4.21),('10318','2013-04-01','11:15:00',9.94),('10318','2013-04-01','11:20:00',7.99),('10318','2013-04-01','11:25:00',7.38),('10318','2013-04-01','11:30:00',5.99),('10318','2013-04-01','11:35:00',5.46),('10318','2013-04-01','11:40:00',6.23),('10318','2013-04-01','11:45:00',4.1),('10318','2013-04-01','11:50:00',4.72),('10318','2013-04-01','11:55:00',5.11),('10318','2013-04-01','12:00:00',4.64),('10318','2013-04-01','12:05:00',3.62),('10318','2013-04-01','12:10:00',3.92),('10318','2013-04-01','12:15:00',3.51),('10318','2013-04-01','12:20:00',2.94),('10318','2013-04-01','12:25:00',3.25),('10318','2013-04-01','12:30:00',5.39),('10318','2013-04-01','12:35:00',5.02),('10318','2013-04-01','12:40:00',5.7),('10318','2013-04-01','12:45:00',5.98),('10318','2013-04-01','12:50:00',6.46),('10318','2013-04-01','12:55:00',6.92),('10318','2013-04-01','13:00:00',6.88),('10318','2013-04-01','13:05:00',7.66),('10318','2013-04-01','13:10:00',6.66),('10318','2013-04-01','13:15:00',6.47),('10318','2013-04-01','13:20:00',6.19),('10318','2013-04-01','13:25:00',6.03),('10318','2013-04-01','13:30:00',6.75),('10318','2013-04-01','13:35:00',5.3),('10318','2013-04-01','13:40:00',7.21),('10318','2013-04-01','13:45:00',7.57),('10318','2013-04-01','13:50:00',8.63),('10318','2013-04-01','13:55:00',8.12),('10318','2013-04-01','14:00:00',4.54),('10318','2013-04-01','14:05:00',4.05),('10318','2013-04-01','14:10:00',5.18),('10318','2013-04-01','14:15:00',5.29),('10318','2013-04-01','14:20:00',5.95),('10318','2013-04-01','14:25:00',9.21),('10318','2013-04-01','14:30:00',6.96),('10318','2013-04-01','14:35:00',5.3),('10318','2013-04-01','14:40:00',4.33),('10318','2013-04-01','14:45:00',4.65),('10318','2013-04-01','14:50:00',4.92),('10318','2013-04-01','14:55:00',4.74),('10318','2013-04-01','15:00:00',4.26),('10318','2013-04-01','15:05:00',4.17),('10318','2013-04-01','15:10:00',4.44),('10318','2013-04-01','15:15:00',4.77),('10318','2013-04-01','15:20:00',4.68),('10318','2013-04-01','15:25:00',4.93),('10318','2013-04-01','15:30:00',4.6),('10318','2013-04-01','15:35:00',5.09),('10318','2013-04-01','15:40:00',4.56),('10318','2013-04-01','15:45:00',4.19),('10318','2013-04-01','15:50:00',4.22),('10318','2013-04-01','15:55:00',4.1),('10318','2013-04-01','16:00:00',4),('10318','2013-04-01','16:05:00',3.44),('10318','2013-04-01','16:10:00',2.77),('10318','2013-04-01','16:15:00',2.2),('10318','2013-04-01','16:20:00',2.25),('10318','2013-04-01','16:25:00',2.09),('10318','2013-04-01','16:30:00',1.61),('10318','2013-04-01','16:35:00',1.64),('10318','2013-04-01','16:40:00',1.47),('10318','2013-04-01','16:45:00',1.12),('10318','2013-03-31','08:15:00',1.32),('10318','2013-03-31','08:20:00',1.53),('10318','2013-03-31','08:25:00',1.49),('10318','2013-03-31','08:30:00',3.18),('10318','2013-03-31','08:35:00',1.52),('10318','2013-03-31','08:40:00',2.17),('10318','2013-03-31','08:45:00',2.3),('10318','2013-03-31','08:50:00',3.46),('10318','2013-03-31','08:55:00',3.78),('10318','2013-03-31','09:00:00',2.32),('10318','2013-03-31','09:05:00',2.08),('10318','2013-03-31','09:10:00',2.57),('10318','2013-03-31','09:15:00',3.61),('10318','2013-03-31','09:20:00',4.03),('10318','2013-03-31','09:25:00',6.47),('10318','2013-03-31','09:30:00',5.46),('10318','2013-03-31','09:35:00',7.99),('10318','2013-03-31','09:40:00',7.05),('10318','2013-03-31','09:45:00',5.86),('10318','2013-03-31','09:50:00',2.73),('10318','2013-03-31','09:55:00',3.27),('10318','2013-03-31','10:00:00',1.98),('10318','2013-03-31','10:05:00',1.26),('10318','2013-03-31','10:10:00',1.89),('10318','2013-03-31','10:15:00',3.36),('10318','2013-03-31','10:20:00',4.21),('10318','2013-03-31','10:25:00',5.71),('10318','2013-03-31','10:30:00',4.26),('10318','2013-03-31','10:35:00',5.38),('10318','2013-03-31','10:40:00',1.81),('10318','2013-03-31','10:45:00',3.39),('10318','2013-03-31','10:50:00',4.93),('10318','2013-03-31','10:55:00',2.25),('10318','2013-03-31','11:00:00',1.78),('10318','2013-03-31','11:05:00',2.9),('10318','2013-03-31','11:10:00',2.61),('10318','2013-03-31','11:15:00',2),('10318','2013-03-31','11:20:00',2.42),('10318','2013-03-31','11:25:00',5.06),('10318','2013-03-31','11:30:00',4.35),('10318','2013-03-31','11:35:00',4.51),('10318','2013-03-31','11:40:00',5.79),('10318','2013-03-31','11:45:00',6.28),('10318','2013-03-31','11:50:00',5.73),('10318','2013-03-31','11:55:00',3.45),('10318','2013-03-31','12:00:00',3.12),('10318','2013-03-31','12:05:00',2.56),('10318','2013-03-31','12:10:00',2.83),('10318','2013-03-31','12:15:00',2.4),('10318','2013-03-31','12:20:00',1.89),('10318','2013-03-31','12:25:00',2.83),('10318','2013-03-31','12:30:00',4.98),('10318','2013-03-31','12:35:00',8.89),('10318','2013-03-31','12:40:00',8.73),('10318','2013-03-31','12:45:00',4.77),('10318','2013-03-31','12:50:00',5.25),('10318','2013-03-31','12:55:00',5.51),('10318','2013-03-31','13:00:00',5.8),('10318','2013-03-31','13:05:00',4.38),('10318','2013-03-31','13:10:00',6.73),('10318','2013-03-31','13:15:00',9.23),('10318','2013-03-31','13:20:00',8.83),('10318','2013-03-31','13:25:00',7.94),('10318','2013-03-31','13:30:00',2.08),('10318','2013-03-31','13:35:00',1.84),('10318','2013-03-31','13:40:00',7.19),('10318','2013-03-31','13:45:00',7.6),('10318','2013-03-31','13:50:00',5.59),('10318','2013-03-31','13:55:00',4.94),('10318','2013-03-31','14:00:00',5.39),('10318','2013-03-31','14:05:00',2.86),('10318','2013-03-31','14:10:00',4.5),('10318','2013-03-31','14:15:00',5.56),('10318','2013-03-31','14:20:00',5.8),('10318','2013-03-31','14:25:00',9.34),('10318','2013-03-31','14:30:00',4.83),('10318','2013-03-31','14:35:00',5.55),('10318','2013-03-31','14:40:00',6.85),('10318','2013-03-31','14:45:00',8.41),('10318','2013-03-31','14:50:00',6.68),('10318','2013-03-31','14:55:00',7.05),('10318','2013-03-31','15:00:00',7.82),('10318','2013-03-31','15:05:00',6.27),('10318','2013-03-31','15:10:00',6.72),('10318','2013-03-31','15:15:00',7.88),('10318','2013-03-31','15:20:00',9.15),('10318','2013-03-31','15:25:00',5.93),('10318','2013-03-31','15:30:00',5.42),('10318','2013-03-31','15:35:00',7.27),('10318','2013-03-31','15:40:00',5.89),('10318','2013-03-31','15:45:00',5.06),('10318','2013-03-31','15:50:00',2.17),('10318','2013-03-31','15:55:00',1.68),('10318','2013-03-31','16:00:00',5.28),('10318','2013-03-31','16:05:00',2.09),('10318','2013-03-31','16:10:00',2.59),('10318','2013-03-31','16:15:00',4.48),('10318','2013-03-31','16:20:00',3.88),('10318','2013-03-31','16:25:00',2.71),('10318','2013-03-31','16:30:00',2.53),('10318','2013-03-31','16:35:00',2.74),('10318','2013-03-31','16:40:00',2.77),('10318','2013-03-31','16:45:00',2.38),('10318','2013-03-31','16:50:00',1.91),('10318','2013-03-31','16:55:00',1.9),('10318','2013-03-31','17:00:00',2.46),('10318','2013-03-31','17:05:00',2.13),('10318','2013-03-31','17:10:00',1.58),('10318','2013-03-31','17:15:00',1.23),('10318','2013-03-31','17:20:00',1.8),('10318','2013-03-31','17:25:00',1.86),('10318','2013-03-31','17:30:00',2.28),('10318','2013-03-31','17:35:00',2.53),('10318','2013-03-31','17:40:00',2.13),('10318','2013-03-31','17:45:00',2.77),('10318','2013-03-31','17:50:00',3.44),('10318','2013-03-31','17:55:00',3.11),('10318','2013-03-31','18:10:00',1.34),('10318','2013-03-31','18:15:00',2.15),('10318','2013-03-31','18:20:00',1.01),('10318','2013-03-31','18:25:00',1.02),('10318','2013-03-30','07:05:00',1.07),('10318','2013-03-30','07:20:00',1.16),('10318','2013-03-30','07:25:00',1.37),('10318','2013-03-30','07:30:00',1.62),('10318','2013-03-30','07:35:00',1.06),('10318','2013-03-30','07:50:00',1.56),('10318','2013-03-30','07:55:00',1.95),('10318','2013-03-30','08:00:00',1.73),('10318','2013-03-30','08:05:00',1.42),('10318','2013-03-30','08:10:00',1.56),('10318','2013-03-30','08:15:00',1.77),('10318','2013-03-30','08:20:00',1.89),('10318','2013-03-30','08:25:00',2),('10318','2013-03-30','08:30:00',2.35),('10318','2013-03-30','08:35:00',2.69),('10318','2013-03-30','08:40:00',2.38),('10318','2013-03-30','08:45:00',1.68),('10318','2013-03-30','08:50:00',1.49),('10318','2013-03-30','08:55:00',1.21),('10318','2013-03-30','09:00:00',2.73),('10318','2013-03-30','09:05:00',6.51),('10318','2013-03-30','09:10:00',7.09),('10318','2013-03-30','09:15:00',9.22),('10318','2013-03-30','09:20:00',7.91),('10318','2013-03-30','09:25:00',4.85),('10318','2013-03-30','09:30:00',3.8),('10318','2013-03-30','09:35:00',3.37),('10318','2013-03-30','09:40:00',3.49),('10318','2013-03-30','09:45:00',2.64),('10318','2013-03-30','09:50:00',2.66),('10318','2013-03-30','09:55:00',3.7),('10318','2013-03-30','10:00:00',4.65),('10318','2013-03-30','10:05:00',4.24),('10318','2013-03-30','10:10:00',4.26),('10318','2013-03-30','10:15:00',3.42),('10318','2013-03-30','10:20:00',3.16),('10318','2013-03-30','10:25:00',3.38),('10318','2013-03-30','10:30:00',3.91),('10318','2013-03-30','10:35:00',4.62),('10318','2013-03-30','10:40:00',5.47),('10318','2013-03-30','10:45:00',5.64),('10318','2013-03-30','10:50:00',5.3),('10318','2013-03-30','10:55:00',6.56),('10318','2013-03-30','11:00:00',9.91),('10318','2013-03-30','11:05:00',7.43),('10318','2013-03-30','11:10:00',7.9),('10318','2013-03-30','11:15:00',9.8),('10318','2013-03-30','11:20:00',10.61),('10318','2013-03-30','11:25:00',5.43),('10318','2013-03-30','11:30:00',6.59),('10318','2013-03-30','11:35:00',7.79),('10318','2013-03-30','11:40:00',8.61),('10318','2013-03-30','11:45:00',8.55),('10318','2013-03-30','11:50:00',7.06),('10318','2013-03-30','11:55:00',8.15),('10318','2013-03-30','12:00:00',8.6),('10318','2013-03-30','12:05:00',6.22),('10318','2013-03-30','12:10:00',3.37),('10318','2013-03-30','12:15:00',2.83),('10318','2013-03-30','12:20:00',2.45),('10318','2013-03-30','12:25:00',1.55),('10318','2013-03-30','12:30:00',2.6),('10318','2013-03-30','12:35:00',2.19),('10318','2013-03-30','12:40:00',1.07),('10318','2013-03-30','12:45:00',1.43),('10318','2013-03-30','12:50:00',1.37),('10318','2013-03-30','12:55:00',1.11),('10318','2013-03-30','13:00:00',1.04),('10318','2013-03-30','13:05:00',3.68),('10318','2013-03-30','13:10:00',7.68),('10318','2013-03-30','13:15:00',5.22),('10318','2013-03-30','13:20:00',4.56),('10318','2013-03-30','13:25:00',3.79),('10318','2013-03-30','13:30:00',3.28),('10318','2013-03-30','13:35:00',3.35),('10318','2013-03-30','13:40:00',4.78),('10318','2013-03-30','13:45:00',6.23),('10318','2013-03-30','13:50:00',5.96),('10318','2013-03-30','13:55:00',3.9),('10318','2013-03-30','14:00:00',4.59),('10318','2013-03-30','14:05:00',4.11),('10318','2013-03-30','14:10:00',3.69),('10318','2013-03-30','14:15:00',2.61),('10318','2013-03-30','14:20:00',3.44),('10318','2013-03-30','14:25:00',3.66),('10318','2013-03-30','14:30:00',2.68),('10318','2013-03-30','14:35:00',1.94),('10318','2013-03-30','14:40:00',2.05),('10318','2013-03-30','14:45:00',2.32),('10318','2013-03-30','14:50:00',2.69),('10318','2013-03-30','14:55:00',2.01),('10318','2013-03-30','15:00:00',1.61),('10318','2013-03-30','15:05:00',1.86),('10318','2013-03-30','15:10:00',1.12),('10318','2013-03-30','15:15:00',1.28),('10318','2013-03-30','15:20:00',1.04),('10318','2013-03-30','15:30:00',1.07),('10318','2013-03-30','15:40:00',1.31),('10318','2013-03-30','15:45:00',1.03),('10318','2013-03-30','17:40:00',1.19),('10318','2013-03-30','17:45:00',1.2),('10318','2013-03-29','06:50:00',1.06),('10318','2013-03-29','06:55:00',1.16),('10318','2013-03-29','07:05:00',1.41),('10318','2013-03-29','07:10:00',2.17),('10318','2013-03-29','07:15:00',2.88),('10318','2013-03-29','07:20:00',3.2),('10318','2013-03-29','07:25:00',3.78),('10318','2013-03-29','07:30:00',2.69),('10318','2013-03-29','07:35:00',3.86),('10318','2013-03-29','07:40:00',4.4),('10318','2013-03-29','07:45:00',4.49),('10318','2013-03-29','07:50:00',3.47),('10318','2013-03-29','07:55:00',3.6),('10318','2013-03-29','08:00:00',3.33),('10318','2013-03-29','08:05:00',5),('10318','2013-03-29','08:10:00',4.9),('10318','2013-03-29','08:16:00',5.59),('10318','2013-03-29','08:20:00',5.88),('10318','2013-03-29','08:25:00',6.06),('10318','2013-03-29','08:30:00',6.26),('10318','2013-03-29','08:35:00',6.52),('10318','2013-03-29','08:40:00',6.52),('10318','2013-03-29','08:45:00',6.1),('10318','2013-03-29','08:50:00',6.31),('10318','2013-03-29','08:55:00',5.44),('10318','2013-03-29','09:00:00',6.99),('10318','2013-03-29','09:05:00',7.08),('10318','2013-03-29','09:10:00',7),('10318','2013-03-29','09:15:00',7.78),('10318','2013-03-29','09:20:00',7.85),('10318','2013-03-29','09:25:00',7.03),('10318','2013-03-29','09:30:00',7.61),('10318','2013-03-29','09:35:00',6.48),('10318','2013-03-29','09:40:00',4.96),('10318','2013-03-29','09:45:00',5.42),('10318','2013-03-29','09:50:00',7.4),('10318','2013-03-29','09:55:00',8.4),('10318','2013-03-29','10:00:00',7.7),('10318','2013-03-29','10:05:00',7.35),('10318','2013-03-29','10:10:00',7.39),('10318','2013-03-29','10:15:00',7.78),('10318','2013-03-29','10:20:00',6.96),('10318','2013-03-29','10:25:00',5.68),('10318','2013-03-29','10:30:00',3.82),('10318','2013-03-29','10:35:00',7.54),('10318','2013-03-29','10:40:00',7.85),('10318','2013-03-29','10:45:00',6.29),('10318','2013-03-29','10:50:00',8.04),('10318','2013-03-29','10:55:00',8.81),('10318','2013-03-29','11:00:00',8.88),('10318','2013-03-29','11:05:00',6.51),('10318','2013-03-29','11:10:00',8.48),('10318','2013-03-29','11:15:00',10.11),('10318','2013-03-29','11:20:00',9.93),('10318','2013-03-29','11:25:00',10.14),('10318','2013-03-29','11:30:00',9.81),('10318','2013-03-29','11:35:00',9.46),('10318','2013-03-29','11:40:00',9.49),('10318','2013-03-29','11:45:00',9.87),('10318','2013-03-29','11:50:00',9.88),('10318','2013-03-29','11:55:00',9.94),('10318','2013-03-29','12:00:00',9.88),('10318','2013-03-29','12:05:00',10.01),('10318','2013-03-29','12:10:00',9.56),('10318','2013-03-29','12:15:00',9.27),('10318','2013-03-29','12:20:00',9.42),('10318','2013-03-29','12:25:00',8.96),('10318','2013-03-29','12:30:00',9.5),('10318','2013-03-29','12:35:00',8.78),('10318','2013-03-29','12:40:00',8.76),('10318','2013-03-29','12:45:00',9.35),('10318','2013-03-29','12:50:00',9.34),('10318','2013-03-29','12:55:00',8.96),('10318','2013-03-29','13:00:00',8.05),('10318','2013-03-29','13:05:00',8.88),('10318','2013-03-29','13:10:00',8.48),('10318','2013-03-29','13:15:00',8.18),('10318','2013-03-29','13:20:00',7.87),('10318','2013-03-29','13:25:00',9.71),('10318','2013-03-29','13:30:00',7.25),('10318','2013-03-29','13:35:00',7.21),('10318','2013-03-29','13:40:00',7.1),('10318','2013-03-29','13:45:00',7.55),('10318','2013-03-29','13:50:00',7.31),('10318','2013-03-29','13:55:00',7.56),('10318','2013-03-29','14:00:00',7.82),('10318','2013-03-29','14:05:00',5.85),('10318','2013-03-29','14:10:00',5.19),('10318','2013-03-29','14:15:00',5.19),('10318','2013-03-29','14:20:00',5.15),('10318','2013-03-29','14:25:00',5.23),('10318','2013-03-29','14:30:00',4.56),('10318','2013-03-29','14:35:00',4.46),('10318','2013-03-29','14:40:00',4.35),('10318','2013-03-29','14:45:00',3.97),('10318','2013-03-29','14:50:00',3.87),('10318','2013-03-29','14:55:00',3.68),('10318','2013-03-29','15:00:00',3.45),('10318','2013-03-29','15:05:00',3.48),('10318','2013-03-29','15:10:00',3.2),('10318','2013-03-29','15:15:00',3.17),('10318','2013-03-29','15:20:00',2.93),('10318','2013-03-29','15:25:00',2.68),('10318','2013-03-29','15:30:00',2.52),('10318','2013-03-29','15:35:00',2.42),('10318','2013-03-29','15:40:00',2.29),('10318','2013-03-29','15:45:00',2.26),('10318','2013-03-29','15:50:00',2.56),('10318','2013-03-29','15:55:00',3.15),('10318','2013-03-29','16:00:00',3.02),('10318','2013-03-29','16:05:00',2.98),('10318','2013-03-29','16:10:00',2.33),('10318','2013-03-29','16:15:00',2.1),('10318','2013-03-29','16:20:00',1.93),('10318','2013-03-29','16:25:00',2.44),('10318','2013-03-29','16:30:00',2.15),('10318','2013-03-29','16:35:00',2.76),('10318','2013-03-29','16:40:00',3.59),('10318','2013-03-29','16:45:00',2.9),('10318','2013-03-29','16:50:00',2.15),('10318','2013-03-29','16:55:00',2.02),('10318','2013-03-29','17:00:00',2.24),('10318','2013-03-29','17:05:00',1.53),('10318','2013-03-29','17:10:00',1.12),('10318','2013-03-29','17:15:00',1.24),('10318','2013-03-29','17:20:00',1.68),('10318','2013-03-29','17:25:00',1.54),('10318','2013-03-29','17:30:00',1.33),('10318','2013-03-29','17:35:00',1.06),('10318','2013-03-28','07:30:00',1.13),('10318','2013-03-28','08:40:00',1.13),('10318','2013-03-28','08:45:00',1.11),('10318','2013-03-28','08:50:00',1.26),('10318','2013-03-28','08:55:00',1.4),('10318','2013-03-28','09:00:00',1.43),('10318','2013-03-28','09:05:00',1.96),('10318','2013-03-28','09:10:00',2.99),('10318','2013-03-28','09:15:00',4.15),('10318','2013-03-28','09:20:00',3.43),('10318','2013-03-28','09:25:00',3.86),('10318','2013-03-28','09:30:00',2.86),('10318','2013-03-28','09:35:00',2.06),('10318','2013-03-28','09:40:00',1.92),('10318','2013-03-28','09:45:00',2.27),('10318','2013-03-28','09:50:00',2.28),('10318','2013-03-28','09:55:00',2.58),('10318','2013-03-28','10:00:00',2.62),('10318','2013-03-28','10:05:00',2.06),('10318','2013-03-28','10:10:00',1.54),('10318','2013-03-28','10:15:00',1.58),('10318','2013-03-28','10:20:00',1.11),('10318','2013-03-28','10:25:00',1.1),('10318','2013-03-28','10:30:00',1.24),('10318','2013-03-28','10:35:00',1.29),('10318','2013-03-28','10:40:00',1.07),('10318','2013-03-28','10:50:00',1.09),('10318','2013-03-28','10:55:00',1.2),('10318','2013-03-28','11:00:00',1.94),('10318','2013-03-28','11:05:00',1.48),('10318','2013-03-28','11:10:00',1.77),('10318','2013-03-28','11:15:00',1.19),('10318','2013-03-28','11:30:00',1.15),('10318','2013-03-28','11:35:00',1.21),('10318','2013-03-28','11:40:00',1.42),('10318','2013-03-28','11:45:00',1.56),('10318','2013-03-28','11:50:00',2.08),('10318','2013-03-28','11:55:00',2.9),('10318','2013-03-28','12:00:00',1.91),('10318','2013-03-28','12:05:00',1.54),('10318','2013-03-28','12:10:00',1.47),('10318','2013-03-28','12:15:00',1.59),('10318','2013-03-28','12:20:00',1.8),('10318','2013-03-28','12:25:00',1.96),('10318','2013-03-28','12:30:00',2.82),('10318','2013-03-28','12:35:00',2.19),('10318','2013-03-28','12:40:00',2.95),('10318','2013-03-28','12:45:00',3.29),('10318','2013-03-28','12:50:00',4),('10318','2013-03-28','12:55:00',5.4),('10318','2013-03-28','13:00:00',5.68),('10318','2013-03-28','13:05:00',6.53),('10318','2013-03-28','13:10:00',5.52),('10318','2013-03-28','13:15:00',4.06),('10318','2013-03-28','13:20:00',6.64),('10318','2013-03-28','13:25:00',6.62),('10318','2013-03-28','13:30:00',7.58),('10318','2013-03-28','13:35:00',5.64),('10318','2013-03-28','13:40:00',2.48),('10318','2013-03-28','13:45:00',3),('10318','2013-03-28','13:50:00',4.36),('10318','2013-03-28','13:55:00',2.39),('10318','2013-03-28','14:00:00',3.34),('10318','2013-03-28','14:05:00',3.44),('10318','2013-03-28','14:10:00',2.48),('10318','2013-03-28','14:15:00',2.79),('10318','2013-03-28','14:20:00',3.4),('10318','2013-03-28','14:25:00',2.97),('10318','2013-03-28','14:30:00',3.54),('10318','2013-03-28','14:35:00',3.1),('10318','2013-03-28','14:40:00',2.45),('10318','2013-03-28','14:45:00',2.2),('10318','2013-03-28','14:50:00',1.64),('10318','2013-03-28','14:55:00',2.03),('10318','2013-03-28','15:00:00',2.74),('10318','2013-03-28','15:05:00',3.83),('10318','2013-03-28','15:10:00',7.06),('10318','2013-03-28','15:15:00',6.42),('10318','2013-03-28','15:20:00',5.24),('10318','2013-03-28','15:25:00',2.48),('10318','2013-03-28','15:30:00',3.01),('10318','2013-03-28','15:35:00',2.25),('10318','2013-03-28','15:40:00',2.05),('10318','2013-03-28','15:45:00',2.53),('10318','2013-03-28','15:50:00',2.55),('10318','2013-03-28','15:55:00',3.59),('10318','2013-03-28','16:00:00',2.37),('10318','2013-03-28','16:05:00',2.34),('10318','2013-03-28','16:10:00',2.35),('10318','2013-03-28','16:15:00',1.52),('10318','2013-03-28','16:25:00',1.19),('10318','2013-03-28','16:30:00',1.21),('10318','2013-03-28','16:35:00',1.67),('10318','2013-03-28','16:40:00',1.36),('10318','2013-03-28','16:45:00',1.62),('10318','2013-03-28','16:50:00',1.28),('10318','2013-03-28','16:55:00',1.32),('10318','2013-03-28','17:00:00',1.68),('10318','2013-03-28','17:05:00',2.1),('10318','2013-03-28','17:10:00',1.7),('10318','2013-03-28','17:15:00',1.46),('10318','2013-03-28','17:20:00',1.17),('10318','2013-03-27','06:50:00',1.11),('10318','2013-03-27','06:55:00',1.27),('10318','2013-03-27','07:00:00',1.81),('10318','2013-03-27','07:05:00',1.84),('10318','2013-03-27','07:10:00',2.08),('10318','2013-03-27','07:15:00',2.75),('10318','2013-03-27','07:20:00',3.07),('10318','2013-03-27','07:25:00',3.31),('10318','2013-03-27','07:30:00',3.57),('10318','2013-03-27','07:35:00',3.63),('10318','2013-03-27','07:40:00',3.91),('10318','2013-03-27','07:45:00',4.18),('10318','2013-03-27','07:50:00',4.4),('10318','2013-03-27','07:55:00',3.31),('10318','2013-03-27','08:00:00',3.93),('10318','2013-03-27','08:05:00',3.23),('10318','2013-03-27','08:10:00',3.1),('10318','2013-03-27','08:15:00',3.21),('10318','2013-03-27','08:20:00',2.98),('10318','2013-03-27','08:25:00',4.07),('10318','2013-03-27','08:30:00',4.41),('10318','2013-03-27','08:35:00',4.54),('10318','2013-03-27','08:40:00',3.19),('10318','2013-03-27','08:45:00',4.02),('10318','2013-03-27','08:50:00',4.81),('10318','2013-03-27','08:55:00',3.93),('10318','2013-03-27','09:00:00',1.69),('10318','2013-03-27','09:05:00',1.32),('10318','2013-03-27','09:10:00',1.48),('10318','2013-03-27','09:15:00',1.92),('10318','2013-03-27','09:20:00',2.83),('10318','2013-03-27','09:25:00',2.57),('10318','2013-03-27','09:30:00',3.36),('10318','2013-03-27','09:35:00',2.16),('10318','2013-03-27','09:40:00',4.87),('10318','2013-03-27','09:45:00',6.13),('10318','2013-03-27','09:50:00',3.68),('10318','2013-03-27','09:55:00',2.49),('10318','2013-03-27','10:00:00',2.21),('10318','2013-03-27','10:05:00',1.78),('10318','2013-03-27','10:10:00',1.87),('10318','2013-03-27','10:15:00',2.64),('10318','2013-03-27','10:20:00',2.81),('10318','2013-03-27','10:25:00',3.73),('10318','2013-03-27','10:30:00',6.38),('10318','2013-03-27','10:35:00',5.23),('10318','2013-03-27','10:40:00',6.74),('10318','2013-03-27','10:45:00',6.11),('10318','2013-03-27','10:50:00',5.47),('10318','2013-03-27','10:55:00',4.27),('10318','2013-03-27','11:00:00',3.71),('10318','2013-03-27','11:05:00',3.47),('10318','2013-03-27','11:10:00',3.48),('10318','2013-03-27','11:15:00',3.82),('10318','2013-03-27','11:20:00',3.96),('10318','2013-03-27','11:25:00',4.35),('10318','2013-03-27','11:30:00',5.17),('10318','2013-03-27','11:35:00',4.43),('10318','2013-03-27','11:40:00',3.96),('10318','2013-03-27','11:45:00',3.84),('10318','2013-03-27','11:50:00',4.43),('10318','2013-03-27','11:55:00',6.54),('10318','2013-03-27','12:00:00',5.17),('10318','2013-03-27','12:05:00',5.39),('10318','2013-03-27','12:10:00',5.78),('10318','2013-03-27','12:15:00',5.33),('10318','2013-03-27','12:20:00',5.59),('10318','2013-03-27','12:25:00',3.63),('10318','2013-03-27','12:30:00',4.32),('10318','2013-03-27','12:35:00',6.09),('10318','2013-03-27','12:40:00',6.25),('10318','2013-03-27','12:45:00',5.32),('10318','2013-03-27','12:50:00',3.33),('10318','2013-03-27','12:55:00',2.96),('10318','2013-03-27','13:00:00',4.45),('10318','2013-03-27','13:05:00',3.07),('10318','2013-03-27','13:10:00',2.37),('10318','2013-03-27','13:15:00',2.58),('10318','2013-03-27','13:20:00',2.69),('10318','2013-03-27','13:25:00',2.8),('10318','2013-03-27','13:30:00',2.98),('10318','2013-03-27','13:35:00',3.02),('10318','2013-03-27','13:40:00',2.17),('10318','2013-03-27','13:45:00',2.23),('10318','2013-03-27','13:50:00',2.08),('10318','2013-03-27','13:55:00',2.18),('10318','2013-03-27','14:00:00',2.84),('10318','2013-03-27','14:05:00',2.76),('10318','2013-03-27','14:10:00',2.91),('10318','2013-03-27','14:15:00',3.01),('10318','2013-03-27','14:20:00',3.05),('10318','2013-03-27','14:25:00',3.29),('10318','2013-03-27','14:30:00',3.23),('10318','2013-03-27','14:35:00',3.83),('10318','2013-03-27','14:40:00',4.34),('10318','2013-03-27','14:45:00',3.88),('10318','2013-03-27','14:50:00',2.81),('10318','2013-03-27','14:55:00',2.19),('10318','2013-03-27','15:00:00',2.15),('10318','2013-03-27','15:05:00',2.2),('10318','2013-03-27','15:10:00',2.36),('10318','2013-03-27','15:15:00',2.21),('10318','2013-03-27','15:20:00',1.96),('10318','2013-03-27','15:25:00',1.93),('10318','2013-03-27','15:30:00',2.01),('10318','2013-03-27','15:35:00',1.75),('10318','2013-03-27','15:40:00',2.23),('10318','2013-03-27','15:45:00',1.63),('10318','2013-03-27','15:50:00',1.15),('10318','2013-03-27','15:55:00',1.3),('10318','2013-03-27','16:00:00',1.38),('10318','2013-03-27','16:05:00',2.03),('10318','2013-03-27','16:10:00',3.04),('10318','2013-03-27','16:15:00',2.19),('10318','2013-03-27','16:20:00',1.9),('10318','2013-03-27','16:25:00',1.86),('10318','2013-03-27','16:30:00',1.91),('10318','2013-03-27','16:35:00',1.99),('10318','2013-03-27','16:40:00',2.32),('10318','2013-03-27','16:45:00',2.31),('10318','2013-03-27','16:50:00',2.05),('10318','2013-03-27','16:55:00',2.4),('10318','2013-03-27','17:00:00',2.49),('10318','2013-03-27','17:05:00',2.54),('10318','2013-03-27','17:10:00',2.08),('10318','2013-03-26','07:05:00',1.14),('10318','2013-03-26','07:10:00',1.16),('10318','2013-03-26','07:15:00',1.17),('10318','2013-03-26','07:20:00',1.07),('10318','2013-03-26','07:35:00',1.44),('10318','2013-03-26','07:40:00',1.86),('10318','2013-03-26','07:45:00',2.45),('10318','2013-03-26','07:50:00',4.88),('10318','2013-03-26','07:55:00',2.74),('10318','2013-03-26','08:00:00',1.64),('10318','2013-03-26','08:05:00',1.33),('10318','2013-03-26','08:10:00',1.31),('10318','2013-03-26','08:15:00',1.54),('10318','2013-03-26','08:20:00',1.65),('10318','2013-03-26','08:25:00',1.69),('10318','2013-03-26','08:30:00',2.68),('10318','2013-03-26','08:35:00',3.02),('10318','2013-03-26','08:40:00',2.58),('10318','2013-03-26','08:45:00',1.68),('10318','2013-03-26','08:50:00',1.81),('10318','2013-03-26','08:55:00',1.48),('10318','2013-03-26','09:00:00',1.88),('10318','2013-03-26','09:05:00',1.85),('10318','2013-03-26','09:10:00',2.94),('10318','2013-03-26','09:15:00',3.15),('10318','2013-03-26','09:20:00',1.65),('10318','2013-03-26','09:25:00',1.25),('10318','2013-03-26','09:40:00',1.19),('10318','2013-03-26','09:45:00',2.06),('10318','2013-03-26','09:50:00',4.46),('10318','2013-03-26','09:55:00',3.39),('10318','2013-03-26','10:00:00',2.13),('10318','2013-03-26','10:10:00',1.17),('10318','2013-03-26','10:15:00',1.33),('10318','2013-03-26','10:20:00',1.03),('10318','2013-03-26','10:35:00',1.58),('10318','2013-03-26','10:40:00',1.14),('10318','2013-03-26','10:45:00',1.27),('10318','2013-03-26','10:50:00',1.74),('10318','2013-03-26','10:55:00',2.79),('10318','2013-03-26','11:00:00',2.41),('10318','2013-03-26','11:05:00',3.38),('10318','2013-03-26','11:10:00',4.72),('10318','2013-03-26','11:15:00',2.54),('10318','2013-03-26','11:20:00',1.45),('10318','2013-03-26','11:25:00',1.06),('10318','2013-03-26','11:45:00',1.49),('10318','2013-03-26','11:50:00',1.57),('10318','2013-03-26','11:55:00',2.55),('10318','2013-03-26','12:00:00',4.92),('10318','2013-03-26','12:05:00',3.27),('10318','2013-03-26','12:10:00',3.16),('10318','2013-03-26','12:15:00',3.23),('10318','2013-03-26','12:20:00',4.14),('10318','2013-03-26','12:25:00',7.6),('10318','2013-03-26','12:30:00',7.32),('10318','2013-03-26','12:35:00',4.41),('10318','2013-03-26','12:40:00',3.08),('10318','2013-03-26','12:45:00',6.72),('10318','2013-03-26','12:50:00',3.66),('10318','2013-03-26','12:55:00',2.67),('10318','2013-03-26','13:00:00',4.99),('10318','2013-03-26','13:05:00',5.45),('10318','2013-03-26','13:10:00',6.69),('10318','2013-03-26','13:15:00',4.2),('10318','2013-03-26','13:20:00',4.61),('10318','2013-03-26','13:25:00',3.91),('10318','2013-03-26','13:30:00',5.73),('10318','2013-03-26','13:35:00',5.74),('10318','2013-03-26','13:40:00',6.23),('10318','2013-03-26','13:45:00',4.41),('10318','2013-03-26','13:50:00',3.49),('10318','2013-03-26','13:55:00',2.85),('10318','2013-03-26','14:00:00',3.33),('10318','2013-03-26','14:05:00',3.7),('10318','2013-03-26','14:10:00',3.91),('10318','2013-03-26','14:15:00',3.17),('10318','2013-03-26','14:20:00',2.84),('10318','2013-03-26','14:25:00',2.74),('10318','2013-03-26','14:30:00',2.28),('10318','2013-03-26','14:35:00',2.16),('10318','2013-03-26','14:40:00',2.24),('10318','2013-03-26','14:45:00',2.2),('10318','2013-03-26','14:50:00',1.97),('10318','2013-03-26','14:55:00',1.89),('10318','2013-03-26','15:00:00',1.93),('10318','2013-03-26','15:05:00',2.06),('10318','2013-03-26','15:10:00',1.87),('10318','2013-03-26','15:15:00',1.79),('10318','2013-03-26','15:20:00',1.91),('10318','2013-03-26','15:25:00',1.93),('10318','2013-03-26','15:30:00',2.14),('10318','2013-03-26','15:35:00',2.23),('10318','2013-03-26','15:40:00',1.69),('10318','2013-03-26','15:45:00',1.03),('10318','2013-03-25','08:10:00',1.55),('10318','2013-03-25','08:15:00',1.52),('10318','2013-03-25','08:20:00',2.06),('10318','2013-03-25','08:25:00',5.05),('10318','2013-03-25','08:30:00',3.67),('10318','2013-03-25','08:35:00',1.5),('10318','2013-03-25','08:40:00',1.74),('10318','2013-03-25','08:45:00',1.58),('10318','2013-03-25','08:50:00',2.53),('10318','2013-03-25','08:55:00',2.08),('10318','2013-03-25','09:00:00',1.34),('10318','2013-03-25','09:05:00',1.78),('10318','2013-03-25','09:10:00',2.33),('10318','2013-03-25','09:15:00',4.81),('10318','2013-03-25','09:20:00',5.52),('10318','2013-03-25','09:25:00',4.15),('10318','2013-03-25','09:30:00',4.58),('10318','2013-03-25','09:35:00',4.82),('10318','2013-03-25','09:40:00',2.63),('10318','2013-03-25','09:45:00',1.89),('10318','2013-03-25','09:50:00',2.53),('10318','2013-03-25','09:55:00',2.69),('10318','2013-03-25','10:00:00',1.72),('10318','2013-03-25','10:05:00',3.06),('10318','2013-03-25','10:10:00',3.17),('10318','2013-03-25','10:15:00',2.11),('10318','2013-03-25','10:20:00',5.2),('10318','2013-03-25','10:25:00',6.17),('10318','2013-03-25','10:30:00',3.98),('10318','2013-03-25','10:35:00',3.1),('10318','2013-03-25','10:40:00',3.06),('10318','2013-03-25','10:45:00',4.18),('10318','2013-03-25','10:50:00',5.28),('10318','2013-03-25','10:55:00',5.63),('10318','2013-03-25','11:00:00',6.32),('10318','2013-03-25','11:05:00',3.28),('10318','2013-03-25','11:10:00',2.17),('10318','2013-03-25','11:15:00',2.52),('10318','2013-03-25','11:20:00',3.26),('10318','2013-03-25','11:25:00',7.09),('10318','2013-03-25','11:30:00',5.38),('10318','2013-03-25','11:35:00',3.18),('10318','2013-03-25','11:40:00',3.1),('10318','2013-03-25','11:45:00',3.59),('10318','2013-03-25','11:50:00',4.2),('10318','2013-03-25','11:55:00',9.21),('10318','2013-03-25','12:00:00',10.33),('10318','2013-03-25','12:05:00',7.15),('10318','2013-03-25','12:10:00',7.29),('10318','2013-03-25','12:15:00',10.6),('10318','2013-03-25','12:20:00',10.87),('10318','2013-03-25','12:25:00',10.51),('10318','2013-03-25','12:30:00',5.77),('10318','2013-03-25','12:35:00',5.76),('10318','2013-03-25','12:40:00',5.8),('10318','2013-03-25','12:45:00',6.3),('10318','2013-03-25','12:50:00',6.22),('10318','2013-03-25','12:55:00',6.05),('10318','2013-03-25','13:00:00',5.94),('10318','2013-03-25','13:05:00',6.23),('10318','2013-03-25','13:10:00',5.73),('10318','2013-03-25','13:15:00',5.25),('10318','2013-03-25','13:20:00',3.33),('10318','2013-03-25','13:25:00',2.34),('10318','2013-03-25','13:30:00',1.98),('10318','2013-03-25','13:35:00',2.21),('10318','2013-03-25','13:40:00',2.89),('10318','2013-03-25','13:45:00',3.82),('10318','2013-03-25','13:50:00',3.27),('10318','2013-03-25','13:55:00',1.9),('10318','2013-03-25','14:00:00',1.85),('10318','2013-03-25','14:05:00',3.16),('10318','2013-03-25','14:10:00',3.21),('10318','2013-03-25','14:15:00',4.24),('10318','2013-03-25','14:20:00',5.27),('10318','2013-03-25','14:25:00',5.41),('10318','2013-03-25','14:30:00',6.82),('10318','2013-03-25','14:35:00',4.6),('10318','2013-03-25','14:40:00',5.58),('10318','2013-03-25','14:45:00',4.26),('10318','2013-03-25','14:50:00',4.08),('10318','2013-03-25','14:55:00',5.09),('10318','2013-03-25','15:00:00',4.14),('10318','2013-03-25','15:05:00',4.24),('10318','2013-03-25','15:10:00',5.93),('10318','2013-03-25','15:15:00',5.86),('10318','2013-03-25','15:20:00',5.18),('10318','2013-03-25','15:25:00',5.63),('10318','2013-03-25','15:30:00',6.2),('10318','2013-03-25','15:35:00',4.78),('10318','2013-03-25','15:40:00',3.76),('10318','2013-03-25','15:45:00',2.53),('10318','2013-03-25','15:50:00',4.73),('10318','2013-03-25','15:55:00',4.82),('10318','2013-03-25','16:00:00',4.1),('10318','2013-03-25','16:05:00',2.4),('10318','2013-03-25','16:10:00',2.5),('10318','2013-03-25','16:15:00',2.59),('10318','2013-03-25','16:20:00',1.36),('10318','2013-03-25','16:25:00',1.5),('10318','2013-03-25','16:30:00',3.07),('10318','2013-03-25','16:35:00',3.7),('10318','2013-03-25','16:40:00',2.9),('10318','2013-03-25','16:45:00',1.53),('10318','2013-03-25','16:50:00',1.16),('10318','2013-03-24','07:00:00',1.03),('10318','2013-03-24','07:05:00',1.31),('10318','2013-03-24','07:10:00',1.49),('10318','2013-03-24','07:15:00',1.75),('10318','2013-03-24','07:20:00',1.77),('10318','2013-03-24','07:25:00',2.19),('10318','2013-03-24','07:30:00',2.4),('10318','2013-03-24','07:35:00',2.63),('10318','2013-03-24','07:40:00',2.88),('10318','2013-03-24','07:45:00',3.3),('10318','2013-03-24','07:50:00',3.46),('10318','2013-03-24','07:55:00',3.88),('10318','2013-03-24','08:00:00',4.68),('10318','2013-03-24','08:05:00',5.07),('10318','2013-03-24','08:10:00',5.12),('10318','2013-03-24','08:15:00',5.45),('10318','2013-03-24','08:20:00',5.68),('10318','2013-03-24','08:25:00',5.87),('10318','2013-03-24','08:30:00',5.99),('10318','2013-03-24','08:35:00',6.16),('10318','2013-03-24','08:40:00',6.33),('10318','2013-03-24','08:45:00',6.36),('10318','2013-03-24','08:50:00',6.52),('10318','2013-03-24','08:55:00',6.59),('10318','2013-03-24','09:00:00',6.72),('10318','2013-03-24','09:05:00',6.9),('10318','2013-03-24','09:10:00',7.1),('10318','2013-03-24','09:15:00',7.22),('10318','2013-03-24','09:20:00',7.34),('10318','2013-03-24','09:25:00',7.49),('10318','2013-03-24','09:30:00',7.65),('10318','2013-03-24','09:35:00',7.74),('10318','2013-03-24','09:40:00',7.84),('10318','2013-03-24','09:45:00',7.96),('10318','2013-03-24','09:50:00',8.06),('10318','2013-03-24','09:55:00',8.11),('10318','2013-03-24','10:00:00',8.19),('10318','2013-03-24','10:05:00',8.32),('10318','2013-03-24','10:10:00',8.42),('10318','2013-03-24','10:15:00',8.5),('10318','2013-03-24','10:20:00',8.56),('10318','2013-03-24','10:25:00',8.59),('10318','2013-03-24','10:30:00',8.38),('10318','2013-03-24','10:35:00',8.74),('10318','2013-03-24','10:40:00',8.8),('10318','2013-03-24','10:45:00',8.8),('10318','2013-03-24','10:50:00',8.81),('10318','2013-03-24','10:55:00',8.85),('10318','2013-03-24','11:00:00',8.87),('10318','2013-03-24','11:05:00',8.9),('10318','2013-03-24','11:10:00',8.93),('10318','2013-03-24','11:15:00',8.91),('10318','2013-03-24','11:20:00',8.86),('10318','2013-03-24','11:25:00',8.89),('10318','2013-03-24','11:30:00',8.95),('10318','2013-03-24','11:35:00',8.95),('10318','2013-03-24','11:40:00',8.99),('10318','2013-03-24','11:45:00',8.9),('10318','2013-03-24','11:50:00',8.93),('10318','2013-03-24','11:55:00',8.89),('10318','2013-03-24','12:00:00',8.89),('10318','2013-03-24','12:05:00',8.94),('10318','2013-03-24','12:10:00',8.97),('10318','2013-03-24','12:15:00',9.07),('10318','2013-03-24','12:20:00',9.11),('10318','2013-03-24','12:25:00',9.31),('10318','2013-03-24','12:30:00',9.26),('10318','2013-03-24','12:35:00',9.3),('10318','2013-03-24','12:40:00',9.26),('10318','2013-03-24','12:45:00',9.11),('10318','2013-03-24','12:50:00',9.15),('10318','2013-03-24','12:55:00',9.06),('10318','2013-03-24','13:00:00',8.99),('10318','2013-03-24','13:05:00',8.94),('10318','2013-03-24','13:10:00',8.85),('10318','2013-03-24','13:15:00',8.81),('10318','2013-03-24','13:20:00',8.71),('10318','2013-03-24','13:25:00',8.58),('10318','2013-03-24','13:30:00',8.46),('10318','2013-03-24','13:35:00',8.39),('10318','2013-03-24','13:40:00',8.35),('10318','2013-03-24','13:45:00',8.23),('10318','2013-03-24','13:50:00',8.11),('10318','2013-03-24','13:55:00',7.94),('10318','2013-03-24','14:00:00',7.8),('10318','2013-03-24','14:05:00',7.53),('10318','2013-03-24','14:10:00',7.54),('10318','2013-03-24','14:15:00',7.36),('10318','2013-03-24','14:20:00',7.23),('10318','2013-03-24','14:25:00',7),('10318','2013-03-24','14:30:00',6.72),('10318','2013-03-24','14:35:00',6.52),('10318','2013-03-24','14:40:00',6.49),('10318','2013-03-24','14:45:00',6.41),('10318','2013-03-24','14:50:00',5.99),('10318','2013-03-24','14:55:00',6.06),('10318','2013-03-24','15:00:00',5.77),('10318','2013-03-24','15:05:00',5.74),('10318','2013-03-24','15:10:00',5.36),('10318','2013-03-24','15:15:00',5.65),('10318','2013-03-24','15:20:00',5.43),('10318','2013-03-24','15:25:00',5.17),('10318','2013-03-24','15:30:00',4.72),('10318','2013-03-24','15:35:00',4.44),('10318','2013-03-24','15:40:00',4.39),('10318','2013-03-24','15:45:00',3.63),('10318','2013-03-24','15:50:00',2.57),('10318','2013-03-24','15:55:00',2.5),('10318','2013-03-24','16:00:00',2.55),('10318','2013-03-24','16:05:00',2.67),('10318','2013-03-24','16:10:00',2.3),('10318','2013-03-24','16:15:00',2.9),('10318','2013-03-24','16:20:00',2.91),('10318','2013-03-24','16:25:00',2.04),('10318','2013-03-24','16:30:00',2.46),('10318','2013-03-24','16:35:00',2.02),('10318','2013-03-24','16:40:00',1.76),('10318','2013-03-24','16:45:00',1.75),('10318','2013-03-24','16:50:00',1.37),('10318','2013-03-24','16:55:00',1.22),('10318','2013-03-24','17:00:00',1.14),('10318','2013-03-23','07:00:00',1.29),('10318','2013-03-23','07:05:00',1.53),('10318','2013-03-23','07:10:00',1.76),('10318','2013-03-23','07:15:00',2.31),('10318','2013-03-23','07:20:00',2.7),('10318','2013-03-23','07:25:00',2.76),('10318','2013-03-23','07:30:00',3.08),('10318','2013-03-23','07:35:00',3.06),('10318','2013-03-23','07:40:00',3.69),('10318','2013-03-23','07:45:00',3.57),('10318','2013-03-23','07:50:00',4.08),('10318','2013-03-23','07:55:00',4.42),('10318','2013-03-23','08:00:00',4.87),('10318','2013-03-23','08:05:00',5.25),('10318','2013-03-23','08:10:00',5.37),('10318','2013-03-23','08:15:00',5.56),('10318','2013-03-23','08:20:00',5.69),('10318','2013-03-23','08:25:00',5.88),('10318','2013-03-23','08:30:00',5.92),('10318','2013-03-23','08:35:00',6.11),('10318','2013-03-23','08:40:00',6.36),('10318','2013-03-23','08:45:00',6.61),('10318','2013-03-23','08:50:00',6.74),('10318','2013-03-23','08:55:00',7),('10318','2013-03-23','09:00:00',7.16),('10318','2013-03-23','09:05:00',7.37),('10318','2013-03-23','09:10:00',7.44),('10318','2013-03-23','09:15:00',7.44),('10318','2013-03-23','09:20:00',7.53),('10318','2013-03-23','09:25:00',7.85),('10318','2013-03-23','09:30:00',8.1),('10318','2013-03-23','09:35:00',8.02),('10318','2013-03-23','09:40:00',7.9),('10318','2013-03-23','09:45:00',8.05),('10318','2013-03-23','09:50:00',8.06),('10318','2013-03-23','09:55:00',8.38),('10318','2013-03-23','10:00:00',8.43),('10318','2013-03-23','10:05:00',8.43),('10318','2013-03-23','10:10:00',7.37),('10318','2013-03-23','10:15:00',6.82),('10318','2013-03-23','10:20:00',8.5),('10318','2013-03-23','10:25:00',8.54),('10318','2013-03-23','10:30:00',8.68),('10318','2013-03-23','10:35:00',8.86),('10318','2013-03-23','10:40:00',8.81),('10318','2013-03-23','10:45:00',8.46),('10318','2013-03-23','10:50:00',8.54),('10318','2013-03-23','10:55:00',8.46),('10318','2013-03-23','11:00:00',8.4),('10318','2013-03-23','11:05:00',7.08),('10318','2013-03-23','11:10:00',6.88),('10318','2013-03-23','11:15:00',8.06),('10318','2013-03-23','11:20:00',8.84),('10318','2013-03-23','11:25:00',8.56),('10318','2013-03-23','11:30:00',8.75),('10318','2013-03-23','11:35:00',9.09),('10318','2013-03-23','11:40:00',8.98),('10318','2013-03-23','11:45:00',8.93),('10318','2013-03-23','11:50:00',8.6),('10318','2013-03-23','11:55:00',8.94),('10318','2013-03-23','12:00:00',9.07),('10318','2013-03-23','12:05:00',8.79),('10318','2013-03-23','12:10:00',9.09),('10318','2013-03-23','12:15:00',8.8),('10318','2013-03-23','12:20:00',8.84),('10318','2013-03-23','12:25:00',8.87),('10318','2013-03-23','12:30:00',8.96),('10318','2013-03-23','12:35:00',8.85),('10318','2013-03-23','12:40:00',8.53),('10318','2013-03-23','12:45:00',8.82),('10318','2013-03-23','12:50:00',8.82),('10318','2013-03-23','12:55:00',8.25),('10318','2013-03-23','13:00:00',6.71),('10318','2013-03-23','13:05:00',8.49),('10318','2013-03-23','13:10:00',8.63),('10318','2013-03-23','13:15:00',8.21),('10318','2013-03-23','13:20:00',8.51),('10318','2013-03-23','13:25:00',8.37),('10318','2013-03-23','13:30:00',8.25),('10318','2013-03-23','13:35:00',8.24),('10318','2013-03-23','13:40:00',8.11),('10318','2013-03-23','13:45:00',7.94),('10318','2013-03-23','13:50:00',7.82),('10318','2013-03-23','13:55:00',7.61),('10318','2013-03-23','14:00:00',7.36),('10318','2013-03-23','14:05:00',7.66),('10318','2013-03-23','14:10:00',7.28),('10318','2013-03-23','14:15:00',6.97),('10318','2013-03-23','14:20:00',7.15),('10318','2013-03-23','14:25:00',7.1),('10318','2013-03-23','14:30:00',6.93),('10318','2013-03-23','14:35:00',6.81),('10318','2013-03-23','14:40:00',6.52),('10318','2013-03-23','14:45:00',5.96),('10318','2013-03-23','14:50:00',6.06),('10318','2013-03-23','14:55:00',6.04),('10318','2013-03-23','15:00:00',5.81),('10318','2013-03-23','15:05:00',5.6),('10318','2013-03-23','15:10:00',5.5),('10318','2013-03-23','15:15:00',5.04),('10318','2013-03-23','15:20:00',5.2),('10318','2013-03-23','15:25:00',5),('10318','2013-03-23','15:30:00',4.47),('10318','2013-03-23','15:35:00',4.48),('10318','2013-03-23','15:40:00',4.23),('10318','2013-03-23','15:45:00',3.74),('10318','2013-03-23','15:50:00',3.67),('10318','2013-03-23','15:55:00',3.5),('10318','2013-03-23','16:00:00',3.15),('10318','2013-03-23','16:05:00',3.18),('10318','2013-03-23','16:10:00',3.73),('10318','2013-03-23','16:15:00',3.39),('10318','2013-03-23','16:20:00',2.91),('10318','2013-03-23','16:25:00',2.73),('10318','2013-03-23','16:30:00',2.36),('10318','2013-03-23','16:35:00',2.41),('10318','2013-03-23','16:40:00',2.02),('10318','2013-03-23','16:45:00',1.94),('10318','2013-03-23','16:50:00',1.69),('10318','2013-03-23','16:55:00',1.7),('10318','2013-03-23','17:00:00',1.94),('10318','2013-03-23','17:05:00',1.95),('10318','2013-03-23','17:10:00',1.65),('10318','2013-03-23','17:15:00',1.34),('10318','2013-03-23','17:20:00',1.15),('10318','2014-03-26','07:00:00',1.29),('10318','2014-03-26','07:05:00',1.5),('10318','2014-03-26','07:10:00',1.92),('10318','2014-03-26','07:15:00',2.82),('10318','2014-03-26','07:20:00',3.21),('10318','2014-03-26','07:25:00',3.46),('10318','2014-03-26','07:30:00',3.76),('10318','2014-03-26','07:35:00',4.06),('10318','2014-03-26','07:40:00',4.26),('10318','2014-03-26','07:45:00',4.53),('10318','2014-03-26','07:50:00',4.72),('10318','2014-03-26','07:55:00',5),('10318','2014-03-26','08:00:00',5.25),('10318','2014-03-26','08:05:00',5.46),('10318','2014-03-26','08:10:00',5.72),('10318','2014-03-26','08:15:00',6.22),('10318','2014-03-26','08:20:00',5.89),('10318','2014-03-26','08:25:00',3.21),('10318','2014-03-26','08:30:00',2.46),('10318','2014-03-26','08:35:00',2.04),('10318','2014-03-26','08:40:00',2.29),('10318','2014-03-26','08:45:00',2.63),('10318','2014-03-26','08:50:00',2.89),('10318','2014-03-26','08:55:00',3.71),('10318','2014-03-26','09:00:00',3.97),('10318','2014-03-26','09:05:00',3.45),('10318','2014-03-26','09:10:00',3.33),('10318','2014-03-26','09:15:00',4.47),('10318','2014-03-26','09:20:00',7.54),('10318','2014-03-26','09:25:00',7.6),('10318','2014-03-26','09:30:00',8.36),('10318','2014-03-26','09:35:00',8.35),('10318','2014-03-26','09:40:00',8.41),('10318','2014-03-26','09:45:00',8.49),('10318','2014-03-26','09:50:00',8.52),('10318','2014-03-26','09:55:00',7.61),('10318','2014-03-26','10:00:00',7.48),('10318','2014-03-26','10:05:00',5.13),('10318','2014-03-26','10:10:00',2.9),('10318','2014-03-26','10:15:00',9.02),('10318','2014-03-26','10:20:00',6.74),('10318','2014-03-26','10:25:00',6.28),('10318','2014-03-26','10:30:00',9.02),('10318','2014-03-26','10:35:00',4.23),('10318','2014-03-26','10:40:00',1.96),('10318','2014-03-26','10:45:00',5.36),('10318','2014-03-26','10:50:00',10.1),('10318','2014-03-26','10:55:00',4.86),('10318','2014-03-26','11:00:00',2.21),('10318','2014-03-26','11:05:00',6.27),('10318','2014-03-26','11:10:00',5.68),('10318','2014-03-26','11:15:00',4.25),('10318','2014-03-26','11:20:00',2.32),('10318','2014-03-26','11:25:00',2.02),('10318','2014-03-26','11:30:00',2.27),('10318','2014-03-26','11:35:00',6.33),('10318','2014-03-26','11:40:00',9.72),('10318','2014-03-26','11:45:00',9.87),('10318','2014-03-26','11:50:00',7.01),('10318','2014-03-26','11:55:00',5.7),('10318','2014-03-26','12:00:00',6.26),('10318','2014-03-26','12:05:00',7.32),('10318','2014-03-26','12:10:00',8.57),('10318','2014-03-26','12:15:00',3.58),('10318','2014-03-26','12:20:00',3.36),('10318','2014-03-26','12:25:00',3.27),('10318','2014-03-26','12:30:00',3.36),('10318','2014-03-26','12:35:00',3.45),('10318','2014-03-26','12:40:00',5),('10318','2014-03-26','12:45:00',5.74),('10318','2014-03-26','12:50:00',8.52),('10318','2014-03-26','12:55:00',9.89),('10318','2014-03-26','13:00:00',9.39),('10318','2014-03-26','13:05:00',9.83),('10318','2014-03-26','13:10:00',8.92),('10318','2014-03-26','13:15:00',8),('10318','2014-03-26','13:20:00',9.83),('10318','2014-03-26','13:25:00',7.55),('10318','2014-03-26','13:30:00',7.88),('10318','2014-03-26','13:35:00',5.23),('10318','2014-03-26','13:40:00',2.15),('10318','2014-03-26','13:45:00',2.65),('10318','2014-03-26','13:50:00',5.1),('10318','2014-03-26','13:55:00',8.44),('10318','2014-03-26','14:00:00',8.98),('10318','2014-03-26','14:05:00',9.7),('10318','2014-03-26','14:10:00',3.97),('10318','2014-03-26','14:15:00',3.27),('10318','2014-03-26','14:20:00',2.4),('10318','2014-03-26','14:25:00',1.95),('10318','2014-03-26','14:30:00',1.81),('10318','2014-03-26','14:35:00',1.65),('10318','2014-03-26','14:40:00',1.9),('10318','2014-03-26','14:45:00',4.16),('10318','2014-03-26','14:50:00',4.92),('10318','2014-03-26','14:55:00',6.91),('10318','2014-03-26','15:00:00',6.57),('10318','2014-03-26','15:05:00',5.94),('10318','2014-03-26','15:10:00',6.14),('10318','2014-03-26','15:15:00',6.28),('10318','2014-03-26','15:20:00',6.42),('10318','2014-03-26','15:25:00',5.58),('10318','2014-03-26','15:30:00',5.91),('10318','2014-03-26','15:35:00',5.72),('10318','2014-03-26','15:40:00',4.89),('10318','2014-03-26','15:45:00',4.12),('10318','2014-03-26','15:50:00',2.96),('10318','2014-03-26','15:55:00',2.21),('10318','2014-03-26','16:00:00',1.81),('10318','2014-03-26','16:05:00',2.73),('10318','2014-03-26','16:10:00',3.24),('10318','2014-03-26','16:15:00',4.08),('10318','2014-03-26','16:20:00',3.16),('10318','2014-03-26','16:25:00',2.3),('10318','2014-03-26','16:30:00',1.76),('10318','2014-03-26','16:35:00',1.51),('10318','2014-03-26','16:40:00',1.08),('10318','2014-03-26','16:45:00',1.05),('10318','2014-03-26','16:50:00',1.13),('10318','2014-03-26','16:55:00',1.09),('10318','2013-03-22','07:00:00',1.03),('10318','2013-03-22','07:05:00',1.27),('10318','2013-03-22','07:10:00',1.45),('10318','2013-03-22','07:15:00',1.93),('10318','2013-03-22','07:20:00',2.7),('10318','2013-03-22','07:25:00',3.15),('10318','2013-03-22','07:30:00',3.4),('10318','2013-03-22','07:35:00',3.69),('10318','2013-03-22','07:40:00',3.94),('10318','2013-03-22','07:45:00',4.16),('10318','2013-03-22','07:50:00',4.39),('10318','2013-03-22','07:55:00',4.58),('10318','2013-03-22','08:00:00',4.7),('10318','2013-03-22','08:05:00',5.04),('10318','2013-03-22','08:10:00',5.28),('10318','2013-03-22','08:15:00',5.49),('10318','2013-03-22','08:20:00',5.69),('10318','2013-03-22','08:25:00',5.91),('10318','2013-03-22','08:30:00',6.13),('10318','2013-03-22','08:35:00',6.31),('10318','2013-03-22','08:40:00',6.49),('10318','2013-03-22','08:45:00',6.67),('10318','2013-03-22','08:50:00',6.84),('10318','2013-03-22','08:55:00',7),('10318','2013-03-22','09:00:00',7.1),('10318','2013-03-22','09:05:00',7.22),('10318','2013-03-22','09:10:00',7.35),('10318','2013-03-22','09:15:00',7.47),('10318','2013-03-22','09:20:00',7.62),('10318','2013-03-22','09:25:00',7.68),('10318','2013-03-22','09:30:00',7.84),('10318','2013-03-22','09:35:00',7.97),('10318','2013-03-22','09:40:00',7.98),('10318','2013-03-22','09:45:00',7.94),('10318','2013-03-22','09:50:00',8.2),('10318','2013-03-22','09:55:00',8.24),('10318','2013-03-22','10:00:00',8.43),('10318','2013-03-22','10:05:00',8.49),('10318','2013-03-22','10:10:00',8.56),('10318','2013-03-22','10:15:00',8.66),('10318','2013-03-22','10:20:00',8.76),('10318','2013-03-22','10:25:00',8.82),('10318','2013-03-22','10:30:00',8.92),('10318','2013-03-22','10:35:00',9.1),('10318','2013-03-22','10:40:00',9.12),('10318','2013-03-22','10:45:00',9.21),('10318','2013-03-22','10:50:00',9.25),('10318','2013-03-22','10:55:00',9.3),('10318','2013-03-22','11:00:00',9.32),('10318','2013-03-22','11:05:00',9.45),('10318','2013-03-22','11:10:00',9.41),('10318','2013-03-22','11:15:00',9.42),('10318','2013-03-22','11:20:00',9.47),('10318','2013-03-22','11:25:00',9.41),('10318','2013-03-22','11:30:00',9.39),('10318','2013-03-22','11:35:00',9.6),('10318','2013-03-22','11:40:00',9.63),('10318','2013-03-22','11:45:00',9.66),('10318','2013-03-22','11:50:00',9.66),('10318','2013-03-22','11:55:00',9.66),('10318','2013-03-22','12:00:00',9.68),('10318','2013-03-22','12:05:00',9.65),('10318','2013-03-22','12:10:00',9.59),('10318','2013-03-22','12:15:00',9.58),('10318','2013-03-22','12:20:00',9.56),('10318','2013-03-22','12:25:00',9.53),('10318','2013-03-22','12:30:00',9.51),('10318','2013-03-22','12:35:00',9.43),('10318','2013-03-22','12:40:00',9.39),('10318','2013-03-22','12:45:00',9.36),('10318','2013-03-22','12:50:00',9.08),('10318','2013-03-22','12:55:00',9.05),('10318','2013-03-22','13:00:00',9.19),('10318','2013-03-22','13:05:00',9.22),('10318','2013-03-22','13:10:00',9.16),('10318','2013-03-22','13:15:00',9.01),('10318','2013-03-22','13:20:00',8.84),('10318','2013-03-22','13:25:00',7.98),('10318','2013-03-22','13:30:00',8.49),('10318','2013-03-22','13:35:00',8.28),('10318','2013-03-22','13:40:00',7.17),('10318','2013-03-22','13:45:00',8.26),('10318','2013-03-22','13:50:00',8.45),('10318','2013-03-22','13:55:00',8.22),('10318','2013-03-22','14:00:00',8.07),('10318','2013-03-22','14:05:00',7.93),('10318','2013-03-22','14:10:00',7.83),('10318','2013-03-22','14:15:00',7.68),('10318','2013-03-22','14:20:00',7.5),('10318','2013-03-22','14:25:00',7.36),('10318','2013-03-22','14:30:00',7.16),('10318','2013-03-22','14:35:00',6.89),('10318','2013-03-22','14:40:00',6.87),('10318','2013-03-22','14:45:00',6.65),('10318','2013-03-22','14:50:00',6.54),('10318','2013-03-22','14:55:00',6.38),('10318','2013-03-22','15:00:00',6.22),('10318','2013-03-22','15:05:00',5.97),('10318','2013-03-22','15:10:00',5.18),('10318','2013-03-22','15:15:00',4.27),('10318','2013-03-22','15:20:00',4.38),('10318','2013-03-22','15:25:00',4.45),('10318','2013-03-22','15:30:00',4.44),('10318','2013-03-22','15:35:00',4.64),('10318','2013-03-22','15:40:00',4.22),('10318','2013-03-22','15:45:00',3.85),('10318','2013-03-22','15:50:00',4.07),('10318','2013-03-22','15:55:00',3.41),('10318','2013-03-22','16:00:00',2.55),('10318','2013-03-22','16:05:00',2.94),('10318','2013-03-22','16:10:00',3.3),('10318','2013-03-22','16:15:00',3.5),('10318','2013-03-22','16:20:00',2.73),('10318','2013-03-22','16:25:00',2.97),('10318','2013-03-22','16:30:00',3.11),('10318','2013-03-22','16:35:00',3.06),('10318','2013-03-22','16:40:00',2.93),('10318','2013-03-22','16:45:00',2.45),('10318','2013-03-22','16:50:00',2.54),('10318','2013-03-22','16:55:00',2.4),('10318','2013-03-22','17:00:00',1.63),('10318','2013-03-22','17:05:00',1.38),('10318','2013-03-22','17:15:00',1.3),('10318','2013-03-22','17:25:00',1.05),('10318','2013-03-21','07:20:00',2.31),('10318','2013-03-21','07:25:00',3.38),('10318','2013-03-21','07:30:00',3.62),('10318','2013-03-21','07:35:00',3.99),('10318','2013-03-21','07:40:00',4.32),('10318','2013-03-21','07:45:00',5.11),('10318','2013-03-21','07:50:00',5.37),('10318','2013-03-21','07:55:00',2.09),('10318','2013-03-21','08:00:00',1.69),('10318','2013-03-21','08:05:00',3.23),('10318','2013-03-21','08:10:00',5.41),('10318','2013-03-21','08:15:00',5.5),('10318','2013-03-21','08:20:00',4.41),('10318','2013-03-21','08:25:00',6.12),('10318','2013-03-21','08:30:00',6.16),('10318','2013-03-21','08:35:00',6.46),('10318','2013-03-21','08:40:00',6.79),('10318','2013-03-21','08:45:00',6.81),('10318','2013-03-21','08:50:00',7.18),('10318','2013-03-21','08:55:00',7.79),('10318','2013-03-21','09:00:00',8.34),('10318','2013-03-21','09:05:00',4.59),('10318','2013-03-21','09:10:00',4.69),('10318','2013-03-21','09:15:00',3.68),('10318','2013-03-21','09:20:00',4.33),('10318','2013-03-21','09:25:00',6.42),('10318','2013-03-21','09:30:00',8.25),('10318','2013-03-21','09:35:00',8.51),('10318','2013-03-21','09:40:00',8.68),('10318','2013-03-21','09:45:00',8.82),('10318','2013-03-21','09:50:00',8.82),('10318','2013-03-21','09:55:00',9.04),('10318','2013-03-21','10:00:00',9.12),('10318','2013-03-21','10:05:00',9.08),('10318','2013-03-21','10:10:00',9.19),('10318','2013-03-21','10:15:00',9.24),('10318','2013-03-21','10:20:00',9.21),('10318','2013-03-21','10:25:00',9.34),('10318','2013-03-21','10:30:00',9.46),('10318','2013-03-21','10:35:00',9.42),('10318','2013-03-21','10:40:00',9.34),('10318','2013-03-21','10:45:00',9.33),('10318','2013-03-21','10:50:00',9.49),('10318','2013-03-21','10:55:00',9.67),('10318','2013-03-21','11:00:00',9.63),('10318','2013-03-21','11:05:00',9.56),('10318','2013-03-21','11:10:00',9.75),('10318','2013-03-21','11:15:00',9.77),('10318','2013-03-21','11:20:00',9.85),('10318','2013-03-21','11:25:00',9.99),('10318','2013-03-21','11:30:00',9.94),('10318','2013-03-21','11:35:00',10.03),('10318','2013-03-21','11:40:00',9.98),('10318','2013-03-21','11:45:00',10.03),('10318','2013-03-21','11:50:00',10.04),('10318','2013-03-21','11:55:00',10.06),('10318','2013-03-21','12:00:00',9.97),('10318','2013-03-21','12:05:00',9.93),('10318','2013-03-21','12:10:00',9.97),('10318','2013-03-21','12:15:00',9.93),('10318','2013-03-21','12:20:00',9.85),('10318','2013-03-21','12:25:00',9.91),('10318','2013-03-21','12:30:00',9.91),('10318','2013-03-21','12:35:00',9.88),('10318','2013-03-21','12:40:00',9.81),('10318','2013-03-21','12:45:00',9.69),('10318','2013-03-21','12:50:00',9.54),('10318','2013-03-21','12:55:00',9.51),('10318','2013-03-21','13:00:00',9.42),('10318','2013-03-21','13:05:00',9.36),('10318','2013-03-21','13:10:00',9.24),('10318','2013-03-21','13:15:00',9.14),('10318','2013-03-21','13:20:00',9.05),('10318','2013-03-21','13:25:00',8.95),('10318','2013-03-21','13:30:00',8.88),('10318','2013-03-21','13:35:00',8.77),('10318','2013-03-21','13:40:00',8.67),('10318','2013-03-21','13:45:00',8.62),('10318','2013-03-21','13:50:00',8.47),('10318','2013-03-21','13:55:00',8.35),('10318','2013-03-21','14:00:00',8.21),('10318','2013-03-21','14:05:00',8.01),('10318','2013-03-21','14:10:00',7.9),('10318','2013-03-21','14:15:00',7.73),('10318','2013-03-21','14:20:00',7.61),('10318','2013-03-21','14:25:00',7.44),('10318','2013-03-21','14:30:00',7.27),('10318','2013-03-21','14:35:00',6.93),('10318','2013-03-21','14:40:00',6.91),('10318','2013-03-21','14:45:00',6.78),('10318','2013-03-21','14:50:00',6.63),('10318','2013-03-21','14:55:00',6.47),('10318','2013-03-21','15:00:00',6.3),('10318','2013-03-21','15:05:00',6.12),('10318','2013-03-21','15:10:00',5.95),('10318','2013-03-21','15:15:00',5.75),('10318','2013-03-21','15:20:00',5.54),('10318','2013-03-21','15:25:00',5.36),('10318','2013-03-21','15:30:00',5.16),('10318','2013-03-21','15:35:00',4.95),('10318','2013-03-21','15:40:00',4.72),('10318','2013-03-21','15:45:00',4.51),('10318','2013-03-21','15:50:00',4.31),('10318','2013-03-21','15:55:00',4.11),('10318','2013-03-21','16:00:00',3.91),('10318','2013-03-21','16:05:00',3.71),('10318','2013-03-21','16:10:00',3.53),('10318','2013-03-21','16:15:00',3.33),('10318','2013-03-21','16:20:00',3.11),('10318','2013-03-21','16:25:00',2.95),('10318','2013-03-21','16:30:00',2.76),('10318','2013-03-21','16:35:00',2.6),('10318','2013-03-21','16:40:00',2.42),('10318','2013-03-21','16:45:00',2.25),('10318','2013-03-21','16:50:00',2.06),('10318','2013-03-21','16:55:00',1.89),('10318','2013-03-21','17:00:00',1.73),('10318','2013-03-21','17:05:00',1.56),('10318','2013-03-21','17:10:00',1.4),('10318','2013-03-21','17:15:00',1.19),('10318','2013-03-21','17:20:00',1.01),('10318','2013-03-20','07:05:00',1.21),('10318','2013-03-20','07:10:00',1.42),('10318','2013-03-20','07:15:00',1.62),('10318','2013-03-20','07:20:00',2.19),('10318','2013-03-20','07:25:00',3.03),('10318','2013-03-20','07:30:00',3.42),('10318','2013-03-20','07:35:00',3.74),('10318','2013-03-20','07:40:00',3.93),('10318','2013-03-20','07:45:00',3.95),('10318','2013-03-20','07:50:00',4.22),('10318','2013-03-20','07:55:00',4.87),('10318','2013-03-20','08:00:00',3.26),('10318','2013-03-20','08:05:00',5.26),('10318','2013-03-20','08:10:00',5.23),('10318','2013-03-20','08:15:00',5.46),('10318','2013-03-20','08:20:00',5.47),('10318','2013-03-20','08:25:00',5.86),('10318','2013-03-20','08:30:00',6.19),('10318','2013-03-20','08:35:00',5.82),('10318','2013-03-20','08:40:00',6.07),('10318','2013-03-20','08:45:00',6.34),('10318','2013-03-20','08:50:00',6.53),('10318','2013-03-20','08:55:00',6.36),('10318','2013-03-20','09:00:00',6.64),('10318','2013-03-20','09:05:00',5.89),('10318','2013-03-20','09:10:00',5.87),('10318','2013-03-20','09:15:00',7.39),('10318','2013-03-20','09:20:00',5.76),('10318','2013-03-20','09:25:00',7.65),('10318','2013-03-20','09:30:00',8.19),('10318','2013-03-20','09:35:00',7.8),('10318','2013-03-20','09:40:00',8.12),('10318','2013-03-20','09:45:00',8.27),('10318','2013-03-20','09:50:00',7.86),('10318','2013-03-20','09:55:00',8.16),('10318','2013-03-20','10:00:00',8.41),('10318','2013-03-20','10:05:00',7.26),('10318','2013-03-20','10:10:00',7.99),('10318','2013-03-20','10:15:00',8.12),('10318','2013-03-20','10:20:00',5.04),('10318','2013-03-20','10:25:00',5.34),('10318','2013-03-20','10:30:00',9.1),('10318','2013-03-20','10:35:00',9.34),('10318','2013-03-20','10:40:00',6.99),('10318','2013-03-20','10:45:00',6.74),('10318','2013-03-20','10:50:00',7.96),('10318','2013-03-20','10:55:00',7.21),('10318','2013-03-20','11:00:00',6.05),('10318','2013-03-20','11:05:00',7.66),('10318','2013-03-20','11:10:00',5.56),('10318','2013-03-20','11:15:00',5.59),('10318','2013-03-20','11:20:00',6.41),('10318','2013-03-20','11:25:00',6.05),('10318','2013-03-20','11:30:00',5.55),('10318','2013-03-20','11:35:00',6.21),('10318','2013-03-20','11:40:00',4.96),('10318','2013-03-20','11:45:00',4.72),('10318','2013-03-20','11:50:00',4.63),('10318','2013-03-20','11:55:00',4.83),('10318','2013-03-20','12:00:00',4.97),('10318','2013-03-20','12:05:00',5.18),('10318','2013-03-20','12:10:00',4.38),('10318','2013-03-20','12:15:00',3.67),('10318','2013-03-20','12:20:00',3.28),('10318','2013-03-20','12:25:00',2.77),('10318','2013-03-20','12:30:00',2.48),('10318','2013-03-20','12:35:00',3.17),('10318','2013-03-20','12:40:00',2.29),('10318','2013-03-20','12:45:00',2.61),('10318','2013-03-20','12:50:00',3.37),('10318','2013-03-20','12:55:00',4.31),('10318','2013-03-20','13:00:00',3.88),('10318','2013-03-20','13:05:00',3.02),('10318','2013-03-20','13:10:00',2.93),('10318','2013-03-20','13:15:00',2.61),('10318','2013-03-20','13:20:00',2.75),('10318','2013-03-20','13:25:00',3.04),('10318','2013-03-20','13:30:00',3.27),('10318','2013-03-20','13:35:00',3.17),('10318','2013-03-20','13:40:00',4.14),('10318','2013-03-20','13:45:00',4.41),('10318','2013-03-20','13:50:00',3.7),('10318','2013-03-20','13:55:00',3.55),('10318','2013-03-20','14:00:00',3.54),('10318','2013-03-20','14:05:00',2.96),('10318','2013-03-20','14:10:00',2.89),('10318','2013-03-20','14:15:00',4.07),('10318','2013-03-20','14:20:00',4.59),('10318','2013-03-20','14:25:00',4.39),('10318','2013-03-20','14:30:00',3.83),('10318','2013-03-20','14:35:00',3.01),('10318','2013-03-20','14:40:00',2.44),('10318','2013-03-20','14:45:00',2.44),('10318','2013-03-20','14:50:00',1.9),('10318','2013-03-20','14:55:00',1.43),('10318','2013-03-20','15:00:00',1.69),('10318','2013-03-20','15:05:00',1.6),('10318','2013-03-20','15:10:00',1.41),('10318','2013-03-20','15:15:00',1.18),('10318','2013-03-20','15:20:00',1.14),('10318','2013-03-20','15:25:00',1.18),('10318','2013-03-20','15:30:00',1.42),('10318','2013-03-20','15:35:00',1.14),('10318','2013-03-19','07:00:00',1.08),('10318','2013-03-19','07:05:00',1.33),('10318','2013-03-19','07:20:00',2.01),('10318','2013-03-19','07:25:00',2.8),('10318','2013-03-19','07:30:00',3.18),('10318','2013-03-19','07:35:00',3.51),('10318','2013-03-19','07:40:00',3.76),('10318','2013-03-19','07:45:00',4),('10318','2013-03-19','07:50:00',4.36),('10318','2013-03-19','07:55:00',4.15),('10318','2013-03-19','08:00:00',3.44),('10318','2013-03-19','08:05:00',4.49),('10318','2013-03-19','08:10:00',4.89),('10318','2013-03-19','08:15:00',5.33),('10318','2013-03-19','08:20:00',5.58),('10318','2013-03-19','08:25:00',5.82),('10318','2013-03-19','08:30:00',6.11),('10318','2013-03-19','08:35:00',6.32),('10318','2013-03-19','08:40:00',6.42),('10318','2013-03-19','08:45:00',6.71),('10318','2013-03-19','08:50:00',6.72),('10318','2013-03-19','08:55:00',6.98),('10318','2013-03-19','09:00:00',7.18),('10318','2013-03-19','09:05:00',7.08),('10318','2013-03-19','09:10:00',7.49),('10318','2013-03-19','09:15:00',7.65),('10318','2013-03-19','09:20:00',7.8),('10318','2013-03-19','09:25:00',7.9),('10318','2013-03-19','09:30:00',8.06),('10318','2013-03-19','09:35:00',8.18),('10318','2013-03-19','09:40:00',7.48),('10318','2013-03-19','09:45:00',8.66),('10318','2013-03-19','09:50:00',6.9),('10318','2013-03-19','09:55:00',8.19),('10318','2013-03-19','10:00:00',6.67),('10318','2013-03-19','10:05:00',8.51),('10318','2013-03-19','10:10:00',9.1),('10318','2013-03-19','10:15:00',9.12),('10318','2013-03-19','10:20:00',9.22),('10318','2013-03-19','10:25:00',9.29),('10318','2013-03-19','10:30:00',9.29),('10318','2013-03-19','10:35:00',9.41),('10318','2013-03-19','10:40:00',9.49),('10318','2013-03-19','10:45:00',9.57),('10318','2013-03-19','10:50:00',9.42),('10318','2013-03-19','10:55:00',9.82),('10318','2013-03-19','11:00:00',9.82),('10318','2013-03-19','11:05:00',9.52),('10318','2013-03-19','11:10:00',9.83),('10318','2013-03-19','11:15:00',9.57),('10318','2013-03-19','11:20:00',9.85),('10318','2013-03-19','11:25:00',9.9),('10318','2013-03-19','11:30:00',9.78),('10318','2013-03-19','11:35:00',5.93),('10318','2013-03-19','11:40:00',8.62),('10318','2013-03-19','11:45:00',8.96),('10318','2013-03-19','11:50:00',10.04),('10318','2013-03-19','11:55:00',10.1),('10318','2013-03-19','12:00:00',9.96),('10318','2013-03-19','12:05:00',9.73),('10318','2013-03-19','12:10:00',9.84),('10318','2013-03-19','12:15:00',9.44),('10318','2013-03-19','12:20:00',9.81),('10318','2013-03-19','12:25:00',9.65),('10318','2013-03-19','12:30:00',9.66),('10318','2013-03-19','12:35:00',9.46),('10318','2013-03-19','12:40:00',9.57),('10318','2013-03-19','12:45:00',9.54),('10318','2013-03-19','12:50:00',8.69),('10318','2013-03-19','12:55:00',9.2),('10318','2013-03-19','13:00:00',9.17),('10318','2013-03-19','13:05:00',9.15),('10318','2013-03-19','13:10:00',9.12),('10318','2013-03-19','13:15:00',9.06),('10318','2013-03-19','13:20:00',8.94),('10318','2013-03-19','13:25:00',8.85),('10318','2013-03-19','13:30:00',8.71),('10318','2013-03-19','13:35:00',8.55),('10318','2013-03-19','13:40:00',8.4),('10318','2013-03-19','13:45:00',8.46),('10318','2013-03-19','13:50:00',8.18),('10318','2013-03-19','13:55:00',8.22),('10318','2013-03-19','14:00:00',8.1),('10318','2013-03-19','14:05:00',7.93),('10318','2013-03-19','14:10:00',7.76),('10318','2013-03-19','14:15:00',7.62),('10318','2013-03-19','14:20:00',7.48),('10318','2013-03-19','14:25:00',7.31),('10318','2013-03-19','14:30:00',7.2),('10318','2013-03-19','14:35:00',7.04),('10318','2013-03-19','14:40:00',6.86),('10318','2013-03-19','14:45:00',6.72),('10318','2013-03-19','14:50:00',6.49),('10318','2013-03-19','14:55:00',6.43),('10318','2013-03-19','15:00:00',6.23),('10318','2013-03-19','15:05:00',6.02),('10318','2013-03-19','15:10:00',5.87),('10318','2013-03-19','15:15:00',5.65),('10318','2013-03-19','15:20:00',5.49),('10318','2013-03-19','15:25:00',5.31),('10318','2013-03-19','15:30:00',5.1),('10318','2013-03-19','15:35:00',4.77),('10318','2013-03-19','15:40:00',4.71),('10318','2013-03-19','15:45:00',4.54),('10318','2013-03-19','15:50:00',4.31),('10318','2013-03-19','15:55:00',4.14),('10318','2013-03-19','16:00:00',3.95),('10318','2013-03-19','16:05:00',3.73),('10318','2013-03-19','16:10:00',3.51),('10318','2013-03-19','16:15:00',3.36),('10318','2013-03-19','16:20:00',3.16),('10318','2013-03-19','16:25:00',2.98),('10318','2013-03-19','16:30:00',2.8),('10318','2013-03-19','16:35:00',2.58),('10318','2013-03-19','16:40:00',2.46),('10318','2013-03-19','16:45:00',1.95),('10318','2013-03-19','16:50:00',1.6),('10318','2013-03-19','16:55:00',1.75),('10318','2013-03-19','17:00:00',1.23),('10318','2013-03-19','17:05:00',1.19),('10318','2013-03-19','17:10:00',1.23),('10318','2013-03-19','17:15:00',1.37),('10318','2013-03-19','17:20:00',1.23),('10318','2013-03-18','08:00:00',1.03),('10318','2013-03-18','08:10:00',1.01),('10318','2013-03-18','08:15:00',1.18),('10318','2013-03-18','08:20:00',1.44),('10318','2013-03-18','08:25:00',1.58),('10318','2013-03-18','08:30:00',1.59),('10318','2013-03-18','08:35:00',1.74),('10318','2013-03-18','08:40:00',1.93),('10318','2013-03-18','08:45:00',2.44),('10318','2013-03-18','08:50:00',1.94),('10318','2013-03-18','08:55:00',1.51),('10318','2013-03-18','09:20:00',1.13),('10318','2013-03-18','09:25:00',1.17),('10318','2013-03-18','09:30:00',1.22),('10318','2013-03-18','09:35:00',1.41),('10318','2013-03-18','09:40:00',1.67),('10318','2013-03-18','09:45:00',1.68),('10318','2013-03-18','09:50:00',1.91),('10318','2013-03-18','09:55:00',2.66),('10318','2013-03-18','10:00:00',3.22),('10318','2013-03-18','10:05:00',3.78),('10318','2013-03-18','10:10:00',4.2),('10318','2013-03-18','10:15:00',3.56),('10318','2013-03-18','10:20:00',4.04),('10318','2013-03-18','10:25:00',4.65),('10318','2013-03-18','10:30:00',4.3),('10318','2013-03-18','10:35:00',3.75),('10318','2013-03-18','10:40:00',3.51),('10318','2013-03-18','10:45:00',3.94),('10318','2013-03-18','10:50:00',3.11),('10318','2013-03-18','10:55:00',2.64),('10318','2013-03-18','11:00:00',2.94),('10318','2013-03-18','11:05:00',3.29),('10318','2013-03-18','11:10:00',3.79),('10318','2013-03-18','11:15:00',4.33),('10318','2013-03-18','11:20:00',4.39),('10318','2013-03-18','11:25:00',4.53),('10318','2013-03-18','11:30:00',6),('10318','2013-03-18','11:35:00',4.65),('10318','2013-03-18','11:40:00',3.98),('10318','2013-03-18','11:45:00',3.31),('10318','2013-03-18','11:50:00',2.88),('10318','2013-03-18','11:55:00',3.53),('10318','2013-03-18','12:00:00',3.64),('10318','2013-03-18','12:05:00',5.53),('10318','2013-03-18','12:10:00',6.03),('10318','2013-03-18','12:15:00',7.83),('10318','2013-03-18','12:20:00',7.04),('10318','2013-03-18','12:25:00',6.5),('10318','2013-03-18','12:30:00',8.7),('10318','2013-03-18','12:35:00',8.38),('10318','2013-03-18','12:40:00',5.34),('10318','2013-03-18','12:45:00',6.68),('10318','2013-03-18','12:50:00',7.77),('10318','2013-03-18','12:55:00',8.23),('10318','2013-03-18','13:00:00',6.81),('10318','2013-03-18','13:05:00',3.47),('10318','2013-03-18','13:10:00',2.85),('10318','2013-03-18','13:15:00',2.12),('10318','2013-03-18','13:20:00',3.08),('10318','2013-03-18','13:25:00',5.58),('10318','2013-03-18','13:30:00',2.75),('10318','2013-03-18','13:35:00',2.8),('10318','2013-03-18','13:40:00',4.36),('10318','2013-03-18','13:45:00',4.1),('10318','2013-03-18','13:50:00',3.48),('10318','2013-03-18','13:55:00',2.83),('10318','2013-03-18','14:00:00',3.97),('10318','2013-03-18','14:05:00',4.35),('10318','2013-03-18','14:10:00',5.04),('10318','2013-03-18','14:15:00',2.53),('10318','2013-03-18','14:20:00',2.79),('10318','2013-03-18','14:25:00',2.83),('10318','2013-03-18','14:30:00',1.77),('10318','2013-03-18','14:35:00',2.44),('10318','2013-03-18','14:40:00',2.33),('10318','2013-03-18','14:45:00',1.88),('10318','2013-03-18','14:50:00',1.22),('10318','2013-03-18','14:55:00',2.2),('10318','2013-03-18','15:00:00',2.18),('10318','2013-03-18','15:05:00',2),('10318','2013-03-18','15:10:00',1.52),('10318','2013-03-18','15:15:00',1.97),('10318','2013-03-18','15:20:00',1.35),('10318','2013-03-18','15:25:00',1.33),('10318','2013-03-18','15:30:00',1.32),('10318','2013-03-18','15:35:00',1.17),('10318','2013-03-17','07:40:00',1.08),('10318','2013-03-17','07:45:00',1.22),('10318','2013-03-17','07:50:00',1.39),('10318','2013-03-17','07:55:00',1.49),('10318','2013-03-17','08:00:00',1.66),('10318','2013-03-17','08:05:00',1.99),('10318','2013-03-17','08:10:00',2.17),('10318','2013-03-17','08:15:00',3.13),('10318','2013-03-17','08:20:00',2.92),('10318','2013-03-17','08:25:00',4.33),('10318','2013-03-17','08:30:00',3.11),('10318','2013-03-17','08:35:00',2.78),('10318','2013-03-17','08:40:00',3.07),('10318','2013-03-17','08:45:00',3.57),('10318','2013-03-17','08:50:00',3.36),('10318','2013-03-17','08:55:00',2.97),('10318','2013-03-17','09:00:00',3.04),('10318','2013-03-17','09:05:00',3.69),('10318','2013-03-17','09:10:00',4.41),('10318','2013-03-17','09:15:00',4.56),('10318','2013-03-17','09:20:00',3.57),('10318','2013-03-17','09:25:00',2.86),('10318','2013-03-17','09:30:00',3.44),('10318','2013-03-17','09:35:00',3.63),('10318','2013-03-17','09:40:00',3.39),('10318','2013-03-17','09:45:00',3.64),('10318','2013-03-17','09:50:00',4.15),('10318','2013-03-17','09:55:00',4.36),('10318','2013-03-17','10:00:00',4.87),('10318','2013-03-17','10:05:00',3.84),('10318','2013-03-17','10:10:00',3.94),('10318','2013-03-17','10:15:00',4.18),('10318','2013-03-17','10:20:00',4.3),('10318','2013-03-17','10:25:00',4.48),('10318','2013-03-17','10:30:00',4.29),('10318','2013-03-17','10:35:00',4.14),('10318','2013-03-17','10:40:00',3.93),('10318','2013-03-17','10:45:00',4.09),('10318','2013-03-17','10:50:00',3.46),('10318','2013-03-17','10:55:00',2.89),('10318','2013-03-17','11:00:00',2.94),('10318','2013-03-17','11:05:00',2.89),('10318','2013-03-17','11:10:00',2.9),('10318','2013-03-17','11:15:00',3.36),('10318','2013-03-17','11:20:00',4.03),('10318','2013-03-17','11:25:00',3.75),('10318','2013-03-17','11:30:00',3.43),('10318','2013-03-17','11:35:00',3.43),('10318','2013-03-17','11:40:00',3.27),('10318','2013-03-17','11:45:00',2.98),('10318','2013-03-17','11:50:00',2.79),('10318','2013-03-17','11:55:00',2.53),('10318','2013-03-17','12:00:00',2.41),('10318','2013-03-17','12:05:00',2.46),('10318','2013-03-17','12:10:00',3.31),('10318','2013-03-17','12:15:00',4.59),('10318','2013-03-17','12:20:00',5.41),('10318','2013-03-17','12:25:00',6.98),('10318','2013-03-17','12:30:00',6.64),('10318','2013-03-17','12:35:00',5.46),('10318','2013-03-17','12:40:00',5.55),('10318','2013-03-17','12:45:00',5.28),('10318','2013-03-17','12:50:00',4.45),('10318','2013-03-17','12:55:00',3.88),('10318','2013-03-17','13:00:00',4.62),('10318','2013-03-17','13:05:00',4.77),('10318','2013-03-17','13:10:00',5.23),('10318','2013-03-17','13:15:00',4.72),('10318','2013-03-17','13:20:00',4.11),('10318','2013-03-17','13:25:00',4.07),('10318','2013-03-17','13:30:00',6.16),('10318','2013-03-17','13:35:00',5.34),('10318','2013-03-17','13:40:00',4.35),('10318','2013-03-17','13:45:00',3.71),('10318','2013-03-17','13:50:00',3.41),('10318','2013-03-17','13:55:00',5.24),('10318','2013-03-17','14:00:00',4.46),('10318','2013-03-17','14:05:00',5.1),('10318','2013-03-17','14:10:00',6.17),('10318','2013-03-17','14:15:00',5.54),('10318','2013-03-17','14:20:00',5.84),('10318','2013-03-17','14:25:00',5.41),('10318','2013-03-17','14:30:00',4.64),('10318','2013-03-17','14:35:00',4.33),('10318','2013-03-17','14:40:00',3.32),('10318','2013-03-17','14:45:00',3.04),('10318','2013-03-17','14:50:00',2.52),('10318','2013-03-17','14:55:00',2.85),('10318','2013-03-17','15:00:00',3.58),('10318','2013-03-17','15:05:00',4.62),('10318','2013-03-17','15:10:00',6.5),('10318','2013-03-17','15:15:00',5.28),('10318','2013-03-17','15:20:00',6.37),('10318','2013-03-17','15:25:00',5.2),('10318','2013-03-17','15:30:00',3.64),('10318','2013-03-17','15:35:00',2.94),('10318','2013-03-17','15:40:00',2.58),('10318','2013-03-17','15:45:00',2.67),('10318','2013-03-17','15:50:00',1.58),('10318','2013-03-17','15:55:00',1.47),('10318','2013-03-17','16:00:00',1.31),('10318','2013-03-17','16:15:00',1.61),('10318','2013-03-17','16:20:00',1.32),('10318','2013-03-17','16:30:00',1.16),('10318','2013-03-17','16:35:00',1.31),('10318','2013-03-17','16:40:00',1.9),('10318','2013-03-17','16:45:00',1.74),('10318','2013-03-16','07:30:00',1.04),('10318','2013-03-16','07:35:00',1.12),('10318','2013-03-16','07:40:00',1.32),('10318','2013-03-16','07:45:00',2.34),('10318','2013-03-16','07:50:00',2.07),('10318','2013-03-16','07:55:00',2.31),('10318','2013-03-16','08:00:00',2.31),('10318','2013-03-16','08:05:00',3.72),('10318','2013-03-16','08:10:00',3.82),('10318','2013-03-16','08:15:00',3.34),('10318','2013-03-16','08:20:00',5.04),('10318','2013-03-16','08:25:00',6.04),('10318','2013-03-16','08:30:00',6.36),('10318','2013-03-16','08:35:00',6.54),('10318','2013-03-16','08:40:00',6.35),('10318','2013-03-16','08:45:00',6.41),('10318','2013-03-16','08:50:00',7.36),('10318','2013-03-16','08:55:00',7.32),('10318','2013-03-16','09:00:00',7.38),('10318','2013-03-16','09:05:00',6.67),('10318','2013-03-16','09:10:00',7.88),('10318','2013-03-16','09:15:00',7.89),('10318','2013-03-16','09:20:00',8.19),('10318','2013-03-16','09:25:00',7.22),('10318','2013-03-16','09:30:00',8.62),('10318','2013-03-16','09:35:00',8.49),('10318','2013-03-16','09:40:00',6.76),('10318','2013-03-16','09:45:00',9.15),('10318','2013-03-16','09:50:00',9.11),('10318','2013-03-16','09:55:00',9.49),('10318','2013-03-16','10:00:00',7.71),('10318','2013-03-16','10:05:00',7.04),('10318','2013-03-16','10:10:00',7.26),('10318','2013-03-16','10:15:00',6.39),('10318','2013-03-16','10:20:00',7.21),('10318','2013-03-16','10:25:00',6.41),('10318','2013-03-16','10:30:00',5.31),('10318','2013-03-16','10:35:00',7.86),('10318','2013-03-16','10:40:00',9.88),('10318','2013-03-16','10:45:00',9.78),('10318','2013-03-16','10:50:00',9.53),('10318','2013-03-16','10:55:00',9.77),('10318','2013-03-16','11:00:00',9.76),('10318','2013-03-16','11:05:00',9.55),('10318','2013-03-16','11:10:00',9.71),('10318','2013-03-16','11:15:00',9.75),('10318','2013-03-16','11:20:00',9.77),('10318','2013-03-16','11:25:00',9.75),('10318','2013-03-16','11:30:00',9.74),('10318','2013-03-16','11:35:00',9.75),('10318','2013-03-16','11:40:00',9.79),('10318','2013-03-16','11:45:00',9.79),('10318','2013-03-16','11:50:00',9.79),('10318','2013-03-16','11:55:00',9.8),('10318','2013-03-16','12:00:00',9.73),('10318','2013-03-16','12:05:00',9.69),('10318','2013-03-16','12:10:00',9.67),('10318','2013-03-16','12:15:00',9.67),('10318','2013-03-16','12:20:00',9.49),('10318','2013-03-16','12:25:00',9.54),('10318','2013-03-16','12:30:00',9.39),('10318','2013-03-16','12:35:00',9.42),('10318','2013-03-16','12:40:00',9.44),('10318','2013-03-16','12:45:00',9.38),('10318','2013-03-16','12:50:00',9.32),('10318','2013-03-16','12:55:00',9.18),('10318','2013-03-16','13:00:00',9.07),('10318','2013-03-16','13:05:00',9.05),('10318','2013-03-16','13:10:00',9.06),('10318','2013-03-16','13:15:00',9.08),('10318','2013-03-16','13:20:00',9.19),('10318','2013-03-16','13:25:00',8.94),('10318','2013-03-16','13:30:00',8.76),('10318','2013-03-16','13:35:00',8.65),('10318','2013-03-16','13:40:00',8.6),('10318','2013-03-16','13:45:00',8.69),('10318','2013-03-16','13:50:00',8.63),('10318','2013-03-16','13:55:00',8.53),('10318','2013-03-16','14:00:00',2.29),('10318','2013-03-16','14:05:00',6.09),('10318','2013-03-16','14:10:00',5.02),('10318','2013-03-16','14:15:00',5.24),('10318','2013-03-16','14:20:00',8.27),('10318','2013-03-16','14:25:00',7.23),('10318','2013-03-16','14:30:00',5.02),('10318','2013-03-16','14:35:00',2.03),('10318','2013-03-16','14:40:00',2.43),('10318','2013-03-16','14:45:00',1.72),('10318','2013-03-16','14:50:00',1.46),('10318','2013-03-16','14:55:00',1.29),('10318','2013-03-16','15:00:00',1.25),('10318','2013-03-16','15:05:00',1.17),('10318','2013-03-16','15:10:00',1.09),('10318','2013-03-16','15:15:00',1.12),('10318','2013-03-16','15:20:00',1.31),('10318','2013-03-16','15:25:00',1.29),('10318','2013-03-16','15:30:00',1.34),('10318','2013-03-16','15:35:00',3.18),('10318','2013-03-16','15:40:00',3.86),('10318','2013-03-16','15:45:00',1.68),('10318','2013-03-16','15:50:00',3.11),('10318','2013-03-16','15:55:00',4.25),('10318','2013-03-16','16:00:00',4.08),('10318','2013-03-16','16:05:00',4),('10318','2013-03-16','16:10:00',3.62),('10318','2013-03-16','16:15:00',1.9),('10318','2013-03-16','16:20:00',2.74),('10318','2013-03-16','16:25:00',1.75),('10318','2013-03-16','16:30:00',1.85),('10318','2013-03-16','16:35:00',2.58),('10318','2013-03-16','16:40:00',2.88),('10318','2013-03-16','16:45:00',2.9),('10318','2013-03-16','16:50:00',2.73),('10318','2013-03-16','16:55:00',2.53),('10318','2013-03-16','17:00:00',2.24),('10318','2013-03-16','17:05:00',2.12),('10318','2013-03-16','17:10:00',1.86),('10318','2013-03-16','17:15:00',1.5),('10318','2013-03-16','17:20:00',1.09),('10318','2013-03-16','17:25:00',1.09),('10318','2013-03-15','09:50:00',1.05),('10318','2013-03-15','09:55:00',1.25),('10318','2013-03-15','10:00:00',1.56),('10318','2013-03-15','10:05:00',1.64),('10318','2013-03-15','10:10:00',1.42),('10318','2013-03-15','10:15:00',1.52),('10318','2013-03-15','10:20:00',1.54),('10318','2013-03-15','10:25:00',1.77),('10318','2013-03-15','10:30:00',2.26),('10318','2013-03-15','10:35:00',2.55),('10318','2013-03-15','10:40:00',2.85),('10318','2013-03-15','10:45:00',3.16),('10318','2013-03-15','10:50:00',3.49),('10318','2013-03-15','10:55:00',3.65),('10318','2013-03-15','11:00:00',3.37),('10318','2013-03-15','11:05:00',3.03),('10318','2013-03-15','11:10:00',2.95),('10318','2013-03-15','11:15:00',2.45),('10318','2013-03-15','11:20:00',2.66),('10318','2013-03-15','11:25:00',3.17),('10318','2013-03-15','11:30:00',3.8),('10318','2013-03-15','11:35:00',4.86),('10318','2013-03-15','11:40:00',4.6),('10318','2013-03-15','11:45:00',4.81),('10318','2013-03-15','11:50:00',4.83),('10318','2013-03-15','11:55:00',5.11),('10318','2013-03-15','12:00:00',4.64),('10318','2013-03-15','12:05:00',4.43),('10318','2013-03-15','12:10:00',5.63),('10318','2013-03-15','12:15:00',4.27),('10318','2013-03-15','12:20:00',4.33),('10318','2013-03-15','12:25:00',4.52),('10318','2013-03-15','12:30:00',4.77),('10318','2013-03-15','12:35:00',4.71),('10318','2013-03-15','12:40:00',3.68),('10318','2013-03-15','12:45:00',2.84),('10318','2013-03-15','12:50:00',2.89),('10318','2013-03-15','12:55:00',2.98),('10318','2013-03-15','13:00:00',2.72),('10318','2013-03-15','13:05:00',2.62),('10318','2013-03-15','13:10:00',2.88),('10318','2013-03-15','13:15:00',3.29),('10318','2013-03-15','13:20:00',3.7),('10318','2013-03-15','13:25:00',4.16),('10318','2013-03-15','13:30:00',3.47),('10318','2013-03-15','13:35:00',3.38),('10318','2013-03-15','13:40:00',3.39),('10318','2013-03-15','13:45:00',3.27),('10318','2013-03-15','13:50:00',2.75),('10318','2013-03-15','13:55:00',2.45),('10318','2013-03-15','14:00:00',2.14),('10318','2013-03-15','14:05:00',1.87),('10318','2013-03-15','14:10:00',1.67),('10318','2013-03-15','14:15:00',1.62),('10318','2013-03-15','14:20:00',1.46),('10318','2013-03-15','14:25:00',1.24),('10318','2013-03-15','14:30:00',1.13),('10318','2013-03-15','14:35:00',1.23),('10318','2013-03-15','14:40:00',1.6),('10318','2013-03-15','14:45:00',2.12),('10318','2013-03-15','14:50:00',2.66),('10318','2013-03-15','14:55:00',2.77),('10318','2013-03-15','15:00:00',2.78),('10318','2013-03-15','15:05:00',2.63),('10318','2013-03-15','15:10:00',2.82),('10318','2013-03-15','15:15:00',2.95),('10318','2013-03-15','15:20:00',3.66),('10318','2013-03-15','15:25:00',3.12),('10318','2013-03-15','15:30:00',2.53),('10318','2013-03-15','15:35:00',2.2),('10318','2013-03-15','15:40:00',2.01),('10318','2013-03-15','15:45:00',2.05),('10318','2013-03-15','15:50:00',1.84),('10318','2013-03-15','15:55:00',1.78),('10318','2013-03-15','16:00:00',1.84),('10318','2013-03-15','16:05:00',1.63),('10318','2013-03-15','16:10:00',1.5),('10318','2013-03-15','16:15:00',1.46),('10318','2013-03-15','16:20:00',1.16),('10318','2013-03-15','17:10:00',1.5),('10318','2013-03-15','17:15:00',1.47),('10318','2013-03-15','17:20:00',1.14),('10318','2013-03-14','08:20:00',1.18),('10318','2013-03-14','08:25:00',1.42),('10318','2013-03-14','08:30:00',1.16),('10318','2013-03-14','09:30:00',1.27),('10318','2013-03-14','09:35:00',1.46),('10318','2013-03-14','09:40:00',1.57),('10318','2013-03-14','09:45:00',1.62),('10318','2013-03-14','09:50:00',1.45),('10318','2013-03-14','09:55:00',1.48),('10318','2013-03-14','10:00:00',1.47),('10318','2013-03-14','10:05:00',1.32),('10318','2013-03-14','10:10:00',1.28),('10318','2013-03-14','10:15:00',1.44),('10318','2013-03-14','10:20:00',1.5),('10318','2013-03-14','10:25:00',1.32),('10318','2013-03-14','10:30:00',1.25),('10318','2013-03-14','10:35:00',1.22),('10318','2013-03-14','10:40:00',1.08),('10318','2013-03-14','11:10:00',1.03),('10318','2013-03-14','11:15:00',1.24),('10318','2013-03-14','11:20:00',1.42),('10318','2013-03-14','11:25:00',1.53),('10318','2013-03-14','11:30:00',1.65),('10318','2013-03-14','11:35:00',1.72),('10318','2013-03-14','11:40:00',1.74),('10318','2013-03-14','11:45:00',1.71),('10318','2013-03-14','11:50:00',1.64),('10318','2013-03-14','11:55:00',1.45),('10318','2013-03-14','12:00:00',1.35),('10318','2013-03-14','12:05:00',1.36),('10318','2013-03-14','12:10:00',1.33),('10318','2013-03-14','12:15:00',1.41),('10318','2013-03-14','12:20:00',1.53),('10318','2013-03-14','12:25:00',1.7),('10318','2013-03-14','12:30:00',1.79),('10318','2013-03-14','12:35:00',1.93),('10318','2013-03-14','12:40:00',2.16),('10318','2013-03-14','12:45:00',2.39),('10318','2013-03-14','12:50:00',2.58),('10318','2013-03-14','12:55:00',2.64),('10318','2013-03-14','13:00:00',2.78),('10318','2013-03-14','13:05:00',2.83),('10318','2013-03-14','13:10:00',2.86),('10318','2013-03-14','13:15:00',3.06),('10318','2013-03-14','13:20:00',2.39),('10318','2013-03-14','13:25:00',2.33),('10318','2013-03-14','13:30:00',3.38),('10318','2013-03-14','13:35:00',3.8),('10318','2013-03-14','13:40:00',3.61),('10318','2013-03-14','13:45:00',2.93),('10318','2013-03-14','13:50:00',2.67),('10318','2013-03-14','13:55:00',3.25),('10318','2013-03-14','14:00:00',3.42),('10318','2013-03-14','14:05:00',3.25),('10318','2013-03-14','14:10:00',2.98),('10318','2013-03-14','14:15:00',2.84),('10318','2013-03-14','14:20:00',3.05),('10318','2013-03-14','14:25:00',2.45),('10318','2013-03-14','14:30:00',1.69),('10318','2013-03-14','14:35:00',1.05),('10318','2013-03-14','14:40:00',1.04),('10318','2013-03-14','14:45:00',1.06),('10318','2013-03-14','14:50:00',1.12),('10318','2013-03-14','14:55:00',1.19),('10318','2013-03-14','15:00:00',1.22),('10318','2013-03-14','15:05:00',1.93),('10318','2013-03-14','15:10:00',2.58),('10318','2013-03-14','15:15:00',2.5),('10318','2013-03-14','15:20:00',2.6),('10318','2013-03-14','15:25:00',2.81),('10318','2013-03-14','15:30:00',2.66),('10318','2013-03-14','15:35:00',1.92),('10318','2013-03-14','15:40:00',1.38),('10318','2013-03-14','16:25:00',1.38),('10318','2013-03-14','16:30:00',1.23),('10318','2013-03-13','08:05:00',1.57),('10318','2013-03-13','08:10:00',1.69),('10318','2013-03-13','08:15:00',1.31),('10318','2013-03-13','08:20:00',1.32),('10318','2013-03-13','08:25:00',1.31),('10318','2013-03-13','08:30:00',1.16),('10318','2013-03-13','08:35:00',1.11),('10318','2013-03-13','08:40:00',1.56),('10318','2013-03-13','08:45:00',1.66),('10318','2013-03-13','08:50:00',2.2),('10318','2013-03-13','08:55:00',1.96),('10318','2013-03-13','09:00:00',1.52),('10318','2013-03-13','09:05:00',1.77),('10318','2013-03-13','09:10:00',2.49),('10318','2013-03-13','09:15:00',2.04),('10318','2013-03-13','09:20:00',1.59),('10318','2013-03-13','09:25:00',1.81),('10318','2013-03-13','09:30:00',1.84),('10318','2013-03-13','09:35:00',1.84),('10318','2013-03-13','09:40:00',1.8),('10318','2013-03-13','09:45:00',2.01),('10318','2013-03-13','09:50:00',2.23),('10318','2013-03-13','09:55:00',1.37),('10318','2013-03-13','10:00:00',1.53),('10318','2013-03-13','10:05:00',2.47),('10318','2013-03-13','10:10:00',4.41),('10318','2013-03-13','10:15:00',4.14),('10318','2013-03-13','10:20:00',2.27),('10318','2013-03-13','10:25:00',4.77),('10318','2013-03-13','10:30:00',7.95),('10318','2013-03-13','10:35:00',6.9),('10318','2013-03-13','10:40:00',6.68),('10318','2013-03-13','10:45:00',6.51),('10318','2013-03-13','10:50:00',3.71),('10318','2013-03-13','10:55:00',2.19),('10318','2013-03-13','11:00:00',1.9),('10318','2013-03-13','11:05:00',2.01),('10318','2013-03-13','11:10:00',2.52),('10318','2013-03-13','11:15:00',2.54),('10318','2013-03-13','11:20:00',2.8),('10318','2013-03-13','11:25:00',2.38),('10318','2013-03-13','11:30:00',2.67),('10318','2013-03-13','11:35:00',2.74),('10318','2013-03-13','11:40:00',3.01),('10318','2013-03-13','11:45:00',3.45),('10318','2013-03-13','11:50:00',2.94),('10318','2013-03-13','11:55:00',2.05),('10318','2013-03-13','12:00:00',1.06),('10318','2013-03-13','12:20:00',1.12),('10318','2013-03-13','12:25:00',1.35),('10318','2013-03-13','12:30:00',1.7),('10318','2013-03-13','12:35:00',2.04),('10318','2013-03-13','12:40:00',2.26),('10318','2013-03-13','12:45:00',2.6),('10318','2013-03-13','12:50:00',2.84),('10318','2013-03-13','12:55:00',2.76),('10318','2013-03-13','13:00:00',2.61),('10318','2013-03-13','13:05:00',2.58),('10318','2013-03-13','13:10:00',2.43),('10318','2013-03-13','13:15:00',1.88),('10318','2013-03-13','13:20:00',1.59),('10318','2013-03-13','13:25:00',1.6),('10318','2013-03-13','13:30:00',1.98),('10318','2013-03-13','13:35:00',2.71),('10318','2013-03-13','13:40:00',2.33),('10318','2013-03-13','13:45:00',2.04),('10318','2013-03-13','13:50:00',1.78),('10318','2013-03-13','13:55:00',1.23),('10318','2013-03-13','14:00:00',1.08),('10318','2013-03-13','14:05:00',1.19),('10318','2013-03-13','14:10:00',1.2),('10318','2013-03-13','14:35:00',1.11),('10318','2013-03-13','14:40:00',1.11),('10318','2013-03-13','14:45:00',1.31),('10318','2013-03-13','14:50:00',1.58),('10318','2013-03-13','14:55:00',1.47),('10318','2013-03-13','15:00:00',1.53),('10318','2013-03-13','15:05:00',1.64),('10318','2013-03-13','15:10:00',1.75),('10318','2013-03-13','15:15:00',1.36),('10318','2014-03-25','06:50:00',1.11),('10318','2014-03-25','06:55:00',1.26),('10318','2014-03-25','07:00:00',1.3),('10318','2014-03-25','07:05:00',1.51),('10318','2014-03-25','07:10:00',2.36),('10318','2014-03-25','07:15:00',3.23),('10318','2014-03-25','07:20:00',3.99),('10318','2014-03-25','07:25:00',3.96),('10318','2014-03-25','07:30:00',4.12),('10318','2014-03-25','07:35:00',3.04),('10318','2014-03-25','07:40:00',2.91),('10318','2014-03-25','07:45:00',3.24),('10318','2014-03-25','07:50:00',3.31),('10318','2014-03-25','07:55:00',3.26),('10318','2014-03-25','08:00:00',3.02),('10318','2014-03-25','08:05:00',3.1),('10318','2014-03-25','08:10:00',3.3),('10318','2014-03-25','08:15:00',3.43),('10318','2014-03-25','08:20:00',2.98),('10318','2014-03-25','08:25:00',2.67),('10318','2014-03-25','08:30:00',2.45),('10318','2014-03-25','08:35:00',2.63),('10318','2014-03-25','08:40:00',3.32),('10318','2014-03-25','08:45:00',4.79),('10318','2014-03-25','08:50:00',4.57),('10318','2014-03-25','08:55:00',4.77),('10318','2014-03-25','09:00:00',4.25),('10318','2014-03-25','09:05:00',4.45),('10318','2014-03-25','09:10:00',4.6),('10318','2014-03-25','09:15:00',5.91),('10318','2014-03-25','09:20:00',6.03),('10318','2014-03-25','09:25:00',5.07),('10318','2014-03-25','09:30:00',4.54),('10318','2014-03-25','09:35:00',4.34),('10318','2014-03-25','09:40:00',4.32),('10318','2014-03-25','09:45:00',4.21),('10318','2014-03-25','09:50:00',4.63),('10318','2014-03-25','09:55:00',5.16),('10318','2014-03-25','10:00:00',5.76),('10318','2014-03-25','10:05:00',6.49),('10318','2014-03-25','10:10:00',7.01),('10318','2014-03-25','10:15:00',7.48),('10318','2014-03-25','10:20:00',7.09),('10318','2014-03-25','10:25:00',7.53),('10318','2014-03-25','10:30:00',6.61),('10318','2014-03-25','10:35:00',5.39),('10318','2014-03-25','10:40:00',4.74),('10318','2014-03-25','10:45:00',4.39),('10318','2014-03-25','10:50:00',4.17),('10318','2014-03-25','10:55:00',4.41),('10318','2014-03-25','11:00:00',4.98),('10318','2014-03-25','11:05:00',5.7),('10318','2014-03-25','11:10:00',6.44),('10318','2014-03-25','11:15:00',6.72),('10318','2014-03-25','11:20:00',6.96),('10318','2014-03-25','11:25:00',7.29),('10318','2014-03-25','11:30:00',7.45),('10318','2014-03-25','11:35:00',6.57),('10318','2014-03-25','11:40:00',5.05),('10318','2014-03-25','11:45:00',4.63),('10318','2014-03-25','11:50:00',5.01),('10318','2014-03-25','11:55:00',3.77),('10318','2014-03-25','12:00:00',2.43),('10318','2014-03-25','12:05:00',1.67),('10318','2014-03-25','12:10:00',1.73),('10318','2014-03-25','12:15:00',1.94),('10318','2014-03-25','12:20:00',2.31),('10318','2014-03-25','12:25:00',2.92),('10318','2014-03-25','12:30:00',2.79),('10318','2014-03-25','12:35:00',2.4),('10318','2014-03-25','12:40:00',2.08),('10318','2014-03-25','12:45:00',2.34),('10318','2014-03-25','12:50:00',2.01),('10318','2014-03-25','12:55:00',1.31),('10318','2014-03-25','13:05:00',1.13),('10318','2014-03-25','13:10:00',1.15),('10318','2014-03-25','13:15:00',1.13),('10318','2014-03-25','13:20:00',1.23),('10318','2014-03-25','13:25:00',1.36),('10318','2014-03-25','13:30:00',1.57),('10318','2014-03-25','13:35:00',1.83),('10318','2014-03-25','13:40:00',1.78),('10318','2014-03-25','13:45:00',1.48),('10318','2014-03-25','13:50:00',1.6),('10318','2014-03-25','13:55:00',1.88),('10318','2014-03-25','14:00:00',2.01),('10318','2014-03-25','14:05:00',1.83),('10318','2014-03-25','14:10:00',1.54),('10318','2014-03-25','14:15:00',1.51),('10318','2014-03-25','14:20:00',1.34),('10318','2014-03-25','14:25:00',1.21),('10318','2014-03-25','14:30:00',1.5),('10318','2014-03-25','14:35:00',1.55),('10318','2014-03-25','14:40:00',1.52),('10318','2014-03-25','14:45:00',1.65),('10318','2014-03-25','14:50:00',1.55),('10318','2014-03-25','14:55:00',1.3),('10318','2014-03-25','15:00:00',1.18),('10318','2014-03-25','15:10:00',1.07),('10318','2014-03-25','15:15:00',1.63),('10318','2014-03-25','15:20:00',1.66),('10318','2014-03-25','15:25:00',1.18),('10318','2014-03-25','15:45:00',1.1),('10318','2014-03-25','15:50:00',1.05),('10318','2014-03-25','15:55:00',1.15),('10318','2013-03-11','07:10:00',1.01),('10318','2013-03-11','07:15:00',1.37),('10318','2013-03-11','07:20:00',1.64),('10318','2013-03-11','07:25:00',1.63),('10318','2013-03-11','07:30:00',1.87),('10318','2013-03-11','07:35:00',3.31),('10318','2013-03-11','07:40:00',2.9),('10318','2013-03-11','07:55:00',1.45),('10318','2013-03-11','08:00:00',3.02),('10318','2013-03-11','08:05:00',3.82),('10318','2013-03-11','08:10:00',4.63),('10318','2013-03-11','08:15:00',4.87),('10318','2013-03-11','08:20:00',5.09),('10318','2013-03-11','08:25:00',5.33),('10318','2013-03-11','08:30:00',5.53),('10318','2013-03-11','08:35:00',5.66),('10318','2013-03-11','08:40:00',6),('10318','2013-03-11','08:45:00',6.23),('10318','2013-03-11','08:50:00',5.56),('10318','2013-03-11','08:55:00',6.34),('10318','2013-03-11','09:00:00',6.66),('10318','2013-03-11','09:05:00',6.8),('10318','2013-03-11','09:10:00',6.95),('10318','2013-03-11','09:15:00',7.13),('10318','2013-03-11','09:20:00',7.48),('10318','2013-03-11','09:25:00',8.49),('10318','2013-03-11','09:30:00',6.8),('10318','2013-03-11','09:35:00',5.19),('10318','2013-03-11','09:40:00',4.37),('10318','2013-03-11','09:45:00',2.35),('10318','2013-03-11','09:50:00',1.67),('10318','2013-03-11','09:55:00',2.07),('10318','2013-03-11','10:00:00',2.32),('10318','2013-03-11','10:05:00',2.68),('10318','2013-03-11','10:10:00',3.22),('10318','2013-03-11','10:15:00',3.11),('10318','2013-03-11','10:20:00',3.23),('10318','2013-03-11','10:25:00',3.21),('10318','2013-03-11','10:30:00',3.16),('10318','2013-03-11','10:35:00',3.84),('10318','2013-03-11','10:40:00',5.68),('10318','2013-03-11','10:45:00',6.27),('10318','2013-03-11','10:50:00',6.13),('10318','2013-03-11','10:55:00',4.77),('10318','2013-03-11','11:00:00',3.92),('10318','2013-03-11','11:05:00',3.25),('10318','2013-03-11','11:10:00',3.13),('10318','2013-03-11','11:15:00',3.2),('10318','2013-03-11','11:20:00',3.18),('10318','2013-03-11','11:25:00',3.93),('10318','2013-03-11','11:30:00',4.74),('10318','2013-03-11','11:35:00',3.58),('10318','2013-03-11','11:40:00',4.36),('10318','2013-03-11','11:45:00',8.09),('10318','2013-03-11','11:50:00',5.54),('10318','2013-03-11','11:55:00',4.35),('10318','2013-03-11','12:00:00',3.86),('10318','2013-03-11','12:05:00',3.83),('10318','2013-03-11','12:10:00',6.97),('10318','2013-03-11','12:15:00',7.39),('10318','2013-03-11','12:20:00',7.22),('10318','2013-03-11','12:25:00',3.97),('10318','2013-03-11','12:30:00',3.73),('10318','2013-03-11','12:35:00',4.37),('10318','2013-03-11','12:40:00',3.33),('10318','2013-03-11','12:45:00',3.64),('10318','2013-03-11','12:50:00',3.47),('10318','2013-03-11','12:55:00',6.01),('10318','2013-03-11','13:00:00',5.48),('10318','2013-03-11','13:05:00',6.37),('10318','2013-03-11','13:10:00',4.45),('10318','2013-03-11','13:15:00',3.7),('10318','2013-03-11','13:20:00',6.93),('10318','2013-03-11','13:25:00',8.61),('10318','2013-03-11','13:30:00',3.3),('10318','2013-03-11','13:35:00',8.11),('10318','2013-03-11','13:40:00',2.45),('10318','2013-03-11','13:45:00',1.87),('10318','2013-03-11','13:50:00',1.69),('10318','2013-03-11','13:55:00',1.53),('10318','2013-03-11','14:00:00',1.53),('10318','2013-03-11','14:05:00',3.91),('10318','2013-03-11','14:10:00',8.48),('10318','2013-03-11','14:15:00',7.46),('10318','2013-03-11','14:20:00',5.47),('10318','2013-03-11','14:25:00',6.17),('10318','2013-03-11','14:30:00',7.92),('10318','2013-03-11','14:35:00',7.4),('10318','2013-03-11','14:40:00',2.62),('10318','2013-03-11','14:45:00',5.77),('10318','2013-03-11','14:50:00',6.88),('10318','2013-03-11','14:55:00',6.6),('10318','2013-03-11','15:00:00',5.22),('10318','2013-03-11','15:05:00',5.04),('10318','2013-03-11','15:10:00',5.26),('10318','2013-03-11','15:15:00',6.01),('10318','2013-03-11','15:20:00',5.81),('10318','2013-03-11','15:25:00',4.65),('10318','2013-03-11','15:30:00',4.86),('10318','2013-03-11','15:35:00',4.27),('10318','2013-03-11','15:40:00',5.18),('10318','2013-03-11','15:45:00',4.74),('10318','2013-03-11','15:50:00',3.8),('10318','2013-03-11','15:55:00',2.88),('10318','2013-03-11','16:00:00',2.06),('10318','2013-03-11','16:05:00',4.31),('10318','2013-03-11','16:10:00',3.45),('10318','2013-03-11','16:15:00',3.38),('10318','2013-03-11','16:20:00',3.2),('10318','2013-03-11','16:25:00',2.78),('10318','2013-03-11','16:30:00',2.58),('10318','2013-03-11','16:35:00',2.27),('10318','2013-03-11','16:40:00',1.81),('10318','2013-03-11','16:45:00',1.54),('10318','2013-03-11','16:50:00',1.14),('10318','2013-03-11','17:05:00',1.13),('10318','2013-03-10','07:15:00',1.05),('10318','2013-03-10','07:20:00',1.24),('10318','2013-03-10','07:25:00',1.38),('10318','2013-03-10','07:30:00',1.79),('10318','2013-03-10','07:35:00',2.42),('10318','2013-03-10','07:40:00',3.25),('10318','2013-03-10','07:45:00',3.12),('10318','2013-03-10','07:50:00',3.71),('10318','2013-03-10','07:55:00',3.97),('10318','2013-03-10','08:00:00',4.22),('10318','2013-03-10','08:05:00',4.43),('10318','2013-03-10','08:10:00',4.52),('10318','2013-03-10','08:15:00',4.96),('10318','2013-03-10','08:20:00',5.13),('10318','2013-03-10','08:25:00',5.33),('10318','2013-03-10','08:30:00',5.53),('10318','2013-03-10','08:35:00',5.66),('10318','2013-03-10','08:40:00',5.88),('10318','2013-03-10','08:45:00',6.08),('10318','2013-03-10','08:50:00',6.26),('10318','2013-03-10','08:55:00',6.47),('10318','2013-03-10','09:00:00',6.63),('10318','2013-03-10','09:05:00',6.7),('10318','2013-03-10','09:10:00',6.95),('10318','2013-03-10','09:15:00',7.1),('10318','2013-03-10','09:20:00',7.15),('10318','2013-03-10','09:25:00',7.36),('10318','2013-03-10','09:30:00',7.62),('10318','2013-03-10','09:35:00',7.56),('10318','2013-03-10','09:40:00',8.32),('10318','2013-03-10','09:45:00',4.67),('10318','2013-03-10','09:50:00',8),('10318','2013-03-10','09:55:00',8.95),('10318','2013-03-10','10:00:00',9.39),('10318','2013-03-10','10:05:00',8.4),('10318','2013-03-10','10:10:00',8.71),('10318','2013-03-10','10:15:00',8.7),('10318','2013-03-10','10:20:00',7.19),('10318','2013-03-10','10:25:00',6.84),('10318','2013-03-10','10:30:00',8.39),('10318','2013-03-10','10:35:00',8.93),('10318','2013-03-10','10:40:00',8.52),('10318','2013-03-10','10:45:00',8.85),('10318','2013-03-10','10:50:00',8.84),('10318','2013-03-10','10:55:00',9.09),('10318','2013-03-10','11:00:00',9.33),('10318','2013-03-10','11:05:00',8.41),('10318','2013-03-10','11:10:00',7.81),('10318','2013-03-10','11:15:00',9.51),('10318','2013-03-10','11:20:00',8.96),('10318','2013-03-10','11:25:00',7.32),('10318','2013-03-10','11:30:00',8.59),('10318','2013-03-10','11:35:00',10.16),('10318','2013-03-10','11:40:00',3.87),('10318','2013-03-10','11:45:00',7.99),('10318','2013-03-10','11:50:00',9.8),('10318','2013-03-10','11:55:00',9.54),('10318','2013-03-10','12:00:00',9.35),('10318','2013-03-10','12:05:00',9.22),('10318','2013-03-10','12:10:00',9.22),('10318','2013-03-10','12:15:00',9.25),('10318','2013-03-10','12:20:00',8.89),('10318','2013-03-10','12:25:00',8.88),('10318','2013-03-10','12:30:00',9.25),('10318','2013-03-10','12:35:00',8.9),('10318','2013-03-10','12:40:00',9.26),('10318','2013-03-10','12:45:00',9.5),('10318','2013-03-10','12:50:00',9.35),('10318','2013-03-10','12:55:00',9.27),('10318','2013-03-10','13:00:00',9.11),('10318','2013-03-10','13:05:00',8.56),('10318','2013-03-10','13:10:00',8.4),('10318','2013-03-10','13:15:00',8.84),('10318','2013-03-10','13:20:00',8.7),('10318','2013-03-10','13:25:00',7.71),('10318','2013-03-10','13:30:00',8.02),('10318','2013-03-10','13:35:00',6.63),('10318','2013-03-10','13:40:00',4.61),('10318','2013-03-10','13:45:00',4.54),('10318','2013-03-10','13:50:00',3.96),('10318','2013-03-10','13:55:00',4.02),('10318','2013-03-10','14:00:00',3.63),('10318','2013-03-10','14:05:00',4.93),('10318','2013-03-10','14:10:00',4.46),('10318','2013-03-10','14:15:00',5.1),('10318','2013-03-10','14:20:00',5.65),('10318','2013-03-10','14:25:00',5.29),('10318','2013-03-10','14:30:00',6.41),('10318','2013-03-10','14:35:00',4.19),('10318','2013-03-10','14:40:00',5.9),('10318','2013-03-10','14:45:00',4.12),('10318','2013-03-10','14:50:00',3.57),('10318','2013-03-10','14:55:00',2.88),('10318','2013-03-10','15:00:00',2.29),('10318','2013-03-10','15:05:00',3.15),('10318','2013-03-10','15:10:00',2.55),('10318','2013-03-10','15:15:00',1.9),('10318','2013-03-10','15:20:00',1.84),('10318','2013-03-10','15:25:00',1.21),('10318','2013-03-10','15:30:00',1.27),('10318','2013-03-10','15:35:00',1.3),('10318','2013-03-10','15:40:00',1.25),('10318','2013-03-10','15:45:00',1.5),('10318','2013-03-10','15:50:00',1.89),('10318','2013-03-10','15:55:00',1.62),('10318','2013-03-10','16:00:00',1.05),('10318','2013-03-09','07:40:00',1.22),('10318','2013-03-09','07:45:00',2.7),('10318','2013-03-09','07:50:00',1.08),('10318','2013-03-09','07:55:00',1.42),('10318','2013-03-09','08:00:00',3.56),('10318','2013-03-09','08:05:00',3.73),('10318','2013-03-09','08:10:00',4.67),('10318','2013-03-09','08:15:00',4.61),('10318','2013-03-09','08:20:00',4.99),('10318','2013-03-09','08:25:00',5.15),('10318','2013-03-09','08:30:00',5.46),('10318','2013-03-09','08:35:00',5.64),('10318','2013-03-09','08:40:00',5.78),('10318','2013-03-09','08:45:00',6),('10318','2013-03-09','08:50:00',5.98),('10318','2013-03-09','08:55:00',4.63),('10318','2013-03-09','09:00:00',4.64),('10318','2013-03-09','09:05:00',5.22),('10318','2013-03-09','09:10:00',6.05),('10318','2013-03-09','09:15:00',3.22),('10318','2013-03-09','09:20:00',2.17),('10318','2013-03-09','09:25:00',2.32),('10318','2013-03-09','09:30:00',5.24),('10318','2013-03-09','09:35:00',1.84),('10318','2013-03-09','09:40:00',3.43),('10318','2013-03-09','09:45:00',2.44),('10318','2013-03-09','09:50:00',4.45),('10318','2013-03-09','09:55:00',4.49),('10318','2013-03-09','10:00:00',6.25),('10318','2013-03-09','10:05:00',2.12),('10318','2013-03-09','10:10:00',3.72),('10318','2013-03-09','10:15:00',1.9),('10318','2013-03-09','10:20:00',1.83),('10318','2013-03-09','10:25:00',3.31),('10318','2013-03-09','10:30:00',2.53),('10318','2013-03-09','10:35:00',6.17),('10318','2013-03-09','10:40:00',3.44),('10318','2013-03-09','10:45:00',4.26),('10318','2013-03-09','10:50:00',6.9),('10318','2013-03-09','10:55:00',7.55),('10318','2013-03-09','11:00:00',8.57),('10318','2013-03-09','11:05:00',8.4),('10318','2013-03-09','11:10:00',8.21),('10318','2013-03-09','11:15:00',8.94),('10318','2013-03-09','11:20:00',8.27),('10318','2013-03-09','11:25:00',9.15),('10318','2013-03-09','11:30:00',9.32),('10318','2013-03-09','11:35:00',8.96),('10318','2013-03-09','11:40:00',8.86),('10318','2013-03-09','11:45:00',9.28),('10318','2013-03-09','11:50:00',9.22),('10318','2013-03-09','11:55:00',9.24),('10318','2013-03-09','12:00:00',9.2),('10318','2013-03-09','12:05:00',9.28),('10318','2013-03-09','12:10:00',8.81),('10318','2013-03-09','12:15:00',8.05),('10318','2013-03-09','12:20:00',5.2),('10318','2013-03-09','12:25:00',7.8),('10318','2013-03-09','12:30:00',7.77),('10318','2013-03-09','12:35:00',5.52),('10318','2013-03-09','12:40:00',7.11),('10318','2013-03-09','12:45:00',9.15),('10318','2013-03-09','12:50:00',9.33),('10318','2013-03-09','12:55:00',8.86),('10318','2013-03-09','13:00:00',6.49),('10318','2013-03-09','13:05:00',8.74),('10318','2013-03-09','13:10:00',8.46),('10318','2013-03-09','13:15:00',8.82),('10318','2013-03-09','13:20:00',8.98),('10318','2013-03-09','13:25:00',9.4),('10318','2013-03-09','13:30:00',8.55),('10318','2013-03-09','13:35:00',8.33),('10318','2013-03-09','13:40:00',7.1),('10318','2013-03-09','13:45:00',6.31),('10318','2013-03-09','13:50:00',3.68),('10318','2013-03-09','13:55:00',6.23),('10318','2013-03-09','14:00:00',3.14),('10318','2013-03-09','14:05:00',8.14),('10318','2013-03-09','14:10:00',7.78),('10318','2013-03-09','14:15:00',2.89),('10318','2013-03-09','14:20:00',5.52),('10318','2013-03-09','14:25:00',5.88),('10318','2013-03-09','14:30:00',6.81),('10318','2013-03-09','14:35:00',6.58),('10318','2013-03-09','14:40:00',6.41),('10318','2013-03-09','14:45:00',6.24),('10318','2013-03-09','14:50:00',6.08),('10318','2013-03-09','14:55:00',5.79),('10318','2013-03-09','15:00:00',5.74),('10318','2013-03-09','15:05:00',5.57),('10318','2013-03-09','15:10:00',5.39),('10318','2013-03-09','15:15:00',5.21),('10318','2013-03-09','15:20:00',5.03),('10318','2013-03-09','15:25:00',4.86),('10318','2013-03-09','15:30:00',4.71),('10318','2013-03-09','15:35:00',4.52),('10318','2013-03-09','15:40:00',4.3),('10318','2013-03-09','15:45:00',4.13),('10318','2013-03-09','15:50:00',3.91),('10318','2013-03-09','15:55:00',3.76),('10318','2013-03-09','16:00:00',3.18),('10318','2013-03-09','16:05:00',3.11),('10318','2013-03-09','16:10:00',2.39),('10318','2013-03-09','16:15:00',2.73),('10318','2013-03-09','16:20:00',1.97),('10318','2013-03-09','16:25:00',2.83),('10318','2013-03-09','16:30:00',1.69),('10318','2013-03-09','16:35:00',2.13),('10318','2013-03-09','16:40:00',1.96),('10318','2013-03-09','16:45:00',1.32),('10318','2013-03-09','16:50:00',1.31),('10318','2013-03-08','08:10:00',1.12),('10318','2013-03-08','08:15:00',1.14),('10318','2013-03-08','08:25:00',1.13),('10318','2013-03-08','08:30:00',3.06),('10318','2013-03-08','08:35:00',2.97),('10318','2013-03-08','08:40:00',1.81),('10318','2013-03-08','08:45:00',1.32),('10318','2013-03-08','08:50:00',1.23),('10318','2013-03-08','09:05:00',2.37),('10318','2013-03-08','09:10:00',2.77),('10318','2013-03-08','09:15:00',5.36),('10318','2013-03-08','09:20:00',2.66),('10318','2013-03-08','09:25:00',3.03),('10318','2013-03-08','09:30:00',5.64),('10318','2013-03-08','09:35:00',5.72),('10318','2013-03-08','09:40:00',6.49),('10318','2013-03-08','09:45:00',7.11),('10318','2013-03-08','09:50:00',8.67),('10318','2013-03-08','09:55:00',8.38),('10318','2013-03-08','10:00:00',8.91),('10318','2013-03-08','10:05:00',5.19),('10318','2013-03-08','10:10:00',3.6),('10318','2013-03-08','10:15:00',4.35),('10318','2013-03-08','10:20:00',4.57),('10318','2013-03-08','10:25:00',3.55),('10318','2013-03-08','10:30:00',5.48),('10318','2013-03-08','10:35:00',5.03),('10318','2013-03-08','10:40:00',3.09),('10318','2013-03-08','10:45:00',2.26),('10318','2013-03-08','10:50:00',2.13),('10318','2013-03-08','10:55:00',2.51),('10318','2013-03-08','11:00:00',1.73),('10318','2013-03-08','11:05:00',1.38),('10318','2013-03-08','11:10:00',1.34),('10318','2013-03-08','11:20:00',1.03),('10318','2013-03-08','11:35:00',1.76),('10318','2013-03-08','11:40:00',1.99),('10318','2013-03-08','11:45:00',2.17),('10318','2013-03-08','11:50:00',2.21),('10318','2013-03-08','11:55:00',3.54),('10318','2013-03-08','12:00:00',4.16),('10318','2013-03-08','12:05:00',5.1),('10318','2013-03-08','12:10:00',4.76),('10318','2013-03-08','12:15:00',3.45),('10318','2013-03-08','12:20:00',3.68),('10318','2013-03-08','12:25:00',3.17),('10318','2013-03-08','12:30:00',2.63),('10318','2013-03-08','12:35:00',2.57),('10318','2013-03-08','12:40:00',4.94),('10318','2013-03-08','12:45:00',4.32),('10318','2013-03-08','12:50:00',5.27),('10318','2013-03-08','12:55:00',4.77),('10318','2013-03-08','13:00:00',4.7),('10318','2013-03-08','13:05:00',4.11),('10318','2013-03-08','13:10:00',3.08),('10318','2013-03-08','13:15:00',2.63),('10318','2013-03-08','13:20:00',2.52),('10318','2013-03-08','13:25:00',2.88),('10318','2013-03-08','13:30:00',2.99),('10318','2013-03-08','13:35:00',2.73),('10318','2013-03-08','13:40:00',1.95),('10318','2013-03-08','13:45:00',1.7),('10318','2013-03-08','13:50:00',2.18),('10318','2013-03-08','13:55:00',1.71),('10318','2013-03-08','14:00:00',1.72),('10318','2013-03-08','14:05:00',1.43),('10318','2013-03-08','14:10:00',1),('10318','2013-03-08','16:55:00',1.32),('10318','2013-03-08','17:00:00',1.22),('10318','2013-03-08','17:05:00',1.64),('10318','2013-03-08','17:10:00',2.21),('10318','2013-03-08','17:15:00',1.52),('10318','2013-03-08','17:20:00',1.23),('10318','2013-03-07','08:30:00',1.01),('10318','2013-03-07','08:35:00',1.51),('10318','2013-03-07','08:40:00',2.04),('10318','2013-03-07','08:45:00',2.55),('10318','2013-03-07','08:50:00',2.81),('10318','2013-03-07','08:55:00',2.91),('10318','2013-03-07','09:00:00',2.28),('10318','2013-03-07','09:05:00',1.81),('10318','2013-03-07','09:15:00',1.04),('10318','2013-03-07','09:20:00',1.39),('10318','2013-03-07','09:25:00',1.77),('10318','2013-03-07','09:30:00',1.74),('10318','2013-03-07','09:40:00',1.27),('10318','2013-03-07','09:45:00',1.56),('10318','2013-03-07','09:50:00',1.32),('10318','2013-03-07','09:55:00',1.26),('10318','2013-03-07','10:20:00',1.65),('10318','2013-03-07','10:25:00',1.82),('10318','2013-03-07','10:30:00',1.55),('10318','2013-03-07','10:35:00',1.73),('10318','2013-03-07','10:40:00',2.23),('10318','2013-03-07','10:45:00',1.9),('10318','2013-03-07','10:50:00',2.21),('10318','2013-03-07','10:55:00',2.78),('10318','2013-03-07','11:00:00',3.42),('10318','2013-03-07','11:05:00',3.52),('10318','2013-03-07','11:10:00',2.56),('10318','2013-03-07','11:15:00',2.47),('10318','2013-03-07','11:25:00',1),('10318','2013-03-07','11:30:00',2.83),('10318','2013-03-07','11:35:00',3.64),('10318','2013-03-07','11:40:00',6.41),('10318','2013-03-07','11:45:00',9.81),('10318','2013-03-07','11:50:00',5.09),('10318','2013-03-07','11:55:00',5.7),('10318','2013-03-07','12:00:00',4.45),('10318','2013-03-07','12:05:00',2.22),('10318','2013-03-07','12:15:00',1.24),('10318','2013-03-07','12:20:00',2.34),('10318','2013-03-07','12:25:00',4.01),('10318','2013-03-07','12:30:00',5.94),('10318','2013-03-07','12:35:00',2.03),('10318','2013-03-07','12:40:00',1.54),('10318','2013-03-07','12:45:00',2.01),('10318','2013-03-07','12:50:00',2.13),('10318','2013-03-07','12:55:00',2.49),('10318','2013-03-07','13:00:00',3.8),('10318','2013-03-07','13:05:00',4.94),('10318','2013-03-07','13:10:00',4.62),('10318','2013-03-07','13:15:00',4.25),('10318','2013-03-07','13:20:00',3.9),('10318','2013-03-07','13:25:00',4.99),('10318','2013-03-07','13:30:00',4.67),('10318','2013-03-07','13:35:00',3.58),('10318','2013-03-07','13:40:00',2.28),('10318','2013-03-07','13:45:00',1.34),('10318','2013-03-07','13:50:00',1.2),('10318','2013-03-07','13:55:00',1.62),('10318','2013-03-07','14:00:00',1.9),('10318','2013-03-07','14:05:00',2.17),('10318','2013-03-07','14:10:00',2.19),('10318','2013-03-07','14:15:00',2.35),('10318','2013-03-07','14:20:00',1.78),('10318','2013-03-07','14:25:00',1.85),('10318','2013-03-07','14:30:00',1.06),('10318','2013-03-07','14:45:00',1.8),('10318','2013-03-07','14:50:00',1.75),('10318','2013-03-07','15:20:00',1.19),('10318','2013-03-07','15:25:00',1.24),('10318','2013-03-07','15:30:00',1.24),('10318','2013-03-07','15:35:00',2.96),('10318','2013-03-07','15:40:00',2.87),('10318','2013-03-07','15:45:00',2.8),('10318','2013-03-07','15:50:00',2.02),('10318','2013-03-07','15:55:00',1.34),('10318','2013-03-07','16:00:00',1.15),('10318','2013-03-07','16:05:00',1.14),('10318','2013-03-07','16:10:00',1.14),('10318','2013-03-07','16:15:00',1.38),('10318','2013-03-07','16:20:00',1.38),('10318','2013-03-07','16:25:00',1.16),('10318','2013-03-07','16:30:00',1.19),('10318','2013-03-07','16:35:00',1.52),('10318','2013-03-07','16:40:00',2.06),('10318','2013-03-07','16:45:00',1.27),('10318','2013-03-06','08:20:00',1.05),('10318','2013-03-06','08:25:00',1.11),('10318','2013-03-06','08:30:00',1.02),('10318','2013-03-06','09:05:00',1.09),('10318','2013-03-06','09:10:00',1.18),('10318','2013-03-06','09:20:00',1.01),('10318','2013-03-06','09:25:00',1.03),('10318','2013-03-06','09:50:00',1.12),('10318','2013-03-06','12:00:00',1.02),('10318','2013-03-06','15:40:00',1.31),('10318','2013-03-06','15:45:00',1.19),('10318','2013-03-06','15:50:00',1.04),('10318','2013-03-06','15:55:00',1.01),('10318','2013-03-06','16:00:00',1.18),('10318','2013-03-06','16:05:00',1.2),('10318','2013-03-06','16:10:00',1.11),('10318','2013-03-06','16:15:00',1.06),('10318','2013-03-05','07:35:00',1.31),('10318','2013-03-05','07:40:00',1.24),('10318','2013-03-05','07:45:00',1.29),('10318','2013-03-05','07:50:00',1.29),('10318','2013-03-05','07:55:00',1.29),('10318','2013-03-05','08:00:00',1.63),('10318','2013-03-05','08:05:00',2.13),('10318','2013-03-05','08:10:00',2.62),('10318','2013-03-05','08:15:00',3.42),('10318','2013-03-05','08:20:00',2.94),('10318','2013-03-05','08:25:00',4.67),('10318','2013-03-05','08:30:00',5.3),('10318','2013-03-05','08:35:00',5.31),('10318','2013-03-05','08:40:00',4.94),('10318','2013-03-05','08:45:00',4.2),('10318','2013-03-05','08:50:00',4.28),('10318','2013-03-05','08:55:00',4.09),('10318','2013-03-05','09:00:00',3.79),('10318','2013-03-05','09:05:00',3.88),('10318','2013-03-05','09:10:00',3.54),('10318','2013-03-05','09:15:00',3.44),('10318','2013-03-05','09:20:00',3.49),('10318','2013-03-05','09:25:00',3.47),('10318','2013-03-05','09:30:00',3.7),('10318','2013-03-05','09:35:00',3.99),('10318','2013-03-05','09:40:00',4.08),('10318','2013-03-05','09:45:00',4.17),('10318','2013-03-05','09:50:00',3.99),('10318','2013-03-05','09:55:00',4.01),('10318','2013-03-05','10:00:00',4.13),('10318','2013-03-05','10:05:00',4.29),('10318','2013-03-05','10:10:00',4.12),('10318','2013-03-05','10:15:00',4.37),('10318','2013-03-05','10:20:00',4.97),('10318','2013-03-05','10:25:00',4.5),('10318','2013-03-05','10:30:00',4.51),('10318','2013-03-05','10:35:00',5.42),('10318','2013-03-05','10:40:00',5.52),('10318','2013-03-05','10:45:00',5.92),('10318','2013-03-05','10:50:00',6.4),('10318','2013-03-05','10:55:00',6.35),('10318','2013-03-05','11:00:00',6.16),('10318','2013-03-05','11:05:00',6.46),('10318','2013-03-05','11:10:00',6.5),('10318','2013-03-05','11:15:00',6.21),('10318','2013-03-05','11:20:00',6.06),('10318','2013-03-05','11:25:00',5.87),('10318','2013-03-05','11:30:00',6.05),('10318','2013-03-05','11:35:00',6.73),('10318','2013-03-05','11:40:00',7.13),('10318','2013-03-05','11:45:00',6.97),('10318','2013-03-05','11:50:00',7.28),('10318','2013-03-05','11:55:00',7.19),('10318','2013-03-05','12:00:00',7.56),('10318','2013-03-05','12:05:00',7.78),('10318','2013-03-05','12:10:00',7.81),('10318','2013-03-05','12:15:00',5.97),('10318','2013-03-05','12:20:00',7.45),('10318','2013-03-05','12:25:00',7.05),('10318','2013-03-05','12:30:00',5.95),('10318','2013-03-05','12:35:00',6.17),('10318','2013-03-05','12:40:00',5.84),('10318','2013-03-05','12:45:00',5.92),('10318','2013-03-05','12:50:00',5.11),('10318','2013-03-05','12:55:00',4.41),('10318','2013-03-05','13:00:00',3.82),('10318','2013-03-05','13:05:00',3.7),('10318','2013-03-05','13:10:00',3.92),('10318','2013-03-05','13:15:00',4.14),('10318','2013-03-05','13:20:00',3.9),('10318','2013-03-05','13:25:00',3.52),('10318','2013-03-05','13:30:00',3.21),('10318','2013-03-05','13:35:00',3.04),('10318','2013-03-05','13:40:00',2.8),('10318','2013-03-05','13:45:00',2.58),('10318','2013-03-05','13:50:00',2.37),('10318','2013-03-05','13:55:00',2.32),('10318','2013-03-05','14:00:00',2.34),('10318','2013-03-05','14:05:00',2.39),('10318','2013-03-05','14:10:00',2.41),('10318','2013-03-05','14:15:00',2.22),('10318','2013-03-05','14:20:00',2.14),('10318','2013-03-05','14:25:00',2.16),('10318','2013-03-05','14:30:00',2.12),('10318','2013-03-05','14:35:00',2.15),('10318','2013-03-05','14:40:00',2.2),('10318','2013-03-05','14:45:00',2.26),('10318','2013-03-05','14:50:00',2.17),('10318','2013-03-05','14:55:00',1.91),('10318','2013-03-05','15:00:00',1.78),('10318','2013-03-05','15:05:00',1.64),('10318','2013-03-05','15:10:00',1.3),('10318','2013-03-05','15:15:00',1.23),('10318','2013-03-05','15:20:00',1.44),('10318','2013-03-05','15:25:00',1.62),('10318','2013-03-05','15:30:00',1.97),('10318','2013-03-05','15:35:00',2.01),('10318','2013-03-05','15:40:00',2.23),('10318','2013-03-05','15:45:00',2.55),('10318','2013-03-05','15:50:00',2.3),('10318','2013-03-05','15:55:00',2.01),('10318','2013-03-05','16:00:00',1.77),('10318','2013-03-05','16:05:00',1.57),('10318','2013-03-05','16:10:00',1.27),('10318','2013-03-05','16:15:00',1.13),('10318','2013-03-04','07:20:00',1.03),('10318','2013-03-04','07:25:00',1.21),('10318','2013-03-04','07:30:00',1.39),('10318','2013-03-04','07:35:00',1.59),('10318','2013-03-04','07:40:00',1.85),('10318','2013-03-04','07:45:00',2.58),('10318','2013-03-04','07:50:00',3.09),('10318','2013-03-04','07:55:00',3.4),('10318','2013-03-04','08:00:00',3.62),('10318','2013-03-04','08:05:00',3.86),('10318','2013-03-04','08:10:00',4.12),('10318','2013-03-04','08:15:00',4.37),('10318','2013-03-04','08:20:00',4.6),('10318','2013-03-04','08:25:00',4.83),('10318','2013-03-04','08:30:00',4.94),('10318','2013-03-04','08:35:00',5.25),('10318','2013-03-04','08:40:00',5.44),('10318','2013-03-04','08:45:00',5.63),('10318','2013-03-04','08:50:00',5.81),('10318','2013-03-04','08:55:00',6.03),('10318','2013-03-04','09:00:00',6.13),('10318','2013-03-04','09:05:00',6.33),('10318','2013-03-04','09:10:00',6.46),('10318','2013-03-04','09:15:00',6.64),('10318','2013-03-04','09:20:00',6.81),('10318','2013-03-04','09:25:00',6.93),('10318','2013-03-04','09:30:00',7.09),('10318','2013-03-04','09:35:00',7.22),('10318','2013-03-04','09:40:00',7.38),('10318','2013-03-04','09:45:00',7.49),('10318','2013-03-04','09:50:00',7.6),('10318','2013-03-04','09:55:00',7.72),('10318','2013-03-04','10:00:00',7.8),('10318','2013-03-04','10:05:00',7.94),('10318','2013-03-04','10:10:00',8.02),('10318','2013-03-04','10:15:00',8),('10318','2013-03-04','10:20:00',8.17),('10318','2013-03-04','10:25:00',8.22),('10318','2013-03-04','10:30:00',8.24),('10318','2013-03-04','10:35:00',8.34),('10318','2013-03-04','10:40:00',8.39),('10318','2013-03-04','10:45:00',8.43),('10318','2013-03-04','10:50:00',8.46),('10318','2013-03-04','10:55:00',8.49),('10318','2013-03-04','11:00:00',8.59),('10318','2013-03-04','11:05:00',8.7),('10318','2013-03-04','11:10:00',8.67),('10318','2013-03-04','11:15:00',8.6),('10318','2013-03-04','11:20:00',8.69),('10318','2013-03-04','11:25:00',8.68),('10318','2013-03-04','11:30:00',8.57),('10318','2013-03-04','11:35:00',8.51),('10318','2013-03-04','11:40:00',8.58),('10318','2013-03-04','11:45:00',8.6),('10318','2013-03-04','11:50:00',8.71),('10318','2013-03-04','11:55:00',8.66),('10318','2013-03-04','12:00:00',8.4),('10318','2013-03-04','12:05:00',8.43),('10318','2013-03-04','12:10:00',8.45),('10318','2013-03-04','12:15:00',8.52),('10318','2013-03-04','12:20:00',8.52),('10318','2013-03-04','12:25:00',8.57),('10318','2013-03-04','12:30:00',8.54),('10318','2013-03-04','12:35:00',8.5),('10318','2013-03-04','12:40:00',8.36),('10318','2013-03-04','12:45:00',8.32),('10318','2013-03-04','12:50:00',8.2),('10318','2013-03-04','12:55:00',8.23),('10318','2013-03-04','13:00:00',8.22),('10318','2013-03-04','13:05:00',8.15),('10318','2013-03-04','13:10:00',7.89),('10318','2013-03-04','13:15:00',7.67),('10318','2013-03-04','13:20:00',7.73),('10318','2013-03-04','13:25:00',7.77),('10318','2013-03-04','13:30:00',8.19),('10318','2013-03-04','13:35:00',8.06),('10318','2013-03-04','13:40:00',7.59),('10318','2013-03-04','13:45:00',7.13),('10318','2013-03-04','13:50:00',7.25),('10318','2013-03-04','13:55:00',7.11),('10318','2013-03-04','14:00:00',6.89),('10318','2013-03-04','14:05:00',6.8),('10318','2013-03-04','14:10:00',6.68),('10318','2013-03-04','14:15:00',6.5),('10318','2013-03-04','14:20:00',6.3),('10318','2013-03-04','14:25:00',6),('10318','2013-03-04','14:30:00',5.96),('10318','2013-03-04','14:35:00',6.03),('10318','2013-03-04','14:40:00',5.92),('10318','2013-03-04','14:45:00',5.63),('10318','2013-03-04','14:50:00',5.48),('10318','2013-03-04','14:55:00',5.33),('10318','2013-03-04','15:00:00',5.19),('10318','2013-03-04','15:05:00',5.06),('10318','2013-03-04','15:10:00',4.93),('10318','2013-03-04','15:15:00',4.73),('10318','2013-03-04','15:20:00',4.6),('10318','2013-03-04','15:25:00',4.4),('10318','2013-03-04','15:30:00',4.17),('10318','2013-03-04','15:35:00',4.03),('10318','2013-03-04','15:40:00',3.86),('10318','2013-03-04','15:45:00',3.76),('10318','2013-03-04','15:50:00',3.58),('10318','2013-03-04','15:55:00',3.4),('10318','2013-03-04','16:00:00',3.22),('10318','2013-03-04','16:05:00',3.07),('10318','2013-03-04','16:10:00',2.88),('10318','2013-03-04','16:15:00',2.63),('10318','2013-03-04','16:20:00',2.55),('10318','2013-03-04','16:25:00',2.45),('10318','2013-03-04','16:30:00',2.27),('10318','2013-03-04','16:35:00',2.1),('10318','2013-03-04','16:40:00',1.92),('10318','2013-03-04','16:45:00',1.75),('10318','2013-03-04','16:50:00',1.56),('10318','2013-03-04','16:55:00',1.41),('10318','2013-03-04','17:00:00',1.24),('10318','2013-03-04','17:05:00',1.05),('10318','2013-03-03','07:20:00',1.01),('10318','2013-03-03','07:25:00',1.23),('10318','2013-03-03','07:30:00',1.4),('10318','2013-03-03','07:35:00',1.64),('10318','2013-03-03','07:40:00',1.83),('10318','2013-03-03','07:45:00',2.15),('10318','2013-03-03','07:50:00',3.29),('10318','2013-03-03','07:55:00',3.73),('10318','2013-03-03','08:00:00',3.98),('10318','2013-03-03','08:05:00',4.23),('10318','2013-03-03','08:10:00',4.43),('10318','2013-03-03','08:15:00',4.69),('10318','2013-03-03','08:20:00',4.89),('10318','2013-03-03','08:25:00',5.14),('10318','2013-03-03','08:30:00',5.36),('10318','2013-03-03','08:35:00',5.56),('10318','2013-03-03','08:40:00',5.76),('10318','2013-03-03','08:45:00',5.97),('10318','2013-03-03','08:50:00',6.16),('10318','2013-03-03','08:55:00',6.33),('10318','2013-03-03','09:00:00',6.51),('10318','2013-03-03','09:05:00',6.69),('10318','2013-03-03','09:10:00',6.86),('10318','2013-03-03','09:15:00',6.86),('10318','2013-03-03','09:20:00',7.14),('10318','2013-03-03','09:25:00',7.26),('10318','2013-03-03','09:30:00',7.37),('10318','2013-03-03','09:35:00',7.51),('10318','2013-03-03','09:40:00',7.64),('10318','2013-03-03','09:45:00',7.74),('10318','2013-03-03','09:50:00',7.81),('10318','2013-03-03','09:55:00',7.95),('10318','2013-03-03','10:00:00',8.06),('10318','2013-03-03','10:05:00',8.19),('10318','2013-03-03','10:10:00',8.26),('10318','2013-03-03','10:15:00',8.35),('10318','2013-03-03','10:20:00',8.47),('10318','2013-03-03','10:25:00',8.55),('10318','2013-03-03','10:30:00',8.62),('10318','2013-03-03','10:35:00',8.7),('10318','2013-03-03','10:40:00',8.75),('10318','2013-03-03','10:45:00',8.76),('10318','2013-03-03','10:50:00',8.78),('10318','2013-03-03','10:55:00',8.83),('10318','2013-03-03','11:00:00',8.91),('10318','2013-03-03','11:05:00',8.85),('10318','2013-03-03','11:10:00',8.96),('10318','2013-03-03','11:15:00',8.98),('10318','2013-03-03','11:20:00',9),('10318','2013-03-03','11:25:00',9.03),('10318','2013-03-03','11:30:00',9.04),('10318','2013-03-03','11:35:00',8.97),('10318','2013-03-03','11:40:00',8.98),('10318','2013-03-03','11:45:00',9.02),('10318','2013-03-03','11:50:00',8.99),('10318','2013-03-03','11:55:00',8.98),('10318','2013-03-03','12:00:00',8.94),('10318','2013-03-03','12:05:00',8.91),('10318','2013-03-03','12:10:00',8.92),('10318','2013-03-03','12:15:00',8.86),('10318','2013-03-03','12:20:00',8.94),('10318','2013-03-03','12:25:00',8.89),('10318','2013-03-03','12:30:00',8.82),('10318','2013-03-03','12:35:00',8.69),('10318','2013-03-03','12:40:00',8.68),('10318','2013-03-03','12:45:00',8.68),('10318','2013-03-03','12:50:00',8.44),('10318','2013-03-03','12:55:00',8.59),('10318','2013-03-03','13:00:00',8.48),('10318','2013-03-03','13:05:00',8.43),('10318','2013-03-03','13:10:00',8.37),('10318','2013-03-03','13:15:00',8.3),('10318','2013-03-03','13:20:00',8.16),('10318','2013-03-03','13:25:00',8.04),('10318','2013-03-03','13:30:00',7.95),('10318','2013-03-03','13:35:00',7.88),('10318','2013-03-03','13:40:00',7.83),('10318','2013-03-03','13:45:00',7.7),('10318','2013-03-03','13:50:00',7.55),('10318','2013-03-03','13:55:00',7.48),('10318','2013-03-03','14:00:00',7.38),('10318','2013-03-03','14:05:00',7.24),('10318','2013-03-03','14:10:00',7.07),('10318','2013-03-03','14:15:00',6.96),('10318','2013-03-03','14:20:00',6.84),('10318','2013-03-03','14:25:00',6.75),('10318','2013-03-03','14:30:00',6.61),('10318','2013-03-03','14:35:00',6.33),('10318','2013-03-03','14:40:00',6.26),('10318','2013-03-03','14:45:00',5.98),('10318','2013-03-03','14:50:00',5.89),('10318','2013-03-03','14:55:00',5.69),('10318','2013-03-03','15:00:00',5.52),('10318','2013-03-03','15:05:00',5.34),('10318','2013-03-03','15:10:00',5.22),('10318','2013-03-03','15:15:00',5.08),('10318','2013-03-03','15:20:00',4.91),('10318','2013-03-03','15:25:00',4.71),('10318','2013-03-03','15:30:00',4.55),('10318','2013-03-03','15:35:00',4.33),('10318','2013-03-03','15:40:00',4.16),('10318','2013-03-03','15:45:00',3.99),('10318','2013-03-03','15:50:00',3.78),('10318','2013-03-03','15:55:00',3.63),('10318','2013-03-03','16:00:00',3.45),('10318','2013-03-03','16:05:00',3.29),('10318','2013-03-03','16:10:00',3.12),('10318','2013-03-03','16:15:00',2.94),('10318','2013-03-03','16:20:00',2.76),('10318','2013-03-03','16:25:00',2.61),('10318','2013-03-03','16:30:00',2.4),('10318','2013-03-03','16:35:00',2.22),('10318','2013-03-03','16:40:00',2.05),('10318','2013-03-03','16:45:00',1.84),('10318','2013-03-03','16:50:00',1.67),('10318','2013-03-03','16:55:00',1.5),('10318','2013-03-03','17:00:00',1.33),('10318','2013-03-03','17:05:00',1.17),('10318','2013-03-03','17:10:00',1.01),('10318','2014-03-24','07:05:00',1.1),('10318','2014-03-24','07:30:00',1.85),('10318','2014-03-24','07:35:00',1.77),('10318','2014-03-24','07:40:00',1.93),('10318','2014-03-24','07:45:00',3.46),('10318','2014-03-24','07:50:00',1.97),('10318','2014-03-24','07:55:00',1.64),('10318','2014-03-24','08:30:00',1.69),('10318','2014-03-24','08:35:00',2.29),('10318','2014-03-24','08:40:00',1.92),('10318','2014-03-24','08:45:00',1.23),('10318','2014-03-24','08:50:00',2.38),('10318','2014-03-24','08:55:00',5.38),('10318','2014-03-24','09:00:00',3.14),('10318','2014-03-24','09:05:00',1.58),('10318','2014-03-24','09:10:00',1.3),('10318','2014-03-24','09:15:00',1.76),('10318','2014-03-24','09:20:00',2.66),('10318','2014-03-24','09:25:00',4.02),('10318','2014-03-24','09:30:00',3.09),('10318','2014-03-24','09:35:00',2.44),('10318','2014-03-24','09:40:00',4.41),('10318','2014-03-24','09:45:00',2.74),('10318','2014-03-24','09:50:00',2.44),('10318','2014-03-24','09:55:00',1.81),('10318','2014-03-24','10:00:00',7.33),('10318','2014-03-24','10:05:00',7.86),('10318','2014-03-24','10:10:00',5.7),('10318','2014-03-24','10:15:00',2.38),('10318','2014-03-24','10:20:00',2.06),('10318','2014-03-24','10:25:00',1.87),('10318','2014-03-24','10:30:00',2.09),('10318','2014-03-24','10:35:00',3.32),('10318','2014-03-24','10:40:00',2.37),('10318','2014-03-24','10:45:00',4.6),('10318','2014-03-24','10:50:00',10.6),('10318','2014-03-24','10:55:00',7.97),('10318','2014-03-24','11:00:00',8.51),('10318','2014-03-24','11:05:00',4.9),('10318','2014-03-24','11:10:00',5.45),('10318','2014-03-24','11:15:00',8.19),('10318','2014-03-24','11:20:00',7.99),('10318','2014-03-24','11:25:00',6.53),('10318','2014-03-24','11:30:00',6.87),('10318','2014-03-24','11:35:00',3.26),('10318','2014-03-24','11:40:00',1.64),('10318','2014-03-24','11:45:00',1.39),('10318','2014-03-24','11:50:00',1.4),('10318','2014-03-24','11:55:00',1.38),('10318','2014-03-24','12:00:00',1.15),('10318','2014-03-24','12:15:00',1.07),('10318','2014-03-24','12:20:00',1.31),('10318','2014-03-24','12:25:00',1.78),('10318','2014-03-24','12:30:00',3.8),('10318','2014-03-24','12:35:00',4.75),('10318','2014-03-24','12:40:00',4.75),('10318','2014-03-24','12:45:00',3.64),('10318','2014-03-24','12:50:00',3.34),('10318','2014-03-24','12:55:00',3.24),('10318','2014-03-24','13:00:00',3.2),('10318','2014-03-24','13:05:00',3.06),('10318','2014-03-24','13:10:00',2.47),('10318','2014-03-24','13:15:00',2.85),('10318','2014-03-24','13:20:00',2.96),('10318','2014-03-24','13:25:00',3.26),('10318','2014-03-24','13:30:00',3.08),('10318','2014-03-24','13:35:00',3.06),('10318','2014-03-24','13:40:00',3.21),('10318','2014-03-24','13:45:00',3.17),('10318','2014-03-24','13:50:00',2.98),('10318','2014-03-24','13:55:00',2.78),('10318','2014-03-24','14:00:00',2.41),('10318','2014-03-24','14:05:00',2.59),('10318','2014-03-24','14:10:00',3.01),('10318','2014-03-24','14:15:00',3.99),('10318','2014-03-24','14:20:00',4.91),('10318','2014-03-24','14:25:00',4.52),('10318','2014-03-24','14:30:00',4.25),('10318','2014-03-24','14:35:00',5.64),('10318','2014-03-24','14:40:00',6.7),('10318','2014-03-24','14:45:00',7.9),('10318','2014-03-24','14:50:00',7.5),('10318','2014-03-24','14:55:00',6.08),('10318','2014-03-24','15:00:00',5.1),('10318','2014-03-24','15:05:00',5.05),('10318','2014-03-24','15:10:00',4.24),('10318','2014-03-24','15:15:00',3.95),('10318','2014-03-24','15:20:00',3.81),('10318','2014-03-24','15:25:00',3.44),('10318','2014-03-24','15:30:00',3.84),('10318','2014-03-24','15:35:00',3.45),('10318','2014-03-24','15:40:00',2.68),('10318','2014-03-24','15:45:00',2.93),('10318','2014-03-24','15:50:00',2.83),('10318','2014-03-24','15:55:00',4.84),('10318','2014-03-24','16:00:00',3.18),('10318','2014-03-24','16:10:00',2.1),('10318','2013-03-02','08:05:00',1.03),('10318','2013-03-02','08:35:00',1.18),('10318','2013-03-02','08:40:00',1.23),('10318','2013-03-02','08:45:00',1.29),('10318','2013-03-02','08:50:00',1.52),('10318','2013-03-02','08:55:00',1.59),('10318','2013-03-02','09:00:00',1.71),('10318','2013-03-02','09:05:00',1.61),('10318','2013-03-02','09:10:00',1.19),('10318','2013-03-02','09:20:00',1.01),('10318','2013-03-02','09:25:00',1.11),('10318','2013-03-02','09:30:00',1.03),('10318','2013-03-02','09:35:00',1.04),('10318','2013-03-02','09:40:00',1.34),('10318','2013-03-02','09:45:00',1.75),('10318','2013-03-02','09:50:00',1.93),('10318','2013-03-02','09:55:00',1.77),('10318','2013-03-02','10:00:00',1.43),('10318','2013-03-02','10:05:00',1.46),('10318','2013-03-02','10:10:00',1.4),('10318','2013-03-02','10:15:00',1.45),('10318','2013-03-02','10:20:00',1.62),('10318','2013-03-02','10:25:00',1.82),('10318','2013-03-02','10:30:00',2.02),('10318','2013-03-02','10:35:00',2.14),('10318','2013-03-02','10:40:00',2.22),('10318','2013-03-02','10:45:00',2.27),('10318','2013-03-02','10:50:00',2.5),('10318','2013-03-02','10:55:00',2.7),('10318','2013-03-02','11:00:00',2.93),('10318','2013-03-02','11:05:00',3.33),('10318','2013-03-02','11:10:00',3.07),('10318','2013-03-02','11:15:00',3.65),('10318','2013-03-02','11:20:00',3.08),('10318','2013-03-02','11:25:00',2.81),('10318','2013-03-02','11:30:00',2.85),('10318','2013-03-02','11:35:00',2.89),('10318','2013-03-02','11:40:00',3.51),('10318','2013-03-02','11:45:00',3.27),('10318','2013-03-02','11:50:00',3.35),('10318','2013-03-02','11:55:00',3.27),('10318','2013-03-02','12:00:00',3.14),('10318','2013-03-02','12:05:00',3.59),('10318','2013-03-02','12:10:00',3.61),('10318','2013-03-02','12:15:00',4.05),('10318','2013-03-02','12:20:00',4.38),('10318','2013-03-02','12:25:00',4.35),('10318','2013-03-02','12:30:00',4.82),('10318','2013-03-02','12:35:00',4.76),('10318','2013-03-02','12:40:00',5.23),('10318','2013-03-02','12:45:00',4.51),('10318','2013-03-02','12:50:00',4.09),('10318','2013-03-02','12:55:00',3.41),('10318','2013-03-02','13:00:00',3.03),('10318','2013-03-02','13:05:00',2.54),('10318','2013-03-02','13:10:00',2.11),('10318','2013-03-02','13:15:00',2.02),('10318','2013-03-02','13:20:00',2.07),('10318','2013-03-02','13:25:00',2.06),('10318','2013-03-02','13:30:00',2.53),('10318','2013-03-02','13:35:00',2.65),('10318','2013-03-02','13:40:00',2.59),('10318','2013-03-02','13:45:00',2.71),('10318','2013-03-02','13:50:00',2.6),('10318','2013-03-02','13:55:00',2.88),('10318','2013-03-02','14:00:00',3.01),('10318','2013-03-02','14:05:00',2.87),('10318','2013-03-02','14:10:00',2.49),('10318','2013-03-02','14:15:00',2.17),('10318','2013-03-02','14:20:00',1.93),('10318','2013-03-02','14:25:00',1.63),('10318','2013-03-02','14:30:00',1.35),('10318','2013-03-02','14:35:00',1.08),('10318','2013-03-02','14:40:00',1.03),('10318','2013-03-02','14:45:00',1.13),('10318','2013-03-02','14:50:00',1.52),('10318','2013-03-02','14:55:00',1.97),('10318','2013-03-02','15:00:00',1.8),('10318','2013-03-02','15:05:00',1.91),('10318','2013-03-02','15:10:00',2.02),('10318','2013-03-02','15:15:00',2.02),('10318','2013-03-02','15:20:00',1.92),('10318','2013-03-02','15:25:00',1.79),('10318','2013-03-02','15:30:00',1.9),('10318','2013-03-02','15:35:00',1.78),('10318','2013-03-02','15:40:00',1.51),('10318','2013-03-02','15:45:00',1.59),('10318','2013-03-02','15:50:00',1.51),('10318','2013-03-02','15:55:00',1.52),('10318','2013-03-02','16:00:00',1.43),('10318','2013-03-02','16:05:00',1.12),('10318','2013-03-02','16:10:00',1.12),('10318','2013-03-02','16:15:00',1.18),('10318','2013-03-02','16:20:00',1.14),('10318','2013-03-02','16:25:00',1.16),('10318','2013-03-02','16:30:00',1.24),('10318','2013-03-02','16:35:00',1.13),('10318','2013-03-01','07:40:00',1.19),('10318','2013-03-01','07:45:00',1.46),('10318','2013-03-01','07:50:00',1.91),('10318','2013-03-01','07:55:00',2.64),('10318','2013-03-01','08:00:00',2.85),('10318','2013-03-01','08:05:00',2.73),('10318','2013-03-01','08:10:00',2.81),('10318','2013-03-01','08:15:00',2.97),('10318','2013-03-01','08:20:00',3.03),('10318','2013-03-01','08:25:00',3.17),('10318','2013-03-01','08:30:00',3.34),('10318','2013-03-01','08:35:00',3.54),('10318','2013-03-01','08:40:00',3.83),('10318','2013-03-01','08:45:00',4.22),('10318','2013-03-01','08:50:00',4.42),('10318','2013-03-01','08:55:00',4.74),('10318','2013-03-01','09:00:00',5.15),('10318','2013-03-01','09:05:00',5.55),('10318','2013-03-01','09:10:00',5.3),('10318','2013-03-01','09:15:00',5.31),('10318','2013-03-01','09:20:00',5.52),('10318','2013-03-01','09:25:00',6.03),('10318','2013-03-01','09:30:00',6.2),('10318','2013-03-01','09:35:00',6.15),('10318','2013-03-01','09:40:00',6.23),('10318','2013-03-01','09:45:00',6.56),('10318','2013-03-01','09:50:00',6.66),('10318','2013-03-01','09:55:00',6.44),('10318','2013-03-01','10:00:00',6.19),('10318','2013-03-01','10:05:00',5.61),('10318','2013-03-01','10:10:00',5.28),('10318','2013-03-01','10:15:00',5.14),('10318','2013-03-01','10:20:00',4.91),('10318','2013-03-01','10:25:00',5.12),('10318','2013-03-01','10:30:00',6.06),('10318','2013-03-01','10:35:00',6.45),('10318','2013-03-01','10:40:00',5.65),('10318','2013-03-01','10:45:00',5.32),('10318','2013-03-01','10:50:00',5.1),('10318','2013-03-01','10:55:00',4.71),('10318','2013-03-01','11:00:00',4.14),('10318','2013-03-01','11:05:00',3.73),('10318','2013-03-01','11:10:00',3.57),('10318','2013-03-01','11:15:00',3.95),('10318','2013-03-01','11:20:00',4.11),('10318','2013-03-01','11:25:00',4.07),('10318','2013-03-01','11:30:00',4.09),('10318','2013-03-01','11:35:00',4.07),('10318','2013-03-01','11:40:00',3.84),('10318','2013-03-01','11:45:00',3.71),('10318','2013-03-01','11:50:00',3.65),('10318','2013-03-01','11:55:00',3.38),('10318','2013-03-01','12:00:00',3.22),('10318','2013-03-01','12:05:00',3),('10318','2013-03-01','12:10:00',2.79),('10318','2013-03-01','12:15:00',2.61),('10318','2013-03-01','12:20:00',2.51),('10318','2013-03-01','12:25:00',2.55),('10318','2013-03-01','12:30:00',2.63),('10318','2013-03-01','12:35:00',2.59),('10318','2013-03-01','12:40:00',2.52),('10318','2013-03-01','12:45:00',2.56),('10318','2013-03-01','12:50:00',2.67),('10318','2013-03-01','12:55:00',2.78),('10318','2013-03-01','13:00:00',2.92),('10318','2013-03-01','13:05:00',2.96),('10318','2013-03-01','13:10:00',3.09),('10318','2013-03-01','13:15:00',3.3),('10318','2013-03-01','13:20:00',3.66),('10318','2013-03-01','13:25:00',3.84),('10318','2013-03-01','13:30:00',3.61),('10318','2013-03-01','13:35:00',3.38),('10318','2013-03-01','13:40:00',3.25),('10318','2013-03-01','13:45:00',3.23),('10318','2013-03-01','13:50:00',3.19),('10318','2013-03-01','13:55:00',3.08),('10318','2013-03-01','14:00:00',2.97),('10318','2013-03-01','14:05:00',2.82),('10318','2013-03-01','14:10:00',2.61),('10318','2013-03-01','14:15:00',2.51),('10318','2013-03-01','14:20:00',2.43),('10318','2013-03-01','14:25:00',2.46),('10318','2013-03-01','14:30:00',2.5),('10318','2013-03-01','14:35:00',2.46),('10318','2013-03-01','14:40:00',2.3),('10318','2013-03-01','14:45:00',2.19),('10318','2013-03-01','14:50:00',2.11),('10318','2013-03-01','14:55:00',2.13),('10318','2013-03-01','15:00:00',2.12),('10318','2013-03-01','15:05:00',2.05),('10318','2013-03-01','15:10:00',1.88),('10318','2013-03-01','15:15:00',1.7),('10318','2013-03-01','15:20:00',1.64),('10318','2013-03-01','15:25:00',1.49),('10318','2013-03-01','15:30:00',1.35),('10318','2013-03-01','15:35:00',1.38),('10318','2013-03-01','15:40:00',1.44),('10318','2013-03-01','15:45:00',1.4),('10318','2013-03-01','15:50:00',1.27),('10318','2013-03-01','15:55:00',1.24),('10318','2013-03-01','16:00:00',1.26),('10318','2013-03-01','16:05:00',1.25),('10318','2013-03-01','16:10:00',1.2),('10318','2013-03-01','16:15:00',1.09),('10318','2013-02-28','07:30:00',1.1),('10318','2013-02-28','07:35:00',1.3),('10318','2013-02-28','07:40:00',1.53),('10318','2013-02-28','07:45:00',1.71),('10318','2013-02-28','07:50:00',2.05),('10318','2013-02-28','07:55:00',2.78),('10318','2013-02-28','08:00:00',3.12),('10318','2013-02-28','08:05:00',3.33),('10318','2013-02-28','08:10:00',3.59),('10318','2013-02-28','08:15:00',3.83),('10318','2013-02-28','08:20:00',4.05),('10318','2013-02-28','08:25:00',4.28),('10318','2013-02-28','08:30:00',4.51),('10318','2013-02-28','08:35:00',4.73),('10318','2013-02-28','08:40:00',4.95),('10318','2013-02-28','08:45:00',5.19),('10318','2013-02-28','08:50:00',5.38),('10318','2013-02-28','08:55:00',5.56),('10318','2013-02-28','09:00:00',5.72),('10318','2013-02-28','09:05:00',5.88),('10318','2013-02-28','09:10:00',6),('10318','2013-02-28','09:15:00',6.24),('10318','2013-02-28','09:20:00',6.31),('10318','2013-02-28','09:25:00',6.42),('10318','2013-02-28','09:30:00',6.59),('10318','2013-02-28','09:35:00',6.62),('10318','2013-02-28','09:40:00',6.94),('10318','2013-02-28','09:45:00',7.12),('10318','2013-02-28','09:50:00',6.7),('10318','2013-02-28','09:55:00',7.24),('10318','2013-02-28','10:00:00',7.38),('10318','2013-02-28','10:05:00',7.42),('10318','2013-02-28','10:10:00',7.54),('10318','2013-02-28','10:15:00',7.66),('10318','2013-02-28','10:20:00',7.81),('10318','2013-02-28','10:25:00',7.84),('10318','2013-02-28','10:30:00',7.78),('10318','2013-02-28','10:35:00',7.96),('10318','2013-02-28','10:40:00',8.05),('10318','2013-02-28','10:45:00',8.09),('10318','2013-02-28','10:50:00',8.04),('10318','2013-02-28','10:55:00',7.96),('10318','2013-02-28','11:00:00',8.14),('10318','2013-02-28','11:05:00',8.26),('10318','2013-02-28','11:10:00',8.19),('10318','2013-02-28','11:15:00',8.14),('10318','2013-02-28','11:20:00',8.13),('10318','2013-02-28','11:25:00',8.58),('10318','2013-02-28','11:30:00',8.51),('10318','2013-02-28','11:35:00',8.31),('10318','2013-02-28','11:40:00',8.35),('10318','2013-02-28','11:45:00',8.45),('10318','2013-02-28','11:50:00',8.46),('10318','2013-02-28','11:55:00',8.51),('10318','2013-02-28','12:00:00',8.37),('10318','2013-02-28','12:05:00',8.41),('10318','2013-02-28','12:10:00',8.35),('10318','2013-02-28','12:15:00',8.49),('10318','2013-02-28','12:20:00',8.58),('10318','2013-02-28','12:25:00',8.3),('10318','2013-02-28','12:30:00',8.29),('10318','2013-02-28','12:35:00',8.23),('10318','2013-02-28','12:40:00',8.07),('10318','2013-02-28','12:45:00',8.23),('10318','2013-02-28','12:50:00',8.19),('10318','2013-02-28','12:55:00',8.17),('10318','2013-02-28','13:00:00',7.88),('10318','2013-02-28','13:05:00',8.04),('10318','2013-02-28','13:10:00',7.75),('10318','2013-02-28','13:15:00',7.63),('10318','2013-02-28','13:20:00',7.88),('10318','2013-02-28','13:25:00',7.8),('10318','2013-02-28','13:30:00',7.72),('10318','2013-02-28','13:35:00',7.63),('10318','2013-02-28','13:40:00',7.57),('10318','2013-02-28','13:45:00',7.29),('10318','2013-02-28','13:50:00',7),('10318','2013-02-28','13:55:00',7),('10318','2013-02-28','14:00:00',7.04),('10318','2013-02-28','14:05:00',6.94),('10318','2013-02-28','14:10:00',6.83),('10318','2013-02-28','14:15:00',6.72),('10318','2013-02-28','14:20:00',6.42),('10318','2013-02-28','14:25:00',6.19),('10318','2013-02-28','14:30:00',6.12),('10318','2013-02-28','14:35:00',5.63),('10318','2013-02-28','14:40:00',5.81),('10318','2013-02-28','14:45:00',5.76),('10318','2013-02-28','14:50:00',5.63),('10318','2013-02-28','14:55:00',5.4),('10318','2013-02-28','15:00:00',5.43),('10318','2013-02-28','15:05:00',5.2),('10318','2013-02-28','15:10:00',4.86),('10318','2013-02-28','15:15:00',4.59),('10318','2013-02-28','15:20:00',4.26),('10318','2013-02-28','15:25:00',4.11),('10318','2013-02-28','15:30:00',3.88),('10318','2013-02-28','15:35:00',3.81),('10318','2013-02-28','15:40:00',3.65),('10318','2013-02-28','15:45:00',3.46),('10318','2013-02-28','15:50:00',3.26),('10318','2013-02-28','15:55:00',3.16),('10318','2013-02-28','16:00:00',2.98),('10318','2013-02-28','16:05:00',2.82),('10318','2013-02-28','16:10:00',2.65),('10318','2013-02-28','16:15:00',2.5),('10318','2013-02-28','16:20:00',2.36),('10318','2013-02-28','16:25:00',2.19),('10318','2013-02-28','16:30:00',2.03),('10318','2013-02-28','16:35:00',1.88),('10318','2013-02-28','16:40:00',1.72),('10318','2013-02-28','16:45:00',1.55),('10318','2013-02-28','16:50:00',1.4),('10318','2013-02-28','16:55:00',1.23),('10318','2013-02-28','17:00:00',1.08),('10318','2013-02-27','07:30:00',1.03),('10318','2013-02-27','07:35:00',1.21),('10318','2013-02-27','07:40:00',1.42),('10318','2013-02-27','07:45:00',1.64),('10318','2013-02-27','07:50:00',1.83),('10318','2013-02-27','07:55:00',2.49),('10318','2013-02-27','08:00:00',3.06),('10318','2013-02-27','08:05:00',3.28),('10318','2013-02-27','08:10:00',3.47),('10318','2013-02-27','08:15:00',3.71),('10318','2013-02-27','08:20:00',3.9),('10318','2013-02-27','08:25:00',4.11),('10318','2013-02-27','08:30:00',4.37),('10318','2013-02-27','08:35:00',4.58),('10318','2013-02-27','08:40:00',4.8),('10318','2013-02-27','08:45:00',4.98),('10318','2013-02-27','08:50:00',5.15),('10318','2013-02-27','08:55:00',5.41),('10318','2013-02-27','09:00:00',5.6),('10318','2013-02-27','09:05:00',5.79),('10318','2013-02-27','09:10:00',5.93),('10318','2013-02-27','09:15:00',6.11),('10318','2013-02-27','09:20:00',6.26),('10318','2013-02-27','09:25:00',6.38),('10318','2013-02-27','09:30:00',6.52),('10318','2013-02-27','09:35:00',6.65),('10318','2013-02-27','09:40:00',6.66),('10318','2013-02-27','09:45:00',6.94),('10318','2013-02-27','09:50:00',7.05),('10318','2013-02-27','09:55:00',7.17),('10318','2013-02-27','10:00:00',7.3),('10318','2013-02-27','10:05:00',7.45),('10318','2013-02-27','10:10:00',7.5),('10318','2013-02-27','10:15:00',7.63),('10318','2013-02-27','10:20:00',7.72),('10318','2013-02-27','10:25:00',7.88),('10318','2013-02-27','10:30:00',7.95),('10318','2013-02-27','10:35:00',8.06),('10318','2013-02-27','10:40:00',8.04),('10318','2013-02-27','10:45:00',8.19),('10318','2013-02-27','10:50:00',8.28),('10318','2013-02-27','10:55:00',8.15),('10318','2013-02-27','11:00:00',8.35),('10318','2013-02-27','11:05:00',8.4),('10318','2013-02-27','11:10:00',8.41),('10318','2013-02-27','11:15:00',8.59),('10318','2013-02-27','11:20:00',8.51),('10318','2013-02-27','11:25:00',8.45),('10318','2013-02-27','11:30:00',8.69),('10318','2013-02-27','11:35:00',8.7),('10318','2013-02-27','11:40:00',8.75),('10318','2013-02-27','11:45:00',8.65),('10318','2013-02-27','11:50:00',8.07),('10318','2013-02-27','11:55:00',8.52),('10318','2013-02-27','12:00:00',8.85),('10318','2013-02-27','12:05:00',8.87),('10318','2013-02-27','12:10:00',8.35),('10318','2013-02-27','12:15:00',4.7),('10318','2013-02-27','12:20:00',8.88),('10318','2013-02-27','12:25:00',8.82),('10318','2013-02-27','12:30:00',8.85),('10318','2013-02-27','12:35:00',8.69),('10318','2013-02-27','12:40:00',8.43),('10318','2013-02-27','12:45:00',8.29),('10318','2013-02-27','12:50:00',8.45),('10318','2013-02-27','12:55:00',8.36),('10318','2013-02-27','13:00:00',7.9),('10318','2013-02-27','13:05:00',8.01),('10318','2013-02-27','13:10:00',7.72),('10318','2013-02-27','13:15:00',7.9),('10318','2013-02-27','13:20:00',8.11),('10318','2013-02-27','13:25:00',8.02),('10318','2013-02-27','13:30:00',8.03),('10318','2013-02-27','13:35:00',7.74),('10318','2013-02-27','13:40:00',7.49),('10318','2013-02-27','13:45:00',7.12),('10318','2013-02-27','13:50:00',7.52),('10318','2013-02-27','13:55:00',7.41),('10318','2013-02-27','14:00:00',7.13),('10318','2013-02-27','14:05:00',6.44),('10318','2013-02-27','14:10:00',6.08),('10318','2013-02-27','14:15:00',5.13),('10318','2013-02-27','14:20:00',6.52),('10318','2013-02-27','14:25:00',6.17),('10318','2013-02-27','14:30:00',3.12),('10318','2013-02-27','14:35:00',2.86),('10318','2013-02-27','14:40:00',6.16),('10318','2013-02-27','14:45:00',6.2),('10318','2013-02-27','14:50:00',6.13),('10318','2013-02-27','14:55:00',5.64),('10318','2013-02-27','15:00:00',5.59),('10318','2013-02-27','15:05:00',5.39),('10318','2013-02-27','15:10:00',5.23),('10318','2013-02-27','15:15:00',4.92),('10318','2013-02-27','15:20:00',4.65),('10318','2013-02-27','15:25:00',4.43),('10318','2013-02-27','15:30:00',4.22),('10318','2013-02-27','15:35:00',4.02),('10318','2013-02-27','15:40:00',3.79),('10318','2013-02-27','15:45:00',3.62),('10318','2013-02-27','15:50:00',3.48),('10318','2013-02-27','15:55:00',3.32),('10318','2013-02-27','16:00:00',3.14),('10318','2013-02-27','16:05:00',2.97),('10318','2013-02-27','16:10:00',2.82),('10318','2013-02-27','16:15:00',2.66),('10318','2013-02-27','16:20:00',2.52),('10318','2013-02-27','16:25:00',2.31),('10318','2013-02-27','16:30:00',2.14),('10318','2013-02-27','16:35:00',1.97),('10318','2013-02-27','16:40:00',1.79),('10318','2013-02-27','16:45:00',1.62),('10318','2013-02-27','16:50:00',1.45),('10318','2013-02-27','16:55:00',1.3),('10318','2013-02-27','17:00:00',1.12),('10318','2013-02-26','08:40:00',1.02),('10318','2013-02-26','08:45:00',1.15),('10318','2013-02-26','08:50:00',1.3),('10318','2013-02-26','08:55:00',1.55),('10318','2013-02-26','09:00:00',1.7),('10318','2013-02-26','09:05:00',1.81),('10318','2013-02-26','09:10:00',2.01),('10318','2013-02-26','09:15:00',2.24),('10318','2013-02-26','09:20:00',2.38),('10318','2013-02-26','09:25:00',2.58),('10318','2013-02-26','09:30:00',2.93),('10318','2013-02-26','09:35:00',3.54),('10318','2013-02-26','09:40:00',4.48),('10318','2013-02-26','09:45:00',5.21),('10318','2013-02-26','09:50:00',5.71),('10318','2013-02-26','09:55:00',6.08),('10318','2013-02-26','10:00:00',5.99),('10318','2013-02-26','10:05:00',5.8),('10318','2013-02-26','10:10:00',5.77),('10318','2013-02-26','10:15:00',6.83),('10318','2013-02-26','10:20:00',7.71),('10318','2013-02-26','10:25:00',8.5),('10318','2013-02-26','10:30:00',6.14),('10318','2013-02-26','10:35:00',5.96),('10318','2013-02-26','10:40:00',4.94),('10318','2013-02-26','10:45:00',4.75),('10318','2013-02-26','10:50:00',4.95),('10318','2013-02-26','10:55:00',5.95),('10318','2013-02-26','11:00:00',6.4),('10318','2013-02-26','11:05:00',6.74),('10318','2013-02-26','11:10:00',7.42),('10318','2013-02-26','11:15:00',5.13),('10318','2013-02-26','11:20:00',5.59),('10318','2013-02-26','11:25:00',5.22),('10318','2013-02-26','11:30:00',4.27),('10318','2013-02-26','11:35:00',4.12),('10318','2013-02-26','11:40:00',4),('10318','2013-02-26','11:45:00',3.98),('10318','2013-02-26','11:50:00',4.19),('10318','2013-02-26','11:55:00',3.82),('10318','2013-02-26','12:00:00',5.04),('10318','2013-02-26','12:05:00',3.95),('10318','2013-02-26','12:10:00',3.82),('10318','2013-02-26','12:15:00',3.57),('10318','2013-02-26','12:20:00',3.5),('10318','2013-02-26','12:25:00',3.27),('10318','2013-02-26','12:30:00',3.17),('10318','2013-02-26','12:35:00',2.78),('10318','2013-02-26','12:40:00',2.63),('10318','2013-02-26','12:45:00',2.42),('10318','2013-02-26','12:50:00',2.23),('10318','2013-02-26','12:55:00',2.33),('10318','2013-02-26','13:00:00',2.53),('10318','2013-02-26','13:05:00',2.36),('10318','2013-02-26','13:10:00',2.25),('10318','2013-02-26','13:15:00',2.33),('10318','2013-02-26','13:20:00',2.13),('10318','2013-02-26','13:25:00',2.09),('10318','2013-02-26','13:30:00',2.11),('10318','2013-02-26','13:35:00',2.1),('10318','2013-02-26','13:40:00',2.11),('10318','2013-02-26','13:45:00',2.14),('10318','2013-02-26','13:50:00',1.91),('10318','2013-02-26','13:55:00',1.72),('10318','2013-02-26','14:00:00',1.57),('10318','2013-02-26','14:05:00',1.54),('10318','2013-02-26','14:10:00',1.42),('10318','2013-02-26','14:15:00',1.21),('10318','2013-02-25','08:35:00',1.66),('10318','2013-02-25','08:40:00',2.57),('10318','2013-02-25','08:45:00',2.71),('10318','2013-02-25','08:50:00',2.42),('10318','2013-02-25','08:55:00',2.17),('10318','2013-02-25','09:00:00',1.56),('10318','2013-02-25','09:05:00',1.61),('10318','2013-02-25','09:10:00',2.75),('10318','2013-02-25','09:15:00',2.1),('10318','2013-02-25','09:20:00',2.24),('10318','2013-02-25','09:25:00',3.8),('10318','2013-02-25','09:30:00',4.43),('10318','2013-02-25','09:35:00',2.91),('10318','2013-02-25','09:40:00',2.07),('10318','2013-02-25','09:45:00',1.93),('10318','2013-02-25','09:50:00',1.38),('10318','2013-02-25','10:20:00',1.42),('10318','2013-02-25','10:25:00',1.54),('10318','2013-02-25','10:30:00',1.29),('10318','2013-02-25','10:35:00',1.48),('10318','2013-02-25','10:40:00',2.32),('10318','2013-02-25','10:45:00',4.1),('10318','2013-02-25','10:50:00',8.6),('10318','2013-02-25','10:55:00',10.53),('10318','2013-02-25','11:00:00',9.04),('10318','2013-02-25','11:05:00',7.32),('10318','2013-02-25','11:10:00',8.35),('10318','2013-02-25','11:15:00',5.73),('10318','2013-02-25','11:20:00',8.65),('10318','2013-02-25','11:25:00',8.67),('10318','2013-02-25','11:30:00',5.87),('10318','2013-02-25','11:35:00',6.99),('10318','2013-02-25','11:40:00',3.76),('10318','2013-02-25','11:45:00',5.21),('10318','2013-02-25','11:50:00',4.89),('10318','2013-02-25','11:55:00',3.84),('10318','2013-02-25','12:00:00',3.7),('10318','2013-02-25','12:05:00',6.68),('10318','2013-02-25','12:10:00',6.17),('10318','2013-02-25','12:15:00',6.44),('10318','2013-02-25','12:20:00',6.6),('10318','2013-02-25','12:25:00',6.15),('10318','2013-02-25','12:30:00',7.26),('10318','2013-02-25','12:35:00',9.23),('10318','2013-02-25','12:40:00',9.8),('10318','2013-02-25','12:45:00',8.07),('10318','2013-02-25','12:50:00',6.69),('10318','2013-02-25','12:55:00',9.15),('10318','2013-02-25','13:00:00',7.89),('10318','2013-02-25','13:05:00',6.51),('10318','2013-02-25','13:10:00',4.59),('10318','2013-02-25','13:15:00',3.29),('10318','2013-02-25','13:20:00',2.99),('10318','2013-02-25','13:25:00',2.65),('10318','2013-02-25','13:30:00',2.62),('10318','2013-02-25','13:35:00',2.34),('10318','2013-02-25','13:40:00',2.73),('10318','2013-02-25','13:45:00',3.56),('10318','2013-02-25','13:50:00',2.59),('10318','2013-02-25','13:55:00',2.23),('10318','2013-02-25','14:00:00',1.85),('10318','2013-02-25','14:05:00',1.33),('10318','2013-02-25','14:10:00',1.01),('10318','2013-02-25','14:20:00',1.04),('10318','2013-02-25','14:30:00',1.09),('10318','2013-02-25','14:35:00',1.22),('10318','2013-02-25','14:40:00',1.18),('10318','2013-02-25','14:45:00',1.43),('10318','2013-02-25','14:50:00',1.65),('10318','2013-02-25','14:55:00',1.65),('10318','2013-02-25','15:00:00',1.46),('10318','2013-02-25','15:05:00',1.56),('10318','2013-02-25','15:10:00',1.63),('10318','2013-02-25','15:15:00',1.57),('10318','2013-02-25','15:20:00',1.5),('10318','2013-02-25','15:25:00',1.37),('10318','2013-02-25','15:30:00',1.07),('10318','2013-02-25','15:55:00',1.16),('10318','2013-02-25','16:00:00',1.32),('10318','2013-02-25','16:05:00',1.35),('10318','2013-02-25','16:10:00',1.25),('10318','2013-02-25','16:15:00',1),('10318','2013-02-25','16:30:00',2.06),('10318','2013-02-25','16:35:00',1.89),('10318','2013-02-25','16:40:00',1.4),('10318','2013-02-25','16:45:00',1.24),('10318','2013-02-25','16:50:00',1.38),('10318','2013-02-25','16:55:00',1.7),('10318','2013-02-25','17:00:00',1.52),('10318','2013-02-25','17:05:00',1.26),('10318','2013-02-25','17:10:00',1.01),('10318','2013-02-24','08:00:00',1.49),('10318','2013-02-24','08:05:00',1.21),('10318','2013-02-24','08:15:00',1.41),('10318','2013-02-24','08:20:00',1.65),('10318','2013-02-24','08:25:00',1.55),('10318','2013-02-24','08:30:00',1.09),('10318','2013-02-24','08:40:00',1.12),('10318','2013-02-24','08:45:00',2.07),('10318','2013-02-24','08:50:00',2.24),('10318','2013-02-24','08:55:00',1.52),('10318','2013-02-24','09:00:00',1.74),('10318','2013-02-24','09:05:00',1.31),('10318','2013-02-24','09:10:00',1.01),('10318','2013-02-24','09:25:00',1.1),('10318','2013-02-24','09:30:00',1.04),('10318','2013-02-24','09:45:00',1.27),('10318','2013-02-24','09:50:00',1),('10318','2013-02-24','09:55:00',1.05),('10318','2013-02-24','10:00:00',1.4),('10318','2013-02-24','10:05:00',1.29),('10318','2013-02-24','10:10:00',1.19),('10318','2013-02-24','10:15:00',1.18),('10318','2013-02-24','10:25:00',1.29),('10318','2013-02-24','10:30:00',1.46),('10318','2013-02-24','10:35:00',1.74),('10318','2013-02-24','10:40:00',2.22),('10318','2013-02-24','10:45:00',2.77),('10318','2013-02-24','10:50:00',4.3),('10318','2013-02-24','10:55:00',3.7),('10318','2013-02-24','11:00:00',2.92),('10318','2013-02-24','11:05:00',2.42),('10318','2013-02-24','11:10:00',2.07),('10318','2013-02-24','11:15:00',2.01),('10318','2013-02-24','11:20:00',1.85),('10318','2013-02-24','11:25:00',2.2),('10318','2013-02-24','11:30:00',2.1),('10318','2013-02-24','11:35:00',1.91),('10318','2013-02-24','11:40:00',2.12),('10318','2013-02-24','11:45:00',2.25),('10318','2013-02-24','11:50:00',2.05),('10318','2013-02-24','11:55:00',2.18),('10318','2013-02-24','12:00:00',1.92),('10318','2013-02-24','12:05:00',1.65),('10318','2013-02-24','12:10:00',1.19),('10318','2013-02-24','12:15:00',1.18),('10318','2013-02-24','12:25:00',1.12),('10318','2013-02-24','12:30:00',2.25),('10318','2013-02-24','12:35:00',2.31),('10318','2013-02-24','12:40:00',3),('10318','2013-02-24','12:45:00',2.22),('10318','2013-02-24','12:50:00',2.19),('10318','2013-02-24','12:55:00',2.28),('10318','2013-02-24','13:00:00',2.71),('10318','2013-02-24','13:05:00',3.14),('10318','2013-02-24','13:10:00',3.09),('10318','2013-02-24','13:15:00',2.91),('10318','2013-02-24','13:20:00',2.48),('10318','2013-02-24','13:25:00',2.42),('10318','2013-02-24','13:30:00',3.83),('10318','2013-02-24','13:35:00',2.1),('10318','2013-02-24','13:40:00',1.78),('10318','2013-02-24','13:45:00',2.64),('10318','2013-02-24','13:50:00',2.53),('10318','2013-02-24','13:55:00',2.39),('10318','2013-02-24','14:00:00',4.14),('10318','2013-02-24','14:05:00',4.82),('10318','2013-02-24','14:10:00',3.62),('10318','2013-02-24','14:15:00',3.03),('10318','2013-02-24','14:20:00',2.29),('10318','2013-02-24','14:25:00',2.58),('10318','2013-02-24','14:30:00',2.6),('10318','2013-02-24','14:35:00',2.26),('10318','2013-02-24','14:40:00',1.87),('10318','2013-02-24','14:45:00',1.78),('10318','2013-02-24','14:50:00',1.67),('10318','2013-02-24','14:55:00',1.59),('10318','2013-02-24','15:00:00',2.89),('10318','2013-02-24','15:05:00',4.08),('10318','2013-02-24','15:10:00',3.98),('10318','2013-02-24','15:15:00',3.8),('10318','2013-02-24','15:20:00',5.26),('10318','2013-02-24','15:25:00',3.37),('10318','2013-02-24','15:30:00',5.78),('10318','2013-02-24','15:35:00',3.55),('10318','2013-02-24','15:40:00',2.26),('10318','2013-02-24','15:45:00',2.93),('10318','2013-02-24','15:50:00',3.27),('10318','2013-02-24','15:55:00',3.3),('10318','2013-02-24','16:00:00',1.98),('10318','2013-02-24','16:05:00',1.53),('10318','2013-02-24','16:10:00',1.16),('10318','2013-02-24','16:15:00',1.2),('10318','2013-02-24','16:20:00',1.4),('10318','2013-02-24','16:25:00',1.71),('10318','2013-02-24','16:30:00',1.81),('10318','2013-02-24','16:35:00',2.48),('10318','2013-02-24','16:40:00',2.05),('10318','2013-02-23','07:30:00',1.05),('10318','2013-02-23','07:35:00',1.26),('10318','2013-02-23','07:40:00',1.46),('10318','2013-02-23','07:45:00',1.72),('10318','2013-02-23','07:50:00',1.97),('10318','2013-02-23','07:55:00',2.46),('10318','2013-02-23','08:00:00',3.32),('10318','2013-02-23','08:05:00',3.9),('10318','2013-02-23','08:10:00',4.62),('10318','2013-02-23','08:15:00',4.88),('10318','2013-02-23','08:20:00',2.14),('10318','2013-02-23','08:25:00',1.53),('10318','2013-02-23','08:30:00',1.38),('10318','2013-02-23','08:35:00',1.24),('10318','2013-02-23','08:40:00',1.13),('10318','2013-02-23','08:45:00',1.46),('10318','2013-02-23','08:50:00',2.05),('10318','2013-02-23','08:55:00',2.52),('10318','2013-02-23','09:00:00',3.41),('10318','2013-02-23','09:05:00',3.8),('10318','2013-02-23','09:10:00',2.27),('10318','2013-02-23','09:15:00',1.72),('10318','2013-02-23','09:20:00',1.45),('10318','2013-02-23','09:30:00',1.18),('10318','2013-02-23','09:35:00',1.71),('10318','2013-02-23','09:40:00',1.98),('10318','2013-02-23','09:45:00',2.82),('10318','2013-02-23','09:50:00',3.03),('10318','2013-02-23','09:55:00',2.95),('10318','2013-02-23','10:00:00',2.25),('10318','2013-02-23','10:05:00',2.08),('10318','2013-02-23','10:10:00',1.72),('10318','2013-02-23','10:15:00',1.42),('10318','2013-02-23','10:20:00',1.73),('10318','2013-02-23','10:25:00',2.4),('10318','2013-02-23','10:30:00',2.79),('10318','2013-02-23','10:35:00',2.42),('10318','2013-02-23','10:40:00',2.33),('10318','2013-02-23','10:45:00',2.3),('10318','2013-02-23','10:50:00',2.63),('10318','2013-02-23','10:55:00',2.18),('10318','2013-02-23','11:00:00',1.56),('10318','2013-02-23','11:05:00',1.4),('10318','2013-02-23','11:10:00',1.46),('10318','2013-02-23','11:15:00',1.52),('10318','2013-02-23','11:20:00',1.88),('10318','2013-02-23','11:25:00',1.84),('10318','2013-02-23','11:30:00',1.79),('10318','2013-02-23','11:35:00',2.34),('10318','2013-02-23','11:40:00',2.03),('10318','2013-02-23','11:45:00',1.85),('10318','2013-02-23','11:50:00',1.6),('10318','2013-02-23','11:55:00',1.34),('10318','2013-02-23','12:00:00',1.22),('10318','2013-02-23','12:05:00',1.7),('10318','2013-02-23','12:10:00',1.57),('10318','2013-02-23','12:15:00',1.18),('10318','2013-02-23','12:20:00',1.37),('10318','2013-02-23','12:25:00',1.28),('10318','2013-02-23','12:30:00',1.19),('10318','2013-02-23','13:10:00',1.03),('10318','2013-02-23','13:50:00',1.31),('10318','2013-02-23','13:55:00',2.02),('10318','2013-02-23','14:00:00',2.19),('10318','2013-02-23','14:05:00',3.72),('10318','2013-02-23','14:10:00',2.23),('10318','2013-02-23','14:45:00',1.59),('10318','2013-02-23','14:50:00',1.28),('10318','2013-02-23','14:55:00',1.05),('10318','2013-02-22','09:35:00',1.14),('10318','2013-02-22','09:40:00',1.18),('10318','2013-02-22','09:50:00',1.14),('10318','2013-02-22','10:00:00',1.05),('10318','2013-02-22','10:05:00',1.02),('10318','2013-02-22','10:15:00',1.14),('10318','2013-02-22','11:10:00',1.03),('10318','2013-02-22','11:15:00',1.02),('10318','2013-02-22','11:30:00',1.13),('10318','2013-02-22','11:35:00',1.66),('10318','2013-02-22','11:40:00',1.48),('10318','2013-02-22','11:45:00',1),('10318','2013-02-22','11:50:00',1.02),('10318','2013-02-22','11:55:00',1.38),('10318','2013-02-22','12:00:00',2.07),('10318','2013-02-22','12:05:00',1.78),('10318','2013-02-22','12:40:00',1.14),('10318','2013-02-22','12:45:00',1.82),('10318','2013-02-22','12:50:00',2.15),('10318','2013-02-22','12:55:00',2.47),('10318','2013-02-22','13:00:00',1.68),('10318','2013-02-22','13:05:00',1.04),('10318','2013-02-22','14:00:00',2.23),('10318','2013-02-22','14:05:00',1.68),('10318','2013-02-22','14:10:00',2.24),('10318','2013-02-22','14:15:00',2.72),('10318','2013-02-22','14:20:00',2.12),('10318','2013-02-22','14:25:00',1.25),('10318','2013-02-22','14:30:00',1.77),('10318','2013-02-22','14:35:00',2.56),('10318','2013-02-22','14:40:00',3.52),('10318','2013-02-22','14:45:00',3.06),('10318','2013-02-22','14:50:00',2.1),('10318','2013-02-22','14:55:00',2.1),('10318','2013-02-22','15:00:00',1.73),('10318','2013-02-22','15:45:00',1.31),('10318','2013-02-22','15:50:00',1.67),('10318','2013-02-22','15:55:00',2.12),('10318','2013-02-22','16:00:00',1.89),('10318','2013-02-22','16:05:00',1.73),('10318','2013-02-22','16:15:00',3.29),('10318','2013-02-22','16:20:00',3.57),('10318','2013-02-22','16:25:00',1.6),('10318','2013-02-22','16:30:00',1.48),('10318','2013-02-22','16:35:00',1.11),('10318','2013-02-21','09:35:00',1.1),('10318','2013-02-21','09:40:00',1.4),('10318','2013-02-21','09:45:00',1.77),('10318','2013-02-21','09:50:00',1.75),('10318','2013-02-21','09:55:00',1.68),('10318','2013-02-21','10:00:00',1.57),('10318','2013-02-21','10:05:00',1.68),('10318','2013-02-21','10:10:00',1.68),('10318','2013-02-21','10:15:00',1.64),('10318','2013-02-21','10:20:00',1.64),('10318','2013-02-21','10:25:00',1.62),('10318','2013-02-21','10:30:00',1.71),('10318','2013-02-21','10:35:00',1.71),('10318','2013-02-21','10:40:00',1.62),('10318','2013-02-21','10:45:00',1.49),('10318','2013-02-21','10:50:00',1.54),('10318','2013-02-21','10:55:00',1.48),('10318','2013-02-21','11:00:00',1.4),('10318','2013-02-21','11:05:00',1.44),('10318','2013-02-21','11:10:00',1.51),('10318','2013-02-21','11:15:00',1.64),('10318','2013-02-21','11:20:00',1.97),('10318','2013-02-21','11:25:00',2.18),('10318','2013-02-21','11:30:00',2.27),('10318','2013-02-21','11:35:00',2.35),('10318','2013-02-21','11:40:00',2.32),('10318','2013-02-21','11:45:00',2.48),('10318','2013-02-21','11:50:00',2.71),('10318','2013-02-21','11:55:00',2.55),('10318','2013-02-21','12:00:00',2.5),('10318','2013-02-21','12:05:00',2.7),('10318','2013-02-21','12:10:00',2.69),('10318','2013-02-21','12:15:00',2.86),('10318','2013-02-21','12:20:00',2.88),('10318','2013-02-21','12:25:00',2.7),('10318','2013-02-21','12:30:00',2.64),('10318','2013-02-21','12:35:00',2.62),('10318','2013-02-21','12:40:00',2.66),('10318','2013-02-21','12:45:00',2.67),('10318','2013-02-21','12:50:00',2.7),('10318','2013-02-21','12:55:00',2.83),('10318','2013-02-21','13:00:00',2.68),('10318','2013-02-21','13:05:00',2.55),('10318','2013-02-21','13:10:00',2.59),('10318','2013-02-21','13:15:00',2.66),('10318','2013-02-21','13:20:00',2.89),('10318','2013-02-21','13:25:00',2.95),('10318','2013-02-21','13:30:00',2.9),('10318','2013-02-21','13:35:00',2.75),('10318','2013-02-21','13:40:00',2.51),('10318','2013-02-21','13:45:00',2.48),('10318','2013-02-21','13:50:00',2.5),('10318','2013-02-21','13:55:00',2.44),('10318','2013-02-21','14:00:00',2.58),('10318','2013-02-21','14:05:00',2.34),('10318','2013-02-21','14:10:00',2.1),('10318','2013-02-21','14:15:00',1.77),('10318','2013-02-21','14:20:00',1.72),('10318','2013-02-21','14:25:00',1.76),('10318','2013-02-21','14:30:00',1.88),('10318','2013-02-21','14:35:00',1.94),('10318','2013-02-21','14:40:00',1.89),('10318','2013-02-21','14:45:00',1.86),('10318','2013-02-21','14:50:00',1.76),('10318','2013-02-21','14:55:00',1.59),('10318','2013-02-21','15:00:00',1.45),('10318','2013-02-21','15:05:00',1.42),('10318','2013-02-21','15:10:00',1.49),('10318','2013-02-21','15:15:00',1.43),('10318','2013-02-21','15:20:00',1.3),('10318','2013-02-21','15:25:00',1.27),('10318','2013-02-21','15:30:00',1.37),('10318','2013-02-21','15:35:00',1.46),('10318','2013-02-21','15:40:00',1.61),('10318','2013-02-21','15:45:00',1.82),('10318','2013-02-21','15:50:00',2.07),('10318','2013-02-21','15:55:00',2.3),('10318','2013-02-21','16:00:00',2.23),('10318','2013-02-21','16:05:00',2.46),('10318','2013-02-21','16:10:00',2.47),('10318','2013-02-21','16:15:00',2.91),('10318','2013-02-21','16:20:00',3.42),('10318','2013-02-21','16:25:00',3.21),('10318','2013-02-21','16:30:00',2.84),('10318','2013-02-21','16:35:00',2.36),('10318','2013-02-21','16:40:00',1.96),('10318','2013-02-21','16:45:00',1.57),('10318','2013-02-21','16:50:00',1.25),('10318','2013-02-21','16:55:00',1.04),('10318','2014-03-23','08:00:00',1.33),('10318','2014-03-23','08:05:00',1.47),('10318','2014-03-23','08:10:00',1.65),('10318','2014-03-23','08:15:00',1.65),('10318','2014-03-23','08:20:00',1.96),('10318','2014-03-23','08:25:00',2.26),('10318','2014-03-23','08:30:00',2.69),('10318','2014-03-23','08:35:00',2.44),('10318','2014-03-23','08:40:00',1.87),('10318','2014-03-23','08:45:00',2.2),('10318','2014-03-23','08:50:00',3.52),('10318','2014-03-23','08:55:00',4.01),('10318','2014-03-23','09:00:00',3),('10318','2014-03-23','09:05:00',5.67),('10318','2014-03-23','09:10:00',7.33),('10318','2014-03-23','09:15:00',6.27),('10318','2014-03-23','09:20:00',3.66),('10318','2014-03-23','09:25:00',2.4),('10318','2014-03-23','09:30:00',3.46),('10318','2014-03-23','09:35:00',3.49),('10318','2014-03-23','09:40:00',2.27),('10318','2014-03-23','09:45:00',1.89),('10318','2014-03-23','09:50:00',1.8),('10318','2014-03-23','09:55:00',1.72),('10318','2014-03-23','10:00:00',1.66),('10318','2014-03-23','10:05:00',1.66),('10318','2014-03-23','10:10:00',1.57),('10318','2014-03-23','10:15:00',1.32),('10318','2014-03-23','10:20:00',1.79),('10318','2014-03-23','10:25:00',3.08),('10318','2014-03-23','10:30:00',1.89),('10318','2014-03-23','10:35:00',1.91),('10318','2014-03-23','10:40:00',2.7),('10318','2014-03-23','10:45:00',1.64),('10318','2014-03-23','10:50:00',2.7),('10318','2014-03-23','10:55:00',3.81),('10318','2014-03-23','11:00:00',2.56),('10318','2014-03-23','11:05:00',2.68),('10318','2014-03-23','11:10:00',2.6),('10318','2014-03-23','11:15:00',1.52),('10318','2014-03-23','11:20:00',2.32),('10318','2014-03-23','11:25:00',2.67),('10318','2014-03-23','11:30:00',1.88),('10318','2014-03-23','11:35:00',5.34),('10318','2014-03-23','11:40:00',7.3),('10318','2014-03-23','11:45:00',1.71),('10318','2014-03-23','11:55:00',1.38),('10318','2014-03-23','12:00:00',2.13),('10318','2014-03-23','12:05:00',1.14),('10318','2014-03-23','12:20:00',1.24),('10318','2014-03-23','12:25:00',1.67),('10318','2014-03-23','12:30:00',1.51),('10318','2014-03-23','12:35:00',1.52),('10318','2014-03-23','13:05:00',1.28),('10318','2014-03-23','13:10:00',1.36),('10318','2014-03-23','13:15:00',1.38),('10318','2014-03-23','13:35:00',1.83),('10318','2014-03-23','13:40:00',4.43),('10318','2014-03-23','13:45:00',5.91),('10318','2014-03-23','13:50:00',2.34),('10318','2014-03-23','13:55:00',2.36),('10318','2014-03-23','14:00:00',1.88),('10318','2014-03-23','14:05:00',1.47),('10318','2014-03-23','14:20:00',1.09),('10318','2014-03-23','14:45:00',1.81),('10318','2014-03-23','14:55:00',1.51),('10318','2014-03-23','15:00:00',2.08),('10318','2014-03-23','15:05:00',3.79),('10318','2014-03-23','15:10:00',3.69),('10318','2014-03-23','15:15:00',3.2),('10318','2014-03-23','15:20:00',3.39),('10318','2014-03-23','15:25:00',5.22),('10318','2014-03-23','15:30:00',2.71),('10318','2014-03-23','15:35:00',2.05),('10318','2014-03-23','15:40:00',1.42),('10318','2013-02-20','07:55:00',1.92),('10318','2013-02-20','08:00:00',1.78),('10318','2013-02-20','08:05:00',1.36),('10318','2013-02-20','08:10:00',1.46),('10318','2013-02-20','08:15:00',2.05),('10318','2013-02-20','08:20:00',4.06),('10318','2013-02-20','08:25:00',4.31),('10318','2013-02-20','08:30:00',4.55),('10318','2013-02-20','08:35:00',4.76),('10318','2013-02-20','08:40:00',4.94),('10318','2013-02-20','08:45:00',5.14),('10318','2013-02-20','08:50:00',5.35),('10318','2013-02-20','08:55:00',5.58),('10318','2013-02-20','09:00:00',5.34),('10318','2013-02-20','09:05:00',4.77),('10318','2013-02-20','09:10:00',2.82),('10318','2013-02-20','09:15:00',2.72),('10318','2013-02-20','09:20:00',6.38),('10318','2013-02-20','09:25:00',4.89),('10318','2013-02-20','09:30:00',6.44),('10318','2013-02-20','09:35:00',7.38),('10318','2013-02-20','09:40:00',4.33),('10318','2013-02-20','09:45:00',3.69),('10318','2013-02-20','09:50:00',5.62),('10318','2013-02-20','09:55:00',5.18),('10318','2013-02-20','10:00:00',6.33),('10318','2013-02-20','10:05:00',2.44),('10318','2013-02-20','10:10:00',2.11),('10318','2013-02-20','10:15:00',1.84),('10318','2013-02-20','10:20:00',1.95),('10318','2013-02-20','10:25:00',1.94),('10318','2013-02-20','10:30:00',1.9),('10318','2013-02-20','10:35:00',2.35),('10318','2013-02-20','10:40:00',2.68),('10318','2013-02-20','10:45:00',6.14),('10318','2013-02-20','10:50:00',4.57),('10318','2013-02-20','10:55:00',5.7),('10318','2013-02-20','11:00:00',7.12),('10318','2013-02-20','11:05:00',4.6),('10318','2013-02-20','11:10:00',9.97),('10318','2013-02-20','11:15:00',10.08),('10318','2013-02-20','11:20:00',9.96),('10318','2013-02-20','11:25:00',8.63),('10318','2013-02-20','11:30:00',5.94),('10318','2013-02-20','11:35:00',6.21),('10318','2013-02-20','11:40:00',5.99),('10318','2013-02-20','11:45:00',10.2),('10318','2013-02-20','11:50:00',9.89),('10318','2013-02-20','11:55:00',8.59),('10318','2013-02-20','12:00:00',2.9),('10318','2013-02-20','12:05:00',2.55),('10318','2013-02-20','12:10:00',2.69),('10318','2013-02-20','12:15:00',3.84),('10318','2013-02-20','12:20:00',3.96),('10318','2013-02-20','12:25:00',3.39),('10318','2013-02-20','12:30:00',6.49),('10318','2013-02-20','12:35:00',8.72),('10318','2013-02-20','12:40:00',8.62),('10318','2013-02-20','12:45:00',7.26),('10318','2013-02-20','12:50:00',9.36),('10318','2013-02-20','12:55:00',7.19),('10318','2013-02-20','13:00:00',4.68),('10318','2013-02-20','13:05:00',8.78),('10318','2013-02-20','13:10:00',8.88),('10318','2013-02-20','13:15:00',8),('10318','2013-02-20','13:20:00',4.06),('10318','2013-02-20','13:25:00',3.03),('10318','2013-02-20','13:30:00',2.97),('10318','2013-02-20','13:35:00',2.55),('10318','2013-02-20','13:40:00',5.02),('10318','2013-02-20','13:45:00',7.68),('10318','2013-02-20','13:50:00',7.35),('10318','2013-02-20','13:55:00',7.1),('10318','2013-02-20','14:00:00',6.75),('10318','2013-02-20','14:05:00',4.63),('10318','2013-02-20','14:10:00',2.11),('10318','2013-02-20','14:15:00',1.67),('10318','2013-02-20','14:20:00',1.69),('10318','2013-02-20','14:25:00',2.03),('10318','2013-02-20','14:30:00',2.61),('10318','2013-02-20','14:35:00',2.57),('10318','2013-02-20','14:40:00',2.57),('10318','2013-02-20','14:45:00',2.96),('10318','2013-02-20','14:50:00',2.71),('10318','2013-02-20','14:55:00',5.13),('10318','2013-02-20','15:00:00',5.27),('10318','2013-02-20','15:05:00',4.2),('10318','2013-02-20','15:10:00',3.25),('10318','2013-02-20','15:15:00',5.42),('10318','2013-02-20','15:20:00',2.66),('10318','2013-02-20','15:25:00',1.95),('10318','2013-02-20','15:30:00',1.76),('10318','2013-02-20','15:35:00',1.57),('10318','2013-02-20','15:40:00',1.23),('10318','2013-02-20','15:45:00',1.36),('10318','2013-02-20','15:50:00',1.32),('10318','2013-02-20','15:55:00',1.49),('10318','2013-02-20','16:00:00',1.57),('10318','2013-02-20','16:05:00',2.1),('10318','2013-02-20','16:10:00',3.15),('10318','2013-02-20','16:15:00',2.28),('10318','2013-02-20','16:20:00',2.2),('10318','2013-02-20','16:25:00',2.54),('10318','2013-02-20','16:30:00',2.43),('10318','2013-02-20','16:35:00',1.94),('10318','2013-02-20','16:40:00',1.82),('10318','2013-02-20','16:45:00',1.16),('10318','2013-02-20','16:55:00',1.11),('10318','2013-02-20','17:00:00',1.09),('10318','2013-02-19','07:35:00',1.03),('10318','2013-02-19','07:40:00',1.21),('10318','2013-02-19','07:45:00',1.42),('10318','2013-02-19','07:50:00',1.63),('10318','2013-02-19','07:55:00',1.82),('10318','2013-02-19','08:00:00',2.04),('10318','2013-02-19','08:05:00',2.91),('10318','2013-02-19','08:10:00',3.48),('10318','2013-02-19','08:15:00',3.73),('10318','2013-02-19','08:20:00',3.98),('10318','2013-02-19','08:25:00',4.21),('10318','2013-02-19','08:30:00',4.43),('10318','2013-02-19','08:35:00',4.59),('10318','2013-02-19','08:40:00',4.88),('10318','2013-02-19','08:45:00',5.04),('10318','2013-02-19','08:50:00',5.21),('10318','2013-02-19','08:55:00',5.41),('10318','2013-02-19','09:00:00',5.59),('10318','2013-02-19','09:05:00',5.74),('10318','2013-02-19','09:10:00',5.91),('10318','2013-02-19','09:15:00',6.08),('10318','2013-02-19','09:20:00',6.24),('10318','2013-02-19','09:25:00',6.38),('10318','2013-02-19','09:30:00',6.52),('10318','2013-02-19','09:35:00',6.66),('10318','2013-02-19','09:40:00',6.78),('10318','2013-02-19','09:45:00',6.89),('10318','2013-02-19','09:50:00',6.94),('10318','2013-02-19','09:55:00',7.2),('10318','2013-02-19','10:00:00',7.29),('10318','2013-02-19','10:05:00',7.39),('10318','2013-02-19','10:10:00',7.5),('10318','2013-02-19','10:15:00',7.56),('10318','2013-02-19','10:20:00',7.71),('10318','2013-02-19','10:25:00',7.83),('10318','2013-02-19','10:30:00',7.87),('10318','2013-02-19','10:35:00',7.93),('10318','2013-02-19','10:40:00',8.03),('10318','2013-02-19','10:45:00',8.04),('10318','2013-02-19','10:50:00',8.06),('10318','2013-02-19','10:55:00',8.15),('10318','2013-02-19','11:00:00',8.2),('10318','2013-02-19','11:05:00',8.3),('10318','2013-02-19','11:10:00',8.4),('10318','2013-02-19','11:15:00',8.39),('10318','2013-02-19','11:20:00',8.37),('10318','2013-02-19','11:25:00',8.42),('10318','2013-02-19','11:30:00',8.46),('10318','2013-02-19','11:35:00',8.34),('10318','2013-02-19','11:40:00',8.43),('10318','2013-02-19','11:45:00',8.45),('10318','2013-02-19','11:50:00',8.47),('10318','2013-02-19','11:55:00',8.43),('10318','2013-02-19','12:00:00',8.47),('10318','2013-02-19','12:05:00',8.5),('10318','2013-02-19','12:10:00',8.43),('10318','2013-02-19','12:15:00',8.35),('10318','2013-02-19','12:20:00',8.35),('10318','2013-02-19','12:25:00',8.3),('10318','2013-02-19','12:30:00',8.27),('10318','2013-02-19','12:35:00',8.2),('10318','2013-02-19','12:40:00',8.09),('10318','2013-02-19','12:45:00',8.07),('10318','2013-02-19','12:50:00',8.02),('10318','2013-02-19','12:55:00',7.99),('10318','2013-02-19','13:00:00',7.91),('10318','2013-02-19','13:05:00',7.9),('10318','2013-02-19','13:10:00',7.78),('10318','2013-02-19','13:15:00',7.72),('10318','2013-02-19','13:20:00',7.49),('10318','2013-02-19','13:25:00',7.5),('10318','2013-02-19','13:30:00',7.24),('10318','2013-02-19','13:35:00',7.14),('10318','2013-02-19','13:40:00',6.42),('10318','2013-02-19','13:45:00',2.54),('10318','2013-02-19','13:50:00',6.18),('10318','2013-02-19','13:55:00',6.86),('10318','2013-02-19','14:00:00',6.82),('10318','2013-02-19','14:05:00',6.72),('10318','2013-02-19','14:10:00',6.53),('10318','2013-02-19','14:15:00',6.28),('10318','2013-02-19','14:20:00',6.15),('10318','2013-02-19','14:25:00',6.03),('10318','2013-02-19','14:30:00',5.92),('10318','2013-02-19','14:35:00',5.76),('10318','2013-02-19','14:40:00',5.62),('10318','2013-02-19','14:45:00',5.41),('10318','2013-02-19','14:50:00',5.28),('10318','2013-02-19','14:55:00',5.1),('10318','2013-02-19','15:00:00',4.95),('10318','2013-02-19','15:05:00',4.86),('10318','2013-02-19','15:10:00',4.77),('10318','2013-02-19','15:15:00',4.73),('10318','2013-02-19','15:20:00',4.46),('10318','2013-02-19','15:25:00',4.11),('10318','2013-02-19','15:30:00',3.87),('10318','2013-02-19','15:35:00',3.67),('10318','2013-02-19','15:40:00',3.57),('10318','2013-02-19','15:45:00',3.43),('10318','2013-02-19','15:50:00',3.3),('10318','2013-02-19','15:55:00',3.18),('10318','2013-02-19','16:00:00',2.95),('10318','2013-02-19','16:05:00',2.76),('10318','2013-02-19','16:10:00',2.63),('10318','2013-02-19','16:15:00',2.47),('10318','2013-02-19','16:20:00',2.22),('10318','2013-02-19','16:25:00',2.03),('10318','2013-02-19','16:30:00',1.92),('10318','2013-02-19','16:35:00',1.79),('10318','2013-02-19','16:40:00',1.57),('10318','2013-02-19','16:45:00',1.46),('10318','2013-02-19','16:50:00',1.26),('10318','2013-02-19','16:55:00',1.11),('10318','2013-02-18','07:50:00',1.12),('10318','2013-02-18','07:55:00',1.79),('10318','2013-02-18','08:00:00',2.33),('10318','2013-02-18','08:05:00',2.72),('10318','2013-02-18','08:10:00',3.25),('10318','2013-02-18','08:15:00',3.46),('10318','2013-02-18','08:20:00',3.59),('10318','2013-02-18','08:25:00',3.85),('10318','2013-02-18','08:30:00',4.06),('10318','2013-02-18','08:35:00',4.29),('10318','2013-02-18','08:40:00',4.43),('10318','2013-02-18','08:45:00',4.63),('10318','2013-02-18','08:50:00',4.85),('10318','2013-02-18','08:55:00',5.05),('10318','2013-02-18','09:00:00',5.18),('10318','2013-02-18','09:05:00',5.46),('10318','2013-02-18','09:10:00',5.67),('10318','2013-02-18','09:15:00',6),('10318','2013-02-18','09:20:00',5.62),('10318','2013-02-18','09:25:00',6.19),('10318','2013-02-18','09:30:00',5.7),('10318','2013-02-18','09:35:00',2.58),('10318','2013-02-18','09:40:00',2.95),('10318','2013-02-18','09:45:00',6.32),('10318','2013-02-18','09:50:00',1.99),('10318','2013-02-18','09:55:00',1.42),('10318','2013-02-18','10:00:00',3.8),('10318','2013-02-18','10:05:00',8.01),('10318','2013-02-18','10:10:00',6.74),('10318','2013-02-18','10:15:00',3.95),('10318','2013-02-18','10:20:00',3.09),('10318','2013-02-18','10:25:00',1.68),('10318','2013-02-18','10:30:00',1.83),('10318','2013-02-18','10:35:00',1.48),('10318','2013-02-18','10:40:00',1.79),('10318','2013-02-18','10:45:00',1.79),('10318','2013-02-18','10:50:00',1.75),('10318','2013-02-18','10:55:00',2.28),('10318','2013-02-18','11:00:00',2.14),('10318','2013-02-18','11:05:00',2.83),('10318','2013-02-18','11:10:00',3.54),('10318','2013-02-18','11:15:00',3.34),('10318','2013-02-18','11:20:00',4),('10318','2013-02-18','11:25:00',3.3),('10318','2013-02-18','11:30:00',3.4),('10318','2013-02-18','11:35:00',3.91),('10318','2013-02-18','11:40:00',3.8),('10318','2013-02-18','11:45:00',3.67),('10318','2013-02-18','11:50:00',4.03),('10318','2013-02-18','11:55:00',5.04),('10318','2013-02-18','12:00:00',4.3),('10318','2013-02-18','12:05:00',3.53),('10318','2013-02-18','12:10:00',3.31),('10318','2013-02-18','12:15:00',3.35),('10318','2013-02-18','12:20:00',3.11),('10318','2013-02-18','12:25:00',3.16),('10318','2013-02-18','12:30:00',2.92),('10318','2013-02-18','12:35:00',2.73),('10318','2013-02-18','12:40:00',2.97),('10318','2013-02-18','12:45:00',3.77),('10318','2013-02-18','12:50:00',3.51),('10318','2013-02-18','12:55:00',3.33),('10318','2013-02-18','13:00:00',3.65),('10318','2013-02-18','13:05:00',4.06),('10318','2013-02-18','13:10:00',4.39),('10318','2013-02-18','13:15:00',4.81),('10318','2013-02-18','13:20:00',4.08),('10318','2013-02-18','13:25:00',4.36),('10318','2013-02-18','13:30:00',3.26),('10318','2013-02-18','13:35:00',2.81),('10318','2013-02-18','13:40:00',3.01),('10318','2013-02-18','13:45:00',2.97),('10318','2013-02-18','13:50:00',3.08),('10318','2013-02-18','13:55:00',4.05),('10318','2013-02-18','14:00:00',3.8),('10318','2013-02-18','14:05:00',3.96),('10318','2013-02-18','14:10:00',3.05),('10318','2013-02-18','14:15:00',2.93),('10318','2013-02-18','14:20:00',3.78),('10318','2013-02-18','14:25:00',2.53),('10318','2013-02-18','14:30:00',2.29),('10318','2013-02-18','14:35:00',2.36),('10318','2013-02-18','14:40:00',2.72),('10318','2013-02-18','14:45:00',2.77),('10318','2013-02-18','14:50:00',2.19),('10318','2013-02-18','14:55:00',3.56),('10318','2013-02-18','15:00:00',3.64),('10318','2013-02-18','15:05:00',4.18),('10318','2013-02-18','15:10:00',1.79),('10318','2013-02-18','15:15:00',1.09),('10318','2013-02-18','15:35:00',1.29),('10318','2013-02-18','15:40:00',1.03),('10318','2013-02-17','07:45:00',1.17),('10318','2013-02-17','07:50:00',1.34),('10318','2013-02-17','07:55:00',1.57),('10318','2013-02-17','08:00:00',1.79),('10318','2013-02-17','08:05:00',2.14),('10318','2013-02-17','08:10:00',2.93),('10318','2013-02-17','08:15:00',3.21),('10318','2013-02-17','08:20:00',3.44),('10318','2013-02-17','08:25:00',3.69),('10318','2013-02-17','08:30:00',3.99),('10318','2013-02-17','08:35:00',4.37),('10318','2013-02-17','08:40:00',4.52),('10318','2013-02-17','08:45:00',4.4),('10318','2013-02-17','08:50:00',3.83),('10318','2013-02-17','08:55:00',4.95),('10318','2013-02-17','09:00:00',4.99),('10318','2013-02-17','09:05:00',5.06),('10318','2013-02-17','09:10:00',5.22),('10318','2013-02-17','09:15:00',5.69),('10318','2013-02-17','09:20:00',5.89),('10318','2013-02-17','09:25:00',6.05),('10318','2013-02-17','09:30:00',6.15),('10318','2013-02-17','09:35:00',6.23),('10318','2013-02-17','09:40:00',6.39),('10318','2013-02-17','09:45:00',6.49),('10318','2013-02-17','09:50:00',6.62),('10318','2013-02-17','09:55:00',6.78),('10318','2013-02-17','10:00:00',6.91),('10318','2013-02-17','10:05:00',7.06),('10318','2013-02-17','10:10:00',7.14),('10318','2013-02-17','10:15:00',7.15),('10318','2013-02-17','10:20:00',7.3),('10318','2013-02-17','10:25:00',7.21),('10318','2013-02-17','10:30:00',7.43),('10318','2013-02-17','10:35:00',7.53),('10318','2013-02-17','10:40:00',7.61),('10318','2013-02-17','10:45:00',7.67),('10318','2013-02-17','10:50:00',7.7),('10318','2013-02-17','10:55:00',7.78),('10318','2013-02-17','11:00:00',7.83),('10318','2013-02-17','11:05:00',7.83),('10318','2013-02-17','11:10:00',7.86),('10318','2013-02-17','11:15:00',7.87),('10318','2013-02-17','11:20:00',8.04),('10318','2013-02-17','11:25:00',8.06),('10318','2013-02-17','11:30:00',8.01),('10318','2013-02-17','11:35:00',8.03),('10318','2013-02-17','11:40:00',8.15),('10318','2013-02-17','11:45:00',8.13),('10318','2013-02-17','11:50:00',8.09),('10318','2013-02-17','11:55:00',8.03),('10318','2013-02-17','12:00:00',8.02),('10318','2013-02-17','12:05:00',8.05),('10318','2013-02-17','12:10:00',7.77),('10318','2013-02-17','12:15:00',7.89),('10318','2013-02-17','12:20:00',7.9),('10318','2013-02-17','12:25:00',7.93),('10318','2013-02-17','12:30:00',7.91),('10318','2013-02-17','12:35:00',7.89),('10318','2013-02-17','12:40:00',7.82),('10318','2013-02-17','12:45:00',7.79),('10318','2013-02-17','12:50:00',7.67),('10318','2013-02-17','12:55:00',7.62),('10318','2013-02-17','13:00:00',7.55),('10318','2013-02-17','13:05:00',7.43),('10318','2013-02-17','13:10:00',7.34),('10318','2013-02-17','13:15:00',7.42),('10318','2013-02-17','13:20:00',7.4),('10318','2013-02-17','13:25:00',7.25),('10318','2013-02-17','13:30:00',7.07),('10318','2013-02-17','13:35:00',6.77),('10318','2013-02-17','13:40:00',6.68),('10318','2013-02-17','13:45:00',6.23),('10318','2013-02-17','13:50:00',6.26),('10318','2013-02-17','13:55:00',6.2),('10318','2013-02-17','14:01:00',4.33),('10318','2013-02-17','14:05:00',3.69),('10318','2013-02-17','14:10:00',6.4),('10318','2013-02-17','14:15:00',6.36),('10318','2013-02-17','14:20:00',6.5),('10318','2013-02-17','14:25:00',3.79),('10318','2013-02-17','14:30:00',2.68),('10318','2013-02-17','14:35:00',5.83),('10318','2013-02-17','14:40:00',5.49),('10318','2013-02-17','14:45:00',2.92),('10318','2013-02-17','14:50:00',4.72),('10318','2013-02-17','14:55:00',5.54),('10318','2013-02-17','15:00:00',5.34),('10318','2013-02-17','15:05:00',5.3),('10318','2013-02-17','15:10:00',5.13),('10318','2013-02-17','15:15:00',4.74),('10318','2013-02-17','15:20:00',4.52),('10318','2013-02-17','15:25:00',4.31),('10318','2013-02-17','15:30:00',4.06),('10318','2013-02-17','15:35:00',3.92),('10318','2013-02-17','15:40:00',3.69),('10318','2013-02-17','15:45:00',3.6),('10318','2013-02-17','15:50:00',3.4),('10318','2013-02-17','15:55:00',2.96),('10318','2013-02-17','16:00:00',2.89),('10318','2013-02-17','16:05:00',2.28),('10318','2013-02-17','16:15:00',1.94),('10318','2013-02-17','16:20:00',2.21),('10318','2013-02-17','16:25:00',1.94),('10318','2013-02-17','16:30:00',2.37),('10318','2013-02-17','16:35:00',1.43),('10318','2013-02-16','07:50:00',1.25),('10318','2013-02-16','07:55:00',1.6),('10318','2013-02-16','08:00:00',2.03),('10318','2013-02-16','08:05:00',2.31),('10318','2013-02-16','08:10:00',2.81),('10318','2013-02-16','08:15:00',3.14),('10318','2013-02-16','08:20:00',3.41),('10318','2013-02-16','08:25:00',3.63),('10318','2013-02-16','08:30:00',3.87),('10318','2013-02-16','08:35:00',4.11),('10318','2013-02-16','08:40:00',4.17),('10318','2013-02-16','08:45:00',2.8),('10318','2013-02-16','08:50:00',1.11),('10318','2013-02-16','08:55:00',1.61),('10318','2013-02-16','09:00:00',1.96),('10318','2013-02-16','09:05:00',4.91),('10318','2013-02-16','09:10:00',5.84),('10318','2013-02-16','09:15:00',5.97),('10318','2013-02-16','09:20:00',6.21),('10318','2013-02-16','09:25:00',6.19),('10318','2013-02-16','09:30:00',6.51),('10318','2013-02-16','09:35:00',6.54),('10318','2013-02-16','09:40:00',6.65),('10318','2013-02-16','09:45:00',6.68),('10318','2013-02-16','09:50:00',6.8),('10318','2013-02-16','09:55:00',6.87),('10318','2013-02-16','10:00:00',7),('10318','2013-02-16','10:05:00',7.12),('10318','2013-02-16','10:10:00',7.26),('10318','2013-02-16','10:15:00',7.32),('10318','2013-02-16','10:20:00',7.43),('10318','2013-02-16','10:25:00',7.6),('10318','2013-02-16','10:30:00',7.66),('10318','2013-02-16','10:35:00',7.8),('10318','2013-02-16','10:40:00',7.83),('10318','2013-02-16','10:45:00',7.91),('10318','2013-02-16','10:50:00',7.98),('10318','2013-02-16','10:55:00',8.01),('10318','2013-02-16','11:00:00',8.16),('10318','2013-02-16','11:05:00',8.22),('10318','2013-02-16','11:10:00',8.23),('10318','2013-02-16','11:15:00',8.34),('10318','2013-02-16','11:20:00',8.34),('10318','2013-02-16','11:25:00',8.29),('10318','2013-02-16','11:30:00',8.35),('10318','2013-02-16','11:35:00',8.37),('10318','2013-02-16','11:40:00',8.38),('10318','2013-02-16','11:45:00',8.42),('10318','2013-02-16','11:50:00',8.42),('10318','2013-02-16','11:55:00',8.38),('10318','2013-02-16','12:00:00',8.34),('10318','2013-02-16','12:05:00',8.36),('10318','2013-02-16','12:10:00',8.33),('10318','2013-02-16','12:15:00',8.29),('10318','2013-02-16','12:20:00',8.22),('10318','2013-02-16','12:25:00',8.21),('10318','2013-02-16','12:30:00',8.04),('10318','2013-02-16','12:35:00',8.1),('10318','2013-02-16','12:40:00',8.14),('10318','2013-02-16','12:45:00',8.07),('10318','2013-02-16','12:50:00',7.98),('10318','2013-02-16','12:55:00',7.91),('10318','2013-02-16','13:00:00',7.79),('10318','2013-02-16','13:05:00',7.73),('10318','2013-02-16','13:10:00',7.67),('10318','2013-02-16','13:15:00',7.59),('10318','2013-02-16','13:20:00',7.48),('10318','2013-02-16','13:25:00',7.41),('10318','2013-02-16','13:30:00',7.28),('10318','2013-02-16','13:35:00',7.21),('10318','2013-02-16','13:40:00',7.15),('10318','2013-02-16','13:45:00',7.1),('10318','2013-02-16','13:50:00',6.92),('10318','2013-02-16','13:55:00',6.75),('10318','2013-02-16','14:00:00',6.83),('10318','2013-02-16','14:05:00',6.6),('10318','2013-02-16','14:10:00',6.47),('10318','2013-02-16','14:15:00',6.25),('10318','2013-02-16','14:20:00',5.6),('10318','2013-02-16','14:25:00',2.14),('10318','2013-02-16','14:30:00',5.53),('10318','2013-02-16','14:35:00',3.05),('10318','2013-02-16','14:40:00',2.09),('10318','2013-02-16','14:45:00',2.37),('10318','2013-02-16','14:50:00',1.99),('10318','2013-02-16','14:55:00',1.9),('10318','2013-02-16','15:00:00',1.99),('10318','2013-02-16','15:05:00',1.99),('10318','2013-02-16','15:10:00',2.11),('10318','2013-02-16','15:15:00',3.07),('10318','2013-02-16','15:20:00',5.12),('10318','2013-02-16','15:25:00',4.96),('10318','2013-02-16','15:30:00',4.64),('10318','2013-02-16','15:35:00',4.34),('10318','2013-02-16','15:40:00',4.31),('10318','2013-02-16','15:45:00',2.54),('10318','2013-02-16','15:50:00',2.05),('10318','2013-02-16','15:55:00',1.96),('10318','2013-02-16','16:00:00',1.93),('10318','2013-02-16','16:05:00',1.68),('10318','2013-02-16','16:10:00',2.6),('10318','2013-02-16','16:15:00',1.67),('10318','2013-02-16','16:20:00',2.2),('10318','2013-02-16','16:25:00',1.74),('10318','2013-02-16','16:30:00',1.26),('10318','2013-02-15','07:40:00',1.16),('10318','2013-02-15','07:45:00',1.42),('10318','2013-02-15','07:50:00',1.68),('10318','2013-02-15','07:55:00',1.96),('10318','2013-02-15','08:00:00',1.95),('10318','2013-02-15','08:05:00',1.91),('10318','2013-02-15','08:10:00',2.46),('10318','2013-02-15','08:15:00',1.72),('10318','2013-02-15','08:20:00',1.46),('10318','2013-02-15','08:50:00',1.32),('10318','2013-02-15','08:55:00',1.42),('10318','2013-02-15','09:00:00',1.23),('10318','2013-02-15','09:10:00',1.24),('10318','2013-02-15','09:15:00',2),('10318','2013-02-15','09:20:00',3.17),('10318','2013-02-15','09:25:00',2.3),('10318','2013-02-15','09:30:00',3.52),('10318','2013-02-15','09:35:00',2.28),('10318','2013-02-15','09:40:00',3.06),('10318','2013-02-15','09:45:00',4),('10318','2013-02-15','09:50:00',3.22),('10318','2013-02-15','09:55:00',5.24),('10318','2013-02-15','10:00:00',5.74),('10318','2013-02-15','10:05:00',5.89),('10318','2013-02-15','10:10:00',5.06),('10318','2013-02-15','10:15:00',4.93),('10318','2013-02-15','10:20:00',5.57),('10318','2013-02-15','10:25:00',4.88),('10318','2013-02-15','10:30:00',6.49),('10318','2013-02-15','10:35:00',6.93),('10318','2013-02-15','10:40:00',7.06),('10318','2013-02-15','10:45:00',7.86),('10318','2013-02-15','10:50:00',4.16),('10318','2013-02-15','10:55:00',4.35),('10318','2013-02-15','11:00:00',4.63),('10318','2013-02-15','11:05:00',4.86),('10318','2013-02-15','11:10:00',5.94),('10318','2013-02-15','11:15:00',8.6),('10318','2013-02-15','11:20:00',8.57),('10318','2013-02-15','11:25:00',8.4),('10318','2013-02-15','11:30:00',8.46),('10318','2013-02-15','11:35:00',7.44),('10318','2013-02-15','11:40:00',8.03),('10318','2013-02-15','11:45:00',8.87),('10318','2013-02-15','11:50:00',7.6),('10318','2013-02-15','11:55:00',5.78),('10318','2013-02-15','12:00:00',6.19),('10318','2013-02-15','12:05:00',6.5),('10318','2013-02-15','12:10:00',6.71),('10318','2013-02-15','12:15:00',8.53),('10318','2013-02-15','12:20:00',8.53),('10318','2013-02-15','12:25:00',8.34),('10318','2013-02-15','12:30:00',8.26),('10318','2013-02-15','12:35:00',8.08),('10318','2013-02-15','12:40:00',8.11),('10318','2013-02-15','12:45:00',8.01),('10318','2013-02-15','12:50:00',7.92),('10318','2013-02-15','12:55:00',7.9),('10318','2013-02-15','13:00:00',7.88),('10318','2013-02-15','13:05:00',7.76),('10318','2013-02-15','13:10:00',7.19),('10318','2013-02-15','13:15:00',5.59),('10318','2013-02-15','13:20:00',3.7),('10318','2013-02-15','13:25:00',3.73),('10318','2013-02-15','13:30:00',5.41),('10318','2013-02-15','13:35:00',7.1),('10318','2013-02-15','13:40:00',5.79),('10318','2013-02-15','13:45:00',5.28),('10318','2013-02-15','13:50:00',5.95),('10318','2013-02-15','13:55:00',4.44),('10318','2013-02-15','14:00:00',5.01),('10318','2013-02-15','14:05:00',7.91),('10318','2013-02-15','14:10:00',5.69),('10318','2013-02-15','14:15:00',5.94),('10318','2013-02-15','14:20:00',5.06),('10318','2013-02-15','14:25:00',5.85),('10318','2013-02-15','14:30:00',4.37),('10318','2013-02-15','14:35:00',6.04),('10318','2013-02-15','14:40:00',4.87),('10318','2013-02-15','14:45:00',3.24),('10318','2013-02-15','14:50:00',3.06),('10318','2013-02-15','14:55:00',3.01),('10318','2013-02-15','15:00:00',3.03),('10318','2013-02-15','15:05:00',2.76),('10318','2013-02-15','15:10:00',4.05),('10318','2013-02-15','15:15:00',3.38),('10318','2013-02-15','15:20:00',3.31),('10318','2013-02-15','15:25:00',4.11),('10318','2013-02-15','15:30:00',3.94),('10318','2013-02-15','15:35:00',2.82),('10318','2013-02-15','15:40:00',2.7),('10318','2013-02-15','15:45:00',2.25),('10318','2013-02-15','15:50:00',1.87),('10318','2013-02-15','15:55:00',1.69),('10318','2013-02-15','16:00:00',1.63),('10318','2013-02-15','16:05:00',1.5),('10318','2013-02-15','16:10:00',1.37),('10318','2013-02-15','16:15:00',1.17),('10318','2013-02-15','16:20:00',1.01),('10318','2013-02-14','07:40:00',1.06),('10318','2013-02-14','07:45:00',1.25),('10318','2013-02-14','07:50:00',1.49),('10318','2013-02-14','07:55:00',1.67),('10318','2013-02-14','08:00:00',2.36),('10318','2013-02-14','08:05:00',2.69),('10318','2013-02-14','08:10:00',2.95),('10318','2013-02-14','08:15:00',3.48),('10318','2013-02-14','08:20:00',3.64),('10318','2013-02-14','08:25:00',4.08),('10318','2013-02-14','08:30:00',4.38),('10318','2013-02-14','08:35:00',4.58),('10318','2013-02-14','08:40:00',4.81),('10318','2013-02-14','08:45:00',5.01),('10318','2013-02-14','08:50:00',5.21),('10318','2013-02-14','08:55:00',5.4),('10318','2013-02-14','09:00:00',5.48),('10318','2013-02-14','09:05:00',5.7),('10318','2013-02-14','09:10:00',5.86),('10318','2013-02-14','09:15:00',6.1),('10318','2013-02-14','09:20:00',6.29),('10318','2013-02-14','09:25:00',6.44),('10318','2013-02-14','09:30:00',6.55),('10318','2013-02-14','09:35:00',6.7),('10318','2013-02-14','09:40:00',6.86),('10318','2013-02-14','09:45:00',7),('10318','2013-02-14','09:50:00',7.15),('10318','2013-02-14','09:55:00',7.29),('10318','2013-02-14','10:00:00',7.39),('10318','2013-02-14','10:05:00',7.53),('10318','2013-02-14','10:10:00',7.64),('10318','2013-02-14','10:15:00',7.71),('10318','2013-02-14','10:20:00',7.83),('10318','2013-02-14','10:25:00',7.91),('10318','2013-02-14','10:30:00',8),('10318','2013-02-14','10:35:00',8.07),('10318','2013-02-14','10:40:00',8.14),('10318','2013-02-14','10:45:00',8.04),('10318','2013-02-14','10:50:00',8.26),('10318','2013-02-14','10:55:00',8.31),('10318','2013-02-14','11:00:00',8.35),('10318','2013-02-14','11:05:00',8.38),('10318','2013-02-14','11:10:00',8.4),('10318','2013-02-14','11:15:00',8.45),('10318','2013-02-14','11:20:00',8.51),('10318','2013-02-14','11:25:00',8.55),('10318','2013-02-14','11:30:00',8.53),('10318','2013-02-14','11:35:00',8.51),('10318','2013-02-14','11:40:00',8.52),('10318','2013-02-14','11:45:00',8.55),('10318','2013-02-14','11:50:00',8.51),('10318','2013-02-14','11:55:00',8.5),('10318','2013-02-14','12:00:00',8.57),('10318','2013-02-14','12:05:00',8.53),('10318','2013-02-14','12:10:00',8.5),('10318','2013-02-14','12:15:00',8.47),('10318','2013-02-14','12:20:00',8.46),('10318','2013-02-14','12:25:00',8.37),('10318','2013-02-14','12:30:00',8.24),('10318','2013-02-14','12:35:00',8.29),('10318','2013-02-14','12:40:00',8.27),('10318','2013-02-14','12:45:00',8.25),('10318','2013-02-14','12:50:00',8.16),('10318','2013-02-14','12:55:00',8.05),('10318','2013-02-14','13:00:00',8),('10318','2013-02-14','13:05:00',7.94),('10318','2013-02-14','13:10:00',7.85),('10318','2013-02-14','13:15:00',7.77),('10318','2013-02-14','13:20:00',7.65),('10318','2013-02-14','13:25:00',7.57),('10318','2013-02-14','13:30:00',7.48),('10318','2013-02-14','13:35:00',7.38),('10318','2013-02-14','13:40:00',7.25),('10318','2013-02-14','13:45:00',7.13),('10318','2013-02-14','13:50:00',7),('10318','2013-02-14','13:55:00',6.89),('10318','2013-02-14','14:00:00',6.81),('10318','2013-02-14','14:05:00',6.63),('10318','2013-02-14','14:10:00',6.51),('10318','2013-02-14','14:15:00',6.29),('10318','2013-02-14','14:20:00',6.2),('10318','2013-02-14','14:25:00',6.06),('10318','2013-02-14','14:30:00',5.95),('10318','2013-02-14','14:35:00',5.76),('10318','2013-02-14','14:40:00',5.61),('10318','2013-02-14','14:45:00',5.45),('10318','2013-02-14','14:50:00',5.31),('10318','2013-02-14','14:55:00',5.1),('10318','2013-02-14','15:00:00',4.9),('10318','2013-02-14','15:05:00',4.75),('10318','2013-02-14','15:10:00',4.57),('10318','2013-02-14','15:15:00',4.36),('10318','2013-02-14','15:20:00',4.21),('10318','2013-02-14','15:25:00',4.06),('10318','2013-02-14','15:30:00',3.83),('10318','2013-02-14','15:35:00',3.7),('10318','2013-02-14','15:40:00',3.54),('10318','2013-02-14','15:45:00',3.37),('10318','2013-02-14','15:50:00',3.19),('10318','2013-02-14','15:55:00',3.02),('10318','2013-02-14','16:00:00',2.83),('10318','2013-02-14','16:05:00',2.71),('10318','2013-02-14','16:10:00',2.49),('10318','2013-02-14','16:15:00',2.37),('10318','2013-02-14','16:20:00',2.2),('10318','2013-02-14','16:25:00',2.03),('10318','2013-02-14','16:30:00',1.83),('10318','2013-02-14','16:35:00',1.64),('10318','2013-02-14','16:40:00',1.46),('10318','2013-02-14','16:45:00',1.3),('10318','2013-02-14','16:50:00',1.14),('10318','2013-02-13','08:25:00',1.07),('10318','2013-02-13','08:30:00',1.18),('10318','2013-02-13','08:35:00',1.34),('10318','2013-02-13','08:40:00',1.5),('10318','2013-02-13','08:45:00',1.72),('10318','2013-02-13','08:50:00',2.03),('10318','2013-02-13','08:55:00',2.48),('10318','2013-02-13','09:00:00',2.71),('10318','2013-02-13','09:05:00',2.99),('10318','2013-02-13','09:10:00',3.02),('10318','2013-02-13','09:15:00',3.08),('10318','2013-02-13','09:20:00',3.05),('10318','2013-02-13','09:25:00',3.2),('10318','2013-02-13','09:30:00',4.19),('10318','2013-02-13','09:35:00',5.33),('10318','2013-02-13','09:40:00',5.16),('10318','2013-02-13','09:45:00',6.15),('10318','2013-02-13','09:50:00',5.88),('10318','2013-02-13','09:55:00',5.13),('10318','2013-02-13','10:00:00',6.18),('10318','2013-02-13','10:05:00',6.64),('10318','2013-02-13','10:10:00',7.06),('10318','2013-02-13','10:15:00',7.27),('10318','2013-02-13','10:20:00',7.51),('10318','2013-02-13','10:25:00',7.51),('10318','2013-02-13','10:30:00',7.8),('10318','2013-02-13','10:35:00',8.05),('10318','2013-02-13','10:40:00',8.05),('10318','2013-02-13','10:45:00',7.59),('10318','2013-02-13','10:50:00',7.21),('10318','2013-02-13','10:55:00',7.84),('10318','2013-02-13','11:00:00',8.42),('10318','2013-02-13','11:05:00',8.09),('10318','2013-02-13','11:10:00',7.5),('10318','2013-02-13','11:15:00',6.21),('10318','2013-02-13','11:20:00',5.88),('10318','2013-02-13','11:25:00',3.21),('10318','2013-02-13','11:30:00',2.7),('10318','2013-02-13','11:35:00',4.9),('10318','2013-02-13','11:40:00',2.99),('10318','2013-02-13','11:45:00',3.1),('10318','2013-02-13','11:50:00',6.55),('10318','2013-02-13','11:55:00',8.12),('10318','2013-02-13','12:00:00',5.75),('10318','2013-02-13','12:05:00',5.16),('10318','2013-02-13','12:10:00',3.58),('10318','2013-02-13','12:15:00',4.33),('10318','2013-02-13','12:20:00',3.02),('10318','2013-02-13','12:25:00',4.13),('10318','2013-02-13','12:30:00',2.14),('10318','2013-02-13','12:35:00',2.36),('10318','2013-02-13','12:40:00',3.67),('10318','2013-02-13','12:45:00',7.19),('10318','2013-02-13','12:50:00',6.45),('10318','2013-02-13','12:55:00',5.13),('10318','2013-02-13','13:00:00',5.31),('10318','2013-02-13','13:05:00',5.47),('10318','2013-02-13','13:10:00',6.13),('10318','2013-02-13','13:15:00',6.68),('10318','2013-02-13','13:20:00',7),('10318','2013-02-13','13:25:00',7.11),('10318','2013-02-13','13:30:00',7.54),('10318','2013-02-13','13:35:00',7.93),('10318','2013-02-13','13:40:00',8.01),('10318','2013-02-13','13:45:00',7.88),('10318','2013-02-13','13:50:00',5.69),('10318','2013-02-13','13:55:00',6.85),('10318','2013-02-13','14:00:00',5.68),('10318','2013-02-13','14:05:00',5.71),('10318','2013-02-13','14:10:00',6.52),('10318','2013-02-13','14:15:00',6.02),('10318','2013-02-13','14:20:00',5.18),('10318','2013-02-13','14:25:00',5.44),('10318','2013-02-13','14:30:00',5.12),('10318','2013-02-13','14:35:00',5.55),('10318','2013-02-13','14:40:00',5.59),('10318','2013-02-13','14:45:00',5.51),('10318','2013-02-13','14:50:00',5.11),('10318','2013-02-13','14:55:00',5.12),('10318','2013-02-13','15:00:00',4.93),('10318','2013-02-13','15:05:00',4.8),('10318','2013-02-13','15:10:00',4.56),('10318','2013-02-13','15:15:00',4.39),('10318','2013-02-13','15:20:00',4.18),('10318','2013-02-13','15:25:00',4.07),('10318','2013-02-13','15:30:00',3.93),('10318','2013-02-13','15:35:00',3.77),('10318','2013-02-13','15:40:00',3.59),('10318','2013-02-13','15:45:00',3.44),('10318','2013-02-13','15:50:00',3.32),('10318','2013-02-13','15:55:00',3.13),('10318','2013-02-13','16:00:00',2.93),('10318','2013-02-13','16:05:00',2.8),('10318','2013-02-13','16:10:00',2.62),('10318','2013-02-13','16:15:00',2.45),('10318','2013-02-13','16:20:00',2.27),('10318','2013-02-13','16:25:00',2.06),('10318','2013-02-13','16:30:00',1.75),('10318','2013-02-13','16:35:00',1.68),('10318','2013-02-13','16:40:00',1.48),('10318','2013-02-13','16:45:00',1.32),('10318','2013-02-12','11:40:00',1.12),('10318','2013-02-12','11:45:00',1.16),('10318','2013-02-12','11:50:00',1.1),('10318','2013-02-12','11:55:00',1.01),('10318','2013-02-12','12:05:00',1.03),('10318','2013-02-12','12:10:00',1.22),('10318','2013-02-12','12:15:00',1.23),('10318','2013-02-12','12:20:00',1.17),('10318','2013-02-12','12:25:00',1.1),('10318','2013-02-12','12:30:00',1.14),('10318','2013-02-12','12:35:00',1.05),('10318','2013-02-12','12:40:00',1.07),('10318','2013-02-12','13:25:00',1.03),('10318','2013-02-12','13:30:00',1.16),('10318','2013-02-12','13:35:00',1.13),('10318','2013-02-12','13:40:00',1.06),('10318','2013-02-12','13:45:00',1.02),('10318','2013-02-11','09:10:00',1.06),('10318','2013-02-11','09:15:00',1.25),('10318','2013-02-11','09:20:00',1.34),('10318','2013-02-11','09:25:00',1.53),('10318','2013-02-11','09:30:00',1.51),('10318','2013-02-11','09:35:00',1.49),('10318','2013-02-11','09:40:00',1.11),('10318','2013-02-11','09:55:00',1.06),('10318','2013-02-11','10:00:00',1.27),('10318','2013-02-11','10:05:00',1.45),('10318','2013-02-11','10:10:00',1.55),('10318','2013-02-11','10:15:00',2.21),('10318','2013-02-11','10:20:00',2.47),('10318','2013-02-11','10:25:00',2.43),('10318','2013-02-11','10:30:00',2.11),('10318','2013-02-11','10:35:00',2.44),('10318','2013-02-11','10:40:00',1.77),('10318','2013-02-11','10:45:00',1.65),('10318','2013-02-11','10:50:00',1.4),('10318','2013-02-11','10:55:00',1.32),('10318','2013-02-11','11:00:00',1.67),('10318','2013-02-11','11:05:00',1.7),('10318','2013-02-11','11:10:00',2.59),('10318','2013-02-11','11:15:00',2.94),('10318','2013-02-11','11:20:00',2.69),('10318','2013-02-11','11:25:00',1.77),('10318','2013-02-11','11:30:00',1.2),('10318','2013-02-11','11:35:00',1.41),('10318','2013-02-11','11:40:00',1.92),('10318','2013-02-11','11:45:00',2.78),('10318','2013-02-11','11:50:00',1.96),('10318','2013-02-11','11:55:00',1.22),('10318','2013-02-11','12:00:00',1.1),('10318','2013-02-11','12:05:00',1.28),('10318','2013-02-11','12:10:00',1.24),('10318','2013-02-11','12:15:00',1.3),('10318','2013-02-11','12:35:00',1.09),('10318','2013-02-11','12:40:00',1.94),('10318','2013-02-11','12:45:00',2.72),('10318','2013-02-11','12:50:00',1.44),('10318','2013-02-11','12:55:00',1.69),('10318','2013-02-11','13:00:00',1.39),('10318','2013-02-11','13:05:00',1.03),('10318','2013-02-11','13:50:00',1.7),('10318','2013-02-11','13:55:00',1.97),('10318','2013-02-11','14:00:00',2.07),('10318','2013-02-11','14:05:00',1.84),('10318','2013-02-11','14:10:00',2.64),('10318','2013-02-11','14:15:00',1.98),('10318','2013-02-11','14:20:00',2.13),('10318','2013-02-11','14:25:00',3.13),('10318','2013-02-11','14:30:00',4.16),('10318','2013-02-11','14:35:00',3.54),('10318','2013-02-11','14:40:00',3.6),('10318','2013-02-11','14:45:00',2.8),('10318','2013-02-11','14:50:00',2.13),('10318','2013-02-11','14:55:00',1.8),('10318','2013-02-11','15:00:00',1.5),('10318','2013-02-11','15:05:00',2),('10318','2013-02-11','15:10:00',1.73),('10318','2013-02-11','15:15:00',1.59),('10318','2013-02-11','15:20:00',1.93),('10318','2013-02-11','15:25:00',1.65),('10318','2013-02-11','15:30:00',1.35),('10318','2013-02-11','15:35:00',1.45),('10318','2013-02-11','15:40:00',1.05),('10318','2013-02-11','15:45:00',1.36),('10318','2013-02-11','15:50:00',1.45),('10318','2014-03-22','07:25:00',1.06),('10318','2014-03-22','07:30:00',1.53),('10318','2014-03-22','07:35:00',2.2),('10318','2014-03-22','07:40:00',2.39),('10318','2014-03-22','07:45:00',2.82),('10318','2014-03-22','07:50:00',2.39),('10318','2014-03-22','07:55:00',1.36),('10318','2014-03-22','08:00:00',1.23),('10318','2014-03-22','08:05:00',2.62),('10318','2014-03-22','08:10:00',4.27),('10318','2014-03-22','08:15:00',4.39),('10318','2014-03-22','08:20:00',4.67),('10318','2014-03-22','08:25:00',5.08),('10318','2014-03-22','08:30:00',4.18),('10318','2014-03-22','08:35:00',4.73),('10318','2014-03-22','08:40:00',5.88),('10318','2014-03-22','08:45:00',6.17),('10318','2014-03-22','08:50:00',4.38),('10318','2014-03-22','08:55:00',4.32),('10318','2014-03-22','09:00:00',4.02),('10318','2014-03-22','09:05:00',5.12),('10318','2014-03-22','09:10:00',5.18),('10318','2014-03-22','09:15:00',3.1),('10318','2014-03-22','09:20:00',3.36),('10318','2014-03-22','09:25:00',6.2),('10318','2014-03-22','09:30:00',4.56),('10318','2014-03-22','09:35:00',5.98),('10318','2014-03-22','09:40:00',7.46),('10318','2014-03-22','09:45:00',7.48),('10318','2014-03-22','09:50:00',7.73),('10318','2014-03-22','09:55:00',4.52),('10318','2014-03-22','10:00:00',5.5),('10318','2014-03-22','10:05:00',9.65),('10318','2014-03-22','10:10:00',5.4),('10318','2014-03-22','10:15:00',3.16),('10318','2014-03-22','10:20:00',3.14),('10318','2014-03-22','10:25:00',3.15),('10318','2014-03-22','10:30:00',3.68),('10318','2014-03-22','10:35:00',4.7),('10318','2014-03-22','10:40:00',4.64),('10318','2014-03-22','10:45:00',5.73),('10318','2014-03-22','10:50:00',3.82),('10318','2014-03-22','10:55:00',2.95),('10318','2014-03-22','11:00:00',2.78),('10318','2014-03-22','11:05:00',4.92),('10318','2014-03-22','11:10:00',3.79),('10318','2014-03-22','11:15:00',4.19),('10318','2014-03-22','11:20:00',6.48),('10318','2014-03-22','11:25:00',4.95),('10318','2014-03-22','11:30:00',7.2),('10318','2014-03-22','11:35:00',5.39),('10318','2014-03-22','11:40:00',5.08),('10318','2014-03-22','11:45:00',6.06),('10318','2014-03-22','11:50:00',8.31),('10318','2014-03-22','11:55:00',4.3),('10318','2014-03-22','12:00:00',5.37),('10318','2014-03-22','12:05:00',6.34),('10318','2014-03-22','12:10:00',4.32),('10318','2014-03-22','12:15:00',3.76),('10318','2014-03-22','12:20:00',3.8),('10318','2014-03-22','12:25:00',9.29),('10318','2014-03-22','12:30:00',9.31),('10318','2014-03-22','12:35:00',7.19),('10318','2014-03-22','12:40:00',3.85),('10318','2014-03-22','12:45:00',7.34),('10318','2014-03-22','12:50:00',9.28),('10318','2014-03-22','12:55:00',3.47),('10318','2014-03-22','13:00:00',5.59),('10318','2014-03-22','13:05:00',4.9),('10318','2014-03-22','13:10:00',4.71),('10318','2014-03-22','13:15:00',4.2),('10318','2014-03-22','13:20:00',3.04),('10318','2014-03-22','13:25:00',3.67),('10318','2014-03-22','13:30:00',6.39),('10318','2014-03-22','13:35:00',7.9),('10318','2014-03-22','13:40:00',6.62),('10318','2014-03-22','13:45:00',8.24),('10318','2014-03-22','13:50:00',7.69),('10318','2014-03-22','13:55:00',5.22),('10318','2014-03-22','14:00:00',7.46),('10318','2014-03-22','14:05:00',7.66),('10318','2014-03-22','14:10:00',7.41),('10318','2014-03-22','14:15:00',7.18),('10318','2014-03-22','14:20:00',7.15),('10318','2014-03-22','14:25:00',6.78),('10318','2014-03-22','14:30:00',6.68),('10318','2014-03-22','14:35:00',6.69),('10318','2014-03-22','14:40:00',6.2),('10318','2014-03-22','14:45:00',6.17),('10318','2014-03-22','14:50:00',6.05),('10318','2014-03-22','14:55:00',5.93),('10318','2014-03-22','15:00:00',5.8),('10318','2014-03-22','15:05:00',5.74),('10318','2014-03-22','15:10:00',5.4),('10318','2014-03-22','15:15:00',5.12),('10318','2014-03-22','15:20:00',4.77),('10318','2014-03-22','15:25:00',4.01),('10318','2014-03-22','15:30:00',5.54),('10318','2014-03-22','15:35:00',5.99),('10318','2014-03-22','15:40:00',5.45),('10318','2014-03-22','15:45:00',5),('10318','2014-03-22','15:50:00',4.9),('10318','2014-03-22','15:55:00',4.31),('10318','2014-03-22','16:00:00',4.04),('10318','2014-03-22','16:05:00',3.63),('10318','2014-03-22','16:10:00',2.69),('10318','2014-03-22','16:15:00',1.47),('10318','2014-03-22','16:20:00',2.5),('10318','2014-03-22','16:25:00',1.32),('10318','2014-03-22','16:35:00',1.76),('10318','2014-03-22','16:40:00',1.5),('10318','2014-03-22','16:45:00',1.55),('10318','2014-03-22','16:50:00',1.59),('10318','2014-03-22','16:55:00',1.64),('10318','2014-03-22','17:00:00',1.43),('10318','2014-03-22','17:05:00',1.15),('10318','2014-03-22','17:10:00',1.25),('10318','2013-02-10','08:55:00',1),('10318','2013-02-10','09:00:00',1.36),('10318','2013-02-10','09:05:00',1.51),('10318','2013-02-10','09:10:00',1.64),('10318','2013-02-10','09:15:00',1.8),('10318','2013-02-10','09:20:00',1.32),('10318','2013-02-10','09:25:00',1.06),('10318','2013-02-10','09:30:00',1.4),('10318','2013-02-10','09:35:00',2.21),('10318','2013-02-10','09:40:00',4.15),('10318','2013-02-10','09:45:00',6.04),('10318','2013-02-10','09:50:00',7.01),('10318','2013-02-10','09:55:00',7.47),('10318','2013-02-10','10:00:00',7.42),('10318','2013-02-10','10:05:00',7.41),('10318','2013-02-10','10:10:00',7.43),('10318','2013-02-10','10:15:00',7.51),('10318','2013-02-10','10:20:00',7.59),('10318','2013-02-10','10:25:00',7.7),('10318','2013-02-10','10:30:00',7.75),('10318','2013-02-10','10:35:00',7.8),('10318','2013-02-10','10:40:00',7.87),('10318','2013-02-10','10:45:00',7.99),('10318','2013-02-10','10:50:00',8.02),('10318','2013-02-10','10:55:00',8.06),('10318','2013-02-10','11:00:00',7.87),('10318','2013-02-10','11:05:00',8.14),('10318','2013-02-10','11:10:00',8.13),('10318','2013-02-10','11:15:00',8.16),('10318','2013-02-10','11:20:00',8.17),('10318','2013-02-10','11:25:00',8.2),('10318','2013-02-10','11:30:00',8.21),('10318','2013-02-10','11:35:00',8.26),('10318','2013-02-10','11:40:00',8.27),('10318','2013-02-10','11:45:00',8.3),('10318','2013-02-10','11:50:00',8.37),('10318','2013-02-10','11:55:00',8.36),('10318','2013-02-10','12:00:00',8.38),('10318','2013-02-10','12:05:00',8.33),('10318','2013-02-10','12:10:00',8.35),('10318','2013-02-10','12:15:00',8.15),('10318','2013-02-10','12:20:00',8.32),('10318','2013-02-10','12:25:00',8.29),('10318','2013-02-10','12:30:00',8.21),('10318','2013-02-10','12:35:00',8.18),('10318','2013-02-10','12:40:00',8.12),('10318','2013-02-10','12:45:00',7.93),('10318','2013-02-10','12:50:00',8.03),('10318','2013-02-10','12:55:00',7.92),('10318','2013-02-10','13:00:00',7.8),('10318','2013-02-10','13:05:00',7.73),('10318','2013-02-10','13:10:00',7.68),('10318','2013-02-10','13:15:00',7.69),('10318','2013-02-10','13:20:00',7.52),('10318','2013-02-10','13:25:00',7.39),('10318','2013-02-10','13:30:00',7.27),('10318','2013-02-10','13:35:00',7.19),('10318','2013-02-10','13:40:00',6.96),('10318','2013-02-10','13:45:00',6.64),('10318','2013-02-10','13:50:00',6.74),('10318','2013-02-10','13:55:00',6.67),('10318','2013-02-10','14:00:00',6.35),('10318','2013-02-10','14:05:00',6.31),('10318','2013-02-10','14:10:00',6.31),('10318','2013-02-10','14:15:00',6.12),('10318','2013-02-10','14:20:00',6.08),('10318','2013-02-10','14:25:00',5.94),('10318','2013-02-10','14:30:00',5.78),('10318','2013-02-10','14:35:00',5.63),('10318','2013-02-10','14:40:00',5.37),('10318','2013-02-10','14:45:00',4.77),('10318','2013-02-10','14:50:00',1.61),('10318','2013-02-10','14:55:00',4.43),('10318','2013-02-10','15:00:00',4.73),('10318','2013-02-10','15:05:00',4.54),('10318','2013-02-10','15:10:00',4.5),('10318','2013-02-10','15:15:00',4.51),('10318','2013-02-10','15:20:00',4.72),('10318','2013-02-10','15:25:00',2.38),('10318','2013-02-10','15:30:00',3.51),('10318','2013-02-10','15:35:00',3.42),('10318','2013-02-10','15:40:00',1.67),('10318','2013-02-10','15:45:00',1.22),('10318','2013-02-10','15:50:00',2.31),('10318','2013-02-10','15:55:00',2.14),('10318','2013-02-10','16:00:00',1.14),('10318','2013-02-10','16:05:00',1.01),('10318','2013-02-10','16:10:00',1.01),('10318','2013-02-10','16:15:00',1.42),('10318','2013-02-10','16:20:00',1.86),('10318','2013-02-10','16:25:00',2.43),('10318','2013-02-10','16:30:00',2.44),('10318','2013-02-10','16:35:00',2.02),('10318','2013-02-09','09:05:00',1.08),('10318','2013-02-09','09:10:00',1.24),('10318','2013-02-09','09:15:00',1.22),('10318','2013-02-09','09:20:00',1.22),('10318','2013-02-09','09:25:00',1.44),('10318','2013-02-09','09:30:00',1.68),('10318','2013-02-09','09:35:00',1.55),('10318','2013-02-09','09:40:00',1.35),('10318','2013-02-09','09:45:00',1.23),('10318','2013-02-09','09:50:00',1.15),('10318','2013-02-09','09:55:00',1.08),('10318','2013-02-09','10:00:00',1.08),('10318','2013-02-09','10:05:00',1.1),('10318','2013-02-09','10:10:00',1.12),('10318','2013-02-09','10:15:00',1.12),('10318','2013-02-09','10:20:00',1.16),('10318','2013-02-09','10:25:00',1.25),('10318','2013-02-09','10:30:00',1.38),('10318','2013-02-09','10:35:00',1.48),('10318','2013-02-09','10:40:00',1.64),('10318','2013-02-09','10:45:00',1.9),('10318','2013-02-09','10:50:00',2.16),('10318','2013-02-09','10:55:00',2.36),('10318','2013-02-09','11:00:00',2.51),('10318','2013-02-09','11:05:00',2.62),('10318','2013-02-09','11:10:00',2.72),('10318','2013-02-09','11:15:00',2.75),('10318','2013-02-09','11:20:00',2.89),('10318','2013-02-09','11:25:00',2.9),('10318','2013-02-09','11:30:00',2.9),('10318','2013-02-09','11:35:00',2.8),('10318','2013-02-09','11:40:00',2.74),('10318','2013-02-09','11:45:00',2.74),('10318','2013-02-09','11:50:00',2.67),('10318','2013-02-09','11:55:00',2.61),('10318','2013-02-09','12:00:00',2.64),('10318','2013-02-09','12:05:00',2.66),('10318','2013-02-09','12:10:00',2.56),('10318','2013-02-09','12:15:00',2.5),('10318','2013-02-09','12:20:00',2.54),('10318','2013-02-09','12:25:00',2.59),('10318','2013-02-09','12:30:00',2.67),('10318','2013-02-09','12:35:00',2.8),('10318','2013-02-09','12:40:00',2.85),('10318','2013-02-09','12:45:00',2.85),('10318','2013-02-09','12:50:00',2.82),('10318','2013-02-09','12:55:00',2.91),('10318','2013-02-09','13:00:00',3.23),('10318','2013-02-09','13:05:00',3.81),('10318','2013-02-09','13:10:00',4.45),('10318','2013-02-09','13:15:00',4.89),('10318','2013-02-09','13:20:00',5.46),('10318','2013-02-09','13:25:00',6.18),('10318','2013-02-09','13:30:00',6.45),('10318','2013-02-09','13:35:00',7),('10318','2013-02-09','13:40:00',6.96),('10318','2013-02-09','13:45:00',7.45),('10318','2013-02-09','13:50:00',7.72),('10318','2013-02-09','13:55:00',7.66),('10318','2013-02-09','14:00:00',6.93),('10318','2013-02-09','14:05:00',6.73),('10318','2013-02-09','14:10:00',4.95),('10318','2013-02-09','14:15:00',6.72),('10318','2013-02-09','14:20:00',7.74),('10318','2013-02-09','14:25:00',7.09),('10318','2013-02-09','14:30:00',6.43),('10318','2013-02-09','14:35:00',5.77),('10318','2013-02-09','14:40:00',5.18),('10318','2013-02-09','14:45:00',4.76),('10318','2013-02-09','14:50:00',5.21),('10318','2013-02-09','14:55:00',4.94),('10318','2013-02-09','15:00:00',4.73),('10318','2013-02-09','15:05:00',4.53),('10318','2013-02-09','15:10:00',4.29),('10318','2013-02-09','15:15:00',4.07),('10318','2013-02-09','15:20:00',4.03),('10318','2013-02-09','15:25:00',3.55),('10318','2013-02-09','15:30:00',3.63),('10318','2013-02-09','15:35:00',3.47),('10318','2013-02-09','15:40:00',2.93),('10318','2013-02-09','15:45:00',2.45),('10318','2013-02-09','15:50:00',1.35),('10318','2013-02-09','16:00:00',1.7),('10318','2013-02-09','16:05:00',1.36),('10318','2013-02-09','16:10:00',1.95),('10318','2013-02-09','16:15:00',2.7),('10318','2013-02-09','16:20:00',2.43),('10318','2013-02-09','16:25:00',2.13),('10318','2013-02-09','16:30:00',1.82),('10318','2013-02-09','16:35:00',1.83),('10318','2013-02-09','16:40:00',1.12),('10318','2013-02-09','16:50:00',1.42),('10318','2013-02-09','16:55:00',1.2),('10318','2013-02-08','08:40:00',1.01),('10318','2013-02-08','08:45:00',1.16),('10318','2013-02-08','08:50:00',1.34),('10318','2013-02-08','08:55:00',1.48),('10318','2013-02-08','09:00:00',1.38),('10318','2013-02-08','09:05:00',1.46),('10318','2013-02-08','09:10:00',1.55),('10318','2013-02-08','09:15:00',1.7),('10318','2013-02-08','09:20:00',2.44),('10318','2013-02-08','09:25:00',2.59),('10318','2013-02-08','09:30:00',3.77),('10318','2013-02-08','09:35:00',5.95),('10318','2013-02-08','09:40:00',6.58),('10318','2013-02-08','09:45:00',7.6),('10318','2013-02-08','09:50:00',8.07),('10318','2013-02-08','09:55:00',7.99),('10318','2013-02-08','10:00:00',8.29),('10318','2013-02-08','10:05:00',8.72),('10318','2013-02-08','10:10:00',3.95),('10318','2013-02-08','10:15:00',3.93),('10318','2013-02-08','10:20:00',6.45),('10318','2013-02-08','10:25:00',8.77),('10318','2013-02-08','10:30:00',5.34),('10318','2013-02-08','10:35:00',5.35),('10318','2013-02-08','10:40:00',8.56),('10318','2013-02-08','10:45:00',8.96),('10318','2013-02-08','10:50:00',9.2),('10318','2013-02-08','10:55:00',8.61),('10318','2013-02-08','11:00:00',7.58),('10318','2013-02-08','11:05:00',8.35),('10318','2013-02-08','11:10:00',8.32),('10318','2013-02-08','11:15:00',8.31),('10318','2013-02-08','11:20:00',8.34),('10318','2013-02-08','11:25:00',8.36),('10318','2013-02-08','11:30:00',8.33),('10318','2013-02-08','11:35:00',8.32),('10318','2013-02-08','11:40:00',8.34),('10318','2013-02-08','11:45:00',8.33),('10318','2013-02-08','11:50:00',8.31),('10318','2013-02-08','11:55:00',8.32),('10318','2013-02-08','12:00:00',8.12),('10318','2013-02-08','12:05:00',8.31),('10318','2013-02-08','12:10:00',8.28),('10318','2013-02-08','12:15:00',8.27),('10318','2013-02-08','12:20:00',8.31),('10318','2013-02-08','12:25:00',8.45),('10318','2013-02-08','12:30:00',8.29),('10318','2013-02-08','12:35:00',8.19),('10318','2013-02-08','12:40:00',6.88),('10318','2013-02-08','12:45:00',4.56),('10318','2013-02-08','12:50:00',6.03),('10318','2013-02-08','12:55:00',7),('10318','2013-02-08','13:00:00',5.32),('10318','2013-02-08','13:05:00',3.66),('10318','2013-02-08','13:10:00',4.03),('10318','2013-02-08','13:15:00',4.08),('10318','2013-02-08','13:20:00',4.27),('10318','2013-02-08','13:25:00',3.86),('10318','2013-02-08','13:30:00',3.64),('10318','2013-02-08','13:35:00',3.91),('10318','2013-02-08','13:40:00',3.84),('10318','2013-02-08','13:45:00',3.03),('10318','2013-02-08','13:50:00',2.96),('10318','2013-02-08','13:55:00',3.12),('10318','2013-02-08','14:00:00',3.07),('10318','2013-02-08','14:05:00',3.07),('10318','2013-02-08','14:10:00',3.02),('10318','2013-02-08','14:15:00',3.32),('10318','2013-02-08','14:20:00',3.81),('10318','2013-02-08','14:25:00',3.96),('10318','2013-02-08','14:30:00',4.47),('10318','2013-02-08','14:35:00',6.51),('10318','2013-02-08','14:40:00',6.86),('10318','2013-02-08','14:45:00',4.26),('10318','2013-02-08','14:50:00',5),('10318','2013-02-08','14:55:00',6.51),('10318','2013-02-08','15:00:00',6.46),('10318','2013-02-08','15:05:00',6.05),('10318','2013-02-08','15:10:00',5.63),('10318','2013-02-08','15:15:00',5.08),('10318','2013-02-08','15:20:00',4.58),('10318','2013-02-08','15:25:00',4.17),('10318','2013-02-08','15:30:00',3.89),('10318','2013-02-08','15:35:00',3.73),('10318','2013-02-08','15:40:00',3.55),('10318','2013-02-08','15:45:00',3.36),('10318','2013-02-08','15:50:00',3.19),('10318','2013-02-08','15:55:00',3.03),('10318','2013-02-08','16:00:00',2.87),('10318','2013-02-08','16:05:00',2.66),('10318','2013-02-08','16:10:00',2.38),('10318','2013-02-08','16:15:00',1.45),('10318','2013-02-07','09:15:00',1.54),('10318','2013-02-07','09:20:00',1.91),('10318','2013-02-07','09:25:00',1.27),('10318','2013-02-07','09:30:00',1.3),('10318','2013-02-07','09:35:00',1.35),('10318','2013-02-07','09:40:00',1.39),('10318','2013-02-07','09:45:00',1.54),('10318','2013-02-07','09:50:00',1.37),('10318','2013-02-07','09:55:00',1.04),('10318','2013-02-07','10:00:00',1.02),('10318','2013-02-07','10:20:00',1.21),('10318','2013-02-07','10:25:00',1.69),('10318','2013-02-07','10:30:00',2.13),('10318','2013-02-07','10:35:00',4.18),('10318','2013-02-07','10:40:00',5.04),('10318','2013-02-07','10:45:00',6.16),('10318','2013-02-07','10:50:00',3.34),('10318','2013-02-07','10:55:00',2.77),('10318','2013-02-07','11:00:00',2.78),('10318','2013-02-07','11:05:00',2.34),('10318','2013-02-07','11:10:00',2.86),('10318','2013-02-07','11:15:00',1.53),('10318','2013-02-07','12:15:00',1.05),('10318','2013-02-07','12:20:00',2.07),('10318','2013-02-07','12:25:00',3.75),('10318','2013-02-07','12:30:00',3.15),('10318','2013-02-07','12:35:00',1.86),('10318','2013-02-07','12:40:00',1.82),('10318','2013-02-07','12:45:00',2.1),('10318','2013-02-07','12:50:00',1.91),('10318','2013-02-07','12:55:00',1.43),('10318','2013-02-07','13:00:00',1.33),('10318','2013-02-07','13:05:00',1.6),('10318','2013-02-07','13:10:00',2.25),('10318','2013-02-07','13:15:00',8.13),('10318','2013-02-07','13:20:00',6.44),('10318','2013-02-07','13:25:00',3.09),('10318','2013-02-07','13:30:00',2.1),('10318','2013-02-07','13:35:00',1.89),('10318','2013-02-07','13:40:00',1.98),('10318','2013-02-07','13:45:00',2.05),('10318','2013-02-07','13:50:00',2.17),('10318','2013-02-07','13:55:00',2.48),('10318','2013-02-07','14:00:00',3.74),('10318','2013-02-07','14:05:00',5.32),('10318','2013-02-07','14:10:00',7.65),('10318','2013-02-07','14:15:00',5.3),('10318','2013-02-07','14:20:00',3.24),('10318','2013-02-07','14:25:00',3.82),('10318','2013-02-07','14:30:00',1.94),('10318','2013-02-07','14:35:00',1.82),('10318','2013-02-07','14:40:00',2.14),('10318','2013-02-07','14:45:00',1.73),('10318','2013-02-07','14:50:00',1.36),('10318','2013-02-07','14:55:00',1.97),('10318','2013-02-07','15:00:00',3.59),('10318','2013-02-07','15:05:00',3.14),('10318','2013-02-07','15:10:00',2.7),('10318','2013-02-07','15:15:00',2.22),('10318','2013-02-07','15:20:00',1.8),('10318','2013-02-07','15:25:00',1.45),('10318','2013-02-07','15:30:00',1.37),('10318','2013-02-07','15:35:00',1.62),('10318','2013-02-07','15:40:00',2.32),('10318','2013-02-07','15:45:00',2.24),('10318','2013-02-07','15:50:00',3.02),('10318','2013-02-07','15:55:00',1.8),('10318','2013-02-06','07:50:00',1.03),('10318','2013-02-06','07:55:00',1.14),('10318','2013-02-06','08:10:00',1.11),('10318','2013-02-06','08:15:00',1.1),('10318','2013-02-06','08:20:00',1.18),('10318','2013-02-06','08:25:00',1.23),('10318','2013-02-06','08:30:00',1.46),('10318','2013-02-06','08:35:00',1.87),('10318','2013-02-06','08:40:00',2.5),('10318','2013-02-06','08:45:00',2.75),('10318','2013-02-06','08:50:00',3.66),('10318','2013-02-06','08:55:00',2.25),('10318','2013-02-06','09:00:00',3.79),('10318','2013-02-06','09:05:00',3.17),('10318','2013-02-06','09:10:00',3.45),('10318','2013-02-06','09:15:00',2.39),('10318','2013-02-06','09:20:00',2.51),('10318','2013-02-06','09:25:00',3.16),('10318','2013-02-06','09:30:00',4.22),('10318','2013-02-06','09:35:00',3.17),('10318','2013-02-06','09:40:00',3.17),('10318','2013-02-06','09:45:00',3.34),('10318','2013-02-06','09:50:00',3.15),('10318','2013-02-06','09:55:00',3.91),('10318','2013-02-06','10:00:00',3.01),('10318','2013-02-06','10:05:00',4.35),('10318','2013-02-06','10:10:00',3),('10318','2013-02-06','10:15:00',3.42),('10318','2013-02-06','10:20:00',4.13),('10318','2013-02-06','10:25:00',3.63),('10318','2013-02-06','10:30:00',3.55),('10318','2013-02-06','10:35:00',4.18),('10318','2013-02-06','10:40:00',2.52),('10318','2013-02-06','10:45:00',2.47),('10318','2013-02-06','10:50:00',3.59),('10318','2013-02-06','10:55:00',4.48),('10318','2013-02-06','11:00:00',3.52),('10318','2013-02-06','11:05:00',3.46),('10318','2013-02-06','11:10:00',3.56),('10318','2013-02-06','11:15:00',3.53),('10318','2013-02-06','11:20:00',6.26),('10318','2013-02-06','11:25:00',5.22),('10318','2013-02-06','11:30:00',3.07),('10318','2013-02-06','11:35:00',3.26),('10318','2013-02-06','11:40:00',3.75),('10318','2013-02-06','11:45:00',3.88),('10318','2013-02-06','11:50:00',3.82),('10318','2013-02-06','11:55:00',3.33),('10318','2013-02-06','12:00:00',2.56),('10318','2013-02-06','12:05:00',1.59),('10318','2013-02-06','12:10:00',2.63),('10318','2013-02-06','12:15:00',2.79),('10318','2013-02-06','12:20:00',2.45),('10318','2013-02-06','12:25:00',2.18),('10318','2013-02-06','12:30:00',1.86),('10318','2013-02-06','12:35:00',1.71),('10318','2013-02-06','12:40:00',1.62),('10318','2013-02-06','12:45:00',1.64),('10318','2013-02-06','12:50:00',1.53),('10318','2013-02-06','12:55:00',1.52),('10318','2013-02-06','13:00:00',1.35),('10318','2013-02-06','13:05:00',1.53),('10318','2013-02-06','13:10:00',1.64),('10318','2013-02-06','13:15:00',2.04),('10318','2013-02-06','13:20:00',2.34),('10318','2013-02-06','13:25:00',2.85),('10318','2013-02-06','13:30:00',3.26),('10318','2013-02-06','13:35:00',4.16),('10318','2013-02-06','13:40:00',2.71),('10318','2013-02-06','13:45:00',3.22),('10318','2013-02-06','13:50:00',4.14),('10318','2013-02-06','13:55:00',2.9),('10318','2013-02-06','14:00:00',2.84),('10318','2013-02-06','14:05:00',3.74),('10318','2013-02-06','14:10:00',1.35),('10318','2013-02-06','14:25:00',1.53),('10318','2013-02-06','14:30:00',4.5),('10318','2013-02-06','14:35:00',4.26),('10318','2013-02-06','14:40:00',2.55),('10318','2013-02-06','14:45:00',1.08),('10318','2013-02-06','15:15:00',1.15),('10318','2013-02-06','15:20:00',1.31),('10318','2013-02-06','15:25:00',1.95),('10318','2013-02-06','15:45:00',1.65),('10318','2013-02-06','15:50:00',1.59),('10318','2013-02-06','15:55:00',1.01),('10318','2013-02-06','16:00:00',1.04),('10318','2013-02-06','16:05:00',1.01),('10318','2013-02-05','07:50:00',1.06),('10318','2013-02-05','07:55:00',1.33),('10318','2013-02-05','08:00:00',1.53),('10318','2013-02-05','08:05:00',2.02),('10318','2013-02-05','08:10:00',2.4),('10318','2013-02-05','08:15:00',2.68),('10318','2013-02-05','08:20:00',3.06),('10318','2013-02-05','08:25:00',3.48),('10318','2013-02-05','08:30:00',3.72),('10318','2013-02-05','08:35:00',3.91),('10318','2013-02-05','08:40:00',4.12),('10318','2013-02-05','08:45:00',4.31),('10318','2013-02-05','08:50:00',4.47),('10318','2013-02-05','08:55:00',4.68),('10318','2013-02-05','09:00:00',4.83),('10318','2013-02-05','09:05:00',5.06),('10318','2013-02-05','09:10:00',5.26),('10318','2013-02-05','09:15:00',5.45),('10318','2013-02-05','09:20:00',5.52),('10318','2013-02-05','09:25:00',5.74),('10318','2013-02-05','09:30:00',5.86),('10318','2013-02-05','09:35:00',6),('10318','2013-02-05','09:40:00',6.11),('10318','2013-02-05','09:45:00',6.22),('10318','2013-02-05','09:50:00',6.35),('10318','2013-02-05','09:55:00',6.48),('10318','2013-02-05','10:00:00',6.51),('10318','2013-02-05','10:05:00',6.25),('10318','2013-02-05','10:10:00',6.33),('10318','2013-02-05','10:15:00',6.42),('10318','2013-02-05','10:20:00',6.96),('10318','2013-02-05','10:25:00',6.98),('10318','2013-02-05','10:30:00',7.06),('10318','2013-02-05','10:35:00',7.07),('10318','2013-02-05','10:40:00',7.19),('10318','2013-02-05','10:45:00',7.28),('10318','2013-02-05','10:50:00',7.29),('10318','2013-02-05','10:55:00',7.33),('10318','2013-02-05','11:00:00',7.33),('10318','2013-02-05','11:05:00',7.09),('10318','2013-02-05','11:10:00',7.43),('10318','2013-02-05','11:15:00',7.41),('10318','2013-02-05','11:20:00',7.42),('10318','2013-02-05','11:25:00',7.43),('10318','2013-02-05','11:30:00',7.24),('10318','2013-02-05','11:35:00',5.34),('10318','2013-02-05','11:40:00',4.11),('10318','2013-02-05','11:45:00',4.14),('10318','2013-02-05','11:50:00',3.7),('10318','2013-02-05','11:55:00',4.77),('10318','2013-02-05','12:00:00',3.59),('10318','2013-02-05','12:05:00',2.81),('10318','2013-02-05','12:10:00',3.2),('10318','2013-02-05','12:15:00',3.03),('10318','2013-02-05','12:20:00',2.77),('10318','2013-02-05','12:25:00',2.75),('10318','2013-02-05','12:30:00',4.7),('10318','2013-02-05','12:35:00',4.46),('10318','2013-02-05','12:40:00',3.61),('10318','2013-02-05','12:45:00',4.37),('10318','2013-02-05','12:50:00',3.14),('10318','2013-02-05','12:55:00',1.89),('10318','2013-02-05','13:00:00',1.38),('10318','2013-02-05','13:05:00',2.2),('10318','2013-02-05','13:10:00',2.99),('10318','2013-02-05','13:15:00',4.27),('10318','2013-02-05','13:20:00',3.67),('10318','2013-02-05','13:25:00',3.48),('10318','2013-02-05','13:30:00',2.62),('10318','2013-02-05','13:35:00',2.38),('10318','2013-02-05','13:40:00',2.79),('10318','2013-02-05','13:45:00',3.37),('10318','2013-02-05','13:50:00',3.33),('10318','2013-02-05','13:55:00',2.97),('10318','2013-02-05','14:00:00',3.02),('10318','2013-02-05','14:05:00',2.78),('10318','2013-02-05','14:10:00',2.47),('10318','2013-02-05','14:15:00',2.88),('10318','2013-02-05','14:20:00',3.59),('10318','2013-02-05','14:25:00',4.15),('10318','2013-02-05','14:30:00',4.26),('10318','2013-02-05','14:35:00',3.85),('10318','2013-02-05','14:40:00',2.72),('10318','2013-02-05','14:45:00',2.3),('10318','2013-02-05','14:50:00',2.1),('10318','2013-02-05','14:55:00',1.9),('10318','2013-02-05','15:00:00',2.09),('10318','2013-02-05','15:05:00',2.25),('10318','2013-02-05','15:10:00',1.76),('10318','2013-02-05','15:15:00',1.81),('10318','2013-02-04','07:50:00',1.13),('10318','2013-02-04','07:55:00',1.32),('10318','2013-02-04','08:00:00',1.53),('10318','2013-02-04','08:05:00',1.86),('10318','2013-02-04','08:10:00',2.48),('10318','2013-02-04','08:15:00',2.8),('10318','2013-02-04','08:20:00',3.17),('10318','2013-02-04','08:25:00',3.62),('10318','2013-02-04','08:30:00',3.87),('10318','2013-02-04','08:35:00',4.14),('10318','2013-02-04','08:40:00',4.32),('10318','2013-02-04','08:45:00',4.52),('10318','2013-02-04','08:50:00',4.73),('10318','2013-02-04','08:55:00',4.59),('10318','2013-02-04','09:00:00',5.2),('10318','2013-02-04','09:05:00',5.37),('10318','2013-02-04','09:10:00',5.71),('10318','2013-02-04','09:15:00',5.77),('10318','2013-02-04','09:20:00',5.07),('10318','2013-02-04','09:25:00',5.71),('10318','2013-02-04','09:30:00',5.98),('10318','2013-02-04','09:35:00',6.14),('10318','2013-02-04','09:40:00',6.34),('10318','2013-02-04','09:45:00',6.31),('10318','2013-02-04','09:50:00',6.9),('10318','2013-02-04','09:55:00',7.05),('10318','2013-02-04','10:00:00',7.14),('10318','2013-02-04','10:05:00',7.26),('10318','2013-02-04','10:10:00',7.35),('10318','2013-02-04','10:15:00',7.39),('10318','2013-02-04','10:20:00',6.78),('10318','2013-02-04','10:25:00',7.49),('10318','2013-02-04','10:30:00',6.64),('10318','2013-02-04','10:35:00',6.89),('10318','2013-02-04','10:40:00',7.22),('10318','2013-02-04','10:45:00',7.7),('10318','2013-02-04','10:50:00',7.65),('10318','2013-02-04','10:55:00',7.89),('10318','2013-02-04','11:00:00',7.76),('10318','2013-02-04','11:05:00',7.99),('10318','2013-02-04','11:10:00',7.99),('10318','2013-02-04','11:15:00',7.98),('10318','2013-02-04','11:20:00',8.02),('10318','2013-02-04','11:25:00',7.95),('10318','2013-02-04','11:30:00',8),('10318','2013-02-04','11:35:00',8.02),('10318','2013-02-04','11:40:00',8.06),('10318','2013-02-04','11:45:00',8.02),('10318','2013-02-04','11:50:00',8),('10318','2013-02-04','11:55:00',7.98),('10318','2013-02-04','12:00:00',7.98),('10318','2013-02-04','12:05:00',7.98),('10318','2013-02-04','12:10:00',7.95),('10318','2013-02-04','12:15:00',8.02),('10318','2013-02-04','12:20:00',7.95),('10318','2013-02-04','12:25:00',7.91),('10318','2013-02-04','12:30:00',7.85),('10318','2013-02-04','12:35:00',7.8),('10318','2013-02-04','12:40:00',7.6),('10318','2013-02-04','12:45:00',7.64),('10318','2013-02-04','12:50:00',7.57),('10318','2013-02-04','12:55:00',7.53),('10318','2013-02-04','13:00:00',7.47),('10318','2013-02-04','13:05:00',7.46),('10318','2013-02-04','13:10:00',7.37),('10318','2013-02-04','13:15:00',7.28),('10318','2013-02-04','13:20:00',7.17),('10318','2013-02-04','13:25:00',7.1),('10318','2013-02-04','13:30:00',6.99),('10318','2013-02-04','13:35:00',6.93),('10318','2013-02-04','13:40:00',6.79),('10318','2013-02-04','13:45:00',6.68),('10318','2013-02-04','13:50:00',6.51),('10318','2013-02-04','13:55:00',6.45),('10318','2013-02-04','14:00:00',6.35),('10318','2013-02-04','14:05:00',6.24),('10318','2013-02-04','14:10:00',6.12),('10318','2013-02-04','14:15:00',5.97),('10318','2013-02-04','14:20:00',5.8),('10318','2013-02-04','14:25:00',5.56),('10318','2013-02-04','14:30:00',5.51),('10318','2013-02-04','14:35:00',5.36),('10318','2013-02-04','14:40:00',5.2),('10318','2013-02-04','14:45:00',5.01),('10318','2013-02-04','14:50:00',4.88),('10318','2013-02-04','14:55:00',4.72),('10318','2013-02-04','15:00:00',4.55),('10318','2013-02-04','15:05:00',4.37),('10318','2013-02-04','15:10:00',4.21),('10318','2013-02-04','15:15:00',4.08),('10318','2013-02-04','15:20:00',3.91),('10318','2013-02-04','15:25:00',3.74),('10318','2013-02-04','15:30:00',3.57),('10318','2013-02-04','15:35:00',3.42),('10318','2013-02-04','15:40:00',3.2),('10318','2013-02-04','15:45:00',3.12),('10318','2013-02-04','15:50:00',2.97),('10318','2013-02-04','15:55:00',2.82),('10318','2013-02-04','16:00:00',2.64),('10318','2013-02-04','16:05:00',2.47),('10318','2013-02-04','16:10:00',2.27),('10318','2013-02-04','16:15:00',2.09),('10318','2013-02-04','16:20:00',1.88),('10318','2013-02-04','16:25:00',1.71),('10318','2013-02-04','16:30:00',1.54),('10318','2013-02-04','16:35:00',1.42),('10318','2013-02-04','16:40:00',1.21),('10318','2013-02-04','16:45:00',1.04),('10318','2013-02-03','08:40:00',1.43),('10318','2013-02-03','08:45:00',2.16),('10318','2013-02-03','08:50:00',1.44),('10318','2013-02-03','08:55:00',1.06),('10318','2013-02-03','09:05:00',1.04),('10318','2013-02-03','09:10:00',1.28),('10318','2013-02-03','09:15:00',2.36),('10318','2013-02-03','09:20:00',2.89),('10318','2013-02-03','09:25:00',5.36),('10318','2013-02-03','09:30:00',2.01),('10318','2013-02-03','09:35:00',1.74),('10318','2013-02-03','09:40:00',2.33),('10318','2013-02-03','09:45:00',4.28),('10318','2013-02-03','09:50:00',3.41),('10318','2013-02-03','09:55:00',2.42),('10318','2013-02-03','10:00:00',2.69),('10318','2013-02-03','10:20:00',1.01),('10318','2013-02-03','11:15:00',1.81),('10318','2013-02-03','11:20:00',3.55),('10318','2013-02-03','11:25:00',2.38),('10318','2013-02-03','11:30:00',2.16),('10318','2013-02-03','11:35:00',1.31),('10318','2013-02-03','11:40:00',2.02),('10318','2013-02-03','11:45:00',3.68),('10318','2013-02-03','11:50:00',5.43),('10318','2013-02-03','11:55:00',3.41),('10318','2013-02-03','12:00:00',3.47),('10318','2013-02-03','12:05:00',3.42),('10318','2013-02-03','12:10:00',3.39),('10318','2013-02-03','12:15:00',1.3),('10318','2013-02-03','14:00:00',1.11),('10318','2013-02-03','14:50:00',1.17),('10318','2013-02-03','14:55:00',1.3),('10318','2013-02-03','15:00:00',1.05),('10318','2013-02-02','08:15:00',1.27),('10318','2013-02-02','09:50:00',1.3),('10318','2013-02-02','09:55:00',1.08),('10318','2013-02-02','10:00:00',1.1),('10318','2013-02-02','10:05:00',1.52),('10318','2013-02-02','10:10:00',1.87),('10318','2013-02-02','10:15:00',2.81),('10318','2013-02-02','10:20:00',3.25),('10318','2013-02-02','10:25:00',2.88),('10318','2013-02-02','10:30:00',2.87),('10318','2013-02-02','10:35:00',3.41),('10318','2013-02-02','10:40:00',3.75),('10318','2013-02-02','10:45:00',4.54),('10318','2013-02-02','10:50:00',4.23),('10318','2013-02-02','10:55:00',5.12),('10318','2013-02-02','11:00:00',5.12),('10318','2013-02-02','11:05:00',4.42),('10318','2013-02-02','11:10:00',5.11),('10318','2013-02-02','11:15:00',4.27),('10318','2013-02-02','11:20:00',4.36),('10318','2013-02-02','11:25:00',5.13),('10318','2013-02-02','11:30:00',4.76),('10318','2013-02-02','11:35:00',4.4),('10318','2013-02-02','11:40:00',4.07),('10318','2013-02-02','11:45:00',3.01),('10318','2013-02-02','11:50:00',2.78),('10318','2013-02-02','11:55:00',1.96),('10318','2013-02-02','12:00:00',1.38),('10318','2013-02-02','12:05:00',1.46),('10318','2013-02-02','12:10:00',1.24),('10318','2013-02-02','12:15:00',1.03),('10318','2013-02-02','12:20:00',1),('10318','2013-02-02','12:25:00',1.01),('10318','2013-02-02','12:35:00',1.27),('10318','2013-02-02','12:40:00',1.33),('10318','2013-02-02','12:45:00',1.35),('10318','2013-02-02','12:50:00',4.47),('10318','2013-02-02','12:55:00',5.56),('10318','2013-02-02','13:00:00',5.64),('10318','2013-02-02','13:05:00',5.46),('10318','2013-02-02','13:10:00',5.82),('10318','2013-02-02','13:15:00',4.5),('10318','2013-02-02','13:20:00',5.19),('10318','2013-02-02','13:25:00',4.3),('10318','2013-02-02','13:30:00',4.06),('10318','2013-02-02','13:35:00',4.7),('10318','2013-02-02','13:40:00',4.65),('10318','2013-02-02','13:45:00',3.37),('10318','2013-02-02','13:50:00',2.6),('10318','2013-02-02','13:55:00',1.75),('10318','2013-02-02','14:00:00',1.54),('10318','2013-02-02','14:05:00',1.24),('10318','2013-02-01','08:10:00',1.72),('10318','2013-02-01','08:15:00',2.19),('10318','2013-02-01','08:20:00',2.26),('10318','2013-02-01','08:25:00',2.44),('10318','2013-02-01','08:30:00',2.94),('10318','2013-02-01','08:35:00',3.15),('10318','2013-02-01','08:40:00',3.23),('10318','2013-02-01','08:45:00',3.49),('10318','2013-02-01','08:50:00',3.2),('10318','2013-02-01','08:55:00',3.64),('10318','2013-02-01','09:00:00',4.28),('10318','2013-02-01','09:05:00',3.05),('10318','2013-02-01','09:10:00',2.06),('10318','2013-02-01','09:15:00',3.36),('10318','2013-02-01','09:20:00',4.8),('10318','2013-02-01','09:25:00',4.42),('10318','2013-02-01','09:30:00',2.45),('10318','2013-02-01','09:35:00',2.59),('10318','2013-02-01','09:40:00',4.56),('10318','2013-02-01','09:45:00',2.23),('10318','2013-02-01','09:50:00',3.85),('10318','2013-02-01','09:55:00',2.44),('10318','2013-02-01','10:00:00',4.21),('10318','2013-02-01','10:05:00',4.24),('10318','2013-02-01','10:10:00',4.73),('10318','2013-02-01','10:15:00',4.82),('10318','2013-02-01','10:20:00',1.46),('10318','2013-02-01','10:25:00',2.03),('10318','2013-02-01','10:30:00',2.44),('10318','2013-02-01','10:35:00',1.41),('10318','2013-02-01','10:40:00',1.52),('10318','2013-02-01','10:45:00',2.07),('10318','2013-02-01','10:50:00',3.06),('10318','2013-02-01','10:55:00',5.07),('10318','2013-02-01','11:00:00',8.3),('10318','2013-02-01','11:05:00',3.86),('10318','2013-02-01','11:10:00',4.85),('10318','2013-02-01','11:15:00',1.27),('10318','2013-02-01','11:20:00',1.11),('10318','2013-02-01','11:25:00',1.87),('10318','2013-02-01','11:30:00',2.67),('10318','2013-02-01','11:35:00',2.61),('10318','2013-02-01','11:40:00',3.66),('10318','2013-02-01','11:45:00',3.58),('10318','2013-02-01','11:50:00',4.11),('10318','2013-02-01','11:55:00',2.7),('10318','2013-02-01','12:00:00',3.17),('10318','2013-02-01','12:05:00',6.93),('10318','2013-02-01','12:10:00',9.16),('10318','2013-02-01','12:15:00',8.63),('10318','2013-02-01','12:20:00',8.11),('10318','2013-02-01','12:25:00',8.05),('10318','2013-02-01','12:30:00',6.06),('10318','2013-02-01','12:35:00',2.92),('10318','2013-02-01','12:40:00',5.91),('10318','2013-02-01','12:45:00',8.11),('10318','2013-02-01','12:50:00',6.88),('10318','2013-02-01','12:55:00',1.88),('10318','2013-02-01','13:00:00',7.81),('10318','2013-02-01','13:05:00',7.5),('10318','2013-02-01','13:10:00',7.08),('10318','2013-02-01','13:15:00',6.96),('10318','2013-02-01','13:20:00',4.87),('10318','2013-02-01','13:25:00',3.95),('10318','2013-02-01','13:30:00',3.27),('10318','2013-02-01','13:35:00',2.58),('10318','2013-02-01','13:40:00',2.8),('10318','2013-02-01','13:45:00',2.83),('10318','2013-02-01','13:50:00',3.6),('10318','2013-02-01','13:55:00',6.78),('10318','2013-02-01','14:00:00',7.11),('10318','2013-02-01','14:05:00',4.73),('10318','2013-02-01','14:10:00',5.88),('10318','2013-02-01','14:15:00',6.04),('10318','2013-02-01','14:20:00',5.33),('10318','2013-02-01','14:25:00',5.33),('10318','2013-02-01','14:30:00',5.32),('10318','2013-02-01','14:35:00',3.28),('10318','2013-02-01','14:40:00',3.59),('10318','2013-02-01','14:45:00',4.27),('10318','2013-02-01','14:50:00',5.12),('10318','2013-02-01','14:55:00',3.45),('10318','2013-02-01','15:00:00',2.63),('10318','2013-02-01','15:05:00',2.6),('10318','2013-02-01','15:10:00',2.09),('10318','2013-02-01','15:15:00',3.29),('10318','2013-02-01','15:20:00',2.91),('10318','2013-02-01','15:25:00',2.55),('10318','2013-02-01','15:30:00',1.59),('10318','2013-02-01','15:35:00',2.66),('10318','2013-02-01','15:40:00',2.13),('10318','2013-02-01','15:45:00',1.13),('10318','2013-02-01','15:50:00',2.44),('10318','2013-02-01','15:55:00',1.17),('10318','2014-03-21','07:00:00',1.02),('10318','2014-03-21','07:05:00',1.09),('10318','2014-03-21','07:10:00',1.14),('10318','2014-03-21','07:15:00',1.31),('10318','2014-03-21','07:20:00',1.9),('10318','2014-03-21','07:25:00',2.27),('10318','2014-03-21','07:30:00',2.19),('10318','2014-03-21','07:35:00',2.85),('10318','2014-03-21','07:40:00',3.18),('10318','2014-03-21','07:45:00',3.47),('10318','2014-03-21','07:50:00',3.84),('10318','2014-03-21','07:55:00',4.12),('10318','2014-03-21','08:00:00',4.21),('10318','2014-03-21','08:05:00',4.45),('10318','2014-03-21','08:10:00',4.64),('10318','2014-03-21','08:15:00',4.8),('10318','2014-03-21','08:20:00',4.89),('10318','2014-03-21','08:25:00',5.15),('10318','2014-03-21','08:30:00',5.44),('10318','2014-03-21','08:35:00',5.7),('10318','2014-03-21','08:40:00',5.86),('10318','2014-03-21','08:45:00',5.97),('10318','2014-03-21','08:50:00',6.13),('10318','2014-03-21','08:55:00',6.31),('10318','2014-03-21','09:00:00',6.46),('10318','2014-03-21','09:05:00',6.61),('10318','2014-03-21','09:10:00',6.82),('10318','2014-03-21','09:15:00',6.96),('10318','2014-03-21','09:20:00',7.15),('10318','2014-03-21','09:25:00',6.95),('10318','2014-03-21','09:30:00',7.19),('10318','2014-03-21','09:35:00',7.27),('10318','2014-03-21','09:40:00',7.56),('10318','2014-03-21','09:45:00',7.46),('10318','2014-03-21','09:50:00',7.71),('10318','2014-03-21','09:55:00',7.69),('10318','2014-03-21','10:00:00',7.8),('10318','2014-03-21','10:05:00',8),('10318','2014-03-21','10:10:00',7.91),('10318','2014-03-21','10:15:00',8.03),('10318','2014-03-21','10:20:00',8.06),('10318','2014-03-21','10:25:00',8.15),('10318','2014-03-21','10:30:00',8.25),('10318','2014-03-21','10:35:00',8.35),('10318','2014-03-21','10:40:00',8.2),('10318','2014-03-21','10:45:00',8.23),('10318','2014-03-21','10:50:00',8.26),('10318','2014-03-21','10:55:00',8.12),('10318','2014-03-21','11:00:00',8.26),('10318','2014-03-21','11:05:00',8.17),('10318','2014-03-21','11:10:00',7.75),('10318','2014-03-21','11:15:00',6.55),('10318','2014-03-21','11:20:00',8.46),('10318','2014-03-21','11:25:00',8.3),('10318','2014-03-21','11:30:00',8.38),('10318','2014-03-21','11:35:00',8.61),('10318','2014-03-21','11:40:00',8.48),('10318','2014-03-21','11:45:00',8.44),('10318','2014-03-21','11:50:00',8.63),('10318','2014-03-21','11:55:00',8.46),('10318','2014-03-21','12:00:00',8.4),('10318','2014-03-21','12:05:00',7.93),('10318','2014-03-21','12:10:00',8.73),('10318','2014-03-21','12:15:00',8.58),('10318','2014-03-21','12:20:00',8.62),('10318','2014-03-21','12:25:00',8.6),('10318','2014-03-21','12:30:00',8.63),('10318','2014-03-21','12:35:00',8.68),('10318','2014-03-21','12:40:00',8.57),('10318','2014-03-21','12:45:00',8.31),('10318','2014-03-21','12:50:00',8.43),('10318','2014-03-21','12:55:00',8.36),('10318','2014-03-21','13:00:00',8.33),('10318','2014-03-21','13:05:00',8.32),('10318','2014-03-21','13:10:00',8.3),('10318','2014-03-21','13:15:00',8.22),('10318','2014-03-21','13:20:00',8.13),('10318','2014-03-21','13:25:00',8.16),('10318','2014-03-21','13:30:00',8.05),('10318','2014-03-21','13:35:00',7.95),('10318','2014-03-21','13:40:00',7.87),('10318','2014-03-21','13:45:00',7.84),('10318','2014-03-21','13:50:00',7.78),('10318','2014-03-21','13:55:00',7.66),('10318','2014-03-21','14:00:00',7.58),('10318','2014-03-21','14:05:00',7.48),('10318','2014-03-21','14:10:00',7.39),('10318','2014-03-21','14:15:00',7.26),('10318','2014-03-21','14:20:00',7.14),('10318','2014-03-21','14:25:00',7),('10318','2014-03-21','14:30:00',6.63),('10318','2014-03-21','14:35:00',6.44),('10318','2014-03-21','14:40:00',6.28),('10318','2014-03-21','14:45:00',5.59),('10318','2014-03-21','14:50:00',2.73),('10318','2014-03-21','14:55:00',1.78),('10318','2014-03-21','15:00:00',2.98),('10318','2014-03-21','15:05:00',4.3),('10318','2014-03-21','15:10:00',5.83),('10318','2014-03-21','15:15:00',6.24),('10318','2014-03-21','15:20:00',3.73),('10318','2014-03-21','15:25:00',5.8),('10318','2014-03-21','15:30:00',5.73),('10318','2014-03-21','15:35:00',5.02),('10318','2014-03-21','15:40:00',5.1),('10318','2014-03-21','15:45:00',5.07),('10318','2014-03-21','15:50:00',5.07),('10318','2014-03-21','15:55:00',4.87),('10318','2014-03-21','16:00:00',4.53),('10318','2014-03-21','16:05:00',4.08),('10318','2014-03-21','16:10:00',3.78),('10318','2014-03-21','16:15:00',3.42),('10318','2014-03-21','16:20:00',3.1),('10318','2014-03-21','16:25:00',2.86),('10318','2014-03-21','16:30:00',2.61),('10318','2014-03-21','16:35:00',2.42),('10318','2014-03-21','16:40:00',2.26),('10318','2014-03-21','16:45:00',2.08),('10318','2014-03-21','16:50:00',1.91),('10318','2014-03-21','16:55:00',1.74),('10318','2014-03-21','17:00:00',1.44),('10318','2014-03-21','17:05:00',1.33),('10318','2014-03-21','17:10:00',1.18),('10318','2013-01-31','08:55:00',1.19),('10318','2013-01-31','09:00:00',1.71),('10318','2013-01-31','09:05:00',1.47),('10318','2013-01-31','09:10:00',1.4),('10318','2013-01-31','09:15:00',1.8),('10318','2013-01-31','09:20:00',1.91),('10318','2013-01-31','09:25:00',2.93),('10318','2013-01-31','09:30:00',2.21),('10318','2013-01-31','09:35:00',5.05),('10318','2013-01-31','09:40:00',5.82),('10318','2013-01-31','09:45:00',5.64),('10318','2013-01-31','09:50:00',6.11),('10318','2013-01-31','09:55:00',6.02),('10318','2013-01-31','10:00:00',6.95),('10318','2013-01-31','10:05:00',6.35),('10318','2013-01-31','10:10:00',4.53),('10318','2013-01-31','10:15:00',5.72),('10318','2013-01-31','10:20:00',6.38),('10318','2013-01-31','10:25:00',7.21),('10318','2013-01-31','10:30:00',7.46),('10318','2013-01-31','10:35:00',7.7),('10318','2013-01-31','10:40:00',5.61),('10318','2013-01-31','10:45:00',7.03),('10318','2013-01-31','10:50:00',2.47),('10318','2013-01-31','10:55:00',1.64),('10318','2013-01-31','11:00:00',1.29),('10318','2013-01-31','11:05:00',1.17),('10318','2013-01-31','11:10:00',7.14),('10318','2013-01-31','11:15:00',7.98),('10318','2013-01-31','11:20:00',8.25),('10318','2013-01-31','11:25:00',8.4),('10318','2013-01-31','11:30:00',8.02),('10318','2013-01-31','11:35:00',7.64),('10318','2013-01-31','11:40:00',7.49),('10318','2013-01-31','11:45:00',7.52),('10318','2013-01-31','11:50:00',7.5),('10318','2013-01-31','11:55:00',7.46),('10318','2013-01-31','12:00:00',7.4),('10318','2013-01-31','12:05:00',7.36),('10318','2013-01-31','12:10:00',7.31),('10318','2013-01-31','12:15:00',7.12),('10318','2013-01-31','12:20:00',7.23),('10318','2013-01-31','12:25:00',7.26),('10318','2013-01-31','12:30:00',7.13),('10318','2013-01-31','12:35:00',7.19),('10318','2013-01-31','12:40:00',7.05),('10318','2013-01-31','12:45:00',7),('10318','2013-01-31','12:50:00',6.9),('10318','2013-01-31','12:55:00',6.93),('10318','2013-01-31','13:00:00',6.78),('10318','2013-01-31','13:05:00',6.58),('10318','2013-01-31','13:10:00',6.64),('10318','2013-01-31','13:15:00',6.52),('10318','2013-01-31','13:20:00',6.52),('10318','2013-01-31','13:25:00',6.38),('10318','2013-01-31','13:30:00',6.28),('10318','2013-01-31','13:35:00',6.13),('10318','2013-01-31','13:40:00',6.07),('10318','2013-01-31','13:45:00',5.95),('10318','2013-01-31','13:50:00',5.76),('10318','2013-01-31','13:55:00',5.69),('10318','2013-01-31','14:00:00',5.52),('10318','2013-01-31','14:05:00',5.52),('10318','2013-01-31','14:10:00',5.41),('10318','2013-01-31','14:15:00',5.2),('10318','2013-01-31','14:20:00',5.06),('10318','2013-01-31','14:25:00',4.89),('10318','2013-01-31','14:30:00',4.83),('10318','2013-01-31','14:35:00',4.59),('10318','2013-01-31','14:40:00',4.48),('10318','2013-01-31','14:45:00',4.42),('10318','2013-01-31','14:50:00',4.22),('10318','2013-01-31','14:55:00',4.09),('10318','2013-01-31','15:00:00',4),('10318','2013-01-31','15:05:00',3.89),('10318','2013-01-31','15:10:00',3.73),('10318','2013-01-31','15:15:00',3.58),('10318','2013-01-31','15:20:00',3.45),('10318','2013-01-31','15:25:00',3.07),('10318','2013-01-31','15:30:00',2.96),('10318','2013-01-31','15:35:00',3.13),('10318','2013-01-31','15:40:00',2.95),('10318','2013-01-31','15:45:00',2.58),('10318','2013-01-31','15:50:00',2.57),('10318','2013-01-31','15:55:00',2.41),('10318','2013-01-31','16:00:00',1.88),('10318','2013-01-31','16:05:00',1.7),('10318','2013-01-31','16:10:00',1.88),('10318','2013-01-31','16:15:00',1.56),('10318','2013-01-31','16:20:00',1.51),('10318','2013-01-31','16:25:00',1.32),('10318','2013-01-31','16:30:00',1.3),('10318','2013-01-31','16:35:00',1.13),('10318','2013-01-30','08:55:00',1.1),('10318','2013-01-30','09:00:00',1.42),('10318','2013-01-30','09:05:00',1.6),('10318','2013-01-30','09:10:00',1.25),('10318','2013-01-30','09:15:00',2.07),('10318','2013-01-30','09:20:00',1.77),('10318','2013-01-30','09:25:00',1.65),('10318','2013-01-30','09:30:00',2.48),('10318','2013-01-30','09:35:00',1.47),('10318','2013-01-30','09:40:00',1.61),('10318','2013-01-30','09:45:00',1.66),('10318','2013-01-30','09:55:00',1.78),('10318','2013-01-30','10:00:00',3.14),('10318','2013-01-30','10:05:00',2.42),('10318','2013-01-30','10:10:00',2.63),('10318','2013-01-30','10:15:00',3.87),('10318','2013-01-30','10:20:00',4.83),('10318','2013-01-30','10:25:00',3.03),('10318','2013-01-30','10:30:00',3.33),('10318','2013-01-30','10:35:00',4.21),('10318','2013-01-30','10:40:00',5.83),('10318','2013-01-30','10:45:00',6.74),('10318','2013-01-30','10:50:00',7.56),('10318','2013-01-30','10:55:00',7.22),('10318','2013-01-30','11:00:00',6.82),('10318','2013-01-30','11:05:00',6.69),('10318','2013-01-30','11:10:00',6.94),('10318','2013-01-30','11:15:00',7.15),('10318','2013-01-30','11:20:00',7.35),('10318','2013-01-30','11:25:00',7.29),('10318','2013-01-30','11:30:00',5.36),('10318','2013-01-30','11:35:00',7.25),('10318','2013-01-30','11:40:00',5.75),('10318','2013-01-30','11:45:00',5.3),('10318','2013-01-30','11:50:00',3.2),('10318','2013-01-30','11:55:00',2.74),('10318','2013-01-30','12:00:00',5.96),('10318','2013-01-30','12:05:00',6.54),('10318','2013-01-30','12:10:00',5.41),('10318','2013-01-30','12:15:00',6.22),('10318','2013-01-30','12:20:00',7.16),('10318','2013-01-30','12:25:00',8.81),('10318','2013-01-30','12:30:00',8.5),('10318','2013-01-30','12:35:00',7.3),('10318','2013-01-30','12:40:00',3.75),('10318','2013-01-30','12:45:00',3.85),('10318','2013-01-30','12:50:00',4.08),('10318','2013-01-30','12:55:00',2.31),('10318','2013-01-30','13:00:00',4.41),('10318','2013-01-30','13:05:00',2.9),('10318','2013-01-30','13:10:00',5.7),('10318','2013-01-30','13:15:00',7.57),('10318','2013-01-30','13:20:00',6.22),('10318','2013-01-30','13:25:00',2.7),('10318','2013-01-30','13:30:00',1.68),('10318','2013-01-30','13:35:00',2.22),('10318','2013-01-30','13:40:00',2.5),('10318','2013-01-30','13:45:00',4.21),('10318','2013-01-30','13:50:00',4.17),('10318','2013-01-30','13:55:00',3.84),('10318','2013-01-30','14:00:00',2.11),('10318','2013-01-30','14:05:00',1.95),('10318','2013-01-30','14:10:00',2.17),('10318','2013-01-30','14:15:00',3.02),('10318','2013-01-30','14:20:00',4.45),('10318','2013-01-30','14:25:00',5.56),('10318','2013-01-30','14:30:00',4.89),('10318','2013-01-30','14:35:00',3.47),('10318','2013-01-30','14:40:00',4.73),('10318','2013-01-30','14:45:00',3.85),('10318','2013-01-30','14:50:00',2.71),('10318','2013-01-30','14:55:00',2.74),('10318','2013-01-30','15:00:00',3.34),('10318','2013-01-30','15:05:00',2.37),('10318','2013-01-30','15:10:00',2.05),('10318','2013-01-30','15:15:00',1.74),('10318','2013-01-30','15:20:00',1.61),('10318','2013-01-30','15:25:00',1.58),('10318','2013-01-30','15:30:00',1.6),('10318','2013-01-30','15:35:00',1.4),('10318','2013-01-30','15:40:00',1.31),('10318','2013-01-30','15:45:00',1.24),('10318','2013-01-30','15:50:00',1.22),('10318','2013-01-30','15:55:00',1.18),('10318','2013-01-30','16:00:00',1.08),('10318','2013-01-30','16:05:00',1.02),('10318','2013-01-30','16:10:00',1.07),('10318','2013-01-30','16:15:00',1.25),('10318','2013-01-30','16:20:00',1.19),('10318','2013-01-30','16:25:00',1.06),('10318','2013-01-29','08:00:00',1.16),('10318','2013-01-29','08:05:00',1.36),('10318','2013-01-29','08:10:00',1.54),('10318','2013-01-29','08:15:00',2.07),('10318','2013-01-29','08:20:00',2.41),('10318','2013-01-29','08:25:00',2.75),('10318','2013-01-29','08:30:00',3.14),('10318','2013-01-29','08:35:00',3.34),('10318','2013-01-29','08:40:00',3.63),('10318','2013-01-29','08:45:00',3.85),('10318','2013-01-29','08:50:00',4.05),('10318','2013-01-29','08:55:00',4.23),('10318','2013-01-29','09:00:00',4.43),('10318','2013-01-29','09:05:00',4.63),('10318','2013-01-29','09:10:00',4.82),('10318','2013-01-29','09:15:00',5),('10318','2013-01-29','09:20:00',5.15),('10318','2013-01-29','09:25:00',5.28),('10318','2013-01-29','09:30:00',5.45),('10318','2013-01-29','09:35:00',5.62),('10318','2013-01-29','09:40:00',5.78),('10318','2013-01-29','09:45:00',5.91),('10318','2013-01-29','09:50:00',6.06),('10318','2013-01-29','09:55:00',6.23),('10318','2013-01-29','10:00:00',6.35),('10318','2013-01-29','10:05:00',6.42),('10318','2013-01-29','10:10:00',6.48),('10318','2013-01-29','10:15:00',6.55),('10318','2013-01-29','10:20:00',6.76),('10318','2013-01-29','10:25:00',6.84),('10318','2013-01-29','10:30:00',6.96),('10318','2013-01-29','10:35:00',7.07),('10318','2013-01-29','10:40:00',7.12),('10318','2013-01-29','10:45:00',7.18),('10318','2013-01-29','10:50:00',7.28),('10318','2013-01-29','10:55:00',7.22),('10318','2013-01-29','11:00:00',7.18),('10318','2013-01-29','11:05:00',7.16),('10318','2013-01-29','11:10:00',7.22),('10318','2013-01-29','11:15:00',7.24),('10318','2013-01-29','11:20:00',7.41),('10318','2013-01-29','11:25:00',7.29),('10318','2013-01-29','11:30:00',7.02),('10318','2013-01-29','11:35:00',7.41),('10318','2013-01-29','11:40:00',7.41),('10318','2013-01-29','11:45:00',7.41),('10318','2013-01-29','11:50:00',7.4),('10318','2013-01-29','11:55:00',7.47),('10318','2013-01-29','12:00:00',7.47),('10318','2013-01-29','12:05:00',7.44),('10318','2013-01-29','12:10:00',7.51),('10318','2013-01-29','12:15:00',7.46),('10318','2013-01-29','12:20:00',7.32),('10318','2013-01-29','12:25:00',7.35),('10318','2013-01-29','12:30:00',7.36),('10318','2013-01-29','12:35:00',7.21),('10318','2013-01-29','12:40:00',7.23),('10318','2013-01-29','12:45:00',7.06),('10318','2013-01-29','12:50:00',7.07),('10318','2013-01-29','12:55:00',7.13),('10318','2013-01-29','13:00:00',7.06),('10318','2013-01-29','13:05:00',7.03),('10318','2013-01-29','13:10:00',6.96),('10318','2013-01-29','13:15:00',6.78),('10318','2013-01-29','13:20:00',6.72),('10318','2013-01-29','13:25:00',6.58),('10318','2013-01-29','13:30:00',6.5),('10318','2013-01-29','13:35:00',6.43),('10318','2013-01-29','13:40:00',6.23),('10318','2013-01-29','13:45:00',6.13),('10318','2013-01-29','13:50:00',5.94),('10318','2013-01-29','13:55:00',5.88),('10318','2013-01-29','14:00:00',5.78),('10318','2013-01-29','14:05:00',5.08),('10318','2013-01-29','14:10:00',5.55),('10318','2013-01-29','14:15:00',5.44),('10318','2013-01-29','14:20:00',5.34),('10318','2013-01-29','14:25:00',5.19),('10318','2013-01-29','14:30:00',5.01),('10318','2013-01-29','14:35:00',4.85),('10318','2013-01-29','14:40:00',4.71),('10318','2013-01-29','14:45:00',4.59),('10318','2013-01-29','14:50:00',4.35),('10318','2013-01-29','14:55:00',4.17),('10318','2013-01-29','15:00:00',3.95),('10318','2013-01-29','15:05:00',3.97),('10318','2013-01-29','15:10:00',3.79),('10318','2013-01-29','15:15:00',3.63),('10318','2013-01-29','15:20:00',3.47),('10318','2013-01-29','15:25:00',3.33),('10318','2013-01-29','15:30:00',3.18),('10318','2013-01-29','15:35:00',3.07),('10318','2013-01-29','15:40:00',2.89),('10318','2013-01-29','15:45:00',2.71),('10318','2013-01-29','15:50:00',2.66),('10318','2013-01-29','15:55:00',2.58),('10318','2013-01-29','16:00:00',2.41),('10318','2013-01-29','16:05:00',2.24),('10318','2013-01-29','16:10:00',2.03),('10318','2013-01-29','16:15:00',1.83),('10318','2013-01-29','16:20:00',1.67),('10318','2013-01-29','16:25:00',1.55),('10318','2013-01-29','16:30:00',1.36),('10318','2013-01-29','16:35:00',1.17),('10318','2013-01-29','16:40:00',1.02),('10318','2013-01-28','08:25:00',1.07),('10318','2013-01-28','08:30:00',1.11),('10318','2013-01-28','08:35:00',1.11),('10318','2013-01-28','08:40:00',1.04),('10318','2013-01-28','10:05:00',1.06),('10318','2013-01-28','10:10:00',1.18),('10318','2013-01-28','10:15:00',1.13),('10318','2013-01-28','10:20:00',1.11),('10318','2013-01-28','10:25:00',1.06),('10318','2013-01-28','10:45:00',1.04),('10318','2013-01-28','10:50:00',1.27),('10318','2013-01-28','10:55:00',1.51),('10318','2013-01-28','11:00:00',1.75),('10318','2013-01-28','11:05:00',1.97),('10318','2013-01-28','11:10:00',1.92),('10318','2013-01-28','11:15:00',1.66),('10318','2013-01-28','11:20:00',1.63),('10318','2013-01-28','11:25:00',1.52),('10318','2013-01-28','11:30:00',1.31),('10318','2013-01-28','11:35:00',1.21),('10318','2013-01-28','11:40:00',1.17),('10318','2013-01-28','11:45:00',1.22),('10318','2013-01-28','11:50:00',1.13),('10318','2013-01-28','12:15:00',1.05),('10318','2013-01-28','12:20:00',1.11),('10318','2013-01-28','12:25:00',1.15),('10318','2013-01-28','12:30:00',1.35),('10318','2013-01-28','12:35:00',1.76),('10318','2013-01-28','12:40:00',2.28),('10318','2013-01-28','12:45:00',2.73),('10318','2013-01-28','12:50:00',2.83),('10318','2013-01-28','12:55:00',2.66),('10318','2013-01-28','13:00:00',2.48),('10318','2013-01-28','13:05:00',2.47),('10318','2013-01-28','13:10:00',2.31),('10318','2013-01-28','13:15:00',2.19),('10318','2013-01-28','13:20:00',2.05),('10318','2013-01-28','13:25:00',1.97),('10318','2013-01-28','13:30:00',1.94),('10318','2013-01-28','13:35:00',1.9),('10318','2013-01-28','13:40:00',1.78),('10318','2013-01-28','13:45:00',1.63),('10318','2013-01-28','13:50:00',1.5),('10318','2013-01-28','13:55:00',1.57),('10318','2013-01-28','14:00:00',1.59),('10318','2013-01-28','14:05:00',1.59),('10318','2013-01-28','14:10:00',1.58),('10318','2013-01-28','14:15:00',1.44),('10318','2013-01-28','14:20:00',1.3),('10318','2013-01-28','14:25:00',1.17),('10318','2013-01-28','14:30:00',1.13),('10318','2013-01-28','14:35:00',1.03),('10318','2013-01-28','14:40:00',1.04),('10318','2013-01-28','14:45:00',1.04),('10318','2013-01-27','08:00:00',1.11),('10318','2013-01-27','08:05:00',1.3),('10318','2013-01-27','08:10:00',1.53),('10318','2013-01-27','08:15:00',2),('10318','2013-01-27','08:20:00',2.32),('10318','2013-01-27','08:25:00',2.76),('10318','2013-01-27','08:30:00',3.31),('10318','2013-01-27','08:35:00',3.47),('10318','2013-01-27','08:40:00',3.49),('10318','2013-01-27','08:45:00',3.26),('10318','2013-01-27','08:50:00',3.7),('10318','2013-01-27','08:55:00',4.39),('10318','2013-01-27','09:00:00',4.44),('10318','2013-01-27','09:05:00',4.53),('10318','2013-01-27','09:10:00',4.61),('10318','2013-01-27','09:15:00',4.79),('10318','2013-01-27','09:20:00',5.02),('10318','2013-01-27','09:25:00',5.15),('10318','2013-01-27','09:30:00',5.29),('10318','2013-01-27','09:35:00',5.51),('10318','2013-01-27','09:40:00',5.64),('10318','2013-01-27','09:45:00',5.66),('10318','2013-01-27','09:50:00',5.88),('10318','2013-01-27','09:55:00',5.99),('10318','2013-01-27','10:00:00',6.08),('10318','2013-01-27','10:05:00',6.24),('10318','2013-01-27','10:10:00',6.35),('10318','2013-01-27','10:15:00',6.44),('10318','2013-01-27','10:20:00',6.6),('10318','2013-01-27','10:25:00',6.67),('10318','2013-01-27','10:30:00',6.69),('10318','2013-01-27','10:35:00',6.81),('10318','2013-01-27','10:40:00',6.86),('10318','2013-01-27','10:45:00',6.97),('10318','2013-01-27','10:50:00',7.03),('10318','2013-01-27','10:55:00',7.12),('10318','2013-01-27','11:00:00',7.15),('10318','2013-01-27','11:05:00',7.15),('10318','2013-01-27','11:10:00',7.22),('10318','2013-01-27','11:15:00',7.29),('10318','2013-01-27','11:20:00',7.34),('10318','2013-01-27','11:25:00',7.32),('10318','2013-01-27','11:30:00',7.2),('10318','2013-01-27','11:35:00',7.34),('10318','2013-01-27','11:40:00',7.41),('10318','2013-01-27','11:45:00',7.37),('10318','2013-01-27','11:50:00',7.37),('10318','2013-01-27','11:55:00',7.38),('10318','2013-01-27','12:00:00',7.34),('10318','2013-01-27','12:05:00',7.35),('10318','2013-01-27','12:10:00',7.37),('10318','2013-01-27','12:15:00',7.35),('10318','2013-01-27','12:20:00',7.27),('10318','2013-01-27','12:25:00',7.23),('10318','2013-01-27','12:30:00',7.22),('10318','2013-01-27','12:35:00',7.12),('10318','2013-01-27','12:40:00',7.08),('10318','2013-01-27','12:45:00',7.14),('10318','2013-01-27','12:50:00',7.08),('10318','2013-01-27','12:55:00',6.99),('10318','2013-01-27','13:00:00',6.76),('10318','2013-01-27','13:05:00',6.13),('10318','2013-01-27','13:10:00',5.94),('10318','2013-01-27','13:15:00',6.41),('10318','2013-01-27','13:20:00',6.4),('10318','2013-01-27','13:25:00',6.35),('10318','2013-01-27','13:30:00',6.17),('10318','2013-01-27','13:35:00',6.07),('10318','2013-01-27','13:40:00',6.04),('10318','2013-01-27','13:45:00',5.9),('10318','2013-01-27','13:50:00',5.8),('10318','2013-01-27','13:55:00',5.65),('10318','2013-01-27','14:00:00',5.49),('10318','2013-01-27','14:05:00',5.33),('10318','2013-01-27','14:10:00',5.24),('10318','2013-01-27','14:15:00',5.05),('10318','2013-01-27','14:20:00',5.02),('10318','2013-01-27','14:25:00',4.92),('10318','2013-01-27','14:30:00',4.8),('10318','2013-01-27','14:35:00',4.63),('10318','2013-01-27','14:40:00',4.43),('10318','2013-01-27','14:45:00',4.29),('10318','2013-01-27','14:50:00',4.2),('10318','2013-01-27','14:55:00',4.02),('10318','2013-01-27','15:00:00',3.76),('10318','2013-01-27','15:05:00',3.71),('10318','2013-01-27','15:10:00',3.53),('10318','2013-01-27','15:15:00',3.43),('10318','2013-01-27','15:20:00',3.26),('10318','2013-01-27','15:25:00',3.11),('10318','2013-01-27','15:30:00',2.92),('10318','2013-01-27','15:35:00',2.85),('10318','2013-01-27','15:40:00',2.8),('10318','2013-01-27','15:45:00',2.68),('10318','2013-01-27','15:50:00',2.52),('10318','2013-01-27','15:55:00',2.34),('10318','2013-01-27','16:00:00',2.1),('10318','2013-01-27','16:05:00',1.9),('10318','2013-01-27','16:10:00',1.77),('10318','2013-01-27','16:15:00',1.58),('10318','2013-01-27','16:20:00',1.39),('10318','2013-01-27','16:25:00',1.25),('10318','2013-01-27','16:30:00',1.1),('10318','2013-01-26','08:45:00',1.12),('10318','2013-01-26','08:50:00',1.27),('10318','2013-01-26','08:55:00',1.99),('10318','2013-01-26','09:00:00',3.08),('10318','2013-01-26','09:05:00',4.04),('10318','2013-01-26','09:10:00',3.66),('10318','2013-01-26','09:15:00',2.78),('10318','2013-01-26','09:20:00',2.97),('10318','2013-01-26','09:25:00',1.91),('10318','2013-01-26','09:30:00',2.25),('10318','2013-01-26','09:35:00',1.84),('10318','2013-01-26','09:40:00',1.45),('10318','2013-01-26','09:45:00',2.26),('10318','2013-01-26','09:50:00',2.45),('10318','2013-01-26','09:55:00',1.82),('10318','2013-01-26','10:00:00',1.6),('10318','2013-01-26','10:05:00',1.65),('10318','2013-01-26','10:10:00',1.78),('10318','2013-01-26','10:15:00',2.3),('10318','2013-01-26','10:20:00',2.67),('10318','2013-01-26','10:25:00',1.9),('10318','2013-01-26','10:30:00',1.72),('10318','2013-01-26','10:35:00',1.83),('10318','2013-01-26','10:40:00',2.09),('10318','2013-01-26','10:45:00',2.35),('10318','2013-01-26','10:50:00',2.14),('10318','2013-01-26','10:55:00',1.81),('10318','2013-01-26','11:00:00',1.99),('10318','2013-01-26','11:05:00',2.18),('10318','2013-01-26','11:10:00',2.16),('10318','2013-01-26','11:15:00',2.27),('10318','2013-01-26','11:20:00',2.14),('10318','2013-01-26','11:25:00',2.9),('10318','2013-01-26','11:30:00',2.85),('10318','2013-01-26','11:35:00',1.98),('10318','2013-01-26','11:40:00',2.07),('10318','2013-01-26','11:45:00',2.03),('10318','2013-01-26','11:50:00',2),('10318','2013-01-26','11:55:00',1.58),('10318','2013-01-26','12:00:00',1.59),('10318','2013-01-26','12:05:00',1.51),('10318','2013-01-26','12:10:00',1.57),('10318','2013-01-26','12:15:00',1.7),('10318','2013-01-26','12:20:00',1.79),('10318','2013-01-26','12:25:00',1.82),('10318','2013-01-26','12:30:00',1.78),('10318','2013-01-26','12:35:00',1.75),('10318','2013-01-26','12:40:00',1.7),('10318','2013-01-26','12:45:00',1.71),('10318','2013-01-26','12:50:00',1.42),('10318','2013-01-26','12:55:00',1.24),('10318','2013-01-26','13:00:00',1.61),('10318','2013-01-26','13:05:00',1.52),('10318','2013-01-26','13:10:00',1.18),('10318','2013-01-26','13:15:00',1.15),('10318','2013-01-26','13:20:00',1.18),('10318','2013-01-26','13:25:00',1.24),('10318','2013-01-26','13:30:00',1.46),('10318','2013-01-26','13:35:00',1.61),('10318','2013-01-26','13:40:00',1.64),('10318','2013-01-26','13:45:00',1.64),('10318','2013-01-26','13:50:00',1.41),('10318','2013-01-26','13:55:00',1.23),('10318','2013-01-26','14:00:00',1.06),('10318','2013-01-26','14:05:00',1.06),('10318','2013-01-26','14:10:00',1.06),('10318','2013-01-26','14:15:00',1.13),('10318','2013-01-26','14:20:00',1.29),('10318','2013-01-26','14:25:00',1.32),('10318','2013-01-26','14:30:00',1.2),('10318','2013-01-26','14:35:00',1),('10318','2013-01-25','08:15:00',1.07),('10318','2013-01-25','08:20:00',2.13),('10318','2013-01-25','08:25:00',2.87),('10318','2013-01-25','08:30:00',3.45),('10318','2013-01-25','08:35:00',3.66),('10318','2013-01-25','08:40:00',3.86),('10318','2013-01-25','08:45:00',4.14),('10318','2013-01-25','08:50:00',4.36),('10318','2013-01-25','08:55:00',4.47),('10318','2013-01-25','09:00:00',4.47),('10318','2013-01-25','09:05:00',3.69),('10318','2013-01-25','09:10:00',4.6),('10318','2013-01-25','09:15:00',4.79),('10318','2013-01-25','09:20:00',5.05),('10318','2013-01-25','09:25:00',5.01),('10318','2013-01-25','09:30:00',5.35),('10318','2013-01-25','09:35:00',4.91),('10318','2013-01-25','09:40:00',4.7),('10318','2013-01-25','09:45:00',5.18),('10318','2013-01-25','09:50:00',5.79),('10318','2013-01-25','09:55:00',6.2),('10318','2013-01-25','10:00:00',6.64),('10318','2013-01-25','10:05:00',6.86),('10318','2013-01-25','10:10:00',7),('10318','2013-01-25','10:15:00',6.95),('10318','2013-01-25','10:20:00',7.16),('10318','2013-01-25','10:25:00',6.9),('10318','2013-01-25','10:30:00',7.45),('10318','2013-01-25','10:35:00',7.38),('10318','2013-01-25','10:40:00',7.28),('10318','2013-01-25','10:45:00',7.32),('10318','2013-01-25','10:50:00',5.8),('10318','2013-01-25','10:55:00',7.97),('10318','2013-01-25','11:00:00',6.92),('10318','2013-01-25','11:05:00',6.76),('10318','2013-01-25','11:10:00',7.63),('10318','2013-01-25','11:15:00',7.51),('10318','2013-01-25','11:20:00',7.4),('10318','2013-01-25','11:25:00',7.77),('10318','2013-01-25','11:30:00',7.84),('10318','2013-01-25','11:35:00',7.83),('10318','2013-01-25','11:40:00',7.81),('10318','2013-01-25','11:45:00',7.79),('10318','2013-01-25','11:50:00',7.7),('10318','2013-01-25','11:55:00',7.82),('10318','2013-01-25','12:00:00',7.75),('10318','2013-01-25','12:05:00',7.4),('10318','2013-01-25','12:10:00',7.41),('10318','2013-01-25','12:15:00',7.47),('10318','2013-01-25','12:20:00',7.51),('10318','2013-01-25','12:25:00',7.52),('10318','2013-01-25','12:30:00',6.51),('10318','2013-01-25','12:35:00',6.59),('10318','2013-01-25','12:40:00',6.91),('10318','2013-01-25','12:45:00',6.83),('10318','2013-01-25','12:50:00',7.1),('10318','2013-01-25','12:55:00',7.11),('10318','2013-01-25','13:00:00',6.98),('10318','2013-01-25','13:05:00',6.9),('10318','2013-01-25','13:10:00',6.77),('10318','2013-01-25','13:15:00',6.77),('10318','2013-01-25','13:20:00',6.59),('10318','2013-01-25','13:25:00',6.39),('10318','2013-01-25','13:30:00',6.55),('10318','2013-01-25','13:35:00',6.5),('10318','2013-01-25','13:40:00',6.54),('10318','2013-01-25','13:45:00',6.35),('10318','2013-01-25','13:50:00',6.21),('10318','2013-01-25','13:55:00',6.05),('10318','2013-01-25','14:00:00',5.62),('10318','2013-01-25','14:05:00',5.34),('10318','2013-01-25','14:10:00',5.05),('10318','2013-01-25','14:15:00',5.04),('10318','2013-01-25','14:20:00',4.81),('10318','2013-01-25','14:25:00',4.71),('10318','2013-01-25','14:30:00',4.47),('10318','2013-01-25','14:35:00',4.34),('10318','2013-01-25','14:40:00',4.23),('10318','2013-01-25','14:45:00',4.09),('10318','2013-01-25','14:50:00',3.84),('10318','2013-01-25','14:55:00',3.67),('10318','2013-01-25','15:00:00',3.36),('10318','2013-01-25','15:05:00',3.34),('10318','2013-01-25','15:10:00',3.22),('10318','2013-01-25','15:15:00',3.22),('10318','2013-01-25','15:20:00',3.05),('10318','2013-01-25','15:25:00',2.97),('10318','2013-01-25','15:30:00',3.12),('10318','2013-01-25','15:35:00',3.17),('10318','2013-01-25','15:40:00',2.87),('10318','2013-01-25','15:45:00',3.01),('10318','2013-01-25','15:50:00',2.81),('10318','2013-01-25','15:55:00',2.35),('10318','2013-01-25','16:00:00',1.55),('10318','2013-01-25','16:05:00',1.26),('10318','2013-01-25','16:10:00',1.3),('10318','2013-01-25','16:15:00',1.42),('10318','2013-01-25','16:20:00',1.39),('10318','2013-01-25','16:25:00',1.12),('10318','2013-01-24','08:45:00',1.17),('10318','2013-01-24','08:50:00',1.51),('10318','2013-01-24','08:55:00',1.71),('10318','2013-01-24','09:00:00',1.64),('10318','2013-01-24','09:05:00',1.41),('10318','2013-01-24','09:10:00',1.51),('10318','2013-01-24','09:15:00',1.73),('10318','2013-01-24','09:20:00',1.97),('10318','2013-01-24','09:25:00',2.03),('10318','2013-01-24','09:30:00',4.01),('10318','2013-01-24','09:35:00',3.15),('10318','2013-01-24','09:40:00',5.5),('10318','2013-01-24','09:45:00',6.08),('10318','2013-01-24','09:50:00',6.31),('10318','2013-01-24','09:55:00',5.93),('10318','2013-01-24','10:00:00',4.2),('10318','2013-01-24','10:05:00',5.5),('10318','2013-01-24','10:10:00',6.83),('10318','2013-01-24','10:15:00',7.07),('10318','2013-01-24','10:20:00',7.18),('10318','2013-01-24','10:25:00',7.17),('10318','2013-01-24','10:30:00',7.16),('10318','2013-01-24','10:35:00',7.22),('10318','2013-01-24','10:40:00',7.3),('10318','2013-01-24','10:45:00',7.39),('10318','2013-01-24','10:50:00',6.8),('10318','2013-01-24','10:55:00',4.03),('10318','2013-01-24','11:00:00',2.33),('10318','2013-01-24','11:05:00',1.2),('10318','2013-01-24','11:10:00',1),('10318','2013-01-24','11:25:00',1),('10318','2013-01-24','11:30:00',1.01),('10318','2013-01-24','11:35:00',1.08),('10318','2013-01-24','11:40:00',1.12),('10318','2013-01-24','11:45:00',1.08),('10318','2013-01-24','11:50:00',1.08),('10318','2013-01-24','11:55:00',1),('10318','2013-01-24','12:25:00',1.16),('10318','2013-01-24','12:30:00',1.47),('10318','2013-01-24','12:35:00',1.89),('10318','2013-01-24','12:40:00',2.26),('10318','2013-01-24','12:45:00',2.4),('10318','2013-01-24','12:50:00',2.28),('10318','2013-01-24','12:55:00',2.14),('10318','2013-01-24','13:00:00',2.09),('10318','2013-01-24','13:05:00',2.09),('10318','2013-01-24','13:10:00',2.09),('10318','2013-01-24','13:15:00',1.97),('10318','2013-01-24','13:20:00',1.88),('10318','2013-01-24','13:25:00',1.88),('10318','2013-01-24','13:30:00',1.83),('10318','2013-01-24','13:35:00',1.85),('10318','2013-01-24','13:40:00',1.84),('10318','2013-01-24','13:45:00',1.89),('10318','2013-01-24','13:50:00',2.01),('10318','2013-01-24','13:55:00',2.3),('10318','2013-01-24','14:00:00',2.61),('10318','2013-01-24','14:05:00',2.48),('10318','2013-01-24','14:10:00',2.62),('10318','2013-01-24','14:15:00',3.06),('10318','2013-01-24','14:20:00',6.51),('10318','2013-01-24','14:25:00',6.74),('10318','2013-01-24','14:30:00',4.58),('10318','2013-01-24','14:35:00',3.26),('10318','2013-01-24','14:40:00',4.6),('10318','2013-01-24','14:45:00',4.62),('10318','2013-01-24','14:50:00',4.9),('10318','2013-01-24','14:55:00',3.77),('10318','2013-01-24','15:00:00',2.56),('10318','2013-01-24','15:05:00',2.42),('10318','2013-01-24','15:10:00',2.78),('10318','2013-01-24','15:15:00',3.01),('10318','2013-01-24','15:20:00',2.7),('10318','2013-01-24','15:25:00',2.74),('10318','2013-01-24','15:30:00',2.88),('10318','2013-01-24','15:35:00',1.59),('10318','2013-01-24','15:40:00',2.59),('10318','2013-01-24','15:45:00',2.72),('10318','2013-01-24','15:50:00',2.63),('10318','2013-01-24','15:55:00',2.38),('10318','2013-01-24','16:00:00',2.04),('10318','2013-01-24','16:05:00',1.21),('10318','2013-01-24','16:10:00',1.53),('10318','2013-01-24','16:15:00',1.63),('10318','2013-01-24','16:20:00',1.42),('10318','2013-01-23','09:10:00',1.43),('10318','2013-01-23','09:30:00',1.03),('10318','2013-01-23','09:35:00',1.33),('10318','2013-01-23','09:40:00',1.46),('10318','2013-01-23','09:45:00',1.98),('10318','2013-01-23','09:50:00',2.13),('10318','2013-01-23','09:55:00',4.73),('10318','2013-01-23','10:00:00',5.38),('10318','2013-01-23','10:05:00',2.11),('10318','2013-01-23','10:10:00',1.58),('10318','2013-01-23','10:15:00',2.34),('10318','2013-01-23','10:20:00',1.86),('10318','2013-01-23','10:25:00',3.4),('10318','2013-01-23','10:30:00',5.7),('10318','2013-01-23','10:35:00',6.73),('10318','2013-01-23','10:40:00',5.09),('10318','2013-01-23','10:45:00',3.06),('10318','2013-01-23','10:50:00',2.78),('10318','2013-01-23','10:55:00',2.64),('10318','2013-01-23','11:00:00',1.64),('10318','2013-01-23','13:40:00',1.06),('10318','2013-01-22','08:00:00',1.19),('10318','2013-01-22','08:05:00',1.43),('10318','2013-01-22','08:10:00',1.45),('10318','2013-01-22','08:15:00',1.43),('10318','2013-01-22','08:20:00',1.78),('10318','2013-01-22','08:25:00',1.62),('10318','2013-01-22','08:30:00',1.35),('10318','2013-01-22','08:35:00',1.72),('10318','2013-01-22','08:40:00',2.73),('10318','2013-01-22','08:45:00',3.46),('10318','2013-01-22','08:50:00',3.35),('10318','2013-01-22','08:55:00',2.59),('10318','2013-01-22','09:00:00',3.55),('10318','2013-01-22','09:05:00',1.76),('10318','2013-01-22','09:25:00',4.12),('10318','2013-01-22','09:30:00',5.72),('10318','2013-01-22','09:35:00',5.97),('10318','2013-01-22','09:40:00',5.41),('10318','2013-01-22','09:45:00',5.89),('10318','2013-01-22','09:50:00',5.23),('10318','2013-01-22','09:55:00',4.75),('10318','2013-01-22','10:00:00',3.32),('10318','2013-01-22','10:05:00',6.35),('10318','2013-01-22','10:10:00',6.39),('10318','2013-01-22','10:15:00',6.15),('10318','2013-01-22','10:20:00',6.9),('10318','2013-01-22','10:25:00',7.36),('10318','2013-01-22','10:30:00',6.64),('10318','2013-01-22','10:35:00',7.63),('10318','2013-01-22','10:40:00',7),('10318','2013-01-22','10:45:00',4.75),('10318','2013-01-22','10:50:00',5.11),('10318','2013-01-22','10:55:00',2.12),('10318','2013-01-22','11:00:00',1.42),('10318','2013-01-22','11:05:00',2.91),('10318','2013-01-22','11:10:00',2.08),('10318','2013-01-22','11:15:00',3.1),('10318','2013-01-22','11:20:00',4.9),('10318','2013-01-22','11:25:00',3.27),('10318','2013-01-22','11:30:00',1.65),('10318','2013-01-22','11:35:00',1.6),('10318','2013-01-22','11:40:00',1.08),('10318','2013-01-22','11:45:00',6.16),('10318','2013-01-22','11:50:00',2.29),('10318','2013-01-22','11:55:00',1.71),('10318','2013-01-22','12:00:00',2.24),('10318','2013-01-22','12:05:00',2.05),('10318','2013-01-22','12:10:00',5.45),('10318','2013-01-22','12:15:00',1.91),('10318','2013-01-22','12:20:00',5.04),('10318','2013-01-22','12:25:00',2.83),('10318','2013-01-22','12:30:00',2.47),('10318','2013-01-22','12:35:00',6.68),('10318','2013-01-22','12:40:00',2.89),('10318','2013-01-22','12:45:00',1.87),('10318','2013-01-22','12:50:00',4.65),('10318','2013-01-22','12:55:00',5.09),('10318','2013-01-22','13:00:00',6.86),('10318','2013-01-22','13:05:00',2.17),('10318','2013-01-22','13:10:00',3.36),('10318','2013-01-22','13:15:00',6.99),('10318','2013-01-22','13:20:00',3.92),('10318','2013-01-22','13:25:00',2.72),('10318','2013-01-22','13:30:00',1.32),('10318','2013-01-22','13:35:00',1.8),('10318','2013-01-22','13:40:00',4.79),('10318','2013-01-22','13:45:00',3.23),('10318','2013-01-22','13:50:00',1.69),('10318','2013-01-22','13:55:00',1.45),('10318','2013-01-22','14:00:00',3.71),('10318','2013-01-22','14:05:00',1.53),('10318','2013-01-22','14:10:00',4.83),('10318','2013-01-22','14:15:00',4.65),('10318','2013-01-22','14:20:00',3.97),('10318','2013-01-22','14:25:00',2.67),('10318','2013-01-22','14:30:00',1.89),('10318','2013-01-22','14:35:00',2.97),('10318','2013-01-22','14:40:00',3.43),('10318','2013-01-22','14:45:00',3.23),('10318','2013-01-22','14:50:00',1.85),('10318','2013-01-22','14:55:00',1.1),('10318','2013-01-22','15:00:00',2.85),('10318','2013-01-22','15:10:00',1.09),('10318','2013-01-22','15:20:00',1.02),('10318','2013-01-22','15:25:00',1.12),('10318','2013-01-22','15:30:00',1.11),('10318','2014-03-20','07:00:00',1.04),('10318','2014-03-20','07:05:00',1.33),('10318','2014-03-20','07:10:00',1.5),('10318','2014-03-20','07:15:00',1.8),('10318','2014-03-20','07:20:00',2.17),('10318','2014-03-20','07:25:00',2.63),('10318','2014-03-20','07:30:00',2.81),('10318','2014-03-20','07:35:00',3.24),('10318','2014-03-20','07:40:00',3.57),('10318','2014-03-20','07:45:00',3.77),('10318','2014-03-20','07:50:00',4.04),('10318','2014-03-20','07:55:00',4.18),('10318','2014-03-20','08:00:00',4.32),('10318','2014-03-20','08:05:00',4.43),('10318','2014-03-20','08:10:00',4.42),('10318','2014-03-20','08:15:00',4.55),('10318','2014-03-20','08:20:00',4.81),('10318','2014-03-20','08:25:00',5.03),('10318','2014-03-20','08:30:00',5.28),('10318','2014-03-20','08:35:00',5.48),('10318','2014-03-20','08:40:00',5.92),('10318','2014-03-20','08:45:00',6.12),('10318','2014-03-20','08:50:00',6.19),('10318','2014-03-20','08:55:00',6.3),('10318','2014-03-20','09:00:00',6.22),('10318','2014-03-20','09:05:00',6.71),('10318','2014-03-20','09:10:00',6.83),('10318','2014-03-20','09:15:00',6.91),('10318','2014-03-20','09:20:00',7.02),('10318','2014-03-20','09:25:00',7.15),('10318','2014-03-20','09:30:00',7.23),('10318','2014-03-20','09:35:00',7.38),('10318','2014-03-20','09:40:00',7.5),('10318','2014-03-20','09:45:00',7.44),('10318','2014-03-20','09:50:00',7.55),('10318','2014-03-20','09:55:00',7.85),('10318','2014-03-20','10:00:00',7.98),('10318','2014-03-20','10:05:00',8.09),('10318','2014-03-20','10:10:00',8.23),('10318','2014-03-20','10:15:00',8.02),('10318','2014-03-20','10:20:00',7.96),('10318','2014-03-20','10:25:00',8.26),('10318','2014-03-20','10:30:00',8.34),('10318','2014-03-20','10:35:00',8.11),('10318','2014-03-20','10:40:00',8.01),('10318','2014-03-20','10:45:00',7.97),('10318','2014-03-20','10:50:00',8.5),('10318','2014-03-20','10:55:00',8.65),('10318','2014-03-20','11:00:00',8.72),('10318','2014-03-20','11:05:00',8.77),('10318','2014-03-20','11:10:00',8.61),('10318','2014-03-20','11:15:00',8.09),('10318','2014-03-20','11:20:00',8.32),('10318','2014-03-20','11:25:00',8.41),('10318','2014-03-20','11:30:00',8.56),('10318','2014-03-20','11:35:00',8.43),('10318','2014-03-20','11:40:00',8.73),('10318','2014-03-20','11:45:00',8.6),('10318','2014-03-20','11:50:00',8.2),('10318','2014-03-20','11:55:00',7.7),('10318','2014-03-20','12:00:00',7.3),('10318','2014-03-20','12:05:00',7.93),('10318','2014-03-20','12:10:00',8.57),('10318','2014-03-20','12:15:00',8.83),('10318','2014-03-20','12:20:00',8.58),('10318','2014-03-20','12:25:00',8.08),('10318','2014-03-20','12:30:00',8.34),('10318','2014-03-20','12:35:00',8.69),('10318','2014-03-20','12:40:00',8.68),('10318','2014-03-20','12:45:00',8.68),('10318','2014-03-20','12:50:00',8.64),('10318','2014-03-20','12:55:00',8.48),('10318','2014-03-20','13:00:00',8.49),('10318','2014-03-20','13:05:00',8.3),('10318','2014-03-20','13:10:00',8.11),('10318','2014-03-20','13:15:00',8.09),('10318','2014-03-20','13:20:00',8),('10318','2014-03-20','13:25:00',7.75),('10318','2014-03-20','13:30:00',7.72),('10318','2014-03-20','13:35:00',7.63),('10318','2014-03-20','13:40:00',7.28),('10318','2014-03-20','13:45:00',6.82),('10318','2014-03-20','13:50:00',6.48),('10318','2014-03-20','13:55:00',6.2),('10318','2014-03-20','14:00:00',6.55),('10318','2014-03-20','14:05:00',6.58),('10318','2014-03-20','14:10:00',6.33),('10318','2014-03-20','14:15:00',6.36),('10318','2014-03-20','14:20:00',6.24),('10318','2014-03-20','14:25:00',5.84),('10318','2014-03-20','14:30:00',5.16),('10318','2014-03-20','14:35:00',4.87),('10318','2014-03-20','14:40:00',5.22),('10318','2014-03-20','14:45:00',5.12),('10318','2014-03-20','14:50:00',4.83),('10318','2014-03-20','14:55:00',4.6),('10318','2014-03-20','15:00:00',4.64),('10318','2014-03-20','15:05:00',4.51),('10318','2014-03-20','15:10:00',4.66),('10318','2014-03-20','15:15:00',4.42),('10318','2014-03-20','15:20:00',4.28),('10318','2014-03-20','15:25:00',4),('10318','2014-03-20','15:30:00',3.63),('10318','2014-03-20','15:35:00',3.4),('10318','2014-03-20','15:40:00',3.29),('10318','2014-03-20','15:45:00',3.15),('10318','2014-03-20','15:50:00',2.85),('10318','2014-03-20','15:55:00',2.42),('10318','2014-03-20','16:00:00',2.45),('10318','2014-03-20','16:05:00',2.13),('10318','2014-03-20','16:10:00',1.97),('10318','2014-03-20','16:15:00',1.94),('10318','2014-03-20','16:20:00',1.87),('10318','2014-03-20','16:25:00',1.91),('10318','2014-03-20','16:30:00',1.94),('10318','2014-03-20','16:35:00',1.89),('10318','2014-03-20','16:40:00',1.72),('10318','2014-03-20','16:45:00',1.31),('10318','2014-03-20','16:50:00',1.08),('10318','2013-01-21','10:00:00',1.02),('10318','2013-01-21','10:05:00',1.37),('10318','2013-01-21','10:10:00',1.84),('10318','2013-01-21','10:15:00',1.6),('10318','2013-01-21','10:20:00',1.4),('10318','2013-01-21','10:25:00',1.64),('10318','2013-01-21','10:30:00',1.39),('10318','2013-01-21','10:35:00',1.28),('10318','2013-01-21','10:40:00',1.32),('10318','2013-01-21','10:45:00',1.5),('10318','2013-01-21','10:50:00',1.66),('10318','2013-01-21','10:55:00',1.8),('10318','2013-01-21','11:00:00',1.87),('10318','2013-01-21','11:05:00',2.22),('10318','2013-01-21','11:10:00',2.62),('10318','2013-01-21','11:15:00',3.33),('10318','2013-01-21','11:20:00',2.8),('10318','2013-01-21','11:25:00',1.99),('10318','2013-01-21','11:30:00',1.74),('10318','2013-01-21','11:35:00',1.21),('10318','2013-01-21','11:40:00',2.02),('10318','2013-01-21','11:45:00',2.25),('10318','2013-01-21','11:50:00',6.53),('10318','2013-01-21','11:55:00',7.71),('10318','2013-01-21','12:00:00',7.24),('10318','2013-01-21','12:05:00',7.22),('10318','2013-01-21','12:10:00',5.09),('10318','2013-01-21','12:15:00',5.34),('10318','2013-01-21','12:20:00',3.39),('10318','2013-01-21','12:25:00',2.49),('10318','2013-01-21','12:30:00',1.72),('10318','2013-01-21','12:35:00',2.9),('10318','2013-01-21','12:40:00',1.74),('10318','2013-01-21','12:45:00',2.06),('10318','2013-01-21','12:50:00',1.78),('10318','2013-01-21','12:55:00',1.48),('10318','2013-01-21','13:00:00',2.7),('10318','2013-01-21','13:05:00',3.16),('10318','2013-01-21','13:10:00',2.59),('10318','2013-01-21','13:15:00',1.55),('10318','2013-01-21','13:20:00',1.78),('10318','2013-01-21','13:25:00',4.37),('10318','2013-01-21','13:30:00',5.78),('10318','2013-01-21','13:35:00',5.47),('10318','2013-01-21','13:40:00',4.51),('10318','2013-01-21','13:45:00',1.85),('10318','2013-01-21','13:50:00',2.62),('10318','2013-01-21','13:55:00',6.38),('10318','2013-01-21','14:00:00',4.16),('10318','2013-01-21','14:05:00',4.15),('10318','2013-01-21','14:10:00',4.28),('10318','2013-01-21','14:15:00',5.64),('10318','2013-01-21','14:20:00',5.01),('10318','2013-01-21','14:25:00',4.52),('10318','2013-01-21','14:30:00',1.79),('10318','2013-01-21','14:35:00',1.22),('10318','2013-01-21','14:40:00',1.35),('10318','2013-01-21','14:45:00',1.08),('10318','2013-01-21','14:50:00',1.14),('10318','2013-01-21','14:55:00',1.02),('10318','2013-01-21','15:00:00',1.03),('10318','2013-01-21','15:35:00',1),('10318','2013-01-21','15:40:00',1.34),('10318','2013-01-20','08:30:00',1.38),('10318','2013-01-20','08:35:00',1.56),('10318','2013-01-20','08:40:00',1.39),('10318','2013-01-20','08:45:00',1.09),('10318','2013-01-20','09:00:00',1.04),('10318','2013-01-20','09:05:00',1.15),('10318','2013-01-20','10:00:00',1.18),('10318','2013-01-20','10:05:00',1.11),('10318','2013-01-20','10:20:00',1.02),('10318','2013-01-20','10:25:00',1.28),('10318','2013-01-20','10:30:00',1.39),('10318','2013-01-20','10:35:00',1.29),('10318','2013-01-20','10:40:00',1.53),('10318','2013-01-20','10:45:00',1.77),('10318','2013-01-20','10:50:00',1.97),('10318','2013-01-20','10:55:00',2.14),('10318','2013-01-20','11:00:00',2.65),('10318','2013-01-20','11:05:00',2.6),('10318','2013-01-20','11:10:00',3.21),('10318','2013-01-20','11:15:00',4.2),('10318','2013-01-20','11:20:00',3.14),('10318','2013-01-20','11:25:00',4.44),('10318','2013-01-20','11:30:00',5.23),('10318','2013-01-20','11:35:00',3.95),('10318','2013-01-20','11:40:00',2.15),('10318','2013-01-20','11:45:00',2.01),('10318','2013-01-20','11:50:00',1.6),('10318','2013-01-20','11:55:00',1.2),('10318','2013-01-20','12:00:00',1.17),('10318','2013-01-20','12:05:00',1.19),('10318','2013-01-20','12:10:00',1.51),('10318','2013-01-20','12:15:00',1.85),('10318','2013-01-20','12:20:00',2.03),('10318','2013-01-20','12:25:00',2.06),('10318','2013-01-20','12:30:00',1.87),('10318','2013-01-20','12:35:00',1.72),('10318','2013-01-20','12:40:00',1.54),('10318','2013-01-20','12:45:00',1.51),('10318','2013-01-20','12:50:00',1.53),('10318','2013-01-20','12:55:00',1.51),('10318','2013-01-20','13:00:00',1.37),('10318','2013-01-20','13:05:00',1.36),('10318','2013-01-20','13:10:00',1.45),('10318','2013-01-20','13:15:00',1.62),('10318','2013-01-20','13:20:00',1.58),('10318','2013-01-20','13:25:00',1.5),('10318','2013-01-20','13:30:00',1.49),('10318','2013-01-20','13:35:00',1.76),('10318','2013-01-20','13:40:00',1.92),('10318','2013-01-20','13:45:00',1.88),('10318','2013-01-20','13:50:00',1.8),('10318','2013-01-20','13:55:00',1.57),('10318','2013-01-20','14:00:00',1.41),('10318','2013-01-20','14:05:00',1.26),('10318','2013-01-20','14:10:00',1.18),('10318','2013-01-20','14:15:00',1.35),('10318','2013-01-20','14:20:00',1.52),('10318','2013-01-20','14:25:00',1.32),('10318','2013-01-20','14:30:00',1.07),('10318','2013-01-19','08:45:00',1.13),('10318','2013-01-19','08:50:00',1.26),('10318','2013-01-19','08:55:00',1.35),('10318','2013-01-19','09:00:00',1.56),('10318','2013-01-19','09:05:00',1.74),('10318','2013-01-19','09:10:00',2.06),('10318','2013-01-19','09:15:00',3.64),('10318','2013-01-19','09:20:00',3.56),('10318','2013-01-19','09:25:00',2.19),('10318','2013-01-19','09:30:00',1.61),('10318','2013-01-19','09:35:00',1.43),('10318','2013-01-19','09:40:00',1.33),('10318','2013-01-19','09:45:00',2),('10318','2013-01-19','09:50:00',2.74),('10318','2013-01-19','09:55:00',3.63),('10318','2013-01-19','10:00:00',2.94),('10318','2013-01-19','10:05:00',2.19),('10318','2013-01-19','10:10:00',1.43),('10318','2013-01-19','10:15:00',1.05),('10318','2013-01-19','10:20:00',1.02),('10318','2013-01-19','10:25:00',1.3),('10318','2013-01-19','10:30:00',1.37),('10318','2013-01-19','10:35:00',2.3),('10318','2013-01-19','10:40:00',2.45),('10318','2013-01-19','10:45:00',3.26),('10318','2013-01-19','10:50:00',2.37),('10318','2013-01-19','10:55:00',1.47),('10318','2013-01-19','11:00:00',1.75),('10318','2013-01-19','11:05:00',1.71),('10318','2013-01-19','11:10:00',1.86),('10318','2013-01-19','11:15:00',2.19),('10318','2013-01-19','11:20:00',2.77),('10318','2013-01-19','11:25:00',2.43),('10318','2013-01-19','11:30:00',1.92),('10318','2013-01-19','11:35:00',1.43),('10318','2013-01-19','11:40:00',1.04),('10318','2013-01-19','11:45:00',1.26),('10318','2013-01-19','11:50:00',1.54),('10318','2013-01-19','11:55:00',1.28),('10318','2013-01-19','12:05:00',1.31),('10318','2013-01-19','12:10:00',1.55),('10318','2013-01-19','12:15:00',1.48),('10318','2013-01-19','12:20:00',1.36),('10318','2013-01-19','12:25:00',1.15),('10318','2013-01-19','14:25:00',1.04),('10318','2013-01-19','14:30:00',1.58),('10318','2013-01-19','14:35:00',1.04),('10318','2013-01-18','08:40:00',1.15),('10318','2013-01-18','08:45:00',1.48),('10318','2013-01-18','08:50:00',1.58),('10318','2013-01-18','08:55:00',1.92),('10318','2013-01-18','09:00:00',1.14),('10318','2013-01-18','09:30:00',1.05),('10318','2013-01-18','09:35:00',1.11),('10318','2013-01-18','09:50:00',1.14),('10318','2013-01-18','09:55:00',1.29),('10318','2013-01-18','10:00:00',1.34),('10318','2013-01-18','10:05:00',1.54),('10318','2013-01-18','10:10:00',2.36),('10318','2013-01-18','10:15:00',7.74),('10318','2013-01-18','10:20:00',5.87),('10318','2013-01-18','10:25:00',3.97),('10318','2013-01-18','10:30:00',2.78),('10318','2013-01-18','10:35:00',2.36),('10318','2013-01-18','10:40:00',1.8),('10318','2013-01-18','10:45:00',1.68),('10318','2013-01-18','10:50:00',1.72),('10318','2013-01-18','10:55:00',1.78),('10318','2013-01-18','11:00:00',1.84),('10318','2013-01-18','11:05:00',2.02),('10318','2013-01-18','11:10:00',1.87),('10318','2013-01-18','11:15:00',1.82),('10318','2013-01-18','11:20:00',1.71),('10318','2013-01-18','11:25:00',2.12),('10318','2013-01-18','11:30:00',2.61),('10318','2013-01-18','11:35:00',2.89),('10318','2013-01-18','11:40:00',2.38),('10318','2013-01-18','11:45:00',1.98),('10318','2013-01-18','11:50:00',1.81),('10318','2013-01-18','11:55:00',1.96),('10318','2013-01-18','12:00:00',2.05),('10318','2013-01-18','12:05:00',2.11),('10318','2013-01-18','12:10:00',2.33),('10318','2013-01-18','12:15:00',2.43),('10318','2013-01-18','12:20:00',2.53),('10318','2013-01-18','12:25:00',2.5),('10318','2013-01-18','12:30:00',2.65),('10318','2013-01-18','12:35:00',3.26),('10318','2013-01-18','12:40:00',2.99),('10318','2013-01-18','12:45:00',3.37),('10318','2013-01-18','12:50:00',4.38),('10318','2013-01-18','12:55:00',5.24),('10318','2013-01-18','13:00:00',6.28),('10318','2013-01-18','13:05:00',5.96),('10318','2013-01-18','13:10:00',6.15),('10318','2013-01-18','13:15:00',5.76),('10318','2013-01-18','13:20:00',4.75),('10318','2013-01-18','13:25:00',3.87),('10318','2013-01-18','13:30:00',2.96),('10318','2013-01-18','13:35:00',2.79),('10318','2013-01-18','13:40:00',5.96),('10318','2013-01-18','13:45:00',6.74),('10318','2013-01-18','13:50:00',3.9),('10318','2013-01-18','13:55:00',6.3),('10318','2013-01-18','14:00:00',6.42),('10318','2013-01-18','14:05:00',5.89),('10318','2013-01-18','14:10:00',5.85),('10318','2013-01-18','14:15:00',6.48),('10318','2013-01-18','14:20:00',6.12),('10318','2013-01-18','14:25:00',3.65),('10318','2013-01-18','14:30:00',2.53),('10318','2013-01-18','14:35:00',2.15),('10318','2013-01-18','14:40:00',2.05),('10318','2013-01-18','14:45:00',2.01),('10318','2013-01-18','14:50:00',2.56),('10318','2013-01-18','14:55:00',2.55),('10318','2013-01-18','15:00:00',2.03),('10318','2013-01-18','15:05:00',1.99),('10318','2013-01-18','15:10:00',2.07),('10318','2013-01-18','15:15:00',1.99),('10318','2013-01-18','15:20:00',1.66),('10318','2013-01-18','15:25:00',1.7),('10318','2013-01-18','15:30:00',1.35),('10318','2013-01-18','15:35:00',1.93),('10318','2013-01-18','15:40:00',1.69),('10318','2013-01-18','15:45:00',2.14),('10318','2013-01-18','15:50:00',2.11),('10318','2013-01-18','15:55:00',2.12),('10318','2013-01-18','16:00:00',1.95),('10318','2013-01-18','16:05:00',1.8),('10318','2013-01-18','16:10:00',1.81),('10318','2013-01-18','16:15:00',1.65),('10318','2013-01-18','16:20:00',1.36),('10318','2013-01-18','16:25:00',1.19),('10318','2013-01-17','09:00:00',1.04),('10318','2013-01-17','09:05:00',1.45),('10318','2013-01-17','09:10:00',1.74),('10318','2013-01-17','09:15:00',1.73),('10318','2013-01-17','09:20:00',1.65),('10318','2013-01-17','09:25:00',1.54),('10318','2013-01-17','09:30:00',1.84),('10318','2013-01-17','09:35:00',1.86),('10318','2013-01-17','09:40:00',2.19),('10318','2013-01-17','09:45:00',3.15),('10318','2013-01-17','09:50:00',4.01),('10318','2013-01-17','09:55:00',3.46),('10318','2013-01-17','10:00:00',2.43),('10318','2013-01-17','10:05:00',2.45),('10318','2013-01-17','10:10:00',2.87),('10318','2013-01-17','10:15:00',3.48),('10318','2013-01-17','10:20:00',3.82),('10318','2013-01-17','10:25:00',3.97),('10318','2013-01-17','10:30:00',4.2),('10318','2013-01-17','10:35:00',4.03),('10318','2013-01-17','10:40:00',3.89),('10318','2013-01-17','10:45:00',3.83),('10318','2013-01-17','10:50:00',3.6),('10318','2013-01-17','10:55:00',3.98),('10318','2013-01-17','11:00:00',3.52),('10318','2013-01-17','11:05:00',4.16),('10318','2013-01-17','11:10:00',4.55),('10318','2013-01-17','11:15:00',4.61),('10318','2013-01-17','11:20:00',4.19),('10318','2013-01-17','11:25:00',3.6),('10318','2013-01-17','11:30:00',3.13),('10318','2013-01-17','11:35:00',3.7),('10318','2013-01-17','11:40:00',4),('10318','2013-01-17','11:45:00',3.76),('10318','2013-01-17','11:50:00',3.82),('10318','2013-01-17','11:55:00',3.94),('10318','2013-01-17','12:00:00',4.2),('10318','2013-01-17','12:05:00',4.34),('10318','2013-01-17','12:10:00',3.84),('10318','2013-01-17','12:15:00',4.38),('10318','2013-01-17','12:20:00',4.91),('10318','2013-01-17','12:25:00',3.68),('10318','2013-01-17','12:30:00',3),('10318','2013-01-17','12:35:00',3.4),('10318','2013-01-17','12:40:00',2.68),('10318','2013-01-17','12:45:00',2.32),('10318','2013-01-17','12:50:00',2.23),('10318','2013-01-17','12:55:00',2.8),('10318','2013-01-17','13:00:00',2.99),('10318','2013-01-17','13:05:00',3.18),('10318','2013-01-17','13:10:00',3.13),('10318','2013-01-17','13:15:00',3),('10318','2013-01-17','13:20:00',3.12),('10318','2013-01-17','13:25:00',3.29),('10318','2013-01-17','13:30:00',2.53),('10318','2013-01-17','13:35:00',2.43),('10318','2013-01-17','13:40:00',4.02),('10318','2013-01-17','13:45:00',5.66),('10318','2013-01-17','13:50:00',4.54),('10318','2013-01-17','13:55:00',3.63),('10318','2013-01-17','14:00:00',2.86),('10318','2013-01-17','14:05:00',2.24),('10318','2013-01-17','14:10:00',1.83),('10318','2013-01-17','14:15:00',2.14),('10318','2013-01-17','14:20:00',2.27),('10318','2013-01-17','14:25:00',2.54),('10318','2013-01-17','14:30:00',2.64),('10318','2013-01-17','14:35:00',2.09),('10318','2013-01-17','14:40:00',1.09),('10318','2013-01-17','14:50:00',1.43),('10318','2013-01-17','14:55:00',1.95),('10318','2013-01-17','15:00:00',1.68),('10318','2013-01-17','15:05:00',1.4),('10318','2013-01-17','15:20:00',1.05),('10318','2013-01-17','15:25:00',1.04),('10318','2013-01-16','08:40:00',1.15),('10318','2013-01-16','09:10:00',2.8),('10318','2013-01-16','09:15:00',3.45),('10318','2013-01-16','09:20:00',3.6),('10318','2013-01-16','09:25:00',5.26),('10318','2013-01-16','09:30:00',5.37),('10318','2013-01-16','09:35:00',5.5),('10318','2013-01-16','09:40:00',4.28),('10318','2013-01-16','09:45:00',2.78),('10318','2013-01-16','09:50:00',1.31),('10318','2013-01-16','09:55:00',2.08),('10318','2013-01-16','10:00:00',1.33),('10318','2013-01-16','10:20:00',1.19),('10318','2013-01-16','10:25:00',1.44),('10318','2013-01-16','10:30:00',2.69),('10318','2013-01-16','10:35:00',5.76),('10318','2013-01-16','10:40:00',7.01),('10318','2013-01-16','10:45:00',4.13),('10318','2013-01-16','10:50:00',5.79),('10318','2013-01-16','10:55:00',3.85),('10318','2013-01-16','11:00:00',1.67),('10318','2013-01-16','11:05:00',1.5),('10318','2013-01-16','12:00:00',3.7),('10318','2013-01-16','12:05:00',3.58),('10318','2013-01-16','12:10:00',7.29),('10318','2013-01-16','12:15:00',8.58),('10318','2013-01-16','12:20:00',6.24),('10318','2013-01-16','12:25:00',1.24),('10318','2013-01-16','13:00:00',1.01),('10318','2013-01-16','13:05:00',5.58),('10318','2013-01-16','13:10:00',5),('10318','2013-01-16','13:15:00',8.07),('10318','2013-01-16','13:20:00',5.68),('10318','2013-01-16','13:25:00',2.02),('10318','2013-01-16','13:30:00',1.22),('10318','2013-01-16','13:50:00',3.46),('10318','2013-01-16','13:55:00',6.94),('10318','2013-01-16','14:00:00',2.36),('10318','2013-01-16','15:00:00',1.89),('10318','2013-01-16','15:05:00',1.76),('10318','2013-01-16','15:10:00',1.79),('10318','2013-01-16','16:00:00',1.73),('10318','2013-01-16','16:05:00',1.86),('10318','2013-01-16','16:10:00',1.44),('10318','2013-01-16','16:15:00',1.29),('10318','2013-01-15','08:10:00',1.2),('10318','2013-01-15','08:15:00',1.4),('10318','2013-01-15','08:20:00',1.21),('10318','2013-01-15','08:25:00',1.26),('10318','2013-01-15','08:30:00',1.67),('10318','2013-01-15','08:35:00',1.34),('10318','2013-01-15','08:40:00',1.63),('10318','2013-01-15','08:45:00',1.06),('10318','2013-01-15','08:55:00',1.48),('10318','2013-01-15','09:00:00',1.2),('10318','2013-01-15','09:05:00',1.25),('10318','2013-01-15','09:10:00',1.43),('10318','2013-01-15','09:15:00',1.63),('10318','2013-01-15','09:20:00',1.15),('10318','2013-01-15','09:50:00',1.19),('10318','2013-01-15','09:55:00',2.15),('10318','2013-01-15','10:00:00',2.61),('10318','2013-01-15','10:05:00',1.53),('10318','2013-01-15','10:10:00',1.78),('10318','2013-01-15','10:15:00',1.71),('10318','2013-01-15','10:20:00',1.91),('10318','2013-01-15','10:25:00',2.76),('10318','2013-01-15','10:30:00',2.05),('10318','2013-01-15','10:35:00',2.02),('10318','2013-01-15','10:40:00',2.22),('10318','2013-01-15','10:45:00',2.54),('10318','2013-01-15','10:50:00',3.25),('10318','2013-01-15','10:55:00',3.86),('10318','2013-01-15','11:00:00',3.51),('10318','2013-01-15','11:05:00',3.64),('10318','2013-01-15','11:10:00',4.08),('10318','2013-01-15','11:15:00',3.86),('10318','2013-01-15','11:20:00',3.74),('10318','2013-01-15','11:25:00',3.52),('10318','2013-01-15','11:30:00',3.23),('10318','2013-01-15','11:35:00',2.82),('10318','2013-01-15','11:40:00',2.66),('10318','2013-01-15','11:45:00',2.54),('10318','2013-01-15','11:50:00',2.53),('10318','2013-01-15','11:55:00',2.67),('10318','2013-01-15','12:00:00',2.39),('10318','2013-01-15','12:05:00',2.24),('10318','2013-01-15','12:10:00',2.36),('10318','2013-01-15','12:15:00',2.56),('10318','2013-01-15','12:20:00',2.82),('10318','2013-01-15','12:25:00',2.99),('10318','2013-01-15','12:30:00',2.93),('10318','2013-01-15','12:35:00',3.04),('10318','2013-01-15','12:40:00',3.31),('10318','2013-01-15','12:45:00',3.46),('10318','2013-01-15','12:50:00',3.4),('10318','2013-01-15','12:55:00',2.77),('10318','2013-01-15','13:00:00',2.43),('10318','2013-01-15','13:05:00',2.49),('10318','2013-01-15','13:10:00',2.55),('10318','2013-01-15','13:15:00',2.53),('10318','2013-01-15','13:20:00',2.46),('10318','2013-01-15','13:25:00',2.4),('10318','2013-01-15','13:30:00',2.62),('10318','2013-01-15','13:35:00',2.86),('10318','2013-01-15','13:40:00',3.14),('10318','2013-01-15','13:45:00',2.76),('10318','2013-01-15','13:50:00',2.52),('10318','2013-01-15','13:55:00',3),('10318','2013-01-15','14:00:00',2.83),('10318','2013-01-15','14:05:00',2.46),('10318','2013-01-15','14:10:00',3.71),('10318','2013-01-15','14:15:00',4.7),('10318','2013-01-15','14:20:00',5.85),('10318','2013-01-15','14:25:00',5.08),('10318','2013-01-15','14:30:00',5.11),('10318','2013-01-15','14:35:00',4.94),('10318','2013-01-15','14:40:00',4.73),('10318','2013-01-15','14:45:00',4.05),('10318','2013-01-15','14:50:00',2.5),('10318','2013-01-15','14:55:00',3.25),('10318','2013-01-15','15:00:00',3.85),('10318','2013-01-15','15:05:00',3.82),('10318','2013-01-15','15:10:00',3.61),('10318','2013-01-15','15:15:00',3.18),('10318','2013-01-15','15:20:00',2.91),('10318','2013-01-15','15:25:00',2.83),('10318','2013-01-15','15:30:00',2.71),('10318','2013-01-15','15:35:00',2.56),('10318','2013-01-15','15:40:00',2.04),('10318','2013-01-15','15:45:00',1.67),('10318','2013-01-15','15:50:00',1.66),('10318','2013-01-15','15:55:00',1.98),('10318','2013-01-15','16:00:00',2.06),('10318','2013-01-15','16:05:00',2.3),('10318','2013-01-15','16:10:00',2.04),('10318','2013-01-15','16:15:00',1.85),('10318','2013-01-15','16:20:00',1.62),('10318','2013-01-15','16:25:00',1.37),('10318','2013-01-15','16:30:00',1.15),('10318','2013-01-14','09:50:00',1.18),('10318','2013-01-14','10:25:00',1.33),('10318','2013-01-14','10:35:00',1.2),('10318','2013-01-14','10:45:00',1.02),('10318','2013-01-14','10:55:00',1.06),('10318','2013-01-14','11:05:00',1.22),('10318','2013-01-14','11:10:00',1.06),('10318','2013-01-14','11:20:00',1.45),('10318','2013-01-14','11:25:00',1.36),('10318','2013-01-14','11:30:00',1.18),('10318','2013-01-14','11:35:00',1.14),('10318','2013-01-14','11:40:00',1.19),('10318','2013-01-14','11:45:00',1.03),('10318','2013-01-14','11:50:00',1.25),('10318','2013-01-14','11:55:00',1.11),('10318','2013-01-14','12:15:00',1.34),('10318','2013-01-14','12:20:00',1.59),('10318','2013-01-14','12:25:00',1.94),('10318','2013-01-14','12:30:00',1.99),('10318','2013-01-14','12:35:00',1.63),('10318','2013-01-14','12:40:00',2.02),('10318','2013-01-14','12:45:00',2.29),('10318','2013-01-14','12:50:00',2.39),('10318','2013-01-14','12:55:00',2.57),('10318','2013-01-14','13:00:00',2.59),('10318','2013-01-14','13:05:00',2.4),('10318','2013-01-14','13:10:00',1.62),('10318','2013-01-14','13:15:00',1.46),('10318','2013-01-14','13:20:00',1.13),('10318','2013-01-14','13:30:00',1.11),('10318','2013-01-14','13:35:00',1.4),('10318','2013-01-14','15:10:00',1.64),('10318','2013-01-14','15:15:00',1.78),('10318','2013-01-14','15:20:00',1.83),('10318','2013-01-14','15:25:00',1.57),('10318','2013-01-13','09:10:00',1.46),('10318','2013-01-13','09:15:00',4.53),('10318','2013-01-13','09:20:00',4.55),('10318','2013-01-13','09:25:00',4.51),('10318','2013-01-13','09:30:00',3.91),('10318','2013-01-13','09:35:00',4.15),('10318','2013-01-13','09:40:00',3.84),('10318','2013-01-13','09:45:00',3.21),('10318','2013-01-13','09:50:00',3.88),('10318','2013-01-13','09:55:00',5.02),('10318','2013-01-13','10:00:00',5.26),('10318','2013-01-13','10:05:00',5.85),('10318','2013-01-13','10:10:00',5.79),('10318','2013-01-13','10:15:00',6.14),('10318','2013-01-13','10:20:00',4.48),('10318','2013-01-13','10:25:00',7.84),('10318','2013-01-13','10:30:00',3.29),('10318','2013-01-13','10:35:00',1.95),('10318','2013-01-13','10:40:00',1.84),('10318','2013-01-13','10:45:00',1.21),('10318','2013-01-13','12:05:00',1.01),('10318','2013-01-13','12:10:00',1.15),('10318','2013-01-13','12:15:00',1.36),('10318','2013-01-13','12:20:00',1.41),('10318','2013-01-13','12:35:00',1.08),('10318','2013-01-13','12:40:00',1.25),('10318','2013-01-12','08:05:00',1.01),('10318','2013-01-12','08:10:00',1.37),('10318','2013-01-12','08:15:00',1.67),('10318','2013-01-12','08:20:00',1.93),('10318','2013-01-12','08:25:00',2.28),('10318','2013-01-12','08:30:00',2.52),('10318','2013-01-12','08:35:00',2.78),('10318','2013-01-12','08:40:00',3.15),('10318','2013-01-12','08:45:00',3.32),('10318','2013-01-12','08:50:00',3.55),('10318','2013-01-12','08:55:00',3.74),('10318','2013-01-12','09:00:00',3.97),('10318','2013-01-12','09:05:00',4.18),('10318','2013-01-12','09:10:00',4.38),('10318','2013-01-12','09:15:00',4.54),('10318','2013-01-12','09:20:00',4.66),('10318','2013-01-12','09:25:00',4.8),('10318','2013-01-12','09:30:00',4.94),('10318','2013-01-12','09:35:00',5.09),('10318','2013-01-12','09:40:00',5.24),('10318','2013-01-12','09:45:00',5.4),('10318','2013-01-12','09:50:00',5.54),('10318','2013-01-12','09:55:00',5.63),('10318','2013-01-12','10:00:00',5.75),('10318','2013-01-12','10:05:00',5.84),('10318','2013-01-12','10:10:00',5.94),('10318','2013-01-12','10:15:00',6.03),('10318','2013-01-12','10:20:00',6.03),('10318','2013-01-12','10:25:00',6.19),('10318','2013-01-12','10:30:00',6.3),('10318','2013-01-12','10:35:00',6.4),('10318','2013-01-12','10:40:00',6.38),('10318','2013-01-12','10:45:00',6.47),('10318','2013-01-12','10:50:00',6.51),('10318','2013-01-12','10:55:00',6.58),('10318','2013-01-12','11:00:00',6.6),('10318','2013-01-12','11:05:00',6.7),('10318','2013-01-12','11:10:00',6.65),('10318','2013-01-12','11:15:00',6.66),('10318','2013-01-12','11:20:00',6.58),('10318','2013-01-12','11:25:00',6.7),('10318','2013-01-12','11:30:00',6.74),('10318','2013-01-12','11:35:00',6.72),('10318','2013-01-12','11:40:00',6.73),('10318','2013-01-12','11:45:00',6.67),('10318','2013-01-12','11:50:00',6.61),('10318','2013-01-12','11:55:00',6.55),('10318','2013-01-12','12:00:00',6.44),('10318','2013-01-12','12:05:00',6.41),('10318','2013-01-12','12:10:00',6.27),('10318','2013-01-12','12:15:00',6.33),('10318','2013-01-12','12:20:00',6.27),('10318','2013-01-12','12:25:00',6.39),('10318','2013-01-12','12:30:00',6.27),('10318','2013-01-12','12:35:00',6.22),('10318','2013-01-12','12:40:00',3.22),('10318','2013-01-12','12:45:00',2.26),('10318','2013-01-12','12:50:00',4.23),('10318','2013-01-12','12:55:00',5.77),('10318','2013-01-12','13:00:00',6.13),('10318','2013-01-12','13:05:00',6.02),('10318','2013-01-12','13:10:00',5.62),('10318','2013-01-12','13:15:00',5.25),('10318','2013-01-12','13:20:00',5.31),('10318','2013-01-12','13:25:00',4.67),('10318','2013-01-12','13:30:00',5.93),('10318','2013-01-12','13:35:00',5.76),('10318','2013-01-12','13:40:00',4.6),('10318','2013-01-12','13:45:00',2.69),('10318','2013-01-12','13:50:00',2.48),('10318','2013-01-12','13:55:00',5.75),('10318','2013-01-12','14:00:00',5.03),('10318','2013-01-12','14:05:00',5.01),('10318','2013-01-12','14:10:00',5.21),('10318','2013-01-12','14:15:00',4.24),('10318','2013-01-12','14:20:00',4.43),('10318','2013-01-12','14:25:00',4.25),('10318','2013-01-12','14:30:00',4.14),('10318','2013-01-12','14:35:00',4.02),('10318','2013-01-12','14:40:00',3.9),('10318','2013-01-12','14:45:00',3.71),('10318','2013-01-12','14:50:00',3.5),('10318','2013-01-12','14:55:00',3.36),('10318','2013-01-12','15:00:00',3.17),('10318','2013-01-12','15:05:00',3.05),('10318','2013-01-12','15:10:00',2.87),('10318','2013-01-12','15:15:00',2.86),('10318','2013-01-12','15:20:00',2.1),('10318','2013-01-12','15:25:00',2.35),('10318','2013-01-12','15:30:00',1.36),('10318','2013-01-12','15:35:00',2.18),('10318','2013-01-12','15:40:00',1.99),('10318','2013-01-12','15:45:00',1.95),('10318','2013-01-12','15:50:00',1.82),('10318','2013-01-12','15:55:00',1.68),('10318','2013-01-12','16:00:00',1.53),('10318','2013-01-12','16:05:00',1.36),('10318','2013-01-12','16:10:00',1.18),('10318','2014-03-19','07:55:00',1.25),('10318','2014-03-19','08:00:00',1.36),('10318','2014-03-19','08:05:00',1.08),('10318','2014-03-19','08:10:00',1.16),('10318','2014-03-19','08:15:00',1.22),('10318','2014-03-19','08:20:00',1.42),('10318','2014-03-19','08:25:00',1.56),('10318','2014-03-19','08:30:00',1.78),('10318','2014-03-19','08:35:00',1.86),('10318','2014-03-19','08:40:00',2.14),('10318','2014-03-19','08:45:00',2.32),('10318','2014-03-19','08:50:00',2.43),('10318','2014-03-19','08:55:00',2.57),('10318','2014-03-19','09:00:00',2.55),('10318','2014-03-19','09:05:00',2.55),('10318','2014-03-19','09:10:00',2.75),('10318','2014-03-19','09:15:00',3.06),('10318','2014-03-19','09:20:00',3.31),('10318','2014-03-19','09:25:00',4),('10318','2014-03-19','09:30:00',4.41),('10318','2014-03-19','09:35:00',5.63),('10318','2014-03-19','09:40:00',5.84),('10318','2014-03-19','09:45:00',4.56),('10318','2014-03-19','09:50:00',3.64),('10318','2014-03-19','09:55:00',3.32),('10318','2014-03-19','10:00:00',7.08),('10318','2014-03-19','10:05:00',6.14),('10318','2014-03-19','10:10:00',3.52),('10318','2014-03-19','10:15:00',3.01),('10318','2014-03-19','10:20:00',3.16),('10318','2014-03-19','10:25:00',4.3),('10318','2014-03-19','10:30:00',6.55),('10318','2014-03-19','10:35:00',7.58),('10318','2014-03-19','10:40:00',4.58),('10318','2014-03-19','10:45:00',4.18),('10318','2014-03-19','10:50:00',3.82),('10318','2014-03-19','10:55:00',3.37),('10318','2014-03-19','11:00:00',2.84),('10318','2014-03-19','11:05:00',2.7),('10318','2014-03-19','11:10:00',3.24),('10318','2014-03-19','11:15:00',3.71),('10318','2014-03-19','11:20:00',6.43),('10318','2014-03-19','11:25:00',7.49),('10318','2014-03-19','11:30:00',8.57),('10318','2014-03-19','11:35:00',10.25),('10318','2014-03-19','11:40:00',10.07),('10318','2014-03-19','11:45:00',5.08),('10318','2014-03-19','11:50:00',4.29),('10318','2014-03-19','11:55:00',5.24),('10318','2014-03-19','12:00:00',8),('10318','2014-03-19','12:05:00',9.47),('10318','2014-03-19','12:10:00',7.82),('10318','2014-03-19','12:15:00',8.02),('10318','2014-03-19','12:20:00',6.6),('10318','2014-03-19','12:25:00',9.01),('10318','2014-03-19','12:30:00',8.29),('10318','2014-03-19','12:35:00',8.33),('10318','2014-03-19','12:40:00',8.75),('10318','2014-03-19','12:45:00',8.44),('10318','2014-03-19','12:50:00',8.82),('10318','2014-03-19','12:55:00',6.56),('10318','2014-03-19','13:00:00',8.34),('10318','2014-03-19','13:05:00',8),('10318','2014-03-19','13:10:00',8.62),('10318','2014-03-19','13:15:00',8.02),('10318','2014-03-19','13:20:00',6.91),('10318','2014-03-19','13:25:00',7.56),('10318','2014-03-19','13:30:00',7.97),('10318','2014-03-19','13:35:00',7.88),('10318','2014-03-19','13:40:00',7.74),('10318','2014-03-19','13:45:00',7.52),('10318','2014-03-19','13:50:00',7.05),('10318','2014-03-19','13:55:00',7.49),('10318','2014-03-19','14:00:00',7.22),('10318','2014-03-19','14:05:00',7.09),('10318','2014-03-19','14:10:00',6.96),('10318','2014-03-19','14:15:00',6.66),('10318','2014-03-19','14:20:00',6.7),('10318','2014-03-19','14:25:00',6.62),('10318','2014-03-19','14:30:00',6.45),('10318','2014-03-19','14:35:00',6.52),('10318','2014-03-19','14:40:00',6.35),('10318','2014-03-19','14:45:00',6.18),('10318','2014-03-19','14:50:00',6.03),('10318','2014-03-19','14:55:00',5.77),('10318','2014-03-19','15:00:00',5.59),('10318','2014-03-19','15:05:00',5.44),('10318','2014-03-19','15:10:00',5.35),('10318','2014-03-19','15:15:00',5.23),('10318','2014-03-19','15:20:00',4.99),('10318','2014-03-19','15:25:00',4.85),('10318','2014-03-19','15:30:00',4.58),('10318','2014-03-19','15:35:00',4.4),('10318','2014-03-19','15:40:00',4.32),('10318','2014-03-19','15:45:00',4.14),('10318','2014-03-19','15:50:00',3.92),('10318','2014-03-19','15:55:00',3.8),('10318','2014-03-19','16:00:00',3.58),('10318','2014-03-19','16:05:00',3.45),('10318','2014-03-19','16:10:00',3.3),('10318','2014-03-19','16:15:00',3.13),('10318','2014-03-19','16:20:00',2.91),('10318','2014-03-19','16:25:00',2.69),('10318','2014-03-19','16:30:00',2.44),('10318','2014-03-19','16:35:00',2.21),('10318','2014-03-19','16:40:00',2.01),('10318','2014-03-19','16:45:00',1.9),('10318','2014-03-19','16:50:00',1.6),('10318','2014-03-19','16:55:00',1.52),('10318','2014-03-19','17:00:00',1.2),('10318','2014-03-19','17:05:00',1.01),('10318','2013-01-11','09:15:00',1.24),('10318','2013-01-11','09:20:00',1.23),('10318','2013-01-11','09:25:00',1.15),('10318','2013-01-11','09:30:00',1.3),('10318','2013-01-11','09:35:00',1.3),('10318','2013-01-11','09:40:00',1.43),('10318','2013-01-11','09:45:00',3.49),('10318','2013-01-11','09:50:00',3.59),('10318','2013-01-11','09:55:00',2.67),('10318','2013-01-11','10:00:00',1.81),('10318','2013-01-11','10:05:00',3.57),('10318','2013-01-11','10:10:00',7.21),('10318','2013-01-11','10:15:00',6.03),('10318','2013-01-11','10:20:00',2.43),('10318','2013-01-11','10:25:00',5.11),('10318','2013-01-11','10:30:00',5.9),('10318','2013-01-11','10:35:00',5.95),('10318','2013-01-11','10:40:00',6.1),('10318','2013-01-11','10:45:00',6.18),('10318','2013-01-11','10:50:00',6.21),('10318','2013-01-11','10:55:00',6.29),('10318','2013-01-11','11:00:00',6.23),('10318','2013-01-11','11:05:00',6.38),('10318','2013-01-11','11:10:00',6.51),('10318','2013-01-11','11:15:00',6.45),('10318','2013-01-11','11:20:00',6.28),('10318','2013-01-11','11:25:00',1.9),('10318','2013-01-11','11:30:00',2.88),('10318','2013-01-11','11:35:00',3.92),('10318','2013-01-11','11:40:00',4.29),('10318','2013-01-11','11:45:00',4.71),('10318','2013-01-11','11:50:00',3.39),('10318','2013-01-11','11:55:00',2.86),('10318','2013-01-11','12:00:00',2.05),('10318','2013-01-11','12:05:00',1.27),('10318','2013-01-11','12:20:00',1.11),('10318','2013-01-11','12:50:00',2.19),('10318','2013-01-11','12:55:00',2.87),('10318','2013-01-11','13:00:00',3.07),('10318','2013-01-11','13:05:00',2.36),('10318','2013-01-11','13:10:00',2.28),('10318','2013-01-11','13:15:00',1.92),('10318','2013-01-11','13:20:00',1.84),('10318','2013-01-11','13:25:00',1.94),('10318','2013-01-11','13:30:00',2.21),('10318','2013-01-11','13:35:00',6.55),('10318','2013-01-11','13:40:00',3.74),('10318','2013-01-11','13:45:00',4.41),('10318','2013-01-11','14:15:00',1.45),('10318','2013-01-11','14:20:00',2.37),('10318','2013-01-11','14:25:00',1.76),('10318','2013-01-11','14:30:00',1.77),('10318','2013-01-11','14:35:00',1.74),('10318','2013-01-11','14:40:00',1.74),('10318','2013-01-11','14:45:00',3.29),('10318','2013-01-11','14:50:00',4.26),('10318','2013-01-11','14:55:00',3.75),('10318','2013-01-11','15:00:00',3.7),('10318','2013-01-11','15:05:00',1.8),('10318','2013-01-11','15:10:00',1.09),('10318','2013-01-11','15:40:00',1.87),('10318','2013-01-11','15:45:00',1.35),('10318','2013-01-10','09:55:00',1.18),('10318','2013-01-10','10:00:00',1.33),('10318','2013-01-10','10:05:00',1.3),('10318','2013-01-10','10:10:00',1.21),('10318','2013-01-10','10:15:00',1.03),('10318','2013-01-10','10:20:00',1.03),('10318','2013-01-10','10:25:00',1.22),('10318','2013-01-10','11:15:00',1.19),('10318','2013-01-10','11:20:00',1.24),('10318','2013-01-10','11:25:00',2.09),('10318','2013-01-10','11:30:00',2.61),('10318','2013-01-10','11:35:00',1.92),('10318','2013-01-10','11:40:00',1.34),('10318','2013-01-10','11:45:00',1.44),('10318','2013-01-10','11:50:00',2.21),('10318','2013-01-10','11:55:00',2.66),('10318','2013-01-10','12:00:00',2.66),('10318','2013-01-10','12:05:00',2.36),('10318','2013-01-10','12:10:00',1.77),('10318','2013-01-10','12:15:00',1.76),('10318','2013-01-10','12:20:00',1.46),('10318','2013-01-10','12:25:00',1.39),('10318','2013-01-10','12:30:00',1.44),('10318','2013-01-10','12:35:00',1.44),('10318','2013-01-10','12:40:00',1.36),('10318','2013-01-10','12:45:00',1.28),('10318','2013-01-10','12:50:00',1.11),('10318','2013-01-10','13:10:00',1.27),('10318','2013-01-10','13:15:00',1.62),('10318','2013-01-10','13:20:00',1.33),('10318','2013-01-10','13:25:00',1.17),('10318','2013-01-10','13:30:00',1.37),('10318','2013-01-10','13:35:00',1.32),('10318','2013-01-10','13:40:00',1.37),('10318','2013-01-10','13:45:00',1.64),('10318','2013-01-10','13:50:00',1.45),('10318','2013-01-10','13:55:00',1.72),('10318','2013-01-10','14:00:00',1.81),('10318','2013-01-10','14:05:00',1.51),('10318','2013-01-10','14:10:00',1.1),('10318','2013-01-09','09:35:00',1.02),('10318','2013-01-09','09:45:00',1.08),('10318','2013-01-09','09:50:00',1.51),('10318','2013-01-09','09:55:00',1.69),('10318','2013-01-09','10:00:00',1.22),('10318','2013-01-09','10:05:00',1.21),('10318','2013-01-09','10:10:00',1.34),('10318','2013-01-09','10:15:00',1.5),('10318','2013-01-09','10:20:00',1.22),('10318','2013-01-09','10:25:00',1.47),('10318','2013-01-09','10:30:00',1.8),('10318','2013-01-09','10:35:00',1.96),('10318','2013-01-09','10:40:00',2.21),('10318','2013-01-09','10:45:00',2.99),('10318','2013-01-09','10:50:00',2.81),('10318','2013-01-09','10:55:00',2.42),('10318','2013-01-09','11:00:00',2.63),('10318','2013-01-09','11:05:00',3.21),('10318','2013-01-09','11:10:00',3.76),('10318','2013-01-09','11:15:00',3.63),('10318','2013-01-09','11:20:00',3.96),('10318','2013-01-09','11:25:00',3.47),('10318','2013-01-09','11:30:00',3.09),('10318','2013-01-09','11:35:00',2.83),('10318','2013-01-09','11:40:00',3.24),('10318','2013-01-09','11:45:00',3.33),('10318','2013-01-09','11:50:00',2.9),('10318','2013-01-09','11:55:00',2.64),('10318','2013-01-09','12:00:00',2.67),('10318','2013-01-09','12:05:00',2.85),('10318','2013-01-09','12:10:00',2.94),('10318','2013-01-09','12:15:00',2.85),('10318','2013-01-09','12:20:00',2.54),('10318','2013-01-09','12:25:00',2.51),('10318','2013-01-09','12:30:00',2.62),('10318','2013-01-09','12:35:00',2.65),('10318','2013-01-09','12:40:00',2.57),('10318','2013-01-09','12:45:00',2.83),('10318','2013-01-09','12:50:00',2.83),('10318','2013-01-09','12:55:00',2.91),('10318','2013-01-09','13:00:00',2.61),('10318','2013-01-09','13:05:00',2.68),('10318','2013-01-09','13:10:00',2.38),('10318','2013-01-09','13:15:00',2.23),('10318','2013-01-09','13:20:00',2.08),('10318','2013-01-09','13:25:00',2.06),('10318','2013-01-09','13:30:00',2.12),('10318','2013-01-09','13:35:00',2.46),('10318','2013-01-09','13:40:00',2.53),('10318','2013-01-09','13:45:00',2.1),('10318','2013-01-09','13:50:00',1.91),('10318','2013-01-09','13:55:00',1.88),('10318','2013-01-09','14:00:00',2),('10318','2013-01-09','14:05:00',1.78),('10318','2013-01-09','14:10:00',1.68),('10318','2013-01-09','14:15:00',1.52),('10318','2013-01-09','14:20:00',1.38),('10318','2013-01-09','14:25:00',1.22),('10318','2013-01-09','14:30:00',1.22),('10318','2013-01-09','14:35:00',1.12),('10318','2013-01-09','15:40:00',1.38),('10318','2013-01-09','15:45:00',1.21),('10318','2013-01-09','15:50:00',1.11),('10318','2013-01-09','15:55:00',1.02),('10318','2013-01-09','16:10:00',1.13),('10318','2013-01-08','08:25:00',1.24),('10318','2013-01-08','08:30:00',2.48),('10318','2013-01-08','08:35:00',3.6),('10318','2013-01-08','08:40:00',3.9),('10318','2013-01-08','08:45:00',4.13),('10318','2013-01-08','08:50:00',3.65),('10318','2013-01-08','08:55:00',4.54),('10318','2013-01-08','09:00:00',4.87),('10318','2013-01-08','09:05:00',4.53),('10318','2013-01-08','09:10:00',2.55),('10318','2013-01-08','09:15:00',4.19),('10318','2013-01-08','09:20:00',4.37),('10318','2013-01-08','09:25:00',5.11),('10318','2013-01-08','09:30:00',4.19),('10318','2013-01-08','09:35:00',4.84),('10318','2013-01-08','09:40:00',4.86),('10318','2013-01-08','09:45:00',5.96),('10318','2013-01-08','09:50:00',6.05),('10318','2013-01-08','09:55:00',5.87),('10318','2013-01-08','10:00:00',5.56),('10318','2013-01-08','10:05:00',4.96),('10318','2013-01-08','10:10:00',5.41),('10318','2013-01-08','10:15:00',4.76),('10318','2013-01-08','10:20:00',4.53),('10318','2013-01-08','10:25:00',4.86),('10318','2013-01-08','10:30:00',5.24),('10318','2013-01-08','10:35:00',5.51),('10318','2013-01-08','10:40:00',4.78),('10318','2013-01-08','10:45:00',4.19),('10318','2013-01-08','10:50:00',5.88),('10318','2013-01-08','10:55:00',6.26),('10318','2013-01-08','11:00:00',6.41),('10318','2013-01-08','11:05:00',6.5),('10318','2013-01-08','11:10:00',6.49),('10318','2013-01-08','11:15:00',6.49),('10318','2013-01-08','11:20:00',6.49),('10318','2013-01-08','11:25:00',6.5),('10318','2013-01-08','11:30:00',6.55),('10318','2013-01-08','11:35:00',6.49),('10318','2013-01-08','11:40:00',6.61),('10318','2013-01-08','11:45:00',7.3),('10318','2013-01-08','11:50:00',4.48),('10318','2013-01-08','11:55:00',5.03),('10318','2013-01-08','12:00:00',4.07),('10318','2013-01-08','12:05:00',3.68),('10318','2013-01-08','12:10:00',3.79),('10318','2013-01-08','12:15:00',3.74),('10318','2013-01-08','12:20:00',2.98),('10318','2013-01-08','12:25:00',2.82),('10318','2013-01-08','12:30:00',2.74),('10318','2013-01-08','12:35:00',2.74),('10318','2013-01-08','12:40:00',3.34),('10318','2013-01-08','12:45:00',3.4),('10318','2013-01-08','12:50:00',3.79),('10318','2013-01-08','12:55:00',4.85),('10318','2013-01-08','13:00:00',2.38),('10318','2013-01-08','13:05:00',2.52),('10318','2013-01-08','13:10:00',1.87),('10318','2013-01-08','13:15:00',1.92),('10318','2013-01-08','13:20:00',2.16),('10318','2013-01-08','13:25:00',1.58),('10318','2013-01-08','13:30:00',1.75),('10318','2013-01-08','13:35:00',1.8),('10318','2013-01-08','13:40:00',3.88),('10318','2013-01-08','13:45:00',2.53),('10318','2013-01-08','13:50:00',3.19),('10318','2013-01-08','13:55:00',2.28),('10318','2013-01-08','14:00:00',2.44),('10318','2013-01-08','14:05:00',1.94),('10318','2013-01-08','14:10:00',1.81),('10318','2013-01-08','14:15:00',1.66),('10318','2013-01-08','14:20:00',1.83),('10318','2013-01-08','14:25:00',1.97),('10318','2013-01-08','14:30:00',1.91),('10318','2013-01-08','14:35:00',1.96),('10318','2013-01-08','14:40:00',1.78),('10318','2013-01-08','14:45:00',1.22),('10318','2013-01-08','14:50:00',1.28),('10318','2013-01-08','14:55:00',1.37),('10318','2013-01-08','15:00:00',1.39),('10318','2013-01-08','15:05:00',1.49),('10318','2013-01-08','15:10:00',1.21),('10318','2013-01-08','15:15:00',1.11),('10318','2013-01-08','15:20:00',1),('10318','2013-01-08','15:35:00',1.18),('10318','2013-01-08','15:40:00',1.11),('10318','2013-01-07','08:10:00',1.17),('10318','2013-01-07','08:15:00',1.44),('10318','2013-01-07','08:20:00',1.73),('10318','2013-01-07','08:25:00',1.98),('10318','2013-01-07','08:30:00',2.37),('10318','2013-01-07','08:35:00',2.63),('10318','2013-01-07','08:40:00',2.88),('10318','2013-01-07','08:45:00',3.09),('10318','2013-01-07','08:50:00',3.3),('10318','2013-01-07','08:55:00',3.53),('10318','2013-01-07','09:00:00',3.49),('10318','2013-01-07','09:05:00',3.18),('10318','2013-01-07','09:10:00',3.04),('10318','2013-01-07','09:15:00',3.34),('10318','2013-01-07','09:20:00',4.31),('10318','2013-01-07','09:25:00',4.52),('10318','2013-01-07','09:30:00',4.67),('10318','2013-01-07','09:35:00',4.84),('10318','2013-01-07','09:40:00',4.96),('10318','2013-01-07','09:45:00',5.14),('10318','2013-01-07','09:50:00',5.31),('10318','2013-01-07','09:55:00',5.41),('10318','2013-01-07','10:00:00',5.49),('10318','2013-01-07','10:05:00',5.61),('10318','2013-01-07','10:10:00',5.67),('10318','2013-01-07','10:15:00',6),('10318','2013-01-07','10:20:00',6.07),('10318','2013-01-07','10:25:00',6.1),('10318','2013-01-07','10:30:00',6.09),('10318','2013-01-07','10:35:00',6.23),('10318','2013-01-07','10:40:00',6.33),('10318','2013-01-07','10:45:00',6.38),('10318','2013-01-07','10:50:00',6.35),('10318','2013-01-07','10:55:00',6.36),('10318','2013-01-07','11:00:00',6.35),('10318','2013-01-07','11:05:00',6.38),('10318','2013-01-07','11:10:00',6.44),('10318','2013-01-07','11:15:00',6.5),('10318','2013-01-07','11:20:00',6.51),('10318','2013-01-07','11:25:00',6.53),('10318','2013-01-07','11:30:00',6.56),('10318','2013-01-07','11:35:00',6.49),('10318','2013-01-07','11:40:00',6.51),('10318','2013-01-07','11:45:00',6.46),('10318','2013-01-07','11:50:00',6.49),('10318','2013-01-07','11:55:00',6.32),('10318','2013-01-07','12:00:00',6.48),('10318','2013-01-07','12:05:00',6.4),('10318','2013-01-07','12:10:00',6.36),('10318','2013-01-07','12:15:00',6.36),('10318','2013-01-07','12:20:00',6.36),('10318','2013-01-07','12:25:00',6.32),('10318','2013-01-07','12:30:00',6.24),('10318','2013-01-07','12:35:00',6.16),('10318','2013-01-07','12:40:00',6.11),('10318','2013-01-07','12:45:00',6.14),('10318','2013-01-07','12:50:00',6),('10318','2013-01-07','12:55:00',5.88),('10318','2013-01-07','13:00:00',5.83),('10318','2013-01-07','13:05:00',5.79),('10318','2013-01-07','13:10:00',5.6),('10318','2013-01-07','13:15:00',5.6),('10318','2013-01-07','13:20:00',5.52),('10318','2013-01-07','13:25:00',5.41),('10318','2013-01-07','13:30:00',5.34),('10318','2013-01-07','13:35:00',5.18),('10318','2013-01-07','13:40:00',5.08),('10318','2013-01-07','13:45:00',5.02),('10318','2013-01-07','13:50:00',4.86),('10318','2013-01-07','13:55:00',4.73),('10318','2013-01-07','14:00:00',4.63),('10318','2013-01-07','14:05:00',4.52),('10318','2013-01-07','14:10:00',4.49),('10318','2013-01-07','14:15:00',4.4),('10318','2013-01-07','14:20:00',4.31),('10318','2013-01-07','14:25:00',4.15),('10318','2013-01-07','14:30:00',4.01),('10318','2013-01-07','14:35:00',3.87),('10318','2013-01-07','14:40:00',3.73),('10318','2013-01-07','14:45:00',3.59),('10318','2013-01-07','14:50:00',3.45),('10318','2013-01-07','14:55:00',3.26),('10318','2013-01-07','15:00:00',3.18),('10318','2013-01-07','15:05:00',3.03),('10318','2013-01-07','15:10:00',2.85),('10318','2013-01-07','15:15:00',2.71),('10318','2013-01-07','15:20:00',2.57),('10318','2013-01-07','15:25:00',2.46),('10318','2013-01-07','15:30:00',2.44),('10318','2013-01-07','15:35:00',2.3),('10318','2013-01-07','15:40:00',2.15),('10318','2013-01-07','15:45:00',1.99),('10318','2013-01-07','15:50:00',1.84),('10318','2013-01-07','15:55:00',1.68),('10318','2013-01-07','16:00:00',1.52),('10318','2013-01-07','16:05:00',1.35),('10318','2013-01-07','16:10:00',1.18),('10318','2013-01-07','16:15:00',1.01),('10318','2013-01-06','08:00:00',1.06),('10318','2013-01-06','08:05:00',1.34),('10318','2013-01-06','08:10:00',1.64),('10318','2013-01-06','08:15:00',1.89),('10318','2013-01-06','08:20:00',2.12),('10318','2013-01-06','08:25:00',2.36),('10318','2013-01-06','08:30:00',2.64),('10318','2013-01-06','08:35:00',2.94),('10318','2013-01-06','08:40:00',3.18),('10318','2013-01-06','08:45:00',3.38),('10318','2013-01-06','08:50:00',3.57),('10318','2013-01-06','08:55:00',3.78),('10318','2013-01-06','09:00:00',3.96),('10318','2013-01-06','09:05:00',4.14),('10318','2013-01-06','09:10:00',4.23),('10318','2013-01-06','09:15:00',4.47),('10318','2013-01-06','09:20:00',4.63),('10318','2013-01-06','09:25:00',4.78),('10318','2013-01-06','09:30:00',4.94),('10318','2013-01-06','09:35:00',5.08),('10318','2013-01-06','09:40:00',5.2),('10318','2013-01-06','09:45:00',5.34),('10318','2013-01-06','09:50:00',5.48),('10318','2013-01-06','09:55:00',5.53),('10318','2013-01-06','10:00:00',5.68),('10318','2013-01-06','10:05:00',5.74),('10318','2013-01-06','10:10:00',5.82),('10318','2013-01-06','10:15:00',5.92),('10318','2013-01-06','10:20:00',5.95),('10318','2013-01-06','10:25:00',6.07),('10318','2013-01-06','10:30:00',6.17),('10318','2013-01-06','10:35:00',6.25),('10318','2013-01-06','10:40:00',6.29),('10318','2013-01-06','10:45:00',6.27),('10318','2013-01-06','10:50:00',6.31),('10318','2013-01-06','10:55:00',6.29),('10318','2013-01-06','11:00:00',6.4),('10318','2013-01-06','11:05:00',6.44),('10318','2013-01-06','11:10:00',6.46),('10318','2013-01-06','11:15:00',6.51),('10318','2013-01-06','11:20:00',6.55),('10318','2013-01-06','11:25:00',6.55),('10318','2013-01-06','11:30:00',6.56),('10318','2013-01-06','11:35:00',6.55),('10318','2013-01-06','11:40:00',6.55),('10318','2013-01-06','11:45:00',6.57),('10318','2013-01-06','11:50:00',6.56),('10318','2013-01-06','11:55:00',6.54),('10318','2013-01-06','12:00:00',6.53),('10318','2013-01-06','12:05:00',6.5),('10318','2013-01-06','12:10:00',6.42),('10318','2013-01-06','12:15:00',6.37),('10318','2013-01-06','12:20:00',6.26),('10318','2013-01-06','12:25:00',6.27),('10318','2013-01-06','12:30:00',6.28),('10318','2013-01-06','12:35:00',6.2),('10318','2013-01-06','12:40:00',6.16),('10318','2013-01-06','12:45:00',6.24),('10318','2013-01-06','12:50:00',6.2),('10318','2013-01-06','12:55:00',6.15),('10318','2013-01-06','13:00:00',6.1),('10318','2013-01-06','13:05:00',6.02),('10318','2013-01-06','13:10:00',5.92),('10318','2013-01-06','13:15:00',5.81),('10318','2013-01-06','13:20:00',5.75),('10318','2013-01-06','13:25:00',5.65),('10318','2013-01-06','13:30:00',5.54),('10318','2013-01-06','13:35:00',5.39),('10318','2013-01-06','13:40:00',5.28),('10318','2013-01-06','13:45:00',5.15),('10318','2013-01-06','13:50:00',5),('10318','2013-01-06','13:55:00',4.76),('10318','2013-01-06','14:00:00',4.77),('10318','2013-01-06','14:05:00',4.69),('10318','2013-01-06','14:10:00',4.52),('10318','2013-01-06','14:15:00',4.33),('10318','2013-01-06','14:20:00',4.13),('10318','2013-01-06','14:25:00',4.05),('10318','2013-01-06','14:30:00',3.81),('10318','2013-01-06','14:35:00',3.66),('10318','2013-01-06','14:40:00',3.58),('10318','2013-01-06','14:45:00',3.42),('10318','2013-01-06','14:50:00',3.23),('10318','2013-01-06','14:55:00',3.1),('10318','2013-01-06','15:00:00',2.98),('10318','2013-01-06','15:05:00',2.82),('10318','2013-01-06','15:10:00',2.76),('10318','2013-01-06','15:15:00',2.63),('10318','2013-01-06','15:20:00',2.47),('10318','2013-01-06','15:25:00',2.35),('10318','2013-01-06','15:30:00',2.19),('10318','2013-01-06','15:35:00',2.04),('10318','2013-01-06','15:40:00',1.85),('10318','2013-01-06','15:45:00',1.74),('10318','2013-01-06','15:50:00',1.6),('10318','2013-01-06','15:55:00',1.48),('10318','2013-01-06','16:00:00',1.35),('10318','2013-01-06','16:05:00',1.19),('10318','2013-01-06','16:10:00',1.04),('10318','2013-01-05','08:35:00',1.24),('10318','2013-01-05','08:40:00',1.38),('10318','2013-01-05','08:45:00',2.08),('10318','2013-01-05','08:50:00',1.93),('10318','2013-01-05','08:55:00',1.63),('10318','2013-01-05','09:00:00',1.48),('10318','2013-01-05','09:05:00',1.62),('10318','2013-01-05','09:10:00',1.64),('10318','2013-01-05','09:15:00',1.58),('10318','2013-01-05','09:20:00',1.48),('10318','2013-01-05','09:25:00',1.58),('10318','2013-01-05','09:30:00',1.56),('10318','2013-01-05','09:35:00',1.75),('10318','2013-01-05','09:40:00',1.85),('10318','2013-01-05','09:45:00',1.71),('10318','2013-01-05','09:50:00',1.63),('10318','2013-01-05','09:55:00',1.73),('10318','2013-01-05','10:00:00',1.94),('10318','2013-01-05','10:05:00',2.12),('10318','2013-01-05','10:10:00',2.51),('10318','2013-01-05','10:15:00',2.58),('10318','2013-01-05','10:20:00',2.91),('10318','2013-01-05','10:25:00',2.36),('10318','2013-01-05','10:30:00',2.39),('10318','2013-01-05','10:35:00',2.81),('10318','2013-01-05','10:40:00',2.81),('10318','2013-01-05','10:45:00',3.1),('10318','2013-01-05','10:50:00',3.53),('10318','2013-01-05','10:55:00',5.64),('10318','2013-01-05','11:00:00',5.57),('10318','2013-01-05','11:05:00',5.03),('10318','2013-01-05','11:10:00',5.28),('10318','2013-01-05','11:15:00',4.79),('10318','2013-01-05','11:20:00',6.22),('10318','2013-01-05','11:25:00',6.37),('10318','2013-01-05','11:30:00',6.06),('10318','2013-01-05','11:35:00',5.58),('10318','2013-01-05','11:40:00',5.34),('10318','2013-01-05','11:45:00',5.4),('10318','2013-01-05','11:50:00',4.73),('10318','2013-01-05','11:55:00',4.06),('10318','2013-01-05','12:00:00',3.63),('10318','2013-01-05','12:05:00',3.7),('10318','2013-01-05','12:10:00',3.85),('10318','2013-01-05','12:15:00',3.84),('10318','2013-01-05','12:20:00',3.41),('10318','2013-01-05','12:25:00',2.82),('10318','2013-01-05','12:30:00',2.77),('10318','2013-01-05','12:35:00',3.81),('10318','2013-01-05','12:40:00',5.29),('10318','2013-01-05','12:45:00',5),('10318','2013-01-05','12:50:00',3.11),('10318','2013-01-05','12:55:00',2.77),('10318','2013-01-05','13:00:00',2.75),('10318','2013-01-05','13:05:00',2.9),('10318','2013-01-05','13:10:00',2.85),('10318','2013-01-05','13:15:00',2.48),('10318','2013-01-05','13:20:00',2.05),('10318','2013-01-05','13:25:00',2.88),('10318','2013-01-05','13:30:00',3.74),('10318','2013-01-05','13:35:00',2.91),('10318','2013-01-05','13:40:00',2.33),('10318','2013-01-05','13:45:00',1.94),('10318','2013-01-05','13:50:00',2.06),('10318','2013-01-05','13:55:00',2.99),('10318','2013-01-05','14:00:00',2.3),('10318','2013-01-05','14:05:00',3.94),('10318','2013-01-05','14:10:00',3.49),('10318','2013-01-05','14:15:00',3.56),('10318','2013-01-05','14:20:00',2.9),('10318','2013-01-05','14:25:00',1.75),('10318','2013-01-05','14:30:00',2.41),('10318','2013-01-05','14:35:00',2.56),('10318','2013-01-05','14:40:00',2.82),('10318','2013-01-05','14:45:00',2.58),('10318','2013-01-05','14:50:00',2.34),('10318','2013-01-05','14:55:00',2.31),('10318','2013-01-05','15:00:00',2.35),('10318','2013-01-05','15:05:00',1.78),('10318','2013-01-05','15:40:00',1.1),('10318','2013-01-04','08:10:00',1.14),('10318','2013-01-04','08:15:00',1.24),('10318','2013-01-04','08:20:00',1.38),('10318','2013-01-04','08:25:00',1.41),('10318','2013-01-04','08:30:00',1.4),('10318','2013-01-04','08:35:00',2.12),('10318','2013-01-04','08:40:00',2.31),('10318','2013-01-04','08:45:00',3.3),('10318','2013-01-04','08:50:00',3.26),('10318','2013-01-04','08:55:00',3.61),('10318','2013-01-04','09:00:00',3.42),('10318','2013-01-04','09:05:00',3.38),('10318','2013-01-04','09:10:00',3.78),('10318','2013-01-04','09:15:00',3.59),('10318','2013-01-04','09:20:00',3.8),('10318','2013-01-04','09:25:00',3.52),('10318','2013-01-04','09:30:00',3.8),('10318','2013-01-04','09:35:00',3.28),('10318','2013-01-04','09:40:00',3.68),('10318','2013-01-04','09:45:00',4),('10318','2013-01-04','09:50:00',4.67),('10318','2013-01-04','09:55:00',4.91),('10318','2013-01-04','10:00:00',5.73),('10318','2013-01-04','10:05:00',6.04),('10318','2013-01-04','10:10:00',5.31),('10318','2013-01-04','10:15:00',5.57),('10318','2013-01-04','10:20:00',4.97),('10318','2013-01-04','10:25:00',5.29),('10318','2013-01-04','10:30:00',6.06),('10318','2013-01-04','10:35:00',6.29),('10318','2013-01-04','10:40:00',6.31),('10318','2013-01-04','10:45:00',6.55),('10318','2013-01-04','10:50:00',6.73),('10318','2013-01-04','10:55:00',6.99),('10318','2013-01-04','11:00:00',6.55),('10318','2013-01-04','11:05:00',3.46),('10318','2013-01-04','11:10:00',2.45),('10318','2013-01-04','11:15:00',4.18),('10318','2013-01-04','11:20:00',1.98),('10318','2013-01-04','11:25:00',1.69),('10318','2013-01-04','11:30:00',1.88),('10318','2013-01-04','11:35:00',1.71),('10318','2013-01-04','11:40:00',2.34),('10318','2013-01-04','11:45:00',2.6),('10318','2013-01-04','11:50:00',5.46),('10318','2013-01-04','11:55:00',7.05),('10318','2013-01-04','12:00:00',7.75),('10318','2013-01-04','12:05:00',6.09),('10318','2013-01-04','12:10:00',4.13),('10318','2013-01-04','12:15:00',2.83),('10318','2013-01-04','12:20:00',2.26),('10318','2013-01-04','12:25:00',3),('10318','2013-01-04','12:30:00',5.15),('10318','2013-01-04','12:35:00',4.51),('10318','2013-01-04','12:40:00',5.81),('10318','2013-01-04','12:45:00',5.73),('10318','2013-01-04','12:50:00',6.38),('10318','2013-01-04','12:55:00',6.24),('10318','2013-01-04','13:00:00',5.98),('10318','2013-01-04','13:05:00',5.1),('10318','2013-01-04','13:10:00',4.34),('10318','2013-01-04','13:15:00',4.62),('10318','2013-01-04','13:20:00',5.5),('10318','2013-01-04','13:25:00',5.35),('10318','2013-01-04','13:30:00',5.28),('10318','2013-01-04','13:35:00',5.14),('10318','2013-01-04','13:40:00',4.99),('10318','2013-01-04','13:45:00',4.93),('10318','2013-01-04','13:50:00',4.74),('10318','2013-01-04','13:55:00',4.64),('10318','2013-01-04','14:00:00',4.57),('10318','2013-01-04','14:05:00',4.42),('10318','2013-01-04','14:10:00',4.26),('10318','2013-01-04','14:15:00',4.11),('10318','2013-01-04','14:20:00',3.89),('10318','2013-01-04','14:25:00',3.71),('10318','2013-01-04','14:30:00',3.65),('10318','2013-01-04','14:35:00',3.55),('10318','2013-01-04','14:40:00',3.41),('10318','2013-01-04','14:45:00',3.36),('10318','2013-01-04','14:50:00',3.1),('10318','2013-01-04','14:55:00',2.96),('10318','2013-01-04','15:00:00',2.9),('10318','2013-01-04','15:05:00',2.69),('10318','2013-01-04','15:10:00',2.45),('10318','2013-01-04','15:15:00',2.51),('10318','2013-01-04','15:20:00',2.43),('10318','2013-01-04','15:25:00',2.24),('10318','2013-01-04','15:30:00',2.08),('10318','2013-01-04','15:35:00',1.97),('10318','2013-01-04','15:40:00',1.83),('10318','2013-01-04','15:45:00',1.39),('10318','2013-01-03','08:05:00',1.02),('10318','2013-01-03','08:10:00',1.3),('10318','2013-01-03','08:15:00',1.68),('10318','2013-01-03','08:20:00',1.87),('10318','2013-01-03','08:25:00',2.03),('10318','2013-01-03','08:30:00',2.4),('10318','2013-01-03','08:35:00',2.62),('10318','2013-01-03','08:40:00',2.98),('10318','2013-01-03','08:45:00',3.16),('10318','2013-01-03','08:50:00',3.29),('10318','2013-01-03','08:55:00',3.56),('10318','2013-01-03','09:00:00',3.78),('10318','2013-01-03','09:05:00',3.99),('10318','2013-01-03','09:10:00',4.19),('10318','2013-01-03','09:15:00',4.42),('10318','2013-01-03','09:20:00',4.58),('10318','2013-01-03','09:25:00',4.67),('10318','2013-01-03','09:30:00',4.92),('10318','2013-01-03','09:35:00',5.07),('10318','2013-01-03','09:40:00',5.41),('10318','2013-01-03','09:45:00',5.76),('10318','2013-01-03','09:50:00',6.13),('10318','2013-01-03','09:55:00',6.44),('10318','2013-01-03','10:00:00',6.63),('10318','2013-01-03','10:05:00',6.68),('10318','2013-01-03','10:10:00',4.25),('10318','2013-01-03','10:15:00',5.46),('10318','2013-01-03','10:20:00',5.24),('10318','2013-01-03','10:25:00',4.75),('10318','2013-01-03','10:30:00',4.83),('10318','2013-01-03','10:35:00',4.89),('10318','2013-01-03','10:40:00',4.81),('10318','2013-01-03','10:45:00',4.4),('10318','2013-01-03','10:50:00',3.86),('10318','2013-01-03','10:55:00',3.9),('10318','2013-01-03','11:00:00',4.12),('10318','2013-01-03','11:05:00',4.24),('10318','2013-01-03','11:10:00',3.91),('10318','2013-01-03','11:15:00',3.79),('10318','2013-01-03','11:20:00',3.43),('10318','2013-01-03','11:25:00',2.92),('10318','2013-01-03','11:30:00',2.64),('10318','2013-01-03','11:35:00',4.07),('10318','2013-01-03','11:40:00',6.97),('10318','2013-01-03','11:45:00',6.93),('10318','2013-01-03','11:50:00',6.79),('10318','2013-01-03','11:55:00',6.65),('10318','2013-01-03','12:00:00',6.58),('10318','2013-01-03','12:05:00',6.54),('10318','2013-01-03','12:10:00',6.47),('10318','2013-01-03','12:15:00',6.45),('10318','2013-01-03','12:20:00',6.41),('10318','2013-01-03','12:25:00',6.34),('10318','2013-01-03','12:30:00',6.33),('10318','2013-01-03','12:35:00',6.32),('10318','2013-01-03','12:40:00',6.25),('10318','2013-01-03','12:45:00',6.22),('10318','2013-01-03','12:50:00',6.15),('10318','2013-01-03','12:55:00',6.07),('10318','2013-01-03','13:00:00',5.89),('10318','2013-01-03','13:05:00',5.94),('10318','2013-01-03','13:10:00',5.84),('10318','2013-01-03','13:15:00',5.73),('10318','2013-01-03','13:20:00',5.68),('10318','2013-01-03','13:25:00',5.6),('10318','2013-01-03','13:30:00',5.49),('10318','2013-01-03','13:35:00',5.37),('10318','2013-01-03','13:40:00',5.25),('10318','2013-01-03','13:45:00',5.14),('10318','2013-01-03','13:50:00',5.01),('10318','2013-01-03','13:55:00',4.89),('10318','2013-01-03','14:00:00',4.75),('10318','2013-01-03','14:05:00',4.63),('10318','2013-01-03','14:10:00',4.48),('10318','2013-01-03','14:15:00',4.33),('10318','2013-01-03','14:20:00',4.22),('10318','2013-01-03','14:25:00',4.07),('10318','2013-01-03','14:30:00',3.94),('10318','2013-01-03','14:35:00',3.76),('10318','2013-01-03','14:40:00',3.63),('10318','2013-01-03','14:45:00',3.4),('10318','2013-01-03','14:50:00',3.37),('10318','2013-01-03','14:55:00',3.24),('10318','2013-01-03','15:00:00',3.1),('10318','2013-01-03','15:05:00',2.95),('10318','2013-01-03','15:10:00',2.81),('10318','2013-01-03','15:15:00',2.64),('10318','2013-01-03','15:20:00',2.29),('10318','2013-01-03','15:25:00',2.21),('10318','2013-01-03','15:30:00',2.22),('10318','2013-01-03','15:35:00',2.09),('10318','2013-01-03','15:40:00',1.86),('10318','2013-01-03','15:45:00',1.78),('10318','2013-01-03','15:50:00',1.64),('10318','2013-01-03','15:55:00',1.49),('10318','2013-01-03','16:00:00',1.3),('10318','2013-01-03','16:05:00',1.15),('10318','2013-01-02','09:40:00',1.48),('10318','2013-01-02','09:45:00',1.45),('10318','2013-01-02','09:50:00',1.42),('10318','2013-01-02','09:55:00',1.43),('10318','2013-01-02','10:00:00',1.46),('10318','2013-01-02','10:05:00',1.37),('10318','2013-01-02','10:10:00',1.33),('10318','2013-01-02','10:15:00',1.26),('10318','2013-01-02','10:40:00',1.1),('10318','2013-01-02','10:50:00',1.11),('10318','2013-01-02','10:55:00',1.01),('10318','2013-01-02','11:00:00',1.06),('10318','2013-01-02','11:05:00',1.53),('10318','2013-01-02','11:10:00',1.38),('10318','2013-01-02','11:15:00',1.2),('10318','2013-01-02','11:40:00',1.01),('10318','2013-01-02','11:45:00',1.02),('10318','2013-01-02','12:30:00',1.14),('10318','2013-01-02','12:50:00',1.13),('10318','2013-01-02','12:55:00',1.38),('10318','2013-01-02','13:30:00',2.12),('10318','2013-01-02','13:35:00',2.7),('10318','2013-01-02','13:40:00',2.59),('10318','2013-01-02','13:45:00',2.12),('10318','2013-01-02','13:50:00',1.92),('10318','2013-01-02','13:55:00',1.71),('10318','2013-01-02','14:00:00',1.33),('10318','2014-03-18','07:30:00',1),('10318','2014-03-18','07:35:00',1.03),('10318','2014-03-18','07:40:00',1.13),('10318','2014-03-18','07:45:00',1.43),('10318','2014-03-18','07:50:00',1.67),('10318','2014-03-18','07:55:00',2.02),('10318','2014-03-18','08:00:00',3.56),('10318','2014-03-18','08:05:00',4.3),('10318','2014-03-18','08:10:00',2.63),('10318','2014-03-18','08:15:00',2.94),('10318','2014-03-18','08:20:00',2.16),('10318','2014-03-18','08:25:00',3.51),('10318','2014-03-18','08:30:00',4.3),('10318','2014-03-18','08:35:00',4.63),('10318','2014-03-18','08:40:00',6.76),('10318','2014-03-18','08:45:00',6.01),('10318','2014-03-18','08:50:00',3.25),('10318','2014-03-18','08:55:00',1.55),('10318','2014-03-18','09:00:00',1.52),('10318','2014-03-18','09:05:00',1.84),('10318','2014-03-18','09:10:00',1.99),('10318','2014-03-18','09:15:00',2.07),('10318','2014-03-18','09:20:00',2.18),('10318','2014-03-18','09:25:00',2.2),('10318','2014-03-18','09:30:00',2.13),('10318','2014-03-18','09:35:00',2.1),('10318','2014-03-18','09:40:00',2.6),('10318','2014-03-18','09:45:00',2.75),('10318','2014-03-18','09:50:00',7.19),('10318','2014-03-18','09:55:00',8.31),('10318','2014-03-18','10:00:00',8.2),('10318','2014-03-18','10:05:00',9.13),('10318','2014-03-18','10:10:00',4.37),('10318','2014-03-18','10:15:00',3.2),('10318','2014-03-18','10:20:00',3.33),('10318','2014-03-18','10:25:00',7.11),('10318','2014-03-18','10:30:00',5.88),('10318','2014-03-18','10:35:00',6.05),('10318','2014-03-18','10:40:00',9.98),('10318','2014-03-18','10:45:00',9.23),('10318','2014-03-18','10:50:00',4.48),('10318','2014-03-18','10:55:00',4.78),('10318','2014-03-18','11:00:00',9.51),('10318','2014-03-18','11:05:00',7.21),('10318','2014-03-18','11:10:00',4.63),('10318','2014-03-18','11:15:00',5.01),('10318','2014-03-18','11:20:00',5.31),('10318','2014-03-18','11:25:00',4.83),('10318','2014-03-18','11:30:00',4.46),('10318','2014-03-18','11:35:00',4.29),('10318','2014-03-18','11:40:00',4.58),('10318','2014-03-18','11:45:00',3.99),('10318','2014-03-18','11:50:00',3.65),('10318','2014-03-18','11:55:00',3.58),('10318','2014-03-18','12:00:00',4.34),('10318','2014-03-18','12:05:00',3.95),('10318','2014-03-18','12:10:00',8.42),('10318','2014-03-18','12:15:00',8.74),('10318','2014-03-18','12:20:00',8.38),('10318','2014-03-18','12:25:00',6.57),('10318','2014-03-18','12:30:00',8.78),('10318','2014-03-18','12:35:00',8.68),('10318','2014-03-18','12:40:00',7.55),('10318','2014-03-18','12:45:00',7.42),('10318','2014-03-18','12:50:00',8.68),('10318','2014-03-18','12:55:00',6.2),('10318','2014-03-18','13:00:00',9.1),('10318','2014-03-18','13:05:00',8.67),('10318','2014-03-18','13:10:00',7.73),('10318','2014-03-18','13:15:00',8.46),('10318','2014-03-18','13:20:00',8.24),('10318','2014-03-18','13:25:00',8.07),('10318','2014-03-18','13:30:00',7.96),('10318','2014-03-18','13:35:00',7.98),('10318','2014-03-18','13:40:00',7.83),('10318','2014-03-18','13:45:00',7.65),('10318','2014-03-18','13:50:00',7.73),('10318','2014-03-18','13:55:00',7.55),('10318','2014-03-18','14:00:00',7.43),('10318','2014-03-18','14:05:00',7.25),('10318','2014-03-18','14:10:00',7.12),('10318','2014-03-18','14:15:00',7.04),('10318','2014-03-18','14:20:00',6.83),('10318','2014-03-18','14:25:00',6.78),('10318','2014-03-18','14:30:00',6.7),('10318','2014-03-18','14:35:00',6.54),('10318','2014-03-18','14:40:00',6.36),('10318','2014-03-18','14:45:00',6.18),('10318','2014-03-18','14:50:00',6.02),('10318','2014-03-18','14:55:00',5.88),('10318','2014-03-18','15:00:00',5.72),('10318','2014-03-18','15:05:00',5.54),('10318','2014-03-18','15:10:00',5.37),('10318','2014-03-18','15:15:00',5.22),('10318','2014-03-18','15:20:00',5.04),('10318','2014-03-18','15:25:00',4.83),('10318','2014-03-18','15:30:00',4.59),('10318','2014-03-18','15:35:00',4.48),('10318','2014-03-18','15:40:00',4.31),('10318','2014-03-18','15:45:00',4.09),('10318','2014-03-18','15:50:00',3.89),('10318','2014-03-18','15:55:00',3.69),('10318','2014-03-18','16:00:00',3.47),('10318','2014-03-18','16:05:00',3.32),('10318','2014-03-18','16:10:00',3.17),('10318','2014-03-18','16:15:00',3.01),('10318','2014-03-18','16:20:00',2.84),('10318','2014-03-18','16:25:00',2.63),('10318','2014-03-18','16:30:00',2.46),('10318','2014-03-18','16:35:00',2.3),('10318','2014-03-18','16:40:00',2.09),('10318','2014-03-18','16:45:00',1.97),('10318','2014-03-18','16:50:00',1.8),('10318','2014-03-18','16:55:00',1.66),('10318','2014-03-18','17:00:00',1.49),('10318','2014-03-18','17:05:00',1.29),('10318','2014-03-18','17:10:00',1.18),('10318','2014-03-18','17:15:00',1.05),('10318','2013-01-01','08:05:00',1.11),('10318','2013-01-01','08:10:00',1.37),('10318','2013-01-01','08:15:00',1.58),('10318','2013-01-01','08:20:00',1.79),('10318','2013-01-01','08:25:00',2.02),('10318','2013-01-01','08:30:00',2.29),('10318','2013-01-01','08:35:00',2.6),('10318','2013-01-01','08:40:00',2.84),('10318','2013-01-01','08:45:00',3.03),('10318','2013-01-01','08:50:00',3.22),('10318','2013-01-01','08:55:00',3.44),('10318','2013-01-01','09:00:00',3.64),('10318','2013-01-01','09:05:00',3.81),('10318','2013-01-01','09:10:00',3.98),('10318','2013-01-01','09:15:00',4.17),('10318','2013-01-01','09:20:00',4.37),('10318','2013-01-01','09:25:00',4.5),('10318','2013-01-01','09:30:00',4.65),('10318','2013-01-01','09:35:00',4.77),('10318','2013-01-01','09:40:00',4.91),('10318','2013-01-01','09:45:00',5.03),('10318','2013-01-01','09:50:00',5.14),('10318','2013-01-01','09:55:00',5.26),('10318','2013-01-01','10:00:00',5.36),('10318','2013-01-01','10:05:00',5.42),('10318','2013-01-01','10:10:00',5.53),('10318','2013-01-01','10:15:00',5.63),('10318','2013-01-01','10:20:00',5.64),('10318','2013-01-01','10:25:00',5.75),('10318','2013-01-01','10:30:00',5.79),('10318','2013-01-01','10:35:00',5.98),('10318','2013-01-01','10:40:00',5.75),('10318','2013-01-01','10:45:00',4.2),('10318','2013-01-01','10:50:00',3.38),('10318','2013-01-01','10:55:00',2.51),('10318','2013-01-01','11:00:00',6.55),('10318','2013-01-01','11:05:00',6.43),('10318','2013-01-01','11:10:00',5.01),('10318','2013-01-01','11:15:00',4.49),('10318','2013-01-01','11:20:00',4.62),('10318','2013-01-01','11:25:00',6.28),('10318','2013-01-01','11:30:00',3.05),('10318','2013-01-01','11:35:00',3.24),('10318','2013-01-01','11:40:00',6.4),('10318','2013-01-01','11:45:00',6.76),('10318','2013-01-01','11:50:00',4.7),('10318','2013-01-01','11:55:00',2.62),('10318','2013-01-01','12:00:00',2.5),('10318','2013-01-01','12:05:00',2.79),('10318','2013-01-01','12:10:00',3.24),('10318','2013-01-01','12:15:00',3.13),('10318','2013-01-01','12:20:00',2.78),('10318','2013-01-01','12:25:00',2.19),('10318','2013-01-01','12:30:00',1.84),('10318','2013-01-01','12:35:00',1.97),('10318','2013-01-01','12:40:00',2.62),('10318','2013-01-01','12:45:00',3.47),('10318','2013-01-01','12:50:00',3.07),('10318','2013-01-01','12:55:00',2.98),('10318','2013-01-01','13:00:00',3.02),('10318','2013-01-01','13:05:00',1.95),('10318','2013-01-01','13:10:00',1.97),('10318','2013-01-01','13:15:00',1.82),('10318','2013-01-01','13:20:00',1.59),('10318','2013-01-01','13:25:00',1.3),('10318','2013-01-01','13:30:00',1.07),('10318','2012-12-31','08:00:00',1.15),('10318','2012-12-31','08:05:00',1.46),('10318','2012-12-31','08:10:00',1.89),('10318','2012-12-31','08:15:00',2.07),('10318','2012-12-31','08:20:00',2.19),('10318','2012-12-31','08:25:00',2.65),('10318','2012-12-31','08:30:00',2.91),('10318','2012-12-31','08:35:00',2.56),('10318','2012-12-31','08:40:00',1.31),('10318','2012-12-31','08:45:00',1.93),('10318','2012-12-31','08:50:00',2.4),('10318','2012-12-31','08:55:00',3.21),('10318','2012-12-31','09:00:00',3.34),('10318','2012-12-31','09:05:00',3.33),('10318','2012-12-31','09:10:00',3.9),('10318','2012-12-31','09:15:00',4.06),('10318','2012-12-31','09:20:00',4.85),('10318','2012-12-31','09:25:00',5.1),('10318','2012-12-31','09:30:00',2.34),('10318','2012-12-31','09:35:00',1.47),('10318','2012-12-31','09:40:00',1.11),('10318','2012-12-31','09:45:00',2.53),('10318','2012-12-31','09:50:00',3.55),('10318','2012-12-31','09:55:00',5.58),('10318','2012-12-31','10:00:00',3.95),('10318','2012-12-31','10:05:00',5.44),('10318','2012-12-31','10:10:00',6.21),('10318','2012-12-31','10:15:00',6.25),('10318','2012-12-31','10:20:00',6.25),('10318','2012-12-31','10:25:00',6.28),('10318','2012-12-31','10:30:00',6.29),('10318','2012-12-31','10:35:00',6.27),('10318','2012-12-31','10:40:00',6.19),('10318','2012-12-31','10:45:00',6.3),('10318','2012-12-31','10:50:00',6.4),('10318','2012-12-31','10:55:00',6.5),('10318','2012-12-31','11:00:00',6.4),('10318','2012-12-31','11:05:00',6.22),('10318','2012-12-31','11:10:00',6.53),('10318','2012-12-31','11:15:00',6.65),('10318','2012-12-31','11:20:00',6.69),('10318','2012-12-31','11:25:00',6.69),('10318','2012-12-31','11:30:00',6.71),('10318','2012-12-31','11:35:00',6.71),('10318','2012-12-31','11:40:00',6.75),('10318','2012-12-31','11:45:00',6.76),('10318','2012-12-31','11:50:00',6.57),('10318','2012-12-31','11:55:00',6.74),('10318','2012-12-31','12:00:00',6.79),('10318','2012-12-31','12:05:00',6.78),('10318','2012-12-31','12:10:00',6.73),('10318','2012-12-31','12:15:00',6.71),('10318','2012-12-31','12:20:00',6.63),('10318','2012-12-31','12:25:00',6.61),('10318','2012-12-31','12:30:00',6.54),('10318','2012-12-31','12:35:00',6.49),('10318','2012-12-31','12:40:00',6.46),('10318','2012-12-31','12:45:00',6.38),('10318','2012-12-31','12:50:00',6.27),('10318','2012-12-31','12:55:00',6.21),('10318','2012-12-31','13:00:00',6.1),('10318','2012-12-31','13:05:00',6.01),('10318','2012-12-31','13:10:00',5.94),('10318','2012-12-31','13:15:00',5.84),('10318','2012-12-31','13:20:00',5.76),('10318','2012-12-31','13:25:00',5.64),('10318','2012-12-31','13:30:00',5.5),('10318','2012-12-31','13:35:00',5.25),('10318','2012-12-31','13:40:00',5.26),('10318','2012-12-31','13:45:00',5.11),('10318','2012-12-31','13:50:00',4.99),('10318','2012-12-31','13:55:00',4.88),('10318','2012-12-31','14:00:00',4.78),('10318','2012-12-31','14:05:00',4.63),('10318','2012-12-31','14:10:00',4.52),('10318','2012-12-31','14:15:00',4.37),('10318','2012-12-31','14:20:00',4.24),('10318','2012-12-31','14:25:00',4.1),('10318','2012-12-31','14:30:00',3.96),('10318','2012-12-31','14:35:00',3.84),('10318','2012-12-31','14:40:00',3.7),('10318','2012-12-31','14:45:00',3.62),('10318','2012-12-31','14:50:00',3.45),('10318','2012-12-31','14:55:00',3.29),('10318','2012-12-31','15:00:00',3.14),('10318','2012-12-31','15:05:00',2.96),('10318','2012-12-31','15:10:00',2.81),('10318','2012-12-31','15:15:00',2.7),('10318','2012-12-31','15:20:00',2.54),('10318','2012-12-31','15:25:00',2.4),('10318','2012-12-31','15:30:00',2.26),('10318','2012-12-31','15:35:00',2.11),('10318','2012-12-31','15:40:00',1.94),('10318','2012-12-31','15:45:00',1.75),('10318','2012-12-31','15:50:00',1.58),('10318','2012-12-31','15:55:00',1.42),('10318','2012-12-31','16:00:00',1.26),('10318','2012-12-31','16:05:00',1.06),('10318','2012-12-30','08:00:00',1.11),('10318','2012-12-30','08:05:00',1.35),('10318','2012-12-30','08:10:00',1.67),('10318','2012-12-30','08:15:00',1.93),('10318','2012-12-30','08:20:00',2.17),('10318','2012-12-30','08:25:00',2.44),('10318','2012-12-30','08:30:00',2.75),('10318','2012-12-30','08:35:00',3.02),('10318','2012-12-30','08:40:00',3.28),('10318','2012-12-30','08:45:00',3.5),('10318','2012-12-30','08:50:00',3.7),('10318','2012-12-30','08:55:00',3.87),('10318','2012-12-30','09:00:00',4.04),('10318','2012-12-30','09:05:00',4.2),('10318','2012-12-30','09:10:00',4.27),('10318','2012-12-30','09:15:00',4.52),('10318','2012-12-30','09:20:00',4.64),('10318','2012-12-30','09:25:00',4.79),('10318','2012-12-30','09:30:00',4.93),('10318','2012-12-30','09:35:00',5.09),('10318','2012-12-30','09:40:00',5.21),('10318','2012-12-30','09:45:00',5.38),('10318','2012-12-30','09:50:00',5.48),('10318','2012-12-30','09:55:00',5.58),('10318','2012-12-30','10:00:00',5.72),('10318','2012-12-30','10:05:00',5.83),('10318','2012-12-30','10:10:00',5.91),('10318','2012-12-30','10:15:00',6),('10318','2012-12-30','10:20:00',6.07),('10318','2012-12-30','10:25:00',6.18),('10318','2012-12-30','10:30:00',6.28),('10318','2012-12-30','10:35:00',6.34),('10318','2012-12-30','10:40:00',6.32),('10318','2012-12-30','10:45:00',6.4),('10318','2012-12-30','10:50:00',6.46),('10318','2012-12-30','10:55:00',6.36),('10318','2012-12-30','11:00:00',6.54),('10318','2012-12-30','11:05:00',6.58),('10318','2012-12-30','11:10:00',6.62),('10318','2012-12-30','11:15:00',6.62),('10318','2012-12-30','11:20:00',6.6),('10318','2012-12-30','11:25:00',6.59),('10318','2012-12-30','11:30:00',6.6),('10318','2012-12-30','11:35:00',6.57),('10318','2012-12-30','11:40:00',6.58),('10318','2012-12-30','11:45:00',6.61),('10318','2012-12-30','11:50:00',6.62),('10318','2012-12-30','11:55:00',6.61),('10318','2012-12-30','12:00:00',6.54),('10318','2012-12-30','12:05:00',6.52),('10318','2012-12-30','12:10:00',6.53),('10318','2012-12-30','12:15:00',6.48),('10318','2012-12-30','12:20:00',6.4),('10318','2012-12-30','12:25:00',6.28),('10318','2012-12-30','12:30:00',6.22),('10318','2012-12-30','12:35:00',6.23),('10318','2012-12-30','12:40:00',6.15),('10318','2012-12-30','12:45:00',6.18),('10318','2012-12-30','12:50:00',6.17),('10318','2012-12-30','12:55:00',6.06),('10318','2012-12-30','13:00:00',6.03),('10318','2012-12-30','13:05:00',5.92),('10318','2012-12-30','13:10:00',5.87),('10318','2012-12-30','13:15:00',5.77),('10318','2012-12-30','13:20:00',5.67),('10318','2012-12-30','13:25:00',5.6),('10318','2012-12-30','13:30:00',5.5),('10318','2012-12-30','13:35:00',5.41),('10318','2012-12-30','13:40:00',5.29),('10318','2012-12-30','13:45:00',5.18),('10318','2012-12-30','13:50:00',5.06),('10318','2012-12-30','13:55:00',4.94),('10318','2012-12-30','14:00:00',4.81),('10318','2012-12-30','14:05:00',4.67),('10318','2012-12-30','14:10:00',4.55),('10318','2012-12-30','14:15:00',4.36),('10318','2012-12-30','14:20:00',4.26),('10318','2012-12-30','14:25:00',4.09),('10318','2012-12-30','14:30:00',3.99),('10318','2012-12-30','14:35:00',3.84),('10318','2012-12-30','14:40:00',3.69),('10318','2012-12-30','14:45:00',3.54),('10318','2012-12-30','14:50:00',3.37),('10318','2012-12-30','14:55:00',3.25),('10318','2012-12-30','15:00:00',3.09),('10318','2012-12-30','15:05:00',2.96),('10318','2012-12-30','15:10:00',2.83),('10318','2012-12-30','15:15:00',2.69),('10318','2012-12-30','15:20:00',2.53),('10318','2012-12-30','15:25:00',2.37),('10318','2012-12-30','15:30:00',2.24),('10318','2012-12-30','15:35:00',2.06),('10318','2012-12-30','15:40:00',1.91),('10318','2012-12-30','15:45:00',1.79),('10318','2012-12-30','15:50:00',1.63),('10318','2012-12-30','15:55:00',1.45),('10318','2012-12-30','16:00:00',1.27),('10318','2012-12-30','16:05:00',1.12),('10318','2012-12-29','08:00:00',1),('10318','2012-12-29','08:05:00',1.28),('10318','2012-12-29','08:10:00',1.62),('10318','2012-12-29','08:15:00',1.87),('10318','2012-12-29','08:20:00',2.08),('10318','2012-12-29','08:25:00',2.37),('10318','2012-12-29','08:30:00',2.66),('10318','2012-12-29','08:35:00',2.94),('10318','2012-12-29','08:40:00',3.18),('10318','2012-12-29','08:45:00',3.38),('10318','2012-12-29','08:50:00',3.59),('10318','2012-12-29','08:55:00',3.81),('10318','2012-12-29','09:00:00',4),('10318','2012-12-29','09:05:00',4.17),('10318','2012-12-29','09:10:00',4.34),('10318','2012-12-29','09:15:00',4.49),('10318','2012-12-29','09:20:00',4.6),('10318','2012-12-29','09:25:00',4.66),('10318','2012-12-29','09:30:00',4.87),('10318','2012-12-29','09:35:00',5.06),('10318','2012-12-29','09:40:00',5.19),('10318','2012-12-29','09:45:00',5.31),('10318','2012-12-29','09:50:00',5.43),('10318','2012-12-29','09:55:00',5.58),('10318','2012-12-29','10:00:00',5.75),('10318','2012-12-29','10:05:00',5.88),('10318','2012-12-29','10:10:00',6),('10318','2012-12-29','10:15:00',6.1),('10318','2012-12-29','10:20:00',6.2),('10318','2012-12-29','10:25:00',6.26),('10318','2012-12-29','10:30:00',6.37),('10318','2012-12-29','10:35:00',6.43),('10318','2012-12-29','10:40:00',6.49),('10318','2012-12-29','10:45:00',6.49),('10318','2012-12-29','10:50:00',6.55),('10318','2012-12-29','10:55:00',6.65),('10318','2012-12-29','11:00:00',6.68),('10318','2012-12-29','11:05:00',6.68),('10318','2012-12-29','11:10:00',6.5),('10318','2012-12-29','11:15:00',6.63),('10318','2012-12-29','11:20:00',6.69),('10318','2012-12-29','11:25:00',6.68),('10318','2012-12-29','11:30:00',6.71),('10318','2012-12-29','11:35:00',6.72),('10318','2012-12-29','11:40:00',6.74),('10318','2012-12-29','11:45:00',6.78),('10318','2012-12-29','11:50:00',6.84),('10318','2012-12-29','11:55:00',6.86),('10318','2012-12-29','12:00:00',6.87),('10318','2012-12-29','12:05:00',6.82),('10318','2012-12-29','12:10:00',6.75),('10318','2012-12-29','12:15:00',6.74),('10318','2012-12-29','12:20:00',6.69),('10318','2012-12-29','12:25:00',6.64),('10318','2012-12-29','12:30:00',6.52),('10318','2012-12-29','12:35:00',6.42),('10318','2012-12-29','12:40:00',6.34),('10318','2012-12-29','12:45:00',6.3),('10318','2012-12-29','12:50:00',6.26),('10318','2012-12-29','12:55:00',6.06),('10318','2012-12-29','13:00:00',6.05),('10318','2012-12-29','13:05:00',6.06),('10318','2012-12-29','13:10:00',5.96),('10318','2012-12-29','13:15:00',5.75),('10318','2012-12-29','13:20:00',5.69),('10318','2012-12-29','13:25:00',5.63),('10318','2012-12-29','13:30:00',5.56),('10318','2012-12-29','13:35:00',5.45),('10318','2012-12-29','13:40:00',5.29),('10318','2012-12-29','13:45:00',5.2),('10318','2012-12-29','13:50:00',5.11),('10318','2012-12-29','13:55:00',5),('10318','2012-12-29','14:00:00',4.86),('10318','2012-12-29','14:05:00',4.71),('10318','2012-12-29','14:10:00',4.59),('10318','2012-12-29','14:15:00',4.49),('10318','2012-12-29','14:20:00',4.32),('10318','2012-12-29','14:25:00',4.18),('10318','2012-12-29','14:30:00',4.05),('10318','2012-12-29','14:35:00',3.93),('10318','2012-12-29','14:40:00',3.73),('10318','2012-12-29','14:45:00',3.66),('10318','2012-12-29','14:50:00',3.52),('10318','2012-12-29','14:55:00',3.38),('10318','2012-12-29','15:00:00',3.24),('10318','2012-12-29','15:05:00',3.07),('10318','2012-12-29','15:10:00',2.92),('10318','2012-12-29','15:15:00',2.79),('10318','2012-12-29','15:20:00',2.65),('10318','2012-12-29','15:25:00',2.5),('10318','2012-12-29','15:30:00',2.33),('10318','2012-12-29','15:35:00',2.17),('10318','2012-12-29','15:40:00',1.99),('10318','2012-12-29','15:45:00',1.86),('10318','2012-12-29','15:50:00',1.68),('10318','2012-12-29','15:55:00',1.52),('10318','2012-12-29','16:00:00',1.34),('10318','2012-12-29','16:05:00',1.17),('10318','2012-12-28','08:35:00',1.2),('10318','2012-12-28','08:40:00',2.66),('10318','2012-12-28','08:45:00',2.93),('10318','2012-12-28','08:50:00',3.18),('10318','2012-12-28','08:55:00',3.4),('10318','2012-12-28','09:00:00',3.61),('10318','2012-12-28','09:05:00',3.76),('10318','2012-12-28','09:10:00',3.98),('10318','2012-12-28','09:15:00',4.13),('10318','2012-12-28','09:20:00',4.25),('10318','2012-12-28','09:25:00',4.37),('10318','2012-12-28','09:30:00',4.48),('10318','2012-12-28','09:35:00',4.61),('10318','2012-12-28','09:40:00',4.8),('10318','2012-12-28','09:45:00',4.89),('10318','2012-12-28','09:50:00',4.94),('10318','2012-12-28','09:55:00',5.04),('10318','2012-12-28','10:00:00',5.14),('10318','2012-12-28','10:05:00',5.41),('10318','2012-12-28','10:10:00',5.54),('10318','2012-12-28','10:15:00',5.67),('10318','2012-12-28','10:20:00',5.78),('10318','2012-12-28','10:25:00',5.83),('10318','2012-12-28','10:30:00',5.86),('10318','2012-12-28','10:35:00',6.06),('10318','2012-12-28','10:40:00',6.07),('10318','2012-12-28','10:45:00',6.12),('10318','2012-12-28','10:50:00',6.14),('10318','2012-12-28','10:55:00',6.16),('10318','2012-12-28','11:00:00',6.19),('10318','2012-12-28','11:05:00',6.33),('10318','2012-12-28','11:10:00',6.44),('10318','2012-12-28','11:15:00',6.46),('10318','2012-12-28','11:20:00',6.35),('10318','2012-12-28','11:25:00',6.56),('10318','2012-12-28','11:30:00',6.5),('10318','2012-12-28','11:35:00',6.56),('10318','2012-12-28','11:40:00',6.49),('10318','2012-12-28','11:45:00',5.88),('10318','2012-12-28','11:50:00',6.61),('10318','2012-12-28','11:55:00',6.55),('10318','2012-12-28','12:00:00',6.49),('10318','2012-12-28','12:05:00',6.49),('10318','2012-12-28','12:10:00',6.46),('10318','2012-12-28','12:15:00',6.24),('10318','2012-12-28','12:20:00',6.34),('10318','2012-12-28','12:25:00',6.34),('10318','2012-12-28','12:30:00',6.26),('10318','2012-12-28','12:35:00',6.18),('10318','2012-12-28','12:40:00',6.07),('10318','2012-12-28','12:45:00',5.97),('10318','2012-12-28','12:50:00',5.93),('10318','2012-12-28','12:55:00',5.81),('10318','2012-12-28','13:00:00',5.75),('10318','2012-12-28','13:05:00',5.74),('10318','2012-12-28','13:10:00',5.55),('10318','2012-12-28','13:15:00',5.29),('10318','2012-12-28','13:20:00',5.24),('10318','2012-12-28','13:25:00',2.45),('10318','2012-12-28','13:30:00',4.5),('10318','2012-12-28','13:35:00',4.91),('10318','2012-12-28','13:40:00',4.72),('10318','2012-12-28','13:45:00',4.77),('10318','2012-12-28','13:50:00',4.61),('10318','2012-12-28','13:55:00',4.53),('10318','2012-12-28','14:00:00',4.45),('10318','2012-12-28','14:05:00',4.3),('10318','2012-12-28','14:10:00',4.19),('10318','2012-12-28','14:15:00',3.82),('10318','2012-12-28','14:20:00',2.3),('10318','2012-12-28','14:25:00',3.84),('10318','2012-12-28','14:30:00',3.81),('10318','2012-12-28','14:35:00',3.65),('10318','2012-12-28','14:40:00',3.44),('10318','2012-12-28','14:45:00',3.26),('10318','2012-12-28','14:50:00',3.14),('10318','2012-12-28','14:55:00',2.99),('10318','2012-12-28','15:00:00',2.89),('10318','2012-12-28','15:05:00',2.78),('10318','2012-12-28','15:10:00',2.63),('10318','2012-12-28','15:15:00',2.46),('10318','2012-12-28','15:20:00',2.35),('10318','2012-12-28','15:25:00',2.18),('10318','2012-12-28','15:30:00',2.03),('10318','2012-12-28','15:35:00',1.85),('10318','2012-12-28','15:40:00',1.67),('10318','2012-12-28','15:45:00',1.51),('10318','2012-12-28','15:50:00',1.36),('10318','2012-12-28','15:55:00',1.2),('10318','2012-12-28','16:00:00',1.05),('10318','2012-12-27','08:50:00',1.04),('10318','2012-12-27','08:55:00',1.05),('10318','2012-12-27','09:05:00',1.29),('10318','2012-12-27','09:10:00',1.93),('10318','2012-12-27','09:15:00',1.66),('10318','2012-12-27','09:20:00',2.07),('10318','2012-12-27','09:25:00',4.59),('10318','2012-12-27','09:30:00',4.2),('10318','2012-12-27','09:35:00',4.42),('10318','2012-12-27','09:40:00',5.03),('10318','2012-12-27','09:45:00',5.22),('10318','2012-12-27','09:50:00',4.38),('10318','2012-12-27','09:55:00',3.9),('10318','2012-12-27','10:00:00',2.67),('10318','2012-12-27','10:05:00',5.38),('10318','2012-12-27','10:10:00',5.21),('10318','2012-12-27','10:15:00',5.4),('10318','2012-12-27','10:20:00',3.54),('10318','2012-12-27','10:25:00',5.31),('10318','2012-12-27','10:30:00',5.75),('10318','2012-12-27','10:35:00',5.51),('10318','2012-12-27','10:40:00',1.75),('10318','2012-12-27','10:45:00',5.34),('10318','2012-12-27','10:50:00',5.54),('10318','2012-12-27','10:55:00',5.16),('10318','2012-12-27','11:00:00',5.62),('10318','2012-12-27','11:05:00',5.38),('10318','2012-12-27','11:10:00',2.56),('10318','2012-12-27','11:15:00',3.07),('10318','2012-12-27','11:20:00',1.73),('10318','2012-12-27','11:25:00',1.46),('10318','2012-12-27','11:30:00',2.58),('10318','2012-12-27','11:35:00',3.93),('10318','2012-12-27','11:40:00',6.06),('10318','2012-12-27','11:45:00',6.49),('10318','2012-12-27','11:50:00',6.94),('10318','2012-12-27','11:55:00',5.31),('10318','2012-12-27','12:00:00',2.1),('10318','2012-12-27','12:05:00',3.44),('10318','2012-12-27','12:10:00',5.69),('10318','2012-12-27','12:15:00',5.51),('10318','2012-12-27','12:20:00',5.65),('10318','2012-12-27','12:25:00',6.03),('10318','2012-12-27','12:30:00',4.84),('10318','2012-12-27','12:35:00',2.54),('10318','2012-12-27','12:40:00',6.14),('10318','2012-12-27','12:45:00',5.68),('10318','2012-12-27','12:50:00',6.32),('10318','2012-12-27','12:55:00',6.42),('10318','2012-12-27','13:00:00',5.63),('10318','2012-12-27','13:05:00',3.34),('10318','2012-12-27','13:10:00',2.29),('10318','2012-12-27','13:15:00',3.12),('10318','2012-12-27','13:20:00',2.76),('10318','2012-12-27','13:25:00',1.68),('10318','2012-12-27','13:45:00',1),('10318','2012-12-27','13:50:00',2.25),('10318','2012-12-27','13:55:00',2.45),('10318','2012-12-27','14:00:00',4.4),('10318','2012-12-27','14:05:00',3.92),('10318','2012-12-27','14:10:00',4.36),('10318','2012-12-27','14:15:00',4.18),('10318','2012-12-27','14:20:00',4.08),('10318','2012-12-27','14:25:00',3.91),('10318','2012-12-27','14:30:00',3.68),('10318','2012-12-27','14:35:00',2.75),('10318','2012-12-27','14:40:00',1.04),('10318','2012-12-27','14:50:00',1.52),('10318','2012-12-27','14:55:00',3.54),('10318','2012-12-27','15:00:00',2.78),('10318','2012-12-27','15:05:00',1.56),('10318','2012-12-27','15:10:00',1.27),('10318','2012-12-27','15:20:00',1.28),('10318','2012-12-27','15:25:00',2.31),('10318','2012-12-27','15:30:00',1.75),('10318','2012-12-27','15:35:00',1.98),('10318','2012-12-27','15:40:00',1.76),('10318','2012-12-27','15:45:00',1.64),('10318','2012-12-27','15:50:00',1.32),('10318','2012-12-27','15:55:00',1.02),('10318','2012-12-26','08:55:00',1.08),('10318','2012-12-26','09:00:00',1.54),('10318','2012-12-26','09:05:00',1.51),('10318','2012-12-26','09:10:00',2.43),('10318','2012-12-26','09:15:00',4.07),('10318','2012-12-26','09:20:00',4.39),('10318','2012-12-26','09:25:00',4.51),('10318','2012-12-26','09:30:00',4.62),('10318','2012-12-26','09:35:00',4.7),('10318','2012-12-26','09:40:00',4.78),('10318','2012-12-26','09:45:00',4.95),('10318','2012-12-26','09:50:00',5.05),('10318','2012-12-26','09:55:00',5.13),('10318','2012-12-26','10:00:00',5.26),('10318','2012-12-26','10:05:00',5.36),('10318','2012-12-26','10:10:00',5.41),('10318','2012-12-26','10:15:00',5.62),('10318','2012-12-26','10:20:00',5.62),('10318','2012-12-26','10:25:00',5.7),('10318','2012-12-26','10:30:00',5.72),('10318','2012-12-26','10:35:00',5.78),('10318','2012-12-26','10:40:00',5.81),('10318','2012-12-26','10:45:00',5.84),('10318','2012-12-26','10:50:00',5.85),('10318','2012-12-26','10:55:00',5.89),('10318','2012-12-26','11:00:00',5.84),('10318','2012-12-26','11:05:00',5.96),('10318','2012-12-26','11:10:00',5.93),('10318','2012-12-26','11:15:00',5.91),('10318','2012-12-26','11:20:00',6.01),('10318','2012-12-26','11:25:00',5.96),('10318','2012-12-26','11:30:00',6.17),('10318','2012-12-26','11:35:00',6.14),('10318','2012-12-26','11:40:00',6.14),('10318','2012-12-26','11:45:00',5.93),('10318','2012-12-26','11:50:00',6.12),('10318','2012-12-26','11:55:00',6.06),('10318','2012-12-26','12:00:00',6.58),('10318','2012-12-26','12:05:00',6.36),('10318','2012-12-26','12:10:00',6.77),('10318','2012-12-26','12:15:00',6.57),('10318','2012-12-26','12:20:00',6.5),('10318','2012-12-26','12:25:00',6.48),('10318','2012-12-26','12:30:00',6.53),('10318','2012-12-26','12:35:00',6.25),('10318','2012-12-26','12:40:00',5.23),('10318','2012-12-26','12:45:00',5.99),('10318','2012-12-26','12:50:00',4.77),('10318','2012-12-26','12:55:00',5.97),('10318','2012-12-26','13:00:00',4.61),('10318','2012-12-26','13:05:00',5.94),('10318','2012-12-26','13:10:00',3.95),('10318','2012-12-26','13:15:00',5.18),('10318','2012-12-26','13:20:00',6.54),('10318','2012-12-26','13:25:00',5.62),('10318','2012-12-26','13:30:00',6.06),('10318','2012-12-26','13:35:00',6.42),('10318','2012-12-26','13:40:00',5.24),('10318','2012-12-26','13:45:00',5.54),('10318','2012-12-26','13:50:00',3.6),('10318','2012-12-26','13:55:00',3.47),('10318','2012-12-26','14:00:00',3.47),('10318','2012-12-26','14:05:00',2.88),('10318','2012-12-26','14:10:00',2.05),('10318','2012-12-26','14:15:00',1.88),('10318','2012-12-26','14:20:00',1.14),('10318','2012-12-26','14:25:00',1.39),('10318','2012-12-25','09:55:00',1.03),('10318','2012-12-25','10:00:00',1.23),('10318','2012-12-25','10:05:00',1.41),('10318','2012-12-25','10:10:00',1.48),('10318','2012-12-25','10:15:00',1.56),('10318','2012-12-25','10:20:00',1.74),('10318','2012-12-25','10:25:00',1.66),('10318','2012-12-25','10:30:00',1.68),('10318','2012-12-25','10:35:00',1.66),('10318','2012-12-25','10:40:00',1.5),('10318','2012-12-25','10:45:00',1.49),('10318','2012-12-25','10:50:00',1.51),('10318','2012-12-25','10:55:00',1.68),('10318','2012-12-25','11:00:00',1.81),('10318','2012-12-25','11:05:00',1.63),('10318','2012-12-25','11:10:00',1.87),('10318','2012-12-25','11:15:00',1.83),('10318','2012-12-25','11:20:00',1.9),('10318','2012-12-25','11:25:00',2.01),('10318','2012-12-25','11:30:00',1.81),('10318','2012-12-25','11:35:00',1.82),('10318','2012-12-25','11:40:00',1.94),('10318','2012-12-25','11:45:00',2.04),('10318','2012-12-25','11:50:00',1.93),('10318','2012-12-25','11:55:00',1.87),('10318','2012-12-25','12:00:00',1.89),('10318','2012-12-25','12:05:00',1.79),('10318','2012-12-25','12:10:00',1.53),('10318','2012-12-25','12:15:00',1.61),('10318','2012-12-25','12:20:00',1.73),('10318','2012-12-25','12:25:00',1.73),('10318','2012-12-25','12:30:00',1.67),('10318','2012-12-25','12:35:00',1.56),('10318','2012-12-25','12:40:00',1.64),('10318','2012-12-25','12:45:00',1.45),('10318','2012-12-25','12:50:00',1.55),('10318','2012-12-25','12:55:00',1.43),('10318','2012-12-25','13:00:00',1.54),('10318','2012-12-25','13:05:00',1.74),('10318','2012-12-25','13:10:00',2.02),('10318','2012-12-25','13:15:00',2.05),('10318','2012-12-25','13:20:00',2.23),('10318','2012-12-25','13:25:00',2.53),('10318','2012-12-25','13:30:00',2.03),('10318','2012-12-25','13:35:00',1.8),('10318','2012-12-25','13:40:00',1.75),('10318','2012-12-25','13:45:00',1.66),('10318','2012-12-25','13:50:00',1.47),('10318','2012-12-25','13:55:00',1.17),('10318','2012-12-25','14:00:00',1.3),('10318','2012-12-25','14:05:00',1.04),('10318','2012-12-25','14:35:00',1.07),('10318','2012-12-25','14:40:00',1.13),('10318','2012-12-25','14:45:00',1.1),('10318','2012-12-25','14:50:00',1.04),('10318','2012-12-25','15:05:00',1.07),('10318','2012-12-25','15:10:00',1.57),('10318','2012-12-25','15:15:00',1.75),('10318','2012-12-25','15:20:00',1.45),('10318','2012-12-25','15:25:00',1.37),('10318','2012-12-25','15:30:00',1.16),('10318','2012-12-25','15:35:00',1.23),('10318','2012-12-25','15:40:00',1.18),('10318','2012-12-25','15:45:00',1.02),('10318','2012-12-24','10:40:00',1.01),('10318','2012-12-24','10:45:00',1.06),('10318','2012-12-24','10:50:00',1.12),('10318','2012-12-24','10:55:00',1.18),('10318','2012-12-24','11:00:00',1.1),('10318','2012-12-24','11:05:00',1.02),('10318','2012-12-24','11:10:00',1.11),('10318','2012-12-24','11:15:00',1.19),('10318','2012-12-24','11:20:00',1.42),('10318','2012-12-24','11:25:00',1.53),('10318','2012-12-24','11:30:00',1.54),('10318','2012-12-24','11:35:00',1.5),('10318','2012-12-24','11:40:00',1.42),('10318','2012-12-24','11:45:00',1.36),('10318','2012-12-24','11:50:00',1.32),('10318','2012-12-24','11:55:00',1.36),('10318','2012-12-24','12:00:00',1.49),('10318','2012-12-24','12:05:00',1.66),('10318','2012-12-24','12:10:00',1.76),('10318','2012-12-24','12:15:00',1.76),('10318','2012-12-24','12:20:00',1.71),('10318','2012-12-24','12:25:00',1.75),('10318','2012-12-24','12:30:00',1.58),('10318','2012-12-24','12:35:00',1.59),('10318','2012-12-24','12:40:00',1.6),('10318','2012-12-24','12:45:00',1.41),('10318','2012-12-24','12:50:00',1.24),('10318','2012-12-24','12:55:00',1.34),('10318','2012-12-24','13:00:00',1.34),('10318','2012-12-24','13:05:00',1.32),('10318','2012-12-24','13:10:00',1.19),('10318','2012-12-24','13:15:00',1.21),('10318','2012-12-24','13:20:00',1.17),('10318','2012-12-24','13:25:00',1.17),('10318','2012-12-24','13:30:00',1.14),('10318','2012-12-24','13:35:00',1.13),('10318','2012-12-24','13:40:00',1.04),('10318','2012-12-24','13:45:00',1.07),('10318','2012-12-24','13:50:00',1.1),('10318','2012-12-24','13:55:00',1.07),('10318','2012-12-23','08:00:00',1.11),('10318','2012-12-23','08:05:00',1.38),('10318','2012-12-23','08:10:00',1.56),('10318','2012-12-23','08:15:00',1.9),('10318','2012-12-23','08:20:00',2.11),('10318','2012-12-23','08:25:00',2.3),('10318','2012-12-23','08:30:00',2.58),('10318','2012-12-23','08:35:00',2.92),('10318','2012-12-23','08:40:00',3.08),('10318','2012-12-23','08:45:00',3.33),('10318','2012-12-23','08:50:00',3.44),('10318','2012-12-23','08:55:00',3.74),('10318','2012-12-23','09:00:00',3.93),('10318','2012-12-23','09:05:00',4.1),('10318','2012-12-23','09:10:00',4.25),('10318','2012-12-23','09:15:00',4.33),('10318','2012-12-23','09:20:00',4.38),('10318','2012-12-23','09:25:00',4.63),('10318','2012-12-23','09:30:00',4.71),('10318','2012-12-23','09:35:00',4.84),('10318','2012-12-23','09:40:00',5),('10318','2012-12-23','09:45:00',5.09),('10318','2012-12-23','09:50:00',5.23),('10318','2012-12-23','09:55:00',5.39),('10318','2012-12-23','10:00:00',5.48),('10318','2012-12-23','10:05:00',5.59),('10318','2012-12-23','10:10:00',5.66),('10318','2012-12-23','10:15:00',5.68),('10318','2012-12-23','10:20:00',5.72),('10318','2012-12-23','10:25:00',5.43),('10318','2012-12-23','10:30:00',5.57),('10318','2012-12-23','10:35:00',5.76),('10318','2012-12-23','10:40:00',5.96),('10318','2012-12-23','10:45:00',6.07),('10318','2012-12-23','10:50:00',6.01),('10318','2012-12-23','10:55:00',5.8),('10318','2012-12-23','11:00:00',6.12),('10318','2012-12-23','11:05:00',6.22),('10318','2012-12-23','11:10:00',6.23),('10318','2012-12-23','11:15:00',6.3),('10318','2012-12-23','11:20:00',6.34),('10318','2012-12-23','11:25:00',5.98),('10318','2012-12-23','11:30:00',5.49),('10318','2012-12-23','11:35:00',6.34),('10318','2012-12-23','11:40:00',6.37),('10318','2012-12-23','11:45:00',6.23),('10318','2012-12-23','11:50:00',6.46),('10318','2012-12-23','11:55:00',5.78),('10318','2012-12-23','12:00:00',5.62),('10318','2012-12-23','12:05:00',5.67),('10318','2012-12-23','12:10:00',5.31),('10318','2012-12-23','12:15:00',3.84),('10318','2012-12-23','12:20:00',5.04),('10318','2012-12-23','12:25:00',4.3),('10318','2012-12-23','12:30:00',4.35),('10318','2012-12-23','12:35:00',4.51),('10318','2012-12-23','12:40:00',4.05),('10318','2012-12-23','12:45:00',3.1),('10318','2012-12-23','12:50:00',3.66),('10318','2012-12-23','12:55:00',4.74),('10318','2012-12-23','13:00:00',4.47),('10318','2012-12-23','13:05:00',5.16),('10318','2012-12-23','13:10:00',4.64),('10318','2012-12-23','13:15:00',3.48),('10318','2012-12-23','13:20:00',2.76),('10318','2012-12-23','13:25:00',2.72),('10318','2012-12-23','13:30:00',2.81),('10318','2012-12-23','13:35:00',3.71),('10318','2012-12-23','13:40:00',4.09),('10318','2012-12-23','13:45:00',3.5),('10318','2012-12-23','13:50:00',3.12),('10318','2012-12-23','13:55:00',3.56),('10318','2012-12-23','14:00:00',4.65),('10318','2012-12-23','14:05:00',4.15),('10318','2012-12-23','14:10:00',3.94),('10318','2012-12-23','14:15:00',3.78),('10318','2012-12-23','14:20:00',2.68),('10318','2012-12-23','14:25:00',1.98),('10318','2012-12-23','14:30:00',2.34),('10318','2012-12-23','14:35:00',2.64),('10318','2012-12-23','14:40:00',2.96),('10318','2012-12-23','14:45:00',3.1),('10318','2012-12-23','14:50:00',1.94),('10318','2012-12-23','14:55:00',1.53),('10318','2012-12-23','15:00:00',1.75),('10318','2012-12-23','15:05:00',1.58),('10318','2012-12-23','15:10:00',1.8),('10318','2012-12-23','15:15:00',1.08),('10318','2012-12-23','15:45:00',1.45),('10318','2014-05-01','07:35:00',2.14),('10318','2014-05-01','07:40:00',2.18),('10318','2014-05-01','07:45:00',2.07),('10318','2014-05-01','07:50:00',3.74),('10318','2014-05-01','07:55:00',3.96),('10318','2014-05-01','08:00:00',4.27),('10318','2014-05-01','08:05:00',4.09),('10318','2014-05-01','08:10:00',4.45),('10318','2014-05-01','08:15:00',4.6),('10318','2014-05-01','08:20:00',4.79),('10318','2014-05-01','08:25:00',4.99),('10318','2014-05-01','08:30:00',5.22),('10318','2014-05-01','08:35:00',5.43),('10318','2014-05-01','08:40:00',5.61),('10318','2014-05-01','08:45:00',5.81),('10318','2014-05-01','08:50:00',4.88),('10318','2014-05-01','08:55:00',3.39),('10318','2014-05-01','09:00:00',2.83),('10318','2014-05-01','09:05:00',4.61),('10318','2014-05-01','09:10:00',4.21),('10318','2014-05-01','09:15:00',5.74),('10318','2014-05-01','09:20:00',7.59),('10318','2014-05-01','09:25:00',7.02),('10318','2014-05-01','09:30:00',7.41),('10318','2014-05-01','09:35:00',6.48),('10318','2014-05-01','09:40:00',9.54),('10318','2014-05-01','09:45:00',3.68),('10318','2014-05-01','09:50:00',4.32),('10318','2014-05-01','09:55:00',2.9),('10318','2014-05-01','10:00:00',4.05),('10318','2014-05-01','10:05:00',3.11),('10318','2014-05-01','10:10:00',3.3),('10318','2014-05-01','10:15:00',6.61),('10318','2014-05-01','10:20:00',5.65),('10318','2014-05-01','10:25:00',7.33),('10318','2014-05-01','10:30:00',4.56),('10318','2014-05-01','10:35:00',8.86),('10318','2014-05-01','10:40:00',10.04),('10318','2014-05-01','10:45:00',9.99),('10318','2014-05-01','10:50:00',8.12),('10318','2014-05-01','10:55:00',10.71),('10318','2014-05-01','11:00:00',9.96),('10318','2014-05-01','11:05:00',10.84),('10318','2014-05-01','11:10:00',3.92),('10318','2014-05-01','11:15:00',5.73),('10318','2014-05-01','11:20:00',10.88),('10318','2014-05-01','11:25:00',10.67),('10318','2014-05-01','11:30:00',9.11),('10318','2014-05-01','11:35:00',6.72),('10318','2014-05-01','11:40:00',7.66),('10318','2014-05-01','11:45:00',9.81),('10318','2014-05-01','11:50:00',9.33),('10318','2014-05-01','11:55:00',2.4),('10318','2014-05-01','12:00:00',4.07),('10318','2014-05-01','12:05:00',10.34),('10318','2014-05-01','12:10:00',10.37),('10318','2014-05-01','12:15:00',10.39),('10318','2014-05-01','12:20:00',10.44),('10318','2014-05-01','12:25:00',10.67),('10318','2014-05-01','12:30:00',10.22),('10318','2014-05-01','12:35:00',7.23),('10318','2014-05-01','12:40:00',5.96),('10318','2014-05-01','12:45:00',2.53),('10318','2014-05-01','12:50:00',2.79),('10318','2014-05-01','12:55:00',3.65),('10318','2014-05-01','13:00:00',8.92),('10318','2014-05-01','13:05:00',2.2),('10318','2014-05-01','13:10:00',10.42),('10318','2014-05-01','13:15:00',10.5),('10318','2014-05-01','13:20:00',10.54),('10318','2014-05-01','13:25:00',9.69),('10318','2014-05-01','13:30:00',5.26),('10318','2014-05-01','13:35:00',6.19),('10318','2014-05-01','13:40:00',2.94),('10318','2014-05-01','13:45:00',6.99),('10318','2014-05-01','13:50:00',4.36),('10318','2014-05-01','13:55:00',9.07),('10318','2014-05-01','14:00:00',10),('10318','2014-05-01','14:05:00',9.98),('10318','2014-05-01','14:10:00',9.75),('10318','2014-05-01','14:15:00',9.43),('10318','2014-05-01','14:20:00',9.05),('10318','2014-05-01','14:25:00',9),('10318','2014-05-01','14:30:00',8.68),('10318','2014-05-01','14:35:00',8.58),('10318','2014-05-01','14:40:00',9.06),('10318','2014-05-01','14:45:00',8.99),('10318','2014-05-01','14:50:00',8.72),('10318','2014-05-01','14:55:00',7.53),('10318','2014-05-01','15:00:00',3.87),('10318','2014-05-01','15:05:00',2.72),('10318','2014-05-01','15:10:00',6.21),('10318','2014-05-01','15:15:00',8.56),('10318','2014-05-01','15:20:00',8.22),('10318','2014-05-01','15:25:00',8.06),('10318','2014-05-01','15:30:00',7.78),('10318','2014-05-01','15:35:00',7.59),('10318','2014-05-01','15:40:00',7.43),('10318','2014-05-01','15:45:00',7.14),('10318','2014-05-01','15:50:00',6.9),('10318','2014-05-01','15:55:00',6.87),('10318','2014-05-01','16:00:00',6.83),('10318','2014-05-01','16:05:00',6.65),('10318','2014-05-01','16:10:00',6.43),('10318','2014-05-01','16:15:00',6.21),('10318','2014-05-01','16:20:00',5.85),('10318','2014-05-01','16:25:00',5.55),('10318','2014-05-01','16:30:00',5.58),('10318','2014-05-01','16:35:00',5.51),('10318','2014-05-01','16:40:00',5.08),('10318','2014-05-01','16:45:00',4.28),('10318','2014-05-01','16:50:00',4.5),('10318','2014-05-01','16:55:00',4.47),('10318','2014-05-01','17:00:00',3.8),('10318','2014-05-01','17:05:00',4.41),('10318','2014-05-01','17:10:00',4.3),('10318','2014-05-01','17:15:00',4.04),('10318','2014-05-01','17:20:00',3.83),('10318','2014-05-01','17:25:00',3.54),('10318','2014-05-01','17:30:00',3.19),('10318','2014-05-01','17:35:00',3.32),('10318','2014-05-01','17:40:00',2.38),('10318','2014-05-01','17:45:00',2.57),('10318','2014-05-01','17:50:00',2.6),('10318','2014-05-01','17:55:00',2.44),('10318','2014-05-01','18:00:00',1.89),('10318','2014-05-01','18:05:00',2.12),('10318','2014-05-01','18:10:00',1.97),('10318','2014-05-01','18:15:00',1.75),('10318','2014-05-01','18:20:00',1.58),('10318','2014-05-01','18:25:00',1.39),('10318','2014-05-01','18:30:00',1.32),('10318','2014-05-01','18:35:00',1.18),('10318','2014-03-17','08:25:00',1.03),('10318','2014-03-17','08:30:00',1.14),('10318','2014-03-17','08:35:00',1.27),('10318','2014-03-17','08:40:00',1.49),('10318','2014-03-17','08:45:00',1.82),('10318','2014-03-17','08:50:00',1.61),('10318','2014-03-17','08:55:00',1.81),('10318','2014-03-17','09:00:00',1.8),('10318','2014-03-17','09:05:00',1.79),('10318','2014-03-17','09:10:00',1.95),('10318','2014-03-17','09:15:00',2.53),('10318','2014-03-17','09:20:00',3.79),('10318','2014-03-17','09:25:00',3.3),('10318','2014-03-17','09:30:00',3.34),('10318','2014-03-17','09:35:00',3.68),('10318','2014-03-17','09:40:00',3.72),('10318','2014-03-17','09:45:00',4.09),('10318','2014-03-17','09:50:00',4.57),('10318','2014-03-17','09:55:00',3.72),('10318','2014-03-17','10:00:00',3.84),('10318','2014-03-17','10:05:00',3.33),('10318','2014-03-17','10:10:00',3.45),('10318','2014-03-17','10:15:00',3.66),('10318','2014-03-17','10:20:00',4.14),('10318','2014-03-17','10:25:00',2.48),('10318','2014-03-17','10:30:00',2.78),('10318','2014-03-17','10:35:00',2.79),('10318','2014-03-17','10:40:00',3.15),('10318','2014-03-17','10:45:00',2.59),('10318','2014-03-17','10:50:00',2.65),('10318','2014-03-17','10:55:00',3.38),('10318','2014-03-17','11:00:00',2.98),('10318','2014-03-17','11:05:00',3.31),('10318','2014-03-17','11:10:00',3.63),('10318','2014-03-17','11:15:00',3.54),('10318','2014-03-17','11:20:00',2.83),('10318','2014-03-17','11:25:00',2.95),('10318','2014-03-17','11:30:00',3.68),('10318','2014-03-17','11:35:00',3.07),('10318','2014-03-17','11:40:00',2.9),('10318','2014-03-17','11:45:00',2.9),('10318','2014-03-17','11:50:00',2.87),('10318','2014-03-17','11:55:00',4.05),('10318','2014-03-17','12:00:00',3.12),('10318','2014-03-17','12:05:00',3.1),('10318','2014-03-17','12:10:00',5.56),('10318','2014-03-17','12:15:00',5.48),('10318','2014-03-17','12:20:00',3.79),('10318','2014-03-17','12:25:00',4.6),('10318','2014-03-17','12:30:00',4.17),('10318','2014-03-17','12:35:00',5.35),('10318','2014-03-17','12:40:00',6.07),('10318','2014-03-17','12:45:00',9.44),('10318','2014-03-17','12:50:00',9.07),('10318','2014-03-17','12:55:00',8.69),('10318','2014-03-17','13:00:00',5.59),('10318','2014-03-17','13:05:00',8.18),('10318','2014-03-17','13:10:00',6.23),('10318','2014-03-17','13:15:00',5.44),('10318','2014-03-17','13:20:00',8.42),('10318','2014-03-17','13:25:00',7.28),('10318','2014-03-17','13:30:00',7.65),('10318','2014-03-17','13:35:00',6.29),('10318','2014-03-17','13:40:00',6.64),('10318','2014-03-17','13:45:00',4.65),('10318','2014-03-17','13:50:00',6.76),('10318','2014-03-17','13:55:00',4.43),('10318','2014-03-17','14:00:00',6.26),('10318','2014-03-17','14:05:00',6.12),('10318','2014-03-17','14:10:00',4.66),('10318','2014-03-17','14:15:00',7.85),('10318','2014-03-17','14:20:00',5.61),('10318','2014-03-17','14:25:00',4.19),('10318','2014-03-17','14:30:00',3.45),('10318','2014-03-17','14:35:00',4.5),('10318','2014-03-17','14:40:00',5.29),('10318','2014-03-17','14:45:00',6.15),('10318','2014-03-17','14:50:00',6.41),('10318','2014-03-17','14:55:00',6.08),('10318','2014-03-17','15:00:00',5.22),('10318','2014-03-17','15:05:00',4.63),('10318','2014-03-17','15:10:00',3.46),('10318','2014-03-17','15:15:00',4.03),('10318','2014-03-17','15:20:00',5.33),('10318','2014-03-17','15:25:00',5.19),('10318','2014-03-17','15:30:00',4.95),('10318','2014-03-17','15:35:00',4.43),('10318','2014-03-17','15:40:00',3.91),('10318','2014-03-17','15:45:00',2.33),('10318','2014-03-17','15:50:00',3.18),('10318','2014-03-17','15:55:00',3.41),('10318','2014-03-17','16:00:00',3.55),('10318','2014-03-17','16:05:00',3.24),('10318','2014-03-17','16:10:00',3.05),('10318','2014-03-17','16:15:00',3.06),('10318','2014-03-17','16:20:00',2.89),('10318','2014-03-17','16:25:00',2.62),('10318','2014-03-17','16:30:00',2.45),('10318','2014-03-17','16:35:00',2.25),('10318','2014-03-17','16:40:00',1.98),('10318','2014-03-17','16:45:00',1.99),('10318','2014-03-17','16:50:00',1.69),('10318','2014-03-17','16:55:00',1.49),('10318','2014-03-17','17:00:00',1.43),('10318','2014-03-17','17:05:00',1.12),('10318','2012-12-22','09:25:00',1.25),('10318','2012-12-22','09:30:00',1.6),('10318','2012-12-22','09:35:00',1.77),('10318','2012-12-22','09:40:00',2.31),('10318','2012-12-22','09:45:00',1.76),('10318','2012-12-22','09:50:00',1.49),('10318','2012-12-22','09:55:00',1.67),('10318','2012-12-22','10:00:00',1.84),('10318','2012-12-22','10:05:00',1.87),('10318','2012-12-22','10:10:00',1.95),('10318','2012-12-22','10:15:00',2.11),('10318','2012-12-22','10:20:00',2.61),('10318','2012-12-22','10:25:00',4.06),('10318','2012-12-22','10:30:00',6.19),('10318','2012-12-22','10:35:00',7.26),('10318','2012-12-22','10:40:00',7.82),('10318','2012-12-22','10:45:00',6.75),('10318','2012-12-22','10:50:00',4.62),('10318','2012-12-22','10:55:00',3.42),('10318','2012-12-22','11:00:00',2.2),('10318','2012-12-22','11:05:00',1.9),('10318','2012-12-22','11:10:00',1.25),('10318','2012-12-22','11:15:00',1.27),('10318','2012-12-22','11:20:00',2.32),('10318','2012-12-22','11:25:00',1.56),('10318','2012-12-22','11:30:00',2.28),('10318','2012-12-22','11:35:00',5.03),('10318','2012-12-22','11:40:00',5.71),('10318','2012-12-22','11:45:00',2.1),('10318','2012-12-22','11:50:00',2.44),('10318','2012-12-22','11:55:00',3.03),('10318','2012-12-22','12:00:00',1.5),('10318','2012-12-22','12:05:00',1.88),('10318','2012-12-22','12:10:00',2.48),('10318','2012-12-22','12:15:00',3.36),('10318','2012-12-22','12:20:00',2.2),('10318','2012-12-22','12:25:00',2.26),('10318','2012-12-22','12:30:00',2.11),('10318','2012-12-22','12:35:00',5.37),('10318','2012-12-22','12:40:00',7.65),('10318','2012-12-22','12:45:00',7.75),('10318','2012-12-22','12:50:00',3.54),('10318','2012-12-22','12:55:00',2.58),('10318','2012-12-22','13:00:00',2.77),('10318','2012-12-22','13:05:00',3.9),('10318','2012-12-22','13:10:00',7.75),('10318','2012-12-22','13:15:00',7.25),('10318','2012-12-22','13:20:00',6.92),('10318','2012-12-22','13:25:00',6.84),('10318','2012-12-22','13:30:00',6.63),('10318','2012-12-22','13:35:00',4.33),('10318','2012-12-22','13:40:00',4.5),('10318','2012-12-22','13:45:00',5.44),('10318','2012-12-22','13:50:00',2.92),('10318','2012-12-22','13:55:00',2.35),('10318','2012-12-22','14:00:00',1.81),('10318','2012-12-22','14:05:00',4.82),('10318','2012-12-22','14:10:00',4.49),('10318','2012-12-22','14:15:00',2.07),('10318','2012-12-22','14:20:00',1.76),('10318','2012-12-22','14:25:00',1.22),('10318','2012-12-22','14:45:00',1.03),('10318','2012-12-22','14:50:00',2.09),('10318','2012-12-22','14:55:00',3.55),('10318','2012-12-22','15:00:00',2.45),('10318','2012-12-22','15:05:00',1.25),('10318','2012-12-22','15:10:00',1.17),('10318','2012-12-22','15:15:00',1.22),('10318','2012-12-22','15:50:00',1.24),('10318','2012-12-22','15:55:00',1.24),('10318','2012-12-22','16:00:00',1.02),('10318','2014-03-16','07:10:00',1.09),('10318','2014-03-16','07:15:00',1.32),('10318','2014-03-16','07:20:00',1.46),('10318','2014-03-16','07:25:00',1.62),('10318','2014-03-16','07:30:00',1.92),('10318','2014-03-16','07:35:00',2.26),('10318','2014-03-16','07:40:00',2.39),('10318','2014-03-16','07:45:00',2.5),('10318','2014-03-16','07:50:00',2.58),('10318','2014-03-16','07:55:00',2.98),('10318','2014-03-16','08:00:00',3.36),('10318','2014-03-16','08:05:00',3.62),('10318','2014-03-16','08:10:00',3.74),('10318','2014-03-16','08:15:00',3.86),('10318','2014-03-16','08:20:00',4.12),('10318','2014-03-16','08:25:00',4.46),('10318','2014-03-16','08:30:00',4.69),('10318','2014-03-16','08:35:00',4.87),('10318','2014-03-16','08:40:00',4.95),('10318','2014-03-16','08:45:00',5.2),('10318','2014-03-16','08:50:00',5.35),('10318','2014-03-16','08:55:00',5.46),('10318','2014-03-16','09:00:00',5.39),('10318','2014-03-16','09:05:00',5.6),('10318','2014-03-16','09:10:00',5.84),('10318','2014-03-16','09:15:00',6.3),('10318','2014-03-16','09:20:00',6.33),('10318','2014-03-16','09:25:00',6.22),('10318','2014-03-16','09:30:00',6.39),('10318','2014-03-16','09:35:00',6.44),('10318','2014-03-16','09:40:00',6.6),('10318','2014-03-16','09:45:00',6.84),('10318','2014-03-16','09:50:00',7.26),('10318','2014-03-16','09:55:00',7),('10318','2014-03-16','10:00:00',7.16),('10318','2014-03-16','10:05:00',7.45),('10318','2014-03-16','10:10:00',7.42),('10318','2014-03-16','10:15:00',7.72),('10318','2014-03-16','10:20:00',7.71),('10318','2014-03-16','10:25:00',7.64),('10318','2014-03-16','10:30:00',7.75),('10318','2014-03-16','10:35:00',7.77),('10318','2014-03-16','10:40:00',7.89),('10318','2014-03-16','10:45:00',8.07),('10318','2014-03-16','10:50:00',8.14),('10318','2014-03-16','10:55:00',8.16),('10318','2014-03-16','11:00:00',7.5),('10318','2014-03-16','11:05:00',5.56),('10318','2014-03-16','11:10:00',8.22),('10318','2014-03-16','11:15:00',8.11),('10318','2014-03-16','11:20:00',8.49),('10318','2014-03-16','11:25:00',8.51),('10318','2014-03-16','11:30:00',8.48),('10318','2014-03-16','11:35:00',8.4),('10318','2014-03-16','11:40:00',8.45),('10318','2014-03-16','11:45:00',8.46),('10318','2014-03-16','11:50:00',8.32),('10318','2014-03-16','11:55:00',8.22),('10318','2014-03-16','12:00:00',8.16),('10318','2014-03-16','12:05:00',8.22),('10318','2014-03-16','12:10:00',8.3),('10318','2014-03-16','12:15:00',8.23),('10318','2014-03-16','12:20:00',8.09),('10318','2014-03-16','12:25:00',7.91),('10318','2014-03-16','12:30:00',8.06),('10318','2014-03-16','12:35:00',8.06),('10318','2014-03-16','12:40:00',8.07),('10318','2014-03-16','12:45:00',8.06),('10318','2014-03-16','12:50:00',8.13),('10318','2014-03-16','12:55:00',7.9),('10318','2014-03-16','13:00:00',6.3),('10318','2014-03-16','13:05:00',8.05),('10318','2014-03-16','13:10:00',7.88),('10318','2014-03-16','13:15:00',7.79),('10318','2014-03-16','13:20:00',7.51),('10318','2014-03-16','13:25:00',7.59),('10318','2014-03-16','13:30:00',7.4),('10318','2014-03-16','13:35:00',7.5),('10318','2014-03-16','13:40:00',7.49),('10318','2014-03-16','13:45:00',7.45),('10318','2014-03-16','13:50:00',7.19),('10318','2014-03-16','13:55:00',7.14),('10318','2014-03-16','14:00:00',7.01),('10318','2014-03-16','14:05:00',6.81),('10318','2014-03-16','14:10:00',6.55),('10318','2014-03-16','14:15:00',6.62),('10318','2014-03-16','14:20:00',6.41),('10318','2014-03-16','14:25:00',6.34),('10318','2014-03-16','14:30:00',6.21),('10318','2014-03-16','14:35:00',6.02),('10318','2014-03-16','14:40:00',5.93),('10318','2014-03-16','14:45:00',5.86),('10318','2014-03-16','14:50:00',5.23),('10318','2014-03-16','14:55:00',5.38),('10318','2014-03-16','15:00:00',5.25),('10318','2014-03-16','15:05:00',5.13),('10318','2014-03-16','15:10:00',4.81),('10318','2014-03-16','15:15:00',4.08),('10318','2014-03-16','15:20:00',3.72),('10318','2014-03-16','15:25:00',4.11),('10318','2014-03-16','15:30:00',3.75),('10318','2014-03-16','15:35:00',3.35),('10318','2014-03-16','15:40:00',2.89),('10318','2014-03-16','15:45:00',2.99),('10318','2014-03-16','15:50:00',3.03),('10318','2014-03-16','15:55:00',2.85),('10318','2014-03-16','16:00:00',2.35),('10318','2014-03-16','16:05:00',2.95),('10318','2014-03-16','16:10:00',3.08),('10318','2014-03-16','16:15:00',2.92),('10318','2014-03-16','16:20:00',2.79),('10318','2014-03-16','16:25:00',2.55),('10318','2014-03-16','16:30:00',2.65),('10318','2014-03-16','16:35:00',2.53),('10318','2014-03-16','16:40:00',2.12),('10318','2014-03-16','16:45:00',1.89),('10318','2014-03-16','16:50:00',1.76),('10318','2014-03-16','16:55:00',1.42),('10318','2014-03-16','17:00:00',1.2),('10318','2014-03-16','17:05:00',1.09),('10318','2014-03-15','07:15:00',1.12),('10318','2014-03-15','07:20:00',1.29),('10318','2014-03-15','07:25:00',1.44),('10318','2014-03-15','07:30:00',1.68),('10318','2014-03-15','07:35:00',2.08),('10318','2014-03-15','07:40:00',2.28),('10318','2014-03-15','07:45:00',2.48),('10318','2014-03-15','07:50:00',2.74),('10318','2014-03-15','07:55:00',2.98),('10318','2014-03-15','08:00:00',3.19),('10318','2014-03-15','08:05:00',3.42),('10318','2014-03-15','08:10:00',3.6),('10318','2014-03-15','08:15:00',3.8),('10318','2014-03-15','08:20:00',4.05),('10318','2014-03-15','08:25:00',4.25),('10318','2014-03-15','08:30:00',4.44),('10318','2014-03-15','08:35:00',4.61),('10318','2014-03-15','08:40:00',4.75),('10318','2014-03-15','08:45:00',4.91),('10318','2014-03-15','08:50:00',5.16),('10318','2014-03-15','08:55:00',5.36),('10318','2014-03-15','09:00:00',5.43),('10318','2014-03-15','09:05:00',5.68),('10318','2014-03-15','09:10:00',5.82),('10318','2014-03-15','09:15:00',5.99),('10318','2014-03-15','09:20:00',6.09),('10318','2014-03-15','09:25:00',6.22),('10318','2014-03-15','09:30:00',6.31),('10318','2014-03-15','09:35:00',6.52),('10318','2014-03-15','09:40:00',6.66),('10318','2014-03-15','09:45:00',6.78),('10318','2014-03-15','09:50:00',6.9),('10318','2014-03-15','09:55:00',7.02),('10318','2014-03-15','10:00:00',7.07),('10318','2014-03-15','10:05:00',7.23),('10318','2014-03-15','10:10:00',7.25),('10318','2014-03-15','10:15:00',7.31),('10318','2014-03-15','10:20:00',7.39),('10318','2014-03-15','10:25:00',7.42),('10318','2014-03-15','10:30:00',7.48),('10318','2014-03-15','10:35:00',7.56),('10318','2014-03-15','10:40:00',7.58),('10318','2014-03-15','10:45:00',7.23),('10318','2014-03-15','10:50:00',7.61),('10318','2014-03-15','10:55:00',7.79),('10318','2014-03-15','11:00:00',7.69),('10318','2014-03-15','11:05:00',8.02),('10318','2014-03-15','11:10:00',8.14),('10318','2014-03-15','11:15:00',8.04),('10318','2014-03-15','11:20:00',8.21),('10318','2014-03-15','11:25:00',8.1),('10318','2014-03-15','11:30:00',8.1),('10318','2014-03-15','11:35:00',8.15),('10318','2014-03-15','11:40:00',8.29),('10318','2014-03-15','11:45:00',8.21),('10318','2014-03-15','11:50:00',8.2),('10318','2014-03-15','11:55:00',8.15),('10318','2014-03-15','12:00:00',8.17),('10318','2014-03-15','12:05:00',8.29),('10318','2014-03-15','12:10:00',8.03),('10318','2014-03-15','12:15:00',8.25),('10318','2014-03-15','12:20:00',8.21),('10318','2014-03-15','12:25:00',8.3),('10318','2014-03-15','12:30:00',8.24),('10318','2014-03-15','12:35:00',7.96),('10318','2014-03-15','12:40:00',8.09),('10318','2014-03-15','12:45:00',8.13),('10318','2014-03-15','12:50:00',8.22),('10318','2014-03-15','12:55:00',8),('10318','2014-03-15','13:00:00',7.99),('10318','2014-03-15','13:05:00',7.89),('10318','2014-03-15','13:10:00',7.91),('10318','2014-03-15','13:15:00',7.87),('10318','2014-03-15','13:20:00',7.77),('10318','2014-03-15','13:25:00',7.77),('10318','2014-03-15','13:30:00',7.71),('10318','2014-03-15','13:35:00',7.62),('10318','2014-03-15','13:40:00',7.5),('10318','2014-03-15','13:45:00',7.33),('10318','2014-03-15','13:50:00',7.33),('10318','2014-03-15','13:55:00',7.26),('10318','2014-03-15','14:00:00',7.18),('10318','2014-03-15','14:05:00',7.04),('10318','2014-03-15','14:10:00',6.91),('10318','2014-03-15','14:15:00',6.77),('10318','2014-03-15','14:20:00',6.5),('10318','2014-03-15','14:25:00',6.53),('10318','2014-03-15','14:30:00',6.39),('10318','2014-03-15','14:35:00',6.21),('10318','2014-03-15','14:40:00',6.06),('10318','2014-03-15','14:45:00',5.84),('10318','2014-03-15','14:50:00',5.72),('10318','2014-03-15','14:55:00',5.62),('10318','2014-03-15','15:00:00',5.45),('10318','2014-03-15','15:05:00',5.27),('10318','2014-03-15','15:10:00',5.09),('10318','2014-03-15','15:15:00',4.92),('10318','2014-03-15','15:20:00',4.77),('10318','2014-03-15','15:25:00',4.57),('10318','2014-03-15','15:30:00',4.39),('10318','2014-03-15','15:35:00',4.13),('10318','2014-03-15','15:40:00',4.01),('10318','2014-03-15','15:45:00',3.87),('10318','2014-03-15','15:50:00',3.66),('10318','2014-03-15','15:55:00',3.43),('10318','2014-03-15','16:00:00',3.2),('10318','2014-03-15','16:05:00',2.99),('10318','2014-03-15','16:10:00',2.85),('10318','2014-03-15','16:15:00',2.59),('10318','2014-03-15','16:20:00',2.48),('10318','2014-03-15','16:25:00',2.35),('10318','2014-03-15','16:30:00',2.2),('10318','2014-03-15','16:35:00',1.98),('10318','2014-03-15','16:40:00',1.91),('10318','2014-03-15','16:45:00',1.75),('10318','2014-03-15','16:50:00',1.58),('10318','2014-03-15','16:55:00',1.43),('10318','2014-03-15','17:00:00',1.29),('10318','2014-03-15','17:05:00',1.14),('10318','2014-03-15','17:10:00',1.02),('10318','2014-03-14','07:30:00',1.1),('10318','2014-03-14','07:35:00',1.21),('10318','2014-03-14','07:40:00',1.35),('10318','2014-03-14','07:45:00',1.51),('10318','2014-03-14','07:50:00',1.65),('10318','2014-03-14','07:55:00',1.79),('10318','2014-03-14','08:00:00',1.92),('10318','2014-03-14','08:05:00',2.04),('10318','2014-03-14','08:10:00',2.19),('10318','2014-03-14','08:15:00',2.36),('10318','2014-03-14','08:20:00',2.68),('10318','2014-03-14','08:25:00',3.02),('10318','2014-03-14','08:30:00',3.06),('10318','2014-03-14','08:35:00',3.01),('10318','2014-03-14','08:40:00',2.72),('10318','2014-03-14','08:45:00',2.57),('10318','2014-03-14','08:50:00',2.45),('10318','2014-03-14','08:55:00',2.46),('10318','2014-03-14','09:00:00',2.7),('10318','2014-03-14','09:05:00',3.06),('10318','2014-03-14','09:10:00',3.66),('10318','2014-03-14','09:15:00',3.96),('10318','2014-03-14','09:20:00',3.81),('10318','2014-03-14','09:25:00',3.67),('10318','2014-03-14','09:30:00',3.89),('10318','2014-03-14','09:35:00',4.2),('10318','2014-03-14','09:40:00',5.09),('10318','2014-03-14','09:45:00',6.05),('10318','2014-03-14','09:50:00',6.84),('10318','2014-03-14','09:55:00',7.71),('10318','2014-03-14','10:00:00',8.2),('10318','2014-03-14','10:05:00',8.25),('10318','2014-03-14','10:10:00',8.23),('10318','2014-03-14','10:15:00',8.47),('10318','2014-03-14','10:20:00',8.39),('10318','2014-03-14','10:25:00',8.03),('10318','2014-03-14','10:30:00',7.85),('10318','2014-03-14','10:35:00',7.88),('10318','2014-03-14','10:40:00',8.2),('10318','2014-03-14','10:45:00',8.04),('10318','2014-03-14','10:50:00',5.6),('10318','2014-03-14','10:55:00',5.17),('10318','2014-03-14','11:00:00',7.62),('10318','2014-03-14','11:05:00',7.72),('10318','2014-03-14','11:10:00',8.32),('10318','2014-03-14','11:15:00',8.8),('10318','2014-03-14','11:20:00',8.71),('10318','2014-03-14','11:25:00',8.26),('10318','2014-03-14','11:30:00',8.29),('10318','2014-03-14','11:35:00',8.25),('10318','2014-03-14','11:40:00',8.03),('10318','2014-03-14','11:45:00',7.94),('10318','2014-03-14','11:50:00',8.35),('10318','2014-03-14','11:55:00',8.42),('10318','2014-03-14','12:00:00',8.34),('10318','2014-03-14','12:05:00',8.38),('10318','2014-03-14','12:10:00',8.22),('10318','2014-03-14','12:15:00',7.96),('10318','2014-03-14','12:20:00',7.5),('10318','2014-03-14','12:25:00',6.16),('10318','2014-03-14','12:30:00',5.52),('10318','2014-03-14','12:35:00',4.93),('10318','2014-03-14','12:40:00',4.33),('10318','2014-03-14','12:45:00',5.33),('10318','2014-03-14','12:50:00',5.35),('10318','2014-03-14','12:55:00',6.12),('10318','2014-03-14','13:00:00',5.47),('10318','2014-03-14','13:05:00',3.94),('10318','2014-03-14','13:10:00',4.86),('10318','2014-03-14','13:15:00',5.23),('10318','2014-03-14','13:20:00',5.83),('10318','2014-03-14','13:25:00',5.9),('10318','2014-03-14','13:30:00',5.5),('10318','2014-03-14','13:35:00',4.99),('10318','2014-03-14','13:40:00',4.11),('10318','2014-03-14','13:45:00',4.56),('10318','2014-03-14','13:50:00',4.92),('10318','2014-03-14','13:55:00',4.85),('10318','2014-03-14','14:00:00',4.59),('10318','2014-03-14','14:05:00',5.34),('10318','2014-03-14','14:10:00',5.76),('10318','2014-03-14','14:15:00',6.36),('10318','2014-03-14','14:20:00',5.46),('10318','2014-03-14','14:25:00',5.47),('10318','2014-03-14','14:30:00',5.39),('10318','2014-03-14','14:35:00',5.45),('10318','2014-03-14','14:40:00',4.76),('10318','2014-03-14','14:45:00',3.8),('10318','2014-03-14','14:50:00',3.45),('10318','2014-03-14','14:55:00',3.11),('10318','2014-03-14','15:00:00',2.77),('10318','2014-03-14','15:05:00',2.69),('10318','2014-03-14','15:10:00',2.61),('10318','2014-03-14','15:15:00',2.43),('10318','2014-03-14','15:20:00',2.51),('10318','2014-03-14','15:25:00',2.93),('10318','2014-03-14','15:30:00',2.97),('10318','2014-03-14','15:35:00',3.54),('10318','2014-03-14','15:40:00',3.47),('10318','2014-03-14','15:45:00',2.88),('10318','2014-03-14','15:50:00',2.49),('10318','2014-03-14','15:55:00',2.39),('10318','2014-03-14','16:00:00',2.24),('10318','2014-03-14','16:05:00',2.18),('10318','2014-03-14','16:10:00',2.11),('10318','2014-03-14','16:15:00',1.75),('10318','2014-03-14','16:20:00',1.51),('10318','2014-03-14','16:25:00',1.35),('10318','2014-03-14','16:30:00',1.3),('10318','2014-03-14','16:35:00',1.26),('10318','2014-03-14','16:40:00',1.17),('10318','2014-03-14','16:45:00',1.09),('10318','2014-03-14','16:50:00',1.05),('10318','2014-03-13','07:10:00',1.07),('10318','2014-03-13','07:15:00',1.24),('10318','2014-03-13','07:20:00',1.46),('10318','2014-03-13','07:25:00',1.66),('10318','2014-03-13','07:30:00',2.1),('10318','2014-03-13','07:35:00',2.93),('10318','2014-03-13','07:40:00',3.34),('10318','2014-03-13','07:45:00',3.57),('10318','2014-03-13','07:50:00',3.82),('10318','2014-03-13','07:55:00',4.06),('10318','2014-03-13','08:00:00',4.28),('10318','2014-03-13','08:05:00',4.5),('10318','2014-03-13','08:10:00',4.71),('10318','2014-03-13','08:15:00',4.9),('10318','2014-03-13','08:20:00',5.11),('10318','2014-03-13','08:25:00',5.31),('10318','2014-03-13','08:30:00',5.48),('10318','2014-03-13','08:35:00',5.69),('10318','2014-03-13','08:40:00',5.87),('10318','2014-03-13','08:45:00',6.03),('10318','2014-03-13','08:50:00',6.23),('10318','2014-03-13','08:55:00',6.4),('10318','2014-03-13','09:00:00',6.38),('10318','2014-03-13','09:05:00',6.7),('10318','2014-03-13','09:10:00',6.83),('10318','2014-03-13','09:15:00',6.98),('10318','2014-03-13','09:20:00',7.09),('10318','2014-03-13','09:25:00',7.24),('10318','2014-03-13','09:30:00',7.35),('10318','2014-03-13','09:35:00',7.46),('10318','2014-03-13','09:40:00',7.54),('10318','2014-03-13','09:45:00',7.68),('10318','2014-03-13','09:50:00',7.77),('10318','2014-03-13','09:55:00',7.95),('10318','2014-03-13','10:00:00',8.05),('10318','2014-03-13','10:05:00',8.19),('10318','2014-03-13','10:10:00',8.32),('10318','2014-03-13','10:15:00',8.34),('10318','2014-03-13','10:20:00',8.44),('10318','2014-03-13','10:25:00',8.51),('10318','2014-03-13','10:30:00',8.57),('10318','2014-03-13','10:35:00',8.64),('10318','2014-03-13','10:40:00',8.64),('10318','2014-03-13','10:45:00',8.72),('10318','2014-03-13','10:50:00',8.76),('10318','2014-03-13','10:55:00',8.76),('10318','2014-03-13','11:00:00',8.76),('10318','2014-03-13','11:05:00',8.83),('10318','2014-03-13','11:10:00',8.89),('10318','2014-03-13','11:15:00',8.85),('10318','2014-03-13','11:20:00',8.85),('10318','2014-03-13','11:25:00',8.86),('10318','2014-03-13','11:30:00',8.85),('10318','2014-03-13','11:35:00',8.84),('10318','2014-03-13','11:40:00',8.76),('10318','2014-03-13','11:45:00',8.84),('10318','2014-03-13','11:50:00',8.83),('10318','2014-03-13','11:55:00',8.78),('10318','2014-03-13','12:00:00',8.62),('10318','2014-03-13','12:05:00',8.78),('10318','2014-03-13','12:10:00',8.74),('10318','2014-03-13','12:15:00',8.71),('10318','2014-03-13','12:20:00',8.64),('10318','2014-03-13','12:25:00',8.58),('10318','2014-03-13','12:30:00',8.58),('10318','2014-03-13','12:35:00',8.54),('10318','2014-03-13','12:40:00',8.5),('10318','2014-03-13','12:45:00',8.41),('10318','2014-03-13','12:50:00',8.31),('10318','2014-03-13','12:55:00',8.21),('10318','2014-03-13','13:00:00',8.12),('10318','2014-03-13','13:05:00',8.03),('10318','2014-03-13','13:10:00',7.92),('10318','2014-03-13','13:15:00',7.95),('10318','2014-03-13','13:20:00',7.91),('10318','2014-03-13','13:25:00',7.85),('10318','2014-03-13','13:30:00',7.77),('10318','2014-03-13','13:35:00',7.71),('10318','2014-03-13','13:40:00',7.59),('10318','2014-03-13','13:45:00',7.54),('10318','2014-03-13','13:50:00',7.29),('10318','2014-03-13','13:55:00',7.3),('10318','2014-03-13','14:00:00',7.14),('10318','2014-03-13','14:05:00',6.99),('10318','2014-03-13','14:10:00',6.91),('10318','2014-03-13','14:15:00',6.75),('10318','2014-03-13','14:20:00',6.57),('10318','2014-03-13','14:25:00',6.46),('10318','2014-03-13','14:30:00',6.36),('10318','2014-03-13','14:35:00',6.26),('10318','2014-03-13','14:40:00',6.09),('10318','2014-03-13','14:45:00',5.92),('10318','2014-03-13','14:50:00',5.73),('10318','2014-03-13','14:55:00',5.57),('10318','2014-03-13','15:00:00',5.38),('10318','2014-03-13','15:05:00',5.18),('10318','2014-03-13','15:10:00',5.02),('10318','2014-03-13','15:15:00',4.84),('10318','2014-03-13','15:20:00',4.67),('10318','2014-03-13','15:25:00',4.48),('10318','2014-03-13','15:30:00',4.31),('10318','2014-03-13','15:35:00',4.06),('10318','2014-03-13','15:40:00',3.96),('10318','2014-03-13','15:45:00',3.77),('10318','2014-03-13','15:50:00',3.61),('10318','2014-03-13','15:55:00',3.46),('10318','2014-03-13','16:00:00',3.27),('10318','2014-03-13','16:05:00',3.08),('10318','2014-03-13','16:10:00',2.92),('10318','2014-03-13','16:15:00',2.74),('10318','2014-03-13','16:20:00',2.59),('10318','2014-03-13','16:25:00',2.43),('10318','2014-03-13','16:30:00',2.27),('10318','2014-03-13','16:35:00',2.11),('10318','2014-03-13','16:40:00',1.96),('10318','2014-03-13','16:45:00',1.83),('10318','2014-03-13','16:50:00',1.66),('10318','2014-03-13','16:55:00',1.5),('10318','2014-03-13','17:00:00',1.34),('10318','2014-03-13','17:05:00',1.19),('10318','2014-03-13','17:10:00',1.04),('10318','2014-03-12','07:15:00',1.15),('10318','2014-03-12','07:20:00',1.31),('10318','2014-03-12','07:25:00',1.52),('10318','2014-03-12','07:30:00',1.7),('10318','2014-03-12','07:35:00',2.62),('10318','2014-03-12','07:40:00',3.17),('10318','2014-03-12','07:45:00',3.41),('10318','2014-03-12','07:50:00',3.65),('10318','2014-03-12','07:55:00',3.9),('10318','2014-03-12','08:00:00',4.13),('10318','2014-03-12','08:05:00',4.25),('10318','2014-03-12','08:10:00',4.59),('10318','2014-03-12','08:15:00',4.8),('10318','2014-03-12','08:20:00',5.04),('10318','2014-03-12','08:25:00',5.24),('10318','2014-03-12','08:30:00',5.42),('10318','2014-03-12','08:35:00',5.58),('10318','2014-03-12','08:40:00',5.81),('10318','2014-03-12','08:45:00',6.01),('10318','2014-03-12','08:50:00',6.19),('10318','2014-03-12','08:55:00',6.36),('10318','2014-03-12','09:00:00',6.51),('10318','2014-03-12','09:05:00',6.66),('10318','2014-03-12','09:10:00',6.79),('10318','2014-03-12','09:15:00',6.92),('10318','2014-03-12','09:20:00',7.06),('10318','2014-03-12','09:25:00',7.16),('10318','2014-03-12','09:30:00',7.24),('10318','2014-03-12','09:35:00',7.39),('10318','2014-03-12','09:40:00',7.52),('10318','2014-03-12','09:45:00',7.61),('10318','2014-03-12','09:50:00',7.66),('10318','2014-03-12','09:55:00',7.88),('10318','2014-03-12','10:00:00',7.93),('10318','2014-03-12','10:05:00',8.03),('10318','2014-03-12','10:10:00',8.11),('10318','2014-03-12','10:15:00',8.19),('10318','2014-03-12','10:20:00',8.27),('10318','2014-03-12','10:25:00',8.35),('10318','2014-03-12','10:30:00',8.4),('10318','2014-03-12','10:35:00',8.5),('10318','2014-03-12','10:40:00',8.62),('10318','2014-03-12','10:45:00',8.72),('10318','2014-03-12','10:50:00',8.77),('10318','2014-03-12','10:55:00',8.82),('10318','2014-03-12','11:00:00',8.86),('10318','2014-03-12','11:05:00',8.95),('10318','2014-03-12','11:10:00',8.92),('10318','2014-03-12','11:15:00',8.94),('10318','2014-03-12','11:20:00',9.05),('10318','2014-03-12','11:25:00',9.04),('10318','2014-03-12','11:30:00',9),('10318','2014-03-12','11:35:00',8.79),('10318','2014-03-12','11:40:00',8.98),('10318','2014-03-12','11:45:00',9.04),('10318','2014-03-12','11:50:00',9.06),('10318','2014-03-12','11:55:00',9.02),('10318','2014-03-12','12:00:00',8.98),('10318','2014-03-12','12:05:00',8.97),('10318','2014-03-12','12:10:00',9.02),('10318','2014-03-12','12:15:00',8.98),('10318','2014-03-12','12:20:00',8.91),('10318','2014-03-12','12:25:00',8.91),('10318','2014-03-12','12:30:00',8.82),('10318','2014-03-12','12:35:00',8.78),('10318','2014-03-12','12:40:00',8.75),('10318','2014-03-12','12:45:00',8.75),('10318','2014-03-12','12:50:00',8.62),('10318','2014-03-12','12:55:00',8.59),('10318','2014-03-12','13:00:00',8.53),('10318','2014-03-12','13:05:00',8.41),('10318','2014-03-12','13:10:00',8.29),('10318','2014-03-12','13:15:00',8.21),('10318','2014-03-12','13:20:00',8.04),('10318','2014-03-12','13:25:00',8.11),('10318','2014-03-12','13:30:00',8),('10318','2014-03-12','13:35:00',7.92),('10318','2014-03-12','13:40:00',7.84),('10318','2014-03-12','13:45:00',7.76),('10318','2014-03-12','13:50:00',7.58),('10318','2014-03-12','13:55:00',7.54),('10318','2014-03-12','14:00:00',7.35),('10318','2014-03-12','14:05:00',7.23),('10318','2014-03-12','14:10:00',7.08),('10318','2014-03-12','14:15:00',6.95),('10318','2014-03-12','14:20:00',6.82),('10318','2014-03-12','14:25:00',6.73),('10318','2014-03-12','14:30:00',6.51),('10318','2014-03-12','14:35:00',6.28),('10318','2014-03-12','14:40:00',6.12),('10318','2014-03-12','14:45:00',5.87),('10318','2014-03-12','14:50:00',5.3),('10318','2014-03-12','14:55:00',4.13),('10318','2014-03-12','15:00:00',5.59),('10318','2014-03-12','15:05:00',5.21),('10318','2014-03-12','15:10:00',4.99),('10318','2014-03-12','15:15:00',4.79),('10318','2014-03-12','15:20:00',4.61),('10318','2014-03-12','15:25:00',4.5),('10318','2014-03-12','15:30:00',4.36),('10318','2014-03-12','15:35:00',4.22),('10318','2014-03-12','15:40:00',4.1),('10318','2014-03-12','15:45:00',3.89),('10318','2014-03-12','15:50:00',3.67),('10318','2014-03-12','15:55:00',3.52),('10318','2014-03-12','16:00:00',3.35),('10318','2014-03-12','16:05:00',3.18),('10318','2014-03-12','16:10:00',3.01),('10318','2014-03-12','16:15:00',2.82),('10318','2014-03-12','16:20:00',2.63),('10318','2014-03-12','16:25:00',2.51),('10318','2014-03-12','16:30:00',2.33),('10318','2014-03-12','16:35:00',2.17),('10318','2014-03-12','16:40:00',2),('10318','2014-03-12','16:45:00',1.83),('10318','2014-03-12','16:50:00',1.63),('10318','2014-03-12','16:55:00',1.46),('10318','2014-03-12','17:00:00',1.32),('10318','2014-03-12','17:05:00',1.18),('10318','2014-03-12','17:10:00',1.03),('10318','2014-03-11','07:35:00',1.07),('10318','2014-03-11','07:40:00',1.21),('10318','2014-03-11','07:45:00',1.36),('10318','2014-03-11','07:50:00',1.36),('10318','2014-03-11','07:55:00',1.45),('10318','2014-03-11','08:00:00',1.36),('10318','2014-03-11','08:05:00',1.16),('10318','2014-03-11','08:10:00',1),('10318','2014-03-11','08:20:00',1.05),('10318','2014-03-11','08:25:00',1.13),('10318','2014-03-11','08:55:00',1.03),('10318','2014-03-11','09:00:00',1.07),('10318','2014-03-11','09:05:00',1.09),('10318','2014-03-11','09:10:00',1.18),('10318','2014-03-11','09:15:00',1.19),('10318','2014-03-11','09:20:00',1.09),('10318','2014-03-11','09:25:00',1.12),('10318','2014-03-11','09:30:00',1.17),('10318','2014-03-11','09:35:00',1.15),('10318','2014-03-11','09:40:00',1.09),('10318','2014-03-11','09:50:00',1.02),('10318','2014-03-11','09:55:00',1.01),('10318','2014-03-11','10:00:00',1.05),('10318','2014-03-11','10:05:00',1.22),('10318','2014-03-11','10:10:00',1.45),('10318','2014-03-11','10:15:00',1.71),('10318','2014-03-11','10:20:00',2.08),('10318','2014-03-11','10:25:00',2.22),('10318','2014-03-11','10:30:00',2.32),('10318','2014-03-11','10:35:00',2.19),('10318','2014-03-11','10:40:00',2.05),('10318','2014-03-11','10:45:00',1.93),('10318','2014-03-11','10:50:00',1.84),('10318','2014-03-11','10:55:00',2),('10318','2014-03-11','11:00:00',2.29),('10318','2014-03-11','11:05:00',2.46),('10318','2014-03-11','11:10:00',2.58),('10318','2014-03-11','11:15:00',2.68),('10318','2014-03-11','11:20:00',2.47),('10318','2014-03-11','11:25:00',2.31),('10318','2014-03-11','11:30:00',1.96),('10318','2014-03-11','11:35:00',1.93),('10318','2014-03-11','11:40:00',1.99),('10318','2014-03-11','11:45:00',2.17),('10318','2014-03-11','11:50:00',2.08),('10318','2014-03-11','11:55:00',2.27),('10318','2014-03-11','12:00:00',2.39),('10318','2014-03-11','12:05:00',2.35),('10318','2014-03-11','12:10:00',2.4),('10318','2014-03-11','12:15:00',2.77),('10318','2014-03-11','12:20:00',3.01),('10318','2014-03-11','12:25:00',2.8),('10318','2014-03-11','12:30:00',2.77),('10318','2014-03-11','12:35:00',3.02),('10318','2014-03-11','12:40:00',3.17),('10318','2014-03-11','12:45:00',3.42),('10318','2014-03-11','12:50:00',3.45),('10318','2014-03-11','12:55:00',3.29),('10318','2014-03-11','13:00:00',3.1),('10318','2014-03-11','13:05:00',3.11),('10318','2014-03-11','13:10:00',3.24),('10318','2014-03-11','13:15:00',2.99),('10318','2014-03-11','13:20:00',3.48),('10318','2014-03-11','13:25:00',2.95),('10318','2014-03-11','13:30:00',2.54),('10318','2014-03-11','13:35:00',2.46),('10318','2014-03-11','13:40:00',2.62),('10318','2014-03-11','13:45:00',3.04),('10318','2014-03-11','13:50:00',3.31),('10318','2014-03-11','13:55:00',3.55),('10318','2014-03-11','14:00:00',3.94),('10318','2014-03-11','14:05:00',4.52),('10318','2014-03-11','14:10:00',5),('10318','2014-03-11','14:15:00',5.54),('10318','2014-03-11','14:20:00',7.76),('10318','2014-03-11','14:25:00',4.42),('10318','2014-03-11','14:30:00',3.52),('10318','2014-03-11','14:35:00',3.79),('10318','2014-03-11','14:40:00',3.47),('10318','2014-03-11','14:45:00',3.77),('10318','2014-03-11','14:50:00',3.36),('10318','2014-03-11','14:55:00',3.21),('10318','2014-03-11','15:00:00',3.36),('10318','2014-03-11','15:05:00',3.39),('10318','2014-03-11','15:10:00',3.64),('10318','2014-03-11','15:15:00',4.34),('10318','2014-03-11','15:20:00',3.7),('10318','2014-03-11','15:25:00',3.16),('10318','2014-03-11','15:30:00',3.04),('10318','2014-03-11','15:35:00',2.81),('10318','2014-03-11','15:40:00',2.41),('10318','2014-03-11','15:45:00',2.26),('10318','2014-03-11','15:50:00',2.26),('10318','2014-03-11','15:55:00',1.82),('10318','2014-03-11','16:00:00',1.65),('10318','2014-03-11','16:05:00',1.54),('10318','2014-03-11','16:10:00',1.62),('10318','2014-03-11','16:15:00',1.58),('10318','2014-03-11','16:20:00',1.57),('10318','2014-03-11','16:25:00',1.39),('10318','2014-03-11','16:30:00',1.32),('10318','2014-03-11','16:35:00',1.21),('10318','2014-03-11','16:40:00',1.12),('10318','2014-03-10','08:05:00',1.03),('10318','2014-03-10','08:10:00',1.21),('10318','2014-03-10','08:15:00',1.3),('10318','2014-03-10','08:20:00',1.42),('10318','2014-03-10','08:25:00',1.57),('10318','2014-03-10','08:30:00',1.68),('10318','2014-03-10','08:35:00',1.9),('10318','2014-03-10','08:40:00',2.07),('10318','2014-03-10','08:45:00',2.11),('10318','2014-03-10','08:50:00',2.22),('10318','2014-03-10','08:55:00',2.24),('10318','2014-03-10','09:00:00',2.26),('10318','2014-03-10','09:05:00',2.42),('10318','2014-03-10','09:10:00',2.46),('10318','2014-03-10','09:15:00',2.59),('10318','2014-03-10','09:20:00',2.32),('10318','2014-03-10','09:25:00',1.92),('10318','2014-03-10','09:30:00',2.1),('10318','2014-03-10','09:35:00',2.42),('10318','2014-03-10','09:40:00',2.61),('10318','2014-03-10','09:45:00',2.48),('10318','2014-03-10','09:50:00',2.33),('10318','2014-03-10','09:55:00',2.18),('10318','2014-03-10','10:00:00',1.88),('10318','2014-03-10','10:05:00',2.04),('10318','2014-03-10','10:10:00',2.38),('10318','2014-03-10','10:15:00',2.66),('10318','2014-03-10','10:20:00',2.38),('10318','2014-03-10','10:25:00',2.06),('10318','2014-03-10','10:30:00',2.38),('10318','2014-03-10','10:35:00',2.45),('10318','2014-03-10','10:40:00',1.81),('10318','2014-03-10','10:45:00',1.36),('10318','2014-03-10','11:00:00',1.12),('10318','2014-03-10','11:05:00',1.24),('10318','2014-03-10','11:10:00',1.35),('10318','2014-03-10','11:15:00',1.88),('10318','2014-03-10','11:20:00',2.17),('10318','2014-03-10','11:25:00',2.01),('10318','2014-03-10','11:30:00',1.83),('10318','2014-03-10','11:35:00',1.21),('10318','2014-03-10','12:05:00',1.14),('10318','2014-03-10','12:10:00',1.3),('10318','2014-03-10','12:15:00',1.33),('10318','2014-03-10','12:20:00',1.36),('10318','2014-03-10','12:25:00',1.4),('10318','2014-03-10','12:30:00',1.5),('10318','2014-03-10','12:35:00',1.72),('10318','2014-03-10','12:40:00',1.95),('10318','2014-03-10','12:45:00',2.21),('10318','2014-03-10','12:50:00',2.43),('10318','2014-03-10','12:55:00',2.59),('10318','2014-03-10','13:00:00',2.72),('10318','2014-03-10','13:05:00',2.72),('10318','2014-03-10','13:10:00',2.72),('10318','2014-03-10','13:15:00',2.79),('10318','2014-03-10','13:20:00',2.79),('10318','2014-03-10','13:25:00',2.46),('10318','2014-03-10','13:30:00',2.29),('10318','2014-03-10','13:35:00',2),('10318','2014-03-10','13:40:00',1.74),('10318','2014-03-10','13:45:00',1.58),('10318','2014-03-10','13:50:00',2.12),('10318','2014-03-10','13:55:00',2.49),('10318','2014-03-10','14:00:00',2.57),('10318','2014-03-10','14:05:00',3.33),('10318','2014-03-10','14:10:00',3.44),('10318','2014-03-10','14:15:00',3.75),('10318','2014-03-10','14:20:00',3.3),('10318','2014-03-10','14:25:00',2.65),('10318','2014-03-10','14:30:00',2.43),('10318','2014-03-10','14:35:00',2.92),('10318','2014-03-10','14:40:00',3.8),('10318','2014-03-10','14:45:00',4.68),('10318','2014-03-10','14:50:00',4.16),('10318','2014-03-10','14:55:00',4.26),('10318','2014-03-10','15:00:00',6.5),('10318','2014-03-10','15:05:00',6.37),('10318','2014-03-10','15:10:00',6.06),('10318','2014-03-10','15:15:00',5.7),('10318','2014-03-10','15:20:00',5.36),('10318','2014-03-10','15:25:00',5.26),('10318','2014-03-10','15:30:00',5.2),('10318','2014-03-10','15:35:00',3.9),('10318','2014-03-10','15:40:00',2.75),('10318','2014-03-10','15:45:00',2.18),('10318','2014-03-10','15:50:00',1.27),('10318','2014-03-10','15:55:00',1.63),('10318','2014-03-10','16:00:00',1.51),('10318','2014-03-10','16:05:00',1.42),('10318','2014-03-10','16:10:00',1.22),('10318','2014-03-10','16:15:00',1.36),('10318','2014-03-10','16:20:00',1.43),('10318','2014-03-10','16:25:00',1.62),('10318','2014-03-10','16:30:00',2.29),('10318','2014-03-10','16:35:00',2.29),('10318','2014-03-10','16:40:00',1.66),('10318','2014-03-10','16:45:00',1.47),('10318','2014-03-10','16:50:00',1.43),('10318','2014-03-10','16:55:00',1.7),('10318','2014-03-10','17:00:00',1.77),('10318','2014-03-10','17:05:00',1.41),('10318','2014-03-09','07:30:00',1.21),('10318','2014-03-09','07:35:00',1.29),('10318','2014-03-09','07:40:00',2.38),('10318','2014-03-09','07:45:00',3.03),('10318','2014-03-09','07:50:00',3.07),('10318','2014-03-09','07:55:00',3.65),('10318','2014-03-09','08:00:00',3.89),('10318','2014-03-09','08:05:00',4.12),('10318','2014-03-09','08:10:00',4.37),('10318','2014-03-09','08:15:00',4.61),('10318','2014-03-09','08:20:00',4.84),('10318','2014-03-09','08:25:00',4.98),('10318','2014-03-09','08:30:00',4.9),('10318','2014-03-09','08:35:00',4.53),('10318','2014-03-09','08:40:00',4.81),('10318','2014-03-09','08:45:00',5.57),('10318','2014-03-09','08:50:00',4.97),('10318','2014-03-09','08:55:00',6.01),('10318','2014-03-09','09:00:00',6.48),('10318','2014-03-09','09:05:00',6.66),('10318','2014-03-09','09:10:00',6.8),('10318','2014-03-09','09:15:00',6.91),('10318','2014-03-09','09:20:00',6),('10318','2014-03-09','09:25:00',7.41),('10318','2014-03-09','09:30:00',7.58),('10318','2014-03-09','09:35:00',7.93),('10318','2014-03-09','09:40:00',7.94),('10318','2014-03-09','09:45:00',8.06),('10318','2014-03-09','09:50:00',8.09),('10318','2014-03-09','09:55:00',8.1),('10318','2014-03-09','10:00:00',8.18),('10318','2014-03-09','10:05:00',8.24),('10318','2014-03-09','10:10:00',8.36),('10318','2014-03-09','10:15:00',8.42),('10318','2014-03-09','10:20:00',8.38),('10318','2014-03-09','10:25:00',8.32),('10318','2014-03-09','10:30:00',8.5),('10318','2014-03-09','10:35:00',7.73),('10318','2014-03-09','10:40:00',8.74),('10318','2014-03-09','10:45:00',8.33),('10318','2014-03-09','10:50:00',9.2),('10318','2014-03-09','10:55:00',9.42),('10318','2014-03-09','11:00:00',9.79),('10318','2014-03-09','11:05:00',9.28),('10318','2014-03-09','11:10:00',9.29),('10318','2014-03-09','11:15:00',10.27),('10318','2014-03-09','11:20:00',10.47),('10318','2014-03-09','11:25:00',8.13),('10318','2014-03-09','11:30:00',2.96),('10318','2014-03-09','11:35:00',4.89),('10318','2014-03-09','11:40:00',3.79),('10318','2014-03-09','11:45:00',3.69),('10318','2014-03-09','11:50:00',6.74),('10318','2014-03-09','11:55:00',4.93),('10318','2014-03-09','12:00:00',7.13),('10318','2014-03-09','12:05:00',4.08),('10318','2014-03-09','12:10:00',9.83),('10318','2014-03-09','12:15:00',9.78),('10318','2014-03-09','12:20:00',9.91),('10318','2014-03-09','12:25:00',9.86),('10318','2014-03-09','12:30:00',8.28),('10318','2014-03-09','12:35:00',7.54),('10318','2014-03-09','12:40:00',8.63),('10318','2014-03-09','12:45:00',9.61),('10318','2014-03-09','12:50:00',9.44),('10318','2014-03-09','12:55:00',8.2),('10318','2014-03-09','13:00:00',9.54),('10318','2014-03-09','13:05:00',9.04),('10318','2014-03-09','13:10:00',4.9),('10318','2014-03-09','13:15:00',4.03),('10318','2014-03-09','13:20:00',5.06),('10318','2014-03-09','13:25:00',7.32),('10318','2014-03-09','13:30:00',7.71),('10318','2014-03-09','13:35:00',8.92),('10318','2014-03-09','13:40:00',8.67),('10318','2014-03-09','13:45:00',7.77),('10318','2014-03-09','13:50:00',8.53),('10318','2014-03-09','13:55:00',8.29),('10318','2014-03-09','14:00:00',4.02),('10318','2014-03-09','14:05:00',3.11),('10318','2014-03-09','14:10:00',7.76),('10318','2014-03-09','14:15:00',7.42),('10318','2014-03-09','14:20:00',7.39),('10318','2014-03-09','14:25:00',7.44),('10318','2014-03-09','14:30:00',7.11),('10318','2014-03-09','14:35:00',2.28),('10318','2014-03-09','14:40:00',1.58),('10318','2014-03-09','14:45:00',1.81),('10318','2014-03-09','14:50:00',2.85),('10318','2014-03-09','14:55:00',6.29),('10318','2014-03-09','15:00:00',5.98),('10318','2014-03-09','15:05:00',5.87),('10318','2014-03-09','15:10:00',5.66),('10318','2014-03-09','15:15:00',5.47),('10318','2014-03-09','15:20:00',5.17),('10318','2014-03-09','15:25:00',5.05),('10318','2014-03-09','15:30:00',4.86),('10318','2014-03-09','15:35:00',4.63),('10318','2014-03-09','15:40:00',4.35),('10318','2014-03-09','15:45:00',4.25),('10318','2014-03-09','15:50:00',3.13),('10318','2014-03-09','15:55:00',1.18),('10318','2014-03-09','16:00:00',1.26),('10318','2014-03-09','16:05:00',2.8),('10318','2014-03-09','16:10:00',1.89),('10318','2014-03-09','16:15:00',2.95),('10318','2014-03-09','16:20:00',2.81),('10318','2014-03-09','16:25:00',2.62),('10318','2014-03-09','16:30:00',2.43),('10318','2014-03-09','16:35:00',2.29),('10318','2014-03-09','16:40:00',2.19),('10318','2014-03-09','16:45:00',1.92),('10318','2014-03-09','16:50:00',1.69),('10318','2014-03-09','16:55:00',1.5),('10318','2014-03-09','17:00:00',1.34),('10318','2014-03-09','17:05:00',1.17),('10318','2014-03-08','07:15:00',1.01),('10318','2014-03-08','07:20:00',1.23),('10318','2014-03-08','07:25:00',1.4),('10318','2014-03-08','07:30:00',1.61),('10318','2014-03-08','07:35:00',1.82),('10318','2014-03-08','07:40:00',2.6),('10318','2014-03-08','07:45:00',3.27),('10318','2014-03-08','07:50:00',3.55),('10318','2014-03-08','07:55:00',3.78),('10318','2014-03-08','08:00:00',4.01),('10318','2014-03-08','08:05:00',4.23),('10318','2014-03-08','08:10:00',4.42),('10318','2014-03-08','08:15:00',4.63),('10318','2014-03-08','08:20:00',4.83),('10318','2014-03-08','08:25:00',5.02),('10318','2014-03-08','08:30:00',5.25),('10318','2014-03-08','08:35:00',5.44),('10318','2014-03-08','08:40:00',5.64),('10318','2014-03-08','08:45:00',5.83),('10318','2014-03-08','08:50:00',5.98),('10318','2014-03-08','08:55:00',6.15),('10318','2014-03-08','09:00:00',6.34),('10318','2014-03-08','09:05:00',6.51),('10318','2014-03-08','09:10:00',6.68),('10318','2014-03-08','09:15:00',6.84),('10318','2014-03-08','09:20:00',6.98),('10318','2014-03-08','09:25:00',7.1),('10318','2014-03-08','09:30:00',7.24),('10318','2014-03-08','09:35:00',7.37),('10318','2014-03-08','09:40:00',7.49),('10318','2014-03-08','09:45:00',7.57),('10318','2014-03-08','09:50:00',7.67),('10318','2014-03-08','09:55:00',7.79),('10318','2014-03-08','10:00:00',7.87),('10318','2014-03-08','10:05:00',7.95),('10318','2014-03-08','10:10:00',7.86),('10318','2014-03-08','10:15:00',8.15),('10318','2014-03-08','10:20:00',8.25),('10318','2014-03-08','10:25:00',8.36),('10318','2014-03-08','10:30:00',8.43),('10318','2014-03-08','10:35:00',8.49),('10318','2014-03-08','10:40:00',8.56),('10318','2014-03-08','10:45:00',8.63),('10318','2014-03-08','10:50:00',8.75),('10318','2014-03-08','10:55:00',8.78),('10318','2014-03-08','11:00:00',8.82),('10318','2014-03-08','11:05:00',8.9),('10318','2014-03-08','11:10:00',8.87),('10318','2014-03-08','11:15:00',9.04),('10318','2014-03-08','11:20:00',9.15),('10318','2014-03-08','11:25:00',8.85),('10318','2014-03-08','11:30:00',9.58),('10318','2014-03-08','11:35:00',10.04),('10318','2014-03-08','11:40:00',9.93),('10318','2014-03-08','11:45:00',8.09),('10318','2014-03-08','11:50:00',2.84),('10318','2014-03-08','11:55:00',2.71),('10318','2014-03-08','12:00:00',3.76),('10318','2014-03-08','12:05:00',4.76),('10318','2014-03-08','12:10:00',3.26),('10318','2014-03-08','12:15:00',3.08),('10318','2014-03-08','12:20:00',2.81),('10318','2014-03-08','12:25:00',3.15),('10318','2014-03-08','12:30:00',3.28),('10318','2014-03-08','12:35:00',3.61),('10318','2014-03-08','12:40:00',4.52),('10318','2014-03-08','12:45:00',3.82),('10318','2014-03-08','12:50:00',3.68),('10318','2014-03-08','12:55:00',4.15),('10318','2014-03-08','13:00:00',5.29),('10318','2014-03-08','13:05:00',4.2),('10318','2014-03-08','13:10:00',3.6),('10318','2014-03-08','13:15:00',2.99),('10318','2014-03-08','13:20:00',2.41),('10318','2014-03-08','13:25:00',2.26),('10318','2014-03-08','13:30:00',2.8),('10318','2014-03-08','13:35:00',6.41),('10318','2014-03-08','13:40:00',3.75),('10318','2014-03-08','13:45:00',5.95),('10318','2014-03-08','13:50:00',7.72),('10318','2014-03-08','13:55:00',3.6),('10318','2014-03-08','14:00:00',2.66),('10318','2014-03-08','14:05:00',2.48),('10318','2014-03-08','14:10:00',2.37),('10318','2014-03-08','14:15:00',1.95),('10318','2014-03-08','14:20:00',1.71),('10318','2014-03-08','14:25:00',1.66),('10318','2014-03-08','14:30:00',1.6),('10318','2014-03-08','14:35:00',1.84),('10318','2014-03-08','14:40:00',2.04),('10318','2014-03-08','14:45:00',2.1),('10318','2014-03-08','14:50:00',2.2),('10318','2014-03-08','14:55:00',2.38),('10318','2014-03-08','15:00:00',2.25),('10318','2014-03-08','15:05:00',1.9),('10318','2014-03-08','15:10:00',1.99),('10318','2014-03-08','15:15:00',2.25),('10318','2014-03-08','15:20:00',3.96),('10318','2014-03-08','15:25:00',2.87),('10318','2014-03-08','15:30:00',2.45),('10318','2014-03-08','15:35:00',2.4),('10318','2014-03-08','15:40:00',1.47),('10318','2014-03-08','15:45:00',1.37),('10318','2014-03-08','15:50:00',1.67),('10318','2014-03-08','15:55:00',1.75),('10318','2014-03-08','16:00:00',1.94),('10318','2014-03-08','16:05:00',1.69),('10318','2014-03-08','16:10:00',1.35),('10318','2014-03-08','16:15:00',1.24),('10318','2014-03-08','16:20:00',1.33),('10318','2014-03-08','16:25:00',1.18),('10318','2014-03-08','16:30:00',1.21),('10318','2014-03-08','16:35:00',2.51),('10318','2014-03-08','16:40:00',2.08),('10318','2014-03-08','16:45:00',1.96),('10318','2014-03-08','16:50:00',1.82),('10318','2014-03-08','16:55:00',1.52),('10318','2014-03-08','17:00:00',1.34),('10318','2014-03-08','17:05:00',1.19),('10318','2014-04-30','07:15:00',1.24),('10318','2014-04-30','07:20:00',1.71),('10318','2014-04-30','07:25:00',2.07),('10318','2014-04-30','07:30:00',2.34),('10318','2014-04-30','07:35:00',2.69),('10318','2014-04-30','07:40:00',2.95),('10318','2014-04-30','07:45:00',3.15),('10318','2014-04-30','07:50:00',3.42),('10318','2014-04-30','07:55:00',3.64),('10318','2014-04-30','08:00:00',3.86),('10318','2014-04-30','08:05:00',3.95),('10318','2014-04-30','08:10:00',4.26),('10318','2014-04-30','08:15:00',4.43),('10318','2014-04-30','08:20:00',4.7),('10318','2014-04-30','08:25:00',4.83),('10318','2014-04-30','08:30:00',5.06),('10318','2014-04-30','08:35:00',5.25),('10318','2014-04-30','08:40:00',5.38),('10318','2014-04-30','08:45:00',5.59),('10318','2014-04-30','08:50:00',5.91),('10318','2014-04-30','08:55:00',5.88),('10318','2014-04-30','09:00:00',6.37),('10318','2014-04-30','09:05:00',5.45),('10318','2014-04-30','09:10:00',6.48),('10318','2014-04-30','09:15:00',5.71),('10318','2014-04-30','09:20:00',4.34),('10318','2014-04-30','09:25:00',7.05),('10318','2014-04-30','09:30:00',7.52),('10318','2014-04-30','09:35:00',7.72),('10318','2014-04-30','09:40:00',8.07),('10318','2014-04-30','09:45:00',5.83),('10318','2014-04-30','09:50:00',5.5),('10318','2014-04-30','09:55:00',8.79),('10318','2014-04-30','10:00:00',8.87),('10318','2014-04-30','10:05:00',6.5),('10318','2014-04-30','10:10:00',3.32),('10318','2014-04-30','10:15:00',4.08),('10318','2014-04-30','10:20:00',4.31),('10318','2014-04-30','10:25:00',4.36),('10318','2014-04-30','10:30:00',5.07),('10318','2014-04-30','10:35:00',4.57),('10318','2014-04-30','10:40:00',3.62),('10318','2014-04-30','10:45:00',4.3),('10318','2014-04-30','10:50:00',6.93),('10318','2014-04-30','10:55:00',4.28),('10318','2014-04-30','11:00:00',4.93),('10318','2014-04-30','11:05:00',5.24),('10318','2014-04-30','11:10:00',8.15),('10318','2014-04-30','11:15:00',9.34),('10318','2014-04-30','11:20:00',6.12),('10318','2014-04-30','11:25:00',4.31),('10318','2014-04-30','11:30:00',5.89),('10318','2014-04-30','11:35:00',7.1),('10318','2014-04-30','11:40:00',5.68),('10318','2014-04-30','11:45:00',6.35),('10318','2014-04-30','11:50:00',5.12),('10318','2014-04-30','11:55:00',5.9),('10318','2014-04-30','12:00:00',5.1),('10318','2014-04-30','12:05:00',7.36),('10318','2014-04-30','12:10:00',5.24),('10318','2014-04-30','12:15:00',2.96),('10318','2014-04-30','12:20:00',2.75),('10318','2014-04-30','12:25:00',3.31),('10318','2014-04-30','12:30:00',2.54),('10318','2014-04-30','12:35:00',2.16),('10318','2014-04-30','12:40:00',7.32),('10318','2014-04-30','12:45:00',10.86),('10318','2014-04-30','12:50:00',7.25),('10318','2014-04-30','12:55:00',8.31),('10318','2014-04-30','13:00:00',9.81),('10318','2014-04-30','13:05:00',7.83),('10318','2014-04-30','13:10:00',3.16),('10318','2014-04-30','13:15:00',4.26),('10318','2014-04-30','13:20:00',7.18),('10318','2014-04-30','13:25:00',3.62),('10318','2014-04-30','13:30:00',4),('10318','2014-04-30','13:35:00',9.82),('10318','2014-04-30','13:40:00',9.02),('10318','2014-04-30','13:45:00',7.54),('10318','2014-04-30','13:50:00',7.99),('10318','2014-04-30','13:55:00',4.89),('10318','2014-04-30','14:00:00',4.04),('10318','2014-04-30','14:05:00',3.8),('10318','2014-04-30','14:10:00',3.97),('10318','2014-04-30','14:15:00',7.86),('10318','2014-04-30','14:20:00',7.78),('10318','2014-04-30','14:25:00',8.78),('10318','2014-04-30','14:30:00',7.44),('10318','2014-04-30','14:35:00',5.3),('10318','2014-04-30','14:40:00',3.15),('10318','2014-04-30','14:45:00',3.26),('10318','2014-04-30','14:50:00',3.85),('10318','2014-04-30','14:55:00',3.82),('10318','2014-04-30','15:00:00',3.4),('10318','2014-04-30','15:05:00',3.99),('10318','2014-04-30','15:10:00',3.66),('10318','2014-04-30','15:15:00',2.96),('10318','2014-04-30','15:20:00',4.04),('10318','2014-04-30','15:25:00',3.56),('10318','2014-04-30','15:30:00',5.55),('10318','2014-04-30','15:35:00',4.29),('10318','2014-04-30','15:40:00',3.16),('10318','2014-04-30','15:45:00',3.27),('10318','2014-04-30','15:50:00',3.64),('10318','2014-04-30','15:55:00',6.37),('10318','2014-04-30','16:00:00',3.58),('10318','2014-04-30','16:05:00',3.67),('10318','2014-04-30','16:10:00',4.49),('10318','2014-04-30','16:15:00',5.21),('10318','2014-04-30','16:20:00',7.53),('10318','2014-04-30','16:25:00',3.33),('10318','2014-04-30','16:30:00',3.27),('10318','2014-04-30','16:35:00',5.47),('10318','2014-04-30','16:40:00',6.89),('10318','2014-04-30','16:45:00',2.5),('10318','2014-04-30','16:50:00',4.11),('10318','2014-04-30','16:55:00',2.79),('10318','2014-04-30','17:00:00',5.35),('10318','2014-04-30','17:05:00',4.99),('10318','2014-04-30','17:10:00',2.91),('10318','2014-04-30','17:15:00',2.04),('10318','2014-04-30','17:20:00',3.56),('10318','2014-04-30','17:25:00',1.4),('10318','2014-04-30','17:30:00',1.5),('10318','2014-04-30','17:35:00',2.21),('10318','2014-04-30','17:40:00',2.51),('10318','2014-04-30','17:45:00',1.91),('10318','2014-04-30','17:50:00',1.36),('10318','2014-04-30','17:55:00',1.31),('10318','2014-04-30','18:00:00',1.26),('10318','2014-04-30','18:05:00',1.01),('10318','2014-04-30','18:25:00',1.01),('10318','2014-04-30','18:30:00',1.11),('10318','2014-04-30','18:35:00',1.17),('10318','2014-04-30','18:40:00',1.16),('10318','2014-04-30','18:45:00',1.26),('10318','2014-04-30','18:50:00',1.09),('10318','2014-03-07','09:30:00',1.04),('10318','2014-03-07','09:35:00',1.37),('10318','2014-03-07','09:40:00',1.5),('10318','2014-03-07','09:45:00',1.4),('10318','2014-03-07','09:50:00',1.12),('10318','2014-03-07','09:55:00',1.27),('10318','2014-03-07','10:00:00',2.13),('10318','2014-03-07','10:05:00',1.49),('10318','2014-03-07','10:10:00',1.58),('10318','2014-03-07','10:15:00',1.56),('10318','2014-03-07','10:20:00',2.13),('10318','2014-03-07','10:25:00',2.86),('10318','2014-03-07','10:30:00',3.46),('10318','2014-03-07','10:35:00',2.48),('10318','2014-03-07','10:40:00',2.06),('10318','2014-03-07','10:45:00',2.05),('10318','2014-03-07','10:50:00',2.15),('10318','2014-03-07','10:55:00',2.62),('10318','2014-03-07','11:00:00',3.75),('10318','2014-03-07','11:05:00',2.5),('10318','2014-03-07','11:10:00',2.01),('10318','2014-03-07','11:15:00',2.37),('10318','2014-03-07','11:20:00',3.91),('10318','2014-03-07','11:25:00',5.9),('10318','2014-03-07','11:30:00',3.52),('10318','2014-03-07','11:35:00',4.86),('10318','2014-03-07','11:40:00',2.63),('10318','2014-03-07','11:45:00',3.19),('10318','2014-03-07','11:50:00',7.57),('10318','2014-03-07','11:55:00',10.3),('10318','2014-03-07','12:00:00',5.46),('10318','2014-03-07','12:05:00',9.78),('10318','2014-03-07','12:10:00',9.81),('10318','2014-03-07','12:15:00',9.61),('10318','2014-03-07','12:20:00',9.55),('10318','2014-03-07','12:25:00',9.43),('10318','2014-03-07','12:30:00',4.84),('10318','2014-03-07','12:35:00',3.62),('10318','2014-03-07','12:40:00',3.39),('10318','2014-03-07','12:45:00',4.54),('10318','2014-03-07','12:50:00',4.67),('10318','2014-03-07','12:55:00',2.5),('10318','2014-03-07','13:00:00',1.86),('10318','2014-03-07','13:05:00',2.89),('10318','2014-03-07','13:10:00',4.44),('10318','2014-03-07','13:15:00',2.91),('10318','2014-03-07','13:20:00',5.58),('10318','2014-03-07','13:25:00',5.65),('10318','2014-03-07','13:30:00',3.79),('10318','2014-03-07','13:35:00',3.55),('10318','2014-03-07','13:40:00',3.43),('10318','2014-03-07','13:45:00',3.59),('10318','2014-03-07','13:50:00',3.39),('10318','2014-03-07','13:55:00',3.1),('10318','2014-03-07','14:00:00',2.89),('10318','2014-03-07','14:05:00',2.7),('10318','2014-03-07','14:10:00',2.59),('10318','2014-03-07','14:15:00',2.56),('10318','2014-03-07','14:20:00',2.6),('10318','2014-03-07','14:25:00',2.6),('10318','2014-03-07','14:30:00',2.7),('10318','2014-03-07','14:35:00',2.92),('10318','2014-03-07','14:40:00',3.12),('10318','2014-03-07','14:45:00',3.54),('10318','2014-03-07','14:50:00',4.6),('10318','2014-03-07','15:00:00',6.46),('10318','2014-03-07','15:05:00',6.5),('10318','2014-03-07','15:10:00',6.63),('10318','2014-03-07','15:15:00',6.22),('10318','2014-03-07','15:20:00',6.16),('10318','2014-03-07','15:25:00',5.86),('10318','2014-03-07','15:30:00',5.6),('10318','2014-03-07','15:35:00',5.46),('10318','2014-03-07','15:40:00',5.09),('10318','2014-03-07','15:45:00',4.75),('10318','2014-03-07','15:50:00',4.03),('10318','2014-03-07','15:55:00',4.11),('10318','2014-03-07','16:00:00',3.89),('10318','2014-03-07','16:05:00',3.49),('10318','2014-03-07','16:10:00',3.16),('10318','2014-03-07','16:15:00',3.29),('10318','2014-03-07','16:20:00',3.04),('10318','2014-03-07','16:25:00',2.85),('10318','2014-03-07','16:30:00',2.63),('10318','2014-03-07','16:35:00',2.56),('10318','2014-03-07','16:40:00',2.6),('10318','2014-03-07','16:45:00',2.47),('10318','2014-03-07','16:50:00',2.28),('10318','2014-03-07','16:55:00',2.14),('10318','2014-03-07','17:00:00',1.97),('10318','2014-03-07','17:05:00',1.79),('10318','2014-03-07','17:10:00',1.57),('10318','2014-03-07','17:15:00',1.35),('10318','2014-03-07','17:20:00',1.07),('10318','2014-03-06','07:55:00',1.4),('10318','2014-03-06','08:00:00',2.38),('10318','2014-03-06','08:05:00',3.17),('10318','2014-03-06','08:10:00',3.11),('10318','2014-03-06','08:15:00',5.43),('10318','2014-03-06','08:20:00',4.24),('10318','2014-03-06','08:25:00',3.68),('10318','2014-03-06','08:30:00',3.88),('10318','2014-03-06','08:35:00',2.28),('10318','2014-03-06','08:40:00',1.77),('10318','2014-03-06','08:45:00',1.74),('10318','2014-03-06','08:50:00',1.81),('10318','2014-03-06','08:55:00',2.49),('10318','2014-03-06','09:00:00',2.36),('10318','2014-03-06','09:05:00',2.36),('10318','2014-03-06','09:10:00',2.38),('10318','2014-03-06','09:15:00',2.66),('10318','2014-03-06','09:20:00',4.91),('10318','2014-03-06','09:25:00',4.2),('10318','2014-03-06','09:30:00',3.99),('10318','2014-03-06','09:35:00',4.44),('10318','2014-03-06','09:40:00',4.72),('10318','2014-03-06','09:45:00',5.35),('10318','2014-03-06','09:50:00',6.19),('10318','2014-03-06','09:55:00',5.67),('10318','2014-03-06','10:00:00',5.48),('10318','2014-03-06','10:05:00',6.36),('10318','2014-03-06','10:10:00',7.36),('10318','2014-03-06','10:15:00',8.3),('10318','2014-03-06','10:20:00',7.93),('10318','2014-03-06','10:25:00',7.76),('10318','2014-03-06','10:30:00',8.19),('10318','2014-03-06','10:35:00',8.05),('10318','2014-03-06','10:40:00',8.88),('10318','2014-03-06','10:45:00',8.35),('10318','2014-03-06','10:50:00',8.93),('10318','2014-03-06','10:55:00',7.83),('10318','2014-03-06','11:00:00',8.32),('10318','2014-03-06','11:05:00',6.71),('10318','2014-03-06','11:10:00',7.61),('10318','2014-03-06','11:15:00',8.82),('10318','2014-03-06','11:20:00',6.12),('10318','2014-03-06','11:25:00',3.38),('10318','2014-03-06','11:30:00',3.12),('10318','2014-03-06','11:35:00',3.44),('10318','2014-03-06','11:40:00',3.05),('10318','2014-03-06','11:45:00',2.97),('10318','2014-03-06','11:50:00',2.85),('10318','2014-03-06','11:55:00',3.47),('10318','2014-03-06','12:00:00',3.46),('10318','2014-03-06','12:05:00',6.09),('10318','2014-03-06','12:10:00',6.44),('10318','2014-03-06','12:15:00',5.68),('10318','2014-03-06','12:20:00',2.95),('10318','2014-03-06','12:25:00',2.65),('10318','2014-03-06','12:30:00',3.31),('10318','2014-03-06','12:35:00',3.32),('10318','2014-03-06','12:40:00',2.57),('10318','2014-03-06','12:45:00',2.37),('10318','2014-03-06','12:50:00',2.66),('10318','2014-03-06','12:55:00',3.79),('10318','2014-03-06','13:00:00',3.52),('10318','2014-03-06','13:05:00',3.82),('10318','2014-03-06','13:10:00',2.98),('10318','2014-03-06','13:15:00',2.78),('10318','2014-03-06','13:20:00',2.68),('10318','2014-03-06','13:25:00',2.39),('10318','2014-03-06','13:30:00',2.32),('10318','2014-03-06','13:35:00',2.2),('10318','2014-03-06','13:40:00',2.28),('10318','2014-03-06','13:45:00',2.36),('10318','2014-03-06','13:50:00',2.24),('10318','2014-03-06','13:55:00',2.09),('10318','2014-03-06','14:00:00',2.11),('10318','2014-03-06','14:05:00',2.42),('10318','2014-03-06','14:10:00',2.71),('10318','2014-03-06','14:15:00',2.73),('10318','2014-03-06','14:20:00',2.8),('10318','2014-03-06','14:25:00',2.57),('10318','2014-03-06','14:30:00',2.42),('10318','2014-03-06','14:35:00',2.67),('10318','2014-03-06','14:40:00',2.37),('10318','2014-03-06','14:45:00',1.86),('10318','2014-03-06','14:50:00',1.84),('10318','2014-03-06','14:55:00',2.08),('10318','2014-03-06','15:00:00',2.37),('10318','2014-03-06','15:05:00',2.61),('10318','2014-03-06','15:10:00',3.18),('10318','2014-03-06','15:15:00',2.37),('10318','2014-03-06','15:20:00',1.84),('10318','2014-03-06','15:25:00',2.02),('10318','2014-03-06','15:30:00',1.65),('10318','2014-03-06','15:35:00',1.87),('10318','2014-03-06','15:40:00',1.81),('10318','2014-03-06','15:45:00',1.2),('10318','2014-03-06','15:55:00',1.04),('10318','2014-03-06','16:00:00',1.37),('10318','2014-03-06','16:05:00',1.68),('10318','2014-03-06','16:10:00',1.41),('10318','2014-03-06','16:15:00',1.41),('10318','2014-03-06','16:20:00',1.52),('10318','2014-03-06','16:25:00',1.44),('10318','2014-03-06','16:30:00',1.33),('10318','2014-03-06','16:35:00',1.15),('10318','2014-03-06','16:45:00',1.02),('10318','2014-03-06','16:50:00',1.04),('10318','2014-03-06','16:55:00',1.06),('10318','2014-03-06','17:05:00',1.24),('10318','2014-03-06','17:10:00',1.32),('10318','2014-03-06','17:15:00',1.12),('10318','2014-03-05','07:15:00',1.26),('10318','2014-03-05','07:20:00',1.36),('10318','2014-03-05','07:25:00',1.58),('10318','2014-03-05','07:30:00',1.89),('10318','2014-03-05','07:35:00',2.33),('10318','2014-03-05','07:40:00',2.63),('10318','2014-03-05','07:45:00',3.37),('10318','2014-03-05','07:50:00',4.19),('10318','2014-03-05','07:55:00',4.37),('10318','2014-03-05','08:00:00',4.55),('10318','2014-03-05','08:05:00',4.72),('10318','2014-03-05','08:10:00',4.96),('10318','2014-03-05','08:15:00',5.3),('10318','2014-03-05','08:20:00',5.66),('10318','2014-03-05','08:25:00',3.81),('10318','2014-03-05','08:30:00',2.29),('10318','2014-03-05','08:35:00',5.58),('10318','2014-03-05','08:40:00',6.82),('10318','2014-03-05','08:45:00',6.56),('10318','2014-03-05','08:50:00',6.05),('10318','2014-03-05','08:55:00',4.27),('10318','2014-03-05','09:00:00',2.42),('10318','2014-03-05','09:05:00',3.86),('10318','2014-03-05','09:10:00',6.61),('10318','2014-03-05','09:15:00',7.14),('10318','2014-03-05','09:20:00',7.04),('10318','2014-03-05','09:25:00',7.32),('10318','2014-03-05','09:30:00',7.29),('10318','2014-03-05','09:35:00',7.55),('10318','2014-03-05','09:40:00',7.71),('10318','2014-03-05','09:45:00',7.82),('10318','2014-03-05','09:50:00',7.88),('10318','2014-03-05','09:55:00',7.99),('10318','2014-03-05','10:00:00',8.07),('10318','2014-03-05','10:05:00',8.17),('10318','2014-03-05','10:10:00',8.28),('10318','2014-03-05','10:15:00',8.37),('10318','2014-03-05','10:20:00',8.44),('10318','2014-03-05','10:25:00',8.5),('10318','2014-03-05','10:30:00',8.6),('10318','2014-03-05','10:35:00',8.64),('10318','2014-03-05','10:40:00',8.68),('10318','2014-03-05','10:45:00',8.54),('10318','2014-03-05','10:50:00',8.71),('10318','2014-03-05','10:55:00',8.73),('10318','2014-03-05','11:00:00',8.82),('10318','2014-03-05','11:05:00',8.96),('10318','2014-03-05','11:10:00',9.09),('10318','2014-03-05','11:15:00',9.14),('10318','2014-03-05','11:20:00',9.66),('10318','2014-03-05','11:25:00',9.91),('10318','2014-03-05','11:30:00',9.81),('10318','2014-03-05','11:35:00',9.8),('10318','2014-03-05','11:40:00',9.7),('10318','2014-03-05','11:45:00',9.52),('10318','2014-03-05','11:50:00',9.54),('10318','2014-03-05','11:55:00',8.72),('10318','2014-03-05','12:00:00',6.78),('10318','2014-03-05','12:05:00',5.97),('10318','2014-03-05','12:10:00',9.12),('10318','2014-03-05','12:15:00',6.69),('10318','2014-03-05','12:20:00',7.64),('10318','2014-03-05','12:25:00',5.21),('10318','2014-03-05','12:30:00',3.49),('10318','2014-03-05','12:35:00',4.8),('10318','2014-03-05','12:40:00',6.24),('10318','2014-03-05','12:45:00',2.82),('10318','2014-03-05','12:50:00',3.16),('10318','2014-03-05','12:55:00',2.09),('10318','2014-03-05','13:00:00',5.89),('10318','2014-03-05','13:05:00',4.53),('10318','2014-03-05','13:10:00',7.63),('10318','2014-03-05','13:15:00',8.17),('10318','2014-03-05','13:20:00',5),('10318','2014-03-05','13:25:00',6.15),('10318','2014-03-05','13:30:00',4.7),('10318','2014-03-05','13:35:00',2.98),('10318','2014-03-05','13:40:00',4.12),('10318','2014-03-05','13:45:00',4.8),('10318','2014-03-05','13:50:00',3.25),('10318','2014-03-05','13:55:00',2.87),('10318','2014-03-05','14:00:00',2.67),('10318','2014-03-05','14:05:00',3.12),('10318','2014-03-05','14:10:00',2.95),('10318','2014-03-05','14:15:00',2.76),('10318','2014-03-05','14:20:00',3.13),('10318','2014-03-05','14:25:00',4.09),('10318','2014-03-05','14:30:00',4.9),('10318','2014-03-05','14:35:00',3.36),('10318','2014-03-05','14:40:00',7.1),('10318','2014-03-05','14:45:00',7.56),('10318','2014-03-05','14:50:00',6.98),('10318','2014-03-05','14:55:00',4.34),('10318','2014-03-05','15:00:00',2.67),('10318','2014-03-05','15:05:00',1.84),('10318','2014-03-05','15:10:00',1.68),('10318','2014-03-05','15:15:00',1.62),('10318','2014-03-05','15:20:00',1.6),('10318','2014-03-05','15:25:00',1.79),('10318','2014-03-05','15:30:00',2.09),('10318','2014-03-05','15:35:00',2.42),('10318','2014-03-05','15:40:00',3.25),('10318','2014-03-05','15:45:00',4.07),('10318','2014-03-05','15:50:00',4.1),('10318','2014-03-05','15:55:00',3.95),('10318','2014-03-05','16:00:00',5.09),('10318','2014-03-05','16:05:00',5.12),('10318','2014-03-05','16:10:00',4.42),('10318','2014-03-05','16:15:00',3.06),('10318','2014-03-05','16:20:00',1.19),('10318','2014-03-04','08:40:00',1.33),('10318','2014-03-04','08:45:00',1.39),('10318','2014-03-04','09:00:00',1.93),('10318','2014-03-04','09:05:00',1.94),('10318','2014-03-04','09:10:00',5.84),('10318','2014-03-04','09:15:00',4.47),('10318','2014-03-04','09:20:00',2.41),('10318','2014-03-04','09:25:00',1.89),('10318','2014-03-04','09:30:00',1.86),('10318','2014-03-04','09:35:00',1.69),('10318','2014-03-04','09:40:00',1.75),('10318','2014-03-04','09:45:00',1.26),('10318','2014-03-04','09:50:00',2.03),('10318','2014-03-04','09:55:00',4.35),('10318','2014-03-04','10:00:00',3.13),('10318','2014-03-04','10:05:00',2.39),('10318','2014-03-04','10:10:00',1.59),('10318','2014-03-04','10:15:00',1.27),('10318','2014-03-04','10:20:00',3.25),('10318','2014-03-04','10:25:00',3.21),('10318','2014-03-04','10:30:00',5.95),('10318','2014-03-04','10:35:00',10.2),('10318','2014-03-04','10:40:00',9.33),('10318','2014-03-04','10:45:00',10.74),('10318','2014-03-04','10:50:00',10.01),('10318','2014-03-04','10:55:00',10.15),('10318','2014-03-04','11:00:00',9.93),('10318','2014-03-04','11:05:00',10.44),('10318','2014-03-04','11:10:00',9.52),('10318','2014-03-04','11:15:00',7.92),('10318','2014-03-04','11:25:00',2.34),('10318','2014-03-04','11:30:00',2.64),('10318','2014-03-04','11:35:00',1.97),('10318','2014-03-04','11:40:00',2),('10318','2014-03-04','11:45:00',3.57),('10318','2014-03-04','11:50:00',9.28),('10318','2014-03-04','11:55:00',9.89),('10318','2014-03-04','12:00:00',9.52),('10318','2014-03-04','12:05:00',9.38),('10318','2014-03-04','12:10:00',9.24),('10318','2014-03-04','12:15:00',9.3),('10318','2014-03-04','12:20:00',8.39),('10318','2014-03-04','12:25:00',8.19),('10318','2014-03-04','12:30:00',8.95),('10318','2014-03-04','12:35:00',8.68),('10318','2014-03-04','12:40:00',9.05),('10318','2014-03-04','12:45:00',8.99),('10318','2014-03-04','12:50:00',8.69),('10318','2014-03-04','12:55:00',8.89),('10318','2014-03-04','13:00:00',8.27),('10318','2014-03-04','13:05:00',7.81),('10318','2014-03-04','13:10:00',6.8),('10318','2014-03-04','13:15:00',3.87),('10318','2014-03-04','13:20:00',7.5),('10318','2014-03-04','13:25:00',7.42),('10318','2014-03-04','13:30:00',4.35),('10318','2014-03-04','13:35:00',1.77),('10318','2014-03-04','13:40:00',2.92),('10318','2014-03-04','13:45:00',5.1),('10318','2014-03-04','13:50:00',2.35),('10318','2014-03-04','13:55:00',2.31),('10318','2014-03-04','14:00:00',3.59),('10318','2014-03-04','14:05:00',8),('10318','2014-03-04','14:10:00',8.07),('10318','2014-03-04','14:15:00',2.64),('10318','2014-03-04','14:20:00',8.02),('10318','2014-03-04','14:25:00',7.61),('10318','2014-03-04','14:30:00',6.97),('10318','2014-03-04','14:35:00',6.7),('10318','2014-03-04','14:40:00',6),('10318','2014-03-04','14:45:00',4.92),('10318','2014-03-04','14:50:00',6.07),('10318','2014-03-04','14:55:00',5.23),('10318','2014-03-04','15:00:00',4.49),('10318','2014-03-04','15:05:00',5.87),('10318','2014-03-04','15:10:00',5.05),('10318','2014-03-04','15:15:00',4.8),('10318','2014-03-04','15:20:00',5.15),('10318','2014-03-04','15:25:00',4.34),('10318','2014-03-04','15:30:00',5.35),('10318','2014-03-04','15:35:00',4.87),('10318','2014-03-04','15:40:00',4.58),('10318','2014-03-04','15:45:00',3.52),('10318','2014-03-04','15:50:00',4.27),('10318','2014-03-04','15:55:00',1.32),('10318','2014-03-04','16:00:00',1.61),('10318','2014-03-04','16:05:00',2.19),('10318','2014-03-04','16:10:00',1.65),('10318','2014-03-04','16:15:00',1.65),('10318','2014-03-04','16:20:00',2.06),('10318','2014-03-04','16:25:00',2.52),('10318','2014-03-04','16:30:00',2.04),('10318','2014-03-04','16:35:00',1.89),('10318','2014-03-04','16:40:00',2.07),('10318','2014-03-04','16:45:00',2.04),('10318','2014-03-04','16:50:00',1.73),('10318','2014-03-04','16:55:00',1.45),('10318','2014-03-04','17:00:00',1.05),('10318','2014-03-03','07:20:00',1.03),('10318','2014-03-03','07:25:00',1.29),('10318','2014-03-03','07:30:00',1.51),('10318','2014-03-03','07:35:00',1.71),('10318','2014-03-03','07:40:00',1.89),('10318','2014-03-03','07:45:00',2.04),('10318','2014-03-03','07:50:00',3.23),('10318','2014-03-03','07:55:00',3.19),('10318','2014-03-03','08:00:00',3.28),('10318','2014-03-03','08:05:00',3.79),('10318','2014-03-03','08:10:00',4.48),('10318','2014-03-03','08:15:00',4.69),('10318','2014-03-03','08:20:00',4.89),('10318','2014-03-03','08:25:00',5.07),('10318','2014-03-03','08:30:00',5.27),('10318','2014-03-03','08:35:00',5.4),('10318','2014-03-03','08:40:00',5.69),('10318','2014-03-03','08:45:00',5.86),('10318','2014-03-03','08:50:00',5.89),('10318','2014-03-03','08:55:00',6.04),('10318','2014-03-03','09:00:00',5.57),('10318','2014-03-03','09:05:00',4.86),('10318','2014-03-03','09:10:00',5.26),('10318','2014-03-03','09:15:00',6.72),('10318','2014-03-03','09:20:00',6.87),('10318','2014-03-03','09:25:00',7.18),('10318','2014-03-03','09:30:00',6.82),('10318','2014-03-03','09:35:00',6.84),('10318','2014-03-03','09:40:00',6.43),('10318','2014-03-03','09:45:00',7.06),('10318','2014-03-03','09:50:00',7.33),('10318','2014-03-03','09:55:00',6.98),('10318','2014-03-03','10:00:00',7.9),('10318','2014-03-03','10:05:00',7.92),('10318','2014-03-03','10:10:00',8.05),('10318','2014-03-03','10:15:00',8.12),('10318','2014-03-03','10:20:00',7.95),('10318','2014-03-03','10:25:00',8.24),('10318','2014-03-03','10:30:00',8.29),('10318','2014-03-03','10:35:00',8.33),('10318','2014-03-03','10:40:00',8.36),('10318','2014-03-03','10:45:00',8.46),('10318','2014-03-03','10:50:00',8.62),('10318','2014-03-03','10:55:00',8.63),('10318','2014-03-03','11:00:00',8.64),('10318','2014-03-03','11:05:00',8.67),('10318','2014-03-03','11:10:00',8.69),('10318','2014-03-03','11:15:00',8.74),('10318','2014-03-03','11:20:00',8.77),('10318','2014-03-03','11:25:00',8.9),('10318','2014-03-03','11:30:00',8.95),('10318','2014-03-03','11:35:00',8.94),('10318','2014-03-03','11:40:00',8.88),('10318','2014-03-03','11:45:00',8.91),('10318','2014-03-03','11:50:00',8.96),('10318','2014-03-03','11:55:00',8.97),('10318','2014-03-03','12:00:00',8.96),('10318','2014-03-03','12:05:00',8.92),('10318','2014-03-03','12:10:00',8.92),('10318','2014-03-03','12:15:00',8.92),('10318','2014-03-03','12:20:00',8.89),('10318','2014-03-03','12:25:00',8.84),('10318','2014-03-03','12:30:00',8.81),('10318','2014-03-03','12:35:00',8.81),('10318','2014-03-03','12:40:00',8.78),('10318','2014-03-03','12:45:00',8.73),('10318','2014-03-03','12:50:00',8.68),('10318','2014-03-03','12:55:00',8.66),('10318','2014-03-03','13:00:00',8.59),('10318','2014-03-03','13:05:00',8.48),('10318','2014-03-03','13:10:00',8.43),('10318','2014-03-03','13:15:00',8.34),('10318','2014-03-03','13:20:00',8.21),('10318','2014-03-03','13:25:00',8.2),('10318','2014-03-03','13:30:00',8.09),('10318','2014-03-03','13:35:00',7.65),('10318','2014-03-03','13:40:00',7.89),('10318','2014-03-03','13:45:00',7.85),('10318','2014-03-03','13:50:00',6.47),('10318','2014-03-03','13:55:00',6.45),('10318','2014-03-03','14:00:00',7.64),('10318','2014-03-03','14:05:00',7.64),('10318','2014-03-03','14:10:00',6.96),('10318','2014-03-03','14:15:00',7.21),('10318','2014-03-03','14:20:00',5.36),('10318','2014-03-03','14:25:00',7.04),('10318','2014-03-03','14:30:00',6.58),('10318','2014-03-03','14:35:00',6.64),('10318','2014-03-03','14:40:00',6.36),('10318','2014-03-03','14:45:00',6.2),('10318','2014-03-03','14:50:00',6.03),('10318','2014-03-03','14:55:00',5.76),('10318','2014-03-03','15:00:00',5.72),('10318','2014-03-03','15:05:00',5.39),('10318','2014-03-03','15:10:00',5.3),('10318','2014-03-03','15:15:00',5.25),('10318','2014-03-03','15:20:00',5.13),('10318','2014-03-03','15:25:00',3.93),('10318','2014-03-03','15:30:00',4.72),('10318','2014-03-03','15:35:00',4.48),('10318','2014-03-03','15:40:00',4.23),('10318','2014-03-03','15:45:00',3.87),('10318','2014-03-03','15:50:00',3.83),('10318','2014-03-03','15:55:00',3.63),('10318','2014-03-03','16:00:00',3.43),('10318','2014-03-03','16:05:00',3.26),('10318','2014-03-03','16:10:00',3.12),('10318','2014-03-03','16:15:00',2.95),('10318','2014-03-03','16:20:00',2.78),('10318','2014-03-03','16:25:00',2.61),('10318','2014-03-03','16:30:00',2.43),('10318','2014-03-03','16:35:00',2.23),('10318','2014-03-03','16:40:00',2.01),('10318','2014-03-03','16:45:00',1.81),('10318','2014-03-03','16:50:00',1.57),('10318','2014-03-03','16:55:00',1.24),('10318','2014-03-03','17:00:00',1.28),('10318','2014-03-03','17:05:00',1.11),('10318','2014-03-02','07:45:00',1.02),('10318','2014-03-02','07:50:00',1.94),('10318','2014-03-02','07:55:00',3.36),('10318','2014-03-02','08:00:00',3.06),('10318','2014-03-02','08:05:00',1.35),('10318','2014-03-02','08:10:00',2.69),('10318','2014-03-02','08:15:00',3.16),('10318','2014-03-02','08:20:00',3.24),('10318','2014-03-02','08:25:00',5.73),('10318','2014-03-02','08:30:00',5.4),('10318','2014-03-02','08:35:00',5.44),('10318','2014-03-02','08:40:00',5.72),('10318','2014-03-02','08:45:00',5.91),('10318','2014-03-02','08:50:00',6.13),('10318','2014-03-02','08:55:00',6.3),('10318','2014-03-02','09:00:00',6.47),('10318','2014-03-02','09:05:00',6.7),('10318','2014-03-02','09:10:00',7.01),('10318','2014-03-02','09:15:00',5.79),('10318','2014-03-02','09:20:00',6.13),('10318','2014-03-02','09:25:00',7.69),('10318','2014-03-02','09:30:00',5.95),('10318','2014-03-02','09:35:00',7.34),('10318','2014-03-02','09:40:00',5.01),('10318','2014-03-02','09:45:00',1.04),('10318','2014-03-02','09:50:00',1.39),('10318','2014-03-02','09:55:00',3.36),('10318','2014-03-02','10:00:00',4.65),('10318','2014-03-02','10:05:00',2.58),('10318','2014-03-02','10:10:00',2.71),('10318','2014-03-02','10:15:00',3.43),('10318','2014-03-02','10:20:00',4.96),('10318','2014-03-02','10:25:00',6.02),('10318','2014-03-02','10:30:00',5.12),('10318','2014-03-02','10:35:00',9.17),('10318','2014-03-02','10:40:00',9.13),('10318','2014-03-02','10:45:00',9.22),('10318','2014-03-02','10:50:00',9.48),('10318','2014-03-02','10:55:00',8.78),('10318','2014-03-02','11:00:00',10.21),('10318','2014-03-02','11:05:00',5.24),('10318','2014-03-02','11:10:00',3.6),('10318','2014-03-02','11:15:00',4.03),('10318','2014-03-02','11:20:00',5.07),('10318','2014-03-02','11:25:00',6.51),('10318','2014-03-02','11:30:00',10.55),('10318','2014-03-02','11:35:00',7.93),('10318','2014-03-02','11:40:00',10.22),('10318','2014-03-02','11:45:00',9.99),('10318','2014-03-02','11:50:00',10.21),('10318','2014-03-02','11:55:00',9.98),('10318','2014-03-02','12:00:00',8.72),('10318','2014-03-02','12:05:00',5.22),('10318','2014-03-02','12:10:00',4),('10318','2014-03-02','12:15:00',5.24),('10318','2014-03-02','12:20:00',4.08),('10318','2014-03-02','12:25:00',3.44),('10318','2014-03-02','12:30:00',2.87),('10318','2014-03-02','12:35:00',2.2),('10318','2014-03-02','12:40:00',1.54),('10318','2014-03-02','12:45:00',1.29),('10318','2014-03-02','12:50:00',1.16),('10318','2014-03-02','12:55:00',1.21),('10318','2014-03-02','13:00:00',1.69),('10318','2014-03-02','13:05:00',2.57),('10318','2014-03-02','13:10:00',2.87),('10318','2014-03-02','13:15:00',2.58),('10318','2014-03-02','13:20:00',2.37),('10318','2014-03-02','13:25:00',2.08),('10318','2014-03-02','13:30:00',2.31),('10318','2014-03-02','13:35:00',2.38),('10318','2014-03-02','13:40:00',2.19),('10318','2014-03-02','13:45:00',1.99),('10318','2014-03-02','13:50:00',2.15),('10318','2014-03-02','13:55:00',2.36),('10318','2014-03-02','14:00:00',2.56),('10318','2014-03-02','14:05:00',2.76),('10318','2014-03-02','14:10:00',2.7),('10318','2014-03-02','14:15:00',2.62),('10318','2014-03-02','14:20:00',2.58),('10318','2014-03-02','14:25:00',2.47),('10318','2014-03-02','14:30:00',2.46),('10318','2014-03-02','14:35:00',2.49),('10318','2014-03-02','14:40:00',2.49),('10318','2014-03-02','14:45:00',2.5),('10318','2014-03-02','14:50:00',2.57),('10318','2014-03-02','14:55:00',2.63),('10318','2014-03-02','15:00:00',2.76),('10318','2014-03-02','15:05:00',2.87),('10318','2014-03-02','15:10:00',2.82),('10318','2014-03-02','15:15:00',2.89),('10318','2014-03-02','15:20:00',3.01),('10318','2014-03-02','15:25:00',2.92),('10318','2014-03-02','15:30:00',3.02),('10318','2014-03-02','15:35:00',3.02),('10318','2014-03-02','15:40:00',2.81),('10318','2014-03-02','15:45:00',2.77),('10318','2014-03-02','15:50:00',2.4),('10318','2014-03-02','15:55:00',1.97),('10318','2014-03-02','16:00:00',1.84),('10318','2014-03-02','16:05:00',1.63),('10318','2014-03-02','16:10:00',1.4),('10318','2014-03-02','16:15:00',1.29),('10318','2014-03-02','16:20:00',1.22),('10318','2014-03-02','16:25:00',1.04),('10318','2014-03-01','08:35:00',1.03),('10318','2014-03-01','09:50:00',1.13),('10318','2014-03-01','09:55:00',1.18),('10318','2014-03-01','10:20:00',1.02),('10318','2014-03-01','10:25:00',1.06),('10318','2014-03-01','10:30:00',1.03),('10318','2014-03-01','12:00:00',1.15),('10318','2014-03-01','12:05:00',1.04),('10318','2014-03-01','12:30:00',1.09),('10318','2014-03-01','12:35:00',1.1),('10318','2014-03-01','12:40:00',1.33),('10318','2014-03-01','12:45:00',1.2),('10318','2014-03-01','13:00:00',1.09),('10318','2014-03-01','13:05:00',1.24),('10318','2014-03-01','13:10:00',1.27),('10318','2014-03-01','13:15:00',1.13),('10318','2014-03-01','13:20:00',1.08),('10318','2014-03-01','14:35:00',1.59),('10318','2014-03-01','14:40:00',1.74),('10318','2014-03-01','14:45:00',1.32),('10318','2014-03-01','15:00:00',1.01),('10318','2014-03-01','16:10:00',1.16),('10318','2014-03-01','16:15:00',1.32),('10318','2014-03-01','16:20:00',1.24),('10318','2014-02-28','11:15:00',3.07),('10318','2014-02-28','11:20:00',3.72),('10318','2014-02-28','11:25:00',3.78),('10318','2014-02-28','11:30:00',2.95),('10318','2014-02-28','11:35:00',1.98),('10318','2014-02-28','11:40:00',2.02),('10318','2014-02-28','11:45:00',1.86),('10318','2014-02-28','11:50:00',2.29),('10318','2014-02-28','11:55:00',2.79),('10318','2014-02-28','12:00:00',4.58),('10318','2014-02-28','12:05:00',6.67),('10318','2014-02-28','12:10:00',2.5),('10318','2014-02-28','12:15:00',1.38),('10318','2014-02-28','12:20:00',2.84),('10318','2014-02-28','12:25:00',5.84),('10318','2014-02-28','12:30:00',7.17),('10318','2014-02-28','12:35:00',9.74),('10318','2014-02-28','12:40:00',7.12),('10318','2014-02-28','12:45:00',3.1),('10318','2014-02-28','12:50:00',3.51),('10318','2014-02-28','12:55:00',5.53),('10318','2014-02-28','13:00:00',5.44),('10318','2014-02-28','13:05:00',3.88),('10318','2014-02-28','13:11:00',3.14),('10318','2014-02-28','13:15:00',1.94),('10318','2014-02-28','13:20:00',1.18),('10318','2014-02-28','13:40:00',1.18),('10318','2014-02-28','13:45:00',2.54),('10318','2014-02-28','13:50:00',3.26),('10318','2014-02-28','13:55:00',2.37),('10318','2014-02-28','14:00:00',2.17),('10318','2014-02-28','14:05:00',1.39),('10318','2014-02-28','14:10:00',1.52),('10318','2014-02-28','14:15:00',2.35),('10318','2014-02-28','14:20:00',3.46),('10318','2014-02-28','14:25:00',4.48),('10318','2014-02-28','14:30:00',4.2),('10318','2014-02-28','14:35:00',3.24),('10318','2014-02-28','14:40:00',2.96),('10318','2014-02-28','15:00:00',2.4),('10318','2014-02-28','15:05:00',2.65),('10318','2014-02-28','15:10:00',1.5),('10318','2014-02-28','15:15:00',1.23),('10318','2014-02-28','15:20:00',3.27),('10318','2014-02-28','15:25:00',4.05),('10318','2014-02-28','15:30:00',3.57),('10318','2014-02-28','15:35:00',2.23),('10318','2014-02-28','15:40:00',1.77),('10318','2014-02-28','15:45:00',1.64),('10318','2014-02-28','15:50:00',1.25),('10318','2014-02-28','16:10:00',1.35),('10318','2014-02-28','16:15:00',3.77),('10318','2014-02-28','16:20:00',2.71),('10318','2014-02-28','16:25:00',1.15),('10318','2014-02-28','16:30:00',1.5),('10318','2014-02-28','16:35:00',2.16),('10318','2014-02-28','16:40:00',2.73),('10318','2014-02-28','16:45:00',2.36),('10318','2014-02-28','16:50:00',1.54),('10318','2014-02-27','09:50:00',1.06),('10318','2014-02-27','10:05:00',1.14),('10318','2014-02-27','10:10:00',1.17),('10318','2014-02-27','10:15:00',1.17),('10318','2014-02-27','10:20:00',1.29),('10318','2014-02-27','10:25:00',1.63),('10318','2014-02-27','10:30:00',2.13),('10318','2014-02-27','10:35:00',2.49),('10318','2014-02-27','10:40:00',2.91),('10318','2014-02-27','10:45:00',2.98),('10318','2014-02-27','10:50:00',2.93),('10318','2014-02-27','10:55:00',3.31),('10318','2014-02-27','11:00:00',4.08),('10318','2014-02-27','11:05:00',3.97),('10318','2014-02-27','11:10:00',3.79),('10318','2014-02-27','11:15:00',3.47),('10318','2014-02-27','11:20:00',3.08),('10318','2014-02-27','11:25:00',4.02),('10318','2014-02-27','11:30:00',4.57),('10318','2014-02-27','11:35:00',3.64),('10318','2014-02-27','11:40:00',3.11),('10318','2014-02-27','11:45:00',2.6),('10318','2014-02-27','11:50:00',2.75),('10318','2014-02-27','11:55:00',3),('10318','2014-02-27','12:00:00',2.75),('10318','2014-02-27','12:05:00',2.66),('10318','2014-02-27','12:10:00',2.96),('10318','2014-02-27','12:15:00',2.94),('10318','2014-02-27','12:20:00',2.99),('10318','2014-02-27','12:25:00',2.97),('10318','2014-02-27','12:30:00',2.87),('10318','2014-02-27','12:35:00',2.75),('10318','2014-02-27','12:40:00',2.68),('10318','2014-02-27','12:45:00',2.69),('10318','2014-02-27','12:50:00',2.68),('10318','2014-02-27','12:55:00',2.73),('10318','2014-02-27','13:00:00',2.72),('10318','2014-02-27','13:05:00',2.31),('10318','2014-02-27','13:10:00',2.5),('10318','2014-02-27','13:15:00',2.74),('10318','2014-02-27','13:20:00',2.77),('10318','2014-02-27','13:25:00',2.97),('10318','2014-02-27','13:30:00',3.59),('10318','2014-02-27','13:35:00',3.89),('10318','2014-02-27','13:40:00',3.91),('10318','2014-02-27','13:45:00',3.76),('10318','2014-02-27','13:50:00',3.61),('10318','2014-02-27','13:55:00',4.68),('10318','2014-02-27','14:00:00',5.04),('10318','2014-02-27','14:05:00',3.67),('10318','2014-02-27','14:10:00',3.64),('10318','2014-02-27','14:15:00',3.47),('10318','2014-02-27','14:20:00',3.11),('10318','2014-02-27','14:25:00',2.68),('10318','2014-02-27','14:30:00',2.43),('10318','2014-02-27','14:35:00',2.13),('10318','2014-02-27','14:40:00',1.9),('10318','2014-02-27','14:45:00',2.09),('10318','2014-02-27','14:50:00',2.15),('10318','2014-02-27','14:55:00',2.21),('10318','2014-02-27','15:00:00',2.56),('10318','2014-02-27','15:05:00',2.83),('10318','2014-02-27','15:10:00',3.26),('10318','2014-02-27','15:15:00',4.04),('10318','2014-02-27','15:20:00',3.47),('10318','2014-02-27','15:25:00',3.02),('10318','2014-02-27','15:30:00',2.66),('10318','2014-02-27','15:35:00',2.39),('10318','2014-02-27','15:40:00',2.11),('10318','2014-02-27','15:45:00',1.84),('10318','2014-02-27','15:50:00',1.53),('10318','2014-02-27','15:55:00',1.46),('10318','2014-02-27','16:00:00',1.36),('10318','2014-02-27','16:05:00',1.16),('10318','2014-02-27','16:25:00',1.57),('10318','2014-02-27','16:30:00',1.75),('10318','2014-02-27','16:35:00',1.72),('10318','2014-02-27','16:40:00',1.39),('10318','2014-02-27','16:45:00',1.89),('10318','2014-02-27','16:50:00',2.33),('10318','2014-02-27','16:55:00',2.03),('10318','2014-02-27','17:00:00',1.71),('10318','2014-02-27','17:05:00',1.34),('10318','2014-02-26','07:30:00',1.11),('10318','2014-02-26','07:35:00',1.21),('10318','2014-02-26','07:40:00',1.36),('10318','2014-02-26','07:45:00',1.48),('10318','2014-02-26','07:50:00',1.76),('10318','2014-02-26','07:55:00',2.56),('10318','2014-02-26','08:00:00',3.27),('10318','2014-02-26','08:05:00',3.67),('10318','2014-02-26','08:10:00',3.96),('10318','2014-02-26','08:15:00',4.21),('10318','2014-02-26','08:20:00',4.39),('10318','2014-02-26','08:25:00',4.45),('10318','2014-02-26','08:30:00',4.83),('10318','2014-02-26','08:35:00',5.06),('10318','2014-02-26','08:40:00',5.45),('10318','2014-02-26','08:45:00',4.66),('10318','2014-02-26','08:50:00',3.41),('10318','2014-02-26','08:55:00',5.76),('10318','2014-02-26','09:00:00',5.75),('10318','2014-02-26','09:05:00',5.97),('10318','2014-02-26','09:10:00',6.26),('10318','2014-02-26','09:15:00',5.74),('10318','2014-02-26','09:20:00',5.63),('10318','2014-02-26','09:25:00',6.01),('10318','2014-02-26','09:30:00',4.19),('10318','2014-02-26','09:35:00',3.01),('10318','2014-02-26','09:40:00',4.28),('10318','2014-02-26','09:45:00',4.03),('10318','2014-02-26','09:50:00',3.43),('10318','2014-02-26','09:55:00',3.45),('10318','2014-02-26','10:00:00',2.53),('10318','2014-02-26','10:05:00',2.45),('10318','2014-02-26','10:10:00',2.14),('10318','2014-02-26','10:15:00',2.13),('10318','2014-02-26','10:20:00',1.67),('10318','2014-02-26','10:25:00',1.51),('10318','2014-02-26','10:30:00',1.75),('10318','2014-02-26','10:35:00',1.88),('10318','2014-02-26','10:40:00',1.51),('10318','2014-02-26','10:45:00',1.34),('10318','2014-02-26','10:50:00',1.51),('10318','2014-02-26','10:55:00',2.22),('10318','2014-02-26','11:00:00',2.8),('10318','2014-02-26','11:05:00',2.69),('10318','2014-02-26','11:10:00',2.69),('10318','2014-02-26','11:15:00',2.55),('10318','2014-02-26','11:20:00',2.27),('10318','2014-02-26','11:25:00',1.97),('10318','2014-02-26','11:30:00',1.75),('10318','2014-02-26','11:35:00',1.82),('10318','2014-02-26','11:40:00',2.05),('10318','2014-02-26','11:45:00',2.76),('10318','2014-02-26','11:50:00',2.69),('10318','2014-02-26','11:55:00',2.65),('10318','2014-02-26','12:00:00',2.61),('10318','2014-02-26','12:05:00',2.47),('10318','2014-02-26','12:10:00',2.54),('10318','2014-02-26','12:15:00',3.46),('10318','2014-02-26','12:20:00',6.41),('10318','2014-02-26','12:25:00',5.13),('10318','2014-02-26','12:30:00',3.96),('10318','2014-02-26','12:35:00',6.67),('10318','2014-02-26','12:40:00',9.02),('10318','2014-02-26','12:45:00',6.49),('10318','2014-02-26','12:50:00',8.69),('10318','2014-02-26','12:55:00',7.88),('10318','2014-02-26','13:00:00',7.64),('10318','2014-02-26','13:05:00',4.84),('10318','2014-02-26','13:10:00',6.27),('10318','2014-02-26','13:15:00',3.05),('10318','2014-02-26','13:20:00',4.57),('10318','2014-02-26','13:25:00',5.92),('10318','2014-02-26','13:30:00',7.86),('10318','2014-02-26','13:35:00',6.94),('10318','2014-02-26','13:40:00',4.96),('10318','2014-02-26','13:45:00',3.43),('10318','2014-02-26','13:50:00',6.89),('10318','2014-02-26','13:55:00',2.49),('10318','2014-02-26','14:00:00',4.45),('10318','2014-02-26','14:05:00',6.12),('10318','2014-02-26','14:10:00',1.84),('10318','2014-02-26','14:15:00',4.85),('10318','2014-02-26','14:20:00',5.39),('10318','2014-02-26','14:25:00',6.27),('10318','2014-02-26','14:30:00',6.16),('10318','2014-02-26','14:35:00',4.42),('10318','2014-02-26','14:40:00',4.97),('10318','2014-02-26','14:45:00',2.76),('10318','2014-02-26','14:50:00',5.86),('10318','2014-02-26','14:55:00',3.18),('10318','2014-02-26','15:00:00',5.67),('10318','2014-02-26','15:05:00',5.71),('10318','2014-02-26','15:10:00',5.46),('10318','2014-02-26','15:15:00',4.73),('10318','2014-02-26','15:20:00',3.47),('10318','2014-02-26','15:25:00',2.24),('10318','2014-02-26','15:30:00',2.62),('10318','2014-02-26','15:35:00',3.4),('10318','2014-02-26','15:40:00',3.46),('10318','2014-02-26','15:45:00',2.84),('10318','2014-02-26','15:50:00',2.81),('10318','2014-02-26','15:55:00',3.56),('10318','2014-02-26','16:00:00',3.64),('10318','2014-02-26','16:05:00',3.15),('10318','2014-02-26','16:10:00',2.43),('10318','2014-02-26','16:15:00',2.24),('10318','2014-02-26','16:20:00',1.87),('10318','2014-02-26','16:25:00',1.26),('10318','2014-02-26','16:30:00',1.09),('10318','2014-04-29','09:10:00',1.09),('10318','2014-04-29','09:15:00',1.18),('10318','2014-04-29','09:20:00',1.01),('10318','2014-04-29','09:35:00',1.08),('10318','2014-04-29','09:40:00',1.49),('10318','2014-04-29','09:45:00',2.03),('10318','2014-04-29','09:50:00',2.64),('10318','2014-04-29','09:55:00',3.25),('10318','2014-04-29','10:00:00',4.75),('10318','2014-04-29','10:05:00',8.13),('10318','2014-04-29','10:10:00',9.75),('10318','2014-04-29','10:15:00',9.16),('10318','2014-04-29','10:20:00',9.55),('10318','2014-04-29','10:25:00',9.25),('10318','2014-04-29','10:30:00',9.52),('10318','2014-04-29','10:35:00',9.49),('10318','2014-04-29','10:40:00',9.62),('10318','2014-04-29','10:45:00',9.74),('10318','2014-04-29','10:50:00',8.94),('10318','2014-04-29','10:55:00',8.97),('10318','2014-04-29','11:00:00',9.57),('10318','2014-04-29','11:05:00',9.48),('10318','2014-04-29','11:10:00',5.7),('10318','2014-04-29','11:15:00',7.46),('10318','2014-04-29','11:20:00',9.56),('10318','2014-04-29','11:25:00',9.22),('10318','2014-04-29','11:30:00',6.49),('10318','2014-04-29','11:35:00',9.65),('10318','2014-04-29','11:40:00',5.12),('10318','2014-04-29','11:45:00',8.69),('10318','2014-04-29','11:50:00',3.44),('10318','2014-04-29','11:55:00',3.25),('10318','2014-04-29','12:00:00',2.96),('10318','2014-04-29','12:05:00',3.6),('10318','2014-04-29','12:10:00',5.32),('10318','2014-04-29','12:15:00',4.25),('10318','2014-04-29','12:20:00',8.55),('10318','2014-04-29','12:25:00',3.05),('10318','2014-04-29','12:30:00',6.76),('10318','2014-04-29','12:35:00',10.04),('10318','2014-04-29','12:40:00',10.44),('10318','2014-04-29','12:45:00',3.66),('10318','2014-04-29','12:50:00',3.53),('10318','2014-04-29','12:55:00',3.48),('10318','2014-04-29','13:00:00',5.58),('10318','2014-04-29','13:05:00',5.72),('10318','2014-04-29','13:10:00',3.56),('10318','2014-04-29','13:15:00',2.99),('10318','2014-04-29','13:20:00',3.46),('10318','2014-04-29','13:25:00',6.09),('10318','2014-04-29','13:30:00',4.21),('10318','2014-04-29','13:35:00',3.62),('10318','2014-04-29','13:40:00',6.47),('10318','2014-04-29','13:45:00',4.12),('10318','2014-04-29','13:50:00',1.91),('10318','2014-04-29','13:55:00',1.16),('10318','2014-04-29','14:20:00',1),('10318','2014-04-29','14:25:00',1.11),('10318','2014-04-29','14:30:00',1.01),('10318','2014-04-29','14:35:00',1.1),('10318','2014-04-29','14:40:00',1.23),('10318','2014-04-29','14:45:00',1.22),('10318','2014-04-29','14:50:00',1.09),('10318','2014-04-29','14:55:00',1.12),('10318','2014-04-29','15:00:00',1.54),('10318','2014-04-29','15:05:00',2.1),('10318','2014-04-29','15:10:00',2.25),('10318','2014-04-29','15:15:00',2.03),('10318','2014-04-29','15:20:00',1.89),('10318','2014-04-29','15:25:00',2.1),('10318','2014-04-29','15:30:00',1.99),('10318','2014-04-29','15:35:00',1.67),('10318','2014-04-29','15:40:00',1.15),('10318','2014-04-29','15:45:00',1.05),('10318','2014-04-29','15:50:00',1.31),('10318','2014-04-29','15:55:00',1.46),('10318','2014-04-29','16:00:00',1.44),('10318','2014-04-29','16:05:00',1.73),('10318','2014-04-29','16:10:00',1.83),('10318','2014-04-29','16:15:00',1.68),('10318','2014-04-29','16:20:00',1.45),('10318','2014-04-29','16:25:00',1.33),('10318','2014-04-29','16:30:00',1.21),('10318','2014-04-29','16:35:00',1.2),('10318','2014-04-29','16:40:00',1.33),('10318','2014-04-29','16:45:00',1.34),('10318','2014-04-29','16:50:00',1.41),('10318','2014-04-29','16:55:00',1.75),('10318','2014-04-29','17:00:00',2.32),('10318','2014-04-29','17:05:00',2.34),('10318','2014-04-29','17:10:00',2.07),('10318','2014-04-29','17:15:00',1.84),('10318','2014-04-29','17:20:00',2.75),('10318','2014-04-29','17:25:00',2.61),('10318','2014-04-29','17:30:00',3.5),('10318','2014-04-29','17:35:00',4.12),('10318','2014-04-29','17:40:00',3.36),('10318','2014-04-29','17:45:00',1.96),('10318','2014-04-29','17:50:00',1.11),('10318','2014-04-29','17:55:00',1.4),('10318','2014-04-29','18:00:00',1.48),('10318','2014-04-29','18:05:00',1.4),('10318','2014-02-25','07:30:00',1.06),('10318','2014-02-25','07:35:00',1.22),('10318','2014-02-25','07:40:00',1.41),('10318','2014-02-25','07:45:00',1.66),('10318','2014-02-25','07:50:00',1.86),('10318','2014-02-25','07:55:00',2.44),('10318','2014-02-25','08:00:00',3.24),('10318','2014-02-25','08:05:00',3.54),('10318','2014-02-25','08:10:00',3.75),('10318','2014-02-25','08:15:00',3.97),('10318','2014-02-25','08:20:00',4.21),('10318','2014-02-25','08:25:00',4.45),('10318','2014-02-25','08:30:00',4.66),('10318','2014-02-25','08:35:00',4.87),('10318','2014-02-25','08:40:00',5.08),('10318','2014-02-25','08:45:00',5.29),('10318','2014-02-25','08:50:00',5.47),('10318','2014-02-25','08:55:00',5.64),('10318','2014-02-25','09:00:00',5.8),('10318','2014-02-25','09:05:00',5.95),('10318','2014-02-25','09:10:00',6.1),('10318','2014-02-25','09:15:00',6.26),('10318','2014-02-25','09:20:00',6.45),('10318','2014-02-25','09:25:00',6.44),('10318','2014-02-25','09:30:00',6.69),('10318','2014-02-25','09:35:00',6.84),('10318','2014-02-25','09:40:00',6.96),('10318','2014-02-25','09:45:00',7.12),('10318','2014-02-25','09:50:00',7.18),('10318','2014-02-25','09:55:00',7.17),('10318','2014-02-25','10:00:00',7.25),('10318','2014-02-25','10:05:00',7.37),('10318','2014-02-25','10:10:00',7.55),('10318','2014-02-25','10:15:00',7.65),('10318','2014-02-25','10:20:00',7.75),('10318','2014-02-25','10:25:00',7.8),('10318','2014-02-25','10:30:00',7.91),('10318','2014-02-25','10:35:00',8.01),('10318','2014-02-25','10:40:00',8.04),('10318','2014-02-25','10:45:00',8.14),('10318','2014-02-25','10:50:00',8.18),('10318','2014-02-25','10:55:00',8.23),('10318','2014-02-25','11:00:00',8.27),('10318','2014-02-25','11:05:00',8.3),('10318','2014-02-25','11:10:00',8.24),('10318','2014-02-25','11:15:00',8.31),('10318','2014-02-25','11:20:00',8.37),('10318','2014-02-25','11:25:00',8.39),('10318','2014-02-25','11:30:00',8.34),('10318','2014-02-25','11:35:00',8.36),('10318','2014-02-25','11:40:00',8.36),('10318','2014-02-25','11:45:00',8.41),('10318','2014-02-25','11:50:00',8.35),('10318','2014-02-25','11:55:00',8.38),('10318','2014-02-25','12:00:00',8.35),('10318','2014-02-25','12:05:00',8.26),('10318','2014-02-25','12:10:00',8.37),('10318','2014-02-25','12:15:00',8.36),('10318','2014-02-25','12:20:00',8.28),('10318','2014-02-25','12:25:00',8.2),('10318','2014-02-25','12:30:00',8.16),('10318','2014-02-25','12:35:00',8.09),('10318','2014-02-25','12:40:00',8.13),('10318','2014-02-25','12:45:00',8.06),('10318','2014-02-25','12:50:00',7.89),('10318','2014-02-25','12:55:00',7.78),('10318','2014-02-25','13:00:00',7.78),('10318','2014-02-25','13:05:00',7.68),('10318','2014-02-25','13:10:00',7.51),('10318','2014-02-25','13:15:00',6.92),('10318','2014-02-25','13:20:00',6.05),('10318','2014-02-25','13:25:00',3.87),('10318','2014-02-25','13:30:00',2.18),('10318','2014-02-25','13:35:00',2.77),('10318','2014-02-25','13:40:00',2.82),('10318','2014-02-25','13:45:00',3.14),('10318','2014-02-25','13:50:00',2.9),('10318','2014-02-25','13:55:00',4.83),('10318','2014-02-25','14:00:00',5.06),('10318','2014-02-25','14:05:00',7.56),('10318','2014-02-25','14:10:00',7.41),('10318','2014-02-25','14:15:00',6.39),('10318','2014-02-25','14:20:00',6.49),('10318','2014-02-25','14:25:00',6.45),('10318','2014-02-25','14:30:00',6.3),('10318','2014-02-25','14:35:00',6.2),('10318','2014-02-25','14:40:00',6.16),('10318','2014-02-25','14:45:00',5.87),('10318','2014-02-25','14:50:00',5.51),('10318','2014-02-25','14:55:00',5.54),('10318','2014-02-25','15:00:00',5.22),('10318','2014-02-25','15:05:00',5.08),('10318','2014-02-25','15:10:00',4.84),('10318','2014-02-25','15:15:00',4.74),('10318','2014-02-25','15:20:00',4.33),('10318','2014-02-25','15:25:00',3.99),('10318','2014-02-25','15:30:00',3.58),('10318','2014-02-25','15:35:00',3.4),('10318','2014-02-25','15:40:00',2.86),('10318','2014-02-25','15:45:00',1.58),('10318','2014-02-25','15:50:00',2.05),('10318','2014-02-25','15:55:00',2.37),('10318','2014-02-25','16:00:00',1.95),('10318','2014-02-25','16:05:00',2.18),('10318','2014-02-25','16:10:00',2.16),('10318','2014-02-25','16:15:00',2.34),('10318','2014-02-25','16:20:00',2.12),('10318','2014-02-25','16:25:00',1.61),('10318','2014-02-25','16:30:00',1.07),('10318','2014-02-24','07:30:00',1.16),('10318','2014-02-24','07:35:00',1.33),('10318','2014-02-24','07:40:00',1.42),('10318','2014-02-24','07:45:00',1.61),('10318','2014-02-24','07:50:00',1.8),('10318','2014-02-24','07:55:00',2.13),('10318','2014-02-24','08:00:00',3.56),('10318','2014-02-24','08:05:00',4.24),('10318','2014-02-24','08:10:00',4.64),('10318','2014-02-24','08:15:00',4.88),('10318','2014-02-24','08:20:00',5.03),('10318','2014-02-24','08:25:00',4.14),('10318','2014-02-24','08:30:00',3.6),('10318','2014-02-24','08:35:00',3.57),('10318','2014-02-24','08:40:00',3.02),('10318','2014-02-24','08:45:00',3.26),('10318','2014-02-24','08:50:00',5.57),('10318','2014-02-24','08:55:00',6.02),('10318','2014-02-24','09:00:00',6),('10318','2014-02-24','09:05:00',6.05),('10318','2014-02-24','09:10:00',6.21),('10318','2014-02-24','09:15:00',4.69),('10318','2014-02-24','09:20:00',4.99),('10318','2014-02-24','09:25:00',6.6),('10318','2014-02-24','09:30:00',6.75),('10318','2014-02-24','09:35:00',6.87),('10318','2014-02-24','09:40:00',7),('10318','2014-02-24','09:45:00',7.15),('10318','2014-02-24','09:50:00',7.26),('10318','2014-02-24','09:55:00',7.37),('10318','2014-02-24','10:00:00',5.5),('10318','2014-02-24','10:05:00',7.59),('10318','2014-02-24','10:10:00',7.72),('10318','2014-02-24','10:15:00',7.84),('10318','2014-02-24','10:20:00',7.95),('10318','2014-02-24','10:25:00',6),('10318','2014-02-24','10:30:00',8.07),('10318','2014-02-24','10:35:00',8.17),('10318','2014-02-24','10:40:00',8.22),('10318','2014-02-24','10:45:00',8.24),('10318','2014-02-24','10:50:00',8.32),('10318','2014-02-24','10:55:00',8.31),('10318','2014-02-24','11:00:00',8.31),('10318','2014-02-24','11:05:00',8.42),('10318','2014-02-24','11:10:00',8.47),('10318','2014-02-24','11:15:00',8.55),('10318','2014-02-24','11:20:00',8.64),('10318','2014-02-24','11:25:00',8.85),('10318','2014-02-24','11:30:00',9.39),('10318','2014-02-24','11:35:00',9.04),('10318','2014-02-24','11:40:00',7.88),('10318','2014-02-24','11:45:00',4.94),('10318','2014-02-24','11:50:00',5.85),('10318','2014-02-24','11:55:00',8.69),('10318','2014-02-24','12:00:00',8.79),('10318','2014-02-24','12:05:00',8.7),('10318','2014-02-24','12:10:00',8.61),('10318','2014-02-24','12:15:00',8.56),('10318','2014-02-24','12:20:00',8.49),('10318','2014-02-24','12:25:00',8.67),('10318','2014-02-24','12:30:00',8.7),('10318','2014-02-24','12:35:00',8.66),('10318','2014-02-24','12:40:00',8.64),('10318','2014-02-24','12:45:00',8.69),('10318','2014-02-24','12:50:00',8.08),('10318','2014-02-24','12:55:00',8.74),('10318','2014-02-24','13:00:00',9.2),('10318','2014-02-24','13:05:00',8.79),('10318','2014-02-24','13:10:00',6.73),('10318','2014-02-24','13:15:00',1.92),('10318','2014-02-24','13:20:00',1.75),('10318','2014-02-24','13:25:00',1.74),('10318','2014-02-24','13:30:00',1.69),('10318','2014-02-24','13:35:00',1.58),('10318','2014-02-24','13:40:00',1.58),('10318','2014-02-24','13:45:00',1.61),('10318','2014-02-24','13:50:00',1.73),('10318','2014-02-24','13:55:00',1.97),('10318','2014-02-24','14:00:00',2.23),('10318','2014-02-24','14:05:00',2.48),('10318','2014-02-24','14:10:00',2.78),('10318','2014-02-24','14:15:00',2.55),('10318','2014-02-24','14:20:00',2.4),('10318','2014-02-24','14:25:00',2.22),('10318','2014-02-24','14:30:00',2.3),('10318','2014-02-24','14:35:00',2.18),('10318','2014-02-24','14:40:00',2.12),('10318','2014-02-24','14:45:00',2.23),('10318','2014-02-24','14:50:00',2.26),('10318','2014-02-24','14:55:00',2.12),('10318','2014-02-24','15:00:00',2.04),('10318','2014-02-24','15:05:00',1.97),('10318','2014-02-24','15:10:00',2.15),('10318','2014-02-24','15:15:00',2.73),('10318','2014-02-24','15:20:00',3.96),('10318','2014-02-24','15:25:00',5.9),('10318','2014-02-24','15:30:00',5.11),('10318','2014-02-24','15:35:00',4.79),('10318','2014-02-24','15:40:00',4.6),('10318','2014-02-24','15:45:00',4.19),('10318','2014-02-24','15:50:00',4.25),('10318','2014-02-24','15:55:00',4.33),('10318','2014-02-24','16:00:00',4.39),('10318','2014-02-24','16:05:00',4.18),('10318','2014-02-24','16:10:00',3.84),('10318','2014-02-24','16:15:00',3.41),('10318','2014-02-24','16:20:00',2.75),('10318','2014-02-24','16:40:00',1.7),('10318','2014-02-24','16:45:00',1.57),('10318','2014-02-24','16:50:00',1.33),('10318','2014-02-24','16:55:00',1.12),('10318','2014-02-23','07:35:00',1.11),('10318','2014-02-23','07:40:00',1.42),('10318','2014-02-23','07:45:00',1.72),('10318','2014-02-23','07:50:00',2.2),('10318','2014-02-23','07:55:00',2.5),('10318','2014-02-23','08:00:00',2.97),('10318','2014-02-23','08:05:00',3.44),('10318','2014-02-23','08:10:00',3.67),('10318','2014-02-23','08:15:00',3.89),('10318','2014-02-23','08:20:00',4.11),('10318','2014-02-23','08:25:00',4.32),('10318','2014-02-23','08:30:00',4.51),('10318','2014-02-23','08:35:00',4.76),('10318','2014-02-23','08:40:00',4.97),('10318','2014-02-23','08:45:00',5.19),('10318','2014-02-23','08:50:00',5.39),('10318','2014-02-23','08:55:00',5.59),('10318','2014-02-23','09:00:00',5.75),('10318','2014-02-23','09:05:00',5.96),('10318','2014-02-23','09:10:00',6.15),('10318','2014-02-23','09:15:00',6.35),('10318','2014-02-23','09:20:00',6.48),('10318','2014-02-23','09:25:00',6.26),('10318','2014-02-23','09:30:00',5.97),('10318','2014-02-23','09:35:00',6.82),('10318','2014-02-23','09:40:00',6.93),('10318','2014-02-23','09:45:00',6.99),('10318','2014-02-23','09:50:00',7.1),('10318','2014-02-23','09:55:00',7.21),('10318','2014-02-23','10:00:00',7.29),('10318','2014-02-23','10:05:00',7.35),('10318','2014-02-23','10:10:00',7.47),('10318','2014-02-23','10:15:00',7.47),('10318','2014-02-23','10:20:00',7.66),('10318','2014-02-23','10:25:00',7.79),('10318','2014-02-23','10:30:00',7.9),('10318','2014-02-23','10:35:00',7.91),('10318','2014-02-23','10:40:00',8.03),('10318','2014-02-23','10:45:00',8.13),('10318','2014-02-23','10:50:00',8.11),('10318','2014-02-23','10:55:00',8.01),('10318','2014-02-23','11:00:00',8.3),('10318','2014-02-23','11:05:00',8.42),('10318','2014-02-23','11:10:00',8.58),('10318','2014-02-23','11:15:00',8.56),('10318','2014-02-23','11:20:00',8.58),('10318','2014-02-23','11:25:00',8.5),('10318','2014-02-23','11:30:00',8.63),('10318','2014-02-23','11:35:00',8.69),('10318','2014-02-23','11:40:00',8.83),('10318','2014-02-23','11:45:00',8.93),('10318','2014-02-23','11:50:00',7.81),('10318','2014-02-23','11:55:00',5.94),('10318','2014-02-23','12:00:00',7.91),('10318','2014-02-23','12:05:00',8.95),('10318','2014-02-23','12:10:00',9.19),('10318','2014-02-23','12:15:00',9.14),('10318','2014-02-23','12:20:00',6.8),('10318','2014-02-23','12:25:00',4.43),('10318','2014-02-23','12:30:00',8.78),('10318','2014-02-23','12:35:00',5.96),('10318','2014-02-23','12:40:00',5.8),('10318','2014-02-23','12:45:00',4.45),('10318','2014-02-23','12:50:00',4.92),('10318','2014-02-23','12:55:00',5.44),('10318','2014-02-23','13:00:00',8.18),('10318','2014-02-23','13:05:00',8.37),('10318','2014-02-23','13:10:00',8.22),('10318','2014-02-23','13:15:00',8.27),('10318','2014-02-23','13:20:00',8.32),('10318','2014-02-23','13:25:00',8.07),('10318','2014-02-23','13:30:00',7.77),('10318','2014-02-23','13:35:00',7.2),('10318','2014-02-23','13:40:00',6.42),('10318','2014-02-23','13:45:00',4.05),('10318','2014-02-23','13:50:00',4.47),('10318','2014-02-23','13:55:00',3.22),('10318','2014-02-23','14:00:00',3.47),('10318','2014-02-23','14:05:00',5.26),('10318','2014-02-23','14:10:00',2.8),('10318','2014-02-23','14:15:00',3.31),('10318','2014-02-23','14:20:00',7.17),('10318','2014-02-23','14:25:00',7.61),('10318','2014-02-23','14:30:00',7.63),('10318','2014-02-23','14:35:00',6.7),('10318','2014-02-23','14:40:00',6.93),('10318','2014-02-23','14:45:00',6.79),('10318','2014-02-23','14:50:00',6.25),('10318','2014-02-23','14:55:00',3.62),('10318','2014-02-23','15:00:00',1.65),('10318','2014-02-23','15:05:00',2.09),('10318','2014-02-23','15:10:00',1.56),('10318','2014-02-23','15:15:00',1.62),('10318','2014-02-23','15:20:00',4.62),('10318','2014-02-23','15:25:00',3.68),('10318','2014-02-23','15:30:00',1.69),('10318','2014-02-23','15:35:00',1.35),('10318','2014-02-23','15:40:00',1.02),('10318','2014-02-22','08:50:00',1.1),('10318','2014-02-22','09:00:00',1.48),('10318','2014-02-22','09:05:00',2.19),('10318','2014-02-22','09:10:00',1.95),('10318','2014-02-22','09:15:00',1.51),('10318','2014-02-22','09:20:00',2.74),('10318','2014-02-22','09:25:00',1.81),('10318','2014-02-22','09:30:00',1.84),('10318','2014-02-22','09:35:00',1.94),('10318','2014-02-22','09:40:00',2.69),('10318','2014-02-22','09:45:00',5.29),('10318','2014-02-22','09:50:00',2.38),('10318','2014-02-22','09:55:00',2.5),('10318','2014-02-22','10:00:00',3.23),('10318','2014-02-22','10:05:00',3.98),('10318','2014-02-22','10:10:00',6.06),('10318','2014-02-22','10:15:00',3),('10318','2014-02-22','10:20:00',3.55),('10318','2014-02-22','10:25:00',3.67),('10318','2014-02-22','10:30:00',4.28),('10318','2014-02-22','10:35:00',3.55),('10318','2014-02-22','10:40:00',7.14),('10318','2014-02-22','10:45:00',8.39),('10318','2014-02-22','10:50:00',3.94),('10318','2014-02-22','10:55:00',2.57),('10318','2014-02-22','11:00:00',1.16),('10318','2014-02-22','11:05:00',2.01),('10318','2014-02-22','11:10:00',2.36),('10318','2014-02-22','11:15:00',1.14),('10318','2014-02-22','11:35:00',1.01),('10318','2014-02-22','11:40:00',1.41),('10318','2014-02-22','11:45:00',1.28),('10318','2014-02-22','11:50:00',1.53),('10318','2014-02-22','11:55:00',1.75),('10318','2014-02-22','12:00:00',2.37),('10318','2014-02-22','12:05:00',3.21),('10318','2014-02-22','12:10:00',4.18),('10318','2014-02-22','12:15:00',3.48),('10318','2014-02-22','12:20:00',5.15),('10318','2014-02-22','12:25:00',2.81),('10318','2014-02-22','12:30:00',2.56),('10318','2014-02-22','12:35:00',3.33),('10318','2014-02-22','12:40:00',6.64),('10318','2014-02-22','12:45:00',9.58),('10318','2014-02-22','12:50:00',7.97),('10318','2014-02-22','12:55:00',4.68),('10318','2014-02-22','13:00:00',3.52),('10318','2014-02-22','13:05:00',8.13),('10318','2014-02-22','13:10:00',8.19),('10318','2014-02-22','13:15:00',3.39),('10318','2014-02-22','13:20:00',2.99),('10318','2014-02-22','13:25:00',7.55),('10318','2014-02-22','13:30:00',4.5),('10318','2014-02-22','13:35:00',6.91),('10318','2014-02-22','13:40:00',7.01),('10318','2014-02-22','13:45:00',7.61),('10318','2014-02-22','13:50:00',7.84),('10318','2014-02-22','13:55:00',6.1),('10318','2014-02-22','14:00:00',7.6),('10318','2014-02-22','14:05:00',7.73),('10318','2014-02-22','14:10:00',7.65),('10318','2014-02-22','14:15:00',6.73),('10318','2014-02-22','14:20:00',6.6),('10318','2014-02-22','14:25:00',7.05),('10318','2014-02-22','14:30:00',7.15),('10318','2014-02-22','14:35:00',6.47),('10318','2014-02-22','14:40:00',4.05),('10318','2014-02-22','14:45:00',3.24),('10318','2014-02-22','14:50:00',2.76),('10318','2014-02-22','14:55:00',2.88),('10318','2014-02-22','15:00:00',3.32),('10318','2014-02-22','15:05:00',5.22),('10318','2014-02-22','15:10:00',3.04),('10318','2014-02-22','15:15:00',2.04),('10318','2014-02-22','15:20:00',3.34),('10318','2014-02-22','15:25:00',2.54),('10318','2014-02-22','15:30:00',3.61),('10318','2014-02-22','15:35:00',1.76),('10318','2014-02-22','15:40:00',1.94),('10318','2014-02-22','15:45:00',2.36),('10318','2014-02-22','15:50:00',1.5),('10318','2014-02-22','15:55:00',3.57),('10318','2014-02-22','16:00:00',3.26),('10318','2014-02-22','16:05:00',2.57),('10318','2014-02-22','16:10:00',2.87),('10318','2014-02-22','16:15:00',2.67),('10318','2014-02-22','16:20:00',2.54),('10318','2014-02-22','16:25:00',2.3),('10318','2014-02-22','16:30:00',2.06),('10318','2014-02-22','16:35:00',1.73),('10318','2014-02-22','16:40:00',1.76),('10318','2014-02-22','16:45:00',1.54),('10318','2014-02-22','16:50:00',1.35),('10318','2014-02-22','16:55:00',1.02),('10318','2014-02-22','17:00:00',1),('10318','2014-02-21','08:15:00',1),('10318','2014-02-21','08:20:00',1.12),('10318','2014-02-21','08:25:00',1.22),('10318','2014-02-21','08:30:00',1.33),('10318','2014-02-21','08:35:00',1.45),('10318','2014-02-21','08:40:00',1.59),('10318','2014-02-21','08:45:00',1.68),('10318','2014-02-21','08:50:00',1.8),('10318','2014-02-21','08:55:00',1.88),('10318','2014-02-21','09:00:00',1.91),('10318','2014-02-21','09:05:00',1.81),('10318','2014-02-21','09:10:00',1.88),('10318','2014-02-21','09:15:00',2.29),('10318','2014-02-21','09:20:00',2.68),('10318','2014-02-21','09:25:00',2.28),('10318','2014-02-21','09:30:00',2.1),('10318','2014-02-21','09:35:00',2.2),('10318','2014-02-21','09:40:00',2.34),('10318','2014-02-21','09:45:00',2.65),('10318','2014-02-21','09:50:00',2.74),('10318','2014-02-21','09:55:00',2.74),('10318','2014-02-21','10:00:00',3.01),('10318','2014-02-21','10:05:00',3.18),('10318','2014-02-21','10:10:00',3.21),('10318','2014-02-21','10:15:00',4.27),('10318','2014-02-21','10:20:00',5.07),('10318','2014-02-21','10:25:00',5.86),('10318','2014-02-21','10:30:00',5.29),('10318','2014-02-21','10:35:00',3.96),('10318','2014-02-21','10:40:00',3.85),('10318','2014-02-21','10:45:00',3.78),('10318','2014-02-21','10:50:00',5.59),('10318','2014-02-21','10:55:00',6.84),('10318','2014-02-21','11:00:00',5.91),('10318','2014-02-21','11:05:00',4.45),('10318','2014-02-21','11:10:00',4.56),('10318','2014-02-21','11:15:00',4.21),('10318','2014-02-21','11:20:00',3.75),('10318','2014-02-21','11:25:00',3.62),('10318','2014-02-21','11:30:00',3.23),('10318','2014-02-21','11:35:00',3.4),('10318','2014-02-21','11:40:00',4.1),('10318','2014-02-21','11:45:00',3.68),('10318','2014-02-21','11:50:00',3.64),('10318','2014-02-21','11:55:00',3.82),('10318','2014-02-21','12:00:00',4.09),('10318','2014-02-21','12:05:00',7.97),('10318','2014-02-21','12:10:00',9.12),('10318','2014-02-21','12:15:00',6.54),('10318','2014-02-21','12:20:00',3.85),('10318','2014-02-21','12:25:00',2.34),('10318','2014-02-21','12:30:00',2.33),('10318','2014-02-21','12:35:00',2.63),('10318','2014-02-21','12:40:00',2.09),('10318','2014-02-21','12:45:00',1.29),('10318','2014-02-21','12:50:00',1.17),('10318','2014-02-21','12:55:00',1.06),('10318','2014-02-21','13:30:00',1.29),('10318','2014-02-21','13:35:00',1.6),('10318','2014-02-21','13:40:00',1.75),('10318','2014-02-21','13:45:00',2.08),('10318','2014-02-21','13:50:00',2.1),('10318','2014-02-21','13:55:00',1.86),('10318','2014-02-21','14:00:00',1.57),('10318','2014-02-21','14:05:00',1.61),('10318','2014-02-21','14:10:00',1.59),('10318','2014-02-21','14:15:00',1.61),('10318','2014-02-21','14:20:00',1.72),('10318','2014-02-21','14:25:00',1.74),('10318','2014-02-21','14:30:00',1.88),('10318','2014-02-21','14:35:00',2.13),('10318','2014-02-21','14:40:00',2.34),('10318','2014-02-21','14:45:00',2.36),('10318','2014-02-21','14:50:00',2.31),('10318','2014-02-21','14:55:00',2.34),('10318','2014-02-21','15:00:00',2.25),('10318','2014-02-21','15:05:00',2.01),('10318','2014-02-21','15:10:00',1.66),('10318','2014-02-21','15:15:00',1.51),('10318','2014-02-21','15:20:00',1.7),('10318','2014-02-21','15:25:00',1.63),('10318','2014-02-21','15:30:00',1.52),('10318','2014-02-21','15:35:00',2.66),('10318','2014-02-21','15:40:00',3.69),('10318','2014-02-21','15:45:00',3.48),('10318','2014-02-21','15:50:00',3.29),('10318','2014-02-21','15:55:00',3.09),('10318','2014-02-21','16:00:00',2.97),('10318','2014-02-21','16:05:00',2.75),('10318','2014-02-21','16:10:00',2.59),('10318','2014-02-21','16:15:00',2.44),('10318','2014-02-21','16:20:00',2.28),('10318','2014-02-21','16:25:00',2.11),('10318','2014-02-21','16:30:00',1.93),('10318','2014-02-21','16:35:00',1.72),('10318','2014-02-21','16:40:00',1.52),('10318','2014-02-21','16:45:00',1.33),('10318','2014-02-21','16:50:00',1.17),('10318','2014-02-20','08:15:00',1.09),('10318','2014-02-20','08:20:00',1.19),('10318','2014-02-20','09:30:00',1.1),('10318','2014-02-20','09:35:00',1.39),('10318','2014-02-20','09:40:00',1.56),('10318','2014-02-20','09:45:00',1.38),('10318','2014-02-20','09:50:00',1.15),('10318','2014-02-20','10:00:00',1.01),('10318','2014-02-20','10:05:00',1.09),('10318','2014-02-20','10:10:00',1.34),('10318','2014-02-20','10:15:00',1.12),('10318','2014-02-20','10:20:00',1.46),('10318','2014-02-20','10:25:00',1.71),('10318','2014-02-20','10:30:00',1.78),('10318','2014-02-20','10:35:00',1.79),('10318','2014-02-20','10:40:00',1.82),('10318','2014-02-20','10:45:00',1.77),('10318','2014-02-20','10:50:00',1.71),('10318','2014-02-20','10:55:00',1.98),('10318','2014-02-20','11:00:00',1.19),('10318','2014-02-20','11:15:00',1.56),('10318','2014-02-20','11:20:00',2.73),('10318','2014-02-20','11:25:00',2.76),('10318','2014-02-20','11:30:00',2.81),('10318','2014-02-20','11:35:00',2.24),('10318','2014-02-20','11:40:00',1.44),('10318','2014-02-20','11:45:00',1.53),('10318','2014-02-20','11:50:00',1.43),('10318','2014-02-20','11:55:00',1.65),('10318','2014-02-20','12:00:00',1.78),('10318','2014-02-20','12:05:00',1.61),('10318','2014-02-20','12:10:00',1.76),('10318','2014-02-20','12:15:00',2.17),('10318','2014-02-20','12:20:00',2.76),('10318','2014-02-20','12:25:00',2.68),('10318','2014-02-20','12:30:00',2.28),('10318','2014-02-20','12:35:00',2.46),('10318','2014-02-20','12:40:00',3),('10318','2014-02-20','12:45:00',3.17),('10318','2014-02-20','12:50:00',3),('10318','2014-02-20','12:55:00',2.85),('10318','2014-02-20','13:00:00',2.87),('10318','2014-02-20','13:05:00',1.99),('10318','2014-02-20','13:10:00',1.78),('10318','2014-02-20','13:15:00',2.42),('10318','2014-02-20','13:20:00',1.91),('10318','2014-02-20','13:25:00',2.23),('10318','2014-02-20','13:30:00',2.86),('10318','2014-02-20','13:35:00',2.42),('10318','2014-02-20','13:40:00',2.04),('10318','2014-02-20','13:45:00',2.09),('10318','2014-02-20','13:50:00',2.24),('10318','2014-02-20','13:55:00',2.11),('10318','2014-02-20','14:00:00',2.66),('10318','2014-02-20','14:05:00',1.93),('10318','2014-02-20','14:10:00',1.42),('10318','2014-02-20','14:15:00',1.59),('10318','2014-02-20','14:20:00',1.01),('10318','2014-02-19','08:30:00',1.11),('10318','2014-02-19','08:35:00',1.43),('10318','2014-02-19','08:40:00',1.57),('10318','2014-02-19','08:45:00',1.74),('10318','2014-02-19','08:50:00',1.6),('10318','2014-02-19','08:55:00',1.57),('10318','2014-02-19','09:00:00',1.65),('10318','2014-02-19','09:05:00',1.69),('10318','2014-02-19','09:10:00',1.67),('10318','2014-02-19','09:15:00',1.86),('10318','2014-02-19','09:20:00',2.04),('10318','2014-02-19','09:25:00',2.36),('10318','2014-02-19','09:30:00',2.4),('10318','2014-02-19','09:35:00',2.82),('10318','2014-02-19','09:40:00',3.09),('10318','2014-02-19','09:45:00',3.72),('10318','2014-02-19','09:50:00',3.37),('10318','2014-02-19','09:55:00',3.07),('10318','2014-02-19','10:00:00',3.03),('10318','2014-02-19','10:05:00',3.02),('10318','2014-02-19','10:10:00',3.42),('10318','2014-02-19','10:15:00',3.55),('10318','2014-02-19','10:20:00',3.16),('10318','2014-02-19','10:25:00',3.3),('10318','2014-02-19','10:30:00',3.25),('10318','2014-02-19','10:35:00',3.49),('10318','2014-02-19','10:40:00',4.08),('10318','2014-02-19','10:45:00',4.26),('10318','2014-02-19','10:50:00',4.41),('10318','2014-02-19','10:55:00',3.92),('10318','2014-02-19','11:00:00',3.3),('10318','2014-02-19','11:05:00',3.05),('10318','2014-02-19','11:10:00',3),('10318','2014-02-19','11:15:00',3.23),('10318','2014-02-19','11:20:00',3.61),('10318','2014-02-19','11:25:00',3.17),('10318','2014-02-19','11:30:00',3.07),('10318','2014-02-19','11:35:00',3.19),('10318','2014-02-19','11:40:00',2.97),('10318','2014-02-19','11:45:00',3.04),('10318','2014-02-19','11:50:00',3.66),('10318','2014-02-19','11:55:00',3.72),('10318','2014-02-19','12:00:00',3.63),('10318','2014-02-19','12:05:00',3.85),('10318','2014-02-19','12:10:00',3.56),('10318','2014-02-19','12:15:00',2.64),('10318','2014-02-19','12:20:00',2.19),('10318','2014-02-19','12:25:00',2.37),('10318','2014-02-19','12:30:00',2.99),('10318','2014-02-19','12:35:00',2.67),('10318','2014-02-19','12:40:00',2.86),('10318','2014-02-19','12:45:00',2.68),('10318','2014-02-19','12:50:00',2.38),('10318','2014-02-19','12:55:00',2.09),('10318','2014-02-19','13:00:00',2.28),('10318','2014-02-19','13:05:00',2.58),('10318','2014-02-19','13:10:00',2.34),('10318','2014-02-19','13:15:00',2.66),('10318','2014-02-19','13:20:00',2.82),('10318','2014-02-19','13:25:00',3.79),('10318','2014-02-19','13:30:00',3.78),('10318','2014-02-19','13:35:00',4.19),('10318','2014-02-19','13:40:00',4.14),('10318','2014-02-19','13:45:00',5.14),('10318','2014-02-19','13:50:00',4.61),('10318','2014-02-19','13:55:00',4.61),('10318','2014-02-19','14:00:00',4.29),('10318','2014-02-19','14:05:00',3.72),('10318','2014-02-19','14:10:00',2.81),('10318','2014-02-19','14:15:00',2.89),('10318','2014-02-19','14:20:00',4.33),('10318','2014-02-19','14:25:00',2.98),('10318','2014-02-19','14:30:00',3.42),('10318','2014-02-19','14:35:00',3.54),('10318','2014-02-19','14:40:00',2.74),('10318','2014-02-19','14:45:00',2.54),('10318','2014-02-19','14:50:00',3.84),('10318','2014-02-19','14:55:00',2.74),('10318','2014-02-19','15:00:00',2.47),('10318','2014-02-19','15:05:00',2.46),('10318','2014-02-19','15:10:00',2.43),('10318','2014-02-19','15:15:00',2.85),('10318','2014-02-19','15:20:00',2.21),('10318','2014-02-19','15:25:00',2.72),('10318','2014-02-19','15:30:00',2.13),('10318','2014-02-19','15:35:00',1.9),('10318','2014-02-19','15:40:00',2.04),('10318','2014-02-19','15:45:00',2.26),('10318','2014-02-19','15:50:00',2.53),('10318','2014-02-19','15:55:00',2.06),('10318','2014-02-19','16:00:00',1.88),('10318','2014-02-19','16:05:00',1.73),('10318','2014-02-19','16:10:00',1.59),('10318','2014-02-19','16:15:00',1.51),('10318','2014-02-19','16:20:00',1.17),('10318','2014-02-18','07:40:00',1.18),('10318','2014-02-18','07:45:00',1.39),('10318','2014-02-18','07:50:00',1.6),('10318','2014-02-18','07:55:00',1.82),('10318','2014-02-18','08:00:00',1.98),('10318','2014-02-18','08:05:00',2.87),('10318','2014-02-18','08:10:00',3.44),('10318','2014-02-18','08:15:00',3.66),('10318','2014-02-18','08:20:00',3.87),('10318','2014-02-18','08:25:00',4.09),('10318','2014-02-18','08:30:00',4.29),('10318','2014-02-18','08:35:00',4.46),('10318','2014-02-18','08:40:00',4.66),('10318','2014-02-18','08:45:00',4.84),('10318','2014-02-18','08:50:00',5.01),('10318','2014-02-18','08:55:00',5.18),('10318','2014-02-18','09:00:00',5.34),('10318','2014-02-18','09:05:00',5.48),('10318','2014-02-18','09:10:00',5.66),('10318','2014-02-18','09:15:00',5.83),('10318','2014-02-18','09:20:00',5.83),('10318','2014-02-18','09:25:00',6.11),('10318','2014-02-18','09:30:00',6.27),('10318','2014-02-18','09:35:00',6.4),('10318','2014-02-18','09:40:00',6.52),('10318','2014-02-18','09:45:00',6.66),('10318','2014-02-18','09:50:00',6.78),('10318','2014-02-18','09:55:00',6.89),('10318','2014-02-18','10:00:00',6.98),('10318','2014-02-18','10:05:00',7.04),('10318','2014-02-18','10:10:00',7.09),('10318','2014-02-18','10:15:00',7.19),('10318','2014-02-18','10:20:00',7.33),('10318','2014-02-18','10:25:00',7.37),('10318','2014-02-18','10:30:00',7.39),('10318','2014-02-18','10:35:00',7.4),('10318','2014-02-18','10:40:00',7.56),('10318','2014-02-18','10:45:00',7.64),('10318','2014-02-18','10:50:00',7.73),('10318','2014-02-18','10:55:00',7.81),('10318','2014-02-18','11:00:00',7.92),('10318','2014-02-18','11:05:00',6.9),('10318','2014-02-18','11:10:00',6.83),('10318','2014-02-18','11:15:00',6.76),('10318','2014-02-18','11:20:00',7.27),('10318','2014-02-18','11:25:00',8.09),('10318','2014-02-18','11:30:00',8.06),('10318','2014-02-18','11:35:00',7.38),('10318','2014-02-18','11:40:00',4.53),('10318','2014-02-18','11:45:00',4.11),('10318','2014-02-18','11:50:00',3.93),('10318','2014-02-18','11:55:00',3.55),('10318','2014-02-18','12:00:00',3.46),('10318','2014-02-18','12:05:00',3.39),('10318','2014-02-18','12:10:00',3.84),('10318','2014-02-18','12:15:00',4.13),('10318','2014-02-18','12:20:00',4.17),('10318','2014-02-18','12:25:00',4.88),('10318','2014-02-18','12:30:00',4.78),('10318','2014-02-18','12:35:00',4.22),('10318','2014-02-18','12:40:00',3.51),('10318','2014-02-18','12:45:00',3.34),('10318','2014-02-18','12:50:00',3.55),('10318','2014-02-18','12:55:00',3.86),('10318','2014-02-18','13:00:00',3.13),('10318','2014-02-18','13:05:00',2.98),('10318','2014-02-18','13:10:00',3.1),('10318','2014-02-18','13:15:00',4.32),('10318','2014-02-18','13:20:00',4.74),('10318','2014-02-18','13:25:00',6.3),('10318','2014-02-18','13:30:00',4.38),('10318','2014-02-18','13:35:00',3.91),('10318','2014-02-18','13:40:00',4.65),('10318','2014-02-18','13:45:00',4.81),('10318','2014-02-18','13:50:00',3.99),('10318','2014-02-18','13:55:00',3.82),('10318','2014-02-18','14:00:00',4.11),('10318','2014-02-18','14:05:00',5.31),('10318','2014-02-18','14:10:00',3.7),('10318','2014-02-18','14:15:00',2.99),('10318','2014-02-18','14:20:00',2.58),('10318','2014-02-18','14:25:00',2.58),('10318','2014-02-18','14:30:00',3.11),('10318','2014-02-18','14:35:00',3.01),('10318','2014-02-18','14:40:00',2.6),('10318','2014-02-18','14:45:00',2.31),('10318','2014-02-18','14:50:00',2.21),('10318','2014-02-18','14:55:00',2.13),('10318','2014-02-18','15:00:00',1.98),('10318','2014-02-18','15:05:00',1.88),('10318','2014-02-18','15:10:00',1.86),('10318','2014-02-18','15:15:00',1.49),('10318','2014-02-18','15:20:00',1.59),('10318','2014-02-18','15:25:00',1.7),('10318','2014-02-18','15:30:00',1.43),('10318','2014-02-18','15:35:00',2.21),('10318','2014-02-18','15:40:00',2.79),('10318','2014-02-18','15:45:00',2.65),('10318','2014-02-18','15:50:00',2.26),('10318','2014-02-18','15:55:00',2.03),('10318','2014-02-18','16:00:00',2.15),('10318','2014-02-18','16:05:00',2.32),('10318','2014-02-18','16:10:00',1.91),('10318','2014-02-18','16:15:00',1.59),('10318','2014-02-18','16:20:00',1.2),('10318','2014-02-18','16:30:00',1.2),('10318','2014-02-18','16:35:00',1.36),('10318','2014-02-18','16:40:00',1.12),('10318','2014-02-18','16:45:00',1),('10318','2014-02-18','16:50:00',1.09),('10318','2014-02-17','07:40:00',1.12),('10318','2014-02-17','07:45:00',1.3),('10318','2014-02-17','07:50:00',1.49),('10318','2014-02-17','07:55:00',1.68),('10318','2014-02-17','08:00:00',1.87),('10318','2014-02-17','08:05:00',2.14),('10318','2014-02-17','08:10:00',2.78),('10318','2014-02-17','08:15:00',3.02),('10318','2014-02-17','08:20:00',3.24),('10318','2014-02-17','08:25:00',3.48),('10318','2014-02-17','08:30:00',3.65),('10318','2014-02-17','08:35:00',3.84),('10318','2014-02-17','08:40:00',4.04),('10318','2014-02-17','08:45:00',4.22),('10318','2014-02-17','08:50:00',4.33),('10318','2014-02-17','08:55:00',4.5),('10318','2014-02-17','09:00:00',4.64),('10318','2014-02-17','09:05:00',4.92),('10318','2014-02-17','09:10:00',5.12),('10318','2014-02-17','09:15:00',5.28),('10318','2014-02-17','09:20:00',5.44),('10318','2014-02-17','09:25:00',5.63),('10318','2014-02-17','09:30:00',5.8),('10318','2014-02-17','09:35:00',5.93),('10318','2014-02-17','09:40:00',6.04),('10318','2014-02-17','09:45:00',6.12),('10318','2014-02-17','09:50:00',6.22),('10318','2014-02-17','09:55:00',6.34),('10318','2014-02-17','10:00:00',6.45),('10318','2014-02-17','10:05:00',6.54),('10318','2014-02-17','10:10:00',6.61),('10318','2014-02-17','10:15:00',6.67),('10318','2014-02-17','10:20:00',6.73),('10318','2014-02-17','10:25:00',6.83),('10318','2014-02-17','10:30:00',6.9),('10318','2014-02-17','10:35:00',6.88),('10318','2014-02-17','10:40:00',6.86),('10318','2014-02-17','10:45:00',6.86),('10318','2014-02-17','10:50:00',6.96),('10318','2014-02-17','10:55:00',6.99),('10318','2014-02-17','11:00:00',7.02),('10318','2014-02-17','11:05:00',7.07),('10318','2014-02-17','11:10:00',6.99),('10318','2014-02-17','11:15:00',7.15),('10318','2014-02-17','11:20:00',7.13),('10318','2014-02-17','11:25:00',7.27),('10318','2014-02-17','11:30:00',7.43),('10318','2014-02-17','11:35:00',7.6),('10318','2014-02-17','11:40:00',7.62),('10318','2014-02-17','11:45:00',7.66),('10318','2014-02-17','11:50:00',7.61),('10318','2014-02-17','11:55:00',7.59),('10318','2014-02-17','12:00:00',7.56),('10318','2014-02-17','12:05:00',7.59),('10318','2014-02-17','12:10:00',7.52),('10318','2014-02-17','12:15:00',7.51),('10318','2014-02-17','12:20:00',7.5),('10318','2014-02-17','12:25:00',7.47),('10318','2014-02-17','12:30:00',7.44),('10318','2014-02-17','12:35:00',7.36),('10318','2014-02-17','12:40:00',7.35),('10318','2014-02-17','12:45:00',7.34),('10318','2014-02-17','12:50:00',7.26),('10318','2014-02-17','12:55:00',6.94),('10318','2014-02-17','13:00:00',7.1),('10318','2014-02-17','13:05:00',7.02),('10318','2014-02-17','13:10:00',7.02),('10318','2014-02-17','13:15:00',6.97),('10318','2014-02-17','13:20:00',6.89),('10318','2014-02-17','13:25:00',6.82),('10318','2014-02-17','13:30:00',6.79),('10318','2014-02-17','13:35:00',6.65),('10318','2014-02-17','13:40:00',6.57),('10318','2014-02-17','13:45:00',6.35),('10318','2014-02-17','13:50:00',6.3),('10318','2014-02-17','13:55:00',6.19),('10318','2014-02-17','14:00:00',6.07),('10318','2014-02-17','14:05:00',5.98),('10318','2014-02-17','14:10:00',5.78),('10318','2014-02-17','14:15:00',5.61),('10318','2014-02-17','14:20:00',5.71),('10318','2014-02-17','14:25:00',5.52),('10318','2014-02-17','14:30:00',5.24),('10318','2014-02-17','14:35:00',5.1),('10318','2014-02-17','14:40:00',4.84),('10318','2014-02-17','14:45:00',5.03),('10318','2014-02-17','14:50:00',4.94),('10318','2014-02-17','14:55:00',4.66),('10318','2014-02-17','15:00:00',4.49),('10318','2014-02-17','15:05:00',4.26),('10318','2014-02-17','15:10:00',4.11),('10318','2014-02-17','15:15:00',4.14),('10318','2014-02-17','15:20:00',4),('10318','2014-02-17','15:25:00',3.78),('10318','2014-02-17','15:30:00',3.65),('10318','2014-02-17','15:35:00',3.46),('10318','2014-02-17','15:40:00',3.18),('10318','2014-02-17','15:45:00',3.17),('10318','2014-02-17','15:50:00',2.98),('10318','2014-02-17','15:55:00',2.77),('10318','2014-02-17','16:00:00',2.57),('10318','2014-02-17','16:05:00',2.47),('10318','2014-02-17','16:10:00',2.31),('10318','2014-02-17','16:15:00',2.1),('10318','2014-02-17','16:20:00',1.94),('10318','2014-02-17','16:25:00',1.78),('10318','2014-02-17','16:30:00',1.58),('10318','2014-02-17','16:35:00',1.41),('10318','2014-02-17','16:40:00',1.24),('10318','2014-02-17','16:45:00',1.05),('10318','2014-02-16','07:40:00',1.1),('10318','2014-02-16','07:45:00',1.3),('10318','2014-02-16','07:50:00',1.48),('10318','2014-02-16','07:55:00',1.69),('10318','2014-02-16','08:00:00',1.88),('10318','2014-02-16','08:05:00',2.18),('10318','2014-02-16','08:10:00',3.2),('10318','2014-02-16','08:15:00',3.56),('10318','2014-02-16','08:20:00',3.68),('10318','2014-02-16','08:25:00',4),('10318','2014-02-16','08:30:00',4.23),('10318','2014-02-16','08:35:00',4.45),('10318','2014-02-16','08:40:00',4.19),('10318','2014-02-16','08:45:00',4.68),('10318','2014-02-16','08:50:00',4.97),('10318','2014-02-16','08:55:00',5.24),('10318','2014-02-16','09:00:00',5.56),('10318','2014-02-16','09:05:00',5.65),('10318','2014-02-16','09:10:00',5.36),('10318','2014-02-16','09:15:00',5.03),('10318','2014-02-16','09:20:00',5.63),('10318','2014-02-16','09:25:00',5.86),('10318','2014-02-16','09:30:00',5.6),('10318','2014-02-16','09:35:00',5.24),('10318','2014-02-16','09:40:00',6.36),('10318','2014-02-16','09:45:00',6.46),('10318','2014-02-16','09:50:00',6.65),('10318','2014-02-16','09:55:00',6.34),('10318','2014-02-16','10:00:00',6.51),('10318','2014-02-16','10:05:00',7.09),('10318','2014-02-16','10:10:00',6.98),('10318','2014-02-16','10:15:00',7.05),('10318','2014-02-16','10:20:00',7.2),('10318','2014-02-16','10:25:00',7.11),('10318','2014-02-16','10:30:00',7.49),('10318','2014-02-16','10:35:00',7.49),('10318','2014-02-16','10:40:00',7.76),('10318','2014-02-16','10:45:00',7.62),('10318','2014-02-16','10:50:00',6.4),('10318','2014-02-16','10:55:00',7.35),('10318','2014-02-16','11:00:00',7.84),('10318','2014-02-16','11:05:00',7.71),('10318','2014-02-16','11:10:00',7.68),('10318','2014-02-16','11:15:00',7.3),('10318','2014-02-16','11:20:00',6.8),('10318','2014-02-16','11:25:00',7.23),('10318','2014-02-16','11:30:00',7.51),('10318','2014-02-16','11:35:00',7.71),('10318','2014-02-16','11:40:00',7.48),('10318','2014-02-16','11:45:00',7.2),('10318','2014-02-16','11:50:00',7.54),('10318','2014-02-16','11:55:00',7.08),('10318','2014-02-16','12:00:00',7.89),('10318','2014-02-16','12:05:00',7.79),('10318','2014-02-16','12:10:00',7.76),('10318','2014-02-16','12:15:00',7.71),('10318','2014-02-16','12:20:00',7.65),('10318','2014-02-16','12:25:00',7.58),('10318','2014-02-16','12:30:00',7.59),('10318','2014-02-16','12:35:00',7.51),('10318','2014-02-16','12:40:00',7.5),('10318','2014-02-16','12:45:00',7.45),('10318','2014-02-16','12:50:00',7.39),('10318','2014-02-16','12:55:00',7.36),('10318','2014-02-16','13:00:00',7.2),('10318','2014-02-16','13:05:00',7.2),('10318','2014-02-16','13:10:00',6.91),('10318','2014-02-16','13:15:00',7.1),('10318','2014-02-16','13:20:00',6.93),('10318','2014-02-16','13:25:00',6.81),('10318','2014-02-16','13:30:00',6.78),('10318','2014-02-16','13:35:00',6.75),('10318','2014-02-16','13:40:00',6.56),('10318','2014-02-16','13:45:00',6.42),('10318','2014-02-16','13:50:00',6.41),('10318','2014-02-16','13:55:00',6.43),('10318','2014-02-16','14:00:00',6.39),('10318','2014-02-16','14:05:00',6.26),('10318','2014-02-16','14:10:00',6.16),('10318','2014-02-16','14:15:00',6.09),('10318','2014-02-16','14:20:00',5.99),('10318','2014-02-16','14:25:00',5.87),('10318','2014-02-16','14:30:00',5.73),('10318','2014-02-16','14:35:00',5.53),('10318','2014-02-16','14:40:00',5.33),('10318','2014-02-16','14:45:00',5.26),('10318','2014-02-16','14:50:00',5.1),('10318','2014-02-16','14:55:00',4.99),('10318','2014-02-16','15:00:00',4.36),('10318','2014-02-16','15:05:00',4.54),('10318','2014-02-16','15:10:00',4.48),('10318','2014-02-16','15:15:00',4.3),('10318','2014-02-16','15:20:00',4.12),('10318','2014-02-16','15:25:00',3.97),('10318','2014-02-16','15:30:00',3.79),('10318','2014-02-16','15:35:00',3.63),('10318','2014-02-16','15:40:00',2.55),('10318','2014-02-16','15:45:00',2.97),('10318','2014-02-16','15:50:00',2.35),('10318','2014-02-16','16:05:00',1.07),('10318','2014-02-16','16:10:00',1.92),('10318','2014-02-16','16:15:00',1.99),('10318','2014-02-16','16:20:00',2.54),('10318','2014-02-16','16:25:00',2.78),('10318','2014-02-16','16:30:00',2.51),('10318','2014-02-16','16:35:00',2.04),('10318','2014-02-16','16:40:00',1.27),('10318','2014-04-28','07:15:00',1.21),('10318','2014-04-28','07:20:00',1.08),('10318','2014-04-28','07:25:00',1.06),('10318','2014-04-28','07:30:00',1.09),('10318','2014-04-28','07:35:00',1.09),('10318','2014-04-28','07:40:00',1.21),('10318','2014-04-28','07:45:00',1.38),('10318','2014-04-28','07:50:00',1.39),('10318','2014-04-28','07:55:00',1.71),('10318','2014-04-28','08:00:00',1.65),('10318','2014-04-28','08:05:00',1.05),('10318','2014-04-28','08:10:00',4.28),('10318','2014-04-28','08:15:00',5.06),('10318','2014-04-28','08:20:00',5.56),('10318','2014-04-28','08:25:00',3.87),('10318','2014-04-28','08:30:00',2.74),('10318','2014-04-28','08:35:00',2.7),('10318','2014-04-28','08:40:00',4.29),('10318','2014-04-28','08:45:00',2.99),('10318','2014-04-28','08:50:00',2.93),('10318','2014-04-28','08:55:00',2.8),('10318','2014-04-28','09:00:00',2.92),('10318','2014-04-28','09:05:00',5.56),('10318','2014-04-28','09:10:00',6.21),('10318','2014-04-28','09:15:00',6.96),('10318','2014-04-28','09:20:00',4.42),('10318','2014-04-28','09:25:00',7.81),('10318','2014-04-28','09:30:00',4.11),('10318','2014-04-28','09:35:00',6.19),('10318','2014-04-28','09:40:00',6.65),('10318','2014-04-28','09:45:00',7.06),('10318','2014-04-28','09:50:00',6),('10318','2014-04-28','09:55:00',3.72),('10318','2014-04-28','10:00:00',4.66),('10318','2014-04-28','10:05:00',5.29),('10318','2014-04-28','10:10:00',4.58),('10318','2014-04-28','10:15:00',4.33),('10318','2014-04-28','10:20:00',2.41),('10318','2014-04-28','10:25:00',1.48),('10318','2014-04-28','10:30:00',2.17),('10318','2014-04-28','10:35:00',2.45),('10318','2014-04-28','10:40:00',3.12),('10318','2014-04-28','10:45:00',3.42),('10318','2014-04-28','10:50:00',3.35),('10318','2014-04-28','10:55:00',4.5),('10318','2014-04-28','11:00:00',6.32),('10318','2014-04-28','11:05:00',5.97),('10318','2014-04-28','11:10:00',5.63),('10318','2014-04-28','11:15:00',5.87),('10318','2014-04-28','11:20:00',3.87),('10318','2014-04-28','11:25:00',3.35),('10318','2014-04-28','11:30:00',2.88),('10318','2014-04-28','11:35:00',3.28),('10318','2014-04-28','11:40:00',3.62),('10318','2014-04-28','11:45:00',4.11),('10318','2014-04-28','11:50:00',3.99),('10318','2014-04-28','11:55:00',3.84),('10318','2014-04-28','12:00:00',4.05),('10318','2014-04-28','12:05:00',4.14),('10318','2014-04-28','12:10:00',5.17),('10318','2014-04-28','12:15:00',6.12),('10318','2014-04-28','12:20:00',5.38),('10318','2014-04-28','12:25:00',5.47),('10318','2014-04-28','12:30:00',4.78),('10318','2014-04-28','12:35:00',4.62),('10318','2014-04-28','12:40:00',4.51),('10318','2014-04-28','12:45:00',4.67),('10318','2014-04-28','12:50:00',5.02),('10318','2014-04-28','12:55:00',5.7),('10318','2014-04-28','13:00:00',8.41),('10318','2014-04-28','13:05:00',6),('10318','2014-04-28','13:10:00',4.93),('10318','2014-04-28','13:15:00',6.75),('10318','2014-04-28','13:20:00',9.09),('10318','2014-04-28','13:25:00',8.9),('10318','2014-04-28','13:30:00',10.24),('10318','2014-04-28','13:35:00',10.6),('10318','2014-04-28','13:40:00',7.14),('10318','2014-04-28','13:45:00',9.4),('10318','2014-04-28','13:50:00',4.67),('10318','2014-04-28','13:55:00',4.81),('10318','2014-04-28','14:00:00',6.11),('10318','2014-04-28','14:05:00',9.93),('10318','2014-04-28','14:10:00',8.74),('10318','2014-04-28','14:15:00',4.85),('10318','2014-04-28','14:20:00',7.65),('10318','2014-04-28','14:25:00',9.05),('10318','2014-04-28','14:30:00',6.3),('10318','2014-04-28','14:35:00',3.7),('10318','2014-04-28','14:40:00',3.28),('10318','2014-04-28','14:45:00',3),('10318','2014-04-28','14:50:00',4.88),('10318','2014-04-28','14:55:00',6.81),('10318','2014-04-28','15:00:00',3.79),('10318','2014-04-28','15:05:00',7.36),('10318','2014-04-28','15:10:00',5.28),('10318','2014-04-28','15:15:00',5.07),('10318','2014-04-28','15:20:00',5.94),('10318','2014-04-28','15:25:00',5.21),('10318','2014-04-28','15:30:00',4.77),('10318','2014-04-28','15:35:00',3.56),('10318','2014-04-28','15:40:00',3.01),('10318','2014-04-28','15:45:00',6.97),('10318','2014-04-28','15:50:00',3.95),('10318','2014-04-28','15:55:00',6.83),('10318','2014-04-28','16:00:00',6.17),('10318','2014-04-28','16:05:00',5.52),('10318','2014-04-28','16:10:00',2.28),('10318','2014-04-28','16:15:00',3.41),('10318','2014-04-28','16:20:00',3.99),('10318','2014-04-28','16:25:00',3.67),('10318','2014-04-28','16:30:00',3.73),('10318','2014-04-28','16:35:00',2.47),('10318','2014-04-28','16:40:00',1.45),('10318','2014-04-28','16:45:00',1.49),('10318','2014-04-28','16:50:00',2.95),('10318','2014-04-28','16:55:00',2.98),('10318','2014-04-28','17:00:00',1.72),('10318','2014-04-28','17:05:00',1.56),('10318','2014-04-28','17:10:00',2.02),('10318','2014-04-28','17:15:00',2.7),('10318','2014-04-28','17:20:00',2.66),('10318','2014-04-28','17:25:00',2),('10318','2014-04-28','17:30:00',2.01),('10318','2014-04-28','17:35:00',2.85),('10318','2014-04-28','17:40:00',2.4),('10318','2014-04-28','17:45:00',1.47),('10318','2014-04-28','17:50:00',1.8),('10318','2014-04-28','17:55:00',1.44),('10318','2014-04-28','18:05:00',1.56),('10318','2014-04-28','18:10:00',1.56),('10318','2014-04-28','18:15:00',1.37),('10318','2014-04-28','18:20:00',1.19),('10318','2014-04-28','18:25:00',1.21),('10318','2014-04-28','18:30:00',1.18),('10318','2014-04-28','18:35:00',1.5),('10318','2014-04-28','18:40:00',1.12),('10318','2014-02-15','07:45:00',1.23),('10318','2014-02-15','07:50:00',1.42),('10318','2014-02-15','07:55:00',1.77),('10318','2014-02-15','08:00:00',2.22),('10318','2014-02-15','08:05:00',2.5),('10318','2014-02-15','08:10:00',2.91),('10318','2014-02-15','08:15:00',3.29),('10318','2014-02-15','08:20:00',3.52),('10318','2014-02-15','08:25:00',3.71),('10318','2014-02-15','08:30:00',3.92),('10318','2014-02-15','08:35:00',4.1),('10318','2014-02-15','08:40:00',4.29),('10318','2014-02-15','08:45:00',4.51),('10318','2014-02-15','08:50:00',4.61),('10318','2014-02-15','08:55:00',4.85),('10318','2014-02-15','09:00:00',5.06),('10318','2014-02-15','09:05:00',5.24),('10318','2014-02-15','09:10:00',5.42),('10318','2014-02-15','09:15:00',5.54),('10318','2014-02-15','09:20:00',5.71),('10318','2014-02-15','09:25:00',5.81),('10318','2014-02-15','09:30:00',6),('10318','2014-02-15','09:35:00',6.13),('10318','2014-02-15','09:40:00',6.09),('10318','2014-02-15','09:45:00',6.39),('10318','2014-02-15','09:50:00',6.5),('10318','2014-02-15','09:55:00',6.61),('10318','2014-02-15','10:00:00',6.71),('10318','2014-02-15','10:05:00',6.77),('10318','2014-02-15','10:10:00',6.77),('10318','2014-02-15','10:15:00',6.85),('10318','2014-02-15','10:20:00',6.89),('10318','2014-02-15','10:25:00',6.91),('10318','2014-02-15','10:30:00',7.04),('10318','2014-02-15','10:35:00',7.06),('10318','2014-02-15','10:40:00',7.12),('10318','2014-02-15','10:45:00',7.29),('10318','2014-02-15','10:50:00',7.26),('10318','2014-02-15','10:55:00',7.45),('10318','2014-02-15','11:00:00',7.49),('10318','2014-02-15','11:05:00',7.53),('10318','2014-02-15','11:10:00',7.41),('10318','2014-02-15','11:15:00',7.69),('10318','2014-02-15','11:20:00',7.6),('10318','2014-02-15','11:25:00',7.52),('10318','2014-02-15','11:30:00',2.92),('10318','2014-02-15','11:35:00',4.99),('10318','2014-02-15','11:40:00',8.17),('10318','2014-02-15','11:45:00',3.28),('10318','2014-02-15','11:50:00',7.94),('10318','2014-02-15','11:55:00',7.63),('10318','2014-02-15','12:00:00',5.06),('10318','2014-02-15','12:05:00',2.37),('10318','2014-02-15','12:10:00',7.79),('10318','2014-02-15','12:15:00',8.34),('10318','2014-02-15','12:20:00',8.25),('10318','2014-02-15','12:25:00',8),('10318','2014-02-15','12:30:00',8.02),('10318','2014-02-15','12:35:00',7.97),('10318','2014-02-15','12:40:00',3.91),('10318','2014-02-15','12:45:00',7.7),('10318','2014-02-15','12:50:00',7.77),('10318','2014-02-15','12:55:00',7.61),('10318','2014-02-15','13:00:00',7.54),('10318','2014-02-15','13:05:00',7.01),('10318','2014-02-15','13:10:00',7.65),('10318','2014-02-15','13:15:00',5.48),('10318','2014-02-15','13:20:00',6.79),('10318','2014-02-15','13:25:00',6.91),('10318','2014-02-15','13:30:00',7.23),('10318','2014-02-15','13:35:00',7.2),('10318','2014-02-15','13:40:00',6.11),('10318','2014-02-15','13:45:00',6.96),('10318','2014-02-15','13:50:00',6.85),('10318','2014-02-15','13:55:00',6.7),('10318','2014-02-15','14:00:00',5.19),('10318','2014-02-15','14:05:00',5.96),('10318','2014-02-15','14:10:00',6.14),('10318','2014-02-15','14:15:00',6.11),('10318','2014-02-15','14:20:00',6),('10318','2014-02-15','14:25:00',5.9),('10318','2014-02-15','14:30:00',5.73),('10318','2014-02-15','14:35:00',5.48),('10318','2014-02-15','14:40:00',5.43),('10318','2014-02-15','14:45:00',5.18),('10318','2014-02-15','14:50:00',5),('10318','2014-02-15','14:55:00',4.74),('10318','2014-02-15','15:00:00',4.66),('10318','2014-02-15','15:05:00',4.52),('10318','2014-02-15','15:10:00',4.38),('10318','2014-02-15','15:15:00',4.24),('10318','2014-02-15','15:20:00',4.09),('10318','2014-02-15','15:25:00',3.9),('10318','2014-02-15','15:30:00',3.77),('10318','2014-02-15','15:35:00',3.62),('10318','2014-02-15','15:40:00',3.47),('10318','2014-02-15','15:45:00',3.29),('10318','2014-02-15','15:50:00',3.14),('10318','2014-02-15','15:55:00',2.98),('10318','2014-02-15','16:00:00',2.8),('10318','2014-02-15','16:05:00',2.64),('10318','2014-02-15','16:10:00',2.45),('10318','2014-02-15','16:15:00',2.29),('10318','2014-02-15','16:20:00',2.13),('10318','2014-02-15','16:25:00',1.97),('10318','2014-02-15','16:30:00',1.76),('10318','2014-02-15','16:35:00',1.56),('10318','2014-02-15','16:40:00',1.41),('10318','2014-02-15','16:45:00',1.23),('10318','2014-02-15','16:50:00',1.03),('10318','2014-02-14','08:35:00',1.53),('10318','2014-02-14','08:40:00',4.27),('10318','2014-02-14','08:45:00',4.7),('10318','2014-02-14','08:50:00',4.74),('10318','2014-02-14','08:55:00',4.76),('10318','2014-02-14','09:00:00',5.09),('10318','2014-02-14','09:05:00',5.22),('10318','2014-02-14','09:10:00',5.32),('10318','2014-02-14','09:15:00',4.16),('10318','2014-02-14','09:20:00',4.73),('10318','2014-02-14','09:25:00',4.17),('10318','2014-02-14','09:30:00',4.83),('10318','2014-02-14','09:35:00',3.88),('10318','2014-02-14','09:40:00',6.17),('10318','2014-02-14','09:45:00',5.9),('10318','2014-02-14','09:50:00',5.21),('10318','2014-02-14','09:55:00',7.09),('10318','2014-02-14','10:00:00',6.05),('10318','2014-02-14','10:05:00',5.86),('10318','2014-02-14','10:10:00',5.21),('10318','2014-02-14','10:15:00',7.23),('10318','2014-02-14','10:20:00',5.76),('10318','2014-02-14','10:25:00',7.75),('10318','2014-02-14','10:30:00',7.51),('10318','2014-02-14','10:35:00',7.48),('10318','2014-02-14','10:40:00',7.49),('10318','2014-02-14','10:45:00',6.78),('10318','2014-02-14','10:50:00',7.67),('10318','2014-02-14','10:55:00',8.04),('10318','2014-02-14','11:00:00',8.08),('10318','2014-02-14','11:05:00',8.08),('10318','2014-02-14','11:10:00',8.06),('10318','2014-02-14','11:15:00',8.1),('10318','2014-02-14','11:20:00',8.21),('10318','2014-02-14','11:25:00',8.22),('10318','2014-02-14','11:30:00',8.13),('10318','2014-02-14','11:35:00',8.24),('10318','2014-02-14','11:40:00',8.18),('10318','2014-02-14','11:45:00',8.26),('10318','2014-02-14','11:50:00',8.31),('10318','2014-02-14','11:55:00',7.98),('10318','2014-02-14','12:00:00',8.18),('10318','2014-02-14','12:05:00',8.15),('10318','2014-02-14','12:10:00',8.03),('10318','2014-02-14','12:15:00',8.08),('10318','2014-02-14','12:20:00',8.16),('10318','2014-02-14','12:25:00',8.05),('10318','2014-02-14','12:30:00',8.07),('10318','2014-02-14','12:35:00',7.97),('10318','2014-02-14','12:40:00',7.98),('10318','2014-02-14','12:45:00',7.87),('10318','2014-02-14','12:50:00',7.79),('10318','2014-02-14','12:55:00',7.76),('10318','2014-02-14','13:00:00',7.65),('10318','2014-02-14','13:05:00',7.66),('10318','2014-02-14','13:10:00',7.6),('10318','2014-02-14','13:15:00',7.48),('10318','2014-02-14','13:20:00',7.44),('10318','2014-02-14','13:25:00',7.38),('10318','2014-02-14','13:30:00',7.28),('10318','2014-02-14','13:35:00',7.11),('10318','2014-02-14','13:40:00',7.05),('10318','2014-02-14','13:45:00',6.84),('10318','2014-02-14','13:50:00',6.8),('10318','2014-02-14','13:55:00',6.74),('10318','2014-02-14','14:00:00',6.64),('10318','2014-02-14','14:05:00',6.45),('10318','2014-02-14','14:10:00',6.33),('10318','2014-02-14','14:15:00',6.16),('10318','2014-02-14','14:20:00',6.01),('10318','2014-02-14','14:25:00',5.87),('10318','2014-02-14','14:30:00',5.72),('10318','2014-02-14','14:35:00',5.59),('10318','2014-02-14','14:40:00',5.46),('10318','2014-02-14','14:45:00',5.26),('10318','2014-02-14','14:50:00',5.1),('10318','2014-02-14','14:55:00',4.95),('10318','2014-02-14','15:00:00',4.75),('10318','2014-02-14','15:05:00',4.56),('10318','2014-02-14','15:10:00',4.42),('10318','2014-02-14','15:15:00',4.24),('10318','2014-02-14','15:20:00',4.06),('10318','2014-02-14','15:25:00',3.92),('10318','2014-02-14','15:30:00',3.74),('10318','2014-02-14','15:35:00',3.57),('10318','2014-02-14','15:40:00',3.41),('10318','2014-02-14','15:45:00',3.18),('10318','2014-02-14','15:50:00',3.03),('10318','2014-02-14','15:55:00',2.89),('10318','2014-02-14','16:00:00',2.77),('10318','2014-02-14','16:05:00',2.62),('10318','2014-02-14','16:10:00',2.39),('10318','2014-02-14','16:15:00',2.25),('10318','2014-02-14','16:20:00',2.07),('10318','2014-02-14','16:25:00',1.88),('10318','2014-02-14','16:30:00',1.65),('10318','2014-02-14','16:35:00',1.45),('10318','2014-02-14','16:40:00',1.31),('10318','2014-02-14','16:45:00',1.14),('10318','2014-02-13','07:45:00',1.15),('10318','2014-02-13','07:50:00',1.35),('10318','2014-02-13','07:55:00',1.56),('10318','2014-02-13','08:00:00',2.18),('10318','2014-02-13','08:05:00',2.48),('10318','2014-02-13','08:10:00',2.91),('10318','2014-02-13','08:15:00',2.9),('10318','2014-02-13','08:20:00',2.41),('10318','2014-02-13','08:25:00',3.68),('10318','2014-02-13','08:30:00',3.95),('10318','2014-02-13','08:35:00',4.19),('10318','2014-02-13','08:40:00',4.38),('10318','2014-02-13','08:45:00',4.64),('10318','2014-02-13','08:50:00',4.85),('10318','2014-02-13','08:55:00',5.05),('10318','2014-02-13','09:00:00',5.22),('10318','2014-02-13','09:05:00',5.45),('10318','2014-02-13','09:10:00',5.59),('10318','2014-02-13','09:15:00',5.69),('10318','2014-02-13','09:20:00',5.91),('10318','2014-02-13','09:25:00',6.02),('10318','2014-02-13','09:30:00',6.18),('10318','2014-02-13','09:35:00',6.31),('10318','2014-02-13','09:40:00',6.4),('10318','2014-02-13','09:45:00',6.5),('10318','2014-02-13','09:50:00',6.65),('10318','2014-02-13','09:55:00',6.77),('10318','2014-02-13','10:00:00',6.85),('10318','2014-02-13','10:05:00',6.99),('10318','2014-02-13','10:10:00',7.07),('10318','2014-02-13','10:15:00',7.08),('10318','2014-02-13','10:20:00',7.13),('10318','2014-02-13','10:25:00',7.23),('10318','2014-02-13','10:30:00',7.38),('10318','2014-02-13','10:35:00',7.47),('10318','2014-02-13','10:40:00',7.51),('10318','2014-02-13','10:45:00',7.51),('10318','2014-02-13','10:50:00',7.5),('10318','2014-02-13','10:55:00',7.66),('10318','2014-02-13','11:00:00',7.5),('10318','2014-02-13','11:05:00',7.7),('10318','2014-02-13','11:10:00',5.43),('10318','2014-02-13','11:15:00',2.39),('10318','2014-02-13','11:20:00',7.76),('10318','2014-02-13','11:25:00',7.29),('10318','2014-02-13','11:30:00',3.61),('10318','2014-02-13','11:35:00',8.09),('10318','2014-02-13','11:40:00',7.22),('10318','2014-02-13','11:45:00',3.59),('10318','2014-02-13','11:50:00',3.82),('10318','2014-02-13','11:55:00',2.49),('10318','2014-02-13','12:00:00',3.18),('10318','2014-02-13','12:05:00',5.5),('10318','2014-02-13','12:10:00',3.07),('10318','2014-02-13','12:15:00',3.14),('10318','2014-02-13','12:20:00',4.98),('10318','2014-02-13','12:25:00',4.52),('10318','2014-02-13','12:30:00',6.93),('10318','2014-02-13','12:35:00',8.34),('10318','2014-02-13','12:40:00',6.25),('10318','2014-02-13','12:45:00',8.8),('10318','2014-02-13','12:50:00',8.34),('10318','2014-02-13','12:55:00',7.83),('10318','2014-02-13','13:00:00',7.89),('10318','2014-02-13','13:05:00',7.76),('10318','2014-02-13','13:10:00',7.74),('10318','2014-02-13','13:15:00',7.66),('10318','2014-02-13','13:20:00',7.5),('10318','2014-02-13','13:25:00',7.41),('10318','2014-02-13','13:30:00',7.33),('10318','2014-02-13','13:35:00',7.22),('10318','2014-02-13','13:40:00',7.11),('10318','2014-02-13','13:45:00',7.03),('10318','2014-02-13','13:50:00',6.91),('10318','2014-02-13','13:55:00',6.83),('10318','2014-02-13','14:00:00',6.61),('10318','2014-02-13','14:05:00',5.96),('10318','2014-02-13','14:10:00',5.94),('10318','2014-02-13','14:15:00',6.27),('10318','2014-02-13','14:20:00',6.23),('10318','2014-02-13','14:25:00',6),('10318','2014-02-13','14:30:00',5.84),('10318','2014-02-13','14:35:00',4.46),('10318','2014-02-13','14:40:00',5.77),('10318','2014-02-13','14:45:00',5.28),('10318','2014-02-13','14:50:00',3.49),('10318','2014-02-13','14:55:00',3.66),('10318','2014-02-13','15:00:00',1.58),('10318','2014-02-13','15:05:00',5.02),('10318','2014-02-13','15:10:00',3.35),('10318','2014-02-13','15:15:00',4.69),('10318','2014-02-13','15:20:00',4.6),('10318','2014-02-13','15:25:00',3.23),('10318','2014-02-13','15:30:00',4.24),('10318','2014-02-13','15:35:00',3.92),('10318','2014-02-13','15:40:00',3.83),('10318','2014-02-13','15:45:00',3.36),('10318','2014-02-13','15:50:00',3.5),('10318','2014-02-13','15:55:00',3.12),('10318','2014-02-13','16:00:00',2.73),('10318','2014-02-13','16:05:00',2.64),('10318','2014-02-13','16:10:00',1.48),('10318','2014-02-13','16:15:00',2.18),('10318','2014-02-13','16:20:00',1.58),('10318','2014-02-13','16:30:00',1.08),('10318','2014-02-12','08:10:00',1.04),('10318','2014-02-12','08:15:00',2.97),('10318','2014-02-12','08:20:00',3.02),('10318','2014-02-12','08:25:00',3.17),('10318','2014-02-12','08:30:00',2.92),('10318','2014-02-12','08:35:00',1),('10318','2014-02-12','08:40:00',3.48),('10318','2014-02-12','08:45:00',4.57),('10318','2014-02-12','08:50:00',4.73),('10318','2014-02-12','08:55:00',4.02),('10318','2014-02-12','09:00:00',4.39),('10318','2014-02-12','09:05:00',4.07),('10318','2014-02-12','09:10:00',5.68),('10318','2014-02-12','09:15:00',5.84),('10318','2014-02-12','09:20:00',6.07),('10318','2014-02-12','09:25:00',6.17),('10318','2014-02-12','09:30:00',4.31),('10318','2014-02-12','09:35:00',6.84),('10318','2014-02-12','09:40:00',8.02),('10318','2014-02-12','09:45:00',6.59),('10318','2014-02-12','09:50:00',8.54),('10318','2014-02-12','09:55:00',2.43),('10318','2014-02-12','10:00:00',4.04),('10318','2014-02-12','10:05:00',3.55),('10318','2014-02-12','10:10:00',2.87),('10318','2014-02-12','10:15:00',2.38),('10318','2014-02-12','10:20:00',2.63),('10318','2014-02-12','10:25:00',2.76),('10318','2014-02-12','10:30:00',3.35),('10318','2014-02-12','10:35:00',2.73),('10318','2014-02-12','10:40:00',3.24),('10318','2014-02-12','10:45:00',3.19),('10318','2014-02-12','10:50:00',3.28),('10318','2014-02-12','10:55:00',3.42),('10318','2014-02-12','11:00:00',3.17),('10318','2014-02-12','11:05:00',3.34),('10318','2014-02-12','11:10:00',3.3),('10318','2014-02-12','11:15:00',2.96),('10318','2014-02-12','11:20:00',3.11),('10318','2014-02-12','11:25:00',3.21),('10318','2014-02-12','11:30:00',3.39),('10318','2014-02-12','11:35:00',3.99),('10318','2014-02-12','11:40:00',3.5),('10318','2014-02-12','11:45:00',2.43),('10318','2014-02-12','11:50:00',2.04),('10318','2014-02-12','11:55:00',1.72),('10318','2014-02-12','12:00:00',1.81),('10318','2014-02-12','12:05:00',2.29),('10318','2014-02-12','12:10:00',2.88),('10318','2014-02-12','12:15:00',2.95),('10318','2014-02-12','12:20:00',3.05),('10318','2014-02-12','12:25:00',2.99),('10318','2014-02-12','12:30:00',3.09),('10318','2014-02-12','12:35:00',3.07),('10318','2014-02-12','12:40:00',3.12),('10318','2014-02-12','12:45:00',3.46),('10318','2014-02-12','12:50:00',3.72),('10318','2014-02-12','12:55:00',4.63),('10318','2014-02-12','13:00:00',5.72),('10318','2014-02-12','13:05:00',4.92),('10318','2014-02-12','13:10:00',3.62),('10318','2014-02-12','13:15:00',3.76),('10318','2014-02-12','13:20:00',3.39),('10318','2014-02-12','13:25:00',3.41),('10318','2014-02-12','13:30:00',3.77),('10318','2014-02-12','13:35:00',4.68),('10318','2014-02-12','13:40:00',4.07),('10318','2014-02-12','13:45:00',5.72),('10318','2014-02-12','13:50:00',5.29),('10318','2014-02-12','13:55:00',5.41),('10318','2014-02-12','14:00:00',7.42),('10318','2014-02-12','14:05:00',7.91),('10318','2014-02-12','14:10:00',5.11),('10318','2014-02-12','14:15:00',5.99),('10318','2014-02-12','14:20:00',6.98),('10318','2014-02-12','14:25:00',3.83),('10318','2014-02-12','14:30:00',4.79),('10318','2014-02-12','14:35:00',4.38),('10318','2014-02-12','14:40:00',3.6),('10318','2014-02-12','14:45:00',5.77),('10318','2014-02-12','14:50:00',5.41),('10318','2014-02-12','14:55:00',5.07),('10318','2014-02-12','15:00:00',3.21),('10318','2014-02-12','15:05:00',2.1),('10318','2014-02-12','15:10:00',2.92),('10318','2014-02-12','15:15:00',4.25),('10318','2014-02-12','15:20:00',4.54),('10318','2014-02-12','15:25:00',2.17),('10318','2014-02-12','15:30:00',2.44),('10318','2014-02-12','15:35:00',3.58),('10318','2014-02-12','15:40:00',4.5),('10318','2014-02-12','15:45:00',3.12),('10318','2014-02-12','15:50:00',2.5),('10318','2014-02-12','15:55:00',2.49),('10318','2014-02-12','16:00:00',2.15),('10318','2014-02-12','16:05:00',2.96),('10318','2014-02-12','16:10:00',1.79),('10318','2014-02-11','08:45:00',1.04),('10318','2014-02-11','08:50:00',1.17),('10318','2014-02-11','08:55:00',1.33),('10318','2014-02-11','09:00:00',1.54),('10318','2014-02-11','09:05:00',1.56),('10318','2014-02-11','09:10:00',1.59),('10318','2014-02-11','09:15:00',1.96),('10318','2014-02-11','09:20:00',2.83),('10318','2014-02-11','09:25:00',3.26),('10318','2014-02-11','09:30:00',3.02),('10318','2014-02-11','09:35:00',3.11),('10318','2014-02-11','09:40:00',2.82),('10318','2014-02-11','09:45:00',2.95),('10318','2014-02-11','09:50:00',2.97),('10318','2014-02-11','09:55:00',2.8),('10318','2014-02-11','10:00:00',2.53),('10318','2014-02-11','10:05:00',2.79),('10318','2014-02-11','10:10:00',3.08),('10318','2014-02-11','10:15:00',3.61),('10318','2014-02-11','10:20:00',4.73),('10318','2014-02-11','10:25:00',5.26),('10318','2014-02-11','10:30:00',5.67),('10318','2014-02-11','10:35:00',5.6),('10318','2014-02-11','10:40:00',4.91),('10318','2014-02-11','10:45:00',5.3),('10318','2014-02-11','10:50:00',5.65),('10318','2014-02-11','10:55:00',5.21),('10318','2014-02-11','11:00:00',5.38),('10318','2014-02-11','11:05:00',5.88),('10318','2014-02-11','11:10:00',5.83),('10318','2014-02-11','11:15:00',6.25),('10318','2014-02-11','11:20:00',5.78),('10318','2014-02-11','11:25:00',5.24),('10318','2014-02-11','11:30:00',4.95),('10318','2014-02-11','11:35:00',5.74),('10318','2014-02-11','11:40:00',5.67),('10318','2014-02-11','11:45:00',4.1),('10318','2014-02-11','11:50:00',5.03),('10318','2014-02-11','11:55:00',4.34),('10318','2014-02-11','12:00:00',3.4),('10318','2014-02-11','12:05:00',3.97),('10318','2014-02-11','12:10:00',4.78),('10318','2014-02-11','12:15:00',4.52),('10318','2014-02-11','12:20:00',3.96),('10318','2014-02-11','12:25:00',4.99),('10318','2014-02-11','12:30:00',5.06),('10318','2014-02-11','12:35:00',4.91),('10318','2014-02-11','12:40:00',3.39),('10318','2014-02-11','12:45:00',4.14),('10318','2014-02-11','12:50:00',3.14),('10318','2014-02-11','12:55:00',3.62),('10318','2014-02-11','13:00:00',4.11),('10318','2014-02-11','13:05:00',5.3),('10318','2014-02-11','13:10:00',7.38),('10318','2014-02-11','13:15:00',7.14),('10318','2014-02-11','13:20:00',7.33),('10318','2014-02-11','13:25:00',6.06),('10318','2014-02-11','13:30:00',5.68),('10318','2014-02-11','13:35:00',5.82),('10318','2014-02-11','13:40:00',5.91),('10318','2014-02-11','13:45:00',5.57),('10318','2014-02-11','13:50:00',3.46),('10318','2014-02-11','13:55:00',3.24),('10318','2014-02-11','14:00:00',3.54),('10318','2014-02-11','14:05:00',4.9),('10318','2014-02-11','14:10:00',3.18),('10318','2014-02-11','14:15:00',4.46),('10318','2014-02-11','14:20:00',3.83),('10318','2014-02-11','14:25:00',4.06),('10318','2014-02-11','14:30:00',3.41),('10318','2014-02-11','14:35:00',2.8),('10318','2014-02-11','14:40:00',2.47),('10318','2014-02-11','14:45:00',2.35),('10318','2014-02-11','14:50:00',2.03),('10318','2014-02-11','14:55:00',1.97),('10318','2014-02-11','15:00:00',2.01),('10318','2014-02-11','15:05:00',2.13),('10318','2014-02-11','15:10:00',2.28),('10318','2014-02-11','15:15:00',2.77),('10318','2014-02-11','15:20:00',2.92),('10318','2014-02-11','15:25:00',2.56),('10318','2014-02-11','15:30:00',1.83),('10318','2014-02-11','15:35:00',1.87),('10318','2014-02-11','15:40:00',1.7),('10318','2014-02-11','15:45:00',1.44),('10318','2014-02-11','15:50:00',1.32),('10318','2014-02-11','15:55:00',1.33),('10318','2014-02-11','16:00:00',1.41),('10318','2014-02-11','16:05:00',1.84),('10318','2014-02-11','16:10:00',2.28),('10318','2014-02-11','16:15:00',2.08),('10318','2014-02-11','16:20:00',1.88),('10318','2014-02-11','16:25:00',1.96),('10318','2014-02-11','16:30:00',1.82),('10318','2014-02-11','16:35:00',1.65),('10318','2014-02-11','16:40:00',1.45),('10318','2014-02-11','16:45:00',1.17),('10318','2014-02-10','15:25:00',1.78),('10318','2014-02-10','15:30:00',1.66),('10318','2014-02-10','15:35:00',1.36),('10318','2014-02-10','15:40:00',1.05),('10318','2014-02-10','15:45:00',1.02),('10318','2014-02-10','15:50:00',1.05),('10318','2014-04-27','07:35:00',1.15),('10318','2014-04-27','08:10:00',1.2),('10318','2014-04-27','08:15:00',1.07),('10318','2014-04-27','08:20:00',1.13),('10318','2014-04-27','08:25:00',1.24),('10318','2014-04-27','08:30:00',1.01),('10318','2014-04-27','08:40:00',1.29),('10318','2014-04-27','08:45:00',2.01),('10318','2014-04-27','08:50:00',2.74),('10318','2014-04-27','08:55:00',1.68),('10318','2014-04-27','09:00:00',1.34),('10318','2014-04-27','09:05:00',2.05),('10318','2014-04-27','09:10:00',2.31),('10318','2014-04-27','09:15:00',2.41),('10318','2014-04-27','09:20:00',1.92),('10318','2014-04-27','09:25:00',1.36),('10318','2014-04-27','09:30:00',1.42),('10318','2014-04-27','09:35:00',1.06),('10318','2014-04-27','09:45:00',1.01),('10318','2014-04-27','09:50:00',1.18),('10318','2014-04-27','09:55:00',1.44),('10318','2014-04-27','10:00:00',1.85),('10318','2014-04-27','10:05:00',2.3),('10318','2014-04-27','10:10:00',2.69),('10318','2014-04-27','10:15:00',3.25),('10318','2014-04-27','10:20:00',3.97),('10318','2014-04-27','10:25:00',2.6),('10318','2014-04-27','10:30:00',2.56),('10318','2014-04-27','10:35:00',1.06),('10318','2014-04-27','10:45:00',1.02),('10318','2014-04-27','10:50:00',1.22),('10318','2014-04-27','10:55:00',1.76),('10318','2014-04-27','11:00:00',2),('10318','2014-04-27','11:05:00',1.29),('10318','2014-04-27','11:10:00',1.21),('10318','2014-04-27','11:15:00',1.19),('10318','2014-04-27','11:30:00',1.77),('10318','2014-04-27','11:35:00',2.56),('10318','2014-04-27','11:40:00',4.73),('10318','2014-04-27','11:45:00',7.17),('10318','2014-04-27','11:50:00',9.48),('10318','2014-04-27','11:55:00',5.94),('10318','2014-04-27','12:00:00',5.27),('10318','2014-04-27','12:05:00',5.87),('10318','2014-04-27','12:10:00',6.3),('10318','2014-04-27','12:15:00',6.64),('10318','2014-04-27','12:20:00',5.66),('10318','2014-04-27','12:25:00',5.96),('10318','2014-04-27','12:30:00',6.24),('10318','2014-04-27','12:35:00',6.5),('10318','2014-04-27','12:40:00',6.11),('10318','2014-04-27','12:45:00',4.99),('10318','2014-04-27','12:50:00',4.11),('10318','2014-04-27','12:55:00',4.64),('10318','2014-04-27','13:00:00',5.06),('10318','2014-04-27','13:05:00',4.4),('10318','2014-04-27','13:10:00',4.29),('10318','2014-04-27','13:15:00',4.76),('10318','2014-04-27','13:20:00',5.29),('10318','2014-04-27','13:25:00',4.87),('10318','2014-04-27','13:30:00',4.42),('10318','2014-04-27','13:35:00',3.62),('10318','2014-04-27','13:40:00',3.55),('10318','2014-04-27','13:45:00',3.9),('10318','2014-04-27','13:50:00',3.94),('10318','2014-04-27','13:55:00',3.94),('10318','2014-04-27','14:00:00',5.9),('10318','2014-04-27','14:05:00',4.94),('10318','2014-04-27','14:10:00',3.43),('10318','2014-04-27','14:15:00',3.73),('10318','2014-04-27','14:20:00',4.02),('10318','2014-04-27','14:25:00',4.59),('10318','2014-04-27','14:30:00',4.97),('10318','2014-04-27','14:35:00',5.38),('10318','2014-04-27','14:40:00',5.77),('10318','2014-04-27','14:45:00',4.81),('10318','2014-04-27','14:50:00',4.3),('10318','2014-04-27','14:55:00',4.44),('10318','2014-04-27','15:00:00',5.09),('10318','2014-04-27','15:05:00',7.14),('10318','2014-04-27','15:10:00',7.24),('10318','2014-04-27','15:15:00',5.39),('10318','2014-04-27','15:20:00',3.55),('10318','2014-04-27','15:25:00',2.33),('10318','2014-04-27','15:30:00',2.07),('10318','2014-04-27','15:35:00',2.4),('10318','2014-04-27','15:40:00',2.45),('10318','2014-04-27','15:45:00',1.76),('10318','2014-04-27','15:50:00',1.67),('10318','2014-04-27','15:55:00',1.46),('11288','2014-05-05','07:45:00',1.05),('11288','2014-05-05','07:50:00',1.14),('11288','2014-05-05','07:55:00',1.3),('11288','2014-05-05','08:00:00',1.63),('11288','2014-05-05','08:05:00',1.77),('11288','2014-05-05','08:10:00',1.95),('11288','2014-05-05','08:15:00',2.14),('11288','2014-05-05','08:20:00',2.24),('11288','2014-05-05','08:25:00',2.45),('11288','2014-05-05','08:30:00',2.72),('11288','2014-05-05','08:35:00',2.8),('11288','2014-05-05','08:40:00',3.03),('11288','2014-05-05','08:45:00',3.12),('11288','2014-05-05','08:50:00',3.28),('11288','2014-05-05','08:55:00',3.38),('11288','2014-05-05','09:00:00',3.66),('11288','2014-05-05','09:05:00',3.81),('11288','2014-05-05','09:10:00',3.95),('11288','2014-05-05','09:15:00',4.19),('11288','2014-05-05','09:20:00',4.21),('11288','2014-05-05','09:25:00',4.25),('11288','2014-05-05','09:30:00',4.61),('11288','2014-05-05','09:35:00',4.69),('11288','2014-05-05','09:40:00',4.92),('11288','2014-05-05','09:45:00',5.01),('11288','2014-05-05','09:50:00',5.2),('11288','2014-05-05','09:55:00',5.33),('11288','2014-05-05','10:00:00',5.46),('11288','2014-05-05','10:05:00',5.59),('11288','2014-05-05','10:10:00',5.7),('11288','2014-05-05','10:15:00',5.75),('11288','2014-05-05','10:20:00',5.8),('11288','2014-05-05','10:25:00',5.9),('11288','2014-05-05','10:30:00',5.99),('11288','2014-05-05','10:35:00',6.12),('11288','2014-05-05','10:40:00',6.17),('11288','2014-05-05','10:45:00',6.25),('11288','2014-05-05','10:50:00',6.28),('11288','2014-05-05','10:55:00',6.32),('11288','2014-05-05','11:00:00',6.45),('11288','2014-05-05','11:05:00',6.53),('11288','2014-05-05','11:10:00',6.57),('11288','2014-05-05','11:15:00',6.71),('11288','2014-05-05','11:20:00',6.67),('11288','2014-05-05','11:25:00',6.74),('11288','2014-05-05','11:30:00',6.76),('11288','2014-05-05','11:35:00',6.78),('11288','2014-05-05','11:40:00',6.82),('11288','2014-05-05','11:45:00',6.92),('11288','2014-05-05','11:50:00',7.01),('11288','2014-05-05','11:55:00',6.62),('11288','2014-05-05','12:00:00',7.24),('11288','2014-05-05','12:05:00',5.2),('11288','2014-05-05','12:10:00',2.9),('11288','2014-05-05','12:15:00',3.61),('11288','2014-05-05','12:20:00',3.65),('11288','2014-05-05','12:25:00',2.95),('11288','2014-05-05','12:30:00',6.62),('11288','2014-05-05','12:35:00',5.39),('11288','2014-05-05','12:40:00',2.62),('11288','2014-05-05','12:45:00',5.15),('11288','2014-05-05','12:50:00',7.24),('11288','2014-05-05','12:55:00',3.6),('11288','2014-05-05','13:00:00',2.18),('11288','2014-05-05','13:05:00',3.81),('11288','2014-05-05','13:10:00',8.11),('11288','2014-05-05','13:15:00',7.71),('11288','2014-05-05','13:20:00',7.43),('11288','2014-05-05','13:25:00',7.29),('11288','2014-05-05','13:30:00',7.3),('11288','2014-05-05','13:35:00',7.36),('11288','2014-05-05','13:40:00',7.3),('11288','2014-05-05','13:45:00',6.56),('11288','2014-05-05','13:50:00',7.36),('11288','2014-05-05','13:55:00',7.32),('11288','2014-05-05','14:00:00',6.84),('11288','2014-05-05','14:05:00',5.69),('11288','2014-05-05','14:10:00',3.55),('11288','2014-05-05','14:15:00',7.9),('11288','2014-05-05','14:20:00',7.49),('11288','2014-05-05','14:25:00',6.2),('11288','2014-05-05','14:30:00',6.82),('11288','2014-05-05','14:35:00',4.53),('11288','2014-05-05','14:40:00',4.89),('11288','2014-05-05','14:45:00',3.15),('11288','2014-05-05','14:50:00',2.5),('11288','2014-05-05','14:55:00',2.89),('11288','2014-05-05','15:00:00',4.99),('11288','2014-05-05','15:05:00',7.47),('11288','2014-05-05','15:10:00',5.45),('11288','2014-05-05','15:15:00',2.34),('11288','2014-05-05','15:20:00',2.35),('11288','2014-05-05','15:25:00',3.57),('11288','2014-05-05','15:30:00',4.97),('11288','2014-05-05','15:35:00',2.22),('11288','2014-05-05','15:40:00',7.01),('11288','2014-05-05','15:45:00',5.76),('11288','2014-05-05','15:50:00',2.21),('11288','2014-05-05','15:55:00',2.05),('11288','2014-05-05','16:00:00',3.39),('11288','2014-05-05','16:05:00',4.08),('11288','2014-05-05','16:10:00',4.28),('11288','2014-05-05','16:15:00',2.28),('11288','2014-05-05','16:20:00',3.16),('11288','2014-05-05','16:25:00',2.56),('11288','2014-05-05','16:30:00',2.6),('11288','2014-05-05','16:35:00',5.56),('11288','2014-05-05','16:40:00',5.31),('11288','2014-05-05','16:45:00',4.71),('11288','2014-05-05','16:50:00',4.82),('11288','2014-05-05','16:55:00',4.53),('11288','2014-05-05','17:00:00',4.22),('11288','2014-05-05','17:05:00',4.03),('11288','2014-05-05','17:10:00',4.05),('11288','2014-05-05','17:15:00',3.83),('11288','2014-05-05','17:20:00',3.66),('11288','2014-05-05','17:25:00',3.48),('11288','2014-05-05','17:30:00',3.26),('11288','2014-05-05','17:35:00',3.08),('11288','2014-05-05','17:40:00',2.95),('11288','2014-05-05','17:45:00',2.72),('11288','2014-05-05','17:50:00',2.61),('11288','2014-05-05','17:55:00',2.47),('11288','2014-05-05','18:00:00',2.3),('11288','2014-05-05','18:05:00',2.23),('11288','2014-05-05','18:10:00',2.19),('11288','2014-05-05','18:15:00',2.05),('11288','2014-05-05','18:20:00',1.89),('11288','2014-05-05','18:25:00',1.7),('11288','2014-05-05','18:30:00',1.59),('11288','2014-05-05','18:35:00',1.47),('11288','2014-05-05','18:40:00',1.32),('11288','2014-05-05','18:45:00',1.15),('11288','2014-05-05','18:50:00',1.02),('11288','2014-04-26','08:00:00',1.04),('11288','2014-04-26','08:05:00',1.12),('11288','2014-04-26','08:10:00',1.21),('11288','2014-04-26','08:15:00',1.21),('11288','2014-04-26','08:20:00',1.24),('11288','2014-04-26','08:25:00',1.29),('11288','2014-04-26','08:30:00',1.19),('11288','2014-04-26','08:35:00',1.27),('11288','2014-04-26','08:40:00',1.45),('11288','2014-04-26','08:45:00',1.56),('11288','2014-04-26','08:50:00',1.62),('11288','2014-04-26','08:55:00',1.61),('11288','2014-04-26','09:00:00',1.62),('11288','2014-04-26','09:05:00',1.8),('11288','2014-04-26','09:10:00',1.6),('11288','2014-04-26','09:15:00',1.42),('11288','2014-04-26','09:20:00',1.43),('11288','2014-04-26','09:25:00',1.47),('11288','2014-04-26','09:30:00',1.46),('11288','2014-04-26','09:35:00',1.55),('11288','2014-04-26','09:40:00',1.69),('11288','2014-04-26','09:45:00',1.51),('11288','2014-04-26','09:50:00',1.66),('11288','2014-04-26','09:55:00',2.45),('11288','2014-04-26','10:00:00',2.57),('11288','2014-04-26','10:05:00',2.31),('11288','2014-04-26','10:10:00',2.21),('11288','2014-04-26','10:15:00',2.34),('11288','2014-04-26','10:20:00',2.61),('11288','2014-04-26','10:25:00',2.89),('11288','2014-04-26','10:30:00',3.38),('11288','2014-04-26','10:35:00',3.59),('11288','2014-04-26','10:40:00',3.46),('11288','2014-04-26','10:45:00',3.56),('11288','2014-04-26','10:50:00',4.44),('11288','2014-04-26','10:55:00',6.05),('11288','2014-04-26','11:00:00',6.05),('11288','2014-04-26','11:05:00',5.78),('11288','2014-04-26','11:10:00',5.47),('11288','2014-04-26','11:15:00',5.21),('11288','2014-04-26','11:20:00',5.15),('11288','2014-04-26','11:25:00',4.94),('11288','2014-04-26','11:30:00',5.17),('11288','2014-04-26','11:35:00',5.16),('11288','2014-04-26','11:40:00',4.97),('11288','2014-04-26','11:45:00',5.2),('11288','2014-04-26','11:50:00',5.13),('11288','2014-04-26','11:55:00',4.96),('11288','2014-04-26','12:00:00',5.13),('11288','2014-04-26','12:05:00',5.53),('11288','2014-04-26','12:10:00',5.76),('11288','2014-04-26','12:15:00',3.91),('11288','2014-04-26','12:20:00',5.01),('11288','2014-04-26','12:25:00',5.14),('11288','2014-04-26','12:30:00',3.69),('11288','2014-04-26','12:35:00',6.37),('11288','2014-04-26','12:40:00',5.92),('11288','2014-04-26','12:45:00',6.69),('11288','2014-04-26','12:50:00',6.75),('11288','2014-04-26','12:55:00',7.07),('11288','2014-04-26','13:00:00',6.22),('11288','2014-04-26','13:05:00',5.09),('11288','2014-04-26','13:10:00',5.29),('11288','2014-04-26','13:15:00',6.98),('11288','2014-04-26','13:20:00',7.53),('11288','2014-04-26','13:25:00',6.99),('11288','2014-04-26','13:30:00',2.54),('11288','2014-04-26','13:35:00',3.02),('11288','2014-04-26','13:40:00',7.52),('11288','2014-04-26','13:45:00',7.2),('11288','2014-04-26','13:50:00',6.97),('11288','2014-04-26','13:55:00',6.97),('11288','2014-04-26','14:00:00',5.79),('11288','2014-04-26','14:05:00',1.32),('11288','2014-04-26','14:10:00',2.68),('11288','2014-04-26','14:15:00',3.32),('11288','2014-04-26','14:25:00',1.44),('11288','2014-04-26','14:30:00',1.58),('11288','2014-04-26','14:35:00',2.69),('11288','2014-04-26','14:40:00',4.24),('11288','2014-04-26','14:45:00',1.57),('11288','2014-04-26','17:40:00',1.16),('11288','2014-04-26','17:45:00',1.53),('11288','2014-04-26','17:50:00',1.64),('11288','2014-04-26','17:55:00',1.52),('11288','2014-04-26','18:30:00',1.06),('11288','2014-04-26','18:35:00',1.29),('11288','2014-04-26','18:40:00',1.54),('11288','2014-04-26','18:45:00',1.69),('11288','2014-04-26','18:50:00',1.3),('11288','2014-01-26','08:55:00',1.04),('11288','2014-01-26','09:00:00',1.48),('11288','2014-01-26','09:05:00',1.85),('11288','2014-01-26','09:10:00',1.28),('11288','2014-01-26','09:15:00',1.01),('11288','2014-01-26','09:25:00',1.37),('11288','2014-01-26','09:30:00',2.21),('11288','2014-01-26','09:35:00',2.32),('11288','2014-01-26','09:40:00',1.41),('11288','2014-01-26','09:45:00',1.94),('11288','2014-01-26','09:50:00',2.28),('11288','2014-01-26','09:55:00',1.78),('11288','2014-01-26','10:00:00',1.37),('11288','2014-01-26','10:05:00',1.44),('11288','2014-01-26','10:10:00',2.75),('11288','2014-01-26','10:15:00',3.13),('11288','2014-01-26','10:20:00',1.95),('11288','2014-01-26','10:25:00',1.79),('11288','2014-01-26','10:30:00',1.68),('11288','2014-01-26','10:35:00',1.41),('11288','2014-01-26','10:40:00',1.24),('11288','2014-01-26','10:45:00',1.31),('11288','2014-01-26','10:50:00',1.47),('11288','2014-01-26','10:55:00',1.64),('11288','2014-01-26','11:00:00',1.51),('11288','2014-01-26','11:05:00',1.58),('11288','2014-01-26','11:10:00',1.35),('11288','2014-01-26','11:15:00',1.32),('11288','2014-01-26','11:20:00',1.37),('11288','2014-01-26','11:25:00',1.95),('11288','2014-01-26','11:30:00',1.58),('11288','2014-01-26','11:35:00',1.38),('11288','2014-01-26','11:40:00',1.36),('11288','2014-01-26','11:45:00',1.19),('11288','2014-01-26','11:50:00',1.02),('11288','2014-01-26','11:55:00',1.06),('11288','2014-01-26','12:00:00',1.06),('11288','2014-01-26','12:05:00',1.19),('11288','2014-01-26','12:10:00',1.56),('11288','2014-01-26','12:15:00',2.08),('11288','2014-01-26','12:20:00',2.19),('11288','2014-01-26','12:25:00',2.36),('11288','2014-01-26','12:30:00',3.89),('11288','2014-01-26','12:35:00',2.96),('11288','2014-01-26','12:40:00',2.21),('11288','2014-01-26','12:45:00',1.96),('11288','2014-01-26','12:50:00',1.74),('11288','2014-01-26','12:55:00',1.67),('11288','2014-01-26','13:00:00',1.81),('11288','2014-01-26','13:05:00',2.04),('11288','2014-01-26','13:10:00',2.25),('11288','2014-01-26','13:15:00',2.42),('11288','2014-01-26','13:20:00',2.52),('11288','2014-01-26','13:25:00',2.09),('11288','2014-01-26','13:30:00',1.61),('11288','2014-01-26','13:35:00',1.34),('11288','2014-01-26','13:40:00',1.18),('11288','2014-01-26','13:45:00',1.26),('11288','2014-01-26','13:50:00',1.65),('11288','2014-01-26','13:55:00',1.16),('11288','2014-01-26','14:05:00',1.04),('11288','2014-01-26','14:10:00',1.23),('11288','2014-01-26','14:15:00',1.2),('11288','2014-01-26','15:20:00',1),('11288','2014-01-26','15:25:00',1.41),('11288','2014-01-26','15:45:00',1.5),('11288','2014-01-25','09:00:00',1.1),('11288','2014-01-25','09:05:00',1.7),('11288','2014-01-25','09:10:00',2.03),('11288','2014-01-25','09:15:00',1.44),('11288','2014-01-25','09:20:00',1.72),('11288','2014-01-25','09:25:00',1.12),('11288','2014-01-25','09:40:00',1.1),('11288','2014-01-25','09:45:00',1.43),('11288','2014-01-25','09:50:00',2.22),('11288','2014-01-25','09:55:00',2.83),('11288','2014-01-25','10:00:00',2.06),('11288','2014-01-25','10:05:00',3),('11288','2014-01-25','10:10:00',3.58),('11288','2014-01-25','10:15:00',3.93),('11288','2014-01-25','10:20:00',3.93),('11288','2014-01-25','10:25:00',2.72),('11288','2014-01-25','10:30:00',2.57),('11288','2014-01-25','10:35:00',2.25),('11288','2014-01-25','10:40:00',2.94),('11288','2014-01-25','10:45:00',2.33),('11288','2014-01-25','10:50:00',2.78),('11288','2014-01-25','10:55:00',2.9),('11288','2014-01-25','11:00:00',2.1),('11288','2014-01-25','11:05:00',2),('11288','2014-01-25','11:10:00',1.84),('11288','2014-01-25','11:15:00',2.11),('11288','2014-01-25','11:20:00',1.96),('11288','2014-01-25','11:25:00',2.26),('11288','2014-01-25','11:30:00',4.7),('11288','2014-01-25','11:35:00',5.11),('11288','2014-01-25','11:40:00',3.03),('11288','2014-01-25','11:45:00',2.38),('11288','2014-01-25','11:50:00',2.7),('11288','2014-01-25','11:55:00',2.8),('11288','2014-01-25','12:00:00',2.73),('11288','2014-01-25','12:05:00',2.9),('11288','2014-01-25','12:10:00',3.07),('11288','2014-01-25','12:15:00',2.94),('11288','2014-01-25','12:20:00',3.06),('11288','2014-01-25','12:25:00',3.26),('11288','2014-01-25','12:30:00',3.16),('11288','2014-01-25','12:35:00',2.82),('11288','2014-01-25','12:40:00',2.97),('11288','2014-01-25','12:45:00',3.41),('11288','2014-01-25','12:50:00',3.39),('11288','2014-01-25','12:55:00',3.9),('11288','2014-01-25','13:00:00',4.03),('11288','2014-01-25','13:05:00',3.86),('11288','2014-01-25','13:10:00',4.32),('11288','2014-01-25','13:15:00',3.44),('11288','2014-01-25','13:20:00',1.88),('11288','2014-01-25','13:25:00',2.4),('11288','2014-01-25','13:30:00',2.17),('11288','2014-01-25','13:35:00',2.45),('11288','2014-01-25','13:40:00',1.69),('11288','2014-01-25','13:45:00',2.03),('11288','2014-01-25','13:50:00',2.24),('11288','2014-01-25','13:55:00',1.32),('11288','2014-01-25','14:00:00',1.67),('11288','2014-01-25','14:05:00',1.93),('11288','2014-01-25','14:10:00',3.23),('11288','2014-01-25','14:15:00',1.75),('11288','2014-01-25','14:20:00',3.12),('11288','2014-01-25','14:25:00',3.41),('11288','2014-01-25','14:30:00',3.77),('11288','2014-01-25','14:35:00',4),('11288','2014-01-25','14:40:00',3.71),('11288','2014-01-25','14:45:00',3.64),('11288','2014-01-25','14:50:00',3.35),('11288','2014-01-25','14:55:00',3.03),('11288','2014-01-25','15:00:00',2.63),('11288','2014-01-25','15:05:00',2.37),('11288','2014-01-25','15:10:00',2.23),('11288','2014-01-25','15:15:00',2.1),('11288','2014-01-25','15:20:00',1.93),('11288','2014-01-25','15:25:00',1.8),('11288','2014-01-25','15:30:00',1.67),('11288','2014-01-25','15:35:00',1.52),('11288','2014-01-25','15:40:00',1.38),('11288','2014-01-25','15:45:00',1.26),('11288','2014-01-25','15:50:00',1.06),('11288','2014-01-24','10:05:00',1.63),('11288','2014-01-24','10:10:00',1.73),('11288','2014-01-24','10:15:00',2.32),('11288','2014-01-24','10:20:00',1.28),('11288','2014-01-24','10:25:00',1.49),('11288','2014-01-24','10:30:00',2.26),('11288','2014-01-24','10:35:00',2.28),('11288','2014-01-24','10:40:00',3.09),('11288','2014-01-24','10:45:00',2.76),('11288','2014-01-24','10:50:00',1.91),('11288','2014-01-24','10:55:00',1.82),('11288','2014-01-24','11:00:00',1.87),('11288','2014-01-24','11:05:00',1.29),('11288','2014-01-24','11:20:00',1.39),('11288','2014-01-24','11:25:00',2.1),('11288','2014-01-24','11:30:00',2.52),('11288','2014-01-24','11:35:00',2.18),('11288','2014-01-24','11:40:00',1.06),('11288','2014-01-24','11:45:00',3.09),('11288','2014-01-24','11:50:00',4.8),('11288','2014-01-24','11:55:00',4.85),('11288','2014-01-24','12:00:00',2.95),('11288','2014-01-24','12:05:00',2.19),('11288','2014-01-24','12:10:00',1.58),('11288','2014-01-24','12:15:00',1.13),('11288','2014-01-24','12:20:00',1.65),('11288','2014-01-24','12:25:00',2.86),('11288','2014-01-24','12:30:00',2.13),('11288','2014-01-24','12:35:00',4.32),('11288','2014-01-24','12:40:00',3.74),('11288','2014-01-24','12:45:00',2.6),('11288','2014-01-24','12:50:00',1.98),('11288','2014-01-24','12:55:00',2.53),('11288','2014-01-24','13:00:00',2.95),('11288','2014-01-24','13:05:00',3.27),('11288','2014-01-24','13:10:00',2.22),('11288','2014-01-24','13:15:00',1.81),('11288','2014-01-24','13:20:00',1.34),('11288','2014-01-24','13:25:00',1.35),('11288','2014-01-24','13:30:00',2.28),('11288','2014-01-24','13:35:00',2.75),('11288','2014-01-24','13:40:00',2.42),('11288','2014-01-24','13:45:00',2.44),('11288','2014-01-24','13:50:00',2.57),('11288','2014-01-24','13:55:00',2.73),('11288','2014-01-24','14:00:00',2.35),('11288','2014-01-24','14:05:00',1.43),('11288','2014-01-24','14:10:00',4.16),('11288','2014-01-24','14:15:00',3.09),('11288','2014-01-24','14:20:00',2.9),('11288','2014-01-24','14:25:00',2.54),('11288','2014-01-24','14:35:00',1.19),('11288','2014-01-24','14:40:00',1.26),('11288','2014-01-24','14:45:00',1.7),('11288','2014-01-23','10:10:00',1.02),('11288','2014-01-23','10:15:00',1.21),('11288','2014-01-23','10:20:00',1.24),('11288','2014-01-23','10:25:00',1.24),('11288','2014-01-23','10:30:00',1),('11288','2014-01-23','10:40:00',1.01),('11288','2014-01-23','10:45:00',1.08),('11288','2014-01-23','10:50:00',1.35),('11288','2014-01-23','10:55:00',1.6),('11288','2014-01-23','11:00:00',1.88),('11288','2014-01-23','11:05:00',1.86),('11288','2014-01-23','11:10:00',1.83),('11288','2014-01-23','11:15:00',1.84),('11288','2014-01-23','11:20:00',1.77),('11288','2014-01-23','11:25:00',1.56),('11288','2014-01-23','11:30:00',1.14),('11288','2014-01-23','12:05:00',1.23),('11288','2014-01-23','12:10:00',1.54),('11288','2014-01-23','12:15:00',1.01),('11288','2014-01-23','12:25:00',1.33),('11288','2014-01-23','12:30:00',1.86),('11288','2014-01-23','12:35:00',1.54),('11288','2014-01-23','12:40:00',1.01),('11288','2014-01-23','14:00:00',1),('11288','2014-01-23','14:05:00',1.26),('11288','2014-01-23','14:10:00',1.39),('11288','2014-01-23','14:15:00',1.45),('11288','2014-01-23','14:20:00',1.24),('11288','2014-01-23','14:25:00',1.06),('11288','2014-01-22','10:10:00',1.04),('11288','2014-01-22','10:15:00',1.68),('11288','2014-01-22','10:20:00',1.13),('11288','2014-01-22','10:40:00',1.05),('11288','2014-01-22','10:45:00',1.37),('11288','2014-01-22','10:50:00',1.33),('11288','2014-01-22','10:55:00',1.34),('11288','2014-01-22','11:00:00',1.57),('11288','2014-01-22','11:05:00',1.75),('11288','2014-01-22','11:10:00',1.82),('11288','2014-01-22','11:15:00',1.69),('11288','2014-01-22','11:20:00',1.76),('11288','2014-01-22','11:25:00',1.63),('11288','2014-01-22','11:30:00',1.23),('11288','2014-01-22','11:35:00',1.24),('11288','2014-01-22','11:40:00',1.75),('11288','2014-01-22','11:45:00',1.53),('11288','2014-01-22','11:50:00',1.37),('11288','2014-01-22','11:55:00',1.52),('11288','2014-01-22','12:00:00',1.52),('11288','2014-01-22','12:05:00',1.58),('11288','2014-01-22','12:10:00',1.23),('11288','2014-01-22','12:35:00',1.03),('11288','2014-01-22','12:40:00',1.3),('11288','2014-01-22','12:45:00',1.36),('11288','2014-01-22','12:50:00',1.59),('11288','2014-01-22','12:55:00',1.67),('11288','2014-01-22','13:00:00',1.43),('11288','2014-01-22','13:05:00',1.56),('11288','2014-01-22','13:10:00',1.98),('11288','2014-01-22','13:15:00',2.88),('11288','2014-01-22','13:20:00',1.79),('11288','2014-01-22','13:25:00',1.27),('11288','2014-01-22','13:30:00',1.01),('11288','2014-01-22','13:40:00',1.15),('11288','2014-01-22','13:45:00',1.04),('11288','2014-01-22','13:50:00',1.14),('11288','2014-01-22','13:55:00',1.34),('11288','2014-01-22','14:00:00',1.21),('11288','2014-01-22','14:05:00',1.14),('11288','2014-01-22','14:10:00',1.38),('11288','2014-01-22','14:15:00',1.17),('11288','2014-01-22','14:20:00',1.13),('11288','2014-01-22','14:25:00',1.13),('11288','2014-01-22','14:30:00',1.04),('11288','2014-01-22','15:00:00',1),('11288','2014-01-22','15:05:00',1.07),('11288','2014-01-22','16:05:00',1.18),('11288','2014-01-22','16:10:00',1.3),('11288','2014-01-21','09:35:00',1.29),('11288','2014-01-21','09:40:00',1.41),('11288','2014-01-21','09:50:00',1.16),('11288','2014-01-21','09:55:00',1.7),('11288','2014-01-21','10:00:00',2.05),('11288','2014-01-21','10:05:00',2.1),('11288','2014-01-21','10:35:00',1.42),('11288','2014-01-21','10:40:00',1.3),('11288','2014-01-21','10:55:00',2.52),('11288','2014-01-21','11:00:00',3.5),('11288','2014-01-21','11:05:00',1.44),('11288','2014-01-21','11:15:00',1.14),('11288','2014-01-21','11:20:00',1.29),('11288','2014-01-21','11:45:00',1.03),('11288','2014-01-21','11:50:00',1.7),('11288','2014-01-21','11:55:00',1.62),('11288','2014-01-21','12:00:00',1.86),('11288','2014-01-21','12:05:00',2.48),('11288','2014-01-21','12:10:00',2.95),('11288','2014-01-21','12:15:00',2.2),('11288','2014-01-21','12:20:00',1.85),('11288','2014-01-21','12:25:00',2.41),('11288','2014-01-21','12:30:00',2.78),('11288','2014-01-21','12:35:00',2.55),('11288','2014-01-21','12:40:00',2.22),('11288','2014-01-21','12:45:00',2.13),('11288','2014-01-21','12:50:00',2.57),('11288','2014-01-21','12:55:00',1.2),('11288','2014-01-21','13:10:00',1.05),('11288','2014-01-21','13:15:00',1.48),('11288','2014-01-21','13:20:00',1.65),('11288','2014-01-21','13:55:00',1.13),('11288','2014-01-21','14:00:00',1.92),('11288','2014-01-21','14:05:00',2.33),('11288','2014-01-21','14:10:00',2.15),('11288','2014-01-21','14:15:00',1.78),('11288','2014-01-21','14:20:00',1.24),('11288','2014-01-21','15:25:00',1.06),('11288','2014-01-21','15:30:00',1.13),('11288','2014-01-21','15:35:00',1.43),('11288','2014-01-21','15:40:00',1.26),('11288','2014-01-20','10:50:00',1.05),('11288','2014-01-20','11:15:00',1.77),('11288','2014-01-20','11:20:00',2.73),('11288','2014-01-20','11:25:00',3.13),('11288','2014-01-20','11:30:00',3.18),('11288','2014-01-20','11:35:00',3.19),('11288','2014-01-20','11:40:00',4.35),('11288','2014-01-20','11:45:00',4.7),('11288','2014-01-20','11:50:00',2.9),('11288','2014-01-20','11:55:00',1.86),('11288','2014-01-20','12:00:00',1.85),('11288','2014-01-20','12:05:00',1.91),('11288','2014-01-20','12:10:00',1.36),('11288','2014-01-20','12:15:00',1.22),('11288','2014-01-20','12:25:00',1.96),('11288','2014-01-20','12:30:00',2.02),('11288','2014-01-20','12:35:00',1.35),('11288','2014-01-20','12:45:00',1.05),('11288','2014-01-20','13:10:00',1.04),('11288','2014-01-20','13:15:00',2.14),('11288','2014-01-20','13:20:00',6),('11288','2014-01-20','13:25:00',5.31),('11288','2014-01-20','13:30:00',4.76),('11288','2014-01-20','13:35:00',4.39),('11288','2014-01-20','13:40:00',3.33),('11288','2014-01-20','13:45:00',3.17),('11288','2014-01-20','13:50:00',1.91),('11288','2014-01-20','13:55:00',2.36),('11288','2014-01-20','14:00:00',4.09),('11288','2014-01-20','14:05:00',2.5),('11288','2014-01-20','14:10:00',1.81),('11288','2014-01-20','14:15:00',1.66),('11288','2014-01-20','14:20:00',1.43),('11288','2014-01-20','14:25:00',1.23),('11288','2014-01-19','10:20:00',1.06),('11288','2014-01-19','11:05:00',1.06),('11288','2014-01-19','11:40:00',1),('11288','2014-01-19','11:45:00',1.34),('11288','2014-01-19','11:50:00',1.67),('11288','2014-01-19','11:55:00',1.74),('11288','2014-01-19','12:00:00',1.86),('11288','2014-01-19','12:05:00',1.91),('11288','2014-01-19','12:10:00',1.83),('11288','2014-01-19','12:15:00',1.57),('11288','2014-01-19','12:20:00',1.67),('11288','2014-01-19','12:25:00',1.7),('11288','2014-01-19','12:30:00',1.12),('11288','2014-01-19','12:55:00',1.07),('11288','2014-01-19','13:00:00',1.37),('11288','2014-01-19','13:05:00',1.82),('11288','2014-01-19','13:10:00',2.02),('11288','2014-01-19','13:15:00',1.77),('11288','2014-01-19','13:20:00',1.43),('11288','2014-01-19','13:25:00',1.27),('11288','2014-01-19','13:30:00',1.25),('11288','2014-01-19','13:35:00',1.2),('11288','2014-01-19','13:40:00',1.09),('11288','2014-01-19','13:45:00',1.06),('11288','2014-01-19','13:50:00',1.1),('11288','2014-01-19','13:55:00',1.39),('11288','2014-01-19','14:00:00',1.26),('11288','2014-01-19','14:05:00',1.08),('11288','2014-01-19','14:15:00',1.33),('11288','2014-01-19','14:20:00',2.32),('11288','2014-01-19','14:25:00',2.59),('11288','2014-01-19','14:30:00',2.88),('11288','2014-01-19','14:35:00',2.03),('11288','2014-01-19','14:40:00',1.73),('11288','2014-01-19','14:45:00',1.42),('11288','2014-01-19','15:40:00',1.2),('11288','2014-01-18','09:25:00',1.01),('11288','2014-01-18','09:30:00',1.21),('11288','2014-01-18','09:35:00',1.48),('11288','2014-01-18','09:40:00',1.51),('11288','2014-01-18','09:45:00',1.45),('11288','2014-01-18','09:50:00',1.41),('11288','2014-01-18','09:55:00',1.61),('11288','2014-01-18','10:00:00',1.96),('11288','2014-01-18','10:05:00',2.41),('11288','2014-01-18','10:10:00',3.15),('11288','2014-01-18','10:15:00',3.35),('11288','2014-01-18','10:20:00',2.83),('11288','2014-01-18','10:25:00',2.34),('11288','2014-01-18','10:30:00',2.46),('11288','2014-01-18','10:35:00',1.88),('11288','2014-01-18','10:40:00',1.72),('11288','2014-01-18','10:45:00',1.91),('11288','2014-01-18','10:50:00',2.09),('11288','2014-01-18','10:55:00',1.91),('11288','2014-01-18','11:00:00',1.4),('11288','2014-01-18','11:05:00',2),('11288','2014-01-18','11:10:00',2.85),('11288','2014-01-18','11:15:00',4),('11288','2014-01-18','11:20:00',3.8),('11288','2014-01-18','11:25:00',3.65),('11288','2014-01-18','11:30:00',3.74),('11288','2014-01-18','11:35:00',3.77),('11288','2014-01-18','11:40:00',3.9),('11288','2014-01-18','11:45:00',4.32),('11288','2014-01-18','11:50:00',4.21),('11288','2014-01-18','11:55:00',4.59),('11288','2014-01-18','12:00:00',4.35),('11288','2014-01-18','12:05:00',3.21),('11288','2014-01-18','12:10:00',4.13),('11288','2014-01-18','12:15:00',3.82),('11288','2014-01-18','12:20:00',3.58),('11288','2014-01-18','12:25:00',3.85),('11288','2014-01-18','12:30:00',3.94),('11288','2014-01-18','12:35:00',3.92),('11288','2014-01-18','12:40:00',3.97),('11288','2014-01-18','12:45:00',3.79),('11288','2014-01-18','12:50:00',3.54),('11288','2014-01-18','12:55:00',4.11),('11288','2014-01-18','13:00:00',2.77),('11288','2014-01-18','13:05:00',2.62),('11288','2014-01-18','13:10:00',3.38),('11288','2014-01-18','13:15:00',4.01),('11288','2014-01-18','13:20:00',2.68),('11288','2014-01-18','13:25:00',2.16),('11288','2014-01-18','13:30:00',3.51),('11288','2014-01-18','13:35:00',2.32),('11288','2014-01-18','13:40:00',3.21),('11288','2014-01-18','13:45:00',3.58),('11288','2014-01-18','13:50:00',2.71),('11288','2014-01-18','13:55:00',3.44),('11288','2014-01-18','14:00:00',3.33),('11288','2014-01-18','14:05:00',3.14),('11288','2014-01-18','14:10:00',2.94),('11288','2014-01-18','14:15:00',2.8),('11288','2014-01-18','14:20:00',2.86),('11288','2014-01-18','14:25:00',2.71),('11288','2014-01-18','14:30:00',2.59),('11288','2014-01-18','14:35:00',2.47),('11288','2014-01-18','14:40:00',2.35),('11288','2014-01-18','14:45:00',2.24),('11288','2014-01-18','14:50:00',2.13),('11288','2014-01-18','14:55:00',1.39),('11288','2014-01-18','15:15:00',1.01),('11288','2014-01-18','15:20:00',1.06),('11288','2014-01-17','09:00:00',1.47),('11288','2014-01-17','09:05:00',1.47),('11288','2014-01-17','09:10:00',1.31),('11288','2014-01-17','09:20:00',1.49),('11288','2014-01-17','09:25:00',1.61),('11288','2014-01-17','09:30:00',1.71),('11288','2014-01-17','09:35:00',2.06),('11288','2014-01-17','09:40:00',2.34),('11288','2014-01-17','09:45:00',2.62),('11288','2014-01-17','09:50:00',1.51),('11288','2014-01-17','10:05:00',1.23),('11288','2014-01-17','10:15:00',1),('11288','2014-01-17','11:20:00',1.24),('11288','2014-01-17','11:25:00',2.11),('11288','2014-01-17','11:30:00',2.79),('11288','2014-01-17','11:35:00',3.18),('11288','2014-01-17','11:40:00',2.79),('11288','2014-01-17','11:45:00',1.3),('11288','2014-01-17','11:50:00',1.35),('11288','2014-01-17','11:55:00',1.81),('11288','2014-01-17','12:00:00',2.22),('11288','2014-01-17','12:05:00',2.39),('11288','2014-01-17','12:10:00',2.02),('11288','2014-01-17','12:15:00',1.36),('11288','2014-01-17','12:20:00',1.65),('11288','2014-01-17','12:25:00',1.5),('11288','2014-01-17','12:30:00',1.09),('11288','2014-01-17','12:35:00',1.18),('11288','2014-01-17','12:40:00',1.73),('11288','2014-01-17','12:45:00',1.96),('11288','2014-01-17','12:50:00',1.56),('11288','2014-01-17','13:10:00',1.14),('11288','2014-04-25','07:45:00',1.16),('11288','2014-04-25','07:50:00',1.23),('11288','2014-04-25','07:55:00',1.33),('11288','2014-04-25','08:00:00',1.27),('11288','2014-04-25','08:05:00',1.39),('11288','2014-04-25','08:10:00',1.47),('11288','2014-04-25','08:15:00',1.89),('11288','2014-04-25','08:20:00',1.92),('11288','2014-04-25','08:25:00',1.97),('11288','2014-04-25','08:30:00',2.18),('11288','2014-04-25','08:35:00',2.06),('11288','2014-04-25','08:40:00',2.15),('11288','2014-04-25','08:45:00',2.62),('11288','2014-04-25','08:50:00',2.9),('11288','2014-04-25','08:55:00',2.32),('11288','2014-04-25','09:00:00',2.15),('11288','2014-04-25','09:05:00',1.98),('11288','2014-04-25','09:10:00',1.53),('11288','2014-04-25','09:15:00',1.22),('11288','2014-04-25','09:20:00',1.61),('11288','2014-04-25','09:25:00',2.85),('11288','2014-04-25','09:30:00',1.83),('11288','2014-04-25','09:35:00',1.86),('11288','2014-04-25','09:40:00',1.76),('11288','2014-04-25','09:45:00',1.75),('11288','2014-04-25','09:50:00',1.75),('11288','2014-04-25','09:55:00',2),('11288','2014-04-25','10:00:00',2.33),('11288','2014-04-25','10:05:00',2.21),('11288','2014-04-25','10:10:00',2.37),('11288','2014-04-25','10:15:00',2.17),('11288','2014-04-25','10:20:00',2.38),('11288','2014-04-25','10:25:00',2.41),('11288','2014-04-25','10:30:00',3.47),('11288','2014-04-25','10:35:00',5.12),('11288','2014-04-25','10:40:00',3.92),('11288','2014-04-25','10:45:00',4.59),('11288','2014-04-25','10:50:00',3.8),('11288','2014-04-25','10:55:00',5.76),('11288','2014-04-25','11:00:00',4.84),('11288','2014-04-25','11:05:00',3.2),('11288','2014-04-25','11:10:00',4.61),('11288','2014-04-25','11:15:00',6.74),('11288','2014-04-25','11:20:00',3.57),('11288','2014-04-25','11:25:00',5.89),('11288','2014-04-25','11:30:00',4.42),('11288','2014-04-25','11:35:00',4.4),('11288','2014-04-25','11:40:00',4.38),('11288','2014-04-25','11:45:00',2.99),('11288','2014-04-25','11:50:00',5.16),('11288','2014-04-25','11:55:00',7.87),('11288','2014-04-25','12:00:00',5.55),('11288','2014-04-25','12:05:00',6.58),('11288','2014-04-25','12:10:00',5.94),('11288','2014-04-25','12:15:00',2.32),('11288','2014-04-25','12:20:00',5.08),('11288','2014-04-25','12:25:00',6.64),('11288','2014-04-25','12:30:00',7.1),('11288','2014-04-25','12:35:00',7.33),('11288','2014-04-25','12:40:00',7.42),('11288','2014-04-25','12:45:00',7.52),('11288','2014-04-25','12:50:00',5.97),('11288','2014-04-25','12:55:00',6.38),('11288','2014-04-25','13:00:00',6.44),('11288','2014-04-25','13:05:00',5.73),('11288','2014-04-25','13:10:00',6.93),('11288','2014-04-25','13:15:00',5.12),('11288','2014-04-25','13:20:00',3.36),('11288','2014-04-25','13:25:00',4.66),('11288','2014-04-25','13:30:00',2.44),('11288','2014-04-25','13:35:00',1.88),('11288','2014-04-25','13:40:00',3.17),('11288','2014-04-25','13:45:00',2.38),('11288','2014-04-25','13:50:00',2.2),('11288','2014-04-25','13:55:00',2.69),('11288','2014-04-25','14:00:00',2.45),('11288','2014-04-25','14:05:00',2.68),('11288','2014-04-25','14:10:00',2.13),('11288','2014-04-25','14:15:00',2.47),('11288','2014-04-25','14:20:00',4.85),('11288','2014-04-25','14:25:00',2.71),('11288','2014-04-25','14:30:00',6.95),('11288','2014-04-25','14:35:00',6.95),('11288','2014-04-25','14:40:00',6.55),('11288','2014-04-25','14:45:00',6.35),('11288','2014-04-25','14:50:00',6.32),('11288','2014-04-25','14:55:00',6.27),('11288','2014-04-25','15:00:00',6.15),('11288','2014-04-25','15:05:00',6.06),('11288','2014-04-25','15:10:00',6.03),('11288','2014-04-25','15:15:00',5.91),('11288','2014-04-25','15:20:00',5.66),('11288','2014-04-25','15:25:00',5.65),('11288','2014-04-25','15:30:00',5.5),('11288','2014-04-25','15:35:00',5.65),('11288','2014-04-25','15:40:00',5.54),('11288','2014-04-25','15:45:00',5.38),('11288','2014-04-25','15:50:00',5.4),('11288','2014-04-25','15:55:00',5.28),('11288','2014-04-25','16:00:00',5.18),('11288','2014-04-25','16:05:00',5),('11288','2014-04-25','16:10:00',4.72),('11288','2014-04-25','16:15:00',4.62),('11288','2014-04-25','16:20:00',4.28),('11288','2014-04-25','16:25:00',4.38),('11288','2014-04-25','16:30:00',4.46),('11288','2014-04-25','16:35:00',4.5),('11288','2014-04-25','16:40:00',4.38),('11288','2014-04-25','16:45:00',4.28),('11288','2014-04-25','16:50:00',3.81),('11288','2014-04-25','16:55:00',3.24),('11288','2014-04-25','17:00:00',3.31),('11288','2014-04-25','17:05:00',3.53),('11288','2014-04-25','17:10:00',2.96),('11288','2014-04-25','17:15:00',3.13),('11288','2014-04-25','17:20:00',2.05),('11288','2014-04-25','17:25:00',1.6),('11288','2014-04-25','17:30:00',1.72),('11288','2014-04-25','17:35:00',1.73),('11288','2014-04-25','17:40:00',1.61),('11288','2014-04-25','17:45:00',1.48),('11288','2014-04-25','17:50:00',1.36),('11288','2014-04-25','17:55:00',1.3),('11288','2014-04-25','18:00:00',1.27),('11288','2014-04-25','18:05:00',1.29),('11288','2014-04-25','18:10:00',1.24),('11288','2014-04-25','18:15:00',1.06),('11288','2014-04-25','18:20:00',1.08),('11288','2014-04-25','18:25:00',1.06),('11288','2014-04-25','18:30:00',1.01),('11288','2014-01-16','08:40:00',1.02),('11288','2014-01-16','08:55:00',1.03),('11288','2014-01-16','09:00:00',1.18),('11288','2014-01-16','09:05:00',1.21),('11288','2014-01-16','09:10:00',1.36),('11288','2014-01-16','09:15:00',1.4),('11288','2014-01-16','09:20:00',1.97),('11288','2014-01-16','09:25:00',2.16),('11288','2014-01-16','09:30:00',2.3),('11288','2014-01-16','09:35:00',2.41),('11288','2014-01-16','09:40:00',2.65),('11288','2014-01-16','09:45:00',2.42),('11288','2014-01-16','09:50:00',1.97),('11288','2014-01-16','09:55:00',1.67),('11288','2014-01-16','10:00:00',1.54),('11288','2014-01-16','10:05:00',1.63),('11288','2014-01-16','10:10:00',1.79),('11288','2014-01-16','10:15:00',2.03),('11288','2014-01-16','10:20:00',1.96),('11288','2014-01-16','10:25:00',2.22),('11288','2014-01-16','10:30:00',2.89),('11288','2014-01-16','10:35:00',3.62),('11288','2014-01-16','10:40:00',3.43),('11288','2014-01-16','10:45:00',2.6),('11288','2014-01-16','10:50:00',2.75),('11288','2014-01-16','10:55:00',2.99),('11288','2014-01-16','11:00:00',3.04),('11288','2014-01-16','11:05:00',3),('11288','2014-01-16','11:10:00',3.16),('11288','2014-01-16','11:15:00',3.06),('11288','2014-01-16','11:20:00',2.85),('11288','2014-01-16','11:25:00',2.98),('11288','2014-01-16','11:30:00',2.77),('11288','2014-01-16','11:35:00',2.53),('11288','2014-01-16','11:40:00',2.46),('11288','2014-01-16','11:45:00',2.5),('11288','2014-01-16','11:50:00',2.2),('11288','2014-01-16','11:55:00',2.52),('11288','2014-01-16','12:00:00',2.22),('11288','2014-01-16','12:05:00',2.52),('11288','2014-01-16','12:10:00',2.71),('11288','2014-01-16','12:15:00',2.49),('11288','2014-01-16','12:20:00',2.36),('11288','2014-01-16','12:25:00',2.28),('11288','2014-01-16','12:30:00',2.45),('11288','2014-01-16','12:35:00',2.95),('11288','2014-01-16','12:40:00',2.98),('11288','2014-01-16','12:45:00',3.02),('11288','2014-01-16','12:50:00',3.14),('11288','2014-01-16','12:55:00',3.26),('11288','2014-01-16','13:00:00',3.44),('11288','2014-01-16','13:05:00',3.22),('11288','2014-01-16','13:10:00',3),('11288','2014-01-16','13:15:00',2.45),('11288','2014-01-16','13:20:00',2.36),('11288','2014-01-16','13:25:00',2.64),('11288','2014-01-16','13:30:00',2.04),('11288','2014-01-16','13:35:00',1.82),('11288','2014-01-16','13:40:00',2.17),('11288','2014-01-16','13:45:00',3.03),('11288','2014-01-16','13:50:00',2.73),('11288','2014-01-16','13:55:00',3.31),('11288','2014-01-16','14:00:00',1.85),('11288','2014-01-16','14:05:00',1.87),('11288','2014-01-16','14:10:00',1.77),('11288','2014-01-16','14:15:00',1.47),('11288','2014-01-16','14:20:00',1.37),('11288','2014-01-16','14:25:00',1.64),('11288','2014-01-16','14:30:00',1.66),('11288','2014-01-16','14:35:00',1.54),('11288','2014-01-16','14:40:00',1.33),('11288','2014-01-16','14:45:00',1.25),('11288','2014-01-16','14:50:00',1.38),('11288','2014-01-16','14:55:00',1.47),('11288','2014-01-16','15:00:00',1.43),('11288','2014-01-16','15:05:00',1.46),('11288','2014-01-16','15:10:00',1.36),('11288','2014-01-16','15:15:00',1.1),('11288','2014-01-15','09:40:00',1.08),('11288','2014-01-15','09:45:00',1.03),('11288','2014-01-15','10:00:00',1.01),('11288','2014-01-15','10:10:00',1.41),('11288','2014-01-15','10:15:00',2.05),('11288','2014-01-15','10:20:00',2.63),('11288','2014-01-15','10:25:00',2.85),('11288','2014-01-15','10:30:00',2.61),('11288','2014-01-15','10:35:00',2.15),('11288','2014-01-15','10:40:00',2.71),('11288','2014-01-15','10:45:00',2.27),('11288','2014-01-15','10:50:00',1.49),('11288','2014-01-15','10:55:00',1.74),('11288','2014-01-15','11:00:00',2.15),('11288','2014-01-15','11:05:00',2.62),('11288','2014-01-15','11:10:00',3.83),('11288','2014-01-15','11:15:00',3.74),('11288','2014-01-15','11:20:00',3.56),('11288','2014-01-15','11:25:00',3.4),('11288','2014-01-15','11:30:00',2.77),('11288','2014-01-15','11:35:00',1.8),('11288','2014-01-15','11:40:00',2.67),('11288','2014-01-15','11:45:00',3.44),('11288','2014-01-15','11:50:00',3.5),('11288','2014-01-15','11:55:00',3),('11288','2014-01-15','12:00:00',2.92),('11288','2014-01-15','12:05:00',2.63),('11288','2014-01-15','12:10:00',2.56),('11288','2014-01-15','12:15:00',2.93),('11288','2014-01-15','12:20:00',3.59),('11288','2014-01-15','12:25:00',2.95),('11288','2014-01-15','12:30:00',2.24),('11288','2014-01-15','12:35:00',2.53),('11288','2014-01-15','12:40:00',2.2),('11288','2014-01-15','12:45:00',2.34),('11288','2014-01-15','12:50:00',2.37),('11288','2014-01-15','12:55:00',2.13),('11288','2014-01-15','13:00:00',2.06),('11288','2014-01-15','13:05:00',2.19),('11288','2014-01-15','13:10:00',2.91),('11288','2014-01-15','13:15:00',4.18),('11288','2014-01-15','13:20:00',4.2),('11288','2014-01-15','13:25:00',3.95),('11288','2014-01-15','13:30:00',3.79),('11288','2014-01-15','13:35:00',3.49),('11288','2014-01-15','13:40:00',3.33),('11288','2014-01-15','13:45:00',3.32),('11288','2014-01-15','13:50:00',1.81),('11288','2014-01-15','13:55:00',2.21),('11288','2014-01-15','14:00:00',2.99),('11288','2014-01-15','14:05:00',2.94),('11288','2014-01-15','14:10:00',2.87),('11288','2014-01-15','14:15:00',2.73),('11288','2014-01-15','14:20:00',2.72),('11288','2014-01-15','14:25:00',2.64),('11288','2014-01-15','14:30:00',2.54),('11288','2014-01-15','14:35:00',2.46),('11288','2014-01-15','14:40:00',2.5),('11288','2014-01-15','14:45:00',2.45),('11288','2014-01-15','14:50:00',2.24),('11288','2014-01-15','14:55:00',2.14),('11288','2014-01-15','15:00:00',2.09),('11288','2014-01-15','15:05:00',1.97),('11288','2014-01-15','15:10:00',1.88),('11288','2014-01-15','15:15:00',1.71),('11288','2014-01-15','15:25:00',1.4),('11288','2014-01-15','15:30:00',1.34),('11288','2014-01-15','15:35:00',1.24),('11288','2014-01-15','15:40:00',1.1),('11288','2014-01-14','10:15:00',1.06),('11288','2014-01-14','10:20:00',1.56),('11288','2014-01-14','10:25:00',2.58),('11288','2014-01-14','10:30:00',3.78),('11288','2014-01-14','10:35:00',3.78),('11288','2014-01-14','10:40:00',3.54),('11288','2014-01-14','10:45:00',3.4),('11288','2014-01-14','10:50:00',2.3),('11288','2014-01-14','10:55:00',2.1),('11288','2014-01-14','11:00:00',2.5),('11288','2014-01-14','11:05:00',1.99),('11288','2014-01-14','11:10:00',1.32),('11288','2014-01-14','11:15:00',1.48),('11288','2014-01-14','11:20:00',1.72),('11288','2014-01-14','11:25:00',1.26),('11288','2014-01-14','11:30:00',1.91),('11288','2014-01-14','11:35:00',2.05),('11288','2014-01-14','11:40:00',2.27),('11288','2014-01-14','11:45:00',1.67),('11288','2014-01-14','11:50:00',1.63),('11288','2014-01-14','11:55:00',1.57),('11288','2014-01-14','12:00:00',1.27),('11288','2014-01-13','09:05:00',1.58),('11288','2014-01-13','09:10:00',1.8),('11288','2014-01-13','09:15:00',1.78),('11288','2014-01-13','09:20:00',1.79),('11288','2014-01-13','09:25:00',1.81),('11288','2014-01-13','09:30:00',1.86),('11288','2014-01-13','09:35:00',1.94),('11288','2014-01-13','09:40:00',2),('11288','2014-01-13','09:45:00',1.99),('11288','2014-01-13','09:50:00',2.13),('11288','2014-01-13','09:55:00',2.2),('11288','2014-01-13','10:00:00',2.28),('11288','2014-01-13','10:05:00',2.36),('11288','2014-01-13','10:10:00',2.42),('11288','2014-01-13','10:15:00',2.41),('11288','2014-01-13','10:20:00',2.54),('11288','2014-01-13','10:25:00',2.66),('11288','2014-01-13','10:30:00',2.75),('11288','2014-01-13','10:35:00',2.81),('11288','2014-01-13','10:40:00',2.91),('11288','2014-01-13','10:45:00',2.97),('11288','2014-01-13','10:50:00',2.99),('11288','2014-01-13','10:55:00',3.06),('11288','2014-01-13','11:00:00',3.16),('11288','2014-01-13','11:05:00',3.18),('11288','2014-01-13','11:10:00',3.26),('11288','2014-01-13','11:15:00',3.34),('11288','2014-01-13','11:20:00',3.37),('11288','2014-01-13','11:25:00',3.4),('11288','2014-01-13','11:30:00',3.41),('11288','2014-01-13','11:35:00',3.44),('11288','2014-01-13','11:40:00',3.47),('11288','2014-01-13','11:45:00',3.42),('11288','2014-01-13','11:50:00',3.46),('11288','2014-01-13','11:55:00',3.48),('11288','2014-01-13','12:00:00',3.45),('11288','2014-01-13','12:05:00',3.44),('11288','2014-01-13','12:10:00',3.45),('11288','2014-01-13','12:15:00',3.37),('11288','2014-01-13','12:20:00',3.37),('11288','2014-01-13','12:25:00',3.51),('11288','2014-01-13','12:30:00',3.45),('11288','2014-01-13','12:35:00',3.35),('11288','2014-01-13','12:40:00',3.37),('11288','2014-01-13','12:45:00',3.34),('11288','2014-01-13','12:50:00',3.27),('11288','2014-01-13','12:55:00',3.12),('11288','2014-01-13','13:00:00',3.19),('11288','2014-01-13','13:05:00',3.22),('11288','2014-01-13','13:10:00',3.17),('11288','2014-01-13','13:15:00',3.16),('11288','2014-01-13','13:20:00',3.15),('11288','2014-01-13','13:25:00',3.06),('11288','2014-01-13','13:30:00',3.03),('11288','2014-01-13','13:35:00',3),('11288','2014-01-13','13:40:00',2.89),('11288','2014-01-13','13:45:00',2.75),('11288','2014-01-13','13:50:00',2.85),('11288','2014-01-13','13:55:00',2.71),('11288','2014-01-13','14:00:00',2.71),('11288','2014-01-13','14:05:00',2.55),('11288','2014-01-13','14:10:00',2.55),('11288','2014-01-13','14:15:00',2.47),('11288','2014-01-13','14:20:00',2.45),('11288','2014-01-13','14:25:00',2.33),('11288','2014-01-13','14:30:00',2.21),('11288','2014-01-13','14:35:00',2.12),('11288','2014-01-13','14:40:00',2.06),('11288','2014-01-13','14:45:00',1.96),('11288','2014-01-13','14:50:00',1.84),('11288','2014-01-13','14:55:00',1.76),('11288','2014-01-13','15:00:00',1.7),('11288','2014-01-13','15:05:00',1.6),('11288','2014-01-13','15:10:00',1.5),('11288','2014-01-13','15:15:00',1.4),('11288','2014-01-13','15:20:00',1.31),('11288','2014-01-13','15:25:00',1.2),('11288','2014-01-13','15:30:00',1.08),('11288','2014-01-12','09:35:00',1.06),('11288','2014-01-12','09:40:00',1.26),('11288','2014-01-12','09:45:00',1.45),('11288','2014-01-12','09:50:00',1.61),('11288','2014-01-12','09:55:00',1.63),('11288','2014-01-12','10:00:00',1.58),('11288','2014-01-12','10:05:00',1.54),('11288','2014-01-12','10:10:00',1.56),('11288','2014-01-12','10:15:00',1.66),('11288','2014-01-12','10:20:00',1.88),('11288','2014-01-12','10:25:00',1.81),('11288','2014-01-12','10:30:00',1.85),('11288','2014-01-12','10:35:00',2.09),('11288','2014-01-12','10:40:00',2.34),('11288','2014-01-12','10:45:00',2.3),('11288','2014-01-12','10:50:00',2.52),('11288','2014-01-12','10:55:00',2.66),('11288','2014-01-12','11:00:00',2.58),('11288','2014-01-12','11:05:00',2.69),('11288','2014-01-12','11:10:00',3.03),('11288','2014-01-12','11:15:00',2.68),('11288','2014-01-12','11:20:00',2.46),('11288','2014-01-12','11:25:00',2.55),('11288','2014-01-12','11:30:00',2.51),('11288','2014-01-12','11:35:00',2.36),('11288','2014-01-12','11:40:00',2.73),('11288','2014-01-12','11:45:00',3.06),('11288','2014-01-12','11:50:00',3.24),('11288','2014-01-12','11:55:00',2.88),('11288','2014-01-12','12:00:00',2.43),('11288','2014-01-12','12:05:00',2.45),('11288','2014-01-12','12:10:00',2.2),('11288','2014-01-12','12:15:00',2.12),('11288','2014-01-12','12:20:00',2.09),('11288','2014-01-12','12:25:00',2.04),('11288','2014-01-12','12:30:00',2.1),('11288','2014-01-12','12:35:00',2.15),('11288','2014-01-12','12:40:00',2.23),('11288','2014-01-12','12:45:00',2.15),('11288','2014-01-12','12:50:00',2.22),('11288','2014-01-12','12:55:00',2.15),('11288','2014-01-12','13:00:00',2.15),('11288','2014-01-12','13:05:00',2.02),('11288','2014-01-12','13:10:00',1.93),('11288','2014-01-12','13:15:00',1.88),('11288','2014-01-12','13:20:00',1.94),('11288','2014-01-12','13:25:00',2.01),('11288','2014-01-12','13:30:00',2.22),('11288','2014-01-12','13:35:00',2.08),('11288','2014-01-12','13:40:00',1.88),('11288','2014-01-12','13:45:00',1.7),('11288','2014-01-12','13:50:00',1.55),('11288','2014-01-12','13:55:00',1.47),('11288','2014-01-12','14:00:00',1.43),('11288','2014-01-12','14:05:00',1.39),('11288','2014-01-12','14:10:00',1.31),('11288','2014-01-12','14:15:00',1.2),('11288','2014-01-12','14:20:00',1.12),('11288','2014-01-12','14:25:00',1.06),('11288','2014-01-11','09:20:00',1.06),('11288','2014-01-11','09:25:00',1.17),('11288','2014-01-11','09:50:00',1.39),('11288','2014-01-11','09:55:00',1.88),('11288','2014-01-11','10:00:00',1.99),('11288','2014-01-11','10:05:00',1.77),('11288','2014-01-11','10:10:00',1.75),('11288','2014-01-11','10:15:00',1.83),('11288','2014-01-11','10:20:00',1.95),('11288','2014-01-11','10:25:00',2.24),('11288','2014-01-11','10:30:00',2.26),('11288','2014-01-11','10:35:00',2.43),('11288','2014-01-11','10:40:00',3.05),('11288','2014-01-11','10:45:00',3.19),('11288','2014-01-11','10:50:00',3.21),('11288','2014-01-11','10:55:00',3.22),('11288','2014-01-11','11:00:00',3.17),('11288','2014-01-11','11:05:00',3.04),('11288','2014-01-11','11:10:00',3.34),('11288','2014-01-11','11:15:00',2.94),('11288','2014-01-11','11:20:00',2.84),('11288','2014-01-11','11:25:00',2.91),('11288','2014-01-11','11:30:00',2.88),('11288','2014-01-11','11:35:00',2.54),('11288','2014-01-11','11:40:00',2.36),('11288','2014-01-11','11:45:00',2.48),('11288','2014-01-11','11:50:00',2.73),('11288','2014-01-11','11:55:00',2.78),('11288','2014-01-11','12:00:00',2.9),('11288','2014-01-11','12:05:00',3.22),('11288','2014-01-11','12:10:00',2.92),('11288','2014-01-11','12:15:00',2.82),('11288','2014-01-11','12:20:00',2.89),('11288','2014-01-11','12:25:00',2.66),('11288','2014-01-11','12:30:00',2.45),('11288','2014-01-11','12:35:00',2.14),('11288','2014-01-11','12:40:00',2.1),('11288','2014-01-11','12:45:00',2.35),('11288','2014-01-11','12:50:00',2.87),('11288','2014-01-11','12:55:00',2.93),('11288','2014-01-11','13:00:00',2.98),('11288','2014-01-11','13:05:00',2.57),('11288','2014-01-11','13:10:00',2.48),('11288','2014-01-11','13:15:00',3.05),('11288','2014-01-11','13:20:00',2.57),('11288','2014-01-11','13:25:00',2.23),('11288','2014-01-11','13:30:00',1.79),('11288','2014-01-11','13:35:00',1.87),('11288','2014-01-11','13:40:00',1.75),('11288','2014-01-11','13:45:00',1.9),('11288','2014-01-11','13:50:00',1.55),('11288','2014-01-11','13:55:00',1.76),('11288','2014-01-11','14:00:00',2.26),('11288','2014-01-11','14:05:00',2.36),('11288','2014-01-11','14:10:00',1.96),('11288','2014-01-11','14:15:00',1.32),('11288','2014-01-11','14:20:00',1.06),('11288','2014-01-11','14:30:00',1.06),('11288','2014-01-11','14:35:00',1.21),('11288','2014-01-11','14:40:00',1.39),('11288','2014-01-11','14:45:00',1.42),('11288','2014-01-11','14:50:00',1.29),('11288','2014-01-11','14:55:00',1.15),('11288','2014-01-11','15:00:00',1.13),('11288','2014-01-11','15:05:00',1.06),('11288','2014-01-11','15:10:00',1.03),('11288','2014-01-11','15:15:00',1.04),('11288','2014-01-10','09:50:00',1.05),('11288','2014-01-10','09:55:00',1.1),('11288','2014-01-10','10:00:00',1.07),('11288','2014-01-10','10:05:00',1.02),('11288','2014-01-10','10:10:00',1.02),('11288','2014-01-10','10:15:00',1.04),('11288','2014-01-10','10:20:00',1.09),('11288','2014-01-10','10:25:00',1.14),('11288','2014-01-10','10:30:00',1.07),('11288','2014-01-10','10:35:00',1.04),('11288','2014-01-10','10:45:00',1.1),('11288','2014-01-10','10:50:00',1.21),('11288','2014-01-10','10:55:00',1.18),('11288','2014-01-10','11:00:00',1.17),('11288','2014-01-10','11:05:00',1.26),('11288','2014-01-10','11:10:00',1.23),('11288','2014-01-10','11:15:00',1.11),('11288','2014-01-10','11:20:00',1.04),('11288','2014-01-10','11:25:00',1.1),('11288','2014-01-10','11:30:00',1.27),('11288','2014-01-10','11:35:00',1.38),('11288','2014-01-10','11:40:00',1.34),('11288','2014-01-10','11:45:00',1.25),('11288','2014-01-10','11:50:00',1.33),('11288','2014-01-10','11:55:00',1.38),('11288','2014-01-10','12:00:00',1.09),('11288','2014-01-10','12:10:00',1.02),('11288','2014-01-10','12:15:00',1.15),('11288','2014-01-10','12:20:00',1.42),('11288','2014-01-10','12:25:00',1.39),('11288','2014-01-10','12:30:00',1.53),('11288','2014-01-10','12:35:00',1.47),('11288','2014-01-10','12:40:00',1.34),('11288','2014-01-10','12:45:00',1.39),('11288','2014-01-10','12:50:00',1.59),('11288','2014-01-10','12:55:00',1.56),('11288','2014-01-10','13:00:00',1.66),('11288','2014-01-10','13:05:00',1.76),('11288','2014-01-10','13:10:00',1.64),('11288','2014-01-10','13:15:00',1.41),('11288','2014-01-10','13:20:00',1.28),('11288','2014-01-10','13:25:00',1.25),('11288','2014-01-10','13:30:00',1.33),('11288','2014-01-10','13:35:00',1.35),('11288','2014-01-10','13:40:00',1.34),('11288','2014-01-10','13:45:00',1.25),('11288','2014-01-10','13:50:00',1.26),('11288','2014-01-10','13:55:00',1.18),('11288','2014-01-09','09:05:00',1.14),('11288','2014-01-09','09:10:00',1.21),('11288','2014-01-09','09:15:00',1.2),('11288','2014-01-09','09:20:00',1.47),('11288','2014-01-09','09:25:00',1.54),('11288','2014-01-09','09:30:00',1.79),('11288','2014-01-09','09:35:00',1.69),('11288','2014-01-09','09:40:00',2.21),('11288','2014-01-09','09:45:00',2.51),('11288','2014-01-09','09:50:00',2.64),('11288','2014-01-09','09:55:00',2.58),('11288','2014-01-09','10:00:00',2.66),('11288','2014-01-09','10:05:00',2.61),('11288','2014-01-09','10:10:00',2.35),('11288','2014-01-09','10:15:00',2.35),('11288','2014-01-09','10:20:00',2.43),('11288','2014-01-09','10:25:00',2.64),('11288','2014-01-09','10:30:00',2.67),('11288','2014-01-09','10:35:00',2.88),('11288','2014-01-09','10:40:00',3.23),('11288','2014-01-09','10:45:00',2.64),('11288','2014-01-09','10:50:00',2.05),('11288','2014-01-09','10:55:00',2.14),('11288','2014-01-09','11:00:00',2.23),('11288','2014-01-09','11:05:00',2.19),('11288','2014-01-09','11:10:00',1.94),('11288','2014-01-09','11:15:00',2.12),('11288','2014-01-09','11:20:00',2.48),('11288','2014-01-09','11:25:00',2.36),('11288','2014-01-09','11:30:00',2.13),('11288','2014-01-09','11:35:00',2.55),('11288','2014-01-09','11:40:00',2.75),('11288','2014-01-09','11:45:00',1.95),('11288','2014-01-09','12:00:00',1.46),('11288','2014-01-09','12:05:00',1.31),('11288','2014-01-09','12:10:00',1.4),('11288','2014-01-09','12:15:00',1.51),('11288','2014-01-09','12:20:00',1.29),('11288','2014-01-09','12:25:00',1.43),('11288','2014-01-09','12:30:00',1.25),('11288','2014-01-09','12:35:00',1.21),('11288','2014-01-09','12:40:00',1.36),('11288','2014-01-09','12:45:00',1.45),('11288','2014-01-09','12:50:00',1.37),('11288','2014-01-09','12:55:00',1.33),('11288','2014-01-09','13:00:00',1.24),('11288','2014-01-09','13:05:00',1.74),('11288','2014-01-09','13:10:00',1.72),('11288','2014-01-09','13:15:00',1.84),('11288','2014-01-09','13:20:00',1.57),('11288','2014-01-09','13:25:00',1.68),('11288','2014-01-09','13:30:00',1.7),('11288','2014-01-09','13:35:00',1.55),('11288','2014-01-09','13:40:00',1.45),('11288','2014-01-09','13:45:00',1.3),('11288','2014-01-09','13:50:00',1.33),('11288','2014-01-09','13:55:00',1.2),('11288','2014-01-09','14:00:00',1.14),('11288','2014-01-09','14:05:00',1.16),('11288','2014-01-09','14:10:00',1.19),('11288','2014-01-09','14:15:00',1.15),('11288','2014-01-09','14:20:00',1.06),('11288','2014-01-09','14:25:00',1.02),('11288','2014-01-09','14:30:00',1.04),('11288','2014-01-09','14:35:00',1.19),('11288','2014-01-09','14:40:00',1.08),('11288','2014-01-08','08:55:00',1.03),('11288','2014-01-08','09:00:00',1.25),('11288','2014-01-08','09:05:00',1.34),('11288','2014-01-08','09:10:00',1.48),('11288','2014-01-08','09:15:00',1.59),('11288','2014-01-08','09:20:00',1.63),('11288','2014-01-08','09:25:00',1.73),('11288','2014-01-08','09:30:00',1.74),('11288','2014-01-08','09:35:00',1.73),('11288','2014-01-08','09:40:00',1.9),('11288','2014-01-08','09:45:00',2),('11288','2014-01-08','09:50:00',2.03),('11288','2014-01-08','09:55:00',2.13),('11288','2014-01-08','10:00:00',2.25),('11288','2014-01-08','10:05:00',2.17),('11288','2014-01-08','10:10:00',2.17),('11288','2014-01-08','10:15:00',2.29),('11288','2014-01-08','10:20:00',2.57),('11288','2014-01-08','10:25:00',2.75),('11288','2014-01-08','10:30:00',2.83),('11288','2014-01-08','10:35:00',2.75),('11288','2014-01-08','10:40:00',2.72),('11288','2014-01-08','10:45:00',2.94),('11288','2014-01-08','10:50:00',2.91),('11288','2014-01-08','10:55:00',3.13),('11288','2014-01-08','11:00:00',3.2),('11288','2014-01-08','11:05:00',3.26),('11288','2014-01-08','11:10:00',3.35),('11288','2014-01-08','11:15:00',3.39),('11288','2014-01-08','11:20:00',3.39),('11288','2014-01-08','11:25:00',3.42),('11288','2014-01-08','11:30:00',3.36),('11288','2014-01-08','11:35:00',3.32),('11288','2014-01-08','11:40:00',3.12),('11288','2014-01-08','11:45:00',3.58),('11288','2014-01-08','11:50:00',3.55),('11288','2014-01-08','11:55:00',3.52),('11288','2014-01-08','12:00:00',3.52),('11288','2014-01-08','12:05:00',3.49),('11288','2014-01-08','12:10:00',3.41),('11288','2014-01-08','12:15:00',3.45),('11288','2014-01-08','12:20:00',3.47),('11288','2014-01-08','12:25:00',3.5),('11288','2014-01-08','12:30:00',3.42),('11288','2014-01-08','12:35:00',3.46),('11288','2014-01-08','12:40:00',3.35),('11288','2014-01-08','12:45:00',3.2),('11288','2014-01-08','12:50:00',3.25),('11288','2014-01-08','12:55:00',3.3),('11288','2014-01-08','13:00:00',3.3),('11288','2014-01-08','13:05:00',3.28),('11288','2014-01-08','13:10:00',3.2),('11288','2014-01-08','13:15:00',3.1),('11288','2014-01-08','13:20:00',3.05),('11288','2014-01-08','13:25:00',3.06),('11288','2014-01-08','13:30:00',3.03),('11288','2014-01-08','13:35:00',2.98),('11288','2014-01-08','13:40:00',2.88),('11288','2014-01-08','13:45:00',2.81),('11288','2014-01-08','13:50:00',2.8),('11288','2014-01-08','13:55:00',2.73),('11288','2014-01-08','14:00:00',2.64),('11288','2014-01-08','14:05:00',2.62),('11288','2014-01-08','14:10:00',2.51),('11288','2014-01-08','14:15:00',2.42),('11288','2014-01-08','14:20:00',2.46),('11288','2014-01-08','14:25:00',2.38),('11288','2014-01-08','14:30:00',2.32),('11288','2014-01-08','14:35:00',2.24),('11288','2014-01-08','14:40:00',2.01),('11288','2014-01-08','14:45:00',1.88),('11288','2014-01-08','14:50:00',1.77),('11288','2014-01-08','14:55:00',1.49),('11288','2014-01-08','15:00:00',1.45),('11288','2014-01-08','15:05:00',1.31),('11288','2014-01-08','15:10:00',1.09),('11288','2014-01-08','15:15:00',1.21),('11288','2014-01-08','15:20:00',1.35),('11288','2014-01-08','15:25:00',1.14),('11288','2014-01-08','15:30:00',1.01),('11288','2014-01-07','08:50:00',1),('11288','2014-01-07','08:55:00',1.16),('11288','2014-01-07','09:00:00',1.29),('11288','2014-01-07','09:05:00',1.37),('11288','2014-01-07','09:10:00',1.48),('11288','2014-01-07','09:15:00',1.59),('11288','2014-01-07','09:20:00',1.67),('11288','2014-01-07','09:25:00',1.76),('11288','2014-01-07','09:30:00',1.82),('11288','2014-01-07','09:35:00',1.88),('11288','2014-01-07','09:40:00',1.97),('11288','2014-01-07','09:45:00',2.07),('11288','2014-01-07','09:50:00',2.15),('11288','2014-01-07','09:55:00',2.22),('11288','2014-01-07','10:00:00',2.31),('11288','2014-01-07','10:05:00',2.39),('11288','2014-01-07','10:10:00',2.34),('11288','2014-01-07','10:15:00',2.53),('11288','2014-01-07','10:20:00',2.64),('11288','2014-01-07','10:25:00',2.76),('11288','2014-01-07','10:30:00',2.86),('11288','2014-01-07','10:35:00',2.93),('11288','2014-01-07','10:40:00',3.02),('11288','2014-01-07','10:45:00',3.01),('11288','2014-01-07','10:50:00',3.01),('11288','2014-01-07','10:55:00',3.19),('11288','2014-01-07','11:00:00',3.27),('11288','2014-01-07','11:05:00',3.32),('11288','2014-01-07','11:10:00',3.39),('11288','2014-01-07','11:15:00',3.43),('11288','2014-01-07','11:20:00',3.47),('11288','2014-01-07','11:25:00',3.55),('11288','2014-01-07','11:30:00',3.48),('11288','2014-01-07','11:35:00',3.23),('11288','2014-01-07','11:40:00',3.26),('11288','2014-01-07','11:45:00',3.6),('11288','2014-01-07','11:50:00',3.63),('11288','2014-01-07','11:55:00',3.63),('11288','2014-01-07','12:00:00',3.66),('11288','2014-01-07','12:05:00',3.6),('11288','2014-01-07','12:10:00',3.55),('11288','2014-01-07','12:15:00',3.59),('11288','2014-01-07','12:20:00',3.56),('11288','2014-01-07','12:25:00',3.59),('11288','2014-01-07','12:30:00',3.58),('11288','2014-01-07','12:35:00',3.51),('11288','2014-01-07','12:40:00',3.38),('11288','2014-01-07','12:45:00',3.47),('11288','2014-01-07','12:50:00',3.42),('11288','2014-01-07','12:55:00',3.38),('11288','2014-01-07','13:00:00',3.24),('11288','2014-01-07','13:05:00',3.16),('11288','2014-01-07','13:10:00',3.19),('11288','2014-01-07','13:15:00',3.19),('11288','2014-01-07','13:20:00',3.13),('11288','2014-01-07','13:25:00',2.98),('11288','2014-01-07','13:30:00',2.96),('11288','2014-01-07','13:35:00',3.01),('11288','2014-01-07','13:40:00',2.99),('11288','2014-01-07','13:45:00',3.02),('11288','2014-01-07','13:50:00',2.95),('11288','2014-01-07','13:55:00',2.85),('11288','2014-01-07','14:00:00',2.77),('11288','2014-01-07','14:05:00',2.61),('11288','2014-01-07','14:10:00',2.5),('11288','2014-01-07','14:15:00',2.44),('11288','2014-01-07','14:20:00',2.43),('11288','2014-01-07','14:25:00',2.28),('11288','2014-01-07','14:30:00',2.17),('11288','2014-01-07','14:35:00',2.13),('11288','2014-01-07','14:40:00',2.05),('11288','2014-01-07','14:45:00',1.92),('11288','2014-01-07','14:50:00',1.87),('11288','2014-01-07','14:55:00',1.75),('11288','2014-01-07','15:00:00',1.67),('11288','2014-01-07','15:05:00',1.56),('11288','2014-01-07','15:10:00',1.29),('11288','2014-01-07','15:15:00',1.35),('11288','2014-01-07','15:20:00',1.32),('11288','2014-01-07','15:25:00',1.06),('11288','2014-01-07','15:30:00',1.02),('11288','2014-04-24','07:45:00',1.12),('11288','2014-04-24','07:50:00',1.21),('11288','2014-04-24','07:55:00',1.28),('11288','2014-04-24','08:10:00',1.18),('11288','2014-04-24','08:15:00',1.58),('11288','2014-04-24','08:20:00',1.84),('11288','2014-04-24','08:25:00',1.9),('11288','2014-04-24','08:30:00',1.95),('11288','2014-04-24','08:35:00',2.25),('11288','2014-04-24','08:40:00',2.12),('11288','2014-04-24','08:45:00',2.55),('11288','2014-04-24','08:50:00',2.36),('11288','2014-04-24','08:55:00',2.94),('11288','2014-04-24','09:00:00',3.09),('11288','2014-04-24','09:05:00',3.34),('11288','2014-04-24','09:10:00',2.78),('11288','2014-04-24','09:15:00',3.62),('11288','2014-04-24','09:20:00',3.76),('11288','2014-04-24','09:25:00',3.78),('11288','2014-04-24','09:30:00',3.16),('11288','2014-04-24','09:35:00',3.92),('11288','2014-04-24','09:40:00',4.13),('11288','2014-04-24','09:45:00',4.2),('11288','2014-04-24','09:50:00',4.24),('11288','2014-04-24','09:55:00',4.28),('11288','2014-04-24','10:00:00',4.42),('11288','2014-04-24','10:05:00',4.77),('11288','2014-04-24','10:10:00',4.91),('11288','2014-04-24','10:15:00',5.09),('11288','2014-04-24','10:20:00',5.22),('11288','2014-04-24','10:25:00',5.3),('11288','2014-04-24','10:30:00',5.45),('11288','2014-04-24','10:35:00',5.53),('11288','2014-04-24','10:40:00',5.63),('11288','2014-04-24','10:45:00',5.68),('11288','2014-04-24','10:50:00',5.74),('11288','2014-04-24','10:55:00',5.77),('11288','2014-04-24','11:00:00',5.78),('11288','2014-04-24','11:05:00',5.9),('11288','2014-04-24','11:10:00',5.92),('11288','2014-04-24','11:15:00',5.96),('11288','2014-04-24','11:20:00',6.02),('11288','2014-04-24','11:25:00',6.03),('11288','2014-04-24','11:30:00',6.03),('11288','2014-04-24','11:35:00',6.09),('11288','2014-04-24','11:40:00',6.19),('11288','2014-04-24','11:45:00',6.27),('11288','2014-04-24','11:50:00',6.32),('11288','2014-04-24','11:55:00',6.3),('11288','2014-04-24','12:00:00',6.35),('11288','2014-04-24','12:05:00',6.48),('11288','2014-04-24','12:10:00',3.17),('11288','2014-04-24','12:15:00',6.49),('11288','2014-04-24','12:20:00',6.81),('11288','2014-04-24','12:25:00',6.75),('11288','2014-04-24','12:30:00',6.11),('11288','2014-04-24','12:35:00',6.79),('11288','2014-04-24','12:40:00',6.78),('11288','2014-04-24','12:45:00',6.63),('11288','2014-04-24','12:50:00',6.76),('11288','2014-04-24','12:55:00',6.82),('11288','2014-04-24','13:00:00',6.77),('11288','2014-04-24','13:05:00',6.74),('11288','2014-04-24','13:10:00',6.84),('11288','2014-04-24','13:15:00',6.99),('11288','2014-04-24','13:20:00',6.93),('11288','2014-04-24','13:25:00',6.91),('11288','2014-04-24','13:30:00',6.08),('11288','2014-04-24','13:35:00',3.27),('11288','2014-04-24','13:40:00',3.54),('11288','2014-04-24','13:45:00',3.81),('11288','2014-04-24','13:50:00',7.73),('11288','2014-04-24','13:55:00',7.59),('11288','2014-04-24','14:00:00',7.59),('11288','2014-04-24','14:05:00',7.43),('11288','2014-04-24','14:10:00',7.4),('11288','2014-04-24','14:15:00',7.4),('11288','2014-04-24','14:20:00',7.06),('11288','2014-04-24','14:25:00',7.12),('11288','2014-04-24','14:30:00',5.96),('11288','2014-04-24','14:35:00',5.88),('11288','2014-04-24','14:40:00',5.18),('11288','2014-04-24','14:45:00',3.37),('11288','2014-04-24','14:50:00',4.26),('11288','2014-04-24','14:55:00',7.58),('11288','2014-04-24','15:00:00',7.17),('11288','2014-04-24','15:05:00',7.07),('11288','2014-04-24','15:10:00',7.39),('11288','2014-04-24','15:15:00',6.76),('11288','2014-04-24','15:20:00',5.12),('11288','2014-04-24','15:25:00',3.73),('11288','2014-04-24','15:30:00',4.65),('11288','2014-04-24','15:35:00',4.49),('11288','2014-04-24','15:40:00',4.14),('11288','2014-04-24','15:45:00',3.7),('11288','2014-04-24','15:50:00',4.24),('11288','2014-04-24','15:55:00',4.85),('11288','2014-04-24','16:00:00',6.37),('11288','2014-04-24','16:05:00',5.68),('11288','2014-04-24','16:10:00',4.97),('11288','2014-04-24','16:15:00',6.18),('11288','2014-04-24','16:20:00',5.6),('11288','2014-04-24','16:25:00',4.27),('11288','2014-04-24','16:30:00',4.2),('11288','2014-04-24','16:35:00',3.28),('11288','2014-04-24','16:40:00',3.28),('11288','2014-04-24','16:45:00',2.64),('11288','2014-04-24','16:50:00',2.2),('11288','2014-04-24','16:55:00',2.29),('11288','2014-04-24','17:00:00',2.4),('11288','2014-04-24','17:05:00',2.22),('11288','2014-04-24','17:10:00',2.09),('11288','2014-04-24','17:15:00',1.88),('11288','2014-04-24','17:20:00',1.86),('11288','2014-04-24','17:25:00',1.85),('11288','2014-04-24','17:30:00',1.88),('11288','2014-04-24','17:35:00',1.69),('11288','2014-04-24','17:40:00',1.41),('11288','2014-01-06','11:05:00',1.19),('11288','2014-01-06','11:10:00',1.48),('11288','2014-01-06','11:15:00',1.8),('11288','2014-01-06','11:20:00',1.7),('11288','2014-01-06','11:25:00',1.61),('11288','2014-01-06','11:30:00',1.44),('11288','2014-01-06','11:35:00',1.85),('11288','2014-01-06','11:40:00',3.65),('11288','2014-01-06','11:45:00',3.86),('11288','2014-01-06','11:50:00',3.3),('11288','2014-01-06','11:55:00',2.91),('11288','2014-01-06','12:00:00',3.88),('11288','2014-01-06','12:05:00',3.66),('11288','2014-01-06','12:10:00',3.61),('11288','2014-01-06','12:15:00',3.38),('11288','2014-01-06','12:20:00',3.43),('11288','2014-01-06','12:25:00',3.62),('11288','2014-01-06','12:30:00',3.6),('11288','2014-01-06','12:35:00',3.58),('11288','2014-01-06','12:40:00',3.51),('11288','2014-01-06','12:45:00',3.48),('11288','2014-01-06','12:50:00',3.49),('11288','2014-01-06','12:55:00',3.46),('11288','2014-01-06','13:00:00',3.36),('11288','2014-01-06','13:05:00',3.31),('11288','2014-01-06','13:10:00',3.31),('11288','2014-01-06','13:15:00',3.47),('11288','2014-01-06','13:20:00',3.3),('11288','2014-01-06','13:25:00',3.29),('11288','2014-01-06','13:30:00',3.12),('11288','2014-01-06','13:35:00',3.04),('11288','2014-01-06','13:40:00',2.96),('11288','2014-01-06','13:45:00',2.86),('11288','2014-01-06','13:50:00',2.81),('11288','2014-01-06','13:55:00',2.74),('11288','2014-01-06','14:00:00',2.49),('11288','2014-01-06','14:05:00',1.14),('11288','2014-01-06','14:10:00',1.26),('11288','2014-01-06','14:15:00',2.22),('11288','2014-01-06','14:20:00',2.04),('11288','2014-01-06','14:25:00',1.18),('11288','2014-01-06','14:30:00',1.25),('11288','2014-01-06','14:35:00',1.95),('11288','2014-01-06','14:40:00',2.33),('11288','2014-01-06','14:45:00',2.55),('11288','2014-01-06','14:50:00',2.02),('11288','2014-01-06','14:55:00',1.78),('11288','2014-01-06','15:00:00',1.48),('11288','2014-01-06','15:05:00',1.5),('11288','2014-01-06','15:10:00',1.45),('11288','2014-01-06','15:15:00',1.35),('11288','2014-01-06','15:20:00',1.25),('11288','2014-01-06','15:25:00',1.08),('11288','2014-01-06','15:30:00',1.04),('11288','2014-01-05','13:20:00',1.11),('11288','2014-01-05','13:30:00',1.02),('11288','2014-01-05','15:10:00',1.14),('11288','2014-01-05','15:15:00',1.09),('11288','2014-01-04','14:40:00',1.03),('11288','2014-01-04','14:50:00',1),('11288','2014-01-04','14:55:00',1.12),('11288','2014-01-04','15:00:00',1.38),('11288','2014-01-03','09:15:00',1.25),('11288','2014-01-03','09:30:00',1.37),('11288','2014-01-03','09:35:00',2.1),('11288','2014-01-03','09:40:00',2.42),('11288','2014-01-03','09:45:00',2.51),('11288','2014-01-03','09:50:00',1.7),('11288','2014-01-03','09:55:00',1.63),('11288','2014-01-03','10:00:00',2.52),('11288','2014-01-03','10:05:00',1.8),('11288','2014-01-03','10:10:00',2.19),('11288','2014-01-03','10:15:00',2),('11288','2014-01-03','10:20:00',2.25),('11288','2014-01-03','10:25:00',1.5),('11288','2014-01-03','10:30:00',1.49),('11288','2014-01-03','10:35:00',1.59),('11288','2014-01-03','10:40:00',1.71),('11288','2014-01-03','10:45:00',1.99),('11288','2014-01-03','10:50:00',1.91),('11288','2014-01-03','10:55:00',1.55),('11288','2014-01-03','11:00:00',1.35),('11288','2014-01-03','11:05:00',1.5),('11288','2014-01-03','11:10:00',1.39),('11288','2014-01-03','11:15:00',1.38),('11288','2014-01-03','11:20:00',1.53),('11288','2014-01-03','11:25:00',1.59),('11288','2014-01-03','11:30:00',1.79),('11288','2014-01-03','11:35:00',2.03),('11288','2014-01-03','11:40:00',2.24),('11288','2014-01-03','11:45:00',2.34),('11288','2014-01-03','11:50:00',2.2),('11288','2014-01-03','11:55:00',2.22),('11288','2014-01-03','12:00:00',2.76),('11288','2014-01-03','12:05:00',3.17),('11288','2014-01-03','12:10:00',3.77),('11288','2014-01-03','12:15:00',3.55),('11288','2014-01-03','12:20:00',3.91),('11288','2014-01-03','12:25:00',3.59),('11288','2014-01-03','12:30:00',3.37),('11288','2014-01-03','12:35:00',2.62),('11288','2014-01-03','12:40:00',2.7),('11288','2014-01-03','12:45:00',2.7),('11288','2014-01-03','12:50:00',2.43),('11288','2014-01-03','12:55:00',1.97),('11288','2014-01-03','13:00:00',1.92),('11288','2014-01-03','13:05:00',2.68),('11288','2014-01-03','13:10:00',2.33),('11288','2014-01-03','13:15:00',2.02),('11288','2014-01-03','13:20:00',1.67),('11288','2014-01-03','13:25:00',1.69),('11288','2014-01-03','13:30:00',2.15),('11288','2014-01-03','13:35:00',2.44),('11288','2014-01-03','13:40:00',2.05),('11288','2014-01-03','13:45:00',1.85),('11288','2014-01-03','13:50:00',1.49),('11288','2014-01-03','13:55:00',1.26),('11288','2014-01-03','14:00:00',1.08),('11288','2014-01-02','08:50:00',1.03),('11288','2014-01-02','08:55:00',1.01),('11288','2014-01-02','09:00:00',1.23),('11288','2014-01-02','09:05:00',1.34),('11288','2014-01-02','09:10:00',1.45),('11288','2014-01-02','09:15:00',1.56),('11288','2014-01-02','09:20:00',1.64),('11288','2014-01-02','09:25:00',1.72),('11288','2014-01-02','09:30:00',1.77),('11288','2014-01-02','09:35:00',1.81),('11288','2014-01-02','09:40:00',1.92),('11288','2014-01-02','09:45:00',2.04),('11288','2014-01-02','09:50:00',2.11),('11288','2014-01-02','09:55:00',2.2),('11288','2014-01-02','10:00:00',2.26),('11288','2014-01-02','10:05:00',2.32),('11288','2014-01-02','10:10:00',2.29),('11288','2014-01-02','10:15:00',2.46),('11288','2014-01-02','10:20:00',2.62),('11288','2014-01-02','10:25:00',2.74),('11288','2014-01-02','10:30:00',2.76),('11288','2014-01-02','10:35:00',2.83),('11288','2014-01-02','10:40:00',2.88),('11288','2014-01-02','10:45:00',2.93),('11288','2014-01-02','10:50:00',3.08),('11288','2014-01-02','10:55:00',3.27),('11288','2014-01-02','11:00:00',3.32),('11288','2014-01-02','11:05:00',3.3),('11288','2014-01-02','11:10:00',2.12),('11288','2014-01-02','11:15:00',2.05),('11288','2014-01-02','11:20:00',2.29),('11288','2014-01-02','11:25:00',2.56),('11288','2014-01-02','11:30:00',2.76),('11288','2014-01-02','11:35:00',3.43),('11288','2014-01-02','11:40:00',3.08),('11288','2014-01-02','11:45:00',2.68),('11288','2014-01-02','11:50:00',2.21),('11288','2014-01-02','11:55:00',2.11),('11288','2014-01-02','12:00:00',1.92),('11288','2014-01-02','12:05:00',1.98),('11288','2014-01-02','12:10:00',1.86),('11288','2014-01-02','12:15:00',1.69),('11288','2014-01-02','12:20:00',1.57),('11288','2014-01-02','12:25:00',1.63),('11288','2014-01-02','12:30:00',1.48),('11288','2014-01-02','12:35:00',1.32),('11288','2014-01-02','12:40:00',1.43),('11288','2014-01-02','12:45:00',1.69),('11288','2014-01-02','12:50:00',2.46),('11288','2014-01-02','12:55:00',2.45),('11288','2014-01-02','13:00:00',1.59),('11288','2014-01-02','13:05:00',1.74),('11288','2014-01-02','13:10:00',1.83),('11288','2014-01-02','13:15:00',1.34),('11288','2014-01-02','13:20:00',1.12),('11288','2014-01-02','13:25:00',1.42),('11288','2014-01-02','13:30:00',2.38),('11288','2014-01-02','13:35:00',2.84),('11288','2014-01-02','13:40:00',2.68),('11288','2014-01-02','13:45:00',1.59),('11288','2014-01-02','13:50:00',1.37),('11288','2014-01-02','14:15:00',1.06),('11288','2014-01-02','14:20:00',1.18),('11288','2014-01-02','14:25:00',1.13),('11288','2014-01-02','14:30:00',1.01),('11288','2014-01-01','08:50:00',1.09),('11288','2014-01-01','08:55:00',1.26),('11288','2014-01-01','09:00:00',1.43),('11288','2014-01-01','09:05:00',1.9),('11288','2014-01-01','09:10:00',1.63),('11288','2014-01-01','09:15:00',1.31),('11288','2014-01-01','09:20:00',1.2),('11288','2014-01-01','09:25:00',1.28),('11288','2014-01-01','09:30:00',1.63),('11288','2014-01-01','09:35:00',2.34),('11288','2014-01-01','09:40:00',2.01),('11288','2014-01-01','09:45:00',2.46),('11288','2014-01-01','09:50:00',3.02),('11288','2014-01-01','09:55:00',2.64),('11288','2014-01-01','10:00:00',2.05),('11288','2014-01-01','10:05:00',1.82),('11288','2014-01-01','10:10:00',1.59),('11288','2014-01-01','10:15:00',1.41),('11288','2014-01-01','10:20:00',1.38),('11288','2014-01-01','10:25:00',1.35),('11288','2014-01-01','10:30:00',1.33),('11288','2014-01-01','10:35:00',1.28),('11288','2014-01-01','10:40:00',1.3),('11288','2014-01-01','10:45:00',1.36),('11288','2014-01-01','10:50:00',1.49),('11288','2014-01-01','10:55:00',1.63),('11288','2014-01-01','11:00:00',1.62),('11288','2014-01-01','11:05:00',1.55),('11288','2014-01-01','11:10:00',1.54),('11288','2014-01-01','11:15:00',1.61),('11288','2014-01-01','11:20:00',1.69),('11288','2014-01-01','11:25:00',1.74),('11288','2014-01-01','11:30:00',1.75),('11288','2014-01-01','11:35:00',1.71),('11288','2014-01-01','11:40:00',1.68),('11288','2014-01-01','11:45:00',1.69),('11288','2014-01-01','11:50:00',1.67),('11288','2014-01-01','11:55:00',1.73),('11288','2014-01-01','12:00:00',1.86),('11288','2014-01-01','12:05:00',1.97),('11288','2014-01-01','12:10:00',2.06),('11288','2014-01-01','12:15:00',2.11),('11288','2014-01-01','12:20:00',2.17),('11288','2014-01-01','12:25:00',2.16),('11288','2014-01-01','12:30:00',2.14),('11288','2014-01-01','12:35:00',2.17),('11288','2014-01-01','12:40:00',2.03),('11288','2014-01-01','12:45:00',2.08),('11288','2014-01-01','12:50:00',2.09),('11288','2014-01-01','12:55:00',2.07),('11288','2014-01-01','13:00:00',2.02),('11288','2014-01-01','13:05:00',1.9),('11288','2014-01-01','13:10:00',1.83),('11288','2014-01-01','13:15:00',1.82),('11288','2014-01-01','13:20:00',1.97),('11288','2014-01-01','13:25:00',2),('11288','2014-01-01','13:30:00',2.03),('11288','2014-01-01','13:35:00',2.13),('11288','2014-01-01','13:40:00',2.18),('11288','2014-01-01','13:45:00',1.97),('11288','2014-01-01','13:50:00',3.04),('11288','2014-01-01','13:55:00',2.62),('11288','2014-01-01','14:00:00',2.06),('11288','2014-01-01','14:05:00',1.83),('11288','2014-01-01','14:10:00',1.76),('11288','2014-01-01','14:15:00',1.87),('11288','2014-01-01','14:20:00',1.6),('11288','2014-01-01','14:25:00',1.43),('11288','2014-01-01','14:30:00',1.42),('11288','2014-01-01','14:35:00',1.31),('11288','2014-01-01','14:40:00',1.37),('11288','2014-01-01','14:45:00',1.31),('11288','2014-01-01','14:50:00',1.25),('11288','2014-01-01','14:55:00',1.23),('11288','2014-01-01','15:00:00',1.46),('11288','2014-01-01','15:05:00',1.93),('11288','2014-01-01','15:10:00',1.72),('11288','2014-01-01','15:15:00',1.35),('11288','2014-01-01','15:20:00',1.25),('11288','2013-12-31','09:00:00',1.02),('11288','2013-12-31','09:15:00',1.21),('11288','2013-12-31','09:20:00',1.74),('11288','2013-12-31','09:25:00',1.84),('11288','2013-12-31','09:30:00',2.03),('11288','2013-12-31','09:35:00',2.12),('11288','2013-12-31','09:40:00',1.76),('11288','2013-12-31','09:45:00',1.13),('11288','2013-12-31','09:50:00',2.37),('11288','2013-12-31','09:55:00',1.82),('11288','2013-12-31','10:00:00',1.98),('11288','2013-12-31','10:05:00',1.9),('11288','2013-12-31','10:10:00',1.37),('11288','2013-12-31','10:15:00',1.43),('11288','2013-12-31','10:20:00',1.28),('11288','2013-12-31','10:25:00',1.35),('11288','2013-12-31','10:30:00',1.65),('11288','2013-12-31','10:35:00',1.65),('11288','2013-12-31','10:40:00',1.63),('11288','2013-12-31','10:45:00',1.67),('11288','2013-12-31','10:50:00',2.05),('11288','2013-12-31','10:55:00',2.12),('11288','2013-12-31','11:00:00',2.07),('11288','2013-12-31','11:05:00',2.08),('11288','2013-12-31','11:10:00',1.94),('11288','2013-12-31','11:15:00',1.87),('11288','2013-12-31','11:20:00',1.78),('11288','2013-12-31','11:25:00',2.78),('11288','2013-12-31','11:30:00',3.91),('11288','2013-12-31','11:35:00',2.67),('11288','2013-12-31','11:40:00',3.48),('11288','2013-12-31','11:45:00',1.24),('11288','2013-12-31','11:50:00',1.74),('11288','2013-12-31','11:55:00',1.86),('11288','2013-12-31','12:00:00',3.88),('11288','2013-12-31','12:05:00',3.75),('11288','2013-12-31','12:10:00',3.55),('11288','2013-12-31','12:15:00',3.27),('11288','2013-12-31','12:20:00',3.56),('11288','2013-12-31','12:25:00',3.65),('11288','2013-12-31','12:30:00',3.62),('11288','2013-12-31','12:35:00',3.54),('11288','2013-12-31','12:40:00',3.51),('11288','2013-12-31','12:45:00',3.51),('11288','2013-12-31','12:50:00',3.48),('11288','2013-12-31','12:55:00',3.44),('11288','2013-12-31','13:00:00',3.41),('11288','2013-12-31','13:05:00',3.36),('11288','2013-12-31','13:10:00',3.31),('11288','2013-12-31','13:15:00',3.27),('11288','2013-12-31','13:20:00',3.22),('11288','2013-12-31','13:25:00',3.17),('11288','2013-12-31','13:30:00',3.13),('11288','2013-12-31','13:35:00',3.05),('11288','2013-12-31','13:40:00',2.98),('11288','2013-12-31','13:45:00',2.87),('11288','2013-12-31','13:50:00',2.74),('11288','2013-12-31','13:55:00',2.69),('11288','2013-12-31','14:00:00',2.64),('11288','2013-12-31','14:05:00',2.54),('11288','2013-12-31','14:10:00',2.46),('11288','2013-12-31','14:15:00',2.39),('11288','2013-12-31','14:20:00',2.3),('11288','2013-12-31','14:25:00',2.21),('11288','2013-12-31','14:30:00',2.11),('11288','2013-12-31','14:35:00',1.99),('11288','2013-12-31','14:40:00',1.9),('11288','2013-12-31','14:45:00',1.79),('11288','2013-12-31','14:50:00',1.69),('11288','2013-12-31','14:55:00',1.59),('11288','2013-12-31','15:00:00',1.51),('11288','2013-12-31','15:05:00',1.39),('11288','2013-12-31','15:10:00',1.29),('11288','2013-12-31','15:15:00',1.18),('11288','2013-12-31','15:20:00',1.07),('11288','2013-12-30','09:15:00',1.02),('11288','2013-12-30','09:20:00',1.12),('11288','2013-12-30','09:25:00',1.24),('11288','2013-12-30','09:30:00',1.18),('11288','2013-12-30','11:10:00',1.15),('11288','2013-12-30','11:15:00',1.41),('11288','2013-12-30','11:20:00',1.71),('11288','2013-12-30','11:25:00',1.86),('11288','2013-12-30','11:30:00',1.85),('11288','2013-12-30','11:35:00',1.76),('11288','2013-12-30','11:40:00',1.65),('11288','2013-12-30','11:45:00',1.58),('11288','2013-12-30','11:50:00',1.53),('11288','2013-12-30','11:55:00',1.37),('11288','2013-12-30','12:00:00',1.24),('11288','2013-12-30','12:05:00',1.24),('11288','2013-12-30','12:10:00',1.29),('11288','2013-12-30','12:15:00',1.29),('11288','2013-12-30','12:20:00',1.25),('11288','2013-12-30','12:25:00',1.29),('11288','2013-12-30','12:30:00',1.29),('11288','2013-12-30','12:35:00',1.28),('11288','2013-12-30','12:40:00',1.35),('11288','2013-12-30','12:45:00',1.46),('11288','2013-12-30','12:50:00',1.43),('11288','2013-12-30','12:55:00',1.3),('11288','2013-12-30','13:00:00',1.19),('11288','2013-12-30','13:05:00',1.22),('11288','2013-12-30','13:10:00',1.3),('11288','2013-12-30','13:15:00',1.23),('11288','2013-12-30','13:20:00',1.19),('11288','2013-12-30','13:25:00',1.24),('11288','2013-12-30','13:30:00',1.24),('11288','2013-12-30','13:35:00',1.22),('11288','2013-12-30','13:40:00',1.16),('11288','2013-12-30','13:45:00',1.13),('11288','2013-12-30','13:50:00',1.03),('11288','2013-12-29','08:25:00',1.03),('11288','2013-12-29','08:35:00',1.24),('11288','2013-12-29','08:40:00',1.01),('11288','2013-12-29','09:05:00',1.2),('11288','2013-12-29','09:10:00',1.43),('11288','2013-12-29','09:15:00',1.8),('11288','2013-12-29','09:20:00',1.88),('11288','2013-12-29','09:25:00',1.86),('11288','2013-12-29','09:30:00',1.9),('11288','2013-12-29','09:35:00',1.94),('11288','2013-12-29','09:40:00',2.07),('11288','2013-12-29','09:45:00',2.18),('11288','2013-12-29','09:50:00',2.06),('11288','2013-12-29','09:55:00',1.93),('11288','2013-12-29','10:00:00',1.95),('11288','2013-12-29','10:05:00',2.17),('11288','2013-12-29','10:10:00',2.5),('11288','2013-12-29','10:15:00',2.69),('11288','2013-12-29','10:20:00',2.95),('11288','2013-12-29','10:25:00',2.94),('11288','2013-12-29','10:30:00',3.62),('11288','2013-12-29','10:35:00',4.11),('11288','2013-12-29','10:40:00',2.66),('11288','2013-12-29','10:45:00',2.21),('11288','2013-12-29','10:50:00',1.65),('11288','2013-12-29','10:55:00',2.19),('11288','2013-12-29','11:00:00',1.3),('11288','2013-12-29','11:05:00',1.5),('11288','2013-12-29','11:10:00',1.26),('11288','2013-12-29','11:15:00',1.28),('11288','2013-12-29','11:30:00',1.14),('11288','2013-12-29','11:35:00',1.09),('11288','2013-12-29','11:50:00',1.08),('11288','2013-12-29','11:55:00',1.38),('11288','2013-12-29','12:00:00',1.36),('11288','2013-12-29','12:05:00',1.26),('11288','2013-12-29','12:10:00',1.14),('11288','2013-12-29','13:35:00',1.15),('11288','2013-12-29','13:40:00',1.18),('11288','2013-12-28','08:50:00',1.05),('11288','2013-12-28','08:55:00',1.12),('11288','2013-12-28','09:00:00',1.27),('11288','2013-12-28','09:05:00',1.37),('11288','2013-12-28','09:10:00',1.47),('11288','2013-12-28','09:15:00',1.56),('11288','2013-12-28','09:20:00',1.69),('11288','2013-12-28','09:25:00',1.79),('11288','2013-12-28','09:30:00',1.83),('11288','2013-12-28','09:35:00',1.92),('11288','2013-12-28','09:40:00',1.98),('11288','2013-12-28','09:45:00',2.08),('11288','2013-12-28','09:50:00',2.16),('11288','2013-12-28','09:55:00',2.23),('11288','2013-12-28','10:00:00',2.31),('11288','2013-12-28','10:05:00',2.32),('11288','2013-12-28','10:10:00',2.23),('11288','2013-12-28','10:15:00',2.57),('11288','2013-12-28','10:20:00',2.68),('11288','2013-12-28','10:25:00',2.78),('11288','2013-12-28','10:30:00',2.84),('11288','2013-12-28','10:35:00',2.91),('11288','2013-12-28','10:40:00',2.89),('11288','2013-12-28','10:45:00',3.04),('11288','2013-12-28','10:50:00',3.1),('11288','2013-12-28','10:55:00',3.18),('11288','2013-12-28','11:00:00',3.24),('11288','2013-12-28','11:05:00',3.33),('11288','2013-12-28','11:10:00',3.36),('11288','2013-12-28','11:15:00',3.4),('11288','2013-12-28','11:20:00',3.46),('11288','2013-12-28','11:25:00',3.37),('11288','2013-12-28','11:30:00',3.46),('11288','2013-12-28','11:35:00',3.48),('11288','2013-12-28','11:40:00',3.52),('11288','2013-12-28','11:45:00',3.54),('11288','2013-12-28','11:50:00',3.54),('11288','2013-12-28','11:55:00',3.53),('11288','2013-12-28','12:00:00',3.55),('11288','2013-12-28','12:05:00',3.51),('11288','2013-12-28','12:10:00',3.29),('11288','2013-12-28','12:15:00',3.49),('11288','2013-12-28','12:20:00',3.47),('11288','2013-12-28','12:25:00',3.44),('11288','2013-12-28','12:30:00',3.43),('11288','2013-12-28','12:35:00',3.4),('11288','2013-12-28','12:40:00',3.37),('11288','2013-12-28','12:45:00',3.38),('11288','2013-12-28','12:50:00',3.32),('11288','2013-12-28','12:55:00',3.29),('11288','2013-12-28','13:00:00',3.2),('11288','2013-12-28','13:05:00',3.16),('11288','2013-12-28','13:10:00',3.11),('11288','2013-12-28','13:15:00',3.07),('11288','2013-12-28','13:20:00',3.02),('11288','2013-12-28','13:25:00',2.88),('11288','2013-12-28','13:30:00',2.81),('11288','2013-12-28','13:35:00',2.79),('11288','2013-12-28','13:40:00',2.71),('11288','2013-12-28','13:45:00',2.59),('11288','2013-12-28','13:50:00',2.54),('11288','2013-12-28','13:55:00',2.48),('11288','2013-12-28','14:00:00',2.38),('11288','2013-12-28','14:05:00',2.32),('11288','2013-12-28','14:10:00',2.22),('11288','2013-12-28','14:15:00',2.09),('11288','2013-12-28','14:20:00',2),('11288','2013-12-28','14:25:00',2.02),('11288','2013-12-28','14:30:00',1.93),('11288','2013-12-28','14:35:00',1.85),('11288','2013-12-28','14:40:00',1.82),('11288','2013-12-28','14:45:00',1.47),('11288','2013-12-28','14:50:00',1.16),('11288','2013-12-28','15:00:00',1.2),('11288','2013-12-28','15:05:00',1.34),('11288','2013-12-28','15:10:00',1.08),('11288','2013-12-28','15:15:00',1.08),('11288','2014-04-23','10:40:00',1.12),('11288','2014-04-23','10:45:00',1.08),('11288','2014-04-23','10:50:00',1.02),('11288','2014-04-23','11:15:00',1.08),('11288','2014-04-23','11:20:00',1.01),('11288','2014-04-23','11:35:00',1.09),('11288','2014-04-23','11:40:00',1.19),('11288','2014-04-23','11:45:00',1.25),('11288','2014-04-23','11:50:00',1.01),('11288','2014-04-23','12:50:00',1.02),('11288','2014-04-23','12:55:00',1.09),('11288','2014-04-23','13:00:00',1.2),('11288','2014-04-23','13:05:00',1.44),('11288','2014-04-23','13:10:00',1.82),('11288','2014-04-23','13:15:00',2.12),('11288','2014-04-23','13:20:00',2.37),('11288','2014-04-23','13:25:00',2.44),('11288','2014-04-23','13:30:00',2.59),('11288','2014-04-23','13:35:00',2.68),('11288','2014-04-23','13:40:00',2.82),('11288','2014-04-23','13:45:00',2.84),('11288','2014-04-23','13:50:00',2.82),('11288','2014-04-23','13:55:00',2.83),('11288','2014-04-23','14:00:00',2.69),('11288','2014-04-23','14:05:00',2.7),('11288','2014-04-23','14:10:00',2.58),('11288','2014-04-23','14:15:00',2.15),('11288','2014-04-23','14:20:00',1.87),('11288','2014-04-23','14:25:00',1.69),('11288','2014-04-23','14:30:00',1.6),('11288','2014-04-23','14:35:00',1.53),('11288','2014-04-23','14:40:00',1.59),('11288','2014-04-23','14:45:00',1.86),('11288','2014-04-23','14:50:00',2.22),('11288','2014-04-23','14:55:00',2.57),('11288','2014-04-23','15:00:00',2.87),('11288','2014-04-23','15:05:00',3),('11288','2014-04-23','15:10:00',2.94),('11288','2014-04-23','15:15:00',3.17),('11288','2014-04-23','15:20:00',2.67),('11288','2014-04-23','15:25:00',2.4),('11288','2014-04-23','15:30:00',2.26),('11288','2014-04-23','15:35:00',2.18),('11288','2014-04-23','15:40:00',2.14),('11288','2014-04-23','15:45:00',2.23),('11288','2014-04-23','15:50:00',2.02),('11288','2014-04-23','15:55:00',1.79),('11288','2014-04-23','16:00:00',1.51),('11288','2014-04-23','16:05:00',1.44),('11288','2014-04-23','16:10:00',1.26),('11288','2014-04-23','16:15:00',1.09),('11288','2013-12-27','10:20:00',1.09),('11288','2013-12-27','10:25:00',1.28),('11288','2013-12-27','10:30:00',1.38),('11288','2013-12-27','10:35:00',1.39),('11288','2013-12-27','10:40:00',1.38),('11288','2013-12-27','10:45:00',1.32),('11288','2013-12-27','10:50:00',1.19),('11288','2013-12-27','10:55:00',1.04),('11288','2013-12-27','11:25:00',1.2),('11288','2013-12-27','11:30:00',1.44),('11288','2013-12-27','11:35:00',1.53),('11288','2013-12-27','11:40:00',1.47),('11288','2013-12-27','11:45:00',1.52),('11288','2013-12-27','11:50:00',1.42),('11288','2013-12-27','11:55:00',1.26),('11288','2013-12-27','12:00:00',1.34),('11288','2013-12-27','12:05:00',1.83),('11288','2013-12-27','12:10:00',2.88),('11288','2013-12-27','12:15:00',2.54),('11288','2013-12-27','12:20:00',2.92),('11288','2013-12-27','12:25:00',2.13),('11288','2013-12-27','12:30:00',1.77),('11288','2013-12-27','12:35:00',1.91),('11288','2013-12-27','12:40:00',2.07),('11288','2013-12-27','12:45:00',2.47),('11288','2013-12-27','12:50:00',3.19),('11288','2013-12-27','12:55:00',3.24),('11288','2013-12-27','13:00:00',3.24),('11288','2013-12-27','13:05:00',2.86),('11288','2013-12-27','13:10:00',1.95),('11288','2013-12-27','13:15:00',1.92),('11288','2013-12-27','13:20:00',2.72),('11288','2013-12-27','13:25:00',2.52),('11288','2013-12-27','13:30:00',3.56),('11288','2013-12-27','13:35:00',3.14),('11288','2013-12-27','13:40:00',2.22),('11288','2013-12-27','13:45:00',1.95),('11288','2013-12-27','13:50:00',1.7),('11288','2013-12-27','13:55:00',1.42),('11288','2013-12-27','14:00:00',1.44),('11288','2013-12-27','14:05:00',1.55),('11288','2013-12-27','14:10:00',1.74),('11288','2013-12-27','14:15:00',1.79),('11288','2013-12-27','14:20:00',1.72),('11288','2013-12-27','14:25:00',1.69),('11288','2013-12-27','14:30:00',1.8),('11288','2013-12-27','14:35:00',1.88),('11288','2013-12-27','14:40:00',1.88),('11288','2013-12-27','14:45:00',1.41),('11288','2013-12-26','09:55:00',1.14),('11288','2013-12-26','11:05:00',1.14),('11288','2013-12-25','09:10:00',1.02),('11288','2013-12-25','09:15:00',1.26),('11288','2013-12-25','09:20:00',1.1),('11288','2013-12-25','09:25:00',1.72),('11288','2013-12-25','09:30:00',1.2),('11288','2013-12-25','09:35:00',1.17),('11288','2013-12-25','09:40:00',1),('11288','2013-12-25','10:25:00',1.66),('11288','2013-12-25','10:30:00',2.34),('11288','2013-12-25','10:35:00',2.37),('11288','2013-12-25','10:40:00',2.1),('11288','2013-12-25','10:45:00',2.36),('11288','2013-12-25','10:50:00',2.13),('11288','2013-12-25','10:55:00',1.63),('11288','2013-12-25','11:00:00',1.45),('11288','2013-12-25','11:05:00',1.63),('11288','2013-12-25','11:10:00',1.63),('11288','2013-12-25','11:15:00',2.12),('11288','2013-12-25','11:20:00',2.94),('11288','2013-12-25','11:25:00',2),('11288','2013-12-25','11:30:00',2.77),('11288','2013-12-25','11:35:00',1.67),('11288','2013-12-25','11:40:00',2.47),('11288','2013-12-25','11:45:00',2.61),('11288','2013-12-25','11:50:00',2.15),('11288','2013-12-25','11:55:00',3.2),('11288','2013-12-25','12:00:00',2.26),('11288','2013-12-25','12:05:00',2.25),('11288','2013-12-25','12:10:00',2.14),('11288','2013-12-25','12:15:00',1.9),('11288','2013-12-25','12:20:00',2.22),('11288','2013-12-25','12:25:00',2.57),('11288','2013-12-25','12:30:00',2.21),('11288','2013-12-25','12:35:00',1.66),('11288','2013-12-25','12:40:00',1.54),('11288','2013-12-25','12:45:00',1.75),('11288','2013-12-25','12:50:00',2.06),('11288','2013-12-25','12:55:00',1.25),('11288','2013-12-25','13:00:00',1.09),('11288','2013-12-25','13:05:00',1.71),('11288','2013-12-25','13:10:00',1.57),('11288','2013-12-25','13:25:00',1.83),('11288','2013-12-25','13:30:00',1.71),('11288','2013-12-25','13:35:00',1.68),('11288','2013-12-25','13:40:00',1.72),('11288','2013-12-25','13:45:00',1.92),('11288','2013-12-25','13:50:00',2.07),('11288','2013-12-25','13:55:00',1.84),('11288','2013-12-25','14:00:00',1.49),('11288','2013-12-25','14:05:00',1.41),('11288','2013-12-25','14:10:00',1.31),('11288','2013-12-25','14:15:00',1.26),('11288','2013-12-25','14:20:00',1.16),('11288','2013-12-25','14:25:00',1.1),('11288','2013-12-25','14:30:00',1.1),('11288','2013-12-25','14:35:00',1.12),('11288','2013-12-25','14:40:00',1.08),('11288','2013-12-25','14:45:00',1.08),('11288','2013-12-25','14:50:00',1.09),('11288','2013-12-25','14:55:00',1),('11288','2013-12-25','15:15:00',1.12),('11288','2013-12-25','15:20:00',1.03),('11288','2013-12-24','08:55:00',1.03),('11288','2013-12-24','09:00:00',1.22),('11288','2013-12-24','09:05:00',1.33),('11288','2013-12-24','09:10:00',1.43),('11288','2013-12-24','09:15:00',1.53),('11288','2013-12-24','09:20:00',1.62),('11288','2013-12-24','09:25:00',1.67),('11288','2013-12-24','09:30:00',1.74),('11288','2013-12-24','09:35:00',1.81),('11288','2013-12-24','09:40:00',1.94),('11288','2013-12-24','09:45:00',1.99),('11288','2013-12-24','09:50:00',1.98),('11288','2013-12-24','09:55:00',2.03),('11288','2013-12-24','10:00:00',2.09),('11288','2013-12-24','10:05:00',2.16),('11288','2013-12-24','10:10:00',2.12),('11288','2013-12-24','10:15:00',2.43),('11288','2013-12-24','10:20:00',2.59),('11288','2013-12-24','10:25:00',2.64),('11288','2013-12-24','10:30:00',2.68),('11288','2013-12-24','10:35:00',2.73),('11288','2013-12-24','10:40:00',2.66),('11288','2013-12-24','10:45:00',2.84),('11288','2013-12-24','10:50:00',2.9),('11288','2013-12-24','10:55:00',2.94),('11288','2013-12-24','11:00:00',3),('11288','2013-12-24','11:05:00',3.05),('11288','2013-12-24','11:10:00',3.06),('11288','2013-12-24','11:15:00',3.05),('11288','2013-12-24','11:20:00',3.12),('11288','2013-12-24','11:25:00',3.01),('11288','2013-12-24','11:30:00',3.14),('11288','2013-12-24','11:35:00',3.23),('11288','2013-12-24','11:40:00',3.21),('11288','2013-12-24','11:45:00',3.23),('11288','2013-12-24','11:50:00',3.29),('11288','2013-12-24','11:55:00',3.27),('11288','2013-12-24','12:00:00',3.24),('11288','2013-12-24','12:05:00',3.16),('11288','2013-12-24','12:10:00',2.99),('11288','2013-12-24','12:15:00',2.97),('11288','2013-12-24','12:20:00',3.21),('11288','2013-12-24','12:25:00',3.2),('11288','2013-12-24','12:30:00',3.13),('11288','2013-12-24','12:35:00',3.04),('11288','2013-12-24','12:40:00',2.99),('11288','2013-12-24','12:45:00',2.99),('11288','2013-12-24','12:50:00',2.99),('11288','2013-12-24','12:55:00',2.95),('11288','2013-12-24','13:00:00',2.86),('11288','2013-12-24','13:05:00',2.88),('11288','2013-12-24','13:10:00',2.86),('11288','2013-12-24','13:15:00',2.8),('11288','2013-12-24','13:20:00',2.7),('11288','2013-12-24','13:25:00',2.63),('11288','2013-12-24','13:30:00',2.6),('11288','2013-12-24','13:35:00',2.53),('11288','2013-12-24','13:40:00',2.43),('11288','2013-12-24','13:45:00',2.34),('11288','2013-12-24','13:50:00',2.26),('11288','2013-12-24','13:55:00',2.18),('11288','2013-12-24','14:00:00',2.1),('11288','2013-12-24','14:05:00',2.06),('11288','2013-12-24','14:10:00',1.99),('11288','2013-12-24','14:15:00',1.93),('11288','2013-12-24','14:20:00',1.86),('11288','2013-12-24','14:25:00',1.74),('11288','2013-12-24','14:30:00',1.62),('11288','2013-12-24','14:35:00',1.51),('11288','2013-12-24','14:40:00',1.37),('11288','2013-12-24','14:45:00',1.23),('11288','2013-12-24','14:50:00',1.18),('11288','2013-12-24','14:55:00',1.1),('11288','2013-12-23','09:15:00',1.08),('11288','2013-12-23','09:20:00',1.2),('11288','2013-12-23','09:25:00',1.35),('11288','2013-12-23','09:30:00',1.44),('11288','2013-12-23','09:35:00',1.53),('11288','2013-12-23','09:40:00',1.53),('11288','2013-12-23','09:45:00',1.56),('11288','2013-12-23','09:50:00',1.82),('11288','2013-12-23','09:55:00',2.12),('11288','2013-12-23','10:00:00',2.51),('11288','2013-12-23','10:05:00',2.63),('11288','2013-12-23','10:10:00',2.53),('11288','2013-12-23','10:15:00',2.69),('11288','2013-12-23','10:20:00',2.74),('11288','2013-12-23','10:25:00',2.68),('11288','2013-12-23','10:30:00',2.62),('11288','2013-12-23','10:35:00',2.68),('11288','2013-12-23','10:40:00',2.76),('11288','2013-12-23','10:45:00',2.85),('11288','2013-12-23','10:50:00',2.94),('11288','2013-12-23','10:55:00',3.25),('11288','2013-12-23','11:00:00',3.52),('11288','2013-12-23','11:05:00',3.54),('11288','2013-12-23','11:10:00',3.61),('11288','2013-12-23','11:15:00',3.5),('11288','2013-12-23','11:20:00',3.51),('11288','2013-12-23','11:25:00',3.27),('11288','2013-12-23','11:30:00',3.51),('11288','2013-12-23','11:35:00',3.62),('11288','2013-12-23','11:40:00',3.27),('11288','2013-12-23','11:45:00',3.07),('11288','2013-12-23','11:50:00',3.25),('11288','2013-12-23','11:55:00',3.32),('11288','2013-12-23','12:00:00',3.47),('11288','2013-12-23','12:05:00',3.33),('11288','2013-12-23','12:10:00',3.2),('11288','2013-12-23','12:15:00',3.37),('11288','2013-12-23','12:20:00',3.32),('11288','2013-12-23','12:25:00',3.27),('11288','2013-12-23','12:30:00',3.21),('11288','2013-12-23','12:35:00',3.19),('11288','2013-12-23','12:40:00',3.34),('11288','2013-12-23','12:45:00',3.33),('11288','2013-12-23','12:50:00',3.3),('11288','2013-12-23','12:55:00',3.26),('11288','2013-12-23','13:00:00',3.2),('11288','2013-12-23','13:05:00',3.19),('11288','2013-12-23','13:10:00',3.1),('11288','2013-12-23','13:15:00',3.01),('11288','2013-12-23','13:20:00',2.42),('11288','2013-12-23','13:25:00',2.8),('11288','2013-12-23','13:30:00',2.35),('11288','2013-12-23','13:35:00',1.29),('11288','2013-12-23','13:40:00',2.32),('11288','2013-12-23','13:45:00',1.6),('11288','2013-12-23','13:50:00',2.19),('11288','2013-12-23','13:55:00',2.32),('11288','2013-12-23','14:00:00',2.46),('11288','2013-12-23','14:05:00',2.4),('11288','2013-12-23','14:10:00',2.28),('11288','2013-12-23','14:15:00',2.14),('11288','2013-12-23','14:20:00',2.1),('11288','2013-12-23','14:25:00',2),('11288','2013-12-23','14:30:00',1.78),('11288','2013-12-23','14:35:00',1.85),('11288','2013-12-23','14:40:00',1.7),('11288','2013-12-23','14:45:00',1.59),('11288','2013-12-23','14:50:00',1.51),('11288','2013-12-23','14:55:00',1.42),('11288','2013-12-23','15:00:00',1.31),('11288','2013-12-23','15:05:00',1.19),('11288','2013-12-23','15:10:00',1.09),('11288','2013-12-22','09:00:00',1.19),('11288','2013-12-22','09:05:00',1.44),('11288','2013-12-22','09:10:00',1.4),('11288','2013-12-22','09:15:00',1.54),('11288','2013-12-22','09:20:00',1.74),('11288','2013-12-22','09:25:00',1.72),('11288','2013-12-22','09:30:00',1.82),('11288','2013-12-22','09:35:00',2.45),('11288','2013-12-22','09:40:00',2.76),('11288','2013-12-22','09:45:00',2.87),('11288','2013-12-22','09:50:00',3),('11288','2013-12-22','09:55:00',2.95),('11288','2013-12-22','10:00:00',2.92),('11288','2013-12-22','10:05:00',2.86),('11288','2013-12-22','10:10:00',2.97),('11288','2013-12-22','10:15:00',2.98),('11288','2013-12-22','10:20:00',2.97),('11288','2013-12-22','10:25:00',3.01),('11288','2013-12-22','10:30:00',3.15),('11288','2013-12-22','10:35:00',2.91),('11288','2013-12-22','10:40:00',2.77),('11288','2013-12-22','10:45:00',3.06),('11288','2013-12-22','10:50:00',3.01),('11288','2013-12-22','10:55:00',2.85),('11288','2013-12-22','11:00:00',2.63),('11288','2013-12-22','11:05:00',2.93),('11288','2013-12-22','11:10:00',3.58),('11288','2013-12-22','11:15:00',3.43),('11288','2013-12-22','11:20:00',3.14),('11288','2013-12-22','11:25:00',3.16),('11288','2013-12-22','11:30:00',2.97),('11288','2013-12-22','11:35:00',3.06),('11288','2013-12-22','11:40:00',3.21),('11288','2013-12-22','11:45:00',2.92),('11288','2013-12-22','11:50:00',2.23),('11288','2013-12-22','11:55:00',1.7),('11288','2013-12-22','12:00:00',1.36),('11288','2013-12-22','12:05:00',1.29),('11288','2013-12-22','12:10:00',1.35),('11288','2013-12-22','12:15:00',1.5),('11288','2013-12-22','12:20:00',1.88),('11288','2013-12-22','12:25:00',2.05),('11288','2013-12-22','12:30:00',2.45),('11288','2013-12-22','12:35:00',2.67),('11288','2013-12-22','12:40:00',2.59),('11288','2013-12-22','12:45:00',2.65),('11288','2013-12-22','12:50:00',3.12),('11288','2013-12-22','12:55:00',3.67),('11288','2013-12-22','13:00:00',3.5),('11288','2013-12-22','13:05:00',4.11),('11288','2013-12-22','13:10:00',3.98),('11288','2013-12-22','13:15:00',3.09),('11288','2013-12-22','13:20:00',2.93),('11288','2013-12-22','13:25:00',2.91),('11288','2013-12-22','13:30:00',2.69),('11288','2013-12-22','13:35:00',2.51),('11288','2013-12-22','13:40:00',2.04),('11288','2013-12-22','13:45:00',2.3),('11288','2013-12-22','13:50:00',1.98),('11288','2013-12-22','13:55:00',1.89),('11288','2013-12-22','14:00:00',1.63),('11288','2013-12-22','14:05:00',1.97),('11288','2013-12-22','14:10:00',2.02),('11288','2013-12-22','14:15:00',1.6),('11288','2013-12-22','14:20:00',1.67),('11288','2013-12-22','14:25:00',1.37),('11288','2013-12-22','14:30:00',1.38),('11288','2013-12-22','14:35:00',1.65),('11288','2013-12-22','14:40:00',1.65),('11288','2013-12-22','14:45:00',1.56),('11288','2013-12-22','14:50:00',1.1),('11288','2013-12-22','14:55:00',1.03),('11288','2013-12-22','15:00:00',1.05),('11288','2013-12-22','15:05:00',1),('11288','2013-12-22','15:10:00',1),('11288','2013-12-21','08:50:00',1),('11288','2013-12-21','08:55:00',1.17),('11288','2013-12-21','09:00:00',1.27),('11288','2013-12-21','09:05:00',1.36),('11288','2013-12-21','09:10:00',1.44),('11288','2013-12-21','09:15:00',1.55),('11288','2013-12-21','09:20:00',1.67),('11288','2013-12-21','09:25:00',1.75),('11288','2013-12-21','09:30:00',1.83),('11288','2013-12-21','09:35:00',1.9),('11288','2013-12-21','09:40:00',1.95),('11288','2013-12-21','09:45:00',2.03),('11288','2013-12-21','09:50:00',2.09),('11288','2013-12-21','09:55:00',2.17),('11288','2013-12-21','10:00:00',2.2),('11288','2013-12-21','10:05:00',2.13),('11288','2013-12-21','10:10:00',2.39),('11288','2013-12-21','10:15:00',2.54),('11288','2013-12-21','10:20:00',2.64),('11288','2013-12-21','10:25:00',2.68),('11288','2013-12-21','10:30:00',2.76),('11288','2013-12-21','10:35:00',2.81),('11288','2013-12-21','10:40:00',2.9),('11288','2013-12-21','10:45:00',2.98),('11288','2013-12-21','10:50:00',3.03),('11288','2013-12-21','10:55:00',3.09),('11288','2013-12-21','11:00:00',3.17),('11288','2013-12-21','11:05:00',3.24),('11288','2013-12-21','11:10:00',3.27),('11288','2013-12-21','11:15:00',3.32),('11288','2013-12-21','11:20:00',3.31),('11288','2013-12-21','11:25:00',3.33),('11288','2013-12-21','11:30:00',3.4),('11288','2013-12-21','11:35:00',3.41),('11288','2013-12-21','11:40:00',3.45),('11288','2013-12-21','11:45:00',3.49),('11288','2013-12-21','11:50:00',3.5),('11288','2013-12-21','11:55:00',3.52),('11288','2013-12-21','12:00:00',3.48),('11288','2013-12-21','12:05:00',3.33),('11288','2013-12-21','12:10:00',3.4),('11288','2013-12-21','12:15:00',3.5),('11288','2013-12-21','12:20:00',3.48),('11288','2013-12-21','12:25:00',3.47),('11288','2013-12-21','12:30:00',3.44),('11288','2013-12-21','12:35:00',3.4),('11288','2013-12-21','12:40:00',3.39),('11288','2013-12-21','12:45:00',3.36),('11288','2013-12-21','12:50:00',3.35),('11288','2013-12-21','12:55:00',3.32),('11288','2013-12-21','13:00:00',3.24),('11288','2013-12-21','13:05:00',3.18),('11288','2013-12-21','13:10:00',3.15),('11288','2013-12-21','13:15:00',3.09),('11288','2013-12-21','13:20:00',3.01),('11288','2013-12-21','13:25:00',2.95),('11288','2013-12-21','13:30:00',2.89),('11288','2013-12-21','13:35:00',2.81),('11288','2013-12-21','13:40:00',2.72),('11288','2013-12-21','13:45:00',2.63),('11288','2013-12-21','13:50:00',2.55),('11288','2013-12-21','13:55:00',2.49),('11288','2013-12-21','14:00:00',2.42),('11288','2013-12-21','14:05:00',2.34),('11288','2013-12-21','14:10:00',2.26),('11288','2013-12-21','14:15:00',2.17),('11288','2013-12-21','14:20:00',2.13),('11288','2013-12-21','14:25:00',2.01),('11288','2013-12-21','14:30:00',1.91),('11288','2013-12-21','14:35:00',1.82),('11288','2013-12-21','14:40:00',1.71),('11288','2013-12-21','14:45:00',1.62),('11288','2013-12-21','14:50:00',1.52),('11288','2013-12-21','14:55:00',1.42),('11288','2013-12-21','15:00:00',1.3),('11288','2013-12-21','15:05:00',1.05),('11288','2013-12-21','15:10:00',1.11),('11288','2013-12-20','08:45:00',1),('11288','2013-12-20','08:50:00',1.08),('11288','2013-12-20','08:55:00',1.09),('11288','2013-12-20','09:00:00',1.25),('11288','2013-12-20','09:05:00',1.34),('11288','2013-12-20','09:10:00',1.42),('11288','2013-12-20','09:15:00',1.54),('11288','2013-12-20','09:20:00',1.64),('11288','2013-12-20','09:25:00',1.7),('11288','2013-12-20','09:30:00',1.79),('11288','2013-12-20','09:35:00',1.85),('11288','2013-12-20','09:40:00',1.92),('11288','2013-12-20','09:45:00',1.99),('11288','2013-12-20','09:50:00',2.09),('11288','2013-12-20','09:55:00',2.14),('11288','2013-12-20','10:00:00',2.17),('11288','2013-12-20','10:05:00',2.23),('11288','2013-12-20','10:10:00',2.29),('11288','2013-12-20','10:15:00',2.45),('11288','2013-12-20','10:20:00',2.53),('11288','2013-12-20','10:25:00',2.6),('11288','2013-12-20','10:30:00',2.68),('11288','2013-12-20','10:35:00',2.7),('11288','2013-12-20','10:40:00',2.68),('11288','2013-12-20','10:45:00',2.86),('11288','2013-12-20','10:50:00',2.91),('11288','2013-12-20','10:55:00',2.99),('11288','2013-12-20','11:00:00',3.05),('11288','2013-12-20','11:05:00',3.12),('11288','2013-12-20','11:10:00',3.14),('11288','2013-12-20','11:15:00',3.12),('11288','2013-12-20','11:20:00',3.13),('11288','2013-12-20','11:25:00',3.14),('11288','2013-12-20','11:30:00',3.18),('11288','2013-12-20','11:35:00',3.24),('11288','2013-12-20','11:40:00',3.19),('11288','2013-12-20','11:45:00',3.26),('11288','2013-12-20','11:50:00',3.33),('11288','2013-12-20','11:55:00',3.3),('11288','2013-12-20','12:00:00',3.3),('11288','2013-12-20','12:05:00',3.15),('11288','2013-12-20','12:10:00',2.94),('11288','2013-12-20','12:15:00',3.18),('11288','2013-12-20','12:20:00',3.31),('11288','2013-12-20','12:25:00',3.26),('11288','2013-12-20','12:30:00',3.23),('11288','2013-12-20','12:35:00',3.22),('11288','2013-12-20','12:40:00',3.2),('11288','2013-12-20','12:45:00',3.16),('11288','2013-12-20','12:50:00',3.11),('11288','2013-12-20','12:55:00',3.07),('11288','2013-12-20','13:00:00',3.03),('11288','2013-12-20','13:05:00',2.98),('11288','2013-12-20','13:10:00',2.92),('11288','2013-12-20','13:15:00',2.86),('11288','2013-12-20','13:20:00',2.76),('11288','2013-12-20','13:25:00',2.65),('11288','2013-12-20','13:30:00',2.57),('11288','2013-12-20','13:35:00',2.53),('11288','2013-12-20','13:40:00',2.37),('11288','2013-12-20','13:45:00',2.31),('11288','2013-12-20','13:50:00',2.28),('11288','2013-12-20','13:55:00',2.27),('11288','2013-12-20','14:00:00',1.59),('11288','2013-12-20','14:05:00',1.3),('11288','2013-12-20','14:10:00',1.2),('11288','2013-12-19','08:55:00',1.44),('11288','2013-12-19','09:00:00',1.74),('11288','2013-12-19','09:05:00',1.83),('11288','2013-12-19','09:10:00',1.76),('11288','2013-12-19','09:15:00',1.83),('11288','2013-12-19','09:20:00',2.27),('11288','2013-12-19','09:25:00',1.53),('11288','2013-12-19','09:30:00',2.01),('11288','2013-12-19','09:35:00',1.69),('11288','2013-12-19','09:40:00',1.44),('11288','2013-12-19','09:45:00',1.29),('11288','2013-12-19','09:50:00',2.15),('11288','2013-12-19','09:55:00',2.43),('11288','2013-12-19','10:00:00',2.38),('11288','2013-12-19','10:05:00',2.74),('11288','2013-12-19','10:10:00',2.96),('11288','2013-12-19','10:15:00',2.72),('11288','2013-12-19','10:20:00',2.14),('11288','2013-12-19','10:25:00',1.84),('11288','2013-12-19','10:30:00',1.58),('11288','2013-12-19','10:35:00',1.55),('11288','2013-12-19','10:40:00',2.52),('11288','2013-12-19','10:45:00',3.14),('11288','2013-12-19','10:50:00',2.07),('11288','2013-12-19','10:55:00',1.26),('11288','2013-12-19','11:00:00',1.13),('11288','2013-12-19','11:05:00',1.05),('11288','2013-12-19','11:10:00',1.61),('11288','2013-12-19','11:15:00',1.87),('11288','2013-12-19','11:20:00',1.81),('11288','2013-12-19','11:25:00',1.37),('11288','2013-12-19','11:30:00',1.07),('11288','2013-12-19','12:35:00',1.26),('11288','2013-12-19','12:40:00',1.47),('11288','2013-12-19','12:45:00',1.34),('11288','2013-12-19','12:50:00',1.23),('11288','2013-12-19','12:55:00',1.15),('11288','2013-12-19','13:00:00',1.15),('11288','2013-12-19','13:05:00',1.03),('11288','2013-12-19','13:20:00',1.05),('11288','2013-12-19','13:25:00',1),('11288','2013-12-19','13:45:00',1.06),('11288','2013-12-19','13:50:00',1.14),('11288','2013-12-19','13:55:00',1.27),('11288','2013-12-19','14:00:00',1.42),('11288','2013-12-19','14:05:00',1.4),('11288','2013-12-19','14:10:00',1.24),('11288','2013-12-19','14:15:00',1.17),('11288','2013-12-19','14:20:00',1.31),('11288','2013-12-19','14:25:00',1.46),('11288','2013-12-19','14:30:00',1.87),('11288','2013-12-19','14:35:00',1.46),('11288','2013-12-19','14:40:00',1.37),('11288','2013-12-18','08:45:00',1),('11288','2013-12-18','08:50:00',1.1),('11288','2013-12-18','08:55:00',1.23),('11288','2013-12-18','09:00:00',1.34),('11288','2013-12-18','09:05:00',1.44),('11288','2013-12-18','09:10:00',1.51),('11288','2013-12-18','09:15:00',1.63),('11288','2013-12-18','09:20:00',1.73),('11288','2013-12-18','09:25:00',1.79),('11288','2013-12-18','09:30:00',1.86),('11288','2013-12-18','09:35:00',1.94),('11288','2013-12-18','09:40:00',2.03),('11288','2013-12-18','09:45:00',2.09),('11288','2013-12-18','09:50:00',2.18),('11288','2013-12-18','09:55:00',2.25),('11288','2013-12-18','10:00:00',2.26),('11288','2013-12-18','10:05:00',2.21),('11288','2013-12-18','10:10:00',2.52),('11288','2013-12-18','10:15:00',2.65),('11288','2013-12-18','10:20:00',2.75),('11288','2013-12-18','10:25:00',2.8),('11288','2013-12-18','10:30:00',2.86),('11288','2013-12-18','10:35:00',2.87),('11288','2013-12-18','10:40:00',2.99),('11288','2013-12-18','10:45:00',3.04),('11288','2013-12-18','10:50:00',3.11),('11288','2013-12-18','10:55:00',3.15),('11288','2013-12-18','11:00:00',3.22),('11288','2013-12-18','11:05:00',3.28),('11288','2013-12-18','11:10:00',3.31),('11288','2013-12-18','11:15:00',3.35),('11288','2013-12-18','11:20:00',3.31),('11288','2013-12-18','11:25:00',3.37),('11288','2013-12-18','11:30:00',3.37),('11288','2013-12-18','11:35:00',3.4),('11288','2013-12-18','11:40:00',3.44),('11288','2013-12-18','11:45:00',3.46),('11288','2013-12-18','11:50:00',3.44),('11288','2013-12-18','11:55:00',3.43),('11288','2013-12-18','12:00:00',3.38),('11288','2013-12-18','12:05:00',3.19),('11288','2013-12-18','12:10:00',3.4),('11288','2013-12-18','12:15:00',3.42),('11288','2013-12-18','12:20:00',3.41),('11288','2013-12-18','12:25:00',3.4),('11288','2013-12-18','12:30:00',3.35),('11288','2013-12-18','12:35:00',3.3),('11288','2013-12-18','12:40:00',3.36),('11288','2013-12-18','12:45:00',3.32),('11288','2013-12-18','12:50:00',3.26),('11288','2013-12-18','12:55:00',3.24),('11288','2013-12-18','13:00:00',3.17),('11288','2013-12-18','13:05:00',3.07),('11288','2013-12-18','13:10:00',3.08),('11288','2013-12-18','13:15:00',3),('11288','2013-12-18','13:20:00',2.91),('11288','2013-12-18','13:25:00',2.88),('11288','2013-12-18','13:30:00',2.78),('11288','2013-12-18','13:35:00',2.72),('11288','2013-12-18','13:40:00',2.57),('11288','2013-12-18','13:45:00',2.51),('11288','2013-12-18','13:50:00',2.41),('11288','2013-12-18','13:55:00',2.36),('11288','2013-12-18','14:00:00',2.31),('11288','2013-12-18','14:05:00',2.18),('11288','2013-12-18','14:10:00',2.13),('11288','2013-12-18','14:15:00',2.12),('11288','2013-12-18','14:20:00',2.05),('11288','2013-12-18','14:25:00',1.97),('11288','2013-12-18','14:30:00',1.88),('11288','2013-12-18','14:35:00',1.78),('11288','2013-12-18','14:40:00',1.67),('11288','2013-12-18','14:45:00',1.58),('11288','2013-12-18','14:50:00',1.5),('11288','2013-12-18','14:55:00',1.44),('11288','2013-12-18','15:00:00',1.28),('11288','2013-12-18','15:05:00',1.02),('11288','2013-12-18','15:10:00',1.06),('11288','2014-04-22','07:45:00',1.13),('11288','2014-04-22','07:50:00',1.28),('11288','2014-04-22','07:55:00',1.35),('11288','2014-04-22','08:00:00',1.51),('11288','2014-04-22','08:05:00',1.59),('11288','2014-04-22','08:10:00',1.71),('11288','2014-04-22','08:15:00',1.75),('11288','2014-04-22','08:20:00',1.85),('11288','2014-04-22','08:25:00',1.98),('11288','2014-04-22','08:30:00',2.21),('11288','2014-04-22','08:35:00',2.25),('11288','2014-04-22','08:40:00',2.47),('11288','2014-04-22','08:45:00',2.71),('11288','2014-04-22','08:50:00',2.92),('11288','2014-04-22','08:55:00',2.95),('11288','2014-04-22','09:00:00',2.77),('11288','2014-04-22','09:05:00',3.5),('11288','2014-04-22','09:10:00',3.31),('11288','2014-04-22','09:15:00',3.29),('11288','2014-04-22','09:20:00',3.77),('11288','2014-04-22','09:25:00',3.8),('11288','2014-04-22','09:30:00',2.93),('11288','2014-04-22','09:35:00',3.68),('11288','2014-04-22','09:40:00',3.8),('11288','2014-04-22','09:45:00',4.56),('11288','2014-04-22','09:50:00',3.56),('11288','2014-04-22','09:55:00',2.44),('11288','2014-04-22','10:00:00',2.33),('11288','2014-04-22','10:05:00',2.51),('11288','2014-04-22','10:10:00',3.32),('11288','2014-04-22','10:15:00',3.64),('11288','2014-04-22','10:20:00',5.09),('11288','2014-04-22','10:25:00',3.61),('11288','2014-04-22','10:30:00',5.88),('11288','2014-04-22','10:35:00',5.95),('11288','2014-04-22','10:40:00',5.84),('11288','2014-04-22','10:45:00',6.26),('11288','2014-04-22','10:50:00',6.22),('11288','2014-04-22','10:55:00',4.62),('11288','2014-04-22','11:00:00',3.4),('11288','2014-04-22','11:05:00',3.91),('11288','2014-04-22','11:10:00',2.88),('11288','2014-04-22','11:15:00',2.5),('11288','2014-04-22','11:20:00',2.18),('11288','2014-04-22','11:25:00',2.16),('11288','2014-04-22','11:30:00',1.99),('11288','2014-04-22','11:35:00',2.08),('11288','2014-04-22','11:40:00',1.85),('11288','2014-04-22','11:45:00',1.58),('11288','2014-04-22','11:50:00',1.65),('11288','2014-04-22','11:55:00',1.57),('11288','2014-04-22','12:00:00',1.75),('11288','2014-04-22','12:05:00',2.12),('11288','2014-04-22','12:10:00',2.11),('11288','2014-04-22','12:15:00',2.15),('11288','2014-04-22','12:20:00',2.23),('11288','2014-04-22','12:25:00',2.42),('11288','2014-04-22','12:30:00',2.77),('11288','2014-04-22','12:35:00',2.36),('11288','2014-04-22','12:40:00',1.79),('11288','2014-04-22','12:45:00',1.49),('11288','2014-04-22','12:50:00',1.3),('11288','2014-04-22','12:55:00',1.25),('11288','2014-04-22','13:00:00',1.27),('11288','2014-04-22','13:05:00',1.39),('11288','2014-04-22','13:10:00',1.67),('11288','2014-04-22','13:15:00',2.68),('11288','2014-04-22','13:20:00',3.92),('11288','2014-04-22','13:25:00',4.57),('11288','2014-04-22','13:30:00',4.71),('11288','2014-04-22','13:35:00',4.54),('11288','2014-04-22','13:40:00',5.34),('11288','2014-04-22','13:45:00',5.35),('11288','2014-04-22','13:50:00',4.41),('11288','2014-04-22','13:55:00',2.65),('11288','2014-04-22','14:00:00',2.37),('11288','2014-04-22','14:05:00',3.4),('11288','2014-04-22','14:10:00',5.71),('11288','2014-04-22','14:15:00',5.69),('11288','2014-04-22','14:20:00',6.59),('11288','2014-04-22','14:25:00',3.86),('11288','2014-04-22','14:30:00',3.64),('11288','2014-04-22','14:35:00',4.37),('11288','2014-04-22','14:40:00',5.72),('11288','2014-04-22','14:45:00',6.84),('11288','2014-04-22','14:50:00',6.37),('11288','2014-04-22','14:55:00',4.74),('11288','2014-04-22','15:00:00',2.24),('11288','2014-04-22','15:05:00',2.21),('11288','2014-04-22','15:10:00',2.08),('11288','2014-04-22','15:15:00',2.08),('11288','2014-04-22','15:20:00',2.3),('11288','2014-04-22','15:25:00',2.57),('11288','2014-04-22','15:30:00',3.24),('11288','2014-04-22','15:35:00',4.35),('11288','2014-04-22','15:40:00',3.55),('11288','2014-04-22','15:45:00',3.24),('11288','2014-04-22','15:50:00',3.79),('11288','2014-04-22','15:55:00',3.14),('11288','2014-04-22','16:00:00',3.63),('11288','2014-04-22','16:05:00',2.6),('11288','2014-04-22','16:10:00',2.53),('11288','2014-04-22','16:15:00',2.43),('11288','2014-04-22','16:20:00',2.8),('11288','2014-04-22','16:25:00',2.63),('11288','2014-04-22','16:30:00',2.25),('11288','2014-04-22','16:35:00',2.49),('11288','2014-04-22','16:40:00',2.98),('11288','2014-04-22','16:45:00',2.77),('11288','2014-04-22','16:50:00',2.25),('11288','2014-04-22','16:55:00',1.97),('11288','2014-04-22','17:00:00',2.27),('11288','2014-04-22','17:05:00',2.47),('11288','2014-04-22','17:10:00',1.94),('11288','2014-04-22','17:15:00',1.71),('11288','2014-04-22','17:20:00',1.32),('11288','2014-04-22','17:25:00',1.14),('11288','2014-04-22','17:30:00',1.08),('11288','2014-04-22','17:35:00',1.25),('11288','2014-04-22','17:40:00',1.25),('11288','2014-04-22','17:45:00',1.11),('11288','2014-04-22','17:50:00',1.02),('11288','2013-12-17','08:40:00',1.06),('11288','2013-12-17','08:45:00',1.09),('11288','2013-12-17','08:50:00',1.22),('11288','2013-12-17','08:55:00',1.34),('11288','2013-12-17','09:00:00',1.44),('11288','2013-12-17','09:05:00',1.53),('11288','2013-12-17','09:10:00',1.62),('11288','2013-12-17','09:15:00',1.71),('11288','2013-12-17','09:20:00',1.79),('11288','2013-12-17','09:25:00',1.83),('11288','2013-12-17','09:30:00',1.93),('11288','2013-12-17','09:35:00',2.01),('11288','2013-12-17','09:40:00',2.08),('11288','2013-12-17','09:45:00',2.17),('11288','2013-12-17','09:50:00',2.25),('11288','2013-12-17','09:55:00',2.31),('11288','2013-12-17','10:00:00',2.37),('11288','2013-12-17','10:05:00',2.44),('11288','2013-12-17','10:10:00',2.58),('11288','2013-12-17','10:15:00',2.71),('11288','2013-12-17','10:20:00',2.79),('11288','2013-12-17','10:25:00',2.84),('11288','2013-12-17','10:30:00',2.91),('11288','2013-12-17','10:35:00',2.93),('11288','2013-12-17','10:40:00',3.06),('11288','2013-12-17','10:45:00',3.1),('11288','2013-12-17','10:50:00',3.16),('11288','2013-12-17','10:55:00',3.23),('11288','2013-12-17','11:00:00',3.29),('11288','2013-12-17','11:05:00',3.29),('11288','2013-12-17','11:10:00',3.36),('11288','2013-12-17','11:15:00',3.44),('11288','2013-12-17','11:20:00',3.38),('11288','2013-12-17','11:25:00',3.43),('11288','2013-12-17','11:30:00',3.44),('11288','2013-12-17','11:35:00',3.49),('11288','2013-12-17','11:40:00',3.51),('11288','2013-12-17','11:45:00',3.53),('11288','2013-12-17','11:50:00',3.58),('11288','2013-12-17','11:55:00',3.59),('11288','2013-12-17','12:00:00',3.53),('11288','2013-12-17','12:05:00',3.4),('11288','2013-12-17','12:10:00',3.58),('11288','2013-12-17','12:15:00',3.57),('11288','2013-12-17','12:20:00',3.58),('11288','2013-12-17','12:25:00',3.57),('11288','2013-12-17','12:30:00',3.53),('11288','2013-12-17','12:35:00',3.51),('11288','2013-12-17','12:40:00',3.49),('11288','2013-12-17','12:45:00',3.46),('11288','2013-12-17','12:50:00',3.41),('11288','2013-12-17','12:55:00',3.38),('11288','2013-12-17','13:00:00',3.29),('11288','2013-12-17','13:05:00',3.25),('11288','2013-12-17','13:10:00',3.2),('11288','2013-12-17','13:15:00',3.16),('11288','2013-12-17','13:20:00',3.07),('11288','2013-12-17','13:25:00',3.02),('11288','2013-12-17','13:30:00',2.96),('11288','2013-12-17','13:35:00',2.87),('11288','2013-12-17','13:40:00',2.76),('11288','2013-12-17','13:45:00',2.69),('11288','2013-12-17','13:50:00',2.65),('11288','2013-12-17','13:55:00',2.58),('11288','2013-12-17','14:00:00',2.47),('11288','2013-12-17','14:05:00',2.39),('11288','2013-12-17','14:10:00',2.3),('11288','2013-12-17','14:15:00',2.21),('11288','2013-12-17','14:20:00',2.11),('11288','2013-12-17','14:25:00',1.99),('11288','2013-12-17','14:30:00',1.89),('11288','2013-12-17','14:35:00',1.78),('11288','2013-12-17','14:40:00',1.71),('11288','2013-12-17','14:45:00',1.61),('11288','2013-12-17','14:50:00',1.51),('11288','2013-12-17','14:55:00',1.43),('11288','2013-12-17','15:00:00',1.24),('11288','2013-12-17','15:05:00',1.1),('11288','2013-12-17','15:10:00',1.07),('11288','2013-12-16','08:40:00',1.01),('11288','2013-12-16','08:45:00',1.04),('11288','2013-12-16','08:50:00',1.2),('11288','2013-12-16','08:55:00',1.29),('11288','2013-12-16','09:00:00',1.41),('11288','2013-12-16','09:05:00',1.5),('11288','2013-12-16','09:10:00',1.56),('11288','2013-12-16','09:15:00',1.69),('11288','2013-12-16','09:20:00',1.77),('11288','2013-12-16','09:25:00',1.82),('11288','2013-12-16','09:30:00',1.89),('11288','2013-12-16','09:35:00',1.98),('11288','2013-12-16','09:40:00',2.06),('11288','2013-12-16','09:45:00',2.15),('11288','2013-12-16','09:50:00',2.22),('11288','2013-12-16','09:55:00',2.28),('11288','2013-12-16','10:00:00',2.28),('11288','2013-12-16','10:05:00',2.32),('11288','2013-12-16','10:10:00',2.56),('11288','2013-12-16','10:15:00',2.68),('11288','2013-12-16','10:20:00',2.72),('11288','2013-12-16','10:25:00',2.76),('11288','2013-12-16','10:30:00',2.82),('11288','2013-12-16','10:35:00',2.86),('11288','2013-12-16','10:40:00',2.99),('11288','2013-12-16','10:45:00',3.03),('11288','2013-12-16','10:50:00',3.09),('11288','2013-12-16','10:55:00',3.16),('11288','2013-12-16','11:00:00',3.22),('11288','2013-12-16','11:05:00',3.27),('11288','2013-12-16','11:10:00',3.27),('11288','2013-12-16','11:15:00',3.3),('11288','2013-12-16','11:20:00',3.28),('11288','2013-12-16','11:25:00',3.37),('11288','2013-12-16','11:30:00',3.39),('11288','2013-12-16','11:35:00',3.41),('11288','2013-12-16','11:40:00',3.45),('11288','2013-12-16','11:45:00',3.47),('11288','2013-12-16','11:50:00',3.52),('11288','2013-12-16','11:55:00',3.52),('11288','2013-12-16','12:00:00',3.46),('11288','2013-12-16','12:05:00',3.33),('11288','2013-12-16','12:10:00',3.54),('11288','2013-12-16','12:15:00',3.54),('11288','2013-12-16','12:20:00',3.55),('11288','2013-12-16','12:25:00',3.55),('11288','2013-12-16','12:30:00',3.49),('11288','2013-12-16','12:35:00',3.43),('11288','2013-12-16','12:40:00',3.45),('11288','2013-12-16','12:45:00',3.4),('11288','2013-12-16','12:50:00',3.37),('11288','2013-12-16','12:55:00',3.33),('11288','2013-12-16','13:00:00',3.28),('11288','2013-12-16','13:05:00',3.25),('11288','2013-12-16','13:10:00',3.21),('11288','2013-12-16','13:15:00',3.14),('11288','2013-12-16','13:20:00',3.07),('11288','2013-12-16','13:25:00',3),('11288','2013-12-16','13:30:00',2.92),('11288','2013-12-16','13:35:00',2.81),('11288','2013-12-16','13:40:00',2.7),('11288','2013-12-16','13:45:00',2.64),('11288','2013-12-16','13:50:00',2.58),('11288','2013-12-16','13:55:00',2.53),('11288','2013-12-16','14:00:00',2.42),('11288','2013-12-16','14:05:00',2.33),('11288','2013-12-16','14:10:00',2.29),('11288','2013-12-16','14:15:00',2.21),('11288','2013-12-16','14:20:00',2.11),('11288','2013-12-16','14:25:00',2),('11288','2013-12-16','14:30:00',1.89),('11288','2013-12-16','14:35:00',1.79),('11288','2013-12-16','14:40:00',1.69),('11288','2013-12-16','14:45:00',1.6),('11288','2013-12-16','14:50:00',1.48),('11288','2013-12-16','14:55:00',1.38),('11288','2013-12-16','15:00:00',1.19),('11288','2013-12-16','15:05:00',1.11),('11288','2013-12-16','15:10:00',1.1),('11288','2013-12-15','09:45:00',1.14),('11288','2013-12-15','09:50:00',1.28),('11288','2013-12-15','09:55:00',1.3),('11288','2013-12-15','10:00:00',1.28),('11288','2013-12-15','10:05:00',1.28),('11288','2013-12-15','10:10:00',1.37),('11288','2013-12-15','10:15:00',1.47),('11288','2013-12-15','10:20:00',1.9),('11288','2013-12-15','10:25:00',2.03),('11288','2013-12-15','10:30:00',1.92),('11288','2013-12-15','10:35:00',2.02),('11288','2013-12-15','10:40:00',2.05),('11288','2013-12-15','10:45:00',2.05),('11288','2013-12-15','10:50:00',1.69),('11288','2013-12-15','10:55:00',1.44),('11288','2013-12-15','11:00:00',1.43),('11288','2013-12-15','11:05:00',1.39),('11288','2013-12-15','11:10:00',1.36),('11288','2013-12-15','11:15:00',1.41),('11288','2013-12-15','11:20:00',1.55),('11288','2013-12-15','11:25:00',1.53),('11288','2013-12-15','11:30:00',1.49),('11288','2013-12-15','11:35:00',1.56),('11288','2013-12-15','11:40:00',1.64),('11288','2013-12-15','11:45:00',1.7),('11288','2013-12-15','11:50:00',1.66),('11288','2013-12-15','11:55:00',1.63),('11288','2013-12-15','12:00:00',1.69),('11288','2013-12-15','12:05:00',1.69),('11288','2013-12-15','12:10:00',1.54),('11288','2013-12-15','12:15:00',1.44),('11288','2013-12-15','12:20:00',1.51),('11288','2013-12-15','12:25:00',1.16),('11288','2013-12-15','12:35:00',1.01),('11288','2013-12-15','12:40:00',1.13),('11288','2013-12-15','12:45:00',1.26),('11288','2013-12-15','12:50:00',1.26),('11288','2013-12-14','08:45:00',1.02),('11288','2013-12-14','08:50:00',1.16),('11288','2013-12-14','08:55:00',1.26),('11288','2013-12-14','09:00:00',1.37),('11288','2013-12-14','09:05:00',1.48),('11288','2013-12-14','09:10:00',1.59),('11288','2013-12-14','09:15:00',1.69),('11288','2013-12-14','09:20:00',1.75),('11288','2013-12-14','09:25:00',1.82),('11288','2013-12-14','09:30:00',1.93),('11288','2013-12-14','09:35:00',2.01),('11288','2013-12-14','09:40:00',2.09),('11288','2013-12-14','09:45:00',2.17),('11288','2013-12-14','09:50:00',2.23),('11288','2013-12-14','09:55:00',2.28),('11288','2013-12-14','10:00:00',2.26),('11288','2013-12-14','10:05:00',2.36),('11288','2013-12-14','10:10:00',2.56),('11288','2013-12-14','10:15:00',2.67),('11288','2013-12-14','10:20:00',2.75),('11288','2013-12-14','10:25:00',2.79),('11288','2013-12-14','10:30:00',2.84),('11288','2013-12-14','10:35:00',2.89),('11288','2013-12-14','10:40:00',2.98),('11288','2013-12-14','10:45:00',3.06),('11288','2013-12-14','10:50:00',3.12),('11288','2013-12-14','10:55:00',3.16),('11288','2013-12-14','11:00:00',3.21),('11288','2013-12-14','11:05:00',3.25),('11288','2013-12-14','11:10:00',3.3),('11288','2013-12-14','11:15:00',3.33),('11288','2013-12-14','11:20:00',3.28),('11288','2013-12-14','11:25:00',3.33),('11288','2013-12-14','11:30:00',3.35),('11288','2013-12-14','11:35:00',3.37),('11288','2013-12-14','11:40:00',3.4),('11288','2013-12-14','11:45:00',3.37),('11288','2013-12-14','11:50:00',3.35),('11288','2013-12-14','11:55:00',3.32),('11288','2013-12-14','12:00:00',3.21),('11288','2013-12-14','12:05:00',3.2),('11288','2013-12-14','12:10:00',3.36),('11288','2013-12-14','12:15:00',3.29),('11288','2013-12-14','12:20:00',3.34),('11288','2013-12-14','12:25:00',3.27),('11288','2013-12-14','12:30:00',3.33),('11288','2013-12-14','12:35:00',3.29),('11288','2013-12-14','12:40:00',3.31),('11288','2013-12-14','12:45:00',3.3),('11288','2013-12-14','12:50:00',3.23),('11288','2013-12-14','12:55:00',3.1),('11288','2013-12-14','13:00:00',3.07),('11288','2013-12-14','13:05:00',3.07),('11288','2013-12-14','13:10:00',3),('11288','2013-12-14','13:15:00',2.96),('11288','2013-12-14','13:20:00',2.95),('11288','2013-12-14','13:25:00',2.94),('11288','2013-12-14','13:30:00',2.91),('11288','2013-12-14','13:35:00',2.78),('11288','2013-12-14','13:40:00',2.67),('11288','2013-12-14','13:45:00',2.56),('11288','2013-12-14','13:50:00',2.49),('11288','2013-12-14','13:55:00',2.48),('11288','2013-12-14','14:00:00',2.4),('11288','2013-12-14','14:05:00',2.33),('11288','2013-12-14','14:10:00',2.23),('11288','2013-12-14','14:15:00',2.14),('11288','2013-12-14','14:20:00',2.04),('11288','2013-12-14','14:25:00',1.9),('11288','2013-12-14','14:30:00',1.85),('11288','2013-12-14','14:35:00',1.7),('11288','2013-12-14','14:40:00',1.62),('11288','2013-12-14','14:45:00',1.53),('11288','2013-12-14','14:50:00',1.43),('11288','2013-12-14','14:55:00',1.36),('11288','2013-12-14','15:00:00',1.16),('11288','2013-12-14','15:05:00',1.13),('11288','2013-12-14','15:10:00',1.1),('11288','2013-12-13','08:45:00',1.02),('11288','2013-12-13','08:50:00',1.14),('11288','2013-12-13','08:55:00',1.24),('11288','2013-12-13','09:00:00',1.34),('11288','2013-12-13','09:05:00',1.45),('11288','2013-12-13','09:10:00',1.52),('11288','2013-12-13','09:15:00',1.61),('11288','2013-12-13','09:20:00',1.69),('11288','2013-12-13','09:25:00',1.72),('11288','2013-12-13','09:30:00',1.8),('11288','2013-12-13','09:35:00',1.86),('11288','2013-12-13','09:40:00',1.92),('11288','2013-12-13','09:45:00',1.99),('11288','2013-12-13','09:50:00',2.06),('11288','2013-12-13','09:55:00',2.14),('11288','2013-12-13','10:00:00',2.14),('11288','2013-12-13','10:05:00',2.29),('11288','2013-12-13','10:10:00',2.41),('11288','2013-12-13','10:15:00',2.5),('11288','2013-12-13','10:20:00',2.54),('11288','2013-12-13','10:25:00',2.62),('11288','2013-12-13','10:30:00',2.69),('11288','2013-12-13','10:35:00',2.76),('11288','2013-12-13','10:40:00',2.86),('11288','2013-12-13','10:45:00',2.92),('11288','2013-12-13','10:50:00',2.94),('11288','2013-12-13','10:55:00',3.01),('11288','2013-12-13','11:00:00',3.09),('11288','2013-12-13','11:05:00',3.16),('11288','2013-12-13','11:10:00',3.21),('11288','2013-12-13','11:15:00',3.2),('11288','2013-12-13','11:20:00',3.12),('11288','2013-12-13','11:25:00',3.16),('11288','2013-12-13','11:30:00',3.17),('11288','2013-12-13','11:35:00',3.28),('11288','2013-12-13','11:40:00',3.33),('11288','2013-12-13','11:45:00',3.41),('11288','2013-12-13','11:50:00',3.4),('11288','2013-12-13','11:55:00',3.39),('11288','2013-12-13','12:00:00',3.27),('11288','2013-12-13','12:05:00',3.24),('11288','2013-12-13','12:10:00',3.42),('11288','2013-12-13','12:15:00',3.32),('11288','2013-12-13','12:20:00',3.32),('11288','2013-12-13','12:25:00',3.24),('11288','2013-12-13','12:30:00',3.23),('11288','2013-12-13','12:35:00',3.17),('11288','2013-12-13','12:40:00',3.26),('11288','2013-12-13','12:45:00',3.16),('11288','2013-12-13','12:50:00',3.14),('11288','2013-12-13','12:55:00',3.06),('11288','2013-12-13','13:00:00',3.11),('11288','2013-12-13','13:05:00',3.09),('11288','2013-12-13','13:10:00',3.08),('11288','2013-12-13','13:15:00',2.99),('11288','2013-12-13','13:20:00',3),('11288','2013-12-13','13:25:00',2.97),('11288','2013-12-13','13:30:00',2.93),('11288','2013-12-13','13:35:00',2.81),('11288','2013-12-13','13:40:00',2.71),('11288','2013-12-13','13:45:00',2.59),('11288','2013-12-13','13:50:00',2.53),('11288','2013-12-13','13:55:00',2.46),('11288','2013-12-13','14:00:00',2.42),('11288','2013-12-13','14:05:00',2.37),('11288','2013-12-13','14:10:00',2.25),('11288','2013-12-13','14:15:00',2.16),('11288','2013-12-13','14:20:00',2.07),('11288','2013-12-13','14:25:00',1.92),('11288','2013-12-13','14:30:00',1.86),('11288','2013-12-13','14:35:00',1.78),('11288','2013-12-13','14:40:00',1.7),('11288','2013-12-13','14:45:00',1.63),('11288','2013-12-13','14:50:00',1.53),('11288','2013-12-13','14:55:00',1.34),('11288','2013-12-13','15:00:00',1.12),('11288','2013-12-13','15:05:00',1.07),('11288','2013-12-13','15:10:00',1.01),('11288','2013-12-12','08:40:00',1.02),('11288','2013-12-12','08:45:00',1.05),('11288','2013-12-12','08:50:00',1.2),('11288','2013-12-12','08:55:00',1.29),('11288','2013-12-12','09:00:00',1.4),('11288','2013-12-12','09:05:00',1.49),('11288','2013-12-12','09:10:00',1.58),('11288','2013-12-12','09:15:00',1.69),('11288','2013-12-12','09:20:00',1.75),('11288','2013-12-12','09:25:00',1.8),('11288','2013-12-12','09:30:00',1.89),('11288','2013-12-12','09:35:00',1.99),('11288','2013-12-12','09:40:00',2.08),('11288','2013-12-12','09:45:00',2.16),('11288','2013-12-12','09:50:00',2.22),('11288','2013-12-12','09:55:00',2.27),('11288','2013-12-12','10:00:00',2.22),('11288','2013-12-12','10:05:00',2.31),('11288','2013-12-12','10:10:00',2.56),('11288','2013-12-12','10:15:00',2.68),('11288','2013-12-12','10:20:00',2.73),('11288','2013-12-12','10:25:00',2.78),('11288','2013-12-12','10:30:00',2.86),('11288','2013-12-12','10:35:00',2.87),('11288','2013-12-12','10:40:00',3),('11288','2013-12-12','10:45:00',3.05),('11288','2013-12-12','10:50:00',3.12),('11288','2013-12-12','10:55:00',3.17),('11288','2013-12-12','11:00:00',3.21),('11288','2013-12-12','11:05:00',3.24),('11288','2013-12-12','11:10:00',3.29),('11288','2013-12-12','11:15:00',3.29),('11288','2013-12-12','11:20:00',3.19),('11288','2013-12-12','11:25:00',3.27),('11288','2013-12-12','11:30:00',3.33),('11288','2013-12-12','11:35:00',3.34),('11288','2013-12-12','11:40:00',3.37),('11288','2013-12-12','11:45:00',3.39),('11288','2013-12-12','11:50:00',3.37),('11288','2013-12-12','11:55:00',3.4),('11288','2013-12-12','12:00:00',3.27),('11288','2013-12-12','12:05:00',3.24),('11288','2013-12-12','12:10:00',3.41),('11288','2013-12-12','12:15:00',3.38),('11288','2013-12-12','12:20:00',3.39),('11288','2013-12-12','12:25:00',3.39),('11288','2013-12-12','12:30:00',3.34),('11288','2013-12-12','12:35:00',3.35),('11288','2013-12-12','12:40:00',3.3),('11288','2013-12-12','12:45:00',3.2),('11288','2013-12-12','12:50:00',3.21),('11288','2013-12-12','12:55:00',3.13),('11288','2013-12-12','13:00:00',3.08),('11288','2013-12-12','13:05:00',3.04),('11288','2013-12-12','13:10:00',3.01),('11288','2013-12-12','13:15:00',2.88),('11288','2013-12-12','13:20:00',2.88),('11288','2013-12-12','13:25:00',2.9),('11288','2013-12-12','13:30:00',2.83),('11288','2013-12-12','13:35:00',2.72),('11288','2013-12-12','13:40:00',2.59),('11288','2013-12-12','13:45:00',2.58),('11288','2013-12-12','13:50:00',2.52),('11288','2013-12-12','13:55:00',2.45),('11288','2013-12-12','14:00:00',2.37),('11288','2013-12-12','14:05:00',2.3),('11288','2013-12-12','14:10:00',2.22),('11288','2013-12-12','14:15:00',2.09),('11288','2013-12-12','14:20:00',2),('11288','2013-12-12','14:25:00',1.88),('11288','2013-12-12','14:30:00',1.79),('11288','2013-12-12','14:35:00',1.68),('11288','2013-12-12','14:40:00',1.58),('11288','2013-12-12','14:45:00',1.49),('11288','2013-12-12','14:50:00',1.42),('11288','2013-12-12','14:55:00',1.31),('11288','2013-12-12','15:00:00',1.08),('11288','2013-12-11','08:40:00',1.03),('11288','2013-12-11','08:45:00',1.03),('11288','2013-12-11','08:50:00',1.2),('11288','2013-12-11','08:55:00',1.3),('11288','2013-12-11','09:00:00',1.38),('11288','2013-12-11','09:05:00',1.48),('11288','2013-12-11','09:10:00',1.55),('11288','2013-12-11','09:15:00',1.63),('11288','2013-12-11','09:20:00',1.73),('11288','2013-12-11','09:25:00',1.79),('11288','2013-12-11','09:30:00',1.88),('11288','2013-12-11','09:35:00',1.98),('11288','2013-12-11','09:40:00',2.06),('11288','2013-12-11','09:45:00',2.18),('11288','2013-12-11','09:50:00',2.23),('11288','2013-12-11','09:55:00',2.29),('11288','2013-12-11','10:00:00',2.22),('11288','2013-12-11','10:05:00',2.48),('11288','2013-12-11','10:10:00',2.6),('11288','2013-12-11','10:15:00',2.7),('11288','2013-12-11','10:20:00',2.78),('11288','2013-12-11','10:25:00',2.86),('11288','2013-12-11','10:30:00',2.9),('11288','2013-12-11','10:35:00',2.99),('11288','2013-12-11','10:40:00',3.07),('11288','2013-12-11','10:45:00',3.11),('11288','2013-12-11','10:50:00',3.15),('11288','2013-12-11','10:55:00',3.24),('11288','2013-12-11','11:00:00',3.3),('11288','2013-12-11','11:05:00',3.35),('11288','2013-12-11','11:10:00',3.43),('11288','2013-12-11','11:15:00',3.41),('11288','2013-12-11','11:20:00',3.44),('11288','2013-12-11','11:25:00',3.47),('11288','2013-12-11','11:30:00',3.4),('11288','2013-12-11','11:35:00',3.47),('11288','2013-12-11','11:40:00',3.5),('11288','2013-12-11','11:45:00',3.53),('11288','2013-12-11','11:50:00',3.56),('11288','2013-12-11','11:55:00',3.55),('11288','2013-12-11','12:00:00',3.39),('11288','2013-12-11','12:05:00',3.48),('11288','2013-12-11','12:10:00',3.57),('11288','2013-12-11','12:15:00',3.48),('11288','2013-12-11','12:20:00',3.47),('11288','2013-12-11','12:25:00',3.42),('11288','2013-12-11','12:30:00',3.36),('11288','2013-12-11','12:35:00',3.4),('11288','2013-12-11','12:40:00',3.4),('11288','2013-12-11','12:45:00',3.4),('11288','2013-12-11','12:50:00',3.37),('11288','2013-12-11','12:55:00',3.3),('11288','2013-12-11','13:00:00',3.28),('11288','2013-12-11','13:05:00',3.21),('11288','2013-12-11','13:10:00',3.13),('11288','2013-12-11','13:15:00',3.09),('11288','2013-12-11','13:20:00',3.05),('11288','2013-12-11','13:25:00',3),('11288','2013-12-11','13:30:00',2.94),('11288','2013-12-11','13:35:00',2.84),('11288','2013-12-11','13:40:00',2.7),('11288','2013-12-11','13:45:00',2.63),('11288','2013-12-11','13:50:00',2.58),('11288','2013-12-11','13:55:00',2.47),('11288','2013-12-11','14:00:00',2.4),('11288','2013-12-11','14:05:00',2.33),('11288','2013-12-11','14:10:00',2.27),('11288','2013-12-11','14:15:00',2.18),('11288','2013-12-11','14:20:00',2.07),('11288','2013-12-11','14:25:00',1.98),('11288','2013-12-11','14:30:00',1.9),('11288','2013-12-11','14:35:00',1.79),('11288','2013-12-11','14:40:00',1.68),('11288','2013-12-11','14:45:00',1.57),('11288','2013-12-11','14:50:00',1.49),('11288','2013-12-11','14:55:00',1.35),('11288','2013-12-11','15:00:00',1.11),('11288','2013-12-11','15:05:00',1.18),('11288','2013-12-11','15:10:00',1.04),('11288','2013-12-10','08:45:00',1.16),('11288','2013-12-10','08:50:00',1.27),('11288','2013-12-10','08:55:00',1.37),('11288','2013-12-10','09:00:00',1.49),('11288','2013-12-10','09:05:00',1.6),('11288','2013-12-10','09:10:00',1.67),('11288','2013-12-10','09:15:00',1.77),('11288','2013-12-10','09:20:00',1.85),('11288','2013-12-10','09:25:00',1.9),('11288','2013-12-10','09:30:00',1.95),('11288','2013-12-10','09:35:00',2.04),('11288','2013-12-10','09:40:00',2.14),('11288','2013-12-10','09:45:00',2.21),('11288','2013-12-10','09:50:00',2.31),('11288','2013-12-10','09:55:00',2.36),('11288','2013-12-10','10:00:00',2.31),('11288','2013-12-10','10:05:00',2.56),('11288','2013-12-10','10:10:00',2.66),('11288','2013-12-10','10:15:00',2.79),('11288','2013-12-10','10:20:00',2.84),('11288','2013-12-10','10:25:00',2.94),('11288','2013-12-10','10:30:00',2.98),('11288','2013-12-10','10:35:00',3.06),('11288','2013-12-10','10:40:00',3.15),('11288','2013-12-10','10:45:00',3.17),('11288','2013-12-10','10:50:00',3.21),('11288','2013-12-10','10:55:00',3.28),('11288','2013-12-10','11:00:00',3.33),('11288','2013-12-10','11:05:00',3.38),('11288','2013-12-10','11:10:00',3.45),('11288','2013-12-10','11:15:00',3.44),('11288','2013-12-10','11:20:00',3.47),('11288','2013-12-10','11:25:00',3.51),('11288','2013-12-10','11:30:00',3.55),('11288','2013-12-10','11:35:00',3.6),('11288','2013-12-10','11:40:00',3.6),('11288','2013-12-10','11:45:00',3.61),('11288','2013-12-10','11:50:00',3.61),('11288','2013-12-10','11:55:00',3.58),('11288','2013-12-10','12:00:00',3.39),('11288','2013-12-10','12:05:00',3.6),('11288','2013-12-10','12:10:00',3.56),('11288','2013-12-10','12:15:00',3.55),('11288','2013-12-10','12:20:00',3.53),('11288','2013-12-10','12:25:00',3.49),('11288','2013-12-10','12:30:00',3.39),('11288','2013-12-10','12:35:00',3.39),('11288','2013-12-10','12:40:00',3.34),('11288','2013-12-10','12:45:00',3.33),('11288','2013-12-10','12:50:00',3.3),('11288','2013-12-10','12:55:00',3.21),('11288','2013-12-10','13:00:00',3.17),('11288','2013-12-10','13:05:00',3.08),('11288','2013-12-10','13:10:00',3.09),('11288','2013-12-10','13:15:00',2.99),('11288','2013-12-10','13:20:00',2.92),('11288','2013-12-10','13:25:00',2.9),('11288','2013-12-10','13:30:00',2.86),('11288','2013-12-10','13:35:00',2.77),('11288','2013-12-10','13:40:00',2.71),('11288','2013-12-10','13:45:00',2.68),('11288','2013-12-10','13:50:00',2.63),('11288','2013-12-10','13:55:00',2.54),('11288','2013-12-10','14:00:00',2.45),('11288','2013-12-10','14:05:00',2.38),('11288','2013-12-10','14:10:00',2.3),('11288','2013-12-10','14:15:00',2.2),('11288','2013-12-10','14:20:00',2.1),('11288','2013-12-10','14:25:00',2.01),('11288','2013-12-10','14:30:00',1.94),('11288','2013-12-10','14:35:00',1.83),('11288','2013-12-10','14:40:00',1.74),('11288','2013-12-10','14:45:00',1.61),('11288','2013-12-10','14:50:00',1.56),('11288','2013-12-10','14:55:00',1.36),('11288','2013-12-10','15:00:00',1.18),('11288','2013-12-10','15:05:00',1.2),('11288','2013-12-10','15:10:00',1.03),('11288','2013-12-09','09:30:00',1.43),('11288','2013-12-09','09:35:00',1.66),('11288','2013-12-09','09:40:00',1.82),('11288','2013-12-09','09:45:00',2.19),('11288','2013-12-09','09:50:00',2.27),('11288','2013-12-09','09:55:00',2.35),('11288','2013-12-09','10:00:00',2.51),('11288','2013-12-09','10:05:00',2.83),('11288','2013-12-09','10:10:00',3.27),('11288','2013-12-09','10:15:00',3.81),('11288','2013-12-09','10:20:00',3.96),('11288','2013-12-09','10:25:00',2.54),('11288','2013-12-09','10:30:00',1.32),('11288','2013-12-09','10:35:00',1.15),('11288','2013-12-09','10:40:00',1.02),('11288','2013-12-09','11:50:00',1.03),('11288','2013-12-09','11:55:00',1.14),('11288','2013-12-09','12:00:00',1.25),('11288','2013-12-09','12:05:00',1.3),('11288','2013-12-09','12:10:00',1.24),('11288','2013-12-09','12:15:00',1.21),('11288','2013-12-09','12:20:00',1.35),('11288','2013-12-09','12:25:00',1.85),('11288','2013-12-09','12:30:00',3.23),('11288','2013-12-09','12:35:00',1.92),('11288','2013-12-09','12:40:00',1.94),('11288','2013-12-09','12:45:00',2.84),('11288','2013-12-09','12:50:00',2.43),('11288','2013-12-09','12:55:00',3.07),('11288','2013-12-09','13:00:00',3.21),('11288','2013-12-09','13:05:00',1.9),('11288','2013-12-09','13:10:00',2.48),('11288','2013-12-09','13:15:00',2.62),('11288','2013-12-09','13:20:00',2.64),('11288','2013-12-09','13:25:00',1.95),('11288','2013-12-09','13:30:00',1.2),('11288','2013-12-09','13:35:00',1.05),('11288','2013-12-09','13:40:00',1.38),('11288','2013-12-09','13:45:00',1.66),('11288','2013-12-09','13:50:00',1.9),('11288','2013-12-09','13:55:00',1.96),('11288','2013-12-09','14:00:00',1.68),('11288','2013-12-09','14:05:00',1.34),('11288','2013-12-09','14:10:00',1.14),('11288','2013-12-09','14:15:00',1.01),('11288','2013-12-09','14:45:00',1.04),('11288','2013-12-09','14:50:00',1.01),('11288','2013-12-08','08:55:00',1.04),('11288','2013-12-08','09:00:00',1.07),('11288','2013-12-08','09:05:00',1.14),('11288','2013-12-08','09:10:00',1.05),('11288','2013-12-08','09:15:00',1),('11288','2013-12-08','09:20:00',1.01),('11288','2013-12-08','09:25:00',1.11),('11288','2013-12-08','09:30:00',1.08),('11288','2013-12-08','09:35:00',1.19),('11288','2013-12-08','09:40:00',1.21),('11288','2013-12-08','09:45:00',1.29),('11288','2013-12-08','09:50:00',1.47),('11288','2013-12-08','09:55:00',1.58),('11288','2013-12-08','10:00:00',1.48),('11288','2013-12-08','10:05:00',1.55),('11288','2013-12-08','10:10:00',1.56),('11288','2013-12-08','10:15:00',1.65),('11288','2013-12-08','10:20:00',1.67),('11288','2013-12-08','10:25:00',1.63),('11288','2013-12-08','10:30:00',1.63),('11288','2013-12-08','10:35:00',1.72),('11288','2013-12-08','10:40:00',1.85),('11288','2013-12-08','10:45:00',1.89),('11288','2013-12-08','10:50:00',1.99),('11288','2013-12-08','10:55:00',2.11),('11288','2013-12-08','11:00:00',2.17),('11288','2013-12-08','11:05:00',2.07),('11288','2013-12-08','11:10:00',2.26),('11288','2013-12-08','11:15:00',3.04),('11288','2013-12-08','11:20:00',1.98),('11288','2013-12-08','11:25:00',1.6),('11288','2013-12-08','11:30:00',1.41),('11288','2013-12-08','11:35:00',1.4),('11288','2013-12-08','11:40:00',1.41),('11288','2013-12-08','11:45:00',1.36),('11288','2013-12-08','11:50:00',1.47),('11288','2013-12-08','11:55:00',1.47),('11288','2013-12-08','12:00:00',1.42),('11288','2013-12-08','12:05:00',1.42),('11288','2013-12-08','12:10:00',1.31),('11288','2013-12-08','12:15:00',1.23),('11288','2013-12-08','12:20:00',1.33),('11288','2013-12-08','12:25:00',1.31),('11288','2013-12-08','12:30:00',1.2),('11288','2013-12-08','12:35:00',1.12),('11288','2013-12-08','12:40:00',1.04),('11288','2013-12-08','12:45:00',1.02),('11288','2013-12-08','12:50:00',1.17),('11288','2013-12-08','12:55:00',2.36),('11288','2013-12-08','13:00:00',1.79),('11288','2013-12-08','13:05:00',2.1),('11288','2013-12-08','13:10:00',3.31),('11288','2013-12-08','13:15:00',2.57),('11288','2013-12-08','13:20:00',1.82),('11288','2013-12-08','13:25:00',2.3),('11288','2013-12-08','13:30:00',2.28),('11288','2013-12-08','13:35:00',1.23),('11288','2014-04-21','08:20:00',1.01),('11288','2014-04-21','08:25:00',1.14),('11288','2014-04-21','08:30:00',1.53),('11288','2014-04-21','08:35:00',1.49),('11288','2014-04-21','08:40:00',1.68),('11288','2014-04-21','08:45:00',1.61),('11288','2014-04-21','08:50:00',1.55),('11288','2014-04-21','08:55:00',1.53),('11288','2014-04-21','09:00:00',1.75),('11288','2014-04-21','09:05:00',1.72),('11288','2014-04-21','09:10:00',1.75),('11288','2014-04-21','09:15:00',1.92),('11288','2014-04-21','09:20:00',2.54),('11288','2014-04-21','09:25:00',1.85),('11288','2014-04-21','09:35:00',1.05),('11288','2014-04-21','09:40:00',1.51),('11288','2014-04-21','09:45:00',1.66),('11288','2014-04-21','09:50:00',1.75),('11288','2014-04-21','09:55:00',1.88),('11288','2014-04-21','10:00:00',2.52),('11288','2014-04-21','10:05:00',4.73),('11288','2014-04-21','10:10:00',4.59),('11288','2014-04-21','10:15:00',5.38),('11288','2014-04-21','10:20:00',5.35),('11288','2014-04-21','10:25:00',5.4),('11288','2014-04-21','10:30:00',5.41),('11288','2014-04-21','10:35:00',5.44),('11288','2014-04-21','10:40:00',5.5),('11288','2014-04-21','10:45:00',5.59),('11288','2014-04-21','10:50:00',5.65),('11288','2014-04-21','10:55:00',5.69),('11288','2014-04-21','11:00:00',5.74),('11288','2014-04-21','11:05:00',5.8),('11288','2014-04-21','11:10:00',5.82),('11288','2014-04-21','11:15:00',5.83),('11288','2014-04-21','11:20:00',5.89),('11288','2014-04-21','11:25:00',5.96),('11288','2014-04-21','11:30:00',6.01),('11288','2014-04-21','11:35:00',6.07),('11288','2014-04-21','11:40:00',6.14),('11288','2014-04-21','11:45:00',6.13),('11288','2014-04-21','11:50:00',6.23),('11288','2014-04-21','11:55:00',6.29),('11288','2014-04-21','12:00:00',6.37),('11288','2014-04-21','12:05:00',6.44),('11288','2014-04-21','12:10:00',6.47),('11288','2014-04-21','12:15:00',6.54),('11288','2014-04-21','12:20:00',6.61),('11288','2014-04-21','12:25:00',6.58),('11288','2014-04-21','12:30:00',6.6),('11288','2014-04-21','12:35:00',6.63),('11288','2014-04-21','12:40:00',6.64),('11288','2014-04-21','12:45:00',6.67),('11288','2014-04-21','12:50:00',6.71),('11288','2014-04-21','12:55:00',6.7),('11288','2014-04-21','13:00:00',6.71),('11288','2014-04-21','13:05:00',6.72),('11288','2014-04-21','13:10:00',6.7),('11288','2014-04-21','13:15:00',6.7),('11288','2014-04-21','13:20:00',6.65),('11288','2014-04-21','13:25:00',6.63),('11288','2014-04-21','13:30:00',6.64),('11288','2014-04-21','13:35:00',6.62),('11288','2014-04-21','13:40:00',6.64),('11288','2014-04-21','13:45:00',6.72),('11288','2014-04-21','13:50:00',6.73),('11288','2014-04-21','13:55:00',6.71),('11288','2014-04-21','14:00:00',6.67),('11288','2014-04-21','14:05:00',6.68),('11288','2014-04-21','14:10:00',6.66),('11288','2014-04-21','14:15:00',6.6),('11288','2014-04-21','14:20:00',6.61),('11288','2014-04-21','14:25:00',6.54),('11288','2014-04-21','14:30:00',6.48),('11288','2014-04-21','14:35:00',6.44),('11288','2014-04-21','14:40:00',6.41),('11288','2014-04-21','14:45:00',6.33),('11288','2014-04-21','14:50:00',6.28),('11288','2014-04-21','14:55:00',6.24),('11288','2014-04-21','15:00:00',6.19),('11288','2014-04-21','15:05:00',6.1),('11288','2014-04-21','15:10:00',6.01),('11288','2014-04-21','15:15:00',5.91),('11288','2014-04-21','15:20:00',5.82),('11288','2014-04-21','15:25:00',5.75),('11288','2014-04-21','15:30:00',5.68),('11288','2014-04-21','15:35:00',5.62),('11288','2014-04-21','15:40:00',5.55),('11288','2014-04-21','15:45:00',5.47),('11288','2014-04-21','15:50:00',5.39),('11288','2014-04-21','15:55:00',5.27),('11288','2014-04-21','16:00:00',5.18),('11288','2014-04-21','16:05:00',5.12),('11288','2014-04-21','16:10:00',5.06),('11288','2014-04-21','16:15:00',5.24),('11288','2014-04-21','16:20:00',4.8),('11288','2014-04-21','16:25:00',4.37),('11288','2014-04-21','16:30:00',4.57),('11288','2014-04-21','16:35:00',4.43),('11288','2014-04-21','16:40:00',4.31),('11288','2014-04-21','16:45:00',4.22),('11288','2014-04-21','16:50:00',4.09),('11288','2014-04-21','16:55:00',3.93),('11288','2014-04-21','17:00:00',3.77),('11288','2014-04-21','17:05:00',3.66),('11288','2014-04-21','17:10:00',3.5),('11288','2014-04-21','17:15:00',3.38),('11288','2014-04-21','17:20:00',3.24),('11288','2014-04-21','17:25:00',3.11),('11288','2014-04-21','17:30:00',3),('11288','2014-04-21','17:35:00',2.83),('11288','2014-04-21','17:40:00',2.56),('11288','2014-04-21','17:45:00',2.53),('11288','2014-04-21','17:50:00',2.37),('11288','2014-04-21','17:55:00',2.22),('11288','2014-04-21','18:00:00',2.07),('11288','2014-04-21','18:05:00',1.91),('11288','2014-04-21','18:10:00',1.72),('11288','2014-04-21','18:15:00',1.62),('11288','2014-04-21','18:20:00',1.51),('11288','2014-04-21','18:25:00',1.37),('11288','2014-04-21','18:30:00',1.26),('11288','2014-04-21','18:35:00',1.16),('11288','2014-04-21','18:40:00',1.01),('11288','2013-12-07','08:35:00',1.07),('11288','2013-12-07','08:40:00',1.08),('11288','2013-12-07','08:45:00',1.23),('11288','2013-12-07','08:50:00',1.33),('11288','2013-12-07','08:55:00',1.44),('11288','2013-12-07','09:00:00',1.53),('11288','2013-12-07','09:05:00',1.64),('11288','2013-12-07','09:10:00',1.72),('11288','2013-12-07','09:15:00',1.79),('11288','2013-12-07','09:20:00',1.86),('11288','2013-12-07','09:25:00',1.95),('11288','2013-12-07','09:30:00',2.09),('11288','2013-12-07','09:35:00',2.16),('11288','2013-12-07','09:40:00',2.24),('11288','2013-12-07','09:45:00',2.28),('11288','2013-12-07','09:50:00',2.39),('11288','2013-12-07','09:55:00',2.36),('11288','2013-12-07','10:00:00',2.51),('11288','2013-12-07','10:05:00',2.65),('11288','2013-12-07','10:10:00',2.75),('11288','2013-12-07','10:15:00',2.79),('11288','2013-12-07','10:20:00',2.84),('11288','2013-12-07','10:25:00',2.96),('11288','2013-12-07','10:30:00',2.98),('11288','2013-12-07','10:35:00',3.07),('11288','2013-12-07','10:40:00',3.16),('11288','2013-12-07','10:45:00',3.22),('11288','2013-12-07','10:50:00',3.24),('11288','2013-12-07','10:55:00',3.27),('11288','2013-12-07','11:00:00',3.31),('11288','2013-12-07','11:05:00',3.35),('11288','2013-12-07','11:10:00',3.39),('11288','2013-12-07','11:15:00',3.39),('11288','2013-12-07','11:20:00',3.39),('11288','2013-12-07','11:25:00',3.4),('11288','2013-12-07','11:30:00',3.4),('11288','2013-12-07','11:35:00',3.43),('11288','2013-12-07','11:40:00',3.43),('11288','2013-12-07','11:45:00',3.45),('11288','2013-12-07','11:50:00',3.43),('11288','2013-12-07','11:55:00',3.4),('11288','2013-12-07','12:00:00',3.35),('11288','2013-12-07','12:05:00',3.43),('11288','2013-12-07','12:10:00',3.42),('11288','2013-12-07','12:15:00',3.43),('11288','2013-12-07','12:20:00',3.41),('11288','2013-12-07','12:25:00',3.36),('11288','2013-12-07','12:30:00',3.32),('11288','2013-12-07','12:35:00',3.33),('11288','2013-12-07','12:40:00',3.32),('11288','2013-12-07','12:45:00',3.3),('11288','2013-12-07','12:50:00',3.24),('11288','2013-12-07','12:55:00',3.19),('11288','2013-12-07','13:00:00',3.13),('11288','2013-12-07','13:05:00',3.13),('11288','2013-12-07','13:10:00',3.11),('11288','2013-12-07','13:15:00',3.08),('11288','2013-12-07','13:20:00',3.04),('11288','2013-12-07','13:25:00',2.97),('11288','2013-12-07','13:30:00',2.92),('11288','2013-12-07','13:35:00',2.87),('11288','2013-12-07','13:40:00',2.81),('11288','2013-12-07','13:45:00',2.7),('11288','2013-12-07','13:50:00',2.61),('11288','2013-12-07','13:55:00',2.51),('11288','2013-12-07','14:00:00',2.42),('11288','2013-12-07','14:05:00',2.37),('11288','2013-12-07','14:10:00',2.28),('11288','2013-12-07','14:15:00',2.14),('11288','2013-12-07','14:20:00',1.99),('11288','2013-12-07','14:25:00',1.91),('11288','2013-12-07','14:30:00',1.84),('11288','2013-12-07','14:35:00',1.7),('11288','2013-12-07','14:40:00',1.61),('11288','2013-12-07','14:45:00',1.5),('11288','2013-12-07','14:50:00',1.43),('11288','2013-12-07','14:55:00',1.22),('11288','2013-12-07','15:00:00',1.13),('11288','2013-12-07','15:05:00',1.15),('11288','2013-12-06','09:15:00',1.08),('11288','2013-12-06','09:20:00',1.12),('11288','2013-12-06','09:25:00',1.14),('11288','2013-12-06','09:30:00',1.05),('11288','2013-12-06','09:35:00',1.01),('11288','2013-12-06','09:40:00',1.17),('11288','2013-12-06','09:45:00',1.22),('11288','2013-12-06','09:50:00',1.17),('11288','2013-12-06','09:55:00',1.27),('11288','2013-12-06','10:00:00',1.28),('11288','2013-12-06','10:05:00',1.53),('11288','2013-12-06','10:10:00',1.77),('11288','2013-12-06','10:15:00',1.75),('11288','2013-12-06','10:20:00',1.51),('11288','2013-12-06','10:25:00',1.35),('11288','2013-12-06','10:30:00',1.25),('11288','2013-12-06','10:35:00',1.11),('11288','2013-12-06','10:40:00',1.03),('11288','2013-12-06','10:45:00',1.14),('11288','2013-12-06','10:50:00',1.27),('11288','2013-12-06','10:55:00',1.42),('11288','2013-12-06','11:00:00',1.62),('11288','2013-12-06','11:05:00',1.72),('11288','2013-12-06','11:10:00',1.59),('11288','2013-12-06','11:15:00',1.52),('11288','2013-12-06','11:20:00',1.68),('11288','2013-12-06','11:25:00',1.76),('11288','2013-12-06','11:30:00',1.84),('11288','2013-12-06','11:35:00',2.05),('11288','2013-12-06','11:40:00',3.06),('11288','2013-12-06','11:45:00',2.46),('11288','2013-12-06','11:50:00',3.19),('11288','2013-12-06','11:55:00',3.46),('11288','2013-12-06','12:00:00',3.67),('11288','2013-12-06','12:05:00',2.36),('11288','2013-12-06','12:10:00',2.77),('11288','2013-12-06','12:15:00',2.38),('11288','2013-12-06','12:20:00',2.77),('11288','2013-12-06','12:25:00',1.79),('11288','2013-12-06','12:30:00',1.9),('11288','2013-12-06','12:35:00',1.96),('11288','2013-12-06','12:40:00',3.2),('11288','2013-12-06','12:45:00',1.98),('11288','2013-12-06','12:50:00',1.81),('11288','2013-12-06','12:55:00',1.6),('11288','2013-12-06','13:00:00',1.54),('11288','2013-12-06','13:05:00',1.32),('11288','2013-12-06','13:10:00',1.19),('11288','2013-12-06','13:15:00',1.17),('11288','2013-12-06','13:20:00',1.17),('11288','2013-12-06','13:25:00',1.33),('11288','2013-12-06','13:30:00',1.46),('11288','2013-12-06','13:35:00',1.53),('11288','2013-12-06','13:40:00',1.67),('11288','2013-12-06','13:45:00',1.72),('11288','2013-12-06','13:50:00',1.56),('11288','2013-12-06','13:55:00',1.44),('11288','2013-12-06','14:00:00',1.32),('11288','2013-12-06','14:05:00',1.27),('11288','2013-12-06','14:10:00',1.34),('11288','2013-12-06','14:15:00',1.25),('11288','2013-12-06','14:20:00',1.25),('11288','2013-12-06','14:25:00',1.32),('11288','2013-12-06','14:30:00',1.3),('11288','2013-12-06','14:35:00',1.36),('11288','2013-12-06','14:40:00',1.5),('11288','2013-12-06','14:45:00',1.64),('11288','2013-12-06','14:50:00',1.33),('11288','2013-12-06','14:55:00',1.04),('11288','2013-12-05','08:35:00',1.03),('11288','2013-12-05','08:40:00',1.18),('11288','2013-12-05','08:45:00',1.31),('11288','2013-12-05','08:50:00',1.4),('11288','2013-12-05','08:55:00',1.5),('11288','2013-12-05','09:00:00',1.6),('11288','2013-12-05','09:05:00',1.69),('11288','2013-12-05','09:10:00',1.79),('11288','2013-12-05','09:15:00',1.85),('11288','2013-12-05','09:20:00',1.92),('11288','2013-12-05','09:25:00',1.99),('11288','2013-12-05','09:30:00',2.11),('11288','2013-12-05','09:35:00',2.19),('11288','2013-12-05','09:40:00',2.28),('11288','2013-12-05','09:45:00',2.33),('11288','2013-12-05','09:50:00',2.4),('11288','2013-12-05','09:55:00',2.38),('11288','2013-12-05','10:00:00',2.59),('11288','2013-12-05','10:05:00',2.68),('11288','2013-12-05','10:10:00',2.79),('11288','2013-12-05','10:15:00',2.87),('11288','2013-12-05','10:20:00',2.92),('11288','2013-12-05','10:25:00',3.03),('11288','2013-12-05','10:30:00',3),('11288','2013-12-05','10:35:00',3.02),('11288','2013-12-05','10:40:00',3.18),('11288','2013-12-05','10:45:00',3.27),('11288','2013-12-05','10:50:00',3.29),('11288','2013-12-05','10:55:00',3.36),('11288','2013-12-05','11:00:00',3.41),('11288','2013-12-05','11:05:00',3.44),('11288','2013-12-05','11:10:00',3.56),('11288','2013-12-05','11:15:00',3.44),('11288','2013-12-05','11:20:00',3.22),('11288','2013-12-05','11:25:00',3.07),('11288','2013-12-05','11:30:00',3.53),('11288','2013-12-05','11:35:00',3.54),('11288','2013-12-05','11:40:00',3.55),('11288','2013-12-05','11:45:00',3.57),('11288','2013-12-05','11:50:00',3.66),('11288','2013-12-05','11:55:00',3.53),('11288','2013-12-05','12:00:00',3.58),('11288','2013-12-05','12:05:00',3.58),('11288','2013-12-05','12:10:00',3.52),('11288','2013-12-05','12:15:00',3.52),('11288','2013-12-05','12:20:00',3.54),('11288','2013-12-05','12:25:00',3.39),('11288','2013-12-05','12:30:00',3.34),('11288','2013-12-05','12:35:00',3.44),('11288','2013-12-05','12:40:00',3.44),('11288','2013-12-05','12:45:00',3.32),('11288','2013-12-05','12:50:00',3.47),('11288','2013-12-05','12:55:00',3.31),('11288','2013-12-05','13:00:00',3.43),('11288','2013-12-05','13:05:00',3.41),('11288','2013-12-05','13:10:00',3.3),('11288','2013-12-05','13:15:00',3.24),('11288','2013-12-05','13:20:00',3.2),('11288','2013-12-05','13:25:00',3.15),('11288','2013-12-05','13:30:00',3.02),('11288','2013-12-05','13:35:00',2.94),('11288','2013-12-05','13:40:00',2.74),('11288','2013-12-05','13:45:00',2.42),('11288','2013-12-05','13:50:00',2.61),('11288','2013-12-05','13:55:00',2.48),('11288','2013-12-05','14:00:00',2.42),('11288','2013-12-05','14:05:00',2.39),('11288','2013-12-05','14:10:00',2.25),('11288','2013-12-05','14:15:00',2.18),('11288','2013-12-05','14:20:00',2.09),('11288','2013-12-05','14:25:00',1.96),('11288','2013-12-05','14:30:00',1.86),('11288','2013-12-05','14:35:00',1.78),('11288','2013-12-05','14:40:00',1.71),('11288','2013-12-05','14:45:00',1.62),('11288','2013-12-05','14:50:00',1.48),('11288','2013-12-05','14:55:00',1.25),('11288','2013-12-05','15:00:00',1.26),('11288','2013-12-05','15:05:00',1.21),('11288','2013-12-04','08:25:00',1.01),('11288','2013-12-04','08:30:00',1.11),('11288','2013-12-04','08:35:00',1.13),('11288','2013-12-04','08:40:00',1.32),('11288','2013-12-04','08:45:00',1.42),('11288','2013-12-04','08:50:00',1.49),('11288','2013-12-04','08:55:00',1.61),('11288','2013-12-04','09:00:00',1.69),('11288','2013-12-04','09:05:00',1.79),('11288','2013-12-04','09:10:00',1.86),('11288','2013-12-04','09:15:00',1.93),('11288','2013-12-04','09:20:00',2.04),('11288','2013-12-04','09:25:00',2.1),('11288','2013-12-04','09:30:00',2.2),('11288','2013-12-04','09:35:00',2.27),('11288','2013-12-04','09:40:00',2.37),('11288','2013-12-04','09:45:00',2.44),('11288','2013-12-04','09:50:00',2.55),('11288','2013-12-04','09:55:00',2.6),('11288','2013-12-04','10:00:00',2.73),('11288','2013-12-04','10:05:00',2.83),('11288','2013-12-04','10:10:00',2.94),('11288','2013-12-04','10:15:00',3.03),('11288','2013-12-04','10:20:00',3.1),('11288','2013-12-04','10:25:00',3.21),('11288','2013-12-04','10:30:00',3.17),('11288','2013-12-04','10:35:00',3.17),('11288','2013-12-04','10:40:00',3.38),('11288','2013-12-04','10:45:00',3.45),('11288','2013-12-04','10:50:00',3.49),('11288','2013-12-04','10:55:00',3.54),('11288','2013-12-04','11:00:00',3.6),('11288','2013-12-04','11:05:00',3.66),('11288','2013-12-04','11:10:00',3.7),('11288','2013-12-04','11:15:00',3.58),('11288','2013-12-04','11:20:00',3.34),('11288','2013-12-04','11:25:00',3.35),('11288','2013-12-04','11:30:00',3.77),('11288','2013-12-04','11:35:00',3.79),('11288','2013-12-04','11:40:00',3.78),('11288','2013-12-04','11:45:00',3.81),('11288','2013-12-04','11:50:00',3.8),('11288','2013-12-04','11:55:00',3.77),('11288','2013-12-04','12:00:00',3.81),('11288','2013-12-04','12:05:00',3.8),('11288','2013-12-04','12:10:00',3.77),('11288','2013-12-04','12:15:00',3.76),('11288','2013-12-04','12:20:00',3.75),('11288','2013-12-04','12:25:00',3.68),('11288','2013-12-04','12:30:00',3.68),('11288','2013-12-04','12:35:00',3.68),('11288','2013-12-04','12:40:00',3.65),('11288','2013-12-04','12:45:00',3.62),('11288','2013-12-04','12:50:00',3.56),('11288','2013-12-04','12:55:00',3.5),('11288','2013-12-04','13:00:00',3.44),('11288','2013-12-04','13:05:00',3.41),('11288','2013-12-04','13:10:00',3.37),('11288','2013-12-04','13:15:00',3.31),('11288','2013-12-04','13:20:00',3.26),('11288','2013-12-04','13:25:00',3.18),('11288','2013-12-04','13:30:00',3.11),('11288','2013-12-04','13:35:00',3.01),('11288','2013-12-04','13:40:00',2.94),('11288','2013-12-04','13:45:00',2.89),('11288','2013-12-04','13:50:00',2.79),('11288','2013-12-04','13:55:00',2.68),('11288','2013-12-04','14:00:00',2.61),('11288','2013-12-04','14:05:00',2.54),('11288','2013-12-04','14:10:00',2.43),('11288','2013-12-04','14:15:00',2.32),('11288','2013-12-04','14:20:00',2.22),('11288','2013-12-04','14:25:00',2.1),('11288','2013-12-04','14:30:00',2.03),('11288','2013-12-04','14:35:00',1.92),('11288','2013-12-04','14:40:00',1.83),('11288','2013-12-04','14:45:00',1.71),('11288','2013-12-04','14:50:00',1.48),('11288','2013-12-04','14:55:00',1.31),('11288','2013-12-04','15:00:00',1.4),('11288','2013-12-04','15:05:00',1.27),('11288','2013-12-04','15:10:00',1.07),('11288','2013-12-04','15:15:00',1.05),('11288','2013-12-03','09:20:00',1.07),('11288','2013-12-03','09:25:00',1.2),('11288','2013-12-03','09:30:00',1.44),('11288','2013-12-03','09:35:00',1.57),('11288','2013-12-03','09:40:00',1.9),('11288','2013-12-03','09:45:00',2.09),('11288','2013-12-03','09:50:00',2.26),('11288','2013-12-03','09:55:00',2.01),('11288','2013-12-03','10:00:00',2.44),('11288','2013-12-03','10:05:00',2.75),('11288','2013-12-03','10:10:00',2.91),('11288','2013-12-03','10:15:00',2.99),('11288','2013-12-03','10:20:00',3.04),('11288','2013-12-03','10:25:00',3.15),('11288','2013-12-03','10:30:00',3.12),('11288','2013-12-03','10:35:00',3.22),('11288','2013-12-03','10:40:00',3.34),('11288','2013-12-03','10:45:00',3.42),('11288','2013-12-03','10:50:00',3.49),('11288','2013-12-03','10:55:00',3.6),('11288','2013-12-03','11:00:00',3.66),('11288','2013-12-03','11:05:00',3.73),('11288','2013-12-03','11:10:00',3.79),('11288','2013-12-03','11:15:00',3.68),('11288','2013-12-03','11:20:00',3.7),('11288','2013-12-03','11:25:00',3.78),('11288','2013-12-03','11:30:00',3.83),('11288','2013-12-03','11:35:00',3.85),('11288','2013-12-03','11:40:00',3.86),('11288','2013-12-03','11:45:00',3.88),('11288','2013-12-03','11:50:00',3.9),('11288','2013-12-03','11:55:00',3.82),('11288','2013-12-03','12:00:00',3.59),('11288','2013-12-03','12:05:00',3.84),('11288','2013-12-03','12:10:00',3.99),('11288','2013-12-03','12:15:00',4.01),('11288','2013-12-03','12:20:00',4.01),('11288','2013-12-03','12:25:00',4.02),('11288','2013-12-03','12:30:00',4.09),('11288','2013-12-03','12:35:00',4.14),('11288','2013-12-03','12:40:00',4.19),('11288','2013-12-03','12:45:00',4.27),('11288','2013-12-03','12:50:00',4.36),('11288','2013-12-03','12:55:00',4.5),('11288','2013-12-03','13:00:00',4.57),('11288','2013-12-03','13:05:00',4.6),('11288','2013-12-03','13:10:00',4.61),('11288','2013-12-03','13:15:00',4.44),('11288','2013-12-03','13:20:00',4.36),('11288','2013-12-03','13:25:00',4.18),('11288','2013-12-03','13:30:00',3.93),('11288','2013-12-03','13:35:00',3.8),('11288','2013-12-03','13:40:00',3.6),('11288','2013-12-03','13:45:00',3.38),('11288','2013-12-03','13:50:00',3.2),('11288','2013-12-03','13:55:00',2.97),('11288','2013-12-03','14:00:00',2.83),('11288','2013-12-03','14:05:00',2.63),('11288','2013-12-03','14:10:00',2.42),('11288','2013-12-03','14:15:00',2.28),('11288','2013-12-03','14:20:00',1.94),('11288','2013-12-03','14:25:00',1.82),('11288','2013-12-03','14:30:00',1.91),('11288','2013-12-03','14:35:00',1.89),('11288','2013-12-03','14:40:00',1.83),('11288','2013-12-03','14:45:00',1.71),('11288','2013-12-03','14:50:00',1.52),('11288','2013-12-03','14:55:00',1.48),('11288','2013-12-03','15:00:00',1.39),('11288','2013-12-03','15:05:00',1.25),('11288','2013-12-03','15:10:00',1.15),('11288','2013-12-03','15:15:00',1.04),('11288','2013-12-02','13:40:00',1.07),('11288','2013-12-02','13:45:00',1.16),('11288','2013-12-02','13:50:00',1.13),('11288','2013-12-02','13:55:00',1.24),('11288','2013-12-02','14:00:00',1.23),('11288','2013-12-02','14:05:00',1.13),('11288','2013-12-01','11:00:00',1.01),('11288','2013-12-01','11:05:00',1.14),('11288','2013-12-01','11:10:00',1.05),('11288','2013-12-01','11:25:00',1.22),('11288','2013-12-01','11:30:00',1.45),('11288','2013-12-01','11:35:00',2.05),('11288','2013-12-01','11:40:00',2.06),('11288','2013-12-01','11:45:00',1.6),('11288','2013-12-01','11:50:00',1.6),('11288','2013-12-01','11:55:00',2.28),('11288','2013-12-01','12:00:00',1.99),('11288','2013-12-01','12:05:00',2.27),('11288','2013-12-01','12:10:00',2.75),('11288','2013-12-01','12:15:00',2.03),('11288','2013-12-01','12:20:00',1.16),('11288','2013-12-01','12:45:00',1.44),('11288','2013-12-01','12:50:00',1.45),('11288','2013-12-01','12:55:00',1.4),('11288','2013-12-01','13:00:00',1.38),('11288','2013-12-01','13:05:00',1.19),('11288','2013-11-30','08:55:00',1.3),('11288','2013-11-30','09:00:00',1.33),('11288','2013-11-30','09:05:00',1.32),('11288','2013-11-30','09:10:00',2.01),('11288','2013-11-30','09:15:00',2.22),('11288','2013-11-30','09:20:00',2.43),('11288','2013-11-30','09:25:00',2.39),('11288','2013-11-30','09:30:00',2.71),('11288','2013-11-30','09:35:00',3),('11288','2013-11-30','09:40:00',2.91),('11288','2013-11-30','09:45:00',2.28),('11288','2013-11-30','09:50:00',1.98),('11288','2013-11-30','09:55:00',1.92),('11288','2013-11-30','10:00:00',1.92),('11288','2013-11-30','10:05:00',1.79),('11288','2013-11-30','10:10:00',1.72),('11288','2013-11-30','10:15:00',1.91),('11288','2013-11-30','10:20:00',2.08),('11288','2013-11-30','10:25:00',2.02),('11288','2013-11-30','10:30:00',2.12),('11288','2013-11-30','10:35:00',2.33),('11288','2013-11-30','10:40:00',2.5),('11288','2013-11-30','10:45:00',2.37),('11288','2013-11-30','10:50:00',2.13),('11288','2013-11-30','10:55:00',1.99),('11288','2013-11-30','11:00:00',1.92),('11288','2013-11-30','11:05:00',2.36),('11288','2013-11-30','11:10:00',2.38),('11288','2013-11-30','11:15:00',2.3),('11288','2013-11-30','11:20:00',2.17),('11288','2013-11-30','11:25:00',2.25),('11288','2013-11-30','11:30:00',2.01),('11288','2013-11-30','11:35:00',1.91),('11288','2013-11-30','11:40:00',1.79),('11288','2013-11-30','11:45:00',1.61),('11288','2013-11-30','11:50:00',1.57),('11288','2013-11-30','11:55:00',1.41),('11288','2013-11-30','12:00:00',1.32),('11288','2013-11-30','12:05:00',1.28),('11288','2013-11-30','12:10:00',1.2),('11288','2013-11-30','12:15:00',1.13),('11288','2013-11-30','12:20:00',1.13),('11288','2013-11-30','12:25:00',1.21),('11288','2013-11-30','12:30:00',1.15),('11288','2013-11-30','12:35:00',1.07),('11288','2013-11-30','13:45:00',1.11),('11288','2013-11-30','13:50:00',1.35),('11288','2013-11-30','13:55:00',1.28),('11288','2013-11-30','14:00:00',1.11),('11288','2013-11-29','08:30:00',1.02),('11288','2013-11-29','08:35:00',1.2),('11288','2013-11-29','08:40:00',1.32),('11288','2013-11-29','08:45:00',1.42),('11288','2013-11-29','08:50:00',1.52),('11288','2013-11-29','08:55:00',1.63),('11288','2013-11-29','09:00:00',1.71),('11288','2013-11-29','09:05:00',1.8),('11288','2013-11-29','09:10:00',1.88),('11288','2013-11-29','09:15:00',1.99),('11288','2013-11-29','09:20:00',2.08),('11288','2013-11-29','09:25:00',2.16),('11288','2013-11-29','09:30:00',2.26),('11288','2013-11-29','09:35:00',2.35),('11288','2013-11-29','09:40:00',2.46),('11288','2013-11-29','09:45:00',2.54),('11288','2013-11-29','09:50:00',2.64),('11288','2013-11-29','09:55:00',2.64),('11288','2013-11-29','10:00:00',2.55),('11288','2013-11-29','10:05:00',2.62),('11288','2013-11-29','10:10:00',3.03),('11288','2013-11-29','10:15:00',3.11),('11288','2013-11-29','10:20:00',3.2),('11288','2013-11-29','10:25:00',3.28),('11288','2013-11-29','10:30:00',3.21),('11288','2013-11-29','10:35:00',3.24),('11288','2013-11-29','10:40:00',3.48),('11288','2013-11-29','10:45:00',3.55),('11288','2013-11-29','10:50:00',3.61),('11288','2013-11-29','10:55:00',3.66),('11288','2013-11-29','11:00:00',3.69),('11288','2013-11-29','11:05:00',3.77),('11288','2013-11-29','11:10:00',3.79),('11288','2013-11-29','11:15:00',3.62),('11288','2013-11-29','11:20:00',3.38),('11288','2013-11-29','11:25:00',3.86),('11288','2013-11-29','11:30:00',3.91),('11288','2013-11-29','11:35:00',3.93),('11288','2013-11-29','11:40:00',3.95),('11288','2013-11-29','11:45:00',3.95),('11288','2013-11-29','11:50:00',3.92),('11288','2013-11-29','11:55:00',3.94),('11288','2013-11-29','12:00:00',3.94),('11288','2013-11-29','12:05:00',3.92),('11288','2013-11-29','12:10:00',3.89),('11288','2013-11-29','12:15:00',3.9),('11288','2013-11-29','12:20:00',3.86),('11288','2013-11-29','12:25:00',3.82),('11288','2013-11-29','12:30:00',3.82),('11288','2013-11-29','12:35:00',3.78),('11288','2013-11-29','12:40:00',3.73),('11288','2013-11-29','12:45:00',3.73),('11288','2013-11-29','12:50:00',3.67),('11288','2013-11-29','12:55:00',3.62),('11288','2013-11-29','13:00:00',3.57),('11288','2013-11-29','13:05:00',3.51),('11288','2013-11-29','13:10:00',3.48),('11288','2013-11-29','13:15:00',3.41),('11288','2013-11-29','13:20:00',3.34),('11288','2013-11-29','13:25:00',3.26),('11288','2013-11-29','13:30:00',3.18),('11288','2013-11-29','13:35:00',3.09),('11288','2013-11-29','13:40:00',3.03),('11288','2013-11-29','13:45:00',2.96),('11288','2013-11-29','13:50:00',2.9),('11288','2013-11-29','13:55:00',2.78),('11288','2013-11-29','14:00:00',2.69),('11288','2013-11-29','14:05:00',2.59),('11288','2013-11-29','14:10:00',2.45),('11288','2013-11-29','14:15:00',2.37),('11288','2013-11-29','14:20:00',2.27),('11288','2013-11-29','14:25:00',2.16),('11288','2013-11-29','14:30:00',2.07),('11288','2013-11-29','14:35:00',1.97),('11288','2013-11-29','14:40:00',1.86),('11288','2013-11-29','14:45:00',1.67),('11288','2013-11-29','14:50:00',1.45),('11288','2013-11-29','14:55:00',1.5),('11288','2013-11-29','15:00:00',1.39),('11288','2013-11-29','15:05:00',1.16),('11288','2013-11-29','15:10:00',1.18),('11288','2013-11-29','15:15:00',1.05),('11288','2013-11-28','09:25:00',1.07),('11288','2013-11-28','09:30:00',1.27),('11288','2013-11-28','09:35:00',1.36),('11288','2013-11-28','09:40:00',1.53),('11288','2013-11-28','09:45:00',1.6),('11288','2013-11-28','09:50:00',1.68),('11288','2013-11-28','09:55:00',1.51),('11288','2013-11-28','10:00:00',1.34),('11288','2013-11-28','10:05:00',1.23),('11288','2013-11-28','11:20:00',1.11),('11288','2013-11-28','11:25:00',1.22),('11288','2013-11-28','12:30:00',1.07),('11288','2013-11-28','12:35:00',1.12),('11288','2013-11-28','12:40:00',1.19),('11288','2013-11-28','12:45:00',1.34),('11288','2013-11-28','12:50:00',1.6),('11288','2013-11-28','12:55:00',1.96),('11288','2013-11-28','13:00:00',1.59),('11288','2013-11-28','13:25:00',1.6),('11288','2013-11-28','13:30:00',1.33),('11288','2013-11-28','13:35:00',1.55),('11288','2013-11-28','13:40:00',1.43),('11288','2013-11-28','13:45:00',1.32),('11288','2013-11-28','13:50:00',1.25),('11288','2013-11-28','14:10:00',1.39),('11288','2013-11-28','14:15:00',1.08),('11288','2014-04-20','07:50:00',1.28),('11288','2014-04-20','07:55:00',1.45),('11288','2014-04-20','08:00:00',1.4),('11288','2014-04-20','08:05:00',1.52),('11288','2014-04-20','08:10:00',1.6),('11288','2014-04-20','08:15:00',1.78),('11288','2014-04-20','08:20:00',2.48),('11288','2014-04-20','08:25:00',2.92),('11288','2014-04-20','08:30:00',3.04),('11288','2014-04-20','08:35:00',2.46),('11288','2014-04-20','08:40:00',1.68),('11288','2014-04-20','08:45:00',2.83),('11288','2014-04-20','08:50:00',1.83),('11288','2014-04-20','08:55:00',2.05),('11288','2014-04-20','09:00:00',2.92),('11288','2014-04-20','09:05:00',2.15),('11288','2014-04-20','09:10:00',3.39),('11288','2014-04-20','09:15:00',3.92),('11288','2014-04-20','09:20:00',4.16),('11288','2014-04-20','09:25:00',4.81),('11288','2014-04-20','09:30:00',5.31),('11288','2014-04-20','09:35:00',4.75),('11288','2014-04-20','09:40:00',3.15),('11288','2014-04-20','09:45:00',2.47),('11288','2014-04-20','09:50:00',2.83),('11288','2014-04-20','09:55:00',3.28),('11288','2014-04-20','10:00:00',3.75),('11288','2014-04-20','10:05:00',4.55),('11288','2014-04-20','10:10:00',4.48),('11288','2014-04-20','10:15:00',5.1),('11288','2014-04-20','10:20:00',5.09),('11288','2014-04-20','10:25:00',4.88),('11288','2014-04-20','10:30:00',4.47),('11288','2014-04-20','10:35:00',4.73),('11288','2014-04-20','10:40:00',4.44),('11288','2014-04-20','10:45:00',4.5),('11288','2014-04-20','10:50:00',4.83),('11288','2014-04-20','10:55:00',4.91),('11288','2014-04-20','11:00:00',5.7),('11288','2014-04-20','11:05:00',5.43),('11288','2014-04-20','11:10:00',5.75),('11288','2014-04-20','11:15:00',3.79),('11288','2014-04-20','11:20:00',5.71),('11288','2014-04-20','11:25:00',6.43),('11288','2014-04-20','11:30:00',6.38),('11288','2014-04-20','11:35:00',6.66),('11288','2014-04-20','11:40:00',3.9),('11288','2014-04-20','11:45:00',5.69),('11288','2014-04-20','11:50:00',4.16),('11288','2014-04-20','11:55:00',7.3),('11288','2014-04-20','12:00:00',7.1),('11288','2014-04-20','12:05:00',7.08),('11288','2014-04-20','12:10:00',5.34),('11288','2014-04-20','12:15:00',2.5),('11288','2014-04-20','12:20:00',4.63),('11288','2014-04-20','12:25:00',4.88),('11288','2014-04-20','12:30:00',7.62),('11288','2014-04-20','12:35:00',7.19),('11288','2014-04-20','12:40:00',7.21),('11288','2014-04-20','12:45:00',7.14),('11288','2014-04-20','12:50:00',7.15),('11288','2014-04-20','12:55:00',7.15),('11288','2014-04-20','13:00:00',7.17),('11288','2014-04-20','13:05:00',7.23),('11288','2014-04-20','13:10:00',7.13),('11288','2014-04-20','13:15:00',6.85),('11288','2014-04-20','13:20:00',7.08),('11288','2014-04-20','13:25:00',7.08),('11288','2014-04-20','13:30:00',7.08),('11288','2014-04-20','13:35:00',7.08),('11288','2014-04-20','13:40:00',7.09),('11288','2014-04-20','13:45:00',7.03),('11288','2014-04-20','13:50:00',7.05),('11288','2014-04-20','13:55:00',7.04),('11288','2014-04-20','14:00:00',6.96),('11288','2014-04-20','14:05:00',6.9),('11288','2014-04-20','14:10:00',6.92),('11288','2014-04-20','14:15:00',7.25),('11288','2014-04-20','14:20:00',5.36),('11288','2014-04-20','14:25:00',5.18),('11288','2014-04-20','14:30:00',4.9),('11288','2014-04-20','14:35:00',4.26),('11288','2014-04-20','14:40:00',4.29),('11288','2014-04-20','14:45:00',4.65),('11288','2014-04-20','14:50:00',4.52),('11288','2014-04-20','14:55:00',5.03),('11288','2014-04-20','15:00:00',6.63),('11288','2014-04-20','15:05:00',5.72),('11288','2014-04-20','15:10:00',6.48),('11288','2014-04-20','15:15:00',6.28),('11288','2014-04-20','15:20:00',6.09),('11288','2014-04-20','15:25:00',6.03),('11288','2014-04-20','15:30:00',5.96),('11288','2014-04-20','15:35:00',5.78),('11288','2014-04-20','15:40:00',5.98),('11288','2014-04-20','15:45:00',3.99),('11288','2014-04-20','15:50:00',4.71),('11288','2014-04-20','15:55:00',5.61),('11288','2014-04-20','16:00:00',5.42),('11288','2014-04-20','16:05:00',5.28),('11288','2014-04-20','16:10:00',5.21),('11288','2014-04-20','16:15:00',5.14),('11288','2014-04-20','16:20:00',5.07),('11288','2014-04-20','16:25:00',4.72),('11288','2014-04-20','16:30:00',4.81),('11288','2014-04-20','16:35:00',4.57),('11288','2014-04-20','16:40:00',4.07),('11288','2014-04-20','16:45:00',3.22),('11288','2014-04-20','16:50:00',3.99),('11288','2014-04-20','16:55:00',4.22),('11288','2014-04-20','17:00:00',3.99),('11288','2014-04-20','17:05:00',3.79),('11288','2014-04-20','17:10:00',3.57),('11288','2014-04-20','17:15:00',3.42),('11288','2014-04-20','17:20:00',3.27),('11288','2014-04-20','17:25:00',3.13),('11288','2014-04-20','17:30:00',2.98),('11288','2014-04-20','17:35:00',2.83),('11288','2014-04-20','17:40:00',2.64),('11288','2014-04-20','17:45:00',2.44),('11288','2014-04-20','17:50:00',2.24),('11288','2014-04-20','17:55:00',2.17),('11288','2014-04-20','18:00:00',2.06),('11288','2014-04-20','18:05:00',1.92),('11288','2014-04-20','18:10:00',1.74),('11288','2014-04-20','18:15:00',1.55),('11288','2014-04-20','18:30:00',1.18),('11288','2014-04-20','18:35:00',1.15),('11288','2013-11-27','08:45:00',1.1),('11288','2013-11-27','08:50:00',1.3),('11288','2013-11-27','08:55:00',1.38),('11288','2013-11-27','09:00:00',1.25),('11288','2013-11-27','09:05:00',1.14),('11288','2013-11-27','09:15:00',1.13),('11288','2013-11-27','09:20:00',1.4),('11288','2013-11-27','09:25:00',1.45),('11288','2013-11-27','09:30:00',1.53),('11288','2013-11-27','09:35:00',1.63),('11288','2013-11-27','09:40:00',1.68),('11288','2013-11-27','09:45:00',1.56),('11288','2013-11-27','09:50:00',1.96),('11288','2013-11-27','09:55:00',2.22),('11288','2013-11-27','10:00:00',2.11),('11288','2013-11-27','10:05:00',2.14),('11288','2013-11-27','10:10:00',2.12),('11288','2013-11-27','10:15:00',2.12),('11288','2013-11-27','10:20:00',1.96),('11288','2013-11-27','10:25:00',1.83),('11288','2013-11-27','10:30:00',1.86),('11288','2013-11-27','10:35:00',1.96),('11288','2013-11-27','10:40:00',2.23),('11288','2013-11-27','10:45:00',2.41),('11288','2013-11-27','10:50:00',2.27),('11288','2013-11-27','10:55:00',2.24),('11288','2013-11-27','11:00:00',2.37),('11288','2013-11-27','11:05:00',2.57),('11288','2013-11-27','11:10:00',2.87),('11288','2013-11-27','11:15:00',2.36),('11288','2013-11-27','11:20:00',2.34),('11288','2013-11-27','11:25:00',2.51),('11288','2013-11-27','11:30:00',3.77),('11288','2013-11-27','11:35:00',3.28),('11288','2013-11-27','11:40:00',2.68),('11288','2013-11-27','11:45:00',2.69),('11288','2013-11-27','11:50:00',3.72),('11288','2013-11-27','11:55:00',3.72),('11288','2013-11-27','12:00:00',4.39),('11288','2013-11-27','12:05:00',3.48),('11288','2013-11-27','12:10:00',2.29),('11288','2013-11-27','12:15:00',2.7),('11288','2013-11-27','12:20:00',3.94),('11288','2013-11-27','12:25:00',2.61),('11288','2013-11-27','12:30:00',2.13),('11288','2013-11-27','12:35:00',4.31),('11288','2013-11-27','12:40:00',2.06),('11288','2013-11-27','12:45:00',1.67),('11288','2013-11-27','12:50:00',1.7),('11288','2013-11-27','12:55:00',1.73),('11288','2013-11-27','13:00:00',1.82),('11288','2013-11-27','13:05:00',1.81),('11288','2013-11-27','13:10:00',1.81),('11288','2013-11-27','13:15:00',1.8),('11288','2013-11-27','13:20:00',1.77),('11288','2013-11-27','13:25:00',1.73),('11288','2013-11-27','13:30:00',1.75),('11288','2013-11-27','13:35:00',1.67),('11288','2013-11-27','13:40:00',1.73),('11288','2013-11-27','13:45:00',1.57),('11288','2013-11-27','13:50:00',1.3),('11288','2013-11-27','13:55:00',1.17),('11288','2013-11-27','14:00:00',1.2),('11288','2013-11-27','14:05:00',1.05),('11288','2013-11-26','08:10:00',1.02),('11288','2013-11-26','08:45:00',1.11),('11288','2013-11-26','08:55:00',1.1),('11288','2013-11-26','09:00:00',1.4),('11288','2013-11-26','09:05:00',1.62),('11288','2013-11-26','09:10:00',1.94),('11288','2013-11-26','09:15:00',1.85),('11288','2013-11-26','09:20:00',1.82),('11288','2013-11-26','09:25:00',1.73),('11288','2013-11-26','09:30:00',1.87),('11288','2013-11-26','09:35:00',1.89),('11288','2013-11-26','09:40:00',2.34),('11288','2013-11-26','09:45:00',1.73),('11288','2013-11-26','09:50:00',1.8),('11288','2013-11-26','09:55:00',2.64),('11288','2013-11-26','10:00:00',2.17),('11288','2013-11-26','10:05:00',2.28),('11288','2013-11-26','10:10:00',2.03),('11288','2013-11-26','10:15:00',1.51),('11288','2013-11-26','10:20:00',2.17),('11288','2013-11-26','10:25:00',2.28),('11288','2013-11-26','10:30:00',2.58),('11288','2013-11-26','10:35:00',3.78),('11288','2013-11-26','10:40:00',3.81),('11288','2013-11-26','10:45:00',3.9),('11288','2013-11-26','10:50:00',3.89),('11288','2013-11-26','10:55:00',4.01),('11288','2013-11-26','11:00:00',4.21),('11288','2013-11-26','11:05:00',4.12),('11288','2013-11-26','11:10:00',4.78),('11288','2013-11-26','11:15:00',4.85),('11288','2013-11-26','11:20:00',3.45),('11288','2013-11-26','11:25:00',4.74),('11288','2013-11-26','11:30:00',4.83),('11288','2013-11-26','11:35:00',3.61),('11288','2013-11-26','11:40:00',3.91),('11288','2013-11-26','11:45:00',5.1),('11288','2013-11-26','11:50:00',4.25),('11288','2013-11-26','11:55:00',3.46),('11288','2013-11-26','12:00:00',1.96),('11288','2013-11-26','12:05:00',2.45),('11288','2013-11-26','12:10:00',1.05),('11288','2013-11-26','12:15:00',1.79),('11288','2013-11-26','12:20:00',4.14),('11288','2013-11-26','12:25:00',4.2),('11288','2013-11-26','12:30:00',4.14),('11288','2013-11-26','12:35:00',4.12),('11288','2013-11-26','12:40:00',4.13),('11288','2013-11-26','12:45:00',4.06),('11288','2013-11-26','12:50:00',3.99),('11288','2013-11-26','12:55:00',3.95),('11288','2013-11-26','13:00:00',3.91),('11288','2013-11-26','13:05:00',3.86),('11288','2013-11-26','13:10:00',3.82),('11288','2013-11-26','13:15:00',3.72),('11288','2013-11-26','13:20:00',3.66),('11288','2013-11-26','13:25:00',3.6),('11288','2013-11-26','13:30:00',3.52),('11288','2013-11-26','13:35:00',3.44),('11288','2013-11-26','13:40:00',3.37),('11288','2013-11-26','13:45:00',3.32),('11288','2013-11-26','13:50:00',3.35),('11288','2013-11-26','13:55:00',3.23),('11288','2013-11-26','14:00:00',3.51),('11288','2013-11-26','14:05:00',3.64),('11288','2013-11-26','14:10:00',3.57),('11288','2013-11-26','14:15:00',4.1),('11288','2013-11-26','14:20:00',3.71),('11288','2013-11-26','14:25:00',2.41),('11288','2013-11-26','14:30:00',1.65),('11288','2013-11-26','14:35:00',2.1),('11288','2013-11-26','14:40:00',2.16),('11288','2013-11-26','14:45:00',2.31),('11288','2013-11-26','14:50:00',2.14),('11288','2013-11-26','14:55:00',2.56),('11288','2013-11-26','15:00:00',2.18),('11288','2013-11-26','15:05:00',1.74),('11288','2013-11-26','15:10:00',1.6),('11288','2013-11-26','15:15:00',1.34),('11288','2013-11-26','15:20:00',1.19),('11288','2013-11-26','15:25:00',1.1),('11288','2013-11-25','08:15:00',1.08),('11288','2013-11-25','08:20:00',1.26),('11288','2013-11-25','08:25:00',1.48),('11288','2013-11-25','08:30:00',1.45),('11288','2013-11-25','08:35:00',1.75),('11288','2013-11-25','08:40:00',1.89),('11288','2013-11-25','08:45:00',2.1),('11288','2013-11-25','08:50:00',2.29),('11288','2013-11-25','08:55:00',2.51),('11288','2013-11-25','09:00:00',2.84),('11288','2013-11-25','09:05:00',2.94),('11288','2013-11-25','09:10:00',2.92),('11288','2013-11-25','09:15:00',3.07),('11288','2013-11-25','09:20:00',3.47),('11288','2013-11-25','09:25:00',2.65),('11288','2013-11-25','09:30:00',2.34),('11288','2013-11-25','09:35:00',2.61),('11288','2013-11-25','09:40:00',2.94),('11288','2013-11-25','09:45:00',2.1),('11288','2013-11-25','09:50:00',3.08),('11288','2013-11-25','09:55:00',2.67),('11288','2013-11-25','10:00:00',2.39),('11288','2013-11-25','10:05:00',3.08),('11288','2013-11-25','10:10:00',2.1),('11288','2013-11-25','10:15:00',3.25),('11288','2013-11-25','10:20:00',1.73),('11288','2013-11-25','10:25:00',2.41),('11288','2013-11-25','10:30:00',2.9),('11288','2013-11-25','10:35:00',3.24),('11288','2013-11-25','10:40:00',4.66),('11288','2013-11-25','10:45:00',4.23),('11288','2013-11-25','10:50:00',3.47),('11288','2013-11-25','10:55:00',3.92),('11288','2013-11-25','11:00:00',4.04),('11288','2013-11-25','11:05:00',4.34),('11288','2013-11-25','11:10:00',4.99),('11288','2013-11-25','11:15:00',4.25),('11288','2013-11-25','11:20:00',1.92),('11288','2013-11-25','11:25:00',2.11),('11288','2013-11-25','11:30:00',2.62),('11288','2013-11-25','11:35:00',2.07),('11288','2013-11-25','11:40:00',1.88),('11288','2013-11-25','11:45:00',2.03),('11288','2013-11-25','11:50:00',2.42),('11288','2013-11-25','11:55:00',1.96),('11288','2013-11-25','12:00:00',2.58),('11288','2013-11-25','12:05:00',2.63),('11288','2013-11-25','12:10:00',3.4),('11288','2013-11-25','12:15:00',2.8),('11288','2013-11-25','12:20:00',2.31),('11288','2013-11-25','12:25:00',2.45),('11288','2013-11-25','12:30:00',2.17),('11288','2013-11-25','12:35:00',1.99),('11288','2013-11-25','12:40:00',3.74),('11288','2013-11-25','12:45:00',3.67),('11288','2013-11-25','12:50:00',3.23),('11288','2013-11-25','12:55:00',3.71),('11288','2013-11-25','13:00:00',4.6),('11288','2013-11-25','13:05:00',4.3),('11288','2013-11-25','13:10:00',3.89),('11288','2013-11-25','13:15:00',3.06),('11288','2013-11-25','13:20:00',5.03),('11288','2013-11-25','13:25:00',4.8),('11288','2013-11-25','13:30:00',2.95),('11288','2013-11-25','13:35:00',1.85),('11288','2013-11-25','13:40:00',1.6),('11288','2013-11-25','13:45:00',1.55),('11288','2013-11-25','13:50:00',1.56),('11288','2013-11-25','13:55:00',1.24),('11288','2013-11-25','14:00:00',1.03),('11288','2013-11-24','09:50:00',1.49),('11288','2013-11-24','09:55:00',2.19),('11288','2013-11-24','10:00:00',2.57),('11288','2013-11-24','10:05:00',2.67),('11288','2013-11-24','10:10:00',2.72),('11288','2013-11-24','10:15:00',2.52),('11288','2013-11-24','10:20:00',2.27),('11288','2013-11-24','10:25:00',2.92),('11288','2013-11-24','10:30:00',2.62),('11288','2013-11-24','10:35:00',2.03),('11288','2013-11-24','10:40:00',1.72),('11288','2013-11-24','10:45:00',1.68),('11288','2013-11-24','10:50:00',1.8),('11288','2013-11-24','10:55:00',1.98),('11288','2013-11-24','11:00:00',2.07),('11288','2013-11-24','11:05:00',2.17),('11288','2013-11-24','11:10:00',2.27),('11288','2013-11-24','11:15:00',2.34),('11288','2013-11-24','11:20:00',2.49),('11288','2013-11-24','11:25:00',2.52),('11288','2013-11-24','11:30:00',2.52),('11288','2013-11-24','11:35:00',2.16),('11288','2013-11-24','11:40:00',2.03),('11288','2013-11-24','11:45:00',2.04),('11288','2013-11-24','11:50:00',2.22),('11288','2013-11-24','11:55:00',1.99),('11288','2013-11-24','12:00:00',1.54),('11288','2013-11-24','12:05:00',1.24),('11288','2013-11-24','12:10:00',1.16),('11288','2013-11-24','12:15:00',1.46),('11288','2013-11-24','12:20:00',1.68),('11288','2013-11-24','12:25:00',1.8),('11288','2013-11-24','12:30:00',1.76),('11288','2013-11-24','12:35:00',1.74),('11288','2013-11-24','12:40:00',1.79),('11288','2013-11-24','12:45:00',1.77),('11288','2013-11-24','12:50:00',1.75),('11288','2013-11-24','12:55:00',1.68),('11288','2013-11-24','13:00:00',1.97),('11288','2013-11-24','13:05:00',2.48),('11288','2013-11-24','13:10:00',2.48),('11288','2013-11-24','13:15:00',2.4),('11288','2013-11-24','13:20:00',2.08),('11288','2013-11-24','13:25:00',1.76),('11288','2013-11-24','13:30:00',1.54),('11288','2013-11-24','13:35:00',1.49),('11288','2013-11-24','13:40:00',1.44),('11288','2013-11-24','13:45:00',1.33),('11288','2013-11-24','13:50:00',1.22),('11288','2013-11-24','13:55:00',1.1),('11288','2013-11-24','14:00:00',1.14),('11288','2013-11-24','14:05:00',1.13),('11288','2013-11-24','14:10:00',1.07),('11288','2013-11-24','14:15:00',1.05),('11288','2013-11-24','14:20:00',1.03),('11288','2013-11-24','14:25:00',1.01),('11288','2013-11-23','08:20:00',1.19),('11288','2013-11-23','08:25:00',1.26),('11288','2013-11-23','08:35:00',1.11),('11288','2013-11-23','08:40:00',1.19),('11288','2013-11-23','10:00:00',1.11),('11288','2013-11-23','10:05:00',1.21),('11288','2013-11-23','10:10:00',1.24),('11288','2013-11-23','10:15:00',1.96),('11288','2013-11-23','10:20:00',2.02),('11288','2013-11-23','10:25:00',2.53),('11288','2013-11-23','10:30:00',2.6),('11288','2013-11-23','10:35:00',1.93),('11288','2013-11-23','10:40:00',3.25),('11288','2013-11-23','11:20:00',1.06),('11288','2013-11-23','11:25:00',1.34),('11288','2013-11-23','11:30:00',1.22),('11288','2013-11-23','11:35:00',1.12),('11288','2013-11-23','11:40:00',1.37),('11288','2013-11-23','11:45:00',1.25),('11288','2013-11-23','13:20:00',1.73),('11288','2013-11-23','13:25:00',2.21),('11288','2013-11-23','13:30:00',2.04),('11288','2013-11-23','13:35:00',2.58),('11288','2013-11-23','13:40:00',2.16),('11288','2013-11-23','13:45:00',1.52),('11288','2013-11-23','13:50:00',1.67),('11288','2013-11-23','13:55:00',1.85),('11288','2013-11-23','14:00:00',1.95),('11288','2013-11-23','14:05:00',1.83),('11288','2013-11-23','14:50:00',1),('11288','2013-11-23','14:55:00',1.17),('11288','2013-11-23','15:00:00',1.12),('11288','2013-11-23','15:05:00',1.01),('11288','2013-11-23','16:15:00',1.13),('11288','2013-11-22','09:20:00',1),('11288','2013-11-22','10:00:00',1.11),('11288','2013-11-21','08:10:00',1.41),('11288','2013-11-21','08:15:00',1.57),('11288','2013-11-21','09:05:00',1.09),('11288','2013-11-21','09:10:00',1.62),('11288','2013-11-21','09:15:00',1.63),('11288','2013-11-21','09:20:00',1.64),('11288','2013-11-21','09:25:00',1.73),('11288','2013-11-21','09:30:00',1.41),('11288','2013-11-21','09:35:00',1.24),('11288','2013-11-21','09:40:00',2.08),('11288','2013-11-21','09:45:00',2.64),('11288','2013-11-21','09:50:00',1.74),('11288','2013-11-21','09:55:00',2.32),('11288','2013-11-21','10:00:00',2.71),('11288','2013-11-21','10:05:00',3.16),('11288','2013-11-21','10:10:00',2.7),('11288','2013-11-21','10:15:00',3.42),('11288','2013-11-21','10:20:00',2.94),('11288','2013-11-21','10:25:00',2.23),('11288','2013-11-21','10:30:00',2.94),('11288','2013-11-21','10:35:00',3.56),('11288','2013-11-21','10:40:00',3.96),('11288','2013-11-21','10:45:00',2.68),('11288','2013-11-21','10:50:00',1.03),('11288','2013-11-21','11:00:00',1.17),('11288','2013-11-21','11:05:00',1.17),('11288','2013-11-21','11:10:00',1.19),('11288','2013-11-21','11:15:00',1.65),('11288','2013-11-21','11:20:00',2.4),('11288','2013-11-21','11:25:00',2.39),('11288','2013-11-21','11:30:00',2.7),('11288','2013-11-21','11:35:00',3.29),('11288','2013-11-21','11:40:00',3.07),('11288','2013-11-21','11:45:00',2.77),('11288','2013-11-21','11:50:00',3.23),('11288','2013-11-21','11:55:00',4.03),('11288','2013-11-21','12:00:00',1.74),('11288','2013-11-21','12:05:00',4.07),('11288','2013-11-21','12:10:00',4),('11288','2013-11-21','12:15:00',3.98),('11288','2013-11-21','12:20:00',4),('11288','2013-11-21','12:25:00',4.16),('11288','2013-11-21','12:30:00',4.46),('11288','2013-11-21','12:35:00',4.41),('11288','2013-11-21','12:40:00',4.65),('11288','2013-11-21','12:45:00',4.48),('11288','2013-11-21','12:50:00',4.19),('11288','2013-11-21','12:55:00',4.62),('11288','2013-11-21','13:00:00',4.44),('11288','2013-11-21','13:05:00',4.34),('11288','2013-11-21','13:10:00',4.13),('11288','2013-11-21','13:15:00',4.22),('11288','2013-11-21','13:20:00',3.91),('11288','2013-11-21','13:25:00',3.02),('11288','2013-11-21','13:30:00',1.56),('11288','2013-11-21','13:35:00',1.34),('11288','2013-11-21','13:40:00',2.74),('11288','2013-11-21','13:45:00',2.82),('11288','2013-11-21','13:50:00',1.68),('11288','2013-11-21','13:55:00',2.54),('11288','2013-11-21','14:00:00',2.74),('11288','2013-11-21','14:05:00',1.84),('11288','2013-11-21','14:10:00',1.32),('11288','2013-11-21','14:15:00',1.11),('11288','2013-11-21','14:25:00',1.31),('11288','2013-11-21','14:40:00',1.62),('11288','2013-11-21','14:45:00',1.51),('11288','2013-11-21','14:50:00',1.74),('11288','2013-11-21','14:55:00',1.58),('11288','2013-11-21','15:00:00',1.43),('11288','2013-11-21','15:05:00',1.35),('11288','2013-11-21','15:10:00',1.15),('11288','2013-11-20','08:20:00',1.23),('11288','2013-11-20','09:00:00',1.12),('11288','2013-11-20','09:10:00',1.15),('11288','2013-11-20','09:15:00',1.8),('11288','2013-11-20','09:20:00',1.87),('11288','2013-11-20','09:25:00',2.09),('11288','2013-11-20','09:30:00',2.3),('11288','2013-11-20','09:35:00',1.26),('11288','2013-11-20','09:55:00',1.23),('11288','2013-11-20','10:00:00',2.27),('11288','2013-11-20','10:05:00',1.23),('11288','2013-11-20','10:10:00',1.82),('11288','2013-11-20','10:15:00',2.65),('11288','2013-11-20','10:25:00',1.57),('11288','2013-11-20','10:30:00',1.6),('11288','2013-11-20','10:35:00',1.31),('11288','2013-11-20','10:40:00',1.16),('11288','2013-11-20','10:45:00',1.01),('11288','2013-11-20','10:50:00',1.48),('11288','2013-11-20','10:55:00',1.39),('11288','2013-11-20','11:00:00',1.22),('11288','2013-11-20','11:05:00',1.23),('11288','2013-11-20','11:10:00',1.1),('11288','2013-11-20','11:15:00',1.07),('11288','2013-11-20','11:20:00',1.77),('11288','2013-11-20','11:25:00',2),('11288','2013-11-20','11:30:00',1.82),('11288','2013-11-20','11:35:00',1.78),('11288','2013-11-20','11:40:00',2.04),('11288','2013-11-20','11:45:00',5.34),('11288','2013-11-20','11:50:00',5.47),('11288','2013-11-20','11:55:00',2.79),('11288','2013-11-20','12:00:00',1.24),('11288','2013-11-20','12:10:00',1.15),('11288','2013-11-20','12:15:00',1.83),('11288','2013-11-20','12:20:00',2.66),('11288','2013-11-20','12:25:00',1.77),('11288','2013-11-20','12:30:00',1.26),('11288','2013-11-20','12:35:00',1.45),('11288','2013-11-20','12:40:00',1.66),('11288','2013-11-20','12:45:00',2.04),('11288','2013-11-20','12:50:00',3.88),('11288','2013-11-20','12:55:00',4.41),('11288','2013-11-20','13:00:00',2.75),('11288','2013-11-20','13:05:00',2.68),('11288','2013-11-20','13:10:00',1.37),('11288','2013-11-20','13:15:00',1.59),('11288','2013-11-20','13:20:00',2.5),('11288','2013-11-20','13:25:00',2.2),('11288','2013-11-20','13:30:00',1.25),('11288','2013-11-20','13:35:00',1.53),('11288','2013-11-20','13:40:00',1.51),('11288','2013-11-20','13:45:00',1.9),('11288','2013-11-20','13:50:00',2.4),('11288','2013-11-20','13:55:00',1.34),('11288','2013-11-20','14:00:00',1.45),('11288','2013-11-20','14:05:00',1.46),('11288','2013-11-20','14:10:00',1.38),('11288','2013-11-20','14:15:00',1.37),('11288','2013-11-20','14:20:00',1.51),('11288','2013-11-20','14:25:00',2.05),('11288','2013-11-20','14:30:00',1.29),('11288','2013-11-20','14:35:00',1.26),('11288','2013-11-20','14:40:00',1.65),('11288','2013-11-20','14:45:00',1.75),('11288','2013-11-20','15:05:00',1.72),('11288','2013-11-20','15:10:00',1.57),('11288','2013-11-20','15:15:00',1.11),('11288','2013-11-20','15:20:00',1.07),('11288','2013-11-19','09:35:00',1.73),('11288','2013-11-19','09:40:00',2.8),('11288','2013-11-19','09:45:00',2.63),('11288','2013-11-19','09:50:00',1.23),('11288','2013-11-19','09:55:00',1.5),('11288','2013-11-19','10:00:00',1.99),('11288','2013-11-19','10:05:00',1.77),('11288','2013-11-19','10:10:00',1.09),('11288','2013-11-19','10:20:00',1.07),('11288','2013-11-19','10:45:00',1.26),('11288','2013-11-19','10:50:00',2.36),('11288','2013-11-19','10:55:00',1.56),('11288','2013-11-19','11:05:00',1.29),('11288','2013-11-19','11:10:00',1.49),('11288','2013-11-19','11:15:00',1.42),('11288','2013-11-19','11:20:00',2.94),('11288','2013-11-19','11:25:00',3.32),('11288','2013-11-19','11:30:00',3.8),('11288','2013-11-19','11:35:00',4.17),('11288','2013-11-19','11:40:00',3.52),('11288','2013-11-19','11:45:00',3.81),('11288','2013-11-19','11:50:00',3.53),('11288','2013-11-19','11:55:00',3.18),('11288','2013-11-19','12:00:00',3.11),('11288','2013-11-19','12:05:00',3.67),('11288','2013-11-19','12:10:00',3.04),('11288','2013-11-19','12:15:00',3.71),('11288','2013-11-19','12:20:00',1.7),('11288','2013-11-19','12:25:00',1.52),('11288','2013-11-19','12:30:00',2.46),('11288','2013-11-19','12:40:00',2.22),('11288','2013-11-19','12:45:00',2.87),('11288','2013-11-19','12:50:00',3.06),('11288','2013-11-19','12:55:00',4.4),('11288','2013-11-19','13:00:00',1.54),('11288','2013-11-19','13:05:00',1.48),('11288','2013-11-19','13:10:00',1.87),('11288','2013-11-19','13:15:00',3.08),('11288','2013-11-19','13:20:00',2.52),('11288','2013-11-19','13:30:00',1.05),('11288','2013-11-19','14:30:00',1.18),('11288','2013-11-19','14:35:00',1.08),('11288','2013-11-19','14:40:00',1.27),('11288','2013-11-19','14:45:00',1.15),('11288','2013-11-19','14:50:00',1.14),('11288','2013-11-19','14:55:00',1.17),('11288','2013-11-19','15:25:00',1.76),('11288','2013-11-19','15:30:00',1.88),('11288','2013-11-19','15:35:00',1.16),('11288','2013-11-19','15:40:00',1.01),('11288','2013-11-18','08:05:00',1.11),('11288','2013-11-18','08:10:00',1.05),('11288','2013-11-18','08:15:00',1.03),('11288','2013-11-18','08:20:00',1.21),('11288','2013-11-18','08:25:00',1.31),('11288','2013-11-18','08:30:00',1.43),('11288','2013-11-18','08:35:00',1.41),('11288','2013-11-18','08:40:00',1.43),('11288','2013-11-18','08:45:00',1.42),('11288','2013-11-18','08:50:00',1.37),('11288','2013-11-18','08:55:00',1.45),('11288','2013-11-18','09:00:00',1.51),('11288','2013-11-18','09:05:00',1.4),('11288','2013-11-18','09:10:00',1.38),('11288','2013-11-18','09:15:00',1.82),('11288','2013-11-18','09:20:00',2.19),('11288','2013-11-18','09:25:00',2.32),('11288','2013-11-18','09:30:00',2.1),('11288','2013-11-18','09:35:00',2.73),('11288','2013-11-18','09:40:00',2.1),('11288','2013-11-18','09:45:00',1.88),('11288','2013-11-18','09:50:00',1.66),('11288','2013-11-18','09:55:00',1.82),('11288','2013-11-18','10:00:00',2.07),('11288','2013-11-18','10:05:00',2.25),('11288','2013-11-18','10:10:00',2.6),('11288','2013-11-18','10:15:00',2.64),('11288','2013-11-18','10:20:00',2.22),('11288','2013-11-18','10:25:00',2.17),('11288','2013-11-18','10:30:00',2.02),('11288','2013-11-18','10:35:00',2.06),('11288','2013-11-18','10:40:00',2.15),('11288','2013-11-18','10:45:00',2.22),('11288','2013-11-18','10:50:00',2.09),('11288','2013-11-18','10:55:00',1.86),('11288','2013-11-18','11:00:00',1.7),('11288','2013-11-18','11:05:00',1.56),('11288','2013-11-18','11:10:00',1.42),('11288','2013-11-18','11:15:00',1.32),('11288','2013-11-18','11:20:00',1.45),('11288','2013-11-18','11:25:00',1.69),('11288','2013-11-18','11:30:00',1.89),('11288','2013-11-18','11:35:00',1.97),('11288','2013-11-18','11:40:00',2.04),('11288','2013-11-18','11:45:00',2.09),('11288','2013-11-18','11:50:00',2.18),('11288','2013-11-18','11:55:00',2.32),('11288','2013-11-18','12:00:00',2.42),('11288','2013-11-18','12:05:00',2.5),('11288','2013-11-18','12:10:00',2.48),('11288','2013-11-18','12:15:00',2.56),('11288','2013-11-18','12:20:00',2.68),('11288','2013-11-18','12:25:00',2.73),('11288','2013-11-18','12:30:00',2.47),('11288','2013-11-18','12:35:00',2.2),('11288','2013-11-18','12:40:00',1.91),('11288','2013-11-18','12:45:00',1.73),('11288','2013-11-18','12:50:00',1.62),('11288','2013-11-18','12:55:00',1.57),('11288','2013-11-18','13:00:00',1.55),('11288','2013-11-18','13:05:00',1.66),('11288','2013-11-18','13:10:00',1.79),('11288','2013-11-18','13:15:00',1.72),('11288','2013-11-18','13:20:00',1.59),('11288','2013-11-18','13:25:00',1.46),('11288','2013-11-18','13:30:00',1.64),('11288','2013-11-18','13:35:00',1.94),('11288','2013-11-18','13:40:00',2),('11288','2013-11-18','13:45:00',1.85),('11288','2013-11-18','13:50:00',1.74),('11288','2013-11-18','13:55:00',1.56),('11288','2013-11-18','14:00:00',1.34),('11288','2013-11-18','14:05:00',1.1),('11288','2014-04-19','07:30:00',1.07),('11288','2014-04-19','07:35:00',1.27),('11288','2014-04-19','07:40:00',1.45),('11288','2014-04-19','07:45:00',1.1),('11288','2014-04-19','07:50:00',1.55),('11288','2014-04-19','07:55:00',2.61),('11288','2014-04-19','08:00:00',2.21),('11288','2014-04-19','08:05:00',1.91),('11288','2014-04-19','08:10:00',2.1),('11288','2014-04-19','08:15:00',1.89),('11288','2014-04-19','08:20:00',2.14),('11288','2014-04-19','08:25:00',2.68),('11288','2014-04-19','08:30:00',3.03),('11288','2014-04-19','08:35:00',3.03),('11288','2014-04-19','08:40:00',3.21),('11288','2014-04-19','08:45:00',3.04),('11288','2014-04-19','08:50:00',2.44),('11288','2014-04-19','08:55:00',1.61),('11288','2014-04-19','09:00:00',1.06),('11288','2014-04-19','09:10:00',1.21),('11288','2014-04-19','09:15:00',1.52),('11288','2014-04-19','09:20:00',1.96),('11288','2014-04-19','09:25:00',2.75),('11288','2014-04-19','09:30:00',3.72),('11288','2014-04-19','09:35:00',3.24),('11288','2014-04-19','09:40:00',2.01),('11288','2014-04-19','09:45:00',1.52),('11288','2014-04-19','09:50:00',1.37),('11288','2014-04-19','09:55:00',1.32),('11288','2014-04-19','10:00:00',1.34),('11288','2014-04-19','10:05:00',1.04),('11288','2014-04-19','10:10:00',1.01),('11288','2014-04-19','10:15:00',1.21),('11288','2014-04-19','10:20:00',1.43),('11288','2014-04-19','10:25:00',1.33),('11288','2014-04-19','10:30:00',1.39),('11288','2014-04-19','10:35:00',1.76),('11288','2014-04-19','10:40:00',2.22),('11288','2014-04-19','10:45:00',2.09),('11288','2014-04-19','10:50:00',2.25),('11288','2014-04-19','10:55:00',2.88),('11288','2014-04-19','11:00:00',2.85),('11288','2014-04-19','11:05:00',2.27),('11288','2014-04-19','11:10:00',2.31),('11288','2014-04-19','11:15:00',3.59),('11288','2014-04-19','11:20:00',5.01),('11288','2014-04-19','11:25:00',3.96),('11288','2014-04-19','11:30:00',4.47),('11288','2014-04-19','11:35:00',4.45),('11288','2014-04-19','11:40:00',3.85),('11288','2014-04-19','11:45:00',3.63),('11288','2014-04-19','11:50:00',2.83),('11288','2014-04-19','11:55:00',1.82),('11288','2014-04-19','12:00:00',1.49),('11288','2014-04-19','12:05:00',1.2),('11288','2014-04-19','13:05:00',1.42),('11288','2014-04-19','13:10:00',1.32),('11288','2014-04-19','13:15:00',2.87),('11288','2014-04-19','13:20:00',2.21),('11288','2014-04-19','13:25:00',1.3),('11288','2014-04-19','13:35:00',1.61),('11288','2014-04-19','13:40:00',1.29),('11288','2014-04-19','13:45:00',1.06),('11288','2014-04-19','13:50:00',1.52),('11288','2014-04-19','13:55:00',1.62),('11288','2014-04-19','14:15:00',1.02),('11288','2014-04-19','14:25:00',1.26),('11288','2014-04-19','14:30:00',2.57),('11288','2014-04-19','14:35:00',2.79),('11288','2014-04-19','14:40:00',3.39),('11288','2014-04-19','14:45:00',3.49),('11288','2014-04-19','14:50:00',2.18),('11288','2014-04-19','14:55:00',2.1),('11288','2014-04-19','15:00:00',2.67),('11288','2014-04-19','15:05:00',2.01),('11288','2014-04-19','15:10:00',1.02),('11288','2014-04-19','15:20:00',1.38),('11288','2014-04-19','15:25:00',2.1),('11288','2014-04-19','15:30:00',1.87),('11288','2014-04-19','15:35:00',1.19),('11288','2014-04-19','15:45:00',2.15),('11288','2014-04-19','15:50:00',6.3),('11288','2014-04-19','15:55:00',4.3),('11288','2014-04-19','16:00:00',4.31),('11288','2014-04-19','16:05:00',3.69),('11288','2014-04-19','16:10:00',3.21),('11288','2014-04-19','16:15:00',3.19),('11288','2014-04-19','16:20:00',3.65),('11288','2014-04-19','16:25:00',3.47),('11288','2014-04-19','16:30:00',4.27),('11288','2014-04-19','16:35:00',2.7),('11288','2014-04-19','16:40:00',1.96),('11288','2014-04-19','16:45:00',1.79),('11288','2014-04-19','16:50:00',1.36),('11288','2014-04-19','17:00:00',1.16),('11288','2014-04-19','17:05:00',1.77),('11288','2014-04-19','17:10:00',1.74),('11288','2014-04-19','17:15:00',2.04),('11288','2014-04-19','17:20:00',2.98),('11288','2014-04-19','17:25:00',2.24),('11288','2014-04-19','17:30:00',2.09),('11288','2014-04-19','17:35:00',1.71),('11288','2014-04-19','17:40:00',1.02),('11288','2013-11-17','08:40:00',1.03),('11288','2013-11-17','08:45:00',1.65),('11288','2013-11-17','08:50:00',2.18),('11288','2013-11-17','08:55:00',2.36),('11288','2013-11-17','09:00:00',2.14),('11288','2013-11-17','09:05:00',2.06),('11288','2013-11-17','09:10:00',2.16),('11288','2013-11-17','09:15:00',1.2),('11288','2013-11-17','09:20:00',2.22),('11288','2013-11-17','09:25:00',2.55),('11288','2013-11-17','09:30:00',2.57),('11288','2013-11-17','09:35:00',2.45),('11288','2013-11-17','09:40:00',2.55),('11288','2013-11-17','09:45:00',2.69),('11288','2013-11-17','09:50:00',2.75),('11288','2013-11-17','09:55:00',2.83),('11288','2013-11-17','10:00:00',2.93),('11288','2013-11-17','10:05:00',3),('11288','2013-11-17','10:10:00',3.11),('11288','2013-11-17','10:15:00',3.2),('11288','2013-11-17','10:20:00',3.27),('11288','2013-11-17','10:25:00',3.3),('11288','2013-11-17','10:30:00',3.26),('11288','2013-11-17','10:35:00',3.25),('11288','2013-11-17','10:40:00',3.45),('11288','2013-11-17','10:45:00',3.48),('11288','2013-11-17','10:50:00',3.53),('11288','2013-11-17','10:55:00',3.6),('11288','2013-11-17','11:00:00',3.67),('11288','2013-11-17','11:05:00',3.7),('11288','2013-11-17','11:10:00',3.69),('11288','2013-11-17','11:15:00',3.7),('11288','2013-11-17','11:20:00',3.76),('11288','2013-11-17','11:25:00',3.79),('11288','2013-11-17','11:30:00',3.77),('11288','2013-11-17','11:35:00',3.77),('11288','2013-11-17','11:40:00',3.79),('11288','2013-11-17','11:45:00',3.82),('11288','2013-11-17','11:50:00',3.71),('11288','2013-11-17','11:55:00',3.52),('11288','2013-11-17','12:00:00',3.75),('11288','2013-11-17','12:05:00',3.75),('11288','2013-11-17','12:10:00',3.72),('11288','2013-11-17','12:15:00',3.72),('11288','2013-11-17','12:20:00',3.62),('11288','2013-11-17','12:25:00',3.66),('11288','2013-11-17','12:30:00',3.67),('11288','2013-11-17','12:35:00',3.63),('11288','2013-11-17','12:40:00',3.56),('11288','2013-11-17','12:45:00',3.54),('11288','2013-11-17','12:50:00',3.46),('11288','2013-11-17','12:55:00',3.42),('11288','2013-11-17','13:00:00',3.42),('11288','2013-11-17','13:05:00',3.37),('11288','2013-11-17','13:10:00',3.28),('11288','2013-11-17','13:15:00',3.26),('11288','2013-11-17','13:20:00',3.21),('11288','2013-11-17','13:25:00',3.19),('11288','2013-11-17','13:30:00',3.19),('11288','2013-11-17','13:35:00',3.19),('11288','2013-11-17','13:40:00',2.47),('11288','2013-11-17','13:45:00',2.01),('11288','2013-11-17','13:50:00',2.13),('11288','2013-11-17','14:10:00',1.73),('11288','2013-11-17','14:15:00',2.39),('11288','2013-11-17','14:20:00',2.27),('11288','2013-11-17','14:25:00',2.15),('11288','2013-11-17','14:30:00',2),('11288','2013-11-17','14:35:00',1.93),('11288','2013-11-17','14:40:00',1.75),('11288','2013-11-16','12:45:00',1.03),('11288','2013-11-16','12:50:00',1.35),('11288','2013-11-16','12:55:00',1.43),('11288','2013-11-16','13:00:00',1.6),('11288','2013-11-16','13:05:00',1.86),('11288','2013-11-16','13:10:00',1.6),('11288','2013-11-16','13:15:00',1.27),('11288','2013-11-16','13:20:00',1.09),('11288','2013-11-16','13:25:00',1.06),('11288','2013-11-15','08:50:00',1.06),('11288','2013-11-15','08:55:00',1.2),('11288','2013-11-15','09:00:00',1.35),('11288','2013-11-15','09:05:00',1.57),('11288','2013-11-15','09:10:00',1.93),('11288','2013-11-15','09:15:00',2.2),('11288','2013-11-15','09:20:00',1.83),('11288','2013-11-15','09:25:00',1.79),('11288','2013-11-15','09:30:00',2.2),('11288','2013-11-15','09:35:00',2.31),('11288','2013-11-15','09:40:00',1.9),('11288','2013-11-15','09:45:00',1.27),('11288','2013-11-15','09:50:00',1.02),('11288','2013-11-15','10:00:00',1.08),('11288','2013-11-15','10:05:00',1.27),('11288','2013-11-15','10:10:00',1.89),('11288','2013-11-15','10:15:00',2.33),('11288','2013-11-15','10:20:00',2.14),('11288','2013-11-15','10:25:00',1.71),('11288','2013-11-15','10:30:00',1.51),('11288','2013-11-15','10:35:00',1.36),('11288','2013-11-15','10:40:00',1.24),('11288','2013-11-15','10:45:00',1.33),('11288','2013-11-15','10:50:00',1.83),('11288','2013-11-15','10:55:00',2.23),('11288','2013-11-15','11:00:00',2.2),('11288','2013-11-15','11:05:00',2.12),('11288','2013-11-15','11:10:00',2.06),('11288','2013-11-15','11:15:00',2.16),('11288','2013-11-15','11:20:00',2.68),('11288','2013-11-15','11:25:00',2.79),('11288','2013-11-15','11:30:00',2.92),('11288','2013-11-15','11:35:00',2.84),('11288','2013-11-15','11:40:00',2.96),('11288','2013-11-15','11:45:00',2.53),('11288','2013-11-15','11:50:00',2.2),('11288','2013-11-15','11:55:00',2.02),('11288','2013-11-15','12:00:00',2.09),('11288','2013-11-15','12:05:00',2.14),('11288','2013-11-15','12:10:00',1.86),('11288','2013-11-15','12:15:00',1.94),('11288','2013-11-15','12:20:00',2.39),('11288','2013-11-15','12:25:00',2.46),('11288','2013-11-15','12:30:00',2.14),('11288','2013-11-15','12:35:00',1.95),('11288','2013-11-15','12:40:00',1.87),('11288','2013-11-15','12:45:00',1.83),('11288','2013-11-15','12:50:00',1.9),('11288','2013-11-15','12:55:00',2.16),('11288','2013-11-15','13:00:00',2.2),('11288','2013-11-15','13:05:00',1.92),('11288','2013-11-15','13:10:00',1.74),('11288','2013-11-15','13:15:00',1.48),('11288','2013-11-15','13:20:00',1.44),('11288','2013-11-15','13:25:00',1.62),('11288','2013-11-15','13:30:00',1.78),('11288','2013-11-15','13:35:00',1.99),('11288','2013-11-15','13:40:00',2.27),('11288','2013-11-15','13:45:00',2.77),('11288','2013-11-15','13:50:00',2.79),('11288','2013-11-15','13:55:00',1.91),('11288','2013-11-15','14:00:00',1.77),('11288','2013-11-15','14:05:00',1.53),('11288','2013-11-15','14:10:00',1.28),('11288','2013-11-15','14:15:00',1.03),('11288','2013-11-14','08:15:00',1.1),('11288','2013-11-14','08:55:00',1.36),('11288','2013-11-14','09:00:00',2.34),('11288','2013-11-14','09:05:00',2.44),('11288','2013-11-14','09:10:00',2.19),('11288','2013-11-14','09:15:00',2),('11288','2013-11-14','09:20:00',2.37),('11288','2013-11-14','09:25:00',2.37),('11288','2013-11-14','09:30:00',2.44),('11288','2013-11-14','09:35:00',2.6),('11288','2013-11-14','09:40:00',2.67),('11288','2013-11-14','09:45:00',2.75),('11288','2013-11-14','09:50:00',1.95),('11288','2013-11-14','09:55:00',1.48),('11288','2013-11-14','10:00:00',1.36),('11288','2013-11-14','10:05:00',1.96),('11288','2013-11-14','10:10:00',1.68),('11288','2013-11-14','10:15:00',3.32),('11288','2013-11-14','10:20:00',3.39),('11288','2013-11-14','10:25:00',3.37),('11288','2013-11-14','10:30:00',3.35),('11288','2013-11-14','10:35:00',3.18),('11288','2013-11-14','10:40:00',3.46),('11288','2013-11-14','10:45:00',3.44),('11288','2013-11-14','10:50:00',3.58),('11288','2013-11-14','10:55:00',3.67),('11288','2013-11-14','11:00:00',3.69),('11288','2013-11-14','11:05:00',3.83),('11288','2013-11-14','11:10:00',3.9),('11288','2013-11-14','11:15:00',3.96),('11288','2013-11-14','11:20:00',4.09),('11288','2013-11-14','11:25:00',4.12),('11288','2013-11-14','11:30:00',4.14),('11288','2013-11-14','11:35:00',3.7),('11288','2013-11-14','11:40:00',3.4),('11288','2013-11-14','11:45:00',2.68),('11288','2013-11-14','11:50:00',2.54),('11288','2013-11-14','11:55:00',3.69),('11288','2013-11-14','12:00:00',4.56),('11288','2013-11-14','12:05:00',3.77),('11288','2013-11-14','12:10:00',2.27),('11288','2013-11-14','12:15:00',2.3),('11288','2013-11-14','12:20:00',2.13),('11288','2013-11-14','12:25:00',1.87),('11288','2013-11-14','12:30:00',1.87),('11288','2013-11-14','12:35:00',1.95),('11288','2013-11-14','12:40:00',1.91),('11288','2013-11-14','12:45:00',1.95),('11288','2013-11-14','12:50:00',1.99),('11288','2013-11-14','12:55:00',1.94),('11288','2013-11-14','13:00:00',1.9),('11288','2013-11-14','13:05:00',1.68),('11288','2013-11-14','13:10:00',1.5),('11288','2013-11-14','13:15:00',1.53),('11288','2013-11-14','13:20:00',1.52),('11288','2013-11-14','13:25:00',1.51),('11288','2013-11-14','13:30:00',1.66),('11288','2013-11-14','13:35:00',1.57),('11288','2013-11-14','13:40:00',1.46),('11288','2013-11-14','13:45:00',1.4),('11288','2013-11-14','13:50:00',1.43),('11288','2013-11-14','13:55:00',1.7),('11288','2013-11-14','14:00:00',1.53),('11288','2013-11-14','14:05:00',1.5),('11288','2013-11-14','14:10:00',1.42),('11288','2013-11-14','14:15:00',1.32),('11288','2013-11-14','14:20:00',1.3),('11288','2013-11-14','14:25:00',1.21),('11288','2013-11-14','14:30:00',1.11),('11288','2013-11-14','14:35:00',1.06),('11288','2013-11-13','10:00:00',1.52),('11288','2013-11-13','10:05:00',1.89),('11288','2013-11-13','10:10:00',1.9),('11288','2013-11-13','10:15:00',2.21),('11288','2013-11-13','10:20:00',3.84),('11288','2013-11-13','10:25:00',4.37),('11288','2013-11-13','10:30:00',4.14),('11288','2013-11-13','10:35:00',5.03),('11288','2013-11-13','10:40:00',4.58),('11288','2013-11-13','10:45:00',4.6),('11288','2013-11-13','10:50:00',5.11),('11288','2013-11-13','10:55:00',3.78),('11288','2013-11-13','11:00:00',1.79),('11288','2013-11-13','11:05:00',1.47),('11288','2013-11-13','11:10:00',1.49),('11288','2013-11-13','11:15:00',1.54),('11288','2013-11-13','11:20:00',1.59),('11288','2013-11-13','11:25:00',1.65),('11288','2013-11-13','11:30:00',1.72),('11288','2013-11-13','11:35:00',1.59),('11288','2013-11-13','11:40:00',1.53),('11288','2013-11-13','11:45:00',1.78),('11288','2013-11-13','11:50:00',2.01),('11288','2013-11-13','11:55:00',1.86),('11288','2013-11-13','12:00:00',1.42),('11288','2013-11-13','12:05:00',1.32),('11288','2013-11-13','12:10:00',1.46),('11288','2013-11-13','12:15:00',1.53),('11288','2013-11-13','12:20:00',1.46),('11288','2013-11-13','12:25:00',1.36),('11288','2013-11-13','12:30:00',1.09),('11288','2013-11-13','12:35:00',1.08),('11288','2013-11-13','12:40:00',1.3),('11288','2013-11-13','12:45:00',1.25),('11288','2013-11-13','12:50:00',1.25),('11288','2013-11-13','12:55:00',1.73),('11288','2013-11-13','13:00:00',1.96),('11288','2013-11-13','13:05:00',2.18),('11288','2013-11-13','13:10:00',2.07),('11288','2013-11-13','13:15:00',2.03),('11288','2013-11-13','13:20:00',1.63),('11288','2013-11-13','13:25:00',1.36),('11288','2013-11-13','13:30:00',1.41),('11288','2013-11-13','13:35:00',1.53),('11288','2013-11-13','13:40:00',1.67),('11288','2013-11-13','13:45:00',1.52),('11288','2013-11-13','13:50:00',1.36),('11288','2013-11-13','13:55:00',2.2),('11288','2013-11-13','14:00:00',2.43),('11288','2013-11-13','14:05:00',2.55),('11288','2013-11-13','14:10:00',2.43),('11288','2013-11-13','14:15:00',2.45),('11288','2013-11-13','14:20:00',2.24),('11288','2013-11-13','14:25:00',2.39),('11288','2013-11-13','14:30:00',2.25),('11288','2013-11-13','14:35:00',1.72),('11288','2013-11-13','14:40:00',1.4),('11288','2013-11-13','14:45:00',1.17),('11288','2013-11-13','14:50:00',1.06),('11288','2013-11-12','10:00:00',1.38),('11288','2013-11-12','10:05:00',1.18),('11288','2013-11-12','10:50:00',1.01),('11288','2013-11-12','10:55:00',1.16),('11288','2013-11-12','11:00:00',1.28),('11288','2013-11-12','11:05:00',1.16),('11288','2013-11-12','11:10:00',1.36),('11288','2013-11-12','11:15:00',1.4),('11288','2013-11-12','11:20:00',1.4),('11288','2013-11-12','11:25:00',2.17),('11288','2013-11-12','11:30:00',1.54),('11288','2013-11-12','11:35:00',1.89),('11288','2013-11-12','11:40:00',2.52),('11288','2013-11-12','11:45:00',1.74),('11288','2013-11-12','11:50:00',2.65),('11288','2013-11-12','11:55:00',1.74),('11288','2013-11-12','12:00:00',3.65),('11288','2013-11-12','12:05:00',2.27),('11288','2013-11-12','12:10:00',1.38),('11288','2013-11-12','12:15:00',1.36),('11288','2013-11-12','12:20:00',1.47),('11288','2013-11-12','12:25:00',1.71),('11288','2013-11-12','12:30:00',5.02),('11288','2013-11-12','12:35:00',4.82),('11288','2013-11-12','12:40:00',3.4),('11288','2013-11-12','12:45:00',3.25),('11288','2013-11-12','12:50:00',3.1),('11288','2013-11-12','12:55:00',3.56),('11288','2013-11-12','13:00:00',3.18),('11288','2013-11-12','13:05:00',3.13),('11288','2013-11-12','13:10:00',3.42),('11288','2013-11-12','13:15:00',3.47),('11288','2013-11-12','13:20:00',2.85),('11288','2013-11-12','13:25:00',3.01),('11288','2013-11-12','13:30:00',3.07),('11288','2013-11-12','13:35:00',3.19),('11288','2013-11-12','13:40:00',3.18),('11288','2013-11-12','13:45:00',2.7),('11288','2013-11-12','13:50:00',2.32),('11288','2013-11-12','13:55:00',2.33),('11288','2013-11-12','14:00:00',2.28),('11288','2013-11-12','14:05:00',2.12),('11288','2013-11-12','14:10:00',3.51),('11288','2013-11-12','14:15:00',3.88),('11288','2013-11-12','14:20:00',3.21),('11288','2013-11-12','14:25:00',1.89),('11288','2013-11-12','14:30:00',2.27),('11288','2013-11-12','14:35:00',1.97),('11288','2013-11-12','14:40:00',2),('11288','2013-11-12','14:45:00',1.79),('11288','2013-11-12','14:50:00',1.49),('11288','2013-11-12','14:55:00',1.29),('11288','2013-11-12','15:00:00',1.21),('11288','2013-11-12','15:05:00',1.03),('11288','2013-11-12','15:20:00',1.04),('11288','2013-11-11','09:45:00',1.15),('11288','2013-11-11','09:50:00',2.04),('11288','2013-11-11','09:55:00',2.09),('11288','2013-11-11','10:00:00',1.66),('11288','2013-11-11','10:05:00',1.65),('11288','2013-11-11','10:10:00',2.24),('11288','2013-11-11','10:15:00',3.44),('11288','2013-11-11','10:20:00',3.56),('11288','2013-11-11','10:25:00',1.87),('11288','2013-11-11','10:30:00',1.35),('11288','2013-11-11','10:35:00',1.51),('11288','2013-11-11','10:40:00',1.13),('11288','2013-11-11','10:50:00',1.01),('11288','2013-11-11','11:00:00',1.44),('11288','2013-11-11','11:05:00',2.8),('11288','2013-11-11','11:10:00',5.23),('11288','2013-11-11','11:15:00',4.97),('11288','2013-11-11','11:20:00',3.02),('11288','2013-11-11','11:25:00',3.37),('11288','2013-11-11','11:30:00',5.53),('11288','2013-11-11','11:35:00',4.5),('11288','2013-11-11','11:40:00',4.99),('11288','2013-11-11','11:45:00',4),('11288','2013-11-11','11:50:00',5.04),('11288','2013-11-11','11:55:00',4.86),('11288','2013-11-11','12:00:00',4.63),('11288','2013-11-11','12:05:00',4.45),('11288','2013-11-11','12:10:00',3.78),('11288','2013-11-11','12:15:00',3.79),('11288','2013-11-11','12:20:00',4.37),('11288','2013-11-11','12:25:00',4.54),('11288','2013-11-11','12:30:00',1.76),('11288','2013-11-11','12:35:00',1.07),('11288','2013-11-11','12:40:00',2.48),('11288','2013-11-11','12:45:00',3.02),('11288','2013-11-11','12:50:00',1.5),('11288','2013-11-11','12:55:00',1.31),('11288','2013-11-11','13:00:00',1.84),('11288','2013-11-11','13:05:00',1.65),('11288','2013-11-11','13:10:00',2.37),('11288','2013-11-11','13:15:00',2.47),('11288','2013-11-11','13:30:00',1.12),('11288','2013-11-11','13:35:00',1.77),('11288','2013-11-11','13:40:00',2.48),('11288','2013-11-11','13:45:00',1.02),('11288','2013-11-11','13:50:00',1.06),('11288','2013-11-11','13:55:00',1.35),('11288','2013-11-11','14:00:00',3.29),('11288','2013-11-11','14:05:00',1.99),('11288','2013-11-11','14:10:00',1.4),('11288','2013-11-11','14:15:00',1.34),('11288','2013-11-11','14:20:00',2.06),('11288','2013-11-11','14:25:00',2.54),('11288','2013-11-11','14:30:00',2.34),('11288','2013-11-11','14:35:00',2.55),('11288','2013-11-11','14:40:00',2.17),('11288','2013-11-11','14:45:00',1.26),('11288','2013-11-10','07:40:00',1.06),('11288','2013-11-10','07:45:00',1.28),('11288','2013-11-10','07:50:00',1.47),('11288','2013-11-10','07:55:00',1.43),('11288','2013-11-10','08:00:00',1.52),('11288','2013-11-10','08:05:00',1.23),('11288','2013-11-10','08:10:00',1.2),('11288','2013-11-10','08:15:00',1.24),('11288','2013-11-10','08:20:00',1.46),('11288','2013-11-10','08:25:00',1.36),('11288','2013-11-10','08:30:00',1.51),('11288','2013-11-10','08:35:00',1.81),('11288','2013-11-10','08:40:00',1.92),('11288','2013-11-10','08:45:00',1.68),('11288','2013-11-10','08:50:00',2.24),('11288','2013-11-10','08:55:00',2.14),('11288','2013-11-10','09:00:00',2.17),('11288','2013-11-10','09:05:00',1.78),('11288','2013-11-10','09:10:00',1.61),('11288','2013-11-10','09:15:00',1.9),('11288','2013-11-10','09:20:00',2.32),('11288','2013-11-10','09:25:00',2.73),('11288','2013-11-10','09:30:00',2.27),('11288','2013-11-10','09:35:00',2.34),('11288','2013-11-10','09:40:00',2.61),('11288','2013-11-10','09:45:00',2.91),('11288','2013-11-10','09:50:00',3.05),('11288','2013-11-10','09:55:00',2.98),('11288','2013-11-10','10:00:00',2.89),('11288','2013-11-10','10:05:00',3.44),('11288','2013-11-10','10:10:00',3.71),('11288','2013-11-10','10:15:00',3.7),('11288','2013-11-10','10:20:00',3.43),('11288','2013-11-10','10:25:00',4.17),('11288','2013-11-10','10:30:00',3.95),('11288','2013-11-10','10:35:00',2.61),('11288','2013-11-10','10:40:00',3.98),('11288','2013-11-10','10:45:00',3.69),('11288','2013-11-10','10:50:00',4.37),('11288','2013-11-10','10:55:00',4.77),('11288','2013-11-10','11:00:00',2.37),('11288','2013-11-10','11:05:00',2.18),('11288','2013-11-10','11:10:00',1.69),('11288','2013-11-10','11:20:00',1.78),('11288','2013-11-10','11:25:00',2.23),('11288','2013-11-10','11:30:00',1.49),('11288','2013-11-10','11:35:00',2.16),('11288','2013-11-10','11:40:00',3.58),('11288','2013-11-10','11:45:00',3.87),('11288','2013-11-10','11:50:00',1.5),('11288','2013-11-10','11:55:00',2.31),('11288','2013-11-10','12:00:00',1.38),('11288','2013-11-10','12:05:00',1.8),('11288','2013-11-10','12:10:00',2.73),('11288','2013-11-10','12:15:00',4.23),('11288','2013-11-10','12:20:00',3.75),('11288','2013-11-10','12:25:00',3.93),('11288','2013-11-10','12:30:00',2.28),('11288','2013-11-10','12:35:00',3.82),('11288','2013-11-10','12:40:00',4.45),('11288','2013-11-10','12:45:00',4.71),('11288','2013-11-10','12:50:00',4.91),('11288','2013-11-10','12:55:00',2.89),('11288','2013-11-10','13:00:00',2.13),('11288','2013-11-10','13:05:00',1.3),('11288','2013-11-10','13:10:00',1.45),('11288','2013-11-10','13:35:00',1.53),('11288','2013-11-10','13:40:00',1.32),('11288','2013-11-10','13:45:00',1.89),('11288','2013-11-10','13:50:00',3.29),('11288','2013-11-10','13:55:00',2.25),('11288','2013-11-10','14:20:00',1.32),('11288','2013-11-10','14:25:00',1.04),('11288','2013-11-10','14:30:00',1.76),('11288','2013-11-09','09:10:00',1.03),('11288','2013-11-09','09:15:00',1.32),('11288','2013-11-09','09:30:00',1.47),('11288','2013-11-09','09:35:00',1.35),('11288','2013-11-09','09:40:00',2.3),('11288','2013-11-09','09:45:00',2.47),('11288','2013-11-09','09:50:00',3.64),('11288','2013-11-09','09:55:00',3.32),('11288','2013-11-09','10:00:00',3.37),('11288','2013-11-09','10:05:00',3.27),('11288','2013-11-09','10:10:00',2.89),('11288','2013-11-09','10:15:00',3.22),('11288','2013-11-09','10:20:00',2.96),('11288','2013-11-09','10:25:00',2.01),('11288','2013-11-09','10:30:00',1.97),('11288','2013-11-09','10:35:00',2.27),('11288','2013-11-09','10:40:00',2.32),('11288','2013-11-09','10:45:00',2.31),('11288','2013-11-09','10:50:00',2.86),('11288','2013-11-09','10:55:00',3.02),('11288','2013-11-09','11:00:00',3.01),('11288','2013-11-09','11:05:00',3.43),('11288','2013-11-09','11:10:00',4.02),('11288','2013-11-09','11:15:00',3.58),('11288','2013-11-09','11:20:00',2.81),('11288','2013-11-09','11:25:00',3.14),('11288','2013-11-09','11:30:00',3.34),('11288','2013-11-09','11:35:00',2.49),('11288','2013-11-09','11:40:00',4.08),('11288','2013-11-09','11:45:00',4.86),('11288','2013-11-09','11:50:00',3.75),('11288','2013-11-09','11:55:00',4.84),('11288','2013-11-09','12:00:00',5.42),('11288','2013-11-09','12:05:00',4.84),('11288','2013-11-09','12:10:00',2.55),('11288','2013-11-09','12:15:00',3.27),('11288','2013-11-09','12:20:00',1.91),('11288','2013-11-09','12:25:00',2.85),('11288','2013-11-09','12:30:00',3.47),('11288','2013-11-09','12:35:00',4.67),('11288','2013-11-09','12:40:00',4.71),('11288','2013-11-09','12:45:00',2.52),('11288','2013-11-09','12:50:00',2.33),('11288','2013-11-09','12:55:00',3.07),('11288','2013-11-09','13:00:00',3.38),('11288','2013-11-09','13:05:00',3.8),('11288','2013-11-09','13:10:00',4.32),('11288','2013-11-09','13:15:00',3.66),('11288','2013-11-09','13:20:00',1.39),('11288','2013-11-09','13:25:00',4.03),('11288','2013-11-09','13:30:00',3.65),('11288','2013-11-09','13:35:00',3.56),('11288','2013-11-09','13:40:00',3.39),('11288','2013-11-09','13:45:00',3.33),('11288','2013-11-09','13:50:00',3.33),('11288','2013-11-09','13:55:00',3.27),('11288','2013-11-09','14:00:00',2.62),('11288','2013-11-09','14:05:00',2.79),('11288','2013-11-09','14:10:00',1.43),('11288','2013-11-09','14:15:00',2.03),('11288','2013-11-09','14:20:00',2.86),('11288','2013-11-09','14:25:00',1.85),('11288','2013-11-09','14:35:00',1.71),('11288','2013-11-09','14:40:00',1.77),('11288','2013-11-09','14:45:00',1.31),('11288','2013-11-09','14:50:00',1.68),('11288','2013-11-09','15:30:00',1.18),('11288','2013-11-09','15:35:00',1),('11288','2013-11-08','09:00:00',1.24),('11288','2013-11-08','09:05:00',1.43),('11288','2013-11-08','09:10:00',2),('11288','2013-11-08','09:15:00',1.85),('11288','2013-11-08','09:20:00',1.41),('11288','2013-11-08','09:25:00',1.73),('11288','2013-11-08','09:30:00',2.66),('11288','2013-11-08','09:35:00',2.21),('11288','2013-11-08','09:40:00',1.97),('11288','2013-11-08','09:45:00',1.39),('11288','2013-11-08','09:50:00',3.27),('11288','2013-11-08','09:55:00',3.08),('11288','2013-11-08','10:00:00',3.1),('11288','2013-11-08','10:05:00',2.54),('11288','2013-11-08','10:10:00',2.23),('11288','2013-11-08','10:15:00',1.49),('11288','2013-11-08','10:20:00',1.01),('11288','2013-11-08','10:25:00',1.15),('11288','2013-11-08','10:45:00',2.43),('11288','2013-11-08','10:50:00',3.88),('11288','2013-11-08','10:55:00',1.55),('11288','2013-11-08','11:00:00',1.31),('11288','2013-11-08','11:05:00',1.13),('11288','2013-11-08','11:10:00',1.15),('11288','2013-11-08','11:15:00',1.41),('11288','2013-11-08','11:20:00',2.07),('11288','2013-11-08','11:25:00',1.2),('11288','2013-11-08','11:30:00',1.29),('11288','2013-11-08','11:35:00',2.28),('11288','2013-11-08','11:40:00',2.81),('11288','2013-11-08','11:45:00',2.62),('11288','2013-11-08','11:50:00',4.13),('11288','2013-11-08','11:55:00',4.66),('11288','2013-11-08','12:00:00',4.3),('11288','2013-11-08','12:05:00',4.06),('11288','2013-11-08','12:10:00',3.5),('11288','2013-11-08','12:20:00',2.53),('11288','2013-11-08','12:30:00',3.7),('11288','2013-11-08','12:35:00',4.44),('11288','2013-11-08','12:40:00',4.45),('11288','2013-11-08','12:45:00',4.45),('11288','2013-11-08','12:50:00',4.35),('11288','2013-11-08','12:55:00',4.19),('11288','2013-11-08','13:00:00',4.03),('11288','2013-11-08','13:05:00',4.08),('11288','2013-11-08','13:10:00',3.37),('11288','2013-11-08','13:15:00',1.58),('11288','2013-11-08','13:20:00',2.76),('11288','2013-11-08','13:30:00',2.36),('11288','2013-11-08','13:35:00',3.59),('11288','2013-11-08','13:40:00',3.42),('11288','2013-11-08','13:45:00',3.27),('11288','2013-11-08','13:50:00',3.22),('11288','2013-11-08','13:55:00',3.14),('11288','2013-11-08','14:00:00',3.02),('11288','2013-11-08','14:05:00',2.91),('11288','2013-11-08','14:10:00',2.81),('11288','2013-11-08','14:15:00',2.63),('11288','2013-11-08','14:20:00',1.88),('11288','2013-11-08','14:25:00',2.56),('11288','2013-11-08','14:30:00',2.56),('11288','2013-11-08','14:35:00',2.58),('11288','2013-11-08','14:40:00',2.28),('11288','2013-11-08','14:45:00',2.1),('11288','2013-11-08','14:50:00',1.98),('11288','2013-11-08','14:55:00',1.57),('11288','2013-11-08','15:00:00',1.69),('11288','2013-11-08','15:05:00',1.72),('11288','2013-11-08','15:10:00',1.55),('11288','2013-11-08','15:15:00',1.28),('11288','2014-04-18','08:00:00',1.18),('11288','2014-04-18','08:05:00',1.99),('11288','2014-04-18','08:10:00',2.1),('11288','2014-04-18','08:15:00',1.06),('11288','2014-04-18','08:30:00',1),('11288','2014-04-18','08:35:00',1.47),('11288','2014-04-18','08:40:00',2.09),('11288','2014-04-18','08:45:00',2.32),('11288','2014-04-18','08:50:00',1.92),('11288','2014-04-18','08:55:00',1.8),('11288','2014-04-18','09:00:00',2.03),('11288','2014-04-18','09:05:00',3.48),('11288','2014-04-18','09:10:00',4.57),('11288','2014-04-18','09:15:00',4.4),('11288','2014-04-18','09:20:00',4.18),('11288','2014-04-18','09:25:00',2.51),('11288','2014-04-18','09:30:00',4.11),('11288','2014-04-18','09:35:00',2.78),('11288','2014-04-18','09:40:00',1.77),('11288','2014-04-18','09:45:00',2.67),('11288','2014-04-18','09:50:00',4.34),('11288','2014-04-18','09:55:00',5.18),('11288','2014-04-18','10:00:00',4.32),('11288','2014-04-18','10:05:00',2.93),('11288','2014-04-18','10:10:00',2.59),('11288','2014-04-18','10:15:00',2.8),('11288','2014-04-18','10:20:00',2.64),('11288','2014-04-18','10:25:00',2.7),('11288','2014-04-18','10:30:00',2.29),('11288','2014-04-18','10:35:00',2.1),('11288','2014-04-18','10:40:00',2.42),('11288','2014-04-18','10:45:00',3.84),('11288','2014-04-18','10:50:00',4.33),('11288','2014-04-18','10:55:00',4.72),('11288','2014-04-18','11:00:00',3.29),('11288','2014-04-18','11:05:00',2.95),('11288','2014-04-18','11:10:00',3.19),('11288','2014-04-18','11:15:00',5.24),('11288','2014-04-18','11:20:00',3.4),('11288','2014-04-18','11:25:00',2.52),('11288','2014-04-18','11:30:00',2.93),('11288','2014-04-18','11:35:00',2.93),('11288','2014-04-18','11:40:00',3.05),('11288','2014-04-18','11:45:00',2.9),('11288','2014-04-18','11:50:00',3.51),('11288','2014-04-18','11:55:00',3.11),('11288','2014-04-18','12:00:00',3.24),('11288','2014-04-18','12:05:00',6.03),('11288','2014-04-18','12:10:00',6.03),('11288','2014-04-18','12:15:00',6.32),('11288','2014-04-18','12:20:00',6.38),('11288','2014-04-18','12:25:00',4.86),('11288','2014-04-18','12:30:00',7.34),('11288','2014-04-18','12:35:00',7.05),('11288','2014-04-18','12:40:00',7.39),('11288','2014-04-18','12:45:00',5.88),('11288','2014-04-18','12:50:00',6.12),('11288','2014-04-18','12:55:00',4.55),('11288','2014-04-18','13:00:00',7.38),('11288','2014-04-18','13:05:00',4.07),('11288','2014-04-18','13:10:00',4.18),('11288','2014-04-18','13:15:00',4.06),('11288','2014-04-18','13:20:00',3.86),('11288','2014-04-18','13:25:00',2.95),('11288','2014-04-18','13:30:00',2.39),('11288','2014-04-18','13:35:00',2.45),('11288','2014-04-18','13:40:00',2.39),('11288','2014-04-18','13:45:00',2.05),('11288','2014-04-18','13:50:00',2.43),('11288','2014-04-18','13:55:00',4.06),('11288','2014-04-18','14:00:00',3.58),('11288','2014-04-18','14:05:00',3.16),('11288','2014-04-18','14:10:00',2.7),('11288','2014-04-18','14:15:00',2.42),('11288','2014-04-18','14:20:00',2.81),('11288','2014-04-18','14:25:00',3.57),('11288','2014-04-18','14:30:00',4.06),('11288','2014-04-18','14:35:00',4.51),('11288','2014-04-18','14:40:00',3.93),('11288','2014-04-18','14:45:00',4.58),('11288','2014-04-18','14:50:00',4.93),('11288','2014-04-18','14:55:00',4.03),('11288','2014-04-18','15:00:00',7.39),('11288','2014-04-18','15:05:00',4.5),('11288','2014-04-18','15:10:00',3.21),('11288','2014-04-18','15:15:00',3.64),('11288','2014-04-18','15:20:00',3.22),('11288','2014-04-18','15:25:00',3.93),('11288','2014-04-18','15:30:00',5.38),('11288','2014-04-18','15:35:00',6.05),('11288','2014-04-18','15:40:00',6.01),('11288','2014-04-18','15:45:00',4.05),('11288','2014-04-18','15:50:00',4.56),('11288','2014-04-18','15:55:00',4.82),('11288','2014-04-18','16:00:00',4.1),('11288','2014-04-18','16:05:00',3.19),('11288','2014-04-18','16:10:00',2.6),('11288','2014-04-18','16:15:00',2.29),('11288','2014-04-18','16:20:00',2.38),('11288','2014-04-18','16:25:00',3.93),('11288','2014-04-18','16:30:00',4.21),('11288','2014-04-18','16:35:00',4.99),('11288','2014-04-18','16:40:00',4.89),('11288','2014-04-18','16:45:00',4.46),('11288','2014-04-18','16:50:00',4.47),('11288','2014-04-18','16:55:00',4.35),('11288','2014-04-18','17:00:00',4.5),('11288','2014-04-18','17:05:00',4.42),('11288','2014-04-18','17:10:00',3.59),('11288','2014-04-18','17:15:00',3.32),('11288','2014-04-18','17:20:00',3.31),('11288','2014-04-18','17:25:00',3.25),('11288','2014-04-18','17:30:00',2.91),('11288','2014-04-18','17:35:00',2.78),('11288','2014-04-18','17:40:00',2.65),('11288','2014-04-18','17:45:00',2.47),('11288','2014-04-18','17:50:00',2.34),('11288','2014-04-18','17:55:00',2.22),('11288','2014-04-18','18:00:00',2.11),('11288','2014-04-18','18:05:00',1.89),('11288','2014-04-18','18:10:00',1.74),('11288','2014-04-18','18:15:00',1.54),('11288','2014-04-18','18:20:00',1.42),('11288','2014-04-18','18:25:00',1.25),('11288','2014-04-18','18:35:00',1.01),('11288','2013-11-07','08:00:00',1.01),('11288','2013-11-07','08:05:00',1.01),('11288','2013-11-07','08:10:00',1.21),('11288','2013-11-07','08:15:00',1.31),('11288','2013-11-07','08:20:00',1.37),('11288','2013-11-07','08:25:00',1.49),('11288','2013-11-07','08:30:00',1.58),('11288','2013-11-07','08:35:00',1.66),('11288','2013-11-07','08:40:00',1.72),('11288','2013-11-07','08:45:00',1.82),('11288','2013-11-07','08:50:00',1.92),('11288','2013-11-07','08:55:00',2.07),('11288','2013-11-07','09:00:00',2.13),('11288','2013-11-07','09:05:00',2.2),('11288','2013-11-07','09:10:00',2.37),('11288','2013-11-07','09:15:00',2.43),('11288','2013-11-07','09:20:00',2.41),('11288','2013-11-07','09:25:00',2.55),('11288','2013-11-07','09:30:00',2.54),('11288','2013-11-07','09:35:00',2.73),('11288','2013-11-07','09:40:00',2.85),('11288','2013-11-07','09:45:00',2.97),('11288','2013-11-07','09:50:00',3.07),('11288','2013-11-07','09:55:00',3.13),('11288','2013-11-07','10:00:00',3.11),('11288','2013-11-07','10:05:00',2.94),('11288','2013-11-07','10:10:00',3.16),('11288','2013-11-07','10:15:00',3.35),('11288','2013-11-07','10:20:00',3.38),('11288','2013-11-07','10:25:00',3.47),('11288','2013-11-07','10:30:00',3.46),('11288','2013-11-07','10:35:00',3.35),('11288','2013-11-07','10:40:00',3.6),('11288','2013-11-07','10:45:00',3.63),('11288','2013-11-07','10:50:00',3.68),('11288','2013-11-07','10:55:00',3.71),('11288','2013-11-07','11:00:00',3.75),('11288','2013-11-07','11:05:00',3.78),('11288','2013-11-07','11:10:00',3.73),('11288','2013-11-07','11:15:00',3.76),('11288','2013-11-07','11:20:00',3.82),('11288','2013-11-07','11:25:00',3.78),('11288','2013-11-07','11:30:00',3.87),('11288','2013-11-07','11:35:00',3.91),('11288','2013-11-07','11:40:00',3.88),('11288','2013-11-07','11:45:00',3.86),('11288','2013-11-07','11:50:00',3.75),('11288','2013-11-07','11:55:00',3.68),('11288','2013-11-07','12:00:00',3.83),('11288','2013-11-07','12:05:00',3.82),('11288','2013-11-07','12:10:00',3.81),('11288','2013-11-07','12:15:00',3.7),('11288','2013-11-07','12:20:00',3.68),('11288','2013-11-07','12:25:00',3.69),('11288','2013-11-07','12:30:00',3.61),('11288','2013-11-07','12:35:00',3.71),('11288','2013-11-07','12:40:00',3.74),('11288','2013-11-07','12:45:00',3.72),('11288','2013-11-07','12:50:00',3.65),('11288','2013-11-07','12:55:00',3.87),('11288','2013-11-07','13:00:00',4.07),('11288','2013-11-07','13:05:00',1.74),('11288','2013-11-07','13:10:00',1.55),('11288','2013-11-07','13:15:00',1.79),('11288','2013-11-07','13:20:00',1.97),('11288','2013-11-07','13:25:00',3.61),('11288','2013-11-07','13:30:00',2.73),('11288','2013-11-07','13:35:00',3.07),('11288','2013-11-07','13:40:00',1.91),('11288','2013-11-07','13:45:00',2.65),('11288','2013-11-07','13:50:00',2.36),('11288','2013-11-07','13:55:00',2.32),('11288','2013-11-07','14:00:00',1.63),('11288','2013-11-07','14:05:00',2.28),('11288','2013-11-07','14:10:00',2.29),('11288','2013-11-07','14:15:00',1.39),('11288','2013-11-07','14:20:00',2.01),('11288','2013-11-07','14:25:00',2.15),('11288','2013-11-07','14:30:00',2.54),('11288','2013-11-07','14:35:00',2.03),('11288','2013-11-07','14:40:00',1.88),('11288','2013-11-07','14:45:00',2.1),('11288','2013-11-07','14:50:00',2.01),('11288','2013-11-07','14:55:00',1.87),('11288','2013-11-07','15:00:00',1.74),('11288','2013-11-07','15:05:00',1.62),('11288','2013-11-07','15:10:00',1.47),('11288','2013-11-07','15:15:00',1.35),('11288','2013-11-07','15:20:00',1.26),('11288','2013-11-07','15:25:00',1.15),('11288','2013-11-07','15:30:00',1.05),('11288','2013-11-06','08:10:00',1.27),('11288','2013-11-06','08:15:00',1.55),('11288','2013-11-06','08:20:00',1.43),('11288','2013-11-06','08:35:00',1.17),('11288','2013-11-06','08:40:00',1.87),('11288','2013-11-06','08:45:00',1.96),('11288','2013-11-06','08:50:00',2.2),('11288','2013-11-06','08:55:00',2.14),('11288','2013-11-06','09:00:00',1.47),('11288','2013-11-06','09:05:00',1.54),('11288','2013-11-06','09:10:00',1.67),('11288','2013-11-06','09:15:00',2.16),('11288','2013-11-06','09:20:00',2.22),('11288','2013-11-06','09:25:00',2.72),('11288','2013-11-06','09:30:00',2.71),('11288','2013-11-06','09:35:00',2.85),('11288','2013-11-06','09:40:00',2.94),('11288','2013-11-06','09:45:00',3.08),('11288','2013-11-06','09:50:00',3.22),('11288','2013-11-06','09:55:00',3.3),('11288','2013-11-06','10:00:00',3.29),('11288','2013-11-06','10:05:00',3.11),('11288','2013-11-06','10:10:00',3.48),('11288','2013-11-06','10:15:00',3.6),('11288','2013-11-06','10:20:00',3.66),('11288','2013-11-06','10:25:00',3.72),('11288','2013-11-06','10:30:00',3.69),('11288','2013-11-06','10:35:00',3.53),('11288','2013-11-06','10:40:00',3.8),('11288','2013-11-06','10:45:00',3.87),('11288','2013-11-06','10:50:00',3.95),('11288','2013-11-06','10:55:00',4.02),('11288','2013-11-06','11:00:00',4.05),('11288','2013-11-06','11:05:00',4.07),('11288','2013-11-06','11:10:00',4.05),('11288','2013-11-06','11:15:00',3.85),('11288','2013-11-06','11:20:00',3.64),('11288','2013-11-06','11:25:00',4.14),('11288','2013-11-06','11:30:00',4.14),('11288','2013-11-06','11:35:00',4.15),('11288','2013-11-06','11:40:00',4.16),('11288','2013-11-06','11:45:00',4.22),('11288','2013-11-06','11:50:00',3.99),('11288','2013-11-06','11:55:00',4.11),('11288','2013-11-06','12:00:00',4.18),('11288','2013-11-06','12:05:00',4.15),('11288','2013-11-06','12:10:00',4.13),('11288','2013-11-06','12:15:00',4.09),('11288','2013-11-06','12:20:00',4.08),('11288','2013-11-06','12:25:00',4.06),('11288','2013-11-06','12:30:00',4.07),('11288','2013-11-06','12:35:00',4.04),('11288','2013-11-06','12:40:00',3.97),('11288','2013-11-06','12:45:00',3.96),('11288','2013-11-06','12:50:00',3.91),('11288','2013-11-06','12:55:00',3.83),('11288','2013-11-06','13:00:00',3.81),('11288','2013-11-06','13:05:00',3.79),('11288','2013-11-06','13:10:00',3.7),('11288','2013-11-06','13:15:00',3.63),('11288','2013-11-06','13:20:00',3.59),('11288','2013-11-06','13:25:00',3.55),('11288','2013-11-06','13:30:00',3.48),('11288','2013-11-06','13:35:00',3.4),('11288','2013-11-06','13:40:00',3.34),('11288','2013-11-06','13:45:00',3.27),('11288','2013-11-06','13:50:00',3.18),('11288','2013-11-06','13:55:00',3.11),('11288','2013-11-06','14:00:00',3),('11288','2013-11-06','14:05:00',2.93),('11288','2013-11-06','14:10:00',2.86),('11288','2013-11-06','14:15:00',2.77),('11288','2013-11-06','14:20:00',2.71),('11288','2013-11-06','14:25:00',2.6),('11288','2013-11-06','14:30:00',2.49),('11288','2013-11-06','14:35:00',2.41),('11288','2013-11-06','14:40:00',2.29),('11288','2013-11-06','14:45:00',2.17),('11288','2013-11-06','14:50:00',2.06),('11288','2013-11-06','14:55:00',1.92),('11288','2013-11-06','15:00:00',1.82),('11288','2013-11-06','15:05:00',1.69),('11288','2013-11-06','15:10:00',1.57),('11288','2013-11-06','15:15:00',1.45),('11288','2013-11-06','15:20:00',1.33),('11288','2013-11-06','15:25:00',1.19),('11288','2013-11-06','15:30:00',1.09),('11288','2013-11-05','08:20:00',1.08),('11288','2013-11-05','08:25:00',1.64),('11288','2013-11-05','08:30:00',1.88),('11288','2013-11-05','08:35:00',2.28),('11288','2013-11-05','08:40:00',2.25),('11288','2013-11-05','08:45:00',1.46),('11288','2013-11-05','08:50:00',1.21),('11288','2013-11-05','09:55:00',1.12),('11288','2013-11-05','10:00:00',1.36),('11288','2013-11-05','10:05:00',1.21),('11288','2013-11-05','10:10:00',1.14),('11288','2013-11-05','10:15:00',1.75),('11288','2013-11-05','10:20:00',2.78),('11288','2013-11-05','10:25:00',3.47),('11288','2013-11-05','10:30:00',2.62),('11288','2013-11-05','10:35:00',3.57),('11288','2013-11-05','10:40:00',2.61),('11288','2013-11-05','10:45:00',2.75),('11288','2013-11-05','10:50:00',2.38),('11288','2013-11-05','10:55:00',2.12),('11288','2013-11-05','11:00:00',1.78),('11288','2013-11-05','11:05:00',1.37),('11288','2013-11-05','11:10:00',1.07),('11288','2013-11-05','11:20:00',1.12),('11288','2013-11-05','11:25:00',1.33),('11288','2013-11-05','11:30:00',1.54),('11288','2013-11-05','11:35:00',2.04),('11288','2013-11-05','11:40:00',2.61),('11288','2013-11-05','11:45:00',2.47),('11288','2013-11-05','11:50:00',2.28),('11288','2013-11-05','11:55:00',1.92),('11288','2013-11-05','12:00:00',1.75),('11288','2013-11-05','12:05:00',2.31),('11288','2013-11-05','12:10:00',2.65),('11288','2013-11-05','12:15:00',2.6),('11288','2013-11-05','12:20:00',2.56),('11288','2013-11-05','12:25:00',2.36),('11288','2013-11-05','12:30:00',2.35),('11288','2013-11-05','12:35:00',1.87),('11288','2013-11-05','12:40:00',1.54),('11288','2013-11-05','12:45:00',1.2),('11288','2013-11-05','12:50:00',1.22),('11288','2013-11-05','12:55:00',1.51),('11288','2013-11-05','13:00:00',1.57),('11288','2013-11-05','13:05:00',1.31),('11288','2013-11-05','13:10:00',1.41),('11288','2013-11-05','13:15:00',1.03),('11288','2013-11-05','13:20:00',1.1),('11288','2013-11-05','13:25:00',1.48),('11288','2013-11-05','13:30:00',2.06),('11288','2013-11-05','13:35:00',3.36),('11288','2013-11-05','13:40:00',3.72),('11288','2013-11-05','13:45:00',3.31),('11288','2013-11-05','13:50:00',1.87),('11288','2013-11-05','13:55:00',3.17),('11288','2013-11-05','14:00:00',2.52),('11288','2013-11-05','14:05:00',3.22),('11288','2013-11-05','14:10:00',3.02),('11288','2013-11-05','14:15:00',1.07),('11288','2013-11-05','14:20:00',1.76),('11288','2013-11-05','14:25:00',2.63),('11288','2013-11-05','14:30:00',2.77),('11288','2013-11-05','14:35:00',2.66),('11288','2013-11-05','14:40:00',2.5),('11288','2013-11-05','14:45:00',2.43),('11288','2013-11-05','15:30:00',1.23),('11288','2013-11-05','15:35:00',1.18),('11288','2013-11-04','08:00:00',1.02),('11288','2013-11-04','08:05:00',1.12),('11288','2013-11-04','08:10:00',1.18),('11288','2013-11-04','08:15:00',1.34),('11288','2013-11-04','08:20:00',1.42),('11288','2013-11-04','08:25:00',1.43),('11288','2013-11-04','08:30:00',1.36),('11288','2013-11-04','08:35:00',1.59),('11288','2013-11-04','08:40:00',1.24),('11288','2013-11-04','09:05:00',1.02),('11288','2013-11-04','09:10:00',2.18),('11288','2013-11-04','09:15:00',2.77),('11288','2013-11-04','09:20:00',2.79),('11288','2013-11-04','09:25:00',3.4),('11288','2013-11-04','09:30:00',1.57),('11288','2013-11-04','10:00:00',2.44),('11288','2013-11-04','10:05:00',2.97),('11288','2013-11-04','10:10:00',3.02),('11288','2013-11-04','10:15:00',3.75),('11288','2013-11-04','10:20:00',3.81),('11288','2013-11-04','10:25:00',4.35),('11288','2013-11-04','10:30:00',4.24),('11288','2013-11-04','10:35:00',4.1),('11288','2013-11-04','10:40:00',4.46),('11288','2013-11-04','10:45:00',2.97),('11288','2013-11-04','10:50:00',3.17),('11288','2013-11-04','10:55:00',4.08),('11288','2013-11-04','11:00:00',4.08),('11288','2013-11-04','11:05:00',4.19),('11288','2013-11-04','11:10:00',2.56),('11288','2013-11-04','11:15:00',3.15),('11288','2013-11-04','11:20:00',2.73),('11288','2013-11-04','11:25:00',2.48),('11288','2013-11-04','11:30:00',3.96),('11288','2013-11-04','11:35:00',4.06),('11288','2013-11-04','11:40:00',3.55),('11288','2013-11-04','11:45:00',4.22),('11288','2013-11-04','11:50:00',5.49),('11288','2013-11-04','11:55:00',4.89),('11288','2013-11-04','12:00:00',4.86),('11288','2013-11-04','12:05:00',4.5),('11288','2013-11-04','12:10:00',4.45),('11288','2013-11-04','12:15:00',4.39),('11288','2013-11-04','12:20:00',4.37),('11288','2013-11-04','12:25:00',4.32),('11288','2013-11-04','12:30:00',4.32),('11288','2013-11-04','12:35:00',4.35),('11288','2013-11-04','12:40:00',4.28),('11288','2013-11-04','12:45:00',4.22),('11288','2013-11-04','12:50:00',4.08),('11288','2013-11-04','12:55:00',4),('11288','2013-11-04','13:00:00',4.05),('11288','2013-11-04','13:05:00',3.99),('11288','2013-11-04','13:10:00',3.93),('11288','2013-11-04','13:15:00',3.52),('11288','2013-11-04','13:20:00',3.21),('11288','2013-11-04','13:25:00',3.8),('11288','2013-11-04','13:30:00',3.74),('11288','2013-11-04','13:35:00',3.71),('11288','2013-11-04','13:40:00',2.96),('11288','2013-11-04','13:45:00',3.82),('11288','2013-11-04','13:50:00',3.57),('11288','2013-11-04','13:55:00',2.18),('11288','2013-11-04','14:00:00',1.88),('11288','2013-11-04','14:05:00',2.92),('11288','2013-11-04','14:10:00',3.38),('11288','2013-11-04','14:15:00',3.24),('11288','2013-11-04','14:20:00',3.26),('11288','2013-11-04','14:25:00',1.68),('11288','2013-11-04','14:30:00',2.17),('11288','2013-11-04','14:35:00',3.01),('11288','2013-11-04','14:40:00',2.6),('11288','2013-11-04','14:45:00',2.48),('11288','2013-11-04','14:50:00',2.35),('11288','2013-11-04','14:55:00',1.8),('11288','2013-11-04','15:00:00',1.9),('11288','2013-11-04','15:05:00',1.06),('11288','2013-11-04','15:10:00',1.28),('11288','2013-11-04','15:15:00',1.35),('11288','2013-11-04','15:20:00',1.45),('11288','2013-11-04','15:25:00',1.47),('11288','2013-11-04','15:30:00',1.34);
INSERT INTO `solarlog` VALUES ('11288','2013-11-04','15:35:00',1.33),('11288','2013-11-04','15:40:00',1.25),('11288','2013-11-04','15:45:00',1.33),('11288','2013-11-04','15:50:00',1.04),('11288','2013-11-03','07:55:00',1.02),('11288','2013-11-03','08:20:00',1.08),('11288','2013-11-03','08:35:00',1.61),('11288','2013-11-03','08:45:00',1.13),('11288','2013-11-03','08:50:00',1.88),('11288','2013-11-03','08:55:00',1.23),('11288','2013-11-03','09:00:00',1.06),('11288','2013-11-03','09:05:00',1.04),('11288','2013-11-03','09:35:00',1.1),('11288','2013-11-03','09:40:00',3.32),('11288','2013-11-03','09:45:00',2.19),('11288','2013-11-03','09:50:00',1.49),('11288','2013-11-03','10:05:00',1.69),('11288','2013-11-03','10:10:00',1.67),('11288','2013-11-03','10:15:00',1.26),('11288','2013-11-03','10:20:00',2.95),('11288','2013-11-03','10:25:00',1.62),('11288','2013-11-03','10:30:00',3.34),('11288','2013-11-03','10:35:00',1.81),('11288','2013-11-03','10:55:00',1.04),('11288','2013-11-03','11:10:00',1.24),('11288','2013-11-03','11:15:00',1.69),('11288','2013-11-03','11:20:00',2.68),('11288','2013-11-03','11:25:00',1.58),('11288','2013-11-03','11:30:00',3.97),('11288','2013-11-03','11:35:00',3.57),('11288','2013-11-03','11:40:00',4.71),('11288','2013-11-03','11:45:00',4.82),('11288','2013-11-03','11:50:00',4.97),('11288','2013-11-03','11:55:00',3.81),('11288','2013-11-03','12:00:00',4.52),('11288','2013-11-03','12:05:00',4.67),('11288','2013-11-03','12:10:00',4.12),('11288','2013-11-03','12:15:00',2.75),('11288','2013-11-03','12:20:00',1.29),('11288','2013-11-03','12:25:00',2.25),('11288','2013-11-03','12:30:00',1.42),('11288','2013-11-03','12:35:00',1.98),('11288','2013-11-03','12:40:00',2.15),('11288','2013-11-03','12:45:00',1.78),('11288','2013-11-03','12:50:00',1.78),('11288','2013-11-03','12:55:00',1.43),('11288','2013-11-03','13:00:00',1.32),('11288','2013-11-03','13:05:00',1.48),('11288','2013-11-03','13:10:00',1.61),('11288','2013-11-03','13:15:00',1.42),('11288','2013-11-03','13:20:00',1.61),('11288','2013-11-03','13:25:00',1.74),('11288','2013-11-03','13:30:00',1.68),('11288','2013-11-03','13:35:00',2.14),('11288','2013-11-03','13:40:00',2.31),('11288','2013-11-03','13:45:00',3.47),('11288','2013-11-03','13:50:00',1.54),('11288','2013-11-03','13:55:00',2.1),('11288','2013-11-03','14:00:00',2.45),('11288','2013-11-03','14:05:00',3.15),('11288','2013-11-03','14:10:00',3.61),('11288','2013-11-03','14:15:00',3.18),('11288','2013-11-03','14:20:00',2.63),('11288','2013-11-03','14:25:00',2.69),('11288','2013-11-03','14:30:00',1.55),('11288','2013-11-03','14:35:00',1.9),('11288','2013-11-03','14:40:00',2.65),('11288','2013-11-03','14:45:00',2.29),('11288','2013-11-03','14:50:00',1.71),('11288','2013-11-03','14:55:00',1.21),('11288','2013-11-03','15:05:00',1.12),('11288','2013-11-02','08:00:00',1.02),('11288','2013-11-02','08:05:00',1.06),('11288','2013-11-02','08:10:00',1.25),('11288','2013-11-02','08:15:00',1.34),('11288','2013-11-02','08:20:00',1.42),('11288','2013-11-02','08:25:00',1.46),('11288','2013-11-02','08:30:00',1.58),('11288','2013-11-02','08:35:00',1.66),('11288','2013-11-02','08:40:00',1.77),('11288','2013-11-02','08:45:00',1.84),('11288','2013-11-02','08:50:00',1.94),('11288','2013-11-02','08:55:00',2.1),('11288','2013-11-02','09:00:00',2.21),('11288','2013-11-02','09:05:00',2.5),('11288','2013-11-02','09:10:00',2.47),('11288','2013-11-02','09:15:00',2.44),('11288','2013-11-02','09:20:00',1.92),('11288','2013-11-02','09:25:00',2.71),('11288','2013-11-02','09:30:00',2.83),('11288','2013-11-02','09:35:00',2.54),('11288','2013-11-02','09:40:00',2.96),('11288','2013-11-02','09:45:00',3.19),('11288','2013-11-02','09:50:00',3.37),('11288','2013-11-02','09:55:00',2.94),('11288','2013-11-02','10:00:00',3.07),('11288','2013-11-02','10:05:00',3.38),('11288','2013-11-02','10:10:00',2.24),('11288','2013-11-02','10:15:00',2.1),('11288','2013-11-02','10:20:00',1.4),('11288','2013-11-02','10:25:00',1.12),('11288','2013-11-02','10:35:00',1.12),('11288','2013-11-02','10:40:00',1.26),('11288','2013-11-02','10:45:00',1.29),('11288','2013-11-02','10:50:00',1.21),('11288','2013-11-02','10:55:00',1.77),('11288','2013-11-02','11:00:00',2.19),('11288','2013-11-02','11:05:00',2.37),('11288','2013-11-02','11:10:00',1.93),('11288','2013-11-02','11:15:00',1.34),('11288','2013-11-02','11:20:00',1),('11288','2013-11-02','11:25:00',1.19),('11288','2013-11-02','11:30:00',1.26),('11288','2013-11-02','11:35:00',1.33),('11288','2013-11-02','11:40:00',1.58),('11288','2013-11-02','11:45:00',1.66),('11288','2013-11-02','11:50:00',2.35),('11288','2013-11-02','11:55:00',3.47),('11288','2013-11-02','12:00:00',4.9),('11288','2013-11-02','12:05:00',4.96),('11288','2013-11-02','12:10:00',4.52),('11288','2013-11-02','12:15:00',3.81),('11288','2013-11-02','12:20:00',3.99),('11288','2013-11-02','12:25:00',4.65),('11288','2013-11-02','12:30:00',5.27),('11288','2013-11-02','12:35:00',4.24),('11288','2013-11-02','12:40:00',4.32),('11288','2013-11-02','12:45:00',3.1),('11288','2013-11-02','12:50:00',4.29),('11288','2013-11-02','12:55:00',4.69),('11288','2013-11-02','13:00:00',3.46),('11288','2013-11-02','13:05:00',4.95),('11288','2013-11-02','13:10:00',4.65),('11288','2013-11-02','13:15:00',2.44),('11288','2013-11-02','13:20:00',1.68),('11288','2013-11-02','13:25:00',1.58),('11288','2013-11-02','13:30:00',2.85),('11288','2013-11-02','13:35:00',4.01),('11288','2013-11-02','13:40:00',3.59),('11288','2013-11-02','13:45:00',4.17),('11288','2013-11-02','13:50:00',3.99),('11288','2013-11-02','13:55:00',4.04),('11288','2013-11-02','14:00:00',3.76),('11288','2013-11-02','14:05:00',3.29),('11288','2013-11-02','14:10:00',3.01),('11288','2013-11-02','14:15:00',2.93),('11288','2013-11-02','14:20:00',2.8),('11288','2013-11-02','14:25:00',2.7),('11288','2013-11-02','14:30:00',2.6),('11288','2013-11-02','14:35:00',2.48),('11288','2013-11-02','14:40:00',2.37),('11288','2013-11-02','14:45:00',2.25),('11288','2013-11-02','14:50:00',2.12),('11288','2013-11-02','14:55:00',1.96),('11288','2013-11-02','15:00:00',1.93),('11288','2013-11-02','15:05:00',1.36),('11288','2013-11-02','15:10:00',1.56),('11288','2013-11-02','15:15:00',1.11),('11288','2013-11-02','15:45:00',1),('11288','2013-11-02','15:50:00',1.06),('11288','2013-11-01','08:15:00',1.13),('11288','2013-11-01','08:20:00',1.25),('11288','2013-11-01','08:25:00',1.32),('11288','2013-11-01','08:30:00',1.51),('11288','2013-11-01','08:35:00',1.66),('11288','2013-11-01','08:40:00',1.82),('11288','2013-11-01','08:45:00',1.76),('11288','2013-11-01','08:50:00',1.81),('11288','2013-11-01','08:55:00',1.92),('11288','2013-11-01','09:00:00',2),('11288','2013-11-01','09:05:00',2.25),('11288','2013-11-01','09:10:00',2.34),('11288','2013-11-01','09:15:00',2.47),('11288','2013-11-01','09:20:00',2.58),('11288','2013-11-01','09:25:00',2.7),('11288','2013-11-01','09:30:00',2.82),('11288','2013-11-01','09:35:00',2.81),('11288','2013-11-01','09:40:00',2.9),('11288','2013-11-01','09:45:00',3.07),('11288','2013-11-01','09:50:00',3.16),('11288','2013-11-01','09:55:00',3.24),('11288','2013-11-01','10:00:00',3.32),('11288','2013-11-01','10:05:00',3.36),('11288','2013-11-01','10:10:00',3.43),('11288','2013-11-01','10:15:00',3.51),('11288','2013-11-01','10:20:00',3.6),('11288','2013-11-01','10:25:00',3.67),('11288','2013-11-01','10:30:00',3.59),('11288','2013-11-01','10:35:00',3.63),('11288','2013-11-01','10:40:00',3.72),('11288','2013-11-01','10:45:00',3.67),('11288','2013-11-01','10:50:00',3.68),('11288','2013-11-01','10:55:00',3.81),('11288','2013-11-01','11:00:00',3.88),('11288','2013-11-01','11:05:00',3.5),('11288','2013-11-01','11:10:00',3.11),('11288','2013-11-01','11:15:00',3.5),('11288','2013-11-01','11:20:00',4.05),('11288','2013-11-01','11:25:00',4.3),('11288','2013-11-01','11:30:00',4.33),('11288','2013-11-01','11:35:00',4.16),('11288','2013-11-01','11:40:00',3.61),('11288','2013-11-01','11:45:00',4.01),('11288','2013-11-01','11:50:00',4.32),('11288','2013-11-01','11:55:00',4.33),('11288','2013-11-01','12:00:00',4.22),('11288','2013-11-01','12:05:00',4.15),('11288','2013-11-01','12:10:00',3.78),('11288','2013-11-01','12:15:00',3.44),('11288','2013-11-01','12:20:00',3.5),('11288','2013-11-01','12:25:00',3.85),('11288','2013-11-01','12:30:00',2.09),('11288','2013-11-01','12:35:00',1.24),('11288','2013-11-01','12:40:00',1.05),('11288','2013-11-01','13:00:00',1.05),('11288','2013-11-01','13:05:00',1.19),('11288','2013-11-01','13:10:00',1.8),('11288','2013-11-01','13:15:00',1.98),('11288','2013-11-01','13:20:00',1.87),('11288','2013-11-01','13:25:00',1.69),('11288','2013-11-01','13:30:00',2.09),('11288','2013-11-01','13:35:00',2),('11288','2013-11-01','13:40:00',1.68),('11288','2013-11-01','13:45:00',1.36),('11288','2013-11-01','13:50:00',1.15),('11288','2013-11-01','13:55:00',1.35),('11288','2013-11-01','14:00:00',1.17),('11288','2013-11-01','14:05:00',1.2),('11288','2013-11-01','14:10:00',1.23),('11288','2013-11-01','14:15:00',1.28),('11288','2013-11-01','14:20:00',1.15),('11288','2013-10-31','08:10:00',1.22),('11288','2013-10-31','08:15:00',1.23),('11288','2013-10-31','08:20:00',1.26),('11288','2013-10-31','08:25:00',1.43),('11288','2013-10-31','08:30:00',1.5),('11288','2013-10-31','08:35:00',1.8),('11288','2013-10-31','08:40:00',2.09),('11288','2013-10-31','08:45:00',2.04),('11288','2013-10-31','08:50:00',2.17),('11288','2013-10-31','08:55:00',2.04),('11288','2013-10-31','09:00:00',2),('11288','2013-10-31','09:05:00',1.7),('11288','2013-10-31','09:10:00',1.06),('11288','2013-10-31','09:15:00',1.6),('11288','2013-10-31','09:20:00',1.91),('11288','2013-10-31','09:25:00',2.11),('11288','2013-10-31','09:30:00',2.33),('11288','2013-10-31','09:35:00',2.48),('11288','2013-10-31','09:40:00',2.32),('11288','2013-10-31','09:45:00',2.44),('11288','2013-10-31','09:50:00',2.43),('11288','2013-10-31','09:55:00',2.59),('11288','2013-10-31','10:00:00',2.68),('11288','2013-10-31','10:05:00',2.47),('11288','2013-10-31','10:10:00',2.39),('11288','2013-10-31','10:15:00',1.99),('11288','2013-10-31','10:20:00',2.24),('11288','2013-10-31','10:25:00',2.37),('11288','2013-10-31','10:30:00',2.48),('11288','2013-10-31','10:35:00',2.78),('11288','2013-10-31','10:40:00',2.67),('11288','2013-10-31','10:45:00',2.49),('11288','2013-10-31','10:50:00',2.69),('11288','2013-10-31','10:55:00',2.96),('11288','2013-10-31','11:00:00',3.53),('11288','2013-10-31','11:05:00',4.04),('11288','2013-10-31','11:10:00',3.86),('11288','2013-10-31','11:15:00',3.95),('11288','2013-10-31','11:20:00',3.78),('11288','2013-10-31','11:25:00',3.46),('11288','2013-10-31','11:30:00',3.84),('11288','2013-10-31','11:35:00',3.68),('11288','2013-10-31','11:40:00',4.11),('11288','2013-10-31','11:45:00',4.28),('11288','2013-10-31','11:50:00',4.17),('11288','2013-10-31','11:55:00',4.13),('11288','2013-10-31','12:00:00',4.04),('11288','2013-10-31','12:05:00',3.93),('11288','2013-10-31','12:10:00',4.07),('11288','2013-10-31','12:15:00',3.97),('11288','2013-10-31','12:20:00',3.94),('11288','2013-10-31','12:25:00',4),('11288','2013-10-31','12:30:00',3.88),('11288','2013-10-31','12:35:00',3.75),('11288','2013-10-31','12:40:00',3.87),('11288','2013-10-31','12:45:00',4),('11288','2013-10-31','12:50:00',4.01),('11288','2013-10-31','12:55:00',4.05),('11288','2013-10-31','13:00:00',3.97),('11288','2013-10-31','13:05:00',3.89),('11288','2013-10-31','13:10:00',3.77),('11288','2013-10-31','13:15:00',3.67),('11288','2013-10-31','13:20:00',3.65),('11288','2013-10-31','13:25:00',3.55),('11288','2013-10-31','13:30:00',3.47),('11288','2013-10-31','13:35:00',3.33),('11288','2013-10-31','13:40:00',3.1),('11288','2013-10-31','13:45:00',3.02),('11288','2013-10-31','13:50:00',2.19),('11288','2013-10-31','13:55:00',2.34),('11288','2013-10-31','14:00:00',2.98),('11288','2013-10-31','14:05:00',2.9),('11288','2013-10-31','14:10:00',2.64),('11288','2013-10-31','14:15:00',1.68),('11288','2013-10-31','14:25:00',1.68),('11288','2013-10-31','14:45:00',1.06),('11288','2013-10-31','14:50:00',1.02),('11288','2013-10-31','14:55:00',1.39),('11288','2013-10-31','15:00:00',1.4),('11288','2013-10-31','15:05:00',1.35),('11288','2013-10-31','15:10:00',1.28),('11288','2013-10-31','15:15:00',1.2),('11288','2013-10-31','15:20:00',1.13),('11288','2013-10-31','15:25:00',1.04),('11288','2013-10-30','08:00:00',1),('11288','2013-10-30','08:05:00',1.16),('11288','2013-10-30','08:10:00',1.25),('11288','2013-10-30','08:15:00',1.33),('11288','2013-10-30','08:20:00',1.47),('11288','2013-10-30','08:25:00',1.57),('11288','2013-10-30','08:30:00',1.62),('11288','2013-10-30','08:35:00',1.7),('11288','2013-10-30','08:40:00',1.83),('11288','2013-10-30','08:45:00',1.93),('11288','2013-10-30','08:50:00',1.99),('11288','2013-10-30','08:55:00',1.98),('11288','2013-10-30','09:00:00',2.11),('11288','2013-10-30','09:05:00',2.28),('11288','2013-10-30','09:10:00',2.37),('11288','2013-10-30','09:15:00',2.49),('11288','2013-10-30','09:20:00',2.63),('11288','2013-10-30','09:25:00',2.78),('11288','2013-10-30','09:30:00',2.84),('11288','2013-10-30','09:35:00',2.93),('11288','2013-10-30','09:40:00',2.92),('11288','2013-10-30','09:45:00',3.02),('11288','2013-10-30','09:50:00',3.18),('11288','2013-10-30','09:55:00',2.94),('11288','2013-10-30','10:00:00',2.64),('11288','2013-10-30','10:05:00',2.83),('11288','2013-10-30','10:10:00',3.44),('11288','2013-10-30','10:15:00',3.44),('11288','2013-10-30','10:20:00',3.39),('11288','2013-10-30','10:25:00',3.49),('11288','2013-10-30','10:30:00',3.54),('11288','2013-10-30','10:35:00',3.43),('11288','2013-10-30','10:40:00',3.51),('11288','2013-10-30','10:45:00',3.53),('11288','2013-10-30','10:50:00',2.55),('11288','2013-10-30','10:55:00',3.03),('11288','2013-10-30','11:00:00',3.08),('11288','2013-10-30','11:05:00',4.12),('11288','2013-10-30','11:10:00',4.07),('11288','2013-10-30','11:15:00',3.64),('11288','2013-10-30','11:20:00',3.43),('11288','2013-10-30','11:25:00',1.9),('11288','2013-10-30','11:30:00',1.73),('11288','2013-10-30','11:35:00',1.55),('11288','2013-10-30','11:40:00',1.96),('11288','2013-10-30','11:45:00',2.1),('11288','2013-10-30','11:50:00',1.94),('11288','2013-10-30','11:55:00',1.48),('11288','2013-10-30','12:00:00',1.83),('11288','2013-10-30','12:05:00',1.89),('11288','2013-10-30','12:10:00',1.98),('11288','2013-10-30','12:15:00',3.59),('11288','2013-10-30','12:20:00',4.74),('11288','2013-10-30','12:25:00',2.96),('11288','2013-10-30','12:30:00',3),('11288','2013-10-30','12:35:00',1.77),('11288','2013-10-30','12:40:00',1.85),('11288','2013-10-30','12:45:00',1.72),('11288','2013-10-30','12:50:00',2.16),('11288','2013-10-30','12:55:00',3.99),('11288','2013-10-30','13:00:00',3.8),('11288','2013-10-30','13:05:00',4.44),('11288','2013-10-30','13:10:00',4.32),('11288','2013-10-30','13:15:00',4.55),('11288','2013-10-30','13:20:00',4.39),('11288','2013-10-30','13:25:00',4.28),('11288','2013-10-30','13:30:00',2.22),('11288','2013-10-30','13:35:00',3.58),('11288','2013-10-30','13:40:00',3.87),('11288','2013-10-30','13:45:00',2.97),('11288','2013-10-30','13:50:00',3.07),('11288','2013-10-30','13:55:00',3.76),('11288','2013-10-30','14:00:00',3.7),('11288','2013-10-30','14:05:00',2.08),('11288','2013-10-30','14:10:00',1.41),('11288','2013-10-30','14:20:00',1.99),('11288','2013-10-30','14:35:00',1.24),('11288','2013-10-30','14:40:00',2.1),('11288','2013-10-30','14:45:00',1.55),('11288','2013-10-30','15:05:00',1.1),('11288','2013-10-30','15:10:00',1.4),('11288','2013-10-30','15:15:00',1.6),('11288','2013-10-30','15:20:00',1.55),('11288','2013-10-30','15:25:00',1.26),('11288','2013-10-29','08:15:00',1.09),('11288','2013-10-29','08:20:00',1.26),('11288','2013-10-29','08:25:00',1.37),('11288','2013-10-29','08:30:00',1.49),('11288','2013-10-29','08:35:00',1.77),('11288','2013-10-29','08:40:00',2.09),('11288','2013-10-29','08:45:00',1.81),('11288','2013-10-29','08:50:00',2.01),('11288','2013-10-29','08:55:00',2.15),('11288','2013-10-29','09:00:00',2.28),('11288','2013-10-29','09:05:00',2.41),('11288','2013-10-29','09:10:00',2.38),('11288','2013-10-29','09:15:00',2.58),('11288','2013-10-29','09:20:00',2.69),('11288','2013-10-29','09:25:00',2.81),('11288','2013-10-29','09:30:00',2.9),('11288','2013-10-29','09:35:00',2.78),('11288','2013-10-29','09:40:00',1.82),('11288','2013-10-29','09:45:00',2.67),('11288','2013-10-29','09:50:00',2.98),('11288','2013-10-29','09:55:00',3.22),('11288','2013-10-29','10:00:00',3.53),('11288','2013-10-29','10:05:00',3.66),('11288','2013-10-29','10:10:00',3.64),('11288','2013-10-29','10:15:00',3.7),('11288','2013-10-29','10:20:00',2.23),('11288','2013-10-29','10:25:00',2.08),('11288','2013-10-29','10:30:00',1.59),('11288','2013-10-29','10:35:00',2.25),('11288','2013-10-29','10:40:00',2.35),('11288','2013-10-29','10:45:00',2.26),('11288','2013-10-29','10:50:00',2.99),('11288','2013-10-29','10:55:00',4.7),('11288','2013-10-29','11:00:00',4.58),('11288','2013-10-29','11:05:00',4.74),('11288','2013-10-29','11:10:00',4.56),('11288','2013-10-29','11:15:00',4.25),('11288','2013-10-29','11:20:00',4.03),('11288','2013-10-29','11:25:00',4.28),('11288','2013-10-29','11:30:00',4.3),('11288','2013-10-29','11:35:00',4.34),('11288','2013-10-29','11:40:00',4.28),('11288','2013-10-29','11:45:00',4.32),('11288','2013-10-29','11:50:00',4.23),('11288','2013-10-29','11:55:00',4.16),('11288','2013-10-29','12:00:00',4.1),('11288','2013-10-29','12:05:00',4.15),('11288','2013-10-29','12:10:00',4.12),('11288','2013-10-29','12:15:00',4.1),('11288','2013-10-29','12:20:00',4.07),('11288','2013-10-29','12:25:00',3.95),('11288','2013-10-29','12:30:00',3.97),('11288','2013-10-29','12:35:00',4),('11288','2013-10-29','12:40:00',3.87),('11288','2013-10-29','12:45:00',3.73),('11288','2013-10-29','12:50:00',3.81),('11288','2013-10-29','12:55:00',3.79),('11288','2013-10-29','13:00:00',3.79),('11288','2013-10-29','13:05:00',3.78),('11288','2013-10-29','13:10:00',3.75),('11288','2013-10-29','13:15:00',3.53),('11288','2013-10-29','13:20:00',3.58),('11288','2013-10-29','13:25:00',3.58),('11288','2013-10-29','13:30:00',3.52),('11288','2013-10-29','13:35:00',3.31),('11288','2013-10-29','13:40:00',3.09),('11288','2013-10-29','13:45:00',3.16),('11288','2013-10-29','13:50:00',3.14),('11288','2013-10-29','13:55:00',3.08),('11288','2013-10-29','14:00:00',2.99),('11288','2013-10-29','14:05:00',2.88),('11288','2013-10-29','14:10:00',2.81),('11288','2013-10-29','14:15:00',2.76),('11288','2013-10-29','14:20:00',2.66),('11288','2013-10-29','14:25:00',2.55),('11288','2013-10-29','14:30:00',2.46),('11288','2013-10-29','14:35:00',2.34),('11288','2013-10-29','14:40:00',2.26),('11288','2013-10-29','14:45:00',2.17),('11288','2013-10-29','14:50:00',2.05),('11288','2013-10-29','14:55:00',1.94),('11288','2013-10-29','15:00:00',1.85),('11288','2013-10-29','15:05:00',1.74),('11288','2013-10-29','15:10:00',1.67),('11288','2013-10-29','15:15:00',1.58),('11288','2013-10-29','15:20:00',1.44),('11288','2013-10-29','15:25:00',1.29),('11288','2013-10-29','15:30:00',1.16),('11288','2013-10-29','15:35:00',1.06),('11288','2014-04-17','07:55:00',1.05),('11288','2014-04-17','08:00:00',1.36),('11288','2014-04-17','08:05:00',1.46),('11288','2014-04-17','08:10:00',1.58),('11288','2014-04-17','08:15:00',1.67),('11288','2014-04-17','08:20:00',1.81),('11288','2014-04-17','08:25:00',2.01),('11288','2014-04-17','08:30:00',2.06),('11288','2014-04-17','08:35:00',2.23),('11288','2014-04-17','08:40:00',2.49),('11288','2014-04-17','08:45:00',2.65),('11288','2014-04-17','08:50:00',2.77),('11288','2014-04-17','08:55:00',2.83),('11288','2014-04-17','09:00:00',2.71),('11288','2014-04-17','09:05:00',3.14),('11288','2014-04-17','09:10:00',3.52),('11288','2014-04-17','09:15:00',3.7),('11288','2014-04-17','09:20:00',3.89),('11288','2014-04-17','09:25:00',3.96),('11288','2014-04-17','09:30:00',4.07),('11288','2014-04-17','09:35:00',4.32),('11288','2014-04-17','09:40:00',4.52),('11288','2014-04-17','09:45:00',4.66),('11288','2014-04-17','09:50:00',4.77),('11288','2014-04-17','09:55:00',4.89),('11288','2014-04-17','10:00:00',5.26),('11288','2014-04-17','10:05:00',5.75),('11288','2014-04-17','10:10:00',5.49),('11288','2014-04-17','10:15:00',4.21),('11288','2014-04-17','10:20:00',5.98),('11288','2014-04-17','10:25:00',6.2),('11288','2014-04-17','10:30:00',6.66),('11288','2014-04-17','10:35:00',7.03),('11288','2014-04-17','10:40:00',6.54),('11288','2014-04-17','10:45:00',6.15),('11288','2014-04-17','10:50:00',4.62),('11288','2014-04-17','10:55:00',4.08),('11288','2014-04-17','11:00:00',4.65),('11288','2014-04-17','11:05:00',5.09),('11288','2014-04-17','11:10:00',5.11),('11288','2014-04-17','11:15:00',3.82),('11288','2014-04-17','11:20:00',4.82),('11288','2014-04-17','11:25:00',6.65),('11288','2014-04-17','11:30:00',4.34),('11288','2014-04-17','11:35:00',3.81),('11288','2014-04-17','11:40:00',3.96),('11288','2014-04-17','11:45:00',6.74),('11288','2014-04-17','11:50:00',5.46),('11288','2014-04-17','11:55:00',4.01),('11288','2014-04-17','12:00:00',5.11),('11288','2014-04-17','12:05:00',5.16),('11288','2014-04-17','12:10:00',4.41),('11288','2014-04-17','12:15:00',3.94),('11288','2014-04-17','12:20:00',4.24),('11288','2014-04-17','12:25:00',4.84),('11288','2014-04-17','12:30:00',5.59),('11288','2014-04-17','12:35:00',6.06),('11288','2014-04-17','12:40:00',7.18),('11288','2014-04-17','12:45:00',6.9),('11288','2014-04-17','12:50:00',4.47),('11288','2014-04-17','12:55:00',1.74),('11288','2014-04-17','13:00:00',7.83),('11288','2014-04-17','13:05:00',7.76),('11288','2014-04-17','13:10:00',7.66),('11288','2014-04-17','13:15:00',7.75),('11288','2014-04-17','13:20:00',2.14),('11288','2014-04-17','13:25:00',7.42),('11288','2014-04-17','13:30:00',8.04),('11288','2014-04-17','13:35:00',3.83),('11288','2014-04-17','13:40:00',1.72),('11288','2014-04-17','13:45:00',1.65),('11288','2014-04-17','13:50:00',3.36),('11288','2014-04-17','13:55:00',3.7),('11288','2014-04-17','14:00:00',1.84),('11288','2014-04-17','14:05:00',2.03),('11288','2014-04-17','14:10:00',2.98),('11288','2014-04-17','14:15:00',7.85),('11288','2014-04-17','14:20:00',2.53),('11288','2014-04-17','14:25:00',3.15),('11288','2014-04-17','14:30:00',3.67),('11288','2014-04-17','14:35:00',3.78),('11288','2014-04-17','14:40:00',5.07),('11288','2014-04-17','14:45:00',2.85),('11288','2014-04-17','14:50:00',1.45),('11288','2014-04-17','14:55:00',1.23),('11288','2014-04-17','15:00:00',1.29),('11288','2014-04-17','15:05:00',1.42),('11288','2014-04-17','15:10:00',1.38),('11288','2014-04-17','15:15:00',1.36),('11288','2014-04-17','15:20:00',1.58),('11288','2014-04-17','15:25:00',2.11),('11288','2014-04-17','15:30:00',3.16),('11288','2014-04-17','15:35:00',4.6),('11288','2014-04-17','15:40:00',3.49),('11288','2014-04-17','15:45:00',2.5),('11288','2014-04-17','15:50:00',2.18),('11288','2014-04-17','15:55:00',2.42),('11288','2014-04-17','16:00:00',2.02),('11288','2014-04-17','16:05:00',1.84),('11288','2014-04-17','16:10:00',1.86),('11288','2014-04-17','16:15:00',1.9),('11288','2014-04-17','16:20:00',1.84),('11288','2014-04-17','16:25:00',2.05),('11288','2014-04-17','16:30:00',2.09),('11288','2014-04-17','16:35:00',1.9),('11288','2014-04-17','16:40:00',2.21),('11288','2014-04-17','16:45:00',3.14),('11288','2014-04-17','16:50:00',2.89),('11288','2014-04-17','16:55:00',2.16),('11288','2014-04-17','17:00:00',1.81),('11288','2014-04-17','17:05:00',1.54),('11288','2014-04-17','17:10:00',1.49),('11288','2014-04-17','17:15:00',1.73),('11288','2014-04-17','17:20:00',1.95),('11288','2014-04-17','17:25:00',1.7),('11288','2014-04-17','17:30:00',1.74),('11288','2014-04-17','17:35:00',1.82),('11288','2014-04-17','17:40:00',1.72),('11288','2014-04-17','17:45:00',1.6),('11288','2014-04-17','17:50:00',1.26),('11288','2014-04-17','17:55:00',1.22),('11288','2013-10-28','07:30:00',1.07),('11288','2013-10-28','07:35:00',1.09),('11288','2013-10-28','08:10:00',1.1),('11288','2013-10-28','08:15:00',1.03),('11288','2013-10-28','08:20:00',1.14),('11288','2013-10-28','08:35:00',1.07),('11288','2013-10-28','08:45:00',1.02),('11288','2013-10-28','08:50:00',1.49),('11288','2013-10-28','08:55:00',2.06),('11288','2013-10-28','09:00:00',2.43),('11288','2013-10-28','09:05:00',2.75),('11288','2013-10-28','09:10:00',2.84),('11288','2013-10-28','09:15:00',2.82),('11288','2013-10-28','09:20:00',2.91),('11288','2013-10-28','09:25:00',3),('11288','2013-10-28','09:30:00',3.02),('11288','2013-10-28','09:35:00',3.09),('11288','2013-10-28','09:40:00',3.66),('11288','2013-10-28','09:45:00',3.45),('11288','2013-10-28','09:50:00',3.64),('11288','2013-10-28','09:55:00',2.13),('11288','2013-10-28','10:00:00',1.34),('11288','2013-10-28','10:05:00',1.49),('11288','2013-10-28','10:10:00',1.44),('11288','2013-10-28','10:15:00',1.44),('11288','2013-10-28','10:20:00',1.5),('11288','2013-10-28','10:25:00',1.55),('11288','2013-10-28','10:30:00',1.59),('11288','2013-10-28','10:35:00',1.51),('11288','2013-10-28','10:40:00',1.12),('11288','2013-10-28','10:45:00',1.76),('11288','2013-10-28','10:50:00',4.21),('11288','2013-10-28','10:55:00',4.19),('11288','2013-10-28','11:00:00',4.18),('11288','2013-10-28','11:05:00',4.21),('11288','2013-10-28','11:10:00',4.25),('11288','2013-10-28','11:15:00',4.18),('11288','2013-10-28','11:20:00',4.21),('11288','2013-10-28','11:25:00',4.24),('11288','2013-10-28','11:30:00',4.26),('11288','2013-10-28','11:35:00',4.25),('11288','2013-10-28','11:40:00',4.27),('11288','2013-10-28','11:45:00',4.29),('11288','2013-10-28','11:50:00',4.24),('11288','2013-10-28','11:55:00',3.61),('11288','2013-10-28','12:00:00',2.81),('11288','2013-10-28','12:05:00',4.01),('11288','2013-10-28','12:10:00',4.5),('11288','2013-10-28','12:15:00',4.41),('11288','2013-10-28','12:20:00',3.62),('11288','2013-10-28','12:25:00',2.73),('11288','2013-10-28','12:30:00',4.78),('11288','2013-10-28','12:35:00',4.94),('11288','2013-10-28','12:40:00',4.4),('11288','2013-10-28','12:45:00',4.54),('11288','2013-10-28','12:50:00',4.39),('11288','2013-10-28','12:55:00',4.15),('11288','2013-10-28','13:00:00',4.05),('11288','2013-10-28','13:05:00',4),('11288','2013-10-28','13:10:00',3.92),('11288','2013-10-28','13:15:00',3.88),('11288','2013-10-28','13:20:00',3.38),('11288','2013-10-28','13:25:00',3.66),('11288','2013-10-28','13:30:00',3.68),('11288','2013-10-28','13:35:00',3.66),('11288','2013-10-28','13:40:00',3.63),('11288','2013-10-28','13:45:00',3.5),('11288','2013-10-28','13:50:00',3.44),('11288','2013-10-28','13:55:00',3.46),('11288','2013-10-28','14:00:00',3.06),('11288','2013-10-28','14:05:00',3.54),('11288','2013-10-28','14:10:00',3.37),('11288','2013-10-28','14:15:00',3.15),('11288','2013-10-28','14:20:00',3.12),('11288','2013-10-28','14:25:00',2.54),('11288','2013-10-28','14:30:00',1.56),('11288','2013-10-28','14:35:00',2.01),('11288','2013-10-28','14:40:00',1.35),('11288','2013-10-28','14:45:00',2.14),('11288','2013-10-28','14:50:00',2.25),('11288','2013-10-28','14:55:00',1.65),('11288','2013-10-28','15:00:00',1.83),('11288','2013-10-28','15:05:00',1.9),('11288','2013-10-28','15:10:00',1.76),('11288','2013-10-28','15:20:00',1.14),('11288','2013-10-28','15:25:00',1.26),('11288','2013-10-28','15:35:00',1.02),('11288','2013-10-28','15:40:00',1.31),('11288','2013-10-28','15:45:00',1.44),('11288','2013-10-28','15:50:00',1.09),('11288','2013-10-27','08:50:00',1.12),('11288','2013-10-27','08:55:00',1.21),('11288','2013-10-27','09:00:00',1.31),('11288','2013-10-27','09:25:00',1.02),('11288','2013-10-27','09:30:00',1.17),('11288','2013-10-27','09:35:00',1.34),('11288','2013-10-27','09:40:00',1.44),('11288','2013-10-27','09:45:00',1.5),('11288','2013-10-27','09:50:00',1.62),('11288','2013-10-27','09:55:00',1.78),('11288','2013-10-27','10:00:00',1.84),('11288','2013-10-27','10:05:00',1.88),('11288','2013-10-27','10:10:00',2.04),('11288','2013-10-27','10:15:00',2.16),('11288','2013-10-27','10:20:00',2.3),('11288','2013-10-27','10:25:00',2.24),('11288','2013-10-27','10:30:00',2.2),('11288','2013-10-27','10:35:00',2.23),('11288','2013-10-27','10:40:00',2.26),('11288','2013-10-27','10:45:00',2.49),('11288','2013-10-27','10:50:00',2.42),('11288','2013-10-27','10:55:00',2.19),('11288','2013-10-27','11:00:00',1.89),('11288','2013-10-27','11:05:00',1.66),('11288','2013-10-27','11:10:00',1.28),('11288','2013-10-27','11:15:00',1.06),('11288','2013-10-27','11:20:00',1.09),('11288','2013-10-27','11:25:00',1.41),('11288','2013-10-27','11:30:00',1.96),('11288','2013-10-27','11:35:00',2.59),('11288','2013-10-27','11:40:00',2.99),('11288','2013-10-27','11:45:00',3.17),('11288','2013-10-27','11:50:00',2.16),('11288','2013-10-27','11:55:00',1.89),('11288','2013-10-27','12:00:00',2.16),('11288','2013-10-27','12:05:00',2.09),('11288','2013-10-27','12:10:00',2.09),('11288','2013-10-27','12:15:00',2.88),('11288','2013-10-27','12:20:00',4.22),('11288','2013-10-27','12:25:00',3.71),('11288','2013-10-27','12:30:00',4.02),('11288','2013-10-27','12:35:00',5.25),('11288','2013-10-27','12:40:00',2.75),('11288','2013-10-27','12:45:00',3.77),('11288','2013-10-27','12:50:00',4.64),('11288','2013-10-27','12:55:00',3.31),('11288','2013-10-27','13:00:00',2.13),('11288','2013-10-27','13:05:00',2.15),('11288','2013-10-27','13:10:00',2.19),('11288','2013-10-27','13:15:00',1.68),('11288','2013-10-27','13:20:00',1.56),('11288','2013-10-27','13:25:00',2.93),('11288','2013-10-27','13:30:00',2.96),('11288','2013-10-27','13:35:00',2.72),('11288','2013-10-27','13:40:00',1.67),('11288','2013-10-27','13:45:00',1.27),('11288','2013-10-27','13:50:00',1.18),('11288','2013-10-27','13:55:00',1.56),('11288','2013-10-27','14:00:00',2.06),('11288','2013-10-27','14:05:00',1.55),('11288','2013-10-27','14:10:00',1.97),('11288','2013-10-27','14:15:00',1.91),('11288','2013-10-27','14:20:00',2.49),('11288','2013-10-27','14:25:00',2.12),('11288','2013-10-27','14:30:00',2.68),('11288','2013-10-27','14:35:00',2.17),('11288','2013-10-27','14:40:00',2.19),('11288','2013-10-27','14:45:00',1.63),('11288','2013-10-27','14:50:00',1.48),('11288','2013-10-27','14:55:00',1.9),('11288','2013-10-27','15:00:00',1.87),('11288','2013-10-27','15:05:00',1.86),('11288','2013-10-27','15:10:00',1.89),('11288','2013-10-27','15:15:00',1.78),('11288','2013-10-27','15:20:00',1.64),('11288','2013-10-27','15:25:00',1.3),('11288','2013-10-26','08:55:00',1.03),('11288','2013-10-26','09:00:00',1.17),('11288','2013-10-26','09:05:00',1.25),('11288','2013-10-26','09:10:00',1.35),('11288','2013-10-26','09:15:00',1.47),('11288','2013-10-26','09:20:00',1.53),('11288','2013-10-26','09:25:00',1.67),('11288','2013-10-26','09:30:00',1.78),('11288','2013-10-26','09:35:00',1.78),('11288','2013-10-26','09:40:00',1.96),('11288','2013-10-26','09:45:00',2.08),('11288','2013-10-26','09:50:00',2.14),('11288','2013-10-26','09:55:00',2.27),('11288','2013-10-26','10:00:00',2.39),('11288','2013-10-26','10:05:00',2.49),('11288','2013-10-26','10:10:00',2.57),('11288','2013-10-26','10:15:00',2.68),('11288','2013-10-26','10:20:00',2.77),('11288','2013-10-26','10:25:00',2.88),('11288','2013-10-26','10:30:00',2.98),('11288','2013-10-26','10:35:00',3.07),('11288','2013-10-26','10:40:00',3.17),('11288','2013-10-26','10:45:00',3.27),('11288','2013-10-26','10:50:00',3.37),('11288','2013-10-26','10:55:00',3.46),('11288','2013-10-26','11:00:00',3.53),('11288','2013-10-26','11:05:00',3.52),('11288','2013-10-26','11:10:00',3.42),('11288','2013-10-26','11:15:00',3.65),('11288','2013-10-26','11:20:00',3.75),('11288','2013-10-26','11:25:00',3.8),('11288','2013-10-26','11:30:00',3.82),('11288','2013-10-26','11:35:00',3.84),('11288','2013-10-26','11:40:00',3.83),('11288','2013-10-26','11:45:00',3.92),('11288','2013-10-26','11:50:00',4),('11288','2013-10-26','11:55:00',4.05),('11288','2013-10-26','12:00:00',3.99),('11288','2013-10-26','12:05:00',4.03),('11288','2013-10-26','12:10:00',4.12),('11288','2013-10-26','12:15:00',4),('11288','2013-10-26','12:20:00',3.8),('11288','2013-10-26','12:25:00',3.78),('11288','2013-10-26','12:30:00',4.09),('11288','2013-10-26','12:35:00',4.25),('11288','2013-10-26','12:40:00',4.11),('11288','2013-10-26','12:45:00',3.36),('11288','2013-10-26','12:50:00',4.08),('11288','2013-10-26','12:55:00',3.67),('11288','2013-10-26','13:00:00',4.07),('11288','2013-10-26','13:05:00',3.98),('11288','2013-10-26','13:10:00',4.13),('11288','2013-10-26','13:15:00',4.16),('11288','2013-10-26','13:20:00',4.05),('11288','2013-10-26','13:25:00',3.97),('11288','2013-10-26','13:30:00',4.12),('11288','2013-10-26','13:35:00',3.38),('11288','2013-10-26','13:40:00',4.12),('11288','2013-10-26','13:45:00',3.72),('11288','2013-10-26','13:50:00',3.86),('11288','2013-10-26','13:55:00',3.72),('11288','2013-10-26','14:00:00',3.55),('11288','2013-10-26','14:05:00',3.06),('11288','2013-10-26','14:10:00',2.74),('11288','2013-10-26','14:15:00',1.72),('11288','2013-10-26','14:20:00',3.3),('11288','2013-10-26','14:25:00',3.18),('11288','2013-10-26','14:30:00',3.07),('11288','2013-10-26','14:35:00',3.06),('11288','2013-10-26','14:40:00',2.89),('11288','2013-10-26','14:45:00',1.86),('11288','2013-10-26','14:50:00',1.92),('11288','2013-10-26','14:55:00',3.15),('11288','2013-10-26','15:00:00',3.03),('11288','2013-10-26','15:05:00',2.93),('11288','2013-10-26','15:10:00',2.97),('11288','2013-10-26','15:15:00',2.74),('11288','2013-10-26','15:20:00',2.7),('11288','2013-10-26','15:25:00',2.79),('11288','2013-10-26','15:30:00',2.7),('11288','2013-10-26','15:35:00',2.67),('11288','2013-10-26','15:40:00',2.4),('11288','2013-10-26','15:45:00',2.31),('11288','2013-10-26','15:50:00',2.11),('11288','2013-10-26','15:55:00',1.99),('11288','2013-10-26','16:00:00',1.89),('11288','2013-10-26','16:05:00',1.8),('11288','2013-10-26','16:10:00',1.66),('11288','2013-10-26','16:15:00',1.58),('11288','2013-10-26','16:20:00',1.49),('11288','2013-10-26','16:25:00',1.33),('11288','2013-10-26','16:30:00',1.27),('11288','2013-10-26','16:35:00',1.14),('11288','2013-10-26','16:40:00',1.07),('11288','2013-10-25','08:55:00',1.01),('11288','2013-10-25','09:00:00',1.18),('11288','2013-10-25','09:05:00',1.27),('11288','2013-10-25','09:10:00',1.4),('11288','2013-10-25','09:15:00',1.53),('11288','2013-10-25','09:20:00',1.6),('11288','2013-10-25','09:25:00',1.74),('11288','2013-10-25','09:30:00',1.85),('11288','2013-10-25','09:35:00',1.88),('11288','2013-10-25','09:40:00',1.93),('11288','2013-10-25','09:45:00',2.14),('11288','2013-10-25','09:50:00',2.22),('11288','2013-10-25','09:55:00',2.29),('11288','2013-10-25','10:00:00',2.43),('11288','2013-10-25','10:05:00',2.59),('11288','2013-10-25','10:10:00',2.67),('11288','2013-10-25','10:15:00',2.72),('11288','2013-10-25','10:20:00',2.76),('11288','2013-10-25','10:25:00',2.98),('11288','2013-10-25','10:30:00',3.08),('11288','2013-10-25','10:35:00',3.18),('11288','2013-10-25','10:40:00',3.26),('11288','2013-10-25','10:45:00',3.34),('11288','2013-10-25','10:50:00',3.37),('11288','2013-10-25','10:55:00',3.48),('11288','2013-10-25','11:00:00',3.5),('11288','2013-10-25','11:05:00',3.54),('11288','2013-10-25','11:10:00',3.47),('11288','2013-10-25','11:15:00',3.64),('11288','2013-10-25','11:20:00',3.72),('11288','2013-10-25','11:25:00',3.82),('11288','2013-10-25','11:30:00',3.89),('11288','2013-10-25','11:35:00',3.95),('11288','2013-10-25','11:40:00',3.79),('11288','2013-10-25','11:45:00',4),('11288','2013-10-25','11:50:00',4.15),('11288','2013-10-25','11:55:00',4.18),('11288','2013-10-25','12:00:00',4.26),('11288','2013-10-25','12:05:00',4.3),('11288','2013-10-25','12:10:00',4.29),('11288','2013-10-25','12:15:00',4.29),('11288','2013-10-25','12:20:00',4.33),('11288','2013-10-25','12:25:00',4.34),('11288','2013-10-25','12:30:00',4.3),('11288','2013-10-25','12:35:00',4.3),('11288','2013-10-25','12:40:00',4.38),('11288','2013-10-25','12:45:00',4.4),('11288','2013-10-25','12:50:00',4.34),('11288','2013-10-25','12:55:00',4.34),('11288','2013-10-25','13:00:00',4.32),('11288','2013-10-25','13:05:00',4.32),('11288','2013-10-25','13:10:00',4.31),('11288','2013-10-25','13:15:00',4.29),('11288','2013-10-25','13:20:00',4.27),('11288','2013-10-25','13:25:00',4.25),('11288','2013-10-25','13:30:00',4.19),('11288','2013-10-25','13:35:00',4.13),('11288','2013-10-25','13:40:00',4.07),('11288','2013-10-25','13:45:00',4.08),('11288','2013-10-25','13:50:00',4.06),('11288','2013-10-25','13:55:00',4.01),('11288','2013-10-25','14:00:00',3.95),('11288','2013-10-25','14:05:00',3.92),('11288','2013-10-25','14:10:00',3.85),('11288','2013-10-25','14:15:00',3.82),('11288','2013-10-25','14:20:00',3.8),('11288','2013-10-25','14:25:00',3.72),('11288','2013-10-25','14:30:00',3.69),('11288','2013-10-25','14:35:00',3.61),('11288','2013-10-25','14:40:00',3.5),('11288','2013-10-25','14:45:00',3.47),('11288','2013-10-25','14:50:00',3.39),('11288','2013-10-25','14:55:00',3.33),('11288','2013-10-25','15:00:00',3.18),('11288','2013-10-25','15:05:00',3.13),('11288','2013-10-25','15:10:00',3.06),('11288','2013-10-25','15:15:00',2.96),('11288','2013-10-25','15:20:00',2.86),('11288','2013-10-25','15:25:00',2.77),('11288','2013-10-25','15:30:00',2.66),('11288','2013-10-25','15:35:00',2.52),('11288','2013-10-25','15:40:00',2.51),('11288','2013-10-25','15:45:00',2.36),('11288','2013-10-25','15:50:00',2.27),('11288','2013-10-25','15:55:00',2.17),('11288','2013-10-25','16:00:00',2.02),('11288','2013-10-25','16:05:00',1.95),('11288','2013-10-25','16:10:00',1.86),('11288','2013-10-25','16:15:00',1.77),('11288','2013-10-25','16:20:00',1.64),('11288','2013-10-25','16:25:00',1.53),('11288','2013-10-25','16:30:00',1.43),('11288','2013-10-25','16:35:00',1.32),('11288','2013-10-25','16:40:00',1.21),('11288','2013-10-25','16:45:00',1.08),('11288','2013-10-25','16:50:00',1.02),('11288','2013-10-24','08:55:00',1.11),('11288','2013-10-24','09:00:00',1.32),('11288','2013-10-24','09:05:00',1.57),('11288','2013-10-24','09:10:00',1.68),('11288','2013-10-24','09:15:00',1.97),('11288','2013-10-24','09:20:00',1.62),('11288','2013-10-24','09:25:00',1.43),('11288','2013-10-24','09:30:00',1.56),('11288','2013-10-24','09:35:00',1.74),('11288','2013-10-24','09:40:00',1.84),('11288','2013-10-24','09:45:00',1.9),('11288','2013-10-24','09:50:00',1.89),('11288','2013-10-24','09:55:00',1.87),('11288','2013-10-24','10:00:00',1.82),('11288','2013-10-24','10:05:00',1.71),('11288','2013-10-24','10:10:00',1.55),('11288','2013-10-24','10:15:00',1.42),('11288','2013-10-24','10:20:00',1.99),('11288','2013-10-24','10:25:00',1.15),('11288','2013-10-24','10:30:00',1.36),('11288','2013-10-24','10:35:00',2.28),('11288','2013-10-24','10:40:00',1.73),('11288','2013-10-24','10:45:00',2.91),('11288','2013-10-24','10:50:00',2.53),('11288','2013-10-24','10:55:00',3.03),('11288','2013-10-24','11:00:00',4.22),('11288','2013-10-24','11:05:00',4.33),('11288','2013-10-24','11:10:00',3.33),('11288','2013-10-24','11:15:00',2.7),('11288','2013-10-24','11:20:00',2.81),('11288','2013-10-24','11:25:00',2.19),('11288','2013-10-24','11:30:00',1.91),('11288','2013-10-24','11:35:00',1.93),('11288','2013-10-24','11:40:00',1.83),('11288','2013-10-24','11:45:00',2.02),('11288','2013-10-24','11:50:00',2.71),('11288','2013-10-24','11:55:00',3.39),('11288','2013-10-24','12:00:00',2.88),('11288','2013-10-24','12:05:00',2.36),('11288','2013-10-24','12:10:00',2.25),('11288','2013-10-24','12:15:00',2.24),('11288','2013-10-24','12:20:00',2.34),('11288','2013-10-24','12:25:00',2.52),('11288','2013-10-24','12:30:00',2.66),('11288','2013-10-24','12:35:00',2.9),('11288','2013-10-24','12:40:00',3.5),('11288','2013-10-24','12:45:00',3.72),('11288','2013-10-24','12:50:00',3.18),('11288','2013-10-24','12:55:00',4.75),('11288','2013-10-24','13:00:00',5.08),('11288','2013-10-24','13:05:00',4.73),('11288','2013-10-24','13:10:00',3.76),('11288','2013-10-24','13:15:00',3.65),('11288','2013-10-24','13:20:00',3.36),('11288','2013-10-24','13:25:00',2.63),('11288','2013-10-24','13:30:00',2.25),('11288','2013-10-24','13:35:00',2.19),('11288','2013-10-24','13:40:00',2.22),('11288','2013-10-24','13:45:00',2.53),('11288','2013-10-24','13:50:00',2.91),('11288','2013-10-24','13:55:00',3.69),('11288','2013-10-24','14:00:00',3.4),('11288','2013-10-24','14:05:00',2.38),('11288','2013-10-24','14:10:00',2.25),('11288','2013-10-24','14:15:00',2.24),('11288','2013-10-24','14:20:00',2.43),('11288','2013-10-24','14:25:00',2.45),('11288','2013-10-24','14:30:00',2.54),('11288','2013-10-24','14:35:00',2.76),('11288','2013-10-24','14:40:00',3.06),('11288','2013-10-24','14:45:00',3.52),('11288','2013-10-24','14:50:00',2.21),('11288','2013-10-24','14:55:00',1.42),('11288','2013-10-24','15:00:00',1.48),('11288','2013-10-24','15:05:00',2.04),('11288','2013-10-24','15:10:00',2.74),('11288','2013-10-24','15:15:00',1.8),('11288','2013-10-24','15:20:00',1.95),('11288','2013-10-24','15:25:00',1.61),('11288','2013-10-24','15:30:00',2.1),('11288','2013-10-24','15:35:00',3.01),('11288','2013-10-24','15:40:00',2.64),('11288','2013-10-24','15:45:00',2.86),('11288','2013-10-24','15:50:00',1.67),('11288','2013-10-24','15:55:00',1.29),('11288','2013-10-24','16:00:00',1.24),('11288','2013-10-24','16:05:00',1.24),('11288','2013-10-24','16:10:00',1.21),('11288','2013-10-24','16:15:00',1.2),('11288','2013-10-24','16:20:00',1.12),('11288','2013-10-23','09:50:00',1.15),('11288','2013-10-23','09:55:00',1.57),('11288','2013-10-23','10:00:00',1.34),('11288','2013-10-23','10:05:00',1),('11288','2013-10-23','10:10:00',1.24),('11288','2013-10-23','10:15:00',1.49),('11288','2013-10-23','10:20:00',2.14),('11288','2013-10-23','10:25:00',2.19),('11288','2013-10-23','10:30:00',2.48),('11288','2013-10-23','10:35:00',2.33),('11288','2013-10-23','10:40:00',1.84),('11288','2013-10-23','10:45:00',2.17),('11288','2013-10-23','10:50:00',2.39),('11288','2013-10-23','10:55:00',2.29),('11288','2013-10-23','11:00:00',2.53),('11288','2013-10-23','11:05:00',3.55),('11288','2013-10-23','11:10:00',3.3),('11288','2013-10-23','11:15:00',2.62),('11288','2013-10-23','11:20:00',2.84),('11288','2013-10-23','11:25:00',3.51),('11288','2013-10-23','11:30:00',3.97),('11288','2013-10-23','11:35:00',3.92),('11288','2013-10-23','11:40:00',3.74),('11288','2013-10-23','11:45:00',3.64),('11288','2013-10-23','11:50:00',3.51),('11288','2013-10-23','11:55:00',4.02),('11288','2013-10-23','12:00:00',4.21),('11288','2013-10-23','12:05:00',3.65),('11288','2013-10-23','12:10:00',3.83),('11288','2013-10-23','12:15:00',3.9),('11288','2013-10-23','12:20:00',4.01),('11288','2013-10-23','12:25:00',4.08),('11288','2013-10-23','12:30:00',4.03),('11288','2013-10-23','12:35:00',4.28),('11288','2013-10-23','12:40:00',4.22),('11288','2013-10-23','12:45:00',4.08),('11288','2013-10-23','12:50:00',3.33),('11288','2013-10-23','12:55:00',3.45),('11288','2013-10-23','13:00:00',3.68),('11288','2013-10-23','13:05:00',3.74),('11288','2013-10-23','13:10:00',3.97),('11288','2013-10-23','13:15:00',3.84),('11288','2013-10-23','13:20:00',3.95),('11288','2013-10-23','13:25:00',4.07),('11288','2013-10-23','13:30:00',3.88),('11288','2013-10-23','13:35:00',3.92),('11288','2013-10-23','13:40:00',3.94),('11288','2013-10-23','13:45:00',3.9),('11288','2013-10-23','13:50:00',3.61),('11288','2013-10-23','13:55:00',3.17),('11288','2013-10-23','14:00:00',3.73),('11288','2013-10-23','14:05:00',3.97),('11288','2013-10-23','14:10:00',3.68),('11288','2013-10-23','14:15:00',3.34),('11288','2013-10-23','14:20:00',3.44),('11288','2013-10-23','14:25:00',3.38),('11288','2013-10-23','14:30:00',3.39),('11288','2013-10-23','14:35:00',3.32),('11288','2013-10-23','14:40:00',3.38),('11288','2013-10-23','14:45:00',3.37),('11288','2013-10-23','14:50:00',3.29),('11288','2013-10-23','14:55:00',3.42),('11288','2013-10-23','15:00:00',3.39),('11288','2013-10-23','15:05:00',3.25),('11288','2013-10-23','15:10:00',3.08),('11288','2013-10-23','15:15:00',2.99),('11288','2013-10-23','15:20:00',2.97),('11288','2013-10-23','15:25:00',2.89),('11288','2013-10-23','15:30:00',2.57),('11288','2013-10-23','15:35:00',2.4),('11288','2013-10-23','15:40:00',2.68),('11288','2013-10-23','15:45:00',2.66),('11288','2013-10-23','15:50:00',2.42),('11288','2013-10-23','15:55:00',1.93),('11288','2013-10-23','16:00:00',1.46),('11288','2013-10-23','16:05:00',1.26),('11288','2013-10-23','16:10:00',1.24),('11288','2013-10-23','16:15:00',1.32),('11288','2013-10-23','16:20:00',1.18),('11288','2013-10-23','16:25:00',1.22),('11288','2013-10-23','16:30:00',1.2),('11288','2013-10-23','16:35:00',1.39),('11288','2013-10-23','16:40:00',1.39),('11288','2013-10-23','16:45:00',1.2),('11288','2013-10-23','16:50:00',1),('11288','2013-10-22','08:55:00',1.15),('11288','2013-10-22','09:00:00',1.26),('11288','2013-10-22','09:05:00',1.35),('11288','2013-10-22','09:10:00',1.45),('11288','2013-10-22','09:15:00',1.54),('11288','2013-10-22','09:20:00',1.67),('11288','2013-10-22','09:25:00',1.79),('11288','2013-10-22','09:30:00',1.89),('11288','2013-10-22','09:35:00',1.98),('11288','2013-10-22','09:40:00',2.03),('11288','2013-10-22','09:45:00',2.07),('11288','2013-10-22','09:50:00',2.26),('11288','2013-10-22','09:55:00',2.38),('11288','2013-10-22','10:00:00',2.5),('11288','2013-10-22','10:05:00',2.58),('11288','2013-10-22','10:10:00',2.69),('11288','2013-10-22','10:15:00',2.79),('11288','2013-10-22','10:20:00',2.81),('11288','2013-10-22','10:25:00',2.96),('11288','2013-10-22','10:30:00',3.1),('11288','2013-10-22','10:35:00',3.21),('11288','2013-10-22','10:40:00',3.26),('11288','2013-10-22','10:45:00',3.23),('11288','2013-10-22','10:50:00',3.43),('11288','2013-10-22','10:55:00',3.52),('11288','2013-10-22','11:00:00',3.6),('11288','2013-10-22','11:05:00',3.62),('11288','2013-10-22','11:10:00',3.6),('11288','2013-10-22','11:15:00',3.62),('11288','2013-10-22','11:20:00',3.74),('11288','2013-10-22','11:25:00',3.78),('11288','2013-10-22','11:30:00',3.74),('11288','2013-10-22','11:35:00',3.8),('11288','2013-10-22','11:40:00',3.79),('11288','2013-10-22','11:45:00',3.92),('11288','2013-10-22','11:50:00',3.94),('11288','2013-10-22','11:55:00',4.02),('11288','2013-10-22','12:00:00',4.09),('11288','2013-10-22','12:05:00',4.09),('11288','2013-10-22','12:10:00',4.09),('11288','2013-10-22','12:15:00',4.09),('11288','2013-10-22','12:20:00',3.9),('11288','2013-10-22','12:25:00',4.07),('11288','2013-10-22','12:30:00',4.21),('11288','2013-10-22','12:35:00',4.26),('11288','2013-10-22','12:40:00',4.28),('11288','2013-10-22','12:45:00',4.24),('11288','2013-10-22','12:50:00',4.14),('11288','2013-10-22','12:55:00',4.15),('11288','2013-10-22','13:00:00',4.07),('11288','2013-10-22','13:05:00',4.07),('11288','2013-10-22','13:10:00',4.13),('11288','2013-10-22','13:15:00',4.18),('11288','2013-10-22','13:20:00',4.11),('11288','2013-10-22','13:25:00',4.17),('11288','2013-10-22','13:30:00',3.98),('11288','2013-10-22','13:35:00',4.01),('11288','2013-10-22','13:40:00',3.83),('11288','2013-10-22','13:45:00',3.68),('11288','2013-10-22','13:50:00',3.98),('11288','2013-10-22','13:55:00',3.99),('11288','2013-10-22','14:00:00',3.65),('11288','2013-10-22','14:05:00',2.98),('11288','2013-10-22','14:10:00',4.07),('11288','2013-10-22','14:15:00',4.23),('11288','2013-10-22','14:20:00',4.26),('11288','2013-10-22','14:25:00',4.45),('11288','2013-10-22','14:30:00',4.06),('11288','2013-10-22','14:35:00',4.04),('11288','2013-10-22','14:40:00',3.66),('11288','2013-10-22','14:45:00',3.64),('11288','2013-10-22','14:50:00',3.4),('11288','2013-10-22','14:55:00',3.32),('11288','2013-10-22','15:00:00',3.23),('11288','2013-10-22','15:05:00',3.07),('11288','2013-10-22','15:10:00',3.01),('11288','2013-10-22','15:15:00',2.97),('11288','2013-10-22','15:20:00',2.87),('11288','2013-10-22','15:25:00',2.68),('11288','2013-10-22','15:30:00',2.68),('11288','2013-10-22','15:35:00',2.75),('11288','2013-10-22','15:40:00',2.67),('11288','2013-10-22','15:45:00',2.31),('11288','2013-10-22','15:50:00',2.33),('11288','2013-10-22','15:55:00',2.13),('11288','2013-10-22','16:00:00',1.95),('11288','2013-10-22','16:05:00',1.79),('11288','2013-10-22','16:10:00',1.75),('11288','2013-10-22','16:15:00',1.69),('11288','2013-10-22','16:20:00',1.57),('11288','2013-10-22','16:25:00',1.47),('11288','2013-10-22','16:30:00',1.44),('11288','2013-10-22','16:35:00',1.35),('11288','2013-10-22','16:40:00',1.22),('11288','2013-10-22','16:45:00',1.13),('11288','2013-10-22','16:50:00',1.06),('11288','2013-10-21','08:55:00',1.01),('11288','2013-10-21','09:05:00',1.07),('11288','2013-10-21','09:10:00',1.38),('11288','2013-10-21','09:15:00',1.52),('11288','2013-10-21','09:20:00',1.9),('11288','2013-10-21','09:25:00',1.97),('11288','2013-10-21','09:30:00',1.84),('11288','2013-10-21','09:35:00',1.8),('11288','2013-10-21','09:40:00',2.02),('11288','2013-10-21','09:45:00',1.85),('11288','2013-10-21','09:50:00',2.09),('11288','2013-10-21','09:55:00',2.41),('11288','2013-10-21','10:00:00',2.35),('11288','2013-10-21','10:05:00',2.84),('11288','2013-10-21','10:10:00',2.81),('11288','2013-10-21','10:15:00',2.95),('11288','2013-10-21','10:20:00',2.83),('11288','2013-10-21','10:25:00',3.13),('11288','2013-10-21','10:30:00',3.14),('11288','2013-10-21','10:35:00',3.22),('11288','2013-10-21','10:40:00',3.18),('11288','2013-10-21','10:45:00',3.28),('11288','2013-10-21','10:50:00',3.51),('11288','2013-10-21','10:55:00',3.45),('11288','2013-10-21','11:00:00',3.74),('11288','2013-10-21','11:05:00',3.2),('11288','2013-10-21','11:10:00',3.44),('11288','2013-10-21','11:15:00',3.81),('11288','2013-10-21','11:20:00',3.89),('11288','2013-10-21','11:25:00',3.86),('11288','2013-10-21','11:30:00',4.01),('11288','2013-10-21','11:35:00',3.88),('11288','2013-10-21','11:40:00',3.86),('11288','2013-10-21','11:45:00',4.07),('11288','2013-10-21','11:50:00',4.24),('11288','2013-10-21','11:55:00',4.24),('11288','2013-10-21','12:00:00',4.33),('11288','2013-10-21','12:05:00',4.43),('11288','2013-10-21','12:10:00',4.45),('11288','2013-10-21','12:15:00',4.4),('11288','2013-10-21','12:20:00',4.4),('11288','2013-10-21','12:25:00',4.33),('11288','2013-10-21','12:30:00',4.27),('11288','2013-10-21','12:35:00',4.45),('11288','2013-10-21','12:40:00',4.49),('11288','2013-10-21','12:45:00',4.46),('11288','2013-10-21','12:50:00',4.39),('11288','2013-10-21','12:55:00',4.44),('11288','2013-10-21','13:00:00',4.38),('11288','2013-10-21','13:05:00',4.27),('11288','2013-10-21','13:10:00',4.25),('11288','2013-10-21','13:15:00',4.26),('11288','2013-10-21','13:20:00',4.21),('11288','2013-10-21','13:25:00',4.35),('11288','2013-10-21','13:30:00',4.36),('11288','2013-10-21','13:35:00',4.31),('11288','2013-10-21','13:40:00',4.26),('11288','2013-10-21','13:45:00',4.22),('11288','2013-10-21','13:50:00',4.06),('11288','2013-10-21','13:55:00',4),('11288','2013-10-21','14:00:00',4),('11288','2013-10-21','14:05:00',4.03),('11288','2013-10-21','14:10:00',3.97),('11288','2013-10-21','14:15:00',3.94),('11288','2013-10-21','14:20:00',3.9),('11288','2013-10-21','14:25:00',3.75),('11288','2013-10-21','14:30:00',3.75),('11288','2013-10-21','14:35:00',3.61),('11288','2013-10-21','14:40:00',3.44),('11288','2013-10-21','14:45:00',3.38),('11288','2013-10-21','14:50:00',3.28),('11288','2013-10-21','14:55:00',3.29),('11288','2013-10-21','15:00:00',3.27),('11288','2013-10-21','15:05:00',3.25),('11288','2013-10-21','15:10:00',3.16),('11288','2013-10-21','15:15:00',3.09),('11288','2013-10-21','15:20:00',3),('11288','2013-10-21','15:25:00',2.91),('11288','2013-10-21','15:30:00',2.76),('11288','2013-10-21','15:35:00',2.67),('11288','2013-10-21','15:40:00',2.59),('11288','2013-10-21','15:45:00',2.5),('11288','2013-10-21','15:50:00',2.41),('11288','2013-10-21','15:55:00',2.28),('11288','2013-10-21','16:00:00',2.09),('11288','2013-10-21','16:05:00',2.11),('11288','2013-10-21','16:10:00',2.03),('11288','2013-10-21','16:15:00',1.87),('11288','2013-10-21','16:20:00',1.74),('11288','2013-10-21','16:25:00',1.64),('11288','2013-10-21','16:30:00',1.54),('11288','2013-10-21','16:35:00',1.41),('11288','2013-10-21','16:40:00',1.27),('11288','2013-10-21','16:45:00',1.14),('11288','2013-10-21','16:50:00',1.11),('11288','2013-10-20','08:35:00',1.02),('11288','2013-10-20','08:40:00',1.02),('11288','2013-10-20','08:45:00',1.09),('11288','2013-10-20','08:50:00',1.11),('11288','2013-10-20','08:55:00',1.23),('11288','2013-10-20','09:00:00',1.24),('11288','2013-10-20','09:05:00',1.46),('11288','2013-10-20','09:10:00',1.59),('11288','2013-10-20','09:15:00',1.69),('11288','2013-10-20','09:20:00',1.86),('11288','2013-10-20','09:25:00',1.95),('11288','2013-10-20','09:30:00',2.04),('11288','2013-10-20','09:35:00',2.14),('11288','2013-10-20','09:40:00',2.28),('11288','2013-10-20','09:45:00',2.29),('11288','2013-10-20','09:50:00',2.46),('11288','2013-10-20','09:55:00',2.57),('11288','2013-10-20','10:00:00',2.65),('11288','2013-10-20','10:05:00',2.84),('11288','2013-10-20','10:10:00',2.93),('11288','2013-10-20','10:15:00',3),('11288','2013-10-20','10:20:00',3),('11288','2013-10-20','10:25:00',3.21),('11288','2013-10-20','10:30:00',3.33),('11288','2013-10-20','10:35:00',3.42),('11288','2013-10-20','10:40:00',3.49),('11288','2013-10-20','10:45:00',3.5),('11288','2013-10-20','10:50:00',3.53),('11288','2013-10-20','10:55:00',3.76),('11288','2013-10-20','11:00:00',3.78),('11288','2013-10-20','11:05:00',3.84),('11288','2013-10-20','11:10:00',3.81),('11288','2013-10-20','11:15:00',3.79),('11288','2013-10-20','11:20:00',4.02),('11288','2013-10-20','11:25:00',4.11),('11288','2013-10-20','11:30:00',4.15),('11288','2013-10-20','11:35:00',4.22),('11288','2013-10-20','11:40:00',4.18),('11288','2013-10-20','11:45:00',4.28),('11288','2013-10-20','11:50:00',4.34),('11288','2013-10-20','11:55:00',4.21),('11288','2013-10-20','12:00:00',4.34),('11288','2013-10-20','12:05:00',4.49),('11288','2013-10-20','12:10:00',4.03),('11288','2013-10-20','12:15:00',3.95),('11288','2013-10-20','12:20:00',2.82),('11288','2013-10-20','12:25:00',4.8),('11288','2013-10-20','12:30:00',4.41),('11288','2013-10-20','12:35:00',3.79),('11288','2013-10-20','12:40:00',2.87),('11288','2013-10-20','12:45:00',3.74),('11288','2013-10-20','12:50:00',2.96),('11288','2013-10-20','12:55:00',3.37),('11288','2013-10-20','13:00:00',3.56),('11288','2013-10-20','13:05:00',2.34),('11288','2013-10-20','13:10:00',2.14),('11288','2013-10-20','13:15:00',2.03),('11288','2013-10-20','13:20:00',4.2),('11288','2013-10-20','13:25:00',2.56),('11288','2013-10-20','13:30:00',1.6),('11288','2013-10-20','13:35:00',2.01),('11288','2013-10-20','13:40:00',2.21),('11288','2013-10-20','13:45:00',2.31),('11288','2013-10-20','13:50:00',1.92),('11288','2013-10-20','13:55:00',2.33),('11288','2013-10-20','14:00:00',1.75),('11288','2013-10-20','14:05:00',1.53),('11288','2013-10-20','14:10:00',1.68),('11288','2013-10-20','14:15:00',2.05),('11288','2013-10-20','14:40:00',1.11),('11288','2013-10-20','14:45:00',1.13),('11288','2013-10-20','14:50:00',1.08),('11288','2013-10-20','14:55:00',1.01),('11288','2013-10-20','16:30:00',1.15),('11288','2013-10-20','16:35:00',1.42),('11288','2013-10-20','16:40:00',1.85),('11288','2013-10-20','16:45:00',1.68),('11288','2013-10-20','16:50:00',1.89),('11288','2013-10-20','16:55:00',1.79),('11288','2013-10-20','17:00:00',1.54),('11288','2013-10-20','17:05:00',1.32),('11288','2013-10-19','08:40:00',1.02),('11288','2013-10-19','08:45:00',1.01),('11288','2013-10-19','08:50:00',1.25),('11288','2013-10-19','09:00:00',1.22),('11288','2013-10-19','09:05:00',1.42),('11288','2013-10-19','09:10:00',1.75),('11288','2013-10-19','09:15:00',2.2),('11288','2013-10-19','09:20:00',2.29),('11288','2013-10-19','09:25:00',2.37),('11288','2013-10-19','09:30:00',2.42),('11288','2013-10-19','09:35:00',2.5),('11288','2013-10-19','09:40:00',2.68),('11288','2013-10-19','09:45:00',2.6),('11288','2013-10-19','09:50:00',2.87),('11288','2013-10-19','09:55:00',3.05),('11288','2013-10-19','10:00:00',2.92),('11288','2013-10-19','10:05:00',2.93),('11288','2013-10-19','10:10:00',3.21),('11288','2013-10-19','10:15:00',3.07),('11288','2013-10-19','10:20:00',3.17),('11288','2013-10-19','10:25:00',3.67),('11288','2013-10-19','10:30:00',3.8),('11288','2013-10-19','10:35:00',3.85),('11288','2013-10-19','10:40:00',3.92),('11288','2013-10-19','10:45:00',3.85),('11288','2013-10-19','10:50:00',3.98),('11288','2013-10-19','10:55:00',3.89),('11288','2013-10-19','11:00:00',3.79),('11288','2013-10-19','11:05:00',3.95),('11288','2013-10-19','11:10:00',1.62),('11288','2013-10-19','11:15:00',1.96),('11288','2013-10-19','11:20:00',4.2),('11288','2013-10-19','11:25:00',4.48),('11288','2013-10-19','11:30:00',4.76),('11288','2013-10-19','11:35:00',4.64),('11288','2013-10-19','11:40:00',4.48),('11288','2013-10-19','11:45:00',4.76),('11288','2013-10-19','11:50:00',4.24),('11288','2013-10-19','11:55:00',4.81),('11288','2013-10-19','12:00:00',4.93),('11288','2013-10-19','12:05:00',4.93),('11288','2013-10-19','12:10:00',4.84),('11288','2013-10-19','12:15:00',4.9),('11288','2013-10-19','12:20:00',4.75),('11288','2013-10-19','12:25:00',4.61),('11288','2013-10-19','12:30:00',4.91),('11288','2013-10-19','12:35:00',5.01),('11288','2013-10-19','12:40:00',5.16),('11288','2013-10-19','12:45:00',5.26),('11288','2013-10-19','12:50:00',5.21),('11288','2013-10-19','12:55:00',5.5),('11288','2013-10-19','13:00:00',5.86),('11288','2013-10-19','13:05:00',4.85),('11288','2013-10-19','13:10:00',5.08),('11288','2013-10-19','13:15:00',4.73),('11288','2013-10-19','13:20:00',4.63),('11288','2013-10-19','13:25:00',4.92),('11288','2013-10-19','13:30:00',5.36),('11288','2013-10-19','13:35:00',3.61),('11288','2013-10-19','13:40:00',3.61),('11288','2013-10-19','13:45:00',3.06),('11288','2013-10-19','13:50:00',4.34),('11288','2013-10-19','13:55:00',5.11),('11288','2013-10-19','14:00:00',4.17),('11288','2013-10-19','14:05:00',3.58),('11288','2013-10-19','14:10:00',2.84),('11288','2013-10-19','14:15:00',3.82),('11288','2013-10-19','14:20:00',3.24),('11288','2013-10-19','14:25:00',2.51),('11288','2013-10-19','14:30:00',3.4),('11288','2013-10-19','14:35:00',4.32),('11288','2013-10-19','14:40:00',3.51),('11288','2013-10-19','14:45:00',3.26),('11288','2013-10-19','14:50:00',4.36),('11288','2013-10-19','14:55:00',4.15),('11288','2013-10-19','15:00:00',4.05),('11288','2013-10-19','15:05:00',3.9),('11288','2013-10-19','15:10:00',3.8),('11288','2013-10-19','15:15:00',3.68),('11288','2013-10-19','15:20:00',3.4),('11288','2013-10-19','15:25:00',3.23),('11288','2013-10-19','15:30:00',3.09),('11288','2013-10-19','15:35:00',3.07),('11288','2013-10-19','15:40:00',2.82),('11288','2013-10-19','15:45:00',2.42),('11288','2013-10-19','15:50:00',2.68),('11288','2013-10-19','15:55:00',2.79),('11288','2013-10-19','16:00:00',2.18),('11288','2013-10-19','16:05:00',2.43),('11288','2013-10-19','16:10:00',2.27),('11288','2013-10-19','16:15:00',2.33),('11288','2013-10-19','16:20:00',1.96),('11288','2013-10-19','16:25:00',1.64),('11288','2013-10-19','16:30:00',2.04),('11288','2013-10-19','16:35:00',1.91),('11288','2013-10-19','16:40:00',1.81),('11288','2013-10-19','16:45:00',1.76),('11288','2013-10-19','16:50:00',1.52),('11288','2014-05-04','07:45:00',1.05),('11288','2014-05-04','07:50:00',1.55),('11288','2014-05-04','07:55:00',1.65),('11288','2014-05-04','08:00:00',1.61),('11288','2014-05-04','08:05:00',1.88),('11288','2014-05-04','08:10:00',1.97),('11288','2014-05-04','08:15:00',2.13),('11288','2014-05-04','08:20:00',2.46),('11288','2014-05-04','08:25:00',2.36),('11288','2014-05-04','08:30:00',2.61),('11288','2014-05-04','08:35:00',3.38),('11288','2014-05-04','08:40:00',2.19),('11288','2014-05-04','08:45:00',2.32),('11288','2014-05-04','08:50:00',2.54),('11288','2014-05-04','08:55:00',2.06),('11288','2014-05-04','09:00:00',2.31),('11288','2014-05-04','09:05:00',3.41),('11288','2014-05-04','09:10:00',3.73),('11288','2014-05-04','09:15:00',3.3),('11288','2014-05-04','09:20:00',5.45),('11288','2014-05-04','09:25:00',5.8),('11288','2014-05-04','09:30:00',3.6),('11288','2014-05-04','09:35:00',2.21),('11288','2014-05-04','09:40:00',2.43),('11288','2014-05-04','09:45:00',3.32),('11288','2014-05-04','09:50:00',3.66),('11288','2014-05-04','09:55:00',3.45),('11288','2014-05-04','10:00:00',5.29),('11288','2014-05-04','10:05:00',6.25),('11288','2014-05-04','10:10:00',5.69),('11288','2014-05-04','10:15:00',4.6),('11288','2014-05-04','10:20:00',3.42),('11288','2014-05-04','10:25:00',3.43),('11288','2014-05-04','10:30:00',3.75),('11288','2014-05-04','10:35:00',3.81),('11288','2014-05-04','10:40:00',3.86),('11288','2014-05-04','10:45:00',4.37),('11288','2014-05-04','10:50:00',4.35),('11288','2014-05-04','10:55:00',4.23),('11288','2014-05-04','11:00:00',4.1),('11288','2014-05-04','11:05:00',4.06),('11288','2014-05-04','11:10:00',5.95),('11288','2014-05-04','11:15:00',6.29),('11288','2014-05-04','11:20:00',7.5),('11288','2014-05-04','11:25:00',7.28),('11288','2014-05-04','11:30:00',6.77),('11288','2014-05-04','11:35:00',6.44),('11288','2014-05-04','11:40:00',4.91),('11288','2014-05-04','11:45:00',6.63),('11288','2014-05-04','11:50:00',4.96),('11288','2014-05-04','11:55:00',7.52),('11288','2014-05-04','12:00:00',4.76),('11288','2014-05-04','12:05:00',4.18),('11288','2014-05-04','12:10:00',3.16),('11288','2014-05-04','12:15:00',2.91),('11288','2014-05-04','12:20:00',2.73),('11288','2014-05-04','12:25:00',2.96),('11288','2014-05-04','12:30:00',4.41),('11288','2014-05-04','12:35:00',9.21),('11288','2014-05-04','12:40:00',4.53),('11288','2014-05-04','12:45:00',3.62),('11288','2014-05-04','12:50:00',2.77),('11288','2014-05-04','12:55:00',3.47),('11288','2014-05-04','13:00:00',3.45),('11288','2014-05-04','13:05:00',2.84),('11288','2014-05-04','13:10:00',2.9),('11288','2014-05-04','13:15:00',2.93),('11288','2014-05-04','13:20:00',2.8),('11288','2014-05-04','13:25:00',2.72),('11288','2014-05-04','13:30:00',2.61),('11288','2014-05-04','13:35:00',2.89),('11288','2014-05-04','13:40:00',2.84),('11288','2014-05-04','13:45:00',2.51),('11288','2014-05-04','13:50:00',2.35),('11288','2014-05-04','13:55:00',2.46),('11288','2014-05-04','14:00:00',2.47),('11288','2014-05-04','14:05:00',2.5),('11288','2014-05-04','14:10:00',2.47),('11288','2014-05-04','14:15:00',2.29),('11288','2014-05-04','14:20:00',1.77),('11288','2014-05-04','14:25:00',1.24),('11288','2014-05-04','14:30:00',1.08),('11288','2014-05-04','14:35:00',1.14),('11288','2014-05-04','14:40:00',1.32),('11288','2014-05-04','14:45:00',1.54),('11288','2014-05-04','14:50:00',2.12),('11288','2014-05-04','14:55:00',3.01),('11288','2014-05-04','15:00:00',3.42),('11288','2014-05-04','15:05:00',3.84),('11288','2014-05-04','15:10:00',5.67),('11288','2014-05-04','15:15:00',4.56),('11288','2014-05-04','15:20:00',3.8),('11288','2014-05-04','15:25:00',2.83),('11288','2014-05-04','15:30:00',2.4),('11288','2014-05-04','15:35:00',1.6),('11288','2014-05-04','15:40:00',1.41),('11288','2014-05-04','15:45:00',1.65),('11288','2014-05-04','15:50:00',2.01),('11288','2014-05-04','15:55:00',2.08),('11288','2014-05-04','16:00:00',1.9),('11288','2014-05-04','16:05:00',1.98),('11288','2014-05-04','16:10:00',2.33),('11288','2014-05-04','16:15:00',2.2),('11288','2014-05-04','16:20:00',1.87),('11288','2014-05-04','16:25:00',1.45),('11288','2014-05-04','16:30:00',1.11),('11288','2014-05-04','16:55:00',1.01),('11288','2014-05-04','17:20:00',1.13),('11288','2014-05-04','17:25:00',1.62),('11288','2014-05-04','17:30:00',1.66),('11288','2014-05-04','17:35:00',1.75),('11288','2014-05-04','17:40:00',1.91),('11288','2014-05-04','17:45:00',1.35),('11288','2014-05-04','17:50:00',1.1),('11288','2014-05-04','18:05:00',1.15),('11288','2014-04-16','07:55:00',1.1),('11288','2014-04-16','08:00:00',1.33),('11288','2014-04-16','08:05:00',1.41),('11288','2014-04-16','08:10:00',1.47),('11288','2014-04-16','08:15:00',1.58),('11288','2014-04-16','08:20:00',1.74),('11288','2014-04-16','08:25:00',1.88),('11288','2014-04-16','08:30:00',1.57),('11288','2014-04-16','08:35:00',1.25),('11288','2014-04-16','08:40:00',1.44),('11288','2014-04-16','08:45:00',2.4),('11288','2014-04-16','08:50:00',2.61),('11288','2014-04-16','08:55:00',3.07),('11288','2014-04-16','09:00:00',3.27),('11288','2014-04-16','09:05:00',3.26),('11288','2014-04-16','09:10:00',3.44),('11288','2014-04-16','09:15:00',3.54),('11288','2014-04-16','09:20:00',3.74),('11288','2014-04-16','09:25:00',3.92),('11288','2014-04-16','09:30:00',2.62),('11288','2014-04-16','09:35:00',1.94),('11288','2014-04-16','09:40:00',1.52),('11288','2014-04-16','09:45:00',1.57),('11288','2014-04-16','09:50:00',1.76),('11288','2014-04-16','09:55:00',4.83),('11288','2014-04-16','10:00:00',5.25),('11288','2014-04-16','10:05:00',5.33),('11288','2014-04-16','10:10:00',5.43),('11288','2014-04-16','10:15:00',5.61),('11288','2014-04-16','10:20:00',5.76),('11288','2014-04-16','10:25:00',5.89),('11288','2014-04-16','10:30:00',5.99),('11288','2014-04-16','10:35:00',6.04),('11288','2014-04-16','10:40:00',6.14),('11288','2014-04-16','10:45:00',6.29),('11288','2014-04-16','10:50:00',6.54),('11288','2014-04-16','10:55:00',5.98),('11288','2014-04-16','11:00:00',6.18),('11288','2014-04-16','11:05:00',3.36),('11288','2014-04-16','11:10:00',2.76),('11288','2014-04-16','11:15:00',3.19),('11288','2014-04-16','11:20:00',5.92),('11288','2014-04-16','11:25:00',6.18),('11288','2014-04-16','11:30:00',6.79),('11288','2014-04-16','11:35:00',4.75),('11288','2014-04-16','11:40:00',5.51),('11288','2014-04-16','11:45:00',7.14),('11288','2014-04-16','11:50:00',8.02),('11288','2014-04-16','11:55:00',8),('11288','2014-04-16','12:00:00',8.03),('11288','2014-04-16','12:05:00',6.76),('11288','2014-04-16','12:10:00',6.43),('11288','2014-04-16','12:15:00',8.09),('11288','2014-04-16','12:20:00',4.31),('11288','2014-04-16','12:25:00',2.16),('11288','2014-04-16','12:30:00',2.34),('11288','2014-04-16','12:35:00',7.78),('11288','2014-04-16','12:40:00',7.8),('11288','2014-04-16','12:45:00',7.81),('11288','2014-04-16','12:50:00',7.07),('11288','2014-04-16','12:55:00',1.95),('11288','2014-04-16','13:00:00',4.58),('11288','2014-04-16','13:05:00',2.57),('11288','2014-04-16','13:10:00',1.53),('11288','2014-04-16','13:15:00',1.6),('11288','2014-04-16','13:20:00',2.57),('11288','2014-04-16','13:25:00',2.05),('11288','2014-04-16','13:30:00',1.69),('11288','2014-04-16','13:35:00',2.8),('11288','2014-04-16','13:40:00',4.84),('11288','2014-04-16','13:45:00',8.62),('11288','2014-04-16','13:50:00',7.68),('11288','2014-04-16','13:55:00',7.84),('11288','2014-04-16','14:00:00',3.02),('11288','2014-04-16','14:05:00',6.14),('11288','2014-04-16','14:10:00',7.46),('11288','2014-04-16','14:15:00',8.38),('11288','2014-04-16','14:20:00',6.34),('11288','2014-04-16','14:25:00',6.78),('11288','2014-04-16','14:30:00',7.58),('11288','2014-04-16','14:35:00',7.22),('11288','2014-04-16','14:40:00',7.09),('11288','2014-04-16','14:45:00',7.41),('11288','2014-04-16','14:50:00',7.59),('11288','2014-04-16','14:55:00',3.35),('11288','2014-04-16','15:00:00',2.13),('11288','2014-04-16','15:05:00',5.13),('11288','2014-04-16','15:10:00',7.82),('11288','2014-04-16','15:15:00',5.41),('11288','2014-04-16','15:20:00',1.12),('11288','2014-04-16','15:25:00',2.09),('11288','2014-04-16','15:30:00',4.08),('11288','2014-04-16','15:35:00',6.98),('11288','2014-04-16','15:40:00',6.72),('11288','2014-04-16','15:45:00',6.43),('11288','2014-04-16','15:50:00',6.2),('11288','2014-04-16','15:55:00',5.94),('11288','2014-04-16','16:00:00',5.77),('11288','2014-04-16','16:05:00',5.6),('11288','2014-04-16','16:10:00',5.46),('11288','2014-04-16','16:15:00',5.35),('11288','2014-04-16','16:20:00',5.32),('11288','2014-04-16','16:25:00',5.12),('11288','2014-04-16','16:30:00',5),('11288','2014-04-16','16:35:00',4.82),('11288','2014-04-16','16:40:00',4.71),('11288','2014-04-16','16:45:00',4.58),('11288','2014-04-16','16:50:00',4.42),('11288','2014-04-16','16:55:00',4.24),('11288','2014-04-16','17:00:00',4.07),('11288','2014-04-16','17:05:00',3.93),('11288','2014-04-16','17:10:00',3.77),('11288','2014-04-16','17:15:00',3.64),('11288','2014-04-16','17:20:00',3.45),('11288','2014-04-16','17:25:00',3.28),('11288','2014-04-16','17:30:00',3.12),('11288','2014-04-16','17:35:00',3.01),('11288','2014-04-16','17:40:00',2.81),('11288','2014-04-16','17:45:00',2.68),('11288','2014-04-16','17:50:00',2.61),('11288','2014-04-16','17:55:00',2.57),('11288','2014-04-16','18:00:00',2.35),('11288','2014-04-16','18:05:00',2.22),('11288','2014-04-16','18:10:00',1.97),('11288','2014-04-16','18:15:00',1.49),('11288','2014-04-16','18:20:00',1.74),('11288','2014-04-16','18:25:00',1.47),('11288','2014-04-16','18:30:00',1.27),('11288','2014-04-16','18:35:00',1.1),('11288','2014-04-16','18:40:00',1.23),('11288','2014-04-16','18:45:00',1.32),('11288','2014-04-16','18:50:00',1.35),('11288','2014-04-16','18:55:00',1.08),('11288','2013-10-18','08:45:00',1.07),('11288','2013-10-18','08:50:00',1.24),('11288','2013-10-18','08:55:00',1.3),('11288','2013-10-18','09:00:00',1.38),('11288','2013-10-18','09:05:00',1.62),('11288','2013-10-18','09:10:00',1.78),('11288','2013-10-18','09:15:00',1.89),('11288','2013-10-18','09:20:00',2.09),('11288','2013-10-18','09:25:00',2.2),('11288','2013-10-18','09:30:00',2.3),('11288','2013-10-18','09:35:00',2.45),('11288','2013-10-18','09:40:00',2.53),('11288','2013-10-18','09:45:00',2.57),('11288','2013-10-18','09:50:00',2.82),('11288','2013-10-18','09:55:00',2.95),('11288','2013-10-18','10:00:00',2.97),('11288','2013-10-18','10:05:00',3.18),('11288','2013-10-18','10:10:00',3.27),('11288','2013-10-18','10:15:00',3.36),('11288','2013-10-18','10:20:00',3.31),('11288','2013-10-18','10:25:00',3.39),('11288','2013-10-18','10:30:00',3.68),('11288','2013-10-18','10:35:00',3.78),('11288','2013-10-18','10:40:00',3.87),('11288','2013-10-18','10:45:00',3.9),('11288','2013-10-18','10:50:00',3.97),('11288','2013-10-18','10:55:00',4.03),('11288','2013-10-18','11:00:00',4.06),('11288','2013-10-18','11:05:00',3.89),('11288','2013-10-18','11:10:00',4.07),('11288','2013-10-18','11:15:00',3.99),('11288','2013-10-18','11:20:00',4.41),('11288','2013-10-18','11:25:00',4.42),('11288','2013-10-18','11:30:00',4.4),('11288','2013-10-18','11:35:00',4.51),('11288','2013-10-18','11:40:00',4.62),('11288','2013-10-18','11:45:00',4.47),('11288','2013-10-18','11:50:00',4.51),('11288','2013-10-18','11:55:00',4.77),('11288','2013-10-18','12:00:00',4.73),('11288','2013-10-18','12:05:00',4.72),('11288','2013-10-18','12:10:00',4.8),('11288','2013-10-18','12:15:00',4.75),('11288','2013-10-18','12:20:00',4.66),('11288','2013-10-18','12:25:00',4.74),('11288','2013-10-18','12:30:00',4.78),('11288','2013-10-18','12:35:00',4.71),('11288','2013-10-18','12:40:00',4.75),('11288','2013-10-18','12:45:00',4.7),('11288','2013-10-18','12:50:00',4.62),('11288','2013-10-18','12:55:00',4.73),('11288','2013-10-18','13:00:00',4.69),('11288','2013-10-18','13:05:00',4.63),('11288','2013-10-18','13:10:00',4.41),('11288','2013-10-18','13:15:00',4.46),('11288','2013-10-18','13:20:00',4.69),('11288','2013-10-18','13:25:00',4.7),('11288','2013-10-18','13:30:00',4.75),('11288','2013-10-18','13:35:00',4.64),('11288','2013-10-18','13:40:00',4.62),('11288','2013-10-18','13:45:00',4.52),('11288','2013-10-18','13:50:00',4.53),('11288','2013-10-18','13:55:00',4.5),('11288','2013-10-18','14:00:00',4.2),('11288','2013-10-18','14:05:00',4.16),('11288','2013-10-18','14:10:00',4.15),('11288','2013-10-18','14:15:00',4.22),('11288','2013-10-18','14:20:00',4.13),('11288','2013-10-18','14:25:00',4.15),('11288','2013-10-18','14:30:00',4.11),('11288','2013-10-18','14:35:00',3.94),('11288','2013-10-18','14:40:00',3.93),('11288','2013-10-18','14:45:00',3.71),('11288','2013-10-18','14:50:00',3.66),('11288','2013-10-18','14:55:00',3.71),('11288','2013-10-18','15:00:00',3.15),('11288','2013-10-18','15:05:00',2.99),('11288','2013-10-18','15:10:00',3.28),('11288','2013-10-18','15:15:00',3.22),('11288','2013-10-18','15:20:00',3.35),('11288','2013-10-18','15:25:00',3.12),('11288','2013-10-18','15:30:00',2.95),('11288','2013-10-18','15:35:00',2.93),('11288','2013-10-18','15:40:00',2.74),('11288','2013-10-18','15:45:00',2.52),('11288','2013-10-18','15:50:00',2.37),('11288','2013-10-18','15:55:00',2.18),('11288','2013-10-18','16:00:00',2.25),('11288','2013-10-18','16:05:00',2.17),('11288','2013-10-18','16:10:00',2.08),('11288','2013-10-18','16:15:00',1.81),('11288','2013-10-18','16:20:00',1.74),('11288','2013-10-18','16:25:00',1.53),('11288','2013-10-18','16:30:00',1.39),('11288','2013-10-18','16:35:00',1.32),('11288','2013-10-18','16:40:00',1.03),('11288','2013-10-17','08:45:00',1.18),('11288','2013-10-17','08:50:00',1.35),('11288','2013-10-17','08:55:00',1.5),('11288','2013-10-17','09:00:00',1.59),('11288','2013-10-17','09:05:00',1.73),('11288','2013-10-17','09:10:00',1.85),('11288','2013-10-17','09:15:00',1.99),('11288','2013-10-17','09:20:00',2.09),('11288','2013-10-17','09:25:00',2.21),('11288','2013-10-17','09:30:00',2.32),('11288','2013-10-17','09:35:00',2.44),('11288','2013-10-17','09:40:00',2.51),('11288','2013-10-17','09:45:00',2.62),('11288','2013-10-17','09:50:00',2.82),('11288','2013-10-17','09:55:00',2.91),('11288','2013-10-17','10:00:00',2.97),('11288','2013-10-17','10:05:00',3.14),('11288','2013-10-17','10:10:00',3.24),('11288','2013-10-17','10:15:00',3.38),('11288','2013-10-17','10:20:00',3.43),('11288','2013-10-17','10:25:00',3.45),('11288','2013-10-17','10:30:00',3.66),('11288','2013-10-17','10:35:00',3.79),('11288','2013-10-17','10:40:00',3.89),('11288','2013-10-17','10:45:00',4),('11288','2013-10-17','10:50:00',4.06),('11288','2013-10-17','10:55:00',4.17),('11288','2013-10-17','11:00:00',4.23),('11288','2013-10-17','11:05:00',4.29),('11288','2013-10-17','11:10:00',4.34),('11288','2013-10-17','11:15:00',4.38),('11288','2013-10-17','11:20:00',4.46),('11288','2013-10-17','11:25:00',4.55),('11288','2013-10-17','11:30:00',4.59),('11288','2013-10-17','11:35:00',4.65),('11288','2013-10-17','11:40:00',4.69),('11288','2013-10-17','11:45:00',4.77),('11288','2013-10-17','11:50:00',4.78),('11288','2013-10-17','11:55:00',4.78),('11288','2013-10-17','12:00:00',4.81),('11288','2013-10-17','12:05:00',4.93),('11288','2013-10-17','12:10:00',4.95),('11288','2013-10-17','12:15:00',4.97),('11288','2013-10-17','12:20:00',4.95),('11288','2013-10-17','12:25:00',4.98),('11288','2013-10-17','12:30:00',4.99),('11288','2013-10-17','12:35:00',4.99),('11288','2013-10-17','12:40:00',5.05),('11288','2013-10-17','12:45:00',5.09),('11288','2013-10-17','12:50:00',5.05),('11288','2013-10-17','12:55:00',5.04),('11288','2013-10-17','13:00:00',5.02),('11288','2013-10-17','13:05:00',4.99),('11288','2013-10-17','13:10:00',4.99),('11288','2013-10-17','13:15:00',4.99),('11288','2013-10-17','13:20:00',4.95),('11288','2013-10-17','13:25:00',4.91),('11288','2013-10-17','13:30:00',4.88),('11288','2013-10-17','13:35:00',4.88),('11288','2013-10-17','13:40:00',4.83),('11288','2013-10-17','13:45:00',4.8),('11288','2013-10-17','13:50:00',4.78),('11288','2013-10-17','13:55:00',4.74),('11288','2013-10-17','14:00:00',4.7),('11288','2013-10-17','14:05:00',4.66),('11288','2013-10-17','14:10:00',4.61),('11288','2013-10-17','14:15:00',4.58),('11288','2013-10-17','14:20:00',4.47),('11288','2013-10-17','14:25:00',4.47),('11288','2013-10-17','14:30:00',4.38),('11288','2013-10-17','14:35:00',4.32),('11288','2013-10-17','14:40:00',4.26),('11288','2013-10-17','14:45:00',4.15),('11288','2013-10-17','14:50:00',4.1),('11288','2013-10-17','14:55:00',3.99),('11288','2013-10-17','15:00:00',3.92),('11288','2013-10-17','15:05:00',3.87),('11288','2013-10-17','15:10:00',3.76),('11288','2013-10-17','15:15:00',3.69),('11288','2013-10-17','15:20:00',3.59),('11288','2013-10-17','15:25:00',3.5),('11288','2013-10-17','15:30:00',3.35),('11288','2013-10-17','15:35:00',3.24),('11288','2013-10-17','15:40:00',3.14),('11288','2013-10-17','15:45:00',3.02),('11288','2013-10-17','15:50:00',2.91),('11288','2013-10-17','15:55:00',2.7),('11288','2013-10-17','16:00:00',2.56),('11288','2013-10-17','16:05:00',2.53),('11288','2013-10-17','16:10:00',2.41),('11288','2013-10-17','16:15:00',2.13),('11288','2013-10-17','16:20:00',2.18),('11288','2013-10-17','16:25:00',2.08),('11288','2013-10-17','16:30:00',1.93),('11288','2013-10-17','16:35:00',1.76),('11288','2013-10-17','16:40:00',1.67),('11288','2013-10-17','16:45:00',1.53),('11288','2013-10-17','16:50:00',1.38),('11288','2013-10-17','16:55:00',1.29),('11288','2013-10-17','17:00:00',1.18),('11288','2013-10-17','17:05:00',1.05),('11288','2013-10-16','09:40:00',1.09),('11288','2013-10-16','09:45:00',2.63),('11288','2013-10-16','09:50:00',2.07),('11288','2013-10-16','09:55:00',1.45),('11288','2013-10-16','10:00:00',1.51),('11288','2013-10-16','11:05:00',1.64),('11288','2013-10-16','11:10:00',1.75),('11288','2013-10-16','11:15:00',2.14),('11288','2013-10-16','11:20:00',1.71),('11288','2013-10-16','11:25:00',1.06),('11288','2013-10-16','11:55:00',2.03),('11288','2013-10-16','12:00:00',1.77),('11288','2013-10-16','12:10:00',1.91),('11288','2013-10-16','12:15:00',4.58),('11288','2013-10-16','12:20:00',2.57),('11288','2013-10-16','12:25:00',1.52),('11288','2013-10-16','12:30:00',2.59),('11288','2013-10-16','12:35:00',2.71),('11288','2013-10-16','12:40:00',6.04),('11288','2013-10-16','12:45:00',3.37),('11288','2013-10-16','12:50:00',5),('11288','2013-10-16','12:55:00',3.67),('11288','2013-10-16','13:00:00',3.36),('11288','2013-10-16','13:05:00',4.47),('11288','2013-10-16','13:10:00',5.43),('11288','2013-10-16','13:15:00',5.7),('11288','2013-10-16','13:20:00',5.39),('11288','2013-10-16','13:25:00',5.19),('11288','2013-10-16','13:30:00',4.95),('11288','2013-10-16','13:35:00',4.87),('11288','2013-10-16','13:40:00',4.9),('11288','2013-10-16','13:45:00',4.9),('11288','2013-10-16','13:50:00',4.39),('11288','2013-10-16','13:55:00',5.08),('11288','2013-10-16','14:00:00',4.17),('11288','2013-10-16','14:05:00',2.92),('11288','2013-10-16','14:10:00',5.07),('11288','2013-10-16','14:15:00',4.3),('11288','2013-10-16','14:20:00',4.35),('11288','2013-10-16','14:25:00',5.05),('11288','2013-10-16','14:30:00',4.62),('11288','2013-10-16','14:35:00',4.83),('11288','2013-10-16','14:40:00',4.48),('11288','2013-10-16','14:45:00',3.83),('11288','2013-10-16','14:50:00',3.92),('11288','2013-10-16','14:55:00',4.17),('11288','2013-10-16','15:00:00',3.84),('11288','2013-10-16','15:05:00',2.64),('11288','2013-10-16','15:10:00',3.84),('11288','2013-10-16','15:15:00',3.77),('11288','2013-10-16','15:20:00',3.38),('11288','2013-10-16','15:25:00',2.64),('11288','2013-10-16','15:30:00',1.15),('11288','2013-10-16','15:35:00',1.84),('11288','2013-10-16','15:40:00',3.32),('11288','2013-10-16','15:45:00',3.08),('11288','2013-10-16','15:50:00',2.93),('11288','2013-10-16','15:55:00',2.72),('11288','2013-10-16','16:00:00',2.62),('11288','2013-10-16','16:05:00',2.6),('11288','2013-10-16','16:10:00',2.44),('11288','2013-10-16','16:15:00',2.23),('11288','2013-10-16','16:20:00',2.17),('11288','2013-10-16','16:25:00',2.06),('11288','2013-10-16','16:30:00',1.9),('11288','2013-10-16','16:35:00',1.53),('11288','2013-10-16','16:40:00',1.5),('11288','2013-10-16','16:45:00',1.37),('11288','2013-10-16','16:50:00',1.42),('11288','2013-10-16','16:55:00',1.34),('11288','2013-10-16','17:00:00',1.21),('11288','2013-10-16','17:05:00',1.1),('11288','2013-10-16','17:10:00',1.01),('11288','2013-10-15','09:00:00',1.19),('11288','2013-10-15','09:05:00',1.38),('11288','2013-10-15','09:10:00',1.51),('11288','2013-10-15','09:15:00',1.47),('11288','2013-10-15','09:20:00',1.57),('11288','2013-10-15','09:25:00',1.55),('11288','2013-10-15','09:30:00',2.06),('11288','2013-10-15','09:35:00',1.48),('11288','2013-10-15','09:40:00',1.99),('11288','2013-10-15','09:45:00',2.58),('11288','2013-10-15','09:50:00',2.75),('11288','2013-10-15','09:55:00',2.98),('11288','2013-10-15','10:00:00',3.03),('11288','2013-10-15','10:05:00',3.39),('11288','2013-10-15','10:10:00',2.65),('11288','2013-10-15','10:15:00',1.79),('11288','2013-10-15','10:20:00',1.81),('11288','2013-10-15','10:25:00',2.29),('11288','2013-10-15','10:30:00',2.9),('11288','2013-10-15','10:35:00',2.45),('11288','2013-10-15','10:40:00',2.95),('11288','2013-10-15','10:45:00',3.49),('11288','2013-10-15','10:50:00',3.33),('11288','2013-10-15','10:55:00',2.93),('11288','2013-10-15','11:00:00',2.89),('11288','2013-10-15','11:05:00',3.13),('11288','2013-10-15','11:10:00',3.96),('11288','2013-10-15','11:15:00',4.33),('11288','2013-10-15','11:20:00',4.37),('11288','2013-10-15','11:25:00',4.04),('11288','2013-10-15','11:30:00',4.24),('11288','2013-10-15','11:35:00',3.57),('11288','2013-10-15','11:40:00',2.97),('11288','2013-10-15','11:45:00',2.52),('11288','2013-10-15','11:50:00',2.45),('11288','2013-10-15','11:55:00',2.44),('11288','2013-10-15','12:00:00',2.56),('11288','2013-10-15','12:05:00',2.58),('11288','2013-10-15','12:10:00',2.61),('11288','2013-10-15','12:15:00',2.57),('11288','2013-10-15','12:20:00',2.69),('11288','2013-10-15','12:25:00',2.43),('11288','2013-10-15','12:30:00',2.29),('11288','2013-10-15','12:35:00',2.21),('11288','2013-10-15','12:40:00',2.26),('11288','2013-10-15','12:45:00',2.46),('11288','2013-10-15','12:50:00',2.34),('11288','2013-10-15','12:55:00',2.11),('11288','2013-10-15','13:00:00',2.1),('11288','2013-10-15','13:05:00',2.7),('11288','2013-10-15','13:10:00',2.94),('11288','2013-10-15','13:15:00',2.98),('11288','2013-10-15','13:20:00',4.2),('11288','2013-10-15','13:25:00',4.59),('11288','2013-10-15','13:30:00',2.98),('11288','2013-10-15','13:35:00',2.6),('11288','2013-10-15','13:40:00',2.57),('11288','2013-10-15','13:45:00',2.63),('11288','2013-10-15','13:50:00',2.46),('11288','2013-10-15','13:55:00',2.22),('11288','2013-10-15','14:00:00',2.03),('11288','2013-10-15','14:05:00',2.04),('11288','2013-10-15','14:10:00',2.27),('11288','2013-10-15','14:15:00',3.03),('11288','2013-10-15','14:20:00',3.19),('11288','2013-10-15','14:25:00',3.45),('11288','2013-10-15','14:30:00',3.17),('11288','2013-10-15','14:35:00',2.22),('11288','2013-10-15','14:40:00',3.03),('11288','2013-10-15','14:45:00',3.08),('11288','2013-10-15','14:50:00',4),('11288','2013-10-15','14:55:00',2.96),('11288','2013-10-15','15:00:00',2.08),('11288','2013-10-15','15:05:00',2.17),('11288','2013-10-15','15:10:00',2.18),('11288','2013-10-15','15:15:00',2.05),('11288','2013-10-15','15:20:00',1.88),('11288','2013-10-15','15:25:00',1.73),('11288','2013-10-15','15:30:00',1.7),('11288','2013-10-15','15:35:00',1.78),('11288','2013-10-15','15:40:00',1.85),('11288','2013-10-15','15:45:00',1.78),('11288','2013-10-15','15:50:00',1.56),('11288','2013-10-15','15:55:00',1.38),('11288','2013-10-15','16:00:00',1.27),('11288','2013-10-15','16:05:00',1.3),('11288','2013-10-15','16:10:00',1.33),('11288','2013-10-15','16:15:00',1.24),('11288','2013-10-15','16:20:00',1.17),('11288','2013-10-15','16:25:00',1.56),('11288','2013-10-15','16:30:00',1.92),('11288','2013-10-15','16:35:00',1.93),('11288','2013-10-15','16:40:00',1.58),('11288','2013-10-15','16:45:00',1.28),('11288','2013-10-15','16:50:00',1.04),('11288','2013-10-15','16:55:00',1.07),('11288','2013-10-15','17:00:00',1.07),('11288','2013-10-14','08:25:00',1.05),('11288','2013-10-14','08:30:00',1.1),('11288','2013-10-14','08:35:00',1.22),('11288','2013-10-14','08:40:00',1.17),('11288','2013-10-14','08:45:00',1.3),('11288','2013-10-14','08:50:00',1.37),('11288','2013-10-14','08:55:00',1.56),('11288','2013-10-14','09:00:00',1.38),('11288','2013-10-14','09:05:00',1.41),('11288','2013-10-14','09:10:00',1.15),('11288','2013-10-14','09:15:00',1.01),('11288','2013-10-14','09:20:00',1.42),('11288','2013-10-14','09:25:00',2.1),('11288','2013-10-14','09:30:00',2.36),('11288','2013-10-14','09:35:00',2.09),('11288','2013-10-14','09:40:00',1.92),('11288','2013-10-14','09:45:00',1.62),('11288','2013-10-14','09:50:00',2.23),('11288','2013-10-14','09:55:00',2.61),('11288','2013-10-14','10:00:00',2.62),('11288','2013-10-14','10:05:00',2.87),('11288','2013-10-14','10:10:00',3.1),('11288','2013-10-14','10:15:00',3.29),('11288','2013-10-14','10:20:00',3.41),('11288','2013-10-14','10:25:00',3.48),('11288','2013-10-14','10:30:00',3.54),('11288','2013-10-14','10:35:00',3.64),('11288','2013-10-14','10:40:00',3.62),('11288','2013-10-14','10:45:00',3.74),('11288','2013-10-14','10:50:00',3.87),('11288','2013-10-14','10:55:00',3.94),('11288','2013-10-14','11:00:00',4),('11288','2013-10-14','11:05:00',4.01),('11288','2013-10-14','11:10:00',4.23),('11288','2013-10-14','11:15:00',4.18),('11288','2013-10-14','11:20:00',4.22),('11288','2013-10-14','11:25:00',4.32),('11288','2013-10-14','11:30:00',4.44),('11288','2013-10-14','11:35:00',4.35),('11288','2013-10-14','11:40:00',4.42),('11288','2013-10-14','11:45:00',4.36),('11288','2013-10-14','11:50:00',4.46),('11288','2013-10-14','11:55:00',4.49),('11288','2013-10-14','12:00:00',4.55),('11288','2013-10-14','12:05:00',4.6),('11288','2013-10-14','12:10:00',4.74),('11288','2013-10-14','12:15:00',4.65),('11288','2013-10-14','12:20:00',4.31),('11288','2013-10-14','12:25:00',4.62),('11288','2013-10-14','12:30:00',4.79),('11288','2013-10-14','12:35:00',4.67),('11288','2013-10-14','12:40:00',4.76),('11288','2013-10-14','12:45:00',4.79),('11288','2013-10-14','12:50:00',4.71),('11288','2013-10-14','12:55:00',4.74),('11288','2013-10-14','13:00:00',4.73),('11288','2013-10-14','13:05:00',4.68),('11288','2013-10-14','13:10:00',4.66),('11288','2013-10-14','13:15:00',4.63),('11288','2013-10-14','13:20:00',4.64),('11288','2013-10-14','13:25:00',4.63),('11288','2013-10-14','13:30:00',4.59),('11288','2013-10-14','13:35:00',4.58),('11288','2013-10-14','13:40:00',4.58),('11288','2013-10-14','13:45:00',4.55),('11288','2013-10-14','13:50:00',4.53),('11288','2013-10-14','13:55:00',4.47),('11288','2013-10-14','14:00:00',4.43),('11288','2013-10-14','14:05:00',4.41),('11288','2013-10-14','14:10:00',4.36),('11288','2013-10-14','14:15:00',4.31),('11288','2013-10-14','14:20:00',4.22),('11288','2013-10-14','14:25:00',4.21),('11288','2013-10-14','14:30:00',4.16),('11288','2013-10-14','14:35:00',4.09),('11288','2013-10-14','14:40:00',4.04),('11288','2013-10-14','14:45:00',3.96),('11288','2013-10-14','14:50:00',3.85),('11288','2013-10-14','14:55:00',3.77),('11288','2013-10-14','15:00:00',3.73),('11288','2013-10-14','15:05:00',3.65),('11288','2013-10-14','15:10:00',3.51),('11288','2013-10-14','15:15:00',3.41),('11288','2013-10-14','15:20:00',3.33),('11288','2013-10-14','15:25:00',3.25),('11288','2013-10-14','15:30:00',3.08),('11288','2013-10-14','15:35:00',2.97),('11288','2013-10-14','15:40:00',2.71),('11288','2013-10-14','15:45:00',2.13),('11288','2013-10-14','15:50:00',2.23),('11288','2013-10-14','15:55:00',1.49),('11288','2013-10-14','16:00:00',1.68),('11288','2013-10-14','16:05:00',1.52),('11288','2013-10-14','16:10:00',1.52),('11288','2013-10-14','16:15:00',1.47),('11288','2013-10-14','16:20:00',1.39),('11288','2013-10-14','16:25:00',1.54),('11288','2013-10-14','16:30:00',1.26),('11288','2013-10-14','16:45:00',1.26),('11288','2013-10-13','08:50:00',1.07),('11288','2013-10-13','08:55:00',1.23),('11288','2013-10-13','09:00:00',1.38),('11288','2013-10-13','09:05:00',1.38),('11288','2013-10-13','09:10:00',1.54),('11288','2013-10-13','09:15:00',2.28),('11288','2013-10-13','09:20:00',2.41),('11288','2013-10-13','09:25:00',2.16),('11288','2013-10-13','09:30:00',1.69),('11288','2013-10-13','09:35:00',2.21),('11288','2013-10-13','09:40:00',3.09),('11288','2013-10-13','09:45:00',3.75),('11288','2013-10-13','09:50:00',3.71),('11288','2013-10-13','09:55:00',3.74),('11288','2013-10-13','10:00:00',2.68),('11288','2013-10-13','10:05:00',2.22),('11288','2013-10-13','10:10:00',3.07),('11288','2013-10-13','10:15:00',3.27),('11288','2013-10-13','10:20:00',2.77),('11288','2013-10-13','10:25:00',3.15),('11288','2013-10-13','10:30:00',4.1),('11288','2013-10-13','10:35:00',4.59),('11288','2013-10-13','10:40:00',4.73),('11288','2013-10-13','10:45:00',4.89),('11288','2013-10-13','10:50:00',3.86),('11288','2013-10-13','10:55:00',3.61),('11288','2013-10-13','11:00:00',4.3),('11288','2013-10-13','11:05:00',4.28),('11288','2013-10-13','11:10:00',4.51),('11288','2013-10-13','11:15:00',4.62),('11288','2013-10-13','11:20:00',4.44),('11288','2013-10-13','11:25:00',4.37),('11288','2013-10-13','11:30:00',4.52),('11288','2013-10-13','11:35:00',4.49),('11288','2013-10-13','11:40:00',4.55),('11288','2013-10-13','11:45:00',4.54),('11288','2013-10-13','11:50:00',4.61),('11288','2013-10-13','11:55:00',4.66),('11288','2013-10-13','12:00:00',4.7),('11288','2013-10-13','12:05:00',4.74),('11288','2013-10-13','12:10:00',4.77),('11288','2013-10-13','12:15:00',4.84),('11288','2013-10-13','12:20:00',4.64),('11288','2013-10-13','12:25:00',4.61),('11288','2013-10-13','12:30:00',4.81),('11288','2013-10-13','12:35:00',4.87),('11288','2013-10-13','12:40:00',4.93),('11288','2013-10-13','12:45:00',4.85),('11288','2013-10-13','12:50:00',4.73),('11288','2013-10-13','12:55:00',4.72),('11288','2013-10-13','13:00:00',4.76),('11288','2013-10-13','13:05:00',4.74),('11288','2013-10-13','13:10:00',4.79),('11288','2013-10-13','13:15:00',4.82),('11288','2013-10-13','13:20:00',4.86),('11288','2013-10-13','13:25:00',4.14),('11288','2013-10-13','13:30:00',3.63),('11288','2013-10-13','13:35:00',3.71),('11288','2013-10-13','13:40:00',2.82),('11288','2013-10-13','13:45:00',3.19),('11288','2013-10-13','13:50:00',3.54),('11288','2013-10-13','13:55:00',3.91),('11288','2013-10-13','14:00:00',4.73),('11288','2013-10-13','14:05:00',4.63),('11288','2013-10-13','14:10:00',4.54),('11288','2013-10-13','14:15:00',4.22),('11288','2013-10-13','14:20:00',4.66),('11288','2013-10-13','14:25:00',4.6),('11288','2013-10-13','14:30:00',3.72),('11288','2013-10-13','14:35:00',3.78),('11288','2013-10-13','14:40:00',4.04),('11288','2013-10-13','14:45:00',3.01),('11288','2013-10-13','14:50:00',2.71),('11288','2013-10-13','14:55:00',3.25),('11288','2013-10-13','15:00:00',4.05),('11288','2013-10-13','15:05:00',3.21),('11288','2013-10-13','15:10:00',2.41),('11288','2013-10-13','15:15:00',2.96),('11288','2013-10-13','15:20:00',3.33),('11288','2013-10-13','15:25:00',3.48),('11288','2013-10-13','15:30:00',2.64),('11288','2013-10-13','15:35:00',2.34),('11288','2013-10-13','15:40:00',2.31),('11288','2013-10-13','15:45:00',2.27),('11288','2013-10-13','15:50:00',2.12),('11288','2013-10-13','15:55:00',2.08),('11288','2013-10-13','16:00:00',2.24),('11288','2013-10-13','16:05:00',2.5),('11288','2013-10-13','16:10:00',2.18),('11288','2013-10-13','16:15:00',1.97),('11288','2013-10-13','16:20:00',2.1),('11288','2013-10-13','16:25:00',2.44),('11288','2013-10-13','16:30:00',2.32),('11288','2013-10-13','16:35:00',1.88),('11288','2013-10-13','16:40:00',1.58),('11288','2013-10-13','16:45:00',1.26),('11288','2013-10-13','16:50:00',1.29),('11288','2013-10-13','16:55:00',1.14),('11288','2013-10-13','17:20:00',1.01),('11288','2013-10-13','17:25:00',1.14),('11288','2013-10-12','10:50:00',1.06),('11288','2013-10-12','10:55:00',1.17),('11288','2013-10-12','11:00:00',1.32),('11288','2013-10-12','11:05:00',1.3),('11288','2013-10-12','11:10:00',1.49),('11288','2013-10-12','11:15:00',1.68),('11288','2013-10-12','11:20:00',1.96),('11288','2013-10-12','11:25:00',1.9),('11288','2013-10-12','11:30:00',2.47),('11288','2013-10-12','11:35:00',3.23),('11288','2013-10-12','11:40:00',4.66),('11288','2013-10-12','11:45:00',2.4),('11288','2013-10-12','11:50:00',2.37),('11288','2013-10-12','11:55:00',2.1),('11288','2013-10-12','12:00:00',1.41),('11288','2013-10-12','12:05:00',1.1),('11288','2013-10-12','12:10:00',1.36),('11288','2013-10-12','12:15:00',1.98),('11288','2013-10-12','12:20:00',3.46),('11288','2013-10-12','12:25:00',5.4),('11288','2013-10-12','12:30:00',4.19),('11288','2013-10-12','12:35:00',5.02),('11288','2013-10-12','12:40:00',4.71),('11288','2013-10-12','12:45:00',4.64),('11288','2013-10-12','12:50:00',4.45),('11288','2013-10-12','12:55:00',3.47),('11288','2013-10-12','13:00:00',2.85),('11288','2013-10-12','13:05:00',1.76),('11288','2013-10-12','13:10:00',1.42),('11288','2013-10-12','13:15:00',2.27),('11288','2013-10-12','13:20:00',2.32),('11288','2013-10-12','13:25:00',2.76),('11288','2013-10-12','13:30:00',5.91),('11288','2013-10-12','13:35:00',2.47),('11288','2013-10-12','13:55:00',1.09),('11288','2013-10-12','14:00:00',1.14),('11288','2013-10-12','15:10:00',1.09),('11288','2013-10-12','15:15:00',1.19),('11288','2013-10-12','15:20:00',1.27),('11288','2013-10-12','15:25:00',1.47),('11288','2013-10-12','15:30:00',1.53),('11288','2013-10-12','15:35:00',1.42),('11288','2013-10-12','15:40:00',1.27),('11288','2013-10-12','15:45:00',1.21),('11288','2013-10-12','15:50:00',1.36),('11288','2013-10-12','15:55:00',1.71),('11288','2013-10-12','16:00:00',1.96),('11288','2013-10-12','16:05:00',1.86),('11288','2013-10-12','16:10:00',1.94),('11288','2013-10-12','16:15:00',2.7),('11288','2013-10-12','16:20:00',2.93),('11288','2013-10-12','16:25:00',1.86),('11288','2013-10-12','16:30:00',1.22),('11288','2013-10-12','17:00:00',1.2),('11288','2013-10-11','09:05:00',1.01),('11288','2013-10-11','09:15:00',1.63),('11288','2013-10-11','09:20:00',1.36),('11288','2013-10-11','09:25:00',1.01),('11288','2013-10-11','09:30:00',1.01),('11288','2013-10-11','09:40:00',1.77),('11288','2013-10-11','09:45:00',2.87),('11288','2013-10-11','09:50:00',3.02),('11288','2013-10-11','09:55:00',3.13),('11288','2013-10-11','10:00:00',3.3),('11288','2013-10-11','10:05:00',3.45),('11288','2013-10-11','10:10:00',3.54),('11288','2013-10-11','10:15:00',2.87),('11288','2013-10-11','10:20:00',2.27),('11288','2013-10-11','10:25:00',3.03),('11288','2013-10-11','10:30:00',3.42),('11288','2013-10-11','10:35:00',3.57),('11288','2013-10-11','10:40:00',2.1),('11288','2013-10-11','10:45:00',1.41),('11288','2013-10-11','11:00:00',1.03),('11288','2013-10-11','11:05:00',4.12),('11288','2013-10-11','11:10:00',3.21),('11288','2013-10-11','11:15:00',1.73),('11288','2013-10-11','11:20:00',1.86),('11288','2013-10-11','11:25:00',1.8),('11288','2013-10-11','11:30:00',1.56),('11288','2013-10-11','11:35:00',2.07),('11288','2013-10-11','11:40:00',2.83),('11288','2013-10-11','11:45:00',3.04),('11288','2013-10-11','11:50:00',3.42),('11288','2013-10-11','11:55:00',3.09),('11288','2013-10-11','12:00:00',4.6),('11288','2013-10-11','12:05:00',4.59),('11288','2013-10-11','12:10:00',2.41),('11288','2013-10-11','12:15:00',1.9),('11288','2013-10-11','12:20:00',1.62),('11288','2013-10-11','12:25:00',2.53),('11288','2013-10-11','12:30:00',1.71),('11288','2013-10-11','13:00:00',1.38),('11288','2013-10-11','13:05:00',3.79),('11288','2013-10-11','13:10:00',3.47),('11288','2013-10-11','13:15:00',2.84),('11288','2013-10-11','13:20:00',3.31),('11288','2013-10-11','13:25:00',5.74),('11288','2013-10-11','13:30:00',2.54),('11288','2013-10-11','13:35:00',1.26),('11288','2013-10-11','13:40:00',3.83),('11288','2013-10-11','13:45:00',4.68),('11288','2013-10-11','13:50:00',1.18),('11288','2013-10-11','15:10:00',1.44),('11288','2013-10-11','15:30:00',1.76),('11288','2013-10-11','15:35:00',2.17),('11288','2013-10-11','15:40:00',2.62),('11288','2013-10-11','15:45:00',1.76),('11288','2013-10-11','15:50:00',1.19),('11288','2013-10-11','15:55:00',1.67),('11288','2013-10-11','16:00:00',3.28),('11288','2013-10-11','16:05:00',1.47),('11288','2013-10-11','16:10:00',1.21),('11288','2013-10-11','16:25:00',1.04),('11288','2013-10-11','16:30:00',1.44),('11288','2013-10-11','16:35:00',1.46),('11288','2013-10-11','17:00:00',1.47),('11288','2013-10-10','08:45:00',1.15),('11288','2013-10-10','08:50:00',1.2),('11288','2013-10-10','08:55:00',1.33),('11288','2013-10-10','09:00:00',1.3),('11288','2013-10-10','09:05:00',1.24),('11288','2013-10-10','09:10:00',2.04),('11288','2013-10-10','09:15:00',2.22),('11288','2013-10-10','09:20:00',2.27),('11288','2013-10-10','09:25:00',2.33),('11288','2013-10-10','09:30:00',2.35),('11288','2013-10-10','09:35:00',2),('11288','2013-10-10','09:40:00',2.37),('11288','2013-10-10','09:45:00',2.52),('11288','2013-10-10','09:50:00',2.41),('11288','2013-10-10','09:55:00',1.6),('11288','2013-10-10','10:10:00',2.79),('11288','2013-10-10','10:15:00',3.63),('11288','2013-10-10','10:20:00',3.69),('11288','2013-10-10','10:25:00',1.63),('11288','2013-10-10','10:30:00',2.03),('11288','2013-10-10','10:35:00',1.04),('11288','2013-10-10','10:40:00',3.85),('11288','2013-10-10','10:45:00',4.31),('11288','2013-10-10','10:50:00',3.42),('11288','2013-10-10','10:55:00',2.01),('11288','2013-10-10','11:05:00',1.27),('11288','2013-10-10','11:20:00',4.16),('11288','2013-10-10','11:25:00',3.85),('11288','2013-10-10','11:30:00',1.34),('11288','2013-10-10','11:35:00',3.73),('11288','2013-10-10','11:40:00',3.39),('11288','2013-10-10','11:45:00',1.08),('11288','2013-10-10','11:50:00',5.04),('11288','2013-10-10','11:55:00',5.73),('11288','2013-10-10','12:00:00',5.48),('11288','2013-10-10','12:05:00',5.7),('11288','2013-10-10','12:10:00',1.41),('11288','2013-10-10','12:15:00',1.01),('11288','2013-10-10','12:20:00',4.87),('11288','2013-10-10','12:25:00',4.92),('11288','2013-10-10','12:30:00',1.68),('11288','2013-10-10','12:35:00',6.33),('11288','2013-10-10','12:40:00',5.92),('11288','2013-10-10','12:45:00',4.11),('11288','2013-10-10','12:50:00',3.53),('11288','2013-10-10','12:55:00',6.24),('11288','2013-10-10','13:00:00',5.52),('11288','2013-10-10','13:05:00',6.1),('11288','2013-10-10','13:10:00',5.91),('11288','2013-10-10','13:15:00',3.79),('11288','2013-10-10','13:20:00',2.15),('11288','2013-10-10','13:25:00',6.52),('11288','2013-10-10','13:30:00',5.35),('11288','2013-10-10','13:35:00',4.77),('11288','2013-10-10','13:40:00',3.88),('11288','2013-10-10','13:45:00',4.52),('11288','2013-10-10','13:50:00',5.34),('11288','2013-10-10','13:55:00',5.45),('11288','2013-10-10','14:00:00',5.29),('11288','2013-10-10','14:05:00',5.35),('11288','2013-10-10','14:10:00',5.34),('11288','2013-10-10','14:15:00',2.72),('11288','2013-10-10','14:20:00',4.85),('11288','2013-10-10','14:25:00',5.63),('11288','2013-10-10','14:30:00',5.5),('11288','2013-10-10','14:35:00',5.52),('11288','2013-10-10','14:40:00',5.07),('11288','2013-10-10','14:45:00',4.87),('11288','2013-10-10','14:50:00',4.64),('11288','2013-10-10','14:55:00',4.45),('11288','2013-10-10','15:00:00',4.61),('11288','2013-10-10','15:05:00',3.68),('11288','2013-10-10','15:10:00',4.31),('11288','2013-10-10','15:15:00',3.2),('11288','2013-10-10','15:20:00',4.14),('11288','2013-10-10','15:25:00',2.2),('11288','2013-10-10','15:30:00',3.02),('11288','2013-10-10','15:35:00',1.53),('11288','2013-10-10','15:40:00',3.52),('11288','2013-10-10','15:45:00',2.17),('11288','2013-10-10','15:50:00',2.44),('11288','2013-10-10','15:55:00',3.41),('11288','2013-10-10','16:00:00',2.24),('11288','2013-10-10','16:05:00',1.44),('11288','2013-10-10','16:10:00',1.56),('11288','2013-10-10','16:15:00',2.18),('11288','2013-10-10','16:20:00',1.15),('11288','2013-10-10','16:25:00',2.44),('11288','2013-10-10','16:40:00',1.21),('11288','2013-10-10','16:45:00',1.53),('11288','2013-10-10','16:50:00',1.74),('11288','2013-10-10','16:55:00',1.59),('11288','2013-10-10','17:00:00',1.19),('11288','2013-10-10','17:15:00',1.32),('11288','2013-10-10','17:20:00',1.39),('11288','2013-10-09','08:30:00',1.03),('11288','2013-10-09','08:35:00',1.1),('11288','2013-10-09','08:40:00',1.2),('11288','2013-10-09','08:45:00',1.39),('11288','2013-10-09','08:50:00',1.48),('11288','2013-10-09','08:55:00',1.57),('11288','2013-10-09','09:00:00',1.69),('11288','2013-10-09','09:05:00',1.92),('11288','2013-10-09','09:10:00',2.07),('11288','2013-10-09','09:15:00',1.93),('11288','2013-10-09','09:20:00',2.14),('11288','2013-10-09','09:25:00',2.47),('11288','2013-10-09','09:30:00',2.65),('11288','2013-10-09','09:35:00',2.79),('11288','2013-10-09','09:40:00',3.01),('11288','2013-10-09','09:45:00',3.15),('11288','2013-10-09','09:50:00',3.25),('11288','2013-10-09','09:55:00',3.38),('11288','2013-10-09','10:00:00',3.7),('11288','2013-10-09','10:05:00',3.89),('11288','2013-10-09','10:10:00',3.1),('11288','2013-10-09','10:15:00',2.01),('11288','2013-10-09','10:20:00',1.48),('11288','2013-10-09','10:25:00',1.69),('11288','2013-10-09','10:30:00',1.87),('11288','2013-10-09','10:35:00',2.12),('11288','2013-10-09','10:40:00',2.41),('11288','2013-10-09','10:45:00',3.73),('11288','2013-10-09','10:50:00',5.08),('11288','2013-10-09','10:55:00',3.81),('11288','2013-10-09','11:00:00',4.47),('11288','2013-10-09','11:05:00',5.99),('11288','2013-10-09','11:10:00',5.99),('11288','2013-10-09','11:15:00',5.24),('11288','2013-10-09','11:20:00',3.48),('11288','2013-10-09','11:25:00',5.06),('11288','2013-10-09','11:30:00',6.07),('11288','2013-10-09','11:35:00',6.38),('11288','2013-10-09','11:40:00',5.51),('11288','2013-10-09','11:45:00',5.39),('11288','2013-10-09','11:50:00',4.77),('11288','2013-10-09','11:55:00',5.07),('11288','2013-10-09','12:00:00',2.36),('11288','2013-10-09','12:05:00',3.94),('11288','2013-10-09','12:10:00',5.05),('11288','2013-10-09','12:15:00',7.39),('11288','2013-10-09','12:20:00',5.84),('11288','2013-10-09','12:25:00',3.34),('11288','2013-10-09','12:30:00',4.14),('11288','2013-10-09','12:35:00',4.31),('11288','2013-10-09','12:40:00',2.11),('11288','2013-10-09','12:45:00',1.39),('11288','2013-10-09','12:50:00',1.39),('11288','2013-10-09','12:55:00',2.07),('11288','2013-10-09','13:00:00',1.62),('11288','2013-10-09','13:05:00',1.31),('11288','2013-10-09','13:10:00',2.11),('11288','2013-10-09','13:15:00',2.5),('11288','2013-10-09','13:20:00',3.79),('11288','2013-10-09','13:25:00',4.34),('11288','2013-10-09','13:30:00',4.25),('11288','2013-10-09','13:35:00',5.61),('11288','2013-10-09','13:40:00',4.14),('11288','2013-10-09','13:45:00',2.6),('11288','2013-10-09','13:50:00',4.85),('11288','2013-10-09','13:55:00',6.36),('11288','2013-10-09','14:00:00',2.84),('11288','2013-10-09','14:05:00',3.71),('11288','2013-10-09','14:10:00',1.33),('11288','2013-10-09','14:15:00',1.31),('11288','2013-10-09','14:25:00',1.06),('11288','2013-10-09','14:30:00',1.07),('11288','2013-10-09','14:45:00',1.14),('11288','2013-10-09','14:50:00',1.66),('11288','2013-10-09','14:55:00',2.07),('11288','2013-10-09','15:00:00',2.85),('11288','2013-10-09','15:05:00',5.23),('11288','2013-10-09','15:10:00',4.75),('11288','2013-10-09','15:15:00',4.36),('11288','2013-10-09','15:20:00',4.03),('11288','2013-10-09','15:25:00',3.72),('11288','2013-10-09','15:30:00',3.46),('11288','2013-10-09','15:35:00',4.69),('11288','2013-10-09','15:40:00',2.88),('11288','2013-10-09','15:45:00',2.1),('11288','2013-10-09','15:50:00',1.15),('11288','2013-10-09','16:05:00',1.07),('11288','2013-10-09','16:10:00',1.63),('11288','2013-10-09','16:15:00',1.82),('11288','2013-10-09','16:20:00',2.38),('11288','2013-10-09','16:25:00',2.2),('11288','2013-10-09','16:30:00',2.12),('11288','2013-10-09','16:35:00',2.14),('11288','2013-10-09','16:40:00',1.72),('11288','2013-10-09','17:25:00',1.37),('11288','2013-10-09','17:30:00',1.53),('11288','2013-10-09','17:35:00',1.59),('11288','2013-10-09','17:40:00',1.03),('11288','2014-04-15','08:00:00',1.3),('11288','2014-04-15','08:05:00',1.03),('11288','2014-04-15','08:50:00',1.05),('11288','2014-04-15','08:55:00',1.51),('11288','2014-04-15','09:00:00',2.85),('11288','2014-04-15','09:05:00',2.21),('11288','2014-04-15','09:10:00',3.1),('11288','2014-04-15','09:15:00',3.54),('11288','2014-04-15','09:20:00',4.07),('11288','2014-04-15','09:25:00',4.15),('11288','2014-04-15','09:30:00',2.4),('11288','2014-04-15','09:35:00',1.44),('11288','2014-04-15','09:40:00',1.27),('11288','2014-04-15','09:45:00',2.1),('11288','2014-04-15','09:50:00',2.75),('11288','2014-04-15','10:00:00',1.12),('11288','2014-04-15','10:05:00',3.75),('11288','2014-04-15','10:10:00',4.21),('11288','2014-04-15','10:15:00',2.95),('11288','2014-04-15','10:20:00',3.22),('11288','2014-04-15','10:25:00',4.28),('11288','2014-04-15','10:30:00',6),('11288','2014-04-15','10:35:00',3.46),('11288','2014-04-15','10:40:00',4.26),('11288','2014-04-15','10:45:00',4.01),('11288','2014-04-15','10:50:00',4),('11288','2014-04-15','10:55:00',2.51),('11288','2014-04-15','11:00:00',4.07),('11288','2014-04-15','11:05:00',3.38),('11288','2014-04-15','11:10:00',2.96),('11288','2014-04-15','11:15:00',2.64),('11288','2014-04-15','11:20:00',2.06),('11288','2014-04-15','11:25:00',2.27),('11288','2014-04-15','11:30:00',2.14),('11288','2014-04-15','11:35:00',1.64),('11288','2014-04-15','11:40:00',1.2),('11288','2014-04-15','11:45:00',2.15),('11288','2014-04-15','11:50:00',2.44),('11288','2014-04-15','11:55:00',1.77),('11288','2014-04-15','12:00:00',1.15),('11288','2014-04-15','12:05:00',1.5),('11288','2014-04-15','12:10:00',1.72),('11288','2014-04-15','12:15:00',2.87),('11288','2014-04-15','12:20:00',2.58),('11288','2014-04-15','12:25:00',1.54),('11288','2014-04-15','12:30:00',1.01),('11288','2014-04-15','12:35:00',1.33),('11288','2014-04-15','13:00:00',1.07),('11288','2014-04-15','13:05:00',2.03),('11288','2014-04-15','13:10:00',2.44),('11288','2014-04-15','13:15:00',4.48),('11288','2014-04-15','13:20:00',4.74),('11288','2014-04-15','13:25:00',4.02),('11288','2014-04-15','13:30:00',4.07),('11288','2014-04-15','13:35:00',5.21),('11288','2014-04-15','13:40:00',2.97),('11288','2014-04-15','13:45:00',1.19),('11288','2014-04-15','13:50:00',1.45),('11288','2014-04-15','13:55:00',1.56),('11288','2014-04-15','14:00:00',5.71),('11288','2014-04-15','14:05:00',2.64),('11288','2014-04-15','14:10:00',5.67),('11288','2014-04-15','14:15:00',4.4),('11288','2014-04-15','14:20:00',6.06),('11288','2014-04-15','14:25:00',5.84),('11288','2014-04-15','14:30:00',3.25),('11288','2014-04-15','14:35:00',2.53),('11288','2014-04-15','14:40:00',4.73),('11288','2014-04-15','14:45:00',4.23),('11288','2014-04-15','14:50:00',3.04),('11288','2014-04-15','14:55:00',2.05),('11288','2014-04-15','15:00:00',1.47),('11288','2014-04-15','15:05:00',1.64),('11288','2014-04-15','15:10:00',1.99),('11288','2014-04-15','15:15:00',2.95),('11288','2014-04-15','15:20:00',3.16),('11288','2014-04-15','15:25:00',3.38),('11288','2014-04-15','15:30:00',2.78),('11288','2014-04-15','15:35:00',2.59),('11288','2014-04-15','15:40:00',2.62),('11288','2014-04-15','15:45:00',2.43),('11288','2014-04-15','15:50:00',2.43),('11288','2014-04-15','15:55:00',2.71),('11288','2014-04-15','16:00:00',2.98),('11288','2014-04-15','16:05:00',2.55),('11288','2014-04-15','16:10:00',1.59),('11288','2014-04-15','16:15:00',1.21),('11288','2013-10-08','08:10:00',1.21),('11288','2013-10-08','08:15:00',1.58),('11288','2013-10-08','08:20:00',1.51),('11288','2013-10-08','08:25:00',1.27),('11288','2013-10-08','08:30:00',1.12),('11288','2013-10-08','09:55:00',1.13),('11288','2013-10-08','10:00:00',1.6),('11288','2013-10-08','10:05:00',1.73),('11288','2013-10-08','10:10:00',1.66),('11288','2013-10-08','10:15:00',1.53),('11288','2013-10-08','10:20:00',1.01),('11288','2013-10-08','10:55:00',1.96),('11288','2013-10-08','11:00:00',2.62),('11288','2013-10-08','11:05:00',2.02),('11288','2013-10-08','11:10:00',2.67),('11288','2013-10-08','11:15:00',4.61),('11288','2013-10-08','11:20:00',5.29),('11288','2013-10-08','11:25:00',3.25),('11288','2013-10-08','11:30:00',3.81),('11288','2013-10-08','11:35:00',3.53),('11288','2013-10-08','11:40:00',2.56),('11288','2013-10-08','11:45:00',2.25),('11288','2013-10-08','11:50:00',1.47),('11288','2013-10-08','11:55:00',1.13),('11288','2013-10-08','12:05:00',1.15),('11288','2013-10-08','12:10:00',1.43),('11288','2013-10-08','12:15:00',1.66),('11288','2013-10-08','12:20:00',1.92),('11288','2013-10-08','12:25:00',2.7),('11288','2013-10-08','12:30:00',3.47),('11288','2013-10-08','12:35:00',3.94),('11288','2013-10-08','12:40:00',6.63),('11288','2013-10-08','12:45:00',5.71),('11288','2013-10-08','12:50:00',5.52),('11288','2013-10-08','12:55:00',5.97),('11288','2013-10-08','13:00:00',5.31),('11288','2013-10-08','13:05:00',3.91),('11288','2013-10-08','13:10:00',2.73),('11288','2013-10-08','13:15:00',4.48),('11288','2013-10-08','13:20:00',2.46),('11288','2013-10-08','13:25:00',5.21),('11288','2013-10-08','13:30:00',3.34),('11288','2013-10-08','13:35:00',2.27),('11288','2013-10-08','13:40:00',1.92),('11288','2013-10-08','13:45:00',1.62),('11288','2013-10-08','13:50:00',1.35),('11288','2013-10-08','13:55:00',1.45),('11288','2013-10-08','14:00:00',1.33),('11288','2013-10-08','14:05:00',2.45),('11288','2013-10-08','14:10:00',3.06),('11288','2013-10-08','14:15:00',3.89),('11288','2013-10-08','14:20:00',4.14),('11288','2013-10-08','14:25:00',4.64),('11288','2013-10-08','14:30:00',3.79),('11288','2013-10-08','14:35:00',2.18),('11288','2013-10-08','14:40:00',2.48),('11288','2013-10-08','14:45:00',4.84),('11288','2013-10-08','14:50:00',5),('11288','2013-10-08','14:55:00',4.66),('11288','2013-10-08','15:00:00',4.52),('11288','2013-10-08','15:05:00',4.56),('11288','2013-10-08','15:10:00',4.47),('11288','2013-10-08','15:15:00',3.67),('11288','2013-10-08','15:20:00',4.53),('11288','2013-10-08','15:25:00',4.99),('11288','2013-10-08','15:30:00',4.93),('11288','2013-10-08','15:35:00',4.25),('11288','2013-10-08','15:40:00',2.14),('11288','2013-10-08','15:45:00',1.72),('11288','2013-10-08','15:50:00',2.79),('11288','2013-10-08','15:55:00',1.91),('11288','2013-10-08','16:00:00',1.59),('11288','2013-10-08','16:05:00',1.37),('11288','2013-10-08','16:30:00',1.39),('11288','2013-10-08','16:35:00',1.11),('11288','2013-10-08','16:40:00',1.1),('11288','2013-10-08','16:45:00',1.19),('11288','2013-10-08','16:50:00',1.03),('11288','2013-10-07','08:30:00',1.1),('11288','2013-10-07','08:35:00',1.11),('11288','2013-10-07','08:40:00',1.5),('11288','2013-10-07','08:45:00',1.05),('11288','2013-10-07','08:50:00',1.02),('11288','2013-10-07','08:55:00',1.24),('11288','2013-10-07','09:00:00',1.76),('11288','2013-10-07','09:05:00',1.51),('11288','2013-10-07','09:10:00',1.78),('11288','2013-10-07','09:15:00',2.25),('11288','2013-10-07','09:20:00',2.1),('11288','2013-10-07','09:25:00',2.49),('11288','2013-10-07','09:30:00',2.68),('11288','2013-10-07','09:35:00',2.73),('11288','2013-10-07','09:40:00',2.91),('11288','2013-10-07','09:45:00',3.04),('11288','2013-10-07','09:50:00',3.19),('11288','2013-10-07','09:55:00',3.25),('11288','2013-10-07','10:00:00',3.39),('11288','2013-10-07','10:05:00',3.42),('11288','2013-10-07','10:10:00',3.45),('11288','2013-10-07','10:15:00',3.67),('11288','2013-10-07','10:20:00',3.8),('11288','2013-10-07','10:25:00',3.8),('11288','2013-10-07','10:30:00',4.09),('11288','2013-10-07','10:35:00',4.46),('11288','2013-10-07','10:40:00',4.28),('11288','2013-10-07','10:45:00',4.32),('11288','2013-10-07','10:50:00',4.43),('11288','2013-10-07','10:55:00',3.9),('11288','2013-10-07','11:00:00',3.95),('11288','2013-10-07','11:05:00',4.72),('11288','2013-10-07','11:10:00',4.28),('11288','2013-10-07','11:15:00',4.51),('11288','2013-10-07','11:20:00',4.55),('11288','2013-10-07','11:25:00',4.79),('11288','2013-10-07','11:30:00',4.82),('11288','2013-10-07','11:35:00',4.9),('11288','2013-10-07','11:40:00',4.96),('11288','2013-10-07','11:45:00',5.03),('11288','2013-10-07','11:50:00',5.08),('11288','2013-10-07','11:55:00',5.13),('11288','2013-10-07','12:00:00',5.18),('11288','2013-10-07','12:05:00',5.41),('11288','2013-10-07','12:10:00',5.31),('11288','2013-10-07','12:15:00',1.54),('11288','2013-10-07','12:20:00',4.06),('11288','2013-10-07','12:25:00',5.99),('11288','2013-10-07','12:30:00',6.11),('11288','2013-10-07','12:35:00',5.74),('11288','2013-10-07','12:40:00',3.66),('11288','2013-10-07','12:45:00',5.79),('11288','2013-10-07','12:50:00',3.97),('11288','2013-10-07','12:55:00',5.94),('11288','2013-10-07','13:00:00',5.81),('11288','2013-10-07','13:05:00',5.64),('11288','2013-10-07','13:10:00',5.81),('11288','2013-10-07','13:15:00',5.1),('11288','2013-10-07','13:20:00',4.94),('11288','2013-10-07','13:25:00',2.67),('11288','2013-10-07','13:30:00',2.23),('11288','2013-10-07','13:35:00',3.82),('11288','2013-10-07','13:40:00',5.14),('11288','2013-10-07','13:45:00',2.18),('11288','2013-10-07','13:50:00',5.44),('11288','2013-10-07','13:55:00',5.73),('11288','2013-10-07','14:00:00',3.27),('11288','2013-10-07','14:05:00',2.52),('11288','2013-10-07','14:10:00',2.83),('11288','2013-10-07','14:15:00',1.56),('11288','2013-10-07','14:20:00',1.82),('11288','2013-10-07','14:25:00',1.44),('11288','2013-10-07','14:30:00',5.29),('11288','2013-10-07','14:35:00',5.89),('11288','2013-10-07','14:40:00',3.46),('11288','2013-10-07','14:45:00',5),('11288','2013-10-07','14:50:00',5.46),('11288','2013-10-07','14:55:00',5.32),('11288','2013-10-07','15:00:00',3.9),('11288','2013-10-07','15:05:00',4.81),('11288','2013-10-07','15:10:00',2.46),('11288','2013-10-07','15:15:00',4.72),('11288','2013-10-07','15:20:00',1.57),('11288','2013-10-07','15:25:00',4.04),('11288','2013-10-07','15:30:00',2.44),('11288','2013-10-07','15:35:00',2.19),('11288','2013-10-07','15:40:00',2.57),('11288','2013-10-07','15:45:00',4.56),('11288','2013-10-07','15:50:00',2.96),('11288','2013-10-07','15:55:00',1.21),('11288','2013-10-07','16:00:00',1.79),('11288','2013-10-07','16:05:00',3.22),('11288','2013-10-07','16:10:00',2.99),('11288','2013-10-07','16:15:00',3.04),('11288','2013-10-07','16:20:00',2.94),('11288','2013-10-07','16:25:00',2.77),('11288','2013-10-07','16:30:00',1.87),('11288','2013-10-07','16:35:00',2.32),('11288','2013-10-07','16:40:00',2.12),('11288','2013-10-07','16:45:00',2.25),('11288','2013-10-07','16:50:00',2.07),('11288','2013-10-07','16:55:00',1.76),('11288','2013-10-07','17:00:00',1.52),('11288','2013-10-07','17:05:00',1.47),('11288','2013-10-07','17:10:00',1.34),('11288','2013-10-07','17:15:00',1.13),('11288','2013-10-07','17:20:00',1.08),('11288','2013-10-06','09:00:00',1.14),('11288','2013-10-06','09:05:00',1.6),('11288','2013-10-06','09:10:00',1.32),('11288','2013-10-06','09:25:00',1.14),('11288','2013-10-06','09:30:00',1.63),('11288','2013-10-06','09:35:00',1.92),('11288','2013-10-06','09:40:00',2.03),('11288','2013-10-06','09:45:00',1.86),('11288','2013-10-06','09:50:00',3.11),('11288','2013-10-06','09:55:00',3.68),('11288','2013-10-06','10:00:00',4.17),('11288','2013-10-06','10:05:00',4.25),('11288','2013-10-06','10:10:00',4.23),('11288','2013-10-06','10:15:00',3.97),('11288','2013-10-06','10:20:00',4.04),('11288','2013-10-06','10:25:00',4.52),('11288','2013-10-06','10:30:00',4.47),('11288','2013-10-06','10:35:00',4.39),('11288','2013-10-06','10:40:00',3.63),('11288','2013-10-06','10:45:00',3.04),('11288','2013-10-06','10:50:00',3.59),('11288','2013-10-06','10:55:00',3.59),('11288','2013-10-06','11:00:00',3.89),('11288','2013-10-06','11:05:00',4.25),('11288','2013-10-06','11:10:00',4.35),('11288','2013-10-06','11:15:00',4.18),('11288','2013-10-06','11:20:00',4.44),('11288','2013-10-06','11:25:00',4.43),('11288','2013-10-06','11:30:00',4.36),('11288','2013-10-06','11:35:00',4.09),('11288','2013-10-06','11:40:00',2.97),('11288','2013-10-06','11:45:00',2.9),('11288','2013-10-06','11:50:00',2.51),('11288','2013-10-06','11:55:00',4),('11288','2013-10-06','12:00:00',4.05),('11288','2013-10-06','12:05:00',4.32),('11288','2013-10-06','12:10:00',5.24),('11288','2013-10-06','12:15:00',4.8),('11288','2013-10-06','12:20:00',4.09),('11288','2013-10-06','12:25:00',3.97),('11288','2013-10-06','12:30:00',3.33),('11288','2013-10-06','12:35:00',4.17),('11288','2013-10-06','12:40:00',4),('11288','2013-10-06','12:45:00',4.05),('11288','2013-10-06','12:50:00',4.42),('11288','2013-10-06','12:55:00',4.88),('11288','2013-10-06','13:00:00',4.6),('11288','2013-10-06','13:05:00',4.95),('11288','2013-10-06','13:10:00',4.79),('11288','2013-10-06','13:15:00',5.62),('11288','2013-10-06','13:20:00',2.39),('11288','2013-10-06','13:25:00',1.78),('11288','2013-10-06','13:30:00',1.32),('11288','2013-10-06','13:40:00',1.54),('11288','2013-10-06','13:45:00',3.16),('11288','2013-10-06','13:50:00',5.97),('11288','2013-10-06','13:55:00',5.5),('11288','2013-10-06','14:00:00',4.63),('11288','2013-10-06','14:05:00',3.26),('11288','2013-10-06','14:10:00',2.54),('11288','2013-10-06','14:15:00',2.23),('11288','2013-10-06','14:20:00',2.44),('11288','2013-10-06','14:25:00',2.6),('11288','2013-10-06','14:30:00',3.82),('11288','2013-10-06','14:35:00',3.67),('11288','2013-10-06','14:40:00',3.33),('11288','2013-10-06','14:45:00',2.79),('11288','2013-10-06','14:50:00',3.09),('11288','2013-10-06','14:55:00',3.98),('11288','2013-10-06','15:00:00',3.07),('11288','2013-10-06','15:05:00',2.36),('11288','2013-10-06','15:10:00',1.97),('11288','2013-10-06','15:15:00',1.96),('11288','2013-10-06','15:20:00',1.69),('11288','2013-10-06','15:25:00',1.35),('11288','2013-10-06','15:30:00',1.28),('11288','2013-10-06','15:35:00',1.33),('11288','2013-10-06','15:40:00',1.46),('11288','2013-10-06','15:45:00',1.55),('11288','2013-10-06','15:50:00',1.64),('11288','2013-10-06','15:55:00',1.99),('11288','2013-10-06','16:00:00',1.93),('11288','2013-10-06','16:05:00',1.3),('11288','2013-10-06','16:10:00',1.01),('11288','2013-10-06','17:05:00',1.02),('11288','2013-10-06','17:10:00',1.29),('11288','2013-10-06','17:15:00',1.37),('11288','2013-10-06','17:20:00',1.27),('11288','2013-10-06','17:25:00',1.04),('11288','2013-10-05','14:40:00',1.02),('11288','2013-10-05','14:45:00',1.06),('11288','2013-10-05','14:50:00',1.12),('11288','2013-10-05','14:55:00',1.06),('11288','2013-10-05','15:00:00',1.05),('11288','2013-10-05','15:05:00',1.09),('11288','2013-10-05','15:10:00',1.04),('11288','2013-10-05','15:15:00',1.02),('11288','2013-10-05','15:20:00',1.04),('11288','2013-10-05','15:25:00',1.07),('11288','2013-10-05','15:30:00',1.07),('11288','2013-10-05','15:35:00',1.18),('11288','2013-10-05','15:40:00',1.36),('11288','2013-10-05','15:45:00',1.4),('11288','2013-10-05','15:50:00',1.46),('11288','2013-10-05','15:55:00',1.59),('11288','2013-10-05','16:00:00',1.79),('11288','2013-10-05','16:05:00',2.13),('11288','2013-10-05','16:10:00',2.05),('11288','2013-10-05','16:15:00',1.89),('11288','2013-10-05','16:20:00',1.88),('11288','2013-10-05','16:25:00',1.81),('11288','2013-10-05','16:30:00',1.6),('11288','2013-10-05','16:35:00',1.5),('11288','2013-10-05','16:40:00',1.61),('11288','2013-10-05','16:45:00',1.49),('11288','2013-10-05','16:50:00',1.46),('11288','2013-10-05','16:55:00',1.31),('11288','2013-10-05','17:00:00',1.35),('11288','2013-10-05','17:05:00',1.27),('11288','2013-10-05','17:10:00',1.19),('11288','2013-10-05','17:15:00',1.18),('11288','2013-10-04','08:45:00',1.2),('11288','2013-10-04','08:50:00',1.08),('11288','2013-10-04','08:55:00',1.2),('11288','2013-10-04','09:00:00',1.04),('11288','2013-10-04','09:05:00',1.04),('11288','2013-10-04','09:10:00',1.17),('11288','2013-10-04','09:15:00',1.1),('11288','2013-10-04','09:20:00',1.27),('11288','2013-10-04','09:25:00',1.75),('11288','2013-10-04','09:30:00',1.85),('11288','2013-10-04','09:35:00',1.98),('11288','2013-10-04','09:40:00',1.93),('11288','2013-10-04','09:45:00',2),('11288','2013-10-04','09:50:00',2.42),('11288','2013-10-04','09:55:00',3.51),('11288','2013-10-04','10:00:00',3.22),('11288','2013-10-04','10:05:00',2.43),('11288','2013-10-04','10:10:00',2.52),('11288','2013-10-04','10:15:00',2.75),('11288','2013-10-04','10:20:00',2.57),('11288','2013-10-04','10:25:00',2.95),('11288','2013-10-04','10:30:00',3.51),('11288','2013-10-04','10:35:00',3.66),('11288','2013-10-04','10:40:00',3.83),('11288','2013-10-04','10:45:00',4.08),('11288','2013-10-04','10:50:00',3.18),('11288','2013-10-04','10:55:00',3.71),('11288','2013-10-04','11:00:00',3.31),('11288','2013-10-04','11:05:00',2.8),('11288','2013-10-04','11:10:00',2.69),('11288','2013-10-04','11:15:00',4.24),('11288','2013-10-04','11:20:00',4.28),('11288','2013-10-04','11:25:00',4.56),('11288','2013-10-04','11:30:00',5.56),('11288','2013-10-04','11:35:00',5.12),('11288','2013-10-04','11:40:00',5.33),('11288','2013-10-04','11:45:00',5.3),('11288','2013-10-04','11:50:00',5.33),('11288','2013-10-04','11:55:00',5.38),('11288','2013-10-04','12:00:00',5.42),('11288','2013-10-04','12:05:00',5.52),('11288','2013-10-04','12:10:00',5.54),('11288','2013-10-04','12:15:00',5.27),('11288','2013-10-04','12:20:00',5.18),('11288','2013-10-04','12:25:00',5.65),('11288','2013-10-04','12:30:00',5.82),('11288','2013-10-04','12:35:00',5.51),('11288','2013-10-04','12:40:00',5.44),('11288','2013-10-04','12:45:00',5.51),('11288','2013-10-04','12:50:00',5.39),('11288','2013-10-04','12:55:00',5.36),('11288','2013-10-04','13:00:00',5.39),('11288','2013-10-04','13:05:00',5.49),('11288','2013-10-04','13:10:00',5.55),('11288','2013-10-04','13:15:00',5.78),('11288','2013-10-04','13:20:00',5.6),('11288','2013-10-04','13:25:00',5.23),('11288','2013-10-04','13:30:00',5.64),('11288','2013-10-04','13:35:00',5.65),('11288','2013-10-04','13:40:00',5.3),('11288','2013-10-04','13:45:00',5.26),('11288','2013-10-04','13:50:00',5.21),('11288','2013-10-04','13:55:00',5.1),('11288','2013-10-04','14:00:00',5.09),('11288','2013-10-04','14:05:00',5.09),('11288','2013-10-04','14:10:00',4.6),('11288','2013-10-04','14:15:00',3.8),('11288','2013-10-04','14:20:00',4.77),('11288','2013-10-04','14:25:00',4.83),('11288','2013-10-04','14:30:00',4.23),('11288','2013-10-04','14:35:00',2.98),('11288','2013-10-04','14:40:00',2.56),('11288','2013-10-04','14:45:00',3.14),('11288','2013-10-04','14:50:00',3.98),('11288','2013-10-04','14:55:00',3.84),('11288','2013-10-04','15:00:00',3.29),('11288','2013-10-04','15:05:00',3.68),('11288','2013-10-04','15:10:00',3.05),('11288','2013-10-04','15:15:00',2.53),('11288','2013-10-04','15:20:00',2.21),('11288','2013-10-04','15:25:00',4.04),('11288','2013-10-04','15:30:00',3.23),('11288','2013-10-04','15:35:00',1.93),('11288','2013-10-04','15:40:00',1.48),('11288','2013-10-04','15:45:00',1.29),('11288','2013-10-04','15:50:00',1.26),('11288','2013-10-04','15:55:00',1.48),('11288','2013-10-04','16:00:00',1.83),('11288','2013-10-04','16:05:00',1.96),('11288','2013-10-04','16:10:00',1.77),('11288','2013-10-04','16:15:00',1.57),('11288','2013-10-04','16:20:00',1.35),('11288','2013-10-04','16:25:00',1.15),('11288','2013-10-04','16:30:00',1.08),('11288','2013-10-04','16:35:00',1.1),('11288','2013-10-04','16:40:00',1.05),('11288','2013-10-03','08:30:00',1.04),('11288','2013-10-03','08:35:00',1.19),('11288','2013-10-03','08:40:00',1.33),('11288','2013-10-03','08:45:00',1.5),('11288','2013-10-03','08:50:00',1.6),('11288','2013-10-03','08:55:00',1.76),('11288','2013-10-03','09:00:00',1.99),('11288','2013-10-03','09:05:00',2.13),('11288','2013-10-03','09:10:00',2.31),('11288','2013-10-03','09:15:00',2.47),('11288','2013-10-03','09:20:00',2.65),('11288','2013-10-03','09:25:00',2.65),('11288','2013-10-03','09:30:00',2.65),('11288','2013-10-03','09:35:00',3.09),('11288','2013-10-03','09:40:00',3.25),('11288','2013-10-03','09:45:00',3.4),('11288','2013-10-03','09:50:00',3.53),('11288','2013-10-03','09:55:00',3.65),('11288','2013-10-03','10:00:00',3.77),('11288','2013-10-03','10:05:00',3.93),('11288','2013-10-03','10:10:00',4),('11288','2013-10-03','10:15:00',4.1),('11288','2013-10-03','10:20:00',4.28),('11288','2013-10-03','10:25:00',4.43),('11288','2013-10-03','10:30:00',4.53),('11288','2013-10-03','10:35:00',4.65),('11288','2013-10-03','10:40:00',4.74),('11288','2013-10-03','10:45:00',4.83),('11288','2013-10-03','10:50:00',4.89),('11288','2013-10-03','10:55:00',4.97),('11288','2013-10-03','11:00:00',5.02),('11288','2013-10-03','11:05:00',5.1),('11288','2013-10-03','11:10:00',5.17),('11288','2013-10-03','11:15:00',5.22),('11288','2013-10-03','11:20:00',5.28),('11288','2013-10-03','11:25:00',5.34),('11288','2013-10-03','11:30:00',5.36),('11288','2013-10-03','11:35:00',5.44),('11288','2013-10-03','11:40:00',5.54),('11288','2013-10-03','11:45:00',5.57),('11288','2013-10-03','11:50:00',5.62),('11288','2013-10-03','11:55:00',5.71),('11288','2013-10-03','12:00:00',5.74),('11288','2013-10-03','12:05:00',5.78),('11288','2013-10-03','12:10:00',5.83),('11288','2013-10-03','12:15:00',5.82),('11288','2013-10-03','12:20:00',5.83),('11288','2013-10-03','12:25:00',5.86),('11288','2013-10-03','12:30:00',5.87),('11288','2013-10-03','12:35:00',5.89),('11288','2013-10-03','12:40:00',5.88),('11288','2013-10-03','12:45:00',5.89),('11288','2013-10-03','12:50:00',5.9),('11288','2013-10-03','12:55:00',5.89),('11288','2013-10-03','13:00:00',5.86),('11288','2013-10-03','13:05:00',5.75),('11288','2013-10-03','13:10:00',5.81),('11288','2013-10-03','13:15:00',5.83),('11288','2013-10-03','13:20:00',5.83),('11288','2013-10-03','13:25:00',5.79),('11288','2013-10-03','13:30:00',5.78),('11288','2013-10-03','13:35:00',5.77),('11288','2013-10-03','13:40:00',5.74),('11288','2013-10-03','13:45:00',5.66),('11288','2013-10-03','13:50:00',5.61),('11288','2013-10-03','13:55:00',5.61),('11288','2013-10-03','14:00:00',5.64),('11288','2013-10-03','14:05:00',5.59),('11288','2013-10-03','14:10:00',5.54),('11288','2013-10-03','14:15:00',5.44),('11288','2013-10-03','14:20:00',5.31),('11288','2013-10-03','14:25:00',5.29),('11288','2013-10-03','14:30:00',5.27),('11288','2013-10-03','14:35:00',5.16),('11288','2013-10-03','14:40:00',5.09),('11288','2013-10-03','14:45:00',5.05),('11288','2013-10-03','14:50:00',4.99),('11288','2013-10-03','14:55:00',4.88),('11288','2013-10-03','15:00:00',4.76),('11288','2013-10-03','15:05:00',4.67),('11288','2013-10-03','15:10:00',4.59),('11288','2013-10-03','15:15:00',4.54),('11288','2013-10-03','15:20:00',4.44),('11288','2013-10-03','15:25:00',4.27),('11288','2013-10-03','15:30:00',4.18),('11288','2013-10-03','15:35:00',4.11),('11288','2013-10-03','15:40:00',3.98),('11288','2013-10-03','15:45:00',3.83),('11288','2013-10-03','15:50:00',3.72),('11288','2013-10-03','15:55:00',3.59),('11288','2013-10-03','16:00:00',3.46),('11288','2013-10-03','16:05:00',3.32),('11288','2013-10-03','16:10:00',3.22),('11288','2013-10-03','16:15:00',3.06),('11288','2013-10-03','16:20:00',2.92),('11288','2013-10-03','16:25:00',2.79),('11288','2013-10-03','16:30:00',2.68),('11288','2013-10-03','16:35:00',2.53),('11288','2013-10-03','16:40:00',2.4),('11288','2013-10-03','16:45:00',2.25),('11288','2013-10-03','16:50:00',2.04),('11288','2013-10-03','16:55:00',1.97),('11288','2013-10-03','17:00:00',1.81),('11288','2013-10-03','17:05:00',1.67),('11288','2013-10-03','17:10:00',1.53),('11288','2013-10-03','17:15:00',1.38),('11288','2013-10-03','17:20:00',1.28),('11288','2013-10-03','17:25:00',1.14),('11288','2013-10-03','17:30:00',1.03),('11288','2013-10-02','08:20:00',1.18),('11288','2013-10-02','08:25:00',1.15),('11288','2013-10-02','08:30:00',1.16),('11288','2013-10-02','08:35:00',1.13),('11288','2013-10-02','08:40:00',1.24),('11288','2013-10-02','08:45:00',1.38),('11288','2013-10-02','08:50:00',1.57),('11288','2013-10-02','08:55:00',1.61),('11288','2013-10-02','09:00:00',1.89),('11288','2013-10-02','09:05:00',2.03),('11288','2013-10-02','09:10:00',2.18),('11288','2013-10-02','09:15:00',2.34),('11288','2013-10-02','09:20:00',2.5),('11288','2013-10-02','09:25:00',2.54),('11288','2013-10-02','09:30:00',2.64),('11288','2013-10-02','09:35:00',2.94),('11288','2013-10-02','09:40:00',3.1),('11288','2013-10-02','09:45:00',3.21),('11288','2013-10-02','09:50:00',3.34),('11288','2013-10-02','09:55:00',3.45),('11288','2013-10-02','10:00:00',3.54),('11288','2013-10-02','10:05:00',3.65),('11288','2013-10-02','10:10:00',3.72),('11288','2013-10-02','10:15:00',3.81),('11288','2013-10-02','10:20:00',3.98),('11288','2013-10-02','10:25:00',4.13),('11288','2013-10-02','10:30:00',4.25),('11288','2013-10-02','10:35:00',4.36),('11288','2013-10-02','10:40:00',4.45),('11288','2013-10-02','10:45:00',4.58),('11288','2013-10-02','10:50:00',4.67),('11288','2013-10-02','10:55:00',4.75),('11288','2013-10-02','11:00:00',4.81),('11288','2013-10-02','11:05:00',4.9),('11288','2013-10-02','11:10:00',4.96),('11288','2013-10-02','11:15:00',5.01),('11288','2013-10-02','11:20:00',5.06),('11288','2013-10-02','11:25:00',5.1),('11288','2013-10-02','11:30:00',5.13),('11288','2013-10-02','11:35:00',5.22),('11288','2013-10-02','11:40:00',5.27),('11288','2013-10-02','11:45:00',5.3),('11288','2013-10-02','11:50:00',5.35),('11288','2013-10-02','11:55:00',5.41),('11288','2013-10-02','12:00:00',5.47),('11288','2013-10-02','12:05:00',5.55),('11288','2013-10-02','12:10:00',5.6),('11288','2013-10-02','12:15:00',5.62),('11288','2013-10-02','12:20:00',5.65),('11288','2013-10-02','12:25:00',5.63),('11288','2013-10-02','12:30:00',5.62),('11288','2013-10-02','12:35:00',5.58),('11288','2013-10-02','12:40:00',5.66),('11288','2013-10-02','12:45:00',5.67),('11288','2013-10-02','12:50:00',5.66),('11288','2013-10-02','12:55:00',5.64),('11288','2013-10-02','13:00:00',5.65),('11288','2013-10-02','13:05:00',5.69),('11288','2013-10-02','13:10:00',5.67),('11288','2013-10-02','13:15:00',5.67),('11288','2013-10-02','13:20:00',5.66),('11288','2013-10-02','13:25:00',5.66),('11288','2013-10-02','13:30:00',5.63),('11288','2013-10-02','13:35:00',5.62),('11288','2013-10-02','13:40:00',5.59),('11288','2013-10-02','13:45:00',5.53),('11288','2013-10-02','13:50:00',5.43),('11288','2013-10-02','13:55:00',5.47),('11288','2013-10-02','14:00:00',5.44),('11288','2013-10-02','14:05:00',5.44),('11288','2013-10-02','14:10:00',5.39),('11288','2013-10-02','14:15:00',5.33),('11288','2013-10-02','14:20:00',5.26),('11288','2013-10-02','14:25:00',5.21),('11288','2013-10-02','14:30:00',5.15),('11288','2013-10-02','14:35:00',5.08),('11288','2013-10-02','14:40:00',4.99),('11288','2013-10-02','14:45:00',4.94),('11288','2013-10-02','14:50:00',4.85),('11288','2013-10-02','14:55:00',4.81),('11288','2013-10-02','15:00:00',4.69),('11288','2013-10-02','15:05:00',4.6),('11288','2013-10-02','15:10:00',4.52),('11288','2013-10-02','15:15:00',4.46),('11288','2013-10-02','15:20:00',4.34),('11288','2013-10-02','15:25:00',4.17),('11288','2013-10-02','15:30:00',4.08),('11288','2013-10-02','15:35:00',4),('11288','2013-10-02','15:40:00',3.88),('11288','2013-10-02','15:45:00',3.75),('11288','2013-10-02','15:50:00',3.66),('11288','2013-10-02','15:55:00',3.54),('11288','2013-10-02','16:00:00',3.42),('11288','2013-10-02','16:05:00',3.29),('11288','2013-10-02','16:10:00',3.17),('11288','2013-10-02','16:15:00',3.02),('11288','2013-10-02','16:20:00',2.88),('11288','2013-10-02','16:25:00',2.74),('11288','2013-10-02','16:30:00',2.63),('11288','2013-10-02','16:35:00',2.48),('11288','2013-10-02','16:40:00',2.37),('11288','2013-10-02','16:45:00',2.22),('11288','2013-10-02','16:50:00',2.03),('11288','2013-10-02','16:55:00',1.94),('11288','2013-10-02','17:00:00',1.79),('11288','2013-10-02','17:05:00',1.67),('11288','2013-10-02','17:10:00',1.5),('11288','2013-10-02','17:15:00',1.4),('11288','2013-10-02','17:20:00',1.27),('11288','2013-10-02','17:25:00',1.16),('11288','2013-10-02','17:30:00',1.03),('11288','2013-10-01','08:25:00',1.04),('11288','2013-10-01','08:30:00',1.07),('11288','2013-10-01','08:35:00',1.19),('11288','2013-10-01','08:40:00',1.32),('11288','2013-10-01','08:45:00',1.47),('11288','2013-10-01','08:50:00',1.67),('11288','2013-10-01','08:55:00',1.7),('11288','2013-10-01','09:00:00',1.89),('11288','2013-10-01','09:05:00',2.07),('11288','2013-10-01','09:10:00',2.22),('11288','2013-10-01','09:15:00',2.34),('11288','2013-10-01','09:20:00',2.52),('11288','2013-10-01','09:25:00',2.6),('11288','2013-10-01','09:30:00',2.61),('11288','2013-10-01','09:35:00',2.84),('11288','2013-10-01','09:40:00',3.09),('11288','2013-10-01','09:45:00',3.23),('11288','2013-10-01','09:50:00',3.3),('11288','2013-10-01','09:55:00',3.41),('11288','2013-10-01','10:00:00',3.47),('11288','2013-10-01','10:05:00',3.64),('11288','2013-10-01','10:10:00',3.75),('11288','2013-10-01','10:15:00',3.84),('11288','2013-10-01','10:20:00',4),('11288','2013-10-01','10:25:00',3.97),('11288','2013-10-01','10:30:00',4.27),('11288','2013-10-01','10:35:00',4.32),('11288','2013-10-01','10:40:00',4.36),('11288','2013-10-01','10:45:00',4.46),('11288','2013-10-01','10:50:00',4.55),('11288','2013-10-01','10:55:00',4.67),('11288','2013-10-01','11:00:00',4.86),('11288','2013-10-01','11:05:00',3.57),('11288','2013-10-01','11:10:00',4.49),('11288','2013-10-01','11:15:00',5.35),('11288','2013-10-01','11:20:00',2.52),('11288','2013-10-01','11:25:00',1.28),('11288','2013-10-01','11:30:00',3.18),('11288','2013-10-01','11:35:00',5.45),('11288','2013-10-01','11:40:00',5.48),('11288','2013-10-01','11:45:00',5.53),('11288','2013-10-01','11:50:00',3.16),('11288','2013-10-01','11:55:00',1.24),('11288','2013-10-01','12:00:00',2.68),('11288','2013-10-01','12:05:00',1.52),('11288','2013-10-01','12:10:00',5.23),('11288','2013-10-01','12:15:00',5.49),('11288','2013-10-01','12:20:00',5.98),('11288','2013-10-01','12:25:00',5.99),('11288','2013-10-01','12:30:00',5.84),('11288','2013-10-01','12:35:00',1.74),('11288','2013-10-01','12:40:00',2.24),('11288','2013-10-01','12:45:00',2.8),('11288','2013-10-01','12:50:00',1.97),('11288','2013-10-01','12:55:00',2.39),('11288','2013-10-01','13:00:00',6.19),('11288','2013-10-01','13:05:00',3.65),('11288','2013-10-01','13:10:00',1.73),('11288','2013-10-01','13:15:00',3.79),('11288','2013-10-01','13:20:00',6.27),('11288','2013-10-01','13:25:00',4.55),('11288','2013-10-01','13:30:00',5.7),('11288','2013-10-01','13:35:00',6.2),('11288','2013-10-01','13:40:00',5.95),('11288','2013-10-01','13:45:00',5.3),('11288','2013-10-01','13:50:00',5.21),('11288','2013-10-01','13:55:00',5.36),('11288','2013-10-01','14:00:00',5.26),('11288','2013-10-01','14:05:00',5.24),('11288','2013-10-01','14:10:00',5.11),('11288','2013-10-01','14:15:00',5.1),('11288','2013-10-01','14:20:00',5.12),('11288','2013-10-01','14:25:00',5),('11288','2013-10-01','14:30:00',5.01),('11288','2013-10-01','14:35:00',5),('11288','2013-10-01','14:40:00',4.92),('11288','2013-10-01','14:45:00',5.03),('11288','2013-10-01','14:50:00',5),('11288','2013-10-01','14:55:00',4.91),('11288','2013-10-01','15:00:00',4.69),('11288','2013-10-01','15:05:00',4.54),('11288','2013-10-01','15:10:00',4.46),('11288','2013-10-01','15:15:00',4.4),('11288','2013-10-01','15:20:00',4.3),('11288','2013-10-01','15:25:00',4.17),('11288','2013-10-01','15:30:00',4.07),('11288','2013-10-01','15:35:00',4.01),('11288','2013-10-01','15:40:00',3.9),('11288','2013-10-01','15:45:00',3.74),('11288','2013-10-01','15:50:00',3.63),('11288','2013-10-01','15:55:00',3.5),('11288','2013-10-01','16:00:00',3.38),('11288','2013-10-01','16:05:00',3.24),('11288','2013-10-01','16:10:00',3.16),('11288','2013-10-01','16:15:00',3.03),('11288','2013-10-01','16:20:00',2.9),('11288','2013-10-01','16:25:00',2.77),('11288','2013-10-01','16:30:00',2.65),('11288','2013-10-01','16:35:00',2.5),('11288','2013-10-01','16:40:00',2.35),('11288','2013-10-01','16:45:00',2.23),('11288','2013-10-01','16:50:00',2.09),('11288','2013-10-01','16:55:00',1.99),('11288','2013-10-01','17:00:00',1.83),('11288','2013-10-01','17:05:00',1.7),('11288','2013-10-01','17:10:00',1.52),('11288','2013-10-01','17:15:00',1.43),('11288','2013-10-01','17:20:00',1.29),('11288','2013-10-01','17:25:00',1.22),('11288','2013-10-01','17:30:00',1.07),('11288','2013-09-30','09:35:00',1.11),('11288','2013-09-30','09:40:00',1.23),('11288','2013-09-30','09:45:00',1.62),('11288','2013-09-30','09:50:00',2.01),('11288','2013-09-30','09:55:00',1.78),('11288','2013-09-30','10:00:00',1.71),('11288','2013-09-30','10:05:00',1.72),('11288','2013-09-30','10:10:00',1.88),('11288','2013-09-30','10:15:00',1.9),('11288','2013-09-30','10:20:00',1.93),('11288','2013-09-30','10:25:00',2.11),('11288','2013-09-30','10:30:00',2.34),('11288','2013-09-30','10:35:00',2.6),('11288','2013-09-30','10:40:00',3.43),('11288','2013-09-30','10:45:00',4.95),('11288','2013-09-30','10:50:00',4.94),('11288','2013-09-30','10:55:00',4.42),('11288','2013-09-30','11:00:00',3.98),('11288','2013-09-30','11:05:00',2.06),('11288','2013-09-30','11:10:00',3.58),('11288','2013-09-30','11:15:00',3.8),('11288','2013-09-30','11:20:00',4.28),('11288','2013-09-30','11:25:00',3.81),('11288','2013-09-30','11:30:00',3.38),('11288','2013-09-30','11:35:00',2.76),('11288','2013-09-30','11:40:00',5.05),('11288','2013-09-30','11:45:00',2.38),('11288','2013-09-30','11:50:00',2.42),('11288','2013-09-30','11:55:00',2.22),('11288','2013-09-30','12:00:00',3.1),('11288','2013-09-30','12:05:00',1.49),('11288','2013-09-30','12:10:00',2.93),('11288','2013-09-30','12:15:00',6.06),('11288','2013-09-30','12:20:00',6.06),('11288','2013-09-30','12:25:00',5.96),('11288','2013-09-30','12:30:00',5.82),('11288','2013-09-30','12:35:00',5.72),('11288','2013-09-30','12:40:00',5.66),('11288','2013-09-30','12:45:00',4.62),('11288','2013-09-30','12:50:00',6.02),('11288','2013-09-30','12:55:00',5.91),('11288','2013-09-30','13:00:00',5.97),('11288','2013-09-30','13:05:00',6.08),('11288','2013-09-30','13:10:00',5.97),('11288','2013-09-30','13:15:00',6.35),('11288','2013-09-30','13:20:00',6.36),('11288','2013-09-30','13:25:00',6.77),('11288','2013-09-30','13:30:00',6.35),('11288','2013-09-30','13:35:00',5.79),('11288','2013-09-30','13:40:00',5.49),('11288','2013-09-30','13:45:00',2.45),('11288','2013-09-30','13:50:00',4.69),('11288','2013-09-30','13:55:00',4.37),('11288','2013-09-30','14:00:00',3.32),('11288','2013-09-30','14:05:00',2.21),('11288','2013-09-30','14:10:00',2.21),('11288','2013-09-30','14:15:00',2.1),('11288','2013-09-30','14:20:00',1.82),('11288','2013-09-30','14:25:00',2.08),('11288','2013-09-30','14:30:00',4.78),('11288','2013-09-30','14:35:00',4.06),('11288','2013-09-30','14:40:00',5.41),('11288','2013-09-30','14:45:00',5.9),('11288','2013-09-30','14:50:00',3.82),('11288','2013-09-30','14:55:00',3.9),('11288','2013-09-30','15:00:00',3.21),('11288','2013-09-30','15:05:00',4.5),('11288','2013-09-30','15:10:00',5.81),('11288','2013-09-30','15:15:00',4.01),('11288','2013-09-30','15:20:00',3.27),('11288','2013-09-30','15:25:00',3.94),('11288','2013-09-30','15:30:00',3.89),('11288','2013-09-30','15:35:00',5.22),('11288','2013-09-30','15:40:00',4.81),('11288','2013-09-30','15:45:00',2.65),('11288','2013-09-30','16:10:00',1.8),('11288','2013-09-30','16:15:00',2.36),('11288','2013-09-30','16:20:00',2.8),('11288','2013-09-30','16:25:00',1.63),('11288','2013-09-30','16:30:00',1.13),('11288','2013-09-30','16:40:00',1.35),('11288','2013-09-30','16:45:00',2),('11288','2013-09-30','16:50:00',1.15),('11288','2013-09-30','16:55:00',1.69),('11288','2013-09-30','17:00:00',1.45),('11288','2013-09-30','17:05:00',1.26),('11288','2013-09-30','17:10:00',1.1),('11288','2013-09-30','17:15:00',1.37),('11288','2013-09-30','17:20:00',1.39),('11288','2013-09-30','17:25:00',1.19),('11288','2013-09-29','08:40:00',1.23),('11288','2013-09-29','08:45:00',1.59),('11288','2013-09-29','08:50:00',1.99),('11288','2013-09-29','08:55:00',1.69),('11288','2013-09-29','09:00:00',1.66),('11288','2013-09-29','09:05:00',1.4),('11288','2013-09-29','09:10:00',1.7),('11288','2013-09-29','09:15:00',1.83),('11288','2013-09-29','09:20:00',1.5),('11288','2013-09-29','09:25:00',1.56),('11288','2013-09-29','09:30:00',1.51),('11288','2013-09-29','09:35:00',1.45),('11288','2013-09-29','09:40:00',1.42),('11288','2013-09-29','09:45:00',1.6),('11288','2013-09-29','09:50:00',1.68),('11288','2013-09-29','09:55:00',1.76),('11288','2013-09-29','10:00:00',1.99),('11288','2013-09-29','10:05:00',2.6),('11288','2013-09-29','10:10:00',3.1),('11288','2013-09-29','10:15:00',3.87),('11288','2013-09-29','10:20:00',3.23),('11288','2013-09-29','10:25:00',3.1),('11288','2013-09-29','10:30:00',3.51),('11288','2013-09-29','10:35:00',3.63),('11288','2013-09-29','10:40:00',3.41),('11288','2013-09-29','10:45:00',3.98),('11288','2013-09-29','10:50:00',4.2),('11288','2013-09-29','10:55:00',4.21),('11288','2013-09-29','11:00:00',4.26),('11288','2013-09-29','11:05:00',4.12),('11288','2013-09-29','11:10:00',4.11),('11288','2013-09-29','11:15:00',4.45),('11288','2013-09-29','11:20:00',4.37),('11288','2013-09-29','11:25:00',4.13),('11288','2013-09-29','11:30:00',4.49),('11288','2013-09-29','11:35:00',4.4),('11288','2013-09-29','11:40:00',4.6),('11288','2013-09-29','11:45:00',4.75),('11288','2013-09-29','11:50:00',4.91),('11288','2013-09-29','11:55:00',4.97),('11288','2013-09-29','12:00:00',4.39),('11288','2013-09-29','12:05:00',3.14),('11288','2013-09-29','12:10:00',5.45),('11288','2013-09-29','12:15:00',5.75),('11288','2013-09-29','12:20:00',2.93),('11288','2013-09-29','12:25:00',2.81),('11288','2013-09-29','12:30:00',3.07),('11288','2013-09-29','12:35:00',2.93),('11288','2013-09-29','12:40:00',2.64),('11288','2013-09-29','12:45:00',2.33),('11288','2013-09-29','12:50:00',2.31),('11288','2013-09-29','12:55:00',2.08),('11288','2013-09-29','13:00:00',2),('11288','2013-09-29','13:05:00',1.79),('11288','2013-09-29','13:10:00',1.79),('11288','2013-09-29','13:15:00',1.35),('11288','2013-09-29','13:20:00',1.68),('11288','2013-09-29','13:25:00',2.47),('11288','2013-09-29','13:30:00',2.8),('11288','2013-09-29','13:35:00',3.25),('11288','2013-09-29','13:40:00',2.86),('11288','2013-09-29','13:45:00',2.59),('11288','2013-09-29','13:50:00',2.89),('11288','2013-09-29','13:55:00',3.2),('11288','2013-09-29','14:00:00',3.14),('11288','2013-09-29','14:05:00',3.35),('11288','2013-09-29','14:10:00',2.15),('11288','2013-09-29','14:15:00',2.93),('11288','2013-09-29','14:20:00',4.6),('11288','2013-09-29','14:25:00',2.45),('11288','2013-09-29','14:30:00',2.87),('11288','2013-09-29','14:35:00',2.1),('11288','2013-09-29','14:40:00',1.68),('11288','2013-09-29','14:45:00',1.27),('11288','2013-09-29','14:50:00',1.63),('11288','2013-09-29','14:55:00',1.75),('11288','2013-09-29','15:00:00',1.91),('11288','2013-09-29','15:15:00',1.16),('11288','2013-09-29','15:20:00',1.68),('11288','2013-09-29','15:25:00',1.53),('11288','2013-09-29','15:30:00',1.37),('11288','2013-09-29','15:35:00',1.28),('11288','2013-09-29','15:40:00',1.42),('11288','2013-09-29','15:45:00',1.22),('11288','2013-09-29','15:50:00',1.03),('11288','2013-09-29','15:55:00',1.7),('11288','2013-09-29','16:00:00',1.99),('11288','2013-09-29','16:05:00',1.67),('11288','2013-09-29','16:10:00',1.22),('11288','2013-09-29','16:15:00',1.11),('11288','2013-09-29','16:20:00',1.31),('11288','2013-09-29','16:25:00',1.55),('11288','2013-09-29','16:30:00',2.02),('11288','2013-09-29','16:35:00',1.79),('11288','2013-09-29','16:40:00',1.49),('11288','2013-09-29','16:45:00',1.41),('11288','2013-09-29','17:05:00',1.1),('11288','2014-04-14','07:55:00',1.1),('11288','2014-04-14','08:00:00',1.2),('11288','2014-04-14','08:05:00',1.24),('11288','2014-04-14','08:10:00',1.44),('11288','2014-04-14','08:15:00',1.57),('11288','2014-04-14','08:20:00',1.57),('11288','2014-04-14','08:25:00',1.81),('11288','2014-04-14','08:30:00',2.01),('11288','2014-04-14','08:35:00',2.1),('11288','2014-04-14','08:40:00',2.33),('11288','2014-04-14','08:45:00',2.52),('11288','2014-04-14','08:50:00',2.66),('11288','2014-04-14','08:55:00',2.85),('11288','2014-04-14','09:00:00',3.03),('11288','2014-04-14','09:05:00',3.06),('11288','2014-04-14','09:10:00',3.22),('11288','2014-04-14','09:15:00',3.34),('11288','2014-04-14','09:20:00',3.39),('11288','2014-04-14','09:25:00',3.44),('11288','2014-04-14','09:30:00',3.83),('11288','2014-04-14','09:35:00',3.94),('11288','2014-04-14','09:40:00',4.03),('11288','2014-04-14','09:45:00',4.05),('11288','2014-04-14','09:50:00',4.04),('11288','2014-04-14','09:55:00',4.2),('11288','2014-04-14','10:00:00',4.68),('11288','2014-04-14','10:05:00',4.83),('11288','2014-04-14','10:10:00',4.95),('11288','2014-04-14','10:15:00',5.07),('11288','2014-04-14','10:20:00',5.08),('11288','2014-04-14','10:25:00',5.24),('11288','2014-04-14','10:30:00',5.4),('11288','2014-04-14','10:35:00',5.51),('11288','2014-04-14','10:40:00',5.62),('11288','2014-04-14','10:45:00',5.65),('11288','2014-04-14','10:50:00',5.73),('11288','2014-04-14','10:55:00',5.83),('11288','2014-04-14','11:00:00',5.89),('11288','2014-04-14','11:05:00',5.95),('11288','2014-04-14','11:10:00',6),('11288','2014-04-14','11:15:00',6.04),('11288','2014-04-14','11:20:00',6.12),('11288','2014-04-14','11:25:00',6.19),('11288','2014-04-14','11:30:00',6.26),('11288','2014-04-14','11:35:00',6.32),('11288','2014-04-14','11:40:00',6.33),('11288','2014-04-14','11:45:00',6.4),('11288','2014-04-14','11:50:00',6.42),('11288','2014-04-14','11:55:00',6.43),('11288','2014-04-14','12:00:00',6.59),('11288','2014-04-14','12:05:00',6.63),('11288','2014-04-14','12:10:00',6.63),('11288','2014-04-14','12:15:00',6.68),('11288','2014-04-14','12:20:00',6.72),('11288','2014-04-14','12:25:00',6.75),('11288','2014-04-14','12:30:00',6.75),('11288','2014-04-14','12:35:00',6.78),('11288','2014-04-14','12:40:00',6.77),('11288','2014-04-14','12:45:00',6.77),('11288','2014-04-14','12:50:00',6.8),('11288','2014-04-14','12:55:00',6.79),('11288','2014-04-14','13:00:00',6.82),('11288','2014-04-14','13:05:00',6.8),('11288','2014-04-14','13:10:00',6.8),('11288','2014-04-14','13:15:00',6.86),('11288','2014-04-14','13:20:00',6.83),('11288','2014-04-14','13:25:00',6.83),('11288','2014-04-14','13:30:00',6.83),('11288','2014-04-14','13:35:00',6.81),('11288','2014-04-14','13:40:00',6.82),('11288','2014-04-14','13:45:00',6.79),('11288','2014-04-14','13:50:00',6.85),('11288','2014-04-14','13:55:00',6.81),('11288','2014-04-14','14:00:00',6.71),('11288','2014-04-14','14:05:00',6.77),('11288','2014-04-14','14:10:00',6.74),('11288','2014-04-14','14:15:00',6.72),('11288','2014-04-14','14:20:00',6.72),('11288','2014-04-14','14:25:00',6.65),('11288','2014-04-14','14:30:00',6.57),('11288','2014-04-14','14:35:00',6.55),('11288','2014-04-14','14:40:00',6.5),('11288','2014-04-14','14:45:00',6.44),('11288','2014-04-14','14:50:00',6.4),('11288','2014-04-14','14:55:00',6.37),('11288','2014-04-14','15:00:00',6.31),('11288','2014-04-14','15:05:00',6.23),('11288','2014-04-14','15:10:00',6.17),('11288','2014-04-14','15:15:00',6.08),('11288','2014-04-14','15:20:00',6.02),('11288','2014-04-14','15:25:00',5.94),('11288','2014-04-14','15:30:00',5.85),('11288','2014-04-14','15:35:00',5.79),('11288','2014-04-14','15:40:00',5.71),('11288','2014-04-14','15:45:00',5.62),('11288','2014-04-14','15:50:00',5.51),('11288','2014-04-14','15:55:00',5.38),('11288','2014-04-14','16:00:00',5.28),('11288','2014-04-14','16:05:00',5.17),('11288','2014-04-14','16:10:00',5.07),('11288','2014-04-14','16:15:00',4.89),('11288','2014-04-14','16:20:00',4.82),('11288','2014-04-14','16:25:00',4.7),('11288','2014-04-14','16:30:00',4.58),('11288','2014-04-14','16:35:00',4.43),('11288','2014-04-14','16:40:00',4.31),('11288','2014-04-14','16:45:00',4.18),('11288','2014-04-14','16:50:00',4.03),('11288','2014-04-14','16:55:00',3.88),('11288','2014-04-14','17:00:00',3.74),('11288','2014-04-14','17:05:00',3.58),('11288','2014-04-14','17:10:00',3.42),('11288','2014-04-14','17:15:00',3.29),('11288','2014-04-14','17:20:00',3.15),('11288','2014-04-14','17:25:00',3.01),('11288','2014-04-14','17:30:00',2.83),('11288','2014-04-14','17:35:00',2.66),('11288','2014-04-14','17:40:00',2.51),('11288','2014-04-14','17:45:00',2.34),('11288','2014-04-14','17:50:00',2.19),('11288','2014-04-14','17:55:00',2.01),('11288','2014-04-14','18:00:00',1.85),('11288','2014-04-14','18:05:00',1.73),('11288','2014-04-14','18:10:00',1.61),('11288','2014-04-14','18:15:00',1.48),('11288','2014-04-14','18:20:00',1.34),('11288','2014-04-14','18:25:00',1.21),('11288','2014-04-14','18:30:00',1.08),('11288','2013-09-28','08:30:00',1.13),('11288','2013-09-28','08:35:00',1.16),('11288','2013-09-28','08:40:00',1.34),('11288','2013-09-28','08:45:00',1.5),('11288','2013-09-28','08:50:00',1.6),('11288','2013-09-28','08:55:00',1.68),('11288','2013-09-28','09:00:00',1.83),('11288','2013-09-28','09:05:00',1.84),('11288','2013-09-28','09:10:00',2.14),('11288','2013-09-28','09:15:00',2.28),('11288','2013-09-28','09:20:00',2.44),('11288','2013-09-28','09:25:00',2.58),('11288','2013-09-28','09:30:00',2.69),('11288','2013-09-28','09:35:00',2.65),('11288','2013-09-28','09:40:00',2.61),('11288','2013-09-28','09:45:00',3.1),('11288','2013-09-28','09:50:00',3.51),('11288','2013-09-28','09:55:00',3.77),('11288','2013-09-28','10:00:00',3.06),('11288','2013-09-28','10:05:00',1.86),('11288','2013-09-28','10:10:00',2.69),('11288','2013-09-28','10:15:00',3.13),('11288','2013-09-28','10:20:00',2.79),('11288','2013-09-28','10:25:00',2.06),('11288','2013-09-28','10:30:00',2.18),('11288','2013-09-28','10:35:00',2.42),('11288','2013-09-28','10:40:00',3.6),('11288','2013-09-28','10:45:00',5.26),('11288','2013-09-28','10:50:00',5.43),('11288','2013-09-28','10:55:00',5.05),('11288','2013-09-28','11:00:00',3.06),('11288','2013-09-28','11:05:00',3.71),('11288','2013-09-28','11:10:00',3.73),('11288','2013-09-28','11:15:00',5.36),('11288','2013-09-28','11:20:00',5.54),('11288','2013-09-28','11:25:00',5.65),('11288','2013-09-28','11:30:00',5.47),('11288','2013-09-28','11:35:00',4.2),('11288','2013-09-28','11:40:00',1.34),('11288','2013-09-28','11:45:00',1.67),('11288','2013-09-28','11:50:00',3.81),('11288','2013-09-28','11:55:00',4.75),('11288','2013-09-28','12:00:00',5.98),('11288','2013-09-28','12:05:00',3.68),('11288','2013-09-28','12:10:00',5.42),('11288','2013-09-28','12:15:00',4.61),('11288','2013-09-28','12:20:00',4.9),('11288','2013-09-28','12:25:00',4.71),('11288','2013-09-28','12:30:00',3.34),('11288','2013-09-28','12:35:00',5.55),('11288','2013-09-28','12:40:00',5.68),('11288','2013-09-28','12:45:00',6.07),('11288','2013-09-28','12:50:00',6.24),('11288','2013-09-28','12:55:00',6.09),('11288','2013-09-28','13:00:00',5.18),('11288','2013-09-28','13:05:00',3.69),('11288','2013-09-28','13:10:00',6.26),('11288','2013-09-28','13:15:00',5.79),('11288','2013-09-28','13:20:00',5.87),('11288','2013-09-28','13:25:00',4.86),('11288','2013-09-28','13:30:00',2.91),('11288','2013-09-28','13:35:00',2.74),('11288','2013-09-28','13:40:00',3.78),('11288','2013-09-28','13:45:00',4.7),('11288','2013-09-28','13:50:00',4.85),('11288','2013-09-28','13:55:00',5.31),('11288','2013-09-28','14:00:00',5.63),('11288','2013-09-28','14:05:00',4.26),('11288','2013-09-28','14:10:00',5.72),('11288','2013-09-28','14:15:00',6.03),('11288','2013-09-28','14:20:00',5.74),('11288','2013-09-28','14:25:00',5.55),('11288','2013-09-28','14:30:00',5.45),('11288','2013-09-28','14:35:00',5.47),('11288','2013-09-28','14:40:00',5.3),('11288','2013-09-28','14:45:00',5.19),('11288','2013-09-28','14:50:00',5.08),('11288','2013-09-28','14:55:00',4.97),('11288','2013-09-28','15:00:00',5.02),('11288','2013-09-28','15:05:00',4.29),('11288','2013-09-28','15:10:00',4.56),('11288','2013-09-28','15:15:00',4.67),('11288','2013-09-28','15:20:00',4.5),('11288','2013-09-28','15:25:00',4.34),('11288','2013-09-28','15:30:00',4.18),('11288','2013-09-28','15:35:00',4.1),('11288','2013-09-28','15:40:00',3.95),('11288','2013-09-28','15:45:00',3.92),('11288','2013-09-28','15:50:00',3.7),('11288','2013-09-28','15:55:00',3.75),('11288','2013-09-28','16:00:00',3.7),('11288','2013-09-28','16:05:00',3.53),('11288','2013-09-28','16:10:00',3.4),('11288','2013-09-28','16:15:00',2.29),('11288','2013-09-28','16:20:00',2.21),('11288','2013-09-28','16:25:00',2.35),('11288','2013-09-28','16:30:00',2.36),('11288','2013-09-28','16:35:00',2.56),('11288','2013-09-28','16:40:00',2.39),('11288','2013-09-28','16:45:00',2.23),('11288','2013-09-28','16:50:00',2.13),('11288','2013-09-28','16:55:00',1.99),('11288','2013-09-28','17:00:00',1.85),('11288','2013-09-28','17:05:00',1.71),('11288','2013-09-28','17:10:00',1.58),('11288','2013-09-28','17:15:00',1.47),('11288','2013-09-28','17:20:00',1.36),('11288','2013-09-28','17:25:00',1.27),('11288','2013-09-28','17:30:00',1.17),('11288','2013-09-28','17:35:00',1.06),('11288','2013-09-27','08:20:00',1.13),('11288','2013-09-27','08:25:00',1.13),('11288','2013-09-27','08:30:00',1.18),('11288','2013-09-27','08:35:00',1.36),('11288','2013-09-27','08:40:00',1.39),('11288','2013-09-27','08:45:00',1.55),('11288','2013-09-27','08:50:00',1.67),('11288','2013-09-27','08:55:00',2.09),('11288','2013-09-27','09:00:00',2.2),('11288','2013-09-27','09:05:00',1.72),('11288','2013-09-27','09:10:00',1.48),('11288','2013-09-27','09:15:00',1.67),('11288','2013-09-27','09:20:00',1.44),('11288','2013-09-27','09:25:00',1.46),('11288','2013-09-27','09:30:00',1.31),('11288','2013-09-27','09:35:00',1.56),('11288','2013-09-27','09:40:00',1.5),('11288','2013-09-27','09:45:00',1.65),('11288','2013-09-27','09:50:00',2.81),('11288','2013-09-27','09:55:00',3.32),('11288','2013-09-27','10:00:00',2.79),('11288','2013-09-27','10:05:00',2.99),('11288','2013-09-27','10:10:00',2.78),('11288','2013-09-27','10:15:00',2.61),('11288','2013-09-27','10:20:00',3.35),('11288','2013-09-27','10:25:00',2.44),('11288','2013-09-27','10:30:00',2.27),('11288','2013-09-27','10:35:00',2.11),('11288','2013-09-27','10:40:00',1.87),('11288','2013-09-27','10:45:00',1.83),('11288','2013-09-27','10:50:00',1.66),('11288','2013-09-27','10:55:00',3.53),('11288','2013-09-27','11:00:00',3.45),('11288','2013-09-27','11:05:00',2.71),('11288','2013-09-27','11:10:00',3.33),('11288','2013-09-27','11:15:00',3.51),('11288','2013-09-27','11:20:00',5.04),('11288','2013-09-27','11:25:00',4.27),('11288','2013-09-27','11:30:00',2.43),('11288','2013-09-27','11:35:00',1.73),('11288','2013-09-27','11:40:00',1.73),('11288','2013-09-27','11:45:00',2),('11288','2013-09-27','11:50:00',1.98),('11288','2013-09-27','11:55:00',3.37),('11288','2013-09-27','12:00:00',5.5),('11288','2013-09-27','12:05:00',3.65),('11288','2013-09-27','12:10:00',5.55),('11288','2013-09-27','12:15:00',1.79),('11288','2013-09-27','12:20:00',1.45),('11288','2013-09-27','12:25:00',1.49),('11288','2013-09-27','12:30:00',1.59),('11288','2013-09-27','12:35:00',1.5),('11288','2013-09-27','12:40:00',1.7),('11288','2013-09-27','12:45:00',2.38),('11288','2013-09-27','12:50:00',3.94),('11288','2013-09-27','12:55:00',5.27),('11288','2013-09-27','13:00:00',5.59),('11288','2013-09-27','13:05:00',5.98),('11288','2013-09-27','13:10:00',4.97),('11288','2013-09-27','13:15:00',3.37),('11288','2013-09-27','13:20:00',2.91),('11288','2013-09-27','13:25:00',1.69),('11288','2013-09-27','13:30:00',1.35),('11288','2013-09-27','13:35:00',1.41),('11288','2013-09-27','13:40:00',1.73),('11288','2013-09-27','13:45:00',1.59),('11288','2013-09-27','13:50:00',3.27),('11288','2013-09-27','13:55:00',3.97),('11288','2013-09-27','14:00:00',6.01),('11288','2013-09-27','14:05:00',4.79),('11288','2013-09-27','14:10:00',5.39),('11288','2013-09-27','14:15:00',5.49),('11288','2013-09-27','14:20:00',5.36),('11288','2013-09-27','14:25:00',3.99),('11288','2013-09-27','14:30:00',5.09),('11288','2013-09-27','14:35:00',5),('11288','2013-09-27','14:40:00',4.64),('11288','2013-09-27','14:45:00',4.93),('11288','2013-09-27','14:50:00',4),('11288','2013-09-27','14:55:00',4.96),('11288','2013-09-27','15:00:00',4.75),('11288','2013-09-27','15:05:00',3.18),('11288','2013-09-27','15:10:00',4.54),('11288','2013-09-27','15:15:00',4.5),('11288','2013-09-27','15:20:00',4.51),('11288','2013-09-27','15:25:00',4.41),('11288','2013-09-27','15:30:00',3.14),('11288','2013-09-27','15:35:00',4.23),('11288','2013-09-27','15:40:00',3.19),('11288','2013-09-27','15:45:00',4.14),('11288','2013-09-27','15:50:00',4.07),('11288','2013-09-27','15:55:00',3.68),('11288','2013-09-27','16:00:00',3.5),('11288','2013-09-27','16:05:00',1.98),('11288','2013-09-27','16:10:00',2.31),('11288','2013-09-27','16:15:00',2.25),('11288','2013-09-27','16:20:00',2.6),('11288','2013-09-27','16:25:00',2.45),('11288','2013-09-27','16:30:00',2.07),('11288','2013-09-27','16:35:00',2.28),('11288','2013-09-27','16:40:00',2.19),('11288','2013-09-27','16:45:00',2.28),('11288','2013-09-27','16:50:00',2),('11288','2013-09-27','16:55:00',1.03),('11288','2013-09-27','17:05:00',1.04),('11288','2013-09-27','17:10:00',1.77),('11288','2013-09-27','17:15:00',1.66),('11288','2013-09-27','17:20:00',1.5),('11288','2013-09-27','17:25:00',1.38),('11288','2013-09-27','17:30:00',1.26),('11288','2013-09-27','17:35:00',1.07),('11288','2013-09-26','08:25:00',1.02),('11288','2013-09-26','08:35:00',1.09),('11288','2013-09-26','08:40:00',1.39),('11288','2013-09-26','08:45:00',1.59),('11288','2013-09-26','08:50:00',1.64),('11288','2013-09-26','08:55:00',1.83),('11288','2013-09-26','09:00:00',2.03),('11288','2013-09-26','09:05:00',2.05),('11288','2013-09-26','09:10:00',2.2),('11288','2013-09-26','09:15:00',2.46),('11288','2013-09-26','09:20:00',2.48),('11288','2013-09-26','09:25:00',2.67),('11288','2013-09-26','09:30:00',2.87),('11288','2013-09-26','09:35:00',2.95),('11288','2013-09-26','09:40:00',3.05),('11288','2013-09-26','09:45:00',3.3),('11288','2013-09-26','09:50:00',3.38),('11288','2013-09-26','09:55:00',3.49),('11288','2013-09-26','10:00:00',3.6),('11288','2013-09-26','10:05:00',3.7),('11288','2013-09-26','10:10:00',3.78),('11288','2013-09-26','10:15:00',3.91),('11288','2013-09-26','10:20:00',4.04),('11288','2013-09-26','10:25:00',4.04),('11288','2013-09-26','10:30:00',4.25),('11288','2013-09-26','10:35:00',4.3),('11288','2013-09-26','10:40:00',3.89),('11288','2013-09-26','10:45:00',4.36),('11288','2013-09-26','10:50:00',4.48),('11288','2013-09-26','10:55:00',4.42),('11288','2013-09-26','11:00:00',4.49),('11288','2013-09-26','11:05:00',4.43),('11288','2013-09-26','11:10:00',4.74),('11288','2013-09-26','11:15:00',4.76),('11288','2013-09-26','11:20:00',4.72),('11288','2013-09-26','11:25:00',4.66),('11288','2013-09-26','11:30:00',4.82),('11288','2013-09-26','11:35:00',4.35),('11288','2013-09-26','11:40:00',4.77),('11288','2013-09-26','11:45:00',5.08),('11288','2013-09-26','11:50:00',4.97),('11288','2013-09-26','11:55:00',5.35),('11288','2013-09-26','12:00:00',5.49),('11288','2013-09-26','12:05:00',6.03),('11288','2013-09-26','12:10:00',2.48),('11288','2013-09-26','12:15:00',2.76),('11288','2013-09-26','12:20:00',3.19),('11288','2013-09-26','12:25:00',2),('11288','2013-09-26','12:30:00',2.32),('11288','2013-09-26','12:35:00',2.68),('11288','2013-09-26','12:40:00',2.59),('11288','2013-09-26','12:45:00',2.61),('11288','2013-09-26','12:50:00',2.59),('11288','2013-09-26','12:55:00',6.07),('11288','2013-09-26','13:00:00',3.31),('11288','2013-09-26','13:05:00',3.23),('11288','2013-09-26','13:10:00',4.13),('11288','2013-09-26','13:15:00',5.76),('11288','2013-09-26','13:20:00',4.56),('11288','2013-09-26','13:25:00',3.32),('11288','2013-09-26','13:30:00',3.78),('11288','2013-09-26','13:35:00',3.17),('11288','2013-09-26','13:40:00',2.5),('11288','2013-09-26','13:45:00',2.8),('11288','2013-09-26','13:50:00',4.57),('11288','2013-09-26','13:55:00',3.13),('11288','2013-09-26','14:00:00',4.44),('11288','2013-09-26','14:05:00',6.1),('11288','2013-09-26','14:10:00',5),('11288','2013-09-26','14:15:00',4.25),('11288','2013-09-26','14:20:00',1.69),('11288','2013-09-26','14:25:00',1.26),('11288','2013-09-26','14:30:00',3.29),('11288','2013-09-26','14:35:00',1.6),('11288','2013-09-26','14:40:00',3.2),('11288','2013-09-26','14:45:00',6.03),('11288','2013-09-26','14:50:00',5.61),('11288','2013-09-26','14:55:00',4.25),('11288','2013-09-26','15:00:00',2.56),('11288','2013-09-26','15:05:00',3.95),('11288','2013-09-26','15:10:00',1.78),('11288','2013-09-26','15:15:00',1.76),('11288','2013-09-26','15:20:00',4.16),('11288','2013-09-26','15:25:00',1.62),('11288','2013-09-26','15:30:00',2.01),('11288','2013-09-26','15:35:00',4.29),('11288','2013-09-26','15:40:00',1.48),('11288','2013-09-26','15:45:00',1.3),('11288','2013-09-26','15:50:00',2.79),('11288','2013-09-26','15:55:00',3.82),('11288','2013-09-26','16:00:00',3.25),('11288','2013-09-26','16:05:00',1.57),('11288','2013-09-26','16:10:00',2.87),('11288','2013-09-26','16:15:00',3.14),('11288','2013-09-26','16:20:00',3.13),('11288','2013-09-26','16:25:00',3.05),('11288','2013-09-26','16:30:00',2.85),('11288','2013-09-26','16:35:00',2.69),('11288','2013-09-26','16:40:00',2.54),('11288','2013-09-26','16:45:00',2.39),('11288','2013-09-26','16:50:00',2.26),('11288','2013-09-26','16:55:00',2.14),('11288','2013-09-26','17:00:00',1.97),('11288','2013-09-26','17:05:00',1.88),('11288','2013-09-26','17:10:00',1.79),('11288','2013-09-26','17:15:00',1.64),('11288','2013-09-26','17:20:00',1.54),('11288','2013-09-26','17:25:00',1.43),('11288','2013-09-26','17:30:00',1.36),('11288','2013-09-26','17:35:00',1.37),('11288','2013-09-26','17:40:00',1.19),('11288','2013-09-26','17:45:00',1.05),('11288','2013-09-25','08:25:00',1.08),('11288','2013-09-25','08:30:00',1.24),('11288','2013-09-25','08:40:00',1.24),('11288','2013-09-25','08:45:00',1.93),('11288','2013-09-25','08:50:00',1.19),('11288','2013-09-25','08:55:00',1.14),('11288','2013-09-25','09:00:00',1.46),('11288','2013-09-25','09:05:00',2.04),('11288','2013-09-25','09:10:00',2.37),('11288','2013-09-25','09:15:00',2.08),('11288','2013-09-25','09:20:00',1.95),('11288','2013-09-25','09:25:00',2.12),('11288','2013-09-25','09:30:00',1.77),('11288','2013-09-25','09:35:00',3.13),('11288','2013-09-25','09:40:00',2.22),('11288','2013-09-25','09:55:00',1.13),('11288','2013-09-25','10:00:00',1.63),('11288','2013-09-25','10:10:00',1.09),('11288','2013-09-25','10:25:00',1.58),('11288','2013-09-25','10:30:00',2.07),('11288','2013-09-25','10:35:00',1.89),('11288','2013-09-25','10:40:00',2.49),('11288','2013-09-25','10:45:00',3.98),('11288','2013-09-25','10:50:00',4.78),('11288','2013-09-25','10:55:00',4.97),('11288','2013-09-25','11:00:00',4.14),('11288','2013-09-25','11:05:00',1.75),('11288','2013-09-25','11:10:00',3.34),('11288','2013-09-25','11:15:00',2.52),('11288','2013-09-25','11:20:00',4.29),('11288','2013-09-25','11:25:00',3.33),('11288','2013-09-25','11:30:00',5.18),('11288','2013-09-25','11:35:00',5.33),('11288','2013-09-25','11:40:00',5.35),('11288','2013-09-25','11:45:00',3.65),('11288','2013-09-25','11:50:00',1.63),('11288','2013-09-25','11:55:00',1.43),('11288','2013-09-25','12:00:00',1.21),('11288','2013-09-25','12:05:00',1.38),('11288','2013-09-25','12:10:00',5.12),('11288','2013-09-25','12:15:00',4.78),('11288','2013-09-25','12:20:00',1.38),('11288','2013-09-25','12:25:00',2.35),('11288','2013-09-25','12:30:00',6.55),('11288','2013-09-25','12:35:00',4.91),('11288','2013-09-25','12:40:00',1.81),('11288','2013-09-25','12:45:00',2.17),('11288','2013-09-25','12:50:00',1.99),('11288','2013-09-25','12:55:00',1.85),('11288','2013-09-25','13:00:00',2.87),('11288','2013-09-25','13:05:00',1.46),('11288','2013-09-25','13:10:00',1.92),('11288','2013-09-25','13:15:00',4.43),('11288','2013-09-25','13:20:00',4.59),('11288','2013-09-25','13:25:00',6.97),('11288','2013-09-25','13:30:00',6.57),('11288','2013-09-25','13:35:00',6.67),('11288','2013-09-25','13:40:00',6.6),('11288','2013-09-25','13:45:00',6.43),('11288','2013-09-25','13:50:00',4.94),('11288','2013-09-25','13:55:00',1.64),('11288','2013-09-25','14:00:00',1.48),('11288','2013-09-25','14:05:00',1.72),('11288','2013-09-25','14:10:00',1.81),('11288','2013-09-25','14:15:00',1.65),('11288','2013-09-25','14:20:00',2.26),('11288','2013-09-25','14:25:00',3.87),('11288','2013-09-25','14:30:00',6.24),('11288','2013-09-25','14:35:00',6.26),('11288','2013-09-25','14:40:00',5.77),('11288','2013-09-25','14:45:00',4.96),('11288','2013-09-25','14:50:00',4.54),('11288','2013-09-25','14:55:00',4.05),('11288','2013-09-25','15:00:00',4.73),('11288','2013-09-25','15:05:00',5.32),('11288','2013-09-25','15:10:00',5.02),('11288','2013-09-25','15:15:00',4.93),('11288','2013-09-25','15:20:00',3.44),('11288','2013-09-25','15:25:00',4.6),('11288','2013-09-25','15:30:00',4.04),('11288','2013-09-25','15:35:00',4.88),('11288','2013-09-25','15:40:00',4.55),('11288','2013-09-25','15:45:00',4.17),('11288','2013-09-25','15:50:00',4.18),('11288','2013-09-25','15:55:00',4.06),('11288','2013-09-25','16:00:00',3.95),('11288','2013-09-25','16:05:00',3.71),('11288','2013-09-25','16:10:00',3.62),('11288','2013-09-25','16:15:00',3.5),('11288','2013-09-25','16:20:00',3.04),('11288','2013-09-25','16:25:00',3.19),('11288','2013-09-25','16:30:00',3.1),('11288','2013-09-25','16:35:00',2.3),('11288','2013-09-25','16:40:00',2.34),('11288','2013-09-25','16:45:00',2.58),('11288','2013-09-25','16:50:00',2.44),('11288','2013-09-25','16:55:00',2.31),('11288','2013-09-25','17:00:00',2.17),('11288','2013-09-25','17:05:00',2.03),('11288','2013-09-25','17:10:00',1.89),('11288','2013-09-25','17:15:00',1.73),('11288','2013-09-25','17:20:00',1.6),('11288','2013-09-25','17:25:00',1.51),('11288','2013-09-25','17:30:00',1.4),('11288','2013-09-25','17:35:00',1.26),('11288','2013-09-25','17:40:00',1.11),('11288','2013-09-24','08:25:00',1.12),('11288','2013-09-24','08:30:00',1.25),('11288','2013-09-24','08:35:00',1.43),('11288','2013-09-24','08:40:00',1.44),('11288','2013-09-24','08:45:00',1.58),('11288','2013-09-24','08:50:00',1.71),('11288','2013-09-24','08:55:00',1.95),('11288','2013-09-24','09:00:00',2.13),('11288','2013-09-24','09:05:00',2.25),('11288','2013-09-24','09:10:00',2.41),('11288','2013-09-24','09:15:00',2.47),('11288','2013-09-24','09:20:00',2.59),('11288','2013-09-24','09:25:00',2.87),('11288','2013-09-24','09:30:00',3.01),('11288','2013-09-24','09:35:00',3.17),('11288','2013-09-24','09:40:00',3.31),('11288','2013-09-24','09:45:00',3.43),('11288','2013-09-24','09:50:00',3.53),('11288','2013-09-24','09:55:00',3.66),('11288','2013-09-24','10:00:00',3.78),('11288','2013-09-24','10:05:00',3.91),('11288','2013-09-24','10:10:00',4.03),('11288','2013-09-24','10:15:00',4.2),('11288','2013-09-24','10:20:00',4.31),('11288','2013-09-24','10:25:00',4.44),('11288','2013-09-24','10:30:00',4.52),('11288','2013-09-24','10:35:00',4.59),('11288','2013-09-24','10:40:00',4.66),('11288','2013-09-24','10:45:00',4.73),('11288','2013-09-24','10:50:00',4.79),('11288','2013-09-24','10:55:00',4.84),('11288','2013-09-24','11:00:00',4.9),('11288','2013-09-24','11:05:00',4.94),('11288','2013-09-24','11:10:00',4.94),('11288','2013-09-24','11:15:00',5),('11288','2013-09-24','11:20:00',5.07),('11288','2013-09-24','11:25:00',5.1),('11288','2013-09-24','11:30:00',5.18),('11288','2013-09-24','11:35:00',5.17),('11288','2013-09-24','11:40:00',5.23),('11288','2013-09-24','11:45:00',5.29),('11288','2013-09-24','11:50:00',5.35),('11288','2013-09-24','11:55:00',5.37),('11288','2013-09-24','12:00:00',5.49),('11288','2013-09-24','12:05:00',5.55),('11288','2013-09-24','12:10:00',5.53),('11288','2013-09-24','12:15:00',5.48),('11288','2013-09-24','12:20:00',5.56),('11288','2013-09-24','12:25:00',5.62),('11288','2013-09-24','12:30:00',5.62),('11288','2013-09-24','12:35:00',5.64),('11288','2013-09-24','12:40:00',5.68),('11288','2013-09-24','12:45:00',5.68),('11288','2013-09-24','12:50:00',5.61),('11288','2013-09-24','12:55:00',5.66),('11288','2013-09-24','13:00:00',5.72),('11288','2013-09-24','13:05:00',5.71),('11288','2013-09-24','13:10:00',5.7),('11288','2013-09-24','13:15:00',5.68),('11288','2013-09-24','13:20:00',5.67),('11288','2013-09-24','13:25:00',5.56),('11288','2013-09-24','13:30:00',5.64),('11288','2013-09-24','13:35:00',5.65),('11288','2013-09-24','13:40:00',5.65),('11288','2013-09-24','13:45:00',5.55),('11288','2013-09-24','13:50:00',5.5),('11288','2013-09-24','13:55:00',5.47),('11288','2013-09-24','14:00:00',5.46),('11288','2013-09-24','14:05:00',5.44),('11288','2013-09-24','14:10:00',5.43),('11288','2013-09-24','14:15:00',5.39),('11288','2013-09-24','14:20:00',5.32),('11288','2013-09-24','14:25:00',5.31),('11288','2013-09-24','14:30:00',5.22),('11288','2013-09-24','14:35:00',5.18),('11288','2013-09-24','14:40:00',5.14),('11288','2013-09-24','14:45:00',5.06),('11288','2013-09-24','14:50:00',5.02),('11288','2013-09-24','14:55:00',4.91),('11288','2013-09-24','15:00:00',4.91),('11288','2013-09-24','15:05:00',4.81),('11288','2013-09-24','15:10:00',4.7),('11288','2013-09-24','15:15:00',4.68),('11288','2013-09-24','15:20:00',4.64),('11288','2013-09-24','15:25:00',4.57),('11288','2013-09-24','15:30:00',4.44),('11288','2013-09-24','15:35:00',4.34),('11288','2013-09-24','15:40:00',4.26),('11288','2013-09-24','15:45:00',4.2),('11288','2013-09-24','15:50:00',4.05),('11288','2013-09-24','15:55:00',3.95),('11288','2013-09-24','16:00:00',3.86),('11288','2013-09-24','16:05:00',3.72),('11288','2013-09-24','16:10:00',3.6),('11288','2013-09-24','16:15:00',3.48),('11288','2013-09-24','16:20:00',3.39),('11288','2013-09-24','16:25:00',3.21),('11288','2013-09-24','16:30:00',3.09),('11288','2013-09-24','16:35:00',2.95),('11288','2013-09-24','16:40:00',2.8),('11288','2013-09-24','16:45:00',2.69),('11288','2013-09-24','16:50:00',2.54),('11288','2013-09-24','16:55:00',2.42),('11288','2013-09-24','17:00:00',2.24),('11288','2013-09-24','17:05:00',2.09),('11288','2013-09-24','17:10:00',1.94),('11288','2013-09-24','17:15:00',1.81),('11288','2013-09-24','17:20:00',1.68),('11288','2013-09-24','17:25:00',1.55),('11288','2013-09-24','17:30:00',1.4),('11288','2013-09-24','17:35:00',1.28),('11288','2013-09-24','17:40:00',1.13),('11288','2013-09-23','08:25:00',1.08),('11288','2013-09-23','08:30:00',1.2),('11288','2013-09-23','08:35:00',1.34),('11288','2013-09-23','08:40:00',1.49),('11288','2013-09-23','08:45:00',1.69),('11288','2013-09-23','08:50:00',1.85),('11288','2013-09-23','08:55:00',1.96),('11288','2013-09-23','09:00:00',2.12),('11288','2013-09-23','09:05:00',2.29),('11288','2013-09-23','09:10:00',2.3),('11288','2013-09-23','09:15:00',2.34),('11288','2013-09-23','09:20:00',2.54),('11288','2013-09-23','09:25:00',2.84),('11288','2013-09-23','09:30:00',3),('11288','2013-09-23','09:35:00',3.17),('11288','2013-09-23','09:40:00',3.38),('11288','2013-09-23','09:45:00',3.5),('11288','2013-09-23','09:50:00',3.61),('11288','2013-09-23','09:55:00',3.76),('11288','2013-09-23','10:00:00',3.86),('11288','2013-09-23','10:05:00',3.99),('11288','2013-09-23','10:10:00',4.15),('11288','2013-09-23','10:15:00',4.31),('11288','2013-09-23','10:20:00',4.38),('11288','2013-09-23','10:25:00',4.51),('11288','2013-09-23','10:30:00',4.59),('11288','2013-09-23','10:35:00',4.67),('11288','2013-09-23','10:40:00',4.76),('11288','2013-09-23','10:45:00',4.83),('11288','2013-09-23','10:50:00',4.9),('11288','2013-09-23','10:55:00',5),('11288','2013-09-23','11:00:00',5.02),('11288','2013-09-23','11:05:00',5.06),('11288','2013-09-23','11:10:00',5.16),('11288','2013-09-23','11:15:00',5.25),('11288','2013-09-23','11:20:00',5.33),('11288','2013-09-23','11:25:00',5.36),('11288','2013-09-23','11:30:00',5.42),('11288','2013-09-23','11:35:00',5.43),('11288','2013-09-23','11:40:00',5.48),('11288','2013-09-23','11:45:00',5.56),('11288','2013-09-23','11:50:00',5.64),('11288','2013-09-23','11:55:00',5.69),('11288','2013-09-23','12:00:00',5.76),('11288','2013-09-23','12:05:00',5.83),('11288','2013-09-23','12:10:00',5.85),('11288','2013-09-23','12:15:00',5.93),('11288','2013-09-23','12:20:00',5.93),('11288','2013-09-23','12:25:00',5.97),('11288','2013-09-23','12:30:00',6.01),('11288','2013-09-23','12:35:00',5.97),('11288','2013-09-23','12:40:00',5.94),('11288','2013-09-23','12:45:00',5.94),('11288','2013-09-23','12:50:00',5.95),('11288','2013-09-23','12:55:00',5.9),('11288','2013-09-23','13:00:00',5.92),('11288','2013-09-23','13:05:00',5.9),('11288','2013-09-23','13:10:00',5.85),('11288','2013-09-23','13:15:00',5.8),('11288','2013-09-23','13:20:00',5.77),('11288','2013-09-23','13:25:00',5.66),('11288','2013-09-23','13:30:00',5.72),('11288','2013-09-23','13:35:00',5.75),('11288','2013-09-23','13:40:00',5.75),('11288','2013-09-23','13:45:00',5.76),('11288','2013-09-23','13:50:00',5.7),('11288','2013-09-23','13:55:00',5.64),('11288','2013-09-23','14:00:00',5.6),('11288','2013-09-23','14:05:00',5.52),('11288','2013-09-23','14:10:00',5.44),('11288','2013-09-23','14:15:00',5.55),('11288','2013-09-23','14:20:00',5.47),('11288','2013-09-23','14:25:00',5.41),('11288','2013-09-23','14:30:00',5.44),('11288','2013-09-23','14:35:00',5.29),('11288','2013-09-23','14:40:00',5.15),('11288','2013-09-23','14:45:00',5.09),('11288','2013-09-23','14:50:00',5.02),('11288','2013-09-23','14:55:00',4.31),('11288','2013-09-23','15:00:00',5.1),('11288','2013-09-23','15:05:00',5.06),('11288','2013-09-23','15:10:00',3.28),('11288','2013-09-23','15:15:00',3.11),('11288','2013-09-23','15:20:00',4.11),('11288','2013-09-23','15:25:00',3.29),('11288','2013-09-23','15:30:00',4.36),('11288','2013-09-23','15:35:00',4.31),('11288','2013-09-23','15:40:00',4.38),('11288','2013-09-23','15:45:00',4.26),('11288','2013-09-23','15:50:00',4.11),('11288','2013-09-23','15:55:00',3.95),('11288','2013-09-23','16:00:00',3.83),('11288','2013-09-23','16:05:00',3.72),('11288','2013-09-23','16:10:00',3.55),('11288','2013-09-23','16:15:00',3.24),('11288','2013-09-23','16:20:00',3.37),('11288','2013-09-23','16:25:00',3.22),('11288','2013-09-23','16:30:00',3.07),('11288','2013-09-23','16:35:00',2.89),('11288','2013-09-23','16:40:00',2.74),('11288','2013-09-23','16:45:00',2.63),('11288','2013-09-23','16:50:00',2.49),('11288','2013-09-23','16:55:00',2.36),('11288','2013-09-23','17:00:00',2.23),('11288','2013-09-23','17:05:00',2.09),('11288','2013-09-23','17:10:00',1.94),('11288','2013-09-23','17:15:00',1.81),('11288','2013-09-23','17:20:00',1.69),('11288','2013-09-23','17:25:00',1.58),('11288','2013-09-23','17:30:00',1.48),('11288','2013-09-23','17:35:00',1.35),('11288','2013-09-23','17:40:00',1.22),('11288','2013-09-23','17:45:00',1.05),('11288','2013-09-22','08:15:00',1.07),('11288','2013-09-22','08:20:00',1.03),('11288','2013-09-22','08:25:00',1.17),('11288','2013-09-22','08:30:00',1.24),('11288','2013-09-22','08:35:00',1.35),('11288','2013-09-22','08:40:00',1.49),('11288','2013-09-22','08:45:00',1.65),('11288','2013-09-22','08:50:00',1.83),('11288','2013-09-22','08:55:00',1.97),('11288','2013-09-22','09:00:00',2.14),('11288','2013-09-22','09:05:00',2.27),('11288','2013-09-22','09:10:00',2.38),('11288','2013-09-22','09:15:00',2.32),('11288','2013-09-22','09:20:00',2.48),('11288','2013-09-22','09:25:00',2.86),('11288','2013-09-22','09:30:00',3.09),('11288','2013-09-22','09:35:00',3.26),('11288','2013-09-22','09:40:00',3.39),('11288','2013-09-22','09:45:00',3.49),('11288','2013-09-22','09:50:00',3.61),('11288','2013-09-22','09:55:00',3.74),('11288','2013-09-22','10:00:00',3.89),('11288','2013-09-22','10:05:00',4),('11288','2013-09-22','10:10:00',4.2),('11288','2013-09-22','10:15:00',4.34),('11288','2013-09-22','10:20:00',4.45),('11288','2013-09-22','10:25:00',4.57),('11288','2013-09-22','10:30:00',4.68),('11288','2013-09-22','10:35:00',4.78),('11288','2013-09-22','10:40:00',4.84),('11288','2013-09-22','10:45:00',4.9),('11288','2013-09-22','10:50:00',4.98),('11288','2013-09-22','10:55:00',5.03),('11288','2013-09-22','11:00:00',5.08),('11288','2013-09-22','11:05:00',5.13),('11288','2013-09-22','11:10:00',5.17),('11288','2013-09-22','11:15:00',5.25),('11288','2013-09-22','11:20:00',5.31),('11288','2013-09-22','11:25:00',5.38),('11288','2013-09-22','11:30:00',5.44),('11288','2013-09-22','11:35:00',5.52),('11288','2013-09-22','11:40:00',5.56),('11288','2013-09-22','11:45:00',5.68),('11288','2013-09-22','11:50:00',5.74),('11288','2013-09-22','11:55:00',5.77),('11288','2013-09-22','12:00:00',5.84),('11288','2013-09-22','12:05:00',5.95),('11288','2013-09-22','12:10:00',5.98),('11288','2013-09-22','12:15:00',6.01),('11288','2013-09-22','12:20:00',6.03),('11288','2013-09-22','12:25:00',6.07),('11288','2013-09-22','12:30:00',6.04),('11288','2013-09-22','12:35:00',6),('11288','2013-09-22','12:40:00',6.06),('11288','2013-09-22','12:45:00',6.09),('11288','2013-09-22','12:50:00',6.13),('11288','2013-09-22','12:55:00',6.16),('11288','2013-09-22','13:00:00',6.11),('11288','2013-09-22','13:05:00',6.11),('11288','2013-09-22','13:10:00',6.14),('11288','2013-09-22','13:15:00',6.06),('11288','2013-09-22','13:20:00',6.01),('11288','2013-09-22','13:25:00',5.94),('11288','2013-09-22','13:30:00',5.16),('11288','2013-09-22','13:35:00',5.97),('11288','2013-09-22','13:40:00',5.91),('11288','2013-09-22','13:45:00',5.94),('11288','2013-09-22','13:50:00',5.94),('11288','2013-09-22','13:55:00',5.91),('11288','2013-09-22','14:00:00',5.82),('11288','2013-09-22','14:05:00',5.87),('11288','2013-09-22','14:10:00',5.62),('11288','2013-09-22','14:15:00',5.58),('11288','2013-09-22','14:20:00',5.82),('11288','2013-09-22','14:25:00',6.23),('11288','2013-09-22','14:30:00',1.32),('11288','2013-09-22','14:35:00',4.71),('11288','2013-09-22','14:40:00',5.78),('11288','2013-09-22','14:45:00',5.08),('11288','2013-09-22','14:50:00',5.41),('11288','2013-09-22','14:55:00',5.35),('11288','2013-09-22','15:00:00',5.41),('11288','2013-09-22','15:05:00',5.49),('11288','2013-09-22','15:10:00',5.33),('11288','2013-09-22','15:15:00',5.56),('11288','2013-09-22','15:20:00',5.94),('11288','2013-09-22','15:25:00',3.77),('11288','2013-09-22','15:30:00',2.42),('11288','2013-09-22','15:35:00',2.1),('11288','2013-09-22','15:40:00',4.59),('11288','2013-09-22','15:45:00',4.62),('11288','2013-09-22','15:50:00',4.33),('11288','2013-09-22','15:55:00',4.3),('11288','2013-09-22','16:00:00',4.57),('11288','2013-09-22','16:05:00',4.84),('11288','2013-09-22','16:10:00',4.83),('11288','2013-09-22','16:15:00',4.56),('11288','2013-09-22','16:20:00',3.2),('11288','2013-09-22','16:25:00',2.53),('11288','2013-09-22','16:30:00',2.26),('11288','2013-09-22','16:35:00',2.11),('11288','2013-09-22','16:40:00',1.69),('11288','2013-09-22','16:45:00',2.36),('11288','2013-09-22','16:50:00',3.41),('11288','2013-09-22','16:55:00',2.15),('11288','2013-09-22','17:00:00',2.68),('11288','2013-09-22','17:05:00',2.64),('11288','2013-09-22','17:10:00',2.46),('11288','2013-09-22','17:15:00',1.56),('11288','2013-09-22','17:30:00',1.01),('11288','2013-09-22','17:35:00',1.25),('11288','2013-09-21','08:20:00',1.05),('11288','2013-09-21','08:25:00',1.1),('11288','2013-09-21','08:30:00',1.24),('11288','2013-09-21','08:35:00',1.41),('11288','2013-09-21','08:40:00',1.5),('11288','2013-09-21','08:45:00',1.68),('11288','2013-09-21','08:50:00',1.83),('11288','2013-09-21','08:55:00',1.98),('11288','2013-09-21','09:00:00',2.17),('11288','2013-09-21','09:05:00',2.3),('11288','2013-09-21','09:10:00',2.4),('11288','2013-09-21','09:15:00',2.44),('11288','2013-09-21','09:20:00',2.57),('11288','2013-09-21','09:25:00',2.88),('11288','2013-09-21','09:30:00',3.04),('11288','2013-09-21','09:35:00',3.21),('11288','2013-09-21','09:40:00',3.29),('11288','2013-09-21','09:45:00',3.46),('11288','2013-09-21','09:50:00',3.59),('11288','2013-09-21','09:55:00',3.7),('11288','2013-09-21','10:00:00',3.78),('11288','2013-09-21','10:05:00',3.93),('11288','2013-09-21','10:10:00',4.1),('11288','2013-09-21','10:15:00',4.23),('11288','2013-09-21','10:20:00',4.34),('11288','2013-09-21','10:25:00',4.44),('11288','2013-09-21','10:30:00',4.54),('11288','2013-09-21','10:35:00',4.63),('11288','2013-09-21','10:40:00',4.69),('11288','2013-09-21','10:45:00',4.77),('11288','2013-09-21','10:50:00',4.85),('11288','2013-09-21','10:55:00',4.92),('11288','2013-09-21','11:00:00',4.98),('11288','2013-09-21','11:05:00',5.01),('11288','2013-09-21','11:10:00',5.06),('11288','2013-09-21','11:15:00',5.12),('11288','2013-09-21','11:20:00',5.19),('11288','2013-09-21','11:25:00',5.23),('11288','2013-09-21','11:30:00',5.29),('11288','2013-09-21','11:35:00',5.34),('11288','2013-09-21','11:40:00',5.44),('11288','2013-09-21','11:45:00',5.49),('11288','2013-09-21','11:50:00',5.55),('11288','2013-09-21','11:55:00',5.52),('11288','2013-09-21','12:00:00',5.63),('11288','2013-09-21','12:05:00',5.78),('11288','2013-09-21','12:10:00',5.8),('11288','2013-09-21','12:15:00',5.87),('11288','2013-09-21','12:20:00',5.6),('11288','2013-09-21','12:25:00',5.53),('11288','2013-09-21','12:30:00',5.99),('11288','2013-09-21','12:35:00',5.83),('11288','2013-09-21','12:40:00',5.66),('11288','2013-09-21','12:45:00',5.78),('11288','2013-09-21','12:50:00',5.85),('11288','2013-09-21','12:55:00',5.97),('11288','2013-09-21','13:00:00',5.96),('11288','2013-09-21','13:05:00',5.79),('11288','2013-09-21','13:10:00',5.9),('11288','2013-09-21','13:15:00',6.05),('11288','2013-09-21','13:20:00',5.05),('11288','2013-09-21','13:25:00',5.74),('11288','2013-09-21','13:30:00',5.74),('11288','2013-09-21','13:35:00',5.61),('11288','2013-09-21','13:40:00',5.18),('11288','2013-09-21','13:45:00',5.18),('11288','2013-09-21','13:50:00',5.03),('11288','2013-09-21','13:55:00',4.94),('11288','2013-09-21','14:00:00',5.41),('11288','2013-09-21','14:05:00',5.54),('11288','2013-09-21','14:10:00',5.44),('11288','2013-09-21','14:15:00',5.6),('11288','2013-09-21','14:20:00',5.54),('11288','2013-09-21','14:25:00',5.49),('11288','2013-09-21','14:30:00',5.42),('11288','2013-09-21','14:35:00',5.35),('11288','2013-09-21','14:40:00',5.3),('11288','2013-09-21','14:45:00',5.2),('11288','2013-09-21','14:50:00',5.15),('11288','2013-09-21','14:55:00',5.06),('11288','2013-09-21','15:00:00',5.02),('11288','2013-09-21','15:05:00',4.93),('11288','2013-09-21','15:10:00',4.82),('11288','2013-09-21','15:15:00',4.72),('11288','2013-09-21','15:20:00',4.73),('11288','2013-09-21','15:25:00',4.62),('11288','2013-09-21','15:30:00',4.5),('11288','2013-09-21','15:35:00',4.38),('11288','2013-09-21','15:40:00',3.99),('11288','2013-09-21','15:45:00',3.11),('11288','2013-09-21','15:50:00',4.18),('11288','2013-09-21','15:55:00',3.81),('11288','2013-09-21','16:00:00',2.87),('11288','2013-09-21','16:05:00',2.08),('11288','2013-09-21','16:10:00',2.37),('11288','2013-09-21','16:15:00',2.2),('11288','2013-09-21','16:20:00',2.44),('11288','2013-09-21','16:25:00',1.33),('11288','2013-09-21','16:30:00',1.82),('11288','2013-09-21','16:35:00',2.22),('11288','2013-09-21','16:40:00',1.57),('11288','2013-09-21','16:45:00',1.3),('11288','2013-09-21','16:50:00',1.35),('11288','2013-09-21','16:55:00',1.84),('11288','2013-09-21','17:00:00',1.33),('11288','2013-09-21','17:05:00',1.37),('11288','2013-09-21','17:10:00',1.37),('11288','2013-09-21','17:15:00',1.45),('11288','2013-09-21','17:30:00',1.12),('11288','2013-09-21','17:35:00',1.26),('11288','2013-09-21','17:40:00',1.37),('11288','2013-09-21','17:45:00',1.27),('11288','2013-09-20','08:25:00',1.03),('11288','2013-09-20','08:30:00',1.55),('11288','2013-09-20','08:35:00',1.51),('11288','2013-09-20','08:40:00',1.71),('11288','2013-09-20','08:45:00',1.66),('11288','2013-09-20','08:50:00',1.61),('11288','2013-09-20','08:55:00',1.62),('11288','2013-09-20','09:00:00',1.8),('11288','2013-09-20','09:05:00',1.88),('11288','2013-09-20','09:10:00',1.92),('11288','2013-09-20','09:15:00',2.05),('11288','2013-09-20','09:20:00',2.06),('11288','2013-09-20','09:25:00',2.16),('11288','2013-09-20','09:30:00',2.1),('11288','2013-09-20','09:35:00',2.04),('11288','2013-09-20','09:40:00',2.11),('11288','2013-09-20','09:45:00',2.15),('11288','2013-09-20','09:50:00',2.27),('11288','2013-09-20','09:55:00',2.61),('11288','2013-09-20','10:00:00',3.06),('11288','2013-09-20','10:05:00',3.01),('11288','2013-09-20','10:10:00',3.52),('11288','2013-09-20','10:15:00',4.29),('11288','2013-09-20','10:20:00',5.35),('11288','2013-09-20','10:25:00',5.21),('11288','2013-09-20','10:30:00',5.42),('11288','2013-09-20','10:35:00',4.88),('11288','2013-09-20','10:40:00',5.82),('11288','2013-09-20','10:45:00',4.58),('11288','2013-09-20','10:50:00',4.27),('11288','2013-09-20','10:55:00',3.16),('11288','2013-09-20','11:00:00',3.1),('11288','2013-09-20','11:05:00',3.44),('11288','2013-09-20','11:10:00',3.87),('11288','2013-09-20','11:15:00',3.68),('11288','2013-09-20','11:20:00',3.52),('11288','2013-09-20','11:25:00',3.34),('11288','2013-09-20','11:30:00',4.57),('11288','2013-09-20','11:35:00',3.47),('11288','2013-09-20','11:40:00',6.49),('11288','2013-09-20','11:45:00',6.09),('11288','2013-09-20','11:50:00',5.91),('11288','2013-09-20','11:55:00',5.74),('11288','2013-09-20','12:00:00',5.74),('11288','2013-09-20','12:05:00',5.84),('11288','2013-09-20','12:10:00',5.9),('11288','2013-09-20','12:15:00',6.03),('11288','2013-09-20','12:20:00',6.21),('11288','2013-09-20','12:25:00',5.02),('11288','2013-09-20','12:30:00',5.12),('11288','2013-09-20','12:35:00',4.43),('11288','2013-09-20','12:40:00',4.2),('11288','2013-09-20','12:45:00',3.53),('11288','2013-09-20','12:50:00',6.38),('11288','2013-09-20','12:55:00',6.11),('11288','2013-09-20','13:00:00',5.46),('11288','2013-09-20','13:05:00',5.83),('11288','2013-09-20','13:10:00',5.66),('11288','2013-09-20','13:15:00',4.94),('11288','2013-09-20','13:20:00',4.06),('11288','2013-09-20','13:25:00',3.4),('11288','2013-09-20','13:30:00',6.05),('11288','2013-09-20','13:35:00',6.03),('11288','2013-09-20','13:40:00',5.44),('11288','2013-09-20','13:45:00',5.95),('11288','2013-09-20','13:50:00',5.53),('11288','2013-09-20','13:55:00',4.66),('11288','2013-09-20','14:00:00',1),('11288','2013-09-20','14:10:00',3.13),('11288','2013-09-20','14:15:00',6.13),('11288','2013-09-20','14:20:00',4.42),('11288','2013-09-20','14:25:00',5.49),('11288','2013-09-20','14:30:00',5.61),('11288','2013-09-20','14:35:00',5.01),('11288','2013-09-20','14:40:00',5.48),('11288','2013-09-20','14:45:00',5.6),('11288','2013-09-20','14:50:00',5.49),('11288','2013-09-20','14:55:00',5.53),('11288','2013-09-20','15:00:00',3.59),('11288','2013-09-20','15:05:00',5.81),('11288','2013-09-20','15:10:00',3.68),('11288','2013-09-20','15:15:00',3.27),('11288','2013-09-20','15:20:00',4.08),('11288','2013-09-20','15:25:00',3.63),('11288','2013-09-20','15:30:00',1.98),('11288','2013-09-20','15:35:00',4.72),('11288','2013-09-20','15:40:00',4.86),('11288','2013-09-20','15:45:00',4.57),('11288','2013-09-20','15:50:00',4.49),('11288','2013-09-20','15:55:00',4.54),('11288','2013-09-20','16:00:00',4.83),('11288','2013-09-20','16:05:00',3.09),('11288','2013-09-20','16:10:00',2.45),('11288','2013-09-20','16:15:00',3.62),('11288','2013-09-20','16:20:00',2.39),('11288','2013-09-20','16:25:00',2.9),('11288','2013-09-20','16:30:00',2.12),('11288','2013-09-20','16:35:00',1.39),('11288','2013-09-20','16:40:00',1.68),('11288','2013-09-20','16:45:00',2.98),('11288','2013-09-20','16:50:00',2.98),('11288','2013-09-20','16:55:00',3.12),('11288','2013-09-20','17:00:00',3.07),('11288','2013-09-20','17:05:00',3.17),('11288','2013-09-20','17:10:00',3.24),('11288','2013-09-20','17:15:00',3.07),('11288','2013-09-20','17:20:00',2.87),('11288','2013-09-20','17:25:00',2.58),('11288','2013-09-20','17:30:00',2.06),('11288','2013-09-20','17:35:00',1.5),('11288','2013-09-20','17:40:00',1.45),('11288','2013-09-20','17:45:00',1.63),('11288','2013-09-20','17:50:00',1.44),('11288','2013-09-20','17:55:00',1.39),('11288','2013-09-20','18:00:00',1.41),('11288','2013-09-20','18:05:00',1.53),('11288','2013-09-20','18:10:00',1.46),('11288','2013-09-20','18:15:00',1.3),('11288','2013-09-19','08:10:00',1.13),('11288','2013-09-19','08:20:00',1.07),('11288','2013-09-19','08:25:00',1.13),('11288','2013-09-19','08:30:00',1.39),('11288','2013-09-19','08:35:00',1.55),('11288','2013-09-19','08:40:00',1.53),('11288','2013-09-19','08:45:00',1.56),('11288','2013-09-19','08:50:00',1.48),('11288','2013-09-19','08:55:00',1.69),('11288','2013-09-19','09:00:00',1.66),('11288','2013-09-19','09:05:00',1.16),('11288','2013-09-19','09:10:00',2.3),('11288','2013-09-19','09:15:00',2.38),('11288','2013-09-19','09:20:00',1.91),('11288','2013-09-19','09:25:00',1.61),('11288','2013-09-19','09:30:00',1.56),('11288','2013-09-19','09:45:00',1.1),('11288','2013-09-19','09:55:00',1.11),('11288','2013-09-19','10:00:00',1.26),('11288','2013-09-19','10:05:00',3.7),('11288','2013-09-19','10:10:00',2.05),('11288','2013-09-19','10:15:00',1.82),('11288','2013-09-19','10:20:00',1.41),('11288','2013-09-19','10:25:00',1.84),('11288','2013-09-19','10:30:00',2.11),('11288','2013-09-19','10:35:00',5.3),('11288','2013-09-19','10:40:00',3.83),('11288','2013-09-19','10:45:00',2.94),('11288','2013-09-19','10:50:00',2.4),('11288','2013-09-19','10:55:00',5.64),('11288','2013-09-19','11:00:00',6.05),('11288','2013-09-19','11:05:00',3.39),('11288','2013-09-19','11:10:00',4.28),('11288','2013-09-19','11:15:00',2.81),('11288','2013-09-19','11:20:00',3.32),('11288','2013-09-19','11:25:00',3.98),('11288','2013-09-19','11:30:00',4.45),('11288','2013-09-19','11:35:00',4.44),('11288','2013-09-19','11:40:00',3.86),('11288','2013-09-19','11:45:00',5.03),('11288','2013-09-19','11:50:00',5.96),('11288','2013-09-19','11:55:00',4.34),('11288','2013-09-19','12:00:00',2.81),('11288','2013-09-19','12:05:00',3.17),('11288','2013-09-19','12:10:00',5.44),('11288','2013-09-19','12:15:00',3.46),('11288','2013-09-19','12:20:00',6.05),('11288','2013-09-19','12:25:00',5.44),('11288','2013-09-19','12:30:00',6.52),('11288','2013-09-19','12:35:00',6.27),('11288','2013-09-19','12:40:00',6.51),('11288','2013-09-19','12:45:00',5.22),('11288','2013-09-19','12:50:00',6.48),('11288','2013-09-19','12:55:00',6.43),('11288','2013-09-19','13:00:00',6.42),('11288','2013-09-19','13:05:00',6.53),('11288','2013-09-19','13:10:00',6.76),('11288','2013-09-19','13:15:00',6.74),('11288','2013-09-19','13:20:00',6.77),('11288','2013-09-19','13:25:00',6.27),('11288','2013-09-19','13:30:00',6.25),('11288','2013-09-19','13:35:00',6.39),('11288','2013-09-19','13:40:00',6.77),('11288','2013-09-19','13:45:00',6.92),('11288','2013-09-19','13:50:00',5.43),('11288','2013-09-19','13:55:00',2.09),('11288','2013-09-19','14:00:00',2.87),('11288','2013-09-19','14:05:00',6.54),('11288','2013-09-19','14:10:00',5.62),('11288','2013-09-19','14:15:00',5.46),('11288','2013-09-19','14:20:00',5.8),('11288','2013-09-19','14:25:00',5.69),('11288','2013-09-19','14:30:00',5.66),('11288','2013-09-19','14:35:00',5.63),('11288','2013-09-19','14:40:00',5.01),('11288','2013-09-19','14:45:00',5.45),('11288','2013-09-19','14:50:00',5.43),('11288','2013-09-19','14:55:00',5.48),('11288','2013-09-19','15:00:00',5.36),('11288','2013-09-19','15:05:00',5.26),('11288','2013-09-19','15:10:00',4.59),('11288','2013-09-19','15:15:00',4.97),('11288','2013-09-19','15:20:00',5.15),('11288','2013-09-19','15:25:00',4.72),('11288','2013-09-19','15:30:00',4.29),('11288','2013-09-19','15:35:00',4.02),('11288','2013-09-19','15:40:00',5.03),('11288','2013-09-19','15:45:00',4.73),('11288','2013-09-19','15:50:00',4.18),('11288','2013-09-19','15:55:00',3.99),('11288','2013-09-19','16:00:00',4.1),('11288','2013-09-19','16:05:00',3.94),('11288','2013-09-19','16:10:00',3.9),('11288','2013-09-19','16:15:00',3.8),('11288','2013-09-19','16:20:00',3.88),('11288','2013-09-19','16:25:00',3.45),('11288','2013-09-19','16:30:00',3.15),('11288','2013-09-19','16:35:00',3.1),('11288','2013-09-19','16:40:00',2.26),('11288','2013-09-19','16:45:00',2.84),('11288','2013-09-19','16:50:00',3.1),('11288','2013-09-19','16:55:00',2.91),('11288','2013-09-19','17:00:00',2.35),('11288','2013-09-19','17:05:00',2.34),('11288','2013-09-19','17:10:00',2.18),('11288','2013-09-19','17:15:00',2.09),('11288','2013-09-19','17:20:00',1.86),('11288','2013-09-19','17:25:00',1.79),('11288','2013-09-19','17:30:00',1.54),('11288','2013-09-19','17:35:00',1.46),('11288','2013-09-19','17:40:00',1.28),('11288','2013-09-19','17:45:00',1.01),('11288','2013-09-19','17:50:00',1.04),('11288','2014-04-13','08:30:00',1.19),('11288','2014-04-13','08:35:00',1.2),('11288','2014-04-13','08:40:00',1.22),('11288','2014-04-13','08:45:00',1.25),('11288','2014-04-13','08:50:00',1.2),('11288','2014-04-13','08:55:00',1.31),('11288','2014-04-13','09:00:00',1.66),('11288','2014-04-13','09:05:00',2.23),('11288','2014-04-13','09:10:00',2.65),('11288','2014-04-13','09:15:00',2.24),('11288','2014-04-13','09:20:00',2.36),('11288','2014-04-13','09:25:00',2.63),('11288','2014-04-13','09:30:00',3.31),('11288','2014-04-13','09:35:00',2.91),('11288','2014-04-13','09:40:00',3.46),('11288','2014-04-13','09:45:00',3.16),('11288','2014-04-13','09:50:00',2.42),('11288','2014-04-13','09:55:00',2.5),('11288','2014-04-13','10:00:00',3.89),('11288','2014-04-13','10:05:00',5.14),('11288','2014-04-13','10:10:00',4.4),('11288','2014-04-13','10:15:00',4.04),('11288','2014-04-13','10:20:00',4.35),('11288','2014-04-13','10:25:00',3.14),('11288','2014-04-13','10:30:00',4.86),('11288','2014-04-13','10:35:00',5.36),('11288','2014-04-13','10:40:00',5.41),('11288','2014-04-13','10:45:00',5.7),('11288','2014-04-13','10:50:00',5.74),('11288','2014-04-13','10:55:00',5.82),('11288','2014-04-13','11:00:00',5.9),('11288','2014-04-13','11:05:00',6.12),('11288','2014-04-13','11:10:00',5.94),('11288','2014-04-13','11:15:00',6.17),('11288','2014-04-13','11:20:00',7.28),('11288','2014-04-13','11:25:00',4.26),('11288','2014-04-13','11:30:00',3.61),('11288','2014-04-13','11:35:00',5.27),('11288','2014-04-13','11:40:00',6.42),('11288','2014-04-13','11:45:00',5.68),('11288','2014-04-13','11:50:00',6.34),('11288','2014-04-13','11:55:00',4.88),('11288','2014-04-13','12:00:00',3.54),('11288','2014-04-13','12:05:00',2.92),('11288','2014-04-13','12:10:00',2.59),('11288','2014-04-13','12:15:00',2.49),('11288','2014-04-13','12:20:00',2.29),('11288','2014-04-13','12:25:00',1.67),('11288','2014-04-13','12:30:00',1.15),('11288','2014-04-13','12:45:00',1.03),('11288','2014-04-13','12:50:00',1.17),('11288','2014-04-13','12:55:00',1.34),('11288','2014-04-13','13:00:00',1.47),('11288','2014-04-13','13:05:00',2.38),('11288','2014-04-13','13:10:00',3.53),('11288','2014-04-13','13:15:00',3.59),('11288','2014-04-13','13:20:00',4.64),('11288','2014-04-13','13:25:00',5.47),('11288','2014-04-13','13:30:00',7.51),('11288','2014-04-13','13:35:00',6.83),('11288','2014-04-13','13:40:00',6.24),('11288','2014-04-13','13:45:00',3.55),('11288','2014-04-13','13:50:00',5.12),('11288','2014-04-13','13:55:00',4.37),('11288','2014-04-13','14:00:00',6.86),('11288','2014-04-13','14:05:00',6.43),('11288','2014-04-13','14:10:00',6.49),('11288','2014-04-13','14:15:00',7.07),('11288','2014-04-13','14:20:00',3.35),('11288','2014-04-13','14:25:00',2.94),('11288','2014-04-13','14:30:00',3.07),('11288','2014-04-13','14:35:00',2.81),('11288','2014-04-13','14:40:00',2.44),('11288','2014-04-13','14:45:00',4.04),('11288','2014-04-13','14:50:00',6.43),('11288','2014-04-13','14:55:00',5.57),('11288','2014-04-13','15:00:00',5.51),('11288','2014-04-13','15:05:00',6.17),('11288','2014-04-13','15:10:00',6.3),('11288','2014-04-13','15:15:00',5.36),('11288','2014-04-13','15:20:00',5.29),('11288','2014-04-13','15:25:00',5.78),('11288','2014-04-13','15:30:00',5.43),('11288','2014-04-13','15:35:00',3.69),('11288','2014-04-13','15:40:00',2.43),('11288','2014-04-13','15:45:00',2.5),('11288','2014-04-13','15:50:00',3.07),('11288','2014-04-13','15:55:00',3.09),('11288','2014-04-13','16:00:00',5.53),('11288','2014-04-13','16:05:00',4.8),('11288','2014-04-13','16:10:00',2.14),('11288','2014-04-13','16:15:00',2.21),('11288','2014-04-13','16:20:00',2.27),('11288','2014-04-13','16:25:00',3.06),('11288','2014-04-13','16:30:00',2.5),('11288','2014-04-13','16:35:00',2.49),('11288','2014-04-13','16:40:00',4.02),('11288','2014-04-13','16:45:00',4.42),('11288','2014-04-13','16:50:00',3.84),('11288','2014-04-13','16:55:00',3.79),('11288','2014-04-13','17:00:00',2.87),('11288','2014-04-13','17:05:00',2.54),('11288','2014-04-13','17:10:00',1.75),('11288','2014-04-13','17:15:00',1.74),('11288','2014-04-13','17:20:00',2.47),('11288','2014-04-13','17:25:00',2.19),('11288','2014-04-13','17:30:00',1.53),('11288','2014-04-13','17:35:00',1.13),('11288','2014-04-13','17:40:00',1.27),('11288','2014-04-13','17:45:00',1.47),('11288','2014-04-13','17:50:00',1.58),('11288','2014-04-13','17:55:00',1.81),('11288','2014-04-13','18:00:00',1.78),('11288','2014-04-13','18:05:00',1.73),('11288','2013-09-18','08:15:00',1),('11288','2013-09-18','08:20:00',1.08),('11288','2013-09-18','08:25:00',1.06),('11288','2013-09-18','08:30:00',1.33),('11288','2013-09-18','08:35:00',1.05),('11288','2013-09-18','08:40:00',1.32),('11288','2013-09-18','08:45:00',1.71),('11288','2013-09-18','08:50:00',1.7),('11288','2013-09-18','08:55:00',1.79),('11288','2013-09-18','09:00:00',2.46),('11288','2013-09-18','09:05:00',1.9),('11288','2013-09-18','09:10:00',1.54),('11288','2013-09-18','09:15:00',2.02),('11288','2013-09-18','09:20:00',3.35),('11288','2013-09-18','09:25:00',2.27),('11288','2013-09-18','09:30:00',1.86),('11288','2013-09-18','09:35:00',3.43),('11288','2013-09-18','09:40:00',2),('11288','2013-09-18','09:45:00',1.13),('11288','2013-09-18','09:50:00',1.73),('11288','2013-09-18','09:55:00',3.01),('11288','2013-09-18','10:00:00',3.47),('11288','2013-09-18','10:05:00',4.61),('11288','2013-09-18','10:10:00',4.39),('11288','2013-09-18','10:15:00',4.25),('11288','2013-09-18','10:20:00',4.39),('11288','2013-09-18','10:25:00',4.45),('11288','2013-09-18','10:30:00',4.53),('11288','2013-09-18','10:35:00',4.6),('11288','2013-09-18','10:40:00',4.7),('11288','2013-09-18','10:45:00',4.76),('11288','2013-09-18','10:50:00',4.81),('11288','2013-09-18','10:55:00',5.17),('11288','2013-09-18','11:00:00',5.22),('11288','2013-09-18','11:05:00',5.32),('11288','2013-09-18','11:10:00',4.61),('11288','2013-09-18','11:15:00',3.33),('11288','2013-09-18','11:20:00',4.97),('11288','2013-09-18','11:25:00',5.88),('11288','2013-09-18','11:30:00',5.56),('11288','2013-09-18','11:35:00',4.8),('11288','2013-09-18','11:40:00',4.1),('11288','2013-09-18','11:45:00',5.75),('11288','2013-09-18','11:50:00',5.75),('11288','2013-09-18','11:55:00',5.57),('11288','2013-09-18','12:00:00',5.95),('11288','2013-09-18','12:05:00',6.17),('11288','2013-09-18','12:10:00',6.12),('11288','2013-09-18','12:15:00',6.3),('11288','2013-09-18','12:20:00',6.28),('11288','2013-09-18','12:25:00',2.58),('11288','2013-09-18','12:30:00',4.74),('11288','2013-09-18','12:35:00',6.92),('11288','2013-09-18','12:40:00',4.62),('11288','2013-09-18','12:45:00',6.24),('11288','2013-09-18','12:50:00',4.15),('11288','2013-09-18','12:55:00',4.1),('11288','2013-09-18','13:00:00',2.26),('11288','2013-09-18','13:05:00',6.71),('11288','2013-09-18','13:10:00',6.53),('11288','2013-09-18','13:15:00',6.36),('11288','2013-09-18','13:20:00',6.22),('11288','2013-09-18','13:25:00',6.28),('11288','2013-09-18','13:30:00',6.19),('11288','2013-09-18','13:35:00',6.2),('11288','2013-09-18','13:40:00',6.23),('11288','2013-09-18','13:45:00',6.32),('11288','2013-09-18','13:50:00',6.5),('11288','2013-09-18','13:55:00',6.26),('11288','2013-09-18','14:00:00',5.42),('11288','2013-09-18','14:05:00',4.4),('11288','2013-09-18','14:10:00',6.02),('11288','2013-09-18','14:15:00',5.33),('11288','2013-09-18','14:20:00',5.45),('11288','2013-09-18','14:25:00',5.79),('11288','2013-09-18','14:30:00',5.69),('11288','2013-09-18','14:35:00',5.66),('11288','2013-09-18','14:40:00',5.66),('11288','2013-09-18','14:45:00',5.45),('11288','2013-09-18','14:50:00',5.53),('11288','2013-09-18','14:55:00',4.3),('11288','2013-09-18','15:00:00',4.2),('11288','2013-09-18','15:05:00',3.71),('11288','2013-09-18','15:10:00',2.27),('11288','2013-09-18','15:15:00',4.98),('11288','2013-09-18','15:20:00',3.27),('11288','2013-09-18','15:25:00',4.56),('11288','2013-09-18','15:30:00',5.09),('11288','2013-09-18','15:35:00',4.53),('11288','2013-09-18','15:40:00',4.8),('11288','2013-09-18','15:45:00',4.57),('11288','2013-09-18','15:50:00',3.15),('11288','2013-09-18','15:55:00',4.19),('11288','2013-09-18','16:00:00',4.54),('11288','2013-09-18','16:05:00',4.54),('11288','2013-09-18','16:10:00',4.16),('11288','2013-09-18','16:15:00',3.93),('11288','2013-09-18','16:20:00',3.72),('11288','2013-09-18','16:25:00',3.24),('11288','2013-09-18','16:30:00',3.12),('11288','2013-09-18','16:35:00',2.9),('11288','2013-09-18','16:40:00',3.01),('11288','2013-09-18','16:45:00',2.93),('11288','2013-09-18','16:50:00',2.59),('11288','2013-09-18','16:55:00',2.54),('11288','2013-09-18','17:00:00',2.64),('11288','2013-09-18','17:05:00',2.36),('11288','2013-09-18','17:10:00',2.35),('11288','2013-09-18','17:15:00',2.02),('11288','2013-09-18','17:20:00',1.88),('11288','2013-09-18','17:25:00',1.84),('11288','2013-09-18','17:30:00',1.83),('11288','2013-09-18','17:35:00',1.65),('11288','2013-09-18','17:40:00',1.51),('11288','2013-09-18','17:45:00',1.37),('11288','2013-09-18','17:50:00',1.22),('11288','2013-09-18','17:55:00',1.01),('11288','2013-09-17','08:40:00',1.2),('11288','2013-09-17','08:45:00',1.24),('11288','2013-09-17','08:50:00',1.12),('11288','2013-09-17','08:55:00',1.18),('11288','2013-09-17','09:00:00',1.28),('11288','2013-09-17','09:05:00',1.24),('11288','2013-09-17','09:10:00',1.24),('11288','2013-09-17','09:15:00',1.51),('11288','2013-09-17','09:20:00',2.15),('11288','2013-09-17','09:25:00',1.56),('11288','2013-09-17','09:30:00',1.92),('11288','2013-09-17','09:35:00',1.25),('11288','2013-09-17','09:40:00',1.94),('11288','2013-09-17','09:45:00',2.65),('11288','2013-09-17','09:50:00',1.84),('11288','2013-09-17','09:55:00',3.03),('11288','2013-09-17','10:00:00',3.33),('11288','2013-09-17','10:05:00',2.38),('11288','2013-09-17','10:10:00',2.48),('11288','2013-09-17','10:15:00',1.01),('11288','2013-09-17','10:20:00',2.39),('11288','2013-09-17','10:25:00',3.83),('11288','2013-09-17','10:30:00',4.88),('11288','2013-09-17','10:35:00',2.62),('11288','2013-09-17','10:40:00',2.75),('11288','2013-09-17','10:45:00',3.95),('11288','2013-09-17','10:50:00',5.8),('11288','2013-09-17','10:55:00',4.71),('11288','2013-09-17','11:00:00',3.76),('11288','2013-09-17','11:05:00',3.67),('11288','2013-09-17','11:10:00',5.12),('11288','2013-09-17','11:15:00',4.39),('11288','2013-09-17','11:20:00',3.89),('11288','2013-09-17','11:25:00',2.79),('11288','2013-09-17','11:30:00',3.12),('11288','2013-09-17','11:35:00',4.52),('11288','2013-09-17','11:40:00',4.42),('11288','2013-09-17','11:45:00',4.74),('11288','2013-09-17','11:50:00',5.55),('11288','2013-09-17','11:55:00',5.45),('11288','2013-09-17','12:00:00',5.24),('11288','2013-09-17','12:05:00',4.85),('11288','2013-09-17','12:10:00',2.97),('11288','2013-09-17','12:15:00',3.22),('11288','2013-09-17','12:20:00',3.44),('11288','2013-09-17','12:25:00',6.58),('11288','2013-09-17','12:30:00',3.62),('11288','2013-09-17','12:35:00',3.98),('11288','2013-09-17','12:40:00',5.09),('11288','2013-09-17','12:45:00',7),('11288','2013-09-17','12:50:00',4.6),('11288','2013-09-17','12:55:00',5.23),('11288','2013-09-17','13:00:00',3.29),('11288','2013-09-17','13:05:00',2.43),('11288','2013-09-17','13:10:00',5.07),('11288','2013-09-17','13:15:00',4.26),('11288','2013-09-17','13:20:00',4.18),('11288','2013-09-17','13:25:00',3.57),('11288','2013-09-17','13:30:00',2.63),('11288','2013-09-17','13:35:00',3.73),('11288','2013-09-17','13:40:00',3.75),('11288','2013-09-17','13:45:00',2.27),('11288','2013-09-17','13:50:00',1.63),('11288','2013-09-17','13:55:00',2.65),('11288','2013-09-17','14:00:00',3.02),('11288','2013-09-17','14:05:00',2.25),('11288','2013-09-17','14:10:00',1.64),('11288','2013-09-17','14:15:00',2.29),('11288','2013-09-17','14:20:00',1.64),('11288','2013-09-17','14:25:00',3.04),('11288','2013-09-17','14:30:00',1.65),('11288','2013-09-17','14:35:00',2.05),('11288','2013-09-17','14:40:00',1.45),('11288','2013-09-17','14:45:00',1.49),('11288','2013-09-17','14:50:00',2.93),('11288','2013-09-17','14:55:00',5.84),('11288','2013-09-17','15:00:00',5.39),('11288','2013-09-17','15:05:00',4.57),('11288','2013-09-17','15:10:00',4.03),('11288','2013-09-17','15:15:00',4.89),('11288','2013-09-17','15:20:00',4.89),('11288','2013-09-17','15:25:00',4.37),('11288','2013-09-17','15:30:00',4.23),('11288','2013-09-17','15:35:00',2.19),('11288','2013-09-17','15:40:00',1.27),('11288','2013-09-17','15:45:00',2.44),('11288','2013-09-17','15:50:00',2.97),('11288','2013-09-17','15:55:00',3.25),('11288','2013-09-17','16:00:00',2.32),('11288','2013-09-17','16:05:00',3.27),('11288','2013-09-17','16:10:00',2.79),('11288','2013-09-17','16:15:00',2.53),('11288','2013-09-17','16:20:00',1.7),('11288','2013-09-17','16:25:00',1.16),('11288','2013-09-17','16:35:00',1.41),('11288','2013-09-17','16:40:00',2.11),('11288','2013-09-17','16:45:00',2.5),('11288','2013-09-17','16:50:00',2.05),('11288','2013-09-17','16:55:00',1.75),('11288','2013-09-17','17:00:00',2.42),('11288','2013-09-17','17:05:00',2.62),('11288','2013-09-17','17:10:00',2.43),('11288','2013-09-17','17:15:00',2.41),('11288','2013-09-17','17:20:00',1.93),('11288','2013-09-17','17:25:00',2.02),('11288','2013-09-17','17:30:00',1.68),('11288','2013-09-17','17:35:00',1.67),('11288','2013-09-17','17:40:00',1.56),('11288','2013-09-17','17:45:00',1.12),('11288','2013-09-17','17:50:00',1.2),('11288','2013-09-17','17:55:00',1.16),('11288','2013-09-16','08:10:00',1.18),('11288','2013-09-16','08:15:00',1.04),('11288','2013-09-16','08:20:00',1.23),('11288','2013-09-16','08:25:00',1.31),('11288','2013-09-16','08:30:00',1.44),('11288','2013-09-16','08:35:00',1.6),('11288','2013-09-16','08:40:00',1.71),('11288','2013-09-16','08:45:00',1.78),('11288','2013-09-16','08:50:00',1.36),('11288','2013-09-16','08:55:00',1.45),('11288','2013-09-16','09:00:00',1.4),('11288','2013-09-16','09:05:00',2.8),('11288','2013-09-16','09:10:00',2.06),('11288','2013-09-16','09:15:00',2.2),('11288','2013-09-16','09:20:00',2.78),('11288','2013-09-16','09:25:00',2.75),('11288','2013-09-16','09:30:00',2.2),('11288','2013-09-16','09:35:00',3.32),('11288','2013-09-16','09:40:00',3.44),('11288','2013-09-16','09:45:00',3.61),('11288','2013-09-16','09:50:00',3.75),('11288','2013-09-16','09:55:00',3.79),('11288','2013-09-16','10:00:00',4.1),('11288','2013-09-16','10:05:00',4.45),('11288','2013-09-16','10:10:00',2.59),('11288','2013-09-16','10:15:00',2.61),('11288','2013-09-16','10:20:00',3.6),('11288','2013-09-16','10:25:00',4.12),('11288','2013-09-16','10:30:00',5.08),('11288','2013-09-16','10:35:00',5.39),('11288','2013-09-16','10:40:00',5.68),('11288','2013-09-16','10:45:00',6.11),('11288','2013-09-16','10:50:00',3.97),('11288','2013-09-16','10:55:00',2.57),('11288','2013-09-16','11:00:00',3.29),('11288','2013-09-16','11:05:00',2.47),('11288','2013-09-16','11:10:00',1.08),('11288','2013-09-16','11:15:00',1.41),('11288','2013-09-16','11:20:00',1.54),('11288','2013-09-16','11:25:00',4.6),('11288','2013-09-16','11:30:00',3.93),('11288','2013-09-16','11:35:00',5.99),('11288','2013-09-16','11:40:00',6.05),('11288','2013-09-16','11:45:00',5.52),('11288','2013-09-16','11:50:00',6.11),('11288','2013-09-16','11:55:00',6.07),('11288','2013-09-16','12:00:00',6.28),('11288','2013-09-16','12:05:00',6.23),('11288','2013-09-16','12:10:00',6.08),('11288','2013-09-16','12:15:00',5.93),('11288','2013-09-16','12:20:00',6.24),('11288','2013-09-16','12:25:00',6.23),('11288','2013-09-16','12:30:00',6.18),('11288','2013-09-16','12:35:00',6.26),('11288','2013-09-16','12:40:00',6.52),('11288','2013-09-16','12:45:00',6.44),('11288','2013-09-16','12:50:00',7.45),('11288','2013-09-16','12:55:00',7.26),('11288','2013-09-16','13:00:00',7.01),('11288','2013-09-16','13:05:00',4.51),('11288','2013-09-16','13:10:00',6.85),('11288','2013-09-16','13:15:00',6.26),('11288','2013-09-16','13:20:00',6.17),('11288','2013-09-16','13:25:00',6.17),('11288','2013-09-16','13:30:00',6.13),('11288','2013-09-16','13:35:00',6.13),('11288','2013-09-16','13:40:00',6.11),('11288','2013-09-16','13:45:00',6.11),('11288','2013-09-16','13:50:00',6.14),('11288','2013-09-16','13:55:00',6.28),('11288','2013-09-16','14:00:00',6.18),('11288','2013-09-16','14:05:00',5.92),('11288','2013-09-16','14:10:00',5.83),('11288','2013-09-16','14:15:00',5.8),('11288','2013-09-16','14:20:00',5.74),('11288','2013-09-16','14:25:00',5.73),('11288','2013-09-16','14:30:00',5.67),('11288','2013-09-16','14:35:00',5.61),('11288','2013-09-16','14:40:00',5.53),('11288','2013-09-16','14:45:00',5.49),('11288','2013-09-16','14:50:00',5.48),('11288','2013-09-16','14:55:00',5.15),('11288','2013-09-16','15:00:00',5.36),('11288','2013-09-16','15:05:00',5.29),('11288','2013-09-16','15:10:00',5.24),('11288','2013-09-16','15:15:00',5.18),('11288','2013-09-16','15:20:00',5.07),('11288','2013-09-16','15:25:00',5),('11288','2013-09-16','15:30:00',4.89),('11288','2013-09-16','15:35:00',4.82),('11288','2013-09-16','15:40:00',4.73),('11288','2013-09-16','15:45:00',4.62),('11288','2013-09-16','15:50:00',4.53),('11288','2013-09-16','15:55:00',4.43),('11288','2013-09-16','16:00:00',4.35),('11288','2013-09-16','16:05:00',3.47),('11288','2013-09-16','16:10:00',4.2),('11288','2013-09-16','16:15:00',3.96),('11288','2013-09-16','16:20:00',3.84),('11288','2013-09-16','16:25:00',3.72),('11288','2013-09-16','16:30:00',3.58),('11288','2013-09-16','16:35:00',3.44),('11288','2013-09-16','16:40:00',3.35),('11288','2013-09-16','16:45:00',3.19),('11288','2013-09-16','16:50:00',3.05),('11288','2013-09-16','16:55:00',2.91),('11288','2013-09-16','17:00:00',2.77),('11288','2013-09-16','17:05:00',2.64),('11288','2013-09-16','17:10:00',2.47),('11288','2013-09-16','17:15:00',2.32),('11288','2013-09-16','17:20:00',2.19),('11288','2013-09-16','17:25:00',2.05),('11288','2013-09-16','17:30:00',1.87),('11288','2013-09-16','17:45:00',1.4),('11288','2013-09-16','17:50:00',1.18),('11288','2013-09-16','17:55:00',1.17),('11288','2013-09-16','18:00:00',1.02),('11288','2013-09-15','08:10:00',1),('11288','2013-09-15','08:15:00',1.07),('11288','2013-09-15','08:20:00',1.17),('11288','2013-09-15','08:25:00',1.31),('11288','2013-09-15','08:30:00',1.46),('11288','2013-09-15','08:35:00',1.63),('11288','2013-09-15','08:40:00',1.82),('11288','2013-09-15','08:45:00',1.93),('11288','2013-09-15','08:50:00',1.91),('11288','2013-09-15','08:55:00',1.93),('11288','2013-09-15','09:00:00',2.16),('11288','2013-09-15','09:05:00',2.23),('11288','2013-09-15','09:10:00',2.53),('11288','2013-09-15','09:15:00',2.83),('11288','2013-09-15','09:20:00',2.75),('11288','2013-09-15','09:25:00',2.92),('11288','2013-09-15','09:30:00',3.01),('11288','2013-09-15','09:35:00',3.34),('11288','2013-09-15','09:40:00',3.51),('11288','2013-09-15','09:45:00',3.63),('11288','2013-09-15','09:50:00',3.72),('11288','2013-09-15','09:55:00',3.89),('11288','2013-09-15','10:00:00',4.05),('11288','2013-09-15','10:05:00',4.24),('11288','2013-09-15','10:10:00',4.33),('11288','2013-09-15','10:15:00',4.26),('11288','2013-09-15','10:20:00',4.39),('11288','2013-09-15','10:25:00',4.44),('11288','2013-09-15','10:30:00',4.25),('11288','2013-09-15','10:35:00',2.09),('11288','2013-09-15','10:40:00',1.95),('11288','2013-09-15','10:45:00',1.11),('11288','2013-09-15','10:50:00',3.85),('11288','2013-09-15','10:55:00',5.71),('11288','2013-09-15','11:00:00',5.81),('11288','2013-09-15','11:05:00',5.57),('11288','2013-09-15','11:10:00',2.56),('11288','2013-09-15','11:15:00',1.77),('11288','2013-09-15','11:20:00',2.1),('11288','2013-09-15','11:25:00',1.49),('11288','2013-09-15','11:30:00',3.79),('11288','2013-09-15','11:35:00',3.1),('11288','2013-09-15','11:40:00',2.49),('11288','2013-09-15','11:45:00',4.34),('11288','2013-09-15','11:50:00',3.04),('11288','2013-09-15','11:55:00',2.71),('11288','2013-09-15','12:00:00',2.22),('11288','2013-09-15','12:05:00',2.05),('11288','2013-09-15','12:10:00',2.02),('11288','2013-09-15','12:15:00',2.22),('11288','2013-09-15','12:20:00',2.78),('11288','2013-09-15','12:25:00',3.01),('11288','2013-09-15','12:30:00',2.78),('11288','2013-09-15','12:35:00',2.54),('11288','2013-09-15','12:40:00',2.52),('11288','2013-09-15','12:45:00',2.09),('11288','2013-09-15','12:50:00',2.66),('11288','2013-09-15','12:55:00',2.34),('11288','2013-09-15','13:00:00',2.13),('11288','2013-09-15','13:05:00',1.72),('11288','2013-09-15','13:10:00',1.14),('11288','2013-09-15','13:20:00',1.32),('11288','2013-09-15','13:25:00',2.02),('11288','2013-09-15','13:30:00',1.97),('11288','2013-09-15','13:35:00',2.03),('11288','2013-09-15','13:40:00',2.38),('11288','2013-09-15','13:45:00',3.22),('11288','2013-09-15','13:50:00',2.78),('11288','2013-09-15','13:55:00',2.11),('11288','2013-09-15','14:00:00',3.32),('11288','2013-09-15','14:05:00',3.01),('11288','2013-09-15','14:10:00',2.64),('11288','2013-09-15','14:15:00',2.61),('11288','2013-09-15','14:20:00',2.52),('11288','2013-09-15','14:25:00',2.45),('11288','2013-09-15','14:30:00',2.26),('11288','2013-09-15','14:35:00',1.91),('11288','2013-09-15','14:40:00',1.94),('11288','2013-09-15','14:45:00',1.82),('11288','2013-09-15','14:50:00',1.92),('11288','2013-09-15','14:55:00',1.92),('11288','2013-09-15','15:00:00',1.96),('11288','2013-09-15','15:05:00',2.08),('11288','2013-09-15','15:10:00',2.44),('11288','2013-09-15','15:15:00',4.98),('11288','2013-09-15','15:20:00',3.41),('11288','2013-09-15','15:25:00',2.57),('11288','2013-09-15','15:30:00',1.93),('11288','2013-09-15','15:35:00',1.94),('11288','2013-09-15','15:40:00',1.8),('11288','2013-09-15','15:45:00',1.73),('11288','2013-09-15','15:50:00',1.71),('11288','2013-09-15','15:55:00',1.68),('11288','2013-09-15','16:00:00',1.41),('11288','2013-09-15','16:05:00',1.65),('11288','2013-09-15','16:10:00',1.27),('11288','2013-09-15','16:30:00',1.09),('11288','2013-09-15','16:35:00',1.12),('11288','2013-09-15','16:40:00',1.38),('11288','2013-09-15','16:45:00',1.13),('11288','2013-09-15','17:00:00',1),('11288','2013-09-15','17:15:00',1.04),('11288','2013-09-15','17:20:00',1.33),('11288','2013-09-15','17:25:00',1.02),('11288','2013-09-15','17:30:00',1.02),('11288','2013-09-15','18:00:00',1.03),('11288','2013-09-14','08:10:00',1.01),('11288','2013-09-14','08:15:00',1.08),('11288','2013-09-14','08:20:00',1.23),('11288','2013-09-14','08:25:00',1.36),('11288','2013-09-14','08:30:00',1.53),('11288','2013-09-14','08:35:00',1.61),('11288','2013-09-14','08:40:00',1.69),('11288','2013-09-14','08:45:00',1.89),('11288','2013-09-14','08:50:00',1.98),('11288','2013-09-14','08:55:00',2.02),('11288','2013-09-14','09:00:00',2.27),('11288','2013-09-14','09:05:00',2.38),('11288','2013-09-14','09:10:00',2.53),('11288','2013-09-14','09:15:00',2.64),('11288','2013-09-14','09:20:00',2.75),('11288','2013-09-14','09:25:00',2.88),('11288','2013-09-14','09:30:00',3.08),('11288','2013-09-14','09:35:00',3.21),('11288','2013-09-14','09:40:00',3.44),('11288','2013-09-14','09:45:00',3.59),('11288','2013-09-14','09:50:00',3.7),('11288','2013-09-14','09:55:00',2.92),('11288','2013-09-14','10:00:00',3.91),('11288','2013-09-14','10:05:00',4.09),('11288','2013-09-14','10:10:00',3.87),('11288','2013-09-14','10:15:00',3.99),('11288','2013-09-14','10:20:00',4.33),('11288','2013-09-14','10:25:00',4.52),('11288','2013-09-14','10:30:00',4.61),('11288','2013-09-14','10:35:00',4.97),('11288','2013-09-14','10:40:00',4.87),('11288','2013-09-14','10:45:00',4.17),('11288','2013-09-14','10:50:00',5.82),('11288','2013-09-14','10:55:00',4.3),('11288','2013-09-14','11:00:00',3.84),('11288','2013-09-14','11:05:00',1.98),('11288','2013-09-14','11:10:00',3.92),('11288','2013-09-14','11:15:00',1.21),('11288','2013-09-14','11:20:00',2.54),('11288','2013-09-14','11:25:00',4.72),('11288','2013-09-14','11:30:00',5.39),('11288','2013-09-14','11:35:00',5.82),('11288','2013-09-14','11:40:00',5.76),('11288','2013-09-14','11:45:00',5.97),('11288','2013-09-14','11:50:00',2.16),('11288','2013-09-14','11:55:00',1.55),('11288','2013-09-14','12:00:00',1.28),('11288','2013-09-14','12:05:00',1.88),('11288','2013-09-14','12:10:00',3.11),('11288','2013-09-14','12:15:00',1.46),('11288','2013-09-14','12:20:00',1.32),('11288','2013-09-14','12:25:00',1.05),('11288','2013-09-14','12:30:00',2.43),('11288','2013-09-14','12:35:00',4.56),('11288','2013-09-14','12:40:00',1.78),('11288','2013-09-14','12:45:00',1.55),('11288','2013-09-14','12:50:00',1.29),('11288','2013-09-14','12:55:00',1.7),('11288','2013-09-14','13:00:00',1.6),('11288','2013-09-14','13:05:00',1.47),('11288','2013-09-14','13:10:00',3.97),('11288','2013-09-14','13:15:00',7.02),('11288','2013-09-14','13:20:00',5.06),('11288','2013-09-14','13:25:00',6.79),('11288','2013-09-14','13:30:00',4.78),('11288','2013-09-14','13:35:00',2.92),('11288','2013-09-14','13:40:00',6.47),('11288','2013-09-14','13:45:00',3.85),('11288','2013-09-14','13:50:00',5.94),('11288','2013-09-14','13:55:00',7.05),('11288','2013-09-14','14:00:00',6.44),('11288','2013-09-14','14:05:00',6.06),('11288','2013-09-14','14:10:00',5.97),('11288','2013-09-14','14:15:00',5.96),('11288','2013-09-14','14:20:00',5.76),('11288','2013-09-14','14:25:00',5.84),('11288','2013-09-14','14:30:00',5.76),('11288','2013-09-14','14:35:00',5.69),('11288','2013-09-14','14:40:00',5.7),('11288','2013-09-14','14:45:00',5.57),('11288','2013-09-14','14:50:00',5.52),('11288','2013-09-14','14:55:00',5.49),('11288','2013-09-14','15:00:00',5.36),('11288','2013-09-14','15:05:00',5.27),('11288','2013-09-14','15:10:00',5.22),('11288','2013-09-14','15:15:00',5.16),('11288','2013-09-14','15:20:00',5.08),('11288','2013-09-14','15:25:00',3.38),('11288','2013-09-14','15:30:00',5.06),('11288','2013-09-14','15:35:00',4.87),('11288','2013-09-14','15:40:00',4.74),('11288','2013-09-14','15:45:00',4.62),('11288','2013-09-14','15:50:00',4.53),('11288','2013-09-14','15:55:00',4.42),('11288','2013-09-14','16:00:00',4.28),('11288','2013-09-14','16:05:00',4.16),('11288','2013-09-14','16:10:00',4.03),('11288','2013-09-14','16:15:00',3.94),('11288','2013-09-14','16:20:00',3.78),('11288','2013-09-14','16:25:00',3.74),('11288','2013-09-14','16:30:00',3.62),('11288','2013-09-14','16:35:00',3.45),('11288','2013-09-14','16:40:00',3.31),('11288','2013-09-14','16:45:00',3.17),('11288','2013-09-14','16:50:00',3.06),('11288','2013-09-14','16:55:00',2.93),('11288','2013-09-14','17:00:00',2.77),('11288','2013-09-14','17:05:00',2.66),('11288','2013-09-14','17:10:00',2.5),('11288','2013-09-14','17:15:00',2.38),('11288','2013-09-14','17:20:00',2.24),('11288','2013-09-14','17:25:00',2.09),('11288','2013-09-14','17:30:00',1.94),('11288','2013-09-14','17:40:00',1.46),('11288','2013-09-14','17:45:00',1.5),('11288','2013-09-14','17:50:00',1.44),('11288','2013-09-14','17:55:00',1.26),('11288','2013-09-13','08:15:00',1.03),('11288','2013-09-13','08:20:00',1.24),('11288','2013-09-13','08:25:00',1.48),('11288','2013-09-13','08:30:00',1.33),('11288','2013-09-13','08:35:00',1.19),('11288','2013-09-13','08:40:00',1.29),('11288','2013-09-13','08:45:00',1.49),('11288','2013-09-13','08:50:00',1.66),('11288','2013-09-13','08:55:00',1.74),('11288','2013-09-13','09:00:00',1.77),('11288','2013-09-13','09:05:00',1.7),('11288','2013-09-13','09:10:00',1.64),('11288','2013-09-13','09:15:00',1.71),('11288','2013-09-13','09:20:00',1.77),('11288','2013-09-13','09:25:00',1.97),('11288','2013-09-13','09:30:00',2.09),('11288','2013-09-13','09:35:00',2.25),('11288','2013-09-13','09:40:00',2.41),('11288','2013-09-13','09:45:00',2.29),('11288','2013-09-13','09:50:00',2.71),('11288','2013-09-13','09:55:00',3.8),('11288','2013-09-13','10:00:00',2.77),('11288','2013-09-13','10:05:00',2.4),('11288','2013-09-13','10:10:00',3.91),('11288','2013-09-13','10:15:00',5.82),('11288','2013-09-13','10:20:00',5.48),('11288','2013-09-13','10:25:00',2.81),('11288','2013-09-13','10:30:00',4.41),('11288','2013-09-13','10:35:00',4.69),('11288','2013-09-13','10:40:00',4.99),('11288','2013-09-13','10:45:00',4.98),('11288','2013-09-13','10:50:00',5.06),('11288','2013-09-13','10:55:00',5.14),('11288','2013-09-13','11:00:00',5.21),('11288','2013-09-13','11:05:00',5.28),('11288','2013-09-13','11:10:00',5.34),('11288','2013-09-13','11:15:00',5.44),('11288','2013-09-13','11:20:00',5.46),('11288','2013-09-13','11:25:00',5.49),('11288','2013-09-13','11:30:00',5.53),('11288','2013-09-13','11:35:00',5.62),('11288','2013-09-13','11:40:00',5.64),('11288','2013-09-13','11:45:00',5.67),('11288','2013-09-13','11:50:00',5.73),('11288','2013-09-13','11:55:00',5.76),('11288','2013-09-13','12:00:00',5.85),('11288','2013-09-13','12:05:00',6.01),('11288','2013-09-13','12:10:00',6.04),('11288','2013-09-13','12:15:00',6.08),('11288','2013-09-13','12:20:00',6.15),('11288','2013-09-13','12:25:00',6.18),('11288','2013-09-13','12:30:00',6.26),('11288','2013-09-13','12:35:00',6.25),('11288','2013-09-13','12:40:00',6.35),('11288','2013-09-13','12:45:00',6.37),('11288','2013-09-13','12:50:00',6.41),('11288','2013-09-13','12:55:00',6.35),('11288','2013-09-13','13:00:00',6.24),('11288','2013-09-13','13:05:00',6.22),('11288','2013-09-13','13:10:00',6.15),('11288','2013-09-13','13:15:00',6.13),('11288','2013-09-13','13:20:00',6.12),('11288','2013-09-13','13:25:00',6.1),('11288','2013-09-13','13:30:00',6.07),('11288','2013-09-13','13:35:00',6.02),('11288','2013-09-13','13:40:00',5.98),('11288','2013-09-13','13:45:00',6),('11288','2013-09-13','13:50:00',5.93),('11288','2013-09-13','13:55:00',5.89),('11288','2013-09-13','14:00:00',5.86),('11288','2013-09-13','14:05:00',5.83),('11288','2013-09-13','14:10:00',5.83),('11288','2013-09-13','14:15:00',5.82),('11288','2013-09-13','14:20:00',5.83),('11288','2013-09-13','14:25:00',2.74),('11288','2013-09-13','14:35:00',4.71),('11288','2013-09-13','14:40:00',5.8),('11288','2013-09-13','14:45:00',5.1),('11288','2013-09-13','14:50:00',5.63),('11288','2013-09-13','14:55:00',5.52),('11288','2013-09-13','15:00:00',5.47),('11288','2013-09-13','15:05:00',5.43),('11288','2013-09-13','15:10:00',5.34),('11288','2013-09-13','15:15:00',5.22),('11288','2013-09-13','15:20:00',5.2),('11288','2013-09-13','15:25:00',5.04),('11288','2013-09-13','15:30:00',4.99),('11288','2013-09-13','15:35:00',4.91),('11288','2013-09-13','15:40:00',4.79),('11288','2013-09-13','15:45:00',4.7),('11288','2013-09-13','15:50:00',4.61),('11288','2013-09-13','15:55:00',4.49),('11288','2013-09-13','16:00:00',4.37),('11288','2013-09-13','16:05:00',4.28),('11288','2013-09-13','16:10:00',4.16),('11288','2013-09-13','16:15:00',4.04),('11288','2013-09-13','16:20:00',3.92),('11288','2013-09-13','16:25:00',3.83),('11288','2013-09-13','16:30:00',3.68),('11288','2013-09-13','16:35:00',3.52),('11288','2013-09-13','16:40:00',3.39),('11288','2013-09-13','16:45:00',3.27),('11288','2013-09-13','16:50:00',3.11),('11288','2013-09-13','16:55:00',2.98),('11288','2013-09-13','17:00:00',2.82),('11288','2013-09-13','17:05:00',2.69),('11288','2013-09-13','17:10:00',2.55),('11288','2013-09-13','17:15:00',2.42),('11288','2013-09-13','17:20:00',2.27),('11288','2013-09-13','17:25:00',2.12),('11288','2013-09-13','17:30:00',1.96),('11288','2013-09-13','17:35:00',1.82),('11288','2013-09-13','17:40:00',1.71),('11288','2013-09-13','17:45:00',1.58),('11288','2013-09-13','17:50:00',1.45),('11288','2013-09-13','17:55:00',1.33),('11288','2013-09-13','18:00:00',1.17),('11288','2013-09-13','18:05:00',1.02),('11288','2013-09-12','07:55:00',1.13),('11288','2013-09-12','08:00:00',1.32),('11288','2013-09-12','08:15:00',1.42),('11288','2013-09-12','08:20:00',1.45),('11288','2013-09-12','08:25:00',1.89),('11288','2013-09-12','08:30:00',2.13),('11288','2013-09-12','08:35:00',2.04),('11288','2013-09-12','08:40:00',1.59),('11288','2013-09-12','08:45:00',1.26),('11288','2013-09-12','08:50:00',1.03),('11288','2013-09-12','08:55:00',1.68),('11288','2013-09-12','09:00:00',2.4),('11288','2013-09-12','09:05:00',2.32),('11288','2013-09-12','09:10:00',1.73),('11288','2013-09-12','09:15:00',2.79),('11288','2013-09-12','09:20:00',2.9),('11288','2013-09-12','09:25:00',3.01),('11288','2013-09-12','09:30:00',3.32),('11288','2013-09-12','09:35:00',3.22),('11288','2013-09-12','09:40:00',2.71),('11288','2013-09-12','09:45:00',3.36),('11288','2013-09-12','09:50:00',2.98),('11288','2013-09-12','09:55:00',2.01),('11288','2013-09-12','10:00:00',1.84),('11288','2013-09-12','10:05:00',2.53),('11288','2013-09-12','10:10:00',2.94),('11288','2013-09-12','10:15:00',2.93),('11288','2013-09-12','10:20:00',1.92),('11288','2013-09-12','10:25:00',1.92),('11288','2013-09-12','10:30:00',3.63),('11288','2013-09-12','10:35:00',2.96),('11288','2013-09-12','10:40:00',1.1),('11288','2013-09-12','10:50:00',1.04),('11288','2013-09-12','10:55:00',3.08),('11288','2013-09-12','11:00:00',4.15),('11288','2013-09-12','11:05:00',5.77),('11288','2013-09-12','11:10:00',4.24),('11288','2013-09-12','11:15:00',3.96),('11288','2013-09-12','11:20:00',2.64),('11288','2013-09-12','11:40:00',2.48),('11288','2013-09-12','11:45:00',3.77),('11288','2013-09-12','11:50:00',2.81),('11288','2013-09-12','11:55:00',3.04),('11288','2013-09-12','12:00:00',4.81),('11288','2013-09-12','12:05:00',5.7),('11288','2013-09-12','12:10:00',3.67),('11288','2013-09-12','12:15:00',3.33),('11288','2013-09-12','12:20:00',2.35),('11288','2013-09-12','12:25:00',2.87),('11288','2013-09-12','12:30:00',2.41),('11288','2013-09-12','12:35:00',4.92),('11288','2013-09-12','12:40:00',4.11),('11288','2013-09-12','12:45:00',1.71),('11288','2013-09-12','12:50:00',2.42),('11288','2013-09-12','12:55:00',4.27),('11288','2013-09-12','13:00:00',5.88),('11288','2013-09-12','13:05:00',3.48),('11288','2013-09-12','13:10:00',4.66),('11288','2013-09-12','13:15:00',6.62),('11288','2013-09-12','13:20:00',6.96),('11288','2013-09-12','13:25:00',6.54),('11288','2013-09-12','13:30:00',5.64),('11288','2013-09-12','13:35:00',3.17),('11288','2013-09-12','13:40:00',4.65),('11288','2013-09-12','13:45:00',3.79),('11288','2013-09-12','13:50:00',5.97),('11288','2013-09-12','13:55:00',6.39),('11288','2013-09-12','14:00:00',5.3),('11288','2013-09-12','14:05:00',6.25),('11288','2013-09-12','14:10:00',5.89),('11288','2013-09-12','14:15:00',5.63),('11288','2013-09-12','14:20:00',6.11),('11288','2013-09-12','14:25:00',5.96),('11288','2013-09-12','14:30:00',6.25),('11288','2013-09-12','14:35:00',3),('11288','2013-09-12','14:40:00',5.33),('11288','2013-09-12','14:45:00',5.8),('11288','2013-09-12','14:50:00',5.83),('11288','2013-09-12','14:55:00',5.7),('11288','2013-09-12','15:00:00',4.59),('11288','2013-09-12','15:05:00',3.61),('11288','2013-09-12','15:10:00',5.14),('11288','2013-09-12','15:15:00',5.37),('11288','2013-09-12','15:20:00',5.28),('11288','2013-09-12','15:25:00',5),('11288','2013-09-12','15:30:00',5.14),('11288','2013-09-12','15:35:00',5.01),('11288','2013-09-12','15:40:00',4.97),('11288','2013-09-12','15:45:00',4.86),('11288','2013-09-12','15:50:00',4.77),('11288','2013-09-12','15:55:00',4.69),('11288','2013-09-12','16:00:00',4.3),('11288','2013-09-12','16:05:00',3.53),('11288','2013-09-12','16:10:00',4.67),('11288','2013-09-12','16:15:00',2.79),('11288','2013-09-12','16:20:00',3.61),('11288','2013-09-12','16:25:00',2.49),('11288','2013-09-12','16:30:00',3.7),('11288','2013-09-12','16:35:00',1.95),('11288','2013-09-12','16:40:00',3.9),('11288','2013-09-12','16:45:00',2.8),('11288','2013-09-12','16:50:00',1.23),('11288','2013-09-12','16:55:00',1.72),('11288','2013-09-12','17:00:00',2.96),('11288','2013-09-12','17:05:00',2.84),('11288','2013-09-12','17:10:00',2.23),('11288','2013-09-12','17:15:00',1.7),('11288','2013-09-12','17:20:00',1.27),('11288','2013-09-12','17:30:00',2.21),('11288','2013-09-12','17:35:00',2.1),('11288','2013-09-12','17:40:00',1.93),('11288','2013-09-12','17:45:00',1.62),('11288','2013-09-12','17:50:00',1.23),('11288','2013-09-12','17:55:00',1.29),('11288','2013-09-12','18:00:00',1.12),('11288','2013-09-11','08:05:00',1.19),('11288','2013-09-11','08:10:00',1.62),('11288','2013-09-11','08:15:00',1.32),('11288','2013-09-11','08:25:00',1.11),('11288','2013-09-11','08:30:00',1.55),('11288','2013-09-11','08:35:00',1.24),('11288','2013-09-11','08:40:00',1.31),('11288','2013-09-11','08:45:00',1.18),('11288','2013-09-11','08:50:00',1.5),('11288','2013-09-11','08:55:00',2.05),('11288','2013-09-11','09:00:00',2.21),('11288','2013-09-11','09:05:00',2.34),('11288','2013-09-11','09:10:00',2.48),('11288','2013-09-11','09:15:00',3.1),('11288','2013-09-11','09:20:00',3.38),('11288','2013-09-11','09:25:00',2.41),('11288','2013-09-11','09:30:00',2.11),('11288','2013-09-11','09:35:00',3.04),('11288','2013-09-11','09:40:00',2.09),('11288','2013-09-11','09:45:00',1.3),('11288','2013-09-11','09:50:00',1.6),('11288','2013-09-11','09:55:00',1.46),('11288','2013-09-11','10:00:00',1.95),('11288','2013-09-11','10:05:00',3.03),('11288','2013-09-11','10:15:00',3.67),('11288','2013-09-11','10:20:00',2.85),('11288','2013-09-11','10:25:00',3.75),('11288','2013-09-11','10:30:00',5.04),('11288','2013-09-11','10:35:00',3.95),('11288','2013-09-11','10:40:00',4.91),('11288','2013-09-11','10:45:00',5.39),('11288','2013-09-11','10:50:00',3.24),('11288','2013-09-11','10:55:00',3.44),('11288','2013-09-11','11:00:00',2.27),('11288','2013-09-11','11:05:00',5.03),('11288','2013-09-11','11:10:00',3.86),('11288','2013-09-11','11:15:00',6.13),('11288','2013-09-11','11:20:00',5.07),('11288','2013-09-11','11:25:00',2.57),('11288','2013-09-11','11:30:00',3.96),('11288','2013-09-11','11:35:00',2.34),('11288','2013-09-11','11:40:00',6.11),('11288','2013-09-11','11:45:00',5.98),('11288','2013-09-11','11:50:00',6.05),('11288','2013-09-11','11:55:00',5.22),('11288','2013-09-11','12:00:00',6.48),('11288','2013-09-11','12:05:00',4.26),('11288','2013-09-11','12:10:00',5.14),('11288','2013-09-11','12:15:00',3.39),('11288','2013-09-11','12:20:00',4.15),('11288','2013-09-11','12:25:00',4.61),('11288','2013-09-11','12:30:00',3.05),('11288','2013-09-11','12:35:00',5.33),('11288','2013-09-11','12:40:00',5.27),('11288','2013-09-11','12:45:00',5.5),('11288','2013-09-11','12:50:00',7.2),('11288','2013-09-11','12:55:00',3.71),('11288','2013-09-11','13:00:00',6.62),('11288','2013-09-11','13:05:00',6.62),('11288','2013-09-11','13:10:00',6.64),('11288','2013-09-11','13:15:00',6.76),('11288','2013-09-11','13:20:00',6.08),('11288','2013-09-11','13:25:00',5.97),('11288','2013-09-11','13:30:00',4.54),('11288','2013-09-11','13:35:00',7.25),('11288','2013-09-11','13:40:00',3.99),('11288','2013-09-11','13:45:00',6.42),('11288','2013-09-11','13:50:00',5.47),('11288','2013-09-11','13:55:00',4.35),('11288','2013-09-11','14:00:00',6.17),('11288','2013-09-11','14:05:00',5.29),('11288','2013-09-11','14:10:00',5.13),('11288','2013-09-11','14:15:00',5.47),('11288','2013-09-11','14:20:00',5.36),('11288','2013-09-11','14:25:00',4.8),('11288','2013-09-11','14:30:00',3.93),('11288','2013-09-11','14:35:00',4.04),('11288','2013-09-11','14:40:00',3.91),('11288','2013-09-11','14:45:00',5.44),('11288','2013-09-11','14:50:00',4.66),('11288','2013-09-11','14:55:00',2.88),('11288','2013-09-11','15:00:00',6.12),('11288','2013-09-11','15:05:00',5.69),('11288','2013-09-11','15:10:00',4.75),('11288','2013-09-11','15:15:00',5.9),('11288','2013-09-11','15:20:00',4.57),('11288','2013-09-11','15:25:00',2.45),('11288','2013-09-11','15:30:00',2.45),('11288','2013-09-11','15:35:00',1.64),('11288','2013-09-11','15:40:00',2.01),('11288','2013-09-11','15:45:00',4.32),('11288','2013-09-11','15:50:00',4.13),('11288','2013-09-11','15:55:00',4.89),('11288','2013-09-11','16:00:00',3.81),('11288','2013-09-11','16:05:00',4.9),('11288','2013-09-11','16:10:00',4.53),('11288','2013-09-11','16:15:00',4.24),('11288','2013-09-11','16:20:00',3.07),('11288','2013-09-11','16:25:00',2.88),('11288','2013-09-11','16:30:00',2.54),('11288','2013-09-11','16:35:00',2.99),('11288','2013-09-11','16:40:00',3.12),('11288','2013-09-11','16:45:00',3.11),('11288','2013-09-11','16:50:00',3.26),('11288','2013-09-11','16:55:00',1.64),('11288','2013-09-11','17:00:00',2.94),('11288','2013-09-11','17:05:00',2.74),('11288','2013-09-11','17:10:00',2.7),('11288','2013-09-11','17:15:00',2.49),('11288','2013-09-11','17:20:00',2.31),('11288','2013-09-11','17:25:00',2.16),('11288','2013-09-11','17:30:00',2.07),('11288','2013-09-11','17:35:00',1.96),('11288','2013-09-11','17:40:00',1.36),('11288','2013-09-11','17:45:00',1.14),('11288','2013-09-11','17:50:00',1.14),('11288','2013-09-11','17:55:00',1),('11288','2013-09-11','18:00:00',1.27),('11288','2013-09-11','18:05:00',1.14),('11288','2013-09-10','07:55:00',1.06),('11288','2013-09-10','08:00:00',1.11),('11288','2013-09-10','08:05:00',1.03),('11288','2013-09-10','08:10:00',1.13),('11288','2013-09-10','08:15:00',1.35),('11288','2013-09-10','08:20:00',1.21),('11288','2013-09-10','08:25:00',1.05),('11288','2013-09-10','08:35:00',1.01),('11288','2013-09-10','08:40:00',1.22),('11288','2013-09-10','08:45:00',1.39),('11288','2013-09-10','08:50:00',1.18),('11288','2013-09-10','08:55:00',1.89),('11288','2013-09-10','09:00:00',2.29),('11288','2013-09-10','09:05:00',2.65),('11288','2013-09-10','09:10:00',3.27),('11288','2013-09-10','09:15:00',2.77),('11288','2013-09-10','09:20:00',2.25),('11288','2013-09-10','09:25:00',2.33),('11288','2013-09-10','09:30:00',3.84),('11288','2013-09-10','09:35:00',4.09),('11288','2013-09-10','09:40:00',2.69),('11288','2013-09-10','09:45:00',2.25),('11288','2013-09-10','09:50:00',2.07),('11288','2013-09-10','09:55:00',1.84),('11288','2013-09-10','10:00:00',1.45),('11288','2013-09-10','10:05:00',1.29),('11288','2013-09-10','10:10:00',1.06),('11288','2013-09-10','10:15:00',1.1),('11288','2013-09-10','10:20:00',1.52),('11288','2013-09-10','10:25:00',1.74),('11288','2013-09-10','10:30:00',1.73),('11288','2013-09-10','10:35:00',2.01),('11288','2013-09-10','10:40:00',2.65),('11288','2013-09-10','10:45:00',3.48),('11288','2013-09-10','10:50:00',2.12),('11288','2013-09-10','10:55:00',2.32),('11288','2013-09-10','11:00:00',2.73),('11288','2013-09-10','11:05:00',2.4),('11288','2013-09-10','11:10:00',2.35),('11288','2013-09-10','11:15:00',2.07),('11288','2013-09-10','11:20:00',2.25),('11288','2013-09-10','11:25:00',2.37),('11288','2013-09-10','11:30:00',1.82),('11288','2013-09-10','11:35:00',1.27),('11288','2013-09-10','11:40:00',1.42),('11288','2013-09-10','11:45:00',2.23),('11288','2013-09-10','11:50:00',2.22),('11288','2013-09-10','11:55:00',2.61),('11288','2013-09-10','12:00:00',2.29),('11288','2013-09-10','12:05:00',1.76),('11288','2013-09-10','12:10:00',1.8),('11288','2013-09-10','12:15:00',1.9),('11288','2013-09-10','12:20:00',1.76),('11288','2013-09-10','12:25:00',1.62),('11288','2013-09-10','12:30:00',1.45),('11288','2013-09-10','12:35:00',1.44),('11288','2013-09-10','12:40:00',1.14),('11288','2013-09-10','12:45:00',1.13),('11288','2013-09-10','12:50:00',1.13),('11288','2013-09-10','12:55:00',1.17),('11288','2013-09-10','13:00:00',1.43),('11288','2013-09-10','13:05:00',1.14),('11288','2013-09-10','13:10:00',1.12),('11288','2013-09-10','13:15:00',1.54),('11288','2013-09-10','13:20:00',1.63),('11288','2013-09-10','13:25:00',1.91),('11288','2013-09-10','13:30:00',1.75),('11288','2013-09-10','13:35:00',1.94),('11288','2013-09-10','13:40:00',3.22),('11288','2013-09-10','13:45:00',4.58),('11288','2013-09-10','13:50:00',3.02),('11288','2013-09-10','13:55:00',2.56),('11288','2013-09-10','14:00:00',1.96),('11288','2013-09-10','14:05:00',2.26),('11288','2013-09-10','14:10:00',2.34),('11288','2013-09-10','14:15:00',2.75),('11288','2013-09-10','14:20:00',2.71),('11288','2013-09-10','14:25:00',3.72),('11288','2013-09-10','14:30:00',3.15),('11288','2013-09-10','14:35:00',2.5),('11288','2013-09-10','14:40:00',3.01),('11288','2013-09-10','14:45:00',3.15),('11288','2013-09-10','14:50:00',3.58),('11288','2013-09-10','14:55:00',3.06),('11288','2013-09-10','15:00:00',4.16),('11288','2013-09-10','15:05:00',3.58),('11288','2013-09-10','15:10:00',2.77),('11288','2013-09-10','15:15:00',2.72),('11288','2013-09-10','15:20:00',3.21),('11288','2013-09-10','15:25:00',2.9),('11288','2013-09-10','15:30:00',3.4),('11288','2013-09-10','15:35:00',2.63),('11288','2013-09-10','15:40:00',1.99),('11288','2013-09-10','15:45:00',1.77),('11288','2013-09-10','15:50:00',1.87),('11288','2013-09-10','15:55:00',1.76),('11288','2013-09-10','16:00:00',1.77),('11288','2013-09-10','16:05:00',1.88),('11288','2013-09-10','16:10:00',2.21),('11288','2013-09-10','16:15:00',2.37),('11288','2013-09-10','16:20:00',1.72),('11288','2013-09-10','16:25:00',1.63),('11288','2013-09-10','16:30:00',1.3),('11288','2013-09-10','16:45:00',1.13),('11288','2013-09-10','16:50:00',1.41),('11288','2013-09-10','16:55:00',1.39),('11288','2013-09-10','17:00:00',1.22),('11288','2013-09-10','17:05:00',1.13),('11288','2013-09-10','17:10:00',1.19),('11288','2013-09-10','17:15:00',1.41),('11288','2013-09-10','17:20:00',1.4),('11288','2013-09-10','17:25:00',1.34),('11288','2013-09-10','17:30:00',1.2),('11288','2013-09-10','17:45:00',1.16),('11288','2013-09-10','17:50:00',1.28),('11288','2013-09-10','17:55:00',1.06),('11288','2013-09-09','07:35:00',1.11),('11288','2013-09-09','07:40:00',1.41),('11288','2013-09-09','07:45:00',1.55),('11288','2013-09-09','07:50:00',1.47),('11288','2013-09-09','07:55:00',1.4),('11288','2013-09-09','08:00:00',1.27),('11288','2013-09-09','08:25:00',1.03),('11288','2013-09-09','08:40:00',1.2),('11288','2013-09-09','08:45:00',1.54),('11288','2013-09-09','08:50:00',1.74),('11288','2013-09-09','08:55:00',2.02),('11288','2013-09-09','09:00:00',2),('11288','2013-09-09','09:05:00',1.87),('11288','2013-09-09','09:10:00',1.61),('11288','2013-09-09','09:15:00',1.05),('11288','2013-09-09','09:20:00',1.44),('11288','2013-09-09','09:25:00',1.14),('11288','2013-09-09','09:30:00',1.38),('11288','2013-09-09','09:35:00',2.03),('11288','2013-09-09','09:40:00',1.63),('11288','2013-09-09','09:45:00',1),('11288','2013-09-09','09:50:00',1.35),('11288','2013-09-09','09:55:00',1.39),('11288','2013-09-09','10:00:00',2.59),('11288','2013-09-09','10:05:00',3.02),('11288','2013-09-09','10:10:00',2.93),('11288','2013-09-09','10:15:00',2.86),('11288','2013-09-09','10:20:00',2.76),('11288','2013-09-09','10:25:00',2.74),('11288','2013-09-09','10:30:00',2.63),('11288','2013-09-09','10:35:00',2.73),('11288','2013-09-09','10:40:00',2.87),('11288','2013-09-09','10:45:00',3.27),('11288','2013-09-09','10:50:00',4.1),('11288','2013-09-09','10:55:00',3.98),('11288','2013-09-09','11:00:00',4.36),('11288','2013-09-09','11:05:00',3.62),('11288','2013-09-09','11:10:00',3.44),('11288','2013-09-09','11:15:00',3.36),('11288','2013-09-09','11:20:00',3.57),('11288','2013-09-09','11:25:00',3.78),('11288','2013-09-09','11:30:00',3.46),('11288','2013-09-09','11:35:00',3.71),('11288','2013-09-09','11:40:00',5.05),('11288','2013-09-09','11:45:00',5.16),('11288','2013-09-09','11:50:00',5.6),('11288','2013-09-09','11:55:00',4.98),('11288','2013-09-09','12:00:00',4.43),('11288','2013-09-09','12:05:00',4.11),('11288','2013-09-09','12:10:00',4.61),('11288','2013-09-09','12:15:00',3.3),('11288','2013-09-09','12:20:00',2.34),('11288','2013-09-09','12:25:00',1.91),('11288','2013-09-09','12:30:00',1.89),('11288','2013-09-09','12:35:00',1.85),('11288','2013-09-09','12:40:00',2.84),('11288','2013-09-09','12:45:00',2.48),('11288','2013-09-09','12:50:00',2.17),('11288','2013-09-09','12:55:00',3.11),('11288','2013-09-09','13:00:00',3.12),('11288','2013-09-09','13:05:00',4.02),('11288','2013-09-09','13:10:00',4.14),('11288','2013-09-09','13:15:00',5.06),('11288','2013-09-09','13:20:00',4.42),('11288','2013-09-09','13:25:00',4.76),('11288','2013-09-09','13:30:00',5.45),('11288','2013-09-09','13:35:00',5.94),('11288','2013-09-09','13:40:00',4.73),('11288','2013-09-09','13:45:00',6.25),('11288','2013-09-09','13:50:00',5.35),('11288','2013-09-09','13:55:00',6.16),('11288','2013-09-09','14:00:00',5.69),('11288','2013-09-09','14:05:00',5.2),('11288','2013-09-09','14:10:00',5.24),('11288','2013-09-09','14:15:00',3.16),('11288','2013-09-09','14:20:00',3.27),('11288','2013-09-09','14:25:00',2.53),('11288','2013-09-09','14:30:00',4.21),('11288','2013-09-09','14:35:00',5.44),('11288','2013-09-09','14:40:00',5.39),('11288','2013-09-09','14:45:00',4.68),('11288','2013-09-09','14:50:00',5.22),('11288','2013-09-09','14:55:00',4.06),('11288','2013-09-09','15:00:00',3.99),('11288','2013-09-09','15:05:00',4.49),('11288','2013-09-09','15:10:00',3.48),('11288','2013-09-09','15:15:00',2.31),('11288','2013-09-09','15:20:00',4.04),('11288','2013-09-09','15:25:00',2.38),('11288','2013-09-09','15:30:00',4.84),('11288','2013-09-09','15:35:00',4.04),('11288','2013-09-09','15:40:00',3.39),('11288','2013-09-09','15:45:00',2.47),('11288','2013-09-09','15:50:00',2.44),('11288','2013-09-09','15:55:00',2.74),('11288','2013-09-09','16:00:00',3.11),('11288','2013-09-09','16:05:00',2.3),('11288','2013-09-09','16:10:00',3.02),('11288','2013-09-09','16:15:00',3.65),('11288','2013-09-09','16:20:00',2.88),('11288','2013-09-09','16:25:00',1.91),('11288','2013-09-09','16:30:00',1.84),('11288','2013-09-09','16:35:00',2.15),('11288','2013-09-09','16:40:00',2.36),('11288','2013-09-09','16:45:00',3.37),('11288','2013-09-09','16:50:00',1.31),('11288','2013-09-09','16:55:00',1.3),('11288','2013-09-09','17:00:00',1.67),('11288','2013-09-09','17:05:00',1.35),('11288','2013-09-09','17:10:00',1.33),('11288','2013-09-09','17:15:00',1.02),('11288','2013-09-09','17:35:00',1.04),('11288','2013-09-09','17:40:00',1.04),('11288','2013-09-09','18:10:00',1.3),('11288','2013-09-09','18:15:00',1.52),('11288','2013-09-09','18:20:00',1.29),('11288','2014-04-12','08:05:00',1),('11288','2014-04-12','08:10:00',1.1),('11288','2014-04-12','08:20:00',1.12),('11288','2014-04-12','08:25:00',1.05),('11288','2014-04-12','08:35:00',1.01),('11288','2014-04-12','08:45:00',1.01),('11288','2014-04-12','08:50:00',1.07),('11288','2014-04-12','08:55:00',1.03),('11288','2014-04-12','09:00:00',1.23),('11288','2014-04-12','09:05:00',1.51),('11288','2014-04-12','09:10:00',1.81),('11288','2014-04-12','09:15:00',2.86),('11288','2014-04-12','09:20:00',3.9),('11288','2014-04-12','09:25:00',4.03),('11288','2014-04-12','09:30:00',3.04),('11288','2014-04-12','09:35:00',2.48),('11288','2014-04-12','09:40:00',2.19),('11288','2014-04-12','09:45:00',2.23),('11288','2014-04-12','09:50:00',2.46),('11288','2014-04-12','09:55:00',2.37),('11288','2014-04-12','10:00:00',2.4),('11288','2014-04-12','10:05:00',2.49),('11288','2014-04-12','10:10:00',2.7),('11288','2014-04-12','10:15:00',2.98),('11288','2014-04-12','10:20:00',3.13),('11288','2014-04-12','10:25:00',3.28),('11288','2014-04-12','10:30:00',3.58),('11288','2014-04-12','10:35:00',3.84),('11288','2014-04-12','10:40:00',3.86),('11288','2014-04-12','10:45:00',4.17),('11288','2014-04-12','10:50:00',4.39),('11288','2014-04-12','10:55:00',4.51),('11288','2014-04-12','11:00:00',4.63),('11288','2014-04-12','11:05:00',3.63),('11288','2014-04-12','11:10:00',4.95),('11288','2014-04-12','11:15:00',5.43),('11288','2014-04-12','11:20:00',5.96),('11288','2014-04-12','11:25:00',5.09),('11288','2014-04-12','11:30:00',5.77),('11288','2014-04-12','11:35:00',6.3),('11288','2014-04-12','11:40:00',5.86),('11288','2014-04-12','11:45:00',6.02),('11288','2014-04-12','11:50:00',3.97),('11288','2014-04-12','11:55:00',4.1),('11288','2014-04-12','12:00:00',3.74),('11288','2014-04-12','12:05:00',2.7),('11288','2014-04-12','12:10:00',2.76),('11288','2014-04-12','12:15:00',3.72),('11288','2014-04-12','12:20:00',5.3),('11288','2014-04-12','12:25:00',3.5),('11288','2014-04-12','12:30:00',3.94),('11288','2014-04-12','12:35:00',4.44),('11288','2014-04-12','12:40:00',4.95),('11288','2014-04-12','12:45:00',3.48),('11288','2014-04-12','12:50:00',3.45),('11288','2014-04-12','12:55:00',3.41),('11288','2014-04-12','13:00:00',3.37),('11288','2014-04-12','13:05:00',3.87),('11288','2014-04-12','13:10:00',4.05),('11288','2014-04-12','13:15:00',4.53),('11288','2014-04-12','13:20:00',5.75),('11288','2014-04-12','13:25:00',6.75),('11288','2014-04-12','13:30:00',2.88),('11288','2014-04-12','13:35:00',2.86),('11288','2014-04-12','13:40:00',3.96),('11288','2014-04-12','13:45:00',5.39),('11288','2014-04-12','13:50:00',2.96),('11288','2014-04-12','13:55:00',6.1),('11288','2014-04-12','14:00:00',6.5),('11288','2014-04-12','14:05:00',6.18),('11288','2014-04-12','14:10:00',2.57),('11288','2014-04-12','14:15:00',3.81),('11288','2014-04-12','14:20:00',5.71),('11288','2014-04-12','14:25:00',3.18),('11288','2014-04-12','14:30:00',4.53),('11288','2014-04-12','14:35:00',3.55),('11288','2014-04-12','14:40:00',4.16),('11288','2014-04-12','14:45:00',3.99),('11288','2014-04-12','14:50:00',5.57),('11288','2014-04-12','14:55:00',3.94),('11288','2014-04-12','15:00:00',4.45),('11288','2014-04-12','15:05:00',5.84),('11288','2014-04-12','15:10:00',6.02),('11288','2014-04-12','15:15:00',5.81),('11288','2014-04-12','15:20:00',4.59),('11288','2014-04-12','15:25:00',4.32),('11288','2014-04-12','15:30:00',3.93),('11288','2014-04-12','15:35:00',3.36),('11288','2014-04-12','15:40:00',4.05),('11288','2014-04-12','15:45:00',4.97),('11288','2014-04-12','15:50:00',5.57),('11288','2014-04-12','15:55:00',5.46),('11288','2014-04-12','16:00:00',5.37),('11288','2014-04-12','16:05:00',5.26),('11288','2014-04-12','16:10:00',4.98),('11288','2014-04-12','16:15:00',5.14),('11288','2014-04-12','16:20:00',5.18),('11288','2014-04-12','16:25:00',4.61),('11288','2014-04-12','16:30:00',4.32),('11288','2014-04-12','16:35:00',3.53),('11288','2014-04-12','16:40:00',3.75),('11288','2014-04-12','16:45:00',3.41),('11288','2014-04-12','16:50:00',2.54),('11288','2014-04-12','16:55:00',3.64),('11288','2014-04-12','17:00:00',3.61),('11288','2014-04-12','17:05:00',3.33),('11288','2014-04-12','17:10:00',3.28),('11288','2014-04-12','17:15:00',3.15),('11288','2014-04-12','17:20:00',2.52),('11288','2014-04-12','17:25:00',2.91),('11288','2014-04-12','17:30:00',2.52),('11288','2014-04-12','17:35:00',2.27),('11288','2014-04-12','17:40:00',2.9),('11288','2014-04-12','17:45:00',2.82),('11288','2014-04-12','17:50:00',2.58),('11288','2014-04-12','17:55:00',2.06),('11288','2014-04-12','18:00:00',1.66),('11288','2014-04-12','18:05:00',1.03),('11288','2014-04-12','18:30:00',1.04),('11288','2013-09-08','07:55:00',1.2),('11288','2013-09-08','08:20:00',1.13),('11288','2013-09-08','08:25:00',1.05),('11288','2013-09-08','08:30:00',1.22),('11288','2013-09-08','08:35:00',1.55),('11288','2013-09-08','08:40:00',1.24),('11288','2013-09-08','08:45:00',1.33),('11288','2013-09-08','08:50:00',1.44),('11288','2013-09-08','08:55:00',1.47),('11288','2013-09-08','09:00:00',1.77),('11288','2013-09-08','09:05:00',1.84),('11288','2013-09-08','09:10:00',1.85),('11288','2013-09-08','09:15:00',1.95),('11288','2013-09-08','09:20:00',2.24),('11288','2013-09-08','09:25:00',3.09),('11288','2013-09-08','09:30:00',2.48),('11288','2013-09-08','09:35:00',2.47),('11288','2013-09-08','09:40:00',2.82),('11288','2013-09-08','09:45:00',3.36),('11288','2013-09-08','09:50:00',3.45),('11288','2013-09-08','09:55:00',3.6),('11288','2013-09-08','10:00:00',3.75),('11288','2013-09-08','10:05:00',3.89),('11288','2013-09-08','10:10:00',3.95),('11288','2013-09-08','10:15:00',4.05),('11288','2013-09-08','10:20:00',4.22),('11288','2013-09-08','10:25:00',4.34),('11288','2013-09-08','10:30:00',4.38),('11288','2013-09-08','10:35:00',4.51),('11288','2013-09-08','10:40:00',4.39),('11288','2013-09-08','10:45:00',4.55),('11288','2013-09-08','10:50:00',4.65),('11288','2013-09-08','10:55:00',4.54),('11288','2013-09-08','11:00:00',4.83),('11288','2013-09-08','11:05:00',4.92),('11288','2013-09-08','11:10:00',4.94),('11288','2013-09-08','11:15:00',5.04),('11288','2013-09-08','11:20:00',5.06),('11288','2013-09-08','11:25:00',4.96),('11288','2013-09-08','11:30:00',4.95),('11288','2013-09-08','11:35:00',5.03),('11288','2013-09-08','11:40:00',5.06),('11288','2013-09-08','11:45:00',5.19),('11288','2013-09-08','11:50:00',5.04),('11288','2013-09-08','11:55:00',5.11),('11288','2013-09-08','12:00:00',5.03),('11288','2013-09-08','12:05:00',4.85),('11288','2013-09-08','12:10:00',5.27),('11288','2013-09-08','12:15:00',5.57),('11288','2013-09-08','12:20:00',5.49),('11288','2013-09-08','12:25:00',5.47),('11288','2013-09-08','12:30:00',5.24),('11288','2013-09-08','12:35:00',5.42),('11288','2013-09-08','12:40:00',5.29),('11288','2013-09-08','12:45:00',5.37),('11288','2013-09-08','12:50:00',5.43),('11288','2013-09-08','12:55:00',5.56),('11288','2013-09-08','13:00:00',5.5),('11288','2013-09-08','13:05:00',5.63),('11288','2013-09-08','13:10:00',5.55),('11288','2013-09-08','13:15:00',5.44),('11288','2013-09-08','13:20:00',5.46),('11288','2013-09-08','13:25:00',4.99),('11288','2013-09-08','13:30:00',5.03),('11288','2013-09-08','13:35:00',4.82),('11288','2013-09-08','13:40:00',3.47),('11288','2013-09-08','13:45:00',3.39),('11288','2013-09-08','13:50:00',4.72),('11288','2013-09-08','13:55:00',4.73),('11288','2013-09-08','14:00:00',5.33),('11288','2013-09-08','14:05:00',5.07),('11288','2013-09-08','14:10:00',5.74),('11288','2013-09-08','14:15:00',5.23),('11288','2013-09-08','14:20:00',5.98),('11288','2013-09-08','14:25:00',6.06),('11288','2013-09-08','14:30:00',5.31),('11288','2013-09-08','14:35:00',5.58),('11288','2013-09-08','14:40:00',5.42),('11288','2013-09-08','14:45:00',5.25),('11288','2013-09-08','14:50:00',5.29),('11288','2013-09-08','14:55:00',5.26),('11288','2013-09-08','15:00:00',5.25),('11288','2013-09-08','15:05:00',4.11),('11288','2013-09-08','15:10:00',2.89),('11288','2013-09-08','15:15:00',3.99),('11288','2013-09-08','15:20:00',5.04),('11288','2013-09-08','15:25:00',5.07),('11288','2013-09-08','15:30:00',5.05),('11288','2013-09-08','15:35:00',4.86),('11288','2013-09-08','15:40:00',4.52),('11288','2013-09-08','15:45:00',4.56),('11288','2013-09-08','15:50:00',4.35),('11288','2013-09-08','15:55:00',3.58),('11288','2013-09-08','16:00:00',3.77),('11288','2013-09-08','16:05:00',3.76),('11288','2013-09-08','16:10:00',3.2),('11288','2013-09-08','16:15:00',3.92),('11288','2013-09-08','16:20:00',3.41),('11288','2013-09-08','16:25:00',3.28),('11288','2013-09-08','16:30:00',3.49),('11288','2013-09-08','16:35:00',3.16),('11288','2013-09-08','16:40:00',2.63),('11288','2013-09-08','16:45:00',2.03),('11288','2013-09-08','16:50:00',1.94),('11288','2013-09-08','16:55:00',1.85),('11288','2013-09-08','17:00:00',2.64),('11288','2013-09-08','17:05:00',2.96),('11288','2013-09-08','17:10:00',2.75),('11288','2013-09-08','17:15:00',2.52),('11288','2013-09-08','17:20:00',2.09),('11288','2013-09-08','17:25:00',2.12),('11288','2013-09-08','17:30:00',1.89),('11288','2013-09-08','17:40:00',1.07),('11288','2013-09-08','17:45:00',1.5),('11288','2013-09-08','17:50:00',1.5),('11288','2013-09-08','17:55:00',1.4),('11288','2013-09-08','18:00:00',1.22),('11288','2013-09-08','18:05:00',1.04),('11288','2013-09-07','08:10:00',1.02),('11288','2013-09-07','08:15:00',1.13),('11288','2013-09-07','08:20:00',1.23),('11288','2013-09-07','08:25:00',1.4),('11288','2013-09-07','08:30:00',1.42),('11288','2013-09-07','08:35:00',1.58),('11288','2013-09-07','08:40:00',1.8),('11288','2013-09-07','08:45:00',1.87),('11288','2013-09-07','08:50:00',2.09),('11288','2013-09-07','08:55:00',2.16),('11288','2013-09-07','09:00:00',2.25),('11288','2013-09-07','09:05:00',2.35),('11288','2013-09-07','09:10:00',2.49),('11288','2013-09-07','09:15:00',2.5),('11288','2013-09-07','09:20:00',2.64),('11288','2013-09-07','09:25:00',2.97),('11288','2013-09-07','09:30:00',2.99),('11288','2013-09-07','09:35:00',3.08),('11288','2013-09-07','09:40:00',3.18),('11288','2013-09-07','09:45:00',3.29),('11288','2013-09-07','09:50:00',3.53),('11288','2013-09-07','09:55:00',3.72),('11288','2013-09-07','10:00:00',3.84),('11288','2013-09-07','10:05:00',4),('11288','2013-09-07','10:10:00',4.11),('11288','2013-09-07','10:15:00',4.19),('11288','2013-09-07','10:20:00',4.26),('11288','2013-09-07','10:25:00',4.37),('11288','2013-09-07','10:30:00',4.42),('11288','2013-09-07','10:35:00',4.53),('11288','2013-09-07','10:40:00',4.59),('11288','2013-09-07','10:45:00',4.65),('11288','2013-09-07','10:50:00',4.73),('11288','2013-09-07','10:55:00',4.88),('11288','2013-09-07','11:00:00',4.96),('11288','2013-09-07','11:05:00',4.99),('11288','2013-09-07','11:10:00',5.06),('11288','2013-09-07','11:15:00',5.09),('11288','2013-09-07','11:20:00',5.12),('11288','2013-09-07','11:25:00',5.17),('11288','2013-09-07','11:30:00',5.25),('11288','2013-09-07','11:35:00',5.32),('11288','2013-09-07','11:40:00',5.4),('11288','2013-09-07','11:45:00',5.4),('11288','2013-09-07','11:50:00',5.46),('11288','2013-09-07','11:55:00',5.5),('11288','2013-09-07','12:00:00',5.58),('11288','2013-09-07','12:05:00',5.64),('11288','2013-09-07','12:10:00',5.68),('11288','2013-09-07','12:15:00',5.67),('11288','2013-09-07','12:20:00',5.71),('11288','2013-09-07','12:25:00',5.71),('11288','2013-09-07','12:30:00',5.7),('11288','2013-09-07','12:35:00',5.69),('11288','2013-09-07','12:40:00',5.69),('11288','2013-09-07','12:45:00',5.69),('11288','2013-09-07','12:50:00',5.78),('11288','2013-09-07','12:55:00',5.72),('11288','2013-09-07','13:00:00',5.75),('11288','2013-09-07','13:05:00',5.77),('11288','2013-09-07','13:10:00',5.75),('11288','2013-09-07','13:15:00',5.73),('11288','2013-09-07','13:20:00',5.77),('11288','2013-09-07','13:25:00',5.83),('11288','2013-09-07','13:30:00',5.83),('11288','2013-09-07','13:35:00',4.75),('11288','2013-09-07','13:40:00',3.9),('11288','2013-09-07','13:45:00',3.38),('11288','2013-09-07','13:50:00',5.58),('11288','2013-09-07','13:55:00',5.8),('11288','2013-09-07','14:00:00',5.86),('11288','2013-09-07','14:05:00',5.84),('11288','2013-09-07','14:10:00',5.77),('11288','2013-09-07','14:15:00',5.65),('11288','2013-09-07','14:20:00',5.54),('11288','2013-09-07','14:25:00',5.52),('11288','2013-09-07','14:30:00',5.55),('11288','2013-09-07','14:35:00',5.57),('11288','2013-09-07','14:40:00',5.54),('11288','2013-09-07','14:45:00',5.47),('11288','2013-09-07','14:50:00',5.37),('11288','2013-09-07','14:55:00',5.31),('11288','2013-09-07','15:00:00',5.25),('11288','2013-09-07','15:05:00',5.19),('11288','2013-09-07','15:10:00',5.12),('11288','2013-09-07','15:15:00',5.09),('11288','2013-09-07','15:20:00',5.05),('11288','2013-09-07','15:25:00',4.96),('11288','2013-09-07','15:30:00',4.9),('11288','2013-09-07','15:35:00',4.8),('11288','2013-09-07','15:40:00',4.66),('11288','2013-09-07','15:45:00',4.56),('11288','2013-09-07','15:50:00',4.45),('11288','2013-09-07','15:55:00',4.34),('11288','2013-09-07','16:00:00',4.26),('11288','2013-09-07','16:05:00',4.13),('11288','2013-09-07','16:10:00',4.01),('11288','2013-09-07','16:15:00',3.9),('11288','2013-09-07','16:20:00',3.78),('11288','2013-09-07','16:25:00',3.62),('11288','2013-09-07','16:30:00',3.52),('11288','2013-09-07','16:35:00',3.4),('11288','2013-09-07','16:40:00',3.29),('11288','2013-09-07','16:45:00',3.19),('11288','2013-09-07','16:50:00',3.07),('11288','2013-09-07','16:55:00',2.94),('11288','2013-09-07','17:00:00',2.8),('11288','2013-09-07','17:05:00',2.68),('11288','2013-09-07','17:10:00',2.52),('11288','2013-09-07','17:15:00',2.42),('11288','2013-09-07','17:20:00',2.29),('11288','2013-09-07','17:25:00',2.15),('11288','2013-09-07','17:30:00',1.99),('11288','2013-09-07','17:35:00',1.88),('11288','2013-09-07','17:40:00',1.75),('11288','2013-09-07','17:45:00',1.64),('11288','2013-09-07','17:50:00',1.53),('11288','2013-09-07','17:55:00',1.4),('11288','2013-09-07','18:00:00',1.28),('11288','2013-09-07','18:05:00',1.14),('11288','2013-09-07','18:10:00',1.02),('11288','2013-09-06','08:10:00',1.08),('11288','2013-09-06','08:15:00',1.17),('11288','2013-09-06','08:20:00',1.31),('11288','2013-09-06','08:25:00',1.49),('11288','2013-09-06','08:30:00',1.53),('11288','2013-09-06','08:35:00',1.66),('11288','2013-09-06','08:40:00',1.81),('11288','2013-09-06','08:45:00',2),('11288','2013-09-06','08:50:00',2.19),('11288','2013-09-06','08:55:00',2.28),('11288','2013-09-06','09:00:00',2.4),('11288','2013-09-06','09:05:00',2.5),('11288','2013-09-06','09:10:00',2.57),('11288','2013-09-06','09:15:00',2.66),('11288','2013-09-06','09:20:00',2.78),('11288','2013-09-06','09:25:00',2.99),('11288','2013-09-06','09:30:00',3.09),('11288','2013-09-06','09:35:00',3.27),('11288','2013-09-06','09:40:00',3.32),('11288','2013-09-06','09:45:00',3.33),('11288','2013-09-06','09:50:00',3.65),('11288','2013-09-06','09:55:00',3.82),('11288','2013-09-06','10:00:00',3.92),('11288','2013-09-06','10:05:00',4.06),('11288','2013-09-06','10:10:00',4.17),('11288','2013-09-06','10:15:00',4.26),('11288','2013-09-06','10:20:00',4.32),('11288','2013-09-06','10:25:00',4.46),('11288','2013-09-06','10:30:00',4.59),('11288','2013-09-06','10:35:00',4.69),('11288','2013-09-06','10:40:00',4.77),('11288','2013-09-06','10:45:00',4.88),('11288','2013-09-06','10:50:00',4.93),('11288','2013-09-06','10:55:00',4.99),('11288','2013-09-06','11:00:00',5.08),('11288','2013-09-06','11:05:00',5.11),('11288','2013-09-06','11:10:00',5.19),('11288','2013-09-06','11:15:00',5.28),('11288','2013-09-06','11:20:00',5.28),('11288','2013-09-06','11:25:00',5.38),('11288','2013-09-06','11:30:00',5.4),('11288','2013-09-06','11:35:00',5.44),('11288','2013-09-06','11:40:00',5.47),('11288','2013-09-06','11:45:00',5.51),('11288','2013-09-06','11:50:00',5.52),('11288','2013-09-06','11:55:00',5.53),('11288','2013-09-06','12:00:00',5.59),('11288','2013-09-06','12:05:00',5.63),('11288','2013-09-06','12:10:00',5.69),('11288','2013-09-06','12:15:00',5.77),('11288','2013-09-06','12:20:00',5.8),('11288','2013-09-06','12:25:00',5.81),('11288','2013-09-06','12:30:00',5.83),('11288','2013-09-06','12:35:00',5.85),('11288','2013-09-06','12:40:00',5.88),('11288','2013-09-06','12:45:00',5.87),('11288','2013-09-06','12:50:00',5.87),('11288','2013-09-06','12:55:00',5.88),('11288','2013-09-06','13:00:00',5.89),('11288','2013-09-06','13:05:00',5.88),('11288','2013-09-06','13:10:00',5.87),('11288','2013-09-06','13:15:00',5.86),('11288','2013-09-06','13:20:00',5.85),('11288','2013-09-06','13:25:00',5.8),('11288','2013-09-06','13:30:00',5.83),('11288','2013-09-06','13:35:00',5.84),('11288','2013-09-06','13:40:00',5.79),('11288','2013-09-06','13:45:00',5.71),('11288','2013-09-06','13:50:00',5.69),('11288','2013-09-06','13:55:00',5.65),('11288','2013-09-06','14:00:00',5.6),('11288','2013-09-06','14:05:00',5.61),('11288','2013-09-06','14:10:00',5.59),('11288','2013-09-06','14:15:00',5.56),('11288','2013-09-06','14:20:00',5.5),('11288','2013-09-06','14:25:00',5.49),('11288','2013-09-06','14:30:00',5.32),('11288','2013-09-06','14:35:00',5.19),('11288','2013-09-06','14:40:00',5.21),('11288','2013-09-06','14:45:00',5.22),('11288','2013-09-06','14:50:00',5.3),('11288','2013-09-06','14:55:00',5.3),('11288','2013-09-06','15:00:00',5.24),('11288','2013-09-06','15:05:00',5.15),('11288','2013-09-06','15:10:00',5.06),('11288','2013-09-06','15:15:00',5.02),('11288','2013-09-06','15:20:00',4.96),('11288','2013-09-06','15:25:00',4.85),('11288','2013-09-06','15:30:00',4.72),('11288','2013-09-06','15:35:00',4.63),('11288','2013-09-06','15:40:00',4.6),('11288','2013-09-06','15:45:00',4.52),('11288','2013-09-06','15:50:00',4.43),('11288','2013-09-06','15:55:00',4.32),('11288','2013-09-06','16:00:00',4.24),('11288','2013-09-06','16:05:00',4.16),('11288','2013-09-06','16:10:00',4.03),('11288','2013-09-06','16:15:00',3.94),('11288','2013-09-06','16:20:00',3.84),('11288','2013-09-06','16:25:00',3.74),('11288','2013-09-06','16:30:00',3.69),('11288','2013-09-06','16:35:00',3.53),('11288','2013-09-06','16:40:00',3.42),('11288','2013-09-06','16:45:00',3.23),('11288','2013-09-06','16:50:00',3.14),('11288','2013-09-06','16:55:00',2.99),('11288','2013-09-06','17:00:00',2.91),('11288','2013-09-06','17:05:00',2.74),('11288','2013-09-06','17:10:00',2.58),('11288','2013-09-06','17:15:00',2.5),('11288','2013-09-06','17:20:00',2.35),('11288','2013-09-06','17:25:00',2.2),('11288','2013-09-06','17:30:00',2.06),('11288','2013-09-06','17:35:00',1.93),('11288','2013-09-06','17:40:00',1.82),('11288','2013-09-06','17:45:00',1.69),('11288','2013-09-06','17:50:00',1.52),('11288','2013-09-06','17:55:00',1.4),('11288','2013-09-06','18:00:00',1.32),('11288','2013-09-06','18:05:00',1.2),('11288','2013-09-06','18:10:00',1.1),('11288','2013-09-05','08:10:00',1.1),('11288','2013-09-05','08:15:00',1.24),('11288','2013-09-05','08:20:00',1.42),('11288','2013-09-05','08:25:00',1.6),('11288','2013-09-05','08:30:00',1.71),('11288','2013-09-05','08:35:00',1.85),('11288','2013-09-05','08:40:00',1.98),('11288','2013-09-05','08:45:00',2.1),('11288','2013-09-05','08:50:00',2.33),('11288','2013-09-05','08:55:00',2.4),('11288','2013-09-05','09:00:00',2.48),('11288','2013-09-05','09:05:00',2.61),('11288','2013-09-05','09:10:00',2.58),('11288','2013-09-05','09:15:00',2.71),('11288','2013-09-05','09:20:00',3.03),('11288','2013-09-05','09:25:00',3.17),('11288','2013-09-05','09:30:00',3.3),('11288','2013-09-05','09:35:00',3.4),('11288','2013-09-05','09:40:00',3.43),('11288','2013-09-05','09:45:00',3.33),('11288','2013-09-05','09:50:00',3.77),('11288','2013-09-05','09:55:00',4),('11288','2013-09-05','10:00:00',4.11),('11288','2013-09-05','10:05:00',4.26),('11288','2013-09-05','10:10:00',4.38),('11288','2013-09-05','10:15:00',4.51),('11288','2013-09-05','10:20:00',4.61),('11288','2013-09-05','10:25:00',4.66),('11288','2013-09-05','10:30:00',4.79),('11288','2013-09-05','10:35:00',4.86),('11288','2013-09-05','10:40:00',4.92),('11288','2013-09-05','10:45:00',5),('11288','2013-09-05','10:50:00',5.07),('11288','2013-09-05','10:55:00',5.14),('11288','2013-09-05','11:00:00',5.28),('11288','2013-09-05','11:05:00',5.34),('11288','2013-09-05','11:10:00',5.36),('11288','2013-09-05','11:15:00',5.4),('11288','2013-09-05','11:20:00',5.46),('11288','2013-09-05','11:25:00',5.54),('11288','2013-09-05','11:30:00',5.55),('11288','2013-09-05','11:35:00',5.54),('11288','2013-09-05','11:40:00',5.56),('11288','2013-09-05','11:45:00',5.55),('11288','2013-09-05','11:50:00',5.66),('11288','2013-09-05','11:55:00',5.77),('11288','2013-09-05','12:00:00',5.83),('11288','2013-09-05','12:05:00',5.91),('11288','2013-09-05','12:10:00',5.94),('11288','2013-09-05','12:15:00',5.98),('11288','2013-09-05','12:20:00',5.98),('11288','2013-09-05','12:25:00',6.03),('11288','2013-09-05','12:30:00',6),('11288','2013-09-05','12:35:00',6),('11288','2013-09-05','12:40:00',6.03),('11288','2013-09-05','12:45:00',6.03),('11288','2013-09-05','12:50:00',6.06),('11288','2013-09-05','12:55:00',6.08),('11288','2013-09-05','13:00:00',6.05),('11288','2013-09-05','13:05:00',6.04),('11288','2013-09-05','13:10:00',6.06),('11288','2013-09-05','13:15:00',6.06),('11288','2013-09-05','13:20:00',6.03),('11288','2013-09-05','13:25:00',6.01),('11288','2013-09-05','13:30:00',6.07),('11288','2013-09-05','13:35:00',6.04),('11288','2013-09-05','13:40:00',5.99),('11288','2013-09-05','13:45:00',5.93),('11288','2013-09-05','13:50:00',5.88),('11288','2013-09-05','13:55:00',5.85),('11288','2013-09-05','14:00:00',5.82),('11288','2013-09-05','14:05:00',5.8),('11288','2013-09-05','14:10:00',5.81),('11288','2013-09-05','14:15:00',5.76),('11288','2013-09-05','14:20:00',5.71),('11288','2013-09-05','14:25:00',5.63),('11288','2013-09-05','14:30:00',5.61),('11288','2013-09-05','14:35:00',5.52),('11288','2013-09-05','14:40:00',5.51),('11288','2013-09-05','14:45:00',5.46),('11288','2013-09-05','14:50:00',5.42),('11288','2013-09-05','14:55:00',5.42),('11288','2013-09-05','15:00:00',5.4),('11288','2013-09-05','15:05:00',5.33),('11288','2013-09-05','15:10:00',5.24),('11288','2013-09-05','15:15:00',5.19),('11288','2013-09-05','15:20:00',5.13),('11288','2013-09-05','15:25:00',5.03),('11288','2013-09-05','15:30:00',4.96),('11288','2013-09-05','15:35:00',4.88),('11288','2013-09-05','15:40:00',4.82),('11288','2013-09-05','15:45:00',4.72),('11288','2013-09-05','15:50:00',4.62),('11288','2013-09-05','15:55:00',4.53),('11288','2013-09-05','16:00:00',4.42),('11288','2013-09-05','16:05:00',4.36),('11288','2013-09-05','16:10:00',4.25),('11288','2013-09-05','16:15:00',4.16),('11288','2013-09-05','16:20:00',4.04),('11288','2013-09-05','16:25:00',3.94),('11288','2013-09-05','16:30:00',3.87),('11288','2013-09-05','16:35:00',3.84),('11288','2013-09-05','16:40:00',3.73),('11288','2013-09-05','16:45:00',3.64),('11288','2013-09-05','16:50:00',2.9),('11288','2013-09-05','16:55:00',2.36),('11288','2013-09-05','17:00:00',1.93),('11288','2013-09-05','17:05:00',2.17),('11288','2013-09-05','17:10:00',2.09),('11288','2013-09-05','17:15:00',1.9),('11288','2013-09-05','17:20:00',2.11),('11288','2013-09-05','17:25:00',2.1),('11288','2013-09-05','17:30:00',2.08),('11288','2013-09-05','17:35:00',2.22),('11288','2013-09-05','17:40:00',2.27),('11288','2013-09-05','17:45:00',1.99),('11288','2013-09-05','17:50:00',1.84),('11288','2013-09-05','17:55:00',1.6),('11288','2013-09-05','18:00:00',1.2),('11288','2013-09-05','18:05:00',1.08),('11288','2013-09-05','18:10:00',1.04),('11288','2013-09-05','18:15:00',1),('11288','2013-09-05','18:20:00',1.11),('11288','2013-09-04','08:05:00',1.01),('11288','2013-09-04','08:10:00',1.08),('11288','2013-09-04','08:15:00',1.25),('11288','2013-09-04','08:20:00',1.45),('11288','2013-09-04','08:25:00',1.56),('11288','2013-09-04','08:30:00',1.72),('11288','2013-09-04','08:35:00',1.87),('11288','2013-09-04','08:40:00',2.01),('11288','2013-09-04','08:45:00',2.11),('11288','2013-09-04','08:50:00',2.34),('11288','2013-09-04','08:55:00',2.38),('11288','2013-09-04','09:00:00',2.58),('11288','2013-09-04','09:05:00',2.68),('11288','2013-09-04','09:10:00',2.75),('11288','2013-09-04','09:15:00',2.75),('11288','2013-09-04','09:20:00',3.13),('11288','2013-09-04','09:25:00',3.25),('11288','2013-09-04','09:30:00',3.39),('11288','2013-09-04','09:35:00',3.6),('11288','2013-09-04','09:40:00',3.61),('11288','2013-09-04','09:45:00',3.64),('11288','2013-09-04','09:50:00',4),('11288','2013-09-04','09:55:00',4.13),('11288','2013-09-04','10:00:00',4.29),('11288','2013-09-04','10:05:00',4.47),('11288','2013-09-04','10:10:00',4.59),('11288','2013-09-04','10:15:00',4.66),('11288','2013-09-04','10:20:00',4.77),('11288','2013-09-04','10:25:00',4.85),('11288','2013-09-04','10:30:00',4.97),('11288','2013-09-04','10:35:00',5.03),('11288','2013-09-04','10:40:00',5.13),('11288','2013-09-04','10:45:00',5.21),('11288','2013-09-04','10:50:00',5.32),('11288','2013-09-04','10:55:00',5.41),('11288','2013-09-04','11:00:00',5.49),('11288','2013-09-04','11:05:00',5.53),('11288','2013-09-04','11:10:00',5.61),('11288','2013-09-04','11:15:00',5.66),('11288','2013-09-04','11:20:00',5.72),('11288','2013-09-04','11:25:00',5.74),('11288','2013-09-04','11:30:00',5.78),('11288','2013-09-04','11:35:00',5.84),('11288','2013-09-04','11:40:00',5.92),('11288','2013-09-04','11:45:00',5.96),('11288','2013-09-04','11:50:00',6.02),('11288','2013-09-04','11:55:00',6.08),('11288','2013-09-04','12:00:00',6.13),('11288','2013-09-04','12:05:00',6.2),('11288','2013-09-04','12:10:00',6.24),('11288','2013-09-04','12:15:00',6.23),('11288','2013-09-04','12:20:00',6.23),('11288','2013-09-04','12:25:00',6.31),('11288','2013-09-04','12:30:00',6.33),('11288','2013-09-04','12:35:00',6.36),('11288','2013-09-04','12:40:00',6.39),('11288','2013-09-04','12:45:00',6.38),('11288','2013-09-04','12:50:00',6.29),('11288','2013-09-04','12:55:00',6.3),('11288','2013-09-04','13:00:00',6.3),('11288','2013-09-04','13:05:00',6.31),('11288','2013-09-04','13:10:00',6.35),('11288','2013-09-04','13:15:00',6.32),('11288','2013-09-04','13:20:00',6.28),('11288','2013-09-04','13:25:00',6.27),('11288','2013-09-04','13:30:00',6.28),('11288','2013-09-04','13:35:00',6.27),('11288','2013-09-04','13:40:00',6.27),('11288','2013-09-04','13:45:00',6.22),('11288','2013-09-04','13:50:00',6.22),('11288','2013-09-04','13:55:00',6.2),('11288','2013-09-04','14:00:00',6.16),('11288','2013-09-04','14:05:00',6.12),('11288','2013-09-04','14:10:00',6.08),('11288','2013-09-04','14:15:00',6.05),('11288','2013-09-04','14:20:00',5.97),('11288','2013-09-04','14:25:00',5.95),('11288','2013-09-04','14:30:00',5.95),('11288','2013-09-04','14:35:00',5.9),('11288','2013-09-04','14:40:00',5.87),('11288','2013-09-04','14:45:00',5.8),('11288','2013-09-04','14:50:00',5.73),('11288','2013-09-04','14:55:00',5.66),('11288','2013-09-04','15:00:00',5.57),('11288','2013-09-04','15:05:00',5.52),('11288','2013-09-04','15:10:00',5.5),('11288','2013-09-04','15:15:00',5.41),('11288','2013-09-04','15:20:00',5.38),('11288','2013-09-04','15:25:00',5.27),('11288','2013-09-04','15:30:00',5.2),('11288','2013-09-04','15:35:00',5.11),('11288','2013-09-04','15:40:00',5.03),('11288','2013-09-04','15:45:00',4.94),('11288','2013-09-04','15:50:00',4.81),('11288','2013-09-04','15:55:00',4.7),('11288','2013-09-04','16:00:00',4.61),('11288','2013-09-04','16:05:00',4.47),('11288','2013-09-04','16:10:00',4.32),('11288','2013-09-04','16:15:00',4.23),('11288','2013-09-04','16:20:00',4.14),('11288','2013-09-04','16:25:00',4.02),('11288','2013-09-04','16:30:00',3.91),('11288','2013-09-04','16:35:00',3.8),('11288','2013-09-04','16:40:00',3.67),('11288','2013-09-04','16:45:00',3.55),('11288','2013-09-04','16:50:00',3.38),('11288','2013-09-04','16:55:00',3.27),('11288','2013-09-04','17:00:00',3.13),('11288','2013-09-04','17:05:00',3),('11288','2013-09-04','17:10:00',2.86),('11288','2013-09-04','17:15:00',2.74),('11288','2013-09-04','17:20:00',2.58),('11288','2013-09-04','17:25:00',2.46),('11288','2013-09-04','17:30:00',2.32),('11288','2013-09-04','17:35:00',2.18),('11288','2013-09-04','17:40:00',2.01),('11288','2013-09-04','17:45:00',1.85),('11288','2013-09-04','17:50:00',1.69),('11288','2013-09-04','17:55:00',1.57),('11288','2013-09-04','18:00:00',1.45),('11288','2013-09-04','18:05:00',1.31),('11288','2013-09-04','18:10:00',1.2),('11288','2013-09-04','18:15:00',1.05),('11288','2013-09-03','08:05:00',1.01),('11288','2013-09-03','08:10:00',1.07),('11288','2013-09-03','08:15:00',1.21),('11288','2013-09-03','08:20:00',1.36),('11288','2013-09-03','08:25:00',1.49),('11288','2013-09-03','08:30:00',1.64),('11288','2013-09-03','08:35:00',1.81),('11288','2013-09-03','08:40:00',1.9),('11288','2013-09-03','08:45:00',2.04),('11288','2013-09-03','08:50:00',2.19),('11288','2013-09-03','08:55:00',2.3),('11288','2013-09-03','09:00:00',2.39),('11288','2013-09-03','09:05:00',2.53),('11288','2013-09-03','09:10:00',2.66),('11288','2013-09-03','09:15:00',2.63),('11288','2013-09-03','09:20:00',2.91),('11288','2013-09-03','09:25:00',3.13),('11288','2013-09-03','09:30:00',3.23),('11288','2013-09-03','09:35:00',3.43),('11288','2013-09-03','09:40:00',3.35),('11288','2013-09-03','09:45:00',3.39),('11288','2013-09-03','09:50:00',3.72),('11288','2013-09-03','09:55:00',3.82),('11288','2013-09-03','10:00:00',3.94),('11288','2013-09-03','10:05:00',4.12),('11288','2013-09-03','10:10:00',4.23),('11288','2013-09-03','10:15:00',4.34),('11288','2013-09-03','10:20:00',4.49),('11288','2013-09-03','10:25:00',4.59),('11288','2013-09-03','10:30:00',4.71),('11288','2013-09-03','10:35:00',4.81),('11288','2013-09-03','10:40:00',4.94),('11288','2013-09-03','10:45:00',5.04),('11288','2013-09-03','10:50:00',5.13),('11288','2013-09-03','10:55:00',5.24),('11288','2013-09-03','11:00:00',5.28),('11288','2013-09-03','11:05:00',5.33),('11288','2013-09-03','11:10:00',5.36),('11288','2013-09-03','11:15:00',5.42),('11288','2013-09-03','11:20:00',5.47),('11288','2013-09-03','11:25:00',5.5),('11288','2013-09-03','11:30:00',5.56),('11288','2013-09-03','11:35:00',5.61),('11288','2013-09-03','11:40:00',5.66),('11288','2013-09-03','11:45:00',5.69),('11288','2013-09-03','11:50:00',5.75),('11288','2013-09-03','11:55:00',5.81),('11288','2013-09-03','12:00:00',5.92),('11288','2013-09-03','12:05:00',5.97),('11288','2013-09-03','12:10:00',5.98),('11288','2013-09-03','12:15:00',6.01),('11288','2013-09-03','12:20:00',6.05),('11288','2013-09-03','12:25:00',6.11),('11288','2013-09-03','12:30:00',6.15),('11288','2013-09-03','12:35:00',6.15),('11288','2013-09-03','12:40:00',6.19),('11288','2013-09-03','12:45:00',6.21),('11288','2013-09-03','12:50:00',6.16),('11288','2013-09-03','12:55:00',6.17),('11288','2013-09-03','13:00:00',6.19),('11288','2013-09-03','13:05:00',6.17),('11288','2013-09-03','13:10:00',6.2),('11288','2013-09-03','13:15:00',6.17),('11288','2013-09-03','13:20:00',6.18),('11288','2013-09-03','13:25:00',6.12),('11288','2013-09-03','13:30:00',6.11),('11288','2013-09-03','13:35:00',6.11),('11288','2013-09-03','13:40:00',6.1),('11288','2013-09-03','13:45:00',6.06),('11288','2013-09-03','13:50:00',6.08),('11288','2013-09-03','13:55:00',6.08),('11288','2013-09-03','14:00:00',6.01),('11288','2013-09-03','14:05:00',5.88),('11288','2013-09-03','14:10:00',5.83),('11288','2013-09-03','14:15:00',5.86),('11288','2013-09-03','14:20:00',5.81),('11288','2013-09-03','14:25:00',5.8),('11288','2013-09-03','14:30:00',5.78),('11288','2013-09-03','14:35:00',5.77),('11288','2013-09-03','14:40:00',5.75),('11288','2013-09-03','14:45:00',5.67),('11288','2013-09-03','14:50:00',5.65),('11288','2013-09-03','14:55:00',5.63),('11288','2013-09-03','15:00:00',5.55),('11288','2013-09-03','15:05:00',5.4),('11288','2013-09-03','15:10:00',5.26),('11288','2013-09-03','15:15:00',5.28),('11288','2013-09-03','15:20:00',5.24),('11288','2013-09-03','15:25:00',5.17),('11288','2013-09-03','15:30:00',5.1),('11288','2013-09-03','15:35:00',4.95),('11288','2013-09-03','15:40:00',4.89),('11288','2013-09-03','15:45:00',4.77),('11288','2013-09-03','15:50:00',4.68),('11288','2013-09-03','15:55:00',4.6),('11288','2013-09-03','16:00:00',4.51),('11288','2013-09-03','16:05:00',4.47),('11288','2013-09-03','16:10:00',4.36),('11288','2013-09-03','16:15:00',4.23),('11288','2013-09-03','16:20:00',4.12),('11288','2013-09-03','16:25:00',4.01),('11288','2013-09-03','16:30:00',3.88),('11288','2013-09-03','16:35:00',3.76),('11288','2013-09-03','16:40:00',3.66),('11288','2013-09-03','16:45:00',3.53),('11288','2013-09-03','16:50:00',3.37),('11288','2013-09-03','16:55:00',3.28),('11288','2013-09-03','17:00:00',3.15),('11288','2013-09-03','17:05:00',3),('11288','2013-09-03','17:10:00',2.88),('11288','2013-09-03','17:15:00',2.74),('11288','2013-09-03','17:20:00',2.62),('11288','2013-09-03','17:25:00',2.48),('11288','2013-09-03','17:30:00',2.35),('11288','2013-09-03','17:35:00',2.2),('11288','2013-09-03','17:40:00',2.05),('11288','2013-09-03','17:45:00',1.92),('11288','2013-09-03','17:50:00',1.79),('11288','2013-09-03','17:55:00',1.61),('11288','2013-09-03','18:00:00',1.33),('11288','2013-09-03','18:05:00',1.22),('11288','2013-09-03','18:10:00',1.16),('11288','2013-09-03','18:15:00',1.07),('11288','2013-09-02','08:05:00',1.1),('11288','2013-09-02','08:10:00',1.17),('11288','2013-09-02','08:15:00',1.29),('11288','2013-09-02','08:20:00',1.44),('11288','2013-09-02','08:25:00',1.54),('11288','2013-09-02','08:30:00',1.71),('11288','2013-09-02','08:35:00',1.86),('11288','2013-09-02','08:40:00',2),('11288','2013-09-02','08:45:00',2.14),('11288','2013-09-02','08:50:00',2.29),('11288','2013-09-02','08:55:00',2.32),('11288','2013-09-02','09:00:00',2.5),('11288','2013-09-02','09:05:00',2.6),('11288','2013-09-02','09:10:00',2.73),('11288','2013-09-02','09:15:00',2.86),('11288','2013-09-02','09:20:00',3.03),('11288','2013-09-02','09:25:00',3.1),('11288','2013-09-02','09:30:00',3.16),('11288','2013-09-02','09:35:00',3.46),('11288','2013-09-02','09:40:00',3.46),('11288','2013-09-02','09:45:00',3.56),('11288','2013-09-02','09:50:00',3.85),('11288','2013-09-02','09:55:00',3.73),('11288','2013-09-02','10:00:00',3.97),('11288','2013-09-02','10:05:00',4.26),('11288','2013-09-02','10:10:00',4.37),('11288','2013-09-02','10:15:00',4.5),('11288','2013-09-02','10:20:00',4.59),('11288','2013-09-02','10:25:00',4.7),('11288','2013-09-02','10:30:00',4.79),('11288','2013-09-02','10:35:00',4.91),('11288','2013-09-02','10:40:00',4.99),('11288','2013-09-02','10:45:00',5.05),('11288','2013-09-02','10:50:00',5.13),('11288','2013-09-02','10:55:00',5.23),('11288','2013-09-02','11:00:00',5.28),('11288','2013-09-02','11:05:00',5.34),('11288','2013-09-02','11:10:00',5.4),('11288','2013-09-02','11:15:00',5.47),('11288','2013-09-02','11:20:00',5.49),('11288','2013-09-02','11:25:00',5.54),('11288','2013-09-02','11:30:00',5.59),('11288','2013-09-02','11:35:00',5.66),('11288','2013-09-02','11:40:00',5.7),('11288','2013-09-02','11:45:00',5.71),('11288','2013-09-02','11:50:00',5.73),('11288','2013-09-02','11:55:00',5.78),('11288','2013-09-02','12:00:00',5.9),('11288','2013-09-02','12:05:00',5.95),('11288','2013-09-02','12:10:00',5.98),('11288','2013-09-02','12:15:00',6.05),('11288','2013-09-02','12:20:00',6.04),('11288','2013-09-02','12:25:00',6.04),('11288','2013-09-02','12:30:00',6.05),('11288','2013-09-02','12:35:00',5.99),('11288','2013-09-02','12:40:00',6.03),('11288','2013-09-02','12:45:00',6.05),('11288','2013-09-02','12:50:00',6.08),('11288','2013-09-02','12:55:00',6.14),('11288','2013-09-02','13:00:00',6.16),('11288','2013-09-02','13:05:00',6.13),('11288','2013-09-02','13:10:00',6.12),('11288','2013-09-02','13:15:00',6.1),('11288','2013-09-02','13:20:00',6.06),('11288','2013-09-02','13:25:00',6.07),('11288','2013-09-02','13:30:00',5.98),('11288','2013-09-02','13:35:00',5.89),('11288','2013-09-02','13:40:00',5.81),('11288','2013-09-02','13:45:00',6.11),('11288','2013-09-02','13:50:00',5.64),('11288','2013-09-02','13:55:00',1.73),('11288','2013-09-02','14:00:00',6.26),('11288','2013-09-02','14:05:00',6.2),('11288','2013-09-02','14:10:00',6.04),('11288','2013-09-02','14:15:00',5.97),('11288','2013-09-02','14:20:00',5.76),('11288','2013-09-02','14:25:00',5.78),('11288','2013-09-02','14:30:00',5.88),('11288','2013-09-02','14:35:00',5.78),('11288','2013-09-02','14:40:00',5.8),('11288','2013-09-02','14:45:00',5.85),('11288','2013-09-02','14:50:00',5.82),('11288','2013-09-02','14:55:00',3.52),('11288','2013-09-02','15:00:00',3.94),('11288','2013-09-02','15:05:00',5.01),('11288','2013-09-02','15:10:00',2.87),('11288','2013-09-02','15:15:00',2.98),('11288','2013-09-02','15:20:00',1.47),('11288','2013-09-02','15:25:00',3.75),('11288','2013-09-02','15:30:00',5.17),('11288','2013-09-02','15:35:00',4.83),('11288','2013-09-02','15:40:00',4.42),('11288','2013-09-02','15:45:00',4.74),('11288','2013-09-02','15:50:00',4.79),('11288','2013-09-02','15:55:00',4.71),('11288','2013-09-02','16:00:00',4.66),('11288','2013-09-02','16:05:00',4.53),('11288','2013-09-02','16:10:00',4.39),('11288','2013-09-02','16:15:00',4.33),('11288','2013-09-02','16:20:00',4.25),('11288','2013-09-02','16:25:00',4.06),('11288','2013-09-02','16:30:00',3.9),('11288','2013-09-02','16:35:00',3.8),('11288','2013-09-02','16:40:00',3.66),('11288','2013-09-02','16:45:00',3.5),('11288','2013-09-02','16:50:00',3.32),('11288','2013-09-02','16:55:00',3.14),('11288','2013-09-02','17:00:00',3.02),('11288','2013-09-02','17:05:00',2.88),('11288','2013-09-02','17:10:00',2.78),('11288','2013-09-02','17:15:00',2.65),('11288','2013-09-02','17:20:00',2.55),('11288','2013-09-02','17:25:00',2.43),('11288','2013-09-02','17:30:00',2.3),('11288','2013-09-02','17:35:00',2.14),('11288','2013-09-02','17:40:00',2.01),('11288','2013-09-02','17:45:00',1.89),('11288','2013-09-02','17:50:00',1.75),('11288','2013-09-02','17:55:00',1.65),('11288','2013-09-02','18:00:00',1.52),('11288','2013-09-02','18:05:00',1.38),('11288','2013-09-02','18:10:00',1.26),('11288','2013-09-02','18:15:00',1.14),('11288','2013-09-02','18:20:00',1.01),('11288','2013-09-01','08:05:00',1.07),('11288','2013-09-01','08:10:00',1.19),('11288','2013-09-01','08:15:00',1.34),('11288','2013-09-01','08:20:00',1.43),('11288','2013-09-01','08:25:00',1.53),('11288','2013-09-01','08:30:00',1.68),('11288','2013-09-01','08:35:00',1.9),('11288','2013-09-01','08:40:00',2.08),('11288','2013-09-01','08:45:00',2.26),('11288','2013-09-01','08:50:00',2.33),('11288','2013-09-01','08:55:00',2.44),('11288','2013-09-01','09:00:00',2.57),('11288','2013-09-01','09:05:00',2.73),('11288','2013-09-01','09:10:00',2.73),('11288','2013-09-01','09:15:00',2.98),('11288','2013-09-01','09:20:00',3.17),('11288','2013-09-01','09:25:00',3.26),('11288','2013-09-01','09:30:00',3.27),('11288','2013-09-01','09:35:00',3.52),('11288','2013-09-01','09:40:00',3.6),('11288','2013-09-01','09:45:00',3.72),('11288','2013-09-01','09:50:00',3.89),('11288','2013-09-01','09:55:00',3.89),('11288','2013-09-01','10:00:00',4.02),('11288','2013-09-01','10:05:00',4.29),('11288','2013-09-01','10:10:00',4.44),('11288','2013-09-01','10:15:00',4.53),('11288','2013-09-01','10:20:00',4.61),('11288','2013-09-01','10:25:00',4.73),('11288','2013-09-01','10:30:00',4.85),('11288','2013-09-01','10:35:00',4.92),('11288','2013-09-01','10:40:00',5.01),('11288','2013-09-01','10:45:00',5.08),('11288','2013-09-01','10:50:00',5.15),('11288','2013-09-01','10:55:00',5.29),('11288','2013-09-01','11:00:00',5.32),('11288','2013-09-01','11:05:00',5.42),('11288','2013-09-01','11:10:00',5.46),('11288','2013-09-01','11:15:00',5.51),('11288','2013-09-01','11:20:00',5.49),('11288','2013-09-01','11:25:00',5.6),('11288','2013-09-01','11:30:00',5.57),('11288','2013-09-01','11:35:00',5.66),('11288','2013-09-01','11:40:00',5.74),('11288','2013-09-01','11:45:00',5.81),('11288','2013-09-01','11:50:00',5.84),('11288','2013-09-01','11:55:00',5.84),('11288','2013-09-01','12:00:00',5.88),('11288','2013-09-01','12:05:00',5.8),('11288','2013-09-01','12:10:00',5.96),('11288','2013-09-01','12:15:00',6.03),('11288','2013-09-01','12:20:00',6.09),('11288','2013-09-01','12:25:00',5.92),('11288','2013-09-01','12:30:00',6.12),('11288','2013-09-01','12:35:00',6.14),('11288','2013-09-01','12:40:00',6.19),('11288','2013-09-01','12:45:00',6.08),('11288','2013-09-01','12:50:00',6.15),('11288','2013-09-01','12:55:00',6.14),('11288','2013-09-01','13:00:00',6.28),('11288','2013-09-01','13:05:00',6.28),('11288','2013-09-01','13:10:00',6.25),('11288','2013-09-01','13:15:00',5.54),('11288','2013-09-01','13:20:00',6.3),('11288','2013-09-01','13:25:00',6.29),('11288','2013-09-01','13:30:00',6.33),('11288','2013-09-01','13:35:00',6.14),('11288','2013-09-01','13:40:00',6.21),('11288','2013-09-01','13:45:00',5.84),('11288','2013-09-01','13:50:00',5.25),('11288','2013-09-01','13:55:00',5.32),('11288','2013-09-01','14:00:00',4.76),('11288','2013-09-01','14:05:00',4.83),('11288','2013-09-01','14:10:00',5.57),('11288','2013-09-01','14:15:00',5.59),('11288','2013-09-01','14:20:00',5.08),('11288','2013-09-01','14:25:00',5.11),('11288','2013-09-01','14:30:00',5.27),('11288','2013-09-01','14:35:00',5.2),('11288','2013-09-01','14:40:00',5.27),('11288','2013-09-01','14:45:00',5.33),('11288','2013-09-01','14:50:00',5.26),('11288','2013-09-01','14:55:00',5.14),('11288','2013-09-01','15:00:00',5.11),('11288','2013-09-01','15:05:00',5.04),('11288','2013-09-01','15:10:00',5.02),('11288','2013-09-01','15:15:00',5),('11288','2013-09-01','15:20:00',4.64),('11288','2013-09-01','15:25:00',4.01),('11288','2013-09-01','15:30:00',3.43),('11288','2013-09-01','15:35:00',3.81),('11288','2013-09-01','15:40:00',4.49),('11288','2013-09-01','15:45:00',4.13),('11288','2013-09-01','15:50:00',3.04),('11288','2013-09-01','15:55:00',3.59),('11288','2013-09-01','16:00:00',4.3),('11288','2013-09-01','16:05:00',4.54),('11288','2013-09-01','16:10:00',4.31),('11288','2013-09-01','16:15:00',4.28),('11288','2013-09-01','16:20:00',3.83),('11288','2013-09-01','16:25:00',4.02),('11288','2013-09-01','16:30:00',4.18),('11288','2013-09-01','16:35:00',4.01),('11288','2013-09-01','16:40:00',3.89),('11288','2013-09-01','16:45:00',3.52),('11288','2013-09-01','16:50:00',3.45),('11288','2013-09-01','16:55:00',3.03),('11288','2013-09-01','17:00:00',2.56),('11288','2013-09-01','17:05:00',2.65),('11288','2013-09-01','17:10:00',2.24),('11288','2013-09-01','17:15:00',2.26),('11288','2013-09-01','17:20:00',2.42),('11288','2013-09-01','17:25:00',2.29),('11288','2013-09-01','17:30:00',2.01),('11288','2013-09-01','17:35:00',2.02),('11288','2013-09-01','17:40:00',2.07),('11288','2013-09-01','17:45:00',1.67),('11288','2013-09-01','17:50:00',1.56),('11288','2013-09-01','17:55:00',1.54),('11288','2013-09-01','18:00:00',1.54),('11288','2013-09-01','18:05:00',1.51),('11288','2013-09-01','18:10:00',1.57),('11288','2013-09-01','18:15:00',1.45),('11288','2013-09-01','18:20:00',1.29),('11288','2013-09-01','18:25:00',1.25),('11288','2013-09-01','18:30:00',1.17),('11288','2013-09-01','18:35:00',1.05),('11288','2013-09-01','18:40:00',1.09),('11288','2013-09-01','18:45:00',1.01),('11288','2013-08-31','08:20:00',1.18),('11288','2013-08-31','08:25:00',1.51),('11288','2013-08-31','08:30:00',1.76),('11288','2013-08-31','08:35:00',1.87),('11288','2013-08-31','08:40:00',2.15),('11288','2013-08-31','08:45:00',2.38),('11288','2013-08-31','08:50:00',2.58),('11288','2013-08-31','08:55:00',2.84),('11288','2013-08-31','09:00:00',2.92),('11288','2013-08-31','09:05:00',2.62),('11288','2013-08-31','09:10:00',2.29),('11288','2013-08-31','09:15:00',2.9),('11288','2013-08-31','09:20:00',2.94),('11288','2013-08-31','09:25:00',3.49),('11288','2013-08-31','09:30:00',3.52),('11288','2013-08-31','09:35:00',3.71),('11288','2013-08-31','09:40:00',3.9),('11288','2013-08-31','09:45:00',3.78),('11288','2013-08-31','09:50:00',3.83),('11288','2013-08-31','09:55:00',4.13),('11288','2013-08-31','10:00:00',4.37),('11288','2013-08-31','10:05:00',4.35),('11288','2013-08-31','10:10:00',4.59),('11288','2013-08-31','10:15:00',4.67),('11288','2013-08-31','10:20:00',4.75),('11288','2013-08-31','10:25:00',4.9),('11288','2013-08-31','10:30:00',5.03),('11288','2013-08-31','10:35:00',5.19),('11288','2013-08-31','10:40:00',5.21),('11288','2013-08-31','10:45:00',5.3),('11288','2013-08-31','10:50:00',5.46),('11288','2013-08-31','10:55:00',5.55),('11288','2013-08-31','11:00:00',5.67),('11288','2013-08-31','11:05:00',5.73),('11288','2013-08-31','11:10:00',5.76),('11288','2013-08-31','11:15:00',5.82),('11288','2013-08-31','11:20:00',5.89),('11288','2013-08-31','11:25:00',5.94),('11288','2013-08-31','11:30:00',6.01),('11288','2013-08-31','11:35:00',6.05),('11288','2013-08-31','11:40:00',6.1),('11288','2013-08-31','11:45:00',6.15),('11288','2013-08-31','11:50:00',6.19),('11288','2013-08-31','11:55:00',6.22),('11288','2013-08-31','12:00:00',6.05),('11288','2013-08-31','12:05:00',5.02),('11288','2013-08-31','12:10:00',4.99),('11288','2013-08-31','12:15:00',5.82),('11288','2013-08-31','12:20:00',6.36),('11288','2013-08-31','12:25:00',6.31),('11288','2013-08-31','12:30:00',6.3),('11288','2013-08-31','12:35:00',6.36),('11288','2013-08-31','12:40:00',6.28),('11288','2013-08-31','12:45:00',6.33),('11288','2013-08-31','12:50:00',6.28),('11288','2013-08-31','12:55:00',6.31),('11288','2013-08-31','13:00:00',6.3),('11288','2013-08-31','13:05:00',6.33),('11288','2013-08-31','13:10:00',6.23),('11288','2013-08-31','13:15:00',6.31),('11288','2013-08-31','13:20:00',6.31),('11288','2013-08-31','13:25:00',6.28),('11288','2013-08-31','13:30:00',6.32),('11288','2013-08-31','13:35:00',6.2),('11288','2013-08-31','13:40:00',6.16),('11288','2013-08-31','13:45:00',6.09),('11288','2013-08-31','13:50:00',6.18),('11288','2013-08-31','13:55:00',6.13),('11288','2013-08-31','14:00:00',6.15),('11288','2013-08-31','14:05:00',6.1),('11288','2013-08-31','14:10:00',6.06),('11288','2013-08-31','14:15:00',6.01),('11288','2013-08-31','14:20:00',5.95),('11288','2013-08-31','14:25:00',5.88),('11288','2013-08-31','14:30:00',5.81),('11288','2013-08-31','14:35:00',5.58),('11288','2013-08-31','14:40:00',5.68),('11288','2013-08-31','14:45:00',5.63),('11288','2013-08-31','14:50:00',5.67),('11288','2013-08-31','14:55:00',5.51),('11288','2013-08-31','15:00:00',5.47),('11288','2013-08-31','15:05:00',5.45),('11288','2013-08-31','15:10:00',5.39),('11288','2013-08-31','15:15:00',5.33),('11288','2013-08-31','15:20:00',5.24),('11288','2013-08-31','15:25:00',5.17),('11288','2013-08-31','15:30:00',5.16),('11288','2013-08-31','15:35:00',5),('11288','2013-08-31','15:40:00',4.97),('11288','2013-08-31','15:45:00',4.86),('11288','2013-08-31','15:50:00',4.76),('11288','2013-08-31','15:55:00',4.59),('11288','2013-08-31','16:00:00',4.53),('11288','2013-08-31','16:05:00',4.43),('11288','2013-08-31','16:10:00',4.36),('11288','2013-08-31','16:15:00',4.25),('11288','2013-08-31','16:20:00',4.19),('11288','2013-08-31','16:25:00',4.01),('11288','2013-08-31','16:30:00',3.9),('11288','2013-08-31','16:35:00',3.87),('11288','2013-08-31','16:40:00',3.75),('11288','2013-08-31','16:45:00',3.55),('11288','2013-08-31','16:50:00',3.4),('11288','2013-08-31','16:55:00',3.27),('11288','2013-08-31','17:00:00',3.14),('11288','2013-08-31','17:05:00',3.06),('11288','2013-08-31','17:10:00',2.93),('11288','2013-08-31','17:15:00',2.77),('11288','2013-08-31','17:20:00',2.68),('11288','2013-08-31','17:25:00',2.53),('11288','2013-08-31','17:30:00',2.39),('11288','2013-08-31','17:35:00',2.19),('11288','2013-08-31','17:40:00',2.1),('11288','2013-08-31','17:45:00',1.92),('11288','2013-08-31','17:50:00',1.77),('11288','2013-08-31','17:55:00',1.51),('11288','2013-08-31','18:05:00',1.08),('11288','2013-08-31','18:10:00',1.1),('11288','2013-08-31','18:20:00',1),('11288','2013-08-30','07:55:00',1.02),('11288','2013-08-30','08:00:00',1.18),('11288','2013-08-30','08:05:00',1.43),('11288','2013-08-30','08:10:00',1.62),('11288','2013-08-30','08:15:00',1.69),('11288','2013-08-30','08:20:00',1.86),('11288','2013-08-30','08:25:00',1.95),('11288','2013-08-30','08:30:00',2.09),('11288','2013-08-30','08:35:00',2.24),('11288','2013-08-30','08:40:00',2.32),('11288','2013-08-30','08:45:00',2.15),('11288','2013-08-30','08:50:00',2.01),('11288','2013-08-30','08:55:00',2.06),('11288','2013-08-30','09:00:00',2.37),('11288','2013-08-30','09:05:00',2.59),('11288','2013-08-30','09:10:00',2.37),('11288','2013-08-30','09:15:00',2.22),('11288','2013-08-30','09:20:00',1.99),('11288','2013-08-30','09:25:00',2.14),('11288','2013-08-30','09:30:00',2.6),('11288','2013-08-30','09:35:00',2.9),('11288','2013-08-30','09:40:00',2.79),('11288','2013-08-30','09:45:00',2.89),('11288','2013-08-30','09:50:00',2.94),('11288','2013-08-30','09:55:00',3.13),('11288','2013-08-30','10:00:00',3.19),('11288','2013-08-30','10:05:00',3.21),('11288','2013-08-30','10:10:00',3.19),('11288','2013-08-30','10:15:00',3.39),('11288','2013-08-30','10:20:00',3.55),('11288','2013-08-30','10:25:00',3.32),('11288','2013-08-30','10:30:00',3.63),('11288','2013-08-30','10:35:00',3.5),('11288','2013-08-30','10:40:00',3.3),('11288','2013-08-30','10:45:00',3.26),('11288','2013-08-30','10:50:00',3.44),('11288','2013-08-30','10:55:00',3.27),('11288','2013-08-30','11:00:00',3.46),('11288','2013-08-30','11:05:00',3.61),('11288','2013-08-30','11:10:00',3.82),('11288','2013-08-30','11:15:00',3.82),('11288','2013-08-30','11:20:00',3.86),('11288','2013-08-30','11:25:00',3.98),('11288','2013-08-30','11:30:00',4.17),('11288','2013-08-30','11:35:00',3.98),('11288','2013-08-30','11:40:00',4.29),('11288','2013-08-30','11:45:00',4.28),('11288','2013-08-30','11:50:00',4.81),('11288','2013-08-30','11:55:00',4.26),('11288','2013-08-30','12:00:00',3.87),('11288','2013-08-30','12:05:00',3.39),('11288','2013-08-30','12:10:00',3.7),('11288','2013-08-30','12:15:00',4.06),('11288','2013-08-30','12:20:00',4.34),('11288','2013-08-30','12:25:00',4.78),('11288','2013-08-30','12:30:00',5.35),('11288','2013-08-30','12:35:00',4.98),('11288','2013-08-30','12:40:00',4.92),('11288','2013-08-30','12:45:00',5.12),('11288','2013-08-30','12:50:00',5),('11288','2013-08-30','12:55:00',4.65),('11288','2013-08-30','13:00:00',4.62),('11288','2013-08-30','13:05:00',4.62),('11288','2013-08-30','13:10:00',4.63),('11288','2013-08-30','13:15:00',4.36),('11288','2013-08-30','13:20:00',5.37),('11288','2013-08-30','13:25:00',5.99),('11288','2013-08-30','13:30:00',6.35),('11288','2013-08-30','13:35:00',5.94),('11288','2013-08-30','13:40:00',6.21),('11288','2013-08-30','13:45:00',5.57),('11288','2013-08-30','13:50:00',5.59),('11288','2013-08-30','13:55:00',6.12),('11288','2013-08-30','14:00:00',6.31),('11288','2013-08-30','14:05:00',6.01),('11288','2013-08-30','14:10:00',6.11),('11288','2013-08-30','14:15:00',5.92),('11288','2013-08-30','14:20:00',6.17),('11288','2013-08-30','14:25:00',6.07),('11288','2013-08-30','14:30:00',5.98),('11288','2013-08-30','14:35:00',6.11),('11288','2013-08-30','14:40:00',5.78),('11288','2013-08-30','14:45:00',4.47),('11288','2013-08-30','14:50:00',4.05),('11288','2013-08-30','14:55:00',4.61),('11288','2013-08-30','15:00:00',4),('11288','2013-08-30','15:05:00',3.72),('11288','2013-08-30','15:10:00',3.82),('11288','2013-08-30','15:15:00',4.67),('11288','2013-08-30','15:20:00',3.89),('11288','2013-08-30','15:25:00',3.63),('11288','2013-08-30','15:30:00',3.47),('11288','2013-08-30','15:35:00',2.85),('11288','2013-08-30','15:40:00',3.14),('11288','2013-08-30','15:45:00',3.66),('11288','2013-08-30','15:50:00',3.93),('11288','2013-08-30','15:55:00',3.76),('11288','2013-08-30','16:00:00',3.57),('11288','2013-08-30','16:05:00',3.13),('11288','2013-08-30','16:10:00',2.62),('11288','2013-08-30','16:15:00',2.43),('11288','2013-08-30','16:20:00',2.72),('11288','2013-08-30','16:25:00',2.62),('11288','2013-08-30','16:30:00',3),('11288','2013-08-30','16:35:00',2.62),('11288','2013-08-30','16:40:00',3.39),('11288','2013-08-30','16:45:00',3.59),('11288','2013-08-30','16:50:00',3.3),('11288','2013-08-30','16:55:00',2.91),('11288','2013-08-30','17:00:00',3.24),('11288','2013-08-30','17:05:00',2.14),('11288','2013-08-30','17:10:00',2.47),('11288','2013-08-30','17:15:00',2.19),('11288','2013-08-30','17:20:00',1.89),('11288','2013-08-30','17:25:00',1.97),('11288','2013-08-30','17:30:00',2.06),('11288','2013-08-30','17:35:00',2.38),('11288','2013-08-30','17:40:00',1.74),('11288','2013-08-30','17:45:00',2.08),('11288','2013-08-30','17:50:00',2.02),('11288','2013-08-30','17:55:00',1.82),('11288','2013-08-30','18:00:00',1.4),('11288','2014-04-11','07:50:00',1.12),('11288','2014-04-11','07:55:00',1.17),('11288','2014-04-11','08:30:00',1.23),('11288','2014-04-11','08:35:00',2.44),('11288','2014-04-11','08:40:00',2.61),('11288','2014-04-11','08:45:00',2.76),('11288','2014-04-11','08:50:00',2.77),('11288','2014-04-11','08:55:00',2.73),('11288','2014-04-11','09:00:00',2.55),('11288','2014-04-11','09:05:00',2.91),('11288','2014-04-11','09:10:00',3.04),('11288','2014-04-11','09:15:00',3.19),('11288','2014-04-11','09:20:00',3.4),('11288','2014-04-11','09:25:00',3.51),('11288','2014-04-11','09:30:00',3.42),('11288','2014-04-11','09:35:00',3.73),('11288','2014-04-11','09:40:00',3.83),('11288','2014-04-11','09:45:00',3.84),('11288','2014-04-11','09:50:00',4.11),('11288','2014-04-11','09:55:00',4.19),('11288','2014-04-11','10:00:00',4.28),('11288','2014-04-11','10:05:00',4.62),('11288','2014-04-11','10:10:00',4.77),('11288','2014-04-11','10:15:00',4.86),('11288','2014-04-11','10:20:00',5.01),('11288','2014-04-11','10:25:00',5.15),('11288','2014-04-11','10:30:00',5.25),('11288','2014-04-11','10:35:00',5.29),('11288','2014-04-11','10:40:00',5.46),('11288','2014-04-11','10:45:00',5.57),('11288','2014-04-11','10:50:00',5.68),('11288','2014-04-11','10:55:00',5.78),('11288','2014-04-11','11:00:00',5.88),('11288','2014-04-11','11:05:00',5.94),('11288','2014-04-11','11:10:00',5.95),('11288','2014-04-11','11:15:00',6),('11288','2014-04-11','11:20:00',6.11),('11288','2014-04-11','11:25:00',6.2),('11288','2014-04-11','11:30:00',6.27),('11288','2014-04-11','11:35:00',6.32),('11288','2014-04-11','11:40:00',6.34),('11288','2014-04-11','11:45:00',6.43),('11288','2014-04-11','11:50:00',6.59),('11288','2014-04-11','11:55:00',6.44),('11288','2014-04-11','12:00:00',6.16),('11288','2014-04-11','12:05:00',6.77),('11288','2014-04-11','12:10:00',6.48),('11288','2014-04-11','12:15:00',5.92),('11288','2014-04-11','12:20:00',6.85),('11288','2014-04-11','12:25:00',6.9),('11288','2014-04-11','12:30:00',6.97),('11288','2014-04-11','12:35:00',7.12),('11288','2014-04-11','12:40:00',7.18),('11288','2014-04-11','12:45:00',6.64),('11288','2014-04-11','12:50:00',7.12),('11288','2014-04-11','12:55:00',7.04),('11288','2014-04-11','13:00:00',6.48),('11288','2014-04-11','13:05:00',7.52),('11288','2014-04-11','13:10:00',6.86),('11288','2014-04-11','13:15:00',4.84),('11288','2014-04-11','13:20:00',5.51),('11288','2014-04-11','13:25:00',7.39),('11288','2014-04-11','13:30:00',4.04),('11288','2014-04-11','13:35:00',4.43),('11288','2014-04-11','13:40:00',4.73),('11288','2014-04-11','13:45:00',7.22),('11288','2014-04-11','13:50:00',5.99),('11288','2014-04-11','13:55:00',5.98),('11288','2014-04-11','14:00:00',6.21),('11288','2014-04-11','14:05:00',6.55),('11288','2014-04-11','14:10:00',3.06),('11288','2014-04-11','14:15:00',3.66),('11288','2014-04-11','14:20:00',4.36),('11288','2014-04-11','14:25:00',5.6),('11288','2014-04-11','14:30:00',7.18),('11288','2014-04-11','14:35:00',6.89),('11288','2014-04-11','14:40:00',3.93),('11288','2014-04-11','14:45:00',5.24),('11288','2014-04-11','14:50:00',5.97),('11288','2014-04-11','14:55:00',4.41),('11288','2014-04-11','15:00:00',6.55),('11288','2014-04-11','15:05:00',5.21),('11288','2014-04-11','15:10:00',6.3),('11288','2014-04-11','15:15:00',6.21),('11288','2014-04-11','15:20:00',4.77),('11288','2014-04-11','15:25:00',6),('11288','2014-04-11','15:30:00',5.42),('11288','2014-04-11','15:35:00',4.13),('11288','2014-04-11','15:40:00',5.65),('11288','2014-04-11','15:45:00',5.47),('11288','2014-04-11','15:50:00',5.43),('11288','2014-04-11','15:55:00',5.33),('11288','2014-04-11','16:00:00',5.16),('11288','2014-04-11','16:05:00',4.96),('11288','2014-04-11','16:10:00',3.76),('11288','2014-04-11','16:15:00',4.77),('11288','2014-04-11','16:20:00',4.61),('11288','2014-04-11','16:25:00',4.55),('11288','2014-04-11','16:30:00',4.43),('11288','2014-04-11','16:35:00',3.21),('11288','2014-04-11','16:40:00',4.16),('11288','2014-04-11','16:45:00',3.83),('11288','2014-04-11','16:50:00',2.65),('11288','2014-04-11','16:55:00',3.47),('11288','2014-04-11','17:00:00',3.02),('11288','2014-04-11','17:05:00',3.28),('11288','2014-04-11','17:10:00',3.08),('11288','2014-04-11','17:15:00',2.8),('11288','2014-04-11','17:20:00',2.81),('11288','2014-04-11','17:25:00',2.94),('11288','2014-04-11','17:30:00',2.93),('11288','2014-04-11','17:35:00',2.84),('11288','2014-04-11','17:40:00',2.65),('11288','2014-04-11','17:45:00',2.36),('11288','2014-04-11','17:50:00',2.14),('11288','2014-04-11','17:55:00',1.98),('11288','2014-04-11','18:00:00',1.78),('11288','2014-04-11','18:05:00',1.64),('11288','2014-04-11','18:10:00',1.53),('11288','2014-04-11','18:15:00',1.46),('11288','2014-04-11','18:20:00',1.34),('11288','2014-04-11','18:25:00',1.28),('11288','2014-04-11','18:30:00',1.4),('11288','2014-04-11','18:35:00',1.21),('11288','2014-04-11','18:40:00',1.03),('11288','2013-08-29','07:55:00',1.07),('11288','2013-08-29','08:00:00',1.17),('11288','2013-08-29','08:05:00',1.2),('11288','2013-08-29','08:10:00',1.4),('11288','2013-08-29','08:15:00',1.53),('11288','2013-08-29','08:20:00',1.66),('11288','2013-08-29','08:25:00',2.06),('11288','2013-08-29','08:30:00',2.4),('11288','2013-08-29','08:35:00',2.47),('11288','2013-08-29','08:40:00',2.08),('11288','2013-08-29','08:45:00',1.8),('11288','2013-08-29','08:50:00',2.14),('11288','2013-08-29','08:55:00',2.7),('11288','2013-08-29','09:00:00',2.63),('11288','2013-08-29','09:05:00',2.61),('11288','2013-08-29','09:10:00',2.59),('11288','2013-08-29','09:15:00',2.72),('11288','2013-08-29','09:20:00',2.69),('11288','2013-08-29','09:25:00',2.54),('11288','2013-08-29','09:30:00',2.63),('11288','2013-08-29','09:35:00',2.85),('11288','2013-08-29','09:40:00',2.84),('11288','2013-08-29','09:45:00',2.62),('11288','2013-08-29','09:50:00',2.54),('11288','2013-08-29','09:55:00',2.64),('11288','2013-08-29','10:00:00',2.77),('11288','2013-08-29','10:05:00',2.65),('11288','2013-08-29','10:10:00',2.6),('11288','2013-08-29','10:15:00',2.61),('11288','2013-08-29','10:20:00',2.65),('11288','2013-08-29','10:25:00',2.67),('11288','2013-08-29','10:30:00',2.74),('11288','2013-08-29','10:35:00',2.58),('11288','2013-08-29','10:40:00',2.37),('11288','2013-08-29','10:45:00',2.22),('11288','2013-08-29','10:50:00',2.22),('11288','2013-08-29','10:55:00',2.48),('11288','2013-08-29','11:00:00',2.63),('11288','2013-08-29','11:05:00',2.68),('11288','2013-08-29','11:10:00',3.86),('11288','2013-08-29','11:15:00',4.18),('11288','2013-08-29','11:20:00',3.95),('11288','2013-08-29','11:25:00',3.08),('11288','2013-08-29','11:30:00',2.66),('11288','2013-08-29','11:35:00',2.44),('11288','2013-08-29','11:40:00',2.76),('11288','2013-08-29','11:45:00',3.21),('11288','2013-08-29','11:50:00',3.29),('11288','2013-08-29','11:55:00',3.16),('11288','2013-08-29','12:00:00',3.13),('11288','2013-08-29','12:05:00',3.67),('11288','2013-08-29','12:10:00',4.26),('11288','2013-08-29','12:15:00',4.85),('11288','2013-08-29','12:20:00',4.34),('11288','2013-08-29','12:25:00',4.39),('11288','2013-08-29','12:30:00',4.49),('11288','2013-08-29','12:35:00',5.62),('11288','2013-08-29','12:40:00',7.46),('11288','2013-08-29','12:45:00',6.6),('11288','2013-08-29','12:50:00',4.23),('11288','2013-08-29','12:55:00',6.6),('11288','2013-08-29','13:00:00',4.48),('11288','2013-08-29','13:05:00',4.25),('11288','2013-08-29','13:10:00',4.13),('11288','2013-08-29','13:15:00',4.03),('11288','2013-08-29','13:20:00',3.86),('11288','2013-08-29','13:25:00',3.39),('11288','2013-08-29','13:30:00',3.17),('11288','2013-08-29','13:35:00',2.97),('11288','2013-08-29','13:40:00',2.86),('11288','2013-08-29','13:45:00',2.71),('11288','2013-08-29','13:50:00',2.67),('11288','2013-08-29','13:55:00',3.12),('11288','2013-08-29','14:00:00',3.86),('11288','2013-08-29','14:05:00',2.91),('11288','2013-08-29','14:10:00',2.63),('11288','2013-08-29','14:15:00',2.2),('11288','2013-08-29','14:20:00',1.78),('11288','2013-08-29','14:25:00',1.61),('11288','2013-08-29','14:30:00',1.54),('11288','2013-08-29','14:35:00',1.58),('11288','2013-08-29','14:40:00',1.63),('11288','2013-08-29','14:45:00',1.84),('11288','2013-08-29','14:50:00',2.14),('11288','2013-08-29','14:55:00',2.46),('11288','2013-08-29','15:00:00',2.7),('11288','2013-08-29','15:05:00',2.98),('11288','2013-08-29','15:10:00',2.34),('11288','2013-08-29','15:15:00',2.08),('11288','2013-08-29','15:20:00',2.3),('11288','2013-08-29','15:25:00',2.63),('11288','2013-08-29','15:30:00',4.23),('11288','2013-08-29','15:35:00',3.71),('11288','2013-08-29','15:40:00',3.65),('11288','2013-08-29','15:45:00',4.07),('11288','2013-08-29','15:50:00',4.87),('11288','2013-08-29','15:55:00',5.1),('11288','2013-08-29','16:00:00',4.82),('11288','2013-08-29','16:05:00',5.5),('11288','2013-08-29','16:10:00',5.07),('11288','2013-08-29','16:15:00',4.68),('11288','2013-08-29','16:20:00',4.49),('11288','2013-08-29','16:25:00',4.31),('11288','2013-08-29','16:30:00',4.18),('11288','2013-08-29','16:35:00',4.04),('11288','2013-08-29','16:40:00',3.92),('11288','2013-08-29','16:45:00',3.81),('11288','2013-08-29','16:50:00',3.68),('11288','2013-08-29','16:55:00',3.54),('11288','2013-08-29','17:00:00',3.43),('11288','2013-08-29','17:05:00',3.29),('11288','2013-08-29','17:10:00',3.14),('11288','2013-08-29','17:15:00',3.02),('11288','2013-08-29','17:20:00',2.86),('11288','2013-08-29','17:25:00',2.71),('11288','2013-08-29','17:30:00',2.58),('11288','2013-08-29','17:35:00',2.44),('11288','2013-08-29','17:40:00',2.29),('11288','2013-08-29','17:45:00',2.11),('11288','2013-08-29','17:50:00',1.98),('11288','2013-08-29','17:55:00',1.82),('11288','2013-08-29','18:00:00',1.71),('11288','2013-08-29','18:05:00',1.58),('11288','2013-08-29','18:10:00',1.47),('11288','2013-08-29','18:15:00',1.36),('11288','2013-08-29','18:20:00',1.24),('11288','2013-08-29','18:25:00',1.1),('11288','2013-08-28','08:00:00',1.2),('11288','2013-08-28','08:05:00',1.21),('11288','2013-08-28','08:10:00',1.3),('11288','2013-08-28','08:15:00',1.45),('11288','2013-08-28','08:20:00',1.54),('11288','2013-08-28','08:25:00',1.59),('11288','2013-08-28','08:30:00',1.8),('11288','2013-08-28','08:35:00',2.03),('11288','2013-08-28','08:40:00',1.98),('11288','2013-08-28','08:45:00',2.01),('11288','2013-08-28','08:50:00',2.05),('11288','2013-08-28','08:55:00',1.5),('11288','2013-08-28','09:00:00',2.4),('11288','2013-08-28','09:05:00',1.39),('11288','2013-08-28','09:10:00',2.1),('11288','2013-08-28','09:15:00',2.78),('11288','2013-08-28','09:20:00',1.97),('11288','2013-08-28','09:25:00',1.3),('11288','2013-08-28','09:30:00',1.9),('11288','2013-08-28','09:35:00',3.17),('11288','2013-08-28','09:40:00',3.89),('11288','2013-08-28','09:45:00',3.94),('11288','2013-08-28','09:50:00',4.13),('11288','2013-08-28','09:55:00',4.19),('11288','2013-08-28','10:00:00',4.14),('11288','2013-08-28','10:05:00',4.39),('11288','2013-08-28','10:10:00',4.59),('11288','2013-08-28','10:15:00',4.83),('11288','2013-08-28','10:20:00',4.69),('11288','2013-08-28','10:25:00',1.91),('11288','2013-08-28','10:30:00',2.98),('11288','2013-08-28','10:35:00',3.41),('11288','2013-08-28','10:40:00',4.93),('11288','2013-08-28','10:45:00',5.47),('11288','2013-08-28','10:50:00',5.32),('11288','2013-08-28','10:55:00',5.46),('11288','2013-08-28','11:00:00',2.51),('11288','2013-08-28','11:05:00',6.27),('11288','2013-08-28','11:10:00',3.2),('11288','2013-08-28','11:15:00',6.63),('11288','2013-08-28','11:20:00',6.15),('11288','2013-08-28','11:25:00',6.24),('11288','2013-08-28','11:30:00',6.37),('11288','2013-08-28','11:35:00',6.46),('11288','2013-08-28','11:40:00',6.56),('11288','2013-08-28','11:45:00',5.66),('11288','2013-08-28','11:50:00',5.33),('11288','2013-08-28','11:55:00',1.98),('11288','2013-08-28','12:00:00',5.97),('11288','2013-08-28','12:05:00',6.11),('11288','2013-08-28','12:10:00',5.05),('11288','2013-08-28','12:15:00',6.72),('11288','2013-08-28','12:20:00',6.11),('11288','2013-08-28','12:25:00',6.59),('11288','2013-08-28','12:30:00',6.5),('11288','2013-08-28','12:35:00',6.49),('11288','2013-08-28','12:40:00',6.61),('11288','2013-08-28','12:45:00',6.74),('11288','2013-08-28','12:50:00',6.63),('11288','2013-08-28','12:55:00',6.62),('11288','2013-08-28','13:00:00',6.74),('11288','2013-08-28','13:05:00',6.88),('11288','2013-08-28','13:10:00',6.82),('11288','2013-08-28','13:15:00',6.7),('11288','2013-08-28','13:20:00',6.61),('11288','2013-08-28','13:25:00',5.66),('11288','2013-08-28','13:30:00',6.23),('11288','2013-08-28','13:35:00',6.74),('11288','2013-08-28','13:40:00',5.28),('11288','2013-08-28','13:45:00',6.23),('11288','2013-08-28','13:50:00',6.84),('11288','2013-08-28','13:55:00',4.52),('11288','2013-08-28','14:00:00',6.67),('11288','2013-08-28','14:05:00',6.56),('11288','2013-08-28','14:10:00',6.36),('11288','2013-08-28','14:15:00',6.39),('11288','2013-08-28','14:20:00',6.36),('11288','2013-08-28','14:25:00',6.36),('11288','2013-08-28','14:30:00',6.31),('11288','2013-08-28','14:35:00',6.47),('11288','2013-08-28','14:40:00',6.27),('11288','2013-08-28','14:45:00',6.17),('11288','2013-08-28','14:50:00',6.09),('11288','2013-08-28','14:55:00',6.03),('11288','2013-08-28','15:00:00',5.93),('11288','2013-08-28','15:05:00',4.83),('11288','2013-08-28','15:10:00',5.74),('11288','2013-08-28','15:15:00',5.93),('11288','2013-08-28','15:20:00',4.96),('11288','2013-08-28','15:25:00',4.54),('11288','2013-08-28','15:30:00',4.89),('11288','2013-08-28','15:35:00',5.6),('11288','2013-08-28','15:40:00',2.15),('11288','2013-08-28','15:45:00',2.16),('11288','2013-08-28','15:50:00',2.71),('11288','2013-08-28','15:55:00',5.72),('11288','2013-08-28','16:00:00',5.42),('11288','2013-08-28','16:05:00',3.53),('11288','2013-08-28','16:10:00',3.2),('11288','2013-08-28','16:15:00',3.49),('11288','2013-08-28','16:20:00',4.44),('11288','2013-08-28','16:25:00',4.78),('11288','2013-08-28','16:30:00',4.5),('11288','2013-08-28','16:35:00',4.37),('11288','2013-08-28','16:40:00',4.22),('11288','2013-08-28','16:45:00',4),('11288','2013-08-28','16:50:00',3.82),('11288','2013-08-28','16:55:00',3.72),('11288','2013-08-28','17:00:00',3.62),('11288','2013-08-28','17:05:00',3.4),('11288','2013-08-28','17:10:00',3.32),('11288','2013-08-28','17:15:00',2.55),('11288','2013-08-28','17:20:00',1.57),('11288','2013-08-28','17:25:00',2.91),('11288','2013-08-28','17:30:00',1.95),('11288','2013-08-28','17:35:00',2.7),('11288','2013-08-28','17:40:00',2.55),('11288','2013-08-28','17:45:00',1.16),('11288','2013-08-28','17:50:00',1),('11288','2013-08-28','17:55:00',1.45),('11288','2013-08-28','18:00:00',1.16),('11288','2013-08-28','18:05:00',1.01),('11288','2013-08-28','18:10:00',1.52),('11288','2013-08-28','18:15:00',1.39),('11288','2013-08-28','18:25:00',1.09),('11288','2013-08-27','08:05:00',1.03),('11288','2013-08-27','08:10:00',1.22),('11288','2013-08-27','08:15:00',1.46),('11288','2013-08-27','08:20:00',1.82),('11288','2013-08-27','08:25:00',2.08),('11288','2013-08-27','08:30:00',2.01),('11288','2013-08-27','08:35:00',1.64),('11288','2013-08-27','08:40:00',1.58),('11288','2013-08-27','08:45:00',1.72),('11288','2013-08-27','08:50:00',1.37),('11288','2013-08-27','08:55:00',1.26),('11288','2013-08-27','09:00:00',1.49),('11288','2013-08-27','09:05:00',1.62),('11288','2013-08-27','09:10:00',2.01),('11288','2013-08-27','09:15:00',2.02),('11288','2013-08-27','09:20:00',2.42),('11288','2013-08-27','09:25:00',3),('11288','2013-08-27','09:30:00',3.17),('11288','2013-08-27','09:35:00',1.99),('11288','2013-08-27','09:40:00',1.67),('11288','2013-08-27','09:45:00',1.75),('11288','2013-08-27','09:50:00',1.83),('11288','2013-08-27','09:55:00',2.36),('11288','2013-08-27','10:00:00',3.01),('11288','2013-08-27','10:05:00',3.59),('11288','2013-08-27','10:10:00',4.47),('11288','2013-08-27','10:15:00',4.49),('11288','2013-08-27','10:20:00',4.77),('11288','2013-08-27','10:25:00',4.85),('11288','2013-08-27','10:30:00',4.91),('11288','2013-08-27','10:35:00',4.95),('11288','2013-08-27','10:40:00',4.9),('11288','2013-08-27','10:45:00',5.05),('11288','2013-08-27','10:50:00',5.09),('11288','2013-08-27','10:55:00',5.19),('11288','2013-08-27','11:00:00',5.19),('11288','2013-08-27','11:05:00',5.33),('11288','2013-08-27','11:10:00',5.35),('11288','2013-08-27','11:15:00',5.31),('11288','2013-08-27','11:20:00',5.39),('11288','2013-08-27','11:25:00',5.43),('11288','2013-08-27','11:30:00',5.53),('11288','2013-08-27','11:35:00',5.33),('11288','2013-08-27','11:40:00',5.23),('11288','2013-08-27','11:45:00',6.48),('11288','2013-08-27','11:50:00',4.4),('11288','2013-08-27','11:55:00',6.19),('11288','2013-08-27','12:00:00',6.64),('11288','2013-08-27','12:05:00',5.76),('11288','2013-08-27','12:10:00',4.79),('11288','2013-08-27','12:15:00',5.69),('11288','2013-08-27','12:20:00',6.24),('11288','2013-08-27','12:25:00',6.12),('11288','2013-08-27','12:30:00',6.26),('11288','2013-08-27','12:35:00',6.76),('11288','2013-08-27','12:40:00',6.53),('11288','2013-08-27','12:45:00',4.59),('11288','2013-08-27','12:50:00',3.27),('11288','2013-08-27','12:55:00',2.79),('11288','2013-08-27','13:00:00',2.14),('11288','2013-08-27','13:05:00',2.78),('11288','2013-08-27','13:10:00',2.85),('11288','2013-08-27','13:15:00',3.13),('11288','2013-08-27','13:20:00',3.51),('11288','2013-08-27','13:25:00',3.82),('11288','2013-08-27','13:30:00',4.02),('11288','2013-08-27','13:35:00',3.42),('11288','2013-08-27','13:40:00',3.26),('11288','2013-08-27','13:45:00',5.09),('11288','2013-08-27','13:50:00',5.66),('11288','2013-08-27','13:55:00',5.41),('11288','2013-08-27','14:00:00',6.38),('11288','2013-08-27','14:05:00',3.22),('11288','2013-08-27','14:10:00',3.84),('11288','2013-08-27','14:15:00',5.08),('11288','2013-08-27','14:20:00',3.06),('11288','2013-08-27','14:25:00',2.12),('11288','2013-08-27','14:30:00',2.11),('11288','2013-08-27','14:35:00',1.87),('11288','2013-08-27','14:40:00',2.12),('11288','2013-08-27','14:45:00',2.14),('11288','2013-08-27','14:50:00',1.67),('11288','2013-08-27','14:55:00',1.36),('11288','2013-08-27','15:00:00',1.33),('11288','2013-08-27','15:05:00',1.22),('11288','2013-08-27','15:10:00',1.27),('11288','2013-08-27','15:15:00',1.38),('11288','2013-08-27','15:20:00',1.23),('11288','2013-08-27','15:35:00',1.01),('11288','2013-08-27','15:50:00',1.01),('11288','2013-08-27','15:55:00',2.45),('11288','2013-08-27','16:00:00',2.51),('11288','2013-08-27','16:05:00',3.57),('11288','2013-08-27','16:10:00',5.91),('11288','2013-08-27','16:15:00',5.18),('11288','2013-08-27','16:20:00',3.73),('11288','2013-08-27','16:25:00',3.49),('11288','2013-08-27','16:30:00',1.51),('11288','2013-08-27','16:35:00',1.97),('11288','2013-08-27','16:40:00',2.82),('11288','2013-08-27','16:45:00',2.68),('11288','2013-08-27','16:50:00',3.96),('11288','2013-08-27','16:55:00',3.3),('11288','2013-08-27','17:00:00',1.14),('11288','2013-08-27','17:05:00',2.22),('11288','2013-08-27','17:10:00',4.11),('11288','2013-08-27','17:15:00',2.14),('11288','2013-08-27','17:20:00',1.48),('11288','2013-08-27','17:25:00',1.48),('11288','2013-08-27','17:30:00',1.26),('11288','2013-08-27','17:35:00',1.56),('11288','2013-08-27','17:40:00',1.27),('11288','2013-08-27','17:45:00',2.01),('11288','2013-08-27','17:50:00',2.17),('11288','2013-08-27','17:55:00',2.26),('11288','2013-08-27','18:00:00',1.85),('11288','2013-08-27','18:05:00',1.35),('11288','2013-08-26','07:40:00',1.06),('11288','2013-08-26','07:55:00',1.01),('11288','2013-08-26','08:00:00',1.06),('11288','2013-08-26','08:05:00',1.76),('11288','2013-08-26','08:10:00',1.78),('11288','2013-08-26','08:15:00',1.39),('11288','2013-08-26','08:20:00',1.69),('11288','2013-08-26','08:25:00',1.54),('11288','2013-08-26','08:30:00',1.88),('11288','2013-08-26','08:35:00',1.65),('11288','2013-08-26','08:40:00',2.18),('11288','2013-08-26','08:45:00',2.24),('11288','2013-08-26','08:50:00',2.35),('11288','2013-08-26','08:55:00',2.57),('11288','2013-08-26','09:00:00',2.77),('11288','2013-08-26','09:05:00',2.83),('11288','2013-08-26','09:10:00',2.98),('11288','2013-08-26','09:15:00',3.13),('11288','2013-08-26','09:20:00',3.22),('11288','2013-08-26','09:25:00',3.32),('11288','2013-08-26','09:30:00',3.36),('11288','2013-08-26','09:35:00',3.4),('11288','2013-08-26','09:40:00',3.76),('11288','2013-08-26','09:45:00',3.86),('11288','2013-08-26','09:50:00',3.91),('11288','2013-08-26','09:55:00',4.04),('11288','2013-08-26','10:00:00',4.2),('11288','2013-08-26','10:05:00',4.39),('11288','2013-08-26','10:10:00',4.43),('11288','2013-08-26','10:15:00',4.53),('11288','2013-08-26','10:20:00',4.76),('11288','2013-08-26','10:25:00',4.84),('11288','2013-08-26','10:30:00',4.89),('11288','2013-08-26','10:35:00',4.99),('11288','2013-08-26','10:40:00',5.08),('11288','2013-08-26','10:45:00',5.17),('11288','2013-08-26','10:50:00',5.25),('11288','2013-08-26','10:55:00',5.32),('11288','2013-08-26','11:00:00',5.39),('11288','2013-08-26','11:05:00',5.43),('11288','2013-08-26','11:10:00',5.49),('11288','2013-08-26','11:15:00',5.54),('11288','2013-08-26','11:20:00',5.58),('11288','2013-08-26','11:25:00',5.63),('11288','2013-08-26','11:30:00',5.69),('11288','2013-08-26','11:35:00',5.77),('11288','2013-08-26','11:40:00',5.8),('11288','2013-08-26','11:45:00',5.87),('11288','2013-08-26','11:50:00',5.91),('11288','2013-08-26','11:55:00',5.91),('11288','2013-08-26','12:00:00',6),('11288','2013-08-26','12:05:00',6.03),('11288','2013-08-26','12:10:00',4.44),('11288','2013-08-26','12:15:00',5.65),('11288','2013-08-26','12:20:00',6),('11288','2013-08-26','12:25:00',6.02),('11288','2013-08-26','12:30:00',5.26),('11288','2013-08-26','12:35:00',4.89),('11288','2013-08-26','12:40:00',6.18),('11288','2013-08-26','12:45:00',6.14),('11288','2013-08-26','12:50:00',6.2),('11288','2013-08-26','12:55:00',4.29),('11288','2013-08-26','13:00:00',6.45),('11288','2013-08-26','13:05:00',6.95),('11288','2013-08-26','13:10:00',6.52),('11288','2013-08-26','13:15:00',3.66),('11288','2013-08-26','13:20:00',4.38),('11288','2013-08-26','13:25:00',4.91),('11288','2013-08-26','13:30:00',4.78),('11288','2013-08-26','13:35:00',5.71),('11288','2013-08-26','13:40:00',6.22),('11288','2013-08-26','13:45:00',6.24),('11288','2013-08-26','13:50:00',5.61),('11288','2013-08-26','13:55:00',4.43),('11288','2013-08-26','14:00:00',4.08),('11288','2013-08-26','14:05:00',5.08),('11288','2013-08-26','14:10:00',4.39),('11288','2013-08-26','14:15:00',5.96),('11288','2013-08-26','14:20:00',6.07),('11288','2013-08-26','14:25:00',5.98),('11288','2013-08-26','14:30:00',5.95),('11288','2013-08-26','14:35:00',5.61),('11288','2013-08-26','14:40:00',5.04),('11288','2013-08-26','14:45:00',3.73),('11288','2013-08-26','14:50:00',3.45),('11288','2013-08-26','14:55:00',3.3),('11288','2013-08-26','15:00:00',3.12),('11288','2013-08-26','15:05:00',2.22),('11288','2013-08-26','15:10:00',1.79),('11288','2013-08-26','15:15:00',1.59),('11288','2013-08-26','15:20:00',1.32),('11288','2013-08-26','15:25:00',1.23),('11288','2013-08-26','15:30:00',1.35),('11288','2013-08-26','15:35:00',1.79),('11288','2013-08-26','15:40:00',2.76),('11288','2013-08-26','15:45:00',2.92),('11288','2013-08-26','15:50:00',2.86),('11288','2013-08-26','15:55:00',2.82),('11288','2013-08-26','16:00:00',4.43),('11288','2013-08-26','16:05:00',5.35),('11288','2013-08-26','16:10:00',4.63),('11288','2013-08-26','16:15:00',4.43),('11288','2013-08-26','16:20:00',4.26),('11288','2013-08-26','16:25:00',4.13),('11288','2013-08-26','16:30:00',4.03),('11288','2013-08-26','16:35:00',3.91),('11288','2013-08-26','16:40:00',3.8),('11288','2013-08-26','16:45:00',3.76),('11288','2013-08-26','16:50:00',3.45),('11288','2013-08-26','16:55:00',3.38),('11288','2013-08-26','17:00:00',3.29),('11288','2013-08-26','17:05:00',3.02),('11288','2013-08-26','17:10:00',3.01),('11288','2013-08-26','17:15:00',2.88),('11288','2013-08-26','17:20:00',1.97),('11288','2013-08-26','17:30:00',2.13),('11288','2013-08-26','17:35:00',1.62),('11288','2013-08-26','17:40:00',1.69),('11288','2013-08-26','17:45:00',1.96),('11288','2013-08-26','17:50:00',2.18),('11288','2013-08-26','17:55:00',2.14),('11288','2013-08-26','18:00:00',1.88),('11288','2013-08-26','18:05:00',1.64),('11288','2013-08-26','18:10:00',1.46),('11288','2013-08-26','18:15:00',1.32),('11288','2013-08-26','18:20:00',1.2),('11288','2013-08-26','18:25:00',1.08),('11288','2013-08-25','07:55:00',1.14),('11288','2013-08-25','08:00:00',1.17),('11288','2013-08-25','08:05:00',1.4),('11288','2013-08-25','08:10:00',1.73),('11288','2013-08-25','08:15:00',1.57),('11288','2013-08-25','08:20:00',1.47),('11288','2013-08-25','08:25:00',1.68),('11288','2013-08-25','08:30:00',1.3),('11288','2013-08-25','08:35:00',1.39),('11288','2013-08-25','08:40:00',1.94),('11288','2013-08-25','08:45:00',1.86),('11288','2013-08-25','08:50:00',1.42),('11288','2013-08-25','09:05:00',1.37),('11288','2013-08-25','09:10:00',1.32),('11288','2013-08-25','09:15:00',1.84),('11288','2013-08-25','09:20:00',3.13),('11288','2013-08-25','09:25:00',3.46),('11288','2013-08-25','09:30:00',2.24),('11288','2013-08-25','09:35:00',1.62),('11288','2013-08-25','09:40:00',3.59),('11288','2013-08-25','09:45:00',4.83),('11288','2013-08-25','09:50:00',4.33),('11288','2013-08-25','09:55:00',4.2),('11288','2013-08-25','10:00:00',3.49),('11288','2013-08-25','10:05:00',2.36),('11288','2013-08-25','10:10:00',1.52),('11288','2013-08-25','10:15:00',1.24),('11288','2013-08-25','10:20:00',1.18),('11288','2013-08-25','15:00:00',1.37),('11288','2013-08-25','15:05:00',1.71),('11288','2013-08-25','15:10:00',1.88),('11288','2013-08-25','15:15:00',2.17),('11288','2013-08-25','15:20:00',2.55),('11288','2013-08-25','15:25:00',2.74),('11288','2013-08-25','15:30:00',3.76),('11288','2013-08-25','15:35:00',5.56),('11288','2013-08-25','15:40:00',6.03),('11288','2013-08-25','15:45:00',6.05),('11288','2013-08-25','15:50:00',3.11),('11288','2013-08-25','15:55:00',5.02),('11288','2013-08-25','16:00:00',5.52),('11288','2013-08-25','16:05:00',5.15),('11288','2013-08-25','16:10:00',4.89),('11288','2013-08-25','16:15:00',4.71),('11288','2013-08-25','16:20:00',4.55),('11288','2013-08-25','16:25:00',4.44),('11288','2013-08-25','16:30:00',4.38),('11288','2013-08-25','16:35:00',4.18),('11288','2013-08-25','16:40:00',2.72),('11288','2013-08-25','16:45:00',1.95),('11288','2013-08-25','16:50:00',3.18),('11288','2013-08-25','16:55:00',4.2),('11288','2013-08-25','17:00:00',3.84),('11288','2013-08-25','17:05:00',3.65),('11288','2013-08-25','17:10:00',3.38),('11288','2013-08-25','17:15:00',3.12),('11288','2013-08-25','17:20:00',2.97),('11288','2013-08-25','17:25:00',2.8),('11288','2013-08-25','17:30:00',2.66),('11288','2013-08-25','17:35:00',2.32),('11288','2013-08-25','17:40:00',2.13),('11288','2013-08-25','17:45:00',2.28),('11288','2013-08-25','17:50:00',2.01),('11288','2013-08-25','17:55:00',1.72),('11288','2013-08-25','18:00:00',1.35),('11288','2013-08-25','18:05:00',1.19),('11288','2013-08-25','18:10:00',1.37),('11288','2013-08-25','18:15:00',1.49),('11288','2013-08-25','18:20:00',1.42),('11288','2013-08-25','18:25:00',1.24),('11288','2013-08-25','18:30:00',1.08),('11288','2013-08-24','07:55:00',1.03),('11288','2013-08-24','08:00:00',1.08),('11288','2013-08-24','08:05:00',1.02),('11288','2013-08-24','08:10:00',1.29),('11288','2013-08-24','08:15:00',1.22),('11288','2013-08-24','08:20:00',1.38),('11288','2013-08-24','08:25:00',1.64),('11288','2013-08-24','08:30:00',1.76),('11288','2013-08-24','08:35:00',1.95),('11288','2013-08-24','08:40:00',2.19),('11288','2013-08-24','08:45:00',2.09),('11288','2013-08-24','08:50:00',2.27),('11288','2013-08-24','08:55:00',2.77),('11288','2013-08-24','09:00:00',2.79),('11288','2013-08-24','09:05:00',2.95),('11288','2013-08-24','09:10:00',3),('11288','2013-08-24','09:15:00',2.83),('11288','2013-08-24','09:20:00',2.93),('11288','2013-08-24','09:25:00',3.4),('11288','2013-08-24','09:30:00',3.7),('11288','2013-08-24','09:35:00',3.25),('11288','2013-08-24','09:40:00',3.35),('11288','2013-08-24','09:45:00',3.63),('11288','2013-08-24','09:50:00',2.63),('11288','2013-08-24','09:55:00',3.15),('11288','2013-08-24','10:00:00',3.92),('11288','2013-08-24','10:05:00',4.37),('11288','2013-08-24','10:10:00',4.45),('11288','2013-08-24','10:15:00',4.58),('11288','2013-08-24','10:20:00',4.73),('11288','2013-08-24','10:25:00',4.8),('11288','2013-08-24','10:30:00',4.83),('11288','2013-08-24','10:35:00',4.99),('11288','2013-08-24','10:40:00',5.05),('11288','2013-08-24','10:45:00',5.01),('11288','2013-08-24','10:50:00',5.36),('11288','2013-08-24','10:55:00',5.29),('11288','2013-08-24','11:00:00',5.31),('11288','2013-08-24','11:05:00',5.5),('11288','2013-08-24','11:10:00',5.49),('11288','2013-08-24','11:15:00',5.42),('11288','2013-08-24','11:20:00',5.5),('11288','2013-08-24','11:25:00',5.64),('11288','2013-08-24','11:30:00',5.64),('11288','2013-08-24','11:35:00',5.71),('11288','2013-08-24','11:40:00',5.75),('11288','2013-08-24','11:45:00',5.78),('11288','2013-08-24','11:50:00',5.79),('11288','2013-08-24','11:55:00',5.88),('11288','2013-08-24','12:00:00',5.95),('11288','2013-08-24','12:05:00',6.09),('11288','2013-08-24','12:10:00',6.04),('11288','2013-08-24','12:15:00',6.03),('11288','2013-08-24','12:20:00',6.12),('11288','2013-08-24','12:25:00',6.11),('11288','2013-08-24','12:30:00',6.12),('11288','2013-08-24','12:35:00',6.15),('11288','2013-08-24','12:40:00',6.1),('11288','2013-08-24','12:45:00',6.12),('11288','2013-08-24','12:50:00',6.18),('11288','2013-08-24','12:55:00',6.08),('11288','2013-08-24','13:00:00',6.16),('11288','2013-08-24','13:05:00',6.17),('11288','2013-08-24','13:10:00',6.15),('11288','2013-08-24','13:15:00',6.22),('11288','2013-08-24','13:20:00',6.28),('11288','2013-08-24','13:25:00',6.26),('11288','2013-08-24','13:30:00',6.27),('11288','2013-08-24','13:35:00',6.27),('11288','2013-08-24','13:40:00',6.22),('11288','2013-08-24','13:45:00',6.19),('11288','2013-08-24','13:50:00',6.14),('11288','2013-08-24','13:55:00',6.16),('11288','2013-08-24','14:00:00',6.1),('11288','2013-08-24','14:05:00',6.07),('11288','2013-08-24','14:10:00',6.05),('11288','2013-08-24','14:15:00',6.03),('11288','2013-08-24','14:20:00',5.98),('11288','2013-08-24','14:25:00',5.95),('11288','2013-08-24','14:30:00',5.94),('11288','2013-08-24','14:35:00',5.89),('11288','2013-08-24','14:40:00',5.85),('11288','2013-08-24','14:45:00',5.78),('11288','2013-08-24','14:50:00',5.73),('11288','2013-08-24','14:55:00',5.67),('11288','2013-08-24','15:00:00',5.65),('11288','2013-08-24','15:05:00',5.59),('11288','2013-08-24','15:10:00',5.48),('11288','2013-08-24','15:15:00',5.41),('11288','2013-08-24','15:20:00',5.36),('11288','2013-08-24','15:25:00',5.29),('11288','2013-08-24','15:30:00',5.24),('11288','2013-08-24','15:35:00',5.21),('11288','2013-08-24','15:40:00',5.07),('11288','2013-08-24','15:45:00',4.98),('11288','2013-08-24','15:50:00',4.9),('11288','2013-08-24','15:55:00',4.8),('11288','2013-08-24','16:00:00',4.69),('11288','2013-08-24','16:05:00',4.59),('11288','2013-08-24','16:10:00',4.5),('11288','2013-08-24','16:15:00',4.42),('11288','2013-08-24','16:20:00',4.32),('11288','2013-08-24','16:25:00',4.23),('11288','2013-08-24','16:30:00',4.12),('11288','2013-08-24','16:35:00',3.97),('11288','2013-08-24','16:40:00',3.82),('11288','2013-08-24','16:45:00',3.72),('11288','2013-08-24','16:50:00',3.62),('11288','2013-08-24','16:55:00',3.49),('11288','2013-08-24','17:00:00',3.37),('11288','2013-08-24','17:05:00',3.25),('11288','2013-08-24','17:10:00',3.11),('11288','2013-08-24','17:15:00',3),('11288','2013-08-24','17:20:00',2.87),('11288','2013-08-24','17:25:00',2.74),('11288','2013-08-24','17:30:00',2.62),('11288','2013-08-24','17:35:00',2.46),('11288','2013-08-24','17:40:00',2.32),('11288','2013-08-24','17:45:00',2.18),('11288','2013-08-24','17:50:00',2.02),('11288','2013-08-24','17:55:00',1.85),('11288','2013-08-24','18:00:00',1.78),('11288','2013-08-24','18:05:00',1.66),('11288','2013-08-24','18:10:00',1.53),('11288','2013-08-24','18:15:00',1.41),('11288','2013-08-24','18:20:00',1.26),('11288','2013-08-24','18:25:00',1.16),('11288','2013-08-24','18:30:00',1.06),('11288','2013-08-23','07:55:00',1.03),('11288','2013-08-23','08:00:00',1.13),('11288','2013-08-23','08:05:00',1.22),('11288','2013-08-23','08:10:00',1.31),('11288','2013-08-23','08:15:00',1.41),('11288','2013-08-23','08:20:00',1.51),('11288','2013-08-23','08:25:00',1.65),('11288','2013-08-23','08:30:00',1.77),('11288','2013-08-23','08:35:00',1.74),('11288','2013-08-23','08:40:00',1.96),('11288','2013-08-23','08:45:00',1.98),('11288','2013-08-23','08:50:00',2.22),('11288','2013-08-23','08:55:00',2.44),('11288','2013-08-23','09:00:00',2.54),('11288','2013-08-23','09:05:00',2.63),('11288','2013-08-23','09:10:00',2.83),('11288','2013-08-23','09:15:00',2.9),('11288','2013-08-23','09:20:00',3.02),('11288','2013-08-23','09:25:00',3.15),('11288','2013-08-23','09:30:00',3.2),('11288','2013-08-23','09:35:00',3.24),('11288','2013-08-23','09:40:00',3.38),('11288','2013-08-23','09:45:00',3.56),('11288','2013-08-23','09:50:00',3.6),('11288','2013-08-23','09:55:00',3.72),('11288','2013-08-23','10:00:00',3.83),('11288','2013-08-23','10:05:00',3.94),('11288','2013-08-23','10:10:00',4.01),('11288','2013-08-23','10:15:00',4.15),('11288','2013-08-23','10:20:00',4.28),('11288','2013-08-23','10:25:00',4.44),('11288','2013-08-23','10:30:00',4.54),('11288','2013-08-23','10:35:00',4.57),('11288','2013-08-23','10:40:00',4.58),('11288','2013-08-23','10:45:00',4.74),('11288','2013-08-23','10:50:00',4.81),('11288','2013-08-23','10:55:00',4.74),('11288','2013-08-23','11:00:00',4.46),('11288','2013-08-23','11:05:00',4.05),('11288','2013-08-23','11:10:00',1.99),('11288','2013-08-23','11:15:00',2.71),('11288','2013-08-23','11:20:00',4.8),('11288','2013-08-23','11:25:00',5.25),('11288','2013-08-23','11:30:00',5.59),('11288','2013-08-23','11:35:00',5.71),('11288','2013-08-23','11:40:00',4.4),('11288','2013-08-23','11:45:00',5.93),('11288','2013-08-23','11:50:00',5.7),('11288','2013-08-23','11:55:00',2.41),('11288','2013-08-23','12:00:00',2.78),('11288','2013-08-23','12:05:00',6.23),('11288','2013-08-23','12:10:00',4.15),('11288','2013-08-23','12:15:00',1.61),('11288','2013-08-23','12:20:00',1.64),('11288','2013-08-23','12:25:00',1.74),('11288','2013-08-23','12:30:00',3.49),('11288','2013-08-23','12:35:00',4.26),('11288','2013-08-23','12:40:00',1.97),('11288','2013-08-23','12:45:00',2.7),('11288','2013-08-23','12:50:00',2.24),('11288','2013-08-23','12:55:00',1.74),('11288','2013-08-23','13:00:00',3.75),('11288','2013-08-23','13:05:00',5.2),('11288','2013-08-23','13:10:00',3.46),('11288','2013-08-23','13:15:00',4.26),('11288','2013-08-23','13:20:00',6.6),('11288','2013-08-23','13:25:00',5.78),('11288','2013-08-23','13:30:00',6.72),('11288','2013-08-23','13:35:00',5),('11288','2013-08-23','13:40:00',6.22),('11288','2013-08-23','13:45:00',5.79),('11288','2013-08-23','13:50:00',3.85),('11288','2013-08-23','13:55:00',6.63),('11288','2013-08-23','14:00:00',6.64),('11288','2013-08-23','14:05:00',6.36),('11288','2013-08-23','14:10:00',6.22),('11288','2013-08-23','14:15:00',6.18),('11288','2013-08-23','14:20:00',5.28),('11288','2013-08-23','14:25:00',5.76),('11288','2013-08-23','14:30:00',4.46),('11288','2013-08-23','14:35:00',5.92),('11288','2013-08-23','14:40:00',5.84),('11288','2013-08-23','14:45:00',5.69),('11288','2013-08-23','14:50:00',5.43),('11288','2013-08-23','14:55:00',5.62),('11288','2013-08-23','15:00:00',5.48),('11288','2013-08-23','15:05:00',5.08),('11288','2013-08-23','15:10:00',5.37),('11288','2013-08-23','15:15:00',5.22),('11288','2013-08-23','15:20:00',5.24),('11288','2013-08-23','15:25:00',5.28),('11288','2013-08-23','15:30:00',5.44),('11288','2013-08-23','15:35:00',5.03),('11288','2013-08-23','15:40:00',5.01),('11288','2013-08-23','15:45:00',4.98),('11288','2013-08-23','15:50:00',4.51),('11288','2013-08-23','15:55:00',4.85),('11288','2013-08-23','16:00:00',4.6),('11288','2013-08-23','16:05:00',4.35),('11288','2013-08-23','16:10:00',3.9),('11288','2013-08-23','16:15:00',4.35),('11288','2013-08-23','16:20:00',4.55),('11288','2013-08-23','16:25:00',4.41),('11288','2013-08-23','16:30:00',4.28),('11288','2013-08-23','16:35:00',4.21),('11288','2013-08-23','16:40:00',4.04),('11288','2013-08-23','16:45:00',3.95),('11288','2013-08-23','16:50:00',3.78),('11288','2013-08-23','16:55:00',3.6),('11288','2013-08-23','17:00:00',3.41),('11288','2013-08-23','17:05:00',3.28),('11288','2013-08-23','17:10:00',3.13),('11288','2013-08-23','17:15:00',2.97),('11288','2013-08-23','17:20:00',2.87),('11288','2013-08-23','17:25:00',2.67),('11288','2013-08-23','17:30:00',2.54),('11288','2013-08-23','17:35:00',2.42),('11288','2013-08-23','17:40:00',2.28),('11288','2013-08-23','17:45:00',2.12),('11288','2013-08-23','17:50:00',1.99),('11288','2013-08-23','17:55:00',1.84),('11288','2013-08-23','18:00:00',1.76),('11288','2013-08-23','18:05:00',1.63),('11288','2013-08-23','18:10:00',1.31),('11288','2013-08-23','18:15:00',1.24),('11288','2013-08-23','18:20:00',1.31),('11288','2013-08-23','18:25:00',1.24),('11288','2013-08-23','18:30:00',1.12),('11288','2013-08-23','18:35:00',1.01),('11288','2013-08-22','07:55:00',1.07),('11288','2013-08-22','08:00:00',1.17),('11288','2013-08-22','08:05:00',1.25),('11288','2013-08-22','08:10:00',1.37),('11288','2013-08-22','08:15:00',1.45),('11288','2013-08-22','08:20:00',1.53),('11288','2013-08-22','08:25:00',1.67),('11288','2013-08-22','08:30:00',1.78),('11288','2013-08-22','08:35:00',1.83),('11288','2013-08-22','08:40:00',2.03),('11288','2013-08-22','08:45:00',2.18),('11288','2013-08-22','08:50:00',2.3),('11288','2013-08-22','08:55:00',2.61),('11288','2013-08-22','09:00:00',2.72),('11288','2013-08-22','09:05:00',2.89),('11288','2013-08-22','09:10:00',3.27),('11288','2013-08-22','09:15:00',3.37),('11288','2013-08-22','09:20:00',3.62),('11288','2013-08-22','09:25:00',3.71),('11288','2013-08-22','09:30:00',3.97),('11288','2013-08-22','09:35:00',2.69),('11288','2013-08-22','09:40:00',3.24),('11288','2013-08-22','09:45:00',3.88),('11288','2013-08-22','09:50:00',3.96),('11288','2013-08-22','09:55:00',3.83),('11288','2013-08-22','10:00:00',4.38),('11288','2013-08-22','10:05:00',4.46),('11288','2013-08-22','10:10:00',4.54),('11288','2013-08-22','10:15:00',4.56),('11288','2013-08-22','10:20:00',4.58),('11288','2013-08-22','10:25:00',4.78),('11288','2013-08-22','10:30:00',4.87),('11288','2013-08-22','10:35:00',4.97),('11288','2013-08-22','10:40:00',5.04),('11288','2013-08-22','10:45:00',5.09),('11288','2013-08-22','10:50:00',5.17),('11288','2013-08-22','10:55:00',5.24),('11288','2013-08-22','11:00:00',5.33),('11288','2013-08-22','11:05:00',5.36),('11288','2013-08-22','11:10:00',5.41),('11288','2013-08-22','11:15:00',5.39),('11288','2013-08-22','11:20:00',5.46),('11288','2013-08-22','11:25:00',5.44),('11288','2013-08-22','11:30:00',5.55),('11288','2013-08-22','11:35:00',5.59),('11288','2013-08-22','11:40:00',5.66),('11288','2013-08-22','11:45:00',5.68),('11288','2013-08-22','11:50:00',5.69),('11288','2013-08-22','11:55:00',5.79),('11288','2013-08-22','12:00:00',5.81),('11288','2013-08-22','12:05:00',5.88),('11288','2013-08-22','12:10:00',5.89),('11288','2013-08-22','12:15:00',5.94),('11288','2013-08-22','12:20:00',5.98),('11288','2013-08-22','12:25:00',5.99),('11288','2013-08-22','12:30:00',5.97),('11288','2013-08-22','12:35:00',5.96),('11288','2013-08-22','12:40:00',5.99),('11288','2013-08-22','12:45:00',6.03),('11288','2013-08-22','12:50:00',6.04),('11288','2013-08-22','12:55:00',6.02),('11288','2013-08-22','13:00:00',5.99),('11288','2013-08-22','13:05:00',5.98),('11288','2013-08-22','13:10:00',5.88),('11288','2013-08-22','13:15:00',5.91),('11288','2013-08-22','13:20:00',5.89),('11288','2013-08-22','13:25:00',5.89),('11288','2013-08-22','13:30:00',5.94),('11288','2013-08-22','13:35:00',5.92),('11288','2013-08-22','13:40:00',5.83),('11288','2013-08-22','13:45:00',5.92),('11288','2013-08-22','13:50:00',5.96),('11288','2013-08-22','13:55:00',5.87),('11288','2013-08-22','14:00:00',5.86),('11288','2013-08-22','14:05:00',5.87),('11288','2013-08-22','14:10:00',5.83),('11288','2013-08-22','14:15:00',5.82),('11288','2013-08-22','14:20:00',5.87),('11288','2013-08-22','14:25:00',5.9),('11288','2013-08-22','14:30:00',5.85),('11288','2013-08-22','14:35:00',5.8),('11288','2013-08-22','14:40:00',5.85),('11288','2013-08-22','14:45:00',5.67),('11288','2013-08-22','14:50:00',5.63),('11288','2013-08-22','14:55:00',5.6),('11288','2013-08-22','15:00:00',5.5),('11288','2013-08-22','15:05:00',5.44),('11288','2013-08-22','15:10:00',5.42),('11288','2013-08-22','15:15:00',5.3),('11288','2013-08-22','15:20:00',5.28),('11288','2013-08-22','15:25:00',5.23),('11288','2013-08-22','15:30:00',5.08),('11288','2013-08-22','15:35:00',5),('11288','2013-08-22','15:40:00',5),('11288','2013-08-22','15:45:00',4.94),('11288','2013-08-22','15:50:00',4.87),('11288','2013-08-22','15:55:00',4.75),('11288','2013-08-22','16:00:00',4.61),('11288','2013-08-22','16:05:00',4.45),('11288','2013-08-22','16:10:00',4.39),('11288','2013-08-22','16:15:00',4.34),('11288','2013-08-22','16:20:00',4.21),('11288','2013-08-22','16:25:00',4.11),('11288','2013-08-22','16:30:00',4.03),('11288','2013-08-22','16:35:00',3.88),('11288','2013-08-22','16:40:00',3.73),('11288','2013-08-22','16:45:00',3.64),('11288','2013-08-22','16:50:00',3.49),('11288','2013-08-22','16:55:00',3.42),('11288','2013-08-22','17:00:00',3.29),('11288','2013-08-22','17:05:00',3.11),('11288','2013-08-22','17:10:00',3),('11288','2013-08-22','17:15:00',2.86),('11288','2013-08-22','17:20:00',2.74),('11288','2013-08-22','17:25:00',2.62),('11288','2013-08-22','17:30:00',2.5),('11288','2013-08-22','17:35:00',2.38),('11288','2013-08-22','17:40:00',2.23),('11288','2013-08-22','17:45:00',2.08),('11288','2013-08-22','17:50:00',1.91),('11288','2013-08-22','17:55:00',1.8),('11288','2013-08-22','18:00:00',1.74),('11288','2013-08-22','18:05:00',1.65),('11288','2013-08-22','18:10:00',1.6),('11288','2013-08-22','18:15:00',1.6),('11288','2013-08-22','18:20:00',1.41),('11288','2013-08-22','18:25:00',1.17),('11288','2013-08-22','18:30:00',1.12),('11288','2013-08-21','08:20:00',1.16),('11288','2013-08-21','08:25:00',1.31),('11288','2013-08-21','08:30:00',1.38),('11288','2013-08-21','08:35:00',1.5),('11288','2013-08-21','08:40:00',1.44),('11288','2013-08-21','08:45:00',1.35),('11288','2013-08-21','08:50:00',1.24),('11288','2013-08-21','08:55:00',1.31),('11288','2013-08-21','09:00:00',1.54),('11288','2013-08-21','09:05:00',2.51),('11288','2013-08-21','09:10:00',2.44),('11288','2013-08-21','09:15:00',3.66),('11288','2013-08-21','09:20:00',3.65),('11288','2013-08-21','09:25:00',1.98),('11288','2013-08-21','09:30:00',1.35),('11288','2013-08-21','09:35:00',1.53),('11288','2013-08-21','09:40:00',1.78),('11288','2013-08-21','09:45:00',2.33),('11288','2013-08-21','09:50:00',4.14),('11288','2013-08-21','09:55:00',5.56),('11288','2013-08-21','10:00:00',4.94),('11288','2013-08-21','10:05:00',4.1),('11288','2013-08-21','10:10:00',3.41),('11288','2013-08-21','10:15:00',3.2),('11288','2013-08-21','10:20:00',3.25),('11288','2013-08-21','10:25:00',2.7),('11288','2013-08-21','10:30:00',4.16),('11288','2013-08-21','10:35:00',4.73),('11288','2013-08-21','10:40:00',2.7),('11288','2013-08-21','10:45:00',4.07),('11288','2013-08-21','10:50:00',3.76),('11288','2013-08-21','10:55:00',3.04),('11288','2013-08-21','11:00:00',4.35),('11288','2013-08-21','11:05:00',3.25),('11288','2013-08-21','11:10:00',2.95),('11288','2013-08-21','11:15:00',3.52),('11288','2013-08-21','11:20:00',4.3),('11288','2013-08-21','11:25:00',4.51),('11288','2013-08-21','11:30:00',5.52),('11288','2013-08-21','11:35:00',6.84),('11288','2013-08-21','11:40:00',6.43),('11288','2013-08-21','11:45:00',6.33),('11288','2013-08-21','11:50:00',6.32),('11288','2013-08-21','11:55:00',6.23),('11288','2013-08-21','12:00:00',6.36),('11288','2013-08-21','12:05:00',6.39),('11288','2013-08-21','12:10:00',6.41),('11288','2013-08-21','12:15:00',6.46),('11288','2013-08-21','12:20:00',6.4),('11288','2013-08-21','12:25:00',4.58),('11288','2013-08-21','12:30:00',4.07),('11288','2013-08-21','12:35:00',3.43),('11288','2013-08-21','12:40:00',5.96),('11288','2013-08-21','12:45:00',6.35),('11288','2013-08-21','12:50:00',5.99),('11288','2013-08-21','12:55:00',6.02),('11288','2013-08-21','13:00:00',6.2),('11288','2013-08-21','13:05:00',6.19),('11288','2013-08-21','13:10:00',6.33),('11288','2013-08-21','13:15:00',6.41),('11288','2013-08-21','13:20:00',6.45),('11288','2013-08-21','13:25:00',6.41),('11288','2013-08-21','13:30:00',6.2),('11288','2013-08-21','13:35:00',6.16),('11288','2013-08-21','13:40:00',6.3),('11288','2013-08-21','13:45:00',6.28),('11288','2013-08-21','13:50:00',6.03),('11288','2013-08-21','13:55:00',5.99),('11288','2013-08-21','14:00:00',6.01),('11288','2013-08-21','14:05:00',5.58),('11288','2013-08-21','14:10:00',5.75),('11288','2013-08-21','14:15:00',3.41),('11288','2013-08-21','14:20:00',2.5),('11288','2013-08-21','14:25:00',2.96),('11288','2013-08-21','14:30:00',5.43),('11288','2013-08-21','14:35:00',5.72),('11288','2013-08-21','14:40:00',5.67),('11288','2013-08-21','14:45:00',5.5),('11288','2013-08-21','14:50:00',5.32),('11288','2013-08-21','14:55:00',5.39),('11288','2013-08-21','15:00:00',5.52),('11288','2013-08-21','15:05:00',5.44),('11288','2013-08-21','15:10:00',5.27),('11288','2013-08-21','15:15:00',5.22),('11288','2013-08-21','15:20:00',5.04),('11288','2013-08-21','15:25:00',4.76),('11288','2013-08-21','15:30:00',4.65),('11288','2013-08-21','15:35:00',4.52),('11288','2013-08-21','15:40:00',4.31),('11288','2013-08-21','15:45:00',4.46),('11288','2013-08-21','15:50:00',4.39),('11288','2013-08-21','15:55:00',4.46),('11288','2013-08-21','16:00:00',4.07),('11288','2013-08-21','16:05:00',3.81),('11288','2013-08-21','16:10:00',3.74),('11288','2013-08-21','16:15:00',3.82),('11288','2013-08-21','16:20:00',3.97),('11288','2013-08-21','16:25:00',4.03),('11288','2013-08-21','16:30:00',4.24),('11288','2013-08-21','16:35:00',4.22),('11288','2013-08-21','16:40:00',4),('11288','2013-08-21','16:45:00',3.85),('11288','2013-08-21','16:50:00',3.75),('11288','2013-08-21','16:55:00',3.61),('11288','2013-08-21','17:00:00',3.55),('11288','2013-08-21','17:05:00',3.48),('11288','2013-08-21','17:10:00',3.35),('11288','2013-08-21','17:15:00',3.22),('11288','2013-08-21','17:20:00',3.19),('11288','2013-08-21','17:25:00',3.05),('11288','2013-08-21','17:30:00',2.9),('11288','2013-08-21','17:35:00',2.83),('11288','2013-08-21','17:40:00',2.7),('11288','2013-08-21','17:45:00',2.58),('11288','2013-08-21','17:50:00',2.47),('11288','2013-08-21','17:55:00',2.33),('11288','2013-08-21','18:00:00',2.24),('11288','2013-08-21','18:05:00',2.11),('11288','2013-08-21','18:10:00',1.93),('11288','2013-08-21','18:15:00',1.77),('11288','2013-08-21','18:20:00',1.6),('11288','2013-08-21','18:25:00',1.49),('11288','2013-08-21','18:30:00',1.29),('11288','2013-08-21','18:35:00',1.09),('11288','2013-08-20','07:35:00',1.02),('11288','2013-08-20','07:40:00',1.14),('11288','2013-08-20','07:45:00',1.11),('11288','2013-08-20','07:50:00',1.39),('11288','2013-08-20','07:55:00',1.55),('11288','2013-08-20','08:00:00',1.39),('11288','2013-08-20','08:05:00',1.21),('11288','2013-08-20','08:10:00',1.14),('11288','2013-08-20','08:15:00',1.16),('11288','2013-08-20','08:20:00',1.25),('11288','2013-08-20','08:25:00',1.24),('11288','2013-08-20','08:30:00',1.21),('11288','2013-08-20','08:35:00',1.2),('11288','2013-08-20','08:40:00',1.29),('11288','2013-08-20','08:45:00',1.44),('11288','2013-08-20','08:50:00',1.61),('11288','2013-08-20','08:55:00',1.76),('11288','2013-08-20','09:00:00',1.74),('11288','2013-08-20','09:05:00',1.53),('11288','2013-08-20','09:10:00',1.26),('11288','2013-08-20','09:15:00',1.49),('11288','2013-08-20','09:20:00',1.99),('11288','2013-08-20','09:25:00',2.93),('11288','2013-08-20','09:30:00',3.8),('11288','2013-08-20','09:35:00',4.3),('11288','2013-08-20','09:40:00',5.32),('11288','2013-08-20','09:45:00',3.57),('11288','2013-08-20','09:50:00',3.4),('11288','2013-08-20','09:55:00',4.67),('11288','2013-08-20','10:00:00',3.03),('11288','2013-08-20','10:05:00',1.89),('11288','2013-08-20','10:10:00',2.09),('11288','2013-08-20','10:15:00',3.52),('11288','2013-08-20','10:20:00',2.22),('11288','2013-08-20','10:25:00',1.76),('11288','2013-08-20','10:30:00',1.78),('11288','2013-08-20','10:35:00',1.91),('11288','2013-08-20','10:40:00',2.8),('11288','2013-08-20','10:45:00',4.4),('11288','2013-08-20','10:50:00',4.87),('11288','2013-08-20','10:55:00',2.53),('11288','2013-08-20','11:00:00',1.81),('11288','2013-08-20','11:05:00',2.92),('11288','2013-08-20','11:10:00',5.89),('11288','2013-08-20','11:15:00',6.29),('11288','2013-08-20','11:20:00',6.24),('11288','2013-08-20','11:25:00',3.78),('11288','2013-08-20','11:30:00',5.44),('11288','2013-08-20','11:35:00',6.36),('11288','2013-08-20','11:40:00',6.54),('11288','2013-08-20','11:45:00',6.71),('11288','2013-08-20','11:50:00',7.24),('11288','2013-08-20','11:55:00',6.58),('11288','2013-08-20','12:00:00',4.66),('11288','2013-08-20','12:05:00',3.06),('11288','2013-08-20','12:10:00',2.52),('11288','2013-08-20','12:15:00',1.35),('11288','2013-08-20','12:20:00',1.52),('11288','2013-08-20','12:25:00',2.15),('11288','2013-08-20','12:30:00',2.7),('11288','2013-08-20','12:35:00',2.91),('11288','2013-08-20','12:40:00',3.04),('11288','2013-08-20','12:45:00',2.96),('11288','2013-08-20','12:50:00',2.96),('11288','2013-08-20','12:55:00',3.12),('11288','2013-08-20','13:00:00',3.06),('11288','2013-08-20','13:05:00',2.84),('11288','2013-08-20','13:10:00',2.82),('11288','2013-08-20','13:15:00',2.87),('11288','2013-08-20','13:20:00',2.97),('11288','2013-08-20','13:25:00',3.09),('11288','2013-08-20','13:30:00',3.38),('11288','2013-08-20','13:35:00',4.48),('11288','2013-08-20','13:40:00',7.13),('11288','2013-08-20','13:45:00',5.82),('11288','2013-08-20','13:50:00',6.84),('11288','2013-08-20','13:55:00',6.56),('11288','2013-08-20','14:00:00',6.46),('11288','2013-08-20','14:05:00',6.21),('11288','2013-08-20','14:10:00',5.36),('11288','2013-08-20','14:15:00',6.1),('11288','2013-08-20','14:20:00',6.31),('11288','2013-08-20','14:25:00',5.72),('11288','2013-08-20','14:30:00',5.52),('11288','2013-08-20','14:35:00',6.68),('11288','2013-08-20','14:40:00',6.51),('11288','2013-08-20','14:45:00',5.86),('11288','2013-08-20','14:50:00',6.27),('11288','2013-08-20','14:55:00',5.96),('11288','2013-08-20','15:00:00',6.06),('11288','2013-08-20','15:05:00',6.21),('11288','2013-08-20','15:10:00',6.08),('11288','2013-08-20','15:15:00',6.06),('11288','2013-08-20','15:20:00',5.88),('11288','2013-08-20','15:25:00',5.84),('11288','2013-08-20','15:30:00',5.86),('11288','2013-08-20','15:35:00',5.8),('11288','2013-08-20','15:40:00',5.92),('11288','2013-08-20','15:45:00',6.06),('11288','2013-08-20','15:50:00',6.32),('11288','2013-08-20','15:55:00',6.42),('11288','2013-08-20','16:00:00',6.03),('11288','2013-08-20','16:05:00',5.9),('11288','2013-08-20','16:10:00',5.82),('11288','2013-08-20','16:15:00',5.78),('11288','2013-08-20','16:20:00',5.66),('11288','2013-08-20','16:25:00',5.48),('11288','2013-08-20','16:30:00',5.17),('11288','2013-08-20','16:35:00',5.07),('11288','2013-08-20','16:40:00',5.04),('11288','2013-08-20','16:45:00',4.84),('11288','2013-08-20','16:50:00',4.57),('11288','2013-08-20','16:55:00',4.26),('11288','2013-08-20','17:00:00',3.92),('11288','2013-08-20','17:05:00',3.68),('11288','2013-08-20','17:10:00',3.54),('11288','2013-08-20','17:15:00',3.32),('11288','2013-08-20','17:20:00',3.12),('11288','2013-08-20','17:25:00',3.03),('11288','2013-08-20','17:30:00',2.96),('11288','2013-08-20','17:35:00',2.86),('11288','2013-08-20','17:40:00',2.75),('11288','2013-08-20','17:45:00',2.57),('11288','2013-08-20','17:50:00',2.27),('11288','2013-08-20','17:55:00',2.1),('11288','2013-08-20','18:00:00',1.87),('11288','2013-08-20','18:05:00',1.83),('11288','2013-08-20','18:10:00',1.88),('11288','2013-08-20','18:15:00',1.83),('11288','2013-08-20','18:20:00',1.74),('11288','2013-08-20','18:25:00',1.74),('11288','2013-08-20','18:30:00',1.73),('11288','2013-08-20','18:35:00',1.63),('11288','2013-08-20','18:40:00',1.61),('11288','2013-08-20','18:45:00',1.55),('11288','2013-08-20','18:50:00',1.21),('11288','2013-08-20','18:55:00',1.29),('11288','2013-08-20','19:00:00',1.22),('11288','2013-08-20','19:05:00',1.01),('11288','2014-04-10','08:05:00',1.11),('11288','2014-04-10','08:10:00',1.24),('11288','2014-04-10','08:15:00',1.35),('11288','2014-04-10','08:20:00',1.55),('11288','2014-04-10','08:25:00',1.66),('11288','2014-04-10','08:30:00',1.92),('11288','2014-04-10','08:35:00',2.1),('11288','2014-04-10','08:40:00',2.29),('11288','2014-04-10','08:45:00',2.42),('11288','2014-04-10','08:50:00',2.61),('11288','2014-04-10','08:55:00',2.66),('11288','2014-04-10','09:00:00',2.87),('11288','2014-04-10','09:05:00',3.03),('11288','2014-04-10','09:10:00',3.01),('11288','2014-04-10','09:15:00',3.22),('11288','2014-04-10','09:20:00',3.38),('11288','2014-04-10','09:25:00',3.54),('11288','2014-04-10','09:30:00',3.58),('11288','2014-04-10','09:35:00',3.88),('11288','2014-04-10','09:40:00',3.96),('11288','2014-04-10','09:45:00',3.95),('11288','2014-04-10','09:50:00',4.23),('11288','2014-04-10','09:55:00',4.26),('11288','2014-04-10','10:00:00',4.29),('11288','2014-04-10','10:05:00',4.74),('11288','2014-04-10','10:10:00',4.97),('11288','2014-04-10','10:15:00',4.97),('11288','2014-04-10','10:20:00',5.12),('11288','2014-04-10','10:25:00',5.22),('11288','2014-04-10','10:30:00',5.3),('11288','2014-04-10','10:35:00',5.51),('11288','2014-04-10','10:40:00',5.62),('11288','2014-04-10','10:45:00',5.63),('11288','2014-04-10','10:50:00',5.62),('11288','2014-04-10','10:55:00',5.82),('11288','2014-04-10','11:00:00',5.84),('11288','2014-04-10','11:05:00',6.01),('11288','2014-04-10','11:10:00',5.9),('11288','2014-04-10','11:15:00',6.12),('11288','2014-04-10','11:20:00',6.29),('11288','2014-04-10','11:25:00',6.38),('11288','2014-04-10','11:30:00',6.4),('11288','2014-04-10','11:35:00',6.49),('11288','2014-04-10','11:40:00',6.26),('11288','2014-04-10','11:45:00',6.47),('11288','2014-04-10','11:50:00',6.26),('11288','2014-04-10','11:55:00',6.59),('11288','2014-04-10','12:00:00',6.5),('11288','2014-04-10','12:05:00',6.22),('11288','2014-04-10','12:10:00',6.48),('11288','2014-04-10','12:15:00',6.56),('11288','2014-04-10','12:20:00',6.65),('11288','2014-04-10','12:25:00',6.29),('11288','2014-04-10','12:30:00',6.45),('11288','2014-04-10','12:35:00',6.87),('11288','2014-04-10','12:40:00',6.48),('11288','2014-04-10','12:45:00',6.65),('11288','2014-04-10','12:50:00',6.68),('11288','2014-04-10','12:55:00',6.62),('11288','2014-04-10','13:00:00',6.48),('11288','2014-04-10','13:05:00',6.29),('11288','2014-04-10','13:10:00',6.53),('11288','2014-04-10','13:15:00',6.45),('11288','2014-04-10','13:20:00',6.25),('11288','2014-04-10','13:25:00',6.79),('11288','2014-04-10','13:30:00',6.68),('11288','2014-04-10','13:35:00',6.8),('11288','2014-04-10','13:40:00',6.44),('11288','2014-04-10','13:45:00',6.77),('11288','2014-04-10','13:50:00',6.75),('11288','2014-04-10','13:55:00',6.74),('11288','2014-04-10','14:00:00',6.69),('11288','2014-04-10','14:05:00',6.56),('11288','2014-04-10','14:10:00',6.52),('11288','2014-04-10','14:15:00',6.55),('11288','2014-04-10','14:20:00',6.61),('11288','2014-04-10','14:25:00',6.53),('11288','2014-04-10','14:30:00',6.42),('11288','2014-04-10','14:35:00',6.4),('11288','2014-04-10','14:40:00',6.33),('11288','2014-04-10','14:45:00',5.69),('11288','2014-04-10','14:50:00',6.33),('11288','2014-04-10','14:55:00',6.22),('11288','2014-04-10','15:00:00',6.18),('11288','2014-04-10','15:05:00',6.04),('11288','2014-04-10','15:10:00',5.92),('11288','2014-04-10','15:15:00',5.89),('11288','2014-04-10','15:20:00',5.86),('11288','2014-04-10','15:25:00',5.73),('11288','2014-04-10','15:30:00',5.28),('11288','2014-04-10','15:35:00',5.08),('11288','2014-04-10','15:40:00',5.1),('11288','2014-04-10','15:45:00',5.2),('11288','2014-04-10','15:50:00',5.19),('11288','2014-04-10','15:55:00',5.09),('11288','2014-04-10','16:00:00',5.01),('11288','2014-04-10','16:05:00',5.07),('11288','2014-04-10','16:10:00',5.06),('11288','2014-04-10','16:15:00',5.11),('11288','2014-04-10','16:20:00',4.86),('11288','2014-04-10','16:25:00',4.82),('11288','2014-04-10','16:30:00',4.75),('11288','2014-04-10','16:35:00',4.48),('11288','2014-04-10','16:40:00',4.42),('11288','2014-04-10','16:45:00',4.42),('11288','2014-04-10','16:50:00',4.05),('11288','2014-04-10','16:55:00',3.97),('11288','2014-04-10','17:00:00',3.79),('11288','2014-04-10','17:05:00',3.63),('11288','2014-04-10','17:10:00',3.47),('11288','2014-04-10','17:15:00',3.25),('11288','2014-04-10','17:20:00',3.14),('11288','2014-04-10','17:25:00',2.97),('11288','2014-04-10','17:30:00',2.79),('11288','2014-04-10','17:35:00',2.61),('11288','2014-04-10','17:40:00',2.46),('11288','2014-04-10','17:45:00',2.3),('11288','2014-04-10','17:50:00',2.14),('11288','2014-04-10','17:55:00',1.99),('11288','2014-04-10','18:00:00',1.83),('11288','2014-04-10','18:05:00',1.65),('11288','2014-04-10','18:10:00',1.54),('11288','2014-04-10','18:15:00',1.41),('11288','2014-04-10','18:20:00',1.27),('11288','2014-04-10','18:25:00',1.12),('11288','2013-08-19','07:50:00',1.05),('11288','2013-08-19','07:55:00',1.12),('11288','2013-08-19','08:00:00',1.22),('11288','2013-08-19','08:05:00',1.32),('11288','2013-08-19','08:10:00',1.43),('11288','2013-08-19','08:15:00',1.56),('11288','2013-08-19','08:20:00',1.68),('11288','2013-08-19','08:25:00',1.8),('11288','2013-08-19','08:30:00',1.85),('11288','2013-08-19','08:35:00',2.05),('11288','2013-08-19','08:40:00',2.03),('11288','2013-08-19','08:45:00',1.95),('11288','2013-08-19','08:50:00',2.43),('11288','2013-08-19','08:55:00',2.61),('11288','2013-08-19','09:00:00',2.65),('11288','2013-08-19','09:05:00',2.85),('11288','2013-08-19','09:10:00',2.95),('11288','2013-08-19','09:15:00',2.98),('11288','2013-08-19','09:20:00',3.33),('11288','2013-08-19','09:25:00',3.5),('11288','2013-08-19','09:30:00',3.58),('11288','2013-08-19','09:35:00',3.73),('11288','2013-08-19','09:40:00',3.75),('11288','2013-08-19','09:45:00',3.82),('11288','2013-08-19','09:50:00',4),('11288','2013-08-19','09:55:00',4.05),('11288','2013-08-19','10:00:00',4.08),('11288','2013-08-19','10:05:00',4.31),('11288','2013-08-19','10:10:00',4.47),('11288','2013-08-19','10:15:00',4.58),('11288','2013-08-19','10:20:00',4.66),('11288','2013-08-19','10:25:00',4.78),('11288','2013-08-19','10:30:00',4.9),('11288','2013-08-19','10:35:00',5.02),('11288','2013-08-19','10:40:00',5.04),('11288','2013-08-19','10:45:00',5.18),('11288','2013-08-19','10:50:00',5.27),('11288','2013-08-19','10:55:00',5.3),('11288','2013-08-19','11:00:00',5.38),('11288','2013-08-19','11:05:00',5.4),('11288','2013-08-19','11:10:00',5.54),('11288','2013-08-19','11:15:00',5.6),('11288','2013-08-19','11:20:00',5.63),('11288','2013-08-19','11:25:00',5.66),('11288','2013-08-19','11:30:00',5.69),('11288','2013-08-19','11:35:00',5.73),('11288','2013-08-19','11:40:00',5.71),('11288','2013-08-19','11:45:00',5.7),('11288','2013-08-19','11:50:00',5.73),('11288','2013-08-19','11:55:00',5.83),('11288','2013-08-19','12:00:00',5.93),('11288','2013-08-19','12:05:00',5.94),('11288','2013-08-19','12:10:00',6.01),('11288','2013-08-19','12:15:00',6.05),('11288','2013-08-19','12:20:00',6.07),('11288','2013-08-19','12:25:00',6.14),('11288','2013-08-19','12:30:00',6.13),('11288','2013-08-19','12:35:00',6.16),('11288','2013-08-19','12:40:00',6.2),('11288','2013-08-19','12:45:00',6.24),('11288','2013-08-19','12:50:00',6.21),('11288','2013-08-19','12:55:00',6.26),('11288','2013-08-19','13:00:00',6.28),('11288','2013-08-19','13:05:00',6.32),('11288','2013-08-19','13:10:00',6.31),('11288','2013-08-19','13:15:00',6.3),('11288','2013-08-19','13:20:00',6.31),('11288','2013-08-19','13:25:00',6.3),('11288','2013-08-19','13:30:00',6.28),('11288','2013-08-19','13:35:00',6.25),('11288','2013-08-19','13:40:00',6.27),('11288','2013-08-19','13:45:00',6.25),('11288','2013-08-19','13:50:00',6.27),('11288','2013-08-19','13:55:00',6.25),('11288','2013-08-19','14:00:00',6.18),('11288','2013-08-19','14:05:00',6.17),('11288','2013-08-19','14:10:00',6.15),('11288','2013-08-19','14:15:00',6.15),('11288','2013-08-19','14:20:00',6.07),('11288','2013-08-19','14:25:00',6.06),('11288','2013-08-19','14:30:00',6.06),('11288','2013-08-19','14:35:00',6.01),('11288','2013-08-19','14:40:00',6.02),('11288','2013-08-19','14:45:00',5.98),('11288','2013-08-19','14:50:00',5.94),('11288','2013-08-19','14:55:00',5.9),('11288','2013-08-19','15:00:00',5.85),('11288','2013-08-19','15:05:00',5.76),('11288','2013-08-19','15:10:00',5.75),('11288','2013-08-19','15:15:00',5.69),('11288','2013-08-19','15:20:00',5.66),('11288','2013-08-19','15:25:00',5.53),('11288','2013-08-19','15:30:00',5.49),('11288','2013-08-19','15:35:00',5.43),('11288','2013-08-19','15:40:00',5.35),('11288','2013-08-19','15:45:00',5.26),('11288','2013-08-19','15:50:00',5.17),('11288','2013-08-19','15:55:00',5.11),('11288','2013-08-19','16:00:00',4.97),('11288','2013-08-19','16:05:00',4.86),('11288','2013-08-19','16:10:00',4.8),('11288','2013-08-19','16:15:00',4.72),('11288','2013-08-19','16:20:00',4.58),('11288','2013-08-19','16:25:00',4.45),('11288','2013-08-19','16:30:00',4.36),('11288','2013-08-19','16:35:00',4.27),('11288','2013-08-19','16:40:00',4.15),('11288','2013-08-19','16:45:00',4.01),('11288','2013-08-19','16:50:00',3.89),('11288','2013-08-19','16:55:00',3.78),('11288','2013-08-19','17:00:00',3.64),('11288','2013-08-19','17:05:00',3.5),('11288','2013-08-19','17:10:00',3.37),('11288','2013-08-19','17:15:00',3.24),('11288','2013-08-19','17:20:00',3.12),('11288','2013-08-19','17:25:00',2.99),('11288','2013-08-19','17:30:00',2.85),('11288','2013-08-19','17:35:00',2.73),('11288','2013-08-19','17:40:00',2.56),('11288','2013-08-19','17:45:00',2.38),('11288','2013-08-19','17:50:00',2.22),('11288','2013-08-19','17:55:00',2.18),('11288','2013-08-19','18:00:00',2.04),('11288','2013-08-19','18:05:00',1.91),('11288','2013-08-19','18:10:00',1.73),('11288','2013-08-19','18:15:00',1.61),('11288','2013-08-19','18:20:00',1.51),('11288','2013-08-19','18:25:00',1.4),('11288','2013-08-19','18:30:00',1.28),('11288','2013-08-19','18:35:00',1.22),('11288','2013-08-19','18:40:00',1.13),('11288','2013-08-18','07:50:00',1.07),('11288','2013-08-18','07:55:00',1.15),('11288','2013-08-18','08:00:00',1.24),('11288','2013-08-18','08:05:00',1.36),('11288','2013-08-18','08:10:00',1.48),('11288','2013-08-18','08:15:00',1.61),('11288','2013-08-18','08:20:00',1.78),('11288','2013-08-18','08:25:00',1.82),('11288','2013-08-18','08:30:00',1.89),('11288','2013-08-18','08:35:00',2.08),('11288','2013-08-18','08:40:00',1.97),('11288','2013-08-18','08:45:00',2.15),('11288','2013-08-18','08:50:00',2.5),('11288','2013-08-18','08:55:00',2.62),('11288','2013-08-18','09:00:00',2.79),('11288','2013-08-18','09:05:00',2.93),('11288','2013-08-18','09:10:00',3.2),('11288','2013-08-18','09:15:00',3.27),('11288','2013-08-18','09:20:00',3.46),('11288','2013-08-18','09:25:00',3.62),('11288','2013-08-18','09:30:00',3.73),('11288','2013-08-18','09:35:00',3.82),('11288','2013-08-18','09:40:00',3.74),('11288','2013-08-18','09:45:00',3.85),('11288','2013-08-18','09:50:00',3.66),('11288','2013-08-18','09:55:00',3.38),('11288','2013-08-18','10:00:00',3.98),('11288','2013-08-18','10:05:00',3.67),('11288','2013-08-18','10:10:00',4.48),('11288','2013-08-18','10:15:00',4.63),('11288','2013-08-18','10:20:00',4.78),('11288','2013-08-18','10:25:00',4.88),('11288','2013-08-18','10:30:00',4.95),('11288','2013-08-18','10:35:00',5.05),('11288','2013-08-18','10:40:00',5.09),('11288','2013-08-18','10:45:00',5.15),('11288','2013-08-18','10:50:00',5.22),('11288','2013-08-18','10:55:00',5.17),('11288','2013-08-18','11:00:00',5.35),('11288','2013-08-18','11:05:00',5.41),('11288','2013-08-18','11:10:00',5.45),('11288','2013-08-18','11:15:00',5.52),('11288','2013-08-18','11:20:00',5.57),('11288','2013-08-18','11:25:00',5.62),('11288','2013-08-18','11:30:00',5.67),('11288','2013-08-18','11:35:00',5.73),('11288','2013-08-18','11:40:00',5.77),('11288','2013-08-18','11:45:00',5.81),('11288','2013-08-18','11:50:00',5.91),('11288','2013-08-18','11:55:00',5.87),('11288','2013-08-18','12:00:00',6.02),('11288','2013-08-18','12:05:00',6.16),('11288','2013-08-18','12:10:00',6.25),('11288','2013-08-18','12:15:00',6.28),('11288','2013-08-18','12:20:00',6.29),('11288','2013-08-18','12:25:00',6),('11288','2013-08-18','12:30:00',3.51),('11288','2013-08-18','12:35:00',2.46),('11288','2013-08-18','12:40:00',1.42),('11288','2013-08-18','12:45:00',1.77),('11288','2013-08-18','12:50:00',1.81),('11288','2013-08-18','12:55:00',4.03),('11288','2013-08-18','13:00:00',6.15),('11288','2013-08-18','13:05:00',6.21),('11288','2013-08-18','13:10:00',6.61),('11288','2013-08-18','13:15:00',6.58),('11288','2013-08-18','13:20:00',6.38),('11288','2013-08-18','13:25:00',6.27),('11288','2013-08-18','13:30:00',6.3),('11288','2013-08-18','13:35:00',6.26),('11288','2013-08-18','13:40:00',6.25),('11288','2013-08-18','13:45:00',6.24),('11288','2013-08-18','13:50:00',6.15),('11288','2013-08-18','13:55:00',6.17),('11288','2013-08-18','14:00:00',6.26),('11288','2013-08-18','14:05:00',6.2),('11288','2013-08-18','14:10:00',6.17),('11288','2013-08-18','14:15:00',6.17),('11288','2013-08-18','14:20:00',6.13),('11288','2013-08-18','14:25:00',6.1),('11288','2013-08-18','14:30:00',6.11),('11288','2013-08-18','14:35:00',6.07),('11288','2013-08-18','14:40:00',6.02),('11288','2013-08-18','14:45:00',5.97),('11288','2013-08-18','14:50:00',5.87),('11288','2013-08-18','14:55:00',5.83),('11288','2013-08-18','15:00:00',5.83),('11288','2013-08-18','15:05:00',5.82),('11288','2013-08-18','15:10:00',5.76),('11288','2013-08-18','15:15:00',5.67),('11288','2013-08-18','15:20:00',5.61),('11288','2013-08-18','15:25:00',5.56),('11288','2013-08-18','15:30:00',5.48),('11288','2013-08-18','15:35:00',5.39),('11288','2013-08-18','15:40:00',5.33),('11288','2013-08-18','15:45:00',5.26),('11288','2013-08-18','15:50:00',5.17),('11288','2013-08-18','15:55:00',5.07),('11288','2013-08-18','16:00:00',4.94),('11288','2013-08-18','16:05:00',4.85),('11288','2013-08-18','16:10:00',4.77),('11288','2013-08-18','16:15:00',4.67),('11288','2013-08-18','16:20:00',4.56),('11288','2013-08-18','16:25:00',4.46),('11288','2013-08-18','16:30:00',4.36),('11288','2013-08-18','16:35:00',4.24),('11288','2013-08-18','16:40:00',4.15),('11288','2013-08-18','16:45:00',4.01),('11288','2013-08-18','16:50:00',3.91),('11288','2013-08-18','16:55:00',3.79),('11288','2013-08-18','17:00:00',3.67),('11288','2013-08-18','17:05:00',3.52),('11288','2013-08-18','17:10:00',3.43),('11288','2013-08-18','17:15:00',3.3),('11288','2013-08-18','17:20:00',3.16),('11288','2013-08-18','17:25:00',3.06),('11288','2013-08-18','17:30:00',2.9),('11288','2013-08-18','17:35:00',2.75),('11288','2013-08-18','17:40:00',2.56),('11288','2013-08-18','17:45:00',2.38),('11288','2013-08-18','17:50:00',2.27),('11288','2013-08-18','17:55:00',2.19),('11288','2013-08-18','18:00:00',2.05),('11288','2013-08-18','18:05:00',1.92),('11288','2013-08-18','18:10:00',1.75),('11288','2013-08-18','18:15:00',1.65),('11288','2013-08-18','18:20:00',1.55),('11288','2013-08-18','18:25:00',1.43),('11288','2013-08-18','18:30:00',1.33),('11288','2013-08-18','18:35:00',1.29),('11288','2013-08-18','18:40:00',1.16),('11288','2013-08-18','18:45:00',1),('11288','2013-08-17','07:50:00',1.01),('11288','2013-08-17','07:55:00',1.11),('11288','2013-08-17','08:00:00',1.22),('11288','2013-08-17','08:05:00',1.29),('11288','2013-08-17','08:10:00',1.39),('11288','2013-08-17','08:15:00',1.51),('11288','2013-08-17','08:20:00',1.58),('11288','2013-08-17','08:25:00',1.74),('11288','2013-08-17','08:30:00',1.9),('11288','2013-08-17','08:35:00',2.05),('11288','2013-08-17','08:40:00',2.01),('11288','2013-08-17','08:45:00',2.28),('11288','2013-08-17','08:50:00',2.48),('11288','2013-08-17','08:55:00',2.61),('11288','2013-08-17','09:00:00',2.81),('11288','2013-08-17','09:05:00',2.93),('11288','2013-08-17','09:10:00',3.03),('11288','2013-08-17','09:15:00',3.29),('11288','2013-08-17','09:20:00',3.38),('11288','2013-08-17','09:25:00',3.5),('11288','2013-08-17','09:30:00',3.74),('11288','2013-08-17','09:35:00',3.73),('11288','2013-08-17','09:40:00',3.84),('11288','2013-08-17','09:45:00',3.98),('11288','2013-08-17','09:50:00',4.06),('11288','2013-08-17','09:55:00',4.05),('11288','2013-08-17','10:00:00',4.25),('11288','2013-08-17','10:05:00',4.43),('11288','2013-08-17','10:10:00',4.51),('11288','2013-08-17','10:15:00',4.61),('11288','2013-08-17','10:20:00',4.78),('11288','2013-08-17','10:25:00',4.89),('11288','2013-08-17','10:30:00',4.96),('11288','2013-08-17','10:35:00',5.09),('11288','2013-08-17','10:40:00',5.18),('11288','2013-08-17','10:45:00',5.28),('11288','2013-08-17','10:50:00',5.35),('11288','2013-08-17','10:55:00',5.41),('11288','2013-08-17','11:00:00',5.48),('11288','2013-08-17','11:05:00',5.55),('11288','2013-08-17','11:10:00',5.58),('11288','2013-08-17','11:15:00',5.61),('11288','2013-08-17','11:20:00',5.68),('11288','2013-08-17','11:25:00',5.76),('11288','2013-08-17','11:30:00',5.72),('11288','2013-08-17','11:35:00',5.75),('11288','2013-08-17','11:40:00',5.84),('11288','2013-08-17','11:45:00',5.9),('11288','2013-08-17','11:50:00',5.53),('11288','2013-08-17','11:55:00',5.54),('11288','2013-08-17','12:00:00',5.99),('11288','2013-08-17','12:05:00',6.04),('11288','2013-08-17','12:10:00',6.06),('11288','2013-08-17','12:15:00',6.02),('11288','2013-08-17','12:20:00',6.09),('11288','2013-08-17','12:25:00',6.32),('11288','2013-08-17','12:30:00',6.32),('11288','2013-08-17','12:35:00',6.25),('11288','2013-08-17','12:40:00',6.23),('11288','2013-08-17','12:45:00',6.18),('11288','2013-08-17','12:50:00',6.32),('11288','2013-08-17','12:55:00',6.41),('11288','2013-08-17','13:00:00',6.42),('11288','2013-08-17','13:05:00',6.15),('11288','2013-08-17','13:10:00',4),('11288','2013-08-17','13:15:00',6.19),('11288','2013-08-17','13:20:00',6.61),('11288','2013-08-17','13:25:00',6.46),('11288','2013-08-17','13:30:00',6.58),('11288','2013-08-17','13:35:00',6.61),('11288','2013-08-17','13:40:00',5.43),('11288','2013-08-17','13:45:00',6.68),('11288','2013-08-17','13:50:00',5.63),('11288','2013-08-17','13:55:00',6.3),('11288','2013-08-17','14:00:00',4.04),('11288','2013-08-17','14:05:00',6.39),('11288','2013-08-17','14:10:00',6.25),('11288','2013-08-17','14:15:00',6.18),('11288','2013-08-17','14:20:00',5.04),('11288','2013-08-17','14:25:00',6.01),('11288','2013-08-17','14:30:00',5.56),('11288','2013-08-17','14:35:00',5.99),('11288','2013-08-17','14:40:00',5.9),('11288','2013-08-17','14:45:00',5.97),('11288','2013-08-17','14:50:00',5.87),('11288','2013-08-17','14:55:00',5.84),('11288','2013-08-17','15:00:00',5.77),('11288','2013-08-17','15:05:00',5.75),('11288','2013-08-17','15:10:00',5.68),('11288','2013-08-17','15:15:00',5.61),('11288','2013-08-17','15:20:00',5.54),('11288','2013-08-17','15:25:00',5.53),('11288','2013-08-17','15:30:00',5.44),('11288','2013-08-17','15:35:00',5.4),('11288','2013-08-17','15:40:00',5.34),('11288','2013-08-17','15:45:00',5.26),('11288','2013-08-17','15:50:00',5.19),('11288','2013-08-17','15:55:00',5.11),('11288','2013-08-17','16:00:00',5.01),('11288','2013-08-17','16:05:00',4.87),('11288','2013-08-17','16:10:00',4.78),('11288','2013-08-17','16:15:00',4.69),('11288','2013-08-17','16:20:00',4.66),('11288','2013-08-17','16:25:00',4.48),('11288','2013-08-17','16:30:00',4.42),('11288','2013-08-17','16:35:00',4.34),('11288','2013-08-17','16:40:00',4.26),('11288','2013-08-17','16:45:00',4.03),('11288','2013-08-17','16:50:00',3.94),('11288','2013-08-17','16:55:00',3.89),('11288','2013-08-17','17:00:00',3.78),('11288','2013-08-17','17:05:00',3.58),('11288','2013-08-17','17:10:00',3.32),('11288','2013-08-17','17:15:00',3.09),('11288','2013-08-17','17:20:00',3.08),('11288','2013-08-17','17:25:00',3.19),('11288','2013-08-17','17:30:00',3.07),('11288','2013-08-17','17:35:00',2.93),('11288','2013-08-17','17:40:00',2.74),('11288','2013-08-17','17:45:00',2.55),('11288','2013-08-17','17:50:00',2.48),('11288','2013-08-17','17:55:00',2.34),('11288','2013-08-17','18:00:00',2.2),('11288','2013-08-17','18:05:00',2.04),('11288','2013-08-17','18:10:00',1.86),('11288','2013-08-17','18:15:00',1.77),('11288','2013-08-17','18:20:00',1.65),('11288','2013-08-17','18:25:00',1.52),('11288','2013-08-17','18:30:00',1.42),('11288','2013-08-17','18:35:00',1.35),('11288','2013-08-17','18:40:00',1.22),('11288','2013-08-17','18:45:00',1.07),('11288','2013-08-16','07:50:00',1.02),('11288','2013-08-16','07:55:00',1.16),('11288','2013-08-16','08:00:00',1.27),('11288','2013-08-16','08:05:00',1.33),('11288','2013-08-16','08:10:00',1.43),('11288','2013-08-16','08:15:00',1.61),('11288','2013-08-16','08:20:00',1.76),('11288','2013-08-16','08:25:00',1.78),('11288','2013-08-16','08:30:00',2),('11288','2013-08-16','08:35:00',2.06),('11288','2013-08-16','08:40:00',2.1),('11288','2013-08-16','08:45:00',2.35),('11288','2013-08-16','08:50:00',2.52),('11288','2013-08-16','08:55:00',2.71),('11288','2013-08-16','09:00:00',2.87),('11288','2013-08-16','09:05:00',3.09),('11288','2013-08-16','09:10:00',3.21),('11288','2013-08-16','09:15:00',3.41),('11288','2013-08-16','09:20:00',3.57),('11288','2013-08-16','09:25:00',3.74),('11288','2013-08-16','09:30:00',3.88),('11288','2013-08-16','09:35:00',3.94),('11288','2013-08-16','09:40:00',4.12),('11288','2013-08-16','09:45:00',4.19),('11288','2013-08-16','09:50:00',4.29),('11288','2013-08-16','09:55:00',4.35),('11288','2013-08-16','10:00:00',4.54),('11288','2013-08-16','10:05:00',4.59),('11288','2013-08-16','10:10:00',4.52),('11288','2013-08-16','10:15:00',4.73),('11288','2013-08-16','10:20:00',4.94),('11288','2013-08-16','10:25:00',5.08),('11288','2013-08-16','10:30:00',5.16),('11288','2013-08-16','10:35:00',5.28),('11288','2013-08-16','10:40:00',5.37),('11288','2013-08-16','10:45:00',5.48),('11288','2013-08-16','10:50:00',5.55),('11288','2013-08-16','10:55:00',5.65),('11288','2013-08-16','11:00:00',5.68),('11288','2013-08-16','11:05:00',5.75),('11288','2013-08-16','11:10:00',5.81),('11288','2013-08-16','11:15:00',5.83),('11288','2013-08-16','11:20:00',5.89),('11288','2013-08-16','11:25:00',5.93),('11288','2013-08-16','11:30:00',5.94),('11288','2013-08-16','11:35:00',5.97),('11288','2013-08-16','11:40:00',6.01),('11288','2013-08-16','11:45:00',6.02),('11288','2013-08-16','11:50:00',6.09),('11288','2013-08-16','11:55:00',6.11),('11288','2013-08-16','12:00:00',6.14),('11288','2013-08-16','12:05:00',6.22),('11288','2013-08-16','12:10:00',6.26),('11288','2013-08-16','12:15:00',6.31),('11288','2013-08-16','12:20:00',6.33),('11288','2013-08-16','12:25:00',6.36),('11288','2013-08-16','12:30:00',6.38),('11288','2013-08-16','12:35:00',6.4),('11288','2013-08-16','12:40:00',6.4),('11288','2013-08-16','12:45:00',6.34),('11288','2013-08-16','12:50:00',6.35),('11288','2013-08-16','12:55:00',6.32),('11288','2013-08-16','13:00:00',6.33),('11288','2013-08-16','13:05:00',6.33),('11288','2013-08-16','13:10:00',6.32),('11288','2013-08-16','13:15:00',6.31),('11288','2013-08-16','13:20:00',6.35),('11288','2013-08-16','13:25:00',6.33),('11288','2013-08-16','13:30:00',6.31),('11288','2013-08-16','13:35:00',6.33),('11288','2013-08-16','13:40:00',6.26),('11288','2013-08-16','13:45:00',6.23),('11288','2013-08-16','13:50:00',6.2),('11288','2013-08-16','13:55:00',6.19),('11288','2013-08-16','14:00:00',6.19),('11288','2013-08-16','14:05:00',6.16),('11288','2013-08-16','14:10:00',6.13),('11288','2013-08-16','14:15:00',6.11),('11288','2013-08-16','14:20:00',6.07),('11288','2013-08-16','14:25:00',6),('11288','2013-08-16','14:30:00',5.91),('11288','2013-08-16','14:35:00',5.92),('11288','2013-08-16','14:40:00',5.95),('11288','2013-08-16','14:45:00',5.88),('11288','2013-08-16','14:50:00',5.82),('11288','2013-08-16','14:55:00',5.73),('11288','2013-08-16','15:00:00',5.6),('11288','2013-08-16','15:05:00',5.52),('11288','2013-08-16','15:10:00',5.62),('11288','2013-08-16','15:15:00',5.52),('11288','2013-08-16','15:20:00',5.56),('11288','2013-08-16','15:25:00',5.52),('11288','2013-08-16','15:30:00',5.49),('11288','2013-08-16','15:35:00',5.41),('11288','2013-08-16','15:40:00',5.33),('11288','2013-08-16','15:45:00',5.26),('11288','2013-08-16','15:50:00',5.24),('11288','2013-08-16','15:55:00',5.18),('11288','2013-08-16','16:00:00',5.08),('11288','2013-08-16','16:05:00',4.93),('11288','2013-08-16','16:10:00',4.86),('11288','2013-08-16','16:15:00',4.78),('11288','2013-08-16','16:20:00',4.67),('11288','2013-08-16','16:25:00',4.56),('11288','2013-08-16','16:30:00',4.45),('11288','2013-08-16','16:35:00',4.36),('11288','2013-08-16','16:40:00',4.24),('11288','2013-08-16','16:45:00',4.1),('11288','2013-08-16','16:50:00',3.99),('11288','2013-08-16','16:55:00',3.87),('11288','2013-08-16','17:00:00',3.75),('11288','2013-08-16','17:05:00',3.62),('11288','2013-08-16','17:10:00',3.5),('11288','2013-08-16','17:15:00',3.36),('11288','2013-08-16','17:20:00',3.2),('11288','2013-08-16','17:25:00',3.08),('11288','2013-08-16','17:30:00',2.93),('11288','2013-08-16','17:35:00',2.77),('11288','2013-08-16','17:40:00',2.58),('11288','2013-08-16','17:45:00',2.49),('11288','2013-08-16','17:50:00',2.37),('11288','2013-08-16','17:55:00',2.24),('11288','2013-08-16','18:00:00',2.1),('11288','2013-08-16','18:05:00',1.94),('11288','2013-08-16','18:10:00',1.77),('11288','2013-08-16','18:15:00',1.72),('11288','2013-08-16','18:20:00',1.6),('11288','2013-08-16','18:25:00',1.49),('11288','2013-08-16','18:30:00',1.32),('11288','2013-08-15','07:55:00',1.15),('11288','2013-08-15','08:00:00',1.45),('11288','2013-08-15','08:05:00',1.54),('11288','2013-08-15','08:10:00',1.67),('11288','2013-08-15','08:15:00',1.66),('11288','2013-08-15','08:20:00',1.72),('11288','2013-08-15','08:25:00',1.82),('11288','2013-08-15','08:30:00',1.96),('11288','2013-08-15','08:35:00',2.11),('11288','2013-08-15','08:40:00',2.26),('11288','2013-08-15','08:45:00',2.45),('11288','2013-08-15','08:50:00',2.62),('11288','2013-08-15','08:55:00',2.67),('11288','2013-08-15','09:00:00',2.9),('11288','2013-08-15','09:05:00',2.89),('11288','2013-08-15','09:10:00',2.2),('11288','2013-08-15','09:15:00',3.14),('11288','2013-08-15','09:20:00',3.84),('11288','2013-08-15','09:25:00',3.7),('11288','2013-08-15','09:30:00',3.85),('11288','2013-08-15','09:35:00',3.99),('11288','2013-08-15','09:40:00',4.08),('11288','2013-08-15','09:45:00',4.13),('11288','2013-08-15','09:50:00',4.31),('11288','2013-08-15','09:55:00',4.37),('11288','2013-08-15','10:00:00',4.37),('11288','2013-08-15','10:05:00',4.64),('11288','2013-08-15','10:10:00',4.65),('11288','2013-08-15','10:15:00',4.69),('11288','2013-08-15','10:20:00',4.99),('11288','2013-08-15','10:25:00',5.13),('11288','2013-08-15','10:30:00',5.23),('11288','2013-08-15','10:35:00',5.3),('11288','2013-08-15','10:40:00',5.42),('11288','2013-08-15','10:45:00',5.55),('11288','2013-08-15','10:50:00',5.6),('11288','2013-08-15','10:55:00',4.88),('11288','2013-08-15','11:00:00',5.33),('11288','2013-08-15','11:05:00',5.25),('11288','2013-08-15','11:10:00',3.79),('11288','2013-08-15','11:15:00',3.72),('11288','2013-08-15','11:20:00',4.38),('11288','2013-08-15','11:25:00',4.93),('11288','2013-08-15','11:30:00',5.34),('11288','2013-08-15','11:35:00',5.87),('11288','2013-08-15','11:40:00',6.3),('11288','2013-08-15','11:45:00',6.55),('11288','2013-08-15','11:50:00',6.7),('11288','2013-08-15','11:55:00',6.66),('11288','2013-08-15','12:00:00',6.73),('11288','2013-08-15','12:05:00',6.72),('11288','2013-08-15','12:10:00',6.65),('11288','2013-08-15','12:15:00',6.58),('11288','2013-08-15','12:20:00',6.64),('11288','2013-08-15','12:25:00',6.6),('11288','2013-08-15','12:30:00',6.63),('11288','2013-08-15','12:35:00',6.58),('11288','2013-08-15','12:40:00',6.63),('11288','2013-08-15','12:45:00',6.59),('11288','2013-08-15','12:50:00',6.59),('11288','2013-08-15','12:55:00',6.46),('11288','2013-08-15','13:00:00',6.27),('11288','2013-08-15','13:05:00',6.34),('11288','2013-08-15','13:10:00',6.38),('11288','2013-08-15','13:15:00',6.26),('11288','2013-08-15','13:20:00',6.04),('11288','2013-08-15','13:25:00',6.25),('11288','2013-08-15','13:30:00',6.4),('11288','2013-08-15','13:35:00',6.48),('11288','2013-08-15','13:40:00',6.47),('11288','2013-08-15','13:45:00',6.45),('11288','2013-08-15','13:50:00',6.37),('11288','2013-08-15','13:55:00',6.29),('11288','2013-08-15','14:00:00',6.26),('11288','2013-08-15','14:05:00',6.34),('11288','2013-08-15','14:10:00',6.28),('11288','2013-08-15','14:15:00',6.24),('11288','2013-08-15','14:20:00',6.23),('11288','2013-08-15','14:25:00',6.17),('11288','2013-08-15','14:30:00',6.05),('11288','2013-08-15','14:35:00',6.03),('11288','2013-08-15','14:40:00',6.06),('11288','2013-08-15','14:45:00',6),('11288','2013-08-15','14:50:00',5.85),('11288','2013-08-15','14:55:00',5.79),('11288','2013-08-15','15:00:00',5.72),('11288','2013-08-15','15:05:00',5.65),('11288','2013-08-15','15:10:00',5.66),('11288','2013-08-15','15:15:00',5.63),('11288','2013-08-15','15:20:00',5.53),('11288','2013-08-15','15:25:00',5.47),('11288','2013-08-15','15:30:00',5.34),('11288','2013-08-15','15:35:00',5.29),('11288','2013-08-15','15:40:00',5.22),('11288','2013-08-15','15:45:00',5.15),('11288','2013-08-15','15:50:00',5.07),('11288','2013-08-15','15:55:00',4.96),('11288','2013-08-15','16:00:00',4.86),('11288','2013-08-15','16:05:00',4.83),('11288','2013-08-15','16:10:00',4.74),('11288','2013-08-15','16:15:00',4.56),('11288','2013-08-15','16:20:00',4.49),('11288','2013-08-15','16:25:00',4.37),('11288','2013-08-15','16:30:00',4.28),('11288','2013-08-15','16:35:00',4.15),('11288','2013-08-15','16:40:00',3.79),('11288','2013-08-15','16:45:00',3.55),('11288','2013-08-15','16:50:00',3.74),('11288','2013-08-15','16:55:00',3.73),('11288','2013-08-15','17:00:00',3.62),('11288','2013-08-15','17:05:00',3.43),('11288','2013-08-15','17:10:00',3.32),('11288','2013-08-15','17:15:00',3.22),('11288','2013-08-15','17:20:00',2.86),('11288','2013-08-15','17:25:00',2.25),('11288','2013-08-15','17:30:00',2.27),('11288','2013-08-15','17:35:00',2.53),('11288','2013-08-15','17:40:00',2.6),('11288','2013-08-15','17:45:00',2.47),('11288','2013-08-15','17:50:00',2.35),('11288','2013-08-15','17:55:00',2.21),('11288','2013-08-15','18:00:00',2.08),('11288','2013-08-15','18:05:00',1.9),('11288','2013-08-15','18:10:00',1.75),('11288','2013-08-15','18:15:00',1.69),('11288','2013-08-15','18:20:00',1.61),('11288','2013-08-15','18:25:00',1.52),('11288','2013-08-15','18:30:00',1.45),('11288','2013-08-15','18:35:00',1.37),('11288','2013-08-15','18:40:00',1.26),('11288','2013-08-14','07:45:00',1.06),('11288','2013-08-14','07:50:00',1.12),('11288','2013-08-14','07:55:00',1.22),('11288','2013-08-14','08:00:00',1.35),('11288','2013-08-14','08:05:00',1.41),('11288','2013-08-14','08:10:00',1.46),('11288','2013-08-14','08:15:00',1.7),('11288','2013-08-14','08:20:00',1.8),('11288','2013-08-14','08:25:00',1.85),('11288','2013-08-14','08:30:00',2),('11288','2013-08-14','08:35:00',1.98),('11288','2013-08-14','08:40:00',2.06),('11288','2013-08-14','08:45:00',2.38),('11288','2013-08-14','08:50:00',2.36),('11288','2013-08-14','08:55:00',2.58),('11288','2013-08-14','09:00:00',1.94),('11288','2013-08-14','09:05:00',2.72),('11288','2013-08-14','09:10:00',3.34),('11288','2013-08-14','09:15:00',3.63),('11288','2013-08-14','09:20:00',3.87),('11288','2013-08-14','09:25:00',3.61),('11288','2013-08-14','09:30:00',4.11),('11288','2013-08-14','09:35:00',2.29),('11288','2013-08-14','09:40:00',2.08),('11288','2013-08-14','09:45:00',2.88),('11288','2013-08-14','09:50:00',3.25),('11288','2013-08-14','09:55:00',4.02),('11288','2013-08-14','10:00:00',4.47),('11288','2013-08-14','10:05:00',2.67),('11288','2013-08-14','10:10:00',1.92),('11288','2013-08-14','10:15:00',1.82),('11288','2013-08-14','10:20:00',2.57),('11288','2013-08-14','10:25:00',4.77),('11288','2013-08-14','10:30:00',5.94),('11288','2013-08-14','10:35:00',5.62),('11288','2013-08-14','10:40:00',3.58),('11288','2013-08-14','10:45:00',1.8),('11288','2013-08-14','10:50:00',1.78),('11288','2013-08-14','10:55:00',2.11),('11288','2013-08-14','11:00:00',2.41),('11288','2013-08-14','11:05:00',3.5),('11288','2013-08-14','11:10:00',5.88),('11288','2013-08-14','11:15:00',5.86),('11288','2013-08-14','11:20:00',5.52),('11288','2013-08-14','11:25:00',5.71),('11288','2013-08-14','11:30:00',6.11),('11288','2013-08-14','11:35:00',5),('11288','2013-08-14','11:40:00',2.79),('11288','2013-08-14','11:45:00',2.37),('11288','2013-08-14','11:50:00',2.98),('11288','2013-08-14','11:55:00',6.5),('11288','2013-08-14','12:00:00',6.86),('11288','2013-08-14','12:05:00',5.87),('11288','2013-08-14','12:10:00',3.27),('11288','2013-08-14','12:15:00',2.25),('11288','2013-08-14','12:20:00',2.08),('11288','2013-08-14','12:25:00',2.26),('11288','2013-08-14','12:30:00',1.91),('11288','2013-08-14','12:35:00',2.16),('11288','2013-08-14','12:40:00',2.72),('11288','2013-08-14','12:45:00',2.77),('11288','2013-08-14','12:50:00',3.82),('11288','2013-08-14','12:55:00',5.39),('11288','2013-08-14','13:00:00',4.85),('11288','2013-08-14','13:05:00',1.94),('11288','2013-08-14','13:10:00',2.23),('11288','2013-08-14','13:15:00',2.94),('11288','2013-08-14','13:20:00',3.13),('11288','2013-08-14','13:25:00',6.5),('11288','2013-08-14','13:30:00',5.05),('11288','2013-08-14','13:35:00',6.88),('11288','2013-08-14','13:40:00',5.83),('11288','2013-08-14','13:45:00',6.91),('11288','2013-08-14','13:50:00',5.7),('11288','2013-08-14','13:55:00',6.82),('11288','2013-08-14','14:00:00',6.05),('11288','2013-08-14','14:05:00',6.67),('11288','2013-08-14','14:10:00',6.59),('11288','2013-08-14','14:15:00',6.71),('11288','2013-08-14','14:20:00',4.54),('11288','2013-08-14','14:25:00',6.46),('11288','2013-08-14','14:30:00',5.67),('11288','2013-08-14','14:35:00',6.1),('11288','2013-08-14','14:40:00',6.28),('11288','2013-08-14','14:45:00',6.24),('11288','2013-08-14','14:50:00',6.15),('11288','2013-08-14','14:55:00',6.1),('11288','2013-08-14','15:00:00',5.96),('11288','2013-08-14','15:05:00',5.71),('11288','2013-08-14','15:10:00',5.88),('11288','2013-08-14','15:15:00',5.93),('11288','2013-08-14','15:20:00',5.86),('11288','2013-08-14','15:25:00',5.67),('11288','2013-08-14','15:30:00',5.51),('11288','2013-08-14','15:35:00',5.48),('11288','2013-08-14','15:40:00',5.41),('11288','2013-08-14','15:45:00',5.35),('11288','2013-08-14','15:50:00',5.28),('11288','2013-08-14','15:55:00',5.19),('11288','2013-08-14','16:00:00',5.07),('11288','2013-08-14','16:05:00',4.96),('11288','2013-08-14','16:10:00',4.97),('11288','2013-08-14','16:15:00',4.94),('11288','2013-08-14','16:20:00',4.82),('11288','2013-08-14','16:25:00',4.68),('11288','2013-08-14','16:30:00',4.57),('11288','2013-08-14','16:35:00',4.44),('11288','2013-08-14','16:40:00',4.37),('11288','2013-08-14','16:45:00',4.23),('11288','2013-08-14','16:50:00',4.09),('11288','2013-08-14','16:55:00',3.97),('11288','2013-08-14','17:00:00',3.83),('11288','2013-08-14','17:05:00',3.74),('11288','2013-08-14','17:10:00',3.57),('11288','2013-08-14','17:15:00',3.48),('11288','2013-08-14','17:20:00',3.3),('11288','2013-08-14','17:25:00',3.15),('11288','2013-08-14','17:30:00',3.02),('11288','2013-08-14','17:35:00',2.89),('11288','2013-08-14','17:40:00',2.78),('11288','2013-08-14','17:45:00',2.61),('11288','2013-08-14','17:50:00',2.49),('11288','2013-08-14','17:55:00',2.35),('11288','2013-08-14','18:00:00',2.2),('11288','2013-08-14','18:05:00',2.09),('11288','2013-08-14','18:10:00',1.97),('11288','2013-08-14','18:15:00',1.84),('11288','2013-08-14','18:20:00',1.8),('11288','2013-08-14','18:25:00',1.82),('11288','2013-08-14','18:30:00',1.76),('11288','2013-08-14','18:35:00',1.56),('11288','2013-08-14','18:40:00',1.39),('11288','2013-08-14','18:45:00',1.35),('11288','2013-08-14','18:50:00',1.34),('11288','2013-08-14','18:55:00',1.27),('11288','2013-08-14','19:00:00',1.24),('11288','2013-08-14','19:05:00',1.01),('11288','2013-08-13','07:45:00',1.07),('11288','2013-08-13','07:50:00',1.16),('11288','2013-08-13','07:55:00',1.27),('11288','2013-08-13','08:00:00',1.41),('11288','2013-08-13','08:05:00',1.41),('11288','2013-08-13','08:10:00',1.51),('11288','2013-08-13','08:15:00',1.58),('11288','2013-08-13','08:20:00',1.8),('11288','2013-08-13','08:25:00',1.96),('11288','2013-08-13','08:30:00',2.08),('11288','2013-08-13','08:35:00',2.07),('11288','2013-08-13','08:40:00',2.17),('11288','2013-08-13','08:45:00',2.46),('11288','2013-08-13','08:50:00',2.45),('11288','2013-08-13','08:55:00',2.6),('11288','2013-08-13','09:00:00',2.91),('11288','2013-08-13','09:05:00',3.06),('11288','2013-08-13','09:10:00',3.23),('11288','2013-08-13','09:15:00',3.39),('11288','2013-08-13','09:20:00',3.48),('11288','2013-08-13','09:25:00',3.69),('11288','2013-08-13','09:30:00',3.66),('11288','2013-08-13','09:35:00',3.91),('11288','2013-08-13','09:40:00',3.98),('11288','2013-08-13','09:45:00',4.09),('11288','2013-08-13','09:50:00',4.23),('11288','2013-08-13','09:55:00',4.29),('11288','2013-08-13','10:00:00',4.33),('11288','2013-08-13','10:05:00',4.47),('11288','2013-08-13','10:10:00',2.57),('11288','2013-08-13','10:15:00',4.74),('11288','2013-08-13','10:20:00',4.98),('11288','2013-08-13','10:25:00',5),('11288','2013-08-13','10:30:00',5.12),('11288','2013-08-13','10:35:00',5.09),('11288','2013-08-13','10:40:00',5.14),('11288','2013-08-13','10:45:00',5.29),('11288','2013-08-13','10:50:00',5.45),('11288','2013-08-13','10:55:00',5.52),('11288','2013-08-13','11:00:00',5.6),('11288','2013-08-13','11:05:00',5.58),('11288','2013-08-13','11:10:00',5.53),('11288','2013-08-13','11:15:00',5.68),('11288','2013-08-13','11:20:00',5.75),('11288','2013-08-13','11:25:00',5.75),('11288','2013-08-13','11:30:00',5.63),('11288','2013-08-13','11:35:00',5.7),('11288','2013-08-13','11:40:00',5.9),('11288','2013-08-13','11:45:00',5.94),('11288','2013-08-13','11:50:00',6.03),('11288','2013-08-13','11:55:00',6.05),('11288','2013-08-13','12:00:00',4.77),('11288','2013-08-13','12:05:00',3.92),('11288','2013-08-13','12:10:00',6.25),('11288','2013-08-13','12:15:00',6.6),('11288','2013-08-13','12:20:00',6.6),('11288','2013-08-13','12:25:00',6.73),('11288','2013-08-13','12:30:00',5.72),('11288','2013-08-13','12:35:00',2.36),('11288','2013-08-13','12:40:00',1.94),('11288','2013-08-13','12:45:00',2.12),('11288','2013-08-13','12:50:00',2.56),('11288','2013-08-13','12:55:00',5.72),('11288','2013-08-13','13:00:00',5.49),('11288','2013-08-13','13:05:00',3.3),('11288','2013-08-13','13:10:00',4.67),('11288','2013-08-13','13:15:00',4.44),('11288','2013-08-13','13:20:00',2.63),('11288','2013-08-13','13:25:00',2.06),('11288','2013-08-13','13:30:00',3.04),('11288','2013-08-13','13:35:00',6.12),('11288','2013-08-13','13:40:00',4.66),('11288','2013-08-13','13:45:00',2.36),('11288','2013-08-13','13:50:00',4.42),('11288','2013-08-13','13:55:00',7.34),('11288','2013-08-13','14:00:00',6.24),('11288','2013-08-13','14:05:00',7.13),('11288','2013-08-13','14:10:00',6.78),('11288','2013-08-13','14:15:00',6.56),('11288','2013-08-13','14:20:00',6.64),('11288','2013-08-13','14:25:00',6.06),('11288','2013-08-13','14:30:00',5.9),('11288','2013-08-13','14:35:00',5.08),('11288','2013-08-13','14:40:00',4.07),('11288','2013-08-13','14:45:00',3.37),('11288','2013-08-13','14:50:00',2.3),('11288','2013-08-13','14:55:00',6.12),('11288','2013-08-13','15:00:00',6.35),('11288','2013-08-13','15:05:00',5.23),('11288','2013-08-13','15:10:00',6.16),('11288','2013-08-13','15:15:00',6.05),('11288','2013-08-13','15:20:00',4.17),('11288','2013-08-13','15:25:00',5.75),('11288','2013-08-13','15:30:00',5.77),('11288','2013-08-13','15:35:00',4.75),('11288','2013-08-13','15:40:00',5.41),('11288','2013-08-13','15:45:00',5.48),('11288','2013-08-13','15:50:00',5.31),('11288','2013-08-13','15:55:00',5.18),('11288','2013-08-13','16:00:00',5.13),('11288','2013-08-13','16:05:00',5.02),('11288','2013-08-13','16:10:00',4.89),('11288','2013-08-13','16:15:00',4.8),('11288','2013-08-13','16:20:00',4.74),('11288','2013-08-13','16:25:00',4.66),('11288','2013-08-13','16:30:00',4.53),('11288','2013-08-13','16:35:00',4.42),('11288','2013-08-13','16:40:00',4.31),('11288','2013-08-13','16:45:00',4.17),('11288','2013-08-13','16:50:00',4.06),('11288','2013-08-13','16:55:00',3.95),('11288','2013-08-13','17:00:00',3.84),('11288','2013-08-13','17:05:00',3.73),('11288','2013-08-13','17:10:00',3.59),('11288','2013-08-13','17:15:00',3.46),('11288','2013-08-13','17:20:00',3.34),('11288','2013-08-13','17:25:00',3.19),('11288','2013-08-13','17:30:00',3.03),('11288','2013-08-13','17:35:00',2.88),('11288','2013-08-13','17:40:00',2.76),('11288','2013-08-13','17:45:00',2.62),('11288','2013-08-13','17:50:00',2.51),('11288','2013-08-13','17:55:00',2.35),('11288','2013-08-13','18:00:00',2.19),('11288','2013-08-13','18:05:00',2.04),('11288','2013-08-13','18:10:00',1.91),('11288','2013-08-13','18:15:00',1.77),('11288','2013-08-13','18:20:00',1.69),('11288','2013-08-13','18:25:00',1.6),('11288','2013-08-13','18:30:00',1.54),('11288','2013-08-13','18:35:00',1.41),('11288','2013-08-13','18:40:00',1.28),('11288','2013-08-13','18:45:00',1.14),('11288','2013-08-13','18:50:00',1),('11288','2013-08-12','07:45:00',1.05),('11288','2013-08-12','07:50:00',1.14),('11288','2013-08-12','07:55:00',1.27),('11288','2013-08-12','08:00:00',1.34),('11288','2013-08-12','08:05:00',1.45),('11288','2013-08-12','08:10:00',1.53),('11288','2013-08-12','08:15:00',1.6),('11288','2013-08-12','08:20:00',1.81),('11288','2013-08-12','08:25:00',1.91),('11288','2013-08-12','08:30:00',2.01),('11288','2013-08-12','08:35:00',2.15),('11288','2013-08-12','08:40:00',2.23),('11288','2013-08-12','08:45:00',2.39),('11288','2013-08-12','08:50:00',2.45),('11288','2013-08-12','08:55:00',2.5),('11288','2013-08-12','09:00:00',2.82),('11288','2013-08-12','09:05:00',2.99),('11288','2013-08-12','09:10:00',3.17),('11288','2013-08-12','09:15:00',3.37),('11288','2013-08-12','09:20:00',3.41),('11288','2013-08-12','09:25:00',3.63),('11288','2013-08-12','09:30:00',3.69),('11288','2013-08-12','09:35:00',3.88),('11288','2013-08-12','09:40:00',3.98),('11288','2013-08-12','09:45:00',4.1),('11288','2013-08-12','09:50:00',4.14),('11288','2013-08-12','09:55:00',4.25),('11288','2013-08-12','10:00:00',4.25),('11288','2013-08-12','10:05:00',4.38),('11288','2013-08-12','10:10:00',4.44),('11288','2013-08-12','10:15:00',4.66),('11288','2013-08-12','10:20:00',4.77),('11288','2013-08-12','10:25:00',4.85),('11288','2013-08-12','10:30:00',4.95),('11288','2013-08-12','10:35:00',5.07),('11288','2013-08-12','10:40:00',5.13),('11288','2013-08-12','10:45:00',5.22),('11288','2013-08-12','10:50:00',5.32),('11288','2013-08-12','10:55:00',5.4),('11288','2013-08-12','11:00:00',5.44),('11288','2013-08-12','11:05:00',5.55),('11288','2013-08-12','11:10:00',5.67),('11288','2013-08-12','11:15:00',5.7),('11288','2013-08-12','11:20:00',5.76),('11288','2013-08-12','11:25:00',5.77),('11288','2013-08-12','11:30:00',5.85),('11288','2013-08-12','11:35:00',5.92),('11288','2013-08-12','11:40:00',5.92),('11288','2013-08-12','11:45:00',6.03),('11288','2013-08-12','11:50:00',6.2),('11288','2013-08-12','11:55:00',6.24),('11288','2013-08-12','12:00:00',6.31),('11288','2013-08-12','12:05:00',6.25),('11288','2013-08-12','12:10:00',5.79),('11288','2013-08-12','12:15:00',3.12),('11288','2013-08-12','12:20:00',4.59),('11288','2013-08-12','12:25:00',6.25),('11288','2013-08-12','12:30:00',4.61),('11288','2013-08-12','12:35:00',6.75),('11288','2013-08-12','12:40:00',4.35),('11288','2013-08-12','12:45:00',2.28),('11288','2013-08-12','12:50:00',2.63),('11288','2013-08-12','12:55:00',2.24),('11288','2013-08-12','13:00:00',1.38),('11288','2013-08-12','13:05:00',1.28),('11288','2013-08-12','13:10:00',1.48),('11288','2013-08-12','13:15:00',1.87),('11288','2013-08-12','13:20:00',2.19),('11288','2013-08-12','13:25:00',2.52),('11288','2013-08-12','13:30:00',2.22),('11288','2013-08-12','13:35:00',2.3),('11288','2013-08-12','13:40:00',2.03),('11288','2013-08-12','13:45:00',3.04),('11288','2013-08-12','13:50:00',7.45),('11288','2013-08-12','13:55:00',5.55),('11288','2013-08-12','14:00:00',4.68),('11288','2013-08-12','14:05:00',4.26),('11288','2013-08-12','14:10:00',1.93),('11288','2013-08-12','14:15:00',1.77),('11288','2013-08-12','14:20:00',1.55),('11288','2013-08-12','14:25:00',1.38),('11288','2013-08-12','14:30:00',1.67),('11288','2013-08-12','14:35:00',2.07),('11288','2013-08-12','14:40:00',2.16),('11288','2013-08-12','14:45:00',3.11),('11288','2013-08-12','14:50:00',5.52),('11288','2013-08-12','14:55:00',6.98),('11288','2013-08-12','15:00:00',6.78),('11288','2013-08-12','15:05:00',5.26),('11288','2013-08-12','15:10:00',5.28),('11288','2013-08-12','15:15:00',5.57),('11288','2013-08-12','15:20:00',4.84),('11288','2013-08-12','15:25:00',5.9),('11288','2013-08-12','15:30:00',5.67),('11288','2013-08-12','15:35:00',5.53),('11288','2013-08-12','15:40:00',5.48),('11288','2013-08-12','15:45:00',5.45),('11288','2013-08-12','15:50:00',5.38),('11288','2013-08-12','15:55:00',5.24),('11288','2013-08-12','16:00:00',5.15),('11288','2013-08-12','16:05:00',4.99),('11288','2013-08-12','16:10:00',4.9),('11288','2013-08-12','16:15:00',4.75),('11288','2013-08-12','16:20:00',4.72),('11288','2013-08-12','16:25:00',4.68),('11288','2013-08-12','16:30:00',4.43),('11288','2013-08-12','16:35:00',4.38),('11288','2013-08-12','16:40:00',4.18),('11288','2013-08-12','16:45:00',4.1),('11288','2013-08-12','16:50:00',3.92),('11288','2013-08-12','16:55:00',3.99),('11288','2013-08-12','17:00:00',3.83),('11288','2013-08-12','17:05:00',3.69),('11288','2013-08-12','17:10:00',3.5),('11288','2013-08-12','17:15:00',3.39),('11288','2013-08-12','17:20:00',3.26),('11288','2013-08-12','17:25:00',3.15),('11288','2013-08-12','17:30:00',3),('11288','2013-08-12','17:35:00',2.81),('11288','2013-08-12','17:40:00',2.6),('11288','2013-08-12','17:45:00',2.52),('11288','2013-08-12','17:50:00',2.47),('11288','2013-08-12','17:55:00',2.37),('11288','2013-08-12','18:00:00',2.21),('11288','2013-08-12','18:05:00',2.07),('11288','2013-08-12','18:10:00',1.95),('11288','2013-08-12','18:15:00',1.83),('11288','2013-08-12','18:20:00',1.74),('11288','2013-08-12','18:25:00',1.72),('11288','2013-08-12','18:30:00',1.64),('11288','2013-08-12','18:35:00',1.48),('11288','2013-08-12','18:40:00',1.36),('11288','2013-08-12','18:45:00',1.22),('11288','2013-08-12','18:50:00',1.11),('11288','2013-08-11','07:45:00',1.06),('11288','2013-08-11','07:50:00',1.15),('11288','2013-08-11','07:55:00',1.25),('11288','2013-08-11','08:00:00',1.37),('11288','2013-08-11','08:05:00',1.43),('11288','2013-08-11','08:10:00',1.53),('11288','2013-08-11','08:15:00',1.77),('11288','2013-08-11','08:20:00',1.87),('11288','2013-08-11','08:25:00',1.99),('11288','2013-08-11','08:30:00',2.07),('11288','2013-08-11','08:35:00',2.17),('11288','2013-08-11','08:40:00',2.3),('11288','2013-08-11','08:45:00',2.48),('11288','2013-08-11','08:50:00',2.57),('11288','2013-08-11','08:55:00',2.63),('11288','2013-08-11','09:00:00',2.8),('11288','2013-08-11','09:05:00',2.98),('11288','2013-08-11','09:10:00',3.17),('11288','2013-08-11','09:15:00',3.45),('11288','2013-08-11','09:20:00',3.52),('11288','2013-08-11','09:25:00',3.68),('11288','2013-08-11','09:30:00',3.86),('11288','2013-08-11','09:35:00',3.91),('11288','2013-08-11','09:40:00',4.09),('11288','2013-08-11','09:45:00',4.18),('11288','2013-08-11','09:50:00',4.28),('11288','2013-08-11','09:55:00',4.42),('11288','2013-08-11','10:00:00',4.58),('11288','2013-08-11','10:05:00',4.65),('11288','2013-08-11','10:10:00',4.77),('11288','2013-08-11','10:15:00',4.86),('11288','2013-08-11','10:20:00',4.97),('11288','2013-08-11','10:25:00',5.11),('11288','2013-08-11','10:30:00',5.22),('11288','2013-08-11','10:35:00',5.29),('11288','2013-08-11','10:40:00',5.34),('11288','2013-08-11','10:45:00',5.43),('11288','2013-08-11','10:50:00',5.49),('11288','2013-08-11','10:55:00',5.64),('11288','2013-08-11','11:00:00',5.7),('11288','2013-08-11','11:05:00',5.8),('11288','2013-08-11','11:10:00',5.84),('11288','2013-08-11','11:15:00',5.89),('11288','2013-08-11','11:20:00',5.91),('11288','2013-08-11','11:25:00',5.95),('11288','2013-08-11','11:30:00',6.05),('11288','2013-08-11','11:35:00',6.1),('11288','2013-08-11','11:40:00',6.14),('11288','2013-08-11','11:45:00',6.17),('11288','2013-08-11','11:50:00',6.14),('11288','2013-08-11','11:55:00',6.23),('11288','2013-08-11','12:00:00',6.33),('11288','2013-08-11','12:05:00',6.33),('11288','2013-08-11','12:10:00',6.35),('11288','2013-08-11','12:15:00',6.38),('11288','2013-08-11','12:20:00',6.39),('11288','2013-08-11','12:25:00',6.39),('11288','2013-08-11','12:30:00',6.42),('11288','2013-08-11','12:35:00',6.48),('11288','2013-08-11','12:40:00',6.47),('11288','2013-08-11','12:45:00',6.48),('11288','2013-08-11','12:50:00',6.45),('11288','2013-08-11','12:55:00',6.41),('11288','2013-08-11','13:00:00',6.43),('11288','2013-08-11','13:05:00',6.4),('11288','2013-08-11','13:10:00',6.42),('11288','2013-08-11','13:15:00',6.41),('11288','2013-08-11','13:20:00',6.34),('11288','2013-08-11','13:25:00',6.36),('11288','2013-08-11','13:30:00',6.39),('11288','2013-08-11','13:35:00',6.41),('11288','2013-08-11','13:40:00',6.39),('11288','2013-08-11','13:45:00',6.41),('11288','2013-08-11','13:50:00',6.31),('11288','2013-08-11','13:55:00',6.23),('11288','2013-08-11','14:00:00',6.25),('11288','2013-08-11','14:05:00',6.23),('11288','2013-08-11','14:10:00',6.2),('11288','2013-08-11','14:15:00',6.17),('11288','2013-08-11','14:20:00',6.1),('11288','2013-08-11','14:25:00',6.13),('11288','2013-08-11','14:30:00',6.04),('11288','2013-08-11','14:35:00',5.98),('11288','2013-08-11','14:40:00',6),('11288','2013-08-11','14:45:00',5.98),('11288','2013-08-11','14:50:00',5.99),('11288','2013-08-11','14:55:00',5.83),('11288','2013-08-11','15:00:00',5.42),('11288','2013-08-11','15:05:00',5.08),('11288','2013-08-11','15:10:00',5.64),('11288','2013-08-11','15:15:00',5.61),('11288','2013-08-11','15:20:00',5.59),('11288','2013-08-11','15:25:00',4.34),('11288','2013-08-11','15:30:00',4.03),('11288','2013-08-11','15:35:00',5.4),('11288','2013-08-11','15:40:00',5.4),('11288','2013-08-11','15:45:00',5.34),('11288','2013-08-11','15:50:00',5.22),('11288','2013-08-11','15:55:00',5.19),('11288','2013-08-11','16:00:00',5.13),('11288','2013-08-11','16:05:00',5.05),('11288','2013-08-11','16:10:00',4.92),('11288','2013-08-11','16:15:00',4.83),('11288','2013-08-11','16:20:00',4.73),('11288','2013-08-11','16:25:00',4.64),('11288','2013-08-11','16:30:00',4.49),('11288','2013-08-11','16:35:00',4.41),('11288','2013-08-11','16:40:00',4.28),('11288','2013-08-11','16:45:00',4.17),('11288','2013-08-11','16:50:00',4.04),('11288','2013-08-11','16:55:00',3.92),('11288','2013-08-11','17:00:00',3.78),('11288','2013-08-11','17:05:00',3.69),('11288','2013-08-11','17:10:00',3.54),('11288','2013-08-11','17:15:00',3.45),('11288','2013-08-11','17:20:00',3.32),('11288','2013-08-11','17:25:00',3.17),('11288','2013-08-11','17:30:00',3.03),('11288','2013-08-11','17:35:00',2.9),('11288','2013-08-11','17:40:00',2.78),('11288','2013-08-11','17:45:00',2.65),('11288','2013-08-11','17:50:00',2.51),('11288','2013-08-11','17:55:00',2.36),('11288','2013-08-11','18:00:00',2.2),('11288','2013-08-11','18:05:00',2.07),('11288','2013-08-11','18:10:00',1.87),('11288','2013-08-11','18:15:00',1.79),('11288','2013-08-11','18:20:00',1.71),('11288','2013-08-11','18:25:00',1.69),('11288','2013-08-11','18:30:00',1.59),('11288','2013-08-11','18:35:00',1.45),('11288','2013-08-11','18:40:00',1.3),('11288','2013-08-11','18:45:00',1.19),('11288','2013-08-11','18:50:00',1.05),('11288','2013-08-10','07:45:00',1.06),('11288','2013-08-10','07:50:00',1.17),('11288','2013-08-10','07:55:00',1.31),('11288','2013-08-10','08:00:00',1.38),('11288','2013-08-10','08:05:00',1.44),('11288','2013-08-10','08:10:00',1.44),('11288','2013-08-10','08:15:00',1.78),('11288','2013-08-10','08:20:00',1.84),('11288','2013-08-10','08:25:00',1.95),('11288','2013-08-10','08:30:00',2.14),('11288','2013-08-10','08:35:00',2.19),('11288','2013-08-10','08:40:00',2.28),('11288','2013-08-10','08:45:00',2.59),('11288','2013-08-10','08:50:00',2.68),('11288','2013-08-10','08:55:00',2.73),('11288','2013-08-10','09:00:00',2.95),('11288','2013-08-10','09:05:00',3.09),('11288','2013-08-10','09:10:00',3.31),('11288','2013-08-10','09:15:00',3.53),('11288','2013-08-10','09:20:00',3.65),('11288','2013-08-10','09:25:00',3.65),('11288','2013-08-10','09:30:00',3.9),('11288','2013-08-10','09:35:00',3.92),('11288','2013-08-10','09:40:00',4.07),('11288','2013-08-10','09:45:00',4.25),('11288','2013-08-10','09:50:00',4.32),('11288','2013-08-10','09:55:00',4.39),('11288','2013-08-10','10:00:00',4.58),('11288','2013-08-10','10:05:00',4.71),('11288','2013-08-10','10:10:00',4.08),('11288','2013-08-10','10:20:00',3.5),('11288','2013-08-10','10:25:00',4.71),('11288','2013-08-10','10:30:00',4.85),('11288','2013-08-10','10:35:00',5.26),('11288','2013-08-10','10:40:00',3.91),('11288','2013-08-10','10:45:00',5.4),('11288','2013-08-10','10:50:00',5.41),('11288','2013-08-10','10:55:00',5.64),('11288','2013-08-10','11:00:00',3.98),('11288','2013-08-10','11:05:00',5.85),('11288','2013-08-10','11:10:00',6.1),('11288','2013-08-10','11:15:00',5.96),('11288','2013-08-10','11:20:00',4.7),('11288','2013-08-10','11:25:00',4.72),('11288','2013-08-10','11:30:00',6.28),('11288','2013-08-10','11:35:00',5.83),('11288','2013-08-10','11:40:00',5.55),('11288','2013-08-10','11:45:00',4.63),('11288','2013-08-10','11:50:00',6.19),('11288','2013-08-10','11:55:00',6.24),('11288','2013-08-10','12:00:00',6.31),('11288','2013-08-10','12:05:00',6.36),('11288','2013-08-10','12:10:00',6.41),('11288','2013-08-10','12:15:00',6.4),('11288','2013-08-10','12:20:00',6.42),('11288','2013-08-10','12:25:00',6.44),('11288','2013-08-10','12:30:00',6.48),('11288','2013-08-10','12:35:00',6.49),('11288','2013-08-10','12:40:00',6.53),('11288','2013-08-10','12:45:00',6.64),('11288','2013-08-10','12:50:00',6.8),('11288','2013-08-10','12:55:00',6.71),('11288','2013-08-10','13:00:00',6.7),('11288','2013-08-10','13:05:00',6.56),('11288','2013-08-10','13:10:00',6.68),('11288','2013-08-10','13:15:00',6.83),('11288','2013-08-10','13:20:00',6.65),('11288','2013-08-10','13:25:00',7.03),('11288','2013-08-10','13:30:00',7.2),('11288','2013-08-10','13:35:00',6.14),('11288','2013-08-10','13:40:00',2.45),('11288','2013-08-10','13:45:00',1.1),('11288','2013-08-10','13:50:00',2.22),('11288','2013-08-10','13:55:00',6.27),('11288','2013-08-10','14:00:00',7.18),('11288','2013-08-10','14:05:00',7.48),('11288','2013-08-10','14:10:00',5.34),('11288','2013-08-10','14:15:00',5.15),('11288','2013-08-10','14:20:00',3.75),('11288','2013-08-10','14:25:00',2.26),('11288','2013-08-10','14:30:00',2.11),('11288','2013-08-10','14:35:00',1.87),('11288','2013-08-10','14:40:00',1.73),('11288','2013-08-10','14:45:00',1.69),('11288','2013-08-10','14:50:00',1.57),('11288','2013-08-10','14:55:00',1.58),('11288','2013-08-10','15:00:00',1.78),('11288','2013-08-10','15:05:00',1.86),('11288','2013-08-10','15:10:00',1.97),('11288','2013-08-10','15:15:00',2.14),('11288','2013-08-10','15:20:00',2.14),('11288','2013-08-10','15:25:00',1.92),('11288','2013-08-10','15:30:00',1.88),('11288','2013-08-10','15:35:00',2.33),('11288','2013-08-10','15:40:00',2.25),('11288','2013-08-10','15:45:00',2.57),('11288','2013-08-10','15:50:00',3.47),('11288','2013-08-10','15:55:00',4.11),('11288','2013-08-10','16:00:00',3.9),('11288','2013-08-10','16:05:00',7.25),('11288','2013-08-10','16:10:00',3.97),('11288','2013-08-10','16:15:00',3.68),('11288','2013-08-10','16:20:00',4.17),('11288','2013-08-10','16:25:00',1.93),('11288','2013-08-10','16:30:00',3.54),('11288','2013-08-10','16:35:00',3.79),('11288','2013-08-10','16:40:00',4.23),('11288','2013-08-10','16:45:00',4.76),('11288','2013-08-10','16:50:00',4.44),('11288','2013-08-10','16:55:00',4.14),('11288','2013-08-10','17:00:00',2.86),('11288','2013-08-10','17:05:00',2.68),('11288','2013-08-10','17:10:00',1.65),('11288','2013-08-10','17:15:00',1.95),('11288','2013-08-10','17:20:00',2.15),('11288','2013-08-10','17:25:00',2.68),('11288','2013-08-10','17:30:00',1.97),('11288','2013-08-10','17:55:00',1.33),('11288','2013-08-10','18:00:00',1.1),('11288','2014-04-09','08:00:00',1.35),('11288','2014-04-09','08:05:00',1.57),('11288','2014-04-09','08:10:00',1.42),('11288','2014-04-09','08:15:00',1.34),('11288','2014-04-09','08:20:00',1.55),('11288','2014-04-09','08:25:00',1.29),('11288','2014-04-09','08:30:00',1.51),('11288','2014-04-09','08:50:00',1.03),('11288','2014-04-09','08:55:00',1.61),('11288','2014-04-09','09:00:00',1.69),('11288','2014-04-09','09:05:00',1.54),('11288','2014-04-09','09:10:00',1.54),('11288','2014-04-09','09:15:00',1.52),('11288','2014-04-09','09:20:00',1.53),('11288','2014-04-09','09:25:00',1.7),('11288','2014-04-09','09:30:00',1.73),('11288','2014-04-09','09:35:00',1.48),('11288','2014-04-09','09:40:00',1.34),('11288','2014-04-09','09:45:00',1.39),('11288','2014-04-09','09:50:00',3.5),('11288','2014-04-09','09:55:00',4.27),('11288','2014-04-09','10:00:00',4.44),('11288','2014-04-09','10:05:00',4.48),('11288','2014-04-09','10:10:00',4.64),('11288','2014-04-09','10:15:00',4.12),('11288','2014-04-09','10:20:00',5.14),('11288','2014-04-09','10:25:00',5.55),('11288','2014-04-09','10:30:00',5.8),('11288','2014-04-09','10:35:00',3.46),('11288','2014-04-09','10:40:00',2.15),('11288','2014-04-09','10:45:00',3.17),('11288','2014-04-09','10:50:00',2.12),('11288','2014-04-09','10:55:00',6.1),('11288','2014-04-09','11:00:00',6.5),('11288','2014-04-09','11:05:00',6.58),('11288','2014-04-09','11:10:00',6.68),('11288','2014-04-09','11:15:00',6.9),('11288','2014-04-09','11:20:00',6.23),('11288','2014-04-09','11:25:00',5.19),('11288','2014-04-09','11:30:00',4.53),('11288','2014-04-09','11:35:00',6.87),('11288','2014-04-09','11:40:00',6.99),('11288','2014-04-09','11:45:00',5.72),('11288','2014-04-09','11:50:00',7.06),('11288','2014-04-09','11:55:00',6.99),('11288','2014-04-09','12:00:00',7.31),('11288','2014-04-09','12:05:00',5.49),('11288','2014-04-09','12:10:00',5.86),('11288','2014-04-09','12:15:00',2.95),('11288','2014-04-09','12:20:00',3.96),('11288','2014-04-09','12:25:00',1.98),('11288','2014-04-09','12:30:00',1.67),('11288','2014-04-09','12:35:00',1.61),('11288','2014-04-09','12:40:00',1.54),('11288','2014-04-09','12:45:00',1.16),('11288','2014-04-09','12:50:00',1.04),('11288','2014-04-09','13:10:00',1.13),('11288','2014-04-09','13:15:00',1.83),('11288','2014-04-09','13:20:00',2.3),('11288','2014-04-09','13:25:00',2.23),('11288','2014-04-09','13:30:00',1.86),('11288','2014-04-09','13:35:00',1.87),('11288','2014-04-09','13:40:00',1.59),('11288','2014-04-09','13:45:00',1.48),('11288','2014-04-09','13:50:00',1.49),('11288','2014-04-09','13:55:00',1.5),('11288','2014-04-09','14:00:00',1.91),('11288','2014-04-09','14:05:00',2.45),('11288','2014-04-09','14:10:00',2.54),('11288','2014-04-09','14:15:00',2.43),('11288','2014-04-09','14:20:00',2.16),('11288','2014-04-09','14:25:00',2.26),('11288','2014-04-09','14:30:00',2.47),('11288','2014-04-09','14:35:00',2.46),('11288','2014-04-09','14:40:00',3.39),('11288','2014-04-09','14:45:00',3.51),('11288','2014-04-09','14:50:00',3.64),('11288','2014-04-09','14:55:00',3.4),('11288','2014-04-09','15:00:00',2.95),('11288','2014-04-09','15:05:00',3.16),('11288','2014-04-09','15:10:00',6.66),('11288','2014-04-09','15:15:00',6.53),('11288','2014-04-09','15:20:00',5.13),('11288','2014-04-09','15:25:00',4.8),('11288','2014-04-09','15:30:00',4.19),('11288','2014-04-09','15:35:00',3.44),('11288','2014-04-09','15:40:00',3.02),('11288','2014-04-09','15:45:00',2.63),('11288','2014-04-09','15:50:00',2.24),('11288','2014-04-09','15:55:00',2.09),('11288','2014-04-09','16:00:00',2.82),('11288','2014-04-09','16:05:00',3.9),('11288','2014-04-09','16:10:00',3.96),('11288','2014-04-09','16:15:00',4.91),('11288','2014-04-09','16:20:00',4.67),('11288','2014-04-09','16:25:00',4.54),('11288','2014-04-09','16:30:00',5.08),('11288','2014-04-09','16:35:00',5.27),('11288','2014-04-09','16:40:00',4.29),('11288','2014-04-09','16:45:00',4.78),('11288','2014-04-09','16:50:00',3.48),('11288','2014-04-09','16:55:00',3.51),('11288','2014-04-09','17:00:00',3.72),('11288','2014-04-09','17:05:00',4.22),('11288','2014-04-09','17:10:00',3.39),('11288','2014-04-09','17:15:00',3),('11288','2014-04-09','17:20:00',2.92),('11288','2014-04-09','17:25:00',2.81),('11288','2014-04-09','17:30:00',2.43),('11288','2014-04-09','17:35:00',1.24),('11288','2014-04-09','17:40:00',1.26),('11288','2014-04-09','17:45:00',2.01),('11288','2014-04-09','17:50:00',2.07),('11288','2014-04-09','17:55:00',1.97),('11288','2014-04-09','18:00:00',1.72),('11288','2014-04-09','18:05:00',1.1),('11288','2014-04-09','18:10:00',1.39),('11288','2014-04-09','18:15:00',1.05),('11288','2013-08-09','08:00:00',1.46),('11288','2013-08-09','08:05:00',1.64),('11288','2013-08-09','08:10:00',1.44),('11288','2013-08-09','08:15:00',1.42),('11288','2013-08-09','08:20:00',1.45),('11288','2013-08-09','08:25:00',1.28),('11288','2013-08-09','08:30:00',1.32),('11288','2013-08-09','08:35:00',1.83),('11288','2013-08-09','08:40:00',2.49),('11288','2013-08-09','08:45:00',2.58),('11288','2013-08-09','08:50:00',2.64),('11288','2013-08-09','08:55:00',2.77),('11288','2013-08-09','09:00:00',2.73),('11288','2013-08-09','09:05:00',2.9),('11288','2013-08-09','09:10:00',3.4),('11288','2013-08-09','09:15:00',3.57),('11288','2013-08-09','09:20:00',2.49),('11288','2013-08-09','09:25:00',2.57),('11288','2013-08-09','09:30:00',3.03),('11288','2013-08-09','09:35:00',4.45),('11288','2013-08-09','09:40:00',4.13),('11288','2013-08-09','09:45:00',4),('11288','2013-08-09','09:50:00',3.05),('11288','2013-08-09','09:55:00',2.62),('11288','2013-08-09','10:00:00',3),('11288','2013-08-09','10:05:00',3.26),('11288','2013-08-09','10:10:00',4.08),('11288','2013-08-09','10:15:00',4.4),('11288','2013-08-09','10:20:00',4.37),('11288','2013-08-09','10:25:00',4.4),('11288','2013-08-09','10:30:00',4.52),('11288','2013-08-09','10:35:00',4.29),('11288','2013-08-09','10:40:00',4.14),('11288','2013-08-09','10:45:00',5),('11288','2013-08-09','10:50:00',4.97),('11288','2013-08-09','10:55:00',5.13),('11288','2013-08-09','11:00:00',5.32),('11288','2013-08-09','11:05:00',5.33),('11288','2013-08-09','11:10:00',5.29),('11288','2013-08-09','11:15:00',5.45),('11288','2013-08-09','11:20:00',5.52),('11288','2013-08-09','11:25:00',5.55),('11288','2013-08-09','11:30:00',5.57),('11288','2013-08-09','11:35:00',5.54),('11288','2013-08-09','11:40:00',5.64),('11288','2013-08-09','11:45:00',5.7),('11288','2013-08-09','11:50:00',5.72),('11288','2013-08-09','11:55:00',5.73),('11288','2013-08-09','12:00:00',5.76),('11288','2013-08-09','12:05:00',5.89),('11288','2013-08-09','12:10:00',5.84),('11288','2013-08-09','12:15:00',5.95),('11288','2013-08-09','12:20:00',6.16),('11288','2013-08-09','12:25:00',4.45),('11288','2013-08-09','12:30:00',4.29),('11288','2013-08-09','12:35:00',4.67),('11288','2013-08-09','12:40:00',6.11),('11288','2013-08-09','12:45:00',5.21),('11288','2013-08-09','12:50:00',3.96),('11288','2013-08-09','12:55:00',4.53),('11288','2013-08-09','13:00:00',1.93),('11288','2013-08-09','13:05:00',1.51),('11288','2013-08-09','13:10:00',1.47),('11288','2013-08-09','13:15:00',2.09),('11288','2013-08-09','13:20:00',2.73),('11288','2013-08-09','13:25:00',3.7),('11288','2013-08-09','13:30:00',3.03),('11288','2013-08-09','13:35:00',2.59),('11288','2013-08-09','13:40:00',2.51),('11288','2013-08-09','13:45:00',2.44),('11288','2013-08-09','13:50:00',2.56),('11288','2013-08-09','13:55:00',2.27),('11288','2013-08-09','14:00:00',2.27),('11288','2013-08-09','14:05:00',2.18),('11288','2013-08-09','14:10:00',2.63),('11288','2013-08-09','14:15:00',1.72),('11288','2013-08-09','14:20:00',1.58),('11288','2013-08-09','14:25:00',1.76),('11288','2013-08-09','14:30:00',1.75),('11288','2013-08-09','14:35:00',1.44),('11288','2013-08-09','14:40:00',1.06),('11288','2013-08-09','15:05:00',2.37),('11288','2013-08-09','15:10:00',4.79),('11288','2013-08-09','15:15:00',4.31),('11288','2013-08-09','15:20:00',2.69),('11288','2013-08-09','15:25:00',2.14),('11288','2013-08-09','15:30:00',2.18),('11288','2013-08-09','15:35:00',3.8),('11288','2013-08-09','15:40:00',2.79),('11288','2013-08-09','15:45:00',4.65),('11288','2013-08-09','15:50:00',3.59),('11288','2013-08-09','15:55:00',3.12),('11288','2013-08-09','16:00:00',2.02),('11288','2013-08-09','16:05:00',1.29),('11288','2013-08-09','16:10:00',1.14),('11288','2013-08-09','16:15:00',1.22),('11288','2013-08-09','16:20:00',1.29),('11288','2013-08-09','16:25:00',1.42),('11288','2013-08-09','16:30:00',1.07),('11288','2013-08-09','16:35:00',1.12),('11288','2013-08-09','16:40:00',1.25),('11288','2013-08-09','16:45:00',1.55),('11288','2013-08-09','16:50:00',2.8),('11288','2013-08-09','16:55:00',3.62),('11288','2013-08-09','17:00:00',2.7),('11288','2013-08-09','17:05:00',2.62),('11288','2013-08-09','17:10:00',1.61),('11288','2013-08-09','17:15:00',1.25),('11288','2013-08-09','17:20:00',1.14),('11288','2013-08-09','17:25:00',1.25),('11288','2013-08-09','17:30:00',1.48),('11288','2013-08-09','17:35:00',1.52),('11288','2013-08-09','17:40:00',1.46),('11288','2013-08-09','17:45:00',1.37),('11288','2013-08-09','17:50:00',1.07),('11288','2013-08-09','19:00:00',1.2),('11288','2013-08-09','19:05:00',1.51),('11288','2013-08-09','19:10:00',1.57),('11288','2013-08-09','19:15:00',1.59),('11288','2013-08-09','19:20:00',1.82),('11288','2013-08-09','19:25:00',1.76),('11288','2013-08-08','07:45:00',1.07),('11288','2013-08-08','07:50:00',1.18),('11288','2013-08-08','07:55:00',1.25),('11288','2013-08-08','08:00:00',1.31),('11288','2013-08-08','08:05:00',1.45),('11288','2013-08-08','08:10:00',1.52),('11288','2013-08-08','08:15:00',1.64),('11288','2013-08-08','08:20:00',1.82),('11288','2013-08-08','08:25:00',1.93),('11288','2013-08-08','08:30:00',1.93),('11288','2013-08-08','08:35:00',2.02),('11288','2013-08-08','08:40:00',2.33),('11288','2013-08-08','08:45:00',2.33),('11288','2013-08-08','08:50:00',2.46),('11288','2013-08-08','08:55:00',2.6),('11288','2013-08-08','09:00:00',2.61),('11288','2013-08-08','09:05:00',2.75),('11288','2013-08-08','09:10:00',3.06),('11288','2013-08-08','09:15:00',3.19),('11288','2013-08-08','09:20:00',3.34),('11288','2013-08-08','09:25:00',3.54),('11288','2013-08-08','09:30:00',3.54),('11288','2013-08-08','09:35:00',3.7),('11288','2013-08-08','09:40:00',3.85),('11288','2013-08-08','09:45:00',3.89),('11288','2013-08-08','09:50:00',4.03),('11288','2013-08-08','09:55:00',4.13),('11288','2013-08-08','10:00:00',4.15),('11288','2013-08-08','10:05:00',4.32),('11288','2013-08-08','10:10:00',4.5),('11288','2013-08-08','10:15:00',4.57),('11288','2013-08-08','10:20:00',4.66),('11288','2013-08-08','10:25:00',4.72),('11288','2013-08-08','10:30:00',4.81),('11288','2013-08-08','10:35:00',4.87),('11288','2013-08-08','10:40:00',4.98),('11288','2013-08-08','10:45:00',5.05),('11288','2013-08-08','10:50:00',5.11),('11288','2013-08-08','10:55:00',5.2),('11288','2013-08-08','11:00:00',5.26),('11288','2013-08-08','11:05:00',5.3),('11288','2013-08-08','11:10:00',5.39),('11288','2013-08-08','11:15:00',5.4),('11288','2013-08-08','11:20:00',5.45),('11288','2013-08-08','11:25:00',5.52),('11288','2013-08-08','11:30:00',5.56),('11288','2013-08-08','11:35:00',5.55),('11288','2013-08-08','11:40:00',5.57),('11288','2013-08-08','11:45:00',5.61),('11288','2013-08-08','11:50:00',5.73),('11288','2013-08-08','11:55:00',5.75),('11288','2013-08-08','12:00:00',5.73),('11288','2013-08-08','12:05:00',5.8),('11288','2013-08-08','12:10:00',5.85),('11288','2013-08-08','12:15:00',5.82),('11288','2013-08-08','12:20:00',5.89),('11288','2013-08-08','12:25:00',5.89),('11288','2013-08-08','12:30:00',5.81),('11288','2013-08-08','12:35:00',6.02),('11288','2013-08-08','12:40:00',6.06),('11288','2013-08-08','12:45:00',6.07),('11288','2013-08-08','12:50:00',6.08),('11288','2013-08-08','12:55:00',6.06),('11288','2013-08-08','13:00:00',6.06),('11288','2013-08-08','13:05:00',6.13),('11288','2013-08-08','13:10:00',6.08),('11288','2013-08-08','13:15:00',6.15),('11288','2013-08-08','13:20:00',6.14),('11288','2013-08-08','13:25:00',6.08),('11288','2013-08-08','13:30:00',6.1),('11288','2013-08-08','13:35:00',6.06),('11288','2013-08-08','13:40:00',6.05),('11288','2013-08-08','13:45:00',6.07),('11288','2013-08-08','13:50:00',6.02),('11288','2013-08-08','13:55:00',6.03),('11288','2013-08-08','14:00:00',6.01),('11288','2013-08-08','14:05:00',5.98),('11288','2013-08-08','14:10:00',5.93),('11288','2013-08-08','14:15:00',5.89),('11288','2013-08-08','14:20:00',5.89),('11288','2013-08-08','14:25:00',5.87),('11288','2013-08-08','14:30:00',5.81),('11288','2013-08-08','14:35:00',5.75),('11288','2013-08-08','14:40:00',5.7),('11288','2013-08-08','14:45:00',5.7),('11288','2013-08-08','14:50:00',5.67),('11288','2013-08-08','14:55:00',5.64),('11288','2013-08-08','15:00:00',5.6),('11288','2013-08-08','15:05:00',5.54),('11288','2013-08-08','15:10:00',5.45),('11288','2013-08-08','15:15:00',5.35),('11288','2013-08-08','15:20:00',5.29),('11288','2013-08-08','15:25:00',5.21),('11288','2013-08-08','15:30:00',5.19),('11288','2013-08-08','15:35:00',5.14),('11288','2013-08-08','15:40:00',5.1),('11288','2013-08-08','15:45:00',5),('11288','2013-08-08','15:50:00',4.93),('11288','2013-08-08','15:55:00',4.84),('11288','2013-08-08','16:00:00',4.84),('11288','2013-08-08','16:05:00',4.76),('11288','2013-08-08','16:10:00',4.64),('11288','2013-08-08','16:15:00',4.59),('11288','2013-08-08','16:20:00',4.53),('11288','2013-08-08','16:25:00',4.42),('11288','2013-08-08','16:30:00',4.37),('11288','2013-08-08','16:35:00',4.24),('11288','2013-08-08','16:40:00',4.12),('11288','2013-08-08','16:45:00',4),('11288','2013-08-08','16:50:00',3.84),('11288','2013-08-08','16:55:00',3.74),('11288','2013-08-08','17:00:00',3.64),('11288','2013-08-08','17:05:00',3.5),('11288','2013-08-08','17:10:00',3.39),('11288','2013-08-08','17:15:00',3.25),('11288','2013-08-08','17:20:00',3.13),('11288','2013-08-08','17:25:00',3),('11288','2013-08-08','17:30:00',2.87),('11288','2013-08-08','17:35:00',2.72),('11288','2013-08-08','17:40:00',2.61),('11288','2013-08-08','17:45:00',2.51),('11288','2013-08-08','17:50:00',2.39),('11288','2013-08-08','17:55:00',2.25),('11288','2013-08-08','18:00:00',2.13),('11288','2013-08-08','18:05:00',2.01),('11288','2013-08-08','18:10:00',1.88),('11288','2013-08-08','18:15:00',1.81),('11288','2013-08-08','18:20:00',1.74),('11288','2013-08-08','18:25:00',1.64),('11288','2013-08-08','18:30:00',1.49),('11288','2013-08-08','18:35:00',1.37),('11288','2013-08-08','18:40:00',1.27),('11288','2013-08-08','18:45:00',1.17),('11288','2013-08-08','18:50:00',1.05),('11288','2013-08-07','07:40:00',1.05),('11288','2013-08-07','07:45:00',1.12),('11288','2013-08-07','07:50:00',1.22),('11288','2013-08-07','07:55:00',1.29),('11288','2013-08-07','08:00:00',1.36),('11288','2013-08-07','08:05:00',1.49),('11288','2013-08-07','08:10:00',1.53),('11288','2013-08-07','08:15:00',1.69),('11288','2013-08-07','08:20:00',1.85),('11288','2013-08-07','08:25:00',1.95),('11288','2013-08-07','08:30:00',1.98),('11288','2013-08-07','08:35:00',2.18),('11288','2013-08-07','08:40:00',2.39),('11288','2013-08-07','08:45:00',2.37),('11288','2013-08-07','08:50:00',2.52),('11288','2013-08-07','08:55:00',2.59),('11288','2013-08-07','09:00:00',2.62),('11288','2013-08-07','09:05:00',2.85),('11288','2013-08-07','09:10:00',3.1),('11288','2013-08-07','09:15:00',3.21),('11288','2013-08-07','09:20:00',3.4),('11288','2013-08-07','09:25:00',3.57),('11288','2013-08-07','09:30:00',3.64),('11288','2013-08-07','09:35:00',3.74),('11288','2013-08-07','09:40:00',3.9),('11288','2013-08-07','09:45:00',3.92),('11288','2013-08-07','09:50:00',4.13),('11288','2013-08-07','09:55:00',4.25),('11288','2013-08-07','10:00:00',4.21),('11288','2013-08-07','10:05:00',4.4),('11288','2013-08-07','10:10:00',4.6),('11288','2013-08-07','10:15:00',4.64),('11288','2013-08-07','10:20:00',4.7),('11288','2013-08-07','10:25:00',4.75),('11288','2013-08-07','10:30:00',4.9),('11288','2013-08-07','10:35:00',4.93),('11288','2013-08-07','10:40:00',5.03),('11288','2013-08-07','10:45:00',5.12),('11288','2013-08-07','10:50:00',5.19),('11288','2013-08-07','10:55:00',5.27),('11288','2013-08-07','11:00:00',5.32),('11288','2013-08-07','11:05:00',5.37),('11288','2013-08-07','11:10:00',5.47),('11288','2013-08-07','11:15:00',5.53),('11288','2013-08-07','11:20:00',5.59),('11288','2013-08-07','11:25:00',5.59),('11288','2013-08-07','11:30:00',5.63),('11288','2013-08-07','11:35:00',5.66),('11288','2013-08-07','11:40:00',5.67),('11288','2013-08-07','11:45:00',5.72),('11288','2013-08-07','11:50:00',5.78),('11288','2013-08-07','11:55:00',5.79),('11288','2013-08-07','12:00:00',5.85),('11288','2013-08-07','12:05:00',5.88),('11288','2013-08-07','12:10:00',5.87),('11288','2013-08-07','12:15:00',5.84),('11288','2013-08-07','12:20:00',5.82),('11288','2013-08-07','12:25:00',5.83),('11288','2013-08-07','12:30:00',5.88),('11288','2013-08-07','12:35:00',5.97),('11288','2013-08-07','12:40:00',5.95),('11288','2013-08-07','12:45:00',6.03),('11288','2013-08-07','12:50:00',6.03),('11288','2013-08-07','12:55:00',6.02),('11288','2013-08-07','13:00:00',6.1),('11288','2013-08-07','13:05:00',6.09),('11288','2013-08-07','13:10:00',5.93),('11288','2013-08-07','13:15:00',6.2),('11288','2013-08-07','13:20:00',5.96),('11288','2013-08-07','13:25:00',6.02),('11288','2013-08-07','13:30:00',6.06),('11288','2013-08-07','13:35:00',6.11),('11288','2013-08-07','13:40:00',6.13),('11288','2013-08-07','13:45:00',6.13),('11288','2013-08-07','13:50:00',6.09),('11288','2013-08-07','13:55:00',6.09),('11288','2013-08-07','14:00:00',6.13),('11288','2013-08-07','14:05:00',6),('11288','2013-08-07','14:10:00',5.95),('11288','2013-08-07','14:15:00',5.89),('11288','2013-08-07','14:20:00',5.86),('11288','2013-08-07','14:25:00',5.76),('11288','2013-08-07','14:30:00',5.72),('11288','2013-08-07','14:35:00',5.71),('11288','2013-08-07','14:40:00',5.69),('11288','2013-08-07','14:45:00',5.66),('11288','2013-08-07','14:50:00',5.7),('11288','2013-08-07','14:55:00',5.62),('11288','2013-08-07','15:00:00',5.63),('11288','2013-08-07','15:05:00',5.58),('11288','2013-08-07','15:10:00',5.52),('11288','2013-08-07','15:15:00',5.4),('11288','2013-08-07','15:20:00',5.41),('11288','2013-08-07','15:25:00',5.34),('11288','2013-08-07','15:30:00',5.26),('11288','2013-08-07','15:35:00',5.26),('11288','2013-08-07','15:40:00',5.21),('11288','2013-08-07','15:45:00',5.16),('11288','2013-08-07','15:50:00',5.07),('11288','2013-08-07','15:55:00',4.97),('11288','2013-08-07','16:00:00',4.86),('11288','2013-08-07','16:05:00',4.76),('11288','2013-08-07','16:10:00',4.58),('11288','2013-08-07','16:15:00',4.53),('11288','2013-08-07','16:20:00',4.45),('11288','2013-08-07','16:25:00',4.44),('11288','2013-08-07','16:30:00',4.34),('11288','2013-08-07','16:35:00',4.26),('11288','2013-08-07','16:40:00',4.14),('11288','2013-08-07','16:45:00',4.09),('11288','2013-08-07','16:50:00',3.95),('11288','2013-08-07','16:55:00',3.87),('11288','2013-08-07','17:00:00',3.77),('11288','2013-08-07','17:05:00',3.65),('11288','2013-08-07','17:10:00',3.54),('11288','2013-08-07','17:15:00',3.4),('11288','2013-08-07','17:20:00',3.28),('11288','2013-08-07','17:25:00',3.08),('11288','2013-08-07','17:30:00',2.97),('11288','2013-08-07','17:35:00',2.84),('11288','2013-08-07','17:40:00',2.71),('11288','2013-08-07','17:45:00',2.59),('11288','2013-08-07','17:50:00',2.45),('11288','2013-08-07','17:55:00',2.29),('11288','2013-08-07','18:00:00',2.18),('11288','2013-08-07','18:05:00',1.99),('11288','2013-08-07','18:10:00',1.86),('11288','2013-08-07','18:15:00',1.84),('11288','2013-08-07','18:20:00',1.76),('11288','2013-08-07','18:25:00',1.66),('11288','2013-08-07','18:30:00',1.56),('11288','2013-08-07','18:35:00',1.43),('11288','2013-08-07','18:40:00',1.34),('11288','2013-08-07','18:45:00',1.24),('11288','2013-08-07','18:50:00',1.14),('11288','2013-08-06','07:40:00',1.02),('11288','2013-08-06','07:45:00',1.1),('11288','2013-08-06','07:50:00',1.21),('11288','2013-08-06','07:55:00',1.27),('11288','2013-08-06','08:00:00',1.37),('11288','2013-08-06','08:05:00',1.49),('11288','2013-08-06','08:10:00',1.58),('11288','2013-08-06','08:15:00',1.67),('11288','2013-08-06','08:20:00',1.82),('11288','2013-08-06','08:25:00',1.93),('11288','2013-08-06','08:30:00',1.95),('11288','2013-08-06','08:35:00',2.11),('11288','2013-08-06','08:40:00',2.38),('11288','2013-08-06','08:45:00',2.38),('11288','2013-08-06','08:50:00',2.51),('11288','2013-08-06','08:55:00',2.65),('11288','2013-08-06','09:00:00',2.76),('11288','2013-08-06','09:05:00',2.86),('11288','2013-08-06','09:10:00',3.11),('11288','2013-08-06','09:15:00',3.21),('11288','2013-08-06','09:20:00',3.41),('11288','2013-08-06','09:25:00',3.54),('11288','2013-08-06','09:30:00',3.65),('11288','2013-08-06','09:35:00',3.73),('11288','2013-08-06','09:40:00',3.89),('11288','2013-08-06','09:45:00',4.03),('11288','2013-08-06','09:50:00',4.06),('11288','2013-08-06','09:55:00',4.19),('11288','2013-08-06','10:00:00',4.21),('11288','2013-08-06','10:05:00',4.33),('11288','2013-08-06','10:10:00',4.53),('11288','2013-08-06','10:15:00',4.62),('11288','2013-08-06','10:20:00',4.58),('11288','2013-08-06','10:25:00',4.75),('11288','2013-08-06','10:30:00',4.87),('11288','2013-08-06','10:35:00',4.89),('11288','2013-08-06','10:40:00',5.02),('11288','2013-08-06','10:45:00',5.09),('11288','2013-08-06','10:50:00',5.1),('11288','2013-08-06','10:55:00',5.22),('11288','2013-08-06','11:00:00',5.3),('11288','2013-08-06','11:05:00',5.35),('11288','2013-08-06','11:10:00',5.44),('11288','2013-08-06','11:15:00',5.51),('11288','2013-08-06','11:20:00',5.54),('11288','2013-08-06','11:25:00',5.61),('11288','2013-08-06','11:30:00',5.63),('11288','2013-08-06','11:35:00',5.67),('11288','2013-08-06','11:40:00',5.69),('11288','2013-08-06','11:45:00',5.7),('11288','2013-08-06','11:50:00',5.73),('11288','2013-08-06','11:55:00',5.79),('11288','2013-08-06','12:00:00',5.86),('11288','2013-08-06','12:05:00',5.89),('11288','2013-08-06','12:10:00',5.91),('11288','2013-08-06','12:15:00',5.91),('11288','2013-08-06','12:20:00',5.89),('11288','2013-08-06','12:25:00',5.87),('11288','2013-08-06','12:30:00',5.9),('11288','2013-08-06','12:35:00',5.88),('11288','2013-08-06','12:40:00',5.96),('11288','2013-08-06','12:45:00',6.01),('11288','2013-08-06','12:50:00',6),('11288','2013-08-06','12:55:00',5.92),('11288','2013-08-06','13:00:00',6),('11288','2013-08-06','13:05:00',6.05),('11288','2013-08-06','13:10:00',6.1),('11288','2013-08-06','13:15:00',6.1),('11288','2013-08-06','13:20:00',6.15),('11288','2013-08-06','13:25:00',6.07),('11288','2013-08-06','13:30:00',6.13),('11288','2013-08-06','13:35:00',6.19),('11288','2013-08-06','13:40:00',6.21),('11288','2013-08-06','13:45:00',6.17),('11288','2013-08-06','13:50:00',6.19),('11288','2013-08-06','13:55:00',6.21),('11288','2013-08-06','14:00:00',6.19),('11288','2013-08-06','14:05:00',6.17),('11288','2013-08-06','14:10:00',6.15),('11288','2013-08-06','14:15:00',6.15),('11288','2013-08-06','14:20:00',6.13),('11288','2013-08-06','14:25:00',6.12),('11288','2013-08-06','14:30:00',6.08),('11288','2013-08-06','14:35:00',6.06),('11288','2013-08-06','14:40:00',5.99),('11288','2013-08-06','14:45:00',5.94),('11288','2013-08-06','14:50:00',5.93),('11288','2013-08-06','14:55:00',5.88),('11288','2013-08-06','15:00:00',5.86),('11288','2013-08-06','15:05:00',5.83),('11288','2013-08-06','15:10:00',5.79),('11288','2013-08-06','15:15:00',5.76),('11288','2013-08-06','15:20:00',5.68),('11288','2013-08-06','15:25:00',5.63),('11288','2013-08-06','15:30:00',5.57),('11288','2013-08-06','15:35:00',5.49),('11288','2013-08-06','15:40:00',5.42),('11288','2013-08-06','15:45:00',5.34),('11288','2013-08-06','15:50:00',5.25),('11288','2013-08-06','15:55:00',5.19),('11288','2013-08-06','16:00:00',5.11),('11288','2013-08-06','16:05:00',5.01),('11288','2013-08-06','16:10:00',4.9),('11288','2013-08-06','16:15:00',4.8),('11288','2013-08-06','16:20:00',4.7),('11288','2013-08-06','16:25:00',4.62),('11288','2013-08-06','16:30:00',4.5),('11288','2013-08-06','16:35:00',4.36),('11288','2013-08-06','16:40:00',4.26),('11288','2013-08-06','16:45:00',4.16),('11288','2013-08-06','16:50:00',4.07),('11288','2013-08-06','16:55:00',3.93),('11288','2013-08-06','17:00:00',3.84),('11288','2013-08-06','17:05:00',3.75),('11288','2013-08-06','17:10:00',3.62),('11288','2013-08-06','17:15:00',3.48),('11288','2013-08-06','17:20:00',3.33),('11288','2013-08-06','17:25:00',3.18),('11288','2013-08-06','17:30:00',3.07),('11288','2013-08-06','17:35:00',2.94),('11288','2013-08-06','17:40:00',2.8),('11288','2013-08-06','17:45:00',2.67),('11288','2013-08-06','17:50:00',2.52),('11288','2013-08-06','17:55:00',2.36),('11288','2013-08-06','18:00:00',2.26),('11288','2013-08-06','18:05:00',2.14),('11288','2013-08-06','18:10:00',2.02),('11288','2013-08-06','18:15:00',1.98),('11288','2013-08-06','18:20:00',1.89),('11288','2013-08-06','18:25:00',1.76),('11288','2013-08-06','18:30:00',1.64),('11288','2013-08-06','18:35:00',1.54),('11288','2013-08-06','18:40:00',1.39),('11288','2013-08-06','18:45:00',1.26),('11288','2013-08-06','18:50:00',1.12),('11288','2013-08-05','07:40:00',1.09),('11288','2013-08-05','07:45:00',1.2),('11288','2013-08-05','07:50:00',1.3),('11288','2013-08-05','07:55:00',1.35),('11288','2013-08-05','08:00:00',1.46),('11288','2013-08-05','08:05:00',1.6),('11288','2013-08-05','08:10:00',1.67),('11288','2013-08-05','08:15:00',1.72),('11288','2013-08-05','08:20:00',1.93),('11288','2013-08-05','08:25:00',1.99),('11288','2013-08-05','08:30:00',1.99),('11288','2013-08-05','08:35:00',2.27),('11288','2013-08-05','08:40:00',2.44),('11288','2013-08-05','08:45:00',2.53),('11288','2013-08-05','08:50:00',2.65),('11288','2013-08-05','08:55:00',2.69),('11288','2013-08-05','09:00:00',2.8),('11288','2013-08-05','09:05:00',2.97),('11288','2013-08-05','09:10:00',2.98),('11288','2013-08-05','09:15:00',3.28),('11288','2013-08-05','09:20:00',3.47),('11288','2013-08-05','09:25:00',3.48),('11288','2013-08-05','09:30:00',3.63),('11288','2013-08-05','09:35:00',3.79),('11288','2013-08-05','09:40:00',3.93),('11288','2013-08-05','09:45:00',4.04),('11288','2013-08-05','09:50:00',4.08),('11288','2013-08-05','09:55:00',4.18),('11288','2013-08-05','10:00:00',4.29),('11288','2013-08-05','10:05:00',4.43),('11288','2013-08-05','10:10:00',4.6),('11288','2013-08-05','10:15:00',4.72),('11288','2013-08-05','10:20:00',4.78),('11288','2013-08-05','10:25:00',4.84),('11288','2013-08-05','10:30:00',4.93),('11288','2013-08-05','10:35:00',4.95),('11288','2013-08-05','10:40:00',5.1),('11288','2013-08-05','10:45:00',5.2),('11288','2013-08-05','10:50:00',5.28),('11288','2013-08-05','10:55:00',5.37),('11288','2013-08-05','11:00:00',5.42),('11288','2013-08-05','11:05:00',5.49),('11288','2013-08-05','11:10:00',5.55),('11288','2013-08-05','11:15:00',5.63),('11288','2013-08-05','11:20:00',5.63),('11288','2013-08-05','11:25:00',5.71),('11288','2013-08-05','11:30:00',5.76),('11288','2013-08-05','11:35:00',5.82),('11288','2013-08-05','11:40:00',5.83),('11288','2013-08-05','11:45:00',5.84),('11288','2013-08-05','11:50:00',5.9),('11288','2013-08-05','11:55:00',5.97),('11288','2013-08-05','12:00:00',6.02),('11288','2013-08-05','12:05:00',6.06),('11288','2013-08-05','12:10:00',6.07),('11288','2013-08-05','12:15:00',6.11),('11288','2013-08-05','12:20:00',6.05),('11288','2013-08-05','12:25:00',6.12),('11288','2013-08-05','12:30:00',6.14),('11288','2013-08-05','12:35:00',6.14),('11288','2013-08-05','12:40:00',6.16),('11288','2013-08-05','12:45:00',6.2),('11288','2013-08-05','12:50:00',6.16),('11288','2013-08-05','12:55:00',6.15),('11288','2013-08-05','13:00:00',6.17),('11288','2013-08-05','13:05:00',6.16),('11288','2013-08-05','13:10:00',6.15),('11288','2013-08-05','13:15:00',6.14),('11288','2013-08-05','13:20:00',6.15),('11288','2013-08-05','13:25:00',6.17),('11288','2013-08-05','13:30:00',6.13),('11288','2013-08-05','13:35:00',6.14),('11288','2013-08-05','13:40:00',6.1),('11288','2013-08-05','13:45:00',6),('11288','2013-08-05','13:50:00',6.08),('11288','2013-08-05','13:55:00',6.07),('11288','2013-08-05','14:00:00',6.12),('11288','2013-08-05','14:05:00',6.02),('11288','2013-08-05','14:10:00',5.98),('11288','2013-08-05','14:15:00',5.98),('11288','2013-08-05','14:20:00',5.93),('11288','2013-08-05','14:25:00',5.91),('11288','2013-08-05','14:30:00',5.93),('11288','2013-08-05','14:35:00',5.86),('11288','2013-08-05','14:40:00',5.86),('11288','2013-08-05','14:45:00',5.83),('11288','2013-08-05','14:50:00',5.76),('11288','2013-08-05','14:55:00',5.73),('11288','2013-08-05','15:00:00',5.71),('11288','2013-08-05','15:05:00',5.66),('11288','2013-08-05','15:10:00',5.63),('11288','2013-08-05','15:15:00',5.59),('11288','2013-08-05','15:20:00',5.56),('11288','2013-08-05','15:25:00',5.53),('11288','2013-08-05','15:30:00',5.47),('11288','2013-08-05','15:35:00',5.41),('11288','2013-08-05','15:40:00',5.36),('11288','2013-08-05','15:45:00',5.3),('11288','2013-08-05','15:50:00',5.23),('11288','2013-08-05','15:55:00',5.16),('11288','2013-08-05','16:00:00',5.08),('11288','2013-08-05','16:05:00',5.03),('11288','2013-08-05','16:10:00',4.93),('11288','2013-08-05','16:15:00',4.78),('11288','2013-08-05','16:20:00',4.66),('11288','2013-08-05','16:25:00',4.57),('11288','2013-08-05','16:30:00',4.48),('11288','2013-08-05','16:35:00',4.38),('11288','2013-08-05','16:40:00',4.28),('11288','2013-08-05','16:45:00',4.17),('11288','2013-08-05','16:50:00',4.02),('11288','2013-08-05','16:55:00',3.92),('11288','2013-08-05','17:00:00',3.8),('11288','2013-08-05','17:05:00',3.71),('11288','2013-08-05','17:10:00',3.6),('11288','2013-08-05','17:15:00',3.43),('11288','2013-08-05','17:20:00',3.28),('11288','2013-08-05','17:25:00',3.17),('11288','2013-08-05','17:30:00',3.03),('11288','2013-08-05','17:35:00',2.93),('11288','2013-08-05','17:40:00',2.8),('11288','2013-08-05','17:45:00',2.67),('11288','2013-08-05','17:50:00',2.5),('11288','2013-08-05','17:55:00',2.37),('11288','2013-08-05','18:00:00',2.24),('11288','2013-08-05','18:05:00',2.09),('11288','2013-08-05','18:10:00',1.99),('11288','2013-08-05','18:15:00',1.94),('11288','2013-08-05','18:20:00',1.85),('11288','2013-08-05','18:25:00',1.73),('11288','2013-08-05','18:30:00',1.59),('11288','2013-08-05','18:35:00',1.48),('11288','2013-08-05','18:40:00',1.36),('11288','2013-08-05','18:45:00',1.26),('11288','2013-08-05','18:50:00',1.15),('11288','2013-08-05','18:55:00',1.02),('11288','2013-08-04','07:40:00',1.01),('11288','2013-08-04','07:45:00',1.11),('11288','2013-08-04','07:50:00',1.21),('11288','2013-08-04','07:55:00',1.33),('11288','2013-08-04','08:00:00',1.41),('11288','2013-08-04','08:05:00',1.56),('11288','2013-08-04','08:10:00',1.6),('11288','2013-08-04','08:15:00',1.65),('11288','2013-08-04','08:20:00',1.94),('11288','2013-08-04','08:25:00',1.85),('11288','2013-08-04','08:30:00',1.87),('11288','2013-08-04','08:35:00',2.41),('11288','2013-08-04','08:40:00',2.46),('11288','2013-08-04','08:45:00',2.59),('11288','2013-08-04','08:50:00',2.68),('11288','2013-08-04','08:55:00',2.76),('11288','2013-08-04','09:00:00',2.86),('11288','2013-08-04','09:05:00',3.19),('11288','2013-08-04','09:10:00',3.22),('11288','2013-08-04','09:15:00',3.4),('11288','2013-08-04','09:20:00',3.65),('11288','2013-08-04','09:25:00',3.58),('11288','2013-08-04','09:30:00',3.72),('11288','2013-08-04','09:35:00',3.99),('11288','2013-08-04','09:40:00',4.15),('11288','2013-08-04','09:45:00',4.2),('11288','2013-08-04','09:50:00',4.31),('11288','2013-08-04','09:55:00',4.3),('11288','2013-08-04','10:00:00',4.43),('11288','2013-08-04','10:05:00',4.73),('11288','2013-08-04','10:10:00',4.82),('11288','2013-08-04','10:15:00',4.94),('11288','2013-08-04','10:20:00',5.01),('11288','2013-08-04','10:25:00',5.09),('11288','2013-08-04','10:30:00',5.16),('11288','2013-08-04','10:35:00',5.22),('11288','2013-08-04','10:40:00',5.31),('11288','2013-08-04','10:45:00',5.37),('11288','2013-08-04','10:50:00',5.43),('11288','2013-08-04','10:55:00',5.5),('11288','2013-08-04','11:00:00',5.56),('11288','2013-08-04','11:05:00',5.59),('11288','2013-08-04','11:10:00',5.65),('11288','2013-08-04','11:15:00',5.74),('11288','2013-08-04','11:20:00',5.8),('11288','2013-08-04','11:25:00',5.86),('11288','2013-08-04','11:30:00',5.98),('11288','2013-08-04','11:35:00',5.99),('11288','2013-08-04','11:40:00',6.03),('11288','2013-08-04','11:45:00',6.08),('11288','2013-08-04','11:50:00',6.16),('11288','2013-08-04','11:55:00',6.21),('11288','2013-08-04','12:00:00',6.25),('11288','2013-08-04','12:05:00',6.23),('11288','2013-08-04','12:10:00',6.29),('11288','2013-08-04','12:15:00',6.29),('11288','2013-08-04','12:20:00',6.26),('11288','2013-08-04','12:25:00',6.28),('11288','2013-08-04','12:30:00',6.32),('11288','2013-08-04','12:35:00',6.31),('11288','2013-08-04','12:40:00',6.36),('11288','2013-08-04','12:45:00',6.35),('11288','2013-08-04','12:50:00',6.36),('11288','2013-08-04','12:55:00',6.34),('11288','2013-08-04','13:00:00',6.34),('11288','2013-08-04','13:05:00',6.35),('11288','2013-08-04','13:10:00',6.35),('11288','2013-08-04','13:15:00',6.32),('11288','2013-08-04','13:20:00',6.34),('11288','2013-08-04','13:25:00',6.3),('11288','2013-08-04','13:30:00',6.35),('11288','2013-08-04','13:35:00',6.34),('11288','2013-08-04','13:40:00',6.35),('11288','2013-08-04','13:45:00',6.4),('11288','2013-08-04','13:50:00',6.32),('11288','2013-08-04','13:55:00',6.39),('11288','2013-08-04','14:00:00',6.4),('11288','2013-08-04','14:05:00',6.35),('11288','2013-08-04','14:10:00',6.34),('11288','2013-08-04','14:15:00',6.28),('11288','2013-08-04','14:20:00',6.24),('11288','2013-08-04','14:25:00',6.27),('11288','2013-08-04','14:30:00',6.17),('11288','2013-08-04','14:35:00',6.15),('11288','2013-08-04','14:40:00',6.16),('11288','2013-08-04','14:45:00',6.08),('11288','2013-08-04','14:50:00',6.03),('11288','2013-08-04','14:55:00',5.99),('11288','2013-08-04','15:00:00',5.94),('11288','2013-08-04','15:05:00',5.91),('11288','2013-08-04','15:10:00',5.86),('11288','2013-08-04','15:15:00',5.79),('11288','2013-08-04','15:20:00',5.72),('11288','2013-08-04','15:25:00',5.67),('11288','2013-08-04','15:30:00',5.56),('11288','2013-08-04','15:35:00',5.59),('11288','2013-08-04','15:40:00',5.52),('11288','2013-08-04','15:45:00',5.4),('11288','2013-08-04','15:50:00',5.28),('11288','2013-08-04','15:55:00',5.26),('11288','2013-08-04','16:00:00',5.14),('11288','2013-08-04','16:05:00',5.14),('11288','2013-08-04','16:10:00',5.02),('11288','2013-08-04','16:15:00',4.91),('11288','2013-08-04','16:20:00',4.79),('11288','2013-08-04','16:25:00',4.76),('11288','2013-08-04','16:30:00',4.66),('11288','2013-08-04','16:35:00',4.54),('11288','2013-08-04','16:40:00',4.43),('11288','2013-08-04','16:45:00',4.33),('11288','2013-08-04','16:50:00',4.18),('11288','2013-08-04','16:55:00',4.06),('11288','2013-08-04','17:00:00',3.99),('11288','2013-08-04','17:05:00',3.87),('11288','2013-08-04','17:10:00',3.75),('11288','2013-08-04','17:15:00',3.58),('11288','2013-08-04','17:20:00',3.41),('11288','2013-08-04','17:25:00',3.31),('11288','2013-08-04','17:30:00',3.16),('11288','2013-08-04','17:35:00',3.04),('11288','2013-08-04','17:40:00',2.9),('11288','2013-08-04','17:45:00',2.75),('11288','2013-08-04','17:50:00',2.62),('11288','2013-08-04','17:55:00',2.47),('11288','2013-08-04','18:00:00',2.35),('11288','2013-08-04','18:05:00',2.18),('11288','2013-08-04','18:10:00',2.07),('11288','2013-08-04','18:15:00',2.03),('11288','2013-08-04','18:20:00',1.96),('11288','2013-08-04','18:25:00',1.81),('11288','2013-08-04','18:30:00',1.66),('11288','2013-08-04','18:35:00',1.54),('11288','2013-08-04','18:40:00',1.4),('11288','2013-08-04','18:45:00',1.24),('11288','2013-08-04','18:50:00',1.15),('11288','2013-08-04','18:55:00',1.04),('11288','2013-08-03','07:40:00',1.02),('11288','2013-08-03','07:45:00',1.16),('11288','2013-08-03','07:50:00',1.22),('11288','2013-08-03','07:55:00',1.33),('11288','2013-08-03','08:00:00',1.43),('11288','2013-08-03','08:05:00',1.51),('11288','2013-08-03','08:10:00',1.57),('11288','2013-08-03','08:15:00',1.66),('11288','2013-08-03','08:20:00',1.85),('11288','2013-08-03','08:25:00',1.87),('11288','2013-08-03','08:30:00',2),('11288','2013-08-03','08:35:00',2.45),('11288','2013-08-03','08:40:00',2.48),('11288','2013-08-03','08:45:00',2.62),('11288','2013-08-03','08:50:00',2.6),('11288','2013-08-03','08:55:00',2.77),('11288','2013-08-03','09:00:00',2.97),('11288','2013-08-03','09:05:00',3.1),('11288','2013-08-03','09:10:00',2.93),('11288','2013-08-03','09:15:00',3.37),('11288','2013-08-03','09:20:00',3.61),('11288','2013-08-03','09:25:00',3.61),('11288','2013-08-03','09:30:00',3.67),('11288','2013-08-03','09:35:00',3.93),('11288','2013-08-03','09:40:00',4.07),('11288','2013-08-03','09:45:00',4.08),('11288','2013-08-03','09:50:00',4.36),('11288','2013-08-03','09:55:00',4.47),('11288','2013-08-03','10:00:00',4.59),('11288','2013-08-03','10:05:00',4.68),('11288','2013-08-03','10:10:00',4.77),('11288','2013-08-03','10:15:00',4.91),('11288','2013-08-03','10:20:00',5.02),('11288','2013-08-03','10:25:00',5.12),('11288','2013-08-03','10:30:00',5.15),('11288','2013-08-03','10:35:00',5.18),('11288','2013-08-03','10:40:00',5.31),('11288','2013-08-03','10:45:00',5.39),('11288','2013-08-03','10:50:00',5.45),('11288','2013-08-03','10:55:00',5.57),('11288','2013-08-03','11:00:00',5.59),('11288','2013-08-03','11:05:00',5.66),('11288','2013-08-03','11:10:00',5.77),('11288','2013-08-03','11:15:00',5.8),('11288','2013-08-03','11:20:00',5.82),('11288','2013-08-03','11:25:00',5.9),('11288','2013-08-03','11:30:00',5.91),('11288','2013-08-03','11:35:00',5.97),('11288','2013-08-03','11:40:00',6.02),('11288','2013-08-03','11:45:00',6.04),('11288','2013-08-03','11:50:00',6.05),('11288','2013-08-03','11:55:00',6.06),('11288','2013-08-03','12:00:00',6.09),('11288','2013-08-03','12:05:00',6.13),('11288','2013-08-03','12:10:00',6.06),('11288','2013-08-03','12:15:00',6.11),('11288','2013-08-03','12:20:00',6.19),('11288','2013-08-03','12:25:00',6.17),('11288','2013-08-03','12:30:00',6.23),('11288','2013-08-03','12:35:00',6.19),('11288','2013-08-03','12:40:00',6.16),('11288','2013-08-03','12:45:00',6.18),('11288','2013-08-03','12:50:00',6.12),('11288','2013-08-03','12:55:00',6.13),('11288','2013-08-03','13:00:00',6.17),('11288','2013-08-03','13:05:00',6.2),('11288','2013-08-03','13:10:00',6.21),('11288','2013-08-03','13:15:00',6.15),('11288','2013-08-03','13:20:00',6.12),('11288','2013-08-03','13:25:00',6.11),('11288','2013-08-03','13:30:00',6.11),('11288','2013-08-03','13:35:00',6.22),('11288','2013-08-03','13:40:00',6.23),('11288','2013-08-03','13:45:00',6.18),('11288','2013-08-03','13:50:00',6.18),('11288','2013-08-03','13:55:00',6.12),('11288','2013-08-03','14:00:00',6.11),('11288','2013-08-03','14:05:00',6.06),('11288','2013-08-03','14:10:00',5.98),('11288','2013-08-03','14:15:00',5.93),('11288','2013-08-03','14:20:00',6.01),('11288','2013-08-03','14:25:00',6.06),('11288','2013-08-03','14:30:00',6.07),('11288','2013-08-03','14:35:00',6.12),('11288','2013-08-03','14:40:00',6.12),('11288','2013-08-03','14:45:00',6.08),('11288','2013-08-03','14:50:00',6.01),('11288','2013-08-03','14:55:00',5.96),('11288','2013-08-03','15:00:00',5.95),('11288','2013-08-03','15:05:00',5.89),('11288','2013-08-03','15:10:00',5.87),('11288','2013-08-03','15:15:00',5.81),('11288','2013-08-03','15:20:00',5.69),('11288','2013-08-03','15:25:00',5.68),('11288','2013-08-03','15:30:00',5.62),('11288','2013-08-03','15:35:00',5.56),('11288','2013-08-03','15:40:00',5.47),('11288','2013-08-03','15:45:00',5.43),('11288','2013-08-03','15:50:00',5.39),('11288','2013-08-03','15:55:00',5.29),('11288','2013-08-03','16:00:00',5.2),('11288','2013-08-03','16:05:00',5.07),('11288','2013-08-03','16:10:00',4.96),('11288','2013-08-03','16:15:00',4.81),('11288','2013-08-03','16:20:00',4.71),('11288','2013-08-03','16:25:00',4.64),('11288','2013-08-03','16:30:00',4.58),('11288','2013-08-03','16:35:00',4.44),('11288','2013-08-03','16:40:00',4.35),('11288','2013-08-03','16:45:00',4.23),('11288','2013-08-03','16:50:00',4.16),('11288','2013-08-03','16:55:00',3.69),('11288','2013-08-03','17:00:00',3.77),('11288','2013-08-03','17:05:00',3.8),('11288','2013-08-03','17:10:00',3.73),('11288','2013-08-03','17:15:00',3.54),('11288','2013-08-03','17:20:00',3.38),('11288','2013-08-03','17:25:00',3.3),('11288','2013-08-03','17:30:00',3.17),('11288','2013-08-03','17:35:00',3.05),('11288','2013-08-03','17:40:00',2.91),('11288','2013-08-03','17:45:00',2.75),('11288','2013-08-03','17:50:00',2.62),('11288','2013-08-03','17:55:00',2.49),('11288','2013-08-03','18:00:00',2.38),('11288','2013-08-03','18:05:00',2.24),('11288','2013-08-03','18:10:00',2.13),('11288','2013-08-03','18:15:00',2.12),('11288','2013-08-03','18:20:00',2.01),('11288','2013-08-03','18:25:00',1.87),('11288','2013-08-03','18:30:00',1.75),('11288','2013-08-03','18:35:00',1.63),('11288','2013-08-03','18:40:00',1.5),('11288','2013-08-03','18:45:00',1.37),('11288','2013-08-03','18:50:00',1.24),('11288','2013-08-03','18:55:00',1.13),('11288','2013-08-02','07:40:00',1.07),('11288','2013-08-02','07:45:00',1.15),('11288','2013-08-02','07:50:00',1.27),('11288','2013-08-02','07:55:00',1.42),('11288','2013-08-02','08:00:00',1.55),('11288','2013-08-02','08:05:00',1.62),('11288','2013-08-02','08:10:00',1.6),('11288','2013-08-02','08:15:00',1.72),('11288','2013-08-02','08:20:00',1.95),('11288','2013-08-02','08:25:00',1.91),('11288','2013-08-02','08:30:00',2.25),('11288','2013-08-02','08:35:00',2.51),('11288','2013-08-02','08:40:00',2.58),('11288','2013-08-02','08:45:00',2.72),('11288','2013-08-02','08:50:00',2.74),('11288','2013-08-02','08:55:00',2.89),('11288','2013-08-02','09:00:00',3.1),('11288','2013-08-02','09:05:00',3.15),('11288','2013-08-02','09:10:00',3.14),('11288','2013-08-02','09:15:00',3.52),('11288','2013-08-02','09:20:00',3.76),('11288','2013-08-02','09:25:00',3.8),('11288','2013-08-02','09:30:00',3.86),('11288','2013-08-02','09:35:00',4.06),('11288','2013-08-02','09:40:00',4.11),('11288','2013-08-02','09:45:00',4.2),('11288','2013-08-02','09:50:00',4.41),('11288','2013-08-02','09:55:00',4.36),('11288','2013-08-02','10:00:00',4.49),('11288','2013-08-02','10:05:00',4.82),('11288','2013-08-02','10:10:00',4.91),('11288','2013-08-02','10:15:00',5.03),('11288','2013-08-02','10:20:00',5.08),('11288','2013-08-02','10:25:00',5.2),('11288','2013-08-02','10:30:00',5.3),('11288','2013-08-02','10:35:00',5.32),('11288','2013-08-02','10:40:00',5.42),('11288','2013-08-02','10:45:00',5.52),('11288','2013-08-02','10:50:00',5.59),('11288','2013-08-02','10:55:00',5.63),('11288','2013-08-02','11:00:00',5.64),('11288','2013-08-02','11:05:00',5.76),('11288','2013-08-02','11:10:00',5.83),('11288','2013-08-02','11:15:00',5.87),('11288','2013-08-02','11:20:00',5.92),('11288','2013-08-02','11:25:00',5.99),('11288','2013-08-02','11:30:00',6.02),('11288','2013-08-02','11:35:00',6.09),('11288','2013-08-02','11:40:00',6.12),('11288','2013-08-02','11:45:00',6.15),('11288','2013-08-02','11:50:00',6.16),('11288','2013-08-02','11:55:00',6.2),('11288','2013-08-02','12:00:00',6.24),('11288','2013-08-02','12:05:00',6.32),('11288','2013-08-02','12:10:00',6.35),('11288','2013-08-02','12:15:00',6.42),('11288','2013-08-02','12:20:00',6.42),('11288','2013-08-02','12:25:00',6.42),('11288','2013-08-02','12:30:00',6.4),('11288','2013-08-02','12:35:00',6.4),('11288','2013-08-02','12:40:00',6.44),('11288','2013-08-02','12:45:00',6.46),('11288','2013-08-02','12:50:00',6.43),('11288','2013-08-02','12:55:00',6.42),('11288','2013-08-02','13:00:00',6.44),('11288','2013-08-02','13:05:00',6.46),('11288','2013-08-02','13:10:00',6.47),('11288','2013-08-02','13:15:00',6.47),('11288','2013-08-02','13:20:00',6.44),('11288','2013-08-02','13:25:00',6.43),('11288','2013-08-02','13:30:00',6.37),('11288','2013-08-02','13:35:00',6.39),('11288','2013-08-02','13:40:00',6.44),('11288','2013-08-02','13:45:00',6.39),('11288','2013-08-02','13:50:00',6.38),('11288','2013-08-02','13:55:00',6.39),('11288','2013-08-02','14:00:00',6.38),('11288','2013-08-02','14:05:00',6.34),('11288','2013-08-02','14:10:00',6.31),('11288','2013-08-02','14:15:00',6.24),('11288','2013-08-02','14:20:00',6.14),('11288','2013-08-02','14:25:00',6.12),('11288','2013-08-02','14:30:00',6.17),('11288','2013-08-02','14:35:00',6.24),('11288','2013-08-02','14:40:00',6.21),('11288','2013-08-02','14:45:00',6.2),('11288','2013-08-02','14:50:00',6.13),('11288','2013-08-02','14:55:00',6.1),('11288','2013-08-02','15:00:00',6),('11288','2013-08-02','15:05:00',5.95),('11288','2013-08-02','15:10:00',5.88),('11288','2013-08-02','15:15:00',5.82),('11288','2013-08-02','15:20:00',5.85),('11288','2013-08-02','15:25:00',5.82),('11288','2013-08-02','15:30:00',5.75),('11288','2013-08-02','15:35:00',5.67),('11288','2013-08-02','15:40:00',5.59),('11288','2013-08-02','15:45:00',5.54),('11288','2013-08-02','15:50:00',5.45),('11288','2013-08-02','15:55:00',5.39),('11288','2013-08-02','16:00:00',5.32),('11288','2013-08-02','16:05:00',5.2),('11288','2013-08-02','16:10:00',5.09),('11288','2013-08-02','16:15:00',5.02),('11288','2013-08-02','16:20:00',4.93),('11288','2013-08-02','16:25:00',4.85),('11288','2013-08-02','16:30:00',4.75),('11288','2013-08-02','16:35:00',4.62),('11288','2013-08-02','16:40:00',4.54),('11288','2013-08-02','16:45:00',4.42),('11288','2013-08-02','16:50:00',4.3),('11288','2013-08-02','16:55:00',4.18),('11288','2013-08-02','17:00:00',4.03),('11288','2013-08-02','17:05:00',3.92),('11288','2013-08-02','17:10:00',3.84),('11288','2013-08-02','17:15:00',3.69),('11288','2013-08-02','17:20:00',3.51),('11288','2013-08-02','17:25:00',3.44),('11288','2013-08-02','17:30:00',3.27),('11288','2013-08-02','17:35:00',3.16),('11288','2013-08-02','17:40:00',3.01),('11288','2013-08-02','17:45:00',2.84),('11288','2013-08-02','17:50:00',2.7),('11288','2013-08-02','17:55:00',2.58),('11288','2013-08-02','18:00:00',2.47),('11288','2013-08-02','18:05:00',2.34),('11288','2013-08-02','18:10:00',2.25),('11288','2013-08-02','18:15:00',2.21),('11288','2013-08-02','18:20:00',2.07),('11288','2013-08-02','18:25:00',1.93),('11288','2013-08-02','18:30:00',1.8),('11288','2013-08-02','18:35:00',1.67),('11288','2013-08-02','18:40:00',1.54),('11288','2013-08-02','18:45:00',1.39),('11288','2013-08-02','18:50:00',1.27),('11288','2013-08-02','18:55:00',1.17),('11288','2013-08-02','19:00:00',1.04),('11288','2013-08-01','07:40:00',1.08),('11288','2013-08-01','07:45:00',1.19),('11288','2013-08-01','07:50:00',1.32),('11288','2013-08-01','07:55:00',1.39),('11288','2013-08-01','08:00:00',1.53),('11288','2013-08-01','08:05:00',1.6),('11288','2013-08-01','08:10:00',1.64),('11288','2013-08-01','08:15:00',1.77),('11288','2013-08-01','08:20:00',1.82),('11288','2013-08-01','08:25:00',1.94),('11288','2013-08-01','08:30:00',2.34),('11288','2013-08-01','08:35:00',2.47),('11288','2013-08-01','08:40:00',2.62),('11288','2013-08-01','08:45:00',2.8),('11288','2013-08-01','08:50:00',2.88),('11288','2013-08-01','08:55:00',3.01),('11288','2013-08-01','09:00:00',3.17),('11288','2013-08-01','09:05:00',3.25),('11288','2013-08-01','09:10:00',3.35),('11288','2013-08-01','09:15:00',3.68),('11288','2013-08-01','09:20:00',3.84),('11288','2013-08-01','09:25:00',3.9),('11288','2013-08-01','09:30:00',4.03),('11288','2013-08-01','09:35:00',4.19),('11288','2013-08-01','09:40:00',4.32),('11288','2013-08-01','09:45:00',4.5),('11288','2013-08-01','09:50:00',4.69),('11288','2013-08-01','09:55:00',4.81),('11288','2013-08-01','10:00:00',4.9),('11288','2013-08-01','10:05:00',5.01),('11288','2013-08-01','10:10:00',5.14),('11288','2013-08-01','10:15:00',5.22),('11288','2013-08-01','10:20:00',5.32),('11288','2013-08-01','10:25:00',5.47),('11288','2013-08-01','10:30:00',5.57),('11288','2013-08-01','10:35:00',5.58),('11288','2013-08-01','10:40:00',5.65),('11288','2013-08-01','10:45:00',5.72),('11288','2013-08-01','10:50:00',5.88),('11288','2013-08-01','10:55:00',5.93),('11288','2013-08-01','11:00:00',5.99),('11288','2013-08-01','11:05:00',6.14),('11288','2013-08-01','11:10:00',6.22),('11288','2013-08-01','11:15:00',6.29),('11288','2013-08-01','11:20:00',6.36),('11288','2013-08-01','11:25:00',6.4),('11288','2013-08-01','11:30:00',6.42),('11288','2013-08-01','11:35:00',6.45),('11288','2013-08-01','11:40:00',6.55),('11288','2013-08-01','11:45:00',6.61),('11288','2013-08-01','11:50:00',6.65),('11288','2013-08-01','11:55:00',6.66),('11288','2013-08-01','12:00:00',6.69),('11288','2013-08-01','12:05:00',6.67),('11288','2013-08-01','12:10:00',6.7),('11288','2013-08-01','12:15:00',6.7),('11288','2013-08-01','12:20:00',6.82),('11288','2013-08-01','12:25:00',6.83),('11288','2013-08-01','12:30:00',6.86),('11288','2013-08-01','12:35:00',6.85),('11288','2013-08-01','12:40:00',6.88),('11288','2013-08-01','12:45:00',6.89),('11288','2013-08-01','12:50:00',6.91),('11288','2013-08-01','12:55:00',6.84),('11288','2013-08-01','13:00:00',6.86),('11288','2013-08-01','13:05:00',6.86),('11288','2013-08-01','13:10:00',6.9),('11288','2013-08-01','13:15:00',6.35),('11288','2013-08-01','13:20:00',6.87),('11288','2013-08-01','13:25:00',6.94),('11288','2013-08-01','13:30:00',6.59),('11288','2013-08-01','13:35:00',6.84),('11288','2013-08-01','13:40:00',6.99),('11288','2013-08-01','13:45:00',6.3),('11288','2013-08-01','13:50:00',7.07),('11288','2013-08-01','13:55:00',6.03),('11288','2013-08-01','14:00:00',6.56),('11288','2013-08-01','14:05:00',6.83),('11288','2013-08-01','14:10:00',6.32),('11288','2013-08-01','14:15:00',6.49),('11288','2013-08-01','14:20:00',6.46),('11288','2013-08-01','14:25:00',6.54),('11288','2013-08-01','14:30:00',6.44),('11288','2013-08-01','14:35:00',6.01),('11288','2013-08-01','14:40:00',6.4),('11288','2013-08-01','14:45:00',6.35),('11288','2013-08-01','14:50:00',4.78),('11288','2013-08-01','14:55:00',6.34),('11288','2013-08-01','15:00:00',6.18),('11288','2013-08-01','15:05:00',6.22),('11288','2013-08-01','15:10:00',6.25),('11288','2013-08-01','15:15:00',6.24),('11288','2013-08-01','15:20:00',6.14),('11288','2013-08-01','15:25:00',6.09),('11288','2013-08-01','15:30:00',5.91),('11288','2013-08-01','15:35:00',5.93),('11288','2013-08-01','15:40:00',5.17),('11288','2013-08-01','15:45:00',5.71),('11288','2013-08-01','15:50:00',5.62),('11288','2013-08-01','15:55:00',5.62),('11288','2013-08-01','16:00:00',5.6),('11288','2013-08-01','16:05:00',5.52),('11288','2013-08-01','16:10:00',5.31),('11288','2013-08-01','16:15:00',5.11),('11288','2013-08-01','16:20:00',5.1),('11288','2013-08-01','16:25:00',5.04),('11288','2013-08-01','16:30:00',4.91),('11288','2013-08-01','16:35:00',4.79),('11288','2013-08-01','16:40:00',4.68),('11288','2013-08-01','16:45:00',4.57),('11288','2013-08-01','16:50:00',4.45),('11288','2013-08-01','16:55:00',4.32),('11288','2013-08-01','17:00:00',4.18),('11288','2013-08-01','17:05:00',4.04),('11288','2013-08-01','17:10:00',3.93),('11288','2013-08-01','17:15:00',3.74),('11288','2013-08-01','17:20:00',3.64),('11288','2013-08-01','17:25:00',3.52),('11288','2013-08-01','17:30:00',3.4),('11288','2013-08-01','17:35:00',3.27),('11288','2013-08-01','17:40:00',3.12),('11288','2013-08-01','17:45:00',2.95),('11288','2013-08-01','17:50:00',2.83),('11288','2013-08-01','17:55:00',2.71),('11288','2013-08-01','18:00:00',2.58),('11288','2013-08-01','18:05:00',2.45),('11288','2013-08-01','18:10:00',2.38),('11288','2013-08-01','18:15:00',2.3),('11288','2013-08-01','18:20:00',2.18),('11288','2013-08-01','18:25:00',2.03),('11288','2013-08-01','18:30:00',1.9),('11288','2013-08-01','18:35:00',1.76),('11288','2013-08-01','18:40:00',1.64),('11288','2013-08-01','18:45:00',1.49),('11288','2013-08-01','18:50:00',1.36),('11288','2013-08-01','18:55:00',1.24),('11288','2013-08-01','19:00:00',1.08),('11288','2013-07-31','07:40:00',1.11),('11288','2013-07-31','07:45:00',1.25),('11288','2013-07-31','07:50:00',1.33),('11288','2013-07-31','07:55:00',1.47),('11288','2013-07-31','08:00:00',1.59),('11288','2013-07-31','08:05:00',1.74),('11288','2013-07-31','08:10:00',1.87),('11288','2013-07-31','08:15:00',1.96),('11288','2013-07-31','08:20:00',2.05),('11288','2013-07-31','08:25:00',2.2),('11288','2013-07-31','08:30:00',2.4),('11288','2013-07-31','08:35:00',2.57),('11288','2013-07-31','08:40:00',2.73),('11288','2013-07-31','08:45:00',2.87),('11288','2013-07-31','08:50:00',2.93),('11288','2013-07-31','08:55:00',3.08),('11288','2013-07-31','09:00:00',3.26),('11288','2013-07-31','09:05:00',3.36),('11288','2013-07-31','09:10:00',3.51),('11288','2013-07-31','09:15:00',3.77),('11288','2013-07-31','09:20:00',3.82),('11288','2013-07-31','09:25:00',3.93),('11288','2013-07-31','09:30:00',4.14),('11288','2013-07-31','09:35:00',4.2),('11288','2013-07-31','09:40:00',4.35),('11288','2013-07-31','09:45:00',4.5),('11288','2013-07-31','09:50:00',4.47),('11288','2013-07-31','09:55:00',4.73),('11288','2013-07-31','10:00:00',4.89),('11288','2013-07-31','10:05:00',5.04),('11288','2013-07-31','10:10:00',5.1),('11288','2013-07-31','10:15:00',5.2),('11288','2013-07-31','10:20:00',5.36),('11288','2013-07-31','10:25:00',5.47),('11288','2013-07-31','10:30:00',5.6),('11288','2013-07-31','10:35:00',5.7),('11288','2013-07-31','10:40:00',5.77),('11288','2013-07-31','10:45:00',5.84),('11288','2013-07-31','10:50:00',5.95),('11288','2013-07-31','10:55:00',6.04),('11288','2013-07-31','11:00:00',6.12),('11288','2013-07-31','11:05:00',6.21),('11288','2013-07-31','11:10:00',6.26),('11288','2013-07-31','11:15:00',6.33),('11288','2013-07-31','11:20:00',6.36),('11288','2013-07-31','11:25:00',6.42),('11288','2013-07-31','11:30:00',6.44),('11288','2013-07-31','11:35:00',6.49),('11288','2013-07-31','11:40:00',6.52),('11288','2013-07-31','11:45:00',6.57),('11288','2013-07-31','11:50:00',6.65),('11288','2013-07-31','11:55:00',6.73),('11288','2013-07-31','12:00:00',6.74),('11288','2013-07-31','12:05:00',6.74),('11288','2013-07-31','12:10:00',6.81),('11288','2013-07-31','12:15:00',6.89),('11288','2013-07-31','12:20:00',6.84),('11288','2013-07-31','12:25:00',6.93),('11288','2013-07-31','12:30:00',6.76),('11288','2013-07-31','12:35:00',6.85),('11288','2013-07-31','12:40:00',6.92),('11288','2013-07-31','12:45:00',6.38),('11288','2013-07-31','12:50:00',3.02),('11288','2013-07-31','12:55:00',7.35),('11288','2013-07-31','13:00:00',3.24),('11288','2013-07-31','13:05:00',5.6),('11288','2013-07-31','13:10:00',6.95),('11288','2013-07-31','13:15:00',7.15),('11288','2013-07-31','13:20:00',6.61),('11288','2013-07-31','13:25:00',6.98),('11288','2013-07-31','13:30:00',6.42),('11288','2013-07-31','13:35:00',6.73),('11288','2013-07-31','13:40:00',6.94),('11288','2013-07-31','13:45:00',6.66),('11288','2013-07-31','13:50:00',7.18),('11288','2013-07-31','13:55:00',5.16),('11288','2013-07-31','14:00:00',5.01),('11288','2013-07-31','14:05:00',7.1),('11288','2013-07-31','14:10:00',7.05),('11288','2013-07-31','14:15:00',5.9),('11288','2013-07-31','14:20:00',6.74),('11288','2013-07-31','14:25:00',6.36),('11288','2013-07-31','14:30:00',6.75),('11288','2013-07-31','14:35:00',6.61),('11288','2013-07-31','14:40:00',6.66),('11288','2013-07-31','14:45:00',6.47),('11288','2013-07-31','14:50:00',6.88),('11288','2013-07-31','14:55:00',5.27),('11288','2013-07-31','15:00:00',2.5),('11288','2013-07-31','15:05:00',4.83),('11288','2013-07-31','15:10:00',6.53),('11288','2013-07-31','15:15:00',5.63),('11288','2013-07-31','15:20:00',5.77),('11288','2013-07-31','15:25:00',6.31),('11288','2013-07-31','15:30:00',5.14),('11288','2013-07-31','15:35:00',5.99),('11288','2013-07-31','15:40:00',6.11),('11288','2013-07-31','15:45:00',5.48),('11288','2013-07-31','15:50:00',5.69),('11288','2013-07-31','15:55:00',5.61),('11288','2013-07-31','16:00:00',5.48),('11288','2013-07-31','16:05:00',5.52),('11288','2013-07-31','16:10:00',5.48),('11288','2013-07-31','16:15:00',5.27),('11288','2013-07-31','16:20:00',5.3),('11288','2013-07-31','16:25:00',5.32),('11288','2013-07-31','16:30:00',5.17),('11288','2013-07-31','16:35:00',4.88),('11288','2013-07-31','16:40:00',4.65),('11288','2013-07-31','16:45:00',4.48),('11288','2013-07-31','16:50:00',4.47),('11288','2013-07-31','16:55:00',4.34),('11288','2013-07-31','17:00:00',4.2),('11288','2013-07-31','17:05:00',4.1),('11288','2013-07-31','17:10:00',3.53),('11288','2013-07-31','17:15:00',3.9),('11288','2013-07-31','17:20:00',2.63),('11288','2013-07-31','17:25:00',3.5),('11288','2013-07-31','17:30:00',3.39),('11288','2013-07-31','17:35:00',3.21),('11288','2013-07-31','17:40:00',3.09),('11288','2013-07-31','17:45:00',2.95),('11288','2013-07-31','17:50:00',2.81),('11288','2013-07-31','17:55:00',2.69),('11288','2013-07-31','18:00:00',2.57),('11288','2013-07-31','18:05:00',2.44),('11288','2013-07-31','18:10:00',2.4),('11288','2013-07-31','18:15:00',2.31),('11288','2013-07-31','18:20:00',2.18),('11288','2013-07-31','18:25:00',2.08),('11288','2013-07-31','18:30:00',1.96),('11288','2013-07-31','18:35:00',1.83),('11288','2013-07-31','18:40:00',1.69),('11288','2013-07-31','18:45:00',1.55),('11288','2013-07-31','18:50:00',1.41),('11288','2013-07-31','18:55:00',1.3),('11288','2013-07-31','19:00:00',1.14),('11288','2014-04-08','07:50:00',1.11),('11288','2014-04-08','07:55:00',1.12),('11288','2014-04-08','08:00:00',1.15),('11288','2014-04-08','08:05:00',1.21),('11288','2014-04-08','08:10:00',1.25),('11288','2014-04-08','08:15:00',1.53),('11288','2014-04-08','08:20:00',1.93),('11288','2014-04-08','08:25:00',1.77),('11288','2014-04-08','08:30:00',1.77),('11288','2014-04-08','08:35:00',1.71),('11288','2014-04-08','08:40:00',1.99),('11288','2014-04-08','08:45:00',2.17),('11288','2014-04-08','08:50:00',2.26),('11288','2014-04-08','08:55:00',2.47),('11288','2014-04-08','09:00:00',2.56),('11288','2014-04-08','09:05:00',2.73),('11288','2014-04-08','09:10:00',2.84),('11288','2014-04-08','09:15:00',2.88),('11288','2014-04-08','09:20:00',2.86),('11288','2014-04-08','09:25:00',3.29),('11288','2014-04-08','09:30:00',3.41),('11288','2014-04-08','09:35:00',3.46),('11288','2014-04-08','09:40:00',3.57),('11288','2014-04-08','09:45:00',3.59),('11288','2014-04-08','09:50:00',3.75),('11288','2014-04-08','09:55:00',3.92),('11288','2014-04-08','10:00:00',4.05),('11288','2014-04-08','10:05:00',4.08),('11288','2014-04-08','10:10:00',4.35),('11288','2014-04-08','10:15:00',4.61),('11288','2014-04-08','10:20:00',4.74),('11288','2014-04-08','10:25:00',4.79),('11288','2014-04-08','10:30:00',4.91),('11288','2014-04-08','10:35:00',5.03),('11288','2014-04-08','10:40:00',5.11),('11288','2014-04-08','10:45:00',5.11),('11288','2014-04-08','10:50:00',5.26),('11288','2014-04-08','10:55:00',5.41),('11288','2014-04-08','11:00:00',5.42),('11288','2014-04-08','11:05:00',5.41),('11288','2014-04-08','11:10:00',5.45),('11288','2014-04-08','11:15:00',5.48),('11288','2014-04-08','11:20:00',5.61),('11288','2014-04-08','11:25:00',5.65),('11288','2014-04-08','11:30:00',5.72),('11288','2014-04-08','11:35:00',5.58),('11288','2014-04-08','11:40:00',5.77),('11288','2014-04-08','11:45:00',5.84),('11288','2014-04-08','11:50:00',5.83),('11288','2014-04-08','11:55:00',5.94),('11288','2014-04-08','12:00:00',6.06),('11288','2014-04-08','12:05:00',6.09),('11288','2014-04-08','12:10:00',5.85),('11288','2014-04-08','12:15:00',5.53),('11288','2014-04-08','12:20:00',5.55),('11288','2014-04-08','12:25:00',5.53),('11288','2014-04-08','12:30:00',6.53),('11288','2014-04-08','12:35:00',6.46),('11288','2014-04-08','12:40:00',5.41),('11288','2014-04-08','12:45:00',4.19),('11288','2014-04-08','12:50:00',5.68),('11288','2014-04-08','12:55:00',6.32),('11288','2014-04-08','13:00:00',6.1),('11288','2014-04-08','13:05:00',6.32),('11288','2014-04-08','13:10:00',6.46),('11288','2014-04-08','13:15:00',6.56),('11288','2014-04-08','13:20:00',6.51),('11288','2014-04-08','13:25:00',6.57),('11288','2014-04-08','13:30:00',6.53),('11288','2014-04-08','13:35:00',6.58),('11288','2014-04-08','13:40:00',6.53),('11288','2014-04-08','13:45:00',6.44),('11288','2014-04-08','13:50:00',6.44),('11288','2014-04-08','13:55:00',6.49),('11288','2014-04-08','14:00:00',6.44),('11288','2014-04-08','14:05:00',6.44),('11288','2014-04-08','14:10:00',6.39),('11288','2014-04-08','14:15:00',6.33),('11288','2014-04-08','14:20:00',5.9),('11288','2014-04-08','14:25:00',6.03),('11288','2014-04-08','14:30:00',6.41),('11288','2014-04-08','14:35:00',6.14),('11288','2014-04-08','14:40:00',5.34),('11288','2014-04-08','14:45:00',5.54),('11288','2014-04-08','14:50:00',5.96),('11288','2014-04-08','14:55:00',6.11),('11288','2014-04-08','15:00:00',5.93),('11288','2014-04-08','15:05:00',5.8),('11288','2014-04-08','15:10:00',5.82),('11288','2014-04-08','15:15:00',5.67),('11288','2014-04-08','15:20:00',5.55),('11288','2014-04-08','15:25:00',5.31),('11288','2014-04-08','15:30:00',5.09),('11288','2014-04-08','15:35:00',5.4),('11288','2014-04-08','15:40:00',5.28),('11288','2014-04-08','15:45:00',4.99),('11288','2014-04-08','15:50:00',5.04),('11288','2014-04-08','15:55:00',4.98),('11288','2014-04-08','16:00:00',4.75),('11288','2014-04-08','16:05:00',4.73),('11288','2014-04-08','16:10:00',4.54),('11288','2014-04-08','16:15:00',4.23),('11288','2014-04-08','16:20:00',3.9),('11288','2014-04-08','16:25:00',4.1),('11288','2014-04-08','16:30:00',4.33),('11288','2014-04-08','16:35:00',4.12),('11288','2014-04-08','16:40:00',3.91),('11288','2014-04-08','16:45:00',3.73),('11288','2014-04-08','16:50:00',3.72),('11288','2014-04-08','16:55:00',3.44),('11288','2014-04-08','17:00:00',3.2),('11288','2014-04-08','17:05:00',3.29),('11288','2014-04-08','17:10:00',3.06),('11288','2014-04-08','17:15:00',2.92),('11288','2014-04-08','17:20:00',2.79),('11288','2014-04-08','17:25:00',2.46),('11288','2014-04-08','17:30:00',2.33),('11288','2014-04-08','17:35:00',2.13),('11288','2014-04-08','17:40:00',2.07),('11288','2014-04-08','17:45:00',1.98),('11288','2014-04-08','17:50:00',1.89),('11288','2014-04-08','17:55:00',1.66),('11288','2014-04-08','18:00:00',1.64),('11288','2014-04-08','18:05:00',1.57),('11288','2014-04-08','18:10:00',1.4),('11288','2014-04-08','18:15:00',1.33),('11288','2014-04-08','18:20:00',1.17),('11288','2013-07-30','07:20:00',1.11),('11288','2013-07-30','07:25:00',1.37),('11288','2013-07-30','07:45:00',1.16),('11288','2013-07-30','07:50:00',1.35),('11288','2013-07-30','07:55:00',1.43),('11288','2013-07-30','08:00:00',1.57),('11288','2013-07-30','08:05:00',1.89),('11288','2013-07-30','08:10:00',2.03),('11288','2013-07-30','08:15:00',2.16),('11288','2013-07-30','08:20:00',2.43),('11288','2013-07-30','08:25:00',2.41),('11288','2013-07-30','08:30:00',2.42),('11288','2013-07-30','08:35:00',2.63),('11288','2013-07-30','08:40:00',2.7),('11288','2013-07-30','08:45:00',2.77),('11288','2013-07-30','08:50:00',3),('11288','2013-07-30','08:55:00',3.12),('11288','2013-07-30','09:00:00',3.17),('11288','2013-07-30','09:05:00',3.36),('11288','2013-07-30','09:10:00',3.48),('11288','2013-07-30','09:15:00',3.74),('11288','2013-07-30','09:20:00',3.52),('11288','2013-07-30','09:25:00',3.44),('11288','2013-07-30','09:30:00',4.22),('11288','2013-07-30','09:35:00',4.06),('11288','2013-07-30','09:40:00',3.81),('11288','2013-07-30','09:45:00',2.92),('11288','2013-07-30','09:50:00',1.75),('11288','2013-07-30','09:55:00',1.18),('11288','2013-07-30','10:00:00',1.05),('11288','2013-07-30','10:05:00',3.82),('11288','2013-07-30','10:10:00',5.56),('11288','2013-07-30','10:15:00',5.57),('11288','2013-07-30','10:20:00',5.7),('11288','2013-07-30','10:25:00',5.84),('11288','2013-07-30','10:30:00',5.81),('11288','2013-07-30','10:35:00',5.73),('11288','2013-07-30','10:40:00',5.7),('11288','2013-07-30','10:45:00',5.69),('11288','2013-07-30','10:50:00',5.65),('11288','2013-07-30','10:55:00',5.82),('11288','2013-07-30','11:00:00',6.08),('11288','2013-07-30','11:05:00',6.1),('11288','2013-07-30','11:10:00',6.16),('11288','2013-07-30','11:15:00',6.19),('11288','2013-07-30','11:20:00',6.29),('11288','2013-07-30','11:25:00',6.28),('11288','2013-07-30','11:30:00',6.26),('11288','2013-07-30','11:35:00',6.49),('11288','2013-07-30','11:40:00',6.4),('11288','2013-07-30','11:45:00',5.89),('11288','2013-07-30','11:50:00',3.98),('11288','2013-07-30','11:55:00',5.67),('11288','2013-07-30','12:00:00',6.53),('11288','2013-07-30','12:05:00',6.62),('11288','2013-07-30','12:10:00',6.28),('11288','2013-07-30','12:15:00',6.29),('11288','2013-07-30','12:20:00',6.6),('11288','2013-07-30','12:25:00',6.63),('11288','2013-07-30','12:30:00',6.58),('11288','2013-07-30','12:35:00',5.54),('11288','2013-07-30','12:40:00',4.28),('11288','2013-07-30','12:45:00',6.78),('11288','2013-07-30','12:50:00',7.03),('11288','2013-07-30','12:55:00',6.13),('11288','2013-07-30','13:00:00',5.96),('11288','2013-07-30','13:05:00',3.15),('11288','2013-07-30','13:10:00',3.94),('11288','2013-07-30','13:15:00',5.78),('11288','2013-07-30','13:20:00',7.14),('11288','2013-07-30','13:25:00',7.08),('11288','2013-07-30','13:30:00',6.97),('11288','2013-07-30','13:35:00',6.82),('11288','2013-07-30','13:40:00',6.97),('11288','2013-07-30','13:45:00',6.74),('11288','2013-07-30','13:50:00',6.73),('11288','2013-07-30','13:55:00',6.83),('11288','2013-07-30','14:00:00',5.4),('11288','2013-07-30','14:05:00',5.21),('11288','2013-07-30','14:10:00',6.18),('11288','2013-07-30','14:15:00',6.77),('11288','2013-07-30','14:20:00',6.23),('11288','2013-07-30','14:25:00',6),('11288','2013-07-30','14:30:00',6.59),('11288','2013-07-30','14:35:00',6.6),('11288','2013-07-30','14:40:00',6.34),('11288','2013-07-30','14:45:00',6.24),('11288','2013-07-30','14:50:00',6.11),('11288','2013-07-30','14:55:00',6.16),('11288','2013-07-30','15:00:00',6.16),('11288','2013-07-30','15:05:00',6.03),('11288','2013-07-30','15:10:00',5.92),('11288','2013-07-30','15:15:00',5.85),('11288','2013-07-30','15:20:00',5.82),('11288','2013-07-30','15:25:00',5.82),('11288','2013-07-30','15:30:00',5.73),('11288','2013-07-30','15:35:00',5.65),('11288','2013-07-30','15:40:00',5.61),('11288','2013-07-30','15:45:00',5.54),('11288','2013-07-30','15:50:00',5.45),('11288','2013-07-30','15:55:00',5.38),('11288','2013-07-30','16:00:00',5.34),('11288','2013-07-30','16:05:00',5.24),('11288','2013-07-30','16:10:00',5.15),('11288','2013-07-30','16:15:00',5.01),('11288','2013-07-30','16:20:00',4.95),('11288','2013-07-30','16:25:00',4.87),('11288','2013-07-30','16:30:00',4.73),('11288','2013-07-30','16:35:00',4.59),('11288','2013-07-30','16:40:00',4.57),('11288','2013-07-30','16:45:00',4.45),('11288','2013-07-30','16:50:00',4.32),('11288','2013-07-30','16:55:00',4.22),('11288','2013-07-30','17:00:00',4.1),('11288','2013-07-30','17:05:00',3.96),('11288','2013-07-30','17:10:00',3.82),('11288','2013-07-30','17:15:00',3.62),('11288','2013-07-30','17:20:00',3.49),('11288','2013-07-30','17:25:00',3.47),('11288','2013-07-30','17:30:00',3.33),('11288','2013-07-30','17:35:00',3.18),('11288','2013-07-30','17:40:00',3.08),('11288','2013-07-30','17:45:00',2.93),('11288','2013-07-30','17:50:00',2.78),('11288','2013-07-30','17:55:00',2.63),('11288','2013-07-30','18:00:00',2.49),('11288','2013-07-30','18:05:00',2.4),('11288','2013-07-30','18:10:00',2.37),('11288','2013-07-30','18:15:00',2.24),('11288','2013-07-30','18:20:00',2.12),('11288','2013-07-30','18:25:00',2.01),('11288','2013-07-30','18:30:00',1.85),('11288','2013-07-30','18:35:00',1.72),('11288','2013-07-30','18:40:00',1.58),('11288','2013-07-30','18:45:00',1.46),('11288','2013-07-30','18:50:00',1.31),('11288','2013-07-30','18:55:00',1.2),('11288','2013-07-30','19:00:00',1.09),('11288','2013-07-29','07:30:00',1.01),('11288','2013-07-29','07:35:00',1.1),('11288','2013-07-29','07:40:00',1.19),('11288','2013-07-29','07:45:00',1.28),('11288','2013-07-29','07:50:00',1.36),('11288','2013-07-29','07:55:00',1.51),('11288','2013-07-29','08:00:00',1.65),('11288','2013-07-29','08:05:00',1.77),('11288','2013-07-29','08:10:00',1.84),('11288','2013-07-29','08:15:00',1.91),('11288','2013-07-29','08:20:00',1.99),('11288','2013-07-29','08:25:00',2.11),('11288','2013-07-29','08:30:00',2.32),('11288','2013-07-29','08:35:00',2.5),('11288','2013-07-29','08:40:00',2.57),('11288','2013-07-29','08:45:00',2.65),('11288','2013-07-29','08:50:00',2.79),('11288','2013-07-29','08:55:00',2.9),('11288','2013-07-29','09:00:00',3.02),('11288','2013-07-29','09:05:00',3.14),('11288','2013-07-29','09:10:00',3.22),('11288','2013-07-29','09:15:00',3.44),('11288','2013-07-29','09:20:00',3.49),('11288','2013-07-29','09:25:00',3.61),('11288','2013-07-29','09:30:00',3.77),('11288','2013-07-29','09:35:00',3.82),('11288','2013-07-29','09:40:00',4.01),('11288','2013-07-29','09:45:00',4.23),('11288','2013-07-29','09:50:00',4.28),('11288','2013-07-29','09:55:00',4.31),('11288','2013-07-29','10:00:00',4.55),('11288','2013-07-29','10:05:00',4.67),('11288','2013-07-29','10:10:00',4.78),('11288','2013-07-29','10:15:00',4.84),('11288','2013-07-29','10:20:00',5.01),('11288','2013-07-29','10:25:00',5.1),('11288','2013-07-29','10:30:00',5.16),('11288','2013-07-29','10:35:00',5.26),('11288','2013-07-29','10:40:00',5.36),('11288','2013-07-29','10:45:00',5.37),('11288','2013-07-29','10:50:00',5.46),('11288','2013-07-29','10:55:00',5.51),('11288','2013-07-29','11:00:00',5.55),('11288','2013-07-29','11:05:00',5.65),('11288','2013-07-29','11:10:00',5.66),('11288','2013-07-29','11:15:00',5.71),('11288','2013-07-29','11:20:00',5.81),('11288','2013-07-29','11:25:00',5.84),('11288','2013-07-29','11:30:00',5.83),('11288','2013-07-29','11:35:00',5.9),('11288','2013-07-29','11:40:00',5.98),('11288','2013-07-29','11:45:00',5.93),('11288','2013-07-29','11:50:00',5.92),('11288','2013-07-29','11:55:00',5.96),('11288','2013-07-29','12:00:00',6.07),('11288','2013-07-29','12:05:00',6.15),('11288','2013-07-29','12:10:00',6.16),('11288','2013-07-29','12:15:00',6.13),('11288','2013-07-29','12:20:00',6.17),('11288','2013-07-29','12:25:00',6.19),('11288','2013-07-29','12:30:00',6.17),('11288','2013-07-29','12:35:00',6.19),('11288','2013-07-29','12:40:00',6.23),('11288','2013-07-29','12:45:00',6.25),('11288','2013-07-29','12:50:00',6.16),('11288','2013-07-29','12:55:00',6.11),('11288','2013-07-29','13:00:00',6.28),('11288','2013-07-29','13:05:00',6.18),('11288','2013-07-29','13:10:00',6.3),('11288','2013-07-29','13:15:00',6.36),('11288','2013-07-29','13:20:00',6.45),('11288','2013-07-29','13:25:00',6.5),('11288','2013-07-29','13:30:00',6.55),('11288','2013-07-29','13:35:00',6.51),('11288','2013-07-29','13:40:00',6.51),('11288','2013-07-29','13:45:00',6.55),('11288','2013-07-29','13:50:00',6.54),('11288','2013-07-29','13:55:00',6.52),('11288','2013-07-29','14:00:00',6.49),('11288','2013-07-29','14:05:00',6.45),('11288','2013-07-29','14:10:00',6.43),('11288','2013-07-29','14:15:00',6.45),('11288','2013-07-29','14:20:00',6.39),('11288','2013-07-29','14:25:00',6.31),('11288','2013-07-29','14:30:00',6.3),('11288','2013-07-29','14:35:00',6.25),('11288','2013-07-29','14:40:00',6.19),('11288','2013-07-29','14:45:00',6.16),('11288','2013-07-29','14:50:00',6.13),('11288','2013-07-29','14:55:00',6.1),('11288','2013-07-29','15:00:00',6.02),('11288','2013-07-29','15:05:00',5.98),('11288','2013-07-29','15:10:00',5.93),('11288','2013-07-29','15:15:00',5.86),('11288','2013-07-29','15:20:00',5.83),('11288','2013-07-29','15:25:00',5.79),('11288','2013-07-29','15:30:00',5.71),('11288','2013-07-29','15:35:00',5.69),('11288','2013-07-29','15:40:00',5.75),('11288','2013-07-29','15:45:00',5.82),('11288','2013-07-29','15:50:00',4.61),('11288','2013-07-29','15:55:00',3.22),('11288','2013-07-29','16:00:00',3.2),('11288','2013-07-29','16:05:00',4.94),('11288','2013-07-29','16:10:00',4.9),('11288','2013-07-29','16:15:00',3.95),('11288','2013-07-29','16:20:00',4.02),('11288','2013-07-29','16:25:00',4.56),('11288','2013-07-29','16:30:00',4.94),('11288','2013-07-29','16:35:00',3.89),('11288','2013-07-29','16:40:00',4.24),('11288','2013-07-29','16:45:00',4.87),('11288','2013-07-29','16:50:00',4.17),('11288','2013-07-29','16:55:00',2.93),('11288','2013-07-29','17:00:00',2.39),('11288','2013-07-29','17:05:00',3.38),('11288','2013-07-29','17:10:00',2.2),('11288','2013-07-29','17:15:00',1.97),('11288','2013-07-29','17:20:00',3.78),('11288','2013-07-29','17:25:00',3.35),('11288','2013-07-29','17:30:00',2.03),('11288','2013-07-29','17:35:00',1.48),('11288','2013-07-29','17:40:00',1.89),('11288','2013-07-29','17:45:00',2.98),('11288','2013-07-29','17:50:00',2.8),('11288','2013-07-29','17:55:00',2.52),('11288','2013-07-29','18:00:00',1.76),('11288','2013-07-29','18:05:00',1.34),('11288','2013-07-29','18:10:00',2.19),('11288','2013-07-29','18:15:00',1.9),('11288','2013-07-29','18:20:00',2.08),('11288','2013-07-29','18:25:00',2.02),('11288','2013-07-29','18:30:00',1.91),('11288','2013-07-29','18:35:00',1.66),('11288','2013-07-29','18:40:00',1.18),('11288','2013-07-29','18:50:00',1.01),('11288','2013-07-29','18:55:00',1.07),('11288','2013-07-29','19:00:00',1.37),('11288','2013-07-29','19:05:00',1.33),('11288','2013-07-29','19:10:00',1.02),('11288','2013-07-28','07:35:00',1.05),('11288','2013-07-28','07:40:00',1.18),('11288','2013-07-28','07:45:00',1.23),('11288','2013-07-28','07:50:00',1.32),('11288','2013-07-28','07:55:00',1.48),('11288','2013-07-28','08:00:00',1.57),('11288','2013-07-28','08:05:00',1.68),('11288','2013-07-28','08:10:00',1.79),('11288','2013-07-28','08:15:00',1.78),('11288','2013-07-28','08:20:00',1.86),('11288','2013-07-28','08:25:00',2.16),('11288','2013-07-28','08:30:00',2.3),('11288','2013-07-28','08:35:00',2.4),('11288','2013-07-28','08:40:00',2.55),('11288','2013-07-28','08:45:00',2.65),('11288','2013-07-28','08:50:00',2.71),('11288','2013-07-28','08:55:00',2.86),('11288','2013-07-28','09:00:00',2.91),('11288','2013-07-28','09:05:00',3.15),('11288','2013-07-28','09:10:00',3.26),('11288','2013-07-28','09:15:00',3.5),('11288','2013-07-28','09:20:00',3.56),('11288','2013-07-28','09:25:00',3.61),('11288','2013-07-28','09:30:00',3.77),('11288','2013-07-28','09:35:00',3.87),('11288','2013-07-28','09:40:00',4.04),('11288','2013-07-28','09:45:00',4.26),('11288','2013-07-28','09:50:00',4.32),('11288','2013-07-28','09:55:00',4.29),('11288','2013-07-28','10:00:00',4.59),('11288','2013-07-28','10:05:00',4.7),('11288','2013-07-28','10:10:00',4.84),('11288','2013-07-28','10:15:00',4.91),('11288','2013-07-28','10:20:00',5.02),('11288','2013-07-28','10:25:00',5.13),('11288','2013-07-28','10:30:00',5.2),('11288','2013-07-28','10:35:00',5.27),('11288','2013-07-28','10:40:00',5.3),('11288','2013-07-28','10:45:00',5.37),('11288','2013-07-28','10:50:00',5.41),('11288','2013-07-28','10:55:00',5.45),('11288','2013-07-28','11:00:00',5.53),('11288','2013-07-28','11:05:00',5.62),('11288','2013-07-28','11:10:00',5.64),('11288','2013-07-28','11:15:00',5.67),('11288','2013-07-28','11:20:00',5.71),('11288','2013-07-28','11:25:00',5.75),('11288','2013-07-28','11:30:00',5.82),('11288','2013-07-28','11:35:00',5.94),('11288','2013-07-28','11:40:00',5.95),('11288','2013-07-28','11:45:00',5.98),('11288','2013-07-28','11:50:00',5.93),('11288','2013-07-28','11:55:00',6),('11288','2013-07-28','12:00:00',6.09),('11288','2013-07-28','12:05:00',6.08),('11288','2013-07-28','12:10:00',6.07),('11288','2013-07-28','12:15:00',6.1),('11288','2013-07-28','12:20:00',6.07),('11288','2013-07-28','12:25:00',6.17),('11288','2013-07-28','12:30:00',6.2),('11288','2013-07-28','12:35:00',6.28),('11288','2013-07-28','12:40:00',6.35),('11288','2013-07-28','12:45:00',6.41),('11288','2013-07-28','12:50:00',6.07),('11288','2013-07-28','12:55:00',6.39),('11288','2013-07-28','13:00:00',6.34),('11288','2013-07-28','13:05:00',6.34),('11288','2013-07-28','13:10:00',6.34),('11288','2013-07-28','13:15:00',5.64),('11288','2013-07-28','13:20:00',6.49),('11288','2013-07-28','13:25:00',6.5),('11288','2013-07-28','13:30:00',6.41),('11288','2013-07-28','13:35:00',6.35),('11288','2013-07-28','13:40:00',6.41),('11288','2013-07-28','13:45:00',6.38),('11288','2013-07-28','13:50:00',6.32),('11288','2013-07-28','13:55:00',6.36),('11288','2013-07-28','14:00:00',6.38),('11288','2013-07-28','14:05:00',6.37),('11288','2013-07-28','14:10:00',6.42),('11288','2013-07-28','14:15:00',6.34),('11288','2013-07-28','14:20:00',6.3),('11288','2013-07-28','14:25:00',6.2),('11288','2013-07-28','14:30:00',6.15),('11288','2013-07-28','14:35:00',6.08),('11288','2013-07-28','14:40:00',6.09),('11288','2013-07-28','14:45:00',6),('11288','2013-07-28','14:50:00',6.02),('11288','2013-07-28','14:55:00',5.98),('11288','2013-07-28','15:00:00',5.95),('11288','2013-07-28','15:05:00',5.92),('11288','2013-07-28','15:10:00',5.84),('11288','2013-07-28','15:15:00',5.75),('11288','2013-07-28','15:20:00',5.72),('11288','2013-07-28','15:25:00',5.66),('11288','2013-07-28','15:30:00',5.56),('11288','2013-07-28','15:35:00',5.54),('11288','2013-07-28','15:40:00',5.51),('11288','2013-07-28','15:45:00',5.4),('11288','2013-07-28','15:50:00',5.38),('11288','2013-07-28','15:55:00',5.32),('11288','2013-07-28','16:00:00',5.31),('11288','2013-07-28','16:05:00',5.26),('11288','2013-07-28','16:10:00',5.13),('11288','2013-07-28','16:15:00',5.05),('11288','2013-07-28','16:20:00',4.98),('11288','2013-07-28','16:25:00',4.92),('11288','2013-07-28','16:30:00',4.83),('11288','2013-07-28','16:35:00',4.73),('11288','2013-07-28','16:40:00',4.6),('11288','2013-07-28','16:45:00',4.48),('11288','2013-07-28','16:50:00',4.39),('11288','2013-07-28','16:55:00',4.28),('11288','2013-07-28','17:00:00',4.13),('11288','2013-07-28','17:05:00',4.01),('11288','2013-07-28','17:10:00',3.84),('11288','2013-07-28','17:15:00',3.74),('11288','2013-07-28','17:20:00',3.64),('11288','2013-07-28','17:25:00',3.53),('11288','2013-07-28','17:30:00',3.4),('11288','2013-07-28','17:35:00',3.28),('11288','2013-07-28','17:40:00',3.15),('11288','2013-07-28','17:45:00',2.99),('11288','2013-07-28','17:50:00',2.86),('11288','2013-07-28','17:55:00',2.73),('11288','2013-07-28','18:00:00',2.59),('11288','2013-07-28','18:05:00',2.54),('11288','2013-07-28','18:10:00',2.43),('11288','2013-07-28','18:15:00',2.3),('11288','2013-07-28','18:20:00',2.16),('11288','2013-07-28','18:25:00',2.05),('11288','2013-07-28','18:30:00',1.9),('11288','2013-07-28','18:35:00',1.76),('11288','2013-07-28','18:40:00',1.63),('11288','2013-07-28','18:45:00',1.51),('11288','2013-07-28','18:50:00',1.39),('11288','2013-07-28','18:55:00',1.27),('11288','2013-07-28','19:00:00',1.12),('11288','2013-07-27','07:35:00',1.07),('11288','2013-07-27','07:40:00',1.18),('11288','2013-07-27','07:45:00',1.23),('11288','2013-07-27','07:50:00',1.35),('11288','2013-07-27','07:55:00',1.51),('11288','2013-07-27','08:00:00',1.64),('11288','2013-07-27','08:05:00',1.73),('11288','2013-07-27','08:10:00',1.84),('11288','2013-07-27','08:15:00',1.83),('11288','2013-07-27','08:20:00',1.96),('11288','2013-07-27','08:25:00',2.27),('11288','2013-07-27','08:30:00',2.35),('11288','2013-07-27','08:35:00',2.37),('11288','2013-07-27','08:40:00',2.69),('11288','2013-07-27','08:45:00',2.76),('11288','2013-07-27','08:50:00',2.83),('11288','2013-07-27','08:55:00',3.01),('11288','2013-07-27','09:00:00',2.93),('11288','2013-07-27','09:05:00',3.1),('11288','2013-07-27','09:10:00',3.38),('11288','2013-07-27','09:15:00',3.58),('11288','2013-07-27','09:20:00',3.62),('11288','2013-07-27','09:25:00',3.75),('11288','2013-07-27','09:30:00',3.85),('11288','2013-07-27','09:35:00',4.01),('11288','2013-07-27','09:40:00',4.07),('11288','2013-07-27','09:45:00',4.22),('11288','2013-07-27','09:50:00',4.3),('11288','2013-07-27','09:55:00',4.44),('11288','2013-07-27','10:00:00',4.65),('11288','2013-07-27','10:05:00',4.75),('11288','2013-07-27','10:10:00',4.87),('11288','2013-07-27','10:15:00',4.98),('11288','2013-07-27','10:20:00',5.13),('11288','2013-07-27','10:25:00',5.2),('11288','2013-07-27','10:30:00',5.24),('11288','2013-07-27','10:35:00',5.39),('11288','2013-07-27','10:40:00',5.43),('11288','2013-07-27','10:45:00',5.43),('11288','2013-07-27','10:50:00',5.51),('11288','2013-07-27','10:55:00',5.56),('11288','2013-07-27','11:00:00',5.66),('11288','2013-07-27','11:05:00',5.76),('11288','2013-07-27','11:10:00',5.84),('11288','2013-07-27','11:15:00',5.82),('11288','2013-07-27','11:20:00',5.95),('11288','2013-07-27','11:25:00',5.97),('11288','2013-07-27','11:30:00',5.98),('11288','2013-07-27','11:35:00',6.02),('11288','2013-07-27','11:40:00',6.07),('11288','2013-07-27','11:45:00',6.07),('11288','2013-07-27','11:50:00',6.1),('11288','2013-07-27','11:55:00',6.15),('11288','2013-07-27','12:00:00',6.2),('11288','2013-07-27','12:05:00',6.22),('11288','2013-07-27','12:10:00',6.26),('11288','2013-07-27','12:15:00',6.12),('11288','2013-07-27','12:20:00',6.08),('11288','2013-07-27','12:25:00',6.25),('11288','2013-07-27','12:30:00',6.33),('11288','2013-07-27','12:35:00',6.24),('11288','2013-07-27','12:40:00',6.2),('11288','2013-07-27','12:45:00',6.4),('11288','2013-07-27','12:50:00',6.43),('11288','2013-07-27','12:55:00',6.4),('11288','2013-07-27','13:00:00',6.39),('11288','2013-07-27','13:05:00',2.77),('11288','2013-07-27','13:10:00',3.95),('11288','2013-07-27','13:15:00',6.54),('11288','2013-07-27','13:20:00',6.66),('11288','2013-07-27','13:25:00',6.55),('11288','2013-07-27','13:30:00',6.53),('11288','2013-07-27','13:35:00',6.45),('11288','2013-07-27','13:40:00',6.29),('11288','2013-07-27','13:45:00',6.46),('11288','2013-07-27','13:50:00',6.35),('11288','2013-07-27','13:55:00',6.4),('11288','2013-07-27','14:00:00',6.31),('11288','2013-07-27','14:05:00',6.49),('11288','2013-07-27','14:10:00',6.55),('11288','2013-07-27','14:15:00',6.22),('11288','2013-07-27','14:20:00',6.3),('11288','2013-07-27','14:25:00',6.25),('11288','2013-07-27','14:30:00',6.18),('11288','2013-07-27','14:35:00',6.19),('11288','2013-07-27','14:40:00',6.1),('11288','2013-07-27','14:45:00',6.12),('11288','2013-07-27','14:50:00',6.11),('11288','2013-07-27','14:55:00',6.05),('11288','2013-07-27','15:00:00',5.98),('11288','2013-07-27','15:05:00',6.02),('11288','2013-07-27','15:10:00',5.9),('11288','2013-07-27','15:15:00',5.92),('11288','2013-07-27','15:20:00',5.86),('11288','2013-07-27','15:25:00',5.78),('11288','2013-07-27','15:30:00',5.75),('11288','2013-07-27','15:35:00',5.67),('11288','2013-07-27','15:40:00',5.57),('11288','2013-07-27','15:45:00',5.53),('11288','2013-07-27','15:50:00',5.45),('11288','2013-07-27','15:55:00',5.38),('11288','2013-07-27','16:00:00',5.33),('11288','2013-07-27','16:05:00',5.24),('11288','2013-07-27','16:10:00',5.15),('11288','2013-07-27','16:15:00',4.99),('11288','2013-07-27','16:20:00',4.95),('11288','2013-07-27','16:25:00',4.89),('11288','2013-07-27','16:30:00',4.82),('11288','2013-07-27','16:35:00',4.73),('11288','2013-07-27','16:40:00',4.6),('11288','2013-07-27','16:45:00',4.49),('11288','2013-07-27','16:50:00',4.41),('11288','2013-07-27','16:55:00',4.28),('11288','2013-07-27','17:00:00',4.1),('11288','2013-07-27','17:05:00',4.03),('11288','2013-07-27','17:10:00',3.84),('11288','2013-07-27','17:15:00',3.76),('11288','2013-07-27','17:20:00',3.62),('11288','2013-07-27','17:25:00',3.49),('11288','2013-07-27','17:30:00',3.38),('11288','2013-07-27','17:35:00',3.25),('11288','2013-07-27','17:40:00',3.12),('11288','2013-07-27','17:45:00',2.98),('11288','2013-07-27','17:50:00',2.85),('11288','2013-07-27','17:55:00',2.74),('11288','2013-07-27','18:00:00',2.63),('11288','2013-07-27','18:05:00',2.59),('11288','2013-07-27','18:10:00',2.51),('11288','2013-07-27','18:15:00',2.36),('11288','2013-07-27','18:20:00',2.22),('11288','2013-07-27','18:25:00',2.1),('11288','2013-07-27','18:30:00',1.97),('11288','2013-07-27','18:35:00',1.84),('11288','2013-07-27','18:40:00',1.7),('11288','2013-07-27','18:45:00',1.59),('11288','2013-07-27','18:50:00',1.47),('11288','2013-07-27','18:55:00',1.34),('11288','2013-07-27','19:00:00',1.21),('11288','2013-07-27','19:05:00',1.06),('11288','2013-07-26','07:30:00',1.02),('11288','2013-07-26','07:35:00',1.14),('11288','2013-07-26','07:40:00',1.25),('11288','2013-07-26','07:45:00',1.32),('11288','2013-07-26','07:50:00',1.4),('11288','2013-07-26','07:55:00',1.51),('11288','2013-07-26','08:00:00',1.63),('11288','2013-07-26','08:05:00',1.81),('11288','2013-07-26','08:10:00',1.92),('11288','2013-07-26','08:15:00',1.91),('11288','2013-07-26','08:20:00',1.99),('11288','2013-07-26','08:25:00',2.24),('11288','2013-07-26','08:30:00',2.39),('11288','2013-07-26','08:35:00',2.41),('11288','2013-07-26','08:40:00',2.69),('11288','2013-07-26','08:45:00',2.77),('11288','2013-07-26','08:50:00',2.87),('11288','2013-07-26','08:55:00',3.03),('11288','2013-07-26','09:00:00',2.99),('11288','2013-07-26','09:05:00',3.02),('11288','2013-07-26','09:10:00',3.28),('11288','2013-07-26','09:15:00',3.46),('11288','2013-07-26','09:20:00',3.57),('11288','2013-07-26','09:25:00',3.71),('11288','2013-07-26','09:30:00',3.91),('11288','2013-07-26','09:35:00',3.83),('11288','2013-07-26','09:40:00',4.11),('11288','2013-07-26','09:45:00',4.2),('11288','2013-07-26','09:50:00',4.19),('11288','2013-07-26','09:55:00',3.5),('11288','2013-07-26','10:00:00',4.37),('11288','2013-07-26','10:05:00',4.61),('11288','2013-07-26','10:10:00',4.71),('11288','2013-07-26','10:15:00',4.87),('11288','2013-07-26','10:20:00',4.95),('11288','2013-07-26','10:25:00',5),('11288','2013-07-26','10:30:00',5.12),('11288','2013-07-26','10:35:00',5.28),('11288','2013-07-26','10:40:00',5.34),('11288','2013-07-26','10:45:00',5.41),('11288','2013-07-26','10:50:00',5.29),('11288','2013-07-26','10:55:00',5.63),('11288','2013-07-26','11:00:00',5.19),('11288','2013-07-26','11:05:00',5.43),('11288','2013-07-26','11:10:00',5.82),('11288','2013-07-26','11:15:00',5.37),('11288','2013-07-26','11:20:00',5.57),('11288','2013-07-26','11:25:00',5.98),('11288','2013-07-26','11:30:00',6.08),('11288','2013-07-26','11:35:00',6.02),('11288','2013-07-26','11:40:00',6.02),('11288','2013-07-26','11:45:00',6.21),('11288','2013-07-26','11:50:00',6.38),('11288','2013-07-26','11:55:00',6.19),('11288','2013-07-26','12:00:00',5.97),('11288','2013-07-26','12:05:00',6.3),('11288','2013-07-26','12:10:00',6.21),('11288','2013-07-26','12:15:00',5.48),('11288','2013-07-26','12:20:00',6.63),('11288','2013-07-26','12:25:00',6.41),('11288','2013-07-26','12:30:00',6.12),('11288','2013-07-26','12:35:00',6.42),('11288','2013-07-26','12:40:00',6.79),('11288','2013-07-26','12:45:00',6.79),('11288','2013-07-26','12:50:00',6.85),('11288','2013-07-26','12:55:00',5.8),('11288','2013-07-26','13:00:00',4.97),('11288','2013-07-26','13:05:00',2.12),('11288','2013-07-26','13:10:00',2.9),('11288','2013-07-26','13:15:00',2.92),('11288','2013-07-26','13:20:00',2.44),('11288','2013-07-26','13:25:00',3.08),('11288','2013-07-26','13:30:00',6.76),('11288','2013-07-26','13:35:00',7.14),('11288','2013-07-26','13:40:00',6.87),('11288','2013-07-26','13:45:00',6.04),('11288','2013-07-26','13:50:00',3.63),('11288','2013-07-26','13:55:00',7.11),('11288','2013-07-26','14:00:00',6.91),('11288','2013-07-26','14:05:00',6.59),('11288','2013-07-26','14:10:00',6.78),('11288','2013-07-26','14:15:00',6.47),('11288','2013-07-26','14:20:00',6.48),('11288','2013-07-26','14:25:00',6.42),('11288','2013-07-26','14:30:00',6.39),('11288','2013-07-26','14:35:00',6.39),('11288','2013-07-26','14:40:00',6.26),('11288','2013-07-26','14:45:00',6.26),('11288','2013-07-26','14:50:00',6.16),('11288','2013-07-26','14:55:00',6.14),('11288','2013-07-26','15:00:00',6.12),('11288','2013-07-26','15:05:00',6.04),('11288','2013-07-26','15:10:00',5.99),('11288','2013-07-26','15:15:00',5.99),('11288','2013-07-26','15:20:00',5.88),('11288','2013-07-26','15:25:00',5.79),('11288','2013-07-26','15:30:00',5.73),('11288','2013-07-26','15:35:00',5.71),('11288','2013-07-26','15:40:00',5.74),('11288','2013-07-26','15:45:00',5.62),('11288','2013-07-26','15:50:00',5.56),('11288','2013-07-26','15:55:00',5.49),('11288','2013-07-26','16:00:00',5.41),('11288','2013-07-26','16:05:00',5.33),('11288','2013-07-26','16:10:00',5.24),('11288','2013-07-26','16:15:00',5.11),('11288','2013-07-26','16:20:00',5.02),('11288','2013-07-26','16:25:00',4.93),('11288','2013-07-26','16:30:00',4.87),('11288','2013-07-26','16:35:00',4.76),('11288','2013-07-26','16:40:00',4.6),('11288','2013-07-26','16:45:00',4.51),('11288','2013-07-26','16:50:00',4.41),('11288','2013-07-26','16:55:00',4.26),('11288','2013-07-26','17:00:00',4.12),('11288','2013-07-26','17:05:00',4),('11288','2013-07-26','17:10:00',3.85),('11288','2013-07-26','17:15:00',3.77),('11288','2013-07-26','17:20:00',3.62),('11288','2013-07-26','17:25:00',3.54),('11288','2013-07-26','17:30:00',3.39),('11288','2013-07-26','17:35:00',3.22),('11288','2013-07-26','17:40:00',3.1),('11288','2013-07-26','17:45:00',2.96),('11288','2013-07-26','17:50:00',2.76),('11288','2013-07-26','17:55:00',2.61),('11288','2013-07-26','18:00:00',2.53),('11288','2013-07-26','18:05:00',2.52),('11288','2013-07-26','18:10:00',2.37),('11288','2013-07-26','18:15:00',2.2),('11288','2013-07-26','18:20:00',2.12),('11288','2013-07-26','18:25:00',2.04),('11288','2013-07-26','18:30:00',1.91),('11288','2013-07-26','18:35:00',1.76),('11288','2013-07-26','18:40:00',1.62),('11288','2013-07-26','18:45:00',1.49),('11288','2013-07-26','18:50:00',1.4),('11288','2013-07-26','18:55:00',1.27),('11288','2013-07-26','19:00:00',1.15),('11288','2013-07-26','19:05:00',1.02),('11288','2013-07-25','07:30:00',1.05),('11288','2013-07-25','07:35:00',1.14),('11288','2013-07-25','07:40:00',1.24),('11288','2013-07-25','07:45:00',1.34),('11288','2013-07-25','07:50:00',1.41),('11288','2013-07-25','07:55:00',1.56),('11288','2013-07-25','08:00:00',1.64),('11288','2013-07-25','08:05:00',1.79),('11288','2013-07-25','08:10:00',1.89),('11288','2013-07-25','08:15:00',1.92),('11288','2013-07-25','08:20:00',2.01),('11288','2013-07-25','08:25:00',2.24),('11288','2013-07-25','08:30:00',2.3),('11288','2013-07-25','08:35:00',2.51),('11288','2013-07-25','08:40:00',2.6),('11288','2013-07-25','08:45:00',2.8),('11288','2013-07-25','08:50:00',2.86),('11288','2013-07-25','08:55:00',3.09),('11288','2013-07-25','09:00:00',3.06),('11288','2013-07-25','09:05:00',3.22),('11288','2013-07-25','09:10:00',3.53),('11288','2013-07-25','09:15:00',3.63),('11288','2013-07-25','09:20:00',1.88),('11288','2013-07-25','09:25:00',3.98),('11288','2013-07-25','09:30:00',4.58),('11288','2013-07-25','09:35:00',3.77),('11288','2013-07-25','09:40:00',3.72),('11288','2013-07-25','09:45:00',2.19),('11288','2013-07-25','09:50:00',4.09),('11288','2013-07-25','09:55:00',1.76),('11288','2013-07-25','10:00:00',3.98),('11288','2013-07-25','10:05:00',4.74),('11288','2013-07-25','10:10:00',4.95),('11288','2013-07-25','10:15:00',4.88),('11288','2013-07-25','10:20:00',3.28),('11288','2013-07-25','10:25:00',5.31),('11288','2013-07-25','10:30:00',4.41),('11288','2013-07-25','10:35:00',5.2),('11288','2013-07-25','10:40:00',5.85),('11288','2013-07-25','10:45:00',5.86),('11288','2013-07-25','10:50:00',5.86),('11288','2013-07-25','10:55:00',5.9),('11288','2013-07-25','11:00:00',6.13),('11288','2013-07-25','11:05:00',5.88),('11288','2013-07-25','11:10:00',6.12),('11288','2013-07-25','11:15:00',6.31),('11288','2013-07-25','11:20:00',6.3),('11288','2013-07-25','11:25:00',6.32),('11288','2013-07-25','11:30:00',6.46),('11288','2013-07-25','11:35:00',5.5),('11288','2013-07-25','11:40:00',3.99),('11288','2013-07-25','11:45:00',2.98),('11288','2013-07-25','11:50:00',7),('11288','2013-07-25','11:55:00',6.91),('11288','2013-07-25','12:00:00',5.19),('11288','2013-07-25','12:05:00',1.65),('11288','2013-07-25','12:10:00',4.01),('11288','2013-07-25','12:15:00',4.28),('11288','2013-07-25','12:20:00',6.09),('11288','2013-07-25','12:25:00',7.35),('11288','2013-07-25','12:30:00',7.24),('11288','2013-07-25','12:35:00',6.37),('11288','2013-07-25','12:40:00',6.77),('11288','2013-07-25','12:45:00',4.85),('11288','2013-07-25','12:50:00',6.92),('11288','2013-07-25','12:55:00',7.05),('11288','2013-07-25','13:00:00',6.9),('11288','2013-07-25','13:05:00',6.93),('11288','2013-07-25','13:10:00',7),('11288','2013-07-25','13:15:00',6.86),('11288','2013-07-25','13:20:00',6.8),('11288','2013-07-25','13:25:00',6.7),('11288','2013-07-25','13:30:00',6.84),('11288','2013-07-25','13:35:00',6.87),('11288','2013-07-25','13:40:00',6.81),('11288','2013-07-25','13:45:00',6.84),('11288','2013-07-25','13:50:00',6.89),('11288','2013-07-25','13:55:00',6.81),('11288','2013-07-25','14:00:00',6.82),('11288','2013-07-25','14:05:00',6.79),('11288','2013-07-25','14:10:00',6.75),('11288','2013-07-25','14:15:00',6.71),('11288','2013-07-25','14:20:00',6.69),('11288','2013-07-25','14:25:00',6.64),('11288','2013-07-25','14:30:00',6.63),('11288','2013-07-25','14:35:00',6.59),('11288','2013-07-25','14:40:00',6.57),('11288','2013-07-25','14:45:00',6.51),('11288','2013-07-25','14:50:00',6.47),('11288','2013-07-25','14:55:00',6.38),('11288','2013-07-25','15:00:00',6.37),('11288','2013-07-25','15:05:00',6.3),('11288','2013-07-25','15:10:00',6.24),('11288','2013-07-25','15:15:00',6.18),('11288','2013-07-25','15:20:00',6.14),('11288','2013-07-25','15:25:00',6.07),('11288','2013-07-25','15:30:00',6.04),('11288','2013-07-25','15:35:00',5.98),('11288','2013-07-25','15:40:00',5.92),('11288','2013-07-25','15:45:00',5.85),('11288','2013-07-25','15:50:00',5.77),('11288','2013-07-25','15:55:00',5.68),('11288','2013-07-25','16:00:00',5.62),('11288','2013-07-25','16:05:00',5.54),('11288','2013-07-25','16:10:00',5.46),('11288','2013-07-25','16:15:00',5.33),('11288','2013-07-25','16:20:00',5.22),('11288','2013-07-25','16:25:00',5.11),('11288','2013-07-25','16:30:00',4.98),('11288','2013-07-25','16:35:00',4.93),('11288','2013-07-25','16:40:00',4.75),('11288','2013-07-25','16:45:00',4.75),('11288','2013-07-25','16:50:00',4.6),('11288','2013-07-25','16:55:00',4.47),('11288','2013-07-25','17:00:00',4.35),('11288','2013-07-25','17:05:00',4.19),('11288','2013-07-25','17:10:00',3.96),('11288','2013-07-25','17:15:00',4.01),('11288','2013-07-25','17:20:00',3.84),('11288','2013-07-25','17:25:00',3.77),('11288','2013-07-25','17:30:00',3.62),('11288','2013-07-25','17:35:00',3.47),('11288','2013-07-25','17:40:00',3.3),('11288','2013-07-25','17:45:00',3.19),('11288','2013-07-25','17:50:00',3),('11288','2013-07-25','17:55:00',2.91),('11288','2013-07-25','18:00:00',2.85),('11288','2013-07-25','18:05:00',2.75),('11288','2013-07-25','18:10:00',2.6),('11288','2013-07-25','18:15:00',2.43),('11288','2013-07-25','18:20:00',2.3),('11288','2013-07-25','18:25:00',2.14),('11288','2013-07-25','18:30:00',2.03),('11288','2013-07-25','18:35:00',1.86),('11288','2013-07-25','18:40:00',1.66),('11288','2013-07-25','18:45:00',1.64),('11288','2013-07-25','18:50:00',1.48),('11288','2013-07-25','18:55:00',1.35),('11288','2013-07-25','19:00:00',1.23),('11288','2013-07-25','19:05:00',1.08),('11288','2013-07-24','07:40:00',1.26),('11288','2013-07-24','07:45:00',1.19),('11288','2013-07-24','07:50:00',1.44),('11288','2013-07-24','07:55:00',1.51),('11288','2013-07-24','08:00:00',1.61),('11288','2013-07-24','08:05:00',1.76),('11288','2013-07-24','08:10:00',1.65),('11288','2013-07-24','08:15:00',2.07),('11288','2013-07-24','08:20:00',1.78),('11288','2013-07-24','08:25:00',2.1),('11288','2013-07-24','08:30:00',2.01),('11288','2013-07-24','08:35:00',2.07),('11288','2013-07-24','08:40:00',2.05),('11288','2013-07-24','08:45:00',3.01),('11288','2013-07-24','08:50:00',3.05),('11288','2013-07-24','08:55:00',3.21),('11288','2013-07-24','09:00:00',2.56),('11288','2013-07-24','09:05:00',3.57),('11288','2013-07-24','09:10:00',2.85),('11288','2013-07-24','09:15:00',2.37),('11288','2013-07-24','09:20:00',3.39),('11288','2013-07-24','09:25:00',3.58),('11288','2013-07-24','09:30:00',4.02),('11288','2013-07-24','09:35:00',3.15),('11288','2013-07-24','09:40:00',2.46),('11288','2013-07-24','09:45:00',3.08),('11288','2013-07-24','09:50:00',2.37),('11288','2013-07-24','09:55:00',2.1),('11288','2013-07-24','10:00:00',1.37),('11288','2013-07-24','10:05:00',1.34),('11288','2013-07-24','10:10:00',2.77),('11288','2013-07-24','10:15:00',2.35),('11288','2013-07-24','10:20:00',4.11),('11288','2013-07-24','10:25:00',5.85),('11288','2013-07-24','10:30:00',5.85),('11288','2013-07-24','10:35:00',5.99),('11288','2013-07-24','10:40:00',3.1),('11288','2013-07-24','10:45:00',3.35),('11288','2013-07-24','10:50:00',4.16),('11288','2013-07-24','10:55:00',4.38),('11288','2013-07-24','11:00:00',2.33),('11288','2013-07-24','11:05:00',4.85),('11288','2013-07-24','11:10:00',6.52),('11288','2013-07-24','11:15:00',6.46),('11288','2013-07-24','11:20:00',6.2),('11288','2013-07-24','11:25:00',5.52),('11288','2013-07-24','11:30:00',2.95),('11288','2013-07-24','11:35:00',4.29),('11288','2013-07-24','11:40:00',6.61),('11288','2013-07-24','11:45:00',6.59),('11288','2013-07-24','11:50:00',6.53),('11288','2013-07-24','11:55:00',6.73),('11288','2013-07-24','12:00:00',6.5),('11288','2013-07-24','12:05:00',5.4),('11288','2013-07-24','12:10:00',7.27),('11288','2013-07-24','12:15:00',5.95),('11288','2013-07-24','12:20:00',5.27),('11288','2013-07-24','12:25:00',3.66),('11288','2013-07-24','12:30:00',2.51),('11288','2013-07-24','12:35:00',5),('11288','2013-07-24','12:40:00',7.62),('11288','2013-07-24','12:45:00',4.88),('11288','2013-07-24','12:50:00',5.94),('11288','2013-07-24','12:55:00',7.25),('11288','2013-07-24','13:00:00',7.11),('11288','2013-07-24','13:05:00',6.63),('11288','2013-07-24','13:10:00',6.89),('11288','2013-07-24','13:15:00',6.05),('11288','2013-07-24','13:20:00',4.67),('11288','2013-07-24','13:25:00',5.65),('11288','2013-07-24','13:30:00',6.27),('11288','2013-07-24','13:35:00',3.04),('11288','2013-07-24','13:40:00',1.78),('11288','2013-07-24','13:45:00',5.86),('11288','2013-07-24','13:50:00',7.58),('11288','2013-07-24','13:55:00',4.71),('11288','2013-07-24','14:00:00',7.04),('11288','2013-07-24','14:05:00',6.56),('11288','2013-07-24','14:10:00',7.25),('11288','2013-07-24','14:15:00',6.48),('11288','2013-07-24','14:20:00',6.93),('11288','2013-07-24','14:25:00',6.96),('11288','2013-07-24','14:30:00',7),('11288','2013-07-24','14:35:00',7.05),('11288','2013-07-24','14:40:00',6.47),('11288','2013-07-24','14:45:00',6.74),('11288','2013-07-24','14:50:00',6.65),('11288','2013-07-24','14:55:00',6.6),('11288','2013-07-24','15:00:00',6.54),('11288','2013-07-24','15:05:00',6.41),('11288','2013-07-24','15:10:00',6.32),('11288','2013-07-24','15:15:00',6.38),('11288','2013-07-24','15:20:00',6.29),('11288','2013-07-24','15:25:00',6.25),('11288','2013-07-24','15:30:00',5.93),('11288','2013-07-24','15:35:00',5.8),('11288','2013-07-24','15:40:00',5.98),('11288','2013-07-24','15:45:00',5.84),('11288','2013-07-24','15:50:00',5.73),('11288','2013-07-24','15:55:00',5.74),('11288','2013-07-24','16:00:00',5.66),('11288','2013-07-24','16:05:00',5.51),('11288','2013-07-24','16:10:00',5.55),('11288','2013-07-24','16:15:00',5.4),('11288','2013-07-24','16:20:00',5.44),('11288','2013-07-24','16:25:00',5.33),('11288','2013-07-24','16:30:00',5.27),('11288','2013-07-24','16:35:00',5.14),('11288','2013-07-24','16:40:00',5.04),('11288','2013-07-24','16:45:00',4.82),('11288','2013-07-24','16:50:00',4.82),('11288','2013-07-24','16:55:00',4.87),('11288','2013-07-24','17:00:00',4.73),('11288','2013-07-24','17:05:00',4.54),('11288','2013-07-24','17:10:00',4.2),('11288','2013-07-24','17:15:00',4.16),('11288','2013-07-24','17:20:00',3.97),('11288','2013-07-24','17:25:00',3.81),('11288','2013-07-24','17:30:00',3.68),('11288','2013-07-24','17:35:00',3.5),('11288','2013-07-24','17:40:00',3.31),('11288','2013-07-24','17:45:00',3.14),('11288','2013-07-24','17:50:00',2.98),('11288','2013-07-24','17:55:00',2.87),('11288','2013-07-24','18:00:00',2.8),('11288','2013-07-24','18:05:00',2.69),('11288','2013-07-24','18:10:00',2.54),('11288','2013-07-24','18:15:00',2.37),('11288','2013-07-24','18:20:00',2.21),('11288','2013-07-24','18:25:00',2),('11288','2013-07-24','18:30:00',2),('11288','2013-07-24','18:35:00',1.93),('11288','2013-07-24','18:40:00',1.76),('11288','2013-07-24','18:45:00',1.65),('11288','2013-07-24','18:50:00',1.44),('11288','2013-07-24','18:55:00',1.33),('11288','2013-07-24','19:00:00',1.24),('11288','2013-07-24','19:05:00',1.06),('11288','2013-07-23','07:30:00',1.06),('11288','2013-07-23','07:35:00',1.18),('11288','2013-07-23','07:40:00',1.27),('11288','2013-07-23','07:45:00',1.36),('11288','2013-07-23','07:50:00',1.44),('11288','2013-07-23','07:55:00',1.48),('11288','2013-07-23','08:00:00',1.67),('11288','2013-07-23','08:05:00',1.86),('11288','2013-07-23','08:10:00',1.94),('11288','2013-07-23','08:15:00',2.04),('11288','2013-07-23','08:20:00',2.14),('11288','2013-07-23','08:25:00',2.25),('11288','2013-07-23','08:30:00',2.43),('11288','2013-07-23','08:35:00',2.57),('11288','2013-07-23','08:40:00',2.8),('11288','2013-07-23','08:45:00',2.87),('11288','2013-07-23','08:50:00',3.03),('11288','2013-07-23','08:55:00',3.19),('11288','2013-07-23','09:00:00',3.35),('11288','2013-07-23','09:05:00',3.38),('11288','2013-07-23','09:10:00',3.6),('11288','2013-07-23','09:15:00',3.64),('11288','2013-07-23','09:20:00',3.78),('11288','2013-07-23','09:25:00',3.92),('11288','2013-07-23','09:30:00',3.94),('11288','2013-07-23','09:35:00',4.21),('11288','2013-07-23','09:40:00',4.24),('11288','2013-07-23','09:45:00',4.28),('11288','2013-07-23','09:50:00',4.38),('11288','2013-07-23','09:55:00',4.55),('11288','2013-07-23','10:00:00',4.49),('11288','2013-07-23','10:05:00',4.67),('11288','2013-07-23','10:10:00',4.91),('11288','2013-07-23','10:15:00',4.94),('11288','2013-07-23','10:20:00',5.2),('11288','2013-07-23','10:25:00',5.37),('11288','2013-07-23','10:30:00',5.51),('11288','2013-07-23','10:35:00',5.61),('11288','2013-07-23','10:40:00',5.68),('11288','2013-07-23','10:45:00',5.74),('11288','2013-07-23','10:50:00',5.82),('11288','2013-07-23','10:55:00',5.94),('11288','2013-07-23','11:00:00',6.01),('11288','2013-07-23','11:05:00',6.03),('11288','2013-07-23','11:10:00',6.1),('11288','2013-07-23','11:15:00',6.21),('11288','2013-07-23','11:20:00',6.19),('11288','2013-07-23','11:25:00',6.21),('11288','2013-07-23','11:30:00',6.26),('11288','2013-07-23','11:35:00',6.35),('11288','2013-07-23','11:40:00',6.42),('11288','2013-07-23','11:45:00',6.46),('11288','2013-07-23','11:50:00',6.53),('11288','2013-07-23','11:55:00',6.6),('11288','2013-07-23','12:00:00',6.7),('11288','2013-07-23','12:05:00',6.68),('11288','2013-07-23','12:10:00',6.78),('11288','2013-07-23','12:15:00',6.88),('11288','2013-07-23','12:20:00',6.87),('11288','2013-07-23','12:25:00',6.21),('11288','2013-07-23','12:30:00',5.76),('11288','2013-07-23','12:35:00',1.76),('11288','2013-07-23','12:40:00',1.43),('11288','2013-07-23','12:45:00',2.83),('11288','2013-07-23','12:50:00',2.66),('11288','2013-07-23','12:55:00',6.26),('11288','2013-07-23','13:00:00',3.03),('11288','2013-07-23','13:05:00',1.57),('11288','2013-07-23','13:10:00',1.3),('11288','2013-07-23','13:15:00',1.04),('11288','2013-07-23','13:20:00',1.1),('11288','2013-07-23','13:25:00',1.34),('11288','2013-07-23','13:30:00',1.7),('11288','2013-07-23','13:35:00',6.98),('11288','2013-07-23','13:40:00',2.97),('11288','2013-07-23','13:45:00',1.05),('11288','2013-07-23','13:50:00',1.25),('11288','2013-07-23','13:55:00',2.63),('11288','2013-07-23','14:00:00',6.42),('11288','2013-07-23','14:05:00',7.13),('11288','2013-07-23','14:10:00',1.33),('11288','2013-07-23','14:20:00',1),('11288','2013-07-23','14:25:00',3.12),('11288','2013-07-23','14:30:00',4.62),('11288','2013-07-23','14:35:00',2.78),('11288','2013-07-23','14:40:00',2.45),('11288','2013-07-23','14:45:00',5.38),('11288','2013-07-23','14:50:00',4.85),('11288','2013-07-23','14:55:00',6.04),('11288','2013-07-23','15:00:00',7.42),('11288','2013-07-23','15:05:00',5.99),('11288','2013-07-23','15:10:00',6.52),('11288','2013-07-23','15:15:00',6.43),('11288','2013-07-23','15:20:00',6.27),('11288','2013-07-23','15:25:00',6.19),('11288','2013-07-23','15:30:00',6.14),('11288','2013-07-23','15:35:00',6.05),('11288','2013-07-23','15:40:00',5.72),('11288','2013-07-23','15:45:00',5.67),('11288','2013-07-23','15:50:00',5.69),('11288','2013-07-23','15:55:00',5.65),('11288','2013-07-23','16:00:00',5.52),('11288','2013-07-23','16:05:00',5.45),('11288','2013-07-23','16:10:00',5.34),('11288','2013-07-23','16:15:00',5.22),('11288','2013-07-23','16:20:00',5.17),('11288','2013-07-23','16:25:00',5.1),('11288','2013-07-23','16:30:00',4.99),('11288','2013-07-23','16:35:00',4.88),('11288','2013-07-23','16:40:00',4.74),('11288','2013-07-23','16:45:00',4.67),('11288','2013-07-23','16:50:00',4.59),('11288','2013-07-23','16:55:00',4.47),('11288','2013-07-23','17:00:00',4.31),('11288','2013-07-23','17:05:00',4.09),('11288','2013-07-23','17:10:00',4.05),('11288','2013-07-23','17:15:00',3.98),('11288','2013-07-23','17:20:00',3.86),('11288','2013-07-23','17:25:00',3.76),('11288','2013-07-23','17:30:00',3.64),('11288','2013-07-23','17:35:00',3.53),('11288','2013-07-23','17:40:00',3.36),('11288','2013-07-23','17:45:00',3.23),('11288','2013-07-23','17:50:00',3.09),('11288','2013-07-23','17:55:00',2.99),('11288','2013-07-23','18:00:00',2.97),('11288','2013-07-23','18:05:00',2.83),('11288','2013-07-23','18:10:00',2.64),('11288','2013-07-23','18:15:00',2.51),('11288','2013-07-23','18:20:00',2.43),('11288','2013-07-23','18:25:00',2.29),('11288','2013-07-23','18:30:00',2.16),('11288','2013-07-23','18:35:00',2),('11288','2013-07-23','18:40:00',1.55),('11288','2013-07-23','18:45:00',1.17),('11288','2013-07-23','18:50:00',1.14),('11288','2013-07-23','18:55:00',1.32),('11288','2013-07-23','19:00:00',1.25),('11288','2013-07-23','19:05:00',1.12),('11288','2013-07-22','07:30:00',1.08),('11288','2013-07-22','07:35:00',1.18),('11288','2013-07-22','07:40:00',1.27),('11288','2013-07-22','07:45:00',1.37),('11288','2013-07-22','07:50:00',1.43),('11288','2013-07-22','07:55:00',1.49),('11288','2013-07-22','08:00:00',1.7),('11288','2013-07-22','08:05:00',1.87),('11288','2013-07-22','08:10:00',1.99),('11288','2013-07-22','08:15:00',2.02),('11288','2013-07-22','08:20:00',2.14),('11288','2013-07-22','08:25:00',2.23),('11288','2013-07-22','08:30:00',2.45),('11288','2013-07-22','08:35:00',2.65),('11288','2013-07-22','08:40:00',2.83),('11288','2013-07-22','08:45:00',2.93),('11288','2013-07-22','08:50:00',3.06),('11288','2013-07-22','08:55:00',3.2),('11288','2013-07-22','09:00:00',3.31),('11288','2013-07-22','09:05:00',3.42),('11288','2013-07-22','09:10:00',3.7),('11288','2013-07-22','09:15:00',3.71),('11288','2013-07-22','09:20:00',3.81),('11288','2013-07-22','09:25:00',3.97),('11288','2013-07-22','09:30:00',4.06),('11288','2013-07-22','09:35:00',4.28),('11288','2013-07-22','09:40:00',4.34),('11288','2013-07-22','09:45:00',4.41),('11288','2013-07-22','09:50:00',4.49),('11288','2013-07-22','09:55:00',4.59),('11288','2013-07-22','10:00:00',4.7),('11288','2013-07-22','10:05:00',4.76),('11288','2013-07-22','10:10:00',5.11),('11288','2013-07-22','10:15:00',5.2),('11288','2013-07-22','10:20:00',5.33),('11288','2013-07-22','10:25:00',5.41),('11288','2013-07-22','10:30:00',5.51),('11288','2013-07-22','10:35:00',5.63),('11288','2013-07-22','10:40:00',5.7),('11288','2013-07-22','10:45:00',5.76),('11288','2013-07-22','10:50:00',5.84),('11288','2013-07-22','10:55:00',5.88),('11288','2013-07-22','11:00:00',5.98),('11288','2013-07-22','11:05:00',6.04),('11288','2013-07-22','11:10:00',6.05),('11288','2013-07-22','11:15:00',6.07),('11288','2013-07-22','11:20:00',6.15),('11288','2013-07-22','11:25:00',6.21),('11288','2013-07-22','11:30:00',6.18),('11288','2013-07-22','11:35:00',6.19),('11288','2013-07-22','11:40:00',6.26),('11288','2013-07-22','11:45:00',6.31),('11288','2013-07-22','11:50:00',6.37),('11288','2013-07-22','11:55:00',6.42),('11288','2013-07-22','12:00:00',6.43),('11288','2013-07-22','12:05:00',6.53),('11288','2013-07-22','12:10:00',6.57),('11288','2013-07-22','12:15:00',6.6),('11288','2013-07-22','12:20:00',6.6),('11288','2013-07-22','12:25:00',6.6),('11288','2013-07-22','12:30:00',6.6),('11288','2013-07-22','12:35:00',6.69),('11288','2013-07-22','12:40:00',6.72),('11288','2013-07-22','12:45:00',6.71),('11288','2013-07-22','12:50:00',6.72),('11288','2013-07-22','12:55:00',6.68),('11288','2013-07-22','13:00:00',6.66),('11288','2013-07-22','13:05:00',6.71),('11288','2013-07-22','13:10:00',6.73),('11288','2013-07-22','13:15:00',6.72),('11288','2013-07-22','13:20:00',6.77),('11288','2013-07-22','13:25:00',6.83),('11288','2013-07-22','13:30:00',6.77),('11288','2013-07-22','13:35:00',6.76),('11288','2013-07-22','13:40:00',6.72),('11288','2013-07-22','13:45:00',6.8),('11288','2013-07-22','13:50:00',6.71),('11288','2013-07-22','13:55:00',6.68),('11288','2013-07-22','14:00:00',6.66),('11288','2013-07-22','14:05:00',6.61),('11288','2013-07-22','14:10:00',6.52),('11288','2013-07-22','14:15:00',6.5),('11288','2013-07-22','14:20:00',6.47),('11288','2013-07-22','14:25:00',6.43),('11288','2013-07-22','14:30:00',6.44),('11288','2013-07-22','14:35:00',6.4),('11288','2013-07-22','14:40:00',6.31),('11288','2013-07-22','14:45:00',6.3),('11288','2013-07-22','14:50:00',6.31),('11288','2013-07-22','14:55:00',6.23),('11288','2013-07-22','15:00:00',6.16),('11288','2013-07-22','15:05:00',6.11),('11288','2013-07-22','15:10:00',6.22),('11288','2013-07-22','15:15:00',6.06),('11288','2013-07-22','15:20:00',5.98),('11288','2013-07-22','15:25:00',6.03),('11288','2013-07-22','15:30:00',4.25),('11288','2013-07-22','15:35:00',1.27),('11288','2013-07-22','15:40:00',1.99),('11288','2013-07-22','15:45:00',2.84),('11288','2013-07-22','15:50:00',6.3),('11288','2013-07-22','15:55:00',6.35),('11288','2013-07-22','16:00:00',6.36),('11288','2013-07-22','16:05:00',6.11),('11288','2013-07-22','16:10:00',5.81),('11288','2013-07-22','16:15:00',5.29),('11288','2013-07-22','16:20:00',5.64),('11288','2013-07-22','16:25:00',5.41),('11288','2013-07-22','16:30:00',5.15),('11288','2013-07-22','16:35:00',5.04),('11288','2013-07-22','16:40:00',4.69),('11288','2013-07-22','16:45:00',4.52),('11288','2013-07-22','16:50:00',4.48),('11288','2013-07-22','16:55:00',4.41),('11288','2013-07-22','17:00:00',4.25),('11288','2013-07-22','17:05:00',4.09),('11288','2013-07-22','17:10:00',4),('11288','2013-07-22','17:15:00',3.92),('11288','2013-07-22','17:20:00',3.8),('11288','2013-07-22','17:25:00',3.56),('11288','2013-07-22','17:30:00',3.41),('11288','2013-07-22','17:35:00',3.44),('11288','2013-07-22','17:40:00',3.31),('11288','2013-07-22','17:45:00',2.94),('11288','2013-07-22','17:50:00',2.82),('11288','2013-07-22','17:55:00',2.87),('11288','2013-07-22','18:00:00',2.94),('11288','2013-07-22','18:05:00',2.76),('11288','2013-07-22','18:10:00',2.5),('11288','2013-07-22','18:15:00',2.32),('11288','2013-07-22','18:20:00',2.24),('11288','2013-07-22','18:25:00',2.18),('11288','2013-07-22','18:30:00',1.97),('11288','2013-07-22','18:35:00',1.87),('11288','2013-07-22','18:40:00',1.7),('11288','2013-07-22','18:45:00',1.59),('11288','2013-07-22','18:50:00',1.46),('11288','2013-07-22','18:55:00',1.32),('11288','2013-07-22','19:00:00',1.1),('11288','2013-07-22','19:05:00',1.13),('11288','2013-07-22','19:10:00',1.06),('11288','2013-07-21','07:25:00',1.05),('11288','2013-07-21','07:30:00',1.13),('11288','2013-07-21','07:35:00',1.23),('11288','2013-07-21','07:40:00',1.36),('11288','2013-07-21','07:45:00',1.48),('11288','2013-07-21','07:50:00',1.52),('11288','2013-07-21','07:55:00',1.58),('11288','2013-07-21','08:00:00',1.75),('11288','2013-07-21','08:05:00',1.84),('11288','2013-07-21','08:10:00',1.98),('11288','2013-07-21','08:15:00',2.06),('11288','2013-07-21','08:20:00',2.06),('11288','2013-07-21','08:25:00',2.19),('11288','2013-07-21','08:30:00',2.41),('11288','2013-07-21','08:35:00',2.62),('11288','2013-07-21','08:40:00',2.76),('11288','2013-07-21','08:45:00',2.85),('11288','2013-07-21','08:50:00',2.94),('11288','2013-07-21','08:55:00',3.14),('11288','2013-07-21','09:00:00',3.21),('11288','2013-07-21','09:05:00',3.33),('11288','2013-07-21','09:10:00',3.6),('11288','2013-07-21','09:15:00',3.64),('11288','2013-07-21','09:20:00',3.7),('11288','2013-07-21','09:25:00',3.89),('11288','2013-07-21','09:30:00',4),('11288','2013-07-21','09:35:00',4.13),('11288','2013-07-21','09:40:00',4.24),('11288','2013-07-21','09:45:00',4.32),('11288','2013-07-21','09:50:00',4.37),('11288','2013-07-21','09:55:00',4.61),('11288','2013-07-21','10:00:00',4.75),('11288','2013-07-21','10:05:00',4.88),('11288','2013-07-21','10:10:00',4.97),('11288','2013-07-21','10:15:00',5.07),('11288','2013-07-21','10:20:00',5.23),('11288','2013-07-21','10:25:00',5.29),('11288','2013-07-21','10:30:00',5.37),('11288','2013-07-21','10:35:00',5.47),('11288','2013-07-21','10:40:00',5.54),('11288','2013-07-21','10:45:00',5.57),('11288','2013-07-21','10:50:00',5.68),('11288','2013-07-21','10:55:00',5.76),('11288','2013-07-21','11:00:00',5.85),('11288','2013-07-21','11:05:00',5.96),('11288','2013-07-21','11:10:00',5.97),('11288','2013-07-21','11:15:00',5.98),('11288','2013-07-21','11:20:00',5.99),('11288','2013-07-21','11:25:00',6.07),('11288','2013-07-21','11:30:00',6.19),('11288','2013-07-21','11:35:00',6.19),('11288','2013-07-21','11:40:00',6.35),('11288','2013-07-21','11:45:00',6.4),('11288','2013-07-21','11:50:00',6.35),('11288','2013-07-21','11:55:00',6.39),('11288','2013-07-21','12:00:00',6.44),('11288','2013-07-21','12:05:00',6.44),('11288','2013-07-21','12:10:00',6.22),('11288','2013-07-21','12:15:00',6.65),('11288','2013-07-21','12:20:00',7.11),('11288','2013-07-21','12:25:00',7.48),('11288','2013-07-21','12:30:00',5.9),('11288','2013-07-21','12:35:00',7.09),('11288','2013-07-21','12:40:00',7.93),('11288','2013-07-21','12:45:00',7.86),('11288','2013-07-21','12:50:00',7.72),('11288','2013-07-21','12:55:00',7.71),('11288','2013-07-21','13:00:00',8.04),('11288','2013-07-21','13:05:00',7.76),('11288','2013-07-21','13:10:00',6.17),('11288','2013-07-21','13:15:00',4.1),('11288','2013-07-21','13:20:00',6.91),('11288','2013-07-21','13:25:00',6.58),('11288','2013-07-21','13:30:00',7.47),('11288','2013-07-21','13:35:00',7.25),('11288','2013-07-21','13:40:00',7.2),('11288','2013-07-21','13:45:00',6.93),('11288','2013-07-21','13:50:00',4.67),('11288','2013-07-21','13:55:00',1.75),('11288','2013-07-21','14:00:00',1.83),('11288','2013-07-21','14:05:00',2.04),('11288','2013-07-21','14:10:00',1.93),('11288','2013-07-21','14:15:00',1.94),('11288','2013-07-21','14:20:00',2.4),('11288','2013-07-21','14:25:00',2.61),('11288','2013-07-21','14:30:00',2.17),('11288','2013-07-21','14:35:00',2.19),('11288','2013-07-21','14:40:00',2.23),('11288','2013-07-21','14:45:00',2.47),('11288','2013-07-21','14:50:00',2.85),('11288','2013-07-21','14:55:00',2.93),('11288','2013-07-21','15:00:00',3.43),('11288','2013-07-21','15:05:00',3.2),('11288','2013-07-21','15:10:00',3.18),('11288','2013-07-21','15:15:00',6.27),('11288','2013-07-21','15:20:00',7.42),('11288','2013-07-21','15:25:00',2.92),('11288','2013-07-21','15:30:00',2.61),('11288','2013-07-21','15:35:00',2.97),('11288','2013-07-21','15:40:00',4.68),('11288','2013-07-21','15:45:00',6.4),('11288','2013-07-21','15:50:00',5.08),('11288','2013-07-21','15:55:00',4.2),('11288','2013-07-21','16:00:00',2.37),('11288','2013-07-21','16:05:00',1.81),('11288','2013-07-21','16:10:00',1.56),('11288','2013-07-21','16:15:00',1.39),('11288','2013-07-21','16:20:00',1.3),('11288','2013-07-21','16:25:00',1.34),('11288','2013-07-21','16:30:00',1.39),('11288','2013-07-21','16:35:00',1.52),('11288','2013-07-21','16:40:00',1.6),('11288','2013-07-21','16:45:00',1.63),('11288','2013-07-21','16:50:00',1.67),('11288','2013-07-21','16:55:00',1.88),('11288','2013-07-21','17:00:00',2.13),('11288','2013-07-21','17:05:00',2.3),('11288','2013-07-21','17:10:00',2.37),('11288','2013-07-21','17:15:00',1.99),('11288','2013-07-21','17:20:00',1.77),('11288','2013-07-21','17:25:00',1.6),('11288','2013-07-21','17:30:00',1.51),('11288','2013-07-21','17:35:00',1.45),('11288','2013-07-21','17:40:00',1.44),('11288','2013-07-21','17:45:00',1.42),('11288','2013-07-21','17:50:00',1.44),('11288','2013-07-21','17:55:00',1.47),('11288','2013-07-21','18:00:00',1.46),('11288','2013-07-21','18:05:00',1.37),('11288','2013-07-21','18:10:00',1.19),('11288','2013-07-21','18:15:00',1.03),('11288','2014-04-07','08:10:00',1.29),('11288','2014-04-07','08:15:00',1.4),('11288','2014-04-07','08:20:00',1.59),('11288','2014-04-07','08:25:00',1.72),('11288','2014-04-07','08:30:00',1.98),('11288','2014-04-07','08:35:00',2.33),('11288','2014-04-07','08:40:00',2.46),('11288','2014-04-07','08:45:00',2.28),('11288','2014-04-07','08:50:00',2.2),('11288','2014-04-07','08:55:00',2.12),('11288','2014-04-07','09:00:00',2.04),('11288','2014-04-07','09:05:00',2.08),('11288','2014-04-07','09:10:00',2.38),('11288','2014-04-07','09:15:00',2.62),('11288','2014-04-07','09:20:00',2.21),('11288','2014-04-07','09:25:00',2.1),('11288','2014-04-07','09:30:00',2.07),('11288','2014-04-07','09:35:00',2.01),('11288','2014-04-07','09:40:00',2.08),('11288','2014-04-07','09:45:00',2.19),('11288','2014-04-07','09:50:00',2.3),('11288','2014-04-07','09:55:00',2.39),('11288','2014-04-07','10:00:00',2.41),('11288','2014-04-07','10:05:00',2.41),('11288','2014-04-07','10:10:00',2.45),('11288','2014-04-07','10:15:00',2.29),('11288','2014-04-07','10:20:00',2.29),('11288','2014-04-07','10:25:00',2.34),('11288','2014-04-07','10:30:00',2.4),('11288','2014-04-07','10:35:00',2.54),('11288','2014-04-07','10:40:00',2.6),('11288','2014-04-07','10:45:00',2.68),('11288','2014-04-07','10:50:00',2.81),('11288','2014-04-07','10:55:00',3.01),('11288','2014-04-07','11:00:00',3.26),('11288','2014-04-07','11:05:00',3.29),('11288','2014-04-07','11:10:00',3.64),('11288','2014-04-07','11:15:00',3.82),('11288','2014-04-07','11:20:00',3.8),('11288','2014-04-07','11:25:00',3.42),('11288','2014-04-07','11:30:00',3.39),('11288','2014-04-07','11:35:00',3.38),('11288','2014-04-07','11:40:00',3.35),('11288','2014-04-07','11:45:00',3.17),('11288','2014-04-07','11:50:00',2.99),('11288','2014-04-07','11:55:00',2.89),('11288','2014-04-07','12:00:00',3.14),('11288','2014-04-07','12:05:00',3.88),('11288','2014-04-07','12:10:00',4.08),('11288','2014-04-07','12:15:00',5.41),('11288','2014-04-07','12:20:00',6.47),('11288','2014-04-07','12:25:00',6.01),('11288','2014-04-07','12:30:00',3.89),('11288','2014-04-07','12:35:00',3.53),('11288','2014-04-07','12:40:00',4.13),('11288','2014-04-07','12:45:00',6.45),('11288','2014-04-07','12:50:00',6.52),('11288','2014-04-07','12:55:00',6.37),('11288','2014-04-07','13:00:00',6.38),('11288','2014-04-07','13:05:00',6.4),('11288','2014-04-07','13:10:00',6.31),('11288','2014-04-07','13:15:00',6.3),('11288','2014-04-07','13:20:00',6.26),('11288','2014-04-07','13:25:00',6.26),('11288','2014-04-07','13:30:00',6.3),('11288','2014-04-07','13:35:00',6.29),('11288','2014-04-07','13:40:00',6.23),('11288','2014-04-07','13:45:00',6.24),('11288','2014-04-07','13:50:00',6.32),('11288','2014-04-07','13:55:00',6.33),('11288','2014-04-07','14:00:00',6.27),('11288','2014-04-07','14:05:00',6.23),('11288','2014-04-07','14:10:00',6.16),('11288','2014-04-07','14:15:00',6.05),('11288','2014-04-07','14:20:00',6.03),('11288','2014-04-07','14:25:00',6.15),('11288','2014-04-07','14:30:00',6.13),('11288','2014-04-07','14:35:00',5.97),('11288','2014-04-07','14:40:00',5.9),('11288','2014-04-07','14:45:00',5.91),('11288','2014-04-07','14:50:00',5.86),('11288','2014-04-07','14:55:00',5.83),('11288','2014-04-07','15:00:00',5.11),('11288','2014-04-07','15:05:00',5.84),('11288','2014-04-07','15:10:00',5.71),('11288','2014-04-07','15:15:00',5.88),('11288','2014-04-07','15:20:00',6.07),('11288','2014-04-07','15:25:00',6),('11288','2014-04-07','15:30:00',5.62),('11288','2014-04-07','15:35:00',5.54),('11288','2014-04-07','15:40:00',5.49),('11288','2014-04-07','15:45:00',5.58),('11288','2014-04-07','15:50:00',5.81),('11288','2014-04-07','15:55:00',5.72),('11288','2014-04-07','16:00:00',4.46),('11288','2014-04-07','16:05:00',3.39),('11288','2014-04-07','16:10:00',4.95),('11288','2014-04-07','16:15:00',4.59),('11288','2014-04-07','16:20:00',4.26),('11288','2014-04-07','16:25:00',4.15),('11288','2014-04-07','16:30:00',3.9),('11288','2014-04-07','16:35:00',2.11),('11288','2014-04-07','16:40:00',2.43),('11288','2014-04-07','16:45:00',2.62),('11288','2014-04-07','16:50:00',3.37),('11288','2014-04-07','16:55:00',3.57),('11288','2014-04-07','17:00:00',3.94),('11288','2014-04-07','17:05:00',3.74),('11288','2014-04-07','17:10:00',2.9),('11288','2014-04-07','17:15:00',3.02),('11288','2014-04-07','17:20:00',2.54),('11288','2014-04-07','17:25:00',1.6),('11288','2014-04-07','17:30:00',1.27),('11288','2014-04-07','17:35:00',1.05),('11288','2014-04-07','17:45:00',1.34),('11288','2014-04-07','17:50:00',1.25),('11288','2014-04-07','17:55:00',1.65),('11288','2014-04-07','18:00:00',1.55),('11288','2014-04-07','18:05:00',1.44),('11288','2014-04-07','18:10:00',1.41),('11288','2014-04-07','18:15:00',1.4),('11288','2014-04-07','18:20:00',1.24),('11288','2014-04-07','18:25:00',1.1),('11288','2013-07-20','07:30:00',1.08),('11288','2013-07-20','07:35:00',1.18),('11288','2013-07-20','07:40:00',1.28),('11288','2013-07-20','07:45:00',1.36),('11288','2013-07-20','07:50:00',1.45),('11288','2013-07-20','07:55:00',1.58),('11288','2013-07-20','08:00:00',1.73),('11288','2013-07-20','08:05:00',1.89),('11288','2013-07-20','08:10:00',1.96),('11288','2013-07-20','08:15:00',2.08),('11288','2013-07-20','08:20:00',2.15),('11288','2013-07-20','08:25:00',2.11),('11288','2013-07-20','08:30:00',2.44),('11288','2013-07-20','08:35:00',2.67),('11288','2013-07-20','08:40:00',2.83),('11288','2013-07-20','08:45:00',2.93),('11288','2013-07-20','08:50:00',3.15),('11288','2013-07-20','08:55:00',3.29),('11288','2013-07-20','09:00:00',3.39),('11288','2013-07-20','09:05:00',3.6),('11288','2013-07-20','09:10:00',3.82),('11288','2013-07-20','09:15:00',3.91),('11288','2013-07-20','09:20:00',4.02),('11288','2013-07-20','09:25:00',4),('11288','2013-07-20','09:30:00',3.98),('11288','2013-07-20','09:35:00',4.05),('11288','2013-07-20','09:40:00',4.04),('11288','2013-07-20','09:45:00',4.45),('11288','2013-07-20','09:50:00',4.4),('11288','2013-07-20','09:55:00',4.2),('11288','2013-07-20','10:00:00',4.51),('11288','2013-07-20','10:05:00',4.92),('11288','2013-07-20','10:10:00',5.12),('11288','2013-07-20','10:15:00',5.21),('11288','2013-07-20','10:20:00',5.34),('11288','2013-07-20','10:25:00',5.37),('11288','2013-07-20','10:30:00',5.49),('11288','2013-07-20','10:35:00',5.56),('11288','2013-07-20','10:40:00',5.61),('11288','2013-07-20','10:45:00',5.64),('11288','2013-07-20','10:50:00',5.77),('11288','2013-07-20','10:55:00',5.9),('11288','2013-07-20','11:00:00',6),('11288','2013-07-20','11:05:00',6.03),('11288','2013-07-20','11:10:00',6.05),('11288','2013-07-20','11:15:00',6.07),('11288','2013-07-20','11:20:00',6),('11288','2013-07-20','11:25:00',6.11),('11288','2013-07-20','11:30:00',6.12),('11288','2013-07-20','11:35:00',6.24),('11288','2013-07-20','11:40:00',6.27),('11288','2013-07-20','11:45:00',6.28),('11288','2013-07-20','11:50:00',6.32),('11288','2013-07-20','11:55:00',6.56),('11288','2013-07-20','12:00:00',6.56),('11288','2013-07-20','12:05:00',6.68),('11288','2013-07-20','12:10:00',6.58),('11288','2013-07-20','12:15:00',6.56),('11288','2013-07-20','12:20:00',6.63),('11288','2013-07-20','12:25:00',6.56),('11288','2013-07-20','12:30:00',6.59),('11288','2013-07-20','12:35:00',6.7),('11288','2013-07-20','12:40:00',6.79),('11288','2013-07-20','12:45:00',6.81),('11288','2013-07-20','12:50:00',6.74),('11288','2013-07-20','12:55:00',6.73),('11288','2013-07-20','13:00:00',7),('11288','2013-07-20','13:05:00',4.68),('11288','2013-07-20','13:10:00',1.66),('11288','2013-07-20','13:15:00',1.99),('11288','2013-07-20','13:20:00',3.33),('11288','2013-07-20','13:25:00',3.31),('11288','2013-07-20','13:30:00',4.91),('11288','2013-07-20','13:35:00',7.52),('11288','2013-07-20','13:40:00',6.49),('11288','2013-07-20','13:45:00',6.83),('11288','2013-07-20','13:50:00',3.01),('11288','2013-07-20','13:55:00',1.79),('11288','2013-07-20','14:00:00',6.6),('11288','2013-07-20','14:05:00',7.08),('11288','2013-07-20','14:10:00',7.14),('11288','2013-07-20','14:15:00',7.09),('11288','2013-07-20','14:20:00',6.96),('11288','2013-07-20','14:25:00',6.55),('11288','2013-07-20','14:30:00',6.6),('11288','2013-07-20','14:35:00',6.6),('11288','2013-07-20','14:40:00',5.94),('11288','2013-07-20','14:45:00',6.68),('11288','2013-07-20','14:50:00',6.75),('11288','2013-07-20','14:55:00',6.7),('11288','2013-07-20','15:00:00',6.56),('11288','2013-07-20','15:05:00',6.4),('11288','2013-07-20','15:10:00',6.3),('11288','2013-07-20','15:15:00',6.23),('11288','2013-07-20','15:20:00',6.08),('11288','2013-07-20','15:25:00',6.04),('11288','2013-07-20','15:30:00',6),('11288','2013-07-20','15:35:00',5.95),('11288','2013-07-20','15:40:00',5.9),('11288','2013-07-20','15:45:00',5.87),('11288','2013-07-20','15:50:00',5.76),('11288','2013-07-20','15:55:00',5.64),('11288','2013-07-20','16:00:00',5.63),('11288','2013-07-20','16:05:00',5.56),('11288','2013-07-20','16:10:00',5.44),('11288','2013-07-20','16:15:00',5.39),('11288','2013-07-20','16:20:00',5.25),('11288','2013-07-20','16:25:00',5.18),('11288','2013-07-20','16:30:00',5.05),('11288','2013-07-20','16:35:00',4.9),('11288','2013-07-20','16:40:00',4.79),('11288','2013-07-20','16:45:00',4.7),('11288','2013-07-20','16:50:00',4.63),('11288','2013-07-20','16:55:00',4.43),('11288','2013-07-20','17:00:00',4.25),('11288','2013-07-20','17:05:00',4.05),('11288','2013-07-20','17:10:00',4.07),('11288','2013-07-20','17:15:00',3.96),('11288','2013-07-20','17:20:00',3.83),('11288','2013-07-20','17:25:00',3.7),('11288','2013-07-20','17:30:00',3.59),('11288','2013-07-20','17:35:00',3.48),('11288','2013-07-20','17:40:00',3.31),('11288','2013-07-20','17:45:00',3.2),('11288','2013-07-20','17:50:00',3.09),('11288','2013-07-20','17:55:00',3.04),('11288','2013-07-20','18:00:00',2.94),('11288','2013-07-20','18:05:00',2.78),('11288','2013-07-20','18:10:00',2.64),('11288','2013-07-20','18:15:00',2.52),('11288','2013-07-20','18:20:00',2.39),('11288','2013-07-20','18:25:00',2.26),('11288','2013-07-20','18:30:00',2.1),('11288','2013-07-20','18:35:00',1.96),('11288','2013-07-20','18:40:00',1.85),('11288','2013-07-20','18:45:00',1.68),('11288','2013-07-20','18:50:00',1.55),('11288','2013-07-20','18:55:00',1.44),('11288','2013-07-20','19:00:00',1.32),('11288','2013-07-20','19:05:00',1.18),('11288','2013-07-20','19:10:00',1.04),('11288','2013-07-19','07:25:00',1.04),('11288','2013-07-19','07:30:00',1.12),('11288','2013-07-19','07:35:00',1.21),('11288','2013-07-19','07:40:00',1.32),('11288','2013-07-19','07:45:00',1.4),('11288','2013-07-19','07:50:00',1.49),('11288','2013-07-19','07:55:00',1.65),('11288','2013-07-19','08:00:00',1.8),('11288','2013-07-19','08:05:00',1.89),('11288','2013-07-19','08:10:00',1.99),('11288','2013-07-19','08:15:00',2.1),('11288','2013-07-19','08:20:00',2.24),('11288','2013-07-19','08:35:00',2.65),('11288','2013-07-19','08:40:00',2.76),('11288','2013-07-19','08:45:00',2.88),('11288','2013-07-19','08:50:00',2.94),('11288','2013-07-19','08:55:00',2.85),('11288','2013-07-19','09:00:00',3.3),('11288','2013-07-19','09:05:00',3.44),('11288','2013-07-19','09:10:00',3.55),('11288','2013-07-19','09:15:00',2.89),('11288','2013-07-19','09:20:00',3.75),('11288','2013-07-19','09:25:00',3.92),('11288','2013-07-19','09:30:00',4.05),('11288','2013-07-19','09:45:00',3.36),('11288','2013-07-19','09:50:00',4.34),('11288','2013-07-19','09:55:00',4.39),('11288','2013-07-19','10:00:00',4.53),('11288','2013-07-19','10:05:00',3.52),('11288','2013-07-19','10:10:00',4.88),('11288','2013-07-19','10:15:00',4.98),('11288','2013-07-19','10:20:00',5.09),('11288','2013-07-19','10:25:00',3.88),('11288','2013-07-19','10:30:00',5.25),('11288','2013-07-19','10:35:00',5.39),('11288','2013-07-19','10:40:00',5.49),('11288','2013-07-19','10:45:00',4.15),('11288','2013-07-19','10:50:00',5.25),('11288','2013-07-19','10:55:00',5.61),('11288','2013-07-19','11:00:00',5.71),('11288','2013-07-19','11:05:00',5.25),('11288','2013-07-19','11:10:00',4.65),('11288','2013-07-19','11:15:00',5.96),('11288','2013-07-19','11:20:00',5.96),('11288','2013-07-19','11:25:00',5.95),('11288','2013-07-19','11:30:00',6.05),('11288','2013-07-19','11:35:00',6.05),('11288','2013-07-19','11:40:00',6.18),('11288','2013-07-19','11:45:00',6.28),('11288','2013-07-19','11:50:00',6.17),('11288','2013-07-19','11:55:00',5.99),('11288','2013-07-19','12:00:00',6.4),('11288','2013-07-19','12:05:00',6.82),('11288','2013-07-19','12:10:00',6.69),('11288','2013-07-19','12:15:00',6.83),('11288','2013-07-19','12:20:00',6.64),('11288','2013-07-19','12:25:00',6.64),('11288','2013-07-19','12:30:00',6.66),('11288','2013-07-19','12:35:00',6.57),('11288','2013-07-19','12:40:00',6.46),('11288','2013-07-19','12:45:00',6.52),('11288','2013-07-19','12:50:00',6.79),('11288','2013-07-19','12:55:00',6.15),('11288','2013-07-19','13:00:00',5.33),('11288','2013-07-19','13:05:00',6.87),('11288','2013-07-19','13:10:00',4.59),('11288','2013-07-19','13:15:00',2.74),('11288','2013-07-19','13:20:00',5.7),('11288','2013-07-19','13:25:00',7.3),('11288','2013-07-19','13:30:00',7.16),('11288','2013-07-19','13:35:00',7.02),('11288','2013-07-19','13:40:00',7.03),('11288','2013-07-19','13:45:00',6.98),('11288','2013-07-19','13:50:00',6.99),('11288','2013-07-19','13:55:00',6.99),('11288','2013-07-19','14:00:00',6.91),('11288','2013-07-19','14:05:00',6.66),('11288','2013-07-19','14:10:00',6.12),('11288','2013-07-19','14:15:00',6.4),('11288','2013-07-19','14:20:00',6.5),('11288','2013-07-19','14:25:00',6.64),('11288','2013-07-19','14:30:00',6.9),('11288','2013-07-19','14:35:00',5.99),('11288','2013-07-19','14:40:00',6.63),('11288','2013-07-19','14:45:00',6.54),('11288','2013-07-19','14:50:00',6.65),('11288','2013-07-19','14:55:00',6.69),('11288','2013-07-19','15:00:00',6.43),('11288','2013-07-19','15:05:00',6.58),('11288','2013-07-19','15:10:00',6.16),('11288','2013-07-19','15:15:00',3.69),('11288','2013-07-19','15:20:00',5.31),('11288','2013-07-19','15:25:00',5.8),('11288','2013-07-19','15:30:00',6.53),('11288','2013-07-19','15:35:00',6.41),('11288','2013-07-19','15:40:00',6.32),('11288','2013-07-19','15:45:00',6.12),('11288','2013-07-19','15:50:00',5.83),('11288','2013-07-19','15:55:00',5.91),('11288','2013-07-19','16:00:00',5.78),('11288','2013-07-19','16:05:00',5.71),('11288','2013-07-19','16:10:00',5.66),('11288','2013-07-19','16:15:00',5.54),('11288','2013-07-19','16:20:00',5.43),('11288','2013-07-19','16:25:00',5.34),('11288','2013-07-19','16:30:00',5.32),('11288','2013-07-19','16:35:00',5.23),('11288','2013-07-19','16:40:00',5.11),('11288','2013-07-19','16:45:00',5.06),('11288','2013-07-19','16:50:00',5),('11288','2013-07-19','16:55:00',4.95),('11288','2013-07-19','17:00:00',4.82),('11288','2013-07-19','17:05:00',4.24),('11288','2013-07-19','17:10:00',4.36),('11288','2013-07-19','17:15:00',3.96),('11288','2013-07-19','17:20:00',3.61),('11288','2013-07-19','17:25:00',3.08),('11288','2013-07-19','17:30:00',3.75),('11288','2013-07-19','17:35:00',4.11),('11288','2013-07-19','17:40:00',3.22),('11288','2013-07-19','17:45:00',2.53),('11288','2013-07-19','17:50:00',1.73),('11288','2013-07-19','17:55:00',1.54),('11288','2013-07-19','18:00:00',1.36),('11288','2013-07-19','18:05:00',1.15),('11288','2013-07-19','18:10:00',1.04),('11288','2013-07-18','07:30:00',1.11),('11288','2013-07-18','07:35:00',1.21),('11288','2013-07-18','07:40:00',1.33),('11288','2013-07-18','07:45:00',1.43),('11288','2013-07-18','07:50:00',1.48),('11288','2013-07-18','07:55:00',1.68),('11288','2013-07-18','08:00:00',1.85),('11288','2013-07-18','08:05:00',1.91),('11288','2013-07-18','08:10:00',2),('11288','2013-07-18','08:15:00',2.22),('11288','2013-07-18','08:20:00',2.21),('11288','2013-07-18','08:25:00',2.17),('11288','2013-07-18','08:30:00',2.52),('11288','2013-07-18','08:35:00',2.76),('11288','2013-07-18','08:40:00',2.8),('11288','2013-07-18','08:45:00',3.04),('11288','2013-07-18','08:50:00',3.22),('11288','2013-07-18','08:55:00',3.31),('11288','2013-07-18','09:00:00',3.4),('11288','2013-07-18','09:05:00',3.47),('11288','2013-07-18','09:10:00',3.61),('11288','2013-07-18','09:15:00',3.72),('11288','2013-07-18','09:20:00',3.91),('11288','2013-07-18','09:25:00',4.03),('11288','2013-07-18','09:30:00',4.15),('11288','2013-07-18','09:35:00',4.33),('11288','2013-07-18','09:40:00',4.34),('11288','2013-07-18','09:45:00',4.37),('11288','2013-07-18','09:50:00',4.61),('11288','2013-07-18','09:55:00',4.56),('11288','2013-07-18','10:00:00',4.64),('11288','2013-07-18','10:05:00',5.01),('11288','2013-07-18','10:10:00',5.07),('11288','2013-07-18','10:15:00',5.19),('11288','2013-07-18','10:20:00',5.33),('11288','2013-07-18','10:25:00',5.41),('11288','2013-07-18','10:30:00',5.5),('11288','2013-07-18','10:35:00',5.6),('11288','2013-07-18','10:40:00',5.68),('11288','2013-07-18','10:45:00',5.78),('11288','2013-07-18','10:50:00',5.83),('11288','2013-07-18','10:55:00',5.88),('11288','2013-07-18','11:00:00',5.98),('11288','2013-07-18','11:05:00',6.04),('11288','2013-07-18','11:10:00',6.08),('11288','2013-07-18','11:15:00',6.16),('11288','2013-07-18','11:20:00',6.15),('11288','2013-07-18','11:25:00',6.21),('11288','2013-07-18','11:30:00',6.25),('11288','2013-07-18','11:35:00',6.29),('11288','2013-07-18','11:40:00',6.3),('11288','2013-07-18','11:45:00',6.31),('11288','2013-07-18','11:50:00',6.38),('11288','2013-07-18','11:55:00',6.48),('11288','2013-07-18','12:00:00',6.49),('11288','2013-07-18','12:05:00',6.39),('11288','2013-07-18','12:10:00',6.4),('11288','2013-07-18','12:15:00',6.5),('11288','2013-07-18','12:20:00',6.5),('11288','2013-07-18','12:25:00',6.55),('11288','2013-07-18','12:30:00',6.82),('11288','2013-07-18','12:35:00',6.77),('11288','2013-07-18','12:40:00',6.9),('11288','2013-07-18','12:45:00',7.17),('11288','2013-07-18','12:50:00',6.8),('11288','2013-07-18','12:55:00',6.87),('11288','2013-07-18','13:00:00',6.9),('11288','2013-07-18','13:05:00',6.71),('11288','2013-07-18','13:10:00',6.86),('11288','2013-07-18','13:15:00',6.79),('11288','2013-07-18','13:20:00',6.68),('11288','2013-07-18','13:25:00',6.55),('11288','2013-07-18','13:30:00',5.9),('11288','2013-07-18','13:35:00',6.92),('11288','2013-07-18','13:40:00',6.88),('11288','2013-07-18','13:45:00',6.91),('11288','2013-07-18','13:50:00',6.95),('11288','2013-07-18','13:55:00',6.84),('11288','2013-07-18','14:00:00',6.72),('11288','2013-07-18','14:05:00',6.73),('11288','2013-07-18','14:10:00',6.77),('11288','2013-07-18','14:15:00',6.74),('11288','2013-07-18','14:20:00',6.61),('11288','2013-07-18','14:25:00',6.51),('11288','2013-07-18','14:30:00',6.62),('11288','2013-07-18','14:35:00',6.6),('11288','2013-07-18','14:40:00',6.51),('11288','2013-07-18','14:45:00',6.43),('11288','2013-07-18','14:50:00',6.31),('11288','2013-07-18','14:55:00',6.33),('11288','2013-07-18','15:00:00',6.35),('11288','2013-07-18','15:05:00',6.29),('11288','2013-07-18','15:10:00',6.18),('11288','2013-07-18','15:15:00',6.16),('11288','2013-07-18','15:20:00',6.16),('11288','2013-07-18','15:25:00',6.11),('11288','2013-07-18','15:30:00',6.04),('11288','2013-07-18','15:35:00',5.98),('11288','2013-07-18','15:40:00',5.9),('11288','2013-07-18','15:45:00',5.86),('11288','2013-07-18','15:50:00',5.73),('11288','2013-07-18','15:55:00',5.65),('11288','2013-07-18','16:00:00',5.59),('11288','2013-07-18','16:05:00',5.51),('11288','2013-07-18','16:10:00',5.44),('11288','2013-07-18','16:15:00',5.32),('11288','2013-07-18','16:20:00',5.15),('11288','2013-07-18','16:25:00',5.11),('11288','2013-07-18','16:30:00',5.02),('11288','2013-07-18','16:35:00',4.91),('11288','2013-07-18','16:40:00',4.77),('11288','2013-07-18','16:45:00',4.69),('11288','2013-07-18','16:50:00',4.57),('11288','2013-07-18','16:55:00',4.38),('11288','2013-07-18','17:00:00',4.18),('11288','2013-07-18','17:05:00',4.04),('11288','2013-07-18','17:10:00',4.03),('11288','2013-07-18','17:15:00',3.91),('11288','2013-07-18','17:20:00',3.85),('11288','2013-07-18','17:25:00',3.67),('11288','2013-07-18','17:30:00',3.54),('11288','2013-07-18','17:35:00',3.33),('11288','2013-07-18','17:40:00',3.02),('11288','2013-07-18','17:45:00',3.07),('11288','2013-07-18','17:50:00',2.93),('11288','2013-07-18','17:55:00',2.77),('11288','2013-07-18','18:00:00',2.63),('11288','2013-07-18','18:05:00',2.25),('11288','2013-07-18','18:10:00',2.39),('11288','2013-07-18','18:15:00',2.2),('11288','2013-07-18','18:20:00',2.07),('11288','2013-07-18','18:25:00',1.95),('11288','2013-07-18','18:30:00',1.1),('11288','2013-07-18','18:50:00',1.04),('11288','2013-07-18','18:55:00',1.29),('11288','2013-07-18','19:00:00',1.34),('11288','2013-07-18','19:05:00',1.11),('11288','2013-07-17','07:25:00',1.04),('11288','2013-07-17','07:30:00',1.13),('11288','2013-07-17','07:35:00',1.22),('11288','2013-07-17','07:40:00',1.37),('11288','2013-07-17','07:45:00',1.43),('11288','2013-07-17','07:50:00',1.49),('11288','2013-07-17','07:55:00',1.67),('11288','2013-07-17','08:00:00',1.88),('11288','2013-07-17','08:05:00',2),('11288','2013-07-17','08:10:00',2.04),('11288','2013-07-17','08:15:00',2.34),('11288','2013-07-17','08:20:00',2.45),('11288','2013-07-17','08:25:00',2.4),('11288','2013-07-17','08:30:00',2.7),('11288','2013-07-17','08:35:00',2.91),('11288','2013-07-17','08:40:00',2.94),('11288','2013-07-17','08:45:00',3.21),('11288','2013-07-17','08:50:00',3.36),('11288','2013-07-17','08:55:00',3.44),('11288','2013-07-17','09:00:00',3.59),('11288','2013-07-17','09:05:00',3.69),('11288','2013-07-17','09:10:00',3.84),('11288','2013-07-17','09:15:00',4.02),('11288','2013-07-17','09:20:00',4.11),('11288','2013-07-17','09:25:00',4.23),('11288','2013-07-17','09:30:00',4.44),('11288','2013-07-17','09:35:00',4.53),('11288','2013-07-17','09:40:00',4.51),('11288','2013-07-17','09:45:00',4.7),('11288','2013-07-17','09:50:00',4.8),('11288','2013-07-17','09:55:00',4.75),('11288','2013-07-17','10:00:00',4.9),('11288','2013-07-17','10:05:00',5.26),('11288','2013-07-17','10:10:00',5.34),('11288','2013-07-17','10:15:00',5.43),('11288','2013-07-17','10:20:00',5.52),('11288','2013-07-17','10:25:00',5.58),('11288','2013-07-17','10:30:00',5.73),('11288','2013-07-17','10:35:00',5.85),('11288','2013-07-17','10:40:00',5.87),('11288','2013-07-17','10:45:00',5.96),('11288','2013-07-17','10:50:00',6.07),('11288','2013-07-17','10:55:00',6.15),('11288','2013-07-17','11:00:00',6.25),('11288','2013-07-17','11:05:00',6.35),('11288','2013-07-17','11:10:00',6.41),('11288','2013-07-17','11:15:00',6.44),('11288','2013-07-17','11:20:00',6.47),('11288','2013-07-17','11:25:00',6.48),('11288','2013-07-17','11:30:00',6.56),('11288','2013-07-17','11:35:00',6.54),('11288','2013-07-17','11:40:00',6.61),('11288','2013-07-17','11:45:00',6.65),('11288','2013-07-17','11:50:00',6.73),('11288','2013-07-17','11:55:00',6.75),('11288','2013-07-17','12:00:00',6.83),('11288','2013-07-17','12:05:00',6.84),('11288','2013-07-17','12:10:00',6.82),('11288','2013-07-17','12:15:00',6.83),('11288','2013-07-17','12:20:00',6.84),('11288','2013-07-17','12:25:00',6.82),('11288','2013-07-17','12:30:00',6.87),('11288','2013-07-17','12:35:00',6.87),('11288','2013-07-17','12:40:00',6.82),('11288','2013-07-17','12:45:00',6.84),('11288','2013-07-17','12:50:00',6.82),('11288','2013-07-17','12:55:00',6.85),('11288','2013-07-17','13:00:00',6.89),('11288','2013-07-17','13:05:00',6.94),('11288','2013-07-17','13:10:00',6.86),('11288','2013-07-17','13:15:00',6.9),('11288','2013-07-17','13:20:00',6.91),('11288','2013-07-17','13:25:00',6.79),('11288','2013-07-17','13:30:00',6.78),('11288','2013-07-17','13:35:00',6.82),('11288','2013-07-17','13:40:00',6.75),('11288','2013-07-17','13:45:00',6.75),('11288','2013-07-17','13:50:00',6.69),('11288','2013-07-17','13:55:00',6.56),('11288','2013-07-17','14:00:00',6.79),('11288','2013-07-17','14:05:00',6.76),('11288','2013-07-17','14:10:00',6.8),('11288','2013-07-17','14:15:00',6.77),('11288','2013-07-17','14:20:00',6.67),('11288','2013-07-17','14:25:00',6.63),('11288','2013-07-17','14:30:00',6.59),('11288','2013-07-17','14:35:00',6.58),('11288','2013-07-17','14:40:00',6.66),('11288','2013-07-17','14:45:00',6.58),('11288','2013-07-17','14:50:00',6.39),('11288','2013-07-17','14:55:00',5.02),('11288','2013-07-17','15:00:00',5.75),('11288','2013-07-17','15:05:00',6.42),('11288','2013-07-17','15:10:00',6.21),('11288','2013-07-17','15:15:00',6.28),('11288','2013-07-17','15:20:00',6.23),('11288','2013-07-17','15:25:00',6.21),('11288','2013-07-17','15:30:00',6.16),('11288','2013-07-17','15:35:00',6.12),('11288','2013-07-17','15:40:00',6.09),('11288','2013-07-17','15:45:00',5.81),('11288','2013-07-17','15:50:00',5.38),('11288','2013-07-17','15:55:00',5.12),('11288','2013-07-17','16:00:00',5.75),('11288','2013-07-17','16:05:00',5.61),('11288','2013-07-17','16:10:00',5.62),('11288','2013-07-17','16:15:00',5.51),('11288','2013-07-17','16:20:00',5.3),('11288','2013-07-17','16:25:00',5),('11288','2013-07-17','16:30:00',4.94),('11288','2013-07-17','16:35:00',4.96),('11288','2013-07-17','16:40:00',4.47),('11288','2013-07-17','16:45:00',4.71),('11288','2013-07-17','16:50:00',4.61),('11288','2013-07-17','16:55:00',4.44),('11288','2013-07-17','17:00:00',4.36),('11288','2013-07-17','17:05:00',4.23),('11288','2013-07-17','17:10:00',4.26),('11288','2013-07-17','17:15:00',4.12),('11288','2013-07-17','17:20:00',3.96),('11288','2013-07-17','17:25:00',3.77),('11288','2013-07-17','17:30:00',3.62),('11288','2013-07-17','17:35:00',3.55),('11288','2013-07-17','17:40:00',3.35),('11288','2013-07-17','17:45:00',3.22),('11288','2013-07-17','17:50:00',3.17),('11288','2013-07-17','17:55:00',3.1),('11288','2013-07-17','18:00:00',2.91),('11288','2013-07-17','18:05:00',2.81),('11288','2013-07-17','18:10:00',2.69),('11288','2013-07-17','18:15:00',2.57),('11288','2013-07-17','18:20:00',2.42),('11288','2013-07-17','18:25:00',2.29),('11288','2013-07-17','18:30:00',2.16),('11288','2013-07-17','18:35:00',2.03),('11288','2013-07-17','18:40:00',1.91),('11288','2013-07-17','18:45:00',1.74),('11288','2013-07-17','18:50:00',1.61),('11288','2013-07-17','18:55:00',1.47),('11288','2013-07-17','19:00:00',1.35),('11288','2013-07-17','19:05:00',1.23),('11288','2013-07-17','19:10:00',1.1),('11288','2013-07-16','07:20:00',1.03),('11288','2013-07-16','07:25:00',1.12),('11288','2013-07-16','07:30:00',1.2),('11288','2013-07-16','07:35:00',1.3),('11288','2013-07-16','07:40:00',1.46),('11288','2013-07-16','07:45:00',1.52),('11288','2013-07-16','07:50:00',1.6),('11288','2013-07-16','07:55:00',1.68),('11288','2013-07-16','08:00:00',1.91),('11288','2013-07-16','08:05:00',2.06),('11288','2013-07-16','08:10:00',2.05),('11288','2013-07-16','08:15:00',2.2),('11288','2013-07-16','08:20:00',2.3),('11288','2013-07-16','08:25:00',2.34),('11288','2013-07-16','08:30:00',2.63),('11288','2013-07-16','08:35:00',2.8),('11288','2013-07-16','08:40:00',2.93),('11288','2013-07-16','08:45:00',3.1),('11288','2013-07-16','08:50:00',3.21),('11288','2013-07-16','08:55:00',3.36),('11288','2013-07-16','09:00:00',3.52),('11288','2013-07-16','09:05:00',3.53),('11288','2013-07-16','09:10:00',3.53),('11288','2013-07-16','09:15:00',3.73),('11288','2013-07-16','09:20:00',3.93),('11288','2013-07-16','09:25:00',4),('11288','2013-07-16','09:30:00',4.24),('11288','2013-07-16','09:35:00',4.31),('11288','2013-07-16','09:40:00',4.39),('11288','2013-07-16','09:45:00',4.5),('11288','2013-07-16','09:50:00',4.62),('11288','2013-07-16','09:55:00',4.68),('11288','2013-07-16','10:00:00',4.81),('11288','2013-07-16','10:05:00',5.11),('11288','2013-07-16','10:10:00',5.2),('11288','2013-07-16','10:15:00',5.35),('11288','2013-07-16','10:20:00',5.43),('11288','2013-07-16','10:25:00',5.52),('11288','2013-07-16','10:30:00',5.66),('11288','2013-07-16','10:35:00',5.74),('11288','2013-07-16','10:40:00',5.81),('11288','2013-07-16','10:45:00',5.94),('11288','2013-07-16','10:50:00',5.98),('11288','2013-07-16','10:55:00',6.05),('11288','2013-07-16','11:00:00',6.15),('11288','2013-07-16','11:05:00',6.22),('11288','2013-07-16','11:10:00',6.28),('11288','2013-07-16','11:15:00',6.32),('11288','2013-07-16','11:20:00',6.38),('11288','2013-07-16','11:25:00',6.39),('11288','2013-07-16','11:30:00',6.41),('11288','2013-07-16','11:35:00',6.46),('11288','2013-07-16','11:40:00',6.49),('11288','2013-07-16','11:45:00',6.55),('11288','2013-07-16','11:50:00',6.65),('11288','2013-07-16','11:55:00',6.74),('11288','2013-07-16','12:00:00',6.75),('11288','2013-07-16','12:05:00',6.83),('11288','2013-07-16','12:10:00',6.88),('11288','2013-07-16','12:15:00',6.9),('11288','2013-07-16','12:20:00',6.9),('11288','2013-07-16','12:25:00',6.88),('11288','2013-07-16','12:30:00',6.85),('11288','2013-07-16','12:35:00',6.84),('11288','2013-07-16','12:40:00',6.83),('11288','2013-07-16','12:45:00',6.9),('11288','2013-07-16','12:50:00',6.74),('11288','2013-07-16','12:55:00',6.75),('11288','2013-07-16','13:00:00',6.76),('11288','2013-07-16','13:05:00',6.81),('11288','2013-07-16','13:10:00',6.86),('11288','2013-07-16','13:15:00',6.87),('11288','2013-07-16','13:20:00',6.93),('11288','2013-07-16','13:25:00',6.9),('11288','2013-07-16','13:30:00',6.95),('11288','2013-07-16','13:35:00',6.88),('11288','2013-07-16','13:40:00',6.98),('11288','2013-07-16','13:45:00',7.04),('11288','2013-07-16','13:50:00',7.21),('11288','2013-07-16','13:55:00',6.93),('11288','2013-07-16','14:00:00',6.73),('11288','2013-07-16','14:05:00',6.82),('11288','2013-07-16','14:10:00',2.85),('11288','2013-07-16','14:15:00',6.76),('11288','2013-07-16','14:20:00',2.57),('11288','2013-07-16','14:25:00',5.28),('11288','2013-07-16','14:30:00',6.9),('11288','2013-07-16','14:35:00',6.75),('11288','2013-07-16','14:40:00',6.7),('11288','2013-07-16','14:45:00',6.57),('11288','2013-07-16','14:50:00',6.57),('11288','2013-07-16','14:55:00',6.62),('11288','2013-07-16','15:00:00',6.53),('11288','2013-07-16','15:05:00',6.43),('11288','2013-07-16','15:10:00',6.37),('11288','2013-07-16','15:15:00',6.28),('11288','2013-07-16','15:20:00',6.23),('11288','2013-07-16','15:25:00',6.24),('11288','2013-07-16','15:30:00',6.26),('11288','2013-07-16','15:35:00',5.03),('11288','2013-07-16','15:40:00',6.15),('11288','2013-07-16','15:45:00',4.58),('11288','2013-07-16','15:50:00',5.79),('11288','2013-07-16','15:55:00',5.83),('11288','2013-07-16','16:00:00',5.63),('11288','2013-07-16','16:05:00',4.04),('11288','2013-07-16','16:10:00',4.47),('11288','2013-07-16','16:15:00',3.74),('11288','2013-07-16','16:20:00',2.74),('11288','2013-07-16','16:25:00',3.18),('11288','2013-07-16','16:30:00',2.17),('11288','2013-07-16','16:35:00',1.37),('11288','2013-07-16','16:40:00',1.39),('11288','2013-07-16','16:45:00',1.79),('11288','2013-07-16','16:50:00',2.55),('11288','2013-07-16','16:55:00',2.92),('11288','2013-07-16','17:00:00',4.21),('11288','2013-07-16','17:05:00',4.89),('11288','2013-07-16','17:10:00',4.73),('11288','2013-07-16','17:15:00',4.2),('11288','2013-07-16','17:20:00',2.35),('11288','2013-07-16','17:25:00',3.43),('11288','2013-07-16','17:30:00',2.88),('11288','2013-07-16','17:35:00',2.96),('11288','2013-07-16','17:40:00',3.43),('11288','2013-07-16','17:45:00',3.46),('11288','2013-07-16','17:50:00',3.12),('11288','2013-07-16','17:55:00',2.01),('11288','2013-07-16','18:00:00',1.6),('11288','2013-07-16','18:05:00',2.4),('11288','2013-07-16','18:10:00',1.97),('11288','2013-07-16','18:15:00',2.3),('11288','2013-07-16','18:20:00',2.2),('11288','2013-07-16','18:25:00',2.26),('11288','2013-07-16','18:30:00',2.13),('11288','2013-07-16','18:35:00',1.99),('11288','2013-07-16','18:40:00',1.81),('11288','2013-07-16','18:45:00',1.65),('11288','2013-07-16','18:50:00',1.51),('11288','2013-07-16','18:55:00',1.31),('11288','2013-07-16','19:00:00',1.22),('11288','2013-07-16','19:05:00',1.11),('11288','2013-07-15','07:20:00',1.05),('11288','2013-07-15','07:25:00',1.13),('11288','2013-07-15','07:30:00',1.21),('11288','2013-07-15','07:35:00',1.26),('11288','2013-07-15','07:40:00',1.4),('11288','2013-07-15','07:45:00',1.52),('11288','2013-07-15','07:50:00',1.57),('11288','2013-07-15','07:55:00',1.75),('11288','2013-07-15','08:00:00',1.98),('11288','2013-07-15','08:05:00',2.14),('11288','2013-07-15','08:10:00',2.08),('11288','2013-07-15','08:15:00',2.33),('11288','2013-07-15','08:20:00',2.44),('11288','2013-07-15','08:25:00',2.44),('11288','2013-07-15','08:30:00',2.7),('11288','2013-07-15','08:35:00',2.91),('11288','2013-07-15','08:40:00',3.04),('11288','2013-07-15','08:45:00',3.24),('11288','2013-07-15','08:50:00',3.35),('11288','2013-07-15','08:55:00',3.47),('11288','2013-07-15','09:00:00',3.67),('11288','2013-07-15','09:05:00',3.8),('11288','2013-07-15','09:10:00',3.8),('11288','2013-07-15','09:15:00',3.97),('11288','2013-07-15','09:20:00',3.95),('11288','2013-07-15','09:25:00',3.85),('11288','2013-07-15','09:30:00',4.26),('11288','2013-07-15','09:35:00',4.46),('11288','2013-07-15','09:40:00',4.52),('11288','2013-07-15','09:45:00',4.68),('11288','2013-07-15','09:50:00',4.89),('11288','2013-07-15','09:55:00',5.02),('11288','2013-07-15','10:00:00',5.14),('11288','2013-07-15','10:05:00',5.24),('11288','2013-07-15','10:10:00',5.3),('11288','2013-07-15','10:15:00',5.43),('11288','2013-07-15','10:20:00',5.51),('11288','2013-07-15','10:25:00',5.6),('11288','2013-07-15','10:30:00',5.71),('11288','2013-07-15','10:35:00',5.79),('11288','2013-07-15','10:40:00',5.83),('11288','2013-07-15','10:45:00',5.93),('11288','2013-07-15','10:50:00',5.96),('11288','2013-07-15','10:55:00',6.04),('11288','2013-07-15','11:00:00',6.16),('11288','2013-07-15','11:05:00',6.22),('11288','2013-07-15','11:10:00',6.26),('11288','2013-07-15','11:15:00',6.3),('11288','2013-07-15','11:20:00',6.32),('11288','2013-07-15','11:25:00',6.35),('11288','2013-07-15','11:30:00',6.36),('11288','2013-07-15','11:35:00',6.46),('11288','2013-07-15','11:40:00',6.5),('11288','2013-07-15','11:45:00',6.54),('11288','2013-07-15','11:50:00',6.55),('11288','2013-07-15','11:55:00',6.59),('11288','2013-07-15','12:00:00',6.73),('11288','2013-07-15','12:05:00',6.76),('11288','2013-07-15','12:10:00',6.75),('11288','2013-07-15','12:15:00',6.72),('11288','2013-07-15','12:20:00',6.85),('11288','2013-07-15','12:25:00',6.87),('11288','2013-07-15','12:30:00',6.82),('11288','2013-07-15','12:35:00',6.92),('11288','2013-07-15','12:40:00',6.88),('11288','2013-07-15','12:45:00',6.81),('11288','2013-07-15','12:50:00',6.74),('11288','2013-07-15','12:55:00',6.64),('11288','2013-07-15','13:00:00',6.99),('11288','2013-07-15','13:05:00',6.72),('11288','2013-07-15','13:10:00',4.65),('11288','2013-07-15','13:15:00',7.01),('11288','2013-07-15','13:20:00',7.02),('11288','2013-07-15','13:25:00',7.23),('11288','2013-07-15','13:30:00',7.34),('11288','2013-07-15','13:35:00',7.45),('11288','2013-07-15','13:40:00',3.91),('11288','2013-07-15','13:45:00',4.01),('11288','2013-07-15','13:50:00',2.25),('11288','2013-07-15','13:55:00',4.52),('11288','2013-07-15','14:00:00',6.42),('11288','2013-07-15','14:05:00',7.62),('11288','2013-07-15','14:10:00',5.85),('11288','2013-07-15','14:15:00',1.62),('11288','2013-07-15','14:20:00',1.82),('11288','2013-07-15','14:25:00',6.9),('11288','2013-07-15','14:30:00',7.24),('11288','2013-07-15','14:35:00',7.08),('11288','2013-07-15','14:40:00',6.61),('11288','2013-07-15','14:45:00',6.24),('11288','2013-07-15','14:50:00',6.81),('11288','2013-07-15','14:55:00',6.77),('11288','2013-07-15','15:00:00',6.71),('11288','2013-07-15','15:05:00',6.56),('11288','2013-07-15','15:10:00',6.46),('11288','2013-07-15','15:15:00',6.36),('11288','2013-07-15','15:20:00',5.23),('11288','2013-07-15','15:25:00',1.55),('11288','2013-07-15','15:30:00',5.63),('11288','2013-07-15','15:35:00',6.5),('11288','2013-07-15','15:40:00',6.35),('11288','2013-07-15','15:45:00',6.09),('11288','2013-07-15','15:50:00',6.02),('11288','2013-07-15','15:55:00',5.9),('11288','2013-07-15','16:00:00',5.74),('11288','2013-07-15','16:05:00',5.64),('11288','2013-07-15','16:10:00',5.55),('11288','2013-07-15','16:15:00',5.43),('11288','2013-07-15','16:20:00',5.25),('11288','2013-07-15','16:25:00',5.16),('11288','2013-07-15','16:30:00',5.1),('11288','2013-07-15','16:35:00',4.93),('11288','2013-07-15','16:40:00',4.88),('11288','2013-07-15','16:45:00',4.76),('11288','2013-07-15','16:50:00',4.64),('11288','2013-07-15','16:55:00',4.46),('11288','2013-07-15','17:00:00',4.24),('11288','2013-07-15','17:05:00',4.24),('11288','2013-07-15','17:10:00',4.14),('11288','2013-07-15','17:15:00',4.03),('11288','2013-07-15','17:20:00',3.91),('11288','2013-07-15','17:25:00',3.79),('11288','2013-07-15','17:30:00',3.67),('11288','2013-07-15','17:35:00',3.51),('11288','2013-07-15','17:40:00',3.38),('11288','2013-07-15','17:45:00',3.21),('11288','2013-07-15','17:50:00',3.15),('11288','2013-07-15','17:55:00',3.06),('11288','2013-07-15','18:00:00',2.89),('11288','2013-07-15','18:05:00',2.72),('11288','2013-07-15','18:10:00',2.65),('11288','2013-07-15','18:15:00',2.5),('11288','2013-07-15','18:20:00',2.34),('11288','2013-07-15','18:25:00',2.23),('11288','2013-07-15','18:30:00',2.1),('11288','2013-07-15','18:35:00',1.96),('11288','2013-07-15','18:40:00',1.85),('11288','2013-07-15','18:45:00',1.72),('11288','2013-07-15','18:50:00',1.59),('11288','2013-07-15','18:55:00',1.48),('11288','2013-07-15','19:00:00',1.39),('11288','2013-07-15','19:05:00',1.27),('11288','2013-07-15','19:10:00',1.13),('11288','2013-07-15','19:15:00',1.01),('11288','2013-07-14','07:35:00',1.13),('11288','2013-07-14','07:40:00',1.49),('11288','2013-07-14','07:45:00',1.65),('11288','2013-07-14','07:50:00',2.22),('11288','2013-07-14','07:55:00',2.58),('11288','2013-07-14','08:00:00',2.35),('11288','2013-07-14','08:05:00',2.89),('11288','2013-07-14','08:10:00',2.86),('11288','2013-07-14','08:15:00',2.39),('11288','2013-07-14','08:20:00',2.93),('11288','2013-07-14','08:25:00',2.17),('11288','2013-07-14','08:30:00',1.81),('11288','2013-07-14','08:35:00',2.13),('11288','2013-07-14','08:40:00',1.89),('11288','2013-07-14','08:45:00',1.66),('11288','2013-07-14','08:50:00',1.82),('11288','2013-07-14','08:55:00',1.96),('11288','2013-07-14','09:00:00',1.94),('11288','2013-07-14','09:05:00',2.17),('11288','2013-07-14','09:10:00',2.57),('11288','2013-07-14','09:15:00',2.26),('11288','2013-07-14','09:20:00',3.39),('11288','2013-07-14','09:25:00',3.98),('11288','2013-07-14','09:30:00',3.93),('11288','2013-07-14','09:35:00',3.68),('11288','2013-07-14','09:40:00',3.01),('11288','2013-07-14','09:45:00',2.94),('11288','2013-07-14','09:50:00',2.86),('11288','2013-07-14','09:55:00',2.81),('11288','2013-07-14','10:00:00',2.74),('11288','2013-07-14','10:05:00',3.13),('11288','2013-07-14','10:10:00',2.97),('11288','2013-07-14','10:15:00',2.74),('11288','2013-07-14','10:20:00',3.45),('11288','2013-07-14','10:25:00',5.32),('11288','2013-07-14','10:30:00',4.89),('11288','2013-07-14','10:35:00',5.89),('11288','2013-07-14','10:40:00',5.46),('11288','2013-07-14','10:45:00',4.57),('11288','2013-07-14','10:50:00',6.3),('11288','2013-07-14','10:55:00',5.84),('11288','2013-07-14','11:00:00',5.45),('11288','2013-07-14','11:05:00',2.04),('11288','2013-07-14','11:10:00',2.61),('11288','2013-07-14','11:15:00',4.39),('11288','2013-07-14','11:20:00',7.12),('11288','2013-07-14','11:25:00',3.02),('11288','2013-07-14','11:30:00',3.08),('11288','2013-07-14','11:35:00',3.9),('11288','2013-07-14','11:40:00',3.11),('11288','2013-07-14','11:45:00',2.41),('11288','2013-07-14','11:50:00',3.4),('11288','2013-07-14','11:55:00',7.51),('11288','2013-07-14','12:00:00',7.4),('11288','2013-07-14','12:05:00',7.06),('11288','2013-07-14','12:10:00',7.27),('11288','2013-07-14','12:15:00',6.96),('11288','2013-07-14','12:20:00',6.85),('11288','2013-07-14','12:25:00',7.24),('11288','2013-07-14','12:30:00',7.36),('11288','2013-07-14','12:35:00',6.99),('11288','2013-07-14','12:40:00',6.76),('11288','2013-07-14','12:45:00',7.19),('11288','2013-07-14','12:50:00',7.37),('11288','2013-07-14','12:55:00',5.95),('11288','2013-07-14','13:00:00',3.06),('11288','2013-07-14','13:05:00',7.28),('11288','2013-07-14','13:10:00',7.63),('11288','2013-07-14','13:15:00',7.34),('11288','2013-07-14','13:20:00',7.2),('11288','2013-07-14','13:25:00',7.05),('11288','2013-07-14','13:30:00',6.93),('11288','2013-07-14','13:35:00',6.94),('11288','2013-07-14','13:40:00',7.06),('11288','2013-07-14','13:45:00',7.03),('11288','2013-07-14','13:50:00',7.13),('11288','2013-07-14','13:55:00',7.13),('11288','2013-07-14','14:00:00',7.09),('11288','2013-07-14','14:05:00',7.11),('11288','2013-07-14','14:10:00',7.15),('11288','2013-07-14','14:15:00',7.08),('11288','2013-07-14','14:20:00',7.01),('11288','2013-07-14','14:25:00',6.93),('11288','2013-07-14','14:30:00',6.87),('11288','2013-07-14','14:35:00',6.8),('11288','2013-07-14','14:40:00',6.72),('11288','2013-07-14','14:45:00',6.66),('11288','2013-07-14','14:50:00',6.56),('11288','2013-07-14','14:55:00',6.44),('11288','2013-07-14','15:00:00',6.41),('11288','2013-07-14','15:05:00',6.42),('11288','2013-07-14','15:10:00',6.36),('11288','2013-07-14','15:15:00',6.3),('11288','2013-07-14','15:20:00',6.24),('11288','2013-07-14','15:25:00',6.18),('11288','2013-07-14','15:30:00',6.11),('11288','2013-07-14','15:35:00',6.06),('11288','2013-07-14','15:40:00',5.98),('11288','2013-07-14','15:45:00',5.87),('11288','2013-07-14','15:50:00',5.79),('11288','2013-07-14','15:55:00',5.77),('11288','2013-07-14','16:00:00',5.69),('11288','2013-07-14','16:05:00',5.65),('11288','2013-07-14','16:10:00',5.58),('11288','2013-07-14','16:15:00',5.52),('11288','2013-07-14','16:20:00',5.34),('11288','2013-07-14','16:25:00',3.76),('11288','2013-07-14','16:30:00',4.28),('11288','2013-07-14','16:35:00',5.19),('11288','2013-07-14','16:40:00',5.2),('11288','2013-07-14','16:45:00',3.86),('11288','2013-07-14','16:50:00',2.56),('11288','2013-07-14','16:55:00',3.77),('11288','2013-07-14','17:00:00',3.94),('11288','2013-07-14','17:05:00',2.46),('11288','2013-07-14','17:10:00',3.33),('11288','2013-07-14','17:15:00',4.02),('11288','2013-07-14','17:20:00',2.07),('11288','2013-07-14','17:25:00',3.69),('11288','2013-07-14','17:30:00',3.95),('11288','2013-07-14','17:35:00',3.79),('11288','2013-07-14','17:40:00',2.79),('11288','2013-07-14','17:45:00',3.04),('11288','2013-07-14','17:50:00',2.5),('11288','2013-07-14','17:55:00',2.39),('11288','2013-07-14','18:00:00',2.64),('11288','2013-07-14','18:05:00',2.46),('11288','2013-07-14','18:10:00',1.38),('11288','2013-07-14','18:40:00',1.17),('11288','2013-07-14','18:45:00',1.39),('11288','2013-07-14','18:50:00',1.26),('11288','2013-07-14','18:55:00',1.07),('11288','2013-07-14','19:10:00',1.34),('11288','2013-07-14','19:15:00',1.5),('11288','2013-07-14','19:20:00',1.54),('11288','2013-07-14','19:25:00',1.13),('11288','2013-07-13','07:30:00',1.13),('11288','2013-07-13','07:35:00',1.24),('11288','2013-07-13','07:40:00',1.41),('11288','2013-07-13','07:45:00',1.58),('11288','2013-07-13','07:50:00',1.65),('11288','2013-07-13','07:55:00',1.78),('11288','2013-07-13','08:00:00',1.93),('11288','2013-07-13','08:05:00',2.05),('11288','2013-07-13','08:10:00',2.06),('11288','2013-07-13','08:15:00',2.24),('11288','2013-07-13','08:20:00',2.39),('11288','2013-07-13','08:25:00',2.39),('11288','2013-07-13','08:30:00',2.58),('11288','2013-07-13','08:35:00',2.78),('11288','2013-07-13','08:40:00',2.91),('11288','2013-07-13','08:45:00',2.96),('11288','2013-07-13','08:50:00',3.32),('11288','2013-07-13','08:55:00',3.33),('11288','2013-07-13','09:00:00',3.43),('11288','2013-07-13','09:05:00',3.62),('11288','2013-07-13','09:10:00',3.54),('11288','2013-07-13','09:15:00',3.63),('11288','2013-07-13','09:20:00',3.93),('11288','2013-07-13','09:25:00',4.06),('11288','2013-07-13','09:30:00',4.21),('11288','2013-07-13','09:35:00',4.28),('11288','2013-07-13','09:40:00',4.34),('11288','2013-07-13','09:45:00',4.45),('11288','2013-07-13','09:50:00',4.69),('11288','2013-07-13','09:55:00',4.82),('11288','2013-07-13','10:00:00',4.93),('11288','2013-07-13','10:05:00',5.09),('11288','2013-07-13','10:10:00',5.18),('11288','2013-07-13','10:15:00',5.09),('11288','2013-07-13','10:20:00',4.46),('11288','2013-07-13','10:25:00',3.66),('11288','2013-07-13','10:30:00',5.42),('11288','2013-07-13','10:35:00',5.74),('11288','2013-07-13','10:40:00',5.88),('11288','2013-07-13','10:45:00',6.02),('11288','2013-07-13','10:50:00',6.18),('11288','2013-07-13','10:55:00',6.14),('11288','2013-07-13','11:00:00',6.66),('11288','2013-07-13','11:05:00',5.93),('11288','2013-07-13','11:10:00',5.52),('11288','2013-07-13','11:15:00',5.45),('11288','2013-07-13','11:20:00',1.76),('11288','2013-07-13','11:25:00',2.04),('11288','2013-07-13','11:30:00',7.28),('11288','2013-07-13','11:35:00',6.9),('11288','2013-07-13','11:40:00',2.23),('11288','2013-07-13','11:45:00',1.68),('11288','2013-07-13','11:50:00',7.23),('11288','2013-07-13','11:55:00',5.92),('11288','2013-07-13','12:00:00',3.31),('11288','2013-07-13','12:05:00',6.58),('11288','2013-07-13','12:10:00',7.1),('11288','2013-07-13','12:15:00',7.26),('11288','2013-07-13','12:20:00',2.5),('11288','2013-07-13','12:25:00',6.17),('11288','2013-07-13','12:30:00',7.3),('11288','2013-07-13','12:35:00',6.97),('11288','2013-07-13','12:40:00',7.27),('11288','2013-07-13','12:45:00',5.95),('11288','2013-07-13','12:50:00',1.75),('11288','2013-07-13','12:55:00',4.09),('11288','2013-07-13','13:00:00',7.61),('11288','2013-07-13','13:05:00',7.48),('11288','2013-07-13','13:10:00',7.21),('11288','2013-07-13','13:15:00',7.13),('11288','2013-07-13','13:20:00',7.09),('11288','2013-07-13','13:25:00',6.99),('11288','2013-07-13','13:30:00',7.03),('11288','2013-07-13','13:35:00',7.09),('11288','2013-07-13','13:40:00',6.99),('11288','2013-07-13','13:45:00',6.98),('11288','2013-07-13','13:50:00',6.95),('11288','2013-07-13','13:55:00',6.92),('11288','2013-07-13','14:00:00',6.96),('11288','2013-07-13','14:05:00',6.94),('11288','2013-07-13','14:10:00',6.91),('11288','2013-07-13','14:15:00',6.86),('11288','2013-07-13','14:20:00',6.8),('11288','2013-07-13','14:25:00',6.78),('11288','2013-07-13','14:30:00',6.77),('11288','2013-07-13','14:35:00',6.72),('11288','2013-07-13','14:40:00',6.68),('11288','2013-07-13','14:45:00',6.73),('11288','2013-07-13','14:50:00',6.66),('11288','2013-07-13','14:55:00',6.66),('11288','2013-07-13','15:00:00',6.62),('11288','2013-07-13','15:05:00',6.62),('11288','2013-07-13','15:10:00',6.55),('11288','2013-07-13','15:15:00',6.55),('11288','2013-07-13','15:20:00',6.18),('11288','2013-07-13','15:25:00',6.5),('11288','2013-07-13','15:30:00',6.26),('11288','2013-07-13','15:35:00',6.32),('11288','2013-07-13','15:40:00',6.26),('11288','2013-07-13','15:45:00',6.16),('11288','2013-07-13','15:50:00',6.07),('11288','2013-07-13','15:55:00',6.03),('11288','2013-07-13','16:00:00',5.96),('11288','2013-07-13','16:05:00',5.81),('11288','2013-07-13','16:10:00',5.7),('11288','2013-07-13','16:15:00',5.59),('11288','2013-07-13','16:20:00',5.5),('11288','2013-07-13','16:25:00',5.47),('11288','2013-07-13','16:30:00',5.35),('11288','2013-07-13','16:35:00',5.25),('11288','2013-07-13','16:40:00',5.13),('11288','2013-07-13','16:45:00',5.01),('11288','2013-07-13','16:50:00',4.77),('11288','2013-07-13','16:55:00',4.69),('11288','2013-07-13','17:00:00',4.54),('11288','2013-07-13','17:05:00',4.35),('11288','2013-07-13','17:10:00',4.31),('11288','2013-07-13','17:15:00',4.21),('11288','2013-07-13','17:20:00',3.94),('11288','2013-07-13','17:25:00',4.01),('11288','2013-07-13','17:30:00',3.74),('11288','2013-07-13','17:35:00',3.63),('11288','2013-07-13','17:40:00',3.56),('11288','2013-07-13','17:45:00',3.43),('11288','2013-07-13','17:50:00',3.3),('11288','2013-07-13','17:55:00',3.34),('11288','2013-07-13','18:00:00',3),('11288','2013-07-13','18:05:00',2.75),('11288','2013-07-13','18:10:00',2.8),('11288','2013-07-13','18:15:00',2.69),('11288','2013-07-13','18:20:00',2.54),('11288','2013-07-13','18:25:00',2.45),('11288','2013-07-13','18:30:00',2.28),('11288','2013-07-13','18:35:00',2.14),('11288','2013-07-13','18:40:00',1.49),('11288','2013-07-13','18:45:00',1.07),('11288','2013-07-13','18:50:00',1.52),('11288','2013-07-13','18:55:00',1.74),('11288','2013-07-13','19:00:00',1.65),('11288','2013-07-13','19:05:00',1.45),('11288','2013-07-13','19:10:00',1.27),('11288','2013-07-12','07:15:00',1.03),('11288','2013-07-12','07:20:00',1.27),('11288','2013-07-12','07:25:00',1.35),('11288','2013-07-12','07:30:00',1.18),('11288','2013-07-12','07:35:00',1.02),('11288','2013-07-12','07:40:00',1.02),('11288','2013-07-12','07:45:00',1.27),('11288','2013-07-12','07:50:00',1.37),('11288','2013-07-12','08:05:00',1.51),('11288','2013-07-12','08:10:00',2.04),('11288','2013-07-12','08:15:00',2.02),('11288','2013-07-12','08:20:00',2.03),('11288','2013-07-12','08:25:00',1.43),('11288','2013-07-12','08:30:00',1.31),('11288','2013-07-12','08:35:00',1.59),('11288','2013-07-12','08:40:00',1.83),('11288','2013-07-12','08:45:00',1.95),('11288','2013-07-12','08:50:00',1.67),('11288','2013-07-12','08:55:00',1.28),('11288','2013-07-12','09:00:00',1.33),('11288','2013-07-12','09:05:00',1.73),('11288','2013-07-12','09:10:00',2.33),('11288','2013-07-12','09:15:00',2.78),('11288','2013-07-12','09:20:00',4.19),('11288','2013-07-12','09:25:00',4.35),('11288','2013-07-12','09:30:00',2.89),('11288','2013-07-12','09:35:00',4.08),('11288','2013-07-12','09:40:00',4.26),('11288','2013-07-12','09:45:00',4.56),('11288','2013-07-12','09:50:00',4.8),('11288','2013-07-12','09:55:00',4.85),('11288','2013-07-12','10:00:00',4.82),('11288','2013-07-12','10:05:00',4.7),('11288','2013-07-12','10:10:00',5.42),('11288','2013-07-12','10:15:00',5.47),('11288','2013-07-12','10:20:00',5.73),('11288','2013-07-12','10:25:00',2.94),('11288','2013-07-12','10:30:00',1.72),('11288','2013-07-12','10:35:00',1.45),('11288','2013-07-12','10:40:00',1.97),('11288','2013-07-12','10:45:00',4.74),('11288','2013-07-12','10:50:00',6.38),('11288','2013-07-12','10:55:00',6.71),('11288','2013-07-12','11:00:00',3.36),('11288','2013-07-12','11:05:00',2.52),('11288','2013-07-12','11:10:00',4.31),('11288','2013-07-12','11:15:00',5.78),('11288','2013-07-12','11:20:00',7.09),('11288','2013-07-12','11:25:00',5.99),('11288','2013-07-12','11:30:00',5.13),('11288','2013-07-12','11:35:00',6.26),('11288','2013-07-12','11:40:00',6.97),('11288','2013-07-12','11:45:00',2.6),('11288','2013-07-12','11:50:00',6.36),('11288','2013-07-12','11:55:00',6.66),('11288','2013-07-12','12:00:00',7.38),('11288','2013-07-12','12:05:00',3.02),('11288','2013-07-12','12:10:00',4.6),('11288','2013-07-12','12:15:00',7.8),('11288','2013-07-12','12:20:00',5.31),('11288','2013-07-12','12:25:00',6.97),('11288','2013-07-12','12:30:00',7.66),('11288','2013-07-12','12:35:00',6.57),('11288','2013-07-12','12:40:00',7.68),('11288','2013-07-12','12:45:00',7.57),('11288','2013-07-12','12:50:00',6.61),('11288','2013-07-12','12:55:00',7.23),('11288','2013-07-12','13:00:00',7.12),('11288','2013-07-12','13:05:00',5.66),('11288','2013-07-12','13:10:00',7.28),('11288','2013-07-12','13:15:00',7.23),('11288','2013-07-12','13:20:00',7.08),('11288','2013-07-12','13:25:00',6.98),('11288','2013-07-12','13:30:00',7.02),('11288','2013-07-12','13:35:00',7.01),('11288','2013-07-12','13:40:00',7.06),('11288','2013-07-12','13:45:00',6.58),('11288','2013-07-12','13:50:00',7.21),('11288','2013-07-12','13:55:00',5.24),('11288','2013-07-12','14:00:00',7.42),('11288','2013-07-12','14:05:00',4.39),('11288','2013-07-12','14:10:00',3.97),('11288','2013-07-12','14:15:00',7.68),('11288','2013-07-12','14:20:00',6.7),('11288','2013-07-12','14:25:00',7.18),('11288','2013-07-12','14:30:00',5.67),('11288','2013-07-12','14:35:00',6.85),('11288','2013-07-12','14:40:00',6.68),('11288','2013-07-12','14:45:00',6.61),('11288','2013-07-12','14:50:00',6.6),('11288','2013-07-12','14:55:00',6.54),('11288','2013-07-12','15:00:00',6.37),('11288','2013-07-12','15:05:00',6.47),('11288','2013-07-12','15:10:00',6.42),('11288','2013-07-12','15:15:00',6.33),('11288','2013-07-12','15:20:00',6.32),('11288','2013-07-12','15:25:00',6.18),('11288','2013-07-12','15:30:00',5.4),('11288','2013-07-12','15:35:00',6.04),('11288','2013-07-12','15:40:00',6.06),('11288','2013-07-12','15:45:00',5.93),('11288','2013-07-12','15:50:00',5.83),('11288','2013-07-12','15:55:00',5.77),('11288','2013-07-12','16:00:00',5.74),('11288','2013-07-12','16:05:00',5.61),('11288','2013-07-12','16:10:00',5.52),('11288','2013-07-12','16:15:00',5.37),('11288','2013-07-12','16:20:00',5.29),('11288','2013-07-12','16:25:00',5.2),('11288','2013-07-12','16:30:00',5.12),('11288','2013-07-12','16:35:00',5.07),('11288','2013-07-12','16:40:00',4.94),('11288','2013-07-12','16:45:00',4.87),('11288','2013-07-12','16:50:00',4.64),('11288','2013-07-12','16:55:00',4.47),('11288','2013-07-12','17:00:00',4.28),('11288','2013-07-12','17:05:00',4.35),('11288','2013-07-12','17:10:00',4.23),('11288','2013-07-12','17:15:00',4.1),('11288','2013-07-12','17:20:00',3.94),('11288','2013-07-12','17:25:00',3.8),('11288','2013-07-12','17:30:00',3.68),('11288','2013-07-12','17:35:00',3.58),('11288','2013-07-12','17:40:00',3.43),('11288','2013-07-12','17:45:00',3.29),('11288','2013-07-12','17:50:00',3.29),('11288','2013-07-12','17:55:00',3.1),('11288','2013-07-12','18:00:00',2.93),('11288','2013-07-12','18:05:00',2.84),('11288','2013-07-12','18:10:00',2.72),('11288','2013-07-12','18:15:00',2.59),('11288','2013-07-12','18:20:00',2.38),('11288','2013-07-12','18:25:00',2.3),('11288','2013-07-12','18:30:00',2.19),('11288','2013-07-12','18:35:00',2.06),('11288','2013-07-12','18:40:00',1.91),('11288','2013-07-12','18:45:00',1.78),('11288','2013-07-12','18:50:00',1.64),('11288','2013-07-12','18:55:00',1.52),('11288','2013-07-12','19:00:00',1.39),('11288','2013-07-12','19:05:00',1.27),('11288','2013-07-12','19:10:00',1.16),('11288','2013-07-12','19:15:00',1.03),('11288','2013-07-11','07:20:00',1.11),('11288','2013-07-11','07:25:00',1.19),('11288','2013-07-11','07:30:00',1.26),('11288','2013-07-11','07:35:00',1.35),('11288','2013-07-11','07:40:00',1.46),('11288','2013-07-11','07:45:00',1.53),('11288','2013-07-11','07:50:00',1.64),('11288','2013-07-11','07:55:00',1.8),('11288','2013-07-11','08:00:00',1.99),('11288','2013-07-11','08:05:00',2.05),('11288','2013-07-11','08:10:00',2.17),('11288','2013-07-11','08:15:00',2.29),('11288','2013-07-11','08:20:00',2.4),('11288','2013-07-11','08:25:00',2.4),('11288','2013-07-11','08:30:00',2.72),('11288','2013-07-11','08:35:00',2.78),('11288','2013-07-11','08:40:00',2.8),('11288','2013-07-11','08:45:00',3.09),('11288','2013-07-11','08:50:00',3.26),('11288','2013-07-11','08:55:00',3.44),('11288','2013-07-11','09:00:00',3.67),('11288','2013-07-11','09:05:00',3.67),('11288','2013-07-11','09:10:00',3.79),('11288','2013-07-11','09:15:00',3.79),('11288','2013-07-11','09:20:00',3.86),('11288','2013-07-11','09:25:00',2.31),('11288','2013-07-11','09:30:00',4.45),('11288','2013-07-11','09:35:00',4.54),('11288','2013-07-11','09:40:00',4.73),('11288','2013-07-11','09:45:00',4.99),('11288','2013-07-11','09:50:00',5.09),('11288','2013-07-11','09:55:00',4.04),('11288','2013-07-11','10:00:00',3.2),('11288','2013-07-11','10:05:00',4.83),('11288','2013-07-11','10:10:00',5.68),('11288','2013-07-11','10:15:00',4.91),('11288','2013-07-11','10:20:00',5.47),('11288','2013-07-11','10:25:00',5.46),('11288','2013-07-11','10:30:00',4.09),('11288','2013-07-11','10:35:00',4.7),('11288','2013-07-11','10:40:00',4.65),('11288','2013-07-11','10:45:00',6.25),('11288','2013-07-11','10:50:00',4.86),('11288','2013-07-11','10:55:00',4.86),('11288','2013-07-11','11:00:00',6.76),('11288','2013-07-11','11:05:00',6.65),('11288','2013-07-11','11:10:00',6.66),('11288','2013-07-11','11:15:00',6.85),('11288','2013-07-11','11:20:00',5.49),('11288','2013-07-11','11:25:00',6.65),('11288','2013-07-11','11:30:00',4.47),('11288','2013-07-11','11:35:00',2.74),('11288','2013-07-11','11:40:00',6.87),('11288','2013-07-11','11:45:00',2.83),('11288','2013-07-11','11:50:00',7.23),('11288','2013-07-11','11:55:00',7.61),('11288','2013-07-11','12:00:00',5.79),('11288','2013-07-11','12:05:00',1.72),('11288','2013-07-11','12:10:00',4.38),('11288','2013-07-11','12:15:00',7.35),('11288','2013-07-11','12:20:00',7.47),('11288','2013-07-11','12:25:00',7.45),('11288','2013-07-11','12:30:00',7.43),('11288','2013-07-11','12:35:00',7.28),('11288','2013-07-11','12:40:00',7.46),('11288','2013-07-11','12:45:00',7.28),('11288','2013-07-11','12:50:00',5.74),('11288','2013-07-11','12:55:00',5.98),('11288','2013-07-11','13:00:00',7.32),('11288','2013-07-11','13:05:00',7.21),('11288','2013-07-11','13:10:00',6.03),('11288','2013-07-11','13:15:00',7.29),('11288','2013-07-11','13:20:00',6.96),('11288','2013-07-11','13:25:00',5.5),('11288','2013-07-11','13:30:00',7.24),('11288','2013-07-11','13:35:00',7.48),('11288','2013-07-11','13:40:00',6.65),('11288','2013-07-11','13:45:00',5.4),('11288','2013-07-11','13:50:00',3.9),('11288','2013-07-11','13:55:00',5.35),('11288','2013-07-11','14:00:00',7.32),('11288','2013-07-11','14:05:00',6.95),('11288','2013-07-11','14:10:00',6.52),('11288','2013-07-11','14:15:00',6.87),('11288','2013-07-11','14:20:00',7.08),('11288','2013-07-11','14:25:00',7.1),('11288','2013-07-11','14:30:00',6.99),('11288','2013-07-11','14:35:00',6.94),('11288','2013-07-11','14:40:00',6.02),('11288','2013-07-11','14:45:00',6.88),('11288','2013-07-11','14:50:00',6.77),('11288','2013-07-11','14:55:00',6.68),('11288','2013-07-11','15:00:00',4.76),('11288','2013-07-11','15:05:00',3.06),('11288','2013-07-11','15:10:00',5.48),('11288','2013-07-11','15:15:00',2.88),('11288','2013-07-11','15:20:00',4.21),('11288','2013-07-11','15:25:00',5.47),('11288','2013-07-11','15:30:00',6.19),('11288','2013-07-11','15:35:00',4.05),('11288','2013-07-11','15:40:00',5.67),('11288','2013-07-11','15:45:00',5.09),('11288','2013-07-11','15:50:00',4.04),('11288','2013-07-11','15:55:00',2.89),('11288','2013-07-11','16:00:00',5.36),('11288','2013-07-11','16:05:00',5.05),('11288','2013-07-11','16:10:00',5.17),('11288','2013-07-11','16:15:00',3.97),('11288','2013-07-11','16:20:00',4.23),('11288','2013-07-11','16:25:00',2.67),('11288','2013-07-11','16:30:00',4.71),('11288','2013-07-11','16:35:00',3.19),('11288','2013-07-11','16:40:00',5.59),('11288','2013-07-11','16:45:00',5.68),('11288','2013-07-11','16:50:00',4.91),('11288','2013-07-11','16:55:00',4.43),('11288','2013-07-11','17:00:00',3.17),('11288','2013-07-11','17:05:00',4.61),('11288','2013-07-11','17:10:00',4.5),('11288','2013-07-11','17:15:00',4.05),('11288','2013-07-11','17:20:00',4.55),('11288','2013-07-11','17:25:00',3.66),('11288','2013-07-11','17:30:00',3.87),('11288','2013-07-11','17:35:00',3.55),('11288','2013-07-11','17:40:00',2.67),('11288','2013-07-11','17:45:00',3.37),('11288','2013-07-11','17:50:00',2.59),('11288','2013-07-11','17:55:00',3.32),('11288','2013-07-11','18:00:00',2.69),('11288','2013-07-11','18:05:00',2.46),('11288','2013-07-11','18:10:00',2.98),('11288','2013-07-11','18:15:00',2.81),('11288','2013-07-11','18:20:00',2.13),('11288','2013-07-11','18:25:00',2.12),('11288','2013-07-11','18:30:00',1.58),('11288','2013-07-11','18:35:00',1.7),('11288','2013-07-11','18:40:00',1.46),('11288','2013-07-11','18:45:00',1.34),('11288','2013-07-11','18:50:00',1.17),('11288','2013-07-11','18:55:00',1.42),('11288','2013-07-11','19:00:00',1.2),('11288','2013-07-11','19:05:00',1.01),('11288','2013-07-11','19:10:00',1.16),('11288','2013-07-11','19:15:00',1.03),('11288','2014-05-03','07:35:00',1.07),('11288','2014-05-03','07:40:00',1.21),('11288','2014-05-03','07:45:00',1.36),('11288','2014-05-03','07:50:00',1.38),('11288','2014-05-03','07:55:00',1.55),('11288','2014-05-03','08:00:00',1.67),('11288','2014-05-03','08:05:00',1.93),('11288','2014-05-03','08:10:00',2.64),('11288','2014-05-03','08:15:00',2.21),('11288','2014-05-03','08:20:00',1.76),('11288','2014-05-03','08:25:00',1.87),('11288','2014-05-03','08:30:00',2.07),('11288','2014-05-03','08:35:00',1.38),('11288','2014-05-03','08:40:00',1.42),('11288','2014-05-03','08:45:00',2.66),('11288','2014-05-03','08:50:00',3.82),('11288','2014-05-03','08:55:00',4.07),('11288','2014-05-03','09:00:00',3.23),('11288','2014-05-03','09:05:00',3.32),('11288','2014-05-03','09:10:00',2.6),('11288','2014-05-03','09:15:00',3.56),('11288','2014-05-03','09:20:00',5.23),('11288','2014-05-03','09:25:00',2.77),('11288','2014-05-03','09:30:00',4.84),('11288','2014-05-03','09:35:00',4.87),('11288','2014-05-03','09:40:00',3.86),('11288','2014-05-03','09:45:00',4.92),('11288','2014-05-03','09:50:00',2.99),('11288','2014-05-03','09:55:00',5.69),('11288','2014-05-03','10:00:00',5.79),('11288','2014-05-03','10:05:00',5.77),('11288','2014-05-03','10:10:00',5.5),('11288','2014-05-03','10:15:00',6.02),('11288','2014-05-03','10:20:00',2.23),('11288','2014-05-03','10:25:00',2.35),('11288','2014-05-03','10:30:00',4.41),('11288','2014-05-03','10:35:00',2.02),('11288','2014-05-03','10:40:00',2.89),('11288','2014-05-03','10:45:00',2.01),('11288','2014-05-03','10:50:00',2.12),('11288','2014-05-03','10:55:00',4.13),('11288','2014-05-03','11:00:00',3.36),('11288','2014-05-03','11:05:00',7.13),('11288','2014-05-03','11:10:00',6.97),('11288','2014-05-03','11:15:00',8.05),('11288','2014-05-03','11:20:00',7.79),('11288','2014-05-03','11:25:00',6.78),('11288','2014-05-03','11:30:00',7.44),('11288','2014-05-03','11:35:00',4.55),('11288','2014-05-03','11:40:00',5.31),('11288','2014-05-03','11:45:00',4.43),('11288','2014-05-03','11:50:00',4.1),('11288','2014-05-03','11:55:00',4),('11288','2014-05-03','12:00:00',2.97),('11288','2014-05-03','12:05:00',2.45),('11288','2014-05-03','12:10:00',2.29),('11288','2014-05-03','12:15:00',2.17),('11288','2014-05-03','12:20:00',2.08),('11288','2014-05-03','12:25:00',2.25),('11288','2014-05-03','12:30:00',3.03),('11288','2014-05-03','12:35:00',3.93),('11288','2014-05-03','12:40:00',3.85),('11288','2014-05-03','12:45:00',3.65),('11288','2014-05-03','12:50:00',3.09),('11288','2014-05-03','12:55:00',3.04),('11288','2014-05-03','13:00:00',3.46),('11288','2014-05-03','13:05:00',4.2),('11288','2014-05-03','13:10:00',5.19),('11288','2014-05-03','13:15:00',4.69),('11288','2014-05-03','13:20:00',4.46),('11288','2014-05-03','13:25:00',5.24),('11288','2014-05-03','13:30:00',5.68),('11288','2014-05-03','13:35:00',5.31),('11288','2014-05-03','13:40:00',3.47),('11288','2014-05-03','13:45:00',3.26),('11288','2014-05-03','13:50:00',3.22),('11288','2014-05-03','13:55:00',3.25),('11288','2014-05-03','14:00:00',3.23),('11288','2014-05-03','14:05:00',3.35),('11288','2014-05-03','14:10:00',3.72),('11288','2014-05-03','14:15:00',4.42),('11288','2014-05-03','14:20:00',4.99),('11288','2014-05-03','14:25:00',5.54),('11288','2014-05-03','14:30:00',3.35),('11288','2014-05-03','14:35:00',2.59),('11288','2014-05-03','14:40:00',1.88),('11288','2014-05-03','14:45:00',1.22),('11288','2014-05-03','14:50:00',1.97),('11288','2014-05-03','14:55:00',7.44),('11288','2014-05-03','15:00:00',4.95),('11288','2014-05-03','15:05:00',2.46),('11288','2014-05-03','15:10:00',1.85),('11288','2014-05-03','15:15:00',1.26),('11288','2014-05-03','15:20:00',1.08),('11288','2014-05-03','15:25:00',1.1),('11288','2014-05-03','15:30:00',1.08),('11288','2014-05-03','15:35:00',1.09),('11288','2014-05-03','15:40:00',1.04),('11288','2014-05-03','16:25:00',1),('11288','2014-05-03','16:30:00',1.17),('11288','2014-05-03','16:35:00',1.31),('11288','2014-05-03','16:40:00',1.46),('11288','2014-05-03','16:45:00',1.59),('11288','2014-05-03','16:50:00',1.67),('11288','2014-05-03','16:55:00',1.72),('11288','2014-05-03','17:00:00',1.74),('11288','2014-05-03','17:05:00',1.75),('11288','2014-05-03','17:10:00',1.76),('11288','2014-05-03','17:15:00',1.76),('11288','2014-05-03','17:20:00',1.75),('11288','2014-05-03','17:25:00',1.75),('11288','2014-05-03','17:30:00',1.7),('11288','2014-05-03','17:35:00',1.64),('11288','2014-05-03','17:40:00',1.67),('11288','2014-05-03','17:45:00',1.71),('11288','2014-05-03','17:50:00',1.92),('11288','2014-05-03','17:55:00',2),('11288','2014-05-03','18:00:00',1.66),('11288','2014-05-03','18:05:00',1.39),('11288','2014-05-03','18:10:00',1.28),('11288','2014-05-03','18:15:00',1.18),('11288','2014-05-03','18:50:00',1.02),('11288','2014-04-06','08:15:00',1.27),('11288','2014-04-06','08:20:00',1.39),('11288','2014-04-06','08:25:00',1.59),('11288','2014-04-06','08:30:00',1.76),('11288','2014-04-06','08:35:00',1.83),('11288','2014-04-06','08:40:00',1.97),('11288','2014-04-06','08:45:00',2.14),('11288','2014-04-06','08:50:00',2.38),('11288','2014-04-06','09:10:00',1.66),('11288','2014-04-06','09:15:00',3.28),('11288','2014-04-06','09:20:00',2.95),('11288','2014-04-06','09:25:00',2.52),('11288','2014-04-06','09:30:00',2.74),('11288','2014-04-06','09:35:00',3.38),('11288','2014-04-06','09:40:00',3.83),('11288','2014-04-06','09:45:00',4.47),('11288','2014-04-06','09:50:00',5.12),('11288','2014-04-06','09:55:00',4.99),('11288','2014-04-06','10:00:00',5.5),('11288','2014-04-06','10:05:00',3.16),('11288','2014-04-06','10:10:00',2.51),('11288','2014-04-06','10:15:00',2.99),('11288','2014-04-06','10:20:00',2.44),('11288','2014-04-06','10:25:00',2.19),('11288','2014-04-06','10:30:00',2.35),('11288','2014-04-06','10:35:00',2.6),('11288','2014-04-06','10:40:00',2.84),('11288','2014-04-06','10:45:00',4.36),('11288','2014-04-06','10:50:00',6.03),('11288','2014-04-06','10:55:00',2.49),('11288','2014-04-06','11:00:00',5.58),('11288','2014-04-06','11:05:00',5.98),('11288','2014-04-06','11:10:00',6.64),('11288','2014-04-06','11:15:00',3.71),('11288','2014-04-06','11:20:00',5.1),('11288','2014-04-06','11:25:00',6.49),('11288','2014-04-06','11:30:00',6.72),('11288','2014-04-06','11:35:00',7.22),('11288','2014-04-06','11:40:00',6.91),('11288','2014-04-06','11:45:00',6.93),('11288','2014-04-06','11:50:00',6.24),('11288','2014-04-06','11:55:00',6.31),('11288','2014-04-06','12:00:00',6.95),('11288','2014-04-06','12:05:00',6.91),('11288','2014-04-06','12:10:00',6.86),('11288','2014-04-06','12:15:00',7.06),('11288','2014-04-06','12:20:00',6.19),('11288','2014-04-06','12:25:00',3.43),('11288','2014-04-06','12:30:00',2.98),('11288','2014-04-06','12:35:00',3.74),('11288','2014-04-06','12:40:00',2.25),('11288','2014-04-06','12:45:00',1.88),('11288','2014-04-06','12:50:00',1.78),('11288','2014-04-06','12:55:00',1.84),('11288','2014-04-06','13:00:00',5.36),('11288','2014-04-06','13:05:00',5.73),('11288','2014-04-06','13:10:00',6.83),('11288','2014-04-06','13:15:00',5.42),('11288','2014-04-06','13:20:00',5.52),('11288','2014-04-06','13:25:00',2.4),('11288','2014-04-06','13:30:00',4.83),('11288','2014-04-06','13:35:00',5.95),('11288','2014-04-06','13:40:00',2.38),('11288','2014-04-06','13:45:00',5.22),('11288','2014-04-06','13:50:00',6.87),('11288','2014-04-06','13:55:00',7.23),('11288','2014-04-06','14:00:00',6.92),('11288','2014-04-06','14:05:00',6.72),('11288','2014-04-06','14:10:00',6.58),('11288','2014-04-06','14:15:00',7.01),('11288','2014-04-06','14:20:00',3.63),('11288','2014-04-06','14:25:00',2.48),('11288','2014-04-06','14:30:00',1.86),('11288','2014-04-06','14:35:00',2.19),('11288','2014-04-06','14:40:00',2.36),('11288','2014-04-06','14:45:00',6.45),('11288','2014-04-06','14:50:00',5.93),('11288','2014-04-06','14:55:00',4.32),('11288','2014-04-06','15:00:00',4.81),('11288','2014-04-06','15:05:00',2.11),('11288','2014-04-06','15:10:00',4.23),('11288','2014-04-06','15:15:00',5.36),('11288','2014-04-06','15:20:00',5.11),('11288','2014-04-06','15:25:00',2.54),('11288','2014-04-06','15:30:00',2.23),('11288','2014-04-06','15:35:00',1.15),('11288','2014-04-06','15:40:00',1.23),('11288','2014-04-06','15:45:00',1.66),('11288','2014-04-06','15:50:00',2.31),('11288','2014-04-06','15:55:00',6.21),('11288','2014-04-06','16:00:00',5.68),('11288','2014-04-06','16:05:00',3.37),('11288','2014-04-06','16:10:00',3.61),('11288','2014-04-06','16:15:00',2.4),('11288','2014-04-06','16:20:00',1.09),('11288','2014-04-06','16:25:00',1.32),('11288','2014-04-06','16:30:00',1.61),('11288','2014-04-06','16:35:00',2.35),('11288','2014-04-06','16:40:00',3.12),('11288','2014-04-06','16:45:00',4.5),('11288','2014-04-06','16:50:00',4.87),('11288','2014-04-06','16:55:00',4.02),('11288','2014-04-06','17:00:00',1.53),('11288','2014-04-06','17:05:00',1.31),('11288','2014-04-06','17:10:00',1.12),('11288','2014-04-06','17:15:00',1.01),('11288','2014-04-06','17:20:00',1.27),('11288','2014-04-06','17:25:00',2.44),('11288','2014-04-06','17:30:00',2.6),('11288','2014-04-06','17:35:00',2.02),('11288','2014-04-06','17:40:00',1),('11288','2014-04-06','17:45:00',1.6),('11288','2014-04-06','17:50:00',2.26),('11288','2014-04-06','17:55:00',1.99),('11288','2014-04-06','18:00:00',1.85),('11288','2014-04-06','18:05:00',1.68),('11288','2014-04-06','18:10:00',1.57),('11288','2014-04-06','18:15:00',1.51),('11288','2014-04-06','18:20:00',1.49),('11288','2014-04-06','18:25:00',1.32),('11288','2013-07-10','07:15:00',1.15),('11288','2013-07-10','07:20:00',1.47),('11288','2013-07-10','07:25:00',1.78),('11288','2013-07-10','07:30:00',1.93),('11288','2013-07-10','07:35:00',2.14),('11288','2013-07-10','07:40:00',2.39),('11288','2013-07-10','07:45:00',2.5),('11288','2013-07-10','07:50:00',2.68),('11288','2013-07-10','07:55:00',2.89),('11288','2013-07-10','08:00:00',2.48),('11288','2013-07-10','08:05:00',2.72),('11288','2013-07-10','08:10:00',2.94),('11288','2013-07-10','08:15:00',2.86),('11288','2013-07-10','08:20:00',3.05),('11288','2013-07-10','08:25:00',2.99),('11288','2013-07-10','08:30:00',2.82),('11288','2013-07-10','08:35:00',3.22),('11288','2013-07-10','08:40:00',3.7),('11288','2013-07-10','08:45:00',3.78),('11288','2013-07-10','08:50:00',3.84),('11288','2013-07-10','08:55:00',3.7),('11288','2013-07-10','09:00:00',3.78),('11288','2013-07-10','09:05:00',3.96),('11288','2013-07-10','09:10:00',3.99),('11288','2013-07-10','09:15:00',4.22),('11288','2013-07-10','09:20:00',3.31),('11288','2013-07-10','09:25:00',2.98),('11288','2013-07-10','09:30:00',3.95),('11288','2013-07-10','09:35:00',4.34),('11288','2013-07-10','09:40:00',4.44),('11288','2013-07-10','09:45:00',4.64),('11288','2013-07-10','09:50:00',4.53),('11288','2013-07-10','09:55:00',3.7),('11288','2013-07-10','10:00:00',5.02),('11288','2013-07-10','10:05:00',5.02),('11288','2013-07-10','10:10:00',5.17),('11288','2013-07-10','10:15:00',5.34),('11288','2013-07-10','10:20:00',5.46),('11288','2013-07-10','10:25:00',5.6),('11288','2013-07-10','10:30:00',5.67),('11288','2013-07-10','10:35:00',5.76),('11288','2013-07-10','10:40:00',5.84),('11288','2013-07-10','10:45:00',5.93),('11288','2013-07-10','10:50:00',6.01),('11288','2013-07-10','10:55:00',6.03),('11288','2013-07-10','11:00:00',6.11),('11288','2013-07-10','11:05:00',6.1),('11288','2013-07-10','11:10:00',6.17),('11288','2013-07-10','11:15:00',6.24),('11288','2013-07-10','11:20:00',6.33),('11288','2013-07-10','11:25:00',6.33),('11288','2013-07-10','11:30:00',6.36),('11288','2013-07-10','11:35:00',6.44),('11288','2013-07-10','11:40:00',6.47),('11288','2013-07-10','11:45:00',6.52),('11288','2013-07-10','11:50:00',6.57),('11288','2013-07-10','11:55:00',6.6),('11288','2013-07-10','12:00:00',6.62),('11288','2013-07-10','12:05:00',6.66),('11288','2013-07-10','12:10:00',6.72),('11288','2013-07-10','12:15:00',6.77),('11288','2013-07-10','12:20:00',6.83),('11288','2013-07-10','12:25:00',6.76),('11288','2013-07-10','12:30:00',6.72),('11288','2013-07-10','12:35:00',6.91),('11288','2013-07-10','12:40:00',6.96),('11288','2013-07-10','12:45:00',6.83),('11288','2013-07-10','12:50:00',6.92),('11288','2013-07-10','12:55:00',6.9),('11288','2013-07-10','13:00:00',6.96),('11288','2013-07-10','13:05:00',6.97),('11288','2013-07-10','13:10:00',6.95),('11288','2013-07-10','13:15:00',6.86),('11288','2013-07-10','13:20:00',6.89),('11288','2013-07-10','13:25:00',6.92),('11288','2013-07-10','13:30:00',6.89),('11288','2013-07-10','13:35:00',6.97),('11288','2013-07-10','13:40:00',6.97),('11288','2013-07-10','13:45:00',6.99),('11288','2013-07-10','13:50:00',6.99),('11288','2013-07-10','13:55:00',6.97),('11288','2013-07-10','14:00:00',6.93),('11288','2013-07-10','14:05:00',6.94),('11288','2013-07-10','14:10:00',6.95),('11288','2013-07-10','14:15:00',6.93),('11288','2013-07-10','14:20:00',6.95),('11288','2013-07-10','14:25:00',6.9),('11288','2013-07-10','14:30:00',6.83),('11288','2013-07-10','14:35:00',6.81),('11288','2013-07-10','14:40:00',6.8),('11288','2013-07-10','14:45:00',6.7),('11288','2013-07-10','14:50:00',6.69),('11288','2013-07-10','14:55:00',6.65),('11288','2013-07-10','15:00:00',6.59),('11288','2013-07-10','15:05:00',6.61),('11288','2013-07-10','15:10:00',6.56),('11288','2013-07-10','15:15:00',6.48),('11288','2013-07-10','15:20:00',6.41),('11288','2013-07-10','15:25:00',6.34),('11288','2013-07-10','15:30:00',6.29),('11288','2013-07-10','15:35:00',6.21),('11288','2013-07-10','15:45:00',2.82),('11288','2013-07-10','15:50:00',5.95),('11288','2013-07-10','15:55:00',5.91),('11288','2013-07-10','16:00:00',5.84),('11288','2013-07-10','16:05:00',4.06),('11288','2013-07-10','16:10:00',5.69),('11288','2013-07-10','16:15:00',5.58),('11288','2013-07-10','16:20:00',5.43),('11288','2013-07-10','16:25:00',3.98),('11288','2013-07-10','16:30:00',4.97),('11288','2013-07-10','16:35:00',5.12),('11288','2013-07-10','16:40:00',5),('11288','2013-07-10','16:45:00',4.43),('11288','2013-07-10','16:50:00',3.94),('11288','2013-07-10','16:55:00',4.56),('11288','2013-07-10','17:00:00',4.65),('11288','2013-07-10','17:05:00',4.02),('11288','2013-07-10','17:10:00',3.22),('11288','2013-07-10','17:15:00',2.65),('11288','2013-07-10','17:20:00',3.04),('11288','2013-07-10','17:25:00',1.38),('11288','2013-07-10','17:30:00',1.1),('11288','2013-07-10','17:35:00',2.43),('11288','2013-07-10','17:40:00',2.59),('11288','2013-07-10','17:45:00',2.98),('11288','2013-07-10','17:50:00',3.41),('11288','2013-07-10','17:55:00',3.03),('11288','2013-07-10','18:00:00',3.02),('11288','2013-07-10','18:05:00',2.77),('11288','2013-07-10','18:10:00',2.39),('11288','2013-07-10','18:15:00',1.25),('11288','2013-07-10','18:20:00',2.08),('11288','2013-07-10','18:25:00',1.13),('11288','2013-07-10','18:30:00',1.01),('11288','2013-07-10','19:05:00',1.14),('11288','2013-07-10','19:10:00',1.31),('11288','2013-07-10','19:15:00',1.23),('11288','2013-07-10','19:20:00',1.09),('11288','2013-07-09','07:15:00',1.04),('11288','2013-07-09','07:20:00',1.13),('11288','2013-07-09','07:25:00',1.17),('11288','2013-07-09','07:35:00',1.04),('11288','2013-07-09','07:40:00',1.43),('11288','2013-07-09','07:45:00',1.59),('11288','2013-07-09','07:50:00',1.65),('11288','2013-07-09','07:55:00',1.88),('11288','2013-07-09','08:00:00',2.05),('11288','2013-07-09','08:05:00',2.11),('11288','2013-07-09','08:10:00',2.24),('11288','2013-07-09','08:15:00',2.34),('11288','2013-07-09','08:20:00',2.37),('11288','2013-07-09','08:25:00',2.43),('11288','2013-07-09','08:30:00',2.78),('11288','2013-07-09','08:35:00',2.81),('11288','2013-07-09','08:40:00',2.91),('11288','2013-07-09','08:45:00',3.21),('11288','2013-07-09','08:50:00',3.34),('11288','2013-07-09','08:55:00',3.48),('11288','2013-07-09','09:00:00',3.67),('11288','2013-07-09','09:05:00',3.7),('11288','2013-07-09','09:10:00',3.57),('11288','2013-07-09','09:15:00',3.87),('11288','2013-07-09','09:20:00',3.96),('11288','2013-07-09','09:25:00',3.94),('11288','2013-07-09','09:30:00',4.31),('11288','2013-07-09','09:35:00',4.38),('11288','2013-07-09','09:40:00',4.37),('11288','2013-07-09','09:45:00',4.6),('11288','2013-07-09','09:50:00',4.64),('11288','2013-07-09','09:55:00',4.66),('11288','2013-07-09','10:00:00',4.87),('11288','2013-07-09','10:05:00',4.82),('11288','2013-07-09','10:10:00',5.09),('11288','2013-07-09','10:15:00',5.26),('11288','2013-07-09','10:20:00',5.41),('11288','2013-07-09','10:25:00',5.53),('11288','2013-07-09','10:30:00',5.62),('11288','2013-07-09','10:35:00',5.7),('11288','2013-07-09','10:40:00',5.8),('11288','2013-07-09','10:45:00',5.9),('11288','2013-07-09','10:50:00',5.99),('11288','2013-07-09','10:55:00',6.07),('11288','2013-07-09','11:00:00',6.18),('11288','2013-07-09','11:05:00',6.24),('11288','2013-07-09','11:10:00',6.24),('11288','2013-07-09','11:15:00',6.36),('11288','2013-07-09','11:20:00',6.16),('11288','2013-07-09','11:25:00',4.74),('11288','2013-07-09','11:30:00',5.23),('11288','2013-07-09','11:35:00',4.78),('11288','2013-07-09','11:40:00',5.15),('11288','2013-07-09','11:45:00',4.72),('11288','2013-07-09','11:50:00',7.52),('11288','2013-07-09','11:55:00',7.3),('11288','2013-07-09','12:00:00',7.19),('11288','2013-07-09','12:05:00',7.13),('11288','2013-07-09','12:10:00',6.96),('11288','2013-07-09','12:15:00',6.9),('11288','2013-07-09','12:20:00',6.73),('11288','2013-07-09','12:25:00',6.72),('11288','2013-07-09','12:30:00',6.69),('11288','2013-07-09','12:35:00',6.77),('11288','2013-07-09','12:40:00',6.78),('11288','2013-07-09','12:45:00',6.81),('11288','2013-07-09','12:50:00',6.73),('11288','2013-07-09','12:55:00',6.62),('11288','2013-07-09','13:00:00',6.76),('11288','2013-07-09','13:05:00',6.99),('11288','2013-07-09','13:10:00',7.05),('11288','2013-07-09','13:15:00',6.94),('11288','2013-07-09','13:20:00',6.93),('11288','2013-07-09','13:25:00',7.06),('11288','2013-07-09','13:30:00',7.27),('11288','2013-07-09','13:35:00',6.9),('11288','2013-07-09','13:40:00',6.8),('11288','2013-07-09','13:45:00',6.28),('11288','2013-07-09','13:50:00',5.29),('11288','2013-07-09','13:55:00',5.56),('11288','2013-07-09','14:00:00',5.71),('11288','2013-07-09','14:05:00',5.3),('11288','2013-07-09','14:10:00',5.91),('11288','2013-07-09','14:15:00',6.15),('11288','2013-07-09','14:20:00',4.78),('11288','2013-07-09','14:25:00',5.56),('11288','2013-07-09','14:30:00',3.21),('11288','2013-07-09','14:35:00',1.86),('11288','2013-07-09','14:40:00',1.65),('11288','2013-07-09','14:45:00',1.35),('11288','2013-07-09','17:30:00',1.03),('11288','2013-07-09','17:35:00',1.06),('11288','2013-07-09','17:40:00',1.02),('11288','2013-07-08','07:35:00',1.05),('11288','2013-07-08','07:40:00',1.74),('11288','2013-07-08','07:45:00',2.01),('11288','2013-07-08','07:50:00',1.6),('11288','2013-07-08','07:55:00',1.52),('11288','2013-07-08','08:00:00',1.89),('11288','2013-07-08','08:05:00',1.89),('11288','2013-07-08','08:10:00',2.12),('11288','2013-07-08','08:15:00',2.34),('11288','2013-07-08','08:20:00',2.49),('11288','2013-07-08','08:25:00',2.58),('11288','2013-07-08','08:30:00',2.82),('11288','2013-07-08','08:35:00',2.94),('11288','2013-07-08','08:40:00',2.98),('11288','2013-07-08','08:45:00',3.26),('11288','2013-07-08','08:50:00',3.38),('11288','2013-07-08','08:55:00',3.53),('11288','2013-07-08','09:00:00',3.67),('11288','2013-07-08','09:05:00',3.69),('11288','2013-07-08','09:10:00',3.58),('11288','2013-07-08','09:15:00',3.82),('11288','2013-07-08','09:20:00',3.93),('11288','2013-07-08','09:25:00',3.77),('11288','2013-07-08','09:30:00',4.25),('11288','2013-07-08','09:35:00',4.46),('11288','2013-07-08','09:40:00',4.46),('11288','2013-07-08','09:45:00',4.7),('11288','2013-07-08','09:50:00',4.71),('11288','2013-07-08','09:55:00',4.83),('11288','2013-07-08','10:00:00',5.15),('11288','2013-07-08','10:05:00',5.22),('11288','2013-07-08','10:10:00',5.31),('11288','2013-07-08','10:15:00',5.41),('11288','2013-07-08','10:20:00',5.48),('11288','2013-07-08','10:25:00',5.61),('11288','2013-07-08','10:30:00',5.75),('11288','2013-07-08','10:35:00',5.76),('11288','2013-07-08','10:40:00',5.78),('11288','2013-07-08','10:45:00',5.89),('11288','2013-07-08','10:50:00',5.99),('11288','2013-07-08','10:55:00',6.07),('11288','2013-07-08','11:00:00',6.1),('11288','2013-07-08','11:05:00',6.18),('11288','2013-07-08','11:10:00',6.26),('11288','2013-07-08','11:15:00',6.33),('11288','2013-07-08','11:20:00',6.4),('11288','2013-07-08','11:25:00',6.49),('11288','2013-07-08','11:30:00',6.54),('11288','2013-07-08','11:35:00',6.58),('11288','2013-07-08','11:40:00',6.37),('11288','2013-07-08','11:45:00',6.49),('11288','2013-07-08','11:50:00',6.69),('11288','2013-07-08','11:55:00',6.62),('11288','2013-07-08','12:00:00',6.66),('11288','2013-07-08','12:05:00',6.86),('11288','2013-07-08','12:10:00',7.03),('11288','2013-07-08','12:15:00',7.19),('11288','2013-07-08','12:20:00',6.79),('11288','2013-07-08','12:25:00',7.06),('11288','2013-07-08','12:30:00',5.81),('11288','2013-07-08','12:35:00',6.95),('11288','2013-07-08','12:40:00',6.99),('11288','2013-07-08','12:45:00',6.95),('11288','2013-07-08','12:50:00',6.93),('11288','2013-07-08','12:55:00',7.03),('11288','2013-07-08','13:00:00',7.25),('11288','2013-07-08','13:05:00',6.97),('11288','2013-07-08','13:10:00',6.68),('11288','2013-07-08','13:15:00',7.81),('11288','2013-07-08','13:20:00',5.9),('11288','2013-07-08','13:25:00',2.06),('11288','2013-07-08','13:30:00',1.18),('11288','2013-07-08','14:00:00',1.15),('11288','2013-07-08','14:05:00',1.43),('11288','2013-07-08','14:10:00',1.55),('11288','2013-07-08','14:15:00',1.6),('11288','2013-07-08','14:20:00',1.6),('11288','2013-07-08','14:25:00',1.67),('11288','2013-07-08','14:30:00',1.83),('11288','2013-07-08','14:35:00',2.14),('11288','2013-07-08','14:40:00',2.25),('11288','2013-07-08','14:45:00',2.13),('11288','2013-07-08','14:50:00',2.09),('11288','2013-07-08','14:55:00',2.06),('11288','2013-07-08','15:00:00',1.91),('11288','2013-07-08','15:05:00',1.72),('11288','2013-07-08','15:10:00',1.57),('11288','2013-07-08','15:15:00',1.37),('11288','2013-07-08','15:20:00',1.04),('11288','2013-07-08','17:20:00',1.14),('11288','2013-07-08','17:25:00',1.45),('11288','2013-07-08','17:30:00',1.7),('11288','2013-07-08','17:35:00',1.89),('11288','2013-07-08','17:40:00',1.94),('11288','2013-07-08','17:45:00',1.92),('11288','2013-07-08','17:50:00',1.92),('11288','2013-07-08','17:55:00',1.85),('11288','2013-07-08','18:00:00',1.7),('11288','2013-07-08','18:05:00',1.53),('11288','2013-07-08','18:10:00',1.45),('11288','2013-07-08','18:15:00',1.51),('11288','2013-07-08','18:20:00',1.66),('11288','2013-07-08','18:25:00',1.69),('11288','2013-07-08','18:30:00',1.63),('11288','2013-07-08','18:35:00',1.59),('11288','2013-07-08','18:40:00',1.95),('11288','2013-07-08','18:45:00',2.16),('11288','2013-07-08','18:50:00',2.02),('11288','2013-07-08','18:55:00',1.67),('11288','2013-07-08','19:00:00',1.46),('11288','2013-07-08','19:05:00',1.16),('11288','2013-07-07','07:20:00',1.04),('11288','2013-07-07','07:25:00',1.15),('11288','2013-07-07','07:30:00',1.24),('11288','2013-07-07','07:35:00',1.31),('11288','2013-07-07','07:40:00',1.45),('11288','2013-07-07','07:45:00',1.51),('11288','2013-07-07','07:50:00',1.58),('11288','2013-07-07','07:55:00',1.88),('11288','2013-07-07','08:00:00',1.99),('11288','2013-07-07','08:05:00',2.1),('11288','2013-07-07','08:10:00',2.33),('11288','2013-07-07','08:15:00',2.39),('11288','2013-07-07','08:20:00',1.87),('11288','2013-07-07','08:25:00',2.13),('11288','2013-07-07','08:30:00',2.53),('11288','2013-07-07','08:35:00',3.12),('11288','2013-07-07','08:40:00',2.93),('11288','2013-07-07','08:45:00',1.29),('11288','2013-07-07','08:50:00',2.7),('11288','2013-07-07','08:55:00',3.66),('11288','2013-07-07','09:00:00',3.74),('11288','2013-07-07','09:05:00',3.46),('11288','2013-07-07','09:10:00',3.72),('11288','2013-07-07','09:15:00',3.93),('11288','2013-07-07','09:20:00',2.59),('11288','2013-07-07','09:25:00',3.12),('11288','2013-07-07','09:30:00',4.45),('11288','2013-07-07','09:35:00',4.66),('11288','2013-07-07','09:40:00',4.61),('11288','2013-07-07','09:45:00',4.59),('11288','2013-07-07','09:50:00',4.93),('11288','2013-07-07','09:55:00',5.15),('11288','2013-07-07','10:00:00',5.39),('11288','2013-07-07','10:05:00',5.04),('11288','2013-07-07','10:10:00',5.25),('11288','2013-07-07','10:15:00',5.3),('11288','2013-07-07','10:20:00',5.08),('11288','2013-07-07','10:25:00',5.65),('11288','2013-07-07','10:30:00',4.94),('11288','2013-07-07','10:35:00',6.06),('11288','2013-07-07','10:40:00',5.85),('11288','2013-07-07','10:45:00',5.95),('11288','2013-07-07','10:50:00',6.25),('11288','2013-07-07','10:55:00',6.23),('11288','2013-07-07','11:00:00',6.3),('11288','2013-07-07','11:05:00',6.34),('11288','2013-07-07','11:10:00',6.49),('11288','2013-07-07','11:15:00',6.52),('11288','2013-07-07','11:20:00',6.13),('11288','2013-07-07','11:25:00',5.62),('11288','2013-07-07','11:30:00',5.67),('11288','2013-07-07','11:35:00',5.69),('11288','2013-07-07','11:40:00',5.71),('11288','2013-07-07','11:45:00',5.05),('11288','2013-07-07','11:50:00',5.14),('11288','2013-07-07','11:55:00',3.84),('11288','2013-07-07','12:00:00',3.45),('11288','2013-07-07','12:05:00',6.51),('11288','2013-07-07','12:10:00',6.77),('11288','2013-07-07','12:15:00',6.75),('11288','2013-07-07','12:20:00',7.01),('11288','2013-07-07','12:25:00',6.61),('11288','2013-07-07','12:30:00',6.41),('11288','2013-07-07','12:35:00',6.75),('11288','2013-07-07','12:40:00',7.01),('11288','2013-07-07','12:45:00',7.12),('11288','2013-07-07','12:50:00',6.86),('11288','2013-07-07','12:55:00',7.21),('11288','2013-07-07','13:00:00',7.06),('11288','2013-07-07','13:05:00',6.42),('11288','2013-07-07','13:10:00',7.02),('11288','2013-07-07','13:15:00',7.11),('11288','2013-07-07','13:20:00',7),('11288','2013-07-07','13:25:00',6.04),('11288','2013-07-07','13:30:00',5.67),('11288','2013-07-07','13:35:00',7.2),('11288','2013-07-07','13:40:00',7.39),('11288','2013-07-07','13:45:00',6.79),('11288','2013-07-07','13:50:00',7.79),('11288','2013-07-07','13:55:00',6.41),('11288','2013-07-07','14:00:00',3.97),('11288','2013-07-07','14:05:00',5.86),('11288','2013-07-07','14:10:00',3.63),('11288','2013-07-07','14:15:00',2.57),('11288','2013-07-07','14:20:00',2.18),('11288','2013-07-07','14:25:00',1.92),('11288','2013-07-07','14:30:00',1.83),('11288','2013-07-07','14:35:00',1.7),('11288','2013-07-07','14:40:00',1.57),('11288','2013-07-07','14:45:00',1.44),('11288','2013-07-07','14:50:00',1.41),('11288','2013-07-07','14:55:00',1.54),('11288','2013-07-07','15:00:00',1.82),('11288','2013-07-07','15:05:00',2.07),('11288','2013-07-07','15:10:00',1.61),('11288','2013-07-07','15:15:00',1.08),('11288','2013-07-07','15:20:00',1.21),('11288','2013-07-07','15:25:00',1.1),('11288','2013-07-07','16:45:00',1.11),('11288','2013-07-07','16:50:00',1.34),('11288','2013-07-07','16:55:00',1.58),('11288','2013-07-07','17:00:00',1.77),('11288','2013-07-07','17:05:00',1.89),('11288','2013-07-07','17:10:00',1.95),('11288','2013-07-07','17:15:00',2),('11288','2013-07-07','17:20:00',2.02),('11288','2013-07-07','17:25:00',1.99),('11288','2013-07-07','17:30:00',1.92),('11288','2013-07-07','17:35:00',1.81),('11288','2013-07-07','17:40:00',1.71),('11288','2013-07-07','17:45:00',1.66),('11288','2013-07-07','17:50:00',1.63),('11288','2013-07-07','17:55:00',1.58),('11288','2013-07-07','18:00:00',1.51),('11288','2013-07-07','18:05:00',1.48),('11288','2013-07-07','18:10:00',1.43),('11288','2013-07-07','18:15:00',1.43),('11288','2013-07-07','18:20:00',1.45),('11288','2013-07-07','18:25:00',1.41),('11288','2013-07-07','18:30:00',1.33),('11288','2013-07-07','18:35:00',1.22),('11288','2013-07-07','18:40:00',1.13),('11288','2013-07-07','18:45:00',1.06),('11288','2013-07-07','18:50:00',1.04),('11288','2013-07-07','18:55:00',1.03),('11288','2013-07-06','07:20:00',1.06),('11288','2013-07-06','07:25:00',1.14),('11288','2013-07-06','07:30:00',1.22),('11288','2013-07-06','07:35:00',1.32),('11288','2013-07-06','07:40:00',1.41),('11288','2013-07-06','07:45:00',1.37),('11288','2013-07-06','07:50:00',1.55),('11288','2013-07-06','07:55:00',1.87),('11288','2013-07-06','08:00:00',1.93),('11288','2013-07-06','08:05:00',2.11),('11288','2013-07-06','08:10:00',2.22),('11288','2013-07-06','08:15:00',2.25),('11288','2013-07-06','08:20:00',2.38),('11288','2013-07-06','08:25:00',2.66),('11288','2013-07-06','08:30:00',2.71),('11288','2013-07-06','08:35:00',3),('11288','2013-07-06','08:40:00',3.07),('11288','2013-07-06','08:45:00',3.21),('11288','2013-07-06','08:50:00',3.43),('11288','2013-07-06','08:55:00',3.51),('11288','2013-07-06','09:00:00',3.6),('11288','2013-07-06','09:05:00',3.72),('11288','2013-07-06','09:10:00',3.86),('11288','2013-07-06','09:15:00',3.9),('11288','2013-07-06','09:20:00',3.97),('11288','2013-07-06','09:25:00',4.22),('11288','2013-07-06','09:30:00',4.25),('11288','2013-07-06','09:35:00',4.36),('11288','2013-07-06','09:40:00',4.53),('11288','2013-07-06','09:45:00',4.71),('11288','2013-07-06','09:50:00',4.85),('11288','2013-07-06','09:55:00',5.03),('11288','2013-07-06','10:00:00',5.04),('11288','2013-07-06','10:05:00',5.22),('11288','2013-07-06','10:10:00',5.42),('11288','2013-07-06','10:15:00',5.5),('11288','2013-07-06','10:20:00',5.59),('11288','2013-07-06','10:25:00',5.72),('11288','2013-07-06','10:30:00',5.8),('11288','2013-07-06','10:35:00',5.86),('11288','2013-07-06','10:40:00',5.91),('11288','2013-07-06','10:45:00',6.03),('11288','2013-07-06','10:50:00',6.12),('11288','2013-07-06','10:55:00',6.25),('11288','2013-07-06','11:00:00',6.34),('11288','2013-07-06','11:05:00',6.38),('11288','2013-07-06','11:10:00',6.41),('11288','2013-07-06','11:15:00',6.47),('11288','2013-07-06','11:20:00',6.44),('11288','2013-07-06','11:25:00',6.51),('11288','2013-07-06','11:30:00',6.57),('11288','2013-07-06','11:35:00',6.59),('11288','2013-07-06','11:40:00',6.57),('11288','2013-07-06','11:45:00',6.66),('11288','2013-07-06','11:50:00',6.71),('11288','2013-07-06','11:55:00',6.67),('11288','2013-07-06','12:00:00',6.76),('11288','2013-07-06','12:05:00',6.86),('11288','2013-07-06','12:10:00',7),('11288','2013-07-06','12:15:00',7.07),('11288','2013-07-06','12:20:00',7.11),('11288','2013-07-06','12:25:00',7.14),('11288','2013-07-06','12:30:00',7.11),('11288','2013-07-06','12:35:00',7.11),('11288','2013-07-06','12:40:00',7.01),('11288','2013-07-06','12:45:00',7.06),('11288','2013-07-06','12:50:00',7.08),('11288','2013-07-06','12:55:00',7.05),('11288','2013-07-06','13:00:00',7.14),('11288','2013-07-06','13:05:00',7.15),('11288','2013-07-06','13:10:00',7.06),('11288','2013-07-06','13:15:00',7.09),('11288','2013-07-06','13:20:00',7.15),('11288','2013-07-06','13:25:00',7.09),('11288','2013-07-06','13:30:00',7.17),('11288','2013-07-06','13:35:00',7.04),('11288','2013-07-06','13:40:00',7.07),('11288','2013-07-06','13:45:00',7.14),('11288','2013-07-06','13:50:00',7.05),('11288','2013-07-06','13:55:00',6.98),('11288','2013-07-06','14:00:00',7.01),('11288','2013-07-06','14:05:00',7.07),('11288','2013-07-06','14:10:00',6.97),('11288','2013-07-06','14:15:00',6.99),('11288','2013-07-06','14:20:00',5.72),('11288','2013-07-06','14:25:00',7.1),('11288','2013-07-06','14:30:00',6.9),('11288','2013-07-06','14:35:00',6.85),('11288','2013-07-06','14:40:00',6.8),('11288','2013-07-06','14:45:00',6.75),('11288','2013-07-06','14:50:00',6.37),('11288','2013-07-06','14:55:00',5.03),('11288','2013-07-06','15:00:00',5.47),('11288','2013-07-06','15:05:00',6.84),('11288','2013-07-06','15:10:00',6.68),('11288','2013-07-06','15:15:00',6.52),('11288','2013-07-06','15:20:00',6.39),('11288','2013-07-06','15:25:00',6.41),('11288','2013-07-06','15:30:00',5.47),('11288','2013-07-06','15:35:00',3.43),('11288','2013-07-06','15:40:00',1.96),('11288','2013-07-06','16:40:00',1.25),('11288','2013-07-06','16:45:00',1.72),('11288','2013-07-06','16:50:00',2.98),('11288','2013-07-06','16:55:00',2.85),('11288','2013-07-06','17:00:00',2.11),('11288','2013-07-06','17:05:00',1.98),('11288','2013-07-06','17:10:00',1.92),('11288','2013-07-06','17:15:00',2.9),('11288','2013-07-06','17:20:00',2.11),('11288','2013-07-06','17:25:00',1.85),('11288','2013-07-06','17:30:00',2.12),('11288','2013-07-06','17:35:00',2.09),('11288','2013-07-06','17:40:00',1.77),('11288','2013-07-06','17:45:00',1.68),('11288','2013-07-06','17:50:00',1.47),('11288','2013-07-06','17:55:00',1.38),('11288','2013-07-06','18:00:00',1.28),('11288','2013-07-06','18:05:00',1.18),('11288','2013-07-06','18:10:00',1.13),('11288','2013-07-06','18:15:00',1.04),('11288','2013-07-06','19:15:00',1.16),('11288','2013-07-06','19:20:00',1.08),('11288','2013-07-05','07:15:00',1.06),('11288','2013-07-05','07:20:00',1.15),('11288','2013-07-05','07:25:00',1.27),('11288','2013-07-05','07:30:00',1.31),('11288','2013-07-05','07:35:00',1.44),('11288','2013-07-05','07:40:00',1.56),('11288','2013-07-05','07:45:00',1.55),('11288','2013-07-05','07:50:00',1.7),('11288','2013-07-05','07:55:00',1.95),('11288','2013-07-05','08:00:00',2.02),('11288','2013-07-05','08:05:00',2.18),('11288','2013-07-05','08:10:00',2.35),('11288','2013-07-05','08:15:00',2.33),('11288','2013-07-05','08:20:00',2.49),('11288','2013-07-05','08:25:00',2.68),('11288','2013-07-05','08:30:00',2.76),('11288','2013-07-05','08:35:00',2.99),('11288','2013-07-05','08:40:00',3.08),('11288','2013-07-05','08:45:00',3.15),('11288','2013-07-05','08:50:00',3.43),('11288','2013-07-05','08:55:00',3.52),('11288','2013-07-05','09:00:00',3.63),('11288','2013-07-05','09:05:00',3.77),('11288','2013-07-05','09:10:00',3.85),('11288','2013-07-05','09:15:00',3.94),('11288','2013-07-05','09:20:00',4.02),('11288','2013-07-05','09:25:00',4.28),('11288','2013-07-05','09:30:00',4.28),('11288','2013-07-05','09:35:00',4.41),('11288','2013-07-05','09:40:00',4.6),('11288','2013-07-05','09:45:00',4.79),('11288','2013-07-05','09:50:00',4.91),('11288','2013-07-05','09:55:00',5.01),('11288','2013-07-05','10:00:00',5),('11288','2013-07-05','10:05:00',5.12),('11288','2013-07-05','10:10:00',5.35),('11288','2013-07-05','10:15:00',5.42),('11288','2013-07-05','10:20:00',5.55),('11288','2013-07-05','10:25:00',5.66),('11288','2013-07-05','10:30:00',5.76),('11288','2013-07-05','10:35:00',5.83),('11288','2013-07-05','10:40:00',5.91),('11288','2013-07-05','10:45:00',5.95),('11288','2013-07-05','10:50:00',6.01),('11288','2013-07-05','10:55:00',6.1),('11288','2013-07-05','11:00:00',6.15),('11288','2013-07-05','11:05:00',6.19),('11288','2013-07-05','11:10:00',6.23),('11288','2013-07-05','11:15:00',6.3),('11288','2013-07-05','11:20:00',6.38),('11288','2013-07-05','11:25:00',6.42),('11288','2013-07-05','11:30:00',6.51),('11288','2013-07-05','11:35:00',6.53),('11288','2013-07-05','11:40:00',6.54),('11288','2013-07-05','11:45:00',6.56),('11288','2013-07-05','11:50:00',6.58),('11288','2013-07-05','11:55:00',6.68),('11288','2013-07-05','12:00:00',6.68),('11288','2013-07-05','12:05:00',6.73),('11288','2013-07-05','12:10:00',6.73),('11288','2013-07-05','12:15:00',6.72),('11288','2013-07-05','12:20:00',6.89),('11288','2013-07-05','12:25:00',5.32),('11288','2013-07-05','12:30:00',6.27),('11288','2013-07-05','12:35:00',6.58),('11288','2013-07-05','12:40:00',6.13),('11288','2013-07-05','12:45:00',6.91),('11288','2013-07-05','12:50:00',6.95),('11288','2013-07-05','12:55:00',7.01),('11288','2013-07-05','13:00:00',5.47),('11288','2013-07-05','13:05:00',4.67),('11288','2013-07-05','13:10:00',6.93),('11288','2013-07-05','13:15:00',7.32),('11288','2013-07-05','13:20:00',5.31),('11288','2013-07-05','13:25:00',6.99),('11288','2013-07-05','13:30:00',6.73),('11288','2013-07-05','13:35:00',7.28),('11288','2013-07-05','13:40:00',7.24),('11288','2013-07-05','13:45:00',7.22),('11288','2013-07-05','13:50:00',7.08),('11288','2013-07-05','13:55:00',7.12),('11288','2013-07-05','14:00:00',7.16),('11288','2013-07-05','14:05:00',7.1),('11288','2013-07-05','14:10:00',6.23),('11288','2013-07-05','14:15:00',6.96),('11288','2013-07-05','14:20:00',6.87),('11288','2013-07-05','14:25:00',6.85),('11288','2013-07-05','14:30:00',6.78),('11288','2013-07-05','14:35:00',5.69),('11288','2013-07-05','14:40:00',6.54),('11288','2013-07-05','14:45:00',5.13),('11288','2013-07-05','14:50:00',5.24),('11288','2013-07-05','14:55:00',6.15),('11288','2013-07-05','15:00:00',6.74),('11288','2013-07-05','15:05:00',4.61),('11288','2013-07-05','15:10:00',6.88),('11288','2013-07-05','15:15:00',6.62),('11288','2013-07-05','15:20:00',5.47),('11288','2013-07-05','15:25:00',5),('11288','2013-07-05','15:30:00',5.59),('11288','2013-07-05','15:35:00',6.47),('11288','2013-07-05','15:40:00',6.21),('11288','2013-07-05','15:45:00',6.26),('11288','2013-07-05','15:50:00',6.1),('11288','2013-07-05','15:55:00',5.95),('11288','2013-07-05','16:00:00',5.87),('11288','2013-07-05','16:05:00',5.82),('11288','2013-07-05','16:10:00',5.67),('11288','2013-07-05','16:15:00',5.57),('11288','2013-07-05','16:20:00',5.54),('11288','2013-07-05','16:25:00',5.47),('11288','2013-07-05','16:30:00',5.35),('11288','2013-07-05','16:35:00',5.25),('11288','2013-07-05','16:40:00',5.08),('11288','2013-07-05','16:45:00',4.9),('11288','2013-07-05','16:50:00',4.61),('11288','2013-07-05','16:55:00',4.31),('11288','2013-07-05','17:00:00',4.52),('11288','2013-07-05','17:05:00',4.37),('11288','2013-07-05','17:10:00',4.29),('11288','2013-07-05','17:15:00',4.32),('11288','2013-07-05','17:20:00',4.22),('11288','2013-07-05','17:25:00',3.99),('11288','2013-07-05','17:30:00',3.86),('11288','2013-07-05','17:35:00',3.73),('11288','2013-07-05','17:40:00',3.55),('11288','2013-07-05','17:45:00',3.45),('11288','2013-07-05','17:50:00',3.24),('11288','2013-07-05','17:55:00',3.13),('11288','2013-07-05','18:00:00',3.1),('11288','2013-07-05','18:05:00',3.02),('11288','2013-07-05','18:10:00',2.69),('11288','2013-07-05','18:15:00',2.36),('11288','2013-07-05','18:20:00',2.18),('11288','2013-07-05','18:25:00',1.55),('11288','2013-07-05','18:30:00',1.95),('11288','2013-07-05','18:35:00',2),('11288','2013-07-05','18:40:00',1.94),('11288','2013-07-05','18:45:00',1.84),('11288','2013-07-05','18:50:00',1.7),('11288','2013-07-05','18:55:00',1.56),('11288','2013-07-05','19:00:00',1.43),('11288','2013-07-05','19:05:00',1.32),('11288','2013-07-05','19:10:00',1.19),('11288','2013-07-05','19:15:00',1.05),('11288','2013-07-04','08:45:00',1.08),('11288','2013-07-04','08:50:00',1.44),('11288','2013-07-04','08:55:00',1.73),('11288','2013-07-04','09:00:00',1.63),('11288','2013-07-04','09:05:00',1.33),('11288','2013-07-04','09:10:00',1.24),('11288','2013-07-04','09:15:00',1.27),('11288','2013-07-04','09:20:00',1.25),('11288','2013-07-04','09:25:00',1.39),('11288','2013-07-04','09:30:00',1.41),('11288','2013-07-04','09:35:00',1.31),('11288','2013-07-04','09:40:00',1.08),('11288','2013-07-04','10:10:00',1.06),('11288','2013-07-04','10:15:00',1.23),('11288','2013-07-04','10:20:00',1.33),('11288','2013-07-04','10:25:00',1.36),('11288','2013-07-04','10:30:00',1.39),('11288','2013-07-04','10:35:00',1.43),('11288','2013-07-04','10:40:00',1.34),('11288','2013-07-04','10:45:00',1.17),('11288','2013-07-04','10:50:00',1.07),('11288','2013-07-04','10:55:00',1.22),('11288','2013-07-04','11:00:00',1.47),('11288','2013-07-04','11:05:00',1.66),('11288','2013-07-04','11:10:00',1.94),('11288','2013-07-04','11:15:00',2.01),('11288','2013-07-04','11:20:00',1.95),('11288','2013-07-04','11:25:00',2.09),('11288','2013-07-04','11:30:00',2.29),('11288','2013-07-04','11:35:00',2.62),('11288','2013-07-04','11:40:00',2.93),('11288','2013-07-04','11:45:00',3.1),('11288','2013-07-04','11:50:00',3.06),('11288','2013-07-04','11:55:00',2.7),('11288','2013-07-04','12:00:00',2.61),('11288','2013-07-04','12:05:00',3.54),('11288','2013-07-04','12:10:00',4.37),('11288','2013-07-04','12:15:00',4.23),('11288','2013-07-04','12:20:00',4.7),('11288','2013-07-04','12:25:00',5.73),('11288','2013-07-04','12:30:00',4.72),('11288','2013-07-04','12:35:00',3.77),('11288','2013-07-04','12:40:00',2.95),('11288','2013-07-04','12:45:00',2.35),('11288','2013-07-04','12:50:00',1.9),('11288','2013-07-04','12:55:00',1.76),('11288','2013-07-04','13:00:00',2),('11288','2013-07-04','13:05:00',2.49),('11288','2013-07-04','13:10:00',3.29),('11288','2013-07-04','13:15:00',4.57),('11288','2013-07-04','13:20:00',3.84),('11288','2013-07-04','13:25:00',4.85),('11288','2013-07-04','13:30:00',4.22),('11288','2013-07-04','13:35:00',4.98),('11288','2013-07-04','13:40:00',7.76),('11288','2013-07-04','13:45:00',8.06),('11288','2013-07-04','13:50:00',9.22),('11288','2013-07-04','13:55:00',6.76),('11288','2013-07-04','14:00:00',5.46),('11288','2013-07-04','14:05:00',4.05),('11288','2013-07-04','14:10:00',3.92),('11288','2013-07-04','14:15:00',4.05),('11288','2013-07-04','14:20:00',4),('11288','2013-07-04','14:25:00',3.72),('11288','2013-07-04','14:30:00',3.71),('11288','2013-07-04','14:35:00',4.08),('11288','2013-07-04','14:40:00',4.07),('11288','2013-07-04','14:45:00',5.79),('11288','2013-07-04','14:50:00',4.86),('11288','2013-07-04','14:55:00',3.64),('11288','2013-07-04','15:00:00',3.27),('11288','2013-07-04','15:05:00',3.41),('11288','2013-07-04','15:10:00',4.96),('11288','2013-07-04','15:15:00',4.38),('11288','2013-07-04','15:20:00',4.94),('11288','2013-07-04','15:25:00',6.44),('11288','2013-07-04','15:30:00',4.61),('11288','2013-07-04','15:35:00',3.76),('11288','2013-07-04','15:40:00',4.63),('11288','2013-07-04','15:45:00',6.21),('11288','2013-07-04','15:50:00',3.53),('11288','2013-07-04','15:55:00',3.62),('11288','2013-07-04','16:00:00',3.75),('11288','2013-07-04','16:05:00',4.02),('11288','2013-07-04','16:10:00',3.21),('11288','2013-07-04','16:15:00',3.22),('11288','2013-07-04','16:20:00',3.34),('11288','2013-07-04','16:25:00',4.13),('11288','2013-07-04','16:30:00',3.72),('11288','2013-07-04','16:35:00',4.64),('11288','2013-07-04','16:40:00',2.97),('11288','2013-07-04','16:45:00',2.86),('11288','2013-07-04','16:50:00',2.73),('11288','2013-07-04','16:55:00',2.6),('11288','2013-07-04','17:00:00',2.31),('11288','2013-07-04','17:05:00',2.35),('11288','2013-07-04','17:10:00',3.01),('11288','2013-07-04','17:15:00',4.17),('11288','2013-07-04','17:20:00',3.32),('11288','2013-07-04','17:25:00',4.58),('11288','2013-07-04','17:30:00',3.67),('11288','2013-07-04','17:35:00',4.01),('11288','2013-07-04','17:40:00',3.98),('11288','2013-07-04','17:45:00',3.93),('11288','2013-07-04','17:50:00',3.8),('11288','2013-07-04','17:55:00',3.1),('11288','2013-07-04','18:00:00',3.26),('11288','2013-07-04','18:05:00',3.1),('11288','2013-07-04','18:10:00',3.19),('11288','2013-07-04','18:15:00',3.18),('11288','2013-07-04','18:20:00',2.94),('11288','2013-07-04','18:25:00',2.34),('11288','2013-07-04','18:30:00',1.68),('11288','2013-07-04','18:35:00',1.59),('11288','2013-07-04','18:40:00',1.07),('11288','2013-07-03','07:15:00',1.01),('11288','2013-07-03','07:20:00',1.15),('11288','2013-07-03','07:25:00',1.23),('11288','2013-07-03','07:30:00',1.29),('11288','2013-07-03','07:35:00',1.38),('11288','2013-07-03','07:40:00',1.5),('11288','2013-07-03','07:45:00',1.55),('11288','2013-07-03','07:50:00',1.71),('11288','2013-07-03','07:55:00',1.9),('11288','2013-07-03','08:00:00',2),('11288','2013-07-03','08:05:00',2.3),('11288','2013-07-03','08:10:00',2.39),('11288','2013-07-03','08:15:00',2.38),('11288','2013-07-03','08:20:00',2.54),('11288','2013-07-03','08:25:00',2.85),('11288','2013-07-03','08:30:00',2.83),('11288','2013-07-03','08:35:00',3.08),('11288','2013-07-03','08:40:00',3.2),('11288','2013-07-03','08:45:00',3.28),('11288','2013-07-03','08:50:00',3.5),('11288','2013-07-03','08:55:00',3.69),('11288','2013-07-03','09:00:00',3.72),('11288','2013-07-03','09:05:00',3.89),('11288','2013-07-03','09:10:00',4.02),('11288','2013-07-03','09:15:00',3.96),('11288','2013-07-03','09:20:00',4.13),('11288','2013-07-03','09:25:00',4.45),('11288','2013-07-03','09:30:00',4.39),('11288','2013-07-03','09:35:00',4.49),('11288','2013-07-03','09:40:00',4.67),('11288','2013-07-03','09:45:00',4.84),('11288','2013-07-03','09:50:00',4.99),('11288','2013-07-03','09:55:00',5.13),('11288','2013-07-03','10:00:00',5.21),('11288','2013-07-03','10:05:00',5.29),('11288','2013-07-03','10:10:00',5.42),('11288','2013-07-03','10:15:00',5.49),('11288','2013-07-03','10:20:00',5.52),('11288','2013-07-03','10:25:00',5.61),('11288','2013-07-03','10:30:00',5.8),('11288','2013-07-03','10:35:00',5.86),('11288','2013-07-03','10:40:00',5.98),('11288','2013-07-03','10:45:00',6),('11288','2013-07-03','10:50:00',6.07),('11288','2013-07-03','10:55:00',6.18),('11288','2013-07-03','11:00:00',6.28),('11288','2013-07-03','11:05:00',6.34),('11288','2013-07-03','11:10:00',6.43),('11288','2013-07-03','11:15:00',6.51),('11288','2013-07-03','11:20:00',6.5),('11288','2013-07-03','11:25:00',6.45),('11288','2013-07-03','11:30:00',6.51),('11288','2013-07-03','11:35:00',6.6),('11288','2013-07-03','11:40:00',6.77),('11288','2013-07-03','11:45:00',6.79),('11288','2013-07-03','11:50:00',6.73),('11288','2013-07-03','11:55:00',6.81),('11288','2013-07-03','12:00:00',6.84),('11288','2013-07-03','12:05:00',6.89),('11288','2013-07-03','12:10:00',6.89),('11288','2013-07-03','12:15:00',6.89),('11288','2013-07-03','12:20:00',6.91),('11288','2013-07-03','12:25:00',7),('11288','2013-07-03','12:30:00',7.09),('11288','2013-07-03','12:35:00',7.1),('11288','2013-07-03','12:40:00',7.06),('11288','2013-07-03','12:45:00',7.07),('11288','2013-07-03','12:50:00',7.13),('11288','2013-07-03','12:55:00',7.15),('11288','2013-07-03','13:00:00',7.15),('11288','2013-07-03','13:05:00',7.18),('11288','2013-07-03','13:10:00',7.18),('11288','2013-07-03','13:15:00',7.19),('11288','2013-07-03','13:20:00',7.13),('11288','2013-07-03','13:25:00',7.14),('11288','2013-07-03','13:30:00',7.12),('11288','2013-07-03','13:35:00',7.1),('11288','2013-07-03','13:40:00',7.09),('11288','2013-07-03','13:45:00',7.1),('11288','2013-07-03','13:50:00',7.13),('11288','2013-07-03','13:55:00',7.08),('11288','2013-07-03','14:00:00',7.08),('11288','2013-07-03','14:05:00',7.08),('11288','2013-07-03','14:10:00',7.01),('11288','2013-07-03','14:15:00',7.02),('11288','2013-07-03','14:20:00',7),('11288','2013-07-03','14:25:00',7),('11288','2013-07-03','14:30:00',6.98),('11288','2013-07-03','14:35:00',6.93),('11288','2013-07-03','14:40:00',6.87),('11288','2013-07-03','14:45:00',6.82),('11288','2013-07-03','14:50:00',6.8),('11288','2013-07-03','14:55:00',6.78),('11288','2013-07-03','15:00:00',6.73),('11288','2013-07-03','15:05:00',6.68),('11288','2013-07-03','15:10:00',6.66),('11288','2013-07-03','15:15:00',6.63),('11288','2013-07-03','15:20:00',6.54),('11288','2013-07-03','15:25:00',6.48),('11288','2013-07-03','15:30:00',6.44),('11288','2013-07-03','15:35:00',6.36),('11288','2013-07-03','15:40:00',6.27),('11288','2013-07-03','15:45:00',6.19),('11288','2013-07-03','15:50:00',6.12),('11288','2013-07-03','15:55:00',6.05),('11288','2013-07-03','16:00:00',5.99),('11288','2013-07-03','16:05:00',5.93),('11288','2013-07-03','16:10:00',5.82),('11288','2013-07-03','16:15:00',5.75),('11288','2013-07-03','16:20:00',5.61),('11288','2013-07-03','16:25:00',5.49),('11288','2013-07-03','16:30:00',5.43),('11288','2013-07-03','16:35:00',5.34),('11288','2013-07-03','16:40:00',5.17),('11288','2013-07-03','16:45:00',4.93),('11288','2013-07-03','16:50:00',4.7),('11288','2013-07-03','16:55:00',4.69),('11288','2013-07-03','17:00:00',4.75),('11288','2013-07-03','17:05:00',4.63),('11288','2013-07-03','17:10:00',4.5),('11288','2013-07-03','17:15:00',4.4),('11288','2013-07-03','17:20:00',4.3),('11288','2013-07-03','17:25:00',4.18),('11288','2013-07-03','17:30:00',4.02),('11288','2013-07-03','17:35:00',3.9),('11288','2013-07-03','17:40:00',3.86),('11288','2013-07-03','17:45:00',3.75),('11288','2013-07-03','17:50:00',3.56),('11288','2013-07-03','17:55:00',3.43),('11288','2013-07-03','18:00:00',3.29),('11288','2013-07-03','18:05:00',3.1),('11288','2013-07-03','18:10:00',3.01),('11288','2013-07-03','18:15:00',2.89),('11288','2013-07-03','18:20:00',2.76),('11288','2013-07-03','18:25:00',2.63),('11288','2013-07-03','18:30:00',2.46),('11288','2013-07-03','18:35:00',2.34),('11288','2013-07-03','18:40:00',2.2),('11288','2013-07-03','18:45:00',2.08),('11288','2013-07-03','18:50:00',1.93),('11288','2013-07-03','18:55:00',1.79),('11288','2013-07-03','19:00:00',1.65),('11288','2013-07-03','19:05:00',1.52),('11288','2013-07-03','19:10:00',1.37),('11288','2013-07-03','19:15:00',1.22),('11288','2013-07-03','19:20:00',1.1),('11288','2013-07-03','19:25:00',1.01),('11288','2013-07-02','07:20:00',1.14),('11288','2013-07-02','07:25:00',1.2),('11288','2013-07-02','07:30:00',1.26),('11288','2013-07-02','07:35:00',1.38),('11288','2013-07-02','07:40:00',1.49),('11288','2013-07-02','07:45:00',1.5),('11288','2013-07-02','07:50:00',1.72),('11288','2013-07-02','07:55:00',1.82),('11288','2013-07-02','08:00:00',2),('11288','2013-07-02','08:05:00',2.25),('11288','2013-07-02','08:10:00',2.28),('11288','2013-07-02','08:15:00',2.37),('11288','2013-07-02','08:20:00',2.55),('11288','2013-07-02','08:25:00',2.81),('11288','2013-07-02','08:30:00',2.8),('11288','2013-07-02','08:35:00',3.09),('11288','2013-07-02','08:40:00',3.18),('11288','2013-07-02','08:45:00',3.22),('11288','2013-07-02','08:50:00',3.47),('11288','2013-07-02','08:55:00',3.64),('11288','2013-07-02','09:00:00',3.67),('11288','2013-07-02','09:05:00',3.86),('11288','2013-07-02','09:10:00',3.94),('11288','2013-07-02','09:15:00',3.86),('11288','2013-07-02','09:20:00',4.1),('11288','2013-07-02','09:25:00',4.32),('11288','2013-07-02','09:30:00',4.24),('11288','2013-07-02','09:35:00',4.45),('11288','2013-07-02','09:40:00',4.67),('11288','2013-07-02','09:45:00',4.83),('11288','2013-07-02','09:50:00',4.94),('11288','2013-07-02','09:55:00',5.1),('11288','2013-07-02','10:00:00',5.19),('11288','2013-07-02','10:05:00',5.28),('11288','2013-07-02','10:10:00',5.38),('11288','2013-07-02','10:15:00',5.48),('11288','2013-07-02','10:20:00',5.58),('11288','2013-07-02','10:25:00',5.65),('11288','2013-07-02','10:30:00',5.71),('11288','2013-07-02','10:35:00',5.75),('11288','2013-07-02','10:40:00',5.89),('11288','2013-07-02','10:45:00',5.99),('11288','2013-07-02','10:50:00',5.99),('11288','2013-07-02','10:55:00',6.11),('11288','2013-07-02','11:00:00',6.15),('11288','2013-07-02','11:05:00',6.13),('11288','2013-07-02','11:10:00',6.15),('11288','2013-07-02','11:15:00',6.27),('11288','2013-07-02','11:20:00',6.33),('11288','2013-07-02','11:25:00',6.38),('11288','2013-07-02','11:30:00',6.34),('11288','2013-07-02','11:35:00',6.42),('11288','2013-07-02','11:40:00',6.5),('11288','2013-07-02','11:45:00',6.5),('11288','2013-07-02','11:50:00',6.5),('11288','2013-07-02','11:55:00',6.56),('11288','2013-07-02','12:00:00',6.62),('11288','2013-07-02','12:05:00',6.63),('11288','2013-07-02','12:10:00',6.65),('11288','2013-07-02','12:15:00',6.61),('11288','2013-07-02','12:20:00',6.7),('11288','2013-07-02','12:25:00',6.74),('11288','2013-07-02','12:30:00',6.85),('11288','2013-07-02','12:35:00',4.58),('11288','2013-07-02','12:40:00',7.17),('11288','2013-07-02','12:45:00',7.31),('11288','2013-07-02','12:50:00',6.3),('11288','2013-07-02','12:55:00',6.07),('11288','2013-07-02','13:00:00',4.57),('11288','2013-07-02','13:05:00',5.72),('11288','2013-07-02','13:10:00',7.55),('11288','2013-07-02','13:15:00',6.46),('11288','2013-07-02','13:20:00',7.18),('11288','2013-07-02','13:25:00',7.18),('11288','2013-07-02','13:30:00',6.92),('11288','2013-07-02','13:35:00',6.99),('11288','2013-07-02','13:40:00',6.8),('11288','2013-07-02','13:45:00',6.89),('11288','2013-07-02','13:50:00',6.84),('11288','2013-07-02','13:55:00',6.84),('11288','2013-07-02','14:00:00',6.76),('11288','2013-07-02','14:05:00',6.74),('11288','2013-07-02','14:10:00',6.81),('11288','2013-07-02','14:15:00',6.86),('11288','2013-07-02','14:20:00',6.83),('11288','2013-07-02','14:25:00',6.8),('11288','2013-07-02','14:30:00',6.74),('11288','2013-07-02','14:35:00',6.73),('11288','2013-07-02','14:40:00',6.7),('11288','2013-07-02','14:45:00',6.63),('11288','2013-07-02','14:50:00',6.59),('11288','2013-07-02','14:55:00',6.54),('11288','2013-07-02','15:00:00',6.54),('11288','2013-07-02','15:05:00',6.5),('11288','2013-07-02','15:10:00',6.46),('11288','2013-07-02','15:15:00',6.39),('11288','2013-07-02','15:20:00',6.35),('11288','2013-07-02','15:25:00',6.3),('11288','2013-07-02','15:30:00',6.29),('11288','2013-07-02','15:35:00',6.24),('11288','2013-07-02','15:40:00',6.18),('11288','2013-07-02','15:45:00',6.08),('11288','2013-07-02','15:50:00',5.99),('11288','2013-07-02','15:55:00',5.95),('11288','2013-07-02','16:00:00',5.89),('11288','2013-07-02','16:05:00',5.79),('11288','2013-07-02','16:10:00',5.73),('11288','2013-07-02','16:15:00',5.61),('11288','2013-07-02','16:20:00',5.48),('11288','2013-07-02','16:25:00',5.37),('11288','2013-07-02','16:30:00',5.27),('11288','2013-07-02','16:35:00',5.19),('11288','2013-07-02','16:40:00',5.06),('11288','2013-07-02','16:45:00',4.79),('11288','2013-07-02','16:50:00',4.54),('11288','2013-07-02','16:55:00',4.61),('11288','2013-07-02','17:00:00',4.64),('11288','2013-07-02','17:05:00',4.47),('11288','2013-07-02','17:10:00',4.31),('11288','2013-07-02','17:15:00',4.23),('11288','2013-07-02','17:20:00',4.13),('11288','2013-07-02','17:25:00',4.02),('11288','2013-07-02','17:30:00',3.88),('11288','2013-07-02','17:35:00',3.73),('11288','2013-07-02','17:40:00',3.68),('11288','2013-07-02','17:45:00',3.54),('11288','2013-07-02','17:50:00',3.38),('11288','2013-07-02','17:55:00',3.26),('11288','2013-07-02','18:00:00',3.13),('11288','2013-07-02','18:05:00',3),('11288','2013-07-02','18:10:00',2.88),('11288','2013-07-02','18:15:00',2.76),('11288','2013-07-02','18:20:00',2.62),('11288','2013-07-02','18:25:00',2.49),('11288','2013-07-02','18:30:00',2.31),('11288','2013-07-02','18:35:00',2.19),('11288','2013-07-02','18:40:00',2.06),('11288','2013-07-02','18:45:00',1.95),('11288','2013-07-02','18:50:00',1.81),('11288','2013-07-02','18:55:00',1.68),('11288','2013-07-02','19:00:00',1.57),('11288','2013-07-02','19:05:00',1.46),('11288','2013-07-02','19:10:00',1.32),('11288','2013-07-02','19:15:00',1.17),('11288','2013-07-02','19:20:00',1.06),('11288','2013-07-01','07:15:00',1.05),('11288','2013-07-01','07:20:00',1.19),('11288','2013-07-01','07:25:00',1.26),('11288','2013-07-01','07:30:00',1.33),('11288','2013-07-01','07:35:00',1.46),('11288','2013-07-01','07:40:00',1.57),('11288','2013-07-01','07:45:00',1.59),('11288','2013-07-01','07:50:00',1.75),('11288','2013-07-01','07:55:00',1.98),('11288','2013-07-01','08:00:00',2.03),('11288','2013-07-01','08:05:00',2.29),('11288','2013-07-01','08:10:00',2.37),('11288','2013-07-01','08:15:00',2.45),('11288','2013-07-01','08:20:00',2.63),('11288','2013-07-01','08:25:00',2.86),('11288','2013-07-01','08:30:00',2.83),('11288','2013-07-01','08:35:00',3.13),('11288','2013-07-01','08:40:00',3.29),('11288','2013-07-01','08:45:00',3.35),('11288','2013-07-01','08:50:00',3.45),('11288','2013-07-01','08:55:00',3.77),('11288','2013-07-01','09:00:00',3.77),('11288','2013-07-01','09:05:00',3.93),('11288','2013-07-01','09:10:00',4.04),('11288','2013-07-01','09:15:00',3.94),('11288','2013-07-01','09:20:00',4.19),('11288','2013-07-01','09:25:00',4.48),('11288','2013-07-01','09:30:00',4.4),('11288','2013-07-01','09:35:00',4.6),('11288','2013-07-01','09:40:00',4.84),('11288','2013-07-01','09:45:00',4.99),('11288','2013-07-01','09:50:00',5.1),('11288','2013-07-01','09:55:00',5.15),('11288','2013-07-01','10:00:00',5.01),('11288','2013-07-01','10:05:00',5.19),('11288','2013-07-01','10:10:00',5.48),('11288','2013-07-01','10:15:00',5.58),('11288','2013-07-01','10:20:00',5.75),('11288','2013-07-01','10:25:00',5.84),('11288','2013-07-01','10:30:00',5.91),('11288','2013-07-01','10:35:00',6.02),('11288','2013-07-01','10:40:00',6.13),('11288','2013-07-01','10:45:00',6.22),('11288','2013-07-01','10:50:00',6.31),('11288','2013-07-01','10:55:00',6.41),('11288','2013-07-01','11:00:00',6.47),('11288','2013-07-01','11:05:00',6.5),('11288','2013-07-01','11:10:00',6.46),('11288','2013-07-01','11:15:00',6.61),('11288','2013-07-01','11:20:00',6.68),('11288','2013-07-01','11:25:00',6.78),('11288','2013-07-01','11:30:00',6.8),('11288','2013-07-01','11:35:00',6.77),('11288','2013-07-01','11:40:00',6.76),('11288','2013-07-01','11:45:00',6.85),('11288','2013-07-01','11:50:00',6.92),('11288','2013-07-01','11:55:00',6.96),('11288','2013-07-01','12:00:00',6.93),('11288','2013-07-01','12:05:00',6.91),('11288','2013-07-01','12:10:00',6.9),('11288','2013-07-01','12:15:00',6.93),('11288','2013-07-01','12:20:00',6.96),('11288','2013-07-01','12:25:00',6.99),('11288','2013-07-01','12:30:00',6.98),('11288','2013-07-01','12:35:00',7.06),('11288','2013-07-01','12:40:00',7.03),('11288','2013-07-01','12:45:00',7.08),('11288','2013-07-01','12:50:00',7.09),('11288','2013-07-01','12:55:00',7.1),('11288','2013-07-01','13:00:00',7.06),('11288','2013-07-01','13:05:00',7.09),('11288','2013-07-01','13:10:00',7.15),('11288','2013-07-01','13:15:00',7.1),('11288','2013-07-01','13:20:00',7.06),('11288','2013-07-01','13:25:00',7.08),('11288','2013-07-01','13:30:00',7.13),('11288','2013-07-01','13:35:00',7.16),('11288','2013-07-01','13:40:00',7.14),('11288','2013-07-01','13:45:00',7.03),('11288','2013-07-01','13:50:00',7),('11288','2013-07-01','13:55:00',7.02),('11288','2013-07-01','14:00:00',7.03),('11288','2013-07-01','14:05:00',7.02),('11288','2013-07-01','14:10:00',7.04),('11288','2013-07-01','14:15:00',7),('11288','2013-07-01','14:20:00',6.98),('11288','2013-07-01','14:25:00',6.9),('11288','2013-07-01','14:30:00',6.88),('11288','2013-07-01','14:35:00',6.87),('11288','2013-07-01','14:40:00',6.78),('11288','2013-07-01','14:45:00',6.76),('11288','2013-07-01','14:50:00',6.68),('11288','2013-07-01','14:55:00',6.58),('11288','2013-07-01','15:00:00',6.55),('11288','2013-07-01','15:05:00',6.52),('11288','2013-07-01','15:10:00',6.5),('11288','2013-07-01','15:15:00',6.45),('11288','2013-07-01','15:20:00',6.37),('11288','2013-07-01','15:25:00',6.3),('11288','2013-07-01','15:30:00',6.22),('11288','2013-07-01','15:35:00',6.14),('11288','2013-07-01','15:40:00',6.05),('11288','2013-07-01','15:45:00',6.07),('11288','2013-07-01','15:50:00',6.01),('11288','2013-07-01','15:55:00',5.9),('11288','2013-07-01','16:00:00',5.82),('11288','2013-07-01','16:05:00',5.76),('11288','2013-07-01','16:10:00',5.63),('11288','2013-07-01','16:15:00',5.52),('11288','2013-07-01','16:20:00',5.34),('11288','2013-07-01','16:25:00',5.29),('11288','2013-07-01','16:30:00',5.2),('11288','2013-07-01','16:35:00',5.09),('11288','2013-07-01','16:40:00',4.94),('11288','2013-07-01','16:45:00',4.85),('11288','2013-07-01','16:50:00',4.77),('11288','2013-07-01','16:55:00',4.69),('11288','2013-07-01','17:00:00',4.59),('11288','2013-07-01','17:05:00',4.46),('11288','2013-07-01','17:10:00',4.32),('11288','2013-07-01','17:15:00',4.24),('11288','2013-07-01','17:20:00',4.1),('11288','2013-07-01','17:25:00',3.97),('11288','2013-07-01','17:30:00',3.83),('11288','2013-07-01','17:35:00',3.69),('11288','2013-07-01','17:40:00',3.66),('11288','2013-07-01','17:45:00',3.52),('11288','2013-07-01','17:50:00',3.39),('11288','2013-07-01','17:55:00',3.26),('11288','2013-07-01','18:00:00',2.88),('11288','2013-07-01','18:05:00',2.98),('11288','2013-07-01','18:10:00',2.82),('11288','2013-07-01','18:15:00',2.22),('11288','2013-07-01','18:20:00',2.42),('11288','2013-07-01','18:25:00',2.56),('11288','2013-07-01','18:30:00',2.39),('11288','2013-07-01','18:35:00',2.24),('11288','2013-07-01','18:40:00',2),('11288','2013-07-01','18:45:00',1.9),('11288','2013-07-01','18:50:00',1.75),('11288','2013-07-01','18:55:00',1.53),('11288','2013-07-01','19:00:00',1.47),('11288','2013-07-01','19:05:00',1.38),('11288','2013-07-01','19:10:00',1.26),('11288','2013-07-01','19:20:00',1.02),('11288','2014-04-05','08:35:00',1.17),('11288','2014-04-05','08:40:00',1.2),('11288','2014-04-05','08:45:00',1.1),('11288','2014-04-05','09:00:00',1.07),('11288','2014-04-05','09:05:00',1.26),('11288','2014-04-05','09:10:00',1.47),('11288','2014-04-05','09:15:00',1.96),('11288','2014-04-05','09:20:00',2.75),('11288','2014-04-05','09:25:00',3.02),('11288','2014-04-05','09:30:00',4.66),('11288','2014-04-05','09:35:00',4.86),('11288','2014-04-05','09:40:00',5.28),('11288','2014-04-05','09:45:00',4.7),('11288','2014-04-05','09:50:00',3.16),('11288','2014-04-05','09:55:00',2.51),('11288','2014-04-05','10:00:00',3.1),('11288','2014-04-05','10:05:00',3.21),('11288','2014-04-05','10:10:00',3.36),('11288','2014-04-05','10:15:00',3.2),('11288','2014-04-05','10:20:00',3.48),('11288','2014-04-05','10:25:00',4.32),('11288','2014-04-05','10:30:00',4.12),('11288','2014-04-05','10:35:00',4.37),('11288','2014-04-05','10:40:00',5.05),('11288','2014-04-05','10:45:00',5.35),('11288','2014-04-05','10:50:00',4.48),('11288','2014-04-05','10:55:00',4.53),('11288','2014-04-05','11:00:00',5.19),('11288','2014-04-05','11:05:00',5.64),('11288','2014-04-05','11:10:00',6.13),('11288','2014-04-05','11:15:00',6.37),('11288','2014-04-05','11:20:00',6.81),('11288','2014-04-05','11:25:00',6.29),('11288','2014-04-05','11:30:00',4.44),('11288','2014-04-05','11:35:00',3.51),('11288','2014-04-05','11:40:00',4.44),('11288','2014-04-05','11:45:00',6.09),('11288','2014-04-05','11:50:00',6.53),('11288','2014-04-05','11:55:00',6.27),('11288','2014-04-05','12:00:00',6.49),('11288','2014-04-05','12:05:00',5.22),('11288','2014-04-05','12:10:00',4.94),('11288','2014-04-05','12:15:00',5.63),('11288','2014-04-05','12:20:00',5.46),('11288','2014-04-05','12:25:00',6.09),('11288','2014-04-05','12:30:00',4.83),('11288','2014-04-05','12:35:00',4.36),('11288','2014-04-05','12:40:00',4.77),('11288','2014-04-05','12:45:00',7.45),('11288','2014-04-05','12:50:00',7.07),('11288','2014-04-05','12:55:00',7.06),('11288','2014-04-05','13:00:00',6.14),('11288','2014-04-05','13:05:00',5.02),('11288','2014-04-05','13:10:00',3.5),('11288','2014-04-05','13:15:00',3.6),('11288','2014-04-05','13:20:00',4.22),('11288','2014-04-05','13:25:00',8.02),('11288','2014-04-05','13:30:00',6.37),('11288','2014-04-05','13:35:00',5.41),('11288','2014-04-05','13:40:00',3.39),('11288','2014-04-05','13:45:00',6.71),('11288','2014-04-05','13:50:00',7.24),('11288','2014-04-05','13:55:00',6.23),('11288','2014-04-05','14:00:00',5.22),('11288','2014-04-05','14:05:00',8.08),('11288','2014-04-05','14:10:00',5.54),('11288','2014-04-05','14:15:00',1.32),('11288','2014-04-05','14:20:00',1.43),('11288','2014-04-05','14:25:00',2.27),('11288','2014-04-05','14:30:00',5.4),('11288','2014-04-05','14:35:00',1.92),('11288','2014-04-05','14:40:00',1.29),('11288','2014-04-05','14:45:00',1.26),('11288','2014-04-05','14:50:00',1.11),('11288','2014-04-05','14:55:00',5.21),('11288','2014-04-05','15:00:00',6.76),('11288','2014-04-05','15:05:00',5.82),('11288','2014-04-05','15:10:00',5.8),('11288','2014-04-05','15:15:00',3.4),('11288','2014-04-05','15:20:00',6.58),('11288','2014-04-05','15:25:00',3.53),('11288','2014-04-05','15:30:00',2.81),('11288','2014-04-05','15:35:00',2.54),('11288','2014-04-05','15:40:00',3.39),('11288','2014-04-05','15:45:00',3.55),('11288','2014-04-05','15:50:00',3.99),('11288','2014-04-05','15:55:00',2.31),('11288','2014-04-05','16:00:00',2.22),('11288','2014-04-05','16:05:00',2.22),('11288','2014-04-05','16:10:00',2.11),('11288','2014-04-05','16:15:00',3.32),('11288','2014-04-05','16:20:00',5.72),('11288','2014-04-05','16:25:00',4.94),('11288','2014-04-05','16:30:00',3.19),('11288','2014-04-05','16:35:00',4.86),('11288','2014-04-05','16:40:00',2.63),('11288','2014-04-05','16:45:00',3.67),('11288','2014-04-05','16:50:00',2.94),('11288','2014-04-05','16:55:00',3.93),('11288','2014-04-05','17:00:00',2.38),('11288','2014-04-05','17:05:00',3.26),('11288','2014-04-05','17:10:00',2.72),('11288','2014-04-05','17:15:00',1.4),('11288','2014-04-05','17:20:00',1.79),('11288','2014-04-05','17:25:00',1.96),('11288','2014-04-05','17:30:00',2),('11288','2014-04-05','17:35:00',1.8),('11288','2014-04-05','17:40:00',1.47),('11288','2014-04-05','17:45:00',1.26),('11288','2014-04-05','17:50:00',1.66),('11288','2014-04-05','17:55:00',1.7),('11288','2014-04-05','18:00:00',1.69),('11288','2014-04-05','18:05:00',1.55),('11288','2014-04-05','18:10:00',1.51),('11288','2014-04-05','18:15:00',1.57),('11288','2014-04-05','18:20:00',1.5),('11288','2014-04-05','18:25:00',1.2),('11288','2013-06-30','07:15:00',1.07),('11288','2013-06-30','07:20:00',1.23),('11288','2013-06-30','07:25:00',1.31),('11288','2013-06-30','07:30:00',1.38),('11288','2013-06-30','07:35:00',1.56),('11288','2013-06-30','07:40:00',1.63),('11288','2013-06-30','07:45:00',1.61),('11288','2013-06-30','07:50:00',1.88),('11288','2013-06-30','07:55:00',2.02),('11288','2013-06-30','08:00:00',2.06),('11288','2013-06-30','08:05:00',2.42),('11288','2013-06-30','08:10:00',2.41),('11288','2013-06-30','08:15:00',2.52),('11288','2013-06-30','08:20:00',2.71),('11288','2013-06-30','08:25:00',2.9),('11288','2013-06-30','08:30:00',3),('11288','2013-06-30','08:35:00',3.25),('11288','2013-06-30','08:40:00',3.34),('11288','2013-06-30','08:45:00',3.39),('11288','2013-06-30','08:50:00',3.64),('11288','2013-06-30','08:55:00',3.89),('11288','2013-06-30','09:00:00',3.87),('11288','2013-06-30','09:05:00',4.08),('11288','2013-06-30','09:10:00',4.23),('11288','2013-06-30','09:15:00',4.15),('11288','2013-06-30','09:20:00',4.38),('11288','2013-06-30','09:25:00',4.43),('11288','2013-06-30','09:30:00',4.14),('11288','2013-06-30','09:35:00',4.42),('11288','2013-06-30','09:40:00',4.97),('11288','2013-06-30','09:45:00',5.14),('11288','2013-06-30','09:50:00',5.29),('11288','2013-06-30','09:55:00',5.3),('11288','2013-06-30','10:00:00',5.14),('11288','2013-06-30','10:05:00',5.45),('11288','2013-06-30','10:10:00',5.73),('11288','2013-06-30','10:15:00',5.83),('11288','2013-06-30','10:20:00',5.97),('11288','2013-06-30','10:25:00',6.08),('11288','2013-06-30','10:30:00',6.12),('11288','2013-06-30','10:35:00',6.2),('11288','2013-06-30','10:40:00',6.28),('11288','2013-06-30','10:45:00',6.38),('11288','2013-06-30','10:50:00',6.44),('11288','2013-06-30','10:55:00',6.5),('11288','2013-06-30','11:00:00',6.51),('11288','2013-06-30','11:05:00',6.58),('11288','2013-06-30','11:10:00',6.64),('11288','2013-06-30','11:15:00',6.66),('11288','2013-06-30','11:20:00',6.69),('11288','2013-06-30','11:25:00',6.74),('11288','2013-06-30','11:30:00',6.76),('11288','2013-06-30','11:35:00',6.81),('11288','2013-06-30','11:40:00',6.83),('11288','2013-06-30','11:45:00',6.86),('11288','2013-06-30','11:50:00',6.92),('11288','2013-06-30','11:55:00',6.98),('11288','2013-06-30','12:00:00',7),('11288','2013-06-30','12:05:00',7.04),('11288','2013-06-30','12:10:00',7.1),('11288','2013-06-30','12:15:00',7.15),('11288','2013-06-30','12:20:00',7.15),('11288','2013-06-30','12:25:00',7.1),('11288','2013-06-30','12:30:00',7.1),('11288','2013-06-30','12:35:00',7.14),('11288','2013-06-30','12:40:00',7.18),('11288','2013-06-30','12:45:00',7.11),('11288','2013-06-30','12:50:00',7.21),('11288','2013-06-30','12:55:00',7.3),('11288','2013-06-30','13:00:00',7.32),('11288','2013-06-30','13:05:00',7.26),('11288','2013-06-30','13:10:00',7.2),('11288','2013-06-30','13:15:00',7.26),('11288','2013-06-30','13:20:00',7.3),('11288','2013-06-30','13:25:00',7.41),('11288','2013-06-30','13:30:00',7.38),('11288','2013-06-30','13:35:00',7.26),('11288','2013-06-30','13:40:00',6.77),('11288','2013-06-30','13:45:00',5.78),('11288','2013-06-30','13:50:00',7.44),('11288','2013-06-30','13:55:00',7.35),('11288','2013-06-30','14:00:00',6.91),('11288','2013-06-30','14:05:00',7.26),('11288','2013-06-30','14:10:00',7.23),('11288','2013-06-30','14:15:00',7.08),('11288','2013-06-30','14:20:00',7),('11288','2013-06-30','14:25:00',7.01),('11288','2013-06-30','14:30:00',6.85),('11288','2013-06-30','14:35:00',6.84),('11288','2013-06-30','14:40:00',6.88),('11288','2013-06-30','14:45:00',6.93),('11288','2013-06-30','14:50:00',6.84),('11288','2013-06-30','14:55:00',6.79),('11288','2013-06-30','15:00:00',6.74),('11288','2013-06-30','15:05:00',6.65),('11288','2013-06-30','15:10:00',6.66),('11288','2013-06-30','15:15:00',6.6),('11288','2013-06-30','15:20:00',6.59),('11288','2013-06-30','15:25:00',6.51),('11288','2013-06-30','15:30:00',6.47),('11288','2013-06-30','15:35:00',6.45),('11288','2013-06-30','15:40:00',6.39),('11288','2013-06-30','15:45:00',6.32),('11288','2013-06-30','15:50:00',6.31),('11288','2013-06-30','15:55:00',6.17),('11288','2013-06-30','16:00:00',6.08),('11288','2013-06-30','16:05:00',6.01),('11288','2013-06-30','16:10:00',5.96),('11288','2013-06-30','16:15:00',5.82),('11288','2013-06-30','16:20:00',5.52),('11288','2013-06-30','16:25:00',5.83),('11288','2013-06-30','16:30:00',5.82),('11288','2013-06-30','16:35:00',5.52),('11288','2013-06-30','16:40:00',5.12),('11288','2013-06-30','16:45:00',4.92),('11288','2013-06-30','16:50:00',4.68),('11288','2013-06-30','16:55:00',4.74),('11288','2013-06-30','17:00:00',4.66),('11288','2013-06-30','17:05:00',4.47),('11288','2013-06-30','17:10:00',4.42),('11288','2013-06-30','17:15:00',4.3),('11288','2013-06-30','17:20:00',4.17),('11288','2013-06-30','17:25:00',4.04),('11288','2013-06-30','17:30:00',3.86),('11288','2013-06-30','17:35:00',3.72),('11288','2013-06-30','17:40:00',3.76),('11288','2013-06-30','17:45:00',3.57),('11288','2013-06-30','17:50:00',3.43),('11288','2013-06-30','17:55:00',3.29),('11288','2013-06-30','18:00:00',3.09),('11288','2013-06-30','18:05:00',2.79),('11288','2013-06-30','18:10:00',2.86),('11288','2013-06-30','18:15:00',2.73),('11288','2013-06-30','18:20:00',2.61),('11288','2013-06-30','18:25:00',2.51),('11288','2013-06-30','18:30:00',2.31),('11288','2013-06-30','18:35:00',2.2),('11288','2013-06-30','18:40:00',2.09),('11288','2013-06-30','18:45:00',1.93),('11288','2013-06-30','18:50:00',1.83),('11288','2013-06-30','18:55:00',1.72),('11288','2013-06-30','19:00:00',1.6),('11288','2013-06-30','19:05:00',1.48),('11288','2013-06-30','19:10:00',1.36),('11288','2013-06-30','19:15:00',1.2),('11288','2013-06-30','19:20:00',1.07),('11288','2013-06-29','07:25:00',1.24),('11288','2013-06-29','07:30:00',1.84),('11288','2013-06-29','07:35:00',2.23),('11288','2013-06-29','07:40:00',2.27),('11288','2013-06-29','07:45:00',2.21),('11288','2013-06-29','07:50:00',2.36),('11288','2013-06-29','07:55:00',2.76),('11288','2013-06-29','08:00:00',3.15),('11288','2013-06-29','08:05:00',3.47),('11288','2013-06-29','08:10:00',3.41),('11288','2013-06-29','08:15:00',3.07),('11288','2013-06-29','08:20:00',2.47),('11288','2013-06-29','08:25:00',3.1),('11288','2013-06-29','08:30:00',3.24),('11288','2013-06-29','08:35:00',3.27),('11288','2013-06-29','08:40:00',2.16),('11288','2013-06-29','08:45:00',3.44),('11288','2013-06-29','08:50:00',3.7),('11288','2013-06-29','08:55:00',3.88),('11288','2013-06-29','09:00:00',3.96),('11288','2013-06-29','09:05:00',4.05),('11288','2013-06-29','09:10:00',4.07),('11288','2013-06-29','09:15:00',4.13),('11288','2013-06-29','09:20:00',4.31),('11288','2013-06-29','09:25:00',4.35),('11288','2013-06-29','09:30:00',4.52),('11288','2013-06-29','09:35:00',4.74),('11288','2013-06-29','09:40:00',4.87),('11288','2013-06-29','09:45:00',5.09),('11288','2013-06-29','09:50:00',5.2),('11288','2013-06-29','09:55:00',5.31),('11288','2013-06-29','10:00:00',5.37),('11288','2013-06-29','10:05:00',5.55),('11288','2013-06-29','10:10:00',5.65),('11288','2013-06-29','10:15:00',5.75),('11288','2013-06-29','10:20:00',5.86),('11288','2013-06-29','10:25:00',5.97),('11288','2013-06-29','10:30:00',6.05),('11288','2013-06-29','10:35:00',6.11),('11288','2013-06-29','10:40:00',6.26),('11288','2013-06-29','10:45:00',6.26),('11288','2013-06-29','10:50:00',4.06),('11288','2013-06-29','10:55:00',3.95),('11288','2013-06-29','11:00:00',6.86),('11288','2013-06-29','11:05:00',6.78),('11288','2013-06-29','11:10:00',6.84),('11288','2013-06-29','11:15:00',7.02),('11288','2013-06-29','11:20:00',7.07),('11288','2013-06-29','11:25:00',7.49),('11288','2013-06-29','11:30:00',6.91),('11288','2013-06-29','11:35:00',5.33),('11288','2013-06-29','11:40:00',3.03),('11288','2013-06-29','11:45:00',8.06),('11288','2013-06-29','11:50:00',8.16),('11288','2013-06-29','11:55:00',7.24),('11288','2013-06-29','12:00:00',6.76),('11288','2013-06-29','12:05:00',6.86),('11288','2013-06-29','12:10:00',7.56),('11288','2013-06-29','12:15:00',7.74),('11288','2013-06-29','12:20:00',4.79),('11288','2013-06-29','12:25:00',7.55),('11288','2013-06-29','12:30:00',7.86),('11288','2013-06-29','12:35:00',3.34),('11288','2013-06-29','12:40:00',3.85),('11288','2013-06-29','12:45:00',8.53),('11288','2013-06-29','12:50:00',7.21),('11288','2013-06-29','12:55:00',7.93),('11288','2013-06-29','13:00:00',4.34),('11288','2013-06-29','13:05:00',5.6),('11288','2013-06-29','13:10:00',8.06),('11288','2013-06-29','13:15:00',7.33),('11288','2013-06-29','13:20:00',2.76),('11288','2013-06-29','13:25:00',6.17),('11288','2013-06-29','13:30:00',1.91),('11288','2013-06-29','13:35:00',1.62),('11288','2013-06-29','13:40:00',1.77),('11288','2013-06-29','13:45:00',3.01),('11288','2013-06-29','13:50:00',3),('11288','2013-06-29','13:55:00',5.82),('11288','2013-06-29','14:00:00',8.41),('11288','2013-06-29','14:05:00',8.24),('11288','2013-06-29','14:10:00',7.98),('11288','2013-06-29','14:15:00',7.92),('11288','2013-06-29','14:20:00',8.3),('11288','2013-06-29','14:25:00',8.16),('11288','2013-06-29','14:30:00',7.75),('11288','2013-06-29','14:35:00',7.69),('11288','2013-06-29','14:40:00',7.7),('11288','2013-06-29','14:45:00',7.77),('11288','2013-06-29','14:50:00',8.14),('11288','2013-06-29','14:55:00',6),('11288','2013-06-29','15:00:00',6.68),('11288','2013-06-29','15:05:00',8.48),('11288','2013-06-29','15:10:00',4.63),('11288','2013-06-29','15:15:00',4.71),('11288','2013-06-29','15:20:00',2.64),('11288','2013-06-29','15:25:00',2.33),('11288','2013-06-29','15:30:00',1.22),('11288','2013-06-29','15:35:00',1.07),('11288','2013-06-29','16:25:00',1.07),('11288','2013-06-29','16:30:00',1.3),('11288','2013-06-29','16:35:00',1.71),('11288','2013-06-29','16:40:00',2.31),('11288','2013-06-29','16:45:00',2.91),('11288','2013-06-29','16:50:00',4.27),('11288','2013-06-29','16:55:00',2.29),('11288','2013-06-29','17:00:00',2.3),('11288','2013-06-29','17:05:00',3.13),('11288','2013-06-29','17:10:00',2.11),('11288','2013-06-29','17:15:00',2.01),('11288','2013-06-29','17:20:00',2.57),('11288','2013-06-29','17:25:00',3.12),('11288','2013-06-29','17:30:00',4.32),('11288','2013-06-29','17:35:00',3.21),('11288','2013-06-29','17:40:00',2.2),('11288','2013-06-29','17:45:00',3.2),('11288','2013-06-29','17:50:00',3.34),('11288','2013-06-29','17:55:00',3.43),('11288','2013-06-29','18:00:00',3.21),('11288','2013-06-29','18:05:00',3.05),('11288','2013-06-29','18:15:00',1.51),('11288','2013-06-29','18:20:00',2.51),('11288','2013-06-29','18:25:00',2.01),('11288','2013-06-29','18:35:00',2.13),('11288','2013-06-29','18:40:00',2.26),('11288','2013-06-29','18:45:00',1.17),('11288','2013-06-29','19:05:00',1.6),('11288','2013-06-29','19:10:00',1.58),('11288','2013-06-29','19:15:00',1),('11288','2013-06-28','07:10:00',1.09),('11288','2013-06-28','07:25:00',1.32),('11288','2013-06-28','07:30:00',1.44),('11288','2013-06-28','07:35:00',1.55),('11288','2013-06-28','07:40:00',1.53),('11288','2013-06-28','07:45:00',1.69),('11288','2013-06-28','07:50:00',1.84),('11288','2013-06-28','07:55:00',2.06),('11288','2013-06-28','08:00:00',2.11),('11288','2013-06-28','08:05:00',2.12),('11288','2013-06-28','08:10:00',2.18),('11288','2013-06-28','08:15:00',2.47),('11288','2013-06-28','08:20:00',2.48),('11288','2013-06-28','08:25:00',2.66),('11288','2013-06-28','08:30:00',2.89),('11288','2013-06-28','08:35:00',3.1),('11288','2013-06-28','08:40:00',3.22),('11288','2013-06-28','08:45:00',3.26),('11288','2013-06-28','08:50:00',3.44),('11288','2013-06-28','08:55:00',3.84),('11288','2013-06-28','09:00:00',3.91),('11288','2013-06-28','09:05:00',4.06),('11288','2013-06-28','09:10:00',4.5),('11288','2013-06-28','09:15:00',3.67),('11288','2013-06-28','09:20:00',1.33),('11288','2013-06-28','09:25:00',3.3),('11288','2013-06-28','09:30:00',4.91),('11288','2013-06-28','09:35:00',5.01),('11288','2013-06-28','09:40:00',5.31),('11288','2013-06-28','09:45:00',5.33),('11288','2013-06-28','09:50:00',4.92),('11288','2013-06-28','09:55:00',3.73),('11288','2013-06-28','10:00:00',2.28),('11288','2013-06-28','10:05:00',6.06),('11288','2013-06-28','10:10:00',6.11),('11288','2013-06-28','10:15:00',5.1),('11288','2013-06-28','10:20:00',2.33),('11288','2013-06-28','10:25:00',2.4),('11288','2013-06-28','10:30:00',7.3),('11288','2013-06-28','10:35:00',7.05),('11288','2013-06-28','10:40:00',5.4),('11288','2013-06-28','10:45:00',5.13),('11288','2013-06-28','10:50:00',3.99),('11288','2013-06-28','10:55:00',3.35),('11288','2013-06-28','11:00:00',4.15),('11288','2013-06-28','11:05:00',4.02),('11288','2013-06-28','11:10:00',3.37),('11288','2013-06-28','11:15:00',3.01),('11288','2013-06-28','11:20:00',3.13),('11288','2013-06-28','11:25:00',5.86),('11288','2013-06-28','11:30:00',6.94),('11288','2013-06-28','11:35:00',6.51),('11288','2013-06-28','11:40:00',7.79),('11288','2013-06-28','11:45:00',5.82),('11288','2013-06-28','11:50:00',5.83),('11288','2013-06-28','11:55:00',6.59),('11288','2013-06-28','12:00:00',4.73),('11288','2013-06-28','12:05:00',6.64),('11288','2013-06-28','12:10:00',8.34),('11288','2013-06-28','12:15:00',7.74),('11288','2013-06-28','12:20:00',7.4),('11288','2013-06-28','12:25:00',7.51),('11288','2013-06-28','12:30:00',7.68),('11288','2013-06-28','12:35:00',5.33),('11288','2013-06-28','12:40:00',5.62),('11288','2013-06-28','12:45:00',7.76),('11288','2013-06-28','12:50:00',7.69),('11288','2013-06-28','12:55:00',7.44),('11288','2013-06-28','13:00:00',7.59),('11288','2013-06-28','13:05:00',7.76),('11288','2013-06-28','13:10:00',7.13),('11288','2013-06-28','13:15:00',6.4),('11288','2013-06-28','13:20:00',7.23),('11288','2013-06-28','13:25:00',7.51),('11288','2013-06-28','13:30:00',7.5),('11288','2013-06-28','13:35:00',7.48),('11288','2013-06-28','13:40:00',5.76),('11288','2013-06-28','13:45:00',6.95),('11288','2013-06-28','13:50:00',5.98),('11288','2013-06-28','13:55:00',7.51),('11288','2013-06-28','14:00:00',6.61),('11288','2013-06-28','14:05:00',7.22),('11288','2013-06-28','14:10:00',5.58),('11288','2013-06-28','14:15:00',7.14),('11288','2013-06-28','14:20:00',7.47),('11288','2013-06-28','14:25:00',3.27),('11288','2013-06-28','14:30:00',7.67),('11288','2013-06-28','14:35:00',6.64),('11288','2013-06-28','14:40:00',6.26),('11288','2013-06-28','14:45:00',7.77),('11288','2013-06-28','14:50:00',7.3),('11288','2013-06-28','14:55:00',6.91),('11288','2013-06-28','15:00:00',6.63),('11288','2013-06-28','15:05:00',6.96),('11288','2013-06-28','15:10:00',6.96),('11288','2013-06-28','15:15:00',7.09),('11288','2013-06-28','15:20:00',7.19),('11288','2013-06-28','15:25:00',6.78),('11288','2013-06-28','15:30:00',6.32),('11288','2013-06-28','15:35:00',6.04),('11288','2013-06-28','15:40:00',2.97),('11288','2013-06-28','15:45:00',6.74),('11288','2013-06-28','15:50:00',4.89),('11288','2013-06-28','15:55:00',6.74),('11288','2013-06-28','16:00:00',5.95),('11288','2013-06-28','16:05:00',4.76),('11288','2013-06-28','16:10:00',3.19),('11288','2013-06-28','16:15:00',5.41),('11288','2013-06-28','16:20:00',5.18),('11288','2013-06-28','16:25:00',4.33),('11288','2013-06-28','16:30:00',5.16),('11288','2013-06-28','16:35:00',1.68),('11288','2013-06-28','16:40:00',3.22),('11288','2013-06-28','16:45:00',3.85),('11288','2013-06-28','16:50:00',5.11),('11288','2013-06-28','16:55:00',4.82),('11288','2013-06-28','17:00:00',4.74),('11288','2013-06-28','17:05:00',4.15),('11288','2013-06-28','17:10:00',4.47),('11288','2013-06-28','17:15:00',4.34),('11288','2013-06-28','17:20:00',4.18),('11288','2013-06-28','17:25:00',4.19),('11288','2013-06-28','17:30:00',4.02),('11288','2013-06-28','17:35:00',3.89),('11288','2013-06-28','17:40:00',3.76),('11288','2013-06-28','17:45:00',3.67),('11288','2013-06-28','17:50:00',3.5),('11288','2013-06-28','17:55:00',3.42),('11288','2013-06-28','18:00:00',3.28),('11288','2013-06-28','18:05:00',3.1),('11288','2013-06-28','18:10:00',2.96),('11288','2013-06-28','18:15:00',2.87),('11288','2013-06-28','18:20:00',2.77),('11288','2013-06-28','18:25:00',2.63),('11288','2013-06-28','18:30:00',1.8),('11288','2013-06-28','18:35:00',1.54),('11288','2013-06-28','18:40:00',1.75),('11288','2013-06-28','18:45:00',1.49),('11288','2013-06-28','18:50:00',1.86),('11288','2013-06-28','18:55:00',1.42),('11288','2013-06-28','19:00:00',1.34),('11288','2013-06-28','19:05:00',1.29),('11288','2013-06-28','19:10:00',1.22),('11288','2013-06-28','19:15:00',1.18),('11288','2013-06-28','19:20:00',1.09),('11288','2013-06-28','19:25:00',1.05),('11288','2013-06-27','07:25:00',1.17),('11288','2013-06-27','07:30:00',1.35),('11288','2013-06-27','07:35:00',1.42),('11288','2013-06-27','07:40:00',1.52),('11288','2013-06-27','07:45:00',1.58),('11288','2013-06-27','07:50:00',1.72),('11288','2013-06-27','07:55:00',2.03),('11288','2013-06-27','08:00:00',2.11),('11288','2013-06-27','08:05:00',2.34),('11288','2013-06-27','08:10:00',2.4),('11288','2013-06-27','08:15:00',2.44),('11288','2013-06-27','08:20:00',2.58),('11288','2013-06-27','08:25:00',2.85),('11288','2013-06-27','08:30:00',2.92),('11288','2013-06-27','08:35:00',3.04),('11288','2013-06-27','08:40:00',3.25),('11288','2013-06-27','08:45:00',3.42),('11288','2013-06-27','08:50:00',3.6),('11288','2013-06-27','08:55:00',3.86),('11288','2013-06-27','09:00:00',3.87),('11288','2013-06-27','09:05:00',3.98),('11288','2013-06-27','09:10:00',4.14),('11288','2013-06-27','09:15:00',4.22),('11288','2013-06-27','09:20:00',4.34),('11288','2013-06-27','09:25:00',4.5),('11288','2013-06-27','09:30:00',4.55),('11288','2013-06-27','09:35:00',4.62),('11288','2013-06-27','09:40:00',4.9),('11288','2013-06-27','09:45:00',4.99),('11288','2013-06-27','09:50:00',5.27),('11288','2013-06-27','09:55:00',5.49),('11288','2013-06-27','10:00:00',4.83),('11288','2013-06-27','10:05:00',4.68),('11288','2013-06-27','10:10:00',4.46),('11288','2013-06-27','10:15:00',2.87),('11288','2013-06-27','10:20:00',6.02),('11288','2013-06-27','10:25:00',6.09),('11288','2013-06-27','10:30:00',6.22),('11288','2013-06-27','10:35:00',5.54),('11288','2013-06-27','10:40:00',6.93),('11288','2013-06-27','10:45:00',6.94),('11288','2013-06-27','10:50:00',6.66),('11288','2013-06-27','10:55:00',6.46),('11288','2013-06-27','11:00:00',6.84),('11288','2013-06-27','11:05:00',6.94),('11288','2013-06-27','11:10:00',6.97),('11288','2013-06-27','11:15:00',6.95),('11288','2013-06-27','11:20:00',6.93),('11288','2013-06-27','11:25:00',7.18),('11288','2013-06-27','11:30:00',6.61),('11288','2013-06-27','11:35:00',6.11),('11288','2013-06-27','11:40:00',7.55),('11288','2013-06-27','11:45:00',7.51),('11288','2013-06-27','11:50:00',4.44),('11288','2013-06-27','11:55:00',2.22),('11288','2013-06-27','12:00:00',2.36),('11288','2013-06-27','12:05:00',2.17),('11288','2013-06-27','12:10:00',2.14),('11288','2013-06-27','12:15:00',1.88),('11288','2013-06-27','12:20:00',2.05),('11288','2013-06-27','12:25:00',3.16),('11288','2013-06-27','12:30:00',3.67),('11288','2013-06-27','12:35:00',6.09),('11288','2013-06-27','12:40:00',2.97),('11288','2013-06-27','12:45:00',3.65),('11288','2013-06-27','12:50:00',2.79),('11288','2013-06-27','12:55:00',2.09),('11288','2013-06-27','13:00:00',1.76),('11288','2013-06-27','13:05:00',2.01),('11288','2013-06-27','13:10:00',2.35),('11288','2013-06-27','13:15:00',2.53),('11288','2013-06-27','13:20:00',2.55),('11288','2013-06-27','13:25:00',2.7),('11288','2013-06-27','13:30:00',2.46),('11288','2013-06-27','13:35:00',2.34),('11288','2013-06-27','13:40:00',2.27),('11288','2013-06-27','13:45:00',2.42),('11288','2013-06-27','13:50:00',2.7),('11288','2013-06-27','13:55:00',2.37),('11288','2013-06-27','14:00:00',2.44),('11288','2013-06-27','14:05:00',2.46),('11288','2013-06-27','14:10:00',3.38),('11288','2013-06-27','14:15:00',4.1),('11288','2013-06-27','14:20:00',7.19),('11288','2013-06-27','14:25:00',5.04),('11288','2013-06-27','14:30:00',3.44),('11288','2013-06-27','14:35:00',3.57),('11288','2013-06-27','14:40:00',7.05),('11288','2013-06-27','14:45:00',5.73),('11288','2013-06-27','14:50:00',6.88),('11288','2013-06-27','14:55:00',6.82),('11288','2013-06-27','15:00:00',6.62),('11288','2013-06-27','15:05:00',6.54),('11288','2013-06-27','15:10:00',6.51),('11288','2013-06-27','15:15:00',6.44),('11288','2013-06-27','15:20:00',6.41),('11288','2013-06-27','15:25:00',6.4),('11288','2013-06-27','15:30:00',6.33),('11288','2013-06-27','15:35:00',6.26),('11288','2013-06-27','15:40:00',6.16),('11288','2013-06-27','15:45:00',6.08),('11288','2013-06-27','15:50:00',6.08),('11288','2013-06-27','15:55:00',5.99),('11288','2013-06-27','16:00:00',5.77),('11288','2013-06-27','16:05:00',5.63),('11288','2013-06-27','16:10:00',5.61),('11288','2013-06-27','16:15:00',5.58),('11288','2013-06-27','16:20:00',5.49),('11288','2013-06-27','16:25:00',5.4),('11288','2013-06-27','16:30:00',5.3),('11288','2013-06-27','16:35:00',4.92),('11288','2013-06-27','16:40:00',4.96),('11288','2013-06-27','16:45:00',4.95),('11288','2013-06-27','16:50:00',4.75),('11288','2013-06-27','16:55:00',4.69),('11288','2013-06-27','17:00:00',4.57),('11288','2013-06-27','17:05:00',4.39),('11288','2013-06-27','17:10:00',4.17),('11288','2013-06-27','17:15:00',4.07),('11288','2013-06-27','17:20:00',4.2),('11288','2013-06-27','17:25:00',4.05),('11288','2013-06-27','17:30:00',3.95),('11288','2013-06-27','17:35:00',3.83),('11288','2013-06-27','17:40:00',3.02),('11288','2013-06-27','17:45:00',1.71),('11288','2013-06-27','17:50:00',3),('11288','2013-06-27','17:55:00',2.86),('11288','2013-06-27','18:00:00',3.04),('11288','2013-06-27','18:05:00',2.93),('11288','2013-06-27','18:10:00',2.78),('11288','2013-06-27','18:15:00',2.59),('11288','2013-06-27','18:20:00',2.49),('11288','2013-06-27','18:25:00',2.5),('11288','2013-06-27','18:30:00',2.35),('11288','2013-06-27','18:35:00',2.17),('11288','2013-06-27','18:40:00',1.91),('11288','2013-06-27','18:45:00',1.79),('11288','2013-06-27','18:50:00',1.72),('11288','2013-06-27','18:55:00',1.63),('11288','2013-06-27','19:00:00',1.5),('11288','2013-06-27','19:05:00',1.37),('11288','2013-06-27','19:10:00',1.25),('11288','2013-06-27','19:15:00',1.12),('11288','2013-06-27','19:20:00',1.01),('11288','2013-06-26','07:15:00',1.06),('11288','2013-06-26','07:20:00',1.16),('11288','2013-06-26','07:25:00',1.22),('11288','2013-06-26','07:30:00',1.34),('11288','2013-06-26','07:35:00',1.48),('11288','2013-06-26','07:40:00',1.54),('11288','2013-06-26','07:45:00',1.6),('11288','2013-06-26','07:50:00',1.88),('11288','2013-06-26','07:55:00',1.84),('11288','2013-06-26','08:00:00',2.07),('11288','2013-06-26','08:05:00',2.32),('11288','2013-06-26','08:10:00',2.3),('11288','2013-06-26','08:15:00',2.47),('11288','2013-06-26','08:20:00',2.7),('11288','2013-06-26','08:25:00',2.83),('11288','2013-06-26','08:30:00',2.93),('11288','2013-06-26','08:35:00',3.16),('11288','2013-06-26','08:40:00',3.24),('11288','2013-06-26','08:45:00',3.26),('11288','2013-06-26','08:50:00',3.59),('11288','2013-06-26','08:55:00',3.7),('11288','2013-06-26','09:00:00',3.82),('11288','2013-06-26','09:05:00',3.97),('11288','2013-06-26','09:10:00',3.94),('11288','2013-06-26','09:15:00',3.94),('11288','2013-06-26','09:20:00',4.33),('11288','2013-06-26','09:25:00',4.32),('11288','2013-06-26','09:30:00',4.08),('11288','2013-06-26','09:35:00',4.51),('11288','2013-06-26','09:40:00',4.69),('11288','2013-06-26','09:45:00',4.64),('11288','2013-06-26','09:50:00',5),('11288','2013-06-26','09:55:00',5.03),('11288','2013-06-26','10:00:00',4.96),('11288','2013-06-26','10:05:00',5.34),('11288','2013-06-26','10:10:00',5.53),('11288','2013-06-26','10:15:00',5.69),('11288','2013-06-26','10:20:00',5.82),('11288','2013-06-26','10:25:00',5.85),('11288','2013-06-26','10:30:00',5.87),('11288','2013-06-26','10:35:00',5.98),('11288','2013-06-26','10:40:00',6.1),('11288','2013-06-26','10:45:00',6.16),('11288','2013-06-26','10:50:00',6.24),('11288','2013-06-26','10:55:00',6.31),('11288','2013-06-26','11:00:00',6.36),('11288','2013-06-26','11:05:00',6.44),('11288','2013-06-26','11:10:00',6.51),('11288','2013-06-26','11:15:00',6.55),('11288','2013-06-26','11:20:00',6.62),('11288','2013-06-26','11:25:00',6.62),('11288','2013-06-26','11:30:00',6.62),('11288','2013-06-26','11:35:00',6.7),('11288','2013-06-26','11:40:00',6.71),('11288','2013-06-26','11:45:00',6.74),('11288','2013-06-26','11:50:00',6.75),('11288','2013-06-26','11:55:00',6.89),('11288','2013-06-26','12:00:00',6.99),('11288','2013-06-26','12:05:00',7.04),('11288','2013-06-26','12:10:00',7),('11288','2013-06-26','12:15:00',6.96),('11288','2013-06-26','12:20:00',6.93),('11288','2013-06-26','12:25:00',6.91),('11288','2013-06-26','12:30:00',7.02),('11288','2013-06-26','12:35:00',7),('11288','2013-06-26','12:40:00',5.42),('11288','2013-06-26','12:45:00',3.39),('11288','2013-06-26','12:50:00',3.27),('11288','2013-06-26','12:55:00',2.28),('11288','2013-06-26','13:00:00',5.31),('11288','2013-06-26','13:05:00',4.12),('11288','2013-06-26','13:10:00',8.06),('11288','2013-06-26','13:15:00',7.69),('11288','2013-06-26','13:20:00',2.91),('11288','2013-06-26','13:25:00',4.68),('11288','2013-06-26','13:30:00',2.6),('11288','2013-06-26','13:35:00',2.56),('11288','2013-06-26','13:40:00',2.92),('11288','2013-06-26','13:45:00',4.17),('11288','2013-06-26','13:50:00',5.26),('11288','2013-06-26','13:55:00',4.05),('11288','2013-06-26','14:00:00',6.74),('11288','2013-06-26','14:05:00',7.78),('11288','2013-06-26','14:10:00',6.82),('11288','2013-06-26','14:15:00',3.01),('11288','2013-06-26','14:20:00',7.52),('11288','2013-06-26','14:25:00',6.64),('11288','2013-06-26','14:30:00',4.69),('11288','2013-06-26','14:35:00',5.48),('11288','2013-06-26','14:40:00',7.69),('11288','2013-06-26','14:45:00',5.38),('11288','2013-06-26','14:50:00',7.3),('11288','2013-06-26','14:55:00',7.12),('11288','2013-06-26','15:00:00',6.74),('11288','2013-06-26','15:05:00',6.67),('11288','2013-06-26','15:10:00',6.53),('11288','2013-06-26','15:15:00',6.47),('11288','2013-06-26','15:20:00',6.48),('11288','2013-06-26','15:25:00',6.38),('11288','2013-06-26','15:30:00',6.31),('11288','2013-06-26','15:35:00',6.33),('11288','2013-06-26','15:40:00',6.24),('11288','2013-06-26','15:45:00',6.13),('11288','2013-06-26','15:50:00',6.18),('11288','2013-06-26','15:55:00',6.01),('11288','2013-06-26','16:00:00',5.93),('11288','2013-06-26','16:05:00',5.82),('11288','2013-06-26','16:10:00',5.75),('11288','2013-06-26','16:15:00',5.63),('11288','2013-06-26','16:20:00',5.52),('11288','2013-06-26','16:25:00',5.43),('11288','2013-06-26','16:30:00',5.29),('11288','2013-06-26','16:35:00',5.12),('11288','2013-06-26','16:40:00',4.96),('11288','2013-06-26','16:45:00',4.74),('11288','2013-06-26','16:50:00',4.54),('11288','2013-06-26','16:55:00',4.72),('11288','2013-06-26','17:00:00',4.64),('11288','2013-06-26','17:05:00',4.49),('11288','2013-06-26','17:10:00',4.38),('11288','2013-06-26','17:15:00',4.24),('11288','2013-06-26','17:20:00',4.12),('11288','2013-06-26','17:25:00',4),('11288','2013-06-26','17:30:00',3.88),('11288','2013-06-26','17:35:00',3.8),('11288','2013-06-26','17:40:00',3.71),('11288','2013-06-26','17:45:00',3.5),('11288','2013-06-26','17:50:00',3.35),('11288','2013-06-26','17:55:00',3.22),('11288','2013-06-26','18:00:00',3.09),('11288','2013-06-26','18:05:00',3.1),('11288','2013-06-26','18:10:00',3.43),('11288','2013-06-26','18:15:00',2.51),('11288','2013-06-26','18:20:00',1.44),('11288','2013-06-26','18:25:00',1.38),('11288','2013-06-26','18:30:00',1.11),('11288','2013-06-26','19:00:00',1.13),('11288','2013-06-26','19:15:00',1.12),('11288','2013-06-26','19:20:00',1.14),('11288','2013-06-26','19:25:00',1.05),('11288','2013-06-25','07:10:00',1.05),('11288','2013-06-25','07:15:00',1.16),('11288','2013-06-25','07:20:00',1.26),('11288','2013-06-25','07:25:00',1.36),('11288','2013-06-25','07:30:00',1.5),('11288','2013-06-25','07:35:00',1.68),('11288','2013-06-25','07:40:00',1.8),('11288','2013-06-25','07:45:00',1.9),('11288','2013-06-25','07:50:00',1.71),('11288','2013-06-25','07:55:00',1.82),('11288','2013-06-25','08:00:00',2.48),('11288','2013-06-25','08:05:00',2.23),('11288','2013-06-25','08:10:00',1.55),('11288','2013-06-25','08:15:00',1.24),('11288','2013-06-25','08:20:00',2.01),('11288','2013-06-25','08:25:00',2.87),('11288','2013-06-25','08:30:00',2.94),('11288','2013-06-25','08:35:00',3.22),('11288','2013-06-25','08:40:00',3.36),('11288','2013-06-25','08:45:00',3.39),('11288','2013-06-25','08:50:00',3.67),('11288','2013-06-25','08:55:00',3.84),('11288','2013-06-25','09:00:00',3.92),('11288','2013-06-25','09:05:00',4.02),('11288','2013-06-25','09:10:00',3.99),('11288','2013-06-25','09:15:00',3.95),('11288','2013-06-25','09:20:00',4.28),('11288','2013-06-25','09:25:00',4.43),('11288','2013-06-25','09:30:00',4.25),('11288','2013-06-25','09:35:00',4.91),('11288','2013-06-25','09:40:00',5.15),('11288','2013-06-25','09:45:00',5.31),('11288','2013-06-25','09:50:00',5.55),('11288','2013-06-25','09:55:00',5.85),('11288','2013-06-25','10:00:00',5.99),('11288','2013-06-25','10:05:00',6.19),('11288','2013-06-25','10:10:00',6.4),('11288','2013-06-25','10:15:00',5.97),('11288','2013-06-25','10:20:00',1.62),('11288','2013-06-25','10:25:00',1.82),('11288','2013-06-25','10:30:00',7.1),('11288','2013-06-25','10:35:00',6.86),('11288','2013-06-25','10:40:00',6.45),('11288','2013-06-25','10:45:00',2.43),('11288','2013-06-25','10:50:00',2.19),('11288','2013-06-25','10:55:00',4.52),('11288','2013-06-25','11:00:00',6.97),('11288','2013-06-25','11:05:00',1.98),('11288','2013-06-25','11:10:00',3.61),('11288','2013-06-25','11:15:00',7),('11288','2013-06-25','11:20:00',1.83),('11288','2013-06-25','11:25:00',1.94),('11288','2013-06-25','11:30:00',1.98),('11288','2013-06-25','11:35:00',5.92),('11288','2013-06-25','11:40:00',8.3),('11288','2013-06-25','11:45:00',7.72),('11288','2013-06-25','11:50:00',7.93),('11288','2013-06-25','11:55:00',2.84),('11288','2013-06-25','12:00:00',1.91),('11288','2013-06-25','12:05:00',1.81),('11288','2013-06-25','12:10:00',1.96),('11288','2013-06-25','12:15:00',1.92),('11288','2013-06-25','12:20:00',2.65),('11288','2013-06-25','12:25:00',2.28),('11288','2013-06-25','12:30:00',2.52),('11288','2013-06-25','12:35:00',7.13),('11288','2013-06-25','12:40:00',6.33),('11288','2013-06-25','12:45:00',5.76),('11288','2013-06-25','12:50:00',4.22),('11288','2013-06-25','12:55:00',4.58),('11288','2013-06-25','13:00:00',7.27),('11288','2013-06-25','13:05:00',7.8),('11288','2013-06-25','13:10:00',3.77),('11288','2013-06-25','13:15:00',6.93),('11288','2013-06-25','13:20:00',5.98),('11288','2013-06-25','13:25:00',6.94),('11288','2013-06-25','13:30:00',5.34),('11288','2013-06-25','13:35:00',6.11),('11288','2013-06-25','13:40:00',7.89),('11288','2013-06-25','13:45:00',7.5),('11288','2013-06-25','13:50:00',6.03),('11288','2013-06-25','13:55:00',4.49),('11288','2013-06-25','14:00:00',5.95),('11288','2013-06-25','14:05:00',7.53),('11288','2013-06-25','14:10:00',6.44),('11288','2013-06-25','14:15:00',7.37),('11288','2013-06-25','14:20:00',7.17),('11288','2013-06-25','14:25:00',7.07),('11288','2013-06-25','14:30:00',6.93),('11288','2013-06-25','14:35:00',6.94),('11288','2013-06-25','14:40:00',6.75),('11288','2013-06-25','14:45:00',6.93),('11288','2013-06-25','14:50:00',6.83),('11288','2013-06-25','14:55:00',6.77),('11288','2013-06-25','15:00:00',6.66),('11288','2013-06-25','15:05:00',6.68),('11288','2013-06-25','15:10:00',6.64),('11288','2013-06-25','15:15:00',6.55),('11288','2013-06-25','15:20:00',6.47),('11288','2013-06-25','15:25:00',6.38),('11288','2013-06-25','15:30:00',6.36),('11288','2013-06-25','15:35:00',6.27),('11288','2013-06-25','15:40:00',6.21),('11288','2013-06-25','15:45:00',6.12),('11288','2013-06-25','15:50:00',6.02),('11288','2013-06-25','15:55:00',5.91),('11288','2013-06-25','16:00:00',5.87),('11288','2013-06-25','16:05:00',5.8),('11288','2013-06-25','16:10:00',5.72),('11288','2013-06-25','16:15:00',5.62),('11288','2013-06-25','16:20:00',5.46),('11288','2013-06-25','16:25:00',5.36),('11288','2013-06-25','16:30:00',5.31),('11288','2013-06-25','16:35:00',5.15),('11288','2013-06-25','16:40:00',5.01),('11288','2013-06-25','16:45:00',4.91),('11288','2013-06-25','16:50:00',4.81),('11288','2013-06-25','16:55:00',4.7),('11288','2013-06-25','17:00:00',4.58),('11288','2013-06-25','17:05:00',4.42),('11288','2013-06-25','17:10:00',4.31),('11288','2013-06-25','17:15:00',4.21),('11288','2013-06-25','17:20:00',4.11),('11288','2013-06-25','17:25:00',3.98),('11288','2013-06-25','17:30:00',3.85),('11288','2013-06-25','17:35:00',3.77),('11288','2013-06-25','17:40:00',3.68),('11288','2013-06-25','17:45:00',3.49),('11288','2013-06-25','17:50:00',3.33),('11288','2013-06-25','17:55:00',3.23),('11288','2013-06-25','18:00:00',3.11),('11288','2013-06-25','18:05:00',2.96),('11288','2013-06-25','18:10:00',2.81),('11288','2013-06-25','18:15:00',2.65),('11288','2013-06-25','18:20:00',2.57),('11288','2013-06-25','18:25:00',2.4),('11288','2013-06-25','18:30:00',2.28),('11288','2013-06-25','18:35:00',2.18),('11288','2013-06-25','18:40:00',2.04),('11288','2013-06-25','18:45:00',1.91),('11288','2013-06-25','18:50:00',1.76),('11288','2013-06-25','18:55:00',1.64),('11288','2013-06-25','19:00:00',1.54),('11288','2013-06-25','19:05:00',1.42),('11288','2013-06-25','19:10:00',1.31),('11288','2013-06-25','19:15:00',1.16),('11288','2013-06-25','19:20:00',1.05),('11288','2013-06-24','07:10:00',1.03),('11288','2013-06-24','07:20:00',1.01),('11288','2013-06-24','07:25:00',1.36),('11288','2013-06-24','07:30:00',1.02),('11288','2013-06-24','07:50:00',1.58),('11288','2013-06-24','08:20:00',1.04),('11288','2013-06-24','08:25:00',1.53),('11288','2013-06-24','08:35:00',1.23),('11288','2013-06-24','08:40:00',3.54),('11288','2013-06-24','08:45:00',3.73),('11288','2013-06-24','08:50:00',3.94),('11288','2013-06-24','08:55:00',4.22),('11288','2013-06-24','09:00:00',4.59),('11288','2013-06-24','09:05:00',2.95),('11288','2013-06-24','09:10:00',3.16),('11288','2013-06-24','09:15:00',4.21),('11288','2013-06-24','09:20:00',4.44),('11288','2013-06-24','09:25:00',5.77),('11288','2013-06-24','09:30:00',4.89),('11288','2013-06-24','09:35:00',4.65),('11288','2013-06-24','09:40:00',5.47),('11288','2013-06-24','09:45:00',5.87),('11288','2013-06-24','09:50:00',5.73),('11288','2013-06-24','09:55:00',5.39),('11288','2013-06-24','10:00:00',5.65),('11288','2013-06-24','10:05:00',5.84),('11288','2013-06-24','10:10:00',5.89),('11288','2013-06-24','10:15:00',5.23),('11288','2013-06-24','10:20:00',5.6),('11288','2013-06-24','10:25:00',7.11),('11288','2013-06-24','10:30:00',6.3),('11288','2013-06-24','10:35:00',7.02),('11288','2013-06-24','10:40:00',2.99),('11288','2013-06-24','10:45:00',5),('11288','2013-06-24','10:50:00',6.29),('11288','2013-06-24','10:55:00',5.46),('11288','2013-06-24','11:00:00',6.5),('11288','2013-06-24','11:05:00',5.41),('11288','2013-06-24','11:10:00',2.09),('11288','2013-06-24','11:15:00',8.04),('11288','2013-06-24','11:20:00',5.46),('11288','2013-06-24','11:25:00',3.35),('11288','2013-06-24','11:30:00',4.94),('11288','2013-06-24','11:35:00',2.49),('11288','2013-06-24','11:40:00',2.24),('11288','2013-06-24','11:45:00',3.82),('11288','2013-06-24','11:50:00',3.77),('11288','2013-06-24','11:55:00',6.62),('11288','2013-06-24','12:00:00',6.07),('11288','2013-06-24','12:05:00',5.72),('11288','2013-06-24','12:10:00',7.87),('11288','2013-06-24','12:15:00',3.61),('11288','2013-06-24','12:20:00',8.3),('11288','2013-06-24','12:25:00',7.58),('11288','2013-06-24','12:30:00',5.44),('11288','2013-06-24','12:35:00',8.35),('11288','2013-06-24','12:40:00',4.99),('11288','2013-06-24','12:45:00',7.28),('11288','2013-06-24','12:50:00',7.58),('11288','2013-06-24','12:55:00',6.67),('11288','2013-06-24','13:00:00',6.54),('11288','2013-06-24','13:05:00',8.32),('11288','2013-06-24','13:10:00',6.92),('11288','2013-06-24','13:15:00',5.12),('11288','2013-06-24','13:20:00',3.67),('11288','2013-06-24','13:25:00',7.67),('11288','2013-06-24','13:30:00',7.77),('11288','2013-06-24','13:35:00',7.14),('11288','2013-06-24','13:40:00',7.5),('11288','2013-06-24','13:45:00',7.12),('11288','2013-06-24','13:50:00',7.64),('11288','2013-06-24','13:55:00',7.29),('11288','2013-06-24','14:00:00',6.92),('11288','2013-06-24','14:05:00',7.44),('11288','2013-06-24','14:10:00',7.41),('11288','2013-06-24','14:15:00',7.39),('11288','2013-06-24','14:20:00',7.32),('11288','2013-06-24','14:25:00',7.44),('11288','2013-06-24','14:30:00',7.26),('11288','2013-06-24','14:35:00',7.38),('11288','2013-06-24','14:40:00',7.29),('11288','2013-06-24','14:45:00',6.7),('11288','2013-06-24','14:50:00',6.54),('11288','2013-06-24','14:55:00',4.19),('11288','2013-06-24','15:00:00',6.38),('11288','2013-06-24','15:05:00',2.8),('11288','2013-06-24','15:10:00',6.52),('11288','2013-06-24','15:15:00',6.34),('11288','2013-06-24','15:20:00',6.14),('11288','2013-06-24','15:25:00',5.63),('11288','2013-06-24','15:30:00',5.25),('11288','2013-06-24','15:35:00',2.97),('11288','2013-06-24','15:40:00',4.77),('11288','2013-06-24','15:45:00',4.55),('11288','2013-06-24','15:50:00',6.97),('11288','2013-06-24','15:55:00',6.52),('11288','2013-06-24','16:00:00',6.49),('11288','2013-06-24','16:05:00',6.92),('11288','2013-06-24','16:10:00',5.93),('11288','2013-06-24','16:15:00',5.79),('11288','2013-06-24','16:20:00',3.57),('11288','2013-06-24','16:25:00',4.62),('11288','2013-06-24','16:30:00',5.52),('11288','2013-06-24','16:35:00',5.32),('11288','2013-06-24','16:40:00',3.64),('11288','2013-06-24','16:45:00',2.7),('11288','2013-06-24','16:50:00',3.34),('11288','2013-06-24','16:55:00',2.35),('11288','2013-06-24','17:00:00',2.48),('11288','2013-06-24','17:05:00',3.91),('11288','2013-06-24','17:10:00',3.23),('11288','2013-06-24','17:15:00',4.19),('11288','2013-06-24','17:20:00',3.78),('11288','2013-06-24','17:25:00',3.43),('11288','2013-06-24','17:30:00',2.13),('11288','2013-06-24','17:35:00',1.7),('11288','2013-06-24','17:40:00',1.53),('11288','2013-06-24','17:45:00',1.51),('11288','2013-06-24','17:50:00',2.27),('11288','2013-06-24','17:55:00',2.49),('11288','2013-06-24','18:00:00',3.42),('11288','2013-06-24','18:05:00',3.25),('11288','2013-06-24','18:10:00',2.72),('11288','2013-06-24','18:15:00',2.87),('11288','2013-06-24','18:20:00',2.45),('11288','2013-06-24','18:25:00',2.27),('11288','2013-06-24','18:30:00',1.98),('11288','2013-06-24','18:35:00',2.17),('11288','2013-06-24','18:40:00',1.69),('11288','2013-06-24','18:45:00',2.06),('11288','2013-06-24','18:50:00',1.81),('11288','2013-06-24','18:55:00',1.73),('11288','2013-06-24','19:00:00',1.68),('11288','2013-06-24','19:05:00',1.52),('11288','2013-06-24','19:10:00',1.5),('11288','2013-06-24','19:15:00',1.25),('11288','2013-06-24','19:20:00',1.1),('11288','2013-06-24','19:25:00',1.04),('11288','2013-06-23','08:35:00',1.2),('11288','2013-06-23','08:40:00',1.41),('11288','2013-06-23','08:45:00',1.96),('11288','2013-06-23','08:50:00',2.48),('11288','2013-06-23','08:55:00',2.05),('11288','2013-06-23','09:00:00',3.34),('11288','2013-06-23','09:05:00',2.61),('11288','2013-06-23','09:15:00',1.35),('11288','2013-06-23','09:20:00',2.97),('11288','2013-06-23','09:25:00',4.46),('11288','2013-06-23','09:30:00',4.68),('11288','2013-06-23','09:35:00',4.91),('11288','2013-06-23','09:40:00',5.91),('11288','2013-06-23','09:45:00',3.55),('11288','2013-06-23','09:50:00',1.75),('11288','2013-06-23','09:55:00',3.56),('11288','2013-06-23','10:00:00',3.96),('11288','2013-06-23','10:05:00',3.69),('11288','2013-06-23','10:10:00',3.94),('11288','2013-06-23','10:15:00',4.15),('11288','2013-06-23','10:20:00',3.29),('11288','2013-06-23','10:25:00',3.27),('11288','2013-06-23','10:30:00',3.61),('11288','2013-06-23','10:35:00',4.37),('11288','2013-06-23','10:40:00',5.45),('11288','2013-06-23','10:45:00',6.24),('11288','2013-06-23','10:50:00',6.22),('11288','2013-06-23','10:55:00',6.26),('11288','2013-06-23','11:00:00',6.29),('11288','2013-06-23','11:05:00',6.42),('11288','2013-06-23','11:10:00',6.4),('11288','2013-06-23','11:15:00',6.34),('11288','2013-06-23','11:20:00',6.6),('11288','2013-06-23','11:25:00',6.42),('11288','2013-06-23','11:30:00',5.74),('11288','2013-06-23','11:35:00',6.53),('11288','2013-06-23','11:40:00',6.54),('11288','2013-06-23','11:45:00',6.58),('11288','2013-06-23','11:50:00',6.56),('11288','2013-06-23','11:55:00',6.73),('11288','2013-06-23','12:00:00',6.9),('11288','2013-06-23','12:05:00',6.85),('11288','2013-06-23','12:10:00',6.94),('11288','2013-06-23','12:15:00',6.84),('11288','2013-06-23','12:20:00',6.91),('11288','2013-06-23','12:25:00',7.07),('11288','2013-06-23','12:30:00',7.02),('11288','2013-06-23','12:35:00',6.95),('11288','2013-06-23','12:40:00',7.03),('11288','2013-06-23','12:45:00',7.02),('11288','2013-06-23','12:50:00',7.04),('11288','2013-06-23','12:55:00',7.06),('11288','2013-06-23','13:00:00',7.09),('11288','2013-06-23','13:05:00',7.07),('11288','2013-06-23','13:10:00',7.1),('11288','2013-06-23','13:15:00',7.04),('11288','2013-06-23','13:20:00',7.06),('11288','2013-06-23','13:25:00',7.06),('11288','2013-06-23','13:30:00',7.06),('11288','2013-06-23','13:35:00',7.1),('11288','2013-06-23','13:40:00',7.1),('11288','2013-06-23','13:45:00',7.08),('11288','2013-06-23','13:50:00',7.09),('11288','2013-06-23','13:55:00',7.13),('11288','2013-06-23','14:00:00',7.04),('11288','2013-06-23','14:05:00',7.03),('11288','2013-06-23','14:10:00',7.01),('11288','2013-06-23','14:15:00',6.98),('11288','2013-06-23','14:20:00',6.95),('11288','2013-06-23','14:25:00',6.96),('11288','2013-06-23','14:30:00',6.89),('11288','2013-06-23','14:35:00',6.91),('11288','2013-06-23','14:40:00',6.84),('11288','2013-06-23','14:45:00',6.84),('11288','2013-06-23','14:50:00',6.79),('11288','2013-06-23','14:55:00',6.75),('11288','2013-06-23','15:00:00',6.72),('11288','2013-06-23','15:05:00',6.65),('11288','2013-06-23','15:10:00',6.62),('11288','2013-06-23','15:15:00',6.56),('11288','2013-06-23','15:20:00',6.5),('11288','2013-06-23','15:25:00',6.42),('11288','2013-06-23','15:30:00',6.35),('11288','2013-06-23','15:35:00',6.28),('11288','2013-06-23','15:40:00',6.2),('11288','2013-06-23','15:45:00',6.14),('11288','2013-06-23','15:50:00',6.09),('11288','2013-06-23','15:55:00',6),('11288','2013-06-23','16:00:00',5.9),('11288','2013-06-23','16:05:00',5.79),('11288','2013-06-23','16:10:00',5.68),('11288','2013-06-23','16:15:00',5.52),('11288','2013-06-23','16:20:00',5.43),('11288','2013-06-23','16:25:00',5.36),('11288','2013-06-23','16:30:00',5.25),('11288','2013-06-23','16:35:00',5.18),('11288','2013-06-23','16:40:00',4.92),('11288','2013-06-23','16:45:00',4.89),('11288','2013-06-23','16:50:00',4.76),('11288','2013-06-23','16:55:00',4.67),('11288','2013-06-23','17:00:00',4.57),('11288','2013-06-23','17:05:00',4.44),('11288','2013-06-23','17:10:00',4.34),('11288','2013-06-23','17:15:00',4.23),('11288','2013-06-23','17:20:00',4.09),('11288','2013-06-23','17:25:00',4.01),('11288','2013-06-23','17:30:00',3.88),('11288','2013-06-23','17:35:00',3.76),('11288','2013-06-23','17:40:00',3.73),('11288','2013-06-23','17:45:00',3.56),('11288','2013-06-23','17:50:00',3.42),('11288','2013-06-23','17:55:00',3.28),('11288','2013-06-23','18:00:00',3.14),('11288','2013-06-23','18:05:00',3.04),('11288','2013-06-23','18:10:00',2.86),('11288','2013-06-23','18:15:00',2.71),('11288','2013-06-23','18:20:00',2.63),('11288','2013-06-23','18:25:00',2.44),('11288','2013-06-23','18:30:00',2.32),('11288','2013-06-23','18:35:00',2.12),('11288','2013-06-23','18:40:00',2.11),('11288','2013-06-23','18:45:00',1.98),('11288','2013-06-23','18:50:00',1.86),('11288','2013-06-23','18:55:00',1.68),('11288','2013-06-23','19:00:00',1.35),('11288','2013-06-23','19:05:00',1.47),('11288','2013-06-23','19:10:00',1.31),('11288','2013-06-23','19:15:00',1.03),('11288','2013-06-22','07:10:00',1),('11288','2013-06-22','07:15:00',1.1),('11288','2013-06-22','07:20:00',1.18),('11288','2013-06-22','07:25:00',1.27),('11288','2013-06-22','07:30:00',1.37),('11288','2013-06-22','07:35:00',1.46),('11288','2013-06-22','07:40:00',1.52),('11288','2013-06-22','07:45:00',1.59),('11288','2013-06-22','07:50:00',1.78),('11288','2013-06-22','07:55:00',1.84),('11288','2013-06-22','08:00:00',2.12),('11288','2013-06-22','08:05:00',2.2),('11288','2013-06-22','08:10:00',2.3),('11288','2013-06-22','08:15:00',2.44),('11288','2013-06-22','08:20:00',2.64),('11288','2013-06-22','08:25:00',2.72),('11288','2013-06-22','08:30:00',2.86),('11288','2013-06-22','08:35:00',3.11),('11288','2013-06-22','08:40:00',3.11),('11288','2013-06-22','08:45:00',3.19),('11288','2013-06-22','08:50:00',3.52),('11288','2013-06-22','08:55:00',3.57),('11288','2013-06-22','09:00:00',3.73),('11288','2013-06-22','09:05:00',3.83),('11288','2013-06-22','09:10:00',3.79),('11288','2013-06-22','09:15:00',3.74),('11288','2013-06-22','09:20:00',4.2),('11288','2013-06-22','09:25:00',4.13),('11288','2013-06-22','09:30:00',4.03),('11288','2013-06-22','09:35:00',4.51),('11288','2013-06-22','09:40:00',4.51),('11288','2013-06-22','09:45:00',4.52),('11288','2013-06-22','09:50:00',4.92),('11288','2013-06-22','09:55:00',4.87),('11288','2013-06-22','10:00:00',4.86),('11288','2013-06-22','10:05:00',5.24),('11288','2013-06-22','10:10:00',5.32),('11288','2013-06-22','10:15:00',5.45),('11288','2013-06-22','10:20:00',5.64),('11288','2013-06-22','10:25:00',5.67),('11288','2013-06-22','10:30:00',5.68),('11288','2013-06-22','10:35:00',5.79),('11288','2013-06-22','10:40:00',5.91),('11288','2013-06-22','10:45:00',6.05),('11288','2013-06-22','10:50:00',6.17),('11288','2013-06-22','10:55:00',6.18),('11288','2013-06-22','11:00:00',6.22),('11288','2013-06-22','11:05:00',6.27),('11288','2013-06-22','11:10:00',6.34),('11288','2013-06-22','11:15:00',6.38),('11288','2013-06-22','11:20:00',6.43),('11288','2013-06-22','11:25:00',6.47),('11288','2013-06-22','11:30:00',6.56),('11288','2013-06-22','11:35:00',6.62),('11288','2013-06-22','11:40:00',6.64),('11288','2013-06-22','11:45:00',6.66),('11288','2013-06-22','11:50:00',6.65),('11288','2013-06-22','11:55:00',6.7),('11288','2013-06-22','12:00:00',6.76),('11288','2013-06-22','12:05:00',6.62),('11288','2013-06-22','12:10:00',6.6),('11288','2013-06-22','12:15:00',6.83),('11288','2013-06-22','12:20:00',6.73),('11288','2013-06-22','12:25:00',6.79),('11288','2013-06-22','12:30:00',6.82),('11288','2013-06-22','12:35:00',6.91),('11288','2013-06-22','12:40:00',6.92),('11288','2013-06-22','12:45:00',6.82),('11288','2013-06-22','12:50:00',6.74),('11288','2013-06-22','12:55:00',6.73),('11288','2013-06-22','13:00:00',6.63),('11288','2013-06-22','13:05:00',6.67),('11288','2013-06-22','13:10:00',6.62),('11288','2013-06-22','13:15:00',6.48),('11288','2013-06-22','13:20:00',6.33),('11288','2013-06-22','13:25:00',6.92),('11288','2013-06-22','13:30:00',7.16),('11288','2013-06-22','13:35:00',7.21),('11288','2013-06-22','13:40:00',6.43),('11288','2013-06-22','13:45:00',6.99),('11288','2013-06-22','13:50:00',6.98),('11288','2013-06-22','13:55:00',4.96),('11288','2013-06-22','14:00:00',5.01),('11288','2013-06-22','14:05:00',7.65),('11288','2013-06-22','14:10:00',7.29),('11288','2013-06-22','14:15:00',7.12),('11288','2013-06-22','14:20:00',6.09),('11288','2013-06-22','14:25:00',7.01),('11288','2013-06-22','14:30:00',4.98),('11288','2013-06-22','14:35:00',3.89),('11288','2013-06-22','14:40:00',3),('11288','2013-06-22','14:45:00',4.05),('11288','2013-06-22','14:50:00',6.67),('11288','2013-06-22','14:55:00',6.88),('11288','2013-06-22','15:00:00',6.75),('11288','2013-06-22','15:05:00',5.07),('11288','2013-06-22','15:10:00',6.84),('11288','2013-06-22','15:15:00',6.87),('11288','2013-06-22','15:20:00',6.13),('11288','2013-06-22','15:25:00',5.39),('11288','2013-06-22','15:30:00',4.08),('11288','2013-06-22','15:35:00',3.07),('11288','2013-06-22','15:40:00',3.76),('11288','2013-06-22','15:45:00',4.9),('11288','2013-06-22','15:50:00',4.34),('11288','2013-06-22','15:55:00',4.37),('11288','2013-06-22','16:00:00',3.17),('11288','2013-06-22','16:05:00',2.23),('11288','2013-06-22','16:10:00',2.36),('11288','2013-06-22','16:15:00',2.99),('11288','2013-06-22','16:20:00',3.26),('11288','2013-06-22','16:25:00',2.32),('11288','2013-06-22','16:30:00',1.89),('11288','2013-06-22','16:35:00',1.64),('11288','2013-06-22','16:40:00',1.51),('11288','2013-06-22','16:45:00',1.45),('11288','2013-06-22','16:50:00',1.61),('11288','2013-06-22','16:55:00',2.33),('11288','2013-06-22','17:00:00',2.78),('11288','2013-06-22','17:05:00',2.71),('11288','2013-06-22','17:10:00',3.82),('11288','2013-06-22','17:15:00',4.86),('11288','2013-06-22','17:20:00',4.61),('11288','2013-06-22','17:25:00',4.7),('11288','2013-06-22','17:30:00',3.57),('11288','2013-06-22','17:35:00',3.48),('11288','2013-06-22','17:40:00',3.85),('11288','2013-06-22','17:45:00',3.74),('11288','2013-06-22','17:50:00',3.37),('11288','2013-06-22','17:55:00',3.36),('11288','2013-06-22','18:00:00',3.05),('11288','2013-06-22','18:05:00',2.52),('11288','2013-06-22','18:10:00',1.73),('11288','2013-06-22','18:15:00',1.83),('11288','2013-06-22','18:20:00',1.84),('11288','2013-06-22','18:25:00',1.05),('11288','2013-06-22','18:35:00',1.1),('11288','2013-06-22','18:40:00',1.05),('11288','2013-06-22','19:00:00',1.03),('11288','2013-06-22','19:15:00',1.18),('11288','2013-06-22','19:20:00',1.16),('11288','2013-06-22','19:25:00',1.15),('11288','2013-06-21','07:10:00',1.03),('11288','2013-06-21','07:15:00',1.13),('11288','2013-06-21','07:20:00',1.19),('11288','2013-06-21','07:25:00',1.29),('11288','2013-06-21','07:30:00',1.4),('11288','2013-06-21','07:35:00',1.49),('11288','2013-06-21','07:40:00',1.57),('11288','2013-06-21','07:45:00',1.62),('11288','2013-06-21','07:50:00',1.79),('11288','2013-06-21','07:55:00',1.89),('11288','2013-06-21','08:00:00',2.08),('11288','2013-06-21','08:05:00',2.26),('11288','2013-06-21','08:10:00',2.29),('11288','2013-06-21','08:15:00',2.43),('11288','2013-06-21','08:20:00',2.61),('11288','2013-06-21','08:25:00',2.69),('11288','2013-06-21','08:30:00',2.79),('11288','2013-06-21','08:35:00',2.96),('11288','2013-06-21','08:40:00',2.89),('11288','2013-06-21','08:45:00',2.91),('11288','2013-06-21','08:50:00',3.4),('11288','2013-06-21','08:55:00',3.48),('11288','2013-06-21','09:00:00',3.64),('11288','2013-06-21','09:05:00',3.74),('11288','2013-06-21','09:10:00',3.7),('11288','2013-06-21','09:15:00',3.72),('11288','2013-06-21','09:20:00',4.05),('11288','2013-06-21','09:25:00',4),('11288','2013-06-21','09:30:00',3.91),('11288','2013-06-21','09:35:00',4.31),('11288','2013-06-21','09:40:00',4.38),('11288','2013-06-21','09:45:00',4.38),('11288','2013-06-21','09:50:00',4.75),('11288','2013-06-21','09:55:00',4.68),('11288','2013-06-21','10:00:00',4.67),('11288','2013-06-21','10:05:00',4.98),('11288','2013-06-21','10:10:00',5.08),('11288','2013-06-21','10:15:00',5.17),('11288','2013-06-21','10:20:00',5.25),('11288','2013-06-21','10:25:00',5.31),('11288','2013-06-21','10:30:00',5.38),('11288','2013-06-21','10:35:00',5.49),('11288','2013-06-21','10:40:00',5.57),('11288','2013-06-21','10:45:00',5.63),('11288','2013-06-21','10:50:00',5.7),('11288','2013-06-21','10:55:00',5.66),('11288','2013-06-21','11:00:00',5.74),('11288','2013-06-21','11:05:00',5.81),('11288','2013-06-21','11:10:00',5.89),('11288','2013-06-21','11:15:00',6.02),('11288','2013-06-21','11:20:00',6.12),('11288','2013-06-21','11:25:00',6.15),('11288','2013-06-21','11:30:00',6.17),('11288','2013-06-21','11:35:00',6.2),('11288','2013-06-21','11:40:00',6.23),('11288','2013-06-21','11:45:00',6.27),('11288','2013-06-21','11:50:00',6.39),('11288','2013-06-21','11:55:00',6.37),('11288','2013-06-21','12:00:00',6.41),('11288','2013-06-21','12:05:00',6.41),('11288','2013-06-21','12:10:00',6.4),('11288','2013-06-21','12:15:00',6.38),('11288','2013-06-21','12:20:00',6.37),('11288','2013-06-21','12:25:00',6.35),('11288','2013-06-21','12:30:00',6.33),('11288','2013-06-21','12:35:00',6.36),('11288','2013-06-21','12:40:00',6.42),('11288','2013-06-21','12:45:00',6.51),('11288','2013-06-21','12:50:00',6.35),('11288','2013-06-21','12:55:00',6.38),('11288','2013-06-21','13:00:00',6.44),('11288','2013-06-21','13:05:00',6.35),('11288','2013-06-21','13:10:00',6.46),('11288','2013-06-21','13:15:00',6.55),('11288','2013-06-21','13:20:00',6.58),('11288','2013-06-21','13:25:00',6.62),('11288','2013-06-21','13:30:00',6.66),('11288','2013-06-21','13:35:00',6.62),('11288','2013-06-21','13:40:00',6.64),('11288','2013-06-21','13:45:00',6.62),('11288','2013-06-21','13:50:00',6.59),('11288','2013-06-21','13:55:00',6.65),('11288','2013-06-21','14:00:00',6.69),('11288','2013-06-21','14:05:00',6.65),('11288','2013-06-21','14:10:00',6.6),('11288','2013-06-21','14:15:00',6.56),('11288','2013-06-21','14:20:00',6.55),('11288','2013-06-21','14:25:00',6.6),('11288','2013-06-21','14:30:00',6.58),('11288','2013-06-21','14:35:00',6.52),('11288','2013-06-21','14:40:00',6.5),('11288','2013-06-21','14:45:00',6.48),('11288','2013-06-21','14:50:00',6.47),('11288','2013-06-21','14:55:00',6.44),('11288','2013-06-21','15:00:00',6.4),('11288','2013-06-21','15:05:00',6.36),('11288','2013-06-21','15:10:00',6.28),('11288','2013-06-21','15:15:00',6.25),('11288','2013-06-21','15:20:00',6.16),('11288','2013-06-21','15:25:00',6.11),('11288','2013-06-21','15:30:00',6.09),('11288','2013-06-21','15:35:00',6.04),('11288','2013-06-21','15:40:00',5.95),('11288','2013-06-21','15:45:00',5.88),('11288','2013-06-21','15:50:00',5.82),('11288','2013-06-21','15:55:00',5.74),('11288','2013-06-21','16:00:00',5.66),('11288','2013-06-21','16:05:00',5.59),('11288','2013-06-21','16:10:00',5.49),('11288','2013-06-21','16:15:00',5.41),('11288','2013-06-21','16:20:00',5.31),('11288','2013-06-21','16:25:00',5.22),('11288','2013-06-21','16:30:00',5.13),('11288','2013-06-21','16:35:00',5),('11288','2013-06-21','16:40:00',4.88),('11288','2013-06-21','16:45:00',4.77),('11288','2013-06-21','16:50:00',4.66),('11288','2013-06-21','16:55:00',4.58),('11288','2013-06-21','17:00:00',4.46),('11288','2013-06-21','17:05:00',4.32),('11288','2013-06-21','17:10:00',4.24),('11288','2013-06-21','17:15:00',4.12),('11288','2013-06-21','17:20:00',4),('11288','2013-06-21','17:25:00',3.88),('11288','2013-06-21','17:30:00',3.77),('11288','2013-06-21','17:35:00',3.72),('11288','2013-06-21','17:40:00',3.62),('11288','2013-06-21','17:45:00',3.44),('11288','2013-06-21','17:50:00',3.29),('11288','2013-06-21','17:55:00',3.17),('11288','2013-06-21','18:00:00',3.05),('11288','2013-06-21','18:05:00',2.92),('11288','2013-06-21','18:10:00',2.78),('11288','2013-06-21','18:15:00',2.64),('11288','2013-06-21','18:20:00',2.51),('11288','2013-06-21','18:25:00',2.34),('11288','2013-06-21','18:30:00',2.23),('11288','2013-06-21','18:35:00',2.1),('11288','2013-06-21','18:40:00',1.96),('11288','2013-06-21','18:45:00',1.83),('11288','2013-06-21','18:50:00',1.69),('11288','2013-06-21','18:55:00',1.57),('11288','2013-06-21','19:00:00',1.48),('11288','2013-06-21','19:05:00',1.35),('11288','2013-06-21','19:10:00',1.21),('11288','2013-06-21','19:15:00',1.05),('11288','2014-04-04','08:35:00',1.03),('11288','2014-04-04','08:40:00',1.43),('11288','2014-04-04','08:45:00',1.55),('11288','2014-04-04','08:50:00',1.77),('11288','2014-04-04','08:55:00',1.72),('11288','2014-04-04','09:00:00',1.79),('11288','2014-04-04','09:05:00',2.65),('11288','2014-04-04','09:10:00',3.19),('11288','2014-04-04','09:15:00',3.12),('11288','2014-04-04','09:20:00',2.29),('11288','2014-04-04','09:25:00',1.59),('11288','2014-04-04','09:30:00',1.57),('11288','2014-04-04','09:35:00',1.6),('11288','2014-04-04','09:40:00',1.52),('11288','2014-04-04','09:45:00',1.47),('11288','2014-04-04','09:50:00',1.36),('11288','2014-04-04','11:15:00',1.07),('11288','2014-04-04','11:20:00',1.14),('11288','2014-04-04','12:50:00',1.18),('11288','2014-04-04','13:05:00',1.14),('11288','2014-04-04','13:10:00',2.12),('11288','2014-04-04','13:15:00',1.68),('11288','2014-04-04','13:20:00',3.45),('11288','2014-04-04','13:25:00',3.69),('11288','2014-04-04','13:30:00',3.8),('11288','2014-04-04','13:35:00',4.89),('11288','2014-04-04','13:40:00',7.5),('11288','2014-04-04','13:45:00',5.58),('11288','2014-04-04','13:50:00',7.29),('11288','2014-04-04','13:55:00',3.34),('11288','2014-04-04','14:00:00',5.63),('11288','2014-04-04','14:05:00',7.17),('11288','2014-04-04','14:10:00',7.72),('11288','2014-04-04','14:15:00',5.24),('11288','2014-04-04','14:20:00',5.32),('11288','2014-04-04','14:25:00',5.4),('11288','2014-04-04','14:30:00',2.17),('11288','2014-04-04','14:35:00',3.55),('11288','2014-04-04','14:40:00',2.33),('11288','2014-04-04','14:45:00',2.63),('11288','2014-04-04','14:50:00',5.24),('11288','2014-04-04','14:55:00',6.84),('11288','2014-04-04','15:00:00',5.86),('11288','2014-04-04','15:05:00',5.21),('11288','2014-04-04','15:10:00',6.17),('11288','2014-04-04','15:15:00',5.33),('11288','2014-04-04','15:20:00',3.39),('11288','2014-04-04','15:25:00',3.19),('11288','2014-04-04','15:30:00',2.56),('11288','2014-04-04','15:35:00',2.72),('11288','2014-04-04','15:40:00',3.6),('11288','2014-04-04','15:45:00',2.81),('11288','2014-04-04','15:50:00',3.36),('11288','2014-04-04','15:55:00',5.41),('11288','2014-04-04','16:00:00',3.64),('11288','2014-04-04','16:05:00',3.8),('11288','2014-04-04','16:10:00',5.29),('11288','2014-04-04','16:15:00',2.93),('11288','2014-04-04','16:20:00',1.97),('11288','2014-04-04','16:25:00',2.07),('11288','2014-04-04','16:30:00',3.58),('11288','2014-04-04','16:35:00',2.98),('11288','2014-04-04','16:40:00',2.41),('11288','2014-04-04','16:45:00',3.97),('11288','2014-04-04','16:50:00',4.37),('11288','2014-04-04','16:55:00',3.97),('11288','2014-04-04','17:00:00',3.4),('11288','2014-04-04','17:05:00',3.02),('11288','2014-04-04','17:10:00',3.46),('11288','2014-04-04','17:15:00',3.31),('11288','2014-04-04','17:20:00',2.58),('11288','2014-04-04','17:25:00',2.31),('11288','2014-04-04','17:30:00',3),('11288','2014-04-04','17:35:00',2.12),('11288','2014-04-04','17:40:00',2.4),('11288','2014-04-04','17:45:00',2.4),('11288','2014-04-04','17:50:00',2.28),('11288','2014-04-04','17:55:00',1.97),('11288','2014-04-04','18:00:00',1.78),('11288','2014-04-04','18:10:00',1.32),('11288','2014-04-04','18:15:00',1.22),('11288','2014-04-04','18:20:00',1.06),('11288','2013-06-20','07:15:00',1.03),('11288','2013-06-20','07:20:00',1.1),('11288','2013-06-20','07:25:00',1.18),('11288','2013-06-20','07:30:00',1.31),('11288','2013-06-20','07:35:00',1.36),('11288','2013-06-20','07:40:00',1.43),('11288','2013-06-20','07:45:00',1.51),('11288','2013-06-20','07:50:00',1.63),('11288','2013-06-20','07:55:00',1.7),('11288','2013-06-20','08:00:00',2.06),('11288','2013-06-20','08:05:00',2.13),('11288','2013-06-20','08:10:00',2.2),('11288','2013-06-20','08:15:00',2.42),('11288','2013-06-20','08:20:00',2.54),('11288','2013-06-20','08:25:00',2.63),('11288','2013-06-20','08:30:00',2.77),('11288','2013-06-20','08:35:00',2.97),('11288','2013-06-20','08:40:00',3.1),('11288','2013-06-20','08:45:00',3.31),('11288','2013-06-20','08:50:00',3.42),('11288','2013-06-20','08:55:00',3.55),('11288','2013-06-20','09:00:00',3.67),('11288','2013-06-20','09:05:00',3.76),('11288','2013-06-20','09:10:00',3.69),('11288','2013-06-20','09:15:00',3.86),('11288','2013-06-20','09:20:00',4.15),('11288','2013-06-20','09:25:00',4.1),('11288','2013-06-20','09:30:00',4.19),('11288','2013-06-20','09:35:00',4.49),('11288','2013-06-20','09:40:00',4.5),('11288','2013-06-20','09:45:00',4.46),('11288','2013-06-20','09:50:00',4.9),('11288','2013-06-20','09:55:00',4.78),('11288','2013-06-20','10:00:00',4.83),('11288','2013-06-20','10:05:00',5.2),('11288','2013-06-20','10:10:00',5.27),('11288','2013-06-20','10:15:00',5.32),('11288','2013-06-20','10:20:00',5.5),('11288','2013-06-20','10:25:00',5.59),('11288','2013-06-20','10:30:00',5.61),('11288','2013-06-20','10:35:00',5.71),('11288','2013-06-20','10:40:00',5.78),('11288','2013-06-20','10:45:00',5.82),('11288','2013-06-20','10:50:00',5.93),('11288','2013-06-20','10:55:00',6.02),('11288','2013-06-20','11:00:00',5.96),('11288','2013-06-20','11:05:00',6.04),('11288','2013-06-20','11:10:00',6.06),('11288','2013-06-20','11:15:00',6.05),('11288','2013-06-20','11:20:00',6.06),('11288','2013-06-20','11:25:00',6.11),('11288','2013-06-20','11:30:00',6.2),('11288','2013-06-20','11:35:00',6.27),('11288','2013-06-20','11:40:00',6.28),('11288','2013-06-20','11:45:00',6.19),('11288','2013-06-20','11:50:00',6.1),('11288','2013-06-20','11:55:00',6.16),('11288','2013-06-20','12:00:00',6.09),('11288','2013-06-20','12:05:00',6.19),('11288','2013-06-20','12:10:00',4.88),('11288','2013-06-20','12:15:00',6.26),('11288','2013-06-20','12:20:00',4.31),('11288','2013-06-20','12:25:00',4.55),('11288','2013-06-20','12:30:00',6.64),('11288','2013-06-20','12:35:00',6.43),('11288','2013-06-20','12:40:00',6.39),('11288','2013-06-20','12:45:00',4.28),('11288','2013-06-20','12:50:00',6.63),('11288','2013-06-20','12:55:00',6.55),('11288','2013-06-20','13:00:00',6.82),('11288','2013-06-20','13:05:00',6.67),('11288','2013-06-20','13:10:00',5.18),('11288','2013-06-20','13:15:00',4.57),('11288','2013-06-20','13:20:00',6.62),('11288','2013-06-20','13:25:00',6.64),('11288','2013-06-20','13:30:00',6.05),('11288','2013-06-20','13:35:00',6.74),('11288','2013-06-20','13:40:00',6.72),('11288','2013-06-20','13:45:00',6.78),('11288','2013-06-20','13:50:00',6.77),('11288','2013-06-20','13:55:00',6.68),('11288','2013-06-20','14:00:00',6.79),('11288','2013-06-20','14:05:00',6.68),('11288','2013-06-20','14:10:00',6.73),('11288','2013-06-20','14:15:00',6.74),('11288','2013-06-20','14:20:00',6.78),('11288','2013-06-20','14:25:00',6.73),('11288','2013-06-20','14:30:00',6.77),('11288','2013-06-20','14:35:00',6.76),('11288','2013-06-20','14:40:00',6.76),('11288','2013-06-20','14:45:00',6.72),('11288','2013-06-20','14:50:00',6.68),('11288','2013-06-20','14:55:00',6.63),('11288','2013-06-20','15:00:00',6.55),('11288','2013-06-20','15:05:00',6.52),('11288','2013-06-20','15:10:00',6.48),('11288','2013-06-20','15:15:00',6.39),('11288','2013-06-20','15:20:00',6.34),('11288','2013-06-20','15:25:00',6.26),('11288','2013-06-20','15:30:00',6.16),('11288','2013-06-20','15:35:00',6.09),('11288','2013-06-20','15:40:00',6.03),('11288','2013-06-20','15:45:00',5.91),('11288','2013-06-20','15:50:00',5.87),('11288','2013-06-20','15:55:00',5.8),('11288','2013-06-20','16:00:00',5.74),('11288','2013-06-20','16:05:00',5.63),('11288','2013-06-20','16:10:00',5.6),('11288','2013-06-20','16:15:00',5.52),('11288','2013-06-20','16:20:00',5.36),('11288','2013-06-20','16:25:00',5.3),('11288','2013-06-20','16:30:00',5.22),('11288','2013-06-20','16:35:00',5.06),('11288','2013-06-20','16:40:00',4.81),('11288','2013-06-20','16:45:00',4.53),('11288','2013-06-20','16:50:00',4.53),('11288','2013-06-20','16:55:00',4.59),('11288','2013-06-20','17:00:00',4.48),('11288','2013-06-20','17:05:00',4.37),('11288','2013-06-20','17:10:00',4.26),('11288','2013-06-20','17:15:00',4.16),('11288','2013-06-20','17:20:00',4.02),('11288','2013-06-20','17:25:00',3.94),('11288','2013-06-20','17:30:00',3.79),('11288','2013-06-20','17:35:00',3.73),('11288','2013-06-20','17:40:00',3.66),('11288','2013-06-20','17:45:00',3.49),('11288','2013-06-20','17:50:00',3.33),('11288','2013-06-20','17:55:00',3.23),('11288','2013-06-20','18:00:00',3.11),('11288','2013-06-20','18:05:00',2.97),('11288','2013-06-20','18:10:00',2.84),('11288','2013-06-20','18:15:00',2.7),('11288','2013-06-20','18:20:00',2.58),('11288','2013-06-20','18:25:00',2.43),('11288','2013-06-20','18:30:00',2.29),('11288','2013-06-20','18:35:00',2.14),('11288','2013-06-20','18:40:00',2.01),('11288','2013-06-20','18:45:00',1.87),('11288','2013-06-20','18:50:00',1.74),('11288','2013-06-20','18:55:00',1.6),('11288','2013-06-20','19:00:00',1.47),('11288','2013-06-20','19:05:00',1.34),('11288','2013-06-20','19:10:00',1.22),('11288','2013-06-20','19:15:00',1.08),('11288','2013-06-19','07:15:00',1.07),('11288','2013-06-19','07:20:00',1.14),('11288','2013-06-19','07:25:00',1.21),('11288','2013-06-19','07:30:00',1.3),('11288','2013-06-19','07:35:00',1.38),('11288','2013-06-19','07:40:00',1.46),('11288','2013-06-19','07:45:00',1.54),('11288','2013-06-19','07:50:00',1.65),('11288','2013-06-19','07:55:00',1.73),('11288','2013-06-19','08:00:00',2),('11288','2013-06-19','08:05:00',2.1),('11288','2013-06-19','08:10:00',2.14),('11288','2013-06-19','08:15:00',2.38),('11288','2013-06-19','08:20:00',2.49),('11288','2013-06-19','08:25:00',2.59),('11288','2013-06-19','08:30:00',2.71),('11288','2013-06-19','08:35:00',2.93),('11288','2013-06-19','08:40:00',2.95),('11288','2013-06-19','08:45:00',3.01),('11288','2013-06-19','08:50:00',3.32),('11288','2013-06-19','08:55:00',3.39),('11288','2013-06-19','09:00:00',3.59),('11288','2013-06-19','09:05:00',3.68),('11288','2013-06-19','09:10:00',3.58),('11288','2013-06-19','09:15:00',3.6),('11288','2013-06-19','09:20:00',4.07),('11288','2013-06-19','09:25:00',3.93),('11288','2013-06-19','09:30:00',3.87),('11288','2013-06-19','09:35:00',4.39),('11288','2013-06-19','09:40:00',4.38),('11288','2013-06-19','09:45:00',4.36),('11288','2013-06-19','09:50:00',4.78),('11288','2013-06-19','09:55:00',4.66),('11288','2013-06-19','10:00:00',4.66),('11288','2013-06-19','10:05:00',5),('11288','2013-06-19','10:10:00',5.08),('11288','2013-06-19','10:15:00',5.19),('11288','2013-06-19','10:20:00',5.32),('11288','2013-06-19','10:25:00',5.4),('11288','2013-06-19','10:30:00',5.51),('11288','2013-06-19','10:35:00',5.59),('11288','2013-06-19','10:40:00',5.59),('11288','2013-06-19','10:45:00',5.63),('11288','2013-06-19','10:50:00',5.73),('11288','2013-06-19','10:55:00',5.76),('11288','2013-06-19','11:00:00',5.8),('11288','2013-06-19','11:05:00',5.83),('11288','2013-06-19','11:10:00',5.91),('11288','2013-06-19','11:15:00',5.91),('11288','2013-06-19','11:20:00',6.05),('11288','2013-06-19','11:25:00',6.05),('11288','2013-06-19','11:30:00',6.12),('11288','2013-06-19','11:35:00',6.09),('11288','2013-06-19','11:40:00',6.15),('11288','2013-06-19','11:45:00',6.22),('11288','2013-06-19','11:50:00',6.22),('11288','2013-06-19','11:55:00',6.28),('11288','2013-06-19','12:00:00',6.31),('11288','2013-06-19','12:05:00',6.26),('11288','2013-06-19','12:10:00',6.33),('11288','2013-06-19','12:15:00',6.32),('11288','2013-06-19','12:20:00',6.32),('11288','2013-06-19','12:25:00',6.3),('11288','2013-06-19','12:30:00',6.45),('11288','2013-06-19','12:35:00',6.56),('11288','2013-06-19','12:40:00',6.59),('11288','2013-06-19','12:45:00',6.5),('11288','2013-06-19','12:50:00',6.57),('11288','2013-06-19','12:55:00',6.54),('11288','2013-06-19','13:00:00',6.52),('11288','2013-06-19','13:05:00',6.61),('11288','2013-06-19','13:10:00',6.58),('11288','2013-06-19','13:15:00',6.53),('11288','2013-06-19','13:20:00',6.6),('11288','2013-06-19','13:25:00',6.67),('11288','2013-06-19','13:30:00',6.63),('11288','2013-06-19','13:35:00',6.61),('11288','2013-06-19','13:40:00',6.61),('11288','2013-06-19','13:45:00',6.61),('11288','2013-06-19','13:50:00',6.65),('11288','2013-06-19','13:55:00',6.65),('11288','2013-06-19','14:00:00',6.63),('11288','2013-06-19','14:05:00',6.61),('11288','2013-06-19','14:10:00',6.58),('11288','2013-06-19','14:15:00',6.53),('11288','2013-06-19','14:20:00',6.49),('11288','2013-06-19','14:25:00',6.54),('11288','2013-06-19','14:30:00',6.45),('11288','2013-06-19','14:35:00',6.38),('11288','2013-06-19','14:40:00',6.32),('11288','2013-06-19','14:45:00',6.32),('11288','2013-06-19','14:50:00',6.3),('11288','2013-06-19','14:55:00',6.26),('11288','2013-06-19','15:00:00',6.22),('11288','2013-06-19','15:05:00',6.16),('11288','2013-06-19','15:10:00',6.13),('11288','2013-06-19','15:15:00',6.08),('11288','2013-06-19','15:20:00',6.05),('11288','2013-06-19','15:25:00',5.99),('11288','2013-06-19','15:30:00',5.88),('11288','2013-06-19','15:35:00',5.82),('11288','2013-06-19','15:40:00',5.73),('11288','2013-06-19','15:45:00',5.67),('11288','2013-06-19','15:50:00',5.58),('11288','2013-06-19','15:55:00',5.53),('11288','2013-06-19','16:00:00',5.48),('11288','2013-06-19','16:05:00',5.34),('11288','2013-06-19','16:10:00',5.26),('11288','2013-06-19','16:15:00',5.17),('11288','2013-06-19','16:20:00',5.07),('11288','2013-06-19','16:25:00',5),('11288','2013-06-19','16:30:00',4.91),('11288','2013-06-19','16:35:00',4.75),('11288','2013-06-19','16:40:00',4.58),('11288','2013-06-19','16:45:00',4.36),('11288','2013-06-19','16:50:00',4.32),('11288','2013-06-19','16:55:00',4.42),('11288','2013-06-19','17:00:00',4.32),('11288','2013-06-19','17:05:00',4.18),('11288','2013-06-19','17:10:00',4.1),('11288','2013-06-19','17:15:00',4.01),('11288','2013-06-19','17:20:00',3.92),('11288','2013-06-19','17:25:00',3.84),('11288','2013-06-19','17:30:00',3.73),('11288','2013-06-19','17:35:00',3.69),('11288','2013-06-19','17:40:00',3.57),('11288','2013-06-19','17:45:00',3.4),('11288','2013-06-19','17:50:00',3.25),('11288','2013-06-19','17:55:00',3.13),('11288','2013-06-19','18:00:00',3.01),('11288','2013-06-19','18:05:00',2.87),('11288','2013-06-19','18:10:00',2.7),('11288','2013-06-19','18:15:00',2.57),('11288','2013-06-19','18:20:00',2.44),('11288','2013-06-19','18:25:00',2.26),('11288','2013-06-19','18:30:00',2.14),('11288','2013-06-19','18:35:00',1.92),('11288','2013-06-19','18:40:00',1.72),('11288','2013-06-19','18:45:00',1.67),('11288','2013-06-19','18:50:00',1.55),('11288','2013-06-19','18:55:00',1.46),('11288','2013-06-19','19:00:00',1.41),('11288','2013-06-19','19:05:00',1.28),('11288','2013-06-19','19:10:00',1.14),('11288','2013-06-19','19:15:00',1.04),('11288','2013-06-18','07:20:00',1.09),('11288','2013-06-18','07:25:00',1.16),('11288','2013-06-18','07:30:00',1.27),('11288','2013-06-18','07:35:00',1.36),('11288','2013-06-18','07:40:00',1.42),('11288','2013-06-18','07:45:00',1.52),('11288','2013-06-18','07:50:00',1.67),('11288','2013-06-18','07:55:00',1.74),('11288','2013-06-18','08:00:00',2),('11288','2013-06-18','08:05:00',2.1),('11288','2013-06-18','08:10:00',2.15),('11288','2013-06-18','08:15:00',2.32),('11288','2013-06-18','08:20:00',2.47),('11288','2013-06-18','08:25:00',2.6),('11288','2013-06-18','08:30:00',2.71),('11288','2013-06-18','08:35:00',2.91),('11288','2013-06-18','08:40:00',2.91),('11288','2013-06-18','08:45:00',3.01),('11288','2013-06-18','08:50:00',3.3),('11288','2013-06-18','08:55:00',3.41),('11288','2013-06-18','09:00:00',3.56),('11288','2013-06-18','09:05:00',3.66),('11288','2013-06-18','09:10:00',3.59),('11288','2013-06-18','09:15:00',3.61),('11288','2013-06-18','09:20:00',4.01),('11288','2013-06-18','09:25:00',3.89),('11288','2013-06-18','09:30:00',3.82),('11288','2013-06-18','09:35:00',4.3),('11288','2013-06-18','09:40:00',4.28),('11288','2013-06-18','09:45:00',4.34),('11288','2013-06-18','09:50:00',4.66),('11288','2013-06-18','09:55:00',4.58),('11288','2013-06-18','10:00:00',4.63),('11288','2013-06-18','10:05:00',4.97),('11288','2013-06-18','10:10:00',5.02),('11288','2013-06-18','10:15:00',5.18),('11288','2013-06-18','10:20:00',5.32),('11288','2013-06-18','10:25:00',5.39),('11288','2013-06-18','10:30:00',5.45),('11288','2013-06-18','10:35:00',5.59),('11288','2013-06-18','10:40:00',5.64),('11288','2013-06-18','10:45:00',5.72),('11288','2013-06-18','10:50:00',5.75),('11288','2013-06-18','10:55:00',5.76),('11288','2013-06-18','11:00:00',5.81),('11288','2013-06-18','11:05:00',5.9),('11288','2013-06-18','11:10:00',5.87),('11288','2013-06-18','11:15:00',5.92),('11288','2013-06-18','11:20:00',6.06),('11288','2013-06-18','11:25:00',6.08),('11288','2013-06-18','11:30:00',6.05),('11288','2013-06-18','11:35:00',6.08),('11288','2013-06-18','11:40:00',6.12),('11288','2013-06-18','11:45:00',6.11),('11288','2013-06-18','11:50:00',6.13),('11288','2013-06-18','11:55:00',6.16),('11288','2013-06-18','12:00:00',6.19),('11288','2013-06-18','12:05:00',6.2),('11288','2013-06-18','12:10:00',6.05),('11288','2013-06-18','12:15:00',5.72),('11288','2013-06-18','12:20:00',6.21),('11288','2013-06-18','12:25:00',6.33),('11288','2013-06-18','12:30:00',6.23),('11288','2013-06-18','12:35:00',6.19),('11288','2013-06-18','12:40:00',4.87),('11288','2013-06-18','12:45:00',4.44),('11288','2013-06-18','12:50:00',2.76),('11288','2013-06-18','12:55:00',5.41),('11288','2013-06-18','13:00:00',3.29),('11288','2013-06-18','13:05:00',5.13),('11288','2013-06-18','13:10:00',5.65),('11288','2013-06-18','13:15:00',5.76),('11288','2013-06-18','13:20:00',6.67),('11288','2013-06-18','13:25:00',4.86),('11288','2013-06-18','13:30:00',4.45),('11288','2013-06-18','13:35:00',6.87),('11288','2013-06-18','13:40:00',5.84),('11288','2013-06-18','13:45:00',4.85),('11288','2013-06-18','13:50:00',6.62),('11288','2013-06-18','13:55:00',5.18),('11288','2013-06-18','14:00:00',6.72),('11288','2013-06-18','14:05:00',6.81),('11288','2013-06-18','14:10:00',6.59),('11288','2013-06-18','14:15:00',6.64),('11288','2013-06-18','14:20:00',6.63),('11288','2013-06-18','14:25:00',6.54),('11288','2013-06-18','14:30:00',6.5),('11288','2013-06-18','14:35:00',6.61),('11288','2013-06-18','14:40:00',6.63),('11288','2013-06-18','14:45:00',6.56),('11288','2013-06-18','14:50:00',6.47),('11288','2013-06-18','14:55:00',6.44),('11288','2013-06-18','15:00:00',6.38),('11288','2013-06-18','15:05:00',6.27),('11288','2013-06-18','15:10:00',6.23),('11288','2013-06-18','15:15:00',6.13),('11288','2013-06-18','15:20:00',6.07),('11288','2013-06-18','15:25:00',6.02),('11288','2013-06-18','15:30:00',5.95),('11288','2013-06-18','15:35:00',5.94),('11288','2013-06-18','15:40:00',5.93),('11288','2013-06-18','15:45:00',5.83),('11288','2013-06-18','15:50:00',5.78),('11288','2013-06-18','15:55:00',5.78),('11288','2013-06-18','16:00:00',5.72),('11288','2013-06-18','16:05:00',5.66),('11288','2013-06-18','16:10:00',5.6),('11288','2013-06-18','16:15:00',5.56),('11288','2013-06-18','16:20:00',5.49),('11288','2013-06-18','16:25:00',5.35),('11288','2013-06-18','16:30:00',5.21),('11288','2013-06-18','16:35:00',4.94),('11288','2013-06-18','16:40:00',4.85),('11288','2013-06-18','16:45:00',4.67),('11288','2013-06-18','16:50:00',4.59),('11288','2013-06-18','16:55:00',4.49),('11288','2013-06-18','17:00:00',4.38),('11288','2013-06-18','17:05:00',4.25),('11288','2013-06-18','17:10:00',4.13),('11288','2013-06-18','17:15:00',4.05),('11288','2013-06-18','17:20:00',3.95),('11288','2013-06-18','17:25:00',3.87),('11288','2013-06-18','17:30:00',3.73),('11288','2013-06-18','17:35:00',3.64),('11288','2013-06-18','17:40:00',3.55),('11288','2013-06-18','17:45:00',3.37),('11288','2013-06-18','17:50:00',3.23),('11288','2013-06-18','17:55:00',3.13),('11288','2013-06-18','18:00:00',3.01),('11288','2013-06-18','18:05:00',2.87),('11288','2013-06-18','18:10:00',2.73),('11288','2013-06-18','18:15:00',2.6),('11288','2013-06-18','18:20:00',2.55),('11288','2013-06-18','18:25:00',2.37),('11288','2013-06-18','18:30:00',2.24),('11288','2013-06-18','18:35:00',2.13),('11288','2013-06-18','18:40:00',1.98),('11288','2013-06-18','18:45:00',1.87),('11288','2013-06-18','18:50:00',1.73),('11288','2013-06-18','18:55:00',1.6),('11288','2013-06-18','19:00:00',1.5),('11288','2013-06-18','19:05:00',1.37),('11288','2013-06-18','19:10:00',1.26),('11288','2013-06-18','19:15:00',1.13),('11288','2013-06-18','19:20:00',1.02),('11288','2013-06-17','07:15:00',1.1),('11288','2013-06-17','07:20:00',1.18),('11288','2013-06-17','07:25:00',1.25),('11288','2013-06-17','07:30:00',1.37),('11288','2013-06-17','07:35:00',1.43),('11288','2013-06-17','07:40:00',1.49),('11288','2013-06-17','07:45:00',1.62),('11288','2013-06-17','07:50:00',1.72),('11288','2013-06-17','07:55:00',1.8),('11288','2013-06-17','08:00:00',2.16),('11288','2013-06-17','08:05:00',2.18),('11288','2013-06-17','08:10:00',2.23),('11288','2013-06-17','08:15:00',2.43),('11288','2013-06-17','08:20:00',2.57),('11288','2013-06-17','08:25:00',2.7),('11288','2013-06-17','08:30:00',2.84),('11288','2013-06-17','08:35:00',3.04),('11288','2013-06-17','08:40:00',3.11),('11288','2013-06-17','08:45:00',3.36),('11288','2013-06-17','08:50:00',3.47),('11288','2013-06-17','08:55:00',3.59),('11288','2013-06-17','09:00:00',3.76),('11288','2013-06-17','09:05:00',3.8),('11288','2013-06-17','09:10:00',3.69),('11288','2013-06-17','09:15:00',3.97),('11288','2013-06-17','09:20:00',4.21),('11288','2013-06-17','09:25:00',4.04),('11288','2013-06-17','09:30:00',4.03),('11288','2013-06-17','09:35:00',4.51),('11288','2013-06-17','09:40:00',4.65),('11288','2013-06-17','09:45:00',4.82),('11288','2013-06-17','09:50:00',4.92),('11288','2013-06-17','09:55:00',4.82),('11288','2013-06-17','10:00:00',4.87),('11288','2013-06-17','10:05:00',5.2),('11288','2013-06-17','10:10:00',5.26),('11288','2013-06-17','10:15:00',5.33),('11288','2013-06-17','10:20:00',5.43),('11288','2013-06-17','10:25:00',5.52),('11288','2013-06-17','10:30:00',5.58),('11288','2013-06-17','10:35:00',5.74),('11288','2013-06-17','10:40:00',5.82),('11288','2013-06-17','10:45:00',5.89),('11288','2013-06-17','10:50:00',5.97),('11288','2013-06-17','10:55:00',6.04),('11288','2013-06-17','11:00:00',6.04),('11288','2013-06-17','11:05:00',6.11),('11288','2013-06-17','11:10:00',6.15),('11288','2013-06-17','11:15:00',6.19),('11288','2013-06-17','11:20:00',6.21),('11288','2013-06-17','11:25:00',6.27),('11288','2013-06-17','11:30:00',6.29),('11288','2013-06-17','11:35:00',6.35),('11288','2013-06-17','11:40:00',6.35),('11288','2013-06-17','11:45:00',6.39),('11288','2013-06-17','11:50:00',6.39),('11288','2013-06-17','11:55:00',6.4),('11288','2013-06-17','12:00:00',6.41),('11288','2013-06-17','12:05:00',6.41),('11288','2013-06-17','12:10:00',6.36),('11288','2013-06-17','12:15:00',6.42),('11288','2013-06-17','12:20:00',6.36),('11288','2013-06-17','12:25:00',6.47),('11288','2013-06-17','12:30:00',6.44),('11288','2013-06-17','12:35:00',6.54),('11288','2013-06-17','12:40:00',6.51),('11288','2013-06-17','12:45:00',6.64),('11288','2013-06-17','12:50:00',6.68),('11288','2013-06-17','12:55:00',6.81),('11288','2013-06-17','13:00:00',6.73),('11288','2013-06-17','13:05:00',6.72),('11288','2013-06-17','13:10:00',6.69),('11288','2013-06-17','13:15:00',6.71),('11288','2013-06-17','13:20:00',6.65),('11288','2013-06-17','13:25:00',6.68),('11288','2013-06-17','13:30:00',6.68),('11288','2013-06-17','13:35:00',6.67),('11288','2013-06-17','13:40:00',6.66),('11288','2013-06-17','13:45:00',6.65),('11288','2013-06-17','13:50:00',6.64),('11288','2013-06-17','13:55:00',6.63),('11288','2013-06-17','14:00:00',6.65),('11288','2013-06-17','14:05:00',6.58),('11288','2013-06-17','14:10:00',6.6),('11288','2013-06-17','14:15:00',6.56),('11288','2013-06-17','14:20:00',6.52),('11288','2013-06-17','14:25:00',6.47),('11288','2013-06-17','14:30:00',6.47),('11288','2013-06-17','14:35:00',6.37),('11288','2013-06-17','14:40:00',6.38),('11288','2013-06-17','14:45:00',6.36),('11288','2013-06-17','14:50:00',6.33),('11288','2013-06-17','14:55:00',6.28),('11288','2013-06-17','15:00:00',6.22),('11288','2013-06-17','15:05:00',6.18),('11288','2013-06-17','15:10:00',6.14),('11288','2013-06-17','15:15:00',6.11),('11288','2013-06-17','15:20:00',6.09),('11288','2013-06-17','15:25:00',6.02),('11288','2013-06-17','15:30:00',5.95),('11288','2013-06-17','15:35:00',5.87),('11288','2013-06-17','15:40:00',5.82),('11288','2013-06-17','15:45:00',5.77),('11288','2013-06-17','15:50:00',5.69),('11288','2013-06-17','15:55:00',5.62),('11288','2013-06-17','16:00:00',5.57),('11288','2013-06-17','16:05:00',5.49),('11288','2013-06-17','16:10:00',5.45),('11288','2013-06-17','16:15:00',5.34),('11288','2013-06-17','16:20:00',5.23),('11288','2013-06-17','16:25:00',5.17),('11288','2013-06-17','16:30:00',5.1),('11288','2013-06-17','16:35:00',4.94),('11288','2013-06-17','16:40:00',4.7),('11288','2013-06-17','16:45:00',4.43),('11288','2013-06-17','16:50:00',4.42),('11288','2013-06-17','16:55:00',4.51),('11288','2013-06-17','17:00:00',4.39),('11288','2013-06-17','17:05:00',4.27),('11288','2013-06-17','17:10:00',4.17),('11288','2013-06-17','17:15:00',4.07),('11288','2013-06-17','17:20:00',3.98),('11288','2013-06-17','17:25:00',3.89),('11288','2013-06-17','17:30:00',3.81),('11288','2013-06-17','17:35:00',3.78),('11288','2013-06-17','17:40:00',3.64),('11288','2013-06-17','17:45:00',3.47),('11288','2013-06-17','17:50:00',3.32),('11288','2013-06-17','17:55:00',3.23),('11288','2013-06-17','18:00:00',3.11),('11288','2013-06-17','18:05:00',2.99),('11288','2013-06-17','18:10:00',2.86),('11288','2013-06-17','18:15:00',2.72),('11288','2013-06-17','18:20:00',2.62),('11288','2013-06-17','18:25:00',2.29),('11288','2013-06-17','18:30:00',2.28),('11288','2013-06-17','18:35:00',1.98),('11288','2013-06-17','18:40:00',2.16),('11288','2013-06-17','18:45:00',2.05),('11288','2013-06-17','18:50:00',1.95),('11288','2013-06-17','18:55:00',1.84),('11288','2013-06-17','19:00:00',1.73),('11288','2013-06-17','19:05:00',1.58),('11288','2013-06-17','19:10:00',1.42),('11288','2013-06-17','19:15:00',1.27),('11288','2013-06-17','19:20:00',1.15),('11288','2013-06-17','19:25:00',1.07),('11288','2013-06-16','07:10:00',1.01),('11288','2013-06-16','07:15:00',1.12),('11288','2013-06-16','07:20:00',1.19),('11288','2013-06-16','07:25:00',1.28),('11288','2013-06-16','07:30:00',1.39),('11288','2013-06-16','07:35:00',1.45),('11288','2013-06-16','07:40:00',1.53),('11288','2013-06-16','07:45:00',1.66),('11288','2013-06-16','07:50:00',1.73),('11288','2013-06-16','07:55:00',1.81),('11288','2013-06-16','08:00:00',2.2),('11288','2013-06-16','08:05:00',2.22),('11288','2013-06-16','08:10:00',2.24),('11288','2013-06-16','08:15:00',2.54),('11288','2013-06-16','08:20:00',2.63),('11288','2013-06-16','08:25:00',2.75),('11288','2013-06-16','08:30:00',2.89),('11288','2013-06-16','08:35:00',3.04),('11288','2013-06-16','08:40:00',3.19),('11288','2013-06-16','08:45:00',3.43),('11288','2013-06-16','08:50:00',3.55),('11288','2013-06-16','08:55:00',3.65),('11288','2013-06-16','09:00:00',3.78),('11288','2013-06-16','09:05:00',3.85),('11288','2013-06-16','09:10:00',3.82),('11288','2013-06-16','09:15:00',4.09),('11288','2013-06-16','09:20:00',4.27),('11288','2013-06-16','09:25:00',4.07),('11288','2013-06-16','09:30:00',4.16),('11288','2013-06-16','09:35:00',4.6),('11288','2013-06-16','09:40:00',4.54),('11288','2013-06-16','09:45:00',4.63),('11288','2013-06-16','09:50:00',4.95),('11288','2013-06-16','09:55:00',4.81),('11288','2013-06-16','10:00:00',5),('11288','2013-06-16','10:05:00',5.34),('11288','2013-06-16','10:10:00',5.42),('11288','2013-06-16','10:15:00',5.44),('11288','2013-06-16','10:20:00',5.59),('11288','2013-06-16','10:25:00',5.72),('11288','2013-06-16','10:30:00',5.81),('11288','2013-06-16','10:35:00',5.84),('11288','2013-06-16','10:40:00',5.9),('11288','2013-06-16','10:45:00',6.02),('11288','2013-06-16','10:50:00',6.15),('11288','2013-06-16','10:55:00',6.17),('11288','2013-06-16','11:00:00',6.17),('11288','2013-06-16','11:05:00',6.22),('11288','2013-06-16','11:10:00',6.32),('11288','2013-06-16','11:15:00',6.36),('11288','2013-06-16','11:20:00',6.42),('11288','2013-06-16','11:25:00',6.48),('11288','2013-06-16','11:30:00',6.52),('11288','2013-06-16','11:35:00',6.56),('11288','2013-06-16','11:40:00',6.55),('11288','2013-06-16','11:45:00',6.55),('11288','2013-06-16','11:50:00',6.63),('11288','2013-06-16','11:55:00',6.67),('11288','2013-06-16','12:00:00',6.72),('11288','2013-06-16','12:05:00',6.77),('11288','2013-06-16','12:10:00',6.74),('11288','2013-06-16','12:15:00',6.77),('11288','2013-06-16','12:20:00',6.77),('11288','2013-06-16','12:25:00',6.77),('11288','2013-06-16','12:30:00',6.7),('11288','2013-06-16','12:35:00',6.81),('11288','2013-06-16','12:40:00',6.8),('11288','2013-06-16','12:45:00',6.78),('11288','2013-06-16','12:50:00',6.77),('11288','2013-06-16','12:55:00',6.87),('11288','2013-06-16','13:00:00',6.91),('11288','2013-06-16','13:05:00',6.94),('11288','2013-06-16','13:10:00',6.98),('11288','2013-06-16','13:15:00',6.96),('11288','2013-06-16','13:20:00',7.02),('11288','2013-06-16','13:25:00',6.98),('11288','2013-06-16','13:30:00',6.95),('11288','2013-06-16','13:35:00',7.01),('11288','2013-06-16','13:40:00',6.94),('11288','2013-06-16','13:45:00',6.93),('11288','2013-06-16','13:50:00',6.93),('11288','2013-06-16','13:55:00',6.89),('11288','2013-06-16','14:00:00',6.85),('11288','2013-06-16','14:05:00',6.82),('11288','2013-06-16','14:10:00',6.83),('11288','2013-06-16','14:15:00',6.83),('11288','2013-06-16','14:20:00',6.76),('11288','2013-06-16','14:25:00',6.76),('11288','2013-06-16','14:30:00',6.72),('11288','2013-06-16','14:35:00',6.66),('11288','2013-06-16','14:40:00',6.64),('11288','2013-06-16','14:45:00',6.6),('11288','2013-06-16','14:50:00',6.54),('11288','2013-06-16','14:55:00',6.51),('11288','2013-06-16','15:00:00',6.47),('11288','2013-06-16','15:05:00',6.43),('11288','2013-06-16','15:10:00',6.38),('11288','2013-06-16','15:15:00',6.34),('11288','2013-06-16','15:20:00',6.3),('11288','2013-06-16','15:25:00',6.23),('11288','2013-06-16','15:30:00',6.15),('11288','2013-06-16','15:35:00',6.1),('11288','2013-06-16','15:40:00',6.03),('11288','2013-06-16','15:45:00',5.96),('11288','2013-06-16','15:50:00',5.89),('11288','2013-06-16','15:55:00',5.8),('11288','2013-06-16','16:00:00',5.72),('11288','2013-06-16','16:05:00',5.58),('11288','2013-06-16','16:10:00',5.57),('11288','2013-06-16','16:15:00',5.46),('11288','2013-06-16','16:20:00',5.36),('11288','2013-06-16','16:25:00',5.26),('11288','2013-06-16','16:30:00',5.17),('11288','2013-06-16','16:35:00',5),('11288','2013-06-16','16:40:00',4.76),('11288','2013-06-16','16:45:00',4.5),('11288','2013-06-16','16:50:00',4.55),('11288','2013-06-16','16:55:00',4.56),('11288','2013-06-16','17:00:00',4.44),('11288','2013-06-16','17:05:00',4.32),('11288','2013-06-16','17:10:00',4.2),('11288','2013-06-16','17:15:00',4.1),('11288','2013-06-16','17:20:00',3.98),('11288','2013-06-16','17:25:00',3.88),('11288','2013-06-16','17:30:00',3.76),('11288','2013-06-16','17:35:00',3.72),('11288','2013-06-16','17:40:00',3.54),('11288','2013-06-16','17:45:00',3.34),('11288','2013-06-16','17:50:00',3.21),('11288','2013-06-16','17:55:00',3.11),('11288','2013-06-16','18:00:00',3.01),('11288','2013-06-16','18:05:00',2.86),('11288','2013-06-16','18:10:00',2.74),('11288','2013-06-16','18:15:00',2.61),('11288','2013-06-16','18:20:00',2.48),('11288','2013-06-16','18:25:00',2.31),('11288','2013-06-16','18:30:00',2.22),('11288','2013-06-16','18:35:00',2.1),('11288','2013-06-16','18:40:00',1.97),('11288','2013-06-16','18:45:00',1.85),('11288','2013-06-16','18:50:00',1.7),('11288','2013-06-16','18:55:00',1.59),('11288','2013-06-16','19:00:00',1.48),('11288','2013-06-16','19:05:00',1.35),('11288','2013-06-16','19:10:00',1.2),('11288','2013-06-16','19:15:00',1.08),('11288','2013-06-15','07:15:00',1.11),('11288','2013-06-15','07:20:00',1.21),('11288','2013-06-15','07:25:00',1.3),('11288','2013-06-15','07:30:00',1.41),('11288','2013-06-15','07:35:00',1.5),('11288','2013-06-15','07:40:00',1.54),('11288','2013-06-15','07:45:00',1.67),('11288','2013-06-15','07:50:00',1.82),('11288','2013-06-15','07:55:00',1.97),('11288','2013-06-15','08:00:00',2.22),('11288','2013-06-15','08:05:00',2.25),('11288','2013-06-15','08:10:00',2.33),('11288','2013-06-15','08:15:00',2.53),('11288','2013-06-15','08:20:00',2.6),('11288','2013-06-15','08:25:00',2.69),('11288','2013-06-15','08:30:00',2.91),('11288','2013-06-15','08:35:00',2.94),('11288','2013-06-15','08:40:00',3.01),('11288','2013-06-15','08:45:00',3.26),('11288','2013-06-15','08:50:00',3.47),('11288','2013-06-15','08:55:00',3.33),('11288','2013-06-15','09:00:00',3.38),('11288','2013-06-15','09:05:00',3.5),('11288','2013-06-15','09:10:00',3.82),('11288','2013-06-15','09:15:00',4.15),('11288','2013-06-15','09:20:00',4.38),('11288','2013-06-15','09:25:00',4.27),('11288','2013-06-15','09:30:00',4.29),('11288','2013-06-15','09:35:00',4.69),('11288','2013-06-15','09:40:00',4.52),('11288','2013-06-15','09:45:00',4.64),('11288','2013-06-15','09:50:00',4.89),('11288','2013-06-15','09:55:00',4.23),('11288','2013-06-15','10:00:00',4.36),('11288','2013-06-15','10:05:00',5.34),('11288','2013-06-15','10:10:00',5.59),('11288','2013-06-15','10:15:00',5.72),('11288','2013-06-15','10:20:00',4.27),('11288','2013-06-15','10:25:00',5.89),('11288','2013-06-15','10:30:00',5.96),('11288','2013-06-15','10:35:00',5.65),('11288','2013-06-15','10:40:00',5.6),('11288','2013-06-15','10:45:00',5.3),('11288','2013-06-15','10:50:00',4.76),('11288','2013-06-15','10:55:00',3.52),('11288','2013-06-15','11:00:00',6.67),('11288','2013-06-15','11:05:00',5.13),('11288','2013-06-15','11:10:00',4.92),('11288','2013-06-15','11:15:00',2.92),('11288','2013-06-15','11:20:00',3.79),('11288','2013-06-15','11:25:00',6.95),('11288','2013-06-15','11:30:00',6.74),('11288','2013-06-15','11:35:00',6.87),('11288','2013-06-15','11:40:00',6.91),('11288','2013-06-15','11:45:00',6.49),('11288','2013-06-15','11:50:00',6.93),('11288','2013-06-15','11:55:00',6.39),('11288','2013-06-15','12:00:00',3.98),('11288','2013-06-15','12:05:00',6.89),('11288','2013-06-15','12:10:00',7.05),('11288','2013-06-15','12:15:00',7.02),('11288','2013-06-15','12:20:00',7),('11288','2013-06-15','12:25:00',6.93),('11288','2013-06-15','12:30:00',6.96),('11288','2013-06-15','12:35:00',6.98),('11288','2013-06-15','12:40:00',7.03),('11288','2013-06-15','12:45:00',6.96),('11288','2013-06-15','12:50:00',7),('11288','2013-06-15','12:55:00',7.03),('11288','2013-06-15','13:00:00',6.99),('11288','2013-06-15','13:05:00',7.01),('11288','2013-06-15','13:10:00',7),('11288','2013-06-15','13:15:00',6.98),('11288','2013-06-15','13:20:00',6.9),('11288','2013-06-15','13:25:00',6.95),('11288','2013-06-15','13:30:00',6.89),('11288','2013-06-15','13:35:00',6.9),('11288','2013-06-15','13:40:00',6.94),('11288','2013-06-15','13:45:00',6.92),('11288','2013-06-15','13:50:00',6.86),('11288','2013-06-15','13:55:00',6.89),('11288','2013-06-15','14:00:00',6.86),('11288','2013-06-15','14:05:00',6.82),('11288','2013-06-15','14:10:00',6.82),('11288','2013-06-15','14:15:00',6.79),('11288','2013-06-15','14:20:00',6.77),('11288','2013-06-15','14:25:00',6.65),('11288','2013-06-15','14:30:00',6.66),('11288','2013-06-15','14:35:00',6.6),('11288','2013-06-15','14:40:00',6.67),('11288','2013-06-15','14:45:00',6.52),('11288','2013-06-15','14:50:00',6.57),('11288','2013-06-15','14:55:00',6.48),('11288','2013-06-15','15:00:00',6.37),('11288','2013-06-15','15:05:00',6.36),('11288','2013-06-15','15:10:00',6.37),('11288','2013-06-15','15:15:00',6.39),('11288','2013-06-15','15:20:00',6.33),('11288','2013-06-15','15:25:00',6.3),('11288','2013-06-15','15:30:00',6.23),('11288','2013-06-15','15:35:00',6.17),('11288','2013-06-15','15:40:00',6.06),('11288','2013-06-15','15:45:00',5.97),('11288','2013-06-15','15:50:00',5.88),('11288','2013-06-15','15:55:00',5.81),('11288','2013-06-15','16:00:00',5.72),('11288','2013-06-15','16:05:00',5.63),('11288','2013-06-15','16:10:00',5.55),('11288','2013-06-15','16:15:00',5.44),('11288','2013-06-15','16:20:00',5.32),('11288','2013-06-15','16:25:00',5.24),('11288','2013-06-15','16:30:00',5.16),('11288','2013-06-15','16:35:00',5.01),('11288','2013-06-15','16:40:00',4.87),('11288','2013-06-15','16:45:00',4.79),('11288','2013-06-15','16:50:00',4.66),('11288','2013-06-15','16:55:00',4.59),('11288','2013-06-15','17:00:00',4.47),('11288','2013-06-15','17:05:00',4.32),('11288','2013-06-15','17:10:00',4.22),('11288','2013-06-15','17:15:00',4.09),('11288','2013-06-15','17:20:00',3.97),('11288','2013-06-15','17:25:00',3.85),('11288','2013-06-15','17:30:00',3.72),('11288','2013-06-15','17:35:00',3.66),('11288','2013-06-15','17:40:00',3.53),('11288','2013-06-15','17:45:00',3.32),('11288','2013-06-15','17:50:00',3.18),('11288','2013-06-15','17:55:00',3.08),('11288','2013-06-15','18:00:00',2.99),('11288','2013-06-15','18:05:00',2.81),('11288','2013-06-15','18:10:00',2.69),('11288','2013-06-15','18:15:00',2.55),('11288','2013-06-15','18:20:00',2.44),('11288','2013-06-15','18:25:00',2.24),('11288','2013-06-15','18:30:00',2.14),('11288','2013-06-15','18:35:00',2.01),('11288','2013-06-15','18:40:00',1.92),('11288','2013-06-15','18:45:00',1.79),('11288','2013-06-15','18:50:00',1.66),('11288','2013-06-15','18:55:00',1.55),('11288','2013-06-15','19:00:00',1.44),('11288','2013-06-15','19:05:00',1.31),('11288','2013-06-15','19:10:00',1.17),('11288','2013-06-15','19:15:00',1.06),('11288','2013-06-14','07:15:00',1.08),('11288','2013-06-14','07:20:00',1.18),('11288','2013-06-14','07:25:00',1.27),('11288','2013-06-14','07:30:00',1.42),('11288','2013-06-14','07:35:00',1.46),('11288','2013-06-14','07:40:00',1.55),('11288','2013-06-14','07:45:00',1.67),('11288','2013-06-14','07:50:00',1.81),('11288','2013-06-14','07:55:00',1.84),('11288','2013-06-14','08:00:00',2.27),('11288','2013-06-14','08:05:00',2.32),('11288','2013-06-14','08:10:00',2.48),('11288','2013-06-14','08:15:00',2.72),('11288','2013-06-14','08:20:00',2.8),('11288','2013-06-14','08:25:00',2.96),('11288','2013-06-14','08:30:00',3.1),('11288','2013-06-14','08:35:00',3.21),('11288','2013-06-14','08:40:00',3.37),('11288','2013-06-14','08:45:00',3.6),('11288','2013-06-14','08:50:00',3.69),('11288','2013-06-14','08:55:00',3.78),('11288','2013-06-14','09:00:00',3.98),('11288','2013-06-14','09:05:00',4.12),('11288','2013-06-14','09:10:00',4.05),('11288','2013-06-14','09:15:00',4.22),('11288','2013-06-14','09:20:00',4.38),('11288','2013-06-14','09:25:00',4.1),('11288','2013-06-14','09:30:00',4.34),('11288','2013-06-14','09:35:00',4.81),('11288','2013-06-14','09:40:00',4.99),('11288','2013-06-14','09:45:00',5.14),('11288','2013-06-14','09:50:00',5.21),('11288','2013-06-14','09:55:00',5.03),('11288','2013-06-14','10:00:00',5.26),('11288','2013-06-14','10:05:00',5.53),('11288','2013-06-14','10:10:00',5.63),('11288','2013-06-14','10:15:00',5.74),('11288','2013-06-14','10:20:00',5.82),('11288','2013-06-14','10:25:00',5.9),('11288','2013-06-14','10:30:00',5.79),('11288','2013-06-14','10:35:00',6.18),('11288','2013-06-14','10:40:00',6.21),('11288','2013-06-14','10:45:00',6.25),('11288','2013-06-14','10:50:00',6.33),('11288','2013-06-14','10:55:00',6.35),('11288','2013-06-14','11:00:00',6.31),('11288','2013-06-14','11:05:00',6.36),('11288','2013-06-14','11:10:00',6.45),('11288','2013-06-14','11:15:00',6.57),('11288','2013-06-14','11:20:00',6.57),('11288','2013-06-14','11:25:00',6.41),('11288','2013-06-14','11:30:00',6.74),('11288','2013-06-14','11:35:00',6.77),('11288','2013-06-14','11:40:00',6.8),('11288','2013-06-14','11:45:00',6.79),('11288','2013-06-14','11:50:00',6.86),('11288','2013-06-14','11:55:00',6.91),('11288','2013-06-14','12:00:00',6.87),('11288','2013-06-14','12:05:00',6.86),('11288','2013-06-14','12:10:00',6.82),('11288','2013-06-14','12:15:00',6.84),('11288','2013-06-14','12:20:00',6.86),('11288','2013-06-14','12:25:00',6.76),('11288','2013-06-14','12:30:00',6.88),('11288','2013-06-14','12:35:00',7.02),('11288','2013-06-14','12:40:00',6.93),('11288','2013-06-14','12:45:00',7.03),('11288','2013-06-14','12:50:00',6.96),('11288','2013-06-14','12:55:00',6.98),('11288','2013-06-14','13:00:00',7.02),('11288','2013-06-14','13:05:00',7.11),('11288','2013-06-14','13:10:00',7.12),('11288','2013-06-14','13:15:00',7.08),('11288','2013-06-14','13:20:00',7.09),('11288','2013-06-14','13:25:00',7.16),('11288','2013-06-14','13:30:00',7.02),('11288','2013-06-14','13:35:00',7.05),('11288','2013-06-14','13:40:00',6.95),('11288','2013-06-14','13:45:00',6.93),('11288','2013-06-14','13:50:00',7.03),('11288','2013-06-14','13:55:00',6.97),('11288','2013-06-14','14:00:00',6.85),('11288','2013-06-14','14:05:00',6.86),('11288','2013-06-14','14:10:00',6.93),('11288','2013-06-14','14:15:00',6.78),('11288','2013-06-14','14:20:00',6.72),('11288','2013-06-14','14:25:00',6.73),('11288','2013-06-14','14:30:00',6.77),('11288','2013-06-14','14:35:00',6.77),('11288','2013-06-14','14:40:00',6.73),('11288','2013-06-14','14:45:00',6.63),('11288','2013-06-14','14:50:00',6.6),('11288','2013-06-14','14:55:00',6.62),('11288','2013-06-14','15:00:00',6.59),('11288','2013-06-14','15:05:00',6.53),('11288','2013-06-14','15:10:00',6.46),('11288','2013-06-14','15:15:00',6.41),('11288','2013-06-14','15:20:00',6.38),('11288','2013-06-14','15:25:00',6.35),('11288','2013-06-14','15:30:00',6.29),('11288','2013-06-14','15:35:00',6.23),('11288','2013-06-14','15:40:00',6.17),('11288','2013-06-14','15:45:00',6.1),('11288','2013-06-14','15:50:00',6.05),('11288','2013-06-14','15:55:00',5.95),('11288','2013-06-14','16:00:00',5.86),('11288','2013-06-14','16:05:00',5.8),('11288','2013-06-14','16:10:00',5.69),('11288','2013-06-14','16:15:00',5.56),('11288','2013-06-14','16:20:00',5.46),('11288','2013-06-14','16:25:00',5.36),('11288','2013-06-14','16:30:00',5.23),('11288','2013-06-14','16:35:00',5.02),('11288','2013-06-14','16:40:00',4.92),('11288','2013-06-14','16:45:00',4.85),('11288','2013-06-14','16:50:00',4.72),('11288','2013-06-14','16:55:00',4.64),('11288','2013-06-14','17:00:00',4.53),('11288','2013-06-14','17:05:00',4.27),('11288','2013-06-14','17:10:00',4.23),('11288','2013-06-14','17:15:00',4.21),('11288','2013-06-14','17:20:00',4.07),('11288','2013-06-14','17:25:00',3.93),('11288','2013-06-14','17:30:00',3.71),('11288','2013-06-14','17:35:00',3.77),('11288','2013-06-14','17:40:00',3.7),('11288','2013-06-14','17:45:00',3.52),('11288','2013-06-14','17:50:00',3.39),('11288','2013-06-14','17:55:00',3.25),('11288','2013-06-14','18:00:00',3.09),('11288','2013-06-14','18:05:00',3),('11288','2013-06-14','18:10:00',2.86),('11288','2013-06-14','18:15:00',2.73),('11288','2013-06-14','18:20:00',2.59),('11288','2013-06-14','18:25:00',2.4),('11288','2013-06-14','18:30:00',2.32),('11288','2013-06-14','18:35:00',2.18),('11288','2013-06-14','18:40:00',2.07),('11288','2013-06-14','18:45:00',1.94),('11288','2013-06-14','18:50:00',1.79),('11288','2013-06-14','18:55:00',1.66),('11288','2013-06-14','19:00:00',1.56),('11288','2013-06-14','19:05:00',1.41),('11288','2013-06-14','19:10:00',1.24),('11288','2013-06-14','19:15:00',1.13),('11288','2013-06-14','19:20:00',1.03),('11288','2013-06-13','07:15:00',1.1),('11288','2013-06-13','07:20:00',1.2),('11288','2013-06-13','07:25:00',1.25),('11288','2013-06-13','07:30:00',1.43),('11288','2013-06-13','07:35:00',1.55),('11288','2013-06-13','07:40:00',1.54),('11288','2013-06-13','07:45:00',1.69),('11288','2013-06-13','07:50:00',1.91),('11288','2013-06-13','07:55:00',1.86),('11288','2013-06-13','08:00:00',2.32),('11288','2013-06-13','08:05:00',2.36),('11288','2013-06-13','08:10:00',2.42),('11288','2013-06-13','08:15:00',2.61),('11288','2013-06-13','08:20:00',2.81),('11288','2013-06-13','08:25:00',2.85),('11288','2013-06-13','08:30:00',3.06),('11288','2013-06-13','08:35:00',3.25),('11288','2013-06-13','08:40:00',3.25),('11288','2013-06-13','08:45:00',3.54),('11288','2013-06-13','08:50:00',3.82),('11288','2013-06-13','08:55:00',3.77),('11288','2013-06-13','09:00:00',3.92),('11288','2013-06-13','09:05:00',4.17),('11288','2013-06-13','09:10:00',4.09),('11288','2013-06-13','09:15:00',4.23),('11288','2013-06-13','09:20:00',4.52),('11288','2013-06-13','09:25:00',4.52),('11288','2013-06-13','09:30:00',4.57),('11288','2013-06-13','09:35:00',4.95),('11288','2013-06-13','09:40:00',5.14),('11288','2013-06-13','09:45:00',5.27),('11288','2013-06-13','09:50:00',5.38),('11288','2013-06-13','09:55:00',5.29),('11288','2013-06-13','10:00:00',5.41),('11288','2013-06-13','10:05:00',5.74),('11288','2013-06-13','10:10:00',5.84),('11288','2013-06-13','10:15:00',5.94),('11288','2013-06-13','10:20:00',6.1),('11288','2013-06-13','10:25:00',6.14),('11288','2013-06-13','10:30:00',6.19),('11288','2013-06-13','10:35:00',6.31),('11288','2013-06-13','10:40:00',6.32),('11288','2013-06-13','10:45:00',6.42),('11288','2013-06-13','10:50:00',6.58),('11288','2013-06-13','10:55:00',6.63),('11288','2013-06-13','11:00:00',6.67),('11288','2013-06-13','11:05:00',6.67),('11288','2013-06-13','11:10:00',6.76),('11288','2013-06-13','11:15:00',6.83),('11288','2013-06-13','11:20:00',6.84),('11288','2013-06-13','11:25:00',6.92),('11288','2013-06-13','11:30:00',6.98),('11288','2013-06-13','11:35:00',7.04),('11288','2013-06-13','11:40:00',7.1),('11288','2013-06-13','11:45:00',7.14),('11288','2013-06-13','11:50:00',7.22),('11288','2013-06-13','11:55:00',7.17),('11288','2013-06-13','12:00:00',7.13),('11288','2013-06-13','12:05:00',7.21),('11288','2013-06-13','12:10:00',7.32),('11288','2013-06-13','12:15:00',7.27),('11288','2013-06-13','12:20:00',7.24),('11288','2013-06-13','12:25:00',7.27),('11288','2013-06-13','12:30:00',7.31),('11288','2013-06-13','12:35:00',7.32),('11288','2013-06-13','12:40:00',7.33),('11288','2013-06-13','12:45:00',7.36),('11288','2013-06-13','12:50:00',7.36),('11288','2013-06-13','12:55:00',7.32),('11288','2013-06-13','13:00:00',7.34),('11288','2013-06-13','13:05:00',7.38),('11288','2013-06-13','13:10:00',7.33),('11288','2013-06-13','13:15:00',7.34),('11288','2013-06-13','13:20:00',7.29),('11288','2013-06-13','13:25:00',7.3),('11288','2013-06-13','13:30:00',7.24),('11288','2013-06-13','13:35:00',7.28),('11288','2013-06-13','13:40:00',7.27),('11288','2013-06-13','13:45:00',7.22),('11288','2013-06-13','13:50:00',7.23),('11288','2013-06-13','13:55:00',7.14),('11288','2013-06-13','14:00:00',7.16),('11288','2013-06-13','14:05:00',7.16),('11288','2013-06-13','14:10:00',7.17),('11288','2013-06-13','14:15:00',7.16),('11288','2013-06-13','14:20:00',7.15),('11288','2013-06-13','14:25:00',7.07),('11288','2013-06-13','14:30:00',5.74),('11288','2013-06-13','14:35:00',5.27),('11288','2013-06-13','14:40:00',7.15),('11288','2013-06-13','14:45:00',7.05),('11288','2013-06-13','14:50:00',6.86),('11288','2013-06-13','14:55:00',6.73),('11288','2013-06-13','15:00:00',6.75),('11288','2013-06-13','15:05:00',6.69),('11288','2013-06-13','15:10:00',6.56),('11288','2013-06-13','15:15:00',6.57),('11288','2013-06-13','15:20:00',6.44),('11288','2013-06-13','15:25:00',6.4),('11288','2013-06-13','15:30:00',6.34),('11288','2013-06-13','15:35:00',6.25),('11288','2013-06-13','15:40:00',6.17),('11288','2013-06-13','15:45:00',6.11),('11288','2013-06-13','15:50:00',6),('11288','2013-06-13','15:55:00',5.93),('11288','2013-06-13','16:00:00',5.86),('11288','2013-06-13','16:05:00',5.77),('11288','2013-06-13','16:10:00',5.68),('11288','2013-06-13','16:15:00',5.57),('11288','2013-06-13','16:20:00',5.45),('11288','2013-06-13','16:25:00',5.34),('11288','2013-06-13','16:30:00',5.24),('11288','2013-06-13','16:35:00',5.09),('11288','2013-06-13','16:40:00',4.92),('11288','2013-06-13','16:45:00',4.82),('11288','2013-06-13','16:50:00',4.67),('11288','2013-06-13','16:55:00',4.59),('11288','2013-06-13','17:00:00',4.49),('11288','2013-06-13','17:05:00',4.4),('11288','2013-06-13','17:10:00',4.3),('11288','2013-06-13','17:15:00',4.16),('11288','2013-06-13','17:20:00',4.09),('11288','2013-06-13','17:25:00',3.98),('11288','2013-06-13','17:30:00',3.84),('11288','2013-06-13','17:35:00',3.81),('11288','2013-06-13','17:40:00',3.63),('11288','2013-06-13','17:45:00',3.48),('11288','2013-06-13','17:50:00',3.35),('11288','2013-06-13','17:55:00',3.22),('11288','2013-06-13','18:00:00',3.07),('11288','2013-06-13','18:05:00',2.93),('11288','2013-06-13','18:10:00',2.78),('11288','2013-06-13','18:15:00',2.67),('11288','2013-06-13','18:20:00',2.58),('11288','2013-06-13','18:25:00',2.39),('11288','2013-06-13','18:30:00',2.29),('11288','2013-06-13','18:35:00',2.15),('11288','2013-06-13','18:40:00',2),('11288','2013-06-13','18:45:00',1.89),('11288','2013-06-13','18:50:00',1.75),('11288','2013-06-13','18:55:00',1.62),('11288','2013-06-13','19:00:00',1.51),('11288','2013-06-13','19:05:00',1.37),('11288','2013-06-13','19:10:00',1.22),('11288','2013-06-13','19:15:00',1.11),('11288','2013-06-12','07:10:00',1.01),('11288','2013-06-12','07:15:00',1.13),('11288','2013-06-12','07:20:00',1.27),('11288','2013-06-12','07:25:00',1.29),('11288','2013-06-12','07:30:00',1.45),('11288','2013-06-12','07:35:00',1.56),('11288','2013-06-12','07:40:00',1.57),('11288','2013-06-12','07:45:00',1.67),('11288','2013-06-12','07:50:00',1.95),('11288','2013-06-12','07:55:00',1.93),('11288','2013-06-12','08:00:00',2.28),('11288','2013-06-12','08:05:00',2.37),('11288','2013-06-12','08:10:00',2.48),('11288','2013-06-12','08:15:00',2.61),('11288','2013-06-12','08:20:00',2.96),('11288','2013-06-12','08:25:00',2.99),('11288','2013-06-12','08:30:00',3.23),('11288','2013-06-12','08:35:00',3.37),('11288','2013-06-12','08:40:00',3.36),('11288','2013-06-12','08:45:00',3.63),('11288','2013-06-12','08:50:00',3.95),('11288','2013-06-12','08:55:00',3.9),('11288','2013-06-12','09:00:00',4.05),('11288','2013-06-12','09:05:00',4.24),('11288','2013-06-12','09:10:00',4.22),('11288','2013-06-12','09:15:00',4.33),('11288','2013-06-12','09:20:00',4.63),('11288','2013-06-12','09:25:00',4.63),('11288','2013-06-12','09:30:00',4.7),('11288','2013-06-12','09:35:00',4.97),('11288','2013-06-12','09:40:00',5.16),('11288','2013-06-12','09:45:00',5.31),('11288','2013-06-12','09:50:00',5.47),('11288','2013-06-12','09:55:00',5.54),('11288','2013-06-12','10:00:00',5.67),('11288','2013-06-12','10:05:00',5.75),('11288','2013-06-12','10:10:00',5.83),('11288','2013-06-12','10:15:00',5.95),('11288','2013-06-12','10:20:00',6.11),('11288','2013-06-12','10:25:00',6.21),('11288','2013-06-12','10:30:00',6.25),('11288','2013-06-12','10:35:00',6.34),('11288','2013-06-12','10:40:00',6.37),('11288','2013-06-12','10:45:00',6.44),('11288','2013-06-12','10:50:00',6.63),('11288','2013-06-12','10:55:00',6.71),('11288','2013-06-12','11:00:00',6.81),('11288','2013-06-12','11:05:00',6.88),('11288','2013-06-12','11:10:00',6.94),('11288','2013-06-12','11:15:00',7),('11288','2013-06-12','11:20:00',7.02),('11288','2013-06-12','11:25:00',7.01),('11288','2013-06-12','11:30:00',7.04),('11288','2013-06-12','11:35:00',7.02),('11288','2013-06-12','11:40:00',7.09),('11288','2013-06-12','11:45:00',7.14),('11288','2013-06-12','11:50:00',7.11),('11288','2013-06-12','11:55:00',7.2),('11288','2013-06-12','12:00:00',7.18),('11288','2013-06-12','12:05:00',7.19),('11288','2013-06-12','12:10:00',7.23),('11288','2013-06-12','12:15:00',7.27),('11288','2013-06-12','12:20:00',7.55),('11288','2013-06-12','12:25:00',5.94),('11288','2013-06-12','12:30:00',2.94),('11288','2013-06-12','12:35:00',7.9),('11288','2013-06-12','12:40:00',7.64),('11288','2013-06-12','12:45:00',2.63),('11288','2013-06-12','12:50:00',2.64),('11288','2013-06-12','12:55:00',3.79),('11288','2013-06-12','13:00:00',6.87),('11288','2013-06-12','13:05:00',2.58),('11288','2013-06-12','13:10:00',7.57),('11288','2013-06-12','13:15:00',7.61),('11288','2013-06-12','13:20:00',7.48),('11288','2013-06-12','13:25:00',7.34),('11288','2013-06-12','13:30:00',7.27),('11288','2013-06-12','13:35:00',7.3),('11288','2013-06-12','13:40:00',7.44),('11288','2013-06-12','13:45:00',6.86),('11288','2013-06-12','13:50:00',7.38),('11288','2013-06-12','13:55:00',7.56),('11288','2013-06-12','14:00:00',5.52),('11288','2013-06-12','14:05:00',5.09),('11288','2013-06-12','14:10:00',1.97),('11288','2013-06-12','14:15:00',7.05),('11288','2013-06-12','14:20:00',4.7),('11288','2013-06-12','14:25:00',5.19),('11288','2013-06-12','14:30:00',6.57),('11288','2013-06-12','14:35:00',6.14),('11288','2013-06-12','14:40:00',6.72),('11288','2013-06-12','14:45:00',7.29),('11288','2013-06-12','14:50:00',7.27),('11288','2013-06-12','14:55:00',7.18),('11288','2013-06-12','15:00:00',7.05),('11288','2013-06-12','15:05:00',6.98),('11288','2013-06-12','15:10:00',6.88),('11288','2013-06-12','15:15:00',6.03),('11288','2013-06-12','15:20:00',6.84),('11288','2013-06-12','15:25:00',6.52),('11288','2013-06-12','15:30:00',6.52),('11288','2013-06-12','15:35:00',6.5),('11288','2013-06-12','15:40:00',6.47),('11288','2013-06-12','15:45:00',6.38),('11288','2013-06-12','15:50:00',6.23),('11288','2013-06-12','15:55:00',6.26),('11288','2013-06-12','16:00:00',6.28),('11288','2013-06-12','16:05:00',5.98),('11288','2013-06-12','16:10:00',5.91),('11288','2013-06-12','16:15:00',5.78),('11288','2013-06-12','16:20:00',5.58),('11288','2013-06-12','16:25:00',5.6),('11288','2013-06-12','16:30:00',5.08),('11288','2013-06-12','16:35:00',5.04),('11288','2013-06-12','16:40:00',5.26),('11288','2013-06-12','16:45:00',4.13),('11288','2013-06-12','16:50:00',5.03),('11288','2013-06-12','16:55:00',4.19),('11288','2013-06-12','17:00:00',4.64),('11288','2013-06-12','17:05:00',4.55),('11288','2013-06-12','17:10:00',4.48),('11288','2013-06-12','17:15:00',4.34),('11288','2013-06-12','17:20:00',4.22),('11288','2013-06-12','17:25:00',4.06),('11288','2013-06-12','17:30:00',3.91),('11288','2013-06-12','17:35:00',3.96),('11288','2013-06-12','17:40:00',3.86),('11288','2013-06-12','17:45:00',1.71),('11288','2013-06-12','18:05:00',2.19),('11288','2013-06-12','18:10:00',2.97),('11288','2013-06-12','18:15:00',2.89),('11288','2013-06-12','18:20:00',2.77),('11288','2013-06-12','18:25:00',2.42),('11288','2013-06-12','18:30:00',2.36),('11288','2013-06-12','18:35:00',2.18),('11288','2013-06-12','18:40:00',2.03),('11288','2013-06-12','18:45:00',1.91),('11288','2013-06-12','18:50:00',1.78),('11288','2013-06-12','18:55:00',1.66),('11288','2013-06-12','19:00:00',1.55),('11288','2013-06-12','19:05:00',1.4),('11288','2013-06-11','07:10:00',1.01),('11288','2013-06-11','07:15:00',1.05),('11288','2013-06-11','07:20:00',1.2),('11288','2013-06-11','07:25:00',1.36),('11288','2013-06-11','07:30:00',1.46),('11288','2013-06-11','07:35:00',1.54),('11288','2013-06-11','07:40:00',1.51),('11288','2013-06-11','07:45:00',1.27),('11288','2013-06-11','07:50:00',2.02),('11288','2013-06-11','07:55:00',2.19),('11288','2013-06-11','08:00:00',2.47),('11288','2013-06-11','08:05:00',2.82),('11288','2013-06-11','08:10:00',2.81),('11288','2013-06-11','08:15:00',1.9),('11288','2013-06-11','08:20:00',2.61),('11288','2013-06-11','08:25:00',3.45),('11288','2013-06-11','08:30:00',3.53),('11288','2013-06-11','08:35:00',3.56),('11288','2013-06-11','08:40:00',3.61),('11288','2013-06-11','08:45:00',2.51),('11288','2013-06-11','08:50:00',1.26),('11288','2013-06-11','08:55:00',3.62),('11288','2013-06-11','09:00:00',2.58),('11288','2013-06-11','09:05:00',4.07),('11288','2013-06-11','09:10:00',4.7),('11288','2013-06-11','09:15:00',4.78),('11288','2013-06-11','09:20:00',4.93),('11288','2013-06-11','09:25:00',3.08),('11288','2013-06-11','09:30:00',4.36),('11288','2013-06-11','09:35:00',2.27),('11288','2013-06-11','09:40:00',4.32),('11288','2013-06-11','09:45:00',5.62),('11288','2013-06-11','09:50:00',5.64),('11288','2013-06-11','09:55:00',5.8),('11288','2013-06-11','10:00:00',4.53),('11288','2013-06-11','10:05:00',4.63),('11288','2013-06-11','10:10:00',6.11),('11288','2013-06-11','10:15:00',6.32),('11288','2013-06-11','10:20:00',6.5),('11288','2013-06-11','10:25:00',4.65),('11288','2013-06-11','10:30:00',6.54),('11288','2013-06-11','10:35:00',6.57),('11288','2013-06-11','10:40:00',6.58),('11288','2013-06-11','10:45:00',6.69),('11288','2013-06-11','10:50:00',4.03),('11288','2013-06-11','10:55:00',2.59),('11288','2013-06-11','11:00:00',7.37),('11288','2013-06-11','11:05:00',5.35),('11288','2013-06-11','11:10:00',5.21),('11288','2013-06-11','11:15:00',7.32),('11288','2013-06-11','11:20:00',7.12),('11288','2013-06-11','11:25:00',7.16),('11288','2013-06-11','11:30:00',7.18),('11288','2013-06-11','11:35:00',7.17),('11288','2013-06-11','11:40:00',7.22),('11288','2013-06-11','11:45:00',7.25),('11288','2013-06-11','11:50:00',7.33),('11288','2013-06-11','11:55:00',7.36),('11288','2013-06-11','12:00:00',7.38),('11288','2013-06-11','12:05:00',7.45),('11288','2013-06-11','12:10:00',7.39),('11288','2013-06-11','12:15:00',7.4),('11288','2013-06-11','12:20:00',7.49),('11288','2013-06-11','12:25:00',7.44),('11288','2013-06-11','12:30:00',7.45),('11288','2013-06-11','12:35:00',7.48),('11288','2013-06-11','12:40:00',7.53),('11288','2013-06-11','12:45:00',7.57),('11288','2013-06-11','12:50:00',7.7),('11288','2013-06-11','12:55:00',7.55),('11288','2013-06-11','13:00:00',7.58),('11288','2013-06-11','13:05:00',7.66),('11288','2013-06-11','13:10:00',7.59),('11288','2013-06-11','13:15:00',7.64),('11288','2013-06-11','13:20:00',7.6),('11288','2013-06-11','13:25:00',7.58),('11288','2013-06-11','13:30:00',7.61),('11288','2013-06-11','13:35:00',7.4),('11288','2013-06-11','13:40:00',7.69),('11288','2013-06-11','13:45:00',6.58),('11288','2013-06-11','13:50:00',7.84),('11288','2013-06-11','13:55:00',7.53),('11288','2013-06-11','14:00:00',7.5),('11288','2013-06-11','14:05:00',7.44),('11288','2013-06-11','14:10:00',7.43),('11288','2013-06-11','14:15:00',7.36),('11288','2013-06-11','14:20:00',7.31),('11288','2013-06-11','14:25:00',7.3),('11288','2013-06-11','14:30:00',7.27),('11288','2013-06-11','14:35:00',7.17),('11288','2013-06-11','14:40:00',7.12),('11288','2013-06-11','14:45:00',7.08),('11288','2013-06-11','14:50:00',7.04),('11288','2013-06-11','14:55:00',7.02),('11288','2013-06-11','15:00:00',6.99),('11288','2013-06-11','15:05:00',6.94),('11288','2013-06-11','15:10:00',6.89),('11288','2013-06-11','15:15:00',6.8),('11288','2013-06-11','15:20:00',6.76),('11288','2013-06-11','15:25:00',6.66),('11288','2013-06-11','15:30:00',6.65),('11288','2013-06-11','15:35:00',6.59),('11288','2013-06-11','15:40:00',6.65),('11288','2013-06-11','15:45:00',6.58),('11288','2013-06-11','15:50:00',6.31),('11288','2013-06-11','15:55:00',6.32),('11288','2013-06-11','16:00:00',6.24),('11288','2013-06-11','16:05:00',6.17),('11288','2013-06-11','16:10:00',6),('11288','2013-06-11','16:15:00',5.87),('11288','2013-06-11','16:20:00',5.81),('11288','2013-06-11','16:25:00',5.73),('11288','2013-06-11','16:30:00',5.65),('11288','2013-06-11','16:35:00',5.48),('11288','2013-06-11','16:40:00',5.47),('11288','2013-06-11','16:45:00',5.73),('11288','2013-06-11','16:50:00',5.73),('11288','2013-06-11','16:55:00',5.52),('11288','2013-06-11','17:00:00',4.19),('11288','2013-06-11','17:05:00',3.01),('11288','2013-06-11','17:10:00',1.55),('11288','2013-06-11','17:15:00',1.28),('11288','2013-06-11','17:20:00',1.09),('11288','2013-06-11','19:15:00',1.04),('11288','2013-06-11','19:30:00',1.31),('11288','2013-06-11','19:35:00',1.05),('11288','2014-04-03','08:15:00',1.01),('11288','2014-04-03','08:20:00',1.1),('11288','2014-04-03','08:25:00',1.15),('11288','2014-04-03','08:30:00',1.24),('11288','2014-04-03','08:35:00',1.32),('11288','2014-04-03','08:40:00',1.46),('11288','2014-04-03','08:45:00',1.67),('11288','2014-04-03','08:50:00',1.7),('11288','2014-04-03','08:55:00',1.91),('11288','2014-04-03','09:00:00',2.09),('11288','2014-04-03','09:05:00',2.27),('11288','2014-04-03','09:10:00',2.2),('11288','2014-04-03','09:15:00',2.06),('11288','2014-04-03','09:20:00',2.08),('11288','2014-04-03','09:25:00',2.23),('11288','2014-04-03','09:30:00',2.61),('11288','2014-04-03','09:35:00',2.99),('11288','2014-04-03','09:40:00',3.09),('11288','2014-04-03','09:45:00',3.04),('11288','2014-04-03','09:50:00',2.91),('11288','2014-04-03','09:55:00',3.03),('11288','2014-04-03','10:00:00',3.6),('11288','2014-04-03','10:05:00',4.22),('11288','2014-04-03','10:10:00',4.48),('11288','2014-04-03','10:15:00',5.09),('11288','2014-04-03','10:20:00',5.14),('11288','2014-04-03','10:25:00',4.46),('11288','2014-04-03','10:30:00',4.41),('11288','2014-04-03','10:35:00',4.67),('11288','2014-04-03','10:40:00',3.74),('11288','2014-04-03','10:45:00',3.98),('11288','2014-04-03','10:50:00',3.5),('11288','2014-04-03','10:55:00',3.66),('11288','2014-04-03','11:00:00',3.41),('11288','2014-04-03','11:05:00',2.96),('11288','2014-04-03','11:10:00',2.82),('11288','2014-04-03','11:15:00',2.66),('11288','2014-04-03','11:20:00',2.54),('11288','2014-04-03','11:25:00',2.37),('11288','2014-04-03','11:30:00',2.36),('11288','2014-04-03','11:35:00',2.52),('11288','2014-04-03','11:40:00',2.75),('11288','2014-04-03','11:45:00',3.15),('11288','2014-04-03','11:50:00',3.83),('11288','2014-04-03','11:55:00',4.13),('11288','2014-04-03','12:00:00',3.95),('11288','2014-04-03','12:05:00',3.95),('11288','2014-04-03','12:10:00',3.83),('11288','2014-04-03','12:15:00',3.74),('11288','2014-04-03','12:20:00',4.23),('11288','2014-04-03','12:25:00',5.12),('11288','2014-04-03','12:30:00',6.36),('11288','2014-04-03','12:35:00',6.23),('11288','2014-04-03','12:40:00',6.8),('11288','2014-04-03','12:45:00',3.78),('11288','2014-04-03','12:50:00',4.74),('11288','2014-04-03','12:55:00',4.47),('11288','2014-04-03','13:00:00',4.43),('11288','2014-04-03','13:05:00',5.46),('11288','2014-04-03','13:10:00',4.62),('11288','2014-04-03','13:15:00',7.46),('11288','2014-04-03','13:20:00',4.27),('11288','2014-04-03','13:25:00',4.73),('11288','2014-04-03','13:30:00',4.89),('11288','2014-04-03','13:35:00',7.47),('11288','2014-04-03','13:40:00',6.23),('11288','2014-04-03','13:45:00',3.54),('11288','2014-04-03','13:50:00',3.6),('11288','2014-04-03','13:55:00',4.64),('11288','2014-04-03','14:00:00',6.14),('11288','2014-04-03','14:05:00',5.57),('11288','2014-04-03','14:10:00',4.44),('11288','2014-04-03','14:15:00',6.09),('11288','2014-04-03','14:20:00',6.03),('11288','2014-04-03','14:25:00',6.25),('11288','2014-04-03','14:30:00',6.34),('11288','2014-04-03','14:35:00',6.35),('11288','2014-04-03','14:40:00',6.13),('11288','2014-04-03','14:45:00',5.96),('11288','2014-04-03','14:50:00',5.87),('11288','2014-04-03','14:55:00',5.76),('11288','2014-04-03','15:00:00',5.66),('11288','2014-04-03','15:05:00',5.6),('11288','2014-04-03','15:10:00',5.58),('11288','2014-04-03','15:15:00',5.56),('11288','2014-04-03','15:20:00',5.52),('11288','2014-04-03','15:25:00',5.49),('11288','2014-04-03','15:30:00',5.39),('11288','2014-04-03','15:35:00',5.31),('11288','2014-04-03','15:40:00',5.28),('11288','2014-04-03','15:45:00',5.24),('11288','2014-04-03','15:50:00',5.1),('11288','2014-04-03','15:55:00',5.06),('11288','2014-04-03','16:00:00',5.02),('11288','2014-04-03','16:05:00',4.89),('11288','2014-04-03','16:10:00',4.8),('11288','2014-04-03','16:15:00',4.63),('11288','2014-04-03','16:20:00',4.54),('11288','2014-04-03','16:25:00',4.4),('11288','2014-04-03','16:30:00',4.21),('11288','2014-04-03','16:35:00',4.1),('11288','2014-04-03','16:40:00',4.02),('11288','2014-04-03','16:45:00',3.75),('11288','2014-04-03','16:50:00',2.79),('11288','2014-04-03','16:55:00',2.27),('11288','2014-04-03','17:00:00',1.81),('11288','2014-04-03','17:05:00',1.64),('11288','2014-04-03','17:10:00',1.5),('11288','2014-04-03','17:15:00',1.44),('11288','2014-04-03','17:20:00',1.59),('11288','2014-04-03','17:25:00',1.63),('11288','2014-04-03','17:30:00',1.51),('11288','2014-04-03','17:45:00',1.91),('11288','2014-04-03','17:50:00',2.05),('11288','2014-04-03','17:55:00',1.82),('11288','2014-04-03','18:00:00',1.64),('11288','2014-04-03','18:05:00',1.47),('11288','2014-04-03','18:10:00',1.33),('11288','2014-04-03','18:15:00',1.17),('11288','2013-06-10','07:20:00',1.03),('11288','2013-06-10','07:25:00',1.4),('11288','2013-06-10','07:30:00',1.72),('11288','2013-06-10','07:35:00',2.55),('11288','2013-06-10','07:40:00',1.65),('11288','2013-06-10','07:45:00',1.33),('11288','2013-06-10','07:50:00',1.35),('11288','2013-06-10','07:55:00',1.58),('11288','2013-06-10','08:00:00',2.03),('11288','2013-06-10','08:05:00',2.67),('11288','2013-06-10','08:10:00',3.44),('11288','2013-06-10','08:15:00',2.83),('11288','2013-06-10','08:20:00',2.51),('11288','2013-06-10','08:25:00',2.63),('11288','2013-06-10','08:30:00',2),('11288','2013-06-10','08:35:00',1.99),('11288','2013-06-10','08:40:00',2.59),('11288','2013-06-10','08:45:00',1.28),('11288','2013-06-10','08:50:00',1.42),('11288','2013-06-10','08:55:00',1.97),('11288','2013-06-10','09:00:00',2.06),('11288','2013-06-10','09:05:00',2.11),('11288','2013-06-10','09:10:00',2.31),('11288','2013-06-10','09:15:00',2.45),('11288','2013-06-10','09:20:00',4.44),('11288','2013-06-10','09:25:00',5.12),('11288','2013-06-10','09:30:00',4.1),('11288','2013-06-10','09:35:00',5.46),('11288','2013-06-10','09:40:00',4.42),('11288','2013-06-10','09:45:00',5.95),('11288','2013-06-10','09:50:00',3.1),('11288','2013-06-10','09:55:00',2.96),('11288','2013-06-10','10:00:00',3.85),('11288','2013-06-10','10:05:00',4.06),('11288','2013-06-10','10:10:00',3.39),('11288','2013-06-10','10:15:00',4.44),('11288','2013-06-10','10:20:00',3.91),('11288','2013-06-10','10:25:00',2.99),('11288','2013-06-10','10:30:00',2.55),('11288','2013-06-10','10:35:00',3.88),('11288','2013-06-10','10:40:00',2.61),('11288','2013-06-10','10:45:00',2.23),('11288','2013-06-10','10:50:00',3.49),('11288','2013-06-10','10:55:00',6.77),('11288','2013-06-10','11:00:00',3.7),('11288','2013-06-10','11:05:00',3.55),('11288','2013-06-10','11:10:00',5.42),('11288','2013-06-10','11:15:00',6.76),('11288','2013-06-10','11:20:00',6.8),('11288','2013-06-10','11:25:00',5.9),('11288','2013-06-10','11:30:00',7.53),('11288','2013-06-10','11:35:00',6.49),('11288','2013-06-10','11:40:00',5.28),('11288','2013-06-10','11:45:00',5.79),('11288','2013-06-10','11:50:00',3.53),('11288','2013-06-10','11:55:00',7.87),('11288','2013-06-10','12:00:00',5.94),('11288','2013-06-10','12:05:00',3),('11288','2013-06-10','12:10:00',8.52),('11288','2013-06-10','12:15:00',7.44),('11288','2013-06-10','12:20:00',7.78),('11288','2013-06-10','12:25:00',7.98),('11288','2013-06-10','12:30:00',6.68),('11288','2013-06-10','12:35:00',6.81),('11288','2013-06-10','12:40:00',5.57),('11288','2013-06-10','12:45:00',5.19),('11288','2013-06-10','12:50:00',5.82),('11288','2013-06-10','12:55:00',6.09),('11288','2013-06-10','13:00:00',8.46),('11288','2013-06-10','13:05:00',5.93),('11288','2013-06-10','13:10:00',4.8),('11288','2013-06-10','13:15:00',7.77),('11288','2013-06-10','13:20:00',7.91),('11288','2013-06-10','13:25:00',6.43),('11288','2013-06-10','13:30:00',6.64),('11288','2013-06-10','13:35:00',5.5),('11288','2013-06-10','13:40:00',6.27),('11288','2013-06-10','13:45:00',6.03),('11288','2013-06-10','13:50:00',5.89),('11288','2013-06-10','13:55:00',6.2),('11288','2013-06-10','14:00:00',6.52),('11288','2013-06-10','14:05:00',7.91),('11288','2013-06-10','14:10:00',7.91),('11288','2013-06-10','14:15:00',7.51),('11288','2013-06-10','14:20:00',7.45),('11288','2013-06-10','14:25:00',7.38),('11288','2013-06-10','14:30:00',7.07),('11288','2013-06-10','14:35:00',7.33),('11288','2013-06-10','14:40:00',6.32),('11288','2013-06-10','14:45:00',7.23),('11288','2013-06-10','14:50:00',7.14),('11288','2013-06-10','14:55:00',7.03),('11288','2013-06-10','15:00:00',6.99),('11288','2013-06-10','15:05:00',6.93),('11288','2013-06-10','15:10:00',6.85),('11288','2013-06-10','15:15:00',6.84),('11288','2013-06-10','15:20:00',6.8),('11288','2013-06-10','15:25:00',6.77),('11288','2013-06-10','15:30:00',6.7),('11288','2013-06-10','15:35:00',6.65),('11288','2013-06-10','15:40:00',6.56),('11288','2013-06-10','15:45:00',6.48),('11288','2013-06-10','15:50:00',6.38),('11288','2013-06-10','15:55:00',6.29),('11288','2013-06-10','16:00:00',6.16),('11288','2013-06-10','16:05:00',6.1),('11288','2013-06-10','16:10:00',6.05),('11288','2013-06-10','16:15:00',5.9),('11288','2013-06-10','16:20:00',5.75),('11288','2013-06-10','16:25:00',5.71),('11288','2013-06-10','16:30:00',5.62),('11288','2013-06-10','16:35:00',5.46),('11288','2013-06-10','16:40:00',5.31),('11288','2013-06-10','16:45:00',5.23),('11288','2013-06-10','16:50:00',5.1),('11288','2013-06-10','16:55:00',5.01),('11288','2013-06-10','17:00:00',4.88),('11288','2013-06-10','17:05:00',4.76),('11288','2013-06-10','17:10:00',4.65),('11288','2013-06-10','17:15:00',4.52),('11288','2013-06-10','17:20:00',4.4),('11288','2013-06-10','17:25:00',4.23),('11288','2013-06-10','17:30:00',4.1),('11288','2013-06-10','17:35:00',4.04),('11288','2013-06-10','17:40:00',3.89),('11288','2013-06-10','17:45:00',3.73),('11288','2013-06-10','17:50:00',3.61),('11288','2013-06-10','17:55:00',3.48),('11288','2013-06-10','18:00:00',3.34),('11288','2013-06-10','18:05:00',3.19),('11288','2013-06-10','18:10:00',3.02),('11288','2013-06-10','18:15:00',2.89),('11288','2013-06-10','18:20:00',2.76),('11288','2013-06-10','18:25:00',2.56),('11288','2013-06-10','18:30:00',2.45),('11288','2013-06-10','18:35:00',2.3),('11288','2013-06-10','18:40:00',2.17),('11288','2013-06-10','18:45:00',2.03),('11288','2013-06-10','18:50:00',1.88),('11288','2013-06-10','18:55:00',1.72),('11288','2013-06-10','19:00:00',1.6),('11288','2013-06-10','19:05:00',1.44),('11288','2013-06-10','19:10:00',1.28),('11288','2013-06-10','19:15:00',1.16),('11288','2013-06-10','19:20:00',1.05),('11288','2013-06-09','07:10:00',1.14),('11288','2013-06-09','07:25:00',1.29),('11288','2013-06-09','07:30:00',1.34),('11288','2013-06-09','07:35:00',2.22),('11288','2013-06-09','07:40:00',1.8),('11288','2013-06-09','07:45:00',1.09),('11288','2013-06-09','07:50:00',1.86),('11288','2013-06-09','07:55:00',2.14),('11288','2013-06-09','08:00:00',2.15),('11288','2013-06-09','08:05:00',2.47),('11288','2013-06-09','08:10:00',2.14),('11288','2013-06-09','08:15:00',1.97),('11288','2013-06-09','08:20:00',3),('11288','2013-06-09','08:25:00',2.89),('11288','2013-06-09','08:30:00',3.09),('11288','2013-06-09','08:35:00',3.37),('11288','2013-06-09','08:40:00',3.47),('11288','2013-06-09','08:45:00',3.55),('11288','2013-06-09','08:50:00',3.81),('11288','2013-06-09','08:55:00',3.81),('11288','2013-06-09','09:00:00',3.89),('11288','2013-06-09','09:05:00',4.08),('11288','2013-06-09','09:10:00',4.07),('11288','2013-06-09','09:15:00',4.23),('11288','2013-06-09','09:20:00',4.48),('11288','2013-06-09','09:25:00',4.42),('11288','2013-06-09','09:30:00',4.61),('11288','2013-06-09','09:35:00',4.7),('11288','2013-06-09','09:40:00',4.76),('11288','2013-06-09','09:45:00',4.99),('11288','2013-06-09','09:50:00',5.18),('11288','2013-06-09','09:55:00',5.16),('11288','2013-06-09','10:00:00',5.21),('11288','2013-06-09','10:05:00',5.49),('11288','2013-06-09','10:10:00',5.6),('11288','2013-06-09','10:15:00',5.66),('11288','2013-06-09','10:20:00',5.75),('11288','2013-06-09','10:25:00',5.92),('11288','2013-06-09','10:30:00',5.96),('11288','2013-06-09','10:35:00',6.08),('11288','2013-06-09','10:40:00',6.14),('11288','2013-06-09','10:45:00',6.22),('11288','2013-06-09','10:50:00',6.27),('11288','2013-06-09','10:55:00',6.21),('11288','2013-06-09','11:00:00',6.28),('11288','2013-06-09','11:05:00',6.35),('11288','2013-06-09','11:10:00',6.53),('11288','2013-06-09','11:15:00',6.51),('11288','2013-06-09','11:20:00',6.45),('11288','2013-06-09','11:25:00',6.48),('11288','2013-06-09','11:30:00',6.57),('11288','2013-06-09','11:35:00',6.64),('11288','2013-06-09','11:40:00',6.69),('11288','2013-06-09','11:45:00',6.71),('11288','2013-06-09','11:50:00',6.69),('11288','2013-06-09','11:55:00',6.69),('11288','2013-06-09','12:00:00',6.75),('11288','2013-06-09','12:05:00',6.9),('11288','2013-06-09','12:10:00',5.63),('11288','2013-06-09','12:15:00',6.9),('11288','2013-06-09','12:20:00',6.92),('11288','2013-06-09','12:25:00',6.97),('11288','2013-06-09','12:30:00',6.81),('11288','2013-06-09','12:35:00',6.76),('11288','2013-06-09','12:40:00',6.97),('11288','2013-06-09','12:45:00',6.87),('11288','2013-06-09','12:50:00',7.1),('11288','2013-06-09','12:55:00',6.75),('11288','2013-06-09','13:00:00',6.95),('11288','2013-06-09','13:05:00',2.8),('11288','2013-06-09','13:10:00',4.74),('11288','2013-06-09','13:15:00',3.49),('11288','2013-06-09','13:20:00',5.8),('11288','2013-06-09','13:25:00',7.74),('11288','2013-06-09','13:30:00',7.29),('11288','2013-06-09','13:35:00',7.42),('11288','2013-06-09','13:40:00',7.69),('11288','2013-06-09','13:45:00',7.69),('11288','2013-06-09','13:50:00',7.99),('11288','2013-06-09','13:55:00',6.64),('11288','2013-06-09','14:00:00',6.29),('11288','2013-06-09','14:05:00',7.56),('11288','2013-06-09','14:10:00',7.22),('11288','2013-06-09','14:15:00',5.18),('11288','2013-06-09','14:20:00',3.08),('11288','2013-06-09','14:25:00',2.08),('11288','2013-06-09','14:30:00',3.02),('11288','2013-06-09','14:35:00',6.72),('11288','2013-06-09','14:40:00',7.45),('11288','2013-06-09','14:45:00',6.62),('11288','2013-06-09','14:50:00',7.09),('11288','2013-06-09','14:55:00',6.99),('11288','2013-06-09','15:00:00',6.84),('11288','2013-06-09','15:05:00',6.55),('11288','2013-06-09','15:10:00',6.6),('11288','2013-06-09','15:15:00',6.44),('11288','2013-06-09','15:20:00',6.35),('11288','2013-06-09','15:25:00',6.4),('11288','2013-06-09','15:30:00',6.15),('11288','2013-06-09','15:35:00',6.24),('11288','2013-06-09','15:40:00',4.91),('11288','2013-06-09','15:45:00',5.26),('11288','2013-06-09','15:50:00',5.97),('11288','2013-06-09','15:55:00',6.04),('11288','2013-06-09','16:00:00',4.08),('11288','2013-06-09','16:05:00',5.86),('11288','2013-06-09','16:10:00',5.41),('11288','2013-06-09','16:15:00',2.65),('11288','2013-06-09','16:20:00',2.9),('11288','2013-06-09','16:25:00',4.03),('11288','2013-06-09','16:30:00',2.3),('11288','2013-06-09','16:35:00',1.77),('11288','2013-06-09','16:40:00',1.74),('11288','2013-06-09','16:45:00',1.74),('11288','2013-06-09','16:50:00',1.66),('11288','2013-06-09','16:55:00',1.57),('11288','2013-06-09','17:00:00',1.67),('11288','2013-06-09','17:05:00',1.85),('11288','2013-06-09','17:10:00',1.75),('11288','2013-06-09','17:15:00',1.46),('11288','2013-06-09','17:20:00',1.56),('11288','2013-06-09','17:25:00',1.18),('11288','2013-06-09','17:30:00',1.02),('11288','2013-06-09','17:35:00',1.18),('11288','2013-06-09','17:40:00',1.4),('11288','2013-06-09','17:45:00',1.29),('11288','2013-06-09','17:55:00',1.05),('11288','2013-06-09','18:00:00',1.86),('11288','2013-06-09','18:05:00',1.62),('11288','2013-06-09','18:10:00',2.33),('11288','2013-06-09','18:15:00',1.79),('11288','2013-06-09','18:20:00',1.56),('11288','2013-06-09','18:30:00',1.57),('11288','2013-06-09','18:35:00',1.08),('11288','2013-06-09','18:45:00',1.24),('11288','2013-06-09','18:50:00',1.24),('11288','2013-06-08','07:10:00',1.01),('11288','2013-06-08','07:15:00',1.14),('11288','2013-06-08','07:20:00',1.22),('11288','2013-06-08','07:25:00',1.31),('11288','2013-06-08','07:30:00',1.41),('11288','2013-06-08','07:35:00',1.53),('11288','2013-06-08','07:40:00',1.55),('11288','2013-06-08','07:45:00',1.77),('11288','2013-06-08','07:50:00',1.89),('11288','2013-06-08','07:55:00',2.02),('11288','2013-06-08','08:00:00',2.29),('11288','2013-06-08','08:05:00',2.36),('11288','2013-06-08','08:10:00',2.37),('11288','2013-06-08','08:15:00',2.65),('11288','2013-06-08','08:20:00',2.85),('11288','2013-06-08','08:25:00',2.87),('11288','2013-06-08','08:30:00',3.14),('11288','2013-06-08','08:35:00',3.19),('11288','2013-06-08','08:40:00',3.32),('11288','2013-06-08','08:45:00',3.61),('11288','2013-06-08','08:50:00',3.73),('11288','2013-06-08','08:55:00',3.77),('11288','2013-06-08','09:00:00',3.9),('11288','2013-06-08','09:05:00',3.94),('11288','2013-06-08','09:10:00',3.99),('11288','2013-06-08','09:15:00',4.23),('11288','2013-06-08','09:20:00',4.41),('11288','2013-06-08','09:25:00',4.37),('11288','2013-06-08','09:30:00',4.53),('11288','2013-06-08','09:35:00',4.71),('11288','2013-06-08','09:40:00',4.94),('11288','2013-06-08','09:45:00',5.03),('11288','2013-06-08','09:50:00',5.26),('11288','2013-06-08','09:55:00',5.41),('11288','2013-06-08','10:00:00',5.37),('11288','2013-06-08','10:05:00',5.34),('11288','2013-06-08','10:10:00',5.73),('11288','2013-06-08','10:15:00',5.1),('11288','2013-06-08','10:20:00',5.87),('11288','2013-06-08','10:25:00',4.85),('11288','2013-06-08','10:30:00',5.75),('11288','2013-06-08','10:35:00',6.19),('11288','2013-06-08','10:40:00',6.34),('11288','2013-06-08','10:45:00',6.44),('11288','2013-06-08','10:50:00',5.11),('11288','2013-06-08','10:55:00',2.25),('11288','2013-06-08','11:00:00',4.93),('11288','2013-06-08','11:05:00',2.44),('11288','2013-06-08','11:10:00',7.36),('11288','2013-06-08','11:15:00',7.7),('11288','2013-06-08','11:20:00',7.34),('11288','2013-06-08','11:25:00',2.27),('11288','2013-06-08','11:30:00',2.06),('11288','2013-06-08','11:35:00',5.52),('11288','2013-06-08','11:40:00',7.64),('11288','2013-06-08','11:45:00',7.33),('11288','2013-06-08','11:50:00',7.66),('11288','2013-06-08','11:55:00',7.76),('11288','2013-06-08','12:00:00',7.66),('11288','2013-06-08','12:05:00',4.2),('11288','2013-06-08','12:10:00',7.59),('11288','2013-06-08','12:15:00',7.7),('11288','2013-06-08','12:20:00',7.51),('11288','2013-06-08','12:25:00',6.52),('11288','2013-06-08','12:30:00',6.51),('11288','2013-06-08','12:35:00',7.35),('11288','2013-06-08','12:40:00',6.44),('11288','2013-06-08','12:45:00',7.35),('11288','2013-06-08','12:50:00',7.44),('11288','2013-06-08','12:55:00',7.36),('11288','2013-06-08','13:00:00',7.47),('11288','2013-06-08','13:05:00',7.38),('11288','2013-06-08','13:10:00',7.42),('11288','2013-06-08','13:15:00',7.59),('11288','2013-06-08','13:20:00',7.51),('11288','2013-06-08','13:25:00',7.39),('11288','2013-06-08','13:30:00',7.48),('11288','2013-06-08','13:35:00',7.33),('11288','2013-06-08','13:40:00',7.31),('11288','2013-06-08','13:45:00',7.29),('11288','2013-06-08','13:50:00',7.22),('11288','2013-06-08','13:55:00',7.27),('11288','2013-06-08','14:00:00',7.3),('11288','2013-06-08','14:05:00',7.26),('11288','2013-06-08','14:10:00',7.2),('11288','2013-06-08','14:15:00',7.17),('11288','2013-06-08','14:20:00',7.08),('11288','2013-06-08','14:25:00',7.12),('11288','2013-06-08','14:30:00',7.05),('11288','2013-06-08','14:35:00',7.05),('11288','2013-06-08','14:40:00',7.07),('11288','2013-06-08','14:45:00',7.02),('11288','2013-06-08','14:50:00',7),('11288','2013-06-08','14:55:00',6.99),('11288','2013-06-08','15:00:00',6.87),('11288','2013-06-08','15:05:00',6.59),('11288','2013-06-08','15:10:00',6.18),('11288','2013-06-08','15:15:00',6.49),('11288','2013-06-08','15:20:00',6.71),('11288','2013-06-08','15:25:00',6.32),('11288','2013-06-08','15:30:00',6.23),('11288','2013-06-08','15:35:00',6.17),('11288','2013-06-08','15:40:00',6.21),('11288','2013-06-08','15:45:00',6.62),('11288','2013-06-08','15:50:00',6.58),('11288','2013-06-08','15:55:00',6.02),('11288','2013-06-08','16:00:00',6.17),('11288','2013-06-08','16:05:00',6.14),('11288','2013-06-08','16:10:00',6.18),('11288','2013-06-08','16:15:00',6.03),('11288','2013-06-08','16:20:00',5.9),('11288','2013-06-08','16:25:00',5.65),('11288','2013-06-08','16:30:00',5.41),('11288','2013-06-08','16:35:00',5.26),('11288','2013-06-08','16:40:00',5.03),('11288','2013-06-08','16:45:00',4.75),('11288','2013-06-08','16:50:00',4.05),('11288','2013-06-08','16:55:00',4.46),('11288','2013-06-08','17:00:00',4.77),('11288','2013-06-08','17:05:00',4.66),('11288','2013-06-08','17:10:00',4.97),('11288','2013-06-08','17:15:00',4.88),('11288','2013-06-08','17:20:00',4.62),('11288','2013-06-08','17:25:00',4.3),('11288','2013-06-08','17:30:00',3.22),('11288','2013-06-08','17:35:00',2.55),('11288','2013-06-08','17:40:00',3.91),('11288','2013-06-08','17:45:00',3.93),('11288','2013-06-08','17:50:00',3.62),('11288','2013-06-08','17:55:00',3.56),('11288','2013-06-08','18:00:00',2.98),('11288','2013-06-08','18:05:00',2.62),('11288','2013-06-08','18:10:00',2.15),('11288','2013-06-08','18:15:00',2.19),('11288','2013-06-08','18:20:00',2.18),('11288','2013-06-08','18:25:00',2.06),('11288','2013-06-08','18:30:00',1.31),('11288','2013-06-08','18:35:00',1.13),('11288','2013-06-07','07:15:00',1.11),('11288','2013-06-07','07:20:00',1.21),('11288','2013-06-07','07:25:00',1.29),('11288','2013-06-07','07:30:00',1.41),('11288','2013-06-07','07:35:00',1.51),('11288','2013-06-07','07:40:00',1.58),('11288','2013-06-07','07:45:00',1.77),('11288','2013-06-07','07:50:00',2),('11288','2013-06-07','07:55:00',2.06),('11288','2013-06-07','08:00:00',2.34),('11288','2013-06-07','08:05:00',2.48),('11288','2013-06-07','08:10:00',2.47),('11288','2013-06-07','08:15:00',2.7),('11288','2013-06-07','08:20:00',2.92),('11288','2013-06-07','08:25:00',2.97),('11288','2013-06-07','08:30:00',3.25),('11288','2013-06-07','08:35:00',3.37),('11288','2013-06-07','08:40:00',3.55),('11288','2013-06-07','08:45:00',3.78),('11288','2013-06-07','08:50:00',3.86),('11288','2013-06-07','08:55:00',3.96),('11288','2013-06-07','09:00:00',4.1),('11288','2013-06-07','09:05:00',4.19),('11288','2013-06-07','09:10:00',4.18),('11288','2013-06-07','09:15:00',4.49),('11288','2013-06-07','09:20:00',4.72),('11288','2013-06-07','09:25:00',4.88),('11288','2013-06-07','09:30:00',4.99),('11288','2013-06-07','09:35:00',5.08),('11288','2013-06-07','09:40:00',5.27),('11288','2013-06-07','09:45:00',5.44),('11288','2013-06-07','09:50:00',5.61),('11288','2013-06-07','09:55:00',5.67),('11288','2013-06-07','10:00:00',5.8),('11288','2013-06-07','10:05:00',5.96),('11288','2013-06-07','10:10:00',6.02),('11288','2013-06-07','10:15:00',6.1),('11288','2013-06-07','10:20:00',6.28),('11288','2013-06-07','10:25:00',6.35),('11288','2013-06-07','10:30:00',6.43),('11288','2013-06-07','10:35:00',6.55),('11288','2013-06-07','10:40:00',6.59),('11288','2013-06-07','10:45:00',6.64),('11288','2013-06-07','10:50:00',6.74),('11288','2013-06-07','10:55:00',6.79),('11288','2013-06-07','11:00:00',6.87),('11288','2013-06-07','11:05:00',6.96),('11288','2013-06-07','11:10:00',7.04),('11288','2013-06-07','11:15:00',7.07),('11288','2013-06-07','11:20:00',7.04),('11288','2013-06-07','11:25:00',7.08),('11288','2013-06-07','11:30:00',7.17),('11288','2013-06-07','11:35:00',7.22),('11288','2013-06-07','11:40:00',7.26),('11288','2013-06-07','11:45:00',7.31),('11288','2013-06-07','11:50:00',7.28),('11288','2013-06-07','11:55:00',7.35),('11288','2013-06-07','12:00:00',7.38),('11288','2013-06-07','12:05:00',7.41),('11288','2013-06-07','12:10:00',7.4),('11288','2013-06-07','12:15:00',7.4),('11288','2013-06-07','12:20:00',7.4),('11288','2013-06-07','12:25:00',7.41),('11288','2013-06-07','12:30:00',7.43),('11288','2013-06-07','12:35:00',7.45),('11288','2013-06-07','12:40:00',7.42),('11288','2013-06-07','12:45:00',7.48),('11288','2013-06-07','12:50:00',7.44),('11288','2013-06-07','12:55:00',7.47),('11288','2013-06-07','13:00:00',7.49),('11288','2013-06-07','13:05:00',7.48),('11288','2013-06-07','13:10:00',7.42),('11288','2013-06-07','13:15:00',7.41),('11288','2013-06-07','13:20:00',7.37),('11288','2013-06-07','13:25:00',7.36),('11288','2013-06-07','13:30:00',7.38),('11288','2013-06-07','13:35:00',7.35),('11288','2013-06-07','13:40:00',7.25),('11288','2013-06-07','13:45:00',7.17),('11288','2013-06-07','13:50:00',7.17),('11288','2013-06-07','13:55:00',7.18),('11288','2013-06-07','14:00:00',7.14),('11288','2013-06-07','14:05:00',7.12),('11288','2013-06-07','14:10:00',7.05),('11288','2013-06-07','14:15:00',7.05),('11288','2013-06-07','14:20:00',6.98),('11288','2013-06-07','14:25:00',6.91),('11288','2013-06-07','14:30:00',6.86),('11288','2013-06-07','14:35:00',6.82),('11288','2013-06-07','14:40:00',6.83),('11288','2013-06-07','14:45:00',6.88),('11288','2013-06-07','14:50:00',6.81),('11288','2013-06-07','14:55:00',6.74),('11288','2013-06-07','15:00:00',6.67),('11288','2013-06-07','15:05:00',6.67),('11288','2013-06-07','15:10:00',6.58),('11288','2013-06-07','15:15:00',6.57),('11288','2013-06-07','15:20:00',6.52),('11288','2013-06-07','15:25:00',6.54),('11288','2013-06-07','15:30:00',6.5),('11288','2013-06-07','15:35:00',6.42),('11288','2013-06-07','15:40:00',6.31),('11288','2013-06-07','15:45:00',6.24),('11288','2013-06-07','15:50:00',6.17),('11288','2013-06-07','15:55:00',6.07),('11288','2013-06-07','16:00:00',5.99),('11288','2013-06-07','16:05:00',5.9),('11288','2013-06-07','16:10:00',5.74),('11288','2013-06-07','16:15:00',5.41),('11288','2013-06-07','16:20:00',5.41),('11288','2013-06-07','16:25:00',5.54),('11288','2013-06-07','16:30:00',5.49),('11288','2013-06-07','16:35:00',5.27),('11288','2013-06-07','16:40:00',5.18),('11288','2013-06-07','16:45:00',5.07),('11288','2013-06-07','16:50:00',4.99),('11288','2013-06-07','16:55:00',4.87),('11288','2013-06-07','17:00:00',4.74),('11288','2013-06-07','17:05:00',4.62),('11288','2013-06-07','17:10:00',4.54),('11288','2013-06-07','17:15:00',4.38),('11288','2013-06-07','17:20:00',4.26),('11288','2013-06-07','17:25:00',4.13),('11288','2013-06-07','17:30:00',3.99),('11288','2013-06-07','17:35:00',3.93),('11288','2013-06-07','17:40:00',3.79),('11288','2013-06-07','17:45:00',3.65),('11288','2013-06-07','17:50:00',3.57),('11288','2013-06-07','17:55:00',3.46),('11288','2013-06-07','18:00:00',3.26),('11288','2013-06-07','18:05:00',3.13),('11288','2013-06-07','18:10:00',2.94),('11288','2013-06-07','18:15:00',2.72),('11288','2013-06-07','18:20:00',2.57),('11288','2013-06-07','18:25:00',2.32),('11288','2013-06-07','18:30:00',2.2),('11288','2013-06-07','18:35:00',2.1),('11288','2013-06-07','18:40:00',1.95),('11288','2013-06-07','18:45:00',1.77),('11288','2013-06-07','18:50:00',1.66),('11288','2013-06-07','18:55:00',1.55),('11288','2013-06-07','19:00:00',1.47),('11288','2013-06-07','19:05:00',1.32),('11288','2013-06-06','06:55:00',1.03),('11288','2013-06-06','07:00:00',1.43),('11288','2013-06-06','07:05:00',1.65),('11288','2013-06-06','07:10:00',1.57),('11288','2013-06-06','07:15:00',1.75),('11288','2013-06-06','07:20:00',1.18),('11288','2013-06-06','07:25:00',1.24),('11288','2013-06-06','07:30:00',1.14),('11288','2013-06-06','07:35:00',1.1),('11288','2013-06-06','07:40:00',1.25),('11288','2013-06-06','07:45:00',1.26),('11288','2013-06-06','07:50:00',1.91),('11288','2013-06-06','07:55:00',2.45),('11288','2013-06-06','08:00:00',2.53),('11288','2013-06-06','08:05:00',2.03),('11288','2013-06-06','08:10:00',2.64),('11288','2013-06-06','08:15:00',2.24),('11288','2013-06-06','08:20:00',2.64),('11288','2013-06-06','08:25:00',3),('11288','2013-06-06','08:30:00',3.27),('11288','2013-06-06','08:35:00',3.26),('11288','2013-06-06','08:40:00',3.51),('11288','2013-06-06','08:45:00',3.73),('11288','2013-06-06','08:50:00',3.74),('11288','2013-06-06','08:55:00',3.96),('11288','2013-06-06','09:00:00',4.12),('11288','2013-06-06','09:05:00',4.13),('11288','2013-06-06','09:10:00',4.15),('11288','2013-06-06','09:15:00',4.41),('11288','2013-06-06','09:20:00',4.44),('11288','2013-06-06','09:25:00',4.51),('11288','2013-06-06','09:30:00',4.79),('11288','2013-06-06','09:35:00',4.97),('11288','2013-06-06','09:40:00',5.1),('11288','2013-06-06','09:45:00',5.28),('11288','2013-06-06','09:50:00',5.46),('11288','2013-06-06','09:55:00',5.54),('11288','2013-06-06','10:00:00',5.67),('11288','2013-06-06','10:05:00',5.67),('11288','2013-06-06','10:10:00',5.62),('11288','2013-06-06','10:15:00',5.74),('11288','2013-06-06','10:20:00',6.01),('11288','2013-06-06','10:25:00',6.2),('11288','2013-06-06','10:30:00',6.31),('11288','2013-06-06','10:35:00',6.26),('11288','2013-06-06','10:40:00',6.29),('11288','2013-06-06','10:45:00',6.45),('11288','2013-06-06','10:50:00',6.65),('11288','2013-06-06','10:55:00',6.67),('11288','2013-06-06','11:00:00',6.72),('11288','2013-06-06','11:05:00',6.84),('11288','2013-06-06','11:10:00',6.72),('11288','2013-06-06','11:15:00',6.85),('11288','2013-06-06','11:20:00',6.73),('11288','2013-06-06','11:25:00',6.86),('11288','2013-06-06','11:30:00',6.89),('11288','2013-06-06','11:35:00',7),('11288','2013-06-06','11:40:00',6.82),('11288','2013-06-06','11:45:00',6.86),('11288','2013-06-06','11:50:00',6.93),('11288','2013-06-06','11:55:00',7.08),('11288','2013-06-06','12:00:00',7.1),('11288','2013-06-06','12:05:00',7.15),('11288','2013-06-06','12:10:00',7.1),('11288','2013-06-06','12:15:00',7.08),('11288','2013-06-06','12:20:00',7.08),('11288','2013-06-06','12:25:00',7.1),('11288','2013-06-06','12:30:00',6.96),('11288','2013-06-06','12:35:00',7),('11288','2013-06-06','12:40:00',7.14),('11288','2013-06-06','12:45:00',7.33),('11288','2013-06-06','12:50:00',7.34),('11288','2013-06-06','12:55:00',7.42),('11288','2013-06-06','13:00:00',7.34),('11288','2013-06-06','13:05:00',7.38),('11288','2013-06-06','13:10:00',7.32),('11288','2013-06-06','13:15:00',7.42),('11288','2013-06-06','13:20:00',7.39),('11288','2013-06-06','13:25:00',6.16),('11288','2013-06-06','13:30:00',7.3),('11288','2013-06-06','13:35:00',7.37),('11288','2013-06-06','13:40:00',3.54),('11288','2013-06-06','13:45:00',1.53),('11288','2013-06-06','13:50:00',1.84),('11288','2013-06-06','13:55:00',6.06),('11288','2013-06-06','14:00:00',7.25),('11288','2013-06-06','14:05:00',3.87),('11288','2013-06-06','14:10:00',3.05),('11288','2013-06-06','14:15:00',3.09),('11288','2013-06-06','14:20:00',4.98),('11288','2013-06-06','14:25:00',7.42),('11288','2013-06-06','14:30:00',5.99),('11288','2013-06-06','14:35:00',7.06),('11288','2013-06-06','14:40:00',7.08),('11288','2013-06-06','14:45:00',6.11),('11288','2013-06-06','14:50:00',7.36),('11288','2013-06-06','14:55:00',6.89),('11288','2013-06-06','15:00:00',6.78),('11288','2013-06-06','15:05:00',6.83),('11288','2013-06-06','15:10:00',6.85),('11288','2013-06-06','15:15:00',6.64),('11288','2013-06-06','15:20:00',5.86),('11288','2013-06-06','15:25:00',6.08),('11288','2013-06-06','15:30:00',6.17),('11288','2013-06-06','15:35:00',6.23),('11288','2013-06-06','15:40:00',6.27),('11288','2013-06-06','15:45:00',6.12),('11288','2013-06-06','15:50:00',5.58),('11288','2013-06-06','15:55:00',6.21),('11288','2013-06-06','16:00:00',6.25),('11288','2013-06-06','16:05:00',6.12),('11288','2013-06-06','16:10:00',5.75),('11288','2013-06-06','16:15:00',5.39),('11288','2013-06-06','16:20:00',5.38),('11288','2013-06-06','16:25:00',5.34),('11288','2013-06-06','16:30:00',5.22),('11288','2013-06-06','16:35:00',5.13),('11288','2013-06-06','16:40:00',4.9),('11288','2013-06-06','16:45:00',4.63),('11288','2013-06-06','16:50:00',4.76),('11288','2013-06-06','16:55:00',4.63),('11288','2013-06-06','17:00:00',4.42),('11288','2013-06-06','17:05:00',4.36),('11288','2013-06-06','17:10:00',4.25),('11288','2013-06-06','17:15:00',4.08),('11288','2013-06-06','17:20:00',3.99),('11288','2013-06-06','17:25:00',3.9),('11288','2013-06-06','17:30:00',3.79),('11288','2013-06-06','17:35:00',3.71),('11288','2013-06-06','17:40:00',3.6),('11288','2013-06-06','17:45:00',3.4),('11288','2013-06-06','17:50:00',3.24),('11288','2013-06-06','17:55:00',3.12),('11288','2013-06-06','18:00:00',3.01),('11288','2013-06-06','18:05:00',2.9),('11288','2013-06-06','18:10:00',2.74),('11288','2013-06-06','18:15:00',2.56),('11288','2013-06-06','18:20:00',2.42),('11288','2013-06-06','18:25:00',2.28),('11288','2013-06-06','18:30:00',2.13),('11288','2013-06-06','18:35:00',2.01),('11288','2013-06-06','18:40:00',1.92),('11288','2013-06-06','18:45:00',1.77),('11288','2013-06-06','18:50:00',1.62),('11288','2013-06-06','18:55:00',1.53),('11288','2013-06-06','19:00:00',1.4),('11288','2013-06-06','19:05:00',1.25),('11288','2013-06-06','19:10:00',1.11),('11288','2013-06-06','19:15:00',1.03),('11288','2013-06-05','07:25:00',1.42),('11288','2013-06-05','07:30:00',1.22),('11288','2013-06-05','07:35:00',1.16),('11288','2013-06-05','07:40:00',1.19),('11288','2013-06-05','07:45:00',1.72),('11288','2013-06-05','07:50:00',2.65),('11288','2013-06-05','07:55:00',2.81),('11288','2013-06-05','08:00:00',2.95),('11288','2013-06-05','08:05:00',2.8),('11288','2013-06-05','08:10:00',2.56),('11288','2013-06-05','08:15:00',2.67),('11288','2013-06-05','08:20:00',2.84),('11288','2013-06-05','08:25:00',3.02),('11288','2013-06-05','08:30:00',3.26),('11288','2013-06-05','08:35:00',3.36),('11288','2013-06-05','08:40:00',3.51),('11288','2013-06-05','08:45:00',3.72),('11288','2013-06-05','08:50:00',3.81),('11288','2013-06-05','08:55:00',3.94),('11288','2013-06-05','09:00:00',4),('11288','2013-06-05','09:05:00',4.39),('11288','2013-06-05','09:10:00',3.16),('11288','2013-06-05','09:15:00',3.12),('11288','2013-06-05','09:20:00',4.78),('11288','2013-06-05','09:25:00',3.1),('11288','2013-06-05','09:30:00',2.49),('11288','2013-06-05','09:35:00',5.34),('11288','2013-06-05','09:40:00',5.99),('11288','2013-06-05','09:45:00',3.08),('11288','2013-06-05','09:50:00',3.97),('11288','2013-06-05','09:55:00',4.38),('11288','2013-06-05','10:00:00',6.07),('11288','2013-06-05','10:05:00',6.68),('11288','2013-06-05','10:10:00',5.97),('11288','2013-06-05','10:15:00',3.86),('11288','2013-06-05','10:20:00',2.67),('11288','2013-06-05','10:25:00',2.7),('11288','2013-06-05','10:30:00',2.25),('11288','2013-06-05','10:35:00',4.01),('11288','2013-06-05','10:40:00',7.64),('11288','2013-06-05','10:45:00',7.51),('11288','2013-06-05','10:50:00',6.78),('11288','2013-06-05','10:55:00',4.84),('11288','2013-06-05','11:00:00',2.79),('11288','2013-06-05','11:05:00',2.92),('11288','2013-06-05','11:10:00',2.08),('11288','2013-06-05','11:15:00',2.01),('11288','2013-06-05','11:20:00',1.92),('11288','2013-06-05','11:25:00',2.12),('11288','2013-06-05','11:30:00',3.24),('11288','2013-06-05','11:35:00',5.71),('11288','2013-06-05','11:40:00',8.04),('11288','2013-06-05','11:45:00',3.13),('11288','2013-06-05','11:50:00',5.3),('11288','2013-06-05','11:55:00',8.11),('11288','2013-06-05','12:00:00',8.18),('11288','2013-06-05','12:05:00',7.95),('11288','2013-06-05','12:10:00',7.78),('11288','2013-06-05','12:15:00',7.82),('11288','2013-06-05','12:20:00',8.29),('11288','2013-06-05','12:25:00',7.88),('11288','2013-06-05','12:30:00',4.64),('11288','2013-06-05','12:35:00',3.04),('11288','2013-06-05','12:40:00',6.24),('11288','2013-06-05','12:45:00',8.14),('11288','2013-06-05','12:50:00',3.76),('11288','2013-06-05','12:55:00',3.87),('11288','2013-06-05','13:00:00',4.53),('11288','2013-06-05','13:05:00',5.89),('11288','2013-06-05','13:10:00',7.12),('11288','2013-06-05','13:15:00',5.82),('11288','2013-06-05','13:20:00',4.46),('11288','2013-06-05','13:25:00',7.25),('11288','2013-06-05','13:30:00',8.66),('11288','2013-06-05','13:35:00',8.2),('11288','2013-06-05','13:40:00',7.93),('11288','2013-06-05','13:45:00',7.89),('11288','2013-06-05','13:50:00',7.61),('11288','2013-06-05','13:55:00',7.65),('11288','2013-06-05','14:00:00',7.52),('11288','2013-06-05','14:05:00',7.51),('11288','2013-06-05','14:10:00',7.42),('11288','2013-06-05','14:15:00',7.38),('11288','2013-06-05','14:20:00',7.35),('11288','2013-06-05','14:25:00',7.28),('11288','2013-06-05','14:30:00',6.54),('11288','2013-06-05','14:35:00',7.09),('11288','2013-06-05','14:40:00',7.22),('11288','2013-06-05','14:45:00',7.18),('11288','2013-06-05','14:50:00',7.13),('11288','2013-06-05','14:55:00',7.04),('11288','2013-06-05','15:00:00',6.93),('11288','2013-06-05','15:05:00',6.83),('11288','2013-06-05','15:10:00',6.84),('11288','2013-06-05','15:15:00',6.81),('11288','2013-06-05','15:20:00',6.73),('11288','2013-06-05','15:25:00',6.75),('11288','2013-06-05','15:30:00',6.83),('11288','2013-06-05','15:35:00',6.84),('11288','2013-06-05','15:40:00',6.6),('11288','2013-06-05','15:45:00',6.5),('11288','2013-06-05','15:50:00',6.42),('11288','2013-06-05','15:55:00',6.35),('11288','2013-06-05','16:00:00',6.29),('11288','2013-06-05','16:05:00',6.21),('11288','2013-06-05','16:10:00',6),('11288','2013-06-05','16:15:00',5.92),('11288','2013-06-05','16:20:00',5.75),('11288','2013-06-05','16:25:00',5.73),('11288','2013-06-05','16:30:00',5.61),('11288','2013-06-05','16:35:00',5.45),('11288','2013-06-05','16:40:00',5.21),('11288','2013-06-05','16:45:00',5.02),('11288','2013-06-05','16:50:00',4.77),('11288','2013-06-05','16:55:00',4.83),('11288','2013-06-05','17:00:00',1.71),('11288','2013-06-05','17:05:00',3.87),('11288','2013-06-05','17:10:00',2.14),('11288','2013-06-05','17:15:00',2.84),('11288','2013-06-05','17:20:00',3.01),('11288','2013-06-05','17:25:00',2.31),('11288','2013-06-05','17:30:00',3.64),('11288','2013-06-05','17:35:00',3.81),('11288','2013-06-05','17:40:00',3.56),('11288','2013-06-05','17:45:00',3.58),('11288','2013-06-05','17:50:00',3.29),('11288','2013-06-05','17:55:00',3.18),('11288','2013-06-05','18:00:00',3.05),('11288','2013-06-05','18:05:00',1.71),('11288','2013-06-05','18:10:00',2.41),('11288','2013-06-05','18:15:00',1.91),('11288','2013-06-05','18:20:00',1.5),('11288','2013-06-05','18:25:00',1.72),('11288','2013-06-05','18:30:00',2.17),('11288','2013-06-05','18:35:00',2.19),('11288','2013-06-05','18:40:00',2.25),('11288','2013-06-05','18:45:00',1.25),('11288','2013-06-05','18:50:00',1.37),('11288','2013-06-05','18:55:00',1.4),('11288','2013-06-05','19:00:00',1.26),('11288','2013-06-05','19:05:00',1.01),('11288','2013-06-04','07:10:00',1.2),('11288','2013-06-04','07:15:00',1.28),('11288','2013-06-04','07:20:00',1.33),('11288','2013-06-04','07:25:00',1.45),('11288','2013-06-04','07:30:00',1.52),('11288','2013-06-04','07:35:00',1.7),('11288','2013-06-04','07:40:00',1.95),('11288','2013-06-04','07:45:00',2.27),('11288','2013-06-04','07:50:00',2.68),('11288','2013-06-04','07:55:00',2.93),('11288','2013-06-04','08:00:00',3.29),('11288','2013-06-04','08:05:00',3.64),('11288','2013-06-04','08:10:00',3.55),('11288','2013-06-04','08:15:00',3.53),('11288','2013-06-04','08:20:00',3.72),('11288','2013-06-04','08:25:00',3.79),('11288','2013-06-04','08:30:00',4.1),('11288','2013-06-04','08:35:00',4),('11288','2013-06-04','08:40:00',3.63),('11288','2013-06-04','08:45:00',3.38),('11288','2013-06-04','08:50:00',2.56),('11288','2013-06-04','08:55:00',2.59),('11288','2013-06-04','09:00:00',2.93),('11288','2013-06-04','09:05:00',3.13),('11288','2013-06-04','09:10:00',3.93),('11288','2013-06-04','09:15:00',5.99),('11288','2013-06-04','09:20:00',5.45),('11288','2013-06-04','09:25:00',4.24),('11288','2013-06-04','09:30:00',5.1),('11288','2013-06-04','09:35:00',4.23),('11288','2013-06-04','09:40:00',3.44),('11288','2013-06-04','09:45:00',4.12),('11288','2013-06-04','09:50:00',3.6),('11288','2013-06-04','09:55:00',3.37),('11288','2013-06-04','10:00:00',3.82),('11288','2013-06-04','10:05:00',4.58),('11288','2013-06-04','10:10:00',4.02),('11288','2013-06-04','10:15:00',3.24),('11288','2013-06-04','10:20:00',3.51),('11288','2013-06-04','10:25:00',3.55),('11288','2013-06-04','10:30:00',3.14),('11288','2013-06-04','10:35:00',3.19),('11288','2013-06-04','10:40:00',3.57),('11288','2013-06-04','10:45:00',4.62),('11288','2013-06-04','10:50:00',5.25),('11288','2013-06-04','10:55:00',4.94),('11288','2013-06-04','11:00:00',4.26),('11288','2013-06-04','11:05:00',5.3),('11288','2013-06-04','11:10:00',6.77),('11288','2013-06-04','11:15:00',5.64),('11288','2013-06-04','11:20:00',4.06),('11288','2013-06-04','11:25:00',4.9),('11288','2013-06-04','11:30:00',5.48),('11288','2013-06-04','11:35:00',5.09),('11288','2013-06-04','11:40:00',5.8),('11288','2013-06-04','11:45:00',6.75),('11288','2013-06-04','11:50:00',7.8),('11288','2013-06-04','11:55:00',7.65),('11288','2013-06-04','12:00:00',7.23),('11288','2013-06-04','12:05:00',7.55),('11288','2013-06-04','12:10:00',4.75),('11288','2013-06-04','12:15:00',4.87),('11288','2013-06-04','12:20:00',4.51),('11288','2013-06-04','12:25:00',4.11),('11288','2013-06-04','12:30:00',5.44),('11288','2013-06-04','12:35:00',6.44),('11288','2013-06-04','12:40:00',4.16),('11288','2013-06-04','12:45:00',5.71),('11288','2013-06-04','12:50:00',3.98),('11288','2013-06-04','12:55:00',3),('11288','2013-06-04','13:00:00',3.01),('11288','2013-06-04','13:05:00',3.07),('11288','2013-06-04','13:10:00',3.09),('11288','2013-06-04','13:15:00',2.04),('11288','2013-06-04','13:20:00',2.08),('11288','2013-06-04','13:25:00',2.5),('11288','2013-06-04','13:30:00',3.73),('11288','2013-06-04','13:35:00',8.26),('11288','2013-06-04','13:40:00',6.85),('11288','2013-06-04','13:45:00',6.12),('11288','2013-06-04','13:50:00',7.54),('11288','2013-06-04','13:55:00',6.06),('11288','2013-06-04','14:00:00',3.77),('11288','2013-06-04','14:05:00',6.61),('11288','2013-06-04','14:10:00',5.82),('11288','2013-06-04','14:15:00',3.26),('11288','2013-06-04','14:20:00',7.55),('11288','2013-06-04','14:25:00',2.09),('11288','2013-06-04','14:30:00',2.13),('11288','2013-06-04','14:35:00',2.62),('11288','2013-06-04','14:40:00',4.03),('11288','2013-06-04','14:45:00',2.5),('11288','2013-06-04','14:50:00',2.54),('11288','2013-06-04','14:55:00',5.67),('11288','2013-06-04','15:00:00',7.56),('11288','2013-06-04','15:05:00',3.48),('11288','2013-06-04','15:10:00',2.85),('11288','2013-06-04','15:15:00',4.06),('11288','2013-06-04','15:20:00',2.14),('11288','2013-06-04','15:25:00',1.65),('11288','2013-06-04','15:30:00',1.1),('11288','2013-06-04','17:15:00',1.6),('11288','2013-06-04','17:20:00',1.44),('11288','2013-06-04','17:25:00',1.16),('11288','2013-06-04','17:35:00',1.05),('11288','2013-06-04','17:40:00',1.41),('11288','2013-06-04','17:45:00',1.36),('11288','2013-06-04','17:50:00',1.23),('11288','2013-06-04','17:55:00',1.29),('11288','2013-06-04','18:00:00',1.38),('11288','2013-06-04','18:05:00',1.84),('11288','2013-06-04','18:10:00',1.63),('11288','2013-06-04','18:15:00',1.44),('11288','2013-06-04','18:20:00',1.32),('11288','2013-06-04','18:25:00',1.21),('11288','2013-06-04','18:30:00',1.05),('11288','2013-06-04','18:40:00',1.37),('11288','2013-06-04','18:45:00',1.7),('11288','2013-06-04','18:50:00',1.28),('11288','2013-06-04','18:55:00',1.25),('11288','2013-06-04','19:00:00',1.06),('11288','2013-06-03','06:50:00',1.01),('11288','2013-06-03','07:20:00',1.16),('11288','2013-06-03','07:25:00',1.35),('11288','2013-06-03','07:40:00',1.76),('11288','2013-06-03','07:45:00',1.7),('11288','2013-06-03','07:50:00',2.19),('11288','2013-06-03','07:55:00',2.28),('11288','2013-06-03','08:00:00',2.29),('11288','2013-06-03','08:05:00',2.49),('11288','2013-06-03','08:10:00',2.59),('11288','2013-06-03','08:15:00',2.68),('11288','2013-06-03','08:20:00',2.84),('11288','2013-06-03','08:25:00',3.13),('11288','2013-06-03','08:30:00',3.23),('11288','2013-06-03','08:35:00',3.37),('11288','2013-06-03','08:40:00',3.56),('11288','2013-06-03','08:45:00',3.79),('11288','2013-06-03','08:50:00',3.94),('11288','2013-06-03','08:55:00',4.1),('11288','2013-06-03','09:00:00',4.13),('11288','2013-06-03','09:05:00',4.19),('11288','2013-06-03','09:10:00',4.38),('11288','2013-06-03','09:15:00',5.05),('11288','2013-06-03','09:20:00',5.32),('11288','2013-06-03','09:25:00',3.73),('11288','2013-06-03','09:30:00',3.04),('11288','2013-06-03','09:35:00',3.53),('11288','2013-06-03','09:40:00',4.39),('11288','2013-06-03','09:45:00',5.81),('11288','2013-06-03','09:50:00',5.84),('11288','2013-06-03','09:55:00',6.16),('11288','2013-06-03','10:00:00',6.36),('11288','2013-06-03','10:05:00',5.99),('11288','2013-06-03','10:10:00',3.91),('11288','2013-06-03','10:15:00',2.04),('11288','2013-06-03','10:20:00',1.59),('11288','2013-06-03','10:25:00',1.62),('11288','2013-06-03','10:30:00',1.98),('11288','2013-06-03','10:35:00',2.38),('11288','2013-06-03','10:40:00',2.66),('11288','2013-06-03','10:45:00',3.42),('11288','2013-06-03','10:50:00',5.03),('11288','2013-06-03','10:55:00',3.76),('11288','2013-06-03','11:00:00',4.71),('11288','2013-06-03','11:05:00',3.47),('11288','2013-06-03','11:10:00',3.1),('11288','2013-06-03','11:15:00',2.57),('11288','2013-06-03','11:20:00',3.36),('11288','2013-06-03','11:25:00',3.26),('11288','2013-06-03','11:30:00',4.46),('11288','2013-06-03','11:35:00',2.73),('11288','2013-06-03','11:40:00',2.82),('11288','2013-06-03','11:45:00',2.82),('11288','2013-06-03','11:50:00',3.27),('11288','2013-06-03','11:55:00',3.24),('11288','2013-06-03','12:00:00',4.59),('11288','2013-06-03','12:05:00',2.31),('11288','2013-06-03','12:10:00',2.32),('11288','2013-06-03','12:15:00',2.35),('11288','2013-06-03','12:20:00',2.55),('11288','2013-06-03','12:25:00',2.22),('11288','2013-06-03','12:30:00',2.53),('11288','2013-06-03','12:35:00',4.56),('11288','2013-06-03','12:40:00',9.58),('11288','2013-06-03','12:45:00',5.03),('11288','2013-06-03','12:50:00',4.02),('11288','2013-06-03','12:55:00',6.48),('11288','2013-06-03','13:00:00',5.46),('11288','2013-06-03','13:05:00',4.65),('11288','2013-06-03','13:10:00',4.52),('11288','2013-06-03','13:15:00',7.81),('11288','2013-06-03','13:20:00',8.85),('11288','2013-06-03','13:25:00',7.99),('11288','2013-06-03','13:30:00',7.35),('11288','2013-06-03','13:35:00',8.18),('11288','2013-06-03','13:40:00',7.89),('11288','2013-06-03','13:45:00',8.29),('11288','2013-06-03','13:50:00',7.99),('11288','2013-06-03','13:55:00',3.07),('11288','2013-06-03','14:00:00',5.21),('11288','2013-06-03','14:05:00',6.02),('11288','2013-06-03','14:10:00',4.44),('11288','2013-06-03','14:15:00',4.93),('11288','2013-06-03','14:20:00',5.92),('11288','2013-06-03','14:25:00',4.98),('11288','2013-06-03','14:30:00',8.32),('11288','2013-06-03','14:35:00',8.36),('11288','2013-06-03','14:40:00',5.44),('11288','2013-06-03','14:45:00',5.51),('11288','2013-06-03','14:50:00',4.12),('11288','2013-06-03','14:55:00',6.49),('11288','2013-06-03','15:00:00',7.64),('11288','2013-06-03','15:05:00',7.2),('11288','2013-06-03','15:10:00',6.17),('11288','2013-06-03','15:15:00',7.83),('11288','2013-06-03','15:20:00',5.11),('11288','2013-06-03','15:25:00',7.07),('11288','2013-06-03','15:30:00',6.92),('11288','2013-06-03','15:35:00',6.82),('11288','2013-06-03','15:40:00',6.67),('11288','2013-06-03','15:45:00',6.54),('11288','2013-06-03','15:50:00',6.51),('11288','2013-06-03','15:55:00',6.47),('11288','2013-06-03','16:00:00',6.36),('11288','2013-06-03','16:05:00',6.27),('11288','2013-06-03','16:10:00',6.28),('11288','2013-06-03','16:15:00',6.07),('11288','2013-06-03','16:20:00',5.55),('11288','2013-06-03','16:25:00',5.89),('11288','2013-06-03','16:30:00',6.07),('11288','2013-06-03','16:35:00',5.83),('11288','2013-06-03','16:40:00',5.8),('11288','2013-06-03','16:45:00',5.04),('11288','2013-06-03','16:50:00',4.2),('11288','2013-06-03','16:55:00',3.49),('11288','2013-06-03','17:00:00',4.56),('11288','2013-06-03','17:05:00',5.42),('11288','2013-06-03','17:10:00',4.91),('11288','2013-06-03','17:15:00',3.93),('11288','2013-06-03','17:20:00',3.85),('11288','2013-06-03','17:25:00',2.74),('11288','2013-06-03','17:30:00',1.58),('11288','2013-06-03','17:35:00',1.26),('11288','2013-06-03','17:40:00',1.3),('11288','2013-06-03','17:45:00',1.12),('11288','2013-06-03','17:50:00',1.21),('11288','2013-06-03','17:55:00',1.21),('11288','2013-06-03','18:00:00',1.04),('11288','2013-06-02','06:50:00',1.16),('11288','2013-06-02','06:55:00',1.52),('11288','2013-06-02','07:00:00',1.3),('11288','2013-06-02','07:05:00',1.07),('11288','2013-06-02','08:25:00',1.45),('11288','2013-06-02','08:30:00',1.58),('11288','2013-06-02','08:35:00',1.79),('11288','2013-06-02','08:40:00',1.75),('11288','2013-06-02','08:45:00',1.89),('11288','2013-06-02','08:50:00',1.91),('11288','2013-06-02','08:55:00',1.72),('11288','2013-06-02','09:00:00',1.74),('11288','2013-06-02','09:05:00',1.86),('11288','2013-06-02','09:10:00',2.04),('11288','2013-06-02','09:15:00',2.3),('11288','2013-06-02','09:20:00',4.19),('11288','2013-06-02','09:25:00',5.57),('11288','2013-06-02','09:30:00',5.2),('11288','2013-06-02','09:35:00',5.38),('11288','2013-06-02','09:40:00',5.23),('11288','2013-06-02','09:45:00',5.15),('11288','2013-06-02','09:50:00',5.47),('11288','2013-06-02','09:55:00',5.7),('11288','2013-06-02','10:00:00',5.79),('11288','2013-06-02','10:05:00',5.97),('11288','2013-06-02','10:10:00',6.04),('11288','2013-06-02','10:15:00',6.18),('11288','2013-06-02','10:20:00',5.86),('11288','2013-06-02','10:25:00',6.31),('11288','2013-06-02','10:30:00',6.75),('11288','2013-06-02','10:35:00',4.97),('11288','2013-06-02','10:40:00',7.16),('11288','2013-06-02','10:45:00',4.24),('11288','2013-06-02','10:50:00',6.6),('11288','2013-06-02','10:55:00',7.59),('11288','2013-06-02','11:00:00',7.93),('11288','2013-06-02','11:05:00',6.59),('11288','2013-06-02','11:10:00',2.86),('11288','2013-06-02','11:15:00',6.42),('11288','2013-06-02','11:20:00',7.9),('11288','2013-06-02','11:25:00',5.73),('11288','2013-06-02','11:30:00',3.1),('11288','2013-06-02','11:35:00',4.83),('11288','2013-06-02','11:40:00',4.48),('11288','2013-06-02','11:45:00',3.12),('11288','2013-06-02','11:50:00',2.3),('11288','2013-06-02','11:55:00',4.76),('11288','2013-06-02','12:00:00',4.5),('11288','2013-06-02','12:05:00',3.43),('11288','2013-06-02','12:10:00',8.22),('11288','2013-06-02','12:15:00',4.98),('11288','2013-06-02','12:20:00',7.45),('11288','2013-06-02','12:25:00',4.87),('11288','2013-06-02','12:30:00',6.58),('11288','2013-06-02','12:35:00',6.72),('11288','2013-06-02','12:40:00',7.95),('11288','2013-06-02','12:45:00',4.92),('11288','2013-06-02','12:50:00',6.35),('11288','2013-06-02','12:55:00',5.99),('11288','2013-06-02','13:00:00',4.18),('11288','2013-06-02','13:05:00',8.63),('11288','2013-06-02','13:10:00',8.18),('11288','2013-06-02','13:15:00',7.83),('11288','2013-06-02','13:20:00',7.68),('11288','2013-06-02','13:25:00',7.6),('11288','2013-06-02','13:30:00',7.57),('11288','2013-06-02','13:35:00',7.55),('11288','2013-06-02','13:40:00',7.52),('11288','2013-06-02','13:45:00',7.52),('11288','2013-06-02','13:50:00',7.48),('11288','2013-06-02','13:55:00',7.43),('11288','2013-06-02','14:00:00',7.35),('11288','2013-06-02','14:05:00',7.41),('11288','2013-06-02','14:10:00',7.48),('11288','2013-06-02','14:15:00',7.37),('11288','2013-06-02','14:20:00',7.31),('11288','2013-06-02','14:25:00',7.3),('11288','2013-06-02','14:30:00',7.28),('11288','2013-06-02','14:35:00',7.14),('11288','2013-06-02','14:40:00',7.14),('11288','2013-06-02','14:45:00',7.1),('11288','2013-06-02','14:50:00',7.08),('11288','2013-06-02','14:55:00',7.03),('11288','2013-06-02','15:00:00',6.98),('11288','2013-06-02','15:05:00',6.81),('11288','2013-06-02','15:10:00',6.77),('11288','2013-06-02','15:15:00',6.79),('11288','2013-06-02','15:20:00',5.09),('11288','2013-06-02','15:25:00',7.04),('11288','2013-06-02','15:30:00',5.51),('11288','2013-06-02','15:35:00',6.15),('11288','2013-06-02','15:40:00',5.36),('11288','2013-06-02','15:45:00',6.01),('11288','2013-06-02','15:50:00',4.8),('11288','2013-06-02','15:55:00',6.71),('11288','2013-06-02','16:00:00',6.47),('11288','2013-06-02','16:05:00',5.31),('11288','2013-06-02','16:10:00',5.32),('11288','2013-06-02','16:15:00',6.08),('11288','2013-06-02','16:20:00',5.95),('11288','2013-06-02','16:25:00',5.82),('11288','2013-06-02','16:30:00',5.4),('11288','2013-06-02','16:35:00',5.42),('11288','2013-06-02','16:40:00',5.44),('11288','2013-06-02','16:45:00',5.18),('11288','2013-06-02','16:50:00',5.13),('11288','2013-06-02','16:55:00',4.95),('11288','2013-06-02','17:00:00',4.37),('11288','2013-06-02','17:05:00',4.73),('11288','2013-06-02','17:10:00',4.54),('11288','2013-06-02','17:15:00',4.46),('11288','2013-06-02','17:20:00',4.26),('11288','2013-06-02','17:25:00',4.09),('11288','2013-06-02','17:30:00',2.94),('11288','2013-06-02','17:35:00',2.64),('11288','2013-06-02','17:40:00',1.5),('11288','2013-06-02','17:45:00',3.06),('11288','2013-06-02','17:50:00',1.84),('11288','2013-06-02','17:55:00',2.54),('11288','2013-06-02','18:00:00',1.48),('11288','2013-06-02','18:05:00',1.14),('11288','2013-06-02','18:10:00',2.41),('11288','2013-06-02','18:15:00',1.33),('11288','2013-06-02','18:20:00',1.13),('11288','2013-06-02','18:25:00',1.51),('11288','2013-06-02','18:30:00',1.81),('11288','2013-06-02','18:35:00',1.15),('11288','2013-06-02','18:40:00',1.03),('11288','2013-06-02','18:45:00',1.05),('11288','2013-06-01','07:10:00',1.07),('11288','2013-06-01','07:15:00',1.16),('11288','2013-06-01','07:20:00',1.25),('11288','2013-06-01','07:25:00',1.33),('11288','2013-06-01','07:30:00',1.51),('11288','2013-06-01','07:35:00',1.58),('11288','2013-06-01','07:40:00',1.76),('11288','2013-06-01','07:45:00',2.06),('11288','2013-06-01','07:50:00',1.84),('11288','2013-06-01','07:55:00',2.31),('11288','2013-06-01','08:00:00',1.27),('11288','2013-06-01','08:05:00',1.17),('11288','2013-06-01','08:10:00',1.95),('11288','2013-06-01','08:15:00',2.88),('11288','2013-06-01','08:20:00',1.98),('11288','2013-06-01','08:25:00',1.65),('11288','2013-06-01','08:30:00',2.66),('11288','2013-06-01','08:35:00',1.96),('11288','2013-06-01','08:40:00',1.46),('11288','2013-06-01','08:45:00',1.05),('11288','2013-06-01','08:50:00',1.38),('11288','2013-06-01','08:55:00',1.34),('11288','2013-06-01','09:00:00',1.76),('11288','2013-06-01','09:05:00',1.05),('11288','2013-06-01','09:40:00',1.29),('11288','2013-06-01','09:45:00',1.62),('11288','2013-06-01','09:50:00',1.66),('11288','2013-06-01','09:55:00',1.29),('11288','2013-06-01','10:00:00',1.22),('11288','2013-06-01','10:05:00',1.34),('11288','2013-06-01','10:10:00',1.26),('11288','2013-06-01','10:15:00',1.03),('11288','2013-06-01','10:30:00',1.87),('11288','2013-06-01','10:35:00',2.44),('11288','2013-06-01','10:40:00',1.94),('11288','2013-06-01','10:45:00',1.78),('11288','2013-06-01','10:50:00',5.04),('11288','2013-06-01','10:55:00',3.76),('11288','2013-06-01','11:00:00',1.08),('11288','2013-06-01','11:45:00',1.28),('11288','2013-06-01','11:50:00',2.77),('11288','2013-06-01','11:55:00',3.22),('11288','2013-06-01','12:00:00',6.98),('11288','2013-06-01','12:05:00',4.85),('11288','2013-06-01','12:10:00',5.13),('11288','2013-06-01','12:15:00',2.29),('11288','2013-06-01','12:20:00',1.88),('11288','2013-06-01','12:25:00',2.31),('11288','2013-06-01','12:30:00',2.07),('11288','2013-06-01','12:35:00',1.65),('11288','2013-06-01','12:40:00',2.28),('11288','2013-06-01','12:45:00',3.42),('11288','2013-06-01','12:50:00',3.62),('11288','2013-06-01','12:55:00',3.84),('11288','2013-06-01','13:00:00',4.12),('11288','2013-06-01','13:05:00',4.28),('11288','2013-06-01','13:10:00',4.55),('11288','2013-06-01','13:15:00',4.77),('11288','2013-06-01','13:20:00',3.88),('11288','2013-06-01','13:25:00',3.31),('11288','2013-06-01','13:30:00',2.78),('11288','2013-06-01','13:35:00',2.22),('11288','2013-06-01','13:40:00',1.99),('11288','2013-06-01','13:45:00',2.21),('11288','2013-06-01','13:50:00',2.47),('11288','2013-06-01','13:55:00',2.81),('11288','2013-06-01','14:00:00',3.97),('11288','2013-06-01','14:05:00',4.28),('11288','2013-06-01','14:10:00',4.23),('11288','2013-06-01','14:15:00',4.71),('11288','2013-06-01','14:20:00',4.16),('11288','2013-06-01','14:25:00',2.83),('11288','2013-06-01','14:30:00',2.46),('11288','2013-06-01','14:35:00',2.49),('11288','2013-06-01','14:40:00',2.29),('11288','2013-06-01','14:45:00',2.21),('11288','2013-06-01','14:50:00',2.09),('11288','2013-06-01','14:55:00',1.65),('11288','2013-06-01','15:00:00',1.7),('11288','2013-06-01','15:05:00',1.58),('11288','2013-06-01','15:10:00',1.3),('11288','2013-06-01','15:15:00',1.42),('11288','2013-06-01','15:20:00',1.3),('11288','2013-06-01','15:45:00',1.08),('11288','2013-06-01','15:50:00',1.07),('11288','2013-06-01','15:55:00',1.09),('11288','2013-06-01','16:00:00',1.21),('11288','2013-06-01','16:05:00',1.29),('11288','2013-06-01','16:10:00',1.22),('11288','2013-06-01','16:15:00',1.4),('11288','2013-06-01','16:20:00',1.47),('11288','2013-06-01','16:25:00',1.13),('11288','2013-06-01','16:30:00',1.38),('11288','2013-06-01','16:35:00',1.52),('11288','2013-06-01','16:40:00',1.71),('11288','2013-06-01','16:45:00',1.43),('11288','2013-06-01','16:50:00',1.3),('11288','2013-06-01','16:55:00',1.14),('11288','2013-06-01','18:25:00',1.22),('11288','2013-06-01','18:30:00',1.84),('11288','2013-06-01','18:35:00',1.87),('11288','2013-06-01','18:40:00',1.33),('11288','2013-06-01','18:45:00',1.41),('11288','2013-06-01','18:50:00',1.26),('11288','2013-06-01','18:55:00',1.38),('11288','2013-06-01','19:00:00',2.33),('11288','2013-06-01','19:05:00',1.55),('11288','2014-04-02','07:55:00',1.11),('11288','2014-04-02','08:00:00',1.28),('11288','2014-04-02','08:30:00',1.17),('11288','2014-04-02','08:35:00',1.52),('11288','2014-04-02','08:40:00',1.39),('11288','2014-04-02','08:45:00',1.37),('11288','2014-04-02','08:50:00',2.01),('11288','2014-04-02','08:55:00',1.96),('11288','2014-04-02','09:00:00',1.31),('11288','2014-04-02','09:05:00',1.09),('11288','2014-04-02','09:10:00',1.3),('11288','2014-04-02','09:15:00',1.76),('11288','2014-04-02','09:20:00',1.41),('11288','2014-04-02','09:25:00',1.23),('11288','2014-04-02','09:30:00',1.27),('11288','2014-04-02','09:35:00',1.43),('11288','2014-04-02','09:40:00',1.31),('11288','2014-04-02','09:45:00',1.15),('11288','2014-04-02','09:50:00',2.06),('11288','2014-04-02','09:55:00',3.79),('11288','2014-04-02','10:00:00',3.24),('11288','2014-04-02','10:05:00',4.2),('11288','2014-04-02','10:10:00',5.12),('11288','2014-04-02','10:15:00',4.32),('11288','2014-04-02','10:20:00',3.63),('11288','2014-04-02','10:25:00',2.85),('11288','2014-04-02','10:30:00',1.98),('11288','2014-04-02','10:35:00',2.18),('11288','2014-04-02','10:40:00',2.22),('11288','2014-04-02','10:45:00',3.74),('11288','2014-04-02','10:50:00',5.51),('11288','2014-04-02','10:55:00',6.17),('11288','2014-04-02','11:00:00',3.06),('11288','2014-04-02','11:05:00',1.94),('11288','2014-04-02','11:10:00',2.24),('11288','2014-04-02','11:15:00',5.17),('11288','2014-04-02','11:20:00',5.64),('11288','2014-04-02','11:25:00',6.99),('11288','2014-04-02','11:30:00',5.84),('11288','2014-04-02','11:35:00',2.05),('11288','2014-04-02','11:40:00',1.93),('11288','2014-04-02','11:45:00',4.09),('11288','2014-04-02','11:50:00',5.62),('11288','2014-04-02','11:55:00',6.73),('11288','2014-04-02','12:00:00',4.51),('11288','2014-04-02','12:05:00',3.66),('11288','2014-04-02','12:10:00',2.46),('11288','2014-04-02','12:15:00',2.71),('11288','2014-04-02','12:20:00',5.01),('11288','2014-04-02','12:25:00',3.08),('11288','2014-04-02','12:30:00',7.71),('11288','2014-04-02','12:35:00',3.55),('11288','2014-04-02','12:40:00',7),('11288','2014-04-02','12:45:00',6.96),('11288','2014-04-02','12:50:00',5.68),('11288','2014-04-02','12:55:00',2.19),('11288','2014-04-02','13:00:00',7.01),('11288','2014-04-02','13:05:00',7.73),('11288','2014-04-02','13:10:00',7.53),('11288','2014-04-02','13:15:00',7.33),('11288','2014-04-02','13:20:00',6.89),('11288','2014-04-02','13:25:00',6.86),('11288','2014-04-02','13:30:00',6.92),('11288','2014-04-02','13:35:00',6.93),('11288','2014-04-02','13:40:00',6.9),('11288','2014-04-02','13:45:00',6.65),('11288','2014-04-02','13:50:00',6.63),('11288','2014-04-02','13:55:00',6.66),('11288','2014-04-02','14:00:00',6.54),('11288','2014-04-02','14:05:00',6.52),('11288','2014-04-02','14:10:00',5.85),('11288','2014-04-02','14:15:00',6.45),('11288','2014-04-02','14:20:00',6.45),('11288','2014-04-02','14:25:00',6.46),('11288','2014-04-02','14:30:00',6.36),('11288','2014-04-02','14:35:00',6.34),('11288','2014-04-02','14:40:00',6.23),('11288','2014-04-02','14:45:00',5.26),('11288','2014-04-02','14:50:00',5.36),('11288','2014-04-02','14:55:00',5.55),('11288','2014-04-02','15:00:00',5.67),('11288','2014-04-02','15:05:00',5.87),('11288','2014-04-02','15:10:00',5.48),('11288','2014-04-02','15:15:00',5.59),('11288','2014-04-02','15:20:00',5.57),('11288','2014-04-02','15:25:00',5.53),('11288','2014-04-02','15:30:00',5.15),('11288','2014-04-02','15:35:00',5.11),('11288','2014-04-02','15:40:00',5.17),('11288','2014-04-02','15:45:00',5.34),('11288','2014-04-02','15:50:00',5.21),('11288','2014-04-02','15:55:00',4.54),('11288','2014-04-02','16:00:00',4.75),('11288','2014-04-02','16:05:00',4.7),('11288','2014-04-02','16:10:00',4.54),('11288','2014-04-02','16:15:00',4.41),('11288','2014-04-02','16:20:00',4.29),('11288','2014-04-02','16:25:00',3.97),('11288','2014-04-02','16:30:00',4.19),('11288','2014-04-02','16:35:00',4.05),('11288','2014-04-02','16:40:00',3.88),('11288','2014-04-02','16:45:00',3.73),('11288','2014-04-02','16:50:00',3.43),('11288','2014-04-02','16:55:00',3.4),('11288','2014-04-02','17:00:00',3.38),('11288','2014-04-02','17:05:00',3.04),('11288','2014-04-02','17:10:00',2.88),('11288','2014-04-02','17:15:00',2.56),('11288','2014-04-02','17:20:00',2.56),('11288','2014-04-02','17:25:00',2.41),('11288','2014-04-02','17:30:00',2.13),('11288','2014-04-02','17:35:00',2.11),('11288','2014-04-02','17:40:00',1.54),('11288','2014-04-02','17:45:00',1.53),('11288','2014-04-02','17:50:00',1.93),('11288','2014-04-02','17:55:00',1.67),('11288','2014-04-02','18:00:00',1.52),('11288','2014-04-02','18:05:00',1.02),('11288','2013-05-31','07:05:00',1.01),('11288','2013-05-31','07:10:00',1.13),('11288','2013-05-31','07:15:00',1.22),('11288','2013-05-31','07:20:00',1.33),('11288','2013-05-31','07:25:00',1.47),('11288','2013-05-31','07:30:00',1.58),('11288','2013-05-31','07:35:00',1.68),('11288','2013-05-31','07:40:00',1.82),('11288','2013-05-31','07:45:00',1.86),('11288','2013-05-31','07:50:00',2.18),('11288','2013-05-31','07:55:00',2.39),('11288','2013-05-31','08:00:00',2.38),('11288','2013-05-31','08:05:00',2.59),('11288','2013-05-31','08:10:00',2.73),('11288','2013-05-31','08:15:00',2.56),('11288','2013-05-31','08:20:00',2.77),('11288','2013-05-31','08:25:00',3.24),('11288','2013-05-31','08:30:00',2.72),('11288','2013-05-31','08:35:00',3.7),('11288','2013-05-31','08:40:00',1.66),('11288','2013-05-31','08:45:00',3.27),('11288','2013-05-31','08:50:00',3.39),('11288','2013-05-31','08:55:00',2.14),('11288','2013-05-31','09:00:00',1.57),('11288','2013-05-31','09:05:00',1.33),('11288','2013-05-31','09:10:00',1.76),('11288','2013-05-31','09:15:00',1.66),('11288','2013-05-31','09:20:00',1.63),('11288','2013-05-31','09:25:00',1.89),('11288','2013-05-31','09:30:00',4.22),('11288','2013-05-31','09:35:00',4.29),('11288','2013-05-31','09:40:00',3.47),('11288','2013-05-31','09:45:00',6.06),('11288','2013-05-31','09:50:00',5.36),('11288','2013-05-31','09:55:00',5.52),('11288','2013-05-31','10:00:00',5.63),('11288','2013-05-31','10:05:00',5.53),('11288','2013-05-31','10:10:00',5.17),('11288','2013-05-31','10:15:00',6.62),('11288','2013-05-31','10:20:00',5.6),('11288','2013-05-31','10:25:00',2.95),('11288','2013-05-31','10:30:00',3.77),('11288','2013-05-31','10:35:00',3.92),('11288','2013-05-31','10:40:00',7.29),('11288','2013-05-31','10:45:00',6.22),('11288','2013-05-31','10:50:00',4.62),('11288','2013-05-31','10:55:00',6.73),('11288','2013-05-31','11:00:00',2.7),('11288','2013-05-31','11:05:00',5.41),('11288','2013-05-31','11:10:00',8.42),('11288','2013-05-31','11:15:00',7.21),('11288','2013-05-31','11:20:00',2.39),('11288','2013-05-31','11:25:00',4.23),('11288','2013-05-31','11:30:00',4.58),('11288','2013-05-31','11:35:00',4.63),('11288','2013-05-31','11:40:00',1.61),('11288','2013-05-31','11:45:00',8.02),('11288','2013-05-31','11:50:00',5.38),('11288','2013-05-31','11:55:00',6.73),('11288','2013-05-31','12:00:00',3.46),('11288','2013-05-31','12:05:00',8.74),('11288','2013-05-31','12:10:00',5.87),('11288','2013-05-31','12:15:00',2.85),('11288','2013-05-31','12:20:00',3.43),('11288','2013-05-31','12:25:00',6.22),('11288','2013-05-31','12:30:00',3.06),('11288','2013-05-31','12:35:00',3.6),('11288','2013-05-31','12:40:00',6.66),('11288','2013-05-31','12:45:00',3.11),('11288','2013-05-31','12:50:00',1.69),('11288','2013-05-31','12:55:00',2.82),('11288','2013-05-31','13:00:00',8.94),('11288','2013-05-31','13:05:00',2.8),('11288','2013-05-31','13:10:00',1.25),('11288','2013-05-31','13:15:00',1.39),('11288','2013-05-31','13:20:00',2.41),('11288','2013-05-31','13:25:00',3.53),('11288','2013-05-31','13:30:00',7.58),('11288','2013-05-31','13:35:00',8.79),('11288','2013-05-31','13:40:00',3.71),('11288','2013-05-31','13:45:00',2.2),('11288','2013-05-31','13:50:00',1.23),('11288','2013-05-31','13:55:00',3),('11288','2013-05-31','14:00:00',3.15),('11288','2013-05-31','14:05:00',1.7),('11288','2013-05-31','14:10:00',1.33),('11288','2013-05-31','14:15:00',1.36),('11288','2013-05-31','14:20:00',1.58),('11288','2013-05-31','14:25:00',1.94),('11288','2013-05-31','14:30:00',1.5),('11288','2013-05-31','14:45:00',1.32),('11288','2013-05-31','14:50:00',1.63),('11288','2013-05-31','14:55:00',1.11),('11288','2013-05-31','15:00:00',1.97),('11288','2013-05-31','15:05:00',3.13),('11288','2013-05-31','15:10:00',3.52),('11288','2013-05-31','15:15:00',5.74),('11288','2013-05-31','15:20:00',8.04),('11288','2013-05-31','15:25:00',5.64),('11288','2013-05-31','15:30:00',4.24),('11288','2013-05-31','15:35:00',3.66),('11288','2013-05-31','15:40:00',3.13),('11288','2013-05-31','15:45:00',2.99),('11288','2013-05-31','15:50:00',4.4),('11288','2013-05-31','15:55:00',4.02),('11288','2013-05-31','16:00:00',2.69),('11288','2013-05-31','16:05:00',2.41),('11288','2013-05-31','16:10:00',1.81),('11288','2013-05-31','16:15:00',1.71),('11288','2013-05-31','16:20:00',2.1),('11288','2013-05-31','16:25:00',2.54),('11288','2013-05-31','16:30:00',2.24),('11288','2013-05-31','16:35:00',1.96),('11288','2013-05-31','16:40:00',2.27),('11288','2013-05-31','16:45:00',2.23),('11288','2013-05-31','16:50:00',1.55),('11288','2013-05-31','16:55:00',1.2),('11288','2013-05-31','17:00:00',1.15),('11288','2013-05-31','17:05:00',1.14),('11288','2013-05-31','17:10:00',1.08),('11288','2013-05-31','17:15:00',1.18),('11288','2013-05-31','17:20:00',1.34),('11288','2013-05-31','17:25:00',1.45),('11288','2013-05-31','17:30:00',1.42),('11288','2013-05-31','17:35:00',1.16),('11288','2013-05-31','17:40:00',1.03),('11288','2013-05-31','17:45:00',1.09),('11288','2013-05-30','07:40:00',1.25),('11288','2013-05-30','07:45:00',1.77),('11288','2013-05-30','07:50:00',2.13),('11288','2013-05-30','07:55:00',1.47),('11288','2013-05-30','08:00:00',1.27),('11288','2013-05-30','08:10:00',1.29),('11288','2013-05-30','08:15:00',1.4),('11288','2013-05-30','08:20:00',1.72),('11288','2013-05-30','08:25:00',2.66),('11288','2013-05-30','08:30:00',1.69),('11288','2013-05-30','08:35:00',1.99),('11288','2013-05-30','08:40:00',3.93),('11288','2013-05-30','08:45:00',3.95),('11288','2013-05-30','08:50:00',4.02),('11288','2013-05-30','08:55:00',4.11),('11288','2013-05-30','09:00:00',4.06),('11288','2013-05-30','09:05:00',4.42),('11288','2013-05-30','09:10:00',4.58),('11288','2013-05-30','09:15:00',4.33),('11288','2013-05-30','09:20:00',4.92),('11288','2013-05-30','09:25:00',5.08),('11288','2013-05-30','09:30:00',4.76),('11288','2013-05-30','09:35:00',5.4),('11288','2013-05-30','09:40:00',5.65),('11288','2013-05-30','09:45:00',5.2),('11288','2013-05-30','09:50:00',5.92),('11288','2013-05-30','09:55:00',3.39),('11288','2013-05-30','10:00:00',2.46),('11288','2013-05-30','10:05:00',2.12),('11288','2013-05-30','10:10:00',5.08),('11288','2013-05-30','10:15:00',4.63),('11288','2013-05-30','10:20:00',6.47),('11288','2013-05-30','10:25:00',2.23),('11288','2013-05-30','10:30:00',3.88),('11288','2013-05-30','10:35:00',3.57),('11288','2013-05-30','10:40:00',6.48),('11288','2013-05-30','10:45:00',6.96),('11288','2013-05-30','10:50:00',4.37),('11288','2013-05-30','10:55:00',7.54),('11288','2013-05-30','11:00:00',8.13),('11288','2013-05-30','11:05:00',8.44),('11288','2013-05-30','11:10:00',2.69),('11288','2013-05-30','11:15:00',6.06),('11288','2013-05-30','11:20:00',5.87),('11288','2013-05-30','11:25:00',4.13),('11288','2013-05-30','11:30:00',8.65),('11288','2013-05-30','11:35:00',6.91),('11288','2013-05-30','11:40:00',8.31),('11288','2013-05-30','11:45:00',6.63),('11288','2013-05-30','11:50:00',6.44),('11288','2013-05-30','11:55:00',4.52),('11288','2013-05-30','12:00:00',8.67),('11288','2013-05-30','12:05:00',6.22),('11288','2013-05-30','12:10:00',4.61),('11288','2013-05-30','12:15:00',5.96),('11288','2013-05-30','12:20:00',5.11),('11288','2013-05-30','12:25:00',8.88),('11288','2013-05-30','12:30:00',6.09),('11288','2013-05-30','12:35:00',5.68),('11288','2013-05-30','12:40:00',7.83),('11288','2013-05-30','12:45:00',6.74),('11288','2013-05-30','12:50:00',7.83),('11288','2013-05-30','12:55:00',7.88),('11288','2013-05-30','13:00:00',8.81),('11288','2013-05-30','13:05:00',5.53),('11288','2013-05-30','13:10:00',5.04),('11288','2013-05-30','13:15:00',2.98),('11288','2013-05-30','13:20:00',3.61),('11288','2013-05-30','13:25:00',3.4),('11288','2013-05-30','13:30:00',3.68),('11288','2013-05-30','13:35:00',4.44),('11288','2013-05-30','13:40:00',7.65),('11288','2013-05-30','13:45:00',6.73),('11288','2013-05-30','13:50:00',2.61),('11288','2013-05-30','13:55:00',4.08),('11288','2013-05-30','14:00:00',7),('11288','2013-05-30','14:05:00',8.91),('11288','2013-05-30','14:10:00',8.23),('11288','2013-05-30','14:15:00',8.87),('11288','2013-05-30','14:20:00',5.88),('11288','2013-05-30','14:25:00',7.87),('11288','2013-05-30','14:30:00',6.06),('11288','2013-05-30','14:35:00',7.29),('11288','2013-05-30','14:40:00',8.06),('11288','2013-05-30','14:45:00',8.03),('11288','2013-05-30','14:50:00',7.92),('11288','2013-05-30','14:55:00',6.68),('11288','2013-05-30','15:00:00',7.23),('11288','2013-05-30','15:05:00',5.29),('11288','2013-05-30','15:10:00',4.1),('11288','2013-05-30','15:15:00',6.45),('11288','2013-05-30','15:20:00',7.71),('11288','2013-05-30','15:25:00',7.51),('11288','2013-05-30','15:30:00',6.02),('11288','2013-05-30','15:35:00',6.91),('11288','2013-05-30','15:40:00',6.88),('11288','2013-05-30','15:45:00',7.34),('11288','2013-05-30','15:50:00',3.65),('11288','2013-05-30','15:55:00',7.56),('11288','2013-05-30','16:00:00',7.01),('11288','2013-05-30','16:05:00',7.3),('11288','2013-05-30','16:10:00',6.78),('11288','2013-05-30','16:15:00',6.39),('11288','2013-05-30','16:20:00',5.89),('11288','2013-05-30','16:25:00',4.61),('11288','2013-05-30','16:30:00',3.71),('11288','2013-05-30','16:35:00',3.83),('11288','2013-05-30','16:40:00',1.88),('11288','2013-05-30','16:45:00',4.74),('11288','2013-05-30','16:50:00',4.27),('11288','2013-05-30','16:55:00',3.97),('11288','2013-05-30','17:00:00',2.64),('11288','2013-05-30','17:05:00',2.99),('11288','2013-05-30','17:10:00',1.52),('11288','2013-05-30','17:15:00',1.84),('11288','2013-05-30','17:20:00',2.53),('11288','2013-05-30','17:25:00',1.72),('11288','2013-05-30','17:30:00',2.16),('11288','2013-05-30','17:35:00',1.24),('11288','2013-05-30','17:55:00',1.11),('11288','2013-05-30','18:00:00',1.89),('11288','2013-05-30','18:05:00',1.89),('11288','2013-05-30','18:10:00',2.09),('11288','2013-05-30','18:15:00',1.49),('11288','2013-05-30','18:20:00',1.37),('11288','2013-05-30','18:25:00',1.46),('11288','2013-05-30','18:30:00',1.74),('11288','2013-05-30','18:35:00',2.44),('11288','2013-05-30','18:40:00',2.35),('11288','2013-05-30','18:45:00',2.73),('11288','2013-05-30','18:50:00',2.26),('11288','2013-05-30','18:55:00',1.22),('11288','2013-05-30','19:00:00',1.08),('11288','2013-05-29','07:10:00',1.03),('11288','2013-05-29','07:15:00',1.13),('11288','2013-05-29','07:20:00',1.21),('11288','2013-05-29','07:25:00',1.28),('11288','2013-05-29','07:30:00',1.44),('11288','2013-05-29','07:35:00',1.52),('11288','2013-05-29','07:40:00',1.64),('11288','2013-05-29','07:45:00',1.68),('11288','2013-05-29','07:50:00',1.98),('11288','2013-05-29','07:55:00',2.23),('11288','2013-05-29','08:00:00',2.1),('11288','2013-05-29','08:05:00',2.5),('11288','2013-05-29','08:10:00',2.62),('11288','2013-05-29','08:15:00',2.6),('11288','2013-05-29','08:20:00',2.9),('11288','2013-05-29','08:25:00',3.06),('11288','2013-05-29','08:30:00',3.18),('11288','2013-05-29','08:35:00',3.42),('11288','2013-05-29','08:40:00',3.46),('11288','2013-05-29','08:45:00',3.65),('11288','2013-05-29','08:50:00',3.89),('11288','2013-05-29','08:55:00',3.97),('11288','2013-05-29','09:00:00',4),('11288','2013-05-29','09:05:00',4.26),('11288','2013-05-29','09:10:00',4.35),('11288','2013-05-29','09:15:00',4.51),('11288','2013-05-29','09:20:00',4.78),('11288','2013-05-29','09:25:00',4.82),('11288','2013-05-29','09:30:00',4.82),('11288','2013-05-29','09:35:00',5.08),('11288','2013-05-29','09:40:00',5.32),('11288','2013-05-29','09:45:00',5.47),('11288','2013-05-29','09:50:00',5.6),('11288','2013-05-29','09:55:00',5.75),('11288','2013-05-29','10:00:00',5.79),('11288','2013-05-29','10:05:00',5.96),('11288','2013-05-29','10:10:00',6.05),('11288','2013-05-29','10:15:00',6.17),('11288','2013-05-29','10:20:00',6.36),('11288','2013-05-29','10:25:00',6.46),('11288','2013-05-29','10:30:00',6.53),('11288','2013-05-29','10:35:00',6.64),('11288','2013-05-29','10:40:00',6.79),('11288','2013-05-29','10:45:00',6.87),('11288','2013-05-29','10:50:00',7.04),('11288','2013-05-29','10:55:00',7.06),('11288','2013-05-29','11:00:00',7.16),('11288','2013-05-29','11:05:00',7.35),('11288','2013-05-29','11:10:00',6.93),('11288','2013-05-29','11:15:00',6.95),('11288','2013-05-29','11:20:00',7.72),('11288','2013-05-29','11:25:00',7.13),('11288','2013-05-29','11:30:00',7.12),('11288','2013-05-29','11:35:00',5.9),('11288','2013-05-29','11:40:00',7.46),('11288','2013-05-29','11:45:00',5.28),('11288','2013-05-29','11:50:00',7.14),('11288','2013-05-29','11:55:00',6.88),('11288','2013-05-29','12:00:00',5.68),('11288','2013-05-29','12:05:00',7.25),('11288','2013-05-29','12:10:00',7.79),('11288','2013-05-29','12:15:00',6.24),('11288','2013-05-29','12:20:00',8.01),('11288','2013-05-29','12:25:00',8.04),('11288','2013-05-29','12:30:00',7.91),('11288','2013-05-29','12:35:00',8.06),('11288','2013-05-29','12:40:00',7.53),('11288','2013-05-29','12:45:00',6.75),('11288','2013-05-29','12:50:00',7.52),('11288','2013-05-29','12:55:00',7.05),('11288','2013-05-29','13:00:00',7.95),('11288','2013-05-29','13:05:00',6.97),('11288','2013-05-29','13:10:00',7.72),('11288','2013-05-29','13:15:00',5.78),('11288','2013-05-29','13:20:00',6.94),('11288','2013-05-29','13:25:00',8.46),('11288','2013-05-29','13:30:00',8.3),('11288','2013-05-29','13:35:00',6.45),('11288','2013-05-29','13:40:00',8.22),('11288','2013-05-29','13:45:00',7.33),('11288','2013-05-29','13:50:00',7.06),('11288','2013-05-29','13:55:00',6.83),('11288','2013-05-29','14:00:00',7.98),('11288','2013-05-29','14:05:00',7.54),('11288','2013-05-29','14:10:00',7.58),('11288','2013-05-29','14:15:00',7.73),('11288','2013-05-29','14:20:00',7.52),('11288','2013-05-29','14:25:00',7.79),('11288','2013-05-29','14:30:00',7.67),('11288','2013-05-29','14:35:00',5.14),('11288','2013-05-29','14:40:00',7.84),('11288','2013-05-29','14:45:00',7.43),('11288','2013-05-29','14:50:00',6.44),('11288','2013-05-29','14:55:00',7.09),('11288','2013-05-29','15:00:00',7.37),('11288','2013-05-29','15:05:00',6.85),('11288','2013-05-29','15:10:00',5.25),('11288','2013-05-29','15:15:00',5.26),('11288','2013-05-29','15:20:00',6.7),('11288','2013-05-29','15:25:00',4.88),('11288','2013-05-29','15:30:00',5.89),('11288','2013-05-29','15:35:00',5.25),('11288','2013-05-29','15:40:00',4.68),('11288','2013-05-29','15:45:00',5.45),('11288','2013-05-29','15:50:00',5.36),('11288','2013-05-29','15:55:00',4.89),('11288','2013-05-29','16:00:00',4.74),('11288','2013-05-29','16:05:00',4.87),('11288','2013-05-29','16:10:00',4.16),('11288','2013-05-29','16:15:00',4.06),('11288','2013-05-29','16:20:00',3.98),('11288','2013-05-29','16:25:00',4.02),('11288','2013-05-29','16:30:00',3.32),('11288','2013-05-29','16:35:00',3.44),('11288','2013-05-29','16:40:00',4.13),('11288','2013-05-29','16:45:00',3.74),('11288','2013-05-29','16:50:00',2.91),('11288','2013-05-29','16:55:00',2.71),('11288','2013-05-29','17:00:00',2.45),('11288','2013-05-29','17:05:00',1.32),('11288','2013-05-29','17:25:00',1.13),('11288','2013-05-29','17:30:00',1.39),('11288','2013-05-29','17:35:00',2.17),('11288','2013-05-29','17:40:00',2.83),('11288','2013-05-29','17:45:00',2.07),('11288','2013-05-29','17:50:00',1.53),('11288','2013-05-29','17:55:00',1.25),('11288','2013-05-29','18:00:00',1.79),('11288','2013-05-29','18:05:00',2.05),('11288','2013-05-29','18:10:00',2.19),('11288','2013-05-29','18:15:00',3.74),('11288','2013-05-29','18:20:00',2.53),('11288','2013-05-29','18:25:00',1.13),('11288','2013-05-29','18:50:00',1.01),('11288','2013-05-29','19:05:00',1.26),('11288','2013-05-29','19:10:00',1.19),('11288','2013-05-29','19:15:00',1.24),('11288','2013-05-28','07:10:00',1.15),('11288','2013-05-28','07:15:00',1.56),('11288','2013-05-28','07:20:00',1.76),('11288','2013-05-28','07:25:00',1.85),('11288','2013-05-28','07:30:00',1.5),('11288','2013-05-28','07:35:00',1.53),('11288','2013-05-28','07:40:00',1.79),('11288','2013-05-28','07:45:00',2.05),('11288','2013-05-28','07:50:00',2.14),('11288','2013-05-28','07:55:00',2.1),('11288','2013-05-28','08:00:00',2.18),('11288','2013-05-28','08:05:00',2.33),('11288','2013-05-28','08:10:00',2.63),('11288','2013-05-28','08:15:00',2.9),('11288','2013-05-28','08:20:00',3.1),('11288','2013-05-28','08:25:00',2.81),('11288','2013-05-28','08:30:00',3.19),('11288','2013-05-28','08:35:00',3.01),('11288','2013-05-28','08:40:00',2.71),('11288','2013-05-28','08:45:00',2.65),('11288','2013-05-28','08:50:00',2.96),('11288','2013-05-28','08:55:00',2.91),('11288','2013-05-28','09:00:00',3.01),('11288','2013-05-28','09:05:00',3.36),('11288','2013-05-28','09:10:00',3.05),('11288','2013-05-28','09:15:00',2.95),('11288','2013-05-28','09:20:00',3.43),('11288','2013-05-28','09:25:00',3.77),('11288','2013-05-28','09:30:00',4.04),('11288','2013-05-28','09:35:00',4.1),('11288','2013-05-28','09:40:00',3.96),('11288','2013-05-28','09:45:00',3.81),('11288','2013-05-28','09:50:00',3.92),('11288','2013-05-28','09:55:00',4.21),('11288','2013-05-28','10:00:00',3.88),('11288','2013-05-28','10:05:00',4.2),('11288','2013-05-28','10:10:00',4.61),('11288','2013-05-28','10:15:00',4.82),('11288','2013-05-28','10:20:00',5.01),('11288','2013-05-28','10:25:00',4.99),('11288','2013-05-28','10:30:00',5.4),('11288','2013-05-28','10:35:00',5.51),('11288','2013-05-28','10:40:00',4.88),('11288','2013-05-28','10:45:00',4.7),('11288','2013-05-28','10:50:00',5.03),('11288','2013-05-28','10:55:00',4.37),('11288','2013-05-28','11:00:00',4.39),('11288','2013-05-28','11:05:00',4.46),('11288','2013-05-28','11:10:00',4.26),('11288','2013-05-28','11:15:00',4.4),('11288','2013-05-28','11:20:00',3.95),('11288','2013-05-28','11:25:00',4.36),('11288','2013-05-28','11:30:00',7.13),('11288','2013-05-28','11:35:00',5.74),('11288','2013-05-28','11:40:00',7.06),('11288','2013-05-28','11:45:00',5.39),('11288','2013-05-28','11:50:00',2.06),('11288','2013-05-28','11:55:00',3.1),('11288','2013-05-28','12:00:00',2.8),('11288','2013-05-28','12:05:00',3.57),('11288','2013-05-28','12:10:00',5.22),('11288','2013-05-28','12:15:00',4.72),('11288','2013-05-28','12:20:00',4.26),('11288','2013-05-28','12:25:00',4.45),('11288','2013-05-28','12:30:00',4.82),('11288','2013-05-28','12:35:00',4.68),('11288','2013-05-28','12:40:00',4.84),('11288','2013-05-28','12:45:00',5.35),('11288','2013-05-28','12:50:00',4.76),('11288','2013-05-28','12:55:00',4.88),('11288','2013-05-28','13:00:00',4.96),('11288','2013-05-28','13:05:00',5.35),('11288','2013-05-28','13:10:00',5.51),('11288','2013-05-28','13:15:00',4.89),('11288','2013-05-28','13:20:00',5.36),('11288','2013-05-28','13:25:00',3.24),('11288','2013-05-28','13:30:00',3.89),('11288','2013-05-28','13:35:00',3.29),('11288','2013-05-28','13:40:00',3.77),('11288','2013-05-28','13:45:00',3.68),('11288','2013-05-28','13:50:00',4.74),('11288','2013-05-28','13:55:00',4.64),('11288','2013-05-28','14:00:00',4.75),('11288','2013-05-28','14:05:00',4.98),('11288','2013-05-28','14:10:00',7.05),('11288','2013-05-28','14:15:00',6.41),('11288','2013-05-28','14:20:00',4.54),('11288','2013-05-28','14:25:00',4.91),('11288','2013-05-28','14:30:00',6.09),('11288','2013-05-28','14:35:00',5.17),('11288','2013-05-28','14:40:00',5.79),('11288','2013-05-28','14:45:00',6.38),('11288','2013-05-28','14:50:00',5.09),('11288','2013-05-28','14:55:00',4.9),('11288','2013-05-28','15:00:00',4.66),('11288','2013-05-28','15:05:00',6),('11288','2013-05-28','15:10:00',3),('11288','2013-05-28','15:15:00',4.86),('11288','2013-05-28','15:20:00',5.35),('11288','2013-05-28','15:25:00',3.98),('11288','2013-05-28','15:30:00',2.74),('11288','2013-05-28','15:35:00',2.85),('11288','2013-05-28','15:40:00',4.91),('11288','2013-05-28','15:45:00',6.34),('11288','2013-05-28','15:50:00',5.42),('11288','2013-05-28','15:55:00',3.73),('11288','2013-05-28','16:00:00',2.89),('11288','2013-05-28','16:05:00',2.49),('11288','2013-05-28','16:10:00',2.55),('11288','2013-05-28','16:15:00',3.05),('11288','2013-05-28','16:20:00',4.46),('11288','2013-05-28','16:25:00',3.71),('11288','2013-05-28','16:30:00',4.65),('11288','2013-05-28','16:35:00',5.41),('11288','2013-05-28','16:40:00',5),('11288','2013-05-28','16:45:00',4.77),('11288','2013-05-28','16:50:00',4.71),('11288','2013-05-28','16:55:00',4.58),('11288','2013-05-28','17:00:00',4.42),('11288','2013-05-28','17:05:00',4.33),('11288','2013-05-28','17:10:00',4.18),('11288','2013-05-28','17:15:00',4.07),('11288','2013-05-28','17:20:00',3.92),('11288','2013-05-28','17:25:00',3.74),('11288','2013-05-28','17:30:00',3.63),('11288','2013-05-28','17:35:00',3.42),('11288','2013-05-28','17:40:00',3.33),('11288','2013-05-28','17:45:00',3.24),('11288','2013-05-28','17:50:00',3.11),('11288','2013-05-28','17:55:00',2.9),('11288','2013-05-28','18:00:00',2.97),('11288','2013-05-28','18:05:00',2.74),('11288','2013-05-28','18:10:00',1.44),('11288','2013-05-28','18:15:00',1.07),('11288','2013-05-28','18:30:00',1.24),('11288','2013-05-28','18:35:00',1.93),('11288','2013-05-28','18:40:00',1.83),('11288','2013-05-28','18:45:00',1.67),('11288','2013-05-28','18:50:00',1.56),('11288','2013-05-28','18:55:00',1.43),('11288','2013-05-28','19:00:00',1.29),('11288','2013-05-28','19:05:00',1.16),('11288','2013-05-28','19:10:00',1.05),('11288','2013-05-27','07:05:00',1.03),('11288','2013-05-27','07:10:00',1.03),('11288','2013-05-27','07:25:00',1.27),('11288','2013-05-27','07:30:00',1.55),('11288','2013-05-27','07:35:00',1.55),('11288','2013-05-27','07:40:00',1.67),('11288','2013-05-27','07:45:00',1.85),('11288','2013-05-27','07:50:00',2.11),('11288','2013-05-27','07:55:00',1.39),('11288','2013-05-27','08:00:00',2.32),('11288','2013-05-27','08:05:00',2.79),('11288','2013-05-27','08:10:00',2.52),('11288','2013-05-27','08:15:00',2.93),('11288','2013-05-27','08:20:00',2.11),('11288','2013-05-27','08:25:00',3.18),('11288','2013-05-27','08:30:00',3.37),('11288','2013-05-27','08:35:00',3.58),('11288','2013-05-27','08:40:00',3.69),('11288','2013-05-27','08:45:00',3.82),('11288','2013-05-27','08:50:00',3.95),('11288','2013-05-27','08:55:00',4.43),('11288','2013-05-27','09:00:00',4.57),('11288','2013-05-27','09:05:00',5.09),('11288','2013-05-27','09:10:00',2.81),('11288','2013-05-27','09:15:00',4.09),('11288','2013-05-27','09:20:00',2.69),('11288','2013-05-27','09:25:00',3.67),('11288','2013-05-27','09:30:00',5.36),('11288','2013-05-27','09:35:00',5.34),('11288','2013-05-27','09:40:00',5.59),('11288','2013-05-27','09:45:00',5.28),('11288','2013-05-27','09:50:00',4.4),('11288','2013-05-27','09:55:00',5.65),('11288','2013-05-27','10:00:00',4.26),('11288','2013-05-27','10:05:00',6.37),('11288','2013-05-27','10:10:00',6.56),('11288','2013-05-27','10:15:00',4.88),('11288','2013-05-27','10:20:00',3.11),('11288','2013-05-27','10:25:00',5.64),('11288','2013-05-27','10:30:00',4.26),('11288','2013-05-27','10:35:00',4.68),('11288','2013-05-27','10:40:00',8.01),('11288','2013-05-27','10:45:00',5.23),('11288','2013-05-27','10:50:00',5.15),('11288','2013-05-27','10:55:00',2.57),('11288','2013-05-27','11:00:00',6.04),('11288','2013-05-27','11:05:00',6.19),('11288','2013-05-27','11:10:00',7.7),('11288','2013-05-27','11:15:00',4.48),('11288','2013-05-27','11:20:00',6.98),('11288','2013-05-27','11:25:00',7.42),('11288','2013-05-27','11:30:00',5.53),('11288','2013-05-27','11:35:00',4.05),('11288','2013-05-27','11:40:00',7.3),('11288','2013-05-27','11:45:00',4.22),('11288','2013-05-27','11:50:00',4.83),('11288','2013-05-27','11:55:00',5.97),('11288','2013-05-27','12:00:00',7.71),('11288','2013-05-27','12:05:00',3.49),('11288','2013-05-27','12:10:00',8.78),('11288','2013-05-27','12:15:00',6.3),('11288','2013-05-27','12:20:00',8.04),('11288','2013-05-27','12:25:00',7.06),('11288','2013-05-27','12:30:00',7.91),('11288','2013-05-27','12:35:00',7.17),('11288','2013-05-27','12:40:00',8.64),('11288','2013-05-27','12:45:00',5.36),('11288','2013-05-27','12:50:00',7.35),('11288','2013-05-27','12:55:00',5.2),('11288','2013-05-27','13:00:00',3.33),('11288','2013-05-27','13:05:00',5.65),('11288','2013-05-27','13:10:00',7.46),('11288','2013-05-27','13:15:00',2.53),('11288','2013-05-27','13:20:00',8.36),('11288','2013-05-27','13:25:00',7.09),('11288','2013-05-27','13:30:00',7.87),('11288','2013-05-27','13:35:00',7.1),('11288','2013-05-27','13:40:00',8.26),('11288','2013-05-27','13:45:00',6.49),('11288','2013-05-27','13:50:00',8.2),('11288','2013-05-27','13:55:00',7.89),('11288','2013-05-27','14:00:00',7.56),('11288','2013-05-27','14:05:00',6.82),('11288','2013-05-27','14:10:00',7.22),('11288','2013-05-27','14:15:00',6.23),('11288','2013-05-27','14:20:00',5.93),('11288','2013-05-27','14:25:00',7.19),('11288','2013-05-27','14:30:00',7.81),('11288','2013-05-27','14:35:00',6.65),('11288','2013-05-27','14:40:00',6.01),('11288','2013-05-27','14:45:00',7.92),('11288','2013-05-27','14:50:00',7.64),('11288','2013-05-27','14:55:00',6.41),('11288','2013-05-27','15:00:00',4.94),('11288','2013-05-27','15:05:00',4.88),('11288','2013-05-27','15:10:00',7.48),('11288','2013-05-27','15:15:00',5.17),('11288','2013-05-27','15:20:00',6.73),('11288','2013-05-27','15:25:00',5.78),('11288','2013-05-27','15:30:00',6.61),('11288','2013-05-27','15:35:00',7.16),('11288','2013-05-27','15:40:00',6.14),('11288','2013-05-27','15:45:00',5.58),('11288','2013-05-27','15:50:00',6.79),('11288','2013-05-27','15:55:00',4.61),('11288','2013-05-27','16:00:00',5.37),('11288','2013-05-27','16:05:00',3.99),('11288','2013-05-27','16:10:00',4.31),('11288','2013-05-27','16:15:00',4.12),('11288','2013-05-27','16:20:00',6.69),('11288','2013-05-27','16:25:00',6.28),('11288','2013-05-27','16:30:00',5.87),('11288','2013-05-27','16:35:00',4.72),('11288','2013-05-27','16:40:00',2.5),('11288','2013-05-27','16:45:00',2.28),('11288','2013-05-27','16:50:00',2.38),('11288','2013-05-27','16:55:00',2.53),('11288','2013-05-27','17:00:00',2.64),('11288','2013-05-27','17:05:00',2.75),('11288','2013-05-27','17:10:00',3.33),('11288','2013-05-27','17:15:00',2.73),('11288','2013-05-27','17:20:00',2.38),('11288','2013-05-27','17:25:00',2.19),('11288','2013-05-27','17:30:00',2.14),('11288','2013-05-27','17:35:00',1.99),('11288','2013-05-27','17:40:00',1.85),('11288','2013-05-27','17:45:00',1.74),('11288','2013-05-27','17:50:00',1.66),('11288','2013-05-27','17:55:00',1.69),('11288','2013-05-27','18:00:00',1.66),('11288','2013-05-27','18:05:00',1.5),('11288','2013-05-27','18:10:00',1.61),('11288','2013-05-27','18:15:00',1.8),('11288','2013-05-27','18:20:00',2.35),('11288','2013-05-27','18:25:00',3.27),('11288','2013-05-27','18:30:00',2.66),('11288','2013-05-27','18:35:00',1.75),('11288','2013-05-27','18:40:00',1.4),('11288','2013-05-27','18:45:00',1.9),('11288','2013-05-27','18:50:00',1.36),('11288','2013-05-27','18:55:00',1.91),('11288','2013-05-27','19:00:00',2.01),('11288','2013-05-27','19:05:00',1.89),('11288','2013-05-27','19:10:00',1.67),('11288','2013-05-27','19:15:00',1.25),('11288','2013-05-27','19:20:00',1.1),('11288','2013-05-27','19:25:00',1.09),('11288','2013-05-27','19:30:00',1.11),('11288','2013-05-26','07:20:00',1.73),('11288','2013-05-26','07:35:00',1.52),('11288','2013-05-26','07:40:00',1.66),('11288','2013-05-26','07:45:00',2.2),('11288','2013-05-26','07:50:00',3.31),('11288','2013-05-26','08:00:00',1.37),('11288','2013-05-26','08:05:00',3.18),('11288','2013-05-26','08:10:00',2.6),('11288','2013-05-26','08:15:00',1.27),('11288','2013-05-26','08:20:00',1.74),('11288','2013-05-26','08:25:00',2.32),('11288','2013-05-26','08:30:00',3.53),('11288','2013-05-26','08:35:00',2.61),('11288','2013-05-26','08:40:00',3.56),('11288','2013-05-26','08:45:00',4.77),('11288','2013-05-26','08:50:00',4.56),('11288','2013-05-26','08:55:00',2.03),('11288','2013-05-26','09:00:00',2.66),('11288','2013-05-26','09:05:00',1.5),('11288','2013-05-26','09:10:00',4.62),('11288','2013-05-26','09:15:00',2.14),('11288','2013-05-26','09:20:00',1.59),('11288','2013-05-26','09:25:00',2.38),('11288','2013-05-26','09:30:00',1.46),('11288','2013-05-26','09:35:00',2.13),('11288','2013-05-26','09:40:00',2.79),('11288','2013-05-26','09:45:00',3.1),('11288','2013-05-26','09:50:00',1.32),('11288','2013-05-26','09:55:00',2.78),('11288','2013-05-26','10:00:00',1.64),('11288','2013-05-26','10:05:00',5.83),('11288','2013-05-26','10:10:00',6.58),('11288','2013-05-26','10:15:00',3.11),('11288','2013-05-26','10:20:00',5.68),('11288','2013-05-26','10:25:00',5.99),('11288','2013-05-26','10:30:00',7.1),('11288','2013-05-26','10:35:00',7.42),('11288','2013-05-26','10:40:00',7.21),('11288','2013-05-26','10:45:00',7.33),('11288','2013-05-26','10:50:00',7.58),('11288','2013-05-26','10:55:00',6.26),('11288','2013-05-26','11:00:00',7.27),('11288','2013-05-26','11:05:00',7.61),('11288','2013-05-26','11:10:00',7.65),('11288','2013-05-26','11:15:00',7.64),('11288','2013-05-26','11:20:00',7.59),('11288','2013-05-26','11:25:00',7.79),('11288','2013-05-26','11:30:00',7.79),('11288','2013-05-26','11:35:00',7.44),('11288','2013-05-26','11:40:00',7.73),('11288','2013-05-26','11:45:00',6.72),('11288','2013-05-26','11:50:00',8.07),('11288','2013-05-26','11:55:00',7.08),('11288','2013-05-26','12:00:00',8.1),('11288','2013-05-26','12:05:00',8.2),('11288','2013-05-26','12:10:00',5.87),('11288','2013-05-26','12:15:00',4.95),('11288','2013-05-26','12:20:00',6.39),('11288','2013-05-26','12:25:00',8.38),('11288','2013-05-26','12:30:00',8.37),('11288','2013-05-26','12:35:00',8.46),('11288','2013-05-26','12:40:00',8.8),('11288','2013-05-26','12:45:00',8.57),('11288','2013-05-26','12:50:00',8.25),('11288','2013-05-26','12:55:00',8.16),('11288','2013-05-26','13:00:00',7.39),('11288','2013-05-26','13:05:00',8.31),('11288','2013-05-26','13:10:00',8.34),('11288','2013-05-26','13:15:00',8.4),('11288','2013-05-26','13:20:00',8.34),('11288','2013-05-26','13:25:00',8.21),('11288','2013-05-26','13:30:00',7.83),('11288','2013-05-26','13:35:00',8.22),('11288','2013-05-26','13:40:00',8.15),('11288','2013-05-26','13:45:00',8.12),('11288','2013-05-26','13:50:00',8.07),('11288','2013-05-26','13:55:00',7.96),('11288','2013-05-26','14:00:00',8.05),('11288','2013-05-26','14:05:00',7.92),('11288','2013-05-26','14:10:00',7.89),('11288','2013-05-26','14:15:00',7.85),('11288','2013-05-26','14:20:00',7.8),('11288','2013-05-26','14:25:00',7.74),('11288','2013-05-26','14:30:00',7.61),('11288','2013-05-26','14:35:00',7.68),('11288','2013-05-26','14:40:00',7.65),('11288','2013-05-26','14:45:00',7.57),('11288','2013-05-26','14:50:00',7.52),('11288','2013-05-26','14:55:00',7.42),('11288','2013-05-26','15:00:00',7.36),('11288','2013-05-26','15:05:00',7.33),('11288','2013-05-26','15:10:00',7.27),('11288','2013-05-26','15:15:00',7.2),('11288','2013-05-26','15:20:00',7.17),('11288','2013-05-26','15:25:00',7.09),('11288','2013-05-26','15:30:00',7.05),('11288','2013-05-26','15:35:00',6.96),('11288','2013-05-26','15:40:00',6.87),('11288','2013-05-26','15:45:00',6.76),('11288','2013-05-26','15:50:00',6.68),('11288','2013-05-26','15:55:00',6.58),('11288','2013-05-26','16:00:00',6.49),('11288','2013-05-26','16:05:00',6.42),('11288','2013-05-26','16:10:00',6.29),('11288','2013-05-26','16:15:00',6.13),('11288','2013-05-26','16:20:00',6.06),('11288','2013-05-26','16:25:00',5.96),('11288','2013-05-26','16:30:00',5.8),('11288','2013-05-26','16:35:00',5.64),('11288','2013-05-26','16:40:00',5.53),('11288','2013-05-26','16:45:00',5.34),('11288','2013-05-26','16:50:00',5.26),('11288','2013-05-26','16:55:00',5.09),('11288','2013-05-26','17:00:00',4.98),('11288','2013-05-26','17:05:00',4.87),('11288','2013-05-26','17:10:00',4.7),('11288','2013-05-26','17:15:00',4.54),('11288','2013-05-26','17:20:00',4.41),('11288','2013-05-26','17:25:00',4.29),('11288','2013-05-26','17:30:00',4.12),('11288','2013-05-26','17:35:00',3.9),('11288','2013-05-26','17:40:00',3.81),('11288','2013-05-26','17:45:00',3.79),('11288','2013-05-26','17:50:00',3.61),('11288','2013-05-26','17:55:00',3.35),('11288','2013-05-26','18:00:00',3.29),('11288','2013-05-26','18:05:00',3.15),('11288','2013-05-26','18:10:00',3),('11288','2013-05-26','18:15:00',2.84),('11288','2013-05-26','18:20:00',2.68),('11288','2013-05-26','18:25:00',2.54),('11288','2013-05-26','18:30:00',2.36),('11288','2013-05-26','18:35:00',2.2),('11288','2013-05-26','18:40:00',2.05),('11288','2013-05-26','18:45:00',1.91),('11288','2013-05-26','18:50:00',1.77),('11288','2013-05-26','18:55:00',1.6),('11288','2013-05-26','19:00:00',1.42),('11288','2013-05-26','19:05:00',1.26),('11288','2013-05-26','19:10:00',1.15),('11288','2013-05-26','19:15:00',1.03),('11288','2013-05-25','07:15:00',1.32),('11288','2013-05-25','07:20:00',1.06),('11288','2013-05-25','07:25:00',1.22),('11288','2013-05-25','07:30:00',1.71),('11288','2013-05-25','07:35:00',2.53),('11288','2013-05-25','07:40:00',1.91),('11288','2013-05-25','07:50:00',1.37),('11288','2013-05-25','07:55:00',2.54),('11288','2013-05-25','08:00:00',3.27),('11288','2013-05-25','08:05:00',3.05),('11288','2013-05-25','08:10:00',2.08),('11288','2013-05-25','08:15:00',1.17),('11288','2013-05-25','08:20:00',2.87),('11288','2013-05-25','08:25:00',4.01),('11288','2013-05-25','08:30:00',4.15),('11288','2013-05-25','08:35:00',2.37),('11288','2013-05-25','08:40:00',2.76),('11288','2013-05-25','08:45:00',2.2),('11288','2013-05-25','08:50:00',3.38),('11288','2013-05-25','08:55:00',2.38),('11288','2013-05-25','09:00:00',4.1),('11288','2013-05-25','09:05:00',4.81),('11288','2013-05-25','09:10:00',5.14),('11288','2013-05-25','09:15:00',5.75),('11288','2013-05-25','09:20:00',2.63),('11288','2013-05-25','09:25:00',2.66),('11288','2013-05-25','09:30:00',1.85),('11288','2013-05-25','09:35:00',4.52),('11288','2013-05-25','09:40:00',6.08),('11288','2013-05-25','09:45:00',4.82),('11288','2013-05-25','09:50:00',6.06),('11288','2013-05-25','09:55:00',3.46),('11288','2013-05-25','10:00:00',1.6),('11288','2013-05-25','10:05:00',1.37),('11288','2013-05-25','10:10:00',2.26),('11288','2013-05-25','10:15:00',1.75),('11288','2013-05-25','10:20:00',1.01),('11288','2013-05-25','10:25:00',1.79),('11288','2013-05-25','10:30:00',1.68),('11288','2013-05-25','10:35:00',1.7),('11288','2013-05-25','10:40:00',3.02),('11288','2013-05-25','10:45:00',2.56),('11288','2013-05-25','10:50:00',2.49),('11288','2013-05-25','10:55:00',1.4),('11288','2013-05-25','11:00:00',2.39),('11288','2013-05-25','11:05:00',4.2),('11288','2013-05-25','11:10:00',7.46),('11288','2013-05-25','11:15:00',7.86),('11288','2013-05-25','11:20:00',3.83),('11288','2013-05-25','11:25:00',1.68),('11288','2013-05-25','11:30:00',1.01),('11288','2013-05-25','11:35:00',3.51),('11288','2013-05-25','11:40:00',3.42),('11288','2013-05-25','11:45:00',4.41),('11288','2013-05-25','11:50:00',3.88),('11288','2013-05-25','11:55:00',3.5),('11288','2013-05-25','12:00:00',3.03),('11288','2013-05-25','12:05:00',2.58),('11288','2013-05-25','12:10:00',3.18),('11288','2013-05-25','12:15:00',2.26),('11288','2013-05-25','12:20:00',2.92),('11288','2013-05-25','12:25:00',3.61),('11288','2013-05-25','12:30:00',2.44),('11288','2013-05-25','12:35:00',2.87),('11288','2013-05-25','12:40:00',3.35),('11288','2013-05-25','12:45:00',3.2),('11288','2013-05-25','12:50:00',2.64),('11288','2013-05-25','12:55:00',3.91),('11288','2013-05-25','13:00:00',2.01),('11288','2013-05-25','13:05:00',3.03),('11288','2013-05-25','13:10:00',2.68),('11288','2013-05-25','13:15:00',3.52),('11288','2013-05-25','13:20:00',3.59),('11288','2013-05-25','13:25:00',6.91),('11288','2013-05-25','13:30:00',2.4),('11288','2013-05-25','13:35:00',2.71),('11288','2013-05-25','13:40:00',3.98),('11288','2013-05-25','13:45:00',3.46),('11288','2013-05-25','13:50:00',4.49),('11288','2013-05-25','13:55:00',6.44),('11288','2013-05-25','14:00:00',5.8),('11288','2013-05-25','14:05:00',6.94),('11288','2013-05-25','14:10:00',8.19),('11288','2013-05-25','14:15:00',6.16),('11288','2013-05-25','14:20:00',6.95),('11288','2013-05-25','14:25:00',7.42),('11288','2013-05-25','14:30:00',5.67),('11288','2013-05-25','14:35:00',5.05),('11288','2013-05-25','14:40:00',2.33),('11288','2013-05-25','14:45:00',4.58),('11288','2013-05-25','14:50:00',2.21),('11288','2013-05-25','14:55:00',3.2),('11288','2013-05-25','15:00:00',7.51),('11288','2013-05-25','15:05:00',3.66),('11288','2013-05-25','15:10:00',3.97),('11288','2013-05-25','15:15:00',4.36),('11288','2013-05-25','15:20:00',2.98),('11288','2013-05-25','15:25:00',5.53),('11288','2013-05-25','15:30:00',5.78),('11288','2013-05-25','15:35:00',7.79),('11288','2013-05-25','15:40:00',6.81),('11288','2013-05-25','15:45:00',6.68),('11288','2013-05-25','15:50:00',7.49),('11288','2013-05-25','15:55:00',6.35),('11288','2013-05-25','16:00:00',4.51),('11288','2013-05-25','16:05:00',3.83),('11288','2013-05-25','16:10:00',6.67),('11288','2013-05-25','16:15:00',4.09),('11288','2013-05-25','16:20:00',2.54),('11288','2013-05-25','16:25:00',3.39),('11288','2013-05-25','16:30:00',4.89),('11288','2013-05-25','16:35:00',4.44),('11288','2013-05-25','16:40:00',5.66),('11288','2013-05-25','16:45:00',5.84),('11288','2013-05-25','16:50:00',2.6),('11288','2013-05-25','16:55:00',2.08),('11288','2013-05-25','17:00:00',1.64),('11288','2013-05-25','17:05:00',3.65),('11288','2013-05-25','17:10:00',4.34),('11288','2013-05-25','17:15:00',3.04),('11288','2013-05-25','17:20:00',3.29),('11288','2013-05-25','17:25:00',1.82),('11288','2013-05-25','17:30:00',1.68),('11288','2013-05-25','17:35:00',2.63),('11288','2013-05-25','17:40:00',1.79),('11288','2013-05-25','17:45:00',3.11),('11288','2013-05-25','17:50:00',2.16),('11288','2013-05-25','17:55:00',1.6),('11288','2013-05-25','18:00:00',1.63),('11288','2013-05-25','18:05:00',1.43),('11288','2013-05-25','18:10:00',1.92),('11288','2013-05-25','18:15:00',1.36),('11288','2013-05-25','18:20:00',1.68),('11288','2013-05-25','18:35:00',1.08),('11288','2013-05-24','07:00:00',1.41),('11288','2013-05-24','07:40:00',1.17),('11288','2013-05-24','07:50:00',1.01),('11288','2013-05-24','08:00:00',1.92),('11288','2013-05-24','08:05:00',2.69),('11288','2013-05-24','08:10:00',3.39),('11288','2013-05-24','08:15:00',3.26),('11288','2013-05-24','08:20:00',1.25),('11288','2013-05-24','08:25:00',2.44),('11288','2013-05-24','08:30:00',3.69),('11288','2013-05-24','08:35:00',2.04),('11288','2013-05-24','08:40:00',2.2),('11288','2013-05-24','08:45:00',3.27),('11288','2013-05-24','08:50:00',3.79),('11288','2013-05-24','08:55:00',4.17),('11288','2013-05-24','09:00:00',4.7),('11288','2013-05-24','09:05:00',5.23),('11288','2013-05-24','09:10:00',1.02),('11288','2013-05-24','09:15:00',1.49),('11288','2013-05-24','09:20:00',4.63),('11288','2013-05-24','09:25:00',2.77),('11288','2013-05-24','09:30:00',2.67),('11288','2013-05-24','09:35:00',1.4),('11288','2013-05-24','09:40:00',2.99),('11288','2013-05-24','09:45:00',2.26),('11288','2013-05-24','09:50:00',2.55),('11288','2013-05-24','09:55:00',6.03),('11288','2013-05-24','10:00:00',1.84),('11288','2013-05-24','10:05:00',1.52),('11288','2013-05-24','10:10:00',1.18),('11288','2013-05-24','10:20:00',2.67),('11288','2013-05-24','10:25:00',4.64),('11288','2013-05-24','10:30:00',6.8),('11288','2013-05-24','10:35:00',6.95),('11288','2013-05-24','10:40:00',6.4),('11288','2013-05-24','10:45:00',6.97),('11288','2013-05-24','10:50:00',4.62),('11288','2013-05-24','10:55:00',6.19),('11288','2013-05-24','11:00:00',5.01),('11288','2013-05-24','11:05:00',6.47),('11288','2013-05-24','11:10:00',7.66),('11288','2013-05-24','11:15:00',6.68),('11288','2013-05-24','11:20:00',7.5),('11288','2013-05-24','11:25:00',8.05),('11288','2013-05-24','11:30:00',4.16),('11288','2013-05-24','11:35:00',2.33),('11288','2013-05-24','11:40:00',1.76),('11288','2013-05-24','11:45:00',5.7),('11288','2013-05-24','11:50:00',8.64),('11288','2013-05-24','11:55:00',5.46),('11288','2013-05-24','12:00:00',4.63),('11288','2013-05-24','12:05:00',4.5),('11288','2013-05-24','12:10:00',6.41),('11288','2013-05-24','12:15:00',4.14),('11288','2013-05-24','12:20:00',4.12),('11288','2013-05-24','12:25:00',7.36),('11288','2013-05-24','12:30:00',7.87),('11288','2013-05-24','12:35:00',4.08),('11288','2013-05-24','12:40:00',4.82),('11288','2013-05-24','12:45:00',6.81),('11288','2013-05-24','12:50:00',5.16),('11288','2013-05-24','12:55:00',4.89),('11288','2013-05-24','13:00:00',4.38),('11288','2013-05-24','13:05:00',3.98),('11288','2013-05-24','13:10:00',4.77),('11288','2013-05-24','13:15:00',5.16),('11288','2013-05-24','13:20:00',5.43),('11288','2013-05-24','13:25:00',4.38),('11288','2013-05-24','13:30:00',4.12),('11288','2013-05-24','13:35:00',4.59),('11288','2013-05-24','13:40:00',3.96),('11288','2013-05-24','13:45:00',2.07),('11288','2013-05-24','13:50:00',2.55),('11288','2013-05-24','13:55:00',5.06),('11288','2013-05-24','14:00:00',3.97),('11288','2013-05-24','14:05:00',3.23),('11288','2013-05-24','14:10:00',2.6),('11288','2013-05-24','14:15:00',6.48),('11288','2013-05-24','14:20:00',5.51),('11288','2013-05-24','14:25:00',7.69),('11288','2013-05-24','14:30:00',4.12),('11288','2013-05-24','14:35:00',6.14),('11288','2013-05-24','14:40:00',3.63),('11288','2013-05-24','14:45:00',4.8),('11288','2013-05-24','14:50:00',2.57),('11288','2013-05-24','14:55:00',3.07),('11288','2013-05-24','15:00:00',5.32),('11288','2013-05-24','15:05:00',7.29),('11288','2013-05-24','15:10:00',5.23),('11288','2013-05-24','15:15:00',6.51),('11288','2013-05-24','15:20:00',6.77),('11288','2013-05-24','15:25:00',5.87),('11288','2013-05-24','15:30:00',7.63),('11288','2013-05-24','15:35:00',6.44),('11288','2013-05-24','15:40:00',5.74),('11288','2013-05-24','15:45:00',7.13),('11288','2013-05-24','15:50:00',8.37),('11288','2013-05-24','15:55:00',7.91),('11288','2013-05-24','16:00:00',3.85),('11288','2013-05-24','16:05:00',3.95),('11288','2013-05-24','16:10:00',4.24),('11288','2013-05-24','16:15:00',5.3),('11288','2013-05-24','16:20:00',3.83),('11288','2013-05-24','16:25:00',5.19),('11288','2013-05-24','16:30:00',4.61),('11288','2013-05-24','16:35:00',2.62),('11288','2013-05-24','16:40:00',1.18),('11288','2013-05-24','16:45:00',1.19),('11288','2013-05-24','16:50:00',2.8),('11288','2013-05-24','16:55:00',3.33),('11288','2013-05-24','17:00:00',2.49),('11288','2013-05-24','17:05:00',1.85),('11288','2013-05-24','17:10:00',1.48),('11288','2013-05-24','17:15:00',1.52),('11288','2013-05-24','17:20:00',1.93),('11288','2013-05-24','17:25:00',1.97),('11288','2013-05-24','17:30:00',2.07),('11288','2013-05-24','17:35:00',2.09),('11288','2013-05-24','17:40:00',1.79),('11288','2013-05-24','17:45:00',1.52),('11288','2013-05-24','17:50:00',1.1),('11288','2013-05-24','18:05:00',1.07),('11288','2013-05-24','18:10:00',1.06),('11288','2013-05-23','07:05:00',1.11),('11288','2013-05-23','07:10:00',1.52),('11288','2013-05-23','07:45:00',1.28),('11288','2013-05-23','07:50:00',1.66),('11288','2013-05-23','07:55:00',1.84),('11288','2013-05-23','08:00:00',2.17),('11288','2013-05-23','08:05:00',2.96),('11288','2013-05-23','08:10:00',1.6),('11288','2013-05-23','08:25:00',1.59),('11288','2013-05-23','08:30:00',3.8),('11288','2013-05-23','08:35:00',3.43),('11288','2013-05-23','08:40:00',3.86),('11288','2013-05-23','08:45:00',2.79),('11288','2013-05-23','08:50:00',1.23),('11288','2013-05-23','08:55:00',2.31),('11288','2013-05-23','09:00:00',4.87),('11288','2013-05-23','09:05:00',2.35),('11288','2013-05-23','09:15:00',2.27),('11288','2013-05-23','09:20:00',2.86),('11288','2013-05-23','09:25:00',5.63),('11288','2013-05-23','09:30:00',5.81),('11288','2013-05-23','09:35:00',4.94),('11288','2013-05-23','09:40:00',4.79),('11288','2013-05-23','09:45:00',2.72),('11288','2013-05-23','09:50:00',4.39),('11288','2013-05-23','09:55:00',2.92),('11288','2013-05-23','10:00:00',2.19),('11288','2013-05-23','10:05:00',6.74),('11288','2013-05-23','10:10:00',5.59),('11288','2013-05-23','10:15:00',7.01),('11288','2013-05-23','10:20:00',3.87),('11288','2013-05-23','10:25:00',6.61),('11288','2013-05-23','10:30:00',5.91),('11288','2013-05-23','10:35:00',6.57),('11288','2013-05-23','10:40:00',5.95),('11288','2013-05-23','10:45:00',7.13),('11288','2013-05-23','10:50:00',4.65),('11288','2013-05-23','10:55:00',6.43),('11288','2013-05-23','11:00:00',4.51),('11288','2013-05-23','11:05:00',6.08),('11288','2013-05-23','11:10:00',3.82),('11288','2013-05-23','11:15:00',3.97),('11288','2013-05-23','11:20:00',2.86),('11288','2013-05-23','11:25:00',4.87),('11288','2013-05-23','11:30:00',5.29),('11288','2013-05-23','11:35:00',7.01),('11288','2013-05-23','11:40:00',7.88),('11288','2013-05-23','11:45:00',4.1),('11288','2013-05-23','11:50:00',7.12),('11288','2013-05-23','11:55:00',8.59),('11288','2013-05-23','12:00:00',7.42),('11288','2013-05-23','12:05:00',8.22),('11288','2013-05-23','12:10:00',7.69),('11288','2013-05-23','12:15:00',4.48),('11288','2013-05-23','12:20:00',6.83),('11288','2013-05-23','12:25:00',8.16),('11288','2013-05-23','12:30:00',7.76),('11288','2013-05-23','12:35:00',3.32),('11288','2013-05-23','12:40:00',9.53),('11288','2013-05-23','12:45:00',5.47),('11288','2013-05-23','12:50:00',7.03),('11288','2013-05-23','12:55:00',8.22),('11288','2013-05-23','13:00:00',7.65),('11288','2013-05-23','13:05:00',5.82),('11288','2013-05-23','13:10:00',6.97),('11288','2013-05-23','13:15:00',6.96),('11288','2013-05-23','13:20:00',6.44),('11288','2013-05-23','13:25:00',7.18),('11288','2013-05-23','13:30:00',5.66),('11288','2013-05-23','13:35:00',3.9),('11288','2013-05-23','13:40:00',4.82),('11288','2013-05-23','13:45:00',6.11),('11288','2013-05-23','13:50:00',6.26),('11288','2013-05-23','13:55:00',7.81),('11288','2013-05-23','14:00:00',7.21),('11288','2013-05-23','14:05:00',8.2),('11288','2013-05-23','14:10:00',7.9),('11288','2013-05-23','14:15:00',6.25),('11288','2013-05-23','14:20:00',7.42),('11288','2013-05-23','14:25:00',5.58),('11288','2013-05-23','14:30:00',4.04),('11288','2013-05-23','14:35:00',8.47),('11288','2013-05-23','14:40:00',6.26),('11288','2013-05-23','14:45:00',3.56),('11288','2013-05-23','14:50:00',4.14),('11288','2013-05-23','14:55:00',6.24),('11288','2013-05-23','15:00:00',4.53),('11288','2013-05-23','15:05:00',4.08),('11288','2013-05-23','15:10:00',2.53),('11288','2013-05-23','15:15:00',3.32),('11288','2013-05-23','15:20:00',5.11),('11288','2013-05-23','15:25:00',2.39),('11288','2013-05-23','15:30:00',6.76),('11288','2013-05-23','15:35:00',5.13),('11288','2013-05-23','15:40:00',3.13),('11288','2013-05-23','15:45:00',3.88),('11288','2013-05-23','15:50:00',2.3),('11288','2013-05-23','15:55:00',3.96),('11288','2013-05-23','16:00:00',5.03),('11288','2013-05-23','16:05:00',6.77),('11288','2013-05-23','16:10:00',3.55),('11288','2013-05-23','16:15:00',5.2),('11288','2013-05-23','16:20:00',5.04),('11288','2013-05-23','16:25:00',5.28),('11288','2013-05-23','16:30:00',4.93),('11288','2013-05-23','16:35:00',2.57),('11288','2013-05-23','16:40:00',2.14),('11288','2013-05-23','16:45:00',3.5),('11288','2013-05-23','16:50:00',1.74),('11288','2013-05-23','16:55:00',1.21),('11288','2013-05-23','17:00:00',1.13),('11288','2013-05-23','17:05:00',2.34),('11288','2013-05-23','17:10:00',3.63),('11288','2013-05-23','17:15:00',4.13),('11288','2013-05-23','17:20:00',2.86),('11288','2013-05-23','17:25:00',1.62),('11288','2013-05-23','17:30:00',1.63),('11288','2013-05-23','17:35:00',3.32),('11288','2013-05-23','17:40:00',1.82),('11288','2013-05-23','17:45:00',1.81),('11288','2013-05-23','17:50:00',1.65),('11288','2013-05-23','17:55:00',2.72),('11288','2013-05-23','18:00:00',3.24),('11288','2013-05-23','18:05:00',3.98),('11288','2013-05-23','18:10:00',1.7),('11288','2013-05-23','18:40:00',1.09),('11288','2013-05-23','18:45:00',1.77),('11288','2013-05-23','18:50:00',2.11),('11288','2013-05-23','18:55:00',1.74),('11288','2013-05-23','19:00:00',1.24),('11288','2013-05-22','07:20:00',1.02),('11288','2013-05-22','07:25:00',1.2),('11288','2013-05-22','07:30:00',1.1),('11288','2013-05-22','07:35:00',1.07),('11288','2013-05-22','07:40:00',1.23),('11288','2013-05-22','07:45:00',1.41),('11288','2013-05-22','07:50:00',1.83),('11288','2013-05-22','07:55:00',1.94),('11288','2013-05-22','08:00:00',2.11),('11288','2013-05-22','08:05:00',2.34),('11288','2013-05-22','08:10:00',2.3),('11288','2013-05-22','08:15:00',3.43),('11288','2013-05-22','08:20:00',3.11),('11288','2013-05-22','08:25:00',2.97),('11288','2013-05-22','08:30:00',3.97),('11288','2013-05-22','08:35:00',4.68),('11288','2013-05-22','08:40:00',2.58),('11288','2013-05-22','08:45:00',3.02),('11288','2013-05-22','08:50:00',1.79),('11288','2013-05-22','09:10:00',1.25),('11288','2013-05-22','09:15:00',1.66),('11288','2013-05-22','09:20:00',1.68),('11288','2013-05-22','09:25:00',2.47),('11288','2013-05-22','09:30:00',5.06),('11288','2013-05-22','09:35:00',4.98),('11288','2013-05-22','09:40:00',4.87),('11288','2013-05-22','09:45:00',4.93),('11288','2013-05-22','09:50:00',5.08),('11288','2013-05-22','09:55:00',5.06),('11288','2013-05-22','10:00:00',5.33),('11288','2013-05-22','10:05:00',5.47),('11288','2013-05-22','10:10:00',5.57),('11288','2013-05-22','10:15:00',5.66),('11288','2013-05-22','10:20:00',5.44),('11288','2013-05-22','10:25:00',5.76),('11288','2013-05-22','10:30:00',5.96),('11288','2013-05-22','10:35:00',6.09),('11288','2013-05-22','10:40:00',6.43),('11288','2013-05-22','10:45:00',6.4),('11288','2013-05-22','10:50:00',6.37),('11288','2013-05-22','10:55:00',6.43),('11288','2013-05-22','11:00:00',6.52),('11288','2013-05-22','11:05:00',6.68),('11288','2013-05-22','11:10:00',5.02),('11288','2013-05-22','11:15:00',6.81),('11288','2013-05-22','11:20:00',6.81),('11288','2013-05-22','11:25:00',6.77),('11288','2013-05-22','11:30:00',5.61),('11288','2013-05-22','11:35:00',6.07),('11288','2013-05-22','11:40:00',5.4),('11288','2013-05-22','11:45:00',6.84),('11288','2013-05-22','11:50:00',3.94),('11288','2013-05-22','11:55:00',3.74),('11288','2013-05-22','12:00:00',5.3),('11288','2013-05-22','12:05:00',4.12),('11288','2013-05-22','12:10:00',4.14),('11288','2013-05-22','12:15:00',5.58),('11288','2013-05-22','12:20:00',6.71),('11288','2013-05-22','12:25:00',5.55),('11288','2013-05-22','12:30:00',3.83),('11288','2013-05-22','12:35:00',4.31),('11288','2013-05-22','12:40:00',2.83),('11288','2013-05-22','12:45:00',1.37),('11288','2013-05-22','13:00:00',1.85),('11288','2013-05-22','13:05:00',7.44),('11288','2013-05-22','13:10:00',4.6),('11288','2013-05-22','13:15:00',5.25),('11288','2013-05-22','13:20:00',5.2),('11288','2013-05-22','13:25:00',2.04),('11288','2013-05-22','13:30:00',3.16),('11288','2013-05-22','13:35:00',6.78),('11288','2013-05-22','13:40:00',4.59),('11288','2013-05-22','13:45:00',4.32),('11288','2013-05-22','13:50:00',3.08),('11288','2013-05-22','13:55:00',3.68),('11288','2013-05-22','14:00:00',4.85),('11288','2013-05-22','14:05:00',5.43),('11288','2013-05-22','14:10:00',7.64),('11288','2013-05-22','14:15:00',7.36),('11288','2013-05-22','14:20:00',7.18),('11288','2013-05-22','14:25:00',7.09),('11288','2013-05-22','14:30:00',6.97),('11288','2013-05-22','14:35:00',6.92),('11288','2013-05-22','14:40:00',6.95),('11288','2013-05-22','14:45:00',6.93),('11288','2013-05-22','14:50:00',6.86),('11288','2013-05-22','14:55:00',6.75),('11288','2013-05-22','15:00:00',6.66),('11288','2013-05-22','15:05:00',6.59),('11288','2013-05-22','15:10:00',6.38),('11288','2013-05-22','15:15:00',6.32),('11288','2013-05-22','15:20:00',4.73),('11288','2013-05-22','15:25:00',4.14),('11288','2013-05-22','15:30:00',3.4),('11288','2013-05-22','15:35:00',3.95),('11288','2013-05-22','15:40:00',6.22),('11288','2013-05-22','15:45:00',5.19),('11288','2013-05-22','15:50:00',6),('11288','2013-05-22','15:55:00',5.85),('11288','2013-05-22','16:00:00',5.72),('11288','2013-05-22','16:05:00',5.55),('11288','2013-05-22','16:10:00',5.46),('11288','2013-05-22','16:15:00',5.33),('11288','2013-05-22','16:20:00',5.22),('11288','2013-05-22','16:25:00',5.13),('11288','2013-05-22','16:30:00',4.9),('11288','2013-05-22','16:35:00',4.67),('11288','2013-05-22','16:40:00',4.72),('11288','2013-05-22','16:45:00',4.36),('11288','2013-05-22','16:50:00',1.82),('11288','2013-05-22','16:55:00',1.33),('11288','2013-05-22','17:00:00',1.3),('11288','2013-05-22','17:05:00',1.4),('11288','2013-05-22','17:10:00',1.26),('11288','2013-05-22','17:15:00',1.9),('11288','2013-05-22','17:20:00',2.21),('11288','2013-05-22','17:25:00',2.62),('11288','2013-05-22','17:30:00',2.35),('11288','2013-05-22','17:35:00',3.22),('11288','2013-05-22','17:40:00',1.59),('11288','2013-05-22','17:50:00',1.14),('11288','2013-05-22','17:55:00',2.86),('11288','2013-05-22','18:00:00',2.85),('11288','2013-05-22','18:05:00',1.52),('11288','2013-05-22','18:10:00',1.07),('11288','2013-05-22','18:25:00',1.33),('11288','2013-05-22','19:00:00',1.07),('11288','2013-05-22','19:05:00',1.08),('11288','2013-05-22','19:15:00',1.08),('11288','2014-04-01','08:10:00',1.01),('11288','2014-04-01','08:15:00',1.11),('11288','2014-04-01','08:20:00',1.13),('11288','2014-04-01','08:25:00',1.35),('11288','2014-04-01','08:30:00',1.46),('11288','2014-04-01','08:35:00',1.56),('11288','2014-04-01','08:40:00',1.8),('11288','2014-04-01','08:45:00',1.86),('11288','2014-04-01','08:50:00',1.99),('11288','2014-04-01','08:55:00',2.25),('11288','2014-04-01','09:00:00',2.4),('11288','2014-04-01','09:05:00',2.38),('11288','2014-04-01','09:10:00',2.62),('11288','2014-04-01','09:15:00',2.66),('11288','2014-04-01','09:20:00',2.78),('11288','2014-04-01','09:25:00',2.95),('11288','2014-04-01','09:30:00',3.11),('11288','2014-04-01','09:35:00',3.37),('11288','2014-04-01','09:40:00',3.58),('11288','2014-04-01','09:45:00',3.65),('11288','2014-04-01','09:50:00',3.94),('11288','2014-04-01','09:55:00',4.12),('11288','2014-04-01','10:00:00',4.2),('11288','2014-04-01','10:05:00',4.32),('11288','2014-04-01','10:10:00',4.52),('11288','2014-04-01','10:15:00',4.76),('11288','2014-04-01','10:20:00',4.85),('11288','2014-04-01','10:25:00',5.26),('11288','2014-04-01','10:30:00',5.38),('11288','2014-04-01','10:35:00',5.65),('11288','2014-04-01','10:40:00',5.44),('11288','2014-04-01','10:45:00',5.45),('11288','2014-04-01','10:50:00',5.39),('11288','2014-04-01','10:55:00',5.41),('11288','2014-04-01','11:00:00',5.54),('11288','2014-04-01','11:05:00',5.59),('11288','2014-04-01','11:10:00',5.69),('11288','2014-04-01','11:15:00',5.75),('11288','2014-04-01','11:20:00',5.87),('11288','2014-04-01','11:25:00',5.96),('11288','2014-04-01','11:30:00',5.99),('11288','2014-04-01','11:35:00',5.94),('11288','2014-04-01','11:40:00',6.03),('11288','2014-04-01','11:45:00',6.09),('11288','2014-04-01','11:50:00',6.11),('11288','2014-04-01','11:55:00',6.15),('11288','2014-04-01','12:00:00',6.29),('11288','2014-04-01','12:05:00',6.41),('11288','2014-04-01','12:10:00',6.48),('11288','2014-04-01','12:15:00',6.54),('11288','2014-04-01','12:20:00',6.61),('11288','2014-04-01','12:25:00',6.68),('11288','2014-04-01','12:30:00',6.74),('11288','2014-04-01','12:35:00',6.76),('11288','2014-04-01','12:40:00',6.79),('11288','2014-04-01','12:45:00',6.79),('11288','2014-04-01','12:50:00',6.03),('11288','2014-04-01','12:55:00',6.81),('11288','2014-04-01','13:00:00',6.84),('11288','2014-04-01','13:05:00',6.87),('11288','2014-04-01','13:10:00',6.85),('11288','2014-04-01','13:15:00',6.87),('11288','2014-04-01','13:20:00',6.67),('11288','2014-04-01','13:25:00',6.72),('11288','2014-04-01','13:30:00',6.77),('11288','2014-04-01','13:35:00',6.84),('11288','2014-04-01','13:40:00',5.87),('11288','2014-04-01','13:45:00',6.87),('11288','2014-04-01','13:50:00',6.72),('11288','2014-04-01','13:55:00',6.68),('11288','2014-04-01','14:00:00',6.66),('11288','2014-04-01','14:05:00',6.5),('11288','2014-04-01','14:10:00',5.6),('11288','2014-04-01','14:15:00',4.61),('11288','2014-04-01','14:20:00',5.2),('11288','2014-04-01','14:25:00',6.4),('11288','2014-04-01','14:30:00',6.54),('11288','2014-04-01','14:35:00',5.87),('11288','2014-04-01','14:40:00',5.07),('11288','2014-04-01','14:45:00',6.73),('11288','2014-04-01','14:50:00',6.39),('11288','2014-04-01','14:55:00',5.01),('11288','2014-04-01','15:00:00',5.48),('11288','2014-04-01','15:05:00',4.27),('11288','2014-04-01','15:10:00',5.17),('11288','2014-04-01','15:15:00',5.44),('11288','2014-04-01','15:20:00',3.2),('11288','2014-04-01','15:25:00',5.03),('11288','2014-04-01','15:30:00',5.09),('11288','2014-04-01','15:35:00',4.6),('11288','2014-04-01','15:40:00',5.67),('11288','2014-04-01','15:45:00',4.72),('11288','2014-04-01','15:50:00',5.78),('11288','2014-04-01','15:55:00',5.37),('11288','2014-04-01','16:00:00',4.07),('11288','2014-04-01','16:05:00',5.21),('11288','2014-04-01','16:10:00',4.82),('11288','2014-04-01','16:15:00',4.63),('11288','2014-04-01','16:20:00',2.44),('11288','2014-04-01','16:25:00',3.4),('11288','2014-04-01','16:30:00',4.57),('11288','2014-04-01','16:35:00',4.45),('11288','2014-04-01','16:40:00',3.77),('11288','2014-04-01','16:45:00',2.21),('11288','2014-04-01','16:50:00',2.6),('11288','2014-04-01','16:55:00',2.47),('11288','2014-04-01','17:00:00',2.79),('11288','2014-04-01','17:05:00',2.85),('11288','2014-04-01','17:10:00',2.68),('11288','2014-04-01','17:15:00',3.05),('11288','2014-04-01','17:20:00',2.83),('11288','2014-04-01','17:25:00',2.55),('11288','2014-04-01','17:30:00',2.48),('11288','2014-04-01','17:35:00',2.32),('11288','2014-04-01','17:40:00',2.18),('11288','2014-04-01','17:45:00',2.04),('11288','2014-04-01','17:50:00',1.89),('11288','2014-04-01','17:55:00',1.72),('11288','2014-04-01','18:00:00',1.57),('11288','2014-04-01','18:05:00',1.46),('11288','2014-04-01','18:10:00',1.26),('11288','2014-04-01','18:15:00',1.12),('11288','2013-05-21','07:10:00',1.05),('11288','2013-05-21','07:15:00',1.16),('11288','2013-05-21','07:20:00',1.24),('11288','2013-05-21','07:25:00',1.39),('11288','2013-05-21','07:30:00',1.67),('11288','2013-05-21','07:35:00',2.1),('11288','2013-05-21','07:40:00',2.43),('11288','2013-05-21','07:45:00',2.02),('11288','2013-05-21','07:50:00',1.64),('11288','2013-05-21','07:55:00',1.9),('11288','2013-05-21','08:00:00',1.93),('11288','2013-05-21','08:05:00',1.55),('11288','2013-05-21','08:10:00',2.49),('11288','2013-05-21','08:15:00',3.15),('11288','2013-05-21','08:20:00',2.87),('11288','2013-05-21','08:25:00',3.29),('11288','2013-05-21','08:30:00',2.39),('11288','2013-05-21','08:35:00',2.32),('11288','2013-05-21','08:40:00',2.66),('11288','2013-05-21','08:45:00',2.27),('11288','2013-05-21','08:50:00',2.51),('11288','2013-05-21','08:55:00',3.17),('11288','2013-05-21','09:00:00',2.68),('11288','2013-05-21','09:05:00',2.41),('11288','2013-05-21','09:10:00',2.67),('11288','2013-05-21','09:15:00',2.92),('11288','2013-05-21','09:20:00',4.28),('11288','2013-05-21','09:25:00',4.02),('11288','2013-05-21','09:30:00',3.3),('11288','2013-05-21','09:35:00',3.68),('11288','2013-05-21','09:40:00',3.43),('11288','2013-05-21','09:45:00',2.98),('11288','2013-05-21','09:50:00',2.93),('11288','2013-05-21','09:55:00',3.26),('11288','2013-05-21','10:00:00',3.56),('11288','2013-05-21','10:05:00',3.89),('11288','2013-05-21','10:10:00',4.03),('11288','2013-05-21','10:15:00',4.32),('11288','2013-05-21','10:20:00',3.52),('11288','2013-05-21','10:25:00',3.38),('11288','2013-05-21','10:30:00',3.16),('11288','2013-05-21','10:35:00',3.33),('11288','2013-05-21','10:40:00',3.68),('11288','2013-05-21','10:45:00',5.17),('11288','2013-05-21','10:50:00',3.66),('11288','2013-05-21','10:55:00',2.89),('11288','2013-05-21','11:00:00',3.4),('11288','2013-05-21','11:05:00',3.28),('11288','2013-05-21','11:10:00',5.15),('11288','2013-05-21','11:15:00',6.45),('11288','2013-05-21','11:20:00',6.32),('11288','2013-05-21','11:25:00',6.69),('11288','2013-05-21','11:30:00',5.18),('11288','2013-05-21','11:35:00',4.23),('11288','2013-05-21','11:40:00',4.65),('11288','2013-05-21','11:45:00',5.21),('11288','2013-05-21','11:50:00',4.97),('11288','2013-05-21','11:55:00',6.09),('11288','2013-05-21','12:00:00',5.68),('11288','2013-05-21','12:05:00',6.38),('11288','2013-05-21','12:10:00',4.72),('11288','2013-05-21','12:15:00',5.3),('11288','2013-05-21','12:20:00',4.17),('11288','2013-05-21','12:25:00',5.82),('11288','2013-05-21','12:30:00',6.76),('11288','2013-05-21','12:35:00',4.59),('11288','2013-05-21','12:40:00',7.37),('11288','2013-05-21','12:45:00',6.43),('11288','2013-05-21','12:50:00',4.74),('11288','2013-05-21','12:55:00',7.9),('11288','2013-05-21','13:00:00',6.81),('11288','2013-05-21','13:05:00',6.45),('11288','2013-05-21','13:10:00',4.43),('11288','2013-05-21','13:15:00',6.02),('11288','2013-05-21','13:20:00',5.44),('11288','2013-05-21','13:25:00',5.44),('11288','2013-05-21','13:30:00',4.93),('11288','2013-05-21','13:35:00',2.47),('11288','2013-05-21','13:40:00',1.5),('11288','2013-05-21','13:45:00',1.05),('11288','2013-05-21','14:00:00',1.17),('11288','2013-05-21','14:05:00',2.05),('11288','2013-05-21','14:10:00',3.16),('11288','2013-05-21','14:15:00',3.6),('11288','2013-05-21','14:20:00',3.02),('11288','2013-05-21','14:25:00',5.06),('11288','2013-05-21','14:30:00',4.46),('11288','2013-05-21','14:35:00',3.45),('11288','2013-05-21','14:40:00',3.33),('11288','2013-05-21','14:45:00',2.72),('11288','2013-05-21','14:50:00',1.74),('11288','2013-05-21','14:55:00',1.29),('11288','2013-05-21','15:05:00',1),('11288','2013-05-21','15:10:00',1.19),('11288','2013-05-21','15:15:00',2.1),('11288','2013-05-21','15:20:00',2.75),('11288','2013-05-21','15:25:00',2.78),('11288','2013-05-21','15:30:00',4.32),('11288','2013-05-21','15:35:00',2.9),('11288','2013-05-21','15:40:00',2.39),('11288','2013-05-21','15:45:00',2.46),('11288','2013-05-21','15:50:00',2.2),('11288','2013-05-21','15:55:00',2.12),('11288','2013-05-21','16:00:00',2.06),('11288','2013-05-21','16:05:00',2.12),('11288','2013-05-21','16:10:00',2.31),('11288','2013-05-21','16:15:00',1.94),('11288','2013-05-21','16:20:00',1.64),('11288','2013-05-21','16:25:00',2.29),('11288','2013-05-21','16:30:00',2.98),('11288','2013-05-21','16:35:00',3.42),('11288','2013-05-21','16:40:00',3.31),('11288','2013-05-21','16:45:00',2.9),('11288','2013-05-21','16:50:00',1.92),('11288','2013-05-21','16:55:00',1.03),('11288','2013-05-21','17:00:00',1.14),('11288','2013-05-21','17:05:00',1.33),('11288','2013-05-21','17:10:00',1.11),('11288','2013-05-20','07:05:00',1),('11288','2013-05-20','07:15:00',1.16),('11288','2013-05-20','07:20:00',1.21),('11288','2013-05-20','07:25:00',1.27),('11288','2013-05-20','07:30:00',1.53),('11288','2013-05-20','07:35:00',1.63),('11288','2013-05-20','07:40:00',1.72),('11288','2013-05-20','07:45:00',1.87),('11288','2013-05-20','07:50:00',2.02),('11288','2013-05-20','07:55:00',2.03),('11288','2013-05-20','08:00:00',2.2),('11288','2013-05-20','08:05:00',1.93),('11288','2013-05-20','08:10:00',2.02),('11288','2013-05-20','08:15:00',2.6),('11288','2013-05-20','08:20:00',2.6),('11288','2013-05-20','08:25:00',1.16),('11288','2013-05-20','08:30:00',1.18),('11288','2013-05-20','08:35:00',1.25),('11288','2013-05-20','08:40:00',1.46),('11288','2013-05-20','08:45:00',4.19),('11288','2013-05-20','08:50:00',4.95),('11288','2013-05-20','08:55:00',4.13),('11288','2013-05-20','09:00:00',4.88),('11288','2013-05-20','09:05:00',4.14),('11288','2013-05-20','09:10:00',5.42),('11288','2013-05-20','09:15:00',1.74),('11288','2013-05-20','09:20:00',3.21),('11288','2013-05-20','09:25:00',1.64),('11288','2013-05-20','09:30:00',2.01),('11288','2013-05-20','09:35:00',3.73),('11288','2013-05-20','09:40:00',1.12),('11288','2013-05-20','09:45:00',3.95),('11288','2013-05-20','09:50:00',3.11),('11288','2013-05-20','09:55:00',1.33),('11288','2013-05-20','10:00:00',2.97),('11288','2013-05-20','10:05:00',1.76),('11288','2013-05-20','10:10:00',4.53),('11288','2013-05-20','10:15:00',1.49),('11288','2013-05-20','10:20:00',1.37),('11288','2013-05-20','10:25:00',3.6),('11288','2013-05-20','10:30:00',5.73),('11288','2013-05-20','10:35:00',2.12),('11288','2013-05-20','10:40:00',3.71),('11288','2013-05-20','10:45:00',2.77),('11288','2013-05-20','10:50:00',3.61),('11288','2013-05-20','10:55:00',1.99),('11288','2013-05-20','11:00:00',7.19),('11288','2013-05-20','11:05:00',7.2),('11288','2013-05-20','11:10:00',7.6),('11288','2013-05-20','11:15:00',6.78),('11288','2013-05-20','11:20:00',4.29),('11288','2013-05-20','11:25:00',6.09),('11288','2013-05-20','11:30:00',6.68),('11288','2013-05-20','11:35:00',4.86),('11288','2013-05-20','11:40:00',3.26),('11288','2013-05-20','11:45:00',2.8),('11288','2013-05-20','11:50:00',3.73),('11288','2013-05-20','11:55:00',6.59),('11288','2013-05-20','12:00:00',4.67),('11288','2013-05-20','12:05:00',7.94),('11288','2013-05-20','12:10:00',4.19),('11288','2013-05-20','12:15:00',3.82),('11288','2013-05-20','12:20:00',6.86),('11288','2013-05-20','12:25:00',5.47),('11288','2013-05-20','12:30:00',3.23),('11288','2013-05-20','12:35:00',3.39),('11288','2013-05-20','12:40:00',9.18),('11288','2013-05-20','12:45:00',5.76),('11288','2013-05-20','12:50:00',3.32),('11288','2013-05-20','12:55:00',5.91),('11288','2013-05-20','13:00:00',6.55),('11288','2013-05-20','13:05:00',3.67),('11288','2013-05-20','13:10:00',3.08),('11288','2013-05-20','13:15:00',3.65),('11288','2013-05-20','13:20:00',5.79),('11288','2013-05-20','13:25:00',7.55),('11288','2013-05-20','13:30:00',2.05),('11288','2013-05-20','13:35:00',8.4),('11288','2013-05-20','13:40:00',2.16),('11288','2013-05-20','13:45:00',8.2),('11288','2013-05-20','13:50:00',6.22),('11288','2013-05-20','13:55:00',8.34),('11288','2013-05-20','14:00:00',6.09),('11288','2013-05-20','14:05:00',1.55),('11288','2013-05-20','14:10:00',6.51),('11288','2013-05-20','14:15:00',6.94),('11288','2013-05-20','14:20:00',2.38),('11288','2013-05-20','14:25:00',8.04),('11288','2013-05-20','14:30:00',7.2),('11288','2013-05-20','14:35:00',4.51),('11288','2013-05-20','14:40:00',3.9),('11288','2013-05-20','14:45:00',6.57),('11288','2013-05-20','14:50:00',5.03),('11288','2013-05-20','14:55:00',5.93),('11288','2013-05-20','15:00:00',3.3),('11288','2013-05-20','15:05:00',5.76),('11288','2013-05-20','15:10:00',7.57),('11288','2013-05-20','15:15:00',2.5),('11288','2013-05-20','15:20:00',7.12),('11288','2013-05-20','15:25:00',5.43),('11288','2013-05-20','15:30:00',7),('11288','2013-05-20','15:35:00',6.32),('11288','2013-05-20','15:40:00',3.71),('11288','2013-05-20','15:45:00',4.25),('11288','2013-05-20','15:50:00',3.65),('11288','2013-05-20','15:55:00',4.77),('11288','2013-05-20','16:00:00',3.41),('11288','2013-05-20','16:05:00',4.31),('11288','2013-05-20','16:10:00',4.19),('11288','2013-05-20','16:15:00',5.4),('11288','2013-05-20','16:20:00',5.93),('11288','2013-05-20','16:25:00',5.74),('11288','2013-05-20','16:30:00',5.45),('11288','2013-05-20','16:35:00',5.26),('11288','2013-05-20','16:40:00',5.15),('11288','2013-05-20','16:45:00',4.8),('11288','2013-05-20','16:50:00',4.72),('11288','2013-05-20','16:55:00',4.36),('11288','2013-05-20','17:00:00',4.29),('11288','2013-05-20','17:05:00',4.22),('11288','2013-05-20','17:10:00',3.23),('11288','2013-05-20','17:15:00',2.17),('11288','2013-05-20','17:20:00',3.37),('11288','2013-05-20','17:25:00',4.07),('11288','2013-05-20','17:30:00',3.8),('11288','2013-05-20','17:35:00',3.49),('11288','2013-05-20','17:40:00',3.28),('11288','2013-05-20','17:45:00',3.13),('11288','2013-05-20','17:50:00',3.08),('11288','2013-05-20','17:55:00',2.96),('11288','2013-05-20','18:00:00',2.82),('11288','2013-05-20','18:05:00',2.9),('11288','2013-05-20','18:10:00',2.35),('11288','2013-05-20','18:15:00',2.4),('11288','2013-05-20','18:20:00',2.32),('11288','2013-05-20','18:25:00',2.09),('11288','2013-05-20','18:30:00',1.96),('11288','2013-05-20','18:35:00',1.83),('11288','2013-05-20','18:40:00',1.54),('11288','2013-05-20','18:45:00',1.54),('11288','2013-05-20','18:50:00',1.4),('11288','2013-05-20','18:55:00',1.28),('11288','2013-05-20','19:00:00',1.14),('11288','2013-05-20','19:05:00',1.02),('11288','2013-05-19','08:00:00',1.13),('11288','2013-05-19','08:05:00',1.01),('11288','2013-05-19','08:10:00',1.21),('11288','2013-05-19','08:15:00',1.2),('11288','2013-05-19','08:20:00',1.14),('11288','2013-05-19','08:25:00',1.14),('11288','2013-05-19','08:30:00',1.7),('11288','2013-05-19','08:35:00',2.17),('11288','2013-05-19','08:40:00',1.67),('11288','2013-05-19','08:45:00',1.89),('11288','2013-05-19','08:50:00',2.35),('11288','2013-05-19','08:55:00',2.5),('11288','2013-05-19','09:00:00',2.26),('11288','2013-05-19','09:05:00',2.13),('11288','2013-05-19','09:10:00',2.42),('11288','2013-05-19','09:15:00',2.39),('11288','2013-05-19','09:20:00',1.57),('11288','2013-05-19','09:30:00',1.38),('11288','2013-05-19','09:35:00',1.61),('11288','2013-05-19','09:40:00',2.08),('11288','2013-05-19','09:45:00',2.3),('11288','2013-05-19','09:50:00',1.7),('11288','2013-05-19','09:55:00',2.02),('11288','2013-05-19','10:00:00',2.42),('11288','2013-05-19','10:05:00',3.08),('11288','2013-05-19','10:10:00',4.34),('11288','2013-05-19','10:15:00',4.58),('11288','2013-05-19','10:20:00',5.2),('11288','2013-05-19','10:25:00',4.35),('11288','2013-05-19','10:30:00',5.32),('11288','2013-05-19','10:35:00',6.45),('11288','2013-05-19','10:40:00',7.2),('11288','2013-05-19','10:45:00',7.41),('11288','2013-05-19','10:50:00',7.18),('11288','2013-05-19','10:55:00',7.96),('11288','2013-05-19','11:00:00',6.55),('11288','2013-05-19','11:05:00',3.61),('11288','2013-05-19','11:10:00',6.2),('11288','2013-05-19','11:15:00',7.36),('11288','2013-05-19','11:20:00',7.22),('11288','2013-05-19','11:25:00',7.34),('11288','2013-05-19','11:30:00',7.38),('11288','2013-05-19','11:35:00',7.4),('11288','2013-05-19','11:40:00',7.47),('11288','2013-05-19','11:45:00',7.56),('11288','2013-05-19','11:50:00',7.55),('11288','2013-05-19','11:55:00',7.72),('11288','2013-05-19','12:00:00',7.61),('11288','2013-05-19','12:05:00',7.63),('11288','2013-05-19','12:10:00',7.63),('11288','2013-05-19','12:15:00',7.88),('11288','2013-05-19','12:20:00',7.86),('11288','2013-05-19','12:25:00',5.28),('11288','2013-05-19','12:30:00',4.91),('11288','2013-05-19','12:35:00',5.26),('11288','2013-05-19','12:40:00',7.06),('11288','2013-05-19','12:45:00',6.87),('11288','2013-05-19','12:50:00',5.3),('11288','2013-05-19','12:55:00',4.41),('11288','2013-05-19','13:00:00',6.88),('11288','2013-05-19','13:05:00',7.08),('11288','2013-05-19','13:10:00',6.65),('11288','2013-05-19','13:15:00',6.2),('11288','2013-05-19','13:20:00',6.23),('11288','2013-05-19','13:25:00',7.44),('11288','2013-05-19','13:30:00',7.6),('11288','2013-05-19','13:35:00',7.53),('11288','2013-05-19','13:40:00',7.55),('11288','2013-05-19','13:45:00',7.54),('11288','2013-05-19','13:50:00',7.56),('11288','2013-05-19','13:55:00',7.5),('11288','2013-05-19','14:00:00',7.5),('11288','2013-05-19','14:05:00',7.47),('11288','2013-05-19','14:10:00',7.45),('11288','2013-05-19','14:15:00',7.41),('11288','2013-05-19','14:20:00',7.38),('11288','2013-05-19','14:25:00',7.37),('11288','2013-05-19','14:30:00',7.31),('11288','2013-05-19','14:35:00',7.23),('11288','2013-05-19','14:40:00',7.18),('11288','2013-05-19','14:45:00',7.16),('11288','2013-05-19','14:50:00',7.11),('11288','2013-05-19','14:55:00',7.07),('11288','2013-05-19','15:00:00',6.95),('11288','2013-05-19','15:05:00',6.96),('11288','2013-05-19','15:10:00',6.84),('11288','2013-05-19','15:15:00',6.8),('11288','2013-05-19','15:20:00',6.65),('11288','2013-05-19','15:25:00',6.71),('11288','2013-05-19','15:30:00',6.63),('11288','2013-05-19','15:35:00',6.48),('11288','2013-05-19','15:40:00',6.39),('11288','2013-05-19','15:45:00',6.33),('11288','2013-05-19','15:50:00',6.28),('11288','2013-05-19','15:55:00',6.14),('11288','2013-05-19','16:00:00',6.11),('11288','2013-05-19','16:05:00',5.97),('11288','2013-05-19','16:10:00',5.83),('11288','2013-05-19','16:15:00',5.75),('11288','2013-05-19','16:20:00',5.61),('11288','2013-05-19','16:25:00',5.53),('11288','2013-05-19','16:30:00',5.34),('11288','2013-05-19','16:35:00',5.25),('11288','2013-05-19','16:40:00',5.15),('11288','2013-05-19','16:45:00',5.03),('11288','2013-05-19','16:50:00',4.85),('11288','2013-05-19','16:55:00',4.67),('11288','2013-05-19','17:00:00',4.43),('11288','2013-05-19','17:05:00',4.41),('11288','2013-05-19','17:10:00',4.34),('11288','2013-05-19','17:15:00',4.21),('11288','2013-05-19','17:20:00',4.07),('11288','2013-05-19','17:25:00',3.91),('11288','2013-05-19','17:30:00',3.72),('11288','2013-05-19','17:35:00',3.59),('11288','2013-05-19','17:40:00',3.44),('11288','2013-05-19','17:45:00',3.28),('11288','2013-05-19','17:50:00',3.28),('11288','2013-05-19','17:55:00',3.16),('11288','2013-05-19','18:00:00',3.01),('11288','2013-05-19','18:05:00',2.85),('11288','2013-05-19','18:10:00',2.73),('11288','2013-05-19','18:15:00',2.56),('11288','2013-05-19','18:20:00',2.42),('11288','2013-05-19','18:25:00',2.27),('11288','2013-05-19','18:30:00',2.12),('11288','2013-05-19','18:35:00',2.01),('11288','2013-05-19','18:40:00',1.85),('11288','2013-05-19','18:45:00',1.68),('11288','2013-05-19','18:50:00',1.54),('11288','2013-05-19','18:55:00',1.38),('11288','2013-05-19','19:00:00',1.21),('11288','2013-05-19','19:05:00',1.05),('11288','2013-05-18','07:15:00',1.04),('11288','2013-05-18','07:20:00',1.14),('11288','2013-05-18','07:25:00',1.31),('11288','2013-05-18','07:30:00',1.41),('11288','2013-05-18','07:35:00',1.48),('11288','2013-05-18','07:40:00',1.7),('11288','2013-05-18','07:45:00',1.81),('11288','2013-05-18','07:50:00',1.93),('11288','2013-05-18','07:55:00',2.83),('11288','2013-05-18','08:00:00',3.16),('11288','2013-05-18','08:05:00',2.86),('11288','2013-05-18','08:10:00',1.83),('11288','2013-05-18','08:15:00',1.8),('11288','2013-05-18','08:20:00',2.58),('11288','2013-05-18','08:25:00',3.72),('11288','2013-05-18','08:30:00',3.58),('11288','2013-05-18','08:35:00',3.26),('11288','2013-05-18','08:40:00',3.57),('11288','2013-05-18','08:45:00',3.54),('11288','2013-05-18','08:50:00',3.54),('11288','2013-05-18','08:55:00',3.62),('11288','2013-05-18','09:00:00',3.89),('11288','2013-05-18','09:05:00',3.97),('11288','2013-05-18','09:10:00',4.25),('11288','2013-05-18','09:15:00',4.34),('11288','2013-05-18','09:20:00',4.43),('11288','2013-05-18','09:25:00',4.49),('11288','2013-05-18','09:30:00',4.71),('11288','2013-05-18','09:35:00',4.62),('11288','2013-05-18','09:40:00',4.88),('11288','2013-05-18','09:45:00',5.04),('11288','2013-05-18','09:50:00',4.92),('11288','2013-05-18','09:55:00',5.23),('11288','2013-05-18','10:00:00',5.44),('11288','2013-05-18','10:05:00',5.59),('11288','2013-05-18','10:10:00',5.59),('11288','2013-05-18','10:15:00',5.76),('11288','2013-05-18','10:20:00',5.86),('11288','2013-05-18','10:25:00',5.95),('11288','2013-05-18','10:30:00',5.97),('11288','2013-05-18','10:35:00',5.94),('11288','2013-05-18','10:40:00',6.13),('11288','2013-05-18','10:45:00',6.19),('11288','2013-05-18','10:50:00',6.32),('11288','2013-05-18','10:55:00',6.31),('11288','2013-05-18','11:00:00',6.72),('11288','2013-05-18','11:05:00',5.87),('11288','2013-05-18','11:10:00',5.5),('11288','2013-05-18','11:15:00',6.99),('11288','2013-05-18','11:20:00',6.76),('11288','2013-05-18','11:25:00',6.98),('11288','2013-05-18','11:30:00',6.35),('11288','2013-05-18','11:35:00',6.69),('11288','2013-05-18','11:40:00',6.82),('11288','2013-05-18','11:45:00',6.8),('11288','2013-05-18','11:50:00',6.57),('11288','2013-05-18','11:55:00',6.39),('11288','2013-05-18','12:00:00',6.71),('11288','2013-05-18','12:05:00',6.83),('11288','2013-05-18','12:10:00',6.8),('11288','2013-05-18','12:15:00',6.79),('11288','2013-05-18','12:20:00',6.91),('11288','2013-05-18','12:25:00',7.08),('11288','2013-05-18','12:30:00',5.31),('11288','2013-05-18','12:35:00',7.07),('11288','2013-05-18','12:40:00',6.99),('11288','2013-05-18','12:45:00',6.39),('11288','2013-05-18','12:50:00',7),('11288','2013-05-18','12:55:00',6.91),('11288','2013-05-18','13:00:00',6.97),('11288','2013-05-18','13:05:00',6.97),('11288','2013-05-18','13:10:00',7.02),('11288','2013-05-18','13:15:00',7.02),('11288','2013-05-18','13:20:00',7.03),('11288','2013-05-18','13:25:00',7.02),('11288','2013-05-18','13:30:00',7.04),('11288','2013-05-18','13:35:00',6.49),('11288','2013-05-18','13:40:00',7.02),('11288','2013-05-18','13:45:00',7.33),('11288','2013-05-18','13:50:00',6.36),('11288','2013-05-18','13:55:00',5.4),('11288','2013-05-18','14:00:00',5.02),('11288','2013-05-18','14:05:00',6.27),('11288','2013-05-18','14:10:00',7.42),('11288','2013-05-18','14:15:00',7.17),('11288','2013-05-18','14:20:00',7.14),('11288','2013-05-18','14:25:00',6.96),('11288','2013-05-18','14:30:00',6.88),('11288','2013-05-18','14:35:00',6.62),('11288','2013-05-18','14:40:00',7.11),('11288','2013-05-18','14:45:00',6.8),('11288','2013-05-18','14:50:00',6.82),('11288','2013-05-18','14:55:00',5.99),('11288','2013-05-18','15:00:00',6.13),('11288','2013-05-18','15:05:00',6.06),('11288','2013-05-18','15:10:00',5.97),('11288','2013-05-18','15:15:00',5.87),('11288','2013-05-18','15:20:00',5.77),('11288','2013-05-18','15:25:00',5.69),('11288','2013-05-18','15:30:00',5.64),('11288','2013-05-18','15:35:00',5.6),('11288','2013-05-18','15:40:00',5.48),('11288','2013-05-18','15:45:00',5.39),('11288','2013-05-18','15:50:00',5.32),('11288','2013-05-18','15:55:00',5.23),('11288','2013-05-18','16:00:00',5.14),('11288','2013-05-18','16:05:00',5.03),('11288','2013-05-18','16:10:00',4.91),('11288','2013-05-18','16:15:00',4.83),('11288','2013-05-18','16:20:00',4.76),('11288','2013-05-18','16:25:00',4.67),('11288','2013-05-18','16:30:00',4.5),('11288','2013-05-18','16:35:00',4.38),('11288','2013-05-18','16:40:00',4.28),('11288','2013-05-18','16:45:00',4.16),('11288','2013-05-18','16:50:00',4.01),('11288','2013-05-18','16:55:00',3.85),('11288','2013-05-18','17:00:00',3.68),('11288','2013-05-18','17:05:00',3.64),('11288','2013-05-18','17:10:00',3.52),('11288','2013-05-18','17:15:00',3.42),('11288','2013-05-18','17:20:00',3.31),('11288','2013-05-18','17:25:00',3.17),('11288','2013-05-18','17:30:00',3),('11288','2013-05-18','17:35:00',2.87),('11288','2013-05-18','17:40:00',2.77),('11288','2013-05-18','17:45:00',2.67),('11288','2013-05-18','17:50:00',2.62),('11288','2013-05-18','17:55:00',2.54),('11288','2013-05-18','18:00:00',2.38),('11288','2013-05-18','18:05:00',2.23),('11288','2013-05-18','18:10:00',2.08),('11288','2013-05-18','18:15:00',1.95),('11288','2013-05-18','18:20:00',1.85),('11288','2013-05-18','18:25:00',1.73),('11288','2013-05-18','18:30:00',1.6),('11288','2013-05-18','18:35:00',1.49),('11288','2013-05-18','18:40:00',1.38),('11288','2013-05-18','18:45:00',1.26),('11288','2013-05-18','18:50:00',1.15),('11288','2013-05-18','18:55:00',1.05),('11288','2013-05-17','07:05:00',1.21),('11288','2013-05-17','07:10:00',1.22),('11288','2013-05-17','07:15:00',1.01),('11288','2013-05-17','07:20:00',1.24),('11288','2013-05-17','07:35:00',1.16),('11288','2013-05-17','07:40:00',1.77),('11288','2013-05-17','07:45:00',1.73),('11288','2013-05-17','07:50:00',1.91),('11288','2013-05-17','07:55:00',1.89),('11288','2013-05-17','08:00:00',1.71),('11288','2013-05-17','08:05:00',1.76),('11288','2013-05-17','08:10:00',2.07),('11288','2013-05-17','08:15:00',3.05),('11288','2013-05-17','08:20:00',3.48),('11288','2013-05-17','08:25:00',2.81),('11288','2013-05-17','08:30:00',1.43),('11288','2013-05-17','08:35:00',1.05),('11288','2013-05-17','09:05:00',1.16),('11288','2013-05-17','09:10:00',1.3),('11288','2013-05-17','09:15:00',1.16),('11288','2013-05-17','09:20:00',1.63),('11288','2013-05-17','09:25:00',1.87),('11288','2013-05-17','10:15:00',1.35),('11288','2013-05-17','10:20:00',1.75),('11288','2013-05-17','10:25:00',2.52),('11288','2013-05-17','10:30:00',2.95),('11288','2013-05-17','10:35:00',2.31),('11288','2013-05-17','10:40:00',2.63),('11288','2013-05-17','10:45:00',2.85),('11288','2013-05-17','10:50:00',5.39),('11288','2013-05-17','10:55:00',5.21),('11288','2013-05-17','11:00:00',3.93),('11288','2013-05-17','11:05:00',3.51),('11288','2013-05-17','11:10:00',2.69),('11288','2013-05-17','11:15:00',3.66),('11288','2013-05-17','11:20:00',3.5),('11288','2013-05-17','11:25:00',3.04),('11288','2013-05-17','11:30:00',3.02),('11288','2013-05-17','11:35:00',3.75),('11288','2013-05-17','11:40:00',3.18),('11288','2013-05-17','11:45:00',7.72),('11288','2013-05-17','11:50:00',8.43),('11288','2013-05-17','11:55:00',7.01),('11288','2013-05-17','12:00:00',7.22),('11288','2013-05-17','12:05:00',6.73),('11288','2013-05-17','12:10:00',5.34),('11288','2013-05-17','12:15:00',4.86),('11288','2013-05-17','12:20:00',6.65),('11288','2013-05-17','12:25:00',5.25),('11288','2013-05-17','12:30:00',3.94),('11288','2013-05-17','12:35:00',6.32),('11288','2013-05-17','12:40:00',7.8),('11288','2013-05-17','12:45:00',8.21),('11288','2013-05-17','12:50:00',8.16),('11288','2013-05-17','12:55:00',7.24),('11288','2013-05-17','13:00:00',7.49),('11288','2013-05-17','13:05:00',7.5),('11288','2013-05-17','13:10:00',7.08),('11288','2013-05-17','13:15:00',7.93),('11288','2013-05-17','13:20:00',8.48),('11288','2013-05-17','13:25:00',7.11),('11288','2013-05-17','13:30:00',6.04),('11288','2013-05-17','13:35:00',7.69),('11288','2013-05-17','13:40:00',7.19),('11288','2013-05-17','13:45:00',6.85),('11288','2013-05-17','13:50:00',7.31),('11288','2013-05-17','13:55:00',7.73),('11288','2013-05-17','14:00:00',5.57),('11288','2013-05-17','14:05:00',6.34),('11288','2013-05-17','14:10:00',6.7),('11288','2013-05-17','14:15:00',7.24),('11288','2013-05-17','14:20:00',7.71),('11288','2013-05-17','14:25:00',6.32),('11288','2013-05-17','14:30:00',7.27),('11288','2013-05-17','14:35:00',7.09),('11288','2013-05-17','14:40:00',5.31),('11288','2013-05-17','14:45:00',5.78),('11288','2013-05-17','14:50:00',7.42),('11288','2013-05-17','14:55:00',4.76),('11288','2013-05-17','15:00:00',7.32),('11288','2013-05-17','15:05:00',4.73),('11288','2013-05-17','15:10:00',2.75),('11288','2013-05-17','15:15:00',6.04),('11288','2013-05-17','15:20:00',4),('11288','2013-05-17','15:25:00',2.86),('11288','2013-05-17','15:30:00',4.11),('11288','2013-05-17','15:35:00',5.35),('11288','2013-05-17','15:40:00',4.72),('11288','2013-05-17','15:45:00',3.99),('11288','2013-05-17','15:50:00',5.8),('11288','2013-05-17','15:55:00',7.12),('11288','2013-05-17','16:00:00',5.94),('11288','2013-05-17','16:05:00',4.48),('11288','2013-05-17','16:10:00',6.51),('11288','2013-05-17','16:15:00',4.47),('11288','2013-05-17','16:20:00',5.51),('11288','2013-05-17','16:25:00',5.58),('11288','2013-05-17','16:30:00',5.65),('11288','2013-05-17','16:35:00',6.08),('11288','2013-05-17','16:40:00',5.68),('11288','2013-05-17','16:45:00',5.24),('11288','2013-05-17','16:50:00',4.82),('11288','2013-05-17','16:55:00',4.58),('11288','2013-05-17','17:00:00',4.48),('11288','2013-05-17','17:05:00',4.3),('11288','2013-05-17','17:10:00',4.17),('11288','2013-05-17','17:15:00',4.06),('11288','2013-05-17','17:20:00',3.95),('11288','2013-05-17','17:25:00',3.8),('11288','2013-05-17','17:30:00',3.64),('11288','2013-05-17','17:35:00',3.5),('11288','2013-05-17','17:40:00',3.34),('11288','2013-05-17','17:45:00',3.19),('11288','2013-05-17','17:50:00',3.12),('11288','2013-05-17','17:55:00',3.04),('11288','2013-05-17','18:00:00',2.94),('11288','2013-05-17','18:05:00',2.75),('11288','2013-05-17','18:10:00',2.61),('11288','2013-05-17','18:15:00',2.45),('11288','2013-05-17','18:20:00',2.32),('11288','2013-05-17','18:25:00',2.17),('11288','2013-05-17','18:30:00',2.02),('11288','2013-05-17','18:35:00',1.93),('11288','2013-05-17','18:40:00',1.74),('11288','2013-05-17','18:45:00',1.59),('11288','2013-05-17','18:50:00',1.47),('11288','2013-05-17','18:55:00',1.25),('11288','2013-05-16','09:15:00',1.65),('11288','2013-05-16','09:20:00',2.07),('11288','2013-05-16','09:25:00',2.78),('11288','2013-05-16','09:30:00',2.86),('11288','2013-05-16','09:35:00',3.48),('11288','2013-05-16','09:40:00',3.73),('11288','2013-05-16','09:45:00',4.26),('11288','2013-05-16','09:50:00',2.34),('11288','2013-05-16','09:55:00',2.42),('11288','2013-05-16','10:00:00',2.85),('11288','2013-05-16','10:05:00',2.31),('11288','2013-05-16','10:10:00',2.18),('11288','2013-05-16','10:15:00',2.8),('11288','2013-05-16','10:20:00',3.73),('11288','2013-05-16','10:25:00',3.29),('11288','2013-05-16','10:30:00',3.44),('11288','2013-05-16','10:35:00',2.51),('11288','2013-05-16','10:40:00',2.44),('11288','2013-05-16','10:45:00',2.18),('11288','2013-05-16','10:50:00',2.49),('11288','2013-05-16','10:55:00',2.9),('11288','2013-05-16','11:00:00',7.03),('11288','2013-05-16','11:05:00',5.4),('11288','2013-05-16','11:10:00',5.44),('11288','2013-05-16','11:15:00',3.6),('11288','2013-05-16','11:20:00',2.04),('11288','2013-05-16','11:25:00',2.19),('11288','2013-05-16','11:30:00',2.7),('11288','2013-05-16','11:35:00',4.15),('11288','2013-05-16','11:40:00',6.21),('11288','2013-05-16','11:45:00',4.96),('11288','2013-05-16','11:50:00',5.17),('11288','2013-05-16','11:55:00',4.14),('11288','2013-05-16','12:00:00',3.13),('11288','2013-05-16','12:05:00',3.01),('11288','2013-05-16','12:10:00',3.04),('11288','2013-05-16','12:15:00',4.13),('11288','2013-05-16','12:20:00',3.39),('11288','2013-05-16','12:25:00',3.61),('11288','2013-05-16','12:30:00',6.05),('11288','2013-05-16','12:35:00',6.06),('11288','2013-05-16','12:40:00',7.26),('11288','2013-05-16','12:45:00',5.29),('11288','2013-05-16','12:50:00',4.56),('11288','2013-05-16','12:55:00',6.87),('11288','2013-05-16','13:00:00',6.84),('11288','2013-05-16','13:05:00',6.92),('11288','2013-05-16','13:10:00',6.78),('11288','2013-05-16','13:15:00',5.95),('11288','2013-05-16','13:20:00',5.18),('11288','2013-05-16','13:25:00',6.84),('11288','2013-05-16','13:30:00',6.73),('11288','2013-05-16','13:35:00',6.64),('11288','2013-05-16','13:40:00',6.56),('11288','2013-05-16','13:45:00',6.52),('11288','2013-05-16','13:50:00',6.56),('11288','2013-05-16','13:55:00',6.57),('11288','2013-05-16','14:00:00',6.53),('11288','2013-05-16','14:05:00',6.54),('11288','2013-05-16','14:10:00',6.47),('11288','2013-05-16','14:15:00',6.41),('11288','2013-05-16','14:20:00',6.31),('11288','2013-05-16','14:25:00',6.19),('11288','2013-05-16','14:30:00',6.22),('11288','2013-05-16','14:35:00',6.13),('11288','2013-05-16','14:40:00',6.07),('11288','2013-05-16','14:45:00',6.01),('11288','2013-05-16','14:50:00',5.47),('11288','2013-05-16','14:55:00',5.36),('11288','2013-05-16','15:00:00',5.92),('11288','2013-05-16','15:05:00',5.75),('11288','2013-05-16','15:10:00',5.64),('11288','2013-05-16','15:15:00',5.33),('11288','2013-05-16','15:20:00',5.67),('11288','2013-05-16','15:25:00',5.55),('11288','2013-05-16','15:30:00',5.39),('11288','2013-05-16','15:35:00',5.22),('11288','2013-05-16','15:40:00',5.41),('11288','2013-05-16','15:45:00',5.22),('11288','2013-05-16','15:50:00',5.19),('11288','2013-05-16','15:55:00',5.11),('11288','2013-05-16','16:00:00',5.04),('11288','2013-05-16','16:05:00',4.74),('11288','2013-05-16','16:10:00',4.83),('11288','2013-05-16','16:15:00',4.42),('11288','2013-05-16','16:20:00',4.76),('11288','2013-05-16','16:25:00',4.6),('11288','2013-05-16','16:30:00',4.53),('11288','2013-05-16','16:35:00',4.19),('11288','2013-05-16','16:40:00',2.7),('11288','2013-05-16','16:45:00',2.46),('11288','2013-05-16','16:50:00',3.23),('11288','2013-05-16','16:55:00',3.04),('11288','2013-05-16','17:00:00',2.49),('11288','2013-05-16','17:05:00',1.36),('11288','2013-05-16','17:10:00',1.49),('11288','2013-05-16','17:15:00',2.4),('11288','2013-05-16','17:20:00',2.65),('11288','2013-05-16','17:25:00',2.8),('11288','2013-05-16','17:30:00',3.09),('11288','2013-05-16','17:35:00',2.89),('11288','2013-05-16','17:40:00',2.45),('11288','2013-05-16','17:45:00',1.82),('11288','2013-05-16','17:50:00',1.13),('11288','2013-05-16','18:25:00',1.08),('11288','2013-05-16','18:30:00',1.24),('11288','2013-05-16','18:35:00',1.46),('11288','2013-05-16','18:40:00',1.5),('11288','2013-05-16','18:45:00',1.67),('11288','2013-05-16','18:50:00',1.74),('11288','2013-05-16','18:55:00',1.74),('11288','2013-05-16','19:00:00',1.8),('11288','2013-05-16','19:05:00',1.65),('11288','2013-05-16','19:10:00',1.36),('11288','2013-05-16','19:15:00',1.14),('11288','2013-05-15','07:20:00',1.1),('11288','2013-05-15','07:25:00',1.21),('11288','2013-05-15','07:30:00',1.36),('11288','2013-05-15','07:35:00',1.38),('11288','2013-05-15','07:40:00',1.63),('11288','2013-05-15','07:45:00',1.87),('11288','2013-05-15','07:50:00',1.89),('11288','2013-05-15','07:55:00',2),('11288','2013-05-15','08:00:00',2),('11288','2013-05-15','08:05:00',1.86),('11288','2013-05-15','08:10:00',2.1),('11288','2013-05-15','08:15:00',2.57),('11288','2013-05-15','08:20:00',2.54),('11288','2013-05-15','08:25:00',2.7),('11288','2013-05-15','08:30:00',2.92),('11288','2013-05-15','08:35:00',2.97),('11288','2013-05-15','08:40:00',3.13),('11288','2013-05-15','08:45:00',3.29),('11288','2013-05-15','08:50:00',3.3),('11288','2013-05-15','08:55:00',3.64),('11288','2013-05-15','09:00:00',3.54),('11288','2013-05-15','09:05:00',3.9),('11288','2013-05-15','09:10:00',3.89),('11288','2013-05-15','09:15:00',4.12),('11288','2013-05-15','09:20:00',4.03),('11288','2013-05-15','09:25:00',4.24),('11288','2013-05-15','09:30:00',4.61),('11288','2013-05-15','09:35:00',4.68),('11288','2013-05-15','09:40:00',4.64),('11288','2013-05-15','09:45:00',4.84),('11288','2013-05-15','09:50:00',4.85),('11288','2013-05-15','09:55:00',4.88),('11288','2013-05-15','10:00:00',5.19),('11288','2013-05-15','10:05:00',5.13),('11288','2013-05-15','10:10:00',5.26),('11288','2013-05-15','10:15:00',5.29),('11288','2013-05-15','10:20:00',5.53),('11288','2013-05-15','10:25:00',5.73),('11288','2013-05-15','10:30:00',5.61),('11288','2013-05-15','10:35:00',5.89),('11288','2013-05-15','10:40:00',6.06),('11288','2013-05-15','10:45:00',6.12),('11288','2013-05-15','10:50:00',6.1),('11288','2013-05-15','10:55:00',5.9),('11288','2013-05-15','11:00:00',5.96),('11288','2013-05-15','11:05:00',6.3),('11288','2013-05-15','11:10:00',6.38),('11288','2013-05-15','11:15:00',6.44),('11288','2013-05-15','11:20:00',6.13),('11288','2013-05-15','11:25:00',6.5),('11288','2013-05-15','11:30:00',6.6),('11288','2013-05-15','11:35:00',6.49),('11288','2013-05-15','11:40:00',5.3),('11288','2013-05-15','11:45:00',5.07),('11288','2013-05-15','11:50:00',4.19),('11288','2013-05-15','11:55:00',3.18),('11288','2013-05-15','12:00:00',3.58),('11288','2013-05-15','12:05:00',5.55),('11288','2013-05-15','12:10:00',8.3),('11288','2013-05-15','12:15:00',7.41),('11288','2013-05-15','12:20:00',5.14),('11288','2013-05-15','12:25:00',6.32),('11288','2013-05-15','12:30:00',5.01),('11288','2013-05-15','12:35:00',6.21),('11288','2013-05-15','12:40:00',7.77),('11288','2013-05-15','12:45:00',4.31),('11288','2013-05-15','12:50:00',4.37),('11288','2013-05-15','12:55:00',4.93),('11288','2013-05-15','13:00:00',4.8),('11288','2013-05-15','13:05:00',5.97),('11288','2013-05-15','13:10:00',4.61),('11288','2013-05-15','13:15:00',4.48),('11288','2013-05-15','13:20:00',4.8),('11288','2013-05-15','13:25:00',4.9),('11288','2013-05-15','13:30:00',4.91),('11288','2013-05-15','13:35:00',4.23),('11288','2013-05-15','13:40:00',4.69),('11288','2013-05-15','13:45:00',4.34),('11288','2013-05-15','13:50:00',3.75),('11288','2013-05-15','13:55:00',3.7),('11288','2013-05-15','14:00:00',3.23),('11288','2013-05-15','14:05:00',2.91),('11288','2013-05-15','14:10:00',3.08),('11288','2013-05-15','14:15:00',3.02),('11288','2013-05-15','14:20:00',3.24),('11288','2013-05-15','14:25:00',2.96),('11288','2013-05-15','14:30:00',2.64),('11288','2013-05-15','14:35:00',2.63),('11288','2013-05-15','14:40:00',2.85),('11288','2013-05-15','14:45:00',2.65),('11288','2013-05-15','14:50:00',2.6),('11288','2013-05-15','14:55:00',2.64),('11288','2013-05-15','15:00:00',2.56),('11288','2013-05-15','15:05:00',1.99),('11288','2013-05-15','15:10:00',1.56),('11288','2013-05-15','15:15:00',1.49),('11288','2013-05-15','15:20:00',1.41),('11288','2013-05-15','15:25:00',1.32),('11288','2013-05-15','15:30:00',1.41),('11288','2013-05-15','15:35:00',1.38),('11288','2013-05-15','15:40:00',1.52),('11288','2013-05-15','15:45:00',2.02),('11288','2013-05-15','15:50:00',2.77),('11288','2013-05-15','15:55:00',3.56),('11288','2013-05-15','16:00:00',3.35),('11288','2013-05-15','16:05:00',3.16),('11288','2013-05-15','16:10:00',2.82),('11288','2013-05-15','16:15:00',2.52),('11288','2013-05-15','16:20:00',2.75),('11288','2013-05-15','16:25:00',2.76),('11288','2013-05-15','16:30:00',2.43),('11288','2013-05-15','16:35:00',2.28),('11288','2013-05-15','16:40:00',2.15),('11288','2013-05-15','16:45:00',2.09),('11288','2013-05-15','16:50:00',2.16),('11288','2013-05-15','16:55:00',2.49),('11288','2013-05-15','17:00:00',2.96),('11288','2013-05-15','17:05:00',3.37),('11288','2013-05-15','17:10:00',4),('11288','2013-05-15','17:15:00',4.17),('11288','2013-05-15','17:20:00',2.87),('11288','2013-05-15','17:25:00',1.67),('11288','2013-05-15','17:30:00',1.8),('11288','2013-05-15','17:35:00',1.56),('11288','2013-05-15','17:40:00',1.44),('11288','2013-05-15','17:45:00',1.5),('11288','2013-05-15','17:50:00',1.53),('11288','2013-05-15','17:55:00',1.47),('11288','2013-05-15','18:00:00',1.33),('11288','2013-05-15','18:05:00',1.07),('11288','2013-05-14','07:20:00',1.08),('11288','2013-05-14','07:25:00',1.14),('11288','2013-05-14','07:30:00',1.25),('11288','2013-05-14','07:35:00',1.32),('11288','2013-05-14','07:40:00',1.43),('11288','2013-05-14','07:45:00',1.69),('11288','2013-05-14','07:50:00',1.82),('11288','2013-05-14','07:55:00',1.91),('11288','2013-05-14','08:00:00',2.07),('11288','2013-05-14','08:05:00',2.02),('11288','2013-05-14','08:10:00',2.19),('11288','2013-05-14','08:15:00',2.5),('11288','2013-05-14','08:20:00',2.73),('11288','2013-05-14','08:25:00',2.88),('11288','2013-05-14','08:30:00',3.01),('11288','2013-05-14','08:35:00',3.18),('11288','2013-05-14','08:40:00',3.18),('11288','2013-05-14','08:45:00',3.42),('11288','2013-05-14','08:50:00',3.46),('11288','2013-05-14','08:55:00',3.61),('11288','2013-05-14','09:00:00',3.79),('11288','2013-05-14','09:05:00',4.13),('11288','2013-05-14','09:10:00',4.18),('11288','2013-05-14','09:15:00',4.31),('11288','2013-05-14','09:20:00',4.36),('11288','2013-05-14','09:25:00',4.44),('11288','2013-05-14','09:30:00',4.65),('11288','2013-05-14','09:35:00',4.89),('11288','2013-05-14','09:40:00',4.85),('11288','2013-05-14','09:45:00',4.96),('11288','2013-05-14','09:50:00',5.34),('11288','2013-05-14','09:55:00',5.42),('11288','2013-05-14','10:00:00',5.53),('11288','2013-05-14','10:05:00',5.68),('11288','2013-05-14','10:10:00',5.81),('11288','2013-05-14','10:15:00',5.9),('11288','2013-05-14','10:20:00',5.98),('11288','2013-05-14','10:25:00',6.08),('11288','2013-05-14','10:30:00',6.09),('11288','2013-05-14','10:35:00',6.21),('11288','2013-05-14','10:40:00',6.28),('11288','2013-05-14','10:45:00',6.39),('11288','2013-05-14','10:50:00',6.47),('11288','2013-05-14','10:55:00',6.52),('11288','2013-05-14','11:00:00',6.56),('11288','2013-05-14','11:05:00',6.67),('11288','2013-05-14','11:10:00',6.73),('11288','2013-05-14','11:15:00',6.73),('11288','2013-05-14','11:20:00',6.77),('11288','2013-05-14','11:25:00',6.8),('11288','2013-05-14','11:30:00',6.79),('11288','2013-05-14','11:35:00',6.82),('11288','2013-05-14','11:40:00',6.82),('11288','2013-05-14','11:45:00',6.86),('11288','2013-05-14','11:50:00',6.98),('11288','2013-05-14','11:55:00',7.03),('11288','2013-05-14','12:00:00',7.03),('11288','2013-05-14','12:05:00',7.05),('11288','2013-05-14','12:10:00',7.07),('11288','2013-05-14','12:15:00',7.11),('11288','2013-05-14','12:20:00',7.23),('11288','2013-05-14','12:25:00',7.25),('11288','2013-05-14','12:30:00',7.27),('11288','2013-05-14','12:35:00',7.27),('11288','2013-05-14','12:40:00',7.31),('11288','2013-05-14','12:45:00',7.32),('11288','2013-05-14','12:50:00',7.28),('11288','2013-05-14','12:55:00',7.31),('11288','2013-05-14','13:00:00',7.34),('11288','2013-05-14','13:05:00',7.31),('11288','2013-05-14','13:10:00',7.25),('11288','2013-05-14','13:15:00',7.27),('11288','2013-05-14','13:20:00',7.16),('11288','2013-05-14','13:25:00',7.18),('11288','2013-05-14','13:30:00',7.13),('11288','2013-05-14','13:35:00',7.09),('11288','2013-05-14','13:40:00',7.13),('11288','2013-05-14','13:45:00',7.08),('11288','2013-05-14','13:50:00',7.05),('11288','2013-05-14','13:55:00',7.03),('11288','2013-05-14','14:00:00',7.02),('11288','2013-05-14','14:05:00',6.96),('11288','2013-05-14','14:10:00',6.89),('11288','2013-05-14','14:15:00',6.88),('11288','2013-05-14','14:20:00',6.8),('11288','2013-05-14','14:25:00',6.73),('11288','2013-05-14','14:30:00',6.73),('11288','2013-05-14','14:35:00',6.71),('11288','2013-05-14','14:40:00',6.73),('11288','2013-05-14','14:45:00',6.78),('11288','2013-05-14','14:50:00',6.78),('11288','2013-05-14','14:55:00',6.76),('11288','2013-05-14','15:00:00',6.71),('11288','2013-05-14','15:05:00',6.65),('11288','2013-05-14','15:10:00',6.59),('11288','2013-05-14','15:15:00',6.51),('11288','2013-05-14','15:20:00',6.47),('11288','2013-05-14','15:25:00',6.44),('11288','2013-05-14','15:30:00',6.36),('11288','2013-05-14','15:35:00',6.27),('11288','2013-05-14','15:40:00',6.19),('11288','2013-05-14','15:45:00',6.1),('11288','2013-05-14','15:50:00',6.01),('11288','2013-05-14','15:55:00',5.92),('11288','2013-05-14','16:00:00',5.81),('11288','2013-05-14','16:05:00',5.68),('11288','2013-05-14','16:10:00',5.56),('11288','2013-05-14','16:15:00',5.46),('11288','2013-05-14','16:20:00',5.36),('11288','2013-05-14','16:25:00',5.26),('11288','2013-05-14','16:30:00',5.11),('11288','2013-05-14','16:35:00',5),('11288','2013-05-14','16:40:00',4.88),('11288','2013-05-14','16:45:00',4.76),('11288','2013-05-14','16:50:00',4.59),('11288','2013-05-14','16:55:00',4.48),('11288','2013-05-14','17:00:00',4.27),('11288','2013-05-14','17:05:00',4.12),('11288','2013-05-14','17:10:00',4.01),('11288','2013-05-14','17:15:00',3.9),('11288','2013-05-14','17:20:00',3.75),('11288','2013-05-14','17:25:00',3.6),('11288','2013-05-14','17:30:00',3.45),('11288','2013-05-14','17:35:00',3.26),('11288','2013-05-14','17:40:00',3.13),('11288','2013-05-14','17:45:00',3.01),('11288','2013-05-14','17:50:00',2.88),('11288','2013-05-14','17:55:00',2.81),('11288','2013-05-14','18:00:00',2.74),('11288','2013-05-14','18:05:00',2.56),('11288','2013-05-14','18:10:00',2.41),('11288','2013-05-14','18:15:00',2.28),('11288','2013-05-14','18:20:00',2.13),('11288','2013-05-14','18:25:00',2.01),('11288','2013-05-14','18:30:00',1.87),('11288','2013-05-14','18:35:00',1.73),('11288','2013-05-14','18:40:00',1.62),('11288','2013-05-14','18:45:00',1.47),('11288','2013-05-14','18:50:00',1.31),('11288','2013-05-14','18:55:00',1.16),('11288','2013-05-13','07:15:00',1.02),('11288','2013-05-13','07:35:00',1.29),('11288','2013-05-13','07:40:00',1.55),('11288','2013-05-13','07:45:00',1.72),('11288','2013-05-13','07:50:00',1.84),('11288','2013-05-13','07:55:00',2),('11288','2013-05-13','08:00:00',1.94),('11288','2013-05-13','08:05:00',2.02),('11288','2013-05-13','08:10:00',2.29),('11288','2013-05-13','08:15:00',2.39),('11288','2013-05-13','08:20:00',2.44),('11288','2013-05-13','08:25:00',2.8),('11288','2013-05-13','08:30:00',2.88),('11288','2013-05-13','08:35:00',2.95),('11288','2013-05-13','08:40:00',3.14),('11288','2013-05-13','08:45:00',3.22),('11288','2013-05-13','08:50:00',3.22),('11288','2013-05-13','08:55:00',3.56),('11288','2013-05-13','09:00:00',3.53),('11288','2013-05-13','09:05:00',3.6),('11288','2013-05-13','09:10:00',4.03),('11288','2013-05-13','09:15:00',4.12),('11288','2013-05-13','09:20:00',4.31),('11288','2013-05-13','09:25:00',4.49),('11288','2013-05-13','09:30:00',4.59),('11288','2013-05-13','09:35:00',4.75),('11288','2013-05-13','09:40:00',4.86),('11288','2013-05-13','09:45:00',5.09),('11288','2013-05-13','09:50:00',4.95),('11288','2013-05-13','09:55:00',5.53),('11288','2013-05-13','10:00:00',5.52),('11288','2013-05-13','10:05:00',5.55),('11288','2013-05-13','10:10:00',5.6),('11288','2013-05-13','10:15:00',4.79),('11288','2013-05-13','10:20:00',2.85),('11288','2013-05-13','10:25:00',6.3),('11288','2013-05-13','10:30:00',6.44),('11288','2013-05-13','10:35:00',3.8),('11288','2013-05-13','10:40:00',3.07),('11288','2013-05-13','10:45:00',1.69),('11288','2013-05-13','10:50:00',2.48),('11288','2013-05-13','10:55:00',4.04),('11288','2013-05-13','11:00:00',7.29),('11288','2013-05-13','11:05:00',4.52),('11288','2013-05-13','11:10:00',5.25),('11288','2013-05-13','11:15:00',3.16),('11288','2013-05-13','11:20:00',2.72),('11288','2013-05-13','11:25:00',2.86),('11288','2013-05-13','11:30:00',2.8),('11288','2013-05-13','11:35:00',4.23),('11288','2013-05-13','11:40:00',7.13),('11288','2013-05-13','11:45:00',3.84),('11288','2013-05-13','11:50:00',5.28),('11288','2013-05-13','11:55:00',3.13),('11288','2013-05-13','12:00:00',3.48),('11288','2013-05-13','12:05:00',3.3),('11288','2013-05-13','12:10:00',7.38),('11288','2013-05-13','12:15:00',3.33),('11288','2013-05-13','12:20:00',2.14),('11288','2013-05-13','12:25:00',1.87),('11288','2013-05-13','12:30:00',2.19),('11288','2013-05-13','12:35:00',8),('11288','2013-05-13','12:40:00',8.24),('11288','2013-05-13','12:45:00',7.96),('11288','2013-05-13','12:50:00',7.85),('11288','2013-05-13','12:55:00',5.42),('11288','2013-05-13','13:00:00',6.03),('11288','2013-05-13','13:05:00',7.16),('11288','2013-05-13','13:10:00',6.98),('11288','2013-05-13','13:15:00',4.11),('11288','2013-05-13','13:20:00',7.38),('11288','2013-05-13','13:25:00',6.64),('11288','2013-05-13','13:30:00',4.67),('11288','2013-05-13','13:35:00',6.53),('11288','2013-05-13','13:40:00',8.11),('11288','2013-05-13','13:45:00',6.87),('11288','2013-05-13','13:50:00',4.72),('11288','2013-05-13','13:55:00',3.18),('11288','2013-05-13','14:00:00',4.98),('11288','2013-05-13','14:05:00',7.95),('11288','2013-05-13','14:10:00',7.88),('11288','2013-05-13','14:15:00',7.67),('11288','2013-05-13','14:20:00',7.44),('11288','2013-05-13','14:25:00',7.38),('11288','2013-05-13','14:30:00',5.73),('11288','2013-05-13','14:35:00',4.74),('11288','2013-05-13','14:40:00',2.09),('11288','2013-05-13','14:45:00',3.32),('11288','2013-05-13','14:50:00',7.04),('11288','2013-05-13','14:55:00',7.71),('11288','2013-05-13','15:00:00',7.74),('11288','2013-05-13','15:05:00',3.29),('11288','2013-05-13','15:10:00',2.26),('11288','2013-05-13','15:15:00',1.68),('11288','2013-05-13','15:20:00',1.79),('11288','2013-05-13','15:25:00',1.46),('11288','2013-05-13','15:30:00',1.52),('11288','2013-05-13','15:35:00',1.33),('11288','2013-05-13','15:40:00',2.28),('11288','2013-05-13','15:45:00',1.55),('11288','2013-05-13','15:50:00',1.69),('11288','2013-05-13','15:55:00',1.23),('11288','2013-05-13','16:00:00',3.67),('11288','2013-05-13','16:05:00',4.13),('11288','2013-05-13','16:10:00',3.25),('11288','2013-05-13','16:15:00',2.25),('11288','2013-05-13','16:20:00',2.39),('11288','2013-05-13','16:25:00',2.48),('11288','2013-05-13','16:30:00',3.37),('11288','2013-05-13','16:35:00',2.23),('11288','2013-05-13','16:40:00',2.43),('11288','2013-05-13','16:45:00',3.87),('11288','2013-05-13','16:50:00',4.69),('11288','2013-05-13','16:55:00',4.46),('11288','2013-05-13','17:00:00',4.69),('11288','2013-05-13','17:05:00',4.68),('11288','2013-05-13','17:10:00',2.11),('11288','2013-05-13','17:15:00',3.67),('11288','2013-05-13','17:20:00',4.7),('11288','2013-05-13','17:25:00',4.54),('11288','2013-05-13','17:30:00',4.7),('11288','2013-05-13','17:35:00',4.35),('11288','2013-05-13','17:40:00',4.06),('11288','2013-05-13','17:45:00',3.85),('11288','2013-05-13','17:50:00',3.51),('11288','2013-05-13','17:55:00',1.83),('11288','2013-05-13','18:00:00',2.54),('11288','2013-05-13','18:05:00',2.51),('11288','2013-05-13','18:10:00',1.67),('11288','2013-05-13','18:15:00',2.65),('11288','2013-05-13','18:20:00',2.26),('11288','2013-05-13','18:25:00',1.29),('11288','2013-05-12','07:35:00',1.29),('11288','2013-05-12','07:40:00',1.19),('11288','2013-05-12','07:45:00',1.51),('11288','2013-05-12','07:50:00',1.54),('11288','2013-05-12','07:55:00',1.41),('11288','2013-05-12','08:00:00',1.38),('11288','2013-05-12','08:05:00',1.67),('11288','2013-05-12','08:10:00',2.3),('11288','2013-05-12','08:15:00',2.22),('11288','2013-05-12','08:20:00',2.28),('11288','2013-05-12','08:25:00',2.7),('11288','2013-05-12','08:30:00',3.39),('11288','2013-05-12','08:35:00',1.56),('11288','2013-05-12','08:40:00',1.66),('11288','2013-05-12','08:45:00',2.81),('11288','2013-05-12','08:50:00',1.85),('11288','2013-05-12','08:55:00',1.94),('11288','2013-05-12','09:00:00',2.92),('11288','2013-05-12','09:05:00',4.9),('11288','2013-05-12','09:10:00',2.28),('11288','2013-05-12','09:15:00',3.23),('11288','2013-05-12','09:20:00',3.54),('11288','2013-05-12','09:25:00',2.5),('11288','2013-05-12','09:30:00',2.16),('11288','2013-05-12','09:35:00',2.05),('11288','2013-05-12','09:40:00',2.06),('11288','2013-05-12','09:45:00',2.82),('11288','2013-05-12','09:50:00',4.88),('11288','2013-05-12','09:55:00',5.99),('11288','2013-05-12','10:00:00',3.88),('11288','2013-05-12','10:05:00',4.71),('11288','2013-05-12','10:10:00',4.7),('11288','2013-05-12','10:15:00',4.96),('11288','2013-05-12','10:20:00',5.91),('11288','2013-05-12','10:25:00',5.5),('11288','2013-05-12','10:30:00',2.16),('11288','2013-05-12','10:35:00',1.88),('11288','2013-05-12','10:40:00',1.6),('11288','2013-05-12','10:45:00',2.46),('11288','2013-05-12','10:50:00',6.29),('11288','2013-05-12','10:55:00',4.61),('11288','2013-05-12','11:00:00',5.14),('11288','2013-05-12','11:05:00',7.35),('11288','2013-05-12','11:10:00',7.33),('11288','2013-05-12','11:15:00',7.22),('11288','2013-05-12','11:20:00',7.25),('11288','2013-05-12','11:25:00',6.66),('11288','2013-05-12','11:30:00',5.92),('11288','2013-05-12','11:35:00',7.95),('11288','2013-05-12','11:40:00',5.49),('11288','2013-05-12','11:45:00',4.76),('11288','2013-05-12','11:50:00',3.72),('11288','2013-05-12','11:55:00',2.49),('11288','2013-05-12','12:00:00',4.36),('11288','2013-05-12','12:05:00',6.32),('11288','2013-05-12','12:10:00',2.59),('11288','2013-05-12','12:15:00',2.14),('11288','2013-05-12','12:20:00',2.03),('11288','2013-05-12','12:25:00',2.03),('11288','2013-05-12','12:30:00',2.87),('11288','2013-05-12','12:35:00',5.81),('11288','2013-05-12','12:40:00',7.28),('11288','2013-05-12','12:45:00',4.68),('11288','2013-05-12','12:50:00',5.8),('11288','2013-05-12','12:55:00',3.44),('11288','2013-05-12','13:00:00',2.75),('11288','2013-05-12','13:05:00',3.77),('11288','2013-05-12','13:10:00',5.79),('11288','2013-05-12','13:15:00',3),('11288','2013-05-12','13:20:00',5.27),('11288','2013-05-12','13:25:00',5.06),('11288','2013-05-12','13:30:00',6.61),('11288','2013-05-12','13:35:00',7.69),('11288','2013-05-12','13:40:00',5.53),('11288','2013-05-12','13:45:00',6.76),('11288','2013-05-12','13:50:00',8.44),('11288','2013-05-12','13:55:00',3.5),('11288','2013-05-12','14:00:00',5.68),('11288','2013-05-12','14:05:00',7.24),('11288','2013-05-12','14:10:00',7.72),('11288','2013-05-12','14:15:00',6.44),('11288','2013-05-12','14:20:00',7.22),('11288','2013-05-12','14:25:00',7.48),('11288','2013-05-12','14:30:00',7.5),('11288','2013-05-12','14:35:00',7.36),('11288','2013-05-12','14:40:00',7.28),('11288','2013-05-12','14:45:00',7.08),('11288','2013-05-12','14:50:00',7.21),('11288','2013-05-12','14:55:00',7.18),('11288','2013-05-12','15:00:00',7.09),('11288','2013-05-12','15:05:00',6.69),('11288','2013-05-12','15:10:00',6.18),('11288','2013-05-12','15:15:00',5.91),('11288','2013-05-12','15:20:00',4.28),('11288','2013-05-12','15:25:00',5.81),('11288','2013-05-12','15:30:00',6.45),('11288','2013-05-12','15:35:00',6.29),('11288','2013-05-12','15:40:00',6.27),('11288','2013-05-12','15:45:00',6.15),('11288','2013-05-12','15:50:00',6),('11288','2013-05-12','15:55:00',5.83),('11288','2013-05-12','16:00:00',4.63),('11288','2013-05-12','16:05:00',5.62),('11288','2013-05-12','16:10:00',5.52),('11288','2013-05-12','16:15:00',5.42),('11288','2013-05-12','16:20:00',5.3),('11288','2013-05-12','16:25:00',5.16),('11288','2013-05-12','16:30:00',5.07),('11288','2013-05-12','16:35:00',4.91),('11288','2013-05-12','16:40:00',4.75),('11288','2013-05-12','16:45:00',4.99),('11288','2013-05-12','16:50:00',4.66),('11288','2013-05-12','16:55:00',5.14),('11288','2013-05-12','17:00:00',5.14),('11288','2013-05-12','17:05:00',5.06),('11288','2013-05-12','17:10:00',4.99),('11288','2013-05-12','17:15:00',5.21),('11288','2013-05-12','17:20:00',4.65),('11288','2013-05-12','17:25:00',3.88),('11288','2013-05-12','17:30:00',2.99),('11288','2013-05-12','17:35:00',4.06),('11288','2013-05-12','17:40:00',3.57),('11288','2013-05-12','17:45:00',2.58),('11288','2013-05-12','17:50:00',2.27),('11288','2013-05-12','17:55:00',1.64),('11288','2013-05-12','18:00:00',3.35),('11288','2013-05-12','18:05:00',3.04),('11288','2013-05-12','18:10:00',2.82),('11288','2013-05-12','18:15:00',2.87),('11288','2013-05-12','18:20:00',2.04),('11288','2013-05-12','18:25:00',2.35),('11288','2013-05-12','18:30:00',2.01),('11288','2013-05-12','18:35:00',2.02),('11288','2013-05-12','18:40:00',1.9),('11288','2013-05-12','18:45:00',1.27),('11288','2013-05-12','18:50:00',1.33),('11288','2013-05-12','18:55:00',1.03),('11288','2013-05-12','19:00:00',1.47),('11288','2013-05-12','19:05:00',1.05),('11288','2013-05-12','19:10:00',1.19),('11288','2013-05-12','19:15:00',1.22),('11288','2013-05-12','19:20:00',1.04),('11288','2014-03-31','08:10:00',1.01),('11288','2014-03-31','08:15:00',1.06),('11288','2014-03-31','08:20:00',1.22),('11288','2014-03-31','08:25:00',1.33),('11288','2014-03-31','08:30:00',1.42),('11288','2014-03-31','08:35:00',1.63),('11288','2014-03-31','08:40:00',1.77),('11288','2014-03-31','08:45:00',1.81),('11288','2014-03-31','08:50:00',2.06),('11288','2014-03-31','08:55:00',2.19),('11288','2014-03-31','09:00:00',2.37),('11288','2014-03-31','09:05:00',2.46),('11288','2014-03-31','09:10:00',2.6),('11288','2014-03-31','09:15:00',2.69),('11288','2014-03-31','09:20:00',2.88),('11288','2014-03-31','09:25:00',2.8),('11288','2014-03-31','09:30:00',2.86),('11288','2014-03-31','09:35:00',3.33),('11288','2014-03-31','09:40:00',3.31),('11288','2014-03-31','09:45:00',3.66),('11288','2014-03-31','09:50:00',3.86),('11288','2014-03-31','09:55:00',4.01),('11288','2014-03-31','10:00:00',4.1),('11288','2014-03-31','10:05:00',4.24),('11288','2014-03-31','10:10:00',4.43),('11288','2014-03-31','10:15:00',4.53),('11288','2014-03-31','10:20:00',4.7),('11288','2014-03-31','10:25:00',4.84),('11288','2014-03-31','10:30:00',4.89),('11288','2014-03-31','10:35:00',4.97),('11288','2014-03-31','10:40:00',5.06),('11288','2014-03-31','10:45:00',5.17),('11288','2014-03-31','10:50:00',5.24),('11288','2014-03-31','10:55:00',5.32),('11288','2014-03-31','11:00:00',5.38),('11288','2014-03-31','11:05:00',5.45),('11288','2014-03-31','11:10:00',5.54),('11288','2014-03-31','11:15:00',5.54),('11288','2014-03-31','11:20:00',5.58),('11288','2014-03-31','11:25:00',5.67),('11288','2014-03-31','11:30:00',5.72),('11288','2014-03-31','11:35:00',5.74),('11288','2014-03-31','11:40:00',5.8),('11288','2014-03-31','11:45:00',5.87),('11288','2014-03-31','11:50:00',5.93),('11288','2014-03-31','11:55:00',5.93),('11288','2014-03-31','12:00:00',6.01),('11288','2014-03-31','12:05:00',6.11),('11288','2014-03-31','12:10:00',6.21),('11288','2014-03-31','12:15:00',6.24),('11288','2014-03-31','12:20:00',6.22),('11288','2014-03-31','12:25:00',6.31),('11288','2014-03-31','12:30:00',6.35),('11288','2014-03-31','12:35:00',6.37),('11288','2014-03-31','12:40:00',6.38),('11288','2014-03-31','12:45:00',6.35),('11288','2014-03-31','12:50:00',6.35),('11288','2014-03-31','12:55:00',6.35),('11288','2014-03-31','13:00:00',6.38),('11288','2014-03-31','13:05:00',6.42),('11288','2014-03-31','13:10:00',6.43),('11288','2014-03-31','13:15:00',6.44),('11288','2014-03-31','13:20:00',6.43),('11288','2014-03-31','13:25:00',6.44),('11288','2014-03-31','13:30:00',6.44),('11288','2014-03-31','13:35:00',6.41),('11288','2014-03-31','13:40:00',6.42),('11288','2014-03-31','13:45:00',6.4),('11288','2014-03-31','13:50:00',6.38),('11288','2014-03-31','13:55:00',6.37),('11288','2014-03-31','14:00:00',6.33),('11288','2014-03-31','14:05:00',6.3),('11288','2014-03-31','14:10:00',6.3),('11288','2014-03-31','14:15:00',6.3),('11288','2014-03-31','14:20:00',6.23),('11288','2014-03-31','14:25:00',6.17),('11288','2014-03-31','14:30:00',6.14),('11288','2014-03-31','14:35:00',6.12),('11288','2014-03-31','14:40:00',6.1),('11288','2014-03-31','14:45:00',6.06),('11288','2014-03-31','14:50:00',6),('11288','2014-03-31','14:55:00',5.9),('11288','2014-03-31','15:00:00',5.87),('11288','2014-03-31','15:05:00',5.8),('11288','2014-03-31','15:10:00',5.74),('11288','2014-03-31','15:15:00',5.69),('11288','2014-03-31','15:20:00',5.64),('11288','2014-03-31','15:25:00',5.54),('11288','2014-03-31','15:30:00',5.46),('11288','2014-03-31','15:35:00',5.35),('11288','2014-03-31','15:40:00',5.25),('11288','2014-03-31','15:45:00',5.18),('11288','2014-03-31','15:50:00',5.02),('11288','2014-03-31','15:55:00',4.89),('11288','2014-03-31','16:00:00',4.79),('11288','2014-03-31','16:05:00',4.67),('11288','2014-03-31','16:10:00',4.53),('11288','2014-03-31','16:15:00',4.41),('11288','2014-03-31','16:20:00',4.31),('11288','2014-03-31','16:25:00',4.17),('11288','2014-03-31','16:30:00',4.05),('11288','2014-03-31','16:35:00',3.9),('11288','2014-03-31','16:40:00',3.8),('11288','2014-03-31','16:45:00',3.67),('11288','2014-03-31','16:50:00',3.52),('11288','2014-03-31','16:55:00',3.37),('11288','2014-03-31','17:00:00',3.2),('11288','2014-03-31','17:05:00',3.09),('11288','2014-03-31','17:10:00',2.94),('11288','2014-03-31','17:15:00',2.79),('11288','2014-03-31','17:20:00',2.63),('11288','2014-03-31','17:25:00',2.49),('11288','2014-03-31','17:30:00',2.35),('11288','2014-03-31','17:35:00',2.18),('11288','2014-03-31','17:40:00',2.08),('11288','2014-03-31','17:45:00',1.94),('11288','2014-03-31','17:50:00',1.8),('11288','2014-03-31','17:55:00',1.66),('11288','2014-03-31','18:00:00',1.53),('11288','2014-03-31','18:05:00',1.38),('11288','2014-03-31','18:10:00',1.25),('11288','2014-03-31','18:15:00',1.14),('11288','2014-03-31','18:20:00',1),('11288','2013-05-11','07:25:00',1.12),('11288','2013-05-11','07:30:00',1.28),('11288','2013-05-11','07:40:00',1.41),('11288','2013-05-11','07:45:00',1.7),('11288','2013-05-11','07:50:00',1.98),('11288','2013-05-11','07:55:00',2.24),('11288','2013-05-11','08:00:00',2.22),('11288','2013-05-11','08:05:00',1.98),('11288','2013-05-11','08:10:00',1.82),('11288','2013-05-11','08:15:00',2.24),('11288','2013-05-11','08:20:00',2.5),('11288','2013-05-11','08:25:00',1.47),('11288','2013-05-11','08:30:00',1.66),('11288','2013-05-11','08:35:00',1.57),('11288','2013-05-11','08:45:00',1.22),('11288','2013-05-11','08:50:00',1.57),('11288','2013-05-11','08:55:00',1.7),('11288','2013-05-11','09:00:00',1.75),('11288','2013-05-11','09:05:00',2.47),('11288','2013-05-11','09:10:00',2.24),('11288','2013-05-11','09:15:00',2.74),('11288','2013-05-11','09:20:00',3.53),('11288','2013-05-11','09:25:00',3.24),('11288','2013-05-11','09:30:00',5.51),('11288','2013-05-11','09:35:00',3.15),('11288','2013-05-11','09:40:00',2.46),('11288','2013-05-11','09:45:00',2.46),('11288','2013-05-11','09:50:00',2.46),('11288','2013-05-11','09:55:00',5.5),('11288','2013-05-11','10:00:00',4.34),('11288','2013-05-11','10:05:00',1.95),('11288','2013-05-11','10:10:00',1.41),('11288','2013-05-11','10:15:00',1.55),('11288','2013-05-11','10:20:00',1.87),('11288','2013-05-11','10:25:00',1.8),('11288','2013-05-11','10:30:00',2.56),('11288','2013-05-11','10:35:00',2.06),('11288','2013-05-11','10:40:00',1.57),('11288','2013-05-11','10:45:00',1.89),('11288','2013-05-11','10:50:00',2.85),('11288','2013-05-11','10:55:00',7.47),('11288','2013-05-11','11:00:00',7.15),('11288','2013-05-11','11:05:00',2.93),('11288','2013-05-11','11:10:00',1.99),('11288','2013-05-11','11:15:00',1.52),('11288','2013-05-11','11:20:00',1.52),('11288','2013-05-11','11:25:00',2.04),('11288','2013-05-11','11:30:00',6.07),('11288','2013-05-11','11:35:00',5.01),('11288','2013-05-11','11:40:00',6.1),('11288','2013-05-11','11:45:00',6.31),('11288','2013-05-11','11:50:00',2.36),('11288','2013-05-11','11:55:00',1.95),('11288','2013-05-11','12:00:00',3.25),('11288','2013-05-11','12:05:00',3.64),('11288','2013-05-11','12:10:00',2.42),('11288','2013-05-11','12:15:00',2.38),('11288','2013-05-11','12:20:00',5.93),('11288','2013-05-11','12:25:00',8.59),('11288','2013-05-11','12:30:00',3.69),('11288','2013-05-11','12:35:00',3.34),('11288','2013-05-11','12:40:00',3.09),('11288','2013-05-11','12:45:00',2.99),('11288','2013-05-11','12:50:00',2.93),('11288','2013-05-11','12:55:00',2.77),('11288','2013-05-11','13:00:00',3.55),('11288','2013-05-11','13:05:00',2.64),('11288','2013-05-11','13:10:00',1.71),('11288','2013-05-11','13:15:00',1.13),('11288','2013-05-11','13:20:00',1.57),('11288','2013-05-11','13:25:00',1.9),('11288','2013-05-11','13:30:00',1.93),('11288','2013-05-11','13:35:00',1.94),('11288','2013-05-11','13:40:00',1.22),('11288','2013-05-11','13:45:00',1.09),('11288','2013-05-11','13:50:00',1.73),('11288','2013-05-11','13:55:00',2.1),('11288','2013-05-11','14:00:00',3.52),('11288','2013-05-11','14:05:00',6.41),('11288','2013-05-11','14:10:00',4.56),('11288','2013-05-11','14:15:00',5.91),('11288','2013-05-11','14:20:00',7.46),('11288','2013-05-11','14:25:00',6),('11288','2013-05-11','14:30:00',3.05),('11288','2013-05-11','14:35:00',5.89),('11288','2013-05-11','14:40:00',6.53),('11288','2013-05-11','14:45:00',6.87),('11288','2013-05-11','14:50:00',7.5),('11288','2013-05-11','14:55:00',6.94),('11288','2013-05-11','15:00:00',7.02),('11288','2013-05-11','15:05:00',6.61),('11288','2013-05-11','15:10:00',6.61),('11288','2013-05-11','15:15:00',6.38),('11288','2013-05-11','15:20:00',6.16),('11288','2013-05-11','15:25:00',6.71),('11288','2013-05-11','15:30:00',5.92),('11288','2013-05-11','15:35:00',6.19),('11288','2013-05-11','15:40:00',6.49),('11288','2013-05-11','15:45:00',5.76),('11288','2013-05-11','15:50:00',6.28),('11288','2013-05-11','15:55:00',5.09),('11288','2013-05-11','16:00:00',4.47),('11288','2013-05-11','16:05:00',5.49),('11288','2013-05-11','16:10:00',4.11),('11288','2013-05-11','16:15:00',5.98),('11288','2013-05-11','16:20:00',5.41),('11288','2013-05-11','16:25:00',5.45),('11288','2013-05-11','16:30:00',5.09),('11288','2013-05-11','16:35:00',3.17),('11288','2013-05-11','16:40:00',5.01),('11288','2013-05-11','16:45:00',4.87),('11288','2013-05-11','16:50:00',4.05),('11288','2013-05-11','16:55:00',4.78),('11288','2013-05-11','17:00:00',4.55),('11288','2013-05-11','17:05:00',2.61),('11288','2013-05-11','17:10:00',3.63),('11288','2013-05-11','17:15:00',2.22),('11288','2013-05-11','17:20:00',2.65),('11288','2013-05-11','17:25:00',2.1),('11288','2013-05-11','17:30:00',3.24),('11288','2013-05-11','17:35:00',2.72),('11288','2013-05-11','17:40:00',3.07),('11288','2013-05-11','17:45:00',2.24),('11288','2013-05-11','17:50:00',1.5),('11288','2013-05-11','17:55:00',1.75),('11288','2013-05-11','18:00:00',1.76),('11288','2013-05-11','18:05:00',2.67),('11288','2013-05-11','18:10:00',3),('11288','2013-05-11','18:15:00',1.71),('11288','2013-05-11','18:20:00',1.81),('11288','2013-05-11','18:25:00',1.87),('11288','2013-05-11','18:30:00',2.01),('11288','2013-05-11','18:35:00',1.07),('11288','2013-05-11','18:40:00',1.52),('11288','2013-05-11','18:45:00',1.06),('11288','2013-05-11','19:00:00',1.04),('11288','2013-05-10','07:30:00',1.08),('11288','2013-05-10','07:35:00',1.35),('11288','2013-05-10','07:40:00',1.72),('11288','2013-05-10','07:45:00',1.42),('11288','2013-05-10','07:50:00',1.35),('11288','2013-05-10','07:55:00',1.91),('11288','2013-05-10','08:00:00',2.24),('11288','2013-05-10','08:05:00',2.63),('11288','2013-05-10','08:10:00',3.21),('11288','2013-05-10','08:15:00',3.27),('11288','2013-05-10','08:20:00',3.12),('11288','2013-05-10','08:25:00',3.15),('11288','2013-05-10','08:30:00',3.1),('11288','2013-05-10','08:35:00',3.14),('11288','2013-05-10','08:40:00',1.32),('11288','2013-05-10','08:45:00',1.03),('11288','2013-05-10','08:55:00',1.12),('11288','2013-05-10','09:00:00',2.41),('11288','2013-05-10','09:05:00',3.61),('11288','2013-05-10','09:10:00',4.31),('11288','2013-05-10','09:15:00',4.4),('11288','2013-05-10','09:20:00',4.16),('11288','2013-05-10','09:25:00',4.11),('11288','2013-05-10','09:30:00',4.18),('11288','2013-05-10','09:35:00',4.68),('11288','2013-05-10','09:40:00',4.48),('11288','2013-05-10','09:45:00',4.48),('11288','2013-05-10','09:50:00',4.46),('11288','2013-05-10','09:55:00',2.46),('11288','2013-05-10','10:00:00',2.4),('11288','2013-05-10','10:05:00',2.45),('11288','2013-05-10','10:10:00',2.93),('11288','2013-05-10','10:15:00',5.33),('11288','2013-05-10','10:20:00',2.09),('11288','2013-05-10','10:25:00',4.43),('11288','2013-05-10','10:30:00',6.49),('11288','2013-05-10','10:35:00',6.49),('11288','2013-05-10','10:40:00',6.7),('11288','2013-05-10','10:45:00',6.71),('11288','2013-05-10','10:50:00',6.46),('11288','2013-05-10','10:55:00',6.59),('11288','2013-05-10','11:00:00',6.63),('11288','2013-05-10','11:05:00',6.59),('11288','2013-05-10','11:10:00',6.5),('11288','2013-05-10','11:15:00',6.8),('11288','2013-05-10','11:20:00',7.23),('11288','2013-05-10','11:25:00',5.66),('11288','2013-05-10','11:30:00',6.52),('11288','2013-05-10','11:35:00',5.59),('11288','2013-05-10','11:40:00',5.62),('11288','2013-05-10','11:45:00',4.8),('11288','2013-05-10','11:50:00',5.97),('11288','2013-05-10','11:55:00',6.94),('11288','2013-05-10','12:00:00',4.77),('11288','2013-05-10','12:05:00',3.95),('11288','2013-05-10','12:10:00',4.06),('11288','2013-05-10','12:15:00',5.06),('11288','2013-05-10','12:20:00',4.66),('11288','2013-05-10','12:25:00',4.18),('11288','2013-05-10','12:30:00',3.66),('11288','2013-05-10','12:35:00',3.47),('11288','2013-05-10','12:40:00',6.6),('11288','2013-05-10','12:45:00',7.95),('11288','2013-05-10','12:50:00',5.01),('11288','2013-05-10','12:55:00',4.75),('11288','2013-05-10','13:00:00',6.24),('11288','2013-05-10','13:05:00',8.12),('11288','2013-05-10','13:10:00',9.29),('11288','2013-05-10','13:15:00',7.19),('11288','2013-05-10','13:20:00',5.62),('11288','2013-05-10','13:25:00',4.7),('11288','2013-05-10','13:30:00',5.88),('11288','2013-05-10','13:35:00',6.24),('11288','2013-05-10','13:40:00',6.49),('11288','2013-05-10','13:45:00',6.05),('11288','2013-05-10','13:50:00',3.79),('11288','2013-05-10','13:55:00',3.66),('11288','2013-05-10','14:00:00',3.42),('11288','2013-05-10','14:05:00',3.75),('11288','2013-05-10','14:10:00',4.52),('11288','2013-05-10','14:15:00',4.69),('11288','2013-05-10','14:20:00',4.49),('11288','2013-05-10','14:25:00',4.73),('11288','2013-05-10','14:30:00',4.49),('11288','2013-05-10','14:35:00',5.4),('11288','2013-05-10','14:40:00',4.9),('11288','2013-05-10','14:45:00',3.26),('11288','2013-05-10','14:50:00',2.54),('11288','2013-05-10','14:55:00',2.25),('11288','2013-05-10','15:00:00',2.19),('11288','2013-05-10','15:05:00',2.52),('11288','2013-05-10','15:10:00',3.51),('11288','2013-05-10','15:15:00',5.33),('11288','2013-05-10','15:20:00',4.21),('11288','2013-05-10','15:25:00',3.47),('11288','2013-05-10','15:30:00',3.4),('11288','2013-05-10','15:35:00',3.51),('11288','2013-05-10','15:40:00',3.63),('11288','2013-05-10','15:45:00',3.42),('11288','2013-05-10','15:50:00',3.11),('11288','2013-05-10','15:55:00',2.98),('11288','2013-05-10','16:00:00',2.94),('11288','2013-05-10','16:05:00',2.86),('11288','2013-05-10','16:10:00',2.75),('11288','2013-05-10','16:15:00',2.53),('11288','2013-05-10','16:20:00',2.34),('11288','2013-05-10','16:25:00',2.41),('11288','2013-05-10','16:30:00',2.6),('11288','2013-05-10','16:35:00',2.72),('11288','2013-05-10','16:40:00',2.56),('11288','2013-05-10','16:45:00',2.51),('11288','2013-05-10','16:50:00',2.38),('11288','2013-05-10','16:55:00',1.93),('11288','2013-05-10','17:00:00',1.63),('11288','2013-05-10','17:05:00',1.76),('11288','2013-05-10','17:10:00',2.32),('11288','2013-05-10','17:15:00',2.78),('11288','2013-05-10','17:20:00',3.85),('11288','2013-05-10','17:25:00',3.8),('11288','2013-05-10','17:30:00',3.46),('11288','2013-05-10','17:35:00',3.66),('11288','2013-05-10','17:40:00',2.43),('11288','2013-05-10','17:45:00',2.43),('11288','2013-05-10','17:50:00',1.9),('11288','2013-05-10','17:55:00',1.73),('11288','2013-05-10','18:00:00',1.66),('11288','2013-05-10','18:05:00',1.64),('11288','2013-05-10','18:10:00',1.47),('11288','2013-05-10','18:15:00',1.36),('11288','2013-05-10','18:20:00',1.36),('11288','2013-05-10','18:25:00',1.15),('11288','2013-05-09','07:25:00',1.09),('11288','2013-05-09','07:30:00',1.22),('11288','2013-05-09','07:35:00',1.32),('11288','2013-05-09','07:40:00',1.46),('11288','2013-05-09','07:45:00',1.56),('11288','2013-05-09','07:50:00',1.6),('11288','2013-05-09','07:55:00',1.81),('11288','2013-05-09','08:00:00',1.88),('11288','2013-05-09','08:05:00',1.92),('11288','2013-05-09','08:10:00',2.24),('11288','2013-05-09','08:15:00',2.17),('11288','2013-05-09','08:20:00',2.34),('11288','2013-05-09','08:25:00',2.75),('11288','2013-05-09','08:30:00',2.77),('11288','2013-05-09','08:35:00',2.92),('11288','2013-05-09','08:40:00',3.12),('11288','2013-05-09','08:45:00',3.29),('11288','2013-05-09','08:50:00',3.32),('11288','2013-05-09','08:55:00',3.55),('11288','2013-05-09','09:00:00',3.5),('11288','2013-05-09','09:05:00',3.81),('11288','2013-05-09','09:10:00',4.08),('11288','2013-05-09','09:15:00',4.14),('11288','2013-05-09','09:20:00',4.14),('11288','2013-05-09','09:25:00',4.45),('11288','2013-05-09','09:30:00',4.63),('11288','2013-05-09','09:35:00',4.65),('11288','2013-05-09','09:40:00',4.93),('11288','2013-05-09','09:45:00',4.86),('11288','2013-05-09','09:50:00',4.94),('11288','2013-05-09','09:55:00',5.27),('11288','2013-05-09','10:00:00',5.42),('11288','2013-05-09','10:05:00',5.56),('11288','2013-05-09','10:10:00',5.59),('11288','2013-05-09','10:15:00',5.72),('11288','2013-05-09','10:20:00',5.78),('11288','2013-05-09','10:25:00',5.8),('11288','2013-05-09','10:30:00',5.92),('11288','2013-05-09','10:35:00',5.99),('11288','2013-05-09','10:40:00',6.07),('11288','2013-05-09','10:45:00',6.16),('11288','2013-05-09','10:50:00',6.19),('11288','2013-05-09','10:55:00',6.33),('11288','2013-05-09','11:00:00',6.44),('11288','2013-05-09','11:05:00',6.51),('11288','2013-05-09','11:10:00',6.49),('11288','2013-05-09','11:15:00',6.56),('11288','2013-05-09','11:20:00',6.61),('11288','2013-05-09','11:25:00',6.64),('11288','2013-05-09','11:30:00',6.67),('11288','2013-05-09','11:35:00',6.68),('11288','2013-05-09','11:40:00',6.69),('11288','2013-05-09','11:45:00',6.79),('11288','2013-05-09','11:50:00',6.85),('11288','2013-05-09','11:55:00',6.9),('11288','2013-05-09','12:00:00',6.95),('11288','2013-05-09','12:05:00',6.99),('11288','2013-05-09','12:10:00',6.94),('11288','2013-05-09','12:15:00',7.12),('11288','2013-05-09','12:20:00',7.09),('11288','2013-05-09','12:25:00',7.14),('11288','2013-05-09','12:30:00',7.13),('11288','2013-05-09','12:35:00',7.18),('11288','2013-05-09','12:40:00',7.14),('11288','2013-05-09','12:45:00',7.21),('11288','2013-05-09','12:50:00',7.24),('11288','2013-05-09','12:55:00',7.21),('11288','2013-05-09','13:00:00',7.15),('11288','2013-05-09','13:05:00',7.19),('11288','2013-05-09','13:10:00',7.15),('11288','2013-05-09','13:15:00',7.15),('11288','2013-05-09','13:20:00',7.12),('11288','2013-05-09','13:25:00',7.05),('11288','2013-05-09','13:30:00',7.06),('11288','2013-05-09','13:35:00',7.09),('11288','2013-05-09','13:40:00',7.15),('11288','2013-05-09','13:45:00',7.22),('11288','2013-05-09','13:50:00',7.17),('11288','2013-05-09','13:55:00',7.25),('11288','2013-05-09','14:00:00',7.32),('11288','2013-05-09','14:05:00',5.92),('11288','2013-05-09','14:10:00',6.81),('11288','2013-05-09','14:15:00',6.7),('11288','2013-05-09','14:20:00',7.33),('11288','2013-05-09','14:25:00',5.68),('11288','2013-05-09','14:30:00',6.86),('11288','2013-05-09','14:35:00',6.8),('11288','2013-05-09','14:40:00',6.66),('11288','2013-05-09','14:45:00',6.7),('11288','2013-05-09','14:50:00',6.56),('11288','2013-05-09','14:55:00',6.67),('11288','2013-05-09','15:00:00',6.55),('11288','2013-05-09','15:05:00',6.51),('11288','2013-05-09','15:10:00',6.42),('11288','2013-05-09','15:15:00',6.38),('11288','2013-05-09','15:20:00',6.32),('11288','2013-05-09','15:25:00',6.23),('11288','2013-05-09','15:30:00',6.14),('11288','2013-05-09','15:35:00',6.08),('11288','2013-05-09','15:40:00',6),('11288','2013-05-09','15:45:00',5.95),('11288','2013-05-09','15:50:00',5.85),('11288','2013-05-09','15:55:00',5.73),('11288','2013-05-09','16:00:00',5.65),('11288','2013-05-09','16:05:00',5.54),('11288','2013-05-09','16:10:00',5.44),('11288','2013-05-09','16:15:00',5.29),('11288','2013-05-09','16:20:00',5.23),('11288','2013-05-09','16:25:00',5.08),('11288','2013-05-09','16:30:00',5),('11288','2013-05-09','16:35:00',4.85),('11288','2013-05-09','16:40:00',4.67),('11288','2013-05-09','16:45:00',4.51),('11288','2013-05-09','16:50:00',4.39),('11288','2013-05-09','16:55:00',4.27),('11288','2013-05-09','17:00:00',4.17),('11288','2013-05-09','17:05:00',3.97),('11288','2013-05-09','17:10:00',3.79),('11288','2013-05-09','17:15:00',3.73),('11288','2013-05-09','17:20:00',3.59),('11288','2013-05-09','17:25:00',3.46),('11288','2013-05-09','17:30:00',3.31),('11288','2013-05-09','17:35:00',3.09),('11288','2013-05-09','17:40:00',3.01),('11288','2013-05-09','17:45:00',2.86),('11288','2013-05-09','17:50:00',2.7),('11288','2013-05-09','17:55:00',2.57),('11288','2013-05-09','18:00:00',2.51),('11288','2013-05-09','18:05:00',2.43),('11288','2013-05-09','18:10:00',2.27),('11288','2013-05-09','18:15:00',2.14),('11288','2013-05-09','18:20:00',2.01),('11288','2013-05-09','18:25:00',1.86),('11288','2013-05-09','18:30:00',1.73),('11288','2013-05-09','18:35:00',1.58),('11288','2013-05-09','18:40:00',1.44),('11288','2013-05-09','18:45:00',1.31),('11288','2013-05-09','18:50:00',1.16),('11288','2013-05-09','18:55:00',1.01),('11288','2013-05-08','08:00:00',1.32),('11288','2013-05-08','08:05:00',2.24),('11288','2013-05-08','08:10:00',2.38),('11288','2013-05-08','08:15:00',2.34),('11288','2013-05-08','08:20:00',2.27),('11288','2013-05-08','08:25:00',2.63),('11288','2013-05-08','08:30:00',2.72),('11288','2013-05-08','08:35:00',3.02),('11288','2013-05-08','08:40:00',3.22),('11288','2013-05-08','08:45:00',3.01),('11288','2013-05-08','08:50:00',3.37),('11288','2013-05-08','08:55:00',2.16),('11288','2013-05-08','09:00:00',1.65),('11288','2013-05-08','09:05:00',1.31),('11288','2013-05-08','09:10:00',1.11),('11288','2013-05-08','09:30:00',1.45),('11288','2013-05-08','09:35:00',5.5),('11288','2013-05-08','09:40:00',6.2),('11288','2013-05-08','09:45:00',5.93),('11288','2013-05-08','09:50:00',4.59),('11288','2013-05-08','09:55:00',2.22),('11288','2013-05-08','10:00:00',3.71),('11288','2013-05-08','10:05:00',5.23),('11288','2013-05-08','10:10:00',2.56),('11288','2013-05-08','10:15:00',1.69),('11288','2013-05-08','10:20:00',1.86),('11288','2013-05-08','10:25:00',2),('11288','2013-05-08','10:30:00',3.13),('11288','2013-05-08','10:35:00',1.83),('11288','2013-05-08','10:40:00',2.08),('11288','2013-05-08','10:45:00',1.65),('11288','2013-05-08','10:50:00',3.16),('11288','2013-05-08','10:55:00',5.89),('11288','2013-05-08','11:00:00',2.69),('11288','2013-05-08','11:05:00',6.05),('11288','2013-05-08','11:10:00',5.64),('11288','2013-05-08','11:15:00',5.47),('11288','2013-05-08','11:20:00',5),('11288','2013-05-08','11:25:00',7.3),('11288','2013-05-08','11:30:00',7.41),('11288','2013-05-08','11:35:00',7.6),('11288','2013-05-08','11:40:00',5.71),('11288','2013-05-08','11:45:00',4.88),('11288','2013-05-08','11:50:00',3.95),('11288','2013-05-08','11:55:00',6.59),('11288','2013-05-08','12:00:00',2.29),('11288','2013-05-08','12:05:00',1.55),('11288','2013-05-08','12:10:00',1.44),('11288','2013-05-08','12:15:00',1.93),('11288','2013-05-08','12:20:00',4.02),('11288','2013-05-08','12:25:00',4.79),('11288','2013-05-08','12:30:00',2.38),('11288','2013-05-08','12:35:00',4.73),('11288','2013-05-08','12:40:00',3.37),('11288','2013-05-08','12:45:00',2.13),('11288','2013-05-08','12:50:00',4.78),('11288','2013-05-08','12:55:00',2.99),('11288','2013-05-08','13:00:00',2.45),('11288','2013-05-08','13:05:00',2.45),('11288','2013-05-08','13:10:00',8.58),('11288','2013-05-08','13:15:00',4.96),('11288','2013-05-08','13:20:00',2.08),('11288','2013-05-08','13:25:00',5.31),('11288','2013-05-08','13:30:00',1.94),('11288','2013-05-08','13:35:00',1.83),('11288','2013-05-08','13:40:00',4.72),('11288','2013-05-08','13:45:00',8.62),('11288','2013-05-08','13:50:00',8.66),('11288','2013-05-08','13:55:00',7.56),('11288','2013-05-08','14:00:00',8.1),('11288','2013-05-08','14:05:00',4.01),('11288','2013-05-08','14:10:00',2.67),('11288','2013-05-08','14:15:00',4.22),('11288','2013-05-08','14:20:00',2.81),('11288','2013-05-08','14:25:00',5.15),('11288','2013-05-08','14:30:00',5.83),('11288','2013-05-08','14:35:00',5.13),('11288','2013-05-08','14:40:00',3.36),('11288','2013-05-08','14:45:00',3.85),('11288','2013-05-08','14:50:00',7.43),('11288','2013-05-08','14:55:00',6.92),('11288','2013-05-08','15:00:00',6.86),('11288','2013-05-08','15:05:00',6.75),('11288','2013-05-08','15:10:00',6.64),('11288','2013-05-08','15:15:00',6.53),('11288','2013-05-08','15:20:00',6.45),('11288','2013-05-08','15:25:00',6.42),('11288','2013-05-08','15:30:00',6.28),('11288','2013-05-08','15:35:00',6.15),('11288','2013-05-08','15:40:00',6.04),('11288','2013-05-08','15:45:00',5.93),('11288','2013-05-08','15:50:00',5.91),('11288','2013-05-08','15:55:00',5.87),('11288','2013-05-08','16:00:00',5.84),('11288','2013-05-08','16:05:00',5.63),('11288','2013-05-08','16:10:00',5.11),('11288','2013-05-08','16:15:00',5.38),('11288','2013-05-08','16:20:00',5.29),('11288','2013-05-08','16:25:00',5.02),('11288','2013-05-08','16:30:00',5.18),('11288','2013-05-08','16:35:00',5.07),('11288','2013-05-08','16:40:00',2.59),('11288','2013-05-08','16:45:00',4.57),('11288','2013-05-08','16:50:00',2.85),('11288','2013-05-08','16:55:00',2.99),('11288','2013-05-08','17:00:00',4.45),('11288','2013-05-08','17:05:00',4.02),('11288','2013-05-08','17:10:00',4.26),('11288','2013-05-08','17:15:00',3.92),('11288','2013-05-08','17:20:00',3.53),('11288','2013-05-08','17:25:00',3.86),('11288','2013-05-08','17:30:00',3.93),('11288','2013-05-08','17:35:00',3.71),('11288','2013-05-08','17:40:00',3.63),('11288','2013-05-08','17:45:00',3.7),('11288','2013-05-08','17:50:00',3.7),('11288','2013-05-08','17:55:00',3.53),('11288','2013-05-08','18:00:00',2.13),('11288','2013-05-08','18:05:00',1.47),('11288','2013-05-08','18:10:00',1.56),('11288','2013-05-08','18:15:00',2.7),('11288','2013-05-08','18:20:00',2.59),('11288','2013-05-08','18:25:00',2.38),('11288','2013-05-08','18:30:00',2.04),('11288','2013-05-08','18:35:00',1.78),('11288','2013-05-07','07:30:00',1.18),('11288','2013-05-07','07:35:00',1.31),('11288','2013-05-07','07:40:00',1.44),('11288','2013-05-07','07:45:00',1.53),('11288','2013-05-07','07:50:00',1.53),('11288','2013-05-07','07:55:00',1.76),('11288','2013-05-07','08:00:00',1.85),('11288','2013-05-07','08:05:00',1.91),('11288','2013-05-07','08:10:00',2.07),('11288','2013-05-07','08:15:00',2.32),('11288','2013-05-07','08:20:00',2.27),('11288','2013-05-07','08:25:00',2.44),('11288','2013-05-07','08:30:00',2.78),('11288','2013-05-07','08:35:00',2.91),('11288','2013-05-07','08:40:00',3.02),('11288','2013-05-07','08:45:00',3.25),('11288','2013-05-07','08:50:00',2.75),('11288','2013-05-07','08:55:00',2.38),('11288','2013-05-07','09:00:00',3.91),('11288','2013-05-07','09:05:00',1.69),('11288','2013-05-07','09:10:00',4.62),('11288','2013-05-07','09:15:00',4.96),('11288','2013-05-07','09:20:00',2.18),('11288','2013-05-07','09:25:00',1.36),('11288','2013-05-07','09:30:00',2.68),('11288','2013-05-07','09:35:00',5.29),('11288','2013-05-07','09:40:00',2.43),('11288','2013-05-07','09:45:00',2.81),('11288','2013-05-07','09:50:00',3.29),('11288','2013-05-07','09:55:00',1.72),('11288','2013-05-07','10:00:00',1.46),('11288','2013-05-07','10:05:00',1.64),('11288','2013-05-07','10:10:00',1.07),('11288','2013-05-07','10:30:00',1),('11288','2013-05-07','10:35:00',1.14),('11288','2013-05-07','10:40:00',1.39),('11288','2013-05-07','10:45:00',1.36),('11288','2013-05-07','10:50:00',1.82),('11288','2013-05-07','10:55:00',2.2),('11288','2013-05-07','11:00:00',2.4),('11288','2013-05-07','11:05:00',2.49),('11288','2013-05-07','11:10:00',5.68),('11288','2013-05-07','11:15:00',3.43),('11288','2013-05-07','11:20:00',5.62),('11288','2013-05-07','11:25:00',1.51),('11288','2013-05-07','11:45:00',1.04),('11288','2013-05-07','11:50:00',1.26),('11288','2013-05-07','11:55:00',1.7),('11288','2013-05-07','12:00:00',3.62),('11288','2013-05-07','12:05:00',8.29),('11288','2013-05-07','12:10:00',4.37),('11288','2013-05-07','12:15:00',5.62),('11288','2013-05-07','12:20:00',7.89),('11288','2013-05-07','12:25:00',2.07),('11288','2013-05-07','12:30:00',1.64),('11288','2013-05-07','12:35:00',1.36),('11288','2013-05-07','12:40:00',1.62),('11288','2013-05-07','12:45:00',1.29),('11288','2013-05-07','12:50:00',1.35),('11288','2013-05-07','12:55:00',1.28),('11288','2013-05-07','13:00:00',1.15),('11288','2013-05-07','13:05:00',1.92),('11288','2013-05-07','13:10:00',2.51),('11288','2013-05-07','13:15:00',2.75),('11288','2013-05-07','13:20:00',3.17),('11288','2013-05-07','13:25:00',6.88),('11288','2013-05-07','13:30:00',6.63),('11288','2013-05-07','13:35:00',8.93),('11288','2013-05-07','13:40:00',8.69),('11288','2013-05-07','13:45:00',8.11),('11288','2013-05-07','13:50:00',6.54),('11288','2013-05-07','13:55:00',4.52),('11288','2013-05-07','14:00:00',7.81),('11288','2013-05-07','14:05:00',8.15),('11288','2013-05-07','14:10:00',7.68),('11288','2013-05-07','14:15:00',7.78),('11288','2013-05-07','14:20:00',4.46),('11288','2013-05-07','14:25:00',5.25),('11288','2013-05-07','14:30:00',3.38),('11288','2013-05-07','14:35:00',7.57),('11288','2013-05-07','14:40:00',6.35),('11288','2013-05-07','14:45:00',5.47),('11288','2013-05-07','14:50:00',7.06),('11288','2013-05-07','14:55:00',6.08),('11288','2013-05-07','15:00:00',6.73),('11288','2013-05-07','15:05:00',6.69),('11288','2013-05-07','15:10:00',6.61),('11288','2013-05-07','15:15:00',7.06),('11288','2013-05-07','15:20:00',7.31),('11288','2013-05-07','15:25:00',5.79),('11288','2013-05-07','15:30:00',4.65),('11288','2013-05-07','15:35:00',5.28),('11288','2013-05-07','15:40:00',6.06),('11288','2013-05-07','15:45:00',5.37),('11288','2013-05-07','15:50:00',3.2),('11288','2013-05-07','15:55:00',4.38),('11288','2013-05-07','16:00:00',6.68),('11288','2013-05-07','16:05:00',2.48),('11288','2013-05-07','16:10:00',3.62),('11288','2013-05-07','16:15:00',6.69),('11288','2013-05-07','16:20:00',6.76),('11288','2013-05-07','16:25:00',6.58),('11288','2013-05-07','16:30:00',6.14),('11288','2013-05-07','16:35:00',6.06),('11288','2013-05-07','16:40:00',5.93),('11288','2013-05-07','16:45:00',5.68),('11288','2013-05-07','16:50:00',5.12),('11288','2013-05-07','16:55:00',4.43),('11288','2013-05-07','17:00:00',5.17),('11288','2013-05-07','17:05:00',3.82),('11288','2013-05-07','17:10:00',2.28),('11288','2013-05-07','17:15:00',2.07),('11288','2013-05-07','17:20:00',2.19),('11288','2013-05-07','17:25:00',2.13),('11288','2013-05-07','17:30:00',1.88),('11288','2013-05-07','17:35:00',1.8),('11288','2013-05-07','17:40:00',1.68),('11288','2013-05-07','17:45:00',1.49),('11288','2013-05-07','17:50:00',1.26),('11288','2013-05-07','18:40:00',1.39),('11288','2013-05-07','18:45:00',1.38),('11288','2013-05-07','18:50:00',1.29),('11288','2013-05-06','08:10:00',1.07),('11288','2013-05-06','08:15:00',1.35),('11288','2013-05-06','08:20:00',1.51),('11288','2013-05-06','08:25:00',2.19),('11288','2013-05-06','08:30:00',2.28),('11288','2013-05-06','08:35:00',2.11),('11288','2013-05-06','08:40:00',1.92),('11288','2013-05-06','08:45:00',1.59),('11288','2013-05-06','08:50:00',2.71),('11288','2013-05-06','08:55:00',4.12),('11288','2013-05-06','09:00:00',3.99),('11288','2013-05-06','09:05:00',2.72),('11288','2013-05-06','09:10:00',2.72),('11288','2013-05-06','09:15:00',2.38),('11288','2013-05-06','09:20:00',2.91),('11288','2013-05-06','09:25:00',2.16),('11288','2013-05-06','09:30:00',1.73),('11288','2013-05-06','09:35:00',1.17),('11288','2013-05-06','09:50:00',1.5),('11288','2013-05-06','09:55:00',2.1),('11288','2013-05-06','10:00:00',3.34),('11288','2013-05-06','10:05:00',2.02),('11288','2013-05-06','10:10:00',1.9),('11288','2013-05-06','10:15:00',2.69),('11288','2013-05-06','10:20:00',4.31),('11288','2013-05-06','10:25:00',3.56),('11288','2013-05-06','10:30:00',3.55),('11288','2013-05-06','10:35:00',3.5),('11288','2013-05-06','10:40:00',3.35),('11288','2013-05-06','10:45:00',4.43),('11288','2013-05-06','10:50:00',3.59),('11288','2013-05-06','10:55:00',3.29),('11288','2013-05-06','11:00:00',3.16),('11288','2013-05-06','11:05:00',3.5),('11288','2013-05-06','11:10:00',3.48),('11288','2013-05-06','11:15:00',3.16),('11288','2013-05-06','11:20:00',3.63),('11288','2013-05-06','11:25:00',3.74),('11288','2013-05-06','11:30:00',2.02),('11288','2013-05-06','11:35:00',3.55),('11288','2013-05-06','11:40:00',3.75),('11288','2013-05-06','11:45:00',5.88),('11288','2013-05-06','11:50:00',3.81),('11288','2013-05-06','11:55:00',2.83),('11288','2013-05-06','12:00:00',3.13),('11288','2013-05-06','12:05:00',3.3),('11288','2013-05-06','12:10:00',3.91),('11288','2013-05-06','12:15:00',3.67),('11288','2013-05-06','12:20:00',4.37),('11288','2013-05-06','12:25:00',5.63),('11288','2013-05-06','12:30:00',6.84),('11288','2013-05-06','12:35:00',6.67),('11288','2013-05-06','12:40:00',2.85),('11288','2013-05-06','12:45:00',4.19),('11288','2013-05-06','12:50:00',6.26),('11288','2013-05-06','12:55:00',3.54),('11288','2013-05-06','13:00:00',3.72),('11288','2013-05-06','13:05:00',5.46),('11288','2013-05-06','13:10:00',6.94),('11288','2013-05-06','13:15:00',5.97),('11288','2013-05-06','13:20:00',5.88),('11288','2013-05-06','13:25:00',4.99),('11288','2013-05-06','13:30:00',5.24),('11288','2013-05-06','13:35:00',5.63),('11288','2013-05-06','13:40:00',6.42),('11288','2013-05-06','13:45:00',6.3),('11288','2013-05-06','13:50:00',7.76),('11288','2013-05-06','13:55:00',7.76),('11288','2013-05-06','14:00:00',8.01),('11288','2013-05-06','14:05:00',5.62),('11288','2013-05-06','14:10:00',5.66),('11288','2013-05-06','14:15:00',7.1),('11288','2013-05-06','14:20:00',7.43),('11288','2013-05-06','14:25:00',4.06),('11288','2013-05-06','14:30:00',7.86),('11288','2013-05-06','14:35:00',6.51),('11288','2013-05-06','14:40:00',6.37),('11288','2013-05-06','14:45:00',4.05),('11288','2013-05-06','14:50:00',5.86),('11288','2013-05-06','14:55:00',6.51),('11288','2013-05-06','15:00:00',3.43),('11288','2013-05-06','15:05:00',5.41),('11288','2013-05-06','15:10:00',3.11),('11288','2013-05-06','15:15:00',5.02),('11288','2013-05-06','15:20:00',4.05),('11288','2013-05-06','15:25:00',3.39),('11288','2013-05-06','15:30:00',5.31),('11288','2013-05-06','15:35:00',4.62),('11288','2013-05-06','15:40:00',2.36),('11288','2013-05-06','15:45:00',2.52),('11288','2013-05-06','15:50:00',4.28),('11288','2013-05-06','15:55:00',3.04),('11288','2013-05-06','16:00:00',2.89),('11288','2013-05-06','16:05:00',2.81),('11288','2013-05-06','16:10:00',2.41),('11288','2013-05-06','16:15:00',2.52),('11288','2013-05-06','16:20:00',4.13),('11288','2013-05-06','16:25:00',3.77),('11288','2013-05-06','16:30:00',4.33),('11288','2013-05-06','16:35:00',4.67),('11288','2013-05-06','16:40:00',4.35),('11288','2013-05-06','16:45:00',2.38),('11288','2013-05-06','16:50:00',5.09),('11288','2013-05-06','16:55:00',2.65),('11288','2013-05-06','17:00:00',1.18),('11288','2013-05-06','17:10:00',1.12),('11288','2013-05-06','17:15:00',2.78),('11288','2013-05-06','17:20:00',1.73),('11288','2013-05-06','17:25:00',1.29),('11288','2013-05-06','17:35:00',2.51),('11288','2013-05-06','17:40:00',2.26),('11288','2013-05-06','17:45:00',2.14),('11288','2013-05-06','17:50:00',1.74),('11288','2013-05-06','17:55:00',2.29),('11288','2013-05-06','18:00:00',2.03),('11288','2013-05-06','18:05:00',2.65),('11288','2013-05-06','18:10:00',1.02),('11288','2013-05-06','18:15:00',1.51),('11288','2013-05-06','18:20:00',2.48),('11288','2013-05-06','18:25:00',1.91),('11288','2013-05-06','18:30:00',1.66),('11288','2013-05-05','07:40:00',1.05),('11288','2013-05-05','07:45:00',1.42),('11288','2013-05-05','07:50:00',1.51),('11288','2013-05-05','07:55:00',1.57),('11288','2013-05-05','08:00:00',1.72),('11288','2013-05-05','08:05:00',1.91),('11288','2013-05-05','08:10:00',2.17),('11288','2013-05-05','08:15:00',2.33),('11288','2013-05-05','08:20:00',2.77),('11288','2013-05-05','08:25:00',3.47),('11288','2013-05-05','08:30:00',3.67),('11288','2013-05-05','08:35:00',3.57),('11288','2013-05-05','08:40:00',3.42),('11288','2013-05-05','08:45:00',2.73),('11288','2013-05-05','08:50:00',2.28),('11288','2013-05-05','08:55:00',2.38),('11288','2013-05-05','09:00:00',2.39),('11288','2013-05-05','09:05:00',2.39),('11288','2013-05-05','09:10:00',2.37),('11288','2013-05-05','09:15:00',2.22),('11288','2013-05-05','09:20:00',2.13),('11288','2013-05-05','09:25:00',2.49),('11288','2013-05-05','09:30:00',2.84),('11288','2013-05-05','09:35:00',2.73),('11288','2013-05-05','09:40:00',4.07),('11288','2013-05-05','09:45:00',5.2),('11288','2013-05-05','09:50:00',5.19),('11288','2013-05-05','09:55:00',5.17),('11288','2013-05-05','10:00:00',4.88),('11288','2013-05-05','10:05:00',4.58),('11288','2013-05-05','10:10:00',3.39),('11288','2013-05-05','10:15:00',5.34),('11288','2013-05-05','10:20:00',5.65),('11288','2013-05-05','10:25:00',3.62),('11288','2013-05-05','10:30:00',4.61),('11288','2013-05-05','10:35:00',5.01),('11288','2013-05-05','10:40:00',5.55),('11288','2013-05-05','10:45:00',4.84),('11288','2013-05-05','10:50:00',2.87),('11288','2013-05-05','10:55:00',2.49),('11288','2013-05-05','11:00:00',2.53),('11288','2013-05-05','11:05:00',2.88),('11288','2013-05-05','11:10:00',2.57),('11288','2013-05-05','11:15:00',2.91),('11288','2013-05-05','11:20:00',4.64),('11288','2013-05-05','11:25:00',5.27),('11288','2013-05-05','11:30:00',4.54),('11288','2013-05-05','11:35:00',6.15),('11288','2013-05-05','11:40:00',4.72),('11288','2013-05-05','11:45:00',4.38),('11288','2013-05-05','11:50:00',5.14),('11288','2013-05-05','11:55:00',6.66),('11288','2013-05-05','12:00:00',4.86),('11288','2013-05-05','12:05:00',4.94),('11288','2013-05-05','12:10:00',5.62),('11288','2013-05-05','12:15:00',5.88),('11288','2013-05-05','12:20:00',5.93),('11288','2013-05-05','12:25:00',6.7),('11288','2013-05-05','12:30:00',6.47),('11288','2013-05-05','12:35:00',7.06),('11288','2013-05-05','12:40:00',7.36),('11288','2013-05-05','12:45:00',7.54),('11288','2013-05-05','12:50:00',6.81),('11288','2013-05-05','12:55:00',7.24),('11288','2013-05-05','13:00:00',7.16),('11288','2013-05-05','13:05:00',6.89),('11288','2013-05-05','13:10:00',6.46),('11288','2013-05-05','13:15:00',4.68),('11288','2013-05-05','13:20:00',4.77),('11288','2013-05-05','13:25:00',3.24),('11288','2013-05-05','13:30:00',3.14),('11288','2013-05-05','13:35:00',7.5),('11288','2013-05-05','13:40:00',7.22),('11288','2013-05-05','13:45:00',7.04),('11288','2013-05-05','13:50:00',7.16),('11288','2013-05-05','13:55:00',7.14),('11288','2013-05-05','14:00:00',7.32),('11288','2013-05-05','14:05:00',6.79),('11288','2013-05-05','14:10:00',5.4),('11288','2013-05-05','14:15:00',6.15),('11288','2013-05-05','14:20:00',6.79),('11288','2013-05-05','14:25:00',6.34),('11288','2013-05-05','14:30:00',6.18),('11288','2013-05-05','14:35:00',6.13),('11288','2013-05-05','14:40:00',6.1),('11288','2013-05-05','14:45:00',6.05),('11288','2013-05-05','14:50:00',6),('11288','2013-05-05','14:55:00',5.95),('11288','2013-05-05','15:00:00',5.86),('11288','2013-05-05','15:05:00',5.8),('11288','2013-05-05','15:10:00',5.72),('11288','2013-05-05','15:15:00',5.68),('11288','2013-05-05','15:20:00',5.62),('11288','2013-05-05','15:25:00',5.59),('11288','2013-05-05','15:30:00',5.54),('11288','2013-05-05','15:35:00',5.5),('11288','2013-05-05','15:40:00',5.41),('11288','2013-05-05','15:45:00',5.34),('11288','2013-05-05','15:50:00',5.27),('11288','2013-05-05','15:55:00',5.17),('11288','2013-05-05','16:00:00',5.08),('11288','2013-05-05','16:05:00',4.96),('11288','2013-05-05','16:10:00',4.85),('11288','2013-05-05','16:15:00',4.79),('11288','2013-05-05','16:20:00',4.7),('11288','2013-05-05','16:25:00',4.59),('11288','2013-05-05','16:30:00',4.48),('11288','2013-05-05','16:35:00',4.37),('11288','2013-05-05','16:40:00',4.27),('11288','2013-05-05','16:45:00',4.11),('11288','2013-05-05','16:50:00',4),('11288','2013-05-05','16:55:00',3.88),('11288','2013-05-05','17:00:00',3.74),('11288','2013-05-05','17:05:00',3.59),('11288','2013-05-05','17:10:00',3.48),('11288','2013-05-05','17:15:00',3.33),('11288','2013-05-05','17:20:00',3.11),('11288','2013-05-05','17:25:00',2.88),('11288','2013-05-05','17:30:00',2.84),('11288','2013-05-05','17:35:00',2.74),('11288','2013-05-05','17:40:00',2.63),('11288','2013-05-05','17:45:00',2.45),('11288','2013-05-05','17:50:00',2.24),('11288','2013-05-05','17:55:00',2.08),('11288','2013-05-05','18:00:00',2.05),('11288','2013-05-05','18:05:00',2),('11288','2013-05-05','18:10:00',1.93),('11288','2013-05-05','18:15:00',1.82),('11288','2013-05-05','18:20:00',1.66),('11288','2013-05-05','18:25:00',1.54),('11288','2013-05-05','18:30:00',1.44),('11288','2013-05-05','18:35:00',1.36),('11288','2013-05-05','18:40:00',1.25),('11288','2013-05-05','18:45:00',1.1),('11288','2013-05-04','07:40:00',1.31),('11288','2013-05-04','07:45:00',1.31),('11288','2013-05-04','07:50:00',1.46),('11288','2013-05-04','07:55:00',1.67),('11288','2013-05-04','08:00:00',1.79),('11288','2013-05-04','08:05:00',1.92),('11288','2013-05-04','08:10:00',2.07),('11288','2013-05-04','08:15:00',2.11),('11288','2013-05-04','08:20:00',2.19),('11288','2013-05-04','08:25:00',2.35),('11288','2013-05-04','08:30:00',2.43),('11288','2013-05-04','08:35:00',2.47),('11288','2013-05-04','08:40:00',2.79),('11288','2013-05-04','08:45:00',2.83),('11288','2013-05-04','08:50:00',2.93),('11288','2013-05-04','08:55:00',3.11),('11288','2013-05-04','09:00:00',3.28),('11288','2013-05-04','09:05:00',3.45),('11288','2013-05-04','09:10:00',3.58),('11288','2013-05-04','09:15:00',3.74),('11288','2013-05-04','09:20:00',3.75),('11288','2013-05-04','09:25:00',3.97),('11288','2013-05-04','09:30:00',3.91),('11288','2013-05-04','09:35:00',4.1),('11288','2013-05-04','09:40:00',4.31),('11288','2013-05-04','09:45:00',4.39),('11288','2013-05-04','09:50:00',4.46),('11288','2013-05-04','09:55:00',4.59),('11288','2013-05-04','10:00:00',4.64),('11288','2013-05-04','10:05:00',4.63),('11288','2013-05-04','10:10:00',4.87),('11288','2013-05-04','10:15:00',4.99),('11288','2013-05-04','10:20:00',4.99),('11288','2013-05-04','10:25:00',5.02),('11288','2013-05-04','10:30:00',5.28),('11288','2013-05-04','10:35:00',5.33),('11288','2013-05-04','10:40:00',5.31),('11288','2013-05-04','10:45:00',5.37),('11288','2013-05-04','10:50:00',5.27),('11288','2013-05-04','10:55:00',5.4),('11288','2013-05-04','11:00:00',5.34),('11288','2013-05-04','11:05:00',5.33),('11288','2013-05-04','11:10:00',5.02),('11288','2013-05-04','11:15:00',5.05),('11288','2013-05-04','11:20:00',5.48),('11288','2013-05-04','11:25:00',5.42),('11288','2013-05-04','11:30:00',5.35),('11288','2013-05-04','11:35:00',5.38),('11288','2013-05-04','11:40:00',5.29),('11288','2013-05-04','11:45:00',5.5),('11288','2013-05-04','11:50:00',5.44),('11288','2013-05-04','11:55:00',5.51),('11288','2013-05-04','12:00:00',5.49),('11288','2013-05-04','12:05:00',5.68),('11288','2013-05-04','12:10:00',5.71),('11288','2013-05-04','12:15:00',5.9),('11288','2013-05-04','12:20:00',5.93),('11288','2013-05-04','12:25:00',6.02),('11288','2013-05-04','12:30:00',6.09),('11288','2013-05-04','12:35:00',6.11),('11288','2013-05-04','12:40:00',6.05),('11288','2013-05-04','12:45:00',6.13),('11288','2013-05-04','12:50:00',5.88),('11288','2013-05-04','12:55:00',5.85),('11288','2013-05-04','13:00:00',5.69),('11288','2013-05-04','13:05:00',5.15),('11288','2013-05-04','13:10:00',5.89),('11288','2013-05-04','13:15:00',6.35),('11288','2013-05-04','13:20:00',6.38),('11288','2013-05-04','13:25:00',6.06),('11288','2013-05-04','13:30:00',6.27),('11288','2013-05-04','13:35:00',5.72),('11288','2013-05-04','13:40:00',5.97),('11288','2013-05-04','13:45:00',5.91),('11288','2013-05-04','13:50:00',5.31),('11288','2013-05-04','13:55:00',5.42),('11288','2013-05-04','14:00:00',5.98),('11288','2013-05-04','14:05:00',5.75),('11288','2013-05-04','14:10:00',5.57),('11288','2013-05-04','14:15:00',5.81),('11288','2013-05-04','14:20:00',5.67),('11288','2013-05-04','14:25:00',5.33),('11288','2013-05-04','14:30:00',5.57),('11288','2013-05-04','14:35:00',5.19),('11288','2013-05-04','14:40:00',5.49),('11288','2013-05-04','14:45:00',5.31),('11288','2013-05-04','14:50:00',5.21),('11288','2013-05-04','14:55:00',5.33),('11288','2013-05-04','15:00:00',5.45),('11288','2013-05-04','15:05:00',5.53),('11288','2013-05-04','15:10:00',5.22),('11288','2013-05-04','15:15:00',5.34),('11288','2013-05-04','15:20:00',5.35),('11288','2013-05-04','15:25:00',5.34),('11288','2013-05-04','15:30:00',5.28),('11288','2013-05-04','15:35:00',5.02),('11288','2013-05-04','15:40:00',5.25),('11288','2013-05-04','15:45:00',5.12),('11288','2013-05-04','15:50:00',5.01),('11288','2013-05-04','15:55:00',4.92),('11288','2013-05-04','16:00:00',4.8),('11288','2013-05-04','16:05:00',4.67),('11288','2013-05-04','16:10:00',4.58),('11288','2013-05-04','16:15:00',4.51),('11288','2013-05-04','16:20:00',4.4),('11288','2013-05-04','16:25:00',4.26),('11288','2013-05-04','16:30:00',4.13),('11288','2013-05-04','16:35:00',4.04),('11288','2013-05-04','16:40:00',3.94),('11288','2013-05-04','16:45:00',3.81),('11288','2013-05-04','16:50:00',3.68),('11288','2013-05-04','16:55:00',3.57),('11288','2013-05-04','17:00:00',3.5),('11288','2013-05-04','17:05:00',3.28),('11288','2013-05-04','17:10:00',2.55),('11288','2013-05-04','17:15:00',3.01),('11288','2013-05-04','17:20:00',3),('11288','2013-05-04','17:25:00',2.8),('11288','2013-05-04','17:30:00',2.67),('11288','2013-05-04','17:35:00',2.47),('11288','2013-05-04','17:40:00',2.33),('11288','2013-05-04','17:45:00',2.3),('11288','2013-05-04','17:50:00',2.19),('11288','2013-05-04','17:55:00',2.13),('11288','2013-05-04','18:00:00',2.01),('11288','2013-05-04','18:05:00',1.91),('11288','2013-05-04','18:10:00',1.68),('11288','2013-05-04','18:15:00',1.37),('11288','2013-05-04','18:20:00',1.16),('11288','2013-05-04','18:25:00',1.03),('11288','2013-05-03','07:50:00',1.09),('11288','2013-05-03','07:55:00',1.16),('11288','2013-05-03','08:00:00',1.5),('11288','2013-05-03','08:05:00',2.05),('11288','2013-05-03','08:10:00',2.35),('11288','2013-05-03','08:15:00',2.59),('11288','2013-05-03','08:20:00',2.47),('11288','2013-05-03','08:25:00',2.63),('11288','2013-05-03','08:30:00',2.83),('11288','2013-05-03','08:35:00',2.93),('11288','2013-05-03','08:40:00',2.99),('11288','2013-05-03','08:45:00',3.05),('11288','2013-05-03','08:50:00',2.96),('11288','2013-05-03','08:55:00',2.88),('11288','2013-05-03','09:00:00',3.18),('11288','2013-05-03','09:05:00',3.6),('11288','2013-05-03','09:10:00',3.7),('11288','2013-05-03','09:15:00',3.86),('11288','2013-05-03','09:20:00',3.83),('11288','2013-05-03','09:25:00',4.04),('11288','2013-05-03','09:30:00',4.12),('11288','2013-05-03','09:35:00',4.34),('11288','2013-05-03','09:40:00',4.38),('11288','2013-05-03','09:45:00',4.43),('11288','2013-05-03','09:50:00',4.62),('11288','2013-05-03','09:55:00',4.74),('11288','2013-05-03','10:00:00',4.71),('11288','2013-05-03','10:05:00',4.89),('11288','2013-05-03','10:10:00',4.91),('11288','2013-05-03','10:15:00',4.88),('11288','2013-05-03','10:20:00',5.03),('11288','2013-05-03','10:25:00',4.96),('11288','2013-05-03','10:30:00',5.13),('11288','2013-05-03','10:35:00',5.44),('11288','2013-05-03','10:40:00',5.48),('11288','2013-05-03','10:45:00',5.59),('11288','2013-05-03','10:50:00',5.72),('11288','2013-05-03','10:55:00',5.82),('11288','2013-05-03','11:00:00',5.88),('11288','2013-05-03','11:05:00',5.92),('11288','2013-05-03','11:10:00',5.95),('11288','2013-05-03','11:15:00',6.02),('11288','2013-05-03','11:20:00',6.06),('11288','2013-05-03','11:25:00',6.12),('11288','2013-05-03','11:30:00',6.17),('11288','2013-05-03','11:35:00',6.18),('11288','2013-05-03','11:40:00',6.24),('11288','2013-05-03','11:45:00',6.26),('11288','2013-05-03','11:50:00',6.29),('11288','2013-05-03','11:55:00',6.38),('11288','2013-05-03','12:00:00',6.37),('11288','2013-05-03','12:05:00',6.36),('11288','2013-05-03','12:10:00',6.41),('11288','2013-05-03','12:15:00',6.4),('11288','2013-05-03','12:20:00',6.49),('11288','2013-05-03','12:25:00',6.51),('11288','2013-05-03','12:30:00',6.49),('11288','2013-05-03','12:35:00',6.48),('11288','2013-05-03','12:40:00',6.48),('11288','2013-05-03','12:45:00',6.41),('11288','2013-05-03','12:50:00',6.64),('11288','2013-05-03','12:55:00',6.61),('11288','2013-05-03','13:00:00',6.57),('11288','2013-05-03','13:05:00',6.56),('11288','2013-05-03','13:10:00',6.54),('11288','2013-05-03','13:15:00',6.5),('11288','2013-05-03','13:20:00',6.46),('11288','2013-05-03','13:25:00',6.44),('11288','2013-05-03','13:30:00',6.45),('11288','2013-05-03','13:35:00',6.39),('11288','2013-05-03','13:40:00',6.15),('11288','2013-05-03','13:45:00',6.22),('11288','2013-05-03','13:50:00',6.23),('11288','2013-05-03','13:55:00',6.26),('11288','2013-05-03','14:00:00',6.08),('11288','2013-05-03','14:05:00',5.96),('11288','2013-05-03','14:10:00',5.93),('11288','2013-05-03','14:15:00',5.86),('11288','2013-05-03','14:20:00',6.06),('11288','2013-05-03','14:25:00',6.02),('11288','2013-05-03','14:30:00',6.04),('11288','2013-05-03','14:35:00',5.96),('11288','2013-05-03','14:40:00',5.9),('11288','2013-05-03','14:45:00',5.88),('11288','2013-05-03','14:50:00',5.81),('11288','2013-05-03','14:55:00',5.82),('11288','2013-05-03','15:00:00',5.82),('11288','2013-05-03','15:05:00',5.71),('11288','2013-05-03','15:10:00',5.69),('11288','2013-05-03','15:15:00',5.67),('11288','2013-05-03','15:20:00',5.64),('11288','2013-05-03','15:25:00',5.58),('11288','2013-05-03','15:30:00',5.54),('11288','2013-05-03','15:35:00',5.43),('11288','2013-05-03','15:40:00',5.37),('11288','2013-05-03','15:45:00',5.28),('11288','2013-05-03','15:50:00',5.16),('11288','2013-05-03','15:55:00',5.09),('11288','2013-05-03','16:00:00',4.99),('11288','2013-05-03','16:05:00',4.9),('11288','2013-05-03','16:10:00',4.82),('11288','2013-05-03','16:15:00',4.67),('11288','2013-05-03','16:20:00',4.42),('11288','2013-05-03','16:25:00',4.41),('11288','2013-05-03','16:30:00',4.38),('11288','2013-05-03','16:35:00',4.26),('11288','2013-05-03','16:40:00',4.11),('11288','2013-05-03','16:45:00',3.97),('11288','2013-05-03','16:50:00',3.83),('11288','2013-05-03','16:55:00',3.74),('11288','2013-05-03','17:00:00',3.61),('11288','2013-05-03','17:05:00',3.46),('11288','2013-05-03','17:10:00',3.3),('11288','2013-05-03','17:15:00',3.19),('11288','2013-05-03','17:20:00',2.95),('11288','2013-05-03','17:25:00',2.75),('11288','2013-05-03','17:30:00',2.6),('11288','2013-05-03','17:35:00',2.54),('11288','2013-05-03','17:40:00',2.4),('11288','2013-05-03','17:45:00',2.26),('11288','2013-05-03','17:50:00',2.06),('11288','2013-05-03','17:55:00',1.94),('11288','2013-05-03','18:00:00',1.88),('11288','2013-05-03','18:05:00',1.83),('11288','2013-05-03','18:10:00',1.78),('11288','2013-05-03','18:15:00',1.69),('11288','2013-05-03','18:20:00',1.58),('11288','2013-05-03','18:25:00',1.45),('11288','2013-05-03','18:30:00',1.31),('11288','2013-05-03','18:35:00',1.18),('11288','2013-05-03','18:40:00',1.11),('11288','2013-05-02','08:35:00',1.14),('11288','2013-05-02','08:40:00',1.56),('11288','2013-05-02','08:45:00',1.41),('11288','2013-05-02','08:50:00',1.45),('11288','2013-05-02','08:55:00',2.28),('11288','2013-05-02','09:00:00',3.06),('11288','2013-05-02','09:05:00',2.27),('11288','2013-05-02','09:10:00',1.49),('11288','2013-05-02','09:15:00',1.48),('11288','2013-05-02','09:20:00',1.95),('11288','2013-05-02','09:25:00',3.07),('11288','2013-05-02','09:30:00',3.77),('11288','2013-05-02','09:35:00',3.24),('11288','2013-05-02','09:40:00',2.63),('11288','2013-05-02','09:45:00',4.5),('11288','2013-05-02','09:50:00',2.35),('11288','2013-05-02','09:55:00',1.84),('11288','2013-05-02','10:00:00',1.84),('11288','2013-05-02','10:05:00',2.57),('11288','2013-05-02','10:10:00',2.39),('11288','2013-05-02','10:15:00',2.5),('11288','2013-05-02','10:20:00',2.54),('11288','2013-05-02','10:25:00',3.02),('11288','2013-05-02','10:30:00',4.67),('11288','2013-05-02','10:35:00',4.35),('11288','2013-05-02','10:40:00',5.48),('11288','2013-05-02','10:45:00',4.83),('11288','2013-05-02','10:50:00',6.08),('11288','2013-05-02','10:55:00',6.47),('11288','2013-05-02','11:00:00',6.31),('11288','2013-05-02','11:05:00',5.86),('11288','2013-05-02','11:10:00',4.85),('11288','2013-05-02','11:15:00',4.78),('11288','2013-05-02','11:20:00',5.31),('11288','2013-05-02','11:25:00',6.08),('11288','2013-05-02','11:30:00',6.34),('11288','2013-05-02','11:35:00',6.09),('11288','2013-05-02','11:40:00',6.13),('11288','2013-05-02','11:45:00',6.11),('11288','2013-05-02','11:50:00',6.14),('11288','2013-05-02','11:55:00',6.21),('11288','2013-05-02','12:00:00',6.18),('11288','2013-05-02','12:05:00',6.16),('11288','2013-05-02','12:10:00',6.18),('11288','2013-05-02','12:15:00',6.22),('11288','2013-05-02','12:20:00',6.24),('11288','2013-05-02','12:25:00',6.25),('11288','2013-05-02','12:30:00',6.38),('11288','2013-05-02','12:35:00',6.46),('11288','2013-05-02','12:40:00',6.53),('11288','2013-05-02','12:45:00',6.63),('11288','2013-05-02','12:50:00',6.63),('11288','2013-05-02','12:55:00',6.73),('11288','2013-05-02','13:00:00',6.79),('11288','2013-05-02','13:05:00',6.85),('11288','2013-05-02','13:10:00',6.85),('11288','2013-05-02','13:15:00',6.83),('11288','2013-05-02','13:20:00',6.84),('11288','2013-05-02','13:25:00',6.85),('11288','2013-05-02','13:30:00',6.85),('11288','2013-05-02','13:35:00',6.81),('11288','2013-05-02','13:40:00',6.81),('11288','2013-05-02','13:45:00',6.73),('11288','2013-05-02','13:50:00',6.75),('11288','2013-05-02','13:55:00',6.73),('11288','2013-05-02','14:00:00',6.66),('11288','2013-05-02','14:05:00',6.56),('11288','2013-05-02','14:10:00',6.48),('11288','2013-05-02','14:15:00',6.43),('11288','2013-05-02','14:20:00',6.41),('11288','2013-05-02','14:25:00',6.39),('11288','2013-05-02','14:30:00',6.31),('11288','2013-05-02','14:35:00',6.25),('11288','2013-05-02','14:40:00',6.2),('11288','2013-05-02','14:45:00',6.15),('11288','2013-05-02','14:50:00',6.12),('11288','2013-05-02','14:55:00',6.08),('11288','2013-05-02','15:00:00',6.05),('11288','2013-05-02','15:05:00',5.96),('11288','2013-05-02','15:10:00',5.89),('11288','2013-05-02','15:15:00',5.78),('11288','2013-05-02','15:20:00',5.73),('11288','2013-05-02','15:25:00',5.6),('11288','2013-05-02','15:30:00',5.51),('11288','2013-05-02','15:35:00',5.46),('11288','2013-05-02','15:40:00',5.34),('11288','2013-05-02','15:45:00',5.29),('11288','2013-05-02','15:50:00',5.18),('11288','2013-05-02','15:55:00',5.1),('11288','2013-05-02','16:00:00',4.95),('11288','2013-05-02','16:05:00',4.88),('11288','2013-05-02','16:10:00',4.78),('11288','2013-05-02','16:15:00',4.67),('11288','2013-05-02','16:20:00',4.58),('11288','2013-05-02','16:25:00',4.44),('11288','2013-05-02','16:30:00',4.29),('11288','2013-05-02','16:35:00',4.21),('11288','2013-05-02','16:40:00',4.1),('11288','2013-05-02','16:45:00',3.95),('11288','2013-05-02','16:50:00',3.84),('11288','2013-05-02','16:55:00',3.73),('11288','2013-05-02','17:00:00',3.63),('11288','2013-05-02','17:05:00',3.5),('11288','2013-05-02','17:10:00',3.39),('11288','2013-05-02','17:15:00',3.26),('11288','2013-05-02','17:20:00',3.1),('11288','2013-05-02','17:25:00',2.9),('11288','2013-05-02','17:30:00',2.75),('11288','2013-05-02','17:35:00',2.7),('11288','2013-05-02','17:40:00',2.57),('11288','2013-05-02','17:45:00',2.44),('11288','2013-05-02','17:50:00',2.25),('11288','2013-05-02','17:55:00',2.06),('11288','2013-05-02','18:00:00',2.02),('11288','2013-05-02','18:05:00',1.91),('11288','2013-05-02','18:10:00',1.85),('11288','2013-05-02','18:15:00',1.78),('11288','2013-05-02','18:20:00',1.68),('11288','2013-05-02','18:25:00',1.5),('11288','2013-05-02','18:30:00',1.41),('11288','2013-05-02','18:35:00',1.3),('11288','2013-05-02','18:40:00',1.19),('11288','2013-05-02','18:45:00',1.04),('11288','2014-03-30','08:00:00',1.04),('11288','2014-03-30','08:05:00',1.1),('11288','2014-03-30','08:10:00',1.11),('11288','2014-03-30','08:15:00',1.32),('11288','2014-03-30','08:20:00',1.51),('11288','2014-03-30','08:25:00',1.6),('11288','2014-03-30','08:30:00',1.73),('11288','2014-03-30','08:35:00',1.78),('11288','2014-03-30','08:40:00',1.87),('11288','2014-03-30','08:45:00',1.89),('11288','2014-03-30','08:50:00',1.96),('11288','2014-03-30','08:55:00',2.06),('11288','2014-03-30','09:00:00',2.11),('11288','2014-03-30','09:05:00',2.11),('11288','2014-03-30','09:10:00',2.01),('11288','2014-03-30','09:15:00',2.23),('11288','2014-03-30','09:20:00',2.4),('11288','2014-03-30','09:25:00',2.7),('11288','2014-03-30','09:30:00',2.99),('11288','2014-03-30','09:35:00',3.23),('11288','2014-03-30','09:40:00',3.26),('11288','2014-03-30','09:45:00',3.49),('11288','2014-03-30','09:50:00',3.61),('11288','2014-03-30','09:55:00',3.51),('11288','2014-03-30','10:00:00',3.75),('11288','2014-03-30','10:05:00',4.11),('11288','2014-03-30','10:10:00',4.24),('11288','2014-03-30','10:15:00',4.14),('11288','2014-03-30','10:20:00',4.48),('11288','2014-03-30','10:25:00',4.69),('11288','2014-03-30','10:30:00',4.77),('11288','2014-03-30','10:35:00',4.93),('11288','2014-03-30','10:40:00',5.02),('11288','2014-03-30','10:45:00',5.04),('11288','2014-03-30','10:50:00',4.99),('11288','2014-03-30','10:55:00',5.05),('11288','2014-03-30','11:00:00',4.91),('11288','2014-03-30','11:05:00',4.88),('11288','2014-03-30','11:10:00',4.95),('11288','2014-03-30','11:15:00',4.81),('11288','2014-03-30','11:20:00',4.87),('11288','2014-03-30','11:25:00',5.24),('11288','2014-03-30','11:30:00',5.45),('11288','2014-03-30','11:35:00',5.47),('11288','2014-03-30','11:40:00',5.64),('11288','2014-03-30','11:45:00',5.79),('11288','2014-03-30','11:50:00',5.86),('11288','2014-03-30','11:55:00',6.02),('11288','2014-03-30','12:00:00',6.14),('11288','2014-03-30','12:05:00',6.33),('11288','2014-03-30','12:10:00',6.5),('11288','2014-03-30','12:15:00',6.65),('11288','2014-03-30','12:20:00',6.42),('11288','2014-03-30','12:25:00',6.36),('11288','2014-03-30','12:30:00',5.84),('11288','2014-03-30','12:35:00',6.18),('11288','2014-03-30','12:40:00',6.22),('11288','2014-03-30','12:45:00',6.2),('11288','2014-03-30','12:50:00',6.25),('11288','2014-03-30','12:55:00',6.38),('11288','2014-03-30','13:00:00',6.55),('11288','2014-03-30','13:05:00',6.62),('11288','2014-03-30','13:10:00',6.5),('11288','2014-03-30','13:15:00',6.57),('11288','2014-03-30','13:20:00',6.53),('11288','2014-03-30','13:25:00',6.52),('11288','2014-03-30','13:30:00',6.54),('11288','2014-03-30','13:35:00',6.55),('11288','2014-03-30','13:40:00',6.58),('11288','2014-03-30','13:45:00',6.57),('11288','2014-03-30','13:50:00',6.43),('11288','2014-03-30','13:55:00',6.28),('11288','2014-03-30','14:00:00',6.25),('11288','2014-03-30','14:05:00',6.18),('11288','2014-03-30','14:10:00',6.05),('11288','2014-03-30','14:15:00',6.05),('11288','2014-03-30','14:20:00',6.26),('11288','2014-03-30','14:25:00',6.34),('11288','2014-03-30','14:30:00',6.02),('11288','2014-03-30','14:35:00',5.36),('11288','2014-03-30','14:40:00',5.56),('11288','2014-03-30','14:45:00',4.89),('11288','2014-03-30','14:50:00',3.74),('11288','2014-03-30','14:55:00',2.72),('11288','2014-03-30','15:00:00',2.75),('11288','2014-03-30','15:05:00',2.95),('11288','2014-03-30','15:10:00',4.05),('11288','2014-03-30','15:15:00',4.93),('11288','2014-03-30','15:20:00',4.94),('11288','2014-03-30','15:25:00',5.22),('11288','2014-03-30','15:30:00',5.22),('11288','2014-03-30','15:35:00',5.13),('11288','2014-03-30','15:40:00',5.21),('11288','2014-03-30','15:45:00',5.13),('11288','2014-03-30','15:50:00',5.01),('11288','2014-03-30','15:55:00',4.88),('11288','2014-03-30','16:00:00',4.35),('11288','2014-03-30','16:05:00',4.26),('11288','2014-03-30','16:10:00',4.05),('11288','2014-03-30','16:15:00',4.51),('11288','2014-03-30','16:20:00',4.52),('11288','2014-03-30','16:25:00',4.33),('11288','2014-03-30','16:30:00',4.31),('11288','2014-03-30','16:35:00',4.19),('11288','2014-03-30','16:40:00',3.89),('11288','2014-03-30','16:45:00',3.46),('11288','2014-03-30','16:50:00',2.93),('11288','2014-03-30','16:55:00',2.88),('11288','2014-03-30','17:00:00',3.07),('11288','2014-03-30','17:05:00',3.22),('11288','2014-03-30','17:10:00',3.28),('11288','2014-03-30','17:15:00',3.13),('11288','2014-03-30','17:20:00',2.92),('11288','2014-03-30','17:25:00',2.59),('11288','2014-03-30','17:30:00',2.56),('11288','2014-03-30','17:35:00',2.36),('11288','2014-03-30','17:40:00',2.12),('11288','2014-03-30','17:45:00',2.06),('11288','2014-03-30','17:50:00',1.64),('11288','2014-03-30','17:55:00',1.31),('11288','2014-03-30','18:00:00',1.12),('11288','2014-03-30','18:05:00',1.18),('11288','2014-03-30','18:10:00',1.16),('11288','2013-05-01','07:35:00',1.14),('11288','2013-05-01','07:40:00',1.28),('11288','2013-05-01','07:45:00',1.4),('11288','2013-05-01','07:50:00',1.54),('11288','2013-05-01','07:55:00',1.66),('11288','2013-05-01','08:00:00',1.73),('11288','2013-05-01','08:05:00',1.83),('11288','2013-05-01','08:10:00',1.91),('11288','2013-05-01','08:15:00',2.1),('11288','2013-05-01','08:20:00',2.21),('11288','2013-05-01','08:25:00',2.33),('11288','2013-05-01','08:30:00',2.44),('11288','2013-05-01','08:35:00',2.63),('11288','2013-05-01','08:40:00',2.78),('11288','2013-05-01','08:45:00',2.89),('11288','2013-05-01','08:50:00',2.92),('11288','2013-05-01','08:55:00',3.08),('11288','2013-05-01','09:00:00',3.21),('11288','2013-05-01','09:05:00',3.45),('11288','2013-05-01','09:10:00',3.68),('11288','2013-05-01','09:15:00',3.77),('11288','2013-05-01','09:20:00',3.92),('11288','2013-05-01','09:25:00',3.98),('11288','2013-05-01','09:30:00',4.03),('11288','2013-05-01','09:35:00',4.17),('11288','2013-05-01','09:40:00',4.33),('11288','2013-05-01','09:45:00',4.41),('11288','2013-05-01','09:50:00',4.47),('11288','2013-05-01','09:55:00',4.54),('11288','2013-05-01','10:00:00',4.6),('11288','2013-05-01','10:05:00',4.65),('11288','2013-05-01','10:10:00',4.88),('11288','2013-05-01','10:15:00',4.91),('11288','2013-05-01','10:20:00',5.03),('11288','2013-05-01','10:25:00',5.15),('11288','2013-05-01','10:30:00',5.25),('11288','2013-05-01','10:35:00',5.38),('11288','2013-05-01','10:40:00',5.7),('11288','2013-05-01','10:45:00',5.84),('11288','2013-05-01','10:50:00',5.86),('11288','2013-05-01','10:55:00',5.9),('11288','2013-05-01','11:00:00',5.98),('11288','2013-05-01','11:05:00',5.95),('11288','2013-05-01','11:10:00',6.07),('11288','2013-05-01','11:15:00',5.59),('11288','2013-05-01','11:20:00',5.71),('11288','2013-05-01','11:25:00',5.52),('11288','2013-05-01','11:30:00',5.52),('11288','2013-05-01','11:35:00',5.65),('11288','2013-05-01','11:40:00',4.42),('11288','2013-05-01','11:45:00',4.47),('11288','2013-05-01','11:50:00',5.9),('11288','2013-05-01','11:55:00',6.52),('11288','2013-05-01','12:00:00',6.43),('11288','2013-05-01','12:05:00',6.37),('11288','2013-05-01','12:10:00',6.4),('11288','2013-05-01','12:15:00',6.35),('11288','2013-05-01','12:20:00',6.41),('11288','2013-05-01','12:25:00',6.47),('11288','2013-05-01','12:30:00',6.58),('11288','2013-05-01','12:35:00',6.7),('11288','2013-05-01','12:40:00',6.86),('11288','2013-05-01','12:45:00',6.01),('11288','2013-05-01','12:50:00',3.8),('11288','2013-05-01','12:55:00',2.66),('11288','2013-05-01','13:00:00',2.87),('11288','2013-05-01','13:05:00',3.53),('11288','2013-05-01','13:10:00',4.66),('11288','2013-05-01','13:15:00',7.47),('11288','2013-05-01','13:20:00',7.69),('11288','2013-05-01','13:25:00',7),('11288','2013-05-01','13:30:00',6.33),('11288','2013-05-01','13:35:00',7.47),('11288','2013-05-01','13:40:00',6.92),('11288','2013-05-01','13:45:00',7.22),('11288','2013-05-01','13:50:00',6.85),('11288','2013-05-01','13:55:00',6.62),('11288','2013-05-01','14:00:00',6.43),('11288','2013-05-01','14:05:00',6.4),('11288','2013-05-01','14:10:00',6.24),('11288','2013-05-01','14:15:00',5.62),('11288','2013-05-01','14:20:00',6.69),('11288','2013-05-01','14:25:00',6.64),('11288','2013-05-01','14:30:00',6.63),('11288','2013-05-01','14:35:00',6.23),('11288','2013-05-01','14:40:00',5.93),('11288','2013-05-01','14:45:00',5.89),('11288','2013-05-01','14:50:00',5.18),('11288','2013-05-01','14:55:00',4.75),('11288','2013-05-01','15:00:00',5.25),('11288','2013-05-01','15:05:00',5.73),('11288','2013-05-01','15:10:00',5.9),('11288','2013-05-01','15:15:00',5.63),('11288','2013-05-01','15:20:00',5.63),('11288','2013-05-01','15:25:00',5.51),('11288','2013-05-01','15:30:00',4.53),('11288','2013-05-01','15:35:00',4.11),('11288','2013-05-01','15:40:00',4.11),('11288','2013-05-01','15:45:00',4.03),('11288','2013-05-01','15:50:00',3.02),('11288','2013-05-01','15:55:00',3.09),('11288','2013-05-01','16:00:00',3.64),('11288','2013-05-01','16:05:00',3.43),('11288','2013-05-01','16:10:00',3.11),('11288','2013-05-01','16:15:00',2.88),('11288','2013-05-01','16:20:00',2.49),('11288','2013-05-01','16:25:00',2.04),('11288','2013-05-01','16:30:00',1.89),('11288','2013-05-01','16:35:00',1.99),('11288','2013-05-01','16:40:00',2.12),('11288','2013-05-01','16:45:00',1.97),('11288','2013-05-01','16:50:00',1.74),('11288','2013-05-01','16:55:00',1.61),('11288','2013-05-01','17:00:00',1.63),('11288','2013-05-01','17:05:00',1.65),('11288','2013-05-01','17:10:00',1.67),('11288','2013-05-01','17:15:00',1.66),('11288','2013-05-01','17:20:00',1.49),('11288','2013-05-01','17:25:00',1.25),('11288','2013-05-01','17:30:00',1.07),('11288','2013-04-30','08:25:00',1.06),('11288','2013-04-30','08:30:00',1.37),('11288','2013-04-30','08:35:00',1.62),('11288','2013-04-30','08:40:00',1.54),('11288','2013-04-30','08:45:00',1.63),('11288','2013-04-30','08:50:00',2.28),('11288','2013-04-30','08:55:00',2.98),('11288','2013-04-30','09:00:00',2.74),('11288','2013-04-30','09:05:00',2.53),('11288','2013-04-30','09:10:00',3.53),('11288','2013-04-30','09:15:00',4.27),('11288','2013-04-30','09:20:00',4.55),('11288','2013-04-30','09:25:00',4.75),('11288','2013-04-30','09:30:00',4.52),('11288','2013-04-30','09:35:00',3.68),('11288','2013-04-30','09:40:00',2.54),('11288','2013-04-30','09:45:00',3.75),('11288','2013-04-30','09:50:00',4.48),('11288','2013-04-30','09:55:00',4.9),('11288','2013-04-30','10:00:00',5.56),('11288','2013-04-30','10:05:00',4.79),('11288','2013-04-30','10:10:00',4.77),('11288','2013-04-30','10:15:00',3.69),('11288','2013-04-30','10:20:00',3.75),('11288','2013-04-30','10:25:00',5.81),('11288','2013-04-30','10:30:00',4.19),('11288','2013-04-30','10:35:00',3.2),('11288','2013-04-30','10:40:00',2.92),('11288','2013-04-30','10:45:00',2.39),('11288','2013-04-30','10:50:00',2.58),('11288','2013-04-30','10:55:00',2.76),('11288','2013-04-30','11:00:00',2.91),('11288','2013-04-30','11:05:00',3.28),('11288','2013-04-30','11:10:00',3.25),('11288','2013-04-30','11:15:00',3.49),('11288','2013-04-30','11:20:00',3.95),('11288','2013-04-30','11:25:00',3.57),('11288','2013-04-30','11:30:00',3.63),('11288','2013-04-30','11:35:00',3.94),('11288','2013-04-30','11:40:00',3.44),('11288','2013-04-30','11:45:00',2.95),('11288','2013-04-30','11:50:00',2.98),('11288','2013-04-30','11:55:00',3.07),('11288','2013-04-30','12:00:00',3.14),('11288','2013-04-30','12:05:00',3.23),('11288','2013-04-30','12:10:00',3.06),('11288','2013-04-30','12:15:00',2.83),('11288','2013-04-30','12:20:00',2.61),('11288','2013-04-30','12:25:00',2.45),('11288','2013-04-30','12:30:00',2.56),('11288','2013-04-30','12:35:00',5.19),('11288','2013-04-30','12:40:00',7.46),('11288','2013-04-30','12:45:00',7.65),('11288','2013-04-30','12:50:00',7.26),('11288','2013-04-30','12:55:00',6.6),('11288','2013-04-30','13:00:00',6.93),('11288','2013-04-30','13:05:00',6.88),('11288','2013-04-30','13:10:00',6.82),('11288','2013-04-30','13:15:00',6.74),('11288','2013-04-30','13:20:00',6.66),('11288','2013-04-30','13:25:00',6.6),('11288','2013-04-30','13:30:00',6.59),('11288','2013-04-30','13:35:00',6.58),('11288','2013-04-30','13:40:00',6.51),('11288','2013-04-30','13:45:00',6.42),('11288','2013-04-30','13:50:00',6.36),('11288','2013-04-30','13:55:00',6.31),('11288','2013-04-30','14:00:00',6.21),('11288','2013-04-30','14:05:00',6.25),('11288','2013-04-30','14:10:00',6.2),('11288','2013-04-30','14:15:00',6.17),('11288','2013-04-30','14:20:00',6.14),('11288','2013-04-30','14:25:00',6.14),('11288','2013-04-30','14:30:00',6.15),('11288','2013-04-30','14:35:00',6.09),('11288','2013-04-30','14:40:00',6.02),('11288','2013-04-30','14:45:00',5.97),('11288','2013-04-30','14:50:00',5.9),('11288','2013-04-30','14:55:00',5.82),('11288','2013-04-30','15:00:00',5.74),('11288','2013-04-30','15:05:00',5.61),('11288','2013-04-30','15:10:00',5.53),('11288','2013-04-30','15:15:00',5.45),('11288','2013-04-30','15:20:00',5.41),('11288','2013-04-30','15:25:00',5.26),('11288','2013-04-30','15:30:00',5.27),('11288','2013-04-30','15:35:00',5.2),('11288','2013-04-30','15:40:00',5.12),('11288','2013-04-30','15:45:00',5.04),('11288','2013-04-30','15:50:00',4.95),('11288','2013-04-30','15:55:00',4.85),('11288','2013-04-30','16:00:00',4.72),('11288','2013-04-30','16:05:00',4.64),('11288','2013-04-30','16:10:00',4.58),('11288','2013-04-30','16:15:00',4.44),('11288','2013-04-30','16:20:00',4.32),('11288','2013-04-30','16:25:00',4.23),('11288','2013-04-30','16:30:00',4.14),('11288','2013-04-30','16:35:00',3.77),('11288','2013-04-30','16:40:00',3.28),('11288','2013-04-30','16:45:00',3.13),('11288','2013-04-30','16:50:00',3.38),('11288','2013-04-30','16:55:00',3.5),('11288','2013-04-30','17:00:00',3.32),('11288','2013-04-30','17:05:00',3.18),('11288','2013-04-30','17:10:00',2.55),('11288','2013-04-30','17:15:00',1.51),('11288','2013-04-30','17:20:00',2.41),('11288','2013-04-30','17:25:00',2.59),('11288','2013-04-30','17:30:00',2.48),('11288','2013-04-30','17:35:00',2.43),('11288','2013-04-30','17:40:00',2.31),('11288','2013-04-30','17:45:00',2.19),('11288','2013-04-30','17:50:00',2.04),('11288','2013-04-30','17:55:00',1.89),('11288','2013-04-30','18:00:00',1.79),('11288','2013-04-30','18:05:00',1.72),('11288','2013-04-30','18:10:00',1.63),('11288','2013-04-30','18:15:00',1.52),('11288','2013-04-30','18:20:00',1.42),('11288','2013-04-30','18:25:00',1.32),('11288','2013-04-30','18:30:00',1.21),('11288','2013-04-30','18:35:00',1.1),('11288','2013-04-29','07:15:00',1.05),('11288','2013-04-29','07:20:00',1.26),('11288','2013-04-29','07:25:00',1.36),('11288','2013-04-29','07:30:00',1.33),('11288','2013-04-29','07:35:00',1.35),('11288','2013-04-29','07:40:00',1.3),('11288','2013-04-29','07:45:00',1.41),('11288','2013-04-29','07:50:00',1.55),('11288','2013-04-29','07:55:00',1.83),('11288','2013-04-29','08:00:00',1.99),('11288','2013-04-29','08:05:00',2.08),('11288','2013-04-29','08:10:00',2.02),('11288','2013-04-29','08:15:00',2.1),('11288','2013-04-29','08:20:00',2.28),('11288','2013-04-29','08:25:00',2.6),('11288','2013-04-29','08:30:00',2.83),('11288','2013-04-29','08:35:00',3.2),('11288','2013-04-29','08:40:00',3.25),('11288','2013-04-29','08:45:00',3.16),('11288','2013-04-29','08:50:00',3.3),('11288','2013-04-29','08:55:00',3.2),('11288','2013-04-29','09:00:00',2.8),('11288','2013-04-29','09:05:00',3.82),('11288','2013-04-29','09:10:00',4.09),('11288','2013-04-29','09:15:00',4.36),('11288','2013-04-29','09:20:00',4.02),('11288','2013-04-29','09:25:00',3.96),('11288','2013-04-29','09:30:00',4.1),('11288','2013-04-29','09:35:00',4.27),('11288','2013-04-29','09:40:00',4.38),('11288','2013-04-29','09:45:00',4.45),('11288','2013-04-29','09:50:00',4.65),('11288','2013-04-29','09:55:00',4.4),('11288','2013-04-29','10:00:00',4.58),('11288','2013-04-29','10:05:00',4.53),('11288','2013-04-29','10:10:00',4.44),('11288','2013-04-29','10:15:00',3.74),('11288','2013-04-29','10:20:00',3.98),('11288','2013-04-29','10:25:00',4.56),('11288','2013-04-29','10:30:00',4.94),('11288','2013-04-29','10:35:00',5.42),('11288','2013-04-29','10:40:00',5.53),('11288','2013-04-29','10:45:00',5.51),('11288','2013-04-29','10:50:00',5.33),('11288','2013-04-29','10:55:00',5.06),('11288','2013-04-29','11:00:00',5.7),('11288','2013-04-29','11:05:00',5.24),('11288','2013-04-29','11:10:00',5.13),('11288','2013-04-29','11:15:00',4.99),('11288','2013-04-29','11:20:00',5.86),('11288','2013-04-29','11:25:00',5.92),('11288','2013-04-29','11:30:00',6.12),('11288','2013-04-29','11:35:00',5.87),('11288','2013-04-29','11:40:00',6.02),('11288','2013-04-29','11:45:00',5.76),('11288','2013-04-29','11:50:00',6.47),('11288','2013-04-29','11:55:00',6.28),('11288','2013-04-29','12:00:00',6.58),('11288','2013-04-29','12:05:00',6.42),('11288','2013-04-29','12:10:00',6.33),('11288','2013-04-29','12:15:00',6.43),('11288','2013-04-29','12:20:00',6.39),('11288','2013-04-29','12:25:00',6.31),('11288','2013-04-29','12:30:00',6.54),('11288','2013-04-29','12:35:00',6.51),('11288','2013-04-29','12:40:00',6.63),('11288','2013-04-29','12:45:00',6.63),('11288','2013-04-29','12:50:00',6.52),('11288','2013-04-29','12:55:00',6.53),('11288','2013-04-29','13:00:00',6.71),('11288','2013-04-29','13:05:00',6.56),('11288','2013-04-29','13:10:00',6.36),('11288','2013-04-29','13:15:00',5.77),('11288','2013-04-29','13:20:00',6.57),('11288','2013-04-29','13:25:00',6.86),('11288','2013-04-29','13:30:00',6.56),('11288','2013-04-29','13:35:00',6.49),('11288','2013-04-29','13:40:00',6.5),('11288','2013-04-29','13:45:00',6.57),('11288','2013-04-29','13:50:00',6.35),('11288','2013-04-29','13:55:00',7.02),('11288','2013-04-29','14:00:00',6.43),('11288','2013-04-29','14:05:00',6.37),('11288','2013-04-29','14:10:00',6.53),('11288','2013-04-29','14:15:00',6.69),('11288','2013-04-29','14:20:00',6.72),('11288','2013-04-29','14:25:00',6.3),('11288','2013-04-29','14:30:00',6.08),('11288','2013-04-29','14:35:00',6.01),('11288','2013-04-29','14:40:00',5.68),('11288','2013-04-29','14:45:00',6.12),('11288','2013-04-29','14:50:00',6.01),('11288','2013-04-29','14:55:00',6.08),('11288','2013-04-29','15:00:00',5.93),('11288','2013-04-29','15:05:00',6.04),('11288','2013-04-29','15:10:00',5.35),('11288','2013-04-29','15:15:00',5.43),('11288','2013-04-29','15:20:00',5.83),('11288','2013-04-29','15:25:00',5.92),('11288','2013-04-29','15:30:00',5.73),('11288','2013-04-29','15:35:00',4.97),('11288','2013-04-29','15:40:00',4.64),('11288','2013-04-29','15:45:00',4.54),('11288','2013-04-29','15:50:00',4.78),('11288','2013-04-29','15:55:00',4.98),('11288','2013-04-29','16:00:00',4.88),('11288','2013-04-29','16:05:00',5.18),('11288','2013-04-29','16:10:00',5.02),('11288','2013-04-29','16:15:00',5.86),('11288','2013-04-29','16:20:00',5.22),('11288','2013-04-29','16:25:00',4.27),('11288','2013-04-29','16:30:00',4.36),('11288','2013-04-29','16:35:00',4.47),('11288','2013-04-29','16:40:00',4.59),('11288','2013-04-29','16:45:00',4.57),('11288','2013-04-29','16:50:00',4.7),('11288','2013-04-29','16:55:00',4.78),('11288','2013-04-29','17:00:00',4.35),('11288','2013-04-29','17:05:00',3.75),('11288','2013-04-29','17:10:00',3.89),('11288','2013-04-29','17:15:00',3.22),('11288','2013-04-29','17:20:00',2.81),('11288','2013-04-29','17:25:00',2.53),('11288','2013-04-29','17:30:00',2.51),('11288','2013-04-29','17:35:00',2.29),('11288','2013-04-29','17:40:00',1.97),('11288','2013-04-29','17:45:00',1.86),('11288','2013-04-29','17:50:00',2.26),('11288','2013-04-29','17:55:00',2.46),('11288','2013-04-29','18:00:00',2.34),('11288','2013-04-29','18:05:00',2.67),('11288','2013-04-29','18:10:00',2.46),('11288','2013-04-29','18:15:00',2.33),('11288','2013-04-29','18:20:00',2.05),('11288','2013-04-29','18:25:00',2.02),('11288','2013-04-29','18:30:00',1.73),('11288','2013-04-29','18:35:00',1.29),('11288','2013-04-29','18:40:00',1.13),('11288','2013-04-28','07:35:00',1.1),('11288','2013-04-28','07:40:00',1.21),('11288','2013-04-28','07:45:00',1.28),('11288','2013-04-28','07:50:00',1.46),('11288','2013-04-28','07:55:00',1.53),('11288','2013-04-28','08:00:00',1.59),('11288','2013-04-28','08:05:00',1.76),('11288','2013-04-28','08:10:00',1.87),('11288','2013-04-28','08:15:00',2.13),('11288','2013-04-28','08:20:00',2.26),('11288','2013-04-28','08:25:00',2.39),('11288','2013-04-28','08:30:00',2.31),('11288','2013-04-28','08:35:00',2.5),('11288','2013-04-28','08:40:00',2.79),('11288','2013-04-28','08:45:00',2.83),('11288','2013-04-28','08:50:00',2.99),('11288','2013-04-28','08:55:00',3.22),('11288','2013-04-28','09:00:00',3.46),('11288','2013-04-28','09:05:00',3.64),('11288','2013-04-28','09:10:00',3.75),('11288','2013-04-28','09:15:00',3.92),('11288','2013-04-28','09:20:00',4.06),('11288','2013-04-28','09:25:00',4.22),('11288','2013-04-28','09:30:00',4.34),('11288','2013-04-28','09:35:00',4.42),('11288','2013-04-28','09:40:00',4.46),('11288','2013-04-28','09:45:00',4.62),('11288','2013-04-28','09:50:00',4.71),('11288','2013-04-28','09:55:00',4.91),('11288','2013-04-28','10:00:00',4.96),('11288','2013-04-28','10:05:00',4.88),('11288','2013-04-28','10:10:00',5.05),('11288','2013-04-28','10:15:00',5.34),('11288','2013-04-28','10:20:00',5.41),('11288','2013-04-28','10:25:00',5.63),('11288','2013-04-28','10:30:00',5.54),('11288','2013-04-28','10:35:00',5.79),('11288','2013-04-28','10:40:00',5.34),('11288','2013-04-28','10:45:00',6.01),('11288','2013-04-28','10:50:00',6.02),('11288','2013-04-28','10:55:00',6.11),('11288','2013-04-28','11:00:00',6.17),('11288','2013-04-28','11:05:00',6.21),('11288','2013-04-28','11:10:00',6.28),('11288','2013-04-28','11:15:00',6.38),('11288','2013-04-28','11:20:00',6.29),('11288','2013-04-28','11:25:00',6.46),('11288','2013-04-28','11:30:00',6.44),('11288','2013-04-28','11:35:00',6.27),('11288','2013-04-28','11:40:00',6.41),('11288','2013-04-28','11:45:00',6.12),('11288','2013-04-28','11:50:00',6.17),('11288','2013-04-28','11:55:00',6.48),('11288','2013-04-28','12:00:00',5.69),('11288','2013-04-28','12:05:00',5.71),('11288','2013-04-28','12:10:00',6.35),('11288','2013-04-28','12:15:00',6.37),('11288','2013-04-28','12:20:00',6.41),('11288','2013-04-28','12:25:00',5.76),('11288','2013-04-28','12:30:00',5.44),('11288','2013-04-28','12:35:00',5.14),('11288','2013-04-28','12:40:00',5.18),('11288','2013-04-28','12:45:00',6.83),('11288','2013-04-28','12:50:00',6.63),('11288','2013-04-28','12:55:00',6.14),('11288','2013-04-28','13:00:00',6.37),('11288','2013-04-28','13:05:00',6.96),('11288','2013-04-28','13:10:00',6.83),('11288','2013-04-28','13:15:00',6.26),('11288','2013-04-28','13:20:00',6.52),('11288','2013-04-28','13:25:00',6.16),('11288','2013-04-28','13:30:00',5.83),('11288','2013-04-28','13:35:00',3.83),('11288','2013-04-28','13:40:00',2.84),('11288','2013-04-28','13:45:00',2.49),('11288','2013-04-28','13:50:00',2.5),('11288','2013-04-28','13:55:00',3.2),('11288','2013-04-28','14:00:00',3.52),('11288','2013-04-28','14:05:00',4.99),('11288','2013-04-28','14:10:00',6.01),('11288','2013-04-28','14:15:00',6.41),('11288','2013-04-28','14:20:00',6.36),('11288','2013-04-28','14:25:00',6.35),('11288','2013-04-28','14:30:00',6.51),('11288','2013-04-28','14:35:00',6.53),('11288','2013-04-28','14:40:00',6.43),('11288','2013-04-28','14:45:00',6.35),('11288','2013-04-28','14:50:00',6.26),('11288','2013-04-28','14:55:00',6.17),('11288','2013-04-28','15:00:00',6.14),('11288','2013-04-28','15:05:00',6.09),('11288','2013-04-28','15:10:00',6.01),('11288','2013-04-28','15:15:00',5.9),('11288','2013-04-28','15:20:00',5.82),('11288','2013-04-28','15:25:00',5.73),('11288','2013-04-28','15:30:00',5.68),('11288','2013-04-28','15:35:00',5.61),('11288','2013-04-28','15:40:00',5.52),('11288','2013-04-28','15:45:00',5.49),('11288','2013-04-28','15:50:00',5.4),('11288','2013-04-28','15:55:00',5.3),('11288','2013-04-28','16:00:00',5.18),('11288','2013-04-28','16:05:00',5.09),('11288','2013-04-28','16:10:00',4.97),('11288','2013-04-28','16:15:00',4.89),('11288','2013-04-28','16:20:00',4.74),('11288','2013-04-28','16:25:00',4.64),('11288','2013-04-28','16:30:00',4.53),('11288','2013-04-28','16:35:00',4.44),('11288','2013-04-28','16:40:00',4.26),('11288','2013-04-28','16:45:00',4.17),('11288','2013-04-28','16:50:00',4.05),('11288','2013-04-28','16:55:00',3.9),('11288','2013-04-28','17:00:00',3.79),('11288','2013-04-28','17:05:00',3.42),('11288','2013-04-28','17:10:00',3.36),('11288','2013-04-28','17:15:00',3.44),('11288','2013-04-28','17:20:00',3.24),('11288','2013-04-28','17:25:00',3.13),('11288','2013-04-28','17:30:00',2.62),('11288','2013-04-28','17:35:00',2.54),('11288','2013-04-28','17:40:00',2.47),('11288','2013-04-28','17:45:00',2.51),('11288','2013-04-28','17:50:00',2.37),('11288','2013-04-28','17:55:00',2.06),('11288','2013-04-28','18:00:00',2.05),('11288','2013-04-28','18:05:00',1.9),('11288','2013-04-28','18:10:00',1.3),('11288','2013-04-28','18:15:00',1.38),('11288','2013-04-28','18:20:00',1.66),('11288','2013-04-28','18:25:00',1.65),('11288','2013-04-28','18:30:00',1.33),('11288','2013-04-28','18:35:00',1.21),('11288','2013-04-28','18:40:00',1.12),('11288','2013-04-27','11:45:00',1.02),('11288','2013-04-27','11:50:00',1.19),('11288','2013-04-27','11:55:00',1.23),('11288','2013-04-27','12:00:00',1.32),('11288','2013-04-27','12:05:00',1.28),('11288','2013-04-27','12:10:00',1.13),('11288','2013-04-27','12:15:00',1.05),('11288','2013-04-27','12:25:00',1.01),('11288','2013-04-27','12:30:00',1.11),('11288','2013-04-27','12:35:00',1.23),('11288','2013-04-27','12:40:00',1.54),('11288','2013-04-27','12:45:00',1.64),('11288','2013-04-27','12:50:00',1.92),('11288','2013-04-27','12:55:00',2.5),('11288','2013-04-27','13:00:00',2.6),('11288','2013-04-27','13:05:00',1.96),('11288','2013-04-27','13:10:00',2.18),('11288','2013-04-27','13:15:00',2.8),('11288','2013-04-27','13:20:00',2.93),('11288','2013-04-27','13:25:00',2.09),('11288','2013-04-27','13:30:00',2.37),('11288','2013-04-27','13:35:00',2.92),('11288','2013-04-27','13:40:00',3.18),('11288','2013-04-27','13:45:00',2.22),('11288','2013-04-27','13:50:00',2.12),('11288','2013-04-27','13:55:00',1.4),('11288','2013-04-27','14:00:00',1.14),('11288','2013-04-27','14:05:00',1.21),('11288','2013-04-27','14:20:00',1.08),('11288','2013-04-27','14:25:00',2.45),('11288','2013-04-27','14:30:00',3.97),('11288','2013-04-27','14:35:00',3.17),('11288','2013-04-27','14:40:00',2.42),('11288','2013-04-27','14:45:00',2.01),('11288','2013-04-27','14:50:00',1.3),('11288','2013-04-27','14:55:00',1.67),('11288','2013-04-27','15:00:00',2.14),('11288','2013-04-27','15:05:00',3.63),('11288','2013-04-27','15:10:00',2.49),('11288','2013-04-27','15:15:00',1.81),('11288','2013-04-27','15:20:00',1.08),('11288','2013-04-27','15:50:00',1.5),('11288','2013-04-27','16:30:00',1.06),('11288','2013-04-27','16:35:00',1.19),('11288','2013-04-27','16:40:00',2),('11288','2013-04-27','16:45:00',2.52),('11288','2013-04-27','16:50:00',3.27),('11288','2013-04-27','16:55:00',3.91),('11288','2013-04-27','17:00:00',4.18),('11288','2013-04-27','17:05:00',2.49),('11288','2013-04-27','17:10:00',1.45),('11288','2013-04-27','17:15:00',1.14),('11288','2013-04-27','17:20:00',2.14),('11288','2013-04-27','17:25:00',1.12),('11288','2013-04-27','17:35:00',1.5),('11288','2013-04-27','17:40:00',2.27),('11288','2013-04-27','17:45:00',1.97),('11288','2013-04-27','17:50:00',1.06),('11288','2013-04-27','17:55:00',1.02),('11288','2013-04-27','18:00:00',1.06),('11288','2013-04-27','18:05:00',1.05),('11288','2013-04-27','18:15:00',1.01),('11288','2013-04-26','07:15:00',1),('11288','2013-04-26','07:20:00',1.08),('11288','2013-04-26','07:25:00',1.1),('11288','2013-04-26','07:30:00',1.08),('11288','2013-04-26','07:40:00',1.01),('11288','2013-04-26','07:45:00',1.02),('11288','2013-04-26','07:50:00',1.12),('11288','2013-04-26','07:55:00',1.2),('11288','2013-04-26','08:00:00',1.32),('11288','2013-04-26','08:05:00',1.62),('11288','2013-04-26','08:10:00',1.89),('11288','2013-04-26','08:15:00',2.07),('11288','2013-04-26','08:20:00',2.17),('11288','2013-04-26','08:25:00',2.31),('11288','2013-04-26','08:30:00',2.41),('11288','2013-04-26','08:35:00',2.55),('11288','2013-04-26','08:40:00',2.62),('11288','2013-04-26','08:45:00',2.77),('11288','2013-04-26','08:50:00',2.65),('11288','2013-04-26','08:55:00',2.33),('11288','2013-04-26','09:00:00',2.71),('11288','2013-04-26','09:05:00',3.23),('11288','2013-04-26','09:10:00',2.62),('11288','2013-04-26','09:15:00',2.16),('11288','2013-04-26','09:20:00',2.23),('11288','2013-04-26','09:25:00',3.44),('11288','2013-04-26','09:30:00',3.22),('11288','2013-04-26','09:35:00',2.93),('11288','2013-04-26','09:40:00',2.94),('11288','2013-04-26','09:45:00',3.85),('11288','2013-04-26','09:50:00',4.5),('11288','2013-04-26','09:55:00',2.98),('11288','2013-04-26','10:00:00',4.68),('11288','2013-04-26','10:05:00',5.1),('11288','2013-04-26','10:10:00',5.07),('11288','2013-04-26','10:15:00',5.33),('11288','2013-04-26','10:20:00',4.89),('11288','2013-04-26','10:25:00',5.24),('11288','2013-04-26','10:30:00',5.43),('11288','2013-04-26','10:35:00',5.8),('11288','2013-04-26','10:40:00',5.79),('11288','2013-04-26','10:45:00',5.68),('11288','2013-04-26','10:50:00',4.01),('11288','2013-04-26','10:55:00',3.31),('11288','2013-04-26','11:00:00',5.71),('11288','2013-04-26','11:05:00',5.88),('11288','2013-04-26','11:10:00',5.9),('11288','2013-04-26','11:15:00',4.82),('11288','2013-04-26','11:20:00',4.31),('11288','2013-04-26','11:25:00',5.52),('11288','2013-04-26','11:30:00',5.4),('11288','2013-04-26','11:35:00',6.17),('11288','2013-04-26','11:40:00',4.98),('11288','2013-04-26','11:45:00',5.9),('11288','2013-04-26','11:50:00',4.17),('11288','2013-04-26','11:55:00',4.32),('11288','2013-04-26','12:00:00',5.43),('11288','2013-04-26','12:05:00',4.45),('11288','2013-04-26','12:10:00',4.36),('11288','2013-04-26','12:15:00',4.93),('11288','2013-04-26','12:20:00',4.77),('11288','2013-04-26','12:25:00',3.13),('11288','2013-04-26','12:30:00',3.21),('11288','2013-04-26','12:35:00',4.42),('11288','2013-04-26','12:40:00',5.12),('11288','2013-04-26','12:45:00',4.71),('11288','2013-04-26','12:50:00',3.76),('11288','2013-04-26','12:55:00',3.24),('11288','2013-04-26','13:00:00',2.42),('11288','2013-04-26','13:05:00',2.4),('11288','2013-04-26','13:10:00',3.06),('11288','2013-04-26','13:15:00',4.63),('11288','2013-04-26','13:20:00',3.28),('11288','2013-04-26','13:25:00',3.86),('11288','2013-04-26','13:30:00',5.87),('11288','2013-04-26','13:35:00',4.36),('11288','2013-04-26','13:40:00',5.08),('11288','2013-04-26','13:45:00',4.28),('11288','2013-04-26','13:50:00',5.16),('11288','2013-04-26','13:55:00',5.01),('11288','2013-04-26','14:00:00',5.07),('11288','2013-04-26','14:05:00',6.07),('11288','2013-04-26','14:10:00',4.97),('11288','2013-04-26','14:15:00',5.76),('11288','2013-04-26','14:20:00',6),('11288','2013-04-26','14:25:00',6.55),('11288','2013-04-26','14:30:00',6.5),('11288','2013-04-26','14:35:00',4.36),('11288','2013-04-26','14:40:00',2.94),('11288','2013-04-26','14:45:00',2.8),('11288','2013-04-26','14:50:00',6.98),('11288','2013-04-26','14:55:00',6.82),('11288','2013-04-26','15:00:00',6.14),('11288','2013-04-26','15:05:00',3.39),('11288','2013-04-26','15:10:00',3.16),('11288','2013-04-26','15:15:00',3.28),('11288','2013-04-26','15:20:00',2.62),('11288','2013-04-26','15:25:00',3.04),('11288','2013-04-26','15:30:00',4.31),('11288','2013-04-26','15:35:00',3.39),('11288','2013-04-26','15:40:00',3.99),('11288','2013-04-26','15:45:00',4.3),('11288','2013-04-26','15:50:00',3.48),('11288','2013-04-26','15:55:00',1.92),('11288','2013-04-26','16:00:00',1.01),('11288','2013-04-26','16:35:00',1.07),('11288','2013-04-25','07:35:00',1.02),('11288','2013-04-25','07:40:00',1.06),('11288','2013-04-25','07:45:00',1.32),('11288','2013-04-25','07:50:00',1.28),('11288','2013-04-25','07:55:00',1.32),('11288','2013-04-25','08:00:00',1.52),('11288','2013-04-25','08:05:00',1.86),('11288','2013-04-25','08:10:00',1.85),('11288','2013-04-25','08:15:00',2.08),('11288','2013-04-25','08:20:00',1.77),('11288','2013-04-25','08:25:00',1.65),('11288','2013-04-25','08:30:00',1.74),('11288','2013-04-25','08:35:00',1.84),('11288','2013-04-25','08:40:00',1.99),('11288','2013-04-25','08:45:00',2.78),('11288','2013-04-25','08:50:00',3.58),('11288','2013-04-25','08:55:00',3.61),('11288','2013-04-25','09:00:00',3.11),('11288','2013-04-25','09:05:00',2.41),('11288','2013-04-25','09:10:00',2.47),('11288','2013-04-25','09:15:00',2.24),('11288','2013-04-25','09:20:00',2.49),('11288','2013-04-25','09:25:00',2.57),('11288','2013-04-25','09:30:00',2.45),('11288','2013-04-25','09:35:00',2.75),('11288','2013-04-25','09:40:00',3.63),('11288','2013-04-25','09:45:00',4.68),('11288','2013-04-25','09:50:00',5),('11288','2013-04-25','09:55:00',5.04),('11288','2013-04-25','10:00:00',5.09),('11288','2013-04-25','10:05:00',4.84),('11288','2013-04-25','10:10:00',4.49),('11288','2013-04-25','10:15:00',4.96),('11288','2013-04-25','10:20:00',5.31),('11288','2013-04-25','10:25:00',5.57),('11288','2013-04-25','10:30:00',5.8),('11288','2013-04-25','10:35:00',5.86),('11288','2013-04-25','10:40:00',5.9),('11288','2013-04-25','10:45:00',5.81),('11288','2013-04-25','10:50:00',5.83),('11288','2013-04-25','10:55:00',5.94),('11288','2013-04-25','11:00:00',6.21),('11288','2013-04-25','11:05:00',6.28),('11288','2013-04-25','11:10:00',6.34),('11288','2013-04-25','11:15:00',6.39),('11288','2013-04-25','11:20:00',6.45),('11288','2013-04-25','11:25:00',6.48),('11288','2013-04-25','11:30:00',6.48),('11288','2013-04-25','11:35:00',6.44),('11288','2013-04-25','11:40:00',6.63),('11288','2013-04-25','11:45:00',6.69),('11288','2013-04-25','11:50:00',6.68),('11288','2013-04-25','11:55:00',6.64),('11288','2013-04-25','12:00:00',6.54),('11288','2013-04-25','12:05:00',6.57),('11288','2013-04-25','12:10:00',6.73),('11288','2013-04-25','12:15:00',6.82),('11288','2013-04-25','12:20:00',6.8),('11288','2013-04-25','12:25:00',6.76),('11288','2013-04-25','12:30:00',6.85),('11288','2013-04-25','12:35:00',6.88),('11288','2013-04-25','12:40:00',6.9),('11288','2013-04-25','12:45:00',6.89),('11288','2013-04-25','12:50:00',6.84),('11288','2013-04-25','12:55:00',6.87),('11288','2013-04-25','13:00:00',6.93),('11288','2013-04-25','13:05:00',7.02),('11288','2013-04-25','13:10:00',6.96),('11288','2013-04-25','13:15:00',6.66),('11288','2013-04-25','13:20:00',6.13),('11288','2013-04-25','13:25:00',5.61),('11288','2013-04-25','13:30:00',4.46),('11288','2013-04-25','13:35:00',4.43),('11288','2013-04-25','13:40:00',4.12),('11288','2013-04-25','13:45:00',3.9),('11288','2013-04-25','13:50:00',3.78),('11288','2013-04-25','13:55:00',4.15),('11288','2013-04-25','14:00:00',4.1),('11288','2013-04-25','14:05:00',3.89),('11288','2013-04-25','14:10:00',4.15),('11288','2013-04-25','14:15:00',4.42),('11288','2013-04-25','14:20:00',4.46),('11288','2013-04-25','14:25:00',4.63),('11288','2013-04-25','14:30:00',5.52),('11288','2013-04-25','14:35:00',6.06),('11288','2013-04-25','14:40:00',5.94),('11288','2013-04-25','14:45:00',5.77),('11288','2013-04-25','14:50:00',5.45),('11288','2013-04-25','14:55:00',5.55),('11288','2013-04-25','15:00:00',5.29),('11288','2013-04-25','15:05:00',4.78),('11288','2013-04-25','15:10:00',4.93),('11288','2013-04-25','15:15:00',5.5),('11288','2013-04-25','15:20:00',5.87),('11288','2013-04-25','15:25:00',5.99),('11288','2013-04-25','15:30:00',5.81),('11288','2013-04-25','15:35:00',5.53),('11288','2013-04-25','15:40:00',5.06),('11288','2013-04-25','15:45:00',4.95),('11288','2013-04-25','15:50:00',4.53),('11288','2013-04-25','15:55:00',4.51),('11288','2013-04-25','16:00:00',4.36),('11288','2013-04-25','16:05:00',3.73),('11288','2013-04-25','16:10:00',3.89),('11288','2013-04-25','16:15:00',3.73),('11288','2013-04-25','16:20:00',3.95),('11288','2013-04-25','16:25:00',3.37),('11288','2013-04-25','16:30:00',3.39),('11288','2013-04-25','16:35:00',4.03),('11288','2013-04-25','16:40:00',3.57),('11288','2013-04-25','16:45:00',3.49),('11288','2013-04-25','16:50:00',3.04),('11288','2013-04-25','16:55:00',3.28),('11288','2013-04-25','17:00:00',3.08),('11288','2013-04-25','17:05:00',3.87),('11288','2013-04-25','17:10:00',3.98),('11288','2013-04-25','17:15:00',3.58),('11288','2013-04-25','17:20:00',3.56),('11288','2013-04-25','17:25:00',2.92),('11288','2013-04-25','17:30:00',2.35),('11288','2013-04-25','17:35:00',2.34),('11288','2013-04-25','17:40:00',2.33),('11288','2013-04-25','17:45:00',2.01),('11288','2013-04-25','17:50:00',1.71),('11288','2013-04-25','17:55:00',1.53),('11288','2013-04-25','18:00:00',1.48),('11288','2013-04-25','18:05:00',1.41),('11288','2013-04-25','18:10:00',1.31),('11288','2013-04-25','18:15:00',1.2),('11288','2013-04-25','18:20:00',1.09),('11288','2013-04-24','07:40:00',1),('11288','2013-04-24','07:45:00',1.05),('11288','2013-04-24','07:50:00',1.35),('11288','2013-04-24','07:55:00',1.47),('11288','2013-04-24','08:00:00',1.54),('11288','2013-04-24','08:05:00',1.65),('11288','2013-04-24','08:10:00',1.89),('11288','2013-04-24','08:15:00',2.08),('11288','2013-04-24','08:20:00',2.22),('11288','2013-04-24','08:25:00',2.31),('11288','2013-04-24','08:30:00',2.37),('11288','2013-04-24','08:35:00',2.4),('11288','2013-04-24','08:40:00',2.36),('11288','2013-04-24','08:45:00',2.53),('11288','2013-04-24','08:50:00',2.82),('11288','2013-04-24','08:55:00',2.92),('11288','2013-04-24','09:00:00',3.3),('11288','2013-04-24','09:05:00',3.72),('11288','2013-04-24','09:10:00',4),('11288','2013-04-24','09:15:00',3.54),('11288','2013-04-24','09:20:00',3.29),('11288','2013-04-24','09:25:00',4.46),('11288','2013-04-24','09:30:00',4.47),('11288','2013-04-24','09:35:00',4.81),('11288','2013-04-24','09:40:00',4.52),('11288','2013-04-24','09:45:00',4.51),('11288','2013-04-24','09:50:00',4.64),('11288','2013-04-24','09:55:00',4.93),('11288','2013-04-24','10:00:00',5.15),('11288','2013-04-24','10:05:00',5.41),('11288','2013-04-24','10:10:00',5.41),('11288','2013-04-24','10:15:00',5.46),('11288','2013-04-24','10:20:00',5.47),('11288','2013-04-24','10:25:00',5.46),('11288','2013-04-24','10:30:00',5.44),('11288','2013-04-24','10:35:00',5.57),('11288','2013-04-24','10:40:00',6.13),('11288','2013-04-24','10:45:00',6.14),('11288','2013-04-24','10:50:00',6.23),('11288','2013-04-24','10:55:00',6.4),('11288','2013-04-24','11:00:00',6.34),('11288','2013-04-24','11:05:00',6.29),('11288','2013-04-24','11:10:00',6.81),('11288','2013-04-24','11:15:00',6.8),('11288','2013-04-24','11:20:00',7.03),('11288','2013-04-24','11:25:00',7.04),('11288','2013-04-24','11:30:00',6.73),('11288','2013-04-24','11:35:00',6.36),('11288','2013-04-24','11:40:00',4.9),('11288','2013-04-24','11:45:00',4.44),('11288','2013-04-24','11:50:00',3.74),('11288','2013-04-24','11:55:00',5.66),('11288','2013-04-24','12:00:00',5.64),('11288','2013-04-24','12:05:00',4.1),('11288','2013-04-24','12:10:00',5.32),('11288','2013-04-24','12:15:00',7.02),('11288','2013-04-24','12:20:00',7.78),('11288','2013-04-24','12:25:00',6.58),('11288','2013-04-24','12:30:00',6.67),('11288','2013-04-24','12:35:00',6.9),('11288','2013-04-24','12:40:00',6.65),('11288','2013-04-24','12:45:00',6.67),('11288','2013-04-24','12:50:00',7.02),('11288','2013-04-24','12:55:00',6.89),('11288','2013-04-24','13:00:00',6.66),('11288','2013-04-24','13:05:00',6.06),('11288','2013-04-24','13:10:00',7.53),('11288','2013-04-24','13:15:00',7.14),('11288','2013-04-24','13:20:00',6.64),('11288','2013-04-24','13:25:00',7.08),('11288','2013-04-24','13:30:00',6.18),('11288','2013-04-24','13:35:00',6.94),('11288','2013-04-24','13:40:00',7.63),('11288','2013-04-24','13:45:00',6.31),('11288','2013-04-24','13:50:00',5.01),('11288','2013-04-24','13:55:00',7.26),('11288','2013-04-24','14:00:00',7.01),('11288','2013-04-24','14:05:00',5.03),('11288','2013-04-24','14:10:00',5.44),('11288','2013-04-24','14:15:00',7.1),('11288','2013-04-24','14:20:00',6.5),('11288','2013-04-24','14:25:00',6.67),('11288','2013-04-24','14:30:00',6.12),('11288','2013-04-24','14:35:00',5.74),('11288','2013-04-24','14:40:00',5.41),('11288','2013-04-24','14:45:00',5.32),('11288','2013-04-24','14:50:00',4.74),('11288','2013-04-24','14:55:00',4.18),('11288','2013-04-24','15:00:00',4.52),('11288','2013-04-24','15:05:00',4.17),('11288','2013-04-24','15:10:00',3.87),('11288','2013-04-24','15:15:00',4.13),('11288','2013-04-24','15:20:00',4.49),('11288','2013-04-24','15:25:00',3.66),('11288','2013-04-24','15:30:00',3.2),('11288','2013-04-24','15:35:00',3.11),('11288','2013-04-24','15:40:00',3.07),('11288','2013-04-24','15:45:00',3.08),('11288','2013-04-24','15:50:00',3.13),('11288','2013-04-24','15:55:00',4.08),('11288','2013-04-24','16:00:00',4.81),('11288','2013-04-24','16:05:00',4.9),('11288','2013-04-24','16:10:00',4.77),('11288','2013-04-24','16:15:00',4.55),('11288','2013-04-24','16:20:00',5.5),('11288','2013-04-24','16:25:00',4.28),('11288','2013-04-24','16:30:00',3.62),('11288','2013-04-24','16:35:00',3.42),('11288','2013-04-24','16:40:00',4.34),('11288','2013-04-24','16:45:00',4.42),('11288','2013-04-24','16:50:00',4.05),('11288','2013-04-24','16:55:00',4.69),('11288','2013-04-24','17:00:00',4.68),('11288','2013-04-24','17:05:00',4.4),('11288','2013-04-24','17:10:00',4.08),('11288','2013-04-24','17:15:00',2.92),('11288','2013-04-24','17:20:00',3.13),('11288','2013-04-24','17:25:00',2.5),('11288','2013-04-24','17:30:00',1.75),('11288','2013-04-24','17:35:00',1.33),('11288','2013-04-24','17:40:00',1.26),('11288','2013-04-24','17:45:00',1.62),('11288','2013-04-24','17:50:00',1.84),('11288','2013-04-24','17:55:00',2.3),('11288','2013-04-24','18:00:00',1.83),('11288','2013-04-24','18:05:00',1.9),('11288','2013-04-24','18:10:00',1.5),('11288','2013-04-24','18:15:00',1.21),('11288','2013-04-24','18:20:00',1.61),('11288','2013-04-24','18:25:00',1.52),('11288','2013-04-24','18:30:00',1.08),('11288','2013-04-23','07:35:00',1.01),('11288','2013-04-23','07:40:00',1.02),('11288','2013-04-23','07:45:00',1.19),('11288','2013-04-23','07:50:00',1.29),('11288','2013-04-23','07:55:00',1.37),('11288','2013-04-23','08:00:00',1.54),('11288','2013-04-23','08:05:00',1.64),('11288','2013-04-23','08:10:00',1.83),('11288','2013-04-23','08:15:00',1.97),('11288','2013-04-23','08:20:00',2.05),('11288','2013-04-23','08:25:00',2.09),('11288','2013-04-23','08:30:00',2.48),('11288','2013-04-23','08:35:00',2.46),('11288','2013-04-23','08:40:00',2.29),('11288','2013-04-23','08:45:00',2.86),('11288','2013-04-23','08:50:00',3.1),('11288','2013-04-23','08:55:00',3.21),('11288','2013-04-23','09:00:00',3.46),('11288','2013-04-23','09:05:00',3.66),('11288','2013-04-23','09:10:00',3.81),('11288','2013-04-23','09:15:00',4.04),('11288','2013-04-23','09:20:00',4.2),('11288','2013-04-23','09:25:00',4.29),('11288','2013-04-23','09:30:00',4.37),('11288','2013-04-23','09:35:00',4.52),('11288','2013-04-23','09:40:00',4.19),('11288','2013-04-23','09:45:00',4.32),('11288','2013-04-23','09:50:00',4.8),('11288','2013-04-23','09:55:00',4.77),('11288','2013-04-23','10:00:00',4.99),('11288','2013-04-23','10:05:00',5.39),('11288','2013-04-23','10:10:00',5.52),('11288','2013-04-23','10:15:00',5.64),('11288','2013-04-23','10:20:00',5.78),('11288','2013-04-23','10:25:00',5.92),('11288','2013-04-23','10:30:00',5.98),('11288','2013-04-23','10:35:00',6.12),('11288','2013-04-23','10:40:00',6.26),('11288','2013-04-23','10:45:00',6.16),('11288','2013-04-23','10:50:00',6.4),('11288','2013-04-23','10:55:00',6.47),('11288','2013-04-23','11:00:00',6.5),('11288','2013-04-23','11:05:00',6.51),('11288','2013-04-23','11:10:00',6.57),('11288','2013-04-23','11:15:00',6.61),('11288','2013-04-23','11:20:00',6.65),('11288','2013-04-23','11:25:00',6.67),('11288','2013-04-23','11:30:00',6.63),('11288','2013-04-23','11:35:00',6.68),('11288','2013-04-23','11:40:00',6.72),('11288','2013-04-23','11:45:00',6.77),('11288','2013-04-23','11:50:00',6.81),('11288','2013-04-23','11:55:00',6.87),('11288','2013-04-23','12:00:00',6.88),('11288','2013-04-23','12:05:00',6.91),('11288','2013-04-23','12:10:00',6.95),('11288','2013-04-23','12:15:00',6.95),('11288','2013-04-23','12:20:00',7.01),('11288','2013-04-23','12:25:00',7.11),('11288','2013-04-23','12:30:00',7.38),('11288','2013-04-23','12:35:00',7.7),('11288','2013-04-23','12:40:00',7.23),('11288','2013-04-23','12:45:00',6.09),('11288','2013-04-23','12:50:00',2.49),('11288','2013-04-23','12:55:00',7.02),('11288','2013-04-23','13:00:00',7.12);
INSERT INTO `solarlog` VALUES ('11288','2013-04-23','13:05:00',7.62),('11288','2013-04-23','13:10:00',5.39),('11288','2013-04-23','13:15:00',8.35),('11288','2013-04-23','13:20:00',7),('11288','2013-04-23','13:25:00',7.52),('11288','2013-04-23','13:30:00',7.29),('11288','2013-04-23','13:35:00',7.53),('11288','2013-04-23','13:40:00',7.36),('11288','2013-04-23','13:45:00',5.17),('11288','2013-04-23','13:50:00',6.87),('11288','2013-04-23','13:55:00',7.29),('11288','2013-04-23','14:00:00',6.41),('11288','2013-04-23','14:05:00',7.52),('11288','2013-04-23','14:10:00',6.82),('11288','2013-04-23','14:15:00',6.64),('11288','2013-04-23','14:20:00',6.42),('11288','2013-04-23','14:25:00',6.08),('11288','2013-04-23','14:30:00',6.96),('11288','2013-04-23','14:35:00',6.74),('11288','2013-04-23','14:40:00',6.89),('11288','2013-04-23','14:45:00',5.75),('11288','2013-04-23','14:50:00',3.66),('11288','2013-04-23','14:55:00',4.04),('11288','2013-04-23','15:00:00',4.26),('11288','2013-04-23','15:05:00',4.55),('11288','2013-04-23','15:10:00',5.46),('11288','2013-04-23','15:15:00',5.23),('11288','2013-04-23','15:20:00',4.82),('11288','2013-04-23','15:25:00',4.37),('11288','2013-04-23','15:30:00',4.29),('11288','2013-04-23','15:35:00',4.09),('11288','2013-04-23','15:40:00',3.79),('11288','2013-04-23','15:45:00',4.65),('11288','2013-04-23','15:50:00',3.46),('11288','2013-04-23','15:55:00',3.38),('11288','2013-04-23','16:00:00',4.37),('11288','2013-04-23','16:05:00',4.41),('11288','2013-04-23','16:10:00',4.29),('11288','2013-04-23','16:15:00',3.65),('11288','2013-04-23','16:20:00',2.42),('11288','2013-04-23','16:25:00',2.45),('11288','2013-04-23','16:30:00',2.13),('11288','2013-04-23','16:35:00',2.04),('11288','2013-04-23','16:40:00',2.03),('11288','2013-04-23','16:45:00',2.05),('11288','2013-04-23','16:50:00',1.82),('11288','2013-04-23','16:55:00',1.9),('11288','2013-04-23','17:00:00',2.02),('11288','2013-04-23','17:05:00',2.13),('11288','2013-04-23','17:10:00',2.85),('11288','2013-04-23','17:15:00',2.13),('11288','2013-04-23','17:20:00',1.74),('11288','2013-04-23','17:25:00',2.84),('11288','2013-04-23','17:30:00',2.4),('11288','2013-04-23','17:35:00',1.8),('11288','2013-04-23','17:40:00',1.49),('11288','2013-04-23','17:45:00',1.48),('11288','2013-04-23','17:50:00',1.19),('11288','2013-04-23','17:55:00',1),('11288','2013-04-23','18:00:00',1.06),('11288','2013-04-23','18:05:00',1.05),('11288','2013-04-22','08:45:00',1.1),('11288','2013-04-22','09:00:00',1.46),('11288','2013-04-22','09:05:00',1.4),('11288','2013-04-22','09:10:00',1.51),('11288','2013-04-22','09:15:00',1.31),('11288','2013-04-22','09:20:00',1.29),('11288','2013-04-22','09:25:00',1.58),('11288','2013-04-22','09:30:00',2.15),('11288','2013-04-22','09:35:00',1.86),('11288','2013-04-22','09:40:00',1.51),('11288','2013-04-22','09:45:00',1.12),('11288','2013-04-22','10:30:00',1.06),('11288','2013-04-22','10:35:00',3.79),('11288','2013-04-22','10:40:00',6.3),('11288','2013-04-22','10:45:00',7.49),('11288','2013-04-22','10:50:00',4.52),('11288','2013-04-22','10:55:00',4.29),('11288','2013-04-22','11:00:00',3.59),('11288','2013-04-22','11:05:00',3.22),('11288','2013-04-22','11:10:00',3.96),('11288','2013-04-22','11:15:00',2.49),('11288','2013-04-22','11:20:00',2.75),('11288','2013-04-22','11:25:00',3.38),('11288','2013-04-22','11:30:00',5.19),('11288','2013-04-22','11:35:00',7.54),('11288','2013-04-22','11:40:00',5.56),('11288','2013-04-22','11:45:00',4.09),('11288','2013-04-22','11:50:00',3.17),('11288','2013-04-22','11:55:00',6.54),('11288','2013-04-22','12:00:00',6.26),('11288','2013-04-22','12:05:00',5.79),('11288','2013-04-22','12:10:00',4.15),('11288','2013-04-22','12:15:00',4.02),('11288','2013-04-22','12:20:00',3.49),('11288','2013-04-22','12:25:00',3.1),('11288','2013-04-22','12:30:00',3.43),('11288','2013-04-22','12:35:00',3.79),('11288','2013-04-22','12:40:00',6.43),('11288','2013-04-22','12:45:00',5.92),('11288','2013-04-22','12:50:00',7.97),('11288','2013-04-22','12:55:00',7.88),('11288','2013-04-22','13:00:00',6.42),('11288','2013-04-22','13:05:00',6.96),('11288','2013-04-22','13:10:00',4.77),('11288','2013-04-22','13:15:00',6.38),('11288','2013-04-22','13:20:00',7.24),('11288','2013-04-22','13:25:00',3.79),('11288','2013-04-22','13:30:00',2.9),('11288','2013-04-22','13:35:00',3.44),('11288','2013-04-22','13:40:00',3.72),('11288','2013-04-22','13:45:00',2.58),('11288','2013-04-22','13:50:00',2.19),('11288','2013-04-22','13:55:00',4.05),('11288','2013-04-22','14:00:00',2.14),('11288','2013-04-22','14:05:00',3.83),('11288','2013-04-22','14:10:00',5.33),('11288','2013-04-22','14:15:00',7.86),('11288','2013-04-22','14:20:00',8.14),('11288','2013-04-22','14:25:00',5.77),('11288','2013-04-22','14:30:00',3.28),('11288','2013-04-22','14:35:00',6.28),('11288','2013-04-22','14:40:00',7.78),('11288','2013-04-22','14:45:00',7.1),('11288','2013-04-22','14:50:00',7.52),('11288','2013-04-22','14:55:00',5.21),('11288','2013-04-22','15:00:00',1.82),('11288','2013-04-22','15:05:00',2.73),('11288','2013-04-22','15:10:00',2.27),('11288','2013-04-22','15:15:00',2.04),('11288','2013-04-22','15:20:00',4.76),('11288','2013-04-22','15:25:00',6.15),('11288','2013-04-22','15:30:00',2.5),('11288','2013-04-22','15:35:00',4.97),('11288','2013-04-22','15:40:00',6.22),('11288','2013-04-22','15:45:00',7.28),('11288','2013-04-22','15:50:00',3.62),('11288','2013-04-22','15:55:00',2.02),('11288','2013-04-22','16:00:00',1.3),('11288','2013-04-22','16:05:00',1.38),('11288','2013-04-22','16:10:00',1.37),('11288','2013-04-22','16:15:00',1.28),('11288','2013-04-22','16:20:00',1.15),('11288','2013-04-22','16:35:00',1.17),('11288','2013-04-22','16:40:00',1.51),('11288','2013-04-22','16:45:00',1.93),('11288','2013-04-22','16:50:00',1.94),('11288','2013-04-22','16:55:00',1.11),('11288','2013-04-22','17:00:00',1.04),('11288','2013-04-22','17:05:00',1.04),('11288','2013-04-22','17:10:00',1.16),('11288','2013-04-22','17:25:00',1.23),('11288','2013-04-22','17:30:00',1.54),('11288','2013-04-22','17:35:00',1.64),('11288','2013-04-22','17:40:00',1.3),('11288','2013-04-22','18:05:00',1.02),('11288','2013-04-22','18:20:00',1.04),('11288','2013-04-22','18:25:00',1.15),('11288','2013-04-22','18:50:00',1.02),('11288','2014-03-29','07:15:00',1.03),('11288','2014-03-29','07:20:00',1.13),('11288','2014-03-29','07:25:00',1.2),('11288','2014-03-29','07:30:00',1.34),('11288','2014-03-29','07:35:00',1.44),('11288','2014-03-29','07:40:00',1.65),('11288','2014-03-29','07:45:00',1.75),('11288','2014-03-29','07:50:00',1.84),('11288','2014-03-29','07:55:00',2.1),('11288','2014-03-29','08:00:00',2.16),('11288','2014-03-29','08:05:00',2.23),('11288','2014-03-29','08:10:00',2.47),('11288','2014-03-29','08:15:00',2.6),('11288','2014-03-29','08:20:00',2.75),('11288','2014-03-29','08:25:00',2.93),('11288','2014-03-29','08:30:00',3.03),('11288','2014-03-29','08:35:00',3.17),('11288','2014-03-29','08:40:00',3.42),('11288','2014-03-29','08:45:00',3.52),('11288','2014-03-29','08:50:00',3.71),('11288','2014-03-29','08:55:00',3.9),('11288','2014-03-29','09:00:00',3.97),('11288','2014-03-29','09:05:00',4.12),('11288','2014-03-29','09:10:00',4.32),('11288','2014-03-29','09:15:00',4.46),('11288','2014-03-29','09:20:00',4.6),('11288','2014-03-29','09:25:00',4.77),('11288','2014-03-29','09:30:00',4.87),('11288','2014-03-29','09:35:00',4.96),('11288','2014-03-29','09:40:00',5.04),('11288','2014-03-29','09:45:00',5.09),('11288','2014-03-29','09:50:00',5.18),('11288','2014-03-29','09:55:00',5.28),('11288','2014-03-29','10:00:00',5.36),('11288','2014-03-29','10:05:00',5.46),('11288','2014-03-29','10:10:00',5.56),('11288','2014-03-29','10:15:00',5.68),('11288','2014-03-29','10:20:00',5.7),('11288','2014-03-29','10:25:00',5.78),('11288','2014-03-29','10:30:00',5.84),('11288','2014-03-29','10:35:00',5.86),('11288','2014-03-29','10:40:00',5.94),('11288','2014-03-29','10:45:00',5.94),('11288','2014-03-29','10:50:00',6.07),('11288','2014-03-29','10:55:00',6.12),('11288','2014-03-29','11:00:00',6.17),('11288','2014-03-29','11:05:00',6.23),('11288','2014-03-29','11:10:00',6.3),('11288','2014-03-29','11:15:00',6.42),('11288','2014-03-29','11:20:00',6.44),('11288','2014-03-29','11:25:00',6.45),('11288','2014-03-29','11:30:00',6.45),('11288','2014-03-29','11:35:00',6.44),('11288','2014-03-29','11:40:00',6.23),('11288','2014-03-29','11:45:00',6.55),('11288','2014-03-29','11:50:00',6.54),('11288','2014-03-29','11:55:00',6.49),('11288','2014-03-29','12:00:00',6.49),('11288','2014-03-29','12:05:00',6.54),('11288','2014-03-29','12:10:00',6.51),('11288','2014-03-29','12:15:00',6.52),('11288','2014-03-29','12:20:00',6.55),('11288','2014-03-29','12:25:00',6.54),('11288','2014-03-29','12:30:00',6.56),('11288','2014-03-29','12:35:00',6.51),('11288','2014-03-29','12:40:00',6.45),('11288','2014-03-29','12:45:00',6.45),('11288','2014-03-29','12:50:00',6.42),('11288','2014-03-29','12:55:00',6.34),('11288','2014-03-29','13:00:00',6.26),('11288','2014-03-29','13:05:00',6.34),('11288','2014-03-29','13:10:00',6.26),('11288','2014-03-29','13:15:00',6.23),('11288','2014-03-29','13:20:00',6.21),('11288','2014-03-29','13:25:00',6.07),('11288','2014-03-29','13:30:00',6.07),('11288','2014-03-29','13:35:00',5.96),('11288','2014-03-29','13:40:00',5.92),('11288','2014-03-29','13:45:00',5.86),('11288','2014-03-29','13:50:00',5.76),('11288','2014-03-29','13:55:00',5.73),('11288','2014-03-29','14:00:00',5.7),('11288','2014-03-29','14:05:00',5.61),('11288','2014-03-29','14:10:00',5.55),('11288','2014-03-29','14:15:00',5.47),('11288','2014-03-29','14:20:00',5.38),('11288','2014-03-29','14:25:00',4.79),('11288','2014-03-29','14:30:00',5.18),('11288','2014-03-29','14:35:00',4.9),('11288','2014-03-29','14:40:00',4.35),('11288','2014-03-29','14:45:00',4.87),('11288','2014-03-29','14:50:00',4.87),('11288','2014-03-29','14:55:00',4.79),('11288','2014-03-29','15:00:00',4.74),('11288','2014-03-29','15:05:00',4.55),('11288','2014-03-29','15:10:00',4.38),('11288','2014-03-29','15:15:00',4.32),('11288','2014-03-29','15:20:00',4.24),('11288','2014-03-29','15:25:00',4),('11288','2014-03-29','15:30:00',3.76),('11288','2014-03-29','15:35:00',3.66),('11288','2014-03-29','15:40:00',3.59),('11288','2014-03-29','15:45:00',3.49),('11288','2014-03-29','15:50:00',3.34),('11288','2014-03-29','15:55:00',3.2),('11288','2014-03-29','16:00:00',3.09),('11288','2014-03-29','16:05:00',2.93),('11288','2014-03-29','16:10:00',2.73),('11288','2014-03-29','16:15:00',2.63),('11288','2014-03-29','16:20:00',2.37),('11288','2014-03-29','16:25:00',2.35),('11288','2014-03-29','16:30:00',2.22),('11288','2014-03-29','16:35:00',1.98),('11288','2014-03-29','16:40:00',1.71),('11288','2014-03-29','16:45:00',1.37),('11288','2014-03-29','16:50:00',1.48),('11288','2014-03-29','16:55:00',1.52),('11288','2014-03-29','17:00:00',1.4),('11288','2014-03-29','17:05:00',1.25),('11288','2014-03-29','17:10:00',1.14),('11288','2014-03-29','17:15:00',1),('11288','2013-04-21','07:55:00',1.26),('11288','2013-04-21','08:00:00',1.41),('11288','2013-04-21','08:05:00',1.59),('11288','2013-04-21','08:10:00',1.76),('11288','2013-04-21','08:15:00',1.91),('11288','2013-04-21','08:20:00',1.84),('11288','2013-04-21','08:25:00',2.37),('11288','2013-04-21','08:30:00',2.64),('11288','2013-04-21','08:35:00',2.52),('11288','2013-04-21','08:40:00',2.06),('11288','2013-04-21','08:45:00',1.81),('11288','2013-04-21','08:50:00',2.05),('11288','2013-04-21','08:55:00',2.9),('11288','2013-04-21','09:00:00',3.16),('11288','2013-04-21','09:05:00',4.03),('11288','2013-04-21','09:10:00',3.17),('11288','2013-04-21','09:15:00',2.66),('11288','2013-04-21','09:20:00',2.43),('11288','2013-04-21','09:25:00',3.71),('11288','2013-04-21','09:30:00',4.53),('11288','2013-04-21','09:35:00',4.6),('11288','2013-04-21','09:40:00',4.71),('11288','2013-04-21','09:45:00',5.13),('11288','2013-04-21','09:50:00',5.25),('11288','2013-04-21','09:55:00',6.23),('11288','2013-04-21','10:00:00',3.91),('11288','2013-04-21','10:05:00',3.43),('11288','2013-04-21','10:10:00',2.94),('11288','2013-04-21','10:15:00',2.96),('11288','2013-04-21','10:20:00',6.41),('11288','2013-04-21','10:25:00',3.99),('11288','2013-04-21','10:30:00',3.41),('11288','2013-04-21','10:35:00',3.07),('11288','2013-04-21','10:40:00',4.03),('11288','2013-04-21','10:45:00',4.36),('11288','2013-04-21','10:50:00',3.9),('11288','2013-04-21','10:55:00',3.69),('11288','2013-04-21','11:00:00',6.8),('11288','2013-04-21','11:05:00',4.85),('11288','2013-04-21','11:10:00',5.76),('11288','2013-04-21','11:15:00',5.06),('11288','2013-04-21','11:20:00',5.25),('11288','2013-04-21','11:25:00',4.49),('11288','2013-04-21','11:30:00',4.37),('11288','2013-04-21','11:35:00',4.36),('11288','2013-04-21','11:40:00',4.88),('11288','2013-04-21','11:45:00',5.99),('11288','2013-04-21','11:50:00',4.75),('11288','2013-04-21','11:55:00',5.64),('11288','2013-04-21','12:00:00',3.99),('11288','2013-04-21','12:05:00',4.12),('11288','2013-04-21','12:10:00',3.85),('11288','2013-04-21','12:15:00',3.66),('11288','2013-04-21','12:20:00',3.31),('11288','2013-04-21','12:25:00',3.3),('11288','2013-04-21','12:30:00',3.56),('11288','2013-04-21','12:35:00',3.65),('11288','2013-04-21','12:40:00',3.65),('11288','2013-04-21','12:45:00',3.69),('11288','2013-04-21','12:50:00',3.52),('11288','2013-04-21','12:55:00',3.4),('11288','2013-04-21','13:00:00',3.98),('11288','2013-04-21','13:05:00',4.49),('11288','2013-04-21','13:10:00',4.37),('11288','2013-04-21','13:15:00',4.03),('11288','2013-04-21','13:20:00',3.82),('11288','2013-04-21','13:25:00',3.83),('11288','2013-04-21','13:30:00',5.65),('11288','2013-04-21','13:35:00',6.84),('11288','2013-04-21','13:40:00',5.12),('11288','2013-04-21','13:45:00',5.71),('11288','2013-04-21','13:50:00',5.15),('11288','2013-04-21','13:55:00',6.35),('11288','2013-04-21','14:00:00',6.81),('11288','2013-04-21','14:05:00',7.63),('11288','2013-04-21','14:10:00',6.69),('11288','2013-04-21','14:15:00',6.97),('11288','2013-04-21','14:20:00',7.42),('11288','2013-04-21','14:25:00',6.94),('11288','2013-04-21','14:30:00',6.29),('11288','2013-04-21','14:35:00',7.25),('11288','2013-04-21','14:40:00',7.11),('11288','2013-04-21','14:45:00',5.42),('11288','2013-04-21','14:50:00',3.61),('11288','2013-04-21','14:55:00',3.59),('11288','2013-04-21','15:00:00',3.46),('11288','2013-04-21','15:05:00',5.72),('11288','2013-04-21','15:10:00',6.56),('11288','2013-04-21','15:15:00',4.01),('11288','2013-04-21','15:20:00',2.87),('11288','2013-04-21','15:25:00',3.13),('11288','2013-04-21','15:30:00',2.83),('11288','2013-04-21','15:35:00',2.48),('11288','2013-04-21','15:40:00',2.58),('11288','2013-04-21','15:45:00',2.1),('11288','2013-04-21','15:50:00',1.72),('11288','2013-04-21','15:55:00',1.49),('11288','2013-04-21','16:00:00',1.34),('11288','2013-04-21','16:05:00',1.19),('11288','2013-04-21','16:10:00',1.21),('11288','2013-04-21','16:15:00',1.17),('11288','2013-04-21','16:55:00',1.16),('11288','2013-04-21','17:00:00',1.42),('11288','2013-04-21','17:05:00',1.37),('11288','2013-04-21','17:10:00',1.23),('11288','2013-04-21','17:15:00',1.24),('11288','2013-04-21','17:20:00',1.07),('11288','2013-04-20','07:30:00',1.18),('11288','2013-04-20','07:35:00',1.37),('11288','2013-04-20','07:40:00',1.48),('11288','2013-04-20','07:45:00',1.18),('11288','2013-04-20','07:50:00',1.26),('11288','2013-04-20','07:55:00',1.47),('11288','2013-04-20','08:00:00',1.7),('11288','2013-04-20','08:05:00',1.81),('11288','2013-04-20','08:10:00',1.83),('11288','2013-04-20','08:15:00',1.65),('11288','2013-04-20','08:20:00',1.66),('11288','2013-04-20','08:25:00',1.81),('11288','2013-04-20','08:30:00',1.99),('11288','2013-04-20','08:35:00',2.16),('11288','2013-04-20','08:40:00',2.48),('11288','2013-04-20','08:45:00',2.67),('11288','2013-04-20','08:50:00',2.66),('11288','2013-04-20','08:55:00',3.04),('11288','2013-04-20','09:00:00',3.32),('11288','2013-04-20','09:05:00',3.44),('11288','2013-04-20','09:10:00',3.14),('11288','2013-04-20','09:15:00',3.68),('11288','2013-04-20','09:20:00',4.19),('11288','2013-04-20','09:25:00',3.67),('11288','2013-04-20','09:30:00',3.64),('11288','2013-04-20','09:35:00',2.61),('11288','2013-04-20','09:40:00',1.59),('11288','2013-04-20','09:45:00',1.97),('11288','2013-04-20','09:50:00',1.63),('11288','2013-04-20','09:55:00',1.17),('11288','2013-04-20','10:30:00',1.17),('11288','2013-04-20','10:35:00',1.78),('11288','2013-04-20','10:40:00',2.64),('11288','2013-04-20','10:45:00',5.86),('11288','2013-04-20','10:50:00',5.12),('11288','2013-04-20','10:55:00',4.65),('11288','2013-04-20','11:00:00',5.52),('11288','2013-04-20','11:05:00',4.7),('11288','2013-04-20','11:10:00',6.56),('11288','2013-04-20','11:15:00',7.01),('11288','2013-04-20','11:20:00',5.43),('11288','2013-04-20','11:25:00',7.29),('11288','2013-04-20','11:30:00',5.28),('11288','2013-04-20','11:35:00',2.49),('11288','2013-04-20','11:40:00',3.3),('11288','2013-04-20','11:45:00',4.41),('11288','2013-04-20','11:50:00',7.67),('11288','2013-04-20','11:55:00',7.49),('11288','2013-04-20','12:00:00',3.59),('11288','2013-04-20','12:05:00',5.42),('11288','2013-04-20','12:10:00',7.42),('11288','2013-04-20','12:15:00',7.36),('11288','2013-04-20','12:20:00',6.92),('11288','2013-04-20','12:25:00',7.26),('11288','2013-04-20','12:30:00',4.37),('11288','2013-04-20','12:35:00',5.82),('11288','2013-04-20','12:40:00',7.5),('11288','2013-04-20','12:45:00',5.87),('11288','2013-04-20','12:50:00',4.35),('11288','2013-04-20','12:55:00',6.42),('11288','2013-04-20','13:00:00',2.07),('11288','2013-04-20','13:05:00',4.06),('11288','2013-04-20','13:10:00',6.47),('11288','2013-04-20','13:15:00',4.09),('11288','2013-04-20','13:20:00',4.39),('11288','2013-04-20','13:25:00',4.21),('11288','2013-04-20','13:30:00',5.26),('11288','2013-04-20','13:35:00',7.76),('11288','2013-04-20','13:40:00',4.23),('11288','2013-04-20','13:45:00',2.99),('11288','2013-04-20','13:50:00',3.49),('11288','2013-04-20','13:55:00',5.44),('11288','2013-04-20','14:00:00',3.19),('11288','2013-04-20','14:05:00',5.75),('11288','2013-04-20','14:10:00',7),('11288','2013-04-20','14:15:00',6.39),('11288','2013-04-20','14:20:00',6.43),('11288','2013-04-20','14:25:00',6.31),('11288','2013-04-20','14:30:00',6.24),('11288','2013-04-20','14:35:00',6.17),('11288','2013-04-20','14:40:00',6.2),('11288','2013-04-20','14:45:00',6.22),('11288','2013-04-20','14:50:00',6.23),('11288','2013-04-20','14:55:00',6.19),('11288','2013-04-20','15:00:00',6.11),('11288','2013-04-20','15:05:00',6.03),('11288','2013-04-20','15:10:00',3.59),('11288','2013-04-20','15:15:00',4.03),('11288','2013-04-20','15:20:00',5.34),('11288','2013-04-20','15:25:00',4.97),('11288','2013-04-20','15:30:00',2.15),('11288','2013-04-20','15:35:00',1.31),('11288','2013-04-20','15:40:00',1.32),('11288','2013-04-20','15:45:00',1.36),('11288','2013-04-20','15:50:00',1.29),('11288','2013-04-20','15:55:00',1.25),('11288','2013-04-20','16:00:00',1.46),('11288','2013-04-20','16:05:00',2.01),('11288','2013-04-20','16:10:00',3.43),('11288','2013-04-20','16:15:00',3.65),('11288','2013-04-20','16:20:00',3.62),('11288','2013-04-20','16:25:00',4.14),('11288','2013-04-20','16:30:00',4.25),('11288','2013-04-20','16:35:00',4.4),('11288','2013-04-20','16:40:00',4.82),('11288','2013-04-20','16:45:00',4.55),('11288','2013-04-20','16:50:00',4.11),('11288','2013-04-20','16:55:00',3.82),('11288','2013-04-20','17:00:00',3.65),('11288','2013-04-20','17:05:00',3.5),('11288','2013-04-20','17:10:00',3.38),('11288','2013-04-20','17:15:00',2.82),('11288','2013-04-20','17:20:00',3.14),('11288','2013-04-20','17:25:00',2.87),('11288','2013-04-20','17:30:00',3.09),('11288','2013-04-20','17:35:00',3.03),('11288','2013-04-20','17:40:00',2.65),('11288','2013-04-20','17:45:00',1.31),('11288','2013-04-20','17:50:00',1.71),('11288','2013-04-20','17:55:00',2.26),('11288','2013-04-20','18:00:00',1.83),('11288','2013-04-20','18:05:00',1.81),('11288','2013-04-20','18:10:00',2),('11288','2013-04-20','18:15:00',1.59),('11288','2013-04-20','18:20:00',1.18),('11288','2013-04-19','08:00:00',1.08),('11288','2013-04-19','08:05:00',1.35),('11288','2013-04-19','08:10:00',1.26),('11288','2013-04-19','08:15:00',1.39),('11288','2013-04-19','08:20:00',1.82),('11288','2013-04-19','08:25:00',1.9),('11288','2013-04-19','08:30:00',1.96),('11288','2013-04-19','08:35:00',2.24),('11288','2013-04-19','08:40:00',2.38),('11288','2013-04-19','08:45:00',2.6),('11288','2013-04-19','08:50:00',2.78),('11288','2013-04-19','08:55:00',2.93),('11288','2013-04-19','09:00:00',3.01),('11288','2013-04-19','09:05:00',3.15),('11288','2013-04-19','09:10:00',3.25),('11288','2013-04-19','09:15:00',3.3),('11288','2013-04-19','09:20:00',3.55),('11288','2013-04-19','09:25:00',3.58),('11288','2013-04-19','09:30:00',3.64),('11288','2013-04-19','09:35:00',3.89),('11288','2013-04-19','09:40:00',3.98),('11288','2013-04-19','09:45:00',4.01),('11288','2013-04-19','09:50:00',4.04),('11288','2013-04-19','09:55:00',4.2),('11288','2013-04-19','10:00:00',4.22),('11288','2013-04-19','10:05:00',4.42),('11288','2013-04-19','10:10:00',4.48),('11288','2013-04-19','10:15:00',4.61),('11288','2013-04-19','10:20:00',5.03),('11288','2013-04-19','10:25:00',5.16),('11288','2013-04-19','10:30:00',5.23),('11288','2013-04-19','10:35:00',4.71),('11288','2013-04-19','10:40:00',5.13),('11288','2013-04-19','10:45:00',5.33),('11288','2013-04-19','10:50:00',5.34),('11288','2013-04-19','10:55:00',5.32),('11288','2013-04-19','11:00:00',5.4),('11288','2013-04-19','11:05:00',5.42),('11288','2013-04-19','11:10:00',5.5),('11288','2013-04-19','11:15:00',5.51),('11288','2013-04-19','11:20:00',5.61),('11288','2013-04-19','11:25:00',5.68),('11288','2013-04-19','11:30:00',5.75),('11288','2013-04-19','11:35:00',5.8),('11288','2013-04-19','11:40:00',5.88),('11288','2013-04-19','11:45:00',5.91),('11288','2013-04-19','11:50:00',5.96),('11288','2013-04-19','11:55:00',6.07),('11288','2013-04-19','12:00:00',6.15),('11288','2013-04-19','12:05:00',6.19),('11288','2013-04-19','12:10:00',6.09),('11288','2013-04-19','12:15:00',6.04),('11288','2013-04-19','12:20:00',6.13),('11288','2013-04-19','12:25:00',6.27),('11288','2013-04-19','12:30:00',6.24),('11288','2013-04-19','12:35:00',6.24),('11288','2013-04-19','12:40:00',6.27),('11288','2013-04-19','12:45:00',6.28),('11288','2013-04-19','12:50:00',6.38),('11288','2013-04-19','12:55:00',6.28),('11288','2013-04-19','13:00:00',6.2),('11288','2013-04-19','13:05:00',6.34),('11288','2013-04-19','13:10:00',6.41),('11288','2013-04-19','13:15:00',6.32),('11288','2013-04-19','13:20:00',6.29),('11288','2013-04-19','13:25:00',6.38),('11288','2013-04-19','13:30:00',6.31),('11288','2013-04-19','13:35:00',6.28),('11288','2013-04-19','13:40:00',6.32),('11288','2013-04-19','13:45:00',6.14),('11288','2013-04-19','13:50:00',6.12),('11288','2013-04-19','13:55:00',6.14),('11288','2013-04-19','14:00:00',6.05),('11288','2013-04-19','14:05:00',6.08),('11288','2013-04-19','14:10:00',5.98),('11288','2013-04-19','14:15:00',6.05),('11288','2013-04-19','14:20:00',5.95),('11288','2013-04-19','14:25:00',5.94),('11288','2013-04-19','14:30:00',5.9),('11288','2013-04-19','14:35:00',5.91),('11288','2013-04-19','14:40:00',5.78),('11288','2013-04-19','14:45:00',5.77),('11288','2013-04-19','14:50:00',5.73),('11288','2013-04-19','14:55:00',5.63),('11288','2013-04-19','15:00:00',5.5),('11288','2013-04-19','15:05:00',5.46),('11288','2013-04-19','15:10:00',5.42),('11288','2013-04-19','15:15:00',5.34),('11288','2013-04-19','15:20:00',5.25),('11288','2013-04-19','15:25:00',5.22),('11288','2013-04-19','15:30:00',5.12),('11288','2013-04-19','15:35:00',5.06),('11288','2013-04-19','15:40:00',5.04),('11288','2013-04-19','15:45:00',4.95),('11288','2013-04-19','15:50:00',4.83),('11288','2013-04-19','15:55:00',4.72),('11288','2013-04-19','16:00:00',4.63),('11288','2013-04-19','16:05:00',4.52),('11288','2013-04-19','16:10:00',4.44),('11288','2013-04-19','16:15:00',4.34),('11288','2013-04-19','16:20:00',4.19),('11288','2013-04-19','16:25:00',4.12),('11288','2013-04-19','16:30:00',3.98),('11288','2013-04-19','16:35:00',3.82),('11288','2013-04-19','16:40:00',3.72),('11288','2013-04-19','16:45:00',3.6),('11288','2013-04-19','16:50:00',3.47),('11288','2013-04-19','16:55:00',3.3),('11288','2013-04-19','17:00:00',3.17),('11288','2013-04-19','17:05:00',3.04),('11288','2013-04-19','17:10:00',2.88),('11288','2013-04-19','17:15:00',2.76),('11288','2013-04-19','17:20:00',2.64),('11288','2013-04-19','17:25:00',2.5),('11288','2013-04-19','17:30:00',2.39),('11288','2013-04-19','17:35:00',2.24),('11288','2013-04-19','17:40:00',2.1),('11288','2013-04-19','17:45:00',1.96),('11288','2013-04-19','17:50:00',1.77),('11288','2013-04-19','17:55:00',1.68),('11288','2013-04-19','18:00:00',1.6),('11288','2013-04-19','18:05:00',1.47),('11288','2013-04-19','18:10:00',1.36),('11288','2013-04-19','18:15:00',1.25),('11288','2013-04-19','18:20:00',1.15),('11288','2013-04-19','18:25:00',1.09),('11288','2013-04-19','18:30:00',1.01),('11288','2013-04-18','07:55:00',1.03),('11288','2013-04-18','08:00:00',1.15),('11288','2013-04-18','08:05:00',1.3),('11288','2013-04-18','08:10:00',1.65),('11288','2013-04-18','08:15:00',1.73),('11288','2013-04-18','08:20:00',1.85),('11288','2013-04-18','08:25:00',1.82),('11288','2013-04-18','08:30:00',1.92),('11288','2013-04-18','08:35:00',2.11),('11288','2013-04-18','08:40:00',2.03),('11288','2013-04-18','08:45:00',2.17),('11288','2013-04-18','08:50:00',2.37),('11288','2013-04-18','08:55:00',2.65),('11288','2013-04-18','09:00:00',2.9),('11288','2013-04-18','09:05:00',3.08),('11288','2013-04-18','09:10:00',3.06),('11288','2013-04-18','09:15:00',3.15),('11288','2013-04-18','09:20:00',3.12),('11288','2013-04-18','09:25:00',3.21),('11288','2013-04-18','09:30:00',3.4),('11288','2013-04-18','09:35:00',3.89),('11288','2013-04-18','09:40:00',4.12),('11288','2013-04-18','09:45:00',4.12),('11288','2013-04-18','09:50:00',3.53),('11288','2013-04-18','09:55:00',3.52),('11288','2013-04-18','10:00:00',3.9),('11288','2013-04-18','10:05:00',4.16),('11288','2013-04-18','10:10:00',4.29),('11288','2013-04-18','10:15:00',5.02),('11288','2013-04-18','10:20:00',5.23),('11288','2013-04-18','10:25:00',5.19),('11288','2013-04-18','10:30:00',5.35),('11288','2013-04-18','10:35:00',5.43),('11288','2013-04-18','10:40:00',5.48),('11288','2013-04-18','10:45:00',5.54),('11288','2013-04-18','10:50:00',5.58),('11288','2013-04-18','10:55:00',5.63),('11288','2013-04-18','11:00:00',5.64),('11288','2013-04-18','11:05:00',5.69),('11288','2013-04-18','11:10:00',5.79),('11288','2013-04-18','11:15:00',5.85),('11288','2013-04-18','11:20:00',5.92),('11288','2013-04-18','11:25:00',5.96),('11288','2013-04-18','11:30:00',5.95),('11288','2013-04-18','11:35:00',6.01),('11288','2013-04-18','11:40:00',5.99),('11288','2013-04-18','11:45:00',5.98),('11288','2013-04-18','11:50:00',6.17),('11288','2013-04-18','11:55:00',6.32),('11288','2013-04-18','12:00:00',6.33),('11288','2013-04-18','12:05:00',6.43),('11288','2013-04-18','12:10:00',6.49),('11288','2013-04-18','12:15:00',6.44),('11288','2013-04-18','12:20:00',6.48),('11288','2013-04-18','12:25:00',6.56),('11288','2013-04-18','12:30:00',6.54),('11288','2013-04-18','12:35:00',6.56),('11288','2013-04-18','12:40:00',6.58),('11288','2013-04-18','12:45:00',6.55),('11288','2013-04-18','12:50:00',6.58),('11288','2013-04-18','12:55:00',6.64),('11288','2013-04-18','13:00:00',6.65),('11288','2013-04-18','13:05:00',6.55),('11288','2013-04-18','13:10:00',6.57),('11288','2013-04-18','13:15:00',6.62),('11288','2013-04-18','13:20:00',6.59),('11288','2013-04-18','13:25:00',6.61),('11288','2013-04-18','13:30:00',6.6),('11288','2013-04-18','13:35:00',6.62),('11288','2013-04-18','13:40:00',6.57),('11288','2013-04-18','13:45:00',6.53),('11288','2013-04-18','13:50:00',6.58),('11288','2013-04-18','13:55:00',6.53),('11288','2013-04-18','14:00:00',6.5),('11288','2013-04-18','14:05:00',6.49),('11288','2013-04-18','14:10:00',6.43),('11288','2013-04-18','14:15:00',6.41),('11288','2013-04-18','14:20:00',6.38),('11288','2013-04-18','14:25:00',6.35),('11288','2013-04-18','14:30:00',6.33),('11288','2013-04-18','14:35:00',6.25),('11288','2013-04-18','14:40:00',6.17),('11288','2013-04-18','14:45:00',6.1),('11288','2013-04-18','14:50:00',6.03),('11288','2013-04-18','14:55:00',5.99),('11288','2013-04-18','15:00:00',5.84),('11288','2013-04-18','15:05:00',5.83),('11288','2013-04-18','15:10:00',5.74),('11288','2013-04-18','15:15:00',5.67),('11288','2013-04-18','15:20:00',5.6),('11288','2013-04-18','15:25:00',5.55),('11288','2013-04-18','15:30:00',5.38),('11288','2013-04-18','15:35:00',5.36),('11288','2013-04-18','15:40:00',5.27),('11288','2013-04-18','15:45:00',5.21),('11288','2013-04-18','15:50:00',5.11),('11288','2013-04-18','15:55:00',4.95),('11288','2013-04-18','16:00:00',4.85),('11288','2013-04-18','16:05:00',4.75),('11288','2013-04-18','16:10:00',4.67),('11288','2013-04-18','16:15:00',4.53),('11288','2013-04-18','16:20:00',4.4),('11288','2013-04-18','16:25:00',4.26),('11288','2013-04-18','16:30:00',4.13),('11288','2013-04-18','16:35:00',3.97),('11288','2013-04-18','16:40:00',3.85),('11288','2013-04-18','16:45:00',3.77),('11288','2013-04-18','16:50:00',3.67),('11288','2013-04-18','16:55:00',3.51),('11288','2013-04-18','17:00:00',3.36),('11288','2013-04-18','17:05:00',3.19),('11288','2013-04-18','17:10:00',3.06),('11288','2013-04-18','17:15:00',2.95),('11288','2013-04-18','17:20:00',2.81),('11288','2013-04-18','17:25:00',2.68),('11288','2013-04-18','17:30:00',2.54),('11288','2013-04-18','17:35:00',2.42),('11288','2013-04-18','17:40:00',2.28),('11288','2013-04-18','17:45:00',2.14),('11288','2013-04-18','17:50:00',2.01),('11288','2013-04-18','17:55:00',1.89),('11288','2013-04-18','18:00:00',1.75),('11288','2013-04-18','18:05:00',1.61),('11288','2013-04-18','18:10:00',1.49),('11288','2013-04-18','18:15:00',1.33),('11288','2013-04-18','18:20:00',1.22),('11288','2013-04-18','18:25:00',1.09),('11288','2013-04-17','07:50:00',1.03),('11288','2013-04-17','07:55:00',1.12),('11288','2013-04-17','08:00:00',1.27),('11288','2013-04-17','08:05:00',1.4),('11288','2013-04-17','08:10:00',1.47),('11288','2013-04-17','08:15:00',1.54),('11288','2013-04-17','08:20:00',1.78),('11288','2013-04-17','08:25:00',1.77),('11288','2013-04-17','08:30:00',1.74),('11288','2013-04-17','08:35:00',2.1),('11288','2013-04-17','08:40:00',2.22),('11288','2013-04-17','08:45:00',2.49),('11288','2013-04-17','08:50:00',2.64),('11288','2013-04-17','08:55:00',2.75),('11288','2013-04-17','09:00:00',2.97),('11288','2013-04-17','09:05:00',3.12),('11288','2013-04-17','09:10:00',3.3),('11288','2013-04-17','09:15:00',3.46),('11288','2013-04-17','09:20:00',3.57),('11288','2013-04-17','09:25:00',3.68),('11288','2013-04-17','09:30:00',3.66),('11288','2013-04-17','09:35:00',3.85),('11288','2013-04-17','09:40:00',4.05),('11288','2013-04-17','09:45:00',4.18),('11288','2013-04-17','09:50:00',4.37),('11288','2013-04-17','09:55:00',4.47),('11288','2013-04-17','10:00:00',4.38),('11288','2013-04-17','10:05:00',4.43),('11288','2013-04-17','10:10:00',4.87),('11288','2013-04-17','10:15:00',5.01),('11288','2013-04-17','10:20:00',5.14),('11288','2013-04-17','10:25:00',5.27),('11288','2013-04-17','10:30:00',5.36),('11288','2013-04-17','10:35:00',5.44),('11288','2013-04-17','10:40:00',5.51),('11288','2013-04-17','10:45:00',5.54),('11288','2013-04-17','10:50:00',5.59),('11288','2013-04-17','10:55:00',5.66),('11288','2013-04-17','11:00:00',5.77),('11288','2013-04-17','11:05:00',5.79),('11288','2013-04-17','11:10:00',5.91),('11288','2013-04-17','11:15:00',5.98),('11288','2013-04-17','11:20:00',6),('11288','2013-04-17','11:25:00',6.03),('11288','2013-04-17','11:30:00',6.04),('11288','2013-04-17','11:35:00',6.08),('11288','2013-04-17','11:40:00',6.13),('11288','2013-04-17','11:45:00',6.15),('11288','2013-04-17','11:50:00',6.14),('11288','2013-04-17','11:55:00',6.27),('11288','2013-04-17','12:00:00',6.43),('11288','2013-04-17','12:05:00',6.44),('11288','2013-04-17','12:10:00',6.43),('11288','2013-04-17','12:15:00',6.46),('11288','2013-04-17','12:20:00',6.51),('11288','2013-04-17','12:25:00',6.57),('11288','2013-04-17','12:30:00',6.57),('11288','2013-04-17','12:35:00',6.63),('11288','2013-04-17','12:40:00',6.65),('11288','2013-04-17','12:45:00',6.64),('11288','2013-04-17','12:50:00',6.63),('11288','2013-04-17','12:55:00',6.58),('11288','2013-04-17','13:00:00',6.57),('11288','2013-04-17','13:05:00',6.57),('11288','2013-04-17','13:10:00',6.58),('11288','2013-04-17','13:15:00',6.69),('11288','2013-04-17','13:20:00',6.69),('11288','2013-04-17','13:25:00',6.67),('11288','2013-04-17','13:30:00',6.59),('11288','2013-04-17','13:35:00',6.59),('11288','2013-04-17','13:40:00',6.62),('11288','2013-04-17','13:45:00',6.64),('11288','2013-04-17','13:50:00',6.49),('11288','2013-04-17','13:55:00',6.78),('11288','2013-04-17','14:00:00',6.51),('11288','2013-04-17','14:05:00',7.06),('11288','2013-04-17','14:10:00',7.02),('11288','2013-04-17','14:15:00',6.56),('11288','2013-04-17','14:20:00',6.43),('11288','2013-04-17','14:25:00',5.99),('11288','2013-04-17','14:30:00',6.49),('11288','2013-04-17','14:35:00',6.7),('11288','2013-04-17','14:40:00',6.07),('11288','2013-04-17','14:45:00',6.02),('11288','2013-04-17','14:50:00',6.82),('11288','2013-04-17','14:55:00',6.56),('11288','2013-04-17','15:00:00',6.47),('11288','2013-04-17','15:05:00',6.56),('11288','2013-04-17','15:10:00',6.76),('11288','2013-04-17','15:15:00',6.15),('11288','2013-04-17','15:20:00',3.8),('11288','2013-04-17','15:25:00',2.85),('11288','2013-04-17','15:30:00',4.98),('11288','2013-04-17','15:35:00',5.61),('11288','2013-04-17','15:40:00',5.75),('11288','2013-04-17','15:45:00',5.71),('11288','2013-04-17','15:50:00',5.74),('11288','2013-04-17','15:55:00',5.44),('11288','2013-04-17','16:00:00',5.32),('11288','2013-04-17','16:05:00',4.08),('11288','2013-04-17','16:10:00',5.04),('11288','2013-04-17','16:15:00',4.88),('11288','2013-04-17','16:20:00',4.64),('11288','2013-04-17','16:25:00',4.5),('11288','2013-04-17','16:30:00',4.39),('11288','2013-04-17','16:35:00',4.33),('11288','2013-04-17','16:40:00',3.68),('11288','2013-04-17','16:45:00',4.08),('11288','2013-04-17','16:50:00',3.82),('11288','2013-04-17','16:55:00',3.6),('11288','2013-04-17','17:00:00',3.43),('11288','2013-04-17','17:05:00',3.3),('11288','2013-04-17','17:10:00',3.12),('11288','2013-04-17','17:15:00',3),('11288','2013-04-17','17:20:00',2.86),('11288','2013-04-17','17:25:00',2.72),('11288','2013-04-17','17:30:00',2.59),('11288','2013-04-17','17:35:00',2.45),('11288','2013-04-17','17:40:00',2.29),('11288','2013-04-17','17:45:00',2.17),('11288','2013-04-17','17:50:00',1.98),('11288','2013-04-17','17:55:00',1.85),('11288','2013-04-17','18:00:00',1.74),('11288','2013-04-17','18:05:00',1.62),('11288','2013-04-17','18:10:00',1.5),('11288','2013-04-17','18:15:00',1.38),('11288','2013-04-17','18:20:00',1.24),('11288','2013-04-17','18:25:00',1.13),('11288','2013-04-17','18:30:00',1.02),('11288','2013-04-16','08:00:00',1.18),('11288','2013-04-16','08:05:00',1.31),('11288','2013-04-16','08:10:00',1.48),('11288','2013-04-16','08:15:00',1.47),('11288','2013-04-16','08:20:00',1.19),('11288','2013-04-16','08:25:00',1.42),('11288','2013-04-16','08:30:00',1.33),('11288','2013-04-16','08:35:00',1.33),('11288','2013-04-16','08:40:00',1.41),('11288','2013-04-16','08:45:00',1.59),('11288','2013-04-16','08:50:00',1.8),('11288','2013-04-16','08:55:00',1.82),('11288','2013-04-16','09:00:00',1.41),('11288','2013-04-16','09:05:00',1.14),('11288','2013-04-16','09:10:00',2.44),('11288','2013-04-16','09:15:00',3.43),('11288','2013-04-16','09:20:00',2.17),('11288','2013-04-16','09:25:00',2.34),('11288','2013-04-16','09:30:00',2.58),('11288','2013-04-16','09:35:00',2.65),('11288','2013-04-16','09:40:00',2.52),('11288','2013-04-16','09:45:00',2.66),('11288','2013-04-16','09:50:00',2.45),('11288','2013-04-16','09:55:00',2.34),('11288','2013-04-16','10:00:00',2.21),('11288','2013-04-16','10:05:00',2.2),('11288','2013-04-16','10:10:00',2.34),('11288','2013-04-16','10:15:00',2.49),('11288','2013-04-16','10:20:00',2.62),('11288','2013-04-16','10:25:00',2.68),('11288','2013-04-16','10:30:00',2.68),('11288','2013-04-16','10:35:00',2.74),('11288','2013-04-16','10:40:00',2.7),('11288','2013-04-16','10:45:00',2.61),('11288','2013-04-16','10:50:00',2.64),('11288','2013-04-16','10:55:00',2.81),('11288','2013-04-16','11:00:00',3.03),('11288','2013-04-16','11:05:00',3.13),('11288','2013-04-16','11:10:00',3.1),('11288','2013-04-16','11:15:00',3.16),('11288','2013-04-16','11:20:00',3.24),('11288','2013-04-16','11:25:00',3.17),('11288','2013-04-16','11:30:00',3.08),('11288','2013-04-16','11:35:00',2.97),('11288','2013-04-16','11:40:00',3.19),('11288','2013-04-16','11:45:00',3.7),('11288','2013-04-16','11:50:00',3.97),('11288','2013-04-16','11:55:00',4.09),('11288','2013-04-16','12:00:00',4.26),('11288','2013-04-16','12:05:00',4.71),('11288','2013-04-16','12:10:00',5.16),('11288','2013-04-16','12:15:00',4.92),('11288','2013-04-16','12:20:00',4.95),('11288','2013-04-16','12:25:00',5.18),('11288','2013-04-16','12:30:00',3.87),('11288','2013-04-16','12:35:00',4.26),('11288','2013-04-16','12:40:00',5.34),('11288','2013-04-16','12:45:00',6.09),('11288','2013-04-16','12:50:00',5.39),('11288','2013-04-16','12:55:00',5.96),('11288','2013-04-16','13:00:00',6.64),('11288','2013-04-16','13:05:00',6.56),('11288','2013-04-16','13:10:00',6.42),('11288','2013-04-16','13:15:00',6.43),('11288','2013-04-16','13:20:00',6.49),('11288','2013-04-16','13:25:00',6.51),('11288','2013-04-16','13:30:00',6.43),('11288','2013-04-16','13:35:00',6.41),('11288','2013-04-16','13:40:00',6.39),('11288','2013-04-16','13:45:00',6.18),('11288','2013-04-16','13:50:00',6.31),('11288','2013-04-16','13:55:00',6.09),('11288','2013-04-16','14:00:00',6.22),('11288','2013-04-16','14:05:00',6.28),('11288','2013-04-16','14:10:00',6.21),('11288','2013-04-16','14:15:00',6.35),('11288','2013-04-16','14:20:00',6.1),('11288','2013-04-16','14:25:00',5.86),('11288','2013-04-16','14:30:00',5.77),('11288','2013-04-16','14:35:00',4.35),('11288','2013-04-16','14:40:00',5.83),('11288','2013-04-16','14:45:00',5.94),('11288','2013-04-16','14:50:00',5.84),('11288','2013-04-16','14:55:00',5.73),('11288','2013-04-16','15:00:00',5.72),('11288','2013-04-16','15:05:00',5.78),('11288','2013-04-16','15:10:00',5.78),('11288','2013-04-16','15:15:00',5.67),('11288','2013-04-16','15:20:00',5.57),('11288','2013-04-16','15:25:00',4.97),('11288','2013-04-16','15:30:00',4.93),('11288','2013-04-16','15:35:00',5.25),('11288','2013-04-16','15:40:00',5.18),('11288','2013-04-16','15:45:00',5.14),('11288','2013-04-16','15:50:00',5.02),('11288','2013-04-16','15:55:00',4.94),('11288','2013-04-16','16:00:00',4.77),('11288','2013-04-16','16:05:00',4.69),('11288','2013-04-16','16:10:00',4.56),('11288','2013-04-16','16:15:00',4.31),('11288','2013-04-16','16:20:00',4.36),('11288','2013-04-16','16:25:00',4.25),('11288','2013-04-16','16:30:00',4.19),('11288','2013-04-16','16:35:00',4.09),('11288','2013-04-16','16:40:00',4.18),('11288','2013-04-16','16:45:00',4.25),('11288','2013-04-16','16:50:00',3.93),('11288','2013-04-16','16:55:00',3.11),('11288','2013-04-16','17:00:00',3.25),('11288','2013-04-16','17:05:00',3.42),('11288','2013-04-16','17:10:00',3.38),('11288','2013-04-16','17:15:00',3.29),('11288','2013-04-16','17:20:00',3.18),('11288','2013-04-16','17:25:00',3.09),('11288','2013-04-16','17:30:00',2.79),('11288','2013-04-16','17:35:00',2.78),('11288','2013-04-16','17:40:00',2.72),('11288','2013-04-16','17:45:00',2.5),('11288','2013-04-16','17:50:00',2.25),('11288','2013-04-16','17:55:00',1.91),('11288','2013-04-16','18:00:00',1.47),('11288','2013-04-16','18:05:00',1.43),('11288','2013-04-16','18:10:00',1.36),('11288','2013-04-16','18:15:00',1.26),('11288','2013-04-16','18:20:00',1.05),('11288','2013-04-15','07:55:00',1.09),('11288','2013-04-15','08:00:00',1.19),('11288','2013-04-15','08:05:00',1.27),('11288','2013-04-15','08:10:00',1.41),('11288','2013-04-15','08:15:00',1.5),('11288','2013-04-15','08:20:00',1.61),('11288','2013-04-15','08:25:00',1.77),('11288','2013-04-15','08:30:00',1.85),('11288','2013-04-15','08:35:00',2.05),('11288','2013-04-15','08:40:00',2.28),('11288','2013-04-15','08:45:00',2.38),('11288','2013-04-15','08:50:00',2.59),('11288','2013-04-15','08:55:00',2.82),('11288','2013-04-15','09:00:00',2.94),('11288','2013-04-15','09:05:00',2.93),('11288','2013-04-15','09:10:00',3.2),('11288','2013-04-15','09:15:00',3.41),('11288','2013-04-15','09:20:00',3.46),('11288','2013-04-15','09:25:00',3.5),('11288','2013-04-15','09:30:00',3.78),('11288','2013-04-15','09:35:00',3.83),('11288','2013-04-15','09:40:00',4.02),('11288','2013-04-15','09:45:00',4.15),('11288','2013-04-15','09:50:00',4.07),('11288','2013-04-15','09:55:00',4.19),('11288','2013-04-15','10:00:00',4.57),('11288','2013-04-15','10:05:00',4.71),('11288','2013-04-15','10:10:00',4.84),('11288','2013-04-15','10:15:00',4.99),('11288','2013-04-15','10:20:00',5.12),('11288','2013-04-15','10:25:00',5.24),('11288','2013-04-15','10:30:00',5.32),('11288','2013-04-15','10:35:00',5.35),('11288','2013-04-15','10:40:00',5.46),('11288','2013-04-15','10:45:00',5.55),('11288','2013-04-15','10:50:00',5.59),('11288','2013-04-15','10:55:00',5.64),('11288','2013-04-15','11:00:00',5.73),('11288','2013-04-15','11:05:00',5.8),('11288','2013-04-15','11:10:00',5.89),('11288','2013-04-15','11:15:00',5.96),('11288','2013-04-15','11:20:00',5.99),('11288','2013-04-15','11:25:00',6.02),('11288','2013-04-15','11:30:00',6.04),('11288','2013-04-15','11:35:00',6.13),('11288','2013-04-15','11:40:00',6.15),('11288','2013-04-15','11:45:00',6.21),('11288','2013-04-15','11:50:00',6.26),('11288','2013-04-15','11:55:00',6.25),('11288','2013-04-15','12:00:00',6.4),('11288','2013-04-15','12:05:00',6.48),('11288','2013-04-15','12:10:00',6.48),('11288','2013-04-15','12:15:00',6.46),('11288','2013-04-15','12:20:00',6.46),('11288','2013-04-15','12:25:00',6.46),('11288','2013-04-15','12:30:00',6.53),('11288','2013-04-15','12:35:00',6.52),('11288','2013-04-15','12:40:00',6.58),('11288','2013-04-15','12:45:00',6.56),('11288','2013-04-15','12:50:00',6.52),('11288','2013-04-15','12:55:00',6.51),('11288','2013-04-15','13:00:00',6.53),('11288','2013-04-15','13:05:00',6.52),('11288','2013-04-15','13:10:00',6.53),('11288','2013-04-15','13:15:00',6.54),('11288','2013-04-15','13:20:00',6.48),('11288','2013-04-15','13:25:00',6.56),('11288','2013-04-15','13:30:00',6.58),('11288','2013-04-15','13:35:00',6.48),('11288','2013-04-15','13:40:00',6.45),('11288','2013-04-15','13:45:00',6.47),('11288','2013-04-15','13:50:00',6.5),('11288','2013-04-15','13:55:00',6.5),('11288','2013-04-15','14:00:00',6.52),('11288','2013-04-15','14:05:00',6.51),('11288','2013-04-15','14:10:00',6.46),('11288','2013-04-15','14:15:00',6.46),('11288','2013-04-15','14:20:00',6.45),('11288','2013-04-15','14:25:00',6.35),('11288','2013-04-15','14:30:00',6.33),('11288','2013-04-15','14:35:00',6.27),('11288','2013-04-15','14:40:00',6.22),('11288','2013-04-15','14:45:00',6.18),('11288','2013-04-15','14:50:00',6.1),('11288','2013-04-15','14:55:00',6.03),('11288','2013-04-15','15:00:00',5.96),('11288','2013-04-15','15:05:00',5.92),('11288','2013-04-15','15:10:00',5.86),('11288','2013-04-15','15:15:00',5.79),('11288','2013-04-15','15:20:00',5.71),('11288','2013-04-15','15:25:00',5.63),('11288','2013-04-15','15:30:00',5.58),('11288','2013-04-15','15:35:00',5.5),('11288','2013-04-15','15:40:00',5.41),('11288','2013-04-15','15:45:00',5.3),('11288','2013-04-15','15:50:00',5.2),('11288','2013-04-15','15:55:00',5.05),('11288','2013-04-15','16:00:00',4.96),('11288','2013-04-15','16:05:00',4.83),('11288','2013-04-15','16:10:00',4.72),('11288','2013-04-15','16:15:00',4.59),('11288','2013-04-15','16:20:00',4.47),('11288','2013-04-15','16:25:00',4.35),('11288','2013-04-15','16:30:00',4.22),('11288','2013-04-15','16:35:00',4.05),('11288','2013-04-15','16:40:00',3.94),('11288','2013-04-15','16:45:00',3.8),('11288','2013-04-15','16:50:00',3.7),('11288','2013-04-15','16:55:00',3.54),('11288','2013-04-15','17:00:00',3.42),('11288','2013-04-15','17:05:00',3.28),('11288','2013-04-15','17:10:00',3.13),('11288','2013-04-15','17:15:00',2.99),('11288','2013-04-15','17:20:00',2.83),('11288','2013-04-15','17:25:00',2.7),('11288','2013-04-15','17:30:00',2.56),('11288','2013-04-15','17:35:00',2.43),('11288','2013-04-15','17:40:00',2.28),('11288','2013-04-15','17:45:00',2.14),('11288','2013-04-15','17:50:00',2),('11288','2013-04-15','17:55:00',1.85),('11288','2013-04-15','18:00:00',1.74),('11288','2013-04-15','18:05:00',1.62),('11288','2013-04-15','18:10:00',1.49),('11288','2013-04-15','18:15:00',1.36),('11288','2013-04-15','18:20:00',1.23),('11288','2013-04-15','18:25:00',1.12),('11288','2013-04-14','07:50:00',1.01),('11288','2013-04-14','07:55:00',1.21),('11288','2013-04-14','08:00:00',1.3),('11288','2013-04-14','08:05:00',1.3),('11288','2013-04-14','08:10:00',1.5),('11288','2013-04-14','08:15:00',1.6),('11288','2013-04-14','08:20:00',1.63),('11288','2013-04-14','08:25:00',1.76),('11288','2013-04-14','08:30:00',1.92),('11288','2013-04-14','08:35:00',2.01),('11288','2013-04-14','08:40:00',2.28),('11288','2013-04-14','08:45:00',2.41),('11288','2013-04-14','08:50:00',2.62),('11288','2013-04-14','08:55:00',2.76),('11288','2013-04-14','09:00:00',2.9),('11288','2013-04-14','09:05:00',2.95),('11288','2013-04-14','09:10:00',3.14),('11288','2013-04-14','09:15:00',3.29),('11288','2013-04-14','09:20:00',3.34),('11288','2013-04-14','09:25:00',3.44),('11288','2013-04-14','09:30:00',3.76),('11288','2013-04-14','09:35:00',3.8),('11288','2013-04-14','09:40:00',3.98),('11288','2013-04-14','09:45:00',3.95),('11288','2013-04-14','09:50:00',3.94),('11288','2013-04-14','09:55:00',4.08),('11288','2013-04-14','10:00:00',4.37),('11288','2013-04-14','10:05:00',4.58),('11288','2013-04-14','10:10:00',4.76),('11288','2013-04-14','10:15:00',4.87),('11288','2013-04-14','10:20:00',4.92),('11288','2013-04-14','10:25:00',5.03),('11288','2013-04-14','10:30:00',5.16),('11288','2013-04-14','10:35:00',5.25),('11288','2013-04-14','10:40:00',5.37),('11288','2013-04-14','10:45:00',5.5),('11288','2013-04-14','10:50:00',5.55),('11288','2013-04-14','10:55:00',5.54),('11288','2013-04-14','11:00:00',5.63),('11288','2013-04-14','11:05:00',5.67),('11288','2013-04-14','11:10:00',5.74),('11288','2013-04-14','11:15:00',5.8),('11288','2013-04-14','11:20:00',5.92),('11288','2013-04-14','11:25:00',5.97),('11288','2013-04-14','11:30:00',5.97),('11288','2013-04-14','11:35:00',6.03),('11288','2013-04-14','11:40:00',6.05),('11288','2013-04-14','11:45:00',6.04),('11288','2013-04-14','11:50:00',6.08),('11288','2013-04-14','11:55:00',6.11),('11288','2013-04-14','12:00:00',6.28),('11288','2013-04-14','12:05:00',6.29),('11288','2013-04-14','12:10:00',6.33),('11288','2013-04-14','12:15:00',6.36),('11288','2013-04-14','12:20:00',6.42),('11288','2013-04-14','12:25:00',6.45),('11288','2013-04-14','12:30:00',6.46),('11288','2013-04-14','12:35:00',6.49),('11288','2013-04-14','12:40:00',5.57),('11288','2013-04-14','12:45:00',1.14),('11288','2013-04-14','12:50:00',4.37),('11288','2013-04-14','12:55:00',6.87),('11288','2013-04-14','13:00:00',6.77),('11288','2013-04-14','13:05:00',4.33),('11288','2013-04-14','13:10:00',6.82),('11288','2013-04-14','13:15:00',6.79),('11288','2013-04-14','13:20:00',6.78),('11288','2013-04-14','13:25:00',6.65),('11288','2013-04-14','13:30:00',6.64),('11288','2013-04-14','13:35:00',6.6),('11288','2013-04-14','13:40:00',6.49),('11288','2013-04-14','13:45:00',6.45),('11288','2013-04-14','13:50:00',6.33),('11288','2013-04-14','13:55:00',6.35),('11288','2013-04-14','14:00:00',6.32),('11288','2013-04-14','14:05:00',6.41),('11288','2013-04-14','14:10:00',6.34),('11288','2013-04-14','14:15:00',6.32),('11288','2013-04-14','14:20:00',6.2),('11288','2013-04-14','14:25:00',6.17),('11288','2013-04-14','14:30:00',6.17),('11288','2013-04-14','14:35:00',6.23),('11288','2013-04-14','14:40:00',6.24),('11288','2013-04-14','14:45:00',6.3),('11288','2013-04-14','14:50:00',6.26),('11288','2013-04-14','14:55:00',6.03),('11288','2013-04-14','15:00:00',6.02),('11288','2013-04-14','15:05:00',5.97),('11288','2013-04-14','15:10:00',5.9),('11288','2013-04-14','15:15:00',5),('11288','2013-04-14','15:20:00',5.43),('11288','2013-04-14','15:25:00',4.04),('11288','2013-04-14','15:30:00',5.43),('11288','2013-04-14','15:35:00',5.44),('11288','2013-04-14','15:40:00',5.52),('11288','2013-04-14','15:45:00',5.32),('11288','2013-04-14','15:50:00',5.27),('11288','2013-04-14','15:55:00',4.97),('11288','2013-04-14','16:00:00',4.55),('11288','2013-04-14','16:05:00',4.61),('11288','2013-04-14','16:10:00',4.45),('11288','2013-04-14','16:15:00',4.38),('11288','2013-04-14','16:20:00',4.23),('11288','2013-04-14','16:25:00',4.15),('11288','2013-04-14','16:30:00',4.07),('11288','2013-04-14','16:35:00',3.94),('11288','2013-04-14','16:40:00',3.84),('11288','2013-04-14','16:45:00',3.69),('11288','2013-04-14','16:50:00',3.57),('11288','2013-04-14','16:55:00',3.42),('11288','2013-04-14','17:00:00',3.28),('11288','2013-04-14','17:05:00',3.12),('11288','2013-04-14','17:10:00',3.02),('11288','2013-04-14','17:15:00',2.88),('11288','2013-04-14','17:20:00',2.72),('11288','2013-04-14','17:25:00',2.6),('11288','2013-04-14','17:30:00',2.44),('11288','2013-04-14','17:35:00',2.33),('11288','2013-04-14','17:40:00',2.19),('11288','2013-04-14','17:45:00',2.05),('11288','2013-04-14','17:50:00',1.93),('11288','2013-04-14','17:55:00',1.77),('11288','2013-04-14','18:00:00',1.63),('11288','2013-04-14','18:05:00',1.53),('11288','2013-04-14','18:10:00',1.42),('11288','2013-04-14','18:15:00',1.32),('11288','2013-04-14','18:20:00',1.2),('11288','2013-04-14','18:25:00',1.07),('11288','2013-04-13','07:50:00',1.04),('11288','2013-04-13','07:55:00',1.1),('11288','2013-04-13','08:00:00',1.21),('11288','2013-04-13','08:05:00',1.29),('11288','2013-04-13','08:10:00',1.43),('11288','2013-04-13','08:15:00',1.62),('11288','2013-04-13','08:20:00',1.61),('11288','2013-04-13','08:25:00',1.02),('11288','2013-04-13','08:40:00',1.17),('11288','2013-04-13','08:45:00',1.26),('11288','2013-04-13','08:50:00',1.76),('11288','2013-04-13','08:55:00',2.48),('11288','2013-04-13','09:00:00',1.85),('11288','2013-04-13','09:05:00',1.84),('11288','2013-04-13','09:10:00',2.52),('11288','2013-04-13','09:15:00',1.91),('11288','2013-04-13','09:20:00',2.39),('11288','2013-04-13','09:25:00',2.33),('11288','2013-04-13','09:30:00',3.49),('11288','2013-04-13','09:35:00',3.64),('11288','2013-04-13','09:40:00',3.49),('11288','2013-04-13','09:45:00',4.03),('11288','2013-04-13','09:50:00',4.19),('11288','2013-04-13','09:55:00',4.31),('11288','2013-04-13','10:00:00',4.47),('11288','2013-04-13','10:05:00',4.62),('11288','2013-04-13','10:10:00',4.35),('11288','2013-04-13','10:15:00',4.84),('11288','2013-04-13','10:20:00',5.35),('11288','2013-04-13','10:25:00',5.39),('11288','2013-04-13','10:30:00',4.23),('11288','2013-04-13','10:35:00',5.07),('11288','2013-04-13','10:40:00',5.92),('11288','2013-04-13','10:45:00',3.65),('11288','2013-04-13','10:50:00',6.28),('11288','2013-04-13','10:55:00',3.37),('11288','2013-04-13','11:00:00',2.67),('11288','2013-04-13','11:05:00',5.7),('11288','2013-04-13','11:10:00',5.8),('11288','2013-04-13','11:15:00',4.97),('11288','2013-04-13','11:20:00',3.01),('11288','2013-04-13','11:25:00',3.8),('11288','2013-04-13','11:30:00',6.12),('11288','2013-04-13','11:35:00',6.64),('11288','2013-04-13','11:40:00',4.42),('11288','2013-04-13','11:45:00',5.48),('11288','2013-04-13','11:50:00',6.18),('11288','2013-04-13','11:55:00',6.71),('11288','2013-04-13','12:00:00',6.94),('11288','2013-04-13','12:05:00',6.81),('11288','2013-04-13','12:10:00',6.83),('11288','2013-04-13','12:15:00',6.15),('11288','2013-04-13','12:20:00',6.92),('11288','2013-04-13','12:25:00',6.96),('11288','2013-04-13','12:30:00',6.76),('11288','2013-04-13','12:35:00',6.88),('11288','2013-04-13','12:40:00',6.86),('11288','2013-04-13','12:45:00',6.66),('11288','2013-04-13','12:50:00',6.57),('11288','2013-04-13','12:55:00',6.51),('11288','2013-04-13','13:00:00',6.59),('11288','2013-04-13','13:05:00',6.69),('11288','2013-04-13','13:10:00',7.04),('11288','2013-04-13','13:15:00',6.81),('11288','2013-04-13','13:20:00',6.78),('11288','2013-04-13','13:25:00',6.74),('11288','2013-04-13','13:30:00',5.77),('11288','2013-04-13','13:35:00',4.45),('11288','2013-04-13','13:40:00',6),('11288','2013-04-13','13:45:00',4.91),('11288','2013-04-13','13:50:00',2.69),('11288','2013-04-13','13:55:00',3.51),('11288','2013-04-13','14:00:00',3.83),('11288','2013-04-13','14:05:00',3.5),('11288','2013-04-13','14:10:00',5.15),('11288','2013-04-13','14:15:00',5.95),('11288','2013-04-13','14:20:00',5.78),('11288','2013-04-13','14:25:00',5.89),('11288','2013-04-13','14:30:00',5.68),('11288','2013-04-13','14:35:00',5.72),('11288','2013-04-13','14:40:00',5.9),('11288','2013-04-13','14:45:00',5.96),('11288','2013-04-13','14:50:00',5.7),('11288','2013-04-13','14:55:00',5.86),('11288','2013-04-13','15:00:00',5.2),('11288','2013-04-13','15:05:00',4.39),('11288','2013-04-13','15:10:00',4.99),('11288','2013-04-13','15:15:00',4.49),('11288','2013-04-13','15:20:00',4.65),('11288','2013-04-13','15:25:00',4.3),('11288','2013-04-13','15:30:00',4.36),('11288','2013-04-13','15:35:00',4.27),('11288','2013-04-13','15:40:00',4.41),('11288','2013-04-13','15:45:00',4.47),('11288','2013-04-13','15:50:00',4.31),('11288','2013-04-13','15:55:00',4.31),('11288','2013-04-13','16:00:00',4.21),('11288','2013-04-13','16:05:00',4),('11288','2013-04-13','16:10:00',3.83),('11288','2013-04-13','16:15:00',3.83),('11288','2013-04-13','16:20:00',3.74),('11288','2013-04-13','16:25:00',3.47),('11288','2013-04-13','16:30:00',3.27),('11288','2013-04-13','16:35:00',3.11),('11288','2013-04-13','16:40:00',2.92),('11288','2013-04-13','16:45:00',2.75),('11288','2013-04-13','16:50:00',2.8),('11288','2013-04-13','16:55:00',2.35),('11288','2013-04-13','17:00:00',2.04),('11288','2013-04-13','17:05:00',1.93),('11288','2013-04-13','17:10:00',2.48),('11288','2013-04-13','17:15:00',2.73),('11288','2013-04-13','17:20:00',2.46),('11288','2013-04-13','17:25:00',2.76),('11288','2013-04-13','17:30:00',2.41),('11288','2013-04-13','17:35:00',2.37),('11288','2013-04-13','17:40:00',2.24),('11288','2013-04-13','17:45:00',2.01),('11288','2013-04-13','17:50:00',1.78),('11288','2013-04-13','17:55:00',1.91),('11288','2013-04-13','18:00:00',1.45),('11288','2013-04-13','18:05:00',1.43),('11288','2013-04-13','18:10:00',1.3),('11288','2013-04-13','18:15:00',1.29),('11288','2013-04-13','18:20:00',1.27),('11288','2013-04-13','18:25:00',1.14),('11288','2013-04-13','18:30:00',1.03),('11288','2013-04-12','07:50:00',1.02),('11288','2013-04-12','07:55:00',1.57),('11288','2013-04-12','08:00:00',1.3),('11288','2013-04-12','08:05:00',1.47),('11288','2013-04-12','08:10:00',1.71),('11288','2013-04-12','08:15:00',1.4),('11288','2013-04-12','08:20:00',1.53),('11288','2013-04-12','08:25:00',1.38),('11288','2013-04-12','08:30:00',1.68),('11288','2013-04-12','08:35:00',1.63),('11288','2013-04-12','08:40:00',1.59),('11288','2013-04-12','08:45:00',2.32),('11288','2013-04-12','08:50:00',2.54),('11288','2013-04-12','08:55:00',2.91),('11288','2013-04-12','09:00:00',2.14),('11288','2013-04-12','09:05:00',1.95),('11288','2013-04-12','09:10:00',1.72),('11288','2013-04-12','09:15:00',2.62),('11288','2013-04-12','09:20:00',3.02),('11288','2013-04-12','09:25:00',3.34),('11288','2013-04-12','09:30:00',2.28),('11288','2013-04-12','09:35:00',2.07),('11288','2013-04-12','09:40:00',2.09),('11288','2013-04-12','09:45:00',1.76),('11288','2013-04-12','09:50:00',1.52),('11288','2013-04-12','09:55:00',1.63),('11288','2013-04-12','10:00:00',1.81),('11288','2013-04-12','10:05:00',2.42),('11288','2013-04-12','10:10:00',1.72),('11288','2013-04-12','10:15:00',3.01),('11288','2013-04-12','10:20:00',5.2),('11288','2013-04-12','10:25:00',3.64),('11288','2013-04-12','10:30:00',2.8),('11288','2013-04-12','10:35:00',5.07),('11288','2013-04-12','10:40:00',6.36),('11288','2013-04-12','10:45:00',7.35),('11288','2013-04-12','10:50:00',4.53),('11288','2013-04-12','10:55:00',2.29),('11288','2013-04-12','11:00:00',2.38),('11288','2013-04-12','11:05:00',3.33),('11288','2013-04-12','11:10:00',5.22),('11288','2013-04-12','11:15:00',5.97),('11288','2013-04-12','11:20:00',6.3),('11288','2013-04-12','11:25:00',7.23),('11288','2013-04-12','11:30:00',7.41),('11288','2013-04-12','11:35:00',3.19),('11288','2013-04-12','11:40:00',2.55),('11288','2013-04-12','11:45:00',3.34),('11288','2013-04-12','11:50:00',4.31),('11288','2013-04-12','11:55:00',5.74),('11288','2013-04-12','12:00:00',6.95),('11288','2013-04-12','12:05:00',6.96),('11288','2013-04-12','12:10:00',6.78),('11288','2013-04-12','12:15:00',7.04),('11288','2013-04-12','12:20:00',6.95),('11288','2013-04-12','12:25:00',6.99),('11288','2013-04-12','12:30:00',6.92),('11288','2013-04-12','12:35:00',6.8),('11288','2013-04-12','12:40:00',6.62),('11288','2013-04-12','12:45:00',6.81),('11288','2013-04-12','12:50:00',5.67),('11288','2013-04-12','12:55:00',6.8),('11288','2013-04-12','13:00:00',6.77),('11288','2013-04-12','13:05:00',6.69),('11288','2013-04-12','13:10:00',6.76),('11288','2013-04-12','13:15:00',6.83),('11288','2013-04-12','13:20:00',6.84),('11288','2013-04-12','13:25:00',6.84),('11288','2013-04-12','13:30:00',6.77),('11288','2013-04-12','13:35:00',6.88),('11288','2013-04-12','13:40:00',6.75),('11288','2013-04-12','13:45:00',6.79),('11288','2013-04-12','13:50:00',6.72),('11288','2013-04-12','13:55:00',6.73),('11288','2013-04-12','14:00:00',6.73),('11288','2013-04-12','14:05:00',6.67),('11288','2013-04-12','14:10:00',6.63),('11288','2013-04-12','14:15:00',6.56),('11288','2013-04-12','14:20:00',6.47),('11288','2013-04-12','14:25:00',6.45),('11288','2013-04-12','14:30:00',6.37),('11288','2013-04-12','14:35:00',6.3),('11288','2013-04-12','14:40:00',6.25),('11288','2013-04-12','14:45:00',6.16),('11288','2013-04-12','14:50:00',6.07),('11288','2013-04-12','14:55:00',6.02),('11288','2013-04-12','15:00:00',5.96),('11288','2013-04-12','15:05:00',5.87),('11288','2013-04-12','15:10:00',5.77),('11288','2013-04-12','15:15:00',5.74),('11288','2013-04-12','15:20:00',5.64),('11288','2013-04-12','15:25:00',5.52),('11288','2013-04-12','15:30:00',5.47),('11288','2013-04-12','15:35:00',5.37),('11288','2013-04-12','15:40:00',5.27),('11288','2013-04-12','15:45:00',5.2),('11288','2013-04-12','15:50:00',5.06),('11288','2013-04-12','15:55:00',4.93),('11288','2013-04-12','16:00:00',4.87),('11288','2013-04-12','16:05:00',4.75),('11288','2013-04-12','16:10:00',4.7),('11288','2013-04-12','16:15:00',4.03),('11288','2013-04-12','16:20:00',4.43),('11288','2013-04-12','16:25:00',4.29),('11288','2013-04-12','16:30:00',2.38),('11288','2013-04-12','16:35:00',1.91),('11288','2013-04-12','16:40:00',2.92),('11288','2013-04-12','16:45:00',3.94),('11288','2013-04-12','16:50:00',3.66),('11288','2013-04-12','16:55:00',3.49),('11288','2013-04-12','17:00:00',3.35),('11288','2013-04-12','17:05:00',3.16),('11288','2013-04-12','17:10:00',3.02),('11288','2013-04-12','17:15:00',2.91),('11288','2013-04-12','17:20:00',2.75),('11288','2013-04-12','17:25:00',2.67),('11288','2013-04-12','17:30:00',2.54),('11288','2013-04-12','17:35:00',2.15),('11288','2013-04-12','17:40:00',1.98),('11288','2013-04-12','17:45:00',2.03),('11288','2013-04-12','17:50:00',1.93),('11288','2013-04-12','17:55:00',1.81),('11288','2013-04-12','18:00:00',1.66),('11288','2013-04-12','18:05:00',1.5),('11288','2013-04-12','18:10:00',1.36),('11288','2013-04-12','18:15:00',1.23),('11288','2013-04-12','18:20:00',1.14),('11288','2014-03-28','07:15:00',1.05),('11288','2014-03-28','07:20:00',1.03),('11288','2014-03-28','07:25:00',1.06),('11288','2014-03-28','07:30:00',1.26),('11288','2014-03-28','07:35:00',1.4),('11288','2014-03-28','07:40:00',1.59),('11288','2014-03-28','07:45:00',1.82),('11288','2014-03-28','07:50:00',1.94),('11288','2014-03-28','07:55:00',2.01),('11288','2014-03-28','08:00:00',2.1),('11288','2014-03-28','08:05:00',2.16),('11288','2014-03-28','08:10:00',2.5),('11288','2014-03-28','08:15:00',2.6),('11288','2014-03-28','08:20:00',2.67),('11288','2014-03-28','08:25:00',3.01),('11288','2014-03-28','08:30:00',3.14),('11288','2014-03-28','08:35:00',3.09),('11288','2014-03-28','08:40:00',3.54),('11288','2014-03-28','08:45:00',3.62),('11288','2014-03-28','08:50:00',3.84),('11288','2014-03-28','08:55:00',4.09),('11288','2014-03-28','09:00:00',4.26),('11288','2014-03-28','09:05:00',4.46),('11288','2014-03-28','09:10:00',4.77),('11288','2014-03-28','09:15:00',4.85),('11288','2014-03-28','09:20:00',4.6),('11288','2014-03-28','09:25:00',5.46),('11288','2014-03-28','09:30:00',5.59),('11288','2014-03-28','09:35:00',5.21),('11288','2014-03-28','09:40:00',3.17),('11288','2014-03-28','09:45:00',3.16),('11288','2014-03-28','09:50:00',3.98),('11288','2014-03-28','09:55:00',5.85),('11288','2014-03-28','10:00:00',5.64),('11288','2014-03-28','10:05:00',5.77),('11288','2014-03-28','10:10:00',5.72),('11288','2014-03-28','10:15:00',4.27),('11288','2014-03-28','10:20:00',3.9),('11288','2014-03-28','10:25:00',5.59),('11288','2014-03-28','10:30:00',5.9),('11288','2014-03-28','10:35:00',5.82),('11288','2014-03-28','10:40:00',5.58),('11288','2014-03-28','10:45:00',4.73),('11288','2014-03-28','10:50:00',5.71),('11288','2014-03-28','10:55:00',6.31),('11288','2014-03-28','11:00:00',6.31),('11288','2014-03-28','11:05:00',6.01),('11288','2014-03-28','11:10:00',4.53),('11288','2014-03-28','11:15:00',3.8),('11288','2014-03-28','11:20:00',2.15),('11288','2014-03-28','11:25:00',4.47),('11288','2014-03-28','11:30:00',4.03),('11288','2014-03-28','11:35:00',2.93),('11288','2014-03-28','11:40:00',2.48),('11288','2014-03-28','11:45:00',4.8),('11288','2014-03-28','11:50:00',4.6),('11288','2014-03-28','11:55:00',2.41),('11288','2014-03-28','12:00:00',2.15),('11288','2014-03-28','12:05:00',6.57),('11288','2014-03-28','12:10:00',7.33),('11288','2014-03-28','12:15:00',7.57),('11288','2014-03-28','12:20:00',7.71),('11288','2014-03-28','12:25:00',3.12),('11288','2014-03-28','12:30:00',1.44),('11288','2014-03-28','12:35:00',4.85),('11288','2014-03-28','12:40:00',4.54),('11288','2014-03-28','12:45:00',7.15),('11288','2014-03-28','12:50:00',6.88),('11288','2014-03-28','12:55:00',4.25),('11288','2014-03-28','13:00:00',5.11),('11288','2014-03-28','13:05:00',5.48),('11288','2014-03-28','13:10:00',5.04),('11288','2014-03-28','13:15:00',3.32),('11288','2014-03-28','13:20:00',3.68),('11288','2014-03-28','13:25:00',2.99),('11288','2014-03-28','13:30:00',2.51),('11288','2014-03-28','13:35:00',6.19),('11288','2014-03-28','13:40:00',6.49),('11288','2014-03-28','13:45:00',6.52),('11288','2014-03-28','13:50:00',6.21),('11288','2014-03-28','13:55:00',6.06),('11288','2014-03-28','14:00:00',6.05),('11288','2014-03-28','14:05:00',5.92),('11288','2014-03-28','14:10:00',5.85),('11288','2014-03-28','14:15:00',5.8),('11288','2014-03-28','14:20:00',5.7),('11288','2014-03-28','14:25:00',5.64),('11288','2014-03-28','14:30:00',5.57),('11288','2014-03-28','14:35:00',5.49),('11288','2014-03-28','14:40:00',5.42),('11288','2014-03-28','14:45:00',5.3),('11288','2014-03-28','14:50:00',5.2),('11288','2014-03-28','14:55:00',5.12),('11288','2014-03-28','15:00:00',5.04),('11288','2014-03-28','15:05:00',4.94),('11288','2014-03-28','15:10:00',4.74),('11288','2014-03-28','15:15:00',4.62),('11288','2014-03-28','15:20:00',4.5),('11288','2014-03-28','15:25:00',4.35),('11288','2014-03-28','15:30:00',4.23),('11288','2014-03-28','15:35:00',4.12),('11288','2014-03-28','15:40:00',3.96),('11288','2014-03-28','15:45:00',3.92),('11288','2014-03-28','15:50:00',3.87),('11288','2014-03-28','15:55:00',3.48),('11288','2014-03-28','16:00:00',3.8),('11288','2014-03-28','16:05:00',3.85),('11288','2014-03-28','16:10:00',3.67),('11288','2014-03-28','16:15:00',3.5),('11288','2014-03-28','16:20:00',2.98),('11288','2014-03-28','16:25:00',2.62),('11288','2014-03-28','16:30:00',2.47),('11288','2014-03-28','16:35:00',1.41),('11288','2014-03-28','16:40:00',1.23),('11288','2014-03-28','16:45:00',1.77),('11288','2014-03-28','16:50:00',1.86),('11288','2014-03-28','16:55:00',1.02),('11288','2014-03-28','17:00:00',1.41),('11288','2014-03-28','17:05:00',1.21),('11288','2014-03-28','17:10:00',1.18),('11288','2014-03-28','17:15:00',1.17),('11288','2014-03-28','17:20:00',1.32),('11288','2013-04-11','07:55:00',1.01),('11288','2013-04-11','08:00:00',1.14),('11288','2013-04-11','08:05:00',1.23),('11288','2013-04-11','08:10:00',1.33),('11288','2013-04-11','08:15:00',1.48),('11288','2013-04-11','08:20:00',1.58),('11288','2013-04-11','08:25:00',1.69),('11288','2013-04-11','08:30:00',1.91),('11288','2013-04-11','08:35:00',2.01),('11288','2013-04-11','08:40:00',2.21),('11288','2013-04-11','08:45:00',2.43),('11288','2013-04-11','08:50:00',2.51),('11288','2013-04-11','08:55:00',2.67),('11288','2013-04-11','09:00:00',2.78),('11288','2013-04-11','09:05:00',2.94),('11288','2013-04-11','09:10:00',3.01),('11288','2013-04-11','09:15:00',3.16),('11288','2013-04-11','09:20:00',3.31),('11288','2013-04-11','09:25:00',3.48),('11288','2013-04-11','09:30:00',3.51),('11288','2013-04-11','09:35:00',3.63),('11288','2013-04-11','09:40:00',2.94),('11288','2013-04-11','09:45:00',3.83),('11288','2013-04-11','09:50:00',3.07),('11288','2013-04-11','09:55:00',1.9),('11288','2013-04-11','10:00:00',2.11),('11288','2013-04-11','10:05:00',1.29),('11288','2013-04-11','10:10:00',4.95),('11288','2013-04-11','10:15:00',4.93),('11288','2013-04-11','10:20:00',5.19),('11288','2013-04-11','10:25:00',5.58),('11288','2013-04-11','10:30:00',5.59),('11288','2013-04-11','10:35:00',5.98),('11288','2013-04-11','10:40:00',5.51),('11288','2013-04-11','10:45:00',5.2),('11288','2013-04-11','10:50:00',1.39),('11288','2013-04-11','10:55:00',1.77),('11288','2013-04-11','11:00:00',3.1),('11288','2013-04-11','11:05:00',4.53),('11288','2013-04-11','11:10:00',6.34),('11288','2013-04-11','11:15:00',4.93),('11288','2013-04-11','11:20:00',2.88),('11288','2013-04-11','11:25:00',5.41),('11288','2013-04-11','11:30:00',6.36),('11288','2013-04-11','11:35:00',5.77),('11288','2013-04-11','11:40:00',2.05),('11288','2013-04-11','11:45:00',4.19),('11288','2013-04-11','11:50:00',7.27),('11288','2013-04-11','11:55:00',7.62),('11288','2013-04-11','12:00:00',7.45),('11288','2013-04-11','12:05:00',7.34),('11288','2013-04-11','12:10:00',7.27),('11288','2013-04-11','12:15:00',5.71),('11288','2013-04-11','12:20:00',7.04),('11288','2013-04-11','12:25:00',6.98),('11288','2013-04-11','12:30:00',5.76),('11288','2013-04-11','12:35:00',5.85),('11288','2013-04-11','12:40:00',3.69),('11288','2013-04-11','12:45:00',4.12),('11288','2013-04-11','12:50:00',7.27),('11288','2013-04-11','12:55:00',7.17),('11288','2013-04-11','13:00:00',7.44),('11288','2013-04-11','13:05:00',7.29),('11288','2013-04-11','13:10:00',6.64),('11288','2013-04-11','13:15:00',4.23),('11288','2013-04-11','13:20:00',6.56),('11288','2013-04-11','13:25:00',6.93),('11288','2013-04-11','13:30:00',6.91),('11288','2013-04-11','13:35:00',6.86),('11288','2013-04-11','13:40:00',6.73),('11288','2013-04-11','13:45:00',6.62),('11288','2013-04-11','13:50:00',6.66),('11288','2013-04-11','13:55:00',6.67),('11288','2013-04-11','14:00:00',6.49),('11288','2013-04-11','14:05:00',6.69),('11288','2013-04-11','14:10:00',6.69),('11288','2013-04-11','14:15:00',6.63),('11288','2013-04-11','14:20:00',6.56),('11288','2013-04-11','14:25:00',6.43),('11288','2013-04-11','14:30:00',6.38),('11288','2013-04-11','14:35:00',6.41),('11288','2013-04-11','14:40:00',6.38),('11288','2013-04-11','14:45:00',6.23),('11288','2013-04-11','14:50:00',6.17),('11288','2013-04-11','14:55:00',6.06),('11288','2013-04-11','15:00:00',5.96),('11288','2013-04-11','15:05:00',5.86),('11288','2013-04-11','15:10:00',5.85),('11288','2013-04-11','15:15:00',5.77),('11288','2013-04-11','15:20:00',5.69),('11288','2013-04-11','15:25:00',5.6),('11288','2013-04-11','15:30:00',5.52),('11288','2013-04-11','15:35:00',5.44),('11288','2013-04-11','15:40:00',5.32),('11288','2013-04-11','15:45:00',5.24),('11288','2013-04-11','15:50:00',5.14),('11288','2013-04-11','15:55:00',5.02),('11288','2013-04-11','16:00:00',4.94),('11288','2013-04-11','16:05:00',4.83),('11288','2013-04-11','16:10:00',4.73),('11288','2013-04-11','16:15:00',4.57),('11288','2013-04-11','16:20:00',4.47),('11288','2013-04-11','16:25:00',4.36),('11288','2013-04-11','16:30:00',4.23),('11288','2013-04-11','16:35:00',4.09),('11288','2013-04-11','16:40:00',3.97),('11288','2013-04-11','16:45:00',3.86),('11288','2013-04-11','16:50:00',3.7),('11288','2013-04-11','16:55:00',3.58),('11288','2013-04-11','17:00:00',3.41),('11288','2013-04-11','17:05:00',3.25),('11288','2013-04-11','17:10:00',3.12),('11288','2013-04-11','17:15:00',2.98),('11288','2013-04-11','17:20:00',2.81),('11288','2013-04-11','17:25:00',2.7),('11288','2013-04-11','17:30:00',2.57),('11288','2013-04-11','17:35:00',2.43),('11288','2013-04-11','17:40:00',2.29),('11288','2013-04-11','17:45:00',2.14),('11288','2013-04-11','17:50:00',2.01),('11288','2013-04-11','17:55:00',1.82),('11288','2013-04-11','18:00:00',1.64),('11288','2013-04-11','18:05:00',1.49),('11288','2013-04-11','18:10:00',1.28),('11288','2013-04-11','18:15:00',1.31),('11288','2013-04-11','18:20:00',1.25),('11288','2013-04-11','18:25:00',1.14),('11288','2013-04-10','08:50:00',1.61),('11288','2013-04-10','08:55:00',2.56),('11288','2013-04-10','09:00:00',2.87),('11288','2013-04-10','09:05:00',3.2),('11288','2013-04-10','09:10:00',3.39),('11288','2013-04-10','09:15:00',3.4),('11288','2013-04-10','09:20:00',3.25),('11288','2013-04-10','09:25:00',3.55),('11288','2013-04-10','09:30:00',3.65),('11288','2013-04-10','09:35:00',3.87),('11288','2013-04-10','09:40:00',3.97),('11288','2013-04-10','09:45:00',3.98),('11288','2013-04-10','09:50:00',4.11),('11288','2013-04-10','09:55:00',4.05),('11288','2013-04-10','10:00:00',4.7),('11288','2013-04-10','10:05:00',4.89),('11288','2013-04-10','10:10:00',4.91),('11288','2013-04-10','10:15:00',5.4),('11288','2013-04-10','10:20:00',5.46),('11288','2013-04-10','10:25:00',5.55),('11288','2013-04-10','10:30:00',5.58),('11288','2013-04-10','10:35:00',5.68),('11288','2013-04-10','10:40:00',5.69),('11288','2013-04-10','10:45:00',5.77),('11288','2013-04-10','10:50:00',5.49),('11288','2013-04-10','10:55:00',5.68),('11288','2013-04-10','11:00:00',5.67),('11288','2013-04-10','11:05:00',5.62),('11288','2013-04-10','11:10:00',5.79),('11288','2013-04-10','11:15:00',5.79),('11288','2013-04-10','11:20:00',6.01),('11288','2013-04-10','11:25:00',6.31),('11288','2013-04-10','11:30:00',6.29),('11288','2013-04-10','11:35:00',6.37),('11288','2013-04-10','11:40:00',6.44),('11288','2013-04-10','11:45:00',6.48),('11288','2013-04-10','11:50:00',6.58),('11288','2013-04-10','11:55:00',6.58),('11288','2013-04-10','12:00:00',6.8),('11288','2013-04-10','12:05:00',6.96),('11288','2013-04-10','12:10:00',7.04),('11288','2013-04-10','12:15:00',7.01),('11288','2013-04-10','12:20:00',7.02),('11288','2013-04-10','12:25:00',7.07),('11288','2013-04-10','12:30:00',7.2),('11288','2013-04-10','12:35:00',6.35),('11288','2013-04-10','12:40:00',7.13),('11288','2013-04-10','12:45:00',7.17),('11288','2013-04-10','12:50:00',7.27),('11288','2013-04-10','12:55:00',6.49),('11288','2013-04-10','13:00:00',4.01),('11288','2013-04-10','13:05:00',4.79),('11288','2013-04-10','13:10:00',3.8),('11288','2013-04-10','13:15:00',6.6),('11288','2013-04-10','13:20:00',7.56),('11288','2013-04-10','13:25:00',7.31),('11288','2013-04-10','13:30:00',6.7),('11288','2013-04-10','13:35:00',6.24),('11288','2013-04-10','13:40:00',5.29),('11288','2013-04-10','13:45:00',4.67),('11288','2013-04-10','13:50:00',7.75),('11288','2013-04-10','13:55:00',4.12),('11288','2013-04-10','14:00:00',7.22),('11288','2013-04-10','14:05:00',6.98),('11288','2013-04-10','14:10:00',6.89),('11288','2013-04-10','14:15:00',6.75),('11288','2013-04-10','14:20:00',6.73),('11288','2013-04-10','14:25:00',6.81),('11288','2013-04-10','14:30:00',6.74),('11288','2013-04-10','14:35:00',5.5),('11288','2013-04-10','14:40:00',6.64),('11288','2013-04-10','14:45:00',6.73),('11288','2013-04-10','14:50:00',6.64),('11288','2013-04-10','14:55:00',6.15),('11288','2013-04-10','15:00:00',6.55),('11288','2013-04-10','15:05:00',4.35),('11288','2013-04-10','15:10:00',5.95),('11288','2013-04-10','15:15:00',5.85),('11288','2013-04-10','15:20:00',6.24),('11288','2013-04-10','15:25:00',5.8),('11288','2013-04-10','15:30:00',5.65),('11288','2013-04-10','15:35:00',5.62),('11288','2013-04-10','15:40:00',5.47),('11288','2013-04-10','15:45:00',5.37),('11288','2013-04-10','15:50:00',5.33),('11288','2013-04-10','15:55:00',5.23),('11288','2013-04-10','16:00:00',4),('11288','2013-04-10','16:05:00',5.11),('11288','2013-04-10','16:10:00',5),('11288','2013-04-10','16:15:00',5),('11288','2013-04-10','16:20:00',4.33),('11288','2013-04-10','16:25:00',4.55),('11288','2013-04-10','16:30:00',3.75),('11288','2013-04-10','16:35:00',2.85),('11288','2013-04-10','16:40:00',3.17),('11288','2013-04-10','16:45:00',4.14),('11288','2013-04-10','16:50:00',3.43),('11288','2013-04-10','16:55:00',3.62),('11288','2013-04-10','17:00:00',3.07),('11288','2013-04-10','17:05:00',2.66),('11288','2013-04-10','17:10:00',2.65),('11288','2013-04-10','17:15:00',2.88),('11288','2013-04-10','17:20:00',2.9),('11288','2013-04-10','17:25:00',2.61),('11288','2013-04-10','17:30:00',2.6),('11288','2013-04-10','17:35:00',2.05),('11288','2013-04-10','17:40:00',2.12),('11288','2013-04-10','17:45:00',2.25),('11288','2013-04-10','17:50:00',2.2),('11288','2013-04-10','17:55:00',1.79),('11288','2013-04-10','18:00:00',1.57),('11288','2013-04-10','18:05:00',1.17),('11288','2013-04-10','18:10:00',1.27),('11288','2013-04-09','07:50:00',1.04),('11288','2013-04-09','07:55:00',1.27),('11288','2013-04-09','08:00:00',1.17),('11288','2013-04-09','08:10:00',1.07),('11288','2013-04-09','08:15:00',1.04),('11288','2013-04-09','08:20:00',1.96),('11288','2013-04-09','08:25:00',1.39),('11288','2013-04-09','08:30:00',1.63),('11288','2013-04-09','08:35:00',1.4),('11288','2013-04-09','08:45:00',1.13),('11288','2013-04-09','08:50:00',1.02),('11288','2013-04-09','09:00:00',1.31),('11288','2013-04-09','09:05:00',1.67),('11288','2013-04-09','09:10:00',1.72),('11288','2013-04-09','09:15:00',1.85),('11288','2013-04-09','09:20:00',1.7),('11288','2013-04-09','09:25:00',1.94),('11288','2013-04-09','09:30:00',1.84),('11288','2013-04-09','09:35:00',1.46),('11288','2013-04-09','09:40:00',1.83),('11288','2013-04-09','09:45:00',3.07),('11288','2013-04-09','09:50:00',3.27),('11288','2013-04-09','09:55:00',4.27),('11288','2013-04-09','10:00:00',3.72),('11288','2013-04-09','10:05:00',2.24),('11288','2013-04-09','10:10:00',2.31),('11288','2013-04-09','10:15:00',3.85),('11288','2013-04-09','10:20:00',2.83),('11288','2013-04-09','10:25:00',1.21),('11288','2013-04-09','10:30:00',2.44),('11288','2013-04-09','10:35:00',3.57),('11288','2013-04-09','10:40:00',4.45),('11288','2013-04-09','10:45:00',6.52),('11288','2013-04-09','10:50:00',5.23),('11288','2013-04-09','10:55:00',6.65),('11288','2013-04-09','11:00:00',5.07),('11288','2013-04-09','11:05:00',5.71),('11288','2013-04-09','11:10:00',5.19),('11288','2013-04-09','11:15:00',1.42),('11288','2013-04-09','11:20:00',2.55),('11288','2013-04-09','11:25:00',5.25),('11288','2013-04-09','11:30:00',6.52),('11288','2013-04-09','11:35:00',3.11),('11288','2013-04-09','11:40:00',4.2),('11288','2013-04-09','11:45:00',4.48),('11288','2013-04-09','11:50:00',6.28),('11288','2013-04-09','11:55:00',5.44),('11288','2013-04-09','12:00:00',7.29),('11288','2013-04-09','12:05:00',7.35),('11288','2013-04-09','12:10:00',7.37),('11288','2013-04-09','12:15:00',7.22),('11288','2013-04-09','12:20:00',6.78),('11288','2013-04-09','12:25:00',6.97),('11288','2013-04-09','12:30:00',7.15),('11288','2013-04-09','12:35:00',7.19),('11288','2013-04-09','12:40:00',7.29),('11288','2013-04-09','12:45:00',6.43),('11288','2013-04-09','12:50:00',7.22),('11288','2013-04-09','12:55:00',6.38),('11288','2013-04-09','13:00:00',7.3),('11288','2013-04-09','13:05:00',7.41),('11288','2013-04-09','13:10:00',7.77),('11288','2013-04-09','13:15:00',5.51),('11288','2013-04-09','13:20:00',4.89),('11288','2013-04-09','13:25:00',6.39),('11288','2013-04-09','13:30:00',1.92),('11288','2013-04-09','13:35:00',3.98),('11288','2013-04-09','13:40:00',3.71),('11288','2013-04-09','13:45:00',5.21),('11288','2013-04-09','13:50:00',7.16),('11288','2013-04-09','13:55:00',6.93),('11288','2013-04-09','14:00:00',6.5),('11288','2013-04-09','14:05:00',5.06),('11288','2013-04-09','14:10:00',4.81),('11288','2013-04-09','14:15:00',5.61),('11288','2013-04-09','14:20:00',3.93),('11288','2013-04-09','14:25:00',5.04),('11288','2013-04-09','14:30:00',4.81),('11288','2013-04-09','14:35:00',5.65),('11288','2013-04-09','14:40:00',5.92),('11288','2013-04-09','14:45:00',5.81),('11288','2013-04-09','14:50:00',5.21),('11288','2013-04-09','14:55:00',3.68),('11288','2013-04-09','15:00:00',5.73),('11288','2013-04-09','15:05:00',5.6),('11288','2013-04-09','15:10:00',5.35),('11288','2013-04-09','15:15:00',5.4),('11288','2013-04-09','15:20:00',6.24),('11288','2013-04-09','15:25:00',5.96),('11288','2013-04-09','15:30:00',3.53),('11288','2013-04-09','15:35:00',6.13),('11288','2013-04-09','15:40:00',5.78),('11288','2013-04-09','15:45:00',5.77),('11288','2013-04-09','15:50:00',5.68),('11288','2013-04-09','15:55:00',4.61),('11288','2013-04-09','16:00:00',4.13),('11288','2013-04-09','16:05:00',4.76),('11288','2013-04-09','16:10:00',2.31),('11288','2013-04-09','16:15:00',2.33),('11288','2013-04-09','16:20:00',1.15),('11288','2013-04-09','16:25:00',1.98),('11288','2013-04-09','16:30:00',1.75),('11288','2013-04-09','16:35:00',2.22),('11288','2013-04-09','16:40:00',2),('11288','2013-04-09','16:45:00',2.24),('11288','2013-04-09','16:50:00',3.92),('11288','2013-04-09','16:55:00',2.19),('11288','2013-04-09','17:00:00',1.36),('11288','2013-04-09','17:05:00',1.12),('11288','2013-04-09','17:10:00',1.1),('11288','2013-04-09','17:15:00',1.82),('11288','2013-04-09','17:20:00',1.82),('11288','2013-04-09','17:25:00',1.39),('11288','2013-04-09','17:30:00',1.52),('11288','2013-04-09','17:35:00',1.37),('11288','2013-04-09','17:40:00',1.57),('11288','2013-04-09','17:45:00',1.23),('11288','2013-04-09','17:50:00',1.03),('11288','2013-04-09','18:00:00',1.06),('11288','2013-04-09','18:05:00',1.02),('11288','2013-04-09','18:15:00',1.34),('11288','2013-04-09','18:20:00',1.33),('11288','2013-04-08','08:05:00',1.12),('11288','2013-04-08','08:10:00',1.29),('11288','2013-04-08','08:15:00',1.42),('11288','2013-04-08','08:20:00',1.32),('11288','2013-04-08','08:25:00',1.3),('11288','2013-04-08','08:30:00',1.34),('11288','2013-04-08','08:35:00',1.35),('11288','2013-04-08','08:40:00',1.79),('11288','2013-04-08','08:45:00',1.74),('11288','2013-04-08','08:50:00',1.9),('11288','2013-04-08','08:55:00',2.2),('11288','2013-04-08','09:00:00',2.18),('11288','2013-04-08','09:05:00',2.25),('11288','2013-04-08','09:10:00',2.1),('11288','2013-04-08','09:15:00',2.93),('11288','2013-04-08','09:20:00',3.36),('11288','2013-04-08','09:25:00',3.35),('11288','2013-04-08','09:30:00',3.78),('11288','2013-04-08','09:35:00',4),('11288','2013-04-08','09:40:00',4.03),('11288','2013-04-08','09:45:00',4.15),('11288','2013-04-08','09:50:00',2.42),('11288','2013-04-08','09:55:00',3.06),('11288','2013-04-08','10:00:00',4.49),('11288','2013-04-08','10:05:00',4.12),('11288','2013-04-08','10:10:00',4.58),('11288','2013-04-08','10:15:00',4.87),('11288','2013-04-08','10:20:00',4.91),('11288','2013-04-08','10:25:00',4.93),('11288','2013-04-08','10:30:00',5.16),('11288','2013-04-08','10:35:00',4.97),('11288','2013-04-08','10:40:00',5.59),('11288','2013-04-08','10:45:00',5.83),('11288','2013-04-08','10:50:00',5.8),('11288','2013-04-08','10:55:00',5.58),('11288','2013-04-08','11:00:00',5.72),('11288','2013-04-08','11:05:00',5.06),('11288','2013-04-08','11:10:00',5.03),('11288','2013-04-08','11:15:00',4.25),('11288','2013-04-08','11:20:00',3.74),('11288','2013-04-08','11:25:00',3.41),('11288','2013-04-08','11:30:00',3.97),('11288','2013-04-08','11:35:00',5.01),('11288','2013-04-08','11:40:00',5.11),('11288','2013-04-08','11:45:00',4.7),('11288','2013-04-08','11:50:00',4.26),('11288','2013-04-08','11:55:00',3.99),('11288','2013-04-08','12:00:00',3.72),('11288','2013-04-08','12:05:00',3.63),('11288','2013-04-08','12:10:00',4.02),('11288','2013-04-08','12:15:00',4.66),('11288','2013-04-08','12:20:00',4.69),('11288','2013-04-08','12:25:00',4.56),('11288','2013-04-08','12:30:00',5.03),('11288','2013-04-08','12:35:00',4.11),('11288','2013-04-08','12:40:00',4.97),('11288','2013-04-08','12:45:00',6.1),('11288','2013-04-08','12:50:00',3.69),('11288','2013-04-08','12:55:00',3.05),('11288','2013-04-08','13:00:00',3.7),('11288','2013-04-08','13:05:00',4.27),('11288','2013-04-08','13:10:00',4.75),('11288','2013-04-08','13:15:00',5.59),('11288','2013-04-08','13:20:00',5.89),('11288','2013-04-08','13:25:00',5.4),('11288','2013-04-08','13:30:00',4.54),('11288','2013-04-08','13:35:00',3.04),('11288','2013-04-08','13:40:00',4.78),('11288','2013-04-08','13:45:00',4.7),('11288','2013-04-08','13:50:00',5.15),('11288','2013-04-08','13:55:00',6.41),('11288','2013-04-08','14:00:00',6.01),('11288','2013-04-08','14:05:00',5.44),('11288','2013-04-08','14:10:00',5.61),('11288','2013-04-08','14:15:00',6.21),('11288','2013-04-08','14:20:00',5.59),('11288','2013-04-08','14:25:00',6.49),('11288','2013-04-08','14:30:00',6.24),('11288','2013-04-08','14:35:00',5.71),('11288','2013-04-08','14:40:00',6.02),('11288','2013-04-08','14:45:00',6.18),('11288','2013-04-08','14:50:00',6),('11288','2013-04-08','14:55:00',5.99),('11288','2013-04-08','15:00:00',4.86),('11288','2013-04-08','15:05:00',4.53),('11288','2013-04-08','15:10:00',5.03),('11288','2013-04-08','15:15:00',4.64),('11288','2013-04-08','15:20:00',5.09),('11288','2013-04-08','15:25:00',5.8),('11288','2013-04-08','15:30:00',5.81),('11288','2013-04-08','15:35:00',5.56),('11288','2013-04-08','15:40:00',5.34),('11288','2013-04-08','15:45:00',5.3),('11288','2013-04-08','15:50:00',5.16),('11288','2013-04-08','15:55:00',5.06),('11288','2013-04-08','16:00:00',4.9),('11288','2013-04-08','16:05:00',4.61),('11288','2013-04-08','16:10:00',4.41),('11288','2013-04-08','16:15:00',4.62),('11288','2013-04-08','16:20:00',4.57),('11288','2013-04-08','16:25:00',4.36),('11288','2013-04-08','16:30:00',4.23),('11288','2013-04-08','16:35:00',4.08),('11288','2013-04-08','16:40:00',3.97),('11288','2013-04-08','16:45:00',3.88),('11288','2013-04-08','16:50:00',3.72),('11288','2013-04-08','16:55:00',3.57),('11288','2013-04-08','17:00:00',3.47),('11288','2013-04-08','17:05:00',3.3),('11288','2013-04-08','17:10:00',3.06),('11288','2013-04-08','17:15:00',2.89),('11288','2013-04-08','17:20:00',2.75),('11288','2013-04-08','17:25:00',2.8),('11288','2013-04-08','17:30:00',2.56),('11288','2013-04-08','17:35:00',2.37),('11288','2013-04-08','17:40:00',2.12),('11288','2013-04-08','17:45:00',1.99),('11288','2013-04-08','17:50:00',1.6),('11288','2013-04-08','17:55:00',1.44),('11288','2013-04-08','18:00:00',1.53),('11288','2013-04-08','18:15:00',1.21),('11288','2013-04-08','18:20:00',1.75),('11288','2013-04-08','18:25:00',1.52),('11288','2013-04-07','08:20:00',1.09),('11288','2013-04-07','08:25:00',1.25),('11288','2013-04-07','08:30:00',1.46),('11288','2013-04-07','08:35:00',1.59),('11288','2013-04-07','08:40:00',1.65),('11288','2013-04-07','08:45:00',1.68),('11288','2013-04-07','08:50:00',1.71),('11288','2013-04-07','08:55:00',1.85),('11288','2013-04-07','09:00:00',1.95),('11288','2013-04-07','09:05:00',2.08),('11288','2013-04-07','09:10:00',2.22),('11288','2013-04-07','09:15:00',2.28),('11288','2013-04-07','09:20:00',2.32),('11288','2013-04-07','09:25:00',2.32),('11288','2013-04-07','09:30:00',2.45),('11288','2013-04-07','09:35:00',2.36),('11288','2013-04-07','09:40:00',2.34),('11288','2013-04-07','09:45:00',2.44),('11288','2013-04-07','09:50:00',3.08),('11288','2013-04-07','09:55:00',3.3),('11288','2013-04-07','10:00:00',3.8),('11288','2013-04-07','10:05:00',4.28),('11288','2013-04-07','10:10:00',4.37),('11288','2013-04-07','10:15:00',4.47),('11288','2013-04-07','10:20:00',4.62),('11288','2013-04-07','10:25:00',4.72),('11288','2013-04-07','10:30:00',4.13),('11288','2013-04-07','10:35:00',4.19),('11288','2013-04-07','10:40:00',4.55),('11288','2013-04-07','10:45:00',4.44),('11288','2013-04-07','10:50:00',4.31),('11288','2013-04-07','10:55:00',3.81),('11288','2013-04-07','11:00:00',3.6),('11288','2013-04-07','11:05:00',3.2),('11288','2013-04-07','11:10:00',3.29),('11288','2013-04-07','11:15:00',4.4),('11288','2013-04-07','11:20:00',5.74),('11288','2013-04-07','11:25:00',6.09),('11288','2013-04-07','11:30:00',6.2),('11288','2013-04-07','11:35:00',5.73),('11288','2013-04-07','11:40:00',5.35),('11288','2013-04-07','11:45:00',4.29),('11288','2013-04-07','11:50:00',3.81),('11288','2013-04-07','11:55:00',3.96),('11288','2013-04-07','12:00:00',4.12),('11288','2013-04-07','12:05:00',4.14),('11288','2013-04-07','12:10:00',4.42),('11288','2013-04-07','12:15:00',4.36),('11288','2013-04-07','12:20:00',4.76),('11288','2013-04-07','12:25:00',5.18),('11288','2013-04-07','12:30:00',4.76),('11288','2013-04-07','12:35:00',4.81),('11288','2013-04-07','12:40:00',4.81),('11288','2013-04-07','12:45:00',4.12),('11288','2013-04-07','12:50:00',4.42),('11288','2013-04-07','12:55:00',4.42),('11288','2013-04-07','13:00:00',5.2),('11288','2013-04-07','13:05:00',5.71),('11288','2013-04-07','13:10:00',5.53),('11288','2013-04-07','13:15:00',4.99),('11288','2013-04-07','13:20:00',4.97),('11288','2013-04-07','13:25:00',5.38),('11288','2013-04-07','13:30:00',4.73),('11288','2013-04-07','13:35:00',5.19),('11288','2013-04-07','13:40:00',5.49),('11288','2013-04-07','13:45:00',4.92),('11288','2013-04-07','13:50:00',4.44),('11288','2013-04-07','13:55:00',4.82),('11288','2013-04-07','14:00:00',5.91),('11288','2013-04-07','14:05:00',5.67),('11288','2013-04-07','14:10:00',3.2),('11288','2013-04-07','14:15:00',4.09),('11288','2013-04-07','14:20:00',4.24),('11288','2013-04-07','14:25:00',3.21),('11288','2013-04-07','14:30:00',2.55),('11288','2013-04-07','14:35:00',3.34),('11288','2013-04-07','14:40:00',3.6),('11288','2013-04-07','14:45:00',3.43),('11288','2013-04-07','14:50:00',3.67),('11288','2013-04-07','14:55:00',4.39),('11288','2013-04-07','15:00:00',3.28),('11288','2013-04-07','15:05:00',3.63),('11288','2013-04-07','15:10:00',4.31),('11288','2013-04-07','15:15:00',3.91),('11288','2013-04-07','15:20:00',3.35),('11288','2013-04-07','15:25:00',3.46),('11288','2013-04-07','15:30:00',4.83),('11288','2013-04-07','15:35:00',4.56),('11288','2013-04-07','15:40:00',4.33),('11288','2013-04-07','15:45:00',2.89),('11288','2013-04-07','15:50:00',4.08),('11288','2013-04-07','15:55:00',4.09),('11288','2013-04-07','16:00:00',3.69),('11288','2013-04-07','16:05:00',3.18),('11288','2013-04-07','16:10:00',2.88),('11288','2013-04-07','16:15:00',2.36),('11288','2013-04-07','16:20:00',2.37),('11288','2013-04-07','16:25:00',2.13),('11288','2013-04-07','16:30:00',2.39),('11288','2013-04-07','16:35:00',2.85),('11288','2013-04-07','16:40:00',2.94),('11288','2013-04-07','16:45:00',3.19),('11288','2013-04-07','16:50:00',3.75),('11288','2013-04-07','16:55:00',3.51),('11288','2013-04-07','17:00:00',3.29),('11288','2013-04-07','17:05:00',3.21),('11288','2013-04-07','17:10:00',3.05),('11288','2013-04-07','17:15:00',2.24),('11288','2013-04-07','17:20:00',2.19),('11288','2013-04-07','17:25:00',2.83),('11288','2013-04-07','17:30:00',2.58),('11288','2013-04-07','17:35:00',2.57),('11288','2013-04-07','17:40:00',2.51),('11288','2013-04-07','17:45:00',2.43),('11288','2013-04-07','17:50:00',2.2),('11288','2013-04-07','17:55:00',1.88),('11288','2013-04-07','18:00:00',1.36),('11288','2013-04-06','08:00:00',1.02),('11288','2013-04-06','08:05:00',1.08),('11288','2013-04-06','08:10:00',1.17),('11288','2013-04-06','08:15:00',1.35),('11288','2013-04-06','08:20:00',1.48),('11288','2013-04-06','08:25:00',1.69),('11288','2013-04-06','08:30:00',1.85),('11288','2013-04-06','08:35:00',1.89),('11288','2013-04-06','08:40:00',2.05),('11288','2013-04-06','08:45:00',2.16),('11288','2013-04-06','08:50:00',2.39),('11288','2013-04-06','08:55:00',2.54),('11288','2013-04-06','09:00:00',2.66),('11288','2013-04-06','09:05:00',2.74),('11288','2013-04-06','09:10:00',2.88),('11288','2013-04-06','09:15:00',2.98),('11288','2013-04-06','09:20:00',3.12),('11288','2013-04-06','09:25:00',3.28),('11288','2013-04-06','09:30:00',3.48),('11288','2013-04-06','09:35:00',3.53),('11288','2013-04-06','09:40:00',3.77),('11288','2013-04-06','09:45:00',3.74),('11288','2013-04-06','09:50:00',3.64),('11288','2013-04-06','09:55:00',4.11),('11288','2013-04-06','10:00:00',4.38),('11288','2013-04-06','10:05:00',4.56),('11288','2013-04-06','10:10:00',4.68),('11288','2013-04-06','10:15:00',4.74),('11288','2013-04-06','10:20:00',4.88),('11288','2013-04-06','10:25:00',4.97),('11288','2013-04-06','10:30:00',5.11),('11288','2013-04-06','10:35:00',5.19),('11288','2013-04-06','10:40:00',5.23),('11288','2013-04-06','10:45:00',5.3),('11288','2013-04-06','10:50:00',5.38),('11288','2013-04-06','10:55:00',5.55),('11288','2013-04-06','11:00:00',5.64),('11288','2013-04-06','11:05:00',5.72),('11288','2013-04-06','11:10:00',5.81),('11288','2013-04-06','11:15:00',5.85),('11288','2013-04-06','11:20:00',5.87),('11288','2013-04-06','11:25:00',5.93),('11288','2013-04-06','11:30:00',5.89),('11288','2013-04-06','11:35:00',5.94),('11288','2013-04-06','11:40:00',6.01),('11288','2013-04-06','11:45:00',6.07),('11288','2013-04-06','11:50:00',6.14),('11288','2013-04-06','11:55:00',6.17),('11288','2013-04-06','12:00:00',6.24),('11288','2013-04-06','12:05:00',6.37),('11288','2013-04-06','12:10:00',6.42),('11288','2013-04-06','12:15:00',6.49),('11288','2013-04-06','12:20:00',6.52),('11288','2013-04-06','12:25:00',6.53),('11288','2013-04-06','12:30:00',6.59),('11288','2013-04-06','12:35:00',6.18),('11288','2013-04-06','12:40:00',6.6),('11288','2013-04-06','12:45:00',6.78),('11288','2013-04-06','12:50:00',6.79),('11288','2013-04-06','12:55:00',6.85),('11288','2013-04-06','13:00:00',4.48),('11288','2013-04-06','13:05:00',6.96),('11288','2013-04-06','13:10:00',7.15),('11288','2013-04-06','13:15:00',7.48),('11288','2013-04-06','13:20:00',4.69),('11288','2013-04-06','13:25:00',2.03),('11288','2013-04-06','13:30:00',5.38),('11288','2013-04-06','13:35:00',4.59),('11288','2013-04-06','13:40:00',2.23),('11288','2013-04-06','13:45:00',4.1),('11288','2013-04-06','13:50:00',7.02),('11288','2013-04-06','13:55:00',7.76),('11288','2013-04-06','14:00:00',6.49),('11288','2013-04-06','14:05:00',7.5),('11288','2013-04-06','14:10:00',7.17),('11288','2013-04-06','14:15:00',3.35),('11288','2013-04-06','14:20:00',3.29),('11288','2013-04-06','14:25:00',2.21),('11288','2013-04-06','14:30:00',5.36),('11288','2013-04-06','14:35:00',6.61),('11288','2013-04-06','14:40:00',6.54),('11288','2013-04-06','14:45:00',6.02),('11288','2013-04-06','14:50:00',6.11),('11288','2013-04-06','14:55:00',6.13),('11288','2013-04-06','15:00:00',5.94),('11288','2013-04-06','15:05:00',5.75),('11288','2013-04-06','15:10:00',5.63),('11288','2013-04-06','15:15:00',5.58),('11288','2013-04-06','15:20:00',5.55),('11288','2013-04-06','15:25:00',5.46),('11288','2013-04-06','15:30:00',5.16),('11288','2013-04-06','15:35:00',5.14),('11288','2013-04-06','15:40:00',5.01),('11288','2013-04-06','15:45:00',4.2),('11288','2013-04-06','15:50:00',4.25),('11288','2013-04-06','15:55:00',4.71),('11288','2013-04-06','16:00:00',4.43),('11288','2013-04-06','16:05:00',4.64),('11288','2013-04-06','16:10:00',4.64),('11288','2013-04-06','16:15:00',4.11),('11288','2013-04-06','16:20:00',3.36),('11288','2013-04-06','16:25:00',3.09),('11288','2013-04-06','16:30:00',3.7),('11288','2013-04-06','16:35:00',3.29),('11288','2013-04-06','16:40:00',2.9),('11288','2013-04-06','16:45:00',3.67),('11288','2013-04-06','16:50:00',3.35),('11288','2013-04-06','16:55:00',3.09),('11288','2013-04-06','17:00:00',3.01),('11288','2013-04-06','17:05:00',2.63),('11288','2013-04-06','17:10:00',2.32),('11288','2013-04-06','17:15:00',1.75),('11288','2013-04-06','17:20:00',1.53),('11288','2013-04-06','17:25:00',1.57),('11288','2013-04-06','17:30:00',1.54),('11288','2013-04-06','17:35:00',1.39),('11288','2013-04-06','17:40:00',1.35),('11288','2013-04-06','17:45:00',1.29),('11288','2013-04-06','17:50:00',1.27),('11288','2013-04-06','17:55:00',1.16),('11288','2013-04-06','18:00:00',1.04),('11288','2013-04-05','08:05:00',1.1),('11288','2013-04-05','08:10:00',1.24),('11288','2013-04-05','08:15:00',1.66),('11288','2013-04-05','08:20:00',1.82),('11288','2013-04-05','08:25:00',1.33),('11288','2013-04-05','08:30:00',1.02),('11288','2013-04-05','08:40:00',1.04),('11288','2013-04-05','08:45:00',1.08),('11288','2013-04-05','08:50:00',1.32),('11288','2013-04-05','08:55:00',1.58),('11288','2013-04-05','09:00:00',1.57),('11288','2013-04-05','09:05:00',3.18),('11288','2013-04-05','09:10:00',2.04),('11288','2013-04-05','09:15:00',3.04),('11288','2013-04-05','09:20:00',3.27),('11288','2013-04-05','09:25:00',1.77),('11288','2013-04-05','09:30:00',1.65),('11288','2013-04-05','09:35:00',2.2),('11288','2013-04-05','09:40:00',3.52),('11288','2013-04-05','09:45:00',2.75),('11288','2013-04-05','09:50:00',2.45),('11288','2013-04-05','09:55:00',1.83),('11288','2013-04-05','10:00:00',2.24),('11288','2013-04-05','10:05:00',2.03),('11288','2013-04-05','10:10:00',4.16),('11288','2013-04-05','10:15:00',4.35),('11288','2013-04-05','10:20:00',1.65),('11288','2013-04-05','10:25:00',5.1),('11288','2013-04-05','10:30:00',2.32),('11288','2013-04-05','10:35:00',2.8),('11288','2013-04-05','10:40:00',6.26),('11288','2013-04-05','10:45:00',2.41),('11288','2013-04-05','10:50:00',3.25),('11288','2013-04-05','10:55:00',4.17),('11288','2013-04-05','11:00:00',5.01),('11288','2013-04-05','11:05:00',5.25),('11288','2013-04-05','11:10:00',6.45),('11288','2013-04-05','11:15:00',5.7),('11288','2013-04-05','11:20:00',6.48),('11288','2013-04-05','11:25:00',5.13),('11288','2013-04-05','11:30:00',6.76),('11288','2013-04-05','11:35:00',6.48),('11288','2013-04-05','11:40:00',6.29),('11288','2013-04-05','11:45:00',6.11),('11288','2013-04-05','11:50:00',6.63),('11288','2013-04-05','11:55:00',6.88),('11288','2013-04-05','12:00:00',6.92),('11288','2013-04-05','12:05:00',4.88),('11288','2013-04-05','12:10:00',3.5),('11288','2013-04-05','12:15:00',4.89),('11288','2013-04-05','12:20:00',3.19),('11288','2013-04-05','12:25:00',4.42),('11288','2013-04-05','12:30:00',2.49),('11288','2013-04-05','12:35:00',2.8),('11288','2013-04-05','12:40:00',3.27),('11288','2013-04-05','12:45:00',4.92),('11288','2013-04-05','12:50:00',7.41),('11288','2013-04-05','12:55:00',4.98),('11288','2013-04-05','13:00:00',5.5),('11288','2013-04-05','13:05:00',5.78),('11288','2013-04-05','13:10:00',5.97),('11288','2013-04-05','13:15:00',7.79),('11288','2013-04-05','13:20:00',6.78),('11288','2013-04-05','13:25:00',4.5),('11288','2013-04-05','13:30:00',7.23),('11288','2013-04-05','13:35:00',6.21),('11288','2013-04-05','13:40:00',4.81),('11288','2013-04-05','13:45:00',6.31),('11288','2013-04-05','13:50:00',7.39),('11288','2013-04-05','13:55:00',5.14),('11288','2013-04-05','14:00:00',5.51),('11288','2013-04-05','14:05:00',7.51),('11288','2013-04-05','14:10:00',7.02),('11288','2013-04-05','14:15:00',6.15),('11288','2013-04-05','14:20:00',4.81),('11288','2013-04-05','14:25:00',6.56),('11288','2013-04-05','14:30:00',6.33),('11288','2013-04-05','14:35:00',6.09),('11288','2013-04-05','14:40:00',5.76),('11288','2013-04-05','14:45:00',5.03),('11288','2013-04-05','14:50:00',5.04),('11288','2013-04-05','14:55:00',7.55),('11288','2013-04-05','15:00:00',6.35),('11288','2013-04-05','15:05:00',6.47),('11288','2013-04-05','15:10:00',3.28),('11288','2013-04-05','15:15:00',2.85),('11288','2013-04-05','15:20:00',2.96),('11288','2013-04-05','15:25:00',3.17),('11288','2013-04-05','15:30:00',2.73),('11288','2013-04-05','15:35:00',2.12),('11288','2013-04-05','15:40:00',2),('11288','2013-04-05','15:45:00',2.52),('11288','2013-04-05','15:50:00',3.05),('11288','2013-04-05','15:55:00',2.88),('11288','2013-04-05','16:00:00',2.92),('11288','2013-04-05','16:05:00',2.79),('11288','2013-04-05','16:10:00',2.93),('11288','2013-04-05','16:15:00',3.23),('11288','2013-04-05','16:20:00',3.19),('11288','2013-04-05','16:25:00',2.41),('11288','2013-04-05','16:30:00',2.76),('11288','2013-04-05','16:35:00',3.35),('11288','2013-04-05','16:40:00',2.71),('11288','2013-04-05','16:45:00',3.57),('11288','2013-04-05','16:50:00',3.76),('11288','2013-04-05','16:55:00',2.16),('11288','2013-04-05','17:00:00',2.25),('11288','2013-04-05','17:05:00',2.15),('11288','2013-04-05','17:10:00',4.42),('11288','2013-04-05','17:15:00',3.83),('11288','2013-04-05','17:20:00',3.12),('11288','2013-04-05','17:25:00',3.21),('11288','2013-04-05','17:30:00',2.06),('11288','2013-04-05','17:35:00',2.4),('11288','2013-04-05','17:40:00',1.44),('11288','2013-04-05','17:50:00',1.75),('11288','2013-04-05','17:55:00',2.39),('11288','2013-04-05','18:00:00',1.37),('11288','2013-04-05','18:15:00',1.4),('11288','2013-04-05','18:20:00',1.12),('11288','2013-04-04','08:05:00',1.13),('11288','2013-04-04','08:10:00',1.06),('11288','2013-04-04','08:15:00',1.1),('11288','2013-04-04','08:20:00',1.14),('11288','2013-04-04','08:25:00',1.22),('11288','2013-04-04','08:30:00',1.32),('11288','2013-04-04','08:35:00',1.68),('11288','2013-04-04','08:40:00',1.47),('11288','2013-04-04','08:45:00',1.49),('11288','2013-04-04','08:50:00',1.59),('11288','2013-04-04','08:55:00',2.31),('11288','2013-04-04','09:00:00',2.88),('11288','2013-04-04','09:05:00',2.29),('11288','2013-04-04','09:10:00',2.36),('11288','2013-04-04','09:15:00',2.39),('11288','2013-04-04','09:20:00',2.1),('11288','2013-04-04','09:25:00',1.85),('11288','2013-04-04','09:30:00',2.77),('11288','2013-04-04','09:35:00',3.95),('11288','2013-04-04','09:40:00',3.84),('11288','2013-04-04','09:45:00',3.24),('11288','2013-04-04','09:50:00',2.01),('11288','2013-04-04','09:55:00',2.33),('11288','2013-04-04','10:00:00',3.19),('11288','2013-04-04','10:05:00',4.01),('11288','2013-04-04','10:10:00',3.31),('11288','2013-04-04','10:15:00',2.81),('11288','2013-04-04','10:20:00',3.5),('11288','2013-04-04','10:25:00',6.14),('11288','2013-04-04','10:30:00',4.75),('11288','2013-04-04','10:35:00',3.35),('11288','2013-04-04','10:40:00',5.69),('11288','2013-04-04','10:45:00',3.32),('11288','2013-04-04','10:50:00',3.86),('11288','2013-04-04','10:55:00',6.6),('11288','2013-04-04','11:00:00',4.1),('11288','2013-04-04','11:05:00',2.21),('11288','2013-04-04','11:10:00',2.01),('11288','2013-04-04','11:15:00',2.72),('11288','2013-04-04','11:20:00',2.43),('11288','2013-04-04','11:25:00',1.93),('11288','2013-04-04','11:30:00',2.15),('11288','2013-04-04','11:35:00',3.24),('11288','2013-04-04','11:40:00',4.97),('11288','2013-04-04','11:45:00',5.43),('11288','2013-04-04','11:50:00',5.24),('11288','2013-04-04','11:55:00',4.26),('11288','2013-04-04','12:00:00',4.6),('11288','2013-04-04','12:05:00',6.46),('11288','2013-04-04','12:10:00',6.28),('11288','2013-04-04','12:15:00',5.59),('11288','2013-04-04','12:20:00',5.45),('11288','2013-04-04','12:25:00',5.19),('11288','2013-04-04','12:30:00',6.79),('11288','2013-04-04','12:35:00',7.27),('11288','2013-04-04','12:40:00',7.09),('11288','2013-04-04','12:45:00',6.81),('11288','2013-04-04','12:50:00',4.51),('11288','2013-04-04','12:55:00',6.38),('11288','2013-04-04','13:00:00',6.45),('11288','2013-04-04','13:05:00',6.32),('11288','2013-04-04','13:10:00',6.61),('11288','2013-04-04','13:15:00',6.79),('11288','2013-04-04','13:20:00',6.56),('11288','2013-04-04','13:25:00',6.84),('11288','2013-04-04','13:30:00',6.57),('11288','2013-04-04','13:35:00',5.87),('11288','2013-04-04','13:40:00',5.06),('11288','2013-04-04','13:45:00',5.74),('11288','2013-04-04','13:50:00',5.46),('11288','2013-04-04','13:55:00',4.26),('11288','2013-04-04','14:00:00',4.68),('11288','2013-04-04','14:05:00',6.25),('11288','2013-04-04','14:10:00',6.59),('11288','2013-04-04','14:15:00',6.43),('11288','2013-04-04','14:20:00',6.35),('11288','2013-04-04','14:25:00',6.25),('11288','2013-04-04','14:30:00',6.22),('11288','2013-04-04','14:35:00',5.91),('11288','2013-04-04','14:40:00',6.14),('11288','2013-04-04','14:45:00',6.01),('11288','2013-04-04','14:50:00',6),('11288','2013-04-04','14:55:00',5.97),('11288','2013-04-04','15:00:00',5.92),('11288','2013-04-04','15:05:00',5.65),('11288','2013-04-04','15:10:00',5.42),('11288','2013-04-04','15:15:00',5.45),('11288','2013-04-04','15:20:00',5.47),('11288','2013-04-04','15:25:00',5.53),('11288','2013-04-04','15:30:00',5.46),('11288','2013-04-04','15:35:00',5.27),('11288','2013-04-04','15:40:00',5.22),('11288','2013-04-04','15:45:00',5.09),('11288','2013-04-04','15:50:00',4.91),('11288','2013-04-04','15:55:00',4.84),('11288','2013-04-04','16:00:00',4.73),('11288','2013-04-04','16:05:00',4.55),('11288','2013-04-04','16:10:00',4.32),('11288','2013-04-04','16:15:00',3.96),('11288','2013-04-04','16:20:00',3.98),('11288','2013-04-04','16:25:00',3.56),('11288','2013-04-04','16:30:00',3.22),('11288','2013-04-04','16:35:00',2.97),('11288','2013-04-04','16:40:00',3.28),('11288','2013-04-04','16:45:00',2.81),('11288','2013-04-04','16:50:00',2.63),('11288','2013-04-04','16:55:00',3),('11288','2013-04-04','17:00:00',2.8),('11288','2013-04-04','17:05:00',2.75),('11288','2013-04-04','17:10:00',2.49),('11288','2013-04-04','17:15:00',2.27),('11288','2013-04-04','17:20:00',1.64),('11288','2013-04-04','17:25:00',1.79),('11288','2013-04-04','17:30:00',1.32),('11288','2013-04-04','17:35:00',1.3),('11288','2013-04-04','17:40:00',1.45),('11288','2013-04-04','17:45:00',1.37),('11288','2013-04-04','17:50:00',1.68),('11288','2013-04-04','17:55:00',1.83),('11288','2013-04-04','18:00:00',1.51),('11288','2013-04-04','18:05:00',1.32),('11288','2013-04-03','08:05:00',1.03),('11288','2013-04-03','08:10:00',1.1),('11288','2013-04-03','08:15:00',1.32),('11288','2013-04-03','08:20:00',1.38),('11288','2013-04-03','08:25:00',1.28),('11288','2013-04-03','08:30:00',1.91),('11288','2013-04-03','08:40:00',1.37),('11288','2013-04-03','08:45:00',1.91),('11288','2013-04-03','08:50:00',2.44),('11288','2013-04-03','08:55:00',2.07),('11288','2013-04-03','09:00:00',2.5),('11288','2013-04-03','09:05:00',3.04),('11288','2013-04-03','09:10:00',2.84),('11288','2013-04-03','09:15:00',2.53),('11288','2013-04-03','09:20:00',3.55),('11288','2013-04-03','09:25:00',3.78),('11288','2013-04-03','09:30:00',3.69),('11288','2013-04-03','09:35:00',2.1),('11288','2013-04-03','09:40:00',3.89),('11288','2013-04-03','09:45:00',3.78),('11288','2013-04-03','09:50:00',4.33),('11288','2013-04-03','09:55:00',2.87),('11288','2013-04-03','10:00:00',2.96),('11288','2013-04-03','10:05:00',2.14),('11288','2013-04-03','10:10:00',2.89),('11288','2013-04-03','10:15:00',3.32),('11288','2013-04-03','10:20:00',5.51),('11288','2013-04-03','10:25:00',5.21),('11288','2013-04-03','10:30:00',7.01),('11288','2013-04-03','10:35:00',3.7),('11288','2013-04-03','10:40:00',2.78),('11288','2013-04-03','10:45:00',2.1),('11288','2013-04-03','10:50:00',2.32),('11288','2013-04-03','10:55:00',2.46),('11288','2013-04-03','11:00:00',5.46),('11288','2013-04-03','11:05:00',6.02),('11288','2013-04-03','11:10:00',5.24),('11288','2013-04-03','11:15:00',7.93),('11288','2013-04-03','11:20:00',4.33),('11288','2013-04-03','11:25:00',2.86),('11288','2013-04-03','11:30:00',3.76),('11288','2013-04-03','11:35:00',4.88),('11288','2013-04-03','11:40:00',2.75),('11288','2013-04-03','11:45:00',3.58),('11288','2013-04-03','11:50:00',6.68),('11288','2013-04-03','11:55:00',3.56),('11288','2013-04-03','12:00:00',4.94),('11288','2013-04-03','12:05:00',7.19),('11288','2013-04-03','12:10:00',6.84),('11288','2013-04-03','12:15:00',5.38),('11288','2013-04-03','12:20:00',7.77),('11288','2013-04-03','12:25:00',7.94),('11288','2013-04-03','12:30:00',7.76),('11288','2013-04-03','12:35:00',7.81),('11288','2013-04-03','12:40:00',8.07),('11288','2013-04-03','12:45:00',7.63),('11288','2013-04-03','12:50:00',7.89),('11288','2013-04-03','12:55:00',3.4),('11288','2013-04-03','13:05:00',7.26),('11288','2013-04-03','13:10:00',8.28),('11288','2013-04-03','13:15:00',7.94),('11288','2013-04-03','13:20:00',4.13),('11288','2013-04-03','13:25:00',4.89),('11288','2013-04-03','13:30:00',5.68),('11288','2013-04-03','13:35:00',6.24),('11288','2013-04-03','13:40:00',6.78),('11288','2013-04-03','13:45:00',4.36),('11288','2013-04-03','13:50:00',6.67),('11288','2013-04-03','13:55:00',5.62),('11288','2013-04-03','14:00:00',6),('11288','2013-04-03','14:05:00',4.79),('11288','2013-04-03','14:10:00',6.89),('11288','2013-04-03','14:15:00',3.62),('11288','2013-04-03','14:20:00',4.87),('11288','2013-04-03','14:25:00',3.83),('11288','2013-04-03','14:30:00',6.87),('11288','2013-04-03','14:35:00',6.69),('11288','2013-04-03','14:40:00',3.99),('11288','2013-04-03','14:45:00',4.92),('11288','2013-04-03','14:50:00',5.89),('11288','2013-04-03','14:55:00',7.59),('11288','2013-04-03','15:00:00',5.94),('11288','2013-04-03','15:05:00',5.68),('11288','2013-04-03','15:10:00',6.84),('11288','2013-04-03','15:15:00',5.87),('11288','2013-04-03','15:20:00',5.06),('11288','2013-04-03','15:25:00',6.08),('11288','2013-04-03','15:30:00',3.31),('11288','2013-04-03','15:35:00',5),('11288','2013-04-03','15:40:00',4.75),('11288','2013-04-03','15:45:00',5.56),('11288','2013-04-03','15:50:00',6.23),('11288','2013-04-03','15:55:00',5.96),('11288','2013-04-03','16:00:00',5.68),('11288','2013-04-03','16:05:00',5.63),('11288','2013-04-03','16:10:00',4.35),('11288','2013-04-03','16:15:00',5.2),('11288','2013-04-03','16:20:00',5.04),('11288','2013-04-03','16:25:00',4.9),('11288','2013-04-03','16:30:00',4.78),('11288','2013-04-03','16:35:00',4.68),('11288','2013-04-03','16:40:00',4.41),('11288','2013-04-03','16:45:00',4.23),('11288','2013-04-03','16:50:00',4.09),('11288','2013-04-03','16:55:00',3.96),('11288','2013-04-03','17:00:00',3.76),('11288','2013-04-03','17:05:00',3.54),('11288','2013-04-03','17:10:00',3.46),('11288','2013-04-03','17:15:00',3.3),('11288','2013-04-03','17:20:00',3.14),('11288','2013-04-03','17:25:00',2.95),('11288','2013-04-03','17:30:00',2.81),('11288','2013-04-03','17:35:00',2.61),('11288','2013-04-03','17:40:00',2.44),('11288','2013-04-03','17:45:00',2.28),('11288','2013-04-03','17:50:00',2.12),('11288','2013-04-03','17:55:00',1.96),('11288','2013-04-03','18:00:00',1.79),('11288','2013-04-03','18:05:00',1.63),('11288','2013-04-03','18:10:00',1.47),('11288','2013-04-03','18:15:00',1.29),('11288','2013-04-03','18:20:00',1.12),('11288','2013-04-02','08:35:00',1.01),('11288','2013-04-02','08:40:00',2.18),('11288','2013-04-02','08:45:00',2.51),('11288','2013-04-02','08:50:00',1.67),('11288','2013-04-02','08:55:00',1.71),('11288','2013-04-02','09:00:00',2.36),('11288','2013-04-02','09:05:00',2.41),('11288','2013-04-02','09:10:00',2.42),('11288','2013-04-02','09:15:00',2.59),('11288','2013-04-02','09:20:00',2.43),('11288','2013-04-02','09:25:00',1.65),('11288','2013-04-02','09:30:00',2.76),('11288','2013-04-02','09:35:00',3.98),('11288','2013-04-02','09:40:00',4.08),('11288','2013-04-02','09:45:00',3.92),('11288','2013-04-02','09:50:00',3.11),('11288','2013-04-02','09:55:00',3),('11288','2013-04-02','10:00:00',3.56),('11288','2013-04-02','10:05:00',2.82),('11288','2013-04-02','10:10:00',1.88),('11288','2013-04-02','10:15:00',2.42),('11288','2013-04-02','10:20:00',2.67),('11288','2013-04-02','10:25:00',3.47),('11288','2013-04-02','10:30:00',1.47),('11288','2013-04-02','10:35:00',5.46),('11288','2013-04-02','10:40:00',3.33),('11288','2013-04-02','10:45:00',3.92),('11288','2013-04-02','10:50:00',6.53),('11288','2013-04-02','10:55:00',2.19),('11288','2013-04-02','11:00:00',2),('11288','2013-04-02','11:05:00',4.86),('11288','2013-04-02','11:10:00',2.66),('11288','2013-04-02','11:15:00',2),('11288','2013-04-02','11:20:00',1.76),('11288','2013-04-02','11:25:00',2.11),('11288','2013-04-02','11:30:00',2.4),('11288','2013-04-02','11:35:00',1.99),('11288','2013-04-02','11:40:00',1.91),('11288','2013-04-02','11:45:00',4.24),('11288','2013-04-02','11:50:00',3.85),('11288','2013-04-02','11:55:00',1.86),('11288','2013-04-02','12:00:00',2.06),('11288','2013-04-02','12:05:00',4.87),('11288','2013-04-02','12:10:00',3.46),('11288','2013-04-02','12:15:00',3.87),('11288','2013-04-02','12:30:00',2.36),('11288','2013-04-02','12:35:00',3.29),('11288','2013-04-02','12:40:00',3.35),('11288','2013-04-02','12:45:00',4.22),('11288','2013-04-02','12:50:00',3.86),('11288','2013-04-02','12:55:00',4.07),('11288','2013-04-02','13:00:00',4.38),('11288','2013-04-02','13:05:00',4.56),('11288','2013-04-02','13:10:00',5.52),('11288','2013-04-02','13:15:00',4.21),('11288','2013-04-02','13:20:00',3.55),('11288','2013-04-02','13:25:00',5.96),('11288','2013-04-02','13:30:00',4.32),('11288','2013-04-02','13:35:00',3.52),('11288','2013-04-02','13:40:00',5.14),('11288','2013-04-02','13:45:00',4.83),('11288','2013-04-02','13:50:00',3.62),('11288','2013-04-02','13:55:00',3.82),('11288','2013-04-02','14:00:00',4.51),('11288','2013-04-02','14:05:00',3.61),('11288','2013-04-02','14:10:00',4.7),('11288','2013-04-02','14:15:00',3.96),('11288','2013-04-02','14:20:00',7.2),('11288','2013-04-02','14:25:00',6.9),('11288','2013-04-02','14:30:00',3.35),('11288','2013-04-02','14:35:00',3.47),('11288','2013-04-02','14:40:00',4.63),('11288','2013-04-02','14:45:00',4.65),('11288','2013-04-02','14:50:00',3.19),('11288','2013-04-02','14:55:00',2.89),('11288','2013-04-02','15:00:00',2.5),('11288','2013-04-02','15:05:00',1.34),('11288','2013-04-02','15:10:00',1.06),('11288','2013-04-02','15:15:00',1.26),('11288','2013-04-02','15:20:00',1.79),('11288','2013-04-02','15:30:00',1.06),('11288','2013-04-02','15:35:00',1.42),('11288','2013-04-02','15:40:00',1.71),('11288','2013-04-02','15:45:00',2.08),('11288','2013-04-02','15:50:00',1.16),('11288','2013-04-02','15:55:00',1.41),('11288','2013-04-02','16:00:00',2.06),('11288','2013-04-02','16:05:00',2.1),('11288','2013-04-02','16:10:00',1.63),('11288','2013-04-02','16:15:00',2.02),('11288','2013-04-02','16:20:00',1.83),('11288','2013-04-02','16:25:00',1.65),('11288','2013-04-02','16:30:00',1.84),('11288','2013-04-02','16:35:00',1.76),('11288','2013-04-02','16:40:00',1.63),('11288','2013-04-02','16:45:00',1.59),('11288','2013-04-02','16:50:00',1.03),('11288','2013-04-02','16:55:00',1.2),('11288','2013-04-02','17:00:00',1.65),('11288','2013-04-02','17:05:00',1.4),('11288','2013-04-02','17:35:00',1),('11288','2013-04-02','17:40:00',1.78),('11288','2013-04-02','17:45:00',1.54),('11288','2014-05-02','07:35:00',1.12),('11288','2014-05-02','07:40:00',1.2),('11288','2014-05-02','07:45:00',1.41),('11288','2014-05-02','07:50:00',1.47),('11288','2014-05-02','07:55:00',1.7),('11288','2014-05-02','08:00:00',1.97),('11288','2014-05-02','08:05:00',1.81),('11288','2014-05-02','08:10:00',1.59),('11288','2014-05-02','08:15:00',2.81),('11288','2014-05-02','08:20:00',2.56),('11288','2014-05-02','08:25:00',1.88),('11288','2014-05-02','08:30:00',1.2),('11288','2014-05-02','08:35:00',1.09),('11288','2014-05-02','08:40:00',1.6),('11288','2014-05-02','08:45:00',2.78),('11288','2014-05-02','08:50:00',2.47),('11288','2014-05-02','08:55:00',1.03),('11288','2014-05-02','09:05:00',1.24),('11288','2014-05-02','09:10:00',1.56),('11288','2014-05-02','09:15:00',2.23),('11288','2014-05-02','09:20:00',2.68),('11288','2014-05-02','09:25:00',3.26),('11288','2014-05-02','09:30:00',3.53),('11288','2014-05-02','09:35:00',3.35),('11288','2014-05-02','09:40:00',3.15),('11288','2014-05-02','09:45:00',2.92),('11288','2014-05-02','09:50:00',2.84),('11288','2014-05-02','09:55:00',2.74),('11288','2014-05-02','10:00:00',3.19),('11288','2014-05-02','10:05:00',3.65),('11288','2014-05-02','10:10:00',3.21),('11288','2014-05-02','10:15:00',2.93),('11288','2014-05-02','10:20:00',2.53),('11288','2014-05-02','10:25:00',2.21),('11288','2014-05-02','10:30:00',1.58),('11288','2014-05-02','10:35:00',1.58),('11288','2014-05-02','10:40:00',1.87),('11288','2014-05-02','10:45:00',2.28),('11288','2014-05-02','10:50:00',1.78),('11288','2014-05-02','10:55:00',1.26),('11288','2014-05-02','12:20:00',1.14),('11288','2014-05-02','12:25:00',1.58),('11288','2014-05-02','12:30:00',1.94),('11288','2014-05-02','12:35:00',2.09),('11288','2014-05-02','12:40:00',2.11),('11288','2014-05-02','12:45:00',2.85),('11288','2014-05-02','12:50:00',3.39),('11288','2014-05-02','12:55:00',2.58),('11288','2014-05-02','13:00:00',2.96),('11288','2014-05-02','13:05:00',3.39),('11288','2014-05-02','13:10:00',3.28),('11288','2014-05-02','13:15:00',4.49),('11288','2014-05-02','13:20:00',5.33),('11288','2014-05-02','13:25:00',6.97),('11288','2014-05-02','13:30:00',4.9),('11288','2014-05-02','13:35:00',4.65),('11288','2014-05-02','13:40:00',4.11),('11288','2014-05-02','13:45:00',3.49),('11288','2014-05-02','13:50:00',2.96),('11288','2014-05-02','13:55:00',2.31),('11288','2014-05-02','14:00:00',2.7),('11288','2014-05-02','14:05:00',4.28),('11288','2014-05-02','14:10:00',1.66),('11288','2014-05-02','14:25:00',1.48),('11288','2014-05-02','14:30:00',2.14),('11288','2014-05-02','14:35:00',3.16),('11288','2014-05-02','14:40:00',4.97),('11288','2014-05-02','14:45:00',2.66),('11288','2014-05-02','14:50:00',2.51),('11288','2014-05-02','14:55:00',3.58),('11288','2014-05-02','15:00:00',4.1),('11288','2014-05-02','15:05:00',3.4),('11288','2014-05-02','15:10:00',6.44),('11288','2014-05-02','15:15:00',4.35),('11288','2014-05-02','15:20:00',5.08),('11288','2014-05-02','15:25:00',2.49),('11288','2014-05-02','15:30:00',2.39),('11288','2014-05-02','15:35:00',5.28),('11288','2014-05-02','15:40:00',5.65),('11288','2014-05-02','15:45:00',2.24),('11288','2014-05-02','15:50:00',1.62),('11288','2014-05-02','15:55:00',1.5),('11288','2014-05-02','16:00:00',2.67),('11288','2014-05-02','16:05:00',2.86),('11288','2014-05-02','16:10:00',1.87),('11288','2014-05-02','16:15:00',2.49),('11288','2014-05-02','16:20:00',3.67),('11288','2014-05-02','16:50:00',1.08),('11288','2014-05-02','16:55:00',1.35),('11288','2014-05-02','17:00:00',1.02),('11288','2014-05-02','17:05:00',1.4),('11288','2014-05-02','17:10:00',1.16),('11288','2014-05-02','17:15:00',1.75),('11288','2014-05-02','17:20:00',1.86),('11288','2014-05-02','17:25:00',2.13),('11288','2014-05-02','17:30:00',1.62),('11288','2014-05-02','17:35:00',1.28),('11288','2014-05-02','17:40:00',1.06),('11288','2014-03-27','07:40:00',1),('11288','2014-03-27','07:45:00',1.32),('11288','2014-03-27','07:50:00',1.34),('11288','2014-03-27','07:55:00',1.98),('11288','2014-03-27','08:00:00',2.56),('11288','2014-03-27','08:05:00',2.6),('11288','2014-03-27','08:10:00',1.13),('11288','2014-03-27','09:10:00',1.52),('11288','2014-03-27','09:15:00',1.76),('11288','2014-03-27','09:20:00',1.63),('11288','2014-03-27','09:25:00',1.5),('11288','2014-03-27','09:30:00',1.26),('11288','2014-03-27','09:55:00',1.37),('11288','2014-03-27','10:00:00',1.53),('11288','2014-03-27','10:05:00',2.1),('11288','2014-03-27','10:10:00',2.27),('11288','2014-03-27','10:15:00',2.23),('11288','2014-03-27','10:20:00',3.04),('11288','2014-03-27','10:25:00',3.72),('11288','2014-03-27','10:30:00',3.59),('11288','2014-03-27','10:35:00',3.33),('11288','2014-03-27','10:40:00',3.48),('11288','2014-03-27','10:45:00',1.8),('11288','2014-03-27','10:50:00',1.51),('11288','2014-03-27','10:55:00',1.41),('11288','2014-03-27','11:00:00',1.3),('11288','2014-03-27','11:05:00',1.56),('11288','2014-03-27','11:10:00',5.6),('11288','2014-03-27','11:15:00',3.56),('11288','2014-03-27','11:20:00',2.25),('11288','2014-03-27','11:25:00',1.22),('11288','2014-03-27','11:45:00',1.11),('11288','2014-03-27','11:50:00',2.03),('11288','2014-03-27','11:55:00',2.52),('11288','2014-03-27','12:00:00',1.99),('11288','2014-03-27','12:05:00',2.03),('11288','2014-03-27','12:10:00',2.15),('11288','2014-03-27','12:15:00',1.69),('11288','2014-03-27','12:20:00',1.9),('11288','2014-03-27','12:50:00',1.05),('11288','2014-03-27','12:55:00',1.46),('11288','2014-03-27','13:00:00',1.77),('11288','2014-03-27','13:05:00',2.23),('11288','2014-03-27','13:10:00',3.03),('11288','2014-03-27','13:15:00',3.96),('11288','2014-03-27','13:20:00',4.17),('11288','2014-03-27','13:25:00',4.12),('11288','2014-03-27','13:30:00',3.54),('11288','2014-03-27','13:35:00',3.29),('11288','2014-03-27','13:40:00',3.1),('11288','2014-03-27','13:45:00',2.93),('11288','2014-03-27','13:50:00',3.93),('11288','2014-03-27','13:55:00',4.62),('11288','2014-03-27','14:00:00',3.42),('11288','2014-03-27','14:05:00',1.77),('11288','2014-03-27','14:10:00',1.39),('11288','2014-03-27','14:15:00',5.02),('11288','2014-03-27','14:20:00',6.1),('11288','2014-03-27','14:25:00',6.81),('11288','2014-03-27','14:30:00',5.76),('11288','2014-03-27','14:35:00',3.73),('11288','2014-03-27','14:40:00',3.21),('11288','2014-03-27','14:45:00',3.03),('11288','2014-03-27','14:50:00',3.8),('11288','2014-03-27','14:55:00',3.2),('11288','2014-03-27','15:00:00',5.89),('11288','2014-03-27','15:05:00',2.24),('11288','2014-03-27','15:20:00',1.92),('11288','2014-03-27','15:25:00',5.2),('11288','2014-03-27','15:30:00',4.42),('11288','2014-03-27','15:35:00',4.29),('11288','2014-03-27','15:40:00',2.03),('11288','2014-03-27','15:45:00',1.12),('11288','2014-03-27','15:50:00',1.67),('11288','2014-03-27','15:55:00',1.52),('11288','2014-03-27','16:00:00',1.59),('11288','2014-03-27','16:05:00',1.83),('11288','2014-03-27','16:10:00',2.15),('11288','2014-03-27','16:15:00',1.75),('11288','2014-03-27','16:20:00',1.55),('11288','2014-03-27','16:25:00',1.86),('11288','2014-03-27','16:30:00',2.12),('11288','2014-03-27','16:35:00',1.55),('11288','2014-03-27','16:40:00',1.6),('11288','2014-03-27','16:45:00',1.52),('11288','2014-03-27','16:50:00',1.13),('11288','2014-03-27','16:55:00',1.57),('11288','2014-03-27','17:00:00',1.35),('11288','2014-03-27','17:05:00',1.24),('11288','2013-04-01','08:25:00',1.5),('11288','2013-04-01','08:30:00',1.41),('11288','2013-04-01','08:35:00',1.88),('11288','2013-04-01','08:40:00',1.75),('11288','2013-04-01','08:45:00',1.34),('11288','2013-04-01','08:50:00',1.71),('11288','2013-04-01','08:55:00',1.76),('11288','2013-04-01','09:00:00',1.99),('11288','2013-04-01','09:05:00',2.66),('11288','2013-04-01','09:10:00',2.79),('11288','2013-04-01','09:15:00',1.87),('11288','2013-04-01','09:20:00',2.52),('11288','2013-04-01','09:25:00',3.15),('11288','2013-04-01','09:30:00',2.64),('11288','2013-04-01','09:35:00',3.07),('11288','2013-04-01','09:40:00',3.11),('11288','2013-04-01','09:45:00',4.21),('11288','2013-04-01','09:50:00',4.41),('11288','2013-04-01','09:55:00',4.18),('11288','2013-04-01','10:00:00',4.76),('11288','2013-04-01','10:05:00',4.85),('11288','2013-04-01','10:10:00',3.7),('11288','2013-04-01','10:15:00',4.51),('11288','2013-04-01','10:20:00',3.39),('11288','2013-04-01','10:25:00',4.61),('11288','2013-04-01','10:30:00',3.61),('11288','2013-04-01','10:35:00',2.17),('11288','2013-04-01','10:40:00',3.67),('11288','2013-04-01','10:45:00',5.16),('11288','2013-04-01','10:50:00',2.21),('11288','2013-04-01','10:55:00',2.77),('11288','2013-04-01','11:00:00',2.12),('11288','2013-04-01','11:05:00',2.61),('11288','2013-04-01','11:10:00',4.66),('11288','2013-04-01','11:15:00',3.34),('11288','2013-04-01','11:20:00',5.98),('11288','2013-04-01','11:25:00',3.1),('11288','2013-04-01','11:30:00',2.86),('11288','2013-04-01','11:35:00',3.37),('11288','2013-04-01','11:40:00',4.87),('11288','2013-04-01','11:45:00',4.89),('11288','2013-04-01','11:50:00',4.21),('11288','2013-04-01','11:55:00',3.76),('11288','2013-04-01','12:00:00',4.86),('11288','2013-04-01','12:05:00',3.39),('11288','2013-04-01','12:10:00',4.07),('11288','2013-04-01','12:15:00',3.4),('11288','2013-04-01','12:20:00',2.95),('11288','2013-04-01','12:25:00',3.32),('11288','2013-04-01','12:30:00',4.68),('11288','2013-04-01','12:35:00',4.22),('11288','2013-04-01','12:40:00',4.3),('11288','2013-04-01','12:45:00',4.85),('11288','2013-04-01','12:50:00',5.1),('11288','2013-04-01','12:55:00',5.26),('11288','2013-04-01','13:00:00',5.22),('11288','2013-04-01','13:05:00',5.54),('11288','2013-04-01','13:10:00',4.96),('11288','2013-04-01','13:15:00',5.44),('11288','2013-04-01','13:20:00',5),('11288','2013-04-01','13:25:00',4.81),('11288','2013-04-01','13:30:00',4.87),('11288','2013-04-01','13:35:00',4.81),('11288','2013-04-01','13:40:00',6.47),('11288','2013-04-01','13:45:00',6.62),('11288','2013-04-01','13:50:00',7.26),('11288','2013-04-01','13:55:00',6.63),('11288','2013-04-01','14:00:00',4.07),('11288','2013-04-01','14:05:00',3.34),('11288','2013-04-01','14:10:00',4.28),('11288','2013-04-01','14:15:00',4.7),('11288','2013-04-01','14:20:00',5.11),('11288','2013-04-01','14:25:00',7.03),('11288','2013-04-01','14:30:00',4.12),('11288','2013-04-01','14:35:00',3.7),('11288','2013-04-01','14:40:00',3.28),('11288','2013-04-01','14:45:00',3.41),('11288','2013-04-01','14:50:00',3.71),('11288','2013-04-01','14:55:00',3.87),('11288','2013-04-01','15:00:00',3.56),('11288','2013-04-01','15:05:00',3.57),('11288','2013-04-01','15:10:00',3.68),('11288','2013-04-01','15:15:00',3.91),('11288','2013-04-01','15:20:00',4.05),('11288','2013-04-01','15:25:00',4.04),('11288','2013-04-01','15:30:00',3.66),('11288','2013-04-01','15:35:00',4.54),('11288','2013-04-01','15:40:00',4.16),('11288','2013-04-01','15:45:00',4.44),('11288','2013-04-01','15:50:00',4.73),('11288','2013-04-01','15:55:00',3.51),('11288','2013-04-01','16:00:00',3.31),('11288','2013-04-01','16:05:00',2.75),('11288','2013-04-01','16:10:00',2.35),('11288','2013-04-01','16:15:00',1.94),('11288','2013-04-01','16:20:00',1.88),('11288','2013-04-01','16:25:00',1.74),('11288','2013-04-01','16:30:00',1.42),('11288','2013-04-01','16:35:00',1.48),('11288','2013-04-01','16:40:00',1.26),('11288','2013-04-01','16:45:00',1.04),('11288','2013-03-31','08:15:00',1.04),('11288','2013-03-31','08:20:00',1.44),('11288','2013-03-31','08:30:00',1.8),('11288','2013-03-31','08:35:00',1.75),('11288','2013-03-31','08:40:00',1.82),('11288','2013-03-31','08:45:00',2.05),('11288','2013-03-31','08:50:00',1.81),('11288','2013-03-31','08:55:00',2.07),('11288','2013-03-31','09:00:00',1.99),('11288','2013-03-31','09:05:00',1.97),('11288','2013-03-31','09:10:00',2.1),('11288','2013-03-31','09:15:00',2.6),('11288','2013-03-31','09:20:00',3.31),('11288','2013-03-31','09:25:00',3.77),('11288','2013-03-31','09:30:00',2.69),('11288','2013-03-31','09:35:00',3.14),('11288','2013-03-31','09:40:00',2.12),('11288','2013-03-31','09:45:00',3.13),('11288','2013-03-31','09:50:00',2.48),('11288','2013-03-31','09:55:00',3.37),('11288','2013-03-31','10:00:00',2.81),('11288','2013-03-31','10:05:00',1.11),('11288','2013-03-31','10:10:00',1.01),('11288','2013-03-31','10:15:00',1.96),('11288','2013-03-31','10:20:00',4.03),('11288','2013-03-31','10:25:00',4.25),('11288','2013-03-31','10:30:00',5.11),('11288','2013-03-31','10:35:00',4.72),('11288','2013-03-31','10:40:00',1.43),('11288','2013-03-31','10:45:00',2.37),('11288','2013-03-31','10:50:00',3.57),('11288','2013-03-31','10:55:00',1.67),('11288','2013-03-31','11:00:00',1.37),('11288','2013-03-31','11:05:00',1.39),('11288','2013-03-31','11:10:00',2.64),('11288','2013-03-31','11:15:00',2.35),('11288','2013-03-31','11:20:00',2.21),('11288','2013-03-31','11:25:00',2.69),('11288','2013-03-31','11:30:00',2.16),('11288','2013-03-31','11:35:00',2.79),('11288','2013-03-31','11:40:00',2.82),('11288','2013-03-31','11:45:00',2.47),('11288','2013-03-31','11:50:00',2.93),('11288','2013-03-31','11:55:00',3.08),('11288','2013-03-31','12:00:00',2.85),('11288','2013-03-31','12:05:00',2.72),('11288','2013-03-31','12:10:00',2.37),('11288','2013-03-31','12:15:00',2.69),('11288','2013-03-31','12:20:00',2.42),('11288','2013-03-31','12:25:00',3.13),('11288','2013-03-31','12:30:00',3.4),('11288','2013-03-31','12:35:00',5.05),('11288','2013-03-31','12:40:00',4.91),('11288','2013-03-31','12:45:00',2.84),('11288','2013-03-31','12:50:00',3.2),('11288','2013-03-31','12:55:00',3.76),('11288','2013-03-31','13:00:00',4.4),('11288','2013-03-31','13:05:00',3.91),('11288','2013-03-31','13:10:00',5.25),('11288','2013-03-31','13:15:00',4.67),('11288','2013-03-31','13:20:00',6.53),('11288','2013-03-31','13:25:00',3.61),('11288','2013-03-31','13:30:00',1.46),('11288','2013-03-31','13:35:00',1.47),('11288','2013-03-31','13:40:00',3.14),('11288','2013-03-31','13:45:00',2.9),('11288','2013-03-31','13:50:00',4.41),('11288','2013-03-31','13:55:00',3.38),('11288','2013-03-31','14:00:00',3.33),('11288','2013-03-31','14:05:00',4.75),('11288','2013-03-31','14:10:00',4.43),('11288','2013-03-31','14:15:00',5.52),('11288','2013-03-31','14:20:00',2.85),('11288','2013-03-31','14:25:00',3.41),('11288','2013-03-31','14:30:00',6.42),('11288','2013-03-31','14:35:00',7.2),('11288','2013-03-31','14:40:00',7.48),('11288','2013-03-31','14:45:00',5.97),('11288','2013-03-31','14:50:00',5.21),('11288','2013-03-31','14:55:00',5.36),('11288','2013-03-31','15:00:00',5.56),('11288','2013-03-31','15:05:00',4.05),('11288','2013-03-31','15:10:00',5.32),('11288','2013-03-31','15:15:00',5.85),('11288','2013-03-31','15:20:00',7.23),('11288','2013-03-31','15:25:00',4.81),('11288','2013-03-31','15:30:00',4.21),('11288','2013-03-31','15:35:00',5.3),('11288','2013-03-31','15:40:00',6.86),('11288','2013-03-31','15:45:00',4.05),('11288','2013-03-31','15:50:00',1.68),('11288','2013-03-31','15:55:00',2.28),('11288','2013-03-31','16:00:00',5.45),('11288','2013-03-31','16:05:00',2.05),('11288','2013-03-31','16:10:00',3.22),('11288','2013-03-31','16:15:00',3.81),('11288','2013-03-31','16:20:00',3.11),('11288','2013-03-31','16:25:00',2.27),('11288','2013-03-31','16:30:00',1.97),('11288','2013-03-31','16:35:00',2.08),('11288','2013-03-31','16:40:00',2.47),('11288','2013-03-31','16:45:00',2.01),('11288','2013-03-31','16:50:00',1.69),('11288','2013-03-31','16:55:00',1.54),('11288','2013-03-31','17:00:00',2.1),('11288','2013-03-31','17:05:00',2.1),('11288','2013-03-31','17:10:00',1.83),('11288','2013-03-31','17:15:00',1.51),('11288','2013-03-31','17:20:00',2),('11288','2013-03-31','17:25:00',2.08),('11288','2013-03-31','17:30:00',2.26),('11288','2013-03-31','17:35:00',2.07),('11288','2013-03-31','17:40:00',1.5),('11288','2013-03-31','17:45:00',1.81),('11288','2013-03-31','17:50:00',1.98),('11288','2013-03-31','17:55:00',2.48),('11288','2013-03-31','18:00:00',1.2),('11288','2013-03-31','18:15:00',1.94),('11288','2013-03-31','18:20:00',1.05),('11288','2013-03-30','07:30:00',1.11),('11288','2013-03-30','07:50:00',1.24),('11288','2013-03-30','07:55:00',1.57),('11288','2013-03-30','08:00:00',1.28),('11288','2013-03-30','08:05:00',1.14),('11288','2013-03-30','08:10:00',1.22),('11288','2013-03-30','08:15:00',1.5),('11288','2013-03-30','08:20:00',1.49),('11288','2013-03-30','08:25:00',1.65),('11288','2013-03-30','08:30:00',1.78),('11288','2013-03-30','08:35:00',2.09),('11288','2013-03-30','08:40:00',1.9),('11288','2013-03-30','08:45:00',1.48),('11288','2013-03-30','08:50:00',1.7),('11288','2013-03-30','08:55:00',1.43),('11288','2013-03-30','09:00:00',1.86),('11288','2013-03-30','09:05:00',2.88),('11288','2013-03-30','09:10:00',3.18),('11288','2013-03-30','09:15:00',3.66),('11288','2013-03-30','09:20:00',5.35),('11288','2013-03-30','09:25:00',2.7),('11288','2013-03-30','09:30:00',2.19),('11288','2013-03-30','09:35:00',2.37),('11288','2013-03-30','09:40:00',2.3),('11288','2013-03-30','09:45:00',2.03),('11288','2013-03-30','09:50:00',1.55),('11288','2013-03-30','09:55:00',2.38),('11288','2013-03-30','10:00:00',3.45),('11288','2013-03-30','10:05:00',3.24),('11288','2013-03-30','10:10:00',3.5),('11288','2013-03-30','10:15:00',3.06),('11288','2013-03-30','10:20:00',2.66),('11288','2013-03-30','10:25:00',2.69),('11288','2013-03-30','10:30:00',3.09),('11288','2013-03-30','10:35:00',3.69),('11288','2013-03-30','10:40:00',4.34),('11288','2013-03-30','10:45:00',5.36),('11288','2013-03-30','10:50:00',4.99),('11288','2013-03-30','10:55:00',3.93),('11288','2013-03-30','11:00:00',5.52),('11288','2013-03-30','11:05:00',6.94),('11288','2013-03-30','11:10:00',7.11),('11288','2013-03-30','11:15:00',5.79),('11288','2013-03-30','11:20:00',8.58),('11288','2013-03-30','11:25:00',6.17),('11288','2013-03-30','11:30:00',5.32),('11288','2013-03-30','11:35:00',6.22),('11288','2013-03-30','11:40:00',5.5),('11288','2013-03-30','11:45:00',6.5),('11288','2013-03-30','11:50:00',6.85),('11288','2013-03-30','11:55:00',6.98),('11288','2013-03-30','12:00:00',5.77),('11288','2013-03-30','12:05:00',4.14),('11288','2013-03-30','12:10:00',3.65),('11288','2013-03-30','12:15:00',3.65),('11288','2013-03-30','12:20:00',3.13),('11288','2013-03-30','12:25:00',1.68),('11288','2013-03-30','12:30:00',1.86),('11288','2013-03-30','12:35:00',1.55),('11288','2013-03-30','12:45:00',1.49),('11288','2013-03-30','12:50:00',1.09),('11288','2013-03-30','13:05:00',1.08),('11288','2013-03-30','13:10:00',5.33),('11288','2013-03-30','13:15:00',5.39),('11288','2013-03-30','13:20:00',3.28),('11288','2013-03-30','13:25:00',3.28),('11288','2013-03-30','13:30:00',1.78),('11288','2013-03-30','13:35:00',1.22),('11288','2013-03-30','13:40:00',1.62),('11288','2013-03-30','13:45:00',4.65),('11288','2013-03-30','13:50:00',5.83),('11288','2013-03-30','13:55:00',2.65),('11288','2013-03-30','14:00:00',3.79),('11288','2013-03-30','14:05:00',2.56),('11288','2013-03-30','14:10:00',1.86),('11288','2013-03-30','14:15:00',1.83),('11288','2013-03-30','14:20:00',2.46),('11288','2013-03-30','14:25:00',2.37),('11288','2013-03-30','14:30:00',3.77),('11288','2013-03-30','14:35:00',3.48),('11288','2013-03-30','14:40:00',2.21),('11288','2013-03-30','14:45:00',1.85),('11288','2013-03-30','14:50:00',2.46),('11288','2013-03-30','14:55:00',1.51),('11288','2013-03-30','15:00:00',1.14),('11288','2013-03-30','15:15:00',1.07),('11288','2013-03-30','15:20:00',1.59),('11288','2013-03-30','15:25:00',1.81),('11288','2013-03-30','15:30:00',1.65),('11288','2013-03-30','15:35:00',1.27),('11288','2013-03-30','15:40:00',1.53),('11288','2013-03-30','15:45:00',1.27),('11288','2013-03-30','15:50:00',1.25),('11288','2013-03-30','15:55:00',1.02),('11288','2013-03-29','07:15:00',1.07),('11288','2013-03-29','07:20:00',1.18),('11288','2013-03-29','07:25:00',1.29),('11288','2013-03-29','07:30:00',1.16),('11288','2013-03-29','07:35:00',1.43),('11288','2013-03-29','07:40:00',1.68),('11288','2013-03-29','07:45:00',2.11),('11288','2013-03-29','07:50:00',1.49),('11288','2013-03-29','07:55:00',1.66),('11288','2013-03-29','08:00:00',1.74),('11288','2013-03-29','08:05:00',2.07),('11288','2013-03-29','08:10:00',2.47),('11288','2013-03-29','08:15:00',2.77),('11288','2013-03-29','08:20:00',2.85),('11288','2013-03-29','08:25:00',2.84),('11288','2013-03-29','08:30:00',3.37),('11288','2013-03-29','08:35:00',3.47),('11288','2013-03-29','08:40:00',3.34),('11288','2013-03-29','08:45:00',3.6),('11288','2013-03-29','08:50:00',3.78),('11288','2013-03-29','08:55:00',3.32),('11288','2013-03-29','09:00:00',3.74),('11288','2013-03-29','09:05:00',4.3),('11288','2013-03-29','09:10:00',4.26),('11288','2013-03-29','09:15:00',4.95),('11288','2013-03-29','09:20:00',5.11),('11288','2013-03-29','09:25:00',5.02),('11288','2013-03-29','09:30:00',5.92),('11288','2013-03-29','09:35:00',5.77),('11288','2013-03-29','09:40:00',5.69),('11288','2013-03-29','09:45:00',5.09),('11288','2013-03-29','09:50:00',5.15),('11288','2013-03-29','09:55:00',5.67),('11288','2013-03-29','10:00:00',5.66),('11288','2013-03-29','10:05:00',5.44),('11288','2013-03-29','10:10:00',4.74),('11288','2013-03-29','10:15:00',5.75),('11288','2013-03-29','10:20:00',5.26),('11288','2013-03-29','10:25:00',5),('11288','2013-03-29','10:30:00',5.19),('11288','2013-03-29','10:35:00',4.64),('11288','2013-03-29','10:40:00',5.58),('11288','2013-03-29','10:45:00',4.44),('11288','2013-03-29','10:50:00',5.05),('11288','2013-03-29','10:55:00',5.5),('11288','2013-03-29','11:00:00',6.7),('11288','2013-03-29','11:05:00',6.23),('11288','2013-03-29','11:10:00',3.56),('11288','2013-03-29','11:15:00',4.09),('11288','2013-03-29','11:20:00',7.49),('11288','2013-03-29','11:25:00',7.33),('11288','2013-03-29','11:30:00',7.05),('11288','2013-03-29','11:35:00',6.83),('11288','2013-03-29','11:40:00',6.97),('11288','2013-03-29','11:45:00',6.99),('11288','2013-03-29','11:50:00',7.11),('11288','2013-03-29','11:55:00',7.17),('11288','2013-03-29','12:00:00',7.16),('11288','2013-03-29','12:05:00',7.31),('11288','2013-03-29','12:10:00',7.27),('11288','2013-03-29','12:15:00',6.76),('11288','2013-03-29','12:20:00',7.01),('11288','2013-03-29','12:25:00',7),('11288','2013-03-29','12:30:00',6.66),('11288','2013-03-29','12:35:00',6.8),('11288','2013-03-29','12:40:00',6.41),('11288','2013-03-29','12:45:00',6.42),('11288','2013-03-29','12:50:00',6.86),('11288','2013-03-29','12:55:00',6.72),('11288','2013-03-29','13:00:00',6.82),('11288','2013-03-29','13:05:00',6.06),('11288','2013-03-29','13:10:00',6.61),('11288','2013-03-29','13:15:00',6.08),('11288','2013-03-29','13:20:00',6.15),('11288','2013-03-29','13:25:00',7.13),('11288','2013-03-29','13:30:00',6.34),('11288','2013-03-29','13:35:00',5.42),('11288','2013-03-29','13:40:00',5.4),('11288','2013-03-29','13:45:00',5.95),('11288','2013-03-29','13:50:00',5.59),('11288','2013-03-29','13:55:00',5.87),('11288','2013-03-29','14:00:00',6.21),('11288','2013-03-29','14:05:00',4.91),('11288','2013-03-29','14:10:00',4.16),('11288','2013-03-29','14:15:00',4.19),('11288','2013-03-29','14:20:00',4.22),('11288','2013-03-29','14:25:00',4.45),('11288','2013-03-29','14:30:00',3.7),('11288','2013-03-29','14:35:00',3.61),('11288','2013-03-29','14:40:00',3.6),('11288','2013-03-29','14:45:00',3.3),('11288','2013-03-29','14:50:00',3.22),('11288','2013-03-29','14:55:00',3.14),('11288','2013-03-29','15:00:00',2.83),('11288','2013-03-29','15:05:00',2.8),('11288','2013-03-29','15:10:00',2.68),('11288','2013-03-29','15:15:00',2.65),('11288','2013-03-29','15:20:00',2.46),('11288','2013-03-29','15:25:00',2.27),('11288','2013-03-29','15:30:00',2.1),('11288','2013-03-29','15:35:00',2.01),('11288','2013-03-29','15:40:00',1.91),('11288','2013-03-29','15:45:00',1.87),('11288','2013-03-29','15:50:00',2.07),('11288','2013-03-29','15:55:00',2.34),('11288','2013-03-29','16:00:00',2.79),('11288','2013-03-29','16:05:00',2.65),('11288','2013-03-29','16:10:00',1.97),('11288','2013-03-29','16:15:00',1.81),('11288','2013-03-29','16:20:00',1.65),('11288','2013-03-29','16:25:00',1.83),('11288','2013-03-29','16:30:00',1.84),('11288','2013-03-29','16:35:00',2.11),('11288','2013-03-29','16:40:00',2.98),('11288','2013-03-29','16:45:00',2.54),('11288','2013-03-29','16:50:00',1.87),('11288','2013-03-29','16:55:00',1.67),('11288','2013-03-29','17:00:00',1.77),('11288','2013-03-29','17:05:00',1.24),('11288','2013-03-29','17:20:00',1.32),('11288','2013-03-29','17:25:00',1.3),('11288','2013-03-29','17:30:00',1.18),('11288','2013-03-28','07:30:00',1.04),('11288','2013-03-28','07:40:00',1.12),('11288','2013-03-28','08:40:00',1.02),('11288','2013-03-28','08:50:00',1.1),('11288','2013-03-28','08:55:00',1.27),('11288','2013-03-28','09:00:00',1.26),('11288','2013-03-28','09:05:00',1.82),('11288','2013-03-28','09:10:00',3.43),('11288','2013-03-28','09:15:00',4.24),('11288','2013-03-28','09:20:00',2.75),('11288','2013-03-28','09:25:00',2.65),('11288','2013-03-28','09:30:00',1.84),('11288','2013-03-28','09:35:00',1.66),('11288','2013-03-28','09:40:00',1.64),('11288','2013-03-28','09:45:00',1.96),('11288','2013-03-28','09:50:00',2.06),('11288','2013-03-28','09:55:00',1.86),('11288','2013-03-28','10:00:00',1.9),('11288','2013-03-28','10:05:00',1.66),('11288','2013-03-28','10:10:00',1.34),('11288','2013-03-28','10:15:00',1.14),('11288','2013-03-28','10:20:00',1.13),('11288','2013-03-28','10:25:00',1.19),('11288','2013-03-28','10:30:00',1.19),('11288','2013-03-28','10:35:00',1.06),('11288','2013-03-28','10:55:00',1.23),('11288','2013-03-28','11:00:00',1.6),('11288','2013-03-28','11:05:00',1.16),('11288','2013-03-28','11:10:00',1.02),('11288','2013-03-28','11:25:00',1.22),('11288','2013-03-28','11:30:00',1.82),('11288','2013-03-28','11:35:00',2.27),('11288','2013-03-28','11:40:00',2.76),('11288','2013-03-28','11:45:00',2.04),('11288','2013-03-28','11:50:00',2.35),('11288','2013-03-28','11:55:00',3.93),('11288','2013-03-28','12:00:00',2.35),('11288','2013-03-28','12:05:00',1.62),('11288','2013-03-28','12:10:00',1.98),('11288','2013-03-28','12:15:00',2.42),('11288','2013-03-28','12:20:00',1.69),('11288','2013-03-28','12:25:00',1.62),('11288','2013-03-28','12:30:00',2.23),('11288','2013-03-28','12:35:00',1.84),('11288','2013-03-28','12:40:00',2.57),('11288','2013-03-28','12:45:00',3.21),('11288','2013-03-28','12:50:00',6.16),('11288','2013-03-28','12:55:00',6.15),('11288','2013-03-28','13:00:00',5.14),('11288','2013-03-28','13:05:00',7.36),('11288','2013-03-28','13:10:00',7.49),('11288','2013-03-28','13:15:00',4.67),('11288','2013-03-28','13:20:00',4.54),('11288','2013-03-28','13:25:00',3.78),('11288','2013-03-28','13:30:00',5.26),('11288','2013-03-28','13:35:00',5.06),('11288','2013-03-28','13:40:00',3.62),('11288','2013-03-28','13:45:00',3.99),('11288','2013-03-28','13:50:00',4.08),('11288','2013-03-28','13:55:00',3.01),('11288','2013-03-28','14:00:00',3.4),('11288','2013-03-28','14:05:00',3.26),('11288','2013-03-28','14:10:00',2.2),('11288','2013-03-28','14:15:00',2.6),('11288','2013-03-28','14:20:00',3.4),('11288','2013-03-28','14:25:00',3.09),('11288','2013-03-28','14:30:00',4.52),('11288','2013-03-28','14:35:00',2.86),('11288','2013-03-28','14:40:00',1.9),('11288','2013-03-28','14:45:00',2.25),('11288','2013-03-28','14:50:00',1.75),('11288','2013-03-28','14:55:00',1.73),('11288','2013-03-28','15:00:00',2.25),('11288','2013-03-28','15:05:00',2.62),('11288','2013-03-28','15:10:00',4.2),('11288','2013-03-28','15:15:00',3.11),('11288','2013-03-28','15:20:00',3.07),('11288','2013-03-28','15:25:00',1.75),('11288','2013-03-28','15:30:00',2.62),('11288','2013-03-28','15:35:00',3.61),('11288','2013-03-28','15:40:00',2.81),('11288','2013-03-28','15:45:00',3.28),('11288','2013-03-28','15:50:00',2.52),('11288','2013-03-28','15:55:00',4.01),('11288','2013-03-28','16:00:00',2.08),('11288','2013-03-28','16:05:00',2.28),('11288','2013-03-28','16:10:00',2.72),('11288','2013-03-28','16:25:00',1.1),('11288','2013-03-28','16:30:00',1.61),('11288','2013-03-28','16:35:00',2.33),('11288','2013-03-28','16:40:00',1.74),('11288','2013-03-28','16:45:00',1.67),('11288','2013-03-28','16:50:00',1.14),('11288','2013-03-28','16:55:00',1.38),('11288','2013-03-28','17:00:00',2.32),('11288','2013-03-28','17:05:00',1.98),('11288','2013-03-28','17:10:00',1.54),('11288','2013-03-28','17:15:00',1.28),('11288','2013-03-28','17:20:00',1.04),('11288','2013-03-27','07:15:00',1.03),('11288','2013-03-27','07:20:00',1.04),('11288','2013-03-27','07:25:00',1.26),('11288','2013-03-27','07:30:00',1.31),('11288','2013-03-27','07:35:00',1.16),('11288','2013-03-27','07:40:00',1.43),('11288','2013-03-27','07:45:00',1.39),('11288','2013-03-27','07:50:00',1.09),('11288','2013-03-27','07:55:00',2.19),('11288','2013-03-27','08:00:00',2.43),('11288','2013-03-27','08:05:00',2.39),('11288','2013-03-27','08:10:00',2.29),('11288','2013-03-27','08:15:00',2.48),('11288','2013-03-27','08:20:00',2.24),('11288','2013-03-27','08:25:00',2.52),('11288','2013-03-27','08:30:00',3.09),('11288','2013-03-27','08:35:00',2.62),('11288','2013-03-27','08:40:00',2.09),('11288','2013-03-27','08:45:00',2.14),('11288','2013-03-27','08:50:00',2.99),('11288','2013-03-27','08:55:00',2.36),('11288','2013-03-27','09:00:00',2.52),('11288','2013-03-27','09:05:00',2.08),('11288','2013-03-27','09:10:00',1.33),('11288','2013-03-27','09:15:00',2.66),('11288','2013-03-27','09:20:00',2.89),('11288','2013-03-27','09:25:00',1.85),('11288','2013-03-27','09:30:00',1.56),('11288','2013-03-27','09:35:00',1.49),('11288','2013-03-27','09:40:00',1.9),('11288','2013-03-27','09:45:00',2.91),('11288','2013-03-27','09:50:00',2.72),('11288','2013-03-27','09:55:00',2.63),('11288','2013-03-27','10:00:00',2.56),('11288','2013-03-27','10:05:00',1.66),('11288','2013-03-27','10:10:00',2.68),('11288','2013-03-27','10:15:00',3.36),('11288','2013-03-27','10:20:00',2.64),('11288','2013-03-27','10:25:00',3.41),('11288','2013-03-27','10:30:00',4.24),('11288','2013-03-27','10:35:00',3.52),('11288','2013-03-27','10:40:00',4.1),('11288','2013-03-27','10:45:00',3.77),('11288','2013-03-27','10:50:00',4.2),('11288','2013-03-27','10:55:00',3.78),('11288','2013-03-27','11:00:00',3.29),('11288','2013-03-27','11:05:00',2.96),('11288','2013-03-27','11:10:00',3.06),('11288','2013-03-27','11:15:00',3.32),('11288','2013-03-27','11:20:00',3.35),('11288','2013-03-27','11:25:00',3.12),('11288','2013-03-27','11:30:00',3.46),('11288','2013-03-27','11:35:00',3.16),('11288','2013-03-27','11:40:00',2.91),('11288','2013-03-27','11:45:00',3.28),('11288','2013-03-27','11:50:00',3.17),('11288','2013-03-27','11:55:00',5.08),('11288','2013-03-27','12:00:00',4.66),('11288','2013-03-27','12:05:00',4.4),('11288','2013-03-27','12:10:00',3.75),('11288','2013-03-27','12:15:00',3.05),('11288','2013-03-27','12:20:00',3.39),('11288','2013-03-27','12:25:00',3.21),('11288','2013-03-27','12:30:00',7.23),('11288','2013-03-27','12:35:00',7.29),('11288','2013-03-27','12:40:00',7.42),('11288','2013-03-27','12:45:00',6.46),('11288','2013-03-27','12:50:00',4.91),('11288','2013-03-27','12:55:00',2.75),('11288','2013-03-27','13:00:00',2.63),('11288','2013-03-27','13:05:00',3.57),('11288','2013-03-27','13:10:00',3.89),('11288','2013-03-27','13:15:00',2.88),('11288','2013-03-27','13:20:00',2.44),('11288','2013-03-27','13:25:00',2.59),('11288','2013-03-27','13:30:00',2.88),('11288','2013-03-27','13:35:00',3.95),('11288','2013-03-27','13:40:00',3.01),('11288','2013-03-27','13:45:00',3.44),('11288','2013-03-27','13:50:00',3.55),('11288','2013-03-27','13:55:00',3.2),('11288','2013-03-27','14:00:00',3.17),('11288','2013-03-27','14:05:00',2.76),('11288','2013-03-27','14:10:00',2.83),('11288','2013-03-27','14:15:00',3.3),('11288','2013-03-27','14:20:00',3.94),('11288','2013-03-27','14:25:00',3.24),('11288','2013-03-27','14:30:00',2.67),('11288','2013-03-27','14:35:00',3.24),('11288','2013-03-27','14:40:00',4.61),('11288','2013-03-27','14:45:00',4.19),('11288','2013-03-27','14:50:00',2.94),('11288','2013-03-27','14:55:00',2.15),('11288','2013-03-27','15:00:00',1.75),('11288','2013-03-27','15:05:00',2.3),('11288','2013-03-27','15:10:00',2.32),('11288','2013-03-27','15:15:00',1.88),('11288','2013-03-27','15:20:00',1.76),('11288','2013-03-27','15:25:00',1.82),('11288','2013-03-27','15:30:00',1.56),('11288','2013-03-27','15:35:00',1.42),('11288','2013-03-27','15:40:00',1.13),('11288','2013-03-27','15:55:00',1.1),('11288','2013-03-27','16:00:00',1.19),('11288','2013-03-27','16:05:00',1.44),('11288','2013-03-27','16:10:00',1.59),('11288','2013-03-27','16:15:00',1.49),('11288','2013-03-27','16:20:00',1.47),('11288','2013-03-27','16:25:00',1.53),('11288','2013-03-27','16:30:00',1.52),('11288','2013-03-27','16:35:00',1.55),('11288','2013-03-27','16:40:00',1.79),('11288','2013-03-27','16:45:00',2.08),('11288','2013-03-27','16:50:00',1.89),('11288','2013-03-27','16:55:00',2.1),('11288','2013-03-27','17:00:00',2.09),('11288','2013-03-27','17:05:00',2.21),('11288','2013-03-27','17:10:00',1.82),('11288','2013-03-27','17:15:00',1.18),('11288','2013-03-26','07:15:00',1.01),('11288','2013-03-26','07:35:00',1.09),('11288','2013-03-26','07:40:00',1.36),('11288','2013-03-26','07:45:00',1.81),('11288','2013-03-26','07:50:00',2.64),('11288','2013-03-26','07:55:00',2.01),('11288','2013-03-26','08:00:00',1.22),('11288','2013-03-26','08:05:00',1.05),('11288','2013-03-26','08:10:00',1.23),('11288','2013-03-26','08:15:00',1.22),('11288','2013-03-26','08:20:00',1.13),('11288','2013-03-26','08:25:00',1.23),('11288','2013-03-26','08:30:00',1.8),('11288','2013-03-26','08:35:00',2.71),('11288','2013-03-26','08:40:00',2.75),('11288','2013-03-26','08:45:00',1.48),('11288','2013-03-26','08:50:00',1.25),('11288','2013-03-26','08:55:00',1.18),('11288','2013-03-26','09:00:00',1.13),('11288','2013-03-26','09:05:00',1.37),('11288','2013-03-26','09:10:00',2.31),('11288','2013-03-26','09:15:00',3.26),('11288','2013-03-26','09:20:00',1.86),('11288','2013-03-26','09:25:00',1.13),('11288','2013-03-26','09:50:00',2.63),('11288','2013-03-26','09:55:00',4),('11288','2013-03-26','10:00:00',1.98),('11288','2013-03-26','10:05:00',1.29),('11288','2013-03-26','10:10:00',1.43),('11288','2013-03-26','10:20:00',1.15),('11288','2013-03-26','10:25:00',1.17),('11288','2013-03-26','10:40:00',1.02),('11288','2013-03-26','10:45:00',1.33),('11288','2013-03-26','10:50:00',2.14),('11288','2013-03-26','10:55:00',1.91),('11288','2013-03-26','11:00:00',2.17),('11288','2013-03-26','11:05:00',2.13),('11288','2013-03-26','11:10:00',3.9),('11288','2013-03-26','11:15:00',3.19),('11288','2013-03-26','11:20:00',3.31),('11288','2013-03-26','11:25:00',1.81),('11288','2013-03-26','11:30:00',1.09),('11288','2013-03-26','11:45:00',2.38),('11288','2013-03-26','11:50:00',4.03),('11288','2013-03-26','11:55:00',2.11),('11288','2013-03-26','12:00:00',2.71),('11288','2013-03-26','12:05:00',2.31),('11288','2013-03-26','12:10:00',2.55),('11288','2013-03-26','12:15:00',2.64),('11288','2013-03-26','12:20:00',2.86),('11288','2013-03-26','12:25:00',3.9),('11288','2013-03-26','12:30:00',3.48),('11288','2013-03-26','12:35:00',5.45),('11288','2013-03-26','12:40:00',3.83),('11288','2013-03-26','12:45:00',4.48),('11288','2013-03-26','12:50:00',2.87),('11288','2013-03-26','12:55:00',2.19),('11288','2013-03-26','13:00:00',3.79),('11288','2013-03-26','13:05:00',4.33),('11288','2013-03-26','13:10:00',4.71),('11288','2013-03-26','13:15:00',2.89),('11288','2013-03-26','13:20:00',3.28),('11288','2013-03-26','13:25:00',3.59),('11288','2013-03-26','13:30:00',3.02),('11288','2013-03-26','13:35:00',3.94),('11288','2013-03-26','13:40:00',4.03),('11288','2013-03-26','13:45:00',3.54),('11288','2013-03-26','13:50:00',3),('11288','2013-03-26','13:55:00',2.83),('11288','2013-03-26','14:00:00',2.77),('11288','2013-03-26','14:05:00',2.73),('11288','2013-03-26','14:10:00',2.82),('11288','2013-03-26','14:15:00',2.64),('11288','2013-03-26','14:20:00',2.26),('11288','2013-03-26','14:25:00',2.07),('11288','2013-03-26','14:30:00',1.66),('11288','2013-03-26','14:35:00',1.57),('11288','2013-03-26','14:40:00',1.68),('11288','2013-03-26','14:45:00',1.7),('11288','2013-03-26','14:50:00',1.56),('11288','2013-03-26','14:55:00',1.54),('11288','2013-03-26','15:00:00',1.55),('11288','2013-03-26','15:05:00',1.62),('11288','2013-03-26','15:10:00',1.52),('11288','2013-03-26','15:15:00',1.43),('11288','2013-03-26','15:20:00',1.55),('11288','2013-03-26','15:25:00',1.56),('11288','2013-03-26','15:30:00',1.69),('11288','2013-03-26','15:35:00',1.81),('11288','2013-03-26','15:40:00',1.55),('11288','2013-03-26','15:45:00',1.01),('11288','2013-03-25','08:10:00',1.24),('11288','2013-03-25','08:15:00',1.53),('11288','2013-03-25','08:20:00',2.09),('11288','2013-03-25','08:25:00',2.79),('11288','2013-03-25','08:30:00',1.83),('11288','2013-03-25','08:35:00',1.03),('11288','2013-03-25','08:40:00',1.42),('11288','2013-03-25','08:45:00',1.62),('11288','2013-03-25','08:50:00',1.83),('11288','2013-03-25','08:55:00',2.29),('11288','2013-03-25','09:00:00',2.03),('11288','2013-03-25','09:05:00',2.01),('11288','2013-03-25','09:10:00',2.23),('11288','2013-03-25','09:15:00',2.18),('11288','2013-03-25','09:20:00',4.16),('11288','2013-03-25','09:25:00',3.82),('11288','2013-03-25','09:30:00',2.74),('11288','2013-03-25','09:35:00',1.84),('11288','2013-03-25','09:40:00',1.25),('11288','2013-03-25','09:45:00',2.32),('11288','2013-03-25','09:50:00',7.17),('11288','2013-03-25','09:55:00',6.23),('11288','2013-03-25','10:00:00',1.99),('11288','2013-03-25','10:05:00',2.36),('11288','2013-03-25','10:10:00',2.15),('11288','2013-03-25','10:15:00',2.22),('11288','2013-03-25','10:20:00',2.99),('11288','2013-03-25','10:25:00',4.47),('11288','2013-03-25','10:30:00',3.96),('11288','2013-03-25','10:35:00',3.52),('11288','2013-03-25','10:40:00',3.42),('11288','2013-03-25','10:45:00',4.79),('11288','2013-03-25','10:50:00',5.25),('11288','2013-03-25','10:55:00',6.57),('11288','2013-03-25','11:00:00',4.27),('11288','2013-03-25','11:05:00',4.51),('11288','2013-03-25','11:10:00',4.78),('11288','2013-03-25','11:15:00',5.08),('11288','2013-03-25','11:20:00',6.72),('11288','2013-03-25','11:25:00',6.94),('11288','2013-03-25','11:30:00',8.16),('11288','2013-03-25','11:35:00',4.96),('11288','2013-03-25','11:40:00',2.45),('11288','2013-03-25','11:45:00',2.94),('11288','2013-03-25','11:50:00',3.45),('11288','2013-03-25','11:55:00',5.8),('11288','2013-03-25','12:00:00',8),('11288','2013-03-25','12:05:00',6.78),('11288','2013-03-25','12:10:00',7.14),('11288','2013-03-25','12:15:00',6.18),('11288','2013-03-25','12:20:00',5.1),('11288','2013-03-25','12:25:00',6.21),('11288','2013-03-25','12:30:00',5.44),('11288','2013-03-25','12:35:00',4.89),('11288','2013-03-25','12:40:00',4.76),('11288','2013-03-25','12:45:00',4.68),('11288','2013-03-25','12:50:00',4.99),('11288','2013-03-25','12:55:00',5.71),('11288','2013-03-25','13:00:00',6.36),('11288','2013-03-25','13:05:00',8.25),('11288','2013-03-25','13:10:00',6.78),('11288','2013-03-25','13:15:00',7.14),('11288','2013-03-25','13:20:00',4.67),('11288','2013-03-25','13:25:00',3.1),('11288','2013-03-25','13:30:00',2.86),('11288','2013-03-25','13:35:00',2.06),('11288','2013-03-25','13:40:00',2.34),('11288','2013-03-25','13:45:00',3.78),('11288','2013-03-25','13:50:00',3.41),('11288','2013-03-25','13:55:00',2.86),('11288','2013-03-25','14:00:00',1.75),('11288','2013-03-25','14:05:00',2.56),('11288','2013-03-25','14:10:00',5.43),('11288','2013-03-25','14:15:00',3.06),('11288','2013-03-25','14:20:00',4.63),('11288','2013-03-25','14:25:00',6.24),('11288','2013-03-25','14:30:00',4.8),('11288','2013-03-25','14:35:00',2.72),('11288','2013-03-25','14:40:00',2.59),('11288','2013-03-25','14:45:00',3.55),('11288','2013-03-25','14:50:00',3.09),('11288','2013-03-25','14:55:00',4.77),('11288','2013-03-25','15:00:00',4.82),('11288','2013-03-25','15:05:00',4.88),('11288','2013-03-25','15:10:00',5.48),('11288','2013-03-25','15:15:00',4.24),('11288','2013-03-25','15:20:00',3.39),('11288','2013-03-25','15:25:00',3.88),('11288','2013-03-25','15:30:00',4),('11288','2013-03-25','15:35:00',3.75),('11288','2013-03-25','15:40:00',4.73),('11288','2013-03-25','15:45:00',4.74),('11288','2013-03-25','15:50:00',2.6),('11288','2013-03-25','15:55:00',4.09),('11288','2013-03-25','16:00:00',3.16),('11288','2013-03-25','16:05:00',1.73),('11288','2013-03-25','16:10:00',2.07),('11288','2013-03-25','16:15:00',1.62),('11288','2013-03-25','16:20:00',1.27),('11288','2013-03-25','16:25:00',1.01),('11288','2013-03-25','16:30:00',2.63),('11288','2013-03-25','16:35:00',2.91),('11288','2013-03-25','16:40:00',2.4),('11288','2013-03-25','16:45:00',1.73),('11288','2013-03-25','16:50:00',1.42),('11288','2013-03-24','07:20:00',1.03),('11288','2013-03-24','07:25:00',1.12),('11288','2013-03-24','07:30:00',1.07),('11288','2013-03-24','07:35:00',1.23),('11288','2013-03-24','07:40:00',1.29),('11288','2013-03-24','07:45:00',1.39),('11288','2013-03-24','07:50:00',1.6),('11288','2013-03-24','07:55:00',1.75),('11288','2013-03-24','08:00:00',1.96),('11288','2013-03-24','08:05:00',2.29),('11288','2013-03-24','08:10:00',2.35),('11288','2013-03-24','08:15:00',2.53),('11288','2013-03-24','08:20:00',2.75),('11288','2013-03-24','08:25:00',2.83),('11288','2013-03-24','08:30:00',2.94),('11288','2013-03-24','08:35:00',3.11),('11288','2013-03-24','08:40:00',3.37),('11288','2013-03-24','08:45:00',3.54),('11288','2013-03-24','08:50:00',3.64),('11288','2013-03-24','08:55:00',3.77),('11288','2013-03-24','09:00:00',3.89),('11288','2013-03-24','09:05:00',4.05),('11288','2013-03-24','09:10:00',4.18),('11288','2013-03-24','09:15:00',4.32),('11288','2013-03-24','09:20:00',4.49),('11288','2013-03-24','09:25:00',4.62),('11288','2013-03-24','09:30:00',4.72),('11288','2013-03-24','09:35:00',4.8),('11288','2013-03-24','09:40:00',4.94),('11288','2013-03-24','09:45:00',5.03),('11288','2013-03-24','09:50:00',5.08),('11288','2013-03-24','09:55:00',5.15),('11288','2013-03-24','10:00:00',5.22),('11288','2013-03-24','10:05:00',5.34),('11288','2013-03-24','10:10:00',5.43),('11288','2013-03-24','10:15:00',5.49),('11288','2013-03-24','10:20:00',5.55),('11288','2013-03-24','10:25:00',5.6),('11288','2013-03-24','10:30:00',5.65),('11288','2013-03-24','10:35:00',5.7),('11288','2013-03-24','10:40:00',5.75),('11288','2013-03-24','10:45:00',5.79),('11288','2013-03-24','10:50:00',5.83),('11288','2013-03-24','10:55:00',5.86),('11288','2013-03-24','11:00:00',5.93),('11288','2013-03-24','11:05:00',5.97),('11288','2013-03-24','11:10:00',6.01),('11288','2013-03-24','11:15:00',6.09),('11288','2013-03-24','11:20:00',6.13),('11288','2013-03-24','11:25:00',6.17),('11288','2013-03-24','11:30:00',6.2),('11288','2013-03-24','11:35:00',6.2),('11288','2013-03-24','11:40:00',6.24),('11288','2013-03-24','11:45:00',6.19),('11288','2013-03-24','11:50:00',6.22),('11288','2013-03-24','11:55:00',6.23),('11288','2013-03-24','12:00:00',6.26),('11288','2013-03-24','12:05:00',6.37),('11288','2013-03-24','12:10:00',6.46),('11288','2013-03-24','12:15:00',6.56),('11288','2013-03-24','12:20:00',6.6),('11288','2013-03-24','12:25:00',6.63),('11288','2013-03-24','12:30:00',6.68),('11288','2013-03-24','12:35:00',6.71),('11288','2013-03-24','12:40:00',6.65),('11288','2013-03-24','12:45:00',6.67),('11288','2013-03-24','12:50:00',6.61),('11288','2013-03-24','12:55:00',6.56),('11288','2013-03-24','13:00:00',6.51),('11288','2013-03-24','13:05:00',6.55),('11288','2013-03-24','13:10:00',6.52),('11288','2013-03-24','13:15:00',6.48),('11288','2013-03-24','13:20:00',6.47),('11288','2013-03-24','13:25:00',6.34),('11288','2013-03-24','13:30:00',6.29),('11288','2013-03-24','13:35:00',6.21),('11288','2013-03-24','13:40:00',6.2),('11288','2013-03-24','13:45:00',6.16),('11288','2013-03-24','13:50:00',6.06),('11288','2013-03-24','13:55:00',6.02),('11288','2013-03-24','14:00:00',5.96),('11288','2013-03-24','14:05:00',5.84),('11288','2013-03-24','14:10:00',5.77),('11288','2013-03-24','14:15:00',5.69),('11288','2013-03-24','14:20:00',5.58),('11288','2013-03-24','14:25:00',5.45),('11288','2013-03-24','14:30:00',5.3),('11288','2013-03-24','14:35:00',5.16),('11288','2013-03-24','14:40:00',5.1),('11288','2013-03-24','14:45:00',5.02),('11288','2013-03-24','14:50:00',4.69),('11288','2013-03-24','14:55:00',4.74),('11288','2013-03-24','15:00:00',4.56),('11288','2013-03-24','15:05:00',4.42),('11288','2013-03-24','15:10:00',4.11),('11288','2013-03-24','15:15:00',4.51),('11288','2013-03-24','15:20:00',4.31),('11288','2013-03-24','15:25:00',3.97),('11288','2013-03-24','15:30:00',3.58),('11288','2013-03-24','15:35:00',3.56),('11288','2013-03-24','15:40:00',3.55),('11288','2013-03-24','15:45:00',2.82),('11288','2013-03-24','15:50:00',2.07),('11288','2013-03-24','15:55:00',2.02),('11288','2013-03-24','16:00:00',2.07),('11288','2013-03-24','16:05:00',2.36),('11288','2013-03-24','16:10:00',1.8),('11288','2013-03-24','16:15:00',2.35),('11288','2013-03-24','16:20:00',1.91),('11288','2013-03-24','16:25:00',1.83),('11288','2013-03-24','16:30:00',1.98),('11288','2013-03-24','16:35:00',1.75),('11288','2013-03-24','16:40:00',1.44),('11288','2013-03-24','16:45:00',1.45),('11288','2013-03-24','16:50:00',1.17),('11288','2013-03-23','07:20:00',1.03),('11288','2013-03-23','07:30:00',1.15),('11288','2013-03-23','07:35:00',1.2),('11288','2013-03-23','07:40:00',1.33),('11288','2013-03-23','07:45:00',1.4),('11288','2013-03-23','07:50:00',1.5),('11288','2013-03-23','07:55:00',1.7),('11288','2013-03-23','08:00:00',2.02),('11288','2013-03-23','08:05:00',2.22),('11288','2013-03-23','08:10:00',2.41),('11288','2013-03-23','08:15:00',2.57),('11288','2013-03-23','08:20:00',2.63),('11288','2013-03-23','08:25:00',2.74),('11288','2013-03-23','08:30:00',2.88),('11288','2013-03-23','08:35:00',2.98),('11288','2013-03-23','08:40:00',3.17),('11288','2013-03-23','08:45:00',3.46),('11288','2013-03-23','08:50:00',3.76),('11288','2013-03-23','08:55:00',4),('11288','2013-03-23','09:00:00',4.13),('11288','2013-03-23','09:05:00',4.32),('11288','2013-03-23','09:10:00',4.34),('11288','2013-03-23','09:15:00',4.49),('11288','2013-03-23','09:20:00',4.57),('11288','2013-03-23','09:25:00',4.76),('11288','2013-03-23','09:30:00',4.78),('11288','2013-03-23','09:35:00',4.99),('11288','2013-03-23','09:40:00',4.9),('11288','2013-03-23','09:45:00',5.14),('11288','2013-03-23','09:50:00',5.31),('11288','2013-03-23','09:55:00',5.4),('11288','2013-03-23','10:00:00',5.35),('11288','2013-03-23','10:05:00',5.49),('11288','2013-03-23','10:10:00',5.74),('11288','2013-03-23','10:15:00',5.68),('11288','2013-03-23','10:20:00',5.53),('11288','2013-03-23','10:25:00',5.66),('11288','2013-03-23','10:30:00',5.9),('11288','2013-03-23','10:35:00',5.91),('11288','2013-03-23','10:40:00',5.89),('11288','2013-03-23','10:45:00',5.85),('11288','2013-03-23','10:50:00',5.79),('11288','2013-03-23','10:55:00',5.71),('11288','2013-03-23','11:00:00',5.74),('11288','2013-03-23','11:05:00',5.49),('11288','2013-03-23','11:10:00',5.01),('11288','2013-03-23','11:15:00',4.81),('11288','2013-03-23','11:20:00',5.81),('11288','2013-03-23','11:25:00',5.99),('11288','2013-03-23','11:30:00',6.01),('11288','2013-03-23','11:35:00',6.31),('11288','2013-03-23','11:40:00',6.26),('11288','2013-03-23','11:45:00',6.23),('11288','2013-03-23','11:50:00',6.01),('11288','2013-03-23','11:55:00',6.33),('11288','2013-03-23','12:00:00',6.37),('11288','2013-03-23','12:05:00',6.31),('11288','2013-03-23','12:10:00',6.52),('11288','2013-03-23','12:15:00',6.56),('11288','2013-03-23','12:20:00',6.61),('11288','2013-03-23','12:25:00',6.41),('11288','2013-03-23','12:30:00',6.52),('11288','2013-03-23','12:35:00',6.5),('11288','2013-03-23','12:40:00',6.29),('11288','2013-03-23','12:45:00',6.43),('11288','2013-03-23','12:50:00',6.46),('11288','2013-03-23','12:55:00',6.12),('11288','2013-03-23','13:00:00',5.3),('11288','2013-03-23','13:05:00',6.35),('11288','2013-03-23','13:10:00',6.36),('11288','2013-03-23','13:15:00',6.23),('11288','2013-03-23','13:20:00',6.25),('11288','2013-03-23','13:25:00',6.09),('11288','2013-03-23','13:30:00',5.99),('11288','2013-03-23','13:35:00',6.19),('11288','2013-03-23','13:40:00',6.1),('11288','2013-03-23','13:45:00',6.1),('11288','2013-03-23','13:50:00',5.99),('11288','2013-03-23','13:55:00',5.81),('11288','2013-03-23','14:00:00',5.69),('11288','2013-03-23','14:05:00',5.73),('11288','2013-03-23','14:10:00',5.49),('11288','2013-03-23','14:15:00',5.35),('11288','2013-03-23','14:20:00',5.55),('11288','2013-03-23','14:25:00',5.41),('11288','2013-03-23','14:30:00',5.43),('11288','2013-03-23','14:35:00',5.28),('11288','2013-03-23','14:40:00',5.09),('11288','2013-03-23','14:45:00',4.81),('11288','2013-03-23','14:50:00',4.76),('11288','2013-03-23','14:55:00',4.87),('11288','2013-03-23','15:00:00',4.68),('11288','2013-03-23','15:05:00',4.36),('11288','2013-03-23','15:10:00',4.43),('11288','2013-03-23','15:15:00',4.14),('11288','2013-03-23','15:20:00',4.18),('11288','2013-03-23','15:25:00',4.02),('11288','2013-03-23','15:30:00',3.71),('11288','2013-03-23','15:35:00',3.66),('11288','2013-03-23','15:40:00',3.51),('11288','2013-03-23','15:45:00',3.19),('11288','2013-03-23','15:50:00',3.06),('11288','2013-03-23','15:55:00',2.98),('11288','2013-03-23','16:00:00',2.74),('11288','2013-03-23','16:05:00',2.58),('11288','2013-03-23','16:10:00',3.09),('11288','2013-03-23','16:15:00',2.71),('11288','2013-03-23','16:20:00',2.36),('11288','2013-03-23','16:25:00',2.32),('11288','2013-03-23','16:30:00',1.77),('11288','2013-03-23','16:35:00',1.9),('11288','2013-03-23','16:40:00',1.66),('11288','2013-03-23','16:45:00',1.63),('11288','2013-03-23','16:50:00',1.37),('11288','2013-03-23','16:55:00',1.36),('11288','2013-03-23','17:00:00',1.56),('11288','2013-03-23','17:05:00',1.51),('11288','2013-03-23','17:10:00',1.32),('11288','2013-03-23','17:15:00',1.07),('11288','2014-03-26','07:20:00',1.02),('11288','2014-03-26','07:25:00',1.06),('11288','2014-03-26','07:30:00',1.25),('11288','2014-03-26','07:35:00',1.42),('11288','2014-03-26','07:40:00',1.58),('11288','2014-03-26','07:45:00',1.71),('11288','2014-03-26','07:50:00',1.74),('11288','2014-03-26','07:55:00',1.82),('11288','2014-03-26','08:00:00',2.1),('11288','2014-03-26','08:05:00',2.25),('11288','2014-03-26','08:10:00',2.49),('11288','2014-03-26','08:15:00',2.95),('11288','2014-03-26','08:20:00',2.46),('11288','2014-03-26','08:25:00',2.03),('11288','2014-03-26','08:30:00',1.85),('11288','2014-03-26','08:35:00',1.58),('11288','2014-03-26','08:40:00',1.87),('11288','2014-03-26','08:45:00',2.02),('11288','2014-03-26','08:50:00',2.39),('11288','2014-03-26','08:55:00',2.12),('11288','2014-03-26','09:00:00',2.38),('11288','2014-03-26','09:05:00',2.24),('11288','2014-03-26','09:10:00',2.63),('11288','2014-03-26','09:15:00',2.16),('11288','2014-03-26','09:20:00',1.76),('11288','2014-03-26','09:25:00',3.32),('11288','2014-03-26','09:30:00',4.84),('11288','2014-03-26','09:35:00',5.11),('11288','2014-03-26','09:40:00',5.17),('11288','2014-03-26','09:45:00',5.25),('11288','2014-03-26','09:50:00',5.31),('11288','2014-03-26','09:55:00',5.48),('11288','2014-03-26','10:00:00',5.8),('11288','2014-03-26','10:05:00',3.8),('11288','2014-03-26','10:10:00',6.36),('11288','2014-03-26','10:15:00',5.35),('11288','2014-03-26','10:20:00',3.47),('11288','2014-03-26','10:25:00',5.52),('11288','2014-03-26','10:30:00',4.38),('11288','2014-03-26','10:35:00',2.28),('11288','2014-03-26','10:40:00',1.43),('11288','2014-03-26','10:45:00',2.55),('11288','2014-03-26','10:50:00',4.89),('11288','2014-03-26','10:55:00',7.95),('11288','2014-03-26','11:00:00',5.33),('11288','2014-03-26','11:05:00',2.45),('11288','2014-03-26','11:10:00',6.77),('11288','2014-03-26','11:15:00',8.49),('11288','2014-03-26','11:20:00',2.94),('11288','2014-03-26','11:25:00',2.17),('11288','2014-03-26','11:30:00',2.92),('11288','2014-03-26','11:35:00',2.96),('11288','2014-03-26','11:40:00',3.3),('11288','2014-03-26','11:45:00',7.15),('11288','2014-03-26','11:50:00',6.23),('11288','2014-03-26','11:55:00',8.02),('11288','2014-03-26','12:00:00',7.36),('11288','2014-03-26','12:05:00',6.66),('11288','2014-03-26','12:10:00',5.7),('11288','2014-03-26','12:15:00',2.86),('11288','2014-03-26','12:20:00',3.25),('11288','2014-03-26','12:25:00',2.99),('11288','2014-03-26','12:30:00',2.98),('11288','2014-03-26','12:35:00',2.85),('11288','2014-03-26','12:40:00',3.68),('11288','2014-03-26','12:45:00',3.52),('11288','2014-03-26','12:50:00',2.68),('11288','2014-03-26','12:55:00',2.1),('11288','2014-03-26','13:00:00',2.36),('11288','2014-03-26','13:05:00',2.15),('11288','2014-03-26','13:10:00',1.67),('11288','2014-03-26','13:15:00',1.38),('11288','2014-03-26','13:20:00',6.29),('11288','2014-03-26','13:25:00',7.35),('11288','2014-03-26','13:30:00',5.33),('11288','2014-03-26','13:35:00',3.28),('11288','2014-03-26','13:40:00',2),('11288','2014-03-26','13:45:00',1.62),('11288','2014-03-26','13:50:00',1.72),('11288','2014-03-26','13:55:00',2.86),('11288','2014-03-26','14:00:00',7.79),('11288','2014-03-26','14:05:00',7.66),('11288','2014-03-26','14:10:00',3.75),('11288','2014-03-26','14:15:00',1.88),('11288','2014-03-26','14:20:00',1.72),('11288','2014-03-26','14:25:00',1.48),('11288','2014-03-26','14:30:00',1.3),('11288','2014-03-26','14:35:00',1.14),('11288','2014-03-26','14:40:00',1.63),('11288','2014-03-26','14:45:00',4.43),('11288','2014-03-26','14:50:00',5.12),('11288','2014-03-26','14:55:00',5.62),('11288','2014-03-26','15:00:00',4.89),('11288','2014-03-26','15:05:00',4.97),('11288','2014-03-26','15:10:00',5.07),('11288','2014-03-26','15:15:00',5.3),('11288','2014-03-26','15:20:00',4.86),('11288','2014-03-26','15:25:00',4.86),('11288','2014-03-26','15:30:00',4.88),('11288','2014-03-26','15:35:00',4.56),('11288','2014-03-26','15:40:00',3.76),('11288','2014-03-26','15:45:00',3.43),('11288','2014-03-26','15:50:00',2.64),('11288','2014-03-26','15:55:00',2.4),('11288','2014-03-26','16:00:00',2.07),('11288','2014-03-26','16:05:00',1.78),('11288','2014-03-26','16:10:00',2.21),('11288','2014-03-26','16:15:00',2.38),('11288','2014-03-26','16:20:00',1.9),('11288','2014-03-26','16:25:00',1.47),('11288','2014-03-26','16:30:00',1.19),('11288','2014-03-26','16:35:00',1.14),('11288','2013-03-22','07:30:00',1.04),('11288','2013-03-22','07:35:00',1.25),('11288','2013-03-22','07:40:00',1.33),('11288','2013-03-22','07:45:00',1.49),('11288','2013-03-22','07:50:00',1.6),('11288','2013-03-22','07:55:00',1.68),('11288','2013-03-22','08:00:00',1.94),('11288','2013-03-22','08:05:00',2.14),('11288','2013-03-22','08:10:00',2.32),('11288','2013-03-22','08:15:00',2.51),('11288','2013-03-22','08:20:00',2.59),('11288','2013-03-22','08:25:00',2.77),('11288','2013-03-22','08:30:00',2.83),('11288','2013-03-22','08:35:00',3.09),('11288','2013-03-22','08:40:00',3.29),('11288','2013-03-22','08:45:00',3.43),('11288','2013-03-22','08:50:00',3.71),('11288','2013-03-22','08:55:00',3.9),('11288','2013-03-22','09:00:00',4.01),('11288','2013-03-22','09:05:00',4.17),('11288','2013-03-22','09:10:00',4.27),('11288','2013-03-22','09:15:00',4.36),('11288','2013-03-22','09:20:00',4.53),('11288','2013-03-22','09:25:00',4.69),('11288','2013-03-22','09:30:00',4.82),('11288','2013-03-22','09:35:00',4.92),('11288','2013-03-22','09:40:00',5.08),('11288','2013-03-22','09:45:00',5.13),('11288','2013-03-22','09:50:00',5.2),('11288','2013-03-22','09:55:00',5.31),('11288','2013-03-22','10:00:00',5.4),('11288','2013-03-22','10:05:00',5.45),('11288','2013-03-22','10:10:00',5.52),('11288','2013-03-22','10:15:00',5.57),('11288','2013-03-22','10:20:00',5.73),('11288','2013-03-22','10:25:00',5.84),('11288','2013-03-22','10:30:00',5.87),('11288','2013-03-22','10:35:00',5.93),('11288','2013-03-22','10:40:00',5.99),('11288','2013-03-22','10:45:00',6.03),('11288','2013-03-22','10:50:00',6.12),('11288','2013-03-22','10:55:00',6.14),('11288','2013-03-22','11:00:00',6.24),('11288','2013-03-22','11:05:00',6.29),('11288','2013-03-22','11:10:00',6.33),('11288','2013-03-22','11:15:00',6.43),('11288','2013-03-22','11:20:00',6.5),('11288','2013-03-22','11:25:00',6.52),('11288','2013-03-22','11:30:00',6.6),('11288','2013-03-22','11:35:00',6.59),('11288','2013-03-22','11:40:00',6.68),('11288','2013-03-22','11:45:00',6.67),('11288','2013-03-22','11:50:00',6.69),('11288','2013-03-22','11:55:00',6.71),('11288','2013-03-22','12:00:00',6.72),('11288','2013-03-22','12:05:00',6.72),('11288','2013-03-22','12:10:00',6.76),('11288','2013-03-22','12:15:00',6.73),('11288','2013-03-22','12:20:00',6.74),('11288','2013-03-22','12:25:00',6.77),('11288','2013-03-22','12:30:00',6.75),('11288','2013-03-22','12:35:00',6.78),('11288','2013-03-22','12:40:00',6.72),('11288','2013-03-22','12:45:00',6.71),('11288','2013-03-22','12:50:00',6.59),('11288','2013-03-22','12:55:00',6.54),('11288','2013-03-22','13:00:00',6.66),('11288','2013-03-22','13:05:00',6.63),('11288','2013-03-22','13:10:00',6.65),('11288','2013-03-22','13:15:00',6.59),('11288','2013-03-22','13:20:00',6.52),('11288','2013-03-22','13:25:00',6.11),('11288','2013-03-22','13:30:00',6.04),('11288','2013-03-22','13:35:00',6.37),('11288','2013-03-22','13:40:00',5.57),('11288','2013-03-22','13:45:00',5.95),('11288','2013-03-22','13:50:00',6.3),('11288','2013-03-22','13:55:00',6.15),('11288','2013-03-22','14:00:00',6.03),('11288','2013-03-22','14:05:00',5.97),('11288','2013-03-22','14:10:00',5.92),('11288','2013-03-22','14:15:00',5.84),('11288','2013-03-22','14:20:00',5.72),('11288','2013-03-22','14:25:00',5.69),('11288','2013-03-22','14:30:00',5.59),('11288','2013-03-22','14:35:00',5.43),('11288','2013-03-22','14:40:00',5.36),('11288','2013-03-22','14:45:00',5.26),('11288','2013-03-22','14:50:00',5.14),('11288','2013-03-22','14:55:00',5.03),('11288','2013-03-22','15:00:00',4.91),('11288','2013-03-22','15:05:00',4.78),('11288','2013-03-22','15:10:00',4.18),('11288','2013-03-22','15:15:00',3.52),('11288','2013-03-22','15:20:00',3.27),('11288','2013-03-22','15:25:00',3.42),('11288','2013-03-22','15:30:00',3.34),('11288','2013-03-22','15:35:00',3.68),('11288','2013-03-22','15:40:00',3.45),('11288','2013-03-22','15:45:00',3.06),('11288','2013-03-22','15:50:00',3.32),('11288','2013-03-22','15:55:00',2.85),('11288','2013-03-22','16:00:00',2.25),('11288','2013-03-22','16:05:00',2.3),('11288','2013-03-22','16:10:00',2.62),('11288','2013-03-22','16:15:00',2.97),('11288','2013-03-22','16:20:00',2.42),('11288','2013-03-22','16:25:00',2.42),('11288','2013-03-22','16:30:00',2.6),('11288','2013-03-22','16:35:00',2.5),('11288','2013-03-22','16:40:00',2.4),('11288','2013-03-22','16:45:00',2.17),('11288','2013-03-22','16:50:00',2.07),('11288','2013-03-22','16:55:00',1.93),('11288','2013-03-22','17:00:00',1.7),('11288','2013-03-22','17:05:00',1.44),('11288','2013-03-22','17:10:00',1.29),('11288','2013-03-22','17:15:00',1.15),('11288','2013-03-22','17:20:00',1.04),('11288','2013-03-21','07:30:00',1.07),('11288','2013-03-21','07:40:00',1.3),('11288','2013-03-21','07:45:00',1.34),('11288','2013-03-21','07:50:00',1.77),('11288','2013-03-21','07:55:00',1.42),('11288','2013-03-21','08:00:00',1.1),('11288','2013-03-21','08:10:00',1.52),('11288','2013-03-21','08:15:00',2.15),('11288','2013-03-21','08:20:00',2.44),('11288','2013-03-21','08:25:00',2.63),('11288','2013-03-21','08:30:00',2.01),('11288','2013-03-21','08:35:00',2.71),('11288','2013-03-21','08:40:00',3.04),('11288','2013-03-21','08:45:00',1.98),('11288','2013-03-21','08:50:00',2.95),('11288','2013-03-21','08:55:00',4.08),('11288','2013-03-21','09:00:00',4.29),('11288','2013-03-21','09:05:00',4.94),('11288','2013-03-21','09:10:00',4.49),('11288','2013-03-21','09:15:00',3.23),('11288','2013-03-21','09:20:00',3.03),('11288','2013-03-21','09:25:00',2.77),('11288','2013-03-21','09:30:00',2.94),('11288','2013-03-21','09:35:00',5.18),('11288','2013-03-21','09:40:00',4.69),('11288','2013-03-21','09:45:00',5.57),('11288','2013-03-21','09:50:00',5.64),('11288','2013-03-21','09:55:00',5.76),('11288','2013-03-21','10:00:00',5.8),('11288','2013-03-21','10:05:00',5.85),('11288','2013-03-21','10:10:00',5.91),('11288','2013-03-21','10:15:00',5.97),('11288','2013-03-21','10:20:00',6),('11288','2013-03-21','10:25:00',6.07),('11288','2013-03-21','10:30:00',6.15),('11288','2013-03-21','10:35:00',6.25),('11288','2013-03-21','10:40:00',6.24),('11288','2013-03-21','10:45:00',6.22),('11288','2013-03-21','10:50:00',6.25),('11288','2013-03-21','10:55:00',5.99),('11288','2013-03-21','11:00:00',6.41),('11288','2013-03-21','11:05:00',6.5),('11288','2013-03-21','11:10:00',6.53),('11288','2013-03-21','11:15:00',6.68),('11288','2013-03-21','11:20:00',6.79),('11288','2013-03-21','11:25:00',6.88),('11288','2013-03-21','11:30:00',6.92),('11288','2013-03-21','11:35:00',6.93),('11288','2013-03-21','11:40:00',6.98),('11288','2013-03-21','11:45:00',7.04),('11288','2013-03-21','11:50:00',7.08),('11288','2013-03-21','11:55:00',7.09),('11288','2013-03-21','12:00:00',7.09),('11288','2013-03-21','12:05:00',7.09),('11288','2013-03-21','12:10:00',7.11),('11288','2013-03-21','12:15:00',7.11),('11288','2013-03-21','12:20:00',7.03),('11288','2013-03-21','12:25:00',7.13),('11288','2013-03-21','12:30:00',7.13),('11288','2013-03-21','12:35:00',7.08),('11288','2013-03-21','12:40:00',7.06),('11288','2013-03-21','12:45:00',6.95),('11288','2013-03-21','12:50:00',6.91),('11288','2013-03-21','12:55:00',6.84),('11288','2013-03-21','13:00:00',6.88),('11288','2013-03-21','13:05:00',6.82),('11288','2013-03-21','13:10:00',6.79),('11288','2013-03-21','13:15:00',6.75),('11288','2013-03-21','13:20:00',6.72),('11288','2013-03-21','13:25:00',6.66),('11288','2013-03-21','13:30:00',6.58),('11288','2013-03-21','13:35:00',6.54),('11288','2013-03-21','13:40:00',6.51),('11288','2013-03-21','13:45:00',6.46),('11288','2013-03-21','13:50:00',6.41),('11288','2013-03-21','13:55:00',6.34),('11288','2013-03-21','14:00:00',6.23),('11288','2013-03-21','14:05:00',6.13),('11288','2013-03-21','14:10:00',6.06),('11288','2013-03-21','14:15:00',5.98),('11288','2013-03-21','14:20:00',5.86),('11288','2013-03-21','14:25:00',5.76),('11288','2013-03-21','14:30:00',5.66),('11288','2013-03-21','14:35:00',5.55),('11288','2013-03-21','14:40:00',5.43),('11288','2013-03-21','14:45:00',5.36),('11288','2013-03-21','14:50:00',5.24),('11288','2013-03-21','14:55:00',5.13),('11288','2013-03-21','15:00:00',5.03),('11288','2013-03-21','15:05:00',4.9),('11288','2013-03-21','15:10:00',4.72),('11288','2013-03-21','15:15:00',4.63),('11288','2013-03-21','15:20:00',4.52),('11288','2013-03-21','15:25:00',4.34),('11288','2013-03-21','15:30:00',4.21),('11288','2013-03-21','15:35:00',4.09),('11288','2013-03-21','15:40:00',3.91),('11288','2013-03-21','15:45:00',3.75),('11288','2013-03-21','15:50:00',3.61),('11288','2013-03-21','15:55:00',3.44),('11288','2013-03-21','16:00:00',3.3),('11288','2013-03-21','16:05:00',3.14),('11288','2013-03-21','16:10:00',2.99),('11288','2013-03-21','16:15:00',2.82),('11288','2013-03-21','16:20:00',2.67),('11288','2013-03-21','16:25:00',2.47),('11288','2013-03-21','16:30:00',2.31),('11288','2013-03-21','16:35:00',2.15),('11288','2013-03-21','16:40:00',1.99),('11288','2013-03-21','16:45:00',1.87),('11288','2013-03-21','16:50:00',1.71),('11288','2013-03-21','16:55:00',1.52),('11288','2013-03-21','17:00:00',1.38),('11288','2013-03-21','17:05:00',1.22),('11288','2013-03-21','17:10:00',1.09),('11288','2013-03-20','07:30:00',1.1),('11288','2013-03-20','07:35:00',1.19),('11288','2013-03-20','07:40:00',1.2),('11288','2013-03-20','07:45:00',1.37),('11288','2013-03-20','07:50:00',1.4),('11288','2013-03-20','07:55:00',2.09),('11288','2013-03-20','08:00:00',1.66),('11288','2013-03-20','08:05:00',1.83),('11288','2013-03-20','08:10:00',2.19),('11288','2013-03-20','08:15:00',2.39),('11288','2013-03-20','08:20:00',2.58),('11288','2013-03-20','08:25:00',2.74),('11288','2013-03-20','08:30:00',2.93),('11288','2013-03-20','08:35:00',3.05),('11288','2013-03-20','08:40:00',3.06),('11288','2013-03-20','08:45:00',3.34),('11288','2013-03-20','08:50:00',3.54),('11288','2013-03-20','08:55:00',3.58),('11288','2013-03-20','09:00:00',3.83),('11288','2013-03-20','09:05:00',4.81),('11288','2013-03-20','09:10:00',4.17),('11288','2013-03-20','09:15:00',4.24),('11288','2013-03-20','09:20:00',4.44),('11288','2013-03-20','09:25:00',4.66),('11288','2013-03-20','09:30:00',4.76),('11288','2013-03-20','09:35:00',4.65),('11288','2013-03-20','09:40:00',4.97),('11288','2013-03-20','09:45:00',5.07),('11288','2013-03-20','09:50:00',5.16),('11288','2013-03-20','09:55:00',5.15),('11288','2013-03-20','10:00:00',5.34),('11288','2013-03-20','10:05:00',5.33),('11288','2013-03-20','10:10:00',4.52),('11288','2013-03-20','10:15:00',5.54),('11288','2013-03-20','10:20:00',4.07),('11288','2013-03-20','10:25:00',4.03),('11288','2013-03-20','10:30:00',4.53),('11288','2013-03-20','10:35:00',5.37),('11288','2013-03-20','10:40:00',4.27),('11288','2013-03-20','10:45:00',4.45),('11288','2013-03-20','10:50:00',4.64),('11288','2013-03-20','10:55:00',4.68),('11288','2013-03-20','11:00:00',4.83),('11288','2013-03-20','11:05:00',5.49),('11288','2013-03-20','11:10:00',4.01),('11288','2013-03-20','11:15:00',4.06),('11288','2013-03-20','11:20:00',4.57),('11288','2013-03-20','11:25:00',4.41),('11288','2013-03-20','11:30:00',4.13),('11288','2013-03-20','11:35:00',4.56),('11288','2013-03-20','11:40:00',3.68),('11288','2013-03-20','11:45:00',3.58),('11288','2013-03-20','11:50:00',3.54),('11288','2013-03-20','11:55:00',3.8),('11288','2013-03-20','12:00:00',3.81),('11288','2013-03-20','12:05:00',4.16),('11288','2013-03-20','12:10:00',3.42),('11288','2013-03-20','12:15:00',2.98),('11288','2013-03-20','12:20:00',2.72),('11288','2013-03-20','12:25:00',2.31),('11288','2013-03-20','12:30:00',1.94),('11288','2013-03-20','12:35:00',2.56),('11288','2013-03-20','12:40:00',1.74),('11288','2013-03-20','12:45:00',2.02),('11288','2013-03-20','12:50:00',2.72),('11288','2013-03-20','12:55:00',3.23),('11288','2013-03-20','13:00:00',3.31),('11288','2013-03-20','13:05:00',2.64),('11288','2013-03-20','13:10:00',2.55),('11288','2013-03-20','13:15:00',2.17),('11288','2013-03-20','13:20:00',2.31),('11288','2013-03-20','13:25:00',2.44),('11288','2013-03-20','13:30:00',2.63),('11288','2013-03-20','13:35:00',2.53),('11288','2013-03-20','13:40:00',3.19),('11288','2013-03-20','13:45:00',3.59),('11288','2013-03-20','13:50:00',3.03),('11288','2013-03-20','13:55:00',2.86),('11288','2013-03-20','14:00:00',2.84),('11288','2013-03-20','14:05:00',2.43),('11288','2013-03-20','14:10:00',2.33),('11288','2013-03-20','14:15:00',3.16),('11288','2013-03-20','14:20:00',3.75),('11288','2013-03-20','14:25:00',3.42),('11288','2013-03-20','14:30:00',2.99),('11288','2013-03-20','14:35:00',2.47),('11288','2013-03-20','14:40:00',1.98),('11288','2013-03-20','14:45:00',1.93),('11288','2013-03-20','14:50:00',1.53),('11288','2013-03-20','14:55:00',1.26),('11288','2013-03-20','15:00:00',1.38),('11288','2013-03-20','15:05:00',1.25),('11288','2013-03-20','15:10:00',1.12),('11288','2013-03-20','15:30:00',1.14),('11288','2013-03-19','07:05:00',1.08),('11288','2013-03-19','07:15:00',1.18),('11288','2013-03-19','07:35:00',1.09),('11288','2013-03-19','07:40:00',1.22),('11288','2013-03-19','07:45:00',1.38),('11288','2013-03-19','07:50:00',1.56),('11288','2013-03-19','07:55:00',1.59),('11288','2013-03-19','08:00:00',1.31),('11288','2013-03-19','08:05:00',1.71),('11288','2013-03-19','08:10:00',2.18),('11288','2013-03-19','08:15:00',2.39),('11288','2013-03-19','08:20:00',2.54),('11288','2013-03-19','08:25:00',2.59),('11288','2013-03-19','08:30:00',2.78),('11288','2013-03-19','08:35:00',2.62),('11288','2013-03-19','08:40:00',3.03),('11288','2013-03-19','08:45:00',3.22),('11288','2013-03-19','08:50:00',3.26),('11288','2013-03-19','08:55:00',3.75),('11288','2013-03-19','09:00:00',3.87),('11288','2013-03-19','09:05:00',4.03),('11288','2013-03-19','09:10:00',4.18),('11288','2013-03-19','09:15:00',4.36),('11288','2013-03-19','09:20:00',3.39),('11288','2013-03-19','09:25:00',4.39),('11288','2013-03-19','09:30:00',4.89),('11288','2013-03-19','09:35:00',4.89),('11288','2013-03-19','09:40:00',5.1),('11288','2013-03-19','09:45:00',4.75),('11288','2013-03-19','09:50:00',4.53),('11288','2013-03-19','09:55:00',5.09),('11288','2013-03-19','10:00:00',4.33),('11288','2013-03-19','10:05:00',5.55),('11288','2013-03-19','10:10:00',5.71),('11288','2013-03-19','10:15:00',5.75),('11288','2013-03-19','10:20:00',5.65),('11288','2013-03-19','10:25:00',4.48),('11288','2013-03-19','10:30:00',6.01),('11288','2013-03-19','10:35:00',6.07),('11288','2013-03-19','10:40:00',6.1),('11288','2013-03-19','10:45:00',6.21),('11288','2013-03-19','10:50:00',6.28),('11288','2013-03-19','10:55:00',6.38),('11288','2013-03-19','11:00:00',6.47),('11288','2013-03-19','11:05:00',6.45),('11288','2013-03-19','11:10:00',6.19),('11288','2013-03-19','11:15:00',6.57),('11288','2013-03-19','11:20:00',6.63),('11288','2013-03-19','11:25:00',6.6),('11288','2013-03-19','11:30:00',6.72),('11288','2013-03-19','11:35:00',4.06),('11288','2013-03-19','11:40:00',6.41),('11288','2013-03-19','11:45:00',6.13),('11288','2013-03-19','11:50:00',7.11),('11288','2013-03-19','11:55:00',6.95),('11288','2013-03-19','12:00:00',6.88),('11288','2013-03-19','12:05:00',6.82),('11288','2013-03-19','12:10:00',6.78),('11288','2013-03-19','12:15:00',6.5),('11288','2013-03-19','12:20:00',6.83),('11288','2013-03-19','12:25:00',6.65),('11288','2013-03-19','12:30:00',6.63),('11288','2013-03-19','12:35:00',6.78),('11288','2013-03-19','12:40:00',6.74),('11288','2013-03-19','12:45:00',6.58),('11288','2013-03-19','12:50:00',6.81),('11288','2013-03-19','12:55:00',6.78),('11288','2013-03-19','13:00:00',6.66),('11288','2013-03-19','13:05:00',6.61),('11288','2013-03-19','13:10:00',6.57),('11288','2013-03-19','13:15:00',6.49),('11288','2013-03-19','13:20:00',6.48),('11288','2013-03-19','13:25:00',6.42),('11288','2013-03-19','13:30:00',6.4),('11288','2013-03-19','13:35:00',6.32),('11288','2013-03-19','13:40:00',6.13),('11288','2013-03-19','13:45:00',6.21),('11288','2013-03-19','13:50:00',6.17),('11288','2013-03-19','13:55:00',6.07),('11288','2013-03-19','14:00:00',6.01),('11288','2013-03-19','14:05:00',5.92),('11288','2013-03-19','14:10:00',5.8),('11288','2013-03-19','14:15:00',5.75),('11288','2013-03-19','14:20:00',5.7),('11288','2013-03-19','14:25:00',5.61),('11288','2013-03-19','14:30:00',5.51),('11288','2013-03-19','14:35:00',5.42),('11288','2013-03-19','14:40:00',5.31),('11288','2013-03-19','14:45:00',5.18),('11288','2013-03-19','14:50:00',5.06),('11288','2013-03-19','14:55:00',4.94),('11288','2013-03-19','15:00:00',4.85),('11288','2013-03-19','15:05:00',4.68),('11288','2013-03-19','15:10:00',4.56),('11288','2013-03-19','15:15:00',4.44),('11288','2013-03-19','15:20:00',4.33),('11288','2013-03-19','15:25:00',4.17),('11288','2013-03-19','15:30:00',4.07),('11288','2013-03-19','15:35:00',3.93),('11288','2013-03-19','15:40:00',3.77),('11288','2013-03-19','15:45:00',3.64),('11288','2013-03-19','15:50:00',3.5),('11288','2013-03-19','15:55:00',3.33),('11288','2013-03-19','16:00:00',3.18),('11288','2013-03-19','16:05:00',3.01),('11288','2013-03-19','16:10:00',2.86),('11288','2013-03-19','16:15:00',2.67),('11288','2013-03-19','16:20:00',2.5),('11288','2013-03-19','16:25:00',2.34),('11288','2013-03-19','16:30:00',2.22),('11288','2013-03-19','16:35:00',2.08),('11288','2013-03-19','16:40:00',1.91),('11288','2013-03-19','16:45:00',1.57),('11288','2013-03-19','16:50:00',1.26),('11288','2013-03-19','16:55:00',1.36),('11288','2013-03-19','17:00:00',1.06),('11288','2013-03-19','17:15:00',1.08),('11288','2013-03-18','08:20:00',1.06),('11288','2013-03-18','08:25:00',1.22),('11288','2013-03-18','08:30:00',1.34),('11288','2013-03-18','08:35:00',1.26),('11288','2013-03-18','08:40:00',1.25),('11288','2013-03-18','08:45:00',1.77),('11288','2013-03-18','08:50:00',1.47),('11288','2013-03-18','08:55:00',1.27),('11288','2013-03-18','09:35:00',1.07),('11288','2013-03-18','09:40:00',1.23),('11288','2013-03-18','09:45:00',1.3),('11288','2013-03-18','09:50:00',1.37),('11288','2013-03-18','09:55:00',1.9),('11288','2013-03-18','10:00:00',2.35),('11288','2013-03-18','10:05:00',2.78),('11288','2013-03-18','10:10:00',2.72),('11288','2013-03-18','10:15:00',2.37),('11288','2013-03-18','10:20:00',2.81),('11288','2013-03-18','10:25:00',3.34),('11288','2013-03-18','10:30:00',3.22),('11288','2013-03-18','10:35:00',2.78),('11288','2013-03-18','10:40:00',2.63),('11288','2013-03-18','10:45:00',2.76),('11288','2013-03-18','10:50:00',2.59),('11288','2013-03-18','10:55:00',2.16),('11288','2013-03-18','11:00:00',2.36),('11288','2013-03-18','11:05:00',2.6),('11288','2013-03-18','11:10:00',2.95),('11288','2013-03-18','11:15:00',3.22),('11288','2013-03-18','11:20:00',3.3),('11288','2013-03-18','11:25:00',3.51),('11288','2013-03-18','11:30:00',4.28),('11288','2013-03-18','11:35:00',3.56),('11288','2013-03-18','11:40:00',3.3),('11288','2013-03-18','11:45:00',2.8),('11288','2013-03-18','11:50:00',2.34),('11288','2013-03-18','11:55:00',2.83),('11288','2013-03-18','12:00:00',2.92),('11288','2013-03-18','12:05:00',4.97),('11288','2013-03-18','12:10:00',4.76),('11288','2013-03-18','12:15:00',5.43),('11288','2013-03-18','12:20:00',5.02),('11288','2013-03-18','12:25:00',4.04),('11288','2013-03-18','12:30:00',5.73),('11288','2013-03-18','12:35:00',6.76),('11288','2013-03-18','12:40:00',4.89),('11288','2013-03-18','12:45:00',4.83),('11288','2013-03-18','12:50:00',6.32),('11288','2013-03-18','12:55:00',6.78),('11288','2013-03-18','13:00:00',6.6),('11288','2013-03-18','13:05:00',3.09),('11288','2013-03-18','13:10:00',2.3),('11288','2013-03-18','13:15:00',1.69),('11288','2013-03-18','13:20:00',2.15),('11288','2013-03-18','13:25:00',3.85),('11288','2013-03-18','13:30:00',2.35),('11288','2013-03-18','13:35:00',2.25),('11288','2013-03-18','13:40:00',3.93),('11288','2013-03-18','13:45:00',3.35),('11288','2013-03-18','13:50:00',3.02),('11288','2013-03-18','13:55:00',2.73),('11288','2013-03-18','14:00:00',3.12),('11288','2013-03-18','14:05:00',4.69),('11288','2013-03-18','14:10:00',4.03),('11288','2013-03-18','14:15:00',2.23),('11288','2013-03-18','14:20:00',2.39),('11288','2013-03-18','14:25:00',3.11),('11288','2013-03-18','14:30:00',1.57),('11288','2013-03-18','14:35:00',2.09),('11288','2013-03-18','14:40:00',2.21),('11288','2013-03-18','14:45:00',1.95),('11288','2013-03-18','14:50:00',1.15),('11288','2013-03-18','14:55:00',1.76),('11288','2013-03-18','15:00:00',1.96),('11288','2013-03-18','15:05:00',1.69),('11288','2013-03-18','15:10:00',1.22),('11288','2013-03-18','15:15:00',1.67),('11288','2013-03-18','15:20:00',1.21),('11288','2013-03-18','15:25:00',1.14),('11288','2013-03-18','15:30:00',1.06),('11288','2013-03-18','15:35:00',1.01),('11288','2013-03-17','07:50:00',1.13),('11288','2013-03-17','07:55:00',1.19),('11288','2013-03-17','08:00:00',1.3),('11288','2013-03-17','08:05:00',1.43),('11288','2013-03-17','08:10:00',1.62),('11288','2013-03-17','08:15:00',1.79),('11288','2013-03-17','08:20:00',1.99),('11288','2013-03-17','08:25:00',2.53),('11288','2013-03-17','08:30:00',2.4),('11288','2013-03-17','08:35:00',2.06),('11288','2013-03-17','08:40:00',2.18),('11288','2013-03-17','08:45:00',2.56),('11288','2013-03-17','08:50:00',2.48),('11288','2013-03-17','08:55:00',2.35),('11288','2013-03-17','09:00:00',2.33),('11288','2013-03-17','09:05:00',2.67),('11288','2013-03-17','09:10:00',3.07),('11288','2013-03-17','09:15:00',3.21),('11288','2013-03-17','09:20:00',2.72),('11288','2013-03-17','09:25:00',2.32),('11288','2013-03-17','09:30:00',2.61),('11288','2013-03-17','09:35:00',2.81),('11288','2013-03-17','09:40:00',2.79),('11288','2013-03-17','09:45:00',2.89),('11288','2013-03-17','09:50:00',3.2),('11288','2013-03-17','09:55:00',3.4),('11288','2013-03-17','10:00:00',3.74),('11288','2013-03-17','10:05:00',3.13),('11288','2013-03-17','10:10:00',3.13),('11288','2013-03-17','10:15:00',3.37),('11288','2013-03-17','10:20:00',3.45),('11288','2013-03-17','10:25:00',3.57),('11288','2013-03-17','10:30:00',3.47),('11288','2013-03-17','10:35:00',3.36),('11288','2013-03-17','10:40:00',3.19),('11288','2013-03-17','10:45:00',3.34),('11288','2013-03-17','10:50:00',3.15),('11288','2013-03-17','10:55:00',2.99),('11288','2013-03-17','11:00:00',2.84),('11288','2013-03-17','11:05:00',2.44),('11288','2013-03-17','11:10:00',2.42),('11288','2013-03-17','11:15:00',2.74),('11288','2013-03-17','11:20:00',3.11),('11288','2013-03-17','11:25:00',3.12),('11288','2013-03-17','11:30:00',2.85),('11288','2013-03-17','11:35:00',2.81),('11288','2013-03-17','11:40:00',2.67),('11288','2013-03-17','11:45:00',2.49),('11288','2013-03-17','11:50:00',2.31),('11288','2013-03-17','11:55:00',2.04),('11288','2013-03-17','12:00:00',1.97),('11288','2013-03-17','12:05:00',2.05),('11288','2013-03-17','12:10:00',2.69),('11288','2013-03-17','12:15:00',3.6),('11288','2013-03-17','12:20:00',4.33),('11288','2013-03-17','12:25:00',5.62),('11288','2013-03-17','12:30:00',5.84),('11288','2013-03-17','12:35:00',4.36),('11288','2013-03-17','12:40:00',4.51),('11288','2013-03-17','12:45:00',4.18),('11288','2013-03-17','12:50:00',3.77),('11288','2013-03-17','12:55:00',3.2),('11288','2013-03-17','13:00:00',3.82),('11288','2013-03-17','13:05:00',4.07),('11288','2013-03-17','13:10:00',4.64),('11288','2013-03-17','13:15:00',4.5),('11288','2013-03-17','13:20:00',3.78),('11288','2013-03-17','13:25:00',3.34),('11288','2013-03-17','13:30:00',4.82),('11288','2013-03-17','13:35:00',4.65),('11288','2013-03-17','13:40:00',3.6),('11288','2013-03-17','13:45:00',3.25),('11288','2013-03-17','13:50:00',2.69),('11288','2013-03-17','13:55:00',4.24),('11288','2013-03-17','14:00:00',3.76),('11288','2013-03-17','14:05:00',3.98),('11288','2013-03-17','14:10:00',4.66),('11288','2013-03-17','14:15:00',4.46),('11288','2013-03-17','14:20:00',5.08),('11288','2013-03-17','14:25:00',4.09),('11288','2013-03-17','14:30:00',3.92),('11288','2013-03-17','14:35:00',3.37),('11288','2013-03-17','14:40:00',2.53),('11288','2013-03-17','14:45:00',2.37),('11288','2013-03-17','14:50:00',2.06),('11288','2013-03-17','14:55:00',2.25),('11288','2013-03-17','15:00:00',2.92),('11288','2013-03-17','15:05:00',3.26),('11288','2013-03-17','15:10:00',4.08),('11288','2013-03-17','15:15:00',3.98),('11288','2013-03-17','15:20:00',4.87),('11288','2013-03-17','15:25:00',4.88),('11288','2013-03-17','15:30:00',2.7),('11288','2013-03-17','15:35:00',3.45),('11288','2013-03-17','15:40:00',2.69),('11288','2013-03-17','15:45:00',2.48),('11288','2013-03-17','15:50:00',1.39),('11288','2013-03-17','15:55:00',1.34),('11288','2013-03-17','16:00:00',1.08),('11288','2013-03-17','16:15:00',1.1),('11288','2013-03-17','16:20:00',1.12),('11288','2013-03-17','16:40:00',1.5),('11288','2013-03-17','16:45:00',1.88),('11288','2013-03-16','07:45:00',1.14),('11288','2013-03-16','07:50:00',1.43),('11288','2013-03-16','07:55:00',1.46),('11288','2013-03-16','08:00:00',1.3),('11288','2013-03-16','08:05:00',1.41),('11288','2013-03-16','08:10:00',2.41),('11288','2013-03-16','08:15:00',2.63),('11288','2013-03-16','08:20:00',2.7),('11288','2013-03-16','08:25:00',2.94),('11288','2013-03-16','08:30:00',3.04),('11288','2013-03-16','08:35:00',3.19),('11288','2013-03-16','08:40:00',3.28),('11288','2013-03-16','08:45:00',3.55),('11288','2013-03-16','08:50:00',3.83),('11288','2013-03-16','08:55:00',4.16),('11288','2013-03-16','09:00:00',4.32),('11288','2013-03-16','09:05:00',3.76),('11288','2013-03-16','09:10:00',3.91),('11288','2013-03-16','09:15:00',4.66),('11288','2013-03-16','09:20:00',4.18),('11288','2013-03-16','09:25:00',2.99),('11288','2013-03-16','09:30:00',4.42),('11288','2013-03-16','09:35:00',5.24),('11288','2013-03-16','09:40:00',4.62),('11288','2013-03-16','09:45:00',5.11),('11288','2013-03-16','09:50:00',5.47),('11288','2013-03-16','09:55:00',5.73),('11288','2013-03-16','10:00:00',4.97),('11288','2013-03-16','10:05:00',4.8),('11288','2013-03-16','10:10:00',5.75),('11288','2013-03-16','10:15:00',4.79),('11288','2013-03-16','10:20:00',3.93),('11288','2013-03-16','10:25:00',3.96),('11288','2013-03-16','10:30:00',3.53),('11288','2013-03-16','10:35:00',5.7),('11288','2013-03-16','10:40:00',6.38),('11288','2013-03-16','10:45:00',6.34),('11288','2013-03-16','10:50:00',6.4),('11288','2013-03-16','10:55:00',6.4),('11288','2013-03-16','11:00:00',6.48),('11288','2013-03-16','11:05:00',6.51),('11288','2013-03-16','11:10:00',6.56),('11288','2013-03-16','11:15:00',6.61),('11288','2013-03-16','11:20:00',6.71),('11288','2013-03-16','11:25:00',6.72),('11288','2013-03-16','11:30:00',6.8),('11288','2013-03-16','11:35:00',6.79),('11288','2013-03-16','11:40:00',6.77),('11288','2013-03-16','11:45:00',6.8),('11288','2013-03-16','11:50:00',6.83),('11288','2013-03-16','11:55:00',6.85),('11288','2013-03-16','12:00:00',6.85),('11288','2013-03-16','12:05:00',6.83),('11288','2013-03-16','12:10:00',6.76),('11288','2013-03-16','12:15:00',6.82),('11288','2013-03-16','12:20:00',6.8),('11288','2013-03-16','12:25:00',6.81),('11288','2013-03-16','12:30:00',6.84),('11288','2013-03-16','12:35:00',6.83),('11288','2013-03-16','12:40:00',6.76),('11288','2013-03-16','12:45:00',6.77),('11288','2013-03-16','12:50:00',6.76),('11288','2013-03-16','12:55:00',6.7),('11288','2013-03-16','13:00:00',6.64),('11288','2013-03-16','13:05:00',6.6),('11288','2013-03-16','13:10:00',6.54),('11288','2013-03-16','13:15:00',6.48),('11288','2013-03-16','13:20:00',6.65),('11288','2013-03-16','13:25:00',4.88),('11288','2013-03-16','13:30:00',1.64),('11288','2013-03-16','13:35:00',1.38),('11288','2013-03-16','13:40:00',2.78),('11288','2013-03-16','13:45:00',2.45),('11288','2013-03-16','13:50:00',4.26),('11288','2013-03-16','13:55:00',5.04),('11288','2013-03-16','14:00:00',6.49),('11288','2013-03-16','14:05:00',5.59),('11288','2013-03-16','14:10:00',1.88),('11288','2013-03-16','14:15:00',5.37),('11288','2013-03-16','14:20:00',3.23),('11288','2013-03-16','14:25:00',3),('11288','2013-03-16','14:30:00',6.15),('11288','2013-03-16','14:35:00',5.45),('11288','2013-03-16','14:40:00',5.84),('11288','2013-03-16','14:45:00',3.53),('11288','2013-03-16','14:50:00',1.53),('11288','2013-03-16','14:55:00',1.74),('11288','2013-03-16','15:00:00',1.12),('11288','2013-03-16','15:05:00',1.59),('11288','2013-03-16','15:20:00',1.02),('11288','2013-03-16','15:25:00',1.02),('11288','2013-03-16','15:35:00',1.2),('11288','2013-03-16','15:40:00',1.41),('11288','2013-03-16','15:45:00',1.45),('11288','2013-03-16','16:00:00',2.41),('11288','2013-03-16','16:05:00',2.76),('11288','2013-03-16','16:10:00',2.89),('11288','2013-03-16','16:15:00',2.99),('11288','2013-03-16','16:20:00',1.95),('11288','2013-03-16','16:25:00',1.19),('11288','2013-03-16','16:30:00',1.22),('11288','2013-03-16','16:35:00',1.61),('11288','2013-03-16','16:40:00',1.13),('11288','2013-03-16','16:45:00',1.17),('11288','2013-03-16','16:50:00',1.13),('11288','2013-03-16','16:55:00',1.65),('11288','2013-03-16','17:00:00',1.54),('11288','2013-03-16','17:05:00',1.42),('11288','2013-03-16','17:10:00',1.24),('11288','2013-03-16','17:15:00',1.16),('11288','2013-03-16','17:20:00',1.04),('11288','2013-03-15','10:00:00',1.19),('11288','2013-03-15','10:05:00',1.16),('11288','2013-03-15','10:10:00',1.14),('11288','2013-03-15','10:15:00',1.27),('11288','2013-03-15','10:20:00',1.18),('11288','2013-03-15','10:25:00',1.31),('11288','2013-03-15','10:30:00',1.76),('11288','2013-03-15','10:35:00',1.99),('11288','2013-03-15','10:40:00',2.21),('11288','2013-03-15','10:45:00',2.57),('11288','2013-03-15','10:50:00',2.6),('11288','2013-03-15','10:55:00',2.81),('11288','2013-03-15','11:00:00',2.78),('11288','2013-03-15','11:05:00',2.37),('11288','2013-03-15','11:10:00',2.4),('11288','2013-03-15','11:15:00',2.01),('11288','2013-03-15','11:20:00',2.4),('11288','2013-03-15','11:25:00',2.92),('11288','2013-03-15','11:30:00',3.22),('11288','2013-03-15','11:35:00',4.07),('11288','2013-03-15','11:40:00',4.16),('11288','2013-03-15','11:45:00',4.16),('11288','2013-03-15','11:50:00',3.67),('11288','2013-03-15','11:55:00',3.86),('11288','2013-03-15','12:00:00',3.51),('11288','2013-03-15','12:05:00',3.32),('11288','2013-03-15','12:10:00',3.59),('11288','2013-03-15','12:15:00',3.19),('11288','2013-03-15','12:20:00',3.12),('11288','2013-03-15','12:25:00',3.34),('11288','2013-03-15','12:30:00',3.51),('11288','2013-03-15','12:35:00',3.96),('11288','2013-03-15','12:40:00',3.34),('11288','2013-03-15','12:45:00',2.76),('11288','2013-03-15','12:50:00',2.6),('11288','2013-03-15','12:55:00',2.52),('11288','2013-03-15','13:00:00',2.33),('11288','2013-03-15','13:05:00',2.19),('11288','2013-03-15','13:10:00',2.29),('11288','2013-03-15','13:15:00',2.51),('11288','2013-03-15','13:20:00',2.7),('11288','2013-03-15','13:25:00',2.99),('11288','2013-03-15','13:30:00',2.85),('11288','2013-03-15','13:35:00',2.67),('11288','2013-03-15','13:40:00',2.77),('11288','2013-03-15','13:45:00',2.97),('11288','2013-03-15','13:50:00',2.42),('11288','2013-03-15','13:55:00',2.05),('11288','2013-03-15','14:00:00',1.86),('11288','2013-03-15','14:05:00',1.62),('11288','2013-03-15','14:10:00',1.4),('11288','2013-03-15','14:15:00',1.27),('11288','2013-03-15','14:20:00',1.16),('11288','2013-03-15','14:25:00',1.02),('11288','2013-03-15','14:40:00',1.06),('11288','2013-03-15','14:45:00',1.39),('11288','2013-03-15','14:50:00',1.91),('11288','2013-03-15','14:55:00',2.19),('11288','2013-03-15','15:00:00',2.35),('11288','2013-03-15','15:05:00',2.19),('11288','2013-03-15','15:10:00',2.19),('11288','2013-03-15','15:15:00',2.34),('11288','2013-03-15','15:20:00',2.46),('11288','2013-03-15','15:25:00',2.65),('11288','2013-03-15','15:30:00',2.26),('11288','2013-03-15','15:35:00',1.92),('11288','2013-03-15','15:40:00',1.62),('11288','2013-03-15','15:45:00',1.67),('11288','2013-03-15','15:50:00',1.61),('11288','2013-03-15','15:55:00',1.54),('11288','2013-03-15','16:00:00',1.7),('11288','2013-03-15','16:05:00',1.42),('11288','2013-03-15','16:10:00',1.28),('11288','2013-03-15','16:15:00',1.34),('11288','2013-03-15','16:20:00',1.08),('11288','2013-03-15','17:15:00',1.06),('11288','2013-03-14','08:20:00',1.23),('11288','2013-03-14','08:25:00',1.35),('11288','2013-03-14','08:30:00',1.1),('11288','2013-03-14','10:15:00',1.08),('11288','2013-03-14','11:20:00',1.05),('11288','2013-03-14','11:25:00',1.21),('11288','2013-03-14','11:30:00',1.46),('11288','2013-03-14','11:35:00',1.29),('11288','2013-03-14','11:40:00',1.24),('11288','2013-03-14','11:45:00',1.44),('11288','2013-03-14','11:50:00',1.47),('11288','2013-03-14','11:55:00',1.44),('11288','2013-03-14','12:00:00',1.29),('11288','2013-03-14','12:05:00',1.17),('11288','2013-03-14','12:10:00',1.11),('11288','2013-03-14','12:15:00',1.13),('11288','2013-03-14','12:20:00',1.19),('11288','2013-03-14','12:25:00',1.29),('11288','2013-03-14','12:30:00',1.34),('11288','2013-03-14','12:35:00',1.37),('11288','2013-03-14','12:40:00',1.47),('11288','2013-03-14','12:45:00',1.66),('11288','2013-03-14','12:50:00',1.8),('11288','2013-03-14','12:55:00',1.93),('11288','2013-03-14','13:00:00',1.74),('11288','2013-03-14','13:05:00',2),('11288','2013-03-14','13:10:00',2.09),('11288','2013-03-14','13:15:00',2.13),('11288','2013-03-14','13:20:00',2.14),('11288','2013-03-14','13:25:00',2.02),('11288','2013-03-14','13:30:00',2.16),('11288','2013-03-14','13:35:00',2.44),('11288','2013-03-14','13:40:00',2.38),('11288','2013-03-14','13:45:00',2.22),('11288','2013-03-14','13:50:00',2.45),('11288','2013-03-14','13:55:00',2.92),('11288','2013-03-14','14:00:00',2.72),('11288','2013-03-14','14:05:00',3.06),('11288','2013-03-14','14:10:00',2.72),('11288','2013-03-14','14:15:00',2.29),('11288','2013-03-14','14:20:00',2.24),('11288','2013-03-14','14:25:00',2.26),('11288','2013-03-14','14:30:00',1.86),('11288','2013-03-14','14:35:00',1.36),('11288','2013-03-14','14:40:00',1.01),('11288','2013-03-14','14:55:00',1.02),('11288','2013-03-14','15:00:00',1.06),('11288','2013-03-14','15:05:00',1.53),('11288','2013-03-14','15:10:00',2.34),('11288','2013-03-14','15:15:00',2.32),('11288','2013-03-14','15:20:00',2.22),('11288','2013-03-14','15:25:00',2.36),('11288','2013-03-14','15:30:00',2.35),('11288','2013-03-14','15:35:00',1.85),('11288','2013-03-14','15:40:00',1.32),('11288','2013-03-14','15:45:00',1.04),('11288','2013-03-14','16:30:00',1.08),('11288','2013-03-13','07:20:00',1.19),('11288','2013-03-13','08:05:00',1.1),('11288','2013-03-13','08:10:00',1.22),('11288','2013-03-13','08:25:00',1.24),('11288','2013-03-13','08:40:00',1.34),('11288','2013-03-13','08:45:00',1.56),('11288','2013-03-13','08:50:00',2.2),('11288','2013-03-13','08:55:00',1.97),('11288','2013-03-13','09:00:00',1.41),('11288','2013-03-13','09:05:00',1.6),('11288','2013-03-13','09:10:00',2.09),('11288','2013-03-13','09:15:00',1.61),('11288','2013-03-13','09:20:00',1.79),('11288','2013-03-13','09:25:00',1.65),('11288','2013-03-13','09:30:00',1.67),('11288','2013-03-13','09:35:00',1.38),('11288','2013-03-13','09:40:00',1.82),('11288','2013-03-13','09:45:00',1.83),('11288','2013-03-13','09:50:00',1.41),('11288','2013-03-13','10:00:00',1.46),('11288','2013-03-13','10:05:00',1.95),('11288','2013-03-13','10:10:00',2.44),('11288','2013-03-13','10:15:00',3.86),('11288','2013-03-13','10:20:00',2.88),('11288','2013-03-13','10:25:00',4.34),('11288','2013-03-13','10:30:00',5.31),('11288','2013-03-13','10:35:00',5.39),('11288','2013-03-13','10:40:00',3.85),('11288','2013-03-13','10:45:00',2.68),('11288','2013-03-13','10:50:00',2.16),('11288','2013-03-13','10:55:00',1.88),('11288','2013-03-13','11:00:00',1.92),('11288','2013-03-13','11:05:00',1.79),('11288','2013-03-13','11:10:00',2.3),('11288','2013-03-13','11:15:00',2.05),('11288','2013-03-13','11:20:00',1.61),('11288','2013-03-13','11:25:00',1.6),('11288','2013-03-13','11:30:00',2.37),('11288','2013-03-13','11:35:00',2.38),('11288','2013-03-13','11:40:00',2.36),('11288','2013-03-13','11:45:00',2.65),('11288','2013-03-13','11:50:00',2.35),('11288','2013-03-13','11:55:00',1.71),('11288','2013-03-13','12:25:00',1.08),('11288','2013-03-13','12:30:00',1.46),('11288','2013-03-13','12:35:00',1.62),('11288','2013-03-13','12:40:00',1.76),('11288','2013-03-13','12:45:00',2.12),('11288','2013-03-13','12:50:00',2.48),('11288','2013-03-13','12:55:00',2.27),('11288','2013-03-13','13:00:00',2.2),('11288','2013-03-13','13:05:00',2.1),('11288','2013-03-13','13:10:00',1.9),('11288','2013-03-13','13:15:00',1.64),('11288','2013-03-13','13:20:00',1.39),('11288','2013-03-13','13:25:00',1.33),('11288','2013-03-13','13:30:00',1.55),('11288','2013-03-13','13:35:00',1.97),('11288','2013-03-13','13:40:00',1.68),('11288','2013-03-13','13:45:00',1.56),('11288','2013-03-13','13:50:00',1.26),('11288','2013-03-13','13:55:00',1.2),('11288','2013-03-13','14:00:00',1.04),('11288','2013-03-13','14:05:00',1.05),('11288','2013-03-13','14:30:00',1.08),('11288','2013-03-13','14:35:00',1.12),('11288','2013-03-13','14:40:00',1.05),('11288','2013-03-13','14:45:00',1.3),('11288','2013-03-13','14:50:00',1.52),('11288','2013-03-13','14:55:00',1.32),('11288','2013-03-13','15:00:00',1.44),('11288','2013-03-13','15:05:00',1.58),('11288','2013-03-13','15:10:00',1.6),('11288','2013-03-13','15:15:00',1.14),('11288','2014-03-25','07:10:00',1.13),('11288','2014-03-25','07:15:00',1.35),('11288','2014-03-25','07:20:00',1.45),('11288','2014-03-25','07:25:00',1.79),('11288','2014-03-25','07:30:00',1.89),('11288','2014-03-25','07:35:00',1.64),('11288','2014-03-25','07:40:00',1.66),('11288','2014-03-25','07:45:00',1.85),('11288','2014-03-25','07:50:00',2.01),('11288','2014-03-25','07:55:00',2.05),('11288','2014-03-25','08:00:00',2.02),('11288','2014-03-25','08:05:00',2.09),('11288','2014-03-25','08:10:00',2.23),('11288','2014-03-25','08:15:00',2.34),('11288','2014-03-25','08:20:00',2.21),('11288','2014-03-25','08:25:00',2.05),('11288','2014-03-25','08:30:00',1.88),('11288','2014-03-25','08:35:00',1.94),('11288','2014-03-25','08:40:00',2.31),('11288','2014-03-25','08:45:00',2.86),('11288','2014-03-25','08:50:00',3.01),('11288','2014-03-25','08:55:00',3.16),('11288','2014-03-25','09:00:00',3.02),('11288','2014-03-25','09:05:00',3),('11288','2014-03-25','09:10:00',2.96),('11288','2014-03-25','09:15:00',3.81),('11288','2014-03-25','09:20:00',4.15),('11288','2014-03-25','09:25:00',3.6),('11288','2014-03-25','09:30:00',3.32),('11288','2014-03-25','09:35:00',3.12),('11288','2014-03-25','09:40:00',3.13),('11288','2014-03-25','09:45:00',2.95),('11288','2014-03-25','09:50:00',3.05),('11288','2014-03-25','09:55:00',3.37),('11288','2014-03-25','10:00:00',3.81),('11288','2014-03-25','10:05:00',4.1),('11288','2014-03-25','10:10:00',4.28),('11288','2014-03-25','10:15:00',4.6),('11288','2014-03-25','10:20:00',4.53),('11288','2014-03-25','10:25:00',4.4),('11288','2014-03-25','10:30:00',4.79),('11288','2014-03-25','10:35:00',4.03),('11288','2014-03-25','10:40:00',3.48),('11288','2014-03-25','10:45:00',3.3),('11288','2014-03-25','10:50:00',3.23),('11288','2014-03-25','10:55:00',3.24),('11288','2014-03-25','11:00:00',3.49),('11288','2014-03-25','11:05:00',3.9),('11288','2014-03-25','11:10:00',4.28),('11288','2014-03-25','11:15:00',4.82),('11288','2014-03-25','11:20:00',4.67),('11288','2014-03-25','11:25:00',4.17),('11288','2014-03-25','11:30:00',4.69),('11288','2014-03-25','11:35:00',3.99),('11288','2014-03-25','11:40:00',4.5),('11288','2014-03-25','11:45:00',3.17),('11288','2014-03-25','11:50:00',3.96),('11288','2014-03-25','11:55:00',2.83),('11288','2014-03-25','12:00:00',1.97),('11288','2014-03-25','12:05:00',1.36),('11288','2014-03-25','12:10:00',1.36),('11288','2014-03-25','12:15:00',1.68),('11288','2014-03-25','12:20:00',2.11),('11288','2014-03-25','12:25:00',2.18),('11288','2014-03-25','12:30:00',1.68),('11288','2014-03-25','12:35:00',1.52),('11288','2014-03-25','12:40:00',1.62),('11288','2014-03-25','12:45:00',1.34),('11288','2014-03-25','13:30:00',1.26),('11288','2014-03-25','13:35:00',1.63),('11288','2014-03-25','13:40:00',1.6),('11288','2014-03-25','13:45:00',1.41),('11288','2014-03-25','13:50:00',1.41),('11288','2014-03-25','13:55:00',1.38),('11288','2014-03-25','14:00:00',1.38),('11288','2014-03-25','14:05:00',1.47),('11288','2014-03-25','14:10:00',1.57),('11288','2014-03-25','14:15:00',1.61),('11288','2014-03-25','14:20:00',1.2),('11288','2014-03-25','14:30:00',1.05),('11288','2014-03-25','14:35:00',1.22),('11288','2014-03-25','14:40:00',1.24),('11288','2014-03-25','14:45:00',1.23),('11288','2014-03-25','14:50:00',1),('11288','2014-03-25','15:15:00',1.2),('11288','2014-03-25','15:20:00',1.15),('11288','2013-03-12','08:15:00',1.04),('11288','2013-03-12','08:20:00',1.85),('11288','2013-03-12','08:25:00',2.36),('11288','2013-03-12','08:30:00',2.75),('11288','2013-03-12','08:35:00',2.51),('11288','2013-03-12','08:40:00',2.87),('11288','2013-03-12','08:45:00',3.29),('11288','2013-03-12','08:50:00',1.73),('11288','2013-03-12','09:00:00',2.74),('11288','2013-03-12','09:05:00',3.84),('11288','2013-03-12','09:10:00',3.95),('11288','2013-03-12','09:15:00',4.05),('11288','2013-03-12','09:20:00',4.15),('11288','2013-03-12','09:25:00',4.31),('11288','2013-03-12','09:30:00',4.27),('11288','2013-03-12','09:35:00',4.53),('11288','2013-03-12','09:40:00',4.14),('11288','2013-03-12','09:45:00',3.14),('11288','2013-03-12','09:50:00',4.56),('11288','2013-03-12','09:55:00',5.2),('11288','2013-03-12','10:00:00',3.4),('11288','2013-03-12','10:05:00',5.32),('11288','2013-03-12','10:10:00',5.49),('11288','2013-03-12','10:15:00',3.8),('11288','2013-03-12','10:20:00',2.87),('11288','2013-03-12','10:25:00',4.83),('11288','2013-03-12','10:30:00',1.95),('11288','2013-03-12','10:35:00',3.22),('11288','2013-03-12','10:40:00',4.44),('11288','2013-03-12','10:45:00',2.42),('11288','2013-03-12','10:50:00',5.86),('11288','2013-03-12','10:55:00',6.25),('11288','2013-03-12','11:00:00',6.57),('11288','2013-03-12','11:05:00',4.95),('11288','2013-03-12','11:10:00',6.74),('11288','2013-03-12','11:15:00',5.94),('11288','2013-03-12','11:20:00',5.86),('11288','2013-03-12','11:25:00',2.63),('11288','2013-03-12','11:30:00',2.85),('11288','2013-03-12','11:35:00',3.8),('11288','2013-03-12','11:40:00',3.68),('11288','2013-03-12','11:45:00',4.1),('11288','2013-03-12','11:50:00',4.28),('11288','2013-03-12','11:55:00',3.82),('11288','2013-03-12','12:00:00',1.55),('11288','2013-03-12','12:05:00',1.95),('11288','2013-03-12','12:10:00',7.23),('11288','2013-03-12','12:15:00',3.49),('11288','2013-03-12','12:20:00',3.88),('11288','2013-03-12','12:25:00',4.87),('11288','2013-03-12','12:30:00',7.64),('11288','2013-03-12','12:35:00',4.87),('11288','2013-03-12','12:40:00',5.33),('11288','2013-03-12','12:45:00',2.47),('11288','2013-03-12','12:50:00',3.02),('11288','2013-03-12','12:55:00',4.72),('11288','2013-03-12','13:00:00',6.55),('11288','2013-03-12','13:05:00',4.26),('11288','2013-03-12','13:10:00',4.05),('11288','2013-03-12','13:15:00',3.22),('11288','2013-03-12','13:20:00',5.11),('11288','2013-03-12','13:25:00',3.13),('11288','2013-03-12','13:30:00',2.69),('11288','2013-03-12','13:35:00',3.14),('11288','2013-03-12','13:40:00',2.6),('11288','2013-03-12','13:45:00',2.15),('11288','2013-03-12','13:50:00',2.2),('11288','2013-03-12','13:55:00',2.83),('11288','2013-03-12','14:00:00',4.7),('11288','2013-03-12','14:05:00',4.43),('11288','2013-03-12','14:10:00',2.73),('11288','2013-03-12','14:15:00',2.16),('11288','2013-03-12','14:20:00',1.64),('11288','2013-03-12','14:30:00',1.02),('11288','2013-03-12','14:35:00',1.22),('11288','2013-03-12','15:00:00',1.79),('11288','2013-03-12','15:05:00',1.11),('11288','2013-03-12','15:10:00',1.63),('11288','2013-03-12','15:15:00',1.64),('11288','2013-03-12','15:20:00',1.83),('11288','2013-03-12','15:25:00',1.71),('11288','2013-03-12','15:30:00',1.1),('11288','2013-03-12','15:35:00',1.05),('11288','2013-03-11','07:35:00',1.14),('11288','2013-03-11','07:40:00',1.54),('11288','2013-03-11','08:10:00',1.82),('11288','2013-03-11','08:15:00',1.85),('11288','2013-03-11','08:20:00',1.96),('11288','2013-03-11','08:25:00',2.29),('11288','2013-03-11','08:30:00',2.49),('11288','2013-03-11','08:35:00',2.65),('11288','2013-03-11','08:40:00',2.81),('11288','2013-03-11','08:45:00',2.87),('11288','2013-03-11','08:50:00',2.97),('11288','2013-03-11','08:55:00',3.28),('11288','2013-03-11','09:00:00',3.46),('11288','2013-03-11','09:05:00',3.58),('11288','2013-03-11','09:10:00',3.73),('11288','2013-03-11','09:15:00',3.9),('11288','2013-03-11','09:20:00',3.43),('11288','2013-03-11','09:25:00',1.46),('11288','2013-03-11','09:30:00',2.34),('11288','2013-03-11','09:35:00',5.16),('11288','2013-03-11','09:40:00',4.13),('11288','2013-03-11','09:45:00',2.95),('11288','2013-03-11','09:50:00',1.53),('11288','2013-03-11','09:55:00',1.47),('11288','2013-03-11','10:00:00',1.49),('11288','2013-03-11','10:05:00',1.74),('11288','2013-03-11','10:10:00',2.01),('11288','2013-03-11','10:15:00',2.08),('11288','2013-03-11','10:20:00',2.35),('11288','2013-03-11','10:25:00',2.52),('11288','2013-03-11','10:30:00',2.4),('11288','2013-03-11','10:35:00',2.87),('11288','2013-03-11','10:40:00',3.64),('11288','2013-03-11','10:45:00',4.2),('11288','2013-03-11','10:50:00',4.85),('11288','2013-03-11','10:55:00',3.37),('11288','2013-03-11','11:00:00',2.81),('11288','2013-03-11','11:05:00',2.35),('11288','2013-03-11','11:10:00',2.5),('11288','2013-03-11','11:15:00',2.53),('11288','2013-03-11','11:20:00',2.23),('11288','2013-03-11','11:25:00',2.22),('11288','2013-03-11','11:30:00',3.87),('11288','2013-03-11','11:35:00',3.83),('11288','2013-03-11','11:40:00',3.38),('11288','2013-03-11','11:45:00',4.15),('11288','2013-03-11','11:50:00',4),('11288','2013-03-11','11:55:00',3.47),('11288','2013-03-11','12:00:00',3.18),('11288','2013-03-11','12:05:00',3.46),('11288','2013-03-11','12:10:00',3.19),('11288','2013-03-11','12:15:00',1.37),('11288','2013-03-11','12:20:00',1.39),('11288','2013-03-11','12:25:00',1.73),('11288','2013-03-11','12:30:00',1.89),('11288','2013-03-11','12:35:00',2.61),('11288','2013-03-11','12:40:00',2.08),('11288','2013-03-11','12:45:00',2.41),('11288','2013-03-11','12:50:00',3.92),('11288','2013-03-11','12:55:00',4.67),('11288','2013-03-11','13:00:00',2.95),('11288','2013-03-11','13:05:00',3.21),('11288','2013-03-11','13:10:00',5.78),('11288','2013-03-11','13:15:00',5.47),('11288','2013-03-11','13:20:00',6.89),('11288','2013-03-11','13:25:00',5.74),('11288','2013-03-11','13:30:00',5.83),('11288','2013-03-11','13:35:00',6.43),('11288','2013-03-11','13:40:00',4.63),('11288','2013-03-11','13:45:00',6.31),('11288','2013-03-11','13:50:00',6.11),('11288','2013-03-11','13:55:00',2.27),('11288','2013-03-11','14:00:00',1.64),('11288','2013-03-11','14:05:00',1.4),('11288','2013-03-11','14:10:00',1.35),('11288','2013-03-11','14:15:00',1.17),('11288','2013-03-11','14:20:00',2.23),('11288','2013-03-11','14:25:00',3.21),('11288','2013-03-11','14:30:00',2.22),('11288','2013-03-11','14:35:00',2.21),('11288','2013-03-11','14:40:00',2.7),('11288','2013-03-11','14:45:00',1.44),('11288','2013-03-11','14:50:00',1.13),('11288','2013-03-11','15:15:00',1.05),('11288','2013-03-11','15:20:00',1.17),('11288','2013-03-11','15:25:00',1.86),('11288','2013-03-11','15:30:00',3.61),('11288','2013-03-11','15:35:00',1.92),('11288','2013-03-11','15:40:00',3.25),('11288','2013-03-11','15:45:00',3.88),('11288','2013-03-11','15:50:00',2.9),('11288','2013-03-11','15:55:00',2.6),('11288','2013-03-11','16:00:00',2.39),('11288','2013-03-11','16:05:00',1.82),('11288','2013-03-11','16:10:00',2.1),('11288','2013-03-11','16:15:00',1.91),('11288','2013-03-11','16:20:00',2.14),('11288','2013-03-11','16:25:00',1.9),('11288','2013-03-11','16:30:00',2.01),('11288','2013-03-11','16:35:00',1.51),('11288','2013-03-11','16:40:00',1.83),('11288','2013-03-11','16:45:00',1.86),('11288','2013-03-11','16:50:00',1.14),('11288','2013-03-10','07:50:00',1.06),('11288','2013-03-10','07:55:00',1.36),('11288','2013-03-10','08:00:00',1.5),('11288','2013-03-10','08:05:00',1.68),('11288','2013-03-10','08:10:00',1.7),('11288','2013-03-10','08:15:00',1.85),('11288','2013-03-10','08:20:00',2.17),('11288','2013-03-10','08:25:00',2.3),('11288','2013-03-10','08:30:00',2.48),('11288','2013-03-10','08:35:00',2.66),('11288','2013-03-10','08:40:00',2.81),('11288','2013-03-10','08:45:00',2.88),('11288','2013-03-10','08:50:00',2.69),('11288','2013-03-10','08:55:00',3.28),('11288','2013-03-10','09:00:00',3.4),('11288','2013-03-10','09:05:00',3.55),('11288','2013-03-10','09:10:00',3.7),('11288','2013-03-10','09:15:00',3.81),('11288','2013-03-10','09:20:00',3.89),('11288','2013-03-10','09:25:00',4.04),('11288','2013-03-10','09:30:00',4.19),('11288','2013-03-10','09:35:00',4.29),('11288','2013-03-10','09:40:00',4.59),('11288','2013-03-10','09:45:00',4.67),('11288','2013-03-10','09:50:00',5.08),('11288','2013-03-10','09:55:00',4.93),('11288','2013-03-10','10:00:00',4.5),('11288','2013-03-10','10:05:00',4.17),('11288','2013-03-10','10:10:00',3.26),('11288','2013-03-10','10:15:00',4.4),('11288','2013-03-10','10:20:00',4.4),('11288','2013-03-10','10:25:00',5.7),('11288','2013-03-10','10:30:00',3.49),('11288','2013-03-10','10:35:00',2.22),('11288','2013-03-10','10:40:00',5.69),('11288','2013-03-10','10:45:00',5.74),('11288','2013-03-10','10:50:00',2.47),('11288','2013-03-10','10:55:00',3.4),('11288','2013-03-10','11:00:00',3.4),('11288','2013-03-10','11:05:00',5.33),('11288','2013-03-10','11:10:00',3.18),('11288','2013-03-10','11:15:00',3.91),('11288','2013-03-10','11:20:00',5.4),('11288','2013-03-10','11:25:00',4.5),('11288','2013-03-10','11:30:00',3.62),('11288','2013-03-10','11:35:00',4.38),('11288','2013-03-10','11:40:00',2.26),('11288','2013-03-10','11:45:00',2.39),('11288','2013-03-10','11:50:00',6.92),('11288','2013-03-10','11:55:00',6.5),('11288','2013-03-10','12:00:00',6.57),('11288','2013-03-10','12:05:00',6.25),('11288','2013-03-10','12:10:00',6.05),('11288','2013-03-10','12:15:00',3.6),('11288','2013-03-10','12:20:00',6.95),('11288','2013-03-10','12:25:00',4.6),('11288','2013-03-10','12:30:00',6.56),('11288','2013-03-10','12:35:00',6.56),('11288','2013-03-10','12:40:00',6.09),('11288','2013-03-10','12:45:00',6.46),('11288','2013-03-10','12:50:00',6.78),('11288','2013-03-10','12:55:00',6.25),('11288','2013-03-10','13:00:00',6.09),('11288','2013-03-10','13:05:00',5.99),('11288','2013-03-10','13:10:00',5.67),('11288','2013-03-10','13:15:00',6.06),('11288','2013-03-10','13:20:00',6.04),('11288','2013-03-10','13:25:00',5.83),('11288','2013-03-10','13:30:00',5.61),('11288','2013-03-10','13:35:00',5.71),('11288','2013-03-10','13:40:00',3.72),('11288','2013-03-10','13:45:00',4.02),('11288','2013-03-10','13:50:00',3.31),('11288','2013-03-10','13:55:00',3.08),('11288','2013-03-10','14:00:00',2.61),('11288','2013-03-10','14:05:00',3.64),('11288','2013-03-10','14:10:00',3.54),('11288','2013-03-10','14:15:00',4.76),('11288','2013-03-10','14:20:00',4.27),('11288','2013-03-10','14:25:00',3.09),('11288','2013-03-10','14:30:00',4.39),('11288','2013-03-10','14:35:00',5.32),('11288','2013-03-10','14:40:00',4.51),('11288','2013-03-10','14:45:00',2.84),('11288','2013-03-10','14:50:00',2.92),('11288','2013-03-10','14:55:00',2.48),('11288','2013-03-10','15:00:00',2.09),('11288','2013-03-10','15:05:00',2.48),('11288','2013-03-10','15:10:00',2.35),('11288','2013-03-10','15:15:00',1.57),('11288','2013-03-10','15:20:00',1.61),('11288','2013-03-10','15:25:00',1.01),('11288','2013-03-10','15:30:00',1),('11288','2013-03-10','15:35:00',1.06),('11288','2013-03-10','15:40:00',1.06),('11288','2013-03-10','15:45:00',1.08),('11288','2013-03-10','15:50:00',1.59),('11288','2013-03-10','15:55:00',1.3),('11288','2013-03-09','07:50:00',1.11),('11288','2013-03-09','07:55:00',1.2),('11288','2013-03-09','08:00:00',1.59),('11288','2013-03-09','08:05:00',1.59),('11288','2013-03-09','08:10:00',1.71),('11288','2013-03-09','08:15:00',1.85),('11288','2013-03-09','08:20:00',2.01),('11288','2013-03-09','08:25:00',2.23),('11288','2013-03-09','08:30:00',2.38),('11288','2013-03-09','08:35:00',2.59),('11288','2013-03-09','08:40:00',2.7),('11288','2013-03-09','08:45:00',2.62),('11288','2013-03-09','08:50:00',2.83),('11288','2013-03-09','08:55:00',3.19),('11288','2013-03-09','09:00:00',2.82),('11288','2013-03-09','09:05:00',1.91),('11288','2013-03-09','09:10:00',1.32),('11288','2013-03-09','09:15:00',1.79),('11288','2013-03-09','09:20:00',1.97),('11288','2013-03-09','09:25:00',4.01),('11288','2013-03-09','09:30:00',3.88),('11288','2013-03-09','09:35:00',3.47),('11288','2013-03-09','09:40:00',4.39),('11288','2013-03-09','09:45:00',5.36),('11288','2013-03-09','09:50:00',2.6),('11288','2013-03-09','09:55:00',4.09),('11288','2013-03-09','10:00:00',1.5),('11288','2013-03-09','10:05:00',1.82),('11288','2013-03-09','10:10:00',1.72),('11288','2013-03-09','10:15:00',2.13),('11288','2013-03-09','10:20:00',1.68),('11288','2013-03-09','10:25:00',1.58),('11288','2013-03-09','10:30:00',1.79),('11288','2013-03-09','10:35:00',2.59),('11288','2013-03-09','10:40:00',3.23),('11288','2013-03-09','10:45:00',5.44),('11288','2013-03-09','10:50:00',4.34),('11288','2013-03-09','10:55:00',4.47),('11288','2013-03-09','11:00:00',4.95),('11288','2013-03-09','11:05:00',6.08),('11288','2013-03-09','11:10:00',6.14),('11288','2013-03-09','11:15:00',6.24),('11288','2013-03-09','11:20:00',5.56),('11288','2013-03-09','11:25:00',5.27),('11288','2013-03-09','11:30:00',6.04),('11288','2013-03-09','11:35:00',6.27),('11288','2013-03-09','11:40:00',6.31),('11288','2013-03-09','11:45:00',6.26),('11288','2013-03-09','11:50:00',6.17),('11288','2013-03-09','11:55:00',4.99),('11288','2013-03-09','12:00:00',4.15),('11288','2013-03-09','12:05:00',1.78),('11288','2013-03-09','12:10:00',2.96),('11288','2013-03-09','12:15:00',2.88),('11288','2013-03-09','12:20:00',3.43),('11288','2013-03-09','12:25:00',3.13),('11288','2013-03-09','12:30:00',2.92),('11288','2013-03-09','12:35:00',2.8),('11288','2013-03-09','12:40:00',3.13),('11288','2013-03-09','12:45:00',3.65),('11288','2013-03-09','12:50:00',2.9),('11288','2013-03-09','12:55:00',6.4),('11288','2013-03-09','13:00:00',6.22),('11288','2013-03-09','13:05:00',6.05),('11288','2013-03-09','13:10:00',6.09),('11288','2013-03-09','13:15:00',6.55),('11288','2013-03-09','13:20:00',4.98),('11288','2013-03-09','13:25:00',3.98),('11288','2013-03-09','13:30:00',6.3),('11288','2013-03-09','13:35:00',5.51),('11288','2013-03-09','13:40:00',5.77),('11288','2013-03-09','13:45:00',5.85),('11288','2013-03-09','13:50:00',3.71),('11288','2013-03-09','13:55:00',1.48),('11288','2013-03-09','14:00:00',2.1),('11288','2013-03-09','14:05:00',3.09),('11288','2013-03-09','14:10:00',4.61),('11288','2013-03-09','14:15:00',5.59),('11288','2013-03-09','14:20:00',5.16),('11288','2013-03-09','14:25:00',5.02),('11288','2013-03-09','14:30:00',4.88),('11288','2013-03-09','14:35:00',4.79),('11288','2013-03-09','14:40:00',4.69),('11288','2013-03-09','14:45:00',4.54),('11288','2013-03-09','14:50:00',4.42),('11288','2013-03-09','14:55:00',4.35),('11288','2013-03-09','15:00:00',4.26),('11288','2013-03-09','15:05:00',4.11),('11288','2013-03-09','15:10:00',3.98),('11288','2013-03-09','15:15:00',3.86),('11288','2013-03-09','15:20:00',3.71),('11288','2013-03-09','15:25:00',3.56),('11288','2013-03-09','15:30:00',3.42),('11288','2013-03-09','15:35:00',3.2),('11288','2013-03-09','15:40:00',3.2),('11288','2013-03-09','15:45:00',3.07),('11288','2013-03-09','15:50:00',2.91),('11288','2013-03-09','15:55:00',2.55),('11288','2013-03-09','16:00:00',2.23),('11288','2013-03-09','16:05:00',2.14),('11288','2013-03-09','16:10:00',1.78),('11288','2013-03-09','16:15:00',2.25),('11288','2013-03-09','16:20:00',1.85),('11288','2013-03-09','16:25:00',2.07),('11288','2013-03-09','16:30:00',1.8),('11288','2013-03-09','16:35:00',1.45),('11288','2013-03-09','16:40:00',1.32),('11288','2013-03-09','16:45:00',1.03),('11288','2013-03-09','16:50:00',1.01),('11288','2013-03-08','08:10:00',1.38),('11288','2013-03-08','08:15:00',1.3),('11288','2013-03-08','08:25:00',1.67),('11288','2013-03-08','08:30:00',2.85),('11288','2013-03-08','08:35:00',2.62),('11288','2013-03-08','08:40:00',1.4),('11288','2013-03-08','08:45:00',1.43),('11288','2013-03-08','08:50:00',1.77),('11288','2013-03-08','08:55:00',1.39),('11288','2013-03-08','09:00:00',1.53),('11288','2013-03-08','09:05:00',1.18),('11288','2013-03-08','09:10:00',1.18),('11288','2013-03-08','09:15:00',1.38),('11288','2013-03-08','09:20:00',1.2),('11288','2013-03-08','09:25:00',1.43),('11288','2013-03-08','09:30:00',2.41),('11288','2013-03-08','09:35:00',3.25),('11288','2013-03-08','09:40:00',3.06),('11288','2013-03-08','09:45:00',2.48),('11288','2013-03-08','09:50:00',2.87),('11288','2013-03-08','09:55:00',2.02),('11288','2013-03-08','10:00:00',1.69),('11288','2013-03-08','10:05:00',1.88),('11288','2013-03-08','10:10:00',2.66),('11288','2013-03-08','10:15:00',2.6),('11288','2013-03-08','10:20:00',2.18),('11288','2013-03-08','10:25:00',2.74),('11288','2013-03-08','10:30:00',3.25),('11288','2013-03-08','10:35:00',4.05),('11288','2013-03-08','10:40:00',2.51),('11288','2013-03-08','10:45:00',2.05),('11288','2013-03-08','10:50:00',2.45),('11288','2013-03-08','10:55:00',2.18),('11288','2013-03-08','11:00:00',1.83),('11288','2013-03-08','11:05:00',1.18),('11288','2013-03-08','11:30:00',1.36),('11288','2013-03-08','11:35:00',3.55),('11288','2013-03-08','11:40:00',4.06),('11288','2013-03-08','11:45:00',3.2),('11288','2013-03-08','11:50:00',2.78),('11288','2013-03-08','11:55:00',3.6),('11288','2013-03-08','12:00:00',3.5),('11288','2013-03-08','12:05:00',2.3),('11288','2013-03-08','12:10:00',1.77),('11288','2013-03-08','12:15:00',1.86),('11288','2013-03-08','12:20:00',2.52),('11288','2013-03-08','12:25:00',2.14),('11288','2013-03-08','12:30:00',1.89),('11288','2013-03-08','12:35:00',3.02),('11288','2013-03-08','12:40:00',4.12),('11288','2013-03-08','12:45:00',3.53),('11288','2013-03-08','12:50:00',4.48),('11288','2013-03-08','12:55:00',4.12),('11288','2013-03-08','13:00:00',3.87),('11288','2013-03-08','13:05:00',4.06),('11288','2013-03-08','13:10:00',2.54),('11288','2013-03-08','13:15:00',2.09),('11288','2013-03-08','13:20:00',2.12),('11288','2013-03-08','13:25:00',2.71),('11288','2013-03-08','13:30:00',3.75),('11288','2013-03-08','13:35:00',2.75),('11288','2013-03-08','13:40:00',2.27),('11288','2013-03-08','13:45:00',1.28),('11288','2013-03-08','13:50:00',1.34),('11288','2013-03-08','13:55:00',1.66),('11288','2013-03-08','14:00:00',1.11),('11288','2013-03-08','16:55:00',1.16),('11288','2013-03-08','17:00:00',1.02),('11288','2013-03-08','17:05:00',1.27),('11288','2013-03-08','17:10:00',2.08),('11288','2013-03-08','17:15:00',1.28),('11288','2013-03-07','08:35:00',1.36),('11288','2013-03-07','08:40:00',1.9),('11288','2013-03-07','08:45:00',1.83),('11288','2013-03-07','08:50:00',2.01),('11288','2013-03-07','08:55:00',1.62),('11288','2013-03-07','09:00:00',1.57),('11288','2013-03-07','09:05:00',1.6),('11288','2013-03-07','09:10:00',1.06),('11288','2013-03-07','09:15:00',1.56),('11288','2013-03-07','09:20:00',1.48),('11288','2013-03-07','09:55:00',1.2),('11288','2013-03-07','10:25:00',1.39),('11288','2013-03-07','10:30:00',1.56),('11288','2013-03-07','10:50:00',2.29),('11288','2013-03-07','10:55:00',2.13),('11288','2013-03-07','11:00:00',2.21),('11288','2013-03-07','11:05:00',2.55),('11288','2013-03-07','11:10:00',1.84),('11288','2013-03-07','11:15:00',1.29),('11288','2013-03-07','11:20:00',1.08),('11288','2013-03-07','11:25:00',1.66),('11288','2013-03-07','11:30:00',3.61),('11288','2013-03-07','11:35:00',4.16),('11288','2013-03-07','11:40:00',3.96),('11288','2013-03-07','11:45:00',4.34),('11288','2013-03-07','11:50:00',3.8),('11288','2013-03-07','11:55:00',3.03),('11288','2013-03-07','12:00:00',2.17),('11288','2013-03-07','12:05:00',1.86),('11288','2013-03-07','12:25:00',2.21),('11288','2013-03-07','12:30:00',1.58),('11288','2013-03-07','12:35:00',1.3),('11288','2013-03-07','12:40:00',2.46),('11288','2013-03-07','12:45:00',3.47),('11288','2013-03-07','12:50:00',3.05),('11288','2013-03-07','12:55:00',2.75),('11288','2013-03-07','13:00:00',3.28),('11288','2013-03-07','13:05:00',3.24),('11288','2013-03-07','13:10:00',3.01),('11288','2013-03-07','13:15:00',3.39),('11288','2013-03-07','13:20:00',3.81),('11288','2013-03-07','13:25:00',3.39),('11288','2013-03-07','13:30:00',2.92),('11288','2013-03-07','13:35:00',2.67),('11288','2013-03-07','13:40:00',1.36),('11288','2013-03-07','13:55:00',1.42),('11288','2013-03-07','14:00:00',1.39),('11288','2013-03-07','14:05:00',1.75),('11288','2013-03-07','14:10:00',1.86),('11288','2013-03-07','14:15:00',1.37),('11288','2013-03-07','14:20:00',1.52),('11288','2013-03-07','14:25:00',1.48),('11288','2013-03-07','14:45:00',1.48),('11288','2013-03-07','15:20:00',1.38),('11288','2013-03-07','15:25:00',1.54),('11288','2013-03-07','15:30:00',1.36),('11288','2013-03-07','15:35:00',1.61),('11288','2013-03-07','15:40:00',1.58),('11288','2013-03-07','15:45:00',1.13),('11288','2013-03-07','16:05:00',1.26),('11288','2013-03-07','16:10:00',1.19),('11288','2013-03-07','16:15:00',1.13),('11288','2013-03-07','16:20:00',1.17),('11288','2013-03-07','16:25:00',1.02),('11288','2013-03-07','16:35:00',1.11),('11288','2013-03-07','16:40:00',1.59),('11288','2013-03-07','16:45:00',1.1),('11288','2013-03-06','09:10:00',1.07),('11288','2013-03-06','16:00:00',1.04),('11288','2013-03-06','16:05:00',1.05),('11288','2013-03-05','08:05:00',1.18),('11288','2013-03-05','08:10:00',1.39),('11288','2013-03-05','08:15:00',1.81),('11288','2013-03-05','08:20:00',1.32),('11288','2013-03-05','08:25:00',1.99),('11288','2013-03-05','08:30:00',2.71),('11288','2013-03-05','08:35:00',2.47),('11288','2013-03-05','08:40:00',2.55),('11288','2013-03-05','08:45:00',2.26),('11288','2013-03-05','08:50:00',2.54),('11288','2013-03-05','08:55:00',2.54),('11288','2013-03-05','09:00:00',2.62),('11288','2013-03-05','09:05:00',2.81),('11288','2013-03-05','09:10:00',2.62),('11288','2013-03-05','09:15:00',2.58),('11288','2013-03-05','09:20:00',2.65),('11288','2013-03-05','09:25:00',2.62),('11288','2013-03-05','09:30:00',2.75),('11288','2013-03-05','09:35:00',2.93),('11288','2013-03-05','09:40:00',3.09),('11288','2013-03-05','09:45:00',3.13),('11288','2013-03-05','09:50:00',3.07),('11288','2013-03-05','09:55:00',2.97),('11288','2013-03-05','10:00:00',2.81),('11288','2013-03-05','10:05:00',3.06),('11288','2013-03-05','10:10:00',3.15),('11288','2013-03-05','10:15:00',3.31),('11288','2013-03-05','10:20:00',3.59),('11288','2013-03-05','10:25:00',3.22),('11288','2013-03-05','10:30:00',3.21),('11288','2013-03-05','10:35:00',3.63),('11288','2013-03-05','10:40:00',3.65),('11288','2013-03-05','10:45:00',3.89),('11288','2013-03-05','10:50:00',4.28),('11288','2013-03-05','10:55:00',4.28),('11288','2013-03-05','11:00:00',3.98),('11288','2013-03-05','11:05:00',4.35),('11288','2013-03-05','11:10:00',4.47),('11288','2013-03-05','11:15:00',4.45),('11288','2013-03-05','11:20:00',4.4),('11288','2013-03-05','11:25:00',4.3),('11288','2013-03-05','11:30:00',4.42),('11288','2013-03-05','11:35:00',4.85),('11288','2013-03-05','11:40:00',5.2),('11288','2013-03-05','11:45:00',5.01),('11288','2013-03-05','11:50:00',5.01),('11288','2013-03-05','11:55:00',5.13),('11288','2013-03-05','12:00:00',5.2),('11288','2013-03-05','12:05:00',5.29),('11288','2013-03-05','12:10:00',5.56),('11288','2013-03-05','12:15:00',4.44),('11288','2013-03-05','12:20:00',5.16),('11288','2013-03-05','12:25:00',5.03),('11288','2013-03-05','12:30:00',4.26),('11288','2013-03-05','12:35:00',3.92),('11288','2013-03-05','12:40:00',4.07),('11288','2013-03-05','12:45:00',4.37),('11288','2013-03-05','12:50:00',3.85),('11288','2013-03-05','12:55:00',3.48),('11288','2013-03-05','13:00:00',3.01),('11288','2013-03-05','13:05:00',2.93),('11288','2013-03-05','13:10:00',3.15),('11288','2013-03-05','13:15:00',3.31),('11288','2013-03-05','13:20:00',3.16),('11288','2013-03-05','13:25:00',2.87),('11288','2013-03-05','13:30:00',2.64),('11288','2013-03-05','13:35:00',2.53),('11288','2013-03-05','13:40:00',2.39),('11288','2013-03-05','13:45:00',2.18),('11288','2013-03-05','13:50:00',1.99),('11288','2013-03-05','13:55:00',1.9),('11288','2013-03-05','14:00:00',1.9),('11288','2013-03-05','14:05:00',1.95),('11288','2013-03-05','14:10:00',2.02),('11288','2013-03-05','14:15:00',1.87),('11288','2013-03-05','14:20:00',1.77),('11288','2013-03-05','14:25:00',1.79),('11288','2013-03-05','14:30:00',1.73),('11288','2013-03-05','14:35:00',1.76),('11288','2013-03-05','14:40:00',1.82),('11288','2013-03-05','14:45:00',1.86),('11288','2013-03-05','14:50:00',1.81),('11288','2013-03-05','14:55:00',1.64),('11288','2013-03-05','15:00:00',1.48),('11288','2013-03-05','15:05:00',1.38),('11288','2013-03-05','15:10:00',1.13),('11288','2013-03-05','15:20:00',1.15),('11288','2013-03-05','15:25:00',1.34),('11288','2013-03-05','15:30:00',1.57),('11288','2013-03-05','15:35:00',1.61),('11288','2013-03-05','15:40:00',1.73),('11288','2013-03-05','15:45:00',2.07),('11288','2013-03-05','15:50:00',1.99),('11288','2013-03-05','15:55:00',1.67),('11288','2013-03-05','16:00:00',1.52),('11288','2013-03-05','16:05:00',1.32),('11288','2013-03-05','16:10:00',1.08),('11288','2013-03-04','07:50:00',1.04),('11288','2013-03-04','07:55:00',1.08),('11288','2013-03-04','08:00:00',1.28),('11288','2013-03-04','08:05:00',1.36),('11288','2013-03-04','08:10:00',1.51),('11288','2013-03-04','08:15:00',1.66),('11288','2013-03-04','08:20:00',1.81),('11288','2013-03-04','08:25:00',1.93),('11288','2013-03-04','08:30:00',2.16),('11288','2013-03-04','08:35:00',2.3),('11288','2013-03-04','08:40:00',2.27),('11288','2013-03-04','08:45:00',2.5),('11288','2013-03-04','08:50:00',2.71),('11288','2013-03-04','08:55:00',2.88),('11288','2013-03-04','09:00:00',3.07),('11288','2013-03-04','09:05:00',3.22),('11288','2013-03-04','09:10:00',3.39),('11288','2013-03-04','09:15:00',3.49),('11288','2013-03-04','09:20:00',3.64),('11288','2013-03-04','09:25:00',3.7),('11288','2013-03-04','09:30:00',3.72),('11288','2013-03-04','09:35:00',4),('11288','2013-03-04','09:40:00',4.08),('11288','2013-03-04','09:45:00',4.22),('11288','2013-03-04','09:50:00',4.36),('11288','2013-03-04','09:55:00',4.48),('11288','2013-03-04','10:00:00',4.53),('11288','2013-03-04','10:05:00',4.64),('11288','2013-03-04','10:10:00',4.79),('11288','2013-03-04','10:15:00',4.84),('11288','2013-03-04','10:20:00',4.95),('11288','2013-03-04','10:25:00',4.96),('11288','2013-03-04','10:30:00',5),('11288','2013-03-04','10:35:00',5.13),('11288','2013-03-04','10:40:00',5.14),('11288','2013-03-04','10:45:00',5.15),('11288','2013-03-04','10:50:00',5.19),('11288','2013-03-04','10:55:00',5.31),('11288','2013-03-04','11:00:00',5.36),('11288','2013-03-04','11:05:00',5.49),('11288','2013-03-04','11:10:00',5.55),('11288','2013-03-04','11:15:00',5.55),('11288','2013-03-04','11:20:00',5.55),('11288','2013-03-04','11:25:00',5.64),('11288','2013-03-04','11:30:00',5.61),('11288','2013-03-04','11:35:00',5.71),('11288','2013-03-04','11:40:00',5.83),('11288','2013-03-04','11:45:00',5.82),('11288','2013-03-04','11:50:00',5.8),('11288','2013-03-04','11:55:00',5.84),('11288','2013-03-04','12:00:00',5.89),('11288','2013-03-04','12:05:00',5.87),('11288','2013-03-04','12:10:00',5.89),('11288','2013-03-04','12:15:00',5.93),('11288','2013-03-04','12:20:00',5.83),('11288','2013-03-04','12:25:00',5.79),('11288','2013-03-04','12:30:00',5.77),('11288','2013-03-04','12:35:00',5.82),('11288','2013-03-04','12:40:00',5.81),('11288','2013-03-04','12:45:00',5.71),('11288','2013-03-04','12:50:00',5.59),('11288','2013-03-04','12:55:00',5.56),('11288','2013-03-04','13:00:00',5.59),('11288','2013-03-04','13:05:00',5.53),('11288','2013-03-04','13:10:00',5.58),('11288','2013-03-04','13:15:00',5.51),('11288','2013-03-04','13:20:00',5.41),('11288','2013-03-04','13:25:00',5.5),('11288','2013-03-04','13:30:00',5.61),('11288','2013-03-04','13:35:00',5.72),('11288','2013-03-04','13:40:00',5.41),('11288','2013-03-04','13:45:00',5.09),('11288','2013-03-04','13:50:00',5.16),('11288','2013-03-04','13:55:00',5.03),('11288','2013-03-04','14:00:00',4.99),('11288','2013-03-04','14:05:00',4.89),('11288','2013-03-04','14:10:00',4.56),('11288','2013-03-04','14:15:00',4.59),('11288','2013-03-04','14:20:00',4.56),('11288','2013-03-04','14:25:00',4.1),('11288','2013-03-04','14:30:00',4.46),('11288','2013-03-04','14:35:00',4.37),('11288','2013-03-04','14:40:00',4.17),('11288','2013-03-04','14:45:00',3.93),('11288','2013-03-04','14:50:00',3.96),('11288','2013-03-04','14:55:00',3.83),('11288','2013-03-04','15:00:00',3.78),('11288','2013-03-04','15:05:00',3.71),('11288','2013-03-04','15:10:00',3.55),('11288','2013-03-04','15:15:00',3.34),('11288','2013-03-04','15:20:00',3.29),('11288','2013-03-04','15:25:00',3.18),('11288','2013-03-04','15:30:00',3.02),('11288','2013-03-04','15:35:00',2.93),('11288','2013-03-04','15:40:00',2.84),('11288','2013-03-04','15:45:00',2.66),('11288','2013-03-04','15:50:00',2.54),('11288','2013-03-04','15:55:00',2.43),('11288','2013-03-04','16:00:00',2.31),('11288','2013-03-04','16:05:00',2.14),('11288','2013-03-04','16:10:00',1.9),('11288','2013-03-04','16:15:00',1.71),('11288','2013-03-04','16:20:00',1.71),('11288','2013-03-04','16:25:00',1.69),('11288','2013-03-04','16:30:00',1.57),('11288','2013-03-04','16:35:00',1.43),('11288','2013-03-04','16:40:00',1.29),('11288','2013-03-04','16:45:00',1.15),('11288','2013-03-04','16:50:00',1.04),('11288','2013-03-03','07:55:00',1.07),('11288','2013-03-03','08:00:00',1.11),('11288','2013-03-03','08:05:00',1.31),('11288','2013-03-03','08:10:00',1.47),('11288','2013-03-03','08:15:00',1.68),('11288','2013-03-03','08:20:00',1.83),('11288','2013-03-03','08:25:00',1.97),('11288','2013-03-03','08:30:00',2.14),('11288','2013-03-03','08:35:00',2.33),('11288','2013-03-03','08:40:00',2.53),('11288','2013-03-03','08:45:00',2.64),('11288','2013-03-03','08:50:00',2.82),('11288','2013-03-03','08:55:00',2.98),('11288','2013-03-03','09:00:00',3.16),('11288','2013-03-03','09:05:00',3.33),('11288','2013-03-03','09:10:00',3.48),('11288','2013-03-03','09:15:00',3.52),('11288','2013-03-03','09:20:00',3.6),('11288','2013-03-03','09:25:00',3.8),('11288','2013-03-03','09:30:00',3.94),('11288','2013-03-03','09:35:00',4.06),('11288','2013-03-03','09:40:00',4.16),('11288','2013-03-03','09:45:00',4.3),('11288','2013-03-03','09:50:00',4.47),('11288','2013-03-03','09:55:00',4.63),('11288','2013-03-03','10:00:00',4.75),('11288','2013-03-03','10:05:00',4.85),('11288','2013-03-03','10:10:00',4.98),('11288','2013-03-03','10:15:00',5.08),('11288','2013-03-03','10:20:00',5.14),('11288','2013-03-03','10:25:00',5.18),('11288','2013-03-03','10:30:00',5.28),('11288','2013-03-03','10:35:00',5.38),('11288','2013-03-03','10:40:00',5.44),('11288','2013-03-03','10:45:00',5.46),('11288','2013-03-03','10:50:00',5.46),('11288','2013-03-03','10:55:00',5.52),('11288','2013-03-03','11:00:00',5.63),('11288','2013-03-03','11:05:00',5.68),('11288','2013-03-03','11:10:00',5.68),('11288','2013-03-03','11:15:00',5.72),('11288','2013-03-03','11:20:00',5.75),('11288','2013-03-03','11:25:00',5.82),('11288','2013-03-03','11:30:00',5.95),('11288','2013-03-03','11:35:00',5.99),('11288','2013-03-03','11:40:00',5.98),('11288','2013-03-03','11:45:00',5.97),('11288','2013-03-03','11:50:00',5.97),('11288','2013-03-03','11:55:00',5.93),('11288','2013-03-03','12:00:00',6.02),('11288','2013-03-03','12:05:00',6.04),('11288','2013-03-03','12:10:00',6.05),('11288','2013-03-03','12:15:00',6.03),('11288','2013-03-03','12:20:00',5.98),('11288','2013-03-03','12:25:00',5.96),('11288','2013-03-03','12:30:00',5.97),('11288','2013-03-03','12:35:00',5.99),('11288','2013-03-03','12:40:00',6.03),('11288','2013-03-03','12:45:00',6.02),('11288','2013-03-03','12:50:00',5.93),('11288','2013-03-03','12:55:00',5.91),('11288','2013-03-03','13:00:00',5.88),('11288','2013-03-03','13:05:00',5.84),('11288','2013-03-03','13:10:00',5.8),('11288','2013-03-03','13:15:00',5.77),('11288','2013-03-03','13:20:00',5.73),('11288','2013-03-03','13:25:00',5.67),('11288','2013-03-03','13:30:00',5.62),('11288','2013-03-03','13:35:00',5.56),('11288','2013-03-03','13:40:00',5.52),('11288','2013-03-03','13:45:00',5.48),('11288','2013-03-03','13:50:00',5.37),('11288','2013-03-03','13:55:00',5.34),('11288','2013-03-03','14:00:00',5.27),('11288','2013-03-03','14:05:00',5.23),('11288','2013-03-03','14:10:00',5.14),('11288','2013-03-03','14:15:00',5.03),('11288','2013-03-03','14:20:00',4.95),('11288','2013-03-03','14:25:00',4.9),('11288','2013-03-03','14:30:00',4.82),('11288','2013-03-03','14:35:00',4.74),('11288','2013-03-03','14:40:00',4.6),('11288','2013-03-03','14:45:00',4.53),('11288','2013-03-03','14:50:00',4.4),('11288','2013-03-03','14:55:00',4.21),('11288','2013-03-03','15:00:00',4.1),('11288','2013-03-03','15:05:00',3.99),('11288','2013-03-03','15:10:00',3.86),('11288','2013-03-03','15:15:00',3.58),('11288','2013-03-03','15:20:00',3.65),('11288','2013-03-03','15:25:00',3.53),('11288','2013-03-03','15:30:00',3.31),('11288','2013-03-03','15:35:00',2.96),('11288','2013-03-03','15:40:00',3.07),('11288','2013-03-03','15:45:00',2.93),('11288','2013-03-03','15:50:00',2.78),('11288','2013-03-03','15:55:00',2.62),('11288','2013-03-03','16:00:00',2.5),('11288','2013-03-03','16:05:00',2.34),('11288','2013-03-03','16:10:00',2.16),('11288','2013-03-03','16:15:00',2.04),('11288','2013-03-03','16:20:00',1.82),('11288','2013-03-03','16:25:00',1.72),('11288','2013-03-03','16:30:00',1.6),('11288','2013-03-03','16:35:00',1.46),('11288','2013-03-03','16:40:00',1.32),('11288','2013-03-03','16:45:00',1.18),('11288','2013-03-03','16:50:00',1.07),('11288','2014-03-24','07:40:00',1.02),('11288','2014-03-24','07:45:00',2.05),('11288','2014-03-24','07:50:00',1.4),('11288','2014-03-24','07:55:00',1.44),('11288','2014-03-24','08:30:00',1.06),('11288','2014-03-24','08:35:00',1.53),('11288','2014-03-24','08:40:00',1.6),('11288','2014-03-24','08:45:00',1.2),('11288','2014-03-24','08:50:00',1.42),('11288','2014-03-24','08:55:00',2.61),('11288','2014-03-24','09:00:00',2.77),('11288','2014-03-24','09:05:00',1.72),('11288','2014-03-24','09:10:00',1.06),('11288','2014-03-24','09:15:00',1.8),('11288','2014-03-24','09:20:00',2.04),('11288','2014-03-24','09:25:00',1.62),('11288','2014-03-24','09:30:00',2.08),('11288','2014-03-24','09:35:00',1.59),('11288','2014-03-24','09:40:00',2.57),('11288','2014-03-24','09:45:00',1.81),('11288','2014-03-24','09:50:00',1.8),('11288','2014-03-24','09:55:00',1.25),('11288','2014-03-24','10:00:00',3.41),('11288','2014-03-24','10:05:00',3.53),('11288','2014-03-24','10:10:00',4.94),('11288','2014-03-24','10:15:00',3.29),('11288','2014-03-24','10:20:00',1.66),('11288','2014-03-24','10:25:00',1.37),('11288','2014-03-24','10:30:00',1.37),('11288','2014-03-24','10:35:00',2.49),('11288','2014-03-24','10:40:00',1.8),('11288','2014-03-24','10:45:00',3.51),('11288','2014-03-24','10:50:00',7.43),('11288','2014-03-24','10:55:00',5.34),('11288','2014-03-24','11:00:00',3.03),('11288','2014-03-24','11:05:00',3.6),('11288','2014-03-24','11:10:00',4.81),('11288','2014-03-24','11:15:00',5.42),('11288','2014-03-24','11:20:00',4.36),('11288','2014-03-24','11:25:00',5.5),('11288','2014-03-24','11:30:00',5.94),('11288','2014-03-24','11:35:00',2.56),('11288','2014-03-24','11:40:00',1.42),('11288','2014-03-24','11:45:00',1.11),('11288','2014-03-24','11:50:00',1.07),('11288','2014-03-24','11:55:00',1.41),('11288','2014-03-24','12:00:00',1.13),('11288','2014-03-24','12:20:00',1.1),('11288','2014-03-24','12:25:00',1.36),('11288','2014-03-24','12:30:00',2.17),('11288','2014-03-24','12:35:00',3.55),('11288','2014-03-24','12:40:00',3.53),('11288','2014-03-24','12:45:00',3.08),('11288','2014-03-24','12:50:00',2.62),('11288','2014-03-24','12:55:00',2.52),('11288','2014-03-24','13:00:00',2.55),('11288','2014-03-24','13:05:00',2.52),('11288','2014-03-24','13:10:00',2.15),('11288','2014-03-24','13:15:00',1.82),('11288','2014-03-24','13:20:00',1.87),('11288','2014-03-24','13:25:00',2.17),('11288','2014-03-24','13:30:00',2.5),('11288','2014-03-24','13:35:00',2.07),('11288','2014-03-24','13:40:00',1.31),('11288','2014-03-24','13:45:00',2.1),('11288','2014-03-24','13:50:00',2.44),('11288','2014-03-24','13:55:00',2.37),('11288','2014-03-24','14:00:00',2.05),('11288','2014-03-24','14:05:00',1.92),('11288','2014-03-24','14:10:00',2.31),('11288','2014-03-24','14:15:00',3),('11288','2014-03-24','14:20:00',3.76),('11288','2014-03-24','14:25:00',3.59),('11288','2014-03-24','14:30:00',3.43),('11288','2014-03-24','14:35:00',4.12),('11288','2014-03-24','14:40:00',4.96),('11288','2014-03-24','14:45:00',5.46),('11288','2014-03-24','14:50:00',5.41),('11288','2014-03-24','14:55:00',4.81),('11288','2014-03-24','15:00:00',4.31),('11288','2014-03-24','15:05:00',3.87),('11288','2014-03-24','15:10:00',3.42),('11288','2014-03-24','15:15:00',2.75),('11288','2014-03-24','15:20:00',2.82),('11288','2014-03-24','15:25:00',2.77),('11288','2014-03-24','15:30:00',2.71),('11288','2014-03-24','15:35:00',2.54),('11288','2014-03-24','15:40:00',2.15),('11288','2014-03-24','15:45:00',1.9),('11288','2014-03-24','15:50:00',2.12),('11288','2014-03-24','15:55:00',2.64),('11288','2014-03-24','16:00:00',3.48),('11288','2014-03-24','16:05:00',2.38),('11288','2014-03-24','16:10:00',1.93),('11288','2014-03-24','16:15:00',1.51),('11288','2013-03-02','08:50:00',1.07),('11288','2013-03-02','08:55:00',1.1),('11288','2013-03-02','09:00:00',1.18),('11288','2013-03-02','09:05:00',1.05),('11288','2013-03-02','09:40:00',1.15),('11288','2013-03-02','09:45:00',1.37),('11288','2013-03-02','09:50:00',1.45),('11288','2013-03-02','09:55:00',1.26),('11288','2013-03-02','10:00:00',1.17),('11288','2013-03-02','10:05:00',1.22),('11288','2013-03-02','10:10:00',1.1),('11288','2013-03-02','10:15:00',1.16),('11288','2013-03-02','10:20:00',1.39),('11288','2013-03-02','10:25:00',1.45),('11288','2013-03-02','10:30:00',1.55),('11288','2013-03-02','10:35:00',1.69),('11288','2013-03-02','10:40:00',1.81),('11288','2013-03-02','10:45:00',1.8),('11288','2013-03-02','10:50:00',2),('11288','2013-03-02','10:55:00',2.08),('11288','2013-03-02','11:00:00',2.22),('11288','2013-03-02','11:05:00',2.32),('11288','2013-03-02','11:10:00',2.4),('11288','2013-03-02','11:15:00',2.76),('11288','2013-03-02','11:20:00',2.47),('11288','2013-03-02','11:25:00',2.18),('11288','2013-03-02','11:30:00',2),('11288','2013-03-02','11:35:00',2.07),('11288','2013-03-02','11:40:00',2.32),('11288','2013-03-02','11:45:00',2.11),('11288','2013-03-02','11:50:00',2.17),('11288','2013-03-02','11:55:00',2.02),('11288','2013-03-02','12:00:00',1.99),('11288','2013-03-02','12:05:00',2.29),('11288','2013-03-02','12:10:00',2.26),('11288','2013-03-02','12:15:00',2.39),('11288','2013-03-02','12:20:00',2.23),('11288','2013-03-02','12:25:00',2.32),('11288','2013-03-02','12:30:00',2.6),('11288','2013-03-02','12:35:00',2.78),('11288','2013-03-02','12:40:00',3.07),('11288','2013-03-02','12:45:00',2.89),('11288','2013-03-02','12:50:00',2.69),('11288','2013-03-02','12:55:00',3.78),('11288','2013-03-02','13:00:00',3.45),('11288','2013-03-02','13:05:00',2.83),('11288','2013-03-02','13:10:00',2.04),('11288','2013-03-02','13:15:00',1.73),('11288','2013-03-02','13:20:00',1.65),('11288','2013-03-02','13:25:00',1.67),('11288','2013-03-02','13:30:00',1.84),('11288','2013-03-02','13:35:00',1.87),('11288','2013-03-02','13:40:00',2),('11288','2013-03-02','13:45:00',2.14),('11288','2013-03-02','13:50:00',2.08),('11288','2013-03-02','13:55:00',2.16),('11288','2013-03-02','14:00:00',2.41),('11288','2013-03-02','14:05:00',2.33),('11288','2013-03-02','14:10:00',2.05),('11288','2013-03-02','14:15:00',1.87),('11288','2013-03-02','14:20:00',1.8),('11288','2013-03-02','14:25:00',1.49),('11288','2013-03-02','14:30:00',1.09),('11288','2013-03-02','14:50:00',1.22),('11288','2013-03-02','14:55:00',1.37),('11288','2013-03-02','15:00:00',1.36),('11288','2013-03-02','15:05:00',1.56),('11288','2013-03-02','15:10:00',1.55),('11288','2013-03-02','15:15:00',1.49),('11288','2013-03-02','15:20:00',1.43),('11288','2013-03-02','15:25:00',1.36),('11288','2013-03-02','15:30:00',1.54),('11288','2013-03-02','15:35:00',1.49),('11288','2013-03-02','15:40:00',1.36),('11288','2013-03-02','15:45:00',1.55),('11288','2013-03-02','15:50:00',1.35),('11288','2013-03-02','15:55:00',1.33),('11288','2013-03-02','16:00:00',1.2),('11288','2013-03-02','16:05:00',1.04),('11288','2013-03-01','07:50:00',1.12),('11288','2013-03-01','07:55:00',1.35),('11288','2013-03-01','08:00:00',1.46),('11288','2013-03-01','08:05:00',1.35),('11288','2013-03-01','08:10:00',1.52),('11288','2013-03-01','08:15:00',1.63),('11288','2013-03-01','08:20:00',1.73),('11288','2013-03-01','08:25:00',1.77),('11288','2013-03-01','08:30:00',1.9),('11288','2013-03-01','08:35:00',2.01),('11288','2013-03-01','08:40:00',2.15),('11288','2013-03-01','08:45:00',2.25),('11288','2013-03-01','08:50:00',2.36),('11288','2013-03-01','08:55:00',2.55),('11288','2013-03-01','09:00:00',2.75),('11288','2013-03-01','09:05:00',2.94),('11288','2013-03-01','09:10:00',2.91),('11288','2013-03-01','09:15:00',3.01),('11288','2013-03-01','09:20:00',3.06),('11288','2013-03-01','09:25:00',3.05),('11288','2013-03-01','09:30:00',3.29),('11288','2013-03-01','09:35:00',3.23),('11288','2013-03-01','09:40:00',3.58),('11288','2013-03-01','09:45:00',3.78),('11288','2013-03-01','09:50:00',3.75),('11288','2013-03-01','09:55:00',3.86),('11288','2013-03-01','10:00:00',3.94),('11288','2013-03-01','10:05:00',3.95),('11288','2013-03-01','10:10:00',3.77),('11288','2013-03-01','10:15:00',3.35),('11288','2013-03-01','10:20:00',3.46),('11288','2013-03-01','10:25:00',3.66),('11288','2013-03-01','10:30:00',4.22),('11288','2013-03-01','10:35:00',4.2),('11288','2013-03-01','10:40:00',3.89),('11288','2013-03-01','10:45:00',3.67),('11288','2013-03-01','10:50:00',3.52),('11288','2013-03-01','10:55:00',3.36),('11288','2013-03-01','11:00:00',3),('11288','2013-03-01','11:05:00',2.77),('11288','2013-03-01','11:10:00',2.8),('11288','2013-03-01','11:15:00',3.11),('11288','2013-03-01','11:20:00',3.2),('11288','2013-03-01','11:25:00',3.19),('11288','2013-03-01','11:30:00',3.28),('11288','2013-03-01','11:35:00',3.26),('11288','2013-03-01','11:40:00',3.1),('11288','2013-03-01','11:45:00',3),('11288','2013-03-01','11:50:00',2.94),('11288','2013-03-01','11:55:00',2.83),('11288','2013-03-01','12:00:00',2.72),('11288','2013-03-01','12:05:00',2.57),('11288','2013-03-01','12:10:00',2.4),('11288','2013-03-01','12:15:00',2.19),('11288','2013-03-01','12:20:00',2.07),('11288','2013-03-01','12:25:00',2.07),('11288','2013-03-01','12:30:00',2.16),('11288','2013-03-01','12:35:00',2.13),('11288','2013-03-01','12:40:00',2.05),('11288','2013-03-01','12:45:00',2.06),('11288','2013-03-01','12:50:00',2.13),('11288','2013-03-01','12:55:00',2.26),('11288','2013-03-01','13:00:00',2.37),('11288','2013-03-01','13:05:00',2.4),('11288','2013-03-01','13:10:00',2.47),('11288','2013-03-01','13:15:00',2.64),('11288','2013-03-01','13:20:00',2.87),('11288','2013-03-01','13:25:00',3.07),('11288','2013-03-01','13:30:00',2.94),('11288','2013-03-01','13:35:00',2.76),('11288','2013-03-01','13:40:00',2.64),('11288','2013-03-01','13:45:00',2.63),('11288','2013-03-01','13:50:00',2.6),('11288','2013-03-01','13:55:00',2.51),('11288','2013-03-01','14:00:00',2.42),('11288','2013-03-01','14:05:00',2.32),('11288','2013-03-01','14:10:00',2.18),('11288','2013-03-01','14:15:00',2.07),('11288','2013-03-01','14:20:00',2),('11288','2013-03-01','14:25:00',2.02),('11288','2013-03-01','14:30:00',2.07),('11288','2013-03-01','14:35:00',2.06),('11288','2013-03-01','14:40:00',1.96),('11288','2013-03-01','14:45:00',1.84),('11288','2013-03-01','14:50:00',1.76),('11288','2013-03-01','14:55:00',1.75),('11288','2013-03-01','15:00:00',1.76),('11288','2013-03-01','15:05:00',1.69),('11288','2013-03-01','15:10:00',1.55),('11288','2013-03-01','15:15:00',1.43),('11288','2013-03-01','15:20:00',1.34),('11288','2013-03-01','15:25:00',1.2),('11288','2013-03-01','15:30:00',1.09),('11288','2013-03-01','15:35:00',1.12),('11288','2013-03-01','15:40:00',1.22),('11288','2013-03-01','15:45:00',1.18),('11288','2013-03-01','15:50:00',1.11),('11288','2013-03-01','15:55:00',1.06),('11288','2013-03-01','16:00:00',1.09),('11288','2013-03-01','16:05:00',1.08),('11288','2013-03-01','16:10:00',1.03),('11288','2013-02-28','07:55:00',1.01),('11288','2013-02-28','08:00:00',1.1),('11288','2013-02-28','08:05:00',1.13),('11288','2013-02-28','08:10:00',1.34),('11288','2013-02-28','08:15:00',1.45),('11288','2013-02-28','08:20:00',1.55),('11288','2013-02-28','08:25:00',1.72),('11288','2013-02-28','08:30:00',1.88),('11288','2013-02-28','08:35:00',1.89),('11288','2013-02-28','08:40:00',2.11),('11288','2013-02-28','08:45:00',2.31),('11288','2013-02-28','08:50:00',2.46),('11288','2013-02-28','08:55:00',2.65),('11288','2013-02-28','09:00:00',2.76),('11288','2013-02-28','09:05:00',2.87),('11288','2013-02-28','09:10:00',2.99),('11288','2013-02-28','09:15:00',3.14),('11288','2013-02-28','09:20:00',3.18),('11288','2013-02-28','09:25:00',3.36),('11288','2013-02-28','09:30:00',3.54),('11288','2013-02-28','09:35:00',3.65),('11288','2013-02-28','09:40:00',3.79),('11288','2013-02-28','09:45:00',3.93),('11288','2013-02-28','09:50:00',3.75),('11288','2013-02-28','09:55:00',4.11),('11288','2013-02-28','10:00:00',4.25),('11288','2013-02-28','10:05:00',4.38),('11288','2013-02-28','10:10:00',4.48),('11288','2013-02-28','10:15:00',4.53),('11288','2013-02-28','10:20:00',4.57),('11288','2013-02-28','10:25:00',4.67),('11288','2013-02-28','10:30:00',4.63),('11288','2013-02-28','10:35:00',4.72),('11288','2013-02-28','10:40:00',4.76),('11288','2013-02-28','10:45:00',4.79),('11288','2013-02-28','10:50:00',4.93),('11288','2013-02-28','10:55:00',4.99),('11288','2013-02-28','11:00:00',5.14),('11288','2013-02-28','11:05:00',5.23),('11288','2013-02-28','11:10:00',5.24),('11288','2013-02-28','11:15:00',5.29),('11288','2013-02-28','11:20:00',5.36),('11288','2013-02-28','11:25:00',5.43),('11288','2013-02-28','11:30:00',5.51),('11288','2013-02-28','11:35:00',5.45),('11288','2013-02-28','11:40:00',5.44),('11288','2013-02-28','11:45:00',5.36),('11288','2013-02-28','11:50:00',5.3),('11288','2013-02-28','11:55:00',5.45),('11288','2013-02-28','12:00:00',5.53),('11288','2013-02-28','12:05:00',5.56),('11288','2013-02-28','12:10:00',5.64),('11288','2013-02-28','12:15:00',5.5),('11288','2013-02-28','12:20:00',5.6),('11288','2013-02-28','12:25:00',5.6),('11288','2013-02-28','12:30:00',5.64),('11288','2013-02-28','12:35:00',5.65),('11288','2013-02-28','12:40:00',5.53),('11288','2013-02-28','12:45:00',5.47),('11288','2013-02-28','12:50:00',5.49),('11288','2013-02-28','12:55:00',5.48),('11288','2013-02-28','13:00:00',5.21),('11288','2013-02-28','13:05:00',5.49),('11288','2013-02-28','13:10:00',5.35),('11288','2013-02-28','13:15:00',5.26),('11288','2013-02-28','13:20:00',5.39),('11288','2013-02-28','13:25:00',5.34),('11288','2013-02-28','13:30:00',5.03),('11288','2013-02-28','13:35:00',5.25),('11288','2013-02-28','13:40:00',5.3),('11288','2013-02-28','13:45:00',5.4),('11288','2013-02-28','13:50:00',5.26),('11288','2013-02-28','13:55:00',4.74),('11288','2013-02-28','14:00:00',5.3),('11288','2013-02-28','14:05:00',5.18),('11288','2013-02-28','14:10:00',5.08),('11288','2013-02-28','14:15:00',4.93),('11288','2013-02-28','14:20:00',4.75),('11288','2013-02-28','14:25:00',4.59),('11288','2013-02-28','14:30:00',4.32),('11288','2013-02-28','14:35:00',4.05),('11288','2013-02-28','14:40:00',4.14),('11288','2013-02-28','14:45:00',4.08),('11288','2013-02-28','14:50:00',3.99),('11288','2013-02-28','14:55:00',3.8),('11288','2013-02-28','15:00:00',3.76),('11288','2013-02-28','15:05:00',3.63),('11288','2013-02-28','15:10:00',3.47),('11288','2013-02-28','15:15:00',3.29),('11288','2013-02-28','15:20:00',3.1),('11288','2013-02-28','15:25:00',2.98),('11288','2013-02-28','15:30:00',2.82),('11288','2013-02-28','15:35:00',2.71),('11288','2013-02-28','15:40:00',2.51),('11288','2013-02-28','15:45:00',2.51),('11288','2013-02-28','15:50:00',2.39),('11288','2013-02-28','15:55:00',2.23),('11288','2013-02-28','16:00:00',2.12),('11288','2013-02-28','16:05:00',1.97),('11288','2013-02-28','16:10:00',1.78),('11288','2013-02-28','16:15:00',1.69),('11288','2013-02-28','16:20:00',1.58),('11288','2013-02-28','16:25:00',1.44),('11288','2013-02-28','16:30:00',1.32),('11288','2013-02-28','16:35:00',1.26),('11288','2013-02-28','16:40:00',1.14),('11288','2013-02-28','16:45:00',1.04),('11288','2013-02-27','08:00:00',1.07),('11288','2013-02-27','08:05:00',1.16),('11288','2013-02-27','08:10:00',1.17),('11288','2013-02-27','08:15:00',1.38),('11288','2013-02-27','08:20:00',1.5),('11288','2013-02-27','08:25:00',1.63),('11288','2013-02-27','08:30:00',1.77),('11288','2013-02-27','08:35:00',1.8),('11288','2013-02-27','08:40:00',1.87),('11288','2013-02-27','08:45:00',2.22),('11288','2013-02-27','08:50:00',2.36),('11288','2013-02-27','08:55:00',2.48),('11288','2013-02-27','09:00:00',2.64),('11288','2013-02-27','09:05:00',2.78),('11288','2013-02-27','09:10:00',2.94),('11288','2013-02-27','09:15:00',3.01),('11288','2013-02-27','09:20:00',3.13),('11288','2013-02-27','09:25:00',3.19),('11288','2013-02-27','09:30:00',3.4),('11288','2013-02-27','09:35:00',3.55),('11288','2013-02-27','09:40:00',3.67),('11288','2013-02-27','09:45:00',3.78),('11288','2013-02-27','09:50:00',3.88),('11288','2013-02-27','09:55:00',4.02),('11288','2013-02-27','10:00:00',4.19),('11288','2013-02-27','10:05:00',4.27),('11288','2013-02-27','10:10:00',4.38),('11288','2013-02-27','10:15:00',4.48),('11288','2013-02-27','10:20:00',4.6),('11288','2013-02-27','10:25:00',4.64),('11288','2013-02-27','10:30:00',4.68),('11288','2013-02-27','10:35:00',4.8),('11288','2013-02-27','10:40:00',4.85),('11288','2013-02-27','10:45:00',4.86),('11288','2013-02-27','10:50:00',4.94),('11288','2013-02-27','10:55:00',4.99),('11288','2013-02-27','11:00:00',5.11),('11288','2013-02-27','11:05:00',5.12),('11288','2013-02-27','11:10:00',5.2),('11288','2013-02-27','11:15:00',5.25),('11288','2013-02-27','11:20:00',5.42),('11288','2013-02-27','11:25:00',5.15),('11288','2013-02-27','11:30:00',5.31),('11288','2013-02-27','11:35:00',5.54),('11288','2013-02-27','11:40:00',2.9),('11288','2013-02-27','11:45:00',3.9),('11288','2013-02-27','11:50:00',5.01),('11288','2013-02-27','11:55:00',5.32),('11288','2013-02-27','12:00:00',5.57),('11288','2013-02-27','12:05:00',3.48),('11288','2013-02-27','12:10:00',1.11),('11288','2013-02-27','12:15:00',3.9),('11288','2013-02-27','12:20:00',4.85),('11288','2013-02-27','12:25:00',2.58),('11288','2013-02-27','12:30:00',6.01),('11288','2013-02-27','12:35:00',5.89),('11288','2013-02-27','12:40:00',5.81),('11288','2013-02-27','12:45:00',5.82),('11288','2013-02-27','12:50:00',5.67),('11288','2013-02-27','12:55:00',5.64),('11288','2013-02-27','13:00:00',5.61),('11288','2013-02-27','13:05:00',5.62),('11288','2013-02-27','13:10:00',5.48),('11288','2013-02-27','13:15:00',5.56),('11288','2013-02-27','13:20:00',5.56),('11288','2013-02-27','13:25:00',5.66),('11288','2013-02-27','13:30:00',5.6),('11288','2013-02-27','13:35:00',5.48),('11288','2013-02-27','13:40:00',5.48),('11288','2013-02-27','13:45:00',5.42),('11288','2013-02-27','13:50:00',5.39),('11288','2013-02-27','13:55:00',5.3),('11288','2013-02-27','14:00:00',5.07),('11288','2013-02-27','14:05:00',4.91),('11288','2013-02-27','14:10:00',4.66),('11288','2013-02-27','14:15:00',4.73),('11288','2013-02-27','14:20:00',4),('11288','2013-02-27','14:25:00',3.6),('11288','2013-02-27','14:30:00',3.63),('11288','2013-02-27','14:35:00',4.52),('11288','2013-02-27','14:40:00',4.39),('11288','2013-02-27','14:45:00',4.37),('11288','2013-02-27','14:50:00',4.15),('11288','2013-02-27','14:55:00',3.85),('11288','2013-02-27','15:00:00',3.78),('11288','2013-02-27','15:05:00',3.84),('11288','2013-02-27','15:10:00',3.56),('11288','2013-02-27','15:15:00',3.47),('11288','2013-02-27','15:20:00',3.34),('11288','2013-02-27','15:25:00',3.17),('11288','2013-02-27','15:30:00',3.02),('11288','2013-02-27','15:35:00',2.89),('11288','2013-02-27','15:40:00',2.74),('11288','2013-02-27','15:45:00',2.66),('11288','2013-02-27','15:50:00',2.52),('11288','2013-02-27','15:55:00',2.4),('11288','2013-02-27','16:00:00',2.13),('11288','2013-02-27','16:05:00',2.1),('11288','2013-02-27','16:10:00',1.95),('11288','2013-02-27','16:15:00',1.72),('11288','2013-02-27','16:20:00',1.68),('11288','2013-02-27','16:25:00',1.51),('11288','2013-02-27','16:30:00',1.3),('11288','2013-02-27','16:35:00',1.26),('11288','2013-02-27','16:40:00',1.13),('11288','2013-02-27','16:45:00',1.02),('11288','2013-02-26','08:50:00',1.13),('11288','2013-02-26','08:55:00',1.29),('11288','2013-02-26','09:00:00',1.42),('11288','2013-02-26','09:05:00',1.53),('11288','2013-02-26','09:10:00',1.67),('11288','2013-02-26','09:15:00',1.77),('11288','2013-02-26','09:20:00',1.85),('11288','2013-02-26','09:25:00',1.98),('11288','2013-02-26','09:30:00',2.25),('11288','2013-02-26','09:35:00',2.66),('11288','2013-02-26','09:40:00',2.9),('11288','2013-02-26','09:45:00',2.87),('11288','2013-02-26','09:50:00',2.91),('11288','2013-02-26','09:55:00',3.33),('11288','2013-02-26','10:00:00',3.28),('11288','2013-02-26','10:05:00',3.21),('11288','2013-02-26','10:10:00',3.62),('11288','2013-02-26','10:15:00',3.92),('11288','2013-02-26','10:20:00',4.91),('11288','2013-02-26','10:25:00',4.6),('11288','2013-02-26','10:30:00',4.68),('11288','2013-02-26','10:35:00',4.58),('11288','2013-02-26','10:40:00',2.58),('11288','2013-02-26','10:45:00',2.7),('11288','2013-02-26','10:50:00',3.19),('11288','2013-02-26','10:55:00',2.99),('11288','2013-02-26','11:00:00',3.47),('11288','2013-02-26','11:05:00',3.64),('11288','2013-02-26','11:10:00',3.8),('11288','2013-02-26','11:15:00',3.16),('11288','2013-02-26','11:20:00',3.29),('11288','2013-02-26','11:25:00',2.98),('11288','2013-02-26','11:30:00',2.8),('11288','2013-02-26','11:35:00',2.61),('11288','2013-02-26','11:40:00',2.64),('11288','2013-02-26','11:45:00',2.83),('11288','2013-02-26','11:50:00',3.26),('11288','2013-02-26','11:55:00',3.38),('11288','2013-02-26','12:00:00',2.77),('11288','2013-02-26','12:05:00',2.7),('11288','2013-02-26','12:10:00',2.83),('11288','2013-02-26','12:15:00',2.65),('11288','2013-02-26','12:20:00',2.69),('11288','2013-02-26','12:25:00',2.48),('11288','2013-02-26','12:30:00',2.45),('11288','2013-02-26','12:35:00',2.27),('11288','2013-02-26','12:40:00',2.11),('11288','2013-02-26','12:45:00',1.93),('11288','2013-02-26','12:50:00',1.77),('11288','2013-02-26','12:55:00',1.91),('11288','2013-02-26','13:00:00',1.99),('11288','2013-02-26','13:05:00',1.79),('11288','2013-02-26','13:10:00',1.64),('11288','2013-02-26','13:15:00',1.71),('11288','2013-02-26','13:20:00',1.78),('11288','2013-02-26','13:25:00',1.81),('11288','2013-02-26','13:30:00',1.82),('11288','2013-02-26','13:35:00',1.86),('11288','2013-02-26','13:40:00',1.89),('11288','2013-02-26','13:45:00',1.83),('11288','2013-02-26','13:50:00',1.67),('11288','2013-02-26','13:55:00',1.56),('11288','2013-02-26','14:00:00',1.46),('11288','2013-02-26','14:05:00',1.34),('11288','2013-02-26','14:10:00',1.3),('11288','2013-02-26','14:15:00',1.32),('11288','2013-02-25','08:35:00',1.42),('11288','2013-02-25','08:40:00',1.62),('11288','2013-02-25','08:45:00',1.75),('11288','2013-02-25','08:50:00',1.61),('11288','2013-02-25','08:55:00',1.56),('11288','2013-02-25','09:00:00',1.77),('11288','2013-02-25','09:05:00',1.43),('11288','2013-02-25','09:10:00',1.73),('11288','2013-02-25','09:15:00',1.69),('11288','2013-02-25','09:20:00',1.95),('11288','2013-02-25','09:25:00',2.54),('11288','2013-02-25','09:30:00',2.71),('11288','2013-02-25','09:35:00',2.54),('11288','2013-02-25','09:40:00',1.94),('11288','2013-02-25','09:45:00',1.6),('11288','2013-02-25','09:50:00',1.15),('11288','2013-02-25','10:25:00',1.06),('11288','2013-02-25','10:35:00',1.02),('11288','2013-02-25','10:40:00',1.8),('11288','2013-02-25','10:45:00',3.28),('11288','2013-02-25','10:50:00',5.67),('11288','2013-02-25','10:55:00',7.23),('11288','2013-02-25','11:00:00',5.81),('11288','2013-02-25','11:05:00',3.48),('11288','2013-02-25','11:10:00',3.92),('11288','2013-02-25','11:15:00',3.87),('11288','2013-02-25','11:20:00',2.13),('11288','2013-02-25','11:25:00',2.12),('11288','2013-02-25','11:30:00',2.26),('11288','2013-02-25','11:35:00',2.36),('11288','2013-02-25','11:40:00',3.08),('11288','2013-02-25','11:45:00',3.23),('11288','2013-02-25','11:50:00',5.36),('11288','2013-02-25','11:55:00',7.48),('11288','2013-02-25','12:00:00',5.18),('11288','2013-02-25','12:05:00',4.14),('11288','2013-02-25','12:10:00',3.76),('11288','2013-02-25','12:15:00',3.72),('11288','2013-02-25','12:20:00',6.15),('11288','2013-02-25','12:25:00',6.87),('11288','2013-02-25','12:30:00',5.06),('11288','2013-02-25','12:35:00',5.19),('11288','2013-02-25','12:40:00',6.47),('11288','2013-02-25','12:45:00',4.39),('11288','2013-02-25','12:50:00',5.95),('11288','2013-02-25','12:55:00',5.58),('11288','2013-02-25','13:00:00',3.18),('11288','2013-02-25','13:05:00',4.6),('11288','2013-02-25','13:10:00',2.69),('11288','2013-02-25','13:15:00',3.92),('11288','2013-02-25','13:20:00',2.89),('11288','2013-02-25','13:25:00',3.12),('11288','2013-02-25','13:30:00',2.98),('11288','2013-02-25','13:35:00',2.42),('11288','2013-02-25','13:40:00',2.29),('11288','2013-02-25','13:45:00',1.88),('11288','2013-02-25','13:50:00',1.69),('11288','2013-02-25','13:55:00',1.46),('11288','2013-02-25','14:00:00',1.25),('11288','2013-02-25','14:35:00',1.29),('11288','2013-02-25','14:40:00',1.55),('11288','2013-02-25','14:45:00',1.5),('11288','2013-02-25','14:50:00',1.53),('11288','2013-02-25','14:55:00',1.47),('11288','2013-02-25','15:00:00',1.44),('11288','2013-02-25','15:05:00',1.49),('11288','2013-02-25','15:10:00',1.43),('11288','2013-02-25','15:15:00',1.34),('11288','2013-02-25','15:20:00',1.24),('11288','2013-02-25','15:55:00',1.15),('11288','2013-02-25','16:00:00',1.2),('11288','2013-02-25','16:05:00',1.1),('11288','2013-02-25','16:30:00',1.16),('11288','2013-02-25','16:35:00',1.31),('11288','2013-02-25','16:40:00',1.16),('11288','2013-02-25','16:45:00',1.03),('11288','2013-02-25','16:50:00',1.02),('11288','2013-02-25','16:55:00',1.11),('11288','2013-02-24','08:00:00',1.31),('11288','2013-02-24','08:05:00',1.06),('11288','2013-02-24','08:20:00',1.2),('11288','2013-02-24','08:25:00',1.28),('11288','2013-02-24','08:30:00',1.08),('11288','2013-02-24','08:45:00',1.4),('11288','2013-02-24','08:50:00',1.56),('11288','2013-02-24','08:55:00',1.52),('11288','2013-02-24','09:00:00',1.19),('11288','2013-02-24','09:05:00',1.01),('11288','2013-02-24','10:00:00',1.08),('11288','2013-02-24','10:25:00',1.07),('11288','2013-02-24','10:30:00',1.16),('11288','2013-02-24','10:35:00',1.32),('11288','2013-02-24','10:40:00',1.69),('11288','2013-02-24','10:45:00',1.9),('11288','2013-02-24','10:50:00',2.8),('11288','2013-02-24','10:55:00',2.51),('11288','2013-02-24','11:00:00',1.94),('11288','2013-02-24','11:05:00',1.84),('11288','2013-02-24','11:10:00',1.64),('11288','2013-02-24','11:15:00',1.73),('11288','2013-02-24','11:20:00',1.67),('11288','2013-02-24','11:25:00',1.76),('11288','2013-02-24','11:30:00',1.81),('11288','2013-02-24','11:35:00',1.53),('11288','2013-02-24','11:40:00',1.68),('11288','2013-02-24','11:45:00',1.72),('11288','2013-02-24','11:50:00',1.7),('11288','2013-02-24','11:55:00',1.63),('11288','2013-02-24','12:00:00',1.51),('11288','2013-02-24','12:05:00',1.49),('11288','2013-02-24','12:10:00',1.19),('11288','2013-02-24','12:30:00',1.36),('11288','2013-02-24','12:35:00',1.9),('11288','2013-02-24','12:40:00',2.07),('11288','2013-02-24','12:45:00',2.25),('11288','2013-02-24','12:50:00',1.83),('11288','2013-02-24','12:55:00',1.83),('11288','2013-02-24','13:00:00',2.28),('11288','2013-02-24','13:05:00',2.66),('11288','2013-02-24','13:10:00',2.74),('11288','2013-02-24','13:15:00',2.47),('11288','2013-02-24','13:20:00',2.71),('11288','2013-02-24','13:25:00',1.7),('11288','2013-02-24','13:30:00',2.14),('11288','2013-02-24','13:35:00',2.4),('11288','2013-02-24','13:40:00',2.22),('11288','2013-02-24','13:45:00',2.3),('11288','2013-02-24','13:50:00',1.85),('11288','2013-02-24','13:55:00',1.82),('11288','2013-02-24','14:00:00',1.92),('11288','2013-02-24','14:05:00',3.15),('11288','2013-02-24','14:10:00',2.25),('11288','2013-02-24','14:15:00',1.93),('11288','2013-02-24','14:20:00',1.74),('11288','2013-02-24','14:25:00',1.7),('11288','2013-02-24','14:30:00',2.13),('11288','2013-02-24','14:35:00',2.1),('11288','2013-02-24','14:40:00',1.41),('11288','2013-02-24','14:45:00',1.56),('11288','2013-02-24','14:50:00',1.24),('11288','2013-02-24','14:55:00',1.12),('11288','2013-02-24','15:00:00',1.25),('11288','2013-02-24','15:05:00',1.69),('11288','2013-02-24','15:10:00',3.75),('11288','2013-02-24','15:15:00',1.54),('11288','2013-02-24','15:20:00',2.41),('11288','2013-02-24','15:25:00',2.77),('11288','2013-02-24','15:30:00',2.68),('11288','2013-02-24','15:35:00',2.22),('11288','2013-02-24','15:40:00',1.68),('11288','2013-02-24','15:45:00',2.35),('11288','2013-02-24','15:50:00',1.33),('11288','2013-02-24','15:55:00',2.51),('11288','2013-02-24','16:00:00',2.51),('11288','2013-02-24','16:05:00',1.3),('11288','2013-02-24','16:20:00',1.05),('11288','2013-02-24','16:25:00',1.07),('11288','2013-02-24','16:40:00',1.4),('11288','2013-02-23','07:55:00',1.03),('11288','2013-02-23','08:00:00',1.17),('11288','2013-02-23','08:05:00',1.35),('11288','2013-02-23','08:10:00',1.67),('11288','2013-02-23','08:15:00',2.28),('11288','2013-02-23','08:20:00',1.6),('11288','2013-02-23','08:25:00',1.28),('11288','2013-02-23','08:30:00',1.19),('11288','2013-02-23','08:35:00',1.08),('11288','2013-02-23','08:45:00',1.15),('11288','2013-02-23','08:50:00',1.58),('11288','2013-02-23','08:55:00',1.91),('11288','2013-02-23','09:00:00',2.29),('11288','2013-02-23','09:05:00',2.23),('11288','2013-02-23','09:10:00',1.8),('11288','2013-02-23','09:15:00',1.49),('11288','2013-02-23','09:20:00',1.11),('11288','2013-02-23','09:30:00',1.25),('11288','2013-02-23','09:35:00',1.42),('11288','2013-02-23','09:40:00',1.91),('11288','2013-02-23','09:45:00',2.5),('11288','2013-02-23','09:50:00',2.52),('11288','2013-02-23','09:55:00',2.47),('11288','2013-02-23','10:00:00',1.96),('11288','2013-02-23','10:05:00',1.86),('11288','2013-02-23','10:10:00',1.63),('11288','2013-02-23','10:15:00',1.29),('11288','2013-02-23','10:20:00',1.48),('11288','2013-02-23','10:25:00',2.02),('11288','2013-02-23','10:30:00',1.9),('11288','2013-02-23','10:35:00',1.78),('11288','2013-02-23','10:40:00',1.51),('11288','2013-02-23','10:45:00',1.59),('11288','2013-02-23','10:50:00',1.8),('11288','2013-02-23','10:55:00',1.2),('11288','2013-02-23','11:00:00',1.05),('11288','2013-02-23','11:05:00',1.23),('11288','2013-02-23','11:10:00',1.14),('11288','2013-02-23','11:15:00',1.14),('11288','2013-02-23','11:20:00',1.41),('11288','2013-02-23','11:25:00',1.23),('11288','2013-02-23','11:30:00',1.24),('11288','2013-02-23','11:35:00',1.69),('11288','2013-02-23','11:40:00',1.61),('11288','2013-02-23','11:45:00',1.51),('11288','2013-02-23','11:50:00',1.24),('11288','2013-02-23','11:55:00',1.11),('11288','2013-02-23','12:00:00',1.01),('11288','2013-02-23','12:05:00',1.43),('11288','2013-02-23','12:10:00',1.37),('11288','2013-02-23','12:15:00',1.11),('11288','2013-02-23','12:20:00',1.22),('11288','2013-02-23','12:25:00',1.04),('11288','2013-02-23','12:30:00',1.09),('11288','2013-02-23','13:50:00',1.11),('11288','2013-02-23','13:55:00',1.88),('11288','2013-02-23','14:00:00',2.02),('11288','2013-02-23','14:05:00',3.43),('11288','2013-02-23','14:10:00',2.35),('11288','2013-02-23','14:45:00',1.56),('11288','2013-02-23','14:50:00',1.32),('11288','2013-02-23','15:05:00',1.01),('11288','2013-02-23','15:10:00',1.09),('11288','2013-02-22','09:35:00',1.54),('11288','2013-02-22','09:40:00',1.53),('11288','2013-02-22','09:45:00',1.05),('11288','2013-02-22','09:50:00',1.24),('11288','2013-02-22','10:00:00',1.01),('11288','2013-02-22','10:05:00',1.02),('11288','2013-02-22','10:15:00',1.24),('11288','2013-02-22','11:30:00',1.03),('11288','2013-02-22','11:35:00',1.21),('11288','2013-02-22','11:40:00',1.1),('11288','2013-02-22','11:55:00',1.05),('11288','2013-02-22','12:00:00',1.27),('11288','2013-02-22','12:05:00',1.08),('11288','2013-02-22','12:45:00',1.25),('11288','2013-02-22','12:50:00',1.57),('11288','2013-02-22','12:55:00',1.81),('11288','2013-02-22','13:00:00',1.27),('11288','2013-02-22','14:10:00',1.43),('11288','2013-02-22','14:15:00',1.83),('11288','2013-02-22','14:20:00',1.71),('11288','2013-02-22','14:30:00',1.67),('11288','2013-02-22','14:35:00',2.49),('11288','2013-02-22','14:40:00',2.46),('11288','2013-02-22','14:45:00',1.78),('11288','2013-02-22','14:50:00',2.11),('11288','2013-02-22','14:55:00',2.42),('11288','2013-02-22','15:00:00',1.5),('11288','2013-02-22','15:45:00',1.13),('11288','2013-02-22','15:50:00',1.6),('11288','2013-02-22','15:55:00',1.23),('11288','2013-02-22','16:00:00',1.11),('11288','2013-02-22','16:15:00',1.2),('11288','2013-02-22','16:20:00',2.16),('11288','2013-02-22','16:25:00',2.18),('11288','2013-02-22','16:30:00',1.57),('11288','2013-02-22','16:35:00',1.01),('11288','2013-02-21','09:40:00',1.11),('11288','2013-02-21','09:45:00',1.43),('11288','2013-02-21','09:50:00',1.49),('11288','2013-02-21','09:55:00',1.5),('11288','2013-02-21','10:00:00',1.39),('11288','2013-02-21','10:05:00',1.44),('11288','2013-02-21','10:10:00',1.46),('11288','2013-02-21','10:15:00',1.4),('11288','2013-02-21','10:20:00',1.42),('11288','2013-02-21','10:25:00',1.39),('11288','2013-02-21','10:30:00',1.42),('11288','2013-02-21','10:35:00',1.47),('11288','2013-02-21','10:40:00',1.49),('11288','2013-02-21','10:45:00',1.38),('11288','2013-02-21','10:50:00',1.41),('11288','2013-02-21','10:55:00',1.4),('11288','2013-02-21','11:00:00',1.26),('11288','2013-02-21','11:05:00',1.18),('11288','2013-02-21','11:10:00',1.18),('11288','2013-02-21','11:15:00',1.26),('11288','2013-02-21','11:20:00',1.51),('11288','2013-02-21','11:25:00',1.7),('11288','2013-02-21','11:30:00',1.8),('11288','2013-02-21','11:35:00',1.87),('11288','2013-02-21','11:40:00',1.84),('11288','2013-02-21','11:45:00',1.95),('11288','2013-02-21','11:50:00',2.15),('11288','2013-02-21','11:55:00',2.19),('11288','2013-02-21','12:00:00',2.15),('11288','2013-02-21','12:05:00',2.18),('11288','2013-02-21','12:10:00',2.25),('11288','2013-02-21','12:15:00',2.39),('11288','2013-02-21','12:20:00',2.52),('11288','2013-02-21','12:25:00',2.44),('11288','2013-02-21','12:30:00',2.3),('11288','2013-02-21','12:35:00',2.2),('11288','2013-02-21','12:40:00',2.15),('11288','2013-02-21','12:45:00',2.17),('11288','2013-02-21','12:50:00',2.21),('11288','2013-02-21','12:55:00',2.37),('11288','2013-02-21','13:00:00',2.35),('11288','2013-02-21','13:05:00',2.19),('11288','2013-02-21','13:10:00',2.11),('11288','2013-02-21','13:15:00',2.19),('11288','2013-02-21','13:20:00',2.27),('11288','2013-02-21','13:25:00',2.32),('11288','2013-02-21','13:30:00',2.34),('11288','2013-02-21','13:35:00',2.35),('11288','2013-02-21','13:40:00',2.25),('11288','2013-02-21','13:45:00',2.14),('11288','2013-02-21','13:50:00',2.18),('11288','2013-02-21','13:55:00',2.17),('11288','2013-02-21','14:00:00',2.19),('11288','2013-02-21','14:05:00',2.1),('11288','2013-02-21','14:10:00',1.92),('11288','2013-02-21','14:15:00',1.67),('11288','2013-02-21','14:20:00',1.51),('11288','2013-02-21','14:25:00',1.49),('11288','2013-02-21','14:30:00',1.57),('11288','2013-02-21','14:35:00',1.58),('11288','2013-02-21','14:40:00',1.52),('11288','2013-02-21','14:45:00',1.48),('11288','2013-02-21','14:50:00',1.41),('11288','2013-02-21','14:55:00',1.25),('11288','2013-02-21','15:00:00',1.11),('11288','2013-02-21','15:05:00',1.04),('11288','2013-02-21','15:10:00',1.07),('11288','2013-02-21','15:15:00',1.05),('11288','2013-02-21','15:20:00',1.02),('11288','2013-02-21','15:25:00',1.01),('11288','2013-02-21','15:30:00',1.04),('11288','2013-02-21','15:35:00',1.02),('11288','2013-02-21','15:40:00',1.08),('11288','2013-02-21','15:45:00',1.19),('11288','2013-02-21','15:50:00',1.36),('11288','2013-02-21','15:55:00',1.51),('11288','2013-02-21','16:00:00',1.64),('11288','2013-02-21','16:05:00',1.69),('11288','2013-02-21','16:10:00',1.47),('11288','2013-02-21','16:15:00',1.56),('11288','2013-02-21','16:20:00',1.97),('11288','2013-02-21','16:25:00',2.09),('11288','2013-02-21','16:30:00',1.86),('11288','2013-02-21','16:35:00',1.55),('11288','2013-02-21','16:40:00',1.25),('11288','2014-03-23','08:05:00',1.16),('11288','2014-03-23','08:10:00',1.25),('11288','2014-03-23','08:15:00',1.22),('11288','2014-03-23','08:20:00',1.37),('11288','2014-03-23','08:25:00',1.51),('11288','2014-03-23','08:30:00',1.7),('11288','2014-03-23','08:35:00',1.75),('11288','2014-03-23','08:40:00',1.36),('11288','2014-03-23','08:45:00',1.52),('11288','2014-03-23','08:50:00',1.93),('11288','2014-03-23','08:55:00',2.3),('11288','2014-03-23','09:00:00',1.7),('11288','2014-03-23','09:05:00',2.61),('11288','2014-03-23','09:10:00',4),('11288','2014-03-23','09:15:00',3.98),('11288','2014-03-23','09:20:00',2.85),('11288','2014-03-23','09:25:00',1.89),('11288','2014-03-23','09:30:00',2.5),('11288','2014-03-23','09:35:00',2.59),('11288','2014-03-23','09:40:00',2.21),('11288','2014-03-23','09:45:00',1.63),('11288','2014-03-23','09:50:00',1.49),('11288','2014-03-23','09:55:00',1.37),('11288','2014-03-23','10:00:00',1.28),('11288','2014-03-23','10:05:00',1.27),('11288','2014-03-23','10:10:00',1.38),('11288','2014-03-23','10:15:00',1.09),('11288','2014-03-23','10:20:00',1.35),('11288','2014-03-23','10:25:00',2.2),('11288','2014-03-23','10:30:00',1.6),('11288','2014-03-23','10:35:00',1.38),('11288','2014-03-23','10:40:00',2.25),('11288','2014-03-23','10:45:00',2.07),('11288','2014-03-23','10:50:00',2.4),('11288','2014-03-23','10:55:00',2.98),('11288','2014-03-23','11:00:00',2.17),('11288','2014-03-23','11:05:00',1.88),('11288','2014-03-23','11:10:00',2.44),('11288','2014-03-23','11:15:00',1.4),('11288','2014-03-23','11:20:00',1.45),('11288','2014-03-23','11:25:00',1.8),('11288','2014-03-23','11:30:00',1.44),('11288','2014-03-23','11:35:00',3.04),('11288','2014-03-23','11:40:00',5.97),('11288','2014-03-23','11:45:00',1.57),('11288','2014-03-23','11:55:00',1.55),('11288','2014-03-23','12:00:00',1.62),('11288','2014-03-23','12:30:00',1.16),('11288','2014-03-23','12:35:00',1.25),('11288','2014-03-23','13:10:00',1.03),('11288','2014-03-23','13:15:00',1.04),('11288','2014-03-23','13:40:00',1.95),('11288','2014-03-23','13:45:00',3.85),('11288','2014-03-23','13:50:00',2.79),('11288','2014-03-23','13:55:00',2.28),('11288','2014-03-23','14:00:00',1.59),('11288','2014-03-23','14:05:00',1.14),('11288','2014-03-23','14:15:00',1.28),('11288','2014-03-23','14:50:00',1.72),('11288','2014-03-23','14:55:00',1.45),('11288','2014-03-23','15:00:00',1.3),('11288','2014-03-23','15:05:00',1.83),('11288','2014-03-23','15:10:00',2.43),('11288','2014-03-23','15:15:00',2.62),('11288','2014-03-23','15:20:00',2.8),('11288','2014-03-23','15:25:00',2.74),('11288','2014-03-23','15:30:00',1.97),('11288','2014-03-23','15:35:00',1.6),('11288','2014-03-23','15:40:00',1.81),('11288','2013-02-20','08:20:00',1.23),('11288','2013-02-20','08:25:00',1.55),('11288','2013-02-20','08:30:00',1.68),('11288','2013-02-20','08:35:00',1.79),('11288','2013-02-20','08:40:00',1.98),('11288','2013-02-20','08:45:00',2.1),('11288','2013-02-20','08:50:00',2.24),('11288','2013-02-20','08:55:00',2.44),('11288','2013-02-20','09:00:00',2.55),('11288','2013-02-20','09:05:00',1.91),('11288','2013-02-20','09:10:00',2.58),('11288','2013-02-20','09:15:00',2.38),('11288','2013-02-20','09:20:00',2.36),('11288','2013-02-20','09:25:00',3.29),('11288','2013-02-20','09:30:00',2.17),('11288','2013-02-20','09:35:00',2.11),('11288','2013-02-20','09:40:00',1.84),('11288','2013-02-20','09:45:00',2.08),('11288','2013-02-20','09:50:00',2.6),('11288','2013-02-20','09:55:00',2.34),('11288','2013-02-20','10:00:00',2.3),('11288','2013-02-20','10:05:00',3.47),('11288','2013-02-20','10:10:00',2.16),('11288','2013-02-20','10:15:00',1.65),('11288','2013-02-20','10:20:00',1.44),('11288','2013-02-20','10:25:00',1.31),('11288','2013-02-20','10:30:00',1.1),('11288','2013-02-20','10:35:00',1.32),('11288','2013-02-20','10:40:00',1.73),('11288','2013-02-20','10:45:00',3.64),('11288','2013-02-20','10:50:00',3.87),('11288','2013-02-20','10:55:00',1.72),('11288','2013-02-20','11:00:00',1.48),('11288','2013-02-20','11:05:00',4.73),('11288','2013-02-20','11:10:00',5.77),('11288','2013-02-20','11:15:00',4.66),('11288','2013-02-20','11:20:00',5.2),('11288','2013-02-20','11:25:00',2.77),('11288','2013-02-20','11:30:00',2.27),('11288','2013-02-20','11:35:00',6.76),('11288','2013-02-20','11:40:00',6.39),('11288','2013-02-20','11:45:00',6.58),('11288','2013-02-20','11:50:00',5.16),('11288','2013-02-20','11:55:00',6.49),('11288','2013-02-20','12:00:00',1.62),('11288','2013-02-20','12:05:00',2.1),('11288','2013-02-20','12:10:00',4.7),('11288','2013-02-20','12:15:00',4.38),('11288','2013-02-20','12:20:00',4),('11288','2013-02-20','12:25:00',6.89),('11288','2013-02-20','12:30:00',6.92),('11288','2013-02-20','12:35:00',2.48),('11288','2013-02-20','12:40:00',1.72),('11288','2013-02-20','12:45:00',1.95),('11288','2013-02-20','12:50:00',2.14),('11288','2013-02-20','12:55:00',4.61),('11288','2013-02-20','13:00:00',5.7),('11288','2013-02-20','13:05:00',5.18),('11288','2013-02-20','13:10:00',5.98),('11288','2013-02-20','13:15:00',6.3),('11288','2013-02-20','13:20:00',1.88),('11288','2013-02-20','13:25:00',2.68),('11288','2013-02-20','13:30:00',2.69),('11288','2013-02-20','13:35:00',2.72),('11288','2013-02-20','13:40:00',2.98),('11288','2013-02-20','13:45:00',2.43),('11288','2013-02-20','13:50:00',2.17),('11288','2013-02-20','13:55:00',2.77),('11288','2013-02-20','14:00:00',2.09),('11288','2013-02-20','14:05:00',1.71),('11288','2013-02-20','14:10:00',1.67),('11288','2013-02-20','14:15:00',1.44),('11288','2013-02-20','14:20:00',1.19),('11288','2013-02-20','14:25:00',1.17),('11288','2013-02-20','14:30:00',1.58),('11288','2013-02-20','14:35:00',1.96),('11288','2013-02-20','14:40:00',2.39),('11288','2013-02-20','14:45:00',1.81),('11288','2013-02-20','14:50:00',1.69),('11288','2013-02-20','14:55:00',1.64),('11288','2013-02-20','15:00:00',1.65),('11288','2013-02-20','15:05:00',2.99),('11288','2013-02-20','15:10:00',3.63),('11288','2013-02-20','15:15:00',4.15),('11288','2013-02-20','15:20:00',3.86),('11288','2013-02-20','15:25:00',3.38),('11288','2013-02-20','15:30:00',2.59),('11288','2013-02-20','15:35:00',1.45),('11288','2013-02-20','15:40:00',1.08),('11288','2013-02-20','15:45:00',1.18),('11288','2013-02-20','15:50:00',1.44),('11288','2013-02-20','15:55:00',1.55),('11288','2013-02-20','16:00:00',1.53),('11288','2013-02-20','16:05:00',2.51),('11288','2013-02-20','16:10:00',2.43),('11288','2013-02-20','16:15:00',2.26),('11288','2013-02-20','16:20:00',1.93),('11288','2013-02-20','16:25:00',1.57),('11288','2013-02-20','16:30:00',1.18),('11288','2013-02-20','16:35:00',1.1),('11288','2013-02-19','08:10:00',1.1),('11288','2013-02-19','08:15:00',1.21),('11288','2013-02-19','08:20:00',1.2),('11288','2013-02-19','08:25:00',1.48),('11288','2013-02-19','08:30:00',1.65),('11288','2013-02-19','08:35:00',1.78),('11288','2013-02-19','08:40:00',1.93),('11288','2013-02-19','08:45:00',2.04),('11288','2013-02-19','08:50:00',2.17),('11288','2013-02-19','08:55:00',2.35),('11288','2013-02-19','09:00:00',2.45),('11288','2013-02-19','09:05:00',2.57),('11288','2013-02-19','09:10:00',2.58),('11288','2013-02-19','09:15:00',2.66),('11288','2013-02-19','09:20:00',2.89),('11288','2013-02-19','09:25:00',3.08),('11288','2013-02-19','09:30:00',3.25),('11288','2013-02-19','09:35:00',3.36),('11288','2013-02-19','09:40:00',3.46),('11288','2013-02-19','09:45:00',3.54),('11288','2013-02-19','09:50:00',3.55),('11288','2013-02-19','09:55:00',3.8),('11288','2013-02-19','10:00:00',3.94),('11288','2013-02-19','10:05:00',4.06),('11288','2013-02-19','10:10:00',4.16),('11288','2013-02-19','10:15:00',4.1),('11288','2013-02-19','10:20:00',4.37),('11288','2013-02-19','10:25:00',4.49),('11288','2013-02-19','10:30:00',4.54),('11288','2013-02-19','10:35:00',4.6),('11288','2013-02-19','10:40:00',4.63),('11288','2013-02-19','10:45:00',4.71),('11288','2013-02-19','10:50:00',4.78),('11288','2013-02-19','10:55:00',4.87),('11288','2013-02-19','11:00:00',4.93),('11288','2013-02-19','11:05:00',4.92),('11288','2013-02-19','11:10:00',4.96),('11288','2013-02-19','11:15:00',5.16),('11288','2013-02-19','11:20:00',5.19),('11288','2013-02-19','11:25:00',5.21),('11288','2013-02-19','11:30:00',5.33),('11288','2013-02-19','11:35:00',5.36),('11288','2013-02-19','11:40:00',5.34),('11288','2013-02-19','11:45:00',5.22),('11288','2013-02-19','11:50:00',5.13),('11288','2013-02-19','11:55:00',5.41),('11288','2013-02-19','12:00:00',5.26),('11288','2013-02-19','12:05:00',5.26),('11288','2013-02-19','12:10:00',5.44),('11288','2013-02-19','12:15:00',5.41),('11288','2013-02-19','12:20:00',5.38),('11288','2013-02-19','12:25:00',5.35),('11288','2013-02-19','12:30:00',5.34),('11288','2013-02-19','12:35:00',5.41),('11288','2013-02-19','12:40:00',5.39),('11288','2013-02-19','12:45:00',5.34),('11288','2013-02-19','12:50:00',5.37),('11288','2013-02-19','12:55:00',5.38),('11288','2013-02-19','13:00:00',5.35),('11288','2013-02-19','13:05:00',5.32),('11288','2013-02-19','13:10:00',5.28),('11288','2013-02-19','13:15:00',5.25),('11288','2013-02-19','13:20:00',5.22),('11288','2013-02-19','13:25:00',5.14),('11288','2013-02-19','13:30:00',5.09),('11288','2013-02-19','13:35:00',5.02),('11288','2013-02-19','13:40:00',4.98),('11288','2013-02-19','13:45:00',4.89),('11288','2013-02-19','13:50:00',4.82),('11288','2013-02-19','13:55:00',4.82),('11288','2013-02-19','14:00:00',4.7),('11288','2013-02-19','14:05:00',4.6),('11288','2013-02-19','14:10:00',4.32),('11288','2013-02-19','14:15:00',4.2),('11288','2013-02-19','14:20:00',4.22),('11288','2013-02-19','14:25:00',4.1),('11288','2013-02-19','14:30:00',3.99),('11288','2013-02-19','14:35:00',3.57),('11288','2013-02-19','14:40:00',3.89),('11288','2013-02-19','14:45:00',3.87),('11288','2013-02-19','14:50:00',3.74),('11288','2013-02-19','14:55:00',3.63),('11288','2013-02-19','15:00:00',3.52),('11288','2013-02-19','15:05:00',3.38),('11288','2013-02-19','15:10:00',3.3),('11288','2013-02-19','15:15:00',3.23),('11288','2013-02-19','15:20:00',3.06),('11288','2013-02-19','15:25:00',2.84),('11288','2013-02-19','15:30:00',2.72),('11288','2013-02-19','15:35:00',2.58),('11288','2013-02-19','15:40:00',2.5),('11288','2013-02-19','15:45:00',2.36),('11288','2013-02-19','15:50:00',2.09),('11288','2013-02-19','15:55:00',2.08),('11288','2013-02-19','16:00:00',1.95),('11288','2013-02-19','16:05:00',1.81),('11288','2013-02-19','16:10:00',1.65),('11288','2013-02-19','16:15:00',1.54),('11288','2013-02-19','16:20:00',1.41),('11288','2013-02-19','16:25:00',1.27),('11288','2013-02-19','16:30:00',1.17),('11288','2013-02-19','16:35:00',1.06),('11288','2013-02-18','08:10:00',1.07),('11288','2013-02-18','08:15:00',1.18),('11288','2013-02-18','08:20:00',1.26),('11288','2013-02-18','08:25:00',1.25),('11288','2013-02-18','08:30:00',1.52),('11288','2013-02-18','08:35:00',1.65),('11288','2013-02-18','08:40:00',1.78),('11288','2013-02-18','08:45:00',1.93),('11288','2013-02-18','08:50:00',2.05),('11288','2013-02-18','08:55:00',2.18),('11288','2013-02-18','09:00:00',2.33),('11288','2013-02-18','09:05:00',2.42),('11288','2013-02-18','09:10:00',2.4),('11288','2013-02-18','09:15:00',2.62),('11288','2013-02-18','09:20:00',2.67),('11288','2013-02-18','09:25:00',3.34),('11288','2013-02-18','09:30:00',2.03),('11288','2013-02-18','09:35:00',2.06),('11288','2013-02-18','09:40:00',1.47),('11288','2013-02-18','09:45:00',1.79),('11288','2013-02-18','09:50:00',1.79),('11288','2013-02-18','09:55:00',1.44),('11288','2013-02-18','10:00:00',1.37),('11288','2013-02-18','10:05:00',1.86),('11288','2013-02-18','10:30:00',1.17),('11288','2013-02-18','10:35:00',1.35),('11288','2013-02-18','10:40:00',1.55),('11288','2013-02-18','10:45:00',1.45),('11288','2013-02-18','10:50:00',1.31),('11288','2013-02-18','10:55:00',1.86),('11288','2013-02-18','11:00:00',2.16),('11288','2013-02-18','11:05:00',2.24),('11288','2013-02-18','11:10:00',2.37),('11288','2013-02-18','11:15:00',2.14),('11288','2013-02-18','11:20:00',2.71),('11288','2013-02-18','11:25:00',2.7),('11288','2013-02-18','11:30:00',2.54),('11288','2013-02-18','11:35:00',2.67),('11288','2013-02-18','11:40:00',2.57),('11288','2013-02-18','11:45:00',2.4),('11288','2013-02-18','11:50:00',2.59),('11288','2013-02-18','11:55:00',3.36),('11288','2013-02-18','12:00:00',3.51),('11288','2013-02-18','12:05:00',2.9),('11288','2013-02-18','12:10:00',2.68),('11288','2013-02-18','12:15:00',2.61),('11288','2013-02-18','12:20:00',2.56),('11288','2013-02-18','12:25:00',2.65),('11288','2013-02-18','12:30:00',2.41),('11288','2013-02-18','12:35:00',2.29),('11288','2013-02-18','12:40:00',2.41),('11288','2013-02-18','12:45:00',2.86),('11288','2013-02-18','12:50:00',2.79),('11288','2013-02-18','12:55:00',2.58),('11288','2013-02-18','13:00:00',2.58),('11288','2013-02-18','13:05:00',2.6),('11288','2013-02-18','13:10:00',2.51),('11288','2013-02-18','13:15:00',3.06),('11288','2013-02-18','13:20:00',2.48),('11288','2013-02-18','13:25:00',2.73),('11288','2013-02-18','13:30:00',2.57),('11288','2013-02-18','13:35:00',2.35),('11288','2013-02-18','13:40:00',2.36),('11288','2013-02-18','13:45:00',2.14),('11288','2013-02-18','13:50:00',2.2),('11288','2013-02-18','13:55:00',2.58),('11288','2013-02-18','14:00:00',2.6),('11288','2013-02-18','14:05:00',2.36),('11288','2013-02-18','14:10:00',2.08),('11288','2013-02-18','14:15:00',1.85),('11288','2013-02-18','14:20:00',1.96),('11288','2013-02-18','14:25:00',1.36),('11288','2013-02-18','14:30:00',1.06),('11288','2013-02-18','14:35:00',1.05),('11288','2013-02-18','14:40:00',1.09),('11288','2013-02-18','14:45:00',1.02),('11288','2013-02-18','15:00:00',1.09),('11288','2013-02-18','15:05:00',1.35),('11288','2013-02-18','15:10:00',1.16),('11288','2013-02-18','15:35:00',1.19),('11288','2013-02-18','15:40:00',1.13),('11288','2013-02-17','08:10:00',1.01),('11288','2013-02-17','08:15:00',1.16),('11288','2013-02-17','08:20:00',1.17),('11288','2013-02-17','08:25:00',1.42),('11288','2013-02-17','08:30:00',1.62),('11288','2013-02-17','08:35:00',1.83),('11288','2013-02-17','08:40:00',2),('11288','2013-02-17','08:45:00',2.02),('11288','2013-02-17','08:50:00',1.82),('11288','2013-02-17','08:55:00',2.17),('11288','2013-02-17','09:00:00',2.27),('11288','2013-02-17','09:05:00',2.22),('11288','2013-02-17','09:10:00',2.37),('11288','2013-02-17','09:15:00',2.59),('11288','2013-02-17','09:20:00',2.71),('11288','2013-02-17','09:25:00',2.82),('11288','2013-02-17','09:30:00',2.92),('11288','2013-02-17','09:35:00',3.02),('11288','2013-02-17','09:40:00',3.19),('11288','2013-02-17','09:45:00',3.29),('11288','2013-02-17','09:50:00',3.29),('11288','2013-02-17','09:55:00',3.48),('11288','2013-02-17','10:00:00',3.66),('11288','2013-02-17','10:05:00',3.77),('11288','2013-02-17','10:10:00',3.89),('11288','2013-02-17','10:15:00',3.79),('11288','2013-02-17','10:20:00',4.08),('11288','2013-02-17','10:25:00',4.17),('11288','2013-02-17','10:30:00',4.28),('11288','2013-02-17','10:35:00',4.37),('11288','2013-02-17','10:40:00',4.34),('11288','2013-02-17','10:45:00',4.46),('11288','2013-02-17','10:50:00',4.58),('11288','2013-02-17','10:55:00',4.65),('11288','2013-02-17','11:00:00',4.69),('11288','2013-02-17','11:05:00',4.69),('11288','2013-02-17','11:10:00',4.73),('11288','2013-02-17','11:15:00',4.93),('11288','2013-02-17','11:20:00',5.02),('11288','2013-02-17','11:25:00',5.07),('11288','2013-02-17','11:30:00',5.04),('11288','2013-02-17','11:35:00',5.08),('11288','2013-02-17','11:40:00',5.14),('11288','2013-02-17','11:45:00',5.09),('11288','2013-02-17','11:50:00',4.75),('11288','2013-02-17','11:55:00',5.02),('11288','2013-02-17','12:00:00',5.23),('11288','2013-02-17','12:05:00',5.21),('11288','2013-02-17','12:10:00',5.19),('11288','2013-02-17','12:15:00',5.23),('11288','2013-02-17','12:20:00',5.09),('11288','2013-02-17','12:25:00',5.2),('11288','2013-02-17','12:30:00',5.16),('11288','2013-02-17','12:35:00',5.15),('11288','2013-02-17','12:40:00',5.07),('11288','2013-02-17','12:45:00',5.13),('11288','2013-02-17','12:50:00',5.14),('11288','2013-02-17','12:55:00',5.16),('11288','2013-02-17','13:00:00',4.45),('11288','2013-02-17','13:05:00',3.32),('11288','2013-02-17','13:10:00',3.54),('11288','2013-02-17','13:15:00',3.45),('11288','2013-02-17','13:20:00',1.18),('11288','2013-02-17','13:25:00',3.3),('11288','2013-02-17','13:30:00',3.05),('11288','2013-02-17','13:35:00',1.42),('11288','2013-02-17','13:40:00',3.55),('11288','2013-02-17','13:45:00',4.26),('11288','2013-02-17','13:50:00',3.8),('11288','2013-02-17','13:55:00',2.54),('11288','2013-02-17','14:00:00',1.05),('11288','2013-02-17','14:05:00',2.18),('11288','2013-02-17','14:10:00',3.6),('11288','2013-02-17','14:15:00',2.1),('11288','2013-02-17','14:20:00',2.17),('11288','2013-02-17','14:25:00',3.26),('11288','2013-02-17','14:30:00',4.09),('11288','2013-02-17','14:35:00',3.16),('11288','2013-02-17','14:40:00',1.96),('11288','2013-02-17','14:45:00',1.02),('11288','2013-02-17','14:50:00',1.18),('11288','2013-02-17','14:55:00',1.7),('11288','2013-02-17','15:00:00',3.41),('11288','2013-02-17','15:05:00',3.78),('11288','2013-02-17','15:10:00',3.9),('11288','2013-02-17','15:15:00',3.66),('11288','2013-02-17','15:20:00',3.5),('11288','2013-02-17','15:25:00',3.17),('11288','2013-02-17','15:30:00',2.97),('11288','2013-02-17','15:35:00',2.94),('11288','2013-02-17','15:40:00',2.86),('11288','2013-02-17','15:45:00',2.61),('11288','2013-02-17','15:50:00',2.38),('11288','2013-02-17','15:55:00',2.13),('11288','2013-02-17','16:00:00',2.09),('11288','2013-02-17','16:05:00',1.9),('11288','2013-02-17','16:20:00',1.39),('11288','2013-02-17','16:25:00',1.8),('11288','2013-02-17','16:30:00',1.79),('11288','2013-02-17','16:35:00',1.26),('11288','2013-02-16','08:15:00',1.04),('11288','2013-02-16','08:20:00',1.08),('11288','2013-02-16','08:25:00',1.18),('11288','2013-02-16','08:30:00',1.41),('11288','2013-02-16','08:35:00',1.53),('11288','2013-02-16','08:40:00',1.67),('11288','2013-02-16','08:45:00',1.83),('11288','2013-02-16','09:05:00',1.64),('11288','2013-02-16','09:10:00',1.11),('11288','2013-02-16','09:15:00',2.4),('11288','2013-02-16','09:20:00',2.85),('11288','2013-02-16','09:25:00',2.87),('11288','2013-02-16','09:30:00',3.03),('11288','2013-02-16','09:35:00',3.2),('11288','2013-02-16','09:40:00',3.26),('11288','2013-02-16','09:45:00',3.36),('11288','2013-02-16','09:50:00',3.51),('11288','2013-02-16','09:55:00',3.6),('11288','2013-02-16','10:00:00',3.71),('11288','2013-02-16','10:05:00',3.8),('11288','2013-02-16','10:10:00',3.93),('11288','2013-02-16','10:15:00',3.97),('11288','2013-02-16','10:20:00',4.16),('11288','2013-02-16','10:25:00',4.29),('11288','2013-02-16','10:30:00',4.34),('11288','2013-02-16','10:35:00',4.43),('11288','2013-02-16','10:40:00',4.47),('11288','2013-02-16','10:45:00',4.6),('11288','2013-02-16','10:50:00',4.01),('11288','2013-02-16','10:55:00',4.22),('11288','2013-02-16','11:00:00',4.9),('11288','2013-02-16','11:05:00',4.77),('11288','2013-02-16','11:10:00',4.74),('11288','2013-02-16','11:15:00',4.89),('11288','2013-02-16','11:20:00',5.01),('11288','2013-02-16','11:25:00',5.08),('11288','2013-02-16','11:30:00',5.16),('11288','2013-02-16','11:35:00',5.19),('11288','2013-02-16','11:40:00',5.25),('11288','2013-02-16','11:45:00',5.24),('11288','2013-02-16','11:50:00',5.33),('11288','2013-02-16','11:55:00',5.34),('11288','2013-02-16','12:00:00',5.31),('11288','2013-02-16','12:05:00',5.37),('11288','2013-02-16','12:10:00',5.31),('11288','2013-02-16','12:15:00',5.35),('11288','2013-02-16','12:20:00',5.31),('11288','2013-02-16','12:25:00',5.29),('11288','2013-02-16','12:30:00',5.29),('11288','2013-02-16','12:35:00',5.32),('11288','2013-02-16','12:40:00',5.3),('11288','2013-02-16','12:45:00',5.3),('11288','2013-02-16','12:50:00',5.34),('11288','2013-02-16','12:55:00',5.31),('11288','2013-02-16','13:00:00',5.28),('11288','2013-02-16','13:05:00',5.26),('11288','2013-02-16','13:10:00',5.2),('11288','2013-02-16','13:15:00',5.18),('11288','2013-02-16','13:20:00',5.05),('11288','2013-02-16','13:25:00',5.05),('11288','2013-02-16','13:30:00',5),('11288','2013-02-16','13:35:00',4.95),('11288','2013-02-16','13:40:00',4.89),('11288','2013-02-16','13:45:00',4.98),('11288','2013-02-16','13:50:00',4.41),('11288','2013-02-16','13:55:00',4.87),('11288','2013-02-16','14:00:00',4.76),('11288','2013-02-16','14:05:00',4.66),('11288','2013-02-16','14:10:00',4.54),('11288','2013-02-16','14:15:00',4.52),('11288','2013-02-16','14:20:00',3.58),('11288','2013-02-16','14:25:00',1.57),('11288','2013-02-16','14:30:00',1.56),('11288','2013-02-16','14:35:00',1.66),('11288','2013-02-16','14:40:00',1.69),('11288','2013-02-16','14:45:00',1.84),('11288','2013-02-16','14:50:00',1.75),('11288','2013-02-16','14:55:00',1.71),('11288','2013-02-16','15:00:00',1.45),('11288','2013-02-16','15:05:00',1.47),('11288','2013-02-16','15:10:00',1.54),('11288','2013-02-16','15:15:00',1.7),('11288','2013-02-16','15:20:00',1.84),('11288','2013-02-16','15:25:00',1.93),('11288','2013-02-16','15:30:00',2.93),('11288','2013-02-16','15:35:00',3.28),('11288','2013-02-16','15:40:00',3.1),('11288','2013-02-16','15:45:00',2.07),('11288','2013-02-16','15:50:00',2.49),('11288','2013-02-16','15:55:00',2.2),('11288','2013-02-16','16:00:00',1.49),('11288','2013-02-16','16:05:00',1.82),('11288','2013-02-16','16:10:00',1.25),('11288','2013-02-16','16:15:00',1.08),('11288','2013-02-16','16:20:00',1.21),('11288','2013-02-16','16:25:00',1.19),('11288','2013-02-15','08:10:00',1.07),('11288','2013-02-15','08:15:00',1.05),('11288','2013-02-15','08:55:00',1.24),('11288','2013-02-15','09:00:00',1.29),('11288','2013-02-15','09:05:00',1.22),('11288','2013-02-15','09:10:00',1.22),('11288','2013-02-15','09:15:00',1.56),('11288','2013-02-15','09:20:00',2.33),('11288','2013-02-15','09:25:00',2.27),('11288','2013-02-15','09:30:00',1.79),('11288','2013-02-15','09:35:00',1.69),('11288','2013-02-15','09:40:00',1.58),('11288','2013-02-15','09:45:00',1.5),('11288','2013-02-15','09:50:00',1.89),('11288','2013-02-15','09:55:00',2.26),('11288','2013-02-15','10:00:00',2.79),('11288','2013-02-15','10:05:00',2.72),('11288','2013-02-15','10:10:00',1.92),('11288','2013-02-15','10:15:00',2.15),('11288','2013-02-15','10:20:00',2.66),('11288','2013-02-15','10:25:00',3.22),('11288','2013-02-15','10:30:00',3.32),('11288','2013-02-15','10:35:00',4.3),('11288','2013-02-15','10:40:00',3.99),('11288','2013-02-15','10:45:00',4.31),('11288','2013-02-15','10:50:00',4.56),('11288','2013-02-15','10:55:00',2.78),('11288','2013-02-15','11:00:00',2.97),('11288','2013-02-15','11:05:00',3.36),('11288','2013-02-15','11:10:00',3.07),('11288','2013-02-15','11:15:00',4.56),('11288','2013-02-15','11:20:00',4.79),('11288','2013-02-15','11:25:00',5.25),('11288','2013-02-15','11:30:00',4.89),('11288','2013-02-15','11:35:00',3.75),('11288','2013-02-15','11:40:00',3.04),('11288','2013-02-15','11:45:00',4.01),('11288','2013-02-15','11:50:00',5.4),('11288','2013-02-15','11:55:00',4.47),('11288','2013-02-15','12:00:00',4.4),('11288','2013-02-15','12:05:00',4.99),('11288','2013-02-15','12:10:00',5.31),('11288','2013-02-15','12:15:00',5.37),('11288','2013-02-15','12:20:00',5.82),('11288','2013-02-15','12:25:00',5.41),('11288','2013-02-15','12:30:00',5.44),('11288','2013-02-15','12:35:00',5.34),('11288','2013-02-15','12:40:00',5.28),('11288','2013-02-15','12:45:00',5.26),('11288','2013-02-15','12:50:00',4.99),('11288','2013-02-15','12:55:00',5.24),('11288','2013-02-15','13:00:00',5.15),('11288','2013-02-15','13:05:00',5.15),('11288','2013-02-15','13:10:00',5.22),('11288','2013-02-15','13:15:00',5.1),('11288','2013-02-15','13:20:00',4.94),('11288','2013-02-15','13:25:00',4.48),('11288','2013-02-15','13:30:00',3.51),('11288','2013-02-15','13:35:00',3.54),('11288','2013-02-15','13:40:00',4.7),('11288','2013-02-15','13:45:00',3.91),('11288','2013-02-15','13:50:00',4.32),('11288','2013-02-15','13:55:00',3.73),('11288','2013-02-15','14:00:00',3.34),('11288','2013-02-15','14:05:00',5.32),('11288','2013-02-15','14:10:00',5.16),('11288','2013-02-15','14:15:00',3.6),('11288','2013-02-15','14:20:00',3.62),('11288','2013-02-15','14:25:00',2.43),('11288','2013-02-15','14:30:00',2.3),('11288','2013-02-15','14:35:00',3.7),('11288','2013-02-15','14:40:00',4.16),('11288','2013-02-15','14:45:00',2.98),('11288','2013-02-15','14:50:00',2.09),('11288','2013-02-15','14:55:00',1.83),('11288','2013-02-15','15:00:00',2.73),('11288','2013-02-15','15:05:00',1.95),('11288','2013-02-15','15:10:00',2.04),('11288','2013-02-15','15:15:00',2.24),('11288','2013-02-15','15:20:00',1.86),('11288','2013-02-15','15:25:00',2.18),('11288','2013-02-15','15:30:00',2.27),('11288','2013-02-15','15:35:00',1.96),('11288','2013-02-15','15:40:00',2.03),('11288','2013-02-15','15:45:00',1.77),('11288','2013-02-15','15:50:00',1.47),('11288','2013-02-15','15:55:00',1.38),('11288','2013-02-15','16:00:00',1.3),('11288','2013-02-15','16:05:00',1.24),('11288','2013-02-15','16:10:00',1.15),('11288','2013-02-15','16:15:00',1.01),('11288','2013-02-14','08:15:00',1),('11288','2013-02-14','08:20:00',1.19),('11288','2013-02-14','08:25:00',1.31),('11288','2013-02-14','08:30:00',1.34),('11288','2013-02-14','08:35:00',1.56),('11288','2013-02-14','08:40:00',1.71),('11288','2013-02-14','08:45:00',1.85),('11288','2013-02-14','08:50:00',1.99),('11288','2013-02-14','08:55:00',2.14),('11288','2013-02-14','09:00:00',2.21),('11288','2013-02-14','09:05:00',2.37),('11288','2013-02-14','09:10:00',2.44),('11288','2013-02-14','09:15:00',2.57),('11288','2013-02-14','09:20:00',2.74),('11288','2013-02-14','09:25:00',2.87),('11288','2013-02-14','09:30:00',2.97),('11288','2013-02-14','09:35:00',3.18),('11288','2013-02-14','09:40:00',3.26),('11288','2013-02-14','09:45:00',3.27),('11288','2013-02-14','09:50:00',3.55),('11288','2013-02-14','09:55:00',3.69),('11288','2013-02-14','10:00:00',3.78),('11288','2013-02-14','10:05:00',3.93),('11288','2013-02-14','10:10:00',4.02),('11288','2013-02-14','10:15:00',4.02),('11288','2013-02-14','10:20:00',4.28),('11288','2013-02-14','10:25:00',4.36),('11288','2013-02-14','10:30:00',4.47),('11288','2013-02-14','10:35:00',4.53),('11288','2013-02-14','10:40:00',4.38),('11288','2013-02-14','10:45:00',4.61),('11288','2013-02-14','10:50:00',4.8),('11288','2013-02-14','10:55:00',4.86),('11288','2013-02-14','11:00:00',4.93),('11288','2013-02-14','11:05:00',4.93),('11288','2013-02-14','11:10:00',4.7),('11288','2013-02-14','11:15:00',4.51),('11288','2013-02-14','11:20:00',5.12),('11288','2013-02-14','11:25:00',5.2),('11288','2013-02-14','11:30:00',5.25),('11288','2013-02-14','11:35:00',5.27),('11288','2013-02-14','11:40:00',5.32),('11288','2013-02-14','11:45:00',5.21),('11288','2013-02-14','11:50:00',5.33),('11288','2013-02-14','11:55:00',5.37),('11288','2013-02-14','12:00:00',5.39),('11288','2013-02-14','12:05:00',5.4),('11288','2013-02-14','12:10:00',5.39),('11288','2013-02-14','12:15:00',5.43),('11288','2013-02-14','12:20:00',5.39),('11288','2013-02-14','12:25:00',5.38),('11288','2013-02-14','12:30:00',5.38),('11288','2013-02-14','12:35:00',5.38),('11288','2013-02-14','12:40:00',5.36),('11288','2013-02-14','12:45:00',5.32),('11288','2013-02-14','12:50:00',5.29),('11288','2013-02-14','12:55:00',5.27),('11288','2013-02-14','13:00:00',5.26),('11288','2013-02-14','13:05:00',5.22),('11288','2013-02-14','13:10:00',5.2),('11288','2013-02-14','13:15:00',5.18),('11288','2013-02-14','13:20:00',5.1),('11288','2013-02-14','13:25:00',5.08),('11288','2013-02-14','13:30:00',5.03),('11288','2013-02-14','13:35:00',4.99),('11288','2013-02-14','13:40:00',4.93),('11288','2013-02-14','13:45:00',4.84),('11288','2013-02-14','13:50:00',4.74),('11288','2013-02-14','13:55:00',4.65),('11288','2013-02-14','14:00:00',4.59),('11288','2013-02-14','14:05:00',4.55),('11288','2013-02-14','14:10:00',4.44),('11288','2013-02-14','14:15:00',4.35),('11288','2013-02-14','14:20:00',4.25),('11288','2013-02-14','14:25:00',4.17),('11288','2013-02-14','14:30:00',4.05),('11288','2013-02-14','14:35:00',3.93),('11288','2013-02-14','14:40:00',3.89),('11288','2013-02-14','14:45:00',3.79),('11288','2013-02-14','14:50:00',3.64),('11288','2013-02-14','14:55:00',3.51),('11288','2013-02-14','15:00:00',3.39),('11288','2013-02-14','15:05:00',3.24),('11288','2013-02-14','15:10:00',3.15),('11288','2013-02-14','15:15:00',3.03),('11288','2013-02-14','15:20:00',2.87),('11288','2013-02-14','15:25:00',2.73),('11288','2013-02-14','15:30:00',2.56),('11288','2013-02-14','15:35:00',2.39),('11288','2013-02-14','15:40:00',2.31),('11288','2013-02-14','15:45:00',2.17),('11288','2013-02-14','15:50:00',2.01),('11288','2013-02-14','15:55:00',1.77),('11288','2013-02-14','16:00:00',1.71),('11288','2013-02-14','16:05:00',1.6),('11288','2013-02-14','16:10:00',1.47),('11288','2013-02-14','16:15:00',1.31),('11288','2013-02-14','16:20:00',1.16),('11288','2013-02-14','16:25:00',1.09),('11288','2013-02-13','08:35:00',1.04),('11288','2013-02-13','08:40:00',1.08),('11288','2013-02-13','08:45:00',1.29),('11288','2013-02-13','08:50:00',1.41),('11288','2013-02-13','08:55:00',1.59),('11288','2013-02-13','09:00:00',1.76),('11288','2013-02-13','09:05:00',1.83),('11288','2013-02-13','09:10:00',1.85),('11288','2013-02-13','09:15:00',1.87),('11288','2013-02-13','09:20:00',1.82),('11288','2013-02-13','09:25:00',1.95),('11288','2013-02-13','09:30:00',2.31),('11288','2013-02-13','09:35:00',2.96),('11288','2013-02-13','09:40:00',2.93),('11288','2013-02-13','09:45:00',3.34),('11288','2013-02-13','09:50:00',3.4),('11288','2013-02-13','09:55:00',3.21),('11288','2013-02-13','10:00:00',3.41),('11288','2013-02-13','10:05:00',3.65),('11288','2013-02-13','10:10:00',3.95),('11288','2013-02-13','10:15:00',4.1),('11288','2013-02-13','10:20:00',4.24),('11288','2013-02-13','10:25:00',4.47),('11288','2013-02-13','10:30:00',4.68),('11288','2013-02-13','10:35:00',4.83),('11288','2013-02-13','10:40:00',4.54),('11288','2013-02-13','10:45:00',4.8),('11288','2013-02-13','10:50:00',5.1),('11288','2013-02-13','10:55:00',5.1),('11288','2013-02-13','11:00:00',5.08),('11288','2013-02-13','11:05:00',5.07),('11288','2013-02-13','11:10:00',4.84),('11288','2013-02-13','11:15:00',4.85),('11288','2013-02-13','11:20:00',4.65),('11288','2013-02-13','11:25:00',4.77),('11288','2013-02-13','11:30:00',4.61),('11288','2013-02-13','11:35:00',2.85),('11288','2013-02-13','11:40:00',2.32),('11288','2013-02-13','11:45:00',3.37),('11288','2013-02-13','11:50:00',3.53),('11288','2013-02-13','11:55:00',2.38),('11288','2013-02-13','12:00:00',2.3),('11288','2013-02-13','12:05:00',3.5),('11288','2013-02-13','12:10:00',4.22),('11288','2013-02-13','12:15:00',3.08),('11288','2013-02-13','12:20:00',3.9),('11288','2013-02-13','12:25:00',2.52),('11288','2013-02-13','12:30:00',1.95),('11288','2013-02-13','12:35:00',2.58),('11288','2013-02-13','12:40:00',2.56),('11288','2013-02-13','12:45:00',4.01),('11288','2013-02-13','12:50:00',4.29),('11288','2013-02-13','12:55:00',3.96),('11288','2013-02-13','13:00:00',4.46),('11288','2013-02-13','13:05:00',2.68),('11288','2013-02-13','13:10:00',2.94),('11288','2013-02-13','13:15:00',4.37),('11288','2013-02-13','13:20:00',5.1),('11288','2013-02-13','13:25:00',5.24),('11288','2013-02-13','13:30:00',5.27),('11288','2013-02-13','13:35:00',5.36),('11288','2013-02-13','13:40:00',4.89),('11288','2013-02-13','13:45:00',4.21),('11288','2013-02-13','13:50:00',4.07),('11288','2013-02-13','13:55:00',4.34),('11288','2013-02-13','14:00:00',4.37),('11288','2013-02-13','14:05:00',4.74),('11288','2013-02-13','14:10:00',4.58),('11288','2013-02-13','14:15:00',4.27),('11288','2013-02-13','14:20:00',4.03),('11288','2013-02-13','14:25:00',3.54),('11288','2013-02-13','14:30:00',3.96),('11288','2013-02-13','14:35:00',3.98),('11288','2013-02-13','14:40:00',3.99),('11288','2013-02-13','14:45:00',3.68),('11288','2013-02-13','14:50:00',3.66),('11288','2013-02-13','14:55:00',3.53),('11288','2013-02-13','15:00:00',3.39),('11288','2013-02-13','15:05:00',3.23),('11288','2013-02-13','15:10:00',3.11),('11288','2013-02-13','15:15:00',3),('11288','2013-02-13','15:20:00',2.82),('11288','2013-02-13','15:25:00',2.77),('11288','2013-02-13','15:30:00',2.62),('11288','2013-02-13','15:35:00',2.5),('11288','2013-02-13','15:40:00',2.29),('11288','2013-02-13','15:45:00',2.22),('11288','2013-02-13','15:50:00',2.04),('11288','2013-02-13','15:55:00',1.81),('11288','2013-02-13','16:00:00',1.73),('11288','2013-02-13','16:05:00',1.62),('11288','2013-02-13','16:10:00',1.51),('11288','2013-02-13','16:15:00',1.36),('11288','2013-02-13','16:20:00',1.23),('11288','2013-02-13','16:25:00',1.09),('11288','2013-02-12','12:10:00',1.07),('11288','2013-02-12','12:15:00',1.08),('11288','2013-02-12','12:20:00',1.06),('11288','2013-02-12','12:25:00',1.04),('11288','2013-02-12','12:30:00',1.05),('11288','2013-02-11','09:15:00',1.04),('11288','2013-02-11','09:20:00',1.01),('11288','2013-02-11','09:25:00',1.07),('11288','2013-02-11','09:30:00',1.34),('11288','2013-02-11','09:35:00',1.23),('11288','2013-02-11','10:00:00',1.05),('11288','2013-02-11','10:05:00',1.08),('11288','2013-02-11','10:10:00',1.17),('11288','2013-02-11','10:15:00',1.56),('11288','2013-02-11','10:20:00',1.86),('11288','2013-02-11','10:25:00',1.97),('11288','2013-02-11','10:30:00',2),('11288','2013-02-11','10:35:00',2.33),('11288','2013-02-11','10:40:00',2.01),('11288','2013-02-11','10:45:00',1.6),('11288','2013-02-11','10:50:00',1.33),('11288','2013-02-11','10:55:00',1.27),('11288','2013-02-11','11:00:00',1.85),('11288','2013-02-11','11:05:00',2.1),('11288','2013-02-11','11:10:00',2.57),('11288','2013-02-11','11:15:00',2.68),('11288','2013-02-11','11:20:00',2.03),('11288','2013-02-11','11:25:00',1.41),('11288','2013-02-11','11:35:00',1.18),('11288','2013-02-11','11:40:00',1.52),('11288','2013-02-11','11:45:00',2.29),('11288','2013-02-11','11:50:00',1.66),('11288','2013-02-11','11:55:00',1.05),('11288','2013-02-11','12:40:00',1.57),('11288','2013-02-11','12:45:00',2.4),('11288','2013-02-11','12:50:00',1.29),('11288','2013-02-11','12:55:00',1.26),('11288','2013-02-11','13:50:00',1.03),('11288','2013-02-11','13:55:00',1.69),('11288','2013-02-11','14:00:00',1.82),('11288','2013-02-11','14:05:00',1.97),('11288','2013-02-11','14:10:00',2.17),('11288','2013-02-11','14:15:00',1.8),('11288','2013-02-11','14:20:00',1.9),('11288','2013-02-11','14:25:00',2.85),('11288','2013-02-11','14:30:00',3.39),('11288','2013-02-11','14:35:00',2.17),('11288','2013-02-11','14:40:00',3),('11288','2013-02-11','14:45:00',2.37),('11288','2013-02-11','14:50:00',1.64),('11288','2013-02-11','14:55:00',1.39),('11288','2013-02-11','15:00:00',1.12),('11288','2013-02-11','15:05:00',1.53),('11288','2013-02-11','15:10:00',1.7),('11288','2013-02-11','15:15:00',1.15),('11288','2013-02-11','15:20:00',1.3),('11288','2013-02-11','15:25:00',1.21),('11288','2013-02-11','15:30:00',1.12),('11288','2013-02-11','15:35:00',1.19),('11288','2013-02-11','15:40:00',1.14),('11288','2013-02-11','15:45:00',1.32),('11288','2013-02-11','15:50:00',1.22),('11288','2014-03-22','07:35:00',1.53),('11288','2014-03-22','07:40:00',1.8),('11288','2014-03-22','07:45:00',1.96),('11288','2014-03-22','07:50:00',1.71),('11288','2014-03-22','07:55:00',1.05),('11288','2014-03-22','08:10:00',1.5),('11288','2014-03-22','08:15:00',1.99),('11288','2014-03-22','08:20:00',2.33),('11288','2014-03-22','08:25:00',2.39),('11288','2014-03-22','08:30:00',2.27),('11288','2014-03-22','08:35:00',1.67),('11288','2014-03-22','08:40:00',2.85),('11288','2014-03-22','08:45:00',3.23),('11288','2014-03-22','08:50:00',2.76),('11288','2014-03-22','08:55:00',3.34),('11288','2014-03-22','09:00:00',3.06),('11288','2014-03-22','09:05:00',2.33),('11288','2014-03-22','09:10:00',2.62),('11288','2014-03-22','09:15:00',2.21),('11288','2014-03-22','09:20:00',2.41),('11288','2014-03-22','09:25:00',3.21),('11288','2014-03-22','09:30:00',3.42),('11288','2014-03-22','09:35:00',2.17),('11288','2014-03-22','09:40:00',3.23),('11288','2014-03-22','09:45:00',4.7),('11288','2014-03-22','09:50:00',4.8),('11288','2014-03-22','09:55:00',4.81),('11288','2014-03-22','10:00:00',4.25),('11288','2014-03-22','10:05:00',3.06),('11288','2014-03-22','10:10:00',3.5),('11288','2014-03-22','10:15:00',3.14),('11288','2014-03-22','10:20:00',1.84),('11288','2014-03-22','10:25:00',1.57),('11288','2014-03-22','10:30:00',1.85),('11288','2014-03-22','10:35:00',2.76),('11288','2014-03-22','10:40:00',3.25),('11288','2014-03-22','10:45:00',4.16),('11288','2014-03-22','10:50:00',3.02),('11288','2014-03-22','10:55:00',2.26),('11288','2014-03-22','11:00:00',2.27),('11288','2014-03-22','11:05:00',1.98),('11288','2014-03-22','11:10:00',2.84),('11288','2014-03-22','11:15:00',3.26),('11288','2014-03-22','11:20:00',6.52),('11288','2014-03-22','11:25:00',7.21),('11288','2014-03-22','11:30:00',4.45),('11288','2014-03-22','11:35:00',4.22),('11288','2014-03-22','11:40:00',3.53),('11288','2014-03-22','11:45:00',2.5),('11288','2014-03-22','11:50:00',5.9),('11288','2014-03-22','11:55:00',6.49),('11288','2014-03-22','12:00:00',2.86),('11288','2014-03-22','12:05:00',2.33),('11288','2014-03-22','12:10:00',2.41),('11288','2014-03-22','12:15:00',4.86),('11288','2014-03-22','12:20:00',6.12),('11288','2014-03-22','12:25:00',2.6),('11288','2014-03-22','12:30:00',3.39),('11288','2014-03-22','12:35:00',3.85),('11288','2014-03-22','12:40:00',6.87),('11288','2014-03-22','12:45:00',4.6),('11288','2014-03-22','12:50:00',5.1),('11288','2014-03-22','12:55:00',3.54),('11288','2014-03-22','13:00:00',2.67),('11288','2014-03-22','13:05:00',6.49),('11288','2014-03-22','13:10:00',6.08),('11288','2014-03-22','13:15:00',6.01),('11288','2014-03-22','13:20:00',5.73),('11288','2014-03-22','13:25:00',4.6),('11288','2014-03-22','13:30:00',4.71),('11288','2014-03-22','13:35:00',5.18),('11288','2014-03-22','13:40:00',6.49),('11288','2014-03-22','13:45:00',4.98),('11288','2014-03-22','13:50:00',3.85),('11288','2014-03-22','13:55:00',4.9),('11288','2014-03-22','14:00:00',4.76),('11288','2014-03-22','14:05:00',4.71),('11288','2014-03-22','14:10:00',4.6),('11288','2014-03-22','14:15:00',3.76),('11288','2014-03-22','14:20:00',5.33),('11288','2014-03-22','14:25:00',5.18),('11288','2014-03-22','14:30:00',5.08),('11288','2014-03-22','14:35:00',4.97),('11288','2014-03-22','14:40:00',4.83),('11288','2014-03-22','14:45:00',4.69),('11288','2014-03-22','14:50:00',4.61),('11288','2014-03-22','14:55:00',4.49),('11288','2014-03-22','15:00:00',4.3),('11288','2014-03-22','15:05:00',4.25),('11288','2014-03-22','15:10:00',3.9),('11288','2014-03-22','15:15:00',4.01),('11288','2014-03-22','15:20:00',3.9),('11288','2014-03-22','15:25:00',2.97),('11288','2014-03-22','15:30:00',2.18),('11288','2014-03-22','15:35:00',3.54),('11288','2014-03-22','15:40:00',3.91),('11288','2014-03-22','15:45:00',3.98),('11288','2014-03-22','15:50:00',4.12),('11288','2014-03-22','15:55:00',3.61),('11288','2014-03-22','16:00:00',3.32),('11288','2014-03-22','16:05:00',2.87),('11288','2014-03-22','16:10:00',2.63),('11288','2014-03-22','16:15:00',2.41),('11288','2014-03-22','16:20:00',2.09),('11288','2014-03-22','16:25:00',1.9),('11288','2014-03-22','16:30:00',1.2),('11288','2014-03-22','16:40:00',1),('11288','2014-03-22','16:50:00',1.19),('11288','2014-03-22','16:55:00',1.3),('11288','2014-03-22','17:00:00',1.38),('11288','2013-02-10','09:05:00',1.05),('11288','2013-02-10','09:10:00',1.12),('11288','2013-02-10','09:15:00',1.25),('11288','2013-02-10','09:40:00',1.16),('11288','2013-02-10','09:45:00',2.23),('11288','2013-02-10','09:50:00',2.63),('11288','2013-02-10','09:55:00',1.45),('11288','2013-02-10','10:00:00',3.58),('11288','2013-02-10','10:05:00',3.76),('11288','2013-02-10','10:10:00',3.83),('11288','2013-02-10','10:15:00',4.03),('11288','2013-02-10','10:20:00',4.12),('11288','2013-02-10','10:25:00',4.24),('11288','2013-02-10','10:30:00',4.35),('11288','2013-02-10','10:35:00',4.31),('11288','2013-02-10','10:40:00',4.1),('11288','2013-02-10','10:45:00',4.45),('11288','2013-02-10','10:50:00',4.64),('11288','2013-02-10','10:55:00',4.72),('11288','2013-02-10','11:00:00',4.78),('11288','2013-02-10','11:05:00',4.75),('11288','2013-02-10','11:10:00',4.63),('11288','2013-02-10','11:15:00',4.86),('11288','2013-02-10','11:20:00',4.98),('11288','2013-02-10','11:25:00',5.05),('11288','2013-02-10','11:30:00',5.08),('11288','2013-02-10','11:35:00',5.12),('11288','2013-02-10','11:40:00',5.15),('11288','2013-02-10','11:45:00',5.05),('11288','2013-02-10','11:50:00',5.2),('11288','2013-02-10','11:55:00',5.21),('11288','2013-02-10','12:00:00',5.29),('11288','2013-02-10','12:05:00',5.3),('11288','2013-02-10','12:10:00',5.31),('11288','2013-02-10','12:15:00',5.37),('11288','2013-02-10','12:20:00',5.35),('11288','2013-02-10','12:25:00',5.34),('11288','2013-02-10','12:30:00',5.34),('11288','2013-02-10','12:35:00',5.31),('11288','2013-02-10','12:40:00',5.26),('11288','2013-02-10','12:45:00',5.22),('11288','2013-02-10','12:50:00',5.2),('11288','2013-02-10','12:55:00',5.18),('11288','2013-02-10','13:00:00',5.15),('11288','2013-02-10','13:05:00',5.03),('11288','2013-02-10','13:10:00',5.05),('11288','2013-02-10','13:15:00',4.98),('11288','2013-02-10','13:20:00',4.88),('11288','2013-02-10','13:25:00',4.88),('11288','2013-02-10','13:30:00',4.82),('11288','2013-02-10','13:35:00',4.77),('11288','2013-02-10','13:40:00',4.67),('11288','2013-02-10','13:45:00',4.54),('11288','2013-02-10','13:50:00',4.55),('11288','2013-02-10','13:55:00',4.41),('11288','2013-02-10','14:00:00',4.36),('11288','2013-02-10','14:05:00',4.37),('11288','2013-02-10','14:10:00',4.23),('11288','2013-02-10','14:15:00',4.16),('11288','2013-02-10','14:20:00',4.09),('11288','2013-02-10','14:25:00',3.99),('11288','2013-02-10','14:30:00',3.91),('11288','2013-02-10','14:35:00',3.5),('11288','2013-02-10','14:40:00',3.74),('11288','2013-02-10','14:45:00',3.4),('11288','2013-02-10','14:50:00',3.4),('11288','2013-02-10','14:55:00',2.88),('11288','2013-02-10','15:00:00',2.93),('11288','2013-02-10','15:05:00',3.03),('11288','2013-02-10','15:10:00',2.98),('11288','2013-02-10','15:15:00',2.75),('11288','2013-02-10','15:20:00',2.94),('11288','2013-02-10','15:25:00',3.21),('11288','2013-02-10','15:30:00',2.41),('11288','2013-02-10','15:35:00',2.75),('11288','2013-02-10','15:40:00',2.12),('11288','2013-02-10','15:45:00',1.1),('11288','2013-02-10','16:25:00',1.33),('11288','2013-02-10','16:30:00',1.34),('11288','2013-02-10','16:35:00',1.24),('11288','2013-02-09','09:10:00',1.06),('11288','2013-02-09','09:15:00',1.12),('11288','2013-02-09','09:20:00',1.15),('11288','2013-02-09','09:25:00',1.35),('11288','2013-02-09','09:30:00',1.6),('11288','2013-02-09','09:35:00',1.61),('11288','2013-02-09','09:40:00',1.33),('11288','2013-02-09','09:45:00',1.14),('11288','2013-02-09','09:50:00',1.12),('11288','2013-02-09','09:55:00',1.1),('11288','2013-02-09','10:00:00',1.03),('11288','2013-02-09','10:05:00',1),('11288','2013-02-09','10:30:00',1.03),('11288','2013-02-09','10:35:00',1.12),('11288','2013-02-09','10:40:00',1.29),('11288','2013-02-09','10:45:00',1.49),('11288','2013-02-09','10:50:00',1.7),('11288','2013-02-09','10:55:00',1.84),('11288','2013-02-09','11:00:00',1.96),('11288','2013-02-09','11:05:00',2.02),('11288','2013-02-09','11:10:00',2.08),('11288','2013-02-09','11:15:00',2.16),('11288','2013-02-09','11:20:00',2.23),('11288','2013-02-09','11:25:00',2.25),('11288','2013-02-09','11:30:00',2.27),('11288','2013-02-09','11:35:00',2.21),('11288','2013-02-09','11:40:00',2.16),('11288','2013-02-09','11:45:00',2.19),('11288','2013-02-09','11:50:00',2.16),('11288','2013-02-09','11:55:00',2.1),('11288','2013-02-09','12:00:00',2.14),('11288','2013-02-09','12:05:00',2.13),('11288','2013-02-09','12:10:00',2.08),('11288','2013-02-09','12:15:00',2.08),('11288','2013-02-09','12:20:00',2.11),('11288','2013-02-09','12:25:00',2.13),('11288','2013-02-09','12:30:00',2.18),('11288','2013-02-09','12:35:00',2.29),('11288','2013-02-09','12:40:00',2.34),('11288','2013-02-09','12:45:00',2.36),('11288','2013-02-09','12:50:00',2.36),('11288','2013-02-09','12:55:00',2.34),('11288','2013-02-09','13:00:00',2.5),('11288','2013-02-09','13:05:00',2.84),('11288','2013-02-09','13:10:00',3.12),('11288','2013-02-09','13:15:00',3.3),('11288','2013-02-09','13:20:00',3.67),('11288','2013-02-09','13:25:00',3.84),('11288','2013-02-09','13:30:00',4.1),('11288','2013-02-09','13:35:00',4.43),('11288','2013-02-09','13:40:00',4.35),('11288','2013-02-09','13:45:00',4.72),('11288','2013-02-09','13:50:00',4.72),('11288','2013-02-09','13:55:00',4.99),('11288','2013-02-09','14:00:00',4.56),('11288','2013-02-09','14:05:00',4.33),('11288','2013-02-09','14:10:00',3.87),('11288','2013-02-09','14:15:00',4.49),('11288','2013-02-09','14:20:00',5.33),('11288','2013-02-09','14:25:00',5.06),('11288','2013-02-09','14:30:00',4.49),('11288','2013-02-09','14:35:00',4.04),('11288','2013-02-09','14:40:00',3.64),('11288','2013-02-09','14:45:00',3.55),('11288','2013-02-09','14:50:00',3.4),('11288','2013-02-09','14:55:00',3.35),('11288','2013-02-09','15:00:00',3.2),('11288','2013-02-09','15:05:00',3.03),('11288','2013-02-09','15:10:00',2.89),('11288','2013-02-09','15:15:00',2.72),('11288','2013-02-09','15:20:00',2.63),('11288','2013-02-09','15:25:00',2.25),('11288','2013-02-09','15:30:00',2.33),('11288','2013-02-09','15:35:00',2.21),('11288','2013-02-09','15:40:00',1.97),('11288','2013-02-09','15:45:00',1.91),('11288','2013-02-09','15:50:00',1.86),('11288','2013-02-09','15:55:00',1.43),('11288','2013-02-09','16:20:00',1.14),('11288','2013-02-08','08:55:00',1.11),('11288','2013-02-08','09:00:00',1.05),('11288','2013-02-08','09:15:00',1.04),('11288','2013-02-08','09:20:00',1.26),('11288','2013-02-08','09:25:00',1.42),('11288','2013-02-08','09:30:00',1.5),('11288','2013-02-08','09:35:00',2.16),('11288','2013-02-08','09:40:00',2.73),('11288','2013-02-08','09:45:00',2.84),('11288','2013-02-08','09:50:00',3.94),('11288','2013-02-08','09:55:00',3.91),('11288','2013-02-08','10:00:00',4.15),('11288','2013-02-08','10:05:00',4.34),('11288','2013-02-08','10:10:00',4.42),('11288','2013-02-08','10:15:00',4.73),('11288','2013-02-08','10:20:00',3.43),('11288','2013-02-08','10:25:00',4.74),('11288','2013-02-08','10:30:00',3.04),('11288','2013-02-08','10:35:00',2.67),('11288','2013-02-08','10:40:00',4.34),('11288','2013-02-08','10:45:00',4.93),('11288','2013-02-08','10:50:00',5.13),('11288','2013-02-08','10:55:00',5.04),('11288','2013-02-08','11:00:00',4.92),('11288','2013-02-08','11:05:00',4.83),('11288','2013-02-08','11:10:00',4.91),('11288','2013-02-08','11:15:00',4.93),('11288','2013-02-08','11:20:00',4.96),('11288','2013-02-08','11:25:00',5.07),('11288','2013-02-08','11:30:00',5.09),('11288','2013-02-08','11:35:00',5.08),('11288','2013-02-08','11:40:00',5.12),('11288','2013-02-08','11:45:00',4.96),('11288','2013-02-08','11:50:00',5.03),('11288','2013-02-08','11:55:00',5.16),('11288','2013-02-08','12:00:00',5.16),('11288','2013-02-08','12:05:00',5.19),('11288','2013-02-08','12:10:00',5.21),('11288','2013-02-08','12:15:00',5.25),('11288','2013-02-08','12:20:00',5.21),('11288','2013-02-08','12:25:00',5.26),('11288','2013-02-08','12:30:00',5.22),('11288','2013-02-08','12:35:00',5.27),('11288','2013-02-08','12:40:00',5.33),('11288','2013-02-08','12:45:00',5.67),('11288','2013-02-08','12:50:00',3.17),('11288','2013-02-08','12:55:00',3.47),('11288','2013-02-08','13:00:00',3.45),('11288','2013-02-08','13:05:00',2.98),('11288','2013-02-08','13:10:00',3.17),('11288','2013-02-08','13:15:00',3.15),('11288','2013-02-08','13:20:00',3.24),('11288','2013-02-08','13:25:00',3.04),('11288','2013-02-08','13:30:00',3.04),('11288','2013-02-08','13:35:00',3.75),('11288','2013-02-08','13:40:00',3.12),('11288','2013-02-08','13:45:00',2.47),('11288','2013-02-08','13:50:00',2.59),('11288','2013-02-08','13:55:00',2.72),('11288','2013-02-08','14:00:00',2.47),('11288','2013-02-08','14:05:00',2.45),('11288','2013-02-08','14:10:00',2.3),('11288','2013-02-08','14:15:00',2.21),('11288','2013-02-08','14:20:00',2.34),('11288','2013-02-08','14:25:00',3.05),('11288','2013-02-08','14:30:00',3.72),('11288','2013-02-08','14:35:00',3.74),('11288','2013-02-08','14:40:00',5.19),('11288','2013-02-08','14:45:00',3.28),('11288','2013-02-08','14:50:00',3.88),('11288','2013-02-08','14:55:00',4.18),('11288','2013-02-08','15:00:00',4.31),('11288','2013-02-08','15:05:00',4.42),('11288','2013-02-08','15:10:00',4.06),('11288','2013-02-08','15:15:00',3.66),('11288','2013-02-08','15:20:00',1.91),('11288','2013-02-08','15:25:00',2.19),('11288','2013-02-08','15:30:00',2.11),('11288','2013-02-08','15:35:00',2.08),('11288','2013-02-08','15:40:00',2.12),('11288','2013-02-08','15:45:00',2.08),('11288','2013-02-08','15:50:00',1.92),('11288','2013-02-08','15:55:00',1.7),('11288','2013-02-08','16:00:00',1.51),('11288','2013-02-08','16:05:00',1.38),('11288','2013-02-08','16:10:00',1.32),('11288','2013-02-08','16:15:00',1.08),('11288','2013-02-07','09:20:00',1.06),('11288','2013-02-07','09:30:00',1.03),('11288','2013-02-07','09:35:00',1.06),('11288','2013-02-07','09:40:00',1.09),('11288','2013-02-07','09:45:00',1.2),('11288','2013-02-07','09:50:00',1.22),('11288','2013-02-07','10:25:00',1.3),('11288','2013-02-07','10:30:00',1.23),('11288','2013-02-07','10:35:00',2.02),('11288','2013-02-07','10:40:00',2.07),('11288','2013-02-07','10:45:00',1.79),('11288','2013-02-07','10:50:00',1.32),('11288','2013-02-07','10:55:00',2.25),('11288','2013-02-07','11:00:00',2.89),('11288','2013-02-07','11:05:00',2.02),('11288','2013-02-07','11:10:00',1.5),('11288','2013-02-07','12:20:00',2.46),('11288','2013-02-07','12:25:00',3.93),('11288','2013-02-07','12:30:00',3.2),('11288','2013-02-07','12:35:00',1.65),('11288','2013-02-07','12:40:00',1.16),('11288','2013-02-07','12:45:00',1.51),('11288','2013-02-07','12:50:00',1.54),('11288','2013-02-07','12:55:00',1.16),('11288','2013-02-07','13:00:00',1.02),('11288','2013-02-07','13:05:00',1.19),('11288','2013-02-07','13:10:00',1.48),('11288','2013-02-07','13:15:00',3.31),('11288','2013-02-07','13:20:00',2.46),('11288','2013-02-07','13:25:00',2.5),('11288','2013-02-07','13:30:00',1.76),('11288','2013-02-07','13:35:00',1.51),('11288','2013-02-07','13:40:00',1.65),('11288','2013-02-07','13:45:00',1.67),('11288','2013-02-07','13:50:00',1.77),('11288','2013-02-07','13:55:00',2.04),('11288','2013-02-07','14:00:00',2.48),('11288','2013-02-07','14:05:00',3.43),('11288','2013-02-07','14:10:00',5.12),('11288','2013-02-07','14:15:00',4.4),('11288','2013-02-07','14:20:00',3.6),('11288','2013-02-07','14:25:00',2),('11288','2013-02-07','14:30:00',1.72),('11288','2013-02-07','14:35:00',2.86),('11288','2013-02-07','14:40:00',3.36),('11288','2013-02-07','14:45:00',2.91),('11288','2013-02-07','14:50:00',2.11),('11288','2013-02-07','14:55:00',2.63),('11288','2013-02-07','15:00:00',3.26),('11288','2013-02-07','15:05:00',3.78),('11288','2013-02-07','15:10:00',3.95),('11288','2013-02-07','15:15:00',2.72),('11288','2013-02-07','15:20:00',2.04),('11288','2013-02-07','15:25:00',1.83),('11288','2013-02-07','15:30:00',1.34),('11288','2013-02-07','15:35:00',1.46),('11288','2013-02-07','15:40:00',1.21),('11288','2013-02-07','15:50:00',1.12),('11288','2013-02-06','08:30:00',1),('11288','2013-02-06','08:35:00',1.13),('11288','2013-02-06','08:40:00',1.37),('11288','2013-02-06','08:45:00',1.5),('11288','2013-02-06','08:50:00',1.77),('11288','2013-02-06','08:55:00',1.59),('11288','2013-02-06','09:00:00',1.78),('11288','2013-02-06','09:05:00',1.74),('11288','2013-02-06','09:10:00',1.99),('11288','2013-02-06','09:15:00',1.62),('11288','2013-02-06','09:20:00',1.79),('11288','2013-02-06','09:25:00',1.96),('11288','2013-02-06','09:30:00',2.3),('11288','2013-02-06','09:35:00',1.99),('11288','2013-02-06','09:40:00',2.39),('11288','2013-02-06','09:45:00',2.11),('11288','2013-02-06','09:50:00',2.17),('11288','2013-02-06','09:55:00',2.56),('11288','2013-02-06','10:00:00',2.29),('11288','2013-02-06','10:05:00',2.75),('11288','2013-02-06','10:10:00',2.32),('11288','2013-02-06','10:15:00',2.23),('11288','2013-02-06','10:20:00',2.11),('11288','2013-02-06','10:25:00',2.65),('11288','2013-02-06','10:30:00',2.51),('11288','2013-02-06','10:35:00',3.26),('11288','2013-02-06','10:40:00',2.21),('11288','2013-02-06','10:45:00',1.98),('11288','2013-02-06','10:50:00',3.17),('11288','2013-02-06','10:55:00',3.38),('11288','2013-02-06','11:00:00',2.91),('11288','2013-02-06','11:05:00',2.57),('11288','2013-02-06','11:10:00',2.81),('11288','2013-02-06','11:15:00',2.59),('11288','2013-02-06','11:20:00',3.37),('11288','2013-02-06','11:25:00',4.39),('11288','2013-02-06','11:30:00',2.66),('11288','2013-02-06','11:35:00',2.61),('11288','2013-02-06','11:40:00',2.87),('11288','2013-02-06','11:45:00',2.89),('11288','2013-02-06','11:50:00',2.99),('11288','2013-02-06','11:55:00',2.78),('11288','2013-02-06','12:00:00',2.41),('11288','2013-02-06','12:05:00',1.88),('11288','2013-02-06','12:10:00',1.53),('11288','2013-02-06','12:15:00',2.19),('11288','2013-02-06','12:20:00',1.98),('11288','2013-02-06','12:25:00',1.92),('11288','2013-02-06','12:30:00',1.61),('11288','2013-02-06','12:35:00',1.4),('11288','2013-02-06','12:40:00',1.25),('11288','2013-02-06','12:45:00',1.28),('11288','2013-02-06','12:50:00',1.25),('11288','2013-02-06','12:55:00',1.24),('11288','2013-02-06','13:00:00',1.11),('11288','2013-02-06','13:05:00',1.17),('11288','2013-02-06','13:10:00',1.32),('11288','2013-02-06','13:15:00',1.59),('11288','2013-02-06','13:20:00',1.76),('11288','2013-02-06','13:25:00',1.98),('11288','2013-02-06','13:30:00',2.28),('11288','2013-02-06','13:35:00',2.36),('11288','2013-02-06','13:40:00',1.97),('11288','2013-02-06','13:45:00',2.06),('11288','2013-02-06','13:50:00',2.7),('11288','2013-02-06','13:55:00',2.3),('11288','2013-02-06','14:00:00',2.52),('11288','2013-02-06','14:05:00',2.28),('11288','2013-02-06','14:10:00',1.29),('11288','2013-02-06','14:30:00',3.11),('11288','2013-02-06','14:35:00',3.12),('11288','2013-02-06','14:40:00',2.38),('11288','2013-02-06','14:45:00',1.1),('11288','2013-02-06','15:15:00',1.06),('11288','2013-02-06','15:20:00',1.07),('11288','2013-02-06','15:25:00',1.81),('11288','2013-02-06','15:45:00',1.11),('11288','2013-02-06','15:50:00',1.14),('11288','2013-02-05','08:25:00',1.07),('11288','2013-02-05','08:30:00',1.18),('11288','2013-02-05','08:35:00',1.24),('11288','2013-02-05','08:40:00',1.46),('11288','2013-02-05','08:45:00',1.55),('11288','2013-02-05','08:50:00',1.65),('11288','2013-02-05','08:55:00',1.76),('11288','2013-02-05','09:00:00',1.86),('11288','2013-02-05','09:05:00',1.94),('11288','2013-02-05','09:10:00',2.08),('11288','2013-02-05','09:15:00',2.24),('11288','2013-02-05','09:20:00',2.3),('11288','2013-02-05','09:25:00',2.45),('11288','2013-02-05','09:30:00',2.56),('11288','2013-02-05','09:35:00',2.59),('11288','2013-02-05','09:40:00',2.81),('11288','2013-02-05','09:45:00',2.9),('11288','2013-02-05','09:50:00',2.89),('11288','2013-02-05','09:55:00',3.14),('11288','2013-02-05','10:00:00',3.13),('11288','2013-02-05','10:05:00',3.08),('11288','2013-02-05','10:10:00',3.1),('11288','2013-02-05','10:15:00',3.21),('11288','2013-02-05','10:20:00',3.68),('11288','2013-02-05','10:25:00',3.75),('11288','2013-02-05','10:30:00',3.77),('11288','2013-02-05','10:35:00',3.6),('11288','2013-02-05','10:40:00',3.71),('11288','2013-02-05','10:45:00',3.97),('11288','2013-02-05','10:50:00',4.03),('11288','2013-02-05','10:55:00',4.12),('11288','2013-02-05','11:00:00',4.12),('11288','2013-02-05','11:05:00',3.94),('11288','2013-02-05','11:10:00',4.13),('11288','2013-02-05','11:15:00',4.31),('11288','2013-02-05','11:20:00',4.32),('11288','2013-02-05','11:25:00',4.58),('11288','2013-02-05','11:30:00',4.38),('11288','2013-02-05','11:35:00',4.21),('11288','2013-02-05','11:40:00',4.16),('11288','2013-02-05','11:45:00',3.69),('11288','2013-02-05','11:50:00',2.72),('11288','2013-02-05','11:55:00',2.37),('11288','2013-02-05','12:00:00',1.83),('11288','2013-02-05','12:05:00',2.64),('11288','2013-02-05','12:10:00',2.46),('11288','2013-02-05','12:15:00',2.51),('11288','2013-02-05','12:20:00',2.29),('11288','2013-02-05','12:25:00',2.24),('11288','2013-02-05','12:30:00',2.02),('11288','2013-02-05','12:35:00',3.82),('11288','2013-02-05','12:40:00',3.24),('11288','2013-02-05','12:45:00',3.82),('11288','2013-02-05','12:50:00',3.09),('11288','2013-02-05','12:55:00',1.63),('11288','2013-02-05','13:00:00',1.23),('11288','2013-02-05','13:05:00',1.49),('11288','2013-02-05','13:10:00',2.03),('11288','2013-02-05','13:15:00',2.39),('11288','2013-02-05','13:20:00',2.34),('11288','2013-02-05','13:25:00',2.44),('11288','2013-02-05','13:30:00',2.18),('11288','2013-02-05','13:35:00',1.78),('11288','2013-02-05','13:40:00',2.02),('11288','2013-02-05','13:45:00',2.42),('11288','2013-02-05','13:50:00',2.45),('11288','2013-02-05','13:55:00',2.17),('11288','2013-02-05','14:00:00',2.18),('11288','2013-02-05','14:05:00',2.12),('11288','2013-02-05','14:10:00',1.76),('11288','2013-02-05','14:15:00',1.88),('11288','2013-02-05','14:20:00',2.31),('11288','2013-02-05','14:25:00',2.93),('11288','2013-02-05','14:30:00',2.82),('11288','2013-02-05','14:35:00',2.36),('11288','2013-02-05','14:40:00',2.76),('11288','2013-02-05','14:45:00',1.88),('11288','2013-02-05','14:50:00',1.5),('11288','2013-02-05','14:55:00',1.27),('11288','2013-02-05','15:00:00',1.39),('11288','2013-02-05','15:05:00',1.77),('11288','2013-02-05','15:10:00',1.34),('11288','2013-02-05','15:15:00',1.16),('11288','2013-02-04','08:25:00',1.05),('11288','2013-02-04','08:30:00',1.18),('11288','2013-02-04','08:35:00',1.19),('11288','2013-02-04','08:40:00',1.41),('11288','2013-02-04','08:45:00',1.53),('11288','2013-02-04','08:50:00',1.63),('11288','2013-02-04','08:55:00',1.63),('11288','2013-02-04','09:00:00',1.92),('11288','2013-02-04','09:05:00',2.08),('11288','2013-02-04','09:10:00',2.24),('11288','2013-02-04','09:15:00',2.35),('11288','2013-02-04','09:20:00',2.35),('11288','2013-02-04','09:25:00',2.44),('11288','2013-02-04','09:30:00',2.59),('11288','2013-02-04','09:35:00',2.72),('11288','2013-02-04','09:40:00',2.79),('11288','2013-02-04','09:45:00',2.52),('11288','2013-02-04','09:50:00',2.88),('11288','2013-02-04','09:55:00',3.27),('11288','2013-02-04','10:00:00',3.36),('11288','2013-02-04','10:05:00',3.6),('11288','2013-02-04','10:10:00',3.71),('11288','2013-02-04','10:15:00',3.93),('11288','2013-02-04','10:20:00',3.75),('11288','2013-02-04','10:25:00',4),('11288','2013-02-04','10:30:00',3.68),('11288','2013-02-04','10:35:00',3.28),('11288','2013-02-04','10:40:00',3.48),('11288','2013-02-04','10:45:00',4.27),('11288','2013-02-04','10:50:00',4.38),('11288','2013-02-04','10:55:00',4.42),('11288','2013-02-04','11:00:00',4.4),('11288','2013-02-04','11:05:00',4.24),('11288','2013-02-04','11:10:00',4.46),('11288','2013-02-04','11:15:00',4.65),('11288','2013-02-04','11:20:00',4.73),('11288','2013-02-04','11:25:00',4.83),('11288','2013-02-04','11:30:00',4.83),('11288','2013-02-04','11:35:00',4.85),('11288','2013-02-04','11:40:00',4.86),('11288','2013-02-04','11:45:00',4.9),('11288','2013-02-04','11:50:00',4.93),('11288','2013-02-04','11:55:00',4.93),('11288','2013-02-04','12:00:00',4.92),('11288','2013-02-04','12:05:00',4.96),('11288','2013-02-04','12:10:00',4.97),('11288','2013-02-04','12:15:00',4.99),('11288','2013-02-04','12:20:00',4.72),('11288','2013-02-04','12:25:00',4.67),('11288','2013-02-04','12:30:00',4.91),('11288','2013-02-04','12:35:00',4.88),('11288','2013-02-04','12:40:00',4.85),('11288','2013-02-04','12:45:00',4.83),('11288','2013-02-04','12:50:00',4.84),('11288','2013-02-04','12:55:00',4.86),('11288','2013-02-04','13:00:00',4.84),('11288','2013-02-04','13:05:00',4.81),('11288','2013-02-04','13:10:00',4.75),('11288','2013-02-04','13:15:00',4.72),('11288','2013-02-04','13:20:00',4.63),('11288','2013-02-04','13:25:00',4.55),('11288','2013-02-04','13:30:00',4.56),('11288','2013-02-04','13:35:00',4.51),('11288','2013-02-04','13:40:00',4.45),('11288','2013-02-04','13:45:00',4.35),('11288','2013-02-04','13:50:00',4.29),('11288','2013-02-04','13:55:00',4.25),('11288','2013-02-04','14:00:00',4.18),('11288','2013-02-04','14:05:00',4.07),('11288','2013-02-04','14:10:00',4.02),('11288','2013-02-04','14:15:00',3.93),('11288','2013-02-04','14:20:00',3.85),('11288','2013-02-04','14:25:00',3.74),('11288','2013-02-04','14:30:00',3.64),('11288','2013-02-04','14:35:00',3.55),('11288','2013-02-04','14:40:00',3.45),('11288','2013-02-04','14:45:00',3.31),('11288','2013-02-04','14:50:00',3.23),('11288','2013-02-04','14:55:00',3.13),('11288','2013-02-04','15:00:00',2.97),('11288','2013-02-04','15:05:00',2.88),('11288','2013-02-04','15:10:00',2.76),('11288','2013-02-04','15:15:00',2.6),('11288','2013-02-04','15:20:00',2.49),('11288','2013-02-04','15:25:00',2.35),('11288','2013-02-04','15:30:00',2.23),('11288','2013-02-04','15:35:00',2.08),('11288','2013-02-04','15:40:00',1.89),('11288','2013-02-04','15:45:00',1.74),('11288','2013-02-04','15:50:00',1.63),('11288','2013-02-04','15:55:00',1.49),('11288','2013-02-04','16:00:00',1.35),('11288','2013-02-04','16:05:00',1.18),('11288','2013-02-04','16:10:00',1.08),('11288','2013-02-04','16:15:00',1.01),('11288','2013-02-03','08:40:00',1.16),('11288','2013-02-03','08:45:00',1.04),('11288','2013-02-03','08:50:00',1.02),('11288','2013-02-03','09:15:00',1.38),('11288','2013-02-03','09:20:00',1.74),('11288','2013-02-03','09:25:00',2.18),('11288','2013-02-03','09:30:00',1.67),('11288','2013-02-03','09:35:00',1.41),('11288','2013-02-03','09:40:00',1.99),('11288','2013-02-03','09:45:00',2.62),('11288','2013-02-03','09:50:00',2.63),('11288','2013-02-03','09:55:00',2.31),('11288','2013-02-03','10:00:00',3.09),('11288','2013-02-03','10:05:00',1.32),('11288','2013-02-03','10:15:00',1.17),('11288','2013-02-03','10:20:00',2.05),('11288','2013-02-03','10:25:00',1.25),('11288','2013-02-03','11:15:00',1.74),('11288','2013-02-03','11:20:00',2.48),('11288','2013-02-03','11:25:00',1.34),('11288','2013-02-03','11:40:00',1.07),('11288','2013-02-03','11:45:00',1.74),('11288','2013-02-03','11:50:00',2.33),('11288','2013-02-03','11:55:00',2.76),('11288','2013-02-03','12:00:00',2.41),('11288','2013-02-03','12:05:00',2.4),('11288','2013-02-03','12:10:00',2.37),('11288','2013-02-03','12:15:00',1.6),('11288','2013-02-03','12:20:00',1.25),('11288','2013-02-03','13:50:00',1.01),('11288','2013-02-03','14:55:00',1.08),('11288','2013-02-02','09:55:00',1.03),('11288','2013-02-02','10:05:00',1.01),('11288','2013-02-02','10:10:00',1.27),('11288','2013-02-02','10:15:00',2.11),('11288','2013-02-02','10:20:00',1.9),('11288','2013-02-02','10:25:00',2.04),('11288','2013-02-02','10:30:00',2.17),('11288','2013-02-02','10:35:00',2.26),('11288','2013-02-02','10:40:00',2.44),('11288','2013-02-02','10:45:00',2.54),('11288','2013-02-02','10:50:00',2.27),('11288','2013-02-02','10:55:00',3.08),('11288','2013-02-02','11:00:00',3.11),('11288','2013-02-02','11:05:00',2.88),('11288','2013-02-02','11:10:00',3.12),('11288','2013-02-02','11:15:00',3.13),('11288','2013-02-02','11:20:00',3.03),('11288','2013-02-02','11:25:00',3.77),('11288','2013-02-02','11:30:00',3.38),('11288','2013-02-02','11:35:00',3.22),('11288','2013-02-02','11:40:00',3.06),('11288','2013-02-02','11:45:00',2.27),('11288','2013-02-02','11:50:00',2.21),('11288','2013-02-02','11:55:00',2.08),('11288','2013-02-02','12:00:00',1.59),('11288','2013-02-02','12:05:00',1.22),('11288','2013-02-02','12:35:00',1.01),('11288','2013-02-02','12:50:00',1.55),('11288','2013-02-02','12:55:00',3.6),('11288','2013-02-02','13:00:00',2.82),('11288','2013-02-02','13:05:00',2.54),('11288','2013-02-02','13:10:00',3.85),('11288','2013-02-02','13:15:00',3.11),('11288','2013-02-02','13:20:00',2.85),('11288','2013-02-02','13:25:00',2.87),('11288','2013-02-02','13:30:00',2.64),('11288','2013-02-02','13:35:00',3.17),('11288','2013-02-02','13:40:00',3.63),('11288','2013-02-02','13:45:00',3.28),('11288','2013-02-02','13:50:00',3.06),('11288','2013-02-02','13:55:00',1.66),('11288','2013-02-02','14:00:00',1.01),('11288','2013-02-01','08:35:00',1.14),('11288','2013-02-01','08:40:00',1.04),('11288','2013-02-01','08:45:00',1.14),('11288','2013-02-01','08:55:00',1.36),('11288','2013-02-01','09:00:00',1.75),('11288','2013-02-01','09:05:00',2.22),('11288','2013-02-01','09:10:00',1.95),('11288','2013-02-01','09:15:00',1.04),('11288','2013-02-01','09:20:00',1.65),('11288','2013-02-01','09:25:00',2.05),('11288','2013-02-01','09:30:00',2.41),('11288','2013-02-01','09:35:00',2.99),('11288','2013-02-01','09:40:00',2.97),('11288','2013-02-01','09:45:00',1.66),('11288','2013-02-01','09:50:00',2.26),('11288','2013-02-01','09:55:00',2.54),('11288','2013-02-01','10:00:00',2.37),('11288','2013-02-01','10:05:00',2.35),('11288','2013-02-01','10:10:00',1.05),('11288','2013-02-01','10:15:00',2.35),('11288','2013-02-01','10:20:00',1.62),('11288','2013-02-01','10:25:00',1.9),('11288','2013-02-01','10:30:00',2.02),('11288','2013-02-01','10:35:00',1.72),('11288','2013-02-01','10:40:00',1.39),('11288','2013-02-01','10:45:00',2.36),('11288','2013-02-01','10:50:00',4.38),('11288','2013-02-01','10:55:00',4.01),('11288','2013-02-01','11:00:00',4.17),('11288','2013-02-01','11:05:00',4.3),('11288','2013-02-01','11:10:00',2.23),('11288','2013-02-01','11:15:00',2.97),('11288','2013-02-01','11:20:00',3.08),('11288','2013-02-01','11:25:00',1.72),('11288','2013-02-01','11:30:00',3.19),('11288','2013-02-01','11:35:00',2.5),('11288','2013-02-01','11:40:00',2.47),('11288','2013-02-01','11:45:00',3.02),('11288','2013-02-01','11:50:00',2.56),('11288','2013-02-01','11:55:00',2.03),('11288','2013-02-01','12:00:00',2.97),('11288','2013-02-01','12:05:00',4.32),('11288','2013-02-01','12:10:00',3.45),('11288','2013-02-01','12:15:00',5.23),('11288','2013-02-01','12:20:00',5.15),('11288','2013-02-01','12:25:00',4.17),('11288','2013-02-01','12:30:00',3.47),('11288','2013-02-01','12:35:00',3.51),('11288','2013-02-01','12:40:00',4.03),('11288','2013-02-01','12:45:00',4.26),('11288','2013-02-01','12:50:00',3.92),('11288','2013-02-01','12:55:00',3),('11288','2013-02-01','13:00:00',2.28),('11288','2013-02-01','13:05:00',4),('11288','2013-02-01','13:10:00',3.69),('11288','2013-02-01','13:15:00',3.97),('11288','2013-02-01','13:20:00',4.35),('11288','2013-02-01','13:25:00',3.01),('11288','2013-02-01','13:30:00',3),('11288','2013-02-01','13:35:00',2.97),('11288','2013-02-01','13:40:00',2.25),('11288','2013-02-01','13:45:00',1.74),('11288','2013-02-01','13:50:00',1.71),('11288','2013-02-01','13:55:00',1.89),('11288','2013-02-01','14:00:00',1.91),('11288','2013-02-01','14:05:00',2.08),('11288','2013-02-01','14:10:00',3.69),('11288','2013-02-01','14:15:00',3.69),('11288','2013-02-01','14:20:00',2.83),('11288','2013-02-01','14:25:00',2.83),('11288','2013-02-01','14:30:00',3.16),('11288','2013-02-01','14:35:00',3.37),('11288','2013-02-01','14:40:00',1.76),('11288','2013-02-01','14:45:00',1.13),('11288','2013-02-01','14:50:00',1.27),('11288','2013-02-01','14:55:00',1.35),('11288','2013-02-01','15:00:00',2.28),('11288','2013-02-01','15:05:00',2.57),('11288','2013-02-01','15:10:00',2.36),('11288','2013-02-01','15:15:00',2.24),('11288','2013-02-01','15:20:00',2.04),('11288','2013-02-01','15:25:00',1.54),('11288','2013-02-01','15:45:00',1.07),('11288','2013-02-01','15:50:00',1.48),('11288','2013-02-01','15:55:00',1.34),('11288','2014-03-21','07:35:00',1.09),('11288','2014-03-21','07:40:00',1.18),('11288','2014-03-21','07:45:00',1.3),('11288','2014-03-21','07:50:00',1.46),('11288','2014-03-21','07:55:00',1.51),('11288','2014-03-21','08:00:00',1.76),('11288','2014-03-21','08:05:00',1.89),('11288','2014-03-21','08:10:00',2.03),('11288','2014-03-21','08:15:00',2.16),('11288','2014-03-21','08:20:00',2.25),('11288','2014-03-21','08:25:00',2.38),('11288','2014-03-21','08:30:00',2.54),('11288','2014-03-21','08:35:00',2.72),('11288','2014-03-21','08:40:00',2.77),('11288','2014-03-21','08:45:00',3.02),('11288','2014-03-21','08:50:00',3.29),('11288','2014-03-21','08:55:00',3.45),('11288','2014-03-21','09:00:00',3.53),('11288','2014-03-21','09:05:00',3.66),('11288','2014-03-21','09:10:00',3.83),('11288','2014-03-21','09:15:00',3.97),('11288','2014-03-21','09:20:00',4.11),('11288','2014-03-21','09:25:00',4.04),('11288','2014-03-21','09:30:00',4.29),('11288','2014-03-21','09:35:00',4.39),('11288','2014-03-21','09:40:00',4.53),('11288','2014-03-21','09:45:00',4.56),('11288','2014-03-21','09:50:00',4.68),('11288','2014-03-21','09:55:00',4.71),('11288','2014-03-21','10:00:00',4.79),('11288','2014-03-21','10:05:00',4.91),('11288','2014-03-21','10:10:00',4.97),('11288','2014-03-21','10:15:00',5),('11288','2014-03-21','10:20:00',5.04),('11288','2014-03-21','10:25:00',5.15),('11288','2014-03-21','10:30:00',5.23),('11288','2014-03-21','10:35:00',5.3),('11288','2014-03-21','10:40:00',5.2),('11288','2014-03-21','10:45:00',5.21),('11288','2014-03-21','10:50:00',5.27),('11288','2014-03-21','10:55:00',5.28),('11288','2014-03-21','11:00:00',5.45),('11288','2014-03-21','11:05:00',5.43),('11288','2014-03-21','11:10:00',5.48),('11288','2014-03-21','11:15:00',5.6),('11288','2014-03-21','11:20:00',5.74),('11288','2014-03-21','11:25:00',5.72),('11288','2014-03-21','11:30:00',3.34),('11288','2014-03-21','11:35:00',4.2),('11288','2014-03-21','11:40:00',5.61),('11288','2014-03-21','11:45:00',6.24),('11288','2014-03-21','11:50:00',6.34),('11288','2014-03-21','11:55:00',5.77),('11288','2014-03-21','12:00:00',4.85),('11288','2014-03-21','12:05:00',6.1),('11288','2014-03-21','12:10:00',6.15),('11288','2014-03-21','12:15:00',6.11),('11288','2014-03-21','12:20:00',6),('11288','2014-03-21','12:25:00',5.93),('11288','2014-03-21','12:30:00',5.93),('11288','2014-03-21','12:35:00',5.97),('11288','2014-03-21','12:40:00',6.06),('11288','2014-03-21','12:45:00',6.08),('11288','2014-03-21','12:50:00',6.01),('11288','2014-03-21','12:55:00',5.93),('11288','2014-03-21','13:00:00',6.01),('11288','2014-03-21','13:05:00',5.91),('11288','2014-03-21','13:10:00',5.92),('11288','2014-03-21','13:15:00',5.87),('11288','2014-03-21','13:20:00',5.79),('11288','2014-03-21','13:25:00',5.75),('11288','2014-03-21','13:30:00',5.71),('11288','2014-03-21','13:35:00',5.64),('11288','2014-03-21','13:40:00',5.59),('11288','2014-03-21','13:45:00',5.59),('11288','2014-03-21','13:50:00',5.53),('11288','2014-03-21','13:55:00',5.46),('11288','2014-03-21','14:00:00',5.47),('11288','2014-03-21','14:05:00',5.41),('11288','2014-03-21','14:10:00',5.35),('11288','2014-03-21','14:15:00',5.28),('11288','2014-03-21','14:20:00',5.14),('11288','2014-03-21','14:25:00',5.05),('11288','2014-03-21','14:30:00',4.92),('11288','2014-03-21','14:35:00',4.72),('11288','2014-03-21','14:40:00',4.73),('11288','2014-03-21','14:45:00',4.44),('11288','2014-03-21','14:50:00',3.68),('11288','2014-03-21','14:55:00',1.58),('11288','2014-03-21','15:00:00',1.56),('11288','2014-03-21','15:05:00',3.24),('11288','2014-03-21','15:10:00',4.9),('11288','2014-03-21','15:15:00',4.81),('11288','2014-03-21','15:20:00',4.01),('11288','2014-03-21','15:25:00',4.77),('11288','2014-03-21','15:30:00',4.44),('11288','2014-03-21','15:35:00',4.18),('11288','2014-03-21','15:40:00',4.17),('11288','2014-03-21','15:45:00',4.08),('11288','2014-03-21','15:50:00',3.93),('11288','2014-03-21','15:55:00',3.79),('11288','2014-03-21','16:00:00',3.49),('11288','2014-03-21','16:05:00',3.23),('11288','2014-03-21','16:10:00',2.98),('11288','2014-03-21','16:15:00',2.72),('11288','2014-03-21','16:20:00',2.44),('11288','2014-03-21','16:25:00',2.21),('11288','2014-03-21','16:30:00',2.04),('11288','2014-03-21','16:35:00',1.87),('11288','2014-03-21','16:40:00',1.73),('11288','2014-03-21','16:45:00',1.6),('11288','2014-03-21','16:50:00',1.46),('11288','2014-03-21','16:55:00',1.31),('11288','2014-03-21','17:00:00',1.07),('11288','2013-01-31','09:00:00',1.05),('11288','2013-01-31','09:05:00',1.35),('11288','2013-01-31','09:10:00',1.4),('11288','2013-01-31','09:15:00',1.1),('11288','2013-01-31','09:20:00',1.39),('11288','2013-01-31','09:25:00',1.3),('11288','2013-01-31','09:30:00',2.1),('11288','2013-01-31','09:35:00',2.03),('11288','2013-01-31','09:40:00',2.09),('11288','2013-01-31','09:45:00',2.63),('11288','2013-01-31','09:50:00',2.65),('11288','2013-01-31','09:55:00',2.65),('11288','2013-01-31','10:00:00',2.8),('11288','2013-01-31','10:05:00',2.69),('11288','2013-01-31','10:10:00',2.84),('11288','2013-01-31','10:15:00',3.18),('11288','2013-01-31','10:20:00',3.35),('11288','2013-01-31','10:25:00',3.44),('11288','2013-01-31','10:30:00',2.95),('11288','2013-01-31','10:35:00',3.73),('11288','2013-01-31','10:40:00',2.91),('11288','2013-01-31','10:45:00',2.51),('11288','2013-01-31','10:50:00',4.75),('11288','2013-01-31','10:55:00',3.65),('11288','2013-01-31','11:00:00',2.05),('11288','2013-01-31','11:05:00',1.97),('11288','2013-01-31','11:10:00',3.73),('11288','2013-01-31','11:15:00',2.28),('11288','2013-01-31','11:20:00',4.56),('11288','2013-01-31','11:25:00',5.13),('11288','2013-01-31','11:30:00',4.96),('11288','2013-01-31','11:35:00',4.75),('11288','2013-01-31','11:40:00',4.45),('11288','2013-01-31','11:45:00',4.41),('11288','2013-01-31','11:50:00',4.46),('11288','2013-01-31','11:55:00',4.45),('11288','2013-01-31','12:00:00',4.42),('11288','2013-01-31','12:05:00',4.63),('11288','2013-01-31','12:10:00',4.5),('11288','2013-01-31','12:15:00',4.56),('11288','2013-01-31','12:20:00',4.49),('11288','2013-01-31','12:25:00',4.45),('11288','2013-01-31','12:30:00',4.42),('11288','2013-01-31','12:35:00',4.45),('11288','2013-01-31','12:40:00',4.45),('11288','2013-01-31','12:45:00',4.35),('11288','2013-01-31','12:50:00',4.34),('11288','2013-01-31','12:55:00',4.36),('11288','2013-01-31','13:00:00',4.36),('11288','2013-01-31','13:05:00',4.31),('11288','2013-01-31','13:10:00',4.27),('11288','2013-01-31','13:15:00',4.08),('11288','2013-01-31','13:20:00',4.09),('11288','2013-01-31','13:25:00',4.09),('11288','2013-01-31','13:30:00',3.97),('11288','2013-01-31','13:35:00',4.01),('11288','2013-01-31','13:40:00',3.85),('11288','2013-01-31','13:45:00',3.9),('11288','2013-01-31','13:50:00',3.97),('11288','2013-01-31','13:55:00',3.77),('11288','2013-01-31','14:00:00',3.64),('11288','2013-01-31','14:05:00',3.56),('11288','2013-01-31','14:10:00',3.45),('11288','2013-01-31','14:15:00',3.34),('11288','2013-01-31','14:20:00',3.28),('11288','2013-01-31','14:25:00',3.16),('11288','2013-01-31','14:30:00',3.11),('11288','2013-01-31','14:35:00',2.99),('11288','2013-01-31','14:40:00',2.94),('11288','2013-01-31','14:45:00',2.82),('11288','2013-01-31','14:50:00',2.75),('11288','2013-01-31','14:55:00',2.64),('11288','2013-01-31','15:00:00',2.5),('11288','2013-01-31','15:05:00',2.48),('11288','2013-01-31','15:10:00',2.34),('11288','2013-01-31','15:15:00',2.28),('11288','2013-01-31','15:20:00',2.17),('11288','2013-01-31','15:25:00',1.95),('11288','2013-01-31','15:30:00',1.82),('11288','2013-01-31','15:35:00',1.82),('11288','2013-01-31','15:40:00',1.68),('11288','2013-01-31','15:45:00',1.5),('11288','2013-01-31','15:50:00',1.35),('11288','2013-01-31','15:55:00',1.25),('11288','2013-01-31','16:00:00',1.03),('11288','2013-01-30','09:10:00',1.18),('11288','2013-01-30','09:15:00',1.09),('11288','2013-01-30','09:25:00',1.24),('11288','2013-01-30','09:30:00',1.45),('11288','2013-01-30','09:35:00',1.46),('11288','2013-01-30','09:40:00',1.34),('11288','2013-01-30','09:45:00',1.07),('11288','2013-01-30','10:00:00',1.91),('11288','2013-01-30','10:05:00',2.32),('11288','2013-01-30','10:10:00',2.86),('11288','2013-01-30','10:15:00',2.12),('11288','2013-01-30','10:20:00',3.1),('11288','2013-01-30','10:25:00',2.74),('11288','2013-01-30','10:30:00',2.6),('11288','2013-01-30','10:35:00',2.28),('11288','2013-01-30','10:40:00',2.04),('11288','2013-01-30','10:45:00',2.72),('11288','2013-01-30','10:50:00',3.67),('11288','2013-01-30','10:55:00',3.32),('11288','2013-01-30','11:00:00',3.92),('11288','2013-01-30','11:05:00',3.75),('11288','2013-01-30','11:10:00',3.84),('11288','2013-01-30','11:15:00',3.93),('11288','2013-01-30','11:20:00',4.02),('11288','2013-01-30','11:25:00',4.19),('11288','2013-01-30','11:30:00',4),('11288','2013-01-30','11:35:00',3.46),('11288','2013-01-30','11:40:00',3.59),('11288','2013-01-30','11:45:00',3.93),('11288','2013-01-30','11:50:00',3.83),('11288','2013-01-30','11:55:00',4.37),('11288','2013-01-30','12:00:00',4.23),('11288','2013-01-30','12:05:00',3.55),('11288','2013-01-30','12:10:00',2.21),('11288','2013-01-30','12:15:00',2.47),('11288','2013-01-30','12:20:00',2.3),('11288','2013-01-30','12:25:00',1.49),('11288','2013-01-30','12:30:00',1.52),('11288','2013-01-30','12:35:00',2.05),('11288','2013-01-30','12:40:00',1.85),('11288','2013-01-30','12:45:00',3.83),('11288','2013-01-30','12:50:00',5.47),('11288','2013-01-30','12:55:00',5.15),('11288','2013-01-30','13:00:00',5.12),('11288','2013-01-30','13:05:00',4.91),('11288','2013-01-30','13:10:00',4.68),('11288','2013-01-30','13:15:00',4.73),('11288','2013-01-30','13:20:00',4.55),('11288','2013-01-30','13:25:00',4.58),('11288','2013-01-30','13:30:00',4.62),('11288','2013-01-30','13:35:00',2.96),('11288','2013-01-30','13:40:00',3.01),('11288','2013-01-30','13:45:00',4.01),('11288','2013-01-30','13:50:00',4.35),('11288','2013-01-30','13:55:00',4.38),('11288','2013-01-30','14:00:00',4.36),('11288','2013-01-30','14:05:00',3.85),('11288','2013-01-30','14:10:00',2.05),('11288','2013-01-30','14:15:00',3.12),('11288','2013-01-30','14:20:00',2.93),('11288','2013-01-30','14:25:00',3.72),('11288','2013-01-30','14:30:00',3.39),('11288','2013-01-30','14:35:00',3.19),('11288','2013-01-30','14:40:00',3.52),('11288','2013-01-30','14:45:00',2.4),('11288','2013-01-30','14:50:00',1.52),('11288','2013-01-30','14:55:00',1.63),('11288','2013-01-30','15:00:00',1.86),('11288','2013-01-30','15:05:00',2.08),('11288','2013-01-30','15:10:00',1.53),('11288','2013-01-30','15:15:00',1.34),('11288','2013-01-30','15:20:00',1.16),('11288','2013-01-30','15:25:00',1.05),('11288','2013-01-30','15:30:00',1.05),('11288','2013-01-29','08:35:00',1.06),('11288','2013-01-29','08:40:00',1.01),('11288','2013-01-29','08:45:00',1.12),('11288','2013-01-29','08:50:00',1.36),('11288','2013-01-29','08:55:00',1.47),('11288','2013-01-29','09:00:00',1.6),('11288','2013-01-29','09:05:00',1.69),('11288','2013-01-29','09:10:00',1.78),('11288','2013-01-29','09:15:00',1.91),('11288','2013-01-29','09:20:00',2.07),('11288','2013-01-29','09:25:00',2.14),('11288','2013-01-29','09:30:00',2.25),('11288','2013-01-29','09:35:00',2.34),('11288','2013-01-29','09:40:00',2.44),('11288','2013-01-29','09:45:00',2.49),('11288','2013-01-29','09:50:00',2.72),('11288','2013-01-29','09:55:00',2.7),('11288','2013-01-29','10:00:00',2.65),('11288','2013-01-29','10:05:00',3.03),('11288','2013-01-29','10:10:00',3.15),('11288','2013-01-29','10:15:00',3.27),('11288','2013-01-29','10:20:00',3.41),('11288','2013-01-29','10:25:00',3.45),('11288','2013-01-29','10:30:00',3.37),('11288','2013-01-29','10:35:00',3.69),('11288','2013-01-29','10:40:00',3.82),('11288','2013-01-29','10:45:00',3.9),('11288','2013-01-29','10:50:00',3.96),('11288','2013-01-29','10:55:00',3.99),('11288','2013-01-29','11:00:00',3.9),('11288','2013-01-29','11:05:00',4.08),('11288','2013-01-29','11:10:00',4.12),('11288','2013-01-29','11:15:00',4.19),('11288','2013-01-29','11:20:00',4.27),('11288','2013-01-29','11:25:00',4.31),('11288','2013-01-29','11:30:00',4.23),('11288','2013-01-29','11:35:00',4.44),('11288','2013-01-29','11:40:00',4.36),('11288','2013-01-29','11:45:00',4.05),('11288','2013-01-29','11:50:00',4.41),('11288','2013-01-29','11:55:00',4.51),('11288','2013-01-29','12:00:00',4.52),('11288','2013-01-29','12:05:00',4.46),('11288','2013-01-29','12:10:00',4.59),('11288','2013-01-29','12:15:00',4.56),('11288','2013-01-29','12:20:00',4.51),('11288','2013-01-29','12:25:00',4.57),('11288','2013-01-29','12:30:00',4.57),('11288','2013-01-29','12:35:00',4.46),('11288','2013-01-29','12:40:00',4.51),('11288','2013-01-29','12:45:00',4.37),('11288','2013-01-29','12:50:00',4.3),('11288','2013-01-29','12:55:00',4.46),('11288','2013-01-29','13:00:00',4.45),('11288','2013-01-29','13:05:00',4.38),('11288','2013-01-29','13:10:00',4.27),('11288','2013-01-29','13:15:00',4.26),('11288','2013-01-29','13:20:00',4.17),('11288','2013-01-29','13:25:00',4.06),('11288','2013-01-29','13:30:00',4.12),('11288','2013-01-29','13:35:00',4.08),('11288','2013-01-29','13:40:00',3.92),('11288','2013-01-29','13:45:00',3.91),('11288','2013-01-29','13:50:00',3.86),('11288','2013-01-29','13:55:00',3.78),('11288','2013-01-29','14:00:00',3.69),('11288','2013-01-29','14:05:00',3.59),('11288','2013-01-29','14:10:00',3.48),('11288','2013-01-29','14:15:00',3.38),('11288','2013-01-29','14:20:00',3.3),('11288','2013-01-29','14:25:00',3.26),('11288','2013-01-29','14:30:00',3.22),('11288','2013-01-29','14:35:00',3.12),('11288','2013-01-29','14:40:00',3),('11288','2013-01-29','14:45:00',2.9),('11288','2013-01-29','14:50:00',2.84),('11288','2013-01-29','14:55:00',2.69),('11288','2013-01-29','15:00:00',2.55),('11288','2013-01-29','15:05:00',2.44),('11288','2013-01-29','15:10:00',2.36),('11288','2013-01-29','15:15:00',2.22),('11288','2013-01-29','15:20:00',2.03),('11288','2013-01-29','15:25:00',1.92),('11288','2013-01-29','15:30:00',1.8),('11288','2013-01-29','15:35:00',1.69),('11288','2013-01-29','15:40:00',1.6),('11288','2013-01-29','15:45:00',1.44),('11288','2013-01-29','15:50:00',1.25),('11288','2013-01-29','15:55:00',1.21),('11288','2013-01-29','16:00:00',1.11),('11288','2013-01-29','16:05:00',1.05),('11288','2013-01-28','10:50:00',1.02),('11288','2013-01-28','10:55:00',1.19),('11288','2013-01-28','11:00:00',1.4),('11288','2013-01-28','11:05:00',1.61),('11288','2013-01-28','11:10:00',1.65),('11288','2013-01-28','11:15:00',1.38),('11288','2013-01-28','11:20:00',1.37),('11288','2013-01-28','11:25:00',1.31),('11288','2013-01-28','11:30:00',1.16),('11288','2013-01-28','11:35:00',1.05),('11288','2013-01-28','11:40:00',1.03),('11288','2013-01-28','11:45:00',1.05),('11288','2013-01-28','12:30:00',1.11),('11288','2013-01-28','12:35:00',1.31),('11288','2013-01-28','12:40:00',1.65),('11288','2013-01-28','12:45:00',2.07),('11288','2013-01-28','12:50:00',2.33),('11288','2013-01-28','12:55:00',2.18),('11288','2013-01-28','13:00:00',1.99),('11288','2013-01-28','13:05:00',1.94),('11288','2013-01-28','13:10:00',1.78),('11288','2013-01-28','13:15:00',1.73),('11288','2013-01-28','13:20:00',1.73),('11288','2013-01-28','13:25:00',1.77),('11288','2013-01-28','13:30:00',1.71),('11288','2013-01-28','13:35:00',1.53),('11288','2013-01-28','13:40:00',1.39),('11288','2013-01-28','13:45:00',1.3),('11288','2013-01-28','13:50:00',1.22),('11288','2013-01-28','13:55:00',1.23),('11288','2013-01-28','14:00:00',1.31),('11288','2013-01-28','14:05:00',1.34),('11288','2013-01-28','14:10:00',1.3),('11288','2013-01-28','14:15:00',1.18),('11288','2013-01-28','14:20:00',1.08),('11288','2013-01-27','08:30:00',1.17),('11288','2013-01-27','08:35:00',1.39),('11288','2013-01-27','08:40:00',1.45),('11288','2013-01-27','08:45:00',1.31),('11288','2013-01-27','08:50:00',1.24),('11288','2013-01-27','08:55:00',1.59),('11288','2013-01-27','09:00:00',1.66),('11288','2013-01-27','09:05:00',1.71),('11288','2013-01-27','09:10:00',1.78),('11288','2013-01-27','09:15:00',1.85),('11288','2013-01-27','09:20:00',2.03),('11288','2013-01-27','09:25:00',2.07),('11288','2013-01-27','09:30:00',2.25),('11288','2013-01-27','09:35:00',2.37),('11288','2013-01-27','09:40:00',2.43),('11288','2013-01-27','09:45:00',2.49),('11288','2013-01-27','09:50:00',2.67),('11288','2013-01-27','09:55:00',2.64),('11288','2013-01-27','10:00:00',2.72),('11288','2013-01-27','10:05:00',2.93),('11288','2013-01-27','10:10:00',3.08),('11288','2013-01-27','10:15:00',3.2),('11288','2013-01-27','10:20:00',3.28),('11288','2013-01-27','10:25:00',3.29),('11288','2013-01-27','10:30:00',3.27),('11288','2013-01-27','10:35:00',3.54),('11288','2013-01-27','10:40:00',3.66),('11288','2013-01-27','10:45:00',3.74),('11288','2013-01-27','10:50:00',3.81),('11288','2013-01-27','10:55:00',3.84),('11288','2013-01-27','11:00:00',3.74),('11288','2013-01-27','11:05:00',3.97),('11288','2013-01-27','11:10:00',4.06),('11288','2013-01-27','11:15:00',4.11),('11288','2013-01-27','11:20:00',4.16),('11288','2013-01-27','11:25:00',4.25),('11288','2013-01-27','11:30:00',4.28),('11288','2013-01-27','11:35:00',4.29),('11288','2013-01-27','11:40:00',4.17),('11288','2013-01-27','11:45:00',3.89),('11288','2013-01-27','11:50:00',4.18),('11288','2013-01-27','11:55:00',4.4),('11288','2013-01-27','12:00:00',4.42),('11288','2013-01-27','12:05:00',4.42),('11288','2013-01-27','12:10:00',4.46),('11288','2013-01-27','12:15:00',4.47),('11288','2013-01-27','12:20:00',4.41),('11288','2013-01-27','12:25:00',4.45),('11288','2013-01-27','12:30:00',4.42),('11288','2013-01-27','12:35:00',4.39),('11288','2013-01-27','12:40:00',4.36),('11288','2013-01-27','12:45:00',4.31),('11288','2013-01-27','12:50:00',4.37),('11288','2013-01-27','12:55:00',4.38),('11288','2013-01-27','13:00:00',4.35),('11288','2013-01-27','13:05:00',4.35),('11288','2013-01-27','13:10:00',4.34),('11288','2013-01-27','13:15:00',4.25),('11288','2013-01-27','13:20:00',4.19),('11288','2013-01-27','13:25:00',4.08),('11288','2013-01-27','13:30:00',4),('11288','2013-01-27','13:35:00',3.93),('11288','2013-01-27','13:40:00',3.78),('11288','2013-01-27','13:45:00',3.75),('11288','2013-01-27','13:50:00',3.7),('11288','2013-01-27','13:55:00',3.56),('11288','2013-01-27','14:00:00',3.48),('11288','2013-01-27','14:05:00',3.42),('11288','2013-01-27','14:10:00',3.41),('11288','2013-01-27','14:15:00',3.32),('11288','2013-01-27','14:20:00',3.23),('11288','2013-01-27','14:25:00',3.11),('11288','2013-01-27','14:30:00',3),('11288','2013-01-27','14:35:00',2.9),('11288','2013-01-27','14:40:00',2.82),('11288','2013-01-27','14:45:00',2.79),('11288','2013-01-27','14:50:00',2.69),('11288','2013-01-27','14:55:00',2.59),('11288','2013-01-27','15:00:00',2.49),('11288','2013-01-27','15:05:00',2.34),('11288','2013-01-27','15:10:00',2.18),('11288','2013-01-27','15:15:00',2.04),('11288','2013-01-27','15:20:00',1.9),('11288','2013-01-27','15:25:00',1.82),('11288','2013-01-27','15:30:00',1.67),('11288','2013-01-27','15:35:00',1.56),('11288','2013-01-27','15:40:00',1.44),('11288','2013-01-27','15:45:00',1.31),('11288','2013-01-27','15:50:00',1.15),('11288','2013-01-27','15:55:00',1.15),('11288','2013-01-27','16:00:00',1.03),('11288','2013-01-26','08:55:00',1.29),('11288','2013-01-26','09:00:00',1.73),('11288','2013-01-26','09:05:00',1.65),('11288','2013-01-26','09:10:00',1.72),('11288','2013-01-26','09:15:00',1.72),('11288','2013-01-26','09:20:00',1.75),('11288','2013-01-26','09:25:00',1.6),('11288','2013-01-26','09:30:00',1.4),('11288','2013-01-26','09:35:00',1.55),('11288','2013-01-26','09:40:00',1.28),('11288','2013-01-26','09:45:00',1.23),('11288','2013-01-26','09:50:00',1.79),('11288','2013-01-26','09:55:00',1.76),('11288','2013-01-26','10:00:00',1.65),('11288','2013-01-26','10:05:00',1.38),('11288','2013-01-26','10:10:00',1.39),('11288','2013-01-26','10:15:00',1.81),('11288','2013-01-26','10:20:00',1.92),('11288','2013-01-26','10:25:00',2.04),('11288','2013-01-26','10:30:00',1.41),('11288','2013-01-26','10:35:00',1.43),('11288','2013-01-26','10:40:00',1.69),('11288','2013-01-26','10:45:00',1.8),('11288','2013-01-26','10:50:00',2.03),('11288','2013-01-26','10:55:00',1.74),('11288','2013-01-26','11:00:00',1.56),('11288','2013-01-26','11:05:00',1.93),('11288','2013-01-26','11:10:00',1.72),('11288','2013-01-26','11:15:00',1.72),('11288','2013-01-26','11:20:00',1.66),('11288','2013-01-26','11:25:00',1.85),('11288','2013-01-26','11:30:00',1.88),('11288','2013-01-26','11:35:00',1.65),('11288','2013-01-26','11:40:00',1.74),('11288','2013-01-26','11:45:00',1.61),('11288','2013-01-26','11:50:00',1.7),('11288','2013-01-26','11:55:00',1.54),('11288','2013-01-26','12:00:00',1.34),('11288','2013-01-26','12:05:00',1.36),('11288','2013-01-26','12:10:00',1.33),('11288','2013-01-26','12:15:00',1.38),('11288','2013-01-26','12:20:00',1.48),('11288','2013-01-26','12:25:00',1.67),('11288','2013-01-26','12:30:00',1.53),('11288','2013-01-26','12:35:00',1.53),('11288','2013-01-26','12:40:00',1.44),('11288','2013-01-26','12:45:00',1.51),('11288','2013-01-26','12:50:00',1.49),('11288','2013-01-26','12:55:00',1.13),('11288','2013-01-26','13:00:00',1.02),('11288','2013-01-26','13:05:00',1.29),('11288','2013-01-26','13:10:00',1.13),('11288','2013-01-26','13:30:00',1.04),('11288','2013-01-26','13:35:00',1.26),('11288','2013-01-26','13:40:00',1.31),('11288','2013-01-26','13:45:00',1.24),('11288','2013-01-26','13:50:00',1.13),('11288','2013-01-26','13:55:00',1.09),('11288','2013-01-26','14:20:00',1),('11288','2013-01-26','14:25:00',1.09),('11288','2013-01-26','14:30:00',1.04),('11288','2013-01-25','08:35:00',1.19),('11288','2013-01-25','08:40:00',1.31),('11288','2013-01-25','08:45:00',1.39),('11288','2013-01-25','08:50:00',1.35),('11288','2013-01-25','08:55:00',1.58),('11288','2013-01-25','09:00:00',1.73),('11288','2013-01-25','09:05:00',1.51),('11288','2013-01-25','09:10:00',1.8),('11288','2013-01-25','09:15:00',2.01),('11288','2013-01-25','09:20:00',2.15),('11288','2013-01-25','09:25:00',2.33),('11288','2013-01-25','09:30:00',2.47),('11288','2013-01-25','09:35:00',2.35),('11288','2013-01-25','09:40:00',2.29),('11288','2013-01-25','09:45:00',2.65),('11288','2013-01-25','09:50:00',3.05),('11288','2013-01-25','09:55:00',3.04),('11288','2013-01-25','10:00:00',3.14),('11288','2013-01-25','10:05:00',3.23),('11288','2013-01-25','10:10:00',3.32),('11288','2013-01-25','10:15:00',3.28),('11288','2013-01-25','10:20:00',3.4),('11288','2013-01-25','10:25:00',3.44),('11288','2013-01-25','10:30:00',2.72),('11288','2013-01-25','10:35:00',1.81),('11288','2013-01-25','10:40:00',3.98),('11288','2013-01-25','10:45:00',2.98),('11288','2013-01-25','10:50:00',3.58),('11288','2013-01-25','10:55:00',4.13),('11288','2013-01-25','11:00:00',2.6),('11288','2013-01-25','11:05:00',2.21),('11288','2013-01-25','11:10:00',3.74),('11288','2013-01-25','11:15:00',4.26),('11288','2013-01-25','11:20:00',4.28),('11288','2013-01-25','11:25:00',4.33),('11288','2013-01-25','11:30:00',4.46),('11288','2013-01-25','11:35:00',4.48),('11288','2013-01-25','11:40:00',4.4),('11288','2013-01-25','11:45:00',4.48),('11288','2013-01-25','11:50:00',4.56),('11288','2013-01-25','11:55:00',4.56),('11288','2013-01-25','12:00:00',4.5),('11288','2013-01-25','12:05:00',4.49),('11288','2013-01-25','12:10:00',4.55),('11288','2013-01-25','12:15:00',4.54),('11288','2013-01-25','12:20:00',4.32),('11288','2013-01-25','12:25:00',4.45),('11288','2013-01-25','12:30:00',4.14),('11288','2013-01-25','12:35:00',3.83),('11288','2013-01-25','12:40:00',4.26),('11288','2013-01-25','12:45:00',4.29),('11288','2013-01-25','12:50:00',4.23),('11288','2013-01-25','12:55:00',4.3),('11288','2013-01-25','13:00:00',4.18),('11288','2013-01-25','13:05:00',4.13),('11288','2013-01-25','13:10:00',4.12),('11288','2013-01-25','13:15:00',4.12),('11288','2013-01-25','13:20:00',4.09),('11288','2013-01-25','13:25:00',4.23),('11288','2013-01-25','13:30:00',4.32),('11288','2013-01-25','13:35:00',4.28),('11288','2013-01-25','13:40:00',4.12),('11288','2013-01-25','13:45:00',4.02),('11288','2013-01-25','13:50:00',3.88),('11288','2013-01-25','13:55:00',3.77),('11288','2013-01-25','14:00:00',3.63),('11288','2013-01-25','14:05:00',3.35),('11288','2013-01-25','14:10:00',3.27),('11288','2013-01-25','14:15:00',2.98),('11288','2013-01-25','14:20:00',2.98),('11288','2013-01-25','14:25:00',2.92),('11288','2013-01-25','14:30:00',2.75),('11288','2013-01-25','14:35:00',2.68),('11288','2013-01-25','14:40:00',2.55),('11288','2013-01-25','14:45:00',2.48),('11288','2013-01-25','14:50:00',2.4),('11288','2013-01-25','14:55:00',2.24),('11288','2013-01-25','15:00:00',2.14),('11288','2013-01-25','15:05:00',2.03),('11288','2013-01-25','15:10:00',1.9),('11288','2013-01-25','15:15:00',1.85),('11288','2013-01-25','15:20:00',1.81),('11288','2013-01-25','15:25:00',1.75),('11288','2013-01-25','15:30:00',1.77),('11288','2013-01-25','15:35:00',1.69),('11288','2013-01-25','15:40:00',1.54),('11288','2013-01-25','15:45:00',1.65),('11288','2013-01-25','15:50:00',1.5),('11288','2013-01-25','15:55:00',1.3),('11288','2013-01-24','08:50:00',1.08),('11288','2013-01-24','08:55:00',1.2),('11288','2013-01-24','09:00:00',1.15),('11288','2013-01-24','09:05:00',1.05),('11288','2013-01-24','09:10:00',1.04),('11288','2013-01-24','09:15:00',1.18),('11288','2013-01-24','09:20:00',1.34),('11288','2013-01-24','09:25:00',1.5),('11288','2013-01-24','09:30:00',1.46),('11288','2013-01-24','09:35:00',1.31),('11288','2013-01-24','09:40:00',1.55),('11288','2013-01-24','09:45:00',1.99),('11288','2013-01-24','09:50:00',2.66),('11288','2013-01-24','09:55:00',2.61),('11288','2013-01-24','10:00:00',2.87),('11288','2013-01-24','10:05:00',3.05),('11288','2013-01-24','10:10:00',3.3),('11288','2013-01-24','10:15:00',3.31),('11288','2013-01-24','10:20:00',3.41),('11288','2013-01-24','10:25:00',3.34),('11288','2013-01-24','10:30:00',3.35),('11288','2013-01-24','10:35:00',3.64),('11288','2013-01-24','10:40:00',3.79),('11288','2013-01-24','10:45:00',3.74),('11288','2013-01-24','10:50:00',3.69),('11288','2013-01-24','10:55:00',2.94),('11288','2013-01-24','11:00:00',2.08),('11288','2013-01-24','11:05:00',1.31),('11288','2013-01-24','12:35:00',1.24),('11288','2013-01-24','12:40:00',1.52),('11288','2013-01-24','12:45:00',1.71),('11288','2013-01-24','12:50:00',1.79),('11288','2013-01-24','12:55:00',1.76),('11288','2013-01-24','13:00:00',1.73),('11288','2013-01-24','13:05:00',1.69),('11288','2013-01-24','13:10:00',1.6),('11288','2013-01-24','13:15:00',1.54),('11288','2013-01-24','13:20:00',1.5),('11288','2013-01-24','13:25:00',1.54),('11288','2013-01-24','13:30:00',1.59),('11288','2013-01-24','13:35:00',1.56),('11288','2013-01-24','13:40:00',1.56),('11288','2013-01-24','13:45:00',1.59),('11288','2013-01-24','13:50:00',1.65),('11288','2013-01-24','13:55:00',1.79),('11288','2013-01-24','14:00:00',2.17),('11288','2013-01-24','14:05:00',2.05),('11288','2013-01-24','14:10:00',2.03),('11288','2013-01-24','14:15:00',2.25),('11288','2013-01-24','14:20:00',3.72),('11288','2013-01-24','14:25:00',4.77),('11288','2013-01-24','14:30:00',4.02),('11288','2013-01-24','14:35:00',2.59),('11288','2013-01-24','14:40:00',2.32),('11288','2013-01-24','14:45:00',2.75),('11288','2013-01-24','14:50:00',2.94),('11288','2013-01-24','14:55:00',2.8),('11288','2013-01-24','15:00:00',1.92),('11288','2013-01-24','15:05:00',1.41),('11288','2013-01-24','15:10:00',1.03),('11288','2013-01-24','15:15:00',1.17),('11288','2013-01-24','15:20:00',1.71),('11288','2013-01-24','15:25:00',1.69),('11288','2013-01-24','15:30:00',1.83),('11288','2013-01-24','15:35:00',1.33),('11288','2013-01-24','15:45:00',1.34),('11288','2013-01-24','15:50:00',1.27),('11288','2013-01-24','15:55:00',1.17),('11288','2013-01-24','16:00:00',1.03),('11288','2013-01-23','09:45:00',1.1),('11288','2013-01-23','09:50:00',1.33),('11288','2013-01-23','09:55:00',2.46),('11288','2013-01-23','10:00:00',1.51),('11288','2013-01-23','10:05:00',1.2),('11288','2013-01-23','10:10:00',1.04),('11288','2013-01-23','10:15:00',1.42),('11288','2013-01-23','10:20:00',1.39),('11288','2013-01-23','10:25:00',2.21),('11288','2013-01-23','10:30:00',3.55),('11288','2013-01-23','10:35:00',3.09),('11288','2013-01-23','10:40:00',2.53),('11288','2013-01-23','10:45:00',2.39),('11288','2013-01-23','10:50:00',3.32),('11288','2013-01-23','10:55:00',2.19),('11288','2013-01-23','11:00:00',1.29),('11288','2013-01-23','11:10:00',1.05),('11288','2013-01-22','08:45:00',1.07),('11288','2013-01-22','08:50:00',1.13),('11288','2013-01-22','08:55:00',1.21),('11288','2013-01-22','09:00:00',2.08),('11288','2013-01-22','09:05:00',1.64),('11288','2013-01-22','09:15:00',1),('11288','2013-01-22','09:25:00',1.22),('11288','2013-01-22','09:30:00',2.02),('11288','2013-01-22','09:35:00',2.33),('11288','2013-01-22','09:40:00',2.45),('11288','2013-01-22','09:45:00',3.36),('11288','2013-01-22','09:50:00',1.51),('11288','2013-01-22','09:55:00',2.21),('11288','2013-01-22','10:00:00',1.73),('11288','2013-01-22','10:05:00',2.51),('11288','2013-01-22','10:10:00',3.3),('11288','2013-01-22','10:15:00',2.69),('11288','2013-01-22','10:20:00',3.03),('11288','2013-01-22','10:25:00',3.45),('11288','2013-01-22','10:30:00',3.66),('11288','2013-01-22','10:35:00',3.83),('11288','2013-01-22','10:40:00',4.17),('11288','2013-01-22','10:45:00',3.49),('11288','2013-01-22','10:50:00',2.73),('11288','2013-01-22','10:55:00',1.97),('11288','2013-01-22','11:00:00',1.2),('11288','2013-01-22','11:05:00',1.43),('11288','2013-01-22','11:10:00',1.81),('11288','2013-01-22','11:15:00',2.12),('11288','2013-01-22','11:20:00',2.43),('11288','2013-01-22','11:25:00',1.55),('11288','2013-01-22','11:30:00',1.37),('11288','2013-01-22','11:35:00',1.35),('11288','2013-01-22','11:45:00',2.83),('11288','2013-01-22','11:50:00',3.09),('11288','2013-01-22','11:55:00',1.57),('11288','2013-01-22','12:00:00',1.59),('11288','2013-01-22','12:05:00',1.45),('11288','2013-01-22','12:10:00',4.63),('11288','2013-01-22','12:15:00',3.4),('11288','2013-01-22','12:20:00',3.22),('11288','2013-01-22','12:25:00',2.94),('11288','2013-01-22','12:30:00',1.73),('11288','2013-01-22','12:35:00',2.27),('11288','2013-01-22','12:40:00',4.22),('11288','2013-01-22','12:45:00',1.52),('11288','2013-01-22','12:50:00',2.2),('11288','2013-01-22','12:55:00',1.33),('11288','2013-01-22','13:00:00',4.51),('11288','2013-01-22','13:05:00',4.61),('11288','2013-01-22','13:10:00',3.62),('11288','2013-01-22','13:15:00',2.32),('11288','2013-01-22','13:20:00',3.01),('11288','2013-01-22','13:25:00',1.44),('11288','2013-01-22','13:30:00',1.2),('11288','2013-01-22','13:35:00',1.1),('11288','2013-01-22','13:40:00',1.76),('11288','2013-01-22','13:45:00',2.07),('11288','2013-01-22','13:50:00',1.66),('11288','2013-01-22','13:55:00',1.06),('11288','2013-01-22','14:00:00',1.37),('11288','2013-01-22','14:05:00',1.28),('11288','2013-01-22','14:10:00',2.45),('11288','2013-01-22','14:15:00',1.8),('11288','2013-01-22','14:20:00',1.68),('11288','2013-01-22','14:25:00',2.26),('11288','2013-01-22','14:30:00',1.11),('11288','2013-01-22','14:35:00',2.35),('11288','2013-01-22','14:40:00',2.5),('11288','2013-01-22','14:45:00',2.5),('11288','2013-01-22','14:50:00',1.6),('11288','2013-01-22','15:00:00',1.14),('11288','2013-01-22','15:05:00',1.02),('11288','2014-03-20','07:20:00',1.01),('11288','2014-03-20','07:25:00',1.06),('11288','2014-03-20','07:30:00',1.03),('11288','2014-03-20','07:35:00',1.22),('11288','2014-03-20','07:40:00',1.34),('11288','2014-03-20','07:45:00',1.41),('11288','2014-03-20','07:50:00',1.57),('11288','2014-03-20','07:55:00',1.66),('11288','2014-03-20','08:00:00',1.77),('11288','2014-03-20','08:05:00',1.99),('11288','2014-03-20','08:10:00',2.02),('11288','2014-03-20','08:15:00',2.16),('11288','2014-03-20','08:20:00',2.32),('11288','2014-03-20','08:25:00',2.38),('11288','2014-03-20','08:30:00',2.53),('11288','2014-03-20','08:35:00',2.76),('11288','2014-03-20','08:40:00',2.89),('11288','2014-03-20','08:45:00',3.02),('11288','2014-03-20','08:50:00',3.29),('11288','2014-03-20','08:55:00',3.44),('11288','2014-03-20','09:00:00',3.53),('11288','2014-03-20','09:05:00',3.69),('11288','2014-03-20','09:10:00',3.86),('11288','2014-03-20','09:15:00',3.94),('11288','2014-03-20','09:20:00',4.07),('11288','2014-03-20','09:25:00',4.15),('11288','2014-03-20','09:30:00',4.29),('11288','2014-03-20','09:35:00',4.43),('11288','2014-03-20','09:40:00',4.46),('11288','2014-03-20','09:45:00',4.5),('11288','2014-03-20','09:50:00',4.51),('11288','2014-03-20','09:55:00',4.59),('11288','2014-03-20','10:00:00',4.83),('11288','2014-03-20','10:05:00',5.01),('11288','2014-03-20','10:10:00',4.99),('11288','2014-03-20','10:15:00',5),('11288','2014-03-20','10:20:00',5.02),('11288','2014-03-20','10:25:00',5.11),('11288','2014-03-20','10:30:00',5.13),('11288','2014-03-20','10:35:00',4.97),('11288','2014-03-20','10:40:00',4.89),('11288','2014-03-20','10:45:00',5),('11288','2014-03-20','10:50:00',5.27),('11288','2014-03-20','10:55:00',5.57),('11288','2014-03-20','11:00:00',5.66),('11288','2014-03-20','11:05:00',5.62),('11288','2014-03-20','11:10:00',5.58),('11288','2014-03-20','11:15:00',5.36),('11288','2014-03-20','11:20:00',5.72),('11288','2014-03-20','11:25:00',5.72),('11288','2014-03-20','11:30:00',5.89),('11288','2014-03-20','11:35:00',6.02),('11288','2014-03-20','11:40:00',5.96),('11288','2014-03-20','11:45:00',5.91),('11288','2014-03-20','11:50:00',6.06),('11288','2014-03-20','11:55:00',5.44),('11288','2014-03-20','12:00:00',5.3),('11288','2014-03-20','12:05:00',5.85),('11288','2014-03-20','12:10:00',5.96),('11288','2014-03-20','12:15:00',5.93),('11288','2014-03-20','12:20:00',5.78),('11288','2014-03-20','12:25:00',5.6),('11288','2014-03-20','12:30:00',5.77),('11288','2014-03-20','12:35:00',5.86),('11288','2014-03-20','12:40:00',5.92),('11288','2014-03-20','12:45:00',6.02),('11288','2014-03-20','12:50:00',5.91),('11288','2014-03-20','12:55:00',5.9),('11288','2014-03-20','13:00:00',5.81),('11288','2014-03-20','13:05:00',5.72),('11288','2014-03-20','13:10:00',5.68),('11288','2014-03-20','13:15:00',5.58),('11288','2014-03-20','13:20:00',5.6),('11288','2014-03-20','13:25:00',5.39),('11288','2014-03-20','13:30:00',5.58),('11288','2014-03-20','13:35:00',5.37),('11288','2014-03-20','13:40:00',5.14),('11288','2014-03-20','13:45:00',4.96),('11288','2014-03-20','13:50:00',4.77),('11288','2014-03-20','13:55:00',4.37),('11288','2014-03-20','14:00:00',4.74),('11288','2014-03-20','14:05:00',5.14),('11288','2014-03-20','14:10:00',4.88),('11288','2014-03-20','14:15:00',4.63),('11288','2014-03-20','14:20:00',4.49),('11288','2014-03-20','14:25:00',4.47),('11288','2014-03-20','14:30:00',3.73),('11288','2014-03-20','14:35:00',3.61),('11288','2014-03-20','14:40:00',4),('11288','2014-03-20','14:45:00',3.85),('11288','2014-03-20','14:50:00',3.63),('11288','2014-03-20','14:55:00',3.53),('11288','2014-03-20','15:00:00',3.25),('11288','2014-03-20','15:05:00',3.29),('11288','2014-03-20','15:10:00',3.28),('11288','2014-03-20','15:15:00',3.16),('11288','2014-03-20','15:20:00',3.36),('11288','2014-03-20','15:25:00',3.03),('11288','2014-03-20','15:30:00',2.9),('11288','2014-03-20','15:35:00',2.75),('11288','2014-03-20','15:40:00',2.54),('11288','2014-03-20','15:45:00',2.54),('11288','2014-03-20','15:50:00',2.2),('11288','2014-03-20','15:55:00',2.02),('11288','2014-03-20','16:00:00',1.74),('11288','2014-03-20','16:05:00',1.57),('11288','2014-03-20','16:10:00',1.58),('11288','2014-03-20','16:15:00',1.51),('11288','2014-03-20','16:20:00',1.59),('11288','2014-03-20','16:25:00',1.61),('11288','2014-03-20','16:30:00',1.48),('11288','2014-03-20','16:35:00',1.37),('11288','2014-03-20','16:40:00',1.27),('11288','2013-01-21','10:10:00',1.19),('11288','2013-01-21','10:15:00',1.29),('11288','2013-01-21','10:20:00',1.12),('11288','2013-01-21','10:25:00',1.18),('11288','2013-01-21','10:30:00',1.11),('11288','2013-01-21','10:45:00',1.01),('11288','2013-01-21','10:55:00',1.24),('11288','2013-01-21','11:00:00',1.69),('11288','2013-01-21','11:05:00',1.58),('11288','2013-01-21','11:10:00',2.13),('11288','2013-01-21','11:15:00',2.27),('11288','2013-01-21','11:20:00',1.99),('11288','2013-01-21','11:25:00',1.85),('11288','2013-01-21','11:30:00',1.32),('11288','2013-01-21','11:40:00',1.59),('11288','2013-01-21','11:45:00',1.53),('11288','2013-01-21','11:50:00',3.02),('11288','2013-01-21','11:55:00',4.58),('11288','2013-01-21','12:00:00',4.27),('11288','2013-01-21','12:05:00',4.21),('11288','2013-01-21','12:10:00',4.24),('11288','2013-01-21','12:15:00',3.08),('11288','2013-01-21','12:20:00',1.97),('11288','2013-01-21','12:25:00',2.43),('11288','2013-01-21','12:30:00',1.19),('11288','2013-01-21','12:35:00',1.57),('11288','2013-01-21','12:40:00',1.55),('11288','2013-01-21','12:45:00',1.38),('11288','2013-01-21','12:50:00',2.47),('11288','2013-01-21','12:55:00',1.72),('11288','2013-01-21','13:00:00',1.78),('11288','2013-01-21','13:05:00',3.02),('11288','2013-01-21','13:10:00',2.34),('11288','2013-01-21','13:15:00',1.64),('11288','2013-01-21','13:20:00',1.59),('11288','2013-01-21','13:25:00',1.6),('11288','2013-01-21','13:30:00',4.15),('11288','2013-01-21','13:35:00',3.71),('11288','2013-01-21','13:40:00',3.65),('11288','2013-01-21','13:45:00',1.46),('11288','2013-01-21','13:50:00',3.52),('11288','2013-01-21','13:55:00',4.67),('11288','2013-01-21','14:00:00',2.88),('11288','2013-01-21','14:05:00',3.87),('11288','2013-01-21','14:10:00',3.17),('11288','2013-01-21','14:15:00',1.77),('11288','2013-01-21','14:20:00',3.21),('11288','2013-01-21','14:25:00',2.62),('11288','2013-01-21','14:30:00',2.07),('11288','2013-01-21','14:35:00',1.37),('11288','2013-01-21','14:40:00',1.03),('11288','2013-01-20','08:30:00',1.03),('11288','2013-01-20','08:35:00',1.09),('11288','2013-01-20','08:40:00',1.07),('11288','2013-01-20','10:00:00',1.01),('11288','2013-01-20','10:05:00',1.02),('11288','2013-01-20','10:25:00',1.1),('11288','2013-01-20','10:30:00',1.23),('11288','2013-01-20','10:35:00',1.06),('11288','2013-01-20','10:40:00',1.32),('11288','2013-01-20','10:45:00',1.5),('11288','2013-01-20','10:50:00',1.73),('11288','2013-01-20','10:55:00',1.85),('11288','2013-01-20','11:00:00',2.06),('11288','2013-01-20','11:05:00',2.15),('11288','2013-01-20','11:10:00',2.34),('11288','2013-01-20','11:15:00',2.83),('11288','2013-01-20','11:20:00',2.36),('11288','2013-01-20','11:25:00',3.06),('11288','2013-01-20','11:30:00',3.67),('11288','2013-01-20','11:35:00',2.95),('11288','2013-01-20','11:40:00',1.94),('11288','2013-01-20','11:45:00',1.84),('11288','2013-01-20','11:50:00',1.33),('11288','2013-01-20','11:55:00',1.01),('11288','2013-01-20','12:00:00',1.1),('11288','2013-01-20','12:05:00',1.06),('11288','2013-01-20','12:10:00',1.28),('11288','2013-01-20','12:15:00',1.55),('11288','2013-01-20','12:20:00',1.73),('11288','2013-01-20','12:25:00',1.78),('11288','2013-01-20','12:30:00',1.64),('11288','2013-01-20','12:35:00',1.51),('11288','2013-01-20','12:40:00',1.4),('11288','2013-01-20','12:45:00',1.37),('11288','2013-01-20','12:50:00',1.33),('11288','2013-01-20','12:55:00',1.31),('11288','2013-01-20','13:00:00',1.25),('11288','2013-01-20','13:05:00',1.2),('11288','2013-01-20','13:10:00',1.23),('11288','2013-01-20','13:15:00',1.36),('11288','2013-01-20','13:20:00',1.38),('11288','2013-01-20','13:25:00',1.38),('11288','2013-01-20','13:30:00',1.29),('11288','2013-01-20','13:35:00',1.45),('11288','2013-01-20','13:40:00',1.65),('11288','2013-01-20','13:45:00',1.6),('11288','2013-01-20','13:50:00',1.54),('11288','2013-01-20','13:55:00',1.35),('11288','2013-01-20','14:00:00',1.2),('11288','2013-01-20','14:05:00',1.06),('11288','2013-01-20','14:15:00',1.09),('11288','2013-01-20','14:20:00',1.29),('11288','2013-01-20','14:25:00',1.11),('11288','2013-01-19','09:00:00',1.04),('11288','2013-01-19','09:05:00',1.14),('11288','2013-01-19','09:10:00',1.52),('11288','2013-01-19','09:15:00',1.93),('11288','2013-01-19','09:20:00',1.82),('11288','2013-01-19','09:25:00',1.54),('11288','2013-01-19','09:30:00',1.32),('11288','2013-01-19','09:35:00',1.2),('11288','2013-01-19','09:40:00',1.09),('11288','2013-01-19','09:45:00',1.49),('11288','2013-01-19','09:50:00',1.89),('11288','2013-01-19','09:55:00',2.47),('11288','2013-01-19','10:00:00',2.33),('11288','2013-01-19','10:05:00',1.87),('11288','2013-01-19','10:10:00',1.3),('11288','2013-01-19','10:25:00',1.09),('11288','2013-01-19','10:30:00',1.05),('11288','2013-01-19','10:35:00',1.74),('11288','2013-01-19','10:40:00',2.01),('11288','2013-01-19','10:45:00',2.44),('11288','2013-01-19','10:50:00',2.29),('11288','2013-01-19','10:55:00',1.27),('11288','2013-01-19','11:00:00',1.44),('11288','2013-01-19','11:05:00',1.48),('11288','2013-01-19','11:10:00',1.63),('11288','2013-01-19','11:15:00',1.72),('11288','2013-01-19','11:20:00',2.13),('11288','2013-01-19','11:25:00',2.07),('11288','2013-01-19','11:30:00',1.65),('11288','2013-01-19','11:35:00',1.18),('11288','2013-01-19','11:40:00',1.02),('11288','2013-01-19','11:45:00',1.25),('11288','2013-01-19','11:50:00',1.33),('11288','2013-01-19','11:55:00',1.2),('11288','2013-01-19','12:05:00',1.1),('11288','2013-01-19','12:10:00',1.22),('11288','2013-01-19','12:15:00',1.28),('11288','2013-01-19','12:20:00',1.17),('11288','2013-01-19','14:30:00',1.06),('11288','2013-01-19','14:35:00',1.13),('11288','2013-01-18','08:45:00',1.13),('11288','2013-01-18','08:50:00',1.15),('11288','2013-01-18','08:58:00',1.09),('11288','2013-01-18','09:58:00',1.04),('11288','2013-01-18','10:00:00',1.07),('11288','2013-01-18','10:05:00',1.14),('11288','2013-01-18','10:10:00',1.53),('11288','2013-01-18','10:15:00',3.44),('11288','2013-01-18','10:20:00',3.78),('11288','2013-01-18','10:25:00',2.73),('11288','2013-01-18','10:30:00',2.22),('11288','2013-01-18','10:35:00',1.86),('11288','2013-01-18','10:40:00',1.52),('11288','2013-01-18','10:45:00',1.4),('11288','2013-01-18','10:50:00',1.44),('11288','2013-01-18','10:55:00',1.48),('11288','2013-01-18','11:00:00',1.56),('11288','2013-01-18','11:05:00',1.67),('11288','2013-01-18','11:10:00',1.62),('11288','2013-01-18','11:15:00',1.58),('11288','2013-01-18','11:20:00',1.42),('11288','2013-01-18','11:25:00',1.56),('11288','2013-01-18','11:30:00',1.96),('11288','2013-01-18','11:35:00',2.25),('11288','2013-01-18','11:40:00',2.04),('11288','2013-01-18','11:45:00',1.72),('11288','2013-01-18','11:50:00',1.48),('11288','2013-01-18','11:55:00',1.54),('11288','2013-01-18','12:00:00',1.66),('11288','2013-01-18','12:05:00',1.68),('11288','2013-01-18','12:10:00',1.89),('11288','2013-01-18','12:15:00',1.92),('11288','2013-01-18','12:20:00',1.92),('11288','2013-01-18','12:25:00',1.96),('11288','2013-01-18','12:30:00',1.95),('11288','2013-01-18','12:35:00',2.29),('11288','2013-01-18','12:40:00',2.4),('11288','2013-01-18','12:45:00',2.53),('11288','2013-01-18','12:50:00',3.14),('11288','2013-01-18','12:55:00',3.46),('11288','2013-01-18','13:00:00',4.27),('11288','2013-01-18','13:05:00',4.33),('11288','2013-01-18','13:10:00',3.99),('11288','2013-01-18','13:15:00',4.08),('11288','2013-01-18','13:20:00',3.26),('11288','2013-01-18','13:25:00',2.57),('11288','2013-01-18','13:30:00',2.39),('11288','2013-01-18','13:35:00',2.17),('11288','2013-01-18','13:40:00',3.27),('11288','2013-01-18','13:45:00',4.47),('11288','2013-01-18','13:50:00',4.48),('11288','2013-01-18','13:55:00',4.57),('11288','2013-01-18','14:00:00',4.38),('11288','2013-01-18','14:05:00',4.43),('11288','2013-01-18','14:10:00',3.76),('11288','2013-01-18','14:15:00',4.18),('11288','2013-01-18','14:20:00',3.46),('11288','2013-01-18','14:25:00',2.52),('11288','2013-01-18','14:30:00',2.06),('11288','2013-01-18','14:35:00',1.75),('11288','2013-01-18','14:40:00',1.61),('11288','2013-01-18','14:45:00',1.61),('11288','2013-01-18','14:50:00',1.64),('11288','2013-01-18','14:55:00',1.59),('11288','2013-01-18','15:00:00',1.38),('11288','2013-01-18','15:05:00',1.4),('11288','2013-01-18','15:10:00',1.35),('11288','2013-01-18','15:15:00',1.42),('11288','2013-01-18','15:20:00',1.14),('11288','2013-01-18','15:25:00',1.06),('11288','2013-01-18','15:30:00',1.07),('11288','2013-01-17','09:10:00',1.32),('11288','2013-01-17','09:15:00',1.34),('11288','2013-01-17','09:20:00',1.27),('11288','2013-01-17','09:25:00',1.12),('11288','2013-01-17','09:30:00',1.27),('11288','2013-01-17','09:35:00',1.34),('11288','2013-01-17','09:40:00',1.49),('11288','2013-01-17','09:45:00',1.76),('11288','2013-01-17','09:50:00',1.93),('11288','2013-01-17','09:55:00',1.87),('11288','2013-01-17','10:00:00',1.6),('11288','2013-01-17','10:05:00',1.7),('11288','2013-01-17','10:10:00',1.98),('11288','2013-01-17','10:15:00',2.23),('11288','2013-01-17','10:20:00',2.14),('11288','2013-01-17','10:25:00',2.55),('11288','2013-01-17','10:30:00',2.6),('11288','2013-01-17','10:35:00',2.49),('11288','2013-01-17','10:40:00',2.52),('11288','2013-01-17','10:45:00',2.59),('11288','2013-01-17','10:50:00',2.52),('11288','2013-01-17','10:55:00',2.79),('11288','2013-01-17','11:00:00',2.6),('11288','2013-01-17','11:05:00',2.58),('11288','2013-01-17','11:10:00',2.95),('11288','2013-01-17','11:15:00',2.88),('11288','2013-01-17','11:20:00',2.75),('11288','2013-01-17','11:25:00',2.41),('11288','2013-01-17','11:30:00',2.19),('11288','2013-01-17','11:35:00',2.43),('11288','2013-01-17','11:40:00',2.39),('11288','2013-01-17','11:45:00',2.25),('11288','2013-01-17','11:50:00',2.39),('11288','2013-01-17','11:55:00',2.55),('11288','2013-01-17','12:00:00',2.85),('11288','2013-01-17','12:05:00',2.87),('11288','2013-01-17','12:10:00',2.99),('11288','2013-01-17','12:15:00',3.26),('11288','2013-01-17','12:20:00',2.91),('11288','2013-01-17','12:25:00',2.7),('11288','2013-01-17','12:30:00',2.24),('11288','2013-01-17','12:35:00',2.62),('11288','2013-01-17','12:40:00',2.58),('11288','2013-01-17','12:45:00',2.32),('11288','2013-01-17','12:50:00',1.59),('11288','2013-01-17','12:55:00',2.02),('11288','2013-01-17','13:00:00',2.64),('11288','2013-01-17','13:05:00',2.3),('11288','2013-01-17','13:10:00',1.96),('11288','2013-01-17','13:15:00',2.39),('11288','2013-01-17','13:20:00',2.37),('11288','2013-01-17','13:25:00',2.1),('11288','2013-01-17','13:30:00',1.94),('11288','2013-01-17','13:35:00',2.45),('11288','2013-01-17','13:40:00',2.43),('11288','2013-01-17','13:45:00',2.24),('11288','2013-01-17','13:50:00',1.83),('11288','2013-01-17','13:55:00',1.48),('11288','2013-01-17','14:00:00',2.01),('11288','2013-01-17','14:05:00',1.81),('11288','2013-01-17','14:10:00',1.43),('11288','2013-01-17','14:15:00',1.02),('11288','2013-01-17','14:20:00',1.3),('11288','2013-01-17','14:25:00',1.61),('11288','2013-01-17','14:30:00',2.13),('11288','2013-01-17','14:35:00',2.57),('11288','2013-01-17','14:40:00',1.14),('11288','2013-01-17','14:55:00',1.3),('11288','2013-01-17','15:00:00',1.27),('11288','2013-01-16','09:15:00',1.53),('11288','2013-01-16','09:20:00',1.43),('11288','2013-01-16','09:25:00',2.02),('11288','2013-01-16','09:30:00',2.08),('11288','2013-01-16','09:35:00',2.18),('11288','2013-01-16','09:40:00',2.15),('11288','2013-01-16','09:45:00',1.36),('11288','2013-01-16','09:55:00',1.54),('11288','2013-01-16','10:00:00',1.51),('11288','2013-01-16','10:30:00',1.32),('11288','2013-01-16','10:35:00',2.58),('11288','2013-01-16','10:40:00',2.57),('11288','2013-01-16','10:45:00',2.7),('11288','2013-01-16','10:50:00',1.43),('11288','2013-01-16','10:55:00',2.43),('11288','2013-01-16','11:00:00',1.32),('11288','2013-01-16','11:05:00',1.32),('11288','2013-01-16','11:25:00',2.52),('11288','2013-01-16','12:00:00',3.01),('11288','2013-01-16','12:05:00',2.25),('11288','2013-01-16','12:10:00',3.11),('11288','2013-01-16','12:15:00',5.41),('11288','2013-01-16','12:20:00',4.8),('11288','2013-01-16','12:25:00',1.17),('11288','2013-01-16','13:00:00',1.12),('11288','2013-01-16','13:05:00',3.89),('11288','2013-01-16','13:10:00',5.18),('11288','2013-01-16','13:15:00',5.58),('11288','2013-01-16','13:20:00',3.82),('11288','2013-01-16','13:25:00',2.5),('11288','2013-01-16','13:30:00',1.1),('11288','2013-01-16','13:50:00',1.03),('11288','2013-01-16','13:55:00',4.3),('11288','2013-01-16','14:00:00',3.11),('11288','2013-01-16','14:05:00',2.12),('11288','2013-01-16','15:00:00',1.05),('11288','2013-01-16','15:05:00',1.52),('11288','2013-01-16','15:10:00',1.34),('11288','2013-01-15','09:15:00',1.13),('11288','2013-01-15','09:55:00',1.74),('11288','2013-01-15','10:00:00',1.73),('11288','2013-01-15','10:05:00',1.38),('11288','2013-01-15','10:10:00',2.15),('11288','2013-01-15','10:15:00',1.45),('11288','2013-01-15','10:20:00',1.57),('11288','2013-01-15','10:25:00',1.67),('11288','2013-01-15','10:30:00',1.25),('11288','2013-01-15','10:35:00',1.36),('11288','2013-01-15','10:40:00',1.6),('11288','2013-01-15','10:45:00',1.83),('11288','2013-01-15','10:50:00',2.24),('11288','2013-01-15','10:55:00',2.44),('11288','2013-01-15','11:00:00',2.42),('11288','2013-01-15','11:05:00',2.51),('11288','2013-01-15','11:10:00',2.55),('11288','2013-01-15','11:15:00',2.42),('11288','2013-01-15','11:20:00',2.48),('11288','2013-01-15','11:25:00',2.46),('11288','2013-01-15','11:30:00',2.36),('11288','2013-01-15','11:35:00',2.23),('11288','2013-01-15','11:40:00',2.03),('11288','2013-01-15','11:45:00',1.92),('11288','2013-01-15','11:50:00',1.85),('11288','2013-01-15','11:55:00',1.99),('11288','2013-01-15','12:00:00',1.86),('11288','2013-01-15','12:05:00',1.77),('11288','2013-01-15','12:10:00',1.72),('11288','2013-01-15','12:15:00',1.98),('11288','2013-01-15','12:20:00',2.22),('11288','2013-01-15','12:25:00',2.18),('11288','2013-01-15','12:30:00',2.08),('11288','2013-01-15','12:35:00',2.1),('11288','2013-01-15','12:40:00',2.34),('11288','2013-01-15','12:45:00',2.33),('11288','2013-01-15','12:50:00',2.37),('11288','2013-01-15','12:55:00',2.01),('11288','2013-01-15','13:00:00',1.72),('11288','2013-01-15','13:05:00',1.81),('11288','2013-01-15','13:10:00',1.82),('11288','2013-01-15','13:15:00',1.88),('11288','2013-01-15','13:20:00',1.88),('11288','2013-01-15','13:25:00',1.84),('11288','2013-01-15','13:30:00',2),('11288','2013-01-15','13:35:00',2.06),('11288','2013-01-15','13:40:00',2.33),('11288','2013-01-15','13:45:00',2.11),('11288','2013-01-15','13:50:00',2.01),('11288','2013-01-15','13:55:00',2.44),('11288','2013-01-15','14:00:00',3.03),('11288','2013-01-15','14:05:00',3.2),('11288','2013-01-15','14:10:00',2.29),('11288','2013-01-15','14:15:00',3.1),('11288','2013-01-15','14:20:00',2.78),('11288','2013-01-15','14:25:00',2.7),('11288','2013-01-15','14:30:00',2.99),('11288','2013-01-15','14:35:00',1.57),('11288','2013-01-15','14:40:00',1.87),('11288','2013-01-15','14:45:00',2.43),('11288','2013-01-15','14:50:00',1.61),('11288','2013-01-15','14:55:00',1.92),('11288','2013-01-15','15:00:00',2.25),('11288','2013-01-15','15:05:00',2.14),('11288','2013-01-15','15:10:00',1.72),('11288','2013-01-15','15:15:00',1.25),('11288','2013-01-15','15:20:00',1.44),('11288','2013-01-15','15:25:00',1.24),('11288','2013-01-15','15:30:00',1.22),('11288','2013-01-15','15:45:00',1.01),('11288','2013-01-15','15:50:00',1.03),('11288','2013-01-15','15:55:00',1.02),('11288','2013-01-15','16:00:00',1.03),('11288','2013-01-15','16:05:00',1.09),('11288','2013-01-15','16:10:00',1.01),('11288','2013-01-14','09:50:00',1.08),('11288','2013-01-14','10:25:00',1.07),('11288','2013-01-14','11:20:00',1.26),('11288','2013-01-14','11:25:00',1.28),('11288','2013-01-14','11:30:00',1.02),('11288','2013-01-14','11:50:00',1.14),('11288','2013-01-14','12:20:00',1.27),('11288','2013-01-14','12:25:00',1.6),('11288','2013-01-14','12:30:00',1.57),('11288','2013-01-14','12:35:00',1.51),('11288','2013-01-14','12:40:00',1.72),('11288','2013-01-14','12:45:00',1.92),('11288','2013-01-14','12:50:00',2.12),('11288','2013-01-14','12:55:00',2.08),('11288','2013-01-14','13:00:00',2.13),('11288','2013-01-14','13:05:00',2.04),('11288','2013-01-14','13:10:00',1.65),('11288','2013-01-14','13:15:00',1.49),('11288','2013-01-14','13:35:00',1.29),('11288','2013-01-14','13:40:00',1.01),('11288','2013-01-14','15:15:00',1.77),('11288','2013-01-14','15:20:00',1.53),('11288','2013-01-14','15:25:00',1.53),('11288','2013-01-13','09:10:00',1.04),('11288','2013-01-13','09:15:00',2.32),('11288','2013-01-13','09:20:00',2.41),('11288','2013-01-13','09:25:00',2.38),('11288','2013-01-13','09:30:00',2.44),('11288','2013-01-13','09:35:00',2.44),('11288','2013-01-13','09:40:00',1.61),('11288','2013-01-13','09:45:00',1.59),('11288','2013-01-13','09:50:00',2.08),('11288','2013-01-13','09:55:00',2.25),('11288','2013-01-13','10:00:00',2.36),('11288','2013-01-13','10:05:00',2.61),('11288','2013-01-13','10:10:00',1.62),('11288','2013-01-13','10:15:00',1.59),('11288','2013-01-13','10:20:00',1.84),('11288','2013-01-13','10:25:00',2.1),('11288','2013-01-13','10:30:00',2.62),('11288','2013-01-13','10:35:00',1.56),('11288','2013-01-13','10:40:00',1.01),('11288','2013-01-13','12:15:00',1.03),('11288','2013-01-13','12:20:00',1.08),('11288','2013-01-12','08:50:00',1.03),('11288','2013-01-12','08:55:00',1.23),('11288','2013-01-12','09:00:00',1.34),('11288','2013-01-12','09:05:00',1.44),('11288','2013-01-12','09:10:00',1.53),('11288','2013-01-12','09:15:00',1.63),('11288','2013-01-12','09:20:00',1.7),('11288','2013-01-12','09:25:00',1.79),('11288','2013-01-12','09:30:00',1.86),('11288','2013-01-12','09:35:00',1.9),('11288','2013-01-12','09:40:00',2),('11288','2013-01-12','09:45:00',2.07),('11288','2013-01-12','09:50:00',2.17),('11288','2013-01-12','09:55:00',2.25),('11288','2013-01-12','10:00:00',2.35),('11288','2013-01-12','10:05:00',2.43),('11288','2013-01-12','10:10:00',2.5),('11288','2013-01-12','10:15:00',2.51),('11288','2013-01-12','10:20:00',2.57),('11288','2013-01-12','10:25:00',2.83),('11288','2013-01-12','10:30:00',2.96),('11288','2013-01-12','10:35:00',3.03),('11288','2013-01-12','10:40:00',3.11),('11288','2013-01-12','10:45:00',3.18),('11288','2013-01-12','10:50:00',3.09),('11288','2013-01-12','10:55:00',3.25),('11288','2013-01-12','11:00:00',3.36),('11288','2013-01-12','11:05:00',3.41),('11288','2013-01-12','11:10:00',3.43),('11288','2013-01-12','11:15:00',3.46),('11288','2013-01-12','11:20:00',3.5),('11288','2013-01-12','11:25:00',3.57),('11288','2013-01-12','11:30:00',3.56),('11288','2013-01-12','11:35:00',3.4),('11288','2013-01-12','11:40:00',3.21),('11288','2013-01-12','11:45:00',3.63),('11288','2013-01-12','11:50:00',3.69),('11288','2013-01-12','11:55:00',3.71),('11288','2013-01-12','12:00:00',3.7),('11288','2013-01-12','12:05:00',3.66),('11288','2013-01-12','12:10:00',3.63),('11288','2013-01-12','12:15:00',3.57),('11288','2013-01-12','12:20:00',3.61),('11288','2013-01-12','12:25:00',3.58),('11288','2013-01-12','12:30:00',3.58),('11288','2013-01-12','12:35:00',3.57),('11288','2013-01-12','12:40:00',3.05),('11288','2013-01-12','12:45:00',3.01),('11288','2013-01-12','12:50:00',2.21),('11288','2013-01-12','12:55:00',1.8),('11288','2013-01-12','13:00:00',3.25),('11288','2013-01-12','13:05:00',3.63),('11288','2013-01-12','13:10:00',3.48),('11288','2013-01-12','13:15:00',2.08),('11288','2013-01-12','13:20:00',1.46),('11288','2013-01-12','13:25:00',2.27),('11288','2013-01-12','13:30:00',2.76),('11288','2013-01-12','13:35:00',1.94),('11288','2013-01-12','13:40:00',1.38),('11288','2013-01-12','13:45:00',2.82),('11288','2013-01-12','13:50:00',3.04),('11288','2013-01-12','13:55:00',3.22),('11288','2013-01-12','14:00:00',2.31),('11288','2013-01-12','14:05:00',3.17),('11288','2013-01-12','14:10:00',2.19),('11288','2013-01-12','14:15:00',1.69),('11288','2013-01-12','14:20:00',2.08),('11288','2013-01-12','14:25:00',2.02),('11288','2013-01-12','14:30:00',2.29),('11288','2013-01-12','14:35:00',2.23),('11288','2013-01-12','14:40:00',2.14),('11288','2013-01-12','14:45:00',2.04),('11288','2013-01-12','14:50:00',1.94),('11288','2013-01-12','14:55:00',1.85),('11288','2013-01-12','15:00:00',1.73),('11288','2013-01-12','15:05:00',1.46),('11288','2013-01-12','15:10:00',1.23),('11288','2013-01-12','15:15:00',1.34),('11288','2013-01-12','15:20:00',1.08),('11288','2014-03-19','08:25:00',1.04),('11288','2014-03-19','08:30:00',1.14),('11288','2014-03-19','08:35:00',1.25),('11288','2014-03-19','08:40:00',1.39),('11288','2014-03-19','08:45:00',1.6),('11288','2014-03-19','08:50:00',1.69),('11288','2014-03-19','08:55:00',1.7),('11288','2014-03-19','09:00:00',1.8),('11288','2014-03-19','09:05:00',2.15),('11288','2014-03-19','09:10:00',2.39),('11288','2014-03-19','09:15:00',2.79),('11288','2014-03-19','09:20:00',2.75),('11288','2014-03-19','09:25:00',4.25),('11288','2014-03-19','09:30:00',4.66),('11288','2014-03-19','09:35:00',5.26),('11288','2014-03-19','09:40:00',4.56),('11288','2014-03-19','09:45:00',3.9),('11288','2014-03-19','09:50:00',4.21),('11288','2014-03-19','09:55:00',2.72),('11288','2014-03-19','10:00:00',2.2),('11288','2014-03-19','10:05:00',1.65),('11288','2014-03-19','10:10:00',1.45),('11288','2014-03-19','10:15:00',1.44),('11288','2014-03-19','10:20:00',1.61),('11288','2014-03-19','10:25:00',1.86),('11288','2014-03-19','10:30:00',2.74),('11288','2014-03-19','10:35:00',4.32),('11288','2014-03-19','10:40:00',2.82),('11288','2014-03-19','10:45:00',2.61),('11288','2014-03-19','10:50:00',2.49),('11288','2014-03-19','10:55:00',3.16),('11288','2014-03-19','11:00:00',6.4),('11288','2014-03-19','11:05:00',5.95),('11288','2014-03-19','11:10:00',3.2),('11288','2014-03-19','11:15:00',3.15),('11288','2014-03-19','11:20:00',2.83),('11288','2014-03-19','11:25:00',3.08),('11288','2014-03-19','11:30:00',4),('11288','2014-03-19','11:35:00',4.83),('11288','2014-03-19','11:40:00',3.39),('11288','2014-03-19','11:45:00',3.15),('11288','2014-03-19','11:50:00',2.9),('11288','2014-03-19','11:55:00',2.84),('11288','2014-03-19','12:00:00',3.61),('11288','2014-03-19','12:05:00',5.47),('11288','2014-03-19','12:10:00',4.59),('11288','2014-03-19','12:15:00',3.03),('11288','2014-03-19','12:20:00',6.18),('11288','2014-03-19','12:25:00',4.77),('11288','2014-03-19','12:30:00',5.47),('11288','2014-03-19','12:35:00',3.94),('11288','2014-03-19','12:40:00',6.11),('11288','2014-03-19','12:45:00',5.61),('11288','2014-03-19','12:50:00',3.32),('11288','2014-03-19','12:55:00',6.26),('11288','2014-03-19','13:00:00',5.92),('11288','2014-03-19','13:05:00',5.77),('11288','2014-03-19','13:10:00',5.73),('11288','2014-03-19','13:15:00',5.57),('11288','2014-03-19','13:20:00',5.26),('11288','2014-03-19','13:25:00',5.04),('11288','2014-03-19','13:30:00',5.59),('11288','2014-03-19','13:35:00',5.61),('11288','2014-03-19','13:40:00',5.4),('11288','2014-03-19','13:45:00',5.39),('11288','2014-03-19','13:50:00',5.19),('11288','2014-03-19','13:55:00',5.38),('11288','2014-03-19','14:00:00',5.03),('11288','2014-03-19','14:05:00',5.36),('11288','2014-03-19','14:10:00',5.23),('11288','2014-03-19','14:15:00',5.07),('11288','2014-03-19','14:20:00',5.01),('11288','2014-03-19','14:25:00',4.94),('11288','2014-03-19','14:30:00',4.78),('11288','2014-03-19','14:35:00',4.86),('11288','2014-03-19','14:40:00',4.75),('11288','2014-03-19','14:45:00',4.62),('11288','2014-03-19','14:50:00',4.44),('11288','2014-03-19','14:55:00',4.37),('11288','2014-03-19','15:00:00',4.26),('11288','2014-03-19','15:05:00',4.12),('11288','2014-03-19','15:10:00',4.03),('11288','2014-03-19','15:15:00',3.94),('11288','2014-03-19','15:20:00',3.8),('11288','2014-03-19','15:25:00',3.72),('11288','2014-03-19','15:30:00',3.57),('11288','2014-03-19','15:35:00',3.36),('11288','2014-03-19','15:40:00',3.33),('11288','2014-03-19','15:45:00',3.21),('11288','2014-03-19','15:50:00',3.03),('11288','2014-03-19','15:55:00',2.96),('11288','2014-03-19','16:00:00',2.76),('11288','2014-03-19','16:05:00',2.65),('11288','2014-03-19','16:10:00',2.51),('11288','2014-03-19','16:15:00',2.34),('11288','2014-03-19','16:20:00',2.19),('11288','2014-03-19','16:25:00',1.94),('11288','2014-03-19','16:30:00',1.83),('11288','2014-03-19','16:35:00',1.65),('11288','2014-03-19','16:40:00',1.52),('11288','2014-03-19','16:45:00',1.46),('11288','2014-03-19','16:50:00',1.22),('11288','2014-03-19','16:55:00',1.14),('11288','2013-01-11','09:45:00',1.21),('11288','2013-01-11','09:55:00',1.2),('11288','2013-01-11','10:00:00',1.63),('11288','2013-01-11','10:05:00',2.12),('11288','2013-01-11','10:10:00',2.07),('11288','2013-01-11','10:15:00',2.17),('11288','2013-01-11','10:20:00',2.26),('11288','2013-01-11','10:25:00',2.29),('11288','2013-01-11','10:30:00',2.59),('11288','2013-01-11','10:35:00',2.92),('11288','2013-01-11','10:40:00',2.99),('11288','2013-01-11','10:45:00',2.99),('11288','2013-01-11','10:50:00',2.99),('11288','2013-01-11','10:55:00',3.12),('11288','2013-01-11','11:00:00',3.27),('11288','2013-01-11','11:05:00',3.3),('11288','2013-01-11','11:10:00',3.39),('11288','2013-01-11','11:15:00',3.37),('11288','2013-01-11','11:20:00',3.35),('11288','2013-01-11','11:25:00',2.05),('11288','2013-01-11','11:30:00',2.06),('11288','2013-01-11','11:35:00',2.09),('11288','2013-01-11','11:40:00',1.96),('11288','2013-01-11','11:45:00',2.48),('11288','2013-01-11','11:50:00',2.28),('11288','2013-01-11','11:55:00',2.12),('11288','2013-01-11','12:00:00',1.77),('11288','2013-01-11','12:05:00',1.29),('11288','2013-01-11','12:15:00',1.17),('11288','2013-01-11','12:20:00',1.18),('11288','2013-01-11','12:50:00',1.54),('11288','2013-01-11','12:55:00',3.46),('11288','2013-01-11','13:00:00',2.33),('11288','2013-01-11','13:05:00',1.95),('11288','2013-01-11','13:10:00',2.77),('11288','2013-01-11','13:15:00',1.92),('11288','2013-01-11','13:20:00',1.46),('11288','2013-01-11','13:25:00',1.2),('11288','2013-01-11','13:30:00',2.02),('11288','2013-01-11','13:35:00',3.76),('11288','2013-01-11','13:40:00',2.46),('11288','2013-01-11','13:45:00',1.61),('11288','2013-01-11','14:20:00',2.33),('11288','2013-01-11','14:25:00',1.87),('11288','2013-01-11','14:30:00',1.39),('11288','2013-01-11','14:35:00',1.35),('11288','2013-01-11','14:40:00',1.26),('11288','2013-01-11','14:45:00',2),('11288','2013-01-11','14:50:00',2.03),('11288','2013-01-11','14:55:00',1.36),('11288','2013-01-11','15:00:00',1.83),('11288','2013-01-11','15:05:00',1.77),('11288','2013-01-11','15:45:00',1.03),('11288','2013-01-10','10:05:00',1.01),('11288','2013-01-10','10:25:00',1.01),('11288','2013-01-10','11:20:00',1.04),('11288','2013-01-10','11:25:00',1.49),('11288','2013-01-10','11:30:00',1.84),('11288','2013-01-10','11:35:00',1.48),('11288','2013-01-10','11:45:00',1.12),('11288','2013-01-10','11:50:00',1.64),('11288','2013-01-10','11:55:00',2.16),('11288','2013-01-10','12:00:00',2.18),('11288','2013-01-10','12:05:00',2.13),('11288','2013-01-10','12:10:00',1.86),('11288','2013-01-10','12:15:00',1.53),('11288','2013-01-10','12:20:00',1.11),('11288','2013-01-10','12:45:00',1.02),('11288','2013-01-10','13:15:00',1.14),('11288','2013-01-10','13:20:00',1.01),('11288','2013-01-10','13:40:00',1),('11288','2013-01-10','13:45:00',1.17),('11288','2013-01-10','13:50:00',1.04),('11288','2013-01-10','13:55:00',1.19),('11288','2013-01-10','14:00:00',1.29),('11288','2013-01-10','14:05:00',1.07),('11288','2013-01-09','09:35:00',1.08),('11288','2013-01-09','09:40:00',1.43),('11288','2013-01-09','09:45:00',1.09),('11288','2013-01-09','09:50:00',1.11),('11288','2013-01-09','09:55:00',1.15),('11288','2013-01-09','10:00:00',1.18),('11288','2013-01-09','10:05:00',1.15),('11288','2013-01-09','10:10:00',1.1),('11288','2013-01-09','10:15:00',1.08),('11288','2013-01-09','10:20:00',1.11),('11288','2013-01-09','10:25:00',1.31),('11288','2013-01-09','10:30:00',1.57),('11288','2013-01-09','10:35:00',1.67),('11288','2013-01-09','10:40:00',1.68),('11288','2013-01-09','10:45:00',1.79),('11288','2013-01-09','10:50:00',1.98),('11288','2013-01-09','10:55:00',1.93),('11288','2013-01-09','11:00:00',1.82),('11288','2013-01-09','11:05:00',2.01),('11288','2013-01-09','11:10:00',2.69),('11288','2013-01-09','11:15:00',2.63),('11288','2013-01-09','11:20:00',2.03),('11288','2013-01-09','11:25:00',2.08),('11288','2013-01-09','11:30:00',2.07),('11288','2013-01-09','11:35:00',2.02),('11288','2013-01-09','11:40:00',1.93),('11288','2013-01-09','11:45:00',1.95),('11288','2013-01-09','11:50:00',2.12),('11288','2013-01-09','11:55:00',2.12),('11288','2013-01-09','12:00:00',1.99),('11288','2013-01-09','12:05:00',2.04),('11288','2013-01-09','12:10:00',2.02),('11288','2013-01-09','12:15:00',2.01),('11288','2013-01-09','12:20:00',1.94),('11288','2013-01-09','12:25:00',1.77),('11288','2013-01-09','12:30:00',1.75),('11288','2013-01-09','12:35:00',1.84),('11288','2013-01-09','12:40:00',1.77),('11288','2013-01-09','12:45:00',1.78),('11288','2013-01-09','12:50:00',1.89),('11288','2013-01-09','12:55:00',2.09),('11288','2013-01-09','13:00:00',2.06),('11288','2013-01-09','13:05:00',2.03),('11288','2013-01-09','13:10:00',2.06),('11288','2013-01-09','13:15:00',1.96),('11288','2013-01-09','13:20:00',1.65),('11288','2013-01-09','13:25:00',1.49),('11288','2013-01-09','13:30:00',1.43),('11288','2013-01-09','13:35:00',1.5),('11288','2013-01-09','13:40:00',1.55),('11288','2013-01-09','13:45:00',1.48),('11288','2013-01-09','13:50:00',1.35),('11288','2013-01-09','13:55:00',1.34),('11288','2013-01-09','14:00:00',1.39),('11288','2013-01-09','14:05:00',1.27),('11288','2013-01-09','14:10:00',1.22),('11288','2013-01-09','14:15:00',1.09),('11288','2013-01-09','14:20:00',1),('11288','2013-01-08','08:35:00',1.09),('11288','2013-01-08','08:40:00',1.26),('11288','2013-01-08','08:45:00',1.45),('11288','2013-01-08','08:50:00',1.42),('11288','2013-01-08','08:55:00',1.81),('11288','2013-01-08','09:00:00',1.96),('11288','2013-01-08','09:05:00',1.91),('11288','2013-01-08','09:10:00',1.28),('11288','2013-01-08','09:15:00',1.61),('11288','2013-01-08','09:20:00',1.74),('11288','2013-01-08','09:25:00',1.98),('11288','2013-01-08','09:30:00',1.84),('11288','2013-01-08','09:35:00',1.68),('11288','2013-01-08','09:40:00',2.08),('11288','2013-01-08','09:45:00',2.52),('11288','2013-01-08','09:50:00',2.66),('11288','2013-01-08','09:55:00',2.68),('11288','2013-01-08','10:00:00',2.6),('11288','2013-01-08','10:05:00',2.42),('11288','2013-01-08','10:10:00',2.47),('11288','2013-01-08','10:15:00',2.39),('11288','2013-01-08','10:20:00',2.32),('11288','2013-01-08','10:25:00',2.51),('11288','2013-01-08','10:30:00',2.61),('11288','2013-01-08','10:35:00',2.76),('11288','2013-01-08','10:40:00',3.07),('11288','2013-01-08','10:45:00',2.93),('11288','2013-01-08','10:50:00',2.89),('11288','2013-01-08','10:55:00',3.12),('11288','2013-01-08','11:00:00',3.17),('11288','2013-01-08','11:05:00',3.28),('11288','2013-01-08','11:10:00',3.39),('11288','2013-01-08','11:15:00',3.4),('11288','2013-01-08','11:20:00',3.46),('11288','2013-01-08','11:25:00',3.54),('11288','2013-01-08','11:30:00',3.53),('11288','2013-01-08','11:35:00',3.32),('11288','2013-01-08','11:40:00',3.35),('11288','2013-01-08','11:45:00',4.38),('11288','2013-01-08','11:50:00',3.2),('11288','2013-01-08','11:55:00',2.73),('11288','2013-01-08','12:00:00',2.65),('11288','2013-01-08','12:05:00',2.53),('11288','2013-01-08','12:10:00',2.66),('11288','2013-01-08','12:15:00',2.56),('11288','2013-01-08','12:20:00',2.24),('11288','2013-01-08','12:25:00',2.16),('11288','2013-01-08','12:30:00',2.08),('11288','2013-01-08','12:35:00',2.02),('11288','2013-01-08','12:40:00',2.47),('11288','2013-01-08','12:45:00',2.94),('11288','2013-01-08','12:50:00',3.14),('11288','2013-01-08','12:55:00',2.41),('11288','2013-01-08','13:00:00',1.8),('11288','2013-01-08','13:05:00',1.48),('11288','2013-01-08','13:10:00',1.42),('11288','2013-01-08','13:15:00',1.28),('11288','2013-01-08','13:20:00',1.59),('11288','2013-01-08','13:25:00',1.42),('11288','2013-01-08','13:30:00',1.24),('11288','2013-01-08','13:35:00',1.3),('11288','2013-01-08','13:40:00',1.65),('11288','2013-01-08','13:45:00',2.14),('11288','2013-01-08','13:50:00',2.38),('11288','2013-01-08','13:55:00',3.03),('11288','2013-01-08','14:00:00',1.75),('11288','2013-01-08','14:05:00',1.7),('11288','2013-01-08','14:10:00',1.38),('11288','2013-01-08','14:15:00',1.37),('11288','2013-01-08','14:20:00',1.26),('11288','2013-01-08','14:25:00',1.47),('11288','2013-01-08','14:30:00',1.52),('11288','2013-01-08','14:35:00',1.58),('11288','2013-01-08','14:40:00',1.71),('11288','2013-01-08','14:45:00',1.16),('11288','2013-01-08','14:55:00',1.02),('11288','2013-01-08','15:05:00',1.17),('11288','2013-01-08','15:10:00',1.11),('11288','2013-01-08','15:15:00',1.2),('11288','2013-01-08','15:35:00',1.09),('11288','2013-01-08','15:40:00',1),('11288','2013-01-07','08:50:00',1.09),('11288','2013-01-07','08:55:00',1.14),('11288','2013-01-07','09:00:00',1.3),('11288','2013-01-07','09:05:00',1.24),('11288','2013-01-07','09:10:00',1.13),('11288','2013-01-07','09:15:00',1.17),('11288','2013-01-07','09:20:00',1.6),('11288','2013-01-07','09:25:00',1.77),('11288','2013-01-07','09:30:00',1.83),('11288','2013-01-07','09:35:00',1.89),('11288','2013-01-07','09:40:00',1.93),('11288','2013-01-07','09:45:00',2.05),('11288','2013-01-07','09:50:00',2.12),('11288','2013-01-07','09:55:00',2.2),('11288','2013-01-07','10:00:00',2.32),('11288','2013-01-07','10:05:00',2.48),('11288','2013-01-07','10:10:00',2.51),('11288','2013-01-07','10:15:00',2.69),('11288','2013-01-07','10:20:00',2.74),('11288','2013-01-07','10:25:00',2.85),('11288','2013-01-07','10:30:00',2.89),('11288','2013-01-07','10:35:00',2.94),('11288','2013-01-07','10:40:00',3.07),('11288','2013-01-07','10:45:00',3.09),('11288','2013-01-07','10:50:00',3.04),('11288','2013-01-07','10:55:00',3.2),('11288','2013-01-07','11:00:00',3.25),('11288','2013-01-07','11:05:00',3.33),('11288','2013-01-07','11:10:00',3.38),('11288','2013-01-07','11:15:00',3.44),('11288','2013-01-07','11:20:00',3.47),('11288','2013-01-07','11:25:00',3.53),('11288','2013-01-07','11:30:00',3.42),('11288','2013-01-07','11:35:00',3.16),('11288','2013-01-07','11:40:00',3.18),('11288','2013-01-07','11:45:00',3.52),('11288','2013-01-07','11:50:00',3.61),('11288','2013-01-07','11:55:00',3.58),('11288','2013-01-07','12:00:00',3.59),('11288','2013-01-07','12:05:00',3.6),('11288','2013-01-07','12:10:00',3.5),('11288','2013-01-07','12:15:00',3.58),('11288','2013-01-07','12:20:00',3.62),('11288','2013-01-07','12:25:00',3.62),('11288','2013-01-07','12:30:00',3.59),('11288','2013-01-07','12:35:00',3.61),('11288','2013-01-07','12:40:00',3.54),('11288','2013-01-07','12:45:00',3.51),('11288','2013-01-07','12:50:00',3.52),('11288','2013-01-07','12:55:00',3.48),('11288','2013-01-07','13:00:00',3.43),('11288','2013-01-07','13:05:00',3.38),('11288','2013-01-07','13:10:00',3.31),('11288','2013-01-07','13:15:00',3.23),('11288','2013-01-07','13:20:00',3.17),('11288','2013-01-07','13:25:00',3.14),('11288','2013-01-07','13:30:00',3.14),('11288','2013-01-07','13:35:00',3.03),('11288','2013-01-07','13:40:00',3.01),('11288','2013-01-07','13:45:00',2.94),('11288','2013-01-07','13:50:00',2.82),('11288','2013-01-07','13:55:00',2.74),('11288','2013-01-07','14:00:00',2.71),('11288','2013-01-07','14:05:00',2.6),('11288','2013-01-07','14:10:00',2.51),('11288','2013-01-07','14:15:00',2.42),('11288','2013-01-07','14:20:00',2.4),('11288','2013-01-07','14:25:00',2.31),('11288','2013-01-07','14:30:00',2.2),('11288','2013-01-07','14:35:00',2.09),('11288','2013-01-07','14:40:00',2.01),('11288','2013-01-07','14:45:00',1.92),('11288','2013-01-07','14:50:00',1.82),('11288','2013-01-07','14:55:00',1.73),('11288','2013-01-07','15:00:00',1.6),('11288','2013-01-07','15:05:00',1.45),('11288','2013-01-07','15:10:00',1.17),('11288','2013-01-07','15:15:00',1.27),('11288','2013-01-07','15:20:00',1.19),('11288','2013-01-07','15:25:00',1.05),('11288','2013-01-07','15:30:00',1.05),('11288','2013-01-06','08:50:00',1.09),('11288','2013-01-06','08:55:00',1.13),('11288','2013-01-06','09:00:00',1.3),('11288','2013-01-06','09:05:00',1.39),('11288','2013-01-06','09:10:00',1.49),('11288','2013-01-06','09:15:00',1.61),('11288','2013-01-06','09:20:00',1.69),('11288','2013-01-06','09:25:00',1.77),('11288','2013-01-06','09:30:00',1.85),('11288','2013-01-06','09:35:00',1.9),('11288','2013-01-06','09:40:00',1.97),('11288','2013-01-06','09:45:00',2.1),('11288','2013-01-06','09:50:00',2.18),('11288','2013-01-06','09:55:00',2.24),('11288','2013-01-06','10:00:00',2.35),('11288','2013-01-06','10:05:00',2.43),('11288','2013-01-06','10:10:00',2.44),('11288','2013-01-06','10:15:00',2.58),('11288','2013-01-06','10:20:00',2.65),('11288','2013-01-06','10:25:00',2.8),('11288','2013-01-06','10:30:00',2.9),('11288','2013-01-06','10:35:00',2.98),('11288','2013-01-06','10:40:00',3.07),('11288','2013-01-06','10:45:00',3.04),('11288','2013-01-06','10:50:00',2.98),('11288','2013-01-06','10:55:00',3.23),('11288','2013-01-06','11:00:00',3.3),('11288','2013-01-06','11:05:00',3.33),('11288','2013-01-06','11:10:00',3.41),('11288','2013-01-06','11:15:00',3.43),('11288','2013-01-06','11:20:00',3.47),('11288','2013-01-06','11:25:00',3.53),('11288','2013-01-06','11:30:00',3.51),('11288','2013-01-06','11:35:00',3.55),('11288','2013-01-06','11:40:00',3.55),('11288','2013-01-06','11:45:00',3.58),('11288','2013-01-06','11:50:00',3.6),('11288','2013-01-06','11:55:00',3.62),('11288','2013-01-06','12:00:00',3.64),('11288','2013-01-06','12:05:00',3.62),('11288','2013-01-06','12:10:00',3.53),('11288','2013-01-06','12:15:00',3.54),('11288','2013-01-06','12:20:00',3.58),('11288','2013-01-06','12:25:00',3.57),('11288','2013-01-06','12:30:00',3.54),('11288','2013-01-06','12:35:00',3.48),('11288','2013-01-06','12:40:00',3.46),('11288','2013-01-06','12:45:00',3.48),('11288','2013-01-06','12:50:00',3.53),('11288','2013-01-06','12:55:00',3.53),('11288','2013-01-06','13:00:00',3.51),('11288','2013-01-06','13:05:00',3.46),('11288','2013-01-06','13:10:00',3.39),('11288','2013-01-06','13:15:00',3.35),('11288','2013-01-06','13:20:00',3.29),('11288','2013-01-06','13:25:00',3.25),('11288','2013-01-06','13:30:00',3.21),('11288','2013-01-06','13:35:00',3.16),('11288','2013-01-06','13:40:00',3.1),('11288','2013-01-06','13:45:00',3.03),('11288','2013-01-06','13:50:00',2.92),('11288','2013-01-06','13:55:00',2.84),('11288','2013-01-06','14:00:00',2.82),('11288','2013-01-06','14:05:00',2.79),('11288','2013-01-06','14:10:00',2.6),('11288','2013-01-06','14:15:00',2.51),('11288','2013-01-06','14:20:00',2.46),('11288','2013-01-06','14:25:00',2.26),('11288','2013-01-06','14:30:00',2.16),('11288','2013-01-06','14:35:00',2.07),('11288','2013-01-06','14:40:00',1.98),('11288','2013-01-06','14:45:00',1.88),('11288','2013-01-06','14:50:00',1.75),('11288','2013-01-06','14:55:00',1.67),('11288','2013-01-06','15:00:00',1.57),('11288','2013-01-06','15:05:00',1.41),('11288','2013-01-06','15:10:00',1.18),('11288','2013-01-06','15:15:00',1.21),('11288','2013-01-06','15:20:00',1.18),('11288','2013-01-06','15:25:00',1.02),('11288','2013-01-05','09:10:00',1.05),('11288','2013-01-05','09:15:00',1.05),('11288','2013-01-05','09:20:00',1.03),('11288','2013-01-05','09:25:00',1.12),('11288','2013-01-05','09:30:00',1.11),('11288','2013-01-05','09:35:00',1.24),('11288','2013-01-05','09:40:00',1.33),('11288','2013-01-05','09:45:00',1.3),('11288','2013-01-05','09:50:00',1.3),('11288','2013-01-05','09:55:00',1.38),('11288','2013-01-05','10:00:00',1.5),('11288','2013-01-05','10:05:00',1.62),('11288','2013-01-05','10:10:00',1.69),('11288','2013-01-05','10:15:00',1.77),('11288','2013-01-05','10:20:00',1.67),('11288','2013-01-05','10:25:00',1.59),('11288','2013-01-05','10:30:00',1.63),('11288','2013-01-05','10:35:00',1.8),('11288','2013-01-05','10:40:00',1.84),('11288','2013-01-05','10:45:00',1.78),('11288','2013-01-05','10:50:00',1.93),('11288','2013-01-05','10:55:00',2.79),('11288','2013-01-05','11:00:00',2.56),('11288','2013-01-05','11:05:00',2.89),('11288','2013-01-05','11:10:00',2.96),('11288','2013-01-05','11:15:00',2.49),('11288','2013-01-05','11:20:00',3.33),('11288','2013-01-05','11:25:00',3.59),('11288','2013-01-05','11:30:00',3.56),('11288','2013-01-05','11:35:00',3.39),('11288','2013-01-05','11:40:00',3.21),('11288','2013-01-05','11:45:00',3.33),('11288','2013-01-05','11:50:00',2.96),('11288','2013-01-05','11:55:00',2.7),('11288','2013-01-05','12:00:00',2.48),('11288','2013-01-05','12:05:00',2.48),('11288','2013-01-05','12:10:00',2.49),('11288','2013-01-05','12:15:00',2.54),('11288','2013-01-05','12:20:00',2.31),('11288','2013-01-05','12:25:00',1.97),('11288','2013-01-05','12:30:00',1.93),('11288','2013-01-05','12:35:00',2.42),('11288','2013-01-05','12:40:00',3.07),('11288','2013-01-05','12:45:00',3.35),('11288','2013-01-05','12:50:00',2.42),('11288','2013-01-05','12:55:00',2.08),('11288','2013-01-05','13:00:00',2.09),('11288','2013-01-05','13:05:00',2.09),('11288','2013-01-05','13:10:00',1.97),('11288','2013-01-05','13:15:00',1.71),('11288','2013-01-05','13:20:00',1.56),('11288','2013-01-05','13:25:00',1.83),('11288','2013-01-05','13:30:00',2.67),('11288','2013-01-05','13:35:00',2.23),('11288','2013-01-05','13:40:00',1.79),('11288','2013-01-05','13:45:00',1.55),('11288','2013-01-05','13:50:00',1.7),('11288','2013-01-05','13:55:00',2.01),('11288','2013-01-05','14:00:00',1.78),('11288','2013-01-05','14:05:00',2.48),('11288','2013-01-05','14:10:00',2.25),('11288','2013-01-05','14:15:00',1.88),('11288','2013-01-05','14:20:00',1.66),('11288','2013-01-05','14:25:00',1.15),('11288','2013-01-05','14:30:00',1.68),('11288','2013-01-05','14:35:00',1.67),('11288','2013-01-05','14:40:00',1.74),('11288','2013-01-05','14:45:00',1.91),('11288','2013-01-05','14:50:00',1.32),('11288','2013-01-05','14:55:00',1.14),('11288','2013-01-05','15:00:00',1.67),('11288','2013-01-05','15:05:00',1.34),('11288','2013-01-04','08:45:00',1.15),('11288','2013-01-04','08:50:00',1.29),('11288','2013-01-04','08:55:00',1.23),('11288','2013-01-04','09:00:00',1.37),('11288','2013-01-04','09:05:00',1.39),('11288','2013-01-04','09:10:00',1.49),('11288','2013-01-04','09:15:00',1.37),('11288','2013-01-04','09:20:00',1.58),('11288','2013-01-04','09:25:00',1.46),('11288','2013-01-04','09:30:00',1.52),('11288','2013-01-04','09:35:00',1.42),('11288','2013-01-04','09:40:00',1.39),('11288','2013-01-04','09:45:00',1.49),('11288','2013-01-04','09:50:00',1.84),('11288','2013-01-04','09:55:00',1.93),('11288','2013-01-04','10:00:00',2.57),('11288','2013-01-04','10:05:00',2.68),('11288','2013-01-04','10:10:00',2.3),('11288','2013-01-04','10:15:00',2.6),('11288','2013-01-04','10:20:00',2.48),('11288','2013-01-04','10:25:00',2.58),('11288','2013-01-04','10:30:00',2.96),('11288','2013-01-04','10:35:00',3.06),('11288','2013-01-04','10:40:00',3.2),('11288','2013-01-04','10:45:00',3.34),('11288','2013-01-04','10:50:00',3.61),('11288','2013-01-04','10:55:00',3.9),('11288','2013-01-04','11:00:00',3.57),('11288','2013-01-04','11:05:00',2.5),('11288','2013-01-04','11:10:00',1.71),('11288','2013-01-04','11:15:00',1.65),('11288','2013-01-04','11:20:00',1.59),('11288','2013-01-04','11:25:00',1.37),('11288','2013-01-04','11:30:00',1.21),('11288','2013-01-04','11:35:00',1.28),('11288','2013-01-04','11:40:00',1.3),('11288','2013-01-04','11:45:00',2.03),('11288','2013-01-04','11:50:00',3.16),('11288','2013-01-04','11:55:00',4.08),('11288','2013-01-04','12:00:00',4.61),('11288','2013-01-04','12:05:00',3.88),('11288','2013-01-04','12:10:00',3.06),('11288','2013-01-04','12:15:00',2.18),('11288','2013-01-04','12:20:00',1.62),('11288','2013-01-04','12:25:00',1.61),('11288','2013-01-04','12:30:00',2.88),('11288','2013-01-04','12:35:00',2.44),('11288','2013-01-04','12:40:00',3.62),('11288','2013-01-04','12:45:00',3.68),('11288','2013-01-04','12:50:00',3.77),('11288','2013-01-04','12:55:00',3.66),('11288','2013-01-04','13:00:00',3.53),('11288','2013-01-04','13:05:00',3.31),('11288','2013-01-04','13:10:00',2.01),('11288','2013-01-04','13:15:00',2.99),('11288','2013-01-04','13:20:00',3.12),('11288','2013-01-04','13:25:00',3.06),('11288','2013-01-04','13:30:00',3.03),('11288','2013-01-04','13:35:00',2.99),('11288','2013-01-04','13:40:00',2.87),('11288','2013-01-04','13:45:00',2.76),('11288','2013-01-04','13:50:00',2.7),('11288','2013-01-04','13:55:00',2.66),('11288','2013-01-04','14:00:00',2.55),('11288','2013-01-04','14:05:00',2.47),('11288','2013-01-04','14:10:00',2.4),('11288','2013-01-04','14:15:00',2.3),('11288','2013-01-04','14:20:00',2.28),('11288','2013-01-04','14:25:00',2.19),('11288','2013-01-04','14:30:00',2.07),('11288','2013-01-04','14:35:00',1.91),('11288','2013-01-04','14:40:00',1.83),('11288','2013-01-04','14:45:00',1.76),('11288','2013-01-04','14:50:00',1.66),('11288','2013-01-04','14:55:00',1.57),('11288','2013-01-04','15:00:00',1.49),('11288','2013-01-04','15:05:00',1.32),('11288','2013-01-04','15:10:00',1.02),('11288','2013-01-04','15:15:00',1.12),('11288','2013-01-04','15:20:00',1.09),('11288','2013-01-03','08:50:00',1.06),('11288','2013-01-03','08:55:00',1.1),('11288','2013-01-03','09:00:00',1.29),('11288','2013-01-03','09:05:00',1.39),('11288','2013-01-03','09:10:00',1.5),('11288','2013-01-03','09:15:00',1.6),('11288','2013-01-03','09:20:00',1.71),('11288','2013-01-03','09:25:00',1.81),('11288','2013-01-03','09:30:00',1.89),('11288','2013-01-03','09:35:00',1.96),('11288','2013-01-03','09:40:00',2.14),('11288','2013-01-03','09:45:00',2.36),('11288','2013-01-03','09:50:00',2.62),('11288','2013-01-03','09:55:00',2.85),('11288','2013-01-03','10:00:00',3.01),('11288','2013-01-03','10:05:00',3.18),('11288','2013-01-03','10:10:00',2.55),('11288','2013-01-03','10:15:00',3.04),('11288','2013-01-03','10:20:00',3.17),('11288','2013-01-03','10:25:00',3.5),('11288','2013-01-03','10:30:00',3.03),('11288','2013-01-03','10:35:00',2.82),('11288','2013-01-03','10:40:00',2.52),('11288','2013-01-03','10:45:00',2.44),('11288','2013-01-03','10:50:00',2.51),('11288','2013-01-03','10:55:00',2.43),('11288','2013-01-03','11:00:00',2.61),('11288','2013-01-03','11:05:00',2.47),('11288','2013-01-03','11:10:00',2.56),('11288','2013-01-03','11:15:00',2.28),('11288','2013-01-03','11:20:00',2.05),('11288','2013-01-03','11:25:00',1.6),('11288','2013-01-03','11:30:00',1.7),('11288','2013-01-03','11:35:00',1.69),('11288','2013-01-03','11:40:00',3.53),('11288','2013-01-03','11:45:00',3.71),('11288','2013-01-03','11:50:00',3.71),('11288','2013-01-03','11:55:00',3.67),('11288','2013-01-03','12:00:00',3.63),('11288','2013-01-03','12:05:00',3.61),('11288','2013-01-03','12:10:00',3.5),('11288','2013-01-03','12:15:00',3.35),('11288','2013-01-03','12:20:00',3.62),('11288','2013-01-03','12:25:00',3.61),('11288','2013-01-03','12:30:00',3.58),('11288','2013-01-03','12:35:00',3.56),('11288','2013-01-03','12:40:00',3.51),('11288','2013-01-03','12:45:00',3.51),('11288','2013-01-03','12:50:00',3.49),('11288','2013-01-03','12:55:00',3.45),('11288','2013-01-03','13:00:00',3.42),('11288','2013-01-03','13:05:00',3.36),('11288','2013-01-03','13:10:00',3.3),('11288','2013-01-03','13:15:00',3.24),('11288','2013-01-03','13:20:00',3.21),('11288','2013-01-03','13:25:00',3.15),('11288','2013-01-03','13:30:00',3.09),('11288','2013-01-03','13:35:00',3.04),('11288','2013-01-03','13:40:00',3),('11288','2013-01-03','13:45:00',2.91),('11288','2013-01-03','13:50:00',2.83),('11288','2013-01-03','13:55:00',2.74),('11288','2013-01-03','14:00:00',2.66),('11288','2013-01-03','14:05:00',2.59),('11288','2013-01-03','14:10:00',2.5),('11288','2013-01-03','14:15:00',2.43),('11288','2013-01-03','14:20:00',2.38),('11288','2013-01-03','14:25:00',2.27),('11288','2013-01-03','14:30:00',2.18),('11288','2013-01-03','14:35:00',2.08),('11288','2013-01-03','14:40:00',1.98),('11288','2013-01-03','14:45:00',1.89),('11288','2013-01-03','14:50:00',1.79),('11288','2013-01-03','14:55:00',1.71),('11288','2013-01-03','15:00:00',1.61),('11288','2013-01-03','15:05:00',1.45),('11288','2013-01-03','15:10:00',1.19),('11288','2013-01-03','15:15:00',1.21),('11288','2013-01-03','15:20:00',1.1),('11288','2013-01-02','09:40:00',1.11),('11288','2013-01-02','09:45:00',1.13),('11288','2013-01-02','09:50:00',1.08),('11288','2013-01-02','09:55:00',1.08),('11288','2013-01-02','10:00:00',1.19),('11288','2013-01-02','10:05:00',1.05),('11288','2013-01-02','11:10:00',1.11),('11288','2013-01-02','13:30:00',1.01),('11288','2013-01-02','13:40:00',1.51),('11288','2013-01-02','13:45:00',1.47),('11288','2013-01-02','13:50:00',1.37),('11288','2013-01-02','13:55:00',1.29),('11288','2013-01-02','14:00:00',1.21),('11288','2014-03-18','07:45:00',1.1),('11288','2014-03-18','07:50:00',1.56),('11288','2014-03-18','07:55:00',1.48),('11288','2014-03-18','08:00:00',1.32),('11288','2014-03-18','08:05:00',1.31),('11288','2014-03-18','08:10:00',1.48),('11288','2014-03-18','08:15:00',1.78),('11288','2014-03-18','08:20:00',2.08),('11288','2014-03-18','08:25:00',1.83),('11288','2014-03-18','08:30:00',1.67),('11288','2014-03-18','08:35:00',1.23),('11288','2014-03-18','08:40:00',1.47),('11288','2014-03-18','08:45:00',1.52),('11288','2014-03-18','08:50:00',3.14),('11288','2014-03-18','08:55:00',3.35),('11288','2014-03-18','09:00:00',3.15),('11288','2014-03-18','09:05:00',2.49),('11288','2014-03-18','09:10:00',3.21),('11288','2014-03-18','09:15:00',3.14),('11288','2014-03-18','09:20:00',3.2),('11288','2014-03-18','09:25:00',2.4),('11288','2014-03-18','09:30:00',3.94),('11288','2014-03-18','09:35:00',2.24),('11288','2014-03-18','09:40:00',1.9),('11288','2014-03-18','09:45:00',3.68),('11288','2014-03-18','09:50:00',2.78),('11288','2014-03-18','09:55:00',2.04),('11288','2014-03-18','10:00:00',3.96),('11288','2014-03-18','10:05:00',4.5),('11288','2014-03-18','10:10:00',4.13),('11288','2014-03-18','10:15:00',4.58),('11288','2014-03-18','10:20:00',5.14),('11288','2014-03-18','10:25:00',5.45),('11288','2014-03-18','10:30:00',4.77),('11288','2014-03-18','10:35:00',4.2),('11288','2014-03-18','10:40:00',3.59),('11288','2014-03-18','10:45:00',4.18),('11288','2014-03-18','10:50:00',4.8),('11288','2014-03-18','10:55:00',4.42),('11288','2014-03-18','11:00:00',3.33),('11288','2014-03-18','11:05:00',3.84),('11288','2014-03-18','11:10:00',2.83),('11288','2014-03-18','11:15:00',4.22),('11288','2014-03-18','11:20:00',4.75),('11288','2014-03-18','11:25:00',4.44),('11288','2014-03-18','11:30:00',4.81),('11288','2014-03-18','11:35:00',6.79),('11288','2014-03-18','11:40:00',3.07),('11288','2014-03-18','11:45:00',5.54),('11288','2014-03-18','11:50:00',4.63),('11288','2014-03-18','11:55:00',3.49),('11288','2014-03-18','12:00:00',4.4),('11288','2014-03-18','12:05:00',6.59),('11288','2014-03-18','12:10:00',3.12),('11288','2014-03-18','12:15:00',3.18),('11288','2014-03-18','12:20:00',2.44),('11288','2014-03-18','12:25:00',2.14),('11288','2014-03-18','12:30:00',3.27),('11288','2014-03-18','12:35:00',2.6),('11288','2014-03-18','12:40:00',3.86),('11288','2014-03-18','12:45:00',6.73),('11288','2014-03-18','12:50:00',6.42),('11288','2014-03-18','12:55:00',6.19),('11288','2014-03-18','13:00:00',6.15),('11288','2014-03-18','13:05:00',6.01),('11288','2014-03-18','13:10:00',5.99),('11288','2014-03-18','13:15:00',5.98),('11288','2014-03-18','13:20:00',5.23),('11288','2014-03-18','13:25:00',4.89),('11288','2014-03-18','13:30:00',5.69),('11288','2014-03-18','13:35:00',5.64),('11288','2014-03-18','13:40:00',5.65),('11288','2014-03-18','13:45:00',5.51),('11288','2014-03-18','13:50:00',5.51),('11288','2014-03-18','13:55:00',5.48),('11288','2014-03-18','14:00:00',5.35),('11288','2014-03-18','14:05:00',5.37),('11288','2014-03-18','14:10:00',5.31),('11288','2014-03-18','14:15:00',5.21),('11288','2014-03-18','14:20:00',5.12),('11288','2014-03-18','14:25:00',5.07),('11288','2014-03-18','14:30:00',5),('11288','2014-03-18','14:35:00',4.92),('11288','2014-03-18','14:40:00',4.77),('11288','2014-03-18','14:45:00',4.67),('11288','2014-03-18','14:50:00',4.58),('11288','2014-03-18','14:55:00',4.48),('11288','2014-03-18','15:00:00',4.33),('11288','2014-03-18','15:05:00',4.24),('11288','2014-03-18','15:10:00',4.12),('11288','2014-03-18','15:15:00',4.02),('11288','2014-03-18','15:20:00',3.89),('11288','2014-03-18','15:25:00',3.73),('11288','2014-03-18','15:30:00',3.61),('11288','2014-03-18','15:40:00',3.3),('11288','2014-03-18','15:45:00',3.2),('11288','2014-03-18','15:50:00',3.01),('11288','2014-03-18','15:57:00',2.87),('11288','2014-03-18','16:00:00',2.74),('11288','2014-03-18','16:05:00',2.6),('11288','2014-03-18','16:10:00',2.47),('11288','2014-03-18','16:15:00',2.27),('11288','2014-03-18','16:20:00',2.14),('11288','2014-03-18','16:25:00',2.03),('11288','2014-03-18','16:30:00',1.88),('11288','2014-03-18','16:35:00',1.74),('11288','2014-03-18','16:40:00',1.63),('11288','2014-03-18','16:45:00',1.5),('11288','2014-03-18','16:50:00',1.34),('11288','2014-03-18','16:55:00',1.24),('11288','2014-03-18','17:00:00',1.06),('11288','2013-01-01','08:50:00',1.06),('11288','2013-01-01','08:55:00',1.09),('11288','2013-01-01','09:00:00',1.27),('11288','2013-01-01','09:05:00',1.35),('11288','2013-01-01','09:10:00',1.45),('11288','2013-01-01','09:15:00',1.53),('11288','2013-01-01','09:20:00',1.66),('11288','2013-01-01','09:25:00',1.75),('11288','2013-01-01','09:30:00',1.82),('11288','2013-01-01','09:35:00',1.88),('11288','2013-01-01','09:40:00',1.96),('11288','2013-01-01','09:45:00',2.04),('11288','2013-01-01','09:50:00',2.13),('11288','2013-01-01','09:55:00',2.21),('11288','2013-01-01','10:00:00',2.26),('11288','2013-01-01','10:05:00',2.28),('11288','2013-01-01','10:10:00',2.24),('11288','2013-01-01','10:15:00',2.46),('11288','2013-01-01','10:20:00',2.59),('11288','2013-01-01','10:25:00',2.69),('11288','2013-01-01','10:30:00',2.77),('11288','2013-01-01','10:35:00',2.88),('11288','2013-01-01','10:40:00',3.01),('11288','2013-01-01','10:45:00',3.47),('11288','2013-01-01','10:50:00',3.71),('11288','2013-01-01','10:55:00',1.61),('11288','2013-01-01','11:00:00',1.22),('11288','2013-01-01','11:05:00',3.16),('11288','2013-01-01','11:10:00',3.1),('11288','2013-01-01','11:15:00',2.21),('11288','2013-01-01','11:20:00',2.21),('11288','2013-01-01','11:25:00',2.71),('11288','2013-01-01','11:30:00',3.97),('11288','2013-01-01','11:35:00',2.36),('11288','2013-01-01','11:40:00',2.75),('11288','2013-01-01','11:45:00',3.42),('11288','2013-01-01','11:50:00',2.25),('11288','2013-01-01','11:55:00',1.99),('11288','2013-01-01','12:00:00',2.24),('11288','2013-01-01','12:05:00',1.93),('11288','2013-01-01','12:10:00',2.12),('11288','2013-01-01','12:15:00',2.1),('11288','2013-01-01','12:20:00',2.15),('11288','2013-01-01','12:25:00',1.89),('11288','2013-01-01','12:30:00',1.81),('11288','2013-01-01','12:35:00',1.63),('11288','2013-01-01','12:40:00',1.97),('11288','2013-01-01','12:45:00',2.2),('11288','2013-01-01','12:50:00',2.49),('11288','2013-01-01','12:55:00',2.03),('11288','2013-01-01','13:00:00',1.91),('11288','2013-01-01','13:05:00',1.69),('11288','2013-01-01','13:10:00',1.41),('11288','2013-01-01','13:15:00',1.44),('11288','2013-01-01','13:20:00',1.46),('11288','2013-01-01','13:25:00',1.25),('11288','2013-01-01','13:30:00',1.07),('11288','2012-12-31','09:00:00',1.15),('11288','2012-12-31','09:05:00',1.19),('11288','2012-12-31','09:10:00',1.32),('11288','2012-12-31','09:15:00',1.6),('11288','2012-12-31','09:20:00',1.68),('11288','2012-12-31','09:25:00',1.93),('11288','2012-12-31','09:30:00',2.06),('11288','2012-12-31','10:00:00',1.73),('11288','2012-12-31','10:05:00',1.4),('11288','2012-12-31','10:10:00',2.45),('11288','2012-12-31','10:15:00',2.72),('11288','2012-12-31','10:20:00',2.79),('11288','2012-12-31','10:25:00',2.95),('11288','2012-12-31','10:30:00',3),('11288','2012-12-31','10:35:00',3.07),('11288','2012-12-31','10:40:00',3.09),('11288','2012-12-31','10:45:00',3.07),('11288','2012-12-31','10:50:00',3.16),('11288','2012-12-31','10:55:00',3.25),('11288','2012-12-31','11:00:00',3.32),('11288','2012-12-31','11:05:00',3.27),('11288','2012-12-31','11:10:00',3.28),('11288','2012-12-31','11:15:00',3.45),('11288','2012-12-31','11:20:00',3.5),('11288','2012-12-31','11:25:00',3.51),('11288','2012-12-31','11:30:00',3.31),('11288','2012-12-31','11:35:00',3.14),('11288','2012-12-31','11:40:00',3.59),('11288','2012-12-31','11:45:00',3.67),('11288','2012-12-31','11:50:00',3.68),('11288','2012-12-31','11:55:00',3.68),('11288','2012-12-31','12:00:00',3.67),('11288','2012-12-31','12:05:00',3.68),('11288','2012-12-31','12:10:00',3.73),('11288','2012-12-31','12:15:00',3.72),('11288','2012-12-31','12:20:00',3.72),('11288','2012-12-31','12:25:00',3.69),('11288','2012-12-31','12:30:00',3.68),('11288','2012-12-31','12:35:00',3.64),('11288','2012-12-31','12:40:00',3.58),('11288','2012-12-31','12:45:00',3.61),('11288','2012-12-31','12:50:00',3.58),('11288','2012-12-31','12:55:00',3.53),('11288','2012-12-31','13:00:00',3.47),('11288','2012-12-31','13:05:00',3.41),('11288','2012-12-31','13:10:00',3.36),('11288','2012-12-31','13:15:00',3.32),('11288','2012-12-31','13:20:00',3.29),('11288','2012-12-31','13:25:00',3.2),('11288','2012-12-31','13:30:00',3.16),('11288','2012-12-31','13:35:00',3.1),('11288','2012-12-31','13:40:00',3.05),('11288','2012-12-31','13:45:00',2.94),('11288','2012-12-31','13:50:00',2.81),('11288','2012-12-31','13:55:00',2.75),('11288','2012-12-31','14:00:00',2.69),('11288','2012-12-31','14:05:00',2.57),('11288','2012-12-31','14:10:00',2.5),('11288','2012-12-31','14:15:00',2.44),('11288','2012-12-31','14:20:00',2.34),('11288','2012-12-31','14:25:00',2.22),('11288','2012-12-31','14:30:00',2.13),('11288','2012-12-31','14:35:00',2.04),('11288','2012-12-31','14:40:00',1.96),('11288','2012-12-31','14:45:00',1.86),('11288','2012-12-31','14:50:00',1.77),('11288','2012-12-31','14:55:00',1.66),('11288','2012-12-31','15:00:00',1.58),('11288','2012-12-31','15:05:00',1.41),('11288','2012-12-31','15:10:00',1.32),('11288','2012-12-31','15:15:00',1.21),('11288','2012-12-31','15:20:00',1.06),('11288','2012-12-30','08:45:00',1),('11288','2012-12-30','08:50:00',1.11),('11288','2012-12-30','08:55:00',1.13),('11288','2012-12-30','09:00:00',1.3),('11288','2012-12-30','09:05:00',1.4),('11288','2012-12-30','09:10:00',1.5),('11288','2012-12-30','09:15:00',1.61),('11288','2012-12-30','09:20:00',1.72),('11288','2012-12-30','09:25:00',1.8),('11288','2012-12-30','09:30:00',1.89),('11288','2012-12-30','09:35:00',1.95),('11288','2012-12-30','09:40:00',2.03),('11288','2012-12-30','09:45:00',2.11),('11288','2012-12-30','09:50:00',2.19),('11288','2012-12-30','09:55:00',2.25),('11288','2012-12-30','10:00:00',2.32),('11288','2012-12-30','10:05:00',2.33),('11288','2012-12-30','10:10:00',2.29),('11288','2012-12-30','10:15:00',2.59),('11288','2012-12-30','10:20:00',2.72),('11288','2012-12-30','10:25:00',2.81),('11288','2012-12-30','10:30:00',2.88),('11288','2012-12-30','10:35:00',2.95),('11288','2012-12-30','10:40:00',2.98),('11288','2012-12-30','10:45:00',3.08),('11288','2012-12-30','10:50:00',3.15),('11288','2012-12-30','10:55:00',3.22),('11288','2012-12-30','11:00:00',3.28),('11288','2012-12-30','11:05:00',3.36),('11288','2012-12-30','11:10:00',3.4),('11288','2012-12-30','11:15:00',3.43),('11288','2012-12-30','11:20:00',3.47),('11288','2012-12-30','11:25:00',3.42),('11288','2012-12-30','11:30:00',3.49),('11288','2012-12-30','11:35:00',3.54),('11288','2012-12-30','11:40:00',3.55),('11288','2012-12-30','11:45:00',3.62),('11288','2012-12-30','11:50:00',3.63),('11288','2012-12-30','11:55:00',3.64),('11288','2012-12-30','12:00:00',3.64),('11288','2012-12-30','12:05:00',3.57),('11288','2012-12-30','12:10:00',3.39),('11288','2012-12-30','12:15:00',3.56),('11288','2012-12-30','12:20:00',3.59),('11288','2012-12-30','12:25:00',3.56),('11288','2012-12-30','12:30:00',3.53),('11288','2012-12-30','12:35:00',3.52),('11288','2012-12-30','12:40:00',3.47),('11288','2012-12-30','12:45:00',3.44),('11288','2012-12-30','12:50:00',3.41),('11288','2012-12-30','12:55:00',3.43),('11288','2012-12-30','13:00:00',3.43),('11288','2012-12-30','13:05:00',3.38),('11288','2012-12-30','13:10:00',3.32),('11288','2012-12-30','13:15:00',3.3),('11288','2012-12-30','13:20:00',3.27),('11288','2012-12-30','13:25:00',3.2),('11288','2012-12-30','13:30:00',3.11),('11288','2012-12-30','13:35:00',3.08),('11288','2012-12-30','13:40:00',3.03),('11288','2012-12-30','13:45:00',2.92),('11288','2012-12-30','13:50:00',2.84),('11288','2012-12-30','13:55:00',2.78),('11288','2012-12-30','14:00:00',2.7),('11288','2012-12-30','14:05:00',2.61),('11288','2012-12-30','14:10:00',2.53),('11288','2012-12-30','14:15:00',2.44),('11288','2012-12-30','14:20:00',2.34),('11288','2012-12-30','14:25:00',2.23),('11288','2012-12-30','14:30:00',2.13),('11288','2012-12-30','14:35:00',2.03),('11288','2012-12-30','14:40:00',1.92),('11288','2012-12-30','14:45:00',1.83),('11288','2012-12-30','14:50:00',1.73),('11288','2012-12-30','14:55:00',1.63),('11288','2012-12-30','15:00:00',1.54),('11288','2012-12-30','15:05:00',1.37),('11288','2012-12-30','15:10:00',1.16),('11288','2012-12-30','15:15:00',1.2),('11288','2012-12-30','15:20:00',1.05),('11288','2012-12-29','08:50:00',1.1),('11288','2012-12-29','08:55:00',1.09),('11288','2012-12-29','09:00:00',1.26),('11288','2012-12-29','09:05:00',1.36),('11288','2012-12-29','09:10:00',1.45),('11288','2012-12-29','09:15:00',1.55),('11288','2012-12-29','09:20:00',1.66),('11288','2012-12-29','09:25:00',1.74),('11288','2012-12-29','09:30:00',1.8),('11288','2012-12-29','09:35:00',1.88),('11288','2012-12-29','09:40:00',1.97),('11288','2012-12-29','09:45:00',2.08),('11288','2012-12-29','09:50:00',2.2),('11288','2012-12-29','09:55:00',2.28),('11288','2012-12-29','10:00:00',2.35),('11288','2012-12-29','10:05:00',2.38),('11288','2012-12-29','10:10:00',2.29),('11288','2012-12-29','10:15:00',2.61),('11288','2012-12-29','10:20:00',2.76),('11288','2012-12-29','10:25:00',2.85),('11288','2012-12-29','10:30:00',2.9),('11288','2012-12-29','10:35:00',2.96),('11288','2012-12-29','10:40:00',2.96),('11288','2012-12-29','10:45:00',3.09),('11288','2012-12-29','10:50:00',3.21),('11288','2012-12-29','10:55:00',3.29),('11288','2012-12-29','11:00:00',3.32),('11288','2012-12-29','11:05:00',3.38),('11288','2012-12-29','11:10:00',3.42),('11288','2012-12-29','11:15:00',3.46),('11288','2012-12-29','11:20:00',3.53),('11288','2012-12-29','11:25:00',3.46),('11288','2012-12-29','11:30:00',3.5),('11288','2012-12-29','11:35:00',3.61),('11288','2012-12-29','11:40:00',3.62),('11288','2012-12-29','11:45:00',3.64),('11288','2012-12-29','11:50:00',3.66),('11288','2012-12-29','11:55:00',3.66),('11288','2012-12-29','12:00:00',3.67),('11288','2012-12-29','12:05:00',3.64),('11288','2012-12-29','12:10:00',3.48),('11288','2012-12-29','12:15:00',3.61),('11288','2012-12-29','12:20:00',3.65),('11288','2012-12-29','12:25:00',3.64),('11288','2012-12-29','12:30:00',3.61),('11288','2012-12-29','12:35:00',3.58),('11288','2012-12-29','12:40:00',3.58),('11288','2012-12-29','12:45:00',3.57),('11288','2012-12-29','12:50:00',3.49),('11288','2012-12-29','12:55:00',3.48),('11288','2012-12-29','13:00:00',3.48),('11288','2012-12-29','13:05:00',3.44),('11288','2012-12-29','13:10:00',3.39),('11288','2012-12-29','13:15:00',3.33),('11288','2012-12-29','13:20:00',3.28),('11288','2012-12-29','13:25:00',3.22),('11288','2012-12-29','13:30:00',3.17),('11288','2012-12-29','13:35:00',3.13),('11288','2012-12-29','13:40:00',3.06),('11288','2012-12-29','13:45:00',2.93),('11288','2012-12-29','13:50:00',2.84),('11288','2012-12-29','13:55:00',2.78),('11288','2012-12-29','14:00:00',2.72),('11288','2012-12-29','14:05:00',2.62),('11288','2012-12-29','14:10:00',2.55),('11288','2012-12-29','14:15:00',2.46),('11288','2012-12-29','14:20:00',2.38),('11288','2012-12-29','14:25:00',2.27),('11288','2012-12-29','14:30:00',2.16),('11288','2012-12-29','14:35:00',2.06),('11288','2012-12-29','14:40:00',1.96),('11288','2012-12-29','14:45:00',1.86),('11288','2012-12-29','14:50:00',1.77),('11288','2012-12-29','14:55:00',1.66),('11288','2012-12-29','15:00:00',1.58),('11288','2012-12-29','15:05:00',1.39),('11288','2012-12-29','15:10:00',1.22),('11288','2012-12-29','15:15:00',1.23),('11288','2012-12-29','15:20:00',1.04),('11288','2012-12-28','08:50:00',1.02),('11288','2012-12-28','08:55:00',1.09),('11288','2012-12-28','09:00:00',1.19),('11288','2012-12-28','09:05:00',1.33),('11288','2012-12-28','09:10:00',1.43),('11288','2012-12-28','09:15:00',1.56),('11288','2012-12-28','09:20:00',1.65),('11288','2012-12-28','09:25:00',1.72),('11288','2012-12-28','09:30:00',1.74),('11288','2012-12-28','09:35:00',1.82),('11288','2012-12-28','09:40:00',1.91),('11288','2012-12-28','09:45:00',1.97),('11288','2012-12-28','09:50:00',2.06),('11288','2012-12-28','09:55:00',2.1),('11288','2012-12-28','10:00:00',2.15),('11288','2012-12-28','10:05:00',2.2),('11288','2012-12-28','10:10:00',2.13),('11288','2012-12-28','10:15:00',2.24),('11288','2012-12-28','10:20:00',2.58),('11288','2012-12-28','10:25:00',2.7),('11288','2012-12-28','10:30:00',2.73),('11288','2012-12-28','10:35:00',2.85),('11288','2012-12-28','10:40:00',2.82),('11288','2012-12-28','10:45:00',2.83),('11288','2012-12-28','10:50:00',3),('11288','2012-12-28','10:55:00',3.12),('11288','2012-12-28','11:00:00',3.15),('11288','2012-12-28','11:05:00',3.21),('11288','2012-12-28','11:10:00',3.3),('11288','2012-12-28','11:15:00',3.34),('11288','2012-12-28','11:20:00',3.35),('11288','2012-12-28','11:25:00',3.33),('11288','2012-12-28','11:30:00',3.2),('11288','2012-12-28','11:35:00',3.39),('11288','2012-12-28','11:40:00',3.47),('11288','2012-12-28','11:45:00',3.26),('11288','2012-12-28','11:50:00',3.48),('11288','2012-12-28','11:55:00',3.57),('11288','2012-12-28','12:00:00',3.64),('11288','2012-12-28','12:05:00',3.5),('11288','2012-12-28','12:10:00',3.44),('11288','2012-12-28','12:15:00',3.53),('11288','2012-12-28','12:20:00',3.52),('11288','2012-12-28','12:25:00',3.53),('11288','2012-12-28','12:30:00',3.49),('11288','2012-12-28','12:35:00',3.42),('11288','2012-12-28','12:40:00',3.44),('11288','2012-12-28','12:45:00',3.42),('11288','2012-12-28','12:50:00',3.37),('11288','2012-12-28','12:55:00',3.22),('11288','2012-12-28','13:00:00',3.23),('11288','2012-12-28','13:05:00',3.21),('11288','2012-12-28','13:10:00',3.18),('11288','2012-12-28','13:15:00',3.14),('11288','2012-12-28','13:20:00',3.07),('11288','2012-12-28','13:25:00',3.05),('11288','2012-12-28','13:30:00',2.86),('11288','2012-12-28','13:35:00',2.33),('11288','2012-12-28','13:40:00',2.81),('11288','2012-12-28','13:45:00',2.71),('11288','2012-12-28','13:50:00',2.64),('11288','2012-12-28','13:55:00',2.54),('11288','2012-12-28','14:00:00',2.47),('11288','2012-12-28','14:05:00',2.31),('11288','2012-12-28','14:10:00',2.28),('11288','2012-12-28','14:15:00',2.24),('11288','2012-12-28','14:20:00',2.13),('11288','2012-12-28','14:25:00',2.03),('11288','2012-12-28','14:30:00',1.92),('11288','2012-12-28','14:35:00',1.15),('11288','2012-12-28','14:40:00',1.58),('11288','2012-12-28','14:45:00',1.71),('11288','2012-12-28','14:50:00',1.61),('11288','2012-12-28','14:55:00',1.51),('11288','2012-12-28','15:00:00',1.44),('11288','2012-12-28','15:05:00',1.27),('11288','2012-12-28','15:10:00',1.08),('11288','2012-12-28','15:15:00',1.12),('11288','2012-12-28','15:20:00',1.02),('11288','2012-12-27','09:15:00',1.03),('11288','2012-12-27','09:20:00',1.41),('11288','2012-12-27','09:25:00',1.65),('11288','2012-12-27','09:30:00',1.81),('11288','2012-12-27','09:35:00',1.95),('11288','2012-12-27','09:40:00',1.95),('11288','2012-12-27','09:45:00',2.16),('11288','2012-12-27','09:50:00',2.52),('11288','2012-12-27','09:55:00',2.23),('11288','2012-12-27','10:00:00',1.93),('11288','2012-12-27','10:05:00',2.1),('11288','2012-12-27','10:10:00',2.11),('11288','2012-12-27','10:15:00',2.21),('11288','2012-12-27','10:20:00',2.4),('11288','2012-12-27','10:25:00',2.51),('11288','2012-12-27','10:30:00',2.61),('11288','2012-12-27','10:35:00',2.55),('11288','2012-12-27','10:40:00',2.68),('11288','2012-12-27','10:45:00',2.74),('11288','2012-12-27','10:50:00',2.93),('11288','2012-12-27','10:55:00',1.97),('11288','2012-12-27','11:00:00',2.55),('11288','2012-12-27','11:05:00',2.59),('11288','2012-12-27','11:10:00',2.18),('11288','2012-12-27','11:15:00',1.38),('11288','2012-12-27','11:20:00',1.09),('11288','2012-12-27','11:50:00',3.12),('11288','2012-12-27','11:55:00',3.27),('11288','2012-12-27','12:00:00',3.53),('11288','2012-12-27','12:05:00',3.64),('11288','2012-12-27','12:10:00',3.37),('11288','2012-12-27','12:15:00',1.97),('11288','2012-12-27','12:20:00',1.9),('11288','2012-12-27','12:25:00',2.99),('11288','2012-12-27','12:30:00',3.39),('11288','2012-12-27','12:35:00',3.36),('11288','2012-12-27','12:40:00',3.53),('11288','2012-12-27','12:45:00',3.94),('11288','2012-12-27','12:50:00',3.37),('11288','2012-12-27','12:55:00',3),('11288','2012-12-27','13:00:00',3.43),('11288','2012-12-27','13:05:00',3.57),('11288','2012-12-27','13:10:00',3.54),('11288','2012-12-27','13:15:00',3.74),('11288','2012-12-27','13:20:00',3.7),('11288','2012-12-27','13:25:00',3.53),('11288','2012-12-27','13:30:00',2.97),('11288','2012-12-27','13:55:00',1.2),('11288','2012-12-27','14:00:00',2.94),('11288','2012-12-27','14:05:00',2.48),('11288','2012-12-27','14:10:00',2.6),('11288','2012-12-27','14:15:00',1.95),('11288','2012-12-27','14:20:00',2.1),('11288','2012-12-27','14:25:00',2.12),('11288','2012-12-27','14:30:00',2.04),('11288','2012-12-27','14:35:00',1.9),('11288','2012-12-27','14:40:00',1.81),('11288','2012-12-27','14:45:00',1.04),('11288','2012-12-27','14:55:00',1.61),('11288','2012-12-27','15:00:00',1.42),('11288','2012-12-27','15:05:00',1.19),('11288','2012-12-26','09:15:00',1.12),('11288','2012-12-26','09:20:00',1.47),('11288','2012-12-26','09:25:00',1.75),('11288','2012-12-26','09:30:00',1.78),('11288','2012-12-26','09:35:00',1.85),('11288','2012-12-26','09:40:00',1.94),('11288','2012-12-26','09:45:00',2.01),('11288','2012-12-26','09:50:00',2.09),('11288','2012-12-26','09:55:00',2.15),('11288','2012-12-26','10:00:00',2.19),('11288','2012-12-26','10:05:00',2.24),('11288','2012-12-26','10:10:00',2.32),('11288','2012-12-26','10:15:00',2.41),('11288','2012-12-26','10:20:00',2.55),('11288','2012-12-26','10:25:00',2.6),('11288','2012-12-26','10:30:00',2.66),('11288','2012-12-26','10:35:00',2.72),('11288','2012-12-26','10:40:00',2.71),('11288','2012-12-26','10:45:00',2.68),('11288','2012-12-26','10:50:00',2.9),('11288','2012-12-26','10:55:00',2.97),('11288','2012-12-26','11:00:00',3.03),('11288','2012-12-26','11:05:00',3.08),('11288','2012-12-26','11:10:00',3.11),('11288','2012-12-26','11:15:00',3.13),('11288','2012-12-26','11:20:00',3.2),('11288','2012-12-26','11:25:00',3.11),('11288','2012-12-26','11:30:00',2.93),('11288','2012-12-26','11:35:00',2.95),('11288','2012-12-26','11:40:00',3.33),('11288','2012-12-26','11:45:00',3.36),('11288','2012-12-26','11:50:00',3.43),('11288','2012-12-26','11:55:00',3.49),('11288','2012-12-26','12:00:00',3.5),('11288','2012-12-26','12:05:00',3.48),('11288','2012-12-26','12:10:00',3.51),('11288','2012-12-26','12:15:00',3.47),('11288','2012-12-26','12:20:00',3.5),('11288','2012-12-26','12:25:00',3.51),('11288','2012-12-26','12:30:00',3.48),('11288','2012-12-26','12:35:00',3.42),('11288','2012-12-26','12:40:00',3.44),('11288','2012-12-26','12:45:00',3.43),('11288','2012-12-26','12:50:00',3.29),('11288','2012-12-26','12:55:00',2.93),('11288','2012-12-26','13:00:00',3.38),('11288','2012-12-26','13:05:00',2.35),('11288','2012-12-26','13:10:00',3.33),('11288','2012-12-26','13:15:00',3),('11288','2012-12-26','13:20:00',3.46),('11288','2012-12-26','13:25:00',3.17),('11288','2012-12-26','13:30:00',3.6),('11288','2012-12-26','13:35:00',3.68),('11288','2012-12-26','13:40:00',3.66),('11288','2012-12-26','13:45:00',3.6),('11288','2012-12-26','13:50:00',2.89),('11288','2012-12-26','13:55:00',3.13),('11288','2012-12-26','14:00:00',2.92),('11288','2012-12-26','14:05:00',2.82),('11288','2012-12-26','14:10:00',1.86),('11288','2012-12-25','10:05:00',1.11),('11288','2012-12-25','10:10:00',1.24),('11288','2012-12-25','10:15:00',1.26),('11288','2012-12-25','10:20:00',1.31),('11288','2012-12-25','10:25:00',1.37),('11288','2012-12-25','10:30:00',1.35),('11288','2012-12-25','10:35:00',1.31),('11288','2012-12-25','10:40:00',1.26),('11288','2012-12-25','10:45:00',1.27),('11288','2012-12-25','10:50:00',1.26),('11288','2012-12-25','10:55:00',1.28),('11288','2012-12-25','11:00:00',1.33),('11288','2012-12-25','11:05:00',1.44),('11288','2012-12-25','11:10:00',1.52),('11288','2012-12-25','11:15:00',1.42),('11288','2012-12-25','11:20:00',1.51),('11288','2012-12-25','11:25:00',1.65),('11288','2012-12-25','11:30:00',1.58),('11288','2012-12-25','11:35:00',1.57),('11288','2012-12-25','11:40:00',1.5),('11288','2012-12-25','11:45:00',1.55),('11288','2012-12-25','11:50:00',1.52),('11288','2012-12-25','11:55:00',1.61),('11288','2012-12-25','12:00:00',1.59),('11288','2012-12-25','12:05:00',1.43),('11288','2012-12-25','12:10:00',1.4),('11288','2012-12-25','12:15:00',1.44),('11288','2012-12-25','12:20:00',1.52),('11288','2012-12-25','12:25:00',1.48),('11288','2012-12-25','12:30:00',1.39),('11288','2012-12-25','12:35:00',1.28),('11288','2012-12-25','12:40:00',1.33),('11288','2012-12-25','12:45:00',1.28),('11288','2012-12-25','12:50:00',1.33),('11288','2012-12-25','12:55:00',1.35),('11288','2012-12-25','13:00:00',1.34),('11288','2012-12-25','13:05:00',1.45),('11288','2012-12-25','13:10:00',1.63),('11288','2012-12-25','13:15:00',1.68),('11288','2012-12-25','13:20:00',1.61),('11288','2012-12-25','13:25:00',1.46),('11288','2012-12-25','13:30:00',1.28),('11288','2012-12-25','13:35:00',1.22),('11288','2012-12-25','13:40:00',1.18),('11288','2012-12-25','13:45:00',1.01),('11288','2012-12-25','14:55:00',1.09),('11288','2012-12-25','15:00:00',1.07),('11288','2012-12-24','11:15:00',1.09),('11288','2012-12-24','11:20:00',1.11),('11288','2012-12-24','11:25:00',1.1),('11288','2012-12-24','11:30:00',1.18),('11288','2012-12-24','11:35:00',1.2),('11288','2012-12-24','11:40:00',1.14),('11288','2012-12-24','11:45:00',1.05),('11288','2012-12-24','11:55:00',1.06),('11288','2012-12-24','12:00:00',1.22),('11288','2012-12-24','12:05:00',1.41),('11288','2012-12-24','12:10:00',1.45),('11288','2012-12-24','12:15:00',1.37),('11288','2012-12-24','12:20:00',1.37),('11288','2012-12-24','12:25:00',1.36),('11288','2012-12-24','12:30:00',1.3),('11288','2012-12-24','12:35:00',1.29),('11288','2012-12-24','12:40:00',1.31),('11288','2012-12-24','12:45:00',1.23),('11288','2012-12-24','12:50:00',1.16),('11288','2012-12-24','12:55:00',1.14),('11288','2012-12-24','13:00:00',1.09),('11288','2012-12-24','13:10:00',1.01),('11288','2012-12-23','08:45:00',1.02),('11288','2012-12-23','08:50:00',1.06),('11288','2012-12-23','08:55:00',1.24),('11288','2012-12-23','09:00:00',1.35),('11288','2012-12-23','09:05:00',1.47),('11288','2012-12-23','09:10:00',1.57),('11288','2012-12-23','09:15:00',1.62),('11288','2012-12-23','09:20:00',1.7),('11288','2012-12-23','09:25:00',1.8),('11288','2012-12-23','09:30:00',1.84),('11288','2012-12-23','09:35:00',1.92),('11288','2012-12-23','09:40:00',2.02),('11288','2012-12-23','09:45:00',2.1),('11288','2012-12-23','09:50:00',2.16),('11288','2012-12-23','09:55:00',2.22),('11288','2012-12-23','10:00:00',2.25),('11288','2012-12-23','10:05:00',2.24),('11288','2012-12-23','10:10:00',2.3),('11288','2012-12-23','10:15:00',2.57),('11288','2012-12-23','10:20:00',2.67),('11288','2012-12-23','10:25:00',2.65),('11288','2012-12-23','10:30:00',2.64),('11288','2012-12-23','10:35:00',2.71),('11288','2012-12-23','10:40:00',2.79),('11288','2012-12-23','10:45:00',2.96),('11288','2012-12-23','10:50:00',2.96),('11288','2012-12-23','10:55:00',2.87),('11288','2012-12-23','11:00:00',3.11),('11288','2012-12-23','11:05:00',3.17),('11288','2012-12-23','11:10:00',3.18),('11288','2012-12-23','11:15:00',3.28),('11288','2012-12-23','11:20:00',3.37),('11288','2012-12-23','11:25:00',3.05),('11288','2012-12-23','11:30:00',3.23),('11288','2012-12-23','11:35:00',3.44),('11288','2012-12-23','11:40:00',3.5),('11288','2012-12-23','11:45:00',3.45),('11288','2012-12-23','11:50:00',3.59),('11288','2012-12-23','11:55:00',3.36),('11288','2012-12-23','12:00:00',3.17),('11288','2012-12-23','12:05:00',3.12),('11288','2012-12-23','12:10:00',3.02),('11288','2012-12-23','12:15:00',2.42),('11288','2012-12-23','12:20:00',2.93),('11288','2012-12-23','12:25:00',1.63),('11288','2012-12-23','12:30:00',1.83),('11288','2012-12-23','12:35:00',1.9),('11288','2012-12-23','12:40:00',2.18),('11288','2012-12-23','12:45:00',1.61),('11288','2012-12-23','12:50:00',1.92),('11288','2012-12-23','12:55:00',2.92),('11288','2012-12-23','13:00:00',3.44),('11288','2012-12-23','13:05:00',2.93),('11288','2012-12-23','13:10:00',2.98),('11288','2012-12-23','13:15:00',2.52),('11288','2012-12-23','13:20:00',2.06),('11288','2012-12-23','13:25:00',1.83),('11288','2012-12-23','13:30:00',1.68),('11288','2012-12-23','13:35:00',1.77),('11288','2012-12-23','13:40:00',2.06),('11288','2012-12-23','13:45:00',2.25),('11288','2012-12-23','13:50:00',2.03),('11288','2012-12-23','13:55:00',1.91),('11288','2012-12-23','14:00:00',2.66),('11288','2012-12-23','14:05:00',2.36),('11288','2012-12-23','14:10:00',2.13),('11288','2012-12-23','14:15:00',2.22),('11288','2012-12-23','14:20:00',1.7),('11288','2012-12-23','14:25:00',1.36),('11288','2012-12-23','14:30:00',1.29),('11288','2012-12-23','14:35:00',1.57),('11288','2012-12-23','14:40:00',1.73),('11288','2012-12-23','14:45:00',1.71),('11288','2012-12-23','14:50:00',1.24),('11288','2014-05-01','07:50:00',1.18),('11288','2014-05-01','07:55:00',1.54),('11288','2014-05-01','08:00:00',1.62),('11288','2014-05-01','08:05:00',1.79),('11288','2014-05-01','08:10:00',1.87),('11288','2014-05-01','08:15:00',2.12),('11288','2014-05-01','08:20:00',2.24),('11288','2014-05-01','08:25:00',2.36),('11288','2014-05-01','08:30:00',2.25),('11288','2014-05-01','08:35:00',2.4),('11288','2014-05-01','08:40:00',2.83),('11288','2014-05-01','08:45:00',2.79),('11288','2014-05-01','08:50:00',3.19),('11288','2014-05-01','08:55:00',3.49),('11288','2014-05-01','09:00:00',2.16),('11288','2014-05-01','09:05:00',2.29),('11288','2014-05-01','09:10:00',3.7),('11288','2014-05-01','09:15:00',3.29),('11288','2014-05-01','09:20:00',2.32),('11288','2014-05-01','09:25:00',3.08),('11288','2014-05-01','09:30:00',4.6),('11288','2014-05-01','09:35:00',5.03),('11288','2014-05-01','09:40:00',5.68),('11288','2014-05-01','09:45:00',3.95),('11288','2014-05-01','09:50:00',4.35),('11288','2014-05-01','09:55:00',4.52),('11288','2014-05-01','10:00:00',2.9),('11288','2014-05-01','10:05:00',2.27),('11288','2014-05-01','10:10:00',2.99),('11288','2014-05-01','10:15:00',5.43),('11288','2014-05-01','10:20:00',4.82),('11288','2014-05-01','10:25:00',2.12),('11288','2014-05-01','10:30:00',4.57),('11288','2014-05-01','10:35:00',5.39),('11288','2014-05-01','10:40:00',4.64),('11288','2014-05-01','10:45:00',6.27),('11288','2014-05-01','10:50:00',6.85),('11288','2014-05-01','10:55:00',7.19),('11288','2014-05-01','11:00:00',3.8),('11288','2014-05-01','11:05:00',3.87),('11288','2014-05-01','11:10:00',5.7),('11288','2014-05-01','11:15:00',1.52),('11288','2014-05-01','11:20:00',2.89),('11288','2014-05-01','11:25:00',7.65),('11288','2014-05-01','11:30:00',6.25),('11288','2014-05-01','11:35:00',7.09),('11288','2014-05-01','11:40:00',1.95),('11288','2014-05-01','11:45:00',6.88),('11288','2014-05-01','11:50:00',7.83),('11288','2014-05-01','11:55:00',3.48),('11288','2014-05-01','12:00:00',1.63),('11288','2014-05-01','12:05:00',5.38),('11288','2014-05-01','12:10:00',7.79),('11288','2014-05-01','12:15:00',7.51),('11288','2014-05-01','12:20:00',7.6),('11288','2014-05-01','12:25:00',7.69),('11288','2014-05-01','12:30:00',3.15),('11288','2014-05-01','12:35:00',6.03),('11288','2014-05-01','12:40:00',8.01),('11288','2014-05-01','12:45:00',4.71),('11288','2014-05-01','12:50:00',7.31),('11288','2014-05-01','12:55:00',7.69),('11288','2014-05-01','13:00:00',7.88),('11288','2014-05-01','13:05:00',7.64),('11288','2014-05-01','13:10:00',7.82),('11288','2014-05-01','13:15:00',7.6),('11288','2014-05-01','13:20:00',6.43),('11288','2014-05-01','13:25:00',3.76),('11288','2014-05-01','13:30:00',2.75),('11288','2014-05-01','13:35:00',3.3),('11288','2014-05-01','13:40:00',7.84),('11288','2014-05-01','13:45:00',8.06),('11288','2014-05-01','13:50:00',8.1),('11288','2014-05-01','13:55:00',6.46),('11288','2014-05-01','14:00:00',5.7),('11288','2014-05-01','14:05:00',7.53),('11288','2014-05-01','14:10:00',7.3),('11288','2014-05-01','14:15:00',7.18),('11288','2014-05-01','14:20:00',7.04),('11288','2014-05-01','14:25:00',7.01),('11288','2014-05-01','14:30:00',6.74),('11288','2014-05-01','14:35:00',6.67),('11288','2014-05-01','14:40:00',7.12),('11288','2014-05-01','14:45:00',7.13),('11288','2014-05-01','14:50:00',7.04),('11288','2014-05-01','14:55:00',6.24),('11288','2014-05-01','15:00:00',6.27),('11288','2014-05-01','15:05:00',6.98),('11288','2014-05-01','15:10:00',6.38),('11288','2014-05-01','15:15:00',5.2),('11288','2014-05-01','15:20:00',6.48),('11288','2014-05-01','15:25:00',6.34),('11288','2014-05-01','15:30:00',6.21),('11288','2014-05-01','15:35:00',6.12),('11288','2014-05-01','15:40:00',6.05),('11288','2014-05-01','15:45:00',5.79),('11288','2014-05-01','15:50:00',5.95),('11288','2014-05-01','15:55:00',5.66),('11288','2014-05-01','16:00:00',5.66),('11288','2014-05-01','16:05:00',5.61),('11288','2014-05-01','16:10:00',5.35),('11288','2014-05-01','16:15:00',5.31),('11288','2014-05-01','16:20:00',5.03),('11288','2014-05-01','16:25:00',4.59),('11288','2014-05-01','16:30:00',4.84),('11288','2014-05-01','16:35:00',4.9),('11288','2014-05-01','16:40:00',4.57),('11288','2014-05-01','16:45:00',3.83),('11288','2014-05-01','16:50:00',3.25),('11288','2014-05-01','16:55:00',4.07),('11288','2014-05-01','17:00:00',3.86),('11288','2014-05-01','17:05:00',3.68),('11288','2014-05-01','17:10:00',4),('11288','2014-05-01','17:15:00',3.76),('11288','2014-05-01','17:20:00',3.55),('11288','2014-05-01','17:25:00',3.39),('11288','2014-05-01','17:30:00',3.27),('11288','2014-05-01','17:35:00',3.13),('11288','2014-05-01','17:40:00',2.96),('11288','2014-05-01','17:45:00',2.8),('11288','2014-05-01','17:50:00',2.59),('11288','2014-05-01','17:55:00',2.43),('11288','2014-05-01','18:00:00',2.45),('11288','2014-05-01','18:05:00',2.26),('11288','2014-05-01','18:10:00',2.06),('11288','2014-05-01','18:15:00',2.03),('11288','2014-05-01','18:20:00',1.92),('11288','2014-05-01','18:25:00',1.74),('11288','2014-05-01','18:30:00',1.59),('11288','2014-05-01','18:35:00',1.41),('11288','2014-05-01','18:40:00',1.29),('11288','2014-05-01','18:45:00',1.12),('11288','2014-03-17','08:30:00',1.06),('11288','2014-03-17','08:35:00',1.07),('11288','2014-03-17','08:40:00',1.22),('11288','2014-03-17','08:45:00',1.29),('11288','2014-03-17','08:50:00',1.39),('11288','2014-03-17','08:55:00',1.46),('11288','2014-03-17','09:00:00',1.6),('11288','2014-03-17','09:05:00',1.65),('11288','2014-03-17','09:10:00',1.86),('11288','2014-03-17','09:15:00',2.11),('11288','2014-03-17','09:20:00',2.13),('11288','2014-03-17','09:25:00',2.55),('11288','2014-03-17','09:30:00',2.69),('11288','2014-03-17','09:35:00',2.32),('11288','2014-03-17','09:40:00',2.11),('11288','2014-03-17','09:45:00',2.23),('11288','2014-03-17','09:50:00',3.56),('11288','2014-03-17','09:55:00',3.16),('11288','2014-03-17','10:00:00',3.29),('11288','2014-03-17','10:05:00',2.98),('11288','2014-03-17','10:10:00',2.78),('11288','2014-03-17','10:15:00',2.97),('11288','2014-03-17','10:20:00',3.16),('11288','2014-03-17','10:25:00',2.77),('11288','2014-03-17','10:30:00',2.42),('11288','2014-03-17','10:35:00',2.2),('11288','2014-03-17','10:40:00',2.51),('11288','2014-03-17','10:45:00',3.01),('11288','2014-03-17','10:50:00',2.53),('11288','2014-03-17','10:55:00',2.58),('11288','2014-03-17','11:00:00',2.74),('11288','2014-03-17','11:05:00',2.42),('11288','2014-03-17','11:10:00',3.42),('11288','2014-03-17','11:15:00',2.43),('11288','2014-03-17','11:20:00',2.29),('11288','2014-03-17','11:25:00',3.01),('11288','2014-03-17','11:30:00',2.62),('11288','2014-03-17','11:35:00',2.43),('11288','2014-03-17','11:40:00',2.15),('11288','2014-03-17','11:45:00',3.02),('11288','2014-03-17','11:50:00',3.07),('11288','2014-03-17','11:55:00',3.07),('11288','2014-03-17','12:00:00',3.02),('11288','2014-03-17','12:05:00',2.83),('11288','2014-03-17','12:10:00',2.4),('11288','2014-03-17','12:15:00',2.97),('11288','2014-03-17','12:20:00',6.61),('11288','2014-03-17','12:25:00',2.68),('11288','2014-03-17','12:30:00',2.92),('11288','2014-03-17','12:35:00',2.94),('11288','2014-03-17','12:40:00',5.31),('11288','2014-03-17','12:45:00',5.18),('11288','2014-03-17','12:50:00',4.92),('11288','2014-03-17','12:55:00',5.46),('11288','2014-03-17','13:00:00',2.88),('11288','2014-03-17','13:05:00',3.42),('11288','2014-03-17','13:10:00',5.28),('11288','2014-03-17','13:15:00',6.06),('11288','2014-03-17','13:20:00',4.86),('11288','2014-03-17','13:25:00',5.53),('11288','2014-03-17','13:30:00',5.74),('11288','2014-03-17','13:35:00',5.12),('11288','2014-03-17','13:40:00',5.36),('11288','2014-03-17','13:45:00',4.55),('11288','2014-03-17','13:50:00',5.42),('11288','2014-03-17','13:55:00',3.98),('11288','2014-03-17','14:00:00',5.32),('11288','2014-03-17','14:05:00',3.53),('11288','2014-03-17','14:10:00',2.12),('11288','2014-03-17','14:15:00',4.54),('11288','2014-03-17','14:20:00',3.52),('11288','2014-03-17','14:25:00',4.99),('11288','2014-03-17','14:30:00',2.89),('11288','2014-03-17','14:35:00',4.05),('11288','2014-03-17','14:40:00',4.76),('11288','2014-03-17','14:45:00',4.74),('11288','2014-03-17','14:50:00',4.86),('11288','2014-03-17','14:55:00',4.55),('11288','2014-03-17','15:00:00',4.55),('11288','2014-03-17','15:05:00',4.28),('11288','2014-03-17','15:10:00',4.16),('11288','2014-03-17','15:15:00',2.02),('11288','2014-03-17','15:20:00',3.82),('11288','2014-03-17','15:25:00',3.73),('11288','2014-03-17','15:30:00',3.47),('11288','2014-03-17','15:35:00',3.28),('11288','2014-03-17','15:40:00',3.17),('11288','2014-03-17','15:45:00',2.28),('11288','2014-03-17','15:50:00',2.27),('11288','2014-03-17','15:55:00',2.38),('11288','2014-03-17','16:00:00',2.53),('11288','2014-03-17','16:05:00',2.38),('11288','2014-03-17','16:10:00',1.03),('11288','2014-03-17','16:15:00',1.49),('11288','2014-03-17','16:20:00',2.1),('11288','2014-03-17','16:25:00',1.97),('11288','2014-03-17','16:30:00',1.85),('11288','2014-03-17','16:35:00',1.9),('11288','2014-03-17','16:40:00',1.58),('11288','2014-03-17','16:45:00',1.62),('11288','2014-03-17','16:50:00',1.44),('11288','2012-12-22','09:30:00',1.19),('11288','2012-12-22','09:35:00',1.37),('11288','2012-12-22','09:40:00',1.38),('11288','2012-12-22','09:45:00',1.13),('11288','2012-12-22','09:50:00',1.17),('11288','2012-12-22','09:55:00',1.27),('11288','2012-12-22','10:00:00',1.3),('11288','2012-12-22','10:05:00',1.34),('11288','2012-12-22','10:10:00',1.4),('11288','2012-12-22','10:15:00',1.38),('11288','2012-12-22','10:20:00',1.34),('11288','2012-12-22','10:25:00',1.69),('11288','2012-12-22','10:30:00',2.18),('11288','2012-12-22','10:35:00',3.3),('11288','2012-12-22','10:40:00',3.12),('11288','2012-12-22','10:45:00',3.64),('11288','2012-12-22','10:50:00',3.53),('11288','2012-12-22','10:55:00',2.23),('11288','2012-12-22','11:00:00',1.09),('11288','2012-12-22','11:20:00',1.15),('11288','2012-12-22','11:30:00',1.18),('11288','2012-12-22','11:35:00',2.07),('11288','2012-12-22','11:40:00',3.98),('11288','2012-12-22','11:45:00',4.38),('11288','2012-12-22','11:50:00',3.18),('11288','2012-12-22','11:55:00',2.63),('11288','2012-12-22','12:00:00',3.01),('11288','2012-12-22','12:05:00',1.53),('11288','2012-12-22','12:10:00',1.55),('11288','2012-12-22','12:15:00',1.68),('11288','2012-12-22','12:20:00',1.21),('11288','2012-12-22','12:25:00',1.38),('11288','2012-12-22','12:30:00',2.75),('11288','2012-12-22','12:35:00',2.22),('11288','2012-12-22','12:40:00',3.31),('11288','2012-12-22','12:45:00',4.53),('11288','2012-12-22','12:50:00',4.06),('11288','2012-12-22','12:55:00',3.68),('11288','2012-12-22','13:00:00',3.96),('11288','2012-12-22','13:05:00',3.29),('11288','2012-12-22','13:10:00',4.18),('11288','2012-12-22','13:15:00',4.4),('11288','2012-12-22','13:20:00',4.36),('11288','2012-12-22','13:25:00',4.22),('11288','2012-12-22','13:30:00',3.88),('11288','2012-12-22','13:35:00',3.81),('11288','2012-12-22','13:40:00',1.71),('11288','2012-12-22','13:45:00',1.47),('11288','2012-12-22','13:50:00',1.58),('11288','2012-12-22','13:55:00',1.59),('11288','2012-12-22','14:00:00',1.57),('11288','2012-12-22','14:05:00',1.47),('11288','2012-12-22','14:10:00',1.74),('11288','2012-12-22','14:15:00',1.55),('11288','2012-12-22','14:20:00',1.51),('11288','2012-12-22','15:00:00',1.03),('11288','2014-03-16','07:35:00',1.06),('11288','2014-03-16','07:40:00',1.12),('11288','2014-03-16','07:45:00',1.1),('11288','2014-03-16','07:50:00',1.27),('11288','2014-03-16','07:55:00',1.48),('11288','2014-03-16','08:00:00',1.65),('11288','2014-03-16','08:05:00',1.8),('11288','2014-03-16','08:10:00',1.85),('11288','2014-03-16','08:15:00',1.89),('11288','2014-03-16','08:20:00',2.03),('11288','2014-03-16','08:25:00',2.17),('11288','2014-03-16','08:30:00',2.25),('11288','2014-03-16','08:35:00',2.42),('11288','2014-03-16','08:40:00',2.52),('11288','2014-03-16','08:45:00',2.66),('11288','2014-03-16','08:50:00',2.85),('11288','2014-03-16','08:55:00',2.84),('11288','2014-03-16','09:00:00',2.75),('11288','2014-03-16','09:05:00',3.09),('11288','2014-03-16','09:10:00',3.32),('11288','2014-03-16','09:15:00',3.57),('11288','2014-03-16','09:20:00',3.67),('11288','2014-03-16','09:25:00',3.63),('11288','2014-03-16','09:30:00',3.77),('11288','2014-03-16','09:35:00',3.77),('11288','2014-03-16','09:40:00',3.84),('11288','2014-03-16','09:45:00',4.11),('11288','2014-03-16','09:50:00',4.41),('11288','2014-03-16','09:55:00',4.35),('11288','2014-03-16','10:00:00',4.3),('11288','2014-03-16','10:05:00',4.43),('11288','2014-03-16','10:10:00',4.57),('11288','2014-03-16','10:15:00',4.68),('11288','2014-03-16','10:20:00',4.71),('11288','2014-03-16','10:25:00',4.75),('11288','2014-03-16','10:30:00',4.78),('11288','2014-03-16','10:35:00',4.86),('11288','2014-03-16','10:40:00',4.96),('11288','2014-03-16','10:45:00',5.01),('11288','2014-03-16','10:50:00',5.03),('11288','2014-03-16','10:55:00',5.18),('11288','2014-03-16','11:00:00',5.32),('11288','2014-03-16','11:05:00',5.37),('11288','2014-03-16','11:10:00',5.33),('11288','2014-03-16','11:15:00',5.39),('11288','2014-03-16','11:20:00',5.47),('11288','2014-03-16','11:25:00',5.59),('11288','2014-03-16','11:30:00',5.55),('11288','2014-03-16','11:35:00',5.51),('11288','2014-03-16','11:40:00',5.48),('11288','2014-03-16','11:45:00',5.44),('11288','2014-03-16','11:50:00',5.46),('11288','2014-03-16','11:55:00',5.42),('11288','2014-03-16','12:00:00',5.52),('11288','2014-03-16','12:05:00',5.66),('11288','2014-03-16','12:10:00',5.56),('11288','2014-03-16','12:15:00',5.41),('11288','2014-03-16','12:20:00',5.49),('11288','2014-03-16','12:25:00',5.6),('11288','2014-03-16','12:30:00',5.6),('11288','2014-03-16','12:35:00',5.66),('11288','2014-03-16','12:40:00',5.58),('11288','2014-03-16','12:45:00',5.56),('11288','2014-03-16','12:50:00',5.47),('11288','2014-03-16','12:55:00',5.5),('11288','2014-03-16','13:00:00',5.37),('11288','2014-03-16','13:05:00',5.39),('11288','2014-03-16','13:10:00',5.27),('11288','2014-03-16','13:15:00',5.23),('11288','2014-03-16','13:20:00',5.16),('11288','2014-03-16','13:25:00',5.18),('11288','2014-03-16','13:30:00',5.3),('11288','2014-03-16','13:35:00',5.21),('11288','2014-03-16','13:40:00',5.35),('11288','2014-03-16','13:45:00',5.17),('11288','2014-03-16','13:50:00',5.17),('11288','2014-03-16','13:55:00',5.16),('11288','2014-03-16','14:00:00',5.02),('11288','2014-03-16','14:05:00',4.94),('11288','2014-03-16','14:10:00',4.78),('11288','2014-03-16','14:15:00',4.69),('11288','2014-03-16','14:20:00',4.71),('11288','2014-03-16','14:25:00',4.64),('11288','2014-03-16','14:30:00',4.6),('11288','2014-03-16','14:35:00',4.51),('11288','2014-03-16','14:40:00',4.39),('11288','2014-03-16','14:45:00',4.31),('11288','2014-03-16','14:50:00',4.06),('11288','2014-03-16','14:55:00',3.99),('11288','2014-03-16','15:00:00',4.15),('11288','2014-03-16','15:05:00',3.92),('11288','2014-03-16','15:10:00',3.61),('11288','2014-03-16','15:15:00',3.46),('11288','2014-03-16','15:20:00',2.91),('11288','2014-03-16','15:25:00',3.25),('11288','2014-03-16','15:30:00',2.97),('11288','2014-03-16','15:35:00',2.8),('11288','2014-03-16','15:40:00',2.23),('11288','2014-03-16','15:45:00',2.07),('11288','2014-03-16','15:50:00',2.33),('11288','2014-03-16','15:55:00',2.11),('11288','2014-03-16','16:00:00',1.8),('11288','2014-03-16','16:05:00',2.13),('11288','2014-03-16','16:10:00',2.26),('11288','2014-03-16','16:15:00',2.19),('11288','2014-03-16','16:20:00',1.99),('11288','2014-03-16','16:25:00',1.96),('11288','2014-03-16','16:30:00',1.96),('11288','2014-03-16','16:35:00',1.79),('11288','2014-03-16','16:40:00',1.55),('11288','2014-03-16','16:45:00',1.38),('11288','2014-03-16','16:50:00',1.27),('11288','2014-03-16','16:55:00',1.05),('11288','2014-03-15','07:35:00',1.01),('11288','2014-03-15','07:40:00',1.09),('11288','2014-03-15','07:45:00',1.08),('11288','2014-03-15','07:50:00',1.28),('11288','2014-03-15','07:55:00',1.39),('11288','2014-03-15','08:00:00',1.51),('11288','2014-03-15','08:05:00',1.64),('11288','2014-03-15','08:10:00',1.75),('11288','2014-03-15','08:15:00',1.85),('11288','2014-03-15','08:20:00',1.97),('11288','2014-03-15','08:25:00',2.11),('11288','2014-03-15','08:30:00',2.21),('11288','2014-03-15','08:35:00',2.37),('11288','2014-03-15','08:40:00',2.51),('11288','2014-03-15','08:45:00',2.65),('11288','2014-03-15','08:50:00',2.74),('11288','2014-03-15','08:55:00',2.74),('11288','2014-03-15','09:00:00',2.74),('11288','2014-03-15','09:05:00',3.08),('11288','2014-03-15','09:10:00',3.32),('11288','2014-03-15','09:15:00',3.47),('11288','2014-03-15','09:20:00',3.57),('11288','2014-03-15','09:25:00',3.68),('11288','2014-03-15','09:30:00',3.77),('11288','2014-03-15','09:35:00',3.87),('11288','2014-03-15','09:40:00',3.97),('11288','2014-03-15','09:45:00',4.06),('11288','2014-03-15','09:50:00',4.13),('11288','2014-03-15','09:55:00',4.17),('11288','2014-03-15','10:00:00',4.28),('11288','2014-03-15','10:05:00',4.4),('11288','2014-03-15','10:10:00',4.47),('11288','2014-03-15','10:15:00',4.54),('11288','2014-03-15','10:20:00',4.61),('11288','2014-03-15','10:25:00',4.61),('11288','2014-03-15','10:30:00',4.73),('11288','2014-03-15','10:35:00',4.73),('11288','2014-03-15','10:40:00',4.8),('11288','2014-03-15','10:45:00',4.91),('11288','2014-03-15','10:50:00',4.91),('11288','2014-03-15','10:55:00',4.94),('11288','2014-03-15','11:00:00',5.1),('11288','2014-03-15','11:05:00',5.15),('11288','2014-03-15','11:10:00',5.11),('11288','2014-03-15','11:15:00',5.31),('11288','2014-03-15','11:20:00',5.33),('11288','2014-03-15','11:25:00',5.48),('11288','2014-03-15','11:30:00',5.35),('11288','2014-03-15','11:35:00',5.45),('11288','2014-03-15','11:40:00',5.46),('11288','2014-03-15','11:45:00',5.56),('11288','2014-03-15','11:50:00',5.45),('11288','2014-03-15','11:55:00',5.46),('11288','2014-03-15','12:00:00',5.48),('11288','2014-03-15','12:05:00',5.46),('11288','2014-03-15','12:10:00',5.56),('11288','2014-03-15','12:15:00',5.62),('11288','2014-03-15','12:20:00',5.52),('11288','2014-03-15','12:25:00',5.63),('11288','2014-03-15','12:30:00',5.7),('11288','2014-03-15','12:35:00',5.67),('11288','2014-03-15','12:40:00',5.67),('11288','2014-03-15','12:45:00',5.65),('11288','2014-03-15','12:50:00',5.64),('11288','2014-03-15','12:55:00',5.6),('11288','2014-03-15','13:00:00',5.62),('11288','2014-03-15','13:05:00',5.57),('11288','2014-03-15','13:10:00',5.58),('11288','2014-03-15','13:15:00',5.55),('11288','2014-03-15','13:20:00',5.48),('11288','2014-03-15','13:25:00',5.43),('11288','2014-03-15','13:30:00',5.44),('11288','2014-03-15','13:35:00',5.42),('11288','2014-03-15','13:40:00',5.39),('11288','2014-03-15','13:45:00',5.32),('11288','2014-03-15','13:50:00',5.29),('11288','2014-03-15','13:55:00',5.26),('11288','2014-03-15','14:00:00',5.2),('11288','2014-03-15','14:05:00',5.17),('11288','2014-03-15','14:10:00',5.1),('11288','2014-03-15','14:15:00',4.99),('11288','2014-03-15','14:20:00',4.92),('11288','2014-03-15','14:25:00',4.83),('11288','2014-03-15','14:30:00',4.73),('11288','2014-03-15','14:35:00',4.63),('11288','2014-03-15','14:40:00',4.53),('11288','2014-03-15','14:45:00',4.37),('11288','2014-03-15','14:50:00',4.25),('11288','2014-03-15','14:55:00',4.21),('11288','2014-03-15','15:00:00',4.12),('11288','2014-03-15','15:05:00',3.96),('11288','2014-03-15','15:10:00',3.82),('11288','2014-03-15','15:15:00',3.7),('11288','2014-03-15','15:20:00',3.54),('11288','2014-03-15','15:25:00',3.41),('11288','2014-03-15','15:30:00',3.28),('11288','2014-03-15','15:35:00',3.17),('11288','2014-03-15','15:40:00',3),('11288','2014-03-15','15:45:00',2.89),('11288','2014-03-15','15:50:00',2.74),('11288','2014-03-15','15:55:00',2.59),('11288','2014-03-15','16:00:00',2.45),('11288','2014-03-15','16:05:00',2.23),('11288','2014-03-15','16:10:00',2.15),('11288','2014-03-15','16:15:00',2.02),('11288','2014-03-15','16:20:00',1.87),('11288','2014-03-15','16:25:00',1.73),('11288','2014-03-15','16:30:00',1.59),('11288','2014-03-15','16:35:00',1.43),('11288','2014-03-15','16:40:00',1.33),('11288','2014-03-15','16:45:00',1.24),('11288','2014-03-15','16:50:00',1.12),('11288','2014-03-15','16:55:00',1.03),('11288','2014-03-14','07:40:00',1),('11288','2014-03-14','07:45:00',1.1),('11288','2014-03-14','07:50:00',1.21),('11288','2014-03-14','07:55:00',1.29),('11288','2014-03-14','08:00:00',1.4),('11288','2014-03-14','08:05:00',1.49),('11288','2014-03-14','08:10:00',1.6),('11288','2014-03-14','08:15:00',1.75),('11288','2014-03-14','08:20:00',1.88),('11288','2014-03-14','08:25:00',1.96),('11288','2014-03-14','08:30:00',2.05),('11288','2014-03-14','08:35:00',2.07),('11288','2014-03-14','08:40:00',2.01),('11288','2014-03-14','08:45:00',1.82),('11288','2014-03-14','08:50:00',1.77),('11288','2014-03-14','08:55:00',1.86),('11288','2014-03-14','09:00:00',2.02),('11288','2014-03-14','09:05:00',2.27),('11288','2014-03-14','09:10:00',2.47),('11288','2014-03-14','09:15:00',2.57),('11288','2014-03-14','09:20:00',2.53),('11288','2014-03-14','09:25:00',2.59),('11288','2014-03-14','09:30:00',2.6),('11288','2014-03-14','09:35:00',2.94),('11288','2014-03-14','09:40:00',3.59),('11288','2014-03-14','09:45:00',4.28),('11288','2014-03-14','09:50:00',5.04),('11288','2014-03-14','09:55:00',5.25),('11288','2014-03-14','10:00:00',5.4),('11288','2014-03-14','10:05:00',5.39),('11288','2014-03-14','10:10:00',5.26),('11288','2014-03-14','10:15:00',5.16),('11288','2014-03-14','10:20:00',5.05),('11288','2014-03-14','10:25:00',4.76),('11288','2014-03-14','10:30:00',4.75),('11288','2014-03-14','10:35:00',5.02),('11288','2014-03-14','10:40:00',5.21),('11288','2014-03-14','10:45:00',4.43),('11288','2014-03-14','10:50:00',3.04),('11288','2014-03-14','10:55:00',4.21),('11288','2014-03-14','11:00:00',4.95),('11288','2014-03-14','11:05:00',5.27),('11288','2014-03-14','11:10:00',5.79),('11288','2014-03-14','11:15:00',5.81),('11288','2014-03-14','11:20:00',5.61),('11288','2014-03-14','11:25:00',5.47),('11288','2014-03-14','11:30:00',5.51),('11288','2014-03-14','11:35:00',5.59),('11288','2014-03-14','11:40:00',5.72),('11288','2014-03-14','11:45:00',5.85),('11288','2014-03-14','11:50:00',5.98),('11288','2014-03-14','11:55:00',5.93),('11288','2014-03-14','12:00:00',5.92),('11288','2014-03-14','12:05:00',5.9),('11288','2014-03-14','12:10:00',5.52),('11288','2014-03-14','12:15:00',5.34),('11288','2014-03-14','12:20:00',4.3),('11288','2014-03-14','12:25:00',3.73),('11288','2014-03-14','12:30:00',3.46),('11288','2014-03-14','12:35:00',2.98),('11288','2014-03-14','12:40:00',3.55),('11288','2014-03-14','12:45:00',4.17),('11288','2014-03-14','12:50:00',4.78),('11288','2014-03-14','12:55:00',5.13),('11288','2014-03-14','13:00:00',3.42),('11288','2014-03-14','13:05:00',3.22),('11288','2014-03-14','13:10:00',3.74),('11288','2014-03-14','13:15:00',4.06),('11288','2014-03-14','13:20:00',4.61),('11288','2014-03-14','13:25:00',4.14),('11288','2014-03-14','13:30:00',3.87),('11288','2014-03-14','13:35:00',3.37),('11288','2014-03-14','13:40:00',3.41),('11288','2014-03-14','13:45:00',3.6),('11288','2014-03-14','13:50:00',3.67),('11288','2014-03-14','13:55:00',3.37),('11288','2014-03-14','14:00:00',4.09),('11288','2014-03-14','14:05:00',4.6),('11288','2014-03-14','14:10:00',4.35),('11288','2014-03-14','14:15:00',4.62),('11288','2014-03-14','14:20:00',4.62),('11288','2014-03-14','14:25:00',4.18),('11288','2014-03-14','14:30:00',4.04),('11288','2014-03-14','14:35:00',3.9),('11288','2014-03-14','14:40:00',3.15),('11288','2014-03-14','14:45:00',2.67),('11288','2014-03-14','14:50:00',2.5),('11288','2014-03-14','14:55:00',2.3),('11288','2014-03-14','15:00:00',2.15),('11288','2014-03-14','15:05:00',2.17),('11288','2014-03-14','15:10:00',2.03),('11288','2014-03-14','15:15:00',1.95),('11288','2014-03-14','15:20:00',2.06),('11288','2014-03-14','15:25:00',2.15),('11288','2014-03-14','15:30:00',2.29),('11288','2014-03-14','15:35:00',2.63),('11288','2014-03-14','15:40:00',2.48),('11288','2014-03-14','15:45:00',2.07),('11288','2014-03-14','15:50:00',1.9),('11288','2014-03-14','15:55:00',1.92),('11288','2014-03-14','16:00:00',1.8),('11288','2014-03-14','16:05:00',1.8),('11288','2014-03-14','16:10:00',1.53),('11288','2014-03-14','16:15:00',1.34),('11288','2014-03-14','16:20:00',1.2),('11288','2014-03-14','16:25:00',1.11),('11288','2014-03-14','16:30:00',1.06),('11288','2014-03-14','16:35:00',1),('11288','2014-03-13','07:40:00',1.04),('11288','2014-03-13','07:45:00',1.08),('11288','2014-03-13','07:50:00',1.26),('11288','2014-03-13','07:55:00',1.38),('11288','2014-03-13','08:00:00',1.54),('11288','2014-03-13','08:05:00',1.73),('11288','2014-03-13','08:10:00',1.9),('11288','2014-03-13','08:15:00',1.97),('11288','2014-03-13','08:20:00',2.15),('11288','2014-03-13','08:25:00',2.34),('11288','2014-03-13','08:30:00',2.49),('11288','2014-03-13','08:35:00',2.66),('11288','2014-03-13','08:40:00',2.76),('11288','2014-03-13','08:45:00',2.9),('11288','2014-03-13','08:50:00',3.06),('11288','2014-03-13','08:55:00',3.29),('11288','2014-03-13','09:00:00',3.48),('11288','2014-03-13','09:05:00',3.63),('11288','2014-03-13','09:10:00',3.74),('11288','2014-03-13','09:15:00',3.82),('11288','2014-03-13','09:20:00',3.94),('11288','2014-03-13','09:25:00',4.03),('11288','2014-03-13','09:30:00',4.15),('11288','2014-03-13','09:35:00',4.28),('11288','2014-03-13','09:40:00',4.44),('11288','2014-03-13','09:45:00',4.54),('11288','2014-03-13','09:50:00',4.66),('11288','2014-03-13','09:55:00',4.74),('11288','2014-03-13','10:00:00',4.84),('11288','2014-03-13','10:05:00',4.89),('11288','2014-03-13','10:10:00',5.01),('11288','2014-03-13','10:15:00',5.07),('11288','2014-03-13','10:20:00',5.12),('11288','2014-03-13','10:25:00',5.16),('11288','2014-03-13','10:30:00',5.21),('11288','2014-03-13','10:35:00',5.27),('11288','2014-03-13','10:40:00',5.32),('11288','2014-03-13','10:45:00',5.38),('11288','2014-03-13','10:50:00',5.41),('11288','2014-03-13','10:55:00',5.47),('11288','2014-03-13','11:00:00',5.57),('11288','2014-03-13','11:05:00',5.58),('11288','2014-03-13','11:10:00',5.63),('11288','2014-03-13','11:15:00',5.66),('11288','2014-03-13','11:20:00',5.77),('11288','2014-03-13','11:25:00',5.84),('11288','2014-03-13','11:30:00',5.85),('11288','2014-03-13','11:35:00',5.86),('11288','2014-03-13','11:40:00',5.92),('11288','2014-03-13','11:45:00',5.9),('11288','2014-03-13','11:50:00',5.92),('11288','2014-03-13','11:55:00',5.95),('11288','2014-03-13','12:00:00',5.96),('11288','2014-03-13','12:05:00',6),('11288','2014-03-13','12:10:00',5.96),('11288','2014-03-13','12:15:00',5.95),('11288','2014-03-13','12:20:00',5.88),('11288','2014-03-13','12:25:00',5.87),('11288','2014-03-13','12:30:00',5.85),('11288','2014-03-13','12:35:00',5.85),('11288','2014-03-13','12:40:00',5.83),('11288','2014-03-13','12:45:00',5.8),('11288','2014-03-13','12:50:00',5.77),('11288','2014-03-13','12:55:00',5.71),('11288','2014-03-13','13:00:00',5.68),('11288','2014-03-13','13:05:00',5.65),('11288','2014-03-13','13:10:00',5.54),('11288','2014-03-13','13:15:00',5.55),('11288','2014-03-13','13:20:00',5.55),('11288','2014-03-13','13:25:00',5.55),('11288','2014-03-13','13:30:00',5.51),('11288','2014-03-13','13:35:00',5.46),('11288','2014-03-13','13:40:00',5.41),('11288','2014-03-13','13:45:00',5.34),('11288','2014-03-13','13:50:00',5.3),('11288','2014-03-13','13:55:00',5.21),('11288','2014-03-13','14:00:00',5.13),('11288','2014-03-13','14:05:00',5.05),('11288','2014-03-13','14:10:00',5.01),('11288','2014-03-13','14:15:00',4.96),('11288','2014-03-13','14:20:00',4.89),('11288','2014-03-13','14:25:00',4.82),('11288','2014-03-13','14:30:00',4.71),('11288','2014-03-13','14:35:00',4.6),('11288','2014-03-13','14:40:00',4.53),('11288','2014-03-13','14:45:00',4.36),('11288','2014-03-13','14:50:00',4.27),('11288','2014-03-13','14:55:00',4.16),('11288','2014-03-13','15:00:00',4.06),('11288','2014-03-13','15:05:00',3.88),('11288','2014-03-13','15:10:00',3.77),('11288','2014-03-13','15:15:00',3.67),('11288','2014-03-13','15:20:00',3.56),('11288','2014-03-13','15:25:00',3.41),('11288','2014-03-13','15:30:00',3.3),('11288','2014-03-13','15:35:00',3.18),('11288','2014-03-13','15:40:00',3.02),('11288','2014-03-13','15:45:00',2.88),('11288','2014-03-13','15:50:00',2.76),('11288','2014-03-13','15:55:00',2.63),('11288','2014-03-13','16:00:00',2.45),('11288','2014-03-13','16:05:00',2.27),('11288','2014-03-13','16:10:00',2.15),('11288','2014-03-13','16:15:00',2.01),('11288','2014-03-13','16:20:00',1.86),('11288','2014-03-13','16:25:00',1.77),('11288','2014-03-13','16:30:00',1.63),('11288','2014-03-13','16:35:00',1.48),('11288','2014-03-13','16:40:00',1.38),('11288','2014-03-13','16:45:00',1.27),('11288','2014-03-13','16:50:00',1.14),('11288','2014-03-13','16:55:00',1.02),('11288','2014-03-12','07:50:00',1.15),('11288','2014-03-12','07:55:00',1.25),('11288','2014-03-12','08:00:00',1.4),('11288','2014-03-12','08:05:00',1.6),('11288','2014-03-12','08:10:00',1.79),('11288','2014-03-12','08:15:00',1.85),('11288','2014-03-12','08:20:00',2.1),('11288','2014-03-12','08:25:00',2.25),('11288','2014-03-12','08:30:00',2.42),('11288','2014-03-12','08:35:00',2.54),('11288','2014-03-12','08:40:00',2.73),('11288','2014-03-12','08:45:00',2.83),('11288','2014-03-12','08:50:00',3.01),('11288','2014-03-12','08:55:00',3.23),('11288','2014-03-12','09:00:00',3.42),('11288','2014-03-12','09:05:00',3.51),('11288','2014-03-12','09:10:00',3.63),('11288','2014-03-12','09:15:00',3.75),('11288','2014-03-12','09:20:00',3.9),('11288','2014-03-12','09:25:00',4.03),('11288','2014-03-12','09:30:00',4.13),('11288','2014-03-12','09:35:00',4.23),('11288','2014-03-12','09:40:00',4.38),('11288','2014-03-12','09:45:00',4.47),('11288','2014-03-12','09:50:00',4.59),('11288','2014-03-12','09:55:00',4.69),('11288','2014-03-12','10:00:00',4.8),('11288','2014-03-12','10:05:00',4.87),('11288','2014-03-12','10:10:00',4.96),('11288','2014-03-12','10:15:00',5.04),('11288','2014-03-12','10:20:00',5.08),('11288','2014-03-12','10:25:00',5.16),('11288','2014-03-12','10:30:00',5.22),('11288','2014-03-12','10:35:00',5.29),('11288','2014-03-12','10:40:00',5.37),('11288','2014-03-12','10:45:00',5.45),('11288','2014-03-12','10:50:00',5.53),('11288','2014-03-12','10:55:00',5.6),('11288','2014-03-12','11:00:00',5.68),('11288','2014-03-12','11:05:00',5.74),('11288','2014-03-12','11:10:00',5.8),('11288','2014-03-12','11:15:00',5.85),('11288','2014-03-12','11:20:00',5.94),('11288','2014-03-12','11:25:00',6.03),('11288','2014-03-12','11:30:00',6.06),('11288','2014-03-12','11:35:00',6.08),('11288','2014-03-12','11:40:00',6.1),('11288','2014-03-12','11:45:00',6.11),('11288','2014-03-12','11:50:00',6.1),('11288','2014-03-12','11:55:00',6.12),('11288','2014-03-12','12:00:00',6.15),('11288','2014-03-12','12:05:00',6.09),('11288','2014-03-12','12:10:00',6.1),('11288','2014-03-12','12:15:00',6.06),('11288','2014-03-12','12:20:00',6.03),('11288','2014-03-12','12:25:00',6.06),('11288','2014-03-12','12:30:00',6.03),('11288','2014-03-12','12:35:00',6.01),('11288','2014-03-12','12:40:00',6.01),('11288','2014-03-12','12:45:00',5.95),('11288','2014-03-12','12:50:00',5.94),('11288','2014-03-12','12:55:00',5.92),('11288','2014-03-12','13:00:00',5.91),('11288','2014-03-12','13:05:00',5.88),('11288','2014-03-12','13:10:00',5.81),('11288','2014-03-12','13:15:00',5.73),('11288','2014-03-12','13:20:00',5.71),('11288','2014-03-12','13:25:00',5.68),('11288','2014-03-12','13:30:00',5.62),('11288','2014-03-12','13:35:00',5.54),('11288','2014-03-12','13:40:00',5.48),('11288','2014-03-12','13:45:00',5.47),('11288','2014-03-12','13:50:00',5.39),('11288','2014-03-12','13:55:00',5.33),('11288','2014-03-12','14:00:00',5.31),('11288','2014-03-12','14:05:00',5.25),('11288','2014-03-12','14:10:00',5.18),('11288','2014-03-12','14:15:00',5.1),('11288','2014-03-12','14:20:00',5.02),('11288','2014-03-12','14:25:00',4.94),('11288','2014-03-12','14:30:00',4.85),('11288','2014-03-12','14:35:00',4.65),('11288','2014-03-12','14:40:00',4.49),('11288','2014-03-12','14:45:00',4.35),('11288','2014-03-12','14:50:00',4.21),('11288','2014-03-12','14:55:00',4.2),('11288','2014-03-12','15:00:00',3.78),('11288','2014-03-12','15:05:00',3.81),('11288','2014-03-12','15:10:00',3.75),('11288','2014-03-12','15:15:00',3.64),('11288','2014-03-12','15:20:00',3.49),('11288','2014-03-12','15:25:00',3.31),('11288','2014-03-12','15:30:00',3.2),('11288','2014-03-12','15:35:00',3.08),('11288','2014-03-12','15:40:00',3.02),('11288','2014-03-12','15:45:00',2.89),('11288','2014-03-12','15:50:00',2.76),('11288','2014-03-12','15:55:00',2.62),('11288','2014-03-12','16:00:00',2.52),('11288','2014-03-12','16:05:00',2.37),('11288','2014-03-12','16:10:00',2.18),('11288','2014-03-12','16:15:00',2.08),('11288','2014-03-12','16:20:00',1.91),('11288','2014-03-12','16:25:00',1.78),('11288','2014-03-12','16:30:00',1.59),('11288','2014-03-12','16:35:00',1.52),('11288','2014-03-12','16:40:00',1.39),('11288','2014-03-12','16:45:00',1.27),('11288','2014-03-12','16:50:00',1.13),('11288','2014-03-12','16:55:00',1.01),('11288','2014-03-11','07:45:00',1.01),('11288','2014-03-11','07:55:00',1.05),('11288','2014-03-11','08:00:00',1.01),('11288','2014-03-11','10:10:00',1.05),('11288','2014-03-11','10:15:00',1.28),('11288','2014-03-11','10:20:00',1.61),('11288','2014-03-11','10:25:00',1.69),('11288','2014-03-11','10:30:00',1.73),('11288','2014-03-11','10:35:00',1.74),('11288','2014-03-11','10:40:00',1.73),('11288','2014-03-11','10:45:00',1.67),('11288','2014-03-11','10:50:00',1.53),('11288','2014-03-11','10:55:00',1.59),('11288','2014-03-11','11:00:00',1.79),('11288','2014-03-11','11:05:00',1.88),('11288','2014-03-11','11:10:00',1.84),('11288','2014-03-11','11:15:00',1.88),('11288','2014-03-11','11:20:00',1.75),('11288','2014-03-11','11:25:00',1.67),('11288','2014-03-11','11:30:00',1.57),('11288','2014-03-11','11:35:00',1.66),('11288','2014-03-11','11:40:00',1.76),('11288','2014-03-11','11:45:00',1.85),('11288','2014-03-11','11:50:00',1.63),('11288','2014-03-11','11:55:00',1.75),('11288','2014-03-11','12:00:00',1.87),('11288','2014-03-11','12:05:00',1.87),('11288','2014-03-11','12:10:00',1.93),('11288','2014-03-11','12:15:00',2.18),('11288','2014-03-11','12:20:00',2.36),('11288','2014-03-11','12:25:00',2.17),('11288','2014-03-11','12:30:00',2.11),('11288','2014-03-11','12:35:00',2.26),('11288','2014-03-11','12:40:00',2.46),('11288','2014-03-11','12:45:00',2.43),('11288','2014-03-11','12:50:00',2.31),('11288','2014-03-11','12:55:00',2.17),('11288','2014-03-11','13:00:00',2.11),('11288','2014-03-11','13:05:00',2.37),('11288','2014-03-11','13:10:00',2.38),('11288','2014-03-11','13:15:00',2.25),('11288','2014-03-11','13:20:00',2.34),('11288','2014-03-11','13:25:00',2.06),('11288','2014-03-11','13:30:00',2.03),('11288','2014-03-11','13:35:00',1.93),('11288','2014-03-11','13:40:00',1.98),('11288','2014-03-11','13:45:00',2.43),('11288','2014-03-11','13:50:00',2.84),('11288','2014-03-11','13:55:00',3.26),('11288','2014-03-11','14:00:00',3.37),('11288','2014-03-11','14:05:00',3.35),('11288','2014-03-11','14:10:00',3.93),('11288','2014-03-11','14:15:00',4.29),('11288','2014-03-11','14:20:00',4.27),('11288','2014-03-11','14:25:00',3.26),('11288','2014-03-11','14:30:00',2.45),('11288','2014-03-11','14:35:00',2.61),('11288','2014-03-11','14:40:00',2.44),('11288','2014-03-11','14:45:00',2.57),('11288','2014-03-11','14:50:00',2.37),('11288','2014-03-11','14:55:00',2.32),('11288','2014-03-11','15:00:00',2.66),('11288','2014-03-11','15:05:00',2.81),('11288','2014-03-11','15:10:00',3.09),('11288','2014-03-11','15:15:00',2.92),('11288','2014-03-11','15:20:00',2.9),('11288','2014-03-11','15:25:00',2.36),('11288','2014-03-11','15:30:00',2.22),('11288','2014-03-11','15:35:00',2.02),('11288','2014-03-11','15:40:00',1.94),('11288','2014-03-11','15:45:00',1.86),('11288','2014-03-11','15:50:00',1.88),('11288','2014-03-11','15:55:00',1.58),('11288','2014-03-11','16:00:00',1.44),('11288','2014-03-11','16:05:00',1.37),('11288','2014-03-11','16:10:00',1.41),('11288','2014-03-11','16:15:00',1.33),('11288','2014-03-11','16:20:00',1.32),('11288','2014-03-11','16:25:00',1.17),('11288','2014-03-11','16:30:00',1.07),('11288','2014-03-10','08:15:00',1.04),('11288','2014-03-10','08:20:00',1.11),('11288','2014-03-10','08:25:00',1.2),('11288','2014-03-10','08:30:00',1.29),('11288','2014-03-10','08:35:00',1.48),('11288','2014-03-10','08:40:00',1.63),('11288','2014-03-10','08:45:00',1.62),('11288','2014-03-10','08:50:00',1.69),('11288','2014-03-10','08:55:00',1.7),('11288','2014-03-10','09:00:00',1.73),('11288','2014-03-10','09:05:00',1.87),('11288','2014-03-10','09:10:00',1.85),('11288','2014-03-10','09:15:00',1.71),('11288','2014-03-10','09:20:00',1.61),('11288','2014-03-10','09:25:00',1.7),('11288','2014-03-10','09:30:00',1.79),('11288','2014-03-10','09:35:00',1.84),('11288','2014-03-10','09:40:00',1.93),('11288','2014-03-10','09:45:00',1.77),('11288','2014-03-10','09:50:00',1.58),('11288','2014-03-10','09:55:00',1.52),('11288','2014-03-10','10:00:00',1.38),('11288','2014-03-10','10:05:00',1.45),('11288','2014-03-10','10:10:00',1.78),('11288','2014-03-10','10:15:00',2.05),('11288','2014-03-10','10:20:00',1.74),('11288','2014-03-10','10:25:00',1.55),('11288','2014-03-10','10:30:00',1.86),('11288','2014-03-10','10:35:00',2.23),('11288','2014-03-10','10:40:00',1.65),('11288','2014-03-10','10:45:00',1.1),('11288','2014-03-10','11:05:00',1),('11288','2014-03-10','11:10:00',1.23),('11288','2014-03-10','11:15:00',1.6),('11288','2014-03-10','11:20:00',1.8),('11288','2014-03-10','11:25:00',1.66),('11288','2014-03-10','11:30:00',1.46),('11288','2014-03-10','12:20:00',1.05),('11288','2014-03-10','12:25:00',1.1),('11288','2014-03-10','12:30:00',1.22),('11288','2014-03-10','12:35:00',1.41),('11288','2014-03-10','12:40:00',1.58),('11288','2014-03-10','12:45:00',1.8),('11288','2014-03-10','12:50:00',1.99),('11288','2014-03-10','12:55:00',2.12),('11288','2014-03-10','13:00:00',2.21),('11288','2014-03-10','13:05:00',2.26),('11288','2014-03-10','13:10:00',2.38),('11288','2014-03-10','13:15:00',2.59),('11288','2014-03-10','13:20:00',2.62),('11288','2014-03-10','13:25:00',2.39),('11288','2014-03-10','13:30:00',2.07),('11288','2014-03-10','13:35:00',1.71),('11288','2014-03-10','13:40:00',1.52),('11288','2014-03-10','13:45:00',1.37),('11288','2014-03-10','13:50:00',2.06),('11288','2014-03-10','13:55:00',2.39),('11288','2014-03-10','14:00:00',2),('11288','2014-03-10','14:05:00',2.97),('11288','2014-03-10','14:10:00',3.5),('11288','2014-03-10','14:15:00',4.91),('11288','2014-03-10','14:20:00',3.49),('11288','2014-03-10','14:25:00',2.78),('11288','2014-03-10','14:30:00',2.39),('11288','2014-03-10','14:35:00',3.13),('11288','2014-03-10','14:40:00',4.56),('11288','2014-03-10','14:45:00',4.67),('11288','2014-03-10','14:50:00',4.32),('11288','2014-03-10','14:55:00',2.23),('11288','2014-03-10','15:00:00',2.92),('11288','2014-03-10','15:05:00',2.47),('11288','2014-03-10','15:10:00',1.67),('11288','2014-03-10','15:15:00',2.15),('11288','2014-03-10','15:20:00',2.82),('11288','2014-03-10','15:25:00',3.67),('11288','2014-03-10','15:30:00',2.88),('11288','2014-03-10','15:35:00',2.05),('11288','2014-03-10','15:40:00',1.71),('11288','2014-03-10','15:45:00',1.5),('11288','2014-03-10','15:50:00',1.53),('11288','2014-03-10','15:55:00',1.34),('11288','2014-03-10','16:00:00',1.44),('11288','2014-03-10','16:05:00',1.57),('11288','2014-03-10','16:10:00',1.29),('11288','2014-03-10','16:15:00',1.07),('11288','2014-03-10','16:20:00',1.16),('11288','2014-03-10','16:25:00',1.25),('11288','2014-03-10','16:30:00',1.5),('11288','2014-03-10','16:35:00',1.25),('11288','2014-03-10','16:55:00',1.37),('11288','2014-03-10','17:00:00',1.17),('11288','2014-03-09','07:55:00',1.08),('11288','2014-03-09','08:00:00',1.3),('11288','2014-03-09','08:05:00',1.43),('11288','2014-03-09','08:10:00',1.53),('11288','2014-03-09','08:15:00',1.79),('11288','2014-03-09','08:20:00',1.9),('11288','2014-03-09','08:25:00',1.95),('11288','2014-03-09','08:30:00',1.74),('11288','2014-03-09','08:35:00',1.79),('11288','2014-03-09','08:40:00',1.69),('11288','2014-03-09','08:45:00',1.67),('11288','2014-03-09','08:50:00',1.38),('11288','2014-03-09','08:55:00',2.4),('11288','2014-03-09','09:00:00',3.02),('11288','2014-03-09','09:05:00',2.86),('11288','2014-03-09','09:10:00',1.6),('11288','2014-03-09','09:15:00',3.64),('11288','2014-03-09','09:20:00',3.82),('11288','2014-03-09','09:25:00',4.04),('11288','2014-03-09','09:30:00',4.19),('11288','2014-03-09','09:35:00',4.51),('11288','2014-03-09','09:40:00',4.61),('11288','2014-03-09','09:45:00',4.75),('11288','2014-03-09','09:50:00',4.81),('11288','2014-03-09','09:55:00',4.86),('11288','2014-03-09','10:00:00',4.87),('11288','2014-03-09','10:05:00',4.95),('11288','2014-03-09','10:10:00',5.09),('11288','2014-03-09','10:15:00',5.14),('11288','2014-03-09','10:20:00',5.14),('11288','2014-03-09','10:25:00',5.21),('11288','2014-03-09','10:30:00',5.33),('11288','2014-03-09','10:35:00',5.43),('11288','2014-03-09','10:40:00',5.44),('11288','2014-03-09','10:45:00',5.5),('11288','2014-03-09','10:50:00',5.66),('11288','2014-03-09','10:55:00',5.8),('11288','2014-03-09','11:00:00',6.16),('11288','2014-03-09','11:05:00',6.06),('11288','2014-03-09','11:10:00',6.36),('11288','2014-03-09','11:15:00',6.63),('11288','2014-03-09','11:20:00',4.78),('11288','2014-03-09','11:25:00',3.03),('11288','2014-03-09','11:30:00',2.25),('11288','2014-03-09','11:35:00',3.97),('11288','2014-03-09','11:40:00',3.81),('11288','2014-03-09','11:45:00',2.67),('11288','2014-03-09','11:50:00',5.34),('11288','2014-03-09','11:55:00',5.01),('11288','2014-03-09','12:00:00',6.19),('11288','2014-03-09','12:05:00',6.07),('11288','2014-03-09','12:10:00',7.13),('11288','2014-03-09','12:15:00',6.91),('11288','2014-03-09','12:20:00',6.95),('11288','2014-03-09','12:25:00',6.73),('11288','2014-03-09','12:30:00',6.78),('11288','2014-03-09','12:35:00',7.07),('11288','2014-03-09','12:40:00',6.68),('11288','2014-03-09','12:45:00',6.46),('11288','2014-03-09','12:50:00',6.5),('11288','2014-03-09','12:55:00',6.55),('11288','2014-03-09','13:00:00',6.69),('11288','2014-03-09','13:05:00',6.76),('11288','2014-03-09','13:10:00',6.5),('11288','2014-03-09','13:15:00',6.28),('11288','2014-03-09','13:20:00',6.21),('11288','2014-03-09','13:25:00',5.94),('11288','2014-03-09','13:30:00',6.05),('11288','2014-03-09','13:35:00',5.75),('11288','2014-03-09','13:40:00',2.2),('11288','2014-03-09','13:45:00',1.66),('11288','2014-03-09','13:50:00',4.83),('11288','2014-03-09','13:55:00',1.79),('11288','2014-03-09','14:00:00',2.24),('11288','2014-03-09','14:05:00',5.52),('11288','2014-03-09','14:10:00',5.46),('11288','2014-03-09','14:15:00',5.29),('11288','2014-03-09','14:20:00',2.6),('11288','2014-03-09','14:25:00',5.52),('11288','2014-03-09','14:30:00',2.9),('11288','2014-03-09','14:35:00',1.75),('11288','2014-03-09','14:40:00',1.35),('11288','2014-03-09','14:45:00',3.07),('11288','2014-03-09','14:50:00',2.6),('11288','2014-03-09','14:55:00',4.54),('11288','2014-03-09','15:00:00',4.36),('11288','2014-03-09','15:05:00',3.85),('11288','2014-03-09','15:10:00',3.85),('11288','2014-03-09','15:15:00',3.89),('11288','2014-03-09','15:20:00',3.78),('11288','2014-03-09','15:25:00',3.72),('11288','2014-03-09','15:30:00',3.63),('11288','2014-03-09','15:35:00',3.43),('11288','2014-03-09','15:40:00',3.23),('11288','2014-03-09','15:45:00',2.8),('11288','2014-03-09','15:50:00',1.02),('11288','2014-03-09','15:55:00',1.98),('11288','2014-03-09','16:00:00',2.62),('11288','2014-03-09','16:05:00',2.49),('11288','2014-03-09','16:10:00',1.8),('11288','2014-03-09','16:15:00',1.59),('11288','2014-03-09','16:20:00',1.48),('11288','2014-03-09','16:25:00',1.63),('11288','2014-03-09','16:30:00',1.67),('11288','2014-03-09','16:35:00',1.59),('11288','2014-03-09','16:40:00',1.5),('11288','2014-03-09','16:45:00',1.25),('11288','2014-03-09','16:50:00',1.11),('11288','2014-03-08','07:55:00',1.14),('11288','2014-03-08','08:00:00',1.27),('11288','2014-03-08','08:05:00',1.39),('11288','2014-03-08','08:10:00',1.45),('11288','2014-03-08','08:15:00',1.71),('11288','2014-03-08','08:20:00',1.9),('11288','2014-03-08','08:25:00',2.1),('11288','2014-03-08','08:30:00',2.25),('11288','2014-03-08','08:35:00',2.39),('11288','2014-03-08','08:40:00',2.54),('11288','2014-03-08','08:45:00',2.68),('11288','2014-03-08','08:50:00',2.83),('11288','2014-03-08','08:55:00',2.97),('11288','2014-03-08','09:00:00',3.16),('11288','2014-03-08','09:05:00',3.32),('11288','2014-03-08','09:10:00',3.46),('11288','2014-03-08','09:15:00',3.59),('11288','2014-03-08','09:20:00',3.66),('11288','2014-03-08','09:25:00',3.84),('11288','2014-03-08','09:30:00',3.94),('11288','2014-03-08','09:35:00',4.09),('11288','2014-03-08','09:40:00',4.21),('11288','2014-03-08','09:45:00',4.35),('11288','2014-03-08','09:50:00',4.48),('11288','2014-03-08','09:55:00',4.59),('11288','2014-03-08','10:00:00',4.69),('11288','2014-03-08','10:05:00',4.79),('11288','2014-03-08','10:10:00',4.86),('11288','2014-03-08','10:15:00',4.94),('11288','2014-03-08','10:20:00',5.01),('11288','2014-03-08','10:25:00',5.08),('11288','2014-03-08','10:30:00',5.18),('11288','2014-03-08','10:35:00',5.25),('11288','2014-03-08','10:40:00',5.34),('11288','2014-03-08','10:45:00',5.41),('11288','2014-03-08','10:50:00',5.44),('11288','2014-03-08','10:55:00',5.5),('11288','2014-03-08','11:00:00',5.59),('11288','2014-03-08','11:05:00',5.65),('11288','2014-03-08','11:10:00',5.68),('11288','2014-03-08','11:15:00',5.8),('11288','2014-03-08','11:20:00',5.91),('11288','2014-03-08','11:25:00',6.13),('11288','2014-03-08','11:30:00',6.45),('11288','2014-03-08','11:35:00',6.38),('11288','2014-03-08','11:40:00',4.72),('11288','2014-03-08','11:45:00',3),('11288','2014-03-08','11:50:00',2.45),('11288','2014-03-08','11:55:00',4.92),('11288','2014-03-08','12:00:00',3.53),('11288','2014-03-08','12:05:00',1.77),('11288','2014-03-08','12:10:00',1.81),('11288','2014-03-08','12:15:00',1.94),('11288','2014-03-08','12:20:00',2.25),('11288','2014-03-08','12:25:00',2.53),('11288','2014-03-08','12:30:00',2.71),('11288','2014-03-08','12:35:00',5.41),('11288','2014-03-08','12:40:00',3.46),('11288','2014-03-08','12:45:00',4.03),('11288','2014-03-08','12:50:00',3.87),('11288','2014-03-08','12:55:00',5.37),('11288','2014-03-08','13:00:00',3.6),('11288','2014-03-08','13:05:00',2.92),('11288','2014-03-08','13:10:00',2.61),('11288','2014-03-08','13:15:00',2.12),('11288','2014-03-08','13:20:00',1.78),('11288','2014-03-08','13:25:00',1.81),('11288','2014-03-08','13:30:00',2.7),('11288','2014-03-08','13:35:00',2.85),('11288','2014-03-08','13:40:00',3.74),('11288','2014-03-08','13:45:00',4.29),('11288','2014-03-08','13:50:00',3.99),('11288','2014-03-08','13:55:00',2.46),('11288','2014-03-08','14:00:00',1.96),('11288','2014-03-08','14:05:00',1.88),('11288','2014-03-08','14:10:00',1.76),('11288','2014-03-08','14:15:00',1.44),('11288','2014-03-08','14:20:00',1.34),('11288','2014-03-08','14:25:00',1.28),('11288','2014-03-08','14:30:00',1.35),('11288','2014-03-08','14:35:00',1.65),('11288','2014-03-08','14:40:00',1.81),('11288','2014-03-08','14:45:00',1.71),('11288','2014-03-08','14:50:00',1.75),('11288','2014-03-08','14:55:00',1.83),('11288','2014-03-08','15:00:00',1.65),('11288','2014-03-08','15:05:00',1.48),('11288','2014-03-08','15:10:00',1.64),('11288','2014-03-08','15:15:00',2.1),('11288','2014-03-08','15:20:00',2.52),('11288','2014-03-08','15:25:00',2.32),('11288','2014-03-08','15:30:00',3.14),('11288','2014-03-08','15:35:00',1.35),('11288','2014-03-08','15:40:00',1.14),('11288','2014-03-08','15:45:00',1.18),('11288','2014-03-08','15:50:00',1.43),('11288','2014-03-08','15:55:00',1.51),('11288','2014-03-08','16:00:00',1.62),('11288','2014-03-08','16:05:00',1.36),('11288','2014-03-08','16:10:00',1.09),('11288','2014-03-08','16:15:00',1.11),('11288','2014-03-08','16:20:00',1.23),('11288','2014-03-08','16:25:00',1.14),('11288','2014-03-08','16:30:00',1.5),('11288','2014-03-08','16:35:00',1.58),('11288','2014-03-08','16:40:00',1.31),('11288','2014-03-08','16:45:00',1.23),('11288','2014-03-08','16:50:00',1.17),('11288','2014-03-08','16:55:00',1.01),('11288','2014-04-30','07:35:00',1.04),('11288','2014-04-30','07:40:00',1.08),('11288','2014-04-30','07:45:00',1.23),('11288','2014-04-30','07:50:00',1.37),('11288','2014-04-30','07:55:00',1.44),('11288','2014-04-30','08:00:00',1.48),('11288','2014-04-30','08:05:00',1.59),('11288','2014-04-30','08:10:00',1.69),('11288','2014-04-30','08:15:00',1.93),('11288','2014-04-30','08:20:00',2.1),('11288','2014-04-30','08:25:00',1.91),('11288','2014-04-30','08:30:00',2.11),('11288','2014-04-30','08:35:00',2.53),('11288','2014-04-30','08:40:00',2.69),('11288','2014-04-30','08:45:00',2.65),('11288','2014-04-30','08:50:00',2.8),('11288','2014-04-30','08:55:00',2.94),('11288','2014-04-30','09:00:00',3.73),('11288','2014-04-30','09:05:00',3.91),('11288','2014-04-30','09:10:00',3.36),('11288','2014-04-30','09:15:00',2.75),('11288','2014-04-30','09:20:00',3.78),('11288','2014-04-30','09:25:00',3.23),('11288','2014-04-30','09:30:00',2.6),('11288','2014-04-30','09:35:00',4.66),('11288','2014-04-30','09:40:00',4.82),('11288','2014-04-30','09:45:00',4.07),('11288','2014-04-30','09:50:00',3.74),('11288','2014-04-30','09:55:00',5.39),('11288','2014-04-30','10:00:00',5.62),('11288','2014-04-30','10:05:00',4.39),('11288','2014-04-30','10:10:00',4.55),('11288','2014-04-30','10:15:00',4.09),('11288','2014-04-30','10:20:00',2.85),('11288','2014-04-30','10:25:00',3.15),('11288','2014-04-30','10:30:00',3.72),('11288','2014-04-30','10:35:00',3.48),('11288','2014-04-30','10:40:00',3.94),('11288','2014-04-30','10:45:00',2.84),('11288','2014-04-30','10:50:00',3.6),('11288','2014-04-30','10:55:00',7.71),('11288','2014-04-30','11:00:00',6.32),('11288','2014-04-30','11:05:00',4.36),('11288','2014-04-30','11:10:00',5.65),('11288','2014-04-30','11:15:00',3.37),('11288','2014-04-30','11:20:00',3.56),('11288','2014-04-30','11:25:00',3.81),('11288','2014-04-30','11:30:00',3.94),('11288','2014-04-30','11:35:00',5.61),('11288','2014-04-30','11:40:00',4.27),('11288','2014-04-30','11:45:00',4.37),('11288','2014-04-30','11:50:00',7.27),('11288','2014-04-30','11:55:00',7.05),('11288','2014-04-30','12:00:00',4.16),('11288','2014-04-30','12:05:00',2.52),('11288','2014-04-30','12:10:00',2.65),('11288','2014-04-30','12:15:00',3.27),('11288','2014-04-30','12:20:00',2.93),('11288','2014-04-30','12:25:00',3.01),('11288','2014-04-30','12:30:00',5.15),('11288','2014-04-30','12:35:00',3.44),('11288','2014-04-30','12:40:00',2.48),('11288','2014-04-30','12:45:00',2.37),('11288','2014-04-30','12:50:00',4),('11288','2014-04-30','12:55:00',6.89),('11288','2014-04-30','13:00:00',6.94),('11288','2014-04-30','13:05:00',3.73),('11288','2014-04-30','13:10:00',5.37),('11288','2014-04-30','13:15:00',4.2),('11288','2014-04-30','13:20:00',4.17),('11288','2014-04-30','13:25:00',7.37),('11288','2014-04-30','13:30:00',3.64),('11288','2014-04-30','13:35:00',4.4),('11288','2014-04-30','13:40:00',5.85),('11288','2014-04-30','13:45:00',5.6),('11288','2014-04-30','13:50:00',4.54),('11288','2014-04-30','13:55:00',6.31),('11288','2014-04-30','14:00:00',3.5),('11288','2014-04-30','14:05:00',3.17),('11288','2014-04-30','14:10:00',2.85),('11288','2014-04-30','14:15:00',3.47),('11288','2014-04-30','14:20:00',7.14),('11288','2014-04-30','14:25:00',7.24),('11288','2014-04-30','14:30:00',8.59),('11288','2014-04-30','14:35:00',5.55),('11288','2014-04-30','14:40:00',3.38),('11288','2014-04-30','14:45:00',2.57),('11288','2014-04-30','14:50:00',3.02),('11288','2014-04-30','14:55:00',3.21),('11288','2014-04-30','15:00:00',2.76),('11288','2014-04-30','15:05:00',2.72),('11288','2014-04-30','15:10:00',2.79),('11288','2014-04-30','15:15:00',2.45),('11288','2014-04-30','15:20:00',2.19),('11288','2014-04-30','15:25:00',2.39),('11288','2014-04-30','15:30:00',3.11),('11288','2014-04-30','15:35:00',5.68),('11288','2014-04-30','15:40:00',7.41),('11288','2014-04-30','15:45:00',5.94),('11288','2014-04-30','15:50:00',6.27),('11288','2014-04-30','15:55:00',3.83),('11288','2014-04-30','16:00:00',3.03),('11288','2014-04-30','16:05:00',3.22),('11288','2014-04-30','16:10:00',4.12),('11288','2014-04-30','16:15:00',6.11),('11288','2014-04-30','16:20:00',2.67),('11288','2014-04-30','16:25:00',3.87),('11288','2014-04-30','16:30:00',4.01),('11288','2014-04-30','16:35:00',3.15),('11288','2014-04-30','16:40:00',3.97),('11288','2014-04-30','16:45:00',2.41),('11288','2014-04-30','16:50:00',3.3),('11288','2014-04-30','16:55:00',3.38),('11288','2014-04-30','17:00:00',3.86),('11288','2014-04-30','17:05:00',2.5),('11288','2014-04-30','17:10:00',2.15),('11288','2014-04-30','17:15:00',1.86),('11288','2014-04-30','17:20:00',1.6),('11288','2014-04-30','17:25:00',1.25),('11288','2014-04-30','17:30:00',1.56),('11288','2014-04-30','17:35:00',2.07),('11288','2014-04-30','17:40:00',1.86),('11288','2014-04-30','17:45:00',1.28),('11288','2014-04-30','17:50:00',1.68),('11288','2014-04-30','17:55:00',1.33),('11288','2014-04-30','18:00:00',1.02),('11288','2014-04-30','18:45:00',1.05),('11288','2014-03-07','09:35:00',1.27),('11288','2014-03-07','09:40:00',1.18),('11288','2014-03-07','09:55:00',1.24),('11288','2014-03-07','10:00:00',1.25),('11288','2014-03-07','10:05:00',1.12),('11288','2014-03-07','10:10:00',1.21),('11288','2014-03-07','10:15:00',1.13),('11288','2014-03-07','10:20:00',1.31),('11288','2014-03-07','10:25:00',1.13),('11288','2014-03-07','10:30:00',1.26),('11288','2014-03-07','10:35:00',1.48),('11288','2014-03-07','10:40:00',1.37),('11288','2014-03-07','10:45:00',1.27),('11288','2014-03-07','10:50:00',1.33),('11288','2014-03-07','10:55:00',1.45),('11288','2014-03-07','11:00:00',1.72),('11288','2014-03-07','11:05:00',1.5),('11288','2014-03-07','11:10:00',1.22),('11288','2014-03-07','11:15:00',1.34),('11288','2014-03-07','11:20:00',1.79),('11288','2014-03-07','11:25:00',1.77),('11288','2014-03-07','11:30:00',2.03),('11288','2014-03-07','11:35:00',1.89),('11288','2014-03-07','11:40:00',1.65),('11288','2014-03-07','11:45:00',3.12),('11288','2014-03-07','11:50:00',5.81),('11288','2014-03-07','11:55:00',6.36),('11288','2014-03-07','12:00:00',7.42),('11288','2014-03-07','12:05:00',6.66),('11288','2014-03-07','12:10:00',6.79),('11288','2014-03-07','12:15:00',6.51),('11288','2014-03-07','12:20:00',6.52),('11288','2014-03-07','12:25:00',6.48),('11288','2014-03-07','12:30:00',2.66),('11288','2014-03-07','12:35:00',4.46),('11288','2014-03-07','12:40:00',3.71),('11288','2014-03-07','12:45:00',1.42),('11288','2014-03-07','12:50:00',2.6),('11288','2014-03-07','12:55:00',2.46),('11288','2014-03-07','13:00:00',6.1),('11288','2014-03-07','13:05:00',6.11),('11288','2014-03-07','13:10:00',3.38),('11288','2014-03-07','13:15:00',2.63),('11288','2014-03-07','13:20:00',4.22),('11288','2014-03-07','13:25:00',5.66),('11288','2014-03-07','13:30:00',5.68),('11288','2014-03-07','13:35:00',4.54),('11288','2014-03-07','13:40:00',4.51),('11288','2014-03-07','13:45:00',4.03),('11288','2014-03-07','13:50:00',2.72),('11288','2014-03-07','13:55:00',2.15),('11288','2014-03-07','14:00:00',2.06),('11288','2014-03-07','14:05:00',1.98),('11288','2014-03-07','14:10:00',2),('11288','2014-03-07','14:15:00',1.98),('11288','2014-03-07','14:20:00',1.95),('11288','2014-03-07','14:25:00',1.9),('11288','2014-03-07','14:30:00',2),('11288','2014-03-07','14:35:00',2.1),('11288','2014-03-07','14:40:00',2.24),('11288','2014-03-07','14:45:00',2.28),('11288','2014-03-07','14:50:00',2.83),('11288','2014-03-07','14:55:00',3.92),('11288','2014-03-07','15:00:00',4.67),('11288','2014-03-07','15:05:00',5.01),('11288','2014-03-07','15:10:00',4.99),('11288','2014-03-07','15:15:00',5.02),('11288','2014-03-07','15:20:00',4.95),('11288','2014-03-07','15:25:00',4.66),('11288','2014-03-07','15:30:00',4.33),('11288','2014-03-07','15:35:00',4.08),('11288','2014-03-07','15:40:00',3.13),('11288','2014-03-07','15:45:00',2.74),('11288','2014-03-07','15:50:00',2.48),('11288','2014-03-07','15:55:00',2.28),('11288','2014-03-07','16:00:00',2.62),('11288','2014-03-07','16:05:00',2.4),('11288','2014-03-07','16:10:00',2.3),('11288','2014-03-07','16:15:00',2.43),('11288','2014-03-07','16:20:00',2.09),('11288','2014-03-07','16:25:00',1.92),('11288','2014-03-07','16:30:00',1.85),('11288','2014-03-07','16:35:00',1.78),('11288','2014-03-07','16:40:00',1.78),('11288','2014-03-07','16:45:00',1.75),('11288','2014-03-07','16:50:00',1.63),('11288','2014-03-07','16:55:00',1.53),('11288','2014-03-07','17:00:00',1.46),('11288','2014-03-07','17:05:00',1.34),('11288','2014-03-07','17:10:00',1.17),('11288','2014-03-07','17:15:00',1),('11288','2014-03-06','08:00:00',1.48),('11288','2014-03-06','08:05:00',1.77),('11288','2014-03-06','08:10:00',1.88),('11288','2014-03-06','08:15:00',2.17),('11288','2014-03-06','08:20:00',2.45),('11288','2014-03-06','08:25:00',2),('11288','2014-03-06','08:30:00',1.38),('11288','2014-03-06','08:35:00',1.1),('11288','2014-03-06','08:40:00',1.01),('11288','2014-03-06','08:45:00',1.51),('11288','2014-03-06','08:50:00',1.4),('11288','2014-03-06','08:55:00',1.49),('11288','2014-03-06','09:00:00',1.62),('11288','2014-03-06','09:05:00',1.58),('11288','2014-03-06','09:10:00',1.53),('11288','2014-03-06','09:15:00',1.83),('11288','2014-03-06','09:20:00',2.01),('11288','2014-03-06','09:25:00',1.69),('11288','2014-03-06','09:30:00',1.64),('11288','2014-03-06','09:35:00',1.98),('11288','2014-03-06','09:40:00',2.23),('11288','2014-03-06','09:45:00',2.47),('11288','2014-03-06','09:50:00',2.8),('11288','2014-03-06','09:55:00',3.47),('11288','2014-03-06','10:00:00',3.76),('11288','2014-03-06','10:05:00',3.91),('11288','2014-03-06','10:10:00',4.05),('11288','2014-03-06','10:15:00',4.77),('11288','2014-03-06','10:20:00',4.98),('11288','2014-03-06','10:25:00',2.76),('11288','2014-03-06','10:30:00',1.67),('11288','2014-03-06','10:35:00',1.87),('11288','2014-03-06','10:40:00',3.88),('11288','2014-03-06','10:45:00',1.87),('11288','2014-03-06','10:50:00',2.62),('11288','2014-03-06','10:55:00',2.24),('11288','2014-03-06','11:00:00',4.6),('11288','2014-03-06','11:05:00',5.29),('11288','2014-03-06','11:10:00',5.18),('11288','2014-03-06','11:15:00',3.56),('11288','2014-03-06','11:20:00',4.35),('11288','2014-03-06','11:25:00',4.16),('11288','2014-03-06','11:30:00',3),('11288','2014-03-06','11:35:00',2.39),('11288','2014-03-06','11:40:00',3.23),('11288','2014-03-06','11:45:00',4.89),('11288','2014-03-06','11:50:00',5.99),('11288','2014-03-06','11:55:00',6.11),('11288','2014-03-06','12:00:00',2.8),('11288','2014-03-06','12:05:00',3.47),('11288','2014-03-06','12:10:00',6.73),('11288','2014-03-06','12:15:00',4.51),('11288','2014-03-06','12:20:00',2.29),('11288','2014-03-06','12:25:00',3.03),('11288','2014-03-06','12:30:00',5.9),('11288','2014-03-06','12:35:00',3.49),('11288','2014-03-06','12:40:00',2.54),('11288','2014-03-06','12:45:00',1.84),('11288','2014-03-06','12:50:00',1.85),('11288','2014-03-06','12:55:00',2.3),('11288','2014-03-06','13:00:00',3.46),('11288','2014-03-06','13:05:00',2.5),('11288','2014-03-06','13:10:00',2.25),('11288','2014-03-06','13:15:00',2.33),('11288','2014-03-06','13:20:00',1.99),('11288','2014-03-06','13:25:00',1.78),('11288','2014-03-06','13:30:00',1.99),('11288','2014-03-06','13:35:00',1.9),('11288','2014-03-06','13:40:00',2.04),('11288','2014-03-06','13:45:00',1.87),('11288','2014-03-06','13:50:00',1.72),('11288','2014-03-06','13:55:00',1.63),('11288','2014-03-06','14:00:00',1.66),('11288','2014-03-06','14:05:00',1.9),('11288','2014-03-06','14:10:00',1.97),('11288','2014-03-06','14:15:00',1.85),('11288','2014-03-06','14:20:00',2.18),('11288','2014-03-06','14:25:00',2.09),('11288','2014-03-06','14:30:00',1.93),('11288','2014-03-06','14:35:00',3.03),('11288','2014-03-06','14:40:00',2.3),('11288','2014-03-06','14:45:00',1.45),('11288','2014-03-06','14:50:00',1.58),('11288','2014-03-06','14:55:00',1.6),('11288','2014-03-06','15:00:00',1.83),('11288','2014-03-06','15:05:00',2.34),('11288','2014-03-06','15:10:00',2.11),('11288','2014-03-06','15:15:00',1.56),('11288','2014-03-06','15:20:00',1.19),('11288','2014-03-06','15:25:00',1.12),('11288','2014-03-06','15:30:00',1.11),('11288','2014-03-06','15:35:00',1.18),('11288','2014-03-06','15:40:00',1.03),('11288','2014-03-06','16:00:00',1.11),('11288','2014-03-06','16:05:00',1.13),('11288','2014-03-06','16:10:00',1.11),('11288','2014-03-06','16:15:00',1.08),('11288','2014-03-06','16:20:00',1.15),('11288','2014-03-06','16:25:00',1.1),('11288','2014-03-06','16:30:00',1.03),('11288','2014-03-06','16:50:00',1.35),('11288','2014-03-06','16:55:00',1.17),('11288','2014-03-05','07:35:00',1.07),('11288','2014-03-05','07:40:00',1.12),('11288','2014-03-05','07:45:00',1.29),('11288','2014-03-05','07:50:00',1.43),('11288','2014-03-05','07:55:00',1.54),('11288','2014-03-05','08:00:00',1.43),('11288','2014-03-05','08:05:00',1.48),('11288','2014-03-05','08:10:00',1.52),('11288','2014-03-05','08:15:00',1.85),('11288','2014-03-05','08:20:00',1.46),('11288','2014-03-05','08:30:00',1.01),('11288','2014-03-05','08:35:00',3.18),('11288','2014-03-05','08:40:00',2.32),('11288','2014-03-05','08:45:00',2.26),('11288','2014-03-05','08:50:00',2.2),('11288','2014-03-05','08:55:00',1.07),('11288','2014-03-05','09:00:00',2.53),('11288','2014-03-05','09:05:00',3.47),('11288','2014-03-05','09:10:00',1.28),('11288','2014-03-05','09:15:00',3.15),('11288','2014-03-05','09:20:00',3.78),('11288','2014-03-05','09:25:00',3.81),('11288','2014-03-05','09:30:00',3.91),('11288','2014-03-05','09:35:00',4.09),('11288','2014-03-05','09:40:00',4.15),('11288','2014-03-05','09:45:00',4.27),('11288','2014-03-05','09:50:00',4.4),('11288','2014-03-05','09:55:00',4.51),('11288','2014-03-05','10:00:00',4.6),('11288','2014-03-05','10:05:00',4.72),('11288','2014-03-05','10:10:00',4.21),('11288','2014-03-05','10:15:00',4.95),('11288','2014-03-05','10:20:00',4.8),('11288','2014-03-05','10:25:00',5.06),('11288','2014-03-05','10:30:00',5.09),('11288','2014-03-05','10:35:00',5.11),('11288','2014-03-05','10:40:00',5.2),('11288','2014-03-05','10:45:00',5.21),('11288','2014-03-05','10:50:00',5.26),('11288','2014-03-05','10:55:00',5.36),('11288','2014-03-05','11:00:00',5.43),('11288','2014-03-05','11:05:00',5.52),('11288','2014-03-05','11:10:00',5.58),('11288','2014-03-05','11:15:00',5.7),('11288','2014-03-05','11:20:00',5.76),('11288','2014-03-05','11:25:00',5.89),('11288','2014-03-05','11:30:00',6),('11288','2014-03-05','11:35:00',6.19),('11288','2014-03-05','11:40:00',6.11),('11288','2014-03-05','11:45:00',6.16),('11288','2014-03-05','11:50:00',6.03),('11288','2014-03-05','11:55:00',5.24),('11288','2014-03-05','12:00:00',5.41),('11288','2014-03-05','12:05:00',4.86),('11288','2014-03-05','12:10:00',3.76),('11288','2014-03-05','12:15:00',2.12),('11288','2014-03-05','12:20:00',1.42),('11288','2014-03-05','12:25:00',1.47),('11288','2014-03-05','12:30:00',1.79),('11288','2014-03-05','12:35:00',3.08),('11288','2014-03-05','12:40:00',3.2),('11288','2014-03-05','12:45:00',1.92),('11288','2014-03-05','12:50:00',2.49),('11288','2014-03-05','12:55:00',2.36),('11288','2014-03-05','13:00:00',2.86),('11288','2014-03-05','13:05:00',3.76),('11288','2014-03-05','13:10:00',5.63),('11288','2014-03-05','13:15:00',4.38),('11288','2014-03-05','13:20:00',3.81),('11288','2014-03-05','13:25:00',2.18),('11288','2014-03-05','13:30:00',2.22),('11288','2014-03-05','13:35:00',2.19),('11288','2014-03-05','13:40:00',2.7),('11288','2014-03-05','13:45:00',2.63),('11288','2014-03-05','13:50:00',2.24),('11288','2014-03-05','13:55:00',1.99),('11288','2014-03-05','14:00:00',1.86),('11288','2014-03-05','14:05:00',1.99),('11288','2014-03-05','14:10:00',1.86),('11288','2014-03-05','14:15:00',2.06),('11288','2014-03-05','14:20:00',2.17),('11288','2014-03-05','14:25:00',2.77),('11288','2014-03-05','14:30:00',2.49),('11288','2014-03-05','14:35:00',2.11),('11288','2014-03-05','14:40:00',3.23),('11288','2014-03-05','14:45:00',4.45),('11288','2014-03-05','14:50:00',5.27),('11288','2014-03-05','14:55:00',3.79),('11288','2014-03-05','15:00:00',1.74),('11288','2014-03-05','15:05:00',1.47),('11288','2014-03-05','15:10:00',1.46),('11288','2014-03-05','15:15:00',1.43),('11288','2014-03-05','15:20:00',1.31),('11288','2014-03-05','15:25:00',1.35),('11288','2014-03-05','15:30:00',1.68),('11288','2014-03-05','15:35:00',2.06),('11288','2014-03-05','15:40:00',2.06),('11288','2014-03-05','15:45:00',2.74),('11288','2014-03-05','15:50:00',2.22),('11288','2014-03-05','15:55:00',3.14),('11288','2014-03-05','16:00:00',3.92),('11288','2014-03-05','16:05:00',3.54),('11288','2014-03-05','16:10:00',3.07),('11288','2014-03-05','16:15:00',2.32),('11288','2014-03-05','16:20:00',1.08),('11288','2014-03-04','08:50:00',1.07),('11288','2014-03-04','09:00:00',1.2),('11288','2014-03-04','09:05:00',1.92),('11288','2014-03-04','09:10:00',1.97),('11288','2014-03-04','09:15:00',3.05),('11288','2014-03-04','09:20:00',2.99),('11288','2014-03-04','09:25:00',1.59),('11288','2014-03-04','09:30:00',1.75),('11288','2014-03-04','09:35:00',1.76),('11288','2014-03-04','09:40:00',2.17),('11288','2014-03-04','09:45:00',1.73),('11288','2014-03-04','09:50:00',1.41),('11288','2014-03-04','09:55:00',3.23),('11288','2014-03-04','10:00:00',2.35),('11288','2014-03-04','10:05:00',1.71),('11288','2014-03-04','10:10:00',1.14),('11288','2014-03-04','10:20:00',1.77),('11288','2014-03-04','10:25:00',5.31),('11288','2014-03-04','10:30:00',3),('11288','2014-03-04','10:35:00',5.02),('11288','2014-03-04','10:40:00',6.34),('11288','2014-03-04','10:45:00',5.74),('11288','2014-03-04','10:50:00',1.61),('11288','2014-03-04','10:55:00',5.65),('11288','2014-03-04','11:00:00',2.76),('11288','2014-03-04','11:05:00',3.34),('11288','2014-03-04','11:10:00',6.67),('11288','2014-03-04','11:15:00',7.3),('11288','2014-03-04','11:20:00',4.09),('11288','2014-03-04','11:25:00',1.78),('11288','2014-03-04','11:30:00',1.85),('11288','2014-03-04','11:35:00',1.33),('11288','2014-03-04','11:40:00',1.74),('11288','2014-03-04','11:45:00',3.39),('11288','2014-03-04','11:50:00',7.8),('11288','2014-03-04','11:55:00',6.55),('11288','2014-03-04','12:00:00',6.35),('11288','2014-03-04','12:05:00',6.19),('11288','2014-03-04','12:10:00',6.14),('11288','2014-03-04','12:15:00',6.06),('11288','2014-03-04','12:20:00',6.05),('11288','2014-03-04','12:25:00',6.09),('11288','2014-03-04','12:30:00',5.92),('11288','2014-03-04','12:35:00',5.89),('11288','2014-03-04','12:40:00',5.94),('11288','2014-03-04','12:45:00',3.82),('11288','2014-03-04','12:50:00',4.92),('11288','2014-03-04','12:55:00',4.32),('11288','2014-03-04','13:00:00',5.75),('11288','2014-03-04','13:05:00',5.13),('11288','2014-03-04','13:10:00',6.43),('11288','2014-03-04','13:15:00',3.43),('11288','2014-03-04','13:20:00',2.95),('11288','2014-03-04','13:25:00',1.7),('11288','2014-03-04','13:30:00',1.82),('11288','2014-03-04','13:35:00',1.33),('11288','2014-03-04','13:40:00',1.15),('11288','2014-03-04','13:45:00',2.06),('11288','2014-03-04','13:50:00',2.21),('11288','2014-03-04','13:55:00',1.92),('11288','2014-03-04','14:00:00',1.22),('11288','2014-03-04','14:05:00',2.94),('11288','2014-03-04','14:10:00',4.13),('11288','2014-03-04','14:15:00',5.52),('11288','2014-03-04','14:20:00',3.17),('11288','2014-03-04','14:25:00',5.51),('11288','2014-03-04','14:30:00',4.95),('11288','2014-03-04','14:35:00',4.74),('11288','2014-03-04','14:40:00',4.53),('11288','2014-03-04','14:45:00',4.39),('11288','2014-03-04','14:50:00',4.58),('11288','2014-03-04','14:55:00',2.83),('11288','2014-03-04','15:00:00',4.38),('11288','2014-03-04','15:05:00',4.15),('11288','2014-03-04','15:10:00',3.84),('11288','2014-03-04','15:15:00',3.23),('11288','2014-03-04','15:20:00',2.13),('11288','2014-03-04','15:25:00',2.72),('11288','2014-03-04','15:30:00',1.75),('11288','2014-03-04','15:35:00',3.57),('11288','2014-03-04','15:40:00',3.06),('11288','2014-03-04','15:45:00',2.44),('11288','2014-03-04','15:50:00',2.18),('11288','2014-03-04','16:00:00',1.12),('11288','2014-03-04','16:05:00',1.65),('11288','2014-03-04','16:10:00',1.58),('11288','2014-03-04','16:15:00',1.38),('11288','2014-03-04','16:20:00',1.7),('11288','2014-03-04','16:25:00',1.84),('11288','2014-03-04','16:30:00',1.18),('11288','2014-03-04','16:35:00',1.13),('11288','2014-03-04','16:40:00',1.25),('11288','2014-03-04','16:45:00',1.35),('11288','2014-03-04','16:50:00',1.21),('11288','2014-03-03','08:10:00',1.49),('11288','2014-03-03','08:15:00',1.65),('11288','2014-03-03','08:20:00',1.8),('11288','2014-03-03','08:25:00',1.96),('11288','2014-03-03','08:30:00',2.1),('11288','2014-03-03','08:35:00',2.22),('11288','2014-03-03','08:40:00',2.43),('11288','2014-03-03','08:45:00',2.56),('11288','2014-03-03','08:50:00',2.54),('11288','2014-03-03','08:55:00',2.9),('11288','2014-03-03','09:00:00',2.98),('11288','2014-03-03','09:05:00',2.99),('11288','2014-03-03','09:10:00',2.79),('11288','2014-03-03','09:15:00',3.04),('11288','2014-03-03','09:20:00',3.47),('11288','2014-03-03','09:25:00',3.63),('11288','2014-03-03','09:30:00',3.66),('11288','2014-03-03','09:35:00',3.56),('11288','2014-03-03','09:40:00',3.06),('11288','2014-03-03','09:45:00',3.48),('11288','2014-03-03','09:50:00',3.64),('11288','2014-03-03','09:55:00',3.92),('11288','2014-03-03','10:00:00',4.21),('11288','2014-03-03','10:05:00',4.51),('11288','2014-03-03','10:10:00',4.62),('11288','2014-03-03','10:15:00',4.72),('11288','2014-03-03','10:20:00',4.76),('11288','2014-03-03','10:25:00',4.77),('11288','2014-03-03','10:30:00',4.87),('11288','2014-03-03','10:35:00',4.94),('11288','2014-03-03','10:40:00',5.01),('11288','2014-03-03','10:45:00',5.02),('11288','2014-03-03','10:50:00',5.01),('11288','2014-03-03','10:55:00',5.1),('11288','2014-03-03','11:00:00',5.24),('11288','2014-03-03','11:05:00',5.26),('11288','2014-03-03','11:10:00',5.3),('11288','2014-03-03','11:15:00',5.35),('11288','2014-03-03','11:20:00',5.4),('11288','2014-03-03','11:25:00',5.49),('11288','2014-03-03','11:30:00',5.67),('11288','2014-03-03','11:35:00',2.98),('11288','2014-03-03','11:40:00',5.89),('11288','2014-03-03','11:45:00',5.82),('11288','2014-03-03','11:50:00',5.82),('11288','2014-03-03','11:55:00',5.8),('11288','2014-03-03','12:00:00',5.83),('11288','2014-03-03','12:05:00',5.89),('11288','2014-03-03','12:10:00',5.86),('11288','2014-03-03','12:15:00',5.88),('11288','2014-03-03','12:20:00',5.86),('11288','2014-03-03','12:25:00',5.83),('11288','2014-03-03','12:30:00',5.83),('11288','2014-03-03','12:35:00',5.8),('11288','2014-03-03','12:40:00',5.83),('11288','2014-03-03','12:45:00',5.84),('11288','2014-03-03','12:50:00',5.75),('11288','2014-03-03','12:55:00',5.69),('11288','2014-03-03','13:00:00',5.66),('11288','2014-03-03','13:05:00',5.64),('11288','2014-03-03','13:10:00',5.62),('11288','2014-03-03','13:15:00',5.63),('11288','2014-03-03','13:20:00',5.62),('11288','2014-03-03','13:25:00',5.48),('11288','2014-03-03','13:30:00',5.49),('11288','2014-03-03','13:35:00',5.45),('11288','2014-03-03','13:40:00',5.42),('11288','2014-03-03','13:45:00',5.4),('11288','2014-03-03','13:50:00',5.3),('11288','2014-03-03','13:55:00',5.24),('11288','2014-03-03','14:00:00',5.18),('11288','2014-03-03','14:05:00',5.16),('11288','2014-03-03','14:10:00',5.13),('11288','2014-03-03','14:15:00',5.05),('11288','2014-03-03','14:20:00',4.61),('11288','2014-03-03','14:25:00',4.72),('11288','2014-03-03','14:30:00',4.75),('11288','2014-03-03','14:35:00',4.66),('11288','2014-03-03','14:40:00',4.51),('11288','2014-03-03','14:45:00',4.4),('11288','2014-03-03','14:50:00',4.29),('11288','2014-03-03','14:55:00',4.15),('11288','2014-03-03','15:00:00',4.01),('11288','2014-03-03','15:05:00',3.94),('11288','2014-03-03','15:10:00',3.72),('11288','2014-03-03','15:15:00',3.67),('11288','2014-03-03','15:20:00',3.56),('11288','2014-03-03','15:25:00',3.45),('11288','2014-03-03','15:30:00',3.25),('11288','2014-03-03','15:35:00',2.87),('11288','2014-03-03','15:40:00',2.96),('11288','2014-03-03','15:45:00',2.83),('11288','2014-03-03','15:50:00',2.7),('11288','2014-03-03','15:55:00',2.48),('11288','2014-03-03','16:00:00',2.4),('11288','2014-03-03','16:05:00',2.24),('11288','2014-03-03','16:10:00',2.02),('11288','2014-03-03','16:15:00',1.98),('11288','2014-03-03','16:20:00',1.75),('11288','2014-03-03','16:25:00',1.56),('11288','2014-03-03','16:30:00',1.52),('11288','2014-03-03','16:35:00',1.4),('11288','2014-03-03','16:40:00',1.24),('11288','2014-03-03','16:45:00',1.12),('11288','2014-03-02','08:00:00',1.12),('11288','2014-03-02','08:05:00',1.31),('11288','2014-03-02','08:10:00',2.22),('11288','2014-03-02','08:15:00',2.15),('11288','2014-03-02','08:20:00',2.06),('11288','2014-03-02','08:25:00',1.93),('11288','2014-03-02','08:30:00',2.05),('11288','2014-03-02','08:35:00',1.99),('11288','2014-03-02','08:40:00',2.18),('11288','2014-03-02','08:45:00',2.47),('11288','2014-03-02','08:50:00',2.61),('11288','2014-03-02','08:55:00',2.78),('11288','2014-03-02','09:00:00',3.02),('11288','2014-03-02','09:05:00',3.21),('11288','2014-03-02','09:10:00',3.45),('11288','2014-03-02','09:15:00',3.54),('11288','2014-03-02','09:20:00',2.84),('11288','2014-03-02','09:25:00',3.93),('11288','2014-03-02','09:30:00',4.15),('11288','2014-03-02','09:35:00',4.12),('11288','2014-03-02','09:40:00',3.33),('11288','2014-03-02','09:45:00',1.23),('11288','2014-03-02','09:50:00',1.26),('11288','2014-03-02','09:55:00',2.19),('11288','2014-03-02','10:00:00',2.66),('11288','2014-03-02','10:05:00',2.76),('11288','2014-03-02','10:10:00',2.37),('11288','2014-03-02','10:15:00',2.24),('11288','2014-03-02','10:20:00',2.28),('11288','2014-03-02','10:25:00',2.58),('11288','2014-03-02','10:30:00',2.7),('11288','2014-03-02','10:35:00',4.06),('11288','2014-03-02','10:40:00',2.84),('11288','2014-03-02','10:45:00',1.69),('11288','2014-03-02','10:50:00',2.74),('11288','2014-03-02','10:55:00',2.3),('11288','2014-03-02','11:00:00',5.23),('11288','2014-03-02','11:05:00',3.85),('11288','2014-03-02','11:10:00',2.65),('11288','2014-03-02','11:15:00',2.28),('11288','2014-03-02','11:20:00',3.1),('11288','2014-03-02','11:25:00',3.28),('11288','2014-03-02','11:30:00',3.98),('11288','2014-03-02','11:35:00',4.63),('11288','2014-03-02','11:40:00',4.65),('11288','2014-03-02','11:45:00',7.46),('11288','2014-03-02','11:50:00',6.96),('11288','2014-03-02','11:55:00',6.11),('11288','2014-03-02','12:00:00',4.04),('11288','2014-03-02','12:05:00',3.16),('11288','2014-03-02','12:10:00',3.29),('11288','2014-03-02','12:15:00',4.09),('11288','2014-03-02','12:20:00',3.73),('11288','2014-03-02','12:25:00',3.75),('11288','2014-03-02','12:30:00',2.46),('11288','2014-03-02','12:35:00',2.03),('11288','2014-03-02','12:40:00',1.59),('11288','2014-03-02','12:45:00',1.65),('11288','2014-03-02','12:50:00',1.92),('11288','2014-03-02','12:55:00',2.3),('11288','2014-03-02','13:00:00',2.57),('11288','2014-03-02','13:05:00',2.68),('11288','2014-03-02','13:10:00',2.58),('11288','2014-03-02','13:15:00',2.29),('11288','2014-03-02','13:20:00',2.13),('11288','2014-03-02','13:25:00',2.04),('11288','2014-03-02','13:30:00',1.95),('11288','2014-03-02','13:35:00',1.78),('11288','2014-03-02','13:40:00',1.6),('11288','2014-03-02','13:45:00',1.61),('11288','2014-03-02','13:50:00',1.81),('11288','2014-03-02','13:55:00',1.94),('11288','2014-03-02','14:00:00',2.3),('11288','2014-03-02','14:05:00',2.48),('11288','2014-03-02','14:10:00',2.35),('11288','2014-03-02','14:15:00',2.24),('11288','2014-03-02','14:20:00',2.07),('11288','2014-03-02','14:25:00',2.07),('11288','2014-03-02','14:30:00',2.14),('11288','2014-03-02','14:35:00',2.15),('11288','2014-03-02','14:40:00',2.11),('11288','2014-03-02','14:45:00',2.18),('11288','2014-03-02','14:50:00',2.18),('11288','2014-03-02','14:55:00',2.15),('11288','2014-03-02','15:00:00',2.22),('11288','2014-03-02','15:05:00',2.33),('11288','2014-03-02','15:10:00',2.36),('11288','2014-03-02','15:15:00',2.32),('11288','2014-03-02','15:20:00',2.33),('11288','2014-03-02','15:25:00',2.26),('11288','2014-03-02','15:30:00',2.31),('11288','2014-03-02','15:35:00',2.25),('11288','2014-03-02','15:40:00',2.23),('11288','2014-03-02','15:45:00',1.91),('11288','2014-03-02','15:50:00',1.76),('11288','2014-03-02','15:55:00',1.59),('11288','2014-03-02','16:00:00',1.44),('11288','2014-03-02','16:05:00',1.3),('11288','2014-03-02','16:10:00',1.14),('11288','2014-03-02','16:15:00',1.01),('11288','2014-03-01','12:30:00',1.06),('11288','2014-03-01','12:40:00',1.1),('11288','2014-03-01','14:40:00',1.18),('11288','2014-03-01','14:45:00',1.35),('11288','2014-03-01','14:50:00',1.26),('11288','2014-03-01','14:55:00',1.13),('11288','2014-02-28','07:55:00',1.16),('11288','2014-02-28','08:00:00',1.57),('11288','2014-02-28','08:05:00',1.61),('11288','2014-02-28','08:10:00',1.23),('11288','2014-02-28','08:15:00',1.39),('11288','2014-02-28','08:20:00',2.13),('11288','2014-02-28','08:25:00',1.57),('11288','2014-02-28','08:30:00',1.21),('11288','2014-02-28','08:35:00',2.46),('11288','2014-02-28','09:10:00',1.55),('11288','2014-02-28','09:15:00',1.97),('11288','2014-02-28','09:20:00',1.94),('11288','2014-02-28','09:25:00',2.37),('11288','2014-02-28','09:30:00',2.73),('11288','2014-02-28','09:35:00',1.01),('11288','2014-02-28','09:40:00',3.16),('11288','2014-02-28','09:45:00',4.24),('11288','2014-02-28','09:50:00',5.18),('11288','2014-02-28','09:55:00',3.36),('11288','2014-02-28','10:00:00',1.99),('11288','2014-02-28','10:05:00',2.09),('11288','2014-02-28','10:10:00',2.47),('11288','2014-02-28','10:15:00',1.99),('11288','2014-02-28','10:20:00',2.9),('11288','2014-02-28','10:25:00',3.82),('11288','2014-02-28','10:30:00',5.33),('11288','2014-02-28','10:35:00',4.19),('11288','2014-02-28','10:40:00',2.16),('11288','2014-02-28','10:45:00',1.39),('11288','2014-02-28','11:00:00',1.11),('11288','2014-02-28','11:05:00',1.55),('11288','2014-02-28','11:10:00',1.63),('11288','2014-02-28','11:15:00',1.91),('11288','2014-02-28','11:20:00',2.44),('11288','2014-02-28','11:25:00',2.34),('11288','2014-02-28','11:30:00',1.9),('11288','2014-02-28','11:35:00',1.39),('11288','2014-02-28','11:40:00',1.33),('11288','2014-02-28','11:45:00',1.73),('11288','2014-02-28','11:50:00',1.96),('11288','2014-02-28','11:55:00',2.11),('11288','2014-02-28','12:00:00',2.68),('11288','2014-02-28','12:05:00',3.79),('11288','2014-02-28','12:10:00',3.3),('11288','2014-02-28','12:15:00',1.97),('11288','2014-02-28','12:20:00',1.85),('11288','2014-02-28','12:25:00',3.5),('11288','2014-02-28','12:30:00',3.26),('11288','2014-02-28','12:35:00',5.89),('11288','2014-02-28','12:40:00',3.69),('11288','2014-02-28','12:45:00',2.26),('11288','2014-02-28','12:50:00',4.13),('11288','2014-02-28','12:55:00',2.78),('11288','2014-02-28','13:00:00',4.22),('11288','2014-02-28','13:05:00',3.09),('11288','2014-02-28','13:10:00',2.78),('11288','2014-02-28','13:15:00',1.85),('11288','2014-02-28','13:45:00',2.14),('11288','2014-02-28','13:50:00',7.13),('11288','2014-02-28','13:55:00',3.89),('11288','2014-02-28','14:00:00',2.44),('11288','2014-02-28','14:05:00',1.57),('11288','2014-02-28','14:10:00',1.45),('11288','2014-02-28','14:15:00',2.16),('11288','2014-02-28','14:20:00',2.63),('11288','2014-02-28','14:25:00',4.15),('11288','2014-02-28','14:30:00',3.28),('11288','2014-02-28','14:35:00',2.55),('11288','2014-02-28','14:40:00',2.38),('11288','2014-02-28','14:45:00',2.26),('11288','2014-02-28','14:50:00',2.46),('11288','2014-02-28','14:55:00',2.66),('11288','2014-02-28','15:00:00',3.63),('11288','2014-02-28','15:05:00',2.28),('11288','2014-02-28','15:10:00',1.13),('11288','2014-02-28','15:20:00',1.33),('11288','2014-02-28','15:25:00',3.46),('11288','2014-02-28','15:30:00',3.36),('11288','2014-02-28','15:35:00',2.98),('11288','2014-02-28','15:40:00',2.91),('11288','2014-02-28','15:45:00',1.31),('11288','2014-02-28','16:10:00',1.77),('11288','2014-02-28','16:15:00',2.83),('11288','2014-02-28','16:20:00',2.25),('11288','2014-02-28','16:25:00',1.18),('11288','2014-02-28','16:35:00',1.34),('11288','2014-02-28','16:40:00',1.73),('11288','2014-02-28','16:45:00',1.99),('11288','2014-02-28','16:50:00',1.74),('11288','2014-02-27','10:25:00',1.09),('11288','2014-02-27','10:30:00',1.52),('11288','2014-02-27','10:35:00',1.77),('11288','2014-02-27','10:40:00',2.08),('11288','2014-02-27','10:45:00',2.25),('11288','2014-02-27','10:50:00',2.34),('11288','2014-02-27','10:55:00',2.42),('11288','2014-02-27','11:00:00',2.76),('11288','2014-02-27','11:05:00',3.02),('11288','2014-02-27','11:10:00',2.85),('11288','2014-02-27','11:15:00',2.8),('11288','2014-02-27','11:20:00',2.54),('11288','2014-02-27','11:25:00',2.91),('11288','2014-02-27','11:30:00',3.39),('11288','2014-02-27','11:35:00',3.08),('11288','2014-02-27','11:40:00',2.64),('11288','2014-02-27','11:45:00',2.28),('11288','2014-02-27','11:50:00',2.25),('11288','2014-02-27','11:55:00',2.34),('11288','2014-02-27','12:00:00',2.26),('11288','2014-02-27','12:05:00',2.21),('11288','2014-02-27','12:10:00',2.04),('11288','2014-02-27','12:15:00',2.22),('11288','2014-02-27','12:20:00',2.35),('11288','2014-02-27','12:25:00',2.37),('11288','2014-02-27','12:30:00',2.2),('11288','2014-02-27','12:35:00',2.14),('11288','2014-02-27','12:40:00',2.1),('11288','2014-02-27','12:45:00',2.09),('11288','2014-02-27','12:50:00',2.06),('11288','2014-02-27','12:55:00',2.11),('11288','2014-02-27','13:00:00',2.22),('11288','2014-02-27','13:05:00',2.05),('11288','2014-02-27','13:10:00',2.15),('11288','2014-02-27','13:15:00',2.32),('11288','2014-02-27','13:20:00',2.32),('11288','2014-02-27','13:25:00',2.43),('11288','2014-02-27','13:30:00',2.76),('11288','2014-02-27','13:35:00',2.95),('11288','2014-02-27','13:40:00',3),('11288','2014-02-27','13:45:00',2.98),('11288','2014-02-27','13:50:00',3.07),('11288','2014-02-27','13:55:00',3.37),('11288','2014-02-27','14:00:00',3.36),('11288','2014-02-27','14:05:00',2.97),('11288','2014-02-27','14:10:00',2.67),('11288','2014-02-27','14:15:00',2.52),('11288','2014-02-27','14:20:00',2.54),('11288','2014-02-27','14:25:00',2.53),('11288','2014-02-27','14:30:00',2.58),('11288','2014-02-27','14:35:00',2.45),('11288','2014-02-27','14:40:00',2.21),('11288','2014-02-27','14:45:00',2.31),('11288','2014-02-27','14:50:00',2.19),('11288','2014-02-27','14:55:00',2.03),('11288','2014-02-27','15:00:00',2.12),('11288','2014-02-27','15:05:00',2.07),('11288','2014-02-27','15:10:00',2.16),('11288','2014-02-27','15:15:00',2.45),('11288','2014-02-27','15:20:00',2.57),('11288','2014-02-27','15:25:00',2.27),('11288','2014-02-27','15:30:00',2.21),('11288','2014-02-27','15:35:00',2.21),('11288','2014-02-27','15:40:00',1.77),('11288','2014-02-27','15:45:00',1.4),('11288','2014-02-27','15:50:00',1.14),('11288','2014-02-27','15:55:00',1.02),('11288','2014-02-27','16:00:00',1.08),('11288','2014-02-27','16:05:00',1.04),('11288','2014-02-27','16:30:00',1.02),('11288','2014-02-27','16:35:00',1.3),('11288','2014-02-27','16:40:00',1.74),('11288','2014-02-27','16:45:00',1.84),('11288','2014-02-27','16:50:00',1.89),('11288','2014-02-27','16:55:00',1.66),('11288','2014-02-27','17:00:00',1.35),('11288','2014-02-27','17:05:00',1.09),('11288','2014-02-26','08:00:00',1.05),('11288','2014-02-26','08:05:00',1.14),('11288','2014-02-26','08:10:00',1.22),('11288','2014-02-26','08:15:00',1.48),('11288','2014-02-26','08:20:00',1.57),('11288','2014-02-26','08:25:00',1.68),('11288','2014-02-26','08:30:00',1.78),('11288','2014-02-26','08:35:00',1.81),('11288','2014-02-26','08:40:00',2.08),('11288','2014-02-26','08:45:00',2.64),('11288','2014-02-26','08:50:00',2.57),('11288','2014-02-26','08:55:00',2.56),('11288','2014-02-26','09:00:00',2.66),('11288','2014-02-26','09:05:00',2.66),('11288','2014-02-26','09:10:00',2.81),('11288','2014-02-26','09:15:00',2.94),('11288','2014-02-26','09:20:00',3.16),('11288','2014-02-26','09:25:00',3.59),('11288','2014-02-26','09:30:00',2.74),('11288','2014-02-26','09:35:00',2.44),('11288','2014-02-26','09:40:00',2.54),('11288','2014-02-26','09:45:00',2.61),('11288','2014-02-26','09:50:00',2.6),('11288','2014-02-26','09:55:00',2.16),('11288','2014-02-26','10:00:00',2.09),('11288','2014-02-26','10:05:00',1.65),('11288','2014-02-26','10:10:00',1.39),('11288','2014-02-26','10:15:00',1.47),('11288','2014-02-26','10:20:00',1.62),('11288','2014-02-26','10:25:00',1.47),('11288','2014-02-26','10:30:00',1.52),('11288','2014-02-26','10:35:00',1.41),('11288','2014-02-26','10:40:00',1.26),('11288','2014-02-26','10:45:00',1.05),('11288','2014-02-26','10:50:00',1.08),('11288','2014-02-26','10:55:00',1.42),('11288','2014-02-26','11:00:00',1.85),('11288','2014-02-26','11:05:00',1.86),('11288','2014-02-26','11:10:00',1.83),('11288','2014-02-26','11:15:00',1.71),('11288','2014-02-26','11:20:00',1.18),('11288','2014-02-26','11:25:00',1.13),('11288','2014-02-26','11:30:00',1.42),('11288','2014-02-26','11:35:00',1.36),('11288','2014-02-26','11:40:00',1.25),('11288','2014-02-26','11:45:00',1.6),('11288','2014-02-26','11:50:00',1.94),('11288','2014-02-26','11:55:00',2.11),('11288','2014-02-26','12:00:00',2.4),('11288','2014-02-26','12:05:00',2.52),('11288','2014-02-26','12:10:00',2.38),('11288','2014-02-26','12:15:00',2.05),('11288','2014-02-26','12:20:00',2.47),('11288','2014-02-26','12:25:00',3.28),('11288','2014-02-26','12:30:00',4.51),('11288','2014-02-26','12:35:00',4.3),('11288','2014-02-26','12:40:00',6.02),('11288','2014-02-26','12:45:00',4.66),('11288','2014-02-26','12:50:00',5.14),('11288','2014-02-26','12:55:00',5.65),('11288','2014-02-26','13:00:00',4.3),('11288','2014-02-26','13:05:00',4.09),('11288','2014-02-26','13:10:00',4.63),('11288','2014-02-26','13:15:00',4.67),('11288','2014-02-26','13:20:00',4.25),('11288','2014-02-26','13:25:00',4.93),('11288','2014-02-26','13:30:00',5.79),('11288','2014-02-26','13:35:00',5.2),('11288','2014-02-26','13:40:00',5.46),('11288','2014-02-26','13:45:00',2.88),('11288','2014-02-26','13:50:00',2.4),('11288','2014-02-26','13:55:00',4.85),('11288','2014-02-26','14:00:00',5.52),('11288','2014-02-26','14:05:00',2.27),('11288','2014-02-26','14:10:00',3.36),('11288','2014-02-26','14:15:00',5.34),('11288','2014-02-26','14:20:00',5.15),('11288','2014-02-26','14:25:00',4.86),('11288','2014-02-26','14:30:00',1.75),('11288','2014-02-26','14:35:00',4.99),('11288','2014-02-26','14:40:00',4.59),('11288','2014-02-26','14:45:00',3.92),('11288','2014-02-26','14:50:00',4.25),('11288','2014-02-26','14:55:00',4.4),('11288','2014-02-26','15:00:00',2.8),('11288','2014-02-26','15:05:00',3.66),('11288','2014-02-26','15:10:00',3.73),('11288','2014-02-26','15:15:00',3.18),('11288','2014-02-26','15:20:00',2.56),('11288','2014-02-26','15:25:00',1.98),('11288','2014-02-26','15:30:00',1.93),('11288','2014-02-26','15:35:00',2.42),('11288','2014-02-26','15:40:00',2.37),('11288','2014-02-26','15:45:00',1.85),('11288','2014-02-26','15:50:00',1.92),('11288','2014-02-26','15:55:00',2.19),('11288','2014-02-26','16:00:00',2.49),('11288','2014-02-26','16:05:00',2.23),('11288','2014-02-26','16:10:00',1.41),('11288','2014-02-26','16:15:00',1.38),('11288','2014-02-26','16:20:00',1.32),('11288','2014-04-29','09:40:00',1.04),('11288','2014-04-29','09:45:00',1.43),('11288','2014-04-29','09:50:00',1.91),('11288','2014-04-29','09:55:00',2.08),('11288','2014-04-29','10:00:00',2.16),('11288','2014-04-29','10:05:00',3.51),('11288','2014-04-29','10:10:00',6.24),('11288','2014-04-29','10:15:00',4.83),('11288','2014-04-29','10:20:00',5.22),('11288','2014-04-29','10:25:00',6.67),('11288','2014-04-29','10:30:00',6.22),('11288','2014-04-29','10:35:00',6.35),('11288','2014-04-29','10:40:00',6.52),('11288','2014-04-29','10:45:00',6.54),('11288','2014-04-29','10:50:00',6.7),('11288','2014-04-29','10:55:00',6.3),('11288','2014-04-29','11:00:00',6.61),('11288','2014-04-29','11:05:00',6.63),('11288','2014-04-29','11:10:00',5.58),('11288','2014-04-29','11:15:00',7.4),('11288','2014-04-29','11:20:00',4.06),('11288','2014-04-29','11:25:00',4.68),('11288','2014-04-29','11:30:00',2.52),('11288','2014-04-29','11:35:00',4.9),('11288','2014-04-29','11:40:00',6.14),('11288','2014-04-29','11:45:00',2.41),('11288','2014-04-29','11:50:00',1.9),('11288','2014-04-29','11:55:00',2.01),('11288','2014-04-29','12:00:00',2.84),('11288','2014-04-29','12:05:00',3.08),('11288','2014-04-29','12:10:00',3.1),('11288','2014-04-29','12:15:00',3.03),('11288','2014-04-29','12:20:00',4.72),('11288','2014-04-29','12:25:00',2.96),('11288','2014-04-29','12:30:00',2.73),('11288','2014-04-29','12:35:00',3.23),('11288','2014-04-29','12:40:00',3.06),('11288','2014-04-29','12:45:00',5.89),('11288','2014-04-29','12:50:00',3.16),('11288','2014-04-29','12:55:00',3.27),('11288','2014-04-29','13:00:00',4.6),('11288','2014-04-29','13:05:00',5.27),('11288','2014-04-29','13:10:00',5.06),('11288','2014-04-29','13:15:00',5.13),('11288','2014-04-29','13:20:00',6.01),('11288','2014-04-29','13:25:00',6.95),('11288','2014-04-29','13:30:00',4.02),('11288','2014-04-29','13:35:00',2.56),('11288','2014-04-29','13:40:00',2.92),('11288','2014-04-29','13:45:00',5.01),('11288','2014-04-29','13:50:00',4.77),('11288','2014-04-29','13:55:00',1.79),('11288','2014-04-29','14:00:00',1.01),('11288','2014-04-29','14:25:00',1.01),('11288','2014-04-29','14:40:00',1.15),('11288','2014-04-29','14:45:00',1.13),('11288','2014-04-29','14:55:00',1.02),('11288','2014-04-29','15:00:00',1.21),('11288','2014-04-29','15:05:00',1.65),('11288','2014-04-29','15:10:00',1.37),('11288','2014-04-29','15:15:00',1.05),('11288','2014-04-29','15:20:00',1.02),('11288','2014-04-29','15:25:00',1.33),('11288','2014-04-29','15:30:00',1.48),('11288','2014-04-29','15:35:00',1.51),('11288','2014-04-29','15:40:00',1.12),('11288','2014-04-29','16:05:00',1.1),('11288','2014-04-29','16:10:00',1.26),('11288','2014-04-29','16:15:00',1.52),('11288','2014-04-29','16:20:00',1.62),('11288','2014-04-29','16:25:00',1.73),('11288','2014-04-29','16:30:00',1.49),('11288','2014-04-29','16:35:00',1.25),('11288','2014-04-29','16:40:00',1.07),('11288','2014-04-29','16:45:00',1.04),('11288','2014-04-29','16:50:00',1.13),('11288','2014-04-29','16:55:00',1.35),('11288','2014-04-29','17:00:00',1.64),('11288','2014-04-29','17:05:00',2.11),('11288','2014-04-29','17:10:00',1.95),('11288','2014-04-29','17:15:00',1.59),('11288','2014-04-29','17:20:00',2.12),('11288','2014-04-29','17:25:00',2.42),('11288','2014-04-29','17:30:00',2.38),('11288','2014-04-29','17:35:00',1.63),('11288','2014-04-29','17:40:00',3.07),('11288','2014-04-29','17:45:00',2.86),('11288','2014-04-29','17:50:00',1.71),('11288','2014-04-29','18:00:00',1.16),('11288','2014-04-29','18:05:00',1.36),('11288','2014-02-25','08:05:00',1.06),('11288','2014-02-25','08:10:00',1.08),('11288','2014-02-25','08:15:00',1.33),('11288','2014-02-25','08:20:00',1.49),('11288','2014-02-25','08:25:00',1.58),('11288','2014-02-25','08:30:00',1.73),('11288','2014-02-25','08:35:00',1.87),('11288','2014-02-25','08:40:00',2.01),('11288','2014-02-25','08:45:00',2.18),('11288','2014-02-25','08:50:00',2.25),('11288','2014-02-25','08:55:00',2.36),('11288','2014-02-25','09:00:00',2.54),('11288','2014-02-25','09:05:00',2.65),('11288','2014-02-25','09:10:00',2.81),('11288','2014-02-25','09:15:00',2.91),('11288','2014-02-25','09:20:00',3.07),('11288','2014-02-25','09:25:00',3.12),('11288','2014-02-25','09:30:00',3.27),('11288','2014-02-25','09:35:00',3.39),('11288','2014-02-25','09:40:00',3.5),('11288','2014-02-25','09:45:00',3.6),('11288','2014-02-25','09:50:00',3.64),('11288','2014-02-25','09:55:00',3.76),('11288','2014-02-25','10:00:00',3.94),('11288','2014-02-25','10:05:00',4.08),('11288','2014-02-25','10:10:00',4.18),('11288','2014-02-25','10:15:00',4.25),('11288','2014-02-25','10:20:00',4.33),('11288','2014-02-25','10:25:00',4.4),('11288','2014-02-25','10:30:00',4.45),('11288','2014-02-25','10:35:00',4.51),('11288','2014-02-25','10:40:00',4.58),('11288','2014-02-25','10:45:00',4.62),('11288','2014-02-25','10:50:00',4.65),('11288','2014-02-25','10:55:00',4.77),('11288','2014-02-25','11:00:00',4.76),('11288','2014-02-25','11:05:00',4.81),('11288','2014-02-25','11:10:00',4.84),('11288','2014-02-25','11:15:00',4.96),('11288','2014-02-25','11:20:00',4.97),('11288','2014-02-25','11:25:00',5.02),('11288','2014-02-25','11:30:00',5.07),('11288','2014-02-25','11:35:00',5.13),('11288','2014-02-25','11:40:00',5.18),('11288','2014-02-25','11:45:00',5.13),('11288','2014-02-25','11:50:00',5.19),('11288','2014-02-25','11:55:00',5.15),('11288','2014-02-25','12:00:00',5.18),('11288','2014-02-25','12:05:00',5.23),('11288','2014-02-25','12:10:00',5.3),('11288','2014-02-25','12:15:00',5.29),('11288','2014-02-25','12:20:00',5.35),('11288','2014-02-25','12:25:00',5.35),('11288','2014-02-25','12:30:00',5.28),('11288','2014-02-25','12:35:00',5.23),('11288','2014-02-25','12:40:00',5.27),('11288','2014-02-25','12:45:00',5.22),('11288','2014-02-25','12:50:00',5.23),('11288','2014-02-25','12:55:00',5.16),('11288','2014-02-25','13:00:00',5.06),('11288','2014-02-25','13:05:00',4.96),('11288','2014-02-25','13:10:00',2.91),('11288','2014-02-25','13:15:00',1.28),('11288','2014-02-25','13:20:00',1.38),('11288','2014-02-25','13:25:00',1.45),('11288','2014-02-25','13:30:00',1.48),('11288','2014-02-25','13:35:00',2.07),('11288','2014-02-25','13:40:00',2.27),('11288','2014-02-25','13:45:00',2.04),('11288','2014-02-25','13:50:00',1.85),('11288','2014-02-25','13:55:00',2.24),('11288','2014-02-25','14:00:00',2.13),('11288','2014-02-25','14:05:00',1.94),('11288','2014-02-25','14:10:00',1.87),('11288','2014-02-25','14:15:00',1.93),('11288','2014-02-25','14:20:00',2.04),('11288','2014-02-25','14:25:00',2.89),('11288','2014-02-25','14:30:00',3.22),('11288','2014-02-25','14:35:00',4.05),('11288','2014-02-25','14:40:00',4.4),('11288','2014-02-25','14:45:00',4.34),('11288','2014-02-25','14:50:00',3.04),('11288','2014-02-25','14:55:00',1.75),('11288','2014-02-25','15:00:00',3.14),('11288','2014-02-25','15:05:00',3.64),('11288','2014-02-25','15:10:00',3.48),('11288','2014-02-25','15:15:00',3.25),('11288','2014-02-25','15:20:00',3.12),('11288','2014-02-25','15:25:00',2.53),('11288','2014-02-25','15:30:00',2.46),('11288','2014-02-25','15:35:00',2.22),('11288','2014-02-25','15:40:00',2.28),('11288','2014-02-25','15:45:00',1.51),('11288','2014-02-25','15:50:00',1.3),('11288','2014-02-25','15:55:00',1.44),('11288','2014-02-25','16:00:00',1.21),('11288','2014-02-25','16:05:00',1.39),('11288','2014-02-25','16:10:00',1.27),('11288','2014-02-25','16:15:00',1.36),('11288','2014-02-25','16:20:00',1.4),('11288','2014-02-25','16:25:00',1.12),('11288','2014-02-24','08:00:00',1.1),('11288','2014-02-24','08:05:00',1.42),('11288','2014-02-24','08:10:00',1.47),('11288','2014-02-24','08:15:00',1.79),('11288','2014-02-24','08:20:00',1.9),('11288','2014-02-24','08:25:00',1.95),('11288','2014-02-24','08:30:00',1.83),('11288','2014-02-24','08:35:00',2.12),('11288','2014-02-24','08:40:00',1.65),('11288','2014-02-24','08:45:00',1.49),('11288','2014-02-24','08:50:00',1.81),('11288','2014-02-24','08:55:00',2.11),('11288','2014-02-24','09:00:00',2.34),('11288','2014-02-24','09:05:00',2.59),('11288','2014-02-24','09:10:00',2.66),('11288','2014-02-24','09:15:00',2.78),('11288','2014-02-24','09:20:00',3),('11288','2014-02-24','09:25:00',3.09),('11288','2014-02-24','09:30:00',3.22),('11288','2014-02-24','09:35:00',3.37),('11288','2014-02-24','09:40:00',3.49),('11288','2014-02-24','09:45:00',3.62),('11288','2014-02-24','09:50:00',3.57),('11288','2014-02-24','09:55:00',3.74),('11288','2014-02-24','10:00:00',3.94),('11288','2014-02-24','10:05:00',4.08),('11288','2014-02-24','10:10:00',4.18),('11288','2014-02-24','10:15:00',4.27),('11288','2014-02-24','10:20:00',4.37),('11288','2014-02-24','10:25:00',4.47),('11288','2014-02-24','10:30:00',4.54),('11288','2014-02-24','10:35:00',4.61),('11288','2014-02-24','10:40:00',4.64),('11288','2014-02-24','10:45:00',4.66),('11288','2014-02-24','10:50:00',4.79),('11288','2014-02-24','10:55:00',4.89),('11288','2014-02-24','11:00:00',4.92),('11288','2014-02-24','11:05:00',4.98),('11288','2014-02-24','11:10:00',5.04),('11288','2014-02-24','11:15:00',5.12),('11288','2014-02-24','11:20:00',5.18),('11288','2014-02-24','11:25:00',5.32),('11288','2014-02-24','11:30:00',5.84),('11288','2014-02-24','11:35:00',4.19),('11288','2014-02-24','11:40:00',4.51),('11288','2014-02-24','11:45:00',5.34),('11288','2014-02-24','11:50:00',5.36),('11288','2014-02-24','11:55:00',4.22),('11288','2014-02-24','12:00:00',5.27),('11288','2014-02-24','12:05:00',5.55),('11288','2014-02-24','12:10:00',5.6),('11288','2014-02-24','12:15:00',5.51),('11288','2014-02-24','12:20:00',5.56),('11288','2014-02-24','12:25:00',5.4),('11288','2014-02-24','12:30:00',1.81),('11288','2014-02-24','12:35:00',6.02),('11288','2014-02-24','12:40:00',6.11),('11288','2014-02-24','12:45:00',5.97),('11288','2014-02-24','12:50:00',5.76),('11288','2014-02-24','12:55:00',3.86),('11288','2014-02-24','13:00:00',4.86),('11288','2014-02-24','13:05:00',4.05),('11288','2014-02-24','13:10:00',5.95),('11288','2014-02-24','13:15:00',4.58),('11288','2014-02-24','13:20:00',1.99),('11288','2014-02-24','13:25:00',1.63),('11288','2014-02-24','13:30:00',1.45),('11288','2014-02-24','13:35:00',1.4),('11288','2014-02-24','13:40:00',1.39),('11288','2014-02-24','13:45:00',1.35),('11288','2014-02-24','13:50:00',1.31),('11288','2014-02-24','13:55:00',1.39),('11288','2014-02-24','14:00:00',1.51),('11288','2014-02-24','14:05:00',1.61),('11288','2014-02-24','14:10:00',1.75),('11288','2014-02-24','14:15:00',1.79),('11288','2014-02-24','14:20:00',1.75),('11288','2014-02-24','14:25:00',1.78),('11288','2014-02-24','14:30:00',1.87),('11288','2014-02-24','14:35:00',1.81),('11288','2014-02-24','14:40:00',1.74),('11288','2014-02-24','14:45:00',1.82),('11288','2014-02-24','14:50:00',1.81),('11288','2014-02-24','14:55:00',1.52),('11288','2014-02-24','15:00:00',1.41),('11288','2014-02-24','15:05:00',1.45),('11288','2014-02-24','15:10:00',1.6),('11288','2014-02-24','15:15:00',1.76),('11288','2014-02-24','15:20:00',1.96),('11288','2014-02-24','15:25:00',2.02),('11288','2014-02-24','15:30:00',1.65),('11288','2014-02-24','15:35:00',3.36),('11288','2014-02-24','15:40:00',3.47),('11288','2014-02-24','15:45:00',3.09),('11288','2014-02-24','15:50:00',3.16),('11288','2014-02-24','15:55:00',2.97),('11288','2014-02-24','16:00:00',2.66),('11288','2014-02-24','16:05:00',2.8),('11288','2014-02-24','16:10:00',2.53),('11288','2014-02-24','16:15:00',2.3),('11288','2014-02-24','16:20:00',1.92),('11288','2014-02-24','16:25:00',1.55),('11288','2014-02-24','16:30:00',1.15),('11288','2014-02-23','08:05:00',1.04),('11288','2014-02-23','08:10:00',1.14),('11288','2014-02-23','08:15:00',1.14),('11288','2014-02-23','08:20:00',1.41),('11288','2014-02-23','08:25:00',1.52),('11288','2014-02-23','08:30:00',1.57),('11288','2014-02-23','08:35:00',1.81),('11288','2014-02-23','08:40:00',1.93),('11288','2014-02-23','08:45:00',2.07),('11288','2014-02-23','08:50:00',2.2),('11288','2014-02-23','08:55:00',2.33),('11288','2014-02-23','09:00:00',2.45),('11288','2014-02-23','09:05:00',2.6),('11288','2014-02-23','09:10:00',2.71),('11288','2014-02-23','09:15:00',2.69),('11288','2014-02-23','09:20:00',3.03),('11288','2014-02-23','09:25:00',2.77),('11288','2014-02-23','09:30:00',2.81),('11288','2014-02-23','09:35:00',3.26),('11288','2014-02-23','09:40:00',3.46),('11288','2014-02-23','09:45:00',3.58),('11288','2014-02-23','09:50:00',3.57),('11288','2014-02-23','09:55:00',3.74),('11288','2014-02-23','10:00:00',3.86),('11288','2014-02-23','10:05:00',3.98),('11288','2014-02-23','10:10:00',4.06),('11288','2014-02-23','10:15:00',4.05),('11288','2014-02-23','10:20:00',4.2),('11288','2014-02-23','10:25:00',4.36),('11288','2014-02-23','10:30:00',4.4),('11288','2014-02-23','10:35:00',4.44),('11288','2014-02-23','10:40:00',4.48),('11288','2014-02-23','10:45:00',4.5),('11288','2014-02-23','10:50:00',4.67),('11288','2014-02-23','10:55:00',4.74),('11288','2014-02-23','11:00:00',4.84),('11288','2014-02-23','11:05:00',4.88),('11288','2014-02-23','11:10:00',4.96),('11288','2014-02-23','11:15:00',5.15),('11288','2014-02-23','11:20:00',5.18),('11288','2014-02-23','11:25:00',5.17),('11288','2014-02-23','11:30:00',5.26),('11288','2014-02-23','11:35:00',5.22),('11288','2014-02-23','11:40:00',4.91),('11288','2014-02-23','11:45:00',5.53),('11288','2014-02-23','11:50:00',5.66),('11288','2014-02-23','11:55:00',5.54),('11288','2014-02-23','12:00:00',5.56),('11288','2014-02-23','12:05:00',2.44),('11288','2014-02-23','12:10:00',2.79),('11288','2014-02-23','12:15:00',5.76),('11288','2014-02-23','12:20:00',5.38),('11288','2014-02-23','12:25:00',3.52),('11288','2014-02-23','12:30:00',4.33),('11288','2014-02-23','12:35:00',5.84),('11288','2014-02-23','12:40:00',3.3),('11288','2014-02-23','12:45:00',4.02),('11288','2014-02-23','12:50:00',2.95),('11288','2014-02-23','12:55:00',3.16),('11288','2014-02-23','13:00:00',4.24),('11288','2014-02-23','13:05:00',5.5),('11288','2014-02-23','13:10:00',5.39),('11288','2014-02-23','13:15:00',5.3),('11288','2014-02-23','13:20:00',5.27),('11288','2014-02-23','13:25:00',5.24),('11288','2014-02-23','13:30:00',5.1),('11288','2014-02-23','13:35:00',4.98),('11288','2014-02-23','13:40:00',4.31),('11288','2014-02-23','13:45:00',3.84),('11288','2014-02-23','13:50:00',4.38),('11288','2014-02-23','13:55:00',1.88),('11288','2014-02-23','14:00:00',1.28),('11288','2014-02-23','14:05:00',4.32),('11288','2014-02-23','14:10:00',4.97),('11288','2014-02-23','14:15:00',3.72),('11288','2014-02-23','14:20:00',2.58),('11288','2014-02-23','14:25:00',4.02),('11288','2014-02-23','14:30:00',5.52),('11288','2014-02-23','14:35:00',4.46),('11288','2014-02-23','14:40:00',3.58),('11288','2014-02-23','14:45:00',2.72),('11288','2014-02-23','14:50:00',3.43),('11288','2014-02-23','14:55:00',1.91),('11288','2014-02-23','15:00:00',1.53),('11288','2014-02-22','09:00:00',1.05),('11288','2014-02-22','09:05:00',1.64),('11288','2014-02-22','09:10:00',1.68),('11288','2014-02-22','09:20:00',1.21),('11288','2014-02-22','09:25:00',1.45),('11288','2014-02-22','09:30:00',1.28),('11288','2014-02-22','09:35:00',1.52),('11288','2014-02-22','09:40:00',1.5),('11288','2014-02-22','09:45:00',1.53),('11288','2014-02-22','09:50:00',1.7),('11288','2014-02-22','09:55:00',1.67),('11288','2014-02-22','10:00:00',2.6),('11288','2014-02-22','10:05:00',2.73),('11288','2014-02-22','10:10:00',4.1),('11288','2014-02-22','10:15:00',3.27),('11288','2014-02-22','10:20:00',2.39),('11288','2014-02-22','10:25:00',3.48),('11288','2014-02-22','10:30:00',3.47),('11288','2014-02-22','10:35:00',2.98),('11288','2014-02-22','10:40:00',2.49),('11288','2014-02-22','10:45:00',5.09),('11288','2014-02-22','10:50:00',4.74),('11288','2014-02-22','10:55:00',1.79),('11288','2014-02-22','11:00:00',1.26),('11288','2014-02-22','11:05:00',1.1),('11288','2014-02-22','11:10:00',1.59),('11288','2014-02-22','11:15:00',1.18),('11288','2014-02-22','11:50:00',1.14),('11288','2014-02-22','11:55:00',1.4),('11288','2014-02-22','12:00:00',1.7),('11288','2014-02-22','12:05:00',2.52),('11288','2014-02-22','12:10:00',2.86),('11288','2014-02-22','12:15:00',3.13),('11288','2014-02-22','12:20:00',3.16),('11288','2014-02-22','12:25:00',2.79),('11288','2014-02-22','12:30:00',1.94),('11288','2014-02-22','12:35:00',2.14),('11288','2014-02-22','12:40:00',2.6),('11288','2014-02-22','12:45:00',5.47),('11288','2014-02-22','12:50:00',5.52),('11288','2014-02-22','12:55:00',2.58),('11288','2014-02-22','13:00:00',2.46),('11288','2014-02-22','13:05:00',4.14),('11288','2014-02-22','13:10:00',7.02),('11288','2014-02-22','13:15:00',4.25),('11288','2014-02-22','13:20:00',2.55),('11288','2014-02-22','13:25:00',1.57),('11288','2014-02-22','13:30:00',2.07),('11288','2014-02-22','13:35:00',3.31),('11288','2014-02-22','13:40:00',2.89),('11288','2014-02-22','13:45:00',2.6),('11288','2014-02-22','13:50:00',2.86),('11288','2014-02-22','13:55:00',5.35),('11288','2014-02-22','14:00:00',5.22),('11288','2014-02-22','14:05:00',2.29),('11288','2014-02-22','14:10:00',3.44),('11288','2014-02-22','14:15:00',4.37),('11288','2014-02-22','14:20:00',4.69),('11288','2014-02-22','14:25:00',3.82),('11288','2014-02-22','14:30:00',2.88),('11288','2014-02-22','14:35:00',3.12),('11288','2014-02-22','14:40:00',3.86),('11288','2014-02-22','14:45:00',4.43),('11288','2014-02-22','14:50:00',3.59),('11288','2014-02-22','14:55:00',1.62),('11288','2014-02-22','15:00:00',2.18),('11288','2014-02-22','15:05:00',3.6),('11288','2014-02-22','15:10:00',1.58),('11288','2014-02-22','15:15:00',1.54),('11288','2014-02-22','15:20:00',1.35),('11288','2014-02-22','15:25:00',1.22),('11288','2014-02-22','15:30:00',2.72),('11288','2014-02-22','15:35:00',1.64),('11288','2014-02-22','15:40:00',1.58),('11288','2014-02-22','15:45:00',2.57),('11288','2014-02-22','15:50:00',1.69),('11288','2014-02-22','15:55:00',1.42),('11288','2014-02-22','16:00:00',1.73),('11288','2014-02-22','16:10:00',1.8),('11288','2014-02-22','16:15:00',1.63),('11288','2014-02-22','16:20:00',1.47),('11288','2014-02-22','16:25:00',1.28),('11288','2014-02-22','16:30:00',1.17),('11288','2014-02-22','16:35:00',1.09),('11288','2014-02-21','08:35:00',1.1),('11288','2014-02-21','08:40:00',1.19),('11288','2014-02-21','08:45:00',1.28),('11288','2014-02-21','08:50:00',1.34),('11288','2014-02-21','08:55:00',1.41),('11288','2014-02-21','09:00:00',1.37),('11288','2014-02-21','09:05:00',1.35),('11288','2014-02-21','09:10:00',1.36),('11288','2014-02-21','09:15:00',1.46),('11288','2014-02-21','09:20:00',1.6),('11288','2014-02-21','09:25:00',1.59),('11288','2014-02-21','09:30:00',1.57),('11288','2014-02-21','09:35:00',1.69),('11288','2014-02-21','09:40:00',1.84),('11288','2014-02-21','09:45:00',2.06),('11288','2014-02-21','09:50:00',2.13),('11288','2014-02-21','09:55:00',2.04),('11288','2014-02-21','10:00:00',2.08),('11288','2014-02-21','10:05:00',2.37),('11288','2014-02-21','10:10:00',2.22),('11288','2014-02-21','10:15:00',2.57),('11288','2014-02-21','10:20:00',3.29),('11288','2014-02-21','10:25:00',3.56),('11288','2014-02-21','10:30:00',3.78),('11288','2014-02-21','10:35:00',2.86),('11288','2014-02-21','10:40:00',2.81),('11288','2014-02-21','10:45:00',2.62),('11288','2014-02-21','10:50:00',2.87),('11288','2014-02-21','10:55:00',3.49),('11288','2014-02-21','11:00:00',2.75),('11288','2014-02-21','11:05:00',2.72),('11288','2014-02-21','11:10:00',2.62),('11288','2014-02-21','11:15:00',2.85),('11288','2014-02-21','11:20:00',2.63),('11288','2014-02-21','11:25:00',2.75),('11288','2014-02-21','11:30:00',2.83),('11288','2014-02-21','11:35:00',2.88),('11288','2014-02-21','11:40:00',3.08),('11288','2014-02-21','11:45:00',2.69),('11288','2014-02-21','11:50:00',2.53),('11288','2014-02-21','11:55:00',2.67),('11288','2014-02-21','12:00:00',2.54),('11288','2014-02-21','12:05:00',5.29),('11288','2014-02-21','12:10:00',5.87),('11288','2014-02-21','12:15:00',5.31),('11288','2014-02-21','12:20:00',5.3),('11288','2014-02-21','12:25:00',3.61),('11288','2014-02-21','12:30:00',2.4),('11288','2014-02-21','12:35:00',2.07),('11288','2014-02-21','12:40:00',1.73),('11288','2014-02-21','12:45:00',1.4),('11288','2014-02-21','12:50:00',1.28),('11288','2014-02-21','12:55:00',1),('11288','2014-02-21','13:40:00',1.01),('11288','2014-02-21','13:45:00',1.13),('11288','2014-02-21','13:50:00',1.18),('11288','2014-02-21','13:55:00',1.11),('11288','2014-02-21','14:10:00',1.02),('11288','2014-02-21','14:15:00',1.12),('11288','2014-02-21','14:20:00',1.24),('11288','2014-02-21','14:25:00',1.31),('11288','2014-02-21','14:30:00',1.34),('11288','2014-02-21','14:35:00',1.39),('11288','2014-02-21','14:40:00',1.55),('11288','2014-02-21','14:45:00',1.71),('11288','2014-02-21','14:50:00',1.69),('11288','2014-02-21','14:55:00',1.77),('11288','2014-02-21','15:00:00',1.89),('11288','2014-02-21','15:05:00',2.21),('11288','2014-02-21','15:10:00',1.75),('11288','2014-02-21','15:15:00',1),('11288','2014-02-21','15:20:00',1.1),('11288','2014-02-21','15:25:00',1.23),('11288','2014-02-21','15:30:00',1.44),('11288','2014-02-21','15:35:00',2.43),('11288','2014-02-21','15:40:00',2.47),('11288','2014-02-21','15:45:00',2.28),('11288','2014-02-21','15:50:00',2.06),('11288','2014-02-21','15:55:00',1.99),('11288','2014-02-21','16:00:00',1.88),('11288','2014-02-21','16:05:00',1.72),('11288','2014-02-21','16:10:00',1.52),('11288','2014-02-21','16:15:00',1.36),('11288','2014-02-21','16:20:00',1.28),('11288','2014-02-21','16:25:00',1.18),('11288','2014-02-21','16:30:00',1.04),('11288','2014-02-20','10:10:00',1.04),('11288','2014-02-20','10:45:00',1.24),('11288','2014-02-20','10:50:00',1.25),('11288','2014-02-20','10:55:00',1.4),('11288','2014-02-20','11:15:00',1.18),('11288','2014-02-20','11:20:00',1.95),('11288','2014-02-20','11:25:00',2.13),('11288','2014-02-20','11:30:00',2.12),('11288','2014-02-20','11:35:00',1.69),('11288','2014-02-20','11:40:00',1.22),('11288','2014-02-20','11:45:00',1.3),('11288','2014-02-20','11:50:00',1.35),('11288','2014-02-20','11:55:00',1.41),('11288','2014-02-20','12:00:00',1.58),('11288','2014-02-20','12:05:00',1.34),('11288','2014-02-20','12:10:00',1.35),('11288','2014-02-20','12:15:00',1.37),('11288','2014-02-20','12:20:00',1.65),('11288','2014-02-20','12:25:00',1.92),('11288','2014-02-20','12:30:00',1.81),('11288','2014-02-20','12:35:00',1.9),('11288','2014-02-20','12:40:00',2.13),('11288','2014-02-20','12:45:00',1.91),('11288','2014-02-20','12:50:00',1.87),('11288','2014-02-20','12:55:00',2.15),('11288','2014-02-20','13:00:00',2.54),('11288','2014-02-20','13:05:00',1.5),('11288','2014-02-20','13:10:00',1.32),('11288','2014-02-20','13:15:00',2.13),('11288','2014-02-20','13:20:00',1.69),('11288','2014-02-20','13:25:00',1.48),('11288','2014-02-20','13:30:00',2.17),('11288','2014-02-20','13:35:00',1.87),('11288','2014-02-20','13:40:00',1.33),('11288','2014-02-20','13:45:00',1.19),('11288','2014-02-20','13:50:00',1.13),('11288','2014-02-20','13:55:00',1.29),('11288','2014-02-20','14:00:00',1.75),('11288','2014-02-20','14:05:00',1.3),('11288','2014-02-20','14:15:00',1.16),('11288','2014-02-19','08:35:00',1.07),('11288','2014-02-19','08:40:00',1.16),('11288','2014-02-19','08:45:00',1.29),('11288','2014-02-19','08:50:00',1.19),('11288','2014-02-19','08:55:00',1.16),('11288','2014-02-19','09:00:00',1.25),('11288','2014-02-19','09:05:00',1.27),('11288','2014-02-19','09:10:00',1.24),('11288','2014-02-19','09:15:00',1.39),('11288','2014-02-19','09:20:00',1.55),('11288','2014-02-19','09:25:00',1.74),('11288','2014-02-19','09:30:00',1.79),('11288','2014-02-19','09:35:00',2),('11288','2014-02-19','09:40:00',2.16),('11288','2014-02-19','09:45:00',2.5),('11288','2014-02-19','09:50:00',2.37),('11288','2014-02-19','09:55:00',2.24),('11288','2014-02-19','10:00:00',2.18),('11288','2014-02-19','10:05:00',2.19),('11288','2014-02-19','10:10:00',2.36),('11288','2014-02-19','10:15:00',2.48),('11288','2014-02-19','10:20:00',2.28),('11288','2014-02-19','10:25:00',2.34),('11288','2014-02-19','10:30:00',2.47),('11288','2014-02-19','10:35:00',2.6),('11288','2014-02-19','10:40:00',2.93),('11288','2014-02-19','10:45:00',3.2),('11288','2014-02-19','10:50:00',3.01),('11288','2014-02-19','10:55:00',2.71),('11288','2014-02-19','11:00:00',2.49),('11288','2014-02-19','11:05:00',2.55),('11288','2014-02-19','11:10:00',2.85),('11288','2014-02-19','11:15:00',2.82),('11288','2014-02-19','11:20:00',3.03),('11288','2014-02-19','11:25:00',2.82),('11288','2014-02-19','11:30:00',2.63),('11288','2014-02-19','11:35:00',2.76),('11288','2014-02-19','11:40:00',2.56),('11288','2014-02-19','11:45:00',2.51),('11288','2014-02-19','11:50:00',2.55),('11288','2014-02-19','11:55:00',2.22),('11288','2014-02-19','12:00:00',2.26),('11288','2014-02-19','12:05:00',2.43),('11288','2014-02-19','12:10:00',2.35),('11288','2014-02-19','12:15:00',2.25),('11288','2014-02-19','12:20:00',1.99),('11288','2014-02-19','12:25:00',2.37),('11288','2014-02-19','12:30:00',2.62),('11288','2014-02-19','12:35:00',2.11),('11288','2014-02-19','12:40:00',2.02),('11288','2014-02-19','12:45:00',2.05),('11288','2014-02-19','12:50:00',1.66),('11288','2014-02-19','12:55:00',1.49),('11288','2014-02-19','13:00:00',1.66),('11288','2014-02-19','13:05:00',1.77),('11288','2014-02-19','13:10:00',1.78),('11288','2014-02-19','13:15:00',2.04),('11288','2014-02-19','13:20:00',1.96),('11288','2014-02-19','13:25:00',2.6),('11288','2014-02-19','13:30:00',2.58),('11288','2014-02-19','13:35:00',2.8),('11288','2014-02-19','13:40:00',2.61),('11288','2014-02-19','13:45:00',3.33),('11288','2014-02-19','13:50:00',3.38),('11288','2014-02-19','13:55:00',3.02),('11288','2014-02-19','14:00:00',2.81),('11288','2014-02-19','14:05:00',2.94),('11288','2014-02-19','14:10:00',2.4),('11288','2014-02-19','14:15:00',2.24),('11288','2014-02-19','14:20:00',3.35),('11288','2014-02-19','14:25:00',2.63),('11288','2014-02-19','14:30:00',2.54),('11288','2014-02-19','14:35:00',2.69),('11288','2014-02-19','14:40:00',2.24),('11288','2014-02-19','14:45:00',2.15),('11288','2014-02-19','14:50:00',2.69),('11288','2014-02-19','14:55:00',2.26),('11288','2014-02-19','15:00:00',1.77),('11288','2014-02-19','15:05:00',1.9),('11288','2014-02-19','15:10:00',1.95),('11288','2014-02-19','15:15:00',2.15),('11288','2014-02-19','15:20:00',1.69),('11288','2014-02-19','15:25:00',1.9),('11288','2014-02-19','15:30:00',1.66),('11288','2014-02-19','15:35:00',1.47),('11288','2014-02-19','15:40:00',1.56),('11288','2014-02-19','15:45:00',1.61),('11288','2014-02-19','15:50:00',1.94),('11288','2014-02-19','15:55:00',1.59),('11288','2014-02-19','16:00:00',1.4),('11288','2014-02-19','16:05:00',1.32),('11288','2014-02-19','16:10:00',1.21),('11288','2014-02-19','16:15:00',1.19),('11288','2014-02-18','08:10:00',1),('11288','2014-02-18','08:15:00',1.12),('11288','2014-02-18','08:20:00',1.13),('11288','2014-02-18','08:25:00',1.35),('11288','2014-02-18','08:30:00',1.46),('11288','2014-02-18','08:35:00',1.54),('11288','2014-02-18','08:40:00',1.7),('11288','2014-02-18','08:45:00',1.82),('11288','2014-02-18','08:50:00',1.87),('11288','2014-02-18','08:55:00',2.1),('11288','2014-02-18','09:00:00',2.22),('11288','2014-02-18','09:05:00',2.27),('11288','2014-02-18','09:10:00',2.42),('11288','2014-02-18','09:15:00',2.51),('11288','2014-02-18','09:20:00',2.65),('11288','2014-02-18','09:25:00',2.74),('11288','2014-02-18','09:30:00',2.9),('11288','2014-02-18','09:35:00',2.97),('11288','2014-02-18','09:40:00',3.11),('11288','2014-02-18','09:45:00',3.17),('11288','2014-02-18','09:50:00',3.2),('11288','2014-02-18','09:55:00',3.43),('11288','2014-02-18','10:00:00',3.56),('11288','2014-02-18','10:05:00',3.67),('11288','2014-02-18','10:10:00',3.72),('11288','2014-02-18','10:15:00',3.68),('11288','2014-02-18','10:20:00',3.88),('11288','2014-02-18','10:25:00',3.99),('11288','2014-02-18','10:30:00',4.06),('11288','2014-02-18','10:35:00',4.1),('11288','2014-02-18','10:40:00',4.11),('11288','2014-02-18','10:45:00',4.2),('11288','2014-02-18','10:50:00',4.32),('11288','2014-02-18','10:55:00',4.4),('11288','2014-02-18','11:00:00',4.45),('11288','2014-02-18','11:05:00',3.73),('11288','2014-02-18','11:10:00',3.62),('11288','2014-02-18','11:15:00',3.57),('11288','2014-02-18','11:20:00',4.14),('11288','2014-02-18','11:25:00',4.62),('11288','2014-02-18','11:30:00',4.1),('11288','2014-02-18','11:35:00',3.97),('11288','2014-02-18','11:40:00',3.33),('11288','2014-02-18','11:45:00',3.32),('11288','2014-02-18','11:50:00',2.85),('11288','2014-02-18','11:55:00',2.57),('11288','2014-02-18','12:00:00',2.56),('11288','2014-02-18','12:05:00',2.6),('11288','2014-02-18','12:10:00',2.94),('11288','2014-02-18','12:15:00',3.09),('11288','2014-02-18','12:20:00',3.1),('11288','2014-02-18','12:25:00',3.49),('11288','2014-02-18','12:30:00',3.68),('11288','2014-02-18','12:35:00',2.92),('11288','2014-02-18','12:40:00',2.72),('11288','2014-02-18','12:45:00',2.65),('11288','2014-02-18','12:50:00',2.8),('11288','2014-02-18','12:55:00',2.94),('11288','2014-02-18','13:00:00',2.43),('11288','2014-02-18','13:05:00',2.31),('11288','2014-02-18','13:10:00',2.45),('11288','2014-02-18','13:15:00',3.08),('11288','2014-02-18','13:20:00',3.31),('11288','2014-02-18','13:25:00',3.89),('11288','2014-02-18','13:30:00',2.84),('11288','2014-02-18','13:35:00',2.43),('11288','2014-02-18','13:40:00',3.09),('11288','2014-02-18','13:45:00',3.45),('11288','2014-02-18','13:50:00',2.74),('11288','2014-02-18','13:55:00',2.72),('11288','2014-02-18','14:00:00',3.01),('11288','2014-02-18','14:05:00',4.24),('11288','2014-02-18','14:10:00',2.58),('11288','2014-02-18','14:15:00',2.11),('11288','2014-02-18','14:20:00',1.94),('11288','2014-02-18','14:25:00',1.99),('11288','2014-02-18','14:30:00',2.41),('11288','2014-02-18','14:35:00',2.33),('11288','2014-02-18','14:40:00',1.99),('11288','2014-02-18','14:45:00',1.84),('11288','2014-02-18','14:50:00',1.73),('11288','2014-02-18','14:55:00',1.66),('11288','2014-02-18','15:00:00',1.57),('11288','2014-02-18','15:05:00',1.49),('11288','2014-02-18','15:10:00',1.47),('11288','2014-02-18','15:15:00',1.38),('11288','2014-02-18','15:20:00',1.24),('11288','2014-02-18','15:25:00',1.28),('11288','2014-02-18','15:30:00',1.43),('11288','2014-02-18','15:35:00',1.72),('11288','2014-02-18','15:40:00',2.01),('11288','2014-02-18','15:45:00',2.1),('11288','2014-02-18','15:50:00',1.72),('11288','2014-02-18','15:55:00',1.52),('11288','2014-02-18','16:00:00',1.52),('11288','2014-02-18','16:05:00',1.64),('11288','2014-02-18','16:10:00',1.4),('11288','2014-02-18','16:15:00',1.06),('11288','2014-02-17','08:15:00',1.06),('11288','2014-02-17','08:20:00',1.06),('11288','2014-02-17','08:25:00',1.27),('11288','2014-02-17','08:30:00',1.39),('11288','2014-02-17','08:35:00',1.47),('11288','2014-02-17','08:40:00',1.59),('11288','2014-02-17','08:45:00',1.7),('11288','2014-02-17','08:50:00',1.78),('11288','2014-02-17','08:55:00',1.9),('11288','2014-02-17','09:00:00',1.99),('11288','2014-02-17','09:05:00',2.06),('11288','2014-02-17','09:10:00',2.15),('11288','2014-02-17','09:15:00',2.33),('11288','2014-02-17','09:20:00',2.44),('11288','2014-02-17','09:25:00',2.55),('11288','2014-02-17','09:30:00',2.72),('11288','2014-02-17','09:35:00',2.83),('11288','2014-02-17','09:40:00',2.93),('11288','2014-02-17','09:45:00',2.96),('11288','2014-02-17','09:50:00',2.93),('11288','2014-02-17','09:55:00',3.09),('11288','2014-02-17','10:00:00',3.3),('11288','2014-02-17','10:05:00',3.41),('11288','2014-02-17','10:10:00',3.46),('11288','2014-02-17','10:15:00',3.39),('11288','2014-02-17','10:20:00',3.56),('11288','2014-02-17','10:25:00',3.64),('11288','2014-02-17','10:30:00',3.74),('11288','2014-02-17','10:35:00',3.75),('11288','2014-02-17','10:40:00',3.69),('11288','2014-02-17','10:45:00',3.78),('11288','2014-02-17','10:50:00',3.9),('11288','2014-02-17','10:55:00',3.96),('11288','2014-02-17','11:00:00',3.99),('11288','2014-02-17','11:05:00',4.03),('11288','2014-02-17','11:10:00',4.05),('11288','2014-02-17','11:15:00',4.21),('11288','2014-02-17','11:20:00',4.32),('11288','2014-02-17','11:25:00',4.44),('11288','2014-02-17','11:30:00',4.5),('11288','2014-02-17','11:35:00',4.58),('11288','2014-02-17','11:40:00',4.61),('11288','2014-02-17','11:45:00',4.59),('11288','2014-02-17','11:50:00',4.34),('11288','2014-02-17','11:55:00',4.14),('11288','2014-02-17','12:00:00',4.7),('11288','2014-02-17','12:05:00',4.7),('11288','2014-02-17','12:10:00',4.72),('11288','2014-02-17','12:15:00',4.69),('11288','2014-02-17','12:20:00',4.49),('11288','2014-02-17','12:25:00',4.6),('11288','2014-02-17','12:30:00',4.65),('11288','2014-02-17','12:35:00',4.64),('11288','2014-02-17','12:40:00',4.62),('11288','2014-02-17','12:45:00',4.59),('11288','2014-02-17','12:50:00',4.55),('11288','2014-02-17','12:55:00',4.52),('11288','2014-02-17','13:00:00',4.53),('11288','2014-02-17','13:05:00',4.48),('11288','2014-02-17','13:10:00',4.46),('11288','2014-02-17','13:15:00',4.42),('11288','2014-02-17','13:20:00',4.38),('11288','2014-02-17','13:25:00',4.37),('11288','2014-02-17','13:30:00',4.37),('11288','2014-02-17','13:35:00',4.31),('11288','2014-02-17','13:40:00',4.27),('11288','2014-02-17','13:45:00',4.14),('11288','2014-02-17','13:50:00',4.13),('11288','2014-02-17','13:55:00',4.07),('11288','2014-02-17','14:00:00',4.01),('11288','2014-02-17','14:05:00',3.98),('11288','2014-02-17','14:10:00',3.78),('11288','2014-02-17','14:15:00',3.63),('11288','2014-02-17','14:20:00',3.76),('11288','2014-02-17','14:25:00',3.6),('11288','2014-02-17','14:30:00',3.47),('11288','2014-02-17','14:35:00',3.36),('11288','2014-02-17','14:40:00',3.1),('11288','2014-02-17','14:45:00',3.35),('11288','2014-02-17','14:50:00',3.16),('11288','2014-02-17','14:55:00',3.07),('11288','2014-02-17','15:00:00',2.9),('11288','2014-02-17','15:05:00',2.82),('11288','2014-02-17','15:10:00',2.73),('11288','2014-02-17','15:15:00',2.74),('11288','2014-02-17','15:20:00',2.66),('11288','2014-02-17','15:25:00',2.43),('11288','2014-02-17','15:30:00',2.36),('11288','2014-02-17','15:35:00',2.22),('11288','2014-02-17','15:40:00',2.05),('11288','2014-02-17','15:45:00',1.98),('11288','2014-02-17','15:50:00',1.83),('11288','2014-02-17','15:55:00',1.64),('11288','2014-02-17','16:00:00',1.54),('11288','2014-02-17','16:05:00',1.48),('11288','2014-02-17','16:10:00',1.36),('11288','2014-02-17','16:15:00',1.22),('11288','2014-02-17','16:20:00',1.13),('11288','2014-02-17','16:25:00',1.04),('11288','2014-02-16','08:15:00',1.08),('11288','2014-02-16','08:20:00',1.06),('11288','2014-02-16','08:25:00',1.34),('11288','2014-02-16','08:30:00',1.47),('11288','2014-02-16','08:35:00',1.59),('11288','2014-02-16','08:40:00',1.64),('11288','2014-02-16','08:45:00',1.85),('11288','2014-02-16','08:50:00',1.76),('11288','2014-02-16','08:55:00',2.03),('11288','2014-02-16','09:00:00',2.22),('11288','2014-02-16','09:05:00',2.22),('11288','2014-02-16','09:10:00',2.23),('11288','2014-02-16','09:15:00',1.94),('11288','2014-02-16','09:20:00',2.57),('11288','2014-02-16','09:25:00',2.54),('11288','2014-02-16','09:30:00',2.65),('11288','2014-02-16','09:35:00',2.23),('11288','2014-02-16','09:40:00',2.95),('11288','2014-02-16','09:45:00',3.09),('11288','2014-02-16','09:50:00',3.28),('11288','2014-02-16','09:55:00',3.24),('11288','2014-02-16','10:00:00',3.23),('11288','2014-02-16','10:05:00',3.58),('11288','2014-02-16','10:10:00',3.7),('11288','2014-02-16','10:15:00',3.79),('11288','2014-02-16','10:20:00',3.94),('11288','2014-02-16','10:25:00',4.04),('11288','2014-02-16','10:30:00',4.12),('11288','2014-02-16','10:35:00',4.27),('11288','2014-02-16','10:40:00',4.24),('11288','2014-02-16','10:45:00',4.29),('11288','2014-02-16','10:50:00',3.72),('11288','2014-02-16','10:55:00',3.86),('11288','2014-02-16','11:00:00',4.44),('11288','2014-02-16','11:05:00',4.49),('11288','2014-02-16','11:10:00',4.27),('11288','2014-02-16','11:15:00',4.52),('11288','2014-02-16','11:20:00',4.33),('11288','2014-02-16','11:25:00',4.45),('11288','2014-02-16','11:30:00',4.52),('11288','2014-02-16','11:35:00',4.72),('11288','2014-02-16','11:40:00',4.7),('11288','2014-02-16','11:45:00',4.18),('11288','2014-02-16','11:50:00',4.29),('11288','2014-02-16','11:55:00',3.91),('11288','2014-02-16','12:00:00',4.82),('11288','2014-02-16','12:05:00',4.77),('11288','2014-02-16','12:10:00',4.77),('11288','2014-02-16','12:15:00',4.8),('11288','2014-02-16','12:20:00',4.63),('11288','2014-02-16','12:25:00',4.69),('11288','2014-02-16','12:30:00',4.71),('11288','2014-02-16','12:35:00',4.71),('11288','2014-02-16','12:40:00',4.65),('11288','2014-02-16','12:45:00',4.69),('11288','2014-02-16','12:50:00',4.68),('11288','2014-02-16','12:55:00',4.66),('11288','2014-02-16','13:00:00',4.67),('11288','2014-02-16','13:05:00',4.66),('11288','2014-02-16','13:10:00',4.46),('11288','2014-02-16','13:15:00',4.55),('11288','2014-02-16','13:20:00',4.49),('11288','2014-02-16','13:25:00',4.41),('11288','2014-02-16','13:30:00',4.43),('11288','2014-02-16','13:35:00',4.34),('11288','2014-02-16','13:40:00',4.42),('11288','2014-02-16','13:45:00',4.42),('11288','2014-02-16','13:50:00',4.31),('11288','2014-02-16','13:55:00',4.3),('11288','2014-02-16','14:00:00',4.29),('11288','2014-02-16','14:05:00',4.23),('11288','2014-02-16','14:10:00',4.12),('11288','2014-02-16','14:15:00',4),('11288','2014-02-16','14:20:00',3.97),('11288','2014-02-16','14:25:00',3.93),('11288','2014-02-16','14:30:00',3.81),('11288','2014-02-16','14:35:00',3.72),('11288','2014-02-16','14:40:00',3.58),('11288','2014-02-16','14:45:00',3.52),('11288','2014-02-16','14:50:00',3.4),('11288','2014-02-16','14:55:00',3.32),('11288','2014-02-16','15:00:00',3.19),('11288','2014-02-16','15:05:00',3.11),('11288','2014-02-16','15:10:00',2.97),('11288','2014-02-16','15:15:00',2.85),('11288','2014-02-16','15:20:00',2.69),('11288','2014-02-16','15:25:00',2.57),('11288','2014-02-16','15:30:00',2.42),('11288','2014-02-16','15:35:00',2.07),('11288','2014-02-16','15:40:00',1.89),('11288','2014-02-16','15:45:00',2.12),('11288','2014-02-16','15:50:00',1.64),('11288','2014-02-16','16:10:00',1.06),('11288','2014-02-16','16:15:00',1.34),('11288','2014-02-16','16:20:00',1.51),('11288','2014-02-16','16:25:00',1.59),('11288','2014-02-16','16:30:00',1.45),('11288','2014-02-16','16:35:00',1.09),('11288','2014-04-28','07:45:00',1.09),('11288','2014-04-28','07:50:00',1.12),('11288','2014-04-28','07:55:00',1.28),('11288','2014-04-28','08:00:00',1.43),('11288','2014-04-28','08:15:00',2.29),('11288','2014-04-28','08:20:00',2.47),('11288','2014-04-28','08:25:00',2.82),('11288','2014-04-28','08:30:00',2.11),('11288','2014-04-28','08:35:00',2.14),('11288','2014-04-28','08:40:00',2.19),('11288','2014-04-28','08:45:00',2.16),('11288','2014-04-28','08:50:00',2.28),('11288','2014-04-28','08:55:00',1.97),('11288','2014-04-28','09:00:00',1.74),('11288','2014-04-28','09:05:00',2.9),('11288','2014-04-28','09:10:00',4.49),('11288','2014-04-28','09:15:00',4.94),('11288','2014-04-28','09:20:00',3.1),('11288','2014-04-28','09:25:00',2.8),('11288','2014-04-28','09:30:00',4.86),('11288','2014-04-28','09:35:00',4.41),('11288','2014-04-28','09:40:00',2.91),('11288','2014-04-28','09:45:00',2.96),('11288','2014-04-28','09:50:00',2.74),('11288','2014-04-28','09:55:00',2.58),('11288','2014-04-28','10:00:00',4.14),('11288','2014-04-28','10:05:00',4.02),('11288','2014-04-28','10:10:00',4.04),('11288','2014-04-28','10:15:00',3.27),('11288','2014-04-28','10:20:00',2.61),('11288','2014-04-28','10:25:00',1.59),('11288','2014-04-28','10:35:00',1.19),('11288','2014-04-28','10:40:00',2.14),('11288','2014-04-28','10:45:00',3.06),('11288','2014-04-28','10:50:00',3.37),('11288','2014-04-28','10:55:00',3.07),('11288','2014-04-28','11:00:00',3.56),('11288','2014-04-28','11:05:00',4.31),('11288','2014-04-28','11:10:00',4.84),('11288','2014-04-28','11:15:00',4.41),('11288','2014-04-28','11:20:00',3.81),('11288','2014-04-28','11:25:00',3.35),('11288','2014-04-28','11:30:00',3.28),('11288','2014-04-28','11:35:00',2.86),('11288','2014-04-28','11:40:00',2.64),('11288','2014-04-28','11:45:00',3.02),('11288','2014-04-28','11:50:00',3.48),('11288','2014-04-28','11:55:00',3.61),('11288','2014-04-28','12:00:00',3.1),('11288','2014-04-28','12:05:00',2.69),('11288','2014-04-28','12:10:00',3.89),('11288','2014-04-28','12:15:00',4.83),('11288','2014-04-28','12:20:00',4.92),('11288','2014-04-28','12:25:00',4.8),('11288','2014-04-28','12:30:00',4.91),('11288','2014-04-28','12:35:00',4.38),('11288','2014-04-28','12:40:00',3.67),('11288','2014-04-28','12:45:00',3.5),('11288','2014-04-28','12:50:00',3.98),('11288','2014-04-28','12:55:00',3.93),('11288','2014-04-28','13:00:00',4.07),('11288','2014-04-28','13:05:00',6.55),('11288','2014-04-28','13:10:00',4.47),('11288','2014-04-28','13:15:00',3.9),('11288','2014-04-28','13:20:00',4.51),('11288','2014-04-28','13:25:00',5.72),('11288','2014-04-28','13:30:00',8.93),('11288','2014-04-28','13:35:00',5.38),('11288','2014-04-28','13:40:00',3.17),('11288','2014-04-28','13:45:00',7.73),('11288','2014-04-28','13:50:00',6.78),('11288','2014-04-28','13:55:00',3.64),('11288','2014-04-28','14:00:00',3.12),('11288','2014-04-28','14:05:00',6.01),('11288','2014-04-28','14:10:00',6.58),('11288','2014-04-28','14:15:00',4.59),('11288','2014-04-28','14:20:00',7.52),('11288','2014-04-28','14:25:00',5.25),('11288','2014-04-28','14:30:00',5.5),('11288','2014-04-28','14:35:00',3.74),('11288','2014-04-28','14:40:00',5.47),('11288','2014-04-28','14:45:00',4.74),('11288','2014-04-28','14:50:00',5.97),('11288','2014-04-28','14:55:00',4.94),('11288','2014-04-28','15:00:00',6.91),('11288','2014-04-28','15:05:00',6.32),('11288','2014-04-28','15:10:00',2.28),('11288','2014-04-28','15:15:00',2.32),('11288','2014-04-28','15:20:00',2.25),('11288','2014-04-28','15:25:00',3.35),('11288','2014-04-28','15:30:00',3.65),('11288','2014-04-28','15:35:00',7.54),('11288','2014-04-28','15:40:00',5.44),('11288','2014-04-28','15:45:00',5.43),('11288','2014-04-28','15:50:00',2.28),('11288','2014-04-28','15:55:00',2.66),('11288','2014-04-28','16:00:00',4.8),('11288','2014-04-28','16:05:00',4.65),('11288','2014-04-28','16:10:00',6.33),('11288','2014-04-28','16:15:00',4.05),('11288','2014-04-28','16:20:00',3.02),('11288','2014-04-28','16:25:00',3.96),('11288','2014-04-28','16:30:00',5.12),('11288','2014-04-28','16:35:00',4.06),('11288','2014-04-28','16:40:00',1.34),('11288','2014-04-28','16:45:00',1.19),('11288','2014-04-28','16:50:00',1.66),('11288','2014-04-28','16:55:00',2.2),('11288','2014-04-28','17:00:00',1.45),('11288','2014-04-28','17:20:00',1.57),('11288','2014-04-28','17:25:00',1.77),('11288','2014-04-28','17:30:00',1.7),('11288','2014-04-28','17:35:00',2.55),('11288','2014-04-28','17:40:00',2.26),('11288','2014-04-28','17:45:00',1.37),('11288','2014-04-28','17:50:00',1.38),('11288','2014-04-28','17:55:00',1.21),('11288','2014-04-28','18:35:00',1.02),('11288','2014-02-15','08:20:00',1.08),('11288','2014-02-15','08:25:00',1.17),('11288','2014-02-15','08:30:00',1.35),('11288','2014-02-15','08:35:00',1.44),('11288','2014-02-15','08:40:00',1.55),('11288','2014-02-15','08:45:00',1.68),('11288','2014-02-15','08:50:00',1.68),('11288','2014-02-15','08:55:00',1.76),('11288','2014-02-15','09:00:00',1.99),('11288','2014-02-15','09:05:00',1.99),('11288','2014-02-15','09:10:00',2.2),('11288','2014-02-15','09:15:00',2.34),('11288','2014-02-15','09:20:00',2.4),('11288','2014-02-15','09:25:00',2.55),('11288','2014-02-15','09:30:00',2.69),('11288','2014-02-15','09:35:00',2.8),('11288','2014-02-15','09:40:00',2.88),('11288','2014-02-15','09:45:00',3.05),('11288','2014-02-15','09:50:00',3.14),('11288','2014-02-15','09:55:00',3.23),('11288','2014-02-15','10:00:00',3.33),('11288','2014-02-15','10:05:00',3.46),('11288','2014-02-15','10:10:00',3.53),('11288','2014-02-15','10:15:00',3.63),('11288','2014-02-15','10:20:00',3.7),('11288','2014-02-15','10:25:00',3.77),('11288','2014-02-15','10:30:00',3.8),('11288','2014-02-15','10:35:00',3.85),('11288','2014-02-15','10:40:00',3.73),('11288','2014-02-15','10:45:00',4),('11288','2014-02-15','10:50:00',4.1),('11288','2014-02-15','10:55:00',4.15),('11288','2014-02-15','11:00:00',3.95),('11288','2014-02-15','11:05:00',4.41),('11288','2014-02-15','11:10:00',4.38),('11288','2014-02-15','11:15:00',3.95),('11288','2014-02-15','11:20:00',2.41),('11288','2014-02-15','11:25:00',4.86),('11288','2014-02-15','11:30:00',2.75),('11288','2014-02-15','11:35:00',5.09),('11288','2014-02-15','11:40:00',5.77),('11288','2014-02-15','11:45:00',5.21),('11288','2014-02-15','11:50:00',4.44),('11288','2014-02-15','11:55:00',2.7),('11288','2014-02-15','12:00:00',2.25),('11288','2014-02-15','12:05:00',2.47),('11288','2014-02-15','12:10:00',4.6),('11288','2014-02-15','12:15:00',4.77),('11288','2014-02-15','12:20:00',5.23),('11288','2014-02-15','12:25:00',1.81),('11288','2014-02-15','12:30:00',5.04),('11288','2014-02-15','12:35:00',5.66),('11288','2014-02-15','12:40:00',5.58),('11288','2014-02-15','12:45:00',5.34),('11288','2014-02-15','12:50:00',4.66),('11288','2014-02-15','12:55:00',2.72),('11288','2014-02-15','13:00:00',5.27),('11288','2014-02-15','13:05:00',5.4),('11288','2014-02-15','13:10:00',5.25),('11288','2014-02-15','13:15:00',4.71),('11288','2014-02-15','13:20:00',4.83),('11288','2014-02-15','13:25:00',4.69),('11288','2014-02-15','13:30:00',4.59),('11288','2014-02-15','13:35:00',4.51),('11288','2014-02-15','13:40:00',4.48),('11288','2014-02-15','13:45:00',4.35),('11288','2014-02-15','13:50:00',4.37),('11288','2014-02-15','13:55:00',4.21),('11288','2014-02-15','14:00:00',4.17),('11288','2014-02-15','14:05:00',4.14),('11288','2014-02-15','14:10:00',3.97),('11288','2014-02-15','14:15:00',3.94),('11288','2014-02-15','14:20:00',3.83),('11288','2014-02-15','14:25:00',3.73),('11288','2014-02-15','14:30:00',3.67),('11288','2014-02-15','14:35:00',3.55),('11288','2014-02-15','14:40:00',3.42),('11288','2014-02-15','14:45:00',3.37),('11288','2014-02-15','14:50:00',3.25),('11288','2014-02-15','14:55:00',3.04),('11288','2014-02-15','15:00:00',3.11),('11288','2014-02-15','15:05:00',2.97),('11288','2014-02-15','15:10:00',2.88),('11288','2014-02-15','15:15:00',2.75),('11288','2014-02-15','15:20:00',2.64),('11288','2014-02-15','15:25:00',2.52),('11288','2014-02-15','15:30:00',2.39),('11288','2014-02-15','15:35:00',2.28),('11288','2014-02-15','15:40:00',2.15),('11288','2014-02-15','15:45:00',2.01),('11288','2014-02-15','15:50:00',1.88),('11288','2014-02-15','15:55:00',1.67),('11288','2014-02-15','16:00:00',1.62),('11288','2014-02-15','16:05:00',1.5),('11288','2014-02-15','16:10:00',1.38),('11288','2014-02-15','16:15:00',1.22),('11288','2014-02-15','16:20:00',1.14),('11288','2014-02-15','16:25:00',1.04),('11288','2014-02-14','08:45:00',1.01),('11288','2014-02-14','08:50:00',1.8),('11288','2014-02-14','08:55:00',1.91),('11288','2014-02-14','09:00:00',2),('11288','2014-02-14','09:05:00',2.05),('11288','2014-02-14','09:10:00',1.76),('11288','2014-02-14','09:15:00',1.95),('11288','2014-02-14','09:20:00',1.54),('11288','2014-02-14','09:25:00',1.76),('11288','2014-02-14','09:30:00',2.67),('11288','2014-02-14','09:35:00',2.43),('11288','2014-02-14','09:40:00',1.72),('11288','2014-02-14','09:45:00',1.48),('11288','2014-02-14','09:50:00',3.53),('11288','2014-02-14','09:55:00',3.27),('11288','2014-02-14','10:00:00',2.94),('11288','2014-02-14','10:05:00',3.66),('11288','2014-02-14','10:10:00',3.38),('11288','2014-02-14','10:15:00',2.62),('11288','2014-02-14','10:20:00',4.02),('11288','2014-02-14','10:25:00',4.05),('11288','2014-02-14','10:30:00',4.11),('11288','2014-02-14','10:35:00',4),('11288','2014-02-14','10:40:00',4.11),('11288','2014-02-14','10:45:00',4.28),('11288','2014-02-14','10:50:00',4.45),('11288','2014-02-14','10:55:00',4.45),('11288','2014-02-14','11:00:00',4.44),('11288','2014-02-14','11:05:00',4.51),('11288','2014-02-14','11:10:00',4.29),('11288','2014-02-14','11:15:00',4.18),('11288','2014-02-14','11:20:00',4.63),('11288','2014-02-14','11:25:00',4.83),('11288','2014-02-14','11:30:00',4.87),('11288','2014-02-14','11:35:00',4.81),('11288','2014-02-14','11:40:00',4.93),('11288','2014-02-14','11:45:00',4.84),('11288','2014-02-14','11:50:00',4.85),('11288','2014-02-14','11:55:00',4.98),('11288','2014-02-14','12:00:00',4.68),('11288','2014-02-14','12:05:00',4.7),('11288','2014-02-14','12:10:00',5.08),('11288','2014-02-14','12:15:00',5.04),('11288','2014-02-14','12:20:00',4.96),('11288','2014-02-14','12:25:00',5),('11288','2014-02-14','12:30:00',5),('11288','2014-02-14','12:35:00',4.98),('11288','2014-02-14','12:40:00',4.95),('11288','2014-02-14','12:45:00',4.9),('11288','2014-02-14','12:50:00',4.82),('11288','2014-02-14','12:55:00',4.84),('11288','2014-02-14','13:00:00',4.85),('11288','2014-02-14','13:05:00',4.83),('11288','2014-02-14','13:10:00',4.82),('11288','2014-02-14','13:15:00',4.75),('11288','2014-02-14','13:20:00',4.66),('11288','2014-02-14','13:25:00',4.68),('11288','2014-02-14','13:30:00',4.59),('11288','2014-02-14','13:35:00',4.58),('11288','2014-02-14','13:40:00',4.52),('11288','2014-02-14','13:45:00',4.44),('11288','2014-02-14','13:50:00',4.35),('11288','2014-02-14','13:55:00',4.32),('11288','2014-02-14','14:00:00',4.27),('11288','2014-02-14','14:05:00',4.2),('11288','2014-02-14','14:10:00',4.08),('11288','2014-02-14','14:15:00',3.97),('11288','2014-02-14','14:20:00',3.92),('11288','2014-02-14','14:25:00',3.84),('11288','2014-02-14','14:30:00',3.75),('11288','2014-02-14','14:35:00',3.61),('11288','2014-02-14','14:40:00',3.55),('11288','2014-02-14','14:45:00',3.43),('11288','2014-02-14','14:50:00',3.32),('11288','2014-02-14','14:55:00',3.22),('11288','2014-02-14','15:00:00',3.09),('11288','2014-02-14','15:05:00',2.95),('11288','2014-02-14','15:10:00',2.88),('11288','2014-02-14','15:15:00',2.78),('11288','2014-02-14','15:20:00',2.65),('11288','2014-02-14','15:25:00',2.53),('11288','2014-02-14','15:30:00',2.38),('11288','2014-02-14','15:35:00',2.16),('11288','2014-02-14','15:40:00',2.13),('11288','2014-02-14','15:45:00',1.97),('11288','2014-02-14','15:50:00',1.84),('11288','2014-02-14','15:55:00',1.62),('11288','2014-02-14','16:00:00',1.59),('11288','2014-02-14','16:05:00',1.48),('11288','2014-02-14','16:10:00',1.31),('11288','2014-02-14','16:15:00',1.2),('11288','2014-02-14','16:20:00',1.05),('11288','2014-02-13','08:15:00',1.04),('11288','2014-02-13','08:20:00',1.15),('11288','2014-02-13','08:25:00',1.14),('11288','2014-02-13','08:30:00',1.33),('11288','2014-02-13','08:35:00',1.41),('11288','2014-02-13','08:40:00',1.55),('11288','2014-02-13','08:45:00',1.67),('11288','2014-02-13','08:50:00',1.78),('11288','2014-02-13','08:55:00',1.87),('11288','2014-02-13','09:00:00',2.01),('11288','2014-02-13','09:05:00',2.16),('11288','2014-02-13','09:10:00',2.13),('11288','2014-02-13','09:15:00',2.3),('11288','2014-02-13','09:20:00',2.44),('11288','2014-02-13','09:25:00',2.59),('11288','2014-02-13','09:30:00',2.71),('11288','2014-02-13','09:35:00',2.85),('11288','2014-02-13','09:40:00',2.9),('11288','2014-02-13','09:45:00',2.95),('11288','2014-02-13','09:50:00',3.14),('11288','2014-02-13','09:55:00',3.28),('11288','2014-02-13','10:00:00',3.41),('11288','2014-02-13','10:05:00',3.49),('11288','2014-02-13','10:10:00',3.57),('11288','2014-02-13','10:15:00',3.51),('11288','2014-02-13','10:20:00',3.74),('11288','2014-02-13','10:25:00',3.84),('11288','2014-02-13','10:30:00',3.94),('11288','2014-02-13','10:35:00',3.98),('11288','2014-02-13','10:40:00',3.8),('11288','2014-02-13','10:45:00',4.07),('11288','2014-02-13','10:50:00',4.19),('11288','2014-02-13','10:55:00',4.24),('11288','2014-02-13','11:00:00',4.27),('11288','2014-02-13','11:05:00',4.34),('11288','2014-02-13','11:10:00',4.18),('11288','2014-02-13','11:15:00',4.22),('11288','2014-02-13','11:20:00',4.76),('11288','2014-02-13','11:25:00',4.82),('11288','2014-02-13','11:30:00',3.74),('11288','2014-02-13','11:35:00',2.88),('11288','2014-02-13','11:40:00',3.92),('11288','2014-02-13','11:45:00',4.65),('11288','2014-02-13','11:50:00',4.74),('11288','2014-02-13','11:55:00',4.29),('11288','2014-02-13','12:00:00',2.95),('11288','2014-02-13','12:05:00',3.42),('11288','2014-02-13','12:10:00',3.05),('11288','2014-02-13','12:15:00',3.56),('11288','2014-02-13','12:20:00',3.21),('11288','2014-02-13','12:25:00',5.26),('11288','2014-02-13','12:30:00',5.88),('11288','2014-02-13','12:35:00',5.66),('11288','2014-02-13','12:40:00',2.24),('11288','2014-02-13','12:45:00',3.18),('11288','2014-02-13','12:50:00',3.95),('11288','2014-02-13','12:55:00',4.94),('11288','2014-02-13','13:00:00',5.06),('11288','2014-02-13','13:05:00',4.94),('11288','2014-02-13','13:10:00',4.84),('11288','2014-02-13','13:15:00',4.81),('11288','2014-02-13','13:20:00',4.73),('11288','2014-02-13','13:25:00',4.72),('11288','2014-02-13','13:30:00',4.68),('11288','2014-02-13','13:35:00',4.6),('11288','2014-02-13','13:40:00',4.53),('11288','2014-02-13','13:45:00',4.49),('11288','2014-02-13','13:50:00',4.43),('11288','2014-02-13','13:55:00',4.37),('11288','2014-02-13','14:00:00',4.33),('11288','2014-02-13','14:05:00',4.27),('11288','2014-02-13','14:10:00',4.14),('11288','2014-02-13','14:15:00',4.05),('11288','2014-02-13','14:20:00',3.98),('11288','2014-02-13','14:25:00',3.9),('11288','2014-02-13','14:30:00',3.8),('11288','2014-02-13','14:35:00',3.74),('11288','2014-02-13','14:40:00',1.86),('11288','2014-02-13','14:45:00',2.52),('11288','2014-02-13','14:50:00',3.54),('11288','2014-02-13','14:55:00',3.58),('11288','2014-02-13','15:00:00',2.33),('11288','2014-02-13','15:05:00',3.15),('11288','2014-02-13','15:10:00',2.82),('11288','2014-02-13','15:15:00',2.46),('11288','2014-02-13','15:20:00',2.72),('11288','2014-02-13','15:25:00',1.92),('11288','2014-02-13','15:30:00',1.82),('11288','2014-02-13','15:35:00',1.51),('11288','2014-02-13','15:40:00',2.06),('11288','2014-02-13','15:45:00',1.68),('11288','2014-02-13','15:50:00',1.19),('11288','2014-02-13','16:00:00',1.13),('11288','2014-02-13','16:05:00',1.44),('11288','2014-02-13','16:10:00',1.62),('11288','2014-02-12','08:45:00',1.03),('11288','2014-02-12','08:50:00',1.54),('11288','2014-02-12','08:55:00',1.38),('11288','2014-02-12','09:10:00',1.93),('11288','2014-02-12','09:15:00',2.35),('11288','2014-02-12','09:20:00',2.2),('11288','2014-02-12','09:25:00',1.92),('11288','2014-02-12','09:30:00',1.18),('11288','2014-02-12','09:35:00',1.18),('11288','2014-02-12','09:40:00',2.13),('11288','2014-02-12','09:45:00',2.48),('11288','2014-02-12','09:50:00',2.87),('11288','2014-02-12','09:55:00',1.65),('11288','2014-02-12','10:00:00',1.83),('11288','2014-02-12','10:05:00',2.59),('11288','2014-02-12','10:10:00',2.35),('11288','2014-02-12','10:15:00',1.96),('11288','2014-02-12','10:20:00',1.87),('11288','2014-02-12','10:25:00',1.98),('11288','2014-02-12','10:30:00',2.43),('11288','2014-02-12','10:35:00',2.57),('11288','2014-02-12','10:40:00',2.35),('11288','2014-02-12','10:45:00',3.02),('11288','2014-02-12','10:50:00',2.33),('11288','2014-02-12','10:55:00',2.38),('11288','2014-02-12','11:00:00',2.55),('11288','2014-02-12','11:05:00',3.47),('11288','2014-02-12','11:10:00',2.58),('11288','2014-02-12','11:15:00',2.42),('11288','2014-02-12','11:20:00',2.35),('11288','2014-02-12','11:25:00',2.47),('11288','2014-02-12','11:30:00',2.51),('11288','2014-02-12','11:35:00',2.81),('11288','2014-02-12','11:40:00',1.82),('11288','2014-02-12','11:45:00',1.47),('11288','2014-02-12','11:50:00',1.33),('11288','2014-02-12','11:55:00',1.2),('11288','2014-02-12','12:00:00',1.27),('11288','2014-02-12','12:05:00',1.63),('11288','2014-02-12','12:10:00',2.13),('11288','2014-02-12','12:15:00',2.29),('11288','2014-02-12','12:20:00',2.33),('11288','2014-02-12','12:25:00',2.42),('11288','2014-02-12','12:30:00',2.52),('11288','2014-02-12','12:35:00',2.43),('11288','2014-02-12','12:40:00',2.4),('11288','2014-02-12','12:45:00',2.66),('11288','2014-02-12','12:50:00',2.9),('11288','2014-02-12','12:55:00',2.96),('11288','2014-02-12','13:00:00',3.16),('11288','2014-02-12','13:05:00',2.98),('11288','2014-02-12','13:10:00',2.66),('11288','2014-02-12','13:15:00',2.22),('11288','2014-02-12','13:20:00',2.19),('11288','2014-02-12','13:25:00',2.54),('11288','2014-02-12','13:30:00',4.09),('11288','2014-02-12','13:35:00',4.43),('11288','2014-02-12','13:40:00',4.21),('11288','2014-02-12','13:45:00',3.57),('11288','2014-02-12','13:50:00',3.71),('11288','2014-02-12','13:55:00',2.87),('11288','2014-02-12','14:00:00',4.54),('11288','2014-02-12','14:05:00',4.76),('11288','2014-02-12','14:10:00',4.53),('11288','2014-02-12','14:15:00',4.34),('11288','2014-02-12','14:20:00',3.85),('11288','2014-02-12','14:25:00',2.52),('11288','2014-02-12','14:30:00',3.02),('11288','2014-02-12','14:35:00',3.32),('11288','2014-02-12','14:40:00',2.92),('11288','2014-02-12','14:45:00',4.03),('11288','2014-02-12','14:50:00',3.8),('11288','2014-02-12','14:55:00',3.11),('11288','2014-02-12','15:00:00',2.29),('11288','2014-02-12','15:05:00',1.37),('11288','2014-02-12','15:10:00',2.17),('11288','2014-02-12','15:15:00',2.52),('11288','2014-02-12','15:20:00',2.61),('11288','2014-02-12','15:25:00',1.73),('11288','2014-02-12','15:30:00',2.56),('11288','2014-02-12','15:35:00',2.88),('11288','2014-02-12','15:40:00',2.77),('11288','2014-02-12','15:45:00',1.58),('11288','2014-02-12','15:50:00',2.03),('11288','2014-02-12','15:55:00',1.36),('11288','2014-02-12','16:00:00',1.11),('11288','2014-02-11','09:00:00',1.14),('11288','2014-02-11','09:05:00',1.21),('11288','2014-02-11','09:10:00',1.18),('11288','2014-02-11','09:15:00',1.4),('11288','2014-02-11','09:20:00',1.84),('11288','2014-02-11','09:25:00',2.02),('11288','2014-02-11','09:30:00',2.04),('11288','2014-02-11','09:35:00',2.1),('11288','2014-02-11','09:40:00',2.02),('11288','2014-02-11','09:45:00',2.03),('11288','2014-02-11','09:50:00',2.09),('11288','2014-02-11','09:55:00',2.06),('11288','2014-02-11','10:00:00',1.87),('11288','2014-02-11','10:05:00',1.59),('11288','2014-02-11','10:15:00',2.46),('11288','2014-02-11','10:20:00',2.94),('11288','2014-02-11','10:25:00',3.02),('11288','2014-02-11','10:30:00',3.27),('11288','2014-02-11','10:35:00',2.85),('11288','2014-02-11','10:40:00',3.42),('11288','2014-02-11','10:45:00',3.37),('11288','2014-02-11','10:50:00',3.67),('11288','2014-02-11','10:55:00',2.81),('11288','2014-02-11','11:00:00',3.49),('11288','2014-02-11','11:05:00',3.23),('11288','2014-02-11','11:10:00',3.3),('11288','2014-02-11','11:15:00',2.87),('11288','2014-02-11','11:20:00',2.67),('11288','2014-02-11','11:25:00',2.58),('11288','2014-02-11','11:30:00',3.08),('11288','2014-02-11','11:35:00',2.81),('11288','2014-02-11','11:40:00',2.82),('11288','2014-02-11','11:45:00',3.41),('11288','2014-02-11','11:50:00',2.63),('11288','2014-02-11','11:55:00',2.02),('11288','2014-02-11','12:00:00',2.28),('11288','2014-02-11','12:05:00',2.96),('11288','2014-02-11','12:10:00',3.12),('11288','2014-02-11','12:15:00',2.77),('11288','2014-02-11','12:20:00',2.91),('11288','2014-02-11','12:25:00',3.71),('11288','2014-02-11','12:30:00',3.55),('11288','2014-02-11','12:35:00',3.22),('11288','2014-02-11','12:40:00',2.5),('11288','2014-02-11','12:45:00',2.89),('11288','2014-02-11','12:50:00',2.38),('11288','2014-02-11','12:55:00',2.88),('11288','2014-02-11','13:00:00',2.95),('11288','2014-02-11','13:05:00',3.56),('11288','2014-02-11','13:10:00',4.39),('11288','2014-02-11','13:15:00',4.19),('11288','2014-02-11','13:20:00',4.67),('11288','2014-02-11','13:25:00',4.21),('11288','2014-02-11','13:30:00',3.91),('11288','2014-02-11','13:35:00',3.64),('11288','2014-02-11','13:40:00',4.28),('11288','2014-02-11','13:45:00',3.18),('11288','2014-02-11','13:50:00',2.66),('11288','2014-02-11','13:55:00',2.3),('11288','2014-02-11','14:00:00',2.96),('11288','2014-02-11','14:05:00',3.3),('11288','2014-02-11','14:10:00',2.53),('11288','2014-02-11','14:15:00',3.21),('11288','2014-02-11','14:20:00',2.45),('11288','2014-02-11','14:25:00',2.3),('11288','2014-02-11','14:30:00',2.38),('11288','2014-02-11','14:35:00',2.27),('11288','2014-02-11','14:40:00',1.91),('11288','2014-02-11','14:45:00',1.93),('11288','2014-02-11','14:50:00',1.58),('11288','2014-02-11','14:55:00',1.59),('11288','2014-02-11','15:00:00',1.56),('11288','2014-02-11','15:05:00',1.62),('11288','2014-02-11','15:10:00',1.67),('11288','2014-02-11','15:15:00',2.14),('11288','2014-02-11','15:20:00',2.26),('11288','2014-02-11','15:25:00',1.84),('11288','2014-02-11','15:30:00',1.43),('11288','2014-02-11','15:35:00',1.43),('11288','2014-02-11','15:40:00',1.37),('11288','2014-02-11','15:45:00',1.14),('11288','2014-02-11','15:50:00',1.01),('11288','2014-02-11','15:55:00',1.02),('11288','2014-02-11','16:00:00',1.16),('11288','2014-02-11','16:05:00',1.43),('11288','2014-02-11','16:10:00',1.39),('11288','2014-02-11','16:15:00',1.25),('11288','2014-02-11','16:20:00',1.21),('11288','2014-02-11','16:25:00',1.35),('11288','2014-02-11','16:30:00',1.31),('11288','2014-02-11','16:35:00',1.14),('11288','2014-02-11','16:40:00',1.03),('11288','2014-02-10','10:30:00',1.02),('11288','2014-02-10','12:25:00',1.63),('11288','2014-02-10','12:30:00',1.3),('11288','2014-02-10','12:35:00',1.07),('11288','2014-02-10','12:50:00',1.21),('11288','2014-02-10','12:55:00',1.78),('11288','2014-02-10','13:00:00',2.28),('11288','2014-02-10','13:05:00',1.91),('11288','2014-02-10','13:10:00',1.47),('11288','2014-02-10','13:15:00',1.44),('11288','2014-02-10','13:20:00',1.31),('11288','2014-02-10','13:25:00',1.21),('11288','2014-02-10','13:30:00',1.4),('11288','2014-02-10','13:35:00',1.55),('11288','2014-02-10','13:40:00',1.54),('11288','2014-02-10','13:45:00',1.53),('11288','2014-02-10','13:50:00',1.47),('11288','2014-02-10','13:55:00',1.7),('11288','2014-02-10','14:00:00',1.76),('11288','2014-02-10','14:05:00',1.54),('11288','2014-02-10','14:10:00',1.49),('11288','2014-02-10','14:15:00',1.52),('11288','2014-02-10','14:20:00',1.56),('11288','2014-02-10','14:25:00',1.63),('11288','2014-02-10','14:30:00',1.76),('11288','2014-02-10','14:35:00',1.88),('11288','2014-02-10','14:40:00',1.95),('11288','2014-02-10','14:45:00',1.75),('11288','2014-02-10','14:50:00',1.49),('11288','2014-02-10','14:55:00',1.33),('11288','2014-02-10','15:00:00',1.31),('11288','2014-02-10','15:05:00',1.42),('11288','2014-02-10','15:10:00',1.35),('11288','2014-02-10','15:15:00',1.31),('11288','2014-02-10','15:20:00',1.33),('11288','2014-02-10','15:25:00',1.43),('11288','2014-02-10','15:30:00',1.34),('11288','2014-02-10','15:35:00',1.09),('11288','2014-02-09','11:00:00',1.34),('11288','2014-02-09','11:05:00',1.19),('11288','2014-02-09','11:15:00',1.06),('11288','2014-02-09','11:20:00',1.21),('11288','2014-02-09','11:25:00',1.81),('11288','2014-02-09','11:30:00',2),('11288','2014-02-09','11:35:00',2.47),('11288','2014-02-09','11:40:00',1.32),('11288','2014-02-09','11:55:00',1.04),('11288','2014-02-09','12:15:00',1.65),('11288','2014-02-09','12:20:00',1.61),('11288','2014-02-09','12:25:00',2.61),('11288','2014-02-09','12:30:00',2.48),('11288','2014-02-09','12:35:00',1.56),('11288','2014-02-09','12:40:00',1.53),('11288','2014-02-09','12:45:00',3.58),('11288','2014-02-09','12:50:00',1.16),('11288','2014-02-09','12:55:00',3.27),('11288','2014-02-09','13:00:00',3.08),('11288','2014-02-09','13:05:00',4.76),('11288','2014-02-09','13:10:00',3.15),('11288','2014-02-09','13:15:00',2.24),('11288','2014-02-09','13:20:00',1.2),('11288','2014-02-09','13:25:00',1.81),('11288','2014-02-09','13:30:00',1.46),('11288','2014-02-09','13:35:00',1.43),('11288','2014-02-09','13:40:00',2.21),('11288','2014-02-09','13:45:00',3.51),('11288','2014-02-09','13:50:00',2.21),('11288','2014-02-09','13:55:00',3.38),('11288','2014-02-09','14:00:00',2.45),('11288','2014-02-09','14:05:00',4.04),('11288','2014-02-09','14:10:00',3.13),('11288','2014-02-09','14:15:00',1.9),('11288','2014-02-09','14:20:00',1.66),('11288','2014-02-09','14:25:00',2.33),('11288','2014-02-09','14:30:00',2.97),('11288','2014-02-09','14:35:00',2.77),('11288','2014-02-09','14:40:00',1.96),('11288','2014-02-09','14:45:00',1.46),('11288','2014-02-09','14:50:00',2.81),('11288','2014-02-09','14:55:00',1.42),('11288','2014-02-09','15:00:00',1.35),('11288','2014-02-09','15:10:00',1.27),('11288','2014-02-09','15:15:00',2.18),('11288','2014-02-09','15:20:00',2.12),('11288','2014-02-09','15:25:00',2.06),('11288','2014-02-09','15:30:00',1.23),('11288','2014-02-09','15:35:00',1.51),('11288','2014-02-09','15:40:00',1.15),('11288','2014-02-09','15:45:00',1.42),('11288','2014-02-09','15:50:00',1.46),('11288','2014-02-09','15:55:00',1.3),('11288','2014-02-09','16:05:00',1.12),('11288','2014-02-09','16:10:00',1.06),('11288','2014-02-08','09:40:00',1.09),('11288','2014-02-08','09:45:00',1.71),('11288','2014-02-08','09:50:00',3.04),('11288','2014-02-08','09:55:00',1.28),('11288','2014-02-08','10:00:00',1.04),('11288','2014-02-08','10:05:00',1.23),('11288','2014-02-08','10:10:00',1.21),('11288','2014-02-08','10:15:00',1.9),('11288','2014-02-08','10:20:00',1.73),('11288','2014-02-08','10:25:00',1.84),('11288','2014-02-08','10:30:00',3.36),('11288','2014-02-08','10:35:00',3.47),('11288','2014-02-08','10:40:00',1.48),('11288','2014-02-08','10:45:00',2.09),('11288','2014-02-08','10:50:00',2.72),('11288','2014-02-08','10:55:00',2.81),('11288','2014-02-08','11:00:00',2.71),('11288','2014-02-08','11:05:00',3.56),('11288','2014-02-08','11:10:00',3.03),('11288','2014-02-08','11:15:00',3.07),('11288','2014-02-08','11:20:00',1.69),('11288','2014-02-08','11:25:00',1.24),('11288','2014-02-08','11:30:00',3.29),('11288','2014-02-08','11:35:00',5.98),('11288','2014-02-08','11:40:00',2.43),('11288','2014-02-08','11:45:00',1.21),('11288','2014-02-08','11:50:00',3.11),('11288','2014-02-08','11:55:00',4.85),('11288','2014-02-08','12:00:00',1.19),('11288','2014-02-08','12:05:00',1.66),('11288','2014-02-08','12:10:00',3.86),('11288','2014-02-08','12:15:00',4.7),('11288','2014-02-08','12:20:00',1.54),('11288','2014-02-08','12:25:00',4.07),('11288','2014-02-08','12:30:00',4.72),('11288','2014-02-08','12:35:00',3.36),('11288','2014-02-08','12:40:00',3.19),('11288','2014-02-08','12:45:00',4.71),('11288','2014-02-08','12:50:00',3.38),('11288','2014-02-08','12:55:00',3),('11288','2014-02-08','13:00:00',3.76),('11288','2014-02-08','13:05:00',1.72),('11288','2014-02-08','13:10:00',3.63),('11288','2014-02-08','13:15:00',5.74),('11288','2014-02-08','13:20:00',5.39),('11288','2014-02-08','13:25:00',4.55),('11288','2014-02-08','13:30:00',3.42),('11288','2014-02-08','13:35:00',3.09),('11288','2014-02-08','13:40:00',3.54),('11288','2014-02-08','13:45:00',4.78),('11288','2014-02-08','13:50:00',3.66),('11288','2014-02-08','13:55:00',4.34),('11288','2014-02-08','14:00:00',4.3),('11288','2014-02-08','14:05:00',4.3),('11288','2014-02-08','14:10:00',4.18),('11288','2014-02-08','14:15:00',1.48),('11288','2014-02-08','14:20:00',3.54),('11288','2014-02-08','14:25:00',2.36),('11288','2014-02-08','14:30:00',3.9),('11288','2014-02-08','14:35:00',2.43),('11288','2014-02-08','14:40:00',2.25),('11288','2014-02-08','14:45:00',1.68),('11288','2014-02-08','14:50:00',3.15),('11288','2014-02-08','14:55:00',2.12),('11288','2014-02-08','15:00:00',1.08),('11288','2014-02-08','15:10:00',1.24),('11288','2014-02-08','15:15:00',2.12),('11288','2014-02-08','15:20:00',2.77),('11288','2014-02-08','15:35:00',1.13),('11288','2014-02-08','15:40:00',2.45),('11288','2014-02-08','15:45:00',2.03),('11288','2014-02-08','15:50:00',1.77),('11288','2014-02-08','15:55:00',1.2),('11288','2014-02-07','08:30:00',1.1),('11288','2014-02-07','08:35:00',1.15),('11288','2014-02-07','08:40:00',1.38),('11288','2014-02-07','08:45:00',1.51),('11288','2014-02-07','08:50:00',1.61),('11288','2014-02-07','08:55:00',1.7),('11288','2014-02-07','09:00:00',1.77),('11288','2014-02-07','09:05:00',1.89),('11288','2014-02-07','09:10:00',1.98),('11288','2014-02-07','09:15:00',2.03),('11288','2014-02-07','09:20:00',2.16),('11288','2014-02-07','09:25:00',2.37),('11288','2014-02-07','09:30:00',2.43),('11288','2014-02-07','09:35:00',2.49),('11288','2014-02-07','09:40:00',2.58),('11288','2014-02-07','09:45:00',2.75),('11288','2014-02-07','09:50:00',2.73),('11288','2014-02-07','09:55:00',2.96),('11288','2014-02-07','10:00:00',3),('11288','2014-02-07','10:05:00',2.94),('11288','2014-02-07','10:10:00',3.26),('11288','2014-02-07','10:15:00',3.51),('11288','2014-02-07','10:20:00',3.63),('11288','2014-02-07','10:25:00',3.13),('11288','2014-02-07','10:30:00',3.7),('11288','2014-02-07','10:35:00',4.09),('11288','2014-02-07','10:40:00',2.35),('11288','2014-02-07','10:45:00',3.53),('11288','2014-02-07','10:50:00',3.45),('11288','2014-02-07','10:55:00',3.51),('11288','2014-02-07','11:00:00',3.63),('11288','2014-02-07','11:05:00',4.43),('11288','2014-02-07','11:10:00',4.85),('11288','2014-02-07','11:15:00',4.93),('11288','2014-02-07','11:20:00',4.36),('11288','2014-02-07','11:25:00',3.69),('11288','2014-02-07','11:30:00',4.44),('11288','2014-02-07','11:35:00',4.62),('11288','2014-02-07','11:40:00',4.89),('11288','2014-02-07','11:45:00',3.54),('11288','2014-02-07','11:50:00',5.09),('11288','2014-02-07','11:55:00',3.89),('11288','2014-02-07','12:00:00',3.67),('11288','2014-02-07','12:05:00',2.88),('11288','2014-02-07','12:10:00',3.48),('11288','2014-02-07','12:15:00',5.64),('11288','2014-02-07','12:20:00',4.2),('11288','2014-02-07','12:25:00',2.32),('11288','2014-02-07','12:30:00',2.54),('11288','2014-02-07','12:35:00',1.84),('11288','2014-02-07','12:40:00',2.7),('11288','2014-02-07','12:45:00',2.9),('11288','2014-02-07','12:50:00',5.5),('11288','2014-02-07','12:55:00',3.74),('11288','2014-02-07','13:00:00',2.03),('11288','2014-02-07','13:05:00',4.25),('11288','2014-02-07','13:10:00',4.45),('11288','2014-02-07','13:15:00',2.7),('11288','2014-02-07','13:20:00',2.89),('11288','2014-02-07','13:25:00',1.78),('11288','2014-02-07','13:30:00',2.66),('11288','2014-02-07','13:35:00',2.84),('11288','2014-02-07','13:40:00',1.65),('11288','2014-02-07','13:45:00',4.3),('11288','2014-02-07','13:50:00',4.24),('11288','2014-02-07','13:55:00',4.55),('11288','2014-02-07','14:00:00',2.83),('11288','2014-02-07','14:05:00',3.71),('11288','2014-02-07','14:10:00',4.22),('11288','2014-02-07','14:15:00',4.19),('11288','2014-02-07','14:20:00',3.09),('11288','2014-02-07','14:25:00',2.95),('11288','2014-02-07','14:30:00',3.24),('11288','2014-02-07','14:35:00',3.6),('11288','2014-02-07','14:40:00',3.57),('11288','2014-02-07','14:45:00',3.45),('11288','2014-02-07','14:50:00',3.32),('11288','2014-02-07','14:55:00',3.16),('11288','2014-02-07','15:00:00',2.97),('11288','2014-02-07','15:05:00',2.83),('11288','2014-02-07','15:10:00',2.71),('11288','2014-02-07','15:15:00',2.56),('11288','2014-02-07','15:20:00',2.54),('11288','2014-02-07','15:25:00',2.18),('11288','2014-02-07','15:30:00',2.19),('11288','2014-02-07','15:35:00',2.07),('11288','2014-02-07','15:40:00',1.93),('11288','2014-02-07','15:45:00',1.8),('11288','2014-02-07','15:50:00',1.64),('11288','2014-02-07','15:55:00',1.5),('11288','2014-02-07','16:00:00',1.33),('11288','2014-02-07','16:05:00',1.15),('11288','2014-02-07','16:10:00',1.11),('11288','2014-02-07','16:15:00',1.03),('11288','2014-02-06','08:40:00',1.26),('11288','2014-02-06','08:45:00',1.49),('11288','2014-02-06','08:50:00',1.72),('11288','2014-02-06','08:55:00',2.02),('11288','2014-02-06','09:00:00',2.45),('11288','2014-02-06','09:05:00',2.7),('11288','2014-02-06','09:10:00',2.47),('11288','2014-02-06','09:15:00',2.15),('11288','2014-02-06','09:20:00',1.03),('11288','2014-02-06','09:30:00',1.73),('11288','2014-02-06','09:35:00',2.35),('11288','2014-02-06','09:40:00',2.64),('11288','2014-02-06','09:45:00',2.77),('11288','2014-02-06','09:50:00',2.74),('11288','2014-02-06','09:55:00',3),('11288','2014-02-06','10:00:00',3.03),('11288','2014-02-06','10:05:00',3.02),('11288','2014-02-06','10:10:00',3.25),('11288','2014-02-06','10:15:00',3.43),('11288','2014-02-06','10:20:00',3.53),('11288','2014-02-06','10:25:00',3.54),('11288','2014-02-06','10:30:00',3.45),('11288','2014-02-06','10:35:00',3.03),('11288','2014-02-06','10:40:00',3.45),('11288','2014-02-06','10:45:00',2.73),('11288','2014-02-06','10:50:00',2.64),('11288','2014-02-06','10:55:00',2.5),('11288','2014-02-06','11:00:00',1.08),('11288','2014-02-06','11:05:00',2.87),('11288','2014-02-06','11:10:00',2.27),('11288','2014-02-06','11:15:00',2.34),('11288','2014-02-06','11:20:00',4.9),('11288','2014-02-06','11:25:00',2.94),('11288','2014-02-06','11:30:00',5.18),('11288','2014-02-06','11:35:00',4.75),('11288','2014-02-06','11:40:00',4.62),('11288','2014-02-06','11:45:00',4.47),('11288','2014-02-06','11:50:00',4.15),('11288','2014-02-06','11:55:00',4.65),('11288','2014-02-06','12:00:00',4.82),('11288','2014-02-06','12:05:00',4.9),('11288','2014-02-06','12:10:00',4.86),('11288','2014-02-06','12:15:00',4.9),('11288','2014-02-06','12:20:00',4.81),('11288','2014-02-06','12:25:00',4.81),('11288','2014-02-06','12:30:00',4.8),('11288','2014-02-06','12:35:00',4.48),('11288','2014-02-06','12:40:00',4.7),('11288','2014-02-06','12:45:00',4.82),('11288','2014-02-06','12:50:00',4.7),('11288','2014-02-06','12:55:00',4.7),('11288','2014-02-06','13:00:00',4.71),('11288','2014-02-06','13:05:00',4.15),('11288','2014-02-06','13:10:00',4.82),('11288','2014-02-06','13:15:00',4.68),('11288','2014-02-06','13:20:00',4.62),('11288','2014-02-06','13:25:00',3.06),('11288','2014-02-06','13:30:00',4.46),('11288','2014-02-06','13:35:00',4.62),('11288','2014-02-06','13:40:00',4.3),('11288','2014-02-06','13:45:00',4.3),('11288','2014-02-06','13:50:00',4.35),('11288','2014-02-06','13:55:00',4.25),('11288','2014-02-06','14:00:00',4.05),('11288','2014-02-06','14:05:00',4.12),('11288','2014-02-06','14:10:00',3.95),('11288','2014-02-06','14:15:00',3.79),('11288','2014-02-06','14:20:00',3.74),('11288','2014-02-06','14:25:00',3.76),('11288','2014-02-06','14:30:00',3.71),('11288','2014-02-06','14:35:00',3.23),('11288','2014-02-06','14:40:00',3.16),('11288','2014-02-06','14:45:00',2.19),('11288','2014-02-06','14:50:00',2.79),('11288','2014-02-06','14:55:00',2.52),('11288','2014-02-06','15:00:00',2.92),('11288','2014-02-06','15:05:00',2.83),('11288','2014-02-06','15:10:00',2.7),('11288','2014-02-06','15:15:00',2.57),('11288','2014-02-06','15:20:00',2.52),('11288','2014-02-06','15:25:00',2.27),('11288','2014-02-06','15:30:00',2.12),('11288','2014-02-06','15:35:00',2),('11288','2014-02-06','15:40:00',1.81),('11288','2014-02-06','15:45:00',1.69),('11288','2014-02-06','15:50:00',1.58),('11288','2014-02-06','15:55:00',1.43),('11288','2014-02-06','16:00:00',1.28),('11288','2014-02-06','16:05:00',1.13),('11288','2014-02-06','16:10:00',1.08),('11288','2014-04-27','08:45:00',1.01),('11288','2014-04-27','08:50:00',1.62),('11288','2014-04-27','08:55:00',1.71),('11288','2014-04-27','09:10:00',1.17),('11288','2014-04-27','09:15:00',1.6),('11288','2014-04-27','09:20:00',1.59),('11288','2014-04-27','09:25:00',1.21),('11288','2014-04-27','09:30:00',1.06),('11288','2014-04-27','09:40:00',1.26),('11288','2014-04-27','09:45:00',1.33),('11288','2014-04-27','09:50:00',1.15),('11288','2014-04-27','09:55:00',1.56),('11288','2014-04-27','10:00:00',2.14),('11288','2014-04-27','10:05:00',2.29),('11288','2014-04-27','10:10:00',2.07),('11288','2014-04-27','10:15:00',2.12),('11288','2014-04-27','10:20:00',2.01),('11288','2014-04-27','10:25:00',1.77),('11288','2014-04-27','10:30:00',1.12),('11288','2014-04-27','10:55:00',1.42),('11288','2014-04-27','11:00:00',1.78),('11288','2014-04-27','11:05:00',2.13),('11288','2014-04-27','11:10:00',2.14),('11288','2014-04-27','11:15:00',2.2),('11288','2014-04-27','11:20:00',1.58),('11288','2014-04-27','11:25:00',1.18),('11288','2014-04-27','11:30:00',1.74),('11288','2014-04-27','11:35:00',2.6),('11288','2014-04-27','11:40:00',3.09),('11288','2014-04-27','11:45:00',6.67),('11288','2014-04-27','11:50:00',5.73),('11288','2014-04-27','11:55:00',4.89),('11288','2014-04-27','12:00:00',4.4),('11288','2014-04-27','12:05:00',5.05),('11288','2014-04-27','12:10:00',5.45),('11288','2014-04-27','12:15:00',5.64),('11288','2014-04-27','12:20:00',4.84),('11288','2014-04-27','12:25:00',4.76),('11288','2014-04-27','12:30:00',4.47),('11288','2014-04-27','12:35:00',4.5),('11288','2014-04-27','12:40:00',4.12),('11288','2014-04-27','12:45:00',4.83),('11288','2014-04-27','12:50:00',3.78),('11288','2014-04-27','12:55:00',4.07),('11288','2014-04-27','13:00:00',4.61),('11288','2014-04-27','13:05:00',3.75),('11288','2014-04-27','13:10:00',3.27),('11288','2014-04-27','13:15:00',3.45),('11288','2014-04-27','13:20:00',4.26),('11288','2014-04-27','13:25:00',3.83),('11288','2014-04-27','13:30:00',3.57),('11288','2014-04-27','13:35:00',3.15),('11288','2014-04-27','13:40:00',3.05),('11288','2014-04-27','13:45:00',3.07),('11288','2014-04-27','13:50:00',3.02),('11288','2014-04-27','13:55:00',2.82),('11288','2014-04-27','14:00:00',3.55),('11288','2014-04-27','14:05:00',3.91),('11288','2014-04-27','14:10:00',2.71),('11288','2014-04-27','14:15:00',2.74),('11288','2014-04-27','14:20:00',3.33),('11288','2014-04-27','14:25:00',3.98),('11288','2014-04-27','14:30:00',4.05),('11288','2014-04-27','14:35:00',4.18),('11288','2014-04-27','14:40:00',4.28),('11288','2014-04-27','14:45:00',3.55),('11288','2014-04-27','14:50:00',3.42),('11288','2014-04-27','14:55:00',3.64),('11288','2014-04-27','15:00:00',3.99),('11288','2014-04-27','15:05:00',5.72),('11288','2014-04-27','15:10:00',7),('11288','2014-04-27','15:15:00',4.61),('11288','2014-04-27','15:20:00',3.17),('11288','2014-04-27','15:25:00',1.97),('11288','2014-04-27','15:30:00',1.63),('11288','2014-04-27','15:35:00',1.84),('11288','2014-04-27','15:40:00',1.9),('11288','2014-04-27','15:45:00',1.56),('11288','2014-04-27','15:50:00',1.61),('11288','2014-04-27','15:55:00',1.01),('11288','2014-02-05','10:10:00',1.69),('11288','2014-02-05','10:15:00',3.01),('11288','2014-02-05','10:20:00',3.84),('11288','2014-02-05','10:25:00',3.12),('11288','2014-02-05','10:30:00',1.26),('11288','2014-02-05','10:35:00',1.71),('11288','2014-02-05','10:40:00',2.27),('11288','2014-02-05','10:45:00',1.13),('11288','2014-02-05','10:50:00',1.41),('11288','2014-02-05','10:55:00',1.9),('11288','2014-02-05','11:00:00',1.03),('11288','2014-02-05','11:10:00',2.35),('11288','2014-02-05','11:15:00',3.89),('11288','2014-02-05','11:20:00',4.88),('11288','2014-02-05','11:25:00',2.79),('11288','2014-02-05','11:30:00',1.88),('11288','2014-02-05','11:35:00',1.15),('11288','2014-02-05','12:50:00',1.4),('11288','2014-02-05','12:55:00',2.32),('11288','2014-02-05','13:00:00',1.83),('11288','2014-02-05','13:05:00',2.13),('11288','2014-02-05','13:10:00',2.6),('11288','2014-02-05','13:15:00',2.04),('11288','2014-02-05','13:20:00',2.51),('11288','2014-02-05','13:25:00',2.7),('11288','2014-02-05','13:30:00',2.69),('11288','2014-02-05','13:35:00',3.2),('11288','2014-02-05','13:40:00',3.31),('11288','2014-02-05','13:45:00',3.2),('11288','2014-02-05','13:50:00',2.91),('11288','2014-02-05','13:55:00',2.08),('11288','2014-02-05','14:00:00',1.56),('11288','2014-02-05','14:05:00',1.04),('11288','2014-02-05','14:15:00',1.17),('11288','2014-02-05','14:25:00',1.45),('11288','2014-02-05','14:30:00',4.15),('11288','2014-02-05','14:35:00',2.63),('11288','2014-02-05','14:40:00',1.53),('11288','2014-02-05','14:45:00',1.22),('11288','2014-02-05','14:50:00',1.19),('11288','2014-02-05','14:55:00',1.03),('11288','2014-02-05','15:00:00',1.05),('11288','2014-02-05','15:05:00',1.02),('11288','2014-02-04','08:50:00',1.04),('11288','2014-02-04','08:55:00',1.09),('11288','2014-02-04','09:00:00',1.17),('11288','2014-02-04','09:05:00',1.28),('11288','2014-02-04','09:10:00',1.39),('11288','2014-02-04','09:15:00',1.73),('11288','2014-02-04','09:20:00',2.14),('11288','2014-02-04','09:25:00',2.14),('11288','2014-02-04','09:30:00',2.33),('11288','2014-02-04','09:35:00',2.14),('11288','2014-02-04','09:40:00',2.4),('11288','2014-02-04','09:45:00',2.19),('11288','2014-02-04','09:50:00',2.84),('11288','2014-02-04','09:55:00',1.71),('11288','2014-02-04','10:00:00',2.88),('11288','2014-02-04','10:05:00',3.49),('11288','2014-02-04','10:10:00',2.77),('11288','2014-02-04','10:15:00',2.53),('11288','2014-02-04','10:20:00',1.71),('11288','2014-02-04','10:25:00',1.09),('11288','2014-02-04','10:30:00',1.18),('11288','2014-02-04','10:35:00',1.48),('11288','2014-02-04','10:40:00',1.89),('11288','2014-02-04','10:45:00',2.59),('11288','2014-02-04','10:50:00',3.24),('11288','2014-02-04','10:55:00',4.24),('11288','2014-02-04','11:00:00',4.69),('11288','2014-02-04','11:05:00',2.49),('11288','2014-02-04','11:10:00',1.94),('11288','2014-02-04','11:15:00',1.6),('11288','2014-02-04','11:20:00',2.05),('11288','2014-02-04','11:25:00',1.51),('11288','2014-02-04','11:30:00',1.78),('11288','2014-02-04','11:35:00',1.41),('11288','2014-02-04','11:40:00',1.31),('11288','2014-02-04','11:45:00',1.22),('11288','2014-02-04','11:50:00',3.13),('11288','2014-02-04','11:55:00',5.31),('11288','2014-02-04','12:00:00',3.15),('11288','2014-02-04','12:05:00',2.94),('11288','2014-02-04','12:10:00',3.36),('11288','2014-02-04','12:15:00',2.75),('11288','2014-02-04','12:20:00',2.75),('11288','2014-02-04','12:25:00',2.23),('11288','2014-02-04','12:30:00',1.61),('11288','2014-02-04','12:35:00',1.27),('11288','2014-02-04','12:40:00',1.2),('11288','2014-02-04','12:45:00',2.07),('11288','2014-02-04','12:50:00',1.96),('11288','2014-02-04','12:55:00',1.88),('11288','2014-02-04','13:00:00',2.24),('11288','2014-02-04','13:05:00',2.26),('11288','2014-02-04','13:10:00',2.07),('11288','2014-02-04','13:15:00',2.31),('11288','2014-02-04','13:20:00',2.86),('11288','2014-02-04','13:25:00',2.49),('11288','2014-02-04','13:30:00',2.15),('11288','2014-02-04','13:35:00',1.88),('11288','2014-02-04','13:40:00',1.8),('11288','2014-02-04','13:45:00',1.6),('11288','2014-02-04','13:50:00',1.72),('11288','2014-02-04','13:55:00',1.55),('11288','2014-02-04','14:00:00',1.1),('11288','2014-02-04','14:05:00',1.05),('11288','2014-02-04','14:10:00',1.42),('11288','2014-02-04','14:15:00',1.44),('11288','2014-02-04','14:20:00',1.33),('11288','2014-02-03','09:20:00',1.04),('11288','2014-02-03','09:25:00',1.1),('11288','2014-02-03','09:30:00',1.14),('11288','2014-02-03','09:35:00',1.25),('11288','2014-02-03','09:40:00',1.37),('11288','2014-02-03','09:45:00',1.54),('11288','2014-02-03','09:50:00',1.76),('11288','2014-02-03','09:55:00',1.58),('11288','2014-02-03','10:00:00',1.42),('11288','2014-02-03','10:05:00',1.45),('11288','2014-02-03','10:10:00',1.66),('11288','2014-02-03','10:15:00',1.92),('11288','2014-02-03','10:20:00',1.79),('11288','2014-02-03','10:25:00',1.82),('11288','2014-02-03','10:30:00',1.84),('11288','2014-02-03','10:35:00',1.85),('11288','2014-02-03','10:40:00',1.94),('11288','2014-02-03','10:45:00',2.01),('11288','2014-02-03','10:50:00',1.97),('11288','2014-02-03','10:55:00',1.93),('11288','2014-02-03','11:00:00',1.78),('11288','2014-02-03','11:05:00',1.76),('11288','2014-02-03','11:10:00',1.78),('11288','2014-02-03','11:15:00',1.75),('11288','2014-02-03','11:20:00',1.85),('11288','2014-02-03','11:25:00',2.04),('11288','2014-02-03','11:30:00',2.26),('11288','2014-02-03','11:35:00',2.33),('11288','2014-02-03','11:40:00',2.33),('11288','2014-02-03','11:45:00',2.37),('11288','2014-02-03','11:50:00',2.33),('11288','2014-02-03','11:55:00',2.15),('11288','2014-02-03','12:00:00',1.91),('11288','2014-02-03','12:05:00',1.82),('11288','2014-02-03','12:10:00',1.81),('11288','2014-02-03','12:15:00',1.95),('11288','2014-02-03','12:20:00',1.95),('11288','2014-02-03','12:25:00',1.82),('11288','2014-02-03','12:30:00',1.74),('11288','2014-02-03','12:35:00',1.39),('11288','2014-02-03','12:40:00',1.3),('11288','2014-02-03','13:00:00',1.01),('11288','2014-02-03','13:05:00',1.01),('11288','2014-02-03','13:10:00',1.08),('11288','2014-02-03','13:15:00',1.21),('11288','2014-02-03','13:20:00',1.29),('11288','2014-02-03','13:25:00',1.49),('11288','2014-02-03','13:30:00',1.64),('11288','2014-02-03','13:35:00',1.65),('11288','2014-02-03','13:40:00',1.58),('11288','2014-02-03','13:45:00',1.5),('11288','2014-02-03','13:50:00',1.48),('11288','2014-02-03','13:55:00',1.41),('11288','2014-02-03','14:00:00',1.46),('11288','2014-02-03','14:05:00',1.57),('11288','2014-02-03','14:10:00',1.63),('11288','2014-02-03','14:15:00',1.6),('11288','2014-02-03','14:20:00',1.46),('11288','2014-02-03','14:25:00',1.58),('11288','2014-02-03','14:30:00',1.67),('11288','2014-02-03','14:35:00',1.67),('11288','2014-02-03','14:40:00',1.69),('11288','2014-02-03','14:45:00',1.61),('11288','2014-02-03','14:50:00',1.52),('11288','2014-02-03','14:55:00',1.33),('11288','2014-02-02','11:25:00',1.17),('11288','2014-02-02','11:30:00',1.29),('11288','2014-02-02','11:35:00',1.23),('11288','2014-02-02','11:40:00',1.26),('11288','2014-02-02','11:45:00',1.35),('11288','2014-02-02','11:50:00',1.45),('11288','2014-02-02','11:55:00',1.64),('11288','2014-02-02','12:00:00',1.8),('11288','2014-02-02','12:05:00',1.84),('11288','2014-02-02','12:10:00',1.8),('11288','2014-02-02','12:15:00',1.61),('11288','2014-02-02','12:20:00',1.4),('11288','2014-02-02','12:25:00',1.25),('11288','2014-02-02','12:30:00',1.27),('11288','2014-02-02','12:35:00',1.25),('11288','2014-02-02','12:40:00',1.12),('11288','2014-02-02','12:45:00',1),('11288','2014-02-02','13:15:00',1.08),('11288','2014-02-02','13:20:00',1.24),('11288','2014-02-02','13:25:00',1.23),('11288','2014-02-02','13:30:00',1.03),('11288','2014-02-02','13:55:00',1.01),('11288','2014-02-02','14:05:00',1),('11288','2014-02-02','14:20:00',1.05),('11288','2014-02-02','14:25:00',1.02),('11288','2014-02-02','15:05:00',1.03),('11288','2014-02-02','15:10:00',1.03),('11288','2014-02-01','08:50:00',1.05),('11288','2014-02-01','09:15:00',1.11),('11288','2014-02-01','09:20:00',1.11),('11288','2014-02-01','09:25:00',1.17),('11288','2014-02-01','09:30:00',1.01),('11288','2014-02-01','10:15:00',1.2),('11288','2014-02-01','10:20:00',1.38),('11288','2014-02-01','10:25:00',1.27),('11288','2014-02-01','10:30:00',1.2),('11288','2014-02-01','10:35:00',1.19),('11288','2014-02-01','10:40:00',1.27),('11288','2014-02-01','10:45:00',1.38),('11288','2014-02-01','10:50:00',1.48),('11288','2014-02-01','10:55:00',1.64),('11288','2014-02-01','11:00:00',2.08),('11288','2014-02-01','11:05:00',1.82),('11288','2014-02-01','11:10:00',1.39),('11288','2014-02-01','11:15:00',1.73),('11288','2014-02-01','11:20:00',2.8),('11288','2014-02-01','11:25:00',2.22),('11288','2014-02-01','11:30:00',2.36),('11288','2014-02-01','11:35:00',2.61),('11288','2014-02-01','11:40:00',1.41),('11288','2014-02-01','11:45:00',1.05),('11288','2014-02-01','11:50:00',1.11),('11288','2014-02-01','11:55:00',2.66),('11288','2014-02-01','12:00:00',2.09),('11288','2014-02-01','12:05:00',2.1),('11288','2014-02-01','12:10:00',3.22),('11288','2014-02-01','12:15:00',2.33),('11288','2014-02-01','12:20:00',3.53),('11288','2014-02-01','12:25:00',2.7),('11288','2014-02-01','12:30:00',1.32),('11288','2014-02-01','12:35:00',1.82),('11288','2014-02-01','12:40:00',2.26),('11288','2014-02-01','12:45:00',3.34),('11288','2014-02-01','12:50:00',3.24),('11288','2014-02-01','12:55:00',2.74),('11288','2014-02-01','13:00:00',2.72),('11288','2014-02-01','13:05:00',2.03),('11288','2014-02-01','13:10:00',1.61),('11288','2014-02-01','13:15:00',1.23),('11288','2014-02-01','13:20:00',1.27),('11288','2014-02-01','13:25:00',1.37),('11288','2014-02-01','13:30:00',1.6),('11288','2014-02-01','13:35:00',1.47),('11288','2014-02-01','13:40:00',1.15),('11288','2014-02-01','13:45:00',1.13),('11288','2014-02-01','13:50:00',1.05),('11288','2014-01-31','10:15:00',1.01),('11288','2014-01-31','10:20:00',1.16),('11288','2014-01-31','10:25:00',1.26),('11288','2014-01-31','10:30:00',1.53),('11288','2014-01-31','10:35:00',1.36),('11288','2014-01-31','11:35:00',1.09),('11288','2014-01-31','11:40:00',1.26),('11288','2014-01-31','11:45:00',1.34),('11288','2014-01-31','11:50:00',1.39),('11288','2014-01-31','11:55:00',1.25),('11288','2014-01-31','12:00:00',1.07),('11288','2014-01-31','12:05:00',1.03),('11288','2014-01-31','12:10:00',1.14),('11288','2014-01-31','12:15:00',1.27),('11288','2014-01-31','12:20:00',1.21),('11288','2014-01-31','12:25:00',1.29),('11288','2014-01-31','12:30:00',1.33),('11288','2014-01-31','12:35:00',1.44),('11288','2014-01-31','12:40:00',1.15),('11288','2014-01-31','13:40:00',1.01),('11288','2014-01-31','13:45:00',1.31),('11288','2014-01-31','13:50:00',1.55),('11288','2014-01-31','13:55:00',1.26),('11288','2014-01-31','14:10:00',1.02),('11288','2014-01-31','14:15:00',1.15),('11288','2014-01-31','14:20:00',1.12),('11288','2014-01-31','14:45:00',1.31),('11288','2014-01-30','08:55:00',1),('11288','2014-01-30','09:00:00',1.08),('11288','2014-01-30','09:05:00',1.15),('11288','2014-01-30','09:10:00',1.22),('11288','2014-01-30','09:15:00',1.34),('11288','2014-01-30','09:20:00',1.44),('11288','2014-01-30','09:25:00',1.46),('11288','2014-01-30','09:30:00',1.36),('11288','2014-01-30','09:35:00',1.3),('11288','2014-01-30','09:40:00',1.28),('11288','2014-01-30','09:45:00',1.34),('11288','2014-01-30','09:50:00',2.01),('11288','2014-01-30','09:55:00',2.65),('11288','2014-01-30','10:00:00',2.44),('11288','2014-01-30','10:05:00',1.82),('11288','2014-01-30','10:10:00',2.47),('11288','2014-01-30','10:15:00',3.19),('11288','2014-01-30','10:20:00',2.74),('11288','2014-01-30','10:25:00',3.39),('11288','2014-01-30','10:30:00',3.58),('11288','2014-01-30','10:35:00',3.45),('11288','2014-01-30','10:40:00',3.52),('11288','2014-01-30','10:45:00',3.28),('11288','2014-01-30','10:50:00',4.07),('11288','2014-01-30','10:55:00',4.79),('11288','2014-01-30','11:00:00',4.67),('11288','2014-01-30','11:05:00',3.93),('11288','2014-01-30','11:10:00',3.59),('11288','2014-01-30','11:15:00',3.62),('11288','2014-01-30','11:20:00',2.43),('11288','2014-01-30','11:25:00',3.72),('11288','2014-01-30','11:30:00',3.45),('11288','2014-01-30','11:35:00',3.89),('11288','2014-01-30','11:40:00',3.58),('11288','2014-01-30','11:45:00',4.27),('11288','2014-01-30','11:50:00',4.45),('11288','2014-01-30','11:55:00',4.4),('11288','2014-01-30','12:00:00',3.86),('11288','2014-01-30','12:05:00',4.7),('11288','2014-01-30','12:10:00',4.98),('11288','2014-01-30','12:15:00',4.43),('11288','2014-01-30','12:20:00',4.95),('11288','2014-01-30','12:25:00',3.94),('11288','2014-01-30','12:30:00',3.65),('11288','2014-01-30','12:35:00',3.81),('11288','2014-01-30','12:40:00',3.61),('11288','2014-01-30','12:45:00',4.4),('11288','2014-01-30','12:50:00',4.43),('11288','2014-01-30','12:55:00',4.35),('11288','2014-01-30','13:00:00',4.51),('11288','2014-01-30','13:05:00',4.79),('11288','2014-01-30','13:10:00',4.07),('11288','2014-01-30','13:15:00',4.44),('11288','2014-01-30','13:20:00',3.73),('11288','2014-01-30','13:25:00',3.97),('11288','2014-01-30','13:30:00',3.27),('11288','2014-01-30','13:35:00',3.01),('11288','2014-01-30','13:40:00',3.85),('11288','2014-01-30','13:45:00',4.2),('11288','2014-01-30','13:50:00',3.81),('11288','2014-01-30','13:55:00',3.31),('11288','2014-01-30','14:00:00',3.3),('11288','2014-01-30','14:05:00',3.07),('11288','2014-01-30','14:10:00',3.08),('11288','2014-01-30','14:15:00',2.7),('11288','2014-01-30','14:20:00',2.46),('11288','2014-01-30','14:25:00',2.61),('11288','2014-01-30','14:30:00',2.71),('11288','2014-01-30','14:35:00',2.62),('11288','2014-01-30','14:40:00',2.93),('11288','2014-01-30','14:45:00',2.74),('11288','2014-01-30','14:50:00',2.91),('11288','2014-01-30','14:55:00',2.71),('11288','2014-01-30','15:00:00',2.55),('11288','2014-01-30','15:05:00',2.49),('11288','2014-01-30','15:10:00',2.33),('11288','2014-01-30','15:15:00',2.19),('11288','2014-01-30','15:20:00',2.2),('11288','2014-01-30','15:25:00',2.15),('11288','2014-01-30','15:30:00',1.87),('11288','2014-01-30','15:35:00',1.85),('11288','2014-01-30','15:40:00',1.7),('11288','2014-01-30','15:45:00',1.11),('11288','2014-01-29','09:05:00',1),('11288','2014-01-29','09:10:00',1.24),('11288','2014-01-29','09:15:00',1.49),('11288','2014-01-29','09:20:00',1.97),('11288','2014-01-29','09:25:00',1.51),('11288','2014-01-29','09:30:00',1.96),('11288','2014-01-29','09:35:00',2.69),('11288','2014-01-29','09:40:00',2.4),('11288','2014-01-29','09:45:00',2.66),('11288','2014-01-29','09:50:00',2.45),('11288','2014-01-29','09:55:00',2.5),('11288','2014-01-29','10:00:00',2.03),('11288','2014-01-29','10:05:00',2.13),('11288','2014-01-29','10:10:00',2.81),('11288','2014-01-29','10:15:00',2.88),('11288','2014-01-29','10:20:00',2.19),('11288','2014-01-29','10:25:00',3.72),('11288','2014-01-29','10:30:00',4.03),('11288','2014-01-29','10:35:00',3.71),('11288','2014-01-29','10:40:00',3.44),('11288','2014-01-29','10:45:00',3.24),('11288','2014-01-29','10:50:00',3.33),('11288','2014-01-29','10:55:00',2.98),('11288','2014-01-29','11:00:00',3.08),('11288','2014-01-29','11:05:00',3.31),('11288','2014-01-29','11:10:00',2.9),('11288','2014-01-29','11:15:00',2.97),('11288','2014-01-29','11:20:00',3.18),('11288','2014-01-29','11:25:00',3.19),('11288','2014-01-29','11:30:00',4.16),('11288','2014-01-29','11:35:00',3.6),('11288','2014-01-29','11:40:00',2.04),('11288','2014-01-29','11:45:00',2.01),('11288','2014-01-29','11:50:00',1.37),('11288','2014-01-29','12:45:00',2.15),('11288','2014-01-29','12:50:00',4.5),('11288','2014-01-29','12:55:00',4.82),('11288','2014-01-29','13:00:00',2.76),('11288','2014-01-29','13:05:00',2.17),('11288','2014-01-29','13:30:00',1.64),('11288','2014-01-29','13:35:00',3),('11288','2014-01-29','13:40:00',4.24),('11288','2014-01-29','13:45:00',2.99),('11288','2014-01-29','13:50:00',3.55),('11288','2014-01-29','13:55:00',4.03),('11288','2014-01-29','14:00:00',1.74),('11288','2014-01-29','14:30:00',1.48),('11288','2014-01-29','14:35:00',1.35),('11288','2014-01-29','14:40:00',1.65),('11288','2014-01-29','14:45:00',1.13),('11288','2014-01-29','15:00:00',1.02),('11288','2014-01-29','15:05:00',1.2),('11288','2014-01-29','15:10:00',1.81),('11288','2014-01-29','15:15:00',2.39),('11288','2014-01-29','15:20:00',1.71),('11288','2014-01-29','15:25:00',1.07),('11288','2014-01-28','09:05:00',1.31),('11288','2014-01-28','09:10:00',1.62),('11288','2014-01-28','09:15:00',1.83),('11288','2014-01-28','09:20:00',1.86),('11288','2014-01-28','09:25:00',1.91),('11288','2014-01-28','09:30:00',1.96),('11288','2014-01-28','09:35:00',2.18),('11288','2014-01-28','09:40:00',1.92),('11288','2014-01-28','09:45:00',2.28),('11288','2014-01-28','09:50:00',2.55),('11288','2014-01-28','09:55:00',2.71),('11288','2014-01-28','10:00:00',2.75),('11288','2014-01-28','10:05:00',2.7),('11288','2014-01-28','10:10:00',2.67),('11288','2014-01-28','10:15:00',2.91),('11288','2014-01-28','10:20:00',3.21),('11288','2014-01-28','10:25:00',3.35),('11288','2014-01-28','10:30:00',3.33),('11288','2014-01-28','10:35:00',3.53),('11288','2014-01-28','10:40:00',3.65),('11288','2014-01-28','10:45:00',3.44),('11288','2014-01-28','10:50:00',3.78),('11288','2014-01-28','10:55:00',2.47),('11288','2014-01-28','11:00:00',2.85),('11288','2014-01-28','11:05:00',3.63),('11288','2014-01-28','11:10:00',3.79),('11288','2014-01-28','11:15:00',2.12),('11288','2014-01-28','11:20:00',1.38),('11288','2014-01-28','11:25:00',3.46),('11288','2014-01-28','11:30:00',2.38),('11288','2014-01-28','11:35:00',3.32),('11288','2014-01-28','11:40:00',4.97),('11288','2014-01-28','11:45:00',4.81),('11288','2014-01-28','11:50:00',2.43),('11288','2014-01-28','11:55:00',1.81),('11288','2014-01-28','12:00:00',3.93),('11288','2014-01-28','12:05:00',3.74),('11288','2014-01-28','12:10:00',3.1),('11288','2014-01-28','12:15:00',2.9),('11288','2014-01-28','12:20:00',2.02),('11288','2014-01-28','12:25:00',1.98),('11288','2014-01-28','12:30:00',2.01),('11288','2014-01-28','12:35:00',2.58),('11288','2014-01-28','12:40:00',2.65),('11288','2014-01-28','12:45:00',3.73),('11288','2014-01-28','12:50:00',3.71),('11288','2014-01-28','12:55:00',4.55),('11288','2014-01-28','13:00:00',4.89),('11288','2014-01-28','13:05:00',4.88),('11288','2014-01-28','13:10:00',3.43),('11288','2014-01-28','13:15:00',4.2),('11288','2014-01-28','13:20:00',3.96),('11288','2014-01-28','13:25:00',4.11),('11288','2014-01-28','13:30:00',4.43),('11288','2014-01-28','13:35:00',4.53),('11288','2014-01-28','13:40:00',4.27),('11288','2014-01-28','13:45:00',4.1),('11288','2014-01-28','13:50:00',3.95),('11288','2014-01-28','13:55:00',3.84),('11288','2014-01-28','14:00:00',3.73),('11288','2014-01-28','14:05:00',3.64),('11288','2014-01-28','14:10:00',3.59),('11288','2014-01-28','14:15:00',3.55),('11288','2014-01-28','14:20:00',3.46),('11288','2014-01-28','14:25:00',3.44),('11288','2014-01-28','14:30:00',3.42),('11288','2014-01-28','14:35:00',3.15),('11288','2014-01-28','14:40:00',3.01),('11288','2014-01-28','14:45:00',2.93),('11288','2014-01-28','14:50:00',2.8),('11288','2014-01-28','14:55:00',2.67),('11288','2014-01-28','15:00:00',2.54),('11288','2014-01-28','15:05:00',2.42),('11288','2014-01-28','15:10:00',2.27),('11288','2014-01-28','15:15:00',2.14),('11288','2014-01-28','15:20:00',1.99),('11288','2014-01-28','15:25:00',1.87),('11288','2014-01-28','15:30:00',1.75),('11288','2014-01-28','15:35:00',1.61),('11288','2014-01-28','15:40:00',1.48),('11288','2014-01-28','15:45:00',1.34),('11288','2014-01-28','15:50:00',1.08),('11288','2014-01-28','15:55:00',1.12),('11288','2014-01-28','16:00:00',1.02),('11288','2014-01-27','09:40:00',1.22),('11288','2014-01-27','09:45:00',1.27),('11288','2014-01-27','09:50:00',1.41),('11288','2014-01-27','09:55:00',1.36),('11288','2014-01-27','10:00:00',1.4),('11288','2014-01-27','10:05:00',1.42),('11288','2014-01-27','10:35:00',1.6),('11288','2014-01-27','10:40:00',1.45),('11288','2014-01-27','10:45:00',1.59),('11288','2014-01-27','10:50:00',1.41),('11288','2014-01-27','10:55:00',1.46),('11288','2014-01-27','11:00:00',1.67),('11288','2014-01-27','11:05:00',1.87),('11288','2014-01-27','11:10:00',1.59),('11288','2014-01-27','11:15:00',1.48),('11288','2014-01-27','11:20:00',1.86),('11288','2014-01-27','11:25:00',1.85),('11288','2014-01-27','11:30:00',1.5),('11288','2014-01-27','11:35:00',1.24),('11288','2014-01-27','11:40:00',1.39),('11288','2014-01-27','11:45:00',1.04),('11288','2014-01-27','11:50:00',1.05),('11288','2014-01-27','12:00:00',1.14),('11288','2014-01-27','12:05:00',1.32),('11288','2014-01-27','12:10:00',1.13),('11288','2014-01-27','12:45:00',1.18),('11288','2014-01-27','12:50:00',1.43),('11288','2014-01-27','12:55:00',1.4),('11288','2014-01-27','13:00:00',1.28),('11288','2014-01-27','13:05:00',1.4),('11288','2014-01-27','13:10:00',1.31),('11288','2014-01-27','13:15:00',1.1),('11288','2014-01-27','13:20:00',1.12),('11288','2014-01-27','13:25:00',1.19),('11288','2014-01-27','13:30:00',1.38),('11288','2014-01-27','13:35:00',1.13),('12374','2013-06-20','06:40:00',1),('12374','2013-06-20','06:50:00',1.19),('12374','2013-06-20','06:55:00',1.29),('12374','2013-06-20','07:00:00',1.39),('12374','2013-06-20','07:05:00',1.34),('12374','2013-06-20','07:10:00',1.61),('12374','2013-06-20','07:15:00',1.72),('12374','2013-06-20','07:20:00',1.92),('12374','2013-06-20','07:25:00',2.09),('12374','2013-06-20','07:30:00',2.26),('12374','2013-06-20','07:35:00',2.41),('12374','2013-06-20','07:40:00',2.57),('12374','2013-06-20','07:45:00',2.72),('12374','2013-06-20','07:50:00',2.86),('12374','2013-06-20','07:55:00',3.04),('12374','2013-06-20','08:00:00',3.2),('12374','2013-06-20','08:05:00',3.36),('12374','2013-06-20','08:10:00',3.5),('12374','2013-06-20','08:15:00',3.65),('12374','2013-06-20','08:20:00',3.8),('12374','2013-06-20','08:25:00',4),('12374','2013-06-20','08:30:00',4.17),('12374','2013-06-20','08:35:00',4.33),('12374','2013-06-20','08:40:00',4.49),('12374','2013-06-20','08:45:00',4.64),('12374','2013-06-20','08:50:00',4.78),('12374','2013-06-20','08:55:00',4.9),('12374','2013-06-20','09:00:00',5.07),('12374','2013-06-20','09:05:00',5.18),('12374','2013-06-20','09:10:00',5.34),('12374','2013-06-20','09:15:00',5.47),('12374','2013-06-20','09:20:00',5.59),('12374','2013-06-20','09:25:00',5.68),('12374','2013-06-20','09:30:00',5.79),('12374','2013-06-20','09:35:00',5.91),('12374','2013-06-20','09:40:00',6.06),('12374','2013-06-20','09:45:00',6.16),('12374','2013-06-20','09:50:00',6.29),('12374','2013-06-20','09:55:00',6.42),('12374','2013-06-20','10:00:00',6.54),('12374','2013-06-20','10:05:00',6.6),('12374','2013-06-20','10:10:00',6.76),('12374','2013-06-20','10:15:00',6.84),('12374','2013-06-20','10:20:00',6.91),('12374','2013-06-20','10:25:00',7),('12374','2013-06-20','10:30:00',7.05),('12374','2013-06-20','10:35:00',7.13),('12374','2013-06-20','10:40:00',7.31),('12374','2013-06-20','10:45:00',7.42),('12374','2013-06-20','10:50:00',7.54),('12374','2013-06-20','10:55:00',7.62),('12374','2013-06-20','11:00:00',7.73),('12374','2013-06-20','11:05:00',7.78),('12374','2013-06-20','11:10:00',7.88),('12374','2013-06-20','11:15:00',7.93),('12374','2013-06-20','11:20:00',7.97),('12374','2013-06-20','11:25:00',1.6),('12374','2013-06-20','11:30:00',2.88),('12374','2013-06-20','11:35:00',8.12),('12374','2013-06-20','11:40:00',8.25),('12374','2013-06-20','11:45:00',8.35),('12374','2013-06-20','11:50:00',6.03),('12374','2013-06-20','11:55:00',7.72),('12374','2013-06-20','12:00:00',8.57),('12374','2013-06-20','12:05:00',8.66),('12374','2013-06-20','12:10:00',7.64),('12374','2013-06-20','12:15:00',6.36),('12374','2013-06-20','12:20:00',8.73),('12374','2013-06-20','12:25:00',8.7),('12374','2013-06-20','12:30:00',8.76),('12374','2013-06-20','12:35:00',5.94),('12374','2013-06-20','12:40:00',8.35),('12374','2013-06-20','12:45:00',8.79),('12374','2013-06-20','12:50:00',8.72),('12374','2013-06-20','12:55:00',6.66),('12374','2013-06-20','13:00:00',7.48),('12374','2013-06-20','13:05:00',8.78),('12374','2013-06-20','13:10:00',8.79),('12374','2013-06-20','13:15:00',8.78),('12374','2013-06-20','13:20:00',8.76),('12374','2013-06-20','13:25:00',8.78),('12374','2013-06-20','13:30:00',8.78),('12374','2013-06-20','13:35:00',8.75),('12374','2013-06-20','13:40:00',8.76),('12374','2013-06-20','13:45:00',8.78),('12374','2013-06-20','13:50:00',8.78),('12374','2013-06-20','13:55:00',8.75),('12374','2013-06-20','14:00:00',8.71),('12374','2013-06-20','14:05:00',8.69),('12374','2013-06-20','14:10:00',8.7),('12374','2013-06-20','14:15:00',8.64),('12374','2013-06-20','14:20:00',8.59),('12374','2013-06-20','14:25:00',8.48),('12374','2013-06-20','14:30:00',8.44),('12374','2013-06-20','14:35:00',8.44),('12374','2013-06-20','14:40:00',8.43),('12374','2013-06-20','14:45:00',8.31),('12374','2013-06-20','14:50:00',8.18),('12374','2013-06-20','14:55:00',8.05),('12374','2013-06-20','15:00:00',8.04),('12374','2013-06-20','15:05:00',8.01),('12374','2013-06-20','15:10:00',7.91),('12374','2013-06-20','15:15:00',7.82),('12374','2013-06-20','15:20:00',7.74),('12374','2013-06-20','15:25:00',7.64),('12374','2013-06-20','15:30:00',7.54),('12374','2013-06-20','15:35:00',7.38),('12374','2013-06-20','15:40:00',7.32),('12374','2013-06-20','15:45:00',7.22),('12374','2013-06-20','15:50:00',7.09),('12374','2013-06-20','15:55:00',6.98),('12374','2013-06-20','16:00:00',6.9),('12374','2013-06-20','16:05:00',6.87),('12374','2013-06-20','16:10:00',6.75),('12374','2013-06-20','16:15:00',6.6),('12374','2013-06-20','16:20:00',6.48),('12374','2013-06-20','16:25:00',6.36),('12374','2013-06-20','16:30:00',6.24),('12374','2013-06-20','16:35:00',6.11),('12374','2013-06-19','06:50:00',1.13),('12374','2013-06-19','06:55:00',1.23),('12374','2013-06-19','07:00:00',1.36),('12374','2013-06-19','07:05:00',1.3),('12374','2013-06-19','07:10:00',1.58),('12374','2013-06-19','07:15:00',1.69),('12374','2013-06-19','07:20:00',1.87),('12374','2013-06-19','07:25:00',2.02),('12374','2013-06-19','07:30:00',2.2),('12374','2013-06-19','07:35:00',2.36),('12374','2013-06-19','07:40:00',2.51),('12374','2013-06-19','07:45:00',2.66),('12374','2013-06-19','07:50:00',2.8),('12374','2013-06-19','07:55:00',2.97),('12374','2013-06-19','08:00:00',3.12),('12374','2013-06-19','08:05:00',3.26),('12374','2013-06-19','08:10:00',3.42),('12374','2013-06-19','08:15:00',3.58),('12374','2013-06-19','08:20:00',3.74),('12374','2013-06-19','08:25:00',3.91),('12374','2013-06-19','08:30:00',4.07),('12374','2013-06-19','08:35:00',4.21),('12374','2013-06-19','08:40:00',4.38),('12374','2013-06-19','08:45:00',4.54),('12374','2013-06-19','08:50:00',4.69),('12374','2013-06-19','08:55:00',4.84),('12374','2013-06-19','09:00:00',4.98),('12374','2013-06-19','09:05:00',5.1),('12374','2013-06-19','09:10:00',5.22),('12374','2013-06-19','09:15:00',5.35),('12374','2013-06-19','09:20:00',5.47),('12374','2013-06-19','09:25:00',5.61),('12374','2013-06-19','09:30:00',5.74),('12374','2013-06-19','09:35:00',5.87),('12374','2013-06-19','09:40:00',5.96),('12374','2013-06-19','09:45:00',6.07),('12374','2013-06-19','09:50:00',6.15),('12374','2013-06-19','09:55:00',6.29),('12374','2013-06-19','10:00:00',6.38),('12374','2013-06-19','10:05:00',6.48),('12374','2013-06-19','10:10:00',6.56),('12374','2013-06-19','10:15:00',6.68),('12374','2013-06-19','10:20:00',6.83),('12374','2013-06-19','10:25:00',6.97),('12374','2013-06-19','10:30:00',7.08),('12374','2013-06-19','10:35:00',7.19),('12374','2013-06-19','10:40:00',7.27),('12374','2013-06-19','10:45:00',7.35),('12374','2013-06-19','10:50:00',7.43),('12374','2013-06-19','10:55:00',7.54),('12374','2013-06-19','11:00:00',7.6),('12374','2013-06-19','11:05:00',7.65),('12374','2013-06-19','11:10:00',7.79),('12374','2013-06-19','11:15:00',7.88),('12374','2013-06-19','11:20:00',7.98),('12374','2013-06-19','11:25:00',8.05),('12374','2013-06-19','11:30:00',8.12),('12374','2013-06-19','11:35:00',8.21),('12374','2013-06-19','11:40:00',8.28),('12374','2013-06-19','11:45:00',8.35),('12374','2013-06-19','11:50:00',8.39),('12374','2013-06-19','11:55:00',8.38),('12374','2013-06-19','12:00:00',8.49),('12374','2013-06-19','12:05:00',8.56),('12374','2013-06-19','12:10:00',8.61),('12374','2013-06-19','12:15:00',8.64),('12374','2013-06-19','12:20:00',8.71),('12374','2013-06-19','12:25:00',8.72),('12374','2013-06-19','12:30:00',8.73),('12374','2013-06-19','12:35:00',8.76),('12374','2013-06-19','12:40:00',8.82),('12374','2013-06-19','12:45:00',8.84),('12374','2013-06-19','12:50:00',8.77),('12374','2013-06-19','12:55:00',8.82),('12374','2013-06-19','13:00:00',8.8),('12374','2013-06-19','13:05:00',8.83),('12374','2013-06-19','13:10:00',8.81),('12374','2013-06-19','13:15:00',8.83),('12374','2013-06-19','13:20:00',8.82),('12374','2013-06-19','13:25:00',8.88),('12374','2013-06-19','13:30:00',8.86),('12374','2013-06-19','13:35:00',8.82),('12374','2013-06-19','13:40:00',8.81),('12374','2013-06-19','13:45:00',8.79),('12374','2013-06-19','13:50:00',8.77),('12374','2013-06-19','13:55:00',8.77),('12374','2013-06-19','14:00:00',8.68),('12374','2013-06-19','14:05:00',8.69),('12374','2013-06-19','14:10:00',8.56),('12374','2013-06-19','14:15:00',8.59),('12374','2013-06-19','14:20:00',8.51),('12374','2013-06-19','14:25:00',8.45),('12374','2013-06-19','14:30:00',8.39),('12374','2013-06-19','14:35:00',8.33),('12374','2013-06-19','14:40:00',8.26),('12374','2013-06-19','14:45:00',8.18),('12374','2013-06-19','14:50:00',8.1),('12374','2013-06-19','14:55:00',8.02),('12374','2013-06-19','15:00:00',7.94),('12374','2013-06-19','15:05:00',7.87),('12374','2013-06-19','15:10:00',7.8),('12374','2013-06-19','15:15:00',7.71),('12374','2013-06-19','15:20:00',7.61),('12374','2013-06-19','15:25:00',7.5),('12374','2013-06-19','15:30:00',7.44),('12374','2013-06-19','15:35:00',7.36),('12374','2013-06-19','15:40:00',7.26),('12374','2013-06-19','15:45:00',7.16),('12374','2013-06-19','15:50:00',7.07),('12374','2013-06-19','15:55:00',6.95),('12374','2013-06-19','16:00:00',6.84),('12374','2013-06-19','16:05:00',6.72),('12374','2013-06-19','16:10:00',6.6),('12374','2013-06-19','16:15:00',6.48),('12374','2013-06-19','16:20:00',6.38),('12374','2013-06-19','16:25:00',6.27),('12374','2013-06-19','16:30:00',6.15),('12374','2013-06-19','16:35:00',6.03),('12374','2013-06-19','16:40:00',5.9),('12374','2013-06-19','16:45:00',5.74),('12374','2013-06-19','16:50:00',5.58),('12374','2013-06-19','16:55:00',5.45),('12374','2013-06-19','17:00:00',5.37),('12374','2013-06-19','17:05:00',5.18),('12374','2013-06-19','17:10:00',5.06),('12374','2013-06-19','17:15:00',4.92),('12374','2013-06-19','17:20:00',4.66),('12374','2013-06-19','17:25:00',4.46),('12374','2013-06-19','17:30:00',4.22),('12374','2013-06-19','17:35:00',4.01),('12374','2013-06-19','17:40:00',3.92),('12374','2013-06-19','17:45:00',3.7),('12374','2013-06-19','17:50:00',3.56),('12374','2013-06-19','17:55:00',3.31),('12374','2013-06-19','18:00:00',3.22),('12374','2013-06-19','18:05:00',3.06),('12374','2013-06-19','18:10:00',2.89),('12374','2013-06-19','18:15:00',2.53),('12374','2013-06-19','18:20:00',2.25),('12374','2013-06-19','18:25:00',2.22),('12374','2013-06-19','18:30:00',2.1),('12374','2013-06-19','18:35:00',1.96),('12374','2013-06-19','18:40:00',1.86),('12374','2013-06-19','18:45:00',1.7),('12374','2013-06-19','18:50:00',1.63),('12374','2013-06-19','18:55:00',1.58),('12374','2013-06-19','19:00:00',1.51),('12374','2013-06-19','19:05:00',1.43),('12374','2013-06-19','19:10:00',1.35),('12374','2013-06-19','19:15:00',1.27),('12374','2013-06-19','19:20:00',1.2),('12374','2013-06-19','19:25:00',1.13),('12374','2013-06-19','19:30:00',1.03),('12374','2013-06-18','06:50:00',1.13),('12374','2013-06-18','06:55:00',1.22),('12374','2013-06-18','07:00:00',1.36),('12374','2013-06-18','07:05:00',1.31),('12374','2013-06-18','07:10:00',1.58),('12374','2013-06-18','07:15:00',1.68),('12374','2013-06-18','07:20:00',1.86),('12374','2013-06-18','07:25:00',2),('12374','2013-06-18','07:30:00',2.19),('12374','2013-06-18','07:35:00',2.33),('12374','2013-06-18','07:40:00',2.5),('12374','2013-06-18','07:45:00',2.67),('12374','2013-06-18','07:50:00',2.84),('12374','2013-06-18','07:55:00',3),('12374','2013-06-18','08:00:00',3.16),('12374','2013-06-18','08:05:00',3.31),('12374','2013-06-18','08:10:00',3.48),('12374','2013-06-18','08:15:00',3.64),('12374','2013-06-18','08:20:00',3.79),('12374','2013-06-18','08:25:00',3.97),('12374','2013-06-18','08:30:00',4.13),('12374','2013-06-18','08:35:00',4.29),('12374','2013-06-18','08:40:00',4.47),('12374','2013-06-18','08:45:00',4.64),('12374','2013-06-18','08:50:00',4.76),('12374','2013-06-18','08:55:00',4.89),('12374','2013-06-18','09:00:00',5.01),('12374','2013-06-18','09:05:00',5.17),('12374','2013-06-18','09:10:00',5.32),('12374','2013-06-18','09:15:00',5.44),('12374','2013-06-18','09:20:00',5.55),('12374','2013-06-18','09:25:00',5.64),('12374','2013-06-18','09:30:00',5.76),('12374','2013-06-18','09:35:00',5.92),('12374','2013-06-18','09:40:00',6.02),('12374','2013-06-18','09:45:00',6.17),('12374','2013-06-18','09:50:00',6.27),('12374','2013-06-18','09:55:00',6.4),('12374','2013-06-18','10:00:00',6.51),('12374','2013-06-18','10:05:00',6.61),('12374','2013-06-18','10:10:00',6.7),('12374','2013-06-18','10:15:00',6.8),('12374','2013-06-18','10:20:00',6.9),('12374','2013-06-18','10:25:00',6.99),('12374','2013-06-18','10:30:00',7.06),('12374','2013-06-18','10:35:00',7.14),('12374','2013-06-18','10:40:00',7.22),('12374','2013-06-18','10:45:00',7.29),('12374','2013-06-18','10:50:00',7.36),('12374','2013-06-18','10:55:00',7.44),('12374','2013-06-18','11:00:00',7.52),('12374','2013-06-18','11:05:00',7.6),('12374','2013-06-18','11:10:00',7.64),('12374','2013-06-18','11:15:00',7.74),('12374','2013-06-18','11:20:00',7.84),('12374','2013-06-18','11:25:00',7.94),('12374','2013-06-18','11:30:00',7.97),('12374','2013-06-18','11:35:00',8.05),('12374','2013-06-18','11:40:00',8.13),('12374','2013-06-18','11:45:00',8.21),('12374','2013-06-18','11:50:00',8.24),('12374','2013-06-18','11:55:00',8.29),('12374','2013-06-18','12:00:00',8.35),('12374','2013-06-18','12:05:00',8.38),('12374','2013-06-18','12:10:00',8.42),('12374','2013-06-18','12:15:00',8.46),('12374','2013-06-18','12:20:00',8.5),('12374','2013-06-18','12:25:00',8.53),('12374','2013-06-18','12:30:00',8.57),('12374','2013-06-18','12:35:00',8.6),('12374','2013-06-18','12:40:00',8.67),('12374','2013-06-18','12:45:00',8.68),('12374','2013-06-18','12:50:00',8.69),('12374','2013-06-18','12:55:00',8.67),('12374','2013-06-18','13:00:00',8.66),('12374','2013-06-18','13:05:00',8.64),('12374','2013-06-18','13:10:00',8.71),('12374','2013-06-18','13:15:00',8.78),('12374','2013-06-18','13:20:00',8.79),('12374','2013-06-18','13:25:00',8.75),('12374','2013-06-18','13:30:00',8.72),('12374','2013-06-18','13:35:00',8.74),('12374','2013-06-18','13:40:00',8.77),('12374','2013-06-18','13:45:00',8.77),('12374','2013-06-18','13:50:00',8.69),('12374','2013-06-18','13:55:00',8.77),('12374','2013-06-18','14:00:00',8.69),('12374','2013-06-18','14:05:00',8.66),('12374','2013-06-18','14:10:00',8.65),('12374','2013-06-18','14:15:00',8.62),('12374','2013-06-18','14:20:00',8.56),('12374','2013-06-18','14:25:00',8.54),('12374','2013-06-18','14:30:00',8.46),('12374','2013-06-18','14:35:00',8.49),('12374','2013-06-18','14:40:00',8.5),('12374','2013-06-18','14:45:00',8.49),('12374','2013-06-18','14:50:00',8.45),('12374','2013-06-18','14:55:00',8.44),('12374','2013-06-18','15:00:00',8.42),('12374','2013-06-18','15:05:00',8.4),('12374','2013-06-18','15:10:00',8.38),('12374','2013-06-18','15:15:00',8.32),('12374','2013-06-18','15:20:00',8.23),('12374','2013-06-18','15:25:00',8.11),('12374','2013-06-18','15:30:00',7.98),('12374','2013-06-18','15:35:00',7.84),('12374','2013-06-18','15:40:00',7.67),('12374','2013-06-18','15:45:00',7.48),('12374','2013-06-18','15:50:00',7.33),('12374','2013-06-18','15:55:00',7.16),('12374','2013-06-18','16:00:00',7),('12374','2013-06-18','16:05:00',6.81),('12374','2013-06-18','16:10:00',6.68),('12374','2013-06-18','16:15:00',6.54),('12374','2013-06-18','16:20:00',6.42),('12374','2013-06-18','16:25:00',6.29),('12374','2013-06-18','16:30:00',6.26),('12374','2013-06-18','16:35:00',6.14),('12374','2013-06-18','16:40:00',6.02),('12374','2013-06-18','16:45:00',5.9),('12374','2013-06-18','16:50:00',5.78),('12374','2013-06-18','16:55:00',5.66),('12374','2013-06-18','17:00:00',5.53),('12374','2013-06-18','17:05:00',5.34),('12374','2013-06-18','17:10:00',5.16),('12374','2013-06-18','17:15:00',5),('12374','2013-06-18','17:20:00',4.71),('12374','2013-06-18','17:25:00',4.47),('12374','2013-06-18','17:30:00',4.25),('12374','2013-06-18','17:35:00',4.12),('12374','2013-06-18','17:40:00',3.93),('12374','2013-06-18','17:45:00',3.7),('12374','2013-06-18','17:50:00',3.57),('12374','2013-06-18','17:55:00',3.39),('12374','2013-06-18','18:00:00',3.24),('12374','2013-06-18','18:05:00',3.09),('12374','2013-06-18','18:10:00',2.9),('12374','2013-06-18','18:15:00',2.55),('12374','2013-06-18','18:20:00',2.29),('12374','2013-06-18','18:25:00',2.26),('12374','2013-06-18','18:30:00',2.14),('12374','2013-06-18','18:35:00',1.98),('12374','2013-06-18','18:40:00',1.89),('12374','2013-06-18','18:45:00',1.73),('12374','2013-06-18','18:50:00',1.64),('12374','2013-06-18','18:55:00',1.6),('12374','2013-06-18','19:00:00',1.53),('12374','2013-06-18','19:05:00',1.46),('12374','2013-06-18','19:10:00',1.39),('12374','2013-06-18','19:15:00',1.31),('12374','2013-06-18','19:20:00',1.24),('12374','2013-06-18','19:25:00',1.16),('12374','2013-06-18','19:30:00',1.07),('12374','2013-06-17','06:45:00',1.09),('12374','2013-06-17','06:50:00',1.19),('12374','2013-06-17','06:55:00',1.28),('12374','2013-06-17','07:00:00',1.42),('12374','2013-06-17','07:05:00',1.36),('12374','2013-06-17','07:10:00',1.66),('12374','2013-06-17','07:15:00',1.77),('12374','2013-06-17','07:20:00',1.96),('12374','2013-06-17','07:25:00',2.13),('12374','2013-06-17','07:30:00',2.32),('12374','2013-06-17','07:35:00',2.47),('12374','2013-06-17','07:40:00',2.63),('12374','2013-06-17','07:45:00',2.79),('12374','2013-06-17','07:50:00',2.94),('12374','2013-06-17','07:55:00',3.13),('12374','2013-06-17','08:00:00',3.29),('12374','2013-06-17','08:05:00',3.43),('12374','2013-06-17','08:10:00',3.59),('12374','2013-06-17','08:15:00',3.76),('12374','2013-06-17','08:20:00',3.92),('12374','2013-06-17','08:25:00',4.08),('12374','2013-06-17','08:30:00',4.25),('12374','2013-06-17','08:35:00',4.39),('12374','2013-06-17','08:40:00',4.56),('12374','2013-06-17','08:45:00',4.71),('12374','2013-06-17','08:50:00',4.84),('12374','2013-06-17','08:55:00',4.97),('12374','2013-06-17','09:00:00',5.11),('12374','2013-06-17','09:05:00',5.25),('12374','2013-06-17','09:10:00',5.4),('12374','2013-06-17','09:15:00',5.52),('12374','2013-06-17','09:20:00',5.64),('12374','2013-06-17','09:25:00',5.76),('12374','2013-06-17','09:30:00',5.87),('12374','2013-06-17','09:35:00',5.95),('12374','2013-06-17','09:40:00',6.04),('12374','2013-06-17','09:45:00',6.14),('12374','2013-06-17','09:50:00',6.28),('12374','2013-06-17','09:55:00',6.37),('12374','2013-06-17','10:00:00',6.5),('12374','2013-06-17','10:05:00',6.63),('12374','2013-06-17','10:10:00',6.81),('12374','2013-06-17','10:15:00',6.9),('12374','2013-06-17','10:20:00',6.96),('12374','2013-06-17','10:25:00',7.07),('12374','2013-06-17','10:30:00',7.14),('12374','2013-06-17','10:35:00',7.25),('12374','2013-06-17','10:40:00',7.42),('12374','2013-06-17','10:45:00',7.53),('12374','2013-06-17','10:50:00',7.6),('12374','2013-06-17','10:55:00',7.64),('12374','2013-06-17','11:00:00',7.8),('12374','2013-06-17','11:05:00',7.89),('12374','2013-06-17','11:10:00',7.98),('12374','2013-06-17','11:15:00',8.04),('12374','2013-06-17','11:20:00',8.12),('12374','2013-06-17','11:25:00',8.18),('12374','2013-06-17','11:30:00',8.26),('12374','2013-06-17','11:35:00',8.3),('12374','2013-06-17','11:40:00',8.35),('12374','2013-06-17','11:45:00',8.4),('12374','2013-06-17','11:50:00',8.43),('12374','2013-06-17','11:55:00',8.52),('12374','2013-06-17','12:00:00',8.57),('12374','2013-06-17','12:05:00',8.6),('12374','2013-06-17','12:10:00',8.6),('12374','2013-06-17','12:15:00',8.66),('12374','2013-06-17','12:20:00',8.7),('12374','2013-06-17','12:25:00',8.77),('12374','2013-06-17','12:30:00',8.79),('12374','2013-06-17','12:35:00',8.79),('12374','2013-06-17','12:40:00',8.79),('12374','2013-06-17','12:45:00',8.81),('12374','2013-06-17','12:50:00',8.78),('12374','2013-06-17','12:55:00',8.82),('12374','2013-06-17','13:00:00',8.88),('12374','2013-06-17','13:05:00',8.87),('12374','2013-06-17','13:10:00',8.85),('12374','2013-06-17','13:15:00',8.79),('12374','2013-06-17','13:20:00',8.79),('12374','2013-06-17','13:25:00',8.79),('12374','2013-06-17','13:30:00',8.77),('12374','2013-06-17','13:35:00',8.76),('12374','2013-06-17','13:40:00',8.73),('12374','2013-06-17','13:45:00',8.69),('12374','2013-06-17','13:50:00',8.7),('12374','2013-06-17','13:55:00',8.68),('12374','2013-06-17','14:00:00',8.68),('12374','2013-06-17','14:05:00',8.66),('12374','2013-06-17','14:10:00',8.63),('12374','2013-06-17','14:15:00',8.54),('12374','2013-06-17','14:20:00',8.47),('12374','2013-06-17','14:25:00',8.42),('12374','2013-06-17','14:30:00',8.38),('12374','2013-06-17','14:35:00',8.3),('12374','2013-06-17','14:40:00',8.22),('12374','2013-06-17','14:45:00',8.14),('12374','2013-06-17','14:50:00',8.04),('12374','2013-06-17','14:55:00',8.02),('12374','2013-06-17','15:00:00',7.93),('12374','2013-06-17','15:05:00',7.83),('12374','2013-06-17','15:10:00',7.78),('12374','2013-06-17','15:15:00',7.72),('12374','2013-06-17','15:20:00',7.65),('12374','2013-06-17','15:25:00',7.56),('12374','2013-06-17','15:30:00',7.48),('12374','2013-06-17','15:35:00',7.38),('12374','2013-06-17','15:40:00',7.28),('12374','2013-06-17','15:45:00',7.2),('12374','2013-06-17','15:50:00',7.1),('12374','2013-06-17','15:55:00',7),('12374','2013-06-17','16:00:00',6.88),('12374','2013-06-17','16:05:00',6.76),('12374','2013-06-17','16:10:00',6.65),('12374','2013-06-17','16:15:00',6.52),('12374','2013-06-17','16:20:00',6.41),('12374','2013-06-17','16:25:00',6.29),('12374','2013-06-17','16:30:00',6.17),('12374','2013-06-17','16:35:00',6.06),('12374','2013-06-17','16:40:00',5.9),('12374','2013-06-17','16:45:00',5.73),('12374','2013-06-17','16:50:00',5.61),('12374','2013-06-17','16:55:00',5.49),('12374','2013-06-17','17:00:00',5.36),('12374','2013-06-17','17:05:00',5.23),('12374','2013-06-17','17:10:00',5.09),('12374','2013-06-17','17:15:00',4.94),('12374','2013-06-17','17:20:00',4.68),('12374','2013-06-17','17:25:00',4.51),('12374','2013-06-17','17:30:00',4.3),('12374','2013-06-17','17:35:00',4.11),('12374','2013-06-17','17:40:00',4.02),('12374','2013-06-17','17:45:00',3.84),('12374','2013-06-17','17:50:00',3.65),('12374','2013-06-17','17:55:00',3.43),('12374','2013-06-17','18:00:00',3.32),('12374','2013-06-17','18:05:00',3.16),('12374','2013-06-17','18:10:00',2.99),('12374','2013-06-17','18:15:00',2.61),('12374','2013-06-17','18:20:00',2.38),('12374','2013-06-17','18:25:00',2.34),('12374','2013-06-17','18:30:00',2.19),('12374','2013-06-17','18:35:00',2.03),('12374','2013-06-17','18:40:00',1.93),('12374','2013-06-17','18:45:00',1.77),('12374','2013-06-17','18:50:00',1.67),('12374','2013-06-17','18:55:00',1.64),('12374','2013-06-17','19:00:00',1.57),('12374','2013-06-17','19:05:00',1.5),('12374','2013-06-17','19:10:00',1.43),('12374','2013-06-17','19:15:00',1.35),('12374','2013-06-17','19:20:00',1.28),('12374','2013-06-17','19:25:00',1.19),('12374','2013-06-17','19:30:00',1.09),('12374','2013-06-17','19:35:00',1.02),('12374','2013-06-16','06:45:00',1.13),('12374','2013-06-16','06:50:00',1.24),('12374','2013-06-16','06:55:00',1.34),('12374','2013-06-16','07:00:00',1.5),('12374','2013-06-16','07:05:00',1.4),('12374','2013-06-16','07:10:00',1.76),('12374','2013-06-16','07:15:00',1.91),('12374','2013-06-16','07:20:00',2.05),('12374','2013-06-16','07:25:00',2.2),('12374','2013-06-16','07:30:00',2.38),('12374','2013-06-16','07:35:00',2.55),('12374','2013-06-16','07:40:00',2.71),('12374','2013-06-16','07:45:00',2.88),('12374','2013-06-16','07:50:00',3.02),('12374','2013-06-16','07:55:00',3.18),('12374','2013-06-16','08:00:00',3.31),('12374','2013-06-16','08:05:00',3.49),('12374','2013-06-16','08:10:00',3.62),('12374','2013-06-16','08:15:00',3.76),('12374','2013-06-16','08:20:00',3.96),('12374','2013-06-16','08:25:00',4.13),('12374','2013-06-16','08:30:00',4.31),('12374','2013-06-16','08:35:00',4.45),('12374','2013-06-16','08:40:00',4.56),('12374','2013-06-16','08:45:00',4.58),('12374','2013-06-16','08:55:00',2.47),('12374','2013-06-16','09:00:00',5.08),('12374','2013-06-16','09:05:00',5.14),('12374','2013-06-16','09:10:00',5.4),('12374','2013-06-16','09:15:00',4.73),('12374','2013-06-16','09:20:00',5.6),('12374','2013-06-16','09:25:00',5.13),('12374','2013-06-16','09:30:00',5.93),('12374','2013-06-16','09:35:00',5.32),('12374','2013-06-16','09:40:00',5.76),('12374','2013-06-16','09:45:00',6.08),('12374','2013-06-16','09:50:00',5.9),('12374','2013-06-16','09:55:00',6.32),('12374','2013-06-16','10:00:00',5.53),('12374','2013-06-16','10:05:00',6.66),('12374','2013-06-16','10:10:00',6.15),('12374','2013-06-16','10:15:00',6.95),('12374','2013-06-16','10:20:00',5.69),('12374','2013-06-16','10:25:00',6.97),('12374','2013-06-16','10:30:00',7.07),('12374','2013-06-16','10:35:00',7.05),('12374','2013-06-16','10:40:00',7.51),('12374','2013-06-16','10:45:00',7.57),('12374','2013-06-16','10:50:00',7.65),('12374','2013-06-16','10:55:00',7.79),('12374','2013-06-16','11:00:00',7.91),('12374','2013-06-16','11:05:00',7.95),('12374','2013-06-16','11:10:00',8.02),('12374','2013-06-16','11:15:00',8.14),('12374','2013-06-16','11:20:00',8.23),('12374','2013-06-16','11:25:00',8.28),('12374','2013-06-16','11:30:00',8.35),('12374','2013-06-16','11:35:00',8.35),('12374','2013-06-16','11:40:00',8.42),('12374','2013-06-16','11:45:00',8.48),('12374','2013-06-16','11:50:00',8.59),('12374','2013-06-16','11:55:00',8.62),('12374','2013-06-16','12:00:00',8.71),('12374','2013-06-16','12:05:00',8.77),('12374','2013-06-16','12:10:00',8.84),('12374','2013-06-16','12:15:00',8.89),('12374','2013-06-16','12:20:00',8.92),('12374','2013-06-16','12:25:00',8.92),('12374','2013-06-16','12:30:00',8.91),('12374','2013-06-16','12:35:00',8.95),('12374','2013-06-16','12:40:00',8.92),('12374','2013-06-16','12:45:00',8.95),('12374','2013-06-16','12:50:00',8.96),('12374','2013-06-16','12:55:00',8.95),('12374','2013-06-16','13:00:00',8.97),('12374','2013-06-16','13:05:00',9),('12374','2013-06-16','13:10:00',2.15),('12374','2013-06-16','13:40:00',7.9),('12374','2013-06-16','13:45:00',8.86),('12374','2013-06-16','13:50:00',8.81),('12374','2013-06-16','13:55:00',8.15),('12374','2013-06-16','14:00:00',6.15),('12374','2013-06-16','14:05:00',8.71),('12374','2013-06-16','14:10:00',8.77),('12374','2013-06-16','14:15:00',8.75),('12374','2013-06-16','14:20:00',5.66),('12374','2013-06-16','14:25:00',8.48),('12374','2013-06-16','14:30:00',8.57),('12374','2013-06-16','14:35:00',8.46),('12374','2013-06-16','14:40:00',6.5),('12374','2013-06-16','14:45:00',7.02),('12374','2013-06-16','14:50:00',8.22),('12374','2013-06-16','14:55:00',8.18),('12374','2013-06-16','15:00:00',6.7),('12374','2013-06-16','15:05:00',6.65),('12374','2013-06-16','15:10:00',7.79),('12374','2013-06-16','15:15:00',7.75),('12374','2013-06-16','15:20:00',7.69),('12374','2013-06-16','15:25:00',7.67),('12374','2013-06-16','15:30:00',7.57),('12374','2013-06-16','15:35:00',7.41),('12374','2013-06-16','15:40:00',7.38),('12374','2013-06-16','15:45:00',7.24),('12374','2013-06-16','15:50:00',7.14),('12374','2013-06-16','15:55:00',7.02),('12374','2013-06-16','16:00:00',6.9),('12374','2013-06-16','16:05:00',6.73),('12374','2013-06-16','16:10:00',6.6),('12374','2013-06-16','16:15:00',6.52),('12374','2013-06-16','16:20:00',6.4),('12374','2013-06-16','16:25:00',6.31),('12374','2013-06-16','16:30:00',6.18),('12374','2013-06-16','16:35:00',6.06),('12374','2013-06-16','16:40:00',5.92),('12374','2013-06-16','16:45:00',5.74),('12374','2013-06-16','16:50:00',5.64),('12374','2013-06-16','16:55:00',5.48),('12374','2013-06-16','17:00:00',5.3),('12374','2013-06-16','17:05:00',5.16),('12374','2013-06-16','17:10:00',5.02),('12374','2013-06-16','17:15:00',4.87),('12374','2013-06-16','17:20:00',4.61),('12374','2013-06-16','17:25:00',4.46),('12374','2013-06-16','17:30:00',4.29),('12374','2013-06-16','17:35:00',4.08),('12374','2013-06-16','17:40:00',3.9),('12374','2013-06-16','17:45:00',3.71),('12374','2013-06-16','17:50:00',3.53),('12374','2013-06-16','17:55:00',3.36),('12374','2013-06-16','18:00:00',3.21),('12374','2013-06-16','18:05:00',3.02),('12374','2013-06-16','18:10:00',2.88),('12374','2013-06-16','18:15:00',2.5),('12374','2013-06-16','18:20:00',2.27),('12374','2013-06-16','18:25:00',2.24),('12374','2013-06-16','18:30:00',2.09),('12374','2013-06-16','18:35:00',1.94),('12374','2013-06-16','18:40:00',1.85),('12374','2013-06-16','18:45:00',1.69),('12374','2013-06-16','18:50:00',1.6),('12374','2013-06-16','18:55:00',1.55),('12374','2013-06-16','19:00:00',1.48),('12374','2013-06-16','19:05:00',1.4),('12374','2013-06-16','19:10:00',1.33),('12374','2013-06-16','19:15:00',1.27),('12374','2013-06-16','19:20:00',1.2),('12374','2013-06-16','19:25:00',1.13),('12374','2013-06-16','19:30:00',1.05),('12374','2013-06-15','07:35:00',1.2),('12374','2013-06-15','07:40:00',1.47),('12374','2013-06-15','07:45:00',1.64),('12374','2013-06-15','07:50:00',1.41),('12374','2013-06-15','07:55:00',1.54),('12374','2013-06-15','08:00:00',1.89),('12374','2013-06-15','08:05:00',2.24),('12374','2013-06-15','08:10:00',2.08),('12374','2013-06-15','08:15:00',2.1),('12374','2013-06-15','08:20:00',3.09),('12374','2013-06-15','08:25:00',3.53),('12374','2013-06-15','08:30:00',3.23),('12374','2013-06-15','08:35:00',2.9),('12374','2013-06-15','08:40:00',3.04),('12374','2013-06-15','08:45:00',3.1),('12374','2013-06-15','08:50:00',4.62),('12374','2013-06-15','08:55:00',4.12),('12374','2013-06-15','09:00:00',3.13),('12374','2013-06-15','09:05:00',5.23),('12374','2013-06-15','09:10:00',4.71),('12374','2013-06-15','09:15:00',5.37),('12374','2013-06-15','09:20:00',5.43),('12374','2013-06-15','09:25:00',3.58),('12374','2013-06-15','09:30:00',3.71),('12374','2013-06-15','09:35:00',3.48),('12374','2013-06-15','09:40:00',4.09),('12374','2013-06-15','09:45:00',4.35),('12374','2013-06-15','09:50:00',3.82),('12374','2013-06-15','09:55:00',3.58),('12374','2013-06-15','10:00:00',3.28),('12374','2013-06-15','10:05:00',2.99),('12374','2013-06-15','10:10:00',3.32),('12374','2013-06-15','10:15:00',3.89),('12374','2013-06-15','10:20:00',3.59),('12374','2013-06-15','10:25:00',6.12),('12374','2013-06-15','10:30:00',4.68),('12374','2013-06-15','10:35:00',5.76),('12374','2013-06-15','10:40:00',7),('12374','2013-06-15','10:45:00',7.79),('12374','2013-06-15','10:50:00',7.76),('12374','2013-06-15','10:55:00',7.89),('12374','2013-06-15','11:00:00',7.87),('12374','2013-06-15','11:05:00',8.03),('12374','2013-06-15','11:10:00',8.17),('12374','2013-06-15','11:15:00',8.1),('12374','2013-06-15','11:20:00',8.34),('12374','2013-06-15','11:25:00',8.42),('12374','2013-06-15','11:30:00',8.27),('12374','2013-06-15','11:35:00',7.41),('12374','2013-06-15','11:40:00',8.32),('12374','2013-06-15','11:45:00',8.79),('12374','2013-06-15','11:50:00',8.61),('12374','2013-06-15','11:55:00',8.14),('12374','2013-06-15','12:00:00',8.51),('12374','2013-06-15','12:05:00',8.88),('12374','2013-06-15','12:10:00',8.39),('12374','2013-06-15','12:15:00',8.05),('12374','2013-06-15','12:20:00',7.94),('12374','2013-06-15','12:25:00',6.17),('12374','2013-06-15','12:30:00',9.16),('12374','2013-06-15','12:35:00',9.05),('12374','2013-06-15','12:40:00',8.66),('12374','2013-06-15','12:45:00',7.54),('12374','2013-06-15','12:50:00',8.97),('12374','2013-06-15','12:55:00',8.94),('12374','2013-06-15','13:00:00',8.87),('12374','2013-06-15','13:05:00',6.54),('12374','2013-06-15','13:10:00',8.61),('12374','2013-06-15','13:15:00',7.76),('12374','2013-06-15','13:20:00',8.27),('12374','2013-06-15','13:25:00',7.43),('12374','2013-06-15','13:30:00',8.5),('12374','2013-06-15','13:35:00',5.52),('12374','2013-06-15','13:40:00',7.78),('12374','2013-06-15','13:45:00',6.89),('12374','2013-06-15','13:50:00',6.89),('12374','2013-06-15','13:55:00',7.18),('12374','2013-06-15','14:00:00',8.81),('12374','2013-06-15','14:05:00',6.41),('12374','2013-06-15','14:10:00',9.15),('12374','2013-06-15','14:15:00',8.59),('12374','2013-06-15','14:20:00',8.73),('12374','2013-06-15','14:25:00',8.43),('12374','2013-06-15','14:30:00',8.58),('12374','2013-06-15','14:35:00',7.86),('12374','2013-06-15','14:40:00',7.06),('12374','2013-06-15','14:45:00',8.63),('12374','2013-06-15','14:50:00',8.33),('12374','2013-06-15','14:55:00',8.05),('12374','2013-06-15','15:00:00',8.02),('12374','2013-06-15','15:05:00',7.84),('12374','2013-06-15','15:10:00',7.84),('12374','2013-06-15','15:15:00',7.77),('12374','2013-06-15','15:20:00',7.65),('12374','2013-06-15','15:25:00',7.47),('12374','2013-06-15','15:30:00',7.43),('12374','2013-06-15','15:35:00',7.31),('12374','2013-06-15','15:40:00',7.21),('12374','2013-06-15','15:45:00',7.17),('12374','2013-06-15','15:50:00',7.11),('12374','2013-06-15','15:55:00',6.99),('12374','2013-06-15','16:00:00',6.87),('12374','2013-06-15','16:05:00',6.79),('12374','2013-06-15','16:10:00',6.68),('12374','2013-06-15','16:15:00',6.57),('12374','2013-06-15','16:20:00',6.42),('12374','2013-06-15','16:25:00',6.29),('12374','2013-06-15','16:30:00',6.11),('12374','2013-06-15','16:35:00',6.01),('12374','2013-06-15','16:40:00',5.85),('12374','2013-06-15','16:45:00',5.68),('12374','2013-06-15','16:50:00',5.56),('12374','2013-06-15','16:55:00',5.44),('12374','2013-06-15','17:00:00',5.27),('12374','2013-06-15','17:05:00',5.14),('12374','2013-06-15','17:10:00',5),('12374','2013-06-15','17:15:00',4.84),('12374','2013-06-15','17:20:00',4.57),('12374','2013-06-15','17:25:00',4.37),('12374','2013-06-15','17:30:00',4.28),('12374','2013-06-15','17:35:00',4.07),('12374','2013-06-15','17:40:00',3.77),('12374','2013-06-15','17:45:00',3.73),('12374','2013-06-15','17:50:00',3.53),('12374','2013-06-15','17:55:00',3.26),('12374','2013-06-15','18:00:00',3.19),('12374','2013-06-15','18:05:00',3.03),('12374','2013-06-15','18:10:00',2.84),('12374','2013-06-15','18:15:00',2.47),('12374','2013-06-15','18:20:00',2.28),('12374','2013-06-15','18:25:00',2.16),('12374','2013-06-15','18:30:00',2.07),('12374','2013-06-15','18:35:00',1.93),('12374','2013-06-15','18:40:00',1.83),('12374','2013-06-15','18:45:00',1.69),('12374','2013-06-15','18:50:00',1.62),('12374','2013-06-15','18:55:00',1.58),('12374','2013-06-15','19:00:00',1.5),('12374','2013-06-15','19:05:00',1.42),('12374','2013-06-15','19:10:00',1.32),('12374','2013-06-15','19:15:00',1.24),('12374','2013-06-15','19:20:00',1.15),('12374','2013-06-15','19:25:00',1.09),('12374','2013-06-14','06:36:00',1.06),('12374','2013-06-14','06:45:00',1.25),('12374','2013-06-14','06:51:00',1.32),('12374','2013-06-14','06:55:00',1.49),('12374','2013-06-14','07:01:00',1.54),('12374','2013-06-14','07:05:00',1.71),('12374','2013-06-14','07:10:00',1.89),('12374','2013-06-14','07:16:00',2),('12374','2013-06-14','07:20:00',2.21),('12374','2013-06-14','07:26:00',2.33),('12374','2013-06-14','07:30:00',2.59),('12374','2013-06-14','07:36:00',2.72),('12374','2013-06-14','07:40:00',2.93),('12374','2013-06-14','07:46:00',3.04),('12374','2013-06-14','07:50:00',3.25),('12374','2013-06-14','07:56:00',3.37),('12374','2013-06-14','08:00:00',3.59),('12374','2013-06-14','08:06:00',3.72),('12374','2013-06-14','08:10:00',3.93),('12374','2013-06-14','08:16:00',4.03),('12374','2013-06-14','08:20:00',4.2),('12374','2013-06-14','08:26:00',4.29),('12374','2013-06-14','08:30:00',4.51),('12374','2013-06-14','08:36:00',4.63),('12374','2013-06-14','08:40:00',4.82),('12374','2013-06-14','08:46:00',4.92),('12374','2013-06-14','08:50:00',5.03),('12374','2013-06-14','08:55:00',5.19),('12374','2013-06-14','09:00:00',5.32),('12374','2013-06-14','09:05:00',5.47),('12374','2013-06-14','09:10:00',5.58),('12374','2013-06-14','09:15:00',5.68),('12374','2013-06-14','09:20:00',5.82),('12374','2013-06-14','09:25:00',5.92),('12374','2013-06-14','09:30:00',6.04),('12374','2013-06-14','09:35:00',6.16),('12374','2013-06-14','09:40:00',6.28),('12374','2013-06-14','09:45:00',6.43),('12374','2013-06-14','09:50:00',6.59),('12374','2013-06-14','09:55:00',6.76),('12374','2013-06-14','10:00:00',6.86),('12374','2013-06-14','10:05:00',6.89),('12374','2013-06-14','10:10:00',6.94),('12374','2013-06-14','10:15:00',7.12),('12374','2013-06-14','10:20:00',7.29),('12374','2013-06-14','10:25:00',7.43),('12374','2013-06-14','10:30:00',7.58),('12374','2013-06-14','10:35:00',7.15),('12374','2013-06-14','10:40:00',7.61),('12374','2013-06-14','10:45:00',7.48),('12374','2013-06-14','10:50:00',7.6),('12374','2013-06-14','10:55:00',7.78),('12374','2013-06-14','11:00:00',8.14),('12374','2013-06-14','11:05:00',8.37),('12374','2013-06-14','11:10:00',8.43),('12374','2013-06-14','11:15:00',8.28),('12374','2013-06-14','11:20:00',8.1),('12374','2013-06-14','11:25:00',8.47),('12374','2013-06-14','11:30:00',8.56),('12374','2013-06-14','11:35:00',8.64),('12374','2013-06-14','11:40:00',8.69),('12374','2013-06-14','11:45:00',8.76),('12374','2013-06-14','11:50:00',8.81),('12374','2013-06-14','11:55:00',8.86),('12374','2013-06-14','12:00:00',8.93),('12374','2013-06-14','12:05:00',8.92),('12374','2013-06-14','12:10:00',8.95),('12374','2013-06-14','12:15:00',9.02),('12374','2013-06-14','12:20:00',8.98),('12374','2013-06-14','12:25:00',9.07),('12374','2013-06-14','12:30:00',9.12),('12374','2013-06-14','12:35:00',9.1),('12374','2013-06-14','12:40:00',9.09),('12374','2013-06-14','12:45:00',9.09),('12374','2013-06-14','12:50:00',9.11),('12374','2013-06-14','12:55:00',9.12),('12374','2013-06-14','13:00:00',9.17),('12374','2013-06-14','13:05:00',9.15),('12374','2013-06-14','13:10:00',9.21),('12374','2013-06-14','13:15:00',9.17),('12374','2013-06-14','13:20:00',8.96),('12374','2013-06-14','13:25:00',8.95),('12374','2013-06-14','13:30:00',8.84),('12374','2013-06-14','13:35:00',9.01),('12374','2013-06-14','13:40:00',9),('12374','2013-06-14','13:45:00',8.65),('12374','2013-06-14','13:50:00',8.64),('12374','2013-06-14','13:55:00',8.67),('12374','2013-06-14','14:00:00',8.77),('12374','2013-06-14','14:05:00',8.76),('12374','2013-06-14','14:10:00',8.9),('12374','2013-06-14','14:15:00',8.91),('12374','2013-06-14','14:20:00',8.87),('12374','2013-06-14','14:25:00',8.84),('12374','2013-06-14','14:30:00',8.79),('12374','2013-06-14','14:35:00',8.7),('12374','2013-06-14','14:40:00',8.63),('12374','2013-06-14','14:45:00',8.56),('12374','2013-06-14','14:50:00',8.47),('12374','2013-06-14','14:55:00',8.38),('12374','2013-06-14','15:00:00',8.3),('12374','2013-06-14','15:05:00',8.21),('12374','2013-06-14','15:10:00',8.09),('12374','2013-06-14','15:15:00',7.98),('12374','2013-06-14','15:20:00',7.86),('12374','2013-06-14','15:25:00',7.8),('12374','2013-06-14','15:30:00',7.7),('12374','2013-06-14','15:35:00',7.67),('12374','2013-06-14','15:40:00',7.56),('12374','2013-06-14','15:45:00',7.46),('12374','2013-06-14','15:50:00',7.34),('12374','2013-06-14','15:55:00',7.2),('12374','2013-06-14','16:00:00',7.05),('12374','2013-06-14','16:05:00',6.93),('12374','2013-06-14','16:10:00',6.81),('12374','2013-06-14','16:15:00',6.73),('12374','2013-06-14','16:20:00',6.6),('12374','2013-06-14','16:25:00',6.48),('12374','2013-06-14','16:30:00',6.23),('12374','2013-06-14','16:35:00',6.13),('12374','2013-06-14','16:40:00',6.01),('12374','2013-06-14','16:45:00',5.85),('12374','2013-06-14','16:50:00',5.75),('12374','2013-06-14','16:55:00',5.67),('12374','2013-06-14','17:00:00',5.52),('12374','2013-06-14','17:05:00',5.4),('12374','2013-06-14','17:10:00',5.21),('12374','2013-06-14','17:15:00',5.02),('12374','2013-06-14','17:20:00',4.79),('12374','2013-06-14','17:25:00',4.59),('12374','2013-06-14','17:30:00',4.37),('12374','2013-06-14','17:35:00',4.18),('12374','2013-06-14','17:40:00',4.07),('12374','2013-06-14','17:45:00',3.84),('12374','2013-06-14','17:50:00',3.68),('12374','2013-06-14','17:55:00',3.43),('12374','2013-06-14','18:00:00',3.37),('12374','2013-06-14','18:05:00',3.16),('12374','2013-06-14','18:10:00',2.97),('12374','2013-06-14','18:15:00',2.52),('12374','2013-06-14','18:20:00',2.35),('12374','2013-06-14','18:25:00',2.32),('12374','2013-06-14','18:30:00',2.18),('12374','2013-06-14','18:35:00',2),('12374','2013-06-14','18:40:00',1.89),('12374','2013-06-14','18:45:00',1.74),('12374','2013-06-14','18:50:00',1.66),('12374','2013-06-14','18:55:00',1.6),('12374','2013-06-14','19:00:00',1.54),('12374','2013-06-14','19:05:00',1.46),('12374','2013-06-14','19:10:00',1.39),('12374','2013-06-14','19:15:00',1.31),('12374','2013-06-14','19:20:00',1.23),('12374','2013-06-14','19:25:00',1.15),('12374','2013-06-14','19:30:00',1.04),('12374','2013-06-07','06:35:00',1.07),('12374','2013-06-07','06:45:00',1.23),('12374','2013-06-07','06:50:00',1.34),('12374','2013-06-07','06:55:00',1.48),('12374','2013-06-07','07:00:00',1.59),('12374','2013-06-07','07:05:00',1.44),('12374','2013-06-07','07:10:00',1.89),('12374','2013-06-07','07:15:00',2.05),('12374','2013-06-07','07:20:00',2.21),('12374','2013-06-07','07:25:00',2.39),('12374','2013-06-07','07:30:00',2.59),('12374','2013-06-07','07:35:00',2.76),('12374','2013-06-07','07:40:00',2.91),('12374','2013-06-07','07:45:00',3.08),('12374','2013-06-07','07:50:00',3.26),('12374','2013-06-07','07:55:00',3.42),('12374','2013-06-07','08:00:00',3.6),('12374','2013-06-07','08:05:00',3.76),('12374','2013-06-07','08:10:00',3.95),('12374','2013-06-07','08:15:00',4.1),('12374','2013-06-07','08:20:00',4.2),('12374','2013-06-07','08:25:00',4.36),('12374','2013-06-07','08:30:00',4.53),('12374','2013-06-07','08:35:00',4.68),('12374','2013-06-07','08:40:00',4.82),('12374','2013-06-07','08:45:00',4.97),('12374','2013-06-07','08:50:00',5.12),('12374','2013-06-07','08:55:00',5.26),('12374','2013-06-07','09:00:00',5.41),('12374','2013-06-07','09:05:00',5.53),('12374','2013-06-07','09:10:00',5.68),('12374','2013-06-07','09:15:00',5.82),('12374','2013-06-07','09:20:00',5.95),('12374','2013-06-07','09:25:00',6.04),('12374','2013-06-07','09:30:00',6.24),('12374','2013-06-07','09:35:00',6.37),('12374','2013-06-07','09:40:00',6.49),('12374','2013-06-07','09:45:00',6.62),('12374','2013-06-07','09:50:00',6.74),('12374','2013-06-07','09:55:00',6.85),('12374','2013-06-07','10:00:00',6.98),('12374','2013-06-07','10:05:00',7.1),('12374','2013-06-07','10:10:00',7.21),('12374','2013-06-07','10:15:00',7.32),('12374','2013-06-07','10:20:00',7.41),('12374','2013-06-07','10:25:00',7.52),('12374','2013-06-07','10:30:00',7.56),('12374','2013-06-07','10:35:00',7.69),('12374','2013-06-07','10:40:00',7.78),('12374','2013-06-07','10:45:00',7.84),('12374','2013-06-07','10:50:00',7.94),('12374','2013-06-07','10:55:00',8.02),('12374','2013-06-07','11:00:00',8.1),('12374','2013-06-07','11:05:00',8.17),('12374','2013-06-07','11:10:00',8.23),('12374','2013-06-07','11:15:00',8.31),('12374','2013-06-07','11:20:00',8.3),('12374','2013-06-07','11:25:00',8.42),('12374','2013-06-07','11:30:00',8.45),('12374','2013-06-07','11:35:00',8.48),('12374','2013-06-07','11:40:00',8.53),('12374','2013-06-07','11:45:00',8.57),('12374','2013-06-07','11:50:00',8.57),('12374','2013-06-07','11:55:00',8.69),('12374','2013-06-07','12:00:00',8.82),('12374','2013-06-07','12:05:00',8.93),('12374','2013-06-07','12:10:00',8.97),('12374','2013-06-07','12:15:00',8.99),('12374','2013-06-07','12:20:00',8.94),('12374','2013-06-07','12:25:00',8.88),('12374','2013-06-07','12:30:00',8.98),('12374','2013-06-07','12:35:00',9.04),('12374','2013-06-07','12:40:00',9.07),('12374','2013-06-07','12:45:00',9.1),('12374','2013-06-07','12:50:00',9.1),('12374','2013-06-07','12:55:00',9.1),('12374','2013-06-07','13:00:00',9.03),('12374','2013-06-07','13:05:00',9.06),('12374','2013-06-07','13:10:00',9.07),('12374','2013-06-07','13:15:00',9.15),('12374','2013-06-07','13:20:00',9.08),('12374','2013-06-07','13:25:00',9.07),('12374','2013-06-07','13:30:00',9.13),('12374','2013-06-07','13:35:00',9.07),('12374','2013-06-07','13:40:00',9.12),('12374','2013-06-07','13:45:00',9.09),('12374','2013-06-07','13:50:00',9.02),('12374','2013-06-07','13:55:00',8.99),('12374','2013-06-07','14:00:00',8.93),('12374','2013-06-07','14:05:00',8.87),('12374','2013-06-07','14:10:00',8.9),('12374','2013-06-07','14:15:00',8.87),('12374','2013-06-07','14:20:00',8.82),('12374','2013-06-07','14:25:00',8.84),('12374','2013-06-07','14:30:00',8.77),('12374','2013-06-07','14:35:00',8.7),('12374','2013-06-07','14:40:00',8.63),('12374','2013-06-07','14:45:00',8.55),('12374','2013-06-07','14:50:00',8.45),('12374','2013-06-07','14:55:00',8.38),('12374','2013-06-07','15:00:00',8.3),('12374','2013-06-07','15:05:00',8.19),('12374','2013-06-07','15:10:00',8.12),('12374','2013-06-07','15:15:00',8.03),('12374','2013-06-07','15:20:00',7.95),('12374','2013-06-07','15:25:00',7.85),('12374','2013-06-07','15:30:00',7.74),('12374','2013-06-07','15:35:00',7.64),('12374','2013-06-07','15:40:00',7.54),('12374','2013-06-07','15:45:00',7.43),('12374','2013-06-07','15:50:00',7.33),('12374','2013-06-07','15:55:00',7.22),('12374','2013-06-07','16:00:00',7.07),('12374','2013-06-07','16:05:00',6.95),('12374','2013-06-07','16:10:00',6.83),('12374','2013-06-07','16:15:00',6.76),('12374','2013-06-07','16:20:00',6.63),('12374','2013-06-07','16:25:00',6.48),('12374','2013-06-07','16:30:00',6.36),('12374','2013-06-07','16:35:00',6.25),('12374','2013-06-07','16:40:00',6.11),('12374','2013-06-07','16:45:00',5.96),('12374','2013-06-07','16:50:00',5.84),('12374','2013-06-07','16:55:00',5.7),('12374','2013-06-07','17:00:00',5.6),('12374','2013-06-07','17:05:00',5.59),('12374','2013-06-07','17:10:00',5.6),('12374','2013-06-07','17:15:00',5.22),('12374','2013-06-07','17:20:00',5.49),('12374','2013-06-07','17:25:00',5.39),('12374','2013-06-07','17:30:00',4.82),('12374','2013-06-07','17:35:00',4.26),('12374','2013-06-07','17:40:00',2.99),('12374','2013-06-07','17:45:00',4.57),('12374','2013-06-06','06:55:00',1.52),('12374','2013-06-06','07:00:00',1.53),('12374','2013-06-06','07:05:00',1.53),('12374','2013-06-06','07:10:00',1.6),('12374','2013-06-06','07:15:00',1.36),('12374','2013-06-06','07:20:00',1.7),('12374','2013-06-06','07:25:00',2.31),('12374','2013-06-06','07:30:00',2.4),('12374','2013-06-06','07:35:00',2.72),('12374','2013-06-06','07:40:00',2.32),('12374','2013-06-06','07:45:00',3.17),('12374','2013-06-06','07:50:00',3.28),('12374','2013-06-06','07:55:00',3.52),('12374','2013-06-06','08:00:00',3.64),('12374','2013-06-06','08:05:00',3.4),('12374','2013-06-06','08:10:00',3.9),('12374','2013-06-06','08:15:00',4.13),('12374','2013-06-06','08:20:00',4.28),('12374','2013-06-06','08:25:00',4.41),('12374','2013-06-06','08:30:00',4.56),('12374','2013-06-06','08:35:00',4.72),('12374','2013-06-06','08:40:00',4.87),('12374','2013-06-06','08:45:00',4.91),('12374','2013-06-06','08:50:00',5.13),('12374','2013-06-06','08:55:00',5.27),('12374','2013-06-06','09:00:00',5.42),('12374','2013-06-06','09:05:00',5.56),('12374','2013-06-06','09:10:00',5.65),('12374','2013-06-06','09:15:00',5.78),('12374','2013-06-06','09:20:00',5.92),('12374','2013-06-06','09:25:00',6.03),('12374','2013-06-06','09:30:00',6.13),('12374','2013-06-06','09:35:00',6.22),('12374','2013-06-06','09:40:00',6.36),('12374','2013-06-06','09:45:00',6.53),('12374','2013-06-06','09:50:00',6.66),('12374','2013-06-06','09:55:00',6.79),('12374','2013-06-06','10:00:00',6.9),('12374','2013-06-06','10:05:00',7),('12374','2013-06-06','10:10:00',7.14),('12374','2013-06-06','10:15:00',7.32),('12374','2013-06-06','10:20:00',7.65),('12374','2013-06-06','10:25:00',5.21),('12374','2013-06-06','10:30:00',4.88),('12374','2013-06-06','10:35:00',7.94),('12374','2013-06-06','10:40:00',7.67),('12374','2013-06-06','10:45:00',7.12),('12374','2013-06-06','10:50:00',8.09),('12374','2013-06-06','10:55:00',7.83),('12374','2013-06-06','11:00:00',7.26),('12374','2013-06-06','11:05:00',8.18),('12374','2013-06-06','11:10:00',8.33),('12374','2013-06-06','11:15:00',8.43),('12374','2013-06-06','11:20:00',8.28),('12374','2013-06-06','11:25:00',8.46),('12374','2013-06-06','11:30:00',8.59),('12374','2013-06-06','11:35:00',8.61),('12374','2013-06-06','11:40:00',8.66),('12374','2013-06-06','11:45:00',8.7),('12374','2013-06-06','11:50:00',8.75),('12374','2013-06-06','11:55:00',8.86),('12374','2013-06-06','12:00:00',8.92),('12374','2013-06-06','12:05:00',8.96),('12374','2013-06-06','12:10:00',8.99),('12374','2013-06-06','12:15:00',9),('12374','2013-06-06','12:20:00',9.01),('12374','2013-06-06','12:25:00',9.04),('12374','2013-06-06','12:30:00',9.14),('12374','2013-06-06','12:35:00',9.1),('12374','2013-06-06','12:40:00',9.11),('12374','2013-06-06','12:45:00',9.12),('12374','2013-06-06','12:50:00',9.15),('12374','2013-06-06','12:55:00',9.17),('12374','2013-06-06','13:00:00',9.19),('12374','2013-06-06','13:05:00',9.16),('12374','2013-06-06','13:10:00',9.2),('12374','2013-06-06','13:15:00',9.18),('12374','2013-06-06','13:20:00',9.18),('12374','2013-06-06','13:25:00',9.16),('12374','2013-06-06','13:30:00',9.04),('12374','2013-06-06','13:35:00',9.24),('12374','2013-06-06','13:40:00',9.24),('12374','2013-06-06','13:45:00',9.08),('12374','2013-06-06','13:50:00',8.95),('12374','2013-06-06','13:55:00',8.98),('12374','2013-06-06','14:00:00',8.98),('12374','2013-06-06','14:05:00',8.98),('12374','2013-06-06','14:10:00',8.82),('12374','2013-06-06','14:15:00',8.8),('12374','2013-06-06','14:20:00',8.79),('12374','2013-06-06','14:25:00',8.75),('12374','2013-06-06','14:30:00',8.82),('12374','2013-06-06','14:35:00',8.72),('12374','2013-06-06','14:40:00',8.6),('12374','2013-06-06','14:45:00',8.61),('12374','2013-06-06','14:50:00',8.43),('12374','2013-06-06','14:55:00',8.41),('12374','2013-06-06','15:00:00',8.3),('12374','2013-06-06','15:05:00',8.22),('12374','2013-06-06','15:10:00',8.16),('12374','2013-06-06','15:15:00',8.06),('12374','2013-06-06','15:20:00',7.94),('12374','2013-06-06','15:25:00',7.86),('12374','2013-06-06','15:30:00',7.7),('12374','2013-06-06','15:35:00',7.58),('12374','2013-06-06','15:40:00',7.47),('12374','2013-06-06','15:45:00',7.43),('12374','2013-06-06','15:50:00',7.32),('12374','2013-06-06','15:55:00',7.19),('12374','2013-06-06','16:00:00',7.09),('12374','2013-06-06','16:05:00',6.98),('12374','2013-06-06','16:10:00',6.86),('12374','2013-06-06','16:15:00',6.72),('12374','2013-06-06','16:20:00',6.59),('12374','2013-06-06','16:25:00',6.46),('12374','2013-06-06','16:30:00',6.31),('12374','2013-06-06','16:35:00',6.16),('12374','2013-06-06','16:40:00',6.04),('12374','2013-06-06','16:45:00',5.9),('12374','2013-06-06','16:50:00',5.78),('12374','2013-06-06','16:55:00',5.64),('12374','2013-06-06','17:00:00',5.5),('12374','2013-06-06','17:05:00',5.32),('12374','2013-06-06','17:10:00',5.16),('12374','2013-06-06','17:15:00',4.97),('12374','2013-06-06','17:20:00',4.73),('12374','2013-06-06','17:25:00',4.59),('12374','2013-06-06','17:30:00',4.39),('12374','2013-06-06','17:35:00',4.1),('12374','2013-06-06','17:40:00',4.01),('12374','2013-06-06','17:45:00',3.79),('12374','2013-06-06','17:50:00',3.59),('12374','2013-06-06','17:55:00',3.41),('12374','2013-06-06','18:00:00',3.21),('12374','2013-06-06','18:05:00',3.08),('12374','2013-06-06','18:10:00',2.86),('12374','2013-06-06','18:15:00',2.4),('12374','2013-06-06','18:20:00',2.28),('12374','2013-06-06','18:25:00',2.26),('12374','2013-06-06','18:30:00',2.04),('12374','2013-06-06','18:35:00',1.91),('12374','2013-06-06','18:40:00',1.84),('12374','2013-06-06','18:45:00',1.71),('12374','2013-06-06','18:50:00',1.63),('12374','2013-06-06','18:55:00',1.56),('12374','2013-06-06','19:00:00',1.51),('12374','2013-06-06','19:05:00',1.42),('12374','2013-06-06','19:10:00',1.34),('12374','2013-06-06','19:15:00',1.25),('12374','2013-06-06','19:20:00',1.17),('12374','2013-06-06','19:25:00',1.08),('12374','2013-06-05','06:55:00',1.08),('12374','2013-06-05','07:00:00',1.19),('12374','2013-06-05','07:05:00',2.04),('12374','2013-06-05','07:10:00',2.04),('12374','2013-06-05','07:15:00',2.15),('12374','2013-06-05','07:20:00',2.05),('12374','2013-06-05','07:25:00',1.75),('12374','2013-06-05','07:30:00',2.51),('12374','2013-06-05','07:35:00',2.71),('12374','2013-06-05','07:40:00',2.98),('12374','2013-06-05','07:45:00',3.15),('12374','2013-06-05','07:50:00',3.37),('12374','2013-06-05','07:55:00',3.68),('12374','2013-06-05','08:00:00',3.73),('12374','2013-06-05','08:05:00',3.77),('12374','2013-06-05','08:10:00',3.23),('12374','2013-06-05','08:15:00',4.11),('12374','2013-06-05','08:20:00',4.18),('12374','2013-06-05','08:25:00',4.31),('12374','2013-06-05','08:30:00',4.5),('12374','2013-06-05','08:35:00',4.65),('12374','2013-06-05','08:40:00',4.83),('12374','2013-06-05','08:45:00',4.97),('12374','2013-06-05','08:50:00',5.11),('12374','2013-06-05','08:55:00',5.31),('12374','2013-06-05','09:00:00',5.41),('12374','2013-06-05','09:05:00',5.51),('12374','2013-06-05','09:10:00',5.69),('12374','2013-06-05','09:15:00',6.05),('12374','2013-06-05','09:20:00',5.4),('12374','2013-06-05','09:25:00',6.02),('12374','2013-06-05','09:30:00',6.58),('12374','2013-06-05','09:35:00',2.96),('12374','2013-06-05','09:40:00',4.27),('12374','2013-06-05','09:45:00',3.87),('12374','2013-06-05','09:50:00',5.86),('12374','2013-06-05','09:55:00',5.68),('12374','2013-06-05','10:00:00',7.9),('12374','2013-06-05','10:05:00',5),('12374','2013-06-05','10:10:00',4.41),('12374','2013-06-05','10:15:00',4.15),('12374','2013-06-05','10:20:00',7.38),('12374','2013-06-05','10:25:00',6.88),('12374','2013-06-05','10:30:00',6.99),('12374','2013-06-05','10:35:00',2.64),('12374','2013-06-05','10:40:00',2),('12374','2013-06-05','10:45:00',2.08),('12374','2013-06-05','10:50:00',2.37),('12374','2013-06-05','10:55:00',3.68),('12374','2013-06-05','11:00:00',4.44),('12374','2013-06-05','11:05:00',8.46),('12374','2013-06-05','11:10:00',8.4),('12374','2013-06-05','11:15:00',8.47),('12374','2013-06-05','11:20:00',8.41),('12374','2013-06-05','11:25:00',8.62),('12374','2013-06-05','11:30:00',8.63),('12374','2013-06-05','11:35:00',8.77),('12374','2013-06-05','11:40:00',8.82),('12374','2013-06-05','11:45:00',8.87),('12374','2013-06-05','11:50:00',8.85),('12374','2013-06-05','11:55:00',8.85),('12374','2013-06-05','12:00:00',8.89),('12374','2013-06-05','12:05:00',9.02),('12374','2013-06-05','12:10:00',8.99),('12374','2013-06-05','12:15:00',9.05),('12374','2013-06-05','12:20:00',9.01),('12374','2013-06-05','12:25:00',9.13),('12374','2013-06-05','12:30:00',9.13),('12374','2013-06-05','12:35:00',9.15),('12374','2013-06-05','12:40:00',9.04),('12374','2013-06-05','12:45:00',9.05),('12374','2013-06-05','12:50:00',9.13),('12374','2013-06-05','12:55:00',9.19),('12374','2013-06-05','13:00:00',9.18),('12374','2013-06-05','13:05:00',9.21),('12374','2013-06-05','13:10:00',8.98),('12374','2013-06-05','13:15:00',7.89),('12374','2013-06-05','13:20:00',8.99),('12374','2013-06-05','13:25:00',9.14),('12374','2013-06-05','13:30:00',9.3),('12374','2013-06-05','13:35:00',9.24),('12374','2013-06-05','13:40:00',9.15),('12374','2013-06-05','13:45:00',9.27),('12374','2013-06-05','13:50:00',9.02),('12374','2013-06-05','13:55:00',9.12),('12374','2013-06-05','14:00:00',9.17),('12374','2013-06-05','14:05:00',9.11),('12374','2013-06-05','14:10:00',9.01),('12374','2013-06-05','14:15:00',8.54),('12374','2013-06-05','14:20:00',8.55),('12374','2013-06-05','14:25:00',9.01),('12374','2013-06-05','14:30:00',8.88),('12374','2013-06-05','14:35:00',8.89),('12374','2013-06-05','14:40:00',8.52),('12374','2013-06-05','14:45:00',8.9),('12374','2013-06-05','14:50:00',8.75),('12374','2013-06-05','14:55:00',5.58),('12374','2013-06-05','15:00:00',8.33),('12374','2013-06-05','15:05:00',7.81),('12374','2013-06-05','15:10:00',8.4),('12374','2013-06-05','15:15:00',8.12),('12374','2013-06-05','15:20:00',8.08),('12374','2013-06-05','15:25:00',7.88),('12374','2013-06-05','15:30:00',8),('12374','2013-06-05','15:35:00',6.48),('12374','2013-06-05','15:40:00',7.19),('12374','2013-06-05','15:45:00',6.31),('12374','2013-06-05','15:50:00',7.05),('12374','2013-06-05','15:55:00',7.79),('12374','2013-06-05','16:00:00',6.58),('12374','2013-06-05','16:05:00',7.33),('12374','2013-06-05','16:10:00',7.16),('12374','2013-06-05','16:15:00',6.86),('12374','2013-06-05','16:20:00',6.84),('12374','2013-06-05','16:25:00',6.77),('12374','2013-06-05','16:30:00',5.34),('12374','2013-06-05','16:35:00',6.09),('12374','2013-06-05','16:40:00',6.31),('12374','2013-06-05','16:45:00',6.15),('12374','2013-06-05','16:50:00',4.33),('12374','2013-06-05','16:55:00',5.46),('12374','2013-06-05','17:00:00',3.27),('12374','2013-06-05','17:05:00',4.28),('12374','2013-06-05','17:10:00',2.97),('12374','2013-06-05','17:15:00',2.53),('12374','2013-06-05','17:20:00',3.98),('12374','2013-06-05','17:25:00',4.24),('12374','2013-06-05','17:30:00',3.94),('12374','2013-06-05','17:35:00',3.87),('12374','2013-06-05','17:40:00',4.21),('12374','2013-06-05','17:45:00',4),('12374','2013-06-05','17:50:00',3.79),('12374','2013-06-05','17:55:00',3.37),('12374','2013-06-05','18:00:00',3.26),('12374','2013-06-05','18:05:00',3.1),('12374','2013-06-05','18:10:00',3),('12374','2013-06-05','18:15:00',2.87),('12374','2013-06-05','18:20:00',2.65),('12374','2013-06-05','18:25:00',1.85),('12374','2013-06-05','18:30:00',1.95),('12374','2013-06-05','18:35:00',2.23),('12374','2013-06-05','18:40:00',1.99),('12374','2013-06-05','18:45:00',1.8),('12374','2013-06-05','18:50:00',1.71),('12374','2013-06-05','18:55:00',1.64),('12374','2013-06-05','19:00:00',1.55),('12374','2013-06-05','19:05:00',1.48),('12374','2013-06-05','19:10:00',1.4),('12374','2013-06-05','19:15:00',1.34),('12374','2013-06-05','19:20:00',1.27),('12374','2013-06-05','19:25:00',1.17),('12374','2013-06-05','19:30:00',1.07),('12374','2013-06-04','06:50:00',1.08),('12374','2013-06-04','06:55:00',1.21),('12374','2013-06-04','07:00:00',1.48),('12374','2013-06-04','07:05:00',1.61),('12374','2013-06-04','07:10:00',1.79),('12374','2013-06-04','07:15:00',2.55),('12374','2013-06-04','07:20:00',3.22),('12374','2013-06-04','07:25:00',3),('12374','2013-06-04','07:30:00',2.35),('12374','2013-06-04','07:35:00',2.8),('12374','2013-06-04','07:40:00',2.43),('12374','2013-06-04','07:45:00',2.06),('12374','2013-06-04','07:50:00',2.88),('12374','2013-06-04','07:55:00',3.4),('12374','2013-06-04','08:00:00',3.05),('12374','2013-06-04','08:05:00',3.57),('12374','2013-06-04','08:10:00',2.8),('12374','2013-06-04','08:15:00',2.72),('12374','2013-06-04','08:20:00',2.37),('12374','2013-06-04','08:25:00',1.98),('12374','2013-06-04','08:30:00',1.45),('12374','2013-06-04','08:35:00',1.38),('12374','2013-06-04','08:40:00',1.7),('12374','2013-06-04','08:45:00',2.17),('12374','2013-06-04','08:50:00',2.45),('12374','2013-06-04','08:55:00',2.26),('12374','2013-06-04','09:00:00',2.63),('12374','2013-06-04','09:05:00',3.42),('12374','2013-06-04','09:10:00',3.6),('12374','2013-06-04','09:15:00',3.3),('12374','2013-06-04','09:20:00',3.72),('12374','2013-06-04','09:25:00',4.05),('12374','2013-06-04','09:30:00',3.58),('12374','2013-06-04','09:35:00',4.13),('12374','2013-06-04','09:40:00',4.44),('12374','2013-06-04','09:45:00',4.34),('12374','2013-06-04','09:50:00',3.08),('12374','2013-06-04','09:55:00',3.03),('12374','2013-06-04','10:00:00',3.11),('12374','2013-06-04','10:05:00',3.74),('12374','2013-06-04','10:10:00',4.18),('12374','2013-06-04','10:15:00',3.36),('12374','2013-06-04','10:20:00',3.61),('12374','2013-06-04','10:25:00',4.01),('12374','2013-06-04','10:30:00',4.72),('12374','2013-06-04','10:35:00',6.32),('12374','2013-06-04','10:40:00',4.9),('12374','2013-06-04','10:45:00',6.06),('12374','2013-06-04','10:50:00',5),('12374','2013-06-04','10:55:00',3.35),('12374','2013-06-04','11:00:00',3.83),('12374','2013-06-04','11:05:00',3.81),('12374','2013-06-04','11:10:00',3.53),('12374','2013-06-04','11:15:00',3.06),('12374','2013-06-04','11:20:00',3.83),('12374','2013-06-04','11:25:00',5.03),('12374','2013-06-04','11:30:00',6.48),('12374','2013-06-04','11:35:00',5.77),('12374','2013-06-04','11:40:00',4.57),('12374','2013-06-04','11:45:00',5.55),('12374','2013-06-04','11:50:00',6.6),('12374','2013-06-04','11:55:00',4.57),('12374','2013-06-04','12:00:00',5.16),('12374','2013-06-04','12:05:00',8.28),('12374','2013-06-04','12:10:00',5.08),('12374','2013-06-04','12:15:00',4.58),('12374','2013-06-04','12:20:00',4.43),('12374','2013-06-04','12:25:00',4.02),('12374','2013-06-04','12:30:00',3.06),('12374','2013-06-04','12:35:00',3.09),('12374','2013-06-04','12:40:00',3.73),('12374','2013-06-04','12:45:00',5.08),('12374','2013-06-04','12:50:00',6.38),('12374','2013-06-04','12:55:00',8.22),('12374','2013-06-04','13:00:00',8.66),('12374','2013-06-04','13:05:00',9.16),('12374','2013-06-04','13:10:00',9.17),('12374','2013-06-04','13:15:00',8.36),('12374','2013-06-04','13:20:00',8.52),('12374','2013-06-04','13:25:00',8.14),('12374','2013-06-04','13:30:00',8.73),('12374','2013-06-04','13:35:00',8.77),('12374','2013-06-04','13:40:00',8.91),('12374','2013-06-04','13:45:00',9.51),('12374','2013-06-04','13:50:00',9.37),('12374','2013-06-04','13:55:00',9.3),('12374','2013-06-04','14:00:00',8.82),('12374','2013-06-04','14:05:00',7.27),('12374','2013-06-04','14:10:00',7.72),('12374','2013-06-04','14:15:00',8.42),('12374','2013-06-04','14:20:00',8.53),('12374','2013-06-04','14:25:00',9.07),('12374','2013-06-04','14:30:00',6.65),('12374','2013-06-04','14:35:00',5.44),('12374','2013-06-04','14:40:00',8),('12374','2013-06-04','14:45:00',8.93),('12374','2013-06-04','14:50:00',9.2),('12374','2013-06-04','14:55:00',9.26),('12374','2013-06-04','15:00:00',9.11),('12374','2013-06-04','15:05:00',8.76),('12374','2013-06-04','15:10:00',7.4),('12374','2013-06-04','15:15:00',7.4),('12374','2013-06-04','15:20:00',6.88),('12374','2013-06-04','15:25:00',6.51),('12374','2013-06-04','15:30:00',5.69),('12374','2013-06-04','15:35:00',7.75),('12374','2013-06-04','15:40:00',7.63),('12374','2013-06-04','15:45:00',5.02),('12374','2013-06-04','15:50:00',5.88),('12374','2013-06-04','15:55:00',7.2),('12374','2013-06-04','16:00:00',7.14),('12374','2013-06-04','16:05:00',7.39),('12374','2013-06-04','16:10:00',5.39),('12374','2013-06-04','16:15:00',3.82),('12374','2013-06-04','16:20:00',3.13),('12374','2013-06-04','16:25:00',3.06),('12374','2013-06-04','16:30:00',2.86),('12374','2013-06-04','16:35:00',2.66),('12374','2013-06-04','16:40:00',2.66),('12374','2013-06-04','16:45:00',2.5),('12374','2013-06-04','16:50:00',2.28),('12374','2013-06-04','16:55:00',2.09),('12374','2013-06-04','17:00:00',1.94),('12374','2013-06-04','17:05:00',1.87),('12374','2013-06-04','17:10:00',1.84),('12374','2013-06-04','17:15:00',1.91),('12374','2013-06-04','17:20:00',2.11),('12374','2013-06-04','17:25:00',2.3),('12374','2013-06-04','17:30:00',2.47),('12374','2013-06-04','17:35:00',2.81),('12374','2013-06-04','17:40:00',3.14),('12374','2013-06-04','17:45:00',3.43),('12374','2013-06-04','17:50:00',3.26),('12374','2013-06-04','17:55:00',2.51),('12374','2013-06-04','18:00:00',1.79),('12374','2013-06-04','18:05:00',1.75),('12374','2013-06-04','18:10:00',1.91),('12374','2013-06-04','18:15:00',1.86),('12374','2013-06-04','18:20:00',1.77),('12374','2013-06-04','18:25:00',1.5),('12374','2013-06-04','18:30:00',1.23),('12374','2013-06-04','18:35:00',1.09),('12374','2013-06-03','06:35:00',1.03),('12374','2013-06-03','06:40:00',1.33),('12374','2013-06-03','06:45:00',1.62),('12374','2013-06-03','06:50:00',1.73),('12374','2013-06-03','06:55:00',1.89),('12374','2013-06-03','07:00:00',2.05),('12374','2013-06-03','07:05:00',2.36),('12374','2013-06-03','07:10:00',2.45),('12374','2013-06-03','07:15:00',2.47),('12374','2013-06-03','07:20:00',1.61),('12374','2013-06-03','07:25:00',1.33),('12374','2013-06-03','07:30:00',1.45),('12374','2013-06-03','07:35:00',1.18),('12374','2013-06-03','07:40:00',1.22),('12374','2013-06-03','07:45:00',1.34),('12374','2013-06-03','07:50:00',1.76),('12374','2013-06-03','07:55:00',1.92),('12374','2013-06-03','08:00:00',1.99),('12374','2013-06-03','08:05:00',2.22),('12374','2013-06-03','08:10:00',2.07),('12374','2013-06-03','08:15:00',1.95),('12374','2013-06-03','08:20:00',1.91),('12374','2013-06-03','08:25:00',1.83),('12374','2013-06-03','08:30:00',3.25),('12374','2013-06-03','08:35:00',4.36),('12374','2013-06-03','08:40:00',3.05),('12374','2013-06-03','08:45:00',4.99),('12374','2013-06-03','08:50:00',3.74),('12374','2013-06-03','08:55:00',2.33),('12374','2013-06-03','09:00:00',3.69),('12374','2013-06-03','09:05:00',3.62),('12374','2013-06-03','09:10:00',2.93),('12374','2013-06-03','09:15:00',2.69),('12374','2013-06-03','09:20:00',2.58),('12374','2013-06-03','09:25:00',2.96),('12374','2013-06-03','09:30:00',3.44),('12374','2013-06-03','09:35:00',3.09),('12374','2013-06-03','09:40:00',3.07),('12374','2013-06-03','09:45:00',3.19),('12374','2013-06-03','09:50:00',3.88),('12374','2013-06-03','09:55:00',5.47),('12374','2013-06-03','10:00:00',4.7),('12374','2013-06-03','10:05:00',6.37),('12374','2013-06-03','10:10:00',4.37),('12374','2013-06-03','10:15:00',5.86),('12374','2013-06-03','10:20:00',4.35),('12374','2013-06-03','10:25:00',4.05),('12374','2013-06-03','10:30:00',6.57),('12374','2013-06-03','10:35:00',6.34),('12374','2013-06-03','10:40:00',6.97),('12374','2013-06-03','10:45:00',5.83),('12374','2013-06-03','10:50:00',7.7),('12374','2013-06-03','10:55:00',4.45),('12374','2013-06-03','11:00:00',4.36),('12374','2013-06-03','11:05:00',3.38),('12374','2013-06-03','11:10:00',3.33),('12374','2013-06-03','11:15:00',4.03),('12374','2013-06-03','11:20:00',9.74),('12374','2013-06-03','11:25:00',8.2),('12374','2013-06-03','11:30:00',4.62),('12374','2013-06-03','11:35:00',4.42),('12374','2013-06-03','11:40:00',3.01),('12374','2013-06-03','11:45:00',4.92),('12374','2013-06-03','11:50:00',4.51),('12374','2013-06-03','11:55:00',6.07),('12374','2013-06-03','12:00:00',4.94),('12374','2013-06-03','12:05:00',8.62),('12374','2013-06-03','12:10:00',9.49),('12374','2013-06-03','12:15:00',9.33),('12374','2013-06-03','12:20:00',8.93),('12374','2013-06-03','12:25:00',8.79),('12374','2013-06-03','12:30:00',5.07),('12374','2013-06-03','12:35:00',6.49),('12374','2013-06-03','12:40:00',8.98),('12374','2013-06-03','12:45:00',8.44),('12374','2013-06-03','12:50:00',9.26),('12374','2013-06-03','12:55:00',9.63),('12374','2013-06-03','13:00:00',6.64),('12374','2013-06-03','13:05:00',7.5),('12374','2013-06-03','13:10:00',4.85),('12374','2013-06-03','13:15:00',4.36),('12374','2013-06-03','13:20:00',5.14),('12374','2013-06-03','13:25:00',9.42),('12374','2013-06-03','13:30:00',9.3),('12374','2013-06-03','13:35:00',9.33),('12374','2013-06-03','13:40:00',9.22),('12374','2013-06-03','13:45:00',9.26),('12374','2013-06-03','13:50:00',9.35),('12374','2013-06-03','13:55:00',9.51),('12374','2013-06-03','14:00:00',8.33),('12374','2013-06-03','14:05:00',4.47),('12374','2013-06-03','14:10:00',3.31),('12374','2013-06-03','14:15:00',4.2),('12374','2013-06-03','14:20:00',9.03),('12374','2013-06-03','14:25:00',8.45),('12374','2013-06-03','14:30:00',8.73),('12374','2013-06-03','14:35:00',8.76),('12374','2013-06-03','14:40:00',8.9),('12374','2013-06-03','14:45:00',7.99),('12374','2013-06-03','14:50:00',6.93),('12374','2013-06-03','14:55:00',8.36),('12374','2013-06-03','15:00:00',8.17),('12374','2013-06-03','15:05:00',7.59),('12374','2013-06-03','15:10:00',8.02),('12374','2013-06-03','15:15:00',7.21),('12374','2013-06-03','15:20:00',7.18),('12374','2013-06-03','15:25:00',7.9),('12374','2013-06-03','15:30:00',6.44),('12374','2013-06-03','15:35:00',7.69),('12374','2013-06-03','15:40:00',7.62),('12374','2013-06-03','15:45:00',7.52),('12374','2013-06-03','15:50:00',7.38),('12374','2013-06-03','15:55:00',7.21),('12374','2013-06-03','16:00:00',7.11),('12374','2013-06-03','16:05:00',6.94),('12374','2013-06-03','16:10:00',6.7),('12374','2013-06-03','16:15:00',6.92),('12374','2013-06-03','16:20:00',6.55),('12374','2013-06-03','16:25:00',5.76),('12374','2013-06-03','16:30:00',4.39),('12374','2013-06-03','16:35:00',4.38),('12374','2013-06-03','16:40:00',3.86),('12374','2013-06-03','16:45:00',5.29),('12374','2013-06-03','16:50:00',5.28),('12374','2013-06-03','16:55:00',4.99),('12374','2013-06-03','17:00:00',4.33),('12374','2013-06-03','17:05:00',3.65),('12374','2013-06-03','17:10:00',3.96),('12374','2013-06-03','17:15:00',3.88),('12374','2013-06-03','17:20:00',3.12),('12374','2013-06-03','17:25:00',2.68),('12374','2013-06-03','17:30:00',2.49),('12374','2013-06-03','17:35:00',2.41),('12374','2013-06-03','17:40:00',2.35),('12374','2013-06-03','17:45:00',2.29),('12374','2013-06-03','17:50:00',2.09),('12374','2013-06-03','17:55:00',1.68),('12374','2013-06-03','18:00:00',1.49),('12374','2013-06-03','18:05:00',1.4),('12374','2013-06-03','18:10:00',1.44),('12374','2013-06-03','18:15:00',1.5),('12374','2013-06-03','18:20:00',1.49),('12374','2013-06-03','18:25:00',1.47),('12374','2013-06-03','18:30:00',1.41),('12374','2013-06-03','18:35:00',1.21),('12374','2013-06-02','07:45:00',1.06),('12374','2013-06-02','07:50:00',1.44),('12374','2013-06-02','07:55:00',1.6),('12374','2013-06-02','08:00:00',1.12),('12374','2013-06-02','08:05:00',2.54),('12374','2013-06-02','08:10:00',4.68),('12374','2013-06-02','08:15:00',4.68),('12374','2013-06-02','08:20:00',4.65),('12374','2013-06-02','08:25:00',4.64),('12374','2013-06-02','08:30:00',4.79),('12374','2013-06-02','08:35:00',5),('12374','2013-06-02','08:40:00',5.37),('12374','2013-06-02','08:45:00',5.41),('12374','2013-06-02','08:50:00',5.28),('12374','2013-06-02','08:55:00',5.42),('12374','2013-06-02','09:00:00',5.49),('12374','2013-06-02','09:05:00',5.57),('12374','2013-06-02','09:10:00',5.69),('12374','2013-06-02','09:15:00',5.87),('12374','2013-06-02','09:20:00',6),('12374','2013-06-02','09:25:00',6.14),('12374','2013-06-02','09:30:00',6.25),('12374','2013-06-02','09:35:00',6.38),('12374','2013-06-02','09:40:00',5.94),('12374','2013-06-02','09:45:00',6.7),('12374','2013-06-02','09:50:00',6.6),('12374','2013-06-02','09:55:00',6.92),('12374','2013-06-02','10:00:00',7.07),('12374','2013-06-02','10:05:00',7.14),('12374','2013-06-02','10:10:00',7.31),('12374','2013-06-02','10:15:00',7.51),('12374','2013-06-02','10:20:00',8.1),('12374','2013-06-02','10:25:00',6.11),('12374','2013-06-02','10:30:00',4.28),('12374','2013-06-02','10:35:00',5.51),('12374','2013-06-02','10:40:00',4.77),('12374','2013-06-02','10:45:00',3.65),('12374','2013-06-02','10:50:00',8.79),('12374','2013-06-02','10:55:00',8.79),('12374','2013-06-02','11:00:00',8.57),('12374','2013-06-02','11:05:00',8.39),('12374','2013-06-02','11:10:00',8.49),('12374','2013-06-02','11:15:00',8.55),('12374','2013-06-02','11:20:00',8.61),('12374','2013-06-02','11:25:00',8.68),('12374','2013-06-02','11:30:00',8.79),('12374','2013-06-02','11:35:00',8.82),('12374','2013-06-02','11:40:00',8.91),('12374','2013-06-02','11:45:00',8.99),('12374','2013-06-02','11:50:00',8.98),('12374','2013-06-02','11:55:00',8.98),('12374','2013-06-02','12:00:00',9.03),('12374','2013-06-02','12:05:00',9.04),('12374','2013-06-02','12:10:00',9.06),('12374','2013-06-02','12:15:00',9.12),('12374','2013-06-02','12:20:00',9.11),('12374','2013-06-02','12:25:00',9.14),('12374','2013-06-02','12:30:00',9.27),('12374','2013-06-02','12:35:00',9.21),('12374','2013-06-02','12:40:00',9.22),('12374','2013-06-02','12:45:00',9.29),('12374','2013-06-02','12:50:00',9.29),('12374','2013-06-02','12:55:00',9.26),('12374','2013-06-02','13:00:00',9.29),('12374','2013-06-02','13:05:00',9.27),('12374','2013-06-02','13:10:00',9.23),('12374','2013-06-02','13:15:00',9.26),('12374','2013-06-02','13:20:00',9.25),('12374','2013-06-02','13:25:00',9.21),('12374','2013-06-02','13:30:00',9.12),('12374','2013-06-02','13:35:00',9.14),('12374','2013-06-02','13:40:00',9.18),('12374','2013-06-02','13:45:00',7.32),('12374','2013-06-02','13:50:00',6.83),('12374','2013-06-02','13:55:00',8.81),('12374','2013-06-02','14:00:00',6.92),('12374','2013-06-02','14:05:00',7.53),('12374','2013-06-02','14:10:00',6.1),('12374','2013-06-02','14:15:00',5.9),('12374','2013-06-02','14:20:00',7.67),('12374','2013-06-02','14:25:00',8.01),('12374','2013-06-02','14:30:00',7.16),('12374','2013-06-02','14:35:00',6.26),('12374','2013-06-02','14:40:00',7.62),('12374','2013-06-02','14:45:00',5.83),('12374','2013-06-02','14:50:00',6.08),('12374','2013-06-02','14:55:00',7.85),('12374','2013-06-02','15:00:00',6.1),('12374','2013-06-02','15:05:00',8.01),('12374','2013-06-02','15:10:00',8.16),('12374','2013-06-02','15:15:00',7.92),('12374','2013-06-02','15:20:00',8.23),('12374','2013-06-02','15:25:00',7.57),('12374','2013-06-02','15:30:00',7.45),('12374','2013-06-02','15:35:00',7.83),('12374','2013-06-02','15:40:00',7.59),('12374','2013-06-02','15:45:00',5.68),('12374','2013-06-02','15:50:00',5.25),('12374','2013-06-02','15:55:00',3.58),('12374','2013-06-02','16:00:00',4.65),('12374','2013-06-02','16:05:00',3.88),('12374','2013-06-02','16:10:00',3.61),('12374','2013-06-02','16:15:00',3.03),('12374','2013-06-02','16:20:00',2.68),('12374','2013-06-02','16:25:00',2.81),('12374','2013-06-02','16:30:00',3.02),('12374','2013-06-02','16:35:00',2.98),('12374','2013-06-02','16:40:00',2.77),('12374','2013-06-02','16:45:00',2.42),('12374','2013-06-02','16:50:00',2.41),('12374','2013-06-02','16:55:00',2.23),('12374','2013-06-02','17:00:00',2.05),('12374','2013-06-02','17:05:00',2.26),('12374','2013-06-02','17:10:00',2.24),('12374','2013-06-02','17:15:00',2.6),('12374','2013-06-02','17:20:00',2.32),('12374','2013-06-02','17:25:00',1.95),('12374','2013-06-02','17:30:00',1.96),('12374','2013-06-02','17:35:00',1.94),('12374','2013-06-02','17:40:00',1.87),('12374','2013-06-02','17:45:00',1.86),('12374','2013-06-02','17:50:00',1.77),('12374','2013-06-02','17:55:00',1.78),('12374','2013-06-02','18:00:00',1.75),('12374','2013-06-02','18:05:00',1.76),('12374','2013-06-02','18:10:00',1.79),('12374','2013-06-02','18:15:00',1.64),('12374','2013-06-02','18:20:00',1.89),('12374','2013-06-02','18:25:00',1.7),('12374','2013-06-02','18:30:00',1.43),('12374','2013-06-02','18:35:00',1.36),('12374','2013-06-02','18:40:00',1.28),('12374','2013-06-02','18:45:00',1.33),('12374','2013-06-02','18:50:00',1.32),('12374','2013-06-02','18:55:00',1.12),('12374','2013-06-02','19:05:00',1.16),('12374','2013-06-02','19:10:00',1.49),('12374','2013-06-02','19:25:00',1.24),('12374','2013-06-02','19:30:00',1.2),('12374','2013-06-02','19:35:00',1.12),('12374','2013-06-01','06:35:00',1.43),('12374','2013-06-01','06:40:00',1.47),('12374','2013-06-01','06:45:00',1.24),('12374','2013-06-01','07:15:00',2.31),('12374','2013-06-01','07:20:00',1.12),('12374','2013-06-01','07:35:00',1.07),('12374','2013-06-01','07:40:00',2.65),('12374','2013-06-01','07:45:00',3.85),('12374','2013-06-01','07:50:00',3.17),('12374','2013-06-01','07:55:00',3.06),('12374','2013-06-01','08:00:00',2.93),('12374','2013-06-01','08:05:00',2.34),('12374','2013-06-01','08:10:00',2.5),('12374','2013-06-01','08:15:00',1.95),('12374','2013-06-01','08:20:00',3.56),('12374','2013-06-01','08:25:00',2.8),('12374','2013-06-01','08:30:00',1.6),('12374','2013-06-01','08:35:00',2.18),('12374','2013-06-01','08:40:00',2.66),('12374','2013-06-01','08:45:00',2.85),('12374','2013-06-01','08:50:00',2.37),('12374','2013-06-01','08:55:00',3.04),('12374','2013-06-01','09:00:00',3.32),('12374','2013-06-01','09:05:00',2.93),('12374','2013-06-01','09:10:00',3.25),('12374','2013-06-01','09:15:00',3),('12374','2013-06-01','09:20:00',3.34),('12374','2013-06-01','09:25:00',4.57),('12374','2013-06-01','09:30:00',6.84),('12374','2013-06-01','09:35:00',6.01),('12374','2013-06-01','09:40:00',2.66),('12374','2013-06-01','09:45:00',3.44),('12374','2013-06-01','09:50:00',4.28),('12374','2013-06-01','09:55:00',3.92),('12374','2013-06-01','10:00:00',4.33),('12374','2013-06-01','10:05:00',3.34),('12374','2013-06-01','10:10:00',2.84),('12374','2013-06-01','10:15:00',2.15),('12374','2013-06-01','10:20:00',1.28),('12374','2013-06-01','10:25:00',1.47),('12374','2013-06-01','10:30:00',1.62),('12374','2013-06-01','10:35:00',1.83),('12374','2013-06-01','10:40:00',2.96),('12374','2013-06-01','10:45:00',2.75),('12374','2013-06-01','10:50:00',1.6),('12374','2013-06-01','10:55:00',2.39),('12374','2013-06-01','11:00:00',2.94),('12374','2013-06-01','11:05:00',3.05),('12374','2013-06-01','11:10:00',3.24),('12374','2013-06-01','11:15:00',3.39),('12374','2013-06-01','11:20:00',2.96),('12374','2013-06-01','11:25:00',2.67),('12374','2013-06-01','11:30:00',2.32),('12374','2013-06-01','11:35:00',2.13),('12374','2013-06-01','11:40:00',2.2),('12374','2013-06-01','11:45:00',3.02),('12374','2013-06-01','11:50:00',3.04),('12374','2013-06-01','11:55:00',4.07),('12374','2013-06-01','12:00:00',3.73),('12374','2013-06-01','12:05:00',5.54),('12374','2013-06-01','12:10:00',8.24),('12374','2013-06-01','12:15:00',4.59),('12374','2013-06-01','12:20:00',3.51),('12374','2013-06-01','12:25:00',3.8),('12374','2013-06-01','12:30:00',3.54),('12374','2013-06-01','12:35:00',4.43),('12374','2013-06-01','12:40:00',5.61),('12374','2013-06-01','12:45:00',6.01),('12374','2013-06-01','12:50:00',5.79),('12374','2013-06-01','12:55:00',5.01),('12374','2013-06-01','13:00:00',4.61),('12374','2013-06-01','13:05:00',4.71),('12374','2013-06-01','13:10:00',4.82),('12374','2013-06-01','13:15:00',4.96),('12374','2013-06-01','13:20:00',4.73),('12374','2013-06-01','13:25:00',4.35),('12374','2013-06-01','13:30:00',4.5),('12374','2013-06-01','13:35:00',5.57),('12374','2013-06-01','13:40:00',5.48),('12374','2013-06-01','13:45:00',5.03),('12374','2013-06-01','13:50:00',5.07),('12374','2013-06-01','13:55:00',4.51),('12374','2013-06-01','14:00:00',3.31),('12374','2013-06-01','14:05:00',3.29),('12374','2013-06-01','14:10:00',3.46),('12374','2013-06-01','14:15:00',3.49),('12374','2013-06-01','14:20:00',3),('12374','2013-06-01','14:25:00',2.59),('12374','2013-06-01','14:30:00',3.48),('12374','2013-06-01','14:35:00',2.93),('12374','2013-06-01','14:40:00',3.48),('12374','2013-06-01','14:45:00',3.84),('12374','2013-06-01','14:50:00',3.38),('12374','2013-06-01','14:55:00',2.99),('12374','2013-06-01','15:00:00',3.03),('12374','2013-06-01','15:05:00',2.79),('12374','2013-06-01','15:10:00',2.7),('12374','2013-06-01','15:15:00',2.68),('12374','2013-06-01','15:20:00',2.77),('12374','2013-06-01','15:25:00',3.39),('12374','2013-06-01','15:30:00',3.48),('12374','2013-06-01','15:35:00',3.17),('12374','2013-06-01','15:40:00',2.78),('12374','2013-06-01','15:45:00',3.26),('12374','2013-06-01','15:50:00',3.33),('12374','2013-06-01','15:55:00',2.73),('12374','2013-06-01','16:00:00',2.44),('12374','2013-06-01','16:05:00',2.33),('12374','2013-06-01','16:10:00',2.1),('12374','2013-06-01','16:15:00',1.8),('12374','2013-06-01','16:20:00',1.59),('12374','2013-06-01','16:25:00',1.42),('12374','2013-06-01','16:30:00',1.19),('12374','2013-06-01','16:35:00',1.02),('12374','2013-06-01','16:40:00',1.09),('12374','2013-06-01','16:45:00',1.38),('12374','2013-06-01','16:50:00',1.85),('12374','2013-06-01','16:55:00',2.56),('12374','2013-06-01','17:00:00',2.78),('12374','2013-06-01','17:05:00',2.42),('12374','2013-06-01','17:10:00',1.75),('12374','2013-06-01','17:15:00',1.5),('12374','2013-06-01','17:20:00',2.34),('12374','2013-06-01','17:25:00',4.41),('12374','2013-06-01','17:30:00',5.53),('12374','2013-06-01','17:35:00',4.01),('12374','2013-06-01','17:40:00',2.58),('12374','2013-06-01','17:45:00',4.03),('12374','2013-06-01','17:50:00',3.85),('12374','2013-06-01','17:55:00',3.8),('12374','2013-06-01','18:00:00',2.78),('12374','2013-06-01','18:05:00',3.04),('12374','2013-06-01','18:10:00',3.02),('12374','2013-06-01','18:15:00',1.03),('12374','2013-06-01','18:30:00',1.77),('12374','2013-06-01','18:35:00',1.38),('12374','2013-06-01','18:55:00',1.27),('12374','2013-06-01','19:00:00',1.94),('12374','2013-06-01','19:05:00',2.01),('12374','2013-06-01','19:10:00',1.83),('12374','2013-06-01','19:15:00',1.8),('12374','2013-06-01','19:20:00',1.55),('12374','2013-06-01','19:25:00',1.78),('12374','2013-06-01','19:30:00',1.58),('12374','2013-05-31','06:35:00',1.02),('12374','2013-05-31','06:40:00',1.16),('12374','2013-05-31','06:45:00',1.16),('12374','2013-05-31','06:50:00',1.33),('12374','2013-05-31','06:55:00',1.12),('12374','2013-05-31','07:00:00',1.64),('12374','2013-05-31','07:05:00',1.83),('12374','2013-05-31','07:10:00',1.69),('12374','2013-05-31','07:15:00',2.23),('12374','2013-05-31','07:20:00',2.53),('12374','2013-05-31','07:25:00',2.79),('12374','2013-05-31','07:30:00',2.65),('12374','2013-05-31','07:35:00',3.25),('12374','2013-05-31','07:40:00',3.97),('12374','2013-05-31','07:45:00',4.54),('12374','2013-05-31','07:50:00',2.57),('12374','2013-05-31','07:55:00',1.28),('12374','2013-05-31','08:05:00',2.2),('12374','2013-05-31','08:10:00',4.36),('12374','2013-05-31','08:15:00',4.35),('12374','2013-05-31','08:20:00',4.14),('12374','2013-05-31','08:25:00',4.93),('12374','2013-05-31','08:30:00',4.59),('12374','2013-05-31','08:35:00',5.43),('12374','2013-05-31','08:40:00',2.47),('12374','2013-05-31','08:45:00',3.36),('12374','2013-05-31','08:50:00',2.85),('12374','2013-05-31','08:55:00',4.75),('12374','2013-05-31','09:00:00',4.12),('12374','2013-05-31','09:05:00',6.08),('12374','2013-05-31','09:10:00',6.05),('12374','2013-05-31','09:15:00',6.1),('12374','2013-05-31','09:20:00',6.23),('12374','2013-05-31','09:25:00',6.47),('12374','2013-05-31','09:30:00',6.37),('12374','2013-05-31','09:35:00',5.76),('12374','2013-05-31','09:40:00',5.71),('12374','2013-05-31','09:45:00',3.5),('12374','2013-05-31','09:50:00',4.54),('12374','2013-05-31','09:55:00',5.92),('12374','2013-05-31','10:00:00',7.51),('12374','2013-05-31','10:05:00',5.35),('12374','2013-05-31','10:10:00',3.31),('12374','2013-05-31','10:15:00',3.35),('12374','2013-05-31','10:20:00',2.92),('12374','2013-05-31','10:25:00',5.14),('12374','2013-05-31','10:30:00',7.99),('12374','2013-05-31','10:35:00',4.68),('12374','2013-05-31','10:40:00',2.1),('12374','2013-05-31','10:45:00',6.93),('12374','2013-05-31','10:50:00',8.31),('12374','2013-05-31','10:55:00',8.83),('12374','2013-05-31','11:00:00',8.78),('12374','2013-05-31','11:05:00',7.72),('12374','2013-05-31','11:10:00',7.51),('12374','2013-05-31','11:15:00',7.8),('12374','2013-05-31','11:20:00',7.54),('12374','2013-05-31','11:25:00',9.01),('12374','2013-05-31','11:30:00',9.14),('12374','2013-05-31','11:35:00',7.56),('12374','2013-05-31','11:40:00',6.69),('12374','2013-05-31','11:45:00',2.47),('12374','2013-05-31','11:50:00',2.73),('12374','2013-05-31','11:55:00',4.86),('12374','2013-05-31','12:00:00',1.23),('12374','2013-05-31','12:05:00',5),('12374','2013-05-31','12:10:00',6.43),('12374','2013-05-31','12:15:00',8.72),('12374','2013-05-31','12:20:00',6.9),('12374','2013-05-31','12:25:00',4.75),('12374','2013-05-31','12:30:00',5.27),('12374','2013-05-31','12:35:00',4.41),('12374','2013-05-31','12:40:00',3.41),('12374','2013-05-31','12:45:00',2.27),('12374','2013-05-31','12:50:00',2.42),('12374','2013-05-31','12:55:00',2.55),('12374','2013-05-31','13:00:00',2.51),('12374','2013-05-31','13:05:00',3.77),('12374','2013-05-31','13:10:00',6.51),('12374','2013-05-31','13:15:00',7.39),('12374','2013-05-31','13:20:00',7.89),('12374','2013-05-31','13:25:00',6.3),('12374','2013-05-31','13:30:00',3.7),('12374','2013-05-31','13:35:00',3.98),('12374','2013-05-31','13:40:00',4.18),('12374','2013-05-31','13:45:00',3.74),('12374','2013-05-31','13:50:00',5.16),('12374','2013-05-31','13:55:00',6.83),('12374','2013-05-31','14:00:00',6.44),('12374','2013-05-31','14:05:00',5.16),('12374','2013-05-31','14:10:00',4.5),('12374','2013-05-31','14:15:00',4.76),('12374','2013-05-31','14:20:00',6.27),('12374','2013-05-31','14:25:00',5.3),('12374','2013-05-31','14:30:00',2.03),('12374','2013-05-31','14:35:00',1.05),('12374','2013-05-31','14:40:00',1.52),('12374','2013-05-31','14:45:00',1.74),('12374','2013-05-31','14:50:00',3.34),('12374','2013-05-31','14:55:00',3.51),('12374','2013-05-31','15:00:00',1.68),('12374','2013-05-31','15:05:00',1.72),('12374','2013-05-31','15:10:00',2.61),('12374','2013-05-31','15:15:00',2.8),('12374','2013-05-31','15:20:00',3.01),('12374','2013-05-31','15:25:00',2.7),('12374','2013-05-31','15:30:00',2.26),('12374','2013-05-31','15:35:00',2.73),('12374','2013-05-31','15:40:00',4.22),('12374','2013-05-31','15:45:00',2.92),('12374','2013-05-31','15:50:00',2.29),('12374','2013-05-31','15:55:00',3.33),('12374','2013-05-31','16:00:00',4.02),('12374','2013-05-31','16:05:00',4.11),('12374','2013-05-31','16:10:00',3.8),('12374','2013-05-31','16:15:00',3.75),('12374','2013-05-31','16:20:00',3.51),('12374','2013-05-31','16:25:00',3.35),('12374','2013-05-31','16:30:00',3.06),('12374','2013-05-31','16:35:00',2.97),('12374','2013-05-31','16:40:00',2.74),('12374','2013-05-31','16:45:00',2.27),('12374','2013-05-31','16:50:00',1.68),('12374','2013-05-31','16:55:00',1.78),('12374','2013-05-31','17:00:00',1.94),('12374','2013-05-31','17:05:00',1.8),('12374','2013-05-31','17:10:00',1.49),('12374','2013-05-31','17:15:00',1.35),('12374','2013-05-31','17:20:00',1.57),('12374','2013-05-31','17:25:00',1.54),('12374','2013-05-31','17:30:00',1.32),('12374','2013-05-31','17:35:00',1.16),('12374','2013-05-31','17:55:00',1.13),('12374','2013-05-31','18:00:00',1.47),('12374','2013-05-31','18:05:00',1.23),('12374','2013-05-31','18:10:00',1.03),('12374','2013-05-31','18:15:00',1.07),('12374','2013-05-31','18:40:00',1.09),('12374','2013-05-31','18:45:00',1.08),('12374','2013-05-30','07:05:00',2.06),('12374','2013-05-30','07:10:00',2.15),('12374','2013-05-30','07:15:00',1.96),('12374','2013-05-30','07:20:00',3.31),('12374','2013-05-30','07:25:00',2.7),('12374','2013-05-30','07:30:00',1.78),('12374','2013-05-30','07:35:00',1.99),('12374','2013-05-30','07:40:00',3.36),('12374','2013-05-30','07:45:00',3.33),('12374','2013-05-30','07:50:00',3.42),('12374','2013-05-30','07:55:00',2.85),('12374','2013-05-30','08:00:00',2.61),('12374','2013-05-30','08:05:00',4.1),('12374','2013-05-30','08:10:00',4.08),('12374','2013-05-30','08:15:00',4.13),('12374','2013-05-30','08:20:00',4.41),('12374','2013-05-30','08:25:00',4.59),('12374','2013-05-30','08:30:00',4.65),('12374','2013-05-30','08:35:00',4.82),('12374','2013-05-30','08:40:00',4.93),('12374','2013-05-30','08:45:00',5.12),('12374','2013-05-30','08:50:00',5.39),('12374','2013-05-30','08:55:00',5.34),('12374','2013-05-30','09:00:00',5.58),('12374','2013-05-30','09:05:00',5.72),('12374','2013-05-30','09:10:00',5.96),('12374','2013-05-30','09:15:00',6),('12374','2013-05-30','09:20:00',5.99),('12374','2013-05-30','09:25:00',5.88),('12374','2013-05-30','09:30:00',6.98),('12374','2013-05-30','09:35:00',4.36),('12374','2013-05-30','09:40:00',3.62),('12374','2013-05-30','09:45:00',4.34),('12374','2013-05-30','09:50:00',6.64),('12374','2013-05-30','09:55:00',7.04),('12374','2013-05-30','10:00:00',7.92),('12374','2013-05-30','10:05:00',7.81),('12374','2013-05-30','10:10:00',6.81),('12374','2013-05-30','10:15:00',8.45),('12374','2013-05-30','10:20:00',7.43),('12374','2013-05-30','10:25:00',6.71),('12374','2013-05-30','10:30:00',6.01),('12374','2013-05-30','10:35:00',6.22),('12374','2013-05-30','10:40:00',6.9),('12374','2013-05-30','10:45:00',6.42),('12374','2013-05-30','10:50:00',2.67),('12374','2013-05-30','10:55:00',3.17),('12374','2013-05-30','11:00:00',8.48),('12374','2013-05-30','11:05:00',9.11),('12374','2013-05-30','11:10:00',8.99),('12374','2013-05-30','11:15:00',8.93),('12374','2013-05-30','11:20:00',9.15),('12374','2013-05-30','11:25:00',9.37),('12374','2013-05-30','11:30:00',8.87),('12374','2013-05-30','11:35:00',9.29),('12374','2013-05-30','11:40:00',9.08),('12374','2013-05-30','11:45:00',8.91),('12374','2013-05-30','11:50:00',9.61),('12374','2013-05-30','11:55:00',9.32),('12374','2013-05-30','12:00:00',7.33),('12374','2013-05-30','12:05:00',9.45),('12374','2013-05-30','12:10:00',9.41),('12374','2013-05-30','12:15:00',9.45),('12374','2013-05-30','12:20:00',9.45),('12374','2013-05-30','12:25:00',9.44),('12374','2013-05-30','12:30:00',9.45),('12374','2013-05-30','12:35:00',9.51),('12374','2013-05-30','12:40:00',9.51),('12374','2013-05-30','12:45:00',9.51),('12374','2013-05-30','12:50:00',9.48),('12374','2013-05-30','12:55:00',9.47),('12374','2013-05-30','13:00:00',9.55),('12374','2013-05-30','13:05:00',9.69),('12374','2013-05-30','13:10:00',9.6),('12374','2013-05-30','13:15:00',9.54),('12374','2013-05-30','13:20:00',5.7),('12374','2013-05-30','13:25:00',5.68),('12374','2013-05-30','13:30:00',8.26),('12374','2013-05-30','13:35:00',8.57),('12374','2013-05-30','13:40:00',7.35),('12374','2013-05-30','13:45:00',5.48),('12374','2013-05-30','13:50:00',7),('12374','2013-05-30','13:55:00',7.8),('12374','2013-05-30','14:00:00',6.68),('12374','2013-05-30','14:05:00',9.71),('12374','2013-05-30','14:10:00',5.9),('12374','2013-05-30','14:15:00',7.35),('12374','2013-05-30','14:20:00',3.13),('12374','2013-05-30','14:25:00',7.78),('12374','2013-05-30','14:30:00',8.44),('12374','2013-05-30','14:35:00',8.78),('12374','2013-05-30','14:40:00',5.02),('12374','2013-05-30','14:45:00',6.05),('12374','2013-05-30','14:50:00',4.22),('12374','2013-05-30','14:55:00',4.33),('12374','2013-05-30','15:00:00',4.1),('12374','2013-05-30','15:05:00',7.35),('12374','2013-05-30','15:10:00',7.29),('12374','2013-05-30','15:15:00',3.31),('12374','2013-05-30','15:20:00',3.57),('12374','2013-05-30','15:25:00',4),('12374','2013-05-30','15:30:00',4.69),('12374','2013-05-30','15:35:00',3.44),('12374','2013-05-30','15:40:00',2.49),('12374','2013-05-30','15:45:00',3.19),('12374','2013-05-30','15:50:00',3.78),('12374','2013-05-30','15:55:00',3.14),('12374','2013-05-30','16:00:00',3),('12374','2013-05-30','16:05:00',3.97),('12374','2013-05-30','16:10:00',5.43),('12374','2013-05-30','16:15:00',5.26),('12374','2013-05-30','16:20:00',6.24),('12374','2013-05-30','16:25:00',8.04),('12374','2013-05-30','16:30:00',3.73),('12374','2013-05-30','16:35:00',2.96),('12374','2013-05-30','16:40:00',2.33),('12374','2013-05-30','16:45:00',1.78),('12374','2013-05-30','16:50:00',1.57),('12374','2013-05-30','16:55:00',3.99),('12374','2013-05-30','17:00:00',6.92),('12374','2013-05-30','17:05:00',6.23),('12374','2013-05-30','17:10:00',5.21),('12374','2013-05-30','17:15:00',5.44),('12374','2013-05-30','17:20:00',3.93),('12374','2013-05-30','17:25:00',2.49),('12374','2013-05-30','17:30:00',2.96),('12374','2013-05-30','17:35:00',3.18),('12374','2013-05-30','17:40:00',1.56),('12374','2013-05-30','17:45:00',1.51),('12374','2013-05-30','17:50:00',2.94),('12374','2013-05-30','17:55:00',4),('12374','2013-05-30','18:00:00',2.11),('12374','2013-05-30','18:05:00',1.58),('12374','2013-05-30','18:10:00',1.4),('12374','2013-05-30','18:15:00',1.18),('12374','2013-05-30','19:05:00',1.06),('12374','2013-05-29','06:40:00',1.11),('12374','2013-05-29','06:45:00',1.17),('12374','2013-05-29','06:50:00',1.23),('12374','2013-05-29','06:55:00',1.48),('12374','2013-05-29','07:00:00',1.61),('12374','2013-05-29','07:05:00',1.75),('12374','2013-05-29','07:10:00',1.62),('12374','2013-05-29','07:15:00',2.03),('12374','2013-05-29','07:20:00',2.24),('12374','2013-05-29','07:25:00',2.45),('12374','2013-05-29','07:30:00',2.62),('12374','2013-05-29','07:35:00',2.79),('12374','2013-05-29','07:40:00',2.95),('12374','2013-05-29','07:45:00',3.13),('12374','2013-05-29','07:50:00',3.29),('12374','2013-05-29','07:55:00',3.46),('12374','2013-05-29','08:00:00',3.62),('12374','2013-05-29','08:05:00',3.81),('12374','2013-05-29','08:10:00',4),('12374','2013-05-29','08:15:00',4.16),('12374','2013-05-29','08:20:00',4.3),('12374','2013-05-29','08:25:00',4.49),('12374','2013-05-29','08:30:00',4.68),('12374','2013-05-29','08:35:00',4.85),('12374','2013-05-29','08:40:00',5),('12374','2013-05-29','08:45:00',5.17),('12374','2013-05-29','08:50:00',5.12),('12374','2013-05-29','08:55:00',5.28),('12374','2013-05-29','09:00:00',5.65),('12374','2013-05-29','09:05:00',5.77),('12374','2013-05-29','09:10:00',5.89),('12374','2013-05-29','09:15:00',5.77),('12374','2013-05-29','09:20:00',6.02),('12374','2013-05-29','09:25:00',6.14),('12374','2013-05-29','09:30:00',6.23),('12374','2013-05-29','09:35:00',6.34),('12374','2013-05-29','09:40:00',6.57),('12374','2013-05-29','09:45:00',6.78),('12374','2013-05-29','09:50:00',6.96),('12374','2013-05-29','09:55:00',6.73),('12374','2013-05-29','10:00:00',7.1),('12374','2013-05-29','10:05:00',7.21),('12374','2013-05-29','10:10:00',7.32),('12374','2013-05-29','10:15:00',7.39),('12374','2013-05-29','10:20:00',7.51),('12374','2013-05-29','10:25:00',7.64),('12374','2013-05-29','10:30:00',7.74),('12374','2013-05-29','10:35:00',7.86),('12374','2013-05-29','10:40:00',7.97),('12374','2013-05-29','10:45:00',8.08),('12374','2013-05-29','10:50:00',8.19),('12374','2013-05-29','10:55:00',8.26),('12374','2013-05-29','11:00:00',8.38),('12374','2013-05-29','11:05:00',8.43),('12374','2013-05-29','11:10:00',8.56),('12374','2013-05-29','11:15:00',8.64),('12374','2013-05-29','11:20:00',8.78),('12374','2013-05-29','11:25:00',8.81),('12374','2013-05-29','11:30:00',8.92),('12374','2013-05-29','11:35:00',9.09),('12374','2013-05-29','11:40:00',9.23),('12374','2013-05-29','11:45:00',8.96),('12374','2013-05-29','11:50:00',9.2),('12374','2013-05-29','11:55:00',9.06),('12374','2013-05-29','12:00:00',9.02),('12374','2013-05-29','12:05:00',9.16),('12374','2013-05-29','12:10:00',9.31),('12374','2013-05-29','12:15:00',9.34),('12374','2013-05-29','12:20:00',9.36),('12374','2013-05-29','12:25:00',9.35),('12374','2013-05-29','12:30:00',9.35),('12374','2013-05-29','12:35:00',9.32),('12374','2013-05-29','12:40:00',9.37),('12374','2013-05-29','12:45:00',9.43),('12374','2013-05-29','12:50:00',9.42),('12374','2013-05-29','12:55:00',9.43),('12374','2013-05-29','13:00:00',9.41),('12374','2013-05-29','13:05:00',9.33),('12374','2013-05-29','13:10:00',9.4),('12374','2013-05-29','13:15:00',9.39),('12374','2013-05-29','13:20:00',9.44),('12374','2013-05-29','13:25:00',9.49),('12374','2013-05-29','13:30:00',9.51),('12374','2013-05-29','13:35:00',9.46),('12374','2013-05-29','13:40:00',9.44),('12374','2013-05-29','13:45:00',9.33),('12374','2013-05-29','13:50:00',9.21),('12374','2013-05-29','13:55:00',9.27),('12374','2013-05-29','14:00:00',9.21),('12374','2013-05-29','14:05:00',9.16),('12374','2013-05-29','14:10:00',9.12),('12374','2013-05-29','14:15:00',9.18),('12374','2013-05-29','14:20:00',9.13),('12374','2013-05-29','14:25:00',8.68),('12374','2013-05-29','14:30:00',8.89),('12374','2013-05-29','14:35:00',9.05),('12374','2013-05-29','14:40:00',4.28),('12374','2013-05-29','14:45:00',4.06),('12374','2013-05-29','14:50:00',7.9),('12374','2013-05-29','14:55:00',6.79),('12374','2013-05-29','15:00:00',8.98),('12374','2013-05-29','15:05:00',8.62),('12374','2013-05-29','15:10:00',8.45),('12374','2013-05-29','15:15:00',8.2),('12374','2013-05-29','15:20:00',7.99),('12374','2013-05-29','15:25:00',8.09),('12374','2013-05-29','15:30:00',7.97),('12374','2013-05-29','15:35:00',7.92),('12374','2013-05-29','15:40:00',4.87),('12374','2013-05-29','15:45:00',4.22),('12374','2013-05-29','15:50:00',5.04),('12374','2013-05-29','15:55:00',5.13),('12374','2013-05-29','16:00:00',6.39),('12374','2013-05-29','16:05:00',4.27),('12374','2013-05-29','16:10:00',4.33),('12374','2013-05-29','16:15:00',3.8),('12374','2013-05-29','16:20:00',3.49),('12374','2013-05-29','16:25:00',3.09),('12374','2013-05-29','16:30:00',3.26),('12374','2013-05-29','16:35:00',2.85),('12374','2013-05-29','16:40:00',3.76),('12374','2013-05-29','16:45:00',3.61),('12374','2013-05-29','16:50:00',3.51),('12374','2013-05-29','16:55:00',3.12),('12374','2013-05-29','17:00:00',3.39),('12374','2013-05-29','17:05:00',3.46),('12374','2013-05-29','17:10:00',3.19),('12374','2013-05-29','17:15:00',2.55),('12374','2013-05-29','17:20:00',1.26),('12374','2013-05-29','17:30:00',1.11),('12374','2013-05-29','17:35:00',1.2),('12374','2013-05-29','17:45:00',1.2),('12374','2013-05-29','17:50:00',1.07),('12374','2013-05-29','18:00:00',1.05),('12374','2013-05-29','18:20:00',1.36),('12374','2013-05-29','18:25:00',1.91),('12374','2013-05-29','18:30:00',2.83),('12374','2013-05-29','18:35:00',2.04),('12374','2013-05-29','18:40:00',1.37),('12374','2013-05-29','18:45:00',1.16),('12374','2013-05-29','18:50:00',1.03),('12374','2013-05-29','18:55:00',1.93),('12374','2013-05-29','19:00:00',1.01),('12374','2013-05-29','19:05:00',1.24),('12374','2013-05-29','19:10:00',1.65),('12374','2013-05-29','19:15:00',1.64),('12374','2013-05-29','19:20:00',1.49),('12374','2013-05-28','06:45:00',1.21),('12374','2013-05-28','06:50:00',1.48),('12374','2013-05-28','06:55:00',1.55),('12374','2013-05-28','07:00:00',2),('12374','2013-05-28','07:05:00',2.14),('12374','2013-05-28','07:10:00',1.92),('12374','2013-05-28','07:15:00',1.68),('12374','2013-05-28','07:20:00',1.97),('12374','2013-05-28','07:25:00',2.01),('12374','2013-05-28','07:30:00',2.51),('12374','2013-05-28','07:35:00',2.58),('12374','2013-05-28','07:40:00',1.65),('12374','2013-05-28','07:45:00',1.79),('12374','2013-05-28','07:50:00',2.34),('12374','2013-05-28','07:55:00',3.37),('12374','2013-05-28','08:00:00',3.76),('12374','2013-05-28','08:05:00',2.7),('12374','2013-05-28','08:10:00',2.47),('12374','2013-05-28','08:15:00',3.03),('12374','2013-05-28','08:20:00',4.14),('12374','2013-05-28','08:25:00',4.19),('12374','2013-05-28','08:30:00',4.29),('12374','2013-05-28','08:35:00',3.67),('12374','2013-05-28','08:40:00',4.13),('12374','2013-05-28','08:45:00',5.38),('12374','2013-05-28','08:50:00',5.5),('12374','2013-05-28','08:55:00',4.88),('12374','2013-05-28','09:00:00',5.06),('12374','2013-05-28','09:05:00',4.68),('12374','2013-05-28','09:10:00',3.7),('12374','2013-05-28','09:15:00',5.8),('12374','2013-05-28','09:20:00',6),('12374','2013-05-28','09:25:00',5.12),('12374','2013-05-28','09:30:00',6.06),('12374','2013-05-28','09:35:00',5.55),('12374','2013-05-28','09:40:00',4.86),('12374','2013-05-28','09:45:00',5.13),('12374','2013-05-28','09:50:00',5.63),('12374','2013-05-28','09:55:00',5.34),('12374','2013-05-28','10:00:00',4.58),('12374','2013-05-28','10:05:00',4.58),('12374','2013-05-28','10:10:00',6.03),('12374','2013-05-28','10:15:00',6.75),('12374','2013-05-28','10:20:00',5.87),('12374','2013-05-28','10:25:00',4.64),('12374','2013-05-28','10:30:00',6.01),('12374','2013-05-28','10:35:00',6.51),('12374','2013-05-28','10:40:00',5.67),('12374','2013-05-28','10:45:00',6.05),('12374','2013-05-28','10:50:00',6.88),('12374','2013-05-28','10:55:00',3.57),('12374','2013-05-28','11:00:00',3),('12374','2013-05-28','11:05:00',3.36),('12374','2013-05-28','11:10:00',6.54),('12374','2013-05-28','11:15:00',8.12),('12374','2013-05-28','11:20:00',8.26),('12374','2013-05-28','11:25:00',8.5),('12374','2013-05-28','11:30:00',8.8),('12374','2013-05-28','11:35:00',4.24),('12374','2013-05-28','11:40:00',4.16),('12374','2013-05-28','11:45:00',5.26),('12374','2013-05-28','11:50:00',4.33),('12374','2013-05-28','11:55:00',4.1),('12374','2013-05-28','12:00:00',4.61),('12374','2013-05-28','12:05:00',5.02),('12374','2013-05-28','12:10:00',4.81),('12374','2013-05-28','12:15:00',3.76),('12374','2013-05-28','12:20:00',4.4),('12374','2013-05-28','12:25:00',4.72),('12374','2013-05-28','12:30:00',4.81),('12374','2013-05-28','12:35:00',4.88),('12374','2013-05-28','12:40:00',7.33),('12374','2013-05-28','12:45:00',8.97),('12374','2013-05-28','12:50:00',4.82),('12374','2013-05-28','12:55:00',3.63),('12374','2013-05-28','13:00:00',5.32),('12374','2013-05-28','13:05:00',8.08),('12374','2013-05-28','13:10:00',8.46),('12374','2013-05-28','13:15:00',7.73),('12374','2013-05-28','13:20:00',7.49),('12374','2013-05-28','13:25:00',7.84),('12374','2013-05-28','13:30:00',4.77),('12374','2013-05-28','13:35:00',5.15),('12374','2013-05-28','13:40:00',4.49),('12374','2013-05-28','13:45:00',5.31),('12374','2013-05-28','13:50:00',6.25),('12374','2013-05-28','13:55:00',5.36),('12374','2013-05-28','14:00:00',4.3),('12374','2013-05-28','14:05:00',5.84),('12374','2013-05-28','14:10:00',6.97),('12374','2013-05-28','14:15:00',6.94),('12374','2013-05-28','14:20:00',7.85),('12374','2013-05-28','14:25:00',6.98),('12374','2013-05-28','14:30:00',5.93),('12374','2013-05-28','14:35:00',8.63),('12374','2013-05-28','14:40:00',7.26),('12374','2013-05-28','14:45:00',7.72),('12374','2013-05-28','14:50:00',8.18),('12374','2013-05-28','14:55:00',5.09),('12374','2013-05-28','15:00:00',4.19),('12374','2013-05-28','15:05:00',4.11),('12374','2013-05-28','15:10:00',4.34),('12374','2013-05-28','15:15:00',5.17),('12374','2013-05-28','15:20:00',6.75),('12374','2013-05-28','15:25:00',6.64),('12374','2013-05-28','15:30:00',7.71),('12374','2013-05-28','15:35:00',6.55),('12374','2013-05-28','15:40:00',4.19),('12374','2013-05-28','15:45:00',2.7),('12374','2013-05-28','15:50:00',2.25),('12374','2013-05-28','15:55:00',2.28),('12374','2013-05-28','16:00:00',2.14),('12374','2013-05-28','16:05:00',2.22),('12374','2013-05-28','16:10:00',2.27),('12374','2013-05-28','16:15:00',2.22),('12374','2013-05-28','16:20:00',2.16),('12374','2013-05-28','16:25:00',2.41),('12374','2013-05-28','16:30:00',2.69),('12374','2013-05-28','16:35:00',2.91),('12374','2013-05-28','16:40:00',2.95),('12374','2013-05-28','16:45:00',2.97),('12374','2013-05-28','16:50:00',3),('12374','2013-05-28','16:55:00',3.17),('12374','2013-05-28','17:00:00',5.46),('12374','2013-05-28','17:05:00',4.86),('12374','2013-05-28','17:10:00',3.8),('12374','2013-05-28','17:15:00',2.56),('12374','2013-05-28','17:20:00',2.17),('12374','2013-05-28','17:25:00',2.44),('12374','2013-05-28','17:30:00',2.79),('12374','2013-05-28','17:35:00',2.79),('12374','2013-05-28','17:40:00',2.29),('12374','2013-05-28','17:45:00',2.22),('12374','2013-05-28','17:50:00',2.23),('12374','2013-05-28','17:55:00',2.49),('12374','2013-05-28','18:00:00',2.21),('12374','2013-05-28','18:05:00',1.78),('12374','2013-05-28','18:10:00',1.68),('12374','2013-05-28','18:15:00',2.63),('12374','2013-05-28','18:20:00',2.76),('12374','2013-05-28','18:25:00',1.71),('12374','2013-05-28','18:30:00',1.18),('12374','2013-05-28','18:35:00',1.96),('12374','2013-05-27','07:00:00',1.07),('12374','2013-05-27','07:45:00',2.85),('12374','2013-05-27','07:50:00',3.51),('12374','2013-05-27','07:55:00',3.61),('12374','2013-05-27','08:00:00',3.77),('12374','2013-05-27','08:05:00',3.92),('12374','2013-05-27','08:10:00',4.09),('12374','2013-05-27','08:15:00',4.23),('12374','2013-05-27','08:20:00',4.34),('12374','2013-05-27','08:25:00',4.49),('12374','2013-05-27','08:30:00',4.66),('12374','2013-05-27','08:35:00',4.8),('12374','2013-05-27','08:40:00',4.94),('12374','2013-05-27','08:45:00',5.05),('12374','2013-05-27','08:50:00',5.16),('12374','2013-05-27','08:55:00',5.39),('12374','2013-05-27','09:00:00',5.52),('12374','2013-05-27','09:05:00',5.65),('12374','2013-05-27','09:10:00',5.72),('12374','2013-05-27','09:15:00',5.94),('12374','2013-05-27','09:20:00',6.06),('12374','2013-05-27','09:25:00',6.17),('12374','2013-05-27','09:30:00',6.27),('12374','2013-05-27','09:35:00',6.49),('12374','2013-05-27','09:40:00',6.61),('12374','2013-05-27','09:45:00',6.73),('12374','2013-05-27','09:50:00',5.23),('12374','2013-05-27','09:55:00',5.66),('12374','2013-05-27','10:00:00',7.24),('12374','2013-05-27','10:05:00',7.35),('12374','2013-05-27','10:10:00',7.36),('12374','2013-05-27','10:15:00',7.52),('12374','2013-05-27','10:20:00',7.67),('12374','2013-05-27','10:25:00',7.77),('12374','2013-05-27','10:30:00',7.89),('12374','2013-05-27','10:35:00',7.96),('12374','2013-05-27','10:40:00',7.41),('12374','2013-05-27','10:45:00',7.69),('12374','2013-05-27','10:50:00',8.35),('12374','2013-05-27','10:55:00',7.22),('12374','2013-05-27','11:00:00',8.68),('12374','2013-05-27','11:05:00',9.66),('12374','2013-05-27','11:10:00',7.38),('12374','2013-05-27','11:15:00',8.18),('12374','2013-05-27','11:20:00',5.53),('12374','2013-05-27','11:25:00',7.63),('12374','2013-05-27','11:30:00',7.99),('12374','2013-05-27','11:35:00',6.63),('12374','2013-05-27','11:40:00',9.28),('12374','2013-05-27','11:45:00',9.18),('12374','2013-05-27','11:50:00',9.23),('12374','2013-05-27','11:55:00',9.27),('12374','2013-05-27','12:00:00',9.25),('12374','2013-05-27','12:05:00',9.33),('12374','2013-05-27','12:10:00',9.32),('12374','2013-05-27','12:15:00',9.34),('12374','2013-05-27','12:20:00',9.32),('12374','2013-05-27','12:25:00',9.25),('12374','2013-05-27','12:30:00',9.13),('12374','2013-05-27','12:35:00',9.29),('12374','2013-05-27','12:40:00',9.39),('12374','2013-05-27','12:45:00',9.38),('12374','2013-05-27','12:50:00',9.38),('12374','2013-05-27','12:55:00',9.39),('12374','2013-05-27','13:00:00',9.28),('12374','2013-05-27','13:05:00',9.32),('12374','2013-05-27','13:10:00',9.52),('12374','2013-05-27','13:15:00',9.23),('12374','2013-05-27','13:20:00',9.07),('12374','2013-05-27','13:25:00',9.49),('12374','2013-05-27','13:30:00',9.49),('12374','2013-05-27','13:35:00',9.39),('12374','2013-05-27','13:40:00',9.3),('12374','2013-05-27','13:45:00',9.28),('12374','2013-05-27','13:50:00',9.4),('12374','2013-05-27','13:55:00',9.3),('12374','2013-05-27','14:00:00',9.25),('12374','2013-05-27','14:05:00',9.12),('12374','2013-05-27','14:10:00',9.19),('12374','2013-05-27','14:15:00',9.11),('12374','2013-05-27','14:20:00',9.19),('12374','2013-05-27','14:25:00',9.11),('12374','2013-05-27','14:30:00',9.06),('12374','2013-05-27','14:35:00',9.03),('12374','2013-05-27','14:40:00',8.5),('12374','2013-05-27','14:45:00',6.68),('12374','2013-05-27','14:50:00',7.87),('12374','2013-05-27','14:55:00',9.31),('12374','2013-05-27','15:00:00',7.06),('12374','2013-05-27','15:05:00',7.01),('12374','2013-05-27','15:10:00',8.69),('12374','2013-05-27','15:15:00',8.3),('12374','2013-05-27','15:20:00',8.27),('12374','2013-05-27','15:25:00',7.07),('12374','2013-05-27','15:30:00',5.58),('12374','2013-05-27','15:35:00',5.74),('12374','2013-05-27','15:40:00',6.28),('12374','2013-05-27','15:45:00',6.69),('12374','2013-05-27','15:50:00',6.46),('12374','2013-05-27','15:55:00',6.46),('12374','2013-05-27','16:00:00',5.96),('12374','2013-05-27','16:05:00',7.65),('12374','2013-05-27','16:10:00',7.52),('12374','2013-05-27','16:15:00',6.66),('12374','2013-05-27','16:20:00',5.21),('12374','2013-05-27','16:25:00',5.1),('12374','2013-05-27','16:30:00',6.48),('12374','2013-05-27','16:35:00',3.7),('12374','2013-05-27','16:40:00',6.61),('12374','2013-05-27','16:45:00',4.86),('12374','2013-05-27','16:50:00',3.14),('12374','2013-05-27','16:55:00',2.9),('12374','2013-05-27','17:00:00',2.87),('12374','2013-05-27','17:05:00',2.79),('12374','2013-05-27','17:10:00',2.75),('12374','2013-05-27','17:15:00',2.98),('12374','2013-05-27','17:20:00',2.76),('12374','2013-05-27','17:25:00',2.62),('12374','2013-05-27','17:30:00',3.05),('12374','2013-05-27','17:35:00',2.59),('12374','2013-05-27','17:40:00',2.18),('12374','2013-05-27','17:45:00',2.09),('12374','2013-05-27','17:50:00',2.1),('12374','2013-05-27','17:55:00',2.07),('12374','2013-05-27','18:00:00',2.05),('12374','2013-05-27','18:05:00',2.12),('12374','2013-05-27','18:10:00',3.18),('12374','2013-05-27','18:15:00',3.79),('12374','2013-05-27','18:20:00',3.43),('12374','2013-05-27','18:25:00',2.93),('12374','2013-05-27','18:30:00',2.65),('12374','2013-05-27','18:35:00',2.19),('12374','2013-05-27','18:40:00',1.78),('12374','2013-05-27','18:45:00',2.44),('12374','2013-05-27','18:50:00',2.35),('12374','2013-05-27','18:55:00',2.09),('12374','2013-05-27','19:00:00',1.79),('12374','2013-05-27','19:05:00',1.54),('12374','2013-05-27','19:10:00',1.47),('12374','2013-05-27','19:15:00',1.43),('12374','2013-05-27','19:20:00',1.33),('12374','2013-05-27','19:25:00',1.07),('12374','2013-05-27','19:30:00',1.17),('12374','2013-05-27','19:35:00',1.03),('12374','2013-05-26','07:05:00',1.56),('12374','2013-05-26','07:10:00',2.03),('12374','2013-05-26','07:15:00',2.28),('12374','2013-05-26','07:20:00',2.16),('12374','2013-05-26','07:55:00',1.33),('12374','2013-05-26','08:00:00',1.69),('12374','2013-05-26','08:05:00',1.85),('12374','2013-05-26','08:10:00',1.25),('12374','2013-05-26','08:15:00',1.61),('12374','2013-05-26','08:20:00',1.98),('12374','2013-05-26','08:25:00',1.56),('12374','2013-05-26','08:30:00',1.31),('12374','2013-05-26','08:35:00',1.74),('12374','2013-05-26','08:40:00',1.42),('12374','2013-05-26','08:55:00',4.35),('12374','2013-05-26','09:00:00',4.91),('12374','2013-05-26','09:05:00',5.05),('12374','2013-05-26','09:10:00',5.92),('12374','2013-05-26','09:15:00',6.11),('12374','2013-05-26','09:20:00',6.24),('12374','2013-05-26','09:25:00',6.37),('12374','2013-05-26','09:30:00',6.51),('12374','2013-05-26','09:35:00',6.63),('12374','2013-05-26','09:40:00',6.77),('12374','2013-05-26','09:45:00',6.94),('12374','2013-05-26','09:50:00',7.04),('12374','2013-05-26','09:55:00',7.2),('12374','2013-05-26','10:00:00',7.33),('12374','2013-05-26','10:05:00',7.48),('12374','2013-05-26','10:10:00',7.59),('12374','2013-05-26','10:15:00',7.72),('12374','2013-05-26','10:20:00',7.79),('12374','2013-05-26','10:25:00',7.86),('12374','2013-05-26','10:30:00',8.07),('12374','2013-05-26','10:35:00',8.2),('12374','2013-05-26','10:40:00',8.31),('12374','2013-05-26','10:45:00',8.42),('12374','2013-05-26','10:50:00',8.51),('12374','2013-05-26','10:55:00',8.61),('12374','2013-05-26','11:00:00',8.69),('12374','2013-05-26','11:05:00',8.77),('12374','2013-05-26','11:10:00',8.89),('12374','2013-05-26','11:15:00',8.94),('12374','2013-05-26','11:20:00',9.01),('12374','2013-05-26','11:25:00',9.13),('12374','2013-05-26','11:30:00',9.22),('12374','2013-05-26','11:35:00',9.25),('12374','2013-05-26','11:40:00',9.28),('12374','2013-05-26','11:45:00',9.31),('12374','2013-05-26','11:50:00',9.33),('12374','2013-05-26','11:55:00',9.34),('12374','2013-05-26','12:00:00',9.37),('12374','2013-05-26','12:05:00',9.33),('12374','2013-05-26','12:10:00',9.41),('12374','2013-05-26','12:15:00',9.52),('12374','2013-05-26','12:20:00',9.57),('12374','2013-05-26','12:25:00',9.62),('12374','2013-05-26','12:30:00',9.65),('12374','2013-05-26','12:35:00',9.79),('12374','2013-05-26','12:40:00',9.97),('12374','2013-05-26','12:45:00',9.77),('12374','2013-05-26','12:50:00',9.72),('12374','2013-05-26','12:55:00',9.73),('12374','2013-05-26','13:00:00',8.6),('12374','2013-05-26','13:05:00',8.37),('12374','2013-05-26','13:10:00',6.24),('12374','2013-05-26','13:15:00',6.94),('12374','2013-05-26','13:20:00',9.57),('12374','2013-05-26','13:25:00',9.63),('12374','2013-05-26','13:30:00',9.56),('12374','2013-05-26','13:35:00',9.54),('12374','2013-05-26','13:40:00',9.49),('12374','2013-05-26','13:45:00',9.52),('12374','2013-05-26','13:50:00',9.46),('12374','2013-05-26','13:55:00',9.47),('12374','2013-05-26','14:00:00',9.47),('12374','2013-05-26','14:05:00',9.38),('12374','2013-05-26','14:10:00',9.34),('12374','2013-05-26','14:15:00',9.32),('12374','2013-05-26','14:20:00',9.24),('12374','2013-05-26','14:25:00',9.19),('12374','2013-05-26','14:30:00',9.17),('12374','2013-05-26','14:35:00',9.1),('12374','2013-05-26','14:40:00',9.06),('12374','2013-05-26','14:45:00',8.99),('12374','2013-05-26','14:50:00',8.86),('12374','2013-05-26','14:55:00',8.79),('12374','2013-05-26','15:00:00',8.68),('12374','2013-05-26','15:05:00',8.54),('12374','2013-05-26','15:10:00',8.51),('12374','2013-05-26','15:15:00',8.39),('12374','2013-05-26','15:20:00',8.3),('12374','2013-05-26','15:25:00',8.18),('12374','2013-05-26','15:30:00',8.08),('12374','2013-05-26','15:35:00',7.93),('12374','2013-05-26','15:40:00',7.8),('12374','2013-05-26','15:45:00',7.66),('12374','2013-05-26','15:50:00',7.55),('12374','2013-05-26','15:55:00',7.44),('12374','2013-05-26','16:00:00',7.31),('12374','2013-05-26','16:05:00',7.17),('12374','2013-05-26','16:10:00',7.03),('12374','2013-05-26','16:15:00',6.87),('12374','2013-05-26','16:20:00',6.68),('12374','2013-05-26','16:25:00',6.63),('12374','2013-05-26','16:30:00',6.49),('12374','2013-05-26','16:35:00',6.33),('12374','2013-05-26','16:40:00',6.22),('12374','2013-05-26','16:45:00',6.04),('12374','2013-05-26','16:50:00',5.83),('12374','2013-05-26','16:55:00',5.69),('12374','2013-05-26','17:00:00',5.54),('12374','2013-05-26','17:05:00',5.38),('12374','2013-05-26','17:10:00',5.24),('12374','2013-05-26','17:15:00',5.1),('12374','2013-05-26','17:20:00',4.94),('12374','2013-05-26','17:25:00',4.68),('12374','2013-05-26','17:30:00',4.36),('12374','2013-05-26','17:35:00',4.27),('12374','2013-05-26','17:40:00',4.11),('12374','2013-05-26','17:45:00',3.86),('12374','2013-05-26','17:50:00',3.61),('12374','2013-05-26','17:55:00',3.5),('12374','2013-05-26','18:00:00',3.28),('12374','2013-05-26','18:05:00',3.16),('12374','2013-05-26','18:10:00',2.95),('12374','2013-05-26','18:15:00',2.56),('12374','2013-05-26','18:20:00',2.33),('12374','2013-05-26','18:25:00',2.3),('12374','2013-05-26','18:30:00',2.14),('12374','2013-05-26','18:35:00',2.07),('12374','2013-05-26','18:40:00',1.91),('12374','2013-05-26','18:45:00',1.74),('12374','2013-05-26','18:50:00',1.66),('12374','2013-05-26','18:55:00',1.58),('12374','2013-05-26','19:00:00',1.51),('12374','2013-05-26','19:05:00',1.44),('12374','2013-05-26','19:10:00',1.36),('12374','2013-05-26','19:15:00',1.29),('12374','2013-05-26','19:20:00',1.22),('12374','2013-05-26','19:25:00',1.13),('12374','2013-05-26','19:30:00',1.05),('12374','2013-05-25','06:35:00',1.22),('12374','2013-05-25','06:40:00',1.15),('12374','2013-05-25','06:45:00',1.39),('12374','2013-05-25','06:50:00',1.11),('12374','2013-05-25','07:30:00',1.46),('12374','2013-05-25','07:35:00',3.09),('12374','2013-05-25','07:40:00',2.22),('12374','2013-05-25','07:45:00',3.27),('12374','2013-05-25','07:50:00',3.43),('12374','2013-05-25','07:55:00',3.64),('12374','2013-05-25','08:00:00',4.07),('12374','2013-05-25','08:05:00',2.96),('12374','2013-05-25','08:10:00',4.22),('12374','2013-05-25','08:15:00',2.28),('12374','2013-05-25','08:20:00',3.62),('12374','2013-05-25','08:25:00',2.5),('12374','2013-05-25','08:30:00',3.87),('12374','2013-05-25','08:35:00',4.55),('12374','2013-05-25','08:40:00',3.03),('12374','2013-05-25','08:45:00',2.46),('12374','2013-05-25','08:50:00',2.21),('12374','2013-05-25','08:55:00',3.42),('12374','2013-05-25','09:00:00',5.71),('12374','2013-05-25','09:05:00',5.42),('12374','2013-05-25','09:10:00',4.93),('12374','2013-05-25','09:15:00',2.69),('12374','2013-05-25','09:20:00',1.6),('12374','2013-05-25','09:25:00',1.27),('12374','2013-05-25','09:35:00',1.06),('12374','2013-05-25','09:40:00',1.11),('12374','2013-05-25','09:45:00',1.7),('12374','2013-05-25','09:50:00',1.42),('12374','2013-05-25','09:55:00',2.15),('12374','2013-05-25','10:00:00',3.43),('12374','2013-05-25','10:05:00',4.11),('12374','2013-05-25','10:10:00',2.22),('12374','2013-05-25','10:15:00',1.71),('12374','2013-05-25','10:20:00',1.6),('12374','2013-05-25','10:25:00',2.31),('12374','2013-05-25','10:30:00',2.83),('12374','2013-05-25','10:35:00',2.71),('12374','2013-05-25','10:40:00',2.17),('12374','2013-05-25','10:45:00',2.12),('12374','2013-05-25','10:50:00',2.17),('12374','2013-05-25','10:55:00',2.51),('12374','2013-05-25','11:00:00',2.85),('12374','2013-05-25','11:05:00',3.5),('12374','2013-05-25','11:10:00',3.9),('12374','2013-05-25','11:15:00',7.86),('12374','2013-05-25','11:20:00',5.84),('12374','2013-05-25','11:25:00',1.48),('12374','2013-05-25','11:30:00',2.89),('12374','2013-05-25','11:35:00',3.85),('12374','2013-05-25','11:40:00',3.21),('12374','2013-05-25','11:45:00',2.85),('12374','2013-05-25','11:50:00',2.04),('12374','2013-05-25','11:55:00',1.86),('12374','2013-05-25','12:00:00',1.97),('12374','2013-05-25','12:05:00',1.16),('12374','2013-05-25','12:10:00',1.47),('12374','2013-05-25','12:15:00',1.67),('12374','2013-05-25','12:20:00',2.78),('12374','2013-05-25','12:25:00',2.8),('12374','2013-05-25','12:30:00',2.47),('12374','2013-05-25','12:35:00',4.26),('12374','2013-05-25','12:40:00',5.7),('12374','2013-05-25','12:45:00',6.09),('12374','2013-05-25','12:50:00',9.59),('12374','2013-05-25','12:55:00',8.73),('12374','2013-05-25','13:00:00',2.83),('12374','2013-05-25','13:05:00',1.97),('12374','2013-05-25','13:10:00',8),('12374','2013-05-25','13:15:00',9.11),('12374','2013-05-25','13:20:00',6.84),('12374','2013-05-25','13:25:00',9.36),('12374','2013-05-25','13:30:00',8.87),('12374','2013-05-25','13:35:00',9.54),('12374','2013-05-25','13:40:00',7.55),('12374','2013-05-25','13:45:00',9.83),('12374','2013-05-25','13:50:00',2.99),('12374','2013-05-25','14:10:00',6.91),('12374','2013-05-25','14:15:00',8.93),('12374','2013-05-25','14:20:00',9.15),('12374','2013-05-25','14:25:00',9.15),('12374','2013-05-25','14:30:00',4.76),('12374','2013-05-25','14:35:00',6.53),('12374','2013-05-25','14:40:00',4.24),('12374','2013-05-25','14:45:00',7.02),('12374','2013-05-25','14:50:00',4.85),('12374','2013-05-25','14:55:00',8.51),('12374','2013-05-25','15:00:00',9.03),('12374','2013-05-25','15:05:00',8.41),('12374','2013-05-25','15:10:00',6.59),('12374','2013-05-25','15:15:00',6.99),('12374','2013-05-25','15:20:00',8.46),('12374','2013-05-25','15:25:00',7.83),('12374','2013-05-25','15:30:00',5.49),('12374','2013-05-25','15:35:00',5.17),('12374','2013-05-25','15:40:00',6.08),('12374','2013-05-25','15:45:00',5.43),('12374','2013-05-25','15:50:00',5.95),('12374','2013-05-25','15:55:00',6.62),('12374','2013-05-25','16:00:00',6.84),('12374','2013-05-25','16:05:00',7.36),('12374','2013-05-25','16:10:00',7.3),('12374','2013-05-25','16:15:00',7.09),('12374','2013-05-25','16:20:00',6.5),('12374','2013-05-25','16:25:00',6.82),('12374','2013-05-25','16:30:00',6.62),('12374','2013-05-25','16:35:00',6.47),('12374','2013-05-25','16:40:00',6.32),('12374','2013-05-25','16:45:00',6.06),('12374','2013-05-25','16:50:00',5.88),('12374','2013-05-25','16:55:00',5.74),('12374','2013-05-25','17:00:00',4.67),('12374','2013-05-25','17:05:00',5.47),('12374','2013-05-25','17:10:00',4.69),('12374','2013-05-25','17:15:00',3.12),('12374','2013-05-25','17:25:00',3.08),('12374','2013-05-25','17:30:00',2.12),('12374','2013-05-25','17:35:00',2.97),('12374','2013-05-25','17:40:00',2.13),('12374','2013-05-25','17:45:00',1.99),('12374','2013-05-25','17:50:00',1.26),('12374','2013-05-25','18:40:00',1.66),('12374','2013-05-25','18:45:00',1.16),('12374','2013-05-24','07:25:00',1),('12374','2013-05-24','07:30:00',1.13),('12374','2013-05-24','07:35:00',1.82),('12374','2013-05-24','07:40:00',3.19),('12374','2013-05-24','07:45:00',2.64),('12374','2013-05-24','07:50:00',2.55),('12374','2013-05-24','07:55:00',2.81),('12374','2013-05-24','08:00:00',3.13),('12374','2013-05-24','08:05:00',3.8),('12374','2013-05-24','08:10:00',3.18),('12374','2013-05-24','08:15:00',1.49),('12374','2013-05-24','08:20:00',2.53),('12374','2013-05-24','08:25:00',4.98),('12374','2013-05-24','08:30:00',5.01),('12374','2013-05-24','08:35:00',2.82),('12374','2013-05-24','08:40:00',4.95),('12374','2013-05-24','08:45:00',1.83),('12374','2013-05-24','08:50:00',4.71),('12374','2013-05-24','08:55:00',5.17),('12374','2013-05-24','09:00:00',2.76),('12374','2013-05-24','09:05:00',4.38),('12374','2013-05-24','09:10:00',4.25),('12374','2013-05-24','09:15:00',3.88),('12374','2013-05-24','09:20:00',6.39),('12374','2013-05-24','09:25:00',6.29),('12374','2013-05-24','09:30:00',5.99),('12374','2013-05-24','09:35:00',5.5),('12374','2013-05-24','09:40:00',6.83),('12374','2013-05-24','09:45:00',5.61),('12374','2013-05-24','09:50:00',2.41),('12374','2013-05-24','09:55:00',3.93),('12374','2013-05-24','10:00:00',7.31),('12374','2013-05-24','10:05:00',7.56),('12374','2013-05-24','10:10:00',7.72),('12374','2013-05-24','10:15:00',7.55),('12374','2013-05-24','10:20:00',3.05),('12374','2013-05-24','10:25:00',7.14),('12374','2013-05-24','10:30:00',8.16),('12374','2013-05-24','10:35:00',8.08),('12374','2013-05-24','10:40:00',7.97),('12374','2013-05-24','10:45:00',8.99),('12374','2013-05-24','10:50:00',8.6),('12374','2013-05-24','10:55:00',6.34),('12374','2013-05-24','11:00:00',6.79),('12374','2013-05-24','11:05:00',6.43),('12374','2013-05-24','11:10:00',8.62),('12374','2013-05-24','11:15:00',4.91),('12374','2013-05-24','11:20:00',6.73),('12374','2013-05-24','11:25:00',9.68),('12374','2013-05-24','11:30:00',9.63),('12374','2013-05-24','11:35:00',9.51),('12374','2013-05-24','11:40:00',8.77),('12374','2013-05-24','11:45:00',9.33),('12374','2013-05-24','11:50:00',9.75),('12374','2013-05-24','11:55:00',9.51),('12374','2013-05-24','12:00:00',6.56),('12374','2013-05-24','12:05:00',9.94),('12374','2013-05-24','12:10:00',9.96),('12374','2013-05-24','12:15:00',9.73),('12374','2013-05-24','12:20:00',6.17),('12374','2013-05-24','12:25:00',8.61),('12374','2013-05-24','12:30:00',7.58),('12374','2013-05-24','12:35:00',7.07),('12374','2013-05-24','12:40:00',5.4),('12374','2013-05-24','12:45:00',8.03),('12374','2013-05-24','12:50:00',5.9),('12374','2013-05-24','12:55:00',5.53),('12374','2013-05-24','13:00:00',5.68),('12374','2013-05-24','13:05:00',7.7),('12374','2013-05-24','13:10:00',8.39),('12374','2013-05-24','13:15:00',7.21),('12374','2013-05-24','13:20:00',7.8),('12374','2013-05-24','13:25:00',8.67),('12374','2013-05-24','13:30:00',2.6),('12374','2013-05-24','13:35:00',2.26),('12374','2013-05-24','13:40:00',3.55),('12374','2013-05-24','13:45:00',7.2),('12374','2013-05-24','13:50:00',8.77),('12374','2013-05-24','13:55:00',2.52),('12374','2013-05-24','14:00:00',5.03),('12374','2013-05-24','14:05:00',3.11),('12374','2013-05-24','14:10:00',6.31),('12374','2013-05-24','14:15:00',6.66),('12374','2013-05-24','14:20:00',9.16),('12374','2013-05-24','14:25:00',9.14),('12374','2013-05-24','14:30:00',6.66),('12374','2013-05-24','14:35:00',4.59),('12374','2013-05-24','14:40:00',4.54),('12374','2013-05-24','14:45:00',6.65),('12374','2013-05-24','14:50:00',8.94),('12374','2013-05-24','14:55:00',6.98),('12374','2013-05-24','15:00:00',8.76),('12374','2013-05-24','15:05:00',9.14),('12374','2013-05-24','15:10:00',9),('12374','2013-05-24','15:15:00',8.84),('12374','2013-05-24','15:20:00',4.75),('12374','2013-05-24','15:25:00',7.04),('12374','2013-05-24','15:30:00',5.22),('12374','2013-05-24','15:35:00',3.37),('12374','2013-05-24','15:40:00',5.41),('12374','2013-05-24','15:45:00',3.77),('12374','2013-05-24','15:50:00',2.02),('12374','2013-05-24','15:55:00',2.86),('12374','2013-05-24','16:00:00',3.61),('12374','2013-05-24','16:05:00',3.61),('12374','2013-05-24','16:10:00',3.39),('12374','2013-05-24','16:15:00',2.76),('12374','2013-05-24','16:20:00',2.67),('12374','2013-05-24','16:25:00',2.34),('12374','2013-05-24','16:30:00',2.32),('12374','2013-05-24','16:35:00',2.55),('12374','2013-05-24','16:40:00',2.79),('12374','2013-05-24','16:45:00',2.86),('12374','2013-05-24','16:50:00',4.06),('12374','2013-05-24','16:55:00',6),('12374','2013-05-24','17:00:00',6.96),('12374','2013-05-24','17:05:00',5.28),('12374','2013-05-24','17:10:00',2.71),('12374','2013-05-24','17:15:00',2.97),('12374','2013-05-24','17:20:00',3.11),('12374','2013-05-24','17:25:00',2.6),('12374','2013-05-24','17:30:00',2.49),('12374','2013-05-24','17:35:00',3.14),('12374','2013-05-24','17:40:00',1.88),('12374','2013-05-24','17:45:00',1.84),('12374','2013-05-24','17:50:00',2.3),('12374','2013-05-24','17:55:00',2.05),('12374','2013-05-24','18:00:00',1.38),('12374','2013-05-23','07:20:00',1.33),('12374','2013-05-23','07:25:00',2.47),('12374','2013-05-23','07:30:00',2.65),('12374','2013-05-23','07:35:00',2.63),('12374','2013-05-23','07:40:00',1.44),('12374','2013-05-23','07:50:00',2.21),('12374','2013-05-23','07:55:00',1.13),('12374','2013-05-23','08:00:00',1.14),('12374','2013-05-23','08:05:00',1.62),('12374','2013-05-23','08:10:00',1.38),('12374','2013-05-23','08:15:00',1.35),('12374','2013-05-23','08:20:00',1.37),('12374','2013-05-23','08:25:00',1.71),('12374','2013-05-23','08:30:00',2.53),('12374','2013-05-23','08:35:00',2.63),('12374','2013-05-23','08:40:00',3.36),('12374','2013-05-23','08:45:00',3.11),('12374','2013-05-23','08:50:00',3.49),('12374','2013-05-23','08:55:00',5.23),('12374','2013-05-23','09:00:00',5.61),('12374','2013-05-23','09:05:00',5.66),('12374','2013-05-23','09:10:00',5.66),('12374','2013-05-23','09:15:00',6.02),('12374','2013-05-23','09:20:00',6.09),('12374','2013-05-23','09:25:00',6.6),('12374','2013-05-23','09:30:00',5.31),('12374','2013-05-23','09:35:00',4.36),('12374','2013-05-23','09:40:00',5.13),('12374','2013-05-23','09:45:00',3.86),('12374','2013-05-23','09:50:00',5.79),('12374','2013-05-23','09:55:00',6.94),('12374','2013-05-23','10:00:00',3.89),('12374','2013-05-23','10:05:00',7.1),('12374','2013-05-23','10:10:00',6.09),('12374','2013-05-23','10:15:00',4.73),('12374','2013-05-23','10:20:00',7.97),('12374','2013-05-23','10:25:00',5.18),('12374','2013-05-23','10:30:00',8.22),('12374','2013-05-23','10:35:00',7.36),('12374','2013-05-23','10:40:00',7.13),('12374','2013-05-23','10:45:00',7.06),('12374','2013-05-23','10:50:00',5.94),('12374','2013-05-23','10:55:00',8.18),('12374','2013-05-23','11:00:00',6.4),('12374','2013-05-23','11:05:00',8.41),('12374','2013-05-23','11:10:00',8.14),('12374','2013-05-23','11:15:00',4.67),('12374','2013-05-23','11:20:00',5.07),('12374','2013-05-23','11:25:00',7.16),('12374','2013-05-23','11:30:00',5.68),('12374','2013-05-23','11:35:00',9.33),('12374','2013-05-23','11:40:00',9.87),('12374','2013-05-23','11:45:00',8.25),('12374','2013-05-23','11:50:00',5.87),('12374','2013-05-23','11:55:00',5.26),('12374','2013-05-23','12:00:00',4.86),('12374','2013-05-23','12:05:00',6.6),('12374','2013-05-23','12:10:00',7.68),('12374','2013-05-23','12:15:00',9.69),('12374','2013-05-23','12:20:00',6.23),('12374','2013-05-23','15:40:00',7.09),('12374','2013-05-23','15:45:00',7.78),('12374','2013-05-23','15:50:00',6.37),('12374','2013-05-23','15:55:00',5.95),('12374','2013-05-23','16:00:00',5.78),('12374','2013-05-23','16:05:00',4.97),('12374','2013-05-23','16:10:00',3.11),('12374','2013-05-23','16:15:00',2.46),('12374','2013-05-23','16:20:00',2.11),('12374','2013-05-23','16:25:00',2.4),('12374','2013-05-23','16:30:00',3),('12374','2013-05-23','16:35:00',3.43),('12374','2013-05-23','16:40:00',3.47),('12374','2013-05-23','16:45:00',2.99),('12374','2013-05-23','16:50:00',3.29),('12374','2013-05-23','16:55:00',3.13),('12374','2013-05-23','17:00:00',2.71),('12374','2013-05-23','17:05:00',2.97),('12374','2013-05-23','17:10:00',3.63),('12374','2013-05-23','17:15:00',4.28),('12374','2013-05-23','17:20:00',4.68),('12374','2013-05-23','17:25:00',3.06),('12374','2013-05-23','17:30:00',1.41),('12374','2013-05-23','17:45:00',1.05),('12374','2013-05-23','17:50:00',1.11),('12374','2013-05-23','17:55:00',1.24),('12374','2013-05-23','18:00:00',1.05),('12374','2013-05-23','18:10:00',1.3),('12374','2013-05-23','18:15:00',1.43),('12374','2013-05-23','18:20:00',1.43),('12374','2013-05-22','07:35:00',1.03),('12374','2013-05-22','07:40:00',1.15),('12374','2013-05-22','07:45:00',1.3),('12374','2013-05-22','07:50:00',1.26),('12374','2013-05-22','07:55:00',1.6),('12374','2013-05-22','08:00:00',2.36),('12374','2013-05-22','08:05:00',3.41),('12374','2013-05-22','08:10:00',2.89),('12374','2013-05-22','08:15:00',4.68),('12374','2013-05-22','08:20:00',3.51),('12374','2013-05-22','08:50:00',3.5),('12374','2013-05-22','08:55:00',5.15),('12374','2013-05-22','09:00:00',2.97),('12374','2013-05-22','09:05:00',2.86),('12374','2013-05-22','09:10:00',2.88),('12374','2013-05-22','09:15:00',2.27),('12374','2013-05-22','09:20:00',1.33),('12374','2013-05-22','09:25:00',3.2),('12374','2013-05-22','09:30:00',5.92),('12374','2013-05-22','09:35:00',4.27),('12374','2013-05-22','09:40:00',5.91),('12374','2013-05-22','09:45:00',6.61),('12374','2013-05-22','09:50:00',6.59),('12374','2013-05-22','09:55:00',6.7),('12374','2013-05-22','10:00:00',6.84),('12374','2013-05-22','10:05:00',7.04),('12374','2013-05-22','10:10:00',5.35),('12374','2013-05-22','10:15:00',7.47),('12374','2013-05-22','10:20:00',5.71),('12374','2013-05-22','10:25:00',6.09),('12374','2013-05-22','10:30:00',5.9),('12374','2013-05-22','10:35:00',4.89),('12374','2013-05-22','10:40:00',5.04),('12374','2013-05-22','10:45:00',6.21),('12374','2013-05-22','10:50:00',7.11),('12374','2013-05-22','10:55:00',8.53),('12374','2013-05-22','11:00:00',6.6),('12374','2013-05-22','11:05:00',6.08),('12374','2013-05-22','11:10:00',6.11),('12374','2013-05-22','11:15:00',8.14),('12374','2013-05-22','11:20:00',7.5),('12374','2013-05-22','11:25:00',8.41),('12374','2013-05-22','11:30:00',7.76),('12374','2013-05-22','11:35:00',7.2),('12374','2013-05-22','11:40:00',8.88),('12374','2013-05-22','11:45:00',7.23),('12374','2013-05-22','11:50:00',9.15),('12374','2013-05-22','11:55:00',8.51),('12374','2013-05-22','12:00:00',7.17),('12374','2013-05-22','12:05:00',4.85),('12374','2013-05-22','12:10:00',4.17),('12374','2013-05-22','12:15:00',4.73),('12374','2013-05-22','12:20:00',5.08),('12374','2013-05-22','12:25:00',5.33),('12374','2013-05-22','12:30:00',5.28),('12374','2013-05-22','12:35:00',3.69),('12374','2013-05-22','12:40:00',2.81),('12374','2013-05-22','12:45:00',2.84),('12374','2013-05-22','12:50:00',3.43),('12374','2013-05-22','12:55:00',2.62),('12374','2013-05-22','13:00:00',1.68),('12374','2013-05-22','13:05:00',1.15),('12374','2013-05-22','13:25:00',1.69),('12374','2013-05-22','13:30:00',2.89),('12374','2013-05-22','13:35:00',3.77),('12374','2013-05-22','13:40:00',5.6),('12374','2013-05-22','13:45:00',3.98),('12374','2013-05-22','13:50:00',5.75),('12374','2013-05-22','13:55:00',6.69),('12374','2013-05-22','14:00:00',6.77),('12374','2013-05-22','14:05:00',8.09),('12374','2013-05-22','14:10:00',8.73),('12374','2013-05-22','14:15:00',8.85),('12374','2013-05-22','14:20:00',8.7),('12374','2013-05-22','14:25:00',8.76),('12374','2013-05-22','14:30:00',8.68),('12374','2013-05-22','14:35:00',8.59),('12374','2013-05-22','14:40:00',8.48),('12374','2013-05-22','14:45:00',8.42),('12374','2013-05-22','14:50:00',8.31),('12374','2013-05-22','14:55:00',8.23),('12374','2013-05-22','15:00:00',8.13),('12374','2013-05-22','15:05:00',8),('12374','2013-05-22','15:10:00',7.93),('12374','2013-05-22','15:15:00',7.74),('12374','2013-05-22','15:20:00',7.73),('12374','2013-05-22','15:25:00',7.63),('12374','2013-05-22','15:30:00',7.65),('12374','2013-05-22','15:35:00',7.76),('12374','2013-05-22','15:40:00',7.02),('12374','2013-05-22','15:45:00',6.75),('12374','2013-05-22','15:50:00',7.12),('12374','2013-05-22','15:55:00',6.88),('12374','2013-05-22','16:00:00',6.7),('12374','2013-05-22','16:05:00',6.57),('12374','2013-05-22','16:10:00',6.47),('12374','2013-05-22','16:15:00',6.31),('12374','2013-05-22','16:20:00',6.19),('12374','2013-05-22','16:25:00',6.05),('12374','2013-05-22','16:30:00',5.93),('12374','2013-05-22','16:35:00',5.85),('12374','2013-05-22','16:40:00',6.03),('12374','2013-05-22','16:45:00',6.35),('12374','2013-05-22','16:50:00',4.85),('12374','2013-05-22','16:55:00',3.64),('12374','2013-05-22','17:00:00',4.75),('12374','2013-05-22','17:05:00',3),('12374','2013-05-22','17:10:00',4.09),('12374','2013-05-22','17:15:00',2.26),('12374','2013-05-22','17:20:00',1.56),('12374','2013-05-22','17:25:00',3.25),('12374','2013-05-22','17:30:00',4.15),('12374','2013-05-22','17:35:00',3.57),('12374','2013-05-22','17:40:00',3.84),('12374','2013-05-22','17:45:00',3.9),('12374','2013-05-22','17:50:00',2.9),('12374','2013-05-22','17:55:00',3.21),('12374','2013-05-22','18:00:00',3.25),('12374','2013-05-22','18:05:00',2.84),('12374','2013-05-22','18:10:00',2.53),('12374','2013-05-22','18:15:00',2.36),('12374','2013-05-22','18:20:00',2.15),('12374','2013-05-22','18:25:00',2.12),('12374','2013-05-22','18:30:00',2.09),('12374','2013-05-22','18:35:00',2.02),('12374','2013-05-22','18:40:00',1.91),('12374','2013-05-22','18:45:00',1.72),('12374','2013-05-22','18:50:00',1.6),('12374','2013-05-22','18:55:00',1.47),('12374','2013-05-22','19:00:00',1.3),('12374','2013-05-22','19:05:00',1.21),('12374','2013-05-21','06:45:00',1.11),('12374','2013-05-21','06:50:00',1.14),('12374','2013-05-21','06:55:00',1.31),('12374','2013-05-21','07:00:00',1.48),('12374','2013-05-21','07:05:00',1.61),('12374','2013-05-21','07:10:00',1.73),('12374','2013-05-21','07:15:00',1.74),('12374','2013-05-21','07:20:00',2.2),('12374','2013-05-21','07:25:00',2.35),('12374','2013-05-21','07:30:00',2.52),('12374','2013-05-21','07:35:00',2.68),('12374','2013-05-21','07:40:00',2.87),('12374','2013-05-21','07:45:00',3.16),('12374','2013-05-21','07:50:00',3.56),('12374','2013-05-21','07:55:00',3.74),('12374','2013-05-21','08:00:00',3.96),('12374','2013-05-21','08:05:00',3.13),('12374','2013-05-21','08:10:00',2.25),('12374','2013-05-21','08:15:00',2.31),('12374','2013-05-21','08:20:00',2.51),('12374','2013-05-21','08:25:00',2.4),('12374','2013-05-21','08:30:00',2.05),('12374','2013-05-21','08:35:00',2.45),('12374','2013-05-21','08:40:00',3.38),('12374','2013-05-21','08:45:00',2.25),('12374','2013-05-21','08:50:00',2.03),('12374','2013-05-21','08:55:00',2.14),('12374','2013-05-21','09:00:00',2.55),('12374','2013-05-21','09:05:00',2.87),('12374','2013-05-21','09:10:00',2.81),('12374','2013-05-21','09:15:00',3.1),('12374','2013-05-21','09:20:00',3.52),('12374','2013-05-21','09:25:00',3.9),('12374','2013-05-21','09:30:00',3.45),('12374','2013-05-21','09:35:00',3.18),('12374','2013-05-21','09:40:00',2.69),('12374','2013-05-21','09:45:00',2.86),('12374','2013-05-21','09:50:00',5.03),('12374','2013-05-21','09:55:00',6.36),('12374','2013-05-21','10:00:00',4.45),('12374','2013-05-21','10:05:00',3.73),('12374','2013-05-21','10:10:00',3.47),('12374','2013-05-21','10:15:00',3.86),('12374','2013-05-21','10:20:00',5.88),('12374','2013-05-21','10:25:00',5.12),('12374','2013-05-21','10:30:00',5.77),('12374','2013-05-21','10:35:00',5.05),('12374','2013-05-21','10:40:00',4.32),('12374','2013-05-21','10:45:00',3.29),('12374','2013-05-21','10:50:00',2.93),('12374','2013-05-21','10:55:00',4.73),('12374','2013-05-21','11:00:00',5.5),('12374','2013-05-21','11:05:00',6.28),('12374','2013-05-21','11:10:00',7.6),('12374','2013-05-21','11:15:00',7.71),('12374','2013-05-21','11:20:00',8.37),('12374','2013-05-21','11:25:00',8.52),('12374','2013-05-21','11:30:00',8.14),('12374','2013-05-21','11:35:00',6.89),('12374','2013-05-21','11:40:00',3.3),('12374','2013-05-21','11:45:00',4.09),('12374','2013-05-21','11:50:00',9.37),('12374','2013-05-21','11:55:00',9.26),('12374','2013-05-21','12:00:00',8.23),('12374','2013-05-21','12:05:00',7.13),('12374','2013-05-21','12:10:00',3.46),('12374','2013-05-21','12:15:00',3.55),('12374','2013-05-21','12:20:00',4.63),('12374','2013-05-21','12:25:00',4.91),('12374','2013-05-21','12:30:00',6.2),('12374','2013-05-21','12:35:00',6.18),('12374','2013-05-21','12:40:00',6.67),('12374','2013-05-21','12:45:00',8.66),('12374','2013-05-21','12:50:00',9.12),('12374','2013-05-21','12:55:00',4.76),('12374','2013-05-21','13:00:00',4.58),('12374','2013-05-21','13:05:00',4.03),('12374','2013-05-21','13:10:00',5.02),('12374','2013-05-21','13:15:00',6.55),('12374','2013-05-21','13:20:00',6.61),('12374','2013-05-21','13:25:00',5.57),('12374','2013-05-21','13:30:00',3.91),('12374','2013-05-21','13:35:00',3.59),('12374','2013-05-21','13:40:00',2.41),('12374','2013-05-21','13:45:00',1.75),('12374','2013-05-21','13:50:00',1.63),('12374','2013-05-21','13:55:00',1.04),('12374','2013-05-21','14:25:00',1.85),('12374','2013-05-21','14:30:00',2.71),('12374','2013-05-21','14:35:00',3.23),('12374','2013-05-21','14:40:00',2.2),('12374','2013-05-21','14:45:00',1.31),('12374','2013-05-21','15:10:00',1.3),('12374','2013-05-21','15:15:00',1.51),('12374','2013-05-21','15:20:00',1.42),('12374','2013-05-21','15:25:00',1.62),('12374','2013-05-21','15:30:00',2),('12374','2013-05-21','15:35:00',1.4),('12374','2013-05-21','15:40:00',1.45),('12374','2013-05-21','15:45:00',2.73),('12374','2013-05-21','15:50:00',3.87),('12374','2013-05-21','15:55:00',2.84),('12374','2013-05-21','16:00:00',1.8),('12374','2013-05-21','16:05:00',1.78),('12374','2013-05-21','16:10:00',1.71),('12374','2013-05-21','16:15:00',1.93),('12374','2013-05-21','16:20:00',1.45),('12374','2013-05-21','16:25:00',1.35),('12374','2013-05-21','16:30:00',1.04),('12374','2013-05-21','16:50:00',1.13),('12374','2013-05-21','16:55:00',1.37),('12374','2013-05-20','07:25:00',1.25),('12374','2013-05-20','07:30:00',1.89),('12374','2013-05-20','07:35:00',2.69),('12374','2013-05-20','07:40:00',2.87),('12374','2013-05-20','07:45:00',3.03),('12374','2013-05-20','07:50:00',3.19),('12374','2013-05-20','07:55:00',3.38),('12374','2013-05-20','08:00:00',3.58),('12374','2013-05-20','08:05:00',3.75),('12374','2013-05-20','08:10:00',3.9),('12374','2013-05-20','08:15:00',4.1),('12374','2013-05-20','08:20:00',4.27),('12374','2013-05-20','08:25:00',4.41),('12374','2013-05-20','08:30:00',4.55),('12374','2013-05-20','08:35:00',4.65),('12374','2013-05-20','08:40:00',4.81),('12374','2013-05-20','08:45:00',4.92),('12374','2013-05-20','08:50:00',5.08),('12374','2013-05-20','08:55:00',5.27),('12374','2013-05-20','09:00:00',5.41),('12374','2013-05-20','09:05:00',5.56),('12374','2013-05-20','09:10:00',5.72),('12374','2013-05-20','09:15:00',5.78),('12374','2013-05-20','09:20:00',5.97),('12374','2013-05-20','09:25:00',6.13),('12374','2013-05-20','09:30:00',6.29),('12374','2013-05-20','09:35:00',6.67),('12374','2013-05-20','09:40:00',7),('12374','2013-05-20','09:45:00',6.88),('12374','2013-05-20','09:50:00',1.97),('12374','2013-05-20','09:55:00',1.4),('12374','2013-05-20','10:00:00',5.88),('12374','2013-05-20','10:05:00',5.16),('12374','2013-05-20','10:10:00',7.47),('12374','2013-05-20','10:15:00',7.54),('12374','2013-05-20','10:20:00',7.59),('12374','2013-05-20','10:25:00',7.68),('12374','2013-05-20','10:30:00',7.53),('12374','2013-05-20','10:35:00',7.84),('12374','2013-05-20','10:40:00',7.99),('12374','2013-05-20','10:45:00',8.1),('12374','2013-05-20','10:50:00',8.18),('12374','2013-05-20','10:55:00',8.26),('12374','2013-05-20','11:00:00',8.36),('12374','2013-05-20','11:05:00',8.43),('12374','2013-05-20','11:10:00',8.49),('12374','2013-05-20','11:15:00',8.61),('12374','2013-05-20','11:20:00',8.67),('12374','2013-05-20','11:25:00',8.73),('12374','2013-05-20','11:30:00',8.81),('12374','2013-05-20','11:35:00',8.87),('12374','2013-05-20','11:40:00',8.91),('12374','2013-05-20','11:45:00',9.04),('12374','2013-05-20','11:50:00',9.13),('12374','2013-05-20','11:55:00',9.14),('12374','2013-05-20','12:00:00',9.18),('12374','2013-05-20','12:05:00',9.19),('12374','2013-05-20','12:10:00',9.2),('12374','2013-05-20','12:15:00',9.21),('12374','2013-05-20','12:20:00',9.28),('12374','2013-05-20','12:25:00',9.34),('12374','2013-05-20','12:30:00',9.34),('12374','2013-05-20','12:35:00',9.38),('12374','2013-05-20','12:40:00',9.37),('12374','2013-05-20','12:45:00',9.33),('12374','2013-05-20','12:50:00',9.37),('12374','2013-05-20','12:55:00',9.4),('12374','2013-05-20','13:00:00',9.37),('12374','2013-05-20','13:05:00',9.36),('12374','2013-05-20','13:10:00',9.38),('12374','2013-05-20','13:15:00',9.38),('12374','2013-05-20','13:20:00',9.3),('12374','2013-05-20','13:25:00',9.24),('12374','2013-05-20','13:30:00',9.24),('12374','2013-05-20','13:35:00',9.24),('12374','2013-05-20','13:40:00',9.32),('12374','2013-05-20','13:45:00',9.3),('12374','2013-05-20','13:50:00',9.29),('12374','2013-05-20','13:55:00',9.26),('12374','2013-05-20','14:00:00',9.23),('12374','2013-05-20','14:05:00',9.18),('12374','2013-05-20','14:10:00',9.11),('12374','2013-05-20','14:15:00',9.04),('12374','2013-05-20','14:20:00',8.99),('12374','2013-05-20','14:25:00',8.93),('12374','2013-05-20','14:30:00',8.85),('12374','2013-05-20','14:35:00',8.76),('12374','2013-05-20','14:40:00',8.73),('12374','2013-05-20','14:45:00',8.65),('12374','2013-05-20','14:50:00',8.56),('12374','2013-05-20','14:55:00',8.38),('12374','2013-05-20','15:00:00',8.29),('12374','2013-05-20','15:05:00',8.26),('12374','2013-05-20','15:10:00',8.09),('12374','2013-05-20','15:15:00',8.03),('12374','2013-05-20','15:20:00',7.93),('12374','2013-05-20','15:25:00',7.84),('12374','2013-05-20','15:30:00',7.81),('12374','2013-05-20','15:35:00',7.64),('12374','2013-05-20','15:40:00',7.56),('12374','2013-05-20','15:45:00',7.48),('12374','2013-05-20','15:50:00',7.22),('12374','2013-05-20','15:55:00',7.15),('12374','2013-05-20','16:00:00',7.16),('12374','2013-05-20','16:05:00',5.93),('12374','2013-05-20','16:10:00',5.23),('12374','2013-05-20','16:15:00',3.69),('12374','2013-05-20','16:20:00',3.97),('12374','2013-05-20','16:25:00',3.47),('12374','2013-05-20','16:30:00',4.47),('12374','2013-05-20','16:35:00',5.95),('12374','2013-05-20','16:40:00',4.95),('12374','2013-05-20','16:45:00',3.48),('12374','2013-05-20','16:50:00',1.91),('12374','2013-05-20','16:55:00',1.97),('12374','2013-05-20','17:00:00',2.35),('12374','2013-05-20','17:05:00',3.32),('12374','2013-05-20','17:10:00',6.33),('12374','2013-05-20','17:15:00',5.15),('12374','2013-05-20','17:20:00',2.91),('12374','2013-05-20','17:25:00',4.55),('12374','2013-05-20','17:30:00',4.2),('12374','2013-05-20','17:35:00',4.03),('12374','2013-05-20','17:40:00',3.92),('12374','2013-05-20','17:45:00',3.74),('12374','2013-05-20','17:50:00',3.6),('12374','2013-05-20','17:55:00',3.09),('12374','2013-05-20','18:00:00',3.71),('12374','2013-05-20','18:05:00',2.65),('12374','2013-05-20','18:10:00',2.54),('12374','2013-05-20','18:15:00',2.52),('12374','2013-05-20','18:20:00',2.3),('12374','2013-05-20','18:25:00',2.16),('12374','2013-05-20','18:30:00',1.97),('12374','2013-05-20','18:35:00',1.89),('12374','2013-05-20','18:40:00',1.71),('12374','2013-05-20','18:45:00',1.63),('12374','2013-05-20','18:50:00',1.55),('12374','2013-05-20','18:55:00',1.46),('12374','2013-05-20','19:00:00',1.38),('12374','2013-05-20','19:05:00',1.22),('12374','2013-05-20','19:10:00',1.05),('12374','2013-05-19','07:35:00',1.17),('12374','2013-05-19','07:40:00',1.17),('12374','2013-05-19','07:45:00',1.15),('12374','2013-05-19','07:50:00',1.26),('12374','2013-05-19','07:55:00',1.48),('12374','2013-05-19','08:00:00',1.61),('12374','2013-05-19','08:05:00',1.9),('12374','2013-05-19','08:10:00',1.9),('12374','2013-05-19','08:15:00',2.39),('12374','2013-05-19','08:20:00',2.48),('12374','2013-05-19','08:25:00',3.85),('12374','2013-05-19','08:30:00',4.33),('12374','2013-05-19','08:35:00',4.18),('12374','2013-05-19','08:40:00',4.51),('12374','2013-05-19','08:45:00',4.7),('12374','2013-05-19','08:50:00',5.17),('12374','2013-05-19','08:55:00',5.19),('12374','2013-05-19','09:00:00',5.28),('12374','2013-05-19','09:05:00',5.53),('12374','2013-05-19','09:10:00',5.49),('12374','2013-05-19','09:15:00',5.62),('12374','2013-05-19','09:20:00',6.19),('12374','2013-05-19','09:25:00',5.16),('12374','2013-05-19','09:30:00',4.28),('12374','2013-05-19','09:35:00',5.7),('12374','2013-05-19','09:40:00',6.39),('12374','2013-05-19','09:45:00',6.54),('12374','2013-05-19','09:50:00',6.69),('12374','2013-05-19','09:55:00',6.85),('12374','2013-05-19','10:00:00',6.96),('12374','2013-05-19','10:05:00',7.07),('12374','2013-05-19','10:10:00',7.19),('12374','2013-05-19','10:15:00',7.32),('12374','2013-05-19','10:20:00',7.45),('12374','2013-05-19','10:25:00',7.55),('12374','2013-05-19','10:30:00',7.69),('12374','2013-05-19','10:35:00',7.93),('12374','2013-05-19','10:40:00',7.91),('12374','2013-05-19','10:45:00',8.02),('12374','2013-05-19','10:50:00',8.14),('12374','2013-05-19','10:55:00',8.27),('12374','2013-05-19','11:00:00',8.33),('12374','2013-05-19','11:05:00',8.48),('12374','2013-05-19','11:10:00',8.59),('12374','2013-05-19','11:15:00',8.73),('12374','2013-05-19','11:20:00',8.8),('12374','2013-05-19','11:25:00',8.56),('12374','2013-05-19','11:30:00',8.18),('12374','2013-05-19','11:35:00',9.05),('12374','2013-05-19','11:40:00',6.27),('12374','2013-05-19','11:45:00',7.26),('12374','2013-05-19','11:50:00',6.67),('12374','2013-05-19','11:55:00',6.82),('12374','2013-05-19','12:00:00',8.19),('12374','2013-05-19','12:05:00',7.61),('12374','2013-05-19','12:10:00',8.41),('12374','2013-05-19','12:15:00',9.7),('12374','2013-05-19','12:20:00',9.54),('12374','2013-05-19','12:25:00',9.41),('12374','2013-05-19','12:30:00',9.44),('12374','2013-05-19','12:35:00',9.46),('12374','2013-05-19','12:40:00',9.43),('12374','2013-05-19','12:45:00',9.5),('12374','2013-05-19','12:50:00',9.46),('12374','2013-05-19','12:55:00',9.53),('12374','2013-05-19','13:00:00',9.47),('12374','2013-05-19','13:05:00',9.49),('12374','2013-05-19','13:10:00',9.48),('12374','2013-05-19','13:15:00',9.47),('12374','2013-05-19','13:20:00',9.4),('12374','2013-05-19','13:25:00',9.46),('12374','2013-05-19','13:30:00',9.49),('12374','2013-05-19','13:35:00',9.43),('12374','2013-05-19','13:40:00',9.42),('12374','2013-05-19','13:45:00',9.43),('12374','2013-05-19','13:50:00',9.35),('12374','2013-05-19','13:55:00',9.36),('12374','2013-05-19','14:00:00',9.37),('12374','2013-05-19','14:05:00',9.33),('12374','2013-05-19','14:10:00',9.32),('12374','2013-05-19','14:15:00',9.27),('12374','2013-05-19','14:20:00',9.22),('12374','2013-05-19','14:25:00',9.11),('12374','2013-05-19','14:30:00',9.04),('12374','2013-05-19','14:35:00',9.03),('12374','2013-05-19','14:40:00',8.95),('12374','2013-05-19','14:45:00',8.9),('12374','2013-05-19','14:50:00',8.84),('12374','2013-05-19','14:55:00',8.75),('12374','2013-05-19','15:00:00',8.65),('12374','2013-05-19','15:05:00',8.53),('12374','2013-05-19','15:10:00',8.39),('12374','2013-05-19','15:15:00',8.27),('12374','2013-05-19','15:20:00',8.11),('12374','2013-05-19','15:25:00',8.04),('12374','2013-05-19','15:30:00',7.97),('12374','2013-05-19','15:35:00',7.82),('12374','2013-05-19','15:40:00',7.72),('12374','2013-05-19','15:45:00',7.6),('12374','2013-05-19','15:50:00',7.48),('12374','2013-05-19','15:55:00',7.36),('12374','2013-05-19','16:00:00',7.22),('12374','2013-05-19','16:05:00',7.12),('12374','2013-05-19','16:10:00',6.96),('12374','2013-05-19','16:15:00',6.82),('12374','2013-05-19','16:20:00',6.68),('12374','2013-05-19','16:25:00',6.53),('12374','2013-05-19','16:30:00',6.38),('12374','2013-05-19','16:35:00',6.24),('12374','2013-05-19','16:40:00',6.07),('12374','2013-05-19','16:45:00',5.92),('12374','2013-05-19','16:50:00',5.8),('12374','2013-05-19','16:55:00',5.61),('12374','2013-05-19','17:00:00',5.48),('12374','2013-05-19','17:05:00',5.32),('12374','2013-05-19','17:10:00',5.1),('12374','2013-05-19','17:15:00',5),('12374','2013-05-19','17:20:00',4.86),('12374','2013-05-19','17:25:00',4.65),('12374','2013-05-19','17:30:00',4.31),('12374','2013-05-19','17:35:00',4.14),('12374','2013-05-19','17:40:00',4.05),('12374','2013-05-19','17:45:00',3.78),('12374','2013-05-19','17:50:00',3.58),('12374','2013-05-19','17:55:00',3.39),('12374','2013-05-19','18:00:00',3.26),('12374','2013-05-19','18:05:00',3.06),('12374','2013-05-19','18:10:00',2.88),('12374','2013-05-19','18:15:00',2.59),('12374','2013-05-19','18:20:00',2.31),('12374','2013-05-19','18:25:00',2.26),('12374','2013-05-19','18:30:00',2.12),('12374','2013-05-19','18:35:00',2.01),('12374','2013-05-19','18:40:00',1.82),('12374','2013-05-19','18:45:00',1.7),('12374','2013-05-19','18:50:00',1.59),('12374','2013-05-19','18:55:00',1.52),('12374','2013-05-19','19:00:00',1.45),('12374','2013-05-19','19:05:00',1.36),('12374','2013-05-19','19:10:00',1.29),('12374','2013-05-19','19:15:00',1.21),('12374','2013-05-19','19:20:00',1.12),('12374','2013-05-19','19:25:00',1.04),('12374','2013-05-18','06:40:00',1),('12374','2013-05-18','06:45:00',1.14),('12374','2013-05-18','06:50:00',1.1),('12374','2013-05-18','06:55:00',1.38),('12374','2013-05-18','07:00:00',1.53),('12374','2013-05-18','07:05:00',1.66),('12374','2013-05-18','07:10:00',1.81),('12374','2013-05-18','07:15:00',1.71),('12374','2013-05-18','07:20:00',2.17),('12374','2013-05-18','07:25:00',2.35),('12374','2013-05-18','07:30:00',2.5),('12374','2013-05-18','07:35:00',2.62),('12374','2013-05-18','07:40:00',2.85),('12374','2013-05-18','07:45:00',3.04),('12374','2013-05-18','07:50:00',3.18),('12374','2013-05-18','07:55:00',3.33),('12374','2013-05-18','08:00:00',3.46),('12374','2013-05-18','08:05:00',3.7),('12374','2013-05-18','08:10:00',3.92),('12374','2013-05-18','08:15:00',4.07),('12374','2013-05-18','08:20:00',4.32),('12374','2013-05-18','08:25:00',4.15),('12374','2013-05-18','08:30:00',3.72),('12374','2013-05-18','08:35:00',4.44),('12374','2013-05-18','08:40:00',4.76),('12374','2013-05-18','08:45:00',5.32),('12374','2013-05-18','08:50:00',5.07),('12374','2013-05-18','08:55:00',5.43),('12374','2013-05-18','09:00:00',5.12),('12374','2013-05-18','09:05:00',5.86),('12374','2013-05-18','09:10:00',5.27),('12374','2013-05-18','09:15:00',5.91),('12374','2013-05-18','09:20:00',5.98),('12374','2013-05-18','09:25:00',6.11),('12374','2013-05-18','09:30:00',6.22),('12374','2013-05-18','09:35:00',6.37),('12374','2013-05-18','09:40:00',6.5),('12374','2013-05-18','09:45:00',6.6),('12374','2013-05-18','09:50:00',6.77),('12374','2013-05-18','09:55:00',6.87),('12374','2013-05-18','10:00:00',6.96),('12374','2013-05-18','10:05:00',7.06),('12374','2013-05-18','10:10:00',7.2),('12374','2013-05-18','10:15:00',7.52),('12374','2013-05-18','10:20:00',6.85),('12374','2013-05-18','10:25:00',6.26),('12374','2013-05-18','10:30:00',6.69),('12374','2013-05-18','10:35:00',7.8),('12374','2013-05-18','10:40:00',7.89),('12374','2013-05-18','10:45:00',8.07),('12374','2013-05-18','10:50:00',8.13),('12374','2013-05-18','10:55:00',4.7),('12374','2013-05-18','11:00:00',7.71),('12374','2013-05-18','11:05:00',7.47),('12374','2013-05-18','11:10:00',7.94),('12374','2013-05-18','11:15:00',8.6),('12374','2013-05-18','11:20:00',7.47),('12374','2013-05-18','11:25:00',3.15),('12374','2013-05-18','11:30:00',9.12),('12374','2013-05-18','11:35:00',8.78),('12374','2013-05-18','11:40:00',8.66),('12374','2013-05-18','11:45:00',8.74),('12374','2013-05-18','11:50:00',8.74),('12374','2013-05-18','11:55:00',8.73),('12374','2013-05-18','12:00:00',8.74),('12374','2013-05-18','12:05:00',8.82),('12374','2013-05-18','12:10:00',8.86),('12374','2013-05-18','12:15:00',8.72),('12374','2013-05-18','12:20:00',6.94),('12374','2013-05-18','12:25:00',8.41),('12374','2013-05-18','12:30:00',8.79),('12374','2013-05-18','12:35:00',3),('12374','2013-05-18','12:40:00',3.24),('12374','2013-05-18','12:45:00',9.65),('12374','2013-05-18','12:50:00',9.39),('12374','2013-05-18','12:55:00',9.09),('12374','2013-05-18','13:00:00',9.04),('12374','2013-05-18','13:05:00',9.07),('12374','2013-05-18','13:10:00',9.04),('12374','2013-05-18','13:15:00',9.03),('12374','2013-05-18','13:20:00',9.06),('12374','2013-05-18','13:25:00',8.8),('12374','2013-05-18','13:30:00',8.74),('12374','2013-05-18','13:35:00',9),('12374','2013-05-18','13:40:00',8.95),('12374','2013-05-18','13:45:00',8.93),('12374','2013-05-18','13:50:00',8.9),('12374','2013-05-18','13:55:00',8.87),('12374','2013-05-18','14:00:00',8.63),('12374','2013-05-18','14:05:00',7.42),('12374','2013-05-18','14:10:00',8.84),('12374','2013-05-18','14:15:00',8.85),('12374','2013-05-18','14:20:00',8.28),('12374','2013-05-18','14:25:00',7.39),('12374','2013-05-18','14:30:00',7.64),('12374','2013-05-18','14:35:00',8.05),('12374','2013-05-18','14:40:00',7.54),('12374','2013-05-18','14:45:00',8.29),('12374','2013-05-18','14:50:00',8.43),('12374','2013-05-18','14:55:00',6.81),('12374','2013-05-18','15:00:00',8.12),('12374','2013-05-18','15:05:00',7.92),('12374','2013-05-18','15:10:00',7.69),('12374','2013-05-18','15:15:00',7.42),('12374','2013-05-18','15:20:00',7.46),('12374','2013-05-18','15:25:00',7.37),('12374','2013-05-18','15:30:00',7.22),('12374','2013-05-18','15:35:00',7.13),('12374','2013-05-18','15:40:00',6.94),('12374','2013-05-18','15:45:00',6.83),('12374','2013-05-18','15:50:00',6.72),('12374','2013-05-18','15:55:00',6.6),('12374','2013-05-18','16:00:00',6.48),('12374','2013-05-18','16:05:00',6.36),('12374','2013-05-18','16:10:00',6.22),('12374','2013-05-18','16:15:00',5.97),('12374','2013-05-18','16:20:00',5.72),('12374','2013-05-18','16:25:00',5.81),('12374','2013-05-18','16:30:00',5.65),('12374','2013-05-18','16:35:00',5.52),('12374','2013-05-18','16:40:00',5.38),('12374','2013-05-18','16:45:00',5.21),('12374','2013-05-18','16:50:00',5.08),('12374','2013-05-18','16:55:00',4.9),('12374','2013-05-18','17:00:00',4.71),('12374','2013-05-18','17:05:00',4.56),('12374','2013-05-18','17:10:00',4.41),('12374','2013-05-18','17:15:00',4.27),('12374','2013-05-18','17:20:00',4.11),('12374','2013-05-18','17:25:00',3.93),('12374','2013-05-18','17:30:00',3.7),('12374','2013-05-18','17:35:00',3.49),('12374','2013-05-18','17:40:00',3.26),('12374','2013-05-18','17:45:00',3.08),('12374','2013-05-18','17:50:00',2.99),('12374','2013-05-18','17:55:00',2.83),('12374','2013-05-18','18:00:00',2.61),('12374','2013-05-18','18:05:00',2.53),('12374','2013-05-18','18:10:00',2.31),('12374','2013-05-18','18:15:00',2.19),('12374','2013-05-18','18:20:00',2.06),('12374','2013-05-18','18:25:00',1.91),('12374','2013-05-18','18:30:00',1.81),('12374','2013-05-18','18:35:00',1.72),('12374','2013-05-18','18:40:00',1.6),('12374','2013-05-18','18:45:00',1.5),('12374','2013-05-18','18:50:00',1.4),('12374','2013-05-18','18:55:00',1.3),('12374','2013-05-18','19:00:00',1.18),('12374','2013-05-18','19:05:00',1.05),('12374','2013-05-17','07:05:00',1.26),('12374','2013-05-17','07:10:00',1.07),('12374','2013-05-17','07:25:00',2.28),('12374','2013-05-17','07:30:00',1.3),('12374','2013-05-17','07:35:00',1.33),('12374','2013-05-17','07:40:00',1.82),('12374','2013-05-17','07:45:00',2.13),('12374','2013-05-17','07:50:00',4.13),('12374','2013-05-17','07:55:00',3.67),('12374','2013-05-17','08:00:00',1.17),('12374','2013-05-17','08:15:00',1.21),('12374','2013-05-17','08:55:00',1.24),('12374','2013-05-17','09:00:00',1.25),('12374','2013-05-17','09:05:00',1.14),('12374','2013-05-17','09:10:00',1.02),('12374','2013-05-17','09:20:00',1.38),('12374','2013-05-17','09:25:00',1.11),('12374','2013-05-17','09:30:00',1.31),('12374','2013-05-17','09:50:00',1),('12374','2013-05-17','09:55:00',1.69),('12374','2013-05-17','10:00:00',2.35),('12374','2013-05-17','10:05:00',2.6),('12374','2013-05-17','10:10:00',3.33),('12374','2013-05-17','10:15:00',3.27),('12374','2013-05-17','10:20:00',4.49),('12374','2013-05-17','10:25:00',4.18),('12374','2013-05-17','10:30:00',4.98),('12374','2013-05-17','10:35:00',6.14),('12374','2013-05-17','10:40:00',5.22),('12374','2013-05-17','10:45:00',5.02),('12374','2013-05-17','10:50:00',5.81),('12374','2013-05-17','10:55:00',5.43),('12374','2013-05-17','11:00:00',5.41),('12374','2013-05-17','11:05:00',7.31),('12374','2013-05-17','11:10:00',4.38),('12374','2013-05-17','11:15:00',5.12),('12374','2013-05-17','11:20:00',5.77),('12374','2013-05-17','11:25:00',5.81),('12374','2013-05-17','11:30:00',5.57),('12374','2013-05-17','11:35:00',5.82),('12374','2013-05-17','11:40:00',5.72),('12374','2013-05-17','11:45:00',4.82),('12374','2013-05-17','11:50:00',3.82),('12374','2013-05-17','11:55:00',4.27),('12374','2013-05-17','12:00:00',7.14),('12374','2013-05-17','12:05:00',8.37),('12374','2013-05-17','12:10:00',7.82),('12374','2013-05-17','12:15:00',5.6),('12374','2013-05-17','12:20:00',7.51),('12374','2013-05-17','12:25:00',8.82),('12374','2013-05-17','12:30:00',9.44),('12374','2013-05-17','12:35:00',8.66),('12374','2013-05-17','12:40:00',8.52),('12374','2013-05-17','12:45:00',8.32),('12374','2013-05-17','12:50:00',9.46),('12374','2013-05-17','12:55:00',9.48),('12374','2013-05-17','13:00:00',9.47),('12374','2013-05-17','13:05:00',9.48),('12374','2013-05-17','13:10:00',9.45),('12374','2013-05-17','13:15:00',9.45),('12374','2013-05-17','13:20:00',9.18),('12374','2013-05-17','13:25:00',9.05),('12374','2013-05-17','13:30:00',9.24),('12374','2013-05-17','13:35:00',9.31),('12374','2013-05-17','13:40:00',8.41),('12374','2013-05-17','13:45:00',8.95),('12374','2013-05-17','13:50:00',8.6),('12374','2013-05-17','13:55:00',7.61),('12374','2013-05-17','14:00:00',7.73),('12374','2013-05-17','14:05:00',9.27),('12374','2013-05-17','14:10:00',7.58),('12374','2013-05-17','14:15:00',8.02),('12374','2013-05-17','14:20:00',9.37),('12374','2013-05-17','14:25:00',8.65),('12374','2013-05-17','14:30:00',7.25),('12374','2013-05-17','14:35:00',6.47),('12374','2013-05-17','14:40:00',7.18),('12374','2013-05-17','14:45:00',8.69),('12374','2013-05-17','14:50:00',8.85),('12374','2013-05-17','14:55:00',8.6),('12374','2013-05-17','15:00:00',8.5),('12374','2013-05-17','15:05:00',8.39),('12374','2013-05-17','15:10:00',8.29),('12374','2013-05-17','15:15:00',8.19),('12374','2013-05-17','15:20:00',8.07),('12374','2013-05-17','15:25:00',7.97),('12374','2013-05-17','15:30:00',7.87),('12374','2013-05-17','15:35:00',7.74),('12374','2013-05-17','15:40:00',7.62),('12374','2013-05-17','15:45:00',7.48),('12374','2013-05-17','15:50:00',7.35),('12374','2013-05-17','15:55:00',7.22),('12374','2013-05-17','16:00:00',7.08),('12374','2013-05-17','16:05:00',6.95),('12374','2013-05-17','16:10:00',6.83),('12374','2013-05-17','16:15:00',6.67),('12374','2013-05-17','16:20:00',6.55),('12374','2013-05-17','16:25:00',6.41),('12374','2013-05-17','16:30:00',6.29),('12374','2013-05-17','16:35:00',6.15),('12374','2013-05-17','16:40:00',5.98),('12374','2013-05-17','16:45:00',5.8),('12374','2013-05-17','16:50:00',5.67),('12374','2013-05-17','16:55:00',5.52),('12374','2013-05-17','17:00:00',5.32),('12374','2013-05-17','17:05:00',5.16),('12374','2013-05-17','17:10:00',5.01),('12374','2013-05-17','17:15:00',4.87),('12374','2013-05-17','17:20:00',4.71),('12374','2013-05-17','17:25:00',4.55),('12374','2013-05-17','17:30:00',4.34),('12374','2013-05-17','17:35:00',4.04),('12374','2013-05-17','17:40:00',3.89),('12374','2013-05-17','17:45:00',3.6),('12374','2013-05-17','17:50:00',3.49),('12374','2013-05-17','17:55:00',3.26),('12374','2013-05-17','18:00:00',3.16),('12374','2013-05-17','18:05:00',2.93),('12374','2013-05-17','18:10:00',2.72),('12374','2013-05-17','18:15:00',2.44),('12374','2013-05-17','18:20:00',2.33),('12374','2013-05-17','18:25:00',2.1),('12374','2013-05-17','18:30:00',1.79),('12374','2013-05-17','18:35:00',1.32),('12374','2013-05-17','18:40:00',1.44),('12374','2013-05-17','18:45:00',1.59),('12374','2013-05-17','18:50:00',1.57),('12374','2013-05-17','18:55:00',1.48),('12374','2013-05-17','19:05:00',1),('12374','2013-05-17','19:10:00',1.02),('12374','2013-05-16','09:10:00',1.33),('12374','2013-05-16','09:20:00',2.09),('12374','2013-05-16','09:25:00',2.03),('12374','2013-05-16','09:30:00',2.75),('12374','2013-05-16','09:35:00',3.53),('12374','2013-05-16','09:40:00',3.85),('12374','2013-05-16','09:45:00',6.5),('12374','2013-05-16','09:50:00',6.86),('12374','2013-05-16','09:55:00',6.46),('12374','2013-05-16','10:00:00',2.53),('12374','2013-05-16','10:05:00',4.43),('12374','2013-05-16','10:10:00',4.25),('12374','2013-05-16','10:15:00',3.77),('12374','2013-05-16','10:20:00',3.65),('12374','2013-05-16','10:25:00',3.07),('12374','2013-05-16','10:30:00',1.68),('12374','2013-05-16','10:35:00',1.18),('12374','2013-05-16','10:40:00',1.46),('12374','2013-05-16','10:45:00',3.82),('12374','2013-05-16','10:55:00',2.1),('12374','2013-05-16','11:00:00',2.84),('12374','2013-05-16','11:05:00',1.95),('12374','2013-05-16','11:10:00',1.15),('12374','2013-05-16','11:15:00',1.12),('12374','2013-05-16','11:20:00',1.54),('12374','2013-05-16','11:25:00',2.41),('12374','2013-05-16','11:30:00',2.42),('12374','2013-05-16','11:35:00',2.22),('12374','2013-05-16','11:40:00',3.26),('12374','2013-05-16','11:45:00',3.34),('12374','2013-05-16','11:50:00',2.95),('12374','2013-05-16','11:55:00',2.72),('12374','2013-05-16','12:00:00',2.05),('12374','2013-05-16','12:05:00',2.13),('12374','2013-05-16','12:10:00',3.42),('12374','2013-05-16','12:15:00',3.34),('12374','2013-05-16','12:20:00',4.39),('12374','2013-05-16','12:25:00',4.17),('12374','2013-05-16','12:30:00',4.82),('12374','2013-05-16','12:35:00',4.54),('12374','2013-05-16','12:40:00',3.24),('12374','2013-05-16','12:45:00',4.36),('12374','2013-05-16','12:50:00',4.93),('12374','2013-05-16','12:55:00',8.45),('12374','2013-05-16','13:00:00',9.04),('12374','2013-05-16','13:05:00',8.88),('12374','2013-05-16','13:10:00',6.59),('12374','2013-05-16','13:15:00',6.97),('12374','2013-05-16','13:20:00',9.02),('12374','2013-05-16','13:25:00',8.86),('12374','2013-05-16','13:30:00',8.81),('12374','2013-05-16','13:35:00',8.68),('12374','2013-05-16','13:40:00',8.71),('12374','2013-05-16','13:45:00',8.66),('12374','2013-05-16','13:50:00',8.63),('12374','2013-05-16','13:55:00',8.56),('12374','2013-05-16','14:00:00',8.47),('12374','2013-05-16','14:05:00',8.4),('12374','2013-05-16','14:10:00',8.41),('12374','2013-05-16','14:15:00',8.3),('12374','2013-05-16','14:20:00',8.26),('12374','2013-05-16','14:25:00',8.18),('12374','2013-05-16','14:30:00',8.21),('12374','2013-05-16','14:35:00',8.15),('12374','2013-05-16','14:40:00',7.97),('12374','2013-05-16','14:45:00',7.95),('12374','2013-05-16','14:50:00',7.88),('12374','2013-05-16','14:55:00',7.78),('12374','2013-05-16','15:00:00',7.69),('12374','2013-05-16','15:05:00',7.54),('12374','2013-05-16','15:10:00',7.48),('12374','2013-05-16','15:15:00',7.38),('12374','2013-05-16','15:20:00',7.26),('12374','2013-05-16','15:25:00',7.18),('12374','2013-05-16','15:30:00',7.03),('12374','2013-05-16','15:35:00',6.92),('12374','2013-05-16','15:40:00',6.8),('12374','2013-05-16','15:45:00',6.68),('12374','2013-05-16','15:50:00',6.39),('12374','2013-05-16','15:55:00',6.38),('12374','2013-05-16','16:00:00',6.2),('12374','2013-05-16','16:05:00',5.92),('12374','2013-05-16','16:10:00',6),('12374','2013-05-16','16:15:00',5.78),('12374','2013-05-16','16:20:00',5.75),('12374','2013-05-16','16:25:00',5.56),('12374','2013-05-16','16:30:00',5.35),('12374','2013-05-16','16:35:00',5.25),('12374','2013-05-16','16:40:00',5.09),('12374','2013-05-16','16:45:00',4.94),('12374','2013-05-16','16:50:00',3.77),('12374','2013-05-16','16:55:00',3.89),('12374','2013-05-16','17:00:00',3.15),('12374','2013-05-16','17:05:00',3.39),('12374','2013-05-16','17:10:00',3.69),('12374','2013-05-16','17:15:00',3.97),('12374','2013-05-16','17:20:00',4.14),('12374','2013-05-16','17:25:00',3.33),('12374','2013-05-16','17:30:00',3.05),('12374','2013-05-16','17:35:00',3.28),('12374','2013-05-16','17:40:00',3.4),('12374','2013-05-16','17:45:00',3.43),('12374','2013-05-16','17:50:00',2.91),('12374','2013-05-16','17:55:00',2.71),('12374','2013-05-16','18:00:00',2.66),('12374','2013-05-16','18:05:00',2.4),('12374','2013-05-16','18:10:00',1.71),('12374','2013-05-16','18:15:00',1.25),('12374','2013-05-15','07:00:00',1.04),('12374','2013-05-15','07:05:00',1.34),('12374','2013-05-15','07:10:00',1.59),('12374','2013-05-15','07:15:00',1.7),('12374','2013-05-15','07:20:00',2.56),('12374','2013-05-15','07:25:00',2.29),('12374','2013-05-15','07:30:00',2.68),('12374','2013-05-15','07:35:00',2.7),('12374','2013-05-15','07:40:00',2.9),('12374','2013-05-15','07:45:00',2.75),('12374','2013-05-15','07:50:00',3.02),('12374','2013-05-15','07:55:00',3.04),('12374','2013-05-15','08:00:00',3.6),('12374','2013-05-15','08:05:00',3.64),('12374','2013-05-15','08:10:00',3.87),('12374','2013-05-15','08:15:00',4.04),('12374','2013-05-15','08:20:00',4.23),('12374','2013-05-15','08:25:00',4.36),('12374','2013-05-15','08:30:00',4.47),('12374','2013-05-15','08:35:00',4.57),('12374','2013-05-15','08:40:00',4.75),('12374','2013-05-15','08:45:00',4.93),('12374','2013-05-15','08:50:00',4.95),('12374','2013-05-15','08:55:00',5.22),('12374','2013-05-15','09:00:00',5.26),('12374','2013-05-15','09:05:00',5.35),('12374','2013-05-15','09:10:00',5.44),('12374','2013-05-15','09:15:00',5.62),('12374','2013-05-15','09:20:00',5.95),('12374','2013-05-15','09:25:00',5.98),('12374','2013-05-15','09:30:00',5.86),('12374','2013-05-15','09:35:00',6.14),('12374','2013-05-15','09:40:00',6.44),('12374','2013-05-15','09:45:00',6.6),('12374','2013-05-15','09:50:00',6.7),('12374','2013-05-15','09:55:00',6.66),('12374','2013-05-15','10:00:00',6.9),('12374','2013-05-15','10:05:00',7.04),('12374','2013-05-15','10:10:00',7.18),('12374','2013-05-15','10:15:00',7.3),('12374','2013-05-15','10:20:00',7.39),('12374','2013-05-15','10:25:00',7.38),('12374','2013-05-15','10:30:00',7.5),('12374','2013-05-15','10:35:00',7.66),('12374','2013-05-15','10:40:00',7.71),('12374','2013-05-15','10:45:00',7.69),('12374','2013-05-15','10:50:00',7.99),('12374','2013-05-15','10:55:00',8.1),('12374','2013-05-15','11:00:00',7.93),('12374','2013-05-15','11:05:00',8.29),('12374','2013-05-15','11:10:00',8.17),('12374','2013-05-15','11:15:00',8.23),('12374','2013-05-15','11:20:00',8.71),('12374','2013-05-15','11:25:00',8.81),('12374','2013-05-15','11:30:00',9),('12374','2013-05-15','11:35:00',7.46),('12374','2013-05-15','11:40:00',8.52),('12374','2013-05-15','11:45:00',8.96),('12374','2013-05-15','11:50:00',8.45),('12374','2013-05-15','11:55:00',8.04),('12374','2013-05-15','12:00:00',7.03),('12374','2013-05-15','12:05:00',6.32),('12374','2013-05-15','12:10:00',8.07),('12374','2013-05-15','12:15:00',8.57),('12374','2013-05-15','12:20:00',7.3),('12374','2013-05-15','12:25:00',6.23),('12374','2013-05-15','12:30:00',5.31),('12374','2013-05-15','12:35:00',4.22),('12374','2013-05-15','12:40:00',3.92),('12374','2013-05-15','12:45:00',3.77),('12374','2013-05-15','12:50:00',3.76),('12374','2013-05-15','12:55:00',3.69),('12374','2013-05-15','13:00:00',3.73),('12374','2013-05-15','13:05:00',4.02),('12374','2013-05-15','13:10:00',4.55),('12374','2013-05-15','13:15:00',5.32),('12374','2013-05-15','13:20:00',5.54),('12374','2013-05-15','13:25:00',5.18),('12374','2013-05-15','13:30:00',4.69),('12374','2013-05-15','13:35:00',4.16),('12374','2013-05-15','13:40:00',4.16),('12374','2013-05-15','13:45:00',4.29),('12374','2013-05-15','13:50:00',3.41),('12374','2013-05-15','13:55:00',2.9),('12374','2013-05-15','14:00:00',3.15),('12374','2013-05-15','14:05:00',3.64),('12374','2013-05-15','14:10:00',4.14),('12374','2013-05-15','14:15:00',3.78),('12374','2013-05-15','14:20:00',3.44),('12374','2013-05-15','14:25:00',3.29),('12374','2013-05-15','14:30:00',3.29),('12374','2013-05-15','14:35:00',3.33),('12374','2013-05-15','14:40:00',3.05),('12374','2013-05-15','14:45:00',2.84),('12374','2013-05-15','14:50:00',2.76),('12374','2013-05-15','14:55:00',2.41),('12374','2013-05-15','15:00:00',2.2),('12374','2013-05-15','15:05:00',2.09),('12374','2013-05-15','15:10:00',2.15),('12374','2013-05-15','15:15:00',2.05),('12374','2013-05-15','15:20:00',2.13),('12374','2013-05-15','15:25:00',2.45),('12374','2013-05-15','15:30:00',2.71),('12374','2013-05-15','15:35:00',2.63),('12374','2013-05-15','15:40:00',3.58),('12374','2013-05-15','15:45:00',5.36),('12374','2013-05-15','15:50:00',6.39),('12374','2013-05-15','15:55:00',6.38),('12374','2013-05-15','16:00:00',7.09),('12374','2013-05-15','16:05:00',4.83),('12374','2013-05-15','16:10:00',3.76),('12374','2013-05-15','16:15:00',3.38),('12374','2013-05-15','16:20:00',4.22),('12374','2013-05-15','16:25:00',4.73),('12374','2013-05-15','16:30:00',5.08),('12374','2013-05-15','16:35:00',3.79),('12374','2013-05-15','16:40:00',3.35),('12374','2013-05-15','16:45:00',4.82),('12374','2013-05-15','16:50:00',4.68),('12374','2013-05-15','16:55:00',3.83),('12374','2013-05-15','17:00:00',4.54),('12374','2013-05-15','17:05:00',5.25),('12374','2013-05-15','17:10:00',5.62),('12374','2013-05-15','17:15:00',3.41),('12374','2013-05-15','17:20:00',2.21),('12374','2013-05-15','17:25:00',1.79),('12374','2013-05-15','17:30:00',1.54),('12374','2013-05-15','17:35:00',1.35),('12374','2013-05-15','17:40:00',1.01),('12374','2013-05-15','18:40:00',1.09),('12374','2013-05-15','18:45:00',1.1),('12374','2013-05-14','06:40:00',1.06),('12374','2013-05-14','06:45:00',1.18),('12374','2013-05-14','06:50:00',1.26),('12374','2013-05-14','06:55:00',1.19),('12374','2013-05-14','07:00:00',1.51),('12374','2013-05-14','07:05:00',1.68),('12374','2013-05-14','07:10:00',1.76),('12374','2013-05-14','07:15:00',2),('12374','2013-05-14','07:20:00',1.87),('12374','2013-05-14','07:25:00',2.38),('12374','2013-05-14','07:30:00',2.55),('12374','2013-05-14','07:35:00',2.72),('12374','2013-05-14','07:41:00',2.87),('12374','2013-05-14','07:45:00',3.09),('12374','2013-05-14','07:50:00',3.25),('12374','2013-05-14','07:55:00',3.42),('12374','2013-05-14','08:00:00',3.58),('12374','2013-05-14','08:05:00',3.75),('12374','2013-05-14','08:10:00',3.92),('12374','2013-05-14','08:15:00',4.07),('12374','2013-05-14','08:20:00',4.21),('12374','2013-05-14','08:25:00',4.36),('12374','2013-05-14','08:30:00',4.5),('12374','2013-05-14','08:35:00',4.66),('12374','2013-05-14','08:40:00',4.77),('12374','2013-05-14','08:45:00',4.96),('12374','2013-05-14','08:50:00',5.09),('12374','2013-05-14','08:55:00',5.25),('12374','2013-05-14','09:00:00',5.4),('12374','2013-05-14','09:05:00',5.54),('12374','2013-05-14','09:10:00',5.68),('12374','2013-05-14','09:15:00',5.81),('12374','2013-05-14','09:20:00',5.96),('12374','2013-05-14','09:25:00',6.1),('12374','2013-05-14','09:30:00',6.2),('12374','2013-05-14','09:35:00',6.36),('12374','2013-05-14','09:40:00',6.46),('12374','2013-05-14','09:45:00',6.54),('12374','2013-05-14','09:50:00',6.71),('12374','2013-05-14','09:55:00',6.84),('12374','2013-05-14','10:00:00',6.96),('12374','2013-05-14','10:05:00',7.08),('12374','2013-05-14','10:10:00',7.2),('12374','2013-05-14','10:15:00',7.32),('12374','2013-05-14','10:20:00',7.37),('12374','2013-05-14','10:25:00',7.48),('12374','2013-05-14','10:30:00',7.58),('12374','2013-05-14','10:35:00',7.71),('12374','2013-05-14','10:40:00',7.8),('12374','2013-05-14','10:45:00',7.87),('12374','2013-05-14','10:50:00',7.96),('12374','2013-05-14','10:55:00',8.04),('12374','2013-05-14','11:00:00',8.15),('12374','2013-05-14','11:05:00',8.15),('12374','2013-05-14','11:10:00',8.3),('12374','2013-05-14','11:15:00',8.44),('12374','2013-05-14','11:20:00',8.57),('12374','2013-05-14','11:25:00',8.67),('12374','2013-05-14','11:30:00',8.73),('12374','2013-05-14','11:35:00',8.79),('12374','2013-05-14','11:40:00',8.88),('12374','2013-05-14','11:45:00',8.95),('12374','2013-05-14','11:50:00',9),('12374','2013-05-14','11:55:00',9.04),('12374','2013-05-14','12:00:00',9.08),('12374','2013-05-14','12:05:00',9.07),('12374','2013-05-14','12:10:00',9.11),('12374','2013-05-14','12:15:00',9.13),('12374','2013-05-14','12:20:00',9.17),('12374','2013-05-14','12:25:00',9.15),('12374','2013-05-14','12:30:00',9.2),('12374','2013-05-14','12:35:00',9.22),('12374','2013-05-14','12:40:00',9.2),('12374','2013-05-14','12:45:00',9.28),('12374','2013-05-14','12:50:00',9.27),('12374','2013-05-14','12:55:00',9.25),('12374','2013-05-14','13:00:00',9.22),('12374','2013-05-14','13:05:00',9.22),('12374','2013-05-14','13:10:00',9.2),('12374','2013-05-14','13:15:00',9.26),('12374','2013-05-14','13:20:00',9.26),('12374','2013-05-14','13:25:00',9.22),('12374','2013-05-14','13:30:00',9.1),('12374','2013-05-14','13:35:00',9.14),('12374','2013-05-14','13:40:00',9.17),('12374','2013-05-14','13:45:00',9.13),('12374','2013-05-14','13:50:00',9.05),('12374','2013-05-14','13:55:00',8.85),('12374','2013-05-14','14:00:00',8.83),('12374','2013-05-14','14:05:00',8.86),('12374','2013-05-14','14:10:00',9.02),('12374','2013-05-14','14:15:00',9),('12374','2013-05-14','14:20:00',8.94),('12374','2013-05-14','14:25:00',8.87),('12374','2013-05-14','14:30:00',8.77),('12374','2013-05-14','14:35:00',8.68),('12374','2013-05-14','14:40:00',8.65),('12374','2013-05-14','14:45:00',8.61),('12374','2013-05-14','14:50:00',8.5),('12374','2013-05-14','14:55:00',8.42),('12374','2013-05-14','15:00:00',8.31),('12374','2013-05-14','15:05:00',8.25),('12374','2013-05-14','15:10:00',8.16),('12374','2013-05-14','15:15:00',8.05),('12374','2013-05-14','15:20:00',7.97),('12374','2013-05-14','15:25:00',7.87),('12374','2013-05-14','15:30:00',7.75),('12374','2013-05-14','15:35:00',7.62),('12374','2013-05-14','15:40:00',7.49),('12374','2013-05-14','15:45:00',7.37),('12374','2013-05-14','15:50:00',7.25),('12374','2013-05-14','15:55:00',7.13),('12374','2013-05-14','16:00:00',6.95),('12374','2013-05-14','16:05:00',6.77),('12374','2013-05-14','16:10:00',6.69),('12374','2013-05-14','16:15:00',6.6),('12374','2013-05-14','16:20:00',6.47),('12374','2013-05-14','16:25:00',6.33),('12374','2013-05-14','16:30:00',6.2),('12374','2013-05-14','16:35:00',6.05),('12374','2013-05-14','16:40:00',5.88),('12374','2013-05-14','16:45:00',5.66),('12374','2013-05-14','16:50:00',5.51),('12374','2013-05-14','16:55:00',5.37),('12374','2013-05-14','17:00:00',5.29),('12374','2013-05-14','17:05:00',5.13),('12374','2013-05-14','17:10:00',4.98),('12374','2013-05-14','17:15:00',4.77),('12374','2013-05-14','17:20:00',4.63),('12374','2013-05-14','17:25:00',4.41),('12374','2013-05-14','17:30:00',4.26),('12374','2013-05-14','17:35:00',4.03),('12374','2013-05-14','17:40:00',3.83),('12374','2013-05-14','17:45:00',3.54),('12374','2013-05-14','17:50:00',3.41),('12374','2013-05-14','17:55:00',3.19),('12374','2013-05-14','18:00:00',2.97),('12374','2013-05-14','18:05:00',2.82),('12374','2013-05-14','18:10:00',2.73),('12374','2013-05-14','18:15:00',2.51),('12374','2013-05-14','18:20:00',2.16),('12374','2013-05-14','18:25:00',2.09),('12374','2013-05-14','18:30:00',1.91),('12374','2013-05-14','18:35:00',1.78),('12374','2013-05-14','18:40:00',1.71),('12374','2013-05-14','18:45:00',1.57),('12374','2013-05-14','18:50:00',1.44),('12374','2013-05-14','18:55:00',1.39),('12374','2013-05-14','19:00:00',1.35),('12374','2013-05-14','19:05:00',1.28),('12374','2013-05-14','19:10:00',1.12),('12374','2013-05-14','19:15:00',1.09),('12374','2013-05-13','06:55:00',1.18),('12374','2013-05-13','07:00:00',1.19),('12374','2013-05-13','07:05:00',1.42),('12374','2013-05-13','07:10:00',1.64),('12374','2013-05-13','07:15:00',2.04),('12374','2013-05-13','07:20:00',1.99),('12374','2013-05-13','07:25:00',2.1),('12374','2013-05-13','07:30:00',2.36),('12374','2013-05-13','07:35:00',2.78),('12374','2013-05-13','07:40:00',2.44),('12374','2013-05-13','07:45:00',1.78),('12374','2013-05-13','07:50:00',3.19),('12374','2013-05-13','07:55:00',3.21),('12374','2013-05-13','08:00:00',3.28),('12374','2013-05-13','08:05:00',3.21),('12374','2013-05-13','08:10:00',3.41),('12374','2013-05-13','08:15:00',3.88),('12374','2013-05-13','08:20:00',4.07),('12374','2013-05-13','08:25:00',4.24),('12374','2013-05-13','08:30:00',4.41),('12374','2013-05-13','08:35:00',4.53),('12374','2013-05-13','08:40:00',4.65),('12374','2013-05-13','08:45:00',4.79),('12374','2013-05-13','08:50:00',4.98),('12374','2013-05-13','08:55:00',5.12),('12374','2013-05-13','09:00:00',5.3),('12374','2013-05-13','09:05:00',5.46),('12374','2013-05-13','09:10:00',5.62),('12374','2013-05-13','09:15:00',5.8),('12374','2013-05-13','09:20:00',6.04),('12374','2013-05-13','09:25:00',6.23),('12374','2013-05-13','09:30:00',6.31),('12374','2013-05-13','09:35:00',6.43),('12374','2013-05-13','09:40:00',6.71),('12374','2013-05-13','16:20:00',3.94),('12374','2013-05-13','16:25:00',6.27),('12374','2013-05-13','16:30:00',6.17),('12374','2013-05-13','16:35:00',6.03),('12374','2013-05-13','16:40:00',4.37),('12374','2013-05-13','16:45:00',5.63),('12374','2013-05-13','16:50:00',5.55),('12374','2013-05-13','16:55:00',5.42),('12374','2013-05-13','17:00:00',4.67),('12374','2013-05-13','17:05:00',4.39),('12374','2013-05-13','17:10:00',4.88),('12374','2013-05-13','17:15:00',4.75),('12374','2013-05-13','17:20:00',4.21),('12374','2013-05-13','17:25:00',3.75),('12374','2013-05-13','17:30:00',4.28),('12374','2013-05-13','17:35:00',4.02),('12374','2013-05-13','17:40:00',3.75),('12374','2013-05-13','17:45:00',3.18),('12374','2013-05-13','17:50:00',2.96),('12374','2013-05-13','17:55:00',1.53),('12374','2013-05-13','18:05:00',1.95),('12374','2013-05-13','18:10:00',2.27),('12374','2013-05-13','18:15:00',2.3),('12374','2013-05-13','18:20:00',2.38),('12374','2013-05-13','18:25:00',2.28),('12374','2013-05-13','18:30:00',1.85),('12374','2013-05-13','18:35:00',1.82),('12374','2013-05-13','18:40:00',1.92),('12374','2013-05-13','18:45:00',1.88),('12374','2013-05-13','18:50:00',1.81),('12374','2013-05-13','18:55:00',1.77),('12374','2013-05-13','19:00:00',1.6),('12374','2013-05-13','19:05:00',1.72),('12374','2013-05-13','19:10:00',1.53),('12374','2013-05-13','19:15:00',1.35),('12374','2013-05-13','19:20:00',1.18),('12374','2013-05-13','19:25:00',1.1),('12374','2013-05-12','07:05:00',1.02),('12374','2013-05-12','07:10:00',1.17),('12374','2013-05-12','07:15:00',1.13),('12374','2013-05-12','07:20:00',1.1),('12374','2013-05-12','07:25:00',1.07),('12374','2013-05-12','07:30:00',1.35),('12374','2013-05-12','07:35:00',1.53),('12374','2013-05-12','07:40:00',1.68),('12374','2013-05-12','07:45:00',2.05),('12374','2013-05-12','07:50:00',2.93),('12374','2013-05-12','07:55:00',2.3),('12374','2013-05-12','08:00:00',2.8),('12374','2013-05-12','08:05:00',3.33),('12374','2013-05-12','08:10:00',2.25),('12374','2013-05-12','08:15:00',2.03),('12374','2013-05-12','08:20:00',2.77),('12374','2013-05-12','08:25:00',4.39),('12374','2013-05-12','08:30:00',4.79),('12374','2013-05-12','08:35:00',4.91),('12374','2013-05-12','08:40:00',4.41),('12374','2013-05-12','08:45:00',5.17),('12374','2013-05-12','08:50:00',5.16),('12374','2013-05-12','08:55:00',5.8),('12374','2013-05-12','09:00:00',6.08),('12374','2013-05-12','09:05:00',6.54),('12374','2013-05-12','09:10:00',4.07),('12374','2013-05-12','09:15:00',3.32),('12374','2013-05-12','09:20:00',3.73),('12374','2013-05-12','09:25:00',2),('12374','2013-05-12','09:30:00',2.36),('12374','2013-05-12','09:35:00',6.52),('12374','2013-05-12','09:40:00',6.58),('12374','2013-05-12','09:45:00',6.64),('12374','2013-05-12','09:50:00',6.76),('12374','2013-05-12','09:55:00',6.87),('12374','2013-05-12','10:00:00',7.16),('12374','2013-05-12','10:05:00',7.32),('12374','2013-05-12','10:10:00',6.61),('12374','2013-05-12','10:15:00',7.64),('12374','2013-05-12','10:20:00',7.13),('12374','2013-05-12','10:25:00',7.55),('12374','2013-05-12','10:30:00',7.7),('12374','2013-05-12','10:35:00',7.83),('12374','2013-05-12','10:40:00',7.82),('12374','2013-05-12','10:45:00',7.95),('12374','2013-05-12','10:50:00',8.06),('12374','2013-05-12','10:55:00',7.76),('12374','2013-05-12','11:00:00',8.28),('12374','2013-05-12','11:05:00',8.3),('12374','2013-05-12','11:10:00',8.41),('12374','2013-05-12','11:15:00',8.43),('12374','2013-05-12','11:20:00',8.53),('12374','2013-05-12','11:25:00',8.67),('12374','2013-05-12','11:30:00',8.71),('12374','2013-05-12','11:35:00',8.76),('12374','2013-05-12','11:40:00',8.87),('12374','2013-05-12','11:45:00',8.9),('12374','2013-05-12','11:50:00',8.95),('12374','2013-05-12','11:55:00',8.99),('12374','2013-05-12','12:00:00',9.03),('12374','2013-05-12','12:05:00',9.1),('12374','2013-05-12','12:10:00',9.06),('12374','2013-05-12','12:15:00',9.08),('12374','2013-05-12','12:20:00',9.15),('12374','2013-05-12','12:25:00',9.19),('12374','2013-05-12','12:30:00',9.25),('12374','2013-05-12','12:35:00',9.28),('12374','2013-05-12','12:40:00',9.28),('12374','2013-05-12','12:45:00',9.29),('12374','2013-05-12','12:50:00',9.31),('12374','2013-05-12','12:55:00',9.28),('12374','2013-05-12','13:00:00',9.25),('12374','2013-05-12','13:05:00',9.23),('12374','2013-05-12','13:10:00',9.25),('12374','2013-05-12','13:15:00',9.27),('12374','2013-05-12','13:20:00',9.34),('12374','2013-05-12','13:25:00',9.28),('12374','2013-05-12','13:30:00',9.25),('12374','2013-05-12','13:35:00',9.27),('12374','2013-05-12','13:40:00',9.22),('12374','2013-05-12','13:45:00',9.11),('12374','2013-05-12','13:50:00',9.03),('12374','2013-05-12','13:55:00',9.02),('12374','2013-05-12','14:00:00',9.16),('12374','2013-05-12','14:05:00',9.1),('12374','2013-05-12','14:10:00',8.97),('12374','2013-05-12','14:15:00',9.03),('12374','2013-05-12','14:20:00',8.93),('12374','2013-05-12','14:25:00',8.91),('12374','2013-05-12','14:30:00',8.96),('12374','2013-05-12','14:35:00',8.79),('12374','2013-05-12','14:40:00',8.6),('12374','2013-05-12','14:45:00',8.57),('12374','2013-05-12','14:50:00',8.44),('12374','2013-05-12','14:55:00',8.39),('12374','2013-05-12','15:00:00',8.25),('12374','2013-05-12','15:05:00',8.15),('12374','2013-05-12','15:10:00',8.03),('12374','2013-05-12','15:15:00',7.86),('12374','2013-05-12','15:20:00',7.78),('12374','2013-05-12','15:25:00',7.71),('12374','2013-05-12','15:30:00',7.65),('12374','2013-05-12','15:35:00',7.59),('12374','2013-05-12','15:40:00',7.43),('12374','2013-05-12','15:45:00',6.86),('12374','2013-05-12','15:50:00',7.05),('12374','2013-05-12','15:55:00',6.52),('12374','2013-05-12','16:00:00',7.26),('12374','2013-05-12','16:05:00',6.94),('12374','2013-05-12','16:10:00',6.8),('12374','2013-05-12','16:15:00',6.7),('12374','2013-05-12','16:20:00',6.59),('12374','2013-05-12','16:25:00',6.36),('12374','2013-05-12','16:30:00',6.35),('12374','2013-05-12','16:35:00',5.97),('12374','2013-05-12','16:40:00',6.1),('12374','2013-05-12','16:45:00',5.33),('12374','2013-05-12','16:50:00',4.85),('12374','2013-05-12','16:55:00',5.64),('12374','2013-05-12','17:00:00',5.49),('12374','2013-05-12','17:05:00',5.67),('12374','2013-05-12','17:10:00',4.48),('12374','2013-05-12','17:15:00',4.94),('12374','2013-05-12','17:20:00',4.9),('12374','2013-05-12','17:25:00',4.84),('12374','2013-05-12','17:30:00',4.93),('12374','2013-05-12','17:35:00',4.91),('12374','2013-05-12','17:40:00',3.79),('12374','2013-05-12','17:45:00',4.43),('12374','2013-05-12','17:50:00',3.98),('12374','2013-05-12','17:55:00',3.64),('12374','2013-05-12','18:00:00',3.41),('12374','2013-05-12','18:05:00',3.13),('12374','2013-05-12','18:10:00',2.92),('12374','2013-05-12','18:15:00',2.9),('12374','2013-05-12','18:20:00',2.56),('12374','2013-05-12','18:25:00',2.5),('12374','2013-05-12','18:30:00',2.58),('12374','2013-05-12','18:35:00',2.69),('12374','2013-05-12','18:40:00',2.66),('12374','2013-05-12','18:45:00',2.5),('12374','2013-05-12','18:50:00',2.33),('12374','2013-05-12','18:55:00',1.89),('12374','2013-05-12','19:00:00',1.34),('12374','2013-05-12','19:05:00',1.26),('12374','2013-05-12','19:10:00',1.16),('12374','2013-05-12','19:15:00',1.15),('12374','2013-05-12','19:20:00',1.07),('12374','2013-05-12','19:25:00',1.02),('12374','2013-05-11','07:30:00',1.39),('12374','2013-05-11','07:35:00',1.85),('12374','2013-05-11','07:40:00',2.61),('12374','2013-05-11','07:45:00',2.91),('12374','2013-05-11','07:50:00',3.29),('12374','2013-05-11','07:55:00',3.83),('12374','2013-05-11','08:00:00',3.27),('12374','2013-05-11','08:05:00',3.79),('12374','2013-05-11','08:10:00',3.45),('12374','2013-05-11','08:15:00',2.22),('12374','2013-05-11','08:20:00',1.27),('12374','2013-05-11','08:25:00',2.25),('12374','2013-05-11','08:30:00',4.73),('12374','2013-05-11','08:35:00',4.14),('12374','2013-05-11','08:40:00',5.19),('12374','2013-05-11','08:45:00',3.77),('12374','2013-05-11','08:50:00',3.08),('12374','2013-05-11','08:55:00',4.72),('12374','2013-05-11','09:00:00',2.67),('12374','2013-05-11','09:05:00',3.1),('12374','2013-05-11','09:10:00',4.44),('12374','2013-05-11','09:15:00',6.02),('12374','2013-05-11','09:20:00',6.04),('12374','2013-05-11','09:25:00',5.95),('12374','2013-05-11','09:30:00',2.27),('12374','2013-05-11','09:35:00',1.17),('12374','2013-05-11','09:40:00',2.68),('12374','2013-05-11','09:45:00',6.14),('12374','2013-05-11','09:50:00',4.49),('12374','2013-05-11','09:55:00',4.74),('12374','2013-05-11','10:00:00',4.17),('12374','2013-05-11','10:05:00',6.24),('12374','2013-05-11','10:10:00',6.75),('12374','2013-05-11','10:15:00',7.8),('12374','2013-05-11','10:20:00',8.32),('12374','2013-05-11','10:25:00',7.97),('12374','2013-05-11','10:30:00',5.89),('12374','2013-05-11','10:35:00',5.46),('12374','2013-05-11','10:40:00',5.84),('12374','2013-05-11','10:45:00',5.6),('12374','2013-05-11','10:50:00',6.87),('12374','2013-05-11','10:55:00',8.06),('12374','2013-05-11','11:00:00',5.61),('12374','2013-05-11','11:05:00',8.83),('12374','2013-05-11','11:10:00',8.63),('12374','2013-05-11','11:15:00',8.58),('12374','2013-05-11','11:20:00',6.62),('12374','2013-05-11','11:25:00',8.97),('12374','2013-05-11','11:30:00',7.7),('12374','2013-05-11','11:35:00',4.85),('12374','2013-05-11','11:40:00',5.96),('12374','2013-05-11','11:45:00',5.89),('12374','2013-05-11','11:50:00',6.82),('12374','2013-05-11','11:55:00',7.52),('12374','2013-05-11','12:00:00',7.34),('12374','2013-05-11','12:05:00',7.06),('12374','2013-05-11','12:10:00',5.87),('12374','2013-05-11','12:15:00',6.14),('12374','2013-05-11','12:20:00',8.48),('12374','2013-05-11','12:25:00',8.32),('12374','2013-05-11','12:30:00',8.8),('12374','2013-05-11','12:35:00',8.02),('12374','2013-05-11','12:40:00',4.65),('12374','2013-05-11','12:45:00',4.12),('12374','2013-05-11','12:50:00',3.7),('12374','2013-05-11','12:55:00',4.35),('12374','2013-05-11','13:00:00',4.38),('12374','2013-05-11','13:05:00',5.32),('12374','2013-05-11','13:10:00',4.68),('12374','2013-05-11','13:15:00',5.87),('12374','2013-05-11','13:20:00',8.96),('12374','2013-05-11','13:25:00',6.88),('12374','2013-05-11','13:30:00',6.07),('12374','2013-05-11','13:35:00',5.88),('12374','2013-05-11','13:40:00',8.9),('12374','2013-05-11','13:45:00',9.51),('12374','2013-05-11','13:50:00',9.31),('12374','2013-05-11','13:55:00',9.16),('12374','2013-05-11','14:00:00',9.12),('12374','2013-05-11','14:05:00',9.18),('12374','2013-05-11','14:10:00',9.06),('12374','2013-05-11','14:15:00',9.02),('12374','2013-05-11','14:20:00',9),('12374','2013-05-11','14:25:00',8.92),('12374','2013-05-11','14:30:00',8.86),('12374','2013-05-11','14:35:00',8.79),('12374','2013-05-11','14:40:00',8.76),('12374','2013-05-11','14:45:00',8.18),('12374','2013-05-11','14:50:00',7.27),('12374','2013-05-11','14:55:00',8.79),('12374','2013-05-11','15:00:00',7.47),('12374','2013-05-11','15:05:00',7.93),('12374','2013-05-11','15:10:00',8.13),('12374','2013-05-11','15:15:00',7.62),('12374','2013-05-11','15:20:00',7.39),('12374','2013-05-11','15:25:00',5.72),('12374','2013-05-11','15:30:00',6.88),('12374','2013-05-11','15:35:00',7.39),('12374','2013-05-11','15:40:00',5.19),('12374','2013-05-11','15:45:00',6.06),('12374','2013-05-11','15:50:00',6.1),('12374','2013-05-11','15:55:00',6.61),('12374','2013-05-11','16:00:00',4.27),('12374','2013-05-11','16:05:00',6.18),('12374','2013-05-11','16:10:00',4.89),('12374','2013-05-11','16:15:00',5.88),('12374','2013-05-11','16:20:00',5.51),('12374','2013-05-11','16:25:00',5.07),('12374','2013-05-11','16:30:00',6.3),('12374','2013-05-11','16:35:00',5.56),('12374','2013-05-11','16:40:00',5.54),('12374','2013-05-11','16:45:00',5.74),('12374','2013-05-11','16:50:00',5.51),('12374','2013-05-11','16:55:00',4.95),('12374','2013-05-11','17:00:00',4.31),('12374','2013-05-11','17:05:00',4.74),('12374','2013-05-11','17:10:00',4.95),('12374','2013-05-11','17:15:00',4.7),('12374','2013-05-11','17:20:00',4.8),('12374','2013-05-11','17:25:00',4.49),('12374','2013-05-11','17:30:00',4.01),('12374','2013-05-11','17:35:00',2.78),('12374','2013-05-11','17:40:00',4.01),('12374','2013-05-11','17:45:00',3.41),('12374','2013-05-11','17:50:00',3.58),('12374','2013-05-11','17:55:00',3.15),('12374','2013-05-11','18:00:00',2.72),('12374','2013-05-11','18:05:00',2.99),('12374','2013-05-11','18:10:00',2.66),('12374','2013-05-11','18:15:00',2.49),('12374','2013-05-11','18:20:00',2.31),('12374','2013-05-11','18:25:00',2.16),('12374','2013-05-11','18:30:00',1.96),('12374','2013-05-11','18:35:00',1.95),('12374','2013-05-11','18:40:00',1.84),('12374','2013-05-11','18:45:00',1.68),('12374','2013-05-11','18:50:00',1.56),('12374','2013-05-11','18:55:00',1.62),('12374','2013-05-11','19:00:00',1.58),('12374','2013-05-11','19:05:00',1.57),('12374','2013-05-11','19:10:00',1.33),('12374','2013-05-11','19:15:00',1.12),('12374','2013-05-10','06:45:00',1.01),('12374','2013-05-10','06:50:00',1.13),('12374','2013-05-10','06:55:00',1.35),('12374','2013-05-10','07:00:00',1.18),('12374','2013-05-10','07:05:00',1.22),('12374','2013-05-10','07:10:00',1.58),('12374','2013-05-10','07:15:00',2.15),('12374','2013-05-10','07:20:00',2.38),('12374','2013-05-10','07:25:00',2.5),('12374','2013-05-10','07:30:00',2.24),('12374','2013-05-10','07:35:00',2.25),('12374','2013-05-10','07:40:00',1.77),('12374','2013-05-10','07:45:00',1.52),('12374','2013-05-10','07:50:00',1.84),('12374','2013-05-10','07:55:00',1.89),('12374','2013-05-10','08:00:00',1.52),('12374','2013-05-10','08:05:00',2.53),('12374','2013-05-10','08:10:00',3.64),('12374','2013-05-10','08:15:00',3.8),('12374','2013-05-10','08:20:00',3.41),('12374','2013-05-10','08:25:00',3.05),('12374','2013-05-10','08:30:00',4.27),('12374','2013-05-10','08:35:00',3.97),('12374','2013-05-10','08:40:00',4.32),('12374','2013-05-10','08:45:00',5.23),('12374','2013-05-10','08:50:00',4.64),('12374','2013-05-10','08:55:00',4.56),('12374','2013-05-10','09:00:00',3.94),('12374','2013-05-10','09:05:00',2.98),('12374','2013-05-10','09:10:00',3.11),('12374','2013-05-10','09:15:00',4.89),('12374','2013-05-10','09:20:00',4.75),('12374','2013-05-10','09:25:00',6.62),('12374','2013-05-10','09:30:00',5.64),('12374','2013-05-10','09:35:00',6.75),('12374','2013-05-10','09:40:00',4.05),('12374','2013-05-10','09:45:00',6.32),('12374','2013-05-10','09:50:00',3.95),('12374','2013-05-10','09:55:00',6.35),('12374','2013-05-10','10:00:00',5.16),('12374','2013-05-10','10:05:00',5.83),('12374','2013-05-10','10:10:00',7.49),('12374','2013-05-10','10:15:00',7.05),('12374','2013-05-10','10:20:00',6.96),('12374','2013-05-10','10:25:00',6.53),('12374','2013-05-10','10:30:00',7.12),('12374','2013-05-10','10:35:00',7),('12374','2013-05-10','10:40:00',6.26),('12374','2013-05-10','10:45:00',7.41),('12374','2013-05-10','10:50:00',7.5),('12374','2013-05-10','10:55:00',5.89),('12374','2013-05-10','11:00:00',7.53),('12374','2013-05-10','11:05:00',6.03),('12374','2013-05-10','11:10:00',4.92),('12374','2013-05-10','11:15:00',4.41),('12374','2013-05-10','11:20:00',7.29),('12374','2013-05-10','11:25:00',7.79),('12374','2013-05-10','11:30:00',9.19),('12374','2013-05-10','11:35:00',6.9),('12374','2013-05-10','11:40:00',8.35),('12374','2013-05-10','11:45:00',8.37),('12374','2013-05-10','11:50:00',8.85),('12374','2013-05-10','11:55:00',7.09),('12374','2013-05-10','12:00:00',7.57),('12374','2013-05-10','12:05:00',7.94),('12374','2013-05-10','12:10:00',9.49),('12374','2013-05-10','12:15:00',9.22),('12374','2013-05-10','12:20:00',9.29),('12374','2013-05-10','12:25:00',7.9),('12374','2013-05-10','12:30:00',6.94),('12374','2013-05-10','12:35:00',4.91),('12374','2013-05-10','12:40:00',4.99),('12374','2013-05-10','12:45:00',6.12),('12374','2013-05-10','12:50:00',9.18),('12374','2013-05-10','12:55:00',9.75),('12374','2013-05-10','13:00:00',8.57),('12374','2013-05-10','13:05:00',9.44),('12374','2013-05-10','13:10:00',9.2),('12374','2013-05-10','13:15:00',7.97),('12374','2013-05-10','13:20:00',7.25),('12374','2013-05-10','13:25:00',5.84),('12374','2013-05-10','13:30:00',5.99),('12374','2013-05-10','13:35:00',5.87),('12374','2013-05-10','13:40:00',5.29),('12374','2013-05-10','13:45:00',4.75),('12374','2013-05-10','13:50:00',5.26),('12374','2013-05-10','13:55:00',5.4),('12374','2013-05-10','14:00:00',5.61),('12374','2013-05-10','14:05:00',6.1),('12374','2013-05-10','14:10:00',5.52),('12374','2013-05-10','14:15:00',5.1),('12374','2013-05-10','14:20:00',4.84),('12374','2013-05-10','14:25:00',5.09),('12374','2013-05-10','14:30:00',5.06),('12374','2013-05-10','14:35:00',5.13),('12374','2013-05-10','14:40:00',5.28),('12374','2013-05-10','14:45:00',4.53),('12374','2013-05-10','14:50:00',4.74),('12374','2013-05-10','14:55:00',5.71),('12374','2013-05-10','15:00:00',6.42),('12374','2013-05-10','15:05:00',5.68),('12374','2013-05-10','15:10:00',4.65),('12374','2013-05-10','15:15:00',4.37),('12374','2013-05-10','15:20:00',3.98),('12374','2013-05-10','15:25:00',3.95),('12374','2013-05-10','15:30:00',4.18),('12374','2013-05-10','15:35:00',4.19),('12374','2013-05-10','15:40:00',4.21),('12374','2013-05-10','15:45:00',3.56),('12374','2013-05-10','15:50:00',3.12),('12374','2013-05-10','15:55:00',3.33),('12374','2013-05-10','16:00:00',4.51),('12374','2013-05-10','16:05:00',4.16),('12374','2013-05-10','16:10:00',4.42),('12374','2013-05-10','16:15:00',4.2),('12374','2013-05-10','16:20:00',3.99),('12374','2013-05-10','16:25:00',3.98),('12374','2013-05-10','16:30:00',3.92),('12374','2013-05-10','16:35:00',3.94),('12374','2013-05-10','16:40:00',3.83),('12374','2013-05-10','16:45:00',3.42),('12374','2013-05-10','16:50:00',3.03),('12374','2013-05-10','16:55:00',3.04),('12374','2013-05-10','17:00:00',3.1),('12374','2013-05-10','17:05:00',2.79),('12374','2013-05-10','17:10:00',2.45),('12374','2013-05-10','17:15:00',2.36),('12374','2013-05-10','17:20:00',2.46),('12374','2013-05-10','17:25:00',2.32),('12374','2013-05-10','17:30:00',1.81),('12374','2013-05-10','17:35:00',1.42),('12374','2013-05-10','17:40:00',1.32),('12374','2013-05-10','17:45:00',1.18),('12374','2013-05-10','17:50:00',1.13),('12374','2013-05-10','17:55:00',1.2),('12374','2013-05-10','18:00:00',1.39),('12374','2013-05-10','18:05:00',1.61),('12374','2013-05-10','18:10:00',1.36),('12374','2013-05-10','18:15:00',1.16),('12374','2013-05-10','18:20:00',1.08),('12374','2013-05-09','06:55:00',1.07),('12374','2013-05-09','07:00:00',1.27),('12374','2013-05-09','07:05:00',1.24),('12374','2013-05-09','07:10:00',1.64),('12374','2013-05-09','07:15:00',1.83),('12374','2013-05-09','07:20:00',1.94),('12374','2013-05-09','07:25:00',1.89),('12374','2013-05-09','07:30:00',2.32),('12374','2013-05-09','07:35:00',2.51),('12374','2013-05-09','07:40:00',2.69),('12374','2013-05-09','07:45:00',2.85),('12374','2013-05-09','07:50:00',3.02),('12374','2013-05-09','07:55:00',3.2),('12374','2013-05-09','08:00:00',3.35),('12374','2013-05-09','08:05:00',3.51),('12374','2013-05-09','08:10:00',3.67),('12374','2013-05-09','08:15:00',3.85),('12374','2013-05-09','08:20:00',4.04),('12374','2013-05-09','08:25:00',4.21),('12374','2013-05-09','08:30:00',4.36),('12374','2013-05-09','08:35:00',4.51),('12374','2013-05-09','08:40:00',4.64),('12374','2013-05-09','08:45:00',4.8),('12374','2013-05-09','08:50:00',4.92),('12374','2013-05-09','08:55:00',5.09),('12374','2013-05-09','09:00:00',5.27),('12374','2013-05-09','09:05:00',5.42),('12374','2013-05-09','09:10:00',5.56),('12374','2013-05-09','09:15:00',5.7),('12374','2013-05-09','09:20:00',5.84),('12374','2013-05-09','09:25:00',5.95),('12374','2013-05-09','09:30:00',6.09),('12374','2013-05-09','09:35:00',6.24),('12374','2013-05-09','09:40:00',6.36),('12374','2013-05-09','09:45:00',6.44),('12374','2013-05-09','09:50:00',6.57),('12374','2013-05-09','09:55:00',6.66),('12374','2013-05-09','10:00:00',6.83),('12374','2013-05-09','10:05:00',6.93),('12374','2013-05-09','10:10:00',7.03),('12374','2013-05-09','10:15:00',7.1),('12374','2013-05-09','10:20:00',7.24),('12374','2013-05-09','10:25:00',7.34),('12374','2013-05-09','10:30:00',7.33),('12374','2013-05-09','10:35:00',7.52),('12374','2013-05-09','10:40:00',7.72),('12374','2013-05-09','10:45:00',7.87),('12374','2013-05-09','10:50:00',7.93),('12374','2013-05-09','10:55:00',7.95),('12374','2013-05-09','11:00:00',8.05),('12374','2013-05-09','11:05:00',8.16),('12374','2013-05-09','11:10:00',8.25),('12374','2013-05-09','11:15:00',8.28),('12374','2013-05-09','11:20:00',8.32),('12374','2013-05-09','11:25:00',8.38),('12374','2013-05-09','11:30:00',8.55),('12374','2013-05-09','11:35:00',8.65),('12374','2013-05-09','11:40:00',8.74),('12374','2013-05-09','11:45:00',8.81),('12374','2013-05-09','11:50:00',8.88),('12374','2013-05-09','11:55:00',8.96),('12374','2013-05-09','12:00:00',8.97),('12374','2013-05-09','12:05:00',9.03),('12374','2013-05-09','12:10:00',9.04),('12374','2013-05-09','12:15:00',9.06),('12374','2013-05-09','12:20:00',9.11),('12374','2013-05-09','12:25:00',9.12),('12374','2013-05-09','12:30:00',9.12),('12374','2013-05-09','12:35:00',9.19),('12374','2013-05-09','12:40:00',9.15),('12374','2013-05-09','12:45:00',9.21),('12374','2013-05-09','12:50:00',9.24),('12374','2013-05-09','12:55:00',9.21),('12374','2013-05-09','13:00:00',9.16),('12374','2013-05-09','13:05:00',9.18),('12374','2013-05-09','13:10:00',9.17),('12374','2013-05-09','13:15:00',9.21),('12374','2013-05-09','13:20:00',9.23),('12374','2013-05-09','13:25:00',9.23),('12374','2013-05-09','13:30:00',9.25),('12374','2013-05-09','13:35:00',9.21),('12374','2013-05-09','13:40:00',9.19),('12374','2013-05-09','13:45:00',9.19),('12374','2013-05-09','13:50:00',9.15),('12374','2013-05-09','13:55:00',9.09),('12374','2013-05-09','14:00:00',9.06),('12374','2013-05-09','14:05:00',8.96),('12374','2013-05-09','14:10:00',8.93),('12374','2013-05-09','14:15:00',8.74),('12374','2013-05-09','14:20:00',8.86),('12374','2013-05-09','14:25:00',8.8),('12374','2013-05-09','14:30:00',8.66),('12374','2013-05-09','14:35:00',8.58),('12374','2013-05-09','14:40:00',8.48),('12374','2013-05-09','14:45:00',8.36),('12374','2013-05-09','14:50:00',8.39),('12374','2013-05-09','14:55:00',8.14),('12374','2013-05-09','15:00:00',8.22),('12374','2013-05-09','15:05:00',8.15),('12374','2013-05-09','15:10:00',8.05),('12374','2013-05-09','15:15:00',7.94),('12374','2013-05-09','15:20:00',7.74),('12374','2013-05-09','15:25:00',7.66),('12374','2013-05-09','15:30:00',7.6),('12374','2013-05-09','15:35:00',7.5),('12374','2013-05-09','15:40:00',7.4),('12374','2013-05-09','15:45:00',7.27),('12374','2013-05-09','15:50:00',7.03),('12374','2013-05-09','15:55:00',6.92),('12374','2013-05-09','16:00:00',6.82),('12374','2013-05-09','16:05:00',6.74),('12374','2013-05-09','16:10:00',6.56),('12374','2013-05-09','16:15:00',6.43),('12374','2013-05-09','16:20:00',6.35),('12374','2013-05-09','16:25:00',6.23),('12374','2013-05-09','16:30:00',6.08),('12374','2013-05-09','16:35:00',5.94),('12374','2013-05-09','16:40:00',5.79),('12374','2013-05-09','16:45:00',5.65),('12374','2013-05-09','16:50:00',5.44),('12374','2013-05-09','16:55:00',5.28),('12374','2013-05-09','17:00:00',5.12),('12374','2013-05-09','17:05:00',4.97),('12374','2013-05-09','17:10:00',4.83),('12374','2013-05-09','17:15:00',4.65),('12374','2013-05-09','17:20:00',4.52),('12374','2013-05-09','17:25:00',4.3),('12374','2013-05-09','17:30:00',4.12),('12374','2013-05-09','17:35:00',3.93),('12374','2013-05-09','17:40:00',3.68),('12374','2013-05-09','17:45:00',3.52),('12374','2013-05-09','17:50:00',3.33),('12374','2013-05-09','17:55:00',3.1),('12374','2013-05-09','18:00:00',2.95),('12374','2013-05-09','18:05:00',2.72),('12374','2013-05-09','18:10:00',2.61),('12374','2013-05-09','18:15:00',2.46),('12374','2013-05-09','18:20:00',2.17),('12374','2013-05-09','18:25:00',1.94),('12374','2013-05-09','18:30:00',1.83),('12374','2013-05-09','18:35:00',1.76),('12374','2013-05-09','18:40:00',1.56),('12374','2013-05-09','18:45:00',1.56),('12374','2013-05-09','18:50:00',1.11),('12374','2013-05-09','18:55:00',1.34),('12374','2013-05-09','19:00:00',1.2),('12374','2013-05-09','19:05:00',1.11),('12374','2013-05-08','07:05:00',1.05),('12374','2013-05-08','07:15:00',1.5),('12374','2013-05-08','07:20:00',1.9),('12374','2013-05-08','07:25:00',2.02),('12374','2013-05-08','07:30:00',2.23),('12374','2013-05-08','07:35:00',2.09),('12374','2013-05-08','07:40:00',2.54),('12374','2013-05-08','07:45:00',2.7),('12374','2013-05-08','07:50:00',2.91),('12374','2013-05-08','07:55:00',3.12),('12374','2013-05-08','08:00:00',3.3),('12374','2013-05-08','08:05:00',3.51),('12374','2013-05-08','08:10:00',3.64),('12374','2013-05-08','08:15:00',3.32),('12374','2013-05-08','08:20:00',4.04),('12374','2013-05-08','08:25:00',4.15),('12374','2013-05-08','08:30:00',4.41),('12374','2013-05-08','08:35:00',4.42),('12374','2013-05-08','08:40:00',4.68),('12374','2013-05-08','08:45:00',4.81),('12374','2013-05-08','08:50:00',5.03),('12374','2013-05-08','08:55:00',4.9),('12374','2013-05-08','09:00:00',5.04),('12374','2013-05-08','09:05:00',5.96),('12374','2013-05-08','09:10:00',5.73),('12374','2013-05-08','09:15:00',3.89),('12374','2013-05-08','09:20:00',1.86),('12374','2013-05-08','09:25:00',4.79),('12374','2013-05-08','09:30:00',5.16),('12374','2013-05-08','09:35:00',7.4),('12374','2013-05-08','09:40:00',7.41),('12374','2013-05-08','09:45:00',7.41),('12374','2013-05-08','09:50:00',7.4),('12374','2013-05-08','09:55:00',7.44),('12374','2013-05-08','10:00:00',7.26),('12374','2013-05-08','10:05:00',2.5),('12374','2013-05-08','10:10:00',2.48),('12374','2013-05-08','10:15:00',2.56),('12374','2013-05-08','10:20:00',5.31),('12374','2013-05-08','10:25:00',2.84),('12374','2013-05-08','10:30:00',5.3),('12374','2013-05-08','10:35:00',7),('12374','2013-05-08','10:40:00',7.68),('12374','2013-05-08','10:45:00',8.19),('12374','2013-05-08','10:50:00',8.16),('12374','2013-05-08','10:55:00',8.12),('12374','2013-05-08','11:00:00',8.24),('12374','2013-05-08','11:05:00',8.25),('12374','2013-05-08','11:10:00',8.26),('12374','2013-05-08','11:15:00',8.38),('12374','2013-05-08','11:20:00',8.45),('12374','2013-05-08','11:25:00',8.55),('12374','2013-05-08','11:30:00',8.63),('12374','2013-05-08','11:35:00',8.71),('12374','2013-05-08','11:40:00',8.73),('12374','2013-05-08','11:45:00',8.87),('12374','2013-05-08','11:50:00',8.94),('12374','2013-05-08','11:55:00',8.99),('12374','2013-05-08','12:00:00',9.01),('12374','2013-05-08','12:05:00',9.11),('12374','2013-05-08','12:10:00',9.19),('12374','2013-05-08','12:15:00',9.17),('12374','2013-05-08','12:20:00',9.18),('12374','2013-05-08','12:25:00',9.24),('12374','2013-05-08','12:30:00',9.23),('12374','2013-05-08','12:35:00',9.28),('12374','2013-05-08','12:40:00',9.27),('12374','2013-05-08','12:45:00',9.22),('12374','2013-05-08','12:50:00',9.23),('12374','2013-05-08','12:55:00',9.24),('12374','2013-05-08','13:00:00',9.17),('12374','2013-05-08','13:05:00',9.27),('12374','2013-05-08','13:10:00',9.31),('12374','2013-05-08','13:15:00',9.26),('12374','2013-05-08','13:20:00',9.24),('12374','2013-05-08','13:25:00',9.3),('12374','2013-05-08','13:30:00',9.31),('12374','2013-05-08','13:35:00',9.26),('12374','2013-05-08','13:40:00',9.17),('12374','2013-05-08','13:45:00',9.1),('12374','2013-05-08','13:50:00',9.05),('12374','2013-05-08','13:55:00',9.12),('12374','2013-05-08','14:00:00',9.12),('12374','2013-05-08','14:05:00',9.11),('12374','2013-05-08','14:10:00',9.01),('12374','2013-05-08','14:15:00',8.97),('12374','2013-05-08','14:20:00',8.94),('12374','2013-05-08','14:25:00',8.89),('12374','2013-05-08','14:30:00',8.8),('12374','2013-05-08','14:35:00',8.69),('12374','2013-05-08','14:40:00',8.68),('12374','2013-05-08','14:45:00',8.67),('12374','2013-05-08','14:50:00',8.56),('12374','2013-05-08','14:55:00',8.46),('12374','2013-05-08','15:00:00',8.15),('12374','2013-05-08','15:05:00',8.17),('12374','2013-05-08','15:10:00',8.04),('12374','2013-05-08','15:15:00',7.94),('12374','2013-05-08','15:20:00',7.84),('12374','2013-05-08','15:25:00',7.74),('12374','2013-05-08','15:30:00',7.68),('12374','2013-05-08','15:35:00',7.66),('12374','2013-05-08','15:40:00',6.71),('12374','2013-05-08','15:45:00',2.75),('12374','2013-05-08','15:50:00',3.5),('12374','2013-05-08','15:55:00',5.37),('12374','2013-05-08','16:00:00',4.87),('12374','2013-05-08','16:05:00',3.91),('12374','2013-05-08','16:10:00',3.81),('12374','2013-05-08','16:15:00',5.92),('12374','2013-05-08','16:20:00',3.91),('12374','2013-05-08','16:25:00',3.58),('12374','2013-05-08','16:30:00',4.79),('12374','2013-05-08','16:35:00',3.51),('12374','2013-05-08','16:40:00',4.01),('12374','2013-05-08','16:45:00',2.76),('12374','2013-05-08','16:50:00',4.1),('12374','2013-05-08','16:55:00',5.83),('12374','2013-05-08','17:00:00',5.9),('12374','2013-05-08','17:05:00',5.78),('12374','2013-05-08','17:10:00',5.59),('12374','2013-05-08','17:15:00',5.36),('12374','2013-05-08','17:20:00',2.87),('12374','2013-05-08','17:25:00',3.13),('12374','2013-05-08','17:30:00',2.34),('12374','2013-05-08','17:35:00',1.42),('12374','2013-05-08','17:40:00',1.44),('12374','2013-05-08','17:45:00',1.49),('12374','2013-05-08','17:50:00',1.34),('12374','2013-05-08','17:55:00',2.35),('12374','2013-05-08','18:00:00',1.17),('12374','2013-05-08','18:05:00',1.35),('12374','2013-05-08','18:10:00',1.86),('12374','2013-05-08','18:15:00',2.31),('12374','2013-05-08','18:20:00',2.27),('12374','2013-05-08','18:25:00',2.23),('12374','2013-05-08','18:30:00',1.78),('12374','2013-05-08','18:35:00',1.71),('12374','2013-05-08','18:40:00',1.85),('12374','2013-05-08','18:45:00',1.17),('12374','2013-05-07','07:30:00',1.42),('12374','2013-05-07','07:35:00',2.64),('12374','2013-05-07','07:40:00',2.8),('12374','2013-05-07','07:45:00',2.95),('12374','2013-05-07','07:50:00',3.1),('12374','2013-05-07','07:55:00',3.34),('12374','2013-05-07','08:00:00',3.45),('12374','2013-05-07','08:05:00',3.6),('12374','2013-05-07','08:10:00',3.78),('12374','2013-05-07','08:15:00',3.95),('12374','2013-05-07','08:20:00',4.11),('12374','2013-05-07','08:25:00',4.32),('12374','2013-05-07','08:30:00',4.47),('12374','2013-05-07','08:35:00',4.51),('12374','2013-05-07','08:40:00',4.13),('12374','2013-05-07','08:45:00',4.04),('12374','2013-05-07','08:50:00',4.93),('12374','2013-05-07','08:55:00',5.18),('12374','2013-05-07','09:00:00',5.32),('12374','2013-05-07','09:05:00',5.51),('12374','2013-05-07','09:10:00',5.26),('12374','2013-05-07','09:15:00',5.92),('12374','2013-05-07','09:20:00',5.48),('12374','2013-05-07','09:25:00',6.25),('12374','2013-05-07','09:30:00',5.82),('12374','2013-05-07','09:35:00',4.06),('12374','2013-05-07','09:40:00',5.02),('12374','2013-05-07','09:45:00',3.5),('12374','2013-05-07','09:50:00',7.57),('12374','2013-05-07','09:55:00',7.41),('12374','2013-05-07','10:00:00',7.31),('12374','2013-05-07','10:05:00',7.59),('12374','2013-05-07','10:10:00',7.73),('12374','2013-05-07','10:15:00',7.82),('12374','2013-05-07','10:20:00',8.16),('12374','2013-05-07','10:25:00',7.62),('12374','2013-05-07','10:30:00',4.31),('12374','2013-05-07','10:35:00',7.96),('12374','2013-05-07','10:40:00',2.89),('12374','2013-05-07','10:45:00',1.79),('12374','2013-05-07','10:50:00',2.16),('12374','2013-05-07','10:55:00',4.3),('12374','2013-05-07','11:00:00',6.09),('12374','2013-05-07','11:05:00',4.33),('12374','2013-05-07','11:10:00',5.48),('12374','2013-05-07','11:15:00',8.78),('12374','2013-05-07','11:20:00',8.75),('12374','2013-05-07','11:25:00',8.79),('12374','2013-05-07','11:30:00',8.81),('12374','2013-05-07','11:35:00',8.9),('12374','2013-05-07','11:40:00',8.96),('12374','2013-05-07','11:45:00',9.07),('12374','2013-05-07','11:50:00',9.31),('12374','2013-05-07','11:55:00',9.26),('12374','2013-05-07','12:00:00',8.64),('12374','2013-05-07','12:05:00',9.38),('12374','2013-05-07','12:10:00',8.69),('12374','2013-05-07','12:15:00',9),('12374','2013-05-07','12:20:00',7.63),('12374','2013-05-07','12:25:00',8.36),('12374','2013-05-07','12:30:00',8.11),('12374','2013-05-07','12:35:00',5.81),('12374','2013-05-07','12:40:00',8.69),('12374','2013-05-07','12:45:00',9.05),('12374','2013-05-07','12:50:00',8.94),('12374','2013-05-07','12:55:00',9.22),('12374','2013-05-07','13:00:00',8.91),('12374','2013-05-07','13:05:00',9.37),('12374','2013-05-07','13:10:00',8.66),('12374','2013-05-07','13:15:00',9.37),('12374','2013-05-07','13:20:00',9.45),('12374','2013-05-07','13:25:00',9.23),('12374','2013-05-07','13:30:00',8.96),('12374','2013-05-07','13:35:00',9.51),('12374','2013-05-07','13:40:00',8.06),('12374','2013-05-07','13:45:00',8.57),('12374','2013-05-07','13:50:00',8.17),('12374','2013-05-07','13:55:00',9.19),('12374','2013-05-07','14:00:00',9.4),('12374','2013-05-07','14:05:00',9.55),('12374','2013-05-07','14:10:00',7.68),('12374','2013-05-07','14:15:00',8.26),('12374','2013-05-07','14:20:00',9.05),('12374','2013-05-07','14:25:00',8.93),('12374','2013-05-07','14:30:00',8.22),('12374','2013-05-07','14:35:00',8.47),('12374','2013-05-07','14:40:00',8.96),('12374','2013-05-07','14:45:00',8.83),('12374','2013-05-07','14:50:00',8.26),('12374','2013-05-07','14:55:00',6.75),('12374','2013-05-07','15:00:00',5.53),('12374','2013-05-07','15:05:00',8.27),('12374','2013-05-07','15:10:00',7.85),('12374','2013-05-07','15:15:00',8.06),('12374','2013-05-07','15:20:00',7.77),('12374','2013-05-07','15:25:00',7.75),('12374','2013-05-07','15:30:00',7.04),('12374','2013-05-07','15:35:00',6.99),('12374','2013-05-07','15:40:00',6.93),('12374','2013-05-07','15:45:00',6.14),('12374','2013-05-07','15:50:00',6.23),('12374','2013-05-07','15:55:00',6.39),('12374','2013-05-07','16:00:00',6.95),('12374','2013-05-07','16:05:00',7.07),('12374','2013-05-07','16:10:00',7.32),('12374','2013-05-07','16:15:00',7.44),('12374','2013-05-07','16:20:00',7.34),('12374','2013-05-07','16:25:00',4.91),('12374','2013-05-07','16:30:00',5.03),('12374','2013-05-07','16:35:00',5.11),('12374','2013-05-07','16:40:00',4.49),('12374','2013-05-07','16:45:00',4.78),('12374','2013-05-07','16:50:00',4.63),('12374','2013-05-07','16:55:00',5.38),('12374','2013-05-07','17:00:00',4.76),('12374','2013-05-07','17:05:00',2.85),('12374','2013-05-07','17:10:00',2.62),('12374','2013-05-07','17:15:00',2.18),('12374','2013-05-07','17:20:00',2.03),('12374','2013-05-07','17:25:00',2),('12374','2013-05-07','17:30:00',2.37),('12374','2013-05-07','17:35:00',3.62),('12374','2013-05-07','17:40:00',5.11),('12374','2013-05-07','17:45:00',4.92),('12374','2013-05-07','17:50:00',4.47),('12374','2013-05-07','17:55:00',3.4),('12374','2013-05-07','18:00:00',2.75),('12374','2013-05-07','18:05:00',1.85),('12374','2013-05-07','18:10:00',1.48),('12374','2013-05-07','18:15:00',1.2),('12374','2013-05-07','18:20:00',1.11),('12374','2013-05-06','10:05:00',2.39),('12374','2013-05-06','10:10:00',2.46),('12374','2013-05-06','10:15:00',2.23),('12374','2013-05-06','10:20:00',2.88),('12374','2013-05-06','10:25:00',3.66),('12374','2013-05-06','10:30:00',3.32),('12374','2013-05-06','10:35:00',2.14),('12374','2013-05-06','10:40:00',2.26),('12374','2013-05-06','10:45:00',2.31),('12374','2013-05-06','10:50:00',2.36),('12374','2013-05-06','10:55:00',3.28),('12374','2013-05-06','11:00:00',5.15),('12374','2013-05-06','11:05:00',4.73),('12374','2013-05-06','11:10:00',5.5),('12374','2013-05-06','11:15:00',6.15),('12374','2013-05-06','11:20:00',8.19),('12374','2013-05-06','11:25:00',7.36),('12374','2013-05-06','11:30:00',6.87),('12374','2013-05-06','11:35:00',7.42),('12374','2013-05-06','11:40:00',8.9),('12374','2013-05-06','11:45:00',9.26),('12374','2013-05-06','11:50:00',9.09),('12374','2013-05-06','11:55:00',9.15),('12374','2013-05-06','12:00:00',8.97),('12374','2013-05-06','12:05:00',9.06),('12374','2013-05-06','12:10:00',9.04),('12374','2013-05-06','12:15:00',8.86),('12374','2013-05-06','12:20:00',8.62),('12374','2013-05-06','12:25:00',9.25),('12374','2013-05-06','12:30:00',9.33),('12374','2013-05-06','12:35:00',9.38),('12374','2013-05-06','12:40:00',9.17),('12374','2013-05-06','12:45:00',9.4),('12374','2013-05-06','12:50:00',8.62),('12374','2013-05-06','12:55:00',8.93),('12374','2013-05-06','13:00:00',9.49),('12374','2013-05-06','13:05:00',8.01),('12374','2013-05-06','13:10:00',9.39),('12374','2013-05-06','13:15:00',9.4),('12374','2013-05-06','13:20:00',9.38),('12374','2013-05-06','13:25:00',9.37),('12374','2013-05-06','13:30:00',7.55),('12374','2013-05-06','13:35:00',9.59),('12374','2013-05-06','13:40:00',9.03),('12374','2013-05-06','13:45:00',7.51),('12374','2013-05-06','13:50:00',7.43),('12374','2013-05-06','13:55:00',6.42),('12374','2013-05-06','14:00:00',5.54),('12374','2013-05-06','14:05:00',7.9),('12374','2013-05-06','14:10:00',5.49),('12374','2013-05-06','14:15:00',7.24),('12374','2013-05-06','14:20:00',9.17),('12374','2013-05-06','14:25:00',8.34),('12374','2013-05-06','14:30:00',7.83),('12374','2013-05-06','14:35:00',7.25),('12374','2013-05-06','14:40:00',8.51),('12374','2013-05-06','14:45:00',8.09),('12374','2013-05-06','14:50:00',8.65),('12374','2013-05-06','14:55:00',8.77),('12374','2013-05-06','15:00:00',8.32),('12374','2013-05-06','15:05:00',7.99),('12374','2013-05-06','15:10:00',8.19),('12374','2013-05-06','15:15:00',7.08),('12374','2013-05-06','15:20:00',5.8),('12374','2013-05-06','15:25:00',5.59),('12374','2013-05-06','15:30:00',7.04),('12374','2013-05-06','15:35:00',7.55),('12374','2013-05-06','15:40:00',7.65),('12374','2013-05-06','15:45:00',7.4),('12374','2013-05-06','15:50:00',7.36),('12374','2013-05-06','15:55:00',7.38),('12374','2013-05-06','16:00:00',5.23),('12374','2013-05-06','16:05:00',5.45),('12374','2013-05-06','16:10:00',2.92),('12374','2013-05-06','16:15:00',2.68),('12374','2013-05-06','16:20:00',3.42),('12374','2013-05-06','16:25:00',3.4),('12374','2013-05-06','16:30:00',2.23),('12374','2013-05-06','16:35:00',3.28),('12374','2013-05-06','16:40:00',4),('12374','2013-05-06','16:45:00',4.55),('12374','2013-05-06','16:50:00',3.98),('12374','2013-05-06','16:55:00',2.97),('12374','2013-05-06','17:00:00',3.86),('12374','2013-05-06','17:05:00',3.32),('12374','2013-05-06','17:10:00',1.63),('12374','2013-05-06','17:15:00',1.01),('12374','2013-05-06','17:20:00',1.5),('12374','2013-05-06','17:25:00',1.95),('12374','2013-05-06','17:30:00',1.56),('12374','2013-05-06','17:35:00',1.75),('12374','2013-05-06','17:40:00',2.33),('12374','2013-05-06','17:45:00',1.73),('12374','2013-05-06','17:50:00',1.44),('12374','2013-05-06','17:55:00',2.37),('12374','2013-05-06','18:00:00',1.49),('12374','2013-05-06','18:05:00',2.66),('12374','2013-05-06','18:10:00',1.3),('12374','2013-05-06','18:15:00',1.02),('12374','2013-05-06','18:25:00',1.07),('12374','2013-05-06','18:30:00',1.11),('12374','2013-05-06','18:35:00',1.17),('12374','2013-05-06','18:40:00',1.19),('12374','2013-05-06','19:00:00',1.1),('12374','2013-05-06','19:05:00',1.5),('12374','2013-05-06','19:10:00',1.67),('12374','2013-05-06','19:15:00',1.39),('12374','2013-05-05','07:05:00',1.35),('12374','2013-05-05','07:10:00',1.51),('12374','2013-05-05','07:15:00',1.72),('12374','2013-05-05','07:20:00',1.81),('12374','2013-05-05','07:25:00',2.34),('12374','2013-05-05','07:30:00',2.39),('12374','2013-05-05','07:35:00',2.54),('12374','2013-05-05','07:40:00',2.09),('12374','2013-05-05','07:45:00',2.34),('12374','2013-05-05','07:50:00',1.9),('12374','2013-05-05','07:55:00',1.44),('12374','2013-05-05','08:00:00',1.48),('12374','2013-05-05','08:05:00',1.51),('12374','2013-05-05','08:10:00',1.56),('12374','2013-05-05','08:15:00',1.62),('12374','2013-05-05','08:20:00',1.56),('12374','2013-05-05','08:25:00',1.62),('12374','2013-05-05','08:30:00',2.28),('12374','2013-05-05','08:35:00',3.32),('12374','2013-05-05','08:40:00',3.5),('12374','2013-05-05','08:45:00',2.87),('12374','2013-05-05','08:50:00',3.29),('12374','2013-05-05','08:55:00',2.05),('12374','2013-05-05','09:00:00',1.96),('12374','2013-05-05','09:05:00',4.32),('12374','2013-05-05','09:10:00',4.37),('12374','2013-05-05','09:15:00',4.25),('12374','2013-05-05','09:20:00',5.97),('12374','2013-05-05','09:25:00',6.29),('12374','2013-05-05','09:30:00',6.79),('12374','2013-05-05','09:35:00',6.47),('12374','2013-05-05','09:40:00',6.15),('12374','2013-05-05','09:45:00',3.64),('12374','2013-05-05','09:50:00',5.45),('12374','2013-05-05','09:55:00',1.85),('12374','2013-05-05','10:00:00',1.27),('12374','2013-05-05','10:05:00',1.48),('12374','2013-05-05','10:10:00',2.75),('12374','2013-05-05','10:15:00',6.71),('12374','2013-05-05','10:20:00',6.52),('12374','2013-05-05','10:25:00',5.1),('12374','2013-05-05','10:30:00',3.58),('12374','2013-05-05','10:35:00',3.41),('12374','2013-05-05','10:40:00',2.69),('12374','2013-05-05','10:45:00',2.76),('12374','2013-05-05','10:50:00',5.16),('12374','2013-05-05','10:55:00',4.78),('12374','2013-05-05','11:00:00',7.34),('12374','2013-05-05','11:05:00',7.79),('12374','2013-05-05','11:10:00',6.79),('12374','2013-05-05','11:15:00',5.97),('12374','2013-05-05','11:20:00',6.73),('12374','2013-05-05','11:25:00',5.28),('12374','2013-05-05','11:30:00',7.04),('12374','2013-05-05','11:35:00',4.67),('12374','2013-05-05','11:40:00',6.34),('12374','2013-05-05','11:45:00',5.74),('12374','2013-05-05','11:50:00',7.02),('12374','2013-05-05','11:55:00',7.69),('12374','2013-05-05','12:00:00',7.47),('12374','2013-05-05','12:05:00',9.83),('12374','2013-05-05','12:10:00',9.35),('12374','2013-05-05','12:15:00',8.82),('12374','2013-05-05','12:20:00',9.17),('12374','2013-05-05','12:25:00',9.08),('12374','2013-05-05','12:30:00',9.17),('12374','2013-05-05','12:35:00',9.22),('12374','2013-05-05','12:40:00',9.31),('12374','2013-05-05','12:45:00',9.58),('12374','2013-05-05','12:50:00',9.57),('12374','2013-05-05','12:55:00',9.38),('12374','2013-05-05','13:00:00',9.34),('12374','2013-05-05','13:05:00',9.34),('12374','2013-05-05','13:10:00',9.16),('12374','2013-05-05','13:15:00',9.39),('12374','2013-05-05','13:20:00',9.31),('12374','2013-05-05','13:25:00',9.5),('12374','2013-05-05','13:30:00',7.27),('12374','2013-05-05','13:35:00',5.26),('12374','2013-05-05','13:40:00',4.68),('12374','2013-05-05','13:45:00',5.08),('12374','2013-05-05','13:50:00',5.33),('12374','2013-05-05','13:55:00',6.35),('12374','2013-05-05','14:00:00',7.5),('12374','2013-05-05','14:05:00',9.04),('12374','2013-05-05','14:10:00',8.87),('12374','2013-05-05','14:15:00',8.69),('12374','2013-05-05','14:20:00',8.65),('12374','2013-05-05','14:25:00',8.54),('12374','2013-05-05','14:30:00',8.4),('12374','2013-05-05','14:35:00',8.29),('12374','2013-05-05','14:40:00',8.15),('12374','2013-05-05','14:45:00',8.12),('12374','2013-05-05','14:50:00',8.09),('12374','2013-05-05','14:55:00',8.03),('12374','2013-05-05','15:00:00',7.95),('12374','2013-05-05','15:05:00',6.14),('12374','2013-05-05','15:10:00',8.04),('12374','2013-05-05','15:15:00',7.79),('12374','2013-05-05','15:20:00',7.65),('12374','2013-05-05','15:25:00',7.46),('12374','2013-05-05','15:30:00',7.38),('12374','2013-05-05','15:35:00',7.26),('12374','2013-05-05','15:40:00',7.13),('12374','2013-05-05','15:45:00',7.01),('12374','2013-05-05','15:50:00',6.91),('12374','2013-05-05','15:55:00',6.76),('12374','2013-05-05','16:00:00',6.64),('12374','2013-05-05','16:05:00',6.52),('12374','2013-05-05','16:10:00',6.39),('12374','2013-05-05','16:15:00',6.25),('12374','2013-05-05','16:20:00',6.11),('12374','2013-05-05','16:25:00',5.99),('12374','2013-05-05','16:30:00',5.88),('12374','2013-05-05','16:35:00',5.75),('12374','2013-05-05','16:40:00',5.59),('12374','2013-05-05','16:45:00',5.41),('12374','2013-05-05','16:50:00',5.27),('12374','2013-05-05','16:55:00',5.14),('12374','2013-05-05','17:00:00',5),('12374','2013-05-05','17:05:00',4.84),('12374','2013-05-05','17:10:00',4.67),('12374','2013-05-05','17:15:00',4.49),('12374','2013-05-05','17:20:00',4.31),('12374','2013-05-05','17:25:00',4.09),('12374','2013-05-05','17:30:00',3.93),('12374','2013-05-05','17:35:00',3.74),('12374','2013-05-05','17:40:00',3.49),('12374','2013-05-05','17:45:00',3.3),('12374','2013-05-05','17:50:00',3.13),('12374','2013-05-05','17:55:00',2.86),('12374','2013-05-05','18:00:00',2.79),('12374','2013-05-05','18:05:00',2.6),('12374','2013-05-05','18:10:00',2.45),('12374','2013-05-05','18:15:00',2.28),('12374','2013-05-05','18:20:00',2.09),('12374','2013-05-05','18:25:00',1.84),('12374','2013-05-05','18:30:00',1.74),('12374','2013-05-05','18:35:00',1.62),('12374','2013-05-05','18:40:00',1.53),('12374','2013-05-05','18:45:00',1.42),('12374','2013-05-05','18:50:00',1.33),('12374','2013-05-05','18:55:00',1.23),('12374','2013-05-05','19:00:00',1.12),('12374','2013-05-05','19:05:00',1.01),('12374','2013-05-04','07:00:00',1.1),('12374','2013-05-04','07:05:00',1.2),('12374','2013-05-04','07:10:00',1.46),('12374','2013-05-04','07:15:00',1.61),('12374','2013-05-04','07:20:00',1.7),('12374','2013-05-04','07:25:00',1.7),('12374','2013-05-04','07:30:00',2.06),('12374','2013-05-04','07:35:00',2.29),('12374','2013-05-04','07:40:00',2.58),('12374','2013-05-04','07:45:00',2.8),('12374','2013-05-04','07:50:00',2.5),('12374','2013-05-04','07:55:00',2.76),('12374','2013-05-04','08:00:00',2.31),('12374','2013-05-04','08:05:00',3.06),('12374','2013-05-04','08:10:00',3.32),('12374','2013-05-04','08:15:00',3.78),('12374','2013-05-04','08:20:00',3.72),('12374','2013-05-04','08:25:00',3.56),('12374','2013-05-04','08:30:00',2.84),('12374','2013-05-04','08:35:00',3.47),('12374','2013-05-04','08:40:00',2.9),('12374','2013-05-04','08:45:00',3.91),('12374','2013-05-04','08:50:00',5.59),('12374','2013-05-04','08:55:00',5.75),('12374','2013-05-04','09:00:00',5.53),('12374','2013-05-04','09:05:00',4.95),('12374','2013-05-04','09:10:00',5.62),('12374','2013-05-04','09:15:00',4.92),('12374','2013-05-04','09:20:00',5.42),('12374','2013-05-04','09:25:00',5.61),('12374','2013-05-04','09:30:00',5.66),('12374','2013-05-04','09:35:00',5.95),('12374','2013-05-04','09:40:00',6.05),('12374','2013-05-04','09:45:00',6.22),('12374','2013-05-04','09:50:00',6.31),('12374','2013-05-04','09:55:00',6.41),('12374','2013-05-04','10:00:00',6.54),('12374','2013-05-04','10:05:00',6.7),('12374','2013-05-04','10:10:00',6.76),('12374','2013-05-04','10:15:00',6.92),('12374','2013-05-04','10:20:00',7.04),('12374','2013-05-04','10:25:00',7.13),('12374','2013-05-04','10:30:00',7.18),('12374','2013-05-04','10:35:00',7.3),('12374','2013-05-04','10:40:00',7.4),('12374','2013-05-04','10:45:00',7.56),('12374','2013-05-04','10:50:00',7.66),('12374','2013-05-04','10:55:00',7.78),('12374','2013-05-04','11:00:00',7.89),('12374','2013-05-04','11:05:00',7.98),('12374','2013-05-04','11:10:00',7.86),('12374','2013-05-04','11:15:00',7.64),('12374','2013-05-04','11:20:00',7.33),('12374','2013-05-04','11:25:00',8.14),('12374','2013-05-04','11:30:00',8.28),('12374','2013-05-04','11:35:00',8.25),('12374','2013-05-04','11:40:00',8.11),('12374','2013-05-04','11:45:00',8.07),('12374','2013-05-04','11:50:00',8.24),('12374','2013-05-04','11:55:00',8.16),('12374','2013-05-04','12:00:00',7.86),('12374','2013-05-04','12:05:00',8.07),('12374','2013-05-04','12:10:00',8.19),('12374','2013-05-04','12:15:00',8.17),('12374','2013-05-04','12:20:00',8.34),('12374','2013-05-04','12:25:00',8.14),('12374','2013-05-04','12:30:00',7.99),('12374','2013-05-04','12:35:00',8),('12374','2013-05-04','12:40:00',7.96),('12374','2013-05-04','12:45:00',8.01),('12374','2013-05-04','12:50:00',7.76),('12374','2013-05-04','12:55:00',8.46),('12374','2013-05-04','13:00:00',8.74),('12374','2013-05-04','13:05:00',8.79),('12374','2013-05-04','13:10:00',8.79),('12374','2013-05-04','13:15:00',8.72),('12374','2013-05-04','13:20:00',8.66),('12374','2013-05-04','13:25:00',8.73),('12374','2013-05-04','13:30:00',8.48),('12374','2013-05-04','13:35:00',8.64),('12374','2013-05-04','13:40:00',8.3),('12374','2013-05-04','13:45:00',8.39),('12374','2013-05-04','13:50:00',8.57),('12374','2013-05-04','13:55:00',8.19),('12374','2013-05-04','14:00:00',8.11),('12374','2013-05-04','14:05:00',7.84),('12374','2013-05-04','14:10:00',8.42),('12374','2013-05-04','14:15:00',8.34),('12374','2013-05-04','14:20:00',7.87),('12374','2013-05-04','14:25:00',7.91),('12374','2013-05-04','14:30:00',7.63),('12374','2013-05-04','14:35:00',8.01),('12374','2013-05-04','14:40:00',7.95),('12374','2013-05-04','14:45:00',7.1),('12374','2013-05-04','14:50:00',6.92),('12374','2013-05-04','14:55:00',7.66),('12374','2013-05-04','15:00:00',7.63),('12374','2013-05-04','15:05:00',7.61),('12374','2013-05-04','15:10:00',7.64),('12374','2013-05-04','15:15:00',7.15),('12374','2013-05-04','15:20:00',6.5),('12374','2013-05-04','15:25:00',7.38),('12374','2013-05-04','15:30:00',7.17),('12374','2013-05-04','15:35:00',7.12),('12374','2013-05-04','15:40:00',7.13),('12374','2013-05-04','15:45:00',6.97),('12374','2013-05-04','15:50:00',6.8),('12374','2013-05-04','15:55:00',6.69),('12374','2013-05-04','16:00:00',6.53),('12374','2013-05-04','16:05:00',6.41),('12374','2013-05-04','16:10:00',6.32),('12374','2013-05-04','16:15:00',6.2),('12374','2013-05-04','16:20:00',6.09),('12374','2013-05-04','16:25:00',5.91),('12374','2013-05-04','16:30:00',5.77),('12374','2013-05-04','16:35:00',5.62),('12374','2013-05-04','16:40:00',5.48),('12374','2013-05-04','16:45:00',5.32),('12374','2013-05-04','16:50:00',5.18),('12374','2013-05-04','16:55:00',5.02),('12374','2013-05-04','17:00:00',4.86),('12374','2013-05-04','17:05:00',4.69),('12374','2013-05-04','17:10:00',4.54),('12374','2013-05-04','17:15:00',4.45),('12374','2013-05-04','17:20:00',4.33),('12374','2013-05-04','17:25:00',4.06),('12374','2013-05-04','17:30:00',3.85),('12374','2013-05-04','17:35:00',3.68),('12374','2013-05-04','17:40:00',3.45),('12374','2013-05-04','17:45:00',3.22),('12374','2013-05-04','17:50:00',2.71),('12374','2013-05-04','17:55:00',2.61),('12374','2013-05-04','18:00:00',2.36),('12374','2013-05-04','18:05:00',1.13),('12374','2013-05-04','18:10:00',1.2),('12374','2013-05-04','18:15:00',1.61),('12374','2013-05-04','18:20:00',1.75),('12374','2013-05-04','18:25:00',1.53),('12374','2013-05-04','18:30:00',1.42),('12374','2013-05-04','18:35:00',1.38),('12374','2013-05-04','18:40:00',1.16),('12374','2013-05-03','07:05:00',1.19),('12374','2013-05-03','07:10:00',1.42),('12374','2013-05-03','07:15:00',1.79),('12374','2013-05-03','07:20:00',1.87),('12374','2013-05-03','07:25:00',1.97),('12374','2013-05-03','07:30:00',1.78),('12374','2013-05-03','07:35:00',1.24),('12374','2013-05-03','07:40:00',1.18),('12374','2013-05-03','07:45:00',1.24),('12374','2013-05-03','07:50:00',1.78),('12374','2013-05-03','07:55:00',2.73),('12374','2013-05-03','08:00:00',2.79),('12374','2013-05-03','08:05:00',3.02),('12374','2013-05-03','08:10:00',3.21),('12374','2013-05-03','08:15:00',3.33),('12374','2013-05-03','08:20:00',3.52),('12374','2013-05-03','08:25:00',3.9),('12374','2013-05-03','08:30:00',4.12),('12374','2013-05-03','08:35:00',4.41),('12374','2013-05-03','08:40:00',4.57),('12374','2013-05-03','08:45:00',4.66),('12374','2013-05-03','08:50:00',4.76),('12374','2013-05-03','08:55:00',4.87),('12374','2013-05-03','09:00:00',5.05),('12374','2013-05-03','09:05:00',5.22),('12374','2013-05-03','09:10:00',5.4),('12374','2013-05-03','09:15:00',5.54),('12374','2013-05-03','09:20:00',5.69),('12374','2013-05-03','09:25:00',5.83),('12374','2013-05-03','09:30:00',5.93),('12374','2013-05-03','09:35:00',6.08),('12374','2013-05-03','09:40:00',6.22),('12374','2013-05-03','09:45:00',6.34),('12374','2013-05-03','09:50:00',6.43),('12374','2013-05-03','09:55:00',6.59),('12374','2013-05-03','10:00:00',6.68),('12374','2013-05-03','10:05:00',6.76),('12374','2013-05-03','10:10:00',6.9),('12374','2013-05-03','10:15:00',7.02),('12374','2013-05-03','10:20:00',7.14),('12374','2013-05-03','10:25:00',7.27),('12374','2013-05-03','10:30:00',7.37),('12374','2013-05-03','10:35:00',7.47),('12374','2013-05-03','10:40:00',7.54),('12374','2013-05-03','10:45:00',7.62),('12374','2013-05-03','10:50:00',7.72),('12374','2013-05-03','10:55:00',7.82),('12374','2013-05-03','11:00:00',7.92),('12374','2013-05-03','11:05:00',8.05),('12374','2013-05-03','11:10:00',8.15),('12374','2013-05-03','11:15:00',8.25),('12374','2013-05-03','11:20:00',8.28),('12374','2013-05-03','11:25:00',8.34),('12374','2013-05-03','11:30:00',8.41),('12374','2013-05-03','11:35:00',8.45),('12374','2013-05-03','11:40:00',8.48),('12374','2013-05-03','11:45:00',8.59),('12374','2013-05-03','11:50:00',8.67),('12374','2013-05-03','11:55:00',8.72),('12374','2013-05-03','12:00:00',8.75),('12374','2013-05-03','12:05:00',8.79),('12374','2013-05-03','12:10:00',8.87),('12374','2013-05-03','12:15:00',8.89),('12374','2013-05-03','12:20:00',8.91),('12374','2013-05-03','12:25:00',8.96),('12374','2013-05-03','12:30:00',8.96),('12374','2013-05-03','12:35:00',8.99),('12374','2013-05-03','12:40:00',9.01),('12374','2013-05-03','12:45:00',8.98),('12374','2013-05-03','12:50:00',8.93),('12374','2013-05-03','12:55:00',9.02),('12374','2013-05-03','13:00:00',9.05),('12374','2013-05-03','13:05:00',8.93),('12374','2013-05-03','13:10:00',8.6),('12374','2013-05-03','13:15:00',8.85),('12374','2013-05-03','13:20:00',9.05),('12374','2013-05-03','13:25:00',9.05),('12374','2013-05-03','13:30:00',8.93),('12374','2013-05-03','13:35:00',8.95),('12374','2013-05-03','13:40:00',9.03),('12374','2013-05-03','13:45:00',9.03),('12374','2013-05-03','13:50:00',8.96),('12374','2013-05-03','13:55:00',8.93),('12374','2013-05-03','14:00:00',8.88),('12374','2013-05-03','14:05:00',8.81),('12374','2013-05-03','14:10:00',8.81),('12374','2013-05-03','14:15:00',8.76),('12374','2013-05-03','14:20:00',8.68),('12374','2013-05-03','14:25:00',8.62),('12374','2013-05-03','14:30:00',8.55),('12374','2013-05-03','14:35:00',8.35),('12374','2013-05-03','14:40:00',8.32),('12374','2013-05-03','14:45:00',8.25),('12374','2013-05-03','14:50:00',8.14),('12374','2013-05-03','14:55:00',8.08),('12374','2013-05-03','15:00:00',7.98),('12374','2013-05-03','15:05:00',7.93),('12374','2013-05-03','15:10:00',7.81),('12374','2013-05-03','15:15:00',7.67),('12374','2013-05-03','15:20:00',7.6),('12374','2013-05-03','15:25:00',7.35),('12374','2013-05-03','15:30:00',7.37),('12374','2013-05-03','15:35:00',7.29),('12374','2013-05-03','15:40:00',6.97),('12374','2013-05-03','15:45:00',6.96),('12374','2013-05-03','15:50:00',6.85),('12374','2013-05-03','15:55:00',6.71),('12374','2013-05-03','16:00:00',6.6),('12374','2013-05-03','16:05:00',6.46),('12374','2013-05-03','16:10:00',6.35),('12374','2013-05-03','16:15:00',6.28),('12374','2013-05-03','16:20:00',6.12),('12374','2013-05-03','16:25:00',5.96),('12374','2013-05-03','16:30:00',5.87),('12374','2013-05-03','16:35:00',5.71),('12374','2013-05-03','16:40:00',5.51),('12374','2013-05-03','16:45:00',5.4),('12374','2013-05-03','16:50:00',5.21),('12374','2013-05-03','16:55:00',5.08),('12374','2013-05-03','17:00:00',4.88),('12374','2013-05-03','17:05:00',4.73),('12374','2013-05-03','17:10:00',4.56),('12374','2013-05-03','17:15:00',4.38),('12374','2013-05-03','17:20:00',4.16),('12374','2013-05-03','17:25:00',3.99),('12374','2013-05-03','17:30:00',3.83),('12374','2013-05-03','17:35:00',3.68),('12374','2013-05-03','17:40:00',3.48),('12374','2013-05-03','17:45:00',3.3),('12374','2013-05-03','17:50:00',3.07),('12374','2013-05-03','17:55:00',2.91),('12374','2013-05-03','18:00:00',2.7),('12374','2013-05-03','18:05:00',2.52),('12374','2013-05-03','18:10:00',2.34),('12374','2013-05-03','18:15:00',2.15),('12374','2013-05-03','18:20:00',2),('12374','2013-05-03','18:25:00',1.79),('12374','2013-05-03','18:30:00',1.65),('12374','2013-05-03','18:35:00',1.55),('12374','2013-05-03','18:40:00',1.46),('12374','2013-05-03','18:45:00',1.36),('12374','2013-05-03','18:50:00',1.25),('12374','2013-05-03','18:55:00',1.15),('12374','2013-05-02','08:30:00',1.05),('12374','2013-05-02','09:05:00',1.26),('12374','2013-05-02','09:10:00',1.65),('12374','2013-05-02','09:15:00',2.37),('12374','2013-05-02','09:20:00',1.64),('12374','2013-05-02','09:45:00',1.3),('12374','2013-05-02','09:50:00',3.42),('12374','2013-05-02','09:55:00',3.67),('12374','2013-05-02','10:00:00',5.23),('12374','2013-05-02','10:05:00',3.22),('12374','2013-05-02','10:10:00',5.65),('12374','2013-05-02','10:15:00',4.36),('12374','2013-05-02','10:20:00',4.11),('12374','2013-05-02','10:25:00',5.25),('12374','2013-05-02','10:30:00',7.37),('12374','2013-05-02','10:35:00',6.93),('12374','2013-05-02','10:40:00',5.81),('12374','2013-05-02','10:45:00',5.63),('12374','2013-05-02','10:50:00',5.81),('12374','2013-05-02','10:55:00',5.94),('12374','2013-05-02','11:00:00',4.4),('12374','2013-05-02','11:05:00',4.38),('12374','2013-05-02','11:10:00',5.13),('12374','2013-05-02','11:15:00',5.79),('12374','2013-05-02','11:20:00',7.85),('12374','2013-05-02','11:25:00',5.27),('12374','2013-05-02','11:30:00',5.1),('12374','2013-05-02','11:35:00',5),('12374','2013-05-02','11:40:00',4.46),('12374','2013-05-02','11:45:00',4.87),('12374','2013-05-02','11:50:00',5.54),('12374','2013-05-02','11:55:00',5.28),('12374','2013-05-02','12:00:00',4.71),('12374','2013-05-02','12:05:00',4.91),('12374','2013-05-02','12:10:00',6.58),('12374','2013-05-02','12:15:00',9.42),('12374','2013-05-02','12:20:00',8.71),('12374','2013-05-02','12:25:00',7.95),('12374','2013-05-02','12:30:00',7.61),('12374','2013-05-02','12:35:00',6.57),('12374','2013-05-02','12:40:00',6.56),('12374','2013-05-02','12:45:00',6.89),('12374','2013-05-02','12:50:00',8.26),('12374','2013-05-02','12:55:00',9.19),('12374','2013-05-02','13:00:00',9.22),('12374','2013-05-02','13:05:00',8.12),('12374','2013-05-02','13:10:00',9.05),('12374','2013-05-02','13:15:00',8.86),('12374','2013-05-02','13:20:00',8.87),('12374','2013-05-02','13:25:00',8.9),('12374','2013-05-02','13:30:00',8.95),('12374','2013-05-02','13:35:00',8.95),('12374','2013-05-02','13:40:00',8.94),('12374','2013-05-02','13:45:00',8.87),('12374','2013-05-02','13:50:00',8.83),('12374','2013-05-02','13:55:00',8.8),('12374','2013-05-02','14:00:00',8.73),('12374','2013-05-02','14:05:00',8.67),('12374','2013-05-02','14:10:00',8.68),('12374','2013-05-02','14:15:00',8.62),('12374','2013-05-02','14:20:00',8.52),('12374','2013-05-02','14:25:00',8.44),('12374','2013-05-02','14:30:00',8.4),('12374','2013-05-02','14:35:00',8.38),('12374','2013-05-02','14:40:00',8.32),('12374','2013-05-02','14:45:00',8.24),('12374','2013-05-02','14:50:00',8.16),('12374','2013-05-02','14:55:00',8.06),('12374','2013-05-02','15:00:00',7.99),('12374','2013-05-02','15:05:00',7.85),('12374','2013-05-02','15:10:00',7.72),('12374','2013-05-02','15:15:00',7.65),('12374','2013-05-02','15:20:00',7.52),('12374','2013-05-02','15:25:00',7.45),('12374','2013-05-02','15:30:00',7.37),('12374','2013-05-02','15:35:00',7.24),('12374','2013-05-02','15:40:00',7.07),('12374','2013-05-02','15:45:00',6.95),('12374','2013-05-02','15:50:00',6.8),('12374','2013-05-02','15:55:00',6.75),('12374','2013-05-02','16:00:00',6.62),('12374','2013-05-02','16:05:00',6.5),('12374','2013-05-02','16:10:00',6.33),('12374','2013-05-02','16:15:00',6.16),('12374','2013-05-02','16:20:00',6.04),('12374','2013-05-02','16:25:00',5.98),('12374','2013-05-02','16:30:00',5.85),('12374','2013-05-02','16:35:00',5.69),('12374','2013-05-02','16:40:00',5.51),('12374','2013-05-02','16:45:00',5.37),('12374','2013-05-02','16:50:00',5.22),('12374','2013-05-02','16:55:00',5.07),('12374','2013-05-02','17:00:00',4.93),('12374','2013-05-02','17:05:00',4.78),('12374','2013-05-02','17:10:00',4.59),('12374','2013-05-02','17:15:00',4.41),('12374','2013-05-02','17:20:00',4.23),('12374','2013-05-02','17:25:00',3.86),('12374','2013-05-02','17:30:00',3.84),('12374','2013-05-02','17:35:00',3.64),('12374','2013-05-02','17:40:00',3.49),('12374','2013-05-02','17:45:00',3.31),('12374','2013-05-02','17:50:00',3.08),('12374','2013-05-02','17:55:00',2.91),('12374','2013-05-02','18:00:00',2.7),('12374','2013-05-02','18:05:00',2.55),('12374','2013-05-02','18:10:00',2.29),('12374','2013-05-02','18:15:00',2.17),('12374','2013-05-02','18:20:00',2.06),('12374','2013-05-02','18:25:00',1.84),('12374','2013-05-02','18:30:00',1.69),('12374','2013-05-02','18:35:00',1.59),('12374','2013-05-02','18:40:00',1.49),('12374','2013-05-02','18:45:00',1.39),('12374','2013-05-02','18:50:00',1.29),('12374','2013-05-02','18:55:00',1.19),('12374','2013-05-02','19:00:00',1.09),('12374','2013-05-01','07:15:00',1.11),('12374','2013-05-01','07:20:00',1.3),('12374','2013-05-01','07:25:00',1.47),('12374','2013-05-01','07:30:00',1.59),('12374','2013-05-01','07:35:00',1.81),('12374','2013-05-01','07:40:00',1.82),('12374','2013-05-01','07:45:00',2.11),('12374','2013-05-01','07:50:00',2.23),('12374','2013-05-01','07:55:00',2.4),('12374','2013-05-01','08:00:00',2.6),('12374','2013-05-01','08:05:00',2.81),('12374','2013-05-01','08:10:00',2.98),('12374','2013-05-01','08:15:00',3.21),('12374','2013-05-01','08:20:00',3.4),('12374','2013-05-01','08:25:00',3.56),('12374','2013-05-01','08:30:00',3.71),('12374','2013-05-01','08:35:00',3.9),('12374','2013-05-01','08:40:00',4.08),('12374','2013-05-01','08:45:00',4.3),('12374','2013-05-01','08:50:00',4.49),('12374','2013-05-01','08:55:00',4.62),('12374','2013-05-01','09:00:00',4.7),('12374','2013-05-01','09:05:00',4.8),('12374','2013-05-01','09:10:00',5.04),('12374','2013-05-01','09:15:00',5.2),('12374','2013-05-01','09:20:00',5.36),('12374','2013-05-01','09:25:00',5.47),('12374','2013-05-01','09:30:00',5.54),('12374','2013-05-01','09:35:00',5.62),('12374','2013-05-01','09:40:00',5.75),('12374','2013-05-01','09:45:00',5.92),('12374','2013-05-01','09:50:00',6.06),('12374','2013-05-01','09:55:00',6.24),('12374','2013-05-01','10:00:00',6.38),('12374','2013-05-01','10:05:00',6.48),('12374','2013-05-01','10:10:00',6.63),('12374','2013-05-01','10:15:00',6.8),('12374','2013-05-01','10:20:00',6.93),('12374','2013-05-01','10:25:00',7),('12374','2013-05-01','10:30:00',7.1),('12374','2013-05-01','10:35:00',7.24),('12374','2013-05-01','10:40:00',7.35),('12374','2013-05-01','10:45:00',7.43),('12374','2013-05-01','10:50:00',7.51),('12374','2013-05-01','10:55:00',7.54),('12374','2013-05-01','11:00:00',7.6),('12374','2013-05-01','11:05:00',7.73),('12374','2013-05-01','11:10:00',7.77),('12374','2013-05-01','11:15:00',7.82),('12374','2013-05-01','11:20:00',7.9),('12374','2013-05-01','11:25:00',7.94),('12374','2013-05-01','11:30:00',8.11),('12374','2013-05-01','11:35:00',8.17),('12374','2013-05-01','11:40:00',8.25),('12374','2013-05-01','11:45:00',8.28),('12374','2013-05-01','11:50:00',8.3),('12374','2013-05-01','11:55:00',8.31),('12374','2013-05-01','12:00:00',8.36),('12374','2013-05-01','12:05:00',8.47),('12374','2013-05-01','12:10:00',8.65),('12374','2013-05-01','12:15:00',6.16),('12374','2013-05-01','12:20:00',6.18),('12374','2013-05-01','12:25:00',5.37),('12374','2013-05-01','12:30:00',5.63),('12374','2013-05-01','12:35:00',5.11),('12374','2013-05-01','12:40:00',4.15),('12374','2013-05-01','12:45:00',6.28),('12374','2013-05-01','12:50:00',8.46),('12374','2013-05-01','12:55:00',8.76),('12374','2013-05-01','13:00:00',8.26),('12374','2013-05-01','13:05:00',6.56),('12374','2013-05-01','13:10:00',6.97),('12374','2013-05-01','13:15:00',8.62),('12374','2013-05-01','13:20:00',8.63),('12374','2013-05-01','13:25:00',8.8),('12374','2013-05-01','13:30:00',8.84),('12374','2013-05-01','13:35:00',8.82),('12374','2013-05-01','13:40:00',8.69),('12374','2013-05-01','13:45:00',8.71),('12374','2013-05-01','13:50:00',8.48),('12374','2013-05-01','13:55:00',7.49),('12374','2013-05-01','14:00:00',7.95),('12374','2013-05-01','14:05:00',8.78),('12374','2013-05-01','14:10:00',7.1),('12374','2013-05-01','14:15:00',6.36),('12374','2013-05-01','14:20:00',7.65),('12374','2013-05-01','14:25:00',7.38),('12374','2013-05-01','14:30:00',8.68),('12374','2013-05-01','14:35:00',8.44),('12374','2013-05-01','14:40:00',7.96),('12374','2013-05-01','14:45:00',8.04),('12374','2013-05-01','14:50:00',4.6),('12374','2013-05-01','14:55:00',3.88),('12374','2013-05-01','15:00:00',5.4),('12374','2013-05-01','15:05:00',4.53),('12374','2013-05-01','15:10:00',5),('12374','2013-05-01','15:15:00',4.82),('12374','2013-05-01','15:20:00',4.42),('12374','2013-05-01','15:25:00',4.53),('12374','2013-05-01','15:30:00',4.24),('12374','2013-05-01','15:35:00',4.68),('12374','2013-05-01','15:40:00',5.02),('12374','2013-05-01','15:45:00',4.68),('12374','2013-05-01','15:50:00',4.35),('12374','2013-05-01','15:55:00',3.54),('12374','2013-05-01','16:00:00',3.49),('12374','2013-05-01','16:05:00',4.57),('12374','2013-05-01','16:10:00',5.15),('12374','2013-05-01','16:15:00',4.8),('12374','2013-05-01','16:20:00',4.05),('12374','2013-05-01','16:25:00',2.91),('12374','2013-05-01','16:30:00',2.66),('12374','2013-05-01','16:35:00',2.58),('12374','2013-05-01','16:40:00',2.27),('12374','2013-05-01','16:45:00',1.99),('12374','2013-05-01','16:50:00',1.96),('12374','2013-05-01','16:55:00',2),('12374','2013-05-01','17:00:00',1.88),('12374','2013-05-01','17:05:00',1.6),('12374','2013-05-01','17:10:00',1.32),('12374','2013-05-01','17:15:00',1.11),('12374','2013-04-30','07:55:00',1.01),('12374','2013-04-30','08:00:00',1.58),('12374','2013-04-30','08:05:00',2.15),('12374','2013-04-30','08:10:00',2.17),('12374','2013-04-30','08:15:00',2.11),('12374','2013-04-30','08:20:00',1.96),('12374','2013-04-30','08:25:00',1.61),('12374','2013-04-30','08:30:00',1.74),('12374','2013-04-30','08:35:00',1.75),('12374','2013-04-30','08:40:00',1.72),('12374','2013-04-30','08:45:00',1.84),('12374','2013-04-30','08:50:00',2.04),('12374','2013-04-30','08:55:00',2.72),('12374','2013-04-30','09:00:00',3.24),('12374','2013-04-30','09:05:00',4.29),('12374','2013-04-30','09:10:00',4.43),('12374','2013-04-30','09:15:00',4.47),('12374','2013-04-30','09:20:00',3.8),('12374','2013-04-30','09:25:00',3.01),('12374','2013-04-30','09:30:00',4.77),('12374','2013-04-30','09:35:00',5.57),('12374','2013-04-30','09:40:00',4.83),('12374','2013-04-30','09:45:00',3.8),('12374','2013-04-30','09:50:00',3.13),('12374','2013-04-30','09:55:00',3.08),('12374','2013-04-30','10:00:00',1.9),('12374','2013-04-30','10:05:00',1.42),('12374','2013-04-30','10:10:00',1.38),('12374','2013-04-30','10:15:00',1.37),('12374','2013-04-30','10:20:00',1.48),('12374','2013-04-30','10:25:00',1.61),('12374','2013-04-30','10:30:00',1.75),('12374','2013-04-30','10:35:00',2.59),('12374','2013-04-30','10:40:00',3.66),('12374','2013-04-30','10:45:00',3.42),('12374','2013-04-30','10:50:00',3.66),('12374','2013-04-30','10:55:00',4.26),('12374','2013-04-30','11:00:00',5.06),('12374','2013-04-30','11:05:00',5.8),('12374','2013-04-30','11:10:00',5.22),('12374','2013-04-30','11:15:00',3.85),('12374','2013-04-30','11:20:00',4.23),('12374','2013-04-30','11:25:00',6.74),('12374','2013-04-30','11:30:00',5.34),('12374','2013-04-30','11:35:00',4.83),('12374','2013-04-30','11:40:00',5.44),('12374','2013-04-30','11:45:00',8),('12374','2013-04-30','11:50:00',7.9),('12374','2013-04-30','11:55:00',6.13),('12374','2013-04-30','12:00:00',4.38),('12374','2013-04-30','12:05:00',4.73),('12374','2013-04-30','12:10:00',4.24),('12374','2013-04-30','12:15:00',3.95),('12374','2013-04-30','12:20:00',4.36),('12374','2013-04-30','12:25:00',5.42),('12374','2013-04-30','12:30:00',6.1),('12374','2013-04-30','12:35:00',6.18),('12374','2013-04-30','12:40:00',7.27),('12374','2013-04-30','12:45:00',8.29),('12374','2013-04-30','12:50:00',8.55),('12374','2013-04-30','12:55:00',8.75),('12374','2013-04-30','13:00:00',8.5),('12374','2013-04-30','13:05:00',9.06),('12374','2013-04-30','13:10:00',8.9),('12374','2013-04-30','13:15:00',8.95),('12374','2013-04-30','13:20:00',8.89),('12374','2013-04-30','13:25:00',8.87),('12374','2013-04-30','13:30:00',8.83),('12374','2013-04-30','13:35:00',8.76),('12374','2013-04-30','13:40:00',8.68),('12374','2013-04-30','13:45:00',8.65),('12374','2013-04-30','13:50:00',8.59),('12374','2013-04-30','13:55:00',8.58),('12374','2013-04-30','14:00:00',8.52),('12374','2013-04-30','14:05:00',8.46),('12374','2013-04-30','14:10:00',8.38),('12374','2013-04-30','14:15:00',8.36),('12374','2013-04-30','14:20:00',8.28),('12374','2013-04-30','14:25:00',8.19),('12374','2013-04-30','14:30:00',8.09),('12374','2013-04-30','14:35:00',8.02),('12374','2013-04-30','14:40:00',7.96),('12374','2013-04-30','14:45:00',7.86),('12374','2013-04-30','14:50:00',7.74),('12374','2013-04-30','14:55:00',7.6),('12374','2013-04-30','15:00:00',7.45),('12374','2013-04-30','15:05:00',7.38),('12374','2013-04-30','15:10:00',7.2),('12374','2013-04-30','15:15:00',6.95),('12374','2013-04-30','15:20:00',7),('12374','2013-04-30','15:25:00',6.95),('12374','2013-04-30','15:30:00',6.88),('12374','2013-04-30','15:35:00',6.91),('12374','2013-04-30','15:40:00',6.43),('12374','2013-04-30','15:45:00',3.93),('12374','2013-04-30','15:50:00',5.27),('12374','2013-04-30','15:55:00',6.64),('12374','2013-04-30','16:00:00',5.89),('12374','2013-04-30','16:05:00',5.7),('12374','2013-04-30','16:10:00',6.33),('12374','2013-04-30','16:15:00',4.86),('12374','2013-04-30','16:20:00',4.06),('12374','2013-04-30','16:25:00',3.56),('12374','2013-04-30','16:30:00',3.84),('12374','2013-04-30','16:35:00',3.78),('12374','2013-04-30','16:40:00',3.36),('12374','2013-04-30','16:45:00',3.25),('12374','2013-04-30','16:50:00',3.32),('12374','2013-04-30','16:55:00',3.96),('12374','2013-04-30','17:00:00',3.85),('12374','2013-04-30','17:05:00',3.07),('12374','2013-04-30','17:10:00',3.81),('12374','2013-04-30','17:15:00',3.85),('12374','2013-04-30','17:20:00',2.69),('12374','2013-04-30','17:25:00',3.34),('12374','2013-04-30','17:30:00',3.25),('12374','2013-04-30','17:35:00',3.04),('12374','2013-04-30','17:40:00',2.8),('12374','2013-04-30','17:45:00',2.58),('12374','2013-04-30','17:50:00',2.44),('12374','2013-04-30','17:55:00',2.22),('12374','2013-04-30','18:00:00',2.06),('12374','2013-04-30','18:05:00',1.97),('12374','2013-04-30','18:10:00',1.55),('12374','2013-04-30','18:15:00',1.56),('12374','2013-04-30','18:20:00',1.5),('12374','2013-04-30','18:25:00',1.49),('12374','2013-04-30','18:30:00',1.42),('12374','2013-04-30','18:35:00',1.32),('12374','2013-04-30','18:40:00',1.15),('12374','2013-04-29','07:10:00',1.04),('12374','2013-04-29','07:15:00',1.25),('12374','2013-04-29','07:20:00',1.38),('12374','2013-04-29','07:25:00',1.36),('12374','2013-04-29','07:30:00',1.27),('12374','2013-04-29','07:35:00',1.47),('12374','2013-04-29','07:40:00',1.73),('12374','2013-04-29','07:45:00',1.99),('12374','2013-04-29','07:50:00',2.38),('12374','2013-04-29','07:55:00',2.48),('12374','2013-04-29','08:00:00',2.56),('12374','2013-04-29','08:05:00',2.75),('12374','2013-04-29','08:10:00',2.51),('12374','2013-04-29','08:15:00',2.46),('12374','2013-04-29','08:20:00',2.93),('12374','2013-04-29','08:25:00',2.84),('12374','2013-04-29','08:30:00',3.19),('12374','2013-04-29','08:35:00',3.44),('12374','2013-04-29','08:40:00',3.3),('12374','2013-04-29','08:45:00',4.12),('12374','2013-04-29','08:50:00',4.42),('12374','2013-04-29','08:55:00',4.5),('12374','2013-04-29','09:00:00',4.69),('12374','2013-04-29','09:05:00',5.09),('12374','2013-04-29','09:10:00',5.34),('12374','2013-04-29','09:15:00',4.82),('12374','2013-04-29','09:20:00',5.22),('12374','2013-04-29','09:25:00',4.94),('12374','2013-04-29','09:30:00',5.17),('12374','2013-04-29','09:35:00',5.42),('12374','2013-04-29','09:40:00',5.7),('12374','2013-04-29','09:45:00',5.85),('12374','2013-04-29','09:50:00',6.05),('12374','2013-04-29','09:55:00',6.07),('12374','2013-04-29','10:00:00',6.21),('12374','2013-04-29','10:05:00',6.15),('12374','2013-04-29','10:10:00',6.02),('12374','2013-04-29','10:15:00',6.25),('12374','2013-04-29','10:20:00',6.08),('12374','2013-04-29','10:25:00',6.59),('12374','2013-04-29','10:30:00',6.63),('12374','2013-04-29','10:35:00',6.39),('12374','2013-04-29','10:40:00',6.81),('12374','2013-04-29','10:45:00',7.18),('12374','2013-04-29','10:50:00',7.49),('12374','2013-04-29','10:55:00',7.17),('12374','2013-04-29','11:00:00',7.44),('12374','2013-04-29','11:05:00',7.57),('12374','2013-04-29','11:10:00',7.57),('12374','2013-04-29','11:15:00',7.67),('12374','2013-04-29','11:20:00',7.94),('12374','2013-04-29','11:25:00',8.17),('12374','2013-04-29','11:30:00',8.18),('12374','2013-04-29','11:35:00',8.11),('12374','2013-04-29','11:40:00',7.72),('12374','2013-04-29','11:45:00',7.98),('12374','2013-04-29','11:50:00',8.34),('12374','2013-04-29','11:55:00',8.21),('12374','2013-04-29','12:00:00',8.4),('12374','2013-04-29','12:05:00',8.52),('12374','2013-04-29','12:10:00',8.63),('12374','2013-04-29','12:15:00',8.66),('12374','2013-04-29','12:20:00',8.62),('12374','2013-04-29','12:25:00',8.85),('12374','2013-04-29','12:30:00',8.82),('12374','2013-04-29','12:35:00',8.66),('12374','2013-04-29','12:40:00',8.51),('12374','2013-04-29','12:45:00',8.68),('12374','2013-04-29','12:50:00',8.69),('12374','2013-04-29','12:55:00',8.81),('12374','2013-04-29','13:00:00',8.88),('12374','2013-04-29','13:05:00',8.86),('12374','2013-04-29','13:10:00',8.62),('12374','2013-04-29','13:15:00',8.42),('12374','2013-04-29','13:20:00',8.5),('12374','2013-04-29','13:25:00',8.12),('12374','2013-04-29','13:30:00',8.09),('12374','2013-04-29','13:35:00',8.35),('12374','2013-04-29','13:40:00',8.28),('12374','2013-04-29','13:45:00',7.76),('12374','2013-04-29','13:50:00',7.7),('12374','2013-04-29','13:55:00',7.33),('12374','2013-04-29','14:00:00',7.35),('12374','2013-04-29','14:05:00',6.99),('12374','2013-04-29','14:10:00',6.93),('12374','2013-04-29','14:15:00',7.1),('12374','2013-04-29','14:20:00',7.26),('12374','2013-04-29','14:25:00',7.28),('12374','2013-04-29','14:30:00',6.75),('12374','2013-04-29','14:35:00',6.9),('12374','2013-04-29','14:40:00',7.2),('12374','2013-04-29','14:45:00',7.19),('12374','2013-04-29','14:50:00',6.59),('12374','2013-04-29','14:55:00',6.73),('12374','2013-04-29','15:00:00',7.07),('12374','2013-04-29','15:05:00',6.99),('12374','2013-04-29','15:10:00',6.35),('12374','2013-04-29','15:15:00',6.17),('12374','2013-04-29','15:20:00',5.95),('12374','2013-04-29','15:25:00',6.19),('12374','2013-04-29','15:30:00',5.91),('12374','2013-04-29','15:35:00',6.25),('12374','2013-04-29','15:40:00',6.52),('12374','2013-04-29','15:45:00',6.53),('12374','2013-04-29','15:50:00',6.07),('12374','2013-04-29','15:55:00',5.97),('12374','2013-04-29','16:00:00',5.97),('12374','2013-04-29','16:05:00',5.9),('12374','2013-04-29','16:10:00',6.1),('12374','2013-04-29','16:15:00',6.14),('12374','2013-04-29','16:20:00',6.29),('12374','2013-04-29','16:25:00',5.86),('12374','2013-04-29','16:30:00',6),('12374','2013-04-29','16:35:00',5.9),('12374','2013-04-29','16:40:00',5.07),('12374','2013-04-29','16:45:00',5.49),('12374','2013-04-29','16:50:00',5.52),('12374','2013-04-29','16:55:00',4.56),('12374','2013-04-29','17:00:00',2.72),('12374','2013-04-29','17:05:00',3.44),('12374','2013-04-29','17:10:00',4.46),('12374','2013-04-29','17:15:00',4.71),('12374','2013-04-29','17:20:00',4.52),('12374','2013-04-29','17:25:00',4.26),('12374','2013-04-29','17:30:00',4.12),('12374','2013-04-29','17:35:00',3.86),('12374','2013-04-29','17:40:00',3.79),('12374','2013-04-29','17:45:00',3.42),('12374','2013-04-29','17:50:00',3.39),('12374','2013-04-29','17:55:00',2.94),('12374','2013-04-29','18:00:00',3.06),('12374','2013-04-29','18:05:00',2.86),('12374','2013-04-29','18:10:00',2.41),('12374','2013-04-29','18:15:00',2.22),('12374','2013-04-29','18:20:00',2.04),('12374','2013-04-29','18:25:00',1.83),('12374','2013-04-29','18:30:00',1.53),('12374','2013-04-29','18:35:00',1.33),('12374','2013-04-28','07:00:00',1.01),('12374','2013-04-28','07:05:00',1.17),('12374','2013-04-28','07:10:00',1.31),('12374','2013-04-28','07:15:00',1.33),('12374','2013-04-28','07:20:00',1.69),('12374','2013-04-28','07:25:00',1.87),('12374','2013-04-28','07:30:00',2.04),('12374','2013-04-28','07:35:00',2.13),('12374','2013-04-28','07:40:00',2.06),('12374','2013-04-28','07:45:00',2.55),('12374','2013-04-28','07:50:00',2.7),('12374','2013-04-28','07:55:00',2.88),('12374','2013-04-28','08:00:00',3.11),('12374','2013-04-28','08:05:00',3.34),('12374','2013-04-28','08:10:00',3.62),('12374','2013-04-28','08:15:00',3.63),('12374','2013-04-28','08:20:00',3.01),('12374','2013-04-28','08:25:00',3.77),('12374','2013-04-28','08:30:00',4.19),('12374','2013-04-28','08:35:00',4.32),('12374','2013-04-28','08:40:00',4.49),('12374','2013-04-28','08:45:00',4.62),('12374','2013-04-28','08:50:00',4.77),('12374','2013-04-28','08:55:00',4.96),('12374','2013-04-28','09:00:00',5.11),('12374','2013-04-28','09:05:00',5.24),('12374','2013-04-28','09:10:00',5.39),('12374','2013-04-28','09:15:00',5.56),('12374','2013-04-28','09:20:00',5.7),('12374','2013-04-28','09:25:00',5.79),('12374','2013-04-28','09:30:00',5.93),('12374','2013-04-28','09:35:00',6.1),('12374','2013-04-28','09:40:00',6.24),('12374','2013-04-28','09:45:00',6.37),('12374','2013-04-28','09:50:00',6.51),('12374','2013-04-28','09:55:00',6.64),('12374','2013-04-28','10:00:00',6.77),('12374','2013-04-28','10:05:00',6.89),('12374','2013-04-28','10:10:00',7),('12374','2013-04-28','10:15:00',7.13),('12374','2013-04-28','10:20:00',7.15),('12374','2013-04-28','10:25:00',7.14),('12374','2013-04-28','10:30:00',7.28),('12374','2013-04-28','10:35:00',7.57),('12374','2013-04-28','10:40:00',7.55),('12374','2013-04-28','10:45:00',7.51),('12374','2013-04-28','10:50:00',7.66),('12374','2013-04-28','10:55:00',7.87),('12374','2013-04-28','11:00:00',8.01),('12374','2013-04-28','11:05:00',8.1),('12374','2013-04-28','11:10:00',8.22),('12374','2013-04-28','11:15:00',7.5),('12374','2013-04-28','11:20:00',7.58),('12374','2013-04-28','11:25:00',8.27),('12374','2013-04-28','11:30:00',8.21),('12374','2013-04-28','11:35:00',8.39),('12374','2013-04-28','11:40:00',8.58),('12374','2013-04-28','11:45:00',7.97),('12374','2013-04-28','11:50:00',7.84),('12374','2013-04-28','11:55:00',7.99),('12374','2013-04-28','12:00:00',8.39),('12374','2013-04-28','12:05:00',8.62),('12374','2013-04-28','12:10:00',8.16),('12374','2013-04-28','12:15:00',8.44),('12374','2013-04-28','12:20:00',8.47),('12374','2013-04-28','12:25:00',9.12),('12374','2013-04-28','12:30:00',8.34),('12374','2013-04-28','12:35:00',7.79),('12374','2013-04-28','12:40:00',7.99),('12374','2013-04-28','12:45:00',8.72),('12374','2013-04-28','12:50:00',9.16),('12374','2013-04-28','12:55:00',8.76),('12374','2013-04-28','13:00:00',8.65),('12374','2013-04-28','13:05:00',8.58),('12374','2013-04-28','13:10:00',8.49),('12374','2013-04-28','13:15:00',9.01),('12374','2013-04-28','13:20:00',9.09),('12374','2013-04-28','13:25:00',8.68),('12374','2013-04-28','13:30:00',8.1),('12374','2013-04-28','13:35:00',8.41),('12374','2013-04-28','13:40:00',8.76),('12374','2013-04-28','13:45:00',8.99),('12374','2013-04-28','13:50:00',8.94),('12374','2013-04-28','13:55:00',8.77),('12374','2013-04-28','14:00:00',8.77),('12374','2013-04-28','14:05:00',8.71),('12374','2013-04-28','14:10:00',8.65),('12374','2013-04-28','14:15:00',8.53),('12374','2013-04-28','14:20:00',8.47),('12374','2013-04-28','14:25:00',8.37),('12374','2013-04-28','14:30:00',8.32),('12374','2013-04-28','14:35:00',8.3),('12374','2013-04-28','14:40:00',8.21),('12374','2013-04-28','14:45:00',8.09),('12374','2013-04-28','14:50:00',7.93),('12374','2013-04-28','14:55:00',7.86),('12374','2013-04-28','15:00:00',7.82),('12374','2013-04-28','15:05:00',7.75),('12374','2013-04-28','15:10:00',7.66),('12374','2013-04-28','15:15:00',7.55),('12374','2013-04-28','15:20:00',7.45),('12374','2013-04-28','15:25:00',7.3),('12374','2013-04-28','15:30:00',7.23),('12374','2013-04-28','15:35:00',7.12),('12374','2013-04-28','15:40:00',6.99),('12374','2013-04-28','15:45:00',6.86),('12374','2013-04-28','15:50:00',6.71),('12374','2013-04-28','15:55:00',6.64),('12374','2013-04-28','16:00:00',6.48),('12374','2013-04-28','16:05:00',6.39),('12374','2013-04-28','16:10:00',6.2),('12374','2013-04-28','16:15:00',6.05),('12374','2013-04-28','16:20:00',5.92),('12374','2013-04-28','16:25:00',5.79),('12374','2013-04-28','16:30:00',5.61),('12374','2013-04-28','16:35:00',5.5),('12374','2013-04-28','16:40:00',5.35),('12374','2013-04-28','16:45:00',5.2),('12374','2013-04-28','16:50:00',5.05),('12374','2013-04-28','16:55:00',4.87),('12374','2013-04-28','17:00:00',4.42),('12374','2013-04-28','17:05:00',4.43),('12374','2013-04-28','17:10:00',4.35),('12374','2013-04-28','17:15:00',4.35),('12374','2013-04-28','17:20:00',4.03),('12374','2013-04-28','17:25:00',3.77),('12374','2013-04-28','17:30:00',3.69),('12374','2013-04-28','17:35:00',3.08),('12374','2013-04-28','17:40:00',3.32),('12374','2013-04-28','17:45:00',3.19),('12374','2013-04-28','17:50:00',2.91),('12374','2013-04-28','17:55:00',2.59),('12374','2013-04-28','18:00:00',2.13),('12374','2013-04-28','18:05:00',1.88),('12374','2013-04-28','18:10:00',2.1),('12374','2013-04-28','18:15:00',1.77),('12374','2013-04-28','18:20:00',1.67),('12374','2013-04-28','18:25:00',1.32),('12374','2013-04-28','18:30:00',1.27),('12374','2013-04-28','18:35:00',1.25),('12374','2013-04-28','18:40:00',1.24),('12374','2013-04-28','18:45:00',1.38),('12374','2013-04-28','18:50:00',1.39),('12374','2013-04-28','18:55:00',1.34),('12374','2013-04-28','19:00:00',1.15),('12374','2013-04-28','19:05:00',1.03),('12374','2013-04-27','07:30:00',1.07),('12374','2013-04-27','07:35:00',1.24),('12374','2013-04-27','07:40:00',1.34),('12374','2013-04-27','07:45:00',1.45),('12374','2013-04-27','07:50:00',1.22),('12374','2013-04-27','12:00:00',1.1),('12374','2013-04-27','12:05:00',1.11),('12374','2013-04-27','12:10:00',1.74),('12374','2013-04-27','12:15:00',1.56),('12374','2013-04-27','12:20:00',1.62),('12374','2013-04-27','12:25:00',1.35),('12374','2013-04-27','12:30:00',1.41),('12374','2013-04-27','12:35:00',1.98),('12374','2013-04-27','12:40:00',3.17),('12374','2013-04-27','12:45:00',3.08),('12374','2013-04-27','12:50:00',3.13),('12374','2013-04-27','12:55:00',4.02),('12374','2013-04-27','13:00:00',2.77),('12374','2013-04-27','13:05:00',3.21),('12374','2013-04-27','13:10:00',3.26),('12374','2013-04-27','13:15:00',2.39),('12374','2013-04-27','13:20:00',2.27),('12374','2013-04-27','13:25:00',2.15),('12374','2013-04-27','13:30:00',2.21),('12374','2013-04-27','13:35:00',2.19),('12374','2013-04-27','13:40:00',2.91),('12374','2013-04-27','13:45:00',1.76),('12374','2013-04-27','13:50:00',1.73),('12374','2013-04-27','13:55:00',1.67),('12374','2013-04-27','14:00:00',2.45),('12374','2013-04-27','14:05:00',5.16),('12374','2013-04-27','14:10:00',4.08),('12374','2013-04-27','14:15:00',3.29),('12374','2013-04-27','14:20:00',4.03),('12374','2013-04-27','14:25:00',3.65),('12374','2013-04-27','14:30:00',1.97),('12374','2013-04-27','14:35:00',1.88),('12374','2013-04-27','14:40:00',2.16),('12374','2013-04-27','14:45:00',2.16),('12374','2013-04-27','14:50:00',1.78),('12374','2013-04-27','14:55:00',1.16),('12374','2013-04-27','15:30:00',1.24),('12374','2013-04-27','15:35:00',1.9),('12374','2013-04-27','15:40:00',1.38),('12374','2013-04-27','16:15:00',1.3),('12374','2013-04-27','16:20:00',3.45),('12374','2013-04-27','16:25:00',3.55),('12374','2013-04-27','16:30:00',1.91),('12374','2013-04-27','16:35:00',3.65),('12374','2013-04-27','16:40:00',3.52),('12374','2013-04-27','16:45:00',3.22),('12374','2013-04-27','16:50:00',3.09),('12374','2013-04-27','16:55:00',3.59),('12374','2013-04-27','17:00:00',2.55),('12374','2013-04-27','17:05:00',2.32),('12374','2013-04-27','17:10:00',1.83),('12374','2013-04-27','17:15:00',1.05),('12374','2013-04-27','17:20:00',1.14),('12374','2013-04-27','17:25:00',2.2),('12374','2013-04-27','17:30:00',1.89),('12374','2013-04-27','17:35:00',1.32),('12374','2013-04-27','17:50:00',1.21),('12374','2013-04-27','17:55:00',1.53),('12374','2013-04-27','18:00:00',1.58),('12374','2013-04-27','18:05:00',1.49),('12374','2013-04-27','18:20:00',1.05),('12374','2013-04-26','07:35:00',1.05),('12374','2013-04-26','07:40:00',1.16),('12374','2013-04-26','07:45:00',1.48),('12374','2013-04-26','07:50:00',1.77),('12374','2013-04-26','07:55:00',2.13),('12374','2013-04-26','08:00:00',2.38),('12374','2013-04-26','08:05:00',2.65),('12374','2013-04-26','08:10:00',2.91),('12374','2013-04-26','08:15:00',3.02),('12374','2013-04-26','08:20:00',3.12),('12374','2013-04-26','08:25:00',3.34),('12374','2013-04-26','08:30:00',3.43),('12374','2013-04-26','08:35:00',2.9),('12374','2013-04-26','08:40:00',2.6),('12374','2013-04-26','08:45:00',2.41),('12374','2013-04-26','08:50:00',2.43),('12374','2013-04-26','08:55:00',2.2),('12374','2013-04-26','09:00:00',2.51),('12374','2013-04-26','09:05:00',3.62),('12374','2013-04-26','09:10:00',4.22),('12374','2013-04-26','09:15:00',4.98),('12374','2013-04-26','09:20:00',5.37),('12374','2013-04-26','09:25:00',5.49),('12374','2013-04-26','09:30:00',5.65),('12374','2013-04-26','09:35:00',5.85),('12374','2013-04-26','09:40:00',6.16),('12374','2013-04-26','09:45:00',6.65),('12374','2013-04-26','09:50:00',7.2),('12374','2013-04-26','09:55:00',6.93),('12374','2013-04-26','10:00:00',4.77),('12374','2013-04-26','10:05:00',5.3),('12374','2013-04-26','10:10:00',5.19),('12374','2013-04-26','10:15:00',5.5),('12374','2013-04-26','10:20:00',5.55),('12374','2013-04-26','10:25:00',5.51),('12374','2013-04-26','10:30:00',5.79),('12374','2013-04-26','10:35:00',5.11),('12374','2013-04-26','10:40:00',4.94),('12374','2013-04-26','10:45:00',5.82),('12374','2013-04-26','10:50:00',6.13),('12374','2013-04-26','10:55:00',6.49),('12374','2013-04-26','11:00:00',5.56),('12374','2013-04-26','11:05:00',5.7),('12374','2013-04-26','11:10:00',5.39),('12374','2013-04-26','11:15:00',5.02),('12374','2013-04-26','11:20:00',4.79),('12374','2013-04-26','11:25:00',4.53),('12374','2013-04-26','11:30:00',4.53),('12374','2013-04-26','11:35:00',5.03),('12374','2013-04-26','11:40:00',5.52),('12374','2013-04-26','11:45:00',7.15),('12374','2013-04-26','11:50:00',5.01),('12374','2013-04-26','11:55:00',3.57),('12374','2013-04-26','12:00:00',3.73),('12374','2013-04-26','12:05:00',6.77),('12374','2013-04-26','12:10:00',7.35),('12374','2013-04-26','12:15:00',7.52),('12374','2013-04-26','12:20:00',8.94),('12374','2013-04-26','12:25:00',7.33),('12374','2013-04-26','12:30:00',9.04),('12374','2013-04-26','12:35:00',8.19),('12374','2013-04-26','12:40:00',6.53),('12374','2013-04-26','12:45:00',4.97),('12374','2013-04-26','12:50:00',4.16),('12374','2013-04-26','12:55:00',5.21),('12374','2013-04-26','13:00:00',4.4),('12374','2013-04-26','13:05:00',4.65),('12374','2013-04-26','13:10:00',4.26),('12374','2013-04-26','13:15:00',3.53),('12374','2013-04-26','13:20:00',5.16),('12374','2013-04-26','13:25:00',6.06),('12374','2013-04-26','13:30:00',4.73),('12374','2013-04-26','13:35:00',9.29),('12374','2013-04-26','13:40:00',5.99),('12374','2013-04-26','13:45:00',5.76),('12374','2013-04-26','13:50:00',7.21),('12374','2013-04-26','13:55:00',5.67),('12374','2013-04-26','14:00:00',5.41),('12374','2013-04-26','14:05:00',6.99),('12374','2013-04-26','14:10:00',7.89),('12374','2013-04-26','14:15:00',7.79),('12374','2013-04-26','14:20:00',3.77),('12374','2013-04-26','14:25:00',3.9),('12374','2013-04-26','14:30:00',2.99),('12374','2013-04-26','14:35:00',2.93),('12374','2013-04-26','14:40:00',3.96),('12374','2013-04-26','14:45:00',3.45),('12374','2013-04-26','14:50:00',4.39),('12374','2013-04-26','14:55:00',3.36),('12374','2013-04-26','15:00:00',2.15),('12374','2013-04-26','15:05:00',2.28),('12374','2013-04-26','15:10:00',1.87),('12374','2013-04-25','07:30:00',1.02),('12374','2013-04-25','07:35:00',1.17),('12374','2013-04-25','07:40:00',1.33),('12374','2013-04-25','07:45:00',1.74),('12374','2013-04-25','07:50:00',1.83),('12374','2013-04-25','07:55:00',1.65),('12374','2013-04-25','08:00:00',1.72),('12374','2013-04-25','08:05:00',1.7),('12374','2013-04-25','08:10:00',1.87),('12374','2013-04-25','08:15:00',1.76),('12374','2013-04-25','08:20:00',2.06),('12374','2013-04-25','08:25:00',2.94),('12374','2013-04-25','08:30:00',2.58),('12374','2013-04-25','08:35:00',2.23),('12374','2013-04-25','08:40:00',2.58),('12374','2013-04-25','08:45:00',3.47),('12374','2013-04-25','08:50:00',4.14),('12374','2013-04-25','08:55:00',3.29),('12374','2013-04-25','09:00:00',3.07),('12374','2013-04-25','09:05:00',3.62),('12374','2013-04-25','09:10:00',3.22),('12374','2013-04-25','09:15:00',4.22),('12374','2013-04-25','09:20:00',5.42),('12374','2013-04-25','09:25:00',5.5),('12374','2013-04-25','09:30:00',5.45),('12374','2013-04-25','09:35:00',5.89),('12374','2013-04-25','09:40:00',6.06),('12374','2013-04-25','09:45:00',5.17),('12374','2013-04-25','09:50:00',5.74),('12374','2013-04-25','09:55:00',4.65),('12374','2013-04-25','10:00:00',5.71),('12374','2013-04-25','10:05:00',6.11),('12374','2013-04-25','10:10:00',6.23),('12374','2013-04-25','10:15:00',6.38),('12374','2013-04-25','10:20:00',6.81),('12374','2013-04-25','10:25:00',6.82),('12374','2013-04-25','10:30:00',6.98),('12374','2013-04-25','10:35:00',7.3),('12374','2013-04-25','10:40:00',7.45),('12374','2013-04-25','10:45:00',7.56),('12374','2013-04-25','10:50:00',7.98),('12374','2013-04-25','10:55:00',5.61),('12374','2013-04-25','11:00:00',4.45),('12374','2013-04-25','11:05:00',5.4),('12374','2013-04-25','11:10:00',8.41),('12374','2013-04-25','11:15:00',8.22),('12374','2013-04-25','11:20:00',6.95),('12374','2013-04-25','11:25:00',7.97),('12374','2013-04-25','11:30:00',7.22),('12374','2013-04-25','11:35:00',7.96),('12374','2013-04-25','11:40:00',8.95),('12374','2013-04-25','11:45:00',8.85),('12374','2013-04-25','11:50:00',8.88),('12374','2013-04-25','11:55:00',8.88),('12374','2013-04-25','12:00:00',9.02),('12374','2013-04-25','12:05:00',8.54),('12374','2013-04-25','12:10:00',9.09),('12374','2013-04-25','12:15:00',9.22),('12374','2013-04-25','12:20:00',9.32),('12374','2013-04-25','12:25:00',9.38),('12374','2013-04-25','12:30:00',9.5),('12374','2013-04-25','12:35:00',6.73),('12374','2013-04-25','12:40:00',6.07),('12374','2013-04-25','12:45:00',7.07),('12374','2013-04-25','12:50:00',6.74),('12374','2013-04-25','12:55:00',7.08),('12374','2013-04-25','13:00:00',7.71),('12374','2013-04-25','13:05:00',7.08),('12374','2013-04-25','13:10:00',6.34),('12374','2013-04-25','13:15:00',7.22),('12374','2013-04-25','13:20:00',4.78),('12374','2013-04-25','13:25:00',3.93),('12374','2013-04-25','13:30:00',3.72),('12374','2013-04-25','13:35:00',3.65),('12374','2013-04-25','13:40:00',3.73),('12374','2013-04-25','13:45:00',3.89),('12374','2013-04-25','13:50:00',4.17),('12374','2013-04-25','13:55:00',4.25),('12374','2013-04-25','14:00:00',4.32),('12374','2013-04-25','14:05:00',5.11),('12374','2013-04-25','14:10:00',6.88),('12374','2013-04-25','14:15:00',8.94),('12374','2013-04-25','14:20:00',7.03),('12374','2013-04-25','14:25:00',7.42),('12374','2013-04-25','14:30:00',8.24),('12374','2013-04-25','14:35:00',8.27),('12374','2013-04-25','14:40:00',6.64),('12374','2013-04-25','14:45:00',7.44),('12374','2013-04-25','14:50:00',6.64),('12374','2013-04-25','14:55:00',6.36),('12374','2013-04-25','15:00:00',7.6),('12374','2013-04-25','15:05:00',7.75),('12374','2013-04-25','15:10:00',7.23),('12374','2013-04-25','15:15:00',7.13),('12374','2013-04-25','15:20:00',6.65),('12374','2013-04-25','15:25:00',6.24),('12374','2013-04-25','15:30:00',7.16),('12374','2013-04-25','15:35:00',6.83),('12374','2013-04-25','15:40:00',5.27),('12374','2013-04-25','15:45:00',4.67),('12374','2013-04-25','15:50:00',4.63),('12374','2013-04-25','15:55:00',4.58),('12374','2013-04-25','16:00:00',4.4),('12374','2013-04-25','16:05:00',4.73),('12374','2013-04-25','16:10:00',4.77),('12374','2013-04-25','16:15:00',4.19),('12374','2013-04-25','16:20:00',4.7),('12374','2013-04-25','16:25:00',4.51),('12374','2013-04-25','16:30:00',3.4),('12374','2013-04-25','16:35:00',3.48),('12374','2013-04-25','16:40:00',3.09),('12374','2013-04-25','16:45:00',2.85),('12374','2013-04-25','16:50:00',2.81),('12374','2013-04-25','16:55:00',2.75),('12374','2013-04-25','17:00:00',2.63),('12374','2013-04-25','17:05:00',2.48),('12374','2013-04-25','17:10:00',2.32),('12374','2013-04-25','17:15:00',2.24),('12374','2013-04-25','17:20:00',2.19),('12374','2013-04-25','17:25:00',2.18),('12374','2013-04-25','17:30:00',2.19),('12374','2013-04-25','17:35:00',2.15),('12374','2013-04-25','17:40:00',2.23),('12374','2013-04-25','17:45:00',2.29),('12374','2013-04-25','17:50:00',2.13),('12374','2013-04-25','17:55:00',1.91),('12374','2013-04-25','18:00:00',1.7),('12374','2013-04-25','18:05:00',1.52),('12374','2013-04-25','18:10:00',1.35),('12374','2013-04-25','18:15:00',1.2),('12374','2013-04-25','18:20:00',1.09),('12374','2013-04-25','18:25:00',1.04),('12374','2013-04-24','07:35:00',1.26),('12374','2013-04-24','07:40:00',1.44),('12374','2013-04-24','07:45:00',1.4),('12374','2013-04-24','07:50:00',1.67),('12374','2013-04-24','07:55:00',1.88),('12374','2013-04-24','08:00:00',2.01),('12374','2013-04-24','08:05:00',2.59),('12374','2013-04-24','08:10:00',3.15),('12374','2013-04-24','08:15:00',3.39),('12374','2013-04-24','08:20:00',3.27),('12374','2013-04-24','08:25:00',3.57),('12374','2013-04-24','08:30:00',3.69),('12374','2013-04-24','08:35:00',3.95),('12374','2013-04-24','08:40:00',4.12),('12374','2013-04-24','08:45:00',4.43),('12374','2013-04-24','08:50:00',4.82),('12374','2013-04-24','08:55:00',5.02),('12374','2013-04-24','09:00:00',4.58),('12374','2013-04-24','09:05:00',4.05),('12374','2013-04-24','09:10:00',4.72),('12374','2013-04-24','09:15:00',3.98),('12374','2013-04-24','09:20:00',4.35),('12374','2013-04-24','09:25:00',4.71),('12374','2013-04-24','09:30:00',4.21),('12374','2013-04-24','09:35:00',4.17),('12374','2013-04-24','09:40:00',4.65),('12374','2013-04-24','09:45:00',4.67),('12374','2013-04-24','09:50:00',5.61),('12374','2013-04-24','09:55:00',5.9),('12374','2013-04-24','10:00:00',6.08),('12374','2013-04-24','10:05:00',5.63),('12374','2013-04-24','10:10:00',7.11),('12374','2013-04-24','10:15:00',7.56),('12374','2013-04-24','10:20:00',7.54),('12374','2013-04-24','10:25:00',7.68),('12374','2013-04-24','10:30:00',7.43),('12374','2013-04-24','10:35:00',7.23),('12374','2013-04-24','10:40:00',7.4),('12374','2013-04-24','10:45:00',7.79),('12374','2013-04-24','10:50:00',7.68),('12374','2013-04-24','10:55:00',7.69),('12374','2013-04-24','11:00:00',7.68),('12374','2013-04-24','11:05:00',7.75),('12374','2013-04-24','11:10:00',6.79),('12374','2013-04-24','11:15:00',6.52),('12374','2013-04-24','11:20:00',7.61),('12374','2013-04-24','11:25:00',8.52),('12374','2013-04-24','11:30:00',9.56),('12374','2013-04-24','11:35:00',9.55),('12374','2013-04-24','11:40:00',7.98),('12374','2013-04-24','11:45:00',7.41),('12374','2013-04-24','11:50:00',4.96),('12374','2013-04-24','11:55:00',6.87),('12374','2013-04-24','12:00:00',7.18),('12374','2013-04-24','12:05:00',7.6),('12374','2013-04-24','12:10:00',8.59),('12374','2013-04-24','12:15:00',8.34),('12374','2013-04-24','12:20:00',8.32),('12374','2013-04-24','12:25:00',8.49),('12374','2013-04-24','12:30:00',8.55),('12374','2013-04-24','12:35:00',8.67),('12374','2013-04-24','12:40:00',9.23),('12374','2013-04-24','12:45:00',9.1),('12374','2013-04-24','12:50:00',9.5),('12374','2013-04-24','12:55:00',9.71),('12374','2013-04-24','13:00:00',9.58),('12374','2013-04-24','13:05:00',8.78),('12374','2013-04-24','13:10:00',9.44),('12374','2013-04-24','13:15:00',9.55),('12374','2013-04-24','13:20:00',8.93),('12374','2013-04-24','13:25:00',9.7),('12374','2013-04-24','13:30:00',9.6),('12374','2013-04-24','13:35:00',8.81),('12374','2013-04-24','13:40:00',6.66),('12374','2013-04-24','13:45:00',5.41),('12374','2013-04-24','13:50:00',5.48),('12374','2013-04-24','13:55:00',7.52),('12374','2013-04-24','14:00:00',8.04),('12374','2013-04-24','14:05:00',7.96),('12374','2013-04-24','14:10:00',8.2),('12374','2013-04-24','14:15:00',8.98),('12374','2013-04-24','14:20:00',8.5),('12374','2013-04-24','14:25:00',8.6),('12374','2013-04-24','14:30:00',8.32),('12374','2013-04-24','14:35:00',8.39),('12374','2013-04-24','14:40:00',7.66),('12374','2013-04-24','14:45:00',6.11),('12374','2013-04-24','14:50:00',5.49),('12374','2013-04-24','14:55:00',5.45),('12374','2013-04-24','15:00:00',4.56),('12374','2013-04-24','15:05:00',4.72),('12374','2013-04-24','15:10:00',5.05),('12374','2013-04-24','15:15:00',4.97),('12374','2013-04-24','15:20:00',5.54),('12374','2013-04-24','15:25:00',5.8),('12374','2013-04-24','15:30:00',6.25),('12374','2013-04-24','15:35:00',6.58),('12374','2013-04-24','15:40:00',6.18),('12374','2013-04-24','15:45:00',3.78),('12374','2013-04-24','15:50:00',5.06),('12374','2013-04-24','15:55:00',5.57),('12374','2013-04-24','16:00:00',5.76),('12374','2013-04-24','16:05:00',5.01),('12374','2013-04-24','16:10:00',5.41),('12374','2013-04-24','16:15:00',4.51),('12374','2013-04-24','16:20:00',4.12),('12374','2013-04-24','16:25:00',4.16),('12374','2013-04-24','16:30:00',4.66),('12374','2013-04-24','16:35:00',4.77),('12374','2013-04-24','16:40:00',5.06),('12374','2013-04-24','16:45:00',5.15),('12374','2013-04-24','16:50:00',5.08),('12374','2013-04-24','16:55:00',5.23),('12374','2013-04-24','17:00:00',5.3),('12374','2013-04-24','17:05:00',4.97),('12374','2013-04-24','17:10:00',4.29),('12374','2013-04-24','17:15:00',3.5),('12374','2013-04-24','17:20:00',3.9),('12374','2013-04-24','17:25:00',3.78),('12374','2013-04-24','17:30:00',3.66),('12374','2013-04-24','17:35:00',3.58),('12374','2013-04-24','17:40:00',3.45),('12374','2013-04-24','17:45:00',2.71),('12374','2013-04-24','17:50:00',2.03),('12374','2013-04-24','17:55:00',2.35),('12374','2013-04-24','18:00:00',1.94),('12374','2013-04-24','18:05:00',2.28),('12374','2013-04-24','18:10:00',2.32),('12374','2013-04-24','18:15:00',2.37),('12374','2013-04-24','18:20:00',2.27),('12374','2013-04-24','18:25:00',2.1),('12374','2013-04-24','18:30:00',1.87),('12374','2013-04-24','18:35:00',1.67),('12374','2013-04-24','18:40:00',1.55),('12374','2013-04-24','18:45:00',1.24),('12374','2013-04-24','18:50:00',1.06),('12374','2013-04-23','07:05:00',1.19),('12374','2013-04-23','07:10:00',1.34),('12374','2013-04-23','07:15:00',1.51),('12374','2013-04-23','07:20:00',1.65),('12374','2013-04-23','07:25:00',1.63),('12374','2013-04-23','07:30:00',2.02),('12374','2013-04-23','07:35:00',2.21),('12374','2013-04-23','07:40:00',2.29),('12374','2013-04-23','07:45:00',2.22),('12374','2013-04-23','07:50:00',2.75),('12374','2013-04-23','07:55:00',2.95),('12374','2013-04-23','08:00:00',3.12),('12374','2013-04-23','08:05:00',3.31),('12374','2013-04-23','08:10:00',3.5),('12374','2013-04-23','08:15:00',3.68),('12374','2013-04-23','08:20:00',3.86),('12374','2013-04-23','08:25:00',4.04),('12374','2013-04-23','08:30:00',4.21),('12374','2013-04-23','08:35:00',4.37),('12374','2013-04-23','08:40:00',4.52),('12374','2013-04-23','08:45:00',4.63),('12374','2013-04-23','08:50:00',4.8),('12374','2013-04-23','08:55:00',4.95),('12374','2013-04-23','09:00:00',5.07),('12374','2013-04-23','09:05:00',5.23),('12374','2013-04-23','09:10:00',5.43),('12374','2013-04-23','09:15:00',5.58),('12374','2013-04-23','09:20:00',5.75),('12374','2013-04-23','09:25:00',5.89),('12374','2013-04-23','09:30:00',6.02),('12374','2013-04-23','09:35:00',6.19),('12374','2013-04-23','09:40:00',6.35),('12374','2013-04-23','09:45:00',6.49),('12374','2013-04-23','09:50:00',6.63),('12374','2013-04-23','09:55:00',6.76),('12374','2013-04-23','10:00:00',6.86),('12374','2013-04-23','10:05:00',7.02),('12374','2013-04-23','10:10:00',7.14),('12374','2013-04-23','10:15:00',7.27),('12374','2013-04-23','10:20:00',7.39),('12374','2013-04-23','10:25:00',7.52),('12374','2013-04-23','10:30:00',7.59),('12374','2013-04-23','10:35:00',7.81),('12374','2013-04-23','10:40:00',7.7),('12374','2013-04-23','10:45:00',8),('12374','2013-04-23','10:50:00',8.01),('12374','2013-04-23','10:55:00',8.14),('12374','2013-04-23','11:00:00',8.15),('12374','2013-04-23','11:05:00',8.2),('12374','2013-04-23','11:10:00',8.38),('12374','2013-04-23','11:15:00',8.42),('12374','2013-04-23','11:20:00',7.78),('12374','2013-04-23','11:25:00',8.59),('12374','2013-04-23','11:30:00',8.61),('12374','2013-04-23','11:35:00',8.72),('12374','2013-04-23','11:40:00',8.76),('12374','2013-04-23','11:45:00',8.82),('12374','2013-04-23','11:50:00',8.89),('12374','2013-04-23','11:55:00',8.97),('12374','2013-04-23','12:00:00',9.01),('12374','2013-04-23','12:05:00',9.02),('12374','2013-04-23','12:10:00',9.1),('12374','2013-04-23','12:15:00',9.16),('12374','2013-04-23','12:20:00',9.18),('12374','2013-04-23','12:25:00',9.22),('12374','2013-04-23','12:30:00',9.2),('12374','2013-04-23','12:35:00',9.08),('12374','2013-04-23','12:40:00',9.21),('12374','2013-04-23','12:45:00',9.15),('12374','2013-04-23','12:50:00',9.11),('12374','2013-04-23','12:55:00',9.23),('12374','2013-04-23','13:00:00',9.1),('12374','2013-04-23','13:05:00',9.13),('12374','2013-04-23','13:10:00',9.15),('12374','2013-04-23','13:15:00',9.16),('12374','2013-04-23','13:20:00',8.8),('12374','2013-04-23','13:25:00',8.68),('12374','2013-04-23','13:30:00',8.4),('12374','2013-04-23','13:35:00',7.87),('12374','2013-04-23','13:40:00',9.2),('12374','2013-04-23','13:45:00',8.8),('12374','2013-04-23','13:50:00',9.15),('12374','2013-04-23','13:55:00',8.73),('12374','2013-04-23','14:00:00',8.71),('12374','2013-04-23','14:05:00',8.62),('12374','2013-04-23','14:10:00',7.8),('12374','2013-04-23','14:15:00',8.19),('12374','2013-04-23','14:20:00',8.61),('12374','2013-04-23','14:25:00',9.14),('12374','2013-04-23','14:30:00',8.82),('12374','2013-04-23','14:35:00',7.77),('12374','2013-04-23','14:40:00',7.52),('12374','2013-04-23','14:45:00',7.77),('12374','2013-04-23','14:50:00',8.01),('12374','2013-04-23','14:55:00',8.61),('12374','2013-04-23','15:00:00',8.78),('12374','2013-04-23','15:05:00',7.68),('12374','2013-04-23','15:10:00',4.34),('12374','2013-04-23','15:15:00',4.77),('12374','2013-04-23','15:20:00',5.4),('12374','2013-04-23','15:25:00',6.19),('12374','2013-04-23','15:30:00',6.52),('12374','2013-04-23','15:35:00',6.45),('12374','2013-04-23','15:40:00',6.66),('12374','2013-04-23','15:45:00',7.15),('12374','2013-04-23','15:50:00',6.83),('12374','2013-04-23','15:55:00',6.5),('12374','2013-04-23','16:00:00',6.06),('12374','2013-04-23','16:05:00',6.09),('12374','2013-04-23','16:10:00',5.69),('12374','2013-04-23','16:15:00',5.2),('12374','2013-04-23','16:20:00',4.99),('12374','2013-04-23','16:25:00',4.99),('12374','2013-04-23','16:30:00',5.01),('12374','2013-04-23','16:35:00',5.25),('12374','2013-04-23','16:40:00',5.22),('12374','2013-04-23','16:45:00',4.83),('12374','2013-04-23','16:50:00',5.18),('12374','2013-04-23','16:55:00',4.82),('12374','2013-04-23','17:00:00',4.17),('12374','2013-04-23','17:05:00',4.87),('12374','2013-04-23','17:10:00',4.87),('12374','2013-04-23','17:15:00',4.45),('12374','2013-04-23','17:20:00',4.25),('12374','2013-04-23','17:25:00',4.08),('12374','2013-04-23','17:30:00',4.02),('12374','2013-04-23','17:35:00',4.29),('12374','2013-04-23','17:40:00',3.86),('12374','2013-04-23','17:45:00',2.98),('12374','2013-04-23','17:50:00',1.94),('12374','2013-04-23','17:55:00',1.98),('12374','2013-04-23','18:00:00',1.7),('12374','2013-04-23','18:05:00',1.66),('12374','2013-04-23','18:10:00',1.53),('12374','2013-04-23','18:15:00',1.63),('12374','2013-04-23','18:20:00',1.08),('12374','2013-04-23','18:30:00',1.37),('12374','2013-04-23','18:35:00',1.48),('12374','2013-04-23','18:40:00',1.22),('12374','2013-04-22','07:45:00',1.27),('12374','2013-04-22','07:50:00',1.05),('12374','2013-04-22','08:15:00',1.06),('12374','2013-04-22','08:20:00',1.09),('12374','2013-04-22','08:35:00',1.02),('12374','2013-04-22','09:30:00',1),('12374','2013-04-22','09:35:00',1.15),('12374','2013-04-22','09:40:00',1.11),('12374','2013-04-22','09:55:00',1.03),('12374','2013-04-22','10:00:00',1.19),('12374','2013-04-22','10:30:00',1.3),('12374','2013-04-22','10:35:00',2.26),('12374','2013-04-22','10:40:00',2.48),('12374','2013-04-22','10:45:00',2.41),('12374','2013-04-22','10:50:00',3.41),('12374','2013-04-22','10:55:00',3.73),('12374','2013-04-22','11:00:00',3.7),('12374','2013-04-22','11:05:00',8.14),('12374','2013-04-22','11:10:00',9.05),('12374','2013-04-22','11:15:00',8.03),('12374','2013-04-22','11:20:00',6.16),('12374','2013-04-22','11:25:00',7.53),('12374','2013-04-22','11:30:00',7.22),('12374','2013-04-22','11:35:00',6.27),('12374','2013-04-22','11:40:00',5.76),('12374','2013-04-22','11:45:00',3.97),('12374','2013-04-22','11:50:00',4.4),('12374','2013-04-22','11:55:00',7.63),('12374','2013-04-22','12:00:00',9.81),('12374','2013-04-22','12:05:00',7.62),('12374','2013-04-22','12:10:00',9.57),('12374','2013-04-22','12:15:00',9.67),('12374','2013-04-22','12:20:00',9.52),('12374','2013-04-22','12:25:00',9.61),('12374','2013-04-22','12:30:00',9.79),('12374','2013-04-22','12:35:00',9.89),('12374','2013-04-22','12:40:00',9.89),('12374','2013-04-22','12:45:00',9.97),('12374','2013-04-22','12:50:00',9.88),('12374','2013-04-22','12:55:00',9.94),('12374','2013-04-22','13:00:00',9.03),('12374','2013-04-22','13:05:00',9.5),('12374','2013-04-22','13:10:00',9.29),('12374','2013-04-22','13:15:00',9.8),('12374','2013-04-22','13:20:00',9.8),('12374','2013-04-22','13:25:00',5.61),('12374','2013-04-22','13:30:00',4.35),('12374','2013-04-22','13:35:00',2.61),('12374','2013-04-22','13:40:00',3.37),('12374','2013-04-22','13:45:00',6.57),('12374','2013-04-22','13:50:00',6.99),('12374','2013-04-22','13:55:00',5.28),('12374','2013-04-22','14:00:00',3.13),('12374','2013-04-22','14:05:00',2.11),('12374','2013-04-22','14:45:00',1.02),('12374','2013-04-22','14:50:00',1.05),('12374','2013-04-22','14:55:00',1.06),('12374','2013-04-22','15:00:00',3.72),('12374','2013-04-22','15:05:00',9.91),('12374','2013-04-22','15:10:00',7.97),('12374','2013-04-22','15:15:00',9.74),('12374','2013-04-22','15:20:00',8.83),('12374','2013-04-22','15:25:00',8.52),('12374','2013-04-22','15:30:00',8.34),('12374','2013-04-22','15:35:00',8.13),('12374','2013-04-22','15:40:00',7.92),('12374','2013-04-22','15:45:00',7.81),('12374','2013-04-22','15:50:00',7.59),('12374','2013-04-22','15:55:00',7.37),('12374','2013-04-22','16:00:00',4.9),('12374','2013-04-22','16:05:00',4.44),('12374','2013-04-22','16:10:00',2.8),('12374','2013-04-22','16:15:00',5.26),('12374','2013-04-22','16:20:00',6.55),('12374','2013-04-22','16:25:00',6.43),('12374','2013-04-22','16:30:00',5.91),('12374','2013-04-22','16:35:00',5.28),('12374','2013-04-22','16:40:00',5.69),('12374','2013-04-22','16:45:00',3.7),('12374','2013-04-22','16:50:00',2.77),('12374','2013-04-22','16:55:00',3.05),('12374','2013-04-22','17:00:00',5.3),('12374','2013-04-22','17:05:00',5.96),('12374','2013-04-22','17:10:00',4.15),('12374','2013-04-22','17:15:00',3.34),('12374','2013-04-22','17:20:00',2.91),('12374','2013-04-22','17:25:00',2.36),('12374','2013-04-22','17:30:00',1.71),('12374','2013-04-22','17:35:00',1.58),('12374','2013-04-22','17:40:00',1.57),('12374','2013-04-22','17:45:00',1.51),('12374','2013-04-22','17:50:00',1.48),('12374','2013-04-22','17:55:00',1.5),('12374','2013-04-22','18:00:00',1.44),('12374','2013-04-22','18:05:00',1.87),('12374','2013-04-22','18:10:00',2.95),('12374','2013-04-22','18:15:00',2.72),('12374','2013-04-22','18:20:00',1.16),('12374','2013-04-21','07:45:00',1.13),('12374','2013-04-21','07:50:00',1.67),('12374','2013-04-21','07:55:00',1.35),('12374','2013-04-21','08:00:00',1.39),('12374','2013-04-21','08:05:00',1.71),('12374','2013-04-21','08:10:00',2.24),('12374','2013-04-21','08:15:00',2.77),('12374','2013-04-21','08:20:00',2.56),('12374','2013-04-21','08:25:00',2.64),('12374','2013-04-21','08:30:00',4.03),('12374','2013-04-21','08:35:00',3.21),('12374','2013-04-21','08:40:00',4.87),('12374','2013-04-21','08:45:00',5.67),('12374','2013-04-21','08:50:00',5.72),('12374','2013-04-21','08:55:00',4.33),('12374','2013-04-21','09:00:00',2.36),('12374','2013-04-21','09:05:00',2.24),('12374','2013-04-21','09:10:00',2.27),('12374','2013-04-21','09:15:00',2.26),('12374','2013-04-21','09:20:00',3.31),('12374','2013-04-21','09:25:00',3.24),('12374','2013-04-21','09:30:00',5.09),('12374','2013-04-21','09:35:00',6.11),('12374','2013-04-21','09:40:00',6.35),('12374','2013-04-21','09:45:00',6.41),('12374','2013-04-21','09:50:00',6.48),('12374','2013-04-21','09:55:00',6.61),('12374','2013-04-21','10:00:00',6.71),('12374','2013-04-21','10:05:00',6.86),('12374','2013-04-21','10:10:00',6.98),('12374','2013-04-21','10:15:00',7.1),('12374','2013-04-21','10:20:00',7.25),('12374','2013-04-21','10:25:00',7.37),('12374','2013-04-21','10:30:00',7.46),('12374','2013-04-21','10:35:00',7.56),('12374','2013-04-21','10:40:00',7.59),('12374','2013-04-21','10:45:00',7.79),('12374','2013-04-21','10:50:00',7.91),('12374','2013-04-21','10:55:00',7.96),('12374','2013-04-21','11:00:00',8.06),('12374','2013-04-21','11:05:00',8.16),('12374','2013-04-21','11:10:00',8.27),('12374','2013-04-21','11:15:00',8.37),('12374','2013-04-21','11:20:00',8.56),('12374','2013-04-21','11:25:00',8.69),('12374','2013-04-21','11:30:00',8.87),('12374','2013-04-21','11:35:00',9.08),('12374','2013-04-21','11:40:00',9.29),('12374','2013-04-21','11:45:00',6.38),('12374','2013-04-21','11:50:00',6.02),('12374','2013-04-21','11:55:00',7.12),('12374','2013-04-21','12:00:00',9.76),('12374','2013-04-21','12:05:00',9.66),('12374','2013-04-21','12:10:00',9.78),('12374','2013-04-21','12:15:00',8.68),('12374','2013-04-21','12:20:00',5.13),('12374','2013-04-21','12:25:00',7.53),('12374','2013-04-21','12:30:00',9.56),('12374','2013-04-21','12:35:00',9.69),('12374','2013-04-21','12:40:00',9.27),('12374','2013-04-21','12:45:00',9.36),('12374','2013-04-21','12:50:00',9.51),('12374','2013-04-21','12:55:00',9.51),('12374','2013-04-21','13:00:00',9.42),('12374','2013-04-21','13:05:00',9.41),('12374','2013-04-21','13:10:00',9.38),('12374','2013-04-21','13:15:00',9.39),('12374','2013-04-21','13:20:00',9.28),('12374','2013-04-21','13:25:00',8.64),('12374','2013-04-21','13:30:00',9.29),('12374','2013-04-21','13:35:00',9.26),('12374','2013-04-21','13:40:00',9.24),('12374','2013-04-21','13:45:00',9.13),('12374','2013-04-21','13:50:00',9.17),('12374','2013-04-21','13:55:00',9.19),('12374','2013-04-21','14:00:00',9.27),('12374','2013-04-21','14:05:00',9.07),('12374','2013-04-21','14:10:00',8.96),('12374','2013-04-21','14:15:00',8.91),('12374','2013-04-21','14:20:00',8.59),('12374','2013-04-21','14:25:00',8.75),('12374','2013-04-21','14:30:00',8.79),('12374','2013-04-21','14:35:00',7.73),('12374','2013-04-21','14:40:00',6.56),('12374','2013-04-21','14:45:00',8.75),('12374','2013-04-21','14:50:00',8.93),('12374','2013-04-21','14:55:00',8.71),('12374','2013-04-21','15:00:00',8.26),('12374','2013-04-21','15:05:00',8.11),('12374','2013-04-21','15:10:00',7.99),('12374','2013-04-21','15:15:00',7.84),('12374','2013-04-21','15:20:00',7.8),('12374','2013-04-21','15:25:00',7.71),('12374','2013-04-21','15:30:00',7.68),('12374','2013-04-21','15:35:00',5.53),('12374','2013-04-21','15:40:00',6.85),('12374','2013-04-21','15:45:00',5.44),('12374','2013-04-21','15:50:00',5.72),('12374','2013-04-21','15:55:00',3.87),('12374','2013-04-21','16:00:00',4.63),('12374','2013-04-21','16:05:00',4.51),('12374','2013-04-21','16:10:00',4.04),('12374','2013-04-21','16:15:00',5.51),('12374','2013-04-21','16:20:00',4.55),('12374','2013-04-21','16:25:00',3.57),('12374','2013-04-21','16:30:00',3.11),('12374','2013-04-21','16:35:00',2.58),('12374','2013-04-21','16:40:00',2.56),('12374','2013-04-21','16:45:00',2.42),('12374','2013-04-21','16:50:00',2.25),('12374','2013-04-21','16:55:00',1.93),('12374','2013-04-21','17:00:00',1.64),('12374','2013-04-21','17:05:00',1.43),('12374','2013-04-21','17:10:00',1.28),('12374','2013-04-21','17:15:00',1.29),('12374','2013-04-21','17:20:00',1.16),('12374','2013-04-21','17:25:00',1.06),('12374','2013-04-21','17:30:00',1.01),('12374','2013-04-20','08:05:00',1.07),('12374','2013-04-20','08:10:00',1.28),('12374','2013-04-20','08:15:00',1.48),('12374','2013-04-20','08:20:00',1.71),('12374','2013-04-20','08:25:00',1.8),('12374','2013-04-20','08:30:00',1.73),('12374','2013-04-20','08:35:00',1.8),('12374','2013-04-20','08:40:00',2.07),('12374','2013-04-20','08:45:00',2.13),('12374','2013-04-20','08:50:00',2.13),('12374','2013-04-20','08:55:00',2.08),('12374','2013-04-20','09:00:00',1.9),('12374','2013-04-20','09:05:00',1.61),('12374','2013-04-20','09:10:00',1.59),('12374','2013-04-20','09:15:00',1.51),('12374','2013-04-20','09:20:00',1.47),('12374','2013-04-20','09:25:00',1.63),('12374','2013-04-20','09:30:00',1.8),('12374','2013-04-20','09:35:00',1.81),('12374','2013-04-20','09:40:00',1.78),('12374','2013-04-20','09:45:00',1.64),('12374','2013-04-20','09:50:00',1.64),('12374','2013-04-20','09:55:00',1.79),('12374','2013-04-20','10:00:00',1.93),('12374','2013-04-20','10:05:00',2.37),('12374','2013-04-20','10:10:00',2.52),('12374','2013-04-20','10:15:00',3.09),('12374','2013-04-20','10:20:00',3.35),('12374','2013-04-20','10:25:00',3.13),('12374','2013-04-20','10:30:00',2.95),('12374','2013-04-20','10:35:00',3.07),('12374','2013-04-20','10:40:00',3.19),('12374','2013-04-20','10:45:00',3.35),('12374','2013-04-20','10:50:00',3.48),('12374','2013-04-20','10:55:00',3.54),('12374','2013-04-20','11:00:00',3.84),('12374','2013-04-20','11:05:00',3.79),('12374','2013-04-20','11:10:00',4.01),('12374','2013-04-20','11:15:00',4.39),('12374','2013-04-20','11:20:00',4.73),('12374','2013-04-20','11:25:00',8.25),('12374','2013-04-20','11:30:00',8.86),('12374','2013-04-20','11:35:00',9.73),('12374','2013-04-20','11:40:00',9.69),('12374','2013-04-20','11:45:00',9.33),('12374','2013-04-20','11:50:00',9.04),('12374','2013-04-20','11:55:00',9.35),('12374','2013-04-20','12:00:00',9.59),('12374','2013-04-20','12:05:00',9.83),('12374','2013-04-20','12:10:00',6.65),('12374','2013-04-20','12:15:00',6.14),('12374','2013-04-20','12:20:00',6.12),('12374','2013-04-20','12:25:00',5.15),('12374','2013-04-20','12:30:00',5.08),('12374','2013-04-20','12:35:00',3.83),('12374','2013-04-20','12:40:00',6.64),('12374','2013-04-20','12:45:00',7.65),('12374','2013-04-20','12:50:00',3.33),('12374','2013-04-20','12:55:00',2.42),('12374','2013-04-20','13:00:00',2.12),('12374','2013-04-20','13:05:00',2.36),('12374','2013-04-20','13:10:00',2.82),('12374','2013-04-20','13:15:00',3.2),('12374','2013-04-20','13:20:00',3.88),('12374','2013-04-20','13:25:00',6.88),('12374','2013-04-20','13:30:00',8.15),('12374','2013-04-20','13:35:00',6.6),('12374','2013-04-20','13:40:00',8.63),('12374','2013-04-20','13:45:00',9.34),('12374','2013-04-20','13:50:00',9.05),('12374','2013-04-20','13:55:00',9.55),('12374','2013-04-20','14:00:00',7.22),('12374','2013-04-20','14:05:00',8.8),('12374','2013-04-20','14:10:00',8.4),('12374','2013-04-20','14:15:00',7.33),('12374','2013-04-20','14:20:00',3.84),('12374','2013-04-20','14:25:00',3.86),('12374','2013-04-20','14:30:00',4.42),('12374','2013-04-20','14:35:00',4.89),('12374','2013-04-20','14:40:00',4.6),('12374','2013-04-20','14:45:00',4.7),('12374','2013-04-20','14:50:00',3.3),('12374','2013-04-20','14:55:00',2.49),('12374','2013-04-20','15:00:00',2.19),('12374','2013-04-20','15:05:00',2.21),('12374','2013-04-20','15:10:00',2.28),('12374','2013-04-20','15:15:00',2.56),('12374','2013-04-20','15:20:00',3.05),('12374','2013-04-20','15:25:00',3.69),('12374','2013-04-20','15:30:00',6.35),('12374','2013-04-20','15:35:00',8.5),('12374','2013-04-20','15:40:00',8.49),('12374','2013-04-20','15:45:00',7.89),('12374','2013-04-20','15:50:00',7.41),('12374','2013-04-20','15:55:00',7.11),('12374','2013-04-20','16:00:00',6.77),('12374','2013-04-20','16:05:00',6.3),('12374','2013-04-20','16:10:00',6.17),('12374','2013-04-20','16:15:00',4.83),('12374','2013-04-20','16:20:00',2.74),('12374','2013-04-20','16:25:00',1.77),('12374','2013-04-20','16:30:00',4.93),('12374','2013-04-20','16:35:00',6.26),('12374','2013-04-20','16:40:00',5.03),('12374','2013-04-20','16:45:00',5.37),('12374','2013-04-20','16:50:00',5.25),('12374','2013-04-20','16:55:00',5.08),('12374','2013-04-20','17:00:00',4.89),('12374','2013-04-20','17:05:00',4.77),('12374','2013-04-20','17:10:00',4.51),('12374','2013-04-20','17:15:00',3.62),('12374','2013-04-20','17:20:00',2.02),('12374','2013-04-20','17:25:00',2.22),('12374','2013-04-20','17:30:00',1.77),('12374','2013-04-20','17:35:00',2.27),('12374','2013-04-20','17:40:00',2.65),('12374','2013-04-20','17:45:00',1.95),('12374','2013-04-20','17:50:00',1.41),('12374','2013-04-20','17:55:00',1.41),('12374','2013-04-20','18:00:00',1.46),('12374','2013-04-20','18:05:00',1.45),('12374','2013-04-20','18:10:00',1.22),('12374','2013-04-20','18:15:00',1.24),('12374','2013-04-20','18:20:00',1.07),('12374','2013-04-20','18:40:00',1.02),('12374','2013-04-20','18:45:00',1.07),('12374','2013-04-20','18:50:00',1.25),('12374','2013-04-20','18:55:00',1.16),('12374','2013-04-19','07:35:00',1.02),('12374','2013-04-19','07:40:00',1.42),('12374','2013-04-19','07:45:00',1.21),('12374','2013-04-19','07:55:00',1.56),('12374','2013-04-19','08:00:00',2.56),('12374','2013-04-19','08:05:00',2.74),('12374','2013-04-19','08:10:00',2.93),('12374','2013-04-19','08:15:00',3.08),('12374','2013-04-19','08:20:00',3.25),('12374','2013-04-19','08:25:00',3.33),('12374','2013-04-19','08:30:00',3.57),('12374','2013-04-19','08:35:00',3.82),('12374','2013-04-19','08:40:00',3.98),('12374','2013-04-19','08:45:00',4.12),('12374','2013-04-19','08:50:00',4.36),('12374','2013-04-19','08:55:00',4.54),('12374','2013-04-19','09:00:00',4.71),('12374','2013-04-19','09:05:00',4.89),('12374','2013-04-19','09:10:00',5.01),('12374','2013-04-19','09:15:00',5.14),('12374','2013-04-19','09:20:00',5.28),('12374','2013-04-19','09:25:00',5.49),('12374','2013-04-19','09:30:00',5.62),('12374','2013-04-19','09:35:00',5.74),('12374','2013-04-19','09:40:00',5.92),('12374','2013-04-19','09:45:00',5.12),('12374','2013-04-19','09:50:00',6.05),('12374','2013-04-19','09:55:00',6.47),('12374','2013-04-19','10:00:00',6.6),('12374','2013-04-19','10:05:00',4.89),('12374','2013-04-19','10:10:00',6.37),('12374','2013-04-19','10:15:00',7.17),('12374','2013-04-19','10:20:00',7.11),('12374','2013-04-19','10:25:00',7.37),('12374','2013-04-19','10:30:00',7.26),('12374','2013-04-19','10:35:00',7.32),('12374','2013-04-19','10:40:00',6.32),('12374','2013-04-19','10:45:00',4.07),('12374','2013-04-19','10:50:00',7.09),('12374','2013-04-19','10:55:00',7.7),('12374','2013-04-19','11:00:00',7.9),('12374','2013-04-19','11:05:00',7.52),('12374','2013-04-19','11:10:00',8),('12374','2013-04-19','11:15:00',7.65),('12374','2013-04-19','11:20:00',7.99),('12374','2013-04-19','11:25:00',8.16),('12374','2013-04-19','11:30:00',8.23),('12374','2013-04-19','11:35:00',8.32),('12374','2013-04-19','11:40:00',8.27),('12374','2013-04-19','11:45:00',8.44),('12374','2013-04-19','11:50:00',8.5),('12374','2013-04-19','11:55:00',8.56),('12374','2013-04-19','12:00:00',8.65),('12374','2013-04-19','12:05:00',8.71),('12374','2013-04-19','12:10:00',8.69),('12374','2013-04-19','12:15:00',8.83),('12374','2013-04-19','12:20:00',8.88),('12374','2013-04-19','12:25:00',8.93),('12374','2013-04-19','12:30:00',8.94),('12374','2013-04-19','12:35:00',9.01),('12374','2013-04-19','12:40:00',8.96),('12374','2013-04-19','12:45:00',8.97),('12374','2013-04-19','12:50:00',9),('12374','2013-04-19','12:55:00',8.99),('12374','2013-04-19','13:00:00',8.98),('12374','2013-04-19','13:05:00',8.95),('12374','2013-04-19','13:10:00',9.04),('12374','2013-04-19','13:15:00',9.07),('12374','2013-04-19','13:20:00',9.1),('12374','2013-04-19','13:25:00',9.04),('12374','2013-04-19','13:30:00',9.01),('12374','2013-04-19','13:35:00',8.98),('12374','2013-04-19','13:40:00',8.99),('12374','2013-04-19','13:45:00',8.95),('12374','2013-04-19','13:50:00',8.93),('12374','2013-04-19','13:55:00',8.78),('12374','2013-04-19','14:00:00',8.82),('12374','2013-04-19','14:05:00',8.77),('12374','2013-04-19','14:10:00',8.69),('12374','2013-04-19','14:15:00',8.64),('12374','2013-04-19','14:20:00',8.55),('12374','2013-04-19','14:25:00',8.46),('12374','2013-04-19','14:30:00',8.38),('12374','2013-04-19','14:35:00',8.33),('12374','2013-04-19','14:40:00',8.23),('12374','2013-04-19','14:45:00',8.14),('12374','2013-04-19','14:50:00',8.08),('12374','2013-04-19','14:55:00',7.99),('12374','2013-04-19','15:00:00',7.92),('12374','2013-04-19','15:05:00',7.81),('12374','2013-04-19','15:10:00',7.66),('12374','2013-04-19','15:15:00',7.55),('12374','2013-04-19','15:20:00',7.46),('12374','2013-04-19','15:25:00',7.37),('12374','2013-04-19','15:30:00',7.28),('12374','2013-04-19','15:35:00',7.16),('12374','2013-04-19','15:40:00',7),('12374','2013-04-19','15:45:00',6.92),('12374','2013-04-19','15:50:00',6.77),('12374','2013-04-19','15:55:00',6.63),('12374','2013-04-19','16:00:00',6.53),('12374','2013-04-19','16:05:00',6.38),('12374','2013-04-19','16:10:00',6.2),('12374','2013-04-19','16:15:00',6.13),('12374','2013-04-19','16:20:00',5.94),('12374','2013-04-19','16:25:00',5.76),('12374','2013-04-19','16:30:00',5.38),('12374','2013-04-19','16:35:00',5.49),('12374','2013-04-19','16:40:00',5.14),('12374','2013-04-19','16:45:00',5.05),('12374','2013-04-19','16:50:00',5.17),('12374','2013-04-19','16:55:00',4.89),('12374','2013-04-19','17:00:00',4.57),('12374','2013-04-19','17:05:00',4.57),('12374','2013-04-19','17:10:00',4.33),('12374','2013-04-19','17:15:00',3.62),('12374','2013-04-19','17:20:00',3.81),('12374','2013-04-19','17:25:00',3.78),('12374','2013-04-19','17:30:00',3.67),('12374','2013-04-19','17:35:00',3.08),('12374','2013-04-19','17:40:00',3.69),('12374','2013-04-19','17:45:00',3.64),('12374','2013-04-19','17:50:00',2.85),('12374','2013-04-19','17:55:00',2.41),('12374','2013-04-19','18:00:00',2.48),('12374','2013-04-19','18:05:00',2.28),('12374','2013-04-19','18:10:00',2.04),('12374','2013-04-19','18:15:00',1.87),('12374','2013-04-19','18:20:00',1.77),('12374','2013-04-19','18:25:00',1.53),('12374','2013-04-19','18:30:00',1.38),('12374','2013-04-19','18:35:00',1.26),('12374','2013-04-19','18:40:00',1.18),('12374','2013-04-18','07:50:00',1.02),('12374','2013-04-18','07:55:00',1.42),('12374','2013-04-18','08:00:00',1.88),('12374','2013-04-18','08:05:00',2.44),('12374','2013-04-18','08:10:00',2.93),('12374','2013-04-18','08:15:00',2.97),('12374','2013-04-18','08:20:00',3.4),('12374','2013-04-18','08:25:00',3.44),('12374','2013-04-18','08:30:00',4.04),('12374','2013-04-18','08:35:00',3.75),('12374','2013-04-18','08:40:00',3.78),('12374','2013-04-18','08:45:00',3.39),('12374','2013-04-18','08:50:00',3.24),('12374','2013-04-18','08:55:00',3.96),('12374','2013-04-18','09:00:00',4.63),('12374','2013-04-18','09:05:00',5.06),('12374','2013-04-18','09:10:00',5.24),('12374','2013-04-18','09:15:00',5.37),('12374','2013-04-18','09:20:00',5.53),('12374','2013-04-18','09:25:00',5.66),('12374','2013-04-18','09:30:00',5.74),('12374','2013-04-18','09:35:00',5.87),('12374','2013-04-18','09:40:00',5.94),('12374','2013-04-18','09:45:00',6.08),('12374','2013-04-18','09:50:00',6.19),('12374','2013-04-18','09:55:00',6.31),('12374','2013-04-18','10:00:00',6.46),('12374','2013-04-18','10:05:00',6.62),('12374','2013-04-18','10:10:00',6.74),('12374','2013-04-18','10:15:00',6.85),('12374','2013-04-18','10:20:00',6.92),('12374','2013-04-18','10:25:00',7.02),('12374','2013-04-18','10:30:00',7.11),('12374','2013-04-18','10:35:00',6.15),('12374','2013-04-18','10:45:00',5.28),('12374','2013-04-18','10:50:00',7.47),('12374','2013-04-18','10:55:00',7.6),('12374','2013-04-18','11:00:00',7.62),('12374','2013-04-18','11:05:00',5.05),('12374','2013-04-18','11:10:00',7.81),('12374','2013-04-18','11:15:00',8),('12374','2013-04-18','11:20:00',8.12),('12374','2013-04-18','11:25:00',6.06),('12374','2013-04-18','11:30:00',7.45),('12374','2013-04-18','11:35:00',8.35),('12374','2013-04-18','11:40:00',8.41),('12374','2013-04-18','11:45:00',7.16),('12374','2013-04-18','11:50:00',6.77),('12374','2013-04-18','11:55:00',8.66),('12374','2013-04-18','12:00:00',8.72),('12374','2013-04-18','12:05:00',8.12),('12374','2013-04-18','12:10:00',6.57),('12374','2013-04-18','12:15:00',8.31),('12374','2013-04-18','12:20:00',8.96),('12374','2013-04-18','12:25:00',9),('12374','2013-04-18','12:30:00',9.07),('12374','2013-04-18','12:35:00',9.04),('12374','2013-04-18','12:40:00',9.07),('12374','2013-04-18','12:45:00',9.09),('12374','2013-04-18','12:50:00',9.09),('12374','2013-04-18','12:55:00',9.08),('12374','2013-04-18','13:00:00',9.13),('12374','2013-04-18','13:05:00',9.12),('12374','2013-04-18','13:10:00',9.05),('12374','2013-04-18','13:15:00',9.06),('12374','2013-04-18','13:20:00',9.01),('12374','2013-04-18','13:25:00',8.92),('12374','2013-04-18','13:30:00',8.78),('12374','2013-04-18','13:35:00',9.06),('12374','2013-04-18','13:40:00',9.02),('12374','2013-04-18','13:45:00',9.02),('12374','2013-04-18','13:50:00',8.9),('12374','2013-04-18','13:55:00',8.86),('12374','2013-04-18','14:00:00',8.65),('12374','2013-04-18','14:05:00',8.74),('12374','2013-04-18','14:10:00',8.56),('12374','2013-04-18','14:15:00',8.57),('12374','2013-04-18','14:20:00',8.52),('12374','2013-04-18','14:25:00',8.42),('12374','2013-04-18','14:30:00',8.41),('12374','2013-04-18','14:35:00',8.29),('12374','2013-04-18','14:40:00',8.2),('12374','2013-04-18','14:45:00',8.23),('12374','2013-04-18','14:50:00',8.11),('12374','2013-04-18','14:55:00',7.85),('12374','2013-04-18','15:00:00',7.66),('12374','2013-04-18','15:05:00',7.48),('12374','2013-04-18','15:10:00',7.69),('12374','2013-04-18','15:15:00',7.46),('12374','2013-04-18','15:20:00',7.49),('12374','2013-04-18','15:25:00',7.38),('12374','2013-04-18','15:30:00',7.2),('12374','2013-04-18','15:35:00',7),('12374','2013-04-18','15:40:00',6.98),('12374','2013-04-18','15:45:00',6.9),('12374','2013-04-18','15:50:00',6.77),('12374','2013-04-18','15:55:00',6.62),('12374','2013-04-18','16:00:00',6.53),('12374','2013-04-18','16:05:00',6.42),('12374','2013-04-18','16:10:00',6.29),('12374','2013-04-18','16:15:00',6.11),('12374','2013-04-18','16:20:00',5.93),('12374','2013-04-18','16:25:00',5.8),('12374','2013-04-18','16:30:00',5.68),('12374','2013-04-18','16:35:00',5.56),('12374','2013-04-18','16:40:00',5.38),('12374','2013-04-18','16:45:00',5.25),('12374','2013-04-18','16:50:00',5.09),('12374','2013-04-18','16:55:00',4.93),('12374','2013-04-18','17:00:00',4.71),('12374','2013-04-18','17:05:00',4.54),('12374','2013-04-18','17:10:00',4.36),('12374','2013-04-18','17:15:00',4.17),('12374','2013-04-18','17:20:00',3.93),('12374','2013-04-18','17:25:00',3.76),('12374','2013-04-18','17:30:00',3.59),('12374','2013-04-18','17:35:00',3.36),('12374','2013-04-18','17:40:00',3.19),('12374','2013-04-18','17:45:00',2.98),('12374','2013-04-18','17:50:00',2.8),('12374','2013-04-18','17:55:00',2.63),('12374','2013-04-18','18:00:00',2.44),('12374','2013-04-18','18:05:00',2.25),('12374','2013-04-18','18:10:00',1.98),('12374','2013-04-18','18:15:00',1.86),('12374','2013-04-18','18:20:00',1.71),('12374','2013-04-18','18:25:00',1.54),('12374','2013-04-18','18:30:00',1.39),('12374','2013-04-18','18:35:00',1.29),('12374','2013-04-18','18:40:00',1.2),('12374','2013-04-18','18:45:00',1.1),('12374','2013-04-18','18:50:00',1.01),('12374','2013-04-17','07:20:00',1.02),('12374','2013-04-17','07:25:00',1.09),('12374','2013-04-17','07:35:00',1.02),('12374','2013-04-17','07:40:00',1.14),('12374','2013-04-17','07:45:00',1.06),('12374','2013-04-17','07:50:00',1.27),('12374','2013-04-17','07:55:00',1.71),('12374','2013-04-17','08:00:00',1.9),('12374','2013-04-17','08:05:00',2.29),('12374','2013-04-17','08:10:00',2.81),('12374','2013-04-17','08:15:00',3.22),('12374','2013-04-17','08:20:00',3.42),('12374','2013-04-17','08:25:00',3.61),('12374','2013-04-17','08:30:00',3.76),('12374','2013-04-17','08:35:00',3.93),('12374','2013-04-17','08:40:00',4.11),('12374','2013-04-17','08:45:00',4.29),('12374','2013-04-17','08:50:00',4.48),('12374','2013-04-17','08:55:00',4.65),('12374','2013-04-17','09:00:00',4.79),('12374','2013-04-17','09:05:00',4.91),('12374','2013-04-17','09:10:00',5.07),('12374','2013-04-17','09:15:00',5.21),('12374','2013-04-17','09:20:00',5.35),('12374','2013-04-17','09:25:00',5.51),('12374','2013-04-17','09:30:00',5.65),('12374','2013-04-17','09:35:00',5.8),('12374','2013-04-17','09:40:00',5.94),('12374','2013-04-17','09:45:00',6.05),('12374','2013-04-17','09:50:00',6.21),('12374','2013-04-17','09:55:00',6.29),('12374','2013-04-17','10:00:00',6.46),('12374','2013-04-17','10:05:00',6.59),('12374','2013-04-17','10:10:00',6.71),('12374','2013-04-17','10:15:00',6.82),('12374','2013-04-17','10:20:00',6.93),('12374','2013-04-17','10:25:00',7.04),('12374','2013-04-17','10:30:00',7.16),('12374','2013-04-17','10:35:00',7.26),('12374','2013-04-17','10:40:00',7.32),('12374','2013-04-17','10:45:00',7.45),('12374','2013-04-17','10:50:00',7.52),('12374','2013-04-17','10:55:00',7.56),('12374','2013-04-17','11:00:00',7.7),('12374','2013-04-17','11:05:00',7.74),('12374','2013-04-17','11:10:00',7.84),('12374','2013-04-17','11:15:00',7.98),('12374','2013-04-17','11:20:00',8.13),('12374','2013-04-17','11:25:00',8.17),('12374','2013-04-17','11:30:00',8.25),('12374','2013-04-17','11:35:00',8.29),('12374','2013-04-17','11:40:00',8.43),('12374','2013-04-17','11:45:00',8.56),('12374','2013-04-17','11:50:00',8.63),('12374','2013-04-17','11:55:00',8.68),('12374','2013-04-17','12:00:00',8.77),('12374','2013-04-17','12:05:00',8.83),('12374','2013-04-17','12:10:00',8.86),('12374','2013-04-17','12:15:00',8.89),('12374','2013-04-17','12:20:00',9.01),('12374','2013-04-17','12:25:00',8.99),('12374','2013-04-17','12:30:00',9.02),('12374','2013-04-17','12:35:00',8.95),('12374','2013-04-17','12:40:00',9.02),('12374','2013-04-17','12:45:00',8.94),('12374','2013-04-17','12:50:00',9),('12374','2013-04-17','12:55:00',9.1),('12374','2013-04-17','13:00:00',8.6),('12374','2013-04-17','13:05:00',8.55),('12374','2013-04-17','13:10:00',8.76),('12374','2013-04-17','13:15:00',8.21),('12374','2013-04-17','13:20:00',8.24),('12374','2013-04-17','13:25:00',8.13),('12374','2013-04-17','13:30:00',8.1),('12374','2013-04-17','13:35:00',9.08),('12374','2013-04-17','13:40:00',8.81),('12374','2013-04-17','13:45:00',8.43),('12374','2013-04-17','13:50:00',8.32),('12374','2013-04-17','13:55:00',8),('12374','2013-04-17','14:00:00',6.93),('12374','2013-04-17','14:05:00',8.01),('12374','2013-04-17','14:10:00',8.45),('12374','2013-04-17','14:15:00',8.21),('12374','2013-04-17','14:20:00',8.76),('12374','2013-04-17','14:25:00',8.76),('12374','2013-04-17','14:30:00',8.71),('12374','2013-04-17','14:35:00',8.73),('12374','2013-04-17','14:40:00',8.77),('12374','2013-04-17','14:45:00',8.91),('12374','2013-04-17','14:50:00',8.54),('12374','2013-04-17','14:55:00',7.7),('12374','2013-04-17','15:00:00',7.46),('12374','2013-04-17','15:05:00',7.1),('12374','2013-04-17','15:10:00',8.02),('12374','2013-04-17','15:15:00',8.61),('12374','2013-04-17','15:20:00',7.97),('12374','2013-04-17','15:25:00',8.25),('12374','2013-04-17','15:30:00',7.98),('12374','2013-04-17','15:35:00',7.69),('12374','2013-04-17','15:40:00',7.58),('12374','2013-04-17','15:45:00',7.3),('12374','2013-04-17','15:50:00',6.78),('12374','2013-04-17','15:55:00',6.81),('12374','2013-04-17','16:00:00',6.65),('12374','2013-04-17','16:05:00',6.44),('12374','2013-04-17','16:10:00',6.34),('12374','2013-04-17','16:15:00',6.19),('12374','2013-04-17','16:20:00',6.03),('12374','2013-04-17','16:25:00',5.86),('12374','2013-04-17','16:30:00',5.71),('12374','2013-04-17','16:35:00',5.56),('12374','2013-04-17','16:40:00',5.38),('12374','2013-04-17','16:45:00',5.24),('12374','2013-04-17','16:50:00',5.11),('12374','2013-04-17','16:55:00',4.97),('12374','2013-04-17','17:00:00',4.77),('12374','2013-04-17','17:05:00',4.58),('12374','2013-04-17','17:10:00',4.39),('12374','2013-04-17','17:15:00',4.2),('12374','2013-04-17','17:20:00',3.97),('12374','2013-04-17','17:25:00',3.83),('12374','2013-04-17','17:30:00',3.63),('12374','2013-04-17','17:35:00',3.47),('12374','2013-04-17','17:40:00',3.32),('12374','2013-04-17','17:45:00',3.13),('12374','2013-04-17','17:50:00',2.98),('12374','2013-04-17','17:55:00',2.79),('12374','2013-04-17','18:00:00',2.61),('12374','2013-04-17','18:05:00',2.39),('12374','2013-04-17','18:10:00',2.17),('12374','2013-04-17','18:15:00',2.02),('12374','2013-04-17','18:20:00',1.82),('12374','2013-04-17','18:25:00',1.58),('12374','2013-04-17','18:30:00',1.44),('12374','2013-04-17','18:35:00',1.3),('12374','2013-04-17','18:40:00',1.21),('12374','2013-04-17','18:45:00',1.12),('12374','2013-04-17','18:50:00',1.03),('12374','2013-04-16','07:15:00',1.04),('12374','2013-04-16','07:20:00',1.09),('12374','2013-04-16','07:25:00',1.13),('12374','2013-04-16','07:30:00',1.22),('12374','2013-04-16','07:40:00',1.05),('12374','2013-04-16','07:45:00',1.16),('12374','2013-04-16','07:50:00',1.28),('12374','2013-04-16','07:55:00',1.55),('12374','2013-04-16','08:00:00',1.82),('12374','2013-04-16','08:05:00',2.04),('12374','2013-04-16','08:10:00',2.63),('12374','2013-04-16','08:15:00',3.03),('12374','2013-04-16','08:20:00',3.22),('12374','2013-04-16','08:25:00',3.4),('12374','2013-04-16','08:30:00',3.47),('12374','2013-04-16','08:35:00',2.72),('12374','2013-04-16','08:40:00',2.34),('12374','2013-04-16','08:45:00',1.55),('12374','2013-04-16','08:50:00',2.66),('12374','2013-04-16','08:55:00',4.48),('12374','2013-04-16','09:00:00',4.86),('12374','2013-04-16','09:05:00',4.71),('12374','2013-04-16','09:10:00',3.94),('12374','2013-04-16','09:15:00',5.88),('12374','2013-04-16','09:20:00',4.27),('12374','2013-04-16','09:25:00',3.08),('12374','2013-04-16','09:30:00',3.45),('12374','2013-04-16','09:35:00',4.3),('12374','2013-04-16','09:40:00',3.55),('12374','2013-04-16','09:45:00',3.7),('12374','2013-04-16','09:50:00',3.13),('12374','2013-04-16','09:55:00',3.13),('12374','2013-04-16','10:00:00',3.41),('12374','2013-04-16','10:05:00',3.27),('12374','2013-04-16','10:10:00',2.96),('12374','2013-04-16','10:15:00',2.81),('12374','2013-04-16','10:20:00',3.1),('12374','2013-04-16','10:25:00',3.09),('12374','2013-04-16','10:30:00',2.71),('12374','2013-04-16','10:35:00',2.57),('12374','2013-04-16','10:40:00',2.82),('12374','2013-04-16','10:45:00',2.87),('12374','2013-04-16','10:50:00',2.85),('12374','2013-04-16','10:55:00',2.75),('12374','2013-04-16','11:00:00',2.73),('12374','2013-04-16','11:05:00',2.9),('12374','2013-04-16','11:10:00',3.23),('12374','2013-04-16','11:15:00',3.68),('12374','2013-04-16','11:20:00',3.95),('12374','2013-04-16','11:25:00',4.38),('12374','2013-04-16','11:30:00',5.25),('12374','2013-04-16','11:35:00',5.78),('12374','2013-04-16','11:40:00',5.82),('12374','2013-04-16','11:45:00',6.43),('12374','2013-04-16','11:50:00',6.1),('12374','2013-04-16','11:55:00',7.19),('12374','2013-04-16','12:00:00',7.35),('12374','2013-04-16','12:05:00',7.39),('12374','2013-04-16','12:10:00',7.6),('12374','2013-04-16','12:15:00',6.64),('12374','2013-04-16','12:20:00',8.43),('12374','2013-04-16','12:25:00',9.67),('12374','2013-04-16','12:30:00',7.65),('12374','2013-04-16','12:35:00',6.81),('12374','2013-04-16','12:40:00',8.68),('12374','2013-04-16','12:45:00',9.01),('12374','2013-04-16','12:50:00',8.95),('12374','2013-04-16','12:55:00',8.99),('12374','2013-04-16','13:00:00',9.05),('12374','2013-04-16','13:05:00',9.17),('12374','2013-04-16','13:10:00',9.16),('12374','2013-04-16','13:15:00',9.15),('12374','2013-04-16','13:20:00',9.04),('12374','2013-04-16','13:25:00',9.03),('12374','2013-04-16','13:30:00',9.09),('12374','2013-04-16','13:35:00',8.83),('12374','2013-04-16','13:40:00',8.74),('12374','2013-04-16','13:45:00',8.29),('12374','2013-04-16','13:50:00',8.58),('12374','2013-04-16','13:55:00',9.07),('12374','2013-04-16','14:00:00',9.08),('12374','2013-04-16','14:05:00',8.93),('12374','2013-04-16','14:10:00',8.96),('12374','2013-04-16','14:15:00',7.28),('12374','2013-04-16','14:20:00',8.64),('12374','2013-04-16','14:25:00',8.38),('12374','2013-04-16','14:30:00',8.49),('12374','2013-04-16','14:35:00',8.26),('12374','2013-04-16','14:40:00',6.11),('12374','2013-04-16','14:45:00',3.68),('12374','2013-04-16','14:50:00',5.46),('12374','2013-04-16','14:55:00',8.45),('12374','2013-04-16','15:00:00',8.26),('12374','2013-04-16','15:05:00',7.8),('12374','2013-04-16','15:10:00',7.59),('12374','2013-04-16','15:15:00',6.3),('12374','2013-04-16','15:20:00',7.3),('12374','2013-04-16','15:25:00',6.07),('12374','2013-04-16','15:30:00',6.26),('12374','2013-04-16','15:35:00',7.11),('12374','2013-04-16','15:40:00',7.06),('12374','2013-04-16','15:45:00',6.91),('12374','2013-04-16','15:50:00',6.78),('12374','2013-04-16','15:55:00',6.68),('12374','2013-04-16','16:00:00',6.57),('12374','2013-04-16','16:05:00',6.49),('12374','2013-04-16','16:10:00',5.93),('12374','2013-04-16','16:15:00',4.2),('12374','2013-04-16','16:20:00',4.61),('12374','2013-04-16','16:25:00',5.15),('12374','2013-04-16','16:30:00',5.89),('12374','2013-04-16','16:35:00',5.63),('12374','2013-04-16','16:40:00',5.62),('12374','2013-04-16','16:45:00',5.37),('12374','2013-04-16','16:50:00',5.08),('12374','2013-04-16','16:55:00',4.84),('12374','2013-04-16','17:00:00',4.6),('12374','2013-04-16','17:05:00',4.47),('12374','2013-04-16','17:10:00',4.32),('12374','2013-04-16','17:15:00',4.14),('12374','2013-04-16','17:20:00',3.93),('12374','2013-04-16','17:25:00',3.77),('12374','2013-04-16','17:30:00',3.58),('12374','2013-04-16','17:35:00',3.35),('12374','2013-04-16','17:40:00',3.25),('12374','2013-04-16','17:45:00',3.05),('12374','2013-04-16','17:50:00',2.89),('12374','2013-04-16','17:55:00',2.74),('12374','2013-04-16','18:00:00',2.56),('12374','2013-04-16','18:05:00',2.38),('12374','2013-04-16','18:10:00',2.13),('12374','2013-04-16','18:15:00',1.87),('12374','2013-04-16','18:20:00',1.68),('12374','2013-04-16','18:25:00',1.46),('12374','2013-04-16','18:30:00',1.28),('12374','2013-04-16','18:35:00',1.04),('12374','2013-04-15','07:25:00',1.06),('12374','2013-04-15','07:30:00',1.18),('12374','2013-04-15','07:35:00',1.15),('12374','2013-04-15','07:40:00',1.38),('12374','2013-04-15','07:45:00',1.07),('12374','2013-04-15','07:50:00',1.24),('12374','2013-04-15','07:55:00',1.55),('12374','2013-04-15','08:00:00',1.84),('12374','2013-04-15','08:05:00',2.18),('12374','2013-04-15','08:10:00',2.74),('12374','2013-04-15','08:15:00',3.21),('12374','2013-04-15','08:20:00',3.43),('12374','2013-04-15','08:25:00',3.63),('12374','2013-04-15','08:30:00',3.81),('12374','2013-04-15','08:35:00',3.98),('12374','2013-04-15','08:40:00',4.16),('12374','2013-04-15','08:45:00',4.31),('12374','2013-04-15','08:50:00',4.5),('12374','2013-04-15','08:55:00',4.65),('12374','2013-04-15','09:00:00',4.79),('12374','2013-04-15','09:05:00',4.92),('12374','2013-04-15','09:10:00',5.1),('12374','2013-04-15','09:15:00',5.09),('12374','2013-04-15','09:20:00',5.24),('12374','2013-04-15','09:25:00',5.45),('12374','2013-04-15','09:30:00',5.64),('12374','2013-04-15','09:35:00',5.74),('12374','2013-04-15','09:40:00',5.91),('12374','2013-04-15','09:45:00',6.03),('12374','2013-04-15','09:50:00',6.19),('12374','2013-04-15','09:55:00',6.33),('12374','2013-04-15','10:00:00',6.47),('12374','2013-04-15','10:05:00',6.58),('12374','2013-04-15','10:10:00',6.67),('12374','2013-04-15','10:15:00',6.72),('12374','2013-04-15','10:20:00',6.92),('12374','2013-04-15','10:25:00',7.04),('12374','2013-04-15','10:30:00',7.14),('12374','2013-04-15','10:35:00',7.18),('12374','2013-04-15','10:40:00',7.3),('12374','2013-04-15','10:45:00',7.38),('12374','2013-04-15','10:50:00',7.44),('12374','2013-04-15','10:55:00',7.56),('12374','2013-04-15','11:00:00',7.61),('12374','2013-04-15','11:05:00',7.72),('12374','2013-04-15','11:10:00',7.76),('12374','2013-04-15','11:15:00',7.91),('12374','2013-04-15','11:20:00',8),('12374','2013-04-15','11:25:00',8.1),('12374','2013-04-15','11:30:00',8.2),('12374','2013-04-15','11:35:00',8.27),('12374','2013-04-15','11:40:00',8.33),('12374','2013-04-15','11:45:00',8.43),('12374','2013-04-15','11:50:00',8.46),('12374','2013-04-15','11:55:00',8.52),('12374','2013-04-15','12:00:00',8.6),('12374','2013-04-15','12:05:00',8.67),('12374','2013-04-15','12:10:00',8.7),('12374','2013-04-15','12:15:00',8.83),('12374','2013-04-15','12:20:00',8.91),('12374','2013-04-15','12:25:00',8.98),('12374','2013-04-15','12:30:00',9.02),('12374','2013-04-15','12:35:00',9.06),('12374','2013-04-15','12:40:00',9.09),('12374','2013-04-15','12:45:00',9.05),('12374','2013-04-15','12:50:00',9.09),('12374','2013-04-15','12:55:00',9.09),('12374','2013-04-15','13:00:00',9.13),('12374','2013-04-15','13:05:00',9.18),('12374','2013-04-15','13:10:00',9.19),('12374','2013-04-15','13:15:00',9.19),('12374','2013-04-15','13:20:00',9.16),('12374','2013-04-15','13:25:00',8.92),('12374','2013-04-15','13:30:00',9.15),('12374','2013-04-15','13:35:00',9.04),('12374','2013-04-15','13:40:00',9),('12374','2013-04-15','13:45:00',9),('12374','2013-04-15','13:50:00',9.01),('12374','2013-04-15','13:55:00',8.98),('12374','2013-04-15','14:00:00',8.83),('12374','2013-04-15','14:05:00',8.87),('12374','2013-04-15','14:10:00',8.79),('12374','2013-04-15','14:15:00',8.73),('12374','2013-04-15','14:20:00',8.65),('12374','2013-04-15','14:25:00',8.59),('12374','2013-04-15','14:30:00',8.49),('12374','2013-04-15','14:35:00',8.37),('12374','2013-04-15','14:40:00',8.3),('12374','2013-04-15','14:45:00',8.25),('12374','2013-04-15','14:50:00',8.14),('12374','2013-04-15','14:55:00',8.06),('12374','2013-04-15','15:00:00',7.97),('12374','2013-04-15','15:05:00',7.87),('12374','2013-04-15','15:10:00',7.76),('12374','2013-04-15','15:15:00',7.65),('12374','2013-04-15','15:20:00',7.52),('12374','2013-04-15','15:25:00',7.41),('12374','2013-04-15','15:30:00',7.3),('12374','2013-04-15','15:35:00',7.19),('12374','2013-04-15','15:40:00',7.08),('12374','2013-04-15','15:45:00',6.94),('12374','2013-04-15','15:50:00',6.81),('12374','2013-04-15','15:55:00',6.68),('12374','2013-04-15','16:00:00',6.56),('12374','2013-04-15','16:05:00',6.42),('12374','2013-04-15','16:10:00',6.29),('12374','2013-04-15','16:15:00',6.12),('12374','2013-04-15','16:20:00',6.01),('12374','2013-04-15','16:25:00',5.87),('12374','2013-04-15','16:30:00',5.74),('12374','2013-04-15','16:35:00',5.59),('12374','2013-04-15','16:40:00',5.45),('12374','2013-04-15','16:45:00',5.25),('12374','2013-04-15','16:50:00',5.09),('12374','2013-04-15','16:55:00',4.92),('12374','2013-04-15','17:00:00',4.74),('12374','2013-04-15','17:05:00',4.58),('12374','2013-04-15','17:10:00',4.42),('12374','2013-04-15','17:15:00',4.21),('12374','2013-04-15','17:20:00',3.99),('12374','2013-04-15','17:25:00',3.84),('12374','2013-04-15','17:30:00',3.67),('12374','2013-04-15','17:35:00',3.48),('12374','2013-04-15','17:40:00',3.33),('12374','2013-04-15','17:45:00',3.15),('12374','2013-04-15','17:50:00',2.99),('12374','2013-04-15','17:55:00',2.82),('12374','2013-04-15','18:00:00',2.65),('12374','2013-04-15','18:05:00',2.44),('12374','2013-04-15','18:10:00',2.23),('12374','2013-04-15','18:15:00',2.02),('12374','2013-04-15','18:20:00',1.81),('12374','2013-04-15','18:25:00',1.64),('12374','2013-04-15','18:30:00',1.49),('12374','2013-04-15','18:35:00',1.34),('12374','2013-04-15','18:40:00',1.23),('12374','2013-04-15','18:45:00',1.14),('12374','2013-04-15','18:50:00',1.05),('12374','2013-04-14','07:30:00',1.22),('12374','2013-04-14','07:35:00',1.13),('12374','2013-04-14','07:40:00',1.42),('12374','2013-04-14','07:45:00',1.37),('12374','2013-04-14','07:50:00',1.48),('12374','2013-04-14','07:55:00',1.55),('12374','2013-04-14','08:00:00',1.73),('12374','2013-04-14','08:05:00',2.05),('12374','2013-04-14','08:10:00',2.56),('12374','2013-04-14','08:15:00',3.05),('12374','2013-04-14','08:20:00',3.24),('12374','2013-04-14','08:25:00',3.46),('12374','2013-04-14','08:30:00',3.65),('12374','2013-04-14','08:35:00',3.82),('12374','2013-04-14','08:40:00',3.99),('12374','2013-04-14','08:45:00',4.14),('12374','2013-04-14','08:50:00',4.29),('12374','2013-04-14','08:55:00',4.45),('12374','2013-04-14','09:00:00',4.63),('12374','2013-04-14','09:05:00',4.78),('12374','2013-04-14','09:10:00',4.94),('12374','2013-04-14','09:15:00',5.08),('12374','2013-04-14','09:20:00',5.23),('12374','2013-04-14','09:25:00',5.37),('12374','2013-04-14','09:30:00',5.51),('12374','2013-04-14','09:35:00',5.65),('12374','2013-04-14','09:40:00',5.81),('12374','2013-04-14','09:45:00',5.99),('12374','2013-04-14','09:50:00',6.12),('12374','2013-04-14','09:55:00',6.24),('12374','2013-04-14','10:00:00',6.36),('12374','2013-04-14','10:05:00',6.5),('12374','2013-04-14','10:10:00',6.62),('12374','2013-04-14','10:15:00',6.68),('12374','2013-04-14','10:20:00',6.81),('12374','2013-04-14','10:25:00',6.96),('12374','2013-04-14','10:30:00',7.06),('12374','2013-04-14','10:35:00',7.16),('12374','2013-04-14','10:40:00',7.24),('12374','2013-04-14','10:45:00',7.36),('12374','2013-04-14','10:50:00',7.47),('12374','2013-04-14','10:55:00',7.55),('12374','2013-04-14','11:00:00',7.55),('12374','2013-04-14','11:05:00',7.68),('12374','2013-04-14','11:10:00',7.79),('12374','2013-04-14','11:15:00',7.82),('12374','2013-04-14','11:20:00',7.98),('12374','2013-04-14','11:25:00',8.1),('12374','2013-04-14','11:30:00',8.21),('12374','2013-04-14','11:35:00',8.32),('12374','2013-04-14','11:40:00',8.38),('12374','2013-04-14','11:45:00',8.5),('12374','2013-04-14','11:50:00',8.58),('12374','2013-04-14','11:55:00',8.61),('12374','2013-04-14','12:00:00',8.65),('12374','2013-04-14','12:05:00',8.71),('12374','2013-04-14','12:10:00',8.8),('12374','2013-04-14','12:15:00',8.87),('12374','2013-04-14','12:20:00',8.9),('12374','2013-04-14','12:25:00',8.93),('12374','2013-04-14','12:30:00',8.97),('12374','2013-04-14','12:35:00',9.02),('12374','2013-04-14','12:40:00',9.03),('12374','2013-04-14','12:45:00',9.04),('12374','2013-04-14','12:50:00',9.03),('12374','2013-04-14','12:55:00',9),('12374','2013-04-14','13:00:00',9.09),('12374','2013-04-14','13:05:00',9.12),('12374','2013-04-14','13:10:00',9.05),('12374','2013-04-14','13:15:00',8.92),('12374','2013-04-14','13:20:00',9.08),('12374','2013-04-14','13:25:00',9.1),('12374','2013-04-14','13:30:00',9.09),('12374','2013-04-14','13:35:00',9.08),('12374','2013-04-14','13:40:00',9.06),('12374','2013-04-14','13:45:00',8.97),('12374','2013-04-14','13:50:00',8.88),('12374','2013-04-14','13:55:00',8.8),('12374','2013-04-14','14:00:00',8.77),('12374','2013-04-14','14:05:00',8.76),('12374','2013-04-14','14:10:00',8.67),('12374','2013-04-14','14:15:00',8.62),('12374','2013-04-14','14:20:00',8.56),('12374','2013-04-14','14:25:00',8.52),('12374','2013-04-14','14:30:00',8.44),('12374','2013-04-14','14:35:00',8.33),('12374','2013-04-14','14:40:00',8.22),('12374','2013-04-14','14:45:00',8.13),('12374','2013-04-14','14:50:00',8.03),('12374','2013-04-14','14:55:00',7.97),('12374','2013-04-14','15:00:00',7.86),('12374','2013-04-14','15:05:00',7.76),('12374','2013-04-14','15:10:00',7.68),('12374','2013-04-14','15:15:00',7.57),('12374','2013-04-14','15:20:00',7.46),('12374','2013-04-14','15:25:00',7.38),('12374','2013-04-14','15:30:00',7.24),('12374','2013-04-14','15:35:00',7.15),('12374','2013-04-14','15:40:00',7.01),('12374','2013-04-14','15:45:00',6.89),('12374','2013-04-14','15:50:00',6.77),('12374','2013-04-14','15:55:00',6.64),('12374','2013-04-14','16:00:00',6.51),('12374','2013-04-14','16:05:00',6.39),('12374','2013-04-14','16:10:00',6.24),('12374','2013-04-14','16:15:00',6.1),('12374','2013-04-14','16:20:00',5.96),('12374','2013-04-14','16:25:00',5.76),('12374','2013-04-14','16:30:00',5.61),('12374','2013-04-14','16:35:00',5.46),('12374','2013-04-14','16:40:00',5.33),('12374','2013-04-14','16:45:00',5.18),('12374','2013-04-14','16:50:00',5.05),('12374','2013-04-14','16:55:00',4.88),('12374','2013-04-14','17:00:00',4.71),('12374','2013-04-14','17:05:00',4.52),('12374','2013-04-14','17:10:00',4.37),('12374','2013-04-14','17:15:00',4.17),('12374','2013-04-14','17:20:00',3.95),('12374','2013-04-14','17:25:00',3.8),('12374','2013-04-14','17:30:00',3.61),('12374','2013-04-14','17:35:00',3.42),('12374','2013-04-14','17:40:00',3.27),('12374','2013-04-14','17:45:00',3.08),('12374','2013-04-14','17:50:00',2.94),('12374','2013-04-14','17:55:00',2.75),('12374','2013-04-14','18:00:00',2.58),('12374','2013-04-14','18:05:00',2.35),('12374','2013-04-14','18:10:00',2.19),('12374','2013-04-14','18:15:00',1.96),('12374','2013-04-14','18:20:00',1.76),('12374','2013-04-14','18:25:00',1.56),('12374','2013-04-14','18:30:00',1.44),('12374','2013-04-14','18:35:00',1.33),('12374','2013-04-14','18:40:00',1.22),('12374','2013-04-14','18:45:00',1.13),('12374','2013-04-14','18:50:00',1.02),('12374','2013-04-13','07:35:00',1),('12374','2013-04-13','07:40:00',1.19),('12374','2013-04-13','07:55:00',1),('12374','2013-04-13','08:00:00',1.7),('12374','2013-04-13','08:05:00',2.09),('12374','2013-04-13','08:10:00',2.3),('12374','2013-04-13','08:15:00',2.98),('12374','2013-04-13','08:20:00',3.24),('12374','2013-04-13','08:25:00',3.45),('12374','2013-04-13','08:30:00',3.61),('12374','2013-04-13','08:35:00',3.68),('12374','2013-04-13','08:40:00',3.85),('12374','2013-04-13','08:45:00',4.14),('12374','2013-04-13','08:50:00',4.59),('12374','2013-04-13','08:55:00',4.87),('12374','2013-04-13','09:00:00',5.16),('12374','2013-04-13','09:05:00',5.24),('12374','2013-04-13','09:10:00',5.1),('12374','2013-04-13','09:15:00',2.97),('12374','2013-04-13','09:20:00',5.94),('12374','2013-04-13','09:25:00',6.26),('12374','2013-04-13','09:30:00',4.71),('12374','2013-04-13','09:35:00',3.85),('12374','2013-04-13','09:40:00',5.26),('12374','2013-04-13','09:45:00',6.17),('12374','2013-04-13','09:50:00',6.43),('12374','2013-04-13','09:55:00',6.17),('12374','2013-04-13','10:00:00',5.55),('12374','2013-04-13','10:05:00',6.56),('12374','2013-04-13','10:10:00',6.67),('12374','2013-04-13','10:15:00',6.82),('12374','2013-04-13','10:20:00',6.87),('12374','2013-04-13','10:25:00',7.03),('12374','2013-04-13','10:30:00',7.11),('12374','2013-04-13','10:35:00',7.24),('12374','2013-04-13','10:40:00',7.2),('12374','2013-04-13','10:45:00',7.01),('12374','2013-04-13','10:50:00',7.5),('12374','2013-04-13','10:55:00',7.68),('12374','2013-04-13','11:00:00',7.84),('12374','2013-04-13','11:05:00',7.77),('12374','2013-04-13','11:10:00',8.02),('12374','2013-04-13','11:15:00',8.07),('12374','2013-04-13','11:20:00',8),('12374','2013-04-13','11:25:00',7.17),('12374','2013-04-13','11:30:00',7.98),('12374','2013-04-13','11:35:00',8.16),('12374','2013-04-13','11:40:00',8.31),('12374','2013-04-13','11:45:00',8.47),('12374','2013-04-13','11:50:00',8.53),('12374','2013-04-13','11:55:00',8.57),('12374','2013-04-13','12:00:00',8.67),('12374','2013-04-13','12:05:00',8.67),('12374','2013-04-13','12:10:00',8.9),('12374','2013-04-13','12:15:00',8.85),('12374','2013-04-13','12:20:00',8.83),('12374','2013-04-13','12:25:00',9.03),('12374','2013-04-13','12:30:00',9.15),('12374','2013-04-13','12:35:00',9.05),('12374','2013-04-13','12:40:00',9.01),('12374','2013-04-13','12:45:00',9.13),('12374','2013-04-13','12:50:00',8.83),('12374','2013-04-13','12:55:00',8.24),('12374','2013-04-13','13:00:00',7.99),('12374','2013-04-13','13:05:00',7.85),('12374','2013-04-13','13:10:00',8.3),('12374','2013-04-13','13:15:00',8.69),('12374','2013-04-13','13:20:00',8.49),('12374','2013-04-13','13:25:00',8.42),('12374','2013-04-13','13:30:00',8.32),('12374','2013-04-13','13:35:00',7.84),('12374','2013-04-13','13:40:00',7.8),('12374','2013-04-13','13:45:00',8.2),('12374','2013-04-13','13:50:00',8.23),('12374','2013-04-13','13:55:00',8.32),('12374','2013-04-13','14:00:00',8.26),('12374','2013-04-13','14:05:00',8.12),('12374','2013-04-13','14:10:00',7.95),('12374','2013-04-13','14:15:00',7.86),('12374','2013-04-13','14:20:00',7.73),('12374','2013-04-13','14:25:00',7.87),('12374','2013-04-13','14:30:00',7.9),('12374','2013-04-13','14:35:00',7.85),('12374','2013-04-13','14:40:00',7.59),('12374','2013-04-13','14:45:00',7.12),('12374','2013-04-13','14:50:00',6.4),('12374','2013-04-13','14:55:00',6.62),('12374','2013-04-13','15:00:00',6.69),('12374','2013-04-13','15:05:00',6.62),('12374','2013-04-13','15:10:00',6.61),('12374','2013-04-13','15:15:00',6.94),('12374','2013-04-13','15:20:00',6.75),('12374','2013-04-13','15:25:00',6.92),('12374','2013-04-13','15:30:00',6.46),('12374','2013-04-13','15:35:00',6.03),('12374','2013-04-13','15:40:00',6.43),('12374','2013-04-13','15:45:00',5.71),('12374','2013-04-13','15:50:00',5.67),('12374','2013-04-13','15:55:00',5.43),('12374','2013-04-13','16:00:00',5.59),('12374','2013-04-13','16:05:00',4.68),('12374','2013-04-13','16:10:00',4.08),('12374','2013-04-13','16:15:00',4.74),('12374','2013-04-13','16:20:00',4.54),('12374','2013-04-13','16:25:00',4.99),('12374','2013-04-13','16:30:00',5.43),('12374','2013-04-13','16:35:00',5.35),('12374','2013-04-13','16:40:00',5.36),('12374','2013-04-13','16:45:00',5.1),('12374','2013-04-13','16:50:00',5.1),('12374','2013-04-13','16:55:00',5.1),('12374','2013-04-13','17:00:00',4.01),('12374','2013-04-13','17:05:00',3.57),('12374','2013-04-13','17:10:00',2.3),('12374','2013-04-13','17:15:00',2.48),('12374','2013-04-13','17:20:00',3),('12374','2013-04-13','17:25:00',3.03),('12374','2013-04-13','17:30:00',4.48),('12374','2013-04-13','17:35:00',3.09),('12374','2013-04-13','17:40:00',2.62),('12374','2013-04-13','17:45:00',2.12),('12374','2013-04-13','17:50:00',1.48),('12374','2013-04-13','17:55:00',1.43),('12374','2013-04-13','18:00:00',1.62),('12374','2013-04-13','18:05:00',1.98),('12374','2013-04-13','18:10:00',1.57),('12374','2013-04-13','18:15:00',1.04),('12374','2013-04-13','18:20:00',1.27),('12374','2013-04-13','18:25:00',1.53),('12374','2013-04-13','18:30:00',1.42),('12374','2013-04-13','18:35:00',1.03),('12374','2013-04-13','18:40:00',1.08),('12374','2013-04-13','18:45:00',1.11),('12374','2013-04-12','08:20:00',1.11),('12374','2013-04-12','08:25:00',1.17),('12374','2013-04-12','08:30:00',1.47),('12374','2013-04-12','08:35:00',2.22),('12374','2013-04-12','08:40:00',1.17),('12374','2013-04-12','08:45:00',2.17),('12374','2013-04-12','08:50:00',2.17),('12374','2013-04-12','08:55:00',4.2),('12374','2013-04-12','09:00:00',2.67),('12374','2013-04-12','09:05:00',1.71),('12374','2013-04-12','09:10:00',4.15),('12374','2013-04-12','09:15:00',3.37),('12374','2013-04-12','09:20:00',1.67),('12374','2013-04-12','09:25:00',1.64),('12374','2013-04-12','09:30:00',4.71),('12374','2013-04-12','09:35:00',4.55),('12374','2013-04-12','09:40:00',3.55),('12374','2013-04-12','09:45:00',4.66),('12374','2013-04-12','09:50:00',5.12),('12374','2013-04-12','09:55:00',4.01),('12374','2013-04-12','10:00:00',2.25),('12374','2013-04-12','10:05:00',1.89),('12374','2013-04-12','10:10:00',1.93),('12374','2013-04-12','10:15:00',1.75),('12374','2013-04-12','10:20:00',1.54),('12374','2013-04-12','10:25:00',2.31),('12374','2013-04-12','10:30:00',5.98),('12374','2013-04-12','10:35:00',2.35),('12374','2013-04-12','10:40:00',2.54),('12374','2013-04-12','10:45:00',2.23),('12374','2013-04-12','10:50:00',3.04),('12374','2013-04-12','10:55:00',5.19),('12374','2013-04-12','11:00:00',6.62),('12374','2013-04-12','11:05:00',4.12),('12374','2013-04-12','11:10:00',4.4),('12374','2013-04-12','11:15:00',7.36),('12374','2013-04-12','11:20:00',8.17),('12374','2013-04-12','11:25:00',7.04),('12374','2013-04-12','11:30:00',5.15),('12374','2013-04-12','11:35:00',5.16),('12374','2013-04-12','11:40:00',6.99),('12374','2013-04-12','11:45:00',9.47),('12374','2013-04-12','11:50:00',5.76),('12374','2013-04-12','11:55:00',4.43),('12374','2013-04-12','12:00:00',3.46),('12374','2013-04-12','12:05:00',4.31),('12374','2013-04-12','12:10:00',5.04),('12374','2013-04-12','12:15:00',6.34),('12374','2013-04-12','12:20:00',8.42),('12374','2013-04-12','12:25:00',8.8),('12374','2013-04-12','12:30:00',7.14),('12374','2013-04-12','12:35:00',9.39),('12374','2013-04-12','12:40:00',9.03),('12374','2013-04-12','12:45:00',7.06),('12374','2013-04-12','12:50:00',9.4),('12374','2013-04-12','12:55:00',9.26),('12374','2013-04-12','13:00:00',9.49),('12374','2013-04-12','13:05:00',9.47),('12374','2013-04-12','13:10:00',9.33),('12374','2013-04-12','13:15:00',9.31),('12374','2013-04-12','13:20:00',9.35),('12374','2013-04-12','13:25:00',9.3),('12374','2013-04-12','13:30:00',8.75),('12374','2013-04-12','13:35:00',9.45),('12374','2013-04-12','13:40:00',9.4),('12374','2013-04-12','13:45:00',9.43),('12374','2013-04-12','13:50:00',9.84),('12374','2013-04-12','13:55:00',9.43),('12374','2013-04-12','14:00:00',6.46),('12374','2013-04-12','14:05:00',8.66),('12374','2013-04-12','14:10:00',9),('12374','2013-04-12','14:15:00',7.82),('12374','2013-04-12','14:20:00',8.82),('12374','2013-04-12','14:25:00',8.79),('12374','2013-04-12','14:30:00',8.63),('12374','2013-04-12','14:35:00',8.46),('12374','2013-04-12','14:40:00',8.34),('12374','2013-04-12','14:45:00',8.3),('12374','2013-04-12','14:50:00',8.2),('12374','2013-04-12','14:55:00',8.09),('12374','2013-04-12','15:00:00',7.99),('12374','2013-04-12','15:05:00',7.87),('12374','2013-04-12','15:10:00',7.77),('12374','2013-04-12','15:15:00',7.66),('12374','2013-04-12','15:20:00',7.57),('12374','2013-04-12','15:25:00',7.46),('12374','2013-04-12','15:30:00',7.35),('12374','2013-04-12','15:35:00',7.21),('12374','2013-04-12','15:40:00',7.06),('12374','2013-04-12','15:45:00',6.95),('12374','2013-04-12','15:50:00',6.82),('12374','2013-04-12','15:55:00',6.68),('12374','2013-04-12','16:00:00',6.54),('12374','2013-04-12','16:05:00',6.4),('12374','2013-04-12','16:10:00',6.28),('12374','2013-04-12','16:15:00',5.98),('12374','2013-04-12','16:20:00',3.7),('12374','2013-04-12','16:25:00',3.93),('12374','2013-04-12','16:30:00',3.98),('12374','2013-04-12','16:35:00',3.44),('12374','2013-04-12','16:40:00',3.43),('12374','2013-04-12','16:45:00',3.15),('12374','2013-04-12','16:50:00',2.88),('12374','2013-04-12','16:55:00',2.8),('12374','2013-04-12','17:00:00',2.67),('12374','2013-04-12','17:05:00',2.35),('12374','2013-04-12','17:10:00',2.32),('12374','2013-04-12','17:15:00',2.4),('12374','2013-04-12','17:20:00',2.93),('12374','2013-04-12','17:25:00',2.68),('12374','2013-04-12','17:30:00',2.44),('12374','2013-04-12','17:35:00',2.48),('12374','2013-04-12','17:40:00',1.53),('12374','2013-04-12','17:45:00',1.46),('12374','2013-04-12','17:50:00',1.34),('12374','2013-04-12','17:55:00',1.12),('12374','2013-04-11','07:25:00',1.05),('12374','2013-04-11','07:30:00',1.2),('12374','2013-04-11','07:35:00',1.37),('12374','2013-04-11','07:40:00',1.43),('12374','2013-04-11','07:45:00',1.54),('12374','2013-04-11','07:50:00',1.22),('12374','2013-04-11','07:55:00',1.41),('12374','2013-04-11','08:00:00',1.17),('12374','2013-04-11','08:05:00',1.95),('12374','2013-04-11','08:10:00',2.32),('12374','2013-04-11','08:15:00',2.51),('12374','2013-04-11','08:20:00',3.24),('12374','2013-04-11','08:25:00',3.33),('12374','2013-04-11','08:30:00',3.31),('12374','2013-04-11','08:35:00',3.81),('12374','2013-04-11','08:40:00',3.96),('12374','2013-04-11','08:45:00',4.11),('12374','2013-04-11','08:50:00',4.19),('12374','2013-04-11','08:55:00',3.63),('12374','2013-04-11','09:00:00',4.67),('12374','2013-04-11','09:05:00',4.84),('12374','2013-04-11','09:10:00',4.97),('12374','2013-04-11','09:15:00',5.14),('12374','2013-04-11','09:20:00',5.31),('12374','2013-04-11','09:25:00',5.46),('12374','2013-04-11','09:30:00',5.57),('12374','2013-04-11','09:35:00',3.6),('12374','2013-04-11','09:40:00',6.27),('12374','2013-04-11','09:45:00',6.41),('12374','2013-04-11','09:50:00',6.32),('12374','2013-04-11','09:55:00',6.53),('12374','2013-04-11','10:00:00',6.69),('12374','2013-04-11','10:05:00',6.85),('12374','2013-04-11','10:10:00',7.14),('12374','2013-04-11','10:15:00',7.21),('12374','2013-04-11','10:20:00',7.53),('12374','2013-04-11','10:25:00',2.76),('12374','2013-04-11','10:30:00',3.8),('12374','2013-04-11','10:35:00',5.5),('12374','2013-04-11','10:40:00',5.48),('12374','2013-04-11','10:45:00',3.74),('12374','2013-04-11','10:50:00',6.95),('12374','2013-04-11','10:55:00',8),('12374','2013-04-11','11:00:00',7.98),('12374','2013-04-11','11:05:00',8.07),('12374','2013-04-11','11:10:00',8.06),('12374','2013-04-11','11:15:00',8.11),('12374','2013-04-11','11:20:00',8.28),('12374','2013-04-11','11:25:00',8.33),('12374','2013-04-11','11:30:00',8.44),('12374','2013-04-11','11:35:00',8.51),('12374','2013-04-11','11:40:00',8.6),('12374','2013-04-11','11:45:00',8.72),('12374','2013-04-11','11:50:00',8.79),('12374','2013-04-11','11:55:00',9.04),('12374','2013-04-11','12:00:00',8.06),('12374','2013-04-11','12:05:00',6.83),('12374','2013-04-11','12:10:00',6.35),('12374','2013-04-11','12:15:00',9.42),('12374','2013-04-11','12:20:00',7.23),('12374','2013-04-11','12:25:00',9.3),('12374','2013-04-11','12:30:00',9.23),('12374','2013-04-11','12:35:00',9.27),('12374','2013-04-11','12:40:00',9.26),('12374','2013-04-11','12:45:00',9.26),('12374','2013-04-11','12:50:00',8.93),('12374','2013-04-11','12:55:00',9.3),('12374','2013-04-11','13:00:00',8.78),('12374','2013-04-11','13:05:00',9.41),('12374','2013-04-11','13:10:00',9.31),('12374','2013-04-11','13:15:00',9.32),('12374','2013-04-11','13:20:00',9.29),('12374','2013-04-11','13:25:00',9.25),('12374','2013-04-11','13:30:00',9.24),('12374','2013-04-11','13:35:00',9.25),('12374','2013-04-11','13:40:00',9.18),('12374','2013-04-11','13:45:00',9.09),('12374','2013-04-11','13:50:00',9.04),('12374','2013-04-11','13:55:00',9.05),('12374','2013-04-11','14:00:00',9.05),('12374','2013-04-11','14:05:00',8.96),('12374','2013-04-11','14:10:00',8.91),('12374','2013-04-11','14:15:00',8.88),('12374','2013-04-11','14:20:00',8.78),('12374','2013-04-11','14:25:00',8.7),('12374','2013-04-11','14:30:00',8.64),('12374','2013-04-11','14:35:00',8.55),('12374','2013-04-11','14:40:00',8.49),('12374','2013-04-11','14:45:00',8.37),('12374','2013-04-11','14:50:00',8.26),('12374','2013-04-11','14:55:00',8.14),('12374','2013-04-11','15:00:00',8.03),('12374','2013-04-11','15:05:00',7.93),('12374','2013-04-11','15:10:00',7.86),('12374','2013-04-11','15:15:00',7.78),('12374','2013-04-11','15:20:00',7.65),('12374','2013-04-11','15:25:00',7.55),('12374','2013-04-11','15:30:00',7.43),('12374','2013-04-11','15:35:00',7.31),('12374','2013-04-11','15:40:00',7.18),('12374','2013-04-11','15:45:00',7.06),('12374','2013-04-11','15:50:00',6.93),('12374','2013-04-11','15:55:00',6.82),('12374','2013-04-11','16:00:00',6.67),('12374','2013-04-11','16:05:00',6.53),('12374','2013-04-11','16:10:00',6.39),('12374','2013-04-11','16:15:00',6.27),('12374','2013-04-11','16:20:00',6.11),('12374','2013-04-11','16:25:00',5.94),('12374','2013-04-11','16:30:00',5.83),('12374','2013-04-11','16:35:00',5.67),('12374','2013-04-11','16:40:00',5.51),('12374','2013-04-11','16:45:00',5.34),('12374','2013-04-11','16:50:00',5.13),('12374','2013-04-11','16:55:00',5.02),('12374','2013-04-11','17:00:00',4.86),('12374','2013-04-11','17:05:00',4.68),('12374','2013-04-11','17:10:00',4.51),('12374','2013-04-11','17:15:00',4.32),('12374','2013-04-11','17:20:00',4.12),('12374','2013-04-11','17:25:00',3.92),('12374','2013-04-11','17:30:00',3.77),('12374','2013-04-11','17:35:00',3.6),('12374','2013-04-11','17:40:00',3.38),('12374','2013-04-11','17:45:00',3.11),('12374','2013-04-11','17:50:00',2.88),('12374','2013-04-11','17:55:00',2.62),('12374','2013-04-11','18:00:00',2.29),('12374','2013-04-11','18:05:00',2.4),('12374','2013-04-11','18:10:00',2.26),('12374','2013-04-11','18:15:00',2.1),('12374','2013-04-11','18:20:00',1.76),('12374','2013-04-11','18:25:00',1.58),('12374','2013-04-11','18:30:00',1.45),('12374','2013-04-11','18:35:00',1.24),('12374','2013-04-10','08:25:00',1.07),('12374','2013-04-10','08:30:00',1.53),('12374','2013-04-10','08:35:00',2.59),('12374','2013-04-10','08:40:00',3.59),('12374','2013-04-10','08:45:00',3.91),('12374','2013-04-10','08:50:00',4.39),('12374','2013-04-10','08:55:00',3.25),('12374','2013-04-10','09:00:00',1.67),('12374','2013-04-10','09:05:00',2.76),('12374','2013-04-10','09:10:00',1.23),('12374','2013-04-10','09:15:00',1.44),('12374','2013-04-10','09:20:00',1.01),('12374','2013-04-10','09:25:00',1.22),('12374','2013-04-10','09:30:00',2.22),('12374','2013-04-10','09:35:00',2.29),('12374','2013-04-10','09:40:00',3.13),('12374','2013-04-10','09:45:00',2.58),('12374','2013-04-10','09:50:00',1.67),('12374','2013-04-10','09:55:00',1.65),('12374','2013-04-10','10:00:00',1.28),('12374','2013-04-10','10:30:00',1.64),('12374','2013-04-10','10:35:00',1.86),('12374','2013-04-10','10:40:00',2.84),('12374','2013-04-10','10:45:00',4.55),('12374','2013-04-10','10:50:00',7.33),('12374','2013-04-10','10:55:00',7.96),('12374','2013-04-10','11:00:00',6.03),('12374','2013-04-10','11:05:00',7.04),('12374','2013-04-10','11:10:00',5.96),('12374','2013-04-10','11:15:00',6.55),('12374','2013-04-10','11:20:00',7.81),('12374','2013-04-10','11:25:00',8.46),('12374','2013-04-10','11:30:00',8.29),('12374','2013-04-10','11:35:00',9.36),('12374','2013-04-10','11:40:00',8.33),('12374','2013-04-10','11:45:00',8.54),('12374','2013-04-10','11:50:00',7.13),('12374','2013-04-10','11:55:00',4.34),('12374','2013-04-10','12:00:00',4.77),('12374','2013-04-10','12:05:00',5.99),('12374','2013-04-10','12:10:00',6.05),('12374','2013-04-10','12:15:00',5.54),('12374','2013-04-10','12:20:00',7.01),('12374','2013-04-10','12:25:00',4.88),('12374','2013-04-10','12:30:00',8.73),('12374','2013-04-10','12:35:00',7.16),('12374','2013-04-10','12:40:00',6.6),('12374','2013-04-10','12:45:00',9.65),('12374','2013-04-10','12:50:00',8.73),('12374','2013-04-10','12:55:00',9.01),('12374','2013-04-10','13:00:00',7.03),('12374','2013-04-10','13:05:00',8.16),('12374','2013-04-10','13:10:00',6.87),('12374','2013-04-10','13:15:00',7.39),('12374','2013-04-10','13:20:00',8.89),('12374','2013-04-10','13:25:00',9.33),('12374','2013-04-10','13:30:00',8.68),('12374','2013-04-10','13:35:00',7.47),('12374','2013-04-10','13:40:00',7.63),('12374','2013-04-10','13:45:00',9.18),('12374','2013-04-10','13:50:00',8.6),('12374','2013-04-10','13:55:00',8.94),('12374','2013-04-10','14:00:00',8.47),('12374','2013-04-10','14:05:00',7.35),('12374','2013-04-10','14:10:00',9.26),('12374','2013-04-10','14:15:00',9.05),('12374','2013-04-10','14:20:00',8.48),('12374','2013-04-10','14:25:00',8.64),('12374','2013-04-10','14:30:00',8.23),('12374','2013-04-10','14:35:00',8.35),('12374','2013-04-10','14:40:00',8.41),('12374','2013-04-10','14:45:00',7.57),('12374','2013-04-10','14:50:00',8.35),('12374','2013-04-10','14:55:00',8.21),('12374','2013-04-10','15:00:00',8.09),('12374','2013-04-10','15:05:00',7.86),('12374','2013-04-10','15:10:00',7.95),('12374','2013-04-10','15:15:00',7.82),('12374','2013-04-10','15:20:00',7.76),('12374','2013-04-10','15:25:00',7.06),('12374','2013-04-10','15:30:00',7.57),('12374','2013-04-10','15:35:00',7.35),('12374','2013-04-10','15:40:00',7.21),('12374','2013-04-10','15:45:00',7.06),('12374','2013-04-10','15:50:00',6.99),('12374','2013-04-10','15:55:00',6.81),('12374','2013-04-10','16:00:00',6.74),('12374','2013-04-10','16:05:00',4.97),('12374','2013-04-10','16:10:00',6.57),('12374','2013-04-10','16:15:00',6.14),('12374','2013-04-10','16:20:00',6.08),('12374','2013-04-10','16:25:00',5.24),('12374','2013-04-10','16:30:00',5.69),('12374','2013-04-10','16:35:00',5.63),('12374','2013-04-10','16:40:00',5.43),('12374','2013-04-10','16:45:00',5.22),('12374','2013-04-10','16:50:00',5.08),('12374','2013-04-10','16:55:00',5.05),('12374','2013-04-10','17:00:00',4.74),('12374','2013-04-10','17:05:00',4.55),('12374','2013-04-10','17:10:00',4.43),('12374','2013-04-10','17:15:00',4.1),('12374','2013-04-10','17:20:00',4.09),('12374','2013-04-10','17:25:00',4.02),('12374','2013-04-10','17:30:00',3.29),('12374','2013-04-10','17:35:00',3.61),('12374','2013-04-10','17:40:00',3.44),('12374','2013-04-10','17:45:00',3.25),('12374','2013-04-10','17:50:00',3),('12374','2013-04-10','17:55:00',2.81),('12374','2013-04-10','18:00:00',2.72),('12374','2013-04-10','18:05:00',2.39),('12374','2013-04-10','18:10:00',1.69),('12374','2013-04-10','18:15:00',1.85),('12374','2013-04-10','18:20:00',1.01),('12374','2013-04-10','18:25:00',1.27),('12374','2013-04-09','07:40:00',1.22),('12374','2013-04-09','08:15:00',2.21),('12374','2013-04-09','08:20:00',3),('12374','2013-04-09','08:25:00',3.34),('12374','2013-04-09','08:30:00',2.7),('12374','2013-04-09','08:35:00',2.28),('12374','2013-04-09','08:40:00',1.18),('12374','2013-04-09','08:45:00',1.56),('12374','2013-04-09','08:50:00',1.34),('12374','2013-04-09','08:55:00',1.43),('12374','2013-04-09','09:00:00',2.42),('12374','2013-04-09','09:05:00',3.57),('12374','2013-04-09','09:10:00',3.71),('12374','2013-04-09','09:15:00',4.5),('12374','2013-04-09','09:20:00',5.23),('12374','2013-04-09','09:25:00',5.34),('12374','2013-04-09','09:30:00',5.56),('12374','2013-04-09','09:35:00',5.77),('12374','2013-04-09','09:40:00',5.91),('12374','2013-04-09','09:45:00',6),('12374','2013-04-09','09:50:00',6.18),('12374','2013-04-09','09:55:00',6.32),('12374','2013-04-09','10:00:00',6.45),('12374','2013-04-09','10:05:00',6.64),('12374','2013-04-09','10:10:00',6.83),('12374','2013-04-09','10:15:00',6.48),('12374','2013-04-09','10:20:00',7.12),('12374','2013-04-09','10:25:00',7.24),('12374','2013-04-09','10:30:00',7.37),('12374','2013-04-09','10:35:00',7.44),('12374','2013-04-09','10:40:00',7.17),('12374','2013-04-09','10:45:00',5.24),('12374','2013-04-09','10:50:00',7.53),('12374','2013-04-09','10:55:00',9.26),('12374','2013-04-09','11:00:00',3.83),('12374','2013-04-09','11:05:00',3.19),('12374','2013-04-09','11:10:00',6.92),('12374','2013-04-09','11:15:00',7.43),('12374','2013-04-09','11:20:00',7.42),('12374','2013-04-09','11:25:00',6.18),('12374','2013-04-09','11:30:00',5.2),('12374','2013-04-09','11:35:00',8.46),('12374','2013-04-09','11:40:00',9.18),('12374','2013-04-09','11:45:00',8.29),('12374','2013-04-09','11:50:00',7.82),('12374','2013-04-09','11:55:00',7.66),('12374','2013-04-09','12:00:00',8.55),('12374','2013-04-09','12:05:00',9.41),('12374','2013-04-09','12:10:00',7.32),('12374','2013-04-09','12:15:00',8.68),('12374','2013-04-09','12:20:00',9.1),('12374','2013-04-09','12:25:00',8.7),('12374','2013-04-09','12:30:00',5.47),('12374','2013-04-09','12:35:00',8.6),('12374','2013-04-09','12:40:00',9.56),('12374','2013-04-09','12:45:00',9.44),('12374','2013-04-09','12:50:00',9.51),('12374','2013-04-09','12:55:00',9.6),('12374','2013-04-09','13:00:00',8.07),('12374','2013-04-09','13:05:00',9.01),('12374','2013-04-09','13:10:00',8.91),('12374','2013-04-09','13:15:00',7.39),('12374','2013-04-09','13:20:00',7.69),('12374','2013-04-09','13:25:00',8.85),('12374','2013-04-09','13:30:00',9.2),('12374','2013-04-09','13:35:00',9.4),('12374','2013-04-09','13:40:00',8.96),('12374','2013-04-09','13:45:00',8.13),('12374','2013-04-09','13:50:00',8.86),('12374','2013-04-09','13:55:00',9.08),('12374','2013-04-09','14:00:00',8.05),('12374','2013-04-09','14:05:00',8.15),('12374','2013-04-09','14:10:00',7.14),('12374','2013-04-09','14:15:00',8.19),('12374','2013-04-09','14:20:00',8.38),('12374','2013-04-09','14:25:00',8.31),('12374','2013-04-09','14:30:00',8.4),('12374','2013-04-09','14:35:00',7.9),('12374','2013-04-09','14:40:00',8.54),('12374','2013-04-09','14:45:00',7.6),('12374','2013-04-09','14:50:00',7.76),('12374','2013-04-09','14:55:00',8.17),('12374','2013-04-09','15:00:00',8.31),('12374','2013-04-09','15:05:00',7.73),('12374','2013-04-09','15:10:00',7.94),('12374','2013-04-09','15:15:00',7.71),('12374','2013-04-09','15:20:00',7.89),('12374','2013-04-09','15:25:00',6.77),('12374','2013-04-09','15:30:00',7.37),('12374','2013-04-09','15:35:00',6.77),('12374','2013-04-09','15:40:00',7.04),('12374','2013-04-09','15:45:00',6.93),('12374','2013-04-09','15:50:00',6.91),('12374','2013-04-09','15:55:00',6.96),('12374','2013-04-09','16:00:00',6.73),('12374','2013-04-09','16:05:00',6.42),('12374','2013-04-09','16:10:00',6.38),('12374','2013-04-09','16:15:00',5.6),('12374','2013-04-09','16:20:00',5.04),('12374','2013-04-09','16:25:00',5.53),('12374','2013-04-09','16:30:00',5.53),('12374','2013-04-09','16:35:00',5.88),('12374','2013-04-09','16:40:00',5.54),('12374','2013-04-09','16:45:00',5.36),('12374','2013-04-09','16:50:00',5.55),('12374','2013-04-09','16:55:00',5.25),('12374','2013-04-09','17:00:00',5.21),('12374','2013-04-09','17:05:00',4.89),('12374','2013-04-09','17:10:00',4.8),('12374','2013-04-09','17:15:00',3.84),('12374','2013-04-09','17:20:00',3.44),('12374','2013-04-09','17:25:00',2.96),('12374','2013-04-09','17:30:00',3.02),('12374','2013-04-09','17:35:00',2.82),('12374','2013-04-09','17:40:00',2.26),('12374','2013-04-09','17:45:00',2.31),('12374','2013-04-09','17:50:00',3.17),('12374','2013-04-09','17:55:00',2.64),('12374','2013-04-09','18:00:00',2.48),('12374','2013-04-09','18:05:00',1.73),('12374','2013-04-09','18:10:00',1.21),('12374','2013-04-09','18:15:00',1.13),('12374','2013-04-09','18:20:00',1.12),('12374','2013-04-08','07:40:00',1.24),('12374','2013-04-08','07:50:00',1.28),('12374','2013-04-08','07:55:00',1.29),('12374','2013-04-08','08:05:00',1.06),('12374','2013-04-08','08:10:00',1.22),('12374','2013-04-08','08:15:00',1.69),('12374','2013-04-08','08:20:00',3.31),('12374','2013-04-08','08:25:00',3.53),('12374','2013-04-08','08:30:00',3.42),('12374','2013-04-08','08:35:00',3.76),('12374','2013-04-08','08:40:00',3.92),('12374','2013-04-08','08:45:00',4.09),('12374','2013-04-08','08:50:00',4.42),('12374','2013-04-08','08:55:00',4.64),('12374','2013-04-08','09:00:00',4.81),('12374','2013-04-08','09:05:00',5.15),('12374','2013-04-08','09:10:00',5.06),('12374','2013-04-08','09:15:00',5.31),('12374','2013-04-08','09:20:00',5.6),('12374','2013-04-08','09:25:00',5.82),('12374','2013-04-08','09:30:00',6.03),('12374','2013-04-08','09:35:00',5.86),('12374','2013-04-08','09:40:00',3.95),('12374','2013-04-08','09:45:00',5.57),('12374','2013-04-08','09:50:00',6.37),('12374','2013-04-08','09:55:00',6.28),('12374','2013-04-08','10:00:00',6.63),('12374','2013-04-08','10:05:00',6.67),('12374','2013-04-08','10:10:00',6.47),('12374','2013-04-08','10:15:00',6.64),('12374','2013-04-08','10:20:00',6.83),('12374','2013-04-08','10:25:00',6.71),('12374','2013-04-08','10:30:00',6.88),('12374','2013-04-08','10:35:00',7.34),('12374','2013-04-08','10:40:00',6.83),('12374','2013-04-08','10:45:00',6.97),('12374','2013-04-08','10:50:00',7.24),('12374','2013-04-08','10:55:00',6.34),('12374','2013-04-08','11:00:00',5.52),('12374','2013-04-08','11:05:00',5.5),('12374','2013-04-08','11:10:00',4.58),('12374','2013-04-08','11:15:00',5.27),('12374','2013-04-08','11:20:00',5.62),('12374','2013-04-08','11:25:00',6.67),('12374','2013-04-08','11:30:00',5.9),('12374','2013-04-08','11:35:00',6.65),('12374','2013-04-08','11:40:00',7.21),('12374','2013-04-08','11:45:00',8.03),('12374','2013-04-08','11:50:00',7.51),('12374','2013-04-08','11:55:00',6.81),('12374','2013-04-08','12:00:00',7.85),('12374','2013-04-08','12:05:00',7.53),('12374','2013-04-08','12:10:00',6.57),('12374','2013-04-08','12:15:00',7.35),('12374','2013-04-08','12:20:00',6.73),('12374','2013-04-08','12:25:00',5.93),('12374','2013-04-08','12:30:00',6.73),('12374','2013-04-08','12:35:00',7.05),('12374','2013-04-08','12:40:00',6.65),('12374','2013-04-08','12:45:00',7.61),('12374','2013-04-08','12:50:00',8.38),('12374','2013-04-08','12:55:00',7.83),('12374','2013-04-08','13:00:00',7.65),('12374','2013-04-08','13:05:00',7.74),('12374','2013-04-08','13:10:00',6.31),('12374','2013-04-08','13:15:00',7.05),('12374','2013-04-08','13:20:00',7.91),('12374','2013-04-08','13:25:00',5.92),('12374','2013-04-08','13:30:00',8.28),('12374','2013-04-08','13:35:00',7.42),('12374','2013-04-08','13:40:00',7.91),('12374','2013-04-08','13:45:00',8.78),('12374','2013-04-08','13:50:00',6.7),('12374','2013-04-08','13:55:00',6.71),('12374','2013-04-08','14:00:00',8),('12374','2013-04-08','14:05:00',8.01),('12374','2013-04-08','14:10:00',7.71),('12374','2013-04-08','14:15:00',8.05),('12374','2013-04-08','14:20:00',7.49),('12374','2013-04-08','14:25:00',7.74),('12374','2013-04-08','14:30:00',7.13),('12374','2013-04-08','14:35:00',8.05),('12374','2013-04-08','14:40:00',8.47),('12374','2013-04-08','14:45:00',6.95),('12374','2013-04-08','14:50:00',6.21),('12374','2013-04-08','14:55:00',6.2),('12374','2013-04-08','15:00:00',6.77),('12374','2013-04-08','15:05:00',6.7),('12374','2013-04-08','15:10:00',5.56),('12374','2013-04-08','15:15:00',7.96),('12374','2013-04-08','15:20:00',7.92),('12374','2013-04-08','15:25:00',7.61),('12374','2013-04-08','15:30:00',7.42),('12374','2013-04-08','15:35:00',7.34),('12374','2013-04-08','15:40:00',7.25),('12374','2013-04-08','15:45:00',5.72),('12374','2013-04-08','15:50:00',5.1),('12374','2013-04-08','15:55:00',6.69),('12374','2013-04-08','16:00:00',6.7),('12374','2013-04-08','16:05:00',6.52),('12374','2013-04-08','16:10:00',6.33),('12374','2013-04-08','16:15:00',6.21),('12374','2013-04-08','16:20:00',6.05),('12374','2013-04-08','16:25:00',5.91),('12374','2013-04-08','16:30:00',5.73),('12374','2013-04-08','16:35:00',5.61),('12374','2013-04-08','16:40:00',5.45),('12374','2013-04-08','16:45:00',5.34),('12374','2013-04-08','16:50:00',5.12),('12374','2013-04-08','16:55:00',4.87),('12374','2013-04-08','17:00:00',4.64),('12374','2013-04-08','17:05:00',4.53),('12374','2013-04-08','17:10:00',4.22),('12374','2013-04-08','17:15:00',4.26),('12374','2013-04-08','17:20:00',3.09),('12374','2013-04-08','17:25:00',3.49),('12374','2013-04-08','17:30:00',3.48),('12374','2013-04-08','17:35:00',3.37),('12374','2013-04-08','17:40:00',2.7),('12374','2013-04-08','17:45:00',2.25),('12374','2013-04-08','17:50:00',1.74),('12374','2013-04-08','17:55:00',1.65),('12374','2013-04-08','18:00:00',3.19),('12374','2013-04-08','18:05:00',3.07),('12374','2013-04-08','18:10:00',2.48),('12374','2013-04-08','18:15:00',1.93),('12374','2013-04-08','18:20:00',1.74),('12374','2013-04-08','18:25:00',1.56),('12374','2013-04-08','18:30:00',1.1),('12374','2013-04-07','07:35:00',1.32),('12374','2013-04-07','07:40:00',1.62),('12374','2013-04-07','07:45:00',1.74),('12374','2013-04-07','07:50:00',1.68),('12374','2013-04-07','07:55:00',1.65),('12374','2013-04-07','08:00:00',1.68),('12374','2013-04-07','08:05:00',1.96),('12374','2013-04-07','08:10:00',1.92),('12374','2013-04-07','08:15:00',2.41),('12374','2013-04-07','08:20:00',3.12),('12374','2013-04-07','08:25:00',3.33),('12374','2013-04-07','08:30:00',3.43),('12374','2013-04-07','08:35:00',3.63),('12374','2013-04-07','08:40:00',3.75),('12374','2013-04-07','08:45:00',3.76),('12374','2013-04-07','08:50:00',3.95),('12374','2013-04-07','08:55:00',4.03),('12374','2013-04-07','09:00:00',3.97),('12374','2013-04-07','09:05:00',4.08),('12374','2013-04-07','09:10:00',4.18),('12374','2013-04-07','09:15:00',4.45),('12374','2013-04-07','09:20:00',4.85),('12374','2013-04-07','09:25:00',5.08),('12374','2013-04-07','09:30:00',5.05),('12374','2013-04-07','09:35:00',5.21),('12374','2013-04-07','09:40:00',5.42),('12374','2013-04-07','09:45:00',5.55),('12374','2013-04-07','09:50:00',5.69),('12374','2013-04-07','09:55:00',5.81),('12374','2013-04-07','10:00:00',5.83),('12374','2013-04-07','10:05:00',5.99),('12374','2013-04-07','10:10:00',6.08),('12374','2013-04-07','10:15:00',6.41),('12374','2013-04-07','10:20:00',6.55),('12374','2013-04-07','10:25:00',6.63),('12374','2013-04-07','10:30:00',6.59),('12374','2013-04-07','10:35:00',6.4),('12374','2013-04-07','10:40:00',6.76),('12374','2013-04-07','10:45:00',7.21),('12374','2013-04-07','10:50:00',7.42),('12374','2013-04-07','10:55:00',7.59),('12374','2013-04-07','11:00:00',7.51),('12374','2013-04-07','11:05:00',7.58),('12374','2013-04-07','11:10:00',7.75),('12374','2013-04-07','11:15:00',7.65),('12374','2013-04-07','11:20:00',7.77),('12374','2013-04-07','11:25:00',7.77),('12374','2013-04-07','11:30:00',7.16),('12374','2013-04-07','11:35:00',7.38),('12374','2013-04-07','11:40:00',7.45),('12374','2013-04-07','11:45:00',6.4),('12374','2013-04-07','11:50:00',6.42),('12374','2013-04-07','11:55:00',6.34),('12374','2013-04-07','12:00:00',7.18),('12374','2013-04-07','12:05:00',8.11),('12374','2013-04-07','12:10:00',8),('12374','2013-04-07','12:15:00',7.5),('12374','2013-04-07','12:20:00',7.25),('12374','2013-04-07','12:25:00',7.13),('12374','2013-04-07','12:30:00',6.91),('12374','2013-04-07','12:35:00',6.93),('12374','2013-04-07','12:40:00',7.14),('12374','2013-04-07','12:45:00',6.36),('12374','2013-04-07','12:50:00',6.66),('12374','2013-04-07','12:55:00',6.74),('12374','2013-04-07','13:00:00',6.47),('12374','2013-04-07','13:05:00',6.12),('12374','2013-04-07','13:10:00',6.05),('12374','2013-04-07','13:15:00',5.77),('12374','2013-04-07','13:20:00',5.91),('12374','2013-04-07','13:25:00',6.18),('12374','2013-04-07','13:30:00',6.31),('12374','2013-04-07','13:35:00',6.44),('12374','2013-04-07','13:40:00',6.51),('12374','2013-04-07','13:45:00',6.51),('12374','2013-04-07','13:50:00',6.56),('12374','2013-04-07','13:55:00',6.54),('12374','2013-04-07','14:00:00',6.86),('12374','2013-04-07','14:05:00',6.99),('12374','2013-04-07','14:10:00',7.43),('12374','2013-04-07','14:15:00',6.88),('12374','2013-04-07','14:20:00',6.85),('12374','2013-04-07','14:25:00',6.41),('12374','2013-04-07','14:30:00',5.97),('12374','2013-04-07','14:35:00',5.58),('12374','2013-04-07','14:40:00',5.38),('12374','2013-04-07','14:45:00',5.43),('12374','2013-04-07','14:50:00',5.82),('12374','2013-04-07','14:55:00',6.19),('12374','2013-04-07','15:00:00',6.54),('12374','2013-04-07','15:05:00',6.92),('12374','2013-04-07','15:10:00',7.25),('12374','2013-04-07','15:15:00',7.36),('12374','2013-04-07','15:20:00',7.52),('12374','2013-04-07','15:25:00',7.62),('12374','2013-04-07','15:30:00',7.72),('12374','2013-04-07','15:35:00',7.76),('12374','2013-04-07','15:40:00',7.6),('12374','2013-04-07','15:45:00',7.54),('12374','2013-04-07','15:50:00',7.46),('12374','2013-04-07','15:55:00',7.29),('12374','2013-04-07','16:00:00',7.13),('12374','2013-04-07','16:05:00',6.96),('12374','2013-04-07','16:10:00',6.73),('12374','2013-04-07','16:15:00',6.56),('12374','2013-04-07','16:20:00',6.5),('12374','2013-04-07','16:25:00',6.36),('12374','2013-04-07','16:30:00',6.08),('12374','2013-04-07','16:35:00',5.9),('12374','2013-04-07','16:40:00',5.72),('12374','2013-04-07','16:45:00',5.53),('12374','2013-04-07','16:50:00',5.33),('12374','2013-04-07','16:55:00',5.13),('12374','2013-04-07','17:00:00',4.44),('12374','2013-04-07','17:05:00',2.13),('12374','2013-04-07','17:10:00',1.41),('12374','2013-04-07','17:15:00',1.03),('12374','2013-04-06','07:30:00',1.05),('12374','2013-04-06','07:35:00',1.41),('12374','2013-04-06','07:40:00',1.56),('12374','2013-04-06','07:45:00',1.4),('12374','2013-04-06','07:50:00',1.45),('12374','2013-04-06','07:55:00',1.49),('12374','2013-04-06','08:00:00',1.46),('12374','2013-04-06','08:05:00',1.6),('12374','2013-04-06','08:10:00',1.9),('12374','2013-04-06','08:15:00',2.42),('12374','2013-04-06','08:20:00',2.96),('12374','2013-04-06','08:25:00',3.31),('12374','2013-04-06','08:30:00',3.5),('12374','2013-04-06','08:35:00',3.68),('12374','2013-04-06','08:40:00',3.83),('12374','2013-04-06','08:45:00',4.01),('12374','2013-04-06','08:50:00',4.21),('12374','2013-04-06','08:55:00',4.35),('12374','2013-04-06','09:00:00',4.54),('12374','2013-04-06','09:05:00',4.75),('12374','2013-04-06','09:10:00',4.9),('12374','2013-04-06','09:15:00',5.06),('12374','2013-04-06','09:20:00',5.21),('12374','2013-04-06','09:25:00',5.36),('12374','2013-04-06','09:30:00',5.54),('12374','2013-04-06','09:35:00',5.8),('12374','2013-04-06','09:40:00',5.56),('12374','2013-04-06','09:45:00',6),('12374','2013-04-06','09:50:00',6.15),('12374','2013-04-06','09:55:00',6.27),('12374','2013-04-06','10:00:00',6.21),('12374','2013-04-06','10:05:00',1.24),('12374','2013-04-06','10:10:00',2.08),('12374','2013-04-06','10:15:00',7.25),('12374','2013-04-06','10:20:00',6.87),('12374','2013-04-06','10:25:00',7.25),('12374','2013-04-06','10:30:00',7.29),('12374','2013-04-06','10:35:00',7.42),('12374','2013-04-06','10:40:00',7.52),('12374','2013-04-06','10:45:00',6.45),('12374','2013-04-06','10:50:00',2.64),('12374','2013-04-06','10:55:00',7.88),('12374','2013-04-06','11:00:00',7.28),('12374','2013-04-06','11:05:00',6.38),('12374','2013-04-06','11:10:00',8.23),('12374','2013-04-06','11:15:00',8.14),('12374','2013-04-06','11:20:00',8.51),('12374','2013-04-06','11:25:00',8.63),('12374','2013-04-06','11:30:00',8.57),('12374','2013-04-06','11:35:00',8.6),('12374','2013-04-06','11:40:00',8.46),('12374','2013-04-06','11:45:00',8.62),('12374','2013-04-06','11:50:00',8.7),('12374','2013-04-06','11:55:00',8.74),('12374','2013-04-06','12:00:00',8.78),('12374','2013-04-06','12:05:00',8.87),('12374','2013-04-06','12:10:00',8.77),('12374','2013-04-06','12:15:00',8.96),('12374','2013-04-06','12:20:00',9),('12374','2013-04-06','12:25:00',9.03),('12374','2013-04-06','12:30:00',9.13),('12374','2013-04-06','12:35:00',9.17),('12374','2013-04-06','12:40:00',9.13),('12374','2013-04-06','12:45:00',9.22),('12374','2013-04-06','12:50:00',9.24),('12374','2013-04-06','12:55:00',9.2),('12374','2013-04-06','13:00:00',9.2),('12374','2013-04-06','13:05:00',9.28),('12374','2013-04-06','13:10:00',9.33),('12374','2013-04-06','13:15:00',9.29),('12374','2013-04-06','13:20:00',9.29),('12374','2013-04-06','13:25:00',9.3),('12374','2013-04-06','13:30:00',9.26),('12374','2013-04-06','13:35:00',9.23),('12374','2013-04-06','13:40:00',9.19),('12374','2013-04-06','13:45:00',9.16),('12374','2013-04-06','13:50:00',9.11),('12374','2013-04-06','13:55:00',9),('12374','2013-04-06','14:00:00',8.92),('12374','2013-04-06','14:05:00',8.89),('12374','2013-04-06','14:10:00',8.83),('12374','2013-04-06','14:15:00',8.74),('12374','2013-04-06','14:20:00',8.68),('12374','2013-04-06','14:25:00',8.56),('12374','2013-04-06','14:30:00',8.52),('12374','2013-04-06','14:35:00',8.48),('12374','2013-04-06','14:40:00',8.41),('12374','2013-04-06','14:45:00',8.32),('12374','2013-04-06','14:50:00',8.25),('12374','2013-04-06','14:55:00',8.11),('12374','2013-04-06','15:00:00',8.01),('12374','2013-04-06','15:05:00',7.9),('12374','2013-04-06','15:10:00',7.75),('12374','2013-04-06','15:15:00',7.58),('12374','2013-04-06','15:20:00',7.49),('12374','2013-04-06','15:25:00',7.52),('12374','2013-04-06','15:30:00',7.45),('12374','2013-04-06','15:35:00',7.16),('12374','2013-04-06','15:40:00',6.75),('12374','2013-04-06','15:45:00',6.66),('12374','2013-04-06','15:50:00',6.42),('12374','2013-04-06','15:55:00',6.22),('12374','2013-04-06','16:00:00',6.73),('12374','2013-04-06','16:05:00',6.63),('12374','2013-04-06','16:10:00',6.47),('12374','2013-04-06','16:15:00',6.04),('12374','2013-04-06','16:20:00',5.79),('12374','2013-04-06','16:25:00',5.97),('12374','2013-04-06','16:30:00',5.43),('12374','2013-04-06','16:35:00',4.67),('12374','2013-04-06','16:40:00',3.92),('12374','2013-04-06','16:45:00',3.11),('12374','2013-04-06','16:50:00',4.83),('12374','2013-04-06','16:55:00',5.33),('12374','2013-04-06','17:00:00',5.11),('12374','2013-04-06','17:05:00',4.86),('12374','2013-04-06','17:10:00',4.3),('12374','2013-04-06','17:15:00',3.88),('12374','2013-04-06','17:20:00',4.68),('12374','2013-04-06','17:25:00',4.34),('12374','2013-04-06','17:30:00',3.38),('12374','2013-04-06','17:35:00',3),('12374','2013-04-06','17:40:00',2.6),('12374','2013-04-06','17:45:00',2.12),('12374','2013-04-06','17:50:00',2.01),('12374','2013-04-06','17:55:00',1.92),('12374','2013-04-06','18:00:00',1.7),('12374','2013-04-06','18:05:00',1.49),('12374','2013-04-06','18:10:00',1.46),('12374','2013-04-06','18:15:00',1.31),('12374','2013-04-06','18:20:00',1.16),('12374','2013-04-06','18:25:00',1.04),('12374','2013-04-05','08:00:00',1.08),('12374','2013-04-05','08:05:00',1.63),('12374','2013-04-05','08:10:00',2.63),('12374','2013-04-05','08:15:00',1.88),('12374','2013-04-05','08:20:00',1.84),('12374','2013-04-05','08:25:00',3.81),('12374','2013-04-05','08:30:00',2.47),('12374','2013-04-05','08:35:00',2.05),('12374','2013-04-05','08:40:00',2.39),('12374','2013-04-05','08:45:00',4.91),('12374','2013-04-05','08:50:00',4.98),('12374','2013-04-05','08:55:00',4.29),('12374','2013-04-05','09:00:00',3.18),('12374','2013-04-05','09:05:00',5.13),('12374','2013-04-05','09:10:00',4.7),('12374','2013-04-05','09:15:00',4.51),('12374','2013-04-05','09:20:00',5.05),('12374','2013-04-05','09:25:00',5.41),('12374','2013-04-05','09:30:00',4.93),('12374','2013-04-05','09:35:00',5.28),('12374','2013-04-05','09:40:00',4.35),('12374','2013-04-05','09:45:00',3.32),('12374','2013-04-05','09:50:00',5.11),('12374','2013-04-05','09:55:00',5.44),('12374','2013-04-05','10:00:00',6.09),('12374','2013-04-05','10:05:00',6.69),('12374','2013-04-05','10:10:00',6.29),('12374','2013-04-05','10:15:00',6.86),('12374','2013-04-05','10:20:00',6.95),('12374','2013-04-05','10:25:00',7.07),('12374','2013-04-05','10:30:00',7.19),('12374','2013-04-05','10:35:00',7.3),('12374','2013-04-05','10:40:00',7.41),('12374','2013-04-05','10:45:00',7.54),('12374','2013-04-05','10:50:00',7.66),('12374','2013-04-05','10:55:00',7.78),('12374','2013-04-05','11:00:00',7.89),('12374','2013-04-05','11:05:00',8.03),('12374','2013-04-05','11:10:00',8.13),('12374','2013-04-05','11:15:00',8.21),('12374','2013-04-05','11:20:00',8.32),('12374','2013-04-05','11:25:00',7.85),('12374','2013-04-05','11:30:00',6.99),('12374','2013-04-05','11:35:00',8.51),('12374','2013-04-05','11:40:00',8.81),('12374','2013-04-05','11:45:00',9.1),('12374','2013-04-05','11:50:00',9),('12374','2013-04-05','11:55:00',8.89),('12374','2013-04-05','12:00:00',8.96),('12374','2013-04-05','12:05:00',9.06),('12374','2013-04-05','12:10:00',8.45),('12374','2013-04-05','12:15:00',6.74),('12374','2013-04-05','12:20:00',7.45),('12374','2013-04-05','12:25:00',9.38),('12374','2013-04-05','12:30:00',9.59),('12374','2013-04-05','12:35:00',9.3),('12374','2013-04-05','12:40:00',9.23),('12374','2013-04-05','12:45:00',9.54),('12374','2013-04-05','12:50:00',9.32),('12374','2013-04-05','12:55:00',9.29),('12374','2013-04-05','13:00:00',8.63),('12374','2013-04-05','13:05:00',9.13),('12374','2013-04-05','13:10:00',9.3),('12374','2013-04-05','13:15:00',9.34),('12374','2013-04-05','13:20:00',9.4),('12374','2013-04-05','13:25:00',9.21),('12374','2013-04-05','13:30:00',8.99),('12374','2013-04-05','13:35:00',6.49),('12374','2013-04-05','13:40:00',8.97),('12374','2013-04-05','13:45:00',4.53),('12374','2013-04-05','13:50:00',6.81),('12374','2013-04-05','13:55:00',4.48),('12374','2013-04-05','14:00:00',3.61),('12374','2013-04-05','14:05:00',3.79),('12374','2013-04-05','14:10:00',2.92),('12374','2013-04-05','14:15:00',2.78),('12374','2013-04-05','14:20:00',2.51),('12374','2013-04-05','14:25:00',2.15),('12374','2013-04-05','14:30:00',2.21),('12374','2013-04-05','14:35:00',2.47),('12374','2013-04-05','14:40:00',3.05),('12374','2013-04-05','14:45:00',2.65),('12374','2013-04-05','14:50:00',2.43),('12374','2013-04-05','14:55:00',3.65),('12374','2013-04-05','15:00:00',3.31),('12374','2013-04-05','15:05:00',3.34),('12374','2013-04-05','15:10:00',3.85),('12374','2013-04-05','15:15:00',2.73),('12374','2013-04-05','15:20:00',3.17),('12374','2013-04-05','15:25:00',3.43),('12374','2013-04-05','15:30:00',4.2),('12374','2013-04-05','15:35:00',2.68),('12374','2013-04-05','15:40:00',2.32),('12374','2013-04-05','15:45:00',2.41),('12374','2013-04-05','15:50:00',2.49),('12374','2013-04-05','15:55:00',5.46),('12374','2013-04-05','16:00:00',5.26),('12374','2013-04-05','16:05:00',6.41),('12374','2013-04-05','16:10:00',6.86),('12374','2013-04-05','16:15:00',6.58),('12374','2013-04-05','16:20:00',6.31),('12374','2013-04-05','16:25:00',6.01),('12374','2013-04-05','16:30:00',5.8),('12374','2013-04-05','16:35:00',5.67),('12374','2013-04-05','16:40:00',5.52),('12374','2013-04-05','16:45:00',5.34),('12374','2013-04-05','16:50:00',5.15),('12374','2013-04-05','16:55:00',5),('12374','2013-04-05','17:00:00',3.09),('12374','2013-04-05','17:05:00',4.08),('12374','2013-04-05','17:10:00',3.63),('12374','2013-04-05','17:15:00',4.34),('12374','2013-04-05','17:20:00',4.11),('12374','2013-04-05','17:25:00',3.9),('12374','2013-04-05','17:30:00',3.68),('12374','2013-04-05','17:35:00',3.53),('12374','2013-04-05','17:40:00',3.38),('12374','2013-04-05','17:45:00',3.19),('12374','2013-04-05','17:50:00',3.03),('12374','2013-04-05','17:55:00',2.8),('12374','2013-04-05','18:00:00',2.44),('12374','2013-04-05','18:05:00',2.25),('12374','2013-04-05','18:10:00',2.03),('12374','2013-04-05','18:15:00',1.87),('12374','2013-04-05','18:20:00',1.68),('12374','2013-04-05','18:25:00',1.49),('12374','2013-04-05','18:30:00',1.33),('12374','2013-04-05','18:35:00',1.21),('12374','2013-04-05','18:40:00',1.12),('12374','2013-04-05','18:45:00',1.01),('12374','2013-04-04','08:10:00',1.08),('12374','2013-04-04','08:15:00',1.18),('12374','2013-04-04','08:20:00',1.4),('12374','2013-04-04','08:25:00',1.61),('12374','2013-04-04','08:30:00',1.47),('12374','2013-04-04','08:35:00',1.84),('12374','2013-04-04','08:40:00',2.25),('12374','2013-04-04','08:45:00',2.12),('12374','2013-04-04','08:50:00',1.48),('12374','2013-04-04','08:55:00',1.62),('12374','2013-04-04','09:00:00',1.72),('12374','2013-04-04','09:05:00',2.03),('12374','2013-04-04','09:10:00',1.74),('12374','2013-04-04','09:15:00',1.52),('12374','2013-04-04','09:20:00',1.38),('12374','2013-04-04','09:30:00',1.03),('12374','2013-04-04','09:35:00',1.32),('12374','2013-04-04','09:40:00',2.14),('12374','2013-04-04','09:45:00',1.99),('12374','2013-04-04','09:50:00',2.11),('12374','2013-04-04','09:55:00',2.31),('12374','2013-04-04','10:00:00',2.18),('12374','2013-04-04','10:05:00',2.75),('12374','2013-04-04','10:10:00',5.04),('12374','2013-04-04','10:15:00',4.6),('12374','2013-04-04','10:20:00',4.31),('12374','2013-04-04','10:25:00',3.01),('12374','2013-04-04','10:30:00',2.81),('12374','2013-04-04','10:35:00',3.61),('12374','2013-04-04','10:40:00',4.36),('12374','2013-04-04','10:45:00',4.69),('12374','2013-04-04','10:50:00',3.76),('12374','2013-04-04','10:55:00',2.82),('12374','2013-04-04','11:00:00',2),('12374','2013-04-04','11:05:00',1.97),('12374','2013-04-04','11:10:00',1.77),('12374','2013-04-04','11:15:00',1.5),('12374','2013-04-04','11:20:00',1.81),('12374','2013-04-04','11:25:00',2.42),('12374','2013-04-04','11:30:00',3.59),('12374','2013-04-04','11:35:00',3.7),('12374','2013-04-04','11:40:00',3.71),('12374','2013-04-04','11:45:00',3.86),('12374','2013-04-04','11:50:00',4.75),('12374','2013-04-04','11:55:00',5.56),('12374','2013-04-04','12:00:00',7.56),('12374','2013-04-04','12:05:00',7.98),('12374','2013-04-04','12:10:00',7.61),('12374','2013-04-04','12:15:00',6.69),('12374','2013-04-04','12:20:00',6.02),('12374','2013-04-04','12:25:00',7.64),('12374','2013-04-04','12:30:00',7.7),('12374','2013-04-04','12:35:00',3.68),('12374','2013-04-04','12:40:00',3.94),('12374','2013-04-04','12:45:00',6.53),('12374','2013-04-04','12:50:00',6.15),('12374','2013-04-04','12:55:00',4.18),('12374','2013-04-04','13:00:00',4.88),('12374','2013-04-04','13:05:00',6.61),('12374','2013-04-04','13:10:00',5.41),('12374','2013-04-04','13:15:00',3.71),('12374','2013-04-04','13:20:00',4.32),('12374','2013-04-04','13:25:00',4.76),('12374','2013-04-04','13:30:00',4.18),('12374','2013-04-04','13:35:00',3.41),('12374','2013-04-04','13:40:00',5.09),('12374','2013-04-04','13:45:00',3.66),('12374','2013-04-04','13:50:00',3.16),('12374','2013-04-04','13:55:00',5.04),('12374','2013-04-04','14:00:00',5.71),('12374','2013-04-04','14:05:00',8.21),('12374','2013-04-04','14:10:00',8.04),('12374','2013-04-04','14:15:00',7.07),('12374','2013-04-04','14:20:00',7.16),('12374','2013-04-04','14:25:00',8.35),('12374','2013-04-04','14:30:00',7.89),('12374','2013-04-04','14:35:00',7.34),('12374','2013-04-04','14:40:00',4.63),('12374','2013-04-04','14:45:00',6.18),('12374','2013-04-04','14:50:00',7.14),('12374','2013-04-04','14:55:00',3.59),('12374','2013-04-04','15:00:00',6.84),('12374','2013-04-04','15:05:00',8.05),('12374','2013-04-04','15:10:00',8.19),('12374','2013-04-04','15:15:00',8.05),('12374','2013-04-04','15:20:00',6.94),('12374','2013-04-04','15:25:00',6.94),('12374','2013-04-04','15:30:00',6.4),('12374','2013-04-04','15:35:00',6.75),('12374','2013-04-04','15:40:00',6.67),('12374','2013-04-04','15:45:00',6.43),('12374','2013-04-04','15:50:00',6.29),('12374','2013-04-04','15:55:00',5.69),('12374','2013-04-04','16:00:00',5),('12374','2013-04-04','16:05:00',5.39),('12374','2013-04-04','16:10:00',4.86),('12374','2013-04-04','16:15:00',4.35),('12374','2013-04-04','16:20:00',3.68),('12374','2013-04-04','16:25:00',3.86),('12374','2013-04-04','16:30:00',4.8),('12374','2013-04-04','16:35:00',3.22),('12374','2013-04-04','16:40:00',3.27),('12374','2013-04-04','16:45:00',3.88),('12374','2013-04-04','16:50:00',3.26),('12374','2013-04-04','16:55:00',3.28),('12374','2013-04-04','17:00:00',3.4),('12374','2013-04-04','17:05:00',3.28),('12374','2013-04-04','17:10:00',2.61),('12374','2013-04-04','17:15:00',2.71),('12374','2013-04-04','17:20:00',2.66),('12374','2013-04-04','17:25:00',2.42),('12374','2013-04-04','17:30:00',2.67),('12374','2013-04-04','17:35:00',2.5),('12374','2013-04-04','17:40:00',2.08),('12374','2013-04-04','17:45:00',1.92),('12374','2013-04-04','17:50:00',2.39),('12374','2013-04-04','17:55:00',1.65),('12374','2013-04-04','18:00:00',1.48),('12374','2013-04-04','18:05:00',1.28),('12374','2013-04-03','07:35:00',1.07),('12374','2013-04-03','07:41:00',1.69),('12374','2013-04-03','07:45:00',1.9),('12374','2013-04-03','07:50:00',1.94),('12374','2013-04-03','07:55:00',1.96),('12374','2013-04-03','08:00:00',1.98),('12374','2013-04-03','08:05:00',1.23),('12374','2013-04-03','08:15:00',1.68),('12374','2013-04-03','08:20:00',2.18),('12374','2013-04-03','08:25:00',3.25),('12374','2013-04-03','08:30:00',3.59),('12374','2013-04-03','08:35:00',3.78),('12374','2013-04-03','08:40:00',4.17),('12374','2013-04-03','08:45:00',4.73),('12374','2013-04-03','08:50:00',4.88),('12374','2013-04-03','08:55:00',4.53),('12374','2013-04-03','09:00:00',3.73),('12374','2013-04-03','09:05:00',3.84),('12374','2013-04-03','09:10:00',5.44),('12374','2013-04-03','09:15:00',5.03),('12374','2013-04-03','09:20:00',5.44),('12374','2013-04-03','09:25:00',5.92),('12374','2013-04-03','09:30:00',6.18),('12374','2013-04-03','09:35:00',5.16),('12374','2013-04-03','09:40:00',2.47),('12374','2013-04-03','09:45:00',4.27),('12374','2013-04-03','09:50:00',3.94),('12374','2013-04-03','09:55:00',5.79),('12374','2013-04-03','10:00:00',3.79),('12374','2013-04-03','10:05:00',3.75),('12374','2013-04-03','10:10:00',3.58),('12374','2013-04-03','10:15:00',4.57),('12374','2013-04-03','10:20:00',4.73),('12374','2013-04-03','10:25:00',8.03),('12374','2013-04-03','10:30:00',7.05),('12374','2013-04-03','10:35:00',6.52),('12374','2013-04-03','10:40:00',6.38),('12374','2013-04-03','10:45:00',4.86),('12374','2013-04-03','10:50:00',7.14),('12374','2013-04-03','10:55:00',8.01),('12374','2013-04-03','11:00:00',8.19),('12374','2013-04-03','11:05:00',8.32),('12374','2013-04-03','11:10:00',8.42),('12374','2013-04-03','11:15:00',8.33),('12374','2013-04-03','11:20:00',8.34),('12374','2013-04-03','11:25:00',8.43),('12374','2013-04-03','11:30:00',8.35),('12374','2013-04-03','11:35:00',8.66),('12374','2013-04-03','11:40:00',6.17),('12374','2013-04-03','11:45:00',6.22),('12374','2013-04-03','11:50:00',9.33),('12374','2013-04-03','11:55:00',9.17),('12374','2013-04-03','12:00:00',8.86),('12374','2013-04-03','12:05:00',4.57),('12374','2013-04-03','12:10:00',8.72),('12374','2013-04-03','12:15:00',9.51),('12374','2013-04-03','12:20:00',9.5),('12374','2013-04-03','12:25:00',9.14),('12374','2013-04-03','12:30:00',6.09),('12374','2013-04-03','12:35:00',7.08),('12374','2013-04-03','12:40:00',6.29),('12374','2013-04-03','12:45:00',5.1),('12374','2013-04-03','12:50:00',7.04),('12374','2013-04-03','12:55:00',9.59),('12374','2013-04-03','13:00:00',9.86),('12374','2013-04-03','13:05:00',9.94),('12374','2013-04-03','13:10:00',9.9),('12374','2013-04-03','13:15:00',9.89),('12374','2013-04-03','13:20:00',9.66),('12374','2013-04-03','13:25:00',9.64),('12374','2013-04-03','13:30:00',9.53),('12374','2013-04-03','13:35:00',9.56),('12374','2013-04-03','13:40:00',8.9),('12374','2013-04-03','13:45:00',9.61),('12374','2013-04-03','13:50:00',9.86),('12374','2013-04-03','13:55:00',9.65),('12374','2013-04-03','14:00:00',9.72),('12374','2013-04-03','14:05:00',9.17),('12374','2013-04-03','14:10:00',6.98),('12374','2013-04-03','14:15:00',5.43),('12374','2013-04-03','14:20:00',5.73),('12374','2013-04-03','14:25:00',6.55),('12374','2013-04-03','14:30:00',8.16),('12374','2013-04-03','14:35:00',9.19),('12374','2013-04-03','14:40:00',9.33),('12374','2013-04-03','14:45:00',9.01),('12374','2013-04-03','14:50:00',7.77),('12374','2013-04-03','14:55:00',6.7),('12374','2013-04-03','15:00:00',8.34),('12374','2013-04-03','15:05:00',8.18),('12374','2013-04-03','15:10:00',8.08),('12374','2013-04-03','15:15:00',7.95),('12374','2013-04-03','15:20:00',7.86),('12374','2013-04-03','15:25:00',7.8),('12374','2013-04-03','15:30:00',3.42),('12374','2013-04-03','15:35:00',8.29),('12374','2013-04-03','15:40:00',7.92),('12374','2013-04-03','15:45:00',8.4),('12374','2013-04-03','15:50:00',7.74),('12374','2013-04-03','15:55:00',7.02),('12374','2013-04-03','16:00:00',6.82),('12374','2013-04-03','16:05:00',6.68),('12374','2013-04-03','16:10:00',6.69),('12374','2013-04-03','16:15:00',6.39),('12374','2013-04-03','16:20:00',6.12),('12374','2013-04-03','16:25:00',5.97),('12374','2013-04-03','16:30:00',5.84),('12374','2013-04-03','16:35:00',5.73),('12374','2013-04-03','16:40:00',5.56),('12374','2013-04-03','16:45:00',5.34),('12374','2013-04-03','16:50:00',5.18),('12374','2013-04-03','16:55:00',5.07),('12374','2013-04-03','17:00:00',4.91),('12374','2013-04-03','17:05:00',4.81),('12374','2013-04-03','17:10:00',4.68),('12374','2013-04-03','17:15:00',4.49),('12374','2013-04-03','17:20:00',4.26),('12374','2013-04-03','17:25:00',4),('12374','2013-04-03','17:30:00',3.76),('12374','2013-04-03','17:35:00',3.62),('12374','2013-04-03','17:40:00',3.44),('12374','2013-04-03','17:45:00',3.2),('12374','2013-04-03','17:50:00',3.03),('12374','2013-04-03','17:55:00',2.68),('12374','2013-04-03','18:00:00',2.39),('12374','2013-04-03','18:05:00',2.2),('12374','2013-04-03','18:10:00',2.04),('12374','2013-04-03','18:15:00',1.84),('12374','2013-04-03','18:20:00',1.63),('12374','2013-04-03','18:25:00',1.43),('12374','2013-04-03','18:30:00',1.27),('12374','2013-04-03','18:35:00',1.2),('12374','2013-04-03','18:40:00',1.15),('12374','2013-04-03','18:45:00',1.09),('12374','2013-04-02','08:20:00',2.03),('12374','2013-04-02','08:25:00',1.91),('12374','2013-04-02','08:30:00',1.15),('12374','2013-04-02','08:45:00',1.32),('12374','2013-04-02','08:50:00',4.26),('12374','2013-04-02','08:55:00',4.03),('12374','2013-04-02','09:00:00',2.83),('12374','2013-04-02','09:05:00',4.37),('12374','2013-04-02','09:10:00',5.63),('12374','2013-04-02','09:15:00',5.03),('12374','2013-04-02','09:20:00',5.3),('12374','2013-04-02','09:25:00',5.3),('12374','2013-04-02','09:30:00',5.32),('12374','2013-04-02','09:35:00',5.68),('12374','2013-04-02','09:40:00',6.08),('12374','2013-04-02','09:45:00',6.01),('12374','2013-04-02','09:50:00',5.71),('12374','2013-04-02','09:55:00',6.22),('12374','2013-04-02','10:00:00',5.73),('12374','2013-04-02','10:05:00',6.62),('12374','2013-04-02','10:10:00',6.71),('12374','2013-04-02','10:15:00',6.68),('12374','2013-04-02','10:20:00',5.57),('12374','2013-04-02','10:25:00',7.28),('12374','2013-04-02','10:30:00',6.88),('12374','2013-04-02','10:35:00',7.25),('12374','2013-04-02','10:40:00',7.67),('12374','2013-04-02','10:45:00',7.97),('12374','2013-04-02','10:50:00',7.66),('12374','2013-04-02','10:55:00',7.88),('12374','2013-04-02','11:00:00',8.06),('12374','2013-04-02','11:05:00',2.53),('12374','2013-04-02','11:10:00',3.84),('12374','2013-04-02','11:15:00',9.87),('12374','2013-04-02','11:20:00',9.09),('12374','2013-04-02','11:25:00',3.34),('12374','2013-04-02','11:30:00',1.41),('12374','2013-04-02','11:35:00',1.06),('12374','2013-04-02','11:40:00',2.47),('12374','2013-04-02','11:45:00',7.07),('12374','2013-04-02','11:50:00',5.5),('12374','2013-04-02','11:55:00',9.18),('12374','2013-04-02','12:00:00',4.2),('12374','2013-04-02','12:05:00',2.45),('12374','2013-04-02','12:10:00',3.02),('12374','2013-04-02','12:15:00',1.61),('12374','2013-04-02','12:20:00',1.53),('12374','2013-04-02','12:25:00',5.53),('12374','2013-04-02','12:30:00',2.45),('12374','2013-04-02','12:35:00',5.56),('12374','2013-04-02','12:40:00',4.77),('12374','2013-04-02','12:45:00',5.65),('12374','2013-04-02','12:50:00',3.83),('12374','2013-04-02','12:55:00',4.76),('12374','2013-04-02','13:00:00',5.21),('12374','2013-04-02','13:05:00',3.96),('12374','2013-04-02','13:10:00',2.61),('12374','2013-04-02','13:15:00',2.68),('12374','2013-04-02','13:20:00',3.06),('12374','2013-04-02','13:25:00',2.68),('12374','2013-04-02','13:30:00',4.33),('12374','2013-04-02','13:35:00',5.07),('12374','2013-04-02','13:40:00',4.49),('12374','2013-04-02','13:45:00',8.85),('12374','2013-04-02','13:50:00',7.32),('12374','2013-04-02','13:55:00',9.74),('12374','2013-04-02','14:00:00',9.06),('12374','2013-04-02','14:05:00',6.2),('12374','2013-04-02','14:10:00',4.49),('12374','2013-04-02','14:15:00',1.37),('12374','2013-04-02','14:20:00',4.2),('12374','2013-04-02','14:25:00',9.15),('12374','2013-04-02','14:30:00',5.99),('12374','2013-04-02','14:35:00',3.78),('12374','2013-04-02','14:40:00',2.37),('12374','2013-04-02','14:45:00',1.42),('12374','2013-04-02','14:50:00',1.09),('12374','2013-04-02','14:55:00',1.84),('12374','2013-04-02','15:00:00',3.32),('12374','2013-04-02','15:05:00',3.07),('12374','2013-04-02','15:10:00',2.31),('12374','2013-04-02','15:15:00',2.29),('12374','2013-04-02','15:20:00',1.92),('12374','2013-04-02','15:25:00',1.15),('12374','2013-04-02','16:00:00',1.16),('12374','2013-04-02','16:05:00',1.07),('12374','2013-04-02','16:10:00',1.3),('12374','2013-04-02','16:15:00',1.41),('12374','2013-04-02','16:20:00',1.64),('12374','2013-04-02','16:25:00',2.35),('12374','2013-04-02','16:30:00',2.59),('12374','2013-04-02','16:35:00',2.23),('12374','2013-04-02','16:40:00',1.88),('12374','2013-04-02','16:45:00',1.27),('12374','2013-04-01','07:35:00',1.2),('12374','2013-04-01','07:41:00',1.31),('12374','2013-04-01','07:45:00',1.61),('12374','2013-04-01','07:50:00',1.68),('12374','2013-04-01','07:55:00',1.81),('12374','2013-04-01','08:00:00',1.54),('12374','2013-04-01','08:05:00',1.95),('12374','2013-04-01','08:10:00',2.39),('12374','2013-04-01','08:15:00',2.44),('12374','2013-04-01','08:20:00',2.45),('12374','2013-04-01','08:25:00',1.64),('12374','2013-04-01','08:30:00',4.14),('12374','2013-04-01','08:35:00',3.18),('12374','2013-04-01','08:40:00',1.09),('12374','2013-04-01','08:45:00',1.19),('12374','2013-04-01','08:50:00',1.42),('12374','2013-04-01','08:55:00',1.7),('12374','2013-04-01','09:00:00',2.13),('12374','2013-04-01','09:05:00',3.56),('12374','2013-04-01','09:10:00',1.71),('12374','2013-04-01','09:15:00',1.65),('12374','2013-04-01','09:20:00',2.1),('12374','2013-04-01','09:25:00',2.38),('12374','2013-04-01','09:30:00',4.5),('12374','2013-04-01','09:35:00',3.62),('12374','2013-04-01','09:40:00',3.08),('12374','2013-04-01','09:47:00',2.97),('12374','2013-04-01','09:50:00',5.62),('12374','2013-04-01','09:55:00',5.92),('12374','2013-04-01','10:00:00',6.85),('12374','2013-04-01','10:05:00',5.83),('12374','2013-04-01','10:10:00',4.18),('12374','2013-04-01','10:15:00',6.68),('12374','2013-04-01','10:20:00',5.18),('12374','2013-04-01','10:25:00',5.32),('12374','2013-04-01','10:30:00',5.65),('12374','2013-04-01','10:35:00',6.15),('12374','2013-04-01','10:40:00',5.34),('12374','2013-04-01','10:45:00',6.08),('12374','2013-04-01','10:50:00',6.27),('12374','2013-04-01','10:55:00',6.07),('12374','2013-04-01','11:00:00',6.85),('12374','2013-04-01','11:05:00',6.09),('12374','2013-04-01','11:10:00',5.24),('12374','2013-04-01','11:15:00',4.57),('12374','2013-04-01','11:20:00',5.1),('12374','2013-04-01','11:25:00',4.51),('12374','2013-04-01','11:30:00',5.22),('12374','2013-04-01','11:35:00',6.26),('12374','2013-04-01','11:40:00',5.83),('12374','2013-04-01','11:45:00',7.87),('12374','2013-04-01','11:50:00',6.68),('12374','2013-04-01','11:55:00',6.98),('12374','2013-04-01','12:00:00',5.06),('12374','2013-04-01','12:05:00',4.18),('12374','2013-04-01','12:10:00',4.77),('12374','2013-04-01','12:15:00',6.17),('12374','2013-04-01','12:20:00',6.95),('12374','2013-04-01','12:25:00',4.94),('12374','2013-04-01','12:30:00',4.26),('12374','2013-04-01','12:35:00',3.98),('12374','2013-04-01','12:40:00',4.33),('12374','2013-04-01','12:45:00',4.86),('12374','2013-04-01','12:50:00',5.02),('12374','2013-04-01','12:55:00',5.45),('12374','2013-04-01','13:00:00',5.53),('12374','2013-04-01','13:05:00',4.78),('12374','2013-04-01','13:10:00',6.72),('12374','2013-04-01','13:15:00',6.42),('12374','2013-04-01','13:20:00',5.87),('12374','2013-04-01','13:25:00',4.75),('12374','2013-04-01','13:30:00',4.4),('12374','2013-04-01','13:35:00',4.28),('12374','2013-04-01','13:40:00',4.76),('12374','2013-04-01','13:45:00',4.28),('12374','2013-04-01','13:50:00',3.6),('12374','2013-04-01','13:55:00',4.08),('12374','2013-04-01','14:00:00',6.49),('12374','2013-04-01','14:05:00',6.79),('12374','2013-04-01','14:10:00',6.55),('12374','2013-04-01','14:15:00',4.23),('12374','2013-04-01','14:20:00',4.66),('12374','2013-04-01','14:25:00',5.25),('12374','2013-04-01','14:30:00',4.29),('12374','2013-04-01','14:35:00',3.47),('12374','2013-04-01','14:40:00',3.11),('12374','2013-04-01','14:45:00',3.9),('12374','2013-04-01','14:50:00',4.55),('12374','2013-04-01','14:55:00',4.21),('12374','2013-04-01','15:00:00',3.97),('12374','2013-04-01','15:05:00',3.46),('12374','2013-04-01','15:10:00',2.85),('12374','2013-04-01','15:15:00',2.39),('12374','2013-04-01','15:20:00',2.92),('12374','2013-04-01','15:25:00',3.67),('12374','2013-04-01','15:30:00',3.18),('12374','2013-04-01','15:35:00',2.58),('12374','2013-04-01','15:40:00',2.46),('12374','2013-04-01','15:45:00',2.71),('12374','2013-04-01','15:50:00',3.55),('12374','2013-04-01','15:55:00',4.57),('12374','2013-04-01','16:00:00',3.95),('12374','2013-04-01','16:05:00',3.75),('12374','2013-04-01','16:10:00',2.73),('12374','2013-04-01','16:15:00',2.1),('12374','2013-04-01','16:20:00',1.74),('12374','2013-04-01','16:25:00',1.66),('12374','2013-04-01','16:30:00',1.8),('12374','2013-04-01','16:35:00',1.6),('12374','2013-04-01','16:40:00',1.37),('12374','2013-04-01','16:45:00',1.01),('12374','2013-03-31','08:40:00',1.2),('12374','2013-03-31','08:45:00',1.83),('12374','2013-03-31','09:00:00',1.32),('12374','2013-03-31','09:05:00',1.95),('12374','2013-03-31','09:10:00',2.69),('12374','2013-03-31','09:15:00',2.25),('12374','2013-03-31','09:20:00',3.12),('12374','2013-03-31','09:25:00',2.35),('12374','2013-03-31','09:30:00',1.6),('12374','2013-03-31','09:35:00',2.45),('12374','2013-03-31','09:40:00',2.89),('12374','2013-03-31','09:45:00',2.14),('12374','2013-03-31','09:50:00',2.11),('12374','2013-03-31','09:55:00',2.04),('12374','2013-03-31','10:00:00',3.88),('12374','2013-03-31','10:05:00',3.44),('12374','2013-03-31','10:10:00',2.77),('12374','2013-03-31','10:15:00',2.09),('12374','2013-03-31','10:20:00',1.44);
INSERT INTO `solarlog` VALUES ('12374','2013-03-31','10:25:00',1.19),('12374','2013-03-31','10:30:00',1.92),('12374','2013-03-31','10:35:00',2.22),('12374','2013-03-31','10:40:00',1.8),('12374','2013-03-31','10:45:00',1.84),('12374','2013-03-31','10:50:00',1.47),('12374','2013-03-31','10:55:00',1.56),('12374','2013-03-31','11:00:00',1.48),('12374','2013-03-31','11:05:00',1.58),('12374','2013-03-31','11:10:00',2.67),('12374','2013-03-31','11:15:00',2.65),('12374','2013-03-31','11:20:00',3.11),('12374','2013-03-31','11:25:00',2.22),('12374','2013-03-31','11:30:00',1.85),('12374','2013-03-31','11:35:00',2.2),('12374','2013-03-31','11:40:00',2.51),('12374','2013-03-31','11:45:00',2.22),('12374','2013-03-31','11:50:00',2.66),('12374','2013-03-31','11:55:00',1.87),('12374','2013-03-31','12:00:00',1.76),('12374','2013-03-31','12:05:00',1.83),('12374','2013-03-31','12:10:00',2.07),('12374','2013-03-31','12:15:00',2.17),('12374','2013-03-31','12:20:00',1.93),('12374','2013-03-31','12:25:00',2.8),('12374','2013-03-31','12:30:00',2.15),('12374','2013-03-31','12:35:00',1.78),('12374','2013-03-31','12:40:00',2.46),('12374','2013-03-31','12:45:00',3.32),('12374','2013-03-31','12:50:00',3.46),('12374','2013-03-31','12:55:00',4.45),('12374','2013-03-31','13:00:00',4.83),('12374','2013-03-31','13:05:00',4.7),('12374','2013-03-31','13:10:00',6.69),('12374','2013-03-31','13:15:00',9.9),('12374','2013-03-31','13:20:00',9.13),('12374','2013-03-31','13:25:00',8.76),('12374','2013-03-31','13:30:00',9.68),('12374','2013-03-31','13:35:00',8.49),('12374','2013-03-31','13:40:00',7.19),('12374','2013-03-31','13:45:00',6.24),('12374','2013-03-31','13:50:00',7.37),('12374','2013-03-31','13:55:00',7.7),('12374','2013-03-31','14:00:00',9.72),('12374','2013-03-31','14:05:00',9.7),('12374','2013-03-31','14:10:00',7.82),('12374','2013-03-31','14:15:00',6.86),('12374','2013-03-31','14:20:00',7.93),('12374','2013-03-31','14:25:00',6.99),('12374','2013-03-31','14:30:00',4.54),('12374','2013-03-31','14:35:00',4.23),('12374','2013-03-31','14:40:00',4.27),('12374','2013-03-31','14:45:00',2.59),('12374','2013-03-31','14:50:00',3.55),('12374','2013-03-31','14:55:00',7.6),('12374','2013-03-31','15:00:00',8.37),('12374','2013-03-31','15:05:00',5.51),('12374','2013-03-31','15:10:00',8.61),('12374','2013-03-31','15:15:00',8.59),('12374','2013-03-31','15:20:00',7.93),('12374','2013-03-31','15:25:00',8.27),('12374','2013-03-31','15:30:00',5),('12374','2013-03-31','15:35:00',5.4),('12374','2013-03-31','15:40:00',4.23),('12374','2013-03-31','15:45:00',4.17),('12374','2013-03-31','15:50:00',3.64),('12374','2013-03-31','15:55:00',3.94),('12374','2013-03-31','16:00:00',2.92),('12374','2013-03-31','16:05:00',2.19),('12374','2013-03-31','16:10:00',2.55),('12374','2013-03-31','16:15:00',3.17),('12374','2013-03-31','16:20:00',3.29),('12374','2013-03-31','16:25:00',1.81),('12374','2013-03-31','16:40:00',1.59),('12374','2013-03-31','16:45:00',1.61),('12374','2013-03-31','17:15:00',1.45),('12374','2013-03-31','17:20:00',3.63),('12374','2013-03-31','17:25:00',5.93),('12374','2013-03-31','17:30:00',3.62),('12374','2013-03-31','17:35:00',2.72),('12374','2013-03-31','17:40:00',2.96),('12374','2013-03-31','17:45:00',3.79),('12374','2013-03-31','17:50:00',3.18),('12374','2013-03-31','17:55:00',2.42),('12374','2013-03-31','18:00:00',1.27),('12374','2013-03-31','18:05:00',2.05),('12374','2013-03-31','18:10:00',2.34),('12374','2013-03-31','18:15:00',1.63),('12374','2013-03-30','09:10:00',1.31),('12374','2013-03-30','09:15:00',1.41),('12374','2013-03-30','09:20:00',1.47),('12374','2013-03-30','09:25:00',1.26),('12374','2013-03-30','09:30:00',1.37),('12374','2013-03-30','09:35:00',1.29),('12374','2013-03-30','09:40:00',1.95),('12374','2013-03-30','09:45:00',1.27),('12374','2013-03-30','09:50:00',1.5),('12374','2013-03-30','09:55:00',1.31),('12374','2013-03-30','10:00:00',2.01),('12374','2013-03-30','10:05:00',1.91),('12374','2013-03-30','10:10:00',2.65),('12374','2013-03-30','10:15:00',4.28),('12374','2013-03-30','10:20:00',4.01),('12374','2013-03-30','10:25:00',5.16),('12374','2013-03-30','10:30:00',5.01),('12374','2013-03-30','10:35:00',4.75),('12374','2013-03-30','10:40:00',4.08),('12374','2013-03-30','10:45:00',3.04),('12374','2013-03-30','10:50:00',2.38),('12374','2013-03-30','10:55:00',2.01),('12374','2013-03-30','11:00:00',1.8),('12374','2013-03-30','11:05:00',1.95),('12374','2013-03-30','11:10:00',1.87),('12374','2013-03-30','11:15:00',1.75),('12374','2013-03-30','11:20:00',1.69),('12374','2013-03-30','11:25:00',1.68),('12374','2013-03-30','11:30:00',1.54),('12374','2013-03-30','11:35:00',2.05),('12374','2013-03-30','11:40:00',2.04),('12374','2013-03-30','11:45:00',2.07),('12374','2013-03-30','11:50:00',1.81),('12374','2013-03-30','11:55:00',1.92),('12374','2013-03-30','12:00:00',1.61),('12374','2013-03-30','12:05:00',1.21),('12374','2013-03-30','12:10:00',1.69),('12374','2013-03-30','12:15:00',1.61),('12374','2013-03-30','12:20:00',1.09),('12374','2013-03-30','12:50:00',1.02),('12374','2013-03-30','12:55:00',1.52),('12374','2013-03-30','13:00:00',1.81),('12374','2013-03-30','13:05:00',2.27),('12374','2013-03-30','13:10:00',1.94),('12374','2013-03-30','13:15:00',2),('12374','2013-03-30','13:20:00',1.56),('12374','2013-03-30','13:25:00',1.31),('12374','2013-03-30','13:35:00',1.19),('12374','2013-03-30','13:40:00',1.39),('12374','2013-03-30','13:45:00',1.71),('12374','2013-03-30','13:50:00',2.39),('12374','2013-03-30','13:55:00',4.04),('12374','2013-03-30','14:00:00',4.3),('12374','2013-03-30','14:05:00',4.98),('12374','2013-03-30','14:10:00',4.79),('12374','2013-03-30','14:15:00',5.11),('12374','2013-03-30','14:20:00',4.79),('12374','2013-03-30','14:25:00',4.64),('12374','2013-03-30','14:30:00',4.89),('12374','2013-03-30','14:35:00',4.89),('12374','2013-03-30','14:40:00',3.09),('12374','2013-03-30','14:45:00',2.44),('12374','2013-03-30','14:50:00',2.06),('12374','2013-03-30','14:55:00',1.4),('12374','2013-03-30','15:00:00',1.56),('12374','2013-03-30','15:05:00',1.23),('12374','2013-03-29','06:55:00',1.25),('12374','2013-03-29','07:00:00',1.94),('12374','2013-03-29','07:05:00',1.57),('12374','2013-03-29','07:10:00',1.69),('12374','2013-03-29','07:20:00',1.59),('12374','2013-03-29','07:25:00',1.2),('12374','2013-03-29','07:30:00',1.28),('12374','2013-03-29','07:55:00',1.28),('12374','2013-03-29','08:00:00',2.01),('12374','2013-03-29','08:05:00',2.35),('12374','2013-03-29','08:10:00',2.56),('12374','2013-03-29','08:15:00',3.28),('12374','2013-03-29','08:20:00',3.19),('12374','2013-03-29','08:25:00',2.9),('12374','2013-03-29','08:30:00',2.56),('12374','2013-03-29','08:35:00',3.92),('12374','2013-03-29','08:40:00',5.86),('12374','2013-03-29','08:45:00',5.84),('12374','2013-03-29','08:50:00',6.03),('12374','2013-03-29','08:55:00',4.48),('12374','2013-03-29','09:00:00',5.09),('12374','2013-03-29','09:05:00',6.42),('12374','2013-03-29','09:10:00',6.03),('12374','2013-03-29','09:15:00',6.4),('12374','2013-03-29','09:20:00',5.75),('12374','2013-03-29','09:25:00',6.87),('12374','2013-03-29','09:30:00',6.93),('12374','2013-03-29','09:35:00',5.5),('12374','2013-03-29','09:40:00',6.1),('12374','2013-03-29','09:45:00',7.22),('12374','2013-03-29','09:50:00',5.27),('12374','2013-03-29','09:55:00',3.47),('12374','2013-03-29','10:00:00',4.01),('12374','2013-03-29','10:05:00',2.99),('12374','2013-03-29','10:10:00',7.15),('12374','2013-03-29','10:15:00',7.11),('12374','2013-03-29','10:20:00',7.31),('12374','2013-03-29','10:25:00',7.63),('12374','2013-03-29','10:30:00',7.54),('12374','2013-03-29','10:35:00',7.45),('12374','2013-03-29','10:40:00',8.56),('12374','2013-03-29','10:45:00',8.59),('12374','2013-03-29','10:50:00',8.52),('12374','2013-03-29','10:55:00',8.62),('12374','2013-03-29','11:00:00',8.55),('12374','2013-03-29','11:05:00',8.7),('12374','2013-03-29','11:10:00',8.86),('12374','2013-03-29','11:15:00',8.95),('12374','2013-03-29','11:20:00',9),('12374','2013-03-29','11:25:00',9.04),('12374','2013-03-29','11:30:00',9.09),('12374','2013-03-29','11:35:00',9.18),('12374','2013-03-29','11:40:00',9.22),('12374','2013-03-29','11:45:00',9.24),('12374','2013-03-29','11:50:00',9.24),('12374','2013-03-29','11:55:00',9.22),('12374','2013-03-29','12:00:00',9.25),('12374','2013-03-29','12:05:00',9.27),('12374','2013-03-29','12:10:00',9.38),('12374','2013-03-29','12:15:00',9.39),('12374','2013-03-29','12:20:00',9.38),('12374','2013-03-29','12:25:00',9.26),('12374','2013-03-29','12:30:00',9.32),('12374','2013-03-29','12:35:00',9.33),('12374','2013-03-29','12:40:00',9.32),('12374','2013-03-29','12:45:00',9.25),('12374','2013-03-29','12:50:00',9.2),('12374','2013-03-29','12:55:00',8.67),('12374','2013-03-29','13:00:00',9.15),('12374','2013-03-29','13:05:00',9.03),('12374','2013-03-29','13:10:00',8.84),('12374','2013-03-29','13:15:00',8.15),('12374','2013-03-29','13:20:00',7.53),('12374','2013-03-29','13:25:00',7.68),('12374','2013-03-29','13:30:00',7.85),('12374','2013-03-29','13:35:00',7.23),('12374','2013-03-29','13:40:00',7.42),('12374','2013-03-29','13:45:00',7.47),('12374','2013-03-29','13:50:00',6.13),('12374','2013-03-29','13:55:00',4.9),('12374','2013-03-29','14:00:00',4.57),('12374','2013-03-29','14:05:00',4.74),('12374','2013-03-29','14:10:00',4.31),('12374','2013-03-29','14:15:00',3.98),('12374','2013-03-29','14:20:00',3.81),('12374','2013-03-29','14:25:00',3.8),('12374','2013-03-29','14:30:00',4.18),('12374','2013-03-29','14:35:00',4.24),('12374','2013-03-29','14:40:00',3.82),('12374','2013-03-29','14:45:00',3.74),('12374','2013-03-29','14:50:00',3.37),('12374','2013-03-29','14:55:00',3.16),('12374','2013-03-29','15:00:00',2.9),('12374','2013-03-29','15:05:00',2.64),('12374','2013-03-29','15:10:00',2.45),('12374','2013-03-29','15:15:00',2.37),('12374','2013-03-29','15:20:00',2.41),('12374','2013-03-29','15:25:00',2.65),('12374','2013-03-29','15:30:00',3.05),('12374','2013-03-29','15:35:00',3.88),('12374','2013-03-29','15:40:00',5.44),('12374','2013-03-29','15:45:00',5.59),('12374','2013-03-29','15:50:00',3.42),('12374','2013-03-29','15:55:00',2.49),('12374','2013-03-29','16:00:00',2.39),('12374','2013-03-29','16:05:00',3.74),('12374','2013-03-29','16:10:00',3.42),('12374','2013-03-29','16:15:00',2.68),('12374','2013-03-29','16:20:00',2.75),('12374','2013-03-29','16:25:00',2.79),('12374','2013-03-29','16:30:00',3.54),('12374','2013-03-29','16:35:00',2.83),('12374','2013-03-29','16:40:00',3.37),('12374','2013-03-29','16:45:00',2.63),('12374','2013-03-29','16:50:00',1.99),('12374','2013-03-29','16:55:00',2),('12374','2013-03-29','17:00:00',2.19),('12374','2013-03-29','17:05:00',1.77),('12374','2013-03-29','17:10:00',2.23),('12374','2013-03-29','17:15:00',1.36),('12374','2013-03-29','17:20:00',1.74),('12374','2013-03-29','17:25:00',1.11),('12374','2013-03-28','08:35:00',1.06),('12374','2013-03-28','08:40:00',1.74),('12374','2013-03-28','08:45:00',1.99),('12374','2013-03-28','08:50:00',2.39),('12374','2013-03-28','08:55:00',2.18),('12374','2013-03-28','09:00:00',2.01),('12374','2013-03-28','09:05:00',1.5),('12374','2013-03-28','09:10:00',1.5),('12374','2013-03-28','09:17:00',2.25),('12374','2013-03-28','09:20:00',2.3),('12374','2013-03-28','09:25:00',2.27),('12374','2013-03-28','09:30:00',2.27),('12374','2013-03-28','09:35:00',2.68),('12374','2013-03-28','09:40:00',3.29),('12374','2013-03-28','09:45:00',3.06),('12374','2013-03-28','09:50:00',2.39),('12374','2013-03-28','09:55:00',2.7),('12374','2013-03-28','10:00:00',2.81),('12374','2013-03-28','10:05:00',1.83),('12374','2013-03-28','10:10:00',1.77),('12374','2013-03-28','10:15:00',1.79),('12374','2013-03-28','10:20:00',1.52),('12374','2013-03-28','10:25:00',1.7),('12374','2013-03-28','10:30:00',1.06),('12374','2013-03-28','10:40:00',1.02),('12374','2013-03-28','10:45:00',1.04),('12374','2013-03-28','10:55:00',1.25),('12374','2013-03-28','11:00:00',1.51),('12374','2013-03-28','11:05:00',1.46),('12374','2013-03-28','11:10:00',1.13),('12374','2013-03-28','11:15:00',1.2),('12374','2013-03-28','11:20:00',1.32),('12374','2013-03-28','11:25:00',1.52),('12374','2013-03-28','11:30:00',2.08),('12374','2013-03-28','11:35:00',2.3),('12374','2013-03-28','11:40:00',2.08),('12374','2013-03-28','11:45:00',2.25),('12374','2013-03-28','11:50:00',2.27),('12374','2013-03-28','11:55:00',2.14),('12374','2013-03-28','12:00:00',1.64),('12374','2013-03-28','12:05:00',1.68),('12374','2013-03-28','12:10:00',1.76),('12374','2013-03-28','12:15:00',1.36),('12374','2013-03-28','12:20:00',1.77),('12374','2013-03-28','12:25:00',2.26),('12374','2013-03-28','12:30:00',2.28),('12374','2013-03-28','12:35:00',2.44),('12374','2013-03-28','12:40:00',2.25),('12374','2013-03-28','12:45:00',2.36),('12374','2013-03-28','12:50:00',2.36),('12374','2013-03-28','12:55:00',1.85),('12374','2013-03-28','13:00:00',1.75),('12374','2013-03-28','13:05:00',2.36),('12374','2013-03-28','13:10:00',2.23),('12374','2013-03-28','13:15:00',2.27),('12374','2013-03-28','13:20:00',2.89),('12374','2013-03-28','13:25:00',2.29),('12374','2013-03-28','13:30:00',1.31),('12374','2013-03-28','13:35:00',1.2),('12374','2013-03-28','13:40:00',2.07),('12374','2013-03-28','13:45:00',3.44),('12374','2013-03-28','13:50:00',2.15),('12374','2013-03-28','13:55:00',1.37),('12374','2013-03-28','14:20:00',2.38),('12374','2013-03-28','14:25:00',2.28),('12374','2013-03-28','14:30:00',1.48),('12374','2013-03-28','14:45:00',1.3),('12374','2013-03-28','15:10:00',2.23),('12374','2013-03-28','15:15:00',1.98),('12374','2013-03-28','15:30:00',1.59),('12374','2013-03-28','15:35:00',2.98),('12374','2013-03-28','15:40:00',2.36),('12374','2013-03-28','15:45:00',1.11),('12374','2013-03-28','16:55:00',1.14),('12374','2013-03-28','17:00:00',1.28),('12374','2013-03-28','17:05:00',1.43),('12374','2013-03-28','17:10:00',1.01),('12374','2013-03-27','06:55:00',1.26),('12374','2013-03-27','07:00:00',1.4),('12374','2013-03-27','07:05:00',1.48),('12374','2013-03-27','07:10:00',1.62),('12374','2013-03-27','07:15:00',2.29),('12374','2013-03-27','07:20:00',1.99),('12374','2013-03-27','07:25:00',1.9),('12374','2013-03-27','07:30:00',3.07),('12374','2013-03-27','07:35:00',2.96),('12374','2013-03-27','07:40:00',3.04),('12374','2013-03-27','07:45:00',2.53),('12374','2013-03-27','07:50:00',2.35),('12374','2013-03-27','07:55:00',3.61),('12374','2013-03-27','08:00:00',3.89),('12374','2013-03-27','08:05:00',3.15),('12374','2013-03-27','08:10:00',2.28),('12374','2013-03-27','08:15:00',2.14),('12374','2013-03-27','08:20:00',2.23),('12374','2013-03-27','08:25:00',3),('12374','2013-03-27','08:30:00',4.81),('12374','2013-03-27','08:35:00',3.62),('12374','2013-03-27','08:40:00',2.91),('12374','2013-03-27','08:45:00',3.14),('12374','2013-03-27','08:50:00',4.02),('12374','2013-03-27','08:55:00',4.15),('12374','2013-03-27','09:00:00',4.84),('12374','2013-03-27','09:05:00',6.55),('12374','2013-03-27','09:10:00',5.28),('12374','2013-03-27','09:15:00',6.1),('12374','2013-03-27','09:20:00',6.7),('12374','2013-03-27','09:25:00',7.8),('12374','2013-03-27','09:30:00',5.54),('12374','2013-03-27','09:35:00',6.68),('12374','2013-03-27','09:40:00',7.59),('12374','2013-03-27','09:45:00',6.38),('12374','2013-03-27','09:50:00',7.24),('12374','2013-03-27','09:55:00',8.39),('12374','2013-03-27','10:00:00',8.59),('12374','2013-03-27','10:05:00',7.7),('12374','2013-03-27','10:10:00',6.03),('12374','2013-03-27','10:15:00',5.83),('12374','2013-03-27','10:20:00',5.04),('12374','2013-03-27','10:25:00',5.25),('12374','2013-03-27','10:30:00',7.22),('12374','2013-03-27','10:35:00',6.03),('12374','2013-03-27','10:40:00',4.44),('12374','2013-03-27','10:45:00',4.37),('12374','2013-03-27','10:50:00',3.75),('12374','2013-03-27','10:55:00',3.21),('12374','2013-03-27','11:00:00',3.65),('12374','2013-03-27','11:05:00',4.44),('12374','2013-03-27','11:10:00',4.09),('12374','2013-03-27','11:15:00',4.23),('12374','2013-03-27','11:20:00',4.2),('12374','2013-03-27','11:25:00',4.5),('12374','2013-03-27','11:30:00',6.23),('12374','2013-03-27','11:35:00',6.82),('12374','2013-03-27','11:40:00',5.96),('12374','2013-03-27','11:45:00',8.49),('12374','2013-03-27','11:50:00',7.83),('12374','2013-03-27','11:55:00',7.32),('12374','2013-03-27','12:00:00',7.37),('12374','2013-03-27','12:05:00',8.16),('12374','2013-03-27','12:10:00',8.96),('12374','2013-03-27','12:15:00',8.53),('12374','2013-03-27','12:20:00',5.72),('12374','2013-03-27','12:25:00',6.15),('12374','2013-03-27','12:30:00',8.5),('12374','2013-03-27','12:35:00',7.5),('12374','2013-03-27','12:40:00',6.68),('12374','2013-03-27','12:45:00',6.26),('12374','2013-03-27','12:50:00',7.34),('12374','2013-03-27','12:55:00',6.22),('12374','2013-03-27','13:00:00',7.67),('12374','2013-03-27','13:05:00',8.22),('12374','2013-03-27','13:10:00',6.96),('12374','2013-03-27','13:15:00',6.59),('12374','2013-03-27','13:20:00',4.99),('12374','2013-03-27','13:25:00',4.81),('12374','2013-03-27','13:30:00',5.94),('12374','2013-03-27','13:35:00',4.36),('12374','2013-03-27','13:40:00',3.46),('12374','2013-03-27','13:45:00',5.74),('12374','2013-03-27','13:50:00',6.82),('12374','2013-03-27','13:55:00',5.69),('12374','2013-03-27','14:00:00',5.54),('12374','2013-03-27','14:05:00',5.56),('12374','2013-03-27','14:10:00',5.69),('12374','2013-03-27','14:15:00',5.66),('12374','2013-03-27','14:20:00',5.28),('12374','2013-03-27','14:25:00',6.27),('12374','2013-03-27','14:30:00',5.95),('12374','2013-03-27','14:35:00',5.45),('12374','2013-03-27','14:40:00',5.37),('12374','2013-03-27','14:45:00',6.27),('12374','2013-03-27','14:50:00',7.31),('12374','2013-03-27','14:55:00',6.79),('12374','2013-03-27','15:00:00',4.1),('12374','2013-03-27','15:05:00',2.8),('12374','2013-03-27','15:10:00',2.94),('12374','2013-03-27','15:15:00',4.48),('12374','2013-03-27','15:20:00',4.35),('12374','2013-03-27','15:25:00',5.24),('12374','2013-03-27','15:30:00',3.73),('12374','2013-03-27','15:35:00',3.92),('12374','2013-03-27','15:40:00',3.06),('12374','2013-03-27','15:45:00',2.82),('12374','2013-03-27','15:50:00',2.76),('12374','2013-03-27','15:55:00',2.63),('12374','2013-03-27','16:00:00',2.72),('12374','2013-03-27','16:05:00',4.07),('12374','2013-03-27','16:10:00',3.68),('12374','2013-03-27','16:15:00',2.45),('12374','2013-03-27','16:20:00',2.32),('12374','2013-03-27','16:25:00',1.93),('12374','2013-03-27','16:30:00',2.2),('12374','2013-03-27','16:35:00',1.58),('12374','2013-03-27','16:40:00',1.2),('12374','2013-03-26','06:45:00',1.05),('12374','2013-03-26','07:00:00',1.05),('12374','2013-03-26','07:30:00',1.03),('12374','2013-03-26','08:00:00',1.19),('12374','2013-03-26','08:05:00',1.19),('12374','2013-03-26','08:10:00',1.41),('12374','2013-03-26','08:15:00',1.67),('12374','2013-03-26','08:20:00',2.46),('12374','2013-03-26','08:25:00',1.77),('12374','2013-03-26','08:30:00',1.34),('12374','2013-03-26','08:35:00',1.9),('12374','2013-03-26','08:40:00',1.8),('12374','2013-03-26','08:45:00',1.42),('12374','2013-03-26','08:55:00',1.68),('12374','2013-03-26','09:00:00',1.97),('12374','2013-03-26','09:05:00',3.58),('12374','2013-03-26','09:10:00',4.24),('12374','2013-03-26','09:15:00',3.26),('12374','2013-03-26','09:20:00',3.61),('12374','2013-03-26','09:25:00',4.8),('12374','2013-03-26','09:30:00',2.13),('12374','2013-03-26','09:35:00',1.9),('12374','2013-03-26','09:40:00',1.02),('12374','2013-03-26','09:45:00',1.97),('12374','2013-03-26','09:50:00',2.46),('12374','2013-03-26','09:55:00',2.05),('12374','2013-03-26','10:00:00',2.19),('12374','2013-03-26','10:05:00',2.27),('12374','2013-03-26','10:10:00',3.74),('12374','2013-03-26','10:15:00',6.62),('12374','2013-03-26','10:20:00',4.61),('12374','2013-03-26','10:25:00',4.22),('12374','2013-03-26','10:30:00',3.46),('12374','2013-03-26','10:35:00',3.61),('12374','2013-03-26','10:40:00',3.21),('12374','2013-03-26','10:45:00',3.74),('12374','2013-03-26','10:50:00',3.86),('12374','2013-03-26','10:55:00',3.6),('12374','2013-03-26','11:00:00',2.64),('12374','2013-03-26','11:05:00',1.78),('12374','2013-03-26','11:10:00',1.86),('12374','2013-03-26','11:15:00',1.77),('12374','2013-03-26','11:20:00',1.47),('12374','2013-03-26','11:25:00',1.22),('12374','2013-03-26','11:30:00',1.19),('12374','2013-03-26','11:35:00',2.64),('12374','2013-03-26','11:40:00',3.31),('12374','2013-03-26','11:45:00',3.48),('12374','2013-03-26','11:50:00',2.55),('12374','2013-03-26','11:55:00',2.62),('12374','2013-03-26','12:00:00',4.27),('12374','2013-03-26','12:05:00',5.63),('12374','2013-03-26','12:10:00',5.07),('12374','2013-03-26','12:15:00',5.31),('12374','2013-03-26','12:20:00',7.44),('12374','2013-03-26','12:25:00',9.01),('12374','2013-03-26','12:30:00',8.61),('12374','2013-03-26','12:35:00',4.74),('12374','2013-03-26','12:40:00',3.12),('12374','2013-03-26','12:45:00',3.97),('12374','2013-03-26','12:50:00',3.33),('12374','2013-03-26','12:55:00',2.74),('12374','2013-03-26','13:00:00',3.36),('12374','2013-03-26','13:05:00',3.21),('12374','2013-03-26','13:10:00',2.73),('12374','2013-03-26','13:15:00',1.89),('12374','2013-03-26','13:20:00',2.26),('12374','2013-03-26','13:25:00',4.67),('12374','2013-03-26','13:30:00',4.15),('12374','2013-03-26','13:35:00',2.5),('12374','2013-03-26','13:40:00',2.9),('12374','2013-03-26','13:45:00',2.86),('12374','2013-03-26','13:50:00',2.08),('12374','2013-03-26','13:55:00',1.75),('12374','2013-03-26','14:00:00',1.64),('12374','2013-03-26','14:05:00',2.97),('12374','2013-03-26','14:10:00',3.23),('12374','2013-03-26','14:15:00',3.48),('12374','2013-03-26','14:20:00',2.94),('12374','2013-03-26','14:25:00',2.75),('12374','2013-03-26','14:30:00',2.76),('12374','2013-03-26','14:35:00',2.61),('12374','2013-03-26','14:40:00',2.19),('12374','2013-03-26','14:45:00',2.3),('12374','2013-03-26','14:50:00',2.21),('12374','2013-03-26','14:55:00',2.12),('12374','2013-03-26','15:00:00',2.3),('12374','2013-03-26','15:05:00',2.15),('12374','2013-03-26','15:10:00',2.07),('12374','2013-03-26','15:15:00',2.29),('12374','2013-03-26','15:20:00',2.61),('12374','2013-03-26','15:25:00',2.51),('12374','2013-03-26','15:30:00',1.68),('12374','2013-03-26','15:35:00',1.46),('12374','2013-03-26','15:40:00',1.64),('12374','2013-03-26','15:45:00',1.38),('12374','2013-03-25','07:40:00',1.01),('12374','2013-03-25','07:45:00',1.79),('12374','2013-03-25','07:50:00',3.29),('12374','2013-03-25','07:55:00',2.92),('12374','2013-03-25','08:00:00',2.27),('12374','2013-03-25','08:05:00',1.91),('12374','2013-03-25','08:10:00',2.3),('12374','2013-03-25','08:15:00',4.99),('12374','2013-03-25','08:20:00',5.31),('12374','2013-03-25','08:25:00',5.66),('12374','2013-03-25','08:30:00',5.67),('12374','2013-03-25','08:35:00',4.73),('12374','2013-03-25','08:40:00',4.9),('12374','2013-03-25','08:45:00',7.21),('12374','2013-03-25','08:50:00',6.25),('12374','2013-03-25','08:55:00',3.64),('12374','2013-03-25','09:00:00',1.78),('12374','2013-03-25','09:05:00',2.01),('12374','2013-03-25','09:10:00',1.92),('12374','2013-03-25','09:15:00',2.25),('12374','2013-03-25','09:20:00',2.79),('12374','2013-03-25','09:25:00',4.24),('12374','2013-03-25','09:30:00',5.89),('12374','2013-03-25','09:35:00',5.77),('12374','2013-03-25','09:40:00',4.11),('12374','2013-03-25','09:45:00',4.48),('12374','2013-03-25','09:50:00',4.17),('12374','2013-03-25','09:55:00',3.27),('12374','2013-03-25','10:00:00',4.24),('12374','2013-03-25','10:05:00',2.64),('12374','2013-03-25','10:10:00',5.18),('12374','2013-03-25','10:15:00',4.49),('12374','2013-03-25','10:20:00',8.22),('12374','2013-03-25','10:25:00',8.63),('12374','2013-03-25','10:30:00',7.44),('12374','2013-03-25','10:35:00',7.1),('12374','2013-03-25','10:40:00',8.92),('12374','2013-03-25','10:45:00',8.01),('12374','2013-03-25','10:50:00',8.28),('12374','2013-03-25','10:55:00',8.07),('12374','2013-03-25','11:00:00',7.38),('12374','2013-03-25','11:05:00',6.4),('12374','2013-03-25','11:10:00',6.43),('12374','2013-03-25','11:15:00',5.03),('12374','2013-03-25','11:20:00',5.76),('12374','2013-03-25','11:25:00',7.06),('12374','2013-03-25','11:30:00',9.5),('12374','2013-03-25','11:35:00',8.31),('12374','2013-03-25','11:40:00',5.06),('12374','2013-03-25','11:45:00',5.24),('12374','2013-03-25','11:50:00',9.65),('12374','2013-03-25','11:55:00',8.53),('12374','2013-03-25','12:00:00',7.92),('12374','2013-03-25','12:05:00',8.74),('12374','2013-03-25','12:10:00',8.83),('12374','2013-03-25','12:15:00',9.88),('12374','2013-03-25','12:20:00',8.64),('12374','2013-03-25','12:25:00',7.92),('12374','2013-03-25','12:30:00',9.78),('12374','2013-03-25','12:35:00',6.45),('12374','2013-03-25','12:40:00',8.66),('12374','2013-03-25','12:45:00',9.59),('12374','2013-03-25','12:50:00',9.09),('12374','2013-03-25','12:55:00',4.44),('12374','2013-03-25','13:00:00',2.96),('12374','2013-03-25','13:05:00',3.45),('12374','2013-03-25','13:10:00',5.72),('12374','2013-03-25','13:15:00',7.23),('12374','2013-03-25','13:20:00',8.56),('12374','2013-03-25','13:25:00',7.49),('12374','2013-03-25','13:30:00',8.61),('12374','2013-03-25','13:35:00',6.27),('12374','2013-03-25','13:40:00',6.82),('12374','2013-03-25','13:45:00',7.5),('12374','2013-03-25','13:50:00',6.98),('12374','2013-03-25','13:55:00',8.07),('12374','2013-03-25','14:00:00',6.57),('12374','2013-03-25','14:05:00',6.14),('12374','2013-03-25','14:10:00',4.73),('12374','2013-03-25','14:15:00',6.53),('12374','2013-03-25','14:20:00',5.59),('12374','2013-03-25','14:25:00',4.99),('12374','2013-03-25','14:30:00',4.71),('12374','2013-03-25','14:35:00',4.06),('12374','2013-03-25','14:40:00',4.36),('12374','2013-03-25','14:45:00',5.24),('12374','2013-03-25','14:50:00',5.04),('12374','2013-03-25','14:55:00',4.44),('12374','2013-03-25','15:00:00',6),('12374','2013-03-25','15:05:00',6.59),('12374','2013-03-25','15:10:00',6.49),('12374','2013-03-25','15:15:00',6.38),('12374','2013-03-25','15:20:00',4.86),('12374','2013-03-25','15:25:00',3.63),('12374','2013-03-25','15:30:00',5.33),('12374','2013-03-25','15:35:00',3.62),('12374','2013-03-25','15:40:00',3.92),('12374','2013-03-25','15:45:00',4.63),('12374','2013-03-25','15:50:00',4.75),('12374','2013-03-25','15:55:00',3.68),('12374','2013-03-25','16:00:00',5.32),('12374','2013-03-25','16:05:00',4.36),('12374','2013-03-25','16:10:00',4.3),('12374','2013-03-25','16:15:00',4.23),('12374','2013-03-25','16:20:00',3.56),('12374','2013-03-25','16:25:00',2.38),('12374','2013-03-25','16:30:00',1.62),('12374','2013-03-25','16:35:00',1.64),('12374','2013-03-25','16:40:00',2.21),('12374','2013-03-25','16:45:00',3.03),('12374','2013-03-25','16:50:00',2.36),('12374','2013-03-25','16:55:00',1.82),('12374','2013-03-25','17:00:00',1.6),('12374','2013-03-25','17:05:00',1.38),('12374','2013-03-25','17:10:00',1.12),('12374','2013-03-24','06:50:00',1.06),('12374','2013-03-24','06:55:00',1.28),('12374','2013-03-24','07:00:00',1.62),('12374','2013-03-24','07:05:00',1.84),('12374','2013-03-24','07:10:00',1.91),('12374','2013-03-24','07:15:00',2),('12374','2013-03-24','07:20:00',2.04),('12374','2013-03-24','07:25:00',2.28),('12374','2013-03-24','07:30:00',2.44),('12374','2013-03-24','07:35:00',2.9),('12374','2013-03-24','07:40:00',2.7),('12374','2013-03-24','07:45:00',3.14),('12374','2013-03-24','07:50:00',3.28),('12374','2013-03-24','07:55:00',3.78),('12374','2013-03-24','08:00:00',3.81),('12374','2013-03-24','08:05:00',3.9),('12374','2013-03-24','08:10:00',4.1),('12374','2013-03-24','08:15:00',4.32),('12374','2013-03-24','08:20:00',4.6),('12374','2013-03-24','08:25:00',4.81),('12374','2013-03-24','08:30:00',4.95),('12374','2013-03-24','08:35:00',5.11),('12374','2013-03-24','08:40:00',5.32),('12374','2013-03-24','08:45:00',5.49),('12374','2013-03-24','08:50:00',5.63),('12374','2013-03-24','08:55:00',5.8),('12374','2013-03-24','09:00:00',5.95),('12374','2013-03-24','09:05:00',6.07),('12374','2013-03-24','09:10:00',6.26),('12374','2013-03-24','09:15:00',6.4),('12374','2013-03-24','09:20:00',6.52),('12374','2013-03-24','09:25:00',6.61),('12374','2013-03-24','09:30:00',6.73),('12374','2013-03-24','09:35:00',6.9),('12374','2013-03-24','09:40:00',7.01),('12374','2013-03-24','09:45:00',7.11),('12374','2013-03-24','09:50:00',7.2),('12374','2013-03-24','09:55:00',7.31),('12374','2013-03-24','10:00:00',7.43),('12374','2013-03-24','10:05:00',7.56),('12374','2013-03-24','10:10:00',7.65),('12374','2013-03-24','10:15:00',7.76),('12374','2013-03-24','10:20:00',7.82),('12374','2013-03-24','10:25:00',7.91),('12374','2013-03-24','10:30:00',7.99),('12374','2013-03-24','10:35:00',8.08),('12374','2013-03-24','10:40:00',8.18),('12374','2013-03-24','10:45:00',8.27),('12374','2013-03-24','10:50:00',8.34),('12374','2013-03-24','10:55:00',8.41),('12374','2013-03-24','11:00:00',8.47),('12374','2013-03-24','11:05:00',8.54),('12374','2013-03-24','11:10:00',8.54),('12374','2013-03-24','11:15:00',8.58),('12374','2013-03-24','11:20:00',8.63),('12374','2013-03-24','11:25:00',8.71),('12374','2013-03-24','11:30:00',8.75),('12374','2013-03-24','11:35:00',8.74),('12374','2013-03-24','11:40:00',8.72),('12374','2013-03-24','11:45:00',8.78),('12374','2013-03-24','11:50:00',8.83),('12374','2013-03-24','11:55:00',8.79),('12374','2013-03-24','12:00:00',8.78),('12374','2013-03-24','12:05:00',8.79),('12374','2013-03-24','12:10:00',8.76),('12374','2013-03-24','12:15:00',8.79),('12374','2013-03-24','12:20:00',8.78),('12374','2013-03-24','12:25:00',8.72),('12374','2013-03-24','12:30:00',8.68),('12374','2013-03-24','12:35:00',8.58),('12374','2013-03-24','12:40:00',8.56),('12374','2013-03-24','12:45:00',8.59),('12374','2013-03-24','12:50:00',8.61),('12374','2013-03-24','12:55:00',8.61),('12374','2013-03-24','13:00:00',8.66),('12374','2013-03-24','13:05:00',8.56),('12374','2013-03-24','13:10:00',8.51),('12374','2013-03-24','13:15:00',8.47),('12374','2013-03-24','13:20:00',8.38),('12374','2013-03-24','13:25:00',8.23),('12374','2013-03-24','13:30:00',8.14),('12374','2013-03-24','13:35:00',8.05),('12374','2013-03-24','13:40:00',7.95),('12374','2013-03-24','13:45:00',7.96),('12374','2013-03-24','13:50:00',7.86),('12374','2013-03-24','13:55:00',7.78),('12374','2013-03-24','14:00:00',7.73),('12374','2013-03-24','14:05:00',7.71),('12374','2013-03-24','14:10:00',6.26),('12374','2013-03-24','14:15:00',6.75),('12374','2013-03-24','14:20:00',7.17),('12374','2013-03-24','14:25:00',7.09),('12374','2013-03-24','14:30:00',7.01),('12374','2013-03-24','14:35:00',5.75),('12374','2013-03-24','14:40:00',6.89),('12374','2013-03-24','14:45:00',6.53),('12374','2013-03-24','14:50:00',6.38),('12374','2013-03-24','14:55:00',6),('12374','2013-03-24','15:00:00',5.58),('12374','2013-03-24','15:05:00',3.74),('12374','2013-03-24','15:10:00',5.08),('12374','2013-03-24','15:15:00',3.95),('12374','2013-03-24','15:20:00',4.75),('12374','2013-03-24','15:25:00',3.52),('12374','2013-03-24','15:30:00',3.2),('12374','2013-03-24','15:35:00',4.7),('12374','2013-03-24','15:40:00',1.99),('12374','2013-03-24','15:45:00',2.6),('12374','2013-03-24','15:50:00',4.42),('12374','2013-03-24','15:55:00',2.69),('12374','2013-03-24','16:00:00',1.66),('12374','2013-03-24','16:05:00',2.87),('12374','2013-03-24','16:10:00',2.97),('12374','2013-03-24','16:15:00',2.27),('12374','2013-03-24','16:20:00',2.4),('12374','2013-03-24','16:25:00',1.81),('12374','2013-03-24','16:30:00',1.45),('12374','2013-03-24','16:35:00',1.51),('12374','2013-03-24','16:40:00',1.43),('12374','2013-03-24','16:45:00',1.51),('12374','2013-03-24','16:50:00',1.63),('12374','2013-03-24','16:55:00',1.45),('12374','2013-03-24','17:00:00',1.22),('12374','2013-03-24','17:05:00',1.02),('12374','2013-03-23','06:50:00',1.22),('12374','2013-03-23','06:55:00',1.4),('12374','2013-03-23','07:00:00',1.61),('12374','2013-03-23','07:05:00',1.67),('12374','2013-03-23','07:10:00',1.53),('12374','2013-03-23','07:15:00',1.54),('12374','2013-03-23','07:20:00',2),('12374','2013-03-23','07:25:00',1.86),('12374','2013-03-23','07:30:00',2.12),('12374','2013-03-23','07:35:00',2.87),('12374','2013-03-23','07:40:00',3.17),('12374','2013-03-23','07:45:00',3.34),('12374','2013-03-23','07:50:00',3.74),('12374','2013-03-23','07:55:00',3.79),('12374','2013-03-23','08:00:00',3.98),('12374','2013-03-23','08:05:00',4.13),('12374','2013-03-23','08:10:00',4.42),('12374','2013-03-23','08:15:00',4.58),('12374','2013-03-23','08:20:00',4.81),('12374','2013-03-23','08:25:00',4.97),('12374','2013-03-23','08:30:00',4.94),('12374','2013-03-23','08:35:00',5.17),('12374','2013-03-23','08:40:00',5.49),('12374','2013-03-23','08:45:00',5.49),('12374','2013-03-23','08:50:00',5.64),('12374','2013-03-23','08:55:00',5.75),('12374','2013-03-23','09:00:00',5.87),('12374','2013-03-23','09:05:00',6.12),('12374','2013-03-23','09:10:00',6.37),('12374','2013-03-23','09:15:00',6.46),('12374','2013-03-23','09:20:00',6.5),('12374','2013-03-23','09:25:00',6.65),('12374','2013-03-23','09:30:00',6.75),('12374','2013-03-23','09:35:00',7),('12374','2013-03-23','09:40:00',7.13),('12374','2013-03-23','09:45:00',7.18),('12374','2013-03-23','09:50:00',7.21),('12374','2013-03-23','09:55:00',7.18),('12374','2013-03-23','10:00:00',6.68),('12374','2013-03-23','10:05:00',7.21),('12374','2013-03-23','10:10:00',7.35),('12374','2013-03-23','10:15:00',7.37),('12374','2013-03-23','10:20:00',7.29),('12374','2013-03-23','10:25:00',7.04),('12374','2013-03-23','10:30:00',7.15),('12374','2013-03-23','10:35:00',7.73),('12374','2013-03-23','10:40:00',7.94),('12374','2013-03-23','10:45:00',8.22),('12374','2013-03-23','10:50:00',7.89),('12374','2013-03-23','10:55:00',8.41),('12374','2013-03-23','11:00:00',8.5),('12374','2013-03-23','11:05:00',8.1),('12374','2013-03-23','11:10:00',8.34),('12374','2013-03-23','11:15:00',8.23),('12374','2013-03-23','11:20:00',8.65),('12374','2013-03-23','11:25:00',8.64),('12374','2013-03-23','11:30:00',8.73),('12374','2013-03-23','11:35:00',8.58),('12374','2013-03-23','11:40:00',8.79),('12374','2013-03-23','11:45:00',8.07),('12374','2013-03-23','11:50:00',8.64),('12374','2013-03-23','11:55:00',8.93),('12374','2013-03-23','12:00:00',8.85),('12374','2013-03-23','12:05:00',9),('12374','2013-03-23','12:10:00',8.86),('12374','2013-03-23','12:15:00',8.96),('12374','2013-03-23','12:20:00',8.92),('12374','2013-03-23','12:25:00',8.89),('12374','2013-03-23','12:30:00',8.95),('12374','2013-03-23','12:35:00',8.78),('12374','2013-03-23','12:40:00',8.74),('12374','2013-03-23','12:45:00',8.73),('12374','2013-03-23','12:50:00',8.67),('12374','2013-03-23','12:55:00',8.69),('12374','2013-03-23','13:00:00',8.73),('12374','2013-03-23','13:05:00',8.5),('12374','2013-03-23','13:10:00',8.55),('12374','2013-03-23','13:15:00',8.42),('12374','2013-03-23','13:20:00',8.42),('12374','2013-03-23','13:25:00',8.39),('12374','2013-03-23','13:30:00',8.19),('12374','2013-03-23','13:35:00',8.08),('12374','2013-03-23','13:40:00',8.05),('12374','2013-03-23','13:45:00',8.27),('12374','2013-03-23','13:50:00',8.1),('12374','2013-03-23','13:55:00',7.68),('12374','2013-03-23','14:00:00',7.84),('12374','2013-03-23','14:05:00',7.73),('12374','2013-03-23','14:10:00',7.68),('12374','2013-03-23','14:15:00',7.2),('12374','2013-03-23','14:20:00',7.17),('12374','2013-03-23','14:25:00',6.93),('12374','2013-03-23','14:30:00',6.69),('12374','2013-03-23','14:35:00',6.58),('12374','2013-03-23','14:40:00',6.28),('12374','2013-03-23','14:45:00',6.79),('12374','2013-03-23','14:50:00',6.58),('12374','2013-03-23','14:55:00',6.06),('12374','2013-03-23','15:00:00',6.28),('12374','2013-03-23','15:05:00',6.36),('12374','2013-03-23','15:10:00',6.02),('12374','2013-03-23','15:15:00',5.67),('12374','2013-03-23','15:20:00',5.01),('12374','2013-03-23','15:25:00',4.73),('12374','2013-03-23','15:30:00',5.04),('12374','2013-03-23','15:35:00',5.02),('12374','2013-03-23','15:40:00',5.12),('12374','2013-03-23','15:45:00',4.35),('12374','2013-03-23','15:50:00',4.33),('12374','2013-03-23','15:55:00',4.01),('12374','2013-03-23','16:00:00',4.23),('12374','2013-03-23','16:05:00',3.85),('12374','2013-03-23','16:10:00',4.1),('12374','2013-03-23','16:15:00',3.52),('12374','2013-03-23','16:20:00',3.63),('12374','2013-03-23','16:25:00',3.78),('12374','2013-03-23','16:30:00',2.82),('12374','2013-03-23','16:35:00',2.44),('12374','2013-03-23','16:40:00',2.63),('12374','2013-03-23','16:45:00',2.02),('12374','2013-03-23','16:50:00',1.83),('12374','2013-03-23','16:55:00',1.93),('12374','2013-03-23','17:00:00',1.87),('12374','2013-03-23','17:05:00',1.38),('12374','2013-03-23','17:10:00',1.28),('12374','2013-03-23','17:15:00',1.32),('12374','2013-03-23','17:20:00',1.08),('12374','2013-03-22','06:40:00',1),('12374','2013-03-22','06:45:00',1.2),('12374','2013-03-22','06:50:00',1.25),('12374','2013-03-22','06:55:00',1.6),('12374','2013-03-22','07:00:00',1.79),('12374','2013-03-22','07:05:00',1.88),('12374','2013-03-22','07:10:00',1.75),('12374','2013-03-22','07:15:00',1.75),('12374','2013-03-22','07:20:00',1.97),('12374','2013-03-22','07:25:00',2.09),('12374','2013-03-22','07:30:00',2.22),('12374','2013-03-22','07:35:00',2.7),('12374','2013-03-22','07:40:00',3.41),('12374','2013-03-22','07:45:00',3.62),('12374','2013-03-22','07:50:00',3.79),('12374','2013-03-22','07:55:00',3.99),('12374','2013-03-22','08:00:00',4.18),('12374','2013-03-22','08:05:00',4.35),('12374','2013-03-22','08:10:00',4.51),('12374','2013-03-22','08:15:00',4.68),('12374','2013-03-22','08:20:00',4.84),('12374','2013-03-22','08:25:00',5),('12374','2013-03-22','08:30:00',5.14),('12374','2013-03-22','08:35:00',5.28),('12374','2013-03-22','08:40:00',5.42),('12374','2013-03-22','08:45:00',5.56),('12374','2013-03-22','08:50:00',5.71),('12374','2013-03-22','08:55:00',5.84),('12374','2013-03-22','09:00:00',5.98),('12374','2013-03-22','09:05:00',6.13),('12374','2013-03-22','09:10:00',6.33),('12374','2013-03-22','09:15:00',6.46),('12374','2013-03-22','09:20:00',6.58),('12374','2013-03-22','09:25:00',6.71),('12374','2013-03-22','09:30:00',6.83),('12374','2013-03-22','09:35:00',6.96),('12374','2013-03-22','09:40:00',7.08),('12374','2013-03-22','09:45:00',7.16),('12374','2013-03-22','09:50:00',7.3),('12374','2013-03-22','09:55:00',7.41),('12374','2013-03-22','10:00:00',7.52),('12374','2013-03-22','10:05:00',7.63),('12374','2013-03-22','10:10:00',7.71),('12374','2013-03-22','10:15:00',7.8),('12374','2013-03-22','10:20:00',7.88),('12374','2013-03-22','10:25:00',7.94),('12374','2013-03-22','10:30:00',8.02),('12374','2013-03-22','10:35:00',8.12),('12374','2013-03-22','10:40:00',8.23),('12374','2013-03-22','10:45:00',8.28),('12374','2013-03-22','10:50:00',8.31),('12374','2013-03-22','10:55:00',8.28),('12374','2013-03-22','11:00:00',8.51),('12374','2013-03-22','11:05:00',8.63),('12374','2013-03-22','11:10:00',8.72),('12374','2013-03-22','11:15:00',8.79),('12374','2013-03-22','11:20:00',8.81),('12374','2013-03-22','11:25:00',8.9),('12374','2013-03-22','11:30:00',8.98),('12374','2013-03-22','11:35:00',9.06),('12374','2013-03-22','11:40:00',9.1),('12374','2013-03-22','11:45:00',9.16),('12374','2013-03-22','11:50:00',9.16),('12374','2013-03-22','11:55:00',9.25),('12374','2013-03-22','12:00:00',9.27),('12374','2013-03-22','12:05:00',9.27),('12374','2013-03-22','12:10:00',9.23),('12374','2013-03-22','12:15:00',9.23),('12374','2013-03-22','12:20:00',9.22),('12374','2013-03-22','12:25:00',9.23),('12374','2013-03-22','12:30:00',9.19),('12374','2013-03-22','12:35:00',8.88),('12374','2013-03-22','12:40:00',8.8),('12374','2013-03-22','12:45:00',9.25),('12374','2013-03-22','12:50:00',9.17),('12374','2013-03-22','12:55:00',9.11),('12374','2013-03-22','13:00:00',9.03),('12374','2013-03-22','13:05:00',8.93),('12374','2013-03-22','13:10:00',8.35),('12374','2013-03-22','13:15:00',8.53),('12374','2013-03-22','13:20:00',8.39),('12374','2013-03-22','13:25:00',7.05),('12374','2013-03-22','13:30:00',7.74),('12374','2013-03-22','13:35:00',8.49),('12374','2013-03-22','13:40:00',8.33),('12374','2013-03-22','13:45:00',8.25),('12374','2013-03-22','13:50:00',8.11),('12374','2013-03-22','13:55:00',7.99),('12374','2013-03-22','14:00:00',7.92),('12374','2013-03-22','14:05:00',7.76),('12374','2013-03-22','14:10:00',7.7),('12374','2013-03-22','14:15:00',7.67),('12374','2013-03-22','14:20:00',7.5),('12374','2013-03-22','14:25:00',7.36),('12374','2013-03-22','14:30:00',7.31),('12374','2013-03-22','14:35:00',7.2),('12374','2013-03-22','14:40:00',7.12),('12374','2013-03-22','14:45:00',6.99),('12374','2013-03-22','14:50:00',6.87),('12374','2013-03-22','14:55:00',6.76),('12374','2013-03-22','15:00:00',6.52),('12374','2013-03-22','15:05:00',5.92),('12374','2013-03-22','15:10:00',5.99),('12374','2013-03-22','15:15:00',5.66),('12374','2013-03-22','15:20:00',5.57),('12374','2013-03-22','15:25:00',5.79),('12374','2013-03-22','15:30:00',5.64),('12374','2013-03-22','15:35:00',5.51),('12374','2013-03-22','15:40:00',4.62),('12374','2013-03-22','15:45:00',3.2),('12374','2013-03-22','15:50:00',3.2),('12374','2013-03-22','15:55:00',3.06),('12374','2013-03-22','16:00:00',3.48),('12374','2013-03-22','16:05:00',3.13),('12374','2013-03-22','16:10:00',1.95),('12374','2013-03-22','16:15:00',2.54),('12374','2013-03-22','16:20:00',3.85),('12374','2013-03-22','16:25:00',2.67),('12374','2013-03-22','16:30:00',2.95),('12374','2013-03-22','16:35:00',2.81),('12374','2013-03-22','16:40:00',3.12),('12374','2013-03-22','16:45:00',2.63),('12374','2013-03-22','16:50:00',2.1),('12374','2013-03-22','16:55:00',2.17),('12374','2013-03-22','17:00:00',1.96),('12374','2013-03-22','17:05:00',1.84),('12374','2013-03-22','17:10:00',1.6),('12374','2013-03-22','17:15:00',1.23),('12374','2013-03-22','17:20:00',1.08),('12374','2013-03-22','17:30:00',1.01),('12374','2013-03-21','07:40:00',2.46),('12374','2013-03-21','07:45:00',4.32),('12374','2013-03-21','07:50:00',3.79),('12374','2013-03-21','07:55:00',1.81),('12374','2013-03-21','08:00:00',1.93),('12374','2013-03-21','08:05:00',2.12),('12374','2013-03-21','08:10:00',3.47),('12374','2013-03-21','08:15:00',3.49),('12374','2013-03-21','08:20:00',4.81),('12374','2013-03-21','08:25:00',4.93),('12374','2013-03-21','08:30:00',5.03),('12374','2013-03-21','08:35:00',3.74),('12374','2013-03-21','08:40:00',5.41),('12374','2013-03-21','08:45:00',5.56),('12374','2013-03-21','08:50:00',5.71),('12374','2013-03-21','08:55:00',4.49),('12374','2013-03-21','09:00:00',5.62),('12374','2013-03-21','09:05:00',6.17),('12374','2013-03-21','09:10:00',6.36),('12374','2013-03-21','09:15:00',6.52),('12374','2013-03-21','09:20:00',6.65),('12374','2013-03-21','09:25:00',6.77),('12374','2013-03-21','09:30:00',6.88),('12374','2013-03-21','09:35:00',7),('12374','2013-03-21','09:40:00',7.15),('12374','2013-03-21','09:45:00',7.23),('12374','2013-03-21','09:50:00',7.32),('12374','2013-03-21','09:55:00',7.49),('12374','2013-03-21','10:00:00',7.55),('12374','2013-03-21','10:05:00',7.67),('12374','2013-03-21','10:10:00',7.75),('12374','2013-03-21','10:15:00',7.9),('12374','2013-03-21','10:20:00',8),('12374','2013-03-21','10:25:00',8.15),('12374','2013-03-21','10:30:00',8.3),('12374','2013-03-21','10:35:00',8.41),('12374','2013-03-21','10:40:00',8.51),('12374','2013-03-21','10:45:00',8.57),('12374','2013-03-21','10:50:00',8.69),('12374','2013-03-21','10:55:00',8.77),('12374','2013-03-21','11:00:00',8.88),('12374','2013-03-21','11:05:00',8.98),('12374','2013-03-21','11:10:00',9.04),('12374','2013-03-21','11:15:00',9.04),('12374','2013-03-21','11:20:00',9.18),('12374','2013-03-21','11:25:00',9.25),('12374','2013-03-21','11:30:00',9.27),('12374','2013-03-21','11:35:00',9.35),('12374','2013-03-21','11:40:00',9.44),('12374','2013-03-21','11:45:00',9.44),('12374','2013-03-21','11:50:00',9.46),('12374','2013-03-21','11:55:00',9.44),('12374','2013-03-21','12:00:00',9.48),('12374','2013-03-21','12:05:00',9.54),('12374','2013-03-21','12:10:00',9.57),('12374','2013-03-21','12:15:00',9.56),('12374','2013-03-21','12:20:00',9.55),('12374','2013-03-21','12:25:00',9.52),('12374','2013-03-21','12:30:00',9.48),('12374','2013-03-21','12:35:00',9.39),('12374','2013-03-21','12:40:00',9.31),('12374','2013-03-21','12:45:00',9.28),('12374','2013-03-21','12:50:00',9.25),('12374','2013-03-21','12:55:00',9.22),('12374','2013-03-21','13:00:00',9.15),('12374','2013-03-21','13:05:00',9.09),('12374','2013-03-21','13:10:00',9.07),('12374','2013-03-21','13:15:00',9.02),('12374','2013-03-21','13:20:00',8.91),('12374','2013-03-21','13:25:00',8.82),('12374','2013-03-21','13:30:00',8.73),('12374','2013-03-21','13:35:00',8.58),('12374','2013-03-21','13:40:00',8.53),('12374','2013-03-21','13:45:00',8.4),('12374','2013-03-21','13:50:00',8.28),('12374','2013-03-21','13:55:00',8.19),('12374','2013-03-21','14:00:00',8.08),('12374','2013-03-21','14:05:00',7.95),('12374','2013-03-21','14:10:00',7.85),('12374','2013-03-21','14:15:00',7.7),('12374','2013-03-21','14:20:00',7.59),('12374','2013-03-21','14:25:00',7.5),('12374','2013-03-21','14:30:00',7.42),('12374','2013-03-21','14:35:00',7.27),('12374','2013-03-21','14:40:00',7.15),('12374','2013-03-21','14:45:00',7.02),('12374','2013-03-21','14:50:00',6.89),('12374','2013-03-21','14:55:00',6.77),('12374','2013-03-21','15:00:00',6.6),('12374','2013-03-21','15:05:00',6.49),('12374','2013-03-21','15:10:00',6.34),('12374','2013-03-21','15:15:00',6.18),('12374','2013-03-21','15:20:00',5.96),('12374','2013-03-21','15:25:00',5.78),('12374','2013-03-21','15:30:00',5.63),('12374','2013-03-21','15:35:00',5.47),('12374','2013-03-21','15:40:00',5.32),('12374','2013-03-21','15:45:00',5.17),('12374','2013-03-21','15:50:00',5),('12374','2013-03-21','15:55:00',4.82),('12374','2013-03-21','16:00:00',4.62),('12374','2013-03-21','16:05:00',4.46),('12374','2013-03-21','16:10:00',4.31),('12374','2013-03-21','16:15:00',4.12),('12374','2013-03-21','16:20:00',3.68),('12374','2013-03-21','16:25:00',3.76),('12374','2013-03-21','16:30:00',3.52),('12374','2013-03-21','16:35:00',3.39),('12374','2013-03-21','16:40:00',3.02),('12374','2013-03-21','16:45:00',2.63),('12374','2013-03-21','16:50:00',2.37),('12374','2013-03-21','16:55:00',2.04),('12374','2013-03-21','17:00:00',1.64),('12374','2013-03-21','17:05:00',1.47),('12374','2013-03-21','17:10:00',1.26),('12374','2013-03-21','17:15:00',1.15),('12374','2013-03-21','17:20:00',1.03),('12374','2013-03-20','06:50:00',1.08),('12374','2013-03-20','06:55:00',1.27),('12374','2013-03-20','07:00:00',1.59),('12374','2013-03-20','07:05:00',1.8),('12374','2013-03-20','07:10:00',1.97),('12374','2013-03-20','07:15:00',1.66),('12374','2013-03-20','07:20:00',1.96),('12374','2013-03-20','07:25:00',2.25),('12374','2013-03-20','07:30:00',1.45),('12374','2013-03-20','07:35:00',1.78),('12374','2013-03-20','07:40:00',2.23),('12374','2013-03-20','07:45:00',3.07),('12374','2013-03-20','07:50:00',3.39),('12374','2013-03-20','07:55:00',3.77),('12374','2013-03-20','08:00:00',4.04),('12374','2013-03-20','08:05:00',4.2),('12374','2013-03-20','08:10:00',4.39),('12374','2013-03-20','08:15:00',4.67),('12374','2013-03-20','08:20:00',4.93),('12374','2013-03-20','08:25:00',2.73),('12374','2013-03-20','08:30:00',2.28),('12374','2013-03-20','08:35:00',4.23),('12374','2013-03-20','08:40:00',5.4),('12374','2013-03-20','08:45:00',5.34),('12374','2013-03-20','08:50:00',5.65),('12374','2013-03-20','08:55:00',5.92),('12374','2013-03-20','09:00:00',5.96),('12374','2013-03-20','09:05:00',5.87),('12374','2013-03-20','09:10:00',6.08),('12374','2013-03-20','09:15:00',6.22),('12374','2013-03-20','09:20:00',6.32),('12374','2013-03-20','09:25:00',5.08),('12374','2013-03-20','09:30:00',6.75),('12374','2013-03-20','09:35:00',6.89),('12374','2013-03-20','09:40:00',6.87),('12374','2013-03-20','09:45:00',6.88),('12374','2013-03-20','09:50:00',7.53),('12374','2013-03-20','09:55:00',7.43),('12374','2013-03-20','10:00:00',7.49),('12374','2013-03-20','10:05:00',7.63),('12374','2013-03-20','10:10:00',7.71),('12374','2013-03-20','10:15:00',7.87),('12374','2013-03-20','10:20:00',7.77),('12374','2013-03-20','10:25:00',7.07),('12374','2013-03-20','10:30:00',7.46),('12374','2013-03-20','10:35:00',8.1),('12374','2013-03-20','10:40:00',7.78),('12374','2013-03-20','10:45:00',4.49),('12374','2013-03-20','10:50:00',3.58),('12374','2013-03-20','10:55:00',4.56),('12374','2013-03-20','11:00:00',5.9),('12374','2013-03-20','11:05:00',6.09),('12374','2013-03-20','11:10:00',7.28),('12374','2013-03-20','11:15:00',5.62),('12374','2013-03-20','11:20:00',5.45),('12374','2013-03-20','11:25:00',5.89),('12374','2013-03-20','11:30:00',5.6),('12374','2013-03-20','11:35:00',5.82),('12374','2013-03-20','11:40:00',4.61),('12374','2013-03-20','11:45:00',5.07),('12374','2013-03-20','11:50:00',3.76),('12374','2013-03-20','11:55:00',3.34),('12374','2013-03-20','12:00:00',4.7),('12374','2013-03-20','12:05:00',6.13),('12374','2013-03-20','12:10:00',5.02),('12374','2013-03-20','12:15:00',2.7),('12374','2013-03-20','12:20:00',2.88),('12374','2013-03-20','12:25:00',2.88),('12374','2013-03-20','12:30:00',2.93),('12374','2013-03-20','12:35:00',2.62),('12374','2013-03-20','12:40:00',2.37),('12374','2013-03-20','12:45:00',2.35),('12374','2013-03-20','12:50:00',3.31),('12374','2013-03-20','12:55:00',2.21),('12374','2013-03-20','13:00:00',1.52),('12374','2013-03-20','13:05:00',1.91),('12374','2013-03-20','13:10:00',2.26),('12374','2013-03-20','13:15:00',2.47),('12374','2013-03-20','13:20:00',2.27),('12374','2013-03-20','13:25:00',2.49),('12374','2013-03-20','13:30:00',2.61),('12374','2013-03-20','13:35:00',2.6),('12374','2013-03-20','13:40:00',3.11),('12374','2013-03-20','13:45:00',3.18),('12374','2013-03-20','13:50:00',3.16),('12374','2013-03-20','13:55:00',2.87),('12374','2013-03-20','14:00:00',2.78),('12374','2013-03-20','14:05:00',2.33),('12374','2013-03-20','14:10:00',2.09),('12374','2013-03-20','14:15:00',1.64),('12374','2013-03-20','14:20:00',1.46),('12374','2013-03-20','14:25:00',1.6),('12374','2013-03-20','14:30:00',1.73),('12374','2013-03-20','14:35:00',1.7),('12374','2013-03-20','14:40:00',1.18),('12374','2013-03-20','14:45:00',1.03),('12374','2013-03-20','14:50:00',1.07),('12374','2013-03-19','06:50:00',1.15),('12374','2013-03-19','06:55:00',1.26),('12374','2013-03-19','07:00:00',1.52),('12374','2013-03-19','07:05:00',1.75),('12374','2013-03-19','07:10:00',1.93),('12374','2013-03-19','07:15:00',1.74),('12374','2013-03-19','07:20:00',1.83),('12374','2013-03-19','07:25:00',2.03),('12374','2013-03-19','07:30:00',2.17),('12374','2013-03-19','07:35:00',2.29),('12374','2013-03-19','07:40:00',2.76),('12374','2013-03-19','07:45:00',3.34),('12374','2013-03-19','07:50:00',3.55),('12374','2013-03-19','07:55:00',3.75),('12374','2013-03-19','08:00:00',3.95),('12374','2013-03-19','08:05:00',4.12),('12374','2013-03-19','08:10:00',4.29),('12374','2013-03-19','08:15:00',4.46),('12374','2013-03-19','08:20:00',4.63),('12374','2013-03-19','08:25:00',4.8),('12374','2013-03-19','08:30:00',4.97),('12374','2013-03-19','08:35:00',5.2),('12374','2013-03-19','08:40:00',5.3),('12374','2013-03-19','08:45:00',5.46),('12374','2013-03-19','08:50:00',5.63),('12374','2013-03-19','08:55:00',5.8),('12374','2013-03-19','09:00:00',5.98),('12374','2013-03-19','09:05:00',6.12),('12374','2013-03-19','09:10:00',6.22),('12374','2013-03-19','09:15:00',6.38),('12374','2013-03-19','09:20:00',6.56),('12374','2013-03-19','09:25:00',6.66),('12374','2013-03-19','09:30:00',6.8),('12374','2013-03-19','09:35:00',6.93),('12374','2013-03-19','09:40:00',7.05),('12374','2013-03-19','09:45:00',7.18),('12374','2013-03-19','09:50:00',7.32),('12374','2013-03-19','09:55:00',7.4),('12374','2013-03-19','10:00:00',7.69),('12374','2013-03-19','10:05:00',7.67),('12374','2013-03-19','10:10:00',7.82),('12374','2013-03-19','10:15:00',7.9),('12374','2013-03-19','10:20:00',8.05),('12374','2013-03-19','10:25:00',8.1),('12374','2013-03-19','10:30:00',8.21),('12374','2013-03-19','10:35:00',8.34),('12374','2013-03-19','10:40:00',8.43),('12374','2013-03-19','10:45:00',8.53),('12374','2013-03-19','10:50:00',8.63),('12374','2013-03-19','10:55:00',8.67),('12374','2013-03-19','11:00:00',8.78),('12374','2013-03-19','11:05:00',8.91),('12374','2013-03-19','11:10:00',8.96),('12374','2013-03-19','11:15:00',9.03),('12374','2013-03-19','11:20:00',9.09),('12374','2013-03-19','11:25:00',9.13),('12374','2013-03-19','11:30:00',9.2),('12374','2013-03-19','11:35:00',9.31),('12374','2013-03-19','11:40:00',9.36),('12374','2013-03-19','11:45:00',9.38),('12374','2013-03-19','11:50:00',9.38),('12374','2013-03-19','11:55:00',9.39),('12374','2013-03-19','12:00:00',9.39),('12374','2013-03-19','12:05:00',9.39),('12374','2013-03-19','12:10:00',9.36),('12374','2013-03-19','12:15:00',9.31),('12374','2013-03-19','12:20:00',9.3),('12374','2013-03-19','12:25:00',9.32),('12374','2013-03-19','12:30:00',9.31),('12374','2013-03-19','12:35:00',9.32),('12374','2013-03-19','12:40:00',9.29),('12374','2013-03-19','12:45:00',9.26),('12374','2013-03-19','12:50:00',9.07),('12374','2013-03-19','12:55:00',9.03),('12374','2013-03-19','13:00:00',9.09),('12374','2013-03-19','13:05:00',8.95),('12374','2013-03-19','13:10:00',8.81),('12374','2013-03-19','13:15:00',8.78),('12374','2013-03-19','13:20:00',8.45),('12374','2013-03-19','13:25:00',8.54),('12374','2013-03-19','13:30:00',8.6),('12374','2013-03-19','13:35:00',8.21),('12374','2013-03-19','13:40:00',8.07),('12374','2013-03-19','13:45:00',8.33),('12374','2013-03-19','13:50:00',8.23),('12374','2013-03-19','13:55:00',8.11),('12374','2013-03-19','14:00:00',8.03),('12374','2013-03-19','14:05:00',7.94),('12374','2013-03-19','14:10:00',7.81),('12374','2013-03-19','14:15:00',7.69),('12374','2013-03-19','14:20:00',7.49),('12374','2013-03-19','14:25:00',7.37),('12374','2013-03-19','14:30:00',7.26),('12374','2013-03-19','14:35:00',7.21),('12374','2013-03-19','14:40:00',7.08),('12374','2013-03-19','14:45:00',6.97),('12374','2013-03-19','14:50:00',6.85),('12374','2013-03-19','14:55:00',6.69),('12374','2013-03-19','15:00:00',6.56),('12374','2013-03-19','15:05:00',6.4),('12374','2013-03-19','15:10:00',6.23),('12374','2013-03-19','15:15:00',6.08),('12374','2013-03-19','15:20:00',5.93),('12374','2013-03-19','15:25:00',5.73),('12374','2013-03-19','15:30:00',5.62),('12374','2013-03-19','15:35:00',5.46),('12374','2013-03-19','15:40:00',5.33),('12374','2013-03-19','15:45:00',5.15),('12374','2013-03-19','15:50:00',4.95),('12374','2013-03-19','15:55:00',4.8),('12374','2013-03-19','16:00:00',4.65),('12374','2013-03-19','16:05:00',4.47),('12374','2013-03-19','16:10:00',4.29),('12374','2013-03-19','16:15:00',4.11),('12374','2013-03-19','16:20:00',3.93),('12374','2013-03-19','16:25:00',3.77),('12374','2013-03-19','16:30:00',3.56),('12374','2013-03-19','16:35:00',3.4),('12374','2013-03-19','16:40:00',2.76),('12374','2013-03-19','16:45:00',2.36),('12374','2013-03-19','16:50:00',2.17),('12374','2013-03-19','16:55:00',1.83),('12374','2013-03-19','17:00:00',1.49),('12374','2013-03-19','17:15:00',1.04),('12374','2013-03-18','07:40:00',1.04),('12374','2013-03-18','07:45:00',1.3),('12374','2013-03-18','07:50:00',1.75),('12374','2013-03-18','07:55:00',1.38),('12374','2013-03-18','08:00:00',1.59),('12374','2013-03-18','08:05:00',1.55),('12374','2013-03-18','08:10:00',1.44),('12374','2013-03-18','08:15:00',1.05),('12374','2013-03-18','08:40:00',1.09),('12374','2013-03-18','08:45:00',1.14),('12374','2013-03-18','08:50:00',1.01),('12374','2013-03-18','08:55:00',1.03),('12374','2013-03-18','09:20:00',1.04),('12374','2013-03-18','09:25:00',1.02),('12374','2013-03-18','09:35:00',1.11),('12374','2013-03-18','09:40:00',1.27),('12374','2013-03-18','09:45:00',1.68),('12374','2013-03-18','09:50:00',2.07),('12374','2013-03-18','09:55:00',2.03),('12374','2013-03-18','10:00:00',2.07),('12374','2013-03-18','10:05:00',2.89),('12374','2013-03-18','10:10:00',2.85),('12374','2013-03-18','10:15:00',2.2),('12374','2013-03-18','10:20:00',2.11),('12374','2013-03-18','10:25:00',2.21),('12374','2013-03-18','10:30:00',2.29),('12374','2013-03-18','10:35:00',2.03),('12374','2013-03-18','10:40:00',1.66),('12374','2013-03-18','10:45:00',1.74),('12374','2013-03-18','10:50:00',2.42),('12374','2013-03-18','10:55:00',3),('12374','2013-03-18','11:00:00',3.57),('12374','2013-03-18','11:05:00',3.55),('12374','2013-03-18','11:10:00',3.49),('12374','2013-03-18','11:15:00',3.79),('12374','2013-03-18','11:20:00',3.67),('12374','2013-03-18','11:25:00',2.68),('12374','2013-03-18','11:30:00',2.22),('12374','2013-03-18','11:35:00',2.01),('12374','2013-03-18','11:40:00',2.3),('12374','2013-03-18','11:45:00',2.37),('12374','2013-03-18','11:50:00',2.5),('12374','2013-03-18','11:55:00',2.39),('12374','2013-03-18','12:00:00',2.38),('12374','2013-03-18','12:05:00',2.81),('12374','2013-03-18','12:10:00',2.46),('12374','2013-03-18','12:15:00',1.95),('12374','2013-03-18','12:20:00',2.32),('12374','2013-03-18','12:25:00',2.09),('12374','2013-03-18','12:30:00',2.05),('12374','2013-03-18','12:35:00',1.64),('12374','2013-03-18','12:40:00',1.48),('12374','2013-03-18','12:45:00',1.49),('12374','2013-03-18','12:50:00',1.53),('12374','2013-03-18','12:55:00',1.81),('12374','2013-03-18','13:00:00',3.11),('12374','2013-03-18','13:05:00',2.69),('12374','2013-03-18','13:10:00',2.16),('12374','2013-03-18','13:15:00',1.89),('12374','2013-03-18','13:20:00',1.64),('12374','2013-03-18','13:25:00',1.77),('12374','2013-03-18','13:30:00',1.33),('12374','2013-03-18','13:35:00',1.02),('12374','2013-03-18','13:40:00',1.35),('12374','2013-03-18','13:45:00',2.16),('12374','2013-03-18','13:50:00',5.2),('12374','2013-03-18','13:55:00',6.17),('12374','2013-03-18','14:00:00',2.03),('12374','2013-03-18','14:05:00',1.6),('12374','2013-03-18','14:10:00',1.1),('12374','2013-03-17','08:00:00',1.23),('12374','2013-03-17','08:05:00',1.64),('12374','2013-03-17','08:10:00',1.69),('12374','2013-03-17','08:15:00',1.61),('12374','2013-03-17','08:20:00',1.76),('12374','2013-03-17','08:25:00',2.15),('12374','2013-03-17','08:30:00',2.52),('12374','2013-03-17','08:35:00',3.08),('12374','2013-03-17','08:40:00',2.81),('12374','2013-03-17','08:45:00',2.77),('12374','2013-03-17','08:50:00',3.17),('12374','2013-03-17','08:55:00',3.04),('12374','2013-03-17','09:00:00',2.93),('12374','2013-03-17','09:05:00',3.43),('12374','2013-03-17','09:10:00',3.2),('12374','2013-03-17','09:15:00',2.58),('12374','2013-03-17','09:20:00',2.98),('12374','2013-03-17','09:25:00',3.24),('12374','2013-03-17','09:30:00',3.5),('12374','2013-03-17','09:35:00',3.28),('12374','2013-03-17','09:40:00',3.02),('12374','2013-03-17','09:45:00',2.67),('12374','2013-03-17','09:50:00',2.38),('12374','2013-03-17','09:55:00',2.28),('12374','2013-03-17','10:00:00',2.51),('12374','2013-03-17','10:05:00',2.74),('12374','2013-03-17','10:10:00',2.91),('12374','2013-03-17','10:15:00',3.2),('12374','2013-03-17','10:20:00',3.47),('12374','2013-03-17','10:25:00',3.63),('12374','2013-03-17','10:30:00',3.29),('12374','2013-03-17','10:35:00',3.01),('12374','2013-03-17','10:40:00',2.89),('12374','2013-03-17','10:45:00',2.66),('12374','2013-03-17','10:50:00',2.49),('12374','2013-03-17','10:55:00',2.62),('12374','2013-03-17','11:00:00',3.12),('12374','2013-03-17','11:05:00',3.56),('12374','2013-03-17','11:10:00',3.95),('12374','2013-03-17','11:15:00',4.33),('12374','2013-03-17','11:20:00',4.25),('12374','2013-03-17','11:25:00',4.01),('12374','2013-03-17','11:30:00',3.92),('12374','2013-03-17','11:35:00',3.68),('12374','2013-03-17','11:40:00',3.53),('12374','2013-03-17','11:45:00',2.8),('12374','2013-03-17','11:50:00',3.27),('12374','2013-03-17','11:55:00',3.58),('12374','2013-03-17','12:00:00',3.8),('12374','2013-03-17','12:05:00',4.86),('12374','2013-03-17','12:10:00',5.2),('12374','2013-03-17','12:15:00',4.88),('12374','2013-03-17','12:20:00',4.57),('12374','2013-03-17','12:25:00',5.15),('12374','2013-03-17','12:30:00',5.39),('12374','2013-03-17','12:35:00',4.73),('12374','2013-03-17','12:40:00',4.06),('12374','2013-03-17','12:45:00',3.52),('12374','2013-03-17','12:50:00',3.26),('12374','2013-03-17','12:55:00',3.11),('12374','2013-03-17','13:00:00',2.68),('12374','2013-03-17','13:05:00',2.84),('12374','2013-03-17','13:10:00',2.9),('12374','2013-03-17','13:15:00',2.74),('12374','2013-03-17','13:20:00',2.03),('12374','2013-03-17','13:25:00',2.09),('12374','2013-03-17','13:30:00',1.75),('12374','2013-03-17','13:35:00',1.82),('12374','2013-03-17','13:40:00',2.63),('12374','2013-03-17','13:45:00',2.74),('12374','2013-03-17','13:50:00',2.87),('12374','2013-03-17','13:55:00',3.13),('12374','2013-03-17','14:00:00',3.06),('12374','2013-03-17','14:05:00',2.79),('12374','2013-03-17','14:10:00',3.14),('12374','2013-03-17','14:15:00',4.07),('12374','2013-03-17','14:20:00',4.37),('12374','2013-03-17','14:25:00',4.2),('12374','2013-03-17','14:30:00',3.58),('12374','2013-03-17','14:35:00',2.92),('12374','2013-03-17','14:40:00',3.07),('12374','2013-03-17','14:45:00',3.53),('12374','2013-03-17','14:50:00',3.7),('12374','2013-03-17','14:55:00',3.63),('12374','2013-03-17','15:00:00',3.02),('12374','2013-03-17','15:05:00',3.46),('12374','2013-03-17','15:10:00',3.62),('12374','2013-03-17','15:15:00',3.04),('12374','2013-03-17','15:20:00',2.55),('12374','2013-03-17','15:25:00',2.27),('12374','2013-03-17','15:30:00',2.25),('12374','2013-03-17','15:35:00',1.85),('12374','2013-03-17','16:30:00',1.41),('12374','2013-03-17','16:35:00',1.1),('12374','2013-03-16','07:20:00',1.14),('12374','2013-03-16','07:25:00',1.47),('12374','2013-03-16','07:30:00',1.76),('12374','2013-03-16','07:35:00',1.45),('12374','2013-03-16','07:40:00',1.49),('12374','2013-03-16','07:45:00',1.6),('12374','2013-03-16','07:50:00',1.67),('12374','2013-03-16','07:55:00',1.82),('12374','2013-03-16','08:00:00',2.01),('12374','2013-03-16','08:05:00',3.18),('12374','2013-03-16','08:10:00',2.73),('12374','2013-03-16','08:15:00',2.24),('12374','2013-03-16','08:20:00',5.25),('12374','2013-03-16','08:25:00',5.06),('12374','2013-03-16','08:30:00',5.13),('12374','2013-03-16','08:35:00',5.27),('12374','2013-03-16','08:40:00',5.38),('12374','2013-03-16','08:45:00',5.48),('12374','2013-03-16','08:50:00',5.63),('12374','2013-03-16','08:55:00',5.77),('12374','2013-03-16','09:00:00',5.92),('12374','2013-03-16','09:05:00',6.1),('12374','2013-03-16','09:10:00',5.49),('12374','2013-03-16','09:15:00',6.51),('12374','2013-03-16','09:20:00',3.16),('12374','2013-03-16','09:25:00',4.89),('12374','2013-03-16','09:30:00',2.52),('12374','2013-03-16','09:35:00',3.31),('12374','2013-03-16','09:40:00',7.17),('12374','2013-03-16','09:45:00',7.34),('12374','2013-03-16','09:50:00',7.45),('12374','2013-03-16','09:55:00',7.51),('12374','2013-03-16','10:00:00',7.59),('12374','2013-03-16','10:05:00',7.7),('12374','2013-03-16','10:10:00',7.79),('12374','2013-03-16','10:15:00',7.92),('12374','2013-03-16','10:20:00',7.97),('12374','2013-03-16','10:25:00',8.1),('12374','2013-03-16','10:30:00',8.19),('12374','2013-03-16','10:35:00',8.25),('12374','2013-03-16','10:40:00',8.39),('12374','2013-03-16','10:45:00',8.45),('12374','2013-03-16','10:50:00',8.53),('12374','2013-03-16','10:55:00',8.65),('12374','2013-03-16','11:00:00',8.69),('12374','2013-03-16','11:05:00',8.77),('12374','2013-03-16','11:10:00',8.8),('12374','2013-03-16','11:15:00',8.91),('12374','2013-03-16','11:20:00',8.94),('12374','2013-03-16','11:25:00',8.95),('12374','2013-03-16','11:30:00',9.09),('12374','2013-03-16','11:35:00',9.21),('12374','2013-03-16','11:40:00',9.2),('12374','2013-03-16','11:45:00',9.18),('12374','2013-03-16','11:50:00',9.22),('12374','2013-03-16','11:55:00',9.21),('12374','2013-03-16','12:00:00',9.28),('12374','2013-03-16','12:05:00',9.34),('12374','2013-03-16','12:10:00',9.38),('12374','2013-03-16','12:15:00',9.37),('12374','2013-03-16','12:20:00',9.45),('12374','2013-03-16','12:25:00',9.55),('12374','2013-03-16','12:30:00',9.78),('12374','2013-03-16','12:35:00',9.7),('12374','2013-03-16','12:40:00',8.99),('12374','2013-03-16','12:45:00',9.58),('12374','2013-03-16','12:50:00',9.2),('12374','2013-03-16','12:55:00',9.4),('12374','2013-03-16','13:00:00',9.34),('12374','2013-03-16','13:05:00',9.55),('12374','2013-03-16','13:10:00',9.69),('12374','2013-03-16','13:15:00',7.11),('12374','2013-03-16','13:20:00',8.69),('12374','2013-03-16','13:25:00',3.81),('12374','2013-03-16','13:30:00',7.06),('12374','2013-03-16','13:35:00',8.03),('12374','2013-03-16','13:40:00',9.39),('12374','2013-03-16','13:45:00',9.53),('12374','2013-03-16','13:50:00',8.63),('12374','2013-03-16','13:55:00',8.81),('12374','2013-03-16','14:00:00',7.88),('12374','2013-03-16','14:05:00',8.55),('12374','2013-03-16','14:10:00',8.24),('12374','2013-03-16','14:15:00',7.91),('12374','2013-03-16','14:20:00',7.82),('12374','2013-03-16','14:25:00',7.75),('12374','2013-03-16','14:30:00',7.73),('12374','2013-03-16','14:35:00',7.66),('12374','2013-03-16','14:40:00',7.53),('12374','2013-03-16','14:45:00',7.52),('12374','2013-03-16','14:50:00',7.3),('12374','2013-03-16','14:55:00',6.96),('12374','2013-03-16','15:00:00',6.66),('12374','2013-03-16','15:05:00',6.44),('12374','2013-03-16','15:10:00',6.28),('12374','2013-03-16','15:15:00',6.13),('12374','2013-03-16','15:20:00',5.95),('12374','2013-03-16','15:25:00',5.81),('12374','2013-03-16','15:30:00',5.59),('12374','2013-03-16','15:35:00',5.48),('12374','2013-03-16','15:40:00',5.29),('12374','2013-03-16','15:45:00',5.1),('12374','2013-03-16','15:50:00',4.95),('12374','2013-03-16','15:55:00',4.79),('12374','2013-03-16','16:00:00',4.6),('12374','2013-03-16','16:05:00',4.44),('12374','2013-03-16','16:10:00',4.22),('12374','2013-03-16','16:15:00',4.09),('12374','2013-03-16','16:20:00',3.94),('12374','2013-03-16','16:25:00',3.73),('12374','2013-03-16','16:30:00',3.47),('12374','2013-03-16','16:35:00',3.19),('12374','2013-03-16','16:40:00',2.79),('12374','2013-03-16','16:45:00',2.51),('12374','2013-03-16','16:50:00',2.15),('12374','2013-03-16','16:55:00',1.73),('12374','2013-03-16','17:00:00',1.42),('12374','2013-03-16','17:05:00',1.2),('12374','2013-03-16','17:10:00',1.05),('12374','2013-03-15','07:50:00',1.09),('12374','2013-03-15','07:55:00',1.16),('12374','2013-03-15','08:00:00',1.36),('12374','2013-03-15','08:05:00',1.35),('12374','2013-03-15','08:10:00',1.21),('12374','2013-03-15','08:15:00',1.26),('12374','2013-03-15','08:20:00',1.37),('12374','2013-03-15','08:25:00',1.2),('12374','2013-03-15','08:30:00',1.35),('12374','2013-03-15','08:35:00',1.44),('12374','2013-03-15','08:40:00',1.37),('12374','2013-03-15','08:45:00',1.39),('12374','2013-03-15','08:50:00',1.49),('12374','2013-03-15','08:55:00',1.57),('12374','2013-03-15','09:00:00',1.5),('12374','2013-03-15','09:05:00',1.36),('12374','2013-03-15','09:10:00',1.07),('12374','2013-03-15','09:15:00',1.01),('12374','2013-03-15','09:20:00',1.12),('12374','2013-03-15','09:25:00',1.25),('12374','2013-03-15','09:30:00',1.41),('12374','2013-03-15','09:35:00',1.55),('12374','2013-03-15','09:40:00',1.58),('12374','2013-03-15','09:45:00',1.51),('12374','2013-03-15','09:50:00',1.51),('12374','2013-03-15','09:55:00',1.55),('12374','2013-03-15','10:00:00',1.49),('12374','2013-03-15','10:05:00',1.45),('12374','2013-03-15','10:10:00',1.42),('12374','2013-03-15','10:15:00',1.36),('12374','2013-03-15','10:20:00',1.47),('12374','2013-03-15','10:25:00',1.7),('12374','2013-03-15','10:30:00',1.84),('12374','2013-03-15','10:35:00',2.1),('12374','2013-03-15','10:40:00',2.74),('12374','2013-03-15','10:45:00',3.29),('12374','2013-03-15','10:50:00',2.95),('12374','2013-03-15','10:55:00',2.67),('12374','2013-03-15','11:00:00',2.52),('12374','2013-03-15','11:05:00',2.67),('12374','2013-03-15','11:10:00',3.1),('12374','2013-03-15','11:15:00',3.3),('12374','2013-03-15','11:20:00',3.19),('12374','2013-03-15','11:25:00',3.43),('12374','2013-03-15','11:30:00',3.76),('12374','2013-03-15','11:35:00',3.89),('12374','2013-03-15','11:40:00',3.94),('12374','2013-03-15','11:45:00',4.06),('12374','2013-03-15','11:50:00',4.33),('12374','2013-03-15','11:55:00',3.86),('12374','2013-03-15','12:00:00',3.39),('12374','2013-03-15','12:05:00',3.37),('12374','2013-03-15','12:10:00',3.69),('12374','2013-03-15','12:15:00',4.56),('12374','2013-03-15','12:20:00',4.4),('12374','2013-03-15','12:25:00',4.21),('12374','2013-03-15','12:30:00',4.67),('12374','2013-03-15','12:35:00',4.5),('12374','2013-03-15','12:40:00',3.71),('12374','2013-03-15','12:45:00',4.1),('12374','2013-03-15','12:50:00',3.79),('12374','2013-03-15','12:55:00',4.39),('12374','2013-03-15','13:00:00',4.49),('12374','2013-03-15','13:05:00',4.19),('12374','2013-03-15','13:10:00',4.09),('12374','2013-03-15','13:15:00',3.19),('12374','2013-03-15','13:20:00',2.57),('12374','2013-03-15','13:25:00',2.15),('12374','2013-03-15','13:30:00',2.04),('12374','2013-03-15','13:35:00',2.12),('12374','2013-03-15','13:40:00',2.66),('12374','2013-03-15','13:45:00',3.73),('12374','2013-03-15','13:50:00',5.15),('12374','2013-03-15','13:55:00',3.61),('12374','2013-03-15','14:00:00',3.11),('12374','2013-03-15','14:05:00',3.06),('12374','2013-03-15','14:10:00',2.84),('12374','2013-03-15','14:15:00',2.92),('12374','2013-03-15','14:20:00',3.29),('12374','2013-03-15','14:25:00',3.55),('12374','2013-03-15','14:30:00',4.12),('12374','2013-03-15','14:35:00',4.89),('12374','2013-03-15','14:40:00',4.65),('12374','2013-03-15','14:45:00',4),('12374','2013-03-15','14:50:00',3.79),('12374','2013-03-15','14:55:00',3.42),('12374','2013-03-15','15:00:00',2.77),('12374','2013-03-15','15:05:00',2.05),('12374','2013-03-15','15:10:00',2.95),('12374','2013-03-15','15:15:00',2.76),('12374','2013-03-15','15:20:00',2.59),('12374','2013-03-15','15:25:00',2.17),('12374','2013-03-15','15:30:00',2.07),('12374','2013-03-15','15:35:00',1.81),('12374','2013-03-15','15:40:00',1.16),('12374','2013-03-15','15:45:00',1.19),('12374','2013-03-15','15:50:00',1.31),('12374','2013-03-15','16:35:00',1.23),('12374','2013-03-15','16:40:00',2.27),('12374','2013-03-15','16:45:00',2.57),('12374','2013-03-15','16:50:00',2.51),('12374','2013-03-15','16:55:00',1.77),('12374','2013-03-15','17:00:00',1.43),('12374','2013-03-15','17:05:00',1.08),('12374','2013-03-15','17:10:00',1.21),('12374','2013-03-15','17:15:00',1.13),('12374','2013-03-14','07:10:00',1.11),('12374','2013-03-14','07:15:00',1.17),('12374','2013-03-14','07:20:00',1.04),('12374','2013-03-14','07:25:00',1.05),('12374','2013-03-14','07:30:00',1.05),('12374','2013-03-14','07:35:00',1),('12374','2013-03-14','10:30:00',1.06),('12374','2013-03-14','10:35:00',1.12),('12374','2013-03-14','10:40:00',1.26),('12374','2013-03-14','10:45:00',1.45),('12374','2013-03-14','10:50:00',1.44),('12374','2013-03-14','10:55:00',1.47),('12374','2013-03-14','11:00:00',1.5),('12374','2013-03-14','11:05:00',1.55),('12374','2013-03-14','11:10:00',1.46),('12374','2013-03-14','11:15:00',1.53),('12374','2013-03-14','11:20:00',1.62),('12374','2013-03-14','11:25:00',1.97),('12374','2013-03-14','11:30:00',2.36),('12374','2013-03-14','11:35:00',2.31),('12374','2013-03-14','11:40:00',2.28),('12374','2013-03-14','11:45:00',2.17),('12374','2013-03-14','11:50:00',1.47),('12374','2013-03-14','11:55:00',2.34),('12374','2013-03-14','12:00:00',2.33),('12374','2013-03-14','12:05:00',2.09),('12374','2013-03-14','12:10:00',1.8),('12374','2013-03-14','12:15:00',1.62),('12374','2013-03-14','12:20:00',1.18),('12374','2013-03-14','12:40:00',1.14),('12374','2013-03-14','12:45:00',1.43),('12374','2013-03-14','12:50:00',1.69),('12374','2013-03-14','12:55:00',2.53),('12374','2013-03-14','13:00:00',3.14),('12374','2013-03-14','13:05:00',3.71),('12374','2013-03-14','13:10:00',4.67),('12374','2013-03-14','13:15:00',4.8),('12374','2013-03-14','13:20:00',2.59),('12374','2013-03-14','13:25:00',1.64),('12374','2013-03-14','13:30:00',1.37),('12374','2013-03-14','13:35:00',1.1),('12374','2013-03-14','13:45:00',1.1),('12374','2013-03-14','13:50:00',1.26),('12374','2013-03-14','13:55:00',1.14),('12374','2013-03-14','14:00:00',1.27),('12374','2013-03-14','14:05:00',1.39),('12374','2013-03-14','14:10:00',1.55),('12374','2013-03-14','14:15:00',1.98),('12374','2013-03-14','14:20:00',2.49),('12374','2013-03-14','14:25:00',2.24),('12374','2013-03-14','14:30:00',1.97),('12374','2013-03-14','14:35:00',1.47),('12374','2013-03-14','14:40:00',1.17),('12374','2013-03-14','15:25:00',1.2),('12374','2013-03-14','15:30:00',1.03),('12374','2013-03-14','15:50:00',1.47),('12374','2013-03-14','15:55:00',1.84),('12374','2013-03-14','16:00:00',1.82),('12374','2013-03-14','16:05:00',1.52),('12374','2013-03-14','16:10:00',1.09),('12374','2013-03-14','16:40:00',1.02),('12374','2013-03-14','16:55:00',1.27),('12374','2013-03-14','17:00:00',1.17),('12374','2013-03-14','17:05:00',1.01),('12374','2013-03-13','08:00:00',1.15),('12374','2013-03-13','08:05:00',1.29),('12374','2013-03-13','08:10:00',1.3),('12374','2013-03-13','08:15:00',1.14),('12374','2013-03-13','08:20:00',1.58),('12374','2013-03-13','08:25:00',1.7),('12374','2013-03-13','08:30:00',1.51),('12374','2013-03-13','08:35:00',1.21),('12374','2013-03-13','08:40:00',1.23),('12374','2013-03-13','08:45:00',1.16),('12374','2013-03-13','09:10:00',1.04),('12374','2013-03-13','09:15:00',2.03),('12374','2013-03-13','09:20:00',2.57),('12374','2013-03-13','09:25:00',2.49),('12374','2013-03-13','09:30:00',3.46),('12374','2013-03-13','09:35:00',5.3),('12374','2013-03-13','09:40:00',5.13),('12374','2013-03-13','09:45:00',5.62),('12374','2013-03-13','09:50:00',5.38),('12374','2013-03-13','09:55:00',5.6),('12374','2013-03-13','10:00:00',5.43),('12374','2013-03-13','10:05:00',5.76),('12374','2013-03-13','10:10:00',7.22),('12374','2013-03-13','10:15:00',7.52),('12374','2013-03-13','10:20:00',6.8),('12374','2013-03-13','10:25:00',7.6),('12374','2013-03-13','10:30:00',6.87),('12374','2013-03-13','10:35:00',6.37),('12374','2013-03-13','10:40:00',6.44),('12374','2013-03-13','10:45:00',6.17),('12374','2013-03-13','10:50:00',4.56),('12374','2013-03-13','10:55:00',4.42),('12374','2013-03-13','11:00:00',4.33),('12374','2013-03-13','11:05:00',4.22),('12374','2013-03-13','11:10:00',4.89),('12374','2013-03-13','11:15:00',4.19),('12374','2013-03-13','11:20:00',3.37),('12374','2013-03-13','11:25:00',2.65),('12374','2013-03-13','11:30:00',1.81),('12374','2013-03-13','11:35:00',1.9),('12374','2013-03-13','11:40:00',1.39),('12374','2013-03-13','11:45:00',1.47),('12374','2013-03-13','11:50:00',2.24),('12374','2013-03-13','11:55:00',2.71),('12374','2013-03-13','12:00:00',2.12),('12374','2013-03-13','12:05:00',1.47),('12374','2013-03-13','12:20:00',1.64),('12374','2013-03-13','12:25:00',2.04),('12374','2013-03-13','12:30:00',2.46),('12374','2013-03-13','12:35:00',2.32),('12374','2013-03-13','12:40:00',1.85),('12374','2013-03-13','12:45:00',1.94),('12374','2013-03-13','12:50:00',2.07),('12374','2013-03-13','12:55:00',1.96),('12374','2013-03-13','13:00:00',1.78),('12374','2013-03-13','13:05:00',1.8),('12374','2013-03-13','13:10:00',1.82),('12374','2013-03-13','13:15:00',1.84),('12374','2013-03-13','13:20:00',1.82),('12374','2013-03-13','13:25:00',1.72),('12374','2013-03-13','13:30:00',1.8),('12374','2013-03-13','13:35:00',2.1),('12374','2013-03-13','13:40:00',2.03),('12374','2013-03-13','13:45:00',1.58),('12374','2013-03-13','13:50:00',1.18),('12374','2013-03-12','07:30:00',1.03),('12374','2013-03-12','07:35:00',2.35),('12374','2013-03-12','07:40:00',2.77),('12374','2013-03-12','07:45:00',2.89),('12374','2013-03-12','07:50:00',3.17),('12374','2013-03-12','07:55:00',3.17),('12374','2013-03-12','08:00:00',3.76),('12374','2013-03-12','08:05:00',3.45),('12374','2013-03-12','08:10:00',3.69),('12374','2013-03-12','08:15:00',3.51),('12374','2013-03-12','08:20:00',3.91),('12374','2013-03-12','08:25:00',4.09),('12374','2013-03-12','08:30:00',4.18),('12374','2013-03-12','08:35:00',4.8),('12374','2013-03-12','08:40:00',4.93),('12374','2013-03-12','08:45:00',5.08),('12374','2013-03-12','08:50:00',5.25),('12374','2013-03-12','08:55:00',5.41),('12374','2013-03-12','09:00:00',5.56),('12374','2013-03-12','09:05:00',5.69),('12374','2013-03-12','09:10:00',5.84),('12374','2013-03-12','09:15:00',5.98),('12374','2013-03-12','09:20:00',6.11),('12374','2013-03-12','09:25:00',6.24),('12374','2013-03-12','09:30:00',6.41),('12374','2013-03-12','09:35:00',6.57),('12374','2013-03-12','09:40:00',6.7),('12374','2013-03-12','09:45:00',6.83),('12374','2013-03-12','09:50:00',6.95),('12374','2013-03-12','09:55:00',7.06),('12374','2013-03-12','10:00:00',7.16),('12374','2013-03-12','10:05:00',7.31),('12374','2013-03-12','10:10:00',7.41),('12374','2013-03-12','10:15:00',7.57),('12374','2013-03-12','10:20:00',7.67),('12374','2013-03-12','10:25:00',7.77),('12374','2013-03-12','10:30:00',7.9),('12374','2013-03-12','10:35:00',8.01),('12374','2013-03-12','10:40:00',8.11),('12374','2013-03-12','10:45:00',8.29),('12374','2013-03-12','10:50:00',8.46),('12374','2013-03-12','10:55:00',7.48),('12374','2013-03-12','11:00:00',5.88),('12374','2013-03-12','11:05:00',8.57),('12374','2013-03-12','11:10:00',5.49),('12374','2013-03-12','11:15:00',4.62),('12374','2013-03-12','11:20:00',5.8),('12374','2013-03-12','11:25:00',2.89),('12374','2013-03-12','11:30:00',1.47),('12374','2013-03-12','11:40:00',1.19),('12374','2013-03-12','11:45:00',2.58),('12374','2013-03-12','11:55:00',1.21),('12374','2013-03-12','12:05:00',1.49),('12374','2013-03-12','12:10:00',4.21),('12374','2013-03-12','12:15:00',9.79),('12374','2013-03-12','12:20:00',9.41),('12374','2013-03-12','12:25:00',9.18),('12374','2013-03-12','12:30:00',9.25),('12374','2013-03-12','12:35:00',9.4),('12374','2013-03-12','12:40:00',8.92),('12374','2013-03-12','12:45:00',9.36),('12374','2013-03-12','12:50:00',8.99),('12374','2013-03-12','12:55:00',8.61),('12374','2013-03-12','13:00:00',6.16),('12374','2013-03-12','13:05:00',3.21),('12374','2013-03-12','13:10:00',3.98),('12374','2013-03-12','13:15:00',6.88),('12374','2013-03-12','13:20:00',6.83),('12374','2013-03-12','13:25:00',7.62),('12374','2013-03-12','13:30:00',8.1),('12374','2013-03-12','13:35:00',6.76),('12374','2013-03-12','13:40:00',5.44),('12374','2013-03-12','13:45:00',4.8),('12374','2013-03-12','13:50:00',4.18),('12374','2013-03-12','13:55:00',6.19),('12374','2013-03-12','14:00:00',9.71),('12374','2013-03-12','14:05:00',6.59),('12374','2013-03-12','14:10:00',2.88),('12374','2013-03-12','14:15:00',3.07),('12374','2013-03-12','14:20:00',3.29),('12374','2013-03-12','14:25:00',2.14),('12374','2013-03-12','14:30:00',1.5),('12374','2013-03-12','14:45:00',4.46),('12374','2013-03-12','14:50:00',4.56),('12374','2013-03-12','14:55:00',3.05),('12374','2013-03-12','15:00:00',2.55),('12374','2013-03-12','15:05:00',2.47),('12374','2013-03-12','15:10:00',2.75),('12374','2013-03-12','15:15:00',4.95),('12374','2013-03-12','15:20:00',3.84),('12374','2013-03-12','15:25:00',2.89),('12374','2013-03-12','15:30:00',2.68),('12374','2013-03-12','15:35:00',3.04),('12374','2013-03-12','15:40:00',2.27),('12374','2013-03-12','15:45:00',2.48),('12374','2013-03-12','15:50:00',2.46),('12374','2013-03-12','15:55:00',2.69),('12374','2013-03-12','16:00:00',4.6),('12374','2013-03-12','16:05:00',1.86),('12374','2013-03-12','16:10:00',1.74),('12374','2013-03-12','16:15:00',3.35),('12374','2013-03-12','16:20:00',2.02),('12374','2013-03-12','16:25:00',1.32),('12374','2013-03-12','16:30:00',1.4),('12374','2013-03-12','16:35:00',1.35),('12374','2013-03-12','16:40:00',1.01),('12374','2013-03-11','07:05:00',1.09),('12374','2013-03-11','07:10:00',1.25),('12374','2013-03-11','07:15:00',1.52),('12374','2013-03-11','07:20:00',1.66),('12374','2013-03-11','07:25:00',1.64),('12374','2013-03-11','07:30:00',1.58),('12374','2013-03-11','07:35:00',1.31),('12374','2013-03-11','07:45:00',1.05),('12374','2013-03-11','07:50:00',1.18),('12374','2013-03-11','07:55:00',1.48),('12374','2013-03-11','08:00:00',1.45),('12374','2013-03-11','08:05:00',1.17),('12374','2013-03-11','08:10:00',3.97),('12374','2013-03-11','08:15:00',4.75),('12374','2013-03-11','08:20:00',2.21),('12374','2013-03-11','08:25:00',2.18),('12374','2013-03-11','08:30:00',1.63),('12374','2013-03-11','08:35:00',1.83),('12374','2013-03-11','08:40:00',3.43),('12374','2013-03-11','08:45:00',3.61),('12374','2013-03-11','08:50:00',4.12),('12374','2013-03-11','08:55:00',5.55),('12374','2013-03-11','09:00:00',5.68),('12374','2013-03-11','09:05:00',5.83),('12374','2013-03-11','09:10:00',5.91),('12374','2013-03-11','09:15:00',5.78),('12374','2013-03-11','09:20:00',6.35),('12374','2013-03-11','09:25:00',6.61),('12374','2013-03-11','09:30:00',6.81),('12374','2013-03-11','09:35:00',6.91),('12374','2013-03-11','09:40:00',6.34),('12374','2013-03-11','09:45:00',7.08),('12374','2013-03-11','09:50:00',7.13),('12374','2013-03-11','09:55:00',7.45),('12374','2013-03-11','10:00:00',5.7),('12374','2013-03-11','10:05:00',4.52),('12374','2013-03-11','10:10:00',3.93),('12374','2013-03-11','10:15:00',6.85),('12374','2013-03-11','10:20:00',7.85),('12374','2013-03-11','10:25:00',7.89),('12374','2013-03-11','10:30:00',7.94),('12374','2013-03-11','10:35:00',8.32),('12374','2013-03-11','10:40:00',8.9),('12374','2013-03-11','10:45:00',8.04),('12374','2013-03-11','10:50:00',5.39),('12374','2013-03-11','10:55:00',7.56),('12374','2013-03-11','11:00:00',4.65),('12374','2013-03-11','11:05:00',5.64),('12374','2013-03-11','11:10:00',5.48),('12374','2013-03-11','11:15:00',3.76),('12374','2013-03-11','11:20:00',3.63),('12374','2013-03-11','11:25:00',4.77),('12374','2013-03-11','11:30:00',4.19),('12374','2013-03-11','11:35:00',5.2),('12374','2013-03-11','11:40:00',4.55),('12374','2013-03-11','11:45:00',4.12),('12374','2013-03-11','11:50:00',3.84),('12374','2013-03-11','11:55:00',3.87),('12374','2013-03-11','12:00:00',4.08),('12374','2013-03-11','12:05:00',5.52),('12374','2013-03-11','12:10:00',4.65),('12374','2013-03-11','12:15:00',6.59),('12374','2013-03-11','12:20:00',7),('12374','2013-03-11','12:25:00',7.36),('12374','2013-03-11','12:30:00',8.63),('12374','2013-03-11','12:35:00',7.31),('12374','2013-03-11','12:40:00',8.99),('12374','2013-03-11','12:45:00',9.18),('12374','2013-03-11','12:50:00',8.78),('12374','2013-03-11','12:55:00',8.92),('12374','2013-03-11','13:00:00',8.79),('12374','2013-03-11','13:05:00',9.18),('12374','2013-03-11','13:10:00',8.78),('12374','2013-03-11','13:15:00',8.58),('12374','2013-03-11','13:20:00',8.56),('12374','2013-03-11','13:25:00',8.45),('12374','2013-03-11','13:30:00',8.44),('12374','2013-03-11','13:35:00',8.84),('12374','2013-03-11','13:40:00',5.96),('12374','2013-03-11','13:45:00',5.7),('12374','2013-03-11','13:50:00',6.21),('12374','2013-03-11','13:55:00',8.28),('12374','2013-03-11','14:00:00',7.81),('12374','2013-03-11','14:05:00',7.83),('12374','2013-03-11','14:10:00',6.93),('12374','2013-03-11','14:15:00',6),('12374','2013-03-11','14:20:00',3.95),('12374','2013-03-11','14:25:00',3.85),('12374','2013-03-11','14:30:00',3.68),('12374','2013-03-11','14:35:00',3.04),('12374','2013-03-11','14:40:00',4.48),('12374','2013-03-11','14:45:00',2.69),('12374','2013-03-11','14:50:00',2.53),('12374','2013-03-11','14:55:00',2.42),('12374','2013-03-11','15:00:00',2.51),('12374','2013-03-11','15:05:00',2.54),('12374','2013-03-11','15:10:00',2.59),('12374','2013-03-11','15:15:00',2.34),('12374','2013-03-11','15:20:00',3),('12374','2013-03-11','15:25:00',4.49),('12374','2013-03-11','15:30:00',4.16),('12374','2013-03-11','15:35:00',5.72),('12374','2013-03-11','15:40:00',4.51),('12374','2013-03-11','15:45:00',5.09),('12374','2013-03-11','15:50:00',4.63),('12374','2013-03-11','15:55:00',3.46),('12374','2013-03-11','16:00:00',1.57),('12374','2013-03-11','16:05:00',1.36),('12374','2013-03-11','16:10:00',2.01),('12374','2013-03-11','16:15:00',2.74),('12374','2013-03-11','16:20:00',1.36),('12374','2013-03-11','16:25:00',1.16),('12374','2013-03-11','16:30:00',1.3),('12374','2013-03-11','16:35:00',1.25),('12374','2013-03-11','16:40:00',1.27),('12374','2013-03-11','16:45:00',2.33),('12374','2013-03-11','16:50:00',1.98),('12374','2013-03-11','16:55:00',1.71),('12374','2013-03-11','17:00:00',1.49),('12374','2013-03-11','17:05:00',1.06),('12374','2013-03-10','07:05:00',1.24),('12374','2013-03-10','07:10:00',1.42),('12374','2013-03-10','07:15:00',1.76),('12374','2013-03-10','07:20:00',1.7),('12374','2013-03-10','07:25:00',2.08),('12374','2013-03-10','07:30:00',2.03),('12374','2013-03-10','07:35:00',2.19),('12374','2013-03-10','07:40:00',2.55),('12374','2013-03-10','07:45:00',2.89),('12374','2013-03-10','07:50:00',2.91),('12374','2013-03-10','07:55:00',2.95),('12374','2013-03-10','08:00:00',3.45),('12374','2013-03-10','08:05:00',3.65),('12374','2013-03-10','08:10:00',3.85),('12374','2013-03-10','08:15:00',4),('12374','2013-03-10','08:20:00',4.16),('12374','2013-03-10','08:25:00',4.33),('12374','2013-03-10','08:30:00',4.51),('12374','2013-03-10','08:35:00',4.5),('12374','2013-03-10','08:40:00',4.61),('12374','2013-03-10','08:45:00',4.68),('12374','2013-03-10','08:50:00',2.93),('12374','2013-03-10','08:55:00',5.93),('12374','2013-03-10','09:00:00',5.85),('12374','2013-03-10','09:05:00',5.83),('12374','2013-03-10','09:10:00',5.89),('12374','2013-03-10','09:15:00',6.05),('12374','2013-03-10','09:20:00',6.3),('12374','2013-03-10','09:25:00',6.32),('12374','2013-03-10','09:30:00',6.12),('12374','2013-03-10','09:35:00',6.52),('12374','2013-03-10','09:40:00',6.62),('12374','2013-03-10','09:45:00',6.76),('12374','2013-03-10','09:50:00',6.87),('12374','2013-03-10','09:55:00',6.9),('12374','2013-03-10','10:00:00',7.09),('12374','2013-03-10','10:05:00',7.21),('12374','2013-03-10','10:10:00',7.32),('12374','2013-03-10','10:15:00',7.45),('12374','2013-03-10','10:20:00',7.57),('12374','2013-03-10','10:25:00',7.65),('12374','2013-03-10','10:30:00',7.73),('12374','2013-03-10','10:35:00',7.81),('12374','2013-03-10','10:40:00',7.9),('12374','2013-03-10','10:45:00',8.05),('12374','2013-03-10','10:50:00',8.13),('12374','2013-03-10','10:55:00',8.17),('12374','2013-03-10','11:00:00',8.28),('12374','2013-03-10','11:05:00',8.35),('12374','2013-03-10','11:10:00',8.42),('12374','2013-03-10','11:15:00',8.41),('12374','2013-03-10','11:20:00',8.47),('12374','2013-03-10','11:25:00',8.57),('12374','2013-03-10','11:30:00',8.66),('12374','2013-03-10','11:35:00',8.77),('12374','2013-03-10','11:40:00',8.74),('12374','2013-03-10','11:45:00',8.81),('12374','2013-03-10','11:50:00',8.84),('12374','2013-03-10','11:55:00',8.88),('12374','2013-03-10','12:00:00',8.93),('12374','2013-03-10','12:05:00',8.92),('12374','2013-03-10','12:10:00',8.9),('12374','2013-03-10','12:15:00',8.89),('12374','2013-03-10','12:20:00',8.9),('12374','2013-03-10','12:25:00',8.92),('12374','2013-03-10','12:30:00',8.9),('12374','2013-03-10','12:35:00',8.92),('12374','2013-03-10','12:40:00',8.94),('12374','2013-03-10','12:45:00',8.95),('12374','2013-03-10','12:50:00',8.35),('12374','2013-03-10','12:55:00',8.68),('12374','2013-03-10','13:00:00',7.45),('12374','2013-03-10','13:05:00',6.95),('12374','2013-03-10','13:10:00',6.02),('12374','2013-03-10','13:15:00',4.9),('12374','2013-03-10','13:20:00',2.99),('12374','2013-03-10','13:25:00',4.03),('12374','2013-03-10','13:30:00',4.9),('12374','2013-03-10','13:35:00',4.24),('12374','2013-03-10','13:40:00',3.49),('12374','2013-03-10','13:45:00',2.37),('12374','2013-03-10','13:50:00',2.19),('12374','2013-03-10','13:55:00',1.92),('12374','2013-03-10','14:00:00',1.96),('12374','2013-03-10','14:05:00',2.5),('12374','2013-03-10','14:10:00',3.09),('12374','2013-03-10','14:15:00',2.81),('12374','2013-03-10','14:20:00',2.26),('12374','2013-03-10','14:25:00',3.02),('12374','2013-03-10','14:30:00',3.95),('12374','2013-03-10','14:35:00',3.59),('12374','2013-03-10','14:40:00',3.02),('12374','2013-03-10','14:45:00',2.45),('12374','2013-03-10','14:50:00',1.88),('12374','2013-03-10','14:55:00',1.49),('12374','2013-03-10','15:00:00',1.48),('12374','2013-03-10','15:05:00',1.32),('12374','2013-03-09','07:30:00',1.56),('12374','2013-03-09','07:35:00',2.19),('12374','2013-03-09','07:40:00',2.54),('12374','2013-03-09','07:45:00',2.81),('12374','2013-03-09','07:50:00',3),('12374','2013-03-09','07:55:00',2.69),('12374','2013-03-09','08:00:00',3.19),('12374','2013-03-09','08:05:00',3.67),('12374','2013-03-09','08:10:00',3.84),('12374','2013-03-09','08:15:00',2.92),('12374','2013-03-09','08:20:00',3.79),('12374','2013-03-09','08:25:00',4.33),('12374','2013-03-09','08:30:00',4.42),('12374','2013-03-09','08:35:00',4.66),('12374','2013-03-09','08:40:00',4.75),('12374','2013-03-09','08:45:00',4.9),('12374','2013-03-09','08:50:00',5.03),('12374','2013-03-09','08:55:00',5.21),('12374','2013-03-09','09:00:00',5.37),('12374','2013-03-09','09:05:00',5.54),('12374','2013-03-09','09:10:00',5.73),('12374','2013-03-09','09:15:00',5.87),('12374','2013-03-09','09:20:00',6.01),('12374','2013-03-09','09:25:00',6.15),('12374','2013-03-09','09:30:00',6.3),('12374','2013-03-09','09:35:00',6.46),('12374','2013-03-09','09:40:00',6.6),('12374','2013-03-09','09:45:00',6.67),('12374','2013-03-09','09:50:00',6.86),('12374','2013-03-09','09:55:00',7.02),('12374','2013-03-09','10:00:00',7.12),('12374','2013-03-09','10:05:00',7.23),('12374','2013-03-09','10:10:00',7.34),('12374','2013-03-09','10:15:00',7.43),('12374','2013-03-09','10:20:00',7.53),('12374','2013-03-09','10:25:00',7.65),('12374','2013-03-09','10:30:00',7.67),('12374','2013-03-09','10:35:00',7.81),('12374','2013-03-09','10:40:00',7.92),('12374','2013-03-09','10:45:00',8.03),('12374','2013-03-09','10:50:00',8.11),('12374','2013-03-09','10:55:00',8.2),('12374','2013-03-09','11:00:00',8.31),('12374','2013-03-09','11:05:00',8.4),('12374','2013-03-09','11:10:00',8.46),('12374','2013-03-09','11:15:00',8.5),('12374','2013-03-09','11:20:00',8.63),('12374','2013-03-09','11:25:00',8.68),('12374','2013-03-09','11:30:00',8.76),('12374','2013-03-09','11:35:00',8.76),('12374','2013-03-09','11:40:00',8.79),('12374','2013-03-09','11:45:00',8.84),('12374','2013-03-09','11:50:00',8.85),('12374','2013-03-09','11:55:00',8.9),('12374','2013-03-09','12:00:00',8.93),('12374','2013-03-09','12:05:00',8.94),('12374','2013-03-09','12:10:00',8.89),('12374','2013-03-09','12:15:00',7.65),('12374','2013-03-09','12:20:00',9.17),('12374','2013-03-09','12:25:00',8.06),('12374','2013-03-09','12:30:00',8.33),('12374','2013-03-09','12:35:00',9.14),('12374','2013-03-09','12:40:00',9.23),('12374','2013-03-09','12:45:00',8.04),('12374','2013-03-09','12:50:00',8.49),('12374','2013-03-09','12:55:00',8.72),('12374','2013-03-09','13:00:00',8.66),('12374','2013-03-09','13:05:00',7.94),('12374','2013-03-09','13:10:00',8),('12374','2013-03-09','13:15:00',4.63),('12374','2013-03-09','13:20:00',7.91),('12374','2013-03-09','13:25:00',8.05),('12374','2013-03-09','13:30:00',7.66),('12374','2013-03-09','13:35:00',7.81),('12374','2013-03-09','13:40:00',7.89),('12374','2013-03-09','13:45:00',7.81),('12374','2013-03-09','13:50:00',7.72),('12374','2013-03-09','13:55:00',7.65),('12374','2013-03-09','14:00:00',7.55),('12374','2013-03-09','14:05:00',7.43),('12374','2013-03-09','14:10:00',7.35),('12374','2013-03-09','14:15:00',7),('12374','2013-03-09','14:20:00',7.09),('12374','2013-03-09','14:25:00',6.98),('12374','2013-03-09','14:30:00',6.86),('12374','2013-03-09','14:35:00',6.76),('12374','2013-03-09','14:40:00',6.64),('12374','2013-03-09','14:45:00',6.53),('12374','2013-03-09','14:50:00',6.39),('12374','2013-03-09','14:55:00',6.22),('12374','2013-03-09','15:00:00',6.02),('12374','2013-03-09','15:05:00',5.88),('12374','2013-03-09','15:10:00',5.77),('12374','2013-03-09','15:15:00',5.62),('12374','2013-03-09','15:20:00',5.47),('12374','2013-03-09','15:25:00',5.33),('12374','2013-03-09','15:30:00',5.25),('12374','2013-03-09','15:35:00',5.11),('12374','2013-03-09','15:40:00',4.69),('12374','2013-03-09','15:45:00',4.25),('12374','2013-03-09','15:50:00',3.39),('12374','2013-03-09','15:55:00',3.47),('12374','2013-03-09','16:00:00',3.33),('12374','2013-03-09','16:05:00',2.09),('12374','2013-03-09','16:10:00',1.94),('12374','2013-03-09','16:15:00',1.14),('12374','2013-03-09','16:20:00',1.91),('12374','2013-03-09','16:25:00',1.96),('12374','2013-03-09','16:30:00',1.67),('12374','2013-03-09','16:35:00',1.65),('12374','2013-03-09','16:40:00',1.19),('12374','2013-03-09','16:45:00',1.17),('12374','2013-03-09','16:50:00',1.27),('12374','2013-03-08','08:10:00',1.21),('12374','2013-03-08','08:15:00',1.58),('12374','2013-03-08','08:20:00',1.17),('12374','2013-03-08','08:45:00',1.37),('12374','2013-03-08','08:50:00',2.01),('12374','2013-03-08','08:55:00',2.39),('12374','2013-03-08','09:00:00',2.17),('12374','2013-03-08','09:05:00',1.95),('12374','2013-03-08','09:10:00',1.94),('12374','2013-03-08','09:15:00',1.92),('12374','2013-03-08','09:20:00',1.64),('12374','2013-03-08','09:25:00',1.23),('12374','2013-03-08','09:30:00',1.85),('12374','2013-03-08','09:35:00',1.66),('12374','2013-03-08','09:40:00',1.9),('12374','2013-03-08','09:45:00',2.03),('12374','2013-03-08','09:50:00',1.6),('12374','2013-03-08','09:55:00',1.4),('12374','2013-03-08','10:00:00',1.45),('12374','2013-03-08','10:05:00',1.64),('12374','2013-03-08','10:10:00',3.21),('12374','2013-03-08','10:15:00',4.93),('12374','2013-03-08','10:20:00',2.73),('12374','2013-03-08','10:25:00',1.8),('12374','2013-03-08','10:30:00',1.16),('12374','2013-03-08','10:35:00',1.22),('12374','2013-03-08','10:40:00',1.54),('12374','2013-03-08','10:45:00',1.63),('12374','2013-03-08','11:05:00',1.33),('12374','2013-03-08','11:25:00',1.62),('12374','2013-03-08','11:30:00',2.09),('12374','2013-03-08','11:35:00',1.69),('12374','2013-03-08','11:40:00',1.54),('12374','2013-03-08','11:50:00',1.24),('12374','2013-03-08','11:55:00',1.37),('12374','2013-03-08','12:15:00',1.17),('12374','2013-03-08','12:20:00',1.55),('12374','2013-03-08','12:25:00',1.21),('12374','2013-03-08','12:30:00',1.56),('12374','2013-03-08','12:35:00',1.46),('12374','2013-03-08','12:40:00',1.18),('12374','2013-03-08','12:45:00',1.01),('12374','2013-03-08','13:15:00',1.38),('12374','2013-03-08','13:20:00',1.39),('12374','2013-03-08','13:25:00',1.51),('12374','2013-03-08','13:30:00',3.01),('12374','2013-03-08','13:35:00',1.97),('12374','2013-03-08','13:40:00',1.18),('12374','2013-03-07','08:35:00',1.5),('12374','2013-03-07','08:40:00',1.57),('12374','2013-03-07','08:45:00',2.38),('12374','2013-03-07','08:50:00',2.43),('12374','2013-03-07','08:55:00',1.65),('12374','2013-03-07','09:00:00',1.18),('12374','2013-03-07','09:30:00',1.26),('12374','2013-03-07','09:35:00',1.18),('12374','2013-03-07','09:40:00',1.55),('12374','2013-03-07','09:45:00',2.19),('12374','2013-03-07','09:50:00',2.34),('12374','2013-03-07','09:55:00',2.58),('12374','2013-03-07','10:00:00',2.64),('12374','2013-03-07','10:05:00',2.49),('12374','2013-03-07','10:10:00',2.13),('12374','2013-03-07','10:15:00',2.23),('12374','2013-03-07','10:20:00',2.05),('12374','2013-03-07','10:25:00',2.16),('12374','2013-03-07','10:30:00',3.3),('12374','2013-03-07','10:35:00',3.39),('12374','2013-03-07','10:40:00',1.91),('12374','2013-03-07','10:45:00',2.13),('12374','2013-03-07','10:50:00',2.45),('12374','2013-03-07','10:55:00',2.45),('12374','2013-03-07','11:00:00',3.12),('12374','2013-03-07','11:05:00',3.32),('12374','2013-03-07','11:10:00',3.4),('12374','2013-03-07','11:15:00',3.87),('12374','2013-03-07','11:20:00',4.51),('12374','2013-03-07','11:25:00',5),('12374','2013-03-07','11:30:00',6.82),('12374','2013-03-07','11:35:00',5.69),('12374','2013-03-07','11:40:00',6.5),('12374','2013-03-07','11:45:00',7.85),('12374','2013-03-07','11:50:00',7.42),('12374','2013-03-07','11:55:00',6.02),('12374','2013-03-07','12:00:00',5.41),('12374','2013-03-07','12:05:00',3.59),('12374','2013-03-07','12:10:00',2.69),('12374','2013-03-07','12:15:00',2.06),('12374','2013-03-07','12:20:00',2.47),('12374','2013-03-07','12:25:00',3.13),('12374','2013-03-07','12:30:00',3.5),('12374','2013-03-07','12:35:00',4.32),('12374','2013-03-07','12:40:00',5.11),('12374','2013-03-07','12:45:00',6.18),('12374','2013-03-07','12:50:00',5.48),('12374','2013-03-07','12:55:00',4.58),('12374','2013-03-07','13:00:00',3.65),('12374','2013-03-07','13:05:00',4.64),('12374','2013-03-07','13:10:00',3.97),('12374','2013-03-07','13:15:00',3.66),('12374','2013-03-07','13:20:00',3.27),('12374','2013-03-07','13:25:00',3.42),('12374','2013-03-07','13:30:00',3.8),('12374','2013-03-07','13:35:00',4.13),('12374','2013-03-07','13:40:00',3.41),('12374','2013-03-07','13:45:00',2.3),('12374','2013-03-07','13:50:00',1.73),('12374','2013-03-07','14:30:00',1.5),('12374','2013-03-07','14:35:00',1.63),('12374','2013-03-07','14:40:00',2.08),('12374','2013-03-07','14:45:00',1.88),('12374','2013-03-07','14:50:00',1.58),('12374','2013-03-07','14:55:00',1.68),('12374','2013-03-07','15:00:00',2.5),('12374','2013-03-07','15:05:00',2.73),('12374','2013-03-07','15:10:00',2.17),('12374','2013-03-07','15:15:00',1.83),('12374','2013-03-07','15:20:00',1.89),('12374','2013-03-07','15:25:00',1.24),('12374','2013-03-07','15:35:00',1.08),('12374','2013-03-07','15:40:00',1.11),('12374','2013-03-07','15:45:00',1.12),('12374','2013-03-07','15:55:00',1.22),('12374','2013-03-07','16:05:00',1.06),('12374','2013-03-07','16:10:00',1.14),('12374','2013-03-07','16:15:00',1.1),('12374','2013-03-07','16:25:00',1.04),('12374','2013-03-06','09:35:00',1.12),('12374','2013-03-06','09:40:00',1.47),('12374','2013-03-06','09:45:00',1.36),('12374','2013-03-06','09:50:00',1.37),('12374','2013-03-06','09:55:00',1.07),('12374','2013-03-05','07:35:00',1.05),('12374','2013-03-05','07:40:00',1.2),('12374','2013-03-05','07:50:00',1.19),('12374','2013-03-05','07:55:00',2.43),('12374','2013-03-05','08:00:00',2.39),('12374','2013-03-05','08:05:00',2.62),('12374','2013-03-05','08:10:00',2.61),('12374','2013-03-05','08:15:00',2.57),('12374','2013-03-05','08:20:00',3.38),('12374','2013-03-05','08:25:00',4.07),('12374','2013-03-05','08:30:00',3.5),('12374','2013-03-05','08:35:00',3.4),('12374','2013-03-05','08:40:00',3.6),('12374','2013-03-05','08:45:00',2.98),('12374','2013-03-05','08:50:00',2.35),('12374','2013-03-05','08:55:00',2.15),('12374','2013-03-05','09:00:00',2.18),('12374','2013-03-05','09:05:00',2.38),('12374','2013-03-05','09:10:00',2.56),('12374','2013-03-05','09:15:00',2.56),('12374','2013-03-05','09:20:00',2.64),('12374','2013-03-05','09:25:00',2.77),('12374','2013-03-05','09:30:00',2.75),('12374','2013-03-05','09:35:00',2.71),('12374','2013-03-05','09:40:00',2.97),('12374','2013-03-05','09:45:00',3.83),('12374','2013-03-05','09:50:00',5.82),('12374','2013-03-05','09:55:00',3.19),('12374','2013-03-05','10:00:00',3.27),('12374','2013-03-05','10:05:00',4.09),('12374','2013-03-05','10:10:00',4.38),('12374','2013-03-05','10:15:00',4.47),('12374','2013-03-05','10:20:00',4.35),('12374','2013-03-05','10:25:00',5.26),('12374','2013-03-05','10:30:00',5.67),('12374','2013-03-05','10:35:00',5.51),('12374','2013-03-05','10:40:00',5.32),('12374','2013-03-05','10:45:00',5.49),('12374','2013-03-05','10:50:00',5.92),('12374','2013-03-05','10:55:00',6.55),('12374','2013-03-05','11:00:00',6.01),('12374','2013-03-05','11:05:00',5.96),('12374','2013-03-05','11:10:00',5.79),('12374','2013-03-05','11:15:00',5.1),('12374','2013-03-05','11:20:00',4.87),('12374','2013-03-05','11:25:00',5.48),('12374','2013-03-05','11:30:00',5.9),('12374','2013-03-05','11:35:00',6.53),('12374','2013-03-05','11:40:00',6.68),('12374','2013-03-05','11:45:00',7.09),('12374','2013-03-05','11:50:00',6.84),('12374','2013-03-05','11:55:00',6.19),('12374','2013-03-05','12:00:00',5.71),('12374','2013-03-05','12:05:00',5.92),('12374','2013-03-05','12:10:00',5.61),('12374','2013-03-05','12:15:00',5.35),('12374','2013-03-05','12:20:00',5.5),('12374','2013-03-05','12:25:00',5.15),('12374','2013-03-05','12:30:00',4.57),('12374','2013-03-05','12:35:00',4.88),('12374','2013-03-05','12:40:00',5.03),('12374','2013-03-05','12:45:00',4.21),('12374','2013-03-05','12:50:00',3.45),('12374','2013-03-05','12:55:00',3.32),('12374','2013-03-05','13:00:00',3.37),('12374','2013-03-05','13:05:00',3.16),('12374','2013-03-05','13:10:00',2.84),('12374','2013-03-05','13:15:00',2.56),('12374','2013-03-05','13:20:00',2.25),('12374','2013-03-05','13:25:00',1.96),('12374','2013-03-05','13:30:00',2),('12374','2013-03-05','13:35:00',2.05),('12374','2013-03-05','13:40:00',2.17),('12374','2013-03-05','13:45:00',2.46),('12374','2013-03-05','13:50:00',2.42),('12374','2013-03-05','13:55:00',2.41),('12374','2013-03-05','14:00:00',2.85),('12374','2013-03-05','14:05:00',3.02),('12374','2013-03-05','14:10:00',2.98),('12374','2013-03-05','14:15:00',2.92),('12374','2013-03-05','14:20:00',2.74),('12374','2013-03-05','14:25:00',2.46),('12374','2013-03-05','14:30:00',2.21),('12374','2013-03-05','14:35:00',2.11),('12374','2013-03-05','14:40:00',2.11),('12374','2013-03-05','14:45:00',2.08),('12374','2013-03-05','14:50:00',2.06),('12374','2013-03-05','14:55:00',1.95),('12374','2013-03-05','15:00:00',1.79),('12374','2013-03-05','15:05:00',1.4),('12374','2013-03-05','15:10:00',1.36),('12374','2013-03-05','15:15:00',1.67),('12374','2013-03-05','15:20:00',1.63),('12374','2013-03-05','15:25:00',1.67),('12374','2013-03-05','15:30:00',1.71),('12374','2013-03-05','15:35:00',1.82),('12374','2013-03-05','15:40:00',2.24),('12374','2013-03-05','15:45:00',2.76),('12374','2013-03-05','15:50:00',2.56),('12374','2013-03-05','15:55:00',1.97),('12374','2013-03-05','16:00:00',1.52),('12374','2013-03-05','16:05:00',1.28),('12374','2013-03-05','16:10:00',1.14),('12374','2013-03-05','16:15:00',1.01),('12374','2013-03-04','07:20:00',1.16),('12374','2013-03-04','07:25:00',1.45),('12374','2013-03-04','07:30:00',1.67),('12374','2013-03-04','07:35:00',1.79),('12374','2013-03-04','07:40:00',1.97),('12374','2013-03-04','07:45:00',2.42),('12374','2013-03-04','07:50:00',2.6),('12374','2013-03-04','07:55:00',2.82),('12374','2013-03-04','08:00:00',2.8),('12374','2013-03-04','08:05:00',2.89),('12374','2013-03-04','08:10:00',3.39),('12374','2013-03-04','08:15:00',3.58),('12374','2013-03-04','08:20:00',3.78),('12374','2013-03-04','08:25:00',3.95),('12374','2013-03-04','08:30:00',4.04),('12374','2013-03-04','08:35:00',4.27),('12374','2013-03-04','08:40:00',4.41),('12374','2013-03-04','08:45:00',4.61),('12374','2013-03-04','08:50:00',4.78),('12374','2013-03-04','08:55:00',4.9),('12374','2013-03-04','09:00:00',5.12),('12374','2013-03-04','09:05:00',5.3),('12374','2013-03-04','09:10:00',5.48),('12374','2013-03-04','09:15:00',5.67),('12374','2013-03-04','09:20:00',5.83),('12374','2013-03-04','09:25:00',5.97),('12374','2013-03-04','09:30:00',6.14),('12374','2013-03-04','09:35:00',6.25),('12374','2013-03-04','09:40:00',6.43),('12374','2013-03-04','09:45:00',6.56),('12374','2013-03-04','09:50:00',6.69),('12374','2013-03-04','09:55:00',6.77),('12374','2013-03-04','10:00:00',6.87),('12374','2013-03-04','10:05:00',7.02),('12374','2013-03-04','10:10:00',7.11),('12374','2013-03-04','10:15:00',7.23),('12374','2013-03-04','10:20:00',7.36),('12374','2013-03-04','10:25:00',7.46),('12374','2013-03-04','10:30:00',7.54),('12374','2013-03-04','10:35:00',7.56),('12374','2013-03-04','10:40:00',7.58),('12374','2013-03-04','10:45:00',7.72),('12374','2013-03-04','10:50:00',7.7),('12374','2013-03-04','10:55:00',7.93),('12374','2013-03-04','11:00:00',8.03),('12374','2013-03-04','11:05:00',8.1),('12374','2013-03-04','11:10:00',8.11),('12374','2013-03-04','11:15:00',8.1),('12374','2013-03-04','11:20:00',8.16),('12374','2013-03-04','11:25:00',8.24),('12374','2013-03-04','11:30:00',8.27),('12374','2013-03-04','11:35:00',8.18),('12374','2013-03-04','11:40:00',8.14),('12374','2013-03-04','11:45:00',8.36),('12374','2013-03-04','11:50:00',8.4),('12374','2013-03-04','11:55:00',8.38),('12374','2013-03-04','12:00:00',8.39),('12374','2013-03-04','12:05:00',8.38),('12374','2013-03-04','12:10:00',8.46),('12374','2013-03-04','12:15:00',8.56),('12374','2013-03-04','12:20:00',8.64),('12374','2013-03-04','12:25:00',8.64),('12374','2013-03-04','12:30:00',8.59),('12374','2013-03-04','12:35:00',8.61),('12374','2013-03-04','12:40:00',8.59),('12374','2013-03-04','12:45:00',8.53),('12374','2013-03-04','12:50:00',8.53),('12374','2013-03-04','12:55:00',8.56),('12374','2013-03-04','13:00:00',8.22),('12374','2013-03-04','13:05:00',8.35),('12374','2013-03-04','13:10:00',8.37),('12374','2013-03-04','13:15:00',7.56),('12374','2013-03-04','13:20:00',8.25),('12374','2013-03-04','13:25:00',8.09),('12374','2013-03-04','13:30:00',7.97),('12374','2013-03-04','13:35:00',7.9),('12374','2013-03-04','13:40:00',7.81),('12374','2013-03-04','13:45:00',7.72),('12374','2013-03-04','13:50:00',7.53),('12374','2013-03-04','13:55:00',7.53),('12374','2013-03-04','14:00:00',7.42),('12374','2013-03-04','14:05:00',7.31),('12374','2013-03-04','14:10:00',7.2),('12374','2013-03-04','14:15:00',7.12),('12374','2013-03-04','14:20:00',6.98),('12374','2013-03-04','14:25:00',6.91),('12374','2013-03-04','14:30:00',6.82),('12374','2013-03-04','14:35:00',6.73),('12374','2013-03-04','14:40:00',6.57),('12374','2013-03-04','14:45:00',6.45),('12374','2013-03-04','14:50:00',6.28),('12374','2013-03-04','14:55:00',6.16),('12374','2013-03-04','15:00:00',6.01),('12374','2013-03-04','15:05:00',5.84),('12374','2013-03-04','15:10:00',5.67),('12374','2013-03-04','15:15:00',5.54),('12374','2013-03-04','15:20:00',5.37),('12374','2013-03-04','15:25:00',5.2),('12374','2013-03-04','15:30:00',5.06),('12374','2013-03-04','15:35:00',4.93),('12374','2013-03-04','15:40:00',4.75),('12374','2013-03-04','15:45:00',4.56),('12374','2013-03-04','15:50:00',4.45),('12374','2013-03-04','15:55:00',4.32),('12374','2013-03-04','16:00:00',4.1),('12374','2013-03-04','16:05:00',3.85),('12374','2013-03-04','16:10:00',3.61),('12374','2013-03-04','16:15:00',3.45),('12374','2013-03-04','16:20:00',3.29),('12374','2013-03-04','16:25:00',3.05),('12374','2013-03-04','16:30:00',2.91),('12374','2013-03-04','16:35:00',2.66),('12374','2013-03-04','16:40:00',2.41),('12374','2013-03-04','16:45:00',2.16),('12374','2013-03-04','16:50:00',1.86),('12374','2013-03-04','16:55:00',1.53),('12374','2013-03-04','17:00:00',1.26),('12374','2013-03-03','07:10:00',1.07),('12374','2013-03-03','07:15:00',1.36),('12374','2013-03-03','07:20:00',1.57),('12374','2013-03-03','07:25:00',1.7),('12374','2013-03-03','07:30:00',2.06),('12374','2013-03-03','07:35:00',2.28),('12374','2013-03-03','07:40:00',2.39),('12374','2013-03-03','07:45:00',2.44),('12374','2013-03-03','07:50:00',2.94),('12374','2013-03-03','07:55:00',3.14),('12374','2013-03-03','08:00:00',3.04),('12374','2013-03-03','08:05:00',3.37),('12374','2013-03-03','08:10:00',3.44),('12374','2013-03-03','08:15:00',3.91),('12374','2013-03-03','08:20:00',4.1),('12374','2013-03-03','08:25:00',4.28),('12374','2013-03-03','08:30:00',4.44),('12374','2013-03-03','08:35:00',4.61),('12374','2013-03-03','08:40:00',4.78),('12374','2013-03-03','08:45:00',4.94),('12374','2013-03-03','08:50:00',5.11),('12374','2013-03-03','08:55:00',5.25),('12374','2013-03-03','09:00:00',5.44),('12374','2013-03-03','09:05:00',5.59),('12374','2013-03-03','09:10:00',5.75),('12374','2013-03-03','09:15:00',5.89),('12374','2013-03-03','09:20:00',6.02),('12374','2013-03-03','09:25:00',6.16),('12374','2013-03-03','09:30:00',6.29),('12374','2013-03-03','09:35:00',6.39),('12374','2013-03-03','09:40:00',6.58),('12374','2013-03-03','09:45:00',6.71),('12374','2013-03-03','09:50:00',6.84),('12374','2013-03-03','09:55:00',6.95),('12374','2013-03-03','10:00:00',7.06),('12374','2013-03-03','10:05:00',7.19),('12374','2013-03-03','10:10:00',7.32),('12374','2013-03-03','10:15:00',7.42),('12374','2013-03-03','10:20:00',7.51),('12374','2013-03-03','10:25:00',7.65),('12374','2013-03-03','10:30:00',7.74),('12374','2013-03-03','10:35:00',7.84),('12374','2013-03-03','10:40:00',7.86),('12374','2013-03-03','10:45:00',7.95),('12374','2013-03-03','10:50:00',8.02),('12374','2013-03-03','10:55:00',8.16),('12374','2013-03-03','11:00:00',8.22),('12374','2013-03-03','11:05:00',8.29),('12374','2013-03-03','11:10:00',8.33),('12374','2013-03-03','11:15:00',8.32),('12374','2013-03-03','11:20:00',8.32),('12374','2013-03-03','11:25:00',8.37),('12374','2013-03-03','11:30:00',8.49),('12374','2013-03-03','11:35:00',8.45),('12374','2013-03-03','11:40:00',8.55),('12374','2013-03-03','11:45:00',8.54),('12374','2013-03-03','11:50:00',8.55),('12374','2013-03-03','11:55:00',8.62),('12374','2013-03-03','12:00:00',8.6),('12374','2013-03-03','12:05:00',8.65),('12374','2013-03-03','12:10:00',8.63),('12374','2013-03-03','12:15:00',8.54),('12374','2013-03-03','12:20:00',8.53),('12374','2013-03-03','12:25:00',8.53),('12374','2013-03-03','12:30:00',8.53),('12374','2013-03-03','12:35:00',8.52),('12374','2013-03-03','12:40:00',8.5),('12374','2013-03-03','12:45:00',8.49),('12374','2013-03-03','12:50:00',8.5),('12374','2013-03-03','12:55:00',8.52),('12374','2013-03-03','13:00:00',8.48),('12374','2013-03-03','13:05:00',8.44),('12374','2013-03-03','13:10:00',8.34),('12374','2013-03-03','13:15:00',8.29),('12374','2013-03-03','13:20:00',8.22),('12374','2013-03-03','13:25:00',8.11),('12374','2013-03-03','13:30:00',8),('12374','2013-03-03','13:35:00',7.93),('12374','2013-03-03','13:40:00',7.76),('12374','2013-03-03','13:45:00',7.78),('12374','2013-03-03','13:50:00',7.69),('12374','2013-03-03','13:55:00',7.6),('12374','2013-03-03','14:00:00',7.48),('12374','2013-03-03','14:05:00',7.37),('12374','2013-03-03','14:10:00',7.26),('12374','2013-03-03','14:15:00',7.17),('12374','2013-03-03','14:20:00',7.07),('12374','2013-03-03','14:25:00',6.95),('12374','2013-03-03','14:30:00',6.84),('12374','2013-03-03','14:35:00',6.72),('12374','2013-03-03','14:40:00',6.59),('12374','2013-03-03','14:45:00',6.45),('12374','2013-03-03','14:50:00',6.33),('12374','2013-03-03','14:55:00',6.2),('12374','2013-03-03','15:00:00',6.07),('12374','2013-03-03','15:05:00',5.91),('12374','2013-03-03','15:10:00',5.75),('12374','2013-03-03','15:15:00',5.6),('12374','2013-03-03','15:20:00',5.41),('12374','2013-03-03','15:25:00',5.21),('12374','2013-03-03','15:30:00',5.07),('12374','2013-03-03','15:35:00',4.91),('12374','2013-03-03','15:40:00',4.75),('12374','2013-03-03','15:45:00',4.59),('12374','2013-03-03','15:50:00',4.43),('12374','2013-03-03','15:55:00',4.25),('12374','2013-03-03','16:00:00',4.09),('12374','2013-03-03','16:05:00',3.93),('12374','2013-03-03','16:10:00',3.72),('12374','2013-03-03','16:15:00',3.56),('12374','2013-03-03','16:20:00',3.39),('12374','2013-03-03','16:25:00',3.2),('12374','2013-03-03','16:30:00',2.98),('12374','2013-03-03','16:35:00',2.71),('12374','2013-03-03','16:40:00',2.47),('12374','2013-03-03','16:45:00',2.19),('12374','2013-03-03','16:50:00',1.89),('12374','2013-03-03','16:55:00',1.59),('12374','2013-03-03','17:00:00',1.3),('12374','2013-03-02','09:35:00',1.07),('12374','2013-03-02','09:55:00',1.07),('12374','2013-03-02','10:00:00',1.16),('12374','2013-03-02','10:05:00',1.25),('12374','2013-03-02','10:10:00',1.25),('12374','2013-03-02','10:15:00',1.55),('12374','2013-03-02','10:20:00',1.47),('12374','2013-03-02','10:25:00',1.35),('12374','2013-03-02','10:30:00',1.46),('12374','2013-03-02','10:35:00',1.87),('12374','2013-03-02','10:40:00',2.03),('12374','2013-03-02','10:45:00',2.2),('12374','2013-03-02','10:50:00',2.64),('12374','2013-03-02','10:55:00',3.26),('12374','2013-03-02','11:00:00',3.44),('12374','2013-03-02','11:05:00',3.62),('12374','2013-03-02','11:10:00',3.74),('12374','2013-03-02','11:15:00',4.01),('12374','2013-03-02','11:20:00',3.83),('12374','2013-03-02','11:25:00',3.46),('12374','2013-03-02','11:30:00',3.26),('12374','2013-03-02','11:35:00',3.65),('12374','2013-03-02','11:40:00',3.93),('12374','2013-03-02','11:45:00',2.97),('12374','2013-03-02','11:50:00',3.22),('12374','2013-03-02','11:55:00',3.24),('12374','2013-03-02','12:00:00',3.16),('12374','2013-03-02','12:05:00',4.24),('12374','2013-03-02','12:10:00',3.32),('12374','2013-03-02','12:15:00',3.43),('12374','2013-03-02','12:20:00',5.26),('12374','2013-03-02','12:25:00',3.74),('12374','2013-03-02','12:30:00',3.62),('12374','2013-03-02','12:35:00',4.22),('12374','2013-03-02','12:40:00',4.85),('12374','2013-03-02','12:45:00',6.57),('12374','2013-03-02','12:50:00',8.12),('12374','2013-03-02','12:55:00',8.12),('12374','2013-03-02','13:00:00',7.01),('12374','2013-03-02','13:05:00',5.46),('12374','2013-03-02','13:10:00',5.84),('12374','2013-03-02','13:15:00',4.48),('12374','2013-03-02','13:20:00',6.38),('12374','2013-03-02','13:25:00',4.62),('12374','2013-03-02','13:30:00',3.12),('12374','2013-03-02','13:35:00',2.77),('12374','2013-03-02','13:40:00',2.87),('12374','2013-03-02','13:45:00',2.81),('12374','2013-03-02','13:50:00',3.06),('12374','2013-03-02','13:55:00',3.33),('12374','2013-03-02','14:00:00',3.13),('12374','2013-03-02','14:05:00',2.6),('12374','2013-03-02','14:10:00',2.39),('12374','2013-03-02','14:15:00',2.3),('12374','2013-03-02','14:20:00',2.21),('12374','2013-03-02','14:25:00',1.91),('12374','2013-03-02','14:30:00',1.8),('12374','2013-03-02','14:35:00',1.86),('12374','2013-03-02','14:40:00',2.26),('12374','2013-03-02','14:45:00',2.44),('12374','2013-03-02','14:50:00',2.85),('12374','2013-03-02','14:55:00',2.91),('12374','2013-03-02','15:00:00',2.73),('12374','2013-03-02','15:05:00',2.77),('12374','2013-03-02','15:10:00',3.03),('12374','2013-03-02','15:15:00',2.42),('12374','2013-03-02','15:20:00',2.1),('12374','2013-03-02','15:25:00',1.8),('12374','2013-03-02','15:30:00',1.64),('12374','2013-03-02','15:35:00',1.71),('12374','2013-03-02','15:40:00',1.75),('12374','2013-03-02','15:45:00',1.75),('12374','2013-03-02','15:50:00',1.81),('12374','2013-03-02','15:55:00',1.72),('12374','2013-03-02','16:00:00',1.28),('12374','2013-03-01','07:45:00',1.04),('12374','2013-03-01','07:50:00',1.31),('12374','2013-03-01','07:55:00',1.55),('12374','2013-03-01','08:00:00',1.77),('12374','2013-03-01','08:05:00',1.71),('12374','2013-03-01','08:10:00',1.7),('12374','2013-03-01','08:15:00',1.5),('12374','2013-03-01','08:20:00',1.66),('12374','2013-03-01','08:25:00',1.82),('12374','2013-03-01','08:30:00',1.83),('12374','2013-03-01','08:35:00',1.87),('12374','2013-03-01','08:40:00',1.98),('12374','2013-03-01','08:45:00',2.12),('12374','2013-03-01','08:50:00',2.26),('12374','2013-03-01','08:55:00',2.42),('12374','2013-03-01','09:00:00',2.67),('12374','2013-03-01','09:05:00',2.87),('12374','2013-03-01','09:10:00',3),('12374','2013-03-01','09:15:00',3.16),('12374','2013-03-01','09:20:00',3.98),('12374','2013-03-01','09:25:00',4.44),('12374','2013-03-01','09:30:00',4.62),('12374','2013-03-01','09:35:00',4.68),('12374','2013-03-01','09:40:00',4.43),('12374','2013-03-01','09:45:00',4.44),('12374','2013-03-01','09:50:00',4.34),('12374','2013-03-01','09:55:00',4.43),('12374','2013-03-01','10:00:00',4.21),('12374','2013-03-01','10:05:00',4.36),('12374','2013-03-01','10:10:00',4.52),('12374','2013-03-01','10:15:00',4.23),('12374','2013-03-01','10:20:00',3.78),('12374','2013-03-01','10:25:00',3.51),('12374','2013-03-01','10:30:00',3.44),('12374','2013-03-01','10:35:00',3.35),('12374','2013-03-01','10:40:00',3.27),('12374','2013-03-01','10:45:00',3.24),('12374','2013-03-01','10:50:00',3.23),('12374','2013-03-01','10:55:00',3.19),('12374','2013-03-01','11:00:00',3.11),('12374','2013-03-01','11:05:00',3.07),('12374','2013-03-01','11:10:00',3.09),('12374','2013-03-01','11:15:00',3.2),('12374','2013-03-01','11:20:00',3.29),('12374','2013-03-01','11:25:00',3.34),('12374','2013-03-01','11:30:00',3.38),('12374','2013-03-01','11:35:00',3.44),('12374','2013-03-01','11:40:00',3.59),('12374','2013-03-01','11:45:00',3.59),('12374','2013-03-01','11:50:00',3.45),('12374','2013-03-01','11:55:00',3.29),('12374','2013-03-01','12:00:00',3.16),('12374','2013-03-01','12:05:00',3.11),('12374','2013-03-01','12:10:00',3.1),('12374','2013-03-01','12:15:00',3.16),('12374','2013-03-01','12:20:00',3.27),('12374','2013-03-01','12:25:00',3.28),('12374','2013-03-01','12:30:00',3.13),('12374','2013-03-01','12:35:00',3.04),('12374','2013-03-01','12:40:00',3.22),('12374','2013-03-01','12:45:00',3.66),('12374','2013-03-01','12:50:00',3.82),('12374','2013-03-01','12:55:00',3.69),('12374','2013-03-01','13:00:00',3.52),('12374','2013-03-01','13:05:00',3.36),('12374','2013-03-01','13:10:00',3.26),('12374','2013-03-01','13:15:00',3.14),('12374','2013-03-01','13:20:00',2.96),('12374','2013-03-01','13:25:00',2.83),('12374','2013-03-01','13:30:00',2.82),('12374','2013-03-01','13:35:00',2.69),('12374','2013-03-01','13:40:00',2.5),('12374','2013-03-01','13:45:00',2.27),('12374','2013-03-01','13:50:00',2.11),('12374','2013-03-01','13:55:00',2),('12374','2013-03-01','14:00:00',2),('12374','2013-03-01','14:05:00',2.03),('12374','2013-03-01','14:10:00',2.01),('12374','2013-03-01','14:15:00',2.05),('12374','2013-03-01','14:20:00',2.16),('12374','2013-03-01','14:25:00',2.22),('12374','2013-03-01','14:30:00',2.21),('12374','2013-03-01','14:35:00',2.16),('12374','2013-03-01','14:40:00',2.07),('12374','2013-03-01','14:45:00',2.04),('12374','2013-03-01','14:50:00',2.01),('12374','2013-03-01','14:55:00',1.96),('12374','2013-03-01','15:00:00',1.96),('12374','2013-03-01','15:05:00',1.97),('12374','2013-03-01','15:10:00',1.85),('12374','2013-03-01','15:15:00',1.61),('12374','2013-03-01','15:20:00',1.35),('12374','2013-03-01','15:25:00',1.17),('12374','2013-03-01','15:30:00',1.14),('12374','2013-03-01','15:35:00',1.11),('12374','2013-03-01','15:40:00',1),('12374','2013-03-01','15:55:00',1.1),('12374','2013-03-01','16:00:00',1.06),('12374','2013-02-28','07:25:00',1.04),('12374','2013-02-28','07:30:00',1.2),('12374','2013-02-28','07:35:00',1.46),('12374','2013-02-28','07:40:00',1.68),('12374','2013-02-28','07:45:00',1.78),('12374','2013-02-28','07:50:00',1.96),('12374','2013-02-28','07:55:00',2.29),('12374','2013-02-28','08:00:00',2.5),('12374','2013-02-28','08:05:00',2.49),('12374','2013-02-28','08:10:00',2.88),('12374','2013-02-28','08:15:00',2.84),('12374','2013-02-28','08:20:00',3.29),('12374','2013-02-28','08:25:00',3.47),('12374','2013-02-28','08:30:00',3.66),('12374','2013-02-28','08:35:00',3.89),('12374','2013-02-28','08:40:00',4.06),('12374','2013-02-28','08:45:00',4.18),('12374','2013-02-28','08:50:00',4.33),('12374','2013-02-28','08:55:00',4.56),('12374','2013-02-28','09:00:00',4.73),('12374','2013-02-28','09:05:00',4.87),('12374','2013-02-28','09:10:00',5.02),('12374','2013-02-28','09:15:00',5.18),('12374','2013-02-28','09:20:00',5.42),('12374','2013-02-28','09:25:00',5.6),('12374','2013-02-28','09:30:00',5.73),('12374','2013-02-28','09:35:00',5.9),('12374','2013-02-28','09:40:00',6.07),('12374','2013-02-28','09:45:00',6.22),('12374','2013-02-28','09:50:00',6.39),('12374','2013-02-28','09:55:00',6.54),('12374','2013-02-28','10:00:00',6.67),('12374','2013-02-28','10:05:00',6.78),('12374','2013-02-28','10:10:00',6.9),('12374','2013-02-28','10:15:00',7.01),('12374','2013-02-28','10:20:00',7.13),('12374','2013-02-28','10:25:00',7.16),('12374','2013-02-28','10:30:00',7.23),('12374','2013-02-28','10:35:00',7.36),('12374','2013-02-28','10:40:00',7.39),('12374','2013-02-28','10:45:00',7.35),('12374','2013-02-28','10:50:00',7.68),('12374','2013-02-28','10:55:00',7.74),('12374','2013-02-28','11:00:00',7.79),('12374','2013-02-28','11:05:00',7.61),('12374','2013-02-28','11:10:00',6.65),('12374','2013-02-28','11:15:00',6.22),('12374','2013-02-28','11:20:00',7.83),('12374','2013-02-28','11:25:00',8.09),('12374','2013-02-28','11:30:00',8.12),('12374','2013-02-28','11:35:00',8.18),('12374','2013-02-28','11:40:00',8.23),('12374','2013-02-28','11:45:00',8.24),('12374','2013-02-28','11:50:00',8.24),('12374','2013-02-28','11:55:00',8.27),('12374','2013-02-28','12:00:00',8.18),('12374','2013-02-28','12:05:00',8.21),('12374','2013-02-28','12:10:00',8.12),('12374','2013-02-28','12:15:00',8.2),('12374','2013-02-28','12:20:00',8.06),('12374','2013-02-28','12:25:00',8.04),('12374','2013-02-28','12:30:00',8.14),('12374','2013-02-28','12:35:00',8.11),('12374','2013-02-28','12:40:00',7.85),('12374','2013-02-28','12:45:00',8.08),('12374','2013-02-28','12:50:00',8.11),('12374','2013-02-28','12:55:00',8.02),('12374','2013-02-28','13:00:00',7.98),('12374','2013-02-28','13:05:00',7.87),('12374','2013-02-28','13:10:00',7.84),('12374','2013-02-28','13:15:00',7.84),('12374','2013-02-28','13:20:00',7.82),('12374','2013-02-28','13:25:00',7.69),('12374','2013-02-28','13:30:00',7.64),('12374','2013-02-28','13:35:00',7.5),('12374','2013-02-28','13:40:00',7.52),('12374','2013-02-28','13:45:00',7.47),('12374','2013-02-28','13:50:00',7.41),('12374','2013-02-28','13:55:00',7.36),('12374','2013-02-28','14:00:00',7.3),('12374','2013-02-28','14:05:00',7.15),('12374','2013-02-28','14:10:00',7.05),('12374','2013-02-28','14:15:00',6.98),('12374','2013-02-28','14:20:00',6.86),('12374','2013-02-28','14:25:00',6.74),('12374','2013-02-28','14:30:00',6.6),('12374','2013-02-28','14:35:00',6.46),('12374','2013-02-28','14:40:00',6.35),('12374','2013-02-28','14:45:00',6.12),('12374','2013-02-28','14:50:00',5.84),('12374','2013-02-28','14:55:00',5.69),('12374','2013-02-28','15:00:00',5.62),('12374','2013-02-28','15:05:00',5.52),('12374','2013-02-28','15:10:00',5.3),('12374','2013-02-28','15:15:00',5.03),('12374','2013-02-28','15:20:00',4.87),('12374','2013-02-28','15:25:00',4.72),('12374','2013-02-28','15:30:00',4.59),('12374','2013-02-28','15:35:00',4.32),('12374','2013-02-28','15:40:00',4.26),('12374','2013-02-28','15:45:00',4.08),('12374','2013-02-28','15:50:00',3.9),('12374','2013-02-28','15:55:00',3.72),('12374','2013-02-28','16:00:00',3.54),('12374','2013-02-28','16:05:00',3.42),('12374','2013-02-28','16:10:00',3.22),('12374','2013-02-28','16:15:00',3.07),('12374','2013-02-28','16:20:00',2.93),('12374','2013-02-28','16:25:00',2.75),('12374','2013-02-28','16:30:00',2.59),('12374','2013-02-28','16:35:00',2.34),('12374','2013-02-28','16:40:00',2.15),('12374','2013-02-28','16:45:00',1.9),('12374','2013-02-28','16:50:00',1.68),('12374','2013-02-28','16:55:00',1.39),('12374','2013-02-28','17:00:00',1.13),('12374','2013-02-27','07:25:00',1),('12374','2013-02-27','07:30:00',1.23),('12374','2013-02-27','07:35:00',1.43),('12374','2013-02-27','07:40:00',1.69),('12374','2013-02-27','07:45:00',1.91),('12374','2013-02-27','07:50:00',2),('12374','2013-02-27','07:55:00',2.17),('12374','2013-02-27','08:00:00',2.52),('12374','2013-02-27','08:05:00',2.73),('12374','2013-02-27','08:10:00',2.72),('12374','2013-02-27','08:15:00',3.02),('12374','2013-02-27','08:20:00',3.17),('12374','2013-02-27','08:25:00',3.53),('12374','2013-02-27','08:30:00',3.73),('12374','2013-02-27','08:35:00',3.93),('12374','2013-02-27','08:40:00',4.09),('12374','2013-02-27','08:45:00',4.25),('12374','2013-02-27','08:50:00',4.43),('12374','2013-02-27','08:55:00',4.6),('12374','2013-02-27','09:00:00',4.76),('12374','2013-02-27','09:05:00',4.93),('12374','2013-02-27','09:10:00',5.11),('12374','2013-02-27','09:15:00',5.26),('12374','2013-02-27','09:20:00',5.44),('12374','2013-02-27','09:25:00',5.61),('12374','2013-02-27','09:30:00',5.77),('12374','2013-02-27','09:35:00',5.93),('12374','2013-02-27','09:40:00',6.09),('12374','2013-02-27','09:45:00',6.26),('12374','2013-02-27','09:50:00',6.4),('12374','2013-02-27','09:55:00',6.52),('12374','2013-02-27','10:00:00',6.6),('12374','2013-02-27','10:05:00',6.75),('12374','2013-02-27','10:10:00',6.86),('12374','2013-02-27','10:15:00',6.96),('12374','2013-02-27','10:20:00',7.02),('12374','2013-02-27','10:25:00',7.07),('12374','2013-02-27','10:30:00',7.16),('12374','2013-02-27','10:35:00',7.22),('12374','2013-02-27','10:40:00',7.36),('12374','2013-02-27','10:45:00',7.46),('12374','2013-02-27','10:50:00',7.59),('12374','2013-02-27','10:55:00',7.66),('12374','2013-02-27','11:00:00',7.74),('12374','2013-02-27','11:05:00',7.78),('12374','2013-02-27','11:10:00',7.83),('12374','2013-02-27','11:15:00',7.77),('12374','2013-02-27','11:20:00',7.9),('12374','2013-02-27','11:25:00',8.07),('12374','2013-02-27','11:30:00',8.11),('12374','2013-02-27','11:35:00',8.08),('12374','2013-02-27','11:40:00',7.67),('12374','2013-02-27','11:45:00',8.17),('12374','2013-02-27','11:50:00',8.48),('12374','2013-02-27','11:55:00',8.65),('12374','2013-02-27','12:00:00',5.04),('12374','2013-02-27','12:05:00',2.34),('12374','2013-02-27','12:10:00',6.2),('12374','2013-02-27','12:15:00',8.58),('12374','2013-02-27','12:20:00',8.53),('12374','2013-02-27','12:25:00',8.39),('12374','2013-02-27','12:30:00',8.39),('12374','2013-02-27','12:35:00',8.31),('12374','2013-02-27','12:40:00',8.34),('12374','2013-02-27','12:45:00',8.32),('12374','2013-02-27','12:50:00',8.25),('12374','2013-02-27','12:55:00',8.14),('12374','2013-02-27','13:00:00',8.11),('12374','2013-02-27','13:05:00',8.02),('12374','2013-02-27','13:10:00',8.02),('12374','2013-02-27','13:15:00',7.98),('12374','2013-02-27','13:20:00',7.96),('12374','2013-02-27','13:25:00',7.9),('12374','2013-02-27','13:30:00',7.84),('12374','2013-02-27','13:35:00',7.75),('12374','2013-02-27','13:40:00',7.67),('12374','2013-02-27','13:45:00',7.6),('12374','2013-02-27','13:50:00',7.46),('12374','2013-02-27','13:55:00',7.38),('12374','2013-02-27','14:00:00',7.23),('12374','2013-02-27','14:05:00',7.06),('12374','2013-02-27','14:10:00',7.07),('12374','2013-02-27','14:15:00',6.89),('12374','2013-02-27','14:20:00',6.81),('12374','2013-02-27','14:25:00',6.72),('12374','2013-02-27','14:30:00',6.55),('12374','2013-02-27','14:35:00',6.45),('12374','2013-02-27','14:40:00',6.33),('12374','2013-02-27','14:45:00',6.17),('12374','2013-02-27','14:50:00',6.01),('12374','2013-02-27','14:55:00',5.86),('12374','2013-02-27','15:00:00',5.66),('12374','2013-02-27','15:05:00',5.55),('12374','2013-02-27','15:10:00',5.44),('12374','2013-02-27','15:15:00',5.33),('12374','2013-02-27','15:20:00',5.15),('12374','2013-02-27','15:25:00',4.99),('12374','2013-02-27','15:30:00',4.84),('12374','2013-02-27','15:35:00',4.69),('12374','2013-02-27','15:40:00',4.5),('12374','2013-02-27','15:45:00',4.35),('12374','2013-02-27','15:50:00',4.19),('12374','2013-02-27','15:55:00',4),('12374','2013-02-27','16:00:00',3.88),('12374','2013-02-27','16:05:00',3.7),('12374','2013-02-27','16:10:00',3.47),('12374','2013-02-27','16:15:00',3.33),('12374','2013-02-27','16:20:00',3.12),('12374','2013-02-27','16:25:00',2.87),('12374','2013-02-27','16:30:00',2.69),('12374','2013-02-27','16:35:00',2.46),('12374','2013-02-27','16:40:00',2.26),('12374','2013-02-27','16:45:00',1.98),('12374','2013-02-27','16:50:00',1.72),('12374','2013-02-27','16:55:00',1.39),('12374','2013-02-27','17:00:00',1.18),('12374','2013-02-26','08:40:00',1.05),('12374','2013-02-26','08:45:00',1.19),('12374','2013-02-26','08:50:00',1.37),('12374','2013-02-26','08:55:00',1.57),('12374','2013-02-26','09:00:00',1.75),('12374','2013-02-26','09:05:00',1.88),('12374','2013-02-26','09:10:00',1.96),('12374','2013-02-26','09:16:00',2.03),('12374','2013-02-26','09:20:00',2.22),('12374','2013-02-26','09:25:00',2.45),('12374','2013-02-26','09:30:00',2.76),('12374','2013-02-26','09:35:00',3.13),('12374','2013-02-26','09:40:00',3.3),('12374','2013-02-26','09:45:00',3.67),('12374','2013-02-26','09:50:00',4.12),('12374','2013-02-26','09:55:00',4.53),('12374','2013-02-26','10:00:00',5.49),('12374','2013-02-26','10:05:00',6.27),('12374','2013-02-26','10:10:00',6.29),('12374','2013-02-26','10:15:00',6.82),('12374','2013-02-26','10:20:00',7.1),('12374','2013-02-26','10:25:00',7.28),('12374','2013-02-26','10:30:00',7.3),('12374','2013-02-26','10:35:00',7.41),('12374','2013-02-26','10:40:00',7.33),('12374','2013-02-26','10:45:00',7.48),('12374','2013-02-26','10:50:00',7.67),('12374','2013-02-26','10:55:00',6.84),('12374','2013-02-26','11:00:00',7.81),('12374','2013-02-26','11:05:00',7.68),('12374','2013-02-26','11:10:00',4.41),('12374','2013-02-26','11:15:00',6.28),('12374','2013-02-26','11:20:00',4.32),('12374','2013-02-26','11:25:00',4.07),('12374','2013-02-26','11:30:00',4.4),('12374','2013-02-26','11:35:00',4.98),('12374','2013-02-26','11:40:00',5.11),('12374','2013-02-26','11:45:00',5.21),('12374','2013-02-26','11:50:00',7.42),('12374','2013-02-26','11:55:00',9.7),('12374','2013-02-26','12:00:00',9.1),('12374','2013-02-26','12:05:00',6.2),('12374','2013-02-26','12:10:00',5.18),('12374','2013-02-26','12:15:00',6.12),('12374','2013-02-26','12:20:00',5.61),('12374','2013-02-26','12:25:00',8.12),('12374','2013-02-26','12:30:00',8.88),('12374','2013-02-26','12:35:00',5.64),('12374','2013-02-26','12:40:00',5.46),('12374','2013-02-26','12:45:00',6.12),('12374','2013-02-26','12:50:00',4.51),('12374','2013-02-26','12:55:00',4.74),('12374','2013-02-26','13:00:00',7.69),('12374','2013-02-26','13:05:00',5.2),('12374','2013-02-26','13:10:00',7.1),('12374','2013-02-26','13:15:00',6.01),('12374','2013-02-26','13:20:00',3.26),('12374','2013-02-26','13:25:00',2.18),('12374','2013-02-26','13:30:00',1.98),('12374','2013-02-26','13:35:00',1.86),('12374','2013-02-26','13:40:00',1.78),('12374','2013-02-26','13:45:00',1.7),('12374','2013-02-26','13:50:00',1.71),('12374','2013-02-26','13:55:00',1.79),('12374','2013-02-26','14:00:00',1.87),('12374','2013-02-26','14:05:00',2.04),('12374','2013-02-26','14:10:00',2.25),('12374','2013-02-26','14:15:00',2.41),('12374','2013-02-26','14:20:00',2.36),('12374','2013-02-26','14:25:00',2.32),('12374','2013-02-26','14:30:00',2.27),('12374','2013-02-26','14:35:00',2.07),('12374','2013-02-26','14:40:00',2.06),('12374','2013-02-26','14:45:00',1.92),('12374','2013-02-26','14:50:00',1.82),('12374','2013-02-26','14:55:00',1.88),('12374','2013-02-26','15:00:00',1.25),('12374','2013-02-26','15:05:00',1.02),('12374','2013-02-25','08:20:00',1.2),('12374','2013-02-25','08:30:00',1.07),('12374','2013-02-25','08:35:00',1.34),('12374','2013-02-25','08:40:00',1.5),('12374','2013-02-25','08:45:00',1.2),('12374','2013-02-25','09:10:00',1.91),('12374','2013-02-25','09:15:00',3.31),('12374','2013-02-25','09:20:00',4.38),('12374','2013-02-25','09:25:00',3.23),('12374','2013-02-25','09:30:00',4.45),('12374','2013-02-25','09:35:00',2.44),('12374','2013-02-25','09:40:00',5.05),('12374','2013-02-25','09:45:00',4.09),('12374','2013-02-25','09:50:00',4.05),('12374','2013-02-25','09:55:00',3.69),('12374','2013-02-25','10:00:00',5.44),('12374','2013-02-25','10:05:00',4.21),('12374','2013-02-25','10:10:00',4.49),('12374','2013-02-25','10:15:00',5.8),('12374','2013-02-25','10:20:00',6.67),('12374','2013-02-25','10:25:00',5.11),('12374','2013-02-25','10:30:00',5.54),('12374','2013-02-25','10:35:00',7.25),('12374','2013-02-25','10:40:00',6.92),('12374','2013-02-25','10:45:00',7.62),('12374','2013-02-25','10:50:00',8.22),('12374','2013-02-25','10:55:00',8.22),('12374','2013-02-25','11:00:00',8.24),('12374','2013-02-25','11:05:00',8.2),('12374','2013-02-25','11:10:00',8.28),('12374','2013-02-25','11:15:00',8.44),('12374','2013-02-25','11:20:00',8.61),('12374','2013-02-25','11:25:00',6.87),('12374','2013-02-25','11:30:00',8.08),('12374','2013-02-25','11:35:00',9.46),('12374','2013-02-25','11:40:00',7.08),('12374','2013-02-25','11:45:00',7.57),('12374','2013-02-25','11:50:00',9.12),('12374','2013-02-25','11:55:00',8.88),('12374','2013-02-25','12:00:00',8.14),('12374','2013-02-25','12:05:00',5.66),('12374','2013-02-25','12:10:00',3.52),('12374','2013-02-25','12:15:00',3.94),('12374','2013-02-25','12:20:00',4.57),('12374','2013-02-25','12:25:00',5.74),('12374','2013-02-25','12:30:00',6.44),('12374','2013-02-25','12:35:00',5.47),('12374','2013-02-25','12:40:00',3.53),('12374','2013-02-25','12:45:00',2.86),('12374','2013-02-25','12:50:00',3.07),('12374','2013-02-25','12:55:00',3.87),('12374','2013-02-25','13:00:00',3.95),('12374','2013-02-25','13:05:00',4.5),('12374','2013-02-25','13:10:00',4.15),('12374','2013-02-25','13:15:00',3.22),('12374','2013-02-25','13:20:00',2.68),('12374','2013-02-25','13:25:00',2.55),('12374','2013-02-25','13:30:00',2.44),('12374','2013-02-25','13:35:00',2.39),('12374','2013-02-25','13:40:00',2.72),('12374','2013-02-25','13:45:00',3.48),('12374','2013-02-25','13:50:00',4.02),('12374','2013-02-25','13:55:00',4.68),('12374','2013-02-25','14:00:00',5.29),('12374','2013-02-25','14:05:00',6.58),('12374','2013-02-25','14:10:00',6.25),('12374','2013-02-25','14:15:00',6.9),('12374','2013-02-25','14:20:00',4.79),('12374','2013-02-25','14:25:00',6.83),('12374','2013-02-25','14:30:00',5.34),('12374','2013-02-25','14:35:00',1.97),('12374','2013-02-25','14:40:00',3.72),('12374','2013-02-25','14:45:00',2.68),('12374','2013-02-25','14:50:00',2.66),('12374','2013-02-25','14:55:00',3.34),('12374','2013-02-25','15:00:00',2.71),('12374','2013-02-25','15:05:00',4.08),('12374','2013-02-25','15:10:00',3.57),('12374','2013-02-25','15:15:00',2.43),('12374','2013-02-25','15:20:00',2.17),('12374','2013-02-25','15:25:00',2.08),('12374','2013-02-25','15:30:00',1.89),('12374','2013-02-25','15:35:00',1.69),('12374','2013-02-25','15:40:00',1.54),('12374','2013-02-25','15:45:00',1.46),('12374','2013-02-25','15:50:00',1.23),('12374','2013-02-25','16:10:00',1.5),('12374','2013-02-25','16:20:00',2.07),('12374','2013-02-25','16:25:00',1.75),('12374','2013-02-24','08:35:00',1.23),('12374','2013-02-24','08:40:00',1.34),('12374','2013-02-24','08:45:00',1.14),('12374','2013-02-24','08:50:00',1.05),('12374','2013-02-24','08:55:00',1.09),('12374','2013-02-24','09:00:00',1.25),('12374','2013-02-24','09:05:00',1.5),('12374','2013-02-24','09:10:00',1.76),('12374','2013-02-24','09:15:00',1.7),('12374','2013-02-24','09:20:00',1.39),('12374','2013-02-24','09:25:00',1.92),('12374','2013-02-24','09:30:00',1.93),('12374','2013-02-24','09:35:00',1.47),('12374','2013-02-24','09:40:00',1.46),('12374','2013-02-24','09:45:00',1.64),('12374','2013-02-24','09:50:00',1.75),('12374','2013-02-24','09:55:00',2.1),('12374','2013-02-24','10:00:00',1.66),('12374','2013-02-24','10:05:00',1.75),('12374','2013-02-24','10:10:00',1.7),('12374','2013-02-24','10:15:00',2.26),('12374','2013-02-24','10:20:00',2.7),('12374','2013-02-24','10:25:00',2.94),('12374','2013-02-24','10:30:00',3.34),('12374','2013-02-24','10:35:00',2.98),('12374','2013-02-24','10:40:00',2.11),('12374','2013-02-24','10:45:00',1.83),('12374','2013-02-24','10:50:00',1.98),('12374','2013-02-24','10:55:00',2.21),('12374','2013-02-24','11:00:00',2.03),('12374','2013-02-24','11:05:00',1.84),('12374','2013-02-24','11:10:00',2.12),('12374','2013-02-24','11:15:00',2.56),('12374','2013-02-24','11:20:00',2.94),('12374','2013-02-24','11:25:00',2.88),('12374','2013-02-24','11:30:00',2.4),('12374','2013-02-24','11:35:00',2.82),('12374','2013-02-24','11:40:00',3.65),('12374','2013-02-24','11:45:00',4.36),('12374','2013-02-24','11:50:00',5),('12374','2013-02-24','11:55:00',5.53),('12374','2013-02-24','12:00:00',3.95),('12374','2013-02-24','12:05:00',4.98),('12374','2013-02-24','12:10:00',5.95),('12374','2013-02-24','12:15:00',3.98),('12374','2013-02-24','12:20:00',5.91),('12374','2013-02-24','12:25:00',8.07),('12374','2013-02-24','12:30:00',3.57),('12374','2013-02-24','12:35:00',5.81),('12374','2013-02-24','12:40:00',6.74),('12374','2013-02-24','12:45:00',4.13),('12374','2013-02-24','12:50:00',3.62),('12374','2013-02-24','12:55:00',8.61),('12374','2013-02-24','13:00:00',3.88),('12374','2013-02-24','13:05:00',9.63),('12374','2013-02-24','13:10:00',8.76),('12374','2013-02-24','13:15:00',5.9),('12374','2013-02-24','13:20:00',8.73),('12374','2013-02-24','13:25:00',8.61),('12374','2013-02-24','13:30:00',5.8),('12374','2013-02-24','13:35:00',4.98),('12374','2013-02-24','13:40:00',7.33),('12374','2013-02-24','13:45:00',3.26),('12374','2013-02-24','13:50:00',2.2),('12374','2013-02-24','13:55:00',2.65),('12374','2013-02-24','14:00:00',2.48),('12374','2013-02-24','14:05:00',2.15),('12374','2013-02-24','14:10:00',2.24),('12374','2013-02-24','14:15:00',2.16),('12374','2013-02-24','14:20:00',6.33),('12374','2013-02-24','14:25:00',7.61),('12374','2013-02-24','14:30:00',4.82),('12374','2013-02-24','14:35:00',7.01),('12374','2013-02-24','14:40:00',6.01),('12374','2013-02-24','14:45:00',3.59),('12374','2013-02-24','14:50:00',6.21),('12374','2013-02-24','14:55:00',6.99),('12374','2013-02-24','15:00:00',3.9),('12374','2013-02-24','15:05:00',2.06),('12374','2013-02-24','15:10:00',6.5),('12374','2013-02-24','15:15:00',3.91),('12374','2013-02-24','15:20:00',4.51),('12374','2013-02-24','15:25:00',3.41),('12374','2013-02-24','15:30:00',2.81),('12374','2013-02-24','15:35:00',5.12),('12374','2013-02-24','15:40:00',3.75),('12374','2013-02-24','15:45:00',4.56),('12374','2013-02-24','15:50:00',4.68),('12374','2013-02-24','15:55:00',3.48),('12374','2013-02-24','16:00:00',2.41),('12374','2013-02-23','07:25:00',1.24),('12374','2013-02-23','07:30:00',1.56),('12374','2013-02-23','07:35:00',1.88),('12374','2013-02-23','07:40:00',2.25),('12374','2013-02-23','07:45:00',2.92),('12374','2013-02-23','07:50:00',2.87),('12374','2013-02-23','07:55:00',2.8),('12374','2013-02-23','08:00:00',3.6),('12374','2013-02-23','08:05:00',2.66),('12374','2013-02-23','08:10:00',1.33),('12374','2013-02-23','08:15:00',1.07),('12374','2013-02-23','08:40:00',1.12),('12374','2013-02-23','08:45:00',1.34),('12374','2013-02-23','08:50:00',1.57),('12374','2013-02-23','08:55:00',1.4),('12374','2013-02-23','09:00:00',1.2),('12374','2013-02-23','09:05:00',1.09),('12374','2013-02-23','09:10:00',1.08),('12374','2013-02-23','09:15:00',1.09),('12374','2013-02-23','09:30:00',1.05),('12374','2013-02-23','09:35:00',1.01),('12374','2013-02-23','09:40:00',1.22),('12374','2013-02-23','09:45:00',1.58),('12374','2013-02-23','09:50:00',1.26),('12374','2013-02-23','10:20:00',1.13),('12374','2013-02-23','10:25:00',2.4),('12374','2013-02-23','10:30:00',1.74),('12374','2013-02-23','10:35:00',1.09),('12374','2013-02-23','10:40:00',1.12),('12374','2013-02-23','10:45:00',1.07),('12374','2013-02-23','10:50:00',1.32),('12374','2013-02-23','11:05:00',1.16),('12374','2013-02-23','11:10:00',1.67),('12374','2013-02-23','11:15:00',1.55),('12374','2013-02-23','11:25:00',1.31),('12374','2013-02-23','11:30:00',1.93),('12374','2013-02-23','11:35:00',1.32),('12374','2013-02-23','11:50:00',1.05),('12374','2013-02-23','12:05:00',1.02),('12374','2013-02-23','12:10:00',1.38),('12374','2013-02-22','11:10:00',1.11),('12374','2013-02-22','11:15:00',1.65),('12374','2013-02-22','11:20:00',1.68),('12374','2013-02-22','11:25:00',1.4),('12374','2013-02-22','11:55:00',1.14),('12374','2013-02-22','12:00:00',1.78),('12374','2013-02-22','12:05:00',1.97),('12374','2013-02-22','12:10:00',1.83),('12374','2013-02-22','12:15:00',2),('12374','2013-02-22','12:20:00',2.12),('12374','2013-02-22','12:25:00',1.63),('12374','2013-02-22','12:30:00',1.09),('12374','2013-02-22','13:00:00',1.33),('12374','2013-02-22','13:05:00',2.08),('12374','2013-02-22','13:10:00',1.11),('12374','2013-02-22','13:40:00',2.47),('12374','2013-02-22','13:45:00',3.31),('12374','2013-02-22','13:50:00',2.6),('12374','2013-02-22','13:55:00',3.12),('12374','2013-02-22','14:00:00',2.23),('12374','2013-02-22','14:10:00',1.15),('12374','2013-02-22','14:15:00',1.3),('12374','2013-02-22','14:25:00',1.68),('12374','2013-02-22','14:30:00',3.67),('12374','2013-02-22','14:35:00',3.14),('12374','2013-02-22','14:40:00',4.02),('12374','2013-02-22','14:45:00',5.4),('12374','2013-02-22','14:50:00',5.36),('12374','2013-02-22','14:55:00',4.09),('12374','2013-02-22','15:00:00',2.78),('12374','2013-02-22','15:05:00',2.3),('12374','2013-02-22','15:10:00',1.39),('12374','2013-02-22','15:45:00',2.58),('12374','2013-02-22','15:50:00',1.59),('12374','2013-02-22','15:55:00',1.33),('12374','2013-02-22','16:00:00',1.23),('12374','2013-02-22','16:05:00',1.29),('12374','2013-02-22','16:10:00',2.41),('12374','2013-02-22','16:15:00',2.9),('12374','2013-02-21','09:15:00',1.09),('12374','2013-02-21','09:20:00',1.24),('12374','2013-02-21','09:25:00',1.38),('12374','2013-02-21','09:30:00',1.44),('12374','2013-02-21','09:35:00',1.47),('12374','2013-02-21','09:40:00',1.52),('12374','2013-02-21','09:45:00',1.53),('12374','2013-02-21','09:50:00',1.62),('12374','2013-02-21','09:55:00',1.71),('12374','2013-02-21','10:00:00',1.79),('12374','2013-02-21','10:05:00',1.91),('12374','2013-02-21','10:10:00',2.01),('12374','2013-02-21','10:15:00',1.97),('12374','2013-02-21','10:20:00',1.97),('12374','2013-02-21','10:25:00',2.06),('12374','2013-02-21','10:30:00',2.17),('12374','2013-02-21','10:35:00',2.15),('12374','2013-02-21','10:40:00',2.08),('12374','2013-02-21','10:45:00',1.92),('12374','2013-02-21','10:50:00',1.75),('12374','2013-02-21','10:55:00',1.72),('12374','2013-02-21','11:00:00',1.64),('12374','2013-02-21','11:05:00',1.67),('12374','2013-02-21','11:10:00',1.81),('12374','2013-02-21','11:15:00',1.94),('12374','2013-02-21','11:20:00',2.13),('12374','2013-02-21','11:25:00',2.15),('12374','2013-02-21','11:30:00',2.22),('12374','2013-02-21','11:35:00',2.25),('12374','2013-02-21','11:40:00',2.27),('12374','2013-02-21','11:45:00',2.39),('12374','2013-02-21','11:50:00',2.51),('12374','2013-02-21','11:55:00',2.62),('12374','2013-02-21','12:00:00',2.61),('12374','2013-02-21','12:05:00',2.68),('12374','2013-02-21','12:10:00',2.74),('12374','2013-02-21','12:15:00',2.6),('12374','2013-02-21','12:20:00',2.36),('12374','2013-02-21','12:25:00',2.1),('12374','2013-02-21','12:30:00',1.88),('12374','2013-02-21','12:35:00',1.55),('12374','2013-02-21','12:40:00',1.46),('12374','2013-02-21','12:45:00',1.58),('12374','2013-02-21','12:50:00',1.83),('12374','2013-02-21','12:55:00',2.09),('12374','2013-02-21','13:00:00',2.5),('12374','2013-02-21','13:05:00',2.97),('12374','2013-02-21','13:10:00',3),('12374','2013-02-21','13:15:00',4.06),('12374','2013-02-21','13:20:00',4.8),('12374','2013-02-21','13:25:00',3.61),('12374','2013-02-21','13:30:00',3.36),('12374','2013-02-21','13:35:00',3.04),('12374','2013-02-21','13:40:00',3.16),('12374','2013-02-21','13:45:00',3.69),('12374','2013-02-21','13:50:00',3.35),('12374','2013-02-21','13:55:00',3.33),('12374','2013-02-21','14:00:00',3.88),('12374','2013-02-21','14:05:00',4.16),('12374','2013-02-21','14:10:00',3.08),('12374','2013-02-21','14:15:00',2.71),('12374','2013-02-21','14:20:00',2.41),('12374','2013-02-21','14:25:00',2.24),('12374','2013-02-21','14:30:00',2.17),('12374','2013-02-21','14:35:00',2.23),('12374','2013-02-21','14:40:00',2.68),('12374','2013-02-21','14:45:00',3.61),('12374','2013-02-21','14:50:00',5.6),('12374','2013-02-21','14:55:00',6.63),('12374','2013-02-21','15:00:00',6.23),('12374','2013-02-21','15:05:00',5.98),('12374','2013-02-21','15:10:00',5.66),('12374','2013-02-21','15:15:00',5.35),('12374','2013-02-21','15:20:00',5.12),('12374','2013-02-21','15:25:00',4.91),('12374','2013-02-21','15:30:00',4.66),('12374','2013-02-21','15:35:00',4.44),('12374','2013-02-21','15:40:00',4.28),('12374','2013-02-21','15:45:00',4.15),('12374','2013-02-21','15:50:00',3.95),('12374','2013-02-21','15:55:00',3.77),('12374','2013-02-21','16:00:00',3.61),('12374','2013-02-21','16:05:00',3.32),('12374','2013-02-21','16:10:00',3.19),('12374','2013-02-21','16:15:00',3.05),('12374','2013-02-21','16:20:00',2.85),('12374','2013-02-21','16:25:00',2.65),('12374','2013-02-21','16:30:00',2.5),('12374','2013-02-21','16:35:00',2.29),('12374','2013-02-21','16:40:00',2.07),('12374','2013-02-21','16:45:00',1.85),('12374','2013-02-21','16:50:00',1.66),('12374','2013-02-21','16:55:00',1.45),('12374','2013-02-21','17:00:00',1.2),('12374','2013-02-20','08:15:00',1.17),('12374','2013-02-20','08:20:00',2.41),('12374','2013-02-20','08:25:00',2.43),('12374','2013-02-20','08:30:00',3.46),('12374','2013-02-20','08:35:00',3.76),('12374','2013-02-20','08:40:00',3.91),('12374','2013-02-20','08:45:00',4.05),('12374','2013-02-20','08:50:00',4.22),('12374','2013-02-20','08:55:00',4.37),('12374','2013-02-20','09:00:00',4.53),('12374','2013-02-20','09:05:00',4.13),('12374','2013-02-20','09:10:00',3.72),('12374','2013-02-20','09:15:00',4.36),('12374','2013-02-20','09:20:00',4.17),('12374','2013-02-20','09:25:00',4.67),('12374','2013-02-20','09:30:00',5.54),('12374','2013-02-20','09:35:00',5.72),('12374','2013-02-20','09:40:00',5.81),('12374','2013-02-20','09:45:00',6.04),('12374','2013-02-20','09:50:00',6.31),('12374','2013-02-20','09:55:00',5.88),('12374','2013-02-20','10:00:00',5.4),('12374','2013-02-20','10:05:00',3.17),('12374','2013-02-20','10:10:00',2.52),('12374','2013-02-20','10:15:00',2.95),('12374','2013-02-20','10:20:00',4),('12374','2013-02-20','10:25:00',5.19),('12374','2013-02-20','10:30:00',7.68),('12374','2013-02-20','10:35:00',5.99),('12374','2013-02-20','10:40:00',4.69),('12374','2013-02-20','10:45:00',7.45),('12374','2013-02-20','10:50:00',4.79),('12374','2013-02-20','10:55:00',7.43),('12374','2013-02-20','11:00:00',4.02),('12374','2013-02-20','11:05:00',6.47),('12374','2013-02-20','11:10:00',8.93),('12374','2013-02-20','11:15:00',9.17),('12374','2013-02-20','11:20:00',8.57),('12374','2013-02-20','11:25:00',2.59),('12374','2013-02-20','11:30:00',3.41),('12374','2013-02-20','11:35:00',4.84),('12374','2013-02-20','11:40:00',8.19),('12374','2013-02-20','11:45:00',8.26),('12374','2013-02-20','11:50:00',5.19),('12374','2013-02-20','11:55:00',5.94),('12374','2013-02-20','12:00:00',5.14),('12374','2013-02-20','12:05:00',5.06),('12374','2013-02-20','12:10:00',4.04),('12374','2013-02-20','12:15:00',8.62),('12374','2013-02-20','12:20:00',9.47),('12374','2013-02-20','12:25:00',5.41),('12374','2013-02-20','12:30:00',7.83),('12374','2013-02-20','12:35:00',7.01),('12374','2013-02-20','12:40:00',6.32),('12374','2013-02-20','12:45:00',9.11),('12374','2013-02-20','12:50:00',8.61),('12374','2013-02-20','12:55:00',8.34),('12374','2013-02-20','13:00:00',8.14),('12374','2013-02-20','13:05:00',8.34),('12374','2013-02-20','13:10:00',8.2),('12374','2013-02-20','13:15:00',8.03),('12374','2013-02-20','13:20:00',7.93),('12374','2013-02-20','13:25:00',7.18),('12374','2013-02-20','13:30:00',7.58),('12374','2013-02-20','13:35:00',7.81),('12374','2013-02-20','13:40:00',7.75),('12374','2013-02-20','13:45:00',7.32),('12374','2013-02-20','13:50:00',7.54),('12374','2013-02-20','13:55:00',7.33),('12374','2013-02-20','14:00:00',6.9),('12374','2013-02-20','14:05:00',7.17),('12374','2013-02-20','14:10:00',7.17),('12374','2013-02-20','14:15:00',7.17),('12374','2013-02-20','14:20:00',7.07),('12374','2013-02-20','14:25:00',6.77),('12374','2013-02-20','14:30:00',6.61),('12374','2013-02-20','14:35:00',6.4),('12374','2013-02-20','14:40:00',6.39),('12374','2013-02-20','14:45:00',5.85),('12374','2013-02-20','14:50:00',4.23),('12374','2013-02-20','14:55:00',5.09),('12374','2013-02-20','15:00:00',4.41),('12374','2013-02-20','15:05:00',3.73),('12374','2013-02-20','15:10:00',4.64),('12374','2013-02-20','15:15:00',5.23),('12374','2013-02-20','15:20:00',3.6),('12374','2013-02-20','15:25:00',3),('12374','2013-02-20','15:30:00',3.77),('12374','2013-02-20','15:35:00',3.89),('12374','2013-02-20','15:40:00',3.72),('12374','2013-02-20','15:45:00',3.98),('12374','2013-02-20','15:51:00',4.16),('12374','2013-02-20','15:55:00',3.54),('12374','2013-02-20','16:00:00',3.62),('12374','2013-02-20','16:05:00',3.51),('12374','2013-02-20','16:10:00',2.84),('12374','2013-02-20','16:15:00',3.47),('12374','2013-02-20','16:20:00',3),('12374','2013-02-20','16:25:00',1.95),('12374','2013-02-20','16:30:00',2.6),('12374','2013-02-20','16:35:00',2.85),('12374','2013-02-20','16:40:00',2.54),('12374','2013-02-20','16:45:00',2.39),('12374','2013-02-20','16:50:00',2.14),('12374','2013-02-20','16:55:00',1.52),('12374','2013-02-20','17:00:00',1.24),('12374','2013-02-19','07:35:00',1.08),('12374','2013-02-19','07:40:00',1.31),('12374','2013-02-19','07:45:00',1.73),('12374','2013-02-19','07:50:00',1.98),('12374','2013-02-19','07:55:00',2.19),('12374','2013-02-19','08:00:00',2.38),('12374','2013-02-19','08:05:00',2.48),('12374','2013-02-19','08:10:00',2.87),('12374','2013-02-19','08:15:00',3.08),('12374','2013-02-19','08:20:00',2.91),('12374','2013-02-19','08:25:00',3.14),('12374','2013-02-19','08:30:00',3.61),('12374','2013-02-19','08:35:00',3.81),('12374','2013-02-19','08:40:00',3.96),('12374','2013-02-19','08:45:00',4.12),('12374','2013-02-19','08:50:00',4.3),('12374','2013-02-19','08:55:00',4.41),('12374','2013-02-19','09:00:00',4.59),('12374','2013-02-19','09:05:00',4.77),('12374','2013-02-19','09:10:00',4.9),('12374','2013-02-19','09:15:00',5.05),('12374','2013-02-19','09:20:00',5.2),('12374','2013-02-19','09:25:00',5.37),('12374','2013-02-19','09:30:00',5.53),('12374','2013-02-19','09:35:00',5.69),('12374','2013-02-19','09:40:00',5.82),('12374','2013-02-19','09:45:00',5.99),('12374','2013-02-19','09:50:00',6.11),('12374','2013-02-19','09:55:00',6.3),('12374','2013-02-19','10:00:00',6.42),('12374','2013-02-19','10:05:00',6.57),('12374','2013-02-19','10:10:00',6.67),('12374','2013-02-19','10:15:00',6.78),('12374','2013-02-19','10:20:00',6.89),('12374','2013-02-19','10:25:00',7.01),('12374','2013-02-19','10:30:00',7.09),('12374','2013-02-19','10:35:00',7.2),('12374','2013-02-19','10:40:00',7.25),('12374','2013-02-19','10:45:00',7.36),('12374','2013-02-19','10:50:00',7.44),('12374','2013-02-19','10:55:00',7.48),('12374','2013-02-19','11:00:00',7.57),('12374','2013-02-19','11:05:00',7.6),('12374','2013-02-19','11:10:00',7.63),('12374','2013-02-19','11:15:00',7.67),('12374','2013-02-19','11:20:00',7.75),('12374','2013-02-19','11:25:00',7.78),('12374','2013-02-19','11:30:00',7.76),('12374','2013-02-19','11:35:00',7.82),('12374','2013-02-19','11:40:00',7.9),('12374','2013-02-19','11:45:00',7.88),('12374','2013-02-19','11:50:00',7.88),('12374','2013-02-19','11:55:00',7.89),('12374','2013-02-19','12:00:00',8.03),('12374','2013-02-19','12:05:00',8.09),('12374','2013-02-19','12:10:00',8.11),('12374','2013-02-19','12:15:00',8.11),('12374','2013-02-19','12:20:00',8.05),('12374','2013-02-19','12:25:00',8),('12374','2013-02-19','12:30:00',7.97),('12374','2013-02-19','12:35:00',8),('12374','2013-02-19','12:40:00',7.97),('12374','2013-02-19','12:45:00',7.92),('12374','2013-02-19','12:50:00',7.88),('12374','2013-02-19','12:55:00',7.91),('12374','2013-02-19','13:00:00',7.85),('12374','2013-02-19','13:05:00',7.78),('12374','2013-02-19','13:10:00',7.8),('12374','2013-02-19','13:15:00',7.73),('12374','2013-02-19','13:20:00',7.67),('12374','2013-02-19','13:25:00',7.65),('12374','2013-02-19','13:30:00',7.55),('12374','2013-02-19','13:35:00',7.51),('12374','2013-02-19','13:40:00',7.39),('12374','2013-02-19','13:45:00',7.31),('12374','2013-02-19','13:50:00',7.27),('12374','2013-02-19','13:55:00',7.21),('12374','2013-02-19','14:00:00',7.14),('12374','2013-02-19','14:05:00',6.99),('12374','2013-02-19','14:10:00',6.94),('12374','2013-02-19','14:15:00',6.8),('12374','2013-02-19','14:20:00',6.7),('12374','2013-02-19','14:25:00',6.58),('12374','2013-02-19','14:30:00',6.42),('12374','2013-02-19','14:35:00',6.32),('12374','2013-02-19','14:40:00',6.16),('12374','2013-02-19','14:45:00',6.02),('12374','2013-02-19','14:50:00',5.89),('12374','2013-02-19','14:55:00',5.76),('12374','2013-02-19','15:00:00',5.56),('12374','2013-02-19','15:05:00',5.44),('12374','2013-02-19','15:10:00',5.32),('12374','2013-02-19','15:15:00',5.16),('12374','2013-02-19','15:20:00',5.01),('12374','2013-02-19','15:25:00',4.83),('12374','2013-02-19','15:30:00',4.68),('12374','2013-02-19','15:35:00',4.53),('12374','2013-02-19','15:40:00',4.38),('12374','2013-02-19','15:45:00',4.21),('12374','2013-02-19','15:50:00',4.03),('12374','2013-02-19','15:55:00',3.87),('12374','2013-02-19','16:00:00',3.67),('12374','2013-02-19','16:05:00',3.43),('12374','2013-02-19','16:10:00',3.29),('12374','2013-02-19','16:15:00',3.09),('12374','2013-02-19','16:20:00',2.82),('12374','2013-02-19','16:25:00',2.51),('12374','2013-02-19','16:30:00',2.48),('12374','2013-02-19','16:35:00',2.3),('12374','2013-02-19','16:40:00',2.07),('12374','2013-02-19','16:45:00',1.81),('12374','2013-02-19','16:50:00',1.59),('12374','2013-02-19','16:55:00',1.37),('12374','2013-02-19','17:00:00',1.11),('12374','2013-02-18','08:05:00',1.5),('12374','2013-02-18','08:10:00',2.61),('12374','2013-02-18','08:15:00',2.42),('12374','2013-02-18','08:20:00',2.78),('12374','2013-02-18','08:25:00',3.04),('12374','2013-02-18','08:30:00',3.27),('12374','2013-02-18','08:35:00',3.61),('12374','2013-02-18','08:40:00',3.29),('12374','2013-02-18','08:45:00',3.98),('12374','2013-02-18','08:50:00',3.92),('12374','2013-02-18','08:55:00',4.44),('12374','2013-02-18','09:00:00',4.56),('12374','2013-02-18','09:05:00',4.66),('12374','2013-02-18','09:10:00',2.34),('12374','2013-02-18','09:15:00',2.39),('12374','2013-02-18','09:20:00',1.88),('12374','2013-02-18','09:25:00',3.86),('12374','2013-02-18','09:30:00',3.35),('12374','2013-02-18','09:35:00',6.1),('12374','2013-02-18','09:40:00',4.42),('12374','2013-02-18','09:45:00',5.63),('12374','2013-02-18','09:50:00',4.86),('12374','2013-02-18','09:55:00',3.25),('12374','2013-02-18','10:00:00',2.13),('12374','2013-02-18','10:05:00',4.35),('12374','2013-02-18','10:10:00',7.36),('12374','2013-02-18','10:15:00',6.49),('12374','2013-02-18','10:20:00',6.73),('12374','2013-02-18','10:25:00',6.3),('12374','2013-02-18','10:30:00',6.62),('12374','2013-02-18','10:35:00',7.04),('12374','2013-02-18','10:40:00',7.41),('12374','2013-02-18','10:45:00',7.76),('12374','2013-02-18','10:50:00',7.08),('12374','2013-02-18','10:55:00',5.37),('12374','2013-02-18','11:00:00',4.71),('12374','2013-02-18','11:05:00',5.39),('12374','2013-02-18','11:10:00',4.58),('12374','2013-02-18','11:15:00',6.69),('12374','2013-02-18','11:20:00',6.85),('12374','2013-02-18','11:25:00',7.03),('12374','2013-02-18','11:30:00',7.79),('12374','2013-02-18','11:35:00',3.61),('12374','2013-02-18','11:40:00',3.45),('12374','2013-02-18','11:45:00',3.31),('12374','2013-02-18','11:50:00',3.63),('12374','2013-02-18','11:55:00',3.38),('12374','2013-02-18','12:00:00',3.04),('12374','2013-02-18','12:05:00',3.4),('12374','2013-02-18','12:10:00',3.9),('12374','2013-02-18','12:15:00',3.8),('12374','2013-02-18','12:20:00',4.39),('12374','2013-02-18','12:25:00',4.83),('12374','2013-02-18','12:30:00',4.84),('12374','2013-02-18','12:35:00',4.8),('12374','2013-02-18','12:40:00',4.71),('12374','2013-02-18','12:45:00',5),('12374','2013-02-18','12:50:00',4.47),('12374','2013-02-18','12:55:00',4.23),('12374','2013-02-18','13:00:00',3.53),('12374','2013-02-18','13:05:00',3.44),('12374','2013-02-18','13:10:00',3.43),('12374','2013-02-18','13:15:00',3.14),('12374','2013-02-18','13:20:00',3.13),('12374','2013-02-18','13:25:00',3.64),('12374','2013-02-18','13:30:00',3.57),('12374','2013-02-18','13:35:00',3.72),('12374','2013-02-18','13:40:00',3.94),('12374','2013-02-18','13:45:00',3.16),('12374','2013-02-18','13:50:00',2.57),('12374','2013-02-18','13:55:00',2.33),('12374','2013-02-18','14:00:00',2.5),('12374','2013-02-18','14:05:00',2.87),('12374','2013-02-18','14:10:00',3.77),('12374','2013-02-18','14:15:00',3.37),('12374','2013-02-18','14:20:00',3.52),('12374','2013-02-18','14:25:00',3.8),('12374','2013-02-18','14:30:00',2.44),('12374','2013-02-18','14:35:00',2.25),('12374','2013-02-18','14:40:00',2.58),('12374','2013-02-18','14:45:00',3.24),('12374','2013-02-18','14:50:00',3.63),('12374','2013-02-18','14:55:00',5.92),('12374','2013-02-18','15:00:00',2.63),('12374','2013-02-18','15:05:00',1.86),('12374','2013-02-18','15:10:00',1.57),('12374','2013-02-18','15:15:00',1.27),('12374','2013-02-18','15:20:00',1.37),('12374','2013-02-18','15:25:00',1.15),('12374','2013-02-18','15:50:00',1.04),('12374','2013-02-17','07:45:00',1.19),('12374','2013-02-17','07:50:00',1.49),('12374','2013-02-17','07:55:00',1.74),('12374','2013-02-17','08:00:00',1.89),('12374','2013-02-17','08:05:00',2.05),('12374','2013-02-17','08:10:00',2.35),('12374','2013-02-17','08:15:00',2.6),('12374','2013-02-17','08:20:00',2.2),('12374','2013-02-17','08:25:00',2.47),('12374','2013-02-17','08:30:00',2.31),('12374','2013-02-17','08:35:00',3.17),('12374','2013-02-17','08:40:00',3.56),('12374','2013-02-17','08:45:00',3.72),('12374','2013-02-17','08:50:00',3.86),('12374','2013-02-17','08:55:00',3.92),('12374','2013-02-17','09:00:00',4.09),('12374','2013-02-17','09:05:00',3.2),('12374','2013-02-17','09:10:00',4.23),('12374','2013-02-17','09:15:00',4.67),('12374','2013-02-17','09:20:00',4.81),('12374','2013-02-17','09:25:00',4.96),('12374','2013-02-17','09:30:00',5.11),('12374','2013-02-17','09:35:00',5.3),('12374','2013-02-17','09:40:00',5.47),('12374','2013-02-17','09:45:00',5.65),('12374','2013-02-17','09:50:00',5.83),('12374','2013-02-17','09:55:00',5.99),('12374','2013-02-17','10:00:00',6.08),('12374','2013-02-17','10:05:00',6.23),('12374','2013-02-17','10:10:00',6.4),('12374','2013-02-17','10:15:00',6.51),('12374','2013-02-17','10:20:00',6.56),('12374','2013-02-17','10:25:00',6.68),('12374','2013-02-17','10:30:00',6.83),('12374','2013-02-17','10:35:00',6.92),('12374','2013-02-17','10:40:00',7),('12374','2013-02-17','10:45:00',7.11),('12374','2013-02-17','10:50:00',7.17),('12374','2013-02-17','10:55:00',7.2),('12374','2013-02-17','11:00:00',7.33),('12374','2013-02-17','11:05:00',7.4),('12374','2013-02-17','11:10:00',7.41),('12374','2013-02-17','11:15:00',7.5),('12374','2013-02-17','11:20:00',7.56),('12374','2013-02-17','11:25:00',7.6),('12374','2013-02-17','11:30:00',7.66),('12374','2013-02-17','11:35:00',7.69),('12374','2013-02-17','11:40:00',7.75),('12374','2013-02-17','11:45:00',7.82),('12374','2013-02-17','11:50:00',7.76),('12374','2013-02-17','11:55:00',8.08),('12374','2013-02-17','12:00:00',8.46),('12374','2013-02-17','12:05:00',8.05),('12374','2013-02-17','12:10:00',8.01),('12374','2013-02-17','12:15:00',7.99),('12374','2013-02-17','12:20:00',8.19),('12374','2013-02-17','12:25:00',8.07),('12374','2013-02-17','12:30:00',8.05),('12374','2013-02-17','12:35:00',8.3),('12374','2013-02-17','12:40:00',7.72),('12374','2013-02-17','12:45:00',4.82),('12374','2013-02-17','12:50:00',6.44),('12374','2013-02-17','12:55:00',7.55),('12374','2013-02-17','13:00:00',7.79),('12374','2013-02-17','13:05:00',7.71),('12374','2013-02-17','13:10:00',7.59),('12374','2013-02-17','13:15:00',7.17),('12374','2013-02-17','13:20:00',7.57),('12374','2013-02-17','13:25:00',7.93),('12374','2013-02-17','13:30:00',8.37),('12374','2013-02-17','13:35:00',7.99),('12374','2013-02-17','13:40:00',8.32),('12374','2013-02-17','13:45:00',7.87),('12374','2013-02-17','13:50:00',4.23),('12374','2013-02-17','13:55:00',3.35),('12374','2013-02-17','14:00:00',3.07),('12374','2013-02-17','14:05:00',3.71),('12374','2013-02-17','14:10:00',4.72),('12374','2013-02-17','14:15:00',4.13),('12374','2013-02-17','14:20:00',6.58),('12374','2013-02-17','14:25:00',5.64),('12374','2013-02-17','14:30:00',5.37),('12374','2013-02-17','14:35:00',5.32),('12374','2013-02-17','14:40:00',4.96),('12374','2013-02-17','14:45:00',5.83),('12374','2013-02-17','14:50:00',4.7),('12374','2013-02-17','14:55:00',4.8),('12374','2013-02-17','15:00:00',5.55),('12374','2013-02-17','15:05:00',5.42),('12374','2013-02-17','15:10:00',5.44),('12374','2013-02-17','15:15:00',2.63),('12374','2013-02-17','15:20:00',1.8),('12374','2013-02-17','15:25:00',1.88),('12374','2013-02-17','15:30:00',2.12),('12374','2013-02-17','15:35:00',1.89),('12374','2013-02-17','15:40:00',1.73),('12374','2013-02-17','15:45:00',1.63),('12374','2013-02-17','15:50:00',1.37),('12374','2013-02-17','15:55:00',1.06),('12374','2013-02-16','08:05:00',1.05),('12374','2013-02-16','08:10:00',1.25),('12374','2013-02-16','08:15:00',1.73),('12374','2013-02-16','08:20:00',1.83),('12374','2013-02-16','08:25:00',1.84),('12374','2013-02-16','08:30:00',1.62),('12374','2013-02-16','08:35:00',1.68),('12374','2013-02-16','08:40:00',1.68),('12374','2013-02-16','08:45:00',1.6),('12374','2013-02-16','08:50:00',1.8),('12374','2013-02-16','08:55:00',3.34),('12374','2013-02-16','09:00:00',2.52),('12374','2013-02-16','09:05:00',4.05),('12374','2013-02-16','09:10:00',4.5),('12374','2013-02-16','09:15:00',5.04),('12374','2013-02-16','09:20:00',4.97),('12374','2013-02-16','09:25:00',5.19),('12374','2013-02-16','09:30:00',5.19),('12374','2013-02-16','09:35:00',5.29),('12374','2013-02-16','09:40:00',5.51),('12374','2013-02-16','09:45:00',5.67),('12374','2013-02-16','09:50:00',5.86),('12374','2013-02-16','09:55:00',6.04),('12374','2013-02-16','10:00:00',6.13),('12374','2013-02-16','10:05:00',6.41),('12374','2013-02-16','10:10:00',6.22),('12374','2013-02-16','10:15:00',6.21),('12374','2013-02-16','10:20:00',6.82),('12374','2013-02-16','10:25:00',6.31),('12374','2013-02-16','10:30:00',5.45),('12374','2013-02-16','10:35:00',5.77),('12374','2013-02-16','10:40:00',7.1),('12374','2013-02-16','10:45:00',6.16),('12374','2013-02-16','10:50:00',7.34),('12374','2013-02-16','10:55:00',7.28),('12374','2013-02-16','11:00:00',7.44),('12374','2013-02-16','11:05:00',7.48),('12374','2013-02-16','11:10:00',7.35),('12374','2013-02-16','11:15:00',7.94),('12374','2013-02-16','11:20:00',7.3),('12374','2013-02-16','11:25:00',7.34),('12374','2013-02-16','11:30:00',8.11),('12374','2013-02-16','11:35:00',8.33),('12374','2013-02-16','11:40:00',8.26),('12374','2013-02-16','11:45:00',8.14),('12374','2013-02-16','11:50:00',8.31),('12374','2013-02-16','11:55:00',8.4),('12374','2013-02-16','12:00:00',8.66),('12374','2013-02-16','12:05:00',9.04),('12374','2013-02-16','12:10:00',6.87),('12374','2013-02-16','12:15:00',8.24),('12374','2013-02-16','12:20:00',8.67),('12374','2013-02-16','12:25:00',4.67),('12374','2013-02-16','12:30:00',8.11),('12374','2013-02-16','12:35:00',5.27),('12374','2013-02-16','12:40:00',4.04),('12374','2013-02-16','12:45:00',3.13),('12374','2013-02-16','12:50:00',3.38),('12374','2013-02-16','12:55:00',3.76),('12374','2013-02-16','13:00:00',5.17),('12374','2013-02-16','13:05:00',5.13),('12374','2013-02-16','13:10:00',4.27),('12374','2013-02-16','13:15:00',7.11),('12374','2013-02-16','13:20:00',8.94),('12374','2013-02-16','13:25:00',8.57),('12374','2013-02-16','13:30:00',8.38),('12374','2013-02-16','13:35:00',7.46),('12374','2013-02-16','13:40:00',8.37),('12374','2013-02-16','13:45:00',7.39),('12374','2013-02-16','13:50:00',6.95),('12374','2013-02-16','13:55:00',4.04),('12374','2013-02-16','14:00:00',2.62),('12374','2013-02-16','14:05:00',2.58),('12374','2013-02-16','14:10:00',2.43),('12374','2013-02-16','14:15:00',2.32),('12374','2013-02-16','14:20:00',2.27),('12374','2013-02-16','14:25:00',2.25),('12374','2013-02-16','14:30:00',2.1),('12374','2013-02-16','14:35:00',1.98),('12374','2013-02-16','14:40:00',1.95),('12374','2013-02-16','14:45:00',1.98),('12374','2013-02-16','14:50:00',1.98),('12374','2013-02-16','14:55:00',1.94),('12374','2013-02-16','15:00:00',1.94),('12374','2013-02-16','15:05:00',1.83),('12374','2013-02-16','15:10:00',1.77),('12374','2013-02-16','15:15:00',1.77),('12374','2013-02-16','15:20:00',1.71),('12374','2013-02-16','15:25:00',1.69),('12374','2013-02-16','15:30:00',1.96),('12374','2013-02-16','15:35:00',2.22),('12374','2013-02-16','15:40:00',2),('12374','2013-02-16','15:45:00',1.88),('12374','2013-02-16','15:50:00',2.4),('12374','2013-02-16','15:55:00',2.19),('12374','2013-02-16','16:00:00',1.64),('12374','2013-02-16','16:05:00',1.3),('12374','2013-02-15','07:40:00',1.01),('12374','2013-02-15','08:00:00',1.33),('12374','2013-02-15','08:40:00',1.14),('12374','2013-02-15','08:45:00',1.29),('12374','2013-02-15','08:50:00',1.75),('12374','2013-02-15','08:55:00',2.5),('12374','2013-02-15','09:00:00',4.38),('12374','2013-02-15','09:05:00',5.13),('12374','2013-02-15','09:10:00',4.01),('12374','2013-02-15','09:15:00',2.79),('12374','2013-02-15','09:20:00',4.66),('12374','2013-02-15','09:25:00',4.47),('12374','2013-02-15','09:30:00',5.71),('12374','2013-02-15','09:35:00',3.01),('12374','2013-02-15','09:40:00',4.01),('12374','2013-02-15','09:45:00',4.12),('12374','2013-02-15','09:50:00',3.87),('12374','2013-02-15','09:55:00',4.65),('12374','2013-02-15','10:00:00',3.97),('12374','2013-02-15','10:05:00',4.98),('12374','2013-02-15','10:10:00',5.41),('12374','2013-02-15','10:15:00',4.77),('12374','2013-02-15','10:20:00',5.41),('12374','2013-02-15','10:25:00',4.64),('12374','2013-02-15','10:30:00',2.81),('12374','2013-02-15','10:35:00',6.24),('12374','2013-02-15','10:50:00',6.98),('12374','2013-02-15','10:55:00',7.64),('12374','2013-02-15','11:00:00',8.06),('12374','2013-02-15','11:05:00',6.72),('12374','2013-02-15','11:10:00',4.31),('12374','2013-02-15','11:15:00',6.36),('12374','2013-02-15','11:20:00',5.86),('12374','2013-02-15','11:25:00',7.37),('12374','2013-02-15','11:30:00',5.43),('12374','2013-02-15','11:35:00',7.8),('12374','2013-02-15','11:40:00',5.17),('12374','2013-02-15','11:45:00',6.2),('12374','2013-02-15','11:50:00',5.73),('12374','2013-02-15','11:55:00',6.87),('12374','2013-02-15','12:00:00',6.96),('12374','2013-02-15','12:05:00',7.48),('12374','2013-02-15','12:10:00',5),('12374','2013-02-15','12:15:00',5.41),('12374','2013-02-15','12:20:00',7.77),('12374','2013-02-15','12:25:00',7.55),('12374','2013-02-15','12:30:00',6.51),('12374','2013-02-15','12:35:00',7.9),('12374','2013-02-15','12:40:00',8.22),('12374','2013-02-15','12:45:00',5.9),('12374','2013-02-15','12:50:00',6.61),('12374','2013-02-15','12:55:00',5.61),('12374','2013-02-15','13:00:00',8.35),('12374','2013-02-15','13:05:00',8.43),('12374','2013-02-15','13:10:00',5.94),('12374','2013-02-15','13:15:00',5.65),('12374','2013-02-15','13:20:00',4.39),('12374','2013-02-15','13:25:00',5.06),('12374','2013-02-15','13:30:00',8.32),('12374','2013-02-15','13:35:00',8),('12374','2013-02-15','13:40:00',6.77),('12374','2013-02-15','13:45:00',6.62),('12374','2013-02-15','13:50:00',7.4),('12374','2013-02-15','13:55:00',7.69),('12374','2013-02-15','14:00:00',6.56),('12374','2013-02-15','14:05:00',5.87),('12374','2013-02-15','14:10:00',6.21),('12374','2013-02-15','14:15:00',7.41),('12374','2013-02-15','14:20:00',7.37),('12374','2013-02-15','14:25:00',6.34),('12374','2013-02-15','14:30:00',5.27),('12374','2013-02-15','14:35:00',5.31),('12374','2013-02-15','14:40:00',3.94),('12374','2013-02-15','14:45:00',3.91),('12374','2013-02-15','14:50:00',5.35),('12374','2013-02-15','14:55:00',5.04),('12374','2013-02-15','15:00:00',3.96),('12374','2013-02-15','15:05:00',3.01),('12374','2013-02-15','15:10:00',2.42),('12374','2013-02-15','15:15:00',2.53),('12374','2013-02-15','15:20:00',2.89),('12374','2013-02-15','15:25:00',2.5),('12374','2013-02-15','15:30:00',2.24),('12374','2013-02-15','15:35:00',2.05),('12374','2013-02-15','15:40:00',1.94),('12374','2013-02-15','15:45:00',1.89),('12374','2013-02-15','15:50:00',2.08),('12374','2013-02-15','15:55:00',2.36),('12374','2013-02-15','16:00:00',2.31),('12374','2013-02-15','16:05:00',2.12),('12374','2013-02-15','16:10:00',1.85),('12374','2013-02-15','16:15:00',2.32),('12374','2013-02-15','16:20:00',2.54),('12374','2013-02-15','16:25:00',2.15),('12374','2013-02-15','16:30:00',1.72),('12374','2013-02-15','16:35:00',1.26),('12374','2013-02-14','07:40:00',1),('12374','2013-02-14','07:45:00',1.21),('12374','2013-02-14','07:50:00',1.59),('12374','2013-02-14','07:55:00',2.02),('12374','2013-02-14','08:00:00',2.29),('12374','2013-02-14','08:05:00',2.32),('12374','2013-02-14','08:10:00',2.4),('12374','2013-02-14','08:15:00',2.66),('12374','2013-02-14','08:20:00',3.03),('12374','2013-02-14','08:25:00',3.2),('12374','2013-02-14','08:30:00',2.91),('12374','2013-02-14','08:35:00',3.03),('12374','2013-02-14','08:40:00',3.41),('12374','2013-02-14','08:45:00',3.44),('12374','2013-02-14','08:50:00',3.62),('12374','2013-02-14','08:55:00',3.53),('12374','2013-02-14','09:00:00',4),('12374','2013-02-14','09:05:00',4.59),('12374','2013-02-14','09:10:00',4.68),('12374','2013-02-14','09:15:00',4.84),('12374','2013-02-14','09:20:00',4.92),('12374','2013-02-14','09:25:00',4.94),('12374','2013-02-14','09:30:00',5.17),('12374','2013-02-14','09:35:00',5.51),('12374','2013-02-14','09:40:00',5.7),('12374','2013-02-14','09:45:00',5.83),('12374','2013-02-14','09:50:00',5.99),('12374','2013-02-14','09:55:00',6.14),('12374','2013-02-14','10:00:00',6.29),('12374','2013-02-14','10:05:00',6.39),('12374','2013-02-14','10:10:00',6.57),('12374','2013-02-14','10:15:00',6.68),('12374','2013-02-14','10:20:00',6.8),('12374','2013-02-14','10:25:00',6.91),('12374','2013-02-14','10:30:00',7.01),('12374','2013-02-14','10:35:00',7.1),('12374','2013-02-14','10:40:00',7.21),('12374','2013-02-14','10:45:00',7.31),('12374','2013-02-14','10:50:00',7.39),('12374','2013-02-14','10:55:00',7.46),('12374','2013-02-14','11:00:00',7.56),('12374','2013-02-14','11:05:00',7.56),('12374','2013-02-14','11:10:00',7.61),('12374','2013-02-14','11:15:00',7.68),('12374','2013-02-14','11:20:00',7.75),('12374','2013-02-14','11:25:00',7.82),('12374','2013-02-14','11:30:00',7.89),('12374','2013-02-14','11:35:00',7.91),('12374','2013-02-14','11:40:00',7.92),('12374','2013-02-14','11:45:00',7.95),('12374','2013-02-14','11:50:00',7.9),('12374','2013-02-14','11:55:00',7.92),('12374','2013-02-14','12:00:00',7.95),('12374','2013-02-14','12:05:00',8.03),('12374','2013-02-14','12:10:00',8.01),('12374','2013-02-14','12:15:00',8.04),('12374','2013-02-14','12:20:00',8.03),('12374','2013-02-14','12:25:00',8.01),('12374','2013-02-14','12:30:00',7.94),('12374','2013-02-14','12:35:00',7.93),('12374','2013-02-14','12:40:00',7.91),('12374','2013-02-14','12:45:00',7.91),('12374','2013-02-14','12:50:00',7.88),('12374','2013-02-14','12:55:00',7.85),('12374','2013-02-14','13:00:00',7.8),('12374','2013-02-14','13:05:00',7.76),('12374','2013-02-14','13:10:00',7.66),('12374','2013-02-14','13:15:00',7.62),('12374','2013-02-14','13:20:00',7.52),('12374','2013-02-14','13:25:00',7.47),('12374','2013-02-14','13:30:00',7.39),('12374','2013-02-14','13:35:00',7.31),('12374','2013-02-14','13:40:00',7.22),('12374','2013-02-14','13:45:00',7.11),('12374','2013-02-14','13:50:00',7.04),('12374','2013-02-14','13:55:00',6.93),('12374','2013-02-14','14:00:00',6.81),('12374','2013-02-14','14:05:00',6.72),('12374','2013-02-14','14:10:00',6.62),('12374','2013-02-14','14:15:00',6.5),('12374','2013-02-14','14:20:00',6.37),('12374','2013-02-14','14:25:00',6.24),('12374','2013-02-14','14:30:00',6.14),('12374','2013-02-14','14:35:00',5.91),('12374','2013-02-14','14:40:00',5.85),('12374','2013-02-14','14:45:00',5.72),('12374','2013-02-14','14:50:00',5.55),('12374','2013-02-14','14:55:00',5.38),('12374','2013-02-14','15:00:00',5.22),('12374','2013-02-14','15:05:00',5.06),('12374','2013-02-14','15:10:00',4.93),('12374','2013-02-14','15:15:00',4.79),('12374','2013-02-14','15:20:00',4.66),('12374','2013-02-14','15:25:00',4.46),('12374','2013-02-14','15:30:00',4.29),('12374','2013-02-14','15:35:00',4.17),('12374','2013-02-14','15:40:00',4.04),('12374','2013-02-14','15:45:00',3.86),('12374','2013-02-14','15:50:00',3.68),('12374','2013-02-14','15:55:00',3.49),('12374','2013-02-14','16:00:00',3.32),('12374','2013-02-14','16:05:00',3.17),('12374','2013-02-14','16:10:00',2.97),('12374','2013-02-14','16:15:00',2.78),('12374','2013-02-14','16:20:00',2.5),('12374','2013-02-14','16:25:00',2.37),('12374','2013-02-14','16:30:00',2.15),('12374','2013-02-14','16:35:00',1.98),('12374','2013-02-14','16:40:00',1.78),('12374','2013-02-14','16:45:00',1.71),('12374','2013-02-14','16:50:00',1.53),('12374','2013-02-14','16:55:00',1.2),('12374','2013-02-13','08:15:00',1.03),('12374','2013-02-13','08:20:00',1.17),('12374','2013-02-13','08:25:00',1.35),('12374','2013-02-13','08:30:00',1.52),('12374','2013-02-13','08:35:00',1.62),('12374','2013-02-13','08:40:00',2.17),('12374','2013-02-13','08:45:00',2.5),('12374','2013-02-13','08:50:00',2.57),('12374','2013-02-13','08:55:00',2.06),('12374','2013-02-13','09:00:00',1.86),('12374','2013-02-13','09:05:00',2.03),('12374','2013-02-13','09:10:00',2.22),('12374','2013-02-13','09:15:00',3.12),('12374','2013-02-13','09:20:00',2.8),('12374','2013-02-13','09:25:00',2.53),('12374','2013-02-13','09:30:00',3.68),('12374','2013-02-13','09:35:00',4.84),('12374','2013-02-13','09:40:00',4.87),('12374','2013-02-13','09:45:00',5.49),('12374','2013-02-13','09:50:00',5.41),('12374','2013-02-13','09:55:00',5.84),('12374','2013-02-13','10:00:00',6.16),('12374','2013-02-13','10:05:00',6.65),('12374','2013-02-13','10:10:00',6.9),('12374','2013-02-13','10:15:00',7.08),('12374','2013-02-13','10:20:00',6.53),('12374','2013-02-13','10:25:00',6.03),('12374','2013-02-13','10:30:00',6.34),('12374','2013-02-13','10:35:00',7.15),('12374','2013-02-13','10:40:00',7.34),('12374','2013-02-13','10:45:00',7.19),('12374','2013-02-13','10:50:00',7.39),('12374','2013-02-13','10:55:00',7.36),('12374','2013-02-13','11:00:00',7.64),('12374','2013-02-13','11:05:00',7.46),('12374','2013-02-13','11:10:00',7.82),('12374','2013-02-13','11:15:00',7.87),('12374','2013-02-13','11:20:00',7.35),('12374','2013-02-13','11:25:00',7.1),('12374','2013-02-13','11:30:00',7.04),('12374','2013-02-13','11:35:00',7.79),('12374','2013-02-13','11:40:00',7.09),('12374','2013-02-13','11:45:00',7.77),('12374','2013-02-13','11:50:00',7.78),('12374','2013-02-13','11:55:00',6.73),('12374','2013-02-13','12:00:00',7.43),('12374','2013-02-13','12:05:00',3.24),('12374','2013-02-13','12:10:00',3.03),('12374','2013-02-13','12:15:00',2.9),('12374','2013-02-13','12:20:00',4.32),('12374','2013-02-13','12:25:00',7.31),('12374','2013-02-13','12:30:00',7.56),('12374','2013-02-13','12:35:00',8.05),('12374','2013-02-13','12:40:00',8.15),('12374','2013-02-13','12:45:00',7.79),('12374','2013-02-13','12:50:00',7.91),('12374','2013-02-13','12:55:00',7.89),('12374','2013-02-13','13:00:00',7.68),('12374','2013-02-13','13:05:00',7.08),('12374','2013-02-13','13:10:00',7.09),('12374','2013-02-13','13:15:00',7.13),('12374','2013-02-13','13:20:00',7),('12374','2013-02-13','13:25:00',5.8),('12374','2013-02-13','13:30:00',4.96),('12374','2013-02-13','13:35:00',5.89),('12374','2013-02-13','13:40:00',7.01),('12374','2013-02-13','13:45:00',7.56),('12374','2013-02-13','13:50:00',7.13),('12374','2013-02-13','13:55:00',6.75),('12374','2013-02-13','14:00:00',7.15),('12374','2013-02-13','14:05:00',7.07),('12374','2013-02-13','14:10:00',6.35),('12374','2013-02-13','14:15:00',5.62),('12374','2013-02-13','14:20:00',5.45),('12374','2013-02-13','14:25:00',5.16),('12374','2013-02-13','14:30:00',5.06),('12374','2013-02-13','14:35:00',5.11),('12374','2013-02-13','14:40:00',5.53),('12374','2013-02-13','14:45:00',5.72),('12374','2013-02-13','14:50:00',5.99),('12374','2013-02-13','14:55:00',5.71),('12374','2013-02-13','15:00:00',5.45),('12374','2013-02-13','15:05:00',4.69),('12374','2013-02-13','15:10:00',4.86),('12374','2013-02-13','15:15:00',4.96),('12374','2013-02-13','15:20:00',4.81),('12374','2013-02-13','15:25:00',4.5),('12374','2013-02-13','15:30:00',3.83),('12374','2013-02-13','15:35:00',3.97),('12374','2013-02-13','15:40:00',3.7),('12374','2013-02-13','15:45:00',3.98),('12374','2013-02-13','15:50:00',3.87),('12374','2013-02-13','15:55:00',3.64),('12374','2013-02-13','16:00:00',3.44),('12374','2013-02-13','16:05:00',3.31),('12374','2013-02-13','16:10:00',3.19),('12374','2013-02-13','16:15:00',3),('12374','2013-02-13','16:20:00',2.6),('12374','2013-02-13','16:25:00',2.59),('12374','2013-02-13','16:30:00',2.42),('12374','2013-02-13','16:35:00',2.23),('12374','2013-02-13','16:40:00',2.03),('12374','2013-02-13','16:45:00',1.83),('12374','2013-02-13','16:50:00',1.61),('12374','2013-02-13','16:55:00',1.27),('12374','2013-02-12','10:40:00',1.02),('12374','2013-02-12','11:20:00',1.04),('12374','2013-02-12','11:25:00',1.13),('12374','2013-02-12','11:30:00',1.23),('12374','2013-02-12','11:35:00',1.26),('12374','2013-02-12','11:40:00',1.17),('12374','2013-02-12','11:45:00',1.05),('12374','2013-02-12','11:50:00',1.04),('12374','2013-02-12','11:55:00',1.03),('12374','2013-02-12','12:00:00',1),('12374','2013-02-12','12:05:00',1.01),('12374','2013-02-12','12:10:00',1.03),('12374','2013-02-12','12:15:00',1),('12374','2013-02-12','12:20:00',1.09),('12374','2013-02-12','12:25:00',1.15),('12374','2013-02-12','12:30:00',1.15),('12374','2013-02-12','12:35:00',1.15),('12374','2013-02-12','12:40:00',1.09),('12374','2013-02-12','13:40:00',1.08),('12374','2013-02-12','13:45:00',1.16),('12374','2013-02-12','13:50:00',1.26),('12374','2013-02-12','13:55:00',1.31),('12374','2013-02-12','14:00:00',1.25),('12374','2013-02-12','14:05:00',1.2),('12374','2013-02-12','14:10:00',1.16),('12374','2013-02-12','14:15:00',1.08),('12374','2013-02-12','14:20:00',1.09),('12374','2013-02-12','14:25:00',1.02),('12374','2013-02-12','15:10:00',1.12),('12374','2013-02-12','15:15:00',1.08),('12374','2013-02-11','08:55:00',1.01),('12374','2013-02-11','09:00:00',1.2),('12374','2013-02-11','09:05:00',1.2),('12374','2013-02-11','09:10:00',1.25),('12374','2013-02-11','09:15:00',1.39),('12374','2013-02-11','09:20:00',1.31),('12374','2013-02-11','09:25:00',1.35),('12374','2013-02-11','09:30:00',1.73),('12374','2013-02-11','09:35:00',2.11),('12374','2013-02-11','09:40:00',2.48),('12374','2013-02-11','09:45:00',2.63),('12374','2013-02-11','09:50:00',2.12),('12374','2013-02-11','09:55:00',1.92),('12374','2013-02-11','10:00:00',2.26),('12374','2013-02-11','10:05:00',2.19),('12374','2013-02-11','10:10:00',1.71),('12374','2013-02-11','10:15:00',1.8),('12374','2013-02-11','10:20:00',1.64),('12374','2013-02-11','11:50:00',1.29),('12374','2013-02-11','11:55:00',1.34),('12374','2013-02-11','12:45:00',1.37),('12374','2013-02-11','13:45:00',1.49),('12374','2013-02-11','14:00:00',1.17),('12374','2013-02-11','14:05:00',1.43),('12374','2013-02-11','14:10:00',1.61),('12374','2013-02-11','14:15:00',1.31),('12374','2013-02-11','14:20:00',1.15),('12374','2013-02-11','14:25:00',1.2),('12374','2013-02-11','14:35:00',1.03),('12374','2013-02-11','15:55:00',1.12),('12374','2013-02-10','08:45:00',1.07),('12374','2013-02-10','08:50:00',1.55),('12374','2013-02-10','08:55:00',1.78),('12374','2013-02-10','09:00:00',3.2),('12374','2013-02-10','09:05:00',4.27),('12374','2013-02-10','09:10:00',4.62),('12374','2013-02-10','09:15:00',4.91),('12374','2013-02-10','09:20:00',3.12),('12374','2013-02-10','09:25:00',4.49),('12374','2013-02-10','09:30:00',5.3),('12374','2013-02-10','09:35:00',5.44),('12374','2013-02-10','09:40:00',5.56),('12374','2013-02-10','09:45:00',5.68),('12374','2013-02-10','09:50:00',5.86),('12374','2013-02-10','09:55:00',6.14),('12374','2013-02-10','10:00:00',6.51),('12374','2013-02-10','10:05:00',6.83),('12374','2013-02-10','10:10:00',6.3),('12374','2013-02-10','10:15:00',6.88),('12374','2013-02-10','10:20:00',6.81),('12374','2013-02-10','10:25:00',6.84),('12374','2013-02-10','10:30:00',6.95),('12374','2013-02-10','10:35:00',7),('12374','2013-02-10','10:40:00',7.14),('12374','2013-02-10','10:45:00',7.16),('12374','2013-02-10','10:50:00',7.18),('12374','2013-02-10','10:55:00',7.33),('12374','2013-02-10','11:00:00',7.12),('12374','2013-02-10','11:05:00',6.89),('12374','2013-02-10','11:10:00',7.55),('12374','2013-02-10','11:15:00',7.62),('12374','2013-02-10','11:20:00',7.7),('12374','2013-02-10','11:25:00',7.67),('12374','2013-02-10','11:30:00',7.78),('12374','2013-02-10','11:35:00',7.81),('12374','2013-02-10','11:40:00',7.85),('12374','2013-02-10','11:45:00',7.84),('12374','2013-02-10','11:50:00',7.83),('12374','2013-02-10','11:55:00',7.85),('12374','2013-02-10','12:00:00',7.87),('12374','2013-02-10','12:05:00',7.9),('12374','2013-02-10','12:10:00',7.9),('12374','2013-02-10','12:15:00',7.92),('12374','2013-02-10','12:20:00',7.88),('12374','2013-02-10','12:25:00',7.8),('12374','2013-02-10','12:30:00',7.8),('12374','2013-02-10','12:35:00',7.83),('12374','2013-02-10','12:40:00',7.89),('12374','2013-02-10','12:45:00',7.96),('12374','2013-02-10','12:50:00',7.94),('12374','2013-02-10','12:55:00',7.78),('12374','2013-02-10','13:00:00',7.69),('12374','2013-02-10','13:05:00',7.77),('12374','2013-02-10','13:10:00',7.63),('12374','2013-02-10','13:15:00',7.66),('12374','2013-02-10','13:20:00',7.53),('12374','2013-02-10','13:25:00',7.56),('12374','2013-02-10','13:30:00',7.54),('12374','2013-02-10','13:35:00',7.59),('12374','2013-02-10','13:40:00',7.73),('12374','2013-02-10','13:45:00',7.95),('12374','2013-02-10','13:50:00',8.19),('12374','2013-02-10','13:55:00',8.12),('12374','2013-02-10','14:00:00',8.07),('12374','2013-02-10','14:05:00',7.86),('12374','2013-02-10','14:10:00',7.61),('12374','2013-02-10','14:15:00',7.64),('12374','2013-02-10','14:20:00',7.6),('12374','2013-02-10','14:25:00',7.39),('12374','2013-02-10','14:30:00',7.12),('12374','2013-02-10','14:35:00',6.81),('12374','2013-02-10','14:40:00',6.61),('12374','2013-02-10','14:45:00',6.39),('12374','2013-02-10','14:50:00',6.22),('12374','2013-02-10','14:55:00',6.5),('12374','2013-02-10','15:00:00',6.7),('12374','2013-02-10','15:05:00',6.77),('12374','2013-02-10','15:10:00',6.64),('12374','2013-02-10','15:15:00',6.42),('12374','2013-02-10','15:20:00',6.29),('12374','2013-02-10','15:25:00',3.64),('12374','2013-02-10','15:30:00',2.34),('12374','2013-02-10','15:35:00',3.53),('12374','2013-02-10','15:40:00',4.87),('12374','2013-02-10','15:45:00',3.6),('12374','2013-02-10','15:50:00',1.88),('12374','2013-02-10','15:55:00',1.49),('12374','2013-02-10','16:00:00',1.87),('12374','2013-02-10','16:05:00',3.09),('12374','2013-02-10','16:10:00',3.92),('12374','2013-02-10','16:15:00',3.54),('12374','2013-02-10','16:20:00',2.98),('12374','2013-02-10','16:25:00',2.86),('12374','2013-02-10','16:30:00',2.69),('12374','2013-02-10','16:35:00',2.65),('12374','2013-02-10','16:40:00',2.4),('12374','2013-02-10','16:45:00',2.02),('12374','2013-02-10','16:50:00',1.62),('12374','2013-02-09','09:05:00',1.05),('12374','2013-02-09','09:10:00',1.17),('12374','2013-02-09','09:15:00',1.23),('12374','2013-02-09','09:20:00',1.24),('12374','2013-02-09','09:25:00',1.31),('12374','2013-02-09','09:30:00',1.41),('12374','2013-02-09','09:35:00',1.51),('12374','2013-02-09','09:40:00',1.64),('12374','2013-02-09','09:45:00',1.83),('12374','2013-02-09','09:50:00',2),('12374','2013-02-09','09:55:00',2.1),('12374','2013-02-09','10:00:00',2.15),('12374','2013-02-09','10:05:00',2.24),('12374','2013-02-09','10:10:00',2.22),('12374','2013-02-09','10:15:00',2.23),('12374','2013-02-09','10:20:00',2.21),('12374','2013-02-09','10:25:00',2.19),('12374','2013-02-09','10:30:00',2.3),('12374','2013-02-09','10:35:00',2.36),('12374','2013-02-09','10:40:00',2.37),('12374','2013-02-09','10:45:00',2.28),('12374','2013-02-09','10:50:00',2.28),('12374','2013-02-09','10:55:00',2.4),('12374','2013-02-09','11:00:00',2.51),('12374','2013-02-09','11:05:00',2.66),('12374','2013-02-09','11:10:00',2.71),('12374','2013-02-09','11:15:00',2.69),('12374','2013-02-09','11:20:00',2.7),('12374','2013-02-09','11:25:00',2.75),('12374','2013-02-09','11:30:00',2.73),('12374','2013-02-09','11:35:00',2.77),('12374','2013-02-09','11:40:00',2.88),('12374','2013-02-09','11:45:00',2.9),('12374','2013-02-09','11:50:00',3.02),('12374','2013-02-09','11:55:00',3.12),('12374','2013-02-09','12:00:00',3.49),('12374','2013-02-09','12:05:00',3.83),('12374','2013-02-09','12:10:00',3.54),('12374','2013-02-09','12:15:00',3.34),('12374','2013-02-09','12:20:00',3.35),('12374','2013-02-09','12:25:00',3.47),('12374','2013-02-09','12:30:00',3.79),('12374','2013-02-09','12:35:00',4.34),('12374','2013-02-09','12:40:00',4.76),('12374','2013-02-09','12:45:00',5.45),('12374','2013-02-09','12:50:00',6.24),('12374','2013-02-09','12:55:00',6.78),('12374','2013-02-09','13:00:00',7.56),('12374','2013-02-09','13:05:00',8.22),('12374','2013-02-09','13:10:00',6.95),('12374','2013-02-09','13:15:00',4.87),('12374','2013-02-09','13:20:00',4.78),('12374','2013-02-09','13:25:00',5.7),('12374','2013-02-09','13:30:00',8.4),('12374','2013-02-09','13:35:00',8.09),('12374','2013-02-09','13:40:00',6.78),('12374','2013-02-09','13:45:00',6.19),('12374','2013-02-09','13:50:00',4.16),('12374','2013-02-09','13:55:00',2.58),('12374','2013-02-09','14:00:00',5.52),('12374','2013-02-09','14:05:00',4.21),('12374','2013-02-09','14:10:00',7.02),('12374','2013-02-09','14:15:00',7.03),('12374','2013-02-09','14:20:00',6.16),('12374','2013-02-09','14:25:00',6.09),('12374','2013-02-09','14:30:00',6.24),('12374','2013-02-09','14:35:00',6.09),('12374','2013-02-09','14:40:00',5.83),('12374','2013-02-09','14:45:00',5.7),('12374','2013-02-09','14:50:00',5.6),('12374','2013-02-09','14:55:00',5.41),('12374','2013-02-09','15:00:00',5.29),('12374','2013-02-09','15:05:00',5.14),('12374','2013-02-09','15:10:00',4.96),('12374','2013-02-09','15:15:00',4.8),('12374','2013-02-09','15:20:00',4.64),('12374','2013-02-09','15:25:00',4.45),('12374','2013-02-09','15:30:00',4.29),('12374','2013-02-09','15:35:00',4.15),('12374','2013-02-09','15:40:00',4.01),('12374','2013-02-09','15:45:00',3.86),('12374','2013-02-09','15:50:00',3.74),('12374','2013-02-09','15:55:00',3.73),('12374','2013-02-09','16:00:00',3.77),('12374','2013-02-09','16:05:00',3.89),('12374','2013-02-09','16:10:00',3.93),('12374','2013-02-09','16:15:00',3.98),('12374','2013-02-09','16:20:00',4.2),('12374','2013-02-09','16:25:00',4.25),('12374','2013-02-09','16:30:00',3.88),('12374','2013-02-09','16:35:00',3.25),('12374','2013-02-09','16:40:00',2.57),('12374','2013-02-09','16:45:00',1.78),('12374','2013-02-09','16:50:00',1.1),('12374','2013-02-08','08:15:00',1.83),('12374','2013-02-08','08:20:00',2.19),('12374','2013-02-08','08:25:00',2.06),('12374','2013-02-08','08:30:00',3.87),('12374','2013-02-08','08:35:00',2.76),('12374','2013-02-08','08:40:00',3.11),('12374','2013-02-08','08:45:00',4.38),('12374','2013-02-08','08:50:00',5.13),('12374','2013-02-08','08:55:00',5.37),('12374','2013-02-08','09:00:00',5.46),('12374','2013-02-08','09:05:00',5.54),('12374','2013-02-08','09:10:00',5.89),('12374','2013-02-08','09:15:00',5.65),('12374','2013-02-08','09:20:00',5.51),('12374','2013-02-08','09:25:00',5.39),('12374','2013-02-08','09:30:00',5.45),('12374','2013-02-08','09:35:00',5.55),('12374','2013-02-08','09:40:00',6.03),('12374','2013-02-08','09:45:00',6.41),('12374','2013-02-08','09:50:00',6.27),('12374','2013-02-08','09:55:00',6.19),('12374','2013-02-08','10:00:00',6.15),('12374','2013-02-08','10:05:00',6.33),('12374','2013-02-08','10:10:00',6.39),('12374','2013-02-08','10:15:00',6.6),('12374','2013-02-08','10:20:00',6.63),('12374','2013-02-08','10:25:00',6.74),('12374','2013-02-08','10:30:00',6.84),('12374','2013-02-08','10:35:00',6.99),('12374','2013-02-08','10:40:00',7.13),('12374','2013-02-08','10:45:00',7.24),('12374','2013-02-08','10:50:00',7.39),('12374','2013-02-08','10:55:00',7.63),('12374','2013-02-08','11:00:00',8.07),('12374','2013-02-08','11:05:00',8.82),('12374','2013-02-08','11:10:00',8.3),('12374','2013-02-08','11:15:00',7.55),('12374','2013-02-08','11:20:00',7.58),('12374','2013-02-08','11:25:00',7.01),('12374','2013-02-08','11:30:00',4.45),('12374','2013-02-08','11:35:00',6.86),('12374','2013-02-08','11:40:00',7.12),('12374','2013-02-08','11:45:00',8.64),('12374','2013-02-08','11:50:00',6.34),('12374','2013-02-08','11:55:00',5.05),('12374','2013-02-08','12:00:00',7.72),('12374','2013-02-08','12:05:00',8.62),('12374','2013-02-08','12:10:00',8.06),('12374','2013-02-08','12:15:00',7.73),('12374','2013-02-08','12:20:00',8.22),('12374','2013-02-08','12:25:00',8.41),('12374','2013-02-08','12:30:00',8.79),('12374','2013-02-08','12:35:00',8.66),('12374','2013-02-08','12:40:00',6.64),('12374','2013-02-08','12:45:00',4.88),('12374','2013-02-08','12:50:00',4.15),('12374','2013-02-08','12:55:00',6.06),('12374','2013-02-08','13:00:00',5.13),('12374','2013-02-08','13:05:00',4.51),('12374','2013-02-08','13:10:00',2.84),('12374','2013-02-08','13:15:00',2.09),('12374','2013-02-08','13:20:00',1.64),('12374','2013-02-08','13:25:00',1.69),('12374','2013-02-08','13:30:00',2.05),('12374','2013-02-08','13:35:00',2.42),('12374','2013-02-08','13:40:00',2.68),('12374','2013-02-08','13:45:00',2.36),('12374','2013-02-08','13:50:00',2.21),('12374','2013-02-08','13:55:00',2.61),('12374','2013-02-08','14:00:00',2.53),('12374','2013-02-08','14:05:00',2.47),('12374','2013-02-08','14:10:00',2.9),('12374','2013-02-08','14:15:00',4.41),('12374','2013-02-08','14:20:00',2.19),('12374','2013-02-08','14:25:00',1.67),('12374','2013-02-08','14:30:00',1.55),('12374','2013-02-08','14:35:00',1.76),('12374','2013-02-08','14:40:00',2.37),('12374','2013-02-08','14:45:00',2.77),('12374','2013-02-08','14:50:00',2.48),('12374','2013-02-08','14:55:00',2.44),('12374','2013-02-08','15:00:00',1.79),('12374','2013-02-08','15:05:00',1.72),('12374','2013-02-08','15:10:00',1.47),('12374','2013-02-08','15:15:00',1.2),('12374','2013-02-08','15:20:00',1.2),('12374','2013-02-08','15:25:00',1.38),('12374','2013-02-08','15:30:00',1.48),('12374','2013-02-08','15:35:00',1.59),('12374','2013-02-08','15:40:00',1.49),('12374','2013-02-08','15:45:00',1.19),('12374','2013-02-07','08:45:00',1.11),('12374','2013-02-07','08:50:00',1.32),('12374','2013-02-07','08:55:00',1.31),('12374','2013-02-07','09:00:00',3.99),('12374','2013-02-07','09:05:00',4.52),('12374','2013-02-07','09:10:00',4.06),('12374','2013-02-07','09:15:00',1.66),('12374','2013-02-07','09:20:00',1.41),('12374','2013-02-07','09:55:00',1.59),('12374','2013-02-07','10:00:00',3.52),('12374','2013-02-07','10:05:00',6.71),('12374','2013-02-07','10:10:00',7.67),('12374','2013-02-07','10:15:00',6.96),('12374','2013-02-07','10:20:00',6.39),('12374','2013-02-07','10:25:00',7.25),('12374','2013-02-07','10:30:00',2.56),('12374','2013-02-07','10:35:00',1.17),('12374','2013-02-07','11:00:00',1.21),('12374','2013-02-07','11:05:00',4.32),('12374','2013-02-07','11:10:00',6.26),('12374','2013-02-07','11:15:00',7.8),('12374','2013-02-07','11:20:00',7.8),('12374','2013-02-07','11:25:00',7.84),('12374','2013-02-07','11:30:00',7.95),('12374','2013-02-07','11:35:00',8.06),('12374','2013-02-07','11:40:00',8),('12374','2013-02-07','11:45:00',6.63),('12374','2013-02-07','11:50:00',1.26),('12374','2013-02-07','11:55:00',3.33),('12374','2013-02-07','12:00:00',6.18),('12374','2013-02-07','12:05:00',5.8),('12374','2013-02-07','12:10:00',7.26),('12374','2013-02-07','12:15:00',8.35),('12374','2013-02-07','12:20:00',7.91),('12374','2013-02-07','12:25:00',4.9),('12374','2013-02-07','12:30:00',7.43),('12374','2013-02-07','12:35:00',8.43),('12374','2013-02-07','12:40:00',8.32),('12374','2013-02-07','12:45:00',7.61),('12374','2013-02-07','12:50:00',8.88),('12374','2013-02-07','12:55:00',7.8),('12374','2013-02-07','13:00:00',8.21),('12374','2013-02-07','13:05:00',8.59),('12374','2013-02-07','13:10:00',7.67),('12374','2013-02-07','13:15:00',6.37),('12374','2013-02-07','13:20:00',2.39),('12374','2013-02-07','13:25:00',2.27),('12374','2013-02-07','13:30:00',3.11),('12374','2013-02-07','13:35:00',8.53),('12374','2013-02-07','13:40:00',8.75),('12374','2013-02-07','13:45:00',5.72),('12374','2013-02-07','13:50:00',6.98),('12374','2013-02-07','13:55:00',4.86),('12374','2013-02-07','14:00:00',6.21),('12374','2013-02-07','14:05:00',7.62),('12374','2013-02-07','14:10:00',6.77),('12374','2013-02-07','14:15:00',7.37),('12374','2013-02-07','14:20:00',5.76),('12374','2013-02-07','14:25:00',7.55),('12374','2013-02-07','14:30:00',6.02),('12374','2013-02-07','14:35:00',3.85),('12374','2013-02-07','14:40:00',5.47),('12374','2013-02-07','14:45:00',3.14),('12374','2013-02-07','14:50:00',2.51),('12374','2013-02-07','14:55:00',4.66),('12374','2013-02-07','15:00:00',5.89),('12374','2013-02-07','15:05:00',5.04),('12374','2013-02-07','15:10:00',3.22),('12374','2013-02-07','15:15:00',2.36),('12374','2013-02-07','15:20:00',1.6),('12374','2013-02-07','15:25:00',1.35),('12374','2013-02-07','16:45:00',2.08),('12374','2013-02-07','16:50:00',2.45),('12374','2013-02-07','16:55:00',1.43),('12374','2013-02-06','08:15:00',1.16),('12374','2013-02-06','08:20:00',1.02),('12374','2013-02-06','08:25:00',1),('12374','2013-02-06','08:30:00',1.45),('12374','2013-02-06','08:35:00',1.38),('12374','2013-02-06','08:40:00',1.5),('12374','2013-02-06','08:45:00',1.78),('12374','2013-02-06','08:50:00',1.74),('12374','2013-02-06','08:55:00',1.85),('12374','2013-02-06','09:00:00',2.27),('12374','2013-02-06','09:05:00',1.8),('12374','2013-02-06','09:10:00',1.58),('12374','2013-02-06','09:15:00',1.58),('12374','2013-02-06','09:20:00',1.69),('12374','2013-02-06','09:25:00',1.74),('12374','2013-02-06','09:30:00',1.66),('12374','2013-02-06','09:35:00',1.55),('12374','2013-02-06','09:40:00',1.8),('12374','2013-02-06','09:45:00',2),('12374','2013-02-06','09:50:00',1.97),('12374','2013-02-06','09:55:00',1.81),('12374','2013-02-06','10:00:00',1.8),('12374','2013-02-06','10:05:00',1.88),('12374','2013-02-06','10:10:00',2.04),('12374','2013-02-06','10:15:00',2.11),('12374','2013-02-06','10:20:00',3.91),('12374','2013-02-06','10:25:00',3.28),('12374','2013-02-06','10:30:00',3.79),('12374','2013-02-06','10:35:00',3.56),('12374','2013-02-06','10:40:00',3.02),('12374','2013-02-06','10:45:00',2.9),('12374','2013-02-06','10:50:00',2.38),('12374','2013-02-06','10:55:00',2.3),('12374','2013-02-06','11:00:00',2.52),('12374','2013-02-06','11:05:00',2.22),('12374','2013-02-06','11:10:00',1.63),('12374','2013-02-06','11:15:00',2.28),('12374','2013-02-06','11:20:00',2.66),('12374','2013-02-06','11:25:00',2.13),('12374','2013-02-06','11:30:00',1.81),('12374','2013-02-06','11:35:00',2.24),('12374','2013-02-06','11:40:00',1.89),('12374','2013-02-06','11:45:00',1.15),('12374','2013-02-06','11:50:00',1.36),('12374','2013-02-06','12:00:00',2.18),('12374','2013-02-06','12:05:00',3.06),('12374','2013-02-06','12:10:00',2.78),('12374','2013-02-06','12:15:00',2.22),('12374','2013-02-06','12:20:00',2.31),('12374','2013-02-06','12:25:00',2.32),('12374','2013-02-06','12:30:00',4.11),('12374','2013-02-06','12:35:00',5.92),('12374','2013-02-06','12:40:00',3.87),('12374','2013-02-06','12:45:00',3.25),('12374','2013-02-06','12:50:00',3.25),('12374','2013-02-06','12:55:00',2.31),('12374','2013-02-06','13:00:00',2.21),('12374','2013-02-06','13:05:00',2.54),('12374','2013-02-06','13:10:00',1.86),('12374','2013-02-06','13:45:00',1.13),('12374','2013-02-06','13:50:00',1.03),('12374','2013-02-06','14:15:00',1.22),('12374','2013-02-06','14:20:00',3.85),('12374','2013-02-06','14:25:00',1.16),('12374','2013-02-06','14:30:00',1.23),('12374','2013-02-06','14:35:00',6.62),('12374','2013-02-06','14:40:00',4.83),('12374','2013-02-06','14:45:00',3.6),('12374','2013-02-06','14:50:00',2.19),('12374','2013-02-06','14:55:00',4.92),('12374','2013-02-06','15:00:00',6.5),('12374','2013-02-06','15:05:00',5.53),('12374','2013-02-06','15:10:00',3.22),('12374','2013-02-06','15:15:00',3.32),('12374','2013-02-06','15:20:00',3.86),('12374','2013-02-06','15:25:00',2.85),('12374','2013-02-06','15:30:00',1.52),('12374','2013-02-06','15:35:00',1.35),('12374','2013-02-06','15:40:00',1.21),('12374','2013-02-06','15:45:00',1.11),('12374','2013-02-06','15:50:00',1.1),('12374','2013-02-06','15:55:00',1.07),('12374','2013-02-06','16:00:00',1.05),('12374','2013-02-06','16:05:00',1.01),('12374','2013-02-06','16:30:00',1.68),('12374','2013-02-06','16:35:00',1.94),('12374','2013-02-06','16:40:00',1.99),('12374','2013-02-06','16:45:00',1.8),('12374','2013-02-06','16:50:00',1.26),('12374','2013-02-05','07:55:00',1.21),('12374','2013-02-05','08:00:00',1.5),('12374','2013-02-05','08:05:00',1.75),('12374','2013-02-05','08:10:00',2),('12374','2013-02-05','08:15:00',2.07),('12374','2013-02-05','08:20:00',2.22),('12374','2013-02-05','08:25:00',2.63),('12374','2013-02-05','08:30:00',2.88),('12374','2013-02-05','08:35:00',2.75),('12374','2013-02-05','08:40:00',3.08),('12374','2013-02-05','08:45:00',3.51),('12374','2013-02-05','08:50:00',3.74),('12374','2013-02-05','08:55:00',3.92),('12374','2013-02-05','09:00:00',4.09),('12374','2013-02-05','09:05:00',4.23),('12374','2013-02-05','09:10:00',4.39),('12374','2013-02-05','09:15:00',4.39),('12374','2013-02-05','09:20:00',4.66),('12374','2013-02-05','09:25:00',4.76),('12374','2013-02-05','09:30:00',4.9),('12374','2013-02-05','09:35:00',5.02),('12374','2013-02-05','09:40:00',5.11),('12374','2013-02-05','09:45:00',5.27),('12374','2013-02-05','09:50:00',5.45),('12374','2013-02-05','09:55:00',5.58),('12374','2013-02-05','10:00:00',5.74),('12374','2013-02-05','10:05:00',5.91),('12374','2013-02-05','10:10:00',6.03),('12374','2013-02-05','10:15:00',6.13),('12374','2013-02-05','10:20:00',6.22),('12374','2013-02-05','10:25:00',6.3),('12374','2013-02-05','10:30:00',6.47),('12374','2013-02-05','10:35:00',6.57),('12374','2013-02-05','10:40:00',6.72),('12374','2013-02-05','10:45:00',6.82),('12374','2013-02-05','10:50:00',6.83),('12374','2013-02-05','10:55:00',6.85),('12374','2013-02-05','11:00:00',7.16),('12374','2013-02-05','11:05:00',7.17),('12374','2013-02-05','11:10:00',6.82),('12374','2013-02-05','11:15:00',7.18),('12374','2013-02-05','11:20:00',7.1),('12374','2013-02-05','11:25:00',7.27),('12374','2013-02-05','11:30:00',7.21),('12374','2013-02-05','11:35:00',6.82),('12374','2013-02-05','11:40:00',6.42),('12374','2013-02-05','11:45:00',3.78),('12374','2013-02-05','11:50:00',2.97),('12374','2013-02-05','11:55:00',3.12),('12374','2013-02-05','12:00:00',3.71),('12374','2013-02-05','12:05:00',5.24),('12374','2013-02-05','12:10:00',4.47),('12374','2013-02-05','12:15:00',4.1),('12374','2013-02-05','12:20:00',3.63),('12374','2013-02-05','12:25:00',3.3),('12374','2013-02-05','12:30:00',3.49),('12374','2013-02-05','12:35:00',2.95),('12374','2013-02-05','12:40:00',3.6),('12374','2013-02-05','12:45:00',3.5),('12374','2013-02-05','12:50:00',3.24),('12374','2013-02-05','12:55:00',2.78),('12374','2013-02-05','13:00:00',2.63),('12374','2013-02-05','13:05:00',2.68),('12374','2013-02-05','13:10:00',3.15),('12374','2013-02-05','13:15:00',3.44),('12374','2013-02-05','13:20:00',3.36),('12374','2013-02-05','13:25:00',3.53),('12374','2013-02-05','13:30:00',4.21),('12374','2013-02-05','13:35:00',3.93),('12374','2013-02-05','13:40:00',4.61),('12374','2013-02-05','13:45:00',3.37),('12374','2013-02-05','13:50:00',3.54),('12374','2013-02-05','13:55:00',3.89),('12374','2013-02-05','14:00:00',4.1),('12374','2013-02-05','14:05:00',4.9),('12374','2013-02-05','14:10:00',4.59),('12374','2013-02-05','14:15:00',6.11),('12374','2013-02-05','14:20:00',5.01),('12374','2013-02-05','14:25:00',4.24),('12374','2013-02-05','14:30:00',3.11),('12374','2013-02-05','14:35:00',2.9),('12374','2013-02-05','14:40:00',2.67),('12374','2013-02-05','14:45:00',2.43),('12374','2013-02-05','14:50:00',1.7),('12374','2013-02-05','14:55:00',1.09),('12374','2013-02-04','07:50:00',1.12),('12374','2013-02-04','07:55:00',1.42),('12374','2013-02-04','08:00:00',1.77),('12374','2013-02-04','08:05:00',2.1),('12374','2013-02-04','08:10:00',2.31),('12374','2013-02-04','08:15:00',2.36),('12374','2013-02-04','08:20:00',2.31),('12374','2013-02-04','08:25:00',2.88),('12374','2013-02-04','08:30:00',3.05),('12374','2013-02-04','08:35:00',2.99),('12374','2013-02-04','08:40:00',3.44),('12374','2013-02-04','08:45:00',3.45),('12374','2013-02-04','08:50:00',4.03),('12374','2013-02-04','08:55:00',4.19),('12374','2013-02-04','09:00:00',4.33),('12374','2013-02-04','09:05:00',4.15),('12374','2013-02-04','09:10:00',4.36),('12374','2013-02-04','09:15:00',4.6),('12374','2013-02-04','09:20:00',3.95),('12374','2013-02-04','09:25:00',4.02),('12374','2013-02-04','09:30:00',4.99),('12374','2013-02-04','09:35:00',5.18),('12374','2013-02-04','09:40:00',5.62),('12374','2013-02-04','09:45:00',5.68),('12374','2013-02-04','09:50:00',5.48),('12374','2013-02-04','09:55:00',5.05),('12374','2013-02-04','10:00:00',5.35),('12374','2013-02-04','10:05:00',6.12),('12374','2013-02-04','10:10:00',6.15),('12374','2013-02-04','10:15:00',6.38),('12374','2013-02-04','10:20:00',6.24),('12374','2013-02-04','10:25:00',6.61),('12374','2013-02-04','10:30:00',6.29),('12374','2013-02-04','10:35:00',6.37),('12374','2013-02-04','10:40:00',6.89),('12374','2013-02-04','10:45:00',6.95),('12374','2013-02-04','10:50:00',7.03),('12374','2013-02-04','10:55:00',7.12),('12374','2013-02-04','11:00:00',7.14),('12374','2013-02-04','11:05:00',7.25),('12374','2013-02-04','11:10:00',7.29),('12374','2013-02-04','11:15:00',7.34),('12374','2013-02-04','11:20:00',7.38),('12374','2013-02-04','11:25:00',7.43),('12374','2013-02-04','11:30:00',7.49),('12374','2013-02-04','11:35:00',7.52),('12374','2013-02-04','11:40:00',7.56),('12374','2013-02-04','11:45:00',7.59),('12374','2013-02-04','11:50:00',7.6),('12374','2013-02-04','11:55:00',7.63),('12374','2013-02-04','12:00:00',7.64),('12374','2013-02-04','12:05:00',7.65),('12374','2013-02-04','12:10:00',7.65),('12374','2013-02-04','12:15:00',7.61),('12374','2013-02-04','12:20:00',7.59),('12374','2013-02-04','12:25:00',7.58),('12374','2013-02-04','12:30:00',7.61),('12374','2013-02-04','12:35:00',7.54),('12374','2013-02-04','12:40:00',7.48),('12374','2013-02-04','12:45:00',7.43),('12374','2013-02-04','12:50:00',7.38),('12374','2013-02-04','12:55:00',7.31),('12374','2013-02-04','13:00:00',7.25),('12374','2013-02-04','13:05:00',7.22),('12374','2013-02-04','13:10:00',7.17),('12374','2013-02-04','13:15:00',7.06),('12374','2013-02-04','13:20:00',7.02),('12374','2013-02-04','13:25:00',6.96),('12374','2013-02-04','13:30:00',6.9),('12374','2013-02-04','13:35:00',6.83),('12374','2013-02-04','13:40:00',6.76),('12374','2013-02-04','13:45:00',6.7),('12374','2013-02-04','13:50:00',6.59),('12374','2013-02-04','13:55:00',6.48),('12374','2013-02-04','14:00:00',6.4),('12374','2013-02-04','14:05:00',6.3),('12374','2013-02-04','14:10:00',6.21),('12374','2013-02-04','14:15:00',6.1),('12374','2013-02-04','14:20:00',5.99),('12374','2013-02-04','14:25:00',5.89),('12374','2013-02-04','14:30:00',5.78),('12374','2013-02-04','14:35:00',5.64),('12374','2013-02-04','14:40:00',5.51),('12374','2013-02-04','14:45:00',5.35),('12374','2013-02-04','14:50:00',5.23),('12374','2013-02-04','14:55:00',5.1),('12374','2013-02-04','15:00:00',4.97),('12374','2013-02-04','15:05:00',4.82),('12374','2013-02-04','15:10:00',4.7),('12374','2013-02-04','15:15:00',4.55),('12374','2013-02-04','15:20:00',4.42),('12374','2013-02-04','15:25:00',4.29),('12374','2013-02-04','15:30:00',4.16),('12374','2013-02-04','15:35:00',4.02),('12374','2013-02-04','15:40:00',3.88),('12374','2013-02-04','15:45:00',3.73),('12374','2013-02-04','15:50:00',3.57),('12374','2013-02-04','15:55:00',3.42),('12374','2013-02-04','16:00:00',3.22),('12374','2013-02-04','16:05:00',3.04),('12374','2013-02-04','16:10:00',2.86),('12374','2013-02-04','16:15:00',2.67),('12374','2013-02-04','16:20:00',2.49),('12374','2013-02-04','16:25:00',2.28),('12374','2013-02-04','16:30:00',2.07),('12374','2013-02-04','16:35:00',1.9),('12374','2013-02-04','16:40:00',1.7),('12374','2013-02-04','16:45:00',1.43),('12374','2013-02-04','16:50:00',1.11),('12374','2013-02-03','08:50:00',1.02),('12374','2013-02-03','09:40:00',1.56),('12374','2013-02-03','09:45:00',1.93),('12374','2013-02-03','09:50:00',1.44),('12374','2013-02-03','09:55:00',1.04),('12374','2013-02-03','11:35:00',1.29),('12374','2013-02-03','11:40:00',2.01),('12374','2013-02-03','11:45:00',2.09),('12374','2013-02-03','11:50:00',1.87),('12374','2013-02-03','11:55:00',1.45),('12374','2013-02-02','08:45:00',1.03),('12374','2013-02-02','08:50:00',1.51),('12374','2013-02-02','08:55:00',1.14),('12374','2013-02-02','09:00:00',1.17),('12374','2013-02-02','09:10:00',1.09),('12374','2013-02-02','09:15:00',1.18),('12374','2013-02-02','09:30:00',1.37),('12374','2013-02-02','09:35:00',1.9),('12374','2013-02-02','09:40:00',2.76),('12374','2013-02-02','09:45:00',3.05),('12374','2013-02-02','09:50:00',2.43),('12374','2013-02-02','09:55:00',2.97),('12374','2013-02-02','10:00:00',2.95),('12374','2013-02-02','10:05:00',1.8),('12374','2013-02-02','10:10:00',1.12),('12374','2013-02-02','10:15:00',1.2),('12374','2013-02-02','10:20:00',1.38),('12374','2013-02-02','10:25:00',2.27),('12374','2013-02-02','10:30:00',1.59),('12374','2013-02-02','10:35:00',2.41),('12374','2013-02-02','10:40:00',3.46),('12374','2013-02-02','10:45:00',3.62),('12374','2013-02-02','10:50:00',4.23),('12374','2013-02-02','10:55:00',3.96),('12374','2013-02-02','11:00:00',3.5),('12374','2013-02-02','11:05:00',1.84),('12374','2013-02-02','11:10:00',1.79),('12374','2013-02-02','11:15:00',1.65),('12374','2013-02-02','11:20:00',1.6),('12374','2013-02-02','11:25:00',1.01),('12374','2013-02-02','11:45:00',1.18),('12374','2013-02-02','11:50:00',1.04),('12374','2013-02-02','12:00:00',1.16),('12374','2013-02-02','12:05:00',1.4),('12374','2013-02-02','12:20:00',1.12),('12374','2013-02-02','12:25:00',1.93),('12374','2013-02-02','12:30:00',5.03),('12374','2013-02-02','12:35:00',2.26),('12374','2013-02-02','12:40:00',1.46),('12374','2013-02-02','12:45:00',1.96),('12374','2013-02-02','12:50:00',1.99),('12374','2013-02-02','12:55:00',1.47),('12374','2013-02-02','13:00:00',2.68),('12374','2013-02-02','13:05:00',1.21),('12374','2013-02-02','14:10:00',1.08),('12374','2013-02-01','08:15:00',1.25),('12374','2013-02-01','08:20:00',1.43),('12374','2013-02-01','08:25:00',1.69),('12374','2013-02-01','08:40:00',1.14),('12374','2013-02-01','08:50:00',1.12),('12374','2013-02-01','08:55:00',1.71),('12374','2013-02-01','09:00:00',1.84),('12374','2013-02-01','09:05:00',1.88),('12374','2013-02-01','09:10:00',3.5),('12374','2013-02-01','09:15:00',3.61),('12374','2013-02-01','09:20:00',1.75),('12374','2013-02-01','09:25:00',3.31),('12374','2013-02-01','09:30:00',3.24),('12374','2013-02-01','09:35:00',1.86),('12374','2013-02-01','09:40:00',1.3),('12374','2013-02-01','09:55:00',1.5),('12374','2013-02-01','10:00:00',5.26),('12374','2013-02-01','10:05:00',4.26),('12374','2013-02-01','10:10:00',2.59),('12374','2013-02-01','10:15:00',3.2),('12374','2013-02-01','10:20:00',1.88),('12374','2013-02-01','10:25:00',2.91),('12374','2013-02-01','10:30:00',2.29),('12374','2013-02-01','10:35:00',3.03),('12374','2013-02-01','10:40:00',6.15),('12374','2013-02-01','10:45:00',6.55),('12374','2013-02-01','10:50:00',6.23),('12374','2013-02-01','10:55:00',5.3),('12374','2013-02-01','11:00:00',5.28),('12374','2013-02-01','11:05:00',5.76),('12374','2013-02-01','11:10:00',4.33),('12374','2013-02-01','11:15:00',2.85),('12374','2013-02-01','11:20:00',3.23),('12374','2013-02-01','11:25:00',9.16),('12374','2013-02-01','11:30:00',8.47),('12374','2013-02-01','11:35:00',7.65),('12374','2013-02-01','11:40:00',7.64),('12374','2013-02-01','11:45:00',7.99),('12374','2013-02-01','11:50:00',7.8),('12374','2013-02-01','11:55:00',7.24),('12374','2013-02-01','12:00:00',7.21),('12374','2013-02-01','12:05:00',6.17),('12374','2013-02-01','12:10:00',6.44),('12374','2013-02-01','12:15:00',4.28),('12374','2013-02-01','12:20:00',5.4),('12374','2013-02-01','12:25:00',7.49),('12374','2013-02-01','12:30:00',7.15),('12374','2013-02-01','12:35:00',7.02),('12374','2013-02-01','12:40:00',6.98),('12374','2013-02-01','12:45:00',6.86),('12374','2013-02-01','12:50:00',6.77),('12374','2013-02-01','12:55:00',6.49),('12374','2013-02-01','13:00:00',6.24),('12374','2013-02-01','13:05:00',6.8),('12374','2013-02-01','13:10:00',6.5),('12374','2013-02-01','13:15:00',6.23),('12374','2013-02-01','13:20:00',5.61),('12374','2013-02-01','13:25:00',6.07),('12374','2013-02-01','13:30:00',6.39),('12374','2013-02-01','13:35:00',5.42),('12374','2013-02-01','13:40:00',6.28),('12374','2013-02-01','13:45:00',6.37),('12374','2013-02-01','13:50:00',6.12),('12374','2013-02-01','13:55:00',6.04),('12374','2013-02-01','14:00:00',6.02),('12374','2013-02-01','14:05:00',5.94),('12374','2013-02-01','14:10:00',5.66),('12374','2013-02-01','14:15:00',5.66),('12374','2013-02-01','14:20:00',5.47),('12374','2013-02-01','14:25:00',5.45),('12374','2013-02-01','14:30:00',5.35),('12374','2013-02-01','14:35:00',5.21),('12374','2013-02-01','14:40:00',5.05),('12374','2013-02-01','14:45:00',4.9),('12374','2013-02-01','14:50:00',4.84),('12374','2013-02-01','14:55:00',4.72),('12374','2013-02-01','15:00:00',4.61),('12374','2013-02-01','15:05:00',4.39),('12374','2013-02-01','15:10:00',4.32),('12374','2013-02-01','15:15:00',4.16),('12374','2013-02-01','15:20:00',3.91),('12374','2013-02-01','15:25:00',3.83),('12374','2013-02-01','15:30:00',3.58),('12374','2013-02-01','15:35:00',3.4),('12374','2013-02-01','15:40:00',3.13),('12374','2013-02-01','15:45:00',2.78),('12374','2013-02-01','15:50:00',2.52),('12374','2013-02-01','15:55:00',1.8),('12374','2013-02-01','16:00:00',1.44),('12374','2013-02-01','16:05:00',1.17),('12374','2013-02-01','16:10:00',1.24),('12374','2013-02-01','16:15:00',1.12),('12374','2013-02-01','16:20:00',1.03),('12374','2013-02-01','16:25:00',1.12),('12374','2013-01-31','08:35:00',1.63),('12374','2013-01-31','08:40:00',2.85),('12374','2013-01-31','08:45:00',2.67),('12374','2013-01-31','08:50:00',3.14),('12374','2013-01-31','08:55:00',3.21),('12374','2013-01-31','09:00:00',3.6),('12374','2013-01-31','09:05:00',3.75),('12374','2013-01-31','09:10:00',3.93),('12374','2013-01-31','09:15:00',4.1),('12374','2013-01-31','09:20:00',4.18),('12374','2013-01-31','09:25:00',4.39),('12374','2013-01-31','09:30:00',4.46),('12374','2013-01-31','09:35:00',4.58),('12374','2013-01-31','09:40:00',4.65),('12374','2013-01-31','09:45:00',4.75),('12374','2013-01-31','09:50:00',5.02),('12374','2013-01-31','09:55:00',5.2),('12374','2013-01-31','10:00:00',5.22),('12374','2013-01-31','10:05:00',5.13),('12374','2013-01-31','10:10:00',5.36),('12374','2013-01-31','10:15:00',5.58),('12374','2013-01-31','10:20:00',5.72),('12374','2013-01-31','10:25:00',5.94),('12374','2013-01-31','10:30:00',5.98),('12374','2013-01-31','10:35:00',6.11),('12374','2013-01-31','10:40:00',6.19),('12374','2013-01-31','10:45:00',6.27),('12374','2013-01-31','10:50:00',6.35),('12374','2013-01-31','10:55:00',6.46),('12374','2013-01-31','11:00:00',6.42),('12374','2013-01-31','11:05:00',6.39),('12374','2013-01-31','11:10:00',6.44),('12374','2013-01-31','11:15:00',6.71),('12374','2013-01-31','11:20:00',6.65),('12374','2013-01-31','11:25:00',6.67),('12374','2013-01-31','11:30:00',6.76),('12374','2013-01-31','11:35:00',6.89),('12374','2013-01-31','11:40:00',6.84),('12374','2013-01-31','11:45:00',7.01),('12374','2013-01-31','11:50:00',7),('12374','2013-01-31','11:55:00',6.89),('12374','2013-01-31','12:00:00',7),('12374','2013-01-31','12:05:00',6.97),('12374','2013-01-31','12:10:00',6.94),('12374','2013-01-31','12:15:00',7.03),('12374','2013-01-31','12:20:00',6.93),('12374','2013-01-31','12:25:00',6.91),('12374','2013-01-31','12:30:00',6.93),('12374','2013-01-31','12:35:00',6.99),('12374','2013-01-31','12:40:00',6.97),('12374','2013-01-31','12:45:00',6.85),('12374','2013-01-31','12:50:00',6.91),('12374','2013-01-31','12:55:00',6.83),('12374','2013-01-31','13:00:00',6.76),('12374','2013-01-31','13:05:00',6.7),('12374','2013-01-31','13:10:00',6.67),('12374','2013-01-31','13:15:00',6.62),('12374','2013-01-31','13:20:00',6.47),('12374','2013-01-31','13:25:00',6.37),('12374','2013-01-31','13:30:00',6.36),('12374','2013-01-31','13:35:00',6.37),('12374','2013-01-31','13:40:00',6.24),('12374','2013-01-31','13:45:00',6.06),('12374','2013-01-31','13:50:00',6.04),('12374','2013-01-31','13:55:00',5.97),('12374','2013-01-31','14:00:00',5.86),('12374','2013-01-31','14:05:00',5.77),('12374','2013-01-31','14:10:00',5.69),('12374','2013-01-31','14:15:00',5.57),('12374','2013-01-31','14:20:00',5.49),('12374','2013-01-31','14:25:00',5.36),('12374','2013-01-31','14:30:00',5.25),('12374','2013-01-31','14:35:00',5.12),('12374','2013-01-31','14:40:00',5.08),('12374','2013-01-31','14:45:00',4.84),('12374','2013-01-31','14:50:00',4.61),('12374','2013-01-31','14:55:00',4.54),('12374','2013-01-31','15:00:00',4.5),('12374','2013-01-31','15:05:00',4.39),('12374','2013-01-31','15:10:00',4.25),('12374','2013-01-31','15:15:00',3.72),('12374','2013-01-31','15:20:00',4.18),('12374','2013-01-31','15:25:00',3.99),('12374','2013-01-31','15:30:00',3.67),('12374','2013-01-31','15:35:00',3.09),('12374','2013-01-31','15:40:00',2.5),('12374','2013-01-31','15:45:00',2.23),('12374','2013-01-31','15:50:00',2.97),('12374','2013-01-31','15:55:00',2.64),('12374','2013-01-31','16:00:00',2.52),('12374','2013-01-31','16:05:00',2.14),('12374','2013-01-31','16:10:00',2.22),('12374','2013-01-31','16:15:00',2.29),('12374','2013-01-31','16:20:00',2.14),('12374','2013-01-31','16:25:00',1.91),('12374','2013-01-31','16:30:00',1.75),('12374','2013-01-31','16:35:00',1.57),('12374','2013-01-31','16:40:00',1.39),('12374','2013-01-30','08:30:00',1.06),('12374','2013-01-30','08:35:00',1.92),('12374','2013-01-30','08:40:00',1.96),('12374','2013-01-30','08:45:00',1.98),('12374','2013-01-30','08:50:00',3.21),('12374','2013-01-30','08:55:00',3.51),('12374','2013-01-30','09:00:00',3.86),('12374','2013-01-30','09:05:00',4.74),('12374','2013-01-30','09:10:00',3.95),('12374','2013-01-30','09:15:00',2.27),('12374','2013-01-30','09:20:00',2.11),('12374','2013-01-30','09:25:00',1.81),('12374','2013-01-30','09:30:00',4.49),('12374','2013-01-30','09:35:00',2.46),('12374','2013-01-30','09:40:00',4.32),('12374','2013-01-30','09:45:00',2.02),('12374','2013-01-30','09:50:00',1.82),('12374','2013-01-30','09:55:00',1.74),('12374','2013-01-30','10:00:00',2.72),('12374','2013-01-30','10:05:00',2.32),('12374','2013-01-30','10:10:00',2.02),('12374','2013-01-30','10:15:00',4.67),('12374','2013-01-30','10:20:00',4.77),('12374','2013-01-30','10:25:00',3.62),('12374','2013-01-30','10:30:00',5.62),('12374','2013-01-30','10:35:00',5.66),('12374','2013-01-30','10:40:00',6.27),('12374','2013-01-30','10:45:00',6.36),('12374','2013-01-30','10:50:00',6.4),('12374','2013-01-30','10:55:00',6.52),('12374','2013-01-30','11:00:00',6.6),('12374','2013-01-30','11:05:00',6.68),('12374','2013-01-30','11:10:00',6.65),('12374','2013-01-30','11:15:00',6.64),('12374','2013-01-30','11:20:00',6.77),('12374','2013-01-30','11:25:00',6.83),('12374','2013-01-30','11:30:00',6.83),('12374','2013-01-30','11:35:00',7.01),('12374','2013-01-30','11:40:00',6.86),('12374','2013-01-30','11:45:00',7.13),('12374','2013-01-30','11:50:00',6.15),('12374','2013-01-30','11:55:00',3.81),('12374','2013-01-30','12:00:00',3.49),('12374','2013-01-30','12:05:00',3.76),('12374','2013-01-30','12:10:00',4.44),('12374','2013-01-30','12:15:00',5.62),('12374','2013-01-30','12:20:00',7.29),('12374','2013-01-30','12:25:00',4.76),('12374','2013-01-30','12:30:00',3.07),('12374','2013-01-30','12:35:00',3.57),('12374','2013-01-30','12:40:00',3.69),('12374','2013-01-30','12:45:00',3.85),('12374','2013-01-30','12:50:00',4.19),('12374','2013-01-30','12:55:00',6),('12374','2013-01-30','13:00:00',6.16),('12374','2013-01-30','13:05:00',6.17),('12374','2013-01-30','13:10:00',6.75),('12374','2013-01-30','13:15:00',6.14),('12374','2013-01-30','13:20:00',6.18),('12374','2013-01-30','13:25:00',6.3),('12374','2013-01-30','13:30:00',6.34),('12374','2013-01-30','13:35:00',6.15),('12374','2013-01-30','13:40:00',5.96),('12374','2013-01-30','13:45:00',5.42),('12374','2013-01-30','13:50:00',4.68),('12374','2013-01-30','13:55:00',4.2),('12374','2013-01-30','14:00:00',4.56),('12374','2013-01-30','14:05:00',4.99),('12374','2013-01-30','14:10:00',4.61),('12374','2013-01-30','14:15:00',3.46),('12374','2013-01-30','14:20:00',2.49),('12374','2013-01-30','14:25:00',3.07),('12374','2013-01-30','14:30:00',2.95),('12374','2013-01-30','14:35:00',2.99),('12374','2013-01-30','14:40:00',2.72),('12374','2013-01-30','14:45:00',2.82),('12374','2013-01-30','14:50:00',2.81),('12374','2013-01-30','14:55:00',2.68),('12374','2013-01-30','15:00:00',2.39),('12374','2013-01-30','15:05:00',2.07),('12374','2013-01-30','15:10:00',1.9),('12374','2013-01-30','15:15:00',1.74),('12374','2013-01-30','15:20:00',1.67),('12374','2013-01-30','15:25:00',1.69),('12374','2013-01-30','15:30:00',1.84),('12374','2013-01-30','15:35:00',1.92),('12374','2013-01-30','15:40:00',1.73),('12374','2013-01-30','15:45:00',1.57),('12374','2013-01-30','15:50:00',1.58),('12374','2013-01-30','15:55:00',1.7),('12374','2013-01-30','16:00:00',2.58),('12374','2013-01-30','16:05:00',2.37),('12374','2013-01-30','16:10:00',1.29),('12374','2013-01-30','16:15:00',1.37),('12374','2013-01-30','16:35:00',1.08),('12374','2013-01-29','08:00:00',1.3),('12374','2013-01-29','08:05:00',1.29),('12374','2013-01-29','08:10:00',1.57),('12374','2013-01-29','08:15:00',1.78),('12374','2013-01-29','08:20:00',1.3),('12374','2013-01-29','08:25:00',1.29),('12374','2013-01-29','08:30:00',1.58),('12374','2013-01-29','08:35:00',2.42),('12374','2013-01-29','08:40:00',2.88),('12374','2013-01-29','08:45:00',2.82),('12374','2013-01-29','08:50:00',3.1),('12374','2013-01-29','08:55:00',3.37),('12374','2013-01-29','09:00:00',3.59),('12374','2013-01-29','09:05:00',3.88),('12374','2013-01-29','09:10:00',4),('12374','2013-01-29','09:15:00',4.13),('12374','2013-01-29','09:20:00',4.29),('12374','2013-01-29','09:25:00',4.43),('12374','2013-01-29','09:30:00',4.54),('12374','2013-01-29','09:35:00',4.67),('12374','2013-01-29','09:40:00',4.77),('12374','2013-01-29','09:45:00',4.79),('12374','2013-01-29','09:50:00',5.02),('12374','2013-01-29','09:55:00',5.17),('12374','2013-01-29','10:00:00',5.3),('12374','2013-01-29','10:05:00',5.48),('12374','2013-01-29','10:10:00',5.89),('12374','2013-01-29','10:15:00',4.73),('12374','2013-01-29','10:20:00',4.17),('12374','2013-01-29','10:25:00',7.21),('12374','2013-01-29','10:30:00',2.65),('12374','2013-01-29','10:35:00',2.72),('12374','2013-01-29','10:40:00',2.76),('12374','2013-01-29','10:45:00',2.75),('12374','2013-01-29','10:50:00',3.51),('12374','2013-01-29','10:55:00',4.79),('12374','2013-01-29','11:00:00',7.19),('12374','2013-01-29','11:05:00',6.86),('12374','2013-01-29','11:10:00',6.82),('12374','2013-01-29','11:15:00',6.92),('12374','2013-01-29','11:20:00',6.91),('12374','2013-01-29','11:25:00',6.52),('12374','2013-01-29','11:30:00',6.57),('12374','2013-01-29','11:35:00',6.4),('12374','2013-01-29','11:40:00',6.83),('12374','2013-01-29','11:45:00',6.58),('12374','2013-01-29','11:50:00',5.21),('12374','2013-01-29','11:55:00',7.25),('12374','2013-01-29','12:00:00',6.99),('12374','2013-01-29','12:05:00',6.98),('12374','2013-01-29','12:10:00',7.02),('12374','2013-01-29','12:15:00',7.02),('12374','2013-01-29','12:20:00',7),('12374','2013-01-29','12:25:00',7.03),('12374','2013-01-29','12:30:00',7.02),('12374','2013-01-29','12:35:00',6.8),('12374','2013-01-29','12:40:00',6.75),('12374','2013-01-29','12:45:00',6.78),('12374','2013-01-29','12:50:00',6.87),('12374','2013-01-29','12:55:00',6.86),('12374','2013-01-29','13:00:00',6.8),('12374','2013-01-29','13:05:00',6.73),('12374','2013-01-29','13:10:00',6.67),('12374','2013-01-29','13:15:00',6.58),('12374','2013-01-29','13:20:00',6.52),('12374','2013-01-29','13:25:00',6.52),('12374','2013-01-29','13:30:00',6.61),('12374','2013-01-29','13:35:00',7.02),('12374','2013-01-29','13:40:00',6.61),('12374','2013-01-29','13:45:00',6.4),('12374','2013-01-29','13:50:00',6.26),('12374','2013-01-29','13:55:00',6.31),('12374','2013-01-29','14:00:00',6.23),('12374','2013-01-29','14:05:00',6.05),('12374','2013-01-29','14:10:00',5.94),('12374','2013-01-29','14:15:00',5.85),('12374','2013-01-29','14:20:00',5.73),('12374','2013-01-29','14:25:00',5.6),('12374','2013-01-29','14:30:00',5.6),('12374','2013-01-29','14:35:00',4.17),('12374','2013-01-29','14:40:00',4.97),('12374','2013-01-29','14:45:00',5.08),('12374','2013-01-29','14:50:00',4.88),('12374','2013-01-29','14:55:00',4.76),('12374','2013-01-29','15:00:00',4.63),('12374','2013-01-29','15:05:00',4.48),('12374','2013-01-29','15:10:00',4.36),('12374','2013-01-29','15:15:00',4.22),('12374','2013-01-29','15:20:00',4.07),('12374','2013-01-29','15:25:00',3.96),('12374','2013-01-29','15:30:00',3.84),('12374','2013-01-29','15:35:00',3.62),('12374','2013-01-29','15:40:00',3.51),('12374','2013-01-29','15:45:00',3.36),('12374','2013-01-29','15:50:00',3.2),('12374','2013-01-29','15:55:00',3),('12374','2013-01-29','16:00:00',2.86),('12374','2013-01-29','16:05:00',2.7),('12374','2013-01-29','16:10:00',2.52),('12374','2013-01-29','16:15:00',2.33),('12374','2013-01-29','16:20:00',2.18),('12374','2013-01-29','16:25:00',1.93),('12374','2013-01-29','16:30:00',1.78),('12374','2013-01-29','16:35:00',1.59),('12374','2013-01-29','16:40:00',1.31),('12374','2013-01-28','10:15:00',1.06),('12374','2013-01-28','10:20:00',1.21),('12374','2013-01-28','10:25:00',1.39),('12374','2013-01-28','10:30:00',1.72),('12374','2013-01-28','10:35:00',1.66),('12374','2013-01-28','10:40:00',1.24),('12374','2013-01-28','10:45:00',1.08),('12374','2013-01-28','10:50:00',1.21),('12374','2013-01-28','10:55:00',1.29),('12374','2013-01-28','11:00:00',1.27),('12374','2013-01-28','11:50:00',1.18),('12374','2013-01-28','11:55:00',1.36),('12374','2013-01-28','12:00:00',1.59),('12374','2013-01-28','12:05:00',1.91),('12374','2013-01-28','12:10:00',1.92),('12374','2013-01-28','12:15:00',1.87),('12374','2013-01-28','12:20:00',1.89),('12374','2013-01-28','12:25:00',1.97),('12374','2013-01-28','12:30:00',1.87),('12374','2013-01-28','12:35:00',1.68),('12374','2013-01-28','12:40:00',1.53),('12374','2013-01-28','12:45:00',1.61),('12374','2013-01-28','12:50:00',1.75),('12374','2013-01-28','12:55:00',1.66),('12374','2013-01-28','13:00:00',1.75),('12374','2013-01-28','13:05:00',1.85),('12374','2013-01-28','13:10:00',1.78),('12374','2013-01-28','13:15:00',1.49),('12374','2013-01-28','13:20:00',1.29),('12374','2013-01-28','13:25:00',1.23),('12374','2013-01-28','13:30:00',1.19),('12374','2013-01-28','13:35:00',1.09),('12374','2013-01-28','13:40:00',1.18),('12374','2013-01-28','13:45:00',1.23),('12374','2013-01-28','13:50:00',1.22),('12374','2013-01-28','13:55:00',1.27),('12374','2013-01-28','14:00:00',1.34),('12374','2013-01-28','14:05:00',1.4),('12374','2013-01-28','14:10:00',1.3),('12374','2013-01-28','14:15:00',1.03),('12374','2013-01-27','08:15:00',1.01),('12374','2013-01-27','08:50:00',1.31),('12374','2013-01-27','08:55:00',2.23),('12374','2013-01-27','09:00:00',2.77),('12374','2013-01-27','09:05:00',3.76),('12374','2013-01-27','09:10:00',2.13),('12374','2013-01-27','09:15:00',2.73),('12374','2013-01-27','09:20:00',4.23),('12374','2013-01-27','09:25:00',4.33),('12374','2013-01-27','09:30:00',4.45),('12374','2013-01-27','09:35:00',4.47),('12374','2013-01-27','09:40:00',4.6),('12374','2013-01-27','09:45:00',4.74),('12374','2013-01-27','09:50:00',4.84),('12374','2013-01-27','09:55:00',4.92),('12374','2013-01-27','10:00:00',5.18),('12374','2013-01-27','10:05:00',5.3),('12374','2013-01-27','10:10:00',5.45),('12374','2013-01-27','10:15:00',5.57),('12374','2013-01-27','10:20:00',5.71),('12374','2013-01-27','10:25:00',5.8),('12374','2013-01-27','10:30:00',5.94),('12374','2013-01-27','10:35:00',6.06),('12374','2013-01-27','10:40:00',6.21),('12374','2013-01-27','10:45:00',6.32),('12374','2013-01-27','10:50:00',6.38),('12374','2013-01-27','10:55:00',6.43),('12374','2013-01-27','11:00:00',6.54),('12374','2013-01-27','11:05:00',6.67),('12374','2013-01-27','11:10:00',6.79),('12374','2013-01-27','11:15:00',6.83),('12374','2013-01-27','11:20:00',6.81),('12374','2013-01-27','11:25:00',6.86),('12374','2013-01-27','11:30:00',6.86),('12374','2013-01-27','11:35:00',6.89),('12374','2013-01-27','11:40:00',6.9),('12374','2013-01-27','11:45:00',6.94),('12374','2013-01-27','11:50:00',6.96),('12374','2013-01-27','11:55:00',7.03),('12374','2013-01-27','12:00:00',7.11),('12374','2013-01-27','12:05:00',6.99),('12374','2013-01-27','12:10:00',7.05),('12374','2013-01-27','12:15:00',7.05),('12374','2013-01-27','12:20:00',6.96),('12374','2013-01-27','12:25:00',6.97),('12374','2013-01-27','12:30:00',7),('12374','2013-01-27','12:35:00',7.02),('12374','2013-01-27','12:40:00',6.96),('12374','2013-01-27','12:45:00',6.9),('12374','2013-01-27','12:50:00',6.88),('12374','2013-01-27','12:55:00',6.81),('12374','2013-01-27','13:00:00',6.75),('12374','2013-01-27','13:05:00',6.66),('12374','2013-01-27','13:10:00',6.58),('12374','2013-01-27','13:15:00',6.54),('12374','2013-01-27','13:20:00',6.44),('12374','2013-01-27','13:25:00',6.3),('12374','2013-01-27','13:30:00',6.23),('12374','2013-01-27','13:35:00',6.2),('12374','2013-01-27','13:40:00',6.14),('12374','2013-01-27','13:45:00',6.11),('12374','2013-01-27','13:50:00',5.99),('12374','2013-01-27','13:55:00',5.78),('12374','2013-01-27','14:00:00',5.78),('12374','2013-01-27','14:05:00',5.67),('12374','2013-01-27','14:10:00',5.6),('12374','2013-01-27','14:15:00',5.5),('12374','2013-01-27','14:20:00',5.4),('12374','2013-01-27','14:25:00',5.24),('12374','2013-01-27','14:30:00',5.19),('12374','2013-01-27','14:35:00',4.97),('12374','2013-01-27','14:40:00',4.76),('12374','2013-01-27','14:45:00',4.68),('12374','2013-01-27','14:50:00',4.68),('12374','2013-01-27','14:55:00',4.38),('12374','2013-01-27','15:00:00',4.37),('12374','2013-01-27','15:05:00',4.28),('12374','2013-01-27','15:10:00',4.1),('12374','2013-01-27','15:15:00',3.96),('12374','2013-01-27','15:20:00',3.73),('12374','2013-01-27','15:25:00',3.14),('12374','2013-01-27','15:30:00',3.38),('12374','2013-01-27','15:35:00',3.4),('12374','2013-01-27','15:40:00',3.18),('12374','2013-01-27','15:45:00',3.05),('12374','2013-01-27','15:50:00',2.86),('12374','2013-01-27','15:55:00',2.63),('12374','2013-01-27','16:00:00',2.45),('12374','2013-01-27','16:05:00',2.24),('12374','2013-01-27','16:10:00',1.99),('12374','2013-01-27','16:15:00',1.88),('12374','2013-01-27','16:20:00',1.7),('12374','2013-01-27','16:25:00',1.47),('12374','2013-01-27','16:30:00',1.32),('12374','2013-01-27','16:35:00',1.08),('12374','2013-01-26','09:45:00',1.2),('12374','2013-01-26','09:50:00',1.61),('12374','2013-01-26','09:55:00',1.71),('12374','2013-01-26','10:00:00',1.78),('12374','2013-01-26','10:05:00',1.62),('12374','2013-01-26','10:10:00',1.78),('12374','2013-01-26','10:15:00',1.88),('12374','2013-01-26','10:20:00',2.11),('12374','2013-01-26','10:25:00',2.01),('12374','2013-01-26','10:30:00',2.35),('12374','2013-01-26','10:35:00',2.24),('12374','2013-01-26','10:40:00',2.32),('12374','2013-01-26','10:45:00',2.33),('12374','2013-01-26','10:50:00',2.25),('12374','2013-01-26','10:55:00',2.13),('12374','2013-01-26','11:00:00',2.05),('12374','2013-01-26','11:05:00',2.12),('12374','2013-01-26','11:10:00',4.71),('12374','2013-01-26','11:15:00',7.38),('12374','2013-01-26','11:20:00',4.45),('12374','2013-01-26','11:25:00',3.15),('12374','2013-01-26','11:30:00',3.76),('12374','2013-01-26','11:35:00',3.58),('12374','2013-01-26','11:40:00',3.62),('12374','2013-01-26','11:45:00',4.2),('12374','2013-01-26','11:50:00',3.54),('12374','2013-01-26','11:55:00',2.84),('12374','2013-01-26','12:00:00',2.64),('12374','2013-01-26','12:05:00',2.09),('12374','2013-01-26','12:10:00',1.77),('12374','2013-01-26','12:15:00',2.09),('12374','2013-01-26','12:20:00',2.16),('12374','2013-01-26','12:25:00',2.23),('12374','2013-01-26','12:30:00',2.36),('12374','2013-01-26','12:35:00',2.45),('12374','2013-01-26','12:40:00',2.87),('12374','2013-01-26','12:45:00',3.36),('12374','2013-01-26','12:50:00',2.82),('12374','2013-01-26','12:55:00',2.77),('12374','2013-01-26','13:00:00',2.59),('12374','2013-01-26','13:05:00',2.58),('12374','2013-01-26','13:10:00',2.61),('12374','2013-01-26','13:15:00',2.63),('12374','2013-01-26','13:20:00',2.45),('12374','2013-01-26','13:25:00',2.25),('12374','2013-01-26','13:30:00',2.12),('12374','2013-01-26','13:35:00',2.23),('12374','2013-01-26','13:40:00',2.18),('12374','2013-01-26','13:45:00',1.97),('12374','2013-01-26','13:50:00',1.94),('12374','2013-01-26','13:55:00',1.84),('12374','2013-01-26','14:00:00',1.66),('12374','2013-01-26','14:05:00',1.51),('12374','2013-01-26','14:10:00',1.47),('12374','2013-01-26','14:15:00',1.28),('12374','2013-01-26','14:45:00',1.01),('12374','2013-01-26','15:15:00',1.04),('12374','2013-01-26','15:20:00',1.07),('12374','2013-01-26','15:25:00',1.01),('12374','2013-01-25','08:05:00',1.13),('12374','2013-01-25','08:10:00',1.25),('12374','2013-01-25','08:15:00',1.27),('12374','2013-01-25','08:20:00',1.57),('12374','2013-01-25','08:25:00',1.78),('12374','2013-01-25','08:30:00',2.38),('12374','2013-01-25','08:35:00',2.91),('12374','2013-01-25','08:40:00',2.37),('12374','2013-01-25','08:45:00',2.9),('12374','2013-01-25','08:50:00',3.71),('12374','2013-01-25','08:55:00',3.61),('12374','2013-01-25','09:00:00',4.02),('12374','2013-01-25','09:05:00',4.56),('12374','2013-01-25','09:10:00',4.79),('12374','2013-01-25','09:15:00',4.96),('12374','2013-01-25','09:20:00',4.59),('12374','2013-01-25','09:25:00',4.71),('12374','2013-01-25','09:30:00',4.65),('12374','2013-01-25','09:35:00',3.66),('12374','2013-01-25','09:40:00',3.29),('12374','2013-01-25','09:45:00',3.53),('12374','2013-01-25','09:50:00',4.16),('12374','2013-01-25','09:55:00',4.68),('12374','2013-01-25','10:00:00',5.72),('12374','2013-01-25','10:05:00',5.97),('12374','2013-01-25','10:10:00',5.27),('12374','2013-01-25','10:15:00',3.81),('12374','2013-01-25','10:20:00',4.93),('12374','2013-01-25','10:25:00',5.88),('12374','2013-01-25','10:30:00',6.39),('12374','2013-01-25','10:35:00',5.71),('12374','2013-01-25','10:40:00',5.33),('12374','2013-01-25','10:45:00',4.93),('12374','2013-01-25','10:50:00',4.17),('12374','2013-01-25','10:55:00',3.07),('12374','2013-01-25','11:00:00',2.74),('12374','2013-01-25','11:05:00',3.65),('12374','2013-01-25','11:10:00',4.2),('12374','2013-01-25','11:15:00',3.83),('12374','2013-01-25','11:20:00',2.75),('12374','2013-01-25','11:25:00',3.01),('12374','2013-01-25','11:30:00',5.42),('12374','2013-01-25','11:35:00',7.1),('12374','2013-01-25','11:40:00',7.3),('12374','2013-01-25','11:45:00',7.15),('12374','2013-01-25','11:50:00',7.23),('12374','2013-01-25','11:55:00',7.26),('12374','2013-01-25','12:00:00',7.26),('12374','2013-01-25','12:05:00',7.21),('12374','2013-01-25','12:10:00',7.01),('12374','2013-01-25','12:15:00',7.28),('12374','2013-01-25','12:20:00',7.27),('12374','2013-01-25','12:25:00',7.25),('12374','2013-01-25','12:30:00',7.25),('12374','2013-01-25','12:35:00',7.17),('12374','2013-01-25','12:40:00',7.12),('12374','2013-01-25','12:45:00',7.09),('12374','2013-01-25','12:50:00',7.16),('12374','2013-01-25','12:55:00',7.1),('12374','2013-01-25','13:00:00',7.04),('12374','2013-01-25','13:05:00',7.07),('12374','2013-01-25','13:10:00',6.91),('12374','2013-01-25','13:15:00',6.5),('12374','2013-01-25','13:20:00',6.72),('12374','2013-01-25','13:25:00',6.7),('12374','2013-01-25','13:30:00',6.6),('12374','2013-01-25','13:35:00',6.55),('12374','2013-01-25','13:40:00',6.4),('12374','2013-01-25','13:45:00',6.26),('12374','2013-01-25','13:50:00',6.14),('12374','2013-01-25','13:55:00',6.08),('12374','2013-01-25','14:00:00',5.5),('12374','2013-01-25','14:05:00',5.45),('12374','2013-01-25','14:10:00',5.59),('12374','2013-01-25','14:15:00',5.46),('12374','2013-01-25','14:20:00',4.95),('12374','2013-01-25','14:25:00',4.9),('12374','2013-01-25','14:30:00',4.9),('12374','2013-01-25','14:35:00',4.81),('12374','2013-01-25','14:40:00',4.68),('12374','2013-01-25','14:45:00',4.65),('12374','2013-01-25','14:50:00',4.56),('12374','2013-01-25','14:55:00',4.52),('12374','2013-01-25','15:00:00',4.34),('12374','2013-01-25','15:05:00',4.28),('12374','2013-01-25','15:10:00',4.18),('12374','2013-01-25','15:15:00',4.07),('12374','2013-01-25','15:20:00',3.63),('12374','2013-01-25','15:25:00',3.79),('12374','2013-01-25','15:30:00',3.67),('12374','2013-01-25','15:35:00',3.65),('12374','2013-01-25','15:40:00',3.48),('12374','2013-01-25','15:45:00',2.87),('12374','2013-01-25','15:50:00',3.6),('12374','2013-01-25','15:55:00',3.21),('12374','2013-01-25','16:00:00',2.79),('12374','2013-01-25','16:05:00',1.6),('12374','2013-01-25','16:10:00',1.29),('12374','2013-01-25','16:15:00',1.21),('12374','2013-01-25','16:20:00',1),('12374','2013-01-24','08:45:00',1.11),('12374','2013-01-24','08:50:00',1.36),('12374','2013-01-24','08:55:00',1.86),('12374','2013-01-24','09:00:00',1.46),('12374','2013-01-24','09:05:00',1.3),('12374','2013-01-24','09:10:00',1.34),('12374','2013-01-24','09:15:00',1.51),('12374','2013-01-24','09:20:00',2.12),('12374','2013-01-24','09:25:00',3.84),('12374','2013-01-24','09:30:00',5.04),('12374','2013-01-24','09:35:00',5.36),('12374','2013-01-24','09:40:00',5.05),('12374','2013-01-24','09:45:00',5.79),('12374','2013-01-24','09:50:00',5.46),('12374','2013-01-24','09:55:00',4.99),('12374','2013-01-24','10:00:00',4.65),('12374','2013-01-24','10:05:00',4.13),('12374','2013-01-24','10:10:00',4.09),('12374','2013-01-24','10:15:00',5.81),('12374','2013-01-24','10:20:00',6.35),('12374','2013-01-24','10:25:00',6.43),('12374','2013-01-24','10:30:00',6.45),('12374','2013-01-24','10:35:00',6.49),('12374','2013-01-24','10:40:00',6.56),('12374','2013-01-24','10:45:00',6.55),('12374','2013-01-24','10:50:00',6.25),('12374','2013-01-24','10:55:00',5.86),('12374','2013-01-24','11:00:00',6.26),('12374','2013-01-24','11:05:00',6.68),('12374','2013-01-24','11:10:00',6.95),('12374','2013-01-24','11:15:00',6.65),('12374','2013-01-24','11:20:00',7.06),('12374','2013-01-24','11:25:00',7.34),('12374','2013-01-24','11:30:00',7.36),('12374','2013-01-24','11:35:00',7.58),('12374','2013-01-24','11:40:00',7.62),('12374','2013-01-24','11:45:00',6.76),('12374','2013-01-24','11:50:00',2.41),('12374','2013-01-24','11:55:00',1.55),('12374','2013-01-24','12:00:00',1.52),('12374','2013-01-24','12:05:00',1.5),('12374','2013-01-24','12:10:00',1.51),('12374','2013-01-24','12:15:00',1.54),('12374','2013-01-24','12:20:00',1.56),('12374','2013-01-24','12:25:00',1.57),('12374','2013-01-24','12:30:00',1.62),('12374','2013-01-24','12:35:00',1.66),('12374','2013-01-24','12:40:00',1.74),('12374','2013-01-24','12:45:00',1.85),('12374','2013-01-24','12:50:00',1.98),('12374','2013-01-24','12:55:00',2.16),('12374','2013-01-24','13:00:00',2.33),('12374','2013-01-24','13:05:00',2.62),('12374','2013-01-24','13:10:00',2.78),('12374','2013-01-24','13:15:00',2.93),('12374','2013-01-24','13:20:00',7.12),('12374','2013-01-24','13:25:00',7.21),('12374','2013-01-24','13:30:00',6.89),('12374','2013-01-24','13:35:00',7.31),('12374','2013-01-24','13:40:00',7.17),('12374','2013-01-24','13:45:00',6.3),('12374','2013-01-24','13:50:00',5.68),('12374','2013-01-24','13:55:00',3.49),('12374','2013-01-24','14:00:00',2.48),('12374','2013-01-24','14:05:00',3.68),('12374','2013-01-24','14:10:00',4.22),('12374','2013-01-24','14:15:00',6.42),('12374','2013-01-24','14:20:00',6.37),('12374','2013-01-24','14:25:00',6.14),('12374','2013-01-24','14:30:00',5.15),('12374','2013-01-24','14:35:00',3.81),('12374','2013-01-24','14:40:00',2.98),('12374','2013-01-24','14:45:00',2.47),('12374','2013-01-24','14:50:00',1.93),('12374','2013-01-24','14:55:00',2.16),('12374','2013-01-24','15:00:00',3.08),('12374','2013-01-24','15:05:00',4.43),('12374','2013-01-24','15:10:00',5.22),('12374','2013-01-24','15:15:00',5),('12374','2013-01-24','15:20:00',4.72),('12374','2013-01-24','15:25:00',4.4),('12374','2013-01-24','15:30:00',4),('12374','2013-01-24','15:35:00',3.28),('12374','2013-01-24','15:40:00',2.36),('12374','2013-01-24','15:45:00',2.42),('12374','2013-01-24','15:55:00',1.12),('12374','2013-01-24','16:00:00',1.95),('12374','2013-01-24','16:05:00',2.86),('12374','2013-01-24','16:10:00',1.96),('12374','2013-01-23','08:45:00',2.45),('12374','2013-01-23','08:50:00',2.79),('12374','2013-01-23','08:55:00',3.34),('12374','2013-01-23','09:00:00',3.3),('12374','2013-01-23','09:05:00',4.1),('12374','2013-01-23','09:10:00',4.58),('12374','2013-01-23','09:15:00',3.22),('12374','2013-01-23','09:20:00',2.43),('12374','2013-01-23','09:25:00',2.62),('12374','2013-01-23','09:30:00',2.02),('12374','2013-01-23','09:35:00',1.62),('12374','2013-01-23','09:50:00',1.01),('12374','2013-01-23','09:55:00',1.03),('12374','2013-01-23','10:35:00',1.19),('12374','2013-01-23','10:40:00',1.91),('12374','2013-01-23','10:45:00',2.1),('12374','2013-01-23','10:50:00',1.95),('12374','2013-01-23','10:55:00',1.11),('12374','2013-01-23','11:10:00',1.1),('12374','2013-01-23','11:40:00',1.44),('12374','2013-01-23','11:45:00',1.53),('12374','2013-01-23','11:50:00',1.29),('12374','2013-01-23','11:55:00',1.22),('12374','2013-01-23','12:15:00',1.48),('12374','2013-01-23','12:20:00',2.21),('12374','2013-01-23','12:25:00',2.42),('12374','2013-01-23','12:30:00',1.8),('12374','2013-01-23','13:10:00',1.06),('12374','2013-01-22','08:25:00',1.45),('12374','2013-01-22','08:30:00',1.56),('12374','2013-01-22','08:35:00',1.1),('12374','2013-01-22','08:40:00',1.2),('12374','2013-01-22','09:00:00',1.03),('12374','2013-01-22','09:10:00',1.12),('12374','2013-01-22','09:25:00',1.95),('12374','2013-01-22','09:30:00',2.98),('12374','2013-01-22','09:35:00',4.34),('12374','2013-01-22','09:40:00',4.28),('12374','2013-01-22','09:45:00',2.47),('12374','2013-01-22','09:50:00',3.33),('12374','2013-01-22','09:55:00',5.23),('12374','2013-01-22','10:00:00',5.62),('12374','2013-01-22','10:05:00',5.87),('12374','2013-01-22','10:10:00',7.05),('12374','2013-01-22','10:15:00',3.57),('12374','2013-01-22','10:20:00',1.82),('12374','2013-01-22','10:25:00',3.7),('12374','2013-01-22','10:30:00',2.79),('12374','2013-01-22','10:35:00',2.9),('12374','2013-01-22','10:40:00',3.14),('12374','2013-01-22','10:45:00',4.68),('12374','2013-01-22','10:50:00',3.62),('12374','2013-01-22','10:55:00',1.96),('12374','2013-01-22','11:00:00',2.74),('12374','2013-01-22','11:05:00',2.28),('12374','2013-01-22','11:10:00',6.28),('12374','2013-01-22','11:15:00',7.13),('12374','2013-01-22','11:20:00',3.67),('12374','2013-01-22','11:25:00',4.99),('12374','2013-01-22','11:30:00',4.09),('12374','2013-01-22','11:35:00',3.12),('12374','2013-01-22','11:40:00',7.21),('12374','2013-01-22','11:45:00',4.67),('12374','2013-01-22','11:50:00',4.67),('12374','2013-01-22','11:55:00',2.95),('12374','2013-01-22','12:00:00',3.44),('12374','2013-01-22','12:05:00',8.04),('12374','2013-01-22','12:10:00',5.32),('12374','2013-01-22','12:15:00',2.48),('12374','2013-01-22','12:20:00',6.38),('12374','2013-01-22','12:25:00',7.38),('12374','2013-01-22','12:30:00',6.2),('12374','2013-01-22','12:35:00',7.27),('12374','2013-01-22','12:40:00',7.29),('12374','2013-01-22','12:45:00',7.71),('12374','2013-01-22','12:50:00',5.39),('12374','2013-01-22','12:55:00',7.37),('12374','2013-01-22','13:00:00',7.34),('12374','2013-01-22','13:05:00',7.36),('12374','2013-01-22','13:10:00',7.04),('12374','2013-01-22','13:15:00',7.05),('12374','2013-01-22','13:20:00',6.83),('12374','2013-01-22','13:25:00',5.27),('12374','2013-01-22','13:30:00',3.11),('12374','2013-01-22','13:35:00',7.68),('12374','2013-01-22','13:40:00',6.72),('12374','2013-01-22','13:45:00',5.9),('12374','2013-01-22','13:50:00',5.4),('12374','2013-01-22','13:55:00',5.54),('12374','2013-01-22','14:00:00',5.32),('12374','2013-01-22','14:05:00',6.43),('12374','2013-01-22','14:10:00',2.9),('12374','2013-01-22','14:15:00',3.07),('12374','2013-01-22','14:20:00',5.17),('12374','2013-01-22','14:26:00',6.3),('12374','2013-01-22','14:30:00',2.74),('12374','2013-01-22','14:35:00',1.73),('12374','2013-01-22','14:45:00',1.66),('12374','2013-01-22','15:00:00',1.16),('12374','2013-01-21','09:30:00',1.07),('12374','2013-01-21','09:35:00',1.42),('12374','2013-01-21','09:40:00',1.2),('12374','2013-01-21','10:00:00',1.2),('12374','2013-01-21','10:05:00',1.36),('12374','2013-01-21','10:10:00',1.25),('12374','2013-01-21','10:15:00',1.45),('12374','2013-01-21','10:20:00',2.01),('12374','2013-01-21','10:25:00',2.5),('12374','2013-01-21','10:30:00',2.35),('12374','2013-01-21','10:35:00',1.55),('12374','2013-01-21','10:40:00',1.25),('12374','2013-01-21','10:45:00',1.3),('12374','2013-01-21','10:50:00',1.2),('12374','2013-01-21','10:55:00',1.44),('12374','2013-01-21','11:00:00',1.83),('12374','2013-01-21','11:05:00',1.84),('12374','2013-01-21','11:10:00',2.91),('12374','2013-01-21','11:15:00',2),('12374','2013-01-21','11:20:00',6.09),('12374','2013-01-21','11:25:00',6.58),('12374','2013-01-21','11:30:00',6.63),('12374','2013-01-21','11:35:00',6.62),('12374','2013-01-21','11:40:00',6.54),('12374','2013-01-21','11:45:00',5.67),('12374','2013-01-21','11:50:00',6.95),('12374','2013-01-21','11:55:00',6.95),('12374','2013-01-21','12:00:00',3.79),('12374','2013-01-21','12:05:00',2.24),('12374','2013-01-21','12:10:00',2.26),('12374','2013-01-21','12:15:00',3.42),('12374','2013-01-21','12:20:00',3.29),('12374','2013-01-21','12:25:00',3.63),('12374','2013-01-21','12:30:00',3.54),('12374','2013-01-21','12:35:00',2.39),('12374','2013-01-21','12:40:00',1.39),('12374','2013-01-21','12:45:00',1.32),('12374','2013-01-21','12:50:00',1.34),('12374','2013-01-21','12:55:00',2.27),('12374','2013-01-21','13:05:00',1.73),('12374','2013-01-21','13:10:00',6.05),('12374','2013-01-21','13:15:00',6.94),('12374','2013-01-21','13:20:00',6.66),('12374','2013-01-21','13:25:00',4.72),('12374','2013-01-21','13:30:00',5.74),('12374','2013-01-21','13:35:00',6.3),('12374','2013-01-21','13:40:00',6.36),('12374','2013-01-21','13:45:00',5.03),('12374','2013-01-21','13:50:00',5.51),('12374','2013-01-21','13:55:00',6.05),('12374','2013-01-21','14:00:00',5.9),('12374','2013-01-21','14:05:00',5.19),('12374','2013-01-21','14:10:00',4),('12374','2013-01-21','14:20:00',1.56),('12374','2013-01-21','14:25:00',1.36),('12374','2013-01-21','14:40:00',1.3),('12374','2013-01-21','14:45:00',1.63),('12374','2013-01-21','14:50:00',1.28),('12374','2013-01-21','14:55:00',1.25),('12374','2013-01-21','15:00:00',1.96),('12374','2013-01-21','15:05:00',5.36),('12374','2013-01-21','15:10:00',3.31),('12374','2013-01-21','15:15:00',3),('12374','2013-01-21','15:20:00',1.49),('12374','2013-01-20','10:30:00',1.08),('12374','2013-01-20','10:35:00',1.15),('12374','2013-01-20','10:40:00',1.37),('12374','2013-01-20','10:45:00',1.21),('12374','2013-01-20','10:50:00',1.2),('12374','2013-01-20','11:05:00',1.04),('12374','2013-01-20','11:10:00',1.03),('12374','2013-01-20','11:20:00',1.11),('12374','2013-01-20','11:25:00',1.27),('12374','2013-01-20','11:30:00',1.17),('12374','2013-01-20','11:35:00',1.21),('12374','2013-01-20','11:40:00',1.17),('12374','2013-01-20','11:45:00',1.14),('12374','2013-01-20','11:55:00',1.01),('12374','2013-01-20','12:00:00',1.03),('12374','2013-01-20','12:15:00',1.09),('12374','2013-01-20','12:20:00',1.05),('12374','2013-01-20','12:25:00',1.1),('12374','2013-01-20','12:30:00',1.12),('12374','2013-01-20','12:35:00',1.11),('12374','2013-01-20','12:40:00',1.14),('12374','2013-01-20','12:45:00',1.21),('12374','2013-01-20','12:50:00',1.26),('12374','2013-01-20','12:55:00',1.16),('12374','2013-01-20','13:15:00',1.01),('12374','2013-01-20','13:20:00',1.13),('12374','2013-01-20','13:25:00',1.43),('12374','2013-01-20','13:30:00',1.46),('12374','2013-01-20','13:35:00',1.31),('12374','2013-01-20','13:40:00',1.24),('12374','2013-01-20','13:45:00',1.26),('12374','2013-01-20','13:50:00',1.16),('12374','2013-01-20','13:55:00',1.1),('12374','2013-01-19','08:50:00',1.2),('12374','2013-01-19','08:55:00',1.44),('12374','2013-01-19','09:00:00',1.52),('12374','2013-01-19','09:05:00',1.08),('12374','2013-01-19','09:25:00',1.22),('12374','2013-01-19','09:30:00',1.67),('12374','2013-01-19','09:35:00',2.24),('12374','2013-01-19','09:40:00',2.52),('12374','2013-01-19','09:45:00',2.08),('12374','2013-01-19','09:50:00',1.33),('12374','2013-01-19','10:15:00',1.35),('12374','2013-01-19','10:20:00',1.43),('12374','2013-01-19','10:25:00',1.17),('12374','2013-01-19','10:50:00',1.01),('12374','2013-01-19','10:55:00',1.41),('12374','2013-01-19','11:00:00',1.57),('12374','2013-01-19','11:05:00',1.63),('12374','2013-01-19','11:10:00',1.5),('12374','2013-01-19','11:15:00',1.18),('12374','2013-01-19','11:20:00',1.09),('12374','2013-01-19','11:25:00',1.21),('12374','2013-01-19','11:30:00',1.07),('12374','2013-01-19','11:35:00',1.11),('12374','2013-01-19','11:40:00',1.53),('12374','2013-01-19','11:45:00',1.69),('12374','2013-01-19','11:50:00',1.5),('12374','2013-01-19','11:55:00',1.22),('12374','2013-01-19','12:00:00',1.18),('12374','2013-01-19','14:05:00',1.32),('12374','2013-01-19','14:10:00',1.14),('12374','2013-01-19','14:45:00',1.06),('12374','2013-01-19','14:50:00',1.04),('12374','2013-01-18','09:35:00',1),('12374','2013-01-18','09:40:00',1.19),('12374','2013-01-18','09:45:00',1.27),('12374','2013-01-18','09:50:00',1.29),('12374','2013-01-18','09:55:00',1.6),('12374','2013-01-18','10:00:00',2.63),('12374','2013-01-18','10:05:00',2.77),('12374','2013-01-18','10:10:00',1.83),('12374','2013-01-18','10:15:00',1.44),('12374','2013-01-18','10:20:00',1.11),('12374','2013-01-18','10:25:00',1.01),('12374','2013-01-18','10:30:00',1.12),('12374','2013-01-18','10:35:00',1.38),('12374','2013-01-18','10:40:00',1.55),('12374','2013-01-18','10:45:00',1.73),('12374','2013-01-18','10:50:00',1.98),('12374','2013-01-18','10:55:00',2.12),('12374','2013-01-18','11:00:00',2.49),('12374','2013-01-18','11:05:00',3.15),('12374','2013-01-18','11:10:00',2.92),('12374','2013-01-18','11:15:00',2.78),('12374','2013-01-18','11:20:00',2.47),('12374','2013-01-18','11:25:00',2.63),('12374','2013-01-18','11:30:00',2.72),('12374','2013-01-18','11:35:00',2.72),('12374','2013-01-18','11:40:00',2.85),('12374','2013-01-18','11:45:00',3.09),('12374','2013-01-18','11:50:00',3.63),('12374','2013-01-18','11:55:00',4.42),('12374','2013-01-18','12:00:00',3.97),('12374','2013-01-18','12:05:00',4.3),('12374','2013-01-18','12:10:00',4.97),('12374','2013-01-18','12:15:00',4.51),('12374','2013-01-18','12:20:00',4.07),('12374','2013-01-18','12:25:00',5.51),('12374','2013-01-18','12:30:00',3.38),('12374','2013-01-18','12:35:00',3.48),('12374','2013-01-18','12:40:00',3.08),('12374','2013-01-18','12:45:00',3.13),('12374','2013-01-18','12:50:00',3.74),('12374','2013-01-18','12:55:00',3.35),('12374','2013-01-18','13:00:00',4.69),('12374','2013-01-18','13:05:00',4.72),('12374','2013-01-18','13:10:00',3.72),('12374','2013-01-18','13:15:00',3.63),('12374','2013-01-18','13:20:00',3.4),('12374','2013-01-18','13:25:00',2.75),('12374','2013-01-18','13:30:00',5.26),('12374','2013-01-18','13:35:00',6.38),('12374','2013-01-18','13:40:00',6.21),('12374','2013-01-18','13:45:00',6.12),('12374','2013-01-18','13:50:00',5.92),('12374','2013-01-18','13:55:00',5.74),('12374','2013-01-18','14:00:00',5.63),('12374','2013-01-18','14:05:00',5.66),('12374','2013-01-18','14:10:00',6),('12374','2013-01-18','14:15:00',6.26),('12374','2013-01-18','14:20:00',6.3),('12374','2013-01-18','14:25:00',3.45),('12374','2013-01-18','14:30:00',5.47),('12374','2013-01-18','14:35:00',3.12),('12374','2013-01-18','14:40:00',2.95),('12374','2013-01-18','14:45:00',2.9),('12374','2013-01-18','14:50:00',2.45),('12374','2013-01-18','14:55:00',1.96),('12374','2013-01-18','15:00:00',1.98),('12374','2013-01-18','15:05:00',3.02),('12374','2013-01-18','15:10:00',3.47),('12374','2013-01-18','15:15:00',3.68),('12374','2013-01-18','15:20:00',4.06),('12374','2013-01-18','15:25:00',3.74),('12374','2013-01-18','15:30:00',3.75),('12374','2013-01-18','15:35:00',3.45),('12374','2013-01-18','15:40:00',3.16),('12374','2013-01-18','15:45:00',2.71),('12374','2013-01-18','15:50:00',2.44),('12374','2013-01-18','15:55:00',2.22),('12374','2013-01-18','16:00:00',2.12),('12374','2013-01-18','16:05:00',1.93),('12374','2013-01-18','16:10:00',1.76),('12374','2013-01-18','16:15:00',1.57),('12374','2013-01-18','16:20:00',1.4),('12374','2013-01-18','16:25:00',1.26),('12374','2013-01-18','16:30:00',1.15),('12374','2013-01-17','09:10:00',1),('12374','2013-01-17','09:15:00',1.2),('12374','2013-01-17','09:20:00',1.66),('12374','2013-01-17','09:25:00',1.95),('12374','2013-01-17','09:30:00',2.1),('12374','2013-01-17','09:35:00',2.12),('12374','2013-01-17','09:40:00',2.25),('12374','2013-01-17','09:45:00',2.39),('12374','2013-01-17','09:50:00',2.29),('12374','2013-01-17','09:55:00',2.16),('12374','2013-01-17','10:00:00',2.21),('12374','2013-01-17','10:05:00',2.56),('12374','2013-01-17','10:10:00',2.78),('12374','2013-01-17','10:15:00',2.98),('12374','2013-01-17','10:20:00',3.09),('12374','2013-01-17','10:25:00',3.05),('12374','2013-01-17','10:30:00',4.02),('12374','2013-01-17','10:35:00',3.8),('12374','2013-01-17','10:40:00',3.49),('12374','2013-01-17','10:45:00',3.57),('12374','2013-01-17','10:50:00',3.87),('12374','2013-01-17','10:55:00',5.46),('12374','2013-01-17','11:00:00',6.3),('12374','2013-01-17','11:05:00',5.23),('12374','2013-01-17','11:10:00',5.58),('12374','2013-01-17','11:15:00',5.41),('12374','2013-01-17','11:20:00',4.79),('12374','2013-01-17','11:25:00',4.38),('12374','2013-01-17','11:30:00',5.37),('12374','2013-01-17','11:35:00',5.34),('12374','2013-01-17','11:40:00',5.2),('12374','2013-01-17','11:45:00',5.42),('12374','2013-01-17','11:50:00',5.16),('12374','2013-01-17','11:55:00',5.67),('12374','2013-01-17','12:00:00',5.73),('12374','2013-01-17','12:05:00',4.98),('12374','2013-01-17','12:10:00',3.44),('12374','2013-01-17','12:15:00',5.28),('12374','2013-01-17','12:20:00',5.54),('12374','2013-01-17','12:25:00',5.09),('12374','2013-01-17','12:30:00',5.58),('12374','2013-01-17','12:35:00',3.03),('12374','2013-01-17','12:40:00',1.71),('12374','2013-01-17','12:45:00',4.34),('12374','2013-01-17','12:50:00',4.38),('12374','2013-01-17','12:55:00',3.58),('12374','2013-01-17','13:00:00',4.94),('12374','2013-01-17','13:05:00',4.27),('12374','2013-01-17','13:10:00',4.15),('12374','2013-01-17','13:15:00',5.55),('12374','2013-01-17','13:20:00',4.7),('12374','2013-01-17','13:25:00',1.49),('12374','2013-01-17','13:30:00',2.83),('12374','2013-01-17','13:35:00',4.27),('12374','2013-01-17','13:40:00',3.23),('12374','2013-01-17','13:45:00',2.57),('12374','2013-01-17','13:50:00',5.23),('12374','2013-01-17','13:55:00',3.49),('12374','2013-01-17','14:00:00',2.45),('12374','2013-01-17','14:05:00',5.64),('12374','2013-01-17','14:10:00',6.07),('12374','2013-01-17','14:15:00',4.37),('12374','2013-01-17','14:20:00',2.49),('12374','2013-01-17','14:25:00',2.02),('12374','2013-01-17','14:30:00',1.89),('12374','2013-01-17','14:35:00',1.82),('12374','2013-01-17','14:40:00',1.65),('12374','2013-01-17','14:45:00',1.7),('12374','2013-01-17','14:50:00',1.78),('12374','2013-01-17','14:55:00',1.66),('12374','2013-01-17','15:00:00',1.43),('12374','2013-01-17','15:05:00',1.41),('12374','2013-01-17','15:10:00',1.26),('12374','2013-01-17','15:15:00',1.17),('12374','2013-01-16','08:45:00',1.34),('12374','2013-01-16','08:50:00',1.23),('12374','2013-01-16','08:55:00',1.03),('12374','2013-01-16','09:05:00',1.24),('12374','2013-01-16','09:20:00',1.14),('12374','2013-01-16','09:50:00',3.83),('12374','2013-01-16','09:55:00',3.3),('12374','2013-01-16','10:10:00',4.64),('12374','2013-01-16','10:15:00',6.78),('12374','2013-01-16','10:20:00',4.23),('12374','2013-01-16','10:25:00',4.16),('12374','2013-01-16','10:30:00',4.98),('12374','2013-01-16','10:35:00',4.67),('12374','2013-01-16','10:50:00',1.16),('12374','2013-01-16','10:55:00',1.56),('12374','2013-01-16','11:00:00',1.85),('12374','2013-01-16','11:05:00',2.82),('12374','2013-01-16','11:10:00',1.76),('12374','2013-01-16','11:15:00',1.89),('12374','2013-01-16','11:20:00',1.9),('12374','2013-01-16','11:25:00',1.75),('12374','2013-01-16','11:30:00',1.71),('12374','2013-01-16','11:35:00',1.53),('12374','2013-01-16','11:40:00',1.66),('12374','2013-01-16','11:45:00',1.06),('12374','2013-01-16','11:50:00',1.04),('12374','2013-01-16','11:55:00',2.48),('12374','2013-01-16','12:15:00',1.66),('12374','2013-01-16','12:20:00',1.23),('12374','2013-01-16','13:00:00',2.69),('12374','2013-01-16','13:35:00',1.14),('12374','2013-01-16','13:40:00',1.16),('12374','2013-01-16','13:45:00',1.35),('12374','2013-01-16','13:50:00',1.48),('12374','2013-01-16','14:10:00',2.35),('12374','2013-01-16','14:15:00',3.76),('12374','2013-01-16','14:20:00',1.58),('12374','2013-01-16','14:25:00',1.22),('12374','2013-01-16','14:30:00',1.8),('12374','2013-01-16','14:35:00',3.78),('12374','2013-01-16','14:40:00',2.47),('12374','2013-01-16','14:45:00',1.26),('12374','2013-01-16','15:20:00',2.88),('12374','2013-01-16','15:25:00',4.02),('12374','2013-01-16','15:30:00',2.79),('12374','2013-01-16','15:40:00',1.52),('12374','2013-01-16','15:45:00',2.63),('12374','2013-01-16','15:50:00',2.61),('12374','2013-01-16','15:55:00',2.01),('12374','2013-01-15','08:35:00',1.61),('12374','2013-01-15','08:40:00',2.18),('12374','2013-01-15','08:45:00',2.59),('12374','2013-01-15','08:50:00',2.9),('12374','2013-01-15','08:55:00',2.81),('12374','2013-01-15','09:00:00',3.23),('12374','2013-01-15','09:05:00',3.25),('12374','2013-01-15','09:10:00',3.6),('12374','2013-01-15','09:15:00',3.73),('12374','2013-01-15','09:20:00',3.87),('12374','2013-01-15','09:25:00',4.02),('12374','2013-01-15','09:30:00',4.21),('12374','2013-01-15','09:35:00',4.43),('12374','2013-01-15','09:40:00',4.58),('12374','2013-01-15','09:45:00',4.77),('12374','2013-01-15','09:50:00',2.85),('12374','2013-01-15','09:55:00',1.11),('12374','2013-01-15','10:00:00',3.66),('12374','2013-01-15','10:05:00',3.16),('12374','2013-01-15','10:15:00',1.49),('12374','2013-01-15','10:20:00',2.79),('12374','2013-01-15','10:25:00',2.98),('12374','2013-01-15','10:30:00',2.65),('12374','2013-01-15','10:35:00',5.94),('12374','2013-01-15','10:40:00',5.06),('12374','2013-01-15','10:45:00',4.97),('12374','2013-01-15','10:50:00',5.63),('12374','2013-01-15','10:55:00',3.71),('12374','2013-01-15','11:00:00',3.18),('12374','2013-01-15','11:05:00',2.67),('12374','2013-01-15','11:10:00',3.43),('12374','2013-01-15','11:15:00',3.89),('12374','2013-01-15','11:20:00',3.76),('12374','2013-01-15','11:25:00',4.22),('12374','2013-01-15','11:30:00',4.12),('12374','2013-01-15','11:35:00',4.44),('12374','2013-01-15','11:40:00',4.81),('12374','2013-01-15','11:45:00',5.8),('12374','2013-01-15','11:50:00',5.15),('12374','2013-01-15','11:55:00',4.11),('12374','2013-01-15','12:00:00',3.27),('12374','2013-01-15','12:05:00',3.08),('12374','2013-01-15','12:10:00',3.39),('12374','2013-01-15','12:15:00',3.28),('12374','2013-01-15','12:20:00',3.29),('12374','2013-01-15','12:25:00',3.2),('12374','2013-01-15','12:30:00',3.32),('12374','2013-01-15','12:35:00',3.4),('12374','2013-01-15','12:40:00',3.52),('12374','2013-01-15','12:45:00',3.51),('12374','2013-01-15','12:50:00',3.66),('12374','2013-01-15','12:55:00',3.41),('12374','2013-01-15','13:00:00',3.75),('12374','2013-01-15','13:05:00',3.74),('12374','2013-01-15','13:10:00',3.93),('12374','2013-01-15','13:15:00',4.28),('12374','2013-01-15','13:20:00',3.62),('12374','2013-01-15','13:25:00',3.95),('12374','2013-01-15','13:30:00',4.19),('12374','2013-01-15','13:35:00',5.54),('12374','2013-01-15','13:40:00',5.17),('12374','2013-01-15','13:45:00',5.47),('12374','2013-01-15','13:50:00',4.85),('12374','2013-01-15','13:55:00',4.28),('12374','2013-01-15','14:00:00',4.09),('12374','2013-01-15','14:05:00',2.38),('12374','2013-01-15','14:10:00',1.86),('12374','2013-01-15','14:15:00',2.47),('12374','2013-01-15','14:20:00',3.88),('12374','2013-01-15','14:25:00',6.36),('12374','2013-01-15','14:30:00',4.99),('12374','2013-01-15','14:35:00',4.72),('12374','2013-01-15','14:40:00',4.64),('12374','2013-01-15','14:45:00',4.25),('12374','2013-01-15','14:50:00',4.43),('12374','2013-01-15','14:55:00',4.31),('12374','2013-01-15','15:00:00',4.11),('12374','2013-01-15','15:05:00',4.05),('12374','2013-01-15','15:10:00',4.06),('12374','2013-01-15','15:15:00',3.9),('12374','2013-01-15','15:20:00',3.72),('12374','2013-01-15','15:25:00',3.59),('12374','2013-01-15','15:30:00',3.67),('12374','2013-01-15','15:35:00',3.48),('12374','2013-01-15','15:40:00',3.09),('12374','2013-01-15','15:45:00',2.94),('12374','2013-01-15','15:50:00',2.72),('12374','2013-01-15','15:55:00',2.69),('12374','2013-01-15','16:00:00',2.57),('12374','2013-01-15','16:05:00',2.41),('12374','2013-01-15','16:10:00',2.24),('12374','2013-01-15','16:15:00',2.02),('12374','2013-01-15','16:20:00',1.77),('12374','2013-01-15','16:25:00',1.57),('12374','2013-01-15','16:30:00',1.29),('12374','2013-01-14','11:00:00',1.08),('12374','2013-01-14','11:05:00',1.05),('12374','2013-01-14','14:05:00',1.13),('12374','2013-01-13','08:50:00',1.02),('12374','2013-01-13','08:55:00',1.12),('12374','2013-01-13','09:35:00',1.23),('12374','2013-01-13','09:40:00',1.74),('12374','2013-01-13','09:45:00',1.63),('12374','2013-01-13','09:50:00',1.42),('12374','2013-01-13','09:55:00',3.15),('12374','2013-01-13','10:00:00',3.66),('12374','2013-01-13','10:05:00',5.84),('12374','2013-01-13','10:10:00',6.49),('12374','2013-01-13','10:15:00',2.35),('12374','2013-01-13','10:40:00',1.02),('12374','2013-01-13','10:45:00',1.05),('12374','2013-01-13','10:55:00',1.16),('12374','2013-01-13','11:10:00',1.7),('12374','2013-01-13','11:15:00',1.62),('12374','2013-01-13','11:55:00',1.02),('12374','2013-01-12','08:15:00',1.09),('12374','2013-01-12','08:20:00',1.33),('12374','2013-01-12','08:25:00',1.58),('12374','2013-01-12','08:30:00',1.8),('12374','2013-01-12','08:35:00',2.03),('12374','2013-01-12','08:40:00',2.24),('12374','2013-01-12','08:45:00',2.47),('12374','2013-01-12','08:50:00',2.47),('12374','2013-01-12','08:55:00',2.88),('12374','2013-01-12','09:00:00',2.86),('12374','2013-01-12','09:05:00',3.27),('12374','2013-01-12','09:10:00',3.47),('12374','2013-01-12','09:15:00',3.63),('12374','2013-01-12','09:20:00',3.76),('12374','2013-01-12','09:25:00',3.86),('12374','2013-01-12','09:30:00',4.07),('12374','2013-01-12','09:35:00',4.22),('12374','2013-01-12','09:40:00',4.37),('12374','2013-01-12','09:45:00',4.49),('12374','2013-01-12','09:50:00',4.63),('12374','2013-01-12','09:55:00',4.76),('12374','2013-01-12','10:00:00',4.88),('12374','2013-01-12','10:05:00',5),('12374','2013-01-12','10:10:00',5.13),('12374','2013-01-12','10:15:00',5.25),('12374','2013-01-12','10:20:00',5.36),('12374','2013-01-12','10:25:00',5.44),('12374','2013-01-12','10:30:00',5.54),('12374','2013-01-12','10:35:00',5.65),('12374','2013-01-12','10:40:00',5.68),('12374','2013-01-12','10:45:00',5.78),('12374','2013-01-12','10:50:00',5.86),('12374','2013-01-12','10:55:00',5.92),('12374','2013-01-12','11:00:00',6.02),('12374','2013-01-12','11:05:00',6.1),('12374','2013-01-12','11:10:00',6.14),('12374','2013-01-12','11:15:00',6.21),('12374','2013-01-12','11:20:00',6.26),('12374','2013-01-12','11:25:00',6.28),('12374','2013-01-12','11:30:00',6.3),('12374','2013-01-12','11:35:00',6.32),('12374','2013-01-12','11:40:00',6.34),('12374','2013-01-12','11:45:00',6.36),('12374','2013-01-12','11:50:00',6.39),('12374','2013-01-12','11:55:00',6.42),('12374','2013-01-12','12:00:00',6.46),('12374','2013-01-12','12:05:00',6.41),('12374','2013-01-12','12:10:00',6.4),('12374','2013-01-12','12:15:00',6.37),('12374','2013-01-12','12:20:00',6.36),('12374','2013-01-12','12:25:00',6.34),('12374','2013-01-12','12:30:00',6.3),('12374','2013-01-12','12:35:00',6.29),('12374','2013-01-12','12:40:00',6.34),('12374','2013-01-12','12:45:00',6.32),('12374','2013-01-12','12:50:00',6.17),('12374','2013-01-12','12:55:00',6.08),('12374','2013-01-12','13:00:00',6.12),('12374','2013-01-12','13:05:00',6.22),('12374','2013-01-12','13:10:00',6.3),('12374','2013-01-12','13:15:00',6.23),('12374','2013-01-12','13:20:00',6.14),('12374','2013-01-12','13:25:00',5.92),('12374','2013-01-12','13:30:00',5.88),('12374','2013-01-12','13:35:00',5.76),('12374','2013-01-12','13:40:00',5.65),('12374','2013-01-12','13:45:00',5.52),('12374','2013-01-12','13:50:00',5.39),('12374','2013-01-12','13:55:00',5.37),('12374','2013-01-12','14:00:00',5.31),('12374','2013-01-12','14:05:00',5.25),('12374','2013-01-12','14:10:00',5.12),('12374','2013-01-12','14:15:00',5.05),('12374','2013-01-12','14:20:00',4.92),('12374','2013-01-12','14:25:00',4.67),('12374','2013-01-12','14:30:00',4.64),('12374','2013-01-12','14:35:00',4.55),('12374','2013-01-12','14:40:00',4.38),('12374','2013-01-12','14:45:00',4.2),('12374','2013-01-12','14:50:00',4.05),('12374','2013-01-12','14:55:00',3.98),('12374','2013-01-12','15:00:00',3.82),('12374','2013-01-12','15:05:00',3.65),('12374','2013-01-12','15:10:00',3.51),('12374','2013-01-12','15:15:00',3.38),('12374','2013-01-12','15:20:00',3.25),('12374','2013-01-12','15:25:00',3.09),('12374','2013-01-12','15:30:00',2.94),('12374','2013-01-12','15:35:00',2.77),('12374','2013-01-12','15:40:00',2.56),('12374','2013-01-12','15:45:00',2.38),('12374','2013-01-12','15:50:00',2.14),('12374','2013-01-12','15:55:00',1.85),('12374','2013-01-11','09:15:00',1.11),('12374','2013-01-11','09:20:00',2.56),('12374','2013-01-11','09:25:00',3.63),('12374','2013-01-11','09:30:00',3.67),('12374','2013-01-11','09:35:00',3.8),('12374','2013-01-11','09:40:00',1.49),('12374','2013-01-11','09:45:00',1.94),('12374','2013-01-11','09:50:00',3.85),('12374','2013-01-11','09:55:00',4.29),('12374','2013-01-11','10:00:00',4.37),('12374','2013-01-11','10:05:00',4.22),('12374','2013-01-11','10:10:00',4.38),('12374','2013-01-11','10:15:00',4.7),('12374','2013-01-11','10:20:00',4.64),('12374','2013-01-11','10:25:00',4.93),('12374','2013-01-11','10:30:00',5.09),('12374','2013-01-11','10:35:00',4.91),('12374','2013-01-11','10:40:00',5.01),('12374','2013-01-11','10:45:00',5.16),('12374','2013-01-11','10:50:00',5.42),('12374','2013-01-11','10:55:00',5.43),('12374','2013-01-11','11:00:00',5.56),('12374','2013-01-11','11:05:00',5.71),('12374','2013-01-11','11:10:00',5.91),('12374','2013-01-11','11:15:00',5.28),('12374','2013-01-11','11:20:00',3.14),('12374','2013-01-11','11:25:00',2.85),('12374','2013-01-11','11:30:00',2.28),('12374','2013-01-11','11:35:00',1.99),('12374','2013-01-11','11:40:00',1.77),('12374','2013-01-11','11:45:00',1.98),('12374','2013-01-11','11:50:00',2.03),('12374','2013-01-11','11:55:00',1.84),('12374','2013-01-11','12:00:00',1.22),('12374','2013-01-11','12:05:00',1.04),('12374','2013-01-11','12:15:00',1.27),('12374','2013-01-11','12:20:00',1.61),('12374','2013-01-11','12:25:00',2.46),('12374','2013-01-11','12:30:00',2.32),('12374','2013-01-11','12:35:00',2.16),('12374','2013-01-11','12:40:00',1.9),('12374','2013-01-11','12:45:00',1.28),('12374','2013-01-11','13:10:00',1.27),('12374','2013-01-11','13:15:00',5.57),('12374','2013-01-11','13:20:00',4.22),('12374','2013-01-11','13:25:00',4.58),('12374','2013-01-11','13:30:00',3.28),('12374','2013-01-11','13:35:00',4.19),('12374','2013-01-11','13:40:00',2),('12374','2013-01-11','14:15:00',2.32),('12374','2013-01-11','14:20:00',3.92),('12374','2013-01-11','14:25:00',3.59),('12374','2013-01-11','14:30:00',3.75),('12374','2013-01-11','14:35:00',3.62),('12374','2013-01-11','14:40:00',1.82),('12374','2013-01-11','14:50:00',1.81),('12374','2013-01-11','14:55:00',2.1),('12374','2013-01-11','15:00:00',3.22),('12374','2013-01-11','15:05:00',3.43),('12374','2013-01-11','15:25:00',1.48),('12374','2013-01-11','15:30:00',2.52),('12374','2013-01-11','15:35:00',2.27),('12374','2013-01-11','15:40:00',1.07),('12374','2013-01-10','10:20:00',1.11),('12374','2013-01-10','10:25:00',1.23),('12374','2013-01-10','10:30:00',1.38),('12374','2013-01-10','10:35:00',1.3),('12374','2013-01-10','10:40:00',1.25),('12374','2013-01-10','10:45:00',1.18),('12374','2013-01-10','10:50:00',1.15),('12374','2013-01-10','10:55:00',1.09),('12374','2013-01-10','11:00:00',1.43),('12374','2013-01-10','11:05:00',1.43),('12374','2013-01-10','11:10:00',1.42),('12374','2013-01-10','11:15:00',1.17),('12374','2013-01-10','11:50:00',1.14),('12374','2013-01-10','11:55:00',1.38),('12374','2013-01-10','12:00:00',1.55),('12374','2013-01-10','12:05:00',1.7),('12374','2013-01-10','12:10:00',1.74),('12374','2013-01-10','12:15:00',1.41),('12374','2013-01-10','12:20:00',1.3),('12374','2013-01-10','12:25:00',1.27),('12374','2013-01-10','12:30:00',1.13),('12374','2013-01-10','12:50:00',1.25),('12374','2013-01-10','12:55:00',1.44),('12374','2013-01-10','13:00:00',1.05),('12374','2013-01-10','13:05:00',1.02),('12374','2013-01-10','13:15:00',1.49),('12374','2013-01-10','13:20:00',1.83),('12374','2013-01-10','13:25:00',1.56),('12374','2013-01-10','13:30:00',1.43),('12374','2013-01-10','13:35:00',1.5),('12374','2013-01-10','13:40:00',1.34),('12374','2013-01-10','13:45:00',1.12),('12374','2013-01-10','14:25:00',1.07),('12374','2013-01-10','14:30:00',1.16),('12374','2013-01-10','14:35:00',1.05),('12374','2013-01-09','09:10:00',1.02),('12374','2013-01-09','09:15:00',1.09),('12374','2013-01-09','09:20:00',1.27),('12374','2013-01-09','09:25:00',1.73),('12374','2013-01-09','09:30:00',1.5),('12374','2013-01-09','09:35:00',1.56),('12374','2013-01-09','09:40:00',1.98),('12374','2013-01-09','09:45:00',2.09),('12374','2013-01-09','09:50:00',2.72),('12374','2013-01-09','09:55:00',1.9),('12374','2013-01-09','10:00:00',1.83),('12374','2013-01-09','10:05:00',1.64),('12374','2013-01-09','10:10:00',1.6),('12374','2013-01-09','10:15:00',1.7),('12374','2013-01-09','10:20:00',2.28),('12374','2013-01-09','10:25:00',1.8),('12374','2013-01-09','10:30:00',1.88),('12374','2013-01-09','10:35:00',2.21),('12374','2013-01-09','10:40:00',2.3),('12374','2013-01-09','10:45:00',2.3),('12374','2013-01-09','10:50:00',1.9),('12374','2013-01-09','10:55:00',1.79),('12374','2013-01-09','11:00:00',1.81),('12374','2013-01-09','11:05:00',1.89),('12374','2013-01-09','11:10:00',1.89),('12374','2013-01-09','11:15:00',2.09),('12374','2013-01-09','11:20:00',2.07),('12374','2013-01-09','11:25:00',1.96),('12374','2013-01-09','11:30:00',2.13),('12374','2013-01-09','11:35:00',2.89),('12374','2013-01-09','11:40:00',3.66),('12374','2013-01-09','11:45:00',3.74),('12374','2013-01-09','11:50:00',3.64),('12374','2013-01-09','11:55:00',4.01),('12374','2013-01-09','12:00:00',4.43),('12374','2013-01-09','12:05:00',5.67),('12374','2013-01-09','12:10:00',4.56),('12374','2013-01-09','12:15:00',4.7),('12374','2013-01-09','12:20:00',5.32),('12374','2013-01-09','12:25:00',4.32),('12374','2013-01-09','12:30:00',3.51),('12374','2013-01-09','12:35:00',3.96),('12374','2013-01-09','12:40:00',4.53),('12374','2013-01-09','12:45:00',3.54),('12374','2013-01-09','12:50:00',4.06),('12374','2013-01-09','12:55:00',3.72),('12374','2013-01-09','13:00:00',4.31),('12374','2013-01-09','13:05:00',5.04),('12374','2013-01-09','13:10:00',5.25),('12374','2013-01-09','13:15:00',4.88),('12374','2013-01-09','13:20:00',4.94),('12374','2013-01-09','13:25:00',5.25),('12374','2013-01-09','13:30:00',5.6),('12374','2013-01-09','13:35:00',3.28),('12374','2013-01-09','13:40:00',2.23),('12374','2013-01-09','13:45:00',1.87),('12374','2013-01-09','13:50:00',1.78),('12374','2013-01-09','13:55:00',2.03),('12374','2013-01-09','14:00:00',3.06),('12374','2013-01-09','14:05:00',3.52),('12374','2013-01-09','14:10:00',3.25),('12374','2013-01-09','14:15:00',2.35),('12374','2013-01-09','14:20:00',2.04),('12374','2013-01-09','14:25:00',1.95),('12374','2013-01-09','14:30:00',2.18),('12374','2013-01-09','14:35:00',2.24),('12374','2013-01-09','14:40:00',2),('12374','2013-01-09','14:45:00',2.63),('12374','2013-01-09','14:50:00',3.18),('12374','2013-01-09','14:55:00',2.23),('12374','2013-01-09','15:00:00',1.38),('12374','2013-01-09','15:05:00',1.25),('12374','2013-01-09','15:10:00',1.23),('12374','2013-01-09','15:15:00',1.57),('12374','2013-01-09','15:20:00',1.67),('12374','2013-01-09','15:25:00',3.29),('12374','2013-01-09','15:30:00',3.08),('12374','2013-01-09','15:35:00',2.75),('12374','2013-01-09','15:40:00',2.11),('12374','2013-01-09','15:45:00',1.85),('12374','2013-01-09','15:50:00',2.18),('12374','2013-01-09','15:55:00',1.96),('12374','2013-01-09','16:00:00',1.65),('12374','2013-01-09','16:05:00',1.42),('12374','2013-01-09','16:10:00',1.2),('12374','2013-01-09','16:15:00',1),('12374','2013-01-08','08:15:00',1.03),('12374','2013-01-08','08:20:00',1.3),('12374','2013-01-08','08:25:00',1.37),('12374','2013-01-08','08:30:00',1.07),('12374','2013-01-08','08:55:00',1.07),('12374','2013-01-08','09:00:00',1.25),('12374','2013-01-08','09:05:00',1.43),('12374','2013-01-08','09:10:00',1.38),('12374','2013-01-08','09:15:00',1.42),('12374','2013-01-08','09:20:00',1.52),('12374','2013-01-08','09:25:00',1.6),('12374','2013-01-08','09:30:00',1.68),('12374','2013-01-08','09:35:00',1.62),('12374','2013-01-08','09:40:00',1.61),('12374','2013-01-08','09:45:00',1.49),('12374','2013-01-08','09:50:00',1.54),('12374','2013-01-08','09:55:00',1.76),('12374','2013-01-08','10:00:00',1.67),('12374','2013-01-08','10:05:00',1.87),('12374','2013-01-08','10:10:00',3.31),('12374','2013-01-08','10:15:00',4.5),('12374','2013-01-08','10:20:00',4.61),('12374','2013-01-08','10:25:00',4.57),('12374','2013-01-08','10:30:00',4.86),('12374','2013-01-08','10:35:00',4.93),('12374','2013-01-08','10:40:00',5.53),('12374','2013-01-08','10:45:00',5.58),('12374','2013-01-08','10:50:00',5.71),('12374','2013-01-08','10:55:00',5.75),('12374','2013-01-08','11:00:00',5.85),('12374','2013-01-08','11:05:00',5.99),('12374','2013-01-08','11:10:00',6.05),('12374','2013-01-08','11:15:00',6.11),('12374','2013-01-08','11:20:00',6.2),('12374','2013-01-08','11:25:00',6.2),('12374','2013-01-08','11:30:00',6.08),('12374','2013-01-08','11:35:00',6.06),('12374','2013-01-08','11:40:00',6.11),('12374','2013-01-08','11:45:00',6.24),('12374','2013-01-08','11:50:00',6.72),('12374','2013-01-08','11:55:00',7.49),('12374','2013-01-08','12:00:00',5.09),('12374','2013-01-08','12:05:00',5.15),('12374','2013-01-08','12:10:00',5.71),('12374','2013-01-08','12:15:00',3.79),('12374','2013-01-08','12:20:00',3.36),('12374','2013-01-08','12:25:00',3.06),('12374','2013-01-08','12:30:00',3.2),('12374','2013-01-08','12:35:00',3.3),('12374','2013-01-08','12:40:00',2.08),('12374','2013-01-08','12:45:00',1.8),('12374','2013-01-08','12:50:00',1.23),('12374','2013-01-08','12:55:00',1.22),('12374','2013-01-08','13:00:00',1.41),('12374','2013-01-08','13:05:00',1.4),('12374','2013-01-08','13:10:00',1.28),('12374','2013-01-08','13:15:00',1.79),('12374','2013-01-08','13:20:00',2.25),('12374','2013-01-08','13:25:00',2.23),('12374','2013-01-08','13:30:00',1.5),('12374','2013-01-08','13:35:00',1.21),('12374','2013-01-08','13:40:00',1.05),('12374','2013-01-08','14:00:00',1.27),('12374','2013-01-08','14:05:00',1.44),('12374','2013-01-08','14:10:00',1.49),('12374','2013-01-08','14:15:00',1.87),('12374','2013-01-08','14:20:00',2.72),('12374','2013-01-08','14:25:00',5.31),('12374','2013-01-08','14:30:00',4.98),('12374','2013-01-08','14:35:00',4.89),('12374','2013-01-08','14:40:00',3.74),('12374','2013-01-08','14:45:00',3.38),('12374','2013-01-08','14:50:00',1.89),('12374','2013-01-08','14:55:00',2.09),('12374','2013-01-08','15:00:00',1.06),('12374','2013-01-08','15:05:00',1.74),('12374','2013-01-08','15:10:00',3.18),('12374','2013-01-08','15:15:00',3.04),('12374','2013-01-08','15:20:00',2.62),('12374','2013-01-08','15:25:00',2.01),('12374','2013-01-07','08:20:00',1),('12374','2013-01-07','08:25:00',1.2),('12374','2013-01-07','08:30:00',1.49),('12374','2013-01-07','08:35:00',1.71),('12374','2013-01-07','08:40:00',1.84),('12374','2013-01-07','08:45:00',2.12),('12374','2013-01-07','08:50:00',2.33),('12374','2013-01-07','08:55:00',2.32),('12374','2013-01-07','09:00:00',2.54),('12374','2013-01-07','09:05:00',2.88),('12374','2013-01-07','09:10:00',3.04),('12374','2013-01-07','09:15:00',3.26),('12374','2013-01-07','09:20:00',3.42),('12374','2013-01-07','09:25:00',3.56),('12374','2013-01-07','09:30:00',3.7),('12374','2013-01-07','09:35:00',3.84),('12374','2013-01-07','09:40:00',3.98),('12374','2013-01-07','09:45:00',4.11),('12374','2013-01-07','09:50:00',4.26),('12374','2013-01-07','09:55:00',4.49),('12374','2013-01-07','10:00:00',4.6),('12374','2013-01-07','10:05:00',4.74),('12374','2013-01-07','10:10:00',4.92),('12374','2013-01-07','10:15:00',5.04),('12374','2013-01-07','10:20:00',5.14),('12374','2013-01-07','10:25:00',5.29),('12374','2013-01-07','10:30:00',5.4),('12374','2013-01-07','10:35:00',5.47),('12374','2013-01-07','10:40:00',5.56),('12374','2013-01-07','10:45:00',5.62),('12374','2013-01-07','10:50:00',5.69),('12374','2013-01-07','10:55:00',5.78),('12374','2013-01-07','11:00:00',5.83),('12374','2013-01-07','11:05:00',5.92),('12374','2013-01-07','11:10:00',5.97),('12374','2013-01-07','11:15:00',5.97),('12374','2013-01-07','11:20:00',6.01),('12374','2013-01-07','11:25:00',6.05),('12374','2013-01-07','11:30:00',6.07),('12374','2013-01-07','11:35:00',6.1),('12374','2013-01-07','11:40:00',6.16),('12374','2013-01-07','11:45:00',6.1),('12374','2013-01-07','11:50:00',6.09),('12374','2013-01-07','11:55:00',6.14),('12374','2013-01-07','12:00:00',6.1),('12374','2013-01-07','12:05:00',6.15),('12374','2013-01-07','12:10:00',6.17),('12374','2013-01-07','12:15:00',6.13),('12374','2013-01-07','12:20:00',6.12),('12374','2013-01-07','12:25:00',6.07),('12374','2013-01-07','12:30:00',6.08),('12374','2013-01-07','12:35:00',6.08),('12374','2013-01-07','12:40:00',6.01),('12374','2013-01-07','12:45:00',5.97),('12374','2013-01-07','12:50:00',5.95),('12374','2013-01-07','12:55:00',5.93),('12374','2013-01-07','13:00:00',5.86),('12374','2013-01-07','13:05:00',5.85),('12374','2013-01-07','13:10:00',5.78),('12374','2013-01-07','13:15:00',5.63),('12374','2013-01-07','13:20:00',5.59),('12374','2013-01-07','13:25:00',5.5),('12374','2013-01-07','13:30:00',5.37),('12374','2013-01-07','13:35:00',5.31),('12374','2013-01-07','13:40:00',5.3),('12374','2013-01-07','13:45:00',5.2),('12374','2013-01-07','13:50:00',5.13),('12374','2013-01-07','13:55:00',5.05),('12374','2013-01-07','14:00:00',4.92),('12374','2013-01-07','14:05:00',4.78),('12374','2013-01-07','14:10:00',4.61),('12374','2013-01-07','14:15:00',4.55),('12374','2013-01-07','14:20:00',4.46),('12374','2013-01-07','14:25:00',4.39),('12374','2013-01-07','14:30:00',4.26),('12374','2013-01-07','14:35:00',4.16),('12374','2013-01-07','14:40:00',4.06),('12374','2013-01-07','14:45:00',3.98),('12374','2013-01-07','14:50:00',3.83),('12374','2013-01-07','14:55:00',3.76),('12374','2013-01-07','15:00:00',3.6),('12374','2013-01-07','15:05:00',3.43),('12374','2013-01-07','15:10:00',3.33),('12374','2013-01-07','15:15:00',3.15),('12374','2013-01-07','15:20:00',3.03),('12374','2013-01-07','15:25:00',2.85),('12374','2013-01-07','15:30:00',2.74),('12374','2013-01-07','15:35:00',2.54),('12374','2013-01-07','15:40:00',2.37),('12374','2013-01-07','15:45:00',2.16),('12374','2013-01-07','15:50:00',2.09),('12374','2013-01-07','15:55:00',1.92),('12374','2013-01-07','16:00:00',1.71),('12374','2013-01-07','16:05:00',1.52),('12374','2013-01-07','16:10:00',1.3),('12374','2013-01-07','16:15:00',1.14),('12374','2013-01-06','08:20:00',1.19),('12374','2013-01-06','08:25:00',1.37),('12374','2013-01-06','08:30:00',1.64),('12374','2013-01-06','08:35:00',1.9),('12374','2013-01-06','08:40:00',1.87),('12374','2013-01-06','08:45:00',2.24),('12374','2013-01-06','08:50:00',2.35),('12374','2013-01-06','08:55:00',2.43),('12374','2013-01-06','09:00:00',2.68),('12374','2013-01-06','09:05:00',3.05),('12374','2013-01-06','09:10:00',3.28),('12374','2013-01-06','09:15:00',3.33),('12374','2013-01-06','09:20:00',3.52),('12374','2013-01-06','09:25:00',3.77),('12374','2013-01-06','09:30:00',3.87),('12374','2013-01-06','09:35:00',3.92),('12374','2013-01-06','09:40:00',4.15),('12374','2013-01-06','09:45:00',4.3),('12374','2013-01-06','09:50:00',4.38),('12374','2013-01-06','09:55:00',4.52),('12374','2013-01-06','10:00:00',4.63),('12374','2013-01-06','10:05:00',4.7),('12374','2013-01-06','10:10:00',4.85),('12374','2013-01-06','10:15:00',4.98),('12374','2013-01-06','10:20:00',5.11),('12374','2013-01-06','10:25:00',5.19),('12374','2013-01-06','10:30:00',5.23),('12374','2013-01-06','10:35:00',5.33),('12374','2013-01-06','10:40:00',5.43),('12374','2013-01-06','10:45:00',5.5),('12374','2013-01-06','10:50:00',5.6),('12374','2013-01-06','10:55:00',5.7),('12374','2013-01-06','11:00:00',5.77),('12374','2013-01-06','11:05:00',5.84),('12374','2013-01-06','11:10:00',5.89),('12374','2013-01-06','11:15:00',5.9),('12374','2013-01-06','11:20:00',5.99),('12374','2013-01-06','11:25:00',6.04),('12374','2013-01-06','11:30:00',6.12),('12374','2013-01-06','11:35:00',6.17),('12374','2013-01-06','11:40:00',6.2),('12374','2013-01-06','11:45:00',6.23),('12374','2013-01-06','11:50:00',6.26),('12374','2013-01-06','11:55:00',6.24),('12374','2013-01-06','12:00:00',6.22),('12374','2013-01-06','12:05:00',6.21),('12374','2013-01-06','12:10:00',6.2),('12374','2013-01-06','12:15:00',6.13),('12374','2013-01-06','12:20:00',6.17),('12374','2013-01-06','12:25:00',6.15),('12374','2013-01-06','12:30:00',6.12),('12374','2013-01-06','12:35:00',6.07),('12374','2013-01-06','12:40:00',6.06),('12374','2013-01-06','12:45:00',6.03),('12374','2013-01-06','12:50:00',6.03),('12374','2013-01-06','12:55:00',5.96),('12374','2013-01-06','13:00:00',5.93),('12374','2013-01-06','13:05:00',5.84),('12374','2013-01-06','13:10:00',5.72),('12374','2013-01-06','13:15:00',5.67),('12374','2013-01-06','13:20:00',5.65),('12374','2013-01-06','13:25:00',5.53),('12374','2013-01-06','13:30:00',5.45),('12374','2013-01-06','13:35:00',5.37),('12374','2013-01-06','13:40:00',5.19),('12374','2013-01-06','13:45:00',5.11),('12374','2013-01-06','13:50:00',5),('12374','2013-01-06','13:55:00',4.92),('12374','2013-01-06','14:00:00',4.79),('12374','2013-01-06','14:05:00',4.72),('12374','2013-01-06','14:10:00',4.56),('12374','2013-01-06','14:15:00',4.48),('12374','2013-01-06','14:20:00',4.29),('12374','2013-01-06','14:25:00',4.17),('12374','2013-01-06','14:30:00',4.06),('12374','2013-01-06','14:35:00',3.97),('12374','2013-01-06','14:40:00',3.89),('12374','2013-01-06','14:45:00',3.79),('12374','2013-01-06','14:50:00',3.63),('12374','2013-01-06','14:55:00',3.48),('12374','2013-01-06','15:00:00',3.29),('12374','2013-01-06','15:05:00',3.15),('12374','2013-01-06','15:10:00',3.02),('12374','2013-01-06','15:15:00',2.85),('12374','2013-01-06','15:20:00',2.7),('12374','2013-01-06','15:25:00',2.57),('12374','2013-01-06','15:30:00',2.42),('12374','2013-01-06','15:35:00',2.25),('12374','2013-01-06','15:40:00',2.06),('12374','2013-01-06','15:45:00',1.88),('12374','2013-01-06','15:50:00',1.76),('12374','2013-01-06','15:55:00',1.63),('12374','2013-01-06','16:00:00',1.44),('12374','2013-01-06','16:05:00',1.07),('12374','2013-01-05','08:30:00',1.06),('12374','2013-01-05','08:35:00',1.34),('12374','2013-01-05','08:40:00',1.36),('12374','2013-01-05','08:45:00',1.05),('12374','2013-01-05','08:50:00',1.73),('12374','2013-01-05','08:55:00',1.96),('12374','2013-01-05','09:00:00',2.08),('12374','2013-01-05','09:25:00',1.06),('12374','2013-01-05','09:30:00',1.4),('12374','2013-01-05','09:35:00',1.73),('12374','2013-01-05','09:40:00',1.95),('12374','2013-01-05','09:45:00',2.04),('12374','2013-01-05','09:50:00',2.15),('12374','2013-01-05','09:55:00',1.81),('12374','2013-01-05','10:00:00',1.8),('12374','2013-01-05','10:05:00',1.92),('12374','2013-01-05','10:10:00',2.37),('12374','2013-01-05','10:15:00',3.44),('12374','2013-01-05','10:20:00',3.98),('12374','2013-01-05','10:25:00',3.9),('12374','2013-01-05','10:30:00',3.55),('12374','2013-01-05','10:35:00',3.7),('12374','2013-01-05','10:40:00',4.05),('12374','2013-01-05','10:45:00',3.68),('12374','2013-01-05','10:50:00',3.55),('12374','2013-01-05','10:55:00',3.64),('12374','2013-01-05','11:00:00',4.56),('12374','2013-01-05','11:05:00',5.35),('12374','2013-01-05','11:10:00',5.89),('12374','2013-01-05','11:15:00',5.43),('12374','2013-01-05','11:20:00',5.73),('12374','2013-01-05','11:25:00',5.7),('12374','2013-01-05','11:30:00',5.7),('12374','2013-01-05','11:35:00',5.98),('12374','2013-01-05','11:40:00',5.99),('12374','2013-01-05','11:45:00',6.01),('12374','2013-01-05','11:50:00',5.57),('12374','2013-01-05','11:55:00',5.55),('12374','2013-01-05','12:00:00',4.57),('12374','2013-01-05','12:05:00',4.51),('12374','2013-01-05','12:10:00',4.51),('12374','2013-01-05','12:15:00',4.43),('12374','2013-01-05','12:20:00',4.3),('12374','2013-01-05','12:25:00',3.64),('12374','2013-01-05','12:30:00',3.52),('12374','2013-01-05','12:35:00',4.25),('12374','2013-01-05','12:40:00',3.39),('12374','2013-01-05','12:45:00',4.05),('12374','2013-01-05','12:50:00',4.86),('12374','2013-01-05','12:55:00',6.24),('12374','2013-01-05','13:00:00',5.66),('12374','2013-01-05','13:05:00',5.95),('12374','2013-01-05','13:10:00',4.12),('12374','2013-01-05','13:15:00',5.01),('12374','2013-01-05','13:20:00',5.57),('12374','2013-01-05','13:25:00',5.48),('12374','2013-01-05','13:30:00',4.8),('12374','2013-01-05','13:35:00',5.23),('12374','2013-01-05','13:40:00',4.83),('12374','2013-01-05','13:45:00',4.84),('12374','2013-01-05','13:50:00',4.76),('12374','2013-01-05','13:55:00',4.25),('12374','2013-01-05','14:00:00',4.5),('12374','2013-01-05','14:05:00',4.46),('12374','2013-01-05','14:10:00',3.95),('12374','2013-01-05','14:15:00',3.92),('12374','2013-01-05','14:20:00',4.34),('12374','2013-01-05','14:25:00',3.42),('12374','2013-01-05','14:30:00',3.67),('12374','2013-01-05','14:35:00',3.44),('12374','2013-01-05','14:40:00',2.61),('12374','2013-01-05','14:45:00',2.89),('12374','2013-01-05','14:50:00',3.38),('12374','2013-01-05','14:55:00',3.5),('12374','2013-01-05','15:00:00',3.56),('12374','2013-01-05','15:05:00',2.43),('12374','2013-01-05','15:10:00',3.39),('12374','2013-01-05','15:15:00',2.99),('12374','2013-01-05','15:20:00',2.34),('12374','2013-01-05','15:25:00',1.83),('12374','2013-01-05','15:30:00',2.3),('12374','2013-01-05','15:35:00',2.14),('12374','2013-01-05','15:40:00',1.9),('12374','2013-01-05','15:45:00',1.68),('12374','2013-01-05','15:50:00',1.56),('12374','2013-01-05','15:55:00',1.39),('12374','2013-01-05','16:00:00',1.24),('12374','2013-01-05','16:05:00',1.11),('12374','2013-01-04','08:25:00',1.02),('12374','2013-01-04','08:30:00',1.07),('12374','2013-01-04','08:35:00',1.31),('12374','2013-01-04','08:40:00',1.33),('12374','2013-01-04','08:45:00',1.51),('12374','2013-01-04','08:50:00',1.06),('12374','2013-01-04','08:55:00',1.4),('12374','2013-01-04','09:00:00',2.13),('12374','2013-01-04','09:05:00',2.74),('12374','2013-01-04','09:10:00',1.88),('12374','2013-01-04','09:15:00',2.78),('12374','2013-01-04','09:20:00',2.79),('12374','2013-01-04','09:25:00',3.15),('12374','2013-01-04','09:30:00',3.67),('12374','2013-01-04','09:35:00',3.96),('12374','2013-01-04','09:40:00',4.25),('12374','2013-01-04','09:45:00',4.64),('12374','2013-01-04','09:50:00',4.96),('12374','2013-01-04','09:55:00',4.93),('12374','2013-01-04','10:00:00',4.36),('12374','2013-01-04','10:05:00',2.25),('12374','2013-01-04','10:10:00',1.42),('12374','2013-01-04','10:15:00',1.53),('12374','2013-01-04','10:20:00',1.67),('12374','2013-01-04','10:25:00',3.26),('12374','2013-01-04','10:30:00',5.28),('12374','2013-01-04','10:35:00',5.46),('12374','2013-01-04','10:40:00',5.86),('12374','2013-01-04','10:45:00',6.11),('12374','2013-01-04','10:50:00',6.37),('12374','2013-01-04','10:55:00',5.43),('12374','2013-01-04','11:00:00',5.18),('12374','2013-01-04','11:05:00',5.55),('12374','2013-01-04','11:10:00',4.06),('12374','2013-01-04','11:15:00',2.16),('12374','2013-01-04','11:20:00',1.81),('12374','2013-01-04','11:25:00',1.99),('12374','2013-01-04','11:30:00',2.45),('12374','2013-01-04','11:35:00',1.81),('12374','2013-01-04','11:40:00',1.27),('12374','2013-01-04','11:45:00',3.43),('12374','2013-01-04','11:50:00',5.51),('12374','2013-01-04','11:55:00',6.99),('12374','2013-01-04','12:00:00',5.45),('12374','2013-01-04','12:05:00',3.78),('12374','2013-01-04','12:10:00',1.88),('12374','2013-01-04','12:15:00',2.1),('12374','2013-01-04','12:20:00',2.13),('12374','2013-01-04','12:25:00',6.57),('12374','2013-01-04','12:30:00',6.28),('12374','2013-01-04','12:35:00',6.19),('12374','2013-01-04','12:40:00',6.18),('12374','2013-01-04','12:45:00',6.2),('12374','2013-01-04','12:50:00',6.13),('12374','2013-01-04','12:55:00',5.93),('12374','2013-01-04','13:00:00',5.3),('12374','2013-01-04','13:05:00',4.7),('12374','2013-01-04','13:10:00',5.58),('12374','2013-01-04','13:15:00',5.46),('12374','2013-01-04','13:20:00',5.42),('12374','2013-01-04','13:25:00',5.35),('12374','2013-01-04','13:30:00',5.32),('12374','2013-01-04','13:35:00',4.98),('12374','2013-01-04','13:40:00',4.69),('12374','2013-01-04','13:45:00',4.67),('12374','2013-01-04','13:50:00',5.01),('12374','2013-01-04','13:55:00',4.49),('12374','2013-01-04','14:00:00',4.49),('12374','2013-01-04','14:05:00',4.33),('12374','2013-01-04','14:10:00',4.29),('12374','2013-01-04','14:15:00',4.32),('12374','2013-01-04','14:20:00',4.16),('12374','2013-01-04','14:25:00',3.93),('12374','2013-01-04','14:30:00',3.81),('12374','2013-01-04','14:35:00',3.87),('12374','2013-01-04','14:40:00',3.74),('12374','2013-01-04','14:45:00',3.56),('12374','2013-01-04','14:50:00',3.49),('12374','2013-01-04','14:55:00',3.4),('12374','2013-01-04','15:00:00',3.41),('12374','2013-01-04','15:05:00',3.36),('12374','2013-01-04','15:10:00',3.1),('12374','2013-01-04','15:15:00',2.87),('12374','2013-01-04','15:20:00',2.79),('12374','2013-01-04','15:25:00',2.71),('12374','2013-01-04','15:30:00',2.39),('12374','2013-01-04','15:35:00',1.52),('12374','2013-01-04','15:40:00',2),('12374','2013-01-04','15:45:00',1.74),('12374','2013-01-04','15:50:00',2.04),('12374','2013-01-04','15:55:00',1.69),('12374','2013-01-04','16:00:00',1.56),('12374','2013-01-04','16:05:00',1.39),('12374','2013-01-04','16:10:00',1.2),('12374','2013-01-03','08:20:00',1.14),('12374','2013-01-03','09:00:00',1.17),('12374','2013-01-03','09:05:00',1.36),('12374','2013-01-03','09:10:00',2.33),('12374','2013-01-03','09:15:00',2.89),('12374','2013-01-03','09:20:00',2.09),('12374','2013-01-03','09:25:00',1.9),('12374','2013-01-03','09:30:00',2.17),('12374','2013-01-03','09:35:00',2.32),('12374','2013-01-03','09:40:00',2.73),('12374','2013-01-03','09:45:00',2.89),('12374','2013-01-03','09:50:00',2.64),('12374','2013-01-03','09:55:00',2.98),('12374','2013-01-03','10:00:00',2.91),('12374','2013-01-03','10:05:00',2.83),('12374','2013-01-03','10:10:00',2.7),('12374','2013-01-03','10:15:00',2.73),('12374','2013-01-03','10:20:00',2.77),('12374','2013-01-03','10:25:00',2.6),('12374','2013-01-03','10:30:00',2.68),('12374','2013-01-03','10:35:00',2.88),('12374','2013-01-03','10:40:00',2.95),('12374','2013-01-03','10:45:00',2.88),('12374','2013-01-03','10:50:00',2.87),('12374','2013-01-03','10:55:00',2.96),('12374','2013-01-03','11:00:00',3.09),('12374','2013-01-03','11:05:00',3.39),('12374','2013-01-03','11:10:00',3.57),('12374','2013-01-03','11:15:00',4.02),('12374','2013-01-03','11:20:00',4.03),('12374','2013-01-03','11:25:00',4.08),('12374','2013-01-03','11:30:00',4.08),('12374','2013-01-03','11:35:00',4.68),('12374','2013-01-03','11:40:00',4.28),('12374','2013-01-03','11:45:00',6.15),('12374','2013-01-03','11:50:00',6.47),('12374','2013-01-03','11:55:00',6.23),('12374','2013-01-03','12:00:00',6.14),('12374','2013-01-03','12:05:00',6.1),('12374','2013-01-03','12:10:00',6.11),('12374','2013-01-03','12:15:00',6.08),('12374','2013-01-03','12:20:00',6.09),('12374','2013-01-03','12:25:00',6.03),('12374','2013-01-03','12:30:00',6.03),('12374','2013-01-03','12:35:00',6.01),('12374','2013-01-03','12:40:00',5.95),('12374','2013-01-03','12:45:00',5.93),('12374','2013-01-03','12:50:00',5.83),('12374','2013-01-03','12:55:00',5.8),('12374','2013-01-03','13:00:00',5.7),('12374','2013-01-03','13:05:00',5.64),('12374','2013-01-03','13:10:00',5.6),('12374','2013-01-03','13:15:00',5.54),('12374','2013-01-03','13:20:00',5.49),('12374','2013-01-03','13:25:00',5.4),('12374','2013-01-03','13:30:00',5.32),('12374','2013-01-03','13:35:00',5.2),('12374','2013-01-03','13:40:00',5.11),('12374','2013-01-03','13:45:00',5.04),('12374','2013-01-03','13:50:00',4.97),('12374','2013-01-03','13:55:00',4.84),('12374','2013-01-03','14:00:00',4.77),('12374','2013-01-03','14:05:00',4.73),('12374','2013-01-03','14:10:00',4.61),('12374','2013-01-03','14:15:00',4.46),('12374','2013-01-03','14:20:00',4.39),('12374','2013-01-03','14:25:00',4.27),('12374','2013-01-03','14:30:00',4.13),('12374','2013-01-03','14:35:00',4),('12374','2013-01-03','14:40:00',3.9),('12374','2013-01-03','14:45:00',3.82),('12374','2013-01-03','14:50:00',3.69),('12374','2013-01-03','14:55:00',3.53),('12374','2013-01-03','15:00:00',3.4),('12374','2013-01-03','15:05:00',3.26),('12374','2013-01-03','15:10:00',3.09),('12374','2013-01-03','15:15:00',2.89),('12374','2013-01-03','15:20:00',2.49),('12374','2013-01-03','15:25:00',2.38),('12374','2013-01-03','15:30:00',2.37),('12374','2013-01-03','15:35:00',2.28),('12374','2013-01-03','15:40:00',2),('12374','2013-01-03','15:45:00',1.81),('12374','2013-01-03','15:50:00',1.54),('12374','2013-01-03','15:55:00',1.34),('12374','2013-01-03','16:00:00',1.18),('12374','2013-01-03','16:05:00',1.05),('12374','2013-01-02','10:05:00',1.03),('12374','2013-01-02','10:10:00',2.5),('12374','2013-01-02','10:15:00',2.73),('12374','2013-01-02','10:20:00',2.31),('12374','2013-01-02','10:25:00',2.05),('12374','2013-01-02','10:30:00',2.17),('12374','2013-01-02','10:35:00',3.44),('12374','2013-01-02','10:40:00',4.11),('12374','2013-01-02','10:45:00',3.07),('12374','2013-01-02','10:50:00',2.42),('12374','2013-01-02','10:55:00',2.02),('12374','2013-01-02','11:00:00',1.91),('12374','2013-01-02','11:05:00',2.12),('12374','2013-01-02','11:10:00',2.86),('12374','2013-01-02','11:15:00',3.2),('12374','2013-01-02','11:20:00',3.38),('12374','2013-01-02','11:25:00',3.45),('12374','2013-01-02','11:30:00',4.09),('12374','2013-01-02','11:35:00',4.19),('12374','2013-01-02','11:40:00',6.04),('12374','2013-01-02','11:45:00',5.85),('12374','2013-01-02','11:50:00',4.5),('12374','2013-01-02','11:55:00',2.23),('12374','2013-01-02','12:00:00',1.81),('12374','2013-01-02','12:05:00',1.9),('12374','2013-01-02','12:10:00',2.25),('12374','2013-01-02','12:15:00',2.2),('12374','2013-01-02','12:20:00',2.09),('12374','2013-01-02','12:25:00',1.99),('12374','2013-01-02','12:30:00',2.41),('12374','2013-01-02','12:35:00',2.79),('12374','2013-01-02','12:40:00',2.62),('12374','2013-01-02','12:45:00',2.34),('12374','2013-01-02','12:50:00',2.14),('12374','2013-01-02','12:55:00',2.48),('12374','2013-01-02','13:00:00',2.57),('12374','2013-01-02','13:05:00',2.86),('12374','2013-01-02','13:10:00',3.1),('12374','2013-01-02','13:15:00',2.72),('12374','2013-01-02','13:20:00',2.76),('12374','2013-01-02','13:25:00',2.81),('12374','2013-01-02','13:30:00',3.68),('12374','2013-01-02','13:35:00',3.99),('12374','2013-01-02','13:40:00',3.39),('12374','2013-01-02','13:45:00',3.15),('12374','2013-01-02','13:50:00',2.8),('12374','2013-01-02','13:55:00',3.63),('12374','2013-01-02','14:00:00',2.74),('12374','2013-01-02','14:05:00',2.29),('12374','2013-01-02','14:10:00',2.25),('12374','2013-01-02','14:15:00',2.19),('12374','2013-01-02','14:20:00',2.04),('12374','2013-01-02','14:25:00',1.51),('12374','2013-01-02','14:30:00',1.11),('12374','2013-01-01','08:15:00',1),('12374','2013-01-01','08:20:00',1.34),('12374','2013-01-01','08:25:00',1.58),('12374','2013-01-01','08:30:00',1.81),('12374','2013-01-01','08:35:00',2.11),('12374','2013-01-01','08:40:00',1.44),('12374','2013-01-01','08:45:00',1.29),('12374','2013-01-01','08:50:00',1.06),('12374','2013-01-01','08:55:00',1.26),('12374','2013-01-01','09:00:00',1.43),('12374','2013-01-01','09:05:00',1.25),('12374','2013-01-01','09:10:00',1.9),('12374','2013-01-01','09:15:00',3.91),('12374','2013-01-01','09:20:00',3.6),('12374','2013-01-01','09:25:00',3.21),('12374','2013-01-01','09:30:00',2.32),('12374','2013-01-01','09:35:00',1.72),('12374','2013-01-01','09:40:00',1.7),('12374','2013-01-01','09:45:00',1.47),('12374','2013-01-01','09:50:00',2.41),('12374','2013-01-01','09:55:00',4.29),('12374','2013-01-01','10:00:00',1.97),('12374','2013-01-01','10:05:00',1.7),('12374','2013-01-01','10:10:00',1.64),('12374','2013-01-01','10:15:00',1.92),('12374','2013-01-01','10:20:00',1.76),('12374','2013-01-01','10:25:00',2.13),('12374','2013-01-01','10:30:00',2.42),('12374','2013-01-01','10:35:00',2.25),('12374','2013-01-01','10:40:00',2.12),('12374','2013-01-01','10:45:00',2.29),('12374','2013-01-01','10:50:00',2.82),('12374','2013-01-01','10:55:00',2.91),('12374','2013-01-01','11:00:00',2.25),('12374','2013-01-01','11:05:00',2.62),('12374','2013-01-01','11:10:00',2.93),('12374','2013-01-01','11:15:00',2.21),('12374','2013-01-01','11:20:00',1.74),('12374','2013-01-01','11:25:00',1.26),('12374','2013-01-01','11:30:00',1.14),('12374','2013-01-01','11:35:00',1.79),('12374','2013-01-01','11:40:00',1.88),('12374','2013-01-01','11:45:00',1.6),('12374','2013-01-01','11:50:00',1.17),('12374','2013-01-01','12:50:00',1.08),('12374','2013-01-01','12:55:00',1.9),('12374','2013-01-01','13:00:00',1.89),('12374','2013-01-01','13:05:00',2.03),('12374','2013-01-01','13:10:00',2.16),('12374','2013-01-01','13:15:00',1.95),('12374','2013-01-01','13:20:00',2.12),('12374','2013-01-01','13:25:00',2.58),('12374','2013-01-01','13:30:00',2.61),('12374','2013-01-01','13:35:00',3.7),('12374','2013-01-01','13:40:00',3.34),('12374','2013-01-01','13:45:00',2.16),('12374','2013-01-01','13:50:00',4.93),('12374','2013-01-01','13:55:00',3.48),('12374','2013-01-01','14:00:00',4.45),('12374','2013-01-01','14:05:00',4.38),('12374','2013-01-01','14:10:00',4.6),('12374','2013-01-01','14:15:00',4.42),('12374','2013-01-01','14:20:00',4.23),('12374','2013-01-01','14:25:00',4.08),('12374','2013-01-01','14:30:00',3.95),('12374','2013-01-01','14:35:00',3.83),('12374','2013-01-01','14:40:00',3.78),('12374','2013-01-01','14:45:00',3.65),('12374','2013-01-01','14:50:00',3.43),('12374','2013-01-01','14:55:00',3.1),('12374','2013-01-01','15:00:00',3.18),('12374','2013-01-01','15:05:00',3.06),('12374','2013-01-01','15:10:00',2.93),('12374','2013-01-01','15:15:00',2.83),('12374','2013-01-01','15:20:00',2.62),('12374','2013-01-01','15:25:00',2.36),('12374','2013-01-01','15:30:00',1.08),('12374','2012-12-31','08:35:00',2.13),('12374','2012-12-31','08:40:00',2.43),('12374','2012-12-31','08:45:00',2.49),('12374','2012-12-31','08:50:00',2.59),('12374','2012-12-31','08:55:00',2.83),('12374','2012-12-31','09:00:00',3.2),('12374','2012-12-31','09:05:00',3.31),('12374','2012-12-31','09:10:00',3.51),('12374','2012-12-31','09:15:00',3.45),('12374','2012-12-31','09:20:00',3.75),('12374','2012-12-31','09:25:00',4.04),('12374','2012-12-31','09:30:00',4.1),('12374','2012-12-31','09:35:00',4.03),('12374','2012-12-31','09:40:00',3.8),('12374','2012-12-31','09:45:00',4.17),('12374','2012-12-31','09:50:00',4.28),('12374','2012-12-31','09:55:00',4.22),('12374','2012-12-31','10:00:00',4.02),('12374','2012-12-31','10:05:00',4.48),('12374','2012-12-31','10:10:00',4.79),('12374','2012-12-31','10:15:00',5.13),('12374','2012-12-31','10:20:00',5.37),('12374','2012-12-31','10:25:00',5.55),('12374','2012-12-31','10:30:00',5.66),('12374','2012-12-31','10:35:00',5.72),('12374','2012-12-31','10:40:00',5.7),('12374','2012-12-31','10:45:00',5.83),('12374','2012-12-31','10:50:00',5.9),('12374','2012-12-31','10:55:00',5.97),('12374','2012-12-31','11:00:00',6.04),('12374','2012-12-31','11:05:00',6.1),('12374','2012-12-31','11:10:00',6.15),('12374','2012-12-31','11:15:00',6.17),('12374','2012-12-31','11:20:00',6.24),('12374','2012-12-31','11:25:00',6.29),('12374','2012-12-31','11:30:00',6.32),('12374','2012-12-31','11:35:00',6.32),('12374','2012-12-31','11:40:00',6.34),('12374','2012-12-31','11:45:00',6.36),('12374','2012-12-31','11:50:00',6.37),('12374','2012-12-31','11:55:00',6.33),('12374','2012-12-31','12:00:00',6.4),('12374','2012-12-31','12:05:00',6.4),('12374','2012-12-31','12:10:00',6.38),('12374','2012-12-31','12:15:00',6.34),('12374','2012-12-31','12:20:00',6.35),('12374','2012-12-31','12:25:00',6.31),('12374','2012-12-31','12:30:00',6.31),('12374','2012-12-31','12:35:00',6.27),('12374','2012-12-31','12:40:00',6.21),('12374','2012-12-31','12:45:00',6.17),('12374','2012-12-31','12:50:00',6.11),('12374','2012-12-31','12:55:00',6.07),('12374','2012-12-31','13:00:00',6.01),('12374','2012-12-31','13:05:00',5.94),('12374','2012-12-31','13:10:00',5.88),('12374','2012-12-31','13:15:00',5.81),('12374','2012-12-31','13:20:00',5.7),('12374','2012-12-31','13:25:00',5.64),('12374','2012-12-31','13:30:00',5.58),('12374','2012-12-31','13:35:00',5.5),('12374','2012-12-31','13:40:00',5.4),('12374','2012-12-31','13:45:00',5.33),('12374','2012-12-31','13:50:00',5.23),('12374','2012-12-31','13:55:00',5.14),('12374','2012-12-31','14:00:00',5.03),('12374','2012-12-31','14:05:00',4.93),('12374','2012-12-31','14:10:00',4.74),('12374','2012-12-31','14:15:00',4.71),('12374','2012-12-31','14:20:00',4.62),('12374','2012-12-31','14:25:00',4.51),('12374','2012-12-31','14:30:00',4.38),('12374','2012-12-31','14:35:00',4.25),('12374','2012-12-31','14:40:00',4.14),('12374','2012-12-31','14:45:00',4.03),('12374','2012-12-31','14:50:00',3.91),('12374','2012-12-31','14:55:00',3.79),('12374','2012-12-31','15:00:00',3.66),('12374','2012-12-31','15:05:00',3.52),('12374','2012-12-31','15:10:00',3.35),('12374','2012-12-31','15:15:00',3.2),('12374','2012-12-31','15:20:00',3.06),('12374','2012-12-31','15:25:00',2.9),('12374','2012-12-31','15:30:00',2.77),('12374','2012-12-31','15:35:00',2.61),('12374','2012-12-31','15:40:00',2.41),('12374','2012-12-31','15:45:00',2.21),('12374','2012-12-31','15:50:00',1.95),('12374','2012-12-31','15:55:00',1.78),('12374','2012-12-31','16:00:00',1.58),('12374','2012-12-31','16:05:00',1.43),('12374','2012-12-31','16:10:00',1.26),('12374','2012-12-31','16:15:00',1.09),('12374','2012-12-30','08:20:00',1.25),('12374','2012-12-30','08:25:00',1.47),('12374','2012-12-30','08:30:00',1.72),('12374','2012-12-30','08:35:00',2.13),('12374','2012-12-30','08:40:00',2.12),('12374','2012-12-30','08:45:00',2.41),('12374','2012-12-30','08:50:00',2.62),('12374','2012-12-30','08:55:00',2.57),('12374','2012-12-30','09:00:00',2.84),('12374','2012-12-30','09:05:00',3.17),('12374','2012-12-30','09:10:00',3.32),('12374','2012-12-30','09:15:00',3.54),('12374','2012-12-30','09:20:00',3.73),('12374','2012-12-30','09:25:00',3.87),('12374','2012-12-30','09:30:00',4.02),('12374','2012-12-30','09:35:00',4.19),('12374','2012-12-30','09:40:00',4.39),('12374','2012-12-30','09:45:00',4.55),('12374','2012-12-30','09:50:00',4.68),('12374','2012-12-30','09:55:00',4.79),('12374','2012-12-30','10:00:00',4.95),('12374','2012-12-30','10:05:00',5.08),('12374','2012-12-30','10:10:00',5.23),('12374','2012-12-30','10:15:00',5.34),('12374','2012-12-30','10:20:00',5.44),('12374','2012-12-30','10:25:00',5.54),('12374','2012-12-30','10:30:00',5.62),('12374','2012-12-30','10:35:00',5.69),('12374','2012-12-30','10:40:00',5.76),('12374','2012-12-30','10:45:00',5.81),('12374','2012-12-30','10:50:00',5.87),('12374','2012-12-30','10:55:00',5.94),('12374','2012-12-30','11:00:00',6.03),('12374','2012-12-30','11:05:00',6.08),('12374','2012-12-30','11:10:00',6.14),('12374','2012-12-30','11:15:00',6.16),('12374','2012-12-30','11:20:00',6.2),('12374','2012-12-30','11:25:00',6.23),('12374','2012-12-30','11:30:00',6.24),('12374','2012-12-30','11:35:00',6.22),('12374','2012-12-30','11:40:00',6.22),('12374','2012-12-30','11:45:00',6.2),('12374','2012-12-30','11:50:00',6.17),('12374','2012-12-30','11:55:00',6.23),('12374','2012-12-30','12:00:00',6.28),('12374','2012-12-30','12:05:00',6.29),('12374','2012-12-30','12:10:00',6.31),('12374','2012-12-30','12:15:00',6.28),('12374','2012-12-30','12:20:00',6.25),('12374','2012-12-30','12:25:00',6.33),('12374','2012-12-30','12:30:00',6.35),('12374','2012-12-30','12:35:00',6.31),('12374','2012-12-30','12:40:00',6.26),('12374','2012-12-30','12:45:00',6.2),('12374','2012-12-30','12:50:00',6.14),('12374','2012-12-30','12:55:00',6.08),('12374','2012-12-30','13:00:00',5.91),('12374','2012-12-30','13:05:00',5.92),('12374','2012-12-30','13:10:00',5.85),('12374','2012-12-30','13:15:00',5.77),('12374','2012-12-30','13:20:00',5.7),('12374','2012-12-30','13:25:00',5.62),('12374','2012-12-30','13:30:00',5.54),('12374','2012-12-30','13:35:00',5.45),('12374','2012-12-30','13:40:00',5.37),('12374','2012-12-30','13:45:00',5.27),('12374','2012-12-30','13:50:00',5.19),('12374','2012-12-30','13:55:00',5.08),('12374','2012-12-30','14:00:00',4.96),('12374','2012-12-30','14:05:00',4.87),('12374','2012-12-30','14:10:00',4.77),('12374','2012-12-30','14:15:00',4.65),('12374','2012-12-30','14:20:00',4.53),('12374','2012-12-30','14:25:00',4.42),('12374','2012-12-30','14:30:00',4.32),('12374','2012-12-30','14:35:00',4.2),('12374','2012-12-30','14:40:00',4.07),('12374','2012-12-30','14:45:00',3.93),('12374','2012-12-30','14:50:00',3.84),('12374','2012-12-30','14:55:00',3.72),('12374','2012-12-30','15:00:00',3.6),('12374','2012-12-30','15:05:00',3.46),('12374','2012-12-30','15:10:00',3.33),('12374','2012-12-30','15:15:00',3.18),('12374','2012-12-30','15:20:00',3.04),('12374','2012-12-30','15:25:00',2.86),('12374','2012-12-30','15:30:00',2.71),('12374','2012-12-30','15:35:00',2.53),('12374','2012-12-30','15:40:00',2.32),('12374','2012-12-30','15:45:00',2.17),('12374','2012-12-30','15:50:00',2),('12374','2012-12-30','15:55:00',1.81),('12374','2012-12-30','16:00:00',1.59),('12374','2012-12-30','16:05:00',1.4),('12374','2012-12-30','16:10:00',1.22),('12374','2012-12-29','08:20:00',1.23),('12374','2012-12-29','08:25:00',1.46),('12374','2012-12-29','08:30:00',1.67),('12374','2012-12-29','08:35:00',2.05),('12374','2012-12-29','08:40:00',2.13),('12374','2012-12-29','08:45:00',2.4),('12374','2012-12-29','08:50:00',2.59),('12374','2012-12-29','08:55:00',2.52),('12374','2012-12-29','09:00:00',2.64),('12374','2012-12-29','09:05:00',3.1),('12374','2012-12-29','09:10:00',3.16),('12374','2012-12-29','09:15:00',3.39),('12374','2012-12-29','09:20:00',3.67),('12374','2012-12-29','09:25:00',3.86),('12374','2012-12-29','09:30:00',4),('12374','2012-12-29','09:35:00',4.17),('12374','2012-12-29','09:40:00',4.33),('12374','2012-12-29','09:45:00',4.51),('12374','2012-12-29','09:50:00',4.62),('12374','2012-12-29','09:55:00',4.74),('12374','2012-12-29','10:00:00',4.85),('12374','2012-12-29','10:05:00',4.97),('12374','2012-12-29','10:10:00',5.09),('12374','2012-12-29','10:15:00',5.23),('12374','2012-12-29','10:20:00',5.32),('12374','2012-12-29','10:25:00',5.4),('12374','2012-12-29','10:30:00',5.47),('12374','2012-12-29','10:35:00',5.56),('12374','2012-12-29','10:40:00',5.64),('12374','2012-12-29','10:45:00',5.71),('12374','2012-12-29','10:50:00',5.79),('12374','2012-12-29','10:55:00',5.86),('12374','2012-12-29','11:00:00',5.92),('12374','2012-12-29','11:05:00',6),('12374','2012-12-29','11:10:00',6.06),('12374','2012-12-29','11:15:00',6.14),('12374','2012-12-29','11:20:00',6.21),('12374','2012-12-29','11:25:00',6.24),('12374','2012-12-29','11:30:00',6.26),('12374','2012-12-29','11:35:00',6.29),('12374','2012-12-29','11:40:00',6.29),('12374','2012-12-29','11:45:00',6.25),('12374','2012-12-29','11:50:00',6.22),('12374','2012-12-29','11:55:00',6.23),('12374','2012-12-29','12:00:00',6.23),('12374','2012-12-29','12:05:00',6.24),('12374','2012-12-29','12:10:00',6.27),('12374','2012-12-29','12:15:00',6.29),('12374','2012-12-29','12:20:00',6.25),('12374','2012-12-29','12:25:00',6.17),('12374','2012-12-29','12:30:00',6.07),('12374','2012-12-29','12:35:00',6.13),('12374','2012-12-29','12:40:00',6.08),('12374','2012-12-29','12:45:00',6.06),('12374','2012-12-29','12:50:00',6.02),('12374','2012-12-29','12:55:00',5.97),('12374','2012-12-29','13:00:00',5.94),('12374','2012-12-29','13:05:00',5.86),('12374','2012-12-29','13:10:00',5.81),('12374','2012-12-29','13:15:00',5.75),('12374','2012-12-29','13:20:00',5.68),('12374','2012-12-29','13:25:00',5.63),('12374','2012-12-29','13:30:00',5.55),('12374','2012-12-29','13:35:00',5.47),('12374','2012-12-29','13:40:00',5.41),('12374','2012-12-29','13:45:00',5.32),('12374','2012-12-29','13:50:00',5.22),('12374','2012-12-29','13:55:00',5.16),('12374','2012-12-29','14:00:00',5.08),('12374','2012-12-29','14:05:00',4.99),('12374','2012-12-29','14:10:00',4.88),('12374','2012-12-29','14:15:00',4.76),('12374','2012-12-29','14:20:00',4.66),('12374','2012-12-29','14:25:00',4.55),('12374','2012-12-29','14:30:00',4.43),('12374','2012-12-29','14:35:00',4.31),('12374','2012-12-29','14:40:00',4.18),('12374','2012-12-29','14:45:00',4.03),('12374','2012-12-29','14:50:00',3.94),('12374','2012-12-29','14:55:00',3.82),('12374','2012-12-29','15:00:00',3.69),('12374','2012-12-29','15:05:00',3.55),('12374','2012-12-29','15:10:00',3.41),('12374','2012-12-29','15:15:00',3.28),('12374','2012-12-29','15:20:00',3.14),('12374','2012-12-29','15:25:00',2.98),('12374','2012-12-29','15:30:00',2.81),('12374','2012-12-29','15:35:00',2.63),('12374','2012-12-29','15:40:00',2.4),('12374','2012-12-29','15:45:00',2.25),('12374','2012-12-29','15:50:00',2.06),('12374','2012-12-29','15:55:00',1.88),('12374','2012-12-29','16:00:00',1.67),('12374','2012-12-29','16:05:00',1.5),('12374','2012-12-29','16:10:00',1.29),('12374','2012-12-29','16:15:00',1.09),('12374','2012-12-28','08:30:00',1.24),('12374','2012-12-28','08:35:00',1.5),('12374','2012-12-28','08:40:00',1.61),('12374','2012-12-28','08:45:00',1.93),('12374','2012-12-28','08:50:00',2.19),('12374','2012-12-28','08:55:00',2.25),('12374','2012-12-28','09:00:00',2.57),('12374','2012-12-28','09:05:00',2.62),('12374','2012-12-28','09:10:00',2.56),('12374','2012-12-28','09:15:00',2.83),('12374','2012-12-28','09:20:00',2.99),('12374','2012-12-28','09:25:00',3.33),('12374','2012-12-28','09:30:00',3.58),('12374','2012-12-28','09:35:00',3.88),('12374','2012-12-28','09:40:00',4.03),('12374','2012-12-28','09:45:00',4.15),('12374','2012-12-28','09:50:00',4.28),('12374','2012-12-28','09:55:00',4.45),('12374','2012-12-28','10:00:00',4.61),('12374','2012-12-28','10:05:00',4.7),('12374','2012-12-28','10:10:00',4.88),('12374','2012-12-28','10:15:00',5.02),('12374','2012-12-28','10:20:00',5.03),('12374','2012-12-28','10:25:00',5.14),('12374','2012-12-28','10:30:00',5.25),('12374','2012-12-28','10:35:00',5.38),('12374','2012-12-28','10:40:00',5.46),('12374','2012-12-28','10:45:00',5.53),('12374','2012-12-28','10:50:00',5.58),('12374','2012-12-28','10:55:00',5.63),('12374','2012-12-28','11:00:00',5.71),('12374','2012-12-28','11:05:00',5.8),('12374','2012-12-28','11:10:00',5.79),('12374','2012-12-28','11:15:00',5.88),('12374','2012-12-28','11:20:00',5.9),('12374','2012-12-28','11:25:00',5.97),('12374','2012-12-28','11:30:00',5.98),('12374','2012-12-28','11:35:00',5.95),('12374','2012-12-28','11:40:00',5.97),('12374','2012-12-28','11:45:00',5.97),('12374','2012-12-28','11:50:00',6.01),('12374','2012-12-28','11:55:00',6.07),('12374','2012-12-28','12:00:00',6.01),('12374','2012-12-28','12:05:00',6.12),('12374','2012-12-28','12:10:00',6.14),('12374','2012-12-28','12:15:00',6.16),('12374','2012-12-28','12:20:00',6.13),('12374','2012-12-28','12:25:00',6.05),('12374','2012-12-28','12:30:00',6),('12374','2012-12-28','12:35:00',5.94),('12374','2012-12-28','12:40:00',5.95),('12374','2012-12-28','12:45:00',5.95),('12374','2012-12-28','12:50:00',5.88),('12374','2012-12-28','12:55:00',5.87),('12374','2012-12-28','13:00:00',5.81),('12374','2012-12-28','13:05:00',5.72),('12374','2012-12-28','13:10:00',5.64),('12374','2012-12-28','13:15:00',5.53),('12374','2012-12-28','13:20:00',5.53),('12374','2012-12-28','13:25:00',5.44),('12374','2012-12-28','13:30:00',5.3),('12374','2012-12-28','13:35:00',5.22),('12374','2012-12-28','13:40:00',5.08),('12374','2012-12-28','13:45:00',5.01),('12374','2012-12-28','13:50:00',4.94),('12374','2012-12-28','13:55:00',4.85),('12374','2012-12-28','14:00:00',4.76),('12374','2012-12-28','14:05:00',4.64),('12374','2012-12-28','14:10:00',4.51),('12374','2012-12-28','14:15:00',4.4),('12374','2012-12-28','14:20:00',4.26),('12374','2012-12-28','14:25:00',4.21),('12374','2012-12-28','14:30:00',4.09),('12374','2012-12-28','14:35:00',3.97),('12374','2012-12-28','14:40:00',3.85),('12374','2012-12-28','14:45:00',3.74),('12374','2012-12-28','14:50:00',3.62),('12374','2012-12-28','14:55:00',3.5),('12374','2012-12-28','15:00:00',3.35),('12374','2012-12-28','15:05:00',3.21),('12374','2012-12-28','15:10:00',3.09),('12374','2012-12-28','15:15:00',2.94),('12374','2012-12-28','15:20:00',2.78),('12374','2012-12-28','15:25:00',2.61),('12374','2012-12-28','15:30:00',2.45),('12374','2012-12-28','15:35:00',2.25),('12374','2012-12-28','15:40:00',2.02),('12374','2012-12-28','15:45:00',1.89),('12374','2012-12-28','15:50:00',1.68),('12374','2012-12-28','15:55:00',1.51),('12374','2012-12-28','16:00:00',1.35),('12374','2012-12-28','16:05:00',1.2),('12374','2012-12-28','16:10:00',1.02),('12374','2012-12-27','08:25:00',1.03),('12374','2012-12-27','08:30:00',1.26),('12374','2012-12-27','08:35:00',1.29),('12374','2012-12-27','09:00:00',1.93),('12374','2012-12-27','09:05:00',2),('12374','2012-12-27','09:10:00',1.79),('12374','2012-12-27','09:15:00',1.28),('12374','2012-12-27','09:20:00',1.08),('12374','2012-12-27','09:25:00',1.35),('12374','2012-12-27','09:30:00',3.59),('12374','2012-12-27','09:35:00',3.84),('12374','2012-12-27','09:40:00',3.92),('12374','2012-12-27','09:45:00',4.02),('12374','2012-12-27','09:50:00',4.1),('12374','2012-12-27','09:55:00',4.24),('12374','2012-12-27','10:00:00',4.33),('12374','2012-12-27','10:05:00',4.49),('12374','2012-12-27','10:10:00',4.64),('12374','2012-12-27','10:15:00',4.67),('12374','2012-12-27','10:20:00',4.8),('12374','2012-12-27','10:25:00',4.88),('12374','2012-12-27','10:30:00',4.89),('12374','2012-12-27','10:35:00',5.04),('12374','2012-12-27','10:40:00',5.17),('12374','2012-12-27','10:45:00',5.23),('12374','2012-12-27','10:50:00',5.28),('12374','2012-12-27','10:55:00',5.39),('12374','2012-12-27','11:00:00',5.4),('12374','2012-12-27','11:05:00',5.49),('12374','2012-12-27','11:10:00',5.6),('12374','2012-12-27','11:15:00',5.66),('12374','2012-12-27','11:20:00',5.68),('12374','2012-12-27','11:25:00',5.66),('12374','2012-12-27','11:30:00',5.68),('12374','2012-12-27','11:35:00',5.9),('12374','2012-12-27','11:40:00',5.46),('12374','2012-12-27','11:45:00',5.79),('12374','2012-12-27','11:50:00',6.03),('12374','2012-12-27','11:55:00',5.87),('12374','2012-12-27','12:00:00',5.79),('12374','2012-12-27','12:05:00',5.73),('12374','2012-12-27','12:10:00',5.85),('12374','2012-12-27','12:15:00',5.93),('12374','2012-12-27','12:20:00',5.91),('12374','2012-12-27','12:25:00',5.92),('12374','2012-12-27','12:30:00',5.89),('12374','2012-12-27','12:35:00',5.89),('12374','2012-12-27','12:40:00',5.91),('12374','2012-12-27','12:45:00',5.87),('12374','2012-12-27','12:50:00',5.89),('12374','2012-12-27','12:55:00',5.8),('12374','2012-12-27','13:00:00',5.69),('12374','2012-12-27','13:05:00',5.62),('12374','2012-12-27','13:10:00',5.58),('12374','2012-12-27','13:15:00',5.57),('12374','2012-12-27','13:20:00',5.48),('12374','2012-12-27','13:25:00',5.42),('12374','2012-12-27','13:30:00',4.58),('12374','2012-12-27','13:35:00',1.26),('12374','2012-12-27','13:40:00',1.9),('12374','2012-12-27','13:45:00',2.2),('12374','2012-12-27','13:50:00',1.91),('12374','2012-12-27','13:55:00',2.28),('12374','2012-12-27','14:00:00',2.2),('12374','2012-12-27','14:05:00',2.24),('12374','2012-12-27','14:10:00',2.3),('12374','2012-12-27','14:15:00',1.71),('12374','2012-12-27','14:20:00',2.17),('12374','2012-12-27','14:25:00',4.05),('12374','2012-12-27','14:30:00',4.04),('12374','2012-12-27','14:35:00',4.05),('12374','2012-12-27','14:40:00',3.88),('12374','2012-12-27','14:45:00',3.7),('12374','2012-12-27','14:50:00',4),('12374','2012-12-27','14:55:00',3.71),('12374','2012-12-27','15:00:00',3.56),('12374','2012-12-27','15:05:00',3.43),('12374','2012-12-27','15:10:00',3.3),('12374','2012-12-27','15:15:00',3.18),('12374','2012-12-27','15:20:00',2.69),('12374','2012-12-27','15:25:00',2.54),('12374','2012-12-27','15:30:00',2.73),('12374','2012-12-27','15:35:00',2.81),('12374','2012-12-27','15:40:00',1.59),('12374','2012-12-27','15:45:00',1.39),('12374','2012-12-27','15:50:00',1.89),('12374','2012-12-27','15:55:00',1.85),('12374','2012-12-27','16:00:00',1.44),('12374','2012-12-26','08:45:00',1.02),('12374','2012-12-26','09:00:00',2.08),('12374','2012-12-26','09:05:00',2.49),('12374','2012-12-26','09:10:00',2.75),('12374','2012-12-26','09:15:00',3.09),('12374','2012-12-26','09:20:00',3.24),('12374','2012-12-26','09:25:00',3.44),('12374','2012-12-26','09:30:00',3.69),('12374','2012-12-26','09:35:00',3.98),('12374','2012-12-26','09:40:00',4.02),('12374','2012-12-26','09:45:00',4.01),('12374','2012-12-26','09:50:00',4.49),('12374','2012-12-26','09:55:00',4.78),('12374','2012-12-26','10:00:00',4.74),('12374','2012-12-26','10:05:00',1.79),('12374','2012-12-26','10:10:00',1.47),('12374','2012-12-26','10:15:00',1.34),('12374','2012-12-26','10:20:00',1.23),('12374','2012-12-26','10:25:00',1.07),('12374','2012-12-26','10:30:00',1.02),('12374','2012-12-26','10:35:00',1.01),('12374','2012-12-26','10:40:00',1.11),('12374','2012-12-26','10:45:00',1.09),('12374','2012-12-26','11:15:00',1.12),('12374','2012-12-26','11:20:00',1.19),('12374','2012-12-26','11:25:00',1.16),('12374','2012-12-26','11:30:00',1.12),('12374','2012-12-26','11:35:00',1.11),('12374','2012-12-26','11:40:00',1.03),('12374','2012-12-26','11:55:00',1.21),('12374','2012-12-26','12:00:00',1.43),('12374','2012-12-26','12:05:00',1.4),('12374','2012-12-26','12:10:00',1.19),('12374','2012-12-26','12:15:00',1.14),('12374','2012-12-26','12:20:00',1.18),('12374','2012-12-26','12:25:00',1.22),('12374','2012-12-26','12:30:00',1.1),('12374','2012-12-26','12:35:00',1.24),('12374','2012-12-26','12:40:00',1.25),('12374','2012-12-26','12:45:00',1.05),('12374','2012-12-26','13:20:00',1.21),('12374','2012-12-26','13:25:00',1.42),('12374','2012-12-26','13:30:00',1.61),('12374','2012-12-26','13:35:00',1.47),('12374','2012-12-26','13:40:00',1.14),('12374','2012-12-26','14:40:00',1.01),('12374','2012-12-26','14:45:00',1.01),('12374','2012-12-26','14:50:00',1.04),('12374','2012-12-26','14:55:00',1.19),('12374','2012-12-26','15:00:00',1.24),('12374','2012-12-25','09:35:00',1.05),('12374','2012-12-25','09:40:00',1.13),('12374','2012-12-25','09:45:00',1.13),('12374','2012-12-25','09:50:00',1.21),('12374','2012-12-25','09:55:00',1.18),('12374','2012-12-25','10:00:00',1.12),('12374','2012-12-25','10:05:00',1.18),('12374','2012-12-25','10:10:00',1.23),('12374','2012-12-25','10:15:00',1.26),('12374','2012-12-25','10:20:00',1.3),('12374','2012-12-25','10:25:00',1.34),('12374','2012-12-25','10:30:00',1.31),('12374','2012-12-25','10:35:00',1.32),('12374','2012-12-25','10:40:00',1.34),('12374','2012-12-25','10:45:00',1.26),('12374','2012-12-25','10:50:00',1.24),('12374','2012-12-25','10:55:00',1.15),('12374','2012-12-25','11:00:00',1.21),('12374','2012-12-25','11:05:00',1.3),('12374','2012-12-25','11:10:00',1.3),('12374','2012-12-25','11:15:00',1.42),('12374','2012-12-25','11:20:00',1.26),('12374','2012-12-25','11:25:00',1.37),('12374','2012-12-25','11:30:00',1.69),('12374','2012-12-25','11:35:00',1.73),('12374','2012-12-25','11:40:00',1.93),('12374','2012-12-25','11:45:00',1.82),('12374','2012-12-25','11:50:00',1.7),('12374','2012-12-25','11:55:00',1.97),('12374','2012-12-25','12:00:00',1.85),('12374','2012-12-25','12:05:00',1.72),('12374','2012-12-25','12:10:00',1.67),('12374','2012-12-25','12:15:00',1.67),('12374','2012-12-25','12:20:00',1.33),('12374','2012-12-25','12:25:00',1.43),('12374','2012-12-25','12:30:00',1.5),('12374','2012-12-25','12:35:00',1.67),('12374','2012-12-25','12:40:00',1.93),('12374','2012-12-25','12:45:00',2.28),('12374','2012-12-25','12:50:00',2.76),('12374','2012-12-25','12:55:00',3.05),('12374','2012-12-25','13:00:00',2.87),('12374','2012-12-25','13:05:00',2.41),('12374','2012-12-25','13:10:00',2.01),('12374','2012-12-25','13:15:00',1.92),('12374','2012-12-25','13:20:00',2.17),('12374','2012-12-25','13:25:00',2.26),('12374','2012-12-25','13:30:00',2.15),('12374','2012-12-25','13:35:00',2.14),('12374','2012-12-25','13:40:00',1.57),('12374','2012-12-25','13:45:00',1.84),('12374','2012-12-25','13:50:00',1.55),('12374','2012-12-25','13:55:00',1.41),('12374','2012-12-25','14:00:00',1.18),('12374','2012-12-25','14:05:00',1.1),('12374','2012-12-25','14:10:00',1.44),('12374','2012-12-25','14:15:00',1.85),('12374','2012-12-25','14:20:00',1.91),('12374','2012-12-25','14:25:00',1.72),('12374','2012-12-25','14:30:00',1.34),('12374','2012-12-25','14:35:00',1.22),('12374','2012-12-25','14:40:00',1.07),('12374','2012-12-25','15:00:00',1.11),('12374','2012-12-25','15:05:00',1.09),('12374','2012-12-25','15:10:00',1.29),('12374','2012-12-25','15:15:00',1.45),('12374','2012-12-25','15:20:00',1.14),('12374','2012-12-25','15:25:00',1.07),('12374','2012-12-25','15:30:00',1.24),('12374','2012-12-25','15:35:00',1.22),('12374','2012-12-25','15:40:00',1.07),('12374','2012-12-25','15:45:00',1.1),('12374','2012-12-24','10:35:00',1.03),('12374','2012-12-24','10:40:00',1.12),('12374','2012-12-24','10:45:00',1.22),('12374','2012-12-24','10:50:00',1.23),('12374','2012-12-24','10:55:00',1.31),('12374','2012-12-24','11:00:00',1.43),('12374','2012-12-24','11:05:00',1.37),('12374','2012-12-24','11:10:00',1.38),('12374','2012-12-24','11:15:00',1.34),('12374','2012-12-24','11:20:00',1.34),('12374','2012-12-24','11:25:00',1.41),('12374','2012-12-24','11:30:00',1.52),('12374','2012-12-24','11:35:00',1.51),('12374','2012-12-24','11:40:00',1.51),('12374','2012-12-24','11:45:00',1.57),('12374','2012-12-24','11:50:00',1.57),('12374','2012-12-24','11:55:00',1.5),('12374','2012-12-24','12:00:00',1.53),('12374','2012-12-24','12:05:00',1.41),('12374','2012-12-24','12:10:00',1.24),('12374','2012-12-24','12:15:00',1.34),('12374','2012-12-24','12:20:00',1.33),('12374','2012-12-24','12:25:00',1.36),('12374','2012-12-24','12:30:00',1.33),('12374','2012-12-24','12:35:00',1.27),('12374','2012-12-24','12:40:00',1.23),('12374','2012-12-24','12:45:00',1.2),('12374','2012-12-24','12:50:00',1.26),('12374','2012-12-24','12:55:00',1.17),('12374','2012-12-24','13:00:00',1.11),('12374','2012-12-24','13:05:00',1.11),('12374','2012-12-24','13:10:00',1.18),('12374','2012-12-24','13:15:00',1.25),('12374','2012-12-24','13:20:00',1.28),('12374','2012-12-24','13:25:00',1.3),('12374','2012-12-24','13:30:00',1.23),('12374','2012-12-24','13:35:00',1.14),('12374','2012-12-24','13:40:00',1.03),('12374','2012-12-23','08:20:00',1.21),('12374','2012-12-23','08:25:00',1.49),('12374','2012-12-23','08:30:00',1.77),('12374','2012-12-23','08:35:00',1.92),('12374','2012-12-23','08:40:00',2.15),('12374','2012-12-23','08:45:00',2.33),('12374','2012-12-23','08:50:00',2.29),('12374','2012-12-23','08:55:00',2.68),('12374','2012-12-23','09:00:00',2.68),('12374','2012-12-23','09:05:00',2.9),('12374','2012-12-23','09:10:00',3.06),('12374','2012-12-23','09:15:00',3.2),('12374','2012-12-23','09:20:00',3.37),('12374','2012-12-23','09:25:00',3.52),('12374','2012-12-23','09:30:00',3.75),('12374','2012-12-23','09:35:00',4),('12374','2012-12-23','09:40:00',4.26),('12374','2012-12-23','09:45:00',4.21),('12374','2012-12-23','09:50:00',4.31),('12374','2012-12-23','09:55:00',4.44),('12374','2012-12-23','10:00:00',4.58),('12374','2012-12-23','10:05:00',4.85),('12374','2012-12-23','10:10:00',4.99),('12374','2012-12-23','10:15:00',5.09),('12374','2012-12-23','10:20:00',5.2),('12374','2012-12-23','10:25:00',5.23),('12374','2012-12-23','10:30:00',5.35),('12374','2012-12-23','10:35:00',5.37),('12374','2012-12-23','10:40:00',5.33),('12374','2012-12-23','10:45:00',5.55),('12374','2012-12-23','10:50:00',5.63),('12374','2012-12-23','10:55:00',5.57),('12374','2012-12-23','11:00:00',5.67),('12374','2012-12-23','11:05:00',5.86),('12374','2012-12-23','11:10:00',5.66),('12374','2012-12-23','11:15:00',5.6),('12374','2012-12-23','11:20:00',5.34),('12374','2012-12-23','11:25:00',5.79),('12374','2012-12-23','11:30:00',6.05),('12374','2012-12-23','11:35:00',6.03),('12374','2012-12-23','11:40:00',5.56),('12374','2012-12-23','11:45:00',6.09),('12374','2012-12-23','11:50:00',6.05),('12374','2012-12-23','11:55:00',5.63),('12374','2012-12-23','12:00:00',5.28),('12374','2012-12-23','12:05:00',5.99),('12374','2012-12-23','12:10:00',5.95),('12374','2012-12-23','12:15:00',5.89),('12374','2012-12-23','12:20:00',5.68),('12374','2012-12-23','12:25:00',5.43),('12374','2012-12-23','12:30:00',5.23),('12374','2012-12-23','12:35:00',6),('12374','2012-12-23','12:40:00',5.97),('12374','2012-12-23','12:45:00',5.93),('12374','2012-12-23','12:50:00',5.91),('12374','2012-12-23','12:55:00',4.58),('12374','2012-12-23','13:00:00',4.56),('12374','2012-12-23','13:05:00',4.66),('12374','2012-12-23','13:10:00',4.64),('12374','2012-12-23','13:15:00',5.17),('12374','2012-12-23','13:20:00',4.2),('12374','2012-12-23','13:25:00',4.45),('12374','2012-12-23','13:30:00',3.16),('12374','2012-12-23','13:35:00',2.26),('12374','2012-12-23','13:40:00',3.6),('12374','2012-12-23','13:45:00',5.04),('12374','2012-12-23','13:50:00',5),('12374','2012-12-23','13:55:00',4.68),('12374','2012-12-23','14:00:00',3.99),('12374','2012-12-23','14:05:00',3.33),('12374','2012-12-23','14:10:00',2.55),('12374','2012-12-23','14:15:00',2.45),('12374','2012-12-23','14:20:00',2.27),('12374','2012-12-23','14:25:00',2.26),('12374','2012-12-23','14:30:00',3.03),('12374','2012-12-23','14:35:00',3.59),('12374','2012-12-23','14:40:00',3.96),('12374','2012-12-23','14:45:00',4.11),('12374','2012-12-23','14:50:00',3.79),('12374','2012-12-23','14:55:00',3.7),('12374','2012-12-23','15:00:00',3.39),('12374','2012-12-23','15:05:00',3.17),('12374','2012-12-23','15:10:00',3.12),('12374','2012-12-23','15:15:00',2.03),('12374','2012-12-23','15:20:00',1.06),('12374','2012-12-23','15:25:00',1.1),('12374','2012-12-23','15:30:00',2.34),('12374','2012-12-23','15:35:00',2.39),('12374','2012-12-23','15:40:00',2.23),('12374','2012-12-23','15:45:00',2.02),('12374','2012-12-23','15:50:00',1.71),('12374','2012-12-23','15:55:00',1.42),('12374','2012-12-22','10:00:00',1.03),('12374','2012-12-22','10:05:00',1.07),('12374','2012-12-22','10:10:00',1.12),('12374','2012-12-22','10:15:00',1.23),('12374','2012-12-22','10:20:00',1.4),('12374','2012-12-22','10:25:00',1.64),('12374','2012-12-22','10:30:00',1.87),('12374','2012-12-22','10:35:00',1.74),('12374','2012-12-22','10:40:00',1.58),('12374','2012-12-22','10:45:00',1.54),('12374','2012-12-22','10:50:00',1.8),('12374','2012-12-22','10:55:00',1.9),('12374','2012-12-22','11:00:00',1.96),('12374','2012-12-22','11:05:00',2.16),('12374','2012-12-22','11:10:00',2.18),('12374','2012-12-22','11:15:00',2.73),('12374','2012-12-22','11:20:00',2.89),('12374','2012-12-22','11:25:00',3.84),('12374','2012-12-22','11:30:00',4.72),('12374','2012-12-22','11:35:00',5.56),('12374','2012-12-22','11:40:00',6.68),('12374','2012-12-22','11:45:00',4.25),('12374','2012-12-22','11:50:00',3.37),('12374','2012-12-22','11:55:00',1.96),('12374','2012-12-22','12:00:00',2.28),('12374','2012-12-22','12:05:00',1.91),('12374','2012-12-22','12:10:00',2.8),('12374','2012-12-22','12:15:00',1.47),('12374','2012-12-22','12:20:00',2.94),('12374','2012-12-22','12:25:00',1.79),('12374','2012-12-22','12:30:00',1.44),('12374','2012-12-22','12:35:00',1.08),('12374','2012-12-22','12:45:00',1.01),('12374','2012-12-22','12:50:00',1.1),('12374','2012-12-22','12:55:00',1.24),('12374','2012-12-22','13:00:00',1.7),('12374','2012-12-22','13:05:00',1.9),('12374','2012-12-22','13:10:00',1.5),('12374','2012-12-22','13:15:00',1.86),('12374','2012-12-22','13:20:00',1.22),('12374','2012-12-22','13:25:00',1.18),('12374','2012-12-22','13:30:00',1.43),('12374','2012-12-22','13:35:00',1.48),('12374','2012-12-22','13:40:00',4.4),('12374','2012-12-22','13:45:00',2.16),('12374','2012-12-22','13:50:00',1.37),('12374','2012-12-22','14:00:00',3.17),('12374','2012-12-22','14:05:00',5.05),('12374','2012-12-22','14:10:00',4.99),('12374','2012-12-22','14:15:00',4.62),('12374','2012-12-22','14:20:00',4.09),('12374','2012-12-22','14:25:00',4.57),('12374','2012-12-22','14:30:00',4.63),('12374','2012-12-22','14:35:00',4.62),('12374','2012-12-22','14:40:00',4.17),('12374','2012-12-22','14:45:00',3.42),('12374','2012-12-22','14:50:00',2.62),('12374','2012-12-22','14:55:00',3.46),('12374','2012-12-22','15:00:00',3.31),('12374','2012-12-22','15:05:00',2.53),('12374','2012-12-22','15:10:00',2.77),('12374','2012-12-22','15:15:00',2.48),('12374','2012-12-22','15:20:00',2.83),('12374','2012-12-22','15:25:00',2.52),('12374','2012-12-22','15:30:00',2.55),('12374','2012-12-22','15:35:00',2.27),('12374','2012-12-22','15:40:00',2.06),('12374','2012-12-22','15:45:00',1.9),('12374','2012-12-22','15:50:00',1.7),('12374','2012-12-22','15:55:00',1.51),('12374','2012-12-22','16:00:00',1.32),('12374','2012-12-22','16:05:00',1.14),('12664','2014-05-05','07:50:00',1.06),('12664','2014-05-05','07:55:00',1.15),('12664','2014-05-05','08:00:00',1.24),('12664','2014-05-05','08:05:00',1.34),('12664','2014-05-05','08:10:00',1.43),('12664','2014-05-05','08:15:00',1.53),('12664','2014-05-05','08:20:00',1.64),('12664','2014-05-05','08:25:00',1.74),('12664','2014-05-05','08:30:00',1.82),('12664','2014-05-05','08:35:00',1.91),('12664','2014-05-05','08:40:00',2),('12664','2014-05-05','08:45:00',2.09),('12664','2014-05-05','08:50:00',2.18),('12664','2014-05-05','08:55:00',2.26),('12664','2014-05-05','09:00:00',2.33),('12664','2014-05-05','09:05:00',2.42),('12664','2014-05-05','09:10:00',2.49),('12664','2014-05-05','09:15:00',2.56),('12664','2014-05-05','09:20:00',2.65),('12664','2014-05-05','09:25:00',2.73),('12664','2014-05-05','09:30:00',2.8),('12664','2014-05-05','09:35:00',2.88),('12664','2014-05-05','09:40:00',2.95),('12664','2014-05-05','09:45:00',3),('12664','2014-05-05','09:50:00',3.06),('12664','2014-05-05','09:55:00',3.14),('12664','2014-05-05','10:00:00',3.2),('12664','2014-05-05','10:05:00',3.27),('12664','2014-05-05','10:10:00',3.34),('12664','2014-05-05','10:15:00',3.39),('12664','2014-05-05','10:20:00',3.44),('12664','2014-05-05','10:25:00',3.49),('12664','2014-05-05','10:30:00',3.53),('12664','2014-05-05','10:35:00',3.59),('12664','2014-05-05','10:40:00',3.66),('12664','2014-05-05','10:45:00',3.69),('12664','2014-05-05','10:50:00',3.72),('12664','2014-05-05','10:55:00',3.74),('12664','2014-05-05','11:00:00',3.79),('12664','2014-05-05','11:05:00',3.84),('12664','2014-05-05','11:10:00',3.88),('12664','2014-05-05','11:15:00',3.92),('12664','2014-05-05','11:20:00',3.96),('12664','2014-05-05','11:25:00',4),('12664','2014-05-05','11:30:00',4.07),('12664','2014-05-05','11:35:00',4.11),('12664','2014-05-05','11:40:00',4.18),('12664','2014-05-05','11:45:00',4.24),('12664','2014-05-05','11:50:00',4.28),('12664','2014-05-05','11:55:00',4.26),('12664','2014-05-05','12:00:00',4.36),('12664','2014-05-05','12:05:00',4.27),('12664','2014-05-05','12:10:00',4.29),('12664','2014-05-05','12:15:00',4.22),('12664','2014-05-05','12:20:00',4.26),('12664','2014-05-05','12:25:00',4.29),('12664','2014-05-05','12:30:00',4.28),('12664','2014-05-05','12:35:00',4.29),('12664','2014-05-05','12:40:00',4.28),('12664','2014-05-05','12:45:00',4.27),('12664','2014-05-05','12:50:00',4.24),('12664','2014-05-05','12:55:00',4.22),('12664','2014-05-05','13:00:00',4.19),('12664','2014-05-05','13:05:00',4.2),('12664','2014-05-05','13:10:00',4.2),('12664','2014-05-05','13:15:00',4.29),('12664','2014-05-05','13:20:00',3.61),('12664','2014-05-05','13:25:00',4.29),('12664','2014-05-05','13:30:00',1.61),('12664','2014-05-05','13:40:00',1.27),('12664','2014-05-05','13:45:00',4.41),('12664','2014-05-05','13:50:00',4.85),('12664','2014-05-05','13:55:00',4.1),('12664','2014-05-05','14:00:00',2.55),('12664','2014-05-05','14:05:00',4.52),('12664','2014-05-05','14:10:00',4.51),('12664','2014-05-05','14:15:00',4.35),('12664','2014-05-05','14:20:00',4.24),('12664','2014-05-05','14:25:00',4.24),('12664','2014-05-05','14:30:00',4.26),('12664','2014-05-05','14:35:00',4.16),('12664','2014-05-05','14:40:00',4.08),('12664','2014-05-05','14:45:00',3.58),('12664','2014-05-05','14:50:00',4.07),('12664','2014-05-05','14:55:00',4.03),('12664','2014-05-05','15:00:00',3.88),('12664','2014-05-05','15:05:00',3.82),('12664','2014-05-05','15:10:00',3.77),('12664','2014-05-05','15:15:00',3.75),('12664','2014-05-05','15:20:00',3.64),('12664','2014-05-05','15:25:00',3.55),('12664','2014-05-05','15:30:00',3.56),('12664','2014-05-05','15:35:00',3.51),('12664','2014-05-05','15:40:00',3.46),('12664','2014-05-05','15:45:00',3.41),('12664','2014-05-05','15:50:00',3.35),('12664','2014-05-05','15:55:00',3.29),('12664','2014-05-05','16:00:00',3.21),('12664','2014-05-05','16:05:00',3.14),('12664','2014-05-05','16:10:00',3.09),('12664','2014-05-05','16:15:00',3.04),('12664','2014-05-05','16:20:00',2.97),('12664','2014-05-05','16:25:00',2.88),('12664','2014-05-05','16:30:00',2.79),('12664','2014-05-05','16:35:00',2.74),('12664','2014-05-05','16:40:00',2.67),('12664','2014-05-05','16:45:00',2.58),('12664','2014-05-05','16:50:00',2.5),('12664','2014-05-05','16:55:00',2.41),('12664','2014-05-05','17:00:00',2.31),('12664','2014-05-05','17:05:00',2.24),('12664','2014-05-05','17:10:00',2.15),('12664','2014-05-05','17:15:00',2.06),('12664','2014-05-05','17:20:00',1.98),('12664','2014-05-05','17:25:00',1.91),('12664','2014-05-05','17:30:00',1.9),('12664','2014-05-05','17:35:00',1.75),('12664','2014-05-05','17:40:00',1.6),('12664','2014-05-05','17:45:00',1.52),('12664','2014-05-05','17:50:00',1.47),('12664','2014-05-05','17:55:00',1.33),('12664','2014-05-05','18:00:00',1.24),('12664','2014-05-05','18:05:00',1.16),('12664','2014-05-05','18:10:00',1.08),('12664','2014-05-04','07:40:00',1.12),('12664','2014-05-04','07:45:00',1.27),('12664','2014-05-04','07:50:00',1.22),('12664','2014-05-04','07:55:00',1.21),('12664','2014-05-04','08:00:00',1.31),('12664','2014-05-04','08:05:00',1.49),('12664','2014-05-04','08:10:00',1.53),('12664','2014-05-04','08:15:00',1.65),('12664','2014-05-04','08:20:00',1.78),('12664','2014-05-04','08:25:00',1.38),('12664','2014-05-04','08:30:00',1.3),('12664','2014-05-04','08:45:00',1.84),('12664','2014-05-04','08:50:00',1.19),('12664','2014-05-04','08:55:00',1.25),('12664','2014-05-04','09:05:00',1.05),('12664','2014-05-04','09:10:00',1.4),('12664','2014-05-04','09:15:00',1.84),('12664','2014-05-04','09:20:00',2.1),('12664','2014-05-04','09:25:00',1.89),('12664','2014-05-04','09:30:00',3.53),('12664','2014-05-04','09:35:00',2.79),('12664','2014-05-04','09:40:00',2.26),('12664','2014-05-04','09:45:00',1.39),('12664','2014-05-04','09:50:00',3.45),('12664','2014-05-04','09:55:00',4.08),('12664','2014-05-04','10:00:00',3.92),('12664','2014-05-04','10:05:00',3.37),('12664','2014-05-04','10:10:00',2.59),('12664','2014-05-04','10:15:00',3.49),('12664','2014-05-04','10:20:00',2.32),('12664','2014-05-04','10:25:00',2.16),('12664','2014-05-04','10:30:00',1.78),('12664','2014-05-04','10:35:00',1.8),('12664','2014-05-04','10:40:00',1.82),('12664','2014-05-04','10:45:00',1.87),('12664','2014-05-04','10:50:00',2.19),('12664','2014-05-04','10:55:00',4.14),('12664','2014-05-04','11:00:00',3.88),('12664','2014-05-04','11:05:00',2.72),('12664','2014-05-04','11:10:00',3.55),('12664','2014-05-04','11:15:00',4.24),('12664','2014-05-04','11:20:00',4.13),('12664','2014-05-04','11:25:00',4.12),('12664','2014-05-04','11:30:00',4.21),('12664','2014-05-04','11:35:00',4.34),('12664','2014-05-04','11:40:00',2.65),('12664','2014-05-04','11:45:00',1.6),('12664','2014-05-04','11:50:00',1.66),('12664','2014-05-04','11:55:00',1.65),('12664','2014-05-04','12:00:00',2.05),('12664','2014-05-04','12:05:00',4.79),('12664','2014-05-04','12:10:00',4.63),('12664','2014-05-04','12:15:00',4.65),('12664','2014-05-04','12:20:00',4.23),('12664','2014-05-04','12:25:00',2.01),('12664','2014-05-04','12:30:00',1.14),('12664','2014-05-04','12:35:00',1.02),('12664','2014-05-04','12:40:00',1.33),('12664','2014-05-04','12:45:00',1.92),('12664','2014-05-04','12:50:00',2.32),('12664','2014-05-04','12:55:00',1.82),('12664','2014-05-04','13:00:00',1.65),('12664','2014-05-04','13:05:00',1.42),('12664','2014-05-04','13:10:00',1.36),('12664','2014-05-04','13:15:00',1.28),('12664','2014-05-04','13:20:00',1.28),('12664','2014-05-04','13:25:00',1.32),('12664','2014-05-04','13:30:00',1.33),('12664','2014-05-04','13:35:00',1.42),('12664','2014-05-04','13:40:00',1.62),('12664','2014-05-04','13:45:00',4.03),('12664','2014-05-04','13:50:00',1.65),('12664','2014-05-04','13:55:00',1.14),('12664','2014-05-04','14:20:00',1.07),('12664','2014-05-04','14:25:00',1.25),('12664','2014-05-04','14:30:00',1.25),('12664','2014-05-04','14:35:00',1.41),('12664','2014-05-04','14:40:00',1.98),('12664','2014-05-04','14:45:00',2.72),('12664','2014-05-04','14:50:00',3.49),('12664','2014-05-04','14:55:00',4.31),('12664','2014-05-04','15:00:00',4.27),('12664','2014-05-04','15:05:00',4.38),('12664','2014-05-04','15:10:00',2.82),('12664','2014-05-04','15:15:00',1.56),('12664','2014-05-04','15:20:00',1.63),('12664','2014-05-04','15:25:00',2.24),('12664','2014-05-04','15:30:00',1.4),('12664','2014-05-04','17:35:00',1.08),('12664','2014-04-25','08:15:00',1.22),('12664','2014-04-25','08:20:00',1.32),('12664','2014-04-25','08:25:00',1.37),('12664','2014-04-25','08:30:00',1.45),('12664','2014-04-25','08:35:00',1.56),('12664','2014-04-25','08:40:00',1.65),('12664','2014-04-25','08:45:00',1.73),('12664','2014-04-25','08:50:00',1.45),('12664','2014-04-25','08:55:00',1.16),('12664','2014-04-25','09:40:00',1.19),('12664','2014-04-25','09:45:00',1.5),('12664','2014-04-25','09:50:00',1.32),('12664','2014-04-25','09:55:00',1.2),('12664','2014-04-25','10:00:00',1.24),('12664','2014-04-25','10:05:00',1.29),('12664','2014-04-25','10:10:00',1.64),('12664','2014-04-25','10:15:00',2.05),('12664','2014-04-25','10:20:00',1.51),('12664','2014-04-25','10:35:00',1.23),('12664','2014-04-25','10:40:00',2.05),('12664','2014-04-25','10:45:00',1.27),('12664','2014-04-25','10:55:00',1.56),('12664','2014-04-25','11:00:00',2.26),('12664','2014-04-25','11:05:00',2.25),('12664','2014-04-25','11:10:00',2.31),('12664','2014-04-25','11:15:00',1.67),('12664','2014-04-25','11:20:00',1.66),('12664','2014-04-25','11:25:00',3.44),('12664','2014-04-25','11:30:00',4.07),('12664','2014-04-25','11:35:00',4.13),('12664','2014-04-25','11:40:00',2.34),('12664','2014-04-25','11:45:00',1.33),('12664','2014-04-25','11:55:00',2.96),('12664','2014-04-25','12:00:00',2.96),('12664','2014-04-25','12:05:00',1.55),('12664','2014-04-25','12:10:00',2.03),('12664','2014-04-25','12:15:00',4.38),('12664','2014-04-25','12:20:00',1.56),('12664','2014-04-25','12:25:00',2.56),('12664','2014-04-25','12:30:00',2.42),('12664','2014-04-25','12:35:00',2),('12664','2014-04-25','12:40:00',1.83),('12664','2014-04-25','12:45:00',1.6),('12664','2014-04-25','12:50:00',1.25),('12664','2014-04-25','12:55:00',3.7),('12664','2014-04-25','13:00:00',4.16),('12664','2014-04-25','13:05:00',4.03),('12664','2014-04-25','13:10:00',3.88),('12664','2014-04-25','13:15:00',4.53),('12664','2014-04-25','13:20:00',3.51),('12664','2014-04-25','13:25:00',4.39),('12664','2014-04-25','13:30:00',4.34),('12664','2014-04-25','13:35:00',4.31),('12664','2014-04-25','13:40:00',4.16),('12664','2014-04-25','13:45:00',2.57),('12664','2014-04-25','13:50:00',3.42),('12664','2014-04-25','13:55:00',3.98),('12664','2014-04-25','14:00:00',3.72),('12664','2014-04-25','14:05:00',4),('12664','2014-04-25','14:10:00',3.93),('12664','2014-04-25','14:15:00',3.91),('12664','2014-04-25','14:20:00',3.89),('12664','2014-04-25','14:25:00',3.89),('12664','2014-04-25','14:30:00',3.84),('12664','2014-04-25','14:35:00',3.8),('12664','2014-04-25','14:40:00',3.77),('12664','2014-04-25','14:45:00',3.75),('12664','2014-04-25','14:50:00',3.71),('12664','2014-04-25','14:55:00',3.67),('12664','2014-04-25','15:00:00',3.6),('12664','2014-04-25','15:05:00',3.58),('12664','2014-04-25','15:10:00',3.5),('12664','2014-04-25','15:15:00',3.39),('12664','2014-04-25','15:20:00',3.18),('12664','2014-04-25','15:25:00',3.38),('12664','2014-04-25','15:30:00',3.37),('12664','2014-04-25','15:35:00',3.31),('12664','2014-04-25','15:40:00',3.25),('12664','2014-04-25','15:45:00',3.16),('12664','2014-04-25','15:50:00',3.13),('12664','2014-04-25','15:55:00',3.06),('12664','2014-04-25','16:00:00',2.88),('12664','2014-04-25','16:05:00',2.85),('12664','2014-04-25','16:10:00',2.59),('12664','2014-04-25','16:15:00',2.5),('12664','2014-04-25','16:20:00',2.66),('12664','2014-04-25','16:25:00',2.42),('12664','2014-04-25','16:30:00',2.24),('12664','2014-04-25','16:35:00',2.48),('12664','2014-04-25','16:40:00',2.42),('12664','2014-04-25','16:45:00',2.19),('12664','2014-04-25','16:50:00',1.93),('12664','2014-04-25','16:55:00',1.53),('12664','2014-04-25','17:00:00',1.72),('12664','2014-04-25','17:05:00',1.75),('12664','2014-04-25','17:10:00',1.79),('12664','2014-04-25','17:15:00',1.81),('12664','2014-04-25','17:20:00',1.49),('12664','2014-04-25','17:25:00',1.44),('12664','2014-04-25','17:30:00',1.41),('12664','2014-04-25','17:35:00',1.04),('12664','2014-01-25','09:45:00',1.17),('12664','2014-01-25','09:50:00',1.41),('12664','2014-01-25','09:55:00',1.44),('12664','2014-01-25','10:00:00',2.98),('12664','2014-01-25','10:05:00',3),('12664','2014-01-25','10:10:00',2.23),('12664','2014-01-25','10:15:00',2.63),('12664','2014-01-25','10:20:00',2.52),('12664','2014-01-25','10:25:00',2.41),('12664','2014-01-25','10:30:00',2.26),('12664','2014-01-25','10:35:00',1.87),('12664','2014-01-25','10:40:00',1.93),('12664','2014-01-25','10:45:00',2.34),('12664','2014-01-25','10:50:00',2.82),('12664','2014-01-25','10:55:00',2.97),('12664','2014-01-25','11:00:00',2.92),('12664','2014-01-25','11:05:00',2.81),('12664','2014-01-25','11:10:00',2.84),('12664','2014-01-25','11:15:00',3.54),('12664','2014-01-25','11:20:00',3.89),('12664','2014-01-25','11:25:00',3.97),('12664','2014-01-25','11:30:00',3.37),('12664','2014-01-25','11:35:00',2.3),('12664','2014-01-25','11:40:00',2.4),('12664','2014-01-25','11:45:00',2.06),('12664','2014-01-25','11:50:00',1.84),('12664','2014-01-25','11:55:00',1.76),('12664','2014-01-25','12:00:00',2.11),('12664','2014-01-25','12:05:00',2.11),('12664','2014-01-25','12:10:00',1.88),('12664','2014-01-25','12:15:00',1.77),('12664','2014-01-25','12:20:00',1.78),('12664','2014-01-25','12:25:00',1.93),('12664','2014-01-25','12:30:00',1.92),('12664','2014-01-25','12:35:00',2.04),('12664','2014-01-25','12:40:00',2.05),('12664','2014-01-25','12:45:00',2.22),('12664','2014-01-25','12:50:00',1.71),('12664','2014-01-25','12:55:00',1.77),('12664','2014-01-25','13:00:00',2.84),('12664','2014-01-25','13:05:00',3.05),('12664','2014-01-25','13:10:00',2.9),('12664','2014-01-25','13:15:00',3.19),('12664','2014-01-25','13:20:00',3.15),('12664','2014-01-25','13:25:00',3.13),('12664','2014-01-25','13:30:00',3.04),('12664','2014-01-25','13:35:00',3.08),('12664','2014-01-25','13:40:00',3.11),('12664','2014-01-25','13:45:00',3.06),('12664','2014-01-25','13:50:00',2.74),('12664','2014-01-25','13:55:00',2.89),('12664','2014-01-25','14:00:00',2.34),('12664','2014-01-25','14:05:00',2.49),('12664','2014-01-25','14:10:00',2.58),('12664','2014-01-25','14:15:00',2.79),('12664','2014-01-25','14:20:00',2.7),('12664','2014-01-25','14:25:00',2.65),('12664','2014-01-25','14:30:00',2.61),('12664','2014-01-25','14:35:00',2.36),('12664','2014-01-25','14:40:00',2.54),('12664','2014-01-25','14:45:00',1.58),('12664','2014-01-25','15:00:00',1.67),('12664','2014-01-25','15:05:00',2.07),('12664','2014-01-25','15:10:00',1.96),('12664','2014-01-25','15:15:00',1.86),('12664','2014-01-25','15:20:00',1.75),('12664','2014-01-25','15:25:00',1.65),('12664','2014-01-25','15:30:00',1.57),('12664','2014-01-25','15:35:00',1.48),('12664','2014-01-25','15:40:00',1.39),('12664','2014-01-25','15:45:00',1.3),('12664','2014-01-25','15:50:00',1.21),('12664','2014-01-25','15:55:00',1.12),('12664','2014-01-25','16:00:00',1.03),('12664','2014-01-24','10:00:00',1.59),('12664','2014-01-24','10:05:00',2.48),('12664','2014-01-24','10:10:00',2.14),('12664','2014-01-24','10:15:00',2.96),('12664','2014-01-24','10:20:00',1.05),('12664','2014-01-24','10:25:00',1.02),('12664','2014-01-24','10:30:00',1.45),('12664','2014-01-24','10:35:00',2.55),('12664','2014-01-24','10:40:00',1.71),('12664','2014-01-24','10:45:00',1.28),('12664','2014-01-24','10:55:00',1.3),('12664','2014-01-24','11:00:00',2.38),('12664','2014-01-24','11:25:00',1.5),('12664','2014-01-24','11:35:00',3.18),('12664','2014-01-24','11:40:00',3.73),('12664','2014-01-24','11:45:00',3.44),('12664','2014-01-24','11:50:00',3.15),('12664','2014-01-24','11:55:00',2.58),('12664','2014-01-24','12:00:00',2.49),('12664','2014-01-24','12:05:00',2.35),('12664','2014-01-24','12:15:00',2.9),('12664','2014-01-24','12:20:00',1.68),('12664','2014-01-24','12:35:00',2),('12664','2014-01-24','12:40:00',1.42),('12664','2014-01-24','12:45:00',1.51),('12664','2014-01-24','13:00:00',1.38),('12664','2014-01-24','13:05:00',1.43),('12664','2014-01-24','13:10:00',2.77),('12664','2014-01-24','13:15:00',1.41),('12664','2014-01-24','13:20:00',2.2),('12664','2014-01-24','13:25:00',3.35),('12664','2014-01-24','13:30:00',3.22),('12664','2014-01-24','13:35:00',2.48),('12664','2014-01-24','13:40:00',1.31),('12664','2014-01-24','13:50:00',1.3),('12664','2014-01-24','14:00:00',1.02),('12664','2014-01-24','14:05:00',3.5),('12664','2014-01-24','14:10:00',2.5),('12664','2014-01-24','14:15:00',1.97),('12664','2014-01-24','14:20:00',2.88),('12664','2014-01-24','14:25:00',1.78),('12664','2014-01-24','14:30:00',1.93),('12664','2014-01-24','14:35:00',1.68),('12664','2014-01-24','14:40:00',1.74),('12664','2014-01-24','14:45:00',2.29),('12664','2014-01-24','14:50:00',1.27),('12664','2014-01-22','11:15:00',1.01),('12664','2014-01-22','12:40:00',1.5),('12664','2014-01-22','12:45:00',2.13),('12664','2014-01-22','12:50:00',1.08),('12664','2014-01-22','16:00:00',1.05),('12664','2014-01-22','16:05:00',1.1),('12664','2014-01-22','16:10:00',1.11),('12664','2014-01-21','10:25:00',1.07),('12664','2014-01-21','10:55:00',1.76),('12664','2014-01-21','11:25:00',2.43),('12664','2014-01-21','11:30:00',2.14),('12664','2014-01-21','11:35:00',3.25),('12664','2014-01-21','11:40:00',2.89),('12664','2014-01-21','11:50:00',1.69),('12664','2014-01-21','11:55:00',1.81),('12664','2014-01-21','12:00:00',1.7),('12664','2014-01-21','12:05:00',1.07),('12664','2014-01-21','12:10:00',1.41),('12664','2014-01-21','12:15:00',1.77),('12664','2014-01-21','12:20:00',1.6),('12664','2014-01-21','12:25:00',1.39),('12664','2014-01-21','12:30:00',1.41),('12664','2014-01-21','12:55:00',1.11),('12664','2014-01-21','13:00:00',1.06),('12664','2014-01-21','13:05:00',1.47),('12664','2014-01-21','13:10:00',1.19),('12664','2014-01-21','13:45:00',1.03),('12664','2014-01-21','15:15:00',1.39),('12664','2014-01-21','15:30:00',1.57),('12664','2014-01-21','15:35:00',1.13),('12664','2014-01-20','12:00:00',1.01),('12664','2014-01-20','12:50:00',1.73),('12664','2014-01-20','12:55:00',1.39),('12664','2014-01-20','13:20:00',1.07),('12664','2014-01-20','13:25:00',1.89),('12664','2014-01-20','13:30:00',1.35),('12664','2014-01-20','13:35:00',1.96),('12664','2014-01-20','14:15:00',1.04),('12664','2014-01-20','14:20:00',1.15),('12664','2014-01-19','11:50:00',1.1),('12664','2014-01-19','11:55:00',1.16),('12664','2014-01-19','12:00:00',1.02),('12664','2014-01-19','12:25:00',1.01),('12664','2014-01-19','13:10:00',1.05),('12664','2014-01-19','14:15:00',1.36),('12664','2014-01-19','14:20:00',1.68),('12664','2014-01-19','14:25:00',1.39),('12664','2014-01-19','14:30:00',1.02),('12664','2014-01-18','09:45:00',1.24),('12664','2014-01-18','09:50:00',1.65),('12664','2014-01-18','09:55:00',1.52),('12664','2014-01-18','10:00:00',1.13),('12664','2014-01-18','10:05:00',1.16),('12664','2014-01-18','10:10:00',2.45),('12664','2014-01-18','10:15:00',2.88),('12664','2014-01-18','10:20:00',2.01),('12664','2014-01-18','10:25:00',1.77),('12664','2014-01-18','10:30:00',1.73),('12664','2014-01-18','10:35:00',1.95),('12664','2014-01-18','10:40:00',2.1),('12664','2014-01-18','10:45:00',1.09),('12664','2014-01-18','10:50:00',1.08),('12664','2014-01-18','11:00:00',1.89),('12664','2014-01-18','11:05:00',2.42),('12664','2014-01-18','11:15:00',1.77),('12664','2014-01-18','11:20:00',3.08),('12664','2014-01-18','11:25:00',3.06),('12664','2014-01-18','11:30:00',3.07),('12664','2014-01-18','11:35:00',2.35),('12664','2014-01-18','11:40:00',1.8),('12664','2014-01-18','11:45:00',1.23),('12664','2014-01-18','11:50:00',1.02),('12664','2014-01-18','11:55:00',1.97),('12664','2014-01-18','12:00:00',2.89),('12664','2014-01-18','12:05:00',2.22),('12664','2014-01-18','12:10:00',3.16),('12664','2014-01-18','12:15:00',3.04),('12664','2014-01-18','12:20:00',3.07),('12664','2014-01-18','12:25:00',3.13),('12664','2014-01-18','12:30:00',3.1),('12664','2014-01-18','12:35:00',2.96),('12664','2014-01-18','12:40:00',2.73),('12664','2014-01-18','12:45:00',2.91),('12664','2014-01-18','12:50:00',2.2),('12664','2014-01-18','12:55:00',2.26),('12664','2014-01-18','13:00:00',2.73),('12664','2014-01-18','13:05:00',2.25),('12664','2014-01-18','13:10:00',2.64),('12664','2014-01-18','13:15:00',2.72),('12664','2014-01-18','13:20:00',3.28),('12664','2014-01-18','13:25:00',2.97),('12664','2014-01-18','13:30:00',2.68),('12664','2014-01-18','13:35:00',2.98),('12664','2014-01-18','13:40:00',2.73),('12664','2014-01-18','13:45:00',2.81),('12664','2014-01-18','13:50:00',2.19),('12664','2014-01-18','13:55:00',1.83),('12664','2014-01-18','14:00:00',2.68),('12664','2014-01-18','14:05:00',2.53),('12664','2014-01-18','14:10:00',2.31),('12664','2014-01-18','14:15:00',2.36),('12664','2014-01-18','14:20:00',2.34),('12664','2014-01-18','14:25:00',2.26),('12664','2014-01-18','14:30:00',2.19),('12664','2014-01-18','14:35:00',2.12),('12664','2014-01-18','14:40:00',2.06),('12664','2014-01-18','14:45:00',2),('12664','2014-01-18','14:50:00',1.88),('12664','2014-01-18','15:25:00',1.17),('12664','2014-01-18','15:50:00',1.11),('12664','2014-01-17','08:55:00',1.16),('12664','2014-01-17','09:00:00',1.24),('12664','2014-01-17','09:05:00',1.13),('12664','2014-01-17','09:10:00',1.34),('12664','2014-01-17','09:15:00',1.17),('12664','2014-01-17','09:30:00',1.31),('12664','2014-01-17','09:35:00',1.51),('12664','2014-01-17','09:40:00',2.33),('12664','2014-01-17','09:45:00',1.03),('12664','2014-01-16','09:00:00',1.02),('12664','2014-01-16','09:05:00',1.15),('12664','2014-01-16','09:10:00',1.19),('12664','2014-01-16','09:15:00',1.69),('12664','2014-01-16','09:20:00',1.81),('12664','2014-01-16','09:25:00',1.85),('12664','2014-01-16','09:30:00',1.92),('12664','2014-01-16','09:35:00',1.93),('12664','2014-01-16','09:40:00',1.65),('12664','2014-01-16','09:45:00',1.24),('12664','2014-01-16','10:05:00',1.17),('12664','2014-01-16','10:10:00',1.33),('12664','2014-01-16','10:15:00',1.33),('12664','2014-01-16','10:20:00',1.71),('12664','2014-01-16','10:25:00',2.42),('12664','2014-01-16','10:30:00',2.82),('12664','2014-01-16','10:35:00',1.9),('12664','2014-01-16','10:40:00',1.81),('12664','2014-01-16','10:45:00',2.17),('12664','2014-01-16','10:50:00',2.18),('12664','2014-01-16','10:55:00',2.17),('12664','2014-01-16','11:00:00',2.37),('12664','2014-01-16','11:05:00',2.45),('12664','2014-01-16','11:10:00',2.23),('12664','2014-01-16','11:15:00',1.96),('12664','2014-01-16','11:20:00',2.05),('12664','2014-01-16','11:25:00',1.92),('12664','2014-01-16','11:30:00',1.94),('12664','2014-01-16','11:35:00',2.03),('12664','2014-01-16','11:40:00',1.93),('12664','2014-01-16','11:45:00',2.02),('12664','2014-01-16','11:50:00',2.18),('12664','2014-01-16','11:55:00',2.02),('12664','2014-01-16','12:00:00',2.04),('12664','2014-01-16','12:05:00',2.1),('12664','2014-01-16','12:10:00',1.91),('12664','2014-01-16','12:15:00',1.7),('12664','2014-01-16','12:20:00',1.62),('12664','2014-01-16','12:25:00',1.76),('12664','2014-01-16','12:30:00',2.09),('12664','2014-01-16','12:35:00',2.08),('12664','2014-01-16','12:40:00',2.11),('12664','2014-01-16','12:45:00',2.27),('12664','2014-01-16','12:50:00',2.41),('12664','2014-01-16','12:55:00',2.51),('12664','2014-01-16','13:00:00',2.6),('12664','2014-01-16','13:05:00',2.57),('12664','2014-01-16','13:10:00',2.57),('12664','2014-01-16','13:15:00',2.58),('12664','2014-01-16','13:20:00',2.59),('12664','2014-01-16','13:25:00',2.5),('12664','2014-01-16','13:30:00',2.64),('12664','2014-01-16','13:35:00',2.7),('12664','2014-01-16','13:40:00',2.87),('12664','2014-01-16','13:45:00',1.19),('12664','2014-01-16','13:50:00',1.12),('12664','2014-01-16','13:55:00',1.12),('12664','2014-01-16','14:00:00',1.07),('12664','2014-01-16','15:00:00',1.07),('12664','2014-04-24','08:00:00',1),('12664','2014-04-24','08:05:00',1.08),('12664','2014-04-24','08:10:00',1.16),('12664','2014-04-24','08:15:00',1.25),('12664','2014-04-24','08:20:00',1.35),('12664','2014-04-24','08:25:00',1.44),('12664','2014-04-24','08:30:00',1.52),('12664','2014-04-24','08:35:00',1.63),('12664','2014-04-24','08:40:00',1.71),('12664','2014-04-24','08:45:00',1.8),('12664','2014-04-24','08:50:00',1.88),('12664','2014-04-24','08:55:00',1.95),('12664','2014-04-24','09:00:00',2.04),('12664','2014-04-24','09:05:00',2.12),('12664','2014-04-24','09:10:00',2.21),('12664','2014-04-24','09:15:00',2.13),('12664','2014-04-24','09:20:00',2.34),('12664','2014-04-24','09:25:00',2.42),('12664','2014-04-24','09:30:00',2.51),('12664','2014-04-24','09:35:00',2.58),('12664','2014-04-24','09:40:00',2.65),('12664','2014-04-24','09:45:00',2.72),('12664','2014-04-24','09:50:00',2.78),('12664','2014-04-24','09:55:00',2.85),('12664','2014-04-24','10:00:00',2.91),('12664','2014-04-24','10:05:00',2.96),('12664','2014-04-24','10:10:00',3.01),('12664','2014-04-24','10:15:00',3.06),('12664','2014-04-24','10:20:00',3.12),('12664','2014-04-24','10:25:00',3.15),('12664','2014-04-24','10:30:00',3.21),('12664','2014-04-24','10:35:00',3.29),('12664','2014-04-24','10:40:00',3.42),('12664','2014-04-24','10:45:00',3.53),('12664','2014-04-24','10:50:00',3.25),('12664','2014-04-24','10:55:00',1.01),('12664','2014-04-24','11:00:00',2.62),('12664','2014-04-24','11:05:00',3.8),('12664','2014-04-24','11:10:00',3.69),('12664','2014-04-24','11:15:00',3.75),('12664','2014-04-24','11:20:00',2.99),('12664','2014-04-24','11:25:00',3.47),('12664','2014-04-24','11:30:00',3.93),('12664','2014-04-24','11:35:00',3.74),('12664','2014-04-24','11:45:00',3.37),('12664','2014-04-24','11:50:00',3.65),('12664','2014-04-24','11:55:00',3.96),('12664','2014-04-24','12:00:00',4),('12664','2014-04-24','12:05:00',4.03),('12664','2014-04-24','12:10:00',3.81),('12664','2014-04-24','12:15:00',3.77),('12664','2014-04-24','12:20:00',3.99),('12664','2014-04-24','12:25:00',3.95),('12664','2014-04-24','12:30:00',4),('12664','2014-04-24','12:35:00',3.98),('12664','2014-04-24','12:40:00',4.06),('12664','2014-04-24','12:45:00',4.07),('12664','2014-04-24','12:50:00',4.05),('12664','2014-04-24','12:55:00',4.05),('12664','2014-04-24','13:00:00',4.09),('12664','2014-04-24','13:05:00',3.62),('12664','2014-04-24','13:10:00',3.69),('12664','2014-04-24','13:15:00',4.21),('12664','2014-04-24','13:20:00',4.15),('12664','2014-04-24','13:25:00',4.16),('12664','2014-04-24','13:30:00',3.87),('12664','2014-04-24','13:35:00',1.06),('12664','2014-04-24','13:40:00',4.05),('12664','2014-04-24','13:45:00',4.17),('12664','2014-04-24','13:50:00',4.11),('12664','2014-04-24','13:55:00',4.09),('12664','2014-04-24','14:00:00',4.04),('12664','2014-04-24','14:05:00',4.07),('12664','2014-04-24','14:10:00',4.04),('12664','2014-04-24','14:15:00',4.02),('12664','2014-04-24','14:20:00',4.03),('12664','2014-04-24','14:25:00',4.05),('12664','2014-04-24','14:30:00',4.1),('12664','2014-04-24','14:35:00',4.06),('12664','2014-04-24','14:40:00',3.98),('12664','2014-04-24','14:45:00',3.88),('12664','2014-04-24','14:50:00',3.81),('12664','2014-04-24','14:55:00',3.8),('12664','2014-04-24','15:00:00',3.89),('12664','2014-04-24','15:05:00',4.03),('12664','2014-04-24','15:10:00',4.25),('12664','2014-04-24','15:15:00',4.21),('12664','2014-04-24','15:20:00',3.58),('12664','2014-04-24','15:25:00',2.63),('12664','2014-04-24','15:30:00',3.76),('12664','2014-04-24','15:35:00',2.94),('12664','2014-04-24','15:40:00',2.3),('12664','2014-04-24','15:45:00',3.84),('12664','2014-04-24','15:50:00',3.42),('12664','2014-04-24','15:55:00',2.79),('12664','2014-04-24','16:00:00',3.22),('12664','2014-04-24','16:05:00',3.06),('12664','2014-04-24','16:10:00',3.28),('12664','2014-04-24','16:15:00',2),('12664','2014-04-24','16:20:00',2.05),('12664','2014-04-24','16:25:00',3.05),('12664','2014-04-24','16:30:00',2.05),('12664','2014-04-24','16:35:00',3.08),('12664','2014-04-24','16:40:00',1.45),('12664','2014-04-24','16:45:00',1.09),('12664','2014-04-24','16:50:00',1.16),('12664','2014-04-24','16:55:00',1.22),('12664','2014-04-24','17:00:00',1.13),('12664','2014-04-24','17:05:00',1.19),('12664','2014-04-24','17:10:00',1.23),('12664','2014-04-24','17:15:00',1.21),('12664','2014-04-24','17:20:00',1.18),('12664','2014-04-24','17:25:00',1.07),('12664','2014-01-15','09:30:00',1.03),('12664','2014-01-15','09:35:00',1.06),('12664','2014-01-15','09:55:00',1.79),('12664','2014-01-15','10:00:00',2.21),('12664','2014-01-15','10:05:00',2.48),('12664','2014-01-15','10:10:00',2.48),('12664','2014-01-15','10:15:00',2.53),('12664','2014-01-15','10:20:00',2.59),('12664','2014-01-15','10:25:00',2.63),('12664','2014-01-15','10:30:00',2.7),('12664','2014-01-15','10:35:00',2.28),('12664','2014-01-15','10:40:00',1.71),('12664','2014-01-15','10:45:00',1.47),('12664','2014-01-15','10:50:00',1.1),('12664','2014-01-15','10:55:00',1.52),('12664','2014-01-15','11:00:00',2.56),('12664','2014-01-15','11:05:00',2.71),('12664','2014-01-15','11:10:00',2.84),('12664','2014-01-15','11:15:00',2.75),('12664','2014-01-15','11:20:00',2.96),('12664','2014-01-15','11:25:00',2.77),('12664','2014-01-15','11:30:00',1.85),('12664','2014-01-15','11:35:00',1.34),('12664','2014-01-15','11:40:00',1.23),('12664','2014-01-15','11:45:00',1.23),('12664','2014-01-15','11:50:00',1.72),('12664','2014-01-15','11:55:00',1.79),('12664','2014-01-15','12:00:00',1.53),('12664','2014-01-15','12:05:00',1.59),('12664','2014-01-15','12:10:00',2.14),('12664','2014-01-15','12:15:00',1.92),('12664','2014-01-15','12:20:00',1.42),('12664','2014-01-15','12:25:00',1.99),('12664','2014-01-15','12:30:00',3.2),('12664','2014-01-15','12:35:00',3.17),('12664','2014-01-15','12:40:00',2.59),('12664','2014-01-15','12:45:00',2.57),('12664','2014-01-15','12:50:00',3.07),('12664','2014-01-15','12:55:00',3.19),('12664','2014-01-15','13:00:00',3.15),('12664','2014-01-15','13:05:00',3.11),('12664','2014-01-15','13:10:00',3.07),('12664','2014-01-15','13:15:00',3.09),('12664','2014-01-15','13:20:00',3.02),('12664','2014-01-15','13:25:00',2.98),('12664','2014-01-15','13:30:00',2.9),('12664','2014-01-15','13:35:00',1.42),('12664','2014-01-15','13:40:00',2.07),('12664','2014-01-15','13:45:00',2.74),('12664','2014-01-15','13:50:00',2.69),('12664','2014-01-15','13:55:00',1.57),('12664','2014-01-15','14:00:00',1.13),('12664','2014-01-15','14:05:00',2.64),('12664','2014-01-15','14:10:00',2.45),('12664','2014-01-15','14:15:00',2.41),('12664','2014-01-15','14:20:00',2.31),('12664','2014-01-15','14:25:00',2.24),('12664','2014-01-15','14:30:00',2.2),('12664','2014-01-15','14:35:00',2.16),('12664','2014-01-15','14:40:00',2.09),('12664','2014-01-15','14:45:00',2.02),('12664','2014-01-15','14:50:00',1.94),('12664','2014-01-15','15:00:00',1.08),('12664','2014-01-15','15:05:00',1.77),('12664','2014-01-15','15:10:00',1.64),('12664','2014-01-15','15:15:00',1.53),('12664','2014-01-15','15:20:00',1.52),('12664','2014-01-15','15:25:00',1.42),('12664','2014-01-15','15:30:00',1.33),('12664','2014-01-15','15:35:00',1.25),('12664','2014-01-15','15:40:00',1.17),('12664','2014-01-15','15:45:00',1.06),('12664','2014-01-14','10:20:00',1.04),('12664','2014-01-14','10:25:00',1.72),('12664','2014-01-14','10:30:00',1.89),('12664','2014-01-14','10:35:00',1.3),('12664','2014-01-14','10:40:00',1.04),('12664','2014-01-13','09:05:00',1.44),('12664','2014-01-13','09:10:00',1.54),('12664','2014-01-13','09:15:00',1.56),('12664','2014-01-13','09:20:00',1.63),('12664','2014-01-13','09:25:00',1.69),('12664','2014-01-13','09:30:00',1.75),('12664','2014-01-13','09:35:00',1.81),('12664','2014-01-13','09:40:00',1.88),('12664','2014-01-13','09:45:00',1.92),('12664','2014-01-13','09:50:00',1.96),('12664','2014-01-13','09:55:00',2.01),('12664','2014-01-13','10:00:00',2.07),('12664','2014-01-13','10:05:00',2.12),('12664','2014-01-13','10:10:00',2.18),('12664','2014-01-13','10:15:00',2.24),('12664','2014-01-13','10:20:00',2.3),('12664','2014-01-13','10:25:00',2.35),('12664','2014-01-13','10:30:00',2.39),('12664','2014-01-13','10:35:00',2.41),('12664','2014-01-13','10:40:00',2.45),('12664','2014-01-13','10:45:00',2.47),('12664','2014-01-13','10:50:00',2.51),('12664','2014-01-13','10:55:00',2.53),('12664','2014-01-13','11:00:00',2.51),('12664','2014-01-13','11:05:00',2.56),('12664','2014-01-13','11:10:00',2.58),('12664','2014-01-13','11:15:00',2.65),('12664','2014-01-13','11:20:00',2.66),('12664','2014-01-13','11:25:00',2.67),('12664','2014-01-13','11:30:00',2.68),('12664','2014-01-13','11:35:00',2.72),('12664','2014-01-13','11:40:00',2.71),('12664','2014-01-13','11:45:00',2.72),('12664','2014-01-13','11:50:00',2.75),('12664','2014-01-13','11:55:00',2.74),('12664','2014-01-13','12:00:00',2.71),('12664','2014-01-13','12:05:00',2.71),('12664','2014-01-13','12:10:00',2.7),('12664','2014-01-13','12:15:00',2.71),('12664','2014-01-13','12:20:00',2.72),('12664','2014-01-13','12:25:00',2.69),('12664','2014-01-13','12:30:00',2.64),('12664','2014-01-13','12:35:00',2.64),('12664','2014-01-13','12:40:00',2.71),('12664','2014-01-13','12:45:00',2.71),('12664','2014-01-13','12:50:00',2.61),('12664','2014-01-13','12:55:00',2.66),('12664','2014-01-13','13:00:00',2.65),('12664','2014-01-13','13:05:00',2.62),('12664','2014-01-13','13:10:00',2.54),('12664','2014-01-13','13:15:00',2.42),('12664','2014-01-13','13:20:00',2.29),('12664','2014-01-13','13:25:00',2.38),('12664','2014-01-13','13:30:00',2.41),('12664','2014-01-13','13:35:00',2.39),('12664','2014-01-13','13:40:00',2.41),('12664','2014-01-13','13:45:00',2.37),('12664','2014-01-13','13:50:00',2.4),('12664','2014-01-13','13:55:00',2.36),('12664','2014-01-13','14:00:00',2.37),('12664','2014-01-13','14:05:00',2.24),('12664','2014-01-13','14:10:00',2.11),('12664','2014-01-13','14:15:00',2.02),('12664','2014-01-13','14:20:00',2.03),('12664','2014-01-13','14:25:00',1.94),('12664','2014-01-13','14:30:00',1.9),('12664','2014-01-13','14:35:00',1.89),('12664','2014-01-13','14:40:00',1.84),('12664','2014-01-13','14:45:00',1.77),('12664','2014-01-13','14:50:00',1.68),('12664','2014-01-13','14:55:00',1.62),('12664','2014-01-13','15:00:00',1.59),('12664','2014-01-13','15:05:00',1.46),('12664','2014-01-13','15:10:00',1.42),('12664','2014-01-13','15:15:00',1.36),('12664','2014-01-13','15:20:00',1.27),('12664','2014-01-13','15:25:00',1.21),('12664','2014-01-13','15:30:00',1.14),('12664','2014-01-13','15:35:00',1.04),('12664','2014-01-12','10:30:00',1.04),('12664','2014-01-12','10:35:00',1.16),('12664','2014-01-12','10:40:00',1.33),('12664','2014-01-12','10:45:00',1.37),('12664','2014-01-12','10:50:00',1.41),('12664','2014-01-12','10:55:00',1.41),('12664','2014-01-12','11:00:00',1.53),('12664','2014-01-12','11:05:00',1.61),('12664','2014-01-12','11:10:00',1.74),('12664','2014-01-12','11:15:00',1.98),('12664','2014-01-12','11:20:00',1.94),('12664','2014-01-12','11:25:00',1.79),('12664','2014-01-12','11:30:00',2.46),('12664','2014-01-12','11:35:00',2.2),('12664','2014-01-12','11:40:00',1.41),('12664','2014-01-12','11:45:00',1.97),('12664','2014-01-12','11:50:00',2.29),('12664','2014-01-12','11:55:00',1.63),('12664','2014-01-12','12:00:00',1.65),('12664','2014-01-12','12:05:00',1.37),('12664','2014-01-12','12:10:00',1.23),('12664','2014-01-12','12:15:00',1.19),('12664','2014-01-12','12:20:00',1.14),('12664','2014-01-12','12:25:00',1.1),('12664','2014-01-12','12:30:00',1.08),('12664','2014-01-12','12:35:00',1.02),('12664','2014-01-12','13:20:00',1.04),('12664','2014-01-12','13:25:00',1.09),('12664','2014-01-12','13:30:00',1.27),('12664','2014-01-12','13:35:00',1.22),('12664','2014-01-12','13:40:00',1.2),('12664','2014-01-12','13:45:00',1.12),('12664','2014-01-12','13:50:00',1.05),('12664','2014-01-12','13:55:00',1),('12664','2014-01-11','09:45:00',1.25),('12664','2014-01-11','09:50:00',1.41),('12664','2014-01-11','09:55:00',1.4),('12664','2014-01-11','10:00:00',1.25),('12664','2014-01-11','10:05:00',1.41),('12664','2014-01-11','10:10:00',1.79),('12664','2014-01-11','10:15:00',1.73),('12664','2014-01-11','10:20:00',1.81),('12664','2014-01-11','10:25:00',1.73),('12664','2014-01-11','10:30:00',1.94),('12664','2014-01-11','10:35:00',2.14),('12664','2014-01-11','10:40:00',2.42),('12664','2014-01-11','10:45:00',2.52),('12664','2014-01-11','10:50:00',2.58),('12664','2014-01-11','10:55:00',2.64),('12664','2014-01-11','11:00:00',2.66),('12664','2014-01-11','11:05:00',2.26),('12664','2014-01-11','11:10:00',2),('12664','2014-01-11','11:15:00',2.01),('12664','2014-01-11','11:20:00',2.09),('12664','2014-01-11','11:25:00',1.86),('12664','2014-01-11','11:30:00',2.14),('12664','2014-01-11','11:35:00',2.3),('12664','2014-01-11','11:40:00',2.07),('12664','2014-01-11','11:45:00',2.05),('12664','2014-01-11','11:50:00',2.18),('12664','2014-01-11','11:55:00',2.23),('12664','2014-01-11','12:00:00',2.07),('12664','2014-01-11','12:05:00',2.2),('12664','2014-01-11','12:10:00',2.78),('12664','2014-01-11','12:15:00',2.53),('12664','2014-01-11','12:20:00',1.44),('12664','2014-01-11','12:25:00',1.84),('12664','2014-01-11','12:30:00',1.7),('12664','2014-01-11','12:35:00',1.8),('12664','2014-01-11','12:40:00',2.14),('12664','2014-01-11','12:45:00',1.26),('12664','2014-01-11','12:50:00',1.66),('12664','2014-01-11','12:55:00',1.79),('12664','2014-01-11','13:00:00',1.92),('12664','2014-01-11','13:05:00',1.66),('12664','2014-01-11','13:10:00',1.58),('12664','2014-01-11','13:15:00',1.9),('12664','2014-01-11','13:20:00',1.77),('12664','2014-01-11','13:25:00',1.49),('12664','2014-01-11','13:30:00',1.68),('12664','2014-01-11','13:35:00',1.11),('12664','2014-01-11','13:40:00',1.09),('12664','2014-01-11','13:50:00',1.09),('12664','2014-01-11','13:55:00',1.19),('12664','2014-01-11','14:00:00',1.24),('12664','2014-01-09','09:55:00',1.09),('12664','2014-01-09','10:00:00',1.03),('12664','2014-01-09','10:35:00',1.11),('12664','2014-01-09','10:40:00',1.11),('12664','2014-01-09','10:45:00',1.23),('12664','2014-01-09','10:50:00',1.24),('12664','2014-01-09','10:55:00',1.2),('12664','2014-01-09','11:00:00',1.31),('12664','2014-01-09','11:05:00',1.35),('12664','2014-01-09','11:10:00',1.36),('12664','2014-01-09','11:15:00',1.43),('12664','2014-01-09','11:20:00',1.42),('12664','2014-01-09','11:25:00',1.43),('12664','2014-01-09','11:30:00',1.51),('12664','2014-01-09','11:35:00',1.54),('12664','2014-01-09','11:40:00',1.74),('12664','2014-01-09','11:45:00',1.71),('12664','2014-01-09','11:50:00',1.44),('12664','2014-01-09','11:55:00',1.37),('12664','2014-01-09','12:00:00',1.33),('12664','2014-01-09','12:05:00',1.42),('12664','2014-01-09','12:10:00',1.26),('12664','2014-01-09','12:15:00',1.32),('12664','2014-01-09','12:20:00',1.36),('12664','2014-01-09','12:25:00',1.36),('12664','2014-01-09','12:30:00',1.36),('12664','2014-01-09','12:35:00',1.32),('12664','2014-01-09','12:40:00',1.31),('12664','2014-01-09','12:45:00',1.65),('12664','2014-01-09','12:50:00',1.38),('12664','2014-01-09','12:55:00',1.38),('12664','2014-01-09','13:00:00',1.32),('12664','2014-01-09','13:05:00',1.37),('12664','2014-01-09','13:10:00',1.66),('12664','2014-01-09','13:15:00',1.66),('12664','2014-01-09','13:20:00',1.54),('12664','2014-01-09','13:25:00',1.52),('12664','2014-01-09','13:30:00',1.38),('12664','2014-01-09','13:35:00',1.48),('12664','2014-01-09','13:40:00',1.23),('12664','2014-01-09','13:45:00',1.05),('12664','2014-01-09','14:10:00',1.19),('12664','2014-01-09','14:15:00',1.04),('12664','2014-01-09','14:25:00',1.12),('12664','2014-01-08','08:55:00',1.14),('12664','2014-01-08','09:00:00',1.23),('12664','2014-01-08','09:05:00',1.34),('12664','2014-01-08','09:10:00',1.42),('12664','2014-01-08','09:15:00',1.46),('12664','2014-01-08','09:20:00',1.56),('12664','2014-01-08','09:25:00',1.62),('12664','2014-01-08','09:30:00',1.61),('12664','2014-01-08','09:35:00',1.81),('12664','2014-01-08','09:40:00',1.84),('12664','2014-01-08','09:45:00',1.92),('12664','2014-01-08','09:50:00',2.01),('12664','2014-01-08','09:55:00',1.96),('12664','2014-01-08','10:00:00',1.82),('12664','2014-01-08','10:05:00',1.96),('12664','2014-01-08','10:10:00',2.13),('12664','2014-01-08','10:15:00',2.26),('12664','2014-01-08','10:20:00',2.32),('12664','2014-01-08','10:25:00',2.35),('12664','2014-01-08','10:30:00',2.33),('12664','2014-01-08','10:35:00',2.3),('12664','2014-01-08','10:40:00',2.34),('12664','2014-01-08','10:45:00',2.44),('12664','2014-01-08','10:50:00',2.47),('12664','2014-01-08','10:55:00',2.51),('12664','2014-01-08','11:00:00',2.56),('12664','2014-01-08','11:05:00',2.57),('12664','2014-01-08','11:10:00',2.61),('12664','2014-01-08','11:15:00',2.61),('12664','2014-01-08','11:20:00',2.6),('12664','2014-01-08','11:25:00',2.71),('12664','2014-01-08','11:30:00',2.78),('12664','2014-01-08','11:35:00',2.82),('12664','2014-01-08','11:40:00',2.75),('12664','2014-01-08','11:45:00',2.79),('12664','2014-01-08','11:50:00',2.72),('12664','2014-01-08','11:55:00',2.71),('12664','2014-01-08','12:00:00',2.71),('12664','2014-01-08','12:05:00',2.76),('12664','2014-01-08','12:10:00',2.76),('12664','2014-01-08','12:15:00',2.81),('12664','2014-01-08','12:20:00',2.77),('12664','2014-01-08','12:25:00',2.78),('12664','2014-01-08','12:30:00',2.78),('12664','2014-01-08','12:35:00',2.66),('12664','2014-01-08','12:40:00',2.52),('12664','2014-01-08','12:45:00',2.65),('12664','2014-01-08','12:50:00',2.64),('12664','2014-01-08','12:55:00',2.7),('12664','2014-01-08','13:00:00',2.64),('12664','2014-01-08','13:05:00',2.59),('12664','2014-01-08','13:10:00',2.54),('12664','2014-01-08','13:15:00',2.57),('12664','2014-01-08','13:20:00',2.62),('12664','2014-01-08','13:25:00',2.56),('12664','2014-01-08','13:30:00',2.55),('12664','2014-01-08','13:35:00',2.52),('12664','2014-01-08','13:40:00',2.53),('12664','2014-01-08','13:45:00',2.37),('12664','2014-01-08','13:50:00',2.27),('12664','2014-01-08','13:55:00',2.16),('12664','2014-01-08','14:00:00',2.04),('12664','2014-01-08','14:05:00',2.08),('12664','2014-01-08','14:10:00',2.1),('12664','2014-01-08','14:15:00',2.21),('12664','2014-01-08','14:20:00',2.01),('12664','2014-01-08','14:25:00',1.97),('12664','2014-01-08','14:30:00',1.91),('12664','2014-01-08','14:35:00',1.79),('12664','2014-01-08','14:40:00',1.68),('12664','2014-01-08','14:45:00',1.62),('12664','2014-01-08','14:50:00',1.36),('12664','2014-01-08','14:55:00',1.3),('12664','2014-01-08','15:00:00',1.22),('12664','2014-01-08','15:05:00',1.14),('12664','2014-01-08','15:10:00',1.01),('12664','2014-01-08','15:15:00',1.13),('12664','2014-01-08','15:20:00',1.15),('12664','2014-01-08','15:25:00',1.08),('12664','2014-01-08','15:30:00',1.03),('12664','2014-01-08','15:35:00',1.08),('12664','2014-01-07','08:45:00',1.05),('12664','2014-01-07','08:50:00',1.13),('12664','2014-01-07','08:55:00',1.22),('12664','2014-01-07','09:00:00',1.29),('12664','2014-01-07','09:05:00',1.36),('12664','2014-01-07','09:10:00',1.44),('12664','2014-01-07','09:15:00',1.51),('12664','2014-01-07','09:20:00',1.58),('12664','2014-01-07','09:25:00',1.68),('12664','2014-01-07','09:30:00',1.75),('12664','2014-01-07','09:35:00',1.82),('12664','2014-01-07','09:40:00',1.9),('12664','2014-01-07','09:45:00',1.97),('12664','2014-01-07','09:50:00',2.05),('12664','2014-01-07','09:55:00',2.12),('12664','2014-01-07','10:00:00',2.18),('12664','2014-01-07','10:05:00',2.25),('12664','2014-01-07','10:10:00',2.29),('12664','2014-01-07','10:15:00',2.33),('12664','2014-01-07','10:20:00',2.39),('12664','2014-01-07','10:25:00',2.44),('12664','2014-01-07','10:30:00',2.43),('12664','2014-01-07','10:35:00',2.51),('12664','2014-01-07','10:40:00',2.51),('12664','2014-01-07','10:45:00',2.5),('12664','2014-01-07','10:50:00',2.58),('12664','2014-01-07','10:55:00',2.58),('12664','2014-01-07','11:00:00',2.63),('12664','2014-01-07','11:05:00',2.67),('12664','2014-01-07','11:10:00',2.7),('12664','2014-01-07','11:15:00',2.72),('12664','2014-01-07','11:20:00',2.75),('12664','2014-01-07','11:25:00',2.78),('12664','2014-01-07','11:30:00',2.83),('12664','2014-01-07','11:35:00',2.87),('12664','2014-01-07','11:40:00',2.89),('12664','2014-01-07','11:45:00',2.9),('12664','2014-01-07','11:50:00',2.85),('12664','2014-01-07','11:55:00',2.92),('12664','2014-01-07','12:00:00',2.93),('12664','2014-01-07','12:05:00',2.91),('12664','2014-01-07','12:10:00',2.94),('12664','2014-01-07','12:15:00',2.93),('12664','2014-01-07','12:20:00',2.94),('12664','2014-01-07','12:25:00',2.94),('12664','2014-01-07','12:30:00',2.93),('12664','2014-01-07','12:35:00',2.94),('12664','2014-01-07','12:40:00',2.86),('12664','2014-01-07','12:45:00',2.89),('12664','2014-01-07','12:50:00',2.92),('12664','2014-01-07','12:55:00',2.89),('12664','2014-01-07','13:00:00',2.82),('12664','2014-01-07','13:05:00',2.8),('12664','2014-01-07','13:10:00',2.69),('12664','2014-01-07','13:15:00',2.6),('12664','2014-01-07','13:20:00',2.6),('12664','2014-01-07','13:25:00',2.58),('12664','2014-01-07','13:30:00',2.57),('12664','2014-01-07','13:35:00',2.41),('12664','2014-01-07','13:40:00',2.51),('12664','2014-01-07','13:45:00',2.48),('12664','2014-01-07','13:50:00',2.45),('12664','2014-01-07','13:55:00',2.38),('12664','2014-01-07','14:00:00',2.29),('12664','2014-01-07','14:05:00',2.17),('12664','2014-01-07','14:10:00',2.19),('12664','2014-01-07','14:15:00',2.14),('12664','2014-01-07','14:20:00',2.12),('12664','2014-01-07','14:25:00',2.11),('12664','2014-01-07','14:30:00',2.02),('12664','2014-01-07','14:35:00',2.01),('12664','2014-01-07','14:40:00',1.96),('12664','2014-01-07','14:45:00',1.71),('12664','2014-01-07','14:50:00',1.75),('12664','2014-01-07','14:55:00',1.65),('12664','2014-01-07','15:00:00',1.66),('12664','2014-01-07','15:05:00',1.59),('12664','2014-01-07','15:10:00',1.47),('12664','2014-01-07','15:15:00',1.41),('12664','2014-01-07','15:20:00',1.26),('12664','2014-01-07','15:25:00',1.17),('12664','2014-01-07','15:30:00',1.03),('12664','2014-01-06','10:35:00',1.05),('12664','2014-01-06','10:40:00',1.05),('12664','2014-01-06','10:50:00',1.04),('12664','2014-01-06','10:55:00',1.03),('12664','2014-01-06','11:30:00',2.06),('12664','2014-01-06','11:35:00',2.51),('12664','2014-01-06','11:40:00',2.98),('12664','2014-01-06','11:45:00',3.01),('12664','2014-01-06','11:50:00',2.91),('12664','2014-01-06','11:55:00',2.98),('12664','2014-01-06','12:00:00',2.97),('12664','2014-01-06','12:05:00',2.93),('12664','2014-01-06','12:10:00',2.67),('12664','2014-01-06','12:15:00',1.03),('12664','2014-01-06','12:20:00',2.76),('12664','2014-01-06','12:25:00',2.88),('12664','2014-01-06','12:30:00',2.8),('12664','2014-01-06','12:35:00',2.8),('12664','2014-01-06','12:40:00',2.81),('12664','2014-01-06','12:45:00',2.77),('12664','2014-01-06','12:50:00',2.73),('12664','2014-01-06','12:55:00',2.73),('12664','2014-01-06','13:00:00',2.72),('12664','2014-01-06','13:05:00',2.73),('12664','2014-01-06','13:10:00',2.75),('12664','2014-01-06','13:15:00',2.73),('12664','2014-01-06','13:20:00',2.7),('12664','2014-01-06','13:25:00',2.7),('12664','2014-01-06','13:30:00',2.69),('12664','2014-01-06','13:35:00',2.22),('12664','2014-01-06','13:40:00',2.12),('12664','2014-01-06','13:45:00',2.29),('12664','2014-01-06','13:50:00',2.56),('12664','2014-01-06','13:55:00',2.48),('12664','2014-01-06','14:00:00',2.43),('12664','2014-01-06','14:05:00',2.37),('12664','2014-01-06','14:10:00',2.28),('12664','2014-01-06','14:15:00',2.22),('12664','2014-01-06','14:20:00',2.17),('12664','2014-01-06','14:25:00',2.56),('12664','2014-01-06','14:30:00',2.58),('12664','2014-01-06','14:35:00',2.25),('12664','2014-01-06','14:40:00',2),('12664','2014-01-06','14:45:00',2.31),('12664','2014-01-06','14:50:00',2.17),('12664','2014-01-06','14:55:00',1.9),('12664','2014-01-06','15:00:00',1.79),('12664','2014-01-06','15:05:00',1.66),('12664','2014-01-06','15:10:00',1.36),('12664','2014-01-06','15:20:00',1.4),('12664','2014-01-06','15:25:00',1.21),('12664','2014-01-06','15:35:00',1.24),('12664','2014-01-06','15:40:00',1.12),('12664','2014-01-06','15:45:00',1.05),('12664','2014-04-23','10:50:00',1.03),('12664','2014-04-23','10:55:00',1.1),('12664','2014-04-23','11:00:00',1.11),('12664','2014-04-23','11:05:00',1.09),('12664','2014-04-23','11:10:00',1.09),('12664','2014-04-23','11:15:00',1.01),('12664','2014-04-23','13:25:00',1.03),('12664','2014-04-23','13:30:00',1.06),('12664','2014-04-23','13:35:00',1.21),('12664','2014-04-23','13:40:00',1.32),('12664','2014-04-23','13:45:00',1.43),('12664','2014-04-23','13:50:00',1.41),('12664','2014-04-23','13:55:00',1.35),('12664','2014-04-23','14:00:00',1.4),('12664','2014-04-23','14:05:00',1.4),('12664','2014-04-23','14:10:00',1.39),('12664','2014-04-23','14:15:00',1.35),('12664','2014-04-23','14:20:00',1.3),('12664','2014-04-23','14:25:00',1.24),('12664','2014-04-23','14:30:00',1.18),('12664','2014-04-23','14:35:00',1.03),('12664','2014-04-23','15:25:00',1.02),('12664','2014-04-23','15:30:00',1.07),('12664','2014-04-23','15:35:00',1.06),('12664','2014-01-03','08:40:00',1.07),('12664','2014-01-03','08:45:00',1.19),('12664','2014-01-03','08:50:00',1.18),('12664','2014-01-03','08:55:00',1.21),('12664','2014-01-03','09:00:00',1.3),('12664','2014-01-03','09:05:00',1.4),('12664','2014-01-03','09:10:00',1.51),('12664','2014-01-03','09:15:00',1.68),('12664','2014-01-03','09:20:00',1.94),('12664','2014-01-03','09:25:00',2.09),('12664','2014-01-03','09:30:00',1.98),('12664','2014-01-03','09:35:00',1.08),('12664','2014-01-03','09:45:00',1.51),('12664','2014-01-03','09:50:00',1.86),('12664','2014-01-03','09:55:00',2.4),('12664','2014-01-03','10:00:00',2.61),('12664','2014-01-03','10:05:00',2.32),('12664','2014-01-03','10:10:00',1.41),('12664','2014-01-03','10:15:00',1.13),('12664','2014-01-03','10:20:00',1.02),('12664','2014-01-03','10:25:00',1.08),('12664','2014-01-03','10:30:00',1.09),('12664','2014-01-03','10:35:00',1.08),('12664','2014-01-03','10:40:00',1.51),('12664','2014-01-03','10:45:00',1.18),('12664','2014-01-03','10:50:00',1.06),('12664','2014-01-03','11:00:00',1.04),('12664','2014-01-03','11:05:00',1.08),('12664','2014-01-03','11:50:00',1.17),('12664','2014-01-03','11:55:00',1.26),('12664','2014-01-03','12:00:00',1.64),('12664','2014-01-03','12:05:00',2.53),('12664','2014-01-03','12:10:00',2.64),('12664','2014-01-03','12:15:00',2.86),('12664','2014-01-03','12:20:00',2.99),('12664','2014-01-03','12:25:00',2.26),('12664','2014-01-03','12:30:00',2.08),('12664','2014-01-03','12:35:00',2.16),('12664','2014-01-03','12:40:00',2.45),('12664','2014-01-03','12:45:00',1.71),('12664','2014-01-03','12:50:00',2.63),('12664','2014-01-03','12:55:00',2.42),('12664','2014-01-03','13:00:00',1.99),('12664','2014-01-03','13:05:00',1.98),('12664','2014-01-03','13:10:00',1.58),('12664','2014-01-03','13:15:00',1.46),('12664','2014-01-03','13:20:00',1.65),('12664','2014-01-03','13:25:00',1.75),('12664','2014-01-03','13:30:00',1.42),('12664','2014-01-03','13:35:00',1.4),('12664','2014-01-03','13:40:00',1.37),('12664','2014-01-03','13:45:00',1.21),('12664','2014-01-03','13:50:00',1.04),('12664','2014-01-02','08:45:00',1),('12664','2014-01-02','08:50:00',1.14),('12664','2014-01-02','08:55:00',1.22),('12664','2014-01-02','09:00:00',1.31),('12664','2014-01-02','09:05:00',1.37),('12664','2014-01-02','09:10:00',1.46),('12664','2014-01-02','09:15:00',1.55),('12664','2014-01-02','09:20:00',1.63),('12664','2014-01-02','09:25:00',1.71),('12664','2014-01-02','09:30:00',1.79),('12664','2014-01-02','09:35:00',1.86),('12664','2014-01-02','09:40:00',1.94),('12664','2014-01-02','09:45:00',2.01),('12664','2014-01-02','09:50:00',2.08),('12664','2014-01-02','09:55:00',2.14),('12664','2014-01-02','10:00:00',2.19),('12664','2014-01-02','10:05:00',2.26),('12664','2014-01-02','10:10:00',2.34),('12664','2014-01-02','10:15:00',2.36),('12664','2014-01-02','10:20:00',2.41),('12664','2014-01-02','10:25:00',2.48),('12664','2014-01-02','10:30:00',2.52),('12664','2014-01-02','10:35:00',2.58),('12664','2014-01-02','10:40:00',2.63),('12664','2014-01-02','10:45:00',2.69),('12664','2014-01-02','10:50:00',1.53),('12664','2014-01-02','10:55:00',1.63),('12664','2014-01-02','11:00:00',1.66),('12664','2014-01-02','11:05:00',1.67),('12664','2014-01-02','11:10:00',1.39),('12664','2014-01-02','11:15:00',1.26),('12664','2014-01-02','11:20:00',1.38),('12664','2014-01-02','11:25:00',1.44),('12664','2014-01-02','11:30:00',1.57),('12664','2014-01-02','11:35:00',1.49),('12664','2014-01-02','11:40:00',1.3),('12664','2014-01-02','11:45:00',1.28),('12664','2014-01-02','11:50:00',1.14),('12664','2014-01-02','11:55:00',1.15),('12664','2014-01-02','12:00:00',1.08),('12664','2014-01-02','12:35:00',1.09),('12664','2014-01-02','12:40:00',1.33),('12664','2014-01-02','12:45:00',1.65),('12664','2014-01-02','12:50:00',3.16),('12664','2014-01-02','12:55:00',2.45),('12664','2014-01-02','13:00:00',1.09),('12664','2014-01-02','13:10:00',1.33),('12664','2014-01-02','13:25:00',1.02),('12664','2014-01-01','08:40:00',1.02),('12664','2014-01-01','08:50:00',1.02),('12664','2014-01-01','11:15:00',1.05),('12664','2014-01-01','11:20:00',1.03),('12664','2014-01-01','11:25:00',1.02),('12664','2014-01-01','11:30:00',1.03),('12664','2014-01-01','11:35:00',1.13),('12664','2014-01-01','11:40:00',1.19),('12664','2014-01-01','11:45:00',1.23),('12664','2014-01-01','11:50:00',1.26),('12664','2014-01-01','11:55:00',1.25),('12664','2014-01-01','12:00:00',1.29),('12664','2014-01-01','12:05:00',1.32),('12664','2014-01-01','12:10:00',1.35),('12664','2014-01-01','12:15:00',1.26),('12664','2014-01-01','12:20:00',1.33),('12664','2014-01-01','12:25:00',1.47),('12664','2014-01-01','12:30:00',1.97),('12664','2014-01-01','12:35:00',3.48),('12664','2014-01-01','12:40:00',2.14),('12664','2014-01-01','12:45:00',1.38),('12664','2014-01-01','12:50:00',1.31),('12664','2014-01-01','12:55:00',1.38),('12664','2014-01-01','13:00:00',1.24),('12664','2014-01-01','13:05:00',1.12),('12664','2014-01-01','13:10:00',1.21),('12664','2014-01-01','13:15:00',1.3),('12664','2014-01-01','13:20:00',1.23),('12664','2014-01-01','13:25:00',1.47),('12664','2014-01-01','13:30:00',1.68),('12664','2014-01-01','13:35:00',3.03),('12664','2014-01-01','13:40:00',2.96),('12664','2014-01-01','13:45:00',2.79),('12664','2014-01-01','13:50:00',2.59),('12664','2014-01-01','13:55:00',1.85),('12664','2014-01-01','14:00:00',2.56),('12664','2014-01-01','14:05:00',1.76),('12664','2014-01-01','14:10:00',2.15),('12664','2014-01-01','14:15:00',1.46),('12664','2014-01-01','14:20:00',1.13),('12664','2014-01-01','14:35:00',1.04),('12664','2014-01-01','14:40:00',1.03),('12664','2014-01-01','15:00:00',1.43),('12664','2014-01-01','15:05:00',1.53),('12664','2014-01-01','15:10:00',1.42),('12664','2014-01-01','15:15:00',1.29),('12664','2014-01-01','15:20:00',1.18),('12664','2014-01-01','15:25:00',1.06),('12664','2013-12-31','08:45:00',1.23),('12664','2013-12-31','08:50:00',1.38),('12664','2013-12-31','08:55:00',1.52),('12664','2013-12-31','09:00:00',1.57),('12664','2013-12-31','09:05:00',1.59),('12664','2013-12-31','09:10:00',1.63),('12664','2013-12-31','09:15:00',1.72),('12664','2013-12-31','09:20:00',1.81),('12664','2013-12-31','09:25:00',1.99),('12664','2013-12-31','09:30:00',1.67),('12664','2013-12-31','09:35:00',1.43),('12664','2013-12-31','10:10:00',1.08),('12664','2013-12-31','11:05:00',1.17),('12664','2013-12-31','11:10:00',1.24),('12664','2013-12-31','11:15:00',1.26),('12664','2013-12-31','11:20:00',1.37),('12664','2013-12-31','11:25:00',1.96),('12664','2013-12-31','11:30:00',1.49),('12664','2013-12-31','11:35:00',1.78),('12664','2013-12-31','11:40:00',2.21),('12664','2013-12-31','11:45:00',2.77),('12664','2013-12-31','11:50:00',2.27),('12664','2013-12-31','11:55:00',3.16),('12664','2013-12-31','12:00:00',3.03),('12664','2013-12-31','12:05:00',2.98),('12664','2013-12-31','12:10:00',2.94),('12664','2013-12-31','12:15:00',2.93),('12664','2013-12-31','12:20:00',2.94),('12664','2013-12-31','12:25:00',2.91),('12664','2013-12-31','12:30:00',2.89),('12664','2013-12-31','12:35:00',2.88),('12664','2013-12-31','12:40:00',2.88),('12664','2013-12-31','12:45:00',2.86),('12664','2013-12-31','12:50:00',2.84),('12664','2013-12-31','12:55:00',2.81),('12664','2013-12-31','13:00:00',2.78),('12664','2013-12-31','13:05:00',2.76),('12664','2013-12-31','13:10:00',2.74),('12664','2013-12-31','13:15:00',2.72),('12664','2013-12-31','13:20:00',2.66),('12664','2013-12-31','13:25:00',2.61),('12664','2013-12-31','13:30:00',2.58),('12664','2013-12-31','13:35:00',2.56),('12664','2013-12-31','13:40:00',2.52),('12664','2013-12-31','13:45:00',2.47),('12664','2013-12-31','13:50:00',2.4),('12664','2013-12-31','13:55:00',2.37),('12664','2013-12-31','14:00:00',2.32),('12664','2013-12-31','14:05:00',2.26),('12664','2013-12-31','14:10:00',2.2),('12664','2013-12-31','14:15:00',2.14),('12664','2013-12-31','14:20:00',2.08),('12664','2013-12-31','14:25:00',2.03),('12664','2013-12-31','14:30:00',1.96),('12664','2013-12-31','14:35:00',1.9),('12664','2013-12-31','14:40:00',1.82),('12664','2013-12-31','14:45:00',1.75),('12664','2013-12-31','14:50:00',1.69),('12664','2013-12-31','14:55:00',1.58),('12664','2013-12-31','15:00:00',1.5),('12664','2013-12-31','15:05:00',1.42),('12664','2013-12-31','15:10:00',1.35),('12664','2013-12-31','15:15:00',1.28),('12664','2013-12-31','15:20:00',1.21),('12664','2013-12-31','15:25:00',1.13),('12664','2013-12-31','15:30:00',1.04),('12664','2013-12-29','09:00:00',1.12),('12664','2013-12-29','09:05:00',1.21),('12664','2013-12-29','09:10:00',1.38),('12664','2013-12-29','09:15:00',1.47),('12664','2013-12-29','09:20:00',1.56),('12664','2013-12-29','09:25:00',1.45),('12664','2013-12-29','09:30:00',1.22),('12664','2013-12-29','09:35:00',1.24),('12664','2013-12-29','09:45:00',1.19),('12664','2013-12-29','09:50:00',1.96),('12664','2013-12-29','09:55:00',1.42),('12664','2013-12-29','10:00:00',1.39),('12664','2013-12-29','10:05:00',2.32),('12664','2013-12-29','10:10:00',2.56),('12664','2013-12-29','10:15:00',2.32),('12664','2013-12-29','10:20:00',1.39),('12664','2013-12-29','10:25:00',2.28),('12664','2013-12-29','10:30:00',1.61),('12664','2013-12-29','10:35:00',1.58),('12664','2013-12-29','10:40:00',2.91),('12664','2013-12-29','10:45:00',3.12),('12664','2013-12-29','10:50:00',2.42),('12664','2013-12-29','10:55:00',1.61),('12664','2013-12-29','11:00:00',2.46),('12664','2013-12-29','11:05:00',1.55),('12664','2013-12-29','11:10:00',2.73),('12664','2013-12-29','11:15:00',2.71),('12664','2013-12-29','11:20:00',1.41),('12664','2013-12-29','11:25:00',1.46),('12664','2013-12-29','11:30:00',1.11),('12664','2013-12-29','11:35:00',1.09),('12664','2013-12-28','08:40:00',1.01),('12664','2013-12-28','08:45:00',1.1),('12664','2013-12-28','08:50:00',1.18),('12664','2013-12-28','08:55:00',1.26),('12664','2013-12-28','09:00:00',1.33),('12664','2013-12-28','09:05:00',1.43),('12664','2013-12-28','09:10:00',1.52),('12664','2013-12-28','09:15:00',1.62),('12664','2013-12-28','09:20:00',1.69),('12664','2013-12-28','09:25:00',1.77),('12664','2013-12-28','09:30:00',1.86),('12664','2013-12-28','09:35:00',1.94),('12664','2013-12-28','09:40:00',2),('12664','2013-12-28','09:45:00',2.06),('12664','2013-12-28','09:50:00',2.11),('12664','2013-12-28','09:55:00',2.16),('12664','2013-12-28','10:00:00',2.23),('12664','2013-12-28','10:05:00',2.3),('12664','2013-12-28','10:10:00',2.37),('12664','2013-12-28','10:15:00',2.42),('12664','2013-12-28','10:20:00',2.47),('12664','2013-12-28','10:25:00',2.52),('12664','2013-12-28','10:30:00',2.56),('12664','2013-12-28','10:35:00',2.6),('12664','2013-12-28','10:40:00',2.64),('12664','2013-12-28','10:45:00',2.68),('12664','2013-12-28','10:50:00',2.71),('12664','2013-12-28','10:55:00',2.74),('12664','2013-12-28','11:00:00',2.74),('12664','2013-12-28','11:05:00',2.79),('12664','2013-12-28','11:10:00',2.8),('12664','2013-12-28','11:15:00',2.81),('12664','2013-12-28','11:20:00',2.8),('12664','2013-12-28','11:25:00',2.84),('12664','2013-12-28','11:30:00',2.87),('12664','2013-12-28','11:35:00',2.87),('12664','2013-12-28','11:40:00',2.88),('12664','2013-12-28','11:45:00',2.9),('12664','2013-12-28','11:50:00',2.89),('12664','2013-12-28','11:55:00',2.94),('12664','2013-12-28','12:00:00',2.93),('12664','2013-12-28','12:05:00',2.92),('12664','2013-12-28','12:10:00',2.9),('12664','2013-12-28','12:15:00',2.92),('12664','2013-12-28','12:20:00',2.92),('12664','2013-12-28','12:25:00',2.88),('12664','2013-12-28','12:30:00',2.87),('12664','2013-12-28','12:35:00',2.82),('12664','2013-12-28','12:40:00',2.79),('12664','2013-12-28','12:45:00',2.76),('12664','2013-12-28','12:50:00',2.74),('12664','2013-12-28','12:55:00',2.74),('12664','2013-12-28','13:00:00',2.72),('12664','2013-12-28','13:05:00',2.68),('12664','2013-12-28','13:10:00',2.67),('12664','2013-12-28','13:15:00',2.68),('12664','2013-12-28','13:20:00',2.6),('12664','2013-12-28','13:25:00',2.56),('12664','2013-12-28','13:30:00',2.53),('12664','2013-12-28','13:35:00',2.49),('12664','2013-12-28','13:40:00',2.47),('12664','2013-12-28','13:45:00',2.44),('12664','2013-12-28','13:50:00',2.38),('12664','2013-12-28','13:55:00',2.35),('12664','2013-12-28','14:00:00',2.29),('12664','2013-12-28','14:05:00',2.24),('12664','2013-12-28','14:10:00',2.2),('12664','2013-12-28','14:15:00',2.15),('12664','2013-12-28','14:20:00',2.08),('12664','2013-12-28','14:25:00',2.02),('12664','2013-12-28','14:30:00',2),('12664','2013-12-28','14:35:00',1.74),('12664','2013-12-28','14:40:00',1.31),('12664','2013-12-28','14:45:00',1.51),('12664','2013-12-28','14:50:00',1.64),('12664','2013-12-28','14:55:00',1.73),('12664','2013-12-28','15:00:00',1.63),('12664','2013-12-28','15:05:00',1.52),('12664','2013-12-28','15:10:00',1.41),('12664','2013-12-28','15:15:00',1.33),('12664','2013-12-28','15:20:00',1.25),('12664','2013-12-28','15:25:00',1.09),('12664','2013-12-28','15:30:00',1.08),('12664','2013-12-27','11:45:00',1.04),('12664','2013-12-27','11:50:00',1.3),('12664','2013-12-27','11:55:00',1.49),('12664','2013-12-27','12:00:00',2.11),('12664','2013-12-27','12:05:00',1.92),('12664','2013-12-27','12:10:00',1.48),('12664','2013-12-27','12:35:00',1.29),('12664','2013-12-27','12:40:00',2.08),('12664','2013-12-27','12:45:00',2.15),('12664','2013-12-27','12:50:00',2.02),('12664','2013-12-27','12:55:00',2.33),('12664','2013-12-27','13:00:00',2.66),('12664','2013-12-27','13:05:00',2.7),('12664','2013-12-27','13:10:00',2.65),('12664','2013-12-27','13:15:00',2.59),('12664','2013-12-27','13:20:00',2.64),('12664','2013-12-27','13:25:00',2.48),('12664','2013-12-27','13:30:00',1.67),('12664','2013-12-27','13:35:00',1.43),('12664','2013-12-27','13:40:00',1.25),('12664','2013-12-27','13:45:00',1.17),('12664','2013-12-27','13:50:00',1.21),('12664','2013-12-27','13:55:00',1.33),('12664','2013-12-27','14:00:00',1.82),('12664','2013-12-27','14:05:00',2.37),('12664','2013-12-27','14:10:00',1.9),('12664','2013-12-27','14:15:00',1.16),('12664','2013-12-27','14:20:00',1.12),('12664','2013-12-27','14:25:00',1.14),('12664','2013-12-27','14:30:00',1.21),('12664','2013-12-27','14:35:00',1.35),('12664','2014-04-22','08:05:00',1.03),('12664','2014-04-22','08:10:00',1.13),('12664','2014-04-22','08:15:00',1.22),('12664','2014-04-22','08:20:00',1.32),('12664','2014-04-22','08:25:00',1.42),('12664','2014-04-22','08:30:00',1.49),('12664','2014-04-22','08:35:00',1.51),('12664','2014-04-22','08:40:00',1.51),('12664','2014-04-22','08:45:00',1.71),('12664','2014-04-22','08:50:00',1.8),('12664','2014-04-22','08:55:00',1.7),('12664','2014-04-22','09:00:00',1.89),('12664','2014-04-22','09:05:00',1.69),('12664','2014-04-22','09:10:00',1.97),('12664','2014-04-22','09:15:00',2.14),('12664','2014-04-22','09:20:00',2.5),('12664','2014-04-22','09:25:00',2.58),('12664','2014-04-22','09:30:00',2.43),('12664','2014-04-22','09:35:00',2.57),('12664','2014-04-22','09:40:00',2.4),('12664','2014-04-22','09:45:00',2.62),('12664','2014-04-22','09:50:00',1.08),('12664','2014-04-22','09:55:00',1.14),('12664','2014-04-22','10:00:00',1.44),('12664','2014-04-22','10:05:00',1.42),('12664','2014-04-22','10:10:00',1.52),('12664','2014-04-22','10:15:00',2.02),('12664','2014-04-22','10:20:00',2.54),('12664','2014-04-22','10:25:00',1.5),('12664','2014-04-22','10:30:00',1.87),('12664','2014-04-22','10:35:00',1.86),('12664','2014-04-22','10:40:00',2.88),('12664','2014-04-22','10:45:00',2.78),('12664','2014-04-22','10:50:00',2.5),('12664','2014-04-22','10:55:00',3.22),('12664','2014-04-22','11:00:00',3.35),('12664','2014-04-22','11:05:00',2.54),('12664','2014-04-22','11:10:00',1.66),('12664','2014-04-22','11:15:00',1.55),('12664','2014-04-22','11:20:00',1.18),('12664','2014-04-22','11:25:00',1.03),('12664','2014-04-22','11:50:00',1.1),('12664','2014-04-22','12:05:00',1.04),('12664','2014-04-22','12:10:00',1.03),('12664','2014-04-22','12:15:00',1.07),('12664','2014-04-22','12:20:00',1.11),('12664','2014-04-22','12:25:00',1.17),('12664','2014-04-22','12:30:00',1),('12664','2014-04-22','13:05:00',1.1),('12664','2014-04-22','13:10:00',1.28),('12664','2014-04-22','13:15:00',1.2),('12664','2014-04-22','13:20:00',1.22),('12664','2014-04-22','13:25:00',1.88),('12664','2014-04-22','13:30:00',2.46),('12664','2014-04-22','13:35:00',2.57),('12664','2014-04-22','13:40:00',2.69),('12664','2014-04-22','13:45:00',3.42),('12664','2014-04-22','13:50:00',2.23),('12664','2014-04-22','13:55:00',2.01),('12664','2014-04-22','14:00:00',2.14),('12664','2014-04-22','14:05:00',3.85),('12664','2014-04-22','14:10:00',3.15),('12664','2014-04-22','14:15:00',2.96),('12664','2014-04-22','14:20:00',1.69),('12664','2014-04-22','14:25:00',1.85),('12664','2014-04-22','14:30:00',2.16),('12664','2014-04-22','14:35:00',2.06),('12664','2014-04-22','14:40:00',1.6),('12664','2014-04-22','14:45:00',2.06),('12664','2014-04-22','14:50:00',2.81),('12664','2014-04-22','14:55:00',2.12),('12664','2014-04-22','15:00:00',1.41),('12664','2014-04-22','15:05:00',1.43),('12664','2014-04-22','15:10:00',1.24),('12664','2014-04-22','15:15:00',1.45),('12664','2014-04-22','15:20:00',1.53),('12664','2014-04-22','15:25:00',2.22),('12664','2014-04-22','15:30:00',2.04),('12664','2014-04-22','15:35:00',2.77),('12664','2014-04-22','15:40:00',2.47),('12664','2014-04-22','15:45:00',2.4),('12664','2014-04-22','15:50:00',2.25),('12664','2014-04-22','15:55:00',2.35),('12664','2014-04-22','16:00:00',2.67),('12664','2014-04-22','16:05:00',1.63),('12664','2014-04-22','16:10:00',1.36),('12664','2014-04-22','16:15:00',1.31),('12664','2014-04-22','16:20:00',1.37),('12664','2014-04-22','16:25:00',1.29),('12664','2014-04-22','16:30:00',1.2),('12664','2014-04-22','16:35:00',1.22),('12664','2014-04-22','16:40:00',1.26),('12664','2014-04-22','16:45:00',1.24),('12664','2014-04-22','16:50:00',1.21),('12664','2014-04-22','16:55:00',1.28),('12664','2014-04-22','17:00:00',1.57),('12664','2014-04-22','17:05:00',1.01),('12664','2013-12-25','09:05:00',1.26),('12664','2013-12-25','09:10:00',1.16),('12664','2013-12-25','10:40:00',1.05),('12664','2013-12-25','10:45:00',1.01),('12664','2013-12-25','11:05:00',1.86),('12664','2013-12-25','11:10:00',2.16),('12664','2013-12-25','11:15:00',1.38),('12664','2013-12-25','11:20:00',2.19),('12664','2013-12-25','11:25:00',1.45),('12664','2013-12-25','11:35:00',1.15),('12664','2013-12-25','11:50:00',2.21),('12664','2013-12-25','11:55:00',2.57),('12664','2013-12-25','12:00:00',1.12),('12664','2013-12-25','12:05:00',1.52),('12664','2013-12-25','12:10:00',2.06),('12664','2013-12-25','12:25:00',1),('12664','2013-12-25','12:30:00',1.93),('12664','2013-12-25','12:35:00',2.24),('12664','2013-12-25','12:40:00',1.65),('12664','2013-12-25','12:45:00',1.5),('12664','2013-12-25','12:55:00',1.06),('12664','2013-12-25','13:00:00',1.09),('12664','2013-12-25','13:35:00',1.1),('12664','2013-12-25','13:40:00',1.33),('12664','2013-12-25','13:45:00',1.3),('12664','2013-12-25','13:50:00',1.17),('12664','2013-12-25','15:10:00',1.01),('12664','2013-12-25','15:15:00',1.16),('12664','2013-12-24','08:55:00',1.04),('12664','2013-12-24','09:00:00',1.22),('12664','2013-12-24','09:05:00',1.31),('12664','2013-12-24','09:10:00',1.4),('12664','2013-12-24','09:15:00',1.47),('12664','2013-12-24','09:20:00',1.54),('12664','2013-12-24','09:25:00',1.62),('12664','2013-12-24','09:30:00',1.69),('12664','2013-12-24','09:35:00',1.74),('12664','2013-12-24','09:40:00',1.81),('12664','2013-12-24','09:45:00',1.88),('12664','2013-12-24','09:50:00',1.94),('12664','2013-12-24','09:55:00',2.01),('12664','2013-12-24','10:00:00',2.07),('12664','2013-12-24','10:05:00',2.12),('12664','2013-12-24','10:10:00',2.18),('12664','2013-12-24','10:15:00',2.22),('12664','2013-12-24','10:20:00',2.25),('12664','2013-12-24','10:25:00',2.31),('12664','2013-12-24','10:30:00',2.35),('12664','2013-12-24','10:35:00',2.37),('12664','2013-12-24','10:40:00',2.39),('12664','2013-12-24','10:45:00',2.42),('12664','2013-12-24','10:50:00',2.44),('12664','2013-12-24','10:55:00',2.46),('12664','2013-12-24','11:00:00',2.51),('12664','2013-12-24','11:05:00',2.51),('12664','2013-12-24','11:10:00',2.52),('12664','2013-12-24','11:15:00',2.56),('12664','2013-12-24','11:20:00',2.54),('12664','2013-12-24','11:25:00',2.55),('12664','2013-12-24','11:30:00',2.47),('12664','2013-12-24','11:35:00',2.47),('12664','2013-12-24','11:40:00',2.48),('12664','2013-12-24','11:45:00',2.51),('12664','2013-12-24','11:50:00',2.55),('12664','2013-12-24','11:55:00',2.6),('12664','2013-12-24','12:00:00',2.59),('12664','2013-12-24','12:05:00',2.62),('12664','2013-12-24','12:10:00',2.62),('12664','2013-12-24','12:15:00',2.61),('12664','2013-12-24','12:20:00',2.59),('12664','2013-12-24','12:25:00',2.59),('12664','2013-12-24','12:30:00',2.57),('12664','2013-12-24','12:35:00',2.56),('12664','2013-12-24','12:40:00',2.54),('12664','2013-12-24','12:45:00',2.54),('12664','2013-12-24','12:50:00',2.5),('12664','2013-12-24','12:55:00',2.39),('12664','2013-12-24','13:00:00',2.35),('12664','2013-12-24','13:05:00',2.35),('12664','2013-12-24','13:10:00',2.33),('12664','2013-12-24','13:15:00',2.23),('12664','2013-12-24','13:20:00',2.19),('12664','2013-12-24','13:25:00',2.14),('12664','2013-12-24','13:30:00',2.17),('12664','2013-12-24','13:35:00',2.13),('12664','2013-12-24','13:40:00',2.09),('12664','2013-12-24','13:45:00',2.05),('12664','2013-12-24','13:50:00',2.01),('12664','2013-12-24','13:55:00',1.96),('12664','2013-12-24','14:00:00',1.88),('12664','2013-12-24','14:05:00',1.81),('12664','2013-12-24','14:10:00',1.72),('12664','2013-12-24','14:15:00',1.65),('12664','2013-12-24','14:20:00',1.55),('12664','2013-12-24','14:25:00',1.51),('12664','2013-12-24','14:30:00',1.48),('12664','2013-12-24','14:35:00',1.46),('12664','2013-12-24','14:40:00',1.37),('12664','2013-12-24','14:45:00',1.29),('12664','2013-12-24','14:50:00',1.26),('12664','2013-12-24','14:55:00',1.21),('12664','2013-12-24','15:00:00',1.14),('12664','2013-12-24','15:05:00',1.08),('12664','2013-12-24','15:10:00',1.03),('12664','2013-12-23','09:10:00',1.06),('12664','2013-12-23','09:15:00',1.35),('12664','2013-12-23','09:20:00',1.24),('12664','2013-12-23','09:25:00',1.21),('12664','2013-12-23','09:30:00',1.33),('12664','2013-12-23','09:35:00',1.05),('12664','2013-12-23','09:40:00',1.06),('12664','2013-12-23','09:55:00',1.04),('12664','2013-12-23','10:00:00',1.17),('12664','2013-12-23','10:05:00',1.22),('12664','2013-12-23','10:10:00',1.77),('12664','2013-12-23','10:15:00',1.8),('12664','2013-12-23','10:20:00',2.13),('12664','2013-12-23','10:25:00',2.39),('12664','2013-12-23','10:30:00',2.4),('12664','2013-12-23','10:35:00',1.97),('12664','2013-12-23','10:40:00',2),('12664','2013-12-23','10:45:00',2.47),('12664','2013-12-23','10:50:00',2.46),('12664','2013-12-23','10:55:00',2.54),('12664','2013-12-23','11:00:00',2.53),('12664','2013-12-23','11:05:00',2.32),('12664','2013-12-23','11:10:00',2.58),('12664','2013-12-23','11:15:00',2.33),('12664','2013-12-23','11:20:00',2.57),('12664','2013-12-23','11:25:00',2.77),('12664','2013-12-23','11:30:00',2.99),('12664','2013-12-23','11:35:00',2.98),('12664','2013-12-23','11:40:00',2.89),('12664','2013-12-23','11:45:00',2.56),('12664','2013-12-23','11:50:00',2.89),('12664','2013-12-23','11:55:00',2.98),('12664','2013-12-23','12:00:00',2.93),('12664','2013-12-23','12:05:00',2.9),('12664','2013-12-23','12:10:00',2.85),('12664','2013-12-23','12:15:00',2.8),('12664','2013-12-23','12:20:00',2.76),('12664','2013-12-23','12:25:00',2.73),('12664','2013-12-23','12:30:00',2.67),('12664','2013-12-23','12:35:00',2.65),('12664','2013-12-23','12:40:00',2.64),('12664','2013-12-23','12:45:00',2.57),('12664','2013-12-23','12:50:00',2.57),('12664','2013-12-23','12:55:00',2.53),('12664','2013-12-23','13:00:00',2.5),('12664','2013-12-23','13:05:00',2.48),('12664','2013-12-23','13:10:00',2.49),('12664','2013-12-23','13:15:00',2.44),('12664','2013-12-23','13:20:00',2.45),('12664','2013-12-23','13:25:00',2.46),('12664','2013-12-23','13:30:00',2.44),('12664','2013-12-23','13:35:00',2.37),('12664','2013-12-23','13:40:00',2.13),('12664','2013-12-23','13:45:00',1.79),('12664','2013-12-23','13:50:00',2.27),('12664','2013-12-23','13:55:00',2.27),('12664','2013-12-23','14:00:00',2.2),('12664','2013-12-23','14:05:00',2.13),('12664','2013-12-23','14:10:00',2.07),('12664','2013-12-23','14:15:00',2.01),('12664','2013-12-23','14:20:00',1.92),('12664','2013-12-23','14:25:00',1.86),('12664','2013-12-23','14:30:00',1.79),('12664','2013-12-23','14:35:00',1.74),('12664','2013-12-23','14:40:00',1.68),('12664','2013-12-23','14:45:00',1.59),('12664','2013-12-23','14:50:00',1.52),('12664','2013-12-23','14:55:00',1.44),('12664','2013-12-23','15:00:00',1.34),('12664','2013-12-23','15:05:00',1.28),('12664','2013-12-23','15:10:00',1.21),('12664','2013-12-23','15:15:00',1.12),('12664','2013-12-23','15:20:00',1.01),('12664','2013-12-22','09:10:00',1.04),('12664','2013-12-22','09:15:00',1.22),('12664','2013-12-22','09:20:00',1.13),('12664','2013-12-22','09:25:00',1.27),('12664','2013-12-22','09:30:00',1.48),('12664','2013-12-22','09:35:00',1.96),('12664','2013-12-22','09:40:00',2.36),('12664','2013-12-22','09:45:00',2.39),('12664','2013-12-22','09:50:00',2.56),('12664','2013-12-22','09:55:00',2.67),('12664','2013-12-22','10:00:00',2.6),('12664','2013-12-22','10:05:00',2.52),('12664','2013-12-22','10:10:00',2.46),('12664','2013-12-22','10:15:00',2.58),('12664','2013-12-22','10:20:00',2.55),('12664','2013-12-22','10:25:00',2.44),('12664','2013-12-22','10:30:00',2.29),('12664','2013-12-22','10:35:00',2.23),('12664','2013-12-22','10:40:00',2.42),('12664','2013-12-22','10:45:00',2.2),('12664','2013-12-22','10:50:00',2.45),('12664','2013-12-22','10:55:00',2.54),('12664','2013-12-22','11:00:00',2.41),('12664','2013-12-22','11:05:00',2.69),('12664','2013-12-22','11:10:00',2.52),('12664','2013-12-22','11:15:00',2.53),('12664','2013-12-22','11:20:00',2.77),('12664','2013-12-22','11:25:00',2.57),('12664','2013-12-22','11:30:00',2.34),('12664','2013-12-22','11:35:00',2.66),('12664','2013-12-22','11:40:00',2.68),('12664','2013-12-22','11:45:00',2.45),('12664','2013-12-22','11:50:00',1.85),('12664','2013-12-22','11:55:00',1.61),('12664','2013-12-22','12:00:00',1.16),('12664','2013-12-22','12:20:00',1),('12664','2013-12-22','12:25:00',1.23),('12664','2013-12-22','12:30:00',1.26),('12664','2013-12-22','12:35:00',1.48),('12664','2013-12-22','12:40:00',1.7),('12664','2013-12-22','12:45:00',1.7),('12664','2013-12-22','12:50:00',1.44),('12664','2013-12-22','12:55:00',1.78),('12664','2013-12-22','13:00:00',2.6),('12664','2013-12-22','13:05:00',2.66),('12664','2013-12-22','13:10:00',2.73),('12664','2013-12-22','13:15:00',2.62),('12664','2013-12-22','13:20:00',2.25),('12664','2013-12-22','13:25:00',2.68),('12664','2013-12-22','13:30:00',2.42),('12664','2013-12-22','13:35:00',2.33),('12664','2013-12-22','13:40:00',2.22),('12664','2013-12-22','13:45:00',1.56),('12664','2013-12-22','13:50:00',1.53),('12664','2013-12-22','13:55:00',1.38),('12664','2013-12-22','14:00:00',1.49),('12664','2013-12-22','14:05:00',1.56),('12664','2013-12-22','14:10:00',1.52),('12664','2013-12-22','14:15:00',1.48),('12664','2013-12-22','14:20:00',1.13),('12664','2013-12-22','14:30:00',1.21),('12664','2013-12-22','14:35:00',1.64),('12664','2013-12-22','14:40:00',1.78),('12664','2013-12-22','14:45:00',1.62),('12664','2013-12-22','14:50:00',1.05),('12664','2013-12-22','15:10:00',1.1),('12664','2013-12-21','08:45:00',1.06),('12664','2013-12-21','08:50:00',1.16),('12664','2013-12-21','08:55:00',1.24),('12664','2013-12-21','09:00:00',1.3),('12664','2013-12-21','09:05:00',1.38),('12664','2013-12-21','09:10:00',1.45),('12664','2013-12-21','09:15:00',1.54),('12664','2013-12-21','09:20:00',1.63),('12664','2013-12-21','09:25:00',1.71),('12664','2013-12-21','09:30:00',1.79),('12664','2013-12-21','09:35:00',1.85),('12664','2013-12-21','09:40:00',1.92),('12664','2013-12-21','09:45:00',1.99),('12664','2013-12-21','09:50:00',2.05),('12664','2013-12-21','09:55:00',2.1),('12664','2013-12-21','10:00:00',2.14),('12664','2013-12-21','10:05:00',2.19),('12664','2013-12-21','10:10:00',2.23),('12664','2013-12-21','10:15:00',2.28),('12664','2013-12-21','10:20:00',2.32),('12664','2013-12-21','10:25:00',2.37),('12664','2013-12-21','10:30:00',2.42),('12664','2013-12-21','10:35:00',2.46),('12664','2013-12-21','10:40:00',2.5),('12664','2013-12-21','10:45:00',2.54),('12664','2013-12-21','10:50:00',2.57),('12664','2013-12-21','10:55:00',2.6),('12664','2013-12-21','11:00:00',2.64),('12664','2013-12-21','11:05:00',2.67),('12664','2013-12-21','11:10:00',2.72),('12664','2013-12-21','11:15:00',2.73),('12664','2013-12-21','11:20:00',2.74),('12664','2013-12-21','11:25:00',2.77),('12664','2013-12-21','11:30:00',2.78),('12664','2013-12-21','11:35:00',2.8),('12664','2013-12-21','11:40:00',2.8),('12664','2013-12-21','11:45:00',2.81),('12664','2013-12-21','11:50:00',2.83),('12664','2013-12-21','11:55:00',2.83),('12664','2013-12-21','12:00:00',2.81),('12664','2013-12-21','12:05:00',2.81),('12664','2013-12-21','12:10:00',2.81),('12664','2013-12-21','12:15:00',2.79),('12664','2013-12-21','12:20:00',2.78),('12664','2013-12-21','12:25:00',2.77),('12664','2013-12-21','12:30:00',2.75),('12664','2013-12-21','12:35:00',2.73),('12664','2013-12-21','12:40:00',2.71),('12664','2013-12-21','12:45:00',2.72),('12664','2013-12-21','12:50:00',2.71),('12664','2013-12-21','12:55:00',2.69),('12664','2013-12-21','13:00:00',2.69),('12664','2013-12-21','13:05:00',2.64),('12664','2013-12-21','13:10:00',2.61),('12664','2013-12-21','13:15:00',2.6),('12664','2013-12-21','13:20:00',2.57),('12664','2013-12-21','13:25:00',2.54),('12664','2013-12-21','13:30:00',2.52),('12664','2013-12-21','13:35:00',2.48),('12664','2013-12-21','13:40:00',2.44),('12664','2013-12-21','13:45:00',2.4),('12664','2013-12-21','13:50:00',2.37),('12664','2013-12-21','13:55:00',2.32),('12664','2013-12-21','14:00:00',2.26),('12664','2013-12-21','14:05:00',2.18),('12664','2013-12-21','14:10:00',2.11),('12664','2013-12-21','14:15:00',2.06),('12664','2013-12-21','14:20:00',2),('12664','2013-12-21','14:25:00',1.92),('12664','2013-12-21','14:30:00',1.84),('12664','2013-12-21','14:35:00',1.77),('12664','2013-12-21','14:40:00',1.69),('12664','2013-12-21','14:45:00',1.62),('12664','2013-12-21','14:50:00',1.54),('12664','2013-12-21','14:55:00',1.47),('12664','2013-12-21','15:00:00',1.4),('12664','2013-12-21','15:05:00',1.32),('12664','2013-12-21','15:10:00',1.24),('12664','2013-12-21','15:15:00',1.17),('12664','2013-12-21','15:20:00',1.08),('12664','2013-12-20','08:50:00',1.1),('12664','2013-12-20','08:55:00',1.18),('12664','2013-12-20','09:00:00',1.26),('12664','2013-12-20','09:05:00',1.36),('12664','2013-12-20','09:10:00',1.43),('12664','2013-12-20','09:15:00',1.5),('12664','2013-12-20','09:20:00',1.56),('12664','2013-12-20','09:25:00',1.62),('12664','2013-12-20','09:30:00',1.69),('12664','2013-12-20','09:35:00',1.75),('12664','2013-12-20','09:40:00',1.81),('12664','2013-12-20','09:45:00',1.89),('12664','2013-12-20','09:50:00',1.91),('12664','2013-12-20','09:55:00',1.97),('12664','2013-12-20','10:00:00',2.06),('12664','2013-12-20','10:05:00',2.11),('12664','2013-12-20','10:10:00',2.12),('12664','2013-12-20','10:15:00',2.15),('12664','2013-12-20','10:20:00',2.23),('12664','2013-12-20','10:25:00',2.3),('12664','2013-12-20','10:30:00',2.34),('12664','2013-12-20','10:35:00',2.35),('12664','2013-12-20','10:40:00',2.37),('12664','2013-12-20','10:45:00',2.43),('12664','2013-12-20','10:50:00',2.46),('12664','2013-12-20','10:55:00',2.5),('12664','2013-12-20','11:00:00',2.53),('12664','2013-12-20','11:05:00',2.56),('12664','2013-12-20','11:10:00',2.59),('12664','2013-12-20','11:15:00',2.58),('12664','2013-12-20','11:20:00',2.58),('12664','2013-12-20','11:25:00',2.63),('12664','2013-12-20','11:30:00',2.62),('12664','2013-12-20','11:35:00',2.61),('12664','2013-12-20','11:40:00',2.64),('12664','2013-12-20','11:45:00',2.63),('12664','2013-12-20','11:50:00',2.63),('12664','2013-12-20','11:55:00',2.64),('12664','2013-12-20','12:00:00',2.68),('12664','2013-12-20','12:05:00',2.67),('12664','2013-12-20','12:10:00',2.65),('12664','2013-12-20','12:15:00',2.66),('12664','2013-12-20','12:20:00',2.62),('12664','2013-12-20','12:25:00',2.59),('12664','2013-12-20','12:30:00',2.57),('12664','2013-12-20','12:35:00',2.56),('12664','2013-12-20','12:40:00',2.51),('12664','2013-12-20','12:45:00',2.46),('12664','2013-12-20','12:50:00',2.49),('12664','2013-12-20','12:55:00',2.45),('12664','2013-12-20','13:00:00',2.4),('12664','2013-12-20','13:05:00',2.36),('12664','2013-12-20','13:10:00',2.4),('12664','2013-12-20','13:15:00',2.3),('12664','2013-12-20','13:20:00',2.15),('12664','2013-12-20','13:25:00',2.25),('12664','2013-12-20','13:30:00',1.52),('12664','2013-12-20','13:35:00',1.67),('12664','2013-12-20','13:40:00',1.96),('12664','2013-12-20','13:45:00',1.67),('12664','2013-12-20','13:55:00',1.5),('12664','2013-12-20','14:00:00',1.14),('12664','2013-12-20','14:15:00',1.57),('12664','2013-12-20','14:25:00',1.04),('12664','2013-12-20','14:30:00',1.48),('12664','2013-12-20','14:35:00',1.46),('12664','2013-12-20','14:40:00',1.34),('12664','2013-12-20','14:45:00',1.26),('12664','2013-12-19','09:10:00',1.26),('12664','2013-12-19','09:25:00',1.13),('12664','2013-12-19','09:40:00',1.48),('12664','2013-12-19','09:45:00',1.75),('12664','2013-12-19','09:50:00',1.31),('12664','2013-12-19','09:55:00',1.08),('12664','2013-12-19','10:35:00',1.38),('12664','2013-12-19','10:40:00',1.07),('12664','2013-12-19','10:55:00',1.17),('12664','2013-12-19','11:00:00',1.13),('12664','2013-12-19','12:20:00',1.3),('12664','2013-12-19','12:25:00',1.07),('12664','2013-12-19','13:35:00',1.09),('12664','2013-12-19','13:40:00',1.12),('12664','2013-12-19','14:20:00',1.67),('12664','2013-12-19','14:25:00',1),('12664','2013-12-19','14:30:00',1.36),('12664','2013-12-19','14:35:00',1.92),('12664','2013-12-19','14:40:00',1.8),('12664','2013-12-19','14:45:00',1.49),('12664','2013-12-19','14:50:00',1.29),('12664','2013-12-19','15:00:00',1.01),('12664','2013-12-19','15:05:00',1.08),('12664','2013-12-18','08:40:00',1.04),('12664','2013-12-18','08:45:00',1.11),('12664','2013-12-18','08:50:00',1.22),('12664','2013-12-18','08:55:00',1.31),('12664','2013-12-18','09:00:00',1.39),('12664','2013-12-18','09:05:00',1.47),('12664','2013-12-18','09:10:00',1.54),('12664','2013-12-18','09:15:00',1.63),('12664','2013-12-18','09:20:00',1.71),('12664','2013-12-18','09:25:00',1.78),('12664','2013-12-18','09:30:00',1.86),('12664','2013-12-18','09:35:00',1.94),('12664','2013-12-18','09:40:00',2),('12664','2013-12-18','09:45:00',2.09),('12664','2013-12-18','09:50:00',2.13),('12664','2013-12-18','09:55:00',2.2),('12664','2013-12-18','10:00:00',2.24),('12664','2013-12-18','10:05:00',2.28),('12664','2013-12-18','10:10:00',2.35),('12664','2013-12-18','10:15:00',2.37),('12664','2013-12-18','10:20:00',2.39),('12664','2013-12-18','10:25:00',2.46),('12664','2013-12-18','10:30:00',2.5),('12664','2013-12-18','10:35:00',2.53),('12664','2013-12-18','10:40:00',2.54),('12664','2013-12-18','10:45:00',2.57),('12664','2013-12-18','10:50:00',2.59),('12664','2013-12-18','10:55:00',2.63),('12664','2013-12-18','11:00:00',2.66),('12664','2013-12-18','11:05:00',2.7),('12664','2013-12-18','11:10:00',2.72),('12664','2013-12-18','11:15:00',2.76),('12664','2013-12-18','11:20:00',2.78),('12664','2013-12-18','11:25:00',2.81),('12664','2013-12-18','11:30:00',2.83),('12664','2013-12-18','11:35:00',2.83),('12664','2013-12-18','11:40:00',2.83),('12664','2013-12-18','11:45:00',2.82),('12664','2013-12-18','11:50:00',2.83),('12664','2013-12-18','11:55:00',2.83),('12664','2013-12-18','12:00:00',2.84),('12664','2013-12-18','12:05:00',2.84),('12664','2013-12-18','12:10:00',2.84),('12664','2013-12-18','12:15:00',2.83),('12664','2013-12-18','12:20:00',2.83),('12664','2013-12-18','12:25:00',2.81),('12664','2013-12-18','12:30:00',2.81),('12664','2013-12-18','12:35:00',2.78),('12664','2013-12-18','12:40:00',2.76),('12664','2013-12-18','12:45:00',2.74),('12664','2013-12-18','12:50:00',2.73),('12664','2013-12-18','12:55:00',2.71),('12664','2013-12-18','13:00:00',2.67),('12664','2013-12-18','13:05:00',2.63),('12664','2013-12-18','13:10:00',2.62),('12664','2013-12-18','13:15:00',2.6),('12664','2013-12-18','13:20:00',2.56),('12664','2013-12-18','13:25:00',2.54),('12664','2013-12-18','13:30:00',2.44),('12664','2013-12-18','13:35:00',2.39),('12664','2013-12-18','13:40:00',2.37),('12664','2013-12-18','13:45:00',2.35),('12664','2013-12-18','13:50:00',2.3),('12664','2013-12-18','13:55:00',2.23),('12664','2013-12-18','14:00:00',2.15),('12664','2013-12-18','14:05:00',2.1),('12664','2013-12-18','14:10:00',2.03),('12664','2013-12-18','14:15:00',1.95),('12664','2013-12-18','14:20:00',1.9),('12664','2013-12-18','14:25:00',1.84),('12664','2013-12-18','14:30:00',1.77),('12664','2013-12-18','14:35:00',1.67),('12664','2013-12-18','14:40:00',1.64),('12664','2013-12-18','14:45:00',1.59),('12664','2013-12-18','14:50:00',1.52),('12664','2013-12-18','14:55:00',1.47),('12664','2013-12-18','15:00:00',1.38),('12664','2013-12-18','15:05:00',1.29),('12664','2013-12-18','15:10:00',1.2),('12664','2013-12-18','15:15:00',1.11),('12664','2013-12-18','15:20:00',1.04),('12664','2013-12-17','08:30:00',1.02),('12664','2013-12-17','08:35:00',1.11),('12664','2013-12-17','08:40:00',1.2),('12664','2013-12-17','08:45:00',1.29),('12664','2013-12-17','08:50:00',1.38),('12664','2013-12-17','08:55:00',1.46),('12664','2013-12-17','09:00:00',1.55),('12664','2013-12-17','09:05:00',1.64),('12664','2013-12-17','09:10:00',1.73),('12664','2013-12-17','09:15:00',1.8),('12664','2013-12-17','09:20:00',1.89),('12664','2013-12-17','09:25:00',1.96),('12664','2013-12-17','09:30:00',2.01),('12664','2013-12-17','09:35:00',2.08),('12664','2013-12-17','09:40:00',2.14),('12664','2013-12-17','09:45:00',2.18),('12664','2013-12-17','09:50:00',2.25),('12664','2013-12-17','09:55:00',2.3),('12664','2013-12-17','10:00:00',2.37),('12664','2013-12-17','10:05:00',2.42),('12664','2013-12-17','10:10:00',2.46),('12664','2013-12-17','10:15:00',2.5),('12664','2013-12-17','10:20:00',2.56),('12664','2013-12-17','10:25:00',2.59),('12664','2013-12-17','10:30:00',2.61),('12664','2013-12-17','10:35:00',2.66),('12664','2013-12-17','10:40:00',2.68),('12664','2013-12-17','10:45:00',2.72),('12664','2013-12-17','10:50:00',2.75),('12664','2013-12-17','10:55:00',2.81),('12664','2013-12-17','11:00:00',2.83),('12664','2013-12-17','11:05:00',2.85),('12664','2013-12-17','11:10:00',2.86),('12664','2013-12-17','11:15:00',2.88),('12664','2013-12-17','11:20:00',2.88),('12664','2013-12-17','11:25:00',2.9),('12664','2013-12-17','11:30:00',2.92),('12664','2013-12-17','11:35:00',2.94),('12664','2013-12-17','11:40:00',2.95),('12664','2013-12-17','11:45:00',2.98),('12664','2013-12-17','11:50:00',2.99),('12664','2013-12-17','11:55:00',2.98),('12664','2013-12-17','12:00:00',2.99),('12664','2013-12-17','12:05:00',3),('12664','2013-12-17','12:10:00',2.99),('12664','2013-12-17','12:15:00',2.97),('12664','2013-12-17','12:20:00',2.97),('12664','2013-12-17','12:25:00',2.96),('12664','2013-12-17','12:30:00',2.94),('12664','2013-12-17','12:35:00',2.93),('12664','2013-12-17','12:40:00',2.91),('12664','2013-12-17','12:45:00',2.88),('12664','2013-12-17','12:50:00',2.87),('12664','2013-12-17','12:55:00',2.85),('12664','2013-12-17','13:00:00',2.83),('12664','2013-12-17','13:05:00',2.8),('12664','2013-12-17','13:10:00',2.75),('12664','2013-12-17','13:15:00',2.71),('12664','2013-12-17','13:20:00',2.69),('12664','2013-12-17','13:25:00',2.62),('12664','2013-12-17','13:30:00',2.56),('12664','2013-12-17','13:35:00',2.53),('12664','2013-12-17','13:40:00',2.48),('12664','2013-12-17','13:45:00',2.42),('12664','2013-12-17','13:50:00',2.38),('12664','2013-12-17','13:55:00',2.31),('12664','2013-12-17','14:00:00',2.23),('12664','2013-12-17','14:05:00',2.19),('12664','2013-12-17','14:10:00',2.12),('12664','2013-12-17','14:15:00',2.08),('12664','2013-12-17','14:20:00',2.02),('12664','2013-12-17','14:25:00',1.96),('12664','2013-12-17','14:30:00',1.88),('12664','2013-12-17','14:35:00',1.79),('12664','2013-12-17','14:40:00',1.7),('12664','2013-12-17','14:45:00',1.62),('12664','2013-12-17','14:50:00',1.55),('12664','2013-12-17','14:55:00',1.47),('12664','2013-12-17','15:00:00',1.4),('12664','2013-12-17','15:05:00',1.32),('12664','2013-12-17','15:10:00',1.24),('12664','2013-12-17','15:15:00',1.17),('12664','2013-12-17','15:20:00',1.09),('12664','2013-12-17','15:25:00',1.01),('12664','2014-04-21','08:50:00',1.28),('12664','2014-04-21','08:55:00',1.29),('12664','2014-04-21','09:00:00',1.25),('12664','2014-04-21','09:05:00',1.05),('12664','2014-04-21','09:10:00',1.15),('12664','2014-04-21','09:15:00',1.25),('12664','2014-04-21','09:25:00',2.27),('12664','2014-04-21','09:30:00',2.83),('12664','2014-04-21','09:35:00',2.08),('12664','2014-04-21','09:40:00',1.55),('12664','2014-04-21','09:50:00',1.01),('12664','2014-04-21','09:55:00',1.19),('12664','2014-04-21','10:00:00',1.29),('12664','2014-04-21','10:05:00',1.37),('12664','2014-04-21','10:10:00',1.93),('12664','2014-04-21','10:15:00',2.86),('12664','2014-04-21','10:20:00',2.24),('12664','2014-04-21','10:25:00',3.37),('12664','2014-04-21','10:30:00',3.3),('12664','2014-04-21','10:35:00',3.23),('12664','2014-04-21','10:40:00',3.34),('12664','2014-04-21','10:45:00',3.35),('12664','2014-04-21','10:50:00',3.36),('12664','2014-04-21','10:55:00',3.41),('12664','2014-04-21','11:00:00',3.44),('12664','2014-04-21','11:05:00',3.47),('12664','2014-04-21','11:10:00',3.51),('12664','2014-04-21','11:15:00',3.57),('12664','2014-04-21','11:20:00',3.61),('12664','2014-04-21','11:25:00',3.62),('12664','2014-04-21','11:30:00',3.65),('12664','2014-04-21','11:35:00',3.69),('12664','2014-04-21','11:40:00',3.75),('12664','2014-04-21','11:45:00',3.77),('12664','2014-04-21','11:50:00',3.79),('12664','2014-04-21','11:55:00',3.84),('12664','2014-04-21','12:00:00',3.87),('12664','2014-04-21','12:05:00',3.91),('12664','2014-04-21','12:10:00',3.94),('12664','2014-04-21','12:15:00',3.99),('12664','2014-04-21','12:20:00',4.01),('12664','2014-04-21','12:25:00',4.01),('12664','2014-04-21','12:30:00',4),('12664','2014-04-21','12:35:00',4),('12664','2014-04-21','12:40:00',4.01),('12664','2014-04-21','12:45:00',4.02),('12664','2014-04-21','12:50:00',4.02),('12664','2014-04-21','12:55:00',4.04),('12664','2014-04-21','13:00:00',4.05),('12664','2014-04-21','13:05:00',4.03),('12664','2014-04-21','13:10:00',4.05),('12664','2014-04-21','13:15:00',4.05),('12664','2014-04-21','13:20:00',4.06),('12664','2014-04-21','13:25:00',4.07),('12664','2014-04-21','13:30:00',4.09),('12664','2014-04-21','13:35:00',4.07),('12664','2014-04-21','13:40:00',4.07),('12664','2014-04-21','13:45:00',4.07),('12664','2014-04-21','13:50:00',4.06),('12664','2014-04-21','13:55:00',4.05),('12664','2014-04-21','14:00:00',4.02),('12664','2014-04-21','14:05:00',4.02),('12664','2014-04-21','14:10:00',4),('12664','2014-04-21','14:15:00',3.97),('12664','2014-04-21','14:20:00',3.94),('12664','2014-04-21','14:25:00',3.92),('12664','2014-04-21','14:30:00',3.89),('12664','2014-04-21','14:35:00',3.86),('12664','2014-04-21','14:40:00',3.82),('12664','2014-04-21','14:45:00',3.78),('12664','2014-04-21','14:50:00',3.74),('12664','2014-04-21','14:55:00',3.71),('12664','2014-04-21','15:00:00',3.66),('12664','2014-04-21','15:05:00',3.62),('12664','2014-04-21','15:10:00',3.57),('12664','2014-04-21','15:15:00',3.53),('12664','2014-04-21','15:20:00',3.48),('12664','2014-04-21','15:25:00',3.42),('12664','2014-04-21','15:30:00',3.37),('12664','2014-04-21','15:35:00',3.32),('12664','2014-04-21','15:40:00',3.27),('12664','2014-04-21','15:45:00',3.2),('12664','2014-04-21','15:50:00',3.14),('12664','2014-04-21','15:55:00',3.07),('12664','2014-04-21','16:00:00',2.67),('12664','2014-04-21','16:05:00',3.43),('12664','2014-04-21','16:10:00',2.97),('12664','2014-04-21','16:15:00',2.83),('12664','2014-04-21','16:20:00',2.72),('12664','2014-04-21','16:25:00',2.7),('12664','2014-04-21','16:30:00',2.65),('12664','2014-04-21','16:35:00',2.58),('12664','2014-04-21','16:40:00',2.5),('12664','2014-04-21','16:45:00',2.42),('12664','2014-04-21','16:50:00',2.35),('12664','2014-04-21','16:55:00',2.27),('12664','2014-04-21','17:00:00',2.19),('12664','2014-04-21','17:05:00',2.11),('12664','2014-04-21','17:10:00',2.02),('12664','2014-04-21','17:15:00',1.95),('12664','2014-04-21','17:20:00',1.87),('12664','2014-04-21','17:25:00',1.78),('12664','2014-04-21','17:30:00',1.7),('12664','2014-04-21','17:35:00',1.6),('12664','2014-04-21','17:40:00',1.51),('12664','2014-04-21','17:45:00',1.41),('12664','2014-04-21','17:50:00',1.3),('12664','2014-04-21','17:55:00',1.2),('12664','2014-04-21','18:00:00',1.11),('12664','2014-04-21','18:05:00',1.01),('12664','2013-12-16','08:35:00',1.06),('12664','2013-12-16','08:40:00',1.14),('12664','2013-12-16','08:45:00',1.23),('12664','2013-12-16','08:50:00',1.31),('12664','2013-12-16','08:55:00',1.4),('12664','2013-12-16','09:00:00',1.49),('12664','2013-12-16','09:05:00',1.57),('12664','2013-12-16','09:10:00',1.66),('12664','2013-12-16','09:15:00',1.73),('12664','2013-12-16','09:20:00',1.8),('12664','2013-12-16','09:25:00',1.87),('12664','2013-12-16','09:30:00',1.95),('12664','2013-12-16','09:35:00',2.02),('12664','2013-12-16','09:40:00',2.1),('12664','2013-12-16','09:45:00',2.18),('12664','2013-12-16','09:50:00',2.25),('12664','2013-12-16','09:55:00',2.3),('12664','2013-12-16','10:00:00',2.35),('12664','2013-12-16','10:05:00',2.39),('12664','2013-12-16','10:10:00',2.43),('12664','2013-12-16','10:15:00',2.48),('12664','2013-12-16','10:20:00',2.51),('12664','2013-12-16','10:25:00',2.56),('12664','2013-12-16','10:30:00',2.6),('12664','2013-12-16','10:35:00',2.63),('12664','2013-12-16','10:40:00',2.65),('12664','2013-12-16','10:45:00',2.68),('12664','2013-12-16','10:50:00',2.75),('12664','2013-12-16','10:55:00',2.77),('12664','2013-12-16','11:00:00',2.78),('12664','2013-12-16','11:05:00',2.8),('12664','2013-12-16','11:10:00',2.84),('12664','2013-12-16','11:15:00',2.87),('12664','2013-12-16','11:20:00',2.91),('12664','2013-12-16','11:25:00',2.92),('12664','2013-12-16','11:30:00',2.95),('12664','2013-12-16','11:35:00',2.96),('12664','2013-12-16','11:40:00',2.95),('12664','2013-12-16','11:45:00',2.96),('12664','2013-12-16','11:50:00',2.92),('12664','2013-12-16','11:55:00',2.91),('12664','2013-12-16','12:00:00',2.91),('12664','2013-12-16','12:05:00',2.95),('12664','2013-12-16','12:10:00',2.94),('12664','2013-12-16','12:15:00',2.92),('12664','2013-12-16','12:20:00',2.93),('12664','2013-12-16','12:25:00',2.84),('12664','2013-12-16','12:30:00',2.85),('12664','2013-12-16','12:35:00',2.84),('12664','2013-12-16','12:40:00',2.78),('12664','2013-12-16','12:45:00',2.78),('12664','2013-12-16','12:50:00',2.76),('12664','2013-12-16','12:55:00',2.78),('12664','2013-12-16','13:00:00',2.79),('12664','2013-12-16','13:05:00',2.77),('12664','2013-12-16','13:10:00',2.73),('12664','2013-12-16','13:15:00',2.7),('12664','2013-12-16','13:20:00',2.65),('12664','2013-12-16','13:25:00',2.59),('12664','2013-12-16','13:30:00',2.56),('12664','2013-12-16','13:35:00',2.52),('12664','2013-12-16','13:40:00',2.48),('12664','2013-12-16','13:45:00',2.43),('12664','2013-12-16','13:50:00',2.4),('12664','2013-12-16','13:55:00',2.34),('12664','2013-12-16','14:00:00',2.29),('12664','2013-12-16','14:05:00',2.23),('12664','2013-12-16','14:10:00',2.15),('12664','2013-12-16','14:15:00',2.08),('12664','2013-12-16','14:20:00',2.01),('12664','2013-12-16','14:25:00',1.93),('12664','2013-12-16','14:30:00',1.87),('12664','2013-12-16','14:35:00',1.81),('12664','2013-12-16','14:40:00',1.7),('12664','2013-12-16','14:45:00',1.64),('12664','2013-12-16','14:50:00',1.56),('12664','2013-12-16','14:55:00',1.5),('12664','2013-12-16','15:00:00',1.42),('12664','2013-12-16','15:05:00',1.35),('12664','2013-12-16','15:10:00',1.28),('12664','2013-12-16','15:15:00',1.2),('12664','2013-12-16','15:20:00',1.11),('12664','2013-12-16','15:25:00',1.01),('12664','2013-12-15','10:25:00',1.43),('12664','2013-12-15','11:10:00',1.01),('12664','2013-12-15','11:15:00',1.06),('12664','2013-12-15','12:00:00',1.03),('12664','2013-12-14','08:40:00',1.02),('12664','2013-12-14','08:45:00',1.05),('12664','2013-12-14','08:50:00',1.13),('12664','2013-12-14','08:55:00',1.23),('12664','2013-12-14','09:00:00',1.35),('12664','2013-12-14','09:05:00',1.46),('12664','2013-12-14','09:10:00',1.55),('12664','2013-12-14','09:15:00',1.63),('12664','2013-12-14','09:20:00',1.7),('12664','2013-12-14','09:25:00',1.78),('12664','2013-12-14','09:30:00',1.86),('12664','2013-12-14','09:35:00',1.92),('12664','2013-12-14','09:40:00',1.99),('12664','2013-12-14','09:45:00',2.06),('12664','2013-12-14','09:50:00',2.1),('12664','2013-12-14','09:55:00',2.15),('12664','2013-12-14','10:00:00',2.2),('12664','2013-12-14','10:05:00',2.27),('12664','2013-12-14','10:10:00',2.31),('12664','2013-12-14','10:15:00',2.36),('12664','2013-12-14','10:20:00',2.41),('12664','2013-12-14','10:25:00',2.47),('12664','2013-12-14','10:30:00',2.51),('12664','2013-12-14','10:35:00',2.53),('12664','2013-12-14','10:40:00',2.56),('12664','2013-12-14','10:45:00',2.6),('12664','2013-12-14','10:50:00',2.61),('12664','2013-12-14','10:55:00',2.65),('12664','2013-12-14','11:00:00',2.66),('12664','2013-12-14','11:05:00',2.63),('12664','2013-12-14','11:10:00',2.65),('12664','2013-12-14','11:15:00',2.67),('12664','2013-12-14','11:20:00',2.72),('12664','2013-12-14','11:25:00',2.71),('12664','2013-12-14','11:30:00',2.69),('12664','2013-12-14','11:35:00',2.72),('12664','2013-12-14','11:40:00',2.73),('12664','2013-12-14','11:45:00',2.73),('12664','2013-12-14','11:50:00',2.73),('12664','2013-12-14','11:55:00',2.75),('12664','2013-12-14','12:00:00',2.77),('12664','2013-12-14','12:05:00',2.82),('12664','2013-12-14','12:10:00',2.81),('12664','2013-12-14','12:15:00',2.78),('12664','2013-12-14','12:20:00',2.78),('12664','2013-12-14','12:25:00',2.77),('12664','2013-12-14','12:30:00',2.76),('12664','2013-12-14','12:35:00',2.73),('12664','2013-12-14','12:40:00',2.68),('12664','2013-12-14','12:45:00',2.63),('12664','2013-12-14','12:50:00',2.63),('12664','2013-12-14','12:55:00',2.56),('12664','2013-12-14','13:00:00',2.51),('12664','2013-12-14','13:05:00',2.48),('12664','2013-12-14','13:10:00',2.52),('12664','2013-12-14','13:15:00',2.46),('12664','2013-12-14','13:20:00',2.39),('12664','2013-12-14','13:25:00',2.37),('12664','2013-12-14','13:30:00',2.37),('12664','2013-12-14','13:35:00',2.34),('12664','2013-12-14','13:40:00',2.33),('12664','2013-12-14','13:45:00',2.26),('12664','2013-12-14','13:50:00',2.19),('12664','2013-12-14','13:55:00',2.18),('12664','2013-12-14','14:00:00',2.11),('12664','2013-12-14','14:05:00',2.1),('12664','2013-12-14','14:10:00',2.05),('12664','2013-12-14','14:15:00',1.99),('12664','2013-12-14','14:20:00',1.91),('12664','2013-12-14','14:25:00',1.83),('12664','2013-12-14','14:30:00',1.74),('12664','2013-12-14','14:35:00',1.66),('12664','2013-12-14','14:40:00',1.58),('12664','2013-12-14','14:45:00',1.51),('12664','2013-12-14','14:50:00',1.46),('12664','2013-12-14','14:55:00',1.4),('12664','2013-12-14','15:00:00',1.32),('12664','2013-12-14','15:05:00',1.24),('12664','2013-12-14','15:10:00',1.11),('12664','2013-12-14','15:15:00',1.05),('12664','2013-12-13','08:50:00',1.05),('12664','2013-12-13','08:55:00',1.13),('12664','2013-12-13','09:00:00',1.22),('12664','2013-12-13','09:05:00',1.31),('12664','2013-12-13','09:10:00',1.38),('12664','2013-12-13','09:15:00',1.44),('12664','2013-12-13','09:20:00',1.53),('12664','2013-12-13','09:25:00',1.61),('12664','2013-12-13','09:30:00',1.68),('12664','2013-12-13','09:35:00',1.76),('12664','2013-12-13','09:40:00',1.84),('12664','2013-12-13','09:45:00',1.92),('12664','2013-12-13','09:50:00',1.99),('12664','2013-12-13','09:55:00',2.05),('12664','2013-12-13','10:00:00',2.09),('12664','2013-12-13','10:05:00',2.14),('12664','2013-12-13','10:10:00',2.18),('12664','2013-12-13','10:15:00',2.21),('12664','2013-12-13','10:20:00',2.26),('12664','2013-12-13','10:25:00',2.3),('12664','2013-12-13','10:30:00',2.35),('12664','2013-12-13','10:35:00',2.4),('12664','2013-12-13','10:40:00',2.42),('12664','2013-12-13','10:45:00',2.48),('12664','2013-12-13','10:50:00',2.46),('12664','2013-12-13','10:55:00',2.45),('12664','2013-12-13','11:00:00',2.47),('12664','2013-12-13','11:05:00',2.49),('12664','2013-12-13','11:10:00',2.55),('12664','2013-12-13','11:15:00',2.62),('12664','2013-12-13','11:20:00',2.62),('12664','2013-12-13','11:25:00',2.65),('12664','2013-12-13','11:30:00',2.67),('12664','2013-12-13','11:35:00',2.68),('12664','2013-12-13','11:40:00',2.66),('12664','2013-12-13','11:45:00',2.59),('12664','2013-12-13','11:50:00',2.63),('12664','2013-12-13','11:55:00',2.61),('12664','2013-12-13','12:00:00',2.6),('12664','2013-12-13','12:05:00',2.63),('12664','2013-12-13','12:10:00',2.61),('12664','2013-12-13','12:15:00',2.62),('12664','2013-12-13','12:20:00',2.64),('12664','2013-12-13','12:25:00',2.6),('12664','2013-12-13','12:30:00',2.61),('12664','2013-12-13','12:35:00',2.62),('12664','2013-12-13','12:40:00',2.6),('12664','2013-12-13','12:45:00',2.63),('12664','2013-12-13','12:50:00',2.62),('12664','2013-12-13','12:55:00',2.55),('12664','2013-12-13','13:00:00',2.52),('12664','2013-12-13','13:05:00',2.46),('12664','2013-12-13','13:10:00',2.43),('12664','2013-12-13','13:15:00',2.45),('12664','2013-12-13','13:20:00',2.43),('12664','2013-12-13','13:25:00',2.47),('12664','2013-12-13','13:30:00',2.41),('12664','2013-12-13','13:35:00',2.28),('12664','2013-12-13','13:40:00',2.27),('12664','2013-12-13','13:45:00',2.24),('12664','2013-12-13','13:50:00',2.22),('12664','2013-12-13','13:55:00',2.19),('12664','2013-12-13','14:00:00',2.14),('12664','2013-12-13','14:05:00',2.06),('12664','2013-12-13','14:10:00',2),('12664','2013-12-13','14:15:00',1.95),('12664','2013-12-13','14:20:00',1.94),('12664','2013-12-13','14:25:00',1.87),('12664','2013-12-13','14:30:00',1.76),('12664','2013-12-13','14:35:00',1.67),('12664','2013-12-13','14:40:00',1.62),('12664','2013-12-13','14:45:00',1.55),('12664','2013-12-13','14:50:00',1.48),('12664','2013-12-13','14:55:00',1.41),('12664','2013-12-13','15:00:00',1.33),('12664','2013-12-13','15:05:00',1.28),('12664','2013-12-13','15:10:00',1.18),('12664','2013-12-13','15:15:00',1.08),('12664','2013-12-13','15:20:00',1),('12664','2013-12-12','08:40:00',1.01),('12664','2013-12-12','08:45:00',1.12),('12664','2013-12-12','08:50:00',1.21),('12664','2013-12-12','08:55:00',1.29),('12664','2013-12-12','09:00:00',1.38),('12664','2013-12-12','09:05:00',1.46),('12664','2013-12-12','09:10:00',1.53),('12664','2013-12-12','09:15:00',1.61),('12664','2013-12-12','09:20:00',1.69),('12664','2013-12-12','09:25:00',1.76),('12664','2013-12-12','09:30:00',1.84),('12664','2013-12-12','09:35:00',1.89),('12664','2013-12-12','09:40:00',1.95),('12664','2013-12-12','09:45:00',2.02),('12664','2013-12-12','09:50:00',2.08),('12664','2013-12-12','09:55:00',2.13),('12664','2013-12-12','10:00:00',2.16),('12664','2013-12-12','10:05:00',2.22),('12664','2013-12-12','10:10:00',2.28),('12664','2013-12-12','10:15:00',2.33),('12664','2013-12-12','10:20:00',2.38),('12664','2013-12-12','10:25:00',2.42),('12664','2013-12-12','10:30:00',2.45),('12664','2013-12-12','10:35:00',2.49),('12664','2013-12-12','10:40:00',2.52),('12664','2013-12-12','10:45:00',2.55),('12664','2013-12-12','10:50:00',2.58),('12664','2013-12-12','10:55:00',2.6),('12664','2013-12-12','11:00:00',2.63),('12664','2013-12-12','11:05:00',2.67),('12664','2013-12-12','11:10:00',2.69),('12664','2013-12-12','11:15:00',2.71),('12664','2013-12-12','11:20:00',2.72),('12664','2013-12-12','11:25:00',2.76),('12664','2013-12-12','11:30:00',2.77),('12664','2013-12-12','11:35:00',2.8),('12664','2013-12-12','11:40:00',2.79),('12664','2013-12-12','11:45:00',2.78),('12664','2013-12-12','11:50:00',2.79),('12664','2013-12-12','11:55:00',2.78),('12664','2013-12-12','12:00:00',2.77),('12664','2013-12-12','12:05:00',2.79),('12664','2013-12-12','12:10:00',2.8),('12664','2013-12-12','12:15:00',2.78),('12664','2013-12-12','12:20:00',2.76),('12664','2013-12-12','12:25:00',2.76),('12664','2013-12-12','12:30:00',2.75),('12664','2013-12-12','12:35:00',2.73),('12664','2013-12-12','12:40:00',2.72),('12664','2013-12-12','12:45:00',2.71),('12664','2013-12-12','12:50:00',2.69),('12664','2013-12-12','12:55:00',2.67),('12664','2013-12-12','13:00:00',2.63),('12664','2013-12-12','13:05:00',2.6),('12664','2013-12-12','13:10:00',2.58),('12664','2013-12-12','13:15:00',2.54),('12664','2013-12-12','13:20:00',2.48),('12664','2013-12-12','13:25:00',2.49),('12664','2013-12-12','13:30:00',2.45),('12664','2013-12-12','13:35:00',2.37),('12664','2013-12-12','13:40:00',2.31),('12664','2013-12-12','13:45:00',2.27),('12664','2013-12-12','13:50:00',2.21),('12664','2013-12-12','13:55:00',2.16),('12664','2013-12-12','14:00:00',2.13),('12664','2013-12-12','14:05:00',2.09),('12664','2013-12-12','14:10:00',2.01),('12664','2013-12-12','14:15:00',1.93),('12664','2013-12-12','14:20:00',1.87),('12664','2013-12-12','14:25:00',1.81),('12664','2013-12-12','14:30:00',1.74),('12664','2013-12-12','14:35:00',1.67),('12664','2013-12-12','14:40:00',1.59),('12664','2013-12-12','14:45:00',1.49),('12664','2013-12-12','14:50:00',1.4),('12664','2013-12-12','14:55:00',1.32),('12664','2013-12-12','15:00:00',1.25),('12664','2013-12-12','15:05:00',1.18),('12664','2013-12-12','15:10:00',1.09),('12664','2013-12-12','15:15:00',1),('12664','2013-12-11','08:35:00',1.08),('12664','2013-12-11','08:40:00',1.17),('12664','2013-12-11','08:45:00',1.26),('12664','2013-12-11','08:50:00',1.35),('12664','2013-12-11','08:55:00',1.42),('12664','2013-12-11','09:00:00',1.5),('12664','2013-12-11','09:05:00',1.58),('12664','2013-12-11','09:10:00',1.67),('12664','2013-12-11','09:15:00',1.75),('12664','2013-12-11','09:20:00',1.82),('12664','2013-12-11','09:25:00',1.89),('12664','2013-12-11','09:30:00',1.98),('12664','2013-12-11','09:35:00',2.04),('12664','2013-12-11','09:40:00',2.09),('12664','2013-12-11','09:45:00',2.15),('12664','2013-12-11','09:50:00',2.2),('12664','2013-12-11','09:55:00',2.24),('12664','2013-12-11','10:00:00',2.3),('12664','2013-12-11','10:05:00',2.36),('12664','2013-12-11','10:10:00',2.41),('12664','2013-12-11','10:15:00',2.46),('12664','2013-12-11','10:20:00',2.53),('12664','2013-12-11','10:25:00',2.58),('12664','2013-12-11','10:30:00',2.64),('12664','2013-12-11','10:35:00',2.68),('12664','2013-12-11','10:40:00',2.7),('12664','2013-12-11','10:45:00',2.68),('12664','2013-12-11','10:50:00',2.71),('12664','2013-12-11','10:55:00',2.75),('12664','2013-12-11','11:00:00',2.8),('12664','2013-12-11','11:05:00',2.82),('12664','2013-12-11','11:10:00',2.84),('12664','2013-12-11','11:15:00',2.84),('12664','2013-12-11','11:20:00',2.82),('12664','2013-12-11','11:25:00',2.83),('12664','2013-12-11','11:30:00',2.83),('12664','2013-12-11','11:35:00',2.88),('12664','2013-12-11','11:40:00',2.88),('12664','2013-12-11','11:45:00',2.9),('12664','2013-12-11','11:50:00',2.91),('12664','2013-12-11','11:55:00',2.92),('12664','2013-12-11','12:00:00',2.9),('12664','2013-12-11','12:05:00',2.91),('12664','2013-12-11','12:10:00',2.9),('12664','2013-12-11','12:15:00',2.86),('12664','2013-12-11','12:20:00',2.84),('12664','2013-12-11','12:25:00',2.82),('12664','2013-12-11','12:30:00',2.83),('12664','2013-12-11','12:35:00',2.78),('12664','2013-12-11','12:40:00',2.75),('12664','2013-12-11','12:45:00',2.78),('12664','2013-12-11','12:50:00',2.79),('12664','2013-12-11','12:55:00',2.8),('12664','2013-12-11','13:00:00',2.78),('12664','2013-12-11','13:05:00',2.73),('12664','2013-12-11','13:10:00',2.71),('12664','2013-12-11','13:15:00',2.65),('12664','2013-12-11','13:20:00',2.63),('12664','2013-12-11','13:25:00',2.6),('12664','2013-12-11','13:30:00',2.55),('12664','2013-12-11','13:35:00',2.5),('12664','2013-12-11','13:40:00',2.41),('12664','2013-12-11','13:45:00',2.34),('12664','2013-12-11','13:50:00',2.32),('12664','2013-12-11','13:55:00',2.27),('12664','2013-12-11','14:00:00',2.22),('12664','2013-12-11','14:05:00',2.18),('12664','2013-12-11','14:10:00',2.13),('12664','2013-12-11','14:15:00',2.08),('12664','2013-12-11','14:20:00',2.01),('12664','2013-12-11','14:25:00',1.92),('12664','2013-12-11','14:30:00',1.86),('12664','2013-12-11','14:35:00',1.8),('12664','2013-12-11','14:40:00',1.7),('12664','2013-12-11','14:45:00',1.62),('12664','2013-12-11','14:50:00',1.54),('12664','2013-12-11','14:55:00',1.45),('12664','2013-12-11','15:00:00',1.36),('12664','2013-12-11','15:05:00',1.28),('12664','2013-12-11','15:10:00',1.19),('12664','2013-12-11','15:15:00',1.09),('12664','2013-12-11','15:20:00',1.02),('12664','2013-12-10','08:35:00',1.08),('12664','2013-12-10','08:40:00',1.18),('12664','2013-12-10','08:45:00',1.27),('12664','2013-12-10','08:50:00',1.36),('12664','2013-12-10','08:55:00',1.45),('12664','2013-12-10','09:00:00',1.53),('12664','2013-12-10','09:05:00',1.63),('12664','2013-12-10','09:10:00',1.7),('12664','2013-12-10','09:15:00',1.79),('12664','2013-12-10','09:20:00',1.87),('12664','2013-12-10','09:25:00',1.94),('12664','2013-12-10','09:30:00',2),('12664','2013-12-10','09:35:00',2.06),('12664','2013-12-10','09:40:00',2.14),('12664','2013-12-10','09:45:00',2.22),('12664','2013-12-10','09:50:00',2.29),('12664','2013-12-10','09:55:00',2.34),('12664','2013-12-10','10:00:00',2.39),('12664','2013-12-10','10:05:00',2.44),('12664','2013-12-10','10:10:00',2.48),('12664','2013-12-10','10:15:00',2.51),('12664','2013-12-10','10:20:00',2.53),('12664','2013-12-10','10:25:00',2.58),('12664','2013-12-10','10:30:00',2.61),('12664','2013-12-10','10:35:00',2.66),('12664','2013-12-10','10:40:00',2.68),('12664','2013-12-10','10:45:00',2.71),('12664','2013-12-10','10:50:00',2.75),('12664','2013-12-10','10:55:00',2.78),('12664','2013-12-10','11:00:00',2.82),('12664','2013-12-10','11:05:00',2.84),('12664','2013-12-10','11:10:00',2.86),('12664','2013-12-10','11:15:00',2.87),('12664','2013-12-10','11:20:00',2.89),('12664','2013-12-10','11:25:00',2.9),('12664','2013-12-10','11:30:00',2.89),('12664','2013-12-10','11:35:00',2.9),('12664','2013-12-10','11:40:00',2.9),('12664','2013-12-10','11:45:00',2.9),('12664','2013-12-10','11:50:00',2.91),('12664','2013-12-10','11:55:00',2.92),('12664','2013-12-10','12:00:00',2.91),('12664','2013-12-10','12:05:00',2.88),('12664','2013-12-10','12:10:00',2.89),('12664','2013-12-10','12:15:00',2.93),('12664','2013-12-10','12:20:00',2.93),('12664','2013-12-10','12:25:00',2.91),('12664','2013-12-10','12:30:00',2.91),('12664','2013-12-10','12:35:00',2.9),('12664','2013-12-10','12:40:00',2.89),('12664','2013-12-10','12:45:00',2.88),('12664','2013-12-10','12:50:00',2.84),('12664','2013-12-10','12:55:00',2.82),('12664','2013-12-10','13:00:00',2.76),('12664','2013-12-10','13:05:00',2.76),('12664','2013-12-10','13:10:00',2.73),('12664','2013-12-10','13:15:00',2.69),('12664','2013-12-10','13:20:00',2.64),('12664','2013-12-10','13:25:00',2.59),('12664','2013-12-10','13:30:00',2.53),('12664','2013-12-10','13:35:00',2.49),('12664','2013-12-10','13:40:00',2.43),('12664','2013-12-10','13:45:00',2.39),('12664','2013-12-10','13:50:00',2.33),('12664','2013-12-10','13:55:00',2.29),('12664','2013-12-10','14:00:00',2.24),('12664','2013-12-10','14:05:00',2.18),('12664','2013-12-10','14:10:00',2.1),('12664','2013-12-10','14:15:00',2.06),('12664','2013-12-10','14:20:00',2),('12664','2013-12-10','14:25:00',1.94),('12664','2013-12-10','14:30:00',1.85),('12664','2013-12-10','14:35:00',1.78),('12664','2013-12-10','14:40:00',1.6),('12664','2013-12-10','14:45:00',1.53),('12664','2013-12-10','14:50:00',1.52),('12664','2013-12-10','14:55:00',1.4),('12664','2013-12-10','15:00:00',1.35),('12664','2013-12-10','15:05:00',1.3),('12664','2013-12-10','15:10:00',1.17),('12664','2013-12-10','15:15:00',1.09),('12664','2013-12-10','15:20:00',1.06),('12664','2013-12-09','09:15:00',1.65),('12664','2013-12-09','09:20:00',1.77),('12664','2013-12-09','09:25:00',1.87),('12664','2013-12-09','09:30:00',1.92),('12664','2013-12-09','09:35:00',2.1),('12664','2013-12-09','09:40:00',2.3),('12664','2013-12-09','09:45:00',2.54),('12664','2013-12-09','09:50:00',2.44),('12664','2013-12-09','09:55:00',2.59),('12664','2013-12-09','10:00:00',1.22),('12664','2013-12-09','12:25:00',1.81),('12664','2013-12-09','12:35:00',1.21),('12664','2013-12-09','12:40:00',1.75),('12664','2013-12-09','12:45:00',2.95),('12664','2013-12-09','12:50:00',2.71),('12664','2013-12-09','12:55:00',2.07),('12664','2013-12-09','13:00:00',2.62),('12664','2013-12-09','13:05:00',2.35),('12664','2013-12-09','13:10:00',2.29),('12664','2013-12-09','13:15:00',2.55),('12664','2013-12-09','13:20:00',3.25),('12664','2013-12-09','13:25:00',2.25),('12664','2013-12-09','13:30:00',1.47),('12664','2013-12-09','13:35:00',1.76),('12664','2013-12-09','13:40:00',1.49),('12664','2013-12-09','13:45:00',1.22),('12664','2013-12-08','09:10:00',1.22),('12664','2013-12-08','12:20:00',1.3),('12664','2013-12-08','12:25:00',1.01),('12664','2013-12-08','12:35:00',1.06),('12664','2013-12-08','12:40:00',1.13),('12664','2013-12-08','12:45:00',1.29),('12664','2013-12-08','12:50:00',1.1),('12664','2013-12-08','14:50:00',1.08),('12664','2013-12-08','14:55:00',1.56),('12664','2013-12-08','15:00:00',1.33),('12664','2013-12-08','15:05:00',1.23),('12664','2013-12-08','15:10:00',1.16),('12664','2013-12-08','15:15:00',1.06),('12664','2013-12-07','08:30:00',1.05),('12664','2013-12-07','08:35:00',1.14),('12664','2013-12-07','08:40:00',1.22),('12664','2013-12-07','08:45:00',1.3),('12664','2013-12-07','08:50:00',1.38),('12664','2013-12-07','08:55:00',1.47),('12664','2013-12-07','09:00:00',1.55),('12664','2013-12-07','09:05:00',1.63),('12664','2013-12-07','09:10:00',1.71),('12664','2013-12-07','09:15:00',1.79),('12664','2013-12-07','09:20:00',1.87),('12664','2013-12-07','09:25:00',1.95),('12664','2013-12-07','09:30:00',2.03),('12664','2013-12-07','09:35:00',2.1),('12664','2013-12-07','09:40:00',2.16),('12664','2013-12-07','09:45:00',2.22),('12664','2013-12-07','09:50:00',2.28),('12664','2013-12-07','09:55:00',2.34),('12664','2013-12-07','10:00:00',2.38),('12664','2013-12-07','10:05:00',2.43),('12664','2013-12-07','10:10:00',2.48),('12664','2013-12-07','10:15:00',2.51),('12664','2013-12-07','10:20:00',2.55),('12664','2013-12-07','10:25:00',2.59),('12664','2013-12-07','10:30:00',2.63),('12664','2013-12-07','10:35:00',2.66),('12664','2013-12-07','10:40:00',2.69),('12664','2013-12-07','10:45:00',2.72),('12664','2013-12-07','10:50:00',2.74),('12664','2013-12-07','10:55:00',2.75),('12664','2013-12-07','11:00:00',2.74),('12664','2013-12-07','11:05:00',2.75),('12664','2013-12-07','11:10:00',2.76),('12664','2013-12-07','11:15:00',2.8),('12664','2013-12-07','11:20:00',2.8),('12664','2013-12-07','11:25:00',2.79),('12664','2013-12-07','11:30:00',2.81),('12664','2013-12-07','11:35:00',2.82),('12664','2013-12-07','11:40:00',2.83),('12664','2013-12-07','11:45:00',2.85),('12664','2013-12-07','11:50:00',2.84),('12664','2013-12-07','11:55:00',2.83),('12664','2013-12-07','12:00:00',2.83),('12664','2013-12-07','12:05:00',2.81),('12664','2013-12-07','12:10:00',2.78),('12664','2013-12-07','12:15:00',2.75),('12664','2013-12-07','12:20:00',2.72),('12664','2013-12-07','12:25:00',2.71),('12664','2013-12-07','12:30:00',2.67),('12664','2013-12-07','12:35:00',2.69),('12664','2013-12-07','12:40:00',2.64),('12664','2013-12-07','12:45:00',2.62),('12664','2013-12-07','12:50:00',2.59),('12664','2013-12-07','12:55:00',2.56),('12664','2013-12-07','13:00:00',2.57),('12664','2013-12-07','13:05:00',2.52),('12664','2013-12-07','13:10:00',2.52),('12664','2013-12-07','13:15:00',2.53),('12664','2013-12-07','13:20:00',2.5),('12664','2013-12-07','13:25:00',2.46),('12664','2013-12-07','13:30:00',2.41),('12664','2013-12-07','13:35:00',2.36),('12664','2013-12-07','13:40:00',2.29),('12664','2013-12-07','13:45:00',2.21),('12664','2013-12-07','13:50:00',2.14),('12664','2013-12-07','13:55:00',2.08),('12664','2013-12-07','14:00:00',2.03),('12664','2013-12-07','14:05:00',2.01),('12664','2013-12-07','14:10:00',1.92),('12664','2013-12-07','14:15:00',1.88),('12664','2013-12-07','14:20:00',1.82),('12664','2013-12-07','14:25:00',1.77),('12664','2013-12-07','14:30:00',1.74),('12664','2013-12-07','14:35:00',1.69),('12664','2013-12-07','14:40:00',1.61),('12664','2013-12-07','14:45:00',1.53),('12664','2013-12-07','14:50:00',1.44),('12664','2013-12-07','14:55:00',1.36),('12664','2013-12-07','15:00:00',1.3),('12664','2013-12-07','15:05:00',1.21),('12664','2013-12-07','15:10:00',1.13),('12664','2013-12-07','15:15:00',1.06),('12664','2014-04-20','08:00:00',1.03),('12664','2014-04-20','08:05:00',1.29),('12664','2014-04-20','08:10:00',1.58),('12664','2014-04-20','08:15:00',1.83),('12664','2014-04-20','08:20:00',2.37),('12664','2014-04-20','08:25:00',1.12),('12664','2014-04-20','08:40:00',1.32),('12664','2014-04-20','08:45:00',1.87),('12664','2014-04-20','08:50:00',1.92),('12664','2014-04-20','08:55:00',2.06),('12664','2014-04-20','09:00:00',2.14),('12664','2014-04-20','09:05:00',2.24),('12664','2014-04-20','09:10:00',2.35),('12664','2014-04-20','09:15:00',2.48),('12664','2014-04-20','09:20:00',2.3),('12664','2014-04-20','09:25:00',2.1),('12664','2014-04-20','09:30:00',2.63),('12664','2014-04-20','09:35:00',3.07),('12664','2014-04-20','09:40:00',3.19),('12664','2014-04-20','09:45:00',2.91),('12664','2014-04-20','09:50:00',2.08),('12664','2014-04-20','09:55:00',1.39),('12664','2014-04-20','10:00:00',2.39),('12664','2014-04-20','10:05:00',2.16),('12664','2014-04-20','10:10:00',2.55),('12664','2014-04-20','10:15:00',2.63),('12664','2014-04-20','10:20:00',2.41),('12664','2014-04-20','10:25:00',2.92),('12664','2014-04-20','10:30:00',2.18),('12664','2014-04-20','10:35:00',2.08),('12664','2014-04-20','10:40:00',2.12),('12664','2014-04-20','10:45:00',2.7),('12664','2014-04-20','10:50:00',3.59),('12664','2014-04-20','10:55:00',3.86),('12664','2014-04-20','11:00:00',3.59),('12664','2014-04-20','11:05:00',3.23),('12664','2014-04-20','11:10:00',3.48),('12664','2014-04-20','11:15:00',3.94),('12664','2014-04-20','11:20:00',3.86),('12664','2014-04-20','11:25:00',4.05),('12664','2014-04-20','11:30:00',3.98),('12664','2014-04-20','11:35:00',4.07),('12664','2014-04-20','11:40:00',4.09),('12664','2014-04-20','11:45:00',4.07),('12664','2014-04-20','11:50:00',4.04),('12664','2014-04-20','11:55:00',4.08),('12664','2014-04-20','12:00:00',4.12),('12664','2014-04-20','12:05:00',4.1),('12664','2014-04-20','12:10:00',4.12),('12664','2014-04-20','12:15:00',4.12),('12664','2014-04-20','12:20:00',4.16),('12664','2014-04-20','12:25:00',4.17),('12664','2014-04-20','12:30:00',4.17),('12664','2014-04-20','12:35:00',4.2),('12664','2014-04-20','12:40:00',4.2),('12664','2014-04-20','12:45:00',4.14),('12664','2014-04-20','12:50:00',4.18),('12664','2014-04-20','12:55:00',4.2),('12664','2014-04-20','13:00:00',4.19),('12664','2014-04-20','13:05:00',4.23),('12664','2014-04-20','13:10:00',4.27),('12664','2014-04-20','13:15:00',3.93),('12664','2014-04-20','13:20:00',4.21),('12664','2014-04-20','13:25:00',4.16),('12664','2014-04-20','13:30:00',4.15),('12664','2014-04-20','13:35:00',4.15),('12664','2014-04-20','13:40:00',4.12),('12664','2014-04-20','13:45:00',4.17),('12664','2014-04-20','13:50:00',3.71),('12664','2014-04-20','13:55:00',4.11),('12664','2014-04-20','14:00:00',4.09),('12664','2014-04-20','14:05:00',3.81),('12664','2014-04-20','14:10:00',3.6),('12664','2014-04-20','14:15:00',3.86),('12664','2014-04-20','14:20:00',2.68),('12664','2014-04-20','14:25:00',2.46),('12664','2014-04-20','14:30:00',2.26),('12664','2014-04-20','14:35:00',2.13),('12664','2014-04-20','14:40:00',2.05),('12664','2014-04-20','14:45:00',2.2),('12664','2014-04-20','14:50:00',2.59),('12664','2014-04-20','14:55:00',2.65),('12664','2014-04-20','15:00:00',3.91),('12664','2014-04-20','15:05:00',4),('12664','2014-04-20','15:10:00',3.44),('12664','2014-04-20','15:15:00',3.68),('12664','2014-04-20','15:20:00',3.6),('12664','2014-04-20','15:25:00',3.52),('12664','2014-04-20','15:30:00',3.43),('12664','2014-04-20','15:35:00',3.51),('12664','2014-04-20','15:40:00',3.53),('12664','2014-04-20','15:45:00',2.38),('12664','2014-04-20','15:50:00',3.41),('12664','2014-04-20','15:55:00',3.21),('12664','2014-04-20','16:00:00',3.12),('12664','2014-04-20','16:05:00',3.07),('12664','2014-04-20','16:10:00',2.99),('12664','2014-04-20','16:15:00',2.99),('12664','2014-04-20','16:20:00',2.94),('12664','2014-04-20','16:25:00',2.9),('12664','2014-04-20','16:30:00',2.71),('12664','2014-04-20','16:35:00',2.82),('12664','2014-04-20','16:40:00',2.27),('12664','2014-04-20','16:45:00',1.98),('12664','2014-04-20','16:50:00',2.59),('12664','2014-04-20','16:55:00',2.38),('12664','2014-04-20','17:00:00',2.25),('12664','2014-04-20','17:05:00',2.14),('12664','2014-04-20','17:10:00',2.05),('12664','2014-04-20','17:15:00',1.95),('12664','2014-04-20','17:20:00',1.85),('12664','2014-04-20','17:25:00',1.76),('12664','2014-04-20','17:30:00',1.67),('12664','2014-04-20','17:35:00',1.58),('12664','2014-04-20','17:40:00',1.47),('12664','2014-04-20','17:45:00',1.38),('12664','2014-04-20','17:50:00',1.29),('12664','2014-04-20','17:55:00',1.19),('12664','2014-04-20','18:00:00',1.1),('12664','2014-04-20','18:05:00',1.01),('12664','2013-12-06','10:10:00',1.04),('12664','2013-12-06','10:15:00',1.1),('12664','2013-12-06','11:00:00',1.03),('12664','2013-12-06','11:10:00',1.25),('12664','2013-12-06','11:15:00',1.25),('12664','2013-12-06','11:20:00',2.19),('12664','2013-12-06','11:25:00',1.96),('12664','2013-12-06','11:30:00',2.35),('12664','2013-12-06','11:35:00',2.65),('12664','2013-12-06','11:40:00',2.81),('12664','2013-12-06','11:45:00',2.34),('12664','2013-12-06','11:50:00',1.9),('12664','2013-12-06','11:55:00',2.53),('12664','2013-12-06','12:00:00',2.78),('12664','2013-12-06','12:05:00',2.26),('12664','2013-12-06','12:10:00',2.15),('12664','2013-12-06','12:15:00',2.27),('12664','2013-12-06','12:20:00',1.3),('12664','2013-12-06','12:25:00',1.2),('12664','2013-12-06','12:30:00',1.22),('12664','2013-12-06','12:35:00',1.13),('12664','2013-12-06','12:40:00',1.05),('12664','2013-12-06','14:55:00',1.6),('12664','2013-12-06','15:00:00',1.51),('12664','2013-12-06','15:05:00',1.4),('12664','2013-12-06','15:10:00',1.42),('12664','2013-12-06','15:15:00',1.25),('12664','2013-12-05','08:30:00',1.05),('12664','2013-12-05','08:35:00',1.14),('12664','2013-12-05','08:40:00',1.24),('12664','2013-12-05','08:45:00',1.32),('12664','2013-12-05','08:50:00',1.4),('12664','2013-12-05','08:55:00',1.48),('12664','2013-12-05','09:00:00',1.57),('12664','2013-12-05','09:05:00',1.67),('12664','2013-12-05','09:10:00',1.76),('12664','2013-12-05','09:15:00',1.82),('12664','2013-12-05','09:20:00',1.89),('12664','2013-12-05','09:25:00',1.97),('12664','2013-12-05','09:30:00',2.04),('12664','2013-12-05','09:35:00',2.11),('12664','2013-12-05','09:40:00',2.19),('12664','2013-12-05','09:45:00',2.25),('12664','2013-12-05','09:50:00',2.3),('12664','2013-12-05','09:55:00',2.34),('12664','2013-12-05','10:00:00',2.39),('12664','2013-12-05','10:05:00',2.43),('12664','2013-12-05','10:10:00',2.49),('12664','2013-12-05','10:15:00',2.54),('12664','2013-12-05','10:20:00',2.59),('12664','2013-12-05','10:25:00',2.63),('12664','2013-12-05','10:30:00',2.66),('12664','2013-12-05','10:35:00',2.69),('12664','2013-12-05','10:40:00',2.73),('12664','2013-12-05','10:45:00',2.75),('12664','2013-12-05','10:50:00',2.75),('12664','2013-12-05','10:55:00',2.8),('12664','2013-12-05','11:00:00',2.8),('12664','2013-12-05','11:05:00',2.81),('12664','2013-12-05','11:10:00',2.82),('12664','2013-12-05','11:15:00',2.83),('12664','2013-12-05','11:20:00',2.89),('12664','2013-12-05','11:25:00',2.88),('12664','2013-12-05','11:30:00',2.86),('12664','2013-12-05','11:35:00',2.88),('12664','2013-12-05','11:40:00',2.88),('12664','2013-12-05','11:45:00',2.89),('12664','2013-12-05','11:50:00',2.92),('12664','2013-12-05','11:55:00',2.89),('12664','2013-12-05','12:00:00',2.9),('12664','2013-12-05','12:05:00',2.9),('12664','2013-12-05','12:10:00',2.94),('12664','2013-12-05','12:15:00',2.91),('12664','2013-12-05','12:20:00',2.87),('12664','2013-12-05','12:25:00',2.87),('12664','2013-12-05','12:30:00',2.9),('12664','2013-12-05','12:35:00',2.88),('12664','2013-12-05','12:40:00',2.85),('12664','2013-12-05','12:45:00',2.83),('12664','2013-12-05','12:50:00',2.84),('12664','2013-12-05','12:55:00',2.82),('12664','2013-12-05','13:00:00',2.79),('12664','2013-12-05','13:05:00',2.74),('12664','2013-12-05','13:10:00',2.62),('12664','2013-12-05','13:15:00',2.64),('12664','2013-12-05','13:20:00',2.54),('12664','2013-12-05','13:25:00',2.53),('12664','2013-12-05','13:30:00',2.55),('12664','2013-12-05','13:35:00',2.48),('12664','2013-12-05','13:40:00',2.47),('12664','2013-12-05','13:45:00',2.43),('12664','2013-12-05','13:50:00',2.45),('12664','2013-12-05','13:55:00',2.31),('12664','2013-12-05','14:00:00',2.27),('12664','2013-12-05','14:05:00',2.14),('12664','2013-12-05','14:10:00',2.06),('12664','2013-12-05','14:15:00',2.08),('12664','2013-12-05','14:20:00',1.96),('12664','2013-12-05','14:25:00',1.92),('12664','2013-12-05','14:30:00',1.8),('12664','2013-12-05','14:35:00',1.73),('12664','2013-12-05','14:40:00',1.67),('12664','2013-12-05','14:45:00',1.6),('12664','2013-12-05','14:50:00',1.54),('12664','2013-12-05','14:55:00',1.45),('12664','2013-12-05','15:00:00',1.35),('12664','2013-12-05','15:05:00',1.16),('12664','2013-12-05','15:10:00',1.13),('12664','2013-12-05','15:15:00',1.08),('12664','2013-12-04','08:20:00',1.07),('12664','2013-12-04','08:25:00',1.17),('12664','2013-12-04','08:30:00',1.27),('12664','2013-12-04','08:35:00',1.36),('12664','2013-12-04','08:40:00',1.47),('12664','2013-12-04','08:45:00',1.56),('12664','2013-12-04','08:50:00',1.65),('12664','2013-12-04','08:55:00',1.74),('12664','2013-12-04','09:00:00',1.82),('12664','2013-12-04','09:05:00',1.91),('12664','2013-12-04','09:10:00',1.98),('12664','2013-12-04','09:15:00',2.06),('12664','2013-12-04','09:20:00',2.13),('12664','2013-12-04','09:25:00',2.19),('12664','2013-12-04','09:30:00',2.26),('12664','2013-12-04','09:35:00',2.33),('12664','2013-12-04','09:40:00',2.39),('12664','2013-12-04','09:45:00',2.45),('12664','2013-12-04','09:50:00',2.5),('12664','2013-12-04','09:55:00',2.56),('12664','2013-12-04','10:00:00',2.61),('12664','2013-12-04','10:05:00',2.66),('12664','2013-12-04','10:10:00',2.71),('12664','2013-12-04','10:15:00',2.76),('12664','2013-12-04','10:20:00',2.81),('12664','2013-12-04','10:25:00',2.85),('12664','2013-12-04','10:30:00',2.86),('12664','2013-12-04','10:35:00',2.9),('12664','2013-12-04','10:40:00',2.93),('12664','2013-12-04','10:45:00',2.97),('12664','2013-12-04','10:50:00',2.98),('12664','2013-12-04','10:55:00',3.02),('12664','2013-12-04','11:00:00',3.05),('12664','2013-12-04','11:05:00',3.07),('12664','2013-12-04','11:10:00',3.09),('12664','2013-12-04','11:15:00',3.09),('12664','2013-12-04','11:20:00',3.09),('12664','2013-12-04','11:25:00',3.09),('12664','2013-12-04','11:30:00',3.11),('12664','2013-12-04','11:35:00',3.13),('12664','2013-12-04','11:40:00',3.14),('12664','2013-12-04','11:45:00',3.15),('12664','2013-12-04','11:50:00',3.16),('12664','2013-12-04','11:55:00',3.16),('12664','2013-12-04','12:00:00',3.17),('12664','2013-12-04','12:05:00',3.16),('12664','2013-12-04','12:10:00',3.14),('12664','2013-12-04','12:15:00',3.12),('12664','2013-12-04','12:20:00',3.1),('12664','2013-12-04','12:25:00',3.08),('12664','2013-12-04','12:30:00',3.07),('12664','2013-12-04','12:35:00',3.03),('12664','2013-12-04','12:40:00',3.03),('12664','2013-12-04','12:45:00',3.02),('12664','2013-12-04','12:50:00',2.96),('12664','2013-12-04','12:55:00',2.95),('12664','2013-12-04','13:00:00',2.92),('12664','2013-12-04','13:05:00',2.89),('12664','2013-12-04','13:10:00',2.86),('12664','2013-12-04','13:15:00',2.83),('12664','2013-12-04','13:20:00',2.78),('12664','2013-12-04','13:25:00',2.74),('12664','2013-12-04','13:30:00',2.69),('12664','2013-12-04','13:35:00',2.66),('12664','2013-12-04','13:40:00',2.63),('12664','2013-12-04','13:45:00',2.58),('12664','2013-12-04','13:50:00',2.53),('12664','2013-12-04','13:55:00',2.47),('12664','2013-12-04','14:00:00',2.41),('12664','2013-12-04','14:05:00',2.34),('12664','2013-12-04','14:10:00',2.29),('12664','2013-12-04','14:15:00',2.23),('12664','2013-12-04','14:20:00',2.17),('12664','2013-12-04','14:25:00',2.1),('12664','2013-12-04','14:30:00',2.03),('12664','2013-12-04','14:35:00',1.96),('12664','2013-12-04','14:40:00',1.89),('12664','2013-12-04','14:45:00',1.81),('12664','2013-12-04','14:50:00',1.73),('12664','2013-12-04','14:55:00',1.64),('12664','2013-12-04','15:00:00',1.55),('12664','2013-12-04','15:05:00',1.46),('12664','2013-12-04','15:10:00',1.37),('12664','2013-12-04','15:15:00',1.29),('12664','2013-12-04','15:20:00',1.19),('12664','2013-12-04','15:25:00',1.09),('12664','2013-12-03','08:55:00',1.35),('12664','2013-12-03','09:00:00',1.29),('12664','2013-12-03','09:05:00',1.08),('12664','2013-12-03','09:20:00',1.01),('12664','2013-12-03','09:25:00',1.34),('12664','2013-12-03','09:30:00',1.42),('12664','2013-12-03','09:35:00',1.62),('12664','2013-12-03','09:40:00',1.73),('12664','2013-12-03','09:45:00',2.07),('12664','2013-12-03','09:50:00',2.08),('12664','2013-12-03','09:55:00',2.54),('12664','2013-12-03','10:00:00',2.6),('12664','2013-12-03','10:05:00',2.65),('12664','2013-12-03','10:10:00',2.71),('12664','2013-12-03','10:15:00',2.74),('12664','2013-12-03','10:20:00',2.78),('12664','2013-12-03','10:25:00',2.81),('12664','2013-12-03','10:30:00',2.85),('12664','2013-12-03','10:35:00',2.89),('12664','2013-12-03','10:40:00',2.9),('12664','2013-12-03','10:45:00',2.93),('12664','2013-12-03','10:50:00',2.95),('12664','2013-12-03','10:55:00',3),('12664','2013-12-03','11:00:00',3.05),('12664','2013-12-03','11:05:00',3.09),('12664','2013-12-03','11:10:00',3.14),('12664','2013-12-03','11:15:00',3.18),('12664','2013-12-03','11:20:00',3.2),('12664','2013-12-03','11:25:00',3.22),('12664','2013-12-03','11:30:00',3.21),('12664','2013-12-03','11:35:00',3.22),('12664','2013-12-03','11:40:00',3.22),('12664','2013-12-03','11:45:00',3.24),('12664','2013-12-03','11:50:00',3.25),('12664','2013-12-03','11:55:00',3.23),('12664','2013-12-03','12:00:00',3.25),('12664','2013-12-03','12:05:00',3.28),('12664','2013-12-03','12:10:00',3.3),('12664','2013-12-03','12:15:00',3.3),('12664','2013-12-03','12:20:00',3.31),('12664','2013-12-03','12:25:00',3.35),('12664','2013-12-03','12:30:00',3.37),('12664','2013-12-03','12:35:00',3.39),('12664','2013-12-03','12:40:00',3.42),('12664','2013-12-03','12:45:00',3.45),('12664','2013-12-03','12:50:00',3.5),('12664','2013-12-03','12:55:00',3.58),('12664','2013-12-03','13:00:00',3.67),('12664','2013-12-03','13:05:00',3.69),('12664','2013-12-03','13:10:00',3.63),('12664','2013-12-03','13:15:00',3.55),('12664','2013-12-03','13:20:00',3.14),('12664','2013-12-03','13:25:00',2),('12664','2013-12-03','13:30:00',1.7),('12664','2013-12-03','13:35:00',1.95),('12664','2013-12-03','13:40:00',1.54),('12664','2013-12-03','13:45:00',1.17),('12664','2013-12-03','13:50:00',1.23),('12664','2013-12-03','13:55:00',1.26),('12664','2013-12-03','14:00:00',1.29),('12664','2013-12-03','14:05:00',1.53),('12664','2013-12-03','14:10:00',2.22),('12664','2013-12-03','14:15:00',2.05),('12664','2013-12-03','14:20:00',2.2),('12664','2013-12-03','14:25:00',2.07),('12664','2013-12-03','14:30:00',2.02),('12664','2013-12-03','14:35:00',1.95),('12664','2013-12-03','14:40:00',1.72),('12664','2013-12-03','14:45:00',1.47),('12664','2013-12-03','14:50:00',1.65),('12664','2013-12-03','14:55:00',1.6),('12664','2013-12-03','15:00:00',1.51),('12664','2013-12-03','15:05:00',1.41),('12664','2013-12-03','15:10:00',1.32),('12664','2013-12-03','15:15:00',1.23),('12664','2013-12-03','15:20:00',1.14),('12664','2013-12-03','15:25:00',1.04),('12664','2013-12-01','11:35:00',1.6),('12664','2013-12-01','11:40:00',2.31),('12664','2013-12-01','11:45:00',2.5),('12664','2013-12-01','11:50:00',2.17),('12664','2013-12-01','11:55:00',1.97),('12664','2013-12-01','12:00:00',2.75),('12664','2013-12-01','12:05:00',2.6),('12664','2013-12-01','12:10:00',2.45),('12664','2013-12-01','12:15:00',2.08),('12664','2013-12-01','12:20:00',1.44),('12664','2013-12-01','12:25:00',1.54),('12664','2013-11-30','09:05:00',1.1),('12664','2013-11-30','09:10:00',1.77),('12664','2013-11-30','09:15:00',1.71),('12664','2013-11-30','09:20:00',1.69),('12664','2013-11-30','09:25:00',1.76),('12664','2013-11-30','09:30:00',1.85),('12664','2013-11-30','09:35:00',1.46),('12664','2013-11-30','09:40:00',1.3),('12664','2013-11-30','09:45:00',1.09),('12664','2013-11-30','09:50:00',1.01),('12664','2013-11-30','10:20:00',1.2),('12664','2013-11-30','10:25:00',1.11),('12664','2013-11-30','10:30:00',1.04),('12664','2013-11-30','10:35:00',1.03),('12664','2013-11-30','10:40:00',1.07),('12664','2013-11-30','10:45:00',1.07),('12664','2013-11-30','10:50:00',1.1),('12664','2013-11-30','10:55:00',1.32),('12664','2013-11-30','11:00:00',1.32),('12664','2013-11-30','11:05:00',1.2),('12664','2013-11-30','11:10:00',1.27),('12664','2013-11-30','11:15:00',1.32),('12664','2013-11-30','11:20:00',1.31),('12664','2013-11-30','11:25:00',1.2),('12664','2013-11-30','11:30:00',1.24),('12664','2013-11-30','11:35:00',1.11),('12664','2013-11-29','08:20:00',1.09),('12664','2013-11-29','08:25:00',1.17),('12664','2013-11-29','08:30:00',1.26),('12664','2013-11-29','08:35:00',1.36),('12664','2013-11-29','08:40:00',1.45),('12664','2013-11-29','08:45:00',1.54),('12664','2013-11-29','08:50:00',1.62),('12664','2013-11-29','08:55:00',1.71),('12664','2013-11-29','09:00:00',1.79),('12664','2013-11-29','09:05:00',1.87),('12664','2013-11-29','09:10:00',1.94),('12664','2013-11-29','09:15:00',2.01),('12664','2013-11-29','09:20:00',2.09),('12664','2013-11-29','09:25:00',2.15),('12664','2013-11-29','09:30:00',2.21),('12664','2013-11-29','09:35:00',2.27),('12664','2013-11-29','09:40:00',2.32),('12664','2013-11-29','09:45:00',2.38),('12664','2013-11-29','09:50:00',2.44),('12664','2013-11-29','09:55:00',2.5),('12664','2013-11-29','10:00:00',2.57),('12664','2013-11-29','10:05:00',2.63),('12664','2013-11-29','10:10:00',2.69),('12664','2013-11-29','10:15:00',2.72),('12664','2013-11-29','10:20:00',2.76),('12664','2013-11-29','10:25:00',2.82),('12664','2013-11-29','10:30:00',2.86),('12664','2013-11-29','10:35:00',2.89),('12664','2013-11-29','10:40:00',2.91),('12664','2013-11-29','10:45:00',2.93),('12664','2013-11-29','10:50:00',2.96),('12664','2013-11-29','10:55:00',2.99),('12664','2013-11-29','11:00:00',3.03),('12664','2013-11-29','11:05:00',3.05),('12664','2013-11-29','11:10:00',3.08),('12664','2013-11-29','11:15:00',3.1),('12664','2013-11-29','11:20:00',3.12),('12664','2013-11-29','11:25:00',3.14),('12664','2013-11-29','11:30:00',3.17),('12664','2013-11-29','11:35:00',3.19),('12664','2013-11-29','11:40:00',3.18),('12664','2013-11-29','11:45:00',3.18),('12664','2013-11-29','11:50:00',3.2),('12664','2013-11-29','11:55:00',3.17),('12664','2013-11-29','12:00:00',3.18),('12664','2013-11-29','12:05:00',3.17),('12664','2013-11-29','12:10:00',3.17),('12664','2013-11-29','12:15:00',3.17),('12664','2013-11-29','12:20:00',3.17),('12664','2013-11-29','12:25:00',3.16),('12664','2013-11-29','12:30:00',3.14),('12664','2013-11-29','12:35:00',3.12),('12664','2013-11-29','12:40:00',3.1),('12664','2013-11-29','12:45:00',3.07),('12664','2013-11-29','12:50:00',3.04),('12664','2013-11-29','12:55:00',3.02),('12664','2013-11-29','13:00:00',2.96),('12664','2013-11-29','13:05:00',2.95),('12664','2013-11-29','13:10:00',2.89),('12664','2013-11-29','13:15:00',2.82),('12664','2013-11-29','13:20:00',2.79),('12664','2013-11-29','13:25:00',2.76),('12664','2013-11-29','13:30:00',2.73),('12664','2013-11-29','13:35:00',2.67),('12664','2013-11-29','13:40:00',2.6),('12664','2013-11-29','13:45:00',2.55),('12664','2013-11-29','13:50:00',2.5),('12664','2013-11-29','13:55:00',2.42),('12664','2013-11-29','14:00:00',2.37),('12664','2013-11-29','14:05:00',2.3),('12664','2013-11-29','14:10:00',2.24),('12664','2013-11-29','14:15:00',2.18),('12664','2013-11-29','14:20:00',2.14),('12664','2013-11-29','14:25:00',2.06),('12664','2013-11-29','14:30:00',1.98),('12664','2013-11-29','14:35:00',1.9),('12664','2013-11-29','14:40:00',1.83),('12664','2013-11-29','14:45:00',1.75),('12664','2013-11-29','14:50:00',1.66),('12664','2013-11-29','14:55:00',1.57),('12664','2013-11-29','15:00:00',1.48),('12664','2013-11-29','15:05:00',1.4),('12664','2013-11-29','15:10:00',1.31),('12664','2013-11-29','15:15:00',1.22),('12664','2013-11-29','15:20:00',1.13),('12664','2013-11-29','15:25:00',1.04),('12664','2013-11-27','08:55:00',1.08),('12664','2013-11-27','09:00:00',1.25),('12664','2013-11-27','09:05:00',1.25),('12664','2013-11-27','09:10:00',1.12),('12664','2013-11-27','09:25:00',1.43),('12664','2013-11-27','09:30:00',1.56),('12664','2013-11-27','09:35:00',1.37),('12664','2013-11-27','09:40:00',1.11),('12664','2013-11-27','09:45:00',1.01),('12664','2013-11-27','10:00:00',1.02),('12664','2013-11-27','10:05:00',1.11),('12664','2013-11-27','10:10:00',1.17),('12664','2013-11-27','10:15:00',1.3),('12664','2013-11-27','10:20:00',1.51),('12664','2013-11-27','10:25:00',1.52),('12664','2013-11-27','10:30:00',1.29),('12664','2013-11-27','10:35:00',1.35),('12664','2013-11-27','10:40:00',1.22),('12664','2013-11-27','10:45:00',1.26),('12664','2013-11-27','10:50:00',1.26),('12664','2013-11-27','10:55:00',1.25),('12664','2013-11-27','11:00:00',1.35),('12664','2013-11-27','11:05:00',1.59),('12664','2013-11-27','11:10:00',1.67),('12664','2013-11-27','11:15:00',1.68),('12664','2013-11-27','11:20:00',2.52),('12664','2013-11-27','11:25:00',1.68),('12664','2013-11-27','11:30:00',1.69),('12664','2013-11-27','11:35:00',1.96),('12664','2013-11-27','11:40:00',1.76),('12664','2013-11-27','11:45:00',2.54),('12664','2013-11-27','11:50:00',3.73),('12664','2013-11-27','11:55:00',2.12),('12664','2013-11-27','12:00:00',1.57),('12664','2013-11-27','12:05:00',1.73),('12664','2013-11-27','12:10:00',2.74),('12664','2013-11-27','12:15:00',2.59),('12664','2013-11-27','12:20:00',2.08),('12664','2013-11-27','12:25:00',2.24),('12664','2013-11-27','12:30:00',2.21),('12664','2013-11-27','12:35:00',1.99),('12664','2013-11-27','12:40:00',1.7),('12664','2013-11-27','12:45:00',1.57),('12664','2013-11-27','12:50:00',1.21),('12664','2013-11-27','13:10:00',1.06),('12664','2013-11-27','13:15:00',1.09),('12664','2013-11-27','13:20:00',1.05),('12664','2013-11-27','13:25:00',1.17),('12664','2013-11-27','13:30:00',1.11),('12664','2014-04-19','08:10:00',1.04),('12664','2014-04-19','08:15:00',1.08),('12664','2014-04-19','08:20:00',1.11),('12664','2014-04-19','08:25:00',1.06),('12664','2014-04-19','08:30:00',1.07),('12664','2014-04-19','09:25:00',1.07),('12664','2014-04-19','10:35:00',2.32),('12664','2014-04-19','10:40:00',1.61),('12664','2014-04-19','10:45:00',1.61),('12664','2014-04-19','10:50:00',1.75),('12664','2014-04-19','10:55:00',1.2),('12664','2014-04-19','11:00:00',1.15),('12664','2014-04-19','11:05:00',1.79),('12664','2014-04-19','11:10:00',3.02),('12664','2014-04-19','11:15:00',3.71),('12664','2014-04-19','11:20:00',3.14),('12664','2014-04-19','11:25:00',2.26),('12664','2014-04-19','11:30:00',3.16),('12664','2014-04-19','11:35:00',2.67),('12664','2014-04-19','11:40:00',1.98),('12664','2014-04-19','11:45:00',1.24),('12664','2014-04-19','14:35:00',1.17),('12664','2014-04-19','14:40:00',1.15),('12664','2014-04-19','15:00:00',1.46),('12664','2014-04-19','15:25:00',1.07),('12664','2014-04-19','15:40:00',1.89),('12664','2014-04-19','15:45:00',3.44),('12664','2014-04-19','15:50:00',2.53),('12664','2014-04-19','15:55:00',2.15),('12664','2014-04-19','16:00:00',1.19),('12664','2014-04-19','16:05:00',1.43),('12664','2014-04-19','16:10:00',1.31),('12664','2014-04-19','16:15:00',1.57),('12664','2014-04-19','16:20:00',1.75),('12664','2014-04-19','16:25:00',2.5),('12664','2014-04-19','16:30:00',1.41),('12664','2014-04-19','16:35:00',1.25),('12664','2014-04-19','16:40:00',1.24),('12664','2014-04-19','17:00:00',1.26),('12664','2014-04-19','17:05:00',1.16),('12664','2014-04-19','17:10:00',1.03),('12664','2014-04-19','17:15:00',1.33),('12664','2014-04-19','17:20:00',1.23),('12664','2013-11-26','08:40:00',1.32),('12664','2013-11-26','09:00:00',1.02),('12664','2013-11-26','09:05:00',1.58),('12664','2013-11-26','09:20:00',1.11),('12664','2013-11-26','09:25:00',1.15),('12664','2013-11-26','09:30:00',1.25),('12664','2013-11-26','09:35:00',1.21),('12664','2013-11-26','09:40:00',1.52),('12664','2013-11-26','09:45:00',1.75),('12664','2013-11-26','09:50:00',1.9),('12664','2013-11-26','09:55:00',2.91),('12664','2013-11-26','10:00:00',1.27),('12664','2013-11-26','10:15:00',1.08),('12664','2013-11-26','10:20:00',1.11),('12664','2013-11-26','10:25:00',2.91),('12664','2013-11-26','10:30:00',3.32),('12664','2013-11-26','10:35:00',3.36),('12664','2013-11-26','10:40:00',3.41),('12664','2013-11-26','10:45:00',3.48),('12664','2013-11-26','10:50:00',3.5),('12664','2013-11-26','10:55:00',3.5),('12664','2013-11-26','11:00:00',3.59),('12664','2013-11-26','11:05:00',3.77),('12664','2013-11-26','11:10:00',1.67),('12664','2013-11-26','11:15:00',2.24),('12664','2013-11-26','11:20:00',2.65),('12664','2013-11-26','11:25:00',1.9),('12664','2013-11-26','11:30:00',3.26),('12664','2013-11-26','11:35:00',1.97),('12664','2013-11-26','11:40:00',3.01),('12664','2013-11-26','11:45:00',3.37),('12664','2013-11-26','11:50:00',3.66),('12664','2013-11-26','11:55:00',3.88),('12664','2013-11-26','12:00:00',3.53),('12664','2013-11-26','12:05:00',3.42),('12664','2013-11-26','12:10:00',1.82),('12664','2013-11-26','12:15:00',3.31),('12664','2013-11-26','12:20:00',2.7),('12664','2013-11-26','12:25:00',2.38),('12664','2013-11-26','12:30:00',3.62),('12664','2013-11-26','12:35:00',3.49),('12664','2013-11-26','12:40:00',3.45),('12664','2013-11-26','12:45:00',3.39),('12664','2013-11-26','12:50:00',3.36),('12664','2013-11-26','12:55:00',3.32),('12664','2013-11-26','13:00:00',3.28),('12664','2013-11-26','13:05:00',3.24),('12664','2013-11-26','13:10:00',3.21),('12664','2013-11-26','13:15:00',3.16),('12664','2013-11-26','13:20:00',3.13),('12664','2013-11-26','13:25:00',3.09),('12664','2013-11-26','13:30:00',3.09),('12664','2013-11-26','13:35:00',2.72),('12664','2013-11-26','13:40:00',2.89),('12664','2013-11-26','13:45:00',2.89),('12664','2013-11-26','13:50:00',2.57),('12664','2013-11-26','13:55:00',3.03),('12664','2013-11-26','14:00:00',2.86),('12664','2013-11-26','14:05:00',2.97),('12664','2013-11-26','14:10:00',2.8),('12664','2013-11-26','14:15:00',2.76),('12664','2013-11-26','14:20:00',2.25),('12664','2013-11-26','14:25:00',1.42),('12664','2013-11-26','14:30:00',2.3),('12664','2013-11-26','14:35:00',2.35),('12664','2013-11-26','14:40:00',1.86),('12664','2013-11-26','14:45:00',1.53),('12664','2013-11-26','14:50:00',1.98),('12664','2013-11-26','14:55:00',1.25),('12664','2013-11-26','15:05:00',1.42),('12664','2013-11-26','15:10:00',1.58),('12664','2013-11-26','15:15:00',1.47),('12664','2013-11-26','15:20:00',1.38),('12664','2013-11-26','15:25:00',1.27),('12664','2013-11-26','15:30:00',1.16),('12664','2013-11-26','15:35:00',1.06),('12664','2013-11-25','08:10:00',1.1),('12664','2013-11-25','08:15:00',1.29),('12664','2013-11-25','08:20:00',1.42),('12664','2013-11-25','08:25:00',1.37),('12664','2013-11-25','08:30:00',1.69),('12664','2013-11-25','08:35:00',1.87),('12664','2013-11-25','08:40:00',2.07),('12664','2013-11-25','08:45:00',2.18),('12664','2013-11-25','08:50:00',2.11),('12664','2013-11-25','08:55:00',1.35),('12664','2013-11-25','09:35:00',1.04),('12664','2013-11-25','09:45:00',1),('12664','2013-11-25','10:00:00',1.35),('12664','2013-11-25','10:05:00',2.02),('12664','2013-11-25','10:10:00',3.16),('12664','2013-11-25','10:15:00',2.62),('12664','2013-11-25','10:20:00',1.96),('12664','2013-11-25','10:25:00',1.31),('12664','2013-11-25','10:30:00',1.83),('12664','2013-11-25','10:35:00',3.63),('12664','2013-11-25','10:40:00',3.17),('12664','2013-11-25','10:45:00',2.71),('12664','2013-11-25','10:50:00',3.05),('12664','2013-11-25','10:55:00',3.2),('12664','2013-11-25','11:00:00',3.21),('12664','2013-11-25','11:05:00',3.35),('12664','2013-11-25','11:10:00',2.92),('12664','2013-11-25','11:15:00',1.24),('12664','2013-11-25','11:20:00',3.23),('12664','2013-11-25','11:25:00',1.57),('12664','2013-11-25','11:30:00',1.6),('12664','2013-11-25','11:35:00',2.97),('12664','2013-11-25','11:40:00',3.32),('12664','2013-11-25','11:45:00',3.58),('12664','2013-11-25','11:50:00',3.41),('12664','2013-11-25','11:55:00',2.04),('12664','2013-11-25','12:00:00',1.68),('12664','2013-11-25','12:05:00',1.51),('12664','2013-11-25','12:10:00',1.45),('12664','2013-11-25','12:15:00',1.98),('12664','2013-11-25','12:20:00',1.75),('12664','2013-11-25','12:25:00',1.55),('12664','2013-11-25','12:30:00',1.24),('12664','2013-11-25','12:35:00',1.09),('12664','2013-11-25','12:40:00',1.19),('12664','2013-11-25','12:45:00',3.18),('12664','2013-11-25','12:50:00',2.49),('12664','2013-11-25','12:55:00',2.59),('12664','2013-11-25','13:00:00',1.97),('12664','2013-11-25','13:05:00',2),('12664','2013-11-25','13:10:00',3.73),('12664','2013-11-25','13:15:00',3.82),('12664','2013-11-25','13:20:00',3.76),('12664','2013-11-25','13:25:00',1.58),('12664','2013-11-25','13:30:00',1.03),('12664','2013-11-25','13:35:00',1.08),('12664','2013-11-25','13:40:00',1.31),('12664','2013-11-25','13:45:00',1.24),('12664','2013-11-25','13:50:00',1.11),('12664','2013-11-24','10:00:00',1.32),('12664','2013-11-24','10:05:00',1.62),('12664','2013-11-24','10:10:00',1.46),('12664','2013-11-24','10:15:00',1.26),('12664','2013-11-24','10:20:00',1.24),('12664','2013-11-24','10:25:00',1.79),('12664','2013-11-24','10:30:00',2.39),('12664','2013-11-24','10:35:00',2.07),('12664','2013-11-24','10:40:00',1.84),('12664','2013-11-24','10:45:00',1.17),('12664','2013-11-24','11:00:00',1.02),('12664','2013-11-24','11:05:00',1.21),('12664','2013-11-24','11:10:00',1.18),('12664','2013-11-24','11:15:00',1.23),('12664','2013-11-24','11:20:00',1.58),('12664','2013-11-24','11:25:00',1.37),('12664','2013-11-24','11:30:00',1.25),('12664','2013-11-24','11:35:00',1.13),('12664','2013-11-24','11:40:00',1.04),('12664','2013-11-24','12:40:00',1.1),('12664','2013-11-24','12:45:00',1.26),('12664','2013-11-24','12:50:00',1.44),('12664','2013-11-24','12:55:00',1.86),('12664','2013-11-24','13:00:00',2.35),('12664','2013-11-24','13:05:00',1.77),('12664','2013-11-24','13:10:00',1.46),('12664','2013-11-24','13:15:00',1.55),('12664','2013-11-24','13:20:00',1.44),('12664','2013-11-24','13:25:00',1.29),('12664','2013-11-24','13:30:00',1.18),('12664','2013-11-24','13:35:00',1.15),('12664','2013-11-24','13:40:00',1.12),('12664','2013-11-24','13:45:00',1.04),('12664','2013-11-23','08:40:00',1.55),('12664','2013-11-23','10:25:00',1.23),('12664','2013-11-23','10:30:00',2.78),('12664','2013-11-23','10:35:00',1.07),('12664','2013-11-22','12:15:00',1.18),('12664','2013-11-22','12:20:00',1.45),('12664','2013-11-22','12:25:00',1.37),('12664','2013-11-21','08:05:00',1.02),('12664','2013-11-21','09:40:00',1.36),('12664','2013-11-21','09:45:00',2.4),('12664','2013-11-21','09:50:00',2.74),('12664','2013-11-21','09:55:00',2.84),('12664','2013-11-21','10:00:00',2.91),('12664','2013-11-21','10:05:00',2.89),('12664','2013-11-21','10:10:00',2.76),('12664','2013-11-21','10:15:00',3.12),('12664','2013-11-21','10:20:00',2.88),('12664','2013-11-21','10:25:00',3.11),('12664','2013-11-21','10:30:00',1.16),('12664','2013-11-21','10:35:00',2.52),('12664','2013-11-21','10:40:00',1.58),('12664','2013-11-21','10:45:00',2.27),('12664','2013-11-21','10:50:00',2.3),('12664','2013-11-21','10:55:00',2.88),('12664','2013-11-21','11:00:00',1.57),('12664','2013-11-21','11:05:00',3.11),('12664','2013-11-21','11:10:00',2.08),('12664','2013-11-21','11:15:00',3.05),('12664','2013-11-21','11:20:00',2.89),('12664','2013-11-21','11:25:00',3.34),('12664','2013-11-21','11:30:00',3.36),('12664','2013-11-21','11:35:00',3.35),('12664','2013-11-21','11:40:00',3.35),('12664','2013-11-21','11:45:00',3.34),('12664','2013-11-21','11:50:00',3.36),('12664','2013-11-21','11:55:00',3.43),('12664','2013-11-21','12:00:00',3.65),('12664','2013-11-21','12:05:00',3.63),('12664','2013-11-21','12:10:00',3.88),('12664','2013-11-21','12:15:00',3.01),('12664','2013-11-21','12:20:00',2.73),('12664','2013-11-21','12:25:00',1.31),('12664','2013-11-21','12:35:00',1.64),('12664','2013-11-21','12:50:00',1.22),('12664','2013-11-21','12:55:00',3.28),('12664','2013-11-21','13:00:00',2.5),('12664','2013-11-21','13:05:00',2.57),('12664','2013-11-21','13:10:00',3.04),('12664','2013-11-21','13:15:00',1.76),('12664','2013-11-21','13:20:00',1.94),('12664','2013-11-21','13:25:00',3.06),('12664','2013-11-21','13:30:00',2.88),('12664','2013-11-21','13:35:00',2.9),('12664','2013-11-21','13:40:00',2.66),('12664','2013-11-21','13:45:00',2.87),('12664','2013-11-21','13:50:00',2.77),('12664','2013-11-21','13:55:00',1.43),('12664','2013-11-21','14:05:00',2.12),('12664','2013-11-21','14:10:00',2.42),('12664','2013-11-21','14:15:00',1.94),('12664','2013-11-21','14:20:00',2.3),('12664','2013-11-21','14:25:00',2.25),('12664','2013-11-21','14:30:00',1.98),('12664','2013-11-21','14:35:00',2.06),('12664','2013-11-21','14:40:00',1.99),('12664','2013-11-21','14:45:00',1.9),('12664','2013-11-21','14:50:00',1.79),('12664','2013-11-21','14:55:00',1.69),('12664','2013-11-21','15:00:00',1.62),('12664','2013-11-21','15:05:00',1.53),('12664','2013-11-21','15:10:00',1.31),('12664','2013-11-20','08:50:00',1.87),('12664','2013-11-20','08:55:00',1.93),('12664','2013-11-20','09:00:00',1.96),('12664','2013-11-20','09:05:00',2.01),('12664','2013-11-20','09:10:00',2.16),('12664','2013-11-20','09:15:00',2.14),('12664','2013-11-20','09:20:00',1.75),('12664','2013-11-20','11:50:00',1.73),('12664','2013-11-20','12:10:00',1.24),('12664','2013-11-20','12:15:00',1.89),('12664','2013-11-20','12:20:00',2.52),('12664','2013-11-20','12:25:00',1.25),('12664','2013-11-20','12:55:00',1.18),('12664','2013-11-20','13:00:00',1.64),('12664','2013-11-20','13:10:00',1.03),('12664','2013-11-20','13:15:00',1.09),('12664','2013-11-20','13:20:00',1.58),('12664','2013-11-20','13:25:00',1.5),('12664','2013-11-20','13:30:00',1.61),('12664','2013-11-20','13:35:00',1.72),('12664','2013-11-20','13:45:00',1.63),('12664','2013-11-20','13:50:00',1.38),('12664','2013-11-20','14:15:00',1.05),('12664','2013-11-20','14:30:00',1.15),('12664','2013-11-20','14:35:00',2.29),('12664','2013-11-20','14:40:00',1.2),('12664','2013-11-20','14:45:00',1.48),('12664','2013-11-20','14:50:00',1.82),('12664','2013-11-20','14:55:00',1.79),('12664','2013-11-20','15:00:00',1.73),('12664','2013-11-20','15:05:00',1.78),('12664','2013-11-20','15:10:00',1.33),('12664','2013-11-20','15:15:00',1.35),('12664','2013-11-20','15:20:00',1.28),('12664','2013-11-20','15:30:00',1.04),('12664','2013-11-20','15:35:00',1.01),('12664','2013-11-19','08:15:00',1.17),('12664','2013-11-19','08:35:00',1.09),('12664','2013-11-19','09:15:00',1.38),('12664','2013-11-19','09:35:00',2.36),('12664','2013-11-19','09:40:00',2.36),('12664','2013-11-19','09:45:00',2.5),('12664','2013-11-19','09:50:00',2.55),('12664','2013-11-19','09:55:00',2.66),('12664','2013-11-19','10:00:00',2.74),('12664','2013-11-19','10:05:00',2.5),('12664','2013-11-19','10:10:00',2.87),('12664','2013-11-19','10:15:00',2.23),('12664','2013-11-19','10:55:00',1.51),('12664','2013-11-19','11:00:00',1.41),('12664','2013-11-19','11:10:00',1.31),('12664','2013-11-19','11:15:00',1.29),('12664','2013-11-19','11:20:00',1.95),('12664','2013-11-19','11:25:00',1.48),('12664','2013-11-19','11:30:00',3.03),('12664','2013-11-19','11:35:00',2.65),('12664','2013-11-19','11:40:00',2.03),('12664','2013-11-19','11:45:00',2.77),('12664','2013-11-19','11:50:00',3.11),('12664','2013-11-19','11:55:00',2.92),('12664','2013-11-19','12:00:00',2.94),('12664','2013-11-19','12:05:00',2.96),('12664','2013-11-19','12:10:00',2.84),('12664','2013-11-19','12:15:00',2.89),('12664','2013-11-19','12:20:00',2.88),('12664','2013-11-19','12:25:00',1.76),('12664','2013-11-19','12:30:00',2.97),('12664','2013-11-19','12:35:00',2.32),('12664','2013-11-19','12:45:00',3.18),('12664','2013-11-19','12:50:00',2.94),('12664','2013-11-19','13:10:00',1.3),('12664','2013-11-19','13:15:00',2.67),('12664','2013-11-19','13:30:00',1.11),('12664','2013-11-19','15:15:00',1.28),('12664','2013-11-19','15:20:00',1.77),('12664','2013-11-19','15:25:00',1.82),('12664','2013-11-19','15:30:00',1.67),('12664','2013-11-19','15:35:00',1.21),('12664','2013-11-18','08:05:00',1.03),('12664','2013-11-18','08:40:00',1.15),('12664','2013-11-18','08:55:00',1.11),('12664','2013-11-18','09:15:00',1.31),('12664','2013-11-18','09:20:00',1.67),('12664','2013-11-18','09:25:00',1.69),('12664','2013-11-18','09:30:00',2.2),('12664','2013-11-18','09:35:00',2.05),('12664','2013-11-18','09:40:00',1.32),('12664','2013-11-18','09:55:00',1),('12664','2013-11-18','10:00:00',1.34),('12664','2013-11-18','10:05:00',1.54),('12664','2013-11-18','10:10:00',1.63),('12664','2013-11-18','10:15:00',1.76),('12664','2013-11-18','10:20:00',1.48),('12664','2013-11-18','10:25:00',1.14),('12664','2013-11-18','10:30:00',1.04),('12664','2013-11-18','10:35:00',1.14),('12664','2013-11-18','10:40:00',1.31),('12664','2013-11-18','10:45:00',1.31),('12664','2013-11-18','10:50:00',1.2),('12664','2013-11-18','11:25:00',1.08),('12664','2013-11-18','11:30:00',1.14),('12664','2013-11-18','11:35:00',1.18),('12664','2013-11-18','11:40:00',1.17),('12664','2013-11-18','11:45:00',1.21),('12664','2013-11-18','11:50:00',1.31),('12664','2013-11-18','11:55:00',1.38),('12664','2013-11-18','12:00:00',1.49),('12664','2013-11-18','12:05:00',1.4),('12664','2013-11-18','12:10:00',1.38),('12664','2013-11-18','12:15:00',1.43),('12664','2013-11-18','12:20:00',1.72),('12664','2013-11-18','12:25:00',2.06),('12664','2013-11-18','12:30:00',1.94),('12664','2013-11-18','12:35:00',1.51),('12664','2013-11-18','12:40:00',1.26),('12664','2013-11-18','12:45:00',1.01),('12664','2013-11-18','13:10:00',1.02),('12664','2013-11-18','13:40:00',1.04),('12664','2013-11-18','13:45:00',1.17),('12664','2013-11-18','13:50:00',1.09),('12664','2013-11-17','08:55:00',1.38),('12664','2013-11-17','09:00:00',2.23),('12664','2013-11-17','09:05:00',2.19),('12664','2013-11-17','09:10:00',2.28),('12664','2013-11-17','09:15:00',2.29),('12664','2013-11-17','09:20:00',2.26),('12664','2013-11-17','09:25:00',1.64),('12664','2013-11-17','09:30:00',1.5),('12664','2013-11-17','09:35:00',2.57),('12664','2013-11-17','09:40:00',2.59),('12664','2013-11-17','09:45:00',2.57),('12664','2013-11-17','09:50:00',2.57),('12664','2013-11-17','09:55:00',2.59),('12664','2013-11-17','10:00:00',2.63),('12664','2013-11-17','10:05:00',2.67),('12664','2013-11-17','10:10:00',2.71),('12664','2013-11-17','10:15:00',2.76),('12664','2013-11-17','10:20:00',2.79),('12664','2013-11-17','10:25:00',2.83),('12664','2013-11-17','10:30:00',2.87),('12664','2013-11-17','10:35:00',2.89),('12664','2013-11-17','10:40:00',2.93),('12664','2013-11-17','10:45:00',2.95),('12664','2013-11-17','10:50:00',2.99),('12664','2013-11-17','10:55:00',2.98),('12664','2013-11-17','11:00:00',2.99),('12664','2013-11-17','11:05:00',3.02),('12664','2013-11-17','11:10:00',3.04),('12664','2013-11-17','11:15:00',3.06),('12664','2013-11-17','11:20:00',3.05),('12664','2013-11-17','11:25:00',3.06),('12664','2013-11-17','11:30:00',3.08),('12664','2013-11-17','11:35:00',3.08),('12664','2013-11-17','11:40:00',3.07),('12664','2013-11-17','11:45:00',3.06),('12664','2013-11-17','11:50:00',3.05),('12664','2013-11-17','11:55:00',3.06),('12664','2013-11-17','12:00:00',3.07),('12664','2013-11-17','12:05:00',3.07),('12664','2013-11-17','12:10:00',3.02),('12664','2013-11-17','12:15:00',3.06),('12664','2013-11-17','12:20:00',3.15),('12664','2013-11-17','12:25:00',3.19),('12664','2013-11-17','12:30:00',3.03),('12664','2013-11-17','12:35:00',2.98),('12664','2013-11-17','12:40:00',2.96),('12664','2013-11-17','12:45:00',2.93),('12664','2013-11-17','12:50:00',2.91),('12664','2013-11-17','12:55:00',2.88),('12664','2013-11-17','13:00:00',2.86),('12664','2013-11-17','13:05:00',2.83),('12664','2013-11-17','13:10:00',2.79),('12664','2013-11-17','13:15:00',2.78),('12664','2013-11-17','13:20:00',2.79),('12664','2013-11-17','13:25:00',2.8),('12664','2013-11-17','13:30:00',2.77),('12664','2013-11-17','13:35:00',2.72),('12664','2013-11-17','13:40:00',2.59),('12664','2013-11-17','13:45:00',2.49),('12664','2013-11-17','13:50:00',1.99),('12664','2013-11-17','13:55:00',2.39),('12664','2013-11-17','14:00:00',2.28),('12664','2013-11-17','14:05:00',2.06),('12664','2013-11-17','14:10:00',2.26),('12664','2013-11-17','14:15:00',2.18),('12664','2013-11-17','14:20:00',2.02),('12664','2013-11-17','14:25:00',1.85),('12664','2013-11-17','14:30:00',1.97),('12664','2013-11-17','14:35:00',1),('12664','2013-11-17','15:05:00',1.47),('12664','2013-11-17','15:10:00',1.44),('12664','2013-11-17','15:15:00',1.32),('12664','2013-11-17','15:20:00',1.23),('12664','2013-11-17','15:25:00',1.15),('12664','2013-11-17','15:30:00',1.04),('12664','2014-04-18','08:10:00',1.35),('12664','2014-04-18','08:20:00',1.2),('12664','2014-04-18','08:35:00',1.24),('12664','2014-04-18','08:40:00',1),('12664','2014-04-18','08:45:00',2.11),('12664','2014-04-18','08:50:00',1.56),('12664','2014-04-18','08:55:00',1.04),('12664','2014-04-18','09:05:00',1),('12664','2014-04-18','09:10:00',1.99),('12664','2014-04-18','09:15:00',2.72),('12664','2014-04-18','09:20:00',2.21),('12664','2014-04-18','09:25:00',1.89),('12664','2014-04-18','09:30:00',2.01),('12664','2014-04-18','09:35:00',1.88),('12664','2014-04-18','09:40:00',2.76),('12664','2014-04-18','09:45:00',2.49),('12664','2014-04-18','09:50:00',2.27),('12664','2014-04-18','09:55:00',1.54),('12664','2014-04-18','10:00:00',1.48),('12664','2014-04-18','10:05:00',1.31),('12664','2014-04-18','10:10:00',1.4),('12664','2014-04-18','10:15:00',1.25),('12664','2014-04-18','10:20:00',1.59),('12664','2014-04-18','10:25:00',1.33),('12664','2014-04-18','10:30:00',1.25),('12664','2014-04-18','10:35:00',1.57),('12664','2014-04-18','10:40:00',2.83),('12664','2014-04-18','10:45:00',2.78),('12664','2014-04-18','10:50:00',3.37),('12664','2014-04-18','10:55:00',3.43),('12664','2014-04-18','11:00:00',2.54),('12664','2014-04-18','11:05:00',2.42),('12664','2014-04-18','11:10:00',2.11),('12664','2014-04-18','11:15:00',2.26),('12664','2014-04-18','11:20:00',2.01),('12664','2014-04-18','11:25:00',2.48),('12664','2014-04-18','11:30:00',3.36),('12664','2014-04-18','11:35:00',2.94),('12664','2014-04-18','11:40:00',2.69),('12664','2014-04-18','11:45:00',3.44),('12664','2014-04-18','11:50:00',2.32),('12664','2014-04-18','11:55:00',1.91),('12664','2014-04-18','12:00:00',2.1),('12664','2014-04-18','12:05:00',2.57),('12664','2014-04-18','12:10:00',4.71),('12664','2014-04-18','12:15:00',3.69),('12664','2014-04-18','12:20:00',4.28),('12664','2014-04-18','12:25:00',3.23),('12664','2014-04-18','12:30:00',4.22),('12664','2014-04-18','12:35:00',4.48),('12664','2014-04-18','12:40:00',3.87),('12664','2014-04-18','12:45:00',4.31),('12664','2014-04-18','12:50:00',3.2),('12664','2014-04-18','12:55:00',2.17),('12664','2014-04-18','13:00:00',3.14),('12664','2014-04-18','13:05:00',2.89),('12664','2014-04-18','13:10:00',3.67),('12664','2014-04-18','13:15:00',2.21),('12664','2014-04-18','13:20:00',1.95),('12664','2014-04-18','13:25:00',1.73),('12664','2014-04-18','13:30:00',1.32),('12664','2014-04-18','13:35:00',1.34),('12664','2014-04-18','13:40:00',1.6),('12664','2014-04-18','13:45:00',1.42),('12664','2014-04-18','13:50:00',1.13),('12664','2014-04-18','13:55:00',1.19),('12664','2014-04-18','14:00:00',1.37),('12664','2014-04-18','14:05:00',1.32),('12664','2014-04-18','14:10:00',1.34),('12664','2014-04-18','14:15:00',1.57),('12664','2014-04-18','14:20:00',1.61),('12664','2014-04-18','14:25:00',1.65),('12664','2014-04-18','14:30:00',2.33),('12664','2014-04-18','14:35:00',2.49),('12664','2014-04-18','14:40:00',2.3),('12664','2014-04-18','14:45:00',1.9),('12664','2014-04-18','14:50:00',1.99),('12664','2014-04-18','14:55:00',3.52),('12664','2014-04-18','15:00:00',3.25),('12664','2014-04-18','15:05:00',3.82),('12664','2014-04-18','15:10:00',3.08),('12664','2014-04-18','15:15:00',3.74),('12664','2014-04-18','15:20:00',3.57),('12664','2014-04-18','15:25:00',2.22),('12664','2014-04-18','15:30:00',3.83),('12664','2014-04-18','15:35:00',2.91),('12664','2014-04-18','15:40:00',2.37),('12664','2014-04-18','15:45:00',3.58),('12664','2014-04-18','15:50:00',3.3),('12664','2014-04-18','15:55:00',3.39),('12664','2014-04-18','16:00:00',2.3),('12664','2014-04-18','16:05:00',3.45),('12664','2014-04-18','16:10:00',3.04),('12664','2014-04-18','16:15:00',3.33),('12664','2014-04-18','16:20:00',3.04),('12664','2014-04-18','16:25:00',2.96),('12664','2014-04-18','16:30:00',2.97),('12664','2014-04-18','16:35:00',2.75),('12664','2014-04-18','16:40:00',2.8),('12664','2014-04-18','16:45:00',1.67),('12664','2014-04-18','16:50:00',1.95),('12664','2014-04-18','16:55:00',2.44),('12664','2014-04-18','17:00:00',2.32),('12664','2014-04-18','17:05:00',2.2),('12664','2014-04-18','17:10:00',2.09),('12664','2014-04-18','17:15:00',1.94),('12664','2014-04-18','17:20:00',1.91),('12664','2014-04-18','17:25:00',1.51),('12664','2014-04-18','17:35:00',1.62),('12664','2014-04-18','17:40:00',1.52),('12664','2014-04-18','17:45:00',1.4),('12664','2014-04-18','17:50:00',1.31),('12664','2014-04-18','17:55:00',1.2),('12664','2014-04-18','18:00:00',1.13),('12664','2014-04-18','18:05:00',1.02),('12664','2013-11-16','12:55:00',1.34),('12664','2013-11-16','13:00:00',1.3),('12664','2013-11-16','13:05:00',1.39),('12664','2013-11-16','13:10:00',1.18),('12664','2013-11-16','13:15:00',1.09),('12664','2013-11-15','09:50:00',1.23),('12664','2013-11-15','09:55:00',1.18),('12664','2013-11-15','10:00:00',1.04),('12664','2013-11-15','10:05:00',1.17),('12664','2013-11-15','10:10:00',1.1),('12664','2013-11-15','10:15:00',1.16),('12664','2013-11-15','10:20:00',1.26),('12664','2013-11-15','10:25:00',1.22),('12664','2013-11-15','10:30:00',1.31),('12664','2013-11-15','10:35:00',1.44),('12664','2013-11-15','10:40:00',1.13),('12664','2013-11-15','11:00:00',1.07),('12664','2013-11-15','11:05:00',1.32),('12664','2013-11-15','11:10:00',1.51),('12664','2013-11-15','11:15:00',1.47),('12664','2013-11-15','11:20:00',1.23),('12664','2013-11-15','11:25:00',1.05),('12664','2013-11-15','11:30:00',1.08),('12664','2013-11-15','11:35:00',1.51),('12664','2013-11-15','11:40:00',2.4),('12664','2013-11-15','11:45:00',1.53),('12664','2013-11-15','11:50:00',2.7),('12664','2013-11-15','11:55:00',1.75),('12664','2013-11-15','12:00:00',1.28),('12664','2013-11-15','12:05:00',1.05),('12664','2013-11-14','08:50:00',1.77),('12664','2013-11-14','08:55:00',1.86),('12664','2013-11-14','09:00:00',1.06),('12664','2013-11-14','09:15:00',1.8),('12664','2013-11-14','09:20:00',2.33),('12664','2013-11-14','09:25:00',2.32),('12664','2013-11-14','09:30:00',2.34),('12664','2013-11-14','09:35:00',2.41),('12664','2013-11-14','09:40:00',2.49),('12664','2013-11-14','09:45:00',2.52),('12664','2013-11-14','09:50:00',2.56),('12664','2013-11-14','09:55:00',2.55),('12664','2013-11-14','10:00:00',2.59),('12664','2013-11-14','10:05:00',2.48),('12664','2013-11-14','10:10:00',2.55),('12664','2013-11-14','10:15:00',2.56),('12664','2013-11-14','10:20:00',2.42),('12664','2013-11-14','10:25:00',2.46),('12664','2013-11-14','10:30:00',2.68),('12664','2013-11-14','10:35:00',2.81),('12664','2013-11-14','10:40:00',2.86),('12664','2013-11-14','10:45:00',2.92),('12664','2013-11-14','10:50:00',2.95),('12664','2013-11-14','10:55:00',3.11),('12664','2013-11-14','11:00:00',3.2),('12664','2013-11-14','11:05:00',3.3),('12664','2013-11-14','11:10:00',3.07),('12664','2013-11-14','11:15:00',3.3),('12664','2013-11-14','11:20:00',3.24),('12664','2013-11-14','11:25:00',3.24),('12664','2013-11-14','11:30:00',2.93),('12664','2013-11-14','11:35:00',2.15),('12664','2013-11-14','11:40:00',2.55),('12664','2013-11-14','11:45:00',2.38),('12664','2013-11-14','11:50:00',1.16),('12664','2013-11-14','11:55:00',1.12),('12664','2013-11-14','12:00:00',1.12),('12664','2013-11-14','12:05:00',1.08),('12664','2013-11-14','12:10:00',1.09),('12664','2013-11-14','12:15:00',1.05),('12664','2013-11-14','12:20:00',1.15),('12664','2013-11-14','12:25:00',1.46),('12664','2013-11-14','12:30:00',1.72),('12664','2013-11-14','12:35:00',1.87),('12664','2013-11-14','12:40:00',1.61),('12664','2013-11-14','12:45:00',1.54),('12664','2013-11-14','12:50:00',1.7),('12664','2013-11-14','12:55:00',2.99),('12664','2013-11-14','13:00:00',2.33),('12664','2013-11-14','13:05:00',1.03),('12664','2013-11-14','13:10:00',2.07),('12664','2013-11-14','13:15:00',1.63),('12664','2013-11-14','13:20:00',2.71),('12664','2013-11-14','13:25:00',3.25),('12664','2013-11-14','13:30:00',2.86),('12664','2013-11-14','13:35:00',2.49),('12664','2013-11-14','13:40:00',2.87),('12664','2013-11-14','13:45:00',2.85),('12664','2013-11-14','13:50:00',2.66),('12664','2013-11-14','13:55:00',1.53),('12664','2013-11-14','14:00:00',1.16),('12664','2013-11-14','14:05:00',1.38),('12664','2013-11-14','14:10:00',1.5),('12664','2013-11-13','10:05:00',1.06),('12664','2013-11-13','10:10:00',1.36),('12664','2013-11-13','10:50:00',1.12),('12664','2013-11-13','10:55:00',1.11),('12664','2013-11-13','11:00:00',1.18),('12664','2013-11-13','11:05:00',3.19),('12664','2013-11-13','11:10:00',4.11),('12664','2013-11-13','11:15:00',4.11),('12664','2013-11-13','11:20:00',2.39),('12664','2013-11-13','11:25:00',3.02),('12664','2013-11-13','11:30:00',2.21),('12664','2013-11-13','11:35:00',1.23),('12664','2013-11-13','11:40:00',1.27),('12664','2013-11-13','11:55:00',1.04),('12664','2013-11-13','12:00:00',2),('12664','2013-11-13','12:05:00',2.14),('12664','2013-11-13','12:10:00',1.17),('12664','2013-11-13','12:15:00',1.01),('12664','2013-11-13','12:50:00',1.03),('12664','2013-11-13','12:55:00',1.08),('12664','2013-11-13','13:00:00',1.07),('12664','2013-11-13','13:05:00',1.11),('12664','2013-11-13','13:10:00',1.28),('12664','2013-11-13','13:15:00',1.43),('12664','2013-11-13','13:20:00',1.71),('12664','2013-11-13','13:25:00',1.82),('12664','2013-11-13','13:30:00',1.08),('12664','2013-11-13','13:45:00',1.04),('12664','2013-11-13','13:50:00',1.26),('12664','2013-11-13','13:55:00',1.4),('12664','2013-11-13','14:00:00',1.7),('12664','2013-11-13','14:05:00',2.02),('12664','2013-11-13','14:10:00',2.1),('12664','2013-11-13','14:15:00',1.86),('12664','2013-11-13','14:20:00',1.82),('12664','2013-11-13','14:25:00',1.66),('12664','2013-11-13','14:30:00',1.73),('12664','2013-11-13','14:35:00',1.47),('12664','2013-11-12','11:40:00',2.46),('12664','2013-11-12','11:45:00',1.79),('12664','2013-11-12','12:00:00',1.78),('12664','2013-11-12','12:05:00',3.05),('12664','2013-11-12','12:10:00',1.22),('12664','2013-11-12','12:35:00',2.03),('12664','2013-11-12','12:40:00',2.66),('12664','2013-11-12','12:45:00',2.1),('12664','2013-11-12','12:50:00',1.89),('12664','2013-11-12','12:55:00',1.43),('12664','2013-11-12','13:00:00',1.74),('12664','2013-11-12','13:05:00',1.54),('12664','2013-11-12','13:10:00',1.44),('12664','2013-11-12','13:15:00',1.76),('12664','2013-11-12','13:20:00',2.11),('12664','2013-11-12','13:25:00',1.84),('12664','2013-11-12','13:30:00',1.79),('12664','2013-11-12','13:35:00',2.03),('12664','2013-11-12','13:40:00',1.97),('12664','2013-11-12','13:45:00',2.5),('12664','2013-11-12','13:50:00',2.12),('12664','2013-11-12','13:55:00',1.95),('12664','2013-11-12','14:00:00',1.9),('12664','2013-11-12','14:05:00',1.43),('12664','2013-11-12','14:10:00',1.49),('12664','2013-11-12','14:15:00',3.04),('12664','2013-11-12','14:20:00',3.03),('12664','2013-11-12','14:25:00',2.18),('12664','2013-11-12','14:30:00',1.2),('12664','2013-11-12','14:35:00',1.1),('12664','2013-11-12','14:40:00',1.59),('12664','2013-11-12','14:45:00',2.48),('12664','2013-11-12','14:50:00',2.18),('12664','2013-11-12','14:55:00',1.28),('12664','2013-11-12','15:10:00',1),('12664','2013-11-12','15:15:00',1.04),('12664','2013-11-12','15:20:00',1.41),('12664','2013-11-12','15:25:00',1.52),('12664','2013-11-12','15:30:00',1.19),('12664','2013-11-11','08:55:00',1.24),('12664','2013-11-11','10:55:00',1.51),('12664','2013-11-11','11:00:00',1.28),('12664','2013-11-11','11:05:00',1.01),('12664','2013-11-11','11:15:00',2.7),('12664','2013-11-11','11:20:00',2.39),('12664','2013-11-11','11:25:00',3.71),('12664','2013-11-11','11:30:00',3.44),('12664','2013-11-11','11:35:00',1.06),('12664','2013-11-11','11:40:00',1.76),('12664','2013-11-11','11:45:00',2.11),('12664','2013-11-11','11:50:00',4.29),('12664','2013-11-11','11:55:00',2.25),('12664','2013-11-11','12:05:00',1.75),('12664','2013-11-11','12:10:00',4.07),('12664','2013-11-11','12:15:00',3.34),('12664','2013-11-11','12:20:00',3.41),('12664','2013-11-11','12:25:00',3.88),('12664','2013-11-11','12:30:00',2.97),('12664','2013-11-11','12:35:00',2.7),('12664','2013-11-11','12:40:00',3.63),('12664','2013-11-11','12:45:00',2.14),('12664','2013-11-11','12:50:00',1.26),('12664','2013-11-11','12:55:00',1.53),('12664','2013-11-11','13:00:00',2.54),('12664','2013-11-11','13:05:00',3.3),('12664','2013-11-11','13:10:00',2.43),('12664','2013-11-11','13:15:00',3.2),('12664','2013-11-11','13:20:00',3.12),('12664','2013-11-11','13:25:00',2.18),('12664','2013-11-11','13:30:00',1.37),('12664','2013-11-11','13:50:00',1.21),('12664','2013-11-11','13:55:00',2.3),('12664','2013-11-11','14:00:00',1.26),('12664','2013-11-11','14:05:00',1.14),('12664','2013-11-11','14:10:00',3.04),('12664','2013-11-11','14:15:00',2.84),('12664','2013-11-11','14:20:00',2.62),('12664','2013-11-11','14:25:00',1.56),('12664','2013-11-11','14:30:00',1.57),('12664','2013-11-11','14:35:00',2.25),('12664','2013-11-11','14:40:00',2.18),('12664','2013-11-11','14:45:00',2.13),('12664','2013-11-11','14:50:00',1.89),('12664','2013-11-11','14:55:00',1.6),('12664','2013-11-11','15:00:00',1.42),('12664','2013-11-11','15:05:00',1.24),('12664','2013-11-10','07:45:00',1.09),('12664','2013-11-10','07:55:00',1.32),('12664','2013-11-10','08:00:00',1.1),('12664','2013-11-10','08:10:00',1.01),('12664','2013-11-10','08:15:00',1.43),('12664','2013-11-10','08:20:00',1.3),('12664','2013-11-10','08:25:00',1.62),('12664','2013-11-10','08:30:00',1.06),('12664','2013-11-10','08:35:00',2.04),('12664','2013-11-10','08:40:00',1.57),('12664','2013-11-10','08:45:00',1.62),('12664','2013-11-10','08:50:00',1.32),('12664','2013-11-10','08:55:00',1.6),('12664','2013-11-10','09:00:00',1.59),('12664','2013-11-10','09:05:00',1.35),('12664','2013-11-10','09:10:00',1.75),('12664','2013-11-10','09:15:00',2.16),('12664','2013-11-10','09:20:00',2.2),('12664','2013-11-10','09:25:00',1.29),('12664','2013-11-10','09:30:00',2.21),('12664','2013-11-10','09:35:00',2.48),('12664','2013-11-10','09:40:00',2.52),('12664','2013-11-10','09:45:00',2.65),('12664','2013-11-10','09:50:00',2.66),('12664','2013-11-10','09:55:00',2.42),('12664','2013-11-10','10:00:00',2.64),('12664','2013-11-10','10:05:00',2.71),('12664','2013-11-10','10:10:00',2.08),('12664','2013-11-10','10:15:00',1.56),('12664','2013-11-10','10:20:00',1.88),('12664','2013-11-10','10:25:00',1.76),('12664','2013-11-10','10:30:00',2.06),('12664','2013-11-10','10:35:00',2.78),('12664','2013-11-10','10:40:00',1.82),('12664','2013-11-10','10:45:00',1.82),('12664','2013-11-10','10:50:00',2.63),('12664','2013-11-10','11:10:00',1.52),('12664','2013-11-10','11:15:00',2.42),('12664','2013-11-10','11:20:00',2.08),('12664','2013-11-10','11:25:00',2.02),('12664','2013-11-10','11:30:00',2.83),('12664','2013-11-10','11:35:00',2.42),('12664','2013-11-10','11:40:00',2.08),('12664','2013-11-10','11:45:00',1.84),('12664','2013-11-10','11:50:00',2.82),('12664','2013-11-10','11:55:00',2.54),('12664','2013-11-10','12:00:00',1.28),('12664','2013-11-10','12:05:00',3.41),('12664','2013-11-10','12:10:00',2.09),('12664','2013-11-10','12:15:00',2.96),('12664','2013-11-10','12:20:00',3.34),('12664','2013-11-10','12:25:00',2.51),('12664','2013-11-10','12:30:00',3.32),('12664','2013-11-10','12:35:00',2.98),('12664','2013-11-10','12:40:00',1.04),('12664','2013-11-10','12:50:00',2.03),('12664','2013-11-10','12:55:00',1.49),('12664','2013-11-10','13:00:00',1.2),('12664','2013-11-10','13:05:00',2.41),('12664','2013-11-10','13:10:00',1.73),('12664','2013-11-10','13:25:00',3.04),('12664','2013-11-10','13:30:00',2.82),('12664','2013-11-10','13:35:00',1.21),('12664','2013-11-09','09:05:00',1.14),('12664','2013-11-09','09:10:00',1.33),('12664','2013-11-09','09:15:00',1.28),('12664','2013-11-09','09:20:00',1.4),('12664','2013-11-09','09:25:00',1.73),('12664','2013-11-09','09:30:00',1.69),('12664','2013-11-09','09:35:00',2.32),('12664','2013-11-09','09:40:00',1.89),('12664','2013-11-09','09:45:00',2.17),('12664','2013-11-09','09:50:00',2.04),('12664','2013-11-09','09:55:00',2.95),('12664','2013-11-09','10:00:00',1.68),('12664','2013-11-09','10:10:00',1.4),('12664','2013-11-09','10:15:00',2.12),('12664','2013-11-09','10:20:00',3.07),('12664','2013-11-09','10:25:00',1.1),('12664','2013-11-09','10:30:00',1.22),('12664','2013-11-09','10:35:00',2.59),('12664','2013-11-09','10:40:00',2.06),('12664','2013-11-09','10:50:00',1.15),('12664','2013-11-09','10:55:00',2.69),('12664','2013-11-09','11:00:00',3.14),('12664','2013-11-09','11:05:00',1.17),('12664','2013-11-09','11:10:00',1.09),('12664','2013-11-09','11:15:00',1.09),('12664','2013-11-09','11:20:00',1.89),('12664','2013-11-09','11:25:00',2.34),('12664','2013-11-09','11:30:00',2.28),('12664','2013-11-09','11:35:00',3.77),('12664','2013-11-09','11:40:00',3.84),('12664','2013-11-09','11:45:00',3.25),('12664','2013-11-09','11:50:00',1.7),('12664','2013-11-09','11:55:00',1.8),('12664','2013-11-09','12:00:00',3.85),('12664','2013-11-09','12:05:00',2.02),('12664','2013-11-09','12:10:00',1.28),('12664','2013-11-09','12:30:00',1.05),('12664','2013-11-09','12:35:00',1.12),('12664','2013-11-09','12:40:00',1.18),('12664','2013-11-09','12:45:00',1.24),('12664','2013-11-09','12:50:00',2.78),('12664','2013-11-09','12:55:00',2.75),('12664','2013-11-09','13:00:00',3.39),('12664','2013-11-09','13:05:00',2.46),('12664','2013-11-09','13:10:00',1.84),('12664','2013-11-09','13:15:00',1.7),('12664','2013-11-09','13:20:00',3.01),('12664','2013-11-09','13:25:00',3.21),('12664','2013-11-09','13:30:00',1.85),('12664','2013-11-09','13:35:00',3.77),('12664','2013-11-09','13:40:00',2.35),('12664','2013-11-09','13:45:00',2.07),('12664','2013-11-09','13:50:00',1.24),('12664','2013-11-09','13:55:00',2.34),('12664','2013-11-09','14:15:00',1.03),('12664','2013-11-09','14:20:00',1.03),('12664','2013-11-09','14:30:00',1.75),('12664','2013-11-09','14:35:00',2.12),('12664','2013-11-09','14:40:00',1.59),('12664','2013-11-09','14:45:00',1.42),('12664','2013-11-09','15:20:00',1.54),('12664','2013-11-09','15:25:00',1.19),('12664','2013-11-09','15:35:00',1.07),('12664','2013-11-08','08:55:00',1.29),('12664','2013-11-08','09:10:00',1.95),('12664','2013-11-08','09:15:00',1.67),('12664','2013-11-08','09:20:00',2.09),('12664','2013-11-08','09:25:00',2.05),('12664','2013-11-08','09:30:00',2.45),('12664','2013-11-08','09:35:00',2.56),('12664','2013-11-08','09:40:00',2.5),('12664','2013-11-08','09:45:00',2.54),('12664','2013-11-08','09:50:00',1.59),('12664','2013-11-08','09:55:00',2.8),('12664','2013-11-08','10:00:00',2.06),('12664','2013-11-08','10:05:00',3.02),('12664','2013-11-08','10:10:00',1),('12664','2013-11-08','10:15:00',1.96),('12664','2013-11-08','10:20:00',3.23),('12664','2013-11-08','10:25:00',3.3),('12664','2013-11-08','10:30:00',3.34),('12664','2013-11-08','10:35:00',3.36),('12664','2013-11-08','10:40:00',3.46),('12664','2013-11-08','10:45:00',1.65),('12664','2013-11-08','10:50:00',2.02),('12664','2013-11-08','10:55:00',2.73),('12664','2013-11-08','11:00:00',1.83),('12664','2013-11-08','11:05:00',2),('12664','2013-11-08','11:10:00',3.65),('12664','2013-11-08','11:15:00',2.68),('12664','2013-11-08','11:20:00',3.46),('12664','2013-11-08','11:25:00',3.71),('12664','2013-11-08','11:30:00',3.62),('12664','2013-11-08','11:35:00',2.78),('12664','2013-11-08','11:40:00',1.98),('12664','2013-11-08','11:45:00',2.46),('12664','2013-11-08','11:50:00',2.95),('12664','2013-11-08','11:55:00',3.49),('12664','2013-11-08','12:00:00',3.3),('12664','2013-11-08','12:05:00',3.24),('12664','2013-11-08','12:10:00',3.23),('12664','2013-11-08','12:15:00',3.02),('12664','2013-11-08','12:20:00',3.42),('12664','2013-11-08','12:25:00',2.62),('12664','2013-11-08','12:30:00',3.37),('12664','2013-11-08','12:35:00',3.3),('12664','2013-11-08','12:40:00',3.23),('12664','2013-11-08','12:45:00',3.29),('12664','2013-11-08','12:50:00',2.19),('12664','2013-11-08','12:55:00',3.2),('12664','2013-11-08','13:00:00',3.27),('12664','2013-11-08','13:05:00',3.11),('12664','2013-11-08','13:10:00',3.09),('12664','2013-11-08','13:15:00',2.76),('12664','2013-11-08','13:20:00',2.56),('12664','2013-11-08','13:25:00',3.05),('12664','2013-11-08','13:30:00',2.88),('12664','2013-11-08','13:35:00',2.29),('12664','2013-11-08','13:40:00',2.58),('12664','2013-11-08','13:45:00',2.82),('12664','2013-11-08','13:50:00',2.65),('12664','2013-11-08','13:55:00',2.6),('12664','2013-11-08','14:00:00',2.37),('12664','2013-11-08','14:05:00',2.06),('12664','2013-11-08','14:10:00',2.39),('12664','2013-11-08','14:15:00',1.38),('12664','2013-11-08','14:20:00',1.36),('12664','2013-11-08','14:25:00',2.29),('12664','2013-11-08','14:30:00',2.04),('12664','2013-11-08','14:35:00',2.18),('12664','2013-11-08','14:40:00',2.11),('12664','2013-11-08','14:45:00',1.24),('12664','2013-11-08','14:50:00',1.92),('12664','2013-11-08','14:55:00',1.68),('12664','2013-11-08','15:00:00',1.16),('12664','2013-11-08','15:05:00',1.36),('12664','2013-11-08','15:10:00',1.24),('12664','2013-11-08','15:15:00',1.53),('12664','2013-11-08','15:20:00',1.43),('12664','2013-11-08','15:25:00',1.28),('12664','2013-11-08','15:30:00',1.05),('12664','2013-11-08','15:35:00',1.02),('12664','2013-11-07','07:55:00',1.03),('12664','2013-11-07','08:00:00',1.12),('12664','2013-11-07','08:05:00',1.2),('12664','2013-11-07','08:10:00',1.29),('12664','2013-11-07','08:15:00',1.38),('12664','2013-11-07','08:20:00',1.47),('12664','2013-11-07','08:25:00',1.55),('12664','2013-11-07','08:30:00',1.63),('12664','2013-11-07','08:35:00',1.72),('12664','2013-11-07','08:40:00',1.8),('12664','2013-11-07','08:45:00',1.88),('12664','2013-11-07','08:50:00',1.97),('12664','2013-11-07','08:55:00',2.04),('12664','2013-11-07','09:00:00',2.11),('12664','2013-11-07','09:05:00',2.18),('12664','2013-11-07','09:10:00',2.24),('12664','2013-11-07','09:15:00',2.31),('12664','2013-11-07','09:20:00',2.37),('12664','2013-11-07','09:25:00',2.42),('12664','2013-11-07','09:30:00',2.48),('12664','2013-11-07','09:35:00',2.54),('12664','2013-11-07','09:40:00',2.59),('12664','2013-11-07','09:45:00',2.64),('12664','2013-11-07','09:50:00',2.68),('12664','2013-11-07','09:55:00',2.73),('12664','2013-11-07','10:00:00',2.78),('12664','2013-11-07','10:05:00',2.82),('12664','2013-11-07','10:10:00',2.86),('12664','2013-11-07','10:15:00',2.9),('12664','2013-11-07','10:20:00',2.93),('12664','2013-11-07','10:25:00',2.96),('12664','2013-11-07','10:30:00',2.99),('12664','2013-11-07','10:35:00',3.01),('12664','2013-11-07','10:40:00',3.02),('12664','2013-11-07','10:45:00',3.04),('12664','2013-11-07','10:50:00',3.05),('12664','2013-11-07','10:55:00',3.07),('12664','2013-11-07','11:00:00',3.06),('12664','2013-11-07','11:05:00',3.07),('12664','2013-11-07','11:10:00',3.08),('12664','2013-11-07','11:15:00',3.08),('12664','2013-11-07','11:20:00',3.11),('12664','2013-11-07','11:25:00',3.13),('12664','2013-11-07','11:30:00',3.14),('12664','2013-11-07','11:35:00',3.16),('12664','2013-11-07','11:40:00',3.13),('12664','2013-11-07','11:45:00',3.06),('12664','2013-11-07','11:50:00',3.09),('12664','2013-11-07','11:55:00',2.51),('12664','2013-11-07','12:00:00',2.17),('12664','2013-11-07','12:05:00',3.34),('12664','2013-11-07','12:10:00',3.28),('12664','2013-11-07','12:15:00',1.16),('12664','2013-11-07','12:20:00',2.12),('12664','2013-11-07','12:25:00',3.78),('12664','2013-11-07','12:30:00',1.94),('12664','2013-11-07','12:35:00',1.65),('12664','2013-11-07','12:40:00',3.56),('12664','2013-11-07','12:45:00',3.41),('12664','2013-11-07','12:50:00',3.19),('12664','2013-11-07','12:55:00',2.79),('12664','2013-11-07','13:00:00',2.33),('12664','2013-11-07','13:05:00',1.61),('12664','2013-11-07','13:10:00',2.29),('12664','2013-11-07','13:15:00',3.15),('12664','2013-11-07','13:20:00',2.88),('12664','2013-11-07','13:25:00',2.83),('12664','2013-11-07','13:30:00',2.77),('12664','2013-11-07','13:35:00',2.72),('12664','2013-11-07','13:40:00',2.72),('12664','2013-11-07','13:45:00',2.69),('12664','2013-11-07','13:50:00',2.61),('12664','2013-11-07','13:55:00',2.59),('12664','2013-11-07','14:00:00',2.4),('12664','2013-11-07','14:05:00',2.52),('12664','2013-11-07','14:10:00',1.82),('12664','2013-11-07','14:15:00',2.35),('12664','2013-11-07','14:20:00',2.22),('12664','2013-11-07','14:25:00',2.23),('12664','2013-11-07','14:30:00',2.17),('12664','2013-11-07','14:35:00',2.08),('12664','2013-11-07','14:40:00',2),('12664','2013-11-07','14:45:00',1.92),('12664','2013-11-07','14:50:00',1.85),('12664','2013-11-07','14:55:00',1.73),('12664','2013-11-07','15:00:00',1.69),('12664','2013-11-07','15:05:00',1.6),('12664','2013-11-07','15:10:00',1.52),('12664','2013-11-07','15:15:00',1.43),('12664','2013-11-07','15:20:00',1.34),('12664','2013-11-07','15:25:00',1.25),('12664','2013-11-07','15:30:00',1.15),('12664','2013-11-07','15:35:00',1.06),('12664','2014-04-17','08:00:00',1),('12664','2014-04-17','08:05:00',1),('12664','2014-04-17','08:15:00',1.2),('12664','2014-04-17','08:20:00',1.41),('12664','2014-04-17','08:25:00',1.49),('12664','2014-04-17','08:30:00',1.6),('12664','2014-04-17','08:35:00',1.69),('12664','2014-04-17','08:40:00',1.79),('12664','2014-04-17','08:45:00',1.9),('12664','2014-04-17','08:50:00',1.99),('12664','2014-04-17','08:55:00',2.1),('12664','2014-04-17','09:00:00',2.21),('12664','2014-04-17','09:05:00',2.3),('12664','2014-04-17','09:10:00',2.39),('12664','2014-04-17','09:15:00',2.48),('12664','2014-04-17','09:20:00',2.56),('12664','2014-04-17','09:25:00',2.66),('12664','2014-04-17','09:30:00',2.73),('12664','2014-04-17','09:35:00',2.8),('12664','2014-04-17','09:40:00',2.88),('12664','2014-04-17','09:45:00',2.95),('12664','2014-04-17','09:50:00',3.05),('12664','2014-04-17','09:55:00',3.14),('12664','2014-04-17','10:00:00',3.26),('12664','2014-04-17','10:05:00',2.92),('12664','2014-04-17','10:10:00',2.85),('12664','2014-04-17','10:15:00',2.65),('12664','2014-04-17','10:20:00',2.87),('12664','2014-04-17','10:25:00',1.93),('12664','2014-04-17','10:30:00',3.62),('12664','2014-04-17','10:35:00',3.38),('12664','2014-04-17','10:40:00',2.49),('12664','2014-04-17','10:45:00',2.92),('12664','2014-04-17','10:50:00',2.36),('12664','2014-04-17','10:55:00',2.08),('12664','2014-04-17','11:00:00',2.86),('12664','2014-04-17','11:05:00',2.49),('12664','2014-04-17','11:10:00',2.57),('12664','2014-04-17','11:15:00',3.32),('12664','2014-04-17','11:20:00',1.96),('12664','2014-04-17','11:25:00',3.03),('12664','2014-04-17','11:30:00',2.08),('12664','2014-04-17','11:35:00',3.4),('12664','2014-04-17','11:40:00',3.61),('12664','2014-04-17','11:45:00',2.52),('12664','2014-04-17','11:50:00',2.22),('12664','2014-04-17','11:55:00',2.02),('12664','2014-04-17','12:00:00',2.44),('12664','2014-04-17','12:05:00',2.05),('12664','2014-04-17','12:10:00',2.54),('12664','2014-04-17','12:15:00',2.59),('12664','2014-04-17','12:20:00',3.59),('12664','2014-04-17','12:25:00',3.74),('12664','2014-04-17','12:30:00',3.92),('12664','2014-04-17','12:35:00',4.22),('12664','2014-04-17','12:40:00',4.34),('12664','2014-04-17','12:45:00',4.4),('12664','2014-04-17','12:50:00',4.39),('12664','2014-04-17','12:55:00',4.41),('12664','2014-04-17','13:00:00',4.38),('12664','2014-04-17','13:05:00',4.35),('12664','2014-04-17','13:10:00',4.34),('12664','2014-04-17','13:15:00',3.87),('12664','2014-04-17','13:20:00',3.95),('12664','2014-04-17','13:25:00',3.08),('12664','2014-04-17','13:30:00',2.18),('12664','2014-04-17','13:35:00',4.71),('12664','2014-04-17','13:40:00',4.84),('12664','2014-04-17','13:45:00',3.7),('12664','2014-04-17','13:50:00',4.76),('12664','2014-04-17','13:55:00',4.58),('12664','2014-04-17','14:00:00',4.52),('12664','2014-04-17','14:05:00',3.91),('12664','2014-04-17','14:10:00',2.87),('12664','2014-04-17','14:15:00',2.8),('12664','2014-04-17','14:20:00',1.8),('12664','2014-04-17','14:25:00',1.69),('12664','2014-04-17','14:30:00',1.68),('12664','2014-04-17','14:35:00',2.39),('12664','2014-04-17','14:40:00',3.42),('12664','2014-04-17','14:45:00',3.43),('12664','2014-04-17','14:50:00',1.61),('12664','2014-04-17','14:55:00',1.36),('12664','2014-04-17','15:00:00',1.12),('12664','2014-04-17','15:05:00',1.21),('12664','2014-04-17','15:10:00',1.33),('12664','2014-04-17','15:15:00',1.12),('12664','2014-04-17','15:20:00',1.03),('12664','2014-04-17','15:50:00',1.1),('12664','2014-04-17','16:35:00',1.04),('12664','2014-04-17','16:40:00',1.33),('12664','2014-04-17','16:45:00',1.54),('12664','2014-04-17','16:50:00',1.52),('12664','2014-04-17','16:55:00',1.2),('12664','2014-04-17','17:15:00',1.04),('12664','2014-04-17','17:20:00',1.3),('12664','2014-04-17','17:25:00',1.59),('12664','2014-04-17','17:30:00',1.48),('12664','2014-04-17','17:35:00',1.37),('12664','2014-04-17','17:40:00',1.22),('12664','2013-11-06','08:10:00',1.42),('12664','2013-11-06','08:15:00',1.56),('12664','2013-11-06','08:30:00',1.28),('12664','2013-11-06','08:35:00',1.85),('12664','2013-11-06','08:40:00',1.92),('12664','2013-11-06','08:45:00',1.99),('12664','2013-11-06','08:50:00',2.13),('12664','2013-11-06','08:55:00',1.57),('12664','2013-11-06','09:00:00',1.56),('12664','2013-11-06','09:05:00',1.69),('12664','2013-11-06','09:10:00',2.49),('12664','2013-11-06','09:15:00',2.35),('12664','2013-11-06','09:20:00',2.52),('12664','2013-11-06','09:25:00',2.55),('12664','2013-11-06','09:30:00',2.6),('12664','2013-11-06','09:35:00',2.65),('12664','2013-11-06','09:40:00',2.7),('12664','2013-11-06','09:45:00',2.74),('12664','2013-11-06','09:50:00',2.79),('12664','2013-11-06','09:55:00',2.82),('12664','2013-11-06','10:00:00',2.86),('12664','2013-11-06','10:05:00',2.89),('12664','2013-11-06','10:10:00',2.93),('12664','2013-11-06','10:15:00',2.95),('12664','2013-11-06','10:20:00',2.99),('12664','2013-11-06','10:25:00',3.04),('12664','2013-11-06','10:30:00',3.06),('12664','2013-11-06','10:35:00',3.09),('12664','2013-11-06','10:40:00',3.13),('12664','2013-11-06','10:45:00',3.15),('12664','2013-11-06','10:50:00',3.17),('12664','2013-11-06','10:55:00',3.19),('12664','2013-11-06','11:00:00',3.22),('12664','2013-11-06','11:05:00',3.24),('12664','2013-11-06','11:10:00',3.25),('12664','2013-11-06','11:15:00',3.25),('12664','2013-11-06','11:20:00',3.26),('12664','2013-11-06','11:25:00',3.28),('12664','2013-11-06','11:30:00',3.29),('12664','2013-11-06','11:35:00',3.3),('12664','2013-11-06','11:40:00',3.31),('12664','2013-11-06','11:45:00',3.31),('12664','2013-11-06','11:50:00',3.3),('12664','2013-11-06','11:55:00',3.29),('12664','2013-11-06','12:00:00',3.31),('12664','2013-11-06','12:05:00',3.32),('12664','2013-11-06','12:10:00',3.33),('12664','2013-11-06','12:15:00',3.31),('12664','2013-11-06','12:20:00',3.3),('12664','2013-11-06','12:25:00',3.26),('12664','2013-11-06','12:30:00',3.26),('12664','2013-11-06','12:35:00',3.22),('12664','2013-11-06','12:40:00',3.2),('12664','2013-11-06','12:45:00',3.16),('12664','2013-11-06','12:50:00',3.13),('12664','2013-11-06','12:55:00',3.09),('12664','2013-11-06','13:00:00',3.07),('12664','2013-11-06','13:05:00',3.07),('12664','2013-11-06','13:10:00',3.05),('12664','2013-11-06','13:15:00',3.01),('12664','2013-11-06','13:20:00',2.97),('12664','2013-11-06','13:25:00',2.92),('12664','2013-11-06','13:30:00',2.86),('12664','2013-11-06','13:35:00',2.81),('12664','2013-11-06','13:40:00',2.76),('12664','2013-11-06','13:45:00',2.73),('12664','2013-11-06','13:50:00',2.68),('12664','2013-11-06','13:55:00',2.64),('12664','2013-11-06','14:00:00',2.59),('12664','2013-11-06','14:05:00',2.53),('12664','2013-11-06','14:10:00',2.47),('12664','2013-11-06','14:15:00',2.42),('12664','2013-11-06','14:20:00',2.35),('12664','2013-11-06','14:25:00',2.28),('12664','2013-11-06','14:30:00',2.22),('12664','2013-11-06','14:35:00',2.14),('12664','2013-11-06','14:40:00',2.05),('12664','2013-11-06','14:45:00',1.98),('12664','2013-11-06','14:50:00',1.89),('12664','2013-11-06','14:55:00',1.79),('12664','2013-11-06','15:00:00',1.72),('12664','2013-11-06','15:05:00',1.63),('12664','2013-11-06','15:10:00',1.54),('12664','2013-11-06','15:15:00',1.46),('12664','2013-11-06','15:20:00',1.39),('12664','2013-11-06','15:25:00',1.29),('12664','2013-11-06','15:30:00',1.2),('12664','2013-11-06','15:35:00',1.12),('12664','2013-11-06','15:40:00',1.04),('12664','2013-11-05','10:20:00',1),('12664','2013-11-05','10:30:00',1.08),('12664','2013-11-05','10:35:00',1.06),('12664','2013-11-05','10:40:00',1.27),('12664','2013-11-05','10:45:00',1.21),('12664','2013-11-05','11:30:00',1.03),('12664','2013-11-05','11:35:00',1.35),('12664','2013-11-05','11:40:00',1.36),('12664','2013-11-05','11:45:00',1.1),('12664','2013-11-05','12:20:00',1.03),('12664','2013-11-05','12:25:00',1.19),('12664','2013-11-05','12:30:00',1.01),('12664','2013-11-05','12:35:00',1.05),('12664','2013-11-05','13:05:00',1.14),('12664','2013-11-05','13:10:00',1.25),('12664','2013-11-05','13:15:00',1.38),('12664','2013-11-05','13:20:00',1.55),('12664','2013-11-05','13:25:00',1.42),('12664','2013-11-05','13:30:00',1.61),('12664','2013-11-05','13:35:00',2.13),('12664','2013-11-05','13:40:00',2.15),('12664','2013-11-05','13:45:00',2.01),('12664','2013-11-05','13:50:00',2.41),('12664','2013-11-05','13:55:00',2.35),('12664','2013-11-05','14:00:00',2.25),('12664','2013-11-05','14:05:00',1.94),('12664','2013-11-05','14:10:00',2.65),('12664','2013-11-05','14:15:00',3.16),('12664','2013-11-05','14:20:00',2.83),('12664','2013-11-05','14:25:00',2.46),('12664','2013-11-05','14:30:00',1.86),('12664','2013-11-05','14:35:00',2.02),('12664','2013-11-05','14:40:00',2.16),('12664','2013-11-05','14:45:00',1.62),('12664','2013-11-05','14:50:00',1.44),('12664','2013-11-05','15:25:00',1.18),('12664','2013-11-05','15:30:00',1.41),('12664','2013-11-05','15:35:00',1.22),('12664','2013-11-05','15:40:00',1.12),('12664','2013-11-05','15:45:00',1.06),('12664','2013-11-04','08:00:00',1.1),('12664','2013-11-04','08:05:00',1.18),('12664','2013-11-04','08:10:00',1.28),('12664','2013-11-04','08:15:00',1.37),('12664','2013-11-04','08:20:00',1.47),('12664','2013-11-04','08:25:00',1.59),('12664','2013-11-04','08:30:00',1.68),('12664','2013-11-04','08:35:00',1.22),('12664','2013-11-04','08:40:00',1.38),('12664','2013-11-04','08:45:00',1.86),('12664','2013-11-04','08:50:00',2.04),('12664','2013-11-04','08:55:00',2.11),('12664','2013-11-04','09:00:00',2.32),('12664','2013-11-04','09:05:00',2.46),('12664','2013-11-04','09:10:00',2.64),('12664','2013-11-04','09:15:00',2.66),('12664','2013-11-04','09:20:00',2.71),('12664','2013-11-04','09:25:00',2.7),('12664','2013-11-04','09:30:00',2.66),('12664','2013-11-04','09:35:00',2.76),('12664','2013-11-04','09:40:00',2.61),('12664','2013-11-04','09:45:00',2.81),('12664','2013-11-04','09:50:00',2.36),('12664','2013-11-04','09:55:00',3.04),('12664','2013-11-04','10:00:00',3.07),('12664','2013-11-04','10:05:00',2.99),('12664','2013-11-04','10:10:00',3.06),('12664','2013-11-04','10:15:00',1.19),('12664','2013-11-04','10:20:00',1.99),('12664','2013-11-04','10:35:00',2.4),('12664','2013-11-04','10:40:00',3.49),('12664','2013-11-04','10:45:00',3.56),('12664','2013-11-04','10:50:00',3.31),('12664','2013-11-04','10:55:00',1.88),('12664','2013-11-04','11:05:00',1.53),('12664','2013-11-04','11:10:00',3.67),('12664','2013-11-04','11:15:00',3.52),('12664','2013-11-04','11:20:00',3.62),('12664','2013-11-04','11:25:00',1.89),('12664','2013-11-04','11:40:00',1.71),('12664','2013-11-04','11:45:00',3.91),('12664','2013-11-04','11:50:00',3.77),('12664','2013-11-04','11:55:00',3.61),('12664','2013-11-04','12:00:00',3.49),('12664','2013-11-04','12:05:00',3.65),('12664','2013-11-04','12:10:00',3.54),('12664','2013-11-04','12:15:00',3.39),('12664','2013-11-04','12:20:00',3.49),('12664','2013-11-04','12:25:00',3.46),('12664','2013-11-04','12:30:00',3.5),('12664','2013-11-04','12:35:00',3.54),('12664','2013-11-04','12:40:00',3.22),('12664','2013-11-04','12:45:00',1.97),('12664','2013-11-04','12:50:00',3.6),('12664','2013-11-04','12:55:00',3.2),('12664','2013-11-04','13:00:00',2.5),('12664','2013-11-04','13:05:00',3.49),('12664','2013-11-04','13:10:00',3.25),('12664','2013-11-04','13:15:00',3.41),('12664','2013-11-04','13:20:00',1.95),('12664','2013-11-04','13:25:00',2.64),('12664','2013-11-04','13:30:00',1.13),('12664','2013-11-04','13:35:00',2.8),('12664','2013-11-04','13:40:00',2.68),('12664','2013-11-04','13:45:00',2.32),('12664','2013-11-04','13:50:00',1.3),('12664','2013-11-04','13:55:00',1.77),('12664','2013-11-04','14:05:00',2.37),('12664','2013-11-04','14:25:00',1.07),('12664','2013-11-04','14:30:00',1.42),('12664','2013-11-04','14:35:00',1.87),('12664','2013-11-04','14:40:00',1.53),('12664','2013-11-04','14:55:00',2.18),('12664','2013-11-04','15:00:00',1.25),('12664','2013-11-04','15:05:00',1.08),('12664','2013-11-04','15:10:00',1.46),('12664','2013-11-04','15:15:00',1.11),('12664','2013-11-04','15:20:00',1.38),('12664','2013-11-04','15:25:00',1.21),('12664','2013-11-04','15:30:00',1.09),('12664','2013-11-03','08:15:00',1.06),('12664','2013-11-03','08:20:00',1.03),('12664','2013-11-03','08:25:00',1.2),('12664','2013-11-03','08:30:00',1.66),('12664','2013-11-03','08:35:00',1.76),('12664','2013-11-03','08:40:00',2.02),('12664','2013-11-03','08:45:00',2.03),('12664','2013-11-03','08:50:00',1.55),('12664','2013-11-03','09:00:00',1.45),('12664','2013-11-03','09:05:00',1.6),('12664','2013-11-03','09:10:00',1.65),('12664','2013-11-03','09:15:00',1.84),('12664','2013-11-03','09:20:00',1.75),('12664','2013-11-03','09:25:00',2.01),('12664','2013-11-03','09:30:00',2.28),('12664','2013-11-03','09:35:00',1.81),('12664','2013-11-03','09:50:00',2.5),('12664','2013-11-03','09:55:00',2.64),('12664','2013-11-03','10:00:00',2.35),('12664','2013-11-03','10:05:00',2.85),('12664','2013-11-03','10:10:00',2.92),('12664','2013-11-03','10:15:00',2.9),('12664','2013-11-03','10:20:00',2.97),('12664','2013-11-03','10:25:00',2.65),('12664','2013-11-03','10:30:00',1.32),('12664','2013-11-03','10:40:00',1.33),('12664','2013-11-03','11:00:00',1.1),('12664','2013-11-03','11:05:00',3.15),('12664','2013-11-03','11:10:00',3.22),('12664','2013-11-03','11:15:00',3.47),('12664','2013-11-03','11:20:00',3.34),('12664','2013-11-03','11:25:00',1.62),('12664','2013-11-03','11:30:00',2.42),('12664','2013-11-03','11:35:00',2.37),('12664','2013-11-03','11:40:00',3.51),('12664','2013-11-03','11:45:00',2.38),('12664','2013-11-03','11:50:00',1.1),('12664','2013-11-03','11:55:00',1.66),('12664','2013-11-03','12:00:00',1.42),('12664','2013-11-03','12:05:00',3.34),('12664','2013-11-03','12:10:00',3.71),('12664','2013-11-03','12:15:00',3.36),('12664','2013-11-03','12:20:00',2.04),('12664','2013-11-03','12:55:00',1.07),('12664','2013-11-03','13:00:00',1.08),('12664','2013-11-03','13:05:00',1.06),('12664','2013-11-03','13:10:00',1.2),('12664','2013-11-03','13:15:00',1.09),('12664','2013-11-03','13:20:00',1.1),('12664','2013-11-03','13:55:00',1.01),('12664','2013-11-03','14:00:00',2.45),('12664','2013-11-03','14:05:00',1.33),('12664','2013-11-03','14:15:00',1.27),('12664','2013-11-03','14:20:00',2.74),('12664','2013-11-03','14:25:00',1.71),('12664','2013-11-03','14:30:00',2.01),('12664','2013-11-03','14:35:00',1.7),('12664','2013-11-03','14:40:00',1.77),('12664','2013-11-03','14:50:00',1.52),('12664','2013-11-03','14:55:00',1.07),('12664','2013-11-02','08:00:00',1.02),('12664','2013-11-02','08:05:00',1.11),('12664','2013-11-02','08:10:00',1.21),('12664','2013-11-02','08:15:00',1.3),('12664','2013-11-02','08:20:00',1.4),('12664','2013-11-02','08:25:00',1.49),('12664','2013-11-02','08:30:00',1.57),('12664','2013-11-02','08:35:00',1.66),('12664','2013-11-02','08:40:00',1.75),('12664','2013-11-02','08:45:00',1.86),('12664','2013-11-02','08:50:00',2.15),('12664','2013-11-02','08:55:00',2.38),('12664','2013-11-02','09:00:00',2.02),('12664','2013-11-02','09:05:00',2.35),('12664','2013-11-02','09:10:00',2.01),('12664','2013-11-02','09:15:00',2.08),('12664','2013-11-02','09:20:00',2.08),('12664','2013-11-02','09:25:00',2.44),('12664','2013-11-02','09:30:00',2.47),('12664','2013-11-02','09:35:00',2.64),('12664','2013-11-02','09:40:00',2.83),('12664','2013-11-02','09:45:00',1.25),('12664','2013-11-02','09:50:00',1.94),('12664','2013-11-02','09:55:00',3),('12664','2013-11-02','10:00:00',1.78),('12664','2013-11-02','10:05:00',1.53),('12664','2013-11-02','10:50:00',1.17),('12664','2013-11-02','10:55:00',1.36),('12664','2013-11-02','11:00:00',1.62),('12664','2013-11-02','11:05:00',2.2),('12664','2013-11-02','11:10:00',4.1),('12664','2013-11-02','11:15:00',3.7),('12664','2013-11-02','11:20:00',2.94),('12664','2013-11-02','11:25:00',2.19),('12664','2013-11-02','11:30:00',2.72),('12664','2013-11-02','11:35:00',3.8),('12664','2013-11-02','11:40:00',3.74),('12664','2013-11-02','11:45:00',3.18),('12664','2013-11-02','11:50:00',3.48),('12664','2013-11-02','11:55:00',3.32),('12664','2013-11-02','12:00:00',1.73),('12664','2013-11-02','12:05:00',1.64),('12664','2013-11-02','12:10:00',1.67),('12664','2013-11-02','12:15:00',1.17),('12664','2013-11-02','12:25:00',1.26),('12664','2013-11-02','12:30:00',1.49),('12664','2013-11-02','12:35:00',2.74),('12664','2013-11-02','12:40:00',1.84),('12664','2013-11-02','12:45:00',1.04),('12664','2013-11-02','12:55:00',2.77),('12664','2013-11-02','13:00:00',3.21),('12664','2013-11-02','13:05:00',2.97),('12664','2013-11-02','13:10:00',2.06),('12664','2013-11-02','13:30:00',1.67),('12664','2013-11-02','13:35:00',1.92),('12664','2013-11-02','13:40:00',2.13),('12664','2013-11-02','13:45:00',2.78),('12664','2013-11-02','13:50:00',3.27),('12664','2013-11-02','13:55:00',2.79),('12664','2013-11-02','14:00:00',2.7),('12664','2013-11-02','14:05:00',2.54),('12664','2013-11-02','14:10:00',2.44),('12664','2013-11-02','14:15:00',2.4),('12664','2013-11-02','14:20:00',2.33),('12664','2013-11-02','14:25:00',2.25),('12664','2013-11-02','14:30:00',2.19),('12664','2013-11-02','14:35:00',2.14),('12664','2013-11-02','14:40:00',2.04),('12664','2013-11-02','14:45:00',1.96),('12664','2013-11-02','14:50:00',1.97),('12664','2013-11-02','14:55:00',1.82),('12664','2013-11-02','15:00:00',1.87),('12664','2013-11-02','15:05:00',1.65),('12664','2013-11-02','15:10:00',1.15),('12664','2013-11-02','15:20:00',1.47),('12664','2013-11-02','15:45:00',1.2),('12664','2013-11-02','15:50:00',1.09),('12664','2013-11-01','08:20:00',1.16),('12664','2013-11-01','08:25:00',1.33),('12664','2013-11-01','08:30:00',1.51),('12664','2013-11-01','08:35:00',1.55),('12664','2013-11-01','08:40:00',1.44),('12664','2013-11-01','08:45:00',1.3),('12664','2013-11-01','08:50:00',1.4),('12664','2013-11-01','08:55:00',1.7),('12664','2013-11-01','09:00:00',2.04),('12664','2013-11-01','09:05:00',2.1),('12664','2013-11-01','09:10:00',2.15),('12664','2013-11-01','09:15:00',2.21),('12664','2013-11-01','09:20:00',2.27),('12664','2013-11-01','09:25:00',2.35),('12664','2013-11-01','09:30:00',2.41),('12664','2013-11-01','09:35:00',2.47),('12664','2013-11-01','09:40:00',2.53),('12664','2013-11-01','09:45:00',2.58),('12664','2013-11-01','09:50:00',2.64),('12664','2013-11-01','09:55:00',2.69),('12664','2013-11-01','10:00:00',2.75),('12664','2013-11-01','10:05:00',2.82),('12664','2013-11-01','10:10:00',2.88),('12664','2013-11-01','10:15:00',2.92),('12664','2013-11-01','10:20:00',2.94),('12664','2013-11-01','10:25:00',3),('12664','2013-11-01','10:30:00',3.08),('12664','2013-11-01','10:35:00',3.12),('12664','2013-11-01','10:40:00',3.17),('12664','2013-11-01','10:45:00',3.14),('12664','2013-11-01','10:50:00',3.11),('12664','2013-11-01','10:55:00',3.24),('12664','2013-11-01','11:00:00',3.23),('12664','2013-11-01','11:05:00',3.17),('12664','2013-11-01','11:10:00',2.57),('12664','2013-11-01','11:15:00',2.6),('12664','2013-11-01','11:20:00',2.64),('12664','2013-11-01','11:25:00',3.09),('12664','2013-11-01','11:30:00',3.11),('12664','2013-11-01','11:35:00',2.65),('12664','2013-11-01','11:40:00',2.73),('12664','2013-11-01','11:45:00',2.84),('12664','2013-11-01','11:50:00',3.21),('12664','2013-11-01','11:55:00',3.35),('12664','2013-11-01','12:00:00',3.29),('12664','2013-11-01','12:05:00',2.74),('12664','2013-11-01','12:10:00',2.71),('12664','2013-11-01','12:15:00',2.55),('12664','2013-11-01','12:20:00',3.13),('12664','2013-11-01','12:25:00',3.33),('12664','2013-11-01','12:30:00',2.93),('12664','2013-11-01','12:35:00',1.41),('12664','2013-11-01','12:50:00',2.01),('12664','2013-11-01','12:55:00',2.3),('12664','2013-11-01','13:00:00',2.1),('12664','2013-11-01','13:05:00',1.77),('12664','2013-11-01','13:10:00',1.49),('12664','2013-11-01','13:15:00',1.57),('12664','2013-11-01','13:20:00',1.74),('12664','2013-11-01','13:25:00',1.35),('12664','2013-11-01','13:30:00',1.12),('12664','2013-11-01','13:35:00',1.15),('12664','2013-11-01','13:40:00',1.05),('12664','2013-11-01','14:00:00',1.5),('12664','2013-11-01','14:05:00',1.53),('12664','2013-10-31','08:20:00',1.14),('12664','2013-10-31','08:25:00',1.38),('12664','2013-10-31','08:30:00',1.66),('12664','2013-10-31','08:35:00',1.69),('12664','2013-10-31','08:40:00',1.18),('12664','2013-10-31','08:55:00',1.06),('12664','2013-10-31','09:10:00',2.07),('12664','2013-10-31','09:15:00',2.16),('12664','2013-10-31','09:20:00',1.91),('12664','2013-10-31','09:25:00',1.9),('12664','2013-10-31','09:30:00',2.1),('12664','2013-10-31','09:35:00',2.2),('12664','2013-10-31','09:40:00',2.18),('12664','2013-10-31','09:45:00',2.13),('12664','2013-10-31','09:50:00',2.25),('12664','2013-10-31','09:55:00',2.36),('12664','2013-10-31','10:00:00',2.44),('12664','2013-10-31','10:05:00',2.49),('12664','2013-10-31','10:10:00',2.55),('12664','2013-10-31','10:15:00',2.55),('12664','2013-10-31','10:20:00',2.39),('12664','2013-10-31','10:25:00',2.25),('12664','2013-10-31','10:30:00',2.52),('12664','2013-10-31','10:35:00',2.99),('12664','2013-10-31','10:40:00',3.12),('12664','2013-10-31','10:45:00',3.11),('12664','2013-10-31','10:50:00',2.81),('12664','2013-10-31','10:55:00',2.51),('12664','2013-10-31','11:00:00',2.35),('12664','2013-10-31','11:05:00',2.51),('12664','2013-10-31','11:10:00',2.73),('12664','2013-10-31','11:15:00',2.79),('12664','2013-10-31','11:20:00',2.81),('12664','2013-10-31','11:25:00',2.76),('12664','2013-10-31','11:30:00',2.64),('12664','2013-10-31','11:35:00',2.54),('12664','2013-10-31','11:40:00',2.57),('12664','2013-10-31','11:45:00',2.39),('12664','2013-10-31','11:50:00',3.02),('12664','2013-10-31','11:55:00',3.12),('12664','2013-10-31','12:00:00',3.24),('12664','2013-10-31','12:05:00',3.19),('12664','2013-10-31','12:10:00',3.16),('12664','2013-10-31','12:15:00',3.16),('12664','2013-10-31','12:20:00',3.16),('12664','2013-10-31','12:25:00',3.11),('12664','2013-10-31','12:30:00',3.05),('12664','2013-10-31','12:35:00',3.02),('12664','2013-10-31','12:40:00',2.9),('12664','2013-10-31','12:45:00',2.91),('12664','2013-10-31','12:50:00',2.97),('12664','2013-10-31','12:55:00',2.95),('12664','2013-10-31','13:00:00',2.95),('12664','2013-10-31','13:05:00',2.95),('12664','2013-10-31','13:10:00',2.9),('12664','2013-10-31','13:15:00',2.83),('12664','2013-10-31','13:20:00',2.77),('12664','2013-10-31','13:25:00',2.68),('12664','2013-10-31','13:30:00',2.61),('12664','2013-10-31','13:35:00',2.59),('12664','2013-10-31','13:40:00',2.6),('12664','2013-10-31','13:45:00',2.62),('12664','2013-10-31','13:50:00',2.56),('12664','2013-10-31','13:55:00',2.51),('12664','2013-10-31','14:00:00',2.35),('12664','2013-10-31','14:05:00',2.03),('12664','2013-10-31','14:10:00',2.31),('12664','2013-10-31','14:15:00',2.26),('12664','2013-10-31','14:20:00',2.15),('12664','2013-10-31','14:25:00',1.81),('12664','2013-10-31','14:30:00',1.98),('12664','2013-10-31','14:35:00',1.86),('12664','2013-10-31','14:40:00',1.77),('12664','2013-10-31','14:45:00',1.7),('12664','2013-10-31','14:50:00',1.65),('12664','2013-10-31','14:55:00',1.63),('12664','2013-10-31','15:00:00',1.5),('12664','2013-10-31','15:05:00',1.34),('12664','2013-10-31','15:10:00',1.23),('12664','2013-10-31','15:15:00',1.18),('12664','2013-10-31','15:20:00',1.11),('12664','2013-10-31','15:25:00',1.06),('12664','2013-10-30','08:05:00',1.03),('12664','2013-10-30','08:10:00',1.1),('12664','2013-10-30','08:15:00',1.18),('12664','2013-10-30','08:20:00',1.28),('12664','2013-10-30','08:25:00',1.33),('12664','2013-10-30','08:30:00',1.41),('12664','2013-10-30','08:35:00',1.53),('12664','2013-10-30','08:40:00',1.56),('12664','2013-10-30','08:45:00',1.62),('12664','2013-10-30','08:50:00',1.66),('12664','2013-10-30','08:55:00',1.84),('12664','2013-10-30','09:00:00',1.9),('12664','2013-10-30','09:05:00',2.02),('12664','2013-10-30','09:10:00',2.1),('12664','2013-10-30','09:15:00',2.16),('12664','2013-10-30','09:20:00',2.18),('12664','2013-10-30','09:25:00',2.12),('12664','2013-10-30','09:30:00',1.96),('12664','2013-10-30','09:35:00',2.06),('12664','2013-10-30','09:40:00',2.34),('12664','2013-10-30','09:45:00',2.43),('12664','2013-10-30','09:50:00',2.26),('12664','2013-10-30','09:55:00',2.5),('12664','2013-10-30','10:00:00',2.4),('12664','2013-10-30','10:05:00',2.53),('12664','2013-10-30','10:10:00',2.29),('12664','2013-10-30','10:15:00',1.48),('12664','2013-10-30','10:20:00',1.26),('12664','2013-10-30','10:25:00',1.55),('12664','2013-10-30','10:30:00',2.7),('12664','2013-10-30','10:35:00',2.08),('12664','2013-10-30','10:40:00',2.82),('12664','2013-10-30','10:45:00',2.73),('12664','2013-10-30','10:50:00',2.77),('12664','2013-10-30','10:55:00',2.44),('12664','2013-10-30','11:00:00',2),('12664','2013-10-30','11:05:00',1.33),('12664','2013-10-30','11:10:00',2.39),('12664','2013-10-30','11:15:00',2.54),('12664','2013-10-30','11:20:00',2.99),('12664','2013-10-30','11:25:00',2.48),('12664','2013-10-30','11:30:00',1.74),('12664','2013-10-30','11:35:00',2.07),('12664','2013-10-30','11:40:00',1.53),('12664','2013-10-30','11:45:00',2.58),('12664','2013-10-30','11:50:00',3.07),('12664','2013-10-30','11:55:00',3.12),('12664','2013-10-30','12:00:00',2.77),('12664','2013-10-30','12:05:00',2.24),('12664','2013-10-30','12:10:00',1.24),('12664','2013-10-30','12:15:00',1.33),('12664','2013-10-30','12:20:00',1.39),('12664','2013-10-30','12:25:00',2.71),('12664','2013-10-30','12:30:00',1.91),('12664','2013-10-30','12:35:00',1.22),('12664','2013-10-30','12:40:00',2.96),('12664','2013-10-30','12:45:00',2.93),('12664','2013-10-30','12:50:00',2.86),('12664','2013-10-30','12:55:00',2.09),('12664','2013-10-30','13:10:00',1.88),('12664','2013-10-30','13:15:00',2.84),('12664','2013-10-30','13:20:00',2.96),('12664','2013-10-30','13:25:00',2.91),('12664','2013-10-30','13:30:00',2.73),('12664','2013-10-30','13:35:00',1.22),('12664','2013-10-30','13:45:00',2.35),('12664','2013-10-30','13:50:00',1.88),('12664','2013-10-30','14:25:00',1.33),('12664','2013-10-30','14:30:00',1.53),('12664','2013-10-30','14:45:00',1.38),('12664','2013-10-30','14:50:00',2.15),('12664','2013-10-30','14:55:00',1.85),('12664','2013-10-30','15:00:00',1.67),('12664','2013-10-30','15:05:00',1.14),('12664','2013-10-30','15:10:00',1.17),('12664','2013-10-30','15:15:00',1.19),('12664','2013-10-30','15:20:00',1.21),('12664','2013-10-29','08:15:00',1.26),('12664','2013-10-29','08:20:00',1.35),('12664','2013-10-29','08:25:00',1.53),('12664','2013-10-29','08:30:00',1.61),('12664','2013-10-29','08:35:00',1.7),('12664','2013-10-29','08:40:00',1.76),('12664','2013-10-29','08:45:00',1.83),('12664','2013-10-29','08:50:00',1.91),('12664','2013-10-29','08:55:00',1.98),('12664','2013-10-29','09:00:00',2.04),('12664','2013-10-29','09:05:00',2.11),('12664','2013-10-29','09:10:00',2.17),('12664','2013-10-29','09:15:00',2.26),('12664','2013-10-29','09:20:00',2.31),('12664','2013-10-29','09:25:00',2.33),('12664','2013-10-29','09:30:00',2.4),('12664','2013-10-29','09:35:00',2.43),('12664','2013-10-29','09:40:00',2.52),('12664','2013-10-29','09:45:00',2.52),('12664','2013-10-29','09:50:00',2.58),('12664','2013-10-29','09:55:00',2.63),('12664','2013-10-29','10:00:00',2.66),('12664','2013-10-29','10:05:00',2.77),('12664','2013-10-29','10:10:00',2.92),('12664','2013-10-29','10:15:00',2.95),('12664','2013-10-29','10:20:00',3.08),('12664','2013-10-29','10:25:00',2.79),('12664','2013-10-29','10:30:00',3.06),('12664','2013-10-29','10:35:00',2.84),('12664','2013-10-29','10:40:00',3.35),('12664','2013-10-29','10:45:00',2.56),('12664','2013-10-29','10:50:00',3.23),('12664','2013-10-29','10:55:00',3.35),('12664','2013-10-29','11:00:00',2.98),('12664','2013-10-29','11:05:00',1.44),('12664','2013-10-29','11:10:00',1.16),('12664','2013-10-29','11:15:00',1.87),('12664','2013-10-29','11:20:00',3.69),('12664','2013-10-29','11:25:00',3.51),('12664','2013-10-29','11:30:00',3.35),('12664','2013-10-29','11:35:00',3.48),('12664','2013-10-29','11:40:00',3.55),('12664','2013-10-29','11:45:00',3.54),('12664','2013-10-29','11:50:00',2.64),('12664','2013-10-29','11:55:00',1.67),('12664','2013-10-29','12:00:00',2.9),('12664','2013-10-29','12:05:00',3.25),('12664','2013-10-29','12:10:00',2.92),('12664','2013-10-29','12:15:00',2.97),('12664','2013-10-29','12:20:00',2.84),('12664','2013-10-29','12:25:00',2.64),('12664','2013-10-29','12:30:00',2.02),('12664','2013-10-29','12:35:00',1.29),('12664','2013-10-29','12:40:00',2.32),('12664','2013-10-29','12:45:00',3.06),('12664','2013-10-29','12:50:00',3.08),('12664','2013-10-29','12:55:00',2.26),('12664','2013-10-29','13:00:00',2.8),('12664','2013-10-29','13:05:00',2),('12664','2013-10-29','13:10:00',2.04),('12664','2013-10-29','13:15:00',2.18),('12664','2013-10-29','13:20:00',1.91),('12664','2013-10-29','13:25:00',2.23),('12664','2013-10-29','13:30:00',1.68),('12664','2013-10-29','13:35:00',1.48),('12664','2013-10-29','13:40:00',1.79),('12664','2013-10-29','13:45:00',2.76),('12664','2013-10-29','13:50:00',1.55),('12664','2013-10-29','13:55:00',1.56),('12664','2013-10-29','14:00:00',2.29),('12664','2013-10-29','14:05:00',2.45),('12664','2013-10-29','14:10:00',2.35),('12664','2013-10-29','14:15:00',2.2),('12664','2013-10-29','14:20:00',2.23),('12664','2013-10-29','14:25:00',2.13),('12664','2013-10-29','14:30:00',2.09),('12664','2013-10-29','14:35:00',2.04),('12664','2013-10-29','14:40:00',1.95),('12664','2013-10-29','14:45:00',1.9),('12664','2013-10-29','14:50:00',1.78),('12664','2013-10-29','14:55:00',1.71),('12664','2013-10-29','15:00:00',1.66),('12664','2013-10-29','15:05:00',1.58),('12664','2013-10-29','15:10:00',1.48),('12664','2013-10-29','15:15:00',1.4),('12664','2013-10-29','15:20:00',1.31),('12664','2013-10-29','15:25:00',1.2),('12664','2013-10-29','15:30:00',1.13),('12664','2013-10-29','15:35:00',1.04),('12664','2013-10-28','08:35:00',1.37),('12664','2013-10-28','08:40:00',1.62),('12664','2013-10-28','08:45:00',1.62),('12664','2013-10-28','08:50:00',1.11),('12664','2013-10-28','08:55:00',1.28),('12664','2013-10-28','09:00:00',1.95),('12664','2013-10-28','09:05:00',2.12),('12664','2013-10-28','09:10:00',2.1),('12664','2013-10-28','09:15:00',1.97),('12664','2013-10-28','09:20:00',2.3),('12664','2013-10-28','09:25:00',2.44),('12664','2013-10-28','09:30:00',2.6),('12664','2013-10-28','09:35:00',2.62),('12664','2013-10-28','09:40:00',1.08),('12664','2013-10-28','10:30:00',2.91),('12664','2013-10-28','10:35:00',3.15),('12664','2013-10-28','10:40:00',3.14),('12664','2013-10-28','10:45:00',3.11),('12664','2013-10-28','10:50:00',3.14),('12664','2013-10-28','10:55:00',3.16),('12664','2013-10-28','11:00:00',3.15),('12664','2013-10-28','11:05:00',3.17),('12664','2013-10-28','11:10:00',3.17),('12664','2013-10-28','11:15:00',3.15),('12664','2013-10-28','11:20:00',3.19),('12664','2013-10-28','11:25:00',3.22),('12664','2013-10-28','11:30:00',3.24),('12664','2013-10-28','11:35:00',3.24),('12664','2013-10-28','11:40:00',3.25),('12664','2013-10-28','11:45:00',3.23),('12664','2013-10-28','11:50:00',3.23),('12664','2013-10-28','11:55:00',3.2),('12664','2013-10-28','12:00:00',3.33),('12664','2013-10-28','12:05:00',2.41),('12664','2013-10-28','12:10:00',2.86),('12664','2013-10-28','12:15:00',3.68),('12664','2013-10-28','12:20:00',2.15),('12664','2013-10-28','12:25:00',3.14),('12664','2013-10-28','12:30:00',3.49),('12664','2013-10-28','12:35:00',3.26),('12664','2013-10-28','12:40:00',3.22),('12664','2013-10-28','12:45:00',3.19),('12664','2013-10-28','12:50:00',3.19),('12664','2013-10-28','12:55:00',3.18),('12664','2013-10-28','13:00:00',3.14),('12664','2013-10-28','13:05:00',3.11),('12664','2013-10-28','13:10:00',3.05),('12664','2013-10-28','13:15:00',3),('12664','2013-10-28','13:20:00',2.96),('12664','2013-10-28','13:25:00',2.94),('12664','2013-10-28','13:30:00',2.86),('12664','2013-10-28','13:35:00',2.84),('12664','2013-10-28','13:40:00',2.84),('12664','2013-10-28','13:45:00',2.84),('12664','2013-10-28','13:50:00',2.77),('12664','2013-10-28','13:55:00',2.67),('12664','2013-10-28','14:00:00',2.63),('12664','2013-10-28','14:05:00',2.59),('12664','2013-10-28','14:10:00',2.5),('12664','2013-10-28','14:15:00',2.49),('12664','2013-10-28','14:20:00',1.75),('12664','2013-10-28','14:25:00',2.28),('12664','2013-10-28','14:30:00',2.22),('12664','2013-10-28','14:35:00',2.16),('12664','2013-10-28','14:40:00',2),('12664','2013-10-28','14:45:00',2.01),('12664','2013-10-28','14:50:00',1.91),('12664','2013-10-28','14:55:00',1.86),('12664','2013-10-28','15:00:00',1.76),('12664','2013-10-28','15:05:00',1.7),('12664','2013-10-28','15:10:00',1.62),('12664','2013-10-28','15:15:00',1.3),('12664','2013-10-28','15:20:00',1.62),('12664','2013-10-28','15:25:00',1.55),('12664','2013-10-28','15:30:00',1.2),('12664','2013-10-28','15:40:00',1.08),('12664','2014-04-16','08:05:00',1.09),('12664','2014-04-16','08:10:00',1.19),('12664','2014-04-16','08:15:00',1.29),('12664','2014-04-16','08:20:00',1.38),('12664','2014-04-16','08:25:00',1.14),('12664','2014-04-16','08:30:00',1.06),('12664','2014-04-16','08:35:00',1.16),('12664','2014-04-16','08:40:00',1.8),('12664','2014-04-16','08:45:00',1.94),('12664','2014-04-16','08:50:00',2.02),('12664','2014-04-16','08:55:00',2.12),('12664','2014-04-16','09:00:00',2.21),('12664','2014-04-16','09:05:00',2.31),('12664','2014-04-16','09:10:00',2.39),('12664','2014-04-16','09:15:00',2.47),('12664','2014-04-16','09:20:00',2.55),('12664','2014-04-16','09:25:00',2.59),('12664','2014-04-16','09:30:00',2.63),('12664','2014-04-16','09:35:00',2.86),('12664','2014-04-16','09:40:00',2.18),('12664','2014-04-16','09:45:00',2.59),('12664','2014-04-16','09:50:00',3.16),('12664','2014-04-16','09:55:00',3.17),('12664','2014-04-16','10:00:00',3.24),('12664','2014-04-16','10:05:00',3.28),('12664','2014-04-16','10:10:00',3.33),('12664','2014-04-16','10:15:00',3.38),('12664','2014-04-16','10:20:00',3.43),('12664','2014-04-16','10:25:00',3.52),('12664','2014-04-16','10:30:00',3.5),('12664','2014-04-16','10:35:00',3.66),('12664','2014-04-16','10:40:00',3.57),('12664','2014-04-16','10:45:00',4.01),('12664','2014-04-16','10:50:00',2.17),('12664','2014-04-16','10:55:00',3.12),('12664','2014-04-16','11:00:00',1.62),('12664','2014-04-16','11:05:00',1.67),('12664','2014-04-16','11:10:00',1.25),('12664','2014-04-16','11:15:00',2.55),('12664','2014-04-16','11:20:00',2.62),('12664','2014-04-16','11:25:00',3.17),('12664','2014-04-16','11:30:00',2.02),('12664','2014-04-16','11:35:00',1.5),('12664','2014-04-16','11:40:00',1.57),('12664','2014-04-16','11:45:00',1.43),('12664','2014-04-16','11:50:00',2.87),('12664','2014-04-16','11:55:00',3.92),('12664','2014-04-16','12:00:00',4.97),('12664','2014-04-16','12:05:00',3.19),('12664','2014-04-16','12:10:00',2.06),('12664','2014-04-16','12:15:00',3.28),('12664','2014-04-16','12:20:00',2.84),('12664','2014-04-16','12:25:00',3.8),('12664','2014-04-16','12:30:00',4.61),('12664','2014-04-16','12:35:00',4.95),('12664','2014-04-16','12:40:00',4.45),('12664','2014-04-16','12:45:00',5.03),('12664','2014-04-16','12:50:00',5.01),('12664','2014-04-16','12:55:00',4.74),('12664','2014-04-16','13:00:00',4.75),('12664','2014-04-16','13:05:00',2.76),('12664','2014-04-16','13:10:00',4.11),('12664','2014-04-16','13:15:00',3.31),('12664','2014-04-16','13:20:00',2.55),('12664','2014-04-16','13:25:00',1.65),('12664','2014-04-16','13:30:00',1.63),('12664','2014-04-16','13:35:00',2.59),('12664','2014-04-16','13:40:00',4.76),('12664','2014-04-16','13:45:00',4.9),('12664','2014-04-16','13:50:00',3.8),('12664','2014-04-16','13:55:00',1.88),('12664','2014-04-16','14:00:00',2.47),('12664','2014-04-16','14:05:00',4.62),('12664','2014-04-16','14:10:00',4.31),('12664','2014-04-16','14:15:00',2.03),('12664','2014-04-16','14:20:00',4.26),('12664','2014-04-16','14:25:00',3.87),('12664','2014-04-16','14:30:00',3.62),('12664','2014-04-16','14:35:00',3.65),('12664','2014-04-16','14:40:00',4.56),('12664','2014-04-16','14:45:00',2.61),('12664','2014-04-16','14:50:00',4.64),('12664','2014-04-16','14:55:00',4.41),('12664','2014-04-16','15:00:00',4.65),('12664','2014-04-16','15:05:00',1.86),('12664','2014-04-16','15:10:00',1.44),('12664','2014-04-16','15:15:00',1.21),('12664','2014-04-16','15:25:00',1),('12664','2014-04-16','15:30:00',1.21),('12664','2014-04-16','15:35:00',1.1),('12664','2014-04-16','15:40:00',1.31),('12664','2014-04-16','15:45:00',3.74),('12664','2014-04-16','15:50:00',3.44),('12664','2014-04-16','15:55:00',3.16),('12664','2014-04-16','16:00:00',3.65),('12664','2014-04-16','16:05:00',3.41),('12664','2014-04-16','16:10:00',3.25),('12664','2014-04-16','16:15:00',3.13),('12664','2014-04-16','16:20:00',1.61),('12664','2014-04-16','16:25:00',2.64),('12664','2014-04-16','16:30:00',2.96),('12664','2014-04-16','16:35:00',2.84),('12664','2014-04-16','16:40:00',2.75),('12664','2014-04-16','16:45:00',2.66),('12664','2014-04-16','16:50:00',2.57),('12664','2014-04-16','16:55:00',2.49),('12664','2014-04-16','17:00:00',2.41),('12664','2014-04-16','17:05:00',2.31),('12664','2014-04-16','17:10:00',2.24),('12664','2014-04-16','17:15:00',2.1),('12664','2014-04-16','17:20:00',1.98),('12664','2014-04-16','17:25:00',1.88),('12664','2014-04-16','17:30:00',1.78),('12664','2014-04-16','17:35:00',1.67),('12664','2014-04-16','17:40:00',1.57),('12664','2014-04-16','17:45:00',1.47),('12664','2014-04-16','17:50:00',1.38),('12664','2014-04-16','17:55:00',1.31),('12664','2014-04-16','18:00:00',1.25),('12664','2014-04-16','18:05:00',1.19),('12664','2014-04-16','18:10:00',1.02),('12664','2013-10-27','10:10:00',1.04),('12664','2013-10-27','10:15:00',1.02),('12664','2013-10-27','10:20:00',1.17),('12664','2013-10-27','10:25:00',1.47),('12664','2013-10-27','10:30:00',2.03),('12664','2013-10-27','10:35:00',1.47),('12664','2013-10-27','10:40:00',1.34),('12664','2013-10-27','10:45:00',1.07),('12664','2013-10-27','10:55:00',1.41),('12664','2013-10-27','11:00:00',1.53),('12664','2013-10-27','11:05:00',1.44),('12664','2013-10-27','11:10:00',1.37),('12664','2013-10-27','11:15:00',1.42),('12664','2013-10-27','11:20:00',1.38),('12664','2013-10-27','11:25:00',1.39),('12664','2013-10-27','11:30:00',1.64),('12664','2013-10-27','11:35:00',2.1),('12664','2013-10-27','11:40:00',1.82),('12664','2013-10-27','11:45:00',2.05),('12664','2013-10-27','11:50:00',1.93),('12664','2013-10-27','11:55:00',1.77),('12664','2013-10-27','12:00:00',1.87),('12664','2013-10-27','12:05:00',2.58),('12664','2013-10-27','12:10:00',2.52),('12664','2013-10-27','12:15:00',1.82),('12664','2013-10-27','12:20:00',2.82),('12664','2013-10-27','12:25:00',2.3),('12664','2013-10-27','12:30:00',1.54),('12664','2013-10-27','12:40:00',2.48),('12664','2013-10-27','12:45:00',2.76),('12664','2013-10-27','12:50:00',1.15),('12664','2013-10-27','12:55:00',1.17),('12664','2013-10-27','13:00:00',1.61),('12664','2013-10-27','13:05:00',1.68),('12664','2013-10-27','13:10:00',1.71),('12664','2013-10-27','13:15:00',2.09),('12664','2013-10-27','13:35:00',1.49),('12664','2013-10-27','13:40:00',1.37),('12664','2013-10-27','13:45:00',1.35),('12664','2013-10-27','13:50:00',1.12),('12664','2013-10-27','13:55:00',1.05),('12664','2013-10-27','14:10:00',1.7),('12664','2013-10-27','14:15:00',2.01),('12664','2013-10-27','14:20:00',2.59),('12664','2013-10-27','14:25:00',2.31),('12664','2013-10-27','14:30:00',2.15),('12664','2013-10-27','14:35:00',1.68),('12664','2013-10-27','14:40:00',1.1),('12664','2013-10-27','14:45:00',1.67),('12664','2013-10-27','14:50:00',1.91),('12664','2013-10-27','14:55:00',1.79),('12664','2013-10-27','15:00:00',1.83),('12664','2013-10-27','15:05:00',1.73),('12664','2013-10-27','15:10:00',1.62),('12664','2013-10-27','15:15:00',1.5),('12664','2013-10-27','15:20:00',1.26),('12664','2013-10-27','15:25:00',1.11),('12664','2013-10-27','15:40:00',1.07),('12664','2013-10-27','15:45:00',1),('12664','2013-10-26','08:55:00',1.09),('12664','2013-10-26','09:00:00',1.17),('12664','2013-10-26','09:05:00',1.26),('12664','2013-10-26','09:10:00',1.35),('12664','2013-10-26','09:15:00',1.43),('12664','2013-10-26','09:20:00',1.52),('12664','2013-10-26','09:25:00',1.61),('12664','2013-10-26','09:30:00',1.71),('12664','2013-10-26','09:35:00',1.77),('12664','2013-10-26','09:40:00',1.84),('12664','2013-10-26','09:45:00',1.9),('12664','2013-10-26','09:50:00',1.98),('12664','2013-10-26','09:55:00',2.04),('12664','2013-10-26','10:00:00',2.11),('12664','2013-10-26','10:05:00',2.17),('12664','2013-10-26','10:10:00',2.22),('12664','2013-10-26','10:15:00',2.28),('12664','2013-10-26','10:20:00',2.34),('12664','2013-10-26','10:25:00',2.4),('12664','2013-10-26','10:30:00',2.46),('12664','2013-10-26','10:35:00',2.5),('12664','2013-10-26','10:40:00',2.56),('12664','2013-10-26','10:45:00',2.6),('12664','2013-10-26','10:50:00',2.67),('12664','2013-10-26','10:55:00',2.71),('12664','2013-10-26','11:00:00',2.74),('12664','2013-10-26','11:05:00',2.77),('12664','2013-10-26','11:10:00',2.86),('12664','2013-10-26','11:15:00',2.88),('12664','2013-10-26','11:20:00',2.91),('12664','2013-10-26','11:25:00',2.93),('12664','2013-10-26','11:30:00',2.96),('12664','2013-10-26','11:35:00',2.99),('12664','2013-10-26','11:40:00',3.01),('12664','2013-10-26','11:45:00',3.07),('12664','2013-10-26','11:50:00',3.04),('12664','2013-10-26','11:55:00',3.06),('12664','2013-10-26','12:00:00',3.12),('12664','2013-10-26','12:05:00',3.11),('12664','2013-10-26','12:10:00',3.07),('12664','2013-10-26','12:15:00',3.07),('12664','2013-10-26','12:20:00',3.13),('12664','2013-10-26','12:25:00',3.21),('12664','2013-10-26','12:30:00',3.15),('12664','2013-10-26','12:35:00',3.15),('12664','2013-10-26','12:40:00',3.16),('12664','2013-10-26','12:45:00',3.22),('12664','2013-10-26','12:50:00',3.14),('12664','2013-10-26','12:55:00',3.17),('12664','2013-10-26','13:00:00',3.14),('12664','2013-10-26','13:05:00',3.13),('12664','2013-10-26','13:10:00',3.14),('12664','2013-10-26','13:15:00',3.14),('12664','2013-10-26','13:20:00',3.13),('12664','2013-10-26','13:25:00',3.14),('12664','2013-10-26','13:30:00',3.11),('12664','2013-10-26','13:35:00',3.09),('12664','2013-10-26','13:40:00',3.12),('12664','2013-10-26','13:45:00',3.04),('12664','2013-10-26','13:50:00',2.99),('12664','2013-10-26','13:55:00',3.03),('12664','2013-10-26','14:00:00',2.92),('12664','2013-10-26','14:05:00',2.94),('12664','2013-10-26','14:10:00',2.88),('12664','2013-10-26','14:15:00',2.84),('12664','2013-10-26','14:20:00',2.89),('12664','2013-10-26','14:25:00',2.65),('12664','2013-10-26','14:30:00',2.78),('12664','2013-10-26','14:35:00',2.68),('12664','2013-10-26','14:40:00',2.7),('12664','2013-10-26','14:45:00',2.54),('12664','2013-10-26','14:50:00',2.42),('12664','2013-10-26','15:00:00',1.58),('12664','2013-10-26','15:05:00',2.37),('12664','2013-10-26','15:10:00',2.21),('12664','2013-10-26','15:15:00',1.91),('12664','2013-10-26','15:20:00',2.16),('12664','2013-10-26','15:25:00',2.02),('12664','2013-10-26','15:30:00',2.06),('12664','2013-10-26','15:35:00',2),('12664','2013-10-26','15:40:00',1.89),('12664','2013-10-26','15:45:00',1.83),('12664','2013-10-26','15:50:00',1.76),('12664','2013-10-26','15:55:00',1.67),('12664','2013-10-26','16:00:00',1.6),('12664','2013-10-26','16:05:00',1.52),('12664','2013-10-26','16:10:00',1.44),('12664','2013-10-26','16:15:00',1.4),('12664','2013-10-26','16:20:00',1.28),('12664','2013-10-26','16:25:00',1.2),('12664','2013-10-26','16:30:00',1.12),('12664','2013-10-26','16:35:00',1.05),('12664','2013-10-25','08:50:00',1),('12664','2013-10-25','08:55:00',1.1),('12664','2013-10-25','09:00:00',1.18),('12664','2013-10-25','09:05:00',1.26),('12664','2013-10-25','09:10:00',1.35),('12664','2013-10-25','09:15:00',1.44),('12664','2013-10-25','09:20:00',1.54),('12664','2013-10-25','09:25:00',1.62),('12664','2013-10-25','09:30:00',1.71),('12664','2013-10-25','09:35:00',1.79),('12664','2013-10-25','09:40:00',1.87),('12664','2013-10-25','09:45:00',1.94),('12664','2013-10-25','09:50:00',2.01),('12664','2013-10-25','09:55:00',2.08),('12664','2013-10-25','10:00:00',2.15),('12664','2013-10-25','10:05:00',2.23),('12664','2013-10-25','10:10:00',2.29),('12664','2013-10-25','10:15:00',2.34),('12664','2013-10-25','10:20:00',2.42),('12664','2013-10-25','10:25:00',2.48),('12664','2013-10-25','10:30:00',2.53),('12664','2013-10-25','10:35:00',2.6),('12664','2013-10-25','10:40:00',2.63),('12664','2013-10-25','10:45:00',2.66),('12664','2013-10-25','10:50:00',2.74),('12664','2013-10-25','10:55:00',2.79),('12664','2013-10-25','11:00:00',2.83),('12664','2013-10-25','11:05:00',2.86),('12664','2013-10-25','11:10:00',2.9),('12664','2013-10-25','11:15:00',2.94),('12664','2013-10-25','11:20:00',3),('12664','2013-10-25','11:25:00',3.04),('12664','2013-10-25','11:30:00',3.04),('12664','2013-10-25','11:35:00',3.07),('12664','2013-10-25','11:40:00',3.12),('12664','2013-10-25','11:45:00',3.15),('12664','2013-10-25','11:50:00',3.17),('12664','2013-10-25','11:55:00',3.19),('12664','2013-10-25','12:00:00',3.2),('12664','2013-10-25','12:05:00',3.24),('12664','2013-10-25','12:10:00',3.24),('12664','2013-10-25','12:15:00',3.24),('12664','2013-10-25','12:20:00',3.24),('12664','2013-10-25','12:25:00',3.27),('12664','2013-10-25','12:30:00',3.28),('12664','2013-10-25','12:35:00',3.31),('12664','2013-10-25','12:40:00',3.3),('12664','2013-10-25','12:45:00',3.31),('12664','2013-10-25','12:50:00',3.31),('12664','2013-10-25','12:55:00',3.31),('12664','2013-10-25','13:00:00',3.28),('12664','2013-10-25','13:05:00',3.28),('12664','2013-10-25','13:10:00',3.25),('12664','2013-10-25','13:15:00',3.22),('12664','2013-10-25','13:20:00',3.23),('12664','2013-10-25','13:25:00',3.2),('12664','2013-10-25','13:30:00',3.18),('12664','2013-10-25','13:35:00',3.19),('12664','2013-10-25','13:40:00',3.19),('12664','2013-10-25','13:45:00',3.17),('12664','2013-10-25','13:50:00',3.12),('12664','2013-10-25','13:55:00',3.05),('12664','2013-10-25','14:00:00',3.01),('12664','2013-10-25','14:05:00',3.01),('12664','2013-10-25','14:10:00',2.98),('12664','2013-10-25','14:15:00',2.92),('12664','2013-10-25','14:20:00',2.78),('12664','2013-10-25','14:25:00',2.9),('12664','2013-10-25','14:30:00',2.82),('12664','2013-10-25','14:35:00',2.8),('12664','2013-10-25','14:40:00',2.73),('12664','2013-10-25','14:45:00',2.7),('12664','2013-10-25','14:50:00',2.64),('12664','2013-10-25','14:55:00',2.6),('12664','2013-10-25','15:00:00',2.56),('12664','2013-10-25','15:05:00',2.45),('12664','2013-10-25','15:10:00',2.34),('12664','2013-10-25','15:15:00',2.26),('12664','2013-10-25','15:20:00',2.22),('12664','2013-10-25','15:25:00',2.21),('12664','2013-10-25','15:30:00',2.19),('12664','2013-10-25','15:35:00',2.15),('12664','2013-10-25','15:40:00',2.08),('12664','2013-10-25','15:45:00',2.02),('12664','2013-10-25','15:50:00',1.97),('12664','2013-10-25','15:55:00',1.9),('12664','2013-10-25','16:00:00',1.81),('12664','2013-10-25','16:05:00',1.74),('12664','2013-10-25','16:10:00',1.68),('12664','2013-10-25','16:15:00',1.58),('12664','2013-10-25','16:20:00',1.49),('12664','2013-10-25','16:25:00',1.4),('12664','2013-10-25','16:30:00',1.31),('12664','2013-10-25','16:35:00',1.22),('12664','2013-10-25','16:40:00',1.13),('12664','2013-10-25','16:45:00',1.03),('12664','2013-10-24','08:55:00',1.26),('12664','2013-10-24','09:00:00',1.46),('12664','2013-10-24','09:05:00',1.45),('12664','2013-10-24','09:10:00',1.02),('12664','2013-10-24','09:25:00',1.02),('12664','2013-10-24','09:40:00',1.02),('12664','2013-10-24','09:45:00',1.02),('12664','2013-10-24','10:25:00',1.35),('12664','2013-10-24','10:30:00',2.72),('12664','2013-10-24','10:35:00',3.43),('12664','2013-10-24','10:40:00',3.43),('12664','2013-10-24','10:45:00',3.03),('12664','2013-10-24','10:50:00',1.69),('12664','2013-10-24','10:55:00',2.07),('12664','2013-10-24','11:00:00',1.3),('12664','2013-10-24','11:05:00',1.54),('12664','2013-10-24','11:10:00',1.29),('12664','2013-10-24','11:15:00',1.29),('12664','2013-10-24','11:20:00',1.05),('12664','2013-10-24','11:25:00',1.26),('12664','2013-10-24','11:30:00',2.71),('12664','2013-10-24','11:35:00',3.86),('12664','2013-10-24','11:40:00',3.3),('12664','2013-10-24','11:45:00',3.13),('12664','2013-10-24','11:50:00',1.77),('12664','2013-10-24','11:55:00',1.28),('12664','2013-10-24','12:00:00',1.32),('12664','2013-10-24','12:05:00',1.4),('12664','2013-10-24','12:10:00',1.57),('12664','2013-10-24','12:15:00',1.87),('12664','2013-10-24','12:20:00',1.89),('12664','2013-10-24','12:25:00',1.88),('12664','2013-10-24','12:30:00',1.74),('12664','2013-10-24','12:35:00',1.57),('12664','2013-10-24','12:40:00',1.59),('12664','2013-10-24','12:45:00',1.55),('12664','2013-10-24','12:50:00',1.5),('12664','2013-10-24','12:55:00',1.4),('12664','2013-10-24','13:00:00',1.33),('12664','2013-10-24','13:05:00',1.25),('12664','2013-10-24','13:10:00',1.23),('12664','2013-10-24','13:15:00',1.2),('12664','2013-10-24','13:20:00',1.19),('12664','2013-10-24','13:25:00',1.21),('12664','2013-10-24','13:30:00',1.25),('12664','2013-10-24','13:35:00',1.29),('12664','2013-10-24','13:40:00',1.44),('12664','2013-10-24','13:45:00',2.6),('12664','2013-10-24','13:50:00',1.24),('12664','2013-10-24','13:55:00',1.25),('12664','2013-10-24','14:00:00',1.49),('12664','2013-10-24','14:05:00',1.57),('12664','2013-10-24','14:10:00',1.25),('12664','2013-10-24','14:15:00',1.28),('12664','2013-10-24','14:20:00',1.38),('12664','2013-10-24','14:25:00',1.94),('12664','2013-10-24','14:30:00',2.13),('12664','2013-10-24','14:35:00',2.38),('12664','2013-10-24','14:40:00',1.17),('12664','2013-10-24','14:50:00',1.1),('12664','2013-10-24','14:55:00',1.5),('12664','2013-10-24','15:00:00',1.69),('12664','2013-10-24','15:05:00',1.11),('12664','2013-10-24','15:10:00',1.11),('12664','2013-10-24','15:15:00',1.05),('12664','2013-10-24','15:20:00',1.23),('12664','2013-10-24','15:25:00',1.18),('12664','2013-10-24','15:30:00',2.38),('12664','2013-10-24','15:35:00',2.6),('12664','2013-10-24','15:40:00',2.48),('12664','2013-10-24','15:45:00',2.07),('12664','2013-10-23','10:30:00',1),('12664','2013-10-23','10:35:00',1.01),('12664','2013-10-23','10:40:00',1.2),('12664','2013-10-23','10:45:00',1.23),('12664','2013-10-23','10:50:00',2.31),('12664','2013-10-23','10:55:00',1.63),('12664','2013-10-23','11:00:00',2.65),('12664','2013-10-23','11:05:00',2.77),('12664','2013-10-23','11:10:00',2.76),('12664','2013-10-23','11:15:00',2.99),('12664','2013-10-23','11:20:00',2.84),('12664','2013-10-23','11:25:00',3),('12664','2013-10-23','11:30:00',2.93),('12664','2013-10-23','11:35:00',1.99),('12664','2013-10-23','11:40:00',3.05),('12664','2013-10-23','11:45:00',2.5),('12664','2013-10-23','11:50:00',1.52),('12664','2013-10-23','11:55:00',2.45),('12664','2013-10-23','12:00:00',2.96),('12664','2013-10-23','12:05:00',2.44),('12664','2013-10-23','12:10:00',2.84),('12664','2013-10-23','12:15:00',3.06),('12664','2013-10-23','12:20:00',3.07),('12664','2013-10-23','12:25:00',3.25),('12664','2013-10-23','12:30:00',3.28),('12664','2013-10-23','12:35:00',3.22),('12664','2013-10-23','12:40:00',3.19),('12664','2013-10-23','12:45:00',3.21),('12664','2013-10-23','12:50:00',3.18),('12664','2013-10-23','12:55:00',3.16),('12664','2013-10-23','13:00:00',3.19),('12664','2013-10-23','13:05:00',3.19),('12664','2013-10-23','13:10:00',3.19),('12664','2013-10-23','13:15:00',3.07),('12664','2013-10-23','13:20:00',3.08),('12664','2013-10-23','13:25:00',3.12),('12664','2013-10-23','13:30:00',3.09),('12664','2013-10-23','13:35:00',3.12),('12664','2013-10-23','13:40:00',3.11),('12664','2013-10-23','13:45:00',3.02),('12664','2013-10-23','13:50:00',2.97),('12664','2013-10-23','13:55:00',2.97),('12664','2013-10-23','14:00:00',2.94),('12664','2013-10-23','14:05:00',2.94),('12664','2013-10-23','14:10:00',2.89),('12664','2013-10-23','14:15:00',2.78),('12664','2013-10-23','14:20:00',2.75),('12664','2013-10-23','14:25:00',2.64),('12664','2013-10-23','14:30:00',2.54),('12664','2013-10-23','14:35:00',2.48),('12664','2013-10-23','14:40:00',2.45),('12664','2013-10-23','14:45:00',2.44),('12664','2013-10-23','14:50:00',2.22),('12664','2013-10-23','14:55:00',2.43),('12664','2013-10-23','15:00:00',2.29),('12664','2013-10-23','15:05:00',2.22),('12664','2013-10-23','15:10:00',1.99),('12664','2013-10-23','15:15:00',2.22),('12664','2013-10-23','15:20:00',2.06),('12664','2013-10-23','15:25:00',1.91),('12664','2013-10-23','15:30:00',1.81),('12664','2013-10-23','15:35:00',1.83),('12664','2013-10-23','15:40:00',1.99),('12664','2013-10-23','15:45:00',1.88),('12664','2013-10-23','15:50:00',1.75),('12664','2013-10-23','15:55:00',1.41),('12664','2013-10-23','16:05:00',1.16),('12664','2013-10-23','16:10:00',1.1),('12664','2013-10-23','16:15:00',1.23),('12664','2013-10-23','16:20:00',1.25),('12664','2013-10-23','16:25:00',1.25),('12664','2013-10-23','16:30:00',1.31),('12664','2013-10-23','16:35:00',1.24),('12664','2013-10-23','16:40:00',1.09),('12664','2013-10-22','08:55:00',1.05),('12664','2013-10-22','09:00:00',1.14),('12664','2013-10-22','09:05:00',1.22),('12664','2013-10-22','09:10:00',1.31),('12664','2013-10-22','09:15:00',1.39),('12664','2013-10-22','09:20:00',1.47),('12664','2013-10-22','09:25:00',1.56),('12664','2013-10-22','09:30:00',1.65),('12664','2013-10-22','09:35:00',1.72),('12664','2013-10-22','09:40:00',1.79),('12664','2013-10-22','09:45:00',1.86),('12664','2013-10-22','09:50:00',1.93),('12664','2013-10-22','09:55:00',2.03),('12664','2013-10-22','10:00:00',2.1),('12664','2013-10-22','10:05:00',2.18),('12664','2013-10-22','10:10:00',2.23),('12664','2013-10-22','10:15:00',2.28),('12664','2013-10-22','10:20:00',2.35),('12664','2013-10-22','10:25:00',2.42),('12664','2013-10-22','10:30:00',2.45),('12664','2013-10-22','10:35:00',2.52),('12664','2013-10-22','10:40:00',2.57),('12664','2013-10-22','10:45:00',2.62),('12664','2013-10-22','10:50:00',2.63),('12664','2013-10-22','10:55:00',2.64),('12664','2013-10-22','11:00:00',2.66),('12664','2013-10-22','11:05:00',2.71),('12664','2013-10-22','11:10:00',2.75),('12664','2013-10-22','11:15:00',2.8),('12664','2013-10-22','11:20:00',2.83),('12664','2013-10-22','11:25:00',2.87),('12664','2013-10-22','11:30:00',2.88),('12664','2013-10-22','11:35:00',2.89),('12664','2013-10-22','11:40:00',2.92),('12664','2013-10-22','11:45:00',2.89),('12664','2013-10-22','11:50:00',3.03),('12664','2013-10-22','11:55:00',2.99),('12664','2013-10-22','12:00:00',3.02),('12664','2013-10-22','12:05:00',3.05),('12664','2013-10-22','12:10:00',3.06),('12664','2013-10-22','12:15:00',3.03),('12664','2013-10-22','12:20:00',3.05),('12664','2013-10-22','12:25:00',3.05),('12664','2013-10-22','12:30:00',3.12),('12664','2013-10-22','12:35:00',3.1),('12664','2013-10-22','12:40:00',3.17),('12664','2013-10-22','12:45:00',3.13),('12664','2013-10-22','12:50:00',2.91),('12664','2013-10-22','12:55:00',3.09),('12664','2013-10-22','13:00:00',3.15),('12664','2013-10-22','13:05:00',3.21),('12664','2013-10-22','13:10:00',3.17),('12664','2013-10-22','13:15:00',3.14),('12664','2013-10-22','13:20:00',3.16),('12664','2013-10-22','13:25:00',3.22),('12664','2013-10-22','13:30:00',3.16),('12664','2013-10-22','13:35:00',3.14),('12664','2013-10-22','13:40:00',3.22),('12664','2013-10-22','13:45:00',2.23),('12664','2013-10-22','13:50:00',3),('12664','2013-10-22','13:55:00',3.08),('12664','2013-10-22','14:00:00',3.05),('12664','2013-10-22','14:05:00',3.09),('12664','2013-10-22','14:10:00',2.94),('12664','2013-10-22','14:15:00',2.86),('12664','2013-10-22','14:20:00',2.8),('12664','2013-10-22','14:25:00',2.27),('12664','2013-10-22','14:30:00',2.53),('12664','2013-10-22','14:35:00',2.14),('12664','2013-10-22','14:40:00',2.66),('12664','2013-10-22','14:45:00',2.64),('12664','2013-10-22','14:50:00',2.64),('12664','2013-10-22','14:55:00',2.6),('12664','2013-10-22','15:00:00',2.48),('12664','2013-10-22','15:05:00',2.42),('12664','2013-10-22','15:10:00',2.32),('12664','2013-10-22','15:15:00',2.34),('12664','2013-10-22','15:20:00',2.22),('12664','2013-10-22','15:25:00',2.19),('12664','2013-10-22','15:30:00',2.07),('12664','2013-10-22','15:35:00',2.04),('12664','2013-10-22','15:40:00',1.97),('12664','2013-10-22','15:45:00',1.91),('12664','2013-10-22','15:50:00',1.82),('12664','2013-10-22','15:55:00',1.78),('12664','2013-10-22','16:00:00',1.69),('12664','2013-10-22','16:05:00',1.6),('12664','2013-10-22','16:10:00',1.54),('12664','2013-10-22','16:15:00',1.47),('12664','2013-10-22','16:20:00',1.38),('12664','2013-10-22','16:25:00',1.31),('12664','2013-10-22','16:30:00',1.23),('12664','2013-10-22','16:35:00',1.14),('12664','2013-10-22','16:40:00',1.06),('12664','2013-10-21','09:05:00',1.12),('12664','2013-10-21','09:10:00',1.43),('12664','2013-10-21','09:15:00',1.61),('12664','2013-10-21','09:20:00',1.58),('12664','2013-10-21','09:25:00',1.57),('12664','2013-10-21','09:30:00',1.44),('12664','2013-10-21','09:35:00',1.7),('12664','2013-10-21','09:40:00',1.68),('12664','2013-10-21','09:45:00',1.78),('12664','2013-10-21','09:50:00',1.93),('12664','2013-10-21','09:55:00',2.11),('12664','2013-10-21','10:00:00',2.11),('12664','2013-10-21','10:05:00',2.13),('12664','2013-10-21','10:10:00',2.13),('12664','2013-10-21','10:15:00',2.17),('12664','2013-10-21','10:20:00',2.55),('12664','2013-10-21','10:25:00',2.48),('12664','2013-10-21','10:30:00',2.56),('12664','2013-10-21','10:35:00',2.63),('12664','2013-10-21','10:40:00',2.69),('12664','2013-10-21','10:45:00',2.77),('12664','2013-10-21','10:50:00',2.81),('12664','2013-10-21','10:55:00',2.51),('12664','2013-10-21','11:00:00',2.96),('12664','2013-10-21','11:05:00',2.97),('12664','2013-10-21','11:10:00',3),('12664','2013-10-21','11:15:00',3.02),('12664','2013-10-21','11:20:00',2.95),('12664','2013-10-21','11:25:00',3.02),('12664','2013-10-21','11:30:00',3),('12664','2013-10-21','11:35:00',2.87),('12664','2013-10-21','11:40:00',3.09),('12664','2013-10-21','11:45:00',3.14),('12664','2013-10-21','11:50:00',3.16),('12664','2013-10-21','11:55:00',3.17),('12664','2013-10-21','12:00:00',3.19),('12664','2013-10-21','12:05:00',3.19),('12664','2013-10-21','12:10:00',3.18),('12664','2013-10-21','12:15:00',3.18),('12664','2013-10-21','12:20:00',3.19),('12664','2013-10-21','12:25:00',3.27),('12664','2013-10-21','12:30:00',3.34),('12664','2013-10-21','12:35:00',3.2),('12664','2013-10-21','12:40:00',3.27),('12664','2013-10-21','12:45:00',3.25),('12664','2013-10-21','12:50:00',3.23),('12664','2013-10-21','12:55:00',3.22),('12664','2013-10-21','13:00:00',3.05),('12664','2013-10-21','13:05:00',3.18),('12664','2013-10-21','13:10:00',3.14),('12664','2013-10-21','13:15:00',2.91),('12664','2013-10-21','13:20:00',3.13),('12664','2013-10-21','13:25:00',3.09),('12664','2013-10-21','13:30:00',3.13),('12664','2013-10-21','13:35:00',3.11),('12664','2013-10-21','13:40:00',3.12),('12664','2013-10-21','13:45:00',2.98),('12664','2013-10-21','13:50:00',2.94),('12664','2013-10-21','13:55:00',2.9),('12664','2013-10-21','14:00:00',3.06),('12664','2013-10-21','14:05:00',3.03),('12664','2013-10-21','14:10:00',2.99),('12664','2013-10-21','14:15:00',2.96),('12664','2013-10-21','14:20:00',2.9),('12664','2013-10-21','14:25:00',2.91),('12664','2013-10-21','14:30:00',2.85),('12664','2013-10-21','14:35:00',2.8),('12664','2013-10-21','14:40:00',2.76),('12664','2013-10-21','14:45:00',2.7),('12664','2013-10-21','14:50:00',2.63),('12664','2013-10-21','14:55:00',2.56),('12664','2013-10-21','15:00:00',2.5),('12664','2013-10-21','15:05:00',2.4),('12664','2013-10-21','15:10:00',2.34),('12664','2013-10-21','15:15:00',2.38),('12664','2013-10-21','15:20:00',2.35),('12664','2013-10-21','15:25:00',2.3),('12664','2013-10-21','15:30:00',2.23),('12664','2013-10-21','15:35:00',2.17),('12664','2013-10-21','15:40:00',2.09),('12664','2013-10-21','15:45:00',2.02),('12664','2013-10-21','15:50:00',1.92),('12664','2013-10-21','15:55:00',1.86),('12664','2013-10-21','16:00:00',1.78),('12664','2013-10-21','16:05:00',1.7),('12664','2013-10-21','16:10:00',1.66),('12664','2013-10-21','16:15:00',1.54),('12664','2013-10-21','16:20:00',1.46),('12664','2013-10-21','16:25:00',1.37),('12664','2013-10-21','16:30:00',1.29),('12664','2013-10-21','16:35:00',1.24),('12664','2013-10-21','16:40:00',1.17),('12664','2013-10-21','16:45:00',1.07),('12664','2013-10-20','08:50:00',1.26),('12664','2013-10-20','08:55:00',1.24),('12664','2013-10-20','09:00:00',1.32),('12664','2013-10-20','09:05:00',1.44),('12664','2013-10-20','09:10:00',1.52),('12664','2013-10-20','09:15:00',1.58),('12664','2013-10-20','09:20:00',1.67),('12664','2013-10-20','09:25:00',1.74),('12664','2013-10-20','09:30:00',1.83),('12664','2013-10-20','09:35:00',1.9),('12664','2013-10-20','09:40:00',1.99),('12664','2013-10-20','09:45:00',2.07),('12664','2013-10-20','09:50:00',2.13),('12664','2013-10-20','09:55:00',2.21),('12664','2013-10-20','10:00:00',2.28),('12664','2013-10-20','10:05:00',2.36),('12664','2013-10-20','10:10:00',2.41),('12664','2013-10-20','10:15:00',2.47),('12664','2013-10-20','10:20:00',2.54),('12664','2013-10-20','10:25:00',2.59),('12664','2013-10-20','10:30:00',2.66),('12664','2013-10-20','10:35:00',2.72),('12664','2013-10-20','10:40:00',2.77),('12664','2013-10-20','10:45:00',2.82),('12664','2013-10-20','10:50:00',2.85),('12664','2013-10-20','10:55:00',2.91),('12664','2013-10-20','11:00:00',2.94),('12664','2013-10-20','11:05:00',2.97),('12664','2013-10-20','11:10:00',3.02),('12664','2013-10-20','11:15:00',3.05),('12664','2013-10-20','11:20:00',3.12),('12664','2013-10-20','11:25:00',3.1),('12664','2013-10-20','11:30:00',2.94),('12664','2013-10-20','11:35:00',3.04),('12664','2013-10-20','11:40:00',3.23),('12664','2013-10-20','11:45:00',3.25),('12664','2013-10-20','11:50:00',3.14),('12664','2013-10-20','11:55:00',3.28),('12664','2013-10-20','12:00:00',3.26),('12664','2013-10-20','12:05:00',3.34),('12664','2013-10-20','12:10:00',3.29),('12664','2013-10-20','12:15:00',2.84),('12664','2013-10-20','12:20:00',3.38),('12664','2013-10-20','12:25:00',3.44),('12664','2013-10-20','12:30:00',2.15),('12664','2013-10-20','12:35:00',2.76),('12664','2013-10-20','12:40:00',3.63),('12664','2013-10-20','12:45:00',1.87),('12664','2013-10-20','12:50:00',2.48),('12664','2013-10-20','12:55:00',2.12),('12664','2013-10-20','13:00:00',1.6),('12664','2013-10-20','13:05:00',1.06),('12664','2013-10-20','13:10:00',2.14),('12664','2013-10-20','13:15:00',3.85),('12664','2013-10-20','13:20:00',2.94),('12664','2013-10-20','13:25:00',3.7),('12664','2013-10-20','13:30:00',3.6),('12664','2013-10-20','13:35:00',3.52),('12664','2013-10-20','13:40:00',3.53),('12664','2013-10-20','13:45:00',3.64),('12664','2013-10-20','13:50:00',2.5),('12664','2013-10-20','13:55:00',3.39),('12664','2013-10-20','14:00:00',3.55),('12664','2013-10-20','14:05:00',3.54),('12664','2013-10-20','14:10:00',3.51),('12664','2013-10-20','14:15:00',3.48),('12664','2013-10-20','14:20:00',3.27),('12664','2013-10-20','14:25:00',2.02),('12664','2013-10-20','14:30:00',2.57),('12664','2013-10-20','14:35:00',1.88),('12664','2013-10-20','14:40:00',2.3),('12664','2013-10-20','14:45:00',2.78),('12664','2013-10-20','14:50:00',2.93),('12664','2013-10-20','14:55:00',2.62),('12664','2013-10-20','15:00:00',1.61),('12664','2013-10-20','15:05:00',1.62),('12664','2013-10-20','15:10:00',2.79),('12664','2013-10-20','15:15:00',2.75),('12664','2013-10-20','15:20:00',2.72),('12664','2013-10-20','15:25:00',2.6),('12664','2013-10-20','15:30:00',1.52),('12664','2013-10-20','15:35:00',1.54),('12664','2013-10-20','15:40:00',1.97),('12664','2013-10-20','15:45:00',2.58),('12664','2013-10-20','15:50:00',2.49),('12664','2013-10-20','15:55:00',2.27),('12664','2013-10-20','16:05:00',2.01),('12664','2013-10-20','16:10:00',1.96),('12664','2013-10-20','16:15:00',1.82),('12664','2013-10-20','16:20:00',1.7),('12664','2013-10-20','16:25:00',1.59),('12664','2013-10-20','16:30:00',1.5),('12664','2013-10-20','16:35:00',1.4),('12664','2013-10-20','16:40:00',1.29),('12664','2013-10-20','16:45:00',1.18),('12664','2013-10-20','16:50:00',1.1),('12664','2013-10-20','16:55:00',1.01),('12664','2013-10-19','08:35:00',1.02),('12664','2013-10-19','08:40:00',1.08),('12664','2013-10-19','08:45:00',1.23),('12664','2013-10-19','08:50:00',1.35),('12664','2013-10-19','08:55:00',1.21),('12664','2013-10-19','09:00:00',1.39),('12664','2013-10-19','09:05:00',1.8),('12664','2013-10-19','09:10:00',1.9),('12664','2013-10-19','09:15:00',2.01),('12664','2013-10-19','09:20:00',2.1),('12664','2013-10-19','09:25:00',2.2),('12664','2013-10-19','09:30:00',2.31),('12664','2013-10-19','09:35:00',2.39),('12664','2013-10-19','09:40:00',2.31),('12664','2013-10-19','09:45:00',2.44),('12664','2013-10-19','09:50:00',2.55),('12664','2013-10-19','09:55:00',2.54),('12664','2013-10-19','10:00:00',2.51),('12664','2013-10-19','10:05:00',2.61),('12664','2013-10-19','10:10:00',2.65),('12664','2013-10-19','10:15:00',2.71),('12664','2013-10-19','10:20:00',2.84),('12664','2013-10-19','10:25:00',2.92),('12664','2013-10-19','10:30:00',2.97),('12664','2013-10-19','10:35:00',2.99),('12664','2013-10-19','10:40:00',3.04),('12664','2013-10-19','10:45:00',2.89),('12664','2013-10-19','10:50:00',2.98),('12664','2013-10-19','10:55:00',3.02),('12664','2013-10-19','11:00:00',2.51),('12664','2013-10-19','11:05:00',3),('12664','2013-10-19','11:10:00',3.24),('12664','2013-10-19','11:15:00',3.36),('12664','2013-10-19','11:20:00',3.38),('12664','2013-10-19','11:25:00',3.37),('12664','2013-10-19','11:30:00',3.38),('12664','2013-10-19','11:35:00',3.45),('12664','2013-10-19','11:40:00',3.28),('12664','2013-10-19','11:45:00',3.37),('12664','2013-10-19','11:50:00',3.49),('12664','2013-10-19','11:55:00',3.46),('12664','2013-10-19','12:00:00',3.54),('12664','2013-10-19','12:05:00',3.58),('12664','2013-10-19','12:10:00',3.51),('12664','2013-10-19','12:15:00',3.33),('12664','2013-10-19','12:20:00',3.63),('12664','2013-10-19','12:25:00',3.63),('12664','2013-10-19','12:30:00',3.55),('12664','2013-10-19','12:35:00',3.76),('12664','2013-10-19','12:40:00',4),('12664','2013-10-19','12:45:00',4.09),('12664','2013-10-19','12:50:00',3.9),('12664','2013-10-19','12:55:00',3.45),('12664','2013-10-19','13:00:00',3.64),('12664','2013-10-19','13:05:00',2.9),('12664','2013-10-19','13:10:00',2.77),('12664','2013-10-19','13:15:00',2.83),('12664','2013-10-19','13:20:00',2.64),('12664','2013-10-19','13:25:00',2.95),('12664','2013-10-19','13:30:00',2.83),('12664','2013-10-19','13:35:00',2.8),('12664','2013-10-19','13:40:00',3.65),('12664','2013-10-19','13:45:00',3.77),('12664','2013-10-19','13:50:00',3.05),('12664','2013-10-19','13:55:00',3.03),('12664','2013-10-19','14:00:00',3.24),('12664','2013-10-19','14:05:00',3.06),('12664','2013-10-19','14:10:00',2.07),('12664','2013-10-19','14:15:00',3.42),('12664','2013-10-19','14:20:00',3.23),('12664','2013-10-19','14:25:00',3.25),('12664','2013-10-19','14:30:00',3.23),('12664','2013-10-19','14:35:00',3.17),('12664','2013-10-19','14:40:00',2.95),('12664','2013-10-19','14:45:00',2.89),('12664','2013-10-19','14:50:00',2.82),('12664','2013-10-19','14:55:00',2.74),('12664','2013-10-19','15:00:00',2.78),('12664','2013-10-19','15:05:00',2.64),('12664','2013-10-19','15:10:00',2.58),('12664','2013-10-19','15:15:00',2.56),('12664','2013-10-19','15:20:00',2.53),('12664','2013-10-19','15:25:00',2.39),('12664','2013-10-19','15:30:00',2.21),('12664','2013-10-19','15:35:00',1.93),('12664','2013-10-19','15:40:00',2.28),('12664','2013-10-19','15:45:00',2.38),('12664','2013-10-19','15:50:00',2.23),('12664','2013-10-19','15:55:00',1.99),('12664','2013-10-19','16:00:00',2.05),('12664','2013-10-19','16:05:00',2.02),('12664','2013-10-19','16:10:00',1.22),('12664','2013-10-19','16:15:00',1.33),('12664','2013-10-19','16:20:00',1.83),('12664','2013-10-19','16:25:00',1.87),('12664','2013-10-19','16:30:00',1.46),('12664','2013-10-19','16:35:00',1.51),('12664','2013-10-19','16:40:00',1.45),('12664','2013-10-19','16:45:00',1.2),('12664','2013-10-19','16:50:00',1.06),('12664','2013-10-18','08:40:00',1.06),('12664','2013-10-18','08:45:00',1.17),('12664','2013-10-18','08:50:00',1.2),('12664','2013-10-18','08:55:00',1.3),('12664','2013-10-18','09:00:00',1.51),('12664','2013-10-18','09:05:00',1.63),('12664','2013-10-18','09:10:00',1.69),('12664','2013-10-18','09:15:00',1.81),('12664','2013-10-18','09:20:00',1.92),('12664','2013-10-18','09:25:00',2.01),('12664','2013-10-18','09:30:00',2.12),('12664','2013-10-18','09:35:00',2.2),('12664','2013-10-18','09:40:00',2.28),('12664','2013-10-18','09:45:00',2.35),('12664','2013-10-18','09:50:00',2.42),('12664','2013-10-18','09:55:00',2.45),('12664','2013-10-18','10:00:00',2.54),('12664','2013-10-18','10:05:00',2.6),('12664','2013-10-18','10:10:00',2.65),('12664','2013-10-18','10:15:00',2.73),('12664','2013-10-18','10:20:00',2.77),('12664','2013-10-18','10:25:00',2.86),('12664','2013-10-18','10:30:00',2.9),('12664','2013-10-18','10:35:00',2.96),('12664','2013-10-18','10:40:00',3),('12664','2013-10-18','10:45:00',3.07),('12664','2013-10-18','10:50:00',3.12),('12664','2013-10-18','10:55:00',3.12),('12664','2013-10-18','11:00:00',3.11),('12664','2013-10-18','11:05:00',3.08),('12664','2013-10-18','11:10:00',3.08),('12664','2013-10-18','11:15:00',3.22),('12664','2013-10-18','11:20:00',3.19),('12664','2013-10-18','11:25:00',3.32),('12664','2013-10-18','11:30:00',3.34),('12664','2013-10-18','11:35:00',3.49),('12664','2013-10-18','11:40:00',3.45),('12664','2013-10-18','11:45:00',3.48),('12664','2013-10-18','11:50:00',3.51),('12664','2013-10-18','11:55:00',3.43),('12664','2013-10-18','12:00:00',3.53),('12664','2013-10-18','12:05:00',3.54),('12664','2013-10-18','12:10:00',3.51),('12664','2013-10-18','12:15:00',3.46),('12664','2013-10-18','12:20:00',3.51),('12664','2013-10-18','12:25:00',3.57),('12664','2013-10-18','12:30:00',3.51),('12664','2013-10-18','12:35:00',3.51),('12664','2013-10-18','12:40:00',3.51),('12664','2013-10-18','12:45:00',3.44),('12664','2013-10-18','12:50:00',3.47),('12664','2013-10-18','12:55:00',3.47),('12664','2013-10-18','13:00:00',3.38),('12664','2013-10-18','13:05:00',3.39),('12664','2013-10-18','13:10:00',3.48),('12664','2013-10-18','13:15:00',3.47),('12664','2013-10-18','13:20:00',3.56),('12664','2013-10-18','13:25:00',3.55),('12664','2013-10-18','13:30:00',3.5),('12664','2013-10-18','13:35:00',3.48),('12664','2013-10-18','13:40:00',3.37),('12664','2013-10-18','13:45:00',3.29),('12664','2013-10-18','13:50:00',3.36),('12664','2013-10-18','13:55:00',3.14),('12664','2013-10-18','14:00:00',3.26),('12664','2013-10-18','14:05:00',3.29),('12664','2013-10-18','14:10:00',3.26),('12664','2013-10-18','14:15:00',3.23),('12664','2013-10-18','14:20:00',3.22),('12664','2013-10-18','14:25:00',3.22),('12664','2013-10-18','14:30:00',3.07),('12664','2013-10-18','14:35:00',3.08),('12664','2013-10-18','14:40:00',3.06),('12664','2013-10-18','14:45:00',3.01),('12664','2013-10-18','14:50:00',2.98),('12664','2013-10-18','14:55:00',2.83),('12664','2013-10-18','15:00:00',2.47),('12664','2013-10-18','15:05:00',2.5),('12664','2013-10-18','15:10:00',2.62),('12664','2013-10-18','15:15:00',2.79),('12664','2013-10-18','15:20:00',2.61),('12664','2013-10-18','15:25:00',2.61),('12664','2013-10-18','15:30:00',2.58),('12664','2013-10-18','15:35:00',2.39),('12664','2013-10-18','15:40:00',2.2),('12664','2013-10-18','15:45:00',2.22),('12664','2013-10-18','15:50:00',2.09),('12664','2013-10-18','15:55:00',2.12),('12664','2013-10-18','16:00:00',1.99),('12664','2013-10-18','16:05:00',1.92),('12664','2013-10-18','16:10:00',1.78),('12664','2013-10-18','16:15:00',1.69),('12664','2013-10-18','16:20:00',1.31),('12664','2013-10-18','16:25:00',1.23),('12664','2013-10-18','16:30:00',1.2),('12664','2014-05-03','07:50:00',1.05),('12664','2014-05-03','07:55:00',1.16),('12664','2014-05-03','08:00:00',1.31),('12664','2014-05-03','08:05:00',1.41),('12664','2014-05-03','08:10:00',1.52),('12664','2014-05-03','08:15:00',1.65),('12664','2014-05-03','08:20:00',1.86),('12664','2014-05-03','08:25:00',1.87),('12664','2014-05-03','08:30:00',2.04),('12664','2014-05-03','08:35:00',1.77),('12664','2014-05-03','08:40:00',1.83),('12664','2014-05-03','08:45:00',2),('12664','2014-05-03','08:50:00',2.13),('12664','2014-05-03','08:55:00',2.74),('12664','2014-05-03','09:00:00',2.26),('12664','2014-05-03','09:05:00',3.09),('12664','2014-05-03','09:10:00',2.03),('12664','2014-05-03','09:15:00',1.53),('12664','2014-05-03','09:20:00',3.27),('12664','2014-05-03','09:25:00',2.82),('12664','2014-05-03','09:30:00',3.03),('12664','2014-05-03','09:35:00',2.46),('12664','2014-05-03','09:40:00',2.97),('12664','2014-05-03','09:45:00',1.16),('12664','2014-05-03','09:50:00',1.22),('12664','2014-05-03','09:55:00',1.35),('12664','2014-05-03','10:00:00',1.51),('12664','2014-05-03','10:05:00',3.06),('12664','2014-05-03','10:10:00',2.05),('12664','2014-05-03','10:15:00',2.2),('12664','2014-05-03','10:20:00',1.23),('12664','2014-05-03','10:25:00',1.1),('12664','2014-05-03','10:30:00',1.04),('12664','2014-05-03','10:35:00',1.23),('12664','2014-05-03','10:40:00',2.21),('12664','2014-05-03','10:45:00',3.37),('12664','2014-05-03','10:55:00',1.23),('12664','2014-05-03','11:00:00',1.42),('12664','2014-05-03','11:05:00',2.45),('12664','2014-05-03','11:45:00',2.54),('12664','2014-05-03','11:50:00',2.69),('12664','2014-05-03','11:55:00',2.01),('12664','2014-05-03','12:00:00',2.63),('12664','2014-05-03','12:05:00',2.67),('12664','2014-05-03','12:10:00',2.17),('12664','2014-05-03','12:15:00',1.9),('12664','2014-05-03','12:20:00',1.99),('12664','2014-05-03','12:25:00',1.88),('12664','2014-05-03','12:30:00',1.44),('12664','2014-05-03','12:35:00',1.39),('12664','2014-05-03','12:40:00',1.7),('12664','2014-05-03','12:45:00',1.86),('12664','2014-05-03','12:50:00',1.92),('12664','2014-05-03','12:55:00',1.69),('12664','2014-05-03','13:00:00',2.19),('12664','2014-05-03','13:05:00',2.05),('12664','2014-05-03','13:10:00',2.05),('12664','2014-05-03','13:15:00',2.14),('12664','2014-05-03','13:20:00',2),('12664','2014-05-03','13:25:00',1.78),('12664','2014-05-03','13:30:00',1.54),('12664','2014-05-03','13:35:00',1.37),('12664','2014-05-03','13:40:00',1.08),('12664','2014-05-03','13:50:00',1.13),('12664','2014-05-03','13:55:00',1.46),('12664','2014-05-03','14:00:00',1.24),('12664','2014-05-03','14:05:00',1.1),('12664','2014-05-03','14:10:00',2.02),('12664','2014-05-03','14:15:00',2.85),('12664','2014-05-03','14:20:00',3.11),('12664','2014-05-03','14:25:00',3.28),('12664','2014-05-03','14:30:00',2.95),('12664','2014-05-03','14:35:00',2.58),('12664','2014-05-03','14:40:00',1.66),('12664','2014-05-03','17:20:00',1.04),('12664','2014-05-03','17:25:00',1.34),('12664','2014-05-03','17:30:00',1.51),('12664','2014-05-03','17:35:00',1.53),('12664','2014-05-03','17:40:00',1.21),('12664','2014-05-03','17:45:00',1.08),('12664','2014-05-03','17:50:00',1.02),('12664','2014-05-03','17:55:00',1.02),('12664','2014-05-03','18:00:00',1.09),('12664','2014-05-03','18:05:00',1.09),('12664','2014-05-03','18:15:00',1.03),('12664','2014-04-15','08:50:00',1.62),('12664','2014-04-15','08:55:00',1.47),('12664','2014-04-15','09:00:00',1.66),('12664','2014-04-15','09:05:00',1.7),('12664','2014-04-15','09:10:00',1.8),('12664','2014-04-15','09:15:00',1.61),('12664','2014-04-15','09:20:00',1.39),('12664','2014-04-15','09:25:00',1.02),('12664','2014-04-15','09:30:00',2.01),('12664','2014-04-15','09:35:00',1.2),('12664','2014-04-15','09:40:00',2.77),('12664','2014-04-15','09:45:00',2.79),('12664','2014-04-15','09:50:00',1.14),('12664','2014-04-15','10:00:00',2.3),('12664','2014-04-15','10:05:00',1.66),('12664','2014-04-15','10:10:00',3.83),('12664','2014-04-15','10:15:00',3.12),('12664','2014-04-15','10:20:00',1.99),('12664','2014-04-15','10:25:00',2.08),('12664','2014-04-15','10:30:00',3.65),('12664','2014-04-15','10:35:00',2.41),('12664','2014-04-15','10:40:00',2.83),('12664','2014-04-15','10:45:00',2.9),('12664','2014-04-15','10:50:00',1.88),('12664','2014-04-15','10:55:00',1.89),('12664','2014-04-15','11:00:00',2.26),('12664','2014-04-15','11:05:00',2.57),('12664','2014-04-15','11:10:00',2.18),('12664','2014-04-15','11:15:00',1.94),('12664','2014-04-15','11:25:00',1.4),('12664','2014-04-15','11:30:00',1.25),('12664','2014-04-15','11:35:00',1.15),('12664','2014-04-15','11:40:00',1.35),('12664','2014-04-15','11:45:00',1.38),('12664','2014-04-15','11:50:00',1.59),('12664','2014-04-15','11:55:00',2.04),('12664','2014-04-15','12:10:00',2.15),('12664','2014-04-15','12:15:00',3.07),('12664','2014-04-15','12:20:00',1.7),('12664','2014-04-15','12:25:00',1.04),('12664','2014-04-15','13:05:00',1.8),('12664','2014-04-15','13:10:00',1.39),('12664','2014-04-15','13:15:00',1.58),('12664','2014-04-15','13:40:00',1.21),('12664','2014-04-15','13:45:00',2.96),('12664','2014-04-15','13:50:00',3.92),('12664','2014-04-15','13:55:00',3.42),('12664','2014-04-15','14:00:00',3.67),('12664','2014-04-15','14:05:00',2.74),('12664','2014-04-15','14:10:00',2.13),('12664','2014-04-15','14:15:00',1.82),('12664','2014-04-15','14:20:00',2.12),('12664','2014-04-15','14:25:00',2.13),('12664','2014-04-15','14:30:00',2.08),('12664','2014-04-15','14:35:00',1.82),('12664','2014-04-15','14:40:00',3.38),('12664','2014-04-15','14:45:00',1.42),('12664','2014-04-15','14:50:00',2.12),('12664','2014-04-15','14:55:00',2.68),('12664','2014-04-15','15:00:00',1.49),('12664','2014-04-15','15:05:00',2.5),('12664','2014-04-15','15:10:00',4.5),('12664','2014-04-15','15:15:00',3.14),('12664','2014-04-15','15:20:00',3.45),('12664','2014-04-15','15:25:00',2.52),('12664','2014-04-15','15:30:00',2.28),('12664','2014-04-15','15:35:00',2.21),('12664','2014-04-15','15:40:00',1.81),('12664','2014-04-15','15:45:00',1.53),('12664','2014-04-15','15:50:00',1.31),('12664','2014-04-15','15:55:00',1.24),('12664','2014-04-15','16:00:00',1.36),('12664','2014-04-15','16:05:00',1.27),('12664','2014-04-15','16:10:00',1.11),('12664','2013-10-17','08:35:00',1.05),('12664','2013-10-17','08:40:00',1.14),('12664','2013-10-17','08:45:00',1.24),('12664','2013-10-17','08:50:00',1.34),('12664','2013-10-17','08:55:00',1.44),('12664','2013-10-17','09:00:00',1.55),('12664','2013-10-17','09:05:00',1.64),('12664','2013-10-17','09:10:00',1.73),('12664','2013-10-17','09:15:00',1.82),('12664','2013-10-17','09:20:00',1.91),('12664','2013-10-17','09:25:00',2),('12664','2013-10-17','09:30:00',2.09),('12664','2013-10-17','09:35:00',2.17),('12664','2013-10-17','09:40:00',2.25),('12664','2013-10-17','09:45:00',2.32),('12664','2013-10-17','09:50:00',2.4),('12664','2013-10-17','09:55:00',2.46),('12664','2013-10-17','10:00:00',2.54),('12664','2013-10-17','10:05:00',2.61),('12664','2013-10-17','10:10:00',2.68),('12664','2013-10-17','10:15:00',2.75),('12664','2013-10-17','10:20:00',2.81),('12664','2013-10-17','10:25:00',2.89),('12664','2013-10-17','10:30:00',2.96),('12664','2013-10-17','10:35:00',3.03),('12664','2013-10-17','10:40:00',3.09),('12664','2013-10-17','10:45:00',3.14),('12664','2013-10-17','10:50:00',3.17),('12664','2013-10-17','10:55:00',3.21),('12664','2013-10-17','11:00:00',3.25),('12664','2013-10-17','11:05:00',3.29),('12664','2013-10-17','11:10:00',3.32),('12664','2013-10-17','11:15:00',3.35),('12664','2013-10-17','11:20:00',3.37),('12664','2013-10-17','11:25:00',3.4),('12664','2013-10-17','11:30:00',3.44),('12664','2013-10-17','11:35:00',3.49),('12664','2013-10-17','11:40:00',3.52),('12664','2013-10-17','11:45:00',3.53),('12664','2013-10-17','11:50:00',3.57),('12664','2013-10-17','11:55:00',3.61),('12664','2013-10-17','12:00:00',3.62),('12664','2013-10-17','12:05:00',3.64),('12664','2013-10-17','12:10:00',3.67),('12664','2013-10-17','12:15:00',3.66),('12664','2013-10-17','12:20:00',3.67),('12664','2013-10-17','12:25:00',3.68),('12664','2013-10-17','12:30:00',3.68),('12664','2013-10-17','12:35:00',3.68),('12664','2013-10-17','12:40:00',3.7),('12664','2013-10-17','12:45:00',3.69),('12664','2013-10-17','12:50:00',3.68),('12664','2013-10-17','12:55:00',3.7),('12664','2013-10-17','13:00:00',3.7),('12664','2013-10-17','13:05:00',3.69),('12664','2013-10-17','13:10:00',3.69),('12664','2013-10-17','13:15:00',3.66),('12664','2013-10-17','13:20:00',3.65),('12664','2013-10-17','13:25:00',3.65),('12664','2013-10-17','13:30:00',3.64),('12664','2013-10-17','13:35:00',3.62),('12664','2013-10-17','13:40:00',3.59),('12664','2013-10-17','13:45:00',3.56),('12664','2013-10-17','13:50:00',3.53),('12664','2013-10-17','13:55:00',3.5),('12664','2013-10-17','14:00:00',3.5),('12664','2013-10-17','14:05:00',3.44),('12664','2013-10-17','14:10:00',3.38),('12664','2013-10-17','14:15:00',3.36),('12664','2013-10-17','14:20:00',3.32),('12664','2013-10-17','14:25:00',3.28),('12664','2013-10-17','14:30:00',3.25),('12664','2013-10-17','14:35:00',3.21),('12664','2013-10-17','14:40:00',3.18),('12664','2013-10-17','14:45:00',3.12),('12664','2013-10-17','14:50:00',3.07),('12664','2013-10-17','14:55:00',3.01),('12664','2013-10-17','15:00:00',2.97),('12664','2013-10-17','15:05:00',2.92),('12664','2013-10-17','15:10:00',2.88),('12664','2013-10-17','15:15:00',2.82),('12664','2013-10-17','15:20:00',2.76),('12664','2013-10-17','15:25:00',2.69),('12664','2013-10-17','15:30:00',2.63),('12664','2013-10-17','15:35:00',2.55),('12664','2013-10-17','15:40:00',2.47),('12664','2013-10-17','15:45:00',2.41),('12664','2013-10-17','15:50:00',2.33),('12664','2013-10-17','15:55:00',2.25),('12664','2013-10-17','16:00:00',2.18),('12664','2013-10-17','16:05:00',2.1),('12664','2013-10-17','16:10:00',2.01),('12664','2013-10-17','16:15:00',1.92),('12664','2013-10-17','16:20:00',1.85),('12664','2013-10-17','16:25:00',1.76),('12664','2013-10-17','16:30:00',1.67),('12664','2013-10-17','16:35:00',1.59),('12664','2013-10-17','16:40:00',1.51),('12664','2013-10-17','16:45:00',1.41),('12664','2013-10-17','16:50:00',1.32),('12664','2013-10-17','16:55:00',1.23),('12664','2013-10-17','17:00:00',1.07),('12664','2013-10-16','09:40:00',1.62),('12664','2013-10-16','09:55:00',1.06),('12664','2013-10-16','11:05:00',1.2),('12664','2013-10-16','11:40:00',1.17),('12664','2013-10-16','11:45:00',1.7),('12664','2013-10-16','12:00:00',1.69),('12664','2013-10-16','12:05:00',1.5),('12664','2013-10-16','12:10:00',1.64),('12664','2013-10-16','12:15:00',1.66),('12664','2013-10-16','12:25:00',1.37),('12664','2013-10-16','12:30:00',1.42),('12664','2013-10-16','12:40:00',1.12),('12664','2013-10-16','12:45:00',1.77),('12664','2013-10-16','12:50:00',1.28),('12664','2013-10-16','12:55:00',1.19),('12664','2013-10-16','13:00:00',1.31),('12664','2013-10-16','13:10:00',1.21),('12664','2013-10-16','13:15:00',2.94),('12664','2013-10-16','13:20:00',1.7),('12664','2013-10-16','13:25:00',1.73),('12664','2013-10-16','13:30:00',1.75),('12664','2013-10-16','13:35:00',1.31),('12664','2013-10-16','13:40:00',2.96),('12664','2013-10-16','13:45:00',3.7),('12664','2013-10-16','13:50:00',2.92),('12664','2013-10-16','13:55:00',1.17),('12664','2013-10-16','14:00:00',3.8),('12664','2013-10-16','14:05:00',2.49),('12664','2013-10-16','14:10:00',3.54),('12664','2013-10-16','14:15:00',3.49),('12664','2013-10-16','14:20:00',3.3),('12664','2013-10-16','14:25:00',2.71),('12664','2013-10-16','14:30:00',3.28),('12664','2013-10-16','14:35:00',3.06),('12664','2013-10-16','14:40:00',3.23),('12664','2013-10-16','14:45:00',2.36),('12664','2013-10-16','14:50:00',3.07),('12664','2013-10-16','14:55:00',3.08),('12664','2013-10-16','15:00:00',2.98),('12664','2013-10-16','15:05:00',2.66),('12664','2013-10-16','15:10:00',2.87),('12664','2013-10-16','15:15:00',2.65),('12664','2013-10-16','15:20:00',2.81),('12664','2013-10-16','15:25:00',2.75),('12664','2013-10-16','15:30:00',2.63),('12664','2013-10-16','15:35:00',2.54),('12664','2013-10-16','15:40:00',2.49),('12664','2013-10-16','15:45:00',2.42),('12664','2013-10-16','15:50:00',2.32),('12664','2013-10-16','15:55:00',2.12),('12664','2013-10-16','16:00:00',2.16),('12664','2013-10-16','16:05:00',2.09),('12664','2013-10-16','16:10:00',2),('12664','2013-10-16','16:15:00',1.88),('12664','2013-10-16','16:20:00',1.81),('12664','2013-10-16','16:25:00',1.73),('12664','2013-10-16','16:30:00',1.66),('12664','2013-10-16','16:35:00',1.56),('12664','2013-10-16','16:40:00',1.46),('12664','2013-10-16','16:45:00',1.37),('12664','2013-10-16','16:50:00',1.27),('12664','2013-10-16','16:55:00',1.18),('12664','2013-10-16','17:00:00',1.09),('12664','2013-10-15','09:20:00',1.02),('12664','2013-10-15','09:25:00',1.01),('12664','2013-10-15','09:30:00',1.05),('12664','2013-10-15','09:35:00',1.23),('12664','2013-10-15','09:40:00',2.02),('12664','2013-10-15','09:45:00',2.41),('12664','2013-10-15','09:50:00',2.31),('12664','2013-10-15','09:55:00',2.55),('12664','2013-10-15','10:00:00',2.35),('12664','2013-10-15','10:05:00',2.09),('12664','2013-10-15','10:10:00',1.25),('12664','2013-10-15','10:15:00',1.5),('12664','2013-10-15','10:20:00',2.31),('12664','2013-10-15','10:25:00',2.47),('12664','2013-10-15','10:30:00',2.25),('12664','2013-10-15','10:35:00',2.82),('12664','2013-10-15','10:40:00',2.57),('12664','2013-10-15','10:45:00',1.98),('12664','2013-10-15','10:50:00',1.88),('12664','2013-10-15','10:55:00',1.94),('12664','2013-10-15','11:00:00',2.32),('12664','2013-10-15','11:05:00',3.04),('12664','2013-10-15','11:10:00',2.92),('12664','2013-10-15','11:15:00',2.73),('12664','2013-10-15','11:20:00',2.52),('12664','2013-10-15','11:25:00',2.65),('12664','2013-10-15','11:30:00',2.13),('12664','2013-10-15','11:35:00',1.62),('12664','2013-10-15','11:40:00',1.64),('12664','2013-10-15','11:45:00',1.72),('12664','2013-10-15','11:50:00',1.64),('12664','2013-10-15','11:55:00',1.51),('12664','2013-10-15','12:00:00',1.46),('12664','2013-10-15','12:05:00',1.47),('12664','2013-10-15','12:10:00',1.44),('12664','2013-10-15','12:15:00',1.52),('12664','2013-10-15','12:20:00',1.38),('12664','2013-10-15','12:25:00',1.3),('12664','2013-10-15','12:30:00',1.34),('12664','2013-10-15','12:35:00',1.38),('12664','2013-10-15','12:40:00',1.47),('12664','2013-10-15','12:45:00',1.3),('12664','2013-10-15','12:50:00',1.23),('12664','2013-10-15','12:55:00',1.22),('12664','2013-10-15','13:00:00',1.59),('12664','2013-10-15','13:05:00',1.74),('12664','2013-10-15','13:10:00',2.03),('12664','2013-10-15','13:15:00',2.96),('12664','2013-10-15','13:20:00',2.96),('12664','2013-10-15','13:25:00',1.88),('12664','2013-10-15','13:30:00',1.72),('12664','2013-10-15','13:35:00',1.71),('12664','2013-10-15','13:40:00',1.65),('12664','2013-10-15','13:45:00',1.43),('12664','2013-10-15','13:50:00',1.23),('12664','2013-10-15','13:55:00',1.12),('12664','2013-10-15','14:00:00',1.15),('12664','2013-10-15','14:05:00',1.29),('12664','2013-10-15','14:10:00',1.87),('12664','2013-10-15','14:15:00',2.02),('12664','2013-10-15','14:20:00',2.71),('12664','2013-10-15','14:25:00',1.82),('12664','2013-10-15','14:30:00',1.65),('12664','2013-10-15','14:35:00',2.22),('12664','2013-10-15','14:40:00',2.6),('12664','2013-10-15','14:45:00',2.17),('12664','2013-10-15','14:50:00',2.09),('12664','2013-10-15','14:55:00',1.42),('12664','2013-10-15','15:00:00',1.6),('12664','2013-10-15','15:05:00',1.43),('12664','2013-10-15','15:10:00',1.24),('12664','2013-10-15','15:15:00',1.02),('12664','2013-10-15','15:30:00',1.03),('12664','2013-10-15','15:35:00',1.11),('12664','2013-10-15','15:40:00',1.04),('12664','2013-10-15','16:20:00',1.05),('12664','2013-10-15','16:25:00',1.22),('12664','2013-10-15','16:30:00',1.28),('12664','2013-10-14','08:40:00',1.06),('12664','2013-10-14','08:45:00',1.08),('12664','2013-10-14','08:50:00',1.23),('12664','2013-10-14','08:55:00',1.3),('12664','2013-10-14','09:00:00',1),('12664','2013-10-14','09:15:00',1.58),('12664','2013-10-14','09:20:00',2),('12664','2013-10-14','09:25:00',2.08),('12664','2013-10-14','09:30:00',1.83),('12664','2013-10-14','09:35:00',1.14),('12664','2013-10-14','09:40:00',1.88),('12664','2013-10-14','09:45:00',1.86),('12664','2013-10-14','09:50:00',2.2),('12664','2013-10-14','09:55:00',2.25),('12664','2013-10-14','10:00:00',2.45),('12664','2013-10-14','10:05:00',2.51),('12664','2013-10-14','10:10:00',2.56),('12664','2013-10-14','10:15:00',2.64),('12664','2013-10-14','10:20:00',2.7),('12664','2013-10-14','10:25:00',2.75),('12664','2013-10-14','10:30:00',2.78),('12664','2013-10-14','10:35:00',2.77),('12664','2013-10-14','10:40:00',2.83),('12664','2013-10-14','10:45:00',2.82),('12664','2013-10-14','10:50:00',2.96),('12664','2013-10-14','10:55:00',3.01),('12664','2013-10-14','11:00:00',3),('12664','2013-10-14','11:05:00',2.98),('12664','2013-10-14','11:10:00',3.13),('12664','2013-10-14','11:15:00',3.05),('12664','2013-10-14','11:20:00',3.2),('12664','2013-10-14','11:25:00',3.29),('12664','2013-10-14','11:30:00',3.27),('12664','2013-10-14','11:35:00',3.27),('12664','2013-10-14','11:40:00',3.23),('12664','2013-10-14','11:45:00',3.22),('12664','2013-10-14','11:50:00',3.3),('12664','2013-10-14','11:55:00',3.34),('12664','2013-10-14','12:00:00',3.37),('12664','2013-10-14','12:05:00',3.41),('12664','2013-10-14','12:10:00',3.39),('12664','2013-10-14','12:15:00',3.24),('12664','2013-10-14','12:20:00',3.35),('12664','2013-10-14','12:25:00',3.43),('12664','2013-10-14','12:30:00',3.47),('12664','2013-10-14','12:35:00',3.46),('12664','2013-10-14','12:40:00',3.45),('12664','2013-10-14','12:45:00',3.47),('12664','2013-10-14','12:50:00',3.48),('12664','2013-10-14','12:55:00',3.45),('12664','2013-10-14','13:00:00',3.45),('12664','2013-10-14','13:05:00',3.45),('12664','2013-10-14','13:10:00',3.42),('12664','2013-10-14','13:15:00',3.39),('12664','2013-10-14','13:20:00',3.4),('12664','2013-10-14','13:25:00',3.38),('12664','2013-10-14','13:30:00',3.36),('12664','2013-10-14','13:35:00',3.33),('12664','2013-10-14','13:40:00',3.32),('12664','2013-10-14','13:45:00',3.3),('12664','2013-10-14','13:50:00',3.28),('12664','2013-10-14','13:55:00',3.26),('12664','2013-10-14','14:00:00',3.22),('12664','2013-10-14','14:05:00',3.18),('12664','2013-10-14','14:10:00',3.16),('12664','2013-10-14','14:15:00',3.12),('12664','2013-10-14','14:20:00',3.1),('12664','2013-10-14','14:25:00',3.06),('12664','2013-10-14','14:30:00',3.02),('12664','2013-10-14','14:35:00',2.98),('12664','2013-10-14','14:40:00',2.93),('12664','2013-10-14','14:45:00',2.92),('12664','2013-10-14','14:50:00',2.88),('12664','2013-10-14','14:55:00',2.83),('12664','2013-10-14','15:00:00',2.78),('12664','2013-10-14','15:05:00',2.73),('12664','2013-10-14','15:10:00',2.68),('12664','2013-10-14','15:15:00',2.62),('12664','2013-10-14','15:20:00',2.55),('12664','2013-10-14','15:25:00',2.5),('12664','2013-10-14','15:30:00',2.41),('12664','2013-10-14','15:35:00',2.35),('12664','2013-10-14','15:40:00',2.24),('12664','2013-10-14','15:45:00',2.12),('12664','2013-10-14','15:50:00',1.62),('12664','2013-10-14','15:55:00',1.52),('12664','2013-10-14','16:00:00',1.14),('12664','2013-10-14','16:05:00',1.1),('12664','2013-10-14','16:10:00',1.05),('12664','2013-10-14','16:35:00',1.15),('12664','2013-10-14','16:40:00',1.41),('12664','2013-10-14','16:45:00',1.13),('12664','2013-10-13','08:50:00',1.05),('12664','2013-10-13','08:55:00',1.17),('12664','2013-10-13','09:00:00',1.14),('12664','2013-10-13','09:05:00',1.16),('12664','2013-10-13','09:10:00',1.62),('12664','2013-10-13','09:15:00',1.78),('12664','2013-10-13','09:20:00',1.76),('12664','2013-10-13','09:25:00',1.33),('12664','2013-10-13','09:30:00',1.56),('12664','2013-10-13','09:35:00',1.42),('12664','2013-10-13','09:40:00',1.8),('12664','2013-10-13','09:45:00',2.17),('12664','2013-10-13','09:50:00',2.55),('12664','2013-10-13','09:55:00',1.92),('12664','2013-10-13','10:00:00',1.87),('12664','2013-10-13','10:05:00',2.09),('12664','2013-10-13','10:10:00',1.82),('12664','2013-10-13','10:15:00',1.49),('12664','2013-10-13','10:20:00',1.45),('12664','2013-10-13','10:25:00',1.63),('12664','2013-10-13','10:30:00',2.98),('12664','2013-10-13','10:35:00',3.6),('12664','2013-10-13','10:40:00',2.91),('12664','2013-10-13','10:45:00',2.97),('12664','2013-10-13','10:50:00',2.16),('12664','2013-10-13','10:55:00',1.98),('12664','2013-10-13','11:00:00',2.13),('12664','2013-10-13','11:05:00',2.25),('12664','2013-10-13','11:10:00',2.94),('12664','2013-10-13','11:15:00',2.9),('12664','2013-10-13','11:20:00',2.96),('12664','2013-10-13','11:25:00',3.15),('12664','2013-10-13','11:30:00',2.85),('12664','2013-10-13','11:35:00',3.4),('12664','2013-10-13','11:40:00',3.34),('12664','2013-10-13','11:45:00',3.24),('12664','2013-10-13','11:50:00',3.29),('12664','2013-10-13','11:55:00',3.44),('12664','2013-10-13','12:00:00',3.49),('12664','2013-10-13','12:05:00',3.5),('12664','2013-10-13','12:10:00',3.49),('12664','2013-10-13','12:15:00',3.51),('12664','2013-10-13','12:20:00',3.51),('12664','2013-10-13','12:25:00',3.31),('12664','2013-10-13','12:30:00',3.49),('12664','2013-10-13','12:35:00',3.57),('12664','2013-10-13','12:40:00',3.51),('12664','2013-10-13','12:45:00',3.5),('12664','2013-10-13','12:50:00',3.51),('12664','2013-10-13','12:55:00',3.15),('12664','2013-10-13','13:00:00',3.49),('12664','2013-10-13','13:05:00',3.54),('12664','2013-10-13','13:10:00',3.58),('12664','2013-10-13','13:15:00',3.56),('12664','2013-10-13','13:20:00',3.39),('12664','2013-10-13','13:25:00',3.34),('12664','2013-10-13','13:30:00',3.56),('12664','2013-10-13','13:35:00',3.53),('12664','2013-10-13','13:40:00',3.56),('12664','2013-10-13','13:45:00',3.33),('12664','2013-10-13','13:50:00',3.48),('12664','2013-10-13','13:55:00',3.35),('12664','2013-10-13','14:00:00',2.57),('12664','2013-10-13','14:05:00',3.72),('12664','2013-10-13','14:10:00',3.12),('12664','2013-10-13','14:15:00',3.63),('12664','2013-10-13','14:20:00',3.51),('12664','2013-10-13','14:25:00',3.27),('12664','2013-10-13','14:30:00',2.88),('12664','2013-10-13','14:35:00',2.05),('12664','2013-10-13','14:40:00',2.57),('12664','2013-10-13','14:45:00',2.88),('12664','2013-10-13','14:50:00',2.64),('12664','2013-10-13','14:55:00',2.52),('12664','2013-10-13','15:00:00',2.64),('12664','2013-10-13','15:05:00',2.84),('12664','2013-10-13','15:10:00',2.77),('12664','2013-10-13','15:15:00',2.72),('12664','2013-10-13','15:20:00',2.31),('12664','2013-10-13','15:25:00',2.13),('12664','2013-10-13','15:30:00',1.9),('12664','2013-10-13','15:35:00',1.58),('12664','2013-10-13','15:40:00',1.4),('12664','2013-10-13','15:45:00',1.8),('12664','2013-10-13','15:50:00',1.78),('12664','2013-10-13','15:55:00',2.02),('12664','2013-10-13','16:00:00',2.06),('12664','2013-10-13','16:05:00',2.24),('12664','2013-10-13','16:10:00',2.08),('12664','2013-10-13','16:15:00',1.98),('12664','2013-10-13','16:20:00',1.85),('12664','2013-10-13','16:25:00',1.51),('12664','2013-10-13','16:30:00',1.29),('12664','2013-10-13','16:35:00',1.48),('12664','2013-10-13','16:40:00',1.06),('12664','2013-10-12','11:15:00',1.03),('12664','2013-10-12','11:20:00',1.28),('12664','2013-10-12','11:25:00',1.33),('12664','2013-10-12','11:30:00',1.83),('12664','2013-10-12','11:35:00',1.74),('12664','2013-10-12','11:40:00',1.46),('12664','2013-10-12','11:45:00',1.23),('12664','2013-10-12','12:10:00',1.17),('12664','2013-10-12','12:15:00',1.7),('12664','2013-10-12','12:20:00',3.6),('12664','2013-10-12','12:25:00',3.21),('12664','2013-10-12','12:30:00',2.92),('12664','2013-10-12','12:35:00',3.66),('12664','2013-10-12','12:40:00',3.59),('12664','2013-10-12','12:45:00',3.55),('12664','2013-10-12','12:50:00',3.11),('12664','2013-10-12','12:55:00',3.07),('12664','2013-10-12','13:00:00',2.21),('12664','2013-10-12','13:15:00',1.17),('12664','2013-10-12','13:20:00',1.38),('12664','2013-10-12','13:25:00',1.39),('12664','2013-10-12','16:15:00',1.16),('12664','2013-10-12','16:20:00',1.57),('12664','2013-10-12','16:25:00',1.38),('12664','2013-10-12','16:30:00',1.19),('12664','2013-10-12','16:35:00',1.55),('12664','2013-10-12','16:40:00',1.36),('12664','2013-10-11','08:30:00',1.04),('12664','2013-10-11','08:35:00',1.22),('12664','2013-10-11','08:40:00',1.36),('12664','2013-10-11','08:45:00',1.1),('12664','2013-10-11','08:50:00',1.39),('12664','2013-10-11','08:55:00',1.49),('12664','2013-10-11','09:00:00',1.58),('12664','2013-10-11','09:05:00',1.65),('12664','2013-10-11','09:10:00',1.73),('12664','2013-10-11','09:15:00',1.83),('12664','2013-10-11','09:20:00',1.97),('12664','2013-10-11','09:25:00',2.18),('12664','2013-10-11','09:30:00',2.2),('12664','2013-10-11','09:35:00',2.32),('12664','2013-10-11','09:40:00',2.36),('12664','2013-10-11','09:45:00',2.4),('12664','2013-10-11','09:50:00',2.48),('12664','2013-10-11','09:55:00',2.57),('12664','2013-10-11','10:00:00',2.66),('12664','2013-10-11','10:05:00',2.43),('12664','2013-10-11','10:10:00',2.11),('12664','2013-10-11','10:15:00',2.19),('12664','2013-10-11','10:20:00',1.05),('12664','2013-10-11','10:25:00',1.92),('12664','2013-10-11','10:30:00',2.72),('12664','2013-10-11','10:35:00',1.77),('12664','2013-10-11','10:40:00',1.15),('12664','2013-10-11','10:45:00',1.63),('12664','2013-10-11','10:50:00',2.28),('12664','2013-10-11','10:55:00',1.5),('12664','2013-10-11','11:00:00',3.98),('12664','2013-10-11','11:05:00',2.22),('12664','2013-10-11','11:10:00',1.34),('12664','2013-10-11','11:15:00',1.45),('12664','2013-10-11','11:20:00',1.27),('12664','2013-10-11','11:25:00',1.11),('12664','2013-10-11','11:30:00',1.12),('12664','2013-10-11','11:35:00',1.29),('12664','2013-10-11','11:40:00',1.24),('12664','2013-10-11','11:45:00',1.05),('12664','2013-10-11','12:05:00',2.59),('12664','2013-10-11','12:10:00',4.15),('12664','2013-10-11','12:15:00',4.71),('12664','2013-10-11','12:20:00',2.97),('12664','2013-10-11','12:25:00',1.73),('12664','2013-10-11','12:35:00',1.52),('12664','2013-10-11','12:40:00',2.14),('12664','2013-10-11','12:45:00',2.65),('12664','2013-10-11','12:50:00',3.33),('12664','2013-10-11','12:55:00',3.39),('12664','2013-10-11','13:00:00',2.53),('12664','2013-10-11','13:05:00',2.37),('12664','2013-10-11','13:10:00',1.18),('12664','2013-10-11','13:15:00',1.94),('12664','2013-10-11','13:20:00',2.03),('12664','2013-10-11','13:25:00',1.9),('12664','2013-10-11','13:30:00',1.95),('12664','2013-10-11','13:35:00',1.54),('12664','2013-10-11','14:35:00',1.19),('12664','2013-10-11','14:40:00',2.41),('12664','2013-10-11','14:45:00',1.38),('12664','2013-10-11','16:55:00',1.21),('12664','2013-10-10','08:30:00',1.02),('12664','2013-10-10','08:35:00',1.12),('12664','2013-10-10','08:40:00',1.3),('12664','2013-10-10','08:45:00',1.4),('12664','2013-10-10','08:50:00',1.47),('12664','2013-10-10','08:55:00',1.6),('12664','2013-10-10','09:00:00',1.74),('12664','2013-10-10','09:05:00',1.87),('12664','2013-10-10','09:10:00',1.84),('12664','2013-10-10','09:15:00',1.9),('12664','2013-10-10','09:20:00',1.97),('12664','2013-10-10','09:25:00',2.04),('12664','2013-10-10','09:30:00',2.13),('12664','2013-10-10','09:35:00',2.22),('12664','2013-10-10','09:40:00',2.25),('12664','2013-10-10','09:45:00',2.36),('12664','2013-10-10','09:50:00',2.42),('12664','2013-10-10','09:55:00',2.46),('12664','2013-10-10','10:00:00',2.56),('12664','2013-10-10','10:05:00',2.64),('12664','2013-10-10','10:10:00',2.57),('12664','2013-10-10','10:15:00',2.87),('12664','2013-10-10','10:20:00',1.43),('12664','2013-10-10','10:25:00',3),('12664','2013-10-10','10:30:00',2.89),('12664','2013-10-10','10:35:00',2.61),('12664','2013-10-10','10:40:00',2.27),('12664','2013-10-10','10:45:00',2.22),('12664','2013-10-10','10:50:00',3.51),('12664','2013-10-10','10:55:00',1.07),('12664','2013-10-10','11:00:00',1.56),('12664','2013-10-10','11:05:00',2.33),('12664','2013-10-10','11:30:00',1.28),('12664','2013-10-10','11:35:00',1.34),('12664','2013-10-10','11:40:00',3.06),('12664','2013-10-10','11:45:00',2.63),('12664','2013-10-10','11:50:00',2.53),('12664','2013-10-10','11:55:00',1.23),('12664','2013-10-10','12:00:00',2.78),('12664','2013-10-10','12:05:00',4.73),('12664','2013-10-10','12:10:00',4.45),('12664','2013-10-10','12:15:00',4.24),('12664','2013-10-10','12:20:00',4.36),('12664','2013-10-10','12:30:00',1.22),('12664','2013-10-10','12:35:00',2.03),('12664','2013-10-10','12:40:00',3.24),('12664','2013-10-10','12:45:00',3.37),('12664','2013-10-10','12:50:00',4.13),('12664','2013-10-10','12:55:00',3.95),('12664','2013-10-10','13:00:00',3.81),('12664','2013-10-10','13:05:00',4.3),('12664','2013-10-10','13:10:00',4.17),('12664','2013-10-10','13:15:00',3.75),('12664','2013-10-10','13:20:00',3.54),('12664','2013-10-10','13:25:00',3.93),('12664','2013-10-10','13:30:00',1.61),('12664','2013-10-10','13:35:00',4.15),('12664','2013-10-10','13:40:00',4.34),('12664','2013-10-10','13:45:00',4.23),('12664','2013-10-10','13:50:00',3.59),('12664','2013-10-10','13:55:00',3.69),('12664','2013-10-10','14:00:00',2.26),('12664','2013-10-10','14:05:00',4.3),('12664','2013-10-10','14:10:00',2.88),('12664','2013-10-10','14:15:00',2.29),('12664','2013-10-10','14:20:00',2.07),('12664','2013-10-10','14:25:00',3.29),('12664','2013-10-10','14:30:00',3.12),('12664','2013-10-10','14:35:00',2.26),('12664','2013-10-10','14:40:00',2.5),('12664','2013-10-10','14:45:00',3.72),('12664','2013-10-10','14:50:00',3.53),('12664','2013-10-10','14:55:00',3.58),('12664','2013-10-10','15:00:00',3.51),('12664','2013-10-10','15:05:00',3.43),('12664','2013-10-10','15:10:00',3.4),('12664','2013-10-10','15:15:00',3.48),('12664','2013-10-10','15:20:00',3.03),('12664','2013-10-10','15:25:00',2.03),('12664','2013-10-10','15:30:00',3.38),('12664','2013-10-10','15:35:00',2.8),('12664','2013-10-10','15:40:00',1.01),('12664','2013-10-10','15:45:00',1.3),('12664','2013-10-10','15:50:00',2.27),('12664','2013-10-10','15:55:00',2.51),('12664','2013-10-10','16:05:00',1.67),('12664','2013-10-10','16:15:00',2.5),('12664','2013-10-10','16:20:00',2.19),('12664','2013-10-10','16:25:00',1.63),('12664','2013-10-10','16:30:00',1.61),('12664','2013-10-10','16:35:00',1.26),('12664','2013-10-10','16:45:00',1.7),('12664','2013-10-10','16:50:00',1.64),('12664','2013-10-10','16:55:00',1.42),('12664','2013-10-10','17:00:00',1.3),('12664','2013-10-10','17:10:00',1.14),('12664','2013-10-09','08:35:00',1.24),('12664','2013-10-09','08:40:00',1.3),('12664','2013-10-09','08:45:00',1.4),('12664','2013-10-09','08:50:00',1.48),('12664','2013-10-09','08:55:00',1.59),('12664','2013-10-09','09:00:00',1.69),('12664','2013-10-09','09:05:00',1.81),('12664','2013-10-09','09:10:00',1.92),('12664','2013-10-09','09:15:00',1.73),('12664','2013-10-09','09:20:00',2.17),('12664','2013-10-09','09:25:00',2.32),('12664','2013-10-09','09:30:00',1.79),('12664','2013-10-09','09:35:00',2.38),('12664','2013-10-09','09:40:00',2.68),('12664','2013-10-09','09:45:00',2.98),('12664','2013-10-09','09:50:00',2.99),('12664','2013-10-09','09:55:00',3.14),('12664','2013-10-09','10:00:00',2.18),('12664','2013-10-09','10:05:00',1.43),('12664','2013-10-09','10:10:00',1.34),('12664','2013-10-09','10:15:00',2.91),('12664','2013-10-09','10:20:00',3.09),('12664','2013-10-09','10:25:00',3.17),('12664','2013-10-09','10:30:00',2.9),('12664','2013-10-09','10:35:00',3.19),('12664','2013-10-09','10:40:00',1.02),('12664','2013-10-09','10:45:00',3.48),('12664','2013-10-09','10:50:00',2.18),('12664','2013-10-09','10:55:00',2.78),('12664','2013-10-09','11:00:00',2.49),('12664','2013-10-09','11:35:00',1.34),('12664','2013-10-09','11:40:00',1.35),('12664','2013-10-09','11:45:00',1.09),('12664','2013-10-09','12:20:00',2.83),('12664','2013-10-09','12:25:00',4.02),('12664','2013-10-09','12:30:00',4.39),('12664','2013-10-09','12:35:00',2.3),('12664','2013-10-09','12:40:00',1.71),('12664','2013-10-09','13:00:00',2.16),('12664','2013-10-09','13:05:00',3.26),('12664','2013-10-09','13:10:00',3.96),('12664','2013-10-09','13:15:00',3.86),('12664','2013-10-09','13:20:00',3.63),('12664','2013-10-09','13:25:00',3.71),('12664','2013-10-09','13:30:00',4),('12664','2013-10-09','13:35:00',4.05),('12664','2013-10-09','13:40:00',4.01),('12664','2013-10-09','13:45:00',4.03),('12664','2013-10-09','13:50:00',2.96),('12664','2013-10-09','13:55:00',2.9),('12664','2013-10-09','14:00:00',3.44),('12664','2013-10-09','14:05:00',2.36),('12664','2013-10-09','14:10:00',3.57),('12664','2013-10-09','14:15:00',3.34),('12664','2013-10-09','14:20:00',3.32),('12664','2013-10-09','14:25:00',2.1),('12664','2013-10-09','14:30:00',4.16),('12664','2013-10-09','14:35:00',3.76),('12664','2013-10-09','14:40:00',3.51),('12664','2013-10-09','14:45:00',3.23),('12664','2013-10-09','14:50:00',2.65),('12664','2013-10-09','14:55:00',3.11),('12664','2013-10-09','15:00:00',3.45),('12664','2013-10-09','15:05:00',1.97),('12664','2013-10-09','15:10:00',2.03),('12664','2013-10-09','15:15:00',1.39),('12664','2013-10-09','15:20:00',2.66),('12664','2013-10-09','15:25:00',2.36),('12664','2013-10-09','15:40:00',1.61),('12664','2013-10-09','15:45:00',1.35),('12664','2013-10-09','15:50:00',1.17),('12664','2013-10-09','15:55:00',1.59),('12664','2013-10-09','16:10:00',1.93),('12664','2013-10-09','16:15:00',2.75),('12664','2013-10-09','16:20:00',1.8),('12664','2013-10-09','16:35:00',1.41),('12664','2013-10-09','16:40:00',1.65),('12664','2013-10-09','16:45:00',1.28),('12664','2013-10-09','16:50:00',1.74),('12664','2013-10-08','08:10:00',1.04),('12664','2013-10-08','09:20:00',1.66),('12664','2013-10-08','09:45:00',2.33),('12664','2013-10-08','09:50:00',2.64),('12664','2013-10-08','09:55:00',3.18),('12664','2013-10-08','10:00:00',3.19),('12664','2013-10-08','10:05:00',1.86),('12664','2013-10-08','10:50:00',1.04),('12664','2013-10-08','10:55:00',1.09),('12664','2013-10-08','11:00:00',1.02),('12664','2013-10-08','12:35:00',1.76),('12664','2013-10-08','12:40:00',1.26),('12664','2013-10-08','12:50:00',1.22),('12664','2013-10-08','12:55:00',1.53),('12664','2013-10-08','13:00:00',1.24),('12664','2013-10-08','13:05:00',1.93),('12664','2013-10-08','13:10:00',4.44),('12664','2013-10-08','13:15:00',1.91),('12664','2013-10-08','13:20:00',2.19),('12664','2013-10-08','13:25:00',1.96),('12664','2013-10-08','13:30:00',1.22),('12664','2013-10-08','13:45:00',1.37),('12664','2013-10-08','13:50:00',1.23),('12664','2013-10-08','13:55:00',1.09),('12664','2013-10-08','14:25:00',1.3),('12664','2013-10-08','14:30:00',2.15),('12664','2013-10-08','14:35:00',3.75),('12664','2013-10-08','14:40:00',3.56),('12664','2013-10-08','14:45:00',3.41),('12664','2013-10-08','14:50:00',3.42),('12664','2013-10-08','14:55:00',3.32),('12664','2013-10-08','15:00:00',3.25),('12664','2013-10-08','15:05:00',3.01),('12664','2013-10-08','15:10:00',1.8),('12664','2013-10-08','15:15:00',1.35),('12664','2014-04-14','08:10:00',1.08),('12664','2014-04-14','08:15:00',1.17),('12664','2014-04-14','08:20:00',1.26),('12664','2014-04-14','08:25:00',1.36),('12664','2014-04-14','08:30:00',1.46),('12664','2014-04-14','08:35:00',1.56),('12664','2014-04-14','08:40:00',1.66),('12664','2014-04-14','08:45:00',1.75),('12664','2014-04-14','08:50:00',1.84),('12664','2014-04-14','08:55:00',1.93),('12664','2014-04-14','09:00:00',2.02),('12664','2014-04-14','09:05:00',2.1),('12664','2014-04-14','09:10:00',2.19),('12664','2014-04-14','09:15:00',2.27),('12664','2014-04-14','09:20:00',2.36),('12664','2014-04-14','09:25:00',2.44),('12664','2014-04-14','09:30:00',2.52),('12664','2014-04-14','09:35:00',2.6),('12664','2014-04-14','09:40:00',2.67),('12664','2014-04-14','09:45:00',2.73),('12664','2014-04-14','09:50:00',2.81),('12664','2014-04-14','09:55:00',2.88),('12664','2014-04-14','10:00:00',2.94),('12664','2014-04-14','10:05:00',3.01),('12664','2014-04-14','10:10:00',3.07),('12664','2014-04-14','10:15:00',3.14),('12664','2014-04-14','10:20:00',3.2),('12664','2014-04-14','10:25:00',3.26),('12664','2014-04-14','10:30:00',3.3),('12664','2014-04-14','10:35:00',3.36),('12664','2014-04-14','10:40:00',3.43),('12664','2014-04-14','10:45:00',3.48),('12664','2014-04-14','10:50:00',3.53),('12664','2014-04-14','10:55:00',3.58),('12664','2014-04-14','11:00:00',3.62),('12664','2014-04-14','11:05:00',3.66),('12664','2014-04-14','11:10:00',3.72),('12664','2014-04-14','11:15:00',3.76),('12664','2014-04-14','11:20:00',3.79),('12664','2014-04-14','11:25:00',3.81),('12664','2014-04-14','11:30:00',3.84),('12664','2014-04-14','11:35:00',3.88),('12664','2014-04-14','11:40:00',3.88),('12664','2014-04-14','11:45:00',3.92),('12664','2014-04-14','11:50:00',3.97),('12664','2014-04-14','11:55:00',4),('12664','2014-04-14','12:00:00',3.99),('12664','2014-04-14','12:05:00',4.02),('12664','2014-04-14','12:10:00',4.04),('12664','2014-04-14','12:15:00',4.04),('12664','2014-04-14','12:20:00',4.04),('12664','2014-04-14','12:25:00',4.06),('12664','2014-04-14','12:30:00',4.08),('12664','2014-04-14','12:35:00',4.12),('12664','2014-04-14','12:40:00',4.13),('12664','2014-04-14','12:45:00',4.17),('12664','2014-04-14','12:50:00',4.19),('12664','2014-04-14','12:55:00',4.21),('12664','2014-04-14','13:00:00',4.21),('12664','2014-04-14','13:05:00',4.2),('12664','2014-04-14','13:10:00',4.2),('12664','2014-04-14','13:15:00',4.2),('12664','2014-04-14','13:20:00',4.2),('12664','2014-04-14','13:25:00',4.21),('12664','2014-04-14','13:30:00',4.2),('12664','2014-04-14','13:35:00',4.18),('12664','2014-04-14','13:40:00',4.18),('12664','2014-04-14','13:45:00',4.17),('12664','2014-04-14','13:50:00',4.17),('12664','2014-04-14','13:55:00',4.15),('12664','2014-04-14','14:00:00',4.12),('12664','2014-04-14','14:05:00',4.11),('12664','2014-04-14','14:10:00',4.1),('12664','2014-04-14','14:15:00',4.06),('12664','2014-04-14','14:20:00',4.03),('12664','2014-04-14','14:25:00',4),('12664','2014-04-14','14:30:00',3.96),('12664','2014-04-14','14:35:00',3.95),('12664','2014-04-14','14:40:00',3.92),('12664','2014-04-14','14:45:00',3.9),('12664','2014-04-14','14:50:00',3.85),('12664','2014-04-14','14:55:00',3.78),('12664','2014-04-14','15:00:00',3.75),('12664','2014-04-14','15:05:00',3.73),('12664','2014-04-14','15:10:00',3.68),('12664','2014-04-14','15:15:00',3.64),('12664','2014-04-14','15:20:00',3.61),('12664','2014-04-14','15:25:00',3.55),('12664','2014-04-14','15:30:00',3.49),('12664','2014-04-14','15:35:00',3.43),('12664','2014-04-14','15:40:00',3.36),('12664','2014-04-14','15:45:00',3.31),('12664','2014-04-14','15:50:00',3.24),('12664','2014-04-14','15:55:00',3.18),('12664','2014-04-14','16:00:00',3.11),('12664','2014-04-14','16:05:00',3.03),('12664','2014-04-14','16:10:00',2.96),('12664','2014-04-14','16:15:00',2.9),('12664','2014-04-14','16:20:00',2.82),('12664','2014-04-14','16:25:00',2.75),('12664','2014-04-14','16:30:00',2.68),('12664','2014-04-14','16:35:00',2.59),('12664','2014-04-14','16:40:00',2.51),('12664','2014-04-14','16:45:00',2.42),('12664','2014-04-14','16:50:00',2.35),('12664','2014-04-14','16:55:00',2.27),('12664','2014-04-14','17:00:00',2.17),('12664','2014-04-14','17:05:00',2.1),('12664','2014-04-14','17:10:00',2),('12664','2014-04-14','17:15:00',1.9),('12664','2014-04-14','17:20:00',1.81),('12664','2014-04-14','17:25:00',1.72),('12664','2014-04-14','17:30:00',1.61),('12664','2014-04-14','17:35:00',1.51),('12664','2014-04-14','17:40:00',1.42),('12664','2014-04-14','17:45:00',1.33),('12664','2014-04-14','17:50:00',1.22),('12664','2014-04-14','17:55:00',1.14),('12664','2014-04-14','18:00:00',1.04),('12664','2013-10-07','08:30:00',1.06),('12664','2013-10-07','08:35:00',1.16),('12664','2013-10-07','08:40:00',1.23),('12664','2013-10-07','08:45:00',1.36),('12664','2013-10-07','08:50:00',1.46),('12664','2013-10-07','08:55:00',1.57),('12664','2013-10-07','09:00:00',1.53),('12664','2013-10-07','09:20:00',1.88),('12664','2013-10-07','09:25:00',2.23),('12664','2013-10-07','09:30:00',2.31),('12664','2013-10-07','09:35:00',2.27),('12664','2013-10-07','09:40:00',2.46),('12664','2013-10-07','09:45:00',2.76),('12664','2013-10-07','09:50:00',2.74),('12664','2013-10-07','09:55:00',2.65),('12664','2013-10-07','10:00:00',2.61),('12664','2013-10-07','10:05:00',2.68),('12664','2013-10-07','10:10:00',2.75),('12664','2013-10-07','10:15:00',2.79),('12664','2013-10-07','10:20:00',2.83),('12664','2013-10-07','10:25:00',2.9),('12664','2013-10-07','10:30:00',2.96),('12664','2013-10-07','10:35:00',3.01),('12664','2013-10-07','10:40:00',3.08),('12664','2013-10-07','10:45:00',3.13),('12664','2013-10-07','10:50:00',3.18),('12664','2013-10-07','10:55:00',3.23),('12664','2013-10-07','11:00:00',3.26),('12664','2013-10-07','11:05:00',3.3),('12664','2013-10-07','11:10:00',3.35),('12664','2013-10-07','11:15:00',3.32),('12664','2013-10-07','11:20:00',3.45),('12664','2013-10-07','11:25:00',3.47),('12664','2013-10-07','11:30:00',3.52),('12664','2013-10-07','11:35:00',3.63),('12664','2013-10-07','11:40:00',3.79),('12664','2013-10-07','11:45:00',3.84),('12664','2013-10-07','11:50:00',3.85),('12664','2013-10-07','11:55:00',3.8),('12664','2013-10-07','12:00:00',3.07),('12664','2013-10-07','12:05:00',2.75),('12664','2013-10-07','12:10:00',4.07),('12664','2013-10-07','12:15:00',4.23),('12664','2013-10-07','12:20:00',3.62),('12664','2013-10-07','12:25:00',2.1),('12664','2013-10-07','12:30:00',2.58),('12664','2013-10-07','12:35:00',2.64),('12664','2013-10-07','12:40:00',1.71),('12664','2013-10-07','12:45:00',1.72),('12664','2013-10-07','12:55:00',3.24),('12664','2013-10-07','13:00:00',3.48),('12664','2013-10-07','13:05:00',4.53),('12664','2013-10-07','13:10:00',4.23),('12664','2013-10-07','13:15:00',3.61),('12664','2013-10-07','13:20:00',1.71),('12664','2013-10-07','13:25:00',2.19),('12664','2013-10-07','13:30:00',1.41),('12664','2013-10-07','13:35:00',2.56),('12664','2013-10-07','13:40:00',1.14),('12664','2013-10-07','13:50:00',1.94),('12664','2013-10-07','13:55:00',4.74),('12664','2013-10-07','14:00:00',3.16),('12664','2013-10-07','14:05:00',3.22),('12664','2013-10-07','14:10:00',1.73),('12664','2013-10-07','14:15:00',3.23),('12664','2013-10-07','14:20:00',3.19),('12664','2013-10-07','14:25:00',2.75),('12664','2013-10-07','14:30:00',2.39),('12664','2013-10-07','14:35:00',3.2),('12664','2013-10-07','14:40:00',2.53),('12664','2013-10-07','14:45:00',1.29),('12664','2013-10-07','14:50:00',3.52),('12664','2013-10-07','14:55:00',3.66),('12664','2013-10-07','15:00:00',3.49),('12664','2013-10-07','15:05:00',3.55),('12664','2013-10-07','15:10:00',3.54),('12664','2013-10-07','15:15:00',3.16),('12664','2013-10-07','15:20:00',2.06),('12664','2013-10-07','15:25:00',2.44),('12664','2013-10-07','15:30:00',2.92),('12664','2013-10-07','15:35:00',2.73),('12664','2013-10-07','15:40:00',2.32),('12664','2013-10-07','15:45:00',2.84),('12664','2013-10-07','15:50:00',2.74),('12664','2013-10-07','15:55:00',2.62),('12664','2013-10-07','16:00:00',2.5),('12664','2013-10-07','16:05:00',2.42),('12664','2013-10-07','16:10:00',2.31),('12664','2013-10-07','16:15:00',2.12),('12664','2013-10-07','16:20:00',2.14),('12664','2013-10-07','16:25:00',2.03),('12664','2013-10-07','16:30:00',1.92),('12664','2013-10-07','16:35:00',1.83),('12664','2013-10-07','16:40:00',1.73),('12664','2013-10-07','16:45:00',1.64),('12664','2013-10-07','16:50:00',1.55),('12664','2013-10-07','16:55:00',1.46),('12664','2013-10-07','17:00:00',1.36),('12664','2013-10-07','17:05:00',1.27),('12664','2013-10-07','17:10:00',1.16),('12664','2013-10-07','17:15:00',1.06),('12664','2013-10-06','09:05:00',1.41),('12664','2013-10-06','09:20:00',1.17),('12664','2013-10-06','09:25:00',1.88),('12664','2013-10-06','09:30:00',2.42),('12664','2013-10-06','09:35:00',2.44),('12664','2013-10-06','09:40:00',2.12),('12664','2013-10-06','09:45:00',2.1),('12664','2013-10-06','09:50:00',2.5),('12664','2013-10-06','09:55:00',2.63),('12664','2013-10-06','10:00:00',2.51),('12664','2013-10-06','10:05:00',2.27),('12664','2013-10-06','10:10:00',2.26),('12664','2013-10-06','10:15:00',2.26),('12664','2013-10-06','10:20:00',2.53),('12664','2013-10-06','10:25:00',2.46),('12664','2013-10-06','10:30:00',2.4),('12664','2013-10-06','10:35:00',2.47),('12664','2013-10-06','10:40:00',1.74),('12664','2013-10-06','10:45:00',2.37),('12664','2013-10-06','10:50:00',2.58),('12664','2013-10-06','10:55:00',3.03),('12664','2013-10-06','11:00:00',3.18),('12664','2013-10-06','11:05:00',2.84),('12664','2013-10-06','11:10:00',3.17),('12664','2013-10-06','11:15:00',2.93),('12664','2013-10-06','11:20:00',2.97),('12664','2013-10-06','11:25:00',2.79),('12664','2013-10-06','11:30:00',1.54),('12664','2013-10-06','11:35:00',1.44),('12664','2013-10-06','11:40:00',2.32),('12664','2013-10-06','11:45:00',2.66),('12664','2013-10-06','11:50:00',2.92),('12664','2013-10-06','11:55:00',2.86),('12664','2013-10-06','12:00:00',3.36),('12664','2013-10-06','12:05:00',3.56),('12664','2013-10-06','12:10:00',3.44),('12664','2013-10-06','12:15:00',3.17),('12664','2013-10-06','12:20:00',2.57),('12664','2013-10-06','12:25:00',3.29),('12664','2013-10-06','12:30:00',2.99),('12664','2013-10-06','12:35:00',3.29),('12664','2013-10-06','12:40:00',3.32),('12664','2013-10-06','12:45:00',3.47),('12664','2013-10-06','12:50:00',1.5),('12664','2013-10-06','12:55:00',3.23),('12664','2013-10-06','13:00:00',3.87),('12664','2013-10-06','13:05:00',3.82),('12664','2013-10-06','13:10:00',2.9),('12664','2013-10-06','13:15:00',2.17),('12664','2013-10-06','13:20:00',1.53),('12664','2013-10-06','13:25:00',1.43),('12664','2013-10-06','13:50:00',1.18),('12664','2013-10-06','13:55:00',2.29),('12664','2013-10-06','14:00:00',1.22),('12664','2013-10-06','14:05:00',1.29),('12664','2013-10-06','14:10:00',1.01),('12664','2013-10-06','14:15:00',1.27),('12664','2013-10-06','14:20:00',1.87),('12664','2013-10-06','14:25:00',2.94),('12664','2013-10-06','14:30:00',2.21),('12664','2013-10-06','14:35:00',2.61),('12664','2013-10-06','14:40:00',1.73),('12664','2013-10-06','14:45:00',1.52),('12664','2013-10-06','14:50:00',2.11),('12664','2013-10-06','14:55:00',2.2),('12664','2013-10-06','15:00:00',2.17),('12664','2013-10-06','15:05:00',1.99),('12664','2013-10-06','15:10:00',1.96),('12664','2013-10-06','15:15:00',1.64),('12664','2013-10-06','15:20:00',1.14),('12664','2013-10-06','15:25:00',1.01),('12664','2013-10-06','17:05:00',1.04),('12664','2013-10-06','17:10:00',1.08),('12664','2013-10-05','15:55:00',1.08),('12664','2013-10-05','16:00:00',1.31),('12664','2013-10-05','16:05:00',1.17),('12664','2013-10-05','16:10:00',1.11),('12664','2013-10-05','16:15:00',1.09),('12664','2013-10-05','16:45:00',1.08),('12664','2013-10-05','16:50:00',1.12),('12664','2013-10-05','16:55:00',1.14),('12664','2013-10-04','09:20:00',1.24),('12664','2013-10-04','09:25:00',1.29),('12664','2013-10-04','09:30:00',1.07),('12664','2013-10-04','09:35:00',1.04),('12664','2013-10-04','09:40:00',1.19),('12664','2013-10-04','09:45:00',1.34),('12664','2013-10-04','09:50:00',1.46),('12664','2013-10-04','09:55:00',1.21),('12664','2013-10-04','10:00:00',1.27),('12664','2013-10-04','10:05:00',1.32),('12664','2013-10-04','10:10:00',1.4),('12664','2013-10-04','10:15:00',1.39),('12664','2013-10-04','10:20:00',1.69),('12664','2013-10-04','10:25:00',2.06),('12664','2013-10-04','10:30:00',2.32),('12664','2013-10-04','10:35:00',2.73),('12664','2013-10-04','10:40:00',3.09),('12664','2013-10-04','10:45:00',2.21),('12664','2013-10-04','10:50:00',1.8),('12664','2013-10-04','10:55:00',2.21),('12664','2013-10-04','11:00:00',1.86),('12664','2013-10-04','11:05:00',1.53),('12664','2013-10-04','11:10:00',2.52),('12664','2013-10-04','11:15:00',2.75),('12664','2013-10-04','11:20:00',2.84),('12664','2013-10-04','11:25:00',2.61),('12664','2013-10-04','11:30:00',3.26),('12664','2013-10-04','11:35:00',3.23),('12664','2013-10-04','11:40:00',3.72),('12664','2013-10-04','11:45:00',3.64),('12664','2013-10-04','11:50:00',3.69),('12664','2013-10-04','11:55:00',3.72),('12664','2013-10-04','12:00:00',3.75),('12664','2013-10-04','12:05:00',3.61),('12664','2013-10-04','12:10:00',3.75),('12664','2013-10-04','12:15:00',3.75),('12664','2013-10-04','12:20:00',3.76),('12664','2013-10-04','12:25:00',3.83),('12664','2013-10-04','12:30:00',3.82),('12664','2013-10-04','12:35:00',3.75),('12664','2013-10-04','12:40:00',3.71),('12664','2013-10-04','12:45:00',3.75),('12664','2013-10-04','12:50:00',3.68),('12664','2013-10-04','12:55:00',3.72),('12664','2013-10-04','13:00:00',3.76),('12664','2013-10-04','13:05:00',3.74),('12664','2013-10-04','13:10:00',3.81),('12664','2013-10-04','13:15:00',3.76),('12664','2013-10-04','13:20:00',3.6),('12664','2013-10-04','13:25:00',3.75),('12664','2013-10-04','13:30:00',3.72),('12664','2013-10-04','13:35:00',3.68),('12664','2013-10-04','13:40:00',3.62),('12664','2013-10-04','13:45:00',3.58),('12664','2013-10-04','13:50:00',3.61),('12664','2013-10-04','13:55:00',3.61),('12664','2013-10-04','14:00:00',3.56),('12664','2013-10-04','14:05:00',3.18),('12664','2013-10-04','14:10:00',2.98),('12664','2013-10-04','14:15:00',3.29),('12664','2013-10-04','14:20:00',3.34),('12664','2013-10-04','14:25:00',2.86),('12664','2013-10-04','14:30:00',2.14),('12664','2013-10-04','14:35:00',1.76),('12664','2013-10-04','14:40:00',2.19),('12664','2013-10-04','14:45:00',2.43),('12664','2013-10-04','14:50:00',2.62),('12664','2013-10-04','14:55:00',2.36),('12664','2013-10-04','15:00:00',2.49),('12664','2013-10-04','15:05:00',2.24),('12664','2013-10-04','15:10:00',1.99),('12664','2013-10-04','15:15:00',1.45),('12664','2013-10-04','15:20:00',2.18),('12664','2013-10-04','15:25:00',1.62),('12664','2013-10-04','15:30:00',1.4),('12664','2013-10-04','15:35:00',1.21),('12664','2013-10-04','15:55:00',1.2),('12664','2013-10-04','16:00:00',1.19),('12664','2013-10-03','08:25:00',1.08),('12664','2013-10-03','08:30:00',1.19),('12664','2013-10-03','08:35:00',1.29),('12664','2013-10-03','08:40:00',1.39),('12664','2013-10-03','08:45:00',1.48),('12664','2013-10-03','08:50:00',1.57),('12664','2013-10-03','08:55:00',1.66),('12664','2013-10-03','09:00:00',1.77),('12664','2013-10-03','09:05:00',1.89),('12664','2013-10-03','09:10:00',1.97),('12664','2013-10-03','09:15:00',2.07),('12664','2013-10-03','09:20:00',2.18),('12664','2013-10-03','09:25:00',2.27),('12664','2013-10-03','09:30:00',2.35),('12664','2013-10-03','09:35:00',2.43),('12664','2013-10-03','09:40:00',2.52),('12664','2013-10-03','09:45:00',2.61),('12664','2013-10-03','09:50:00',2.68),('12664','2013-10-03','09:55:00',2.76),('12664','2013-10-03','10:00:00',2.85),('12664','2013-10-03','10:05:00',2.92),('12664','2013-10-03','10:10:00',2.96),('12664','2013-10-03','10:15:00',3.04),('12664','2013-10-03','10:20:00',3.1),('12664','2013-10-03','10:25:00',3.18),('12664','2013-10-03','10:30:00',3.23),('12664','2013-10-03','10:35:00',3.29),('12664','2013-10-03','10:40:00',3.36),('12664','2013-10-03','10:45:00',3.39),('12664','2013-10-03','10:50:00',3.44),('12664','2013-10-03','10:55:00',3.48),('12664','2013-10-03','11:00:00',3.52),('12664','2013-10-03','11:05:00',3.58),('12664','2013-10-03','11:10:00',3.64),('12664','2013-10-03','11:15:00',3.71),('12664','2013-10-03','11:20:00',3.73),('12664','2013-10-03','11:25:00',3.76),('12664','2013-10-03','11:30:00',3.8),('12664','2013-10-03','11:35:00',3.83),('12664','2013-10-03','11:40:00',3.84),('12664','2013-10-03','11:45:00',3.83),('12664','2013-10-03','11:50:00',3.85),('12664','2013-10-03','11:55:00',3.88),('12664','2013-10-03','12:00:00',3.87),('12664','2013-10-03','12:05:00',3.91),('12664','2013-10-03','12:10:00',3.92),('12664','2013-10-03','12:15:00',3.94),('12664','2013-10-03','12:20:00',3.93),('12664','2013-10-03','12:25:00',3.99),('12664','2013-10-03','12:30:00',3.99),('12664','2013-10-03','12:35:00',3.99),('12664','2013-10-03','12:40:00',4),('12664','2013-10-03','12:45:00',3.99),('12664','2013-10-03','12:50:00',4),('12664','2013-10-03','12:55:00',4),('12664','2013-10-03','13:00:00',3.94),('12664','2013-10-03','13:05:00',3.99),('12664','2013-10-03','13:10:00',3.99),('12664','2013-10-03','13:15:00',3.96),('12664','2013-10-03','13:20:00',3.95),('12664','2013-10-03','13:25:00',3.96),('12664','2013-10-03','13:30:00',3.96),('12664','2013-10-03','13:35:00',3.93),('12664','2013-10-03','13:40:00',3.91),('12664','2013-10-03','13:45:00',3.87),('12664','2013-10-03','13:50:00',3.86),('12664','2013-10-03','13:55:00',3.82),('12664','2013-10-03','14:00:00',3.78),('12664','2013-10-03','14:05:00',3.75),('12664','2013-10-03','14:10:00',3.72),('12664','2013-10-03','14:15:00',3.68),('12664','2013-10-03','14:20:00',3.64),('12664','2013-10-03','14:25:00',3.6),('12664','2013-10-03','14:30:00',3.57),('12664','2013-10-03','14:35:00',3.54),('12664','2013-10-03','14:40:00',3.49),('12664','2013-10-03','14:45:00',3.42),('12664','2013-10-03','14:50:00',3.35),('12664','2013-10-03','14:55:00',3.3),('12664','2013-10-03','15:00:00',3.28),('12664','2013-10-03','15:05:00',3.21),('12664','2013-10-03','15:10:00',3.16),('12664','2013-10-03','15:15:00',3.08),('12664','2013-10-03','15:20:00',3.03),('12664','2013-10-03','15:25:00',2.99),('12664','2013-10-03','15:30:00',2.94),('12664','2013-10-03','15:35:00',2.86),('12664','2013-10-03','15:40:00',2.78),('12664','2013-10-03','15:45:00',2.71),('12664','2013-10-03','15:50:00',2.66),('12664','2013-10-03','15:55:00',2.59),('12664','2013-10-03','16:00:00',2.52),('12664','2013-10-03','16:05:00',2.42),('12664','2013-10-03','16:10:00',2.36),('12664','2013-10-03','16:15:00',2.3),('12664','2013-10-03','16:20:00',2.2),('12664','2013-10-03','16:25:00',2.11),('12664','2013-10-03','16:30:00',2.02),('12664','2013-10-03','16:35:00',1.95),('12664','2013-10-03','16:40:00',1.85),('12664','2013-10-03','16:45:00',1.75),('12664','2013-10-03','16:50:00',1.65),('12664','2013-10-03','16:55:00',1.55),('12664','2013-10-03','17:00:00',1.45),('12664','2013-10-03','17:05:00',1.36),('12664','2013-10-03','17:10:00',1.26),('12664','2013-10-03','17:15:00',1.16),('12664','2013-10-03','17:20:00',1.06),('12664','2013-10-02','08:25:00',1.03),('12664','2013-10-02','08:30:00',1.13),('12664','2013-10-02','08:35:00',1.23),('12664','2013-10-02','08:40:00',1.33),('12664','2013-10-02','08:45:00',1.42),('12664','2013-10-02','08:50:00',1.51),('12664','2013-10-02','08:55:00',1.61),('12664','2013-10-02','09:00:00',1.7),('12664','2013-10-02','09:05:00',1.8),('12664','2013-10-02','09:10:00',1.88),('12664','2013-10-02','09:15:00',1.96),('12664','2013-10-02','09:20:00',2.04),('12664','2013-10-02','09:25:00',2.13),('12664','2013-10-02','09:30:00',2.2),('12664','2013-10-02','09:35:00',2.28),('12664','2013-10-02','09:40:00',2.39),('12664','2013-10-02','09:45:00',2.47),('12664','2013-10-02','09:50:00',2.54),('12664','2013-10-02','09:55:00',2.6),('12664','2013-10-02','10:00:00',2.66),('12664','2013-10-02','10:05:00',2.72),('12664','2013-10-02','10:10:00',2.78),('12664','2013-10-02','10:15:00',2.85),('12664','2013-10-02','10:20:00',2.91),('12664','2013-10-02','10:25:00',2.97),('12664','2013-10-02','10:30:00',3.03),('12664','2013-10-02','10:35:00',3.08),('12664','2013-10-02','10:40:00',3.14),('12664','2013-10-02','10:45:00',3.2),('12664','2013-10-02','10:50:00',3.26),('12664','2013-10-02','10:55:00',3.27),('12664','2013-10-02','11:00:00',3.32),('12664','2013-10-02','11:05:00',3.37),('12664','2013-10-02','11:10:00',3.41),('12664','2013-10-02','11:15:00',3.42),('12664','2013-10-02','11:20:00',3.49),('12664','2013-10-02','11:25:00',3.52),('12664','2013-10-02','11:30:00',3.57),('12664','2013-10-02','11:35:00',3.59),('12664','2013-10-02','11:40:00',3.64),('12664','2013-10-02','11:45:00',3.67),('12664','2013-10-02','11:50:00',3.69),('12664','2013-10-02','11:55:00',3.72),('12664','2013-10-02','12:00:00',3.72),('12664','2013-10-02','12:05:00',3.72),('12664','2013-10-02','12:10:00',3.74),('12664','2013-10-02','12:15:00',3.75),('12664','2013-10-02','12:20:00',3.74),('12664','2013-10-02','12:25:00',3.76),('12664','2013-10-02','12:30:00',3.81),('12664','2013-10-02','12:35:00',3.81),('12664','2013-10-02','12:40:00',3.82),('12664','2013-10-02','12:45:00',3.82),('12664','2013-10-02','12:50:00',3.83),('12664','2013-10-02','12:55:00',3.84),('12664','2013-10-02','13:00:00',3.87),('12664','2013-10-02','13:05:00',3.84),('12664','2013-10-02','13:10:00',3.82),('12664','2013-10-02','13:15:00',3.79),('12664','2013-10-02','13:20:00',3.79),('12664','2013-10-02','13:25:00',3.78),('12664','2013-10-02','13:30:00',3.75),('12664','2013-10-02','13:35:00',3.76),('12664','2013-10-02','13:40:00',3.76),('12664','2013-10-02','13:45:00',3.7),('12664','2013-10-02','13:50:00',3.69),('12664','2013-10-02','13:55:00',3.79),('12664','2013-10-02','14:00:00',3.81),('12664','2013-10-02','14:05:00',3.73),('12664','2013-10-02','14:10:00',3.7),('12664','2013-10-02','14:15:00',3.69),('12664','2013-10-02','14:20:00',3.62),('12664','2013-10-02','14:25:00',3.54),('12664','2013-10-02','14:30:00',3.5),('12664','2013-10-02','14:35:00',3.43),('12664','2013-10-02','14:40:00',3.41),('12664','2013-10-02','14:45:00',3.39),('12664','2013-10-02','14:50:00',3.33),('12664','2013-10-02','14:55:00',3.26),('12664','2013-10-02','15:00:00',3.26),('12664','2013-10-02','15:05:00',3.17),('12664','2013-10-02','15:10:00',3.11),('12664','2013-10-02','15:15:00',3.06),('12664','2013-10-02','15:20:00',3.01),('12664','2013-10-02','15:25:00',2.94),('12664','2013-10-02','15:30:00',2.88),('12664','2013-10-02','15:35:00',2.81),('12664','2013-10-02','15:40:00',2.74),('12664','2013-10-02','15:45:00',2.68),('12664','2013-10-02','15:50:00',2.58),('12664','2013-10-02','15:55:00',2.51),('12664','2013-10-02','16:00:00',2.46),('12664','2013-10-02','16:05:00',2.39),('12664','2013-10-02','16:20:00',2.08),('12664','2013-10-02','16:25:00',2.03),('12664','2013-10-02','16:30:00',1.93),('12664','2013-10-02','16:35:00',1.86),('12664','2013-10-02','16:40:00',1.78),('12664','2013-10-02','16:45:00',1.68),('12664','2013-10-02','16:50:00',1.59),('12664','2013-10-02','16:55:00',1.49),('12664','2013-10-02','17:00:00',1.39),('12664','2013-10-02','17:05:00',1.31),('12664','2013-10-02','17:10:00',1.21),('12664','2013-10-02','17:15:00',1.11),('12664','2013-10-02','17:20:00',1.02),('12664','2013-10-01','08:25:00',1.02),('12664','2013-10-01','08:30:00',1.13),('12664','2013-10-01','08:35:00',1.23),('12664','2013-10-01','08:40:00',1.33),('12664','2013-10-01','08:45:00',1.43),('12664','2013-10-01','08:50:00',1.52),('12664','2013-10-01','08:55:00',1.61),('12664','2013-10-01','09:00:00',1.71),('12664','2013-10-01','09:05:00',1.79),('12664','2013-10-01','09:10:00',1.86),('12664','2013-10-01','09:15:00',1.94),('12664','2013-10-01','09:20:00',2.01),('12664','2013-10-01','09:25:00',2.07),('12664','2013-10-01','09:30:00',2.19),('12664','2013-10-01','09:35:00',2.28),('12664','2013-10-01','09:40:00',2.38),('12664','2013-10-01','09:45:00',2.46),('12664','2013-10-01','09:50:00',2.53),('12664','2013-10-01','09:55:00',2.61),('12664','2013-10-01','10:00:00',2.67),('12664','2013-10-01','10:05:00',2.74),('12664','2013-10-01','10:10:00',2.82),('12664','2013-10-01','10:15:00',2.87),('12664','2013-10-01','10:20:00',2.96),('12664','2013-10-01','10:25:00',3),('12664','2013-10-01','10:30:00',3.02),('12664','2013-10-01','10:35:00',3.1),('12664','2013-10-01','10:40:00',3.17),('12664','2013-10-01','10:45:00',3.24),('12664','2013-10-01','10:50:00',3.25),('12664','2013-10-01','10:55:00',3.26),('12664','2013-10-01','11:00:00',2.34),('12664','2013-10-01','11:05:00',2.02),('12664','2013-10-01','11:10:00',3.46),('12664','2013-10-01','11:15:00',3.11),('12664','2013-10-01','11:20:00',2.8),('12664','2013-10-01','11:25:00',3.8),('12664','2013-10-01','11:30:00',3.83),('12664','2013-10-01','11:35:00',3.67),('12664','2013-10-01','11:40:00',3.8),('12664','2013-10-01','11:45:00',3.91),('12664','2013-10-01','11:50:00',4.05),('12664','2013-10-01','11:55:00',1.65),('12664','2013-10-01','12:00:00',2.04),('12664','2013-10-01','12:05:00',3.92),('12664','2013-10-01','12:10:00',3.06),('12664','2013-10-01','12:15:00',1.97),('12664','2013-10-01','12:20:00',1.17),('12664','2013-10-01','12:25:00',3.6),('12664','2013-10-01','12:30:00',3.5),('12664','2013-10-01','12:35:00',1.11),('12664','2013-10-01','12:40:00',4.32),('12664','2013-10-01','12:45:00',3.86),('12664','2013-10-01','12:50:00',3.41),('12664','2013-10-01','12:55:00',2.54),('12664','2013-10-01','13:00:00',3.04),('12664','2013-10-01','13:10:00',3.2),('12664','2013-10-01','13:15:00',2.19),('12664','2013-10-01','13:20:00',4.09),('12664','2013-10-01','13:25:00',4.19),('12664','2013-10-01','13:30:00',4.1),('12664','2013-10-01','13:35:00',3.97),('12664','2013-10-01','13:40:00',3.8),('12664','2013-10-01','13:45:00',3.77),('12664','2013-10-01','13:50:00',3.73),('12664','2013-10-01','13:55:00',3.71),('12664','2013-10-01','14:00:00',3.65),('12664','2013-10-01','14:05:00',3.61),('12664','2013-10-01','14:10:00',3.6),('12664','2013-10-01','14:15:00',3.56),('12664','2013-10-01','14:20:00',3.54),('12664','2013-10-01','14:25:00',3.5),('12664','2013-10-01','14:30:00',3.45),('12664','2013-10-01','14:35:00',3.46),('12664','2013-10-01','14:40:00',3.4),('12664','2013-10-01','14:45:00',3.37),('12664','2013-10-01','14:50:00',3.33),('12664','2013-10-01','14:55:00',3.29),('12664','2013-10-01','15:00:00',3.24),('12664','2013-10-01','15:05:00',3.18),('12664','2013-10-01','15:10:00',3.13),('12664','2013-10-01','15:15:00',3.07),('12664','2013-10-01','15:20:00',3.02),('12664','2013-10-01','15:25:00',2.97),('12664','2013-10-01','15:30:00',2.91),('12664','2013-10-01','15:35:00',2.81),('12664','2013-10-01','15:40:00',2.75),('12664','2013-10-01','15:45:00',2.68),('12664','2013-10-01','15:50:00',2.62),('12664','2013-10-01','15:55:00',2.57),('12664','2013-10-01','16:00:00',2.5),('12664','2013-10-01','16:05:00',2.43),('12664','2013-10-01','16:10:00',2.37),('12664','2013-10-01','16:15:00',2.28),('12664','2013-10-01','16:20:00',2.2),('12664','2013-10-01','16:25:00',2.11),('12664','2013-10-01','16:30:00',2),('12664','2013-10-01','16:35:00',1.91),('12664','2013-10-01','16:40:00',1.85),('12664','2013-10-01','16:45:00',1.75),('12664','2013-10-01','16:50:00',1.66),('12664','2013-10-01','16:55:00',1.57),('12664','2013-10-01','17:00:00',1.45),('12664','2013-10-01','17:05:00',1.35),('12664','2013-10-01','17:10:00',1.25),('12664','2013-10-01','17:15:00',1.15),('12664','2013-10-01','17:20:00',1.07),('12664','2013-09-30','09:30:00',1.03),('12664','2013-09-30','09:35:00',1.29),('12664','2013-09-30','09:40:00',2.15),('12664','2013-09-30','09:45:00',2.07),('12664','2013-09-30','09:50:00',1.01),('12664','2013-09-30','10:05:00',1.01),('12664','2013-09-30','10:10:00',1.11),('12664','2013-09-30','10:15:00',1.12),('12664','2013-09-30','10:20:00',1.23),('12664','2013-09-30','10:25:00',1.46),('12664','2013-09-30','10:30:00',1.67),('12664','2013-09-30','10:35:00',2.01),('12664','2013-09-30','10:40:00',3),('12664','2013-09-30','10:45:00',3.05),('12664','2013-09-30','10:50:00',2.77),('12664','2013-09-30','10:55:00',3.06),('12664','2013-09-30','11:00:00',3.51),('12664','2013-09-30','11:05:00',3.58),('12664','2013-09-30','11:10:00',3.59),('12664','2013-09-30','11:15:00',2.34),('12664','2013-09-30','11:20:00',3.41),('12664','2013-09-30','11:25:00',3.49),('12664','2013-09-30','11:30:00',3.81),('12664','2013-09-30','11:35:00',3.32),('12664','2013-09-30','11:40:00',2.06),('12664','2013-09-30','11:45:00',1.8),('12664','2013-09-30','11:50:00',1.38),('12664','2013-09-30','11:55:00',3.02),('12664','2013-09-30','12:00:00',3.93),('12664','2013-09-30','12:05:00',3.99),('12664','2013-09-30','12:10:00',3.96),('12664','2013-09-30','12:15:00',3.92),('12664','2013-09-30','12:20:00',3.91),('12664','2013-09-30','12:25:00',3.72),('12664','2013-09-30','12:30:00',3.95),('12664','2013-09-30','12:35:00',3.97),('12664','2013-09-30','12:40:00',3.97),('12664','2013-09-30','12:45:00',3.86),('12664','2013-09-30','12:50:00',4.25),('12664','2013-09-30','12:55:00',4.25),('12664','2013-09-30','13:00:00',3.43),('12664','2013-09-30','13:05:00',2.62),('12664','2013-09-30','13:10:00',4.38),('12664','2013-09-30','13:15:00',3.99),('12664','2013-09-30','13:20:00',3.85),('12664','2013-09-30','13:25:00',4.26),('12664','2013-09-30','13:30:00',4.42),('12664','2013-09-30','13:35:00',3.84),('12664','2013-09-30','13:40:00',1.74),('12664','2013-09-30','14:00:00',1.17),('12664','2013-09-30','14:05:00',1.21),('12664','2013-09-30','14:10:00',1.07),('12664','2013-09-30','14:25:00',2.53),('12664','2013-09-30','14:30:00',4.11),('12664','2013-09-30','14:35:00',4.77),('12664','2013-09-30','14:40:00',4.37),('12664','2013-09-30','14:45:00',2.62),('12664','2013-09-30','14:50:00',2.83),('12664','2013-09-30','14:55:00',3.57),('12664','2013-09-30','15:00:00',2.33),('12664','2013-09-30','15:05:00',1.31),('12664','2013-09-30','15:10:00',2.57),('12664','2013-09-30','15:15:00',1.88),('12664','2013-09-30','15:20:00',1.07),('12664','2013-09-30','15:25:00',1.37),('12664','2013-09-30','15:50:00',3.02),('12664','2013-09-30','15:55:00',2.86),('12664','2013-09-30','16:00:00',2.8),('12664','2013-09-30','16:05:00',1.96),('12664','2013-09-30','16:10:00',1.51),('12664','2013-09-30','16:15:00',1.52),('12664','2013-09-30','16:20:00',1.51),('12664','2013-09-30','16:25:00',2.69),('12664','2013-09-30','16:30:00',1.8),('12664','2013-09-30','16:35:00',1.64),('12664','2013-09-30','16:40:00',2.1),('12664','2013-09-30','16:45:00',1.97),('12664','2013-09-30','16:50:00',1.78),('12664','2013-09-30','16:55:00',1.31),('12664','2013-09-30','17:00:00',1.07),('12664','2013-09-30','17:10:00',1.31),('12664','2013-09-30','17:15:00',1.13),('12664','2013-09-30','17:20:00',1.19),('12664','2013-09-29','08:40:00',1.03),('12664','2013-09-29','08:45:00',1.1),('12664','2013-09-29','09:50:00',1.16),('12664','2013-09-29','09:55:00',1.89),('12664','2013-09-29','10:00:00',2.24),('12664','2013-09-29','10:05:00',2.2),('12664','2013-09-29','10:10:00',2.41),('12664','2013-09-29','10:15:00',2.03),('12664','2013-09-29','10:20:00',2.46),('12664','2013-09-29','10:25:00',2.54),('12664','2013-09-29','10:30:00',2.53),('12664','2013-09-29','10:35:00',2.71),('12664','2013-09-29','10:40:00',2.7),('12664','2013-09-29','10:45:00',2.9),('12664','2013-09-29','10:50:00',2.96),('12664','2013-09-29','10:55:00',2.87),('12664','2013-09-29','11:00:00',2.89),('12664','2013-09-29','11:05:00',2.72),('12664','2013-09-29','11:10:00',2.83),('12664','2013-09-29','11:15:00',2.98),('12664','2013-09-29','11:20:00',2.94),('12664','2013-09-29','11:25:00',2.93),('12664','2013-09-29','11:30:00',3.04),('12664','2013-09-29','11:35:00',3.12),('12664','2013-09-29','11:40:00',3.29),('12664','2013-09-29','11:45:00',3.22),('12664','2013-09-29','11:50:00',3.01),('12664','2013-09-29','11:55:00',3.11),('12664','2013-09-29','12:00:00',3.46),('12664','2013-09-29','12:05:00',3.27),('12664','2013-09-29','12:10:00',2.91),('12664','2013-09-29','12:15:00',1.94),('12664','2013-09-29','12:25:00',1.02),('12664','2013-09-29','12:30:00',1.18),('12664','2013-09-29','12:35:00',1.61),('12664','2013-09-29','12:40:00',1.3),('12664','2013-09-29','12:45:00',1.34),('12664','2013-09-29','12:50:00',1.34),('12664','2013-09-29','13:20:00',1.43),('12664','2013-09-29','13:25:00',2.38),('12664','2013-09-29','13:30:00',1.92),('12664','2013-09-29','13:35:00',2.03),('12664','2013-09-29','13:40:00',2.67),('12664','2013-09-29','13:45:00',2.27),('12664','2013-09-29','13:50:00',2.06),('12664','2013-09-29','13:55:00',1.56),('12664','2013-09-29','14:00:00',1.39),('12664','2013-09-29','14:05:00',1.23),('12664','2013-09-29','14:10:00',1.02),('12664','2013-09-29','14:20:00',1.09),('12664','2013-09-29','14:25:00',1.06),('12664','2013-09-29','14:50:00',1.77),('12664','2013-09-29','15:15:00',1.26),('12664','2013-09-29','15:20:00',1.15),('12664','2013-09-29','15:25:00',1.5),('12664','2013-09-29','15:55:00',1.16),('12664','2013-09-29','16:25:00',1.47),('12664','2013-09-29','16:30:00',1.31),('12664','2013-09-28','08:35:00',1.09),('12664','2013-09-28','08:40:00',1.18),('12664','2013-09-28','08:45:00',1.27),('12664','2013-09-28','08:50:00',1.41),('12664','2013-09-28','08:55:00',1.5),('12664','2013-09-28','09:00:00',1.59),('12664','2013-09-28','09:05:00',1.67),('12664','2013-09-28','09:10:00',1.76),('12664','2013-09-28','09:15:00',1.85),('12664','2013-09-28','09:20:00',1.92),('12664','2013-09-28','09:25:00',2.01),('12664','2013-09-28','09:30:00',1.97),('12664','2013-09-28','09:35:00',1.98),('12664','2013-09-28','09:40:00',2.03),('12664','2013-09-28','09:45:00',2.04),('12664','2013-09-28','10:30:00',1.8),('12664','2013-09-28','10:35:00',3.33),('12664','2013-09-28','10:40:00',3.46),('12664','2013-09-28','10:45:00',3.4),('12664','2013-09-28','10:50:00',3.55),('12664','2013-09-28','10:55:00',3.65),('12664','2013-09-28','11:00:00',3.35),('12664','2013-09-28','11:05:00',3.68),('12664','2013-09-28','11:10:00',3.67),('12664','2013-09-28','11:15:00',1.29),('12664','2013-09-28','11:25:00',3.06),('12664','2013-09-28','11:30:00',2.26),('12664','2013-09-28','11:40:00',1.31),('12664','2013-09-28','11:45:00',3.86),('12664','2013-09-28','11:50:00',3.77),('12664','2013-09-28','11:55:00',3.64),('12664','2013-09-28','12:00:00',1.36),('12664','2013-09-28','12:05:00',3.67),('12664','2013-09-28','12:10:00',4.21),('12664','2013-09-28','12:15:00',4.17),('12664','2013-09-28','12:20:00',4.06),('12664','2013-09-28','12:25:00',3.92),('12664','2013-09-28','12:30:00',3.95),('12664','2013-09-28','12:35:00',3.86),('12664','2013-09-28','12:40:00',3.82),('12664','2013-09-28','12:45:00',3.82),('12664','2013-09-28','12:50:00',3.82),('12664','2013-09-28','12:55:00',3.81),('12664','2013-09-28','13:00:00',3.89),('12664','2013-09-28','13:05:00',3.66),('12664','2013-09-28','13:10:00',3.35),('12664','2013-09-28','13:15:00',3.63),('12664','2013-09-28','13:20:00',3.76),('12664','2013-09-28','13:25:00',3.73),('12664','2013-09-28','13:30:00',3.73),('12664','2013-09-28','13:35:00',3.73),('12664','2013-09-28','13:40:00',3.73),('12664','2013-09-28','13:45:00',3.67),('12664','2013-09-28','13:50:00',3.62),('12664','2013-09-28','13:55:00',2.23),('12664','2013-09-28','14:00:00',3.63),('12664','2013-09-28','14:05:00',3.73),('12664','2013-09-28','14:10:00',3.51),('12664','2013-09-28','14:15:00',3.56),('12664','2013-09-28','14:20:00',3.51),('12664','2013-09-28','14:25:00',3.64),('12664','2013-09-28','14:30:00',3.71),('12664','2013-09-28','14:35:00',3.39),('12664','2013-09-28','14:40:00',2.48),('12664','2013-09-28','14:45:00',3.38),('12664','2013-09-28','14:50:00',2.39),('12664','2013-09-28','14:55:00',2.85),('12664','2013-09-28','15:00:00',2.85),('12664','2013-09-28','15:05:00',2.85),('12664','2013-09-28','15:10:00',3.06),('12664','2013-09-28','15:15:00',2.95),('12664','2013-09-28','15:20:00',2.41),('12664','2013-09-28','15:25:00',2.97),('12664','2013-09-28','15:30:00',1.85),('12664','2013-09-28','15:35:00',2.97),('12664','2013-09-28','15:40:00',2.69),('12664','2013-09-28','15:45:00',2.59),('12664','2013-09-28','15:50:00',2.51),('12664','2013-09-28','15:55:00',2.46),('12664','2013-09-28','16:00:00',2.37),('12664','2013-09-28','16:05:00',2.34),('12664','2013-09-28','16:10:00',2.29),('12664','2013-09-28','16:15:00',2.22),('12664','2013-09-28','16:20:00',1.67),('12664','2013-09-28','16:25:00',1.64),('12664','2013-09-28','16:30:00',1.97),('12664','2013-09-28','16:35:00',1.9),('12664','2013-09-28','16:40:00',1.78),('12664','2013-09-28','16:45:00',1.69),('12664','2013-09-28','16:50:00',1.58),('12664','2013-09-28','16:55:00',1.48),('12664','2013-09-28','17:00:00',1.41),('12664','2013-09-28','17:05:00',1.32),('12664','2013-09-28','17:10:00',1.23),('12664','2013-09-28','17:15:00',1.14),('12664','2013-09-28','17:20:00',1.06),('12664','2014-04-13','09:30:00',1),('12664','2014-04-13','09:35:00',1.13),('12664','2014-04-13','09:40:00',1.55),('12664','2014-04-13','09:45:00',1.34),('12664','2014-04-13','09:50:00',1.73),('12664','2014-04-13','09:55:00',1.74),('12664','2014-04-13','10:00:00',3.04),('12664','2014-04-13','10:05:00',2.91),('12664','2014-04-13','10:10:00',1.71),('12664','2014-04-13','10:15:00',1.81),('12664','2014-04-13','10:20:00',1.73),('12664','2014-04-13','10:25:00',2),('12664','2014-04-13','10:30:00',3.07),('12664','2014-04-13','10:35:00',3.53),('12664','2014-04-13','10:40:00',3.6),('12664','2014-04-13','10:45:00',3.44),('12664','2014-04-13','10:50:00',3.1),('12664','2014-04-13','10:55:00',1.27),('12664','2014-04-13','11:00:00',3.74),('12664','2014-04-13','11:05:00',3.41),('12664','2014-04-13','11:10:00',2.08),('12664','2014-04-13','11:15:00',1.55),('12664','2014-04-13','11:20:00',1.14),('12664','2014-04-13','11:25:00',1.68),('12664','2014-04-13','11:30:00',1.65),('12664','2014-04-13','11:35:00',1.84),('12664','2014-04-13','11:40:00',1.76),('12664','2014-04-13','11:45:00',3.84),('12664','2014-04-13','11:50:00',2.55),('12664','2014-04-13','11:55:00',1.65),('12664','2014-04-13','12:00:00',1.51),('12664','2014-04-13','12:05:00',1.36),('12664','2014-04-13','12:10:00',1.3),('12664','2014-04-13','12:50:00',1.26),('12664','2014-04-13','12:55:00',1.77),('12664','2014-04-13','13:00:00',4.11),('12664','2014-04-13','13:05:00',4.67),('12664','2014-04-13','13:10:00',4),('12664','2014-04-13','13:15:00',4.12),('12664','2014-04-13','13:20:00',2.97),('12664','2014-04-13','13:25:00',4.11),('12664','2014-04-13','13:30:00',3.82),('12664','2014-04-13','13:35:00',2.21),('12664','2014-04-13','13:40:00',2.23),('12664','2014-04-13','13:45:00',1.92),('12664','2014-04-13','13:50:00',1.92),('12664','2014-04-13','13:55:00',1.97),('12664','2014-04-13','14:00:00',2.68),('12664','2014-04-13','14:05:00',2.49),('12664','2014-04-13','14:10:00',1.88),('12664','2014-04-13','14:15:00',1.52),('12664','2014-04-13','14:20:00',1.53),('12664','2014-04-13','14:25:00',1.51),('12664','2014-04-13','14:30:00',1.52),('12664','2014-04-13','14:35:00',1.84),('12664','2014-04-13','14:40:00',2.44),('12664','2014-04-13','14:45:00',3.67),('12664','2014-04-13','14:50:00',3.35),('12664','2014-04-13','14:55:00',3.86),('12664','2014-04-13','15:00:00',3.88),('12664','2014-04-13','15:05:00',3.33),('12664','2014-04-13','15:10:00',3.23),('12664','2014-04-13','15:15:00',3.57),('12664','2014-04-13','15:20:00',3.5),('12664','2014-04-13','15:25:00',3.02),('12664','2014-04-13','15:30:00',1.71),('12664','2014-04-13','15:35:00',1.79),('12664','2014-04-13','15:40:00',1.68),('12664','2014-04-13','15:45:00',2),('12664','2014-04-13','15:50:00',1.66),('12664','2014-04-13','15:55:00',1.38),('12664','2014-04-13','16:00:00',1.34),('12664','2014-04-13','16:05:00',1.15),('12664','2014-04-13','16:10:00',1.2),('12664','2014-04-13','16:15:00',1.45),('12664','2014-04-13','16:20:00',1.15),('12664','2014-04-13','16:25:00',1.04),('12664','2014-04-13','16:30:00',1.38),('12664','2014-04-13','16:35:00',2.16),('12664','2014-04-13','16:40:00',2.67),('12664','2014-04-13','16:45:00',2.56),('12664','2014-04-13','16:50:00',1.83),('12664','2014-04-13','16:55:00',2),('12664','2014-04-13','17:00:00',1.47),('12664','2014-04-13','17:05:00',1.62),('12664','2014-04-13','17:10:00',1.27),('12664','2014-04-13','17:15:00',1.02),('12664','2014-04-13','17:30:00',1.04),('12664','2014-04-13','17:35:00',1.13),('12664','2014-04-13','17:40:00',1.16),('12664','2014-04-13','17:45:00',1.13),('12664','2014-04-13','17:50:00',1.18),('12664','2014-04-13','17:55:00',1.03),('12664','2013-09-27','08:45:00',1.1),('12664','2013-09-27','08:50:00',1.13),('12664','2013-09-27','09:00:00',1.39),('12664','2013-09-27','09:05:00',1.68),('12664','2013-09-27','09:10:00',2.08),('12664','2013-09-27','09:15:00',2.18),('12664','2013-09-27','09:20:00',1.23),('12664','2013-09-27','10:00:00',1.16),('12664','2013-09-27','10:05:00',1.69),('12664','2013-09-27','10:10:00',2.33),('12664','2013-09-27','10:15:00',2.29),('12664','2013-09-27','10:20:00',2.49),('12664','2013-09-27','10:25:00',1.49),('12664','2013-09-27','10:30:00',2.88),('12664','2013-09-27','10:35:00',3.1),('12664','2013-09-27','10:40:00',2.97),('12664','2013-09-27','10:45:00',3.09),('12664','2013-09-27','10:50:00',3.12),('12664','2013-09-27','10:55:00',3.14),('12664','2013-09-27','11:00:00',3.17),('12664','2013-09-27','11:05:00',3.27),('12664','2013-09-27','11:10:00',3.29),('12664','2013-09-27','11:15:00',3.35),('12664','2013-09-27','11:20:00',3.41),('12664','2013-09-27','11:25:00',3.12),('12664','2013-09-27','11:30:00',2.21),('12664','2013-09-27','11:35:00',1.94),('12664','2013-09-27','11:40:00',1.39),('12664','2013-09-27','11:45:00',1.71),('12664','2013-09-27','11:50:00',3.2),('12664','2013-09-27','11:55:00',4.26),('12664','2013-09-27','12:00:00',3.29),('12664','2013-09-27','12:05:00',3.53),('12664','2013-09-27','12:10:00',2.6),('12664','2013-09-27','12:15:00',3.79),('12664','2013-09-27','12:20:00',3.93),('12664','2013-09-27','12:25:00',4.09),('12664','2013-09-27','12:30:00',1.39),('12664','2013-09-27','12:40:00',1.84),('12664','2013-09-27','12:45:00',1.63),('12664','2013-09-27','12:50:00',1.04),('12664','2013-09-27','12:55:00',1.9),('12664','2013-09-27','13:00:00',1.64),('12664','2013-09-27','13:05:00',4.25),('12664','2013-09-27','13:10:00',3.35),('12664','2013-09-27','13:15:00',4.23),('12664','2013-09-27','13:20:00',4.2),('12664','2013-09-27','13:25:00',3.08),('12664','2013-09-27','13:30:00',3.97),('12664','2013-09-27','13:35:00',4.02),('12664','2013-09-27','13:40:00',3.94),('12664','2013-09-27','13:45:00',1.93),('12664','2013-09-27','13:50:00',2.56),('12664','2013-09-27','13:55:00',3.46),('12664','2013-09-27','14:00:00',2.67),('12664','2013-09-27','14:05:00',3.07),('12664','2013-09-27','14:10:00',3.78),('12664','2013-09-27','14:15:00',3.64),('12664','2013-09-27','14:20:00',3.01),('12664','2013-09-27','14:25:00',3.35),('12664','2013-09-27','14:30:00',3.61),('12664','2013-09-27','14:35:00',3.63),('12664','2013-09-27','14:40:00',3.46),('12664','2013-09-27','14:45:00',3.47),('12664','2013-09-27','14:50:00',3.38),('12664','2013-09-27','14:55:00',3.34),('12664','2013-09-27','15:00:00',3.2),('12664','2013-09-27','15:05:00',3.1),('12664','2013-09-27','15:10:00',2.75),('12664','2013-09-27','15:15:00',3.14),('12664','2013-09-27','15:20:00',3.02),('12664','2013-09-27','15:25:00',2.96),('12664','2013-09-27','15:30:00',3.01),('12664','2013-09-27','15:35:00',2.02),('12664','2013-09-27','15:40:00',2.52),('12664','2013-09-27','15:45:00',2.8),('12664','2013-09-27','15:50:00',2.56),('12664','2013-09-27','15:55:00',2.75),('12664','2013-09-27','16:00:00',2.59),('12664','2013-09-27','16:05:00',2.4),('12664','2013-09-27','16:10:00',2.17),('12664','2013-09-27','16:15:00',1.59),('12664','2013-09-27','16:20:00',2.23),('12664','2013-09-27','16:25:00',2.11),('12664','2013-09-27','16:30:00',2.05),('12664','2013-09-27','16:35:00',1.97),('12664','2013-09-27','16:40:00',1.87),('12664','2013-09-27','16:45:00',1.75),('12664','2013-09-27','16:50:00',1.65),('12664','2013-09-27','16:55:00',1.66),('12664','2013-09-27','17:00:00',1.26),('12664','2013-09-27','17:05:00',1.39),('12664','2013-09-27','17:15:00',1),('12664','2013-09-27','17:20:00',1.29),('12664','2013-09-27','17:25:00',1.08),('12664','2013-09-26','08:25:00',1.05),('12664','2013-09-26','08:30:00',1.16),('12664','2013-09-26','08:35:00',1.25),('12664','2013-09-26','08:40:00',1.34),('12664','2013-09-26','08:45:00',1.45),('12664','2013-09-26','08:50:00',1.52),('12664','2013-09-26','08:55:00',1.62),('12664','2013-09-26','09:00:00',1.73),('12664','2013-09-26','09:05:00',1.84),('12664','2013-09-26','09:10:00',1.95),('12664','2013-09-26','09:15:00',1.98),('12664','2013-09-26','09:20:00',2.05),('12664','2013-09-26','09:25:00',2.13),('12664','2013-09-26','09:30:00',2.21),('12664','2013-09-26','09:35:00',2.3),('12664','2013-09-26','09:40:00',2.36),('12664','2013-09-26','09:45:00',2.43),('12664','2013-09-26','09:50:00',2.51),('12664','2013-09-26','09:55:00',2.59),('12664','2013-09-26','10:00:00',2.66),('12664','2013-09-26','10:05:00',2.74),('12664','2013-09-26','10:10:00',2.76),('12664','2013-09-26','10:15:00',2.82),('12664','2013-09-26','10:20:00',2.86),('12664','2013-09-26','10:25:00',2.89),('12664','2013-09-26','10:30:00',2.95),('12664','2013-09-26','10:35:00',2.97),('12664','2013-09-26','10:40:00',3.03),('12664','2013-09-26','10:45:00',3.07),('12664','2013-09-26','10:50:00',3.11),('12664','2013-09-26','10:55:00',3.14),('12664','2013-09-26','11:00:00',3.23),('12664','2013-09-26','11:05:00',3.33),('12664','2013-09-26','11:10:00',3.4),('12664','2013-09-26','11:15:00',3.44),('12664','2013-09-26','11:20:00',3.38),('12664','2013-09-26','11:25:00',3.42),('12664','2013-09-26','11:30:00',3.59),('12664','2013-09-26','11:35:00',3.68),('12664','2013-09-26','11:40:00',3.58),('12664','2013-09-26','11:45:00',2.75),('12664','2013-09-26','11:50:00',3.63),('12664','2013-09-26','11:55:00',3.77),('12664','2013-09-26','12:00:00',3.93),('12664','2013-09-26','12:05:00',3.81),('12664','2013-09-26','12:10:00',3.68),('12664','2013-09-26','12:15:00',3.56),('12664','2013-09-26','12:20:00',3.43),('12664','2013-09-26','12:25:00',2.99),('12664','2013-09-26','12:30:00',1.35),('12664','2013-09-26','12:35:00',1.7),('12664','2013-09-26','12:40:00',2.1),('12664','2013-09-26','12:45:00',3.33),('12664','2013-09-26','12:50:00',2.74),('12664','2013-09-26','12:55:00',3.6),('12664','2013-09-26','13:00:00',3.94),('12664','2013-09-26','13:05:00',3.56),('12664','2013-09-26','13:10:00',3.18),('12664','2013-09-26','13:15:00',2.07),('12664','2013-09-26','13:20:00',1.64),('12664','2013-09-26','13:25:00',1.58),('12664','2013-09-26','13:30:00',1.66),('12664','2013-09-26','13:35:00',1.71),('12664','2013-09-26','13:40:00',3.71),('12664','2013-09-26','13:45:00',3.28),('12664','2013-09-26','13:50:00',3.64),('12664','2013-09-26','13:55:00',3.51),('12664','2013-09-26','14:00:00',2.29),('12664','2013-09-26','14:05:00',3.53),('12664','2013-09-26','14:10:00',3.74),('12664','2013-09-26','14:15:00',1.86),('12664','2013-09-26','14:20:00',2.88),('12664','2013-09-26','14:25:00',3.91),('12664','2013-09-26','14:30:00',3.49),('12664','2013-09-26','14:35:00',3.44),('12664','2013-09-26','14:40:00',3.45),('12664','2013-09-26','14:45:00',3.46),('12664','2013-09-26','14:50:00',3.42),('12664','2013-09-26','14:55:00',3.46),('12664','2013-09-26','15:00:00',3.56),('12664','2013-09-26','15:05:00',3.4),('12664','2013-09-26','15:10:00',3.36),('12664','2013-09-26','15:15:00',3.23),('12664','2013-09-26','15:20:00',3.1),('12664','2013-09-26','15:25:00',3.01),('12664','2013-09-26','15:30:00',2.97),('12664','2013-09-26','15:35:00',2.85),('12664','2013-09-26','15:40:00',2.8),('12664','2013-09-26','15:45:00',2.79),('12664','2013-09-26','15:50:00',2.69),('12664','2013-09-26','15:55:00',2.54),('12664','2013-09-26','16:00:00',2.51),('12664','2013-09-26','16:05:00',1.89),('12664','2013-09-26','16:10:00',2.32),('12664','2013-09-26','16:15:00',2.05),('12664','2013-09-26','16:20:00',2.23),('12664','2013-09-26','16:25:00',2.12),('12664','2013-09-26','16:30:00',2.05),('12664','2013-09-26','16:35:00',1.95),('12664','2013-09-26','16:40:00',1.85),('12664','2013-09-26','16:45:00',1.77),('12664','2013-09-26','16:50:00',1.68),('12664','2013-09-26','16:55:00',1.62),('12664','2013-09-26','17:00:00',1.54),('12664','2013-09-26','17:05:00',1.57),('12664','2013-09-26','17:10:00',1.52),('12664','2013-09-26','17:15:00',1.29),('12664','2013-09-26','17:20:00',1.19),('12664','2013-09-26','17:25:00',1.08),('12664','2013-09-25','08:20:00',1.18),('12664','2013-09-25','08:25:00',1.12),('12664','2013-09-25','08:35:00',1.25),('12664','2013-09-25','08:40:00',1.07),('12664','2013-09-25','08:45:00',1.29),('12664','2013-09-25','08:50:00',1.44),('12664','2013-09-25','08:55:00',1.17),('12664','2013-09-25','10:00:00',1.14),('12664','2013-09-25','10:05:00',1.49),('12664','2013-09-25','10:10:00',2.86),('12664','2013-09-25','10:15:00',2.97),('12664','2013-09-25','10:20:00',3.03),('12664','2013-09-25','10:25:00',3.05),('12664','2013-09-25','10:30:00',3.13),('12664','2013-09-25','10:35:00',3.25),('12664','2013-09-25','10:40:00',3.57),('12664','2013-09-25','10:45:00',1.65),('12664','2013-09-25','10:50:00',2.7),('12664','2013-09-25','10:55:00',2.78),('12664','2013-09-25','11:10:00',2.94),('12664','2013-09-25','11:15:00',3.99),('12664','2013-09-25','11:20:00',4.06),('12664','2013-09-25','11:25:00',3.32),('12664','2013-09-25','11:30:00',1.67),('12664','2013-09-25','11:35:00',4.25),('12664','2013-09-25','11:40:00',2.79),('12664','2013-09-25','11:55:00',1.51),('12664','2013-09-25','12:00:00',3.29),('12664','2013-09-25','12:05:00',3.99),('12664','2013-09-25','12:10:00',4.19),('12664','2013-09-25','12:15:00',3.26),('12664','2013-09-25','12:20:00',3.82),('12664','2013-09-25','12:25:00',4.19),('12664','2013-09-25','12:30:00',4.11),('12664','2013-09-25','12:35:00',4.12),('12664','2013-09-25','12:40:00',4.21),('12664','2013-09-25','12:45:00',4.3),('12664','2013-09-25','12:50:00',4.36),('12664','2013-09-25','12:55:00',3.72),('12664','2013-09-25','13:00:00',4.23),('12664','2013-09-25','13:05:00',1.4),('12664','2013-09-25','13:10:00',1.51),('12664','2013-09-25','13:15:00',3.72),('12664','2013-09-25','13:20:00',4.19),('12664','2013-09-25','13:25:00',4.26),('12664','2013-09-25','13:30:00',4.12),('12664','2013-09-25','13:35:00',1.79),('12664','2013-09-25','13:40:00',2.65),('12664','2013-09-25','13:45:00',4.46),('12664','2013-09-25','13:50:00',4.23),('12664','2013-09-25','13:55:00',4.15),('12664','2013-09-25','14:00:00',4.07),('12664','2013-09-25','14:05:00',3.09),('12664','2013-09-25','14:10:00',3.71),('12664','2013-09-25','14:15:00',1.74),('12664','2013-09-25','14:20:00',1.22),('12664','2013-09-25','14:25:00',2.27),('12664','2013-09-25','14:30:00',4.02),('12664','2013-09-25','14:35:00',3.1),('12664','2013-09-25','14:45:00',1.19),('12664','2013-09-25','14:50:00',2.91),('12664','2013-09-25','14:55:00',3.66),('12664','2013-09-25','15:00:00',3.22),('12664','2013-09-25','15:05:00',2.97),('12664','2013-09-25','15:10:00',3.34),('12664','2013-09-25','15:15:00',3.16),('12664','2013-09-25','15:20:00',3.31),('12664','2013-09-25','15:25:00',3.21),('12664','2013-09-25','15:30:00',2.71),('12664','2013-09-25','15:35:00',3.22),('12664','2013-09-25','15:40:00',3.05),('12664','2013-09-25','15:45:00',2.81),('12664','2013-09-25','15:50:00',2.91),('12664','2013-09-25','15:55:00',2.89),('12664','2013-09-25','16:00:00',2.11),('12664','2013-09-25','16:05:00',2.15),('12664','2013-09-25','16:10:00',2.65),('12664','2013-09-25','16:15:00',2.45),('12664','2013-09-25','16:20:00',2.28),('12664','2013-09-25','16:25:00',2.31),('12664','2013-09-25','16:30:00',2.18),('12664','2013-09-25','16:35:00',2.11),('12664','2013-09-25','16:40:00',2.01),('12664','2013-09-25','16:45:00',1.9),('12664','2013-09-25','16:50:00',1.82),('12664','2013-09-25','16:55:00',1.71),('12664','2013-09-25','17:00:00',1.64),('12664','2013-09-25','17:05:00',1.54),('12664','2013-09-25','17:10:00',1.44),('12664','2013-09-25','17:15:00',1.34),('12664','2013-09-25','17:20:00',1.25),('12664','2013-09-25','17:25:00',1.15),('12664','2013-09-25','17:30:00',1.06),('12664','2013-09-24','08:20:00',1.05),('12664','2013-09-24','08:25:00',1.16),('12664','2013-09-24','08:30:00',1.26),('12664','2013-09-24','08:35:00',1.36),('12664','2013-09-24','08:40:00',1.45),('12664','2013-09-24','08:45:00',1.54),('12664','2013-09-24','08:50:00',1.64),('12664','2013-09-24','08:55:00',1.73),('12664','2013-09-24','09:00:00',1.83),('12664','2013-09-24','09:05:00',1.92),('12664','2013-09-24','09:10:00',2.01),('12664','2013-09-24','09:15:00',2.1),('12664','2013-09-24','09:20:00',2.17),('12664','2013-09-24','09:25:00',2.25),('12664','2013-09-24','09:30:00',2.34),('12664','2013-09-24','09:35:00',2.42),('12664','2013-09-24','09:40:00',2.49),('12664','2013-09-24','09:45:00',2.55),('12664','2013-09-24','09:50:00',2.63),('12664','2013-09-24','09:55:00',2.71),('12664','2013-09-24','10:00:00',2.77),('12664','2013-09-24','10:05:00',2.85),('12664','2013-09-24','10:10:00',2.92),('12664','2013-09-24','10:15:00',3),('12664','2013-09-24','10:20:00',3.07),('12664','2013-09-24','10:25:00',3.12),('12664','2013-09-24','10:30:00',3.17),('12664','2013-09-24','10:35:00',3.21),('12664','2013-09-24','10:40:00',3.28),('12664','2013-09-24','10:45:00',3.32),('12664','2013-09-24','10:50:00',3.36),('12664','2013-09-24','10:55:00',3.41),('12664','2013-09-24','11:00:00',3.44),('12664','2013-09-24','11:05:00',3.47),('12664','2013-09-24','11:10:00',3.52),('12664','2013-09-24','11:15:00',3.57),('12664','2013-09-24','11:20:00',3.59),('12664','2013-09-24','11:25:00',3.62),('12664','2013-09-24','11:30:00',3.65),('12664','2013-09-24','11:35:00',3.68),('12664','2013-09-24','11:40:00',3.7),('12664','2013-09-24','11:45:00',3.7),('12664','2013-09-24','11:50:00',3.74),('12664','2013-09-24','11:55:00',3.77),('12664','2013-09-24','12:00:00',3.8),('12664','2013-09-24','12:05:00',3.8),('12664','2013-09-24','12:10:00',3.82),('12664','2013-09-24','12:15:00',3.85),('12664','2013-09-24','12:20:00',3.88),('12664','2013-09-24','12:25:00',3.89),('12664','2013-09-24','12:30:00',3.87),('12664','2013-09-24','12:35:00',3.89),('12664','2013-09-24','12:40:00',3.89),('12664','2013-09-24','12:45:00',3.88),('12664','2013-09-24','12:50:00',3.9),('12664','2013-09-24','12:55:00',3.91),('12664','2013-09-24','13:00:00',3.91),('12664','2013-09-24','13:05:00',3.9),('12664','2013-09-24','13:10:00',3.88),('12664','2013-09-24','13:15:00',3.89),('12664','2013-09-24','13:20:00',3.85),('12664','2013-09-24','13:25:00',3.84),('12664','2013-09-24','13:30:00',3.88),('12664','2013-09-24','13:35:00',3.84),('12664','2013-09-24','13:40:00',3.81),('12664','2013-09-24','13:45:00',3.81),('12664','2013-09-24','13:50:00',3.8),('12664','2013-09-24','13:55:00',3.82),('12664','2013-09-24','14:00:00',3.82),('12664','2013-09-24','14:05:00',3.79),('12664','2013-09-24','14:10:00',3.77),('12664','2013-09-24','14:15:00',3.75),('12664','2013-09-24','14:20:00',3.69),('12664','2013-09-24','14:25:00',3.68),('12664','2013-09-24','14:30:00',3.62),('12664','2013-09-24','14:35:00',3.61),('12664','2013-09-24','14:40:00',3.58),('12664','2013-09-24','14:45:00',3.55),('12664','2013-09-24','14:50:00',3.48),('12664','2013-09-24','14:55:00',3.41),('12664','2013-09-24','15:00:00',3.37),('12664','2013-09-24','15:05:00',3.36),('12664','2013-09-24','15:10:00',3.27),('12664','2013-09-24','15:15:00',3.22),('12664','2013-09-24','15:20:00',3.21),('12664','2013-09-24','15:25:00',3.15),('12664','2013-09-24','15:30:00',3.09),('12664','2013-09-24','15:35:00',3.02),('12664','2013-09-24','15:40:00',2.96),('12664','2013-09-24','15:45:00',2.9),('12664','2013-09-24','15:50:00',2.83),('12664','2013-09-24','15:55:00',2.75),('12664','2013-09-24','16:00:00',2.69),('12664','2013-09-24','16:05:00',2.63),('12664','2013-09-24','16:10:00',2.54),('12664','2013-09-24','16:15:00',2.46),('12664','2013-09-24','16:20:00',2.38),('12664','2013-09-24','16:25:00',2.3),('12664','2013-09-24','16:30:00',2.22),('12664','2013-09-24','16:35:00',2.13),('12664','2013-09-24','16:40:00',2.06),('12664','2013-09-24','16:45:00',1.98),('12664','2013-09-24','16:50:00',1.89),('12664','2013-09-24','16:55:00',1.81),('12664','2013-09-24','17:00:00',1.7),('12664','2013-09-24','17:05:00',1.61),('12664','2013-09-24','17:10:00',1.51),('12664','2013-09-24','17:15:00',1.41),('12664','2013-09-24','17:20:00',1.32),('12664','2013-09-24','17:25:00',1.22),('12664','2013-09-24','17:30:00',1.11),('12664','2013-09-24','17:35:00',1.01),('12664','2013-09-23','08:20:00',1.1),('12664','2013-09-23','08:25:00',1.2),('12664','2013-09-23','08:30:00',1.31),('12664','2013-09-23','08:35:00',1.41),('12664','2013-09-23','08:40:00',1.51),('12664','2013-09-23','08:45:00',1.61),('12664','2013-09-23','08:50:00',1.71),('12664','2013-09-23','08:55:00',1.8),('12664','2013-09-23','09:00:00',1.89),('12664','2013-09-23','09:05:00',1.98),('12664','2013-09-23','09:10:00',2.08),('12664','2013-09-23','09:15:00',2.16),('12664','2013-09-23','09:20:00',2.25),('12664','2013-09-23','09:25:00',2.33),('12664','2013-09-23','09:30:00',2.4),('12664','2013-09-23','09:35:00',2.48),('12664','2013-09-23','09:40:00',2.56),('12664','2013-09-23','09:45:00',2.64),('12664','2013-09-23','09:50:00',2.71),('12664','2013-09-23','09:55:00',2.77),('12664','2013-09-23','10:00:00',2.83),('12664','2013-09-23','10:05:00',2.88),('12664','2013-09-23','10:10:00',2.94),('12664','2013-09-23','10:15:00',3.01),('12664','2013-09-23','10:20:00',3.07),('12664','2013-09-23','10:25:00',3.12),('12664','2013-09-23','10:30:00',3.18),('12664','2013-09-23','10:35:00',3.24),('12664','2013-09-23','10:40:00',3.29),('12664','2013-09-23','10:45:00',3.38),('12664','2013-09-23','10:50:00',3.43),('12664','2013-09-23','10:55:00',3.49),('12664','2013-09-23','11:00:00',3.56),('12664','2013-09-23','11:05:00',3.6),('12664','2013-09-23','11:10:00',3.6),('12664','2013-09-23','11:15:00',3.63),('12664','2013-09-23','11:20:00',3.66),('12664','2013-09-23','11:25:00',3.68),('12664','2013-09-23','11:30:00',3.71),('12664','2013-09-23','11:35:00',3.75),('12664','2013-09-23','11:40:00',3.8),('12664','2013-09-23','11:45:00',3.83),('12664','2013-09-23','11:50:00',3.84),('12664','2013-09-23','11:55:00',3.86),('12664','2013-09-23','12:00:00',3.85),('12664','2013-09-23','12:05:00',3.85),('12664','2013-09-23','12:10:00',3.88),('12664','2013-09-23','12:15:00',3.94),('12664','2013-09-23','12:20:00',3.93),('12664','2013-09-23','12:25:00',3.85),('12664','2013-09-23','12:30:00',3.92),('12664','2013-09-23','12:35:00',3.98),('12664','2013-09-23','12:40:00',3.98),('12664','2013-09-23','12:45:00',3.97),('12664','2013-09-23','12:50:00',3.96),('12664','2013-09-23','12:55:00',3.95),('12664','2013-09-23','13:00:00',3.92),('12664','2013-09-23','13:05:00',3.93),('12664','2013-09-23','13:10:00',3.89),('12664','2013-09-23','13:15:00',3.86),('12664','2013-09-23','13:20:00',3.9),('12664','2013-09-23','13:25:00',3.84),('12664','2013-09-23','13:30:00',3.82),('12664','2013-09-23','13:35:00',3.82),('12664','2013-09-23','13:40:00',3.79),('12664','2013-09-23','13:45:00',3.76),('12664','2013-09-23','13:50:00',3.76),('12664','2013-09-23','13:55:00',3.72),('12664','2013-09-23','14:00:00',3.56),('12664','2013-09-23','14:05:00',3.66),('12664','2013-09-23','14:10:00',3.67),('12664','2013-09-23','14:15:00',3.63),('12664','2013-09-23','14:20:00',3.66),('12664','2013-09-23','14:25:00',3.6),('12664','2013-09-23','14:30:00',3.53),('12664','2013-09-23','14:35:00',3.46),('12664','2013-09-23','14:40:00',3.46),('12664','2013-09-23','14:45:00',3.4),('12664','2013-09-23','14:50:00',3.36),('12664','2013-09-23','14:55:00',3.3),('12664','2013-09-23','15:00:00',3.26),('12664','2013-09-23','15:05:00',3.18),('12664','2013-09-23','15:10:00',3.18),('12664','2013-09-23','15:15:00',3.15),('12664','2013-09-23','15:20:00',3.08),('12664','2013-09-23','15:25:00',3.02),('12664','2013-09-23','15:30:00',3),('12664','2013-09-23','15:35:00',2.94),('12664','2013-09-23','15:40:00',2.89),('12664','2013-09-23','15:45:00',2.8),('12664','2013-09-23','15:50:00',2.74),('12664','2013-09-23','15:55:00',2.67),('12664','2013-09-23','16:00:00',2.57),('12664','2013-09-23','16:05:00',2.55),('12664','2013-09-23','16:10:00',2.49),('12664','2013-09-23','16:15:00',2.42),('12664','2013-09-23','16:20:00',2.34),('12664','2013-09-23','16:25:00',2.26),('12664','2013-09-23','16:30:00',2.18),('12664','2013-09-23','16:35:00',2.08),('12664','2013-09-23','16:40:00',2.01),('12664','2013-09-23','16:45:00',1.93),('12664','2013-09-23','16:50:00',1.84),('12664','2013-09-23','16:55:00',1.75),('12664','2013-09-23','17:00:00',1.66),('12664','2013-09-23','17:05:00',1.55),('12664','2013-09-23','17:10:00',1.46),('12664','2013-09-23','17:15:00',1.37),('12664','2013-09-23','17:20:00',1.28),('12664','2013-09-23','17:25:00',1.17),('12664','2013-09-23','17:30:00',1.08),('12664','2013-09-22','08:20:00',1.04),('12664','2013-09-22','08:25:00',1.14),('12664','2013-09-22','08:30:00',1.25),('12664','2013-09-22','08:35:00',1.35),('12664','2013-09-22','08:40:00',1.46),('12664','2013-09-22','08:45:00',1.56),('12664','2013-09-22','08:50:00',1.67),('12664','2013-09-22','08:55:00',1.76),('12664','2013-09-22','09:00:00',1.86),('12664','2013-09-22','09:05:00',1.95),('12664','2013-09-22','09:10:00',2.04),('12664','2013-09-22','09:15:00',2.12),('12664','2013-09-22','09:20:00',2.21),('12664','2013-09-22','09:25:00',2.3),('12664','2013-09-22','09:30:00',2.4),('12664','2013-09-22','09:35:00',2.49),('12664','2013-09-22','09:40:00',2.57),('12664','2013-09-22','09:45:00',2.64),('12664','2013-09-22','09:50:00',2.72),('12664','2013-09-22','09:55:00',2.79),('12664','2013-09-22','10:00:00',2.86),('12664','2013-09-22','10:05:00',2.92),('12664','2013-09-22','10:10:00',2.99),('12664','2013-09-22','10:15:00',3.08),('12664','2013-09-22','10:20:00',3.16),('12664','2013-09-22','10:25:00',3.22),('12664','2013-09-22','10:30:00',3.27),('12664','2013-09-22','10:35:00',3.32),('12664','2013-09-22','10:40:00',3.37),('12664','2013-09-22','10:45:00',3.43),('12664','2013-09-22','10:50:00',3.5),('12664','2013-09-22','10:55:00',3.55),('12664','2013-09-22','11:00:00',3.59),('12664','2013-09-22','11:05:00',3.63),('12664','2013-09-22','11:10:00',3.68),('12664','2013-09-22','11:15:00',3.69),('12664','2013-09-22','11:20:00',3.73),('12664','2013-09-22','11:25:00',3.77),('12664','2013-09-22','11:30:00',3.79),('12664','2013-09-22','11:35:00',3.81),('12664','2013-09-22','11:40:00',3.84),('12664','2013-09-22','11:45:00',3.86),('12664','2013-09-22','11:50:00',3.89),('12664','2013-09-22','11:55:00',3.9),('12664','2013-09-22','12:00:00',3.9),('12664','2013-09-22','12:05:00',3.93),('12664','2013-09-22','12:10:00',3.98),('12664','2013-09-22','12:15:00',3.99),('12664','2013-09-22','12:20:00',4.01),('12664','2013-09-22','12:25:00',4.02),('12664','2013-09-22','12:30:00',4.02),('12664','2013-09-22','12:35:00',4.05),('12664','2013-09-22','12:40:00',4.05),('12664','2013-09-22','12:45:00',4.04),('12664','2013-09-22','12:50:00',4.07),('12664','2013-09-22','12:55:00',4.06),('12664','2013-09-22','13:00:00',4.05),('12664','2013-09-22','13:05:00',4.07),('12664','2013-09-22','13:10:00',4.05),('12664','2013-09-22','13:15:00',4.03),('12664','2013-09-22','13:20:00',4.05),('12664','2013-09-22','13:25:00',4.07),('12664','2013-09-22','13:30:00',4.14),('12664','2013-09-22','13:35:00',4.26),('12664','2013-09-22','13:40:00',4.25),('12664','2013-09-22','13:45:00',4.25),('12664','2013-09-22','13:50:00',3.81),('12664','2013-09-22','13:55:00',2.96),('12664','2013-09-22','14:00:00',4.29),('12664','2013-09-22','14:05:00',4.07),('12664','2013-09-22','14:10:00',3.96),('12664','2013-09-22','14:15:00',3.87),('12664','2013-09-22','14:20:00',3.93),('12664','2013-09-22','14:25:00',4),('12664','2013-09-22','14:30:00',3.28),('12664','2013-09-22','14:35:00',2.83),('12664','2013-09-22','14:40:00',2.24),('12664','2013-09-22','14:45:00',3.86),('12664','2013-09-22','14:50:00',3.74),('12664','2013-09-22','14:55:00',3.55),('12664','2013-09-22','15:00:00',1.29),('12664','2013-09-22','15:05:00',1.22),('12664','2013-09-22','15:10:00',2.65),('12664','2013-09-22','15:15:00',2.52),('12664','2013-09-22','15:20:00',2.22),('12664','2013-09-22','15:25:00',1.31),('12664','2013-09-22','15:30:00',1.61),('12664','2013-09-22','15:35:00',2.88),('12664','2013-09-22','15:40:00',2.9),('12664','2013-09-22','15:45:00',3.13),('12664','2013-09-22','15:50:00',3.13),('12664','2013-09-22','15:55:00',2.51),('12664','2013-09-22','16:00:00',2.42),('12664','2013-09-22','16:05:00',3.19),('12664','2013-09-22','16:10:00',2.35),('12664','2013-09-22','16:15:00',1.71),('12664','2013-09-22','16:20:00',1.71),('12664','2013-09-22','16:25:00',1.13),('12664','2013-09-22','16:35:00',1.24),('12664','2013-09-22','16:40:00',1.87),('12664','2013-09-22','16:45:00',1.63),('12664','2013-09-22','16:50:00',2.34),('12664','2013-09-22','16:55:00',2.05),('12664','2013-09-22','17:00:00',1.68),('12664','2013-09-22','17:05:00',1.66),('12664','2013-09-22','17:10:00',1.56),('12664','2013-09-22','17:15:00',1.47),('12664','2013-09-22','17:20:00',1.4),('12664','2013-09-22','17:25:00',1.3),('12664','2013-09-22','17:30:00',1.15),('12664','2013-09-22','17:35:00',1.01),('12664','2013-09-21','08:20:00',1.06),('12664','2013-09-21','08:25:00',1.16),('12664','2013-09-21','08:30:00',1.26),('12664','2013-09-21','08:35:00',1.36),('12664','2013-09-21','08:40:00',1.46),('12664','2013-09-21','08:45:00',1.55),('12664','2013-09-21','08:50:00',1.65),('12664','2013-09-21','08:55:00',1.74),('12664','2013-09-21','09:00:00',1.83),('12664','2013-09-21','09:05:00',1.92),('12664','2013-09-21','09:10:00',2),('12664','2013-09-21','09:15:00',2.1),('12664','2013-09-21','09:20:00',2.19),('12664','2013-09-21','09:25:00',2.28),('12664','2013-09-21','09:30:00',2.36),('12664','2013-09-21','09:35:00',2.44),('12664','2013-09-21','09:40:00',2.53),('12664','2013-09-21','09:45:00',2.6),('12664','2013-09-21','09:50:00',2.61),('12664','2013-09-21','09:55:00',2.72),('12664','2013-09-21','10:00:00',2.79),('12664','2013-09-21','10:05:00',2.86),('12664','2013-09-21','10:10:00',2.91),('12664','2013-09-21','10:15:00',2.97),('12664','2013-09-21','10:20:00',3.03),('12664','2013-09-21','10:25:00',3.09),('12664','2013-09-21','10:30:00',3.14),('12664','2013-09-21','10:35:00',3.2),('12664','2013-09-21','10:40:00',3.25),('12664','2013-09-21','10:45:00',3.29),('12664','2013-09-21','10:50:00',3.35),('12664','2013-09-21','10:55:00',3.38),('12664','2013-09-21','11:00:00',3.42),('12664','2013-09-21','11:05:00',3.46),('12664','2013-09-21','11:10:00',3.5),('12664','2013-09-21','11:15:00',3.53),('12664','2013-09-21','11:20:00',3.57),('12664','2013-09-21','11:25:00',3.6),('12664','2013-09-21','11:30:00',3.64),('12664','2013-09-21','11:35:00',3.67),('12664','2013-09-21','11:40:00',3.7),('12664','2013-09-21','11:45:00',3.54),('12664','2013-09-21','11:50:00',3.75),('12664','2013-09-21','11:55:00',3.81),('12664','2013-09-21','12:00:00',3.83),('12664','2013-09-21','12:05:00',3.84),('12664','2013-09-21','12:10:00',3.8),('12664','2013-09-21','12:15:00',3.29),('12664','2013-09-21','12:20:00',3.07),('12664','2013-09-21','12:25:00',3.98),('12664','2013-09-21','12:30:00',3.8),('12664','2013-09-21','12:35:00',3.66),('12664','2013-09-21','12:40:00',3.23),('12664','2013-09-21','12:45:00',3.94),('12664','2013-09-21','12:50:00',3.64),('12664','2013-09-21','12:55:00',2.69),('12664','2013-09-21','13:00:00',3.85),('12664','2013-09-21','13:05:00',3.69),('12664','2013-09-21','13:10:00',3.87),('12664','2013-09-21','13:15:00',3.26),('12664','2013-09-21','13:20:00',2.87),('12664','2013-09-21','13:25:00',3.61),('12664','2013-09-21','13:30:00',3.14),('12664','2013-09-21','13:35:00',3.44),('12664','2013-09-21','13:40:00',3.85),('12664','2013-09-21','13:45:00',3.85),('12664','2013-09-21','13:50:00',3.81),('12664','2013-09-21','13:55:00',3.75),('12664','2013-09-21','14:00:00',3.59),('12664','2013-09-21','14:05:00',3.74),('12664','2013-09-21','14:10:00',3.5),('12664','2013-09-21','14:15:00',3.64),('12664','2013-09-21','14:20:00',3.64),('12664','2013-09-21','14:25:00',3.57),('12664','2013-09-21','14:30:00',3.51),('12664','2013-09-21','14:35:00',3.44),('12664','2013-09-21','14:40:00',3.46),('12664','2013-09-21','14:45:00',3.41),('12664','2013-09-21','14:50:00',3.37),('12664','2013-09-21','14:55:00',3.34),('12664','2013-09-21','15:00:00',3.04),('12664','2013-09-21','15:05:00',3.27),('12664','2013-09-21','15:10:00',3.2),('12664','2013-09-21','15:15:00',3.11),('12664','2013-09-21','15:20:00',3.07),('12664','2013-09-21','15:25:00',3.03),('12664','2013-09-21','15:30:00',2.95),('12664','2013-09-21','15:35:00',2.92),('12664','2013-09-21','15:40:00',2.9),('12664','2013-09-21','15:45:00',2.84),('12664','2013-09-21','15:50:00',2.73),('12664','2013-09-21','15:55:00',1.84),('12664','2013-09-21','16:00:00',2.12),('12664','2013-09-21','16:05:00',1.49),('12664','2013-09-21','16:10:00',2.1),('12664','2013-09-21','16:15:00',1.42),('12664','2013-09-21','16:20:00',1.11),('12664','2013-09-21','16:25:00',1.83),('12664','2013-09-21','16:30:00',1.72),('12664','2013-09-21','16:45:00',1.14),('12664','2013-09-21','16:55:00',1.1),('12664','2013-09-21','17:00:00',1.13),('12664','2013-09-21','17:05:00',1.02),('12664','2013-09-21','17:10:00',1.36),('12664','2013-09-21','17:35:00',1),('12664','2013-09-20','08:40:00',1.13),('12664','2013-09-20','08:45:00',1.58),('12664','2013-09-20','09:40:00',1.05),('12664','2013-09-20','09:45:00',1.2),('12664','2013-09-20','09:50:00',1.44),('12664','2013-09-20','09:55:00',1.34),('12664','2013-09-20','10:00:00',1.46),('12664','2013-09-20','10:05:00',1.88),('12664','2013-09-20','10:10:00',1.82),('12664','2013-09-20','10:15:00',3.66),('12664','2013-09-20','10:20:00',2.98),('12664','2013-09-20','10:25:00',2.56),('12664','2013-09-20','10:30:00',2.01),('12664','2013-09-20','10:35:00',2.04),('12664','2013-09-20','10:40:00',2.1),('12664','2013-09-20','10:45:00',2.27),('12664','2013-09-20','10:50:00',3.07),('12664','2013-09-20','10:55:00',3.18),('12664','2013-09-20','11:00:00',2.76),('12664','2013-09-20','11:05:00',2.97),('12664','2013-09-20','11:10:00',2.33),('12664','2013-09-20','11:15:00',2.25),('12664','2013-09-20','11:20:00',2.77),('12664','2013-09-20','11:25:00',2.47),('12664','2013-09-20','11:30:00',2.64),('12664','2013-09-20','11:35:00',2.54),('12664','2013-09-20','11:40:00',4.09),('12664','2013-09-20','11:45:00',3.1),('12664','2013-09-20','11:50:00',3.09),('12664','2013-09-20','11:55:00',2.83),('12664','2013-09-20','12:00:00',4.44),('12664','2013-09-20','12:05:00',4.2),('12664','2013-09-20','12:10:00',4.05),('12664','2013-09-20','12:15:00',4.01),('12664','2013-09-20','12:20:00',4.02),('12664','2013-09-20','12:25:00',4.16),('12664','2013-09-20','12:30:00',4.06),('12664','2013-09-20','12:35:00',3.97),('12664','2013-09-20','12:40:00',3.46),('12664','2013-09-20','12:45:00',4.03),('12664','2013-09-20','12:50:00',3.98),('12664','2013-09-20','12:55:00',3.87),('12664','2013-09-20','13:00:00',3.84),('12664','2013-09-20','13:05:00',3.87),('12664','2013-09-20','13:10:00',3.88),('12664','2013-09-20','13:15:00',3.87),('12664','2013-09-20','13:20:00',3.87),('12664','2013-09-20','13:25:00',3.88),('12664','2013-09-20','13:30:00',3.9),('12664','2013-09-20','13:35:00',3.91),('12664','2013-09-20','13:40:00',3.87),('12664','2013-09-20','13:45:00',3.63),('12664','2013-09-20','13:50:00',3.77),('12664','2013-09-20','13:55:00',3.49),('12664','2013-09-20','14:00:00',3.91),('12664','2013-09-20','14:05:00',2.47),('12664','2013-09-20','14:10:00',3.94),('12664','2013-09-20','14:15:00',3.81),('12664','2013-09-20','14:20:00',3.77),('12664','2013-09-20','14:25:00',3.75),('12664','2013-09-20','14:30:00',3.7),('12664','2013-09-20','14:35:00',3.69),('12664','2013-09-20','14:40:00',3.73),('12664','2013-09-20','14:45:00',3.37),('12664','2013-09-20','14:50:00',2.35),('12664','2013-09-20','14:55:00',2.38),('12664','2013-09-20','15:00:00',1.95),('12664','2013-09-20','15:05:00',2.92),('12664','2013-09-20','15:10:00',2.16),('12664','2013-09-20','15:15:00',2.7),('12664','2013-09-20','15:20:00',2.17),('12664','2013-09-20','15:25:00',1.95),('12664','2013-09-20','15:30:00',1.63),('12664','2013-09-20','15:35:00',1.47),('12664','2013-09-20','15:40:00',2.86),('12664','2013-09-20','15:45:00',2.47),('12664','2013-09-20','15:50:00',2.2),('12664','2013-09-20','15:55:00',2.39),('12664','2013-09-20','16:00:00',2.9),('12664','2013-09-20','16:05:00',2.93),('12664','2013-09-20','16:10:00',2.88),('12664','2013-09-20','16:15:00',2.33),('12664','2013-09-20','16:20:00',1.83),('12664','2013-09-20','16:25:00',1.28),('12664','2013-09-20','16:30:00',1.28),('12664','2013-09-20','16:40:00',1.48),('12664','2013-09-20','16:45:00',1.99),('12664','2013-09-20','16:50:00',1.95),('12664','2013-09-20','16:55:00',2.05),('12664','2013-09-20','17:00:00',1.92),('12664','2013-09-20','17:05:00',1.85),('12664','2013-09-20','17:10:00',1.8),('12664','2013-09-20','17:15:00',1.78),('12664','2013-09-20','17:20:00',1.75),('12664','2013-09-20','17:25:00',1.36),('12664','2013-09-20','17:30:00',1.61),('12664','2013-09-20','17:35:00',1.6),('12664','2013-09-20','17:40:00',1.52),('12664','2013-09-20','17:45:00',1.47),('12664','2013-09-20','17:50:00',1.03),('12664','2013-09-19','08:25:00',1.14),('12664','2013-09-19','08:30:00',1.28),('12664','2013-09-19','08:35:00',1.52),('12664','2013-09-19','08:40:00',1.51),('12664','2013-09-19','08:50:00',1.02),('12664','2013-09-19','08:55:00',1.27),('12664','2013-09-19','09:00:00',1.81),('12664','2013-09-19','09:05:00',1.83),('12664','2013-09-19','09:15:00',1.07),('12664','2013-09-19','09:20:00',1.22),('12664','2013-09-19','09:25:00',1.62),('12664','2013-09-19','09:30:00',1.19),('12664','2013-09-19','09:35:00',1.85),('12664','2013-09-19','09:40:00',2.94),('12664','2013-09-19','09:45:00',2.21),('12664','2013-09-19','09:50:00',1.8),('12664','2013-09-19','09:55:00',1.22),('12664','2013-09-19','10:00:00',1.75),('12664','2013-09-19','10:05:00',1.81),('12664','2013-09-19','10:10:00',2.58),('12664','2013-09-19','10:15:00',2.95),('12664','2013-09-19','10:20:00',2.96),('12664','2013-09-19','10:25:00',1.1),('12664','2013-09-19','10:40:00',1.1),('12664','2013-09-19','10:45:00',1.5),('12664','2013-09-19','10:50:00',1.67),('12664','2013-09-19','10:55:00',3.74),('12664','2013-09-19','11:00:00',3.78),('12664','2013-09-19','11:05:00',1.81),('12664','2013-09-19','11:10:00',1.27),('12664','2013-09-19','11:15:00',4.05),('12664','2013-09-19','11:20:00',3.73),('12664','2013-09-19','11:25:00',3.13),('12664','2013-09-19','11:30:00',2.78),('12664','2013-09-19','11:35:00',2.77),('12664','2013-09-19','11:40:00',2.15),('12664','2013-09-19','11:45:00',3.43),('12664','2013-09-19','11:50:00',4.36),('12664','2013-09-19','11:55:00',3.19),('12664','2013-09-19','12:00:00',3.11),('12664','2013-09-19','12:05:00',3.44),('12664','2013-09-19','12:10:00',2.67),('12664','2013-09-19','12:15:00',2.39),('12664','2013-09-19','12:20:00',3.21),('12664','2013-09-19','12:25:00',4.32),('12664','2013-09-19','12:30:00',4.39),('12664','2013-09-19','12:35:00',2.33),('12664','2013-09-19','12:40:00',1.31),('12664','2013-09-19','12:45:00',4.44),('12664','2013-09-19','12:50:00',4.46),('12664','2013-09-19','12:55:00',4.57),('12664','2013-09-19','13:00:00',2.32),('12664','2013-09-19','13:05:00',4.42),('12664','2013-09-19','13:10:00',4.32),('12664','2013-09-19','13:15:00',4.31),('12664','2013-09-19','13:20:00',4.23),('12664','2013-09-19','13:25:00',4.25),('12664','2013-09-19','13:30:00',3.89),('12664','2013-09-19','13:35:00',2.66),('12664','2013-09-19','13:40:00',2.28),('12664','2013-09-19','13:45:00',4.41),('12664','2013-09-19','13:50:00',4.42),('12664','2013-09-19','13:55:00',4.13),('12664','2013-09-19','14:00:00',4.03),('12664','2013-09-19','14:05:00',3.94),('12664','2013-09-19','14:10:00',3.9),('12664','2013-09-19','14:15:00',3.87),('12664','2013-09-19','14:20:00',3.86),('12664','2013-09-19','14:25:00',3.8),('12664','2013-09-19','14:30:00',3.66),('12664','2013-09-19','14:35:00',3.53),('12664','2013-09-19','14:40:00',3.39),('12664','2013-09-19','14:45:00',3.68),('12664','2013-09-19','14:50:00',3.71),('12664','2013-09-19','14:55:00',3.63),('12664','2013-09-19','15:00:00',3.42),('12664','2013-09-19','15:05:00',3.63),('12664','2013-09-19','15:10:00',3.55),('12664','2013-09-19','15:15:00',3.34),('12664','2013-09-19','15:20:00',2.94),('12664','2013-09-19','15:25:00',3.08),('12664','2013-09-19','15:30:00',3.34),('12664','2013-09-19','15:35:00',2.99),('12664','2013-09-19','15:40:00',2.49),('12664','2013-09-19','15:45:00',1.81),('12664','2013-09-19','15:50:00',2.39),('12664','2013-09-19','15:55:00',1.88),('12664','2013-09-19','16:00:00',1.16),('12664','2013-09-19','16:05:00',1.67),('12664','2013-09-19','16:10:00',2.33),('12664','2013-09-19','16:15:00',2.27),('12664','2013-09-19','16:20:00',2.39),('12664','2013-09-19','16:25:00',2.39),('12664','2013-09-19','16:30:00',1.97),('12664','2013-09-19','16:35:00',1.74),('12664','2013-09-19','16:40:00',2.24),('12664','2013-09-19','16:45:00',2.01),('12664','2013-09-19','16:50:00',1.81),('12664','2013-09-19','16:55:00',1.84),('12664','2013-09-19','17:00:00',1.7),('12664','2013-09-19','17:05:00',1.63),('12664','2013-09-19','17:10:00',1.61),('12664','2013-09-19','17:15:00',1.44),('12664','2013-09-19','17:20:00',1.33),('12664','2013-09-19','17:25:00',1.19),('12664','2013-09-18','08:20:00',1.06),('12664','2013-09-18','08:25:00',1.15),('12664','2013-09-18','08:30:00',1.24),('12664','2013-09-18','08:50:00',1.03),('12664','2013-09-18','09:10:00',1.18),('12664','2013-09-18','09:15:00',1.53),('12664','2013-09-18','09:20:00',2.2),('12664','2013-09-18','09:25:00',1.61),('12664','2013-09-18','09:40:00',1.32),('12664','2013-09-18','09:45:00',3.19),('12664','2013-09-18','09:50:00',2.96),('12664','2013-09-18','09:55:00',2.78),('12664','2013-09-18','10:00:00',2.79),('12664','2013-09-18','10:05:00',2.84),('12664','2013-09-18','10:10:00',2.92),('12664','2013-09-18','10:15:00',2.99),('12664','2013-09-18','10:20:00',3.04),('12664','2013-09-18','10:25:00',3.11),('12664','2013-09-18','10:30:00',3.16),('12664','2013-09-18','10:35:00',3.21),('12664','2013-09-18','10:40:00',3.26),('12664','2013-09-18','10:45:00',3.32),('12664','2013-09-18','10:50:00',3.37),('12664','2013-09-18','10:55:00',3.43),('12664','2013-09-18','11:00:00',3.49),('12664','2013-09-18','11:05:00',3.58),('12664','2013-09-18','11:10:00',3.68),('12664','2013-09-18','11:15:00',3.82),('12664','2013-09-18','11:20:00',3.39),('12664','2013-09-18','11:25:00',3.86),('12664','2013-09-18','11:30:00',3.88),('12664','2013-09-18','11:35:00',3.82),('12664','2013-09-18','11:40:00',2.38),('12664','2013-09-18','11:45:00',4.03),('12664','2013-09-18','11:50:00',3.68),('12664','2013-09-18','11:55:00',3.86),('12664','2013-09-18','12:00:00',4),('12664','2013-09-18','12:05:00',4.08),('12664','2013-09-18','12:10:00',4.33),('12664','2013-09-18','12:15:00',4.52),('12664','2013-09-18','12:20:00',4.54),('12664','2013-09-18','12:25:00',4.36),('12664','2013-09-18','12:30:00',2.7),('12664','2013-09-18','12:35:00',2.09),('12664','2013-09-18','12:40:00',1.35),('12664','2013-09-18','12:45:00',2.46),('12664','2013-09-18','12:50:00',4.69),('12664','2013-09-18','12:55:00',3.97),('12664','2013-09-18','13:00:00',1.37),('12664','2013-09-18','13:05:00',3.48),('12664','2013-09-18','13:10:00',4.43),('12664','2013-09-18','13:15:00',4.28),('12664','2013-09-18','13:20:00',4.31),('12664','2013-09-18','13:25:00',4.01),('12664','2013-09-18','13:35:00',3.77),('12664','2013-09-18','13:40:00',3.7),('12664','2013-09-18','13:50:00',4.69),('12664','2013-09-18','13:55:00',4.64),('12664','2013-09-18','14:00:00',4.37),('12664','2013-09-18','14:05:00',1.81),('12664','2013-09-18','14:10:00',2.6),('12664','2013-09-18','14:15:00',3.37),('12664','2013-09-18','14:20:00',3.31),('12664','2013-09-18','14:25:00',3.47),('12664','2013-09-18','14:30:00',3.91),('12664','2013-09-18','14:35:00',3.86),('12664','2013-09-18','14:40:00',3.61),('12664','2013-09-18','14:45:00',2.1),('12664','2013-09-18','14:50:00',2.84),('12664','2013-09-18','14:55:00',1.99),('12664','2013-09-18','15:00:00',2.41),('12664','2013-09-18','15:05:00',2.32),('12664','2013-09-18','15:10:00',1.53),('12664','2013-09-18','15:15:00',1.02),('12664','2013-09-18','15:20:00',1.75),('12664','2013-09-18','15:25:00',3.7),('12664','2013-09-18','15:30:00',1.76),('12664','2013-09-18','15:40:00',3.05),('12664','2013-09-18','15:45:00',3.13),('12664','2013-09-18','15:50:00',3.19),('12664','2013-09-18','15:55:00',1.62),('12664','2013-09-18','16:00:00',2.79),('12664','2013-09-18','16:05:00',1.18),('12664','2013-09-18','16:10:00',3.11),('12664','2013-09-18','16:15:00',2.67),('12664','2013-09-18','16:20:00',2.32),('12664','2013-09-18','16:25:00',2.31),('12664','2013-09-18','16:30:00',2.15),('12664','2013-09-18','16:35:00',2.16),('12664','2013-09-18','16:40:00',1.86),('12664','2013-09-18','16:45:00',1.86),('12664','2013-09-18','16:50:00',1.96),('12664','2013-09-18','16:55:00',1.12),('12664','2013-09-18','17:00:00',1.58),('12664','2013-09-18','17:05:00',1.32),('12664','2013-09-18','17:10:00',1.7),('12664','2013-09-18','17:20:00',1.51),('12664','2013-09-18','17:25:00',1.47),('12664','2013-09-18','17:30:00',1.27),('12664','2013-09-18','17:35:00',1.14),('12664','2014-04-12','08:40:00',1.31),('12664','2014-04-12','08:45:00',1.44),('12664','2014-04-12','08:50:00',1.12),('12664','2014-04-12','08:55:00',1.17),('12664','2014-04-12','09:00:00',1.4),('12664','2014-04-12','09:05:00',1.85),('12664','2014-04-12','09:10:00',1.8),('12664','2014-04-12','09:15:00',1.18),('12664','2014-04-12','09:20:00',1.3),('12664','2014-04-12','09:25:00',1.57),('12664','2014-04-12','09:30:00',2.07),('12664','2014-04-12','09:35:00',1.5),('12664','2014-04-12','09:40:00',1.43),('12664','2014-04-12','09:45:00',1.44),('12664','2014-04-12','09:50:00',1.5),('12664','2014-04-12','09:55:00',1.7),('12664','2014-04-12','10:00:00',2.23),('12664','2014-04-12','10:05:00',2.21),('12664','2014-04-12','10:10:00',1.55),('12664','2014-04-12','10:15:00',1.54),('12664','2014-04-12','10:20:00',1.83),('12664','2014-04-12','10:25:00',1.89),('12664','2014-04-12','10:30:00',1.77),('12664','2014-04-12','10:35:00',1.78),('12664','2014-04-12','10:40:00',2.25),('12664','2014-04-12','10:45:00',2.69),('12664','2014-04-12','10:50:00',2.95),('12664','2014-04-12','10:55:00',3.49),('12664','2014-04-12','11:00:00',3.52),('12664','2014-04-12','11:05:00',3.88),('12664','2014-04-12','11:10:00',3.06),('12664','2014-04-12','11:15:00',3.25),('12664','2014-04-12','11:20:00',2.29),('12664','2014-04-12','11:25:00',1.49),('12664','2014-04-12','11:30:00',1.39),('12664','2014-04-12','11:35:00',1.48),('12664','2014-04-12','11:40:00',1.96),('12664','2014-04-12','11:45:00',3.25),('12664','2014-04-12','11:50:00',1.99),('12664','2014-04-12','11:55:00',2.04),('12664','2014-04-12','12:00:00',2.87),('12664','2014-04-12','12:05:00',1.74),('12664','2014-04-12','12:10:00',1.71),('12664','2014-04-12','12:15:00',3.12),('12664','2014-04-12','12:20:00',3.03),('12664','2014-04-12','12:25:00',2.59),('12664','2014-04-12','12:30:00',2.74),('12664','2014-04-12','12:35:00',3.26),('12664','2014-04-12','12:40:00',3.13),('12664','2014-04-12','12:45:00',3.82),('12664','2014-04-12','12:50:00',3.05),('12664','2014-04-12','12:55:00',3.04),('12664','2014-04-12','13:00:00',3.52),('12664','2014-04-12','13:05:00',2.35),('12664','2014-04-12','13:10:00',3.21),('12664','2014-04-12','13:15:00',3.78),('12664','2014-04-12','13:20:00',4.16),('12664','2014-04-12','13:25:00',2.31),('12664','2014-04-12','13:30:00',4.44),('12664','2014-04-12','13:35:00',2.21),('12664','2014-04-12','13:40:00',1.3),('12664','2014-04-12','13:45:00',3.17),('12664','2014-04-12','13:50:00',4.12),('12664','2014-04-12','13:55:00',2.68),('12664','2014-04-12','14:00:00',3.31),('12664','2014-04-12','14:05:00',3.35),('12664','2014-04-12','14:10:00',2.19),('12664','2014-04-12','14:15:00',3.48),('12664','2014-04-12','14:20:00',3.22),('12664','2014-04-12','14:25:00',2.54),('12664','2014-04-12','14:30:00',2.92),('12664','2014-04-12','14:35:00',3.15),('12664','2014-04-12','14:40:00',3.54),('12664','2014-04-12','14:45:00',3.28),('12664','2014-04-12','14:50:00',3.29),('12664','2014-04-12','14:55:00',3.24),('12664','2014-04-12','15:00:00',3.46),('12664','2014-04-12','15:05:00',3.34),('12664','2014-04-12','15:10:00',3.16),('12664','2014-04-12','15:15:00',2.96),('12664','2014-04-12','15:20:00',2.07),('12664','2014-04-12','15:25:00',2.47),('12664','2014-04-12','15:30:00',2.95),('12664','2014-04-12','15:35:00',3.01),('12664','2014-04-12','15:40:00',3.41),('12664','2014-04-12','15:45:00',3.25),('12664','2014-04-12','15:50:00',3.22),('12664','2014-04-12','15:55:00',3.21),('12664','2014-04-12','16:00:00',3.11),('12664','2014-04-12','16:05:00',3.1),('12664','2014-04-12','16:10:00',2.96),('12664','2014-04-12','16:15:00',2.83),('12664','2014-04-12','16:20:00',2.19),('12664','2014-04-12','16:25:00',1.64),('12664','2014-04-12','16:30:00',2.06),('12664','2014-04-12','16:35:00',1.8),('12664','2014-04-12','16:40:00',2.83),('12664','2014-04-12','16:45:00',2.42),('12664','2014-04-12','16:50:00',2.71),('12664','2014-04-12','16:55:00',2.38),('12664','2014-04-12','17:00:00',2.13),('12664','2014-04-12','17:05:00',2.09),('12664','2014-04-12','17:10:00',1.93),('12664','2014-04-12','17:15:00',1.52),('12664','2014-04-12','17:20:00',1.84),('12664','2014-04-12','17:25:00',1.75),('12664','2014-04-12','17:30:00',1.69),('12664','2014-04-12','17:35:00',1.65),('12664','2014-04-12','17:40:00',1.44),('12664','2014-04-12','17:45:00',1.72),('12664','2014-04-12','17:50:00',1.32),('12664','2014-04-12','17:55:00',1.26),('12664','2014-04-12','18:05:00',1.04),('12664','2013-09-17','09:25:00',1),('12664','2013-09-17','09:30:00',1.13),('12664','2013-09-17','09:40:00',2.84),('12664','2013-09-17','09:45:00',1.16),('12664','2013-09-17','09:50:00',2.29),('12664','2013-09-17','09:55:00',2.08),('12664','2013-09-17','10:00:00',2.18),('12664','2013-09-17','10:05:00',2.14),('12664','2013-09-17','10:15:00',2.35),('12664','2013-09-17','10:20:00',3.94),('12664','2013-09-17','10:25:00',1.69),('12664','2013-09-17','10:30:00',1.67),('12664','2013-09-17','10:35:00',2.67),('12664','2013-09-17','10:40:00',3.97),('12664','2013-09-17','10:45:00',2.02),('12664','2013-09-17','10:50:00',2.12),('12664','2013-09-17','10:55:00',1.94),('12664','2013-09-17','11:00:00',1.77),('12664','2013-09-17','11:05:00',3.27),('12664','2013-09-17','11:10:00',2.09),('12664','2013-09-17','11:15:00',1.49),('12664','2013-09-17','11:20:00',1.68),('12664','2013-09-17','11:25:00',2.2),('12664','2013-09-17','11:30:00',2.36),('12664','2013-09-17','11:35:00',3.7),('12664','2013-09-17','11:40:00',3.47),('12664','2013-09-17','11:45:00',2.37),('12664','2013-09-17','11:50:00',3.11),('12664','2013-09-17','11:55:00',4.44),('12664','2013-09-17','12:00:00',1.74),('12664','2013-09-17','12:05:00',1.28),('12664','2013-09-17','12:10:00',1.76),('12664','2013-09-17','12:15:00',1.83),('12664','2013-09-17','12:20:00',1.48),('12664','2013-09-17','12:25:00',1.09),('12664','2013-09-17','12:30:00',3.28),('12664','2013-09-17','12:35:00',1.59),('12664','2013-09-17','12:40:00',3.88),('12664','2013-09-17','12:45:00',3.68),('12664','2013-09-17','12:50:00',3.43),('12664','2013-09-17','12:55:00',3.26),('12664','2013-09-17','13:00:00',3.48),('12664','2013-09-17','13:05:00',2.85),('12664','2013-09-17','13:10:00',2.52),('12664','2013-09-17','13:15:00',2.16),('12664','2013-09-17','13:20:00',2.11),('12664','2013-09-17','13:25:00',1.63),('12664','2013-09-17','13:30:00',1.07),('12664','2013-09-17','13:35:00',2.34),('12664','2013-09-17','13:40:00',4.33),('12664','2013-09-17','13:50:00',2.41),('12664','2013-09-17','13:55:00',2.14),('12664','2013-09-17','14:05:00',2.41),('12664','2013-09-17','14:10:00',1.47),('12664','2013-09-17','14:15:00',1.1),('12664','2013-09-17','14:25:00',1.26),('12664','2013-09-17','14:30:00',1.95),('12664','2013-09-17','14:45:00',1.18),('12664','2013-09-17','14:50:00',3.29),('12664','2013-09-17','14:55:00',3.84),('12664','2013-09-17','15:00:00',3.26),('12664','2013-09-17','15:05:00',2.48),('12664','2013-09-17','15:10:00',2.36),('12664','2013-09-17','15:15:00',1.11),('12664','2013-09-17','15:30:00',1.21),('12664','2013-09-17','15:35:00',1.12),('12664','2013-09-17','15:40:00',1.64),('12664','2013-09-17','15:45:00',1.9),('12664','2013-09-17','15:50:00',1.87),('12664','2013-09-17','15:55:00',2.6),('12664','2013-09-17','16:00:00',2.61),('12664','2013-09-17','16:05:00',1.86),('12664','2013-09-17','16:10:00',1.84),('12664','2013-09-17','16:15:00',1.1),('12664','2013-09-17','16:35:00',1.15),('12664','2013-09-17','16:40:00',1.63),('12664','2013-09-17','16:45:00',1.78),('12664','2013-09-17','16:50:00',1.04),('12664','2013-09-17','16:55:00',1.44),('12664','2013-09-17','17:00:00',1.84),('12664','2013-09-17','17:05:00',1.69),('12664','2013-09-17','17:10:00',1.84),('12664','2013-09-17','17:15:00',1.51),('12664','2013-09-17','17:20:00',1.46),('12664','2013-09-17','17:25:00',1.29),('12664','2013-09-17','17:30:00',1.39),('12664','2013-09-17','17:35:00',1.15),('12664','2013-09-16','08:20:00',1.1),('12664','2013-09-16','08:25:00',1.2),('12664','2013-09-16','08:35:00',1.41),('12664','2013-09-16','08:40:00',1.51),('12664','2013-09-16','08:45:00',1.76),('12664','2013-09-16','08:50:00',1.41),('12664','2013-09-16','09:05:00',1.41),('12664','2013-09-16','09:10:00',1.9),('12664','2013-09-16','09:15:00',2.23),('12664','2013-09-16','09:20:00',2.32),('12664','2013-09-16','09:25:00',2.25),('12664','2013-09-16','09:30:00',2.39),('12664','2013-09-16','09:35:00',2.47),('12664','2013-09-16','09:40:00',2.55),('12664','2013-09-16','09:45:00',2.64),('12664','2013-09-16','09:50:00',2.79),('12664','2013-09-16','09:55:00',2.69),('12664','2013-09-16','10:00:00',2.87),('12664','2013-09-16','10:05:00',3.08),('12664','2013-09-16','10:10:00',1.82),('12664','2013-09-16','10:15:00',2.08),('12664','2013-09-16','10:30:00',1.49),('12664','2013-09-16','10:35:00',3.76),('12664','2013-09-16','10:40:00',2.38),('12664','2013-09-16','10:45:00',1.35),('12664','2013-09-16','10:50:00',1.18),('12664','2013-09-16','10:55:00',3.22),('12664','2013-09-16','11:00:00',1.52),('12664','2013-09-16','11:10:00',3.42),('12664','2013-09-16','11:15:00',4.37),('12664','2013-09-16','11:20:00',4.4),('12664','2013-09-16','11:25:00',4.36),('12664','2013-09-16','11:30:00',4.14),('12664','2013-09-16','11:35:00',3.25),('12664','2013-09-16','11:40:00',3.16),('12664','2013-09-16','11:45:00',4.05),('12664','2013-09-16','11:50:00',4.23),('12664','2013-09-16','11:55:00',4.29),('12664','2013-09-16','12:00:00',1.35),('12664','2013-09-16','12:05:00',1.72),('12664','2013-09-16','12:10:00',4.05),('12664','2013-09-16','12:15:00',4.4),('12664','2013-09-16','12:20:00',4.32),('12664','2013-09-16','12:25:00',4.29),('12664','2013-09-16','12:30:00',3.71),('12664','2013-09-16','12:35:00',1.8),('12664','2013-09-16','12:40:00',1.77),('12664','2013-09-16','12:45:00',1.84),('12664','2013-09-16','12:50:00',3.24),('12664','2013-09-16','12:55:00',2.74),('12664','2013-09-16','13:00:00',1.91),('12664','2013-09-16','13:05:00',3.86),('12664','2013-09-16','13:10:00',4.25),('12664','2013-09-16','13:15:00',4.24),('12664','2013-09-16','13:20:00',4.2),('12664','2013-09-16','13:25:00',4.19),('12664','2013-09-16','13:30:00',4.26),('12664','2013-09-16','13:35:00',2.08),('12664','2013-09-16','13:40:00',3.19),('12664','2013-09-16','13:45:00',3.82),('12664','2013-09-16','13:50:00',4.22),('12664','2013-09-16','13:55:00',4.24),('12664','2013-09-16','14:00:00',4.08),('12664','2013-09-16','14:05:00',3.94),('12664','2013-09-16','14:10:00',3.93),('12664','2013-09-16','14:15:00',3.9),('12664','2013-09-16','14:20:00',3.85),('12664','2013-09-16','14:25:00',3.83),('12664','2013-09-16','14:30:00',3.77),('12664','2013-09-16','14:35:00',3.71),('12664','2013-09-16','14:40:00',3.71),('12664','2013-09-16','14:45:00',3.69),('12664','2013-09-16','14:50:00',3.67),('12664','2013-09-16','14:55:00',3.65),('12664','2013-09-16','15:00:00',3.59),('12664','2013-09-16','15:05:00',3.54),('12664','2013-09-16','15:10:00',3.51),('12664','2013-09-16','15:15:00',3.44),('12664','2013-09-16','15:20:00',3.39),('12664','2013-09-16','15:25:00',3.33),('12664','2013-09-16','15:30:00',3.29),('12664','2013-09-16','15:35:00',3.22),('12664','2013-09-16','15:40:00',3.16),('12664','2013-09-16','15:45:00',3.09),('12664','2013-09-16','15:50:00',3.02),('12664','2013-09-16','15:55:00',2.9),('12664','2013-09-16','16:00:00',2.96),('12664','2013-09-16','16:05:00',2.83),('12664','2013-09-16','16:10:00',2.75),('12664','2013-09-16','16:15:00',2.68),('12664','2013-09-16','16:20:00',2.61),('12664','2013-09-16','16:25:00',2.53),('12664','2013-09-16','16:30:00',2.45),('12664','2013-09-16','16:35:00',2.38),('12664','2013-09-16','16:40:00',2.29),('12664','2013-09-16','16:45:00',2.2),('12664','2013-09-16','16:50:00',2.1),('12664','2013-09-16','16:55:00',2.01),('12664','2013-09-16','17:00:00',1.79),('12664','2013-09-16','17:05:00',1.79),('12664','2013-09-16','17:10:00',1.34),('12664','2013-09-16','17:15:00',1.65),('12664','2013-09-16','17:20:00',1.12),('12664','2013-09-16','17:30:00',1.21),('12664','2013-09-16','17:35:00',1.3),('12664','2013-09-16','17:40:00',1.15),('12664','2013-09-16','17:45:00',1.02),('12664','2013-09-15','08:15:00',1.06),('12664','2013-09-15','08:20:00',1.17),('12664','2013-09-15','08:25:00',1.28),('12664','2013-09-15','08:30:00',1.38),('12664','2013-09-15','08:35:00',1.5),('12664','2013-09-15','08:40:00',1.62),('12664','2013-09-15','08:45:00',1.71),('12664','2013-09-15','08:50:00',1.65),('12664','2013-09-15','08:55:00',1.78),('12664','2013-09-15','09:00:00',1.85),('12664','2013-09-15','09:05:00',1.97),('12664','2013-09-15','09:10:00',2.1),('12664','2013-09-15','09:15:00',2.18),('12664','2013-09-15','09:20:00',2.22),('12664','2013-09-15','09:25:00',2.24),('12664','2013-09-15','09:30:00',2.36),('12664','2013-09-15','09:35:00',2.46),('12664','2013-09-15','09:40:00',2.5),('12664','2013-09-15','09:45:00',2.61),('12664','2013-09-15','09:50:00',2.66),('12664','2013-09-15','09:55:00',2.81),('12664','2013-09-15','10:00:00',2.88),('12664','2013-09-15','10:05:00',2.84),('12664','2013-09-15','10:10:00',2.7),('12664','2013-09-15','10:15:00',2.9),('12664','2013-09-15','10:20:00',2.98),('12664','2013-09-15','10:25:00',2.96),('12664','2013-09-15','10:30:00',3.05),('12664','2013-09-15','10:35:00',3.27),('12664','2013-09-15','10:40:00',3.3),('12664','2013-09-15','10:45:00',3.13),('12664','2013-09-15','10:50:00',3.4),('12664','2013-09-15','10:55:00',1.97),('12664','2013-09-15','11:00:00',2.69),('12664','2013-09-15','11:05:00',1.11),('12664','2013-09-15','11:10:00',2.52),('12664','2013-09-15','11:15:00',2.83),('12664','2013-09-15','11:20:00',4.33),('12664','2013-09-15','11:25:00',1.67),('12664','2013-09-15','11:35:00',1.57),('12664','2013-09-15','11:40:00',3.87),('12664','2013-09-15','11:45:00',4.5),('12664','2013-09-15','11:50:00',4.07),('12664','2013-09-15','11:55:00',2.09),('12664','2013-09-15','12:00:00',1.71),('12664','2013-09-15','12:05:00',1.57),('12664','2013-09-15','12:10:00',1.4),('12664','2013-09-15','12:15:00',1.43),('12664','2013-09-15','12:20:00',1.43),('12664','2013-09-15','12:25:00',1.32),('12664','2013-09-15','12:30:00',1.22),('12664','2013-09-15','12:35:00',1.27),('12664','2013-09-15','12:40:00',1.15),('12664','2013-09-15','12:45:00',1.36),('12664','2013-09-15','12:50:00',1.37),('12664','2013-09-15','12:55:00',1.26),('12664','2013-09-15','13:00:00',1.35),('12664','2013-09-15','13:05:00',1.33),('12664','2013-09-15','13:10:00',1.07),('12664','2013-09-15','13:15:00',1.16),('12664','2013-09-15','13:20:00',1.38),('12664','2013-09-15','13:25:00',1.24),('12664','2013-09-15','13:30:00',1.82),('12664','2013-09-15','13:35:00',2.23),('12664','2013-09-15','13:40:00',3.47),('12664','2013-09-15','13:45:00',3.08),('12664','2013-09-15','13:50:00',1.68),('12664','2013-09-15','13:55:00',1.83),('12664','2013-09-15','14:00:00',1.52),('12664','2013-09-15','14:05:00',1.51),('12664','2013-09-15','14:10:00',1.76),('12664','2013-09-15','14:15:00',1.75),('12664','2013-09-15','14:20:00',1.48),('12664','2013-09-15','14:25:00',1.36),('12664','2013-09-15','14:30:00',1.25),('12664','2013-09-15','14:35:00',1.17),('12664','2013-09-15','14:40:00',1.17),('12664','2013-09-15','14:45:00',1.23),('12664','2013-09-15','14:50:00',1.19),('12664','2013-09-15','14:55:00',1.14),('12664','2013-09-15','15:00:00',1.18),('12664','2013-09-15','15:05:00',1.18),('12664','2013-09-15','15:10:00',1.59),('12664','2013-09-15','15:15:00',1.93),('12664','2013-09-15','15:20:00',1.64),('12664','2013-09-15','15:25:00',1.01),('12664','2013-09-14','08:15:00',1.01),('12664','2013-09-14','08:20:00',1.11),('12664','2013-09-14','08:25:00',1.21),('12664','2013-09-14','08:30:00',1.31),('12664','2013-09-14','08:35:00',1.41),('12664','2013-09-14','08:40:00',1.52),('12664','2013-09-14','08:45:00',1.6),('12664','2013-09-14','08:50:00',1.71),('12664','2013-09-14','08:55:00',1.81),('12664','2013-09-14','09:00:00',1.89),('12664','2013-09-14','09:05:00',1.97),('12664','2013-09-14','09:10:00',2.05),('12664','2013-09-14','09:15:00',2.14),('12664','2013-09-14','09:20:00',2.22),('12664','2013-09-14','09:25:00',2.32),('12664','2013-09-14','09:30:00',2.4),('12664','2013-09-14','09:35:00',2.5),('12664','2013-09-14','09:40:00',2.59),('12664','2013-09-14','09:45:00',2.62),('12664','2013-09-14','09:50:00',2.71),('12664','2013-09-14','09:55:00',2.8),('12664','2013-09-14','10:00:00',2.88),('12664','2013-09-14','10:05:00',2.85),('12664','2013-09-14','10:10:00',2.94),('12664','2013-09-14','10:15:00',2.98),('12664','2013-09-14','10:20:00',3.1),('12664','2013-09-14','10:25:00',3),('12664','2013-09-14','10:30:00',3.29),('12664','2013-09-14','10:35:00',3.35),('12664','2013-09-14','10:40:00',3.15),('12664','2013-09-14','10:45:00',3.41),('12664','2013-09-14','10:55:00',2.99),('12664','2013-09-14','11:00:00',3.11),('12664','2013-09-14','11:05:00',3.71),('12664','2013-09-14','11:10:00',3.66),('12664','2013-09-14','11:15:00',3.71),('12664','2013-09-14','11:20:00',3.73),('12664','2013-09-14','11:25:00',3.78),('12664','2013-09-14','11:30:00',3.79),('12664','2013-09-14','11:35:00',3.84),('12664','2013-09-14','11:40:00',3.88),('12664','2013-09-14','11:45:00',3.92),('12664','2013-09-14','11:50:00',3.91),('12664','2013-09-14','11:55:00',3.92),('12664','2013-09-14','12:00:00',3.96),('12664','2013-09-14','12:05:00',3.99),('12664','2013-09-14','12:10:00',4.07),('12664','2013-09-14','12:15:00',4.12),('12664','2013-09-14','12:20:00',4.14),('12664','2013-09-14','12:25:00',4.04),('12664','2013-09-14','12:30:00',4.06),('12664','2013-09-14','12:35:00',4.17),('12664','2013-09-14','12:40:00',4.23),('12664','2013-09-14','12:45:00',4.21),('12664','2013-09-14','12:50:00',4.27),('12664','2013-09-14','12:55:00',4.18),('12664','2013-09-14','13:00:00',4.3),('12664','2013-09-14','13:05:00',4.3),('12664','2013-09-14','13:10:00',4.15),('12664','2013-09-14','13:15:00',4.1),('12664','2013-09-14','13:20:00',4.06),('12664','2013-09-14','13:25:00',4.04),('12664','2013-09-14','13:30:00',4.06),('12664','2013-09-14','13:35:00',4),('12664','2013-09-14','13:40:00',2.32),('12664','2013-09-14','13:45:00',2.15),('12664','2013-09-14','13:50:00',2.46),('12664','2013-09-14','13:55:00',3.08),('12664','2013-09-14','14:00:00',3.72),('12664','2013-09-14','14:05:00',3.84),('12664','2013-09-14','14:10:00',4.11),('12664','2013-09-14','14:15:00',3.93),('12664','2013-09-14','14:20:00',3.85),('12664','2013-09-14','14:25:00',3.79),('12664','2013-09-14','14:30:00',3.69),('12664','2013-09-14','14:35:00',3.72),('12664','2013-09-14','14:40:00',3.69),('12664','2013-09-14','14:45:00',3.66),('12664','2013-09-14','14:50:00',3.62),('12664','2013-09-14','14:55:00',3.57),('12664','2013-09-14','15:00:00',3.52),('12664','2013-09-14','15:05:00',3.48),('12664','2013-09-14','15:10:00',3.44),('12664','2013-09-14','15:15:00',3.39),('12664','2013-09-14','15:20:00',3.34),('12664','2013-09-14','15:25:00',3.26),('12664','2013-09-14','15:30:00',3.21),('12664','2013-09-14','15:35:00',3.14),('12664','2013-09-14','15:40:00',3.11),('12664','2013-09-14','15:45:00',3.03),('12664','2013-09-14','15:50:00',2.97),('12664','2013-09-14','15:55:00',2.9),('12664','2013-09-14','16:00:00',2.82),('12664','2013-09-14','16:05:00',2.78),('12664','2013-09-14','16:10:00',2.66),('12664','2013-09-14','16:15:00',2.54),('12664','2013-09-14','16:20:00',2.58),('12664','2013-09-14','16:25:00',2.51),('12664','2013-09-14','16:30:00',2.42),('12664','2013-09-14','16:35:00',2.34),('12664','2013-09-14','16:40:00',2.25),('12664','2013-09-14','16:45:00',2.14),('12664','2013-09-14','16:50:00',2.08),('12664','2013-09-14','16:55:00',2),('12664','2013-09-14','17:00:00',1.93),('12664','2013-09-14','17:05:00',1.82),('12664','2013-09-14','17:10:00',1.72),('12664','2013-09-14','17:15:00',1.66),('12664','2013-09-14','17:20:00',1.55),('12664','2013-09-14','17:25:00',1.38),('12664','2013-09-14','17:30:00',1.33),('12664','2013-09-14','17:35:00',1.23),('12664','2013-09-14','17:40:00',1.13),('12664','2013-09-14','17:45:00',1.03),('12664','2013-09-13','09:30:00',1.04),('12664','2013-09-13','09:35:00',1.17),('12664','2013-09-13','09:40:00',1.2),('12664','2013-09-13','09:45:00',1.26),('12664','2013-09-13','09:50:00',1.54),('12664','2013-09-13','09:55:00',2.1),('12664','2013-09-13','10:00:00',3.24),('12664','2013-09-13','10:05:00',2.38),('12664','2013-09-13','10:10:00',2.2),('12664','2013-09-13','10:15:00',2.18),('12664','2013-09-13','10:20:00',2.26),('12664','2013-09-13','10:25:00',2.17),('12664','2013-09-13','10:30:00',3.41),('12664','2013-09-13','10:35:00',3.39),('12664','2013-09-13','10:40:00',3.41),('12664','2013-09-13','10:45:00',3.43),('12664','2013-09-13','10:50:00',3.47),('12664','2013-09-13','10:55:00',3.51),('12664','2013-09-13','11:00:00',3.56),('12664','2013-09-13','11:05:00',3.6),('12664','2013-09-13','11:10:00',3.63),('12664','2013-09-13','11:15:00',3.66),('12664','2013-09-13','11:20:00',3.69),('12664','2013-09-13','11:25:00',3.73),('12664','2013-09-13','11:30:00',3.76),('12664','2013-09-13','11:35:00',3.79),('12664','2013-09-13','11:40:00',3.82),('12664','2013-09-13','11:45:00',3.86),('12664','2013-09-13','11:50:00',3.89),('12664','2013-09-13','11:55:00',3.93),('12664','2013-09-13','12:00:00',3.93),('12664','2013-09-13','12:05:00',3.95),('12664','2013-09-13','12:10:00',4),('12664','2013-09-13','12:15:00',4.05),('12664','2013-09-13','12:20:00',4.09),('12664','2013-09-13','12:25:00',4.13),('12664','2013-09-13','12:30:00',4.11),('12664','2013-09-13','12:35:00',4.22),('12664','2013-09-13','12:40:00',2.46),('12664','2013-09-13','12:45:00',3.53),('12664','2013-09-13','12:50:00',4.17),('12664','2013-09-13','12:55:00',3.77),('12664','2013-09-13','13:00:00',3.84),('12664','2013-09-13','13:05:00',1.73),('12664','2013-09-13','13:10:00',4.06),('12664','2013-09-13','13:15:00',4.13),('12664','2013-09-13','13:20:00',4.06),('12664','2013-09-13','13:25:00',4.02),('12664','2013-09-13','13:30:00',4.04),('12664','2013-09-13','13:35:00',4.04),('12664','2013-09-13','13:40:00',4.03),('12664','2013-09-13','13:45:00',4),('12664','2013-09-13','13:50:00',4),('12664','2013-09-13','13:55:00',3.93),('12664','2013-09-13','14:00:00',3.89),('12664','2013-09-13','14:05:00',3.91),('12664','2013-09-13','14:10:00',3.91),('12664','2013-09-13','14:15:00',3.83),('12664','2013-09-13','14:20:00',3.82),('12664','2013-09-13','14:25:00',3.82),('12664','2013-09-13','14:30:00',3.79),('12664','2013-09-13','14:35:00',3.8),('12664','2013-09-13','14:40:00',3.76),('12664','2013-09-13','14:45:00',3.74),('12664','2013-09-13','14:50:00',3.71),('12664','2013-09-13','14:55:00',3.64),('12664','2013-09-13','15:00:00',3.62),('12664','2013-09-13','15:05:00',3.55),('12664','2013-09-13','15:10:00',3.52),('12664','2013-09-13','15:15:00',3.46),('12664','2013-09-13','15:20:00',3.42),('12664','2013-09-13','15:25:00',3.36),('12664','2013-09-13','15:30:00',3.3),('12664','2013-09-13','15:35:00',3.24),('12664','2013-09-13','15:40:00',3.19),('12664','2013-09-13','15:45:00',3.13),('12664','2013-09-13','15:50:00',3.07),('12664','2013-09-13','15:55:00',2.99),('12664','2013-09-13','16:00:00',2.92),('12664','2013-09-13','16:05:00',2.85),('12664','2013-09-13','16:10:00',2.79),('12664','2013-09-13','16:15:00',2.71),('12664','2013-09-13','16:20:00',2.63),('12664','2013-09-13','16:25:00',2.56),('12664','2013-09-13','16:30:00',2.47),('12664','2013-09-13','16:35:00',2.38),('12664','2013-09-13','16:40:00',2.31),('12664','2013-09-13','16:45:00',2.21),('12664','2013-09-13','16:50:00',2.13),('12664','2013-09-13','16:55:00',2.03),('12664','2013-09-13','17:00:00',1.95),('12664','2013-09-13','17:05:00',1.85),('12664','2013-09-13','17:10:00',1.76),('12664','2013-09-13','17:15:00',1.66),('12664','2013-09-13','17:20:00',1.57),('12664','2013-09-13','17:25:00',1.48),('12664','2013-09-13','17:30:00',1.37),('12664','2013-09-13','17:35:00',1.27),('12664','2013-09-13','17:40:00',1.17),('12664','2013-09-13','17:45:00',1.08),('12664','2013-09-12','08:20:00',1.23),('12664','2013-09-12','08:50:00',1.48),('12664','2013-09-12','08:55:00',1.83),('12664','2013-09-12','09:00:00',1.95),('12664','2013-09-12','09:05:00',1.71),('12664','2013-09-12','09:10:00',1.45),('12664','2013-09-12','09:15:00',1.41),('12664','2013-09-12','09:20:00',2.03),('12664','2013-09-12','09:25:00',1.32),('12664','2013-09-12','09:30:00',1.66),('12664','2013-09-12','09:35:00',1.58),('12664','2013-09-12','09:40:00',1.01),('12664','2013-09-12','09:45:00',1),('12664','2013-09-12','09:50:00',2.36),('12664','2013-09-12','09:55:00',2.07),('12664','2013-09-12','10:00:00',2.1),('12664','2013-09-12','10:05:00',2.49),('12664','2013-09-12','10:10:00',1.57),('12664','2013-09-12','10:15:00',1.17),('12664','2013-09-12','10:20:00',1.16),('12664','2013-09-12','10:25:00',2.29),('12664','2013-09-12','10:30:00',2.32),('12664','2013-09-12','10:35:00',2.87),('12664','2013-09-12','10:40:00',2.71),('12664','2013-09-12','10:45:00',2.95),('12664','2013-09-12','10:50:00',3.17),('12664','2013-09-12','10:55:00',4.56),('12664','2013-09-12','11:00:00',3.31),('12664','2013-09-12','11:05:00',1.11),('12664','2013-09-12','11:35:00',1.05),('12664','2013-09-12','11:40:00',1.84),('12664','2013-09-12','11:45:00',2.25),('12664','2013-09-12','11:50:00',3.21),('12664','2013-09-12','11:55:00',3.76),('12664','2013-09-12','12:00:00',4.37),('12664','2013-09-12','12:05:00',4.4),('12664','2013-09-12','12:10:00',4.31),('12664','2013-09-12','12:15:00',2.23),('12664','2013-09-12','12:20:00',3.25),('12664','2013-09-12','12:25:00',3.85),('12664','2013-09-12','12:30:00',4.18),('12664','2013-09-12','12:35:00',3.42),('12664','2013-09-12','12:40:00',3.16),('12664','2013-09-12','12:45:00',3.93),('12664','2013-09-12','12:50:00',3.77),('12664','2013-09-12','12:55:00',4.55),('12664','2013-09-12','13:00:00',4.27),('12664','2013-09-12','13:05:00',4.46),('12664','2013-09-12','13:10:00',3.8),('12664','2013-09-12','13:15:00',1.83),('12664','2013-09-12','13:20:00',2.01),('12664','2013-09-12','13:25:00',4.54),('12664','2013-09-12','13:30:00',3.67),('12664','2013-09-12','13:35:00',3.44),('12664','2013-09-12','13:40:00',4.3),('12664','2013-09-12','13:45:00',4.16),('12664','2013-09-12','13:50:00',3.88),('12664','2013-09-12','13:55:00',3.74),('12664','2013-09-12','14:00:00',4),('12664','2013-09-12','14:05:00',4.15),('12664','2013-09-12','14:10:00',4.13),('12664','2013-09-12','14:15:00',4.13),('12664','2013-09-12','14:20:00',4.13),('12664','2013-09-12','14:25:00',2.39),('12664','2013-09-12','14:30:00',4),('12664','2013-09-12','14:35:00',4.29),('12664','2013-09-12','14:40:00',4.14),('12664','2013-09-12','14:45:00',3.99),('12664','2013-09-12','14:50:00',3.47),('12664','2013-09-12','14:55:00',3.86),('12664','2013-09-12','15:00:00',3.7),('12664','2013-09-12','15:05:00',3.7),('12664','2013-09-12','15:10:00',3.63),('12664','2013-09-12','15:15:00',3.59),('12664','2013-09-12','15:20:00',3.55),('12664','2013-09-12','15:25:00',3.51),('12664','2013-09-12','15:30:00',3.45),('12664','2013-09-12','15:35:00',3.37),('12664','2013-09-12','15:40:00',3.32),('12664','2013-09-12','15:45:00',3.29),('12664','2013-09-12','15:50:00',2.45),('12664','2013-09-12','15:55:00',2.93),('12664','2013-09-12','16:00:00',3.08),('12664','2013-09-12','16:05:00',3.02),('12664','2013-09-12','16:10:00',2.65),('12664','2013-09-12','16:15:00',2.9),('12664','2013-09-12','16:20:00',2.24),('12664','2013-09-12','16:25:00',2.74),('12664','2013-09-12','16:30:00',2.74),('12664','2013-09-12','16:35:00',1.4),('12664','2013-09-12','16:40:00',2.61),('12664','2013-09-12','16:45:00',2.25),('12664','2013-09-12','16:50:00',2.34),('12664','2013-09-12','16:55:00',2.2),('12664','2013-09-12','17:00:00',1.55),('12664','2013-09-12','17:05:00',2.01),('12664','2013-09-12','17:10:00',1.88),('12664','2013-09-12','17:15:00',1.77),('12664','2013-09-12','17:20:00',1.67),('12664','2013-09-12','17:25:00',1.59),('12664','2013-09-12','17:30:00',1.46),('12664','2013-09-12','17:35:00',1.34),('12664','2013-09-12','17:40:00',1.24),('12664','2013-09-12','17:45:00',1.09),('12664','2013-09-11','08:00:00',1.21),('12664','2013-09-11','09:45:00',1.06),('12664','2013-09-11','09:50:00',1.33),('12664','2013-09-11','09:55:00',1.22),('12664','2013-09-11','10:00:00',1.96),('12664','2013-09-11','10:05:00',3.02),('12664','2013-09-11','10:10:00',3.03),('12664','2013-09-11','10:15:00',3.08),('12664','2013-09-11','10:20:00',3.09),('12664','2013-09-11','10:25:00',3.12),('12664','2013-09-11','10:30:00',3.03),('12664','2013-09-11','10:35:00',3.22),('12664','2013-09-11','10:40:00',2.13),('12664','2013-09-11','10:45:00',2.4),('12664','2013-09-11','10:50:00',2.22),('12664','2013-09-11','10:55:00',1.81),('12664','2013-09-11','11:00:00',3.02),('12664','2013-09-11','11:05:00',4.22),('12664','2013-09-11','11:10:00',2.37),('12664','2013-09-11','11:15:00',3.32),('12664','2013-09-11','11:20:00',3.89),('12664','2013-09-11','11:25:00',1.99),('12664','2013-09-11','11:30:00',4.4),('12664','2013-09-11','11:35:00',4.18),('12664','2013-09-11','11:40:00',4.28),('12664','2013-09-11','11:45:00',4.22),('12664','2013-09-11','11:50:00',3.93),('12664','2013-09-11','11:55:00',4.2),('12664','2013-09-11','12:00:00',3.62),('12664','2013-09-11','12:05:00',3.7),('12664','2013-09-11','12:10:00',1.94),('12664','2013-09-11','12:15:00',3.36),('12664','2013-09-11','12:20:00',3.44),('12664','2013-09-11','12:25:00',4.75),('12664','2013-09-11','12:30:00',2.88),('12664','2013-09-11','12:35:00',3.68),('12664','2013-09-11','12:40:00',3.5),('12664','2013-09-11','12:45:00',3.05),('12664','2013-09-11','12:50:00',4.26),('12664','2013-09-11','12:55:00',3.58),('12664','2013-09-11','13:00:00',2.33),('12664','2013-09-11','13:05:00',4.32),('12664','2013-09-11','13:10:00',4.35),('12664','2013-09-11','13:15:00',3.93),('12664','2013-09-11','13:20:00',3.28),('12664','2013-09-11','13:25:00',4.48),('12664','2013-09-11','13:30:00',2.77),('12664','2013-09-11','13:35:00',2.88),('12664','2013-09-11','13:40:00',3.21),('12664','2013-09-11','13:45:00',3.52),('12664','2013-09-11','13:50:00',3.6),('12664','2013-09-11','13:55:00',4.45),('12664','2013-09-11','14:00:00',4.21),('12664','2013-09-11','14:05:00',4.11),('12664','2013-09-11','14:10:00',3.97),('12664','2013-09-11','14:15:00',3.84),('12664','2013-09-11','14:20:00',3.67),('12664','2013-09-11','14:25:00',1.76),('12664','2013-09-11','14:30:00',2.71),('12664','2013-09-11','14:35:00',1.81),('12664','2013-09-11','14:40:00',3.4),('12664','2013-09-11','14:45:00',1.15),('12664','2013-09-11','14:50:00',1.14),('12664','2013-09-11','14:55:00',1.38),('12664','2013-09-11','15:00:00',3.18),('12664','2013-09-11','15:05:00',2.09),('12664','2013-09-11','15:10:00',1.62),('12664','2013-09-11','15:15:00',1.37),('12664','2013-09-11','15:20:00',1.51),('12664','2013-09-11','15:25:00',2.33),('12664','2013-09-11','15:30:00',2.16),('12664','2013-09-11','15:35:00',3.43),('12664','2013-09-11','15:40:00',1.35),('12664','2013-09-11','15:45:00',2.15),('12664','2013-09-11','16:00:00',3.2),('12664','2013-09-11','16:05:00',3.08),('12664','2013-09-11','16:10:00',3.14),('12664','2013-09-11','16:15:00',2.41),('12664','2013-09-11','16:25:00',2.54),('12664','2013-09-11','16:30:00',2.58),('12664','2013-09-11','16:35:00',1.88),('12664','2013-09-11','16:40:00',2.22),('12664','2013-09-11','16:45:00',1.6),('12664','2013-09-11','16:50:00',2.29),('12664','2013-09-11','16:55:00',1.79),('12664','2013-09-11','17:00:00',2.02),('12664','2013-09-11','17:05:00',1.92),('12664','2013-09-11','17:10:00',1.82),('12664','2013-09-11','17:15:00',1.75),('12664','2013-09-11','17:20:00',1.76),('12664','2013-09-11','17:25:00',1.37),('12664','2013-09-11','17:30:00',1.25),('12664','2013-09-11','17:35:00',1.37),('12664','2013-09-11','17:40:00',1.25),('12664','2013-09-11','17:45:00',1.14),('12664','2013-09-11','17:50:00',1.04),('12664','2013-09-10','08:45:00',1.11),('12664','2013-09-10','08:50:00',1.64),('12664','2013-09-10','08:55:00',2),('12664','2013-09-10','09:00:00',1.17),('12664','2013-09-10','09:05:00',1.25),('12664','2013-09-10','09:10:00',2.52),('12664','2013-09-10','09:15:00',1.56),('12664','2013-09-10','09:20:00',2.07),('12664','2013-09-10','09:25:00',1.45),('12664','2013-09-10','09:30:00',1.14),('12664','2013-09-10','09:35:00',1.24),('12664','2013-09-10','09:40:00',1.12),('12664','2013-09-10','09:45:00',1.18),('12664','2013-09-10','09:50:00',1.14),('12664','2013-09-10','10:35:00',1.14),('12664','2013-09-10','10:40:00',1.39),('12664','2013-09-10','10:45:00',1.42),('12664','2013-09-10','10:50:00',1.3),('12664','2013-09-10','10:55:00',1.96),('12664','2013-09-10','11:00:00',2.23),('12664','2013-09-10','11:05:00',1.31),('12664','2013-09-10','11:20:00',1.28),('12664','2013-09-10','11:25:00',1.41),('12664','2013-09-10','11:40:00',1.02),('12664','2013-09-10','11:45:00',1.29),('12664','2013-09-10','11:55:00',1.32),('12664','2013-09-10','12:00:00',1.08),('12664','2013-09-10','12:05:00',1.19),('12664','2013-09-10','12:10:00',1.36),('12664','2013-09-10','12:15:00',1.75),('12664','2013-09-10','12:20:00',1.52),('12664','2013-09-10','12:25:00',1.36),('12664','2013-09-10','13:00:00',1.01),('12664','2013-09-10','13:15:00',1.04),('12664','2013-09-10','13:20:00',1.07),('12664','2013-09-10','13:25:00',1.13),('12664','2013-09-10','13:30:00',1.07),('12664','2013-09-10','13:35:00',1.56),('12664','2013-09-10','13:40:00',1.9),('12664','2013-09-10','13:45:00',2.13),('12664','2013-09-10','13:50:00',2.77),('12664','2013-09-10','13:55:00',2.16),('12664','2013-09-10','14:00:00',1.69),('12664','2013-09-10','14:05:00',1.35),('12664','2013-09-10','14:10:00',1.57),('12664','2013-09-10','14:15:00',1.77),('12664','2013-09-10','14:20:00',1.96),('12664','2013-09-10','14:25:00',2.3),('12664','2013-09-10','14:30:00',2.08),('12664','2013-09-10','14:35:00',1.47),('12664','2013-09-10','14:40:00',1.9),('12664','2013-09-10','14:45:00',2.01),('12664','2013-09-10','14:50:00',2),('12664','2013-09-10','14:55:00',2.27),('12664','2013-09-10','15:00:00',2.36),('12664','2013-09-10','15:05:00',2.58),('12664','2013-09-10','15:10:00',2.48),('12664','2013-09-10','15:15:00',2.35),('12664','2013-09-10','15:20:00',1.5),('12664','2013-09-10','15:25:00',1.7),('12664','2013-09-10','15:30:00',1.57),('12664','2013-09-10','15:35:00',1.29),('12664','2013-09-10','15:40:00',1.22),('12664','2013-09-10','15:45:00',1.27),('12664','2013-09-10','15:50:00',1.13),('12664','2013-09-10','16:45:00',1.18),('12664','2013-09-09','08:55:00',1.12),('12664','2013-09-09','09:00:00',1.13),('12664','2013-09-09','09:35:00',1.15),('12664','2013-09-09','09:40:00',1.44),('12664','2013-09-09','09:45:00',1.37),('12664','2013-09-09','09:50:00',1.22),('12664','2013-09-09','09:55:00',1.23),('12664','2013-09-09','10:00:00',1.22),('12664','2013-09-09','10:15:00',1.13),('12664','2013-09-09','10:20:00',1.18),('12664','2013-09-09','10:25:00',1.31),('12664','2013-09-09','10:30:00',1.61),('12664','2013-09-09','10:35:00',1.74),('12664','2013-09-09','10:40:00',1.76),('12664','2013-09-09','10:45:00',2.48),('12664','2013-09-09','10:50:00',2.67),('12664','2013-09-09','10:55:00',2.75),('12664','2013-09-09','11:00:00',2.37),('12664','2013-09-09','11:05:00',1.83),('12664','2013-09-09','11:10:00',2.04),('12664','2013-09-09','11:15:00',2.45),('12664','2013-09-09','11:20:00',1.73),('12664','2013-09-09','11:25:00',1.9),('12664','2013-09-09','11:30:00',2.17),('12664','2013-09-09','11:35:00',1.67),('12664','2013-09-09','11:40:00',1.55),('12664','2013-09-09','11:45:00',1.9),('12664','2013-09-09','11:50:00',3.46),('12664','2013-09-09','11:55:00',3.34),('12664','2013-09-09','12:00:00',2.78),('12664','2013-09-09','12:05:00',1.59),('12664','2013-09-09','12:10:00',1.75),('12664','2013-09-09','12:15:00',1.91),('12664','2013-09-09','12:20:00',2.05),('12664','2013-09-09','12:25:00',2.27),('12664','2013-09-09','12:30:00',2.14),('12664','2013-09-09','12:35:00',2.11),('12664','2013-09-09','12:40:00',2.31),('12664','2013-09-09','12:45:00',2.05),('12664','2013-09-09','12:50:00',2.26),('12664','2013-09-09','12:55:00',1.97),('12664','2013-09-09','13:00:00',2.16),('12664','2013-09-09','13:05:00',3.48),('12664','2013-09-09','13:10:00',3.78),('12664','2013-09-09','13:15:00',3.04),('12664','2013-09-09','13:20:00',3.08),('12664','2013-09-09','13:25:00',3.38),('12664','2013-09-09','13:30:00',3.5),('12664','2013-09-09','13:35:00',3.72),('12664','2013-09-09','13:40:00',2.63),('12664','2013-09-09','13:45:00',2.83),('12664','2013-09-09','13:50:00',3.67),('12664','2013-09-09','13:55:00',1.32),('12664','2013-09-09','14:00:00',2.21),('12664','2013-09-09','14:05:00',3.89),('12664','2013-09-09','14:10:00',3.16),('12664','2013-09-09','14:15:00',2.42),('12664','2013-09-09','14:20:00',3.67),('12664','2013-09-09','14:25:00',3.6),('12664','2013-09-09','14:30:00',2.07),('12664','2013-09-09','14:35:00',3.27),('12664','2013-09-09','14:40:00',1.33),('12664','2013-09-09','14:45:00',2.43),('12664','2013-09-09','14:50:00',1.59),('12664','2013-09-09','14:55:00',2.72),('12664','2013-09-09','15:00:00',2.98),('12664','2013-09-09','15:05:00',3.65),('12664','2013-09-09','15:10:00',3.45),('12664','2013-09-09','15:15:00',2.69),('12664','2013-09-09','15:20:00',2.69),('12664','2013-09-09','15:25:00',3.1),('12664','2013-09-09','15:30:00',1.88),('12664','2013-09-09','15:35:00',2.45),('12664','2013-09-09','15:40:00',1.48),('12664','2013-09-09','15:45:00',1.6),('12664','2013-09-09','15:50:00',2.15),('12664','2013-09-09','15:55:00',1.48),('12664','2013-09-09','16:00:00',1.11),('12664','2013-09-09','16:05:00',1.57),('12664','2013-09-09','16:10:00',1.09),('12664','2013-09-09','16:15:00',2.13),('12664','2013-09-09','16:20:00',1.23),('12664','2013-09-09','16:35:00',1.19),('12664','2013-09-09','16:40:00',1.09),('12664','2013-09-09','16:45:00',1.76),('12664','2013-09-09','16:50:00',1.37),('12664','2013-09-09','18:05:00',1.08),('12664','2013-09-08','08:55:00',1.5),('12664','2013-09-08','09:00:00',1.76),('12664','2013-09-08','09:05:00',1.9),('12664','2013-09-08','09:10:00',1.81),('12664','2013-09-08','09:15:00',1.59),('12664','2013-09-08','09:20:00',2.01),('12664','2013-09-08','09:25:00',2.14),('12664','2013-09-08','09:30:00',2.19),('12664','2013-09-08','09:35:00',2.28),('12664','2013-09-08','09:40:00',2.37),('12664','2013-09-08','09:45:00',2.41),('12664','2013-09-08','09:50:00',2.49),('12664','2013-09-08','09:55:00',2.57),('12664','2013-09-08','10:00:00',2.65),('12664','2013-09-08','10:05:00',2.71),('12664','2013-09-08','10:10:00',2.69),('12664','2013-09-08','10:15:00',2.81),('12664','2013-09-08','10:20:00',2.9),('12664','2013-09-08','10:25:00',2.94),('12664','2013-09-08','10:30:00',2.98),('12664','2013-09-08','10:35:00',3.08),('12664','2013-09-08','10:40:00',3.01),('12664','2013-09-08','10:45:00',3.05),('12664','2013-09-08','10:50:00',3.2),('12664','2013-09-08','10:55:00',3.31),('12664','2013-09-08','11:00:00',3.29),('12664','2013-09-08','11:05:00',3.22),('12664','2013-09-08','11:10:00',3.19),('12664','2013-09-08','11:15:00',3.27),('12664','2013-09-08','11:20:00',3.27),('12664','2013-09-08','11:25:00',3.38),('12664','2013-09-08','11:30:00',3.36),('12664','2013-09-08','11:35:00',3.36),('12664','2013-09-08','11:40:00',3.42),('12664','2013-09-08','11:45:00',3.49),('12664','2013-09-08','11:50:00',3.51),('12664','2013-09-08','11:55:00',3.35),('12664','2013-09-08','12:00:00',3.47),('12664','2013-09-08','12:05:00',3.5),('12664','2013-09-08','12:10:00',3.71),('12664','2013-09-08','12:15:00',3.7),('12664','2013-09-08','12:20:00',3.68),('12664','2013-09-08','12:25:00',3.74),('12664','2013-09-08','12:30:00',3.77),('12664','2013-09-08','12:35:00',3.64),('12664','2013-09-08','12:40:00',3.73),('12664','2013-09-08','12:45:00',3.66),('12664','2013-09-08','12:50:00',3.64),('12664','2013-09-08','12:55:00',3.66),('12664','2013-09-08','13:00:00',3.73),('12664','2013-09-08','13:05:00',3.71),('12664','2013-09-08','13:10:00',3.51),('12664','2013-09-08','13:15:00',3.61),('12664','2013-09-08','13:20:00',3.45),('12664','2013-09-08','13:25:00',3.24),('12664','2013-09-08','13:30:00',3.19),('12664','2013-09-08','13:35:00',2.35),('12664','2013-09-08','13:40:00',2.3),('12664','2013-09-08','13:45:00',2.52),('12664','2013-09-08','13:50:00',3.58),('12664','2013-09-08','13:55:00',3.22),('12664','2013-09-08','14:00:00',3.26),('12664','2013-09-08','14:05:00',3.45),('12664','2013-09-08','14:10:00',2.84),('12664','2013-09-08','14:15:00',3.24),('12664','2013-09-08','14:20:00',3.3),('12664','2013-09-08','14:25:00',3.49),('12664','2013-09-08','14:30:00',3.75),('12664','2013-09-08','14:35:00',3.57),('12664','2013-09-08','14:40:00',3.74),('12664','2013-09-08','14:45:00',3.36),('12664','2013-09-08','14:50:00',3.24),('12664','2013-09-08','14:55:00',3.55),('12664','2013-09-08','15:00:00',2.96),('12664','2013-09-08','15:05:00',1.97),('12664','2013-09-08','15:10:00',2.8),('12664','2013-09-08','15:15:00',3.45),('12664','2013-09-08','15:20:00',3.47),('12664','2013-09-08','15:25:00',3.36),('12664','2013-09-08','15:30:00',3.24),('12664','2013-09-08','15:35:00',2.88),('12664','2013-09-08','15:40:00',3.12),('12664','2013-09-08','15:45:00',3),('12664','2013-09-08','15:50:00',2.42),('12664','2013-09-08','15:55:00',2.63),('12664','2013-09-08','16:00:00',2.3),('12664','2013-09-08','16:05:00',2.08),('12664','2013-09-08','16:10:00',2.49),('12664','2013-09-08','16:15:00',2.54),('12664','2013-09-08','16:20:00',2.19),('12664','2013-09-08','16:25:00',2.17),('12664','2013-09-08','16:30:00',2.15),('12664','2013-09-08','16:35:00',1.66),('12664','2013-09-08','16:40:00',2.05),('12664','2013-09-08','16:45:00',1.16),('12664','2013-09-08','16:55:00',1.55),('12664','2013-09-08','17:00:00',2.1),('12664','2013-09-08','17:05:00',1.89),('12664','2013-09-08','17:10:00',1.75),('12664','2013-09-08','17:15:00',1.54),('12664','2013-09-08','17:20:00',1.5),('12664','2013-09-08','17:25:00',1.08),('12664','2013-09-08','17:40:00',1.15),('12664','2013-09-08','17:45:00',1.07),('12664','2014-04-11','08:30:00',1.21),('12664','2014-04-11','08:35:00',1.04),('12664','2014-04-11','08:45:00',1.21),('12664','2014-04-11','08:50:00',1.13),('12664','2014-04-11','08:55:00',1.95),('12664','2014-04-11','09:00:00',1.99),('12664','2014-04-11','09:05:00',2.05),('12664','2014-04-11','09:10:00',2.13),('12664','2014-04-11','09:15:00',2.2),('12664','2014-04-11','09:20:00',2.3),('12664','2014-04-11','09:25:00',2.39),('12664','2014-04-11','09:30:00',2.46),('12664','2014-04-11','09:35:00',2.52),('12664','2014-04-11','09:40:00',2.61),('12664','2014-04-11','09:45:00',2.71),('12664','2014-04-11','09:50:00',2.79),('12664','2014-04-11','09:55:00',2.85),('12664','2014-04-11','10:00:00',2.92),('12664','2014-04-11','10:05:00',2.99),('12664','2014-04-11','10:10:00',3.05),('12664','2014-04-11','10:15:00',3.13),('12664','2014-04-11','10:20:00',3.2),('12664','2014-04-11','10:25:00',3.24),('12664','2014-04-11','10:30:00',3.29),('12664','2014-04-11','10:35:00',3.36),('12664','2014-04-11','10:40:00',3.41),('12664','2014-04-11','10:45:00',3.47),('12664','2014-04-11','10:50:00',3.51),('12664','2014-04-11','10:55:00',3.56),('12664','2014-04-11','11:00:00',3.62),('12664','2014-04-11','11:05:00',3.68),('12664','2014-04-11','11:10:00',3.71),('12664','2014-04-11','11:15:00',3.76),('12664','2014-04-11','11:20:00',3.79),('12664','2014-04-11','11:25:00',3.84),('12664','2014-04-11','11:30:00',3.88),('12664','2014-04-11','11:35:00',3.91),('12664','2014-04-11','11:40:00',3.92),('12664','2014-04-11','11:45:00',3.94),('12664','2014-04-11','11:50:00',3.99),('12664','2014-04-11','11:55:00',3.18),('12664','2014-04-11','12:00:00',4.08),('12664','2014-04-11','12:05:00',4.14),('12664','2014-04-11','12:10:00',4.16),('12664','2014-04-11','12:15:00',4.02),('12664','2014-04-11','12:20:00',4.24),('12664','2014-04-11','12:25:00',3.43),('12664','2014-04-11','12:30:00',4.55),('12664','2014-04-11','12:35:00',4.45),('12664','2014-04-11','12:40:00',4.71),('12664','2014-04-11','12:45:00',4.49),('12664','2014-04-11','12:50:00',2.67),('12664','2014-04-11','12:55:00',3.12),('12664','2014-04-11','13:00:00',3.85),('12664','2014-04-11','13:05:00',4.16),('12664','2014-04-11','13:10:00',4.45),('12664','2014-04-11','13:15:00',1.71),('12664','2014-04-11','13:20:00',1.43),('12664','2014-04-11','13:25:00',4.78),('12664','2014-04-11','13:30:00',3.1),('12664','2014-04-11','13:35:00',4.7),('12664','2014-04-11','13:40:00',4.45),('12664','2014-04-11','13:45:00',4.3),('12664','2014-04-11','13:50:00',3.46),('12664','2014-04-11','13:55:00',4.51),('12664','2014-04-11','14:00:00',4.44),('12664','2014-04-11','14:05:00',3.41),('12664','2014-04-11','14:10:00',2.05),('12664','2014-04-11','14:15:00',3.49),('12664','2014-04-11','14:20:00',2.96),('12664','2014-04-11','14:25:00',3.78),('12664','2014-04-11','14:30:00',3.41),('12664','2014-04-11','14:35:00',2.71),('12664','2014-04-11','14:40:00',3.05),('12664','2014-04-11','14:45:00',1.32),('12664','2014-04-11','14:50:00',2.92),('12664','2014-04-11','14:55:00',2.75),('12664','2014-04-11','15:00:00',2.23),('12664','2014-04-11','15:05:00',2.36),('12664','2014-04-11','15:10:00',1.74),('12664','2014-04-11','15:15:00',3.21),('12664','2014-04-11','15:20:00',3.53),('12664','2014-04-11','15:25:00',3.01),('12664','2014-04-11','15:30:00',3.49),('12664','2014-04-11','15:35:00',3.22),('12664','2014-04-11','15:40:00',2.68),('12664','2014-04-11','15:45:00',3.02),('12664','2014-04-11','15:50:00',3.01),('12664','2014-04-11','15:55:00',3),('12664','2014-04-11','16:00:00',3.13),('12664','2014-04-11','16:05:00',3.05),('12664','2014-04-11','16:10:00',2.92),('12664','2014-04-11','16:15:00',2.14),('12664','2014-04-11','16:20:00',2.88),('12664','2014-04-11','16:25:00',2.8),('12664','2014-04-11','16:30:00',2.78),('12664','2014-04-11','16:35:00',2.61),('12664','2014-04-11','16:40:00',2.72),('12664','2014-04-11','16:45:00',2.56),('12664','2014-04-11','16:50:00',2.51),('12664','2014-04-11','16:55:00',2.07),('12664','2014-04-11','17:00:00',1.4),('12664','2014-04-11','17:05:00',2.16),('12664','2014-04-11','17:10:00',1.9),('12664','2014-04-11','17:15:00',1.34),('12664','2014-04-11','17:20:00',1.5),('12664','2014-04-11','17:25:00',1.66),('12664','2014-04-11','17:30:00',1.29),('12664','2014-04-11','17:35:00',1.76),('12664','2014-04-11','17:40:00',1.52),('12664','2014-04-11','17:45:00',1.32),('12664','2014-04-11','17:50:00',1.25),('12664','2014-04-11','17:55:00',1.24),('12664','2014-04-11','18:00:00',1.05),('12664','2014-04-11','18:05:00',1.05),('12664','2013-09-07','08:15:00',1),('12664','2013-09-07','08:20:00',1.09),('12664','2013-09-07','08:25:00',1.18),('12664','2013-09-07','08:30:00',1.27),('12664','2013-09-07','08:35:00',1.36),('12664','2013-09-07','08:40:00',1.46),('12664','2013-09-07','08:45:00',1.55),('12664','2013-09-07','08:50:00',1.63),('12664','2013-09-07','08:55:00',1.73),('12664','2013-09-07','09:00:00',1.82),('12664','2013-09-07','09:05:00',1.89),('12664','2013-09-07','09:10:00',1.99),('12664','2013-09-07','09:15:00',2.06),('12664','2013-09-07','09:20:00',2.13),('12664','2013-09-07','09:25:00',2.19),('12664','2013-09-07','09:30:00',2.27),('12664','2013-09-07','09:35:00',2.35),('12664','2013-09-07','09:40:00',2.41),('12664','2013-09-07','09:45:00',2.49),('12664','2013-09-07','09:50:00',2.57),('12664','2013-09-07','09:55:00',2.64),('12664','2013-09-07','10:00:00',2.71),('12664','2013-09-07','10:05:00',2.77),('12664','2013-09-07','10:10:00',2.81),('12664','2013-09-07','10:15:00',2.88),('12664','2013-09-07','10:20:00',2.93),('12664','2013-09-07','10:25:00',2.97),('12664','2013-09-07','10:30:00',3.04),('12664','2013-09-07','10:35:00',3.08),('12664','2013-09-07','10:40:00',3.12),('12664','2013-09-07','10:45:00',3.13),('12664','2013-09-07','10:50:00',3.2),('12664','2013-09-07','10:55:00',3.26),('12664','2013-09-07','11:00:00',3.29),('12664','2013-09-07','11:05:00',3.36),('12664','2013-09-07','11:10:00',3.44),('12664','2013-09-07','11:15:00',3.42),('12664','2013-09-07','11:20:00',3.47),('12664','2013-09-07','11:25:00',3.52),('12664','2013-09-07','11:30:00',3.53),('12664','2013-09-07','11:35:00',3.57),('12664','2013-09-07','11:40:00',3.58),('12664','2013-09-07','11:45:00',3.61),('12664','2013-09-07','11:50:00',3.63),('12664','2013-09-07','11:55:00',3.66),('12664','2013-09-07','12:00:00',3.66),('12664','2013-09-07','12:05:00',3.71),('12664','2013-09-07','12:10:00',3.64),('12664','2013-09-07','12:15:00',3.64),('12664','2013-09-07','12:20:00',3.73),('12664','2013-09-07','12:25:00',3.75),('12664','2013-09-07','12:30:00',3.75),('12664','2013-09-07','12:35:00',3.7),('12664','2013-09-07','12:40:00',3.75),('12664','2013-09-07','12:45:00',3.82),('12664','2013-09-07','12:50:00',3.82),('12664','2013-09-07','12:55:00',3.78),('12664','2013-09-07','13:00:00',3.84),('12664','2013-09-07','13:05:00',3.88),('12664','2013-09-07','13:10:00',3.81),('12664','2013-09-07','13:15:00',3.79),('12664','2013-09-07','13:20:00',3.8),('12664','2013-09-07','13:25:00',3.75),('12664','2013-09-07','13:30:00',3.78),('12664','2013-09-07','13:35:00',3.84),('12664','2013-09-07','13:40:00',3.88),('12664','2013-09-07','13:45:00',3.87),('12664','2013-09-07','13:50:00',3.83),('12664','2013-09-07','13:55:00',3.79),('12664','2013-09-07','14:00:00',3.83),('12664','2013-09-07','14:05:00',3.79),('12664','2013-09-07','14:10:00',3.78),('12664','2013-09-07','14:15:00',3.78),('12664','2013-09-07','14:20:00',3.74),('12664','2013-09-07','14:25:00',3.72),('12664','2013-09-07','14:30:00',3.71),('12664','2013-09-07','14:35:00',3.67),('12664','2013-09-07','14:40:00',3.65),('12664','2013-09-07','14:45:00',3.62),('12664','2013-09-07','14:50:00',3.57),('12664','2013-09-07','14:55:00',3.52),('12664','2013-09-07','15:00:00',3.48),('12664','2013-09-07','15:05:00',3.43),('12664','2013-09-07','15:10:00',3.4),('12664','2013-09-07','15:15:00',3.37),('12664','2013-09-07','15:20:00',3.3),('12664','2013-09-07','15:25:00',3.25),('12664','2013-09-07','15:30:00',3.21),('12664','2013-09-07','15:35:00',3.15),('12664','2013-09-07','15:40:00',3.09),('12664','2013-09-07','15:45:00',3.04),('12664','2013-09-07','15:50:00',2.98),('12664','2013-09-07','15:55:00',2.91),('12664','2013-09-07','16:00:00',2.83),('12664','2013-09-07','16:05:00',2.78),('12664','2013-09-07','16:10:00',2.71),('12664','2013-09-07','16:15:00',2.64),('12664','2013-09-07','16:20:00',2.55),('12664','2013-09-07','16:25:00',2.47),('12664','2013-09-07','16:30:00',2.4),('12664','2013-09-07','16:35:00',2.33),('12664','2013-09-07','16:40:00',2.25),('12664','2013-09-07','16:45:00',2.17),('12664','2013-09-07','16:50:00',2.07),('12664','2013-09-07','16:55:00',1.99),('12664','2013-09-07','17:00:00',1.91),('12664','2013-09-07','17:05:00',1.83),('12664','2013-09-07','17:10:00',1.74),('12664','2013-09-07','17:15:00',1.64),('12664','2013-09-07','17:20:00',1.53),('12664','2013-09-07','17:25:00',1.43),('12664','2013-09-07','17:30:00',1.36),('12664','2013-09-07','17:35:00',1.26),('12664','2013-09-07','17:40:00',1.18),('12664','2013-09-07','17:45:00',1.09),('12664','2013-09-07','17:50:00',1),('12664','2013-09-06','08:15:00',1.05),('12664','2013-09-06','08:20:00',1.14),('12664','2013-09-06','08:25:00',1.23),('12664','2013-09-06','08:30:00',1.32),('12664','2013-09-06','08:35:00',1.41),('12664','2013-09-06','08:40:00',1.5),('12664','2013-09-06','08:45:00',1.57),('12664','2013-09-06','08:50:00',1.63),('12664','2013-09-06','08:55:00',1.71),('12664','2013-09-06','09:00:00',1.8),('12664','2013-09-06','09:05:00',1.91),('12664','2013-09-06','09:10:00',2.01),('12664','2013-09-06','09:15:00',2.08),('12664','2013-09-06','09:20:00',2.16),('12664','2013-09-06','09:25:00',2.24),('12664','2013-09-06','09:30:00',2.32),('12664','2013-09-06','09:35:00',2.4),('12664','2013-09-06','09:40:00',2.49),('12664','2013-09-06','09:45:00',2.56),('12664','2013-09-06','09:50:00',2.64),('12664','2013-09-06','09:55:00',2.71),('12664','2013-09-06','10:00:00',2.76),('12664','2013-09-06','10:05:00',2.84),('12664','2013-09-06','10:10:00',2.9),('12664','2013-09-06','10:15:00',2.95),('12664','2013-09-06','10:20:00',3),('12664','2013-09-06','10:25:00',3.07),('12664','2013-09-06','10:30:00',3.14),('12664','2013-09-06','10:35:00',3.18),('12664','2013-09-06','10:40:00',3.23),('12664','2013-09-06','10:45:00',3.27),('12664','2013-09-06','10:50:00',3.32),('12664','2013-09-06','10:55:00',3.39),('12664','2013-09-06','11:00:00',3.42),('12664','2013-09-06','11:05:00',3.43),('12664','2013-09-06','11:10:00',3.47),('12664','2013-09-06','11:15:00',3.5),('12664','2013-09-06','11:20:00',3.55),('12664','2013-09-06','11:25:00',3.57),('12664','2013-09-06','11:30:00',3.59),('12664','2013-09-06','11:35:00',3.61),('12664','2013-09-06','11:40:00',3.63),('12664','2013-09-06','11:45:00',3.64),('12664','2013-09-06','11:50:00',3.7),('12664','2013-09-06','11:55:00',3.68),('12664','2013-09-06','12:00:00',3.7),('12664','2013-09-06','12:05:00',3.73),('12664','2013-09-06','12:10:00',3.74),('12664','2013-09-06','12:15:00',3.79),('12664','2013-09-06','12:20:00',3.81),('12664','2013-09-06','12:25:00',3.83),('12664','2013-09-06','12:30:00',3.79),('12664','2013-09-06','12:35:00',3.81),('12664','2013-09-06','12:40:00',3.78),('12664','2013-09-06','12:45:00',3.82),('12664','2013-09-06','12:50:00',3.82),('12664','2013-09-06','12:55:00',3.84),('12664','2013-09-06','13:00:00',3.83),('12664','2013-09-06','13:05:00',3.83),('12664','2013-09-06','13:10:00',3.82),('12664','2013-09-06','13:15:00',3.81),('12664','2013-09-06','13:20:00',3.82),('12664','2013-09-06','13:25:00',3.81),('12664','2013-09-06','13:30:00',3.76),('12664','2013-09-06','13:35:00',3.76),('12664','2013-09-06','13:40:00',3.74),('12664','2013-09-06','13:45:00',3.71),('12664','2013-09-06','13:50:00',3.67),('12664','2013-09-06','13:55:00',3.66),('12664','2013-09-06','14:00:00',3.64),('12664','2013-09-06','14:05:00',3.66),('12664','2013-09-06','14:10:00',3.63),('12664','2013-09-06','14:15:00',3.67),('12664','2013-09-06','14:20:00',3.6),('12664','2013-09-06','14:25:00',3.63),('12664','2013-09-06','14:30:00',3.67),('12664','2013-09-06','14:35:00',3.61),('12664','2013-09-06','14:40:00',3.57),('12664','2013-09-06','14:45:00',3.53),('12664','2013-09-06','14:50:00',3.5),('12664','2013-09-06','14:55:00',3.44),('12664','2013-09-06','15:00:00',3.41),('12664','2013-09-06','15:05:00',3.4),('12664','2013-09-06','15:10:00',3.35),('12664','2013-09-06','15:15:00',3.3),('12664','2013-09-06','15:20:00',3.28),('12664','2013-09-06','15:25:00',3.23),('12664','2013-09-06','15:30:00',3.19),('12664','2013-09-06','15:35:00',3.14),('12664','2013-09-06','15:40:00',3.1),('12664','2013-09-06','15:45:00',3.05),('12664','2013-09-06','15:50:00',2.97),('12664','2013-09-06','15:55:00',2.9),('12664','2013-09-06','16:00:00',2.83),('12664','2013-09-06','16:05:00',2.77),('12664','2013-09-06','16:10:00',2.73),('12664','2013-09-06','16:15:00',2.66),('12664','2013-09-06','16:20:00',2.61),('12664','2013-09-06','16:25:00',2.52),('12664','2013-09-06','16:30:00',2.44),('12664','2013-09-06','16:35:00',2.37),('12664','2013-09-06','16:40:00',2.27),('12664','2013-09-06','16:45:00',2.18),('12664','2013-09-06','16:50:00',2.1),('12664','2013-09-06','16:55:00',2.02),('12664','2013-09-06','17:00:00',1.92),('12664','2013-09-06','17:05:00',1.82),('12664','2013-09-06','17:10:00',1.72),('12664','2013-09-06','17:15:00',1.62),('12664','2013-09-06','17:20:00',1.52),('12664','2013-09-06','17:25:00',1.44),('12664','2013-09-06','17:30:00',1.36),('12664','2013-09-06','17:35:00',1.25),('12664','2013-09-06','17:40:00',1.17),('12664','2013-09-06','17:45:00',1.08),('12664','2013-09-05','08:10:00',1.05),('12664','2013-09-05','08:15:00',1.16),('12664','2013-09-05','08:20:00',1.26),('12664','2013-09-05','08:25:00',1.35),('12664','2013-09-05','08:30:00',1.45),('12664','2013-09-05','08:35:00',1.54),('12664','2013-09-05','08:40:00',1.63),('12664','2013-09-05','08:45:00',1.72),('12664','2013-09-05','08:50:00',1.82),('12664','2013-09-05','08:55:00',1.91),('12664','2013-09-05','09:00:00',1.99),('12664','2013-09-05','09:05:00',2.07),('12664','2013-09-05','09:10:00',2.14),('12664','2013-09-05','09:15:00',2.23),('12664','2013-09-05','09:20:00',2.31),('12664','2013-09-05','09:25:00',2.39),('12664','2013-09-05','09:30:00',2.45),('12664','2013-09-05','09:35:00',2.5),('12664','2013-09-05','09:40:00',2.56),('12664','2013-09-05','09:45:00',2.63),('12664','2013-09-05','09:50:00',2.7),('12664','2013-09-05','09:55:00',2.79),('12664','2013-09-05','10:00:00',2.88),('12664','2013-09-05','10:05:00',2.95),('12664','2013-09-05','10:10:00',2.98),('12664','2013-09-05','10:15:00',3.03),('12664','2013-09-05','10:20:00',3.09),('12664','2013-09-05','10:25:00',3.17),('12664','2013-09-05','10:30:00',3.22),('12664','2013-09-05','10:35:00',3.27),('12664','2013-09-05','10:40:00',3.32),('12664','2013-09-05','10:45:00',3.36),('12664','2013-09-05','10:50:00',3.4),('12664','2013-09-05','10:55:00',3.45),('12664','2013-09-05','11:00:00',3.47),('12664','2013-09-05','11:05:00',3.51),('12664','2013-09-05','11:10:00',3.52),('12664','2013-09-05','11:15:00',3.54),('12664','2013-09-05','11:20:00',3.61),('12664','2013-09-05','11:25:00',3.65),('12664','2013-09-05','11:30:00',3.7),('12664','2013-09-05','11:35:00',3.72),('12664','2013-09-05','11:40:00',3.75),('12664','2013-09-05','11:45:00',3.8),('12664','2013-09-05','11:50:00',3.82),('12664','2013-09-05','11:55:00',3.86),('12664','2013-09-05','12:00:00',3.84),('12664','2013-09-05','12:05:00',3.86),('12664','2013-09-05','12:10:00',3.9),('12664','2013-09-05','12:15:00',3.94),('12664','2013-09-05','12:20:00',3.95),('12664','2013-09-05','12:25:00',3.94),('12664','2013-09-05','12:30:00',3.92),('12664','2013-09-05','12:35:00',3.95),('12664','2013-09-05','12:40:00',3.96),('12664','2013-09-05','12:45:00',3.95),('12664','2013-09-05','12:50:00',3.95),('12664','2013-09-05','12:55:00',3.93),('12664','2013-09-05','13:00:00',3.93),('12664','2013-09-05','13:05:00',3.94),('12664','2013-09-05','13:10:00',3.94),('12664','2013-09-05','13:15:00',3.92),('12664','2013-09-05','13:20:00',3.91),('12664','2013-09-05','13:25:00',3.91),('12664','2013-09-05','13:30:00',3.88),('12664','2013-09-05','13:35:00',3.84),('12664','2013-09-05','13:40:00',3.82),('12664','2013-09-05','13:45:00',3.82),('12664','2013-09-05','13:50:00',3.82),('12664','2013-09-05','13:55:00',3.8),('12664','2013-09-05','14:00:00',3.8),('12664','2013-09-05','14:05:00',3.79),('12664','2013-09-05','14:10:00',3.8),('12664','2013-09-05','14:15:00',3.82),('12664','2013-09-05','14:20:00',3.81),('12664','2013-09-05','14:25:00',3.78),('12664','2013-09-05','14:30:00',3.76),('12664','2013-09-05','14:35:00',3.71),('12664','2013-09-05','14:40:00',3.67),('12664','2013-09-05','14:45:00',3.65),('12664','2013-09-05','14:50:00',3.62),('12664','2013-09-05','14:55:00',3.59),('12664','2013-09-05','15:00:00',3.57),('12664','2013-09-05','15:05:00',3.53),('12664','2013-09-05','15:10:00',3.47),('12664','2013-09-05','15:15:00',3.43),('12664','2013-09-05','15:20:00',3.37),('12664','2013-09-05','15:25:00',3.32),('12664','2013-09-05','15:30:00',3.29),('12664','2013-09-05','15:35:00',3.24),('12664','2013-09-05','15:40:00',3.17),('12664','2013-09-05','15:45:00',3.1),('12664','2013-09-05','15:50:00',3.04),('12664','2013-09-05','15:55:00',3),('12664','2013-09-05','16:00:00',2.93),('12664','2013-09-05','16:05:00',2.86),('12664','2013-09-05','16:10:00',2.8),('12664','2013-09-05','16:15:00',2.75),('12664','2013-09-05','16:20:00',2.7),('12664','2013-09-05','16:25:00',2.64),('12664','2013-09-05','16:30:00',2.56),('12664','2013-09-05','16:35:00',2.51),('12664','2013-09-05','16:40:00',2.44),('12664','2013-09-05','16:45:00',2.39),('12664','2013-09-05','16:50:00',2.33),('12664','2013-09-05','16:55:00',2.02),('12664','2013-09-05','17:00:00',1.4),('12664','2013-09-05','17:05:00',1.38),('12664','2013-09-05','17:10:00',1.43),('12664','2013-09-05','17:15:00',1.23),('12664','2013-09-05','17:20:00',1.29),('12664','2013-09-05','17:25:00',1.29),('12664','2013-09-05','17:30:00',1.26),('12664','2013-09-05','17:35:00',1.42),('12664','2013-09-05','17:40:00',1.42),('12664','2013-09-05','17:45:00',1.42),('12664','2013-09-05','17:50:00',1.25),('12664','2013-09-05','17:55:00',1.2),('12664','2013-09-04','08:10:00',1.06),('12664','2013-09-04','08:15:00',1.16),('12664','2013-09-04','08:20:00',1.26),('12664','2013-09-04','08:25:00',1.36),('12664','2013-09-04','08:30:00',1.45),('12664','2013-09-04','08:35:00',1.55),('12664','2013-09-04','08:40:00',1.64),('12664','2013-09-04','08:45:00',1.74),('12664','2013-09-04','08:50:00',1.83),('12664','2013-09-04','08:55:00',1.92),('12664','2013-09-04','09:00:00',2),('12664','2013-09-04','09:05:00',2.09),('12664','2013-09-04','09:10:00',2.18),('12664','2013-09-04','09:15:00',2.26),('12664','2013-09-04','09:20:00',2.34),('12664','2013-09-04','09:25:00',2.43),('12664','2013-09-04','09:30:00',2.5),('12664','2013-09-04','09:35:00',2.58),('12664','2013-09-04','09:40:00',2.64),('12664','2013-09-04','09:45:00',2.71),('12664','2013-09-04','09:50:00',2.78),('12664','2013-09-04','09:55:00',2.83),('12664','2013-09-04','10:00:00',2.91),('12664','2013-09-04','10:05:00',2.99),('12664','2013-09-04','10:10:00',3.05),('12664','2013-09-04','10:15:00',3.11),('12664','2013-09-04','10:20:00',3.16),('12664','2013-09-04','10:25:00',3.2),('12664','2013-09-04','10:30:00',3.24),('12664','2013-09-04','10:35:00',3.28),('12664','2013-09-04','10:40:00',3.32),('12664','2013-09-04','10:45:00',3.35),('12664','2013-09-04','10:50:00',3.4),('12664','2013-09-04','10:55:00',3.44),('12664','2013-09-04','11:00:00',3.49),('12664','2013-09-04','11:05:00',3.53),('12664','2013-09-04','11:10:00',3.6),('12664','2013-09-04','11:15:00',3.65),('12664','2013-09-04','11:20:00',3.7),('12664','2013-09-04','11:25:00',3.71),('12664','2013-09-04','11:30:00',3.74),('12664','2013-09-04','11:35:00',3.76),('12664','2013-09-04','11:40:00',3.81),('12664','2013-09-04','11:45:00',3.83),('12664','2013-09-04','11:50:00',3.87),('12664','2013-09-04','11:55:00',3.88),('12664','2013-09-04','12:00:00',3.9),('12664','2013-09-04','12:05:00',3.95),('12664','2013-09-04','12:10:00',3.94),('12664','2013-09-04','12:15:00',3.96),('12664','2013-09-04','12:20:00',3.98),('12664','2013-09-04','12:25:00',4.02),('12664','2013-09-04','12:30:00',4.04),('12664','2013-09-04','12:35:00',4.08),('12664','2013-09-04','12:40:00',4.07),('12664','2013-09-04','12:45:00',4.04),('12664','2013-09-04','12:50:00',4.03),('12664','2013-09-04','12:55:00',4.03),('12664','2013-09-04','13:00:00',4.05),('12664','2013-09-04','13:05:00',4.03),('12664','2013-09-04','13:10:00',4.03),('12664','2013-09-04','13:15:00',4.05),('12664','2013-09-04','13:20:00',4.05),('12664','2013-09-04','13:25:00',4.03),('12664','2013-09-04','13:30:00',3.99),('12664','2013-09-04','13:35:00',4),('12664','2013-09-04','13:40:00',3.98),('12664','2013-09-04','13:45:00',3.96),('12664','2013-09-04','13:50:00',3.94),('12664','2013-09-04','13:55:00',3.91),('12664','2013-09-04','14:00:00',3.9),('12664','2013-09-04','14:05:00',3.91),('12664','2013-09-04','14:10:00',3.88),('12664','2013-09-04','14:15:00',3.83),('12664','2013-09-04','14:20:00',3.8),('12664','2013-09-04','14:25:00',3.75),('12664','2013-09-04','14:30:00',3.75),('12664','2013-09-04','14:35:00',3.74),('12664','2013-09-04','14:40:00',3.72),('12664','2013-09-04','14:45:00',3.7),('12664','2013-09-04','14:50:00',3.66),('12664','2013-09-04','14:55:00',3.62),('12664','2013-09-04','15:00:00',3.58),('12664','2013-09-04','15:05:00',3.53),('12664','2013-09-04','15:10:00',3.49),('12664','2013-09-04','15:15:00',3.43),('12664','2013-09-04','15:20:00',3.36),('12664','2013-09-04','15:25:00',3.33),('12664','2013-09-04','15:30:00',3.27),('12664','2013-09-04','15:35:00',3.23),('12664','2013-09-04','15:40:00',3.1),('12664','2013-09-04','15:45:00',3.06),('12664','2013-09-04','15:50:00',2.45),('12664','2013-09-04','15:55:00',3.03),('12664','2013-09-04','16:00:00',2.98),('12664','2013-09-04','16:05:00',2.91),('12664','2013-09-04','16:10:00',2.83),('12664','2013-09-04','16:15:00',2.76),('12664','2013-09-04','16:20:00',2.7),('12664','2013-09-04','16:25:00',2.61),('12664','2013-09-04','16:30:00',2.51),('12664','2013-09-04','16:35:00',2.42),('12664','2013-09-04','16:40:00',2.35),('12664','2013-09-04','16:45:00',2.25),('12664','2013-09-04','16:50:00',2.18),('12664','2013-09-04','16:55:00',2.08),('12664','2013-09-04','17:00:00',1.98),('12664','2013-09-04','17:05:00',1.82),('12664','2013-09-04','17:10:00',1.83),('12664','2013-09-04','17:15:00',1.75),('12664','2013-09-04','17:20:00',1.67),('12664','2013-09-04','17:25:00',1.58),('12664','2013-09-04','17:30:00',1.5),('12664','2013-09-04','17:35:00',1.39),('12664','2013-09-04','17:40:00',1.3),('12664','2013-09-04','17:45:00',1.21),('12664','2013-09-04','17:50:00',1.12),('12664','2013-09-04','17:55:00',1.02),('12664','2013-09-03','08:15:00',1.04),('12664','2013-09-03','08:20:00',1.13),('12664','2013-09-03','08:25:00',1.22),('12664','2013-09-03','08:30:00',1.31),('12664','2013-09-03','08:35:00',1.4),('12664','2013-09-03','08:40:00',1.49),('12664','2013-09-03','08:45:00',1.58),('12664','2013-09-03','08:50:00',1.66),('12664','2013-09-03','08:55:00',1.75),('12664','2013-09-03','09:00:00',1.84),('12664','2013-09-03','09:05:00',1.92),('12664','2013-09-03','09:10:00',2.02),('12664','2013-09-03','09:15:00',2.1),('12664','2013-09-03','09:20:00',2.18),('12664','2013-09-03','09:25:00',2.26),('12664','2013-09-03','09:30:00',2.35),('12664','2013-09-03','09:35:00',2.44),('12664','2013-09-03','09:40:00',2.52),('12664','2013-09-03','09:45:00',2.58),('12664','2013-09-03','09:50:00',2.63),('12664','2013-09-03','09:55:00',2.7),('12664','2013-09-03','10:00:00',2.77),('12664','2013-09-03','10:05:00',2.83),('12664','2013-09-03','10:10:00',2.9),('12664','2013-09-03','10:15:00',2.95),('12664','2013-09-03','10:20:00',2.99),('12664','2013-09-03','10:25:00',3.04),('12664','2013-09-03','10:30:00',3.11),('12664','2013-09-03','10:35:00',3.17),('12664','2013-09-03','10:40:00',3.23),('12664','2013-09-03','10:45:00',3.28),('12664','2013-09-03','10:50:00',3.32),('12664','2013-09-03','10:55:00',3.35),('12664','2013-09-03','11:00:00',3.4),('12664','2013-09-03','11:05:00',3.43),('12664','2013-09-03','11:10:00',3.47),('12664','2013-09-03','11:15:00',3.5),('12664','2013-09-03','11:20:00',3.54),('12664','2013-09-03','11:25:00',3.58),('12664','2013-09-03','11:30:00',3.63),('12664','2013-09-03','11:35:00',3.67),('12664','2013-09-03','11:40:00',3.67),('12664','2013-09-03','11:45:00',3.7),('12664','2013-09-03','11:50:00',3.7),('12664','2013-09-03','11:55:00',3.71),('12664','2013-09-03','12:00:00',3.75),('12664','2013-09-03','12:05:00',3.79),('12664','2013-09-03','12:10:00',3.8),('12664','2013-09-03','12:15:00',3.84),('12664','2013-09-03','12:20:00',3.82),('12664','2013-09-03','12:25:00',3.87),('12664','2013-09-03','12:30:00',3.93),('12664','2013-09-03','12:35:00',3.97),('12664','2013-09-03','12:40:00',3.97),('12664','2013-09-03','12:45:00',3.96),('12664','2013-09-03','12:50:00',3.98),('12664','2013-09-03','12:55:00',3.98),('12664','2013-09-03','13:00:00',3.99),('12664','2013-09-03','13:05:00',4),('12664','2013-09-03','13:10:00',4),('12664','2013-09-03','13:15:00',4.01),('12664','2013-09-03','13:20:00',3.99),('12664','2013-09-03','13:25:00',3.96),('12664','2013-09-03','13:30:00',3.92),('12664','2013-09-03','13:35:00',3.92),('12664','2013-09-03','13:40:00',3.92),('12664','2013-09-03','13:45:00',3.92),('12664','2013-09-03','13:50:00',3.91),('12664','2013-09-03','13:55:00',3.9),('12664','2013-09-03','14:00:00',3.91),('12664','2013-09-03','14:05:00',3.89),('12664','2013-09-03','14:10:00',3.86),('12664','2013-09-03','14:15:00',3.83),('12664','2013-09-03','14:20:00',3.78),('12664','2013-09-03','14:25:00',3.72),('12664','2013-09-03','14:30:00',3.68),('12664','2013-09-03','14:35:00',3.7),('12664','2013-09-03','14:40:00',3.66),('12664','2013-09-03','14:45:00',3.64),('12664','2013-09-03','14:50:00',3.59),('12664','2013-09-03','14:55:00',3.55),('12664','2013-09-03','15:00:00',3.51),('12664','2013-09-03','15:05:00',3.45),('12664','2013-09-03','15:10:00',3.42),('12664','2013-09-03','15:15:00',3.36),('12664','2013-09-03','15:20:00',3.32),('12664','2013-09-03','15:25:00',3.27),('12664','2013-09-03','15:30:00',3.2),('12664','2013-09-03','15:35:00',3.15),('12664','2013-09-03','15:40:00',3.1),('12664','2013-09-03','15:45:00',3.08),('12664','2013-09-03','15:50:00',3.01),('12664','2013-09-03','15:55:00',2.96),('12664','2013-09-03','16:00:00',2.88),('12664','2013-09-03','16:05:00',2.81),('12664','2013-09-03','16:10:00',2.76),('12664','2013-09-03','16:15:00',2.7),('12664','2013-09-03','16:20:00',2.63),('12664','2013-09-03','16:25:00',2.55),('12664','2013-09-03','16:30:00',2.47),('12664','2013-09-03','16:35:00',2.42),('12664','2013-09-03','16:40:00',2.34),('12664','2013-09-03','16:45:00',2.28),('12664','2013-09-03','16:50:00',2.19),('12664','2013-09-03','16:55:00',2.11),('12664','2013-09-03','17:00:00',2.03),('12664','2013-09-03','17:05:00',1.96),('12664','2013-09-03','17:10:00',1.87),('12664','2013-09-03','17:15:00',1.66),('12664','2013-09-03','17:20:00',1.52),('12664','2013-09-03','17:25:00',1.43),('12664','2013-09-03','17:30:00',1.42),('12664','2013-09-03','17:35:00',1.34),('12664','2013-09-03','17:40:00',1.27),('12664','2013-09-03','17:45:00',1.18),('12664','2013-09-03','17:50:00',1.1),('12664','2013-09-02','08:15:00',1.09),('12664','2013-09-02','08:20:00',1.18),('12664','2013-09-02','08:25:00',1.28),('12664','2013-09-02','08:30:00',1.37),('12664','2013-09-02','08:35:00',1.46),('12664','2013-09-02','08:40:00',1.55),('12664','2013-09-02','08:45:00',1.64),('12664','2013-09-02','08:50:00',1.74),('12664','2013-09-02','08:55:00',1.83),('12664','2013-09-02','09:00:00',1.92),('12664','2013-09-02','09:05:00',2.01),('12664','2013-09-02','09:10:00',2.09),('12664','2013-09-02','09:15:00',2.17),('12664','2013-09-02','09:20:00',2.26),('12664','2013-09-02','09:25:00',2.34),('12664','2013-09-02','09:30:00',2.41),('12664','2013-09-02','09:35:00',2.49),('12664','2013-09-02','09:40:00',2.57),('12664','2013-09-02','09:45:00',2.63),('12664','2013-09-02','09:50:00',2.7),('12664','2013-09-02','09:55:00',2.75),('12664','2013-09-02','10:00:00',2.81),('12664','2013-09-02','10:05:00',2.88),('12664','2013-09-02','10:10:00',2.96),('12664','2013-09-02','10:15:00',3.02),('12664','2013-09-02','10:20:00',3.09),('12664','2013-09-02','10:25:00',3.15),('12664','2013-09-02','10:30:00',3.21),('12664','2013-09-02','10:35:00',3.26),('12664','2013-09-02','10:40:00',3.31),('12664','2013-09-02','10:45:00',3.36),('12664','2013-09-02','10:50:00',3.4),('12664','2013-09-02','10:55:00',3.44),('12664','2013-09-02','11:00:00',3.46),('12664','2013-09-02','11:05:00',3.5),('12664','2013-09-02','11:10:00',3.54),('12664','2013-09-02','11:15:00',3.58),('12664','2013-09-02','11:20:00',3.6),('12664','2013-09-02','11:25:00',3.64),('12664','2013-09-02','11:30:00',3.68),('12664','2013-09-02','11:35:00',3.71),('12664','2013-09-02','11:40:00',3.73),('12664','2013-09-02','11:45:00',3.72),('12664','2013-09-02','11:50:00',3.76),('12664','2013-09-02','11:55:00',3.81),('12664','2013-09-02','12:00:00',3.86),('12664','2013-09-02','12:05:00',3.84),('12664','2013-09-02','12:10:00',3.86),('12664','2013-09-02','12:15:00',3.9),('12664','2013-09-02','12:20:00',3.91),('12664','2013-09-02','12:25:00',3.92),('12664','2013-09-02','12:30:00',3.9),('12664','2013-09-02','12:35:00',3.91),('12664','2013-09-02','12:40:00',3.92),('12664','2013-09-02','12:45:00',3.93),('12664','2013-09-02','12:50:00',3.95),('12664','2013-09-02','12:55:00',3.92),('12664','2013-09-02','13:00:00',3.92),('12664','2013-09-02','13:05:00',3.93),('12664','2013-09-02','13:10:00',3.92),('12664','2013-09-02','13:15:00',3.89),('12664','2013-09-02','13:20:00',3.9),('12664','2013-09-02','13:25:00',3.89),('12664','2013-09-02','13:30:00',3.91),('12664','2013-09-02','13:35:00',3.92),('12664','2013-09-02','13:40:00',3.87),('12664','2013-09-02','13:45:00',3.82),('12664','2013-09-02','13:50:00',3.82),('12664','2013-09-02','13:55:00',3.85),('12664','2013-09-02','14:00:00',3.94),('12664','2013-09-02','14:05:00',3.88),('12664','2013-09-02','14:10:00',3.83),('12664','2013-09-02','14:15:00',3.77),('12664','2013-09-02','14:20:00',3.75),('12664','2013-09-02','14:25:00',3.74),('12664','2013-09-02','14:30:00',3.67),('12664','2013-09-02','14:35:00',3.66),('12664','2013-09-02','14:40:00',3.62),('12664','2013-09-02','14:45:00',3.61),('12664','2013-09-02','14:50:00',3.59),('12664','2013-09-02','14:55:00',3.47),('12664','2013-09-02','15:00:00',3.06),('12664','2013-09-02','15:05:00',3.48),('12664','2013-09-02','15:10:00',3.44),('12664','2013-09-02','15:15:00',3.39),('12664','2013-09-02','15:20:00',3.41),('12664','2013-09-02','15:25:00',3.4),('12664','2013-09-02','15:30:00',3.29),('12664','2013-09-02','15:35:00',3.24),('12664','2013-09-02','15:40:00',3.18),('12664','2013-09-02','15:45:00',3.07),('12664','2013-09-02','15:50:00',3.04),('12664','2013-09-02','15:55:00',2.98),('12664','2013-09-02','16:00:00',2.94),('12664','2013-09-02','16:05:00',2.91),('12664','2013-09-02','16:10:00',2.83),('12664','2013-09-02','16:15:00',2.76),('12664','2013-09-02','16:20:00',2.64),('12664','2013-09-02','16:25:00',2.59),('12664','2013-09-02','16:30:00',2.52),('12664','2013-09-02','16:35:00',2.45),('12664','2013-09-02','16:40:00',2.39),('12664','2013-09-02','16:45:00',2.3),('12664','2013-09-02','16:50:00',2.21),('12664','2013-09-02','16:55:00',2.12),('12664','2013-09-02','17:00:00',2.02),('12664','2013-09-02','17:05:00',1.93),('12664','2013-09-02','17:10:00',1.84),('12664','2013-09-02','17:15:00',1.73),('12664','2013-09-02','17:20:00',1.66),('12664','2013-09-02','17:25:00',1.58),('12664','2013-09-02','17:30:00',1.48),('12664','2013-09-02','17:35:00',1.39),('12664','2013-09-02','17:40:00',1.3),('12664','2013-09-02','17:45:00',1.21),('12664','2013-09-02','17:50:00',1.13),('12664','2013-09-02','17:55:00',1.02),('12664','2013-09-01','08:10:00',1.04),('12664','2013-09-01','08:15:00',1.15),('12664','2013-09-01','08:20:00',1.25),('12664','2013-09-01','08:25:00',1.34),('12664','2013-09-01','08:30:00',1.43),('12664','2013-09-01','08:35:00',1.52),('12664','2013-09-01','08:40:00',1.6),('12664','2013-09-01','08:45:00',1.7),('12664','2013-09-01','08:50:00',1.78),('12664','2013-09-01','08:55:00',1.86),('12664','2013-09-01','09:00:00',1.96),('12664','2013-09-01','09:05:00',2.05),('12664','2013-09-01','09:10:00',2.13),('12664','2013-09-01','09:15:00',2.22),('12664','2013-09-01','09:20:00',2.3),('12664','2013-09-01','09:25:00',2.38),('12664','2013-09-01','09:30:00',2.47),('12664','2013-09-01','09:35:00',2.53),('12664','2013-09-01','09:40:00',2.62),('12664','2013-09-01','09:45:00',2.69),('12664','2013-09-01','09:50:00',2.76),('12664','2013-09-01','09:55:00',2.83),('12664','2013-09-01','10:00:00',2.89),('12664','2013-09-01','10:05:00',2.95),('12664','2013-09-01','10:10:00',3.01),('12664','2013-09-01','10:15:00',3.08),('12664','2013-09-01','10:20:00',3.13),('12664','2013-09-01','10:25:00',3.18),('12664','2013-09-01','10:30:00',3.22),('12664','2013-09-01','10:35:00',3.27),('12664','2013-09-01','10:40:00',3.32),('12664','2013-09-01','10:45:00',3.35),('12664','2013-09-01','10:50:00',3.41),('12664','2013-09-01','10:55:00',3.47),('12664','2013-09-01','11:00:00',3.5),('12664','2013-09-01','11:05:00',3.56),('12664','2013-09-01','11:10:00',3.6),('12664','2013-09-01','11:15:00',3.65),('12664','2013-09-01','11:20:00',3.68),('12664','2013-09-01','11:25:00',3.7),('12664','2013-09-01','11:30:00',3.75),('12664','2013-09-01','11:35:00',3.77),('12664','2013-09-01','11:40:00',3.81),('12664','2013-09-01','11:45:00',3.84),('12664','2013-09-01','11:50:00',3.88),('12664','2013-09-01','11:55:00',3.88),('12664','2013-09-01','12:00:00',3.89),('12664','2013-09-01','12:05:00',3.93),('12664','2013-09-01','12:10:00',3.96),('12664','2013-09-01','12:15:00',3.96),('12664','2013-09-01','12:20:00',3.95),('12664','2013-09-01','12:25:00',4.01),('12664','2013-09-01','12:30:00',4),('12664','2013-09-01','12:35:00',4.01),('12664','2013-09-01','12:40:00',4),('12664','2013-09-01','12:45:00',4.01),('12664','2013-09-01','12:50:00',4),('12664','2013-09-01','12:55:00',3.87),('12664','2013-09-01','13:00:00',4.03),('12664','2013-09-01','13:05:00',3.6),('12664','2013-09-01','13:10:00',3.53),('12664','2013-09-01','13:15:00',3.9),('12664','2013-09-01','13:20:00',3.58),('12664','2013-09-01','13:25:00',3.57),('12664','2013-09-01','13:30:00',3.53),('12664','2013-09-01','13:35:00',3.86),('12664','2013-09-01','13:40:00',4.09),('12664','2013-09-01','13:45:00',4.06),('12664','2013-09-01','13:50:00',3.91),('12664','2013-09-01','13:55:00',3.65),('12664','2013-09-01','14:00:00',3.89),('12664','2013-09-01','14:05:00',3.69),('12664','2013-09-01','14:10:00',3.67),('12664','2013-09-01','14:15:00',3.73),('12664','2013-09-01','14:20:00',3.56),('12664','2013-09-01','14:25:00',3.43),('12664','2013-09-01','14:30:00',3.05),('12664','2013-09-01','14:35:00',2.92),('12664','2013-09-01','14:40:00',3.58),('12664','2013-09-01','14:45:00',3.59),('12664','2013-09-01','14:50:00',3.54),('12664','2013-09-01','14:55:00',3.57),('12664','2013-09-01','15:00:00',3.49),('12664','2013-09-01','15:05:00',3.37),('12664','2013-09-01','15:10:00',3.2),('12664','2013-09-01','15:15:00',3.18),('12664','2013-09-01','15:20:00',3.16),('12664','2013-09-01','15:25:00',2.99),('12664','2013-09-01','15:30:00',2.72),('12664','2013-09-01','15:35:00',2.76),('12664','2013-09-01','15:40:00',2.82),('12664','2013-09-01','15:45:00',2.74),('12664','2013-09-01','15:50:00',2.44),('12664','2013-09-01','15:55:00',2.1),('12664','2013-09-01','16:00:00',2.42),('12664','2013-09-01','16:05:00',2.69),('12664','2013-09-01','16:10:00',2.67),('12664','2013-09-01','16:15:00',2.64),('12664','2013-09-01','16:20:00',2.65),('12664','2013-09-01','16:25:00',2.57),('12664','2013-09-01','16:30:00',2.56),('12664','2013-09-01','16:35:00',2.35),('12664','2013-09-01','16:40:00',2.08),('12664','2013-09-01','16:45:00',2.09),('12664','2013-09-01','16:50:00',1.98),('12664','2013-09-01','16:55:00',2.01),('12664','2013-09-01','17:00:00',2),('12664','2013-09-01','17:05:00',2.03),('12664','2013-09-01','17:10:00',1.96),('12664','2013-09-01','17:15:00',1.88),('12664','2013-09-01','17:20:00',1.7),('12664','2013-09-01','17:25:00',1.65),('12664','2013-09-01','17:30:00',1.6),('12664','2013-09-01','17:35:00',1.38),('12664','2013-09-01','17:40:00',1.33),('12664','2013-09-01','17:45:00',1.47),('12664','2013-09-01','17:50:00',1.32),('12664','2013-09-01','17:55:00',1.22),('12664','2013-09-01','18:00:00',1.08),('12664','2013-09-01','18:05:00',1.02),('12664','2013-08-31','08:15:00',1.03),('12664','2013-08-31','08:20:00',1.17),('12664','2013-08-31','08:25:00',1.4),('12664','2013-08-31','08:30:00',1.48),('12664','2013-08-31','08:35:00',1.56),('12664','2013-08-31','08:40:00',1.66),('12664','2013-08-31','08:45:00',1.84),('12664','2013-08-31','08:50:00',2.01),('12664','2013-08-31','08:55:00',2.16),('12664','2013-08-31','09:00:00',1.79),('12664','2013-08-31','09:05:00',1.17),('12664','2013-08-31','09:10:00',1.9),('12664','2013-08-31','09:15:00',2.34),('12664','2013-08-31','09:20:00',2.42),('12664','2013-08-31','09:25:00',2.55),('12664','2013-08-31','09:30:00',2.65),('12664','2013-08-31','09:35:00',2.6),('12664','2013-08-31','09:40:00',2.52),('12664','2013-08-31','09:45:00',2.67),('12664','2013-08-31','09:50:00',2.98),('12664','2013-08-31','09:55:00',2.88),('12664','2013-08-31','10:00:00',3.02),('12664','2013-08-31','10:05:00',3.11),('12664','2013-08-31','10:10:00',3.11),('12664','2013-08-31','10:15:00',3.13),('12664','2013-08-31','10:20:00',3.16),('12664','2013-08-31','10:25:00',3.24),('12664','2013-08-31','10:30:00',3.29),('12664','2013-08-31','10:35:00',3.27),('12664','2013-08-31','10:40:00',3.38),('12664','2013-08-31','10:45:00',3.44),('12664','2013-08-31','10:50:00',3.54),('12664','2013-08-31','10:55:00',3.61),('12664','2013-08-31','11:00:00',3.66),('12664','2013-08-31','11:05:00',3.71),('12664','2013-08-31','11:10:00',3.75),('12664','2013-08-31','11:15:00',3.79),('12664','2013-08-31','11:20:00',3.83),('12664','2013-08-31','11:25:00',3.85),('12664','2013-08-31','11:30:00',3.87),('12664','2013-08-31','11:35:00',3.87),('12664','2013-08-31','11:40:00',3.89),('12664','2013-08-31','11:45:00',3.92),('12664','2013-08-31','11:50:00',3.95),('12664','2013-08-31','11:55:00',3.96),('12664','2013-08-31','12:00:00',4),('12664','2013-08-31','12:05:00',4.01),('12664','2013-08-31','12:10:00',4.02),('12664','2013-08-31','12:15:00',4.03),('12664','2013-08-31','12:20:00',4.05),('12664','2013-08-31','12:25:00',4.07),('12664','2013-08-31','12:30:00',4.04),('12664','2013-08-31','12:35:00',4.04),('12664','2013-08-31','12:40:00',4.08),('12664','2013-08-31','12:45:00',4.05),('12664','2013-08-31','12:50:00',4.05),('12664','2013-08-31','12:55:00',4.06),('12664','2013-08-31','13:00:00',4.05),('12664','2013-08-31','13:05:00',4),('12664','2013-08-31','13:10:00',4.02),('12664','2013-08-31','13:15:00',4.05),('12664','2013-08-31','13:20:00',4.02),('12664','2013-08-31','13:25:00',4),('12664','2013-08-31','13:30:00',3.94),('12664','2013-08-31','13:35:00',3.96),('12664','2013-08-31','13:40:00',3.94),('12664','2013-08-31','13:45:00',3.89),('12664','2013-08-31','13:50:00',3.87),('12664','2013-08-31','13:55:00',3.88),('12664','2013-08-31','14:00:00',3.84),('12664','2013-08-31','14:05:00',3.85),('12664','2013-08-31','14:10:00',3.85),('12664','2013-08-31','14:15:00',3.79),('12664','2013-08-31','14:20:00',3.76),('12664','2013-08-31','14:25:00',3.74),('12664','2013-08-31','14:30:00',3.64),('12664','2013-08-31','14:35:00',3.64),('12664','2013-08-31','14:40:00',3.61),('12664','2013-08-31','14:45:00',3.54),('12664','2013-08-31','14:50:00',3.48),('12664','2013-08-31','14:55:00',3.47),('12664','2013-08-31','15:00:00',3.45),('12664','2013-08-31','15:05:00',3.41),('12664','2013-08-31','15:10:00',3.37),('12664','2013-08-31','15:15:00',3.3),('12664','2013-08-31','15:20:00',3.27),('12664','2013-08-31','15:25:00',3.24),('12664','2013-08-31','15:30:00',3.2),('12664','2013-08-31','15:35:00',3.14),('12664','2013-08-31','15:40:00',3.04),('12664','2013-08-31','15:45:00',3.01),('12664','2013-08-31','15:50:00',2.98),('12664','2013-08-31','15:55:00',2.96),('12664','2013-08-31','16:00:00',2.89),('12664','2013-08-31','16:05:00',2.83),('12664','2013-08-31','16:10:00',2.72),('12664','2013-08-31','16:15:00',2.63),('12664','2013-08-31','16:20:00',2.51),('12664','2013-08-31','16:25:00',2.56),('12664','2013-08-31','16:30:00',2.48),('12664','2013-08-31','16:35:00',2.34),('12664','2013-08-31','16:40:00',2.25),('12664','2013-08-31','16:45:00',2.2),('12664','2013-08-31','16:50:00',2.22),('12664','2013-08-31','16:55:00',2.16),('12664','2013-08-31','17:00:00',2.09),('12664','2013-08-31','17:05:00',2.02),('12664','2013-08-31','17:10:00',1.94),('12664','2013-08-31','17:15:00',1.8),('12664','2013-08-31','17:20:00',1.66),('12664','2013-08-31','17:25:00',1.52),('12664','2013-08-31','17:30:00',1.5),('12664','2013-08-31','17:35:00',1.47),('12664','2013-08-31','17:40:00',1.34),('12664','2013-08-31','17:45:00',1.25),('12664','2013-08-30','08:00:00',1.02),('12664','2013-08-30','08:05:00',1.18),('12664','2013-08-30','08:10:00',1.15),('12664','2013-08-30','08:15:00',1.19),('12664','2013-08-30','08:20:00',1.27),('12664','2013-08-30','08:25:00',1.3),('12664','2013-08-30','08:30:00',1.34),('12664','2013-08-30','08:35:00',1.38),('12664','2013-08-30','08:40:00',1.34),('12664','2013-08-30','08:45:00',1.19),('12664','2013-08-30','08:50:00',1.2),('12664','2013-08-30','08:55:00',1.45),('12664','2013-08-30','09:00:00',1.52),('12664','2013-08-30','09:05:00',1.44),('12664','2013-08-30','09:10:00',1.25),('12664','2013-08-30','09:15:00',1.14),('12664','2013-08-30','09:20:00',1.2),('12664','2013-08-30','09:25:00',1.32),('12664','2013-08-30','09:30:00',1.41),('12664','2013-08-30','09:35:00',1.73),('12664','2013-08-30','09:40:00',1.7),('12664','2013-08-30','09:45:00',1.8),('12664','2013-08-30','09:50:00',1.98),('12664','2013-08-30','09:55:00',1.95),('12664','2013-08-30','10:00:00',1.78),('12664','2013-08-30','10:05:00',1.83),('12664','2013-08-30','10:10:00',2),('12664','2013-08-30','10:15:00',2.05),('12664','2013-08-30','10:20:00',1.89),('12664','2013-08-30','10:25:00',2.17),('12664','2013-08-30','10:30:00',2.13),('12664','2013-08-30','10:35:00',2.08),('12664','2013-08-30','10:40:00',2.03),('12664','2013-08-30','10:45:00',2.12),('12664','2013-08-30','10:50:00',2.07),('12664','2013-08-30','10:55:00',2.04),('12664','2013-08-30','11:00:00',2.16),('12664','2013-08-30','11:05:00',2.36),('12664','2013-08-30','11:10:00',2.49),('12664','2013-08-30','11:15:00',2.4),('12664','2013-08-30','11:20:00',2.58),('12664','2013-08-30','11:25:00',2.64),('12664','2013-08-30','11:30:00',2.75),('12664','2013-08-30','11:35:00',2.62),('12664','2013-08-30','11:40:00',2.92),('12664','2013-08-30','11:45:00',3.04),('12664','2013-08-30','11:50:00',2.89),('12664','2013-08-30','11:55:00',2.77),('12664','2013-08-30','12:00:00',2.36),('12664','2013-08-30','12:05:00',2.68),('12664','2013-08-30','12:10:00',2.55),('12664','2013-08-30','12:15:00',2.56),('12664','2013-08-30','12:20:00',2.96),('12664','2013-08-30','12:25:00',3.22),('12664','2013-08-30','12:30:00',3.4),('12664','2013-08-30','12:35:00',3.25),('12664','2013-08-30','12:40:00',3.31),('12664','2013-08-30','12:45:00',3.2),('12664','2013-08-30','12:50:00',2.99),('12664','2013-08-30','12:55:00',2.88),('12664','2013-08-30','13:00:00',2.69),('12664','2013-08-30','13:05:00',2.53),('12664','2013-08-30','13:10:00',2.69),('12664','2013-08-30','13:15:00',2.91),('12664','2013-08-30','13:20:00',3.22),('12664','2013-08-30','13:25:00',4.28),('12664','2013-08-30','13:30:00',3.97),('12664','2013-08-30','13:35:00',3.85),('12664','2013-08-30','13:40:00',4.12),('12664','2013-08-30','13:45:00',3.94),('12664','2013-08-30','13:50:00',3.8),('12664','2013-08-30','13:55:00',3.92),('12664','2013-08-30','14:00:00',3.95),('12664','2013-08-30','14:05:00',4.04),('12664','2013-08-30','14:10:00',3.98),('12664','2013-08-30','14:15:00',3.75),('12664','2013-08-30','14:20:00',3.7),('12664','2013-08-30','14:25:00',3.61),('12664','2013-08-30','14:30:00',3.89),('12664','2013-08-30','14:35:00',3.63),('12664','2013-08-30','14:40:00',3.51),('12664','2013-08-30','14:45:00',2.96),('12664','2013-08-30','14:50:00',2.96),('12664','2013-08-30','14:55:00',3.17),('12664','2013-08-30','15:00:00',2.84),('12664','2013-08-30','15:05:00',2.73),('12664','2013-08-30','15:10:00',2.81),('12664','2013-08-30','15:15:00',2.87),('12664','2013-08-30','15:20:00',2.8),('12664','2013-08-30','15:25:00',2.66),('12664','2013-08-30','15:30:00',2.44),('12664','2013-08-30','15:35:00',2.6),('12664','2013-08-30','15:40:00',2.83),('12664','2013-08-30','15:45:00',2.51),('12664','2013-08-30','15:50:00',2.3),('12664','2013-08-30','15:55:00',2.07),('12664','2013-08-30','16:00:00',1.86),('12664','2013-08-30','16:05:00',1.95),('12664','2013-08-30','16:10:00',2.26),('12664','2013-08-30','16:15:00',2.15),('12664','2013-08-30','16:20:00',2.04),('12664','2013-08-30','16:25:00',1.89),('12664','2013-08-30','16:30:00',2.04),('12664','2013-08-30','16:35:00',2.12),('12664','2013-08-30','16:40:00',2.17),('12664','2013-08-30','16:45:00',2.19),('12664','2013-08-30','16:50:00',2.32),('12664','2013-08-30','16:55:00',1.41),('12664','2013-08-30','17:00:00',1.33),('12664','2013-08-30','17:05:00',1.17),('12664','2013-08-30','17:10:00',1.03),('12664','2013-08-30','17:15:00',1.45),('12664','2013-08-30','17:20:00',1.7),('12664','2013-08-30','17:25:00',1.44),('12664','2013-08-30','17:30:00',1.23),('12664','2013-08-30','17:35:00',1.15),('12664','2013-08-30','17:40:00',1.23),('12664','2013-08-30','17:45:00',1.52),('12664','2013-08-30','17:50:00',1.4),('12664','2013-08-30','17:55:00',1.12),('12664','2013-08-29','08:05:00',1.01),('12664','2013-08-29','08:10:00',1.15),('12664','2013-08-29','08:15:00',1.27),('12664','2013-08-29','08:20:00',1.45),('12664','2013-08-29','08:25:00',1.68),('12664','2013-08-29','08:30:00',1.92),('12664','2013-08-29','08:35:00',1.76),('12664','2013-08-29','08:40:00',1.22),('12664','2013-08-29','08:45:00',1.1),('12664','2013-08-29','08:50:00',1.21),('12664','2013-08-29','08:55:00',1.44),('12664','2013-08-29','09:00:00',1.33),('12664','2013-08-29','09:05:00',1.29),('12664','2013-08-29','09:10:00',1.33),('12664','2013-08-29','09:15:00',1.35),('12664','2013-08-29','09:20:00',1.49),('12664','2013-08-29','09:25:00',1.58),('12664','2013-08-29','09:30:00',1.61),('12664','2013-08-29','09:35:00',1.75),('12664','2013-08-29','09:40:00',1.52),('12664','2013-08-29','09:45:00',1.33),('12664','2013-08-29','09:50:00',1.36),('12664','2013-08-29','09:55:00',1.36),('12664','2013-08-29','10:00:00',1.39),('12664','2013-08-29','10:05:00',1.37),('12664','2013-08-29','10:10:00',1.34),('12664','2013-08-29','10:15:00',1.36),('12664','2013-08-29','10:20:00',1.41),('12664','2013-08-29','10:25:00',1.44),('12664','2013-08-29','10:30:00',1.42),('12664','2013-08-29','10:35:00',1.27),('12664','2013-08-29','10:40:00',1.18),('12664','2013-08-29','10:45:00',1.19),('12664','2013-08-29','10:50:00',1.35),('12664','2013-08-29','10:55:00',1.54),('12664','2013-08-29','11:00:00',1.51),('12664','2013-08-29','11:05:00',1.87),('12664','2013-08-29','11:10:00',2.05),('12664','2013-08-29','11:15:00',1.78),('12664','2013-08-29','11:20:00',1.46),('12664','2013-08-29','11:25:00',1.26),('12664','2013-08-29','11:30:00',1.25),('12664','2013-08-29','11:35:00',1.44),('12664','2013-08-29','11:40:00',1.63),('12664','2013-08-29','11:45:00',1.73),('12664','2013-08-29','11:50:00',1.81),('12664','2013-08-29','11:55:00',1.85),('12664','2013-08-29','12:00:00',2.11),('12664','2013-08-29','12:05:00',2.89),('12664','2013-08-29','12:10:00',3.63),('12664','2013-08-29','12:15:00',2.97),('12664','2013-08-29','12:20:00',3.03),('12664','2013-08-29','12:25:00',2.71),('12664','2013-08-29','12:30:00',2.72),('12664','2013-08-29','12:35:00',4.39),('12664','2013-08-29','12:40:00',4.65),('12664','2013-08-29','12:45:00',4.1),('12664','2013-08-29','12:50:00',2.93),('12664','2013-08-29','12:55:00',2.71),('12664','2013-08-29','13:00:00',2.89),('12664','2013-08-29','13:05:00',2.09),('12664','2013-08-29','13:10:00',2.08),('12664','2013-08-29','13:15:00',2.18),('12664','2013-08-29','13:20:00',1.98),('12664','2013-08-29','13:25:00',1.72),('12664','2013-08-29','13:30:00',1.68),('12664','2013-08-29','13:35:00',1.82),('12664','2013-08-29','13:40:00',1.65),('12664','2013-08-29','13:45:00',1.65),('12664','2013-08-29','13:50:00',2.52),('12664','2013-08-29','13:55:00',2.57),('12664','2013-08-29','14:00:00',1.76),('12664','2013-08-29','14:05:00',1.42),('12664','2013-08-29','14:10:00',1.24),('12664','2013-08-29','14:15:00',1.06),('12664','2013-08-29','14:20:00',1.02),('12664','2013-08-29','14:25:00',1.01),('12664','2013-08-29','14:30:00',1.05),('12664','2013-08-29','14:35:00',1.18),('12664','2013-08-29','14:40:00',1.29),('12664','2013-08-29','14:45:00',1.37),('12664','2013-08-29','14:50:00',1.54),('12664','2013-08-29','14:55:00',2.56),('12664','2013-08-29','15:00:00',2.74),('12664','2013-08-29','15:05:00',1.64),('12664','2013-08-29','15:10:00',1.3),('12664','2013-08-29','15:15:00',1.63),('12664','2013-08-29','15:20:00',2.03),('12664','2013-08-29','15:25:00',2.37),('12664','2013-08-29','15:30:00',2.27),('12664','2013-08-29','15:35:00',2.02),('12664','2013-08-29','15:40:00',1.84),('12664','2013-08-29','15:45:00',1.92),('12664','2013-08-29','15:50:00',2.37),('12664','2013-08-29','15:55:00',3.24),('12664','2013-08-29','16:00:00',3.79),('12664','2013-08-29','16:05:00',3.35),('12664','2013-08-29','16:10:00',3.07),('12664','2013-08-29','16:15:00',2.83),('12664','2013-08-29','16:20:00',2.59),('12664','2013-08-29','16:25:00',2.83),('12664','2013-08-29','16:30:00',2.74),('12664','2013-08-29','16:35:00',2.62),('12664','2013-08-29','16:40:00',2.54),('12664','2013-08-29','16:45:00',2.46),('12664','2013-08-29','16:50:00',2.36),('12664','2013-08-29','16:55:00',2.29),('12664','2013-08-29','17:00:00',2.2),('12664','2013-08-29','17:05:00',2.12),('12664','2013-08-29','17:10:00',2.04),('12664','2013-08-29','17:15:00',1.95),('12664','2013-08-29','17:20:00',1.86),('12664','2013-08-29','17:25:00',1.76),('12664','2013-08-29','17:30:00',1.66),('12664','2013-08-29','17:35:00',1.56),('12664','2013-08-29','17:40:00',1.46),('12664','2013-08-29','17:45:00',1.37),('12664','2013-08-29','17:50:00',1.28),('12664','2013-08-29','17:55:00',1.18),('12664','2013-08-29','18:00:00',1.09),('12664','2014-04-10','08:10:00',1.04),('12664','2014-04-10','08:15:00',1.14),('12664','2014-04-10','08:20:00',1.25),('12664','2014-04-10','08:25:00',1.35),('12664','2014-04-10','08:30:00',1.45),('12664','2014-04-10','08:35:00',1.55),('12664','2014-04-10','08:40:00',1.65),('12664','2014-04-10','08:45:00',1.75),('12664','2014-04-10','08:50:00',1.84),('12664','2014-04-10','08:55:00',1.9),('12664','2014-04-10','09:00:00',2.01),('12664','2014-04-10','09:05:00',2.09),('12664','2014-04-10','09:10:00',2.15),('12664','2014-04-10','09:15:00',2.17),('12664','2014-04-10','09:20:00',2.3),('12664','2014-04-10','09:25:00',2.43),('12664','2014-04-10','09:30:00',2.51),('12664','2014-04-10','09:35:00',2.58),('12664','2014-04-10','09:40:00',2.64),('12664','2014-04-10','09:45:00',2.73),('12664','2014-04-10','09:50:00',2.8),('12664','2014-04-10','09:55:00',2.85),('12664','2014-04-10','10:00:00',2.91),('12664','2014-04-10','10:05:00',3),('12664','2014-04-10','10:10:00',3.06),('12664','2014-04-10','10:15:00',3.05),('12664','2014-04-10','10:20:00',3.13),('12664','2014-04-10','10:25:00',3.18),('12664','2014-04-10','10:30:00',3.26),('12664','2014-04-10','10:35:00',3.4),('12664','2014-04-10','10:40:00',3.38),('12664','2014-04-10','10:45:00',3.42),('12664','2014-04-10','10:50:00',3.4),('12664','2014-04-10','10:55:00',3.48),('12664','2014-04-10','11:00:00',3.61),('12664','2014-04-10','11:05:00',3.59),('12664','2014-04-10','11:10:00',3.71),('12664','2014-04-10','11:15:00',3.72),('12664','2014-04-10','11:20:00',3.86),('12664','2014-04-10','11:25:00',3.89),('12664','2014-04-10','11:30:00',3.95),('12664','2014-04-10','11:35:00',3.81),('12664','2014-04-10','11:40:00',3.98),('12664','2014-04-10','11:45:00',3.95),('12664','2014-04-10','11:50:00',3.93),('12664','2014-04-10','11:55:00',3.93),('12664','2014-04-10','12:00:00',3.68),('12664','2014-04-10','12:05:00',3.73),('12664','2014-04-10','12:10:00',4.02),('12664','2014-04-10','12:15:00',4.05),('12664','2014-04-10','12:20:00',3.96),('12664','2014-04-10','12:25:00',3.91),('12664','2014-04-10','12:30:00',3.76),('12664','2014-04-10','12:35:00',3.95),('12664','2014-04-10','12:40:00',3.89),('12664','2014-04-10','12:45:00',3.94),('12664','2014-04-10','12:50:00',3.99),('12664','2014-04-10','12:55:00',4.07),('12664','2014-04-10','13:00:00',3.82),('12664','2014-04-10','13:05:00',3.92),('12664','2014-04-10','13:10:00',4.14),('12664','2014-04-10','13:15:00',3.98),('12664','2014-04-10','13:20:00',3.88),('12664','2014-04-10','13:25:00',4.03),('12664','2014-04-10','13:30:00',4.09),('12664','2014-04-10','13:35:00',4.08),('12664','2014-04-10','13:40:00',3.94),('12664','2014-04-10','13:45:00',4.04),('12664','2014-04-10','13:50:00',4.01),('12664','2014-04-10','13:55:00',3.98),('12664','2014-04-10','14:00:00',3.94),('12664','2014-04-10','14:05:00',3.84),('12664','2014-04-10','14:10:00',3.86),('12664','2014-04-10','14:15:00',3.93),('12664','2014-04-10','14:20:00',3.9),('12664','2014-04-10','14:25:00',3.86),('12664','2014-04-10','14:30:00',3.82),('12664','2014-04-10','14:35:00',3.73),('12664','2014-04-10','14:40:00',3.77),('12664','2014-04-10','14:45:00',3.31),('12664','2014-04-10','14:50:00',3.74),('12664','2014-04-10','14:55:00',3.67),('12664','2014-04-10','15:00:00',3.61),('12664','2014-04-10','15:05:00',3.61),('12664','2014-04-10','15:10:00',3.51),('12664','2014-04-10','15:15:00',3.42),('12664','2014-04-10','15:20:00',3.29),('12664','2014-04-10','15:25:00',3.34),('12664','2014-04-10','15:30:00',2.94),('12664','2014-04-10','15:35:00',2.83),('12664','2014-04-10','15:40:00',3.09),('12664','2014-04-10','15:45:00',3.03),('12664','2014-04-10','15:50:00',2.93),('12664','2014-04-10','15:55:00',3.11),('12664','2014-04-10','16:00:00',3.06),('12664','2014-04-10','16:05:00',3.01),('12664','2014-04-10','16:10:00',3.08),('12664','2014-04-10','16:15:00',3),('12664','2014-04-10','16:20:00',2.75),('12664','2014-04-10','16:25:00',2.79),('12664','2014-04-10','16:30:00',2.78),('12664','2014-04-10','16:35:00',2.67),('12664','2014-04-10','16:40:00',2.6),('12664','2014-04-10','16:45:00',2.46),('12664','2014-04-10','16:50:00',2.43),('12664','2014-04-10','16:55:00',2.3),('12664','2014-04-10','17:00:00',2.19),('12664','2014-04-10','17:05:00',2.15),('12664','2014-04-10','17:10:00',2.03),('12664','2014-04-10','17:15:00',1.93),('12664','2014-04-10','17:20:00',1.83),('12664','2014-04-10','17:25:00',1.72),('12664','2014-04-10','17:30:00',1.62),('12664','2014-04-10','17:35:00',1.52),('12664','2014-04-10','17:40:00',1.42),('12664','2014-04-10','17:45:00',1.32),('12664','2014-04-10','17:50:00',1.22),('12664','2014-04-10','17:55:00',1.13),('12664','2014-04-10','18:00:00',1.03),('12664','2013-08-28','08:05:00',1.01),('12664','2013-08-28','08:10:00',1.37),('12664','2013-08-28','08:15:00',1.3),('12664','2013-08-28','08:20:00',1.16),('12664','2013-08-28','08:25:00',1.35),('12664','2013-08-28','08:30:00',1.16),('12664','2013-08-28','08:50:00',1.92),('12664','2013-08-28','08:55:00',1.97),('12664','2013-08-28','09:00:00',2.05),('12664','2013-08-28','09:05:00',2.12),('12664','2013-08-28','09:10:00',2.17),('12664','2013-08-28','09:15:00',1.52),('12664','2013-08-28','09:20:00',1.19),('12664','2013-08-28','09:25:00',1.22),('12664','2013-08-28','09:30:00',1.74),('12664','2013-08-28','09:35:00',2.27),('12664','2013-08-28','09:40:00',2.3),('12664','2013-08-28','09:45:00',2.61),('12664','2013-08-28','09:50:00',2.83),('12664','2013-08-28','09:55:00',2.89),('12664','2013-08-28','10:00:00',2.97),('12664','2013-08-28','10:05:00',3.02),('12664','2013-08-28','10:10:00',3.06),('12664','2013-08-28','10:15:00',3.14),('12664','2013-08-28','10:20:00',3.2),('12664','2013-08-28','10:25:00',3.26),('12664','2013-08-28','10:30:00',3.34),('12664','2013-08-28','10:35:00',3.39),('12664','2013-08-28','10:40:00',3.59),('12664','2013-08-28','10:45:00',3.61),('12664','2013-08-28','10:50:00',3.68),('12664','2013-08-28','10:55:00',3.79),('12664','2013-08-28','11:00:00',3.89),('12664','2013-08-28','11:05:00',4),('12664','2013-08-28','11:10:00',3.71),('12664','2013-08-28','11:15:00',3.9),('12664','2013-08-28','11:20:00',3.93),('12664','2013-08-28','11:25:00',2.57),('12664','2013-08-28','11:30:00',3.56),('12664','2013-08-28','11:35:00',3.99),('12664','2013-08-28','11:40:00',3.08),('12664','2013-08-28','11:45:00',2.15),('12664','2013-08-28','11:50:00',4.69),('12664','2013-08-28','11:55:00',4.56),('12664','2013-08-28','12:00:00',4.38),('12664','2013-08-28','12:05:00',4.33),('12664','2013-08-28','12:10:00',4.3),('12664','2013-08-28','12:15:00',4.34),('12664','2013-08-28','12:20:00',4.16),('12664','2013-08-28','12:25:00',4.33),('12664','2013-08-28','12:30:00',4.36),('12664','2013-08-28','12:35:00',4.28),('12664','2013-08-28','12:40:00',4.3),('12664','2013-08-28','12:45:00',4.13),('12664','2013-08-28','12:50:00',4.19),('12664','2013-08-28','12:55:00',4.44),('12664','2013-08-28','13:00:00',4.36),('12664','2013-08-28','13:05:00',4.23),('12664','2013-08-28','13:10:00',4.31),('12664','2013-08-28','13:15:00',4.34),('12664','2013-08-28','13:20:00',4.29),('12664','2013-08-28','13:25:00',3.91),('12664','2013-08-28','13:30:00',4.42),('12664','2013-08-28','13:35:00',4.4),('12664','2013-08-28','13:40:00',4.4),('12664','2013-08-28','13:45:00',4.35),('12664','2013-08-28','13:50:00',4.2),('12664','2013-08-28','13:55:00',4.28),('12664','2013-08-28','14:00:00',4.23),('12664','2013-08-28','14:05:00',4.14),('12664','2013-08-28','14:10:00',4.18),('12664','2013-08-28','14:15:00',4.12),('12664','2013-08-28','14:20:00',4.14),('12664','2013-08-28','14:25:00',4.13),('12664','2013-08-28','14:30:00',4.09),('12664','2013-08-28','14:35:00',4.04),('12664','2013-08-28','14:40:00',4.01),('12664','2013-08-28','14:45:00',4.03),('12664','2013-08-28','14:50:00',3.96),('12664','2013-08-28','14:55:00',3.97),('12664','2013-08-28','15:00:00',3.88),('12664','2013-08-28','15:05:00',3.72),('12664','2013-08-28','15:10:00',3.85),('12664','2013-08-28','15:15:00',3.81),('12664','2013-08-28','15:20:00',3.46),('12664','2013-08-28','15:25:00',3.57),('12664','2013-08-28','15:30:00',3.38),('12664','2013-08-28','15:35:00',3.59),('12664','2013-08-28','15:40:00',3.52),('12664','2013-08-28','15:45:00',3.4),('12664','2013-08-28','15:50:00',3.37),('12664','2013-08-28','15:55:00',3.34),('12664','2013-08-28','16:00:00',3.24),('12664','2013-08-28','16:05:00',3.17),('12664','2013-08-28','16:10:00',3.11),('12664','2013-08-28','16:15:00',3.03),('12664','2013-08-28','16:20:00',2.97),('12664','2013-08-28','16:25:00',2.89),('12664','2013-08-28','16:30:00',2.81),('12664','2013-08-28','16:35:00',2.72),('12664','2013-08-28','16:40:00',2.62),('12664','2013-08-28','16:45:00',2.54),('12664','2013-08-28','16:50:00',2.44),('12664','2013-08-28','16:55:00',2.4),('12664','2013-08-28','17:00:00',1.17),('12664','2013-08-28','17:05:00',1.09),('12664','2013-08-28','17:10:00',2.04),('12664','2013-08-28','17:15:00',1.91),('12664','2013-08-28','17:20:00',2.21),('12664','2013-08-28','17:25:00',1.18),('12664','2013-08-28','17:35:00',1.91),('12664','2013-08-28','17:50:00',1.45),('12664','2013-08-28','17:55:00',1.18),('12664','2013-08-27','08:20:00',1.06),('12664','2013-08-27','08:25:00',1.02),('12664','2013-08-27','08:45:00',1),('12664','2013-08-27','08:50:00',1.45),('12664','2013-08-27','08:55:00',1.17),('12664','2013-08-27','09:00:00',1.05),('12664','2013-08-27','09:05:00',1.4),('12664','2013-08-27','09:10:00',1.99),('12664','2013-08-27','09:15:00',1.96),('12664','2013-08-27','09:20:00',2.16),('12664','2013-08-27','09:25:00',2.49),('12664','2013-08-27','09:30:00',2.54),('12664','2013-08-27','09:35:00',1.73),('12664','2013-08-27','09:40:00',1.35),('12664','2013-08-27','09:45:00',1.58),('12664','2013-08-27','09:50:00',1.91),('12664','2013-08-27','09:55:00',1.59),('12664','2013-08-27','10:00:00',2.09),('12664','2013-08-27','10:05:00',2.9),('12664','2013-08-27','10:10:00',3.1),('12664','2013-08-27','10:15:00',3.11),('12664','2013-08-27','10:20:00',3.09),('12664','2013-08-27','10:25:00',3.11),('12664','2013-08-27','10:30:00',3.19),('12664','2013-08-27','10:35:00',3.27),('12664','2013-08-27','10:40:00',3.3),('12664','2013-08-27','10:45:00',3.36),('12664','2013-08-27','10:50:00',3.39),('12664','2013-08-27','10:55:00',3.32),('12664','2013-08-27','11:00:00',3.35),('12664','2013-08-27','11:05:00',3.48),('12664','2013-08-27','11:10:00',3.57),('12664','2013-08-27','11:15:00',3.55),('12664','2013-08-27','11:20:00',3.59),('12664','2013-08-27','11:25:00',3.76),('12664','2013-08-27','11:30:00',3.62),('12664','2013-08-27','11:35:00',3.69),('12664','2013-08-27','11:40:00',3.48),('12664','2013-08-27','11:45:00',2.89),('12664','2013-08-27','11:50:00',3.24),('12664','2013-08-27','11:55:00',3.63),('12664','2013-08-27','12:00:00',1.79),('12664','2013-08-27','12:05:00',3.07),('12664','2013-08-27','12:10:00',3.55),('12664','2013-08-27','12:15:00',3.81),('12664','2013-08-27','12:20:00',4.07),('12664','2013-08-27','12:25:00',3.85),('12664','2013-08-27','12:30:00',4.15),('12664','2013-08-27','12:35:00',2.63),('12664','2013-08-27','12:40:00',4.07),('12664','2013-08-27','12:45:00',3.09),('12664','2013-08-27','12:50:00',2.54),('12664','2013-08-27','12:55:00',1.7),('12664','2013-08-27','13:00:00',1.59),('12664','2013-08-27','13:05:00',2.02),('12664','2013-08-27','13:10:00',3.12),('12664','2013-08-27','13:15:00',2.35),('12664','2013-08-27','13:20:00',2.74),('12664','2013-08-27','13:25:00',2.86),('12664','2013-08-27','13:30:00',2.21),('12664','2013-08-27','13:35:00',2.15),('12664','2013-08-27','13:40:00',2.35),('12664','2013-08-27','13:45:00',3.3),('12664','2013-08-27','13:50:00',3.41),('12664','2013-08-27','13:55:00',2.75),('12664','2013-08-27','14:00:00',2.28),('12664','2013-08-27','14:05:00',3.77),('12664','2013-08-27','14:10:00',3.56),('12664','2013-08-27','14:15:00',2.47),('12664','2013-08-27','14:20:00',1.82),('12664','2013-08-27','14:25:00',1.44),('12664','2013-08-27','14:30:00',1.39),('12664','2013-08-27','14:35:00',1.39),('12664','2013-08-27','14:40:00',1.3),('12664','2013-08-27','14:45:00',1.08),('12664','2013-08-27','15:50:00',1.84),('12664','2013-08-27','15:55:00',2.51),('12664','2013-08-27','16:00:00',1.75),('12664','2013-08-27','16:05:00',1.67),('12664','2013-08-27','16:10:00',1.65),('12664','2013-08-27','16:15:00',1.6),('12664','2013-08-27','16:20:00',2.05),('12664','2013-08-27','16:40:00',1.47),('12664','2013-08-27','16:45:00',1.06),('12664','2013-08-27','17:00:00',1.42),('12664','2013-08-27','17:05:00',1.13),('12664','2013-08-27','17:35:00',1.03),('12664','2013-08-27','17:45:00',1.14),('12664','2013-08-26','08:05:00',1.04),('12664','2013-08-26','08:20:00',1.4),('12664','2013-08-26','08:25:00',1.35),('12664','2013-08-26','08:30:00',1.34),('12664','2013-08-26','08:35:00',1.54),('12664','2013-08-26','08:40:00',1.63),('12664','2013-08-26','08:45:00',1.71),('12664','2013-08-26','08:50:00',1.8),('12664','2013-08-26','08:55:00',1.89),('12664','2013-08-26','09:00:00',1.96),('12664','2013-08-26','09:05:00',2.05),('12664','2013-08-26','09:10:00',2.14),('12664','2013-08-26','09:15:00',2.22),('12664','2013-08-26','09:20:00',2.27),('12664','2013-08-26','09:25:00',2.35),('12664','2013-08-26','09:30:00',2.41),('12664','2013-08-26','09:35:00',2.55),('12664','2013-08-26','09:40:00',2.66),('12664','2013-08-26','09:45:00',2.71),('12664','2013-08-26','09:50:00',2.76),('12664','2013-08-26','09:55:00',2.82),('12664','2013-08-26','10:00:00',2.91),('12664','2013-08-26','10:05:00',2.96),('12664','2013-08-26','10:10:00',3.02),('12664','2013-08-26','10:15:00',3.09),('12664','2013-08-26','10:20:00',2.94),('12664','2013-08-26','10:25:00',2.83),('12664','2013-08-26','10:30:00',3.25),('12664','2013-08-26','10:35:00',3.34),('12664','2013-08-26','10:40:00',3.36),('12664','2013-08-26','10:45:00',3.41),('12664','2013-08-26','10:50:00',3.45),('12664','2013-08-26','10:55:00',3.49),('12664','2013-08-26','11:00:00',3.56),('12664','2013-08-26','11:05:00',3.6),('12664','2013-08-26','11:10:00',3.63),('12664','2013-08-26','11:15:00',3.67),('12664','2013-08-26','11:20:00',3.7),('12664','2013-08-26','11:25:00',3.72),('12664','2013-08-26','11:30:00',3.76),('12664','2013-08-26','11:35:00',3.78),('12664','2013-08-26','11:40:00',3.79),('12664','2013-08-26','11:45:00',3.84),('12664','2013-08-26','11:50:00',3.88),('12664','2013-08-26','11:55:00',3.89),('12664','2013-08-26','12:00:00',3.87),('12664','2013-08-26','12:05:00',3.9),('12664','2013-08-26','12:10:00',3.89),('12664','2013-08-26','12:15:00',3.91),('12664','2013-08-26','12:20:00',3.94),('12664','2013-08-26','12:25:00',3.96),('12664','2013-08-26','12:30:00',3.91),('12664','2013-08-26','12:35:00',3.63),('12664','2013-08-26','12:40:00',2.78),('12664','2013-08-26','12:45:00',4.34),('12664','2013-08-26','12:50:00',4.2),('12664','2013-08-26','12:55:00',4.38),('12664','2013-08-26','13:00:00',2.62),('12664','2013-08-26','13:05:00',2.94),('12664','2013-08-26','13:10:00',3.06),('12664','2013-08-26','13:15:00',3.11),('12664','2013-08-26','13:20:00',3.44),('12664','2013-08-26','13:25:00',2.47),('12664','2013-08-26','13:30:00',2.86),('12664','2013-08-26','13:35:00',3.86),('12664','2013-08-26','13:40:00',4.22),('12664','2013-08-26','13:45:00',3.94),('12664','2013-08-26','13:50:00',3.51),('12664','2013-08-26','13:55:00',3.14),('12664','2013-08-26','14:00:00',4.03),('12664','2013-08-26','14:05:00',3.12),('12664','2013-08-26','14:10:00',4.34),('12664','2013-08-26','14:15:00',3.75),('12664','2013-08-26','14:20:00',3.71),('12664','2013-08-26','14:25:00',3.87),('12664','2013-08-26','14:30:00',3.86),('12664','2013-08-26','14:35:00',3.84),('12664','2013-08-26','14:40:00',3.77),('12664','2013-08-26','14:45:00',2.58),('12664','2013-08-26','14:50:00',3.17),('12664','2013-08-26','14:55:00',1.75),('12664','2013-08-26','15:00:00',2.02),('12664','2013-08-26','15:05:00',1.17),('12664','2013-08-26','15:10:00',1.02),('12664','2013-08-26','15:35:00',1.35),('12664','2013-08-26','15:40:00',1.96),('12664','2013-08-26','15:45:00',1.31),('12664','2013-08-26','15:50:00',1.48),('12664','2013-08-26','15:55:00',1.99),('12664','2013-08-26','16:00:00',2.8),('12664','2013-08-26','16:05:00',3.29),('12664','2013-08-26','16:10:00',2.96),('12664','2013-08-26','16:15:00',2.81),('12664','2013-08-26','16:20:00',2.75),('12664','2013-08-26','16:25:00',2.64),('12664','2013-08-26','16:30:00',2.58),('12664','2013-08-26','16:35:00',2.51),('12664','2013-08-26','16:40:00',2.37),('12664','2013-08-26','16:45:00',2.31),('12664','2013-08-26','16:50:00',2.24),('12664','2013-08-26','16:55:00',2.17),('12664','2013-08-26','17:00:00',1.91),('12664','2013-08-26','17:05:00',1.98),('12664','2013-08-26','17:10:00',1.91),('12664','2013-08-26','17:15:00',1.83),('12664','2013-08-26','17:20:00',1.14),('12664','2013-08-26','17:25:00',1.33),('12664','2013-08-26','17:30:00',1.07),('12664','2013-08-26','17:45:00',1.54),('12664','2013-08-26','17:50:00',1.45),('12664','2013-08-26','17:55:00',1.27),('12664','2013-08-26','18:00:00',1.08),('12664','2013-08-25','07:55:00',1.01),('12664','2013-08-25','08:00:00',1.14),('12664','2013-08-25','08:25:00',1.31),('12664','2013-08-25','08:30:00',1.48),('12664','2013-08-25','08:35:00',1.46),('12664','2013-08-25','08:40:00',1.32),('12664','2013-08-25','09:00:00',1.12),('12664','2013-08-25','09:05:00',1.11),('12664','2013-08-25','09:10:00',2.2),('12664','2013-08-25','09:15:00',1.81),('12664','2013-08-25','09:20:00',2.15),('12664','2013-08-25','09:25:00',2.69),('12664','2013-08-25','09:30:00',2.87),('12664','2013-08-25','09:35:00',2.94),('12664','2013-08-25','09:40:00',3.19),('12664','2013-08-25','09:45:00',2.81),('12664','2013-08-25','09:50:00',2.54),('12664','2013-08-25','09:55:00',1.72),('12664','2013-08-25','15:05:00',1.15),('12664','2013-08-25','15:10:00',1.23),('12664','2013-08-25','15:15:00',1.46),('12664','2013-08-25','15:20:00',1.87),('12664','2013-08-25','15:25:00',2.82),('12664','2013-08-25','15:30:00',4.44),('12664','2013-08-25','15:35:00',3.88),('12664','2013-08-25','15:40:00',4.01),('12664','2013-08-25','15:45:00',3.72),('12664','2013-08-25','15:50:00',3.44),('12664','2013-08-25','15:55:00',3.69),('12664','2013-08-25','16:00:00',2.92),('12664','2013-08-25','16:05:00',2.3),('12664','2013-08-25','16:10:00',3),('12664','2013-08-25','16:15:00',2.92),('12664','2013-08-25','16:20:00',2.81),('12664','2013-08-25','16:25:00',2.73),('12664','2013-08-25','16:30:00',2.69),('12664','2013-08-25','16:35:00',2.48),('12664','2013-08-25','16:40:00',1.7),('12664','2013-08-25','16:45:00',1.87),('12664','2013-08-25','16:50:00',2.71),('12664','2013-08-25','16:55:00',2.46),('12664','2013-08-25','17:00:00',2.4),('12664','2013-08-25','17:05:00',2.29),('12664','2013-08-25','17:10:00',2.11),('12664','2013-08-25','17:15:00',1.95),('12664','2013-08-25','17:20:00',1.85),('12664','2013-08-25','17:25:00',1.76),('12664','2013-08-25','17:30:00',1.47),('12664','2013-08-25','17:35:00',1.38),('12664','2013-08-25','17:40:00',1.43),('12664','2013-08-25','17:45:00',1.34),('12664','2013-08-25','17:50:00',1.11),('12664','2013-08-25','18:10:00',1.03),('12664','2013-08-24','08:15:00',1.07),('12664','2013-08-24','08:20:00',1.16),('12664','2013-08-24','08:25:00',1.23),('12664','2013-08-24','08:30:00',1.32),('12664','2013-08-24','08:35:00',1.4),('12664','2013-08-24','08:40:00',1.52),('12664','2013-08-24','08:45:00',1.63),('12664','2013-08-24','08:50:00',1.72),('12664','2013-08-24','08:55:00',1.82),('12664','2013-08-24','09:00:00',1.88),('12664','2013-08-24','09:05:00',1.98),('12664','2013-08-24','09:10:00',2.07),('12664','2013-08-24','09:15:00',2.15),('12664','2013-08-24','09:20:00',2.23),('12664','2013-08-24','09:25:00',2.31),('12664','2013-08-24','09:30:00',2.39),('12664','2013-08-24','09:35:00',2.46),('12664','2013-08-24','09:40:00',2.52),('12664','2013-08-24','09:45:00',2.59),('12664','2013-08-24','09:50:00',2.67),('12664','2013-08-24','09:55:00',2.77),('12664','2013-08-24','10:00:00',2.82),('12664','2013-08-24','10:05:00',2.86),('12664','2013-08-24','10:10:00',2.94),('12664','2013-08-24','10:15:00',3.01),('12664','2013-08-24','10:20:00',3.06),('12664','2013-08-24','10:25:00',3.1),('12664','2013-08-24','10:30:00',3.07),('12664','2013-08-24','10:35:00',3.19),('12664','2013-08-24','10:40:00',3.26),('12664','2013-08-24','10:45:00',3.3),('12664','2013-08-24','10:50:00',3.33),('12664','2013-08-24','10:55:00',3.36),('12664','2013-08-24','11:00:00',3.38),('12664','2013-08-24','11:05:00',3.38),('12664','2013-08-24','11:10:00',3.17),('12664','2013-08-24','11:15:00',3.24),('12664','2013-08-24','11:20:00',3.15),('12664','2013-08-24','11:25:00',3.66),('12664','2013-08-24','11:30:00',3.64),('12664','2013-08-24','11:35:00',3.75),('12664','2013-08-24','11:40:00',3.79),('12664','2013-08-24','11:45:00',3.82),('12664','2013-08-24','11:50:00',3.87),('12664','2013-08-24','11:55:00',3.86),('12664','2013-08-24','12:00:00',3.88),('12664','2013-08-24','12:05:00',3.89),('12664','2013-08-24','12:10:00',3.88),('12664','2013-08-24','12:15:00',3.89),('12664','2013-08-24','12:20:00',3.92),('12664','2013-08-24','12:25:00',3.91),('12664','2013-08-24','12:30:00',3.97),('12664','2013-08-24','12:35:00',4),('12664','2013-08-24','12:40:00',4),('12664','2013-08-24','12:45:00',4.01),('12664','2013-08-24','12:50:00',4.01),('12664','2013-08-24','12:55:00',4.04),('12664','2013-08-24','13:00:00',4.03),('12664','2013-08-24','13:05:00',4.04),('12664','2013-08-24','13:10:00',4.04),('12664','2013-08-24','13:15:00',4.04),('12664','2013-08-24','13:20:00',4.01),('12664','2013-08-24','13:25:00',4.02),('12664','2013-08-24','13:30:00',4.02),('12664','2013-08-24','13:35:00',3.98),('12664','2013-08-24','13:40:00',3.96),('12664','2013-08-24','13:45:00',3.99),('12664','2013-08-24','13:50:00',3.94),('12664','2013-08-24','13:55:00',3.94),('12664','2013-08-24','14:00:00',3.93),('12664','2013-08-24','14:05:00',3.9),('12664','2013-08-24','14:10:00',3.87),('12664','2013-08-24','14:15:00',3.86),('12664','2013-08-24','14:20:00',3.82),('12664','2013-08-24','14:25:00',3.8),('12664','2013-08-24','14:30:00',3.79),('12664','2013-08-24','14:35:00',3.75),('12664','2013-08-24','14:40:00',3.72),('12664','2013-08-24','14:45:00',3.69),('12664','2013-08-24','14:50:00',3.68),('12664','2013-08-24','14:55:00',3.63),('12664','2013-08-24','15:00:00',3.59),('12664','2013-08-24','15:05:00',3.55),('12664','2013-08-24','15:10:00',3.52),('12664','2013-08-24','15:15:00',3.49),('12664','2013-08-24','15:20:00',3.41),('12664','2013-08-24','15:25:00',3.35),('12664','2013-08-24','15:30:00',3.3),('12664','2013-08-24','15:35:00',3.26),('12664','2013-08-24','15:40:00',3.2),('12664','2013-08-24','15:45:00',3.16),('12664','2013-08-24','15:50:00',3.11),('12664','2013-08-24','15:55:00',3.06),('12664','2013-08-24','16:00:00',2.99),('12664','2013-08-24','16:05:00',2.94),('12664','2013-08-24','16:10:00',2.88),('12664','2013-08-24','16:15:00',2.82),('12664','2013-08-24','16:20:00',2.76),('12664','2013-08-24','16:25:00',2.68),('12664','2013-08-24','16:30:00',2.6),('12664','2013-08-24','16:35:00',2.53),('12664','2013-08-24','16:40:00',2.46),('12664','2013-08-24','16:45:00',2.39),('12664','2013-08-24','16:50:00',2.3),('12664','2013-08-24','16:55:00',2.23),('12664','2013-08-24','17:00:00',2.15),('12664','2013-08-24','17:05:00',2.07),('12664','2013-08-24','17:10:00',1.98),('12664','2013-08-24','17:15:00',1.91),('12664','2013-08-24','17:20:00',1.83),('12664','2013-08-24','17:25:00',1.73),('12664','2013-08-24','17:30:00',1.64),('12664','2013-08-24','17:35:00',1.55),('12664','2013-08-24','17:40:00',1.46),('12664','2013-08-24','17:45:00',1.38),('12664','2013-08-24','17:50:00',1.3),('12664','2013-08-24','17:55:00',1.19),('12664','2013-08-24','18:00:00',1.1),('12664','2013-08-24','18:05:00',1.02),('12664','2013-08-23','08:20:00',1.07),('12664','2013-08-23','08:25:00',1.13),('12664','2013-08-23','08:30:00',1.23),('12664','2013-08-23','08:35:00',1.3),('12664','2013-08-23','08:40:00',1.58),('12664','2013-08-23','08:45:00',1.67),('12664','2013-08-23','08:50:00',1.65),('12664','2013-08-23','08:55:00',1.55),('12664','2013-08-23','09:00:00',1.75),('12664','2013-08-23','09:05:00',1.82),('12664','2013-08-23','09:10:00',1.96),('12664','2013-08-23','09:15:00',2.01),('12664','2013-08-23','09:20:00',2.09),('12664','2013-08-23','09:25:00',2.12),('12664','2013-08-23','09:30:00',2.18),('12664','2013-08-23','09:35:00',2.23),('12664','2013-08-23','09:40:00',2.31),('12664','2013-08-23','09:45:00',2.41),('12664','2013-08-23','09:50:00',2.48),('12664','2013-08-23','09:55:00',2.54),('12664','2013-08-23','10:00:00',2.61),('12664','2013-08-23','10:05:00',2.62),('12664','2013-08-23','10:10:00',2.7),('12664','2013-08-23','10:15:00',2.78),('12664','2013-08-23','10:20:00',2.81),('12664','2013-08-23','10:25:00',2.88),('12664','2013-08-23','10:30:00',2.94),('12664','2013-08-23','10:35:00',2.99),('12664','2013-08-23','10:40:00',3.06),('12664','2013-08-23','10:45:00',3.07),('12664','2013-08-23','10:50:00',3.13),('12664','2013-08-23','10:55:00',3.18),('12664','2013-08-23','11:00:00',3.26),('12664','2013-08-23','11:05:00',3.27),('12664','2013-08-23','11:10:00',3.15),('12664','2013-08-23','11:15:00',3.47),('12664','2013-08-23','11:20:00',3.5),('12664','2013-08-23','11:25:00',3.37),('12664','2013-08-23','11:30:00',3.05),('12664','2013-08-23','11:35:00',3.82),('12664','2013-08-23','11:40:00',2.88),('12664','2013-08-23','11:45:00',1.19),('12664','2013-08-23','11:50:00',2.92),('12664','2013-08-23','11:55:00',2.22),('12664','2013-08-23','12:00:00',4.08),('12664','2013-08-23','12:05:00',2.78),('12664','2013-08-23','12:10:00',1.27),('12664','2013-08-23','12:15:00',1.64),('12664','2013-08-23','12:20:00',3.15),('12664','2013-08-23','12:25:00',1.94),('12664','2013-08-23','12:30:00',3.99),('12664','2013-08-23','12:35:00',2.48),('12664','2013-08-23','12:40:00',2.86),('12664','2013-08-23','12:45:00',4.04),('12664','2013-08-23','12:50:00',4.02),('12664','2013-08-23','12:55:00',3.99),('12664','2013-08-23','13:00:00',3.95),('12664','2013-08-23','13:05:00',4.02),('12664','2013-08-23','13:10:00',3.99),('12664','2013-08-23','13:15:00',4.02),('12664','2013-08-23','13:20:00',4),('12664','2013-08-23','13:25:00',3.97),('12664','2013-08-23','13:30:00',3.98),('12664','2013-08-23','13:35:00',4),('12664','2013-08-23','13:40:00',4),('12664','2013-08-23','13:45:00',3.98),('12664','2013-08-23','13:50:00',3.96),('12664','2013-08-23','13:55:00',3.96),('12664','2013-08-23','14:00:00',3.96),('12664','2013-08-23','14:05:00',3.93),('12664','2013-08-23','14:10:00',3.9),('12664','2013-08-23','14:15:00',3.89),('12664','2013-08-23','14:20:00',3.87),('12664','2013-08-23','14:25:00',3.86),('12664','2013-08-23','14:30:00',3.81),('12664','2013-08-23','14:35:00',3.78),('12664','2013-08-23','14:40:00',3.74),('12664','2013-08-23','14:45:00',3.7),('12664','2013-08-23','14:50:00',3.59),('12664','2013-08-23','14:55:00',3.45),('12664','2013-08-23','15:00:00',3.54),('12664','2013-08-23','15:05:00',3.52),('12664','2013-08-23','15:10:00',3.1),('12664','2013-08-23','15:15:00',2.86),('12664','2013-08-23','15:20:00',3.14),('12664','2013-08-23','15:25:00',3.26),('12664','2013-08-23','15:30:00',3.26),('12664','2013-08-23','15:35:00',3.33),('12664','2013-08-23','15:40:00',2.92),('12664','2013-08-23','15:45:00',2.96),('12664','2013-08-23','15:50:00',2.79),('12664','2013-08-23','15:55:00',2.7),('12664','2013-08-23','16:00:00',2.64),('12664','2013-08-23','16:05:00',2.58),('12664','2013-08-23','16:10:00',2.47),('12664','2013-08-23','16:15:00',2.56),('12664','2013-08-23','16:20:00',2.56),('12664','2013-08-23','16:25:00',2.39),('12664','2013-08-23','16:30:00',2.55),('12664','2013-08-23','16:35:00',2.59),('12664','2013-08-23','16:40:00',2.55),('12664','2013-08-23','16:45:00',2.43),('12664','2013-08-23','16:50:00',2.32),('12664','2013-08-23','16:55:00',2.24),('12664','2013-08-23','17:00:00',2.14),('12664','2013-08-23','17:05:00',2.02),('12664','2013-08-23','17:10:00',1.95),('12664','2013-08-23','17:15:00',1.88),('12664','2013-08-23','17:20:00',1.81),('12664','2013-08-23','17:25:00',1.71),('12664','2013-08-23','17:30:00',1.6),('12664','2013-08-23','17:35:00',1.54),('12664','2013-08-23','17:40:00',1.46),('12664','2013-08-23','17:45:00',1.39),('12664','2013-08-23','17:50:00',1.16),('12664','2013-08-23','18:00:00',1.02),('12664','2013-08-23','18:05:00',1.03),('12664','2013-08-22','08:10:00',1.02),('12664','2013-08-22','08:15:00',1.1),('12664','2013-08-22','08:20:00',1.17),('12664','2013-08-22','08:25:00',1.24),('12664','2013-08-22','08:30:00',1.33),('12664','2013-08-22','08:35:00',1.4),('12664','2013-08-22','08:40:00',1.49),('12664','2013-08-22','08:45:00',1.61),('12664','2013-08-22','08:50:00',1.71),('12664','2013-08-22','08:55:00',1.79),('12664','2013-08-22','09:00:00',1.88),('12664','2013-08-22','09:05:00',1.72),('12664','2013-08-22','09:10:00',1.68),('12664','2013-08-22','09:15:00',2.17),('12664','2013-08-22','09:20:00',2.28),('12664','2013-08-22','09:25:00',2.39),('12664','2013-08-22','09:30:00',2.48),('12664','2013-08-22','09:35:00',2.39),('12664','2013-08-22','09:40:00',2.55),('12664','2013-08-22','09:45:00',2.59),('12664','2013-08-22','09:50:00',2.8),('12664','2013-08-22','09:55:00',2.86),('12664','2013-08-22','10:00:00',2.86),('12664','2013-08-22','10:05:00',2.32),('12664','2013-08-22','10:10:00',2.45),('12664','2013-08-22','10:15:00',1.97),('12664','2013-08-22','10:20:00',2.87),('12664','2013-08-22','10:25:00',2.87),('12664','2013-08-22','10:30:00',3.19),('12664','2013-08-22','10:35:00',3.12),('12664','2013-08-22','10:40:00',3.23),('12664','2013-08-22','10:45:00',3.23),('12664','2013-08-22','10:50:00',3.26),('12664','2013-08-22','10:55:00',3.2),('12664','2013-08-22','11:00:00',3.36),('12664','2013-08-22','11:05:00',3.41),('12664','2013-08-22','11:10:00',3.43),('12664','2013-08-22','11:15:00',3.47),('12664','2013-08-22','11:20:00',3.53),('12664','2013-08-22','11:25:00',3.56),('12664','2013-08-22','11:30:00',3.59),('12664','2013-08-22','11:35:00',3.61),('12664','2013-08-22','11:40:00',3.65),('12664','2013-08-22','11:45:00',3.67),('12664','2013-08-22','11:50:00',3.68),('12664','2013-08-22','11:55:00',3.67),('12664','2013-08-22','12:00:00',3.72),('12664','2013-08-22','12:05:00',3.72),('12664','2013-08-22','12:10:00',3.73),('12664','2013-08-22','12:15:00',3.75),('12664','2013-08-22','12:20:00',3.75),('12664','2013-08-22','12:25:00',3.78),('12664','2013-08-22','12:30:00',3.79),('12664','2013-08-22','12:35:00',3.8),('12664','2013-08-22','12:40:00',3.78),('12664','2013-08-22','12:45:00',3.78),('12664','2013-08-22','12:50:00',3.79),('12664','2013-08-22','12:55:00',3.78),('12664','2013-08-22','13:00:00',3.78),('12664','2013-08-22','13:05:00',3.77),('12664','2013-08-22','13:10:00',3.77),('12664','2013-08-22','13:15:00',3.76),('12664','2013-08-22','13:20:00',3.77),('12664','2013-08-22','13:25:00',3.76),('12664','2013-08-22','13:30:00',3.74),('12664','2013-08-22','13:35:00',3.74),('12664','2013-08-22','13:40:00',3.75),('12664','2013-08-22','13:45:00',3.7),('12664','2013-08-22','13:50:00',3.63),('12664','2013-08-22','13:55:00',3.62),('12664','2013-08-22','14:00:00',3.66),('12664','2013-08-22','14:05:00',3.69),('12664','2013-08-22','14:10:00',3.49),('12664','2013-08-22','14:15:00',2.07),('12664','2013-08-22','14:20:00',3.57),('12664','2013-08-22','14:25:00',3.59),('12664','2013-08-22','14:30:00',3.64),('12664','2013-08-22','14:35:00',3.53),('12664','2013-08-22','14:40:00',3.53),('12664','2013-08-22','14:45:00',3.47),('12664','2013-08-22','14:50:00',3.46),('12664','2013-08-22','14:55:00',3.47),('12664','2013-08-22','15:00:00',3.47),('12664','2013-08-22','15:05:00',3.48),('12664','2013-08-22','15:10:00',3.4),('12664','2013-08-22','15:15:00',3.38),('12664','2013-08-22','15:20:00',3.32),('12664','2013-08-22','15:25:00',3.29),('12664','2013-08-22','15:30:00',3.26),('12664','2013-08-22','15:35:00',3.19),('12664','2013-08-22','15:40:00',3.13),('12664','2013-08-22','15:45:00',3.08),('12664','2013-08-22','15:50:00',3.02),('12664','2013-08-22','15:55:00',2.94),('12664','2013-08-22','16:00:00',2.88),('12664','2013-08-22','16:05:00',2.83),('12664','2013-08-22','16:10:00',2.78),('12664','2013-08-22','16:15:00',2.7),('12664','2013-08-22','16:20:00',2.6),('12664','2013-08-22','16:25:00',2.51),('12664','2013-08-22','16:30:00',2.46),('12664','2013-08-22','16:35:00',2.38),('12664','2013-08-22','16:40:00',2.31),('12664','2013-08-22','16:45:00',2.24),('12664','2013-08-22','16:50:00',2.12),('12664','2013-08-22','16:55:00',2.07),('12664','2013-08-22','17:00:00',2),('12664','2013-08-22','17:05:00',1.93),('12664','2013-08-22','17:10:00',1.86),('12664','2013-08-22','17:15:00',1.76),('12664','2013-08-22','17:20:00',1.68),('12664','2013-08-22','17:25:00',1.6),('12664','2013-08-22','17:30:00',1.53),('12664','2013-08-22','17:35:00',1.44),('12664','2013-08-22','17:40:00',1.35),('12664','2013-08-22','17:45:00',1.28),('12664','2013-08-22','17:50:00',1.21),('12664','2013-08-22','17:55:00',1.13),('12664','2013-08-22','18:00:00',1.04),('12664','2013-08-21','09:10:00',1.09),('12664','2013-08-21','09:15:00',1.35),('12664','2013-08-21','09:20:00',1.49),('12664','2013-08-21','09:25:00',2.22),('12664','2013-08-21','09:30:00',1.9),('12664','2013-08-21','09:35:00',1.22),('12664','2013-08-21','09:50:00',1.02),('12664','2013-08-21','09:55:00',1.06),('12664','2013-08-21','10:00:00',1.16),('12664','2013-08-21','10:05:00',1.69),('12664','2013-08-21','10:10:00',2.83),('12664','2013-08-21','10:15:00',2.79),('12664','2013-08-21','10:20:00',2.88),('12664','2013-08-21','10:25:00',2.97),('12664','2013-08-21','10:30:00',3.05),('12664','2013-08-21','10:35:00',3.11),('12664','2013-08-21','10:40:00',3.29),('12664','2013-08-21','10:45:00',3.38),('12664','2013-08-21','10:50:00',3.31),('12664','2013-08-21','10:55:00',3.31),('12664','2013-08-21','11:00:00',3.71),('12664','2013-08-21','11:05:00',2.72),('12664','2013-08-21','11:10:00',3.52),('12664','2013-08-21','11:15:00',2.25),('12664','2013-08-21','11:20:00',2.7),('12664','2013-08-21','11:25:00',2.81),('12664','2013-08-21','11:30:00',3.19),('12664','2013-08-21','11:35:00',4.5),('12664','2013-08-21','11:40:00',4.06),('12664','2013-08-21','11:45:00',4.12),('12664','2013-08-21','11:50:00',3.98),('12664','2013-08-21','11:55:00',4),('12664','2013-08-21','12:00:00',3.91),('12664','2013-08-21','12:05:00',4),('12664','2013-08-21','12:10:00',4),('12664','2013-08-21','12:15:00',4.01),('12664','2013-08-21','12:20:00',3.84),('12664','2013-08-21','12:25:00',3.98),('12664','2013-08-21','12:30:00',4),('12664','2013-08-21','12:35:00',3.78),('12664','2013-08-21','12:40:00',3.7),('12664','2013-08-21','12:45:00',2.61),('12664','2013-08-21','12:50:00',2.88),('12664','2013-08-21','12:55:00',3.77),('12664','2013-08-21','13:00:00',3.75),('12664','2013-08-21','13:05:00',3.74),('12664','2013-08-21','13:10:00',3.81),('12664','2013-08-21','13:15:00',3.88),('12664','2013-08-21','13:20:00',3.8),('12664','2013-08-21','13:25:00',3.69),('12664','2013-08-21','13:30:00',3.72),('12664','2013-08-21','13:35:00',3.83),('12664','2013-08-21','13:40:00',3.92),('12664','2013-08-21','13:45:00',3.94),('12664','2013-08-21','13:50:00',3.94),('12664','2013-08-21','13:55:00',3.91),('12664','2013-08-21','14:00:00',3.88),('12664','2013-08-21','14:05:00',3.88),('12664','2013-08-21','14:10:00',3.88),('12664','2013-08-21','14:15:00',3.83),('12664','2013-08-21','14:20:00',3.64),('12664','2013-08-21','14:25:00',3.25),('12664','2013-08-21','14:30:00',3.53),('12664','2013-08-21','14:35:00',3.41),('12664','2013-08-21','14:40:00',3.17),('12664','2013-08-21','14:45:00',3.49),('12664','2013-08-21','14:50:00',2.74),('12664','2013-08-21','14:55:00',3.47),('12664','2013-08-21','15:00:00',3.52),('12664','2013-08-21','15:05:00',3.51),('12664','2013-08-21','15:10:00',3.39),('12664','2013-08-21','15:15:00',3.2),('12664','2013-08-21','15:20:00',2.95),('12664','2013-08-21','15:25:00',2.87),('12664','2013-08-21','15:30:00',2.91),('12664','2013-08-21','15:35:00',2.92),('12664','2013-08-21','15:40:00',2.67),('12664','2013-08-21','15:45:00',2.69),('12664','2013-08-21','15:50:00',2.67),('12664','2013-08-21','15:55:00',2.73),('12664','2013-08-21','16:00:00',2.82),('12664','2013-08-21','16:05:00',2.68),('12664','2013-08-21','16:10:00',2.85),('12664','2013-08-21','16:15:00',2.85),('12664','2013-08-21','16:20:00',2.77),('12664','2013-08-21','16:25:00',2.65),('12664','2013-08-21','16:30:00',2.58),('12664','2013-08-21','16:35:00',2.58),('12664','2013-08-21','16:40:00',2.5),('12664','2013-08-21','16:45:00',2.44),('12664','2013-08-21','16:50:00',2.37),('12664','2013-08-21','16:55:00',2.34),('12664','2013-08-21','17:00:00',2.29),('12664','2013-08-21','17:05:00',2.19),('12664','2013-08-21','17:10:00',2.13),('12664','2013-08-21','17:15:00',2.05),('12664','2013-08-21','17:20:00',1.97),('12664','2013-08-21','17:25:00',1.9),('12664','2013-08-21','17:30:00',1.85),('12664','2013-08-21','17:35:00',1.75),('12664','2013-08-21','17:40:00',1.67),('12664','2013-08-21','17:45:00',1.6),('12664','2013-08-21','17:50:00',1.52),('12664','2013-08-21','17:55:00',1.42),('12664','2013-08-21','18:00:00',1.34),('12664','2013-08-21','18:05:00',1.25),('12664','2013-08-21','18:10:00',1.16),('12664','2013-08-21','18:15:00',1.04),('12664','2013-08-20','08:45:00',1.02),('12664','2013-08-20','08:50:00',1.18),('12664','2013-08-20','08:55:00',1.11),('12664','2013-08-20','09:15:00',1.33),('12664','2013-08-20','09:20:00',2.35),('12664','2013-08-20','09:25:00',2.18),('12664','2013-08-20','09:30:00',2.47),('12664','2013-08-20','09:35:00',2.63),('12664','2013-08-20','09:55:00',1.18),('12664','2013-08-20','10:00:00',2.59),('12664','2013-08-20','10:05:00',3.34),('12664','2013-08-20','10:10:00',3.15),('12664','2013-08-20','10:15:00',2.07),('12664','2013-08-20','10:20:00',1.76),('12664','2013-08-20','10:25:00',2.05),('12664','2013-08-20','10:30:00',1.97),('12664','2013-08-20','10:35:00',1.07),('12664','2013-08-20','10:40:00',1.01),('12664','2013-08-20','10:45:00',1.28),('12664','2013-08-20','10:50:00',3.28),('12664','2013-08-20','10:55:00',3.82),('12664','2013-08-20','11:00:00',3.59),('12664','2013-08-20','11:05:00',3.01),('12664','2013-08-20','11:10:00',4.28),('12664','2013-08-20','11:15:00',4.08),('12664','2013-08-20','11:20:00',2.53),('12664','2013-08-20','11:25:00',3.33),('12664','2013-08-20','11:30:00',4.09),('12664','2013-08-20','11:35:00',4.33),('12664','2013-08-20','11:40:00',3.39),('12664','2013-08-20','11:45:00',2.97),('12664','2013-08-20','11:50:00',2.25),('12664','2013-08-20','11:55:00',2.43),('12664','2013-08-20','12:00:00',1.76),('12664','2013-08-20','12:05:00',1.91),('12664','2013-08-20','12:10:00',1.77),('12664','2013-08-20','12:15:00',1.61),('12664','2013-08-20','12:20:00',1.7),('12664','2013-08-20','12:25:00',1.79),('12664','2013-08-20','12:30:00',1.74),('12664','2013-08-20','12:35:00',2.92),('12664','2013-08-20','12:40:00',2.23),('12664','2013-08-20','12:45:00',1.77),('12664','2013-08-20','12:50:00',2.08),('12664','2013-08-20','12:55:00',1.95),('12664','2013-08-20','13:00:00',1.62),('12664','2013-08-20','13:05:00',1.5),('12664','2013-08-20','13:10:00',1.92),('12664','2013-08-20','13:15:00',2.37),('12664','2013-08-20','13:20:00',1.95),('12664','2013-08-20','13:25:00',2.36),('12664','2013-08-20','13:30:00',2.44),('12664','2013-08-20','13:35:00',2.37),('12664','2013-08-20','13:40:00',4.56),('12664','2013-08-20','13:45:00',4.53),('12664','2013-08-20','13:50:00',4.23),('12664','2013-08-20','13:55:00',4.19),('12664','2013-08-20','14:00:00',3.77),('12664','2013-08-20','14:05:00',4.26),('12664','2013-08-20','14:10:00',4.03),('12664','2013-08-20','14:15:00',3.76),('12664','2013-08-20','14:20:00',2.95),('12664','2013-08-20','14:25:00',4.13),('12664','2013-08-20','14:30:00',3.66),('12664','2013-08-20','14:35:00',3.67),('12664','2013-08-20','14:40:00',4.09),('12664','2013-08-20','14:45:00',4),('12664','2013-08-20','14:50:00',3.92),('12664','2013-08-20','14:55:00',4.02),('12664','2013-08-20','15:00:00',3.89),('12664','2013-08-20','15:05:00',3.75),('12664','2013-08-20','15:10:00',2.91),('12664','2013-08-20','15:15:00',2.75),('12664','2013-08-20','15:20:00',2.88),('12664','2013-08-20','15:25:00',4.01),('12664','2013-08-20','15:30:00',2.83),('12664','2013-08-20','15:35:00',1.66),('12664','2013-08-20','15:40:00',1.41),('12664','2013-08-20','15:45:00',3.41),('12664','2013-08-20','15:50:00',3.7),('12664','2013-08-20','15:55:00',3.49),('12664','2013-08-20','16:00:00',3.33),('12664','2013-08-20','16:05:00',3.39),('12664','2013-08-20','16:10:00',3.44),('12664','2013-08-20','16:15:00',3.46),('12664','2013-08-20','16:20:00',3.44),('12664','2013-08-20','16:25:00',3.38),('12664','2013-08-20','16:30:00',3.11),('12664','2013-08-20','16:35:00',3.04),('12664','2013-08-20','16:40:00',1.66),('12664','2013-08-20','16:45:00',2.39),('12664','2013-08-20','16:50:00',2.53),('12664','2013-08-20','16:55:00',2.21),('12664','2013-08-20','17:00:00',2.1),('12664','2013-08-20','17:05:00',2.22),('12664','2013-08-20','17:10:00',2.15),('12664','2013-08-20','17:15:00',2.05),('12664','2013-08-20','17:25:00',1.92),('12664','2013-08-20','17:30:00',1.76),('12664','2013-08-20','17:35:00',1.7),('12664','2013-08-20','17:40:00',1.57),('12664','2013-08-20','17:45:00',1.47),('12664','2013-08-20','17:50:00',1.36),('12664','2013-08-20','17:55:00',1.25),('12664','2013-08-20','18:00:00',1.18),('12664','2013-08-20','18:05:00',1.1),('12664','2013-08-20','18:10:00',1.01),('12664','2013-08-19','08:15:00',1.07),('12664','2013-08-19','08:20:00',1.18),('12664','2013-08-19','08:25:00',1.34),('12664','2013-08-19','08:30:00',1.41),('12664','2013-08-19','08:35:00',1.48),('12664','2013-08-19','08:40:00',1.55),('12664','2013-08-19','08:45:00',1.66),('12664','2013-08-19','08:50:00',1.77),('12664','2013-08-19','08:55:00',1.87),('12664','2013-08-19','09:00:00',1.94),('12664','2013-08-19','09:05:00',2.03),('12664','2013-08-19','09:10:00',2.12),('12664','2013-08-19','09:15:00',2.21),('12664','2013-08-19','09:20:00',2.3),('12664','2013-08-19','09:25:00',2.36),('12664','2013-08-19','09:30:00',2.44),('12664','2013-08-19','09:35:00',2.49),('12664','2013-08-19','09:40:00',2.57),('12664','2013-08-19','09:45:00',2.65),('12664','2013-08-19','09:50:00',2.69),('12664','2013-08-19','09:55:00',2.75),('12664','2013-08-19','10:00:00',2.82),('12664','2013-08-19','10:05:00',2.88),('12664','2013-08-19','10:10:00',2.92),('12664','2013-08-19','10:15:00',2.98),('12664','2013-08-19','10:20:00',3.06),('12664','2013-08-19','10:25:00',3.12),('12664','2013-08-19','10:30:00',3.17),('12664','2013-08-19','10:35:00',3.21),('12664','2013-08-19','10:40:00',3.25),('12664','2013-08-19','10:45:00',3.3),('12664','2013-08-19','10:50:00',3.34),('12664','2013-08-19','10:55:00',3.37),('12664','2013-08-19','11:00:00',3.41),('12664','2013-08-19','11:05:00',3.45),('12664','2013-08-19','11:10:00',3.48),('12664','2013-08-19','11:15:00',3.52),('12664','2013-08-19','11:20:00',3.55),('12664','2013-08-19','11:25:00',3.55),('12664','2013-08-19','11:30:00',3.6),('12664','2013-08-19','11:35:00',3.69),('12664','2013-08-19','11:40:00',3.7),('12664','2013-08-19','11:45:00',3.73),('12664','2013-08-19','11:50:00',3.8),('12664','2013-08-19','11:55:00',3.81),('12664','2013-08-19','12:00:00',3.86),('12664','2013-08-19','12:05:00',3.82),('12664','2013-08-19','12:10:00',3.78),('12664','2013-08-19','12:15:00',3.87),('12664','2013-08-19','12:20:00',3.89),('12664','2013-08-19','12:25:00',3.98),('12664','2013-08-19','12:30:00',4),('12664','2013-08-19','12:35:00',4),('12664','2013-08-19','12:40:00',4.02),('12664','2013-08-19','12:45:00',3.99),('12664','2013-08-19','12:50:00',3.98),('12664','2013-08-19','12:55:00',4.02),('12664','2013-08-19','13:00:00',4.03),('12664','2013-08-19','13:05:00',4),('12664','2013-08-19','13:10:00',4.05),('12664','2013-08-19','13:15:00',4.04),('12664','2013-08-19','13:20:00',4.04),('12664','2013-08-19','13:25:00',4.05),('12664','2013-08-19','13:30:00',4.06),('12664','2013-08-19','13:35:00',4.05),('12664','2013-08-19','13:40:00',4.05),('12664','2013-08-19','13:45:00',4.02),('12664','2013-08-19','13:50:00',4.02),('12664','2013-08-19','13:55:00',4),('12664','2013-08-19','14:00:00',4.01),('12664','2013-08-19','14:05:00',4),('12664','2013-08-19','14:10:00',3.96),('12664','2013-08-19','14:15:00',3.96),('12664','2013-08-19','14:20:00',3.93),('12664','2013-08-19','14:25:00',3.93),('12664','2013-08-19','14:30:00',3.9),('12664','2013-08-19','14:35:00',3.88),('12664','2013-08-19','14:40:00',3.85),('12664','2013-08-19','14:45:00',3.83),('12664','2013-08-19','14:50:00',3.77),('12664','2013-08-19','14:55:00',3.73),('12664','2013-08-19','15:00:00',3.73),('12664','2013-08-19','15:05:00',3.68),('12664','2013-08-19','15:10:00',3.63),('12664','2013-08-19','15:15:00',3.59),('12664','2013-08-19','15:20:00',3.55),('12664','2013-08-19','15:25:00',3.5),('12664','2013-08-19','15:30:00',3.45),('12664','2013-08-19','15:35:00',3.41),('12664','2013-08-19','15:40:00',3.36),('12664','2013-08-19','15:45:00',3.28),('12664','2013-08-19','15:50:00',3.24),('12664','2013-08-19','15:55:00',3.18),('12664','2013-08-19','16:00:00',3.12),('12664','2013-08-19','16:05:00',3.06),('12664','2013-08-19','16:10:00',2.99),('12664','2013-08-19','16:15:00',2.92),('12664','2013-08-19','16:20:00',2.87),('12664','2013-08-19','16:25:00',2.81),('12664','2013-08-19','16:30:00',2.73),('12664','2013-08-19','16:35:00',2.65),('12664','2013-08-19','16:40:00',2.58),('12664','2013-08-19','16:45:00',2.51),('12664','2013-08-19','16:50:00',2.44),('12664','2013-08-19','16:55:00',2.35),('12664','2013-08-19','17:00:00',2.27),('12664','2013-08-19','17:05:00',2.18),('12664','2013-08-19','17:10:00',2.1),('12664','2013-08-19','17:15:00',2.03),('12664','2013-08-19','17:20:00',1.95),('12664','2013-08-19','17:25:00',1.86),('12664','2013-08-19','17:30:00',1.78),('12664','2013-08-19','17:35:00',1.68),('12664','2013-08-19','17:40:00',1.59),('12664','2013-08-19','17:45:00',1.5),('12664','2013-08-19','17:50:00',1.42),('12664','2013-08-19','17:55:00',1.33),('12664','2013-08-19','18:00:00',1.24),('12664','2013-08-19','18:05:00',1.14),('12664','2013-08-19','18:10:00',1.05),('12664','2014-04-09','10:00:00',1.1),('12664','2014-04-09','10:05:00',2.11),('12664','2014-04-09','10:10:00',2.86),('12664','2014-04-09','10:15:00',2.3),('12664','2014-04-09','10:20:00',2.32),('12664','2014-04-09','10:25:00',1.98),('12664','2014-04-09','10:30:00',1.22),('12664','2014-04-09','10:35:00',3.53),('12664','2014-04-09','10:40:00',3.65),('12664','2014-04-09','10:45:00',3.62),('12664','2014-04-09','10:50:00',3.23),('12664','2014-04-09','10:55:00',1.69),('12664','2014-04-09','11:00:00',3.97),('12664','2014-04-09','11:05:00',3.12),('12664','2014-04-09','11:10:00',2.38),('12664','2014-04-09','11:15:00',3.61),('12664','2014-04-09','11:20:00',3.93),('12664','2014-04-09','11:25:00',4.39),('12664','2014-04-09','11:30:00',1.66),('12664','2014-04-09','11:35:00',3.14),('12664','2014-04-09','11:40:00',3.86),('12664','2014-04-09','11:45:00',1.91),('12664','2014-04-09','11:50:00',1.53),('12664','2014-04-09','11:55:00',4.42),('12664','2014-04-09','12:00:00',3.38),('12664','2014-04-09','12:05:00',2.78),('12664','2014-04-09','12:10:00',1.55),('12664','2014-04-09','12:15:00',1.17),('12664','2014-04-09','12:20:00',1.2),('12664','2014-04-09','12:25:00',1.12),('12664','2014-04-09','13:40:00',1.06),('12664','2014-04-09','13:45:00',1.15),('12664','2014-04-09','13:50:00',1.13),('12664','2014-04-09','13:55:00',1.33),('12664','2014-04-09','14:00:00',1.26),('12664','2014-04-09','14:05:00',1.09),('12664','2014-04-09','14:10:00',1.09),('12664','2014-04-09','14:15:00',2.51),('12664','2014-04-09','14:20:00',3.23),('12664','2014-04-09','14:25:00',2.75),('12664','2014-04-09','14:30:00',1.91),('12664','2014-04-09','14:35:00',3.51),('12664','2014-04-09','14:40:00',1.34),('12664','2014-04-09','14:45:00',2.6),('12664','2014-04-09','14:50:00',1.17),('12664','2014-04-09','14:55:00',1.09),('12664','2014-04-09','15:00:00',1.08),('12664','2014-04-09','15:30:00',1.64),('12664','2014-04-09','15:35:00',2.89),('12664','2014-04-09','15:40:00',3.48),('12664','2014-04-09','15:45:00',3.29),('12664','2014-04-09','15:50:00',3.22),('12664','2014-04-09','15:55:00',2.96),('12664','2014-04-09','16:00:00',2.97),('12664','2014-04-09','16:05:00',2.86),('12664','2014-04-09','16:10:00',2.83),('12664','2014-04-09','16:15:00',2.74),('12664','2014-04-09','16:20:00',2.67),('12664','2014-04-09','16:25:00',2.58),('12664','2014-04-09','16:30:00',2.53),('12664','2014-04-09','16:35:00',2.47),('12664','2014-04-09','16:40:00',2.38),('12664','2014-04-09','16:45:00',2.28),('12664','2014-04-09','16:50:00',2.26),('12664','2014-04-09','16:55:00',2.31),('12664','2014-04-09','17:00:00',2.19),('12664','2014-04-09','17:05:00',1.22),('12664','2014-04-09','17:10:00',1.84),('12664','2014-04-09','17:15:00',1.63),('12664','2014-04-09','17:20:00',1.25),('12664','2014-04-09','17:30:00',1.38),('12664','2014-04-09','17:35:00',1.69),('12664','2014-04-09','17:40:00',1.2),('12664','2014-04-09','17:45:00',1.22),('12664','2014-04-09','17:50:00',1.19),('12664','2013-08-18','08:05:00',1.05),('12664','2013-08-18','08:10:00',1.14),('12664','2013-08-18','08:15:00',1.23),('12664','2013-08-18','08:20:00',1.31),('12664','2013-08-18','08:25:00',1.41),('12664','2013-08-18','08:30:00',1.49),('12664','2013-08-18','08:35:00',1.58),('12664','2013-08-18','08:40:00',1.66),('12664','2013-08-18','08:45:00',1.74),('12664','2013-08-18','08:50:00',1.82),('12664','2013-08-18','08:55:00',1.9),('12664','2013-08-18','09:00:00',1.98),('12664','2013-08-18','09:05:00',2.07),('12664','2013-08-18','09:10:00',2.15),('12664','2013-08-18','09:15:00',2.22),('12664','2013-08-18','09:20:00',2.3),('12664','2013-08-18','09:25:00',2.38),('12664','2013-08-18','09:30:00',2.48),('12664','2013-08-18','09:35:00',2.47),('12664','2013-08-18','09:40:00',2.56),('12664','2013-08-18','09:45:00',2.43),('12664','2013-08-18','09:50:00',2.7),('12664','2013-08-18','09:55:00',2.8),('12664','2013-08-18','10:00:00',2.86),('12664','2013-08-18','10:05:00',2.92),('12664','2013-08-18','10:10:00',2.97),('12664','2013-08-18','10:15:00',3.03),('12664','2013-08-18','10:20:00',3.08),('12664','2013-08-18','10:25:00',3.14),('12664','2013-08-18','10:30:00',3.19),('12664','2013-08-18','10:35:00',3.25),('12664','2013-08-18','10:40:00',3.28),('12664','2013-08-18','10:45:00',3.32),('12664','2013-08-18','10:50:00',3.36),('12664','2013-08-18','10:55:00',3.37),('12664','2013-08-18','11:00:00',3.41),('12664','2013-08-18','11:05:00',3.46),('12664','2013-08-18','11:10:00',3.51),('12664','2013-08-18','11:15:00',3.55),('12664','2013-08-18','11:20:00',3.61),('12664','2013-08-18','11:25:00',3.64),('12664','2013-08-18','11:30:00',3.61),('12664','2013-08-18','11:35:00',3.68),('12664','2013-08-18','11:40:00',3.67),('12664','2013-08-18','11:45:00',3.71),('12664','2013-08-18','11:50:00',3.77),('12664','2013-08-18','11:55:00',3.79),('12664','2013-08-18','12:00:00',3.82),('12664','2013-08-18','12:05:00',3.83),('12664','2013-08-18','12:10:00',3.87),('12664','2013-08-18','12:15:00',3.86),('12664','2013-08-18','12:20:00',3.95),('12664','2013-08-18','12:25:00',3.81),('12664','2013-08-18','12:30:00',3.21),('12664','2013-08-18','12:35:00',4.14),('12664','2013-08-18','12:40:00',4.05),('12664','2013-08-18','12:45:00',3.99),('12664','2013-08-18','12:50:00',4.03),('12664','2013-08-18','12:55:00',4.06),('12664','2013-08-18','13:00:00',4.08),('12664','2013-08-18','13:05:00',4.03),('12664','2013-08-18','13:10:00',4.04),('12664','2013-08-18','13:15:00',4.01),('12664','2013-08-18','13:20:00',4.02),('12664','2013-08-18','13:25:00',4.03),('12664','2013-08-18','13:30:00',4.01),('12664','2013-08-18','13:35:00',4.01),('12664','2013-08-18','13:40:00',4.04),('12664','2013-08-18','13:45:00',4.05),('12664','2013-08-18','13:50:00',4.03),('12664','2013-08-18','13:55:00',4.03),('12664','2013-08-18','14:00:00',4.02),('12664','2013-08-18','14:05:00',4.03),('12664','2013-08-18','14:10:00',3.97),('12664','2013-08-18','14:15:00',3.95),('12664','2013-08-18','14:20:00',3.94),('12664','2013-08-18','14:25:00',3.9),('12664','2013-08-18','14:30:00',3.9),('12664','2013-08-18','14:35:00',3.86),('12664','2013-08-18','14:40:00',3.8),('12664','2013-08-18','14:45:00',3.79),('12664','2013-08-18','14:50:00',3.75),('12664','2013-08-18','14:55:00',3.73),('12664','2013-08-18','15:00:00',3.71),('12664','2013-08-18','15:05:00',3.67),('12664','2013-08-18','15:10:00',3.62),('12664','2013-08-18','15:15:00',3.56),('12664','2013-08-18','15:20:00',3.52),('12664','2013-08-18','15:25:00',3.46),('12664','2013-08-18','15:30:00',3.41),('12664','2013-08-18','15:35:00',3.37),('12664','2013-08-18','15:40:00',3.33),('12664','2013-08-18','15:45:00',3.28),('12664','2013-08-18','15:50:00',3.22),('12664','2013-08-18','15:55:00',3.17),('12664','2013-08-18','16:00:00',3.12),('12664','2013-08-18','16:05:00',3.07),('12664','2013-08-18','16:10:00',3.02),('12664','2013-08-18','16:15:00',2.95),('12664','2013-08-18','16:20:00',2.89),('12664','2013-08-18','16:25:00',2.81),('12664','2013-08-18','16:30:00',2.75),('12664','2013-08-18','16:35:00',2.68),('12664','2013-08-18','16:40:00',2.61),('12664','2013-08-18','16:45:00',2.54),('12664','2013-08-18','16:50:00',2.46),('12664','2013-08-18','16:55:00',2.39),('12664','2013-08-18','17:00:00',2.31),('12664','2013-08-18','17:05:00',2.22),('12664','2013-08-18','17:10:00',2.14),('12664','2013-08-18','17:15:00',2.06),('12664','2013-08-18','17:20:00',1.98),('12664','2013-08-18','17:25:00',1.89),('12664','2013-08-18','17:30:00',1.8),('12664','2013-08-18','17:35:00',1.71),('12664','2013-08-18','17:40:00',1.62),('12664','2013-08-18','17:45:00',1.53),('12664','2013-08-18','17:50:00',1.43),('12664','2013-08-18','17:55:00',1.34),('12664','2013-08-18','18:00:00',1.25),('12664','2013-08-18','18:05:00',1.16),('12664','2013-08-18','18:10:00',1.07),('12664','2013-08-17','08:05:00',1.02),('12664','2013-08-17','08:10:00',1.11),('12664','2013-08-17','08:15:00',1.2),('12664','2013-08-17','08:20:00',1.29),('12664','2013-08-17','08:25:00',1.39),('12664','2013-08-17','08:30:00',1.48),('12664','2013-08-17','08:35:00',1.58),('12664','2013-08-17','08:40:00',1.67),('12664','2013-08-17','08:45:00',1.76),('12664','2013-08-17','08:50:00',1.86),('12664','2013-08-17','08:55:00',1.95),('12664','2013-08-17','09:00:00',2.03),('12664','2013-08-17','09:05:00',2.1),('12664','2013-08-17','09:10:00',2.19),('12664','2013-08-17','09:15:00',2.27),('12664','2013-08-17','09:20:00',2.34),('12664','2013-08-17','09:25:00',2.42),('12664','2013-08-17','09:30:00',2.5),('12664','2013-08-17','09:35:00',2.57),('12664','2013-08-17','09:40:00',2.64),('12664','2013-08-17','09:45:00',2.71),('12664','2013-08-17','09:50:00',2.77),('12664','2013-08-17','09:55:00',2.82),('12664','2013-08-17','10:00:00',2.89),('12664','2013-08-17','10:05:00',2.95),('12664','2013-08-17','10:10:00',3.01),('12664','2013-08-17','10:15:00',3.06),('12664','2013-08-17','10:20:00',3.08),('12664','2013-08-17','10:25:00',3.15),('12664','2013-08-17','10:30:00',3.19),('12664','2013-08-17','10:35:00',3.24),('12664','2013-08-17','10:40:00',3.3),('12664','2013-08-17','10:45:00',3.35),('12664','2013-08-17','10:50:00',3.39),('12664','2013-08-17','10:55:00',3.42),('12664','2013-08-17','11:00:00',3.46),('12664','2013-08-17','11:05:00',3.52),('12664','2013-08-17','11:10:00',3.58),('12664','2013-08-17','11:15:00',3.59),('12664','2013-08-17','11:20:00',3.64),('12664','2013-08-17','11:25:00',3.69),('12664','2013-08-17','11:30:00',3.72),('12664','2013-08-17','11:35:00',3.72),('12664','2013-08-17','11:40:00',3.74),('12664','2013-08-17','11:45:00',3.76),('12664','2013-08-17','11:50:00',3.76),('12664','2013-08-17','11:55:00',3.78),('12664','2013-08-17','12:00:00',3.79),('12664','2013-08-17','12:05:00',3.72),('12664','2013-08-17','12:10:00',3.85),('12664','2013-08-17','12:15:00',3.9),('12664','2013-08-17','12:20:00',3.91),('12664','2013-08-17','12:25:00',3.91),('12664','2013-08-17','12:30:00',3.88),('12664','2013-08-17','12:35:00',3.95),('12664','2013-08-17','12:40:00',3.97),('12664','2013-08-17','12:45:00',3.98),('12664','2013-08-17','12:50:00',3.88),('12664','2013-08-17','12:55:00',3.95),('12664','2013-08-17','13:00:00',3.97),('12664','2013-08-17','13:05:00',3.95),('12664','2013-08-17','13:10:00',4.03),('12664','2013-08-17','13:15:00',4.03),('12664','2013-08-17','13:20:00',3.59),('12664','2013-08-17','13:25:00',3.97),('12664','2013-08-17','13:30:00',4.06),('12664','2013-08-17','13:35:00',3.81),('12664','2013-08-17','13:40:00',4.01),('12664','2013-08-17','13:45:00',4.02),('12664','2013-08-17','13:50:00',3.98),('12664','2013-08-17','13:55:00',3.96),('12664','2013-08-17','14:00:00',3.96),('12664','2013-08-17','14:05:00',3.93),('12664','2013-08-17','14:10:00',3.93),('12664','2013-08-17','14:15:00',3.94),('12664','2013-08-17','14:20:00',3.92),('12664','2013-08-17','14:25:00',3.9),('12664','2013-08-17','14:30:00',3.87),('12664','2013-08-17','14:35:00',3.83),('12664','2013-08-17','14:40:00',3.8),('12664','2013-08-17','14:45:00',3.78),('12664','2013-08-17','14:50:00',3.73),('12664','2013-08-17','14:55:00',3.71),('12664','2013-08-17','15:00:00',3.72),('12664','2013-08-17','15:05:00',3.68),('12664','2013-08-17','15:10:00',3.64),('12664','2013-08-17','15:15:00',3.6),('12664','2013-08-17','15:20:00',3.56),('12664','2013-08-17','15:25:00',3.52),('12664','2013-08-17','15:30:00',3.47),('12664','2013-08-17','15:35:00',3.42),('12664','2013-08-17','15:40:00',3.38),('12664','2013-08-17','15:45:00',3.33),('12664','2013-08-17','15:50:00',3.27),('12664','2013-08-17','15:55:00',3.21),('12664','2013-08-17','16:00:00',3.16),('12664','2013-08-17','16:05:00',3.09),('12664','2013-08-17','16:10:00',3.04),('12664','2013-08-17','16:15:00',2.98),('12664','2013-08-17','16:20:00',2.93),('12664','2013-08-17','16:25:00',2.87),('12664','2013-08-17','16:30:00',2.79),('12664','2013-08-17','16:35:00',2.74),('12664','2013-08-17','16:40:00',2.66),('12664','2013-08-17','16:45:00',2.58),('12664','2013-08-17','16:50:00',2.49),('12664','2013-08-17','16:55:00',2.44),('12664','2013-08-17','17:00:00',2.31),('12664','2013-08-17','17:05:00',2.26),('12664','2013-08-17','17:10:00',2.17),('12664','2013-08-17','17:15:00',2.08),('12664','2013-08-17','17:20:00',2.05),('12664','2013-08-17','17:25:00',1.95),('12664','2013-08-17','17:30:00',1.86),('12664','2013-08-17','17:35:00',1.77),('12664','2013-08-17','17:40:00',1.7),('12664','2013-08-17','17:45:00',1.59),('12664','2013-08-17','17:50:00',1.5),('12664','2013-08-17','17:55:00',1.4),('12664','2013-08-17','18:00:00',1.32),('12664','2013-08-17','18:05:00',1.21),('12664','2013-08-17','18:10:00',1.12),('12664','2013-08-17','18:15:00',1.03),('12664','2013-08-16','08:05:00',1.06),('12664','2013-08-16','08:10:00',1.15),('12664','2013-08-16','08:15:00',1.24),('12664','2013-08-16','08:20:00',1.33),('12664','2013-08-16','08:25:00',1.42),('12664','2013-08-16','08:30:00',1.51),('12664','2013-08-16','08:35:00',1.6),('12664','2013-08-16','08:40:00',1.69),('12664','2013-08-16','08:45:00',1.78),('12664','2013-08-16','08:50:00',1.87),('12664','2013-08-16','08:55:00',1.96),('12664','2013-08-16','09:00:00',2.04),('12664','2013-08-16','09:05:00',2.13),('12664','2013-08-16','09:10:00',2.22),('12664','2013-08-16','09:15:00',2.3),('12664','2013-08-16','09:20:00',2.38),('12664','2013-08-16','09:25:00',2.46),('12664','2013-08-16','09:30:00',2.53),('12664','2013-08-16','09:35:00',2.61),('12664','2013-08-16','09:40:00',2.68),('12664','2013-08-16','09:45:00',2.74),('12664','2013-08-16','09:50:00',2.81),('12664','2013-08-16','09:55:00',2.89),('12664','2013-08-16','10:00:00',2.96),('12664','2013-08-16','10:05:00',3.02),('12664','2013-08-16','10:10:00',3.08),('12664','2013-08-16','10:15:00',3.15),('12664','2013-08-16','10:20:00',3.21),('12664','2013-08-16','10:25:00',3.26),('12664','2013-08-16','10:30:00',3.32),('12664','2013-08-16','10:35:00',3.38),('12664','2013-08-16','10:40:00',3.43),('12664','2013-08-16','10:45:00',3.49),('12664','2013-08-16','10:50:00',3.53),('12664','2013-08-16','10:55:00',3.59),('12664','2013-08-16','11:00:00',3.6),('12664','2013-08-16','11:05:00',3.64),('12664','2013-08-16','11:10:00',3.67),('12664','2013-08-16','11:15:00',3.7),('12664','2013-08-16','11:20:00',3.72),('12664','2013-08-16','11:25:00',3.76),('12664','2013-08-16','11:30:00',3.79),('12664','2013-08-16','11:35:00',3.81),('12664','2013-08-16','11:40:00',3.84),('12664','2013-08-16','11:45:00',3.88),('12664','2013-08-16','11:50:00',3.89),('12664','2013-08-16','11:55:00',3.9),('12664','2013-08-16','12:00:00',3.93),('12664','2013-08-16','12:05:00',3.96),('12664','2013-08-16','12:10:00',3.97),('12664','2013-08-16','12:15:00',3.99),('12664','2013-08-16','12:20:00',4.01),('12664','2013-08-16','12:25:00',4.02),('12664','2013-08-16','12:30:00',4.01),('12664','2013-08-16','12:35:00',4.01),('12664','2013-08-16','12:40:00',4.01),('12664','2013-08-16','12:45:00',4.02),('12664','2013-08-16','12:50:00',4.01),('12664','2013-08-16','12:55:00',4.02),('12664','2013-08-16','13:00:00',4.02),('12664','2013-08-16','13:05:00',4),('12664','2013-08-16','13:10:00',4),('12664','2013-08-16','13:15:00',4),('12664','2013-08-16','13:20:00',4.01),('12664','2013-08-16','13:25:00',3.99),('12664','2013-08-16','13:30:00',3.96),('12664','2013-08-16','13:35:00',3.96),('12664','2013-08-16','13:40:00',3.97),('12664','2013-08-16','13:45:00',3.95),('12664','2013-08-16','13:50:00',3.94),('12664','2013-08-16','13:55:00',3.92),('12664','2013-08-16','14:00:00',3.91),('12664','2013-08-16','14:05:00',3.89),('12664','2013-08-16','14:10:00',3.88),('12664','2013-08-16','14:15:00',3.86),('12664','2013-08-16','14:20:00',3.82),('12664','2013-08-16','14:25:00',3.82),('12664','2013-08-16','14:30:00',3.8),('12664','2013-08-16','14:35:00',3.76),('12664','2013-08-16','14:40:00',3.7),('12664','2013-08-16','14:45:00',3.61),('12664','2013-08-16','14:50:00',3.65),('12664','2013-08-16','14:55:00',3.68),('12664','2013-08-16','15:00:00',3.68),('12664','2013-08-16','15:05:00',3.67),('12664','2013-08-16','15:10:00',3.62),('12664','2013-08-16','15:15:00',3.59),('12664','2013-08-16','15:20:00',3.56),('12664','2013-08-16','15:25:00',3.51),('12664','2013-08-16','15:30:00',3.47),('12664','2013-08-16','15:35:00',3.42),('12664','2013-08-16','15:40:00',3.36),('12664','2013-08-16','15:45:00',3.31),('12664','2013-08-16','15:50:00',3.24),('12664','2013-08-16','15:55:00',3.2),('12664','2013-08-16','16:00:00',3.14),('12664','2013-08-16','16:05:00',3.07),('12664','2013-08-16','16:10:00',3.01),('12664','2013-08-16','16:15:00',2.96),('12664','2013-08-16','16:20:00',2.89),('12664','2013-08-16','16:25:00',2.82),('12664','2013-08-16','16:30:00',2.76),('12664','2013-08-16','16:35:00',2.69),('12664','2013-08-16','16:40:00',2.63),('12664','2013-08-16','16:45:00',2.56),('12664','2013-08-16','16:50:00',2.47),('12664','2013-08-16','16:55:00',2.4),('12664','2013-08-16','17:00:00',2.31),('12664','2013-08-16','17:05:00',2.23),('12664','2013-08-16','17:10:00',2.14),('12664','2013-08-16','17:15:00',2.06),('12664','2013-08-16','17:20:00',1.93),('12664','2013-08-16','17:25:00',1.88),('12664','2013-08-16','17:30:00',1.8),('12664','2013-08-16','17:35:00',1.72),('12664','2013-08-16','17:40:00',1.63),('12664','2013-08-16','17:45:00',1.54),('12664','2013-08-16','17:50:00',1.45),('12664','2013-08-16','17:55:00',1.36),('12664','2013-08-16','18:00:00',1.28),('12664','2013-08-16','18:05:00',1.19),('12664','2013-08-16','18:10:00',1.1),('12664','2013-08-16','18:15:00',1.02),('12664','2013-08-15','08:10:00',1.29),('12664','2013-08-15','08:15:00',1.56),('12664','2013-08-15','08:20:00',1.05),('12664','2013-08-15','08:25:00',1.35),('12664','2013-08-15','08:30:00',1.65),('12664','2013-08-15','08:35:00',1.69),('12664','2013-08-15','08:40:00',1.28),('12664','2013-08-15','08:45:00',1.25),('12664','2013-08-15','08:50:00',1.84),('12664','2013-08-15','08:55:00',1.98),('12664','2013-08-15','09:00:00',2.07),('12664','2013-08-15','09:05:00',2.16),('12664','2013-08-15','09:10:00',2.26),('12664','2013-08-15','09:15:00',2.33),('12664','2013-08-15','09:20:00',2.41),('12664','2013-08-15','09:25:00',2.46),('12664','2013-08-15','09:30:00',2.54),('12664','2013-08-15','09:35:00',2.63),('12664','2013-08-15','09:40:00',2.72),('12664','2013-08-15','09:45:00',2.8),('12664','2013-08-15','09:50:00',2.86),('12664','2013-08-15','09:55:00',2.92),('12664','2013-08-15','10:00:00',2.99),('12664','2013-08-15','10:05:00',3.06),('12664','2013-08-15','10:10:00',3.1),('12664','2013-08-15','10:15:00',3.14),('12664','2013-08-15','10:20:00',3.19),('12664','2013-08-15','10:25:00',3.25),('12664','2013-08-15','10:30:00',3.31),('12664','2013-08-15','10:35:00',3.37),('12664','2013-08-15','10:40:00',3.42),('12664','2013-08-15','10:45:00',3.47),('12664','2013-08-15','10:50:00',3.53),('12664','2013-08-15','10:55:00',3.6),('12664','2013-08-15','11:00:00',3.67),('12664','2013-08-15','11:05:00',3.72),('12664','2013-08-15','11:10:00',3.77),('12664','2013-08-15','11:15:00',3.83),('12664','2013-08-15','11:20:00',3.89),('12664','2013-08-15','11:25:00',3.95),('12664','2013-08-15','11:30:00',3.82),('12664','2013-08-15','11:35:00',3.4),('12664','2013-08-15','11:40:00',3.59),('12664','2013-08-15','11:45:00',3.6),('12664','2013-08-15','11:50:00',3.86),('12664','2013-08-15','11:55:00',3.11),('12664','2013-08-15','12:00:00',2.78),('12664','2013-08-15','12:05:00',3.19),('12664','2013-08-15','12:10:00',3.36),('12664','2013-08-15','12:15:00',3.75),('12664','2013-08-15','12:20:00',4.01),('12664','2013-08-15','12:25:00',4.04),('12664','2013-08-15','12:30:00',4),('12664','2013-08-15','12:35:00',4.06),('12664','2013-08-15','12:40:00',4.13),('12664','2013-08-15','12:45:00',4.17),('12664','2013-08-15','12:50:00',4.11),('12664','2013-08-15','12:55:00',3.94),('12664','2013-08-15','13:00:00',3.69),('12664','2013-08-15','13:05:00',3.72),('12664','2013-08-15','13:10:00',3.84),('12664','2013-08-15','13:15:00',3.79),('12664','2013-08-15','13:20:00',3.85),('12664','2013-08-15','13:25:00',3.86),('12664','2013-08-15','13:30:00',3.87),('12664','2013-08-15','13:35:00',3.73),('12664','2013-08-15','13:40:00',3.74),('12664','2013-08-15','13:45:00',3.96),('12664','2013-08-15','13:50:00',4.02),('12664','2013-08-15','13:55:00',3.86),('12664','2013-08-15','14:00:00',3.68),('12664','2013-08-15','14:05:00',3.65),('12664','2013-08-15','14:10:00',3.43),('12664','2013-08-15','14:15:00',3.73),('12664','2013-08-15','14:20:00',3.54),('12664','2013-08-15','14:25:00',3.8),('12664','2013-08-15','14:30:00',3.77),('12664','2013-08-15','14:35:00',3.68),('12664','2013-08-15','14:40:00',3.74),('12664','2013-08-15','14:45:00',3.69),('12664','2013-08-15','14:50:00',3.59),('12664','2013-08-15','14:55:00',3.52),('12664','2013-08-15','15:00:00',3.31),('12664','2013-08-15','15:05:00',3.5),('12664','2013-08-15','15:10:00',3.36),('12664','2013-08-15','15:15:00',3.38),('12664','2013-08-15','15:20:00',3.39),('12664','2013-08-15','15:25:00',3.4),('12664','2013-08-15','15:30:00',3.35),('12664','2013-08-15','15:35:00',3.34),('12664','2013-08-15','15:40:00',3.2),('12664','2013-08-15','15:45:00',3.09),('12664','2013-08-15','15:50:00',3.11),('12664','2013-08-15','15:55:00',3.1),('12664','2013-08-15','16:00:00',2.99),('12664','2013-08-15','16:05:00',2.99),('12664','2013-08-15','16:10:00',2.93),('12664','2013-08-15','16:15:00',2.88),('12664','2013-08-15','16:20:00',2.81),('12664','2013-08-15','16:25:00',2.78),('12664','2013-08-15','16:30:00',2.72),('12664','2013-08-15','16:35:00',2.65),('12664','2013-08-15','16:40:00',2.6),('12664','2013-08-15','16:45:00',2.51),('12664','2013-08-15','16:50:00',2.41),('12664','2013-08-15','16:55:00',2.35),('12664','2013-08-15','17:00:00',2.25),('12664','2013-08-15','17:05:00',2.17),('12664','2013-08-15','17:10:00',2.1),('12664','2013-08-15','17:15:00',2.03),('12664','2013-08-15','17:20:00',1.94),('12664','2013-08-15','17:25:00',1.85),('12664','2013-08-15','17:30:00',1.76),('12664','2013-08-15','17:35:00',1.66),('12664','2013-08-15','17:40:00',1.6),('12664','2013-08-15','17:45:00',1.51),('12664','2013-08-15','17:50:00',1.44),('12664','2013-08-15','17:55:00',1.34),('12664','2013-08-15','18:00:00',1.25),('12664','2013-08-15','18:05:00',1.13),('12664','2013-08-15','18:10:00',1.04),('12664','2013-08-14','08:05:00',1.04),('12664','2013-08-14','08:10:00',1.12),('12664','2013-08-14','08:15:00',1.17),('12664','2013-08-14','08:20:00',1.3),('12664','2013-08-14','08:25:00',1.22),('12664','2013-08-14','08:30:00',1.22),('12664','2013-08-14','08:35:00',1.61),('12664','2013-08-14','08:40:00',1.64),('12664','2013-08-14','08:45:00',1.74),('12664','2013-08-14','08:50:00',1.83),('12664','2013-08-14','08:55:00',1.84),('12664','2013-08-14','09:00:00',2.02),('12664','2013-08-14','09:05:00',1.6),('12664','2013-08-14','09:10:00',1.18),('12664','2013-08-14','09:15:00',1.03),('12664','2013-08-14','09:30:00',1.36),('12664','2013-08-14','09:35:00',2.62),('12664','2013-08-14','09:40:00',3.01),('12664','2013-08-14','09:45:00',2.06),('12664','2013-08-14','09:50:00',1.9),('12664','2013-08-14','09:55:00',1.88),('12664','2013-08-14','10:00:00',1.53),('12664','2013-08-14','10:10:00',1.11),('12664','2013-08-14','10:15:00',3.14),('12664','2013-08-14','10:20:00',3.61),('12664','2013-08-14','10:25:00',3.59),('12664','2013-08-14','10:30:00',2.3),('12664','2013-08-14','10:35:00',1.12),('12664','2013-08-14','10:40:00',1.11),('12664','2013-08-14','10:45:00',1.09),('12664','2013-08-14','10:50:00',2.09),('12664','2013-08-14','10:55:00',3.75),('12664','2013-08-14','11:00:00',3.77),('12664','2013-08-14','11:05:00',3.87),('12664','2013-08-14','11:10:00',2.77),('12664','2013-08-14','11:15:00',1.29),('12664','2013-08-14','11:20:00',1.04),('12664','2013-08-14','11:25:00',1.11),('12664','2013-08-14','11:30:00',1.39),('12664','2013-08-14','11:35:00',3.37),('12664','2013-08-14','11:40:00',3.68),('12664','2013-08-14','11:45:00',2.44),('12664','2013-08-14','11:50:00',3.3),('12664','2013-08-14','11:55:00',2.57),('12664','2013-08-14','12:00:00',3.7),('12664','2013-08-14','12:05:00',3.91),('12664','2013-08-14','12:10:00',2.99),('12664','2013-08-14','12:15:00',4.44),('12664','2013-08-14','12:20:00',4.36),('12664','2013-08-14','12:25:00',4.09),('12664','2013-08-14','12:30:00',4.35),('12664','2013-08-14','12:35:00',3.88),('12664','2013-08-14','12:40:00',3.68),('12664','2013-08-14','12:45:00',3.32),('12664','2013-08-14','12:50:00',3.25),('12664','2013-08-14','12:55:00',3.23),('12664','2013-08-14','13:00:00',3.46),('12664','2013-08-14','13:05:00',3.76),('12664','2013-08-14','13:10:00',3.71),('12664','2013-08-14','13:15:00',3.94),('12664','2013-08-14','13:20:00',3.61),('12664','2013-08-14','13:25:00',4.18),('12664','2013-08-14','13:30:00',4.23),('12664','2013-08-14','13:35:00',4.03),('12664','2013-08-14','13:40:00',4.17),('12664','2013-08-14','13:45:00',4.12),('12664','2013-08-14','13:50:00',4.14),('12664','2013-08-14','13:55:00',4.11),('12664','2013-08-14','14:00:00',4.07),('12664','2013-08-14','14:05:00',4.1),('12664','2013-08-14','14:10:00',3.97),('12664','2013-08-14','14:15:00',3.96),('12664','2013-08-14','14:20:00',3.98),('12664','2013-08-14','14:25:00',3.87),('12664','2013-08-14','14:30:00',3.87),('12664','2013-08-14','14:35:00',3.87),('12664','2013-08-14','14:40:00',3.84),('12664','2013-08-14','14:45:00',3.78),('12664','2013-08-14','14:50:00',3.77),('12664','2013-08-14','14:55:00',3.75),('12664','2013-08-14','15:00:00',3.72),('12664','2013-08-14','15:05:00',3.68),('12664','2013-08-14','15:10:00',3.64),('12664','2013-08-14','15:15:00',3.62),('12664','2013-08-14','15:20:00',3.58),('12664','2013-08-14','15:25:00',3.52),('12664','2013-08-14','15:30:00',3.52),('12664','2013-08-14','15:35:00',3.46),('12664','2013-08-14','15:40:00',3.4),('12664','2013-08-14','15:45:00',3.33),('12664','2013-08-14','15:50:00',3.27),('12664','2013-08-14','15:55:00',3.2),('12664','2013-08-14','16:00:00',3.17),('12664','2013-08-14','16:05:00',3.1),('12664','2013-08-14','16:10:00',3.03),('12664','2013-08-14','16:15:00',2.99),('12664','2013-08-14','16:20:00',2.95),('12664','2013-08-14','16:25:00',2.87),('12664','2013-08-14','16:30:00',2.78),('12664','2013-08-14','16:35:00',2.72),('12664','2013-08-14','16:40:00',2.66),('12664','2013-08-14','16:45:00',2.6),('12664','2013-08-14','16:50:00',2.51),('12664','2013-08-14','16:55:00',2.43),('12664','2013-08-14','17:00:00',2.34),('12664','2013-08-14','17:05:00',2.27),('12664','2013-08-14','17:10:00',2.19),('12664','2013-08-14','17:15:00',2.09),('12664','2013-08-14','17:20:00',2.01),('12664','2013-08-14','17:25:00',1.91),('12664','2013-08-14','17:30:00',1.83),('12664','2013-08-14','17:35:00',1.76),('12664','2013-08-14','17:40:00',1.67),('12664','2013-08-14','17:45:00',1.57),('12664','2013-08-14','17:50:00',1.48),('12664','2013-08-14','17:55:00',1.4),('12664','2013-08-14','18:00:00',1.32),('12664','2013-08-14','18:05:00',1.22),('12664','2013-08-14','18:10:00',1.11),('12664','2013-08-14','18:15:00',1.03),('12664','2013-08-13','08:05:00',1.05),('12664','2013-08-13','08:10:00',1.16),('12664','2013-08-13','08:15:00',1.26),('12664','2013-08-13','08:20:00',1.36),('12664','2013-08-13','08:25:00',1.44),('12664','2013-08-13','08:30:00',1.53),('12664','2013-08-13','08:35:00',1.63),('12664','2013-08-13','08:40:00',1.71),('12664','2013-08-13','08:45:00',1.8),('12664','2013-08-13','08:50:00',1.89),('12664','2013-08-13','08:55:00',1.98),('12664','2013-08-13','09:00:00',2.06),('12664','2013-08-13','09:05:00',2.14),('12664','2013-08-13','09:10:00',2.21),('12664','2013-08-13','09:15:00',2.26),('12664','2013-08-13','09:20:00',2.39),('12664','2013-08-13','09:25:00',2.45),('12664','2013-08-13','09:30:00',2.53),('12664','2013-08-13','09:35:00',2.53),('12664','2013-08-13','09:40:00',2.62),('12664','2013-08-13','09:45:00',2.77),('12664','2013-08-13','09:50:00',2.57),('12664','2013-08-13','09:55:00',2.24),('12664','2013-08-13','10:00:00',3.16),('12664','2013-08-13','10:05:00',3.3),('12664','2013-08-13','10:10:00',3.32),('12664','2013-08-13','10:15:00',3.39),('12664','2013-08-13','10:20:00',3.49),('12664','2013-08-13','10:25:00',1.65),('12664','2013-08-13','10:30:00',1.59),('12664','2013-08-13','10:35:00',3.56),('12664','2013-08-13','10:40:00',3.6),('12664','2013-08-13','10:45:00',3.59),('12664','2013-08-13','10:50:00',2.59),('12664','2013-08-13','10:55:00',1.87),('12664','2013-08-13','11:00:00',3.56),('12664','2013-08-13','11:05:00',3.69),('12664','2013-08-13','11:10:00',3.71),('12664','2013-08-13','11:15:00',3.69),('12664','2013-08-13','11:20:00',3.71),('12664','2013-08-13','11:25:00',3.76),('12664','2013-08-13','11:30:00',3.72),('12664','2013-08-13','11:35:00',3.69),('12664','2013-08-13','11:40:00',3.69),('12664','2013-08-13','11:45:00',3.81),('12664','2013-08-13','11:50:00',3.91),('12664','2013-08-13','11:55:00',4.09),('12664','2013-08-13','12:00:00',4.18),('12664','2013-08-13','12:05:00',3.56),('12664','2013-08-13','12:10:00',4.23),('12664','2013-08-13','12:15:00',4.18),('12664','2013-08-13','12:20:00',4.1),('12664','2013-08-13','12:25:00',3.83),('12664','2013-08-13','12:30:00',4.26),('12664','2013-08-13','12:35:00',2.16),('12664','2013-08-13','12:40:00',1.04),('12664','2013-08-13','12:45:00',2.42),('12664','2013-08-13','12:50:00',3.95),('12664','2013-08-13','12:55:00',4.29),('12664','2013-08-13','13:00:00',4.13),('12664','2013-08-13','13:05:00',4.18),('12664','2013-08-13','13:10:00',4.12),('12664','2013-08-13','13:15:00',4.14),('12664','2013-08-13','13:20:00',4.06),('12664','2013-08-13','13:25:00',4.05),('12664','2013-08-13','13:30:00',4.05),('12664','2013-08-13','13:35:00',3.93),('12664','2013-08-13','13:40:00',3.83),('12664','2013-08-13','13:45:00',3.79),('12664','2013-08-13','13:50:00',3.96),('12664','2013-08-13','13:55:00',3.94),('12664','2013-08-13','14:00:00',3.88),('12664','2013-08-13','14:05:00',3.92),('12664','2013-08-13','14:10:00',3.99),('12664','2013-08-13','14:15:00',3.91),('12664','2013-08-13','14:20:00',3.88),('12664','2013-08-13','14:25:00',3.9),('12664','2013-08-13','14:30:00',3.9),('12664','2013-08-13','14:35:00',3.86),('12664','2013-08-13','14:40:00',3.82),('12664','2013-08-13','14:45:00',3.84),('12664','2013-08-13','14:50:00',3.79),('12664','2013-08-13','14:55:00',3.77),('12664','2013-08-13','15:00:00',3.74),('12664','2013-08-13','15:05:00',3.69),('12664','2013-08-13','15:10:00',3.65),('12664','2013-08-13','15:15:00',3.62),('12664','2013-08-13','15:20:00',3.58),('12664','2013-08-13','15:25:00',3.56),('12664','2013-08-13','15:30:00',3.49),('12664','2013-08-13','15:35:00',3.42),('12664','2013-08-13','15:40:00',3.4),('12664','2013-08-13','15:45:00',3.33),('12664','2013-08-13','15:50:00',3.31),('12664','2013-08-13','15:55:00',3.24),('12664','2013-08-13','16:00:00',3.18),('12664','2013-08-13','16:05:00',3.15),('12664','2013-08-13','16:10:00',3.06),('12664','2013-08-13','16:15:00',2.96),('12664','2013-08-13','16:20:00',2.89),('12664','2013-08-13','16:25:00',2.86),('12664','2013-08-13','16:30:00',2.8),('12664','2013-08-13','16:35:00',2.72),('12664','2013-08-13','16:40:00',2.63),('12664','2013-08-13','16:45:00',2.58),('12664','2013-08-13','16:50:00',2.52),('12664','2013-08-13','16:55:00',2.45),('12664','2013-08-13','17:00:00',2.37),('12664','2013-08-13','17:05:00',2.29),('12664','2013-08-13','17:10:00',2.22),('12664','2013-08-13','17:15:00',2.13),('12664','2013-08-13','17:20:00',2.03),('12664','2013-08-13','17:25:00',1.93),('12664','2013-08-13','17:30:00',1.85),('12664','2013-08-13','17:35:00',1.76),('12664','2013-08-13','17:40:00',1.67),('12664','2013-08-13','17:45:00',1.58),('12664','2013-08-13','17:50:00',1.49),('12664','2013-08-13','17:55:00',1.4),('12664','2013-08-13','18:00:00',1.31),('12664','2013-08-13','18:05:00',1.22),('12664','2013-08-13','18:10:00',1.13),('12664','2013-08-13','18:15:00',1.05),('12664','2013-08-12','08:05:00',1.08),('12664','2013-08-12','08:10:00',1.16),('12664','2013-08-12','08:15:00',1.25),('12664','2013-08-12','08:20:00',1.34),('12664','2013-08-12','08:25:00',1.42),('12664','2013-08-12','08:30:00',1.51),('12664','2013-08-12','08:35:00',1.6),('12664','2013-08-12','08:40:00',1.68),('12664','2013-08-12','08:45:00',1.77),('12664','2013-08-12','08:50:00',1.85),('12664','2013-08-12','08:55:00',1.93),('12664','2013-08-12','09:00:00',2.02),('12664','2013-08-12','09:05:00',2.1),('12664','2013-08-12','09:10:00',2.19),('12664','2013-08-12','09:15:00',2.25),('12664','2013-08-12','09:20:00',2.33),('12664','2013-08-12','09:25:00',2.41),('12664','2013-08-12','09:30:00',2.48),('12664','2013-08-12','09:35:00',2.56),('12664','2013-08-12','09:40:00',2.63),('12664','2013-08-12','09:45:00',2.69),('12664','2013-08-12','09:50:00',2.74),('12664','2013-08-12','09:55:00',2.8),('12664','2013-08-12','10:00:00',2.86),('12664','2013-08-12','10:05:00',2.91),('12664','2013-08-12','10:10:00',2.97),('12664','2013-08-12','10:15:00',3.02),('12664','2013-08-12','10:20:00',3.09),('12664','2013-08-12','10:25:00',3.13),('12664','2013-08-12','10:30:00',3.21),('12664','2013-08-12','10:35:00',3.26),('12664','2013-08-12','10:40:00',3.3),('12664','2013-08-12','10:45:00',3.32),('12664','2013-08-12','10:50:00',3.39),('12664','2013-08-12','10:55:00',3.39),('12664','2013-08-12','11:00:00',3.46),('12664','2013-08-12','11:05:00',3.48),('12664','2013-08-12','11:10:00',3.54),('12664','2013-08-12','11:15:00',3.56),('12664','2013-08-12','11:20:00',3.23),('12664','2013-08-12','11:25:00',3.38),('12664','2013-08-12','11:30:00',3.88),('12664','2013-08-12','11:35:00',3.89),('12664','2013-08-12','11:40:00',3.59),('12664','2013-08-12','11:45:00',3.41),('12664','2013-08-12','11:50:00',3.45),('12664','2013-08-12','11:55:00',4.08),('12664','2013-08-12','12:00:00',3.22),('12664','2013-08-12','12:05:00',4.18),('12664','2013-08-12','12:10:00',4.23),('12664','2013-08-12','12:15:00',4.05),('12664','2013-08-12','12:20:00',1.53),('12664','2013-08-12','12:25:00',2.79),('12664','2013-08-12','12:30:00',4.29),('12664','2013-08-12','12:35:00',1.78),('12664','2013-08-12','12:40:00',4.31),('12664','2013-08-12','12:45:00',4.4),('12664','2013-08-12','12:50:00',2.02),('12664','2013-08-12','12:55:00',1.3),('12664','2013-08-12','13:00:00',1.65),('12664','2013-08-12','13:05:00',2.31),('12664','2013-08-12','13:10:00',4.73),('12664','2013-08-12','13:15:00',2),('12664','2013-08-12','13:20:00',2.79),('12664','2013-08-12','13:25:00',4.25),('12664','2013-08-12','13:30:00',4.35),('12664','2013-08-12','13:35:00',2.96),('12664','2013-08-12','13:40:00',3.73),('12664','2013-08-12','13:45:00',3.81),('12664','2013-08-12','13:50:00',4.55),('12664','2013-08-12','13:55:00',4.35),('12664','2013-08-12','14:00:00',2.61),('12664','2013-08-12','14:05:00',2.28),('12664','2013-08-12','14:10:00',2.78),('12664','2013-08-12','14:15:00',4),('12664','2013-08-12','14:20:00',3.84),('12664','2013-08-12','14:25:00',3.58),('12664','2013-08-12','14:30:00',3.41),('12664','2013-08-12','14:35:00',4.04),('12664','2013-08-12','14:40:00',3.73),('12664','2013-08-12','14:45:00',3.8),('12664','2013-08-12','14:50:00',3.79),('12664','2013-08-12','14:55:00',3.78),('12664','2013-08-12','15:00:00',3.75),('12664','2013-08-12','15:05:00',3.73),('12664','2013-08-12','15:10:00',3.69),('12664','2013-08-12','15:15:00',3.6),('12664','2013-08-12','15:20:00',3.35),('12664','2013-08-12','15:25:00',3.47),('12664','2013-08-12','15:30:00',3.05),('12664','2013-08-12','15:35:00',3.42),('12664','2013-08-12','15:40:00',3.35),('12664','2013-08-12','15:45:00',3.35),('12664','2013-08-12','15:50:00',3.27),('12664','2013-08-12','15:55:00',3.2),('12664','2013-08-12','16:00:00',3.18),('12664','2013-08-12','16:05:00',3.12),('12664','2013-08-12','16:10:00',3.03),('12664','2013-08-12','16:15:00',3),('12664','2013-08-12','16:20:00',2.9),('12664','2013-08-12','16:25:00',2.86),('12664','2013-08-12','16:30:00',2.77),('12664','2013-08-12','16:35:00',2.74),('12664','2013-08-12','16:40:00',2.68),('12664','2013-08-12','16:45:00',2.6),('12664','2013-08-12','16:50:00',2.51),('12664','2013-08-12','16:55:00',2.44),('12664','2013-08-12','17:00:00',2.32),('12664','2013-08-12','17:05:00',2.27),('12664','2013-08-12','17:10:00',2.16),('12664','2013-08-12','17:15:00',2.11),('12664','2013-08-12','17:20:00',2.01),('12664','2013-08-12','17:25:00',1.94),('12664','2013-08-12','17:30:00',1.87),('12664','2013-08-12','17:35:00',1.78),('12664','2013-08-12','17:40:00',1.69),('12664','2013-08-12','17:45:00',1.6),('12664','2013-08-12','17:50:00',1.51),('12664','2013-08-12','17:55:00',1.43),('12664','2013-08-12','18:00:00',1.33),('12664','2013-08-12','18:05:00',1.25),('12664','2013-08-12','18:10:00',1.17),('12664','2013-08-12','18:15:00',1.08),('12664','2013-08-11','08:00:00',1.02),('12664','2013-08-11','08:05:00',1.11),('12664','2013-08-11','08:10:00',1.2),('12664','2013-08-11','08:15:00',1.29),('12664','2013-08-11','08:20:00',1.38),('12664','2013-08-11','08:25:00',1.47),('12664','2013-08-11','08:30:00',1.55),('12664','2013-08-11','08:35:00',1.64),('12664','2013-08-11','08:40:00',1.73),('12664','2013-08-11','08:45:00',1.82),('12664','2013-08-11','08:50:00',1.91),('12664','2013-08-11','08:55:00',2),('12664','2013-08-11','09:00:00',2.07),('12664','2013-08-11','09:05:00',2.17),('12664','2013-08-11','09:10:00',2.25),('12664','2013-08-11','09:15:00',2.32),('12664','2013-08-11','09:20:00',2.4),('12664','2013-08-11','09:25:00',2.48),('12664','2013-08-11','09:30:00',2.55),('12664','2013-08-11','09:35:00',2.63),('12664','2013-08-11','09:40:00',2.68),('12664','2013-08-11','09:45:00',2.76),('12664','2013-08-11','09:50:00',2.83),('12664','2013-08-11','09:55:00',2.9),('12664','2013-08-11','10:00:00',2.96),('12664','2013-08-11','10:05:00',3.02),('12664','2013-08-11','10:10:00',3.08),('12664','2013-08-11','10:15:00',3.13),('12664','2013-08-11','10:20:00',3.19),('12664','2013-08-11','10:25:00',3.25),('12664','2013-08-11','10:30:00',3.31),('12664','2013-08-11','10:35:00',3.37),('12664','2013-08-11','10:40:00',3.4),('12664','2013-08-11','10:45:00',3.47),('12664','2013-08-11','10:50:00',3.49),('12664','2013-08-11','10:55:00',3.53),('12664','2013-08-11','11:00:00',3.55),('12664','2013-08-11','11:05:00',3.62),('12664','2013-08-11','11:10:00',3.66),('12664','2013-08-11','11:15:00',3.68),('12664','2013-08-11','11:20:00',3.72),('12664','2013-08-11','11:25:00',3.76),('12664','2013-08-11','11:30:00',3.8),('12664','2013-08-11','11:35:00',3.82),('12664','2013-08-11','11:40:00',3.83),('12664','2013-08-11','11:45:00',3.83),('12664','2013-08-11','11:50:00',3.84),('12664','2013-08-11','11:55:00',3.88),('12664','2013-08-11','12:00:00',3.9),('12664','2013-08-11','12:05:00',3.91),('12664','2013-08-11','12:10:00',3.95),('12664','2013-08-11','12:15:00',3.97),('12664','2013-08-11','12:20:00',3.98),('12664','2013-08-11','12:25:00',3.99),('12664','2013-08-11','12:30:00',4),('12664','2013-08-11','12:35:00',4),('12664','2013-08-11','12:40:00',4),('12664','2013-08-11','12:45:00',4.03),('12664','2013-08-11','12:50:00',4.02),('12664','2013-08-11','12:55:00',4.03),('12664','2013-08-11','13:00:00',4.04),('12664','2013-08-11','13:05:00',4.05),('12664','2013-08-11','13:10:00',4),('12664','2013-08-11','13:15:00',4.01),('12664','2013-08-11','13:20:00',3.96),('12664','2013-08-11','13:25:00',3.99),('12664','2013-08-11','13:30:00',3.99),('12664','2013-08-11','13:35:00',3.96),('12664','2013-08-11','13:40:00',3.96),('12664','2013-08-11','13:45:00',3.94),('12664','2013-08-11','13:50:00',3.91),('12664','2013-08-11','13:55:00',3.89),('12664','2013-08-11','14:00:00',3.91),('12664','2013-08-11','14:05:00',3.92),('12664','2013-08-11','14:10:00',3.87),('12664','2013-08-11','14:15:00',3.83),('12664','2013-08-11','14:20:00',3.85),('12664','2013-08-11','14:25:00',3.85),('12664','2013-08-11','14:30:00',3.83),('12664','2013-08-11','14:35:00',3.79),('12664','2013-08-11','14:40:00',3.76),('12664','2013-08-11','14:45:00',3.73),('12664','2013-08-11','14:50:00',3.71),('12664','2013-08-11','14:55:00',3.67),('12664','2013-08-11','15:00:00',3.63),('12664','2013-08-11','15:05:00',3.55),('12664','2013-08-11','15:10:00',3.52),('12664','2013-08-11','15:15:00',3.5),('12664','2013-08-11','15:20:00',3.51),('12664','2013-08-11','15:25:00',3.49),('12664','2013-08-11','15:30:00',3.45),('12664','2013-08-11','15:35:00',3.4),('12664','2013-08-11','15:40:00',3.38),('12664','2013-08-11','15:45:00',3.34),('12664','2013-08-11','15:50:00',3.29),('12664','2013-08-11','15:55:00',3.24),('12664','2013-08-11','16:00:00',3.19),('12664','2013-08-11','16:05:00',3.12),('12664','2013-08-11','16:10:00',3.05),('12664','2013-08-11','16:15:00',3.01),('12664','2013-08-11','16:20:00',2.94),('12664','2013-08-11','16:25:00',2.85),('12664','2013-08-11','16:30:00',2.77),('12664','2013-08-11','16:35:00',2.69),('12664','2013-08-11','16:40:00',2.63),('12664','2013-08-11','16:45:00',2.56),('12664','2013-08-11','16:50:00',2.5),('12664','2013-08-11','16:55:00',2.43),('12664','2013-08-11','17:00:00',2.34),('12664','2013-08-11','17:05:00',2.26),('12664','2013-08-11','17:10:00',2.18),('12664','2013-08-11','17:15:00',2.11),('12664','2013-08-11','17:20:00',2.02),('12664','2013-08-11','17:25:00',1.94),('12664','2013-08-11','17:30:00',1.84),('12664','2013-08-11','17:35:00',1.77),('12664','2013-08-11','17:40:00',1.68),('12664','2013-08-11','17:45:00',1.59),('12664','2013-08-11','17:50:00',1.5),('12664','2013-08-11','17:55:00',1.41),('12664','2013-08-11','18:00:00',1.33),('12664','2013-08-11','18:05:00',1.23),('12664','2013-08-11','18:10:00',1.15),('12664','2013-08-11','18:15:00',1.06),('12664','2013-08-10','08:00:00',1.04),('12664','2013-08-10','08:05:00',1.14),('12664','2013-08-10','08:10:00',1.23),('12664','2013-08-10','08:15:00',1.32),('12664','2013-08-10','08:20:00',1.41),('12664','2013-08-10','08:25:00',1.51),('12664','2013-08-10','08:30:00',1.6),('12664','2013-08-10','08:35:00',1.69),('12664','2013-08-10','08:40:00',1.78),('12664','2013-08-10','08:45:00',1.85),('12664','2013-08-10','08:50:00',1.94),('12664','2013-08-10','08:55:00',2.02),('12664','2013-08-10','09:00:00',2.1),('12664','2013-08-10','09:05:00',2.17),('12664','2013-08-10','09:10:00',2.26),('12664','2013-08-10','09:15:00',2.34),('12664','2013-08-10','09:20:00',2.42),('12664','2013-08-10','09:25:00',2.5),('12664','2013-08-10','09:30:00',2.58),('12664','2013-08-10','09:35:00',2.66),('12664','2013-08-10','09:40:00',2.73),('12664','2013-08-10','09:45:00',2.8),('12664','2013-08-10','09:50:00',2.86),('12664','2013-08-10','09:55:00',2.91),('12664','2013-08-10','10:00:00',2.98),('12664','2013-08-10','10:05:00',3.04),('12664','2013-08-10','10:10:00',3.09),('12664','2013-08-10','10:15:00',3.13),('12664','2013-08-10','10:20:00',3.19),('12664','2013-08-10','10:25:00',3.25),('12664','2013-08-10','10:30:00',3.31),('12664','2013-08-10','10:35:00',3.37),('12664','2013-08-10','10:40:00',3.42),('12664','2013-08-10','10:45:00',3.48),('12664','2013-08-10','10:50:00',3.53),('12664','2013-08-10','10:55:00',3.56),('12664','2013-08-10','11:00:00',3.66),('12664','2013-08-10','11:05:00',3.7),('12664','2013-08-10','11:10:00',3.65),('12664','2013-08-10','11:15:00',3.76),('12664','2013-08-10','11:20:00',3.77),('12664','2013-08-10','11:25:00',3.77),('12664','2013-08-10','11:30:00',3.79),('12664','2013-08-10','11:35:00',3.83),('12664','2013-08-10','11:40:00',3.84),('12664','2013-08-10','11:45:00',3.85),('12664','2013-08-10','11:50:00',3.88),('12664','2013-08-10','11:55:00',4.02),('12664','2013-08-10','12:00:00',4.14),('12664','2013-08-10','12:05:00',3.96),('12664','2013-08-10','12:10:00',3.95),('12664','2013-08-10','12:15:00',4.01),('12664','2013-08-10','12:20:00',3.94),('12664','2013-08-10','12:25:00',4.05),('12664','2013-08-10','12:30:00',4.07),('12664','2013-08-10','12:35:00',4.14),('12664','2013-08-10','12:40:00',4.2),('12664','2013-08-10','12:45:00',4.34),('12664','2013-08-10','12:50:00',4.28),('12664','2013-08-10','12:55:00',4.18),('12664','2013-08-10','13:00:00',4.08),('12664','2013-08-10','13:05:00',4.01),('12664','2013-08-10','13:10:00',4.11),('12664','2013-08-10','13:15:00',4.18),('12664','2013-08-10','13:20:00',4.2),('12664','2013-08-10','13:25:00',4.18),('12664','2013-08-10','13:30:00',3.98),('12664','2013-08-10','13:35:00',4.26),('12664','2013-08-10','13:40:00',4.32),('12664','2013-08-10','13:45:00',3.63),('12664','2013-08-10','13:50:00',2.08),('12664','2013-08-10','13:55:00',2.42),('12664','2013-08-10','14:00:00',4.47),('12664','2013-08-10','14:05:00',3.04),('12664','2013-08-10','14:10:00',1.74),('12664','2013-08-10','15:35:00',1.14),('12664','2013-08-10','15:40:00',1.39),('12664','2013-08-10','15:45:00',1.66),('12664','2013-08-10','15:50:00',2.71),('12664','2013-08-10','15:55:00',3.57),('12664','2013-08-10','16:00:00',2.65),('12664','2013-08-10','16:05:00',1.25),('12664','2013-08-10','16:10:00',1.04),('12664','2013-08-10','16:15:00',1.09),('12664','2013-08-10','16:20:00',1.21),('12664','2013-08-10','16:25:00',1.19),('12664','2013-08-10','16:30:00',1.02),('12664','2013-08-10','16:45:00',1.04),('12664','2013-08-10','16:50:00',1.35),('12664','2013-08-10','16:55:00',1.43),('12664','2013-08-10','17:00:00',2.28),('12664','2013-08-10','17:05:00',1.58),('12664','2013-08-10','17:25:00',1.98),('12664','2013-08-10','17:30:00',1.24),('12664','2013-08-10','17:35:00',1.24),('12664','2013-08-09','08:30:00',1.12),('12664','2013-08-09','08:35:00',1.21),('12664','2013-08-09','08:40:00',1.52),('12664','2013-08-09','08:45:00',1.63),('12664','2013-08-09','08:50:00',1.76),('12664','2013-08-09','08:55:00',1.9),('12664','2013-08-09','09:00:00',1.59),('12664','2013-08-09','09:05:00',1.22),('12664','2013-08-09','09:10:00',1.41),('12664','2013-08-09','09:15:00',1.47),('12664','2013-08-09','09:20:00',1.41),('12664','2013-08-09','09:25:00',1.16),('12664','2013-08-09','09:30:00',2.62),('12664','2013-08-09','09:35:00',2.77),('12664','2013-08-09','09:40:00',2.7),('12664','2013-08-09','09:45:00',2.59),('12664','2013-08-09','09:50:00',2.78),('12664','2013-08-09','09:55:00',2.76),('12664','2013-08-09','10:00:00',2.74),('12664','2013-08-09','10:05:00',2.71),('12664','2013-08-09','10:10:00',2.73),('12664','2013-08-09','10:15:00',2.77),('12664','2013-08-09','10:20:00',2.84),('12664','2013-08-09','10:25:00',2.89),('12664','2013-08-09','10:30:00',2.96),('12664','2013-08-09','10:35:00',3.01),('12664','2013-08-09','10:40:00',3.04),('12664','2013-08-09','10:45:00',3.13),('12664','2013-08-09','10:50:00',3.19),('12664','2013-08-09','10:55:00',3.23),('12664','2013-08-09','11:00:00',3.21),('12664','2013-08-09','11:05:00',3.26),('12664','2013-08-09','11:10:00',3.3),('12664','2013-08-09','11:15:00',3.32),('12664','2013-08-09','11:20:00',3.38),('12664','2013-08-09','11:25:00',3.4),('12664','2013-08-09','11:30:00',3.43),('12664','2013-08-09','11:35:00',3.52),('12664','2013-08-09','11:40:00',3.54),('12664','2013-08-09','11:45:00',3.52),('12664','2013-08-09','11:50:00',3.6),('12664','2013-08-09','11:55:00',3.65),('12664','2013-08-09','12:00:00',3.68),('12664','2013-08-09','12:05:00',3.73),('12664','2013-08-09','12:10:00',3.84),('12664','2013-08-09','12:15:00',3.96),('12664','2013-08-09','12:20:00',4.09),('12664','2013-08-09','12:25:00',3.22),('12664','2013-08-09','12:30:00',3.66),('12664','2013-08-09','12:35:00',3.9),('12664','2013-08-09','12:40:00',3.37),('12664','2013-08-09','12:45:00',2.49),('12664','2013-08-09','12:50:00',1.05),('12664','2013-08-09','12:55:00',1.01),('12664','2013-08-09','13:15:00',1.13),('12664','2013-08-09','13:20:00',1.33),('12664','2013-08-09','13:25:00',1.54),('12664','2013-08-09','13:30:00',1.59),('12664','2013-08-09','13:35:00',1.52),('12664','2013-08-09','13:40:00',1.4),('12664','2013-08-09','13:45:00',1.05),('12664','2013-08-09','13:55:00',1.08),('12664','2013-08-09','14:00:00',1.03),('12664','2013-08-09','15:10:00',1.11),('12664','2013-08-09','15:15:00',2.11),('12664','2013-08-09','15:30:00',1.11),('12664','2013-08-09','15:35:00',1.16),('12664','2013-08-09','15:40:00',1.7),('12664','2013-08-09','15:45:00',2.89),('12664','2013-08-09','15:50:00',2.44),('12664','2013-08-09','15:55:00',1.27),('12664','2013-08-09','16:50:00',1.94),('12664','2014-04-08','08:25:00',1.02),('12664','2014-04-08','08:30:00',1.25),('12664','2014-04-08','08:35:00',1.24),('12664','2014-04-08','08:40:00',1.27),('12664','2014-04-08','08:45:00',1.52),('12664','2014-04-08','08:50:00',1.63),('12664','2014-04-08','08:55:00',1.73),('12664','2014-04-08','09:00:00',1.83),('12664','2014-04-08','09:05:00',1.91),('12664','2014-04-08','09:10:00',1.98),('12664','2014-04-08','09:15:00',2.06),('12664','2014-04-08','09:20:00',2.15),('12664','2014-04-08','09:25:00',2.17),('12664','2014-04-08','09:30:00',2.21),('12664','2014-04-08','09:35:00',2.3),('12664','2014-04-08','09:40:00',2.38),('12664','2014-04-08','09:45:00',2.42),('12664','2014-04-08','09:50:00',2.44),('12664','2014-04-08','09:55:00',2.64),('12664','2014-04-08','10:00:00',2.73),('12664','2014-04-08','10:05:00',2.8),('12664','2014-04-08','10:10:00',2.86),('12664','2014-04-08','10:15:00',2.92),('12664','2014-04-08','10:20:00',2.97),('12664','2014-04-08','10:25:00',3.02),('12664','2014-04-08','10:30:00',3.1),('12664','2014-04-08','10:35:00',3.14),('12664','2014-04-08','10:40:00',3.2),('12664','2014-04-08','10:45:00',3.28),('12664','2014-04-08','10:50:00',3.33),('12664','2014-04-08','10:55:00',3.39),('12664','2014-04-08','11:00:00',3.4),('12664','2014-04-08','11:05:00',3.44),('12664','2014-04-08','11:10:00',3.47),('12664','2014-04-08','11:15:00',3.51),('12664','2014-04-08','11:20:00',3.59),('12664','2014-04-08','11:25:00',3.59),('12664','2014-04-08','11:30:00',3.55),('12664','2014-04-08','11:35:00',3.66),('12664','2014-04-08','11:40:00',3.65),('12664','2014-04-08','11:45:00',3.59),('12664','2014-04-08','11:50:00',3.66),('12664','2014-04-08','11:55:00',3.67),('12664','2014-04-08','12:00:00',3.66),('12664','2014-04-08','12:05:00',3.64),('12664','2014-04-08','12:10:00',3.39),('12664','2014-04-08','12:15:00',3.31),('12664','2014-04-08','12:20:00',3.84),('12664','2014-04-08','12:25:00',3.41),('12664','2014-04-08','12:30:00',3.46),('12664','2014-04-08','12:35:00',4.11),('12664','2014-04-08','12:40:00',3.33),('12664','2014-04-08','12:45:00',3.89),('12664','2014-04-08','12:50:00',3.72),('12664','2014-04-08','12:55:00',3.84),('12664','2014-04-08','13:00:00',3.82),('12664','2014-04-08','13:05:00',3.88),('12664','2014-04-08','13:10:00',3.99),('12664','2014-04-08','13:15:00',4),('12664','2014-04-08','13:20:00',4.02),('12664','2014-04-08','13:25:00',3.99),('12664','2014-04-08','13:30:00',4.03),('12664','2014-04-08','13:35:00',3.98),('12664','2014-04-08','13:40:00',4.03),('12664','2014-04-08','13:45:00',3.98),('12664','2014-04-08','13:50:00',3.76),('12664','2014-04-08','13:55:00',3.65),('12664','2014-04-08','14:00:00',3.64),('12664','2014-04-08','14:05:00',3.83),('12664','2014-04-08','14:10:00',3.93),('12664','2014-04-08','14:15:00',3.88),('12664','2014-04-08','14:20:00',3.53),('12664','2014-04-08','14:25:00',3.26),('12664','2014-04-08','14:30:00',3.81),('12664','2014-04-08','14:35:00',2.97),('12664','2014-04-08','14:40:00',3.56),('12664','2014-04-08','14:45:00',3.84),('12664','2014-04-08','14:50:00',3.75),('12664','2014-04-08','14:55:00',3.65),('12664','2014-04-08','15:00:00',3.6),('12664','2014-04-08','15:05:00',3.54),('12664','2014-04-08','15:10:00',3.4),('12664','2014-04-08','15:15:00',3.4),('12664','2014-04-08','15:20:00',3.4),('12664','2014-04-08','15:25:00',3.28),('12664','2014-04-08','15:30:00',3.25),('12664','2014-04-08','15:35:00',3.06),('12664','2014-04-08','15:40:00',3.13),('12664','2014-04-08','15:45:00',3.12),('12664','2014-04-08','15:50:00',3.04),('12664','2014-04-08','15:55:00',2.95),('12664','2014-04-08','16:00:00',2.99),('12664','2014-04-08','16:05:00',2.86),('12664','2014-04-08','16:10:00',2.67),('12664','2014-04-08','16:15:00',2.7),('12664','2014-04-08','16:20:00',2.49),('12664','2014-04-08','16:25:00',2.57),('12664','2014-04-08','16:30:00',2.5),('12664','2014-04-08','16:35:00',2.39),('12664','2014-04-08','16:40:00',2.3),('12664','2014-04-08','16:45:00',2.32),('12664','2014-04-08','16:50:00',2.06),('12664','2014-04-08','16:55:00',1.97),('12664','2014-04-08','17:00:00',2.02),('12664','2014-04-08','17:05:00',1.93),('12664','2014-04-08','17:10:00',1.82),('12664','2014-04-08','17:15:00',1.73),('12664','2014-04-08','17:20:00',1.58),('12664','2014-04-08','17:25:00',1.45),('12664','2014-04-08','17:30:00',1.37),('12664','2014-04-08','17:35:00',1.34),('12664','2014-04-08','17:40:00',1.27),('12664','2014-04-08','17:45:00',1.18),('12664','2014-04-08','17:50:00',1),('12664','2013-08-08','08:10:00',1.07),('12664','2013-08-08','08:15:00',1.16),('12664','2013-08-08','08:20:00',1.24),('12664','2013-08-08','08:25:00',1.32),('12664','2013-08-08','08:30:00',1.4),('12664','2013-08-08','08:35:00',1.48),('12664','2013-08-08','08:40:00',1.44),('12664','2013-08-08','08:45:00',1.65),('12664','2013-08-08','08:50:00',1.73),('12664','2013-08-08','08:55:00',1.81),('12664','2013-08-08','09:00:00',1.89),('12664','2013-08-08','09:05:00',1.96),('12664','2013-08-08','09:10:00',2.03),('12664','2013-08-08','09:15:00',2.11),('12664','2013-08-08','09:20:00',2.18),('12664','2013-08-08','09:25:00',2.25),('12664','2013-08-08','09:30:00',2.33),('12664','2013-08-08','09:35:00',2.39),('12664','2013-08-08','09:40:00',2.45),('12664','2013-08-08','09:45:00',2.53),('12664','2013-08-08','09:50:00',2.6),('12664','2013-08-08','09:55:00',2.65),('12664','2013-08-08','10:00:00',2.72),('12664','2013-08-08','10:05:00',2.77),('12664','2013-08-08','10:10:00',2.82),('12664','2013-08-08','10:15:00',2.9),('12664','2013-08-08','10:20:00',2.95),('12664','2013-08-08','10:25:00',2.98),('12664','2013-08-08','10:30:00',3.04),('12664','2013-08-08','10:35:00',3.08),('12664','2013-08-08','10:40:00',3.11),('12664','2013-08-08','10:45:00',3.13),('12664','2013-08-08','10:50:00',3.22),('12664','2013-08-08','10:55:00',3.23),('12664','2013-08-08','11:00:00',3.26),('12664','2013-08-08','11:05:00',3.32),('12664','2013-08-08','11:10:00',3.38),('12664','2013-08-08','11:15:00',3.45),('12664','2013-08-08','11:20:00',3.46),('12664','2013-08-08','11:25:00',3.21),('12664','2013-08-08','11:30:00',3.34),('12664','2013-08-08','11:35:00',3.54),('12664','2013-08-08','11:40:00',3.56),('12664','2013-08-08','11:45:00',3.57),('12664','2013-08-08','12:20:00',3.76),('12664','2013-08-08','12:25:00',3.82),('12664','2013-08-08','12:30:00',3.85),('12664','2013-08-08','12:35:00',3.89),('12664','2013-08-08','12:40:00',3.91),('12664','2013-08-08','12:45:00',3.91),('12664','2013-08-08','12:50:00',3.91),('12664','2013-08-08','12:55:00',3.92),('12664','2013-08-08','13:00:00',3.93),('12664','2013-08-08','13:05:00',3.93),('12664','2013-08-08','13:10:00',3.91),('12664','2013-08-08','13:15:00',3.92),('12664','2013-08-08','13:20:00',3.93),('12664','2013-08-08','13:25:00',3.91),('12664','2013-08-08','13:30:00',3.91),('12664','2013-08-08','13:35:00',3.9),('12664','2013-08-08','13:40:00',3.9),('12664','2013-08-08','13:45:00',3.87),('12664','2013-08-08','13:50:00',3.87),('12664','2013-08-08','13:55:00',3.86),('12664','2013-08-08','14:00:00',3.83),('12664','2013-08-08','14:05:00',3.79),('12664','2013-08-08','14:10:00',3.78),('12664','2013-08-08','14:15:00',3.76),('12664','2013-08-08','15:20:00',3.31),('12664','2013-08-08','15:30:00',3.25),('12664','2013-08-08','15:35:00',3.21),('12664','2013-08-08','15:40:00',3.18),('12664','2013-08-08','15:45:00',3.13),('12664','2013-08-08','15:50:00',3.07),('12664','2013-08-08','15:55:00',3),('12664','2013-08-08','16:00:00',2.95),('12664','2013-08-08','16:05:00',2.9),('12664','2013-08-08','16:10:00',2.86),('12664','2013-08-08','16:15:00',2.81),('12664','2013-08-08','16:30:00',2.58),('12664','2013-08-08','16:35:00',2.53),('12664','2013-08-08','16:40:00',2.47),('12664','2013-08-08','16:45:00',2.42),('12664','2013-08-08','16:50:00',2.34),('12664','2013-08-08','16:55:00',2.27),('12664','2013-08-08','17:00:00',2.21),('12664','2013-08-08','17:05:00',2.13),('12664','2013-08-08','17:10:00',2.06),('12664','2013-08-08','17:15:00',1.98),('12664','2013-08-08','17:20:00',1.9),('12664','2013-08-08','17:25:00',1.82),('12664','2013-08-08','17:30:00',1.74),('12664','2013-08-08','17:35:00',1.58),('12664','2013-08-08','17:40:00',1.5),('12664','2013-08-08','17:45:00',1.41),('12664','2013-08-08','17:50:00',1.26),('12664','2013-08-08','17:55:00',1.33),('12664','2013-08-08','18:00:00',1.25),('12664','2013-08-08','18:05:00',1.16),('12664','2013-08-08','18:10:00',1.08),('12664','2013-08-07','08:05:00',1.05),('12664','2013-08-07','08:10:00',1.13),('12664','2013-08-07','08:15:00',1.21),('12664','2013-08-07','08:20:00',1.29),('12664','2013-08-07','08:25:00',1.38),('12664','2013-08-07','08:30:00',1.46),('12664','2013-08-07','08:35:00',1.55),('12664','2013-08-07','08:40:00',1.63),('12664','2013-08-07','08:45:00',1.7),('12664','2013-08-07','08:50:00',1.79),('12664','2013-08-07','08:55:00',1.87),('12664','2013-08-07','09:00:00',1.94),('12664','2013-08-07','09:05:00',2.02),('12664','2013-08-07','09:10:00',2.09),('12664','2013-08-07','09:15:00',2.17),('12664','2013-08-07','09:20:00',2.24),('12664','2013-08-07','09:25:00',2.29),('12664','2013-08-07','09:30:00',2.36),('12664','2013-08-07','09:35:00',2.44),('12664','2013-08-07','09:40:00',2.54),('12664','2013-08-07','09:45:00',2.59),('12664','2013-08-07','09:50:00',2.66),('12664','2013-08-07','09:55:00',2.73),('12664','2013-08-07','10:00:00',2.78),('12664','2013-08-07','10:05:00',2.84),('12664','2013-08-07','10:10:00',2.87),('12664','2013-08-07','10:15:00',2.93),('12664','2013-08-07','10:20:00',2.97),('12664','2013-08-07','10:25:00',3),('12664','2013-08-07','10:30:00',3.04),('12664','2013-08-07','10:35:00',3.11),('12664','2013-08-07','10:40:00',3.22),('12664','2013-08-07','10:45:00',3.29),('12664','2013-08-07','10:50:00',3.31),('12664','2013-08-07','10:55:00',3.32),('12664','2013-08-07','11:00:00',3.36),('12664','2013-08-07','11:05:00',3.39),('12664','2013-08-07','11:10:00',3.43),('12664','2013-08-07','11:15:00',3.43),('12664','2013-08-07','11:20:00',3.45),('12664','2013-08-07','11:25:00',3.47),('12664','2013-08-07','11:30:00',3.51),('12664','2013-08-07','11:35:00',3.57),('12664','2013-08-07','11:40:00',3.57),('12664','2013-08-07','11:45:00',3.58),('12664','2013-08-07','11:50:00',3.63),('12664','2013-08-07','11:55:00',3.63),('12664','2013-08-07','12:00:00',3.67),('12664','2013-08-07','12:05:00',3.71),('12664','2013-08-07','12:10:00',3.64),('12664','2013-08-07','12:15:00',3.69),('12664','2013-08-07','12:20:00',3.75),('12664','2013-08-07','12:25:00',3.82),('12664','2013-08-07','12:30:00',3.86),('12664','2013-08-07','12:35:00',3.89),('12664','2013-08-07','12:40:00',3.91),('12664','2013-08-07','12:45:00',3.87),('12664','2013-08-07','12:50:00',3.87),('12664','2013-08-07','12:55:00',3.91),('12664','2013-08-07','13:00:00',3.91),('12664','2013-08-07','13:05:00',3.92),('12664','2013-08-07','13:10:00',3.91),('12664','2013-08-07','13:15:00',3.91),('12664','2013-08-07','13:20:00',3.88),('12664','2013-08-07','13:25:00',3.92),('12664','2013-08-07','13:30:00',3.96),('12664','2013-08-07','13:35:00',3.94),('12664','2013-08-07','13:40:00',3.91),('12664','2013-08-07','13:45:00',3.91),('12664','2013-08-07','13:50:00',3.92),('12664','2013-08-07','13:55:00',3.92),('12664','2013-08-07','14:00:00',3.91),('12664','2013-08-07','14:05:00',3.89),('12664','2013-08-07','14:10:00',3.88),('12664','2013-08-07','14:15:00',3.84),('12664','2013-08-07','14:20:00',3.82),('12664','2013-08-07','14:25:00',3.78),('12664','2013-08-07','14:30:00',3.8),('12664','2013-08-07','14:35:00',3.77),('12664','2013-08-07','14:40:00',3.74),('12664','2013-08-07','14:45:00',3.7),('12664','2013-08-07','14:50:00',3.66),('12664','2013-08-07','14:55:00',3.64),('12664','2013-08-07','15:00:00',3.62),('12664','2013-08-07','15:05:00',3.57),('12664','2013-08-07','15:10:00',3.54),('12664','2013-08-07','15:15:00',3.51),('12664','2013-08-07','15:20:00',3.45),('12664','2013-08-07','15:25:00',3.42),('12664','2013-08-07','15:30:00',3.37),('12664','2013-08-07','15:35:00',3.33),('12664','2013-08-07','15:40:00',3.28),('12664','2013-08-07','15:45:00',3.23),('12664','2013-08-07','15:50:00',3.19),('12664','2013-08-07','15:55:00',3.13),('12664','2013-08-07','16:00:00',3.09),('12664','2013-08-07','16:05:00',3.02),('12664','2013-08-07','16:10:00',2.95),('12664','2013-08-07','16:15:00',2.88),('12664','2013-08-07','16:20:00',2.82),('12664','2013-08-07','16:25:00',2.76),('12664','2013-08-07','16:30:00',2.69),('12664','2013-08-07','16:35:00',2.62),('12664','2013-08-07','16:40:00',2.56),('12664','2013-08-07','16:45:00',2.49),('12664','2013-08-07','16:50:00',2.42),('12664','2013-08-07','16:55:00',2.34),('12664','2013-08-07','17:00:00',2.27),('12664','2013-08-07','17:05:00',2.19),('12664','2013-08-07','17:10:00',2.11),('12664','2013-08-07','17:15:00',2.03),('12664','2013-08-07','17:20:00',1.96),('12664','2013-08-07','17:25:00',1.89),('12664','2013-08-07','17:30:00',1.79),('12664','2013-08-07','17:35:00',1.72),('12664','2013-08-07','17:40:00',1.64),('12664','2013-08-07','17:45:00',1.55),('12664','2013-08-07','17:50:00',1.47),('12664','2013-08-07','17:55:00',1.4),('12664','2013-08-07','18:00:00',1.32),('12664','2013-08-07','18:05:00',1.23),('12664','2013-08-07','18:10:00',1.13),('12664','2013-08-07','18:15:00',1.05),('12664','2013-08-06','08:05:00',1.03),('12664','2013-08-06','08:10:00',1.11),('12664','2013-08-06','08:15:00',1.2),('12664','2013-08-06','08:20:00',1.28),('12664','2013-08-06','08:25:00',1.36),('12664','2013-08-06','08:30:00',1.45),('12664','2013-08-06','08:35:00',1.53),('12664','2013-08-06','08:40:00',1.6),('12664','2013-08-06','08:45:00',1.69),('12664','2013-08-06','08:50:00',1.77),('12664','2013-08-06','08:55:00',1.86),('12664','2013-08-06','09:00:00',1.94),('12664','2013-08-06','09:05:00',2.02),('12664','2013-08-06','09:10:00',2.08),('12664','2013-08-06','09:15:00',2.15),('12664','2013-08-06','09:20:00',2.23),('12664','2013-08-06','09:25:00',2.31),('12664','2013-08-06','09:30:00',2.39),('12664','2013-08-06','09:35:00',2.46),('12664','2013-08-06','09:40:00',2.53),('12664','2013-08-06','09:45:00',2.59),('12664','2013-08-06','09:50:00',2.66),('12664','2013-08-06','09:55:00',2.72),('12664','2013-08-06','10:00:00',2.74),('12664','2013-08-06','10:05:00',2.81),('12664','2013-08-06','10:10:00',2.88),('12664','2013-08-06','10:15:00',2.95),('12664','2013-08-06','10:20:00',2.99),('12664','2013-08-06','10:25:00',3.02),('12664','2013-08-06','10:30:00',3.08),('12664','2013-08-06','10:35:00',3.12),('12664','2013-08-06','10:40:00',3.18),('12664','2013-08-06','10:45:00',3.23),('12664','2013-08-06','10:50:00',3.26),('12664','2013-08-06','10:55:00',3.3),('12664','2013-08-06','11:00:00',3.34),('12664','2013-08-06','11:05:00',3.32),('12664','2013-08-06','11:10:00',3.4),('12664','2013-08-06','11:15:00',3.42),('12664','2013-08-06','11:20:00',3.42),('12664','2013-08-06','11:25:00',3.48),('12664','2013-08-06','11:30:00',3.51),('12664','2013-08-06','11:35:00',3.59),('12664','2013-08-06','11:40:00',3.61),('12664','2013-08-06','11:45:00',3.64),('12664','2013-08-06','11:50:00',3.68),('12664','2013-08-06','11:55:00',3.67),('12664','2013-08-06','12:00:00',3.66),('12664','2013-08-06','12:05:00',3.68),('12664','2013-08-06','12:10:00',3.66),('12664','2013-08-06','12:15:00',3.72),('12664','2013-08-06','12:20:00',3.73),('12664','2013-08-06','12:25:00',3.76),('12664','2013-08-06','12:30:00',3.81),('12664','2013-08-06','12:35:00',3.88),('12664','2013-08-06','12:40:00',3.9),('12664','2013-08-06','12:45:00',3.9),('12664','2013-08-06','12:50:00',3.91),('12664','2013-08-06','12:55:00',3.93),('12664','2013-08-06','13:00:00',3.94),('12664','2013-08-06','13:05:00',3.94),('12664','2013-08-06','13:10:00',3.96),('12664','2013-08-06','13:15:00',3.97),('12664','2013-08-06','13:20:00',3.99),('12664','2013-08-06','13:25:00',3.96),('12664','2013-08-06','13:30:00',3.96),('12664','2013-08-06','13:35:00',3.97),('12664','2013-08-06','13:40:00',3.98),('12664','2013-08-06','13:45:00',3.97),('12664','2013-08-06','13:50:00',3.97),('12664','2013-08-06','13:55:00',3.95),('12664','2013-08-06','14:00:00',3.97),('12664','2013-08-06','14:05:00',3.96),('12664','2013-08-06','14:10:00',3.92),('12664','2013-08-06','14:15:00',3.91),('12664','2013-08-06','14:20:00',3.87),('12664','2013-08-06','14:25:00',3.84),('12664','2013-08-06','14:30:00',3.83),('12664','2013-08-06','14:35:00',3.82),('12664','2013-08-06','14:40:00',3.8),('12664','2013-08-06','14:45:00',3.78),('12664','2013-08-06','14:50:00',3.72),('12664','2013-08-06','14:55:00',3.71),('12664','2013-08-06','15:00:00',3.67),('12664','2013-08-06','15:05:00',3.65),('12664','2013-08-06','15:10:00',3.61),('12664','2013-08-06','15:15:00',3.57),('12664','2013-08-06','15:20:00',3.52),('12664','2013-08-06','15:25:00',3.48),('12664','2013-08-06','15:30:00',3.43),('12664','2013-08-06','15:35:00',3.37),('12664','2013-08-06','15:40:00',3.32),('12664','2013-08-06','15:45:00',3.28),('12664','2013-08-06','15:50:00',3.23),('12664','2013-08-06','15:55:00',3.19),('12664','2013-08-06','16:00:00',3.12),('12664','2013-08-06','16:05:00',3.06),('12664','2013-08-06','16:10:00',2.99),('12664','2013-08-06','16:15:00',2.93),('12664','2013-08-06','16:20:00',2.87),('12664','2013-08-06','16:25:00',2.8),('12664','2013-08-06','16:30:00',2.73),('12664','2013-08-06','16:35:00',2.68),('12664','2013-08-06','16:40:00',2.62),('12664','2013-08-06','16:45:00',2.55),('12664','2013-08-06','16:50:00',2.49),('12664','2013-08-06','16:55:00',2.41),('12664','2013-08-06','17:00:00',2.34),('12664','2013-08-06','17:05:00',2.27),('12664','2013-08-06','17:10:00',2.18),('12664','2013-08-06','17:15:00',2.09),('12664','2013-08-06','17:20:00',2.02),('12664','2013-08-06','17:25:00',1.93),('12664','2013-08-06','17:30:00',1.85),('12664','2013-08-06','17:35:00',1.77),('12664','2013-08-06','17:40:00',1.68),('12664','2013-08-06','17:45:00',1.59),('12664','2013-08-06','17:50:00',1.51),('12664','2013-08-06','17:55:00',1.42),('12664','2013-08-06','18:00:00',1.33),('12664','2013-08-06','18:05:00',1.25),('12664','2013-08-06','18:10:00',1.16),('12664','2013-08-06','18:15:00',1.08),('12664','2013-08-05','08:05:00',1.05),('12664','2013-08-05','08:10:00',1.13),('12664','2013-08-05','08:15:00',1.22),('12664','2013-08-05','08:20:00',1.3),('12664','2013-08-05','08:25:00',1.39),('12664','2013-08-05','08:30:00',1.47),('12664','2013-08-05','08:35:00',1.55),('12664','2013-08-05','08:40:00',1.63),('12664','2013-08-05','08:45:00',1.71),('12664','2013-08-05','08:50:00',1.82),('12664','2013-08-05','08:55:00',1.91),('12664','2013-08-05','09:00:00',1.97),('12664','2013-08-05','09:05:00',2.06),('12664','2013-08-05','09:10:00',2.13),('12664','2013-08-05','09:15:00',2.21),('12664','2013-08-05','09:20:00',2.28),('12664','2013-08-05','09:25:00',2.37),('12664','2013-08-05','09:30:00',2.43),('12664','2013-08-05','09:35:00',2.51),('12664','2013-08-05','09:40:00',2.57),('12664','2013-08-05','09:45:00',2.64),('12664','2013-08-05','09:50:00',2.7),('12664','2013-08-05','09:55:00',2.75),('12664','2013-08-05','10:00:00',2.82),('12664','2013-08-05','10:05:00',2.87),('12664','2013-08-05','10:10:00',2.93),('12664','2013-08-05','10:15:00',2.99),('12664','2013-08-05','10:20:00',3.05),('12664','2013-08-05','10:25:00',3.1),('12664','2013-08-05','10:30:00',3.15),('12664','2013-08-05','10:35:00',3.17),('12664','2013-08-05','10:40:00',3.24),('12664','2013-08-05','10:45:00',3.31),('12664','2013-08-05','10:50:00',3.34),('12664','2013-08-05','10:55:00',3.4),('12664','2013-08-05','11:00:00',3.43),('12664','2013-08-05','11:05:00',3.47),('12664','2013-08-05','11:10:00',3.51),('12664','2013-08-05','11:15:00',3.56),('12664','2013-08-05','11:20:00',3.6),('12664','2013-08-05','11:25:00',3.65),('12664','2013-08-05','11:30:00',3.69),('12664','2013-08-05','11:35:00',3.71),('12664','2013-08-05','11:40:00',3.74),('12664','2013-08-05','11:45:00',3.77),('12664','2013-08-05','11:50:00',3.77),('12664','2013-08-05','11:55:00',3.78),('12664','2013-08-05','12:00:00',3.82),('12664','2013-08-05','12:05:00',3.83),('12664','2013-08-05','12:10:00',3.81),('12664','2013-08-05','12:15:00',3.88),('12664','2013-08-05','12:20:00',3.88),('12664','2013-08-05','12:25:00',3.88),('12664','2013-08-05','12:30:00',3.91),('12664','2013-08-05','12:35:00',3.93),('12664','2013-08-05','12:40:00',3.92),('12664','2013-08-05','12:45:00',3.92),('12664','2013-08-05','12:50:00',3.93),('12664','2013-08-05','12:55:00',3.93),('12664','2013-08-05','13:00:00',3.94),('12664','2013-08-05','13:05:00',3.97),('12664','2013-08-05','13:10:00',4),('12664','2013-08-05','13:15:00',3.97),('12664','2013-08-05','13:20:00',3.96),('12664','2013-08-05','13:25:00',3.94),('12664','2013-08-05','13:30:00',3.94),('12664','2013-08-05','13:35:00',3.94),('12664','2013-08-05','13:40:00',3.9),('12664','2013-08-05','13:45:00',3.88),('12664','2013-08-05','13:50:00',3.92),('12664','2013-08-05','13:55:00',3.91),('12664','2013-08-05','14:00:00',3.9),('12664','2013-08-05','14:05:00',3.86),('12664','2013-08-05','14:10:00',3.83),('12664','2013-08-05','14:15:00',3.84),('12664','2013-08-05','14:20:00',3.78),('12664','2013-08-05','14:25:00',3.79),('12664','2013-08-05','14:30:00',3.77),('12664','2013-08-05','14:35:00',3.73),('12664','2013-08-05','14:40:00',3.71),('12664','2013-08-05','14:45:00',3.68),('12664','2013-08-05','14:50:00',3.68),('12664','2013-08-05','14:55:00',3.65),('12664','2013-08-05','15:00:00',3.6),('12664','2013-08-05','15:05:00',3.57),('12664','2013-08-05','15:10:00',3.54),('12664','2013-08-05','15:15:00',3.5),('12664','2013-08-05','15:20:00',3.47),('12664','2013-08-05','15:25:00',3.44),('12664','2013-08-05','15:30:00',3.4),('12664','2013-08-05','15:35:00',3.34),('12664','2013-08-05','15:40:00',3.29),('12664','2013-08-05','15:45:00',3.26),('12664','2013-08-05','15:50:00',3.21),('12664','2013-08-05','15:55:00',3.16),('12664','2013-08-05','16:00:00',3.1),('12664','2013-08-05','16:05:00',3.04),('12664','2013-08-05','16:10:00',2.99),('12664','2013-08-05','16:15:00',2.95),('12664','2013-08-05','16:20:00',2.88),('12664','2013-08-05','16:25:00',2.82),('12664','2013-08-05','16:30:00',2.74),('12664','2013-08-05','16:35:00',2.67),('12664','2013-08-05','16:40:00',2.6),('12664','2013-08-05','16:45:00',2.53),('12664','2013-08-05','16:50:00',2.45),('12664','2013-08-05','16:55:00',2.36),('12664','2013-08-05','17:00:00',2.28),('12664','2013-08-05','17:05:00',2.22),('12664','2013-08-05','17:10:00',2.14),('12664','2013-08-05','17:15:00',2.06),('12664','2013-08-05','17:20:00',1.97),('12664','2013-08-05','17:25:00',1.9),('12664','2013-08-05','17:30:00',1.8),('12664','2013-08-05','17:35:00',1.73),('12664','2013-08-05','17:40:00',1.64),('12664','2013-08-05','17:45:00',1.55),('12664','2013-08-05','17:50:00',1.48),('12664','2013-08-05','17:55:00',1.38),('12664','2013-08-05','18:00:00',1.32),('12664','2013-08-05','18:05:00',1.23),('12664','2013-08-05','18:10:00',1.15),('12664','2013-08-05','18:15:00',1.07),('12664','2013-08-04','08:00:00',1.06),('12664','2013-08-04','08:05:00',1.16),('12664','2013-08-04','08:10:00',1.24),('12664','2013-08-04','08:15:00',1.32),('12664','2013-08-04','08:20:00',1.41),('12664','2013-08-04','08:25:00',1.5),('12664','2013-08-04','08:30:00',1.59),('12664','2013-08-04','08:35:00',1.67),('12664','2013-08-04','08:40:00',1.77),('12664','2013-08-04','08:45:00',1.85),('12664','2013-08-04','08:50:00',1.93),('12664','2013-08-04','08:55:00',2.01),('12664','2013-08-04','09:00:00',2.09),('12664','2013-08-04','09:05:00',2.16),('12664','2013-08-04','09:10:00',2.23),('12664','2013-08-04','09:15:00',2.31),('12664','2013-08-04','09:20:00',2.39),('12664','2013-08-04','09:25:00',2.46),('12664','2013-08-04','09:30:00',2.52),('12664','2013-08-04','09:35:00',2.6),('12664','2013-08-04','09:40:00',2.67),('12664','2013-08-04','09:45:00',2.74),('12664','2013-08-04','09:50:00',2.79),('12664','2013-08-04','09:55:00',2.86),('12664','2013-08-04','10:00:00',2.92),('12664','2013-08-04','10:05:00',2.97),('12664','2013-08-04','10:10:00',3.03),('12664','2013-08-04','10:15:00',3.09),('12664','2013-08-04','10:20:00',3.13),('12664','2013-08-04','10:25:00',3.18),('12664','2013-08-04','10:30:00',3.21),('12664','2013-08-04','10:35:00',3.26),('12664','2013-08-04','10:40:00',3.33),('12664','2013-08-04','10:45:00',3.39),('12664','2013-08-04','10:50:00',3.45),('12664','2013-08-04','10:55:00',3.51),('12664','2013-08-04','11:00:00',3.56),('12664','2013-08-04','11:05:00',3.57),('12664','2013-08-04','11:10:00',3.6),('12664','2013-08-04','11:15:00',3.6),('12664','2013-08-04','11:20:00',3.67),('12664','2013-08-04','11:25:00',3.72),('12664','2013-08-04','11:30:00',3.69),('12664','2013-08-04','11:35:00',3.73),('12664','2013-08-04','11:40:00',3.79),('12664','2013-08-04','11:45:00',3.8),('12664','2013-08-04','11:50:00',3.84),('12664','2013-08-04','11:55:00',3.84),('12664','2013-08-04','12:00:00',3.86),('12664','2013-08-04','12:05:00',3.91),('12664','2013-08-04','12:10:00',3.9),('12664','2013-08-04','12:15:00',3.93),('12664','2013-08-04','12:20:00',3.97),('12664','2013-08-04','12:25:00',3.99),('12664','2013-08-04','12:30:00',3.98),('12664','2013-08-04','12:35:00',4.01),('12664','2013-08-04','12:40:00',4),('12664','2013-08-04','12:45:00',4.01),('12664','2013-08-04','12:50:00',4.05),('12664','2013-08-04','12:55:00',4.03),('12664','2013-08-04','13:00:00',4.04),('12664','2013-08-04','13:05:00',4.06),('12664','2013-08-04','13:10:00',4.05),('12664','2013-08-04','13:15:00',4.07),('12664','2013-08-04','13:20:00',4.06),('12664','2013-08-04','13:25:00',4.07),('12664','2013-08-04','13:30:00',4.06),('12664','2013-08-04','13:35:00',4.05),('12664','2013-08-04','13:40:00',4.06),('12664','2013-08-04','13:45:00',4.06),('12664','2013-08-04','13:50:00',4.04),('12664','2013-08-04','13:55:00',4.01),('12664','2013-08-04','14:00:00',4),('12664','2013-08-04','14:05:00',3.97),('12664','2013-08-04','14:10:00',3.95),('12664','2013-08-04','14:15:00',3.95),('12664','2013-08-04','14:20:00',3.94),('12664','2013-08-04','14:25:00',3.94),('12664','2013-08-04','14:30:00',3.92),('12664','2013-08-04','14:35:00',3.88),('12664','2013-08-04','14:40:00',3.81),('12664','2013-08-04','14:45:00',3.7),('12664','2013-08-04','14:50:00',3.59),('12664','2013-08-04','14:55:00',3.57),('12664','2013-08-04','15:00:00',3.55),('12664','2013-08-04','15:05:00',3.69),('12664','2013-08-04','15:10:00',3.67),('12664','2013-08-04','15:15:00',3.64),('12664','2013-08-04','15:20:00',3.59),('12664','2013-08-04','15:25:00',3.56),('12664','2013-08-04','15:30:00',3.53),('12664','2013-08-04','15:35:00',3.5),('12664','2013-08-04','15:40:00',3.45),('12664','2013-08-04','15:45:00',3.35),('12664','2013-08-04','15:50:00',3.32),('12664','2013-08-04','15:55:00',3.26),('12664','2013-08-04','16:00:00',3.21),('12664','2013-08-04','16:05:00',3.16),('12664','2013-08-04','16:10:00',3.09),('12664','2013-08-04','16:15:00',3.04),('12664','2013-08-04','16:20:00',2.97),('12664','2013-08-04','16:25:00',2.89),('12664','2013-08-04','16:30:00',2.83),('12664','2013-08-04','16:35:00',2.75),('12664','2013-08-04','16:40:00',2.67),('12664','2013-08-04','16:45:00',2.61),('12664','2013-08-04','16:50:00',2.53),('12664','2013-08-04','16:55:00',2.45),('12664','2013-08-04','17:00:00',2.38),('12664','2013-08-04','17:05:00',2.3),('12664','2013-08-04','17:10:00',2.21),('12664','2013-08-04','17:15:00',2.13),('12664','2013-08-04','17:20:00',2.05),('12664','2013-08-04','17:25:00',1.96),('12664','2013-08-04','17:30:00',1.88),('12664','2013-08-04','17:35:00',1.79),('12664','2013-08-04','17:40:00',1.69),('12664','2013-08-04','17:45:00',1.59),('12664','2013-08-04','17:50:00',1.5),('12664','2013-08-04','17:55:00',1.43),('12664','2013-08-04','18:00:00',1.34),('12664','2013-08-04','18:05:00',1.26),('12664','2013-08-04','18:10:00',1.17),('12664','2013-08-04','18:15:00',1.08),('12664','2013-08-03','08:00:00',1.05),('12664','2013-08-03','08:05:00',1.14),('12664','2013-08-03','08:10:00',1.23),('12664','2013-08-03','08:15:00',1.32),('12664','2013-08-03','08:20:00',1.41),('12664','2013-08-03','08:25:00',1.5),('12664','2013-08-03','08:30:00',1.59),('12664','2013-08-03','08:35:00',1.68),('12664','2013-08-03','08:40:00',1.76),('12664','2013-08-03','08:45:00',1.84),('12664','2013-08-03','08:50:00',1.92),('12664','2013-08-03','08:55:00',2),('12664','2013-08-03','09:00:00',2.08),('12664','2013-08-03','09:05:00',2.16),('12664','2013-08-03','09:10:00',2.23),('12664','2013-08-03','09:15:00',2.31),('12664','2013-08-03','09:20:00',2.37),('12664','2013-08-03','09:25:00',2.44),('12664','2013-08-03','09:30:00',2.51),('12664','2013-08-03','09:35:00',2.59),('12664','2013-08-03','09:40:00',2.64),('12664','2013-08-03','09:45:00',2.72),('12664','2013-08-03','09:50:00',2.8),('12664','2013-08-03','09:55:00',2.85),('12664','2013-08-03','10:00:00',2.91),('12664','2013-08-03','10:05:00',2.99),('12664','2013-08-03','10:10:00',3.03),('12664','2013-08-03','10:15:00',3.1),('12664','2013-08-03','10:20:00',3.16),('12664','2013-08-03','10:25:00',3.2),('12664','2013-08-03','10:30:00',3.26),('12664','2013-08-03','10:35:00',3.32),('12664','2013-08-03','10:40:00',3.36),('12664','2013-08-03','10:45:00',3.42),('12664','2013-08-03','10:50:00',3.44),('12664','2013-08-03','10:55:00',3.48),('12664','2013-08-03','11:00:00',3.53),('12664','2013-08-03','11:05:00',3.55),('12664','2013-08-03','11:10:00',3.61),('12664','2013-08-03','11:15:00',3.61),('12664','2013-08-03','11:20:00',3.6),('12664','2013-08-03','11:25:00',3.66),('12664','2013-08-03','11:30:00',3.69),('12664','2013-08-03','11:35:00',3.71),('12664','2013-08-03','11:40:00',3.69),('12664','2013-08-03','11:45:00',3.75),('12664','2013-08-03','11:50:00',3.8),('12664','2013-08-03','11:55:00',3.81),('12664','2013-08-03','12:00:00',3.75),('12664','2013-08-03','12:05:00',3.74),('12664','2013-08-03','12:10:00',3.81),('12664','2013-08-03','12:15:00',3.86),('12664','2013-08-03','12:20:00',3.93),('12664','2013-08-03','12:25:00',3.96),('12664','2013-08-03','12:30:00',3.95),('12664','2013-08-03','12:35:00',3.89),('12664','2013-08-03','12:40:00',3.92),('12664','2013-08-03','12:45:00',4.02),('12664','2013-08-03','12:50:00',4.04),('12664','2013-08-03','12:55:00',4.01),('12664','2013-08-03','13:00:00',4.03),('12664','2013-08-03','13:05:00',3.99),('12664','2013-08-03','13:10:00',3.99),('12664','2013-08-03','13:15:00',3.98),('12664','2013-08-03','13:20:00',3.96),('12664','2013-08-03','13:25:00',3.94),('12664','2013-08-03','13:30:00',3.98),('12664','2013-08-03','13:35:00',3.89),('12664','2013-08-03','13:40:00',3.88),('12664','2013-08-03','13:45:00',3.93),('12664','2013-08-03','13:50:00',3.95),('12664','2013-08-03','13:55:00',3.93),('12664','2013-08-03','14:00:00',3.98),('12664','2013-08-03','14:05:00',4.01),('12664','2013-08-03','14:10:00',3.95),('12664','2013-08-03','14:15:00',3.93),('12664','2013-08-03','14:20:00',3.9),('12664','2013-08-03','14:25:00',3.9),('12664','2013-08-03','14:30:00',3.89),('12664','2013-08-03','14:35:00',3.86),('12664','2013-08-03','14:40:00',3.85),('12664','2013-08-03','14:45:00',3.82),('12664','2013-08-03','14:50:00',3.79),('12664','2013-08-03','14:55:00',3.77),('12664','2013-08-03','15:00:00',3.73),('12664','2013-08-03','15:05:00',3.69),('12664','2013-08-03','15:10:00',3.65),('12664','2013-08-03','15:15:00',3.61),('12664','2013-08-03','15:20:00',3.57),('12664','2013-08-03','15:25:00',3.54),('12664','2013-08-03','15:30:00',3.49),('12664','2013-08-03','15:35:00',3.46),('12664','2013-08-03','15:40:00',3.41),('12664','2013-08-03','15:45:00',3.36),('12664','2013-08-03','15:50:00',3.3),('12664','2013-08-03','15:55:00',3.24),('12664','2013-08-03','16:00:00',3.19),('12664','2013-08-03','16:05:00',3.13),('12664','2013-08-03','16:10:00',3.08),('12664','2013-08-03','16:15:00',3.02),('12664','2013-08-03','16:20:00',2.96),('12664','2013-08-03','16:25:00',2.89),('12664','2013-08-03','16:30:00',2.81),('12664','2013-08-03','16:35:00',2.74),('12664','2013-08-03','16:40:00',2.67),('12664','2013-08-03','16:45:00',2.6),('12664','2013-08-03','16:50:00',2.53),('12664','2013-08-03','16:55:00',2.46),('12664','2013-08-03','17:00:00',2.39),('12664','2013-08-03','17:05:00',2.32),('12664','2013-08-03','17:10:00',2.24),('12664','2013-08-03','17:15:00',2.17),('12664','2013-08-03','17:20:00',2.1),('12664','2013-08-03','17:25:00',2),('12664','2013-08-03','17:30:00',1.92),('12664','2013-08-03','17:35:00',1.83),('12664','2013-08-03','17:40:00',1.74),('12664','2013-08-03','17:45:00',1.67),('12664','2013-08-03','17:50:00',1.57),('12664','2013-08-03','17:55:00',1.48),('12664','2013-08-03','18:00:00',1.39),('12664','2013-08-03','18:05:00',1.31),('12664','2013-08-03','18:10:00',1.23),('12664','2013-08-03','18:15:00',1.14),('12664','2013-08-03','18:20:00',1.06),('12664','2013-08-02','07:55:00',1.03),('12664','2013-08-02','08:00:00',1.12),('12664','2013-08-02','08:05:00',1.21),('12664','2013-08-02','08:10:00',1.31),('12664','2013-08-02','08:15:00',1.4),('12664','2013-08-02','08:20:00',1.49),('12664','2013-08-02','08:25:00',1.58),('12664','2013-08-02','08:30:00',1.68),('12664','2013-08-02','08:35:00',1.76),('12664','2013-08-02','08:40:00',1.85),('12664','2013-08-02','08:45:00',1.93),('12664','2013-08-02','08:50:00',2.01),('12664','2013-08-02','08:55:00',2.09),('12664','2013-08-02','09:00:00',2.18),('12664','2013-08-02','09:05:00',2.26),('12664','2013-08-02','09:10:00',2.33),('12664','2013-08-02','09:15:00',2.41),('12664','2013-08-02','09:20:00',2.49),('12664','2013-08-02','09:25:00',2.55),('12664','2013-08-02','09:30:00',2.63),('12664','2013-08-02','09:35:00',2.7),('12664','2013-08-02','09:40:00',2.77),('12664','2013-08-02','09:45:00',2.83),('12664','2013-08-02','09:50:00',2.89),('12664','2013-08-02','09:55:00',2.95),('12664','2013-08-02','10:00:00',2.99),('12664','2013-08-02','10:05:00',3.06),('12664','2013-08-02','10:10:00',3.11),('12664','2013-08-02','10:15:00',3.15),('12664','2013-08-02','10:20:00',3.21),('12664','2013-08-02','10:25:00',3.25),('12664','2013-08-02','10:30:00',3.3),('12664','2013-08-02','10:35:00',3.34),('12664','2013-08-02','10:40:00',3.38),('12664','2013-08-02','10:45:00',3.45),('12664','2013-08-02','10:50:00',3.5),('12664','2013-08-02','10:55:00',3.53),('12664','2013-08-02','11:00:00',3.56),('12664','2013-08-02','11:05:00',3.61),('12664','2013-08-02','11:10:00',3.64),('12664','2013-08-02','11:15:00',3.67),('12664','2013-08-02','11:20:00',3.71),('12664','2013-08-02','11:25:00',3.74),('12664','2013-08-02','11:30:00',3.77),('12664','2013-08-02','11:35:00',3.8),('12664','2013-08-02','11:40:00',3.81),('12664','2013-08-02','11:45:00',3.85),('12664','2013-08-02','11:50:00',3.87),('12664','2013-08-02','11:55:00',3.88),('12664','2013-08-02','12:00:00',3.88),('12664','2013-08-02','12:05:00',3.91),('12664','2013-08-02','12:10:00',3.93),('12664','2013-08-02','12:15:00',3.94),('12664','2013-08-02','12:20:00',3.95),('12664','2013-08-02','12:25:00',3.96),('12664','2013-08-02','12:30:00',3.99),('12664','2013-08-02','12:35:00',4.01),('12664','2013-08-02','12:40:00',4),('12664','2013-08-02','12:45:00',4.02),('12664','2013-08-02','12:50:00',4.02),('12664','2013-08-02','12:55:00',4.06),('12664','2013-08-02','13:00:00',4.05),('12664','2013-08-02','13:05:00',4.07),('12664','2013-08-02','13:10:00',4.07),('12664','2013-08-02','13:15:00',4.05),('12664','2013-08-02','13:20:00',4.04),('12664','2013-08-02','13:25:00',4.01),('12664','2013-08-02','13:30:00',4),('12664','2013-08-02','13:35:00',4),('12664','2013-08-02','13:40:00',3.97),('12664','2013-08-02','13:45:00',3.94),('12664','2013-08-02','13:50:00',3.94),('12664','2013-08-02','13:55:00',3.93),('12664','2013-08-02','14:00:00',3.89),('12664','2013-08-02','14:05:00',3.92),('12664','2013-08-02','14:10:00',3.86),('12664','2013-08-02','14:15:00',3.85),('12664','2013-08-02','14:20:00',3.86),('12664','2013-08-02','14:25:00',3.87),('12664','2013-08-02','14:30:00',3.85),('12664','2013-08-02','14:35:00',3.83),('12664','2013-08-02','14:40:00',3.79),('12664','2013-08-02','14:45:00',3.79),('12664','2013-08-02','14:50:00',3.76),('12664','2013-08-02','14:55:00',3.71),('12664','2013-08-02','15:00:00',3.66),('12664','2013-08-02','15:05:00',3.68),('12664','2013-08-02','15:10:00',3.65),('12664','2013-08-02','15:15:00',3.62),('12664','2013-08-02','15:20:00',3.59),('12664','2013-08-02','15:25:00',3.53),('12664','2013-08-02','15:30:00',3.49),('12664','2013-08-02','15:35:00',3.46),('12664','2013-08-02','15:40:00',3.43),('12664','2013-08-02','15:45:00',3.4),('12664','2013-08-02','15:50:00',3.34),('12664','2013-08-02','15:55:00',3.31),('12664','2013-08-02','16:00:00',3.25),('12664','2013-08-02','16:05:00',3.18),('12664','2013-08-02','16:10:00',3.1),('12664','2013-08-02','16:15:00',3.04),('12664','2013-08-02','16:20:00',2.97),('12664','2013-08-02','16:25:00',2.9),('12664','2013-08-02','16:30:00',2.83),('12664','2013-08-02','16:35:00',2.77),('12664','2013-08-02','16:40:00',2.71),('12664','2013-08-02','16:45:00',2.66),('12664','2013-08-02','16:50:00',2.6),('12664','2013-08-02','16:55:00',2.49),('12664','2013-08-02','17:00:00',2.39),('12664','2013-08-02','17:05:00',2.33),('12664','2013-08-02','17:10:00',2.28),('12664','2013-08-02','17:15:00',2.2),('12664','2013-08-02','17:20:00',2.13),('12664','2013-08-02','17:25:00',2.04),('12664','2013-08-02','17:30:00',1.95),('12664','2013-08-02','17:35:00',1.87),('12664','2013-08-02','17:40:00',1.76),('12664','2013-08-02','17:45:00',1.68),('12664','2013-08-02','17:50:00',1.6),('12664','2013-08-02','17:55:00',1.51),('12664','2013-08-02','18:00:00',1.43),('12664','2013-08-02','18:05:00',1.34),('12664','2013-08-02','18:10:00',1.26),('12664','2013-08-02','18:15:00',1.18),('12664','2013-08-02','18:20:00',1.08),('12664','2013-08-01','07:55:00',1.05),('12664','2013-08-01','08:00:00',1.15),('12664','2013-08-01','08:05:00',1.24),('12664','2013-08-01','08:10:00',1.33),('12664','2013-08-01','08:15:00',1.42),('12664','2013-08-01','08:20:00',1.51),('12664','2013-08-01','08:25:00',1.61),('12664','2013-08-01','08:30:00',1.7),('12664','2013-08-01','08:35:00',1.8),('12664','2013-08-01','08:40:00',1.87),('12664','2013-08-01','08:45:00',1.93),('12664','2013-08-01','08:50:00',2.01),('12664','2013-08-01','08:55:00',2.13),('12664','2013-08-01','09:00:00',2.21),('12664','2013-08-01','09:05:00',2.28),('12664','2013-08-01','09:10:00',2.37),('12664','2013-08-01','09:15:00',2.45),('12664','2013-08-01','09:20:00',2.53),('12664','2013-08-01','09:25:00',2.61),('12664','2013-08-01','09:30:00',2.69),('12664','2013-08-01','09:35:00',2.77),('12664','2013-08-01','09:40:00',2.86),('12664','2013-08-01','09:45:00',2.93),('12664','2013-08-01','09:50:00',3.01),('12664','2013-08-01','09:55:00',3.08),('12664','2013-08-01','10:00:00',3.15),('12664','2013-08-01','10:05:00',3.22),('12664','2013-08-01','10:10:00',3.28),('12664','2013-08-01','10:15:00',3.33),('12664','2013-08-01','10:20:00',3.39),('12664','2013-08-01','10:25:00',3.45),('12664','2013-08-01','10:30:00',3.5),('12664','2013-08-01','10:35:00',3.54),('12664','2013-08-01','10:40:00',3.63),('12664','2013-08-01','10:45:00',3.67),('12664','2013-08-01','10:50:00',3.73),('12664','2013-08-01','10:55:00',3.75),('12664','2013-08-01','11:00:00',3.77),('12664','2013-08-01','11:05:00',3.84),('12664','2013-08-01','11:10:00',3.89),('12664','2013-08-01','11:15:00',3.92),('12664','2013-08-01','11:20:00',3.96),('12664','2013-08-01','11:25:00',3.99),('12664','2013-08-01','11:30:00',4.04),('12664','2013-08-01','11:35:00',4.05),('12664','2013-08-01','11:40:00',4.08),('12664','2013-08-01','11:45:00',4.11),('12664','2013-08-01','11:50:00',4.12),('12664','2013-08-01','11:55:00',4.14),('12664','2013-08-01','12:00:00',4.16),('12664','2013-08-01','12:05:00',4.18),('12664','2013-08-01','12:10:00',4.21),('12664','2013-08-01','12:15:00',4.24),('12664','2013-08-01','12:20:00',4.26),('12664','2013-08-01','12:25:00',4.28),('12664','2013-08-01','12:30:00',4.29),('12664','2013-08-01','12:35:00',4.26),('12664','2013-08-01','12:40:00',4.29),('12664','2013-08-01','12:45:00',4.3),('12664','2013-08-01','12:50:00',4.29),('12664','2013-08-01','12:55:00',4.28),('12664','2013-08-01','13:00:00',4.27),('12664','2013-08-01','13:05:00',4.27),('12664','2013-08-01','13:10:00',4.27),('12664','2013-08-01','13:15:00',4.28),('12664','2013-08-01','13:20:00',4.3),('12664','2013-08-01','13:25:00',4.29),('12664','2013-08-01','13:30:00',4.27),('12664','2013-08-01','13:35:00',4.27),('12664','2013-08-01','13:40:00',4.26),('12664','2013-08-01','13:45:00',4.26),('12664','2013-08-01','13:50:00',4.22),('12664','2013-08-01','13:55:00',4.2),('12664','2013-08-01','14:00:00',4.22),('12664','2013-08-01','14:05:00',4.22),('12664','2013-08-01','14:10:00',4.17),('12664','2013-08-01','14:15:00',4.12),('12664','2013-08-01','14:20:00',4.09),('12664','2013-08-01','14:25:00',4.09),('12664','2013-08-01','14:30:00',4.06),('12664','2013-08-01','14:35:00',4.04),('12664','2013-08-01','14:40:00',4.01),('12664','2013-08-01','14:45:00',3.94),('12664','2013-08-01','14:50:00',3.93),('12664','2013-08-01','14:55:00',3.92),('12664','2013-08-01','15:00:00',3.88),('12664','2013-08-01','15:05:00',3.83),('12664','2013-08-01','15:10:00',3.79),('12664','2013-08-01','15:15:00',3.76),('12664','2013-08-01','15:20:00',3.7),('12664','2013-08-01','15:25:00',3.64),('12664','2013-08-01','15:30:00',3.6),('12664','2013-08-01','15:35:00',3.55),('12664','2013-08-01','15:40:00',3.52),('12664','2013-08-01','15:45:00',3.47),('12664','2013-08-01','15:50:00',3.39),('12664','2013-08-01','15:55:00',3.33),('12664','2013-08-01','16:00:00',3.27),('12664','2013-08-01','16:05:00',3.21),('12664','2013-08-01','16:10:00',3.15),('12664','2013-08-01','16:15:00',3.09),('12664','2013-08-01','16:20:00',3.01),('12664','2013-08-01','16:25:00',2.96),('12664','2013-08-01','16:30:00',2.88),('12664','2013-08-01','16:35:00',2.81),('12664','2013-08-01','16:40:00',2.75),('12664','2013-08-01','16:45:00',2.68),('12664','2013-08-01','16:50:00',2.6),('12664','2013-08-01','16:55:00',2.53),('12664','2013-08-01','17:00:00',2.45),('12664','2013-08-01','17:05:00',2.38),('12664','2013-08-01','17:10:00',2.3),('12664','2013-08-01','17:15:00',2.22),('12664','2013-08-01','17:20:00',2.15),('12664','2013-08-01','17:25:00',2.06),('12664','2013-08-01','17:30:00',1.99),('12664','2013-08-01','17:35:00',1.88),('12664','2013-08-01','17:40:00',1.79),('12664','2013-08-01','17:45:00',1.7),('12664','2013-08-01','17:50:00',1.6),('12664','2013-08-01','17:55:00',1.51),('12664','2013-08-01','18:00:00',1.44),('12664','2013-08-01','18:05:00',1.34),('12664','2013-08-01','18:10:00',1.25),('12664','2013-08-01','18:15:00',1.18),('12664','2013-08-01','18:20:00',1.1),('12664','2013-08-01','18:25:00',1),('12664','2013-07-31','07:55:00',1.08),('12664','2013-07-31','08:00:00',1.17),('12664','2013-07-31','08:05:00',1.26),('12664','2013-07-31','08:10:00',1.35),('12664','2013-07-31','08:15:00',1.43),('12664','2013-07-31','08:20:00',1.53),('12664','2013-07-31','08:25:00',1.62),('12664','2013-07-31','08:30:00',1.71),('12664','2013-07-31','08:35:00',1.8),('12664','2013-07-31','08:40:00',1.88),('12664','2013-07-31','08:45:00',1.97),('12664','2013-07-31','08:50:00',2.05),('12664','2013-07-31','08:55:00',2.13),('12664','2013-07-31','09:00:00',2.21),('12664','2013-07-31','09:05:00',2.29),('12664','2013-07-31','09:10:00',2.37),('12664','2013-07-31','09:15:00',2.44),('12664','2013-07-31','09:20:00',2.51),('12664','2013-07-31','09:25:00',2.59),('12664','2013-07-31','09:30:00',2.66),('12664','2013-07-31','09:35:00',2.73),('12664','2013-07-31','09:40:00',2.81),('12664','2013-07-31','09:45:00',2.88),('12664','2013-07-31','09:50:00',2.94),('12664','2013-07-31','09:55:00',3),('12664','2013-07-31','10:00:00',3.07),('12664','2013-07-31','10:05:00',3.11),('12664','2013-07-31','10:10:00',3.17),('12664','2013-07-31','10:15:00',3.23),('12664','2013-07-31','10:20:00',3.3),('12664','2013-07-31','10:25:00',3.36),('12664','2013-07-31','10:30:00',3.43),('12664','2013-07-31','10:35:00',3.51),('12664','2013-07-31','10:40:00',3.56),('12664','2013-07-31','10:45:00',3.6),('12664','2013-07-31','10:50:00',3.66),('12664','2013-07-31','10:55:00',3.71),('12664','2013-07-31','11:00:00',3.77),('12664','2013-07-31','11:05:00',3.8),('12664','2013-07-31','11:10:00',3.82),('12664','2013-07-31','11:15:00',3.86),('12664','2013-07-31','11:20:00',3.89),('12664','2013-07-31','11:25:00',3.95),('12664','2013-07-31','11:30:00',3.96),('12664','2013-07-31','11:35:00',4.01),('12664','2013-07-31','11:40:00',4.07),('12664','2013-07-31','11:45:00',4.07),('12664','2013-07-31','11:50:00',4.09),('12664','2013-07-31','11:55:00',4.11),('12664','2013-07-31','12:00:00',4.16),('12664','2013-07-31','12:05:00',4.16),('12664','2013-07-31','12:10:00',4.15),('12664','2013-07-31','12:15:00',4.2),('12664','2013-07-31','12:20:00',4.21),('12664','2013-07-31','12:25:00',4.23),('12664','2013-07-31','12:30:00',4.25),('12664','2013-07-31','12:35:00',4.27),('12664','2013-07-31','12:40:00',4.26),('12664','2013-07-31','12:45:00',4.27),('12664','2013-07-31','12:50:00',4.26),('12664','2013-07-31','12:55:00',4.26),('12664','2013-07-31','13:00:00',4.25),('12664','2013-07-31','13:05:00',4.24),('12664','2013-07-31','13:10:00',4.27),('12664','2013-07-31','13:15:00',4.29),('12664','2013-07-31','13:20:00',4.27),('12664','2013-07-31','13:25:00',4.29),('12664','2013-07-31','13:30:00',4.27),('12664','2013-07-31','13:35:00',4.24),('12664','2013-07-31','13:40:00',4.25),('12664','2013-07-31','13:45:00',4.22),('12664','2013-07-31','13:50:00',4.18),('12664','2013-07-31','13:55:00',4.18),('12664','2013-07-31','14:00:00',4.22),('12664','2013-07-31','14:05:00',4.21),('12664','2013-07-31','14:10:00',4.16),('12664','2013-07-31','14:15:00',4.18),('12664','2013-07-31','14:20:00',4.14),('12664','2013-07-31','14:25:00',4.07),('12664','2013-07-31','14:30:00',4.04),('12664','2013-07-31','14:35:00',4.01),('12664','2013-07-31','14:40:00',3.97),('12664','2013-07-31','14:45:00',3.92),('12664','2013-07-31','14:50:00',3.89),('12664','2013-07-31','14:55:00',3.88),('12664','2013-07-31','15:00:00',3.54),('12664','2013-07-31','15:05:00',2.8),('12664','2013-07-31','15:10:00',3.31),('12664','2013-07-31','15:15:00',3.8),('12664','2013-07-31','15:20:00',3.67),('12664','2013-07-31','15:25:00',3.59),('12664','2013-07-31','15:30:00',3.55),('12664','2013-07-31','15:35:00',3.46),('12664','2013-07-31','15:40:00',3.4),('12664','2013-07-31','15:45:00',3.41),('12664','2013-07-31','15:50:00',2.79),('12664','2013-07-31','15:55:00',1.78),('12664','2013-07-31','16:00:00',3.31),('12664','2013-07-31','16:05:00',3.28),('12664','2013-07-31','16:10:00',3.22),('12664','2013-07-31','16:15:00',3.19),('12664','2013-07-31','16:20:00',3.02),('12664','2013-07-31','16:25:00',2.35),('12664','2013-07-31','16:30:00',2.69),('12664','2013-07-31','16:35:00',2.91),('12664','2013-07-31','16:40:00',2.84),('12664','2013-07-31','16:45:00',2.75),('12664','2013-07-31','16:50:00',2.72),('12664','2013-07-31','16:55:00',2.42),('12664','2013-07-31','17:00:00',1.82),('12664','2013-07-31','17:05:00',1.24),('12664','2013-07-31','17:10:00',1.99),('12664','2013-07-31','17:15:00',2.16),('12664','2013-07-31','17:20:00',2.2),('12664','2013-07-31','17:25:00',2.11),('12664','2013-07-31','17:30:00',2.01),('12664','2013-07-31','17:35:00',1.89),('12664','2013-07-31','17:40:00',1.83),('12664','2013-07-31','17:45:00',1.73),('12664','2013-07-31','17:50:00',1.64),('12664','2013-07-31','17:55:00',1.54),('12664','2013-07-31','18:00:00',1.47),('12664','2013-07-31','18:05:00',1.39),('12664','2013-07-31','18:10:00',1.29),('12664','2013-07-31','18:15:00',1.22),('12664','2013-07-31','18:20:00',1.14),('12664','2013-07-31','18:25:00',1.05),('12664','2013-07-30','08:00:00',1.12),('12664','2013-07-30','08:05:00',1.23),('12664','2013-07-30','08:10:00',1.32),('12664','2013-07-30','08:15:00',1.4),('12664','2013-07-30','08:20:00',1.48),('12664','2013-07-30','08:25:00',1.57),('12664','2013-07-30','08:30:00',1.67),('12664','2013-07-30','08:35:00',1.78),('12664','2013-07-30','08:40:00',1.86),('12664','2013-07-30','08:45:00',1.93),('12664','2013-07-30','08:50:00',2.09),('12664','2013-07-30','08:55:00',2.2),('12664','2013-07-30','09:00:00',2.34),('12664','2013-07-30','09:05:00',2.46),('12664','2013-07-30','09:10:00',2.47),('12664','2013-07-30','09:15:00',2.12),('12664','2013-07-30','09:20:00',1.37),('12664','2013-07-30','09:25:00',1.37),('12664','2013-07-30','09:30:00',1.59),('12664','2013-07-30','09:45:00',1.98),('12664','2013-07-30','09:50:00',3.01),('12664','2013-07-30','09:55:00',1.55),('12664','2013-07-30','10:25:00',2.37),('12664','2013-07-30','10:30:00',3.67),('12664','2013-07-30','10:35:00',3.63),('12664','2013-07-30','10:40:00',3.61),('12664','2013-07-30','10:45:00',3.62),('12664','2013-07-30','10:50:00',3.6),('12664','2013-07-30','10:55:00',3.62),('12664','2013-07-30','11:00:00',3.67),('12664','2013-07-30','11:05:00',3.72),('12664','2013-07-30','11:10:00',3.78),('12664','2013-07-30','11:15:00',3.8),('12664','2013-07-30','11:20:00',3.92),('12664','2013-07-30','11:25:00',3.14),('12664','2013-07-30','11:30:00',1.08),('12664','2013-07-30','11:35:00',2.9),('12664','2013-07-30','11:40:00',2.45),('12664','2013-07-30','11:45:00',1.57),('12664','2013-07-30','11:50:00',2.13),('12664','2013-07-30','11:55:00',3.84),('12664','2013-07-30','12:00:00',4.28),('12664','2013-07-30','12:05:00',4.2),('12664','2013-07-30','12:10:00',4.25),('12664','2013-07-30','12:15:00',4.17),('12664','2013-07-30','12:20:00',4.13),('12664','2013-07-30','12:25:00',4.16),('12664','2013-07-30','12:30:00',3.84),('12664','2013-07-30','12:35:00',3.34),('12664','2013-07-30','12:40:00',3.88),('12664','2013-07-30','12:45:00',2.94),('12664','2013-07-30','12:50:00',4.31),('12664','2013-07-30','12:55:00',4.53),('12664','2013-07-30','13:00:00',2.58),('12664','2013-07-30','13:05:00',3.18),('12664','2013-07-30','13:10:00',4.4),('12664','2013-07-30','13:15:00',4.43),('12664','2013-07-30','13:20:00',4.34),('12664','2013-07-30','13:25:00',4.28),('12664','2013-07-30','13:30:00',4.24),('12664','2013-07-30','13:35:00',4.23),('12664','2013-07-30','13:40:00',2.97),('12664','2013-07-30','13:45:00',3.81),('12664','2013-07-30','13:50:00',4.3),('12664','2013-07-30','13:55:00',4.24),('12664','2013-07-30','14:00:00',4.07),('12664','2013-07-30','14:05:00',3.99),('12664','2013-07-30','14:10:00',4.1),('12664','2013-07-30','14:15:00',4.05),('12664','2013-07-30','14:20:00',3.92),('12664','2013-07-30','14:25:00',4.05),('12664','2013-07-30','14:30:00',3.92),('12664','2013-07-30','14:35:00',3.99),('12664','2013-07-30','14:40:00',3.96),('12664','2013-07-30','14:45:00',3.92),('12664','2013-07-30','14:50:00',3.85),('12664','2013-07-30','14:55:00',3.86),('12664','2013-07-30','15:00:00',3.83),('12664','2013-07-30','15:05:00',3.74),('12664','2013-07-30','15:10:00',3.7),('12664','2013-07-30','15:15:00',3.66),('12664','2013-07-30','15:20:00',3.62),('12664','2013-07-30','15:25:00',3.58),('12664','2013-07-30','15:30:00',3.52),('12664','2013-07-30','15:35:00',3.48),('12664','2013-07-30','15:40:00',3.46),('12664','2013-07-30','15:45:00',3.4),('12664','2013-07-30','15:50:00',3.34),('12664','2013-07-30','15:55:00',3.27),('12664','2013-07-30','16:00:00',3.22),('12664','2013-07-30','16:05:00',3.18),('12664','2013-07-30','16:10:00',3.11),('12664','2013-07-30','16:15:00',3.02),('12664','2013-07-30','16:20:00',2.94),('12664','2013-07-30','16:25:00',2.9),('12664','2013-07-30','16:30:00',2.82),('12664','2013-07-30','16:35:00',2.72),('12664','2013-07-30','16:40:00',2.7),('12664','2013-07-30','16:45:00',2.66),('12664','2013-07-30','16:50:00',2.54),('12664','2013-07-30','16:55:00',2.47),('12664','2013-07-30','17:00:00',2.42),('12664','2013-07-30','17:05:00',2.33),('12664','2013-07-30','17:10:00',2.26),('12664','2013-07-30','17:15:00',2.18),('12664','2013-07-30','17:20:00',2.11),('12664','2013-07-30','17:25:00',2.02),('12664','2013-07-30','17:30:00',1.94),('12664','2013-07-30','17:35:00',1.85),('12664','2013-07-30','17:40:00',1.78),('12664','2013-07-30','17:45:00',1.68),('12664','2013-07-30','17:50:00',1.59),('12664','2013-07-30','17:55:00',1.51),('12664','2013-07-30','18:00:00',1.43),('12664','2013-07-30','18:05:00',1.33),('12664','2013-07-30','18:10:00',1.25),('12664','2013-07-30','18:15:00',1.17),('12664','2013-07-30','18:20:00',1.08),('12664','2014-04-07','08:25:00',1.11),('12664','2014-04-07','08:30:00',1.05),('12664','2014-04-07','09:35:00',1.01),('12664','2014-04-07','09:40:00',1.04),('12664','2014-04-07','09:45:00',1.05),('12664','2014-04-07','09:50:00',1.06),('12664','2014-04-07','09:55:00',1.08),('12664','2014-04-07','10:00:00',1.08),('12664','2014-04-07','10:05:00',1.09),('12664','2014-04-07','10:10:00',1.12),('12664','2014-04-07','10:15:00',1.14),('12664','2014-04-07','10:20:00',1.14),('12664','2014-04-07','10:25:00',1.12),('12664','2014-04-07','10:30:00',1.14),('12664','2014-04-07','10:35:00',1.19),('12664','2014-04-07','10:40:00',1.27),('12664','2014-04-07','10:45:00',1.32),('12664','2014-04-07','10:50:00',1.35),('12664','2014-04-07','10:55:00',1.39),('12664','2014-04-07','11:00:00',1.4),('12664','2014-04-07','11:05:00',1.41),('12664','2014-04-07','11:10:00',1.46),('12664','2014-04-07','11:15:00',1.49),('12664','2014-04-07','11:20:00',1.52),('12664','2014-04-07','11:25:00',1.56),('12664','2014-04-07','11:30:00',1.46),('12664','2014-04-07','11:35:00',1.4),('12664','2014-04-07','11:40:00',1.39),('12664','2014-04-07','11:45:00',1.42),('12664','2014-04-07','11:50:00',1.53),('12664','2014-04-07','11:55:00',1.78),('12664','2014-04-07','12:00:00',2.19),('12664','2014-04-07','12:05:00',3.25),('12664','2014-04-07','12:10:00',4.07),('12664','2014-04-07','12:15:00',4.15),('12664','2014-04-07','12:20:00',3.68),('12664','2014-04-07','12:25:00',2.05),('12664','2014-04-07','12:30:00',2.5),('12664','2014-04-07','12:35:00',4.13),('12664','2014-04-07','12:40:00',4),('12664','2014-04-07','12:45:00',3.9),('12664','2014-04-07','12:50:00',3.85),('12664','2014-04-07','12:55:00',3.83),('12664','2014-04-07','13:00:00',3.84),('12664','2014-04-07','13:05:00',3.79),('12664','2014-04-07','13:10:00',3.79),('12664','2014-04-07','13:15:00',3.79),('12664','2014-04-07','13:20:00',3.78),('12664','2014-04-07','13:25:00',3.76),('12664','2014-04-07','13:30:00',3.78),('12664','2014-04-07','13:35:00',3.85),('12664','2014-04-07','13:40:00',3.82),('12664','2014-04-07','13:45:00',3.76),('12664','2014-04-07','13:50:00',3.72),('12664','2014-04-07','13:55:00',3.74),('12664','2014-04-07','14:00:00',3.7),('12664','2014-04-07','14:05:00',3.7),('12664','2014-04-07','14:10:00',3.71),('12664','2014-04-07','14:15:00',3.7),('12664','2014-04-07','14:20:00',3.68),('12664','2014-04-07','14:25:00',3.64),('12664','2014-04-07','14:30:00',3.63),('12664','2014-04-07','14:35:00',3.53),('12664','2014-04-07','14:40:00',3.45),('12664','2014-04-07','14:45:00',3.68),('12664','2014-04-07','14:50:00',3.56),('12664','2014-04-07','14:55:00',3.5),('12664','2014-04-07','15:00:00',3.48),('12664','2014-04-07','15:05:00',3.43),('12664','2014-04-07','15:10:00',3.41),('12664','2014-04-07','15:15:00',3.35),('12664','2014-04-07','15:20:00',3.28),('12664','2014-04-07','15:25:00',3.24),('12664','2014-04-07','15:30:00',3.19),('12664','2014-04-07','15:35:00',3.15),('12664','2014-04-07','15:40:00',3.09),('12664','2014-04-07','15:45:00',3.07),('12664','2014-04-07','15:50:00',3.03),('12664','2014-04-07','15:55:00',2.96),('12664','2014-04-07','16:00:00',2.94),('12664','2014-04-07','16:05:00',3.01),('12664','2014-04-07','16:10:00',2.41),('12664','2014-04-07','16:35:00',1.37),('12664','2014-04-07','16:45:00',1.95),('12664','2014-04-07','16:50:00',2.15),('12664','2014-04-07','16:55:00',2.26),('12664','2014-04-07','17:00:00',2.23),('12664','2014-04-07','17:05:00',2.29),('12664','2014-04-07','17:10:00',2.25),('12664','2014-04-07','17:15:00',2.13),('12664','2014-04-07','17:20:00',2.11),('12664','2014-04-07','17:25:00',1.9),('12664','2014-04-07','17:30:00',1.84),('12664','2014-04-07','17:35:00',1.8),('12664','2014-04-07','17:40:00',1.66),('12664','2014-04-07','17:45:00',1.41),('12664','2014-04-07','17:50:00',1.06),('12664','2013-07-29','08:00:00',1.04),('12664','2013-07-29','08:05:00',1.09),('12664','2013-07-29','08:10:00',1.17),('12664','2013-07-29','08:15:00',1.27),('12664','2013-07-29','08:20:00',1.37),('12664','2013-07-29','08:25:00',1.45),('12664','2013-07-29','08:30:00',1.54),('12664','2013-07-29','08:35:00',1.63),('12664','2013-07-29','08:40:00',1.72),('12664','2013-07-29','08:45:00',1.78),('12664','2013-07-29','08:50:00',1.86),('12664','2013-07-29','08:55:00',1.93),('12664','2013-07-29','09:00:00',2.03),('12664','2013-07-29','09:05:00',2.1),('12664','2013-07-29','09:10:00',2.17),('12664','2013-07-29','09:15:00',2.27),('12664','2013-07-29','09:20:00',2.34),('12664','2013-07-29','09:25:00',2.43),('12664','2013-07-29','09:30:00',2.5),('12664','2013-07-29','09:35:00',2.56),('12664','2013-07-29','09:40:00',2.63),('12664','2013-07-29','09:45:00',2.68),('12664','2013-07-29','09:50:00',2.76),('12664','2013-07-29','09:55:00',2.81),('12664','2013-07-29','10:00:00',2.86),('12664','2013-07-29','10:05:00',2.93),('12664','2013-07-29','10:10:00',2.99),('12664','2013-07-29','10:15:00',3),('12664','2013-07-29','10:20:00',3.06),('12664','2013-07-29','10:25:00',3.14),('12664','2013-07-29','10:30:00',3.19),('12664','2013-07-29','10:35:00',3.22),('12664','2013-07-29','10:40:00',3.25),('12664','2013-07-29','10:45:00',3.3),('12664','2013-07-29','10:50:00',3.36),('12664','2013-07-29','10:55:00',3.39),('12664','2013-07-29','11:00:00',3.44),('12664','2013-07-29','11:05:00',3.49),('12664','2013-07-29','11:10:00',3.53),('12664','2013-07-29','11:15:00',3.54),('12664','2013-07-29','11:20:00',3.59),('12664','2013-07-29','11:25:00',3.62),('12664','2013-07-29','11:30:00',3.63),('12664','2013-07-29','11:35:00',3.67),('12664','2013-07-29','11:40:00',3.68),('12664','2013-07-29','11:45:00',3.72),('12664','2013-07-29','11:50:00',3.77),('12664','2013-07-29','11:55:00',3.79),('12664','2013-07-29','12:00:00',3.78),('12664','2013-07-29','12:05:00',3.84),('12664','2013-07-29','12:10:00',3.84),('12664','2013-07-29','12:15:00',3.83),('12664','2013-07-29','12:20:00',3.88),('12664','2013-07-29','12:25:00',3.89),('12664','2013-07-29','12:30:00',3.9),('12664','2013-07-29','12:35:00',3.91),('12664','2013-07-29','12:40:00',3.92),('12664','2013-07-29','12:45:00',3.93),('12664','2013-07-29','12:50:00',3.98),('12664','2013-07-29','12:55:00',4.04),('12664','2013-07-29','13:00:00',4.05),('12664','2013-07-29','13:05:00',4.04),('12664','2013-07-29','13:10:00',4.07),('12664','2013-07-29','13:15:00',4.09),('12664','2013-07-29','13:20:00',4.1),('12664','2013-07-29','13:25:00',4.12),('12664','2013-07-29','13:30:00',4.12),('12664','2013-07-29','13:35:00',4.11),('12664','2013-07-29','13:40:00',4.07),('12664','2013-07-29','13:45:00',4.07),('12664','2013-07-29','13:50:00',4.06),('12664','2013-07-29','13:55:00',4.05),('12664','2013-07-29','14:00:00',4.04),('12664','2013-07-29','14:05:00',4.01),('12664','2013-07-29','14:10:00',4.02),('12664','2013-07-29','14:15:00',3.99),('12664','2013-07-29','14:20:00',3.95),('12664','2013-07-29','14:25:00',3.93),('12664','2013-07-29','14:30:00',3.9),('12664','2013-07-29','14:35:00',3.88),('12664','2013-07-29','14:40:00',3.85),('12664','2013-07-29','14:45:00',3.84),('12664','2013-07-29','14:50:00',3.78),('12664','2013-07-29','14:55:00',3.74),('12664','2013-07-29','15:00:00',3.71),('12664','2013-07-29','15:05:00',3.68),('12664','2013-07-29','15:10:00',3.65),('12664','2013-07-29','15:15:00',3.61),('12664','2013-07-29','15:20:00',3.57),('12664','2013-07-29','15:25:00',3.56),('12664','2013-07-29','15:30:00',3.55),('12664','2013-07-29','15:35:00',3.55),('12664','2013-07-29','15:40:00',2.59),('12664','2013-07-29','15:45:00',2.88),('12664','2013-07-29','15:50:00',2.18),('12664','2013-07-29','15:55:00',2.61),('12664','2013-07-29','16:00:00',2.94),('12664','2013-07-29','16:05:00',2.61),('12664','2013-07-29','16:10:00',2.99),('12664','2013-07-29','16:15:00',2.86),('12664','2013-07-29','16:20:00',2.25),('12664','2013-07-29','16:25:00',2.96),('12664','2013-07-29','16:30:00',3.01),('12664','2013-07-29','16:35:00',2.81),('12664','2013-07-29','16:40:00',2.59),('12664','2013-07-29','16:45:00',1.98),('12664','2013-07-29','16:50:00',1.25),('12664','2013-07-29','16:55:00',1.34),('12664','2013-07-29','17:00:00',1.89),('12664','2013-07-29','17:05:00',1.87),('12664','2013-07-29','17:10:00',2.66),('12664','2013-07-29','17:15:00',2.05),('12664','2013-07-29','17:20:00',1.76),('12664','2013-07-29','17:25:00',1.42),('12664','2013-07-29','17:35:00',1.44),('12664','2013-07-29','17:40:00',2.14),('12664','2013-07-29','17:45:00',1.79),('12664','2013-07-29','17:50:00',1.35),('12664','2013-07-29','18:00:00',1.35),('12664','2013-07-29','18:05:00',1.35),('12664','2013-07-29','18:10:00',1.34),('12664','2013-07-29','18:15:00',1.27),('12664','2013-07-29','18:20:00',1.14),('12664','2013-07-29','18:25:00',1.04),('12664','2013-07-28','08:00:00',1.04),('12664','2013-07-28','08:05:00',1.12),('12664','2013-07-28','08:10:00',1.21),('12664','2013-07-28','08:15:00',1.29),('12664','2013-07-28','08:20:00',1.37),('12664','2013-07-28','08:25:00',1.46),('12664','2013-07-28','08:30:00',1.55),('12664','2013-07-28','08:35:00',1.61),('12664','2013-07-28','08:40:00',1.7),('12664','2013-07-28','08:45:00',1.82),('12664','2013-07-28','08:50:00',1.89),('12664','2013-07-28','08:55:00',1.97),('12664','2013-07-28','09:00:00',2.06),('12664','2013-07-28','09:05:00',2.11),('12664','2013-07-28','09:10:00',2.18),('12664','2013-07-28','09:15:00',2.25),('12664','2013-07-28','09:20:00',2.34),('12664','2013-07-28','09:25:00',2.42),('12664','2013-07-28','09:30:00',2.44),('12664','2013-07-28','09:35:00',2.53),('12664','2013-07-28','09:40:00',2.61),('12664','2013-07-28','09:45:00',2.66),('12664','2013-07-28','09:50:00',2.73),('12664','2013-07-28','09:55:00',2.78),('12664','2013-07-28','10:00:00',2.86),('12664','2013-07-28','10:05:00',2.9),('12664','2013-07-28','10:10:00',2.94),('12664','2013-07-28','10:15:00',2.97),('12664','2013-07-28','10:20:00',3),('12664','2013-07-28','10:25:00',3.1),('12664','2013-07-28','10:30:00',3.16),('12664','2013-07-28','10:35:00',3.19),('12664','2013-07-28','10:40:00',3.2),('12664','2013-07-28','10:45:00',3.28),('12664','2013-07-28','10:50:00',3.3),('12664','2013-07-28','10:55:00',3.38),('12664','2013-07-28','11:00:00',3.44),('12664','2013-07-28','11:05:00',3.48),('12664','2013-07-28','11:10:00',3.5),('12664','2013-07-28','11:15:00',3.51),('12664','2013-07-28','11:20:00',3.6),('12664','2013-07-28','11:25:00',3.63),('12664','2013-07-28','11:30:00',3.65),('12664','2013-07-28','11:35:00',3.59),('12664','2013-07-28','11:40:00',3.65),('12664','2013-07-28','11:45:00',3.73),('12664','2013-07-28','11:50:00',3.8),('12664','2013-07-28','11:55:00',3.81),('12664','2013-07-28','12:00:00',3.8),('12664','2013-07-28','12:05:00',3.85),('12664','2013-07-28','12:10:00',3.85),('12664','2013-07-28','12:15:00',3.84),('12664','2013-07-28','12:20:00',3.9),('12664','2013-07-28','12:25:00',3.94),('12664','2013-07-28','12:30:00',3.91),('12664','2013-07-28','12:35:00',3.95),('12664','2013-07-28','12:40:00',4.01),('12664','2013-07-28','12:45:00',3.96),('12664','2013-07-28','12:50:00',3.99),('12664','2013-07-28','12:55:00',3.99),('12664','2013-07-28','13:00:00',4.01),('12664','2013-07-28','13:05:00',4.04),('12664','2013-07-28','13:10:00',4.02),('12664','2013-07-28','13:15:00',4.01),('12664','2013-07-28','13:20:00',4.02),('12664','2013-07-28','13:25:00',4.02),('12664','2013-07-28','13:30:00',4.05),('12664','2013-07-28','13:35:00',4.03),('12664','2013-07-28','13:40:00',4.03),('12664','2013-07-28','13:45:00',4),('12664','2013-07-28','13:50:00',4),('12664','2013-07-28','13:55:00',3.98),('12664','2013-07-28','14:00:00',3.97),('12664','2013-07-28','14:05:00',3.95),('12664','2013-07-28','14:10:00',3.95),('12664','2013-07-28','14:15:00',3.93),('12664','2013-07-28','14:20:00',3.92),('12664','2013-07-28','14:25:00',3.9),('12664','2013-07-28','14:30:00',3.89),('12664','2013-07-28','14:35:00',3.86),('12664','2013-07-28','14:40:00',3.82),('12664','2013-07-28','14:45:00',3.78),('12664','2013-07-28','14:50:00',3.74),('12664','2013-07-28','14:55:00',3.71),('12664','2013-07-28','15:00:00',3.65),('12664','2013-07-28','15:05:00',3.62),('12664','2013-07-28','15:10:00',3.6),('12664','2013-07-28','15:15:00',3.57),('12664','2013-07-28','15:20:00',3.54),('12664','2013-07-28','15:25:00',3.5),('12664','2013-07-28','15:30:00',3.47),('12664','2013-07-28','15:35:00',3.44),('12664','2013-07-28','15:40:00',3.4),('12664','2013-07-28','15:45:00',3.37),('12664','2013-07-28','15:50:00',3.32),('12664','2013-07-28','15:55:00',3.26),('12664','2013-07-28','16:00:00',3.21),('12664','2013-07-28','16:05:00',3.17),('12664','2013-07-28','16:10:00',3.11),('12664','2013-07-28','16:15:00',3.05),('12664','2013-07-28','16:20:00',2.99),('12664','2013-07-28','16:25:00',2.92),('12664','2013-07-28','16:30:00',2.86),('12664','2013-07-28','16:35:00',2.79),('12664','2013-07-28','16:40:00',2.73),('12664','2013-07-28','16:45:00',2.67),('12664','2013-07-28','16:50:00',2.58),('12664','2013-07-28','16:55:00',2.51),('12664','2013-07-28','17:00:00',2.45),('12664','2013-07-28','17:05:00',2.37),('12664','2013-07-28','17:10:00',2.29),('12664','2013-07-28','17:15:00',2.21),('12664','2013-07-28','17:20:00',2.14),('12664','2013-07-28','17:25:00',2.06),('12664','2013-07-28','17:30:00',1.98),('12664','2013-07-28','17:35:00',1.89),('12664','2013-07-28','17:40:00',1.81),('12664','2013-07-28','17:45:00',1.72),('12664','2013-07-28','17:50:00',1.63),('12664','2013-07-28','17:55:00',1.54),('12664','2013-07-28','18:00:00',1.44),('12664','2013-07-28','18:05:00',1.36),('12664','2013-07-28','18:10:00',1.28),('12664','2013-07-28','18:15:00',1.19),('12664','2013-07-28','18:20:00',1.12),('12664','2013-07-28','18:25:00',1.02),('12664','2013-07-27','08:00:00',1.07),('12664','2013-07-27','08:05:00',1.15),('12664','2013-07-27','08:10:00',1.22),('12664','2013-07-27','08:15:00',1.3),('12664','2013-07-27','08:20:00',1.4),('12664','2013-07-27','08:25:00',1.48),('12664','2013-07-27','08:30:00',1.57),('12664','2013-07-27','08:35:00',1.67),('12664','2013-07-27','08:40:00',1.76),('12664','2013-07-27','08:45:00',1.83),('12664','2013-07-27','08:50:00',1.91),('12664','2013-07-27','08:55:00',1.99),('12664','2013-07-27','09:00:00',2.07),('12664','2013-07-27','09:05:00',2.17),('12664','2013-07-27','09:10:00',2.24),('12664','2013-07-27','09:15:00',2.32),('12664','2013-07-27','09:20:00',2.41),('12664','2013-07-27','09:25:00',2.47),('12664','2013-07-27','09:30:00',2.52),('12664','2013-07-27','09:35:00',2.6),('12664','2013-07-27','09:40:00',2.66),('12664','2013-07-27','09:45:00',2.73),('12664','2013-07-27','09:50:00',2.79),('12664','2013-07-27','09:55:00',2.85),('12664','2013-07-27','10:00:00',2.94),('12664','2013-07-27','10:05:00',3),('12664','2013-07-27','10:10:00',3.06),('12664','2013-07-27','10:15:00',3.11),('12664','2013-07-27','10:20:00',3.14),('12664','2013-07-27','10:25:00',3.2),('12664','2013-07-27','10:30:00',3.22),('12664','2013-07-27','10:35:00',3.29),('12664','2013-07-27','10:40:00',3.31),('12664','2013-07-27','10:45:00',3.35),('12664','2013-07-27','10:50:00',3.4),('12664','2013-07-27','10:55:00',3.47),('12664','2013-07-27','11:00:00',3.54),('12664','2013-07-27','11:05:00',3.59),('12664','2013-07-27','11:10:00',3.6),('12664','2013-07-27','11:15:00',3.62),('12664','2013-07-27','11:20:00',3.63),('12664','2013-07-27','11:25:00',3.68),('12664','2013-07-27','11:30:00',3.7),('12664','2013-07-27','11:35:00',3.7),('12664','2013-07-27','11:40:00',3.71),('12664','2013-07-27','11:45:00',3.71),('12664','2013-07-27','11:50:00',3.71),('12664','2013-07-27','11:55:00',3.85),('12664','2013-07-27','12:00:00',3.74),('12664','2013-07-27','12:05:00',3.73),('12664','2013-07-27','12:10:00',3.93),('12664','2013-07-27','12:15:00',3.88),('12664','2013-07-27','12:20:00',3.87),('12664','2013-07-27','12:25:00',3.84),('12664','2013-07-27','12:30:00',4.05),('12664','2013-07-27','12:35:00',3.97),('12664','2013-07-27','12:40:00',3.92),('12664','2013-07-27','12:45:00',3.99),('12664','2013-07-27','12:50:00',4.06),('12664','2013-07-27','12:55:00',4.02),('12664','2013-07-27','13:00:00',4.07),('12664','2013-07-27','13:05:00',4.06),('12664','2013-07-27','13:10:00',4.05),('12664','2013-07-27','13:15:00',4.06),('12664','2013-07-27','13:20:00',4.07),('12664','2013-07-27','13:25:00',4.05),('12664','2013-07-27','13:30:00',4.01),('12664','2013-07-27','13:35:00',4.06),('12664','2013-07-27','13:40:00',4.03),('12664','2013-07-27','13:45:00',4.05),('12664','2013-07-27','13:50:00',4.03),('12664','2013-07-27','13:55:00',4),('12664','2013-07-27','14:00:00',4),('12664','2013-07-27','14:05:00',4.02),('12664','2013-07-27','14:10:00',3.99),('12664','2013-07-27','14:15:00',3.97),('12664','2013-07-27','14:20:00',3.95),('12664','2013-07-27','14:25:00',3.95),('12664','2013-07-27','14:30:00',3.89),('12664','2013-07-27','14:35:00',3.86),('12664','2013-07-27','14:40:00',3.84),('12664','2013-07-27','14:45:00',3.78),('12664','2013-07-27','14:50:00',3.78),('12664','2013-07-27','14:55:00',3.77),('12664','2013-07-27','15:00:00',3.73),('12664','2013-07-27','15:05:00',3.69),('12664','2013-07-27','15:10:00',3.67),('12664','2013-07-27','15:15:00',3.64),('12664','2013-07-27','15:20:00',3.6),('12664','2013-07-27','15:25:00',3.54),('12664','2013-07-27','15:30:00',3.48),('12664','2013-07-27','15:35:00',3.45),('12664','2013-07-27','15:40:00',3.42),('12664','2013-07-27','15:45:00',3.36),('12664','2013-07-27','15:50:00',3.3),('12664','2013-07-27','15:55:00',3.25),('12664','2013-07-27','16:00:00',3.19),('12664','2013-07-27','16:05:00',3.16),('12664','2013-07-27','16:10:00',3.1),('12664','2013-07-27','16:15:00',3.05),('12664','2013-07-27','16:20:00',2.98),('12664','2013-07-27','16:25:00',2.93),('12664','2013-07-27','16:30:00',2.87),('12664','2013-07-27','16:35:00',2.82),('12664','2013-07-27','16:40:00',2.75),('12664','2013-07-27','16:45:00',2.7),('12664','2013-07-27','16:50:00',2.61),('12664','2013-07-27','16:55:00',2.53),('12664','2013-07-27','17:00:00',2.46),('12664','2013-07-27','17:05:00',2.38),('12664','2013-07-27','17:10:00',2.31),('12664','2013-07-27','17:15:00',2.23),('12664','2013-07-27','17:20:00',2.15),('12664','2013-07-27','17:25:00',2.07),('12664','2013-07-27','17:30:00',1.97),('12664','2013-07-27','17:35:00',1.9),('12664','2013-07-27','17:40:00',1.8),('12664','2013-07-27','17:45:00',1.72),('12664','2013-07-27','17:50:00',1.64),('12664','2013-07-27','17:55:00',1.56),('12664','2013-07-27','18:00:00',1.47),('12664','2013-07-27','18:05:00',1.38),('12664','2013-07-27','18:10:00',1.3),('12664','2013-07-27','18:15:00',1.21),('12664','2013-07-27','18:20:00',1.13),('12664','2013-07-27','18:25:00',1.04),('12664','2013-07-26','08:00:00',1.08),('12664','2013-07-26','08:05:00',1.21),('12664','2013-07-26','08:10:00',1.36),('12664','2013-07-26','08:15:00',1.26),('12664','2013-07-26','08:20:00',1),('12664','2013-07-26','08:25:00',1.5),('12664','2013-07-26','08:30:00',1.68),('12664','2013-07-26','08:35:00',1.64),('12664','2013-07-26','08:40:00',1.47),('12664','2013-07-26','08:45:00',1.97),('12664','2013-07-26','08:50:00',1.78),('12664','2013-07-26','08:55:00',1.98),('12664','2013-07-26','09:00:00',1.95),('12664','2013-07-26','09:05:00',2.11),('12664','2013-07-26','09:10:00',2.24),('12664','2013-07-26','09:15:00',2.25),('12664','2013-07-26','09:20:00',2.28),('12664','2013-07-26','09:25:00',2.34),('12664','2013-07-26','09:30:00',2.5),('12664','2013-07-26','09:35:00',2.59),('12664','2013-07-26','09:40:00',2.65),('12664','2013-07-26','09:45:00',2.71),('12664','2013-07-26','09:50:00',2.79),('12664','2013-07-26','09:55:00',2.82),('12664','2013-07-26','10:00:00',2.89),('12664','2013-07-26','10:05:00',2.94),('12664','2013-07-26','10:10:00',2.97),('12664','2013-07-26','10:15:00',3.04),('12664','2013-07-26','10:20:00',3.13),('12664','2013-07-26','10:25:00',3.23),('12664','2013-07-26','10:30:00',3.22),('12664','2013-07-26','10:35:00',3.3),('12664','2013-07-26','10:40:00',3.29),('12664','2013-07-26','10:45:00',3.31),('12664','2013-07-26','10:50:00',3.46),('12664','2013-07-26','10:55:00',3.47),('12664','2013-07-26','11:00:00',3.48),('12664','2013-07-26','11:05:00',3.44),('12664','2013-07-26','11:10:00',3.58),('12664','2013-07-26','11:15:00',3.47),('12664','2013-07-26','11:20:00',3.36),('12664','2013-07-26','11:25:00',3.64),('12664','2013-07-26','11:30:00',3.68),('12664','2013-07-26','11:35:00',3.73),('12664','2013-07-26','11:40:00',3.77),('12664','2013-07-26','11:45:00',3.63),('12664','2013-07-26','11:50:00',3.92),('12664','2013-07-26','11:55:00',3.66),('12664','2013-07-26','12:00:00',2.55),('12664','2013-07-26','12:05:00',2.74),('12664','2013-07-26','12:10:00',4.27),('12664','2013-07-26','12:15:00',4.25),('12664','2013-07-26','12:20:00',4.24),('12664','2013-07-26','12:25:00',4.29),('12664','2013-07-26','12:30:00',4.17),('12664','2013-07-26','12:35:00',3.82),('12664','2013-07-26','12:40:00',3.53),('12664','2013-07-26','12:45:00',4.03),('12664','2013-07-26','12:50:00',4.25),('12664','2013-07-26','12:55:00',4.32),('12664','2013-07-26','13:00:00',4.11),('12664','2013-07-26','13:05:00',4.22),('12664','2013-07-26','13:10:00',3.71),('12664','2013-07-26','13:15:00',4.17),('12664','2013-07-26','13:20:00',4.41),('12664','2013-07-26','13:25:00',4.27),('12664','2013-07-26','13:30:00',4.16),('12664','2013-07-26','13:35:00',4.03),('12664','2013-07-26','13:40:00',3.98),('12664','2013-07-26','13:45:00',4.02),('12664','2013-07-26','13:50:00',3.56),('12664','2013-07-26','13:55:00',4.15),('12664','2013-07-26','14:00:00',3.58),('12664','2013-07-26','14:05:00',4.11),('12664','2013-07-26','14:10:00',4.07),('12664','2013-07-26','14:15:00',3.99),('12664','2013-07-26','14:20:00',4.01),('12664','2013-07-26','14:25:00',3.96),('12664','2013-07-26','14:30:00',3.96),('12664','2013-07-26','14:35:00',3.91),('12664','2013-07-26','14:40:00',3.89),('12664','2013-07-26','14:45:00',3.84),('12664','2013-07-26','14:50:00',3.82),('12664','2013-07-26','14:55:00',3.81),('12664','2013-07-26','15:00:00',3.75),('12664','2013-07-26','15:05:00',3.71),('12664','2013-07-26','15:10:00',3.66),('12664','2013-07-26','15:15:00',3.63),('12664','2013-07-26','15:20:00',3.6),('12664','2013-07-26','15:25:00',3.52),('12664','2013-07-26','15:30:00',3.48),('12664','2013-07-26','15:35:00',3.48),('12664','2013-07-26','15:40:00',3.45),('12664','2013-07-26','15:45:00',3.39),('12664','2013-07-26','15:50:00',3.33),('12664','2013-07-26','15:55:00',3.28),('12664','2013-07-26','16:00:00',3.23),('12664','2013-07-26','16:05:00',3.2),('12664','2013-07-26','16:10:00',3.13),('12664','2013-07-26','16:15:00',3.02),('12664','2013-07-26','16:20:00',2.98),('12664','2013-07-26','16:25:00',2.91),('12664','2013-07-26','16:30:00',2.83),('12664','2013-07-26','16:35:00',2.74),('12664','2013-07-26','16:40:00',2.7),('12664','2013-07-26','16:45:00',2.61),('12664','2013-07-26','16:50:00',2.51),('12664','2013-07-26','16:55:00',2.46),('12664','2013-07-26','17:00:00',2.39),('12664','2013-07-26','17:05:00',2.35),('12664','2013-07-26','17:10:00',2.28),('12664','2013-07-26','17:15:00',2.22),('12664','2013-07-26','17:20:00',2.13),('12664','2013-07-26','17:25:00',2.05),('12664','2013-07-26','17:30:00',1.96),('12664','2013-07-26','17:35:00',1.87),('12664','2013-07-26','17:40:00',1.76),('12664','2013-07-26','17:45:00',1.69),('12664','2013-07-26','17:50:00',1.59),('12664','2013-07-26','17:55:00',1.5),('12664','2013-07-26','18:00:00',1.45),('12664','2013-07-26','18:05:00',1.34),('12664','2013-07-26','18:10:00',1.27),('12664','2013-07-26','18:15:00',1.19),('12664','2013-07-26','18:20:00',1.1),('12664','2013-07-26','18:25:00',1.03),('12664','2013-07-25','08:00:00',1.07),('12664','2013-07-25','08:05:00',1.15),('12664','2013-07-25','08:10:00',1.21),('12664','2013-07-25','08:15:00',1.31),('12664','2013-07-25','08:20:00',1.39),('12664','2013-07-25','08:25:00',1.47),('12664','2013-07-25','08:30:00',1.57),('12664','2013-07-25','08:35:00',1.64),('12664','2013-07-25','08:40:00',1.72),('12664','2013-07-25','08:45:00',1.84),('12664','2013-07-25','08:50:00',1.89),('12664','2013-07-25','08:55:00',1.98),('12664','2013-07-25','09:00:00',2.11),('12664','2013-07-25','09:05:00',2.29),('12664','2013-07-25','09:10:00',2.33),('12664','2013-07-25','09:15:00',2.42),('12664','2013-07-25','09:20:00',2.38),('12664','2013-07-25','09:25:00',2.53),('12664','2013-07-25','09:30:00',1.62),('12664','2013-07-25','09:35:00',2.36),('12664','2013-07-25','09:40:00',2.73),('12664','2013-07-25','09:45:00',2.96),('12664','2013-07-25','09:50:00',2.95),('12664','2013-07-25','09:55:00',2.72),('12664','2013-07-25','10:00:00',2.4),('12664','2013-07-25','10:05:00',3.05),('12664','2013-07-25','10:10:00',3.12),('12664','2013-07-25','10:15:00',3.21),('12664','2013-07-25','10:20:00',3.32),('12664','2013-07-25','10:25:00',3.41),('12664','2013-07-25','10:30:00',3.41),('12664','2013-07-25','10:35:00',3.43),('12664','2013-07-25','10:40:00',3.31),('12664','2013-07-25','10:45:00',3.47),('12664','2013-07-25','10:50:00',3.47),('12664','2013-07-25','10:55:00',3.57),('12664','2013-07-25','11:00:00',3.64),('12664','2013-07-25','11:05:00',3.73),('12664','2013-07-25','11:10:00',3.55),('12664','2013-07-25','11:15:00',3.82),('12664','2013-07-25','11:20:00',3.46),('12664','2013-07-25','11:25:00',3.44),('12664','2013-07-25','11:30:00',3.79),('12664','2013-07-25','11:35:00',3.83),('12664','2013-07-25','11:40:00',3.83),('12664','2013-07-25','11:45:00',3.85),('12664','2013-07-25','11:50:00',3.87),('12664','2013-07-25','11:55:00',3.97),('12664','2013-07-25','12:00:00',4.04),('12664','2013-07-25','12:05:00',4.08),('12664','2013-07-25','12:10:00',1.25),('12664','2013-07-25','12:15:00',2.89),('12664','2013-07-25','12:20:00',4.17),('12664','2013-07-25','12:25:00',3.96),('12664','2013-07-25','12:30:00',4.1),('12664','2013-07-25','12:35:00',3.98),('12664','2013-07-25','12:40:00',3.92),('12664','2013-07-25','12:45:00',4.16),('12664','2013-07-25','12:50:00',4.13),('12664','2013-07-25','12:55:00',4.15),('12664','2013-07-25','13:00:00',4.17),('12664','2013-07-25','13:05:00',4.17),('12664','2013-07-25','13:10:00',4.16),('12664','2013-07-25','13:15:00',4.16),('12664','2013-07-25','13:20:00',4.19),('12664','2013-07-25','13:25:00',4.18),('12664','2013-07-25','13:30:00',4.19),('12664','2013-07-25','13:35:00',4.2),('12664','2013-07-25','13:40:00',4.22),('12664','2013-07-25','13:45:00',4.19),('12664','2013-07-25','13:50:00',4.21),('12664','2013-07-25','13:55:00',4.18),('12664','2013-07-25','14:00:00',4.2),('12664','2013-07-25','14:05:00',4.14),('12664','2013-07-25','14:10:00',4.16),('12664','2013-07-25','14:15:00',4.15),('12664','2013-07-25','14:20:00',4.11),('12664','2013-07-25','14:25:00',4.09),('12664','2013-07-25','14:30:00',4.08),('12664','2013-07-25','14:35:00',4.06),('12664','2013-07-25','14:40:00',4.02),('12664','2013-07-25','14:45:00',3.98),('12664','2013-07-25','14:50:00',3.95),('12664','2013-07-25','14:55:00',3.95),('12664','2013-07-25','15:00:00',3.89),('12664','2013-07-25','15:05:00',3.88),('12664','2013-07-25','15:10:00',3.85),('12664','2013-07-25','15:15:00',3.8),('12664','2013-07-25','15:20:00',3.77),('12664','2013-07-25','15:25:00',3.7),('12664','2013-07-25','15:30:00',3.68),('12664','2013-07-25','15:35:00',3.64),('12664','2013-07-25','15:40:00',3.59),('12664','2013-07-25','15:45:00',3.52),('12664','2013-07-25','15:50:00',3.5),('12664','2013-07-25','15:55:00',3.43),('12664','2013-07-25','16:00:00',3.37),('12664','2013-07-25','16:05:00',3.33),('12664','2013-07-25','16:10:00',3.26),('12664','2013-07-25','16:15:00',3.2),('12664','2013-07-25','16:20:00',3.15),('12664','2013-07-25','16:25:00',3.06),('12664','2013-07-25','16:30:00',2.99),('12664','2013-07-25','16:35:00',2.96),('12664','2013-07-25','16:40:00',2.89),('12664','2013-07-25','16:45:00',2.82),('12664','2013-07-25','16:50:00',2.69),('12664','2013-07-25','16:55:00',2.66),('12664','2013-07-25','17:00:00',2.59),('12664','2013-07-25','17:05:00',2.52),('12664','2013-07-25','17:10:00',2.39),('12664','2013-07-25','17:15:00',2.33),('12664','2013-07-25','17:20:00',2.24),('12664','2013-07-25','17:25:00',2.18),('12664','2013-07-25','17:30:00',2.06),('12664','2013-07-25','17:35:00',2),('12664','2013-07-25','17:40:00',1.91),('12664','2013-07-25','17:45:00',1.79),('12664','2013-07-25','17:50:00',1.71),('12664','2013-07-25','17:55:00',1.63),('12664','2013-07-25','18:00:00',1.55),('12664','2013-07-25','18:05:00',1.44),('12664','2013-07-25','18:10:00',1.37),('12664','2013-07-25','18:15:00',1.26),('12664','2013-07-25','18:20:00',1.17),('12664','2013-07-25','18:25:00',1.09),('12664','2013-07-25','18:30:00',1),('12664','2013-07-24','07:55:00',1.08),('12664','2013-07-24','08:00:00',1.34),('12664','2013-07-24','08:05:00',1.27),('12664','2013-07-24','08:10:00',1.4),('12664','2013-07-24','08:20:00',1.37),('12664','2013-07-24','08:25:00',1.22),('12664','2013-07-24','08:45:00',1.11),('12664','2013-07-24','08:50:00',1.1),('12664','2013-07-24','08:55:00',1.48),('12664','2013-07-24','09:00:00',1.52),('12664','2013-07-24','09:05:00',2.34),('12664','2013-07-24','09:10:00',2.56),('12664','2013-07-24','09:15:00',2.11),('12664','2013-07-24','09:20:00',2.32),('12664','2013-07-24','09:25:00',2.03),('12664','2013-07-24','09:30:00',1.26),('12664','2013-07-24','09:35:00',1.19),('12664','2013-07-24','09:40:00',1.3),('12664','2013-07-24','09:45:00',2.35),('12664','2013-07-24','09:50:00',2.04),('12664','2013-07-24','09:55:00',2.8),('12664','2013-07-24','10:00:00',2.6),('12664','2013-07-24','10:05:00',1.75),('12664','2013-07-24','10:10:00',1.2),('12664','2013-07-24','10:15:00',1.44),('12664','2013-07-24','10:20:00',1.57),('12664','2013-07-24','10:25:00',3.64),('12664','2013-07-24','10:30:00',3.5),('12664','2013-07-24','10:35:00',2.36),('12664','2013-07-24','10:40:00',1.83),('12664','2013-07-24','10:45:00',3.58),('12664','2013-07-24','10:50:00',2.64),('12664','2013-07-24','10:55:00',3.82),('12664','2013-07-24','11:00:00',3.83),('12664','2013-07-24','11:05:00',3.67),('12664','2013-07-24','11:10:00',3.48),('12664','2013-07-24','11:15:00',3.9),('12664','2013-07-24','11:20:00',3.6),('12664','2013-07-24','11:25:00',1.34),('12664','2013-07-24','11:30:00',3.92),('12664','2013-07-24','11:35:00',3.89),('12664','2013-07-24','11:40:00',4.01),('12664','2013-07-24','11:45:00',4.04),('12664','2013-07-24','11:50:00',4.1),('12664','2013-07-24','11:55:00',4.11),('12664','2013-07-24','12:00:00',4.07),('12664','2013-07-24','12:05:00',4.11),('12664','2013-07-24','12:10:00',4.2),('12664','2013-07-24','12:15:00',4.12),('12664','2013-07-24','12:20:00',3.96),('12664','2013-07-24','12:25:00',4.3),('12664','2013-07-24','12:30:00',4.19),('12664','2013-07-24','12:35:00',4.12),('12664','2013-07-24','12:40:00',4.22),('12664','2013-07-24','12:45:00',4.06),('12664','2013-07-24','12:50:00',4.2),('12664','2013-07-24','12:55:00',4.18),('12664','2013-07-24','13:00:00',4.24),('12664','2013-07-24','13:05:00',4.18),('12664','2013-07-24','13:10:00',4.14),('12664','2013-07-24','13:15:00',4.19),('12664','2013-07-24','13:20:00',4.19),('12664','2013-07-24','13:25:00',4.13),('12664','2013-07-24','13:30:00',4.24),('12664','2013-07-24','13:35:00',4.23),('12664','2013-07-24','13:40:00',4.21),('12664','2013-07-24','13:45:00',4.17),('12664','2013-07-24','13:50:00',4.21),('12664','2013-07-24','13:55:00',4.18),('12664','2013-07-24','14:00:00',4.17),('12664','2013-07-24','14:05:00',4.15),('12664','2013-07-24','14:10:00',4.1),('12664','2013-07-24','14:15:00',4.15),('12664','2013-07-24','14:20:00',4.13),('12664','2013-07-24','14:25:00',4.16),('12664','2013-07-24','14:30:00',4.07),('12664','2013-07-24','14:35:00',4.13),('12664','2013-07-24','14:40:00',3.96),('12664','2013-07-24','14:45:00',3.98),('12664','2013-07-24','14:50:00',3.98),('12664','2013-07-24','14:55:00',3.98),('12664','2013-07-24','15:00:00',3.96),('12664','2013-07-24','15:05:00',3.86),('12664','2013-07-24','15:10:00',3.87),('12664','2013-07-24','15:15:00',3.86),('12664','2013-07-24','15:20:00',3.65),('12664','2013-07-24','15:25:00',3.66),('12664','2013-07-24','15:30:00',3.7),('12664','2013-07-24','15:35:00',3.49),('12664','2013-07-24','15:40:00',3.2),('12664','2013-07-24','15:45:00',3.45),('12664','2013-07-24','15:50:00',3.37),('12664','2013-07-24','15:55:00',3.14),('12664','2013-07-24','16:00:00',3.38),('12664','2013-07-24','16:05:00',3.24),('12664','2013-07-24','16:10:00',3.31),('12664','2013-07-24','16:15:00',3.29),('12664','2013-07-24','16:20:00',3.27),('12664','2013-07-24','16:25:00',3.21),('12664','2013-07-24','16:30:00',3.2),('12664','2013-07-24','16:35:00',3.17),('12664','2013-07-24','16:40:00',3.11),('12664','2013-07-24','16:45:00',3.15),('12664','2013-07-24','16:50:00',3),('12664','2013-07-24','16:55:00',2.93),('12664','2013-07-24','17:00:00',2.84),('12664','2013-07-24','17:05:00',2.64),('12664','2013-07-24','17:10:00',2.51),('12664','2013-07-24','17:15:00',2.41),('12664','2013-07-24','17:20:00',2.27),('12664','2013-07-24','17:25:00',2.14),('12664','2013-07-24','17:30:00',2.1),('12664','2013-07-24','17:35:00',2),('12664','2013-07-24','17:40:00',1.9),('12664','2013-07-24','17:45:00',1.79),('12664','2013-07-24','17:50:00',1.7),('12664','2013-07-24','17:55:00',1.67),('12664','2013-07-24','18:00:00',1.57),('12664','2013-07-24','18:05:00',1.22),('12664','2013-07-24','18:10:00',1.28),('12664','2013-07-24','18:15:00',1.16),('12664','2013-07-24','18:20:00',1.16),('12664','2013-07-23','07:50:00',1.03),('12664','2013-07-23','07:55:00',1.12),('12664','2013-07-23','08:00:00',1.2),('12664','2013-07-23','08:05:00',1.28),('12664','2013-07-23','08:20:00',1.55),('12664','2013-07-23','08:25:00',1.64),('12664','2013-07-23','08:30:00',1.71),('12664','2013-07-23','08:35:00',1.77),('12664','2013-07-23','08:40:00',1.85),('12664','2013-07-23','08:45:00',1.93),('12664','2013-07-23','08:50:00',2.01),('12664','2013-07-23','08:55:00',2.08),('12664','2013-07-23','09:00:00',2.14),('12664','2013-07-23','09:05:00',2.25),('12664','2013-07-23','09:10:00',2.35),('12664','2013-07-23','09:15:00',2.41),('12664','2013-07-23','09:20:00',2.5),('12664','2013-07-23','09:25:00',2.58),('12664','2013-07-23','09:30:00',2.67),('12664','2013-07-23','09:35:00',2.73),('12664','2013-07-23','09:40:00',2.8),('12664','2013-07-23','09:45:00',2.82),('12664','2013-07-23','09:50:00',2.87),('12664','2013-07-23','09:55:00',2.93),('12664','2013-07-23','10:00:00',2.96),('12664','2013-07-23','10:05:00',3.04),('12664','2013-07-23','10:10:00',3.09),('12664','2013-07-23','10:15:00',3.12),('12664','2013-07-23','10:20:00',3.18),('12664','2013-07-23','10:25:00',3.21),('12664','2013-07-23','10:30:00',3.25),('12664','2013-07-23','10:35:00',3.29),('12664','2013-07-23','10:40:00',3.31),('12664','2013-07-23','10:45:00',3.35),('12664','2013-07-23','10:50:00',3.34),('12664','2013-07-23','10:55:00',3.37),('12664','2013-07-23','11:00:00',3.4),('12664','2013-07-23','11:05:00',3.56),('12664','2013-07-23','11:10:00',3.56),('12664','2013-07-23','11:15:00',3.56),('12664','2013-07-23','11:20:00',3.55),('12664','2013-07-23','11:25:00',3.57),('12664','2013-07-23','11:30:00',3.33),('12664','2013-07-23','11:35:00',1.23),('12664','2013-07-23','11:40:00',1.4),('12664','2013-07-23','11:45:00',2.98),('12664','2013-07-23','11:50:00',1.18),('12664','2013-07-23','11:55:00',1.38),('12664','2013-07-23','12:00:00',4.11),('12664','2013-07-23','12:05:00',4.09),('12664','2013-07-23','12:10:00',3.72),('12664','2013-07-23','12:15:00',4.15),('12664','2013-07-23','12:20:00',4.13),('12664','2013-07-23','12:25:00',1.94),('12664','2013-07-23','12:30:00',1.03),('12664','2013-07-23','12:35:00',2.32),('12664','2013-07-23','12:40:00',4.5),('12664','2013-07-23','12:45:00',4.44),('12664','2013-07-23','12:50:00',3.94),('12664','2013-07-23','12:55:00',3.97),('12664','2013-07-23','13:00:00',4.33),('12664','2013-07-23','13:05:00',4.32),('12664','2013-07-23','13:10:00',4.27),('12664','2013-07-23','13:15:00',3.86),('12664','2013-07-23','13:20:00',2.14),('12664','2013-07-23','13:25:00',4.41),('12664','2013-07-23','13:30:00',4.4),('12664','2013-07-23','13:35:00',4.34),('12664','2013-07-23','13:40:00',4.21),('12664','2013-07-23','13:45:00',4.29),('12664','2013-07-23','13:50:00',2.77),('12664','2013-07-23','13:55:00',4),('12664','2013-07-23','14:00:00',4.18),('12664','2013-07-23','14:05:00',4.44),('12664','2013-07-23','14:10:00',4.16),('12664','2013-07-23','14:15:00',4.2),('12664','2013-07-23','14:20:00',4.23),('12664','2013-07-23','14:25:00',4.13),('12664','2013-07-23','14:30:00',4.14),('12664','2013-07-23','14:35:00',4.07),('12664','2013-07-23','14:40:00',4.03),('12664','2013-07-23','14:45:00',4.01),('12664','2013-07-23','14:50:00',3.95),('12664','2013-07-23','14:55:00',3.95),('12664','2013-07-23','15:00:00',3.92),('12664','2013-07-23','15:05:00',3.86),('12664','2013-07-23','15:10:00',3.82),('12664','2013-07-23','15:15:00',3.73),('12664','2013-07-23','15:20:00',3.71),('12664','2013-07-23','15:25:00',3.63),('12664','2013-07-23','15:30:00',3.59),('12664','2013-07-23','15:35:00',3.56),('12664','2013-07-23','15:40:00',3.51),('12664','2013-07-23','15:45:00',3.48),('12664','2013-07-23','15:50:00',3.26),('12664','2013-07-23','15:55:00',3.39),('12664','2013-07-23','16:00:00',3.33),('12664','2013-07-23','16:05:00',3.28),('12664','2013-07-23','16:10:00',3.23),('12664','2013-07-23','16:15:00',3.18),('12664','2013-07-23','16:20:00',3.11),('12664','2013-07-23','16:25:00',3.04),('12664','2013-07-23','16:30:00',2.97),('12664','2013-07-23','16:35:00',2.9),('12664','2013-07-23','16:40:00',2.82),('12664','2013-07-23','16:45:00',2.75),('12664','2013-07-23','16:50:00',2.68),('12664','2013-07-23','16:55:00',2.6),('12664','2013-07-23','17:00:00',2.52),('12664','2013-07-23','17:05:00',2.46),('12664','2013-07-23','17:10:00',2.39),('12664','2013-07-23','17:15:00',2.3),('12664','2013-07-23','17:20:00',2.22),('12664','2013-07-23','17:25:00',2.12),('12664','2013-07-23','17:30:00',2.04),('12664','2013-07-23','17:35:00',1.96),('12664','2013-07-23','17:40:00',1.88),('12664','2013-07-23','17:45:00',1.79),('12664','2013-07-23','17:50:00',1.7),('12664','2013-07-23','17:55:00',1.62),('12664','2013-07-23','18:00:00',1.54),('12664','2013-07-23','18:05:00',1.46),('12664','2013-07-23','18:10:00',1.38),('12664','2013-07-23','18:15:00',1.29),('12664','2013-07-23','18:20:00',1.22),('12664','2013-07-23','18:25:00',1.13),('12664','2013-07-23','18:30:00',1.03),('12664','2013-07-22','07:50:00',1),('12664','2013-07-22','07:55:00',1.1),('12664','2013-07-22','08:00:00',1.19),('12664','2013-07-22','08:05:00',1.27),('12664','2013-07-22','08:10:00',1.36),('12664','2013-07-22','08:15:00',1.45),('12664','2013-07-22','08:20:00',1.54),('12664','2013-07-22','08:25:00',1.62),('12664','2013-07-22','08:30:00',1.7),('12664','2013-07-22','08:35:00',1.78),('12664','2013-07-22','08:40:00',1.87),('12664','2013-07-22','08:45:00',1.95),('12664','2013-07-22','08:50:00',2.05),('12664','2013-07-22','08:55:00',2.13),('12664','2013-07-22','09:00:00',2.2),('12664','2013-07-22','09:05:00',2.28),('12664','2013-07-22','09:10:00',2.36),('12664','2013-07-22','09:15:00',2.43),('12664','2013-07-22','09:20:00',2.5),('12664','2013-07-22','09:25:00',2.58),('12664','2013-07-22','09:30:00',2.67),('12664','2013-07-22','09:35:00',2.73),('12664','2013-07-22','09:40:00',2.8),('12664','2013-07-22','09:45:00',2.86),('12664','2013-07-22','09:50:00',2.93),('12664','2013-07-22','09:55:00',2.99),('12664','2013-07-22','10:00:00',3.06),('12664','2013-07-22','10:05:00',3.13),('12664','2013-07-22','10:10:00',3.19),('12664','2013-07-22','10:15:00',3.23),('12664','2013-07-22','10:20:00',3.28),('12664','2013-07-22','10:25:00',3.33),('12664','2013-07-22','10:30:00',3.38),('12664','2013-07-22','10:35:00',3.43),('12664','2013-07-22','10:40:00',3.47),('12664','2013-07-22','10:45:00',3.52),('12664','2013-07-22','10:50:00',3.54),('12664','2013-07-22','10:55:00',3.57),('12664','2013-07-22','11:00:00',3.63),('12664','2013-07-22','11:05:00',3.67),('12664','2013-07-22','11:10:00',3.71),('12664','2013-07-22','11:15:00',3.73),('12664','2013-07-22','11:20:00',3.76),('12664','2013-07-22','11:25:00',3.77),('12664','2013-07-22','11:30:00',3.8),('12664','2013-07-22','11:35:00',3.85),('12664','2013-07-22','11:40:00',3.88),('12664','2013-07-22','11:45:00',3.91),('12664','2013-07-22','11:50:00',3.94),('12664','2013-07-22','11:55:00',3.97),('12664','2013-07-22','12:00:00',3.96),('12664','2013-07-22','12:05:00',3.97),('12664','2013-07-22','12:10:00',4),('12664','2013-07-22','12:15:00',4.04),('12664','2013-07-22','12:20:00',4.07),('12664','2013-07-22','12:25:00',4.07),('12664','2013-07-22','12:30:00',4.08),('12664','2013-07-22','12:35:00',4.08),('12664','2013-07-22','12:40:00',4.04),('12664','2013-07-22','12:45:00',4.04),('12664','2013-07-22','12:50:00',4.07),('12664','2013-07-22','12:55:00',4.08),('12664','2013-07-22','13:00:00',4.11),('12664','2013-07-22','13:05:00',4.09),('12664','2013-07-22','13:10:00',4.06),('12664','2013-07-22','13:15:00',4.06),('12664','2013-07-22','13:20:00',4.08),('12664','2013-07-22','13:25:00',4.08),('12664','2013-07-22','13:30:00',4.07),('12664','2013-07-22','13:35:00',4.05),('12664','2013-07-22','13:40:00',4.1),('12664','2013-07-22','13:45:00',4.09),('12664','2013-07-22','13:50:00',4.09),('12664','2013-07-22','13:55:00',4.05),('12664','2013-07-22','14:00:00',4.01),('12664','2013-07-22','14:05:00',4.02),('12664','2013-07-22','14:10:00',4.02),('12664','2013-07-22','14:15:00',3.95),('12664','2013-07-22','14:20:00',3.93),('12664','2013-07-22','14:25:00',3.94),('12664','2013-07-22','14:30:00',3.91),('12664','2013-07-22','14:35:00',3.89),('12664','2013-07-22','14:40:00',3.93),('12664','2013-07-22','14:45:00',3.92),('12664','2013-07-22','14:50:00',3.86),('12664','2013-07-22','14:55:00',3.85),('12664','2013-07-22','15:00:00',3.81),('12664','2013-07-22','15:05:00',3.67),('12664','2013-07-22','15:10:00',3.65),('12664','2013-07-22','15:15:00',3),('12664','2013-07-22','15:20:00',3.03),('12664','2013-07-22','15:25:00',3.75),('12664','2013-07-22','15:30:00',1.39),('12664','2013-07-22','15:35:00',1.61),('12664','2013-07-22','15:40:00',1.14),('12664','2013-07-22','15:45:00',1.18),('12664','2013-07-22','15:50:00',3.09),('12664','2013-07-22','15:55:00',3),('12664','2013-07-22','16:00:00',2.62),('12664','2013-07-22','16:05:00',3.42),('12664','2013-07-22','16:10:00',3.29),('12664','2013-07-22','16:15:00',3.14),('12664','2013-07-22','16:20:00',3.05),('12664','2013-07-22','16:25:00',2.95),('12664','2013-07-22','16:30:00',2.91),('12664','2013-07-22','16:35:00',2.8),('12664','2013-07-22','16:40:00',2.46),('12664','2013-07-22','16:45:00',2),('12664','2013-07-22','16:50:00',2.62),('12664','2013-07-22','16:55:00',2.54),('12664','2013-07-22','17:00:00',2.46),('12664','2013-07-22','17:05:00',2.39),('12664','2013-07-22','17:10:00',2.33),('12664','2013-07-22','17:15:00',2.22),('12664','2013-07-22','17:20:00',2.15),('12664','2013-07-22','17:25:00',2.09),('12664','2013-07-22','17:30:00',2),('12664','2013-07-22','17:35:00',1.94),('12664','2013-07-22','17:40:00',1.86),('12664','2013-07-22','17:45:00',1.79),('12664','2013-07-22','17:50:00',1.7),('12664','2013-07-22','17:55:00',1.63),('12664','2013-07-22','18:00:00',1.58),('12664','2013-07-22','18:05:00',1.48),('12664','2013-07-22','18:10:00',1.35),('12664','2013-07-22','18:15:00',1.25),('12664','2013-07-22','18:20:00',1.06),('12664','2013-07-22','18:25:00',1.07),('12664','2013-07-22','18:30:00',1.02),('12664','2013-07-21','07:55:00',1.03),('12664','2013-07-21','08:00:00',1.11),('12664','2013-07-21','08:05:00',1.2),('12664','2013-07-21','08:10:00',1.26),('12664','2013-07-21','08:15:00',1.36),('12664','2013-07-21','08:20:00',1.45),('12664','2013-07-21','08:25:00',1.54),('12664','2013-07-21','08:30:00',1.63),('12664','2013-07-21','08:35:00',1.71),('12664','2013-07-21','08:40:00',1.8),('12664','2013-07-21','08:45:00',1.86),('12664','2013-07-21','08:50:00',1.93),('12664','2013-07-21','08:55:00',2.01),('12664','2013-07-21','09:00:00',2.1),('12664','2013-07-21','09:05:00',2.2),('12664','2013-07-21','09:10:00',2.27),('12664','2013-07-21','09:15:00',2.36),('12664','2013-07-21','09:20:00',2.44),('12664','2013-07-21','09:25:00',2.48),('12664','2013-07-21','09:30:00',2.56),('12664','2013-07-21','09:35:00',2.65),('12664','2013-07-21','09:40:00',2.7),('12664','2013-07-21','09:45:00',2.76),('12664','2013-07-21','09:50:00',2.83),('12664','2013-07-21','09:55:00',2.89),('12664','2013-07-21','10:00:00',2.94),('12664','2013-07-21','10:05:00',3),('12664','2013-07-21','10:10:00',3.07),('12664','2013-07-21','10:15:00',3.1),('12664','2013-07-21','10:20:00',3.17),('12664','2013-07-21','10:25:00',3.25),('12664','2013-07-21','10:30:00',3.29),('12664','2013-07-21','10:35:00',3.34),('12664','2013-07-21','10:40:00',3.38),('12664','2013-07-21','10:45:00',3.43),('12664','2013-07-21','10:50:00',3.49),('12664','2013-07-21','10:55:00',3.5),('12664','2013-07-21','11:00:00',3.51),('12664','2013-07-21','11:05:00',3.56),('12664','2013-07-21','11:10:00',3.58),('12664','2013-07-21','11:15:00',3.63),('12664','2013-07-21','11:20:00',3.7),('12664','2013-07-21','11:25:00',3.73),('12664','2013-07-21','11:30:00',3.76),('12664','2013-07-21','11:35:00',3.77),('12664','2013-07-21','11:40:00',3.78),('12664','2013-07-21','11:45:00',3.82),('12664','2013-07-21','11:50:00',3.86),('12664','2013-07-21','11:55:00',3.86),('12664','2013-07-21','12:00:00',3.94),('12664','2013-07-21','12:05:00',3.96),('12664','2013-07-21','12:10:00',4.12),('12664','2013-07-21','12:15:00',4.55),('12664','2013-07-21','12:20:00',3.54),('12664','2013-07-21','12:25:00',3.4),('12664','2013-07-21','12:30:00',2.47),('12664','2013-07-21','12:35:00',2.28),('12664','2013-07-21','12:40:00',2.03),('12664','2013-07-21','12:45:00',2.08),('12664','2013-07-21','12:50:00',2.12),('12664','2013-07-21','12:55:00',2.09),('12664','2013-07-21','13:00:00',1.91),('12664','2013-07-21','13:05:00',1.93),('12664','2013-07-21','13:10:00',2.08),('12664','2013-07-21','13:15:00',2.07),('12664','2013-07-21','13:20:00',2.04),('12664','2013-07-21','13:25:00',2.19),('12664','2013-07-21','13:30:00',3.43),('12664','2013-07-21','13:35:00',3.7),('12664','2013-07-21','13:40:00',3.66),('12664','2013-07-21','13:45:00',4.25),('12664','2013-07-21','13:50:00',2.55),('12664','2013-07-21','13:55:00',4.17),('12664','2013-07-21','14:00:00',2.36),('12664','2013-07-21','14:05:00',3.5),('12664','2013-07-21','14:10:00',2.53),('12664','2013-07-21','14:15:00',1.89),('12664','2013-07-21','14:20:00',1.59),('12664','2013-07-21','14:25:00',1.58),('12664','2013-07-21','14:30:00',1.36),('12664','2013-07-21','14:35:00',1.21),('12664','2013-07-21','14:40:00',1.24),('12664','2013-07-21','14:45:00',1.57),('12664','2013-07-21','14:50:00',2.96),('12664','2013-07-21','14:55:00',2.3),('12664','2013-07-21','15:00:00',1.5),('12664','2013-07-21','15:05:00',1.26),('12664','2013-07-21','15:10:00',1.23),('12664','2013-07-21','15:15:00',1.23),('12664','2013-07-21','15:20:00',1.37),('12664','2013-07-21','15:25:00',1.4),('12664','2013-07-21','15:30:00',1.52),('12664','2013-07-21','15:35:00',1.59),('12664','2013-07-21','15:40:00',2.21),('12664','2013-07-21','15:45:00',2.26),('12664','2013-07-21','15:50:00',2.92),('12664','2013-07-21','15:55:00',2.01),('12664','2013-07-21','16:00:00',1.67),('12664','2013-07-21','16:05:00',1.18),('12664','2013-07-21','16:35:00',1.13),('12664','2013-07-21','16:40:00',1.17),('12664','2013-07-21','16:45:00',1.13),('12664','2013-07-21','16:50:00',1.07),('12664','2013-07-21','16:55:00',1.05),('12664','2013-07-21','17:00:00',1.38),('12664','2013-07-21','17:05:00',2.05),('12664','2013-07-21','17:10:00',1.4),('12664','2013-07-21','17:15:00',1.02),('12664','2013-07-20','07:50:00',1.02),('12664','2013-07-20','07:55:00',1.11),('12664','2013-07-20','08:00:00',1.2),('12664','2013-07-20','08:05:00',1.29),('12664','2013-07-20','08:10:00',1.38),('12664','2013-07-20','08:15:00',1.48),('12664','2013-07-20','08:20:00',1.56),('12664','2013-07-20','08:25:00',1.65),('12664','2013-07-20','08:30:00',1.74),('12664','2013-07-20','08:35:00',1.83),('12664','2013-07-20','08:40:00',1.93),('12664','2013-07-20','08:45:00',2.03),('12664','2013-07-20','08:50:00',2.11),('12664','2013-07-20','08:55:00',2.19),('12664','2013-07-20','09:00:00',2.31),('12664','2013-07-20','09:05:00',2.42),('12664','2013-07-20','09:10:00',2.51),('12664','2013-07-20','09:15:00',2.56),('12664','2013-07-20','09:20:00',2.48),('12664','2013-07-20','09:25:00',2.56),('12664','2013-07-20','09:30:00',2.71),('12664','2013-07-20','09:35:00',2.62),('12664','2013-07-20','09:40:00',2.4),('12664','2013-07-20','09:45:00',2.65),('12664','2013-07-20','09:50:00',2.74),('12664','2013-07-20','09:55:00',3.04),('12664','2013-07-20','10:00:00',3.08),('12664','2013-07-20','10:05:00',3.11),('12664','2013-07-20','10:10:00',3.16),('12664','2013-07-20','10:15:00',3.2),('12664','2013-07-20','10:20:00',3.25),('12664','2013-07-20','10:25:00',3.31),('12664','2013-07-20','10:30:00',3.38),('12664','2013-07-20','10:35:00',3.44),('12664','2013-07-20','10:40:00',3.5),('12664','2013-07-20','10:45:00',3.54),('12664','2013-07-20','10:50:00',3.59),('12664','2013-07-20','10:55:00',3.61),('12664','2013-07-20','11:00:00',3.65),('12664','2013-07-20','11:05:00',3.68),('12664','2013-07-20','11:10:00',3.72),('12664','2013-07-20','11:15:00',3.75),('12664','2013-07-20','11:20:00',3.76),('12664','2013-07-20','11:25:00',3.81),('12664','2013-07-20','11:30:00',3.85),('12664','2013-07-20','11:35:00',3.87),('12664','2013-07-20','11:40:00',3.92),('12664','2013-07-20','11:45:00',3.93),('12664','2013-07-20','11:50:00',3.96),('12664','2013-07-20','11:55:00',3.98),('12664','2013-07-20','12:00:00',4),('12664','2013-07-20','12:05:00',4),('12664','2013-07-20','12:10:00',4.03),('12664','2013-07-20','12:15:00',4.1),('12664','2013-07-20','12:20:00',4.08),('12664','2013-07-20','12:25:00',4.09),('12664','2013-07-20','12:30:00',4.04),('12664','2013-07-20','12:35:00',4.11),('12664','2013-07-20','12:40:00',4.09),('12664','2013-07-20','12:45:00',4.09),('12664','2013-07-20','12:50:00',4.12),('12664','2013-07-20','12:55:00',4.14),('12664','2013-07-20','13:00:00',4.08),('12664','2013-07-20','13:05:00',4.09),('12664','2013-07-20','13:10:00',4.09),('12664','2013-07-20','13:15:00',4.15),('12664','2013-07-20','13:20:00',4.13),('12664','2013-07-20','13:25:00',4.18),('12664','2013-07-20','13:30:00',4.27),('12664','2013-07-20','13:35:00',4.33),('12664','2013-07-20','13:40:00',4.31),('12664','2013-07-20','13:45:00',4.16),('12664','2013-07-20','13:50:00',4.12),('12664','2013-07-20','13:55:00',4.09),('12664','2013-07-20','14:00:00',4.02),('12664','2013-07-20','14:05:00',4.05),('12664','2013-07-20','14:10:00',4.05),('12664','2013-07-20','14:15:00',4.05),('12664','2013-07-20','14:20:00',4.06),('12664','2013-07-20','14:25:00',4.01),('12664','2013-07-20','14:30:00',3.95),('12664','2013-07-20','14:35:00',3.96),('12664','2013-07-20','14:40:00',3.94),('12664','2013-07-20','14:45:00',3.93),('12664','2013-07-20','14:50:00',3.94),('12664','2013-07-20','14:55:00',3.85),('12664','2013-07-20','15:00:00',3.87),('12664','2013-07-20','15:05:00',3.82),('12664','2013-07-20','15:10:00',3.76),('12664','2013-07-20','15:15:00',3.77),('12664','2013-07-20','15:20:00',3.71),('12664','2013-07-20','15:25:00',3.68),('12664','2013-07-20','15:30:00',3.62),('12664','2013-07-20','15:35:00',3.59),('12664','2013-07-20','15:40:00',3.55),('12664','2013-07-20','15:45:00',3.51),('12664','2013-07-20','15:50:00',3.47),('12664','2013-07-20','15:55:00',3.41),('12664','2013-07-20','16:00:00',3.37),('12664','2013-07-20','16:05:00',3.29),('12664','2013-07-20','16:10:00',3.21),('12664','2013-07-20','16:15:00',3.17),('12664','2013-07-20','16:20:00',3.11),('12664','2013-07-20','16:25:00',3.06),('12664','2013-07-20','16:30:00',2.98),('12664','2013-07-20','16:35:00',2.92),('12664','2013-07-20','16:40:00',2.85),('12664','2013-07-20','16:45:00',2.77),('12664','2013-07-20','16:50:00',2.71),('12664','2013-07-20','16:55:00',2.65),('12664','2013-07-20','17:00:00',2.58),('12664','2013-07-20','17:05:00',2.48),('12664','2013-07-20','17:10:00',2.4),('12664','2013-07-20','17:15:00',2.33),('12664','2013-07-20','17:20:00',2.24),('12664','2013-07-20','17:25:00',2.16),('12664','2013-07-20','17:30:00',2.08),('12664','2013-07-20','17:35:00',2),('12664','2013-07-20','17:40:00',1.93),('12664','2013-07-20','17:45:00',1.83),('12664','2013-07-20','17:50:00',1.74),('12664','2013-07-20','17:55:00',1.64),('12664','2013-07-20','18:00:00',1.56),('12664','2013-07-20','18:05:00',1.46),('12664','2013-07-20','18:10:00',1.38),('12664','2013-07-20','18:15:00',1.31),('12664','2013-07-20','18:20:00',1.21),('12664','2013-07-20','18:25:00',1.11),('12664','2013-07-20','18:30:00',1.02),('12664','2014-04-06','08:20:00',1.09),('12664','2014-04-06','08:25:00',1.2),('12664','2014-04-06','08:30:00',1.31),('12664','2014-04-06','08:35:00',1.4),('12664','2014-04-06','08:40:00',1.5),('12664','2014-04-06','08:45:00',1.59),('12664','2014-04-06','08:50:00',1.68),('12664','2014-04-06','08:55:00',1.79),('12664','2014-04-06','09:00:00',1.87),('12664','2014-04-06','09:05:00',1.99),('12664','2014-04-06','09:10:00',2.11),('12664','2014-04-06','09:15:00',2.23),('12664','2014-04-06','09:20:00',2.35),('12664','2014-04-06','09:25:00',2.4),('12664','2014-04-06','09:30:00',2.36),('12664','2014-04-06','09:35:00',2.02),('12664','2014-04-06','09:40:00',1.92),('12664','2014-04-06','09:45:00',2.06),('12664','2014-04-06','09:50:00',1.98),('12664','2014-04-06','09:55:00',3.01),('12664','2014-04-06','10:00:00',3.73),('12664','2014-04-06','10:05:00',3.6),('12664','2014-04-06','10:10:00',3.13),('12664','2014-04-06','10:15:00',1.73),('12664','2014-04-06','10:20:00',3.15),('12664','2014-04-06','10:25:00',3.85),('12664','2014-04-06','10:30:00',4.13),('12664','2014-04-06','10:35:00',4.19),('12664','2014-04-06','10:40:00',4.21),('12664','2014-04-06','10:45:00',4.11),('12664','2014-04-06','10:50:00',4.18),('12664','2014-04-06','10:55:00',4.18),('12664','2014-04-06','11:00:00',3.96),('12664','2014-04-06','11:05:00',3.9),('12664','2014-04-06','11:10:00',3.89),('12664','2014-04-06','11:15:00',3.52),('12664','2014-04-06','11:20:00',2.68),('12664','2014-04-06','11:25:00',1.71),('12664','2014-04-06','11:30:00',2.65),('12664','2014-04-06','11:35:00',4.03),('12664','2014-04-06','11:40:00',4.23),('12664','2014-04-06','11:45:00',4.09),('12664','2014-04-06','11:50:00',4.05),('12664','2014-04-06','11:55:00',4.04),('12664','2014-04-06','12:00:00',4.07),('12664','2014-04-06','12:05:00',4.05),('12664','2014-04-06','12:10:00',4.05),('12664','2014-04-06','12:15:00',4.11),('12664','2014-04-06','12:20:00',3.97),('12664','2014-04-06','12:25:00',3.91),('12664','2014-04-06','12:30:00',4.08),('12664','2014-04-06','12:35:00',4.07),('12664','2014-04-06','12:40:00',4.11),('12664','2014-04-06','12:45:00',4.1),('12664','2014-04-06','12:50:00',4.24),('12664','2014-04-06','12:55:00',2.32),('12664','2014-04-06','13:00:00',4.23),('12664','2014-04-06','13:05:00',4.24),('12664','2014-04-06','13:10:00',4.31),('12664','2014-04-06','13:15:00',4.36),('12664','2014-04-06','13:20:00',4.33),('12664','2014-04-06','13:25:00',4.22),('12664','2014-04-06','13:30:00',4.07),('12664','2014-04-06','13:35:00',3.5),('12664','2014-04-06','13:40:00',4.11),('12664','2014-04-06','13:45:00',4.07),('12664','2014-04-06','13:50:00',4.07),('12664','2014-04-06','13:55:00',3.99),('12664','2014-04-06','14:00:00',4),('12664','2014-04-06','14:05:00',3.98),('12664','2014-04-06','14:10:00',3.99),('12664','2014-04-06','14:15:00',3.98),('12664','2014-04-06','14:20:00',3.95),('12664','2014-04-06','14:25:00',3.92),('12664','2014-04-06','14:30:00',3.78),('12664','2014-04-06','14:35:00',2.79),('12664','2014-04-06','14:40:00',4),('12664','2014-04-06','14:45:00',3.86),('12664','2014-04-06','14:50:00',3.89),('12664','2014-04-06','14:55:00',3.84),('12664','2014-04-06','15:00:00',1.85),('12664','2014-04-06','15:05:00',1.05),('12664','2014-04-06','15:20:00',1.61),('12664','2014-04-06','15:30:00',2.57),('12664','2014-04-06','16:05:00',2.68),('12664','2014-04-06','16:10:00',3.56),('12664','2014-04-06','16:15:00',2.05),('12664','2014-04-06','16:45:00',2.06),('12664','2014-04-06','16:50:00',3),('12664','2014-04-06','16:55:00',2.87),('12664','2014-04-06','17:00:00',1.85),('12664','2014-04-06','17:20:00',1.08),('12664','2014-04-06','17:25:00',1.73),('12664','2014-04-06','17:30:00',1.66),('12664','2014-04-06','17:35:00',1.57),('12664','2014-04-06','17:40:00',1.44),('12664','2014-04-06','17:45:00',1.33),('12664','2014-04-06','17:50:00',1.23),('12664','2014-04-06','17:55:00',1.11),('12664','2014-04-06','18:00:00',1.03),('12664','2013-07-19','07:55:00',1.04),('12664','2013-07-19','08:00:00',1.12),('12664','2013-07-19','08:05:00',1.2),('12664','2013-07-19','08:10:00',1.29),('12664','2013-07-19','08:15:00',1.36),('12664','2013-07-19','08:20:00',1.44),('12664','2013-07-19','08:25:00',1.53),('12664','2013-07-19','08:30:00',1.63),('12664','2013-07-19','08:35:00',1.71),('12664','2013-07-19','08:40:00',1.79),('12664','2013-07-19','08:45:00',1.87),('12664','2013-07-19','08:50:00',1.96),('12664','2013-07-19','08:55:00',2.03),('12664','2013-07-19','09:00:00',1.98),('12664','2013-07-19','09:05:00',2.18),('12664','2013-07-19','09:10:00',2.28),('12664','2013-07-19','09:15:00',2.35),('12664','2013-07-19','09:20:00',2.37),('12664','2013-07-19','09:25:00',2.47),('12664','2013-07-19','09:30:00',2.53),('12664','2013-07-19','09:35:00',2.59),('12664','2013-07-19','09:40:00',2.66),('12664','2013-07-19','09:45:00',2.71),('12664','2013-07-19','09:50:00',2.76),('12664','2013-07-19','09:55:00',2.79),('12664','2013-07-19','10:00:00',2.85),('12664','2013-07-19','10:05:00',2.92),('12664','2013-07-19','10:10:00',2.75),('12664','2013-07-19','10:15:00',3.02),('12664','2013-07-19','10:20:00',3.11),('12664','2013-07-19','10:25:00',3.18),('12664','2013-07-19','10:30:00',3.19),('12664','2013-07-19','10:35:00',3.23),('12664','2013-07-19','10:40:00',3.31),('12664','2013-07-19','10:45:00',3.38),('12664','2013-07-19','10:50:00',3.37),('12664','2013-07-19','10:55:00',3.46),('12664','2013-07-19','11:00:00',3.49),('12664','2013-07-19','11:05:00',3.55),('12664','2013-07-19','11:10:00',3.62),('12664','2013-07-19','11:15:00',3.62),('12664','2013-07-19','11:20:00',3.63),('12664','2013-07-19','11:25:00',3.6),('12664','2013-07-19','11:30:00',2.82),('12664','2013-07-19','11:35:00',3.48),('12664','2013-07-19','11:40:00',3.75),('12664','2013-07-19','11:45:00',3.83),('12664','2013-07-19','11:50:00',3.82),('12664','2013-07-19','11:55:00',3.81),('12664','2013-07-19','12:00:00',3.95),('12664','2013-07-19','12:05:00',3.95),('12664','2013-07-19','12:10:00',3.97),('12664','2013-07-19','12:15:00',3.98),('12664','2013-07-19','12:20:00',4.05),('12664','2013-07-19','12:25:00',4.05),('12664','2013-07-19','12:30:00',4.03),('12664','2013-07-19','12:35:00',4.05),('12664','2013-07-19','12:40:00',4.08),('12664','2013-07-19','12:45:00',4.11),('12664','2013-07-19','12:50:00',4.1),('12664','2013-07-19','12:55:00',4.17),('12664','2013-07-19','13:00:00',4.15),('12664','2013-07-19','13:05:00',4.24),('12664','2013-07-19','13:10:00',4.23),('12664','2013-07-19','13:15:00',4.24),('12664','2013-07-19','13:20:00',4.24),('12664','2013-07-19','13:25:00',4.23),('12664','2013-07-19','13:30:00',4.23),('12664','2013-07-19','13:35:00',4.24),('12664','2013-07-19','13:40:00',4.23),('12664','2013-07-19','13:45:00',4.25),('12664','2013-07-19','13:50:00',4.03),('12664','2013-07-19','13:55:00',3.98),('12664','2013-07-19','14:00:00',4.21),('12664','2013-07-19','14:05:00',4.2),('12664','2013-07-19','14:10:00',4.17),('12664','2013-07-19','14:15:00',4.18),('12664','2013-07-19','14:20:00',4.16),('12664','2013-07-19','14:25:00',4.12),('12664','2013-07-19','14:30:00',4.12),('12664','2013-07-19','14:35:00',4.12),('12664','2013-07-19','14:40:00',3.75),('12664','2013-07-19','14:45:00',3.49),('12664','2013-07-19','14:50:00',4),('12664','2013-07-19','14:55:00',3.78),('12664','2013-07-19','15:00:00',4.03),('12664','2013-07-19','15:05:00',3.73),('12664','2013-07-19','15:10:00',1.59),('12664','2013-07-19','15:15:00',3.01),('12664','2013-07-19','15:20:00',2.09),('12664','2013-07-19','15:25:00',3.09),('12664','2013-07-19','15:30:00',3.52),('12664','2013-07-19','15:35:00',3.85),('12664','2013-07-19','15:40:00',3.68),('12664','2013-07-19','15:45:00',3.61),('12664','2013-07-19','15:50:00',3.5),('12664','2013-07-19','15:55:00',3.42),('12664','2013-07-19','16:00:00',3.34),('12664','2013-07-19','16:05:00',3.37),('12664','2013-07-19','16:10:00',3.06),('12664','2013-07-19','16:15:00',3.19),('12664','2013-07-19','16:20:00',3.15),('12664','2013-07-19','16:25:00',3.09),('12664','2013-07-19','16:30:00',2.96),('12664','2013-07-19','16:35:00',2.91),('12664','2013-07-19','16:40:00',2.96),('12664','2013-07-19','16:45:00',2.9),('12664','2013-07-19','16:50:00',2.83),('12664','2013-07-19','16:55:00',2.78),('12664','2013-07-19','17:00:00',2.55),('12664','2013-07-19','17:05:00',1.73),('12664','2013-07-19','17:10:00',1.53),('12664','2013-07-19','17:15:00',1.45),('12664','2013-07-19','17:20:00',1.69),('12664','2013-07-19','17:25:00',1.62),('12664','2013-07-19','17:30:00',1.37),('12664','2013-07-19','17:35:00',1.37),('12664','2013-07-19','17:40:00',1.34),('12664','2013-07-19','17:45:00',1.17),('12664','2013-07-19','17:50:00',1.04),('12664','2013-07-18','07:50:00',1.04),('12664','2013-07-18','07:55:00',1.12),('12664','2013-07-18','08:00:00',1.21),('12664','2013-07-18','08:05:00',1.29),('12664','2013-07-18','08:10:00',1.38),('12664','2013-07-18','08:15:00',1.46),('12664','2013-07-18','08:20:00',1.55),('12664','2013-07-18','08:25:00',1.63),('12664','2013-07-18','08:30:00',1.72),('12664','2013-07-18','08:35:00',1.8),('12664','2013-07-18','08:40:00',1.89),('12664','2013-07-18','08:45:00',1.98),('12664','2013-07-18','08:50:00',2.07),('12664','2013-07-18','08:55:00',2.15),('12664','2013-07-18','09:00:00',2.24),('12664','2013-07-18','09:05:00',2.3),('12664','2013-07-18','09:10:00',2.39),('12664','2013-07-18','09:15:00',2.46),('12664','2013-07-18','09:20:00',2.52),('12664','2013-07-18','09:25:00',2.6),('12664','2013-07-18','09:30:00',2.67),('12664','2013-07-18','09:35:00',2.71),('12664','2013-07-18','09:40:00',2.79),('12664','2013-07-18','09:45:00',2.86),('12664','2013-07-18','09:50:00',2.93),('12664','2013-07-18','09:55:00',2.98),('12664','2013-07-18','10:00:00',3.05),('12664','2013-07-18','10:05:00',3.12),('12664','2013-07-18','10:10:00',3.17),('12664','2013-07-18','10:15:00',3.22),('12664','2013-07-18','10:20:00',3.28),('12664','2013-07-18','10:25:00',3.33),('12664','2013-07-18','10:30:00',3.39),('12664','2013-07-18','10:35:00',3.45),('12664','2013-07-18','10:40:00',3.48),('12664','2013-07-18','10:45:00',3.51),('12664','2013-07-18','10:50:00',3.51),('12664','2013-07-18','10:55:00',3.55),('12664','2013-07-18','11:00:00',3.61),('12664','2013-07-18','11:05:00',3.65),('12664','2013-07-18','11:10:00',3.65),('12664','2013-07-18','11:15:00',3.68),('12664','2013-07-18','11:20:00',3.72),('12664','2013-07-18','11:25:00',3.76),('12664','2013-07-18','11:30:00',3.78),('12664','2013-07-18','11:35:00',3.8),('12664','2013-07-18','11:40:00',3.81),('12664','2013-07-18','11:45:00',3.85),('12664','2013-07-18','11:50:00',3.89),('12664','2013-07-18','11:55:00',3.95),('12664','2013-07-18','12:00:00',3.98),('12664','2013-07-18','12:05:00',3.99),('12664','2013-07-18','12:10:00',4.02),('12664','2013-07-18','12:15:00',4.05),('12664','2013-07-18','12:20:00',4.06),('12664','2013-07-18','12:25:00',4.12),('12664','2013-07-18','12:30:00',4.12),('12664','2013-07-18','12:35:00',4.12),('12664','2013-07-18','12:40:00',4.12),('12664','2013-07-18','12:45:00',4.16),('12664','2013-07-18','12:50:00',4.16),('12664','2013-07-18','12:55:00',4.15),('12664','2013-07-18','13:00:00',4.14),('12664','2013-07-18','13:05:00',4.14),('12664','2013-07-18','13:10:00',4.12),('12664','2013-07-18','13:15:00',4.14),('12664','2013-07-18','13:20:00',4.13),('12664','2013-07-18','13:25:00',4.15),('12664','2013-07-18','13:30:00',4.18),('12664','2013-07-18','13:35:00',4.18),('12664','2013-07-18','13:40:00',4.16),('12664','2013-07-18','13:45:00',4.17),('12664','2013-07-18','13:50:00',4.21),('12664','2013-07-18','13:55:00',4.19),('12664','2013-07-18','14:00:00',4.14),('12664','2013-07-18','14:05:00',4.18),('12664','2013-07-18','14:10:00',4.14),('12664','2013-07-18','14:15:00',4.1),('12664','2013-07-18','14:20:00',4.1),('12664','2013-07-18','14:25:00',4.05),('12664','2013-07-18','14:30:00',4.03),('12664','2013-07-18','14:35:00',4),('12664','2013-07-18','14:40:00',3.98),('12664','2013-07-18','14:45:00',3.97),('12664','2013-07-18','14:50:00',3.9),('12664','2013-07-18','14:55:00',3.87),('12664','2013-07-18','15:00:00',3.82),('12664','2013-07-18','15:05:00',3.8),('12664','2013-07-18','15:10:00',3.77),('12664','2013-07-18','15:15:00',3.73),('12664','2013-07-18','15:20:00',3.68),('12664','2013-07-18','15:25:00',3.63),('12664','2013-07-18','15:30:00',3.6),('12664','2013-07-18','15:35:00',3.57),('12664','2013-07-18','15:40:00',3.54),('12664','2013-07-18','15:45:00',3.48),('12664','2013-07-18','15:50:00',3.41),('12664','2013-07-18','15:55:00',3.37),('12664','2013-07-18','16:00:00',3.3),('12664','2013-07-18','16:05:00',3.22),('12664','2013-07-18','16:10:00',3.15),('12664','2013-07-18','16:15:00',3.11),('12664','2013-07-18','16:20:00',3.06),('12664','2013-07-18','16:25:00',2.99),('12664','2013-07-18','16:30:00',2.92),('12664','2013-07-18','16:35:00',2.86),('12664','2013-07-18','16:40:00',2.79),('12664','2013-07-18','16:45:00',2.73),('12664','2013-07-18','16:50:00',2.67),('12664','2013-07-18','16:55:00',2.58),('12664','2013-07-18','17:00:00',2.48),('12664','2013-07-18','17:05:00',2.4),('12664','2013-07-18','17:10:00',2.34),('12664','2013-07-18','17:15:00',2.28),('12664','2013-07-18','17:20:00',2.17),('12664','2013-07-18','17:25:00',1.88),('12664','2013-07-18','17:30:00',1.98),('12664','2013-07-18','17:35:00',1.9),('12664','2013-07-18','17:40:00',1.8),('12664','2013-07-18','17:45:00',1.68),('12664','2013-07-18','17:50:00',1.67),('12664','2013-07-18','17:55:00',1.66),('12664','2013-07-18','18:00:00',1.44),('12664','2013-07-18','18:05:00',1.2),('12664','2013-07-18','18:10:00',1.2),('12664','2013-07-17','07:50:00',1.08),('12664','2013-07-17','07:55:00',1.18),('12664','2013-07-17','08:00:00',1.27),('12664','2013-07-17','08:05:00',1.36),('12664','2013-07-17','08:10:00',1.44),('12664','2013-07-17','08:15:00',1.52),('12664','2013-07-17','08:20:00',1.62),('12664','2013-07-17','08:25:00',1.7),('12664','2013-07-17','08:30:00',1.78),('12664','2013-07-17','08:35:00',1.88),('12664','2013-07-17','08:40:00',1.96),('12664','2013-07-17','08:45:00',2.05),('12664','2013-07-17','08:50:00',2.12),('12664','2013-07-17','08:55:00',2.19),('12664','2013-07-17','09:00:00',2.28),('12664','2013-07-17','09:05:00',2.34),('12664','2013-07-17','09:10:00',2.43),('12664','2013-07-17','09:15:00',2.5),('12664','2013-07-17','09:20:00',2.58),('12664','2013-07-17','09:25:00',2.65),('12664','2013-07-17','09:30:00',2.73),('12664','2013-07-17','09:35:00',2.79),('12664','2013-07-17','09:40:00',2.86),('12664','2013-07-17','09:45:00',2.92),('12664','2013-07-17','09:50:00',2.99),('12664','2013-07-17','09:55:00',3.05),('12664','2013-07-17','10:00:00',3.12),('12664','2013-07-17','10:05:00',3.2),('12664','2013-07-17','10:10:00',3.24),('12664','2013-07-17','10:15:00',3.3),('12664','2013-07-17','10:20:00',3.37),('12664','2013-07-17','10:25:00',3.41),('12664','2013-07-17','10:30:00',3.46),('12664','2013-07-17','10:35:00',3.54),('12664','2013-07-17','10:40:00',3.59),('12664','2013-07-17','10:45:00',3.62),('12664','2013-07-17','10:50:00',3.67),('12664','2013-07-17','10:55:00',3.7),('12664','2013-07-17','11:00:00',3.75),('12664','2013-07-17','11:05:00',3.78),('12664','2013-07-17','11:10:00',3.8),('12664','2013-07-17','11:15:00',3.86),('12664','2013-07-17','11:20:00',3.9),('12664','2013-07-17','11:25:00',3.93),('12664','2013-07-17','11:30:00',3.95),('12664','2013-07-17','11:35:00',3.99),('12664','2013-07-17','11:40:00',4),('12664','2013-07-17','11:45:00',4.04),('12664','2013-07-17','11:50:00',4.06),('12664','2013-07-17','11:55:00',4.04),('12664','2013-07-17','12:00:00',4.09),('12664','2013-07-17','12:05:00',4.11),('12664','2013-07-17','12:10:00',4.15),('12664','2013-07-17','12:15:00',4.15),('12664','2013-07-17','12:20:00',4.13),('12664','2013-07-17','12:25:00',4.16),('12664','2013-07-17','12:30:00',4.17),('12664','2013-07-17','12:35:00',4.18),('12664','2013-07-17','12:40:00',4.2),('12664','2013-07-17','12:45:00',4.23),('12664','2013-07-17','12:50:00',4.24),('12664','2013-07-17','12:55:00',4.23),('12664','2013-07-17','13:00:00',4.23),('12664','2013-07-17','13:05:00',4.2),('12664','2013-07-17','13:10:00',4.19),('12664','2013-07-17','13:15:00',4.19),('12664','2013-07-17','13:20:00',4.14),('12664','2013-07-17','13:25:00',4.12),('12664','2013-07-17','13:30:00',4.13),('12664','2013-07-17','13:35:00',4.14),('12664','2013-07-17','13:40:00',4.13),('12664','2013-07-17','13:45:00',4.11),('12664','2013-07-17','13:50:00',4.12),('12664','2013-07-17','13:55:00',4.1),('12664','2013-07-17','14:00:00',4.11),('12664','2013-07-17','14:05:00',4.1),('12664','2013-07-17','14:10:00',4.09),('12664','2013-07-17','14:15:00',4.02),('12664','2013-07-17','14:20:00',4.02),('12664','2013-07-17','14:25:00',4.03),('12664','2013-07-17','14:30:00',4.04),('12664','2013-07-17','14:35:00',3.89),('12664','2013-07-17','14:40:00',3.91),('12664','2013-07-17','14:45:00',3.94),('12664','2013-07-17','14:50:00',3.91),('12664','2013-07-17','14:55:00',3.86),('12664','2013-07-17','15:00:00',3.81),('12664','2013-07-17','15:05:00',3.8),('12664','2013-07-17','15:10:00',3.73),('12664','2013-07-17','15:15:00',3.71),('12664','2013-07-17','15:20:00',3.66),('12664','2013-07-17','15:25:00',3.61),('12664','2013-07-17','15:30:00',3.62),('12664','2013-07-17','15:35:00',3.63),('12664','2013-07-17','15:40:00',3.63),('12664','2013-07-17','15:45:00',3.55),('12664','2013-07-17','15:50:00',3.54),('12664','2013-07-17','15:55:00',3.08),('12664','2013-07-17','16:00:00',3.22),('12664','2013-07-17','16:05:00',3.3),('12664','2013-07-17','16:10:00',3.27),('12664','2013-07-17','16:15:00',3.21),('12664','2013-07-17','16:20:00',3.1),('12664','2013-07-17','16:25:00',3.07),('12664','2013-07-17','16:30:00',3.01),('12664','2013-07-17','16:35:00',2.94),('12664','2013-07-17','16:40:00',2.8),('12664','2013-07-17','16:45:00',2.76),('12664','2013-07-17','16:50:00',2.71),('12664','2013-07-17','16:55:00',2.62),('12664','2013-07-17','17:00:00',2.55),('12664','2013-07-17','17:05:00',2.46),('12664','2013-07-17','17:10:00',2.39),('12664','2013-07-17','17:15:00',2.32),('12664','2013-07-17','17:20:00',2.24),('12664','2013-07-17','17:25:00',2.17),('12664','2013-07-17','17:30:00',2.09),('12664','2013-07-17','17:35:00',2.01),('12664','2013-07-17','17:40:00',1.94),('12664','2013-07-17','17:45:00',1.84),('12664','2013-07-17','17:50:00',1.76),('12664','2013-07-17','17:55:00',1.67),('12664','2013-07-17','18:00:00',1.58),('12664','2013-07-17','18:05:00',1.5),('12664','2013-07-17','18:10:00',1.4),('12664','2013-07-17','18:15:00',1.31),('12664','2013-07-17','18:20:00',1.21),('12664','2013-07-17','18:25:00',1.11),('12664','2013-07-17','18:30:00',1.04),('12664','2013-07-16','07:50:00',1.08),('12664','2013-07-16','07:55:00',1.16),('12664','2013-07-16','08:00:00',1.24),('12664','2013-07-16','08:05:00',1.31),('12664','2013-07-16','08:10:00',1.41),('12664','2013-07-16','08:15:00',1.49),('12664','2013-07-16','08:20:00',1.58),('12664','2013-07-16','08:25:00',1.68),('12664','2013-07-16','08:30:00',1.75),('12664','2013-07-16','08:35:00',1.84),('12664','2013-07-16','08:40:00',1.92),('12664','2013-07-16','08:45:00',2.01),('12664','2013-07-16','08:50:00',2.09),('12664','2013-07-16','08:55:00',2.18),('12664','2013-07-16','09:00:00',2.26),('12664','2013-07-16','09:05:00',2.34),('12664','2013-07-16','09:10:00',2.41),('12664','2013-07-16','09:15:00',2.48),('12664','2013-07-16','09:20:00',2.54),('12664','2013-07-16','09:25:00',2.61),('12664','2013-07-16','09:30:00',2.67),('12664','2013-07-16','09:35:00',2.76),('12664','2013-07-16','09:40:00',2.83),('12664','2013-07-16','09:45:00',2.88),('12664','2013-07-16','09:50:00',2.93),('12664','2013-07-16','09:55:00',2.99),('12664','2013-07-16','10:00:00',3.04),('12664','2013-07-16','10:05:00',3.12),('12664','2013-07-16','10:10:00',3.16),('12664','2013-07-16','10:15:00',3.2),('12664','2013-07-16','10:20:00',3.26),('12664','2013-07-16','10:25:00',3.32),('12664','2013-07-16','10:30:00',3.37),('12664','2013-07-16','10:35:00',3.4),('12664','2013-07-16','10:40:00',3.43),('12664','2013-07-16','10:45:00',3.5),('12664','2013-07-16','10:50:00',3.55),('12664','2013-07-16','10:55:00',3.61),('12664','2013-07-16','11:00:00',3.64),('12664','2013-07-16','11:05:00',3.7),('12664','2013-07-16','11:10:00',3.74),('12664','2013-07-16','11:15:00',3.77),('12664','2013-07-16','11:20:00',3.8),('12664','2013-07-16','11:25:00',3.84),('12664','2013-07-16','11:30:00',3.89),('12664','2013-07-16','11:35:00',3.92),('12664','2013-07-16','11:40:00',3.97),('12664','2013-07-16','11:45:00',3.97),('12664','2013-07-16','11:50:00',3.95),('12664','2013-07-16','11:55:00',3.98),('12664','2013-07-16','12:00:00',4),('12664','2013-07-16','12:05:00',4.05),('12664','2013-07-16','12:10:00',4.08),('12664','2013-07-16','12:15:00',4.11),('12664','2013-07-16','12:20:00',4.14),('12664','2013-07-16','12:25:00',4.16),('12664','2013-07-16','12:30:00',4.14),('12664','2013-07-16','12:35:00',4.12),('12664','2013-07-16','12:40:00',4.16),('12664','2013-07-16','12:45:00',4.2),('12664','2013-07-16','12:50:00',4.21),('12664','2013-07-16','12:55:00',4.2),('12664','2013-07-16','13:00:00',4.19),('12664','2013-07-16','13:05:00',4.21),('12664','2013-07-16','13:10:00',4.2),('12664','2013-07-16','13:15:00',4.18),('12664','2013-07-16','13:20:00',4.16),('12664','2013-07-16','13:25:00',4.18),('12664','2013-07-16','13:30:00',4.15),('12664','2013-07-16','13:35:00',4.14),('12664','2013-07-16','13:40:00',4.18),('12664','2013-07-16','13:45:00',4.12),('12664','2013-07-16','13:50:00',4.09),('12664','2013-07-16','13:55:00',4.09),('12664','2013-07-16','14:00:00',4.09),('12664','2013-07-16','14:05:00',4.06),('12664','2013-07-16','14:10:00',4.06),('12664','2013-07-16','14:15:00',4.03),('12664','2013-07-16','14:20:00',4.03),('12664','2013-07-16','14:25:00',3.98),('12664','2013-07-16','14:30:00',3.92),('12664','2013-07-16','14:35:00',3.06),('12664','2013-07-16','14:40:00',3.09),('12664','2013-07-16','14:45:00',3.21),('12664','2013-07-16','14:50:00',3.99),('12664','2013-07-16','14:55:00',3.88),('12664','2013-07-16','15:00:00',3.83),('12664','2013-07-16','15:05:00',3.76),('12664','2013-07-16','15:10:00',3.7),('12664','2013-07-16','15:15:00',3.7),('12664','2013-07-16','15:20:00',3.64),('12664','2013-07-16','15:25:00',3.61),('12664','2013-07-16','15:30:00',3.57),('12664','2013-07-16','15:35:00',3.52),('12664','2013-07-16','15:40:00',3.52),('12664','2013-07-16','15:45:00',3.49),('12664','2013-07-16','15:50:00',3.45),('12664','2013-07-16','15:55:00',3.39),('12664','2013-07-16','16:00:00',3.37),('12664','2013-07-16','16:05:00',3.29),('12664','2013-07-16','16:10:00',2.49),('12664','2013-07-16','16:15:00',2.06),('12664','2013-07-16','16:20:00',2.93),('12664','2013-07-16','16:25:00',3.02),('12664','2013-07-16','16:30:00',3.06),('12664','2013-07-16','16:35:00',2.96),('12664','2013-07-16','16:40:00',2.9),('12664','2013-07-16','16:45:00',2.89),('12664','2013-07-16','16:50:00',2.77),('12664','2013-07-16','16:55:00',1.35),('12664','2013-07-16','17:00:00',2.62),('12664','2013-07-16','17:05:00',2.41),('12664','2013-07-16','17:10:00',2.24),('12664','2013-07-16','17:15:00',2.3),('12664','2013-07-16','17:20:00',2.14),('12664','2013-07-16','17:25:00',2.19),('12664','2013-07-16','17:30:00',2.14),('12664','2013-07-16','17:35:00',1.81),('12664','2013-07-16','17:40:00',1.87),('12664','2013-07-16','17:45:00',1.85),('12664','2013-07-16','17:50:00',1.77),('12664','2013-07-16','17:55:00',1.16),('12664','2013-07-16','18:00:00',1.39),('12664','2013-07-16','18:05:00',1.52),('12664','2013-07-16','18:30:00',1.05),('12664','2013-07-15','07:45:00',1.02),('12664','2013-07-15','07:50:00',1.11),('12664','2013-07-15','07:55:00',1.19),('12664','2013-07-15','08:00:00',1.28),('12664','2013-07-15','08:05:00',1.38),('12664','2013-07-15','08:10:00',1.47),('12664','2013-07-15','08:15:00',1.56),('12664','2013-07-15','08:20:00',1.65),('12664','2013-07-15','08:25:00',1.73),('12664','2013-07-15','08:30:00',1.83),('12664','2013-07-15','08:35:00',1.91),('12664','2013-07-15','08:40:00',2),('12664','2013-07-15','08:45:00',2.07),('12664','2013-07-15','08:50:00',2.16),('12664','2013-07-15','08:55:00',2.24),('12664','2013-07-15','09:00:00',2.33),('12664','2013-07-15','09:05:00',2.41),('12664','2013-07-15','09:10:00',2.49),('12664','2013-07-15','09:15:00',2.57),('12664','2013-07-15','09:20:00',2.64),('12664','2013-07-15','09:25:00',2.71),('12664','2013-07-15','09:30:00',2.76),('12664','2013-07-15','09:35:00',2.83),('12664','2013-07-15','09:40:00',2.9),('12664','2013-07-15','09:45:00',2.95),('12664','2013-07-15','09:50:00',3.02),('12664','2013-07-15','09:55:00',3.09),('12664','2013-07-15','10:00:00',3.14),('12664','2013-07-15','10:05:00',3.18),('12664','2013-07-15','10:10:00',3.24),('12664','2013-07-15','10:15:00',3.3),('12664','2013-07-15','10:20:00',3.34),('12664','2013-07-15','10:25:00',3.38),('12664','2013-07-15','10:30:00',3.43),('12664','2013-07-15','10:35:00',3.49),('12664','2013-07-15','10:40:00',3.53),('12664','2013-07-15','10:45:00',3.56),('12664','2013-07-15','10:50:00',3.61),('12664','2013-07-15','10:55:00',3.68),('12664','2013-07-15','11:00:00',3.71),('12664','2013-07-15','11:05:00',3.77),('12664','2013-07-15','11:10:00',3.82),('12664','2013-07-15','11:15:00',3.85),('12664','2013-07-15','11:20:00',3.88),('12664','2013-07-15','11:25:00',3.92),('12664','2013-07-15','11:30:00',3.95),('12664','2013-07-15','11:35:00',4.01),('12664','2013-07-15','11:40:00',4.01),('12664','2013-07-15','11:45:00',4.02),('12664','2013-07-15','11:50:00',4.04),('12664','2013-07-15','11:55:00',4.07),('12664','2013-07-15','12:00:00',4.09),('12664','2013-07-15','12:05:00',4.06),('12664','2013-07-15','12:10:00',4.08),('12664','2013-07-15','12:15:00',4.1),('12664','2013-07-15','12:20:00',4.11),('12664','2013-07-15','12:25:00',4.1),('12664','2013-07-15','12:30:00',4.11),('12664','2013-07-15','12:35:00',4.13),('12664','2013-07-15','12:40:00',4.15),('12664','2013-07-15','12:45:00',4.17),('12664','2013-07-15','12:50:00',4.13),('12664','2013-07-15','12:55:00',4.15),('12664','2013-07-15','13:00:00',4.15),('12664','2013-07-15','13:05:00',4.19),('12664','2013-07-15','13:10:00',4.18),('12664','2013-07-15','13:15:00',4.2),('12664','2013-07-15','13:20:00',4.21),('12664','2013-07-15','13:25:00',4.25),('12664','2013-07-15','13:30:00',4.24),('12664','2013-07-15','13:35:00',4.21),('12664','2013-07-15','13:40:00',4.18),('12664','2013-07-15','13:45:00',4.17),('12664','2013-07-15','13:50:00',4.21),('12664','2013-07-15','13:55:00',4.19),('12664','2013-07-15','14:00:00',4.2),('12664','2013-07-15','14:05:00',4.23),('12664','2013-07-15','14:10:00',4.23),('12664','2013-07-15','14:15:00',4.25),('12664','2013-07-15','14:20:00',4.21),('12664','2013-07-15','14:25:00',4.18),('12664','2013-07-15','14:30:00',4.06),('12664','2013-07-15','14:35:00',4.05),('12664','2013-07-15','14:40:00',4.02),('12664','2013-07-15','14:45:00',3.98),('12664','2013-07-15','14:50:00',3.9),('12664','2013-07-15','14:55:00',3.87),('12664','2013-07-15','15:00:00',3.84),('12664','2013-07-15','15:05:00',3.83),('12664','2013-07-15','15:10:00',3.82),('12664','2013-07-15','15:15:00',3.79),('12664','2013-07-15','15:20:00',3.67),('12664','2013-07-15','15:25:00',3.62),('12664','2013-07-15','15:30:00',3.6),('12664','2013-07-15','15:35:00',3.63),('12664','2013-07-15','15:40:00',3.3),('12664','2013-07-15','15:45:00',3.43),('12664','2013-07-15','15:50:00',3.46),('12664','2013-07-15','15:55:00',3.41),('12664','2013-07-15','16:00:00',3.36),('12664','2013-07-15','16:05:00',3.29),('12664','2013-07-15','16:10:00',3.22),('12664','2013-07-15','16:15:00',3.14),('12664','2013-07-15','16:20:00',3.08),('12664','2013-07-15','16:25:00',3.01),('12664','2013-07-15','16:30:00',2.87),('12664','2013-07-15','16:35:00',2.78),('12664','2013-07-15','16:40:00',2.73),('12664','2013-07-15','16:45:00',2.67),('12664','2013-07-15','16:50:00',2.63),('12664','2013-07-15','16:55:00',2.59),('12664','2013-07-15','17:00:00',2.53),('12664','2013-07-15','17:05:00',2.46),('12664','2013-07-15','17:10:00',2.38),('12664','2013-07-15','17:15:00',2.3),('12664','2013-07-15','17:20:00',2.22),('12664','2013-07-15','17:25:00',2.14),('12664','2013-07-15','17:30:00',2.05),('12664','2013-07-15','17:35:00',1.95),('12664','2013-07-15','17:40:00',1.88),('12664','2013-07-15','17:45:00',1.8),('12664','2013-07-15','17:50:00',1.68),('12664','2013-07-15','17:55:00',1.63),('12664','2013-07-15','18:00:00',1.54),('12664','2013-07-15','18:05:00',1.43),('12664','2013-07-15','18:10:00',1.36),('12664','2013-07-15','18:15:00',1.29),('12664','2013-07-15','18:20:00',1.22),('12664','2013-07-15','18:25:00',1.14),('12664','2013-07-15','18:30:00',1.06),('12664','2013-07-14','07:50:00',1.03),('12664','2013-07-14','07:55:00',1.23),('12664','2013-07-14','08:00:00',1.21),('12664','2013-07-14','08:05:00',1.6),('12664','2013-07-14','08:10:00',1.8),('12664','2013-07-14','08:15:00',1.49),('12664','2013-07-14','08:20:00',1.31),('12664','2013-07-14','08:25:00',1.03),('12664','2013-07-14','08:30:00',1.45),('12664','2013-07-14','08:35:00',1.23),('12664','2013-07-14','08:40:00',1),('12664','2013-07-14','08:45:00',1.02),('12664','2013-07-14','08:50:00',1.02),('12664','2013-07-14','08:55:00',1.13),('12664','2013-07-14','09:00:00',1.08),('12664','2013-07-14','09:05:00',1.26),('12664','2013-07-14','09:10:00',1.37),('12664','2013-07-14','09:15:00',2.05),('12664','2013-07-14','09:20:00',2.59),('12664','2013-07-14','09:25:00',1.31),('12664','2013-07-14','09:30:00',1.46),('12664','2013-07-14','09:35:00',1.5),('12664','2013-07-14','09:40:00',1.56),('12664','2013-07-14','09:45:00',1.74),('12664','2013-07-14','09:50:00',1.78),('12664','2013-07-14','09:55:00',1.6),('12664','2013-07-14','10:00:00',1.7),('12664','2013-07-14','10:05:00',1.37),('12664','2013-07-14','10:10:00',1.71),('12664','2013-07-14','10:15:00',2.61),('12664','2013-07-14','10:20:00',3.3),('12664','2013-07-14','10:25:00',2.86),('12664','2013-07-14','10:30:00',2.69),('12664','2013-07-14','10:35:00',3),('12664','2013-07-14','10:40:00',2.59),('12664','2013-07-14','10:45:00',2.87),('12664','2013-07-14','10:50:00',3.62),('12664','2013-07-14','10:55:00',3.92),('12664','2013-07-14','11:00:00',3.6),('12664','2013-07-14','11:05:00',3.41),('12664','2013-07-14','11:10:00',2.98),('12664','2013-07-14','11:15:00',3.09),('12664','2013-07-14','11:20:00',2.94),('12664','2013-07-14','11:25:00',4.17),('12664','2013-07-14','11:30:00',4.21),('12664','2013-07-14','11:35:00',3.13),('12664','2013-07-14','11:40:00',4.18),('12664','2013-07-14','11:45:00',4.23),('12664','2013-07-14','11:50:00',4.25),('12664','2013-07-14','11:55:00',4.12),('12664','2013-07-14','12:00:00',1.79),('12664','2013-07-14','12:05:00',1.16),('12664','2013-07-14','12:10:00',1.27),('12664','2013-07-14','12:15:00',3.51),('12664','2013-07-14','12:20:00',4.58),('12664','2013-07-14','12:25:00',4.58),('12664','2013-07-14','12:30:00',4.42),('12664','2013-07-14','12:35:00',1.44),('12664','2013-07-14','12:40:00',4.59),('12664','2013-07-14','12:45:00',4.61),('12664','2013-07-14','12:50:00',4.38),('12664','2013-07-14','12:55:00',4.47),('12664','2013-07-14','13:00:00',4.44),('12664','2013-07-14','13:05:00',4.23),('12664','2013-07-14','13:10:00',4.27),('12664','2013-07-14','13:15:00',4.27),('12664','2013-07-14','13:20:00',4.29),('12664','2013-07-14','13:25:00',4.33),('12664','2013-07-14','13:30:00',4.32),('12664','2013-07-14','13:35:00',4.33),('12664','2013-07-14','13:40:00',4.35),('12664','2013-07-14','13:45:00',4.36),('12664','2013-07-14','13:50:00',4.37),('12664','2013-07-14','13:55:00',4.36),('12664','2013-07-14','14:00:00',4.37),('12664','2013-07-14','14:05:00',4.38),('12664','2013-07-14','14:10:00',4.39),('12664','2013-07-14','14:15:00',4.31),('12664','2013-07-14','14:20:00',4.24),('12664','2013-07-14','14:25:00',4.21),('12664','2013-07-14','14:30:00',4.18),('12664','2013-07-14','14:35:00',4.11),('12664','2013-07-14','14:40:00',4.1),('12664','2013-07-14','14:45:00',4.07),('12664','2013-07-14','14:50:00',4.01),('12664','2013-07-14','14:55:00',3.99),('12664','2013-07-14','15:00:00',4),('12664','2013-07-14','15:05:00',3.97),('12664','2013-07-14','15:10:00',3.9),('12664','2013-07-14','15:15:00',3.89),('12664','2013-07-14','15:20:00',3.83),('12664','2013-07-14','15:25:00',3.81),('12664','2013-07-14','15:30:00',3.77),('12664','2013-07-14','15:35:00',3.72),('12664','2013-07-14','15:40:00',3.67),('12664','2013-07-14','15:45:00',3.55),('12664','2013-07-14','15:50:00',3.52),('12664','2013-07-14','15:55:00',3.48),('12664','2013-07-14','16:00:00',3.35),('12664','2013-07-14','16:05:00',3.14),('12664','2013-07-14','16:10:00',2.53),('12664','2013-07-14','16:15:00',2.76),('12664','2013-07-14','16:20:00',3.25),('12664','2013-07-14','16:25:00',2.93),('12664','2013-07-14','16:30:00',2.01),('12664','2013-07-14','16:35:00',2.2),('12664','2013-07-14','16:40:00',3.1),('12664','2013-07-14','16:45:00',2.36),('12664','2013-07-14','16:50:00',3.06),('12664','2013-07-14','16:55:00',2.05),('12664','2013-07-14','17:00:00',1.88),('12664','2013-07-14','17:05:00',2.4),('12664','2013-07-14','17:15:00',1.63),('12664','2013-07-14','17:20:00',1.75),('12664','2013-07-14','17:25:00',2.42),('12664','2013-07-14','17:30:00',1.61),('12664','2013-07-14','17:35:00',2.3),('12664','2013-07-14','17:40:00',2.19),('12664','2013-07-14','17:45:00',1.55),('12664','2013-07-14','17:50:00',1.6),('12664','2013-07-14','17:55:00',1.02),('12664','2013-07-14','18:30:00',1.01),('12664','2013-07-13','07:50:00',1.06),('12664','2013-07-13','07:55:00',1.12),('12664','2013-07-13','08:00:00',1.18),('12664','2013-07-13','08:05:00',1.28),('12664','2013-07-13','08:10:00',1.38),('12664','2013-07-13','08:15:00',1.46),('12664','2013-07-13','08:20:00',1.53),('12664','2013-07-13','08:25:00',1.63),('12664','2013-07-13','08:30:00',1.73),('12664','2013-07-13','08:35:00',1.83),('12664','2013-07-13','08:40:00',1.92),('12664','2013-07-13','08:45:00',2),('12664','2013-07-13','08:50:00',2.08),('12664','2013-07-13','08:55:00',2.14),('12664','2013-07-13','09:00:00',2.24),('12664','2013-07-13','09:05:00',2.27),('12664','2013-07-13','09:10:00',2.4),('12664','2013-07-13','09:15:00',2.43),('12664','2013-07-13','09:20:00',2.49),('12664','2013-07-13','09:25:00',2.51),('12664','2013-07-13','09:30:00',2.68),('12664','2013-07-13','09:35:00',2.71),('12664','2013-07-13','09:40:00',2.75),('12664','2013-07-13','09:45:00',2.83),('12664','2013-07-13','09:50:00',2.93),('12664','2013-07-13','09:55:00',2.97),('12664','2013-07-13','10:00:00',2.92),('12664','2013-07-13','10:05:00',3.02),('12664','2013-07-13','10:10:00',2.6),('12664','2013-07-13','10:15:00',3.17),('12664','2013-07-13','10:20:00',3.36),('12664','2013-07-13','10:25:00',3.51),('12664','2013-07-13','10:30:00',3.49),('12664','2013-07-13','10:35:00',3.5),('12664','2013-07-13','10:40:00',3.68),('12664','2013-07-13','10:45:00',3.73),('12664','2013-07-13','10:50:00',3.01),('12664','2013-07-13','10:55:00',1.77),('12664','2013-07-13','11:00:00',3.97),('12664','2013-07-13','11:05:00',4.21),('12664','2013-07-13','11:10:00',3.07),('12664','2013-07-13','11:15:00',1.68),('12664','2013-07-13','11:20:00',1.69),('12664','2013-07-13','11:25:00',1.6),('12664','2013-07-13','11:30:00',1.81),('12664','2013-07-13','11:35:00',4.03),('12664','2013-07-13','11:40:00',1.36),('12664','2013-07-13','11:45:00',4.31),('12664','2013-07-13','11:50:00',3.97),('12664','2013-07-13','11:55:00',1.35),('12664','2013-07-13','12:00:00',4.09),('12664','2013-07-13','12:05:00',2.09),('12664','2013-07-13','12:10:00',3.51),('12664','2013-07-13','12:15:00',2.19),('12664','2013-07-13','12:20:00',3.36),('12664','2013-07-13','12:25:00',4.45),('12664','2013-07-13','12:30:00',4.45),('12664','2013-07-13','12:35:00',3.42),('12664','2013-07-13','12:40:00',4.15),('12664','2013-07-13','12:45:00',4.13),('12664','2013-07-13','12:50:00',3.97),('12664','2013-07-13','12:55:00',4.27),('12664','2013-07-13','13:00:00',4.25),('12664','2013-07-13','13:05:00',4.33),('12664','2013-07-13','13:10:00',3.83),('12664','2013-07-13','13:15:00',4.37),('12664','2013-07-13','13:20:00',4.16),('12664','2013-07-13','13:25:00',4.28),('12664','2013-07-13','13:30:00',4.31),('12664','2013-07-13','13:35:00',4.3),('12664','2013-07-13','13:40:00',4.29),('12664','2013-07-13','13:45:00',4.32),('12664','2013-07-13','13:50:00',4.3),('12664','2013-07-13','13:55:00',4.29),('12664','2013-07-13','14:00:00',4.28),('12664','2013-07-13','14:05:00',4.24),('12664','2013-07-13','14:10:00',4.25),('12664','2013-07-13','14:15:00',4.26),('12664','2013-07-13','14:20:00',4.24),('12664','2013-07-13','14:25:00',4.2),('12664','2013-07-13','14:30:00',4.2),('12664','2013-07-13','14:35:00',4.13),('12664','2013-07-13','14:40:00',4.11),('12664','2013-07-13','14:45:00',4.09),('12664','2013-07-13','14:50:00',4.08),('12664','2013-07-13','14:55:00',4.07),('12664','2013-07-13','15:00:00',4.06),('12664','2013-07-13','15:05:00',4.05),('12664','2013-07-13','15:10:00',4),('12664','2013-07-13','15:15:00',3.78),('12664','2013-07-13','15:20:00',3.9),('12664','2013-07-13','15:25:00',3.87),('12664','2013-07-13','15:30:00',3.81),('12664','2013-07-13','15:35:00',3.79),('12664','2013-07-13','15:40:00',3.71),('12664','2013-07-13','15:45:00',3.65),('12664','2013-07-13','15:50:00',3.58),('12664','2013-07-13','15:55:00',3.53),('12664','2013-07-13','16:00:00',3.49),('12664','2013-07-13','16:05:00',3.45),('12664','2013-07-13','16:10:00',3.35),('12664','2013-07-13','16:15:00',3.26),('12664','2013-07-13','16:20:00',3.26),('12664','2013-07-13','16:25:00',3.16),('12664','2013-07-13','16:30:00',3.1),('12664','2013-07-13','16:35:00',3.05),('12664','2013-07-13','16:40:00',3.01),('12664','2013-07-13','16:45:00',2.92),('12664','2013-07-13','16:50:00',2.84),('12664','2013-07-13','16:55:00',2.76),('12664','2013-07-13','17:00:00',2.65),('12664','2013-07-13','17:05:00',2.51),('12664','2013-07-13','17:10:00',2.54),('12664','2013-07-13','17:15:00',2.46),('12664','2013-07-13','17:20:00',2.35),('12664','2013-07-13','17:25:00',2.33),('12664','2013-07-13','17:30:00',2.17),('12664','2013-07-13','17:35:00',2.13),('12664','2013-07-13','17:40:00',2.02),('12664','2013-07-13','17:45:00',1.94),('12664','2013-07-13','17:50:00',1.89),('12664','2013-07-13','17:55:00',1.81),('12664','2013-07-13','18:00:00',1.7),('12664','2013-07-13','18:05:00',1.6),('12664','2013-07-13','18:10:00',1.51),('12664','2013-07-13','18:15:00',1.39),('12664','2013-07-13','18:20:00',1.34),('12664','2013-07-13','18:25:00',1.25),('12664','2013-07-13','18:30:00',1.11),('12664','2013-07-12','08:05:00',1.35),('12664','2013-07-12','08:10:00',1.02),('12664','2013-07-12','08:20:00',1.3),('12664','2013-07-12','08:25:00',1.67),('12664','2013-07-12','08:30:00',1.11),('12664','2013-07-12','08:55:00',1.32),('12664','2013-07-12','09:00:00',1.5),('12664','2013-07-12','09:05:00',1.09),('12664','2013-07-12','09:15:00',1.37),('12664','2013-07-12','09:20:00',2.15),('12664','2013-07-12','09:25:00',1.59),('12664','2013-07-12','09:30:00',2.78),('12664','2013-07-12','09:35:00',2.8),('12664','2013-07-12','09:40:00',2.97),('12664','2013-07-12','09:45:00',2.9),('12664','2013-07-12','09:50:00',3.05),('12664','2013-07-12','09:55:00',2.55),('12664','2013-07-12','10:00:00',2.13),('12664','2013-07-12','10:05:00',2.26),('12664','2013-07-12','10:10:00',3.32),('12664','2013-07-12','10:15:00',3.27),('12664','2013-07-12','10:20:00',3.4),('12664','2013-07-12','10:25:00',3.54),('12664','2013-07-12','10:30:00',3.44),('12664','2013-07-12','10:35:00',2.23),('12664','2013-07-12','10:40:00',1.48),('12664','2013-07-12','10:45:00',3.76),('12664','2013-07-12','10:50:00',3.3),('12664','2013-07-12','10:55:00',2.89),('12664','2013-07-12','11:00:00',1.19),('12664','2013-07-12','11:05:00',1.8),('12664','2013-07-12','11:10:00',4.32),('12664','2013-07-12','11:15:00',2.48),('12664','2013-07-12','11:20:00',3.83),('12664','2013-07-12','11:25:00',2.49),('12664','2013-07-12','11:30:00',2.58),('12664','2013-07-12','11:35:00',4.13),('12664','2013-07-12','11:40:00',3.07),('12664','2013-07-12','11:45:00',4.23),('12664','2013-07-12','11:50:00',3.29),('12664','2013-07-12','11:55:00',2.35),('12664','2013-07-12','12:00:00',4.33),('12664','2013-07-12','12:05:00',4.38),('12664','2013-07-12','12:10:00',4.35),('12664','2013-07-12','12:15:00',4.35),('12664','2013-07-12','12:20:00',4.32),('12664','2013-07-12','12:25:00',3.87),('12664','2013-07-12','12:30:00',3.24),('12664','2013-07-12','12:35:00',2.59),('12664','2013-07-12','12:40:00',3.15),('12664','2013-07-12','12:45:00',4.63),('12664','2013-07-12','12:50:00',4.57),('12664','2013-07-12','12:55:00',4.39),('12664','2013-07-12','13:00:00',4.49),('12664','2013-07-12','13:05:00',4.46),('12664','2013-07-12','13:10:00',3.48),('12664','2013-07-12','13:15:00',3.01),('12664','2013-07-12','13:20:00',2.73),('12664','2013-07-12','13:25:00',4.54),('12664','2013-07-12','13:30:00',4.14),('12664','2013-07-12','13:35:00',4.51),('12664','2013-07-12','13:40:00',2.93),('12664','2013-07-12','13:45:00',4.23),('12664','2013-07-12','13:50:00',3.91),('12664','2013-07-12','13:55:00',2.1),('12664','2013-07-12','14:00:00',3.27),('12664','2013-07-12','14:05:00',4.09),('12664','2013-07-12','14:10:00',3.31),('12664','2013-07-12','14:15:00',4.51),('12664','2013-07-12','14:20:00',3.48),('12664','2013-07-12','14:25:00',4.49),('12664','2013-07-12','14:30:00',4.41),('12664','2013-07-12','14:35:00',2.68),('12664','2013-07-12','14:40:00',3.51),('12664','2013-07-12','14:45:00',4.16),('12664','2013-07-12','14:50:00',4.01),('12664','2013-07-12','14:55:00',3.96),('12664','2013-07-12','15:00:00',3.96),('12664','2013-07-12','15:05:00',3.88),('12664','2013-07-12','15:10:00',3.82),('12664','2013-07-12','15:15:00',3.8),('12664','2013-07-12','15:20:00',3.77);
INSERT INTO `solarlog` VALUES ('12664','2013-07-12','15:25:00',3.74),('12664','2013-07-12','15:30:00',3.7),('12664','2013-07-12','15:35:00',3.64),('12664','2013-07-12','15:40:00',3.47),('12664','2013-07-12','15:45:00',3.53),('12664','2013-07-12','15:50:00',3.45),('12664','2013-07-12','15:55:00',3.4),('12664','2013-07-12','16:00:00',3.38),('12664','2013-07-12','16:05:00',3.25),('12664','2013-07-12','16:10:00',3.21),('12664','2013-07-12','16:15:00',3.17),('12664','2013-07-12','16:20:00',3.16),('12664','2013-07-12','16:25:00',3.08),('12664','2013-07-12','16:30:00',3.03),('12664','2013-07-12','16:35:00',2.95),('12664','2013-07-12','16:40:00',2.88),('12664','2013-07-12','16:45:00',2.78),('12664','2013-07-12','16:50:00',2.7),('12664','2013-07-12','16:55:00',2.63),('12664','2013-07-12','17:00:00',2.54),('12664','2013-07-12','17:05:00',2.45),('12664','2013-07-12','17:10:00',2.41),('12664','2013-07-12','17:15:00',2.33),('12664','2013-07-12','17:20:00',2.2),('12664','2013-07-12','17:25:00',2.15),('12664','2013-07-12','17:30:00',2.09),('12664','2013-07-12','17:35:00',2.03),('12664','2013-07-12','17:40:00',1.96),('12664','2013-07-12','17:45:00',1.88),('12664','2013-07-12','17:50:00',1.07),('12664','2013-07-12','17:55:00',1.12),('12664','2013-07-12','18:05:00',1.01),('12664','2013-07-12','18:10:00',1.45),('12664','2013-07-12','18:15:00',1.33),('12664','2013-07-12','18:20:00',1.25),('12664','2013-07-12','18:25:00',1.18),('12664','2013-07-12','18:30:00',1.1),('12664','2013-07-11','07:50:00',1.08),('12664','2013-07-11','07:55:00',1.16),('12664','2013-07-11','08:00:00',1.25),('12664','2013-07-11','08:05:00',1.32),('12664','2013-07-11','08:10:00',1.4),('12664','2013-07-11','08:15:00',1.48),('12664','2013-07-11','08:20:00',1.54),('12664','2013-07-11','08:25:00',1.64),('12664','2013-07-11','08:30:00',1.74),('12664','2013-07-11','08:35:00',1.84),('12664','2013-07-11','08:40:00',1.88),('12664','2013-07-11','08:45:00',1.98),('12664','2013-07-11','08:50:00',2.05),('12664','2013-07-11','08:55:00',2.21),('12664','2013-07-11','09:00:00',2.23),('12664','2013-07-11','09:05:00',2.29),('12664','2013-07-11','09:10:00',2.39),('12664','2013-07-11','09:15:00',2.47),('12664','2013-07-11','09:20:00',2.59),('12664','2013-07-11','09:25:00',2.65),('12664','2013-07-11','09:30:00',2.7),('12664','2013-07-11','09:35:00',2.71),('12664','2013-07-11','09:40:00',1.88),('12664','2013-07-11','09:45:00',1.86),('12664','2013-07-11','09:50:00',2.2),('12664','2013-07-11','09:55:00',1.27),('12664','2013-07-11','10:00:00',1.38),('12664','2013-07-11','10:05:00',2.94),('12664','2013-07-11','10:10:00',3.48),('12664','2013-07-11','10:15:00',1.94),('12664','2013-07-11','10:20:00',1.08),('12664','2013-07-11','10:30:00',1.86),('12664','2013-07-11','10:35:00',2.58),('12664','2013-07-11','10:40:00',1.31),('12664','2013-07-11','10:45:00',2.75),('12664','2013-07-11','10:50:00',3.47),('12664','2013-07-11','10:55:00',4.14),('12664','2013-07-11','11:00:00',3.19),('12664','2013-07-11','11:05:00',2.15),('12664','2013-07-11','11:10:00',3.25),('12664','2013-07-11','11:15:00',1.72),('12664','2013-07-11','11:20:00',1.29),('12664','2013-07-11','11:25:00',3.16),('12664','2013-07-11','11:30:00',2.67),('12664','2013-07-11','11:35:00',2.78),('12664','2013-07-11','11:40:00',4.51),('12664','2013-07-11','11:45:00',3.45),('12664','2013-07-11','11:50:00',3.99),('12664','2013-07-11','11:55:00',3.67),('12664','2013-07-11','12:00:00',4.36),('12664','2013-07-11','12:05:00',4.39),('12664','2013-07-11','12:10:00',4.32),('12664','2013-07-11','12:15:00',4.34),('12664','2013-07-11','12:20:00',4.4),('12664','2013-07-11','12:25:00',4.42),('12664','2013-07-11','12:30:00',4.26),('12664','2013-07-11','12:35:00',4.38),('12664','2013-07-11','12:40:00',4.35),('12664','2013-07-11','12:45:00',4.36),('12664','2013-07-11','12:50:00',4.38),('12664','2013-07-11','12:55:00',4.28),('12664','2013-07-11','13:00:00',4.34),('12664','2013-07-11','13:05:00',4.33),('12664','2013-07-11','13:10:00',4.37),('12664','2013-07-11','13:15:00',4.34),('12664','2013-07-11','13:20:00',4.3),('12664','2013-07-11','13:25:00',4.31),('12664','2013-07-11','13:30:00',4.32),('12664','2013-07-11','13:35:00',4.35),('12664','2013-07-11','13:40:00',4.37),('12664','2013-07-11','13:45:00',4.36),('12664','2013-07-11','13:50:00',4.33),('12664','2013-07-11','13:55:00',4.27),('12664','2013-07-11','14:00:00',4.31),('12664','2013-07-11','14:05:00',3.53),('12664','2013-07-11','14:10:00',4.4),('12664','2013-07-11','14:15:00',4.3),('12664','2013-07-11','14:20:00',4.3),('12664','2013-07-11','14:25:00',4.29),('12664','2013-07-11','14:30:00',4.27),('12664','2013-07-11','14:35:00',3.39),('12664','2013-07-11','14:40:00',4.19),('12664','2013-07-11','14:45:00',4.11),('12664','2013-07-11','14:50:00',4.1),('12664','2013-07-11','14:55:00',3.84),('12664','2013-07-11','15:00:00',4.04),('12664','2013-07-11','15:05:00',4.01),('12664','2013-07-11','15:10:00',3.93),('12664','2013-07-11','15:15:00',3.91),('12664','2013-07-11','15:20:00',3.35),('12664','2013-07-11','15:25:00',3.86),('12664','2013-07-11','15:30:00',3.8),('12664','2013-07-11','15:35:00',3.77),('12664','2013-07-11','15:40:00',3.64),('12664','2013-07-11','15:45:00',3.69),('12664','2013-07-11','15:50:00',3.65),('12664','2013-07-11','15:55:00',3.42),('12664','2013-07-11','16:00:00',3.57),('12664','2013-07-11','16:05:00',3.44),('12664','2013-07-11','16:10:00',3.02),('12664','2013-07-11','16:15:00',3.32),('12664','2013-07-11','16:20:00',3.26),('12664','2013-07-11','16:25:00',3.19),('12664','2013-07-11','16:30:00',3.15),('12664','2013-07-11','16:35:00',2.93),('12664','2013-07-11','16:40:00',2.75),('12664','2013-07-11','16:45:00',2.95),('12664','2013-07-11','16:50:00',2.46),('12664','2013-07-11','16:55:00',2.23),('12664','2013-07-11','17:00:00',1.66),('12664','2013-07-11','17:05:00',2.7),('12664','2013-07-11','17:10:00',2.36),('12664','2013-07-11','17:15:00',1.59),('12664','2013-07-11','17:20:00',1.38),('12664','2013-07-11','17:25:00',1.94),('12664','2013-07-11','17:30:00',2.03),('12664','2013-07-11','17:40:00',2.11),('12664','2013-07-11','17:45:00',1.62),('12664','2013-07-11','17:50:00',1.75),('12664','2013-07-11','17:55:00',1.97),('12664','2013-07-11','18:00:00',1.69),('12664','2013-07-11','18:05:00',1.37),('12664','2013-07-11','18:10:00',1.08),('12664','2013-07-11','18:15:00',1.7),('12664','2013-07-11','18:20:00',1.13),('12664','2013-07-10','07:35:00',1.08),('12664','2013-07-10','07:40:00',1.19),('12664','2013-07-10','07:45:00',1.12),('12664','2013-07-10','08:20:00',1.27),('12664','2013-07-10','08:25:00',1.41),('12664','2013-07-10','08:30:00',1.68),('12664','2013-07-10','08:35:00',1.86),('12664','2013-07-10','08:40:00',2.08),('12664','2013-07-10','08:45:00',2.44),('12664','2013-07-10','08:50:00',2.36),('12664','2013-07-10','08:55:00',2.34),('12664','2013-07-10','09:00:00',2.38),('12664','2013-07-10','09:05:00',2.45),('12664','2013-07-10','09:10:00',2.52),('12664','2013-07-10','09:15:00',2.58),('12664','2013-07-10','09:20:00',2.67),('12664','2013-07-10','09:25:00',2.75),('12664','2013-07-10','09:30:00',2.79),('12664','2013-07-10','09:35:00',2.86),('12664','2013-07-10','09:40:00',2.93),('12664','2013-07-10','09:45:00',2.99),('12664','2013-07-10','09:50:00',3.01),('12664','2013-07-10','09:55:00',3.09),('12664','2013-07-10','10:00:00',3.1),('12664','2013-07-10','10:05:00',3.16),('12664','2013-07-10','10:10:00',3.23),('12664','2013-07-10','10:15:00',3.31),('12664','2013-07-10','10:20:00',3.37),('12664','2013-07-10','10:25:00',3.42),('12664','2013-07-10','10:30:00',3.47),('12664','2013-07-10','10:35:00',3.51),('12664','2013-07-10','10:40:00',3.55),('12664','2013-07-10','10:45:00',3.58),('12664','2013-07-10','10:50:00',3.6),('12664','2013-07-10','10:55:00',3.64),('12664','2013-07-10','11:00:00',3.69),('12664','2013-07-10','11:05:00',3.71),('12664','2013-07-10','11:10:00',3.74),('12664','2013-07-10','11:15:00',3.77),('12664','2013-07-10','11:20:00',3.8),('12664','2013-07-10','11:25:00',3.8),('12664','2013-07-10','11:30:00',3.82),('12664','2013-07-10','11:35:00',3.85),('12664','2013-07-10','11:40:00',3.9),('12664','2013-07-10','11:45:00',3.88),('12664','2013-07-10','11:50:00',3.96),('12664','2013-07-10','11:55:00',3.86),('12664','2013-07-10','12:00:00',3.99),('12664','2013-07-10','12:05:00',4.1),('12664','2013-07-10','12:10:00',4.1),('12664','2013-07-10','12:15:00',4.13),('12664','2013-07-10','12:20:00',4.15),('12664','2013-07-10','12:25:00',4.21),('12664','2013-07-10','12:30:00',4.17),('12664','2013-07-10','12:35:00',4.24),('12664','2013-07-10','12:40:00',4.22),('12664','2013-07-10','12:45:00',4.2),('12664','2013-07-10','12:50:00',4.22),('12664','2013-07-10','12:55:00',4.23),('12664','2013-07-10','13:00:00',4.25),('12664','2013-07-10','13:05:00',4.26),('12664','2013-07-10','13:10:00',4.24),('12664','2013-07-10','13:15:00',4.27),('12664','2013-07-10','13:20:00',4.31),('12664','2013-07-10','13:25:00',4.32),('12664','2013-07-10','13:30:00',4.32),('12664','2013-07-10','13:35:00',4.32),('12664','2013-07-10','13:40:00',4.33),('12664','2013-07-10','13:45:00',4.3),('12664','2013-07-10','13:50:00',4.32),('12664','2013-07-10','13:55:00',4.31),('12664','2013-07-10','14:00:00',4.3),('12664','2013-07-10','14:05:00',4.27),('12664','2013-07-10','14:10:00',4.25),('12664','2013-07-10','14:15:00',4.23),('12664','2013-07-10','14:20:00',4.22),('12664','2013-07-10','14:25:00',4.2),('12664','2013-07-10','14:30:00',4.16),('12664','2013-07-10','14:35:00',4.13),('12664','2013-07-10','14:40:00',4.1),('12664','2013-07-10','14:45:00',4.08),('12664','2013-07-10','14:50:00',4.08),('12664','2013-07-10','14:55:00',4.07),('12664','2013-07-10','15:00:00',4.04),('12664','2013-07-10','15:05:00',4),('12664','2013-07-10','15:10:00',3.94),('12664','2013-07-10','15:15:00',3.91),('12664','2013-07-10','15:20:00',3.88),('12664','2013-07-10','15:25:00',3.81),('12664','2013-07-10','15:30:00',3.77),('12664','2013-07-10','15:35:00',3.73),('12664','2013-07-10','15:40:00',3.69),('12664','2013-07-10','15:45:00',3.63),('12664','2013-07-10','15:50:00',3.57),('12664','2013-07-10','15:55:00',3.52),('12664','2013-07-10','16:00:00',3.45),('12664','2013-07-10','16:05:00',3.39),('12664','2013-07-10','16:10:00',3.33),('12664','2013-07-10','16:15:00',3.23),('12664','2013-07-10','16:20:00',3.18),('12664','2013-07-10','16:25:00',3.12),('12664','2013-07-10','16:30:00',3.06),('12664','2013-07-10','16:35:00',3.01),('12664','2013-07-10','16:40:00',2.93),('12664','2013-07-10','16:45:00',2.89),('12664','2013-07-10','16:50:00',2.88),('12664','2013-07-10','16:55:00',2.94),('12664','2013-07-10','17:00:00',3.08),('12664','2013-07-10','17:05:00',3.17),('12664','2013-07-10','17:10:00',3.15),('12664','2013-07-10','17:15:00',3),('12664','2013-07-10','17:20:00',2.69),('12664','2013-07-10','17:25:00',2.37),('12664','2013-07-10','17:30:00',2.28),('12664','2013-07-10','17:35:00',2.52),('12664','2013-07-10','17:40:00',2.03),('12664','2013-07-10','17:45:00',1.66),('12664','2013-07-10','17:50:00',2.06),('12664','2013-07-10','17:55:00',1.17),('12664','2014-05-02','07:35:00',1.19),('12664','2014-05-02','07:40:00',1.15),('12664','2014-05-02','07:45:00',1.26),('12664','2014-05-02','07:50:00',1.32),('12664','2014-05-02','08:25:00',1.29),('12664','2014-05-02','08:30:00',1.74),('12664','2014-05-02','08:35:00',1.14),('12664','2014-05-02','09:10:00',1.23),('12664','2014-05-02','09:15:00',1.8),('12664','2014-05-02','09:20:00',1.68),('12664','2014-05-02','09:25:00',1.43),('12664','2014-05-02','09:30:00',1.69),('12664','2014-05-02','09:35:00',1.69),('12664','2014-05-02','09:40:00',1.66),('12664','2014-05-02','09:45:00',1.28),('12664','2014-05-02','09:50:00',1.11),('12664','2014-05-02','12:35:00',1.18),('12664','2014-05-02','12:40:00',1.33),('12664','2014-05-02','12:45:00',1.79),('12664','2014-05-02','12:50:00',2.19),('12664','2014-05-02','12:55:00',2.3),('12664','2014-05-02','13:00:00',2.05),('12664','2014-05-02','13:05:00',1.95),('12664','2014-05-02','13:10:00',2.38),('12664','2014-05-02','13:15:00',2.54),('12664','2014-05-02','13:20:00',2.62),('12664','2014-05-02','13:25:00',1.79),('12664','2014-05-02','13:30:00',3.4),('12664','2014-05-02','13:35:00',2.9),('12664','2014-05-02','13:40:00',2.04),('12664','2014-05-02','13:45:00',1.96),('12664','2014-05-02','13:50:00',2.28),('12664','2014-05-02','13:55:00',1.75),('12664','2014-05-02','14:00:00',1.62),('12664','2014-05-02','14:05:00',2.19),('12664','2014-05-02','14:10:00',2.62),('12664','2014-05-02','14:15:00',2.17),('12664','2014-05-02','14:20:00',2.94),('12664','2014-05-02','14:25:00',2.67),('12664','2014-05-02','14:30:00',1.48),('12664','2014-05-02','14:35:00',1.29),('12664','2014-05-02','14:40:00',1.15),('12664','2014-05-02','15:10:00',1.01),('12664','2014-05-02','15:15:00',1.88),('12664','2014-05-02','15:20:00',1.63),('12664','2014-05-02','15:25:00',3),('12664','2014-05-02','15:30:00',1.59),('12664','2014-05-02','15:35:00',1.27),('12664','2014-05-02','15:45:00',1.15),('12664','2014-05-02','15:50:00',1.47),('12664','2014-05-02','16:05:00',1.03),('12664','2014-05-02','16:10:00',1.89),('12664','2014-05-02','16:15:00',1.5),('12664','2014-05-02','16:20:00',1.04),('12664','2014-05-02','16:25:00',1.44),('12664','2014-05-02','16:30:00',1.24),('12664','2014-05-02','16:35:00',1.18),('12664','2014-05-02','16:40:00',2.41),('12664','2014-05-02','16:45:00',2.26),('12664','2014-05-02','16:50:00',1.46),('12664','2014-05-02','16:55:00',1.1),('12664','2014-05-02','17:00:00',1.08),('12664','2014-05-02','17:10:00',1.08),('12664','2014-04-05','08:35:00',1.08),('12664','2014-04-05','08:40:00',1.06),('12664','2014-04-05','08:45:00',1.07),('12664','2014-04-05','08:50:00',1.08),('12664','2014-04-05','09:25:00',1.23),('12664','2014-04-05','09:30:00',1.56),('12664','2014-04-05','09:35:00',1.73),('12664','2014-04-05','09:40:00',1.43),('12664','2014-04-05','09:45:00',1.65),('12664','2014-04-05','09:50:00',1.86),('12664','2014-04-05','09:55:00',1.79),('12664','2014-04-05','10:00:00',2.58),('12664','2014-04-05','10:05:00',2.49),('12664','2014-04-05','10:10:00',2.25),('12664','2014-04-05','10:15:00',2.14),('12664','2014-04-05','10:20:00',2.03),('12664','2014-04-05','10:25:00',2.19),('12664','2014-04-05','10:30:00',3.91),('12664','2014-04-05','10:35:00',3.73),('12664','2014-04-05','10:40:00',3.48),('12664','2014-04-05','10:45:00',2.85),('12664','2014-04-05','10:50:00',2.35),('12664','2014-04-05','10:55:00',3.45),('12664','2014-04-05','11:00:00',3.84),('12664','2014-04-05','11:05:00',3.61),('12664','2014-04-05','11:10:00',3.57),('12664','2014-04-05','11:15:00',3.39),('12664','2014-04-05','11:20:00',3.09),('12664','2014-04-05','11:25:00',3.1),('12664','2014-04-05','11:30:00',3),('12664','2014-04-05','11:35:00',3.95),('12664','2014-04-05','11:40:00',4.3),('12664','2014-04-05','11:45:00',4.32),('12664','2014-04-05','11:50:00',4.1),('12664','2014-04-05','11:55:00',3.84),('12664','2014-04-05','12:00:00',3.37),('12664','2014-04-05','12:05:00',2.97),('12664','2014-04-05','12:10:00',2.48),('12664','2014-04-05','12:15:00',2.62),('12664','2014-04-05','12:20:00',2.5),('12664','2014-04-05','12:25:00',2.23),('12664','2014-04-05','12:30:00',2.36),('12664','2014-04-05','12:35:00',2.07),('12664','2014-04-05','12:40:00',2.09),('12664','2014-04-05','12:45:00',2.11),('12664','2014-04-05','12:50:00',2.41),('12664','2014-04-05','12:55:00',2.31),('12664','2014-04-05','13:00:00',2.5),('12664','2014-04-05','13:05:00',2.62),('12664','2014-04-05','13:10:00',2.83),('12664','2014-04-05','13:15:00',2.95),('12664','2014-04-05','13:20:00',3.28),('12664','2014-04-05','13:25:00',2.46),('12664','2014-04-05','13:30:00',3.7),('12664','2014-04-05','13:35:00',2.54),('12664','2014-04-05','13:40:00',1.44),('12664','2014-04-05','13:45:00',2.57),('12664','2014-04-05','13:50:00',4.15),('12664','2014-04-05','13:55:00',4.15),('12664','2014-04-05','14:00:00',4.56),('12664','2014-04-05','14:05:00',1.67),('12664','2014-04-05','14:10:00',1.46),('12664','2014-04-05','14:15:00',3.98),('12664','2014-04-05','15:00:00',2.3),('12664','2014-04-05','15:05:00',2.92),('12664','2014-04-05','15:10:00',1.84),('12664','2014-04-05','15:15:00',4.22),('12664','2014-04-05','15:20:00',2.94),('12664','2014-04-05','15:25:00',2.11),('12664','2014-04-05','15:30:00',3.85),('12664','2014-04-05','15:35:00',3.51),('12664','2014-04-05','15:40:00',2.85),('12664','2014-04-05','15:45:00',1.42),('12664','2014-04-05','15:50:00',1.07),('12664','2014-04-05','16:00:00',1.02),('12664','2014-04-05','16:05:00',1.2),('12664','2014-04-05','16:10:00',1.28),('12664','2014-04-05','16:15:00',1.26),('12664','2014-04-05','16:25:00',1.07),('12664','2014-04-05','16:30:00',2.31),('12664','2014-04-05','16:35:00',3.2),('12664','2014-04-05','16:40:00',1.37),('12664','2014-04-05','16:50:00',1.95),('12664','2014-04-05','16:55:00',2.55),('12664','2014-04-05','17:00:00',2.64),('12664','2014-04-05','17:05:00',2.41),('12664','2014-04-05','17:10:00',1.93),('12664','2014-04-05','17:15:00',2.08),('12664','2014-04-05','17:20:00',2.01),('12664','2014-04-05','17:25:00',1.88),('12664','2014-04-05','17:30:00',1.4),('12664','2014-04-05','17:35:00',1.1),('12664','2013-07-09','07:40:00',1.06),('12664','2013-07-09','07:45:00',1.21),('12664','2013-07-09','07:50:00',1.32),('12664','2013-07-09','07:55:00',1.41),('12664','2013-07-09','08:00:00',1.47),('12664','2013-07-09','08:05:00',1.4),('12664','2013-07-09','08:10:00',1.51),('12664','2013-07-09','08:15:00',1.57),('12664','2013-07-09','08:20:00',1.65),('12664','2013-07-09','08:25:00',1.74),('12664','2013-07-09','08:30:00',1.73),('12664','2013-07-09','08:35:00',1.9),('12664','2013-07-09','08:40:00',1.97),('12664','2013-07-09','08:45:00',2.06),('12664','2013-07-09','08:50:00',2.14),('12664','2013-07-09','08:55:00',2.23),('12664','2013-07-09','09:00:00',2.3),('12664','2013-07-09','09:05:00',2.36),('12664','2013-07-09','09:10:00',2.42),('12664','2013-07-09','09:15:00',2.51),('12664','2013-07-09','09:20:00',2.61),('12664','2013-07-09','09:25:00',2.68),('12664','2013-07-09','09:30:00',2.74),('12664','2013-07-09','09:35:00',2.81),('12664','2013-07-09','09:40:00',2.87),('12664','2013-07-09','09:45:00',2.93),('12664','2013-07-09','09:50:00',3),('12664','2013-07-09','09:55:00',3.06),('12664','2013-07-09','10:00:00',3.1),('12664','2013-07-09','10:05:00',3.19),('12664','2013-07-09','10:10:00',3.23),('12664','2013-07-09','10:15:00',3.26),('12664','2013-07-09','10:20:00',3.31),('12664','2013-07-09','10:25:00',3.36),('12664','2013-07-09','10:30:00',3.42),('12664','2013-07-09','10:35:00',3.48),('12664','2013-07-09','10:40:00',3.52),('12664','2013-07-09','10:45:00',3.56),('12664','2013-07-09','10:50:00',3.61),('12664','2013-07-09','10:55:00',3.65),('12664','2013-07-09','11:00:00',3.7),('12664','2013-07-09','11:05:00',3.71),('12664','2013-07-09','11:10:00',3.76),('12664','2013-07-09','11:15:00',3.77),('12664','2013-07-09','11:20:00',3.84),('12664','2013-07-09','11:25:00',3.93),('12664','2013-07-09','11:30:00',4.01),('12664','2013-07-09','11:35:00',3.97),('12664','2013-07-09','11:40:00',3.98),('12664','2013-07-09','11:45:00',3.74),('12664','2013-07-09','11:50:00',3.9),('12664','2013-07-09','11:55:00',4),('12664','2013-07-09','12:00:00',4.02),('12664','2013-07-09','12:05:00',4.04),('12664','2013-07-09','12:10:00',4.12),('12664','2013-07-09','12:15:00',3.98),('12664','2013-07-09','12:20:00',3.31),('12664','2013-07-09','12:25:00',3),('12664','2013-07-09','12:30:00',3.89),('12664','2013-07-09','12:35:00',4.07),('12664','2013-07-09','12:40:00',4.11),('12664','2013-07-09','12:45:00',4.24),('12664','2013-07-09','12:50:00',4.11),('12664','2013-07-09','12:55:00',3.04),('12664','2013-07-09','13:00:00',2.17),('12664','2013-07-09','13:05:00',4.54),('12664','2013-07-09','13:10:00',4.58),('12664','2013-07-09','13:15:00',4.44),('12664','2013-07-09','13:20:00',4.32),('12664','2013-07-09','13:25:00',4.33),('12664','2013-07-09','13:30:00',4.34),('12664','2013-07-09','13:35:00',4.45),('12664','2013-07-09','13:40:00',4.28),('12664','2013-07-09','13:45:00',4.19),('12664','2013-07-09','13:50:00',3.77),('12664','2013-07-09','13:55:00',4.3),('12664','2013-07-09','14:00:00',4.23),('12664','2013-07-09','14:05:00',3.77),('12664','2013-07-09','14:10:00',4.13),('12664','2013-07-09','14:15:00',4.52),('12664','2013-07-09','14:20:00',4.24),('12664','2013-07-09','14:25:00',2.57),('12664','2013-07-09','14:30:00',1.19),('12664','2013-07-08','07:50:00',1.25),('12664','2013-07-08','07:55:00',1.22),('12664','2013-07-08','08:00:00',1.37),('12664','2013-07-08','08:05:00',1.48),('12664','2013-07-08','08:10:00',1.56),('12664','2013-07-08','08:15:00',1.62),('12664','2013-07-08','08:20:00',1.68),('12664','2013-07-08','08:25:00',1.74),('12664','2013-07-08','08:30:00',1.81),('12664','2013-07-08','08:35:00',1.88),('12664','2013-07-08','08:40:00',1.94),('12664','2013-07-08','08:45:00',2.02),('12664','2013-07-08','08:50:00',2.09),('12664','2013-07-08','08:55:00',2.15),('12664','2013-07-08','09:00:00',2.23),('12664','2013-07-08','09:05:00',2.33),('12664','2013-07-08','09:10:00',2.4),('12664','2013-07-08','09:15:00',2.51),('12664','2013-07-08','09:20:00',2.59),('12664','2013-07-08','09:25:00',2.66),('12664','2013-07-08','09:30:00',2.71),('12664','2013-07-08','09:35:00',2.78),('12664','2013-07-08','09:40:00',2.84),('12664','2013-07-08','09:45:00',2.89),('12664','2013-07-08','09:50:00',2.95),('12664','2013-07-08','09:55:00',3.02),('12664','2013-07-08','10:00:00',3.1),('12664','2013-07-08','10:05:00',3.17),('12664','2013-07-08','10:10:00',3.23),('12664','2013-07-08','10:15:00',3.26),('12664','2013-07-08','10:20:00',3.32),('12664','2013-07-08','10:25:00',3.38),('12664','2013-07-08','10:30:00',3.44),('12664','2013-07-08','10:35:00',3.09),('12664','2013-07-08','10:40:00',3.53),('12664','2013-07-08','10:45:00',3.59),('12664','2013-07-08','10:50:00',3.61),('12664','2013-07-08','10:55:00',3.63),('12664','2013-07-08','11:00:00',3.67),('12664','2013-07-08','11:05:00',3.72),('12664','2013-07-08','11:10:00',3.78),('12664','2013-07-08','11:15:00',3.83),('12664','2013-07-08','11:20:00',3.85),('12664','2013-07-08','11:25:00',3.72),('12664','2013-07-08','11:30:00',3.77),('12664','2013-07-08','11:35:00',3.64),('12664','2013-07-08','11:40:00',3.54),('12664','2013-07-08','11:45:00',3.99),('12664','2013-07-08','11:50:00',4.11),('12664','2013-07-08','11:55:00',4.08),('12664','2013-07-08','12:00:00',3.97),('12664','2013-07-08','12:05:00',3.2),('12664','2013-07-08','12:10:00',4.01),('12664','2013-07-08','12:15:00',3.57),('12664','2013-07-08','12:20:00',4.34),('12664','2013-07-08','12:25:00',3.92),('12664','2013-07-08','12:30:00',3.91),('12664','2013-07-08','12:35:00',4.37),('12664','2013-07-08','12:40:00',4.3),('12664','2013-07-08','12:45:00',4.33),('12664','2013-07-08','12:50:00',4.14),('12664','2013-07-08','12:55:00',3.75),('12664','2013-07-08','13:00:00',2.62),('12664','2013-07-08','13:05:00',2.37),('12664','2013-07-08','13:10:00',1.2),('12664','2013-07-08','13:15:00',1.99),('12664','2013-07-08','13:20:00',1.6),('12664','2013-07-08','14:05:00',1.02),('12664','2013-07-08','14:10:00',1.3),('12664','2013-07-08','14:15:00',1.56),('12664','2013-07-08','14:20:00',1.42),('12664','2013-07-08','14:25:00',1.26),('12664','2013-07-08','14:30:00',1.07),('12664','2013-07-08','14:35:00',1.32),('12664','2013-07-08','14:40:00',1.85),('12664','2013-07-08','14:45:00',2.75),('12664','2013-07-08','14:50:00',2.23),('12664','2013-07-08','14:55:00',1.55),('12664','2013-07-08','15:00:00',1.48),('12664','2013-07-08','15:05:00',1.58),('12664','2013-07-08','15:10:00',1.53),('12664','2013-07-08','15:15:00',1.31),('12664','2013-07-08','15:20:00',1),('12664','2013-07-07','07:40:00',1.01),('12664','2013-07-07','07:45:00',1.1),('12664','2013-07-07','07:50:00',1.19),('12664','2013-07-07','07:55:00',1.28),('12664','2013-07-07','08:00:00',1.37),('12664','2013-07-07','08:05:00',1.47),('12664','2013-07-07','08:10:00',1.57),('12664','2013-07-07','08:15:00',1.66),('12664','2013-07-07','08:20:00',1.75),('12664','2013-07-07','08:25:00',1.83),('12664','2013-07-07','08:30:00',1.93),('12664','2013-07-07','08:35:00',1.55),('12664','2013-07-07','08:40:00',1.17),('12664','2013-07-07','08:45:00',2.18),('12664','2013-07-07','08:50:00',2.31),('12664','2013-07-07','08:55:00',2.44),('12664','2013-07-07','09:00:00',2.35),('12664','2013-07-07','09:05:00',1.81),('12664','2013-07-07','09:10:00',2.37),('12664','2013-07-07','09:15:00',1.94),('12664','2013-07-07','09:20:00',1.61),('12664','2013-07-07','09:25:00',1.32),('12664','2013-07-07','09:30:00',2.05),('12664','2013-07-07','09:35:00',2.86),('12664','2013-07-07','09:40:00',2.72),('12664','2013-07-07','09:45:00',2.85),('12664','2013-07-07','09:50:00',3.28),('12664','2013-07-07','09:55:00',3.3),('12664','2013-07-07','10:00:00',3.29),('12664','2013-07-07','10:05:00',3.27),('12664','2013-07-07','10:10:00',3.22),('12664','2013-07-07','10:15:00',2.96),('12664','2013-07-07','10:20:00',3.12),('12664','2013-07-07','10:25:00',3.65),('12664','2013-07-07','10:30:00',3.44),('12664','2013-07-07','10:35:00',3.04),('12664','2013-07-07','10:40:00',3.59),('12664','2013-07-07','10:45:00',3.51),('12664','2013-07-07','10:50:00',3.77),('12664','2013-07-07','10:55:00',3.75),('12664','2013-07-07','11:00:00',3.76),('12664','2013-07-07','11:05:00',3.79),('12664','2013-07-07','11:10:00',3.86),('12664','2013-07-07','11:15:00',3.94),('12664','2013-07-07','11:20:00',3.68),('12664','2013-07-07','11:25:00',3.2),('12664','2013-07-07','11:30:00',3.7),('12664','2013-07-07','11:35:00',3.75),('12664','2013-07-07','11:40:00',3.64),('12664','2013-07-07','11:45:00',3.73),('12664','2013-07-07','11:50:00',3.85),('12664','2013-07-07','11:55:00',3.93),('12664','2013-07-07','12:00:00',2.93),('12664','2013-07-07','12:05:00',3.71),('12664','2013-07-07','12:10:00',3.65),('12664','2013-07-07','12:15:00',3.29),('12664','2013-07-07','12:20:00',3.44),('12664','2013-07-07','12:25:00',3.98),('12664','2013-07-07','12:30:00',4.04),('12664','2013-07-07','12:35:00',4.21),('12664','2013-07-07','12:40:00',4.12),('12664','2013-07-07','12:45:00',4.09),('12664','2013-07-07','12:50:00',4.05),('12664','2013-07-07','12:55:00',4.24),('12664','2013-07-07','13:00:00',4.32),('12664','2013-07-07','13:05:00',4.22),('12664','2013-07-07','13:10:00',4.22),('12664','2013-07-07','13:15:00',4.28),('12664','2013-07-07','13:20:00',4.26),('12664','2013-07-07','13:25:00',4.15),('12664','2013-07-07','13:30:00',4.36),('12664','2013-07-07','13:35:00',4.53),('12664','2013-07-07','13:40:00',4.05),('12664','2013-07-07','13:45:00',1.4),('12664','2013-07-07','13:50:00',1.46),('12664','2013-07-07','13:55:00',1.28),('12664','2013-07-07','14:00:00',1.02),('12664','2013-07-07','14:15:00',1.17),('12664','2013-07-07','14:20:00',1.55),('12664','2013-07-07','14:25:00',2.34),('12664','2013-07-07','14:30:00',3.14),('12664','2013-07-07','14:35:00',1.65),('12664','2013-07-07','14:40:00',1.06),('12664','2013-07-07','14:45:00',1.05),('12664','2013-07-07','14:50:00',1.19),('12664','2013-07-07','14:55:00',1.23),('12664','2013-07-07','15:00:00',1.38),('12664','2013-07-07','15:05:00',1.87),('12664','2013-07-07','15:10:00',2.88),('12664','2013-07-07','15:15:00',1.62),('12664','2013-07-07','15:20:00',1.08),('12664','2013-07-07','17:05:00',1.05),('12664','2013-07-07','17:10:00',1.13),('12664','2013-07-07','17:15:00',1.21),('12664','2013-07-07','17:20:00',1.28),('12664','2013-07-07','17:25:00',1.29),('12664','2013-07-07','17:30:00',1.27),('12664','2013-07-07','17:35:00',1.32),('12664','2013-07-07','17:40:00',1.41),('12664','2013-07-07','17:45:00',1.58),('12664','2013-07-07','17:50:00',1.48),('12664','2013-07-07','17:55:00',1.44),('12664','2013-07-07','18:00:00',1.39),('12664','2013-07-07','18:05:00',1.23),('12664','2013-07-06','07:45:00',1.04),('12664','2013-07-06','07:50:00',1.13),('12664','2013-07-06','07:55:00',1.22),('12664','2013-07-06','08:00:00',1.31),('12664','2013-07-06','08:05:00',1.4),('12664','2013-07-06','08:10:00',1.48),('12664','2013-07-06','08:15:00',1.56),('12664','2013-07-06','08:20:00',1.64),('12664','2013-07-06','08:25:00',1.72),('12664','2013-07-06','08:30:00',1.8),('12664','2013-07-06','08:35:00',1.9),('12664','2013-07-06','08:40:00',1.98),('12664','2013-07-06','08:45:00',2.06),('12664','2013-07-06','08:50:00',2.15),('12664','2013-07-06','08:55:00',2.23),('12664','2013-07-06','09:00:00',2.32),('12664','2013-07-06','09:05:00',2.4),('12664','2013-07-06','09:10:00',2.47),('12664','2013-07-06','09:15:00',2.54),('12664','2013-07-06','09:20:00',2.6),('12664','2013-07-06','09:25:00',2.68),('12664','2013-07-06','09:30:00',2.75),('12664','2013-07-06','09:35:00',2.82),('12664','2013-07-06','09:40:00',2.88),('12664','2013-07-06','09:45:00',2.94),('12664','2013-07-06','09:50:00',3),('12664','2013-07-06','09:55:00',3.04),('12664','2013-07-06','10:00:00',3.09),('12664','2013-07-06','10:05:00',3.17),('12664','2013-07-06','10:10:00',3.23),('12664','2013-07-06','10:15:00',3.27),('12664','2013-07-06','10:20:00',3.33),('12664','2013-07-06','10:25:00',3.39),('12664','2013-07-06','10:30:00',3.44),('12664','2013-07-06','10:35:00',3.47),('12664','2013-07-06','10:40:00',3.55),('12664','2013-07-06','10:45:00',3.59),('12664','2013-07-06','10:50:00',3.63),('12664','2013-07-06','10:55:00',3.66),('12664','2013-07-06','11:00:00',3.71),('12664','2013-07-06','11:05:00',3.76),('12664','2013-07-06','11:10:00',3.8),('12664','2013-07-06','11:15:00',3.82),('12664','2013-07-06','11:20:00',3.87),('12664','2013-07-06','11:25:00',3.9),('12664','2013-07-06','11:30:00',3.89),('12664','2013-07-06','11:35:00',3.93),('12664','2013-07-06','11:40:00',3.97),('12664','2013-07-06','11:45:00',4.01),('12664','2013-07-06','11:50:00',3.99),('12664','2013-07-06','11:55:00',3.99),('12664','2013-07-06','12:00:00',4.02),('12664','2013-07-06','12:05:00',4.06),('12664','2013-07-06','12:10:00',4.08),('12664','2013-07-06','12:15:00',3.3),('12664','2013-07-06','12:20:00',4.12),('12664','2013-07-06','12:25:00',4.19),('12664','2013-07-06','12:30:00',4.22),('12664','2013-07-06','12:35:00',4.23),('12664','2013-07-06','12:40:00',4.22),('12664','2013-07-06','12:45:00',4.23),('12664','2013-07-06','12:50:00',4.22),('12664','2013-07-06','12:55:00',4.19),('12664','2013-07-06','13:00:00',4.23),('12664','2013-07-06','13:05:00',4.28),('12664','2013-07-06','13:10:00',4.2),('12664','2013-07-06','13:15:00',4.21),('12664','2013-07-06','13:20:00',3.19),('12664','2013-07-06','13:25:00',4.24),('12664','2013-07-06','13:30:00',4.14),('12664','2013-07-06','13:35:00',3.69),('12664','2013-07-06','13:40:00',4.07),('12664','2013-07-06','13:45:00',4.27),('12664','2013-07-06','13:50:00',4.21),('12664','2013-07-06','13:55:00',4.16),('12664','2013-07-06','14:00:00',4.16),('12664','2013-07-06','14:05:00',4.12),('12664','2013-07-06','14:10:00',4.08),('12664','2013-07-06','14:15:00',4.08),('12664','2013-07-06','14:20:00',4.08),('12664','2013-07-06','14:25:00',4.05),('12664','2013-07-06','14:30:00',4.06),('12664','2013-07-06','14:35:00',3.99),('12664','2013-07-06','14:40:00',3.96),('12664','2013-07-06','14:45:00',4.06),('12664','2013-07-06','14:50:00',2.68),('12664','2013-07-06','14:55:00',1.38),('12664','2013-07-06','15:00:00',1.51),('12664','2013-07-06','15:05:00',2.45),('12664','2013-07-06','15:10:00',1.01),('12664','2013-07-06','15:20:00',1.23),('12664','2013-07-06','15:25:00',1.03),('12664','2013-07-06','16:30:00',1.06),('12664','2013-07-06','16:35:00',1.22),('12664','2013-07-06','16:40:00',1.34),('12664','2013-07-06','16:45:00',2.06),('12664','2013-07-06','16:50:00',3.21),('12664','2013-07-06','16:55:00',1.95),('12664','2013-07-06','17:00:00',2.5),('12664','2013-07-06','17:05:00',2.64),('12664','2013-07-06','17:10:00',2.77),('12664','2013-07-06','17:15:00',2.11),('12664','2013-07-06','17:20:00',1.21),('12664','2013-07-05','07:45:00',1.07),('12664','2013-07-05','07:50:00',1.15),('12664','2013-07-05','07:55:00',1.24),('12664','2013-07-05','08:00:00',1.33),('12664','2013-07-05','08:05:00',1.41),('12664','2013-07-05','08:10:00',1.5),('12664','2013-07-05','08:15:00',1.6),('12664','2013-07-05','08:20:00',1.67),('12664','2013-07-05','08:25:00',1.76),('12664','2013-07-05','08:30:00',1.84),('12664','2013-07-05','08:35:00',1.91),('12664','2013-07-05','08:40:00',2),('12664','2013-07-05','08:45:00',2.08),('12664','2013-07-05','08:50:00',2.17),('12664','2013-07-05','08:55:00',2.25),('12664','2013-07-05','09:00:00',2.34),('12664','2013-07-05','09:05:00',2.41),('12664','2013-07-05','09:10:00',2.49),('12664','2013-07-05','09:15:00',2.55),('12664','2013-07-05','09:20:00',2.61),('12664','2013-07-05','09:25:00',2.68),('12664','2013-07-05','09:30:00',2.74),('12664','2013-07-05','09:35:00',2.8),('12664','2013-07-05','09:40:00',2.87),('12664','2013-07-05','09:45:00',2.93),('12664','2013-07-05','09:50:00',2.99),('12664','2013-07-05','09:55:00',3.03),('12664','2013-07-05','10:00:00',3.07),('12664','2013-07-05','10:05:00',3.13),('12664','2013-07-05','10:10:00',3.21),('12664','2013-07-05','10:15:00',3.26),('12664','2013-07-05','10:20:00',3.3),('12664','2013-07-05','10:25:00',3.36),('12664','2013-07-05','10:30:00',3.43),('12664','2013-07-05','10:35:00',3.48),('12664','2013-07-05','10:40:00',3.53),('12664','2013-07-05','10:45:00',3.57),('12664','2013-07-05','10:50:00',3.61),('12664','2013-07-05','10:55:00',3.66),('12664','2013-07-05','11:00:00',3.7),('12664','2013-07-05','11:05:00',3.73),('12664','2013-07-05','11:10:00',3.79),('12664','2013-07-05','11:15:00',3.82),('12664','2013-07-05','11:20:00',3.86),('12664','2013-07-05','11:25:00',3.89),('12664','2013-07-05','11:30:00',3.9),('12664','2013-07-05','11:35:00',3.9),('12664','2013-07-05','11:40:00',3.94),('12664','2013-07-05','11:45:00',4),('12664','2013-07-05','11:50:00',4.02),('12664','2013-07-05','11:55:00',4.05),('12664','2013-07-05','12:00:00',4.07),('12664','2013-07-05','12:05:00',4.11),('12664','2013-07-05','12:10:00',4.13),('12664','2013-07-05','12:15:00',4.17),('12664','2013-07-05','12:20:00',4.21),('12664','2013-07-05','12:25:00',3.58),('12664','2013-07-05','12:30:00',3.54),('12664','2013-07-05','12:35:00',3.54),('12664','2013-07-05','12:40:00',4.54),('12664','2013-07-05','12:45:00',3.38),('12664','2013-07-05','12:50:00',2.02),('12664','2013-07-05','12:55:00',2.27),('12664','2013-07-05','13:00:00',2.42),('12664','2013-07-05','13:05:00',4.3),('12664','2013-07-05','13:10:00',3.68),('12664','2013-07-05','13:15:00',4.43),('12664','2013-07-05','13:20:00',3.51),('12664','2013-07-05','13:25:00',4.46),('12664','2013-07-05','13:30:00',4.6),('12664','2013-07-05','13:35:00',3.89),('12664','2013-07-05','13:40:00',3.96),('12664','2013-07-05','13:45:00',4.29),('12664','2013-07-05','13:50:00',4.18),('12664','2013-07-05','13:55:00',4.18),('12664','2013-07-05','14:00:00',4.28),('12664','2013-07-05','14:05:00',4.3),('12664','2013-07-05','14:10:00',2.87),('12664','2013-07-05','14:15:00',3.19),('12664','2013-07-05','14:20:00',4.04),('12664','2013-07-05','14:25:00',4.24),('12664','2013-07-05','14:30:00',4.2),('12664','2013-07-05','14:35:00',4.1),('12664','2013-07-05','14:40:00',4.12),('12664','2013-07-05','14:45:00',3.97),('12664','2013-07-05','14:50:00',3.13),('12664','2013-07-05','14:55:00',4.07),('12664','2013-07-05','15:00:00',4.04),('12664','2013-07-05','15:05:00',4),('12664','2013-07-05','15:10:00',3.94),('12664','2013-07-05','15:15:00',2.67),('12664','2013-07-05','15:20:00',3.33),('12664','2013-07-05','15:25:00',1.98),('12664','2013-07-05','15:30:00',2.61),('12664','2013-07-05','15:40:00',3.22),('12664','2013-07-05','15:45:00',2.71),('12664','2013-07-05','15:50:00',3.59),('12664','2013-07-05','15:55:00',3.48),('12664','2013-07-05','16:00:00',3.42),('12664','2013-07-05','16:05:00',3.36),('12664','2013-07-05','16:10:00',2.99),('12664','2013-07-05','16:15:00',2.66),('12664','2013-07-05','16:20:00',3.17),('12664','2013-07-05','16:25:00',3.16),('12664','2013-07-05','16:30:00',3.09),('12664','2013-07-05','16:35:00',2.96),('12664','2013-07-05','16:40:00',2.87),('12664','2013-07-05','16:45:00',2.78),('12664','2013-07-05','16:50:00',2.75),('12664','2013-07-05','16:55:00',2.21),('12664','2013-07-05','17:00:00',2.2),('12664','2013-07-05','17:05:00',2.58),('12664','2013-07-05','17:10:00',2.45),('12664','2013-07-05','17:15:00',1.54),('12664','2013-07-05','17:20:00',2.03),('12664','2013-07-05','17:25:00',2.17),('12664','2013-07-05','17:30:00',2.06),('12664','2013-07-05','17:35:00',1.88),('12664','2013-07-05','17:40:00',1.97),('12664','2013-07-05','17:45:00',1.86),('12664','2013-07-05','17:50:00',1.72),('12664','2013-07-05','17:55:00',1.7),('12664','2013-07-05','18:00:00',1.7),('12664','2013-07-05','18:05:00',1.7),('12664','2013-07-05','18:10:00',1.63),('12664','2013-07-05','18:15:00',1.53),('12664','2013-07-05','18:20:00',1.44),('12664','2013-07-05','18:25:00',1.29),('12664','2013-07-05','18:30:00',1.14),('12664','2013-07-05','18:35:00',1.01),('12664','2013-07-04','11:00:00',1.03),('12664','2013-07-04','11:05:00',1.17),('12664','2013-07-04','11:10:00',1.16),('12664','2013-07-04','11:15:00',1.15),('12664','2013-07-04','11:20:00',1.2),('12664','2013-07-04','11:25:00',1.24),('12664','2013-07-04','11:30:00',1.32),('12664','2013-07-04','11:35:00',1.44),('12664','2013-07-04','11:40:00',1.61),('12664','2013-07-04','11:45:00',1.73),('12664','2013-07-04','11:50:00',1.51),('12664','2013-07-04','11:55:00',1.87),('12664','2013-07-04','12:00:00',2.21),('12664','2013-07-04','12:05:00',2.46),('12664','2013-07-04','12:10:00',2.35),('12664','2013-07-04','12:15:00',1.79),('12664','2013-07-04','12:20:00',1.86),('12664','2013-07-04','12:25:00',1.89),('12664','2013-07-04','12:30:00',1.48),('12664','2013-07-04','12:35:00',1.37),('12664','2013-07-04','12:40:00',1.44),('12664','2013-07-04','12:45:00',1.21),('12664','2013-07-04','12:50:00',1.2),('12664','2013-07-04','12:55:00',1.36),('12664','2013-07-04','13:00:00',1.32),('12664','2013-07-04','13:05:00',1.54),('12664','2013-07-04','13:10:00',1.85),('12664','2013-07-04','13:15:00',1.83),('12664','2013-07-04','13:20:00',2.14),('12664','2013-07-04','13:25:00',2.89),('12664','2013-07-04','13:30:00',2.72),('12664','2013-07-04','13:35:00',3.05),('12664','2013-07-04','13:40:00',2.04),('12664','2013-07-04','13:45:00',1.97),('12664','2013-07-04','13:50:00',1.96),('12664','2013-07-04','13:55:00',2.19),('12664','2013-07-04','14:00:00',1.97),('12664','2013-07-04','14:05:00',1.68),('12664','2013-07-04','14:10:00',1.67),('12664','2013-07-04','14:15:00',1.82),('12664','2013-07-04','14:20:00',1.73),('12664','2013-07-04','14:25:00',1.59),('12664','2013-07-04','14:30:00',1.48),('12664','2013-07-04','14:35:00',1.66),('12664','2013-07-04','14:40:00',1.29),('12664','2013-07-04','14:45:00',1.31),('12664','2013-07-04','14:50:00',1.42),('12664','2013-07-04','14:55:00',3.04),('12664','2013-07-04','15:00:00',2.46),('12664','2013-07-04','15:05:00',3.77),('12664','2013-07-04','15:10:00',4.29),('12664','2013-07-04','15:15:00',4.39),('12664','2013-07-04','15:20:00',2.32),('12664','2013-07-04','15:25:00',3.13),('12664','2013-07-04','15:30:00',3.87),('12664','2013-07-04','15:35:00',2.73),('12664','2013-07-04','15:40:00',2.76),('12664','2013-07-04','15:45:00',3.55),('12664','2013-07-04','15:50:00',3.49),('12664','2013-07-04','15:55:00',3.33),('12664','2013-07-04','16:00:00',2.55),('12664','2013-07-04','16:05:00',2.26),('12664','2013-07-04','16:10:00',2.58),('12664','2013-07-04','16:15:00',2.7),('12664','2013-07-04','16:20:00',2.93),('12664','2013-07-04','16:25:00',1.89),('12664','2013-07-04','16:30:00',1.96),('12664','2013-07-04','16:35:00',1.64),('12664','2013-07-04','16:40:00',1.47),('12664','2013-07-04','16:45:00',1.44),('12664','2013-07-04','16:50:00',1.38),('12664','2013-07-04','16:55:00',1.71),('12664','2013-07-04','17:00:00',1.99),('12664','2013-07-04','17:05:00',2.14),('12664','2013-07-04','17:10:00',2.61),('12664','2013-07-04','17:15:00',2.75),('12664','2013-07-04','17:20:00',2.39),('12664','2013-07-04','17:25:00',2.51),('12664','2013-07-04','17:30:00',2.01),('12664','2013-07-04','17:35:00',1.28),('12664','2013-07-04','17:40:00',1.41),('12664','2013-07-04','17:45:00',2.09),('12664','2013-07-04','17:50:00',1.99),('12664','2013-07-04','17:55:00',1.86),('12664','2013-07-04','18:00:00',1.78),('12664','2013-07-04','18:05:00',1.42),('12664','2013-07-04','18:10:00',1.58),('12664','2013-07-04','18:15:00',1.29),('12664','2013-07-04','18:20:00',1.2),('12664','2013-07-04','18:25:00',1.13),('12664','2013-07-04','18:30:00',1.1),('12664','2013-07-03','07:40:00',1.03),('12664','2013-07-03','07:45:00',1.12),('12664','2013-07-03','07:50:00',1.2),('12664','2013-07-03','07:55:00',1.29),('12664','2013-07-03','08:00:00',1.39),('12664','2013-07-03','08:05:00',1.49),('12664','2013-07-03','08:10:00',1.57),('12664','2013-07-03','08:15:00',1.67),('12664','2013-07-03','08:20:00',1.77),('12664','2013-07-03','08:25:00',1.85),('12664','2013-07-03','08:30:00',1.94),('12664','2013-07-03','08:35:00',2.01),('12664','2013-07-03','08:40:00',2.08),('12664','2013-07-03','08:45:00',2.17),('12664','2013-07-03','08:50:00',2.25),('12664','2013-07-03','08:55:00',2.33),('12664','2013-07-03','09:00:00',2.35),('12664','2013-07-03','09:05:00',2.47),('12664','2013-07-03','09:10:00',2.57),('12664','2013-07-03','09:15:00',2.63),('12664','2013-07-03','09:20:00',2.68),('12664','2013-07-03','09:25:00',2.78),('12664','2013-07-03','09:30:00',2.85),('12664','2013-07-03','09:35:00',2.91),('12664','2013-07-03','09:40:00',2.96),('12664','2013-07-03','09:45:00',3.01),('12664','2013-07-03','09:50:00',3.08),('12664','2013-07-03','09:55:00',3.11),('12664','2013-07-03','10:00:00',3.2),('12664','2013-07-03','10:05:00',3.26),('12664','2013-07-03','10:10:00',3.31),('12664','2013-07-03','10:15:00',3.35),('12664','2013-07-03','10:20:00',3.36),('12664','2013-07-03','10:25:00',3.46),('12664','2013-07-03','10:30:00',3.57),('12664','2013-07-03','10:35:00',3.61),('12664','2013-07-03','10:40:00',3.65),('12664','2013-07-03','10:45:00',3.72),('12664','2013-07-03','10:50:00',3.79),('12664','2013-07-03','10:55:00',3.8),('12664','2013-07-03','11:00:00',3.78),('12664','2013-07-03','11:05:00',3.89),('12664','2013-07-03','11:10:00',3.92),('12664','2013-07-03','11:15:00',3.95),('12664','2013-07-03','11:20:00',3.99),('12664','2013-07-03','11:25:00',4.05),('12664','2013-07-03','11:30:00',4.12),('12664','2013-07-03','11:35:00',4.15),('12664','2013-07-03','11:40:00',4.17),('12664','2013-07-03','11:45:00',4.2),('12664','2013-07-03','11:50:00',4.23),('12664','2013-07-03','11:55:00',4.27),('12664','2013-07-03','12:00:00',4.28),('12664','2013-07-03','12:05:00',4.3),('12664','2013-07-03','12:10:00',4.32),('12664','2013-07-03','12:15:00',4.31),('12664','2013-07-03','12:20:00',4.34),('12664','2013-07-03','12:25:00',4.36),('12664','2013-07-03','12:30:00',4.36),('12664','2013-07-03','12:35:00',4.37),('12664','2013-07-03','12:40:00',4.4),('12664','2013-07-03','12:45:00',4.39),('12664','2013-07-03','12:50:00',4.4),('12664','2013-07-03','12:55:00',4.39),('12664','2013-07-03','13:00:00',4.42),('12664','2013-07-03','13:05:00',4.44),('12664','2013-07-03','13:10:00',4.44),('12664','2013-07-03','13:15:00',4.44),('12664','2013-07-03','13:20:00',4.42),('12664','2013-07-03','13:25:00',4.43),('12664','2013-07-03','13:30:00',4.4),('12664','2013-07-03','13:35:00',4.4),('12664','2013-07-03','13:40:00',4.38),('12664','2013-07-03','13:45:00',4.37),('12664','2013-07-03','13:50:00',4.37),('12664','2013-07-03','13:55:00',4.36),('12664','2013-07-03','14:00:00',4.34),('12664','2013-07-03','14:05:00',4.33),('12664','2013-07-03','14:10:00',4.31),('12664','2013-07-03','14:15:00',4.3),('12664','2013-07-03','14:20:00',4.28),('12664','2013-07-03','14:25:00',4.26),('12664','2013-07-03','14:30:00',4.22),('12664','2013-07-03','14:35:00',4.22),('12664','2013-07-03','14:40:00',4.2),('12664','2013-07-03','14:45:00',4.18),('12664','2013-07-03','14:50:00',4.15),('12664','2013-07-03','14:55:00',4.11),('12664','2013-07-03','15:00:00',4.07),('12664','2013-07-03','15:05:00',4.04),('12664','2013-07-03','15:10:00',4),('12664','2013-07-03','15:15:00',3.96),('12664','2013-07-03','15:20:00',3.92),('12664','2013-07-03','15:25:00',3.87),('12664','2013-07-03','15:30:00',3.81),('12664','2013-07-03','15:35:00',3.77),('12664','2013-07-03','15:40:00',3.73),('12664','2013-07-03','15:45:00',3.69),('12664','2013-07-03','15:50:00',3.64),('12664','2013-07-03','15:55:00',3.58),('12664','2013-07-03','16:00:00',3.53),('12664','2013-07-03','16:05:00',3.46),('12664','2013-07-03','16:10:00',3.41),('12664','2013-07-03','16:15:00',3.35),('12664','2013-07-03','16:20:00',3.29),('12664','2013-07-03','16:25:00',3.24),('12664','2013-07-03','16:30:00',3.17),('12664','2013-07-03','16:35:00',3.1),('12664','2013-07-03','16:40:00',3.04),('12664','2013-07-03','16:45:00',2.97),('12664','2013-07-03','16:50:00',2.89),('12664','2013-07-03','16:55:00',2.83),('12664','2013-07-03','17:00:00',2.76),('12664','2013-07-03','17:05:00',2.68),('12664','2013-07-03','17:10:00',2.61),('12664','2013-07-03','17:15:00',2.53),('12664','2013-07-03','17:20:00',2.45),('12664','2013-07-03','17:25:00',2.35),('12664','2013-07-03','17:30:00',2.28),('12664','2013-07-03','17:35:00',2.19),('12664','2013-07-03','17:40:00',2.09),('12664','2013-07-03','17:45:00',2.01),('12664','2013-07-03','17:50:00',1.92),('12664','2013-07-03','17:55:00',1.84),('12664','2013-07-03','18:00:00',1.74),('12664','2013-07-03','18:05:00',1.65),('12664','2013-07-03','18:10:00',1.56),('12664','2013-07-03','18:15:00',1.47),('12664','2013-07-03','18:20:00',1.38),('12664','2013-07-03','18:25:00',1.28),('12664','2013-07-03','18:30:00',1.19),('12664','2013-07-03','18:35:00',1.1),('12664','2013-07-03','18:40:00',1),('12664','2013-07-02','07:40:00',1),('12664','2013-07-02','07:45:00',1.09),('12664','2013-07-02','07:50:00',1.18),('12664','2013-07-02','07:55:00',1.27),('12664','2013-07-02','08:00:00',1.36),('12664','2013-07-02','08:05:00',1.44),('12664','2013-07-02','08:10:00',1.53),('12664','2013-07-02','08:15:00',1.62),('12664','2013-07-02','08:20:00',1.71),('12664','2013-07-02','08:25:00',1.79),('12664','2013-07-02','08:30:00',1.87),('12664','2013-07-02','08:35:00',1.96),('12664','2013-07-02','08:40:00',2.05),('12664','2013-07-02','08:45:00',2.13),('12664','2013-07-02','08:50:00',2.21),('12664','2013-07-02','08:55:00',2.28),('12664','2013-07-02','09:00:00',2.36),('12664','2013-07-02','09:05:00',2.45),('12664','2013-07-02','09:10:00',2.52),('12664','2013-07-02','09:15:00',2.59),('12664','2013-07-02','09:20:00',2.66),('12664','2013-07-02','09:25:00',2.74),('12664','2013-07-02','09:30:00',2.81),('12664','2013-07-02','09:35:00',2.87),('12664','2013-07-02','09:40:00',2.93),('12664','2013-07-02','09:45:00',2.96),('12664','2013-07-02','09:50:00',3.02),('12664','2013-07-02','09:55:00',3.07),('12664','2013-07-02','10:00:00',3.14),('12664','2013-07-02','10:05:00',3.21),('12664','2013-07-02','10:10:00',3.26),('12664','2013-07-02','10:15:00',3.31),('12664','2013-07-02','10:20:00',3.35),('12664','2013-07-02','10:25:00',3.4),('12664','2013-07-02','10:30:00',3.45),('12664','2013-07-02','10:35:00',3.5),('12664','2013-07-02','10:40:00',3.53),('12664','2013-07-02','10:45:00',3.58),('12664','2013-07-02','10:50:00',3.62),('12664','2013-07-02','10:55:00',3.67),('12664','2013-07-02','11:00:00',3.71),('12664','2013-07-02','11:05:00',3.75),('12664','2013-07-02','11:10:00',3.78),('12664','2013-07-02','11:15:00',3.83),('12664','2013-07-02','11:20:00',3.89),('12664','2013-07-02','11:25:00',3.9),('12664','2013-07-02','11:30:00',3.92),('12664','2013-07-02','11:35:00',3.94),('12664','2013-07-02','11:40:00',3.91),('12664','2013-07-02','11:45:00',3.96),('12664','2013-07-02','11:50:00',4.07),('12664','2013-07-02','11:55:00',4.12),('12664','2013-07-02','12:00:00',4.13),('12664','2013-07-02','12:05:00',4.07),('12664','2013-07-02','12:10:00',4.03),('12664','2013-07-02','12:15:00',4.05),('12664','2013-07-02','12:20:00',4.14),('12664','2013-07-02','12:25:00',4.21),('12664','2013-07-02','12:30:00',4.18),('12664','2013-07-02','12:35:00',4.18),('12664','2013-07-02','12:40:00',4.2),('12664','2013-07-02','12:45:00',4.23),('12664','2013-07-02','12:50:00',4.33),('12664','2013-07-02','12:55:00',4.29),('12664','2013-07-02','13:00:00',4.27),('12664','2013-07-02','13:05:00',4.2),('12664','2013-07-02','13:10:00',4.26),('12664','2013-07-02','13:15:00',4.26),('12664','2013-07-02','13:20:00',4.28),('12664','2013-07-02','13:25:00',4.21),('12664','2013-07-02','13:30:00',4.26),('12664','2013-07-02','13:35:00',4.27),('12664','2013-07-02','13:40:00',4.24),('12664','2013-07-02','13:45:00',4.23),('12664','2013-07-02','13:50:00',4.17),('12664','2013-07-02','13:55:00',4.15),('12664','2013-07-02','14:00:00',4.2),('12664','2013-07-02','14:05:00',4.21),('12664','2013-07-02','14:10:00',4.18),('12664','2013-07-02','14:15:00',4.17),('12664','2013-07-02','14:20:00',4.14),('12664','2013-07-02','14:25:00',4.13),('12664','2013-07-02','14:30:00',4.11),('12664','2013-07-02','14:35:00',4.09),('12664','2013-07-02','14:40:00',4.07),('12664','2013-07-02','14:45:00',4.07),('12664','2013-07-02','14:50:00',4.04),('12664','2013-07-02','14:55:00',4.01),('12664','2013-07-02','15:00:00',3.98),('12664','2013-07-02','15:05:00',3.93),('12664','2013-07-02','15:10:00',3.91),('12664','2013-07-02','15:15:00',3.88),('12664','2013-07-02','15:20:00',3.84),('12664','2013-07-02','15:25:00',3.79),('12664','2013-07-02','15:30:00',3.74),('12664','2013-07-02','15:35:00',3.69),('12664','2013-07-02','15:40:00',3.67),('12664','2013-07-02','15:45:00',3.64),('12664','2013-07-02','15:50:00',3.58),('12664','2013-07-02','15:55:00',3.54),('12664','2013-07-02','16:00:00',3.46),('12664','2013-07-02','16:05:00',3.41),('12664','2013-07-02','16:10:00',3.34),('12664','2013-07-02','16:15:00',3.27),('12664','2013-07-02','16:20:00',3.22),('12664','2013-07-02','16:25:00',3.15),('12664','2013-07-02','16:30:00',3.09),('12664','2013-07-02','16:35:00',3.02),('12664','2013-07-02','16:40:00',2.96),('12664','2013-07-02','16:45:00',2.88),('12664','2013-07-02','16:50:00',2.82),('12664','2013-07-02','16:55:00',2.76),('12664','2013-07-02','17:00:00',2.66),('12664','2013-07-02','17:05:00',2.59),('12664','2013-07-02','17:10:00',2.53),('12664','2013-07-02','17:15:00',2.44),('12664','2013-07-02','17:20:00',2.36),('12664','2013-07-02','17:25:00',2.28),('12664','2013-07-02','17:30:00',2.19),('12664','2013-07-02','17:35:00',2.1),('12664','2013-07-02','17:40:00',2.02),('12664','2013-07-02','17:45:00',1.94),('12664','2013-07-02','17:50:00',1.85),('12664','2013-07-02','17:55:00',1.76),('12664','2013-07-02','18:00:00',1.67),('12664','2013-07-02','18:05:00',1.57),('12664','2013-07-02','18:10:00',1.48),('12664','2013-07-02','18:15:00',1.39),('12664','2013-07-02','18:20:00',1.3),('12664','2013-07-02','18:25:00',1.22),('12664','2013-07-02','18:30:00',1.13),('12664','2013-07-02','18:35:00',1.04),('12664','2013-07-01','07:40:00',1.05),('12664','2013-07-01','07:45:00',1.14),('12664','2013-07-01','07:50:00',1.23),('12664','2013-07-01','07:55:00',1.33),('12664','2013-07-01','08:00:00',1.42),('12664','2013-07-01','08:05:00',1.5),('12664','2013-07-01','08:10:00',1.58),('12664','2013-07-01','08:15:00',1.66),('12664','2013-07-01','08:20:00',1.75),('12664','2013-07-01','08:25:00',1.84),('12664','2013-07-01','08:30:00',1.92),('12664','2013-07-01','08:35:00',2),('12664','2013-07-01','08:40:00',2.09),('12664','2013-07-01','08:45:00',2.18),('12664','2013-07-01','08:50:00',2.27),('12664','2013-07-01','08:55:00',2.34),('12664','2013-07-01','09:00:00',2.43),('12664','2013-07-01','09:05:00',2.52),('12664','2013-07-01','09:10:00',2.59),('12664','2013-07-01','09:15:00',2.67),('12664','2013-07-01','09:20:00',2.75),('12664','2013-07-01','09:25:00',2.82),('12664','2013-07-01','09:30:00',2.92),('12664','2013-07-01','09:35:00',2.99),('12664','2013-07-01','09:40:00',3.04),('12664','2013-07-01','09:45:00',3.11),('12664','2013-07-01','09:50:00',3.16),('12664','2013-07-01','09:55:00',3.23),('12664','2013-07-01','10:00:00',3.28),('12664','2013-07-01','10:05:00',3.31),('12664','2013-07-01','10:10:00',3.36),('12664','2013-07-01','10:15:00',3.43),('12664','2013-07-01','10:20:00',3.49),('12664','2013-07-01','10:25:00',3.52),('12664','2013-07-01','10:30:00',3.58),('12664','2013-07-01','10:35:00',3.67),('12664','2013-07-01','10:40:00',3.67),('12664','2013-07-01','10:45:00',3.68),('12664','2013-07-01','10:50:00',3.71),('12664','2013-07-01','10:55:00',3.77),('12664','2013-07-01','11:00:00',3.79),('12664','2013-07-01','11:05:00',3.8),('12664','2013-07-01','11:10:00',3.83),('12664','2013-07-01','11:15:00',3.84),('12664','2013-07-01','11:20:00',3.93),('12664','2013-07-01','11:25:00',3.98),('12664','2013-07-01','11:30:00',3.99),('12664','2013-07-01','11:35:00',4.02),('12664','2013-07-01','11:40:00',4.01),('12664','2013-07-01','11:45:00',4.01),('12664','2013-07-01','11:50:00',4.06),('12664','2013-07-01','11:55:00',4.07),('12664','2013-07-01','12:00:00',4.1),('12664','2013-07-01','12:05:00',4.09),('12664','2013-07-01','12:10:00',4.1),('12664','2013-07-01','12:15:00',4.16),('12664','2013-07-01','12:20:00',4.13),('12664','2013-07-01','12:25:00',3.99),('12664','2013-07-01','12:30:00',3.67),('12664','2013-07-01','12:35:00',4.16),('12664','2013-07-01','12:40:00',4.35),('12664','2013-07-01','12:45:00',4.32),('12664','2013-07-01','12:50:00',4.17),('12664','2013-07-01','12:55:00',4.14),('12664','2013-07-01','13:00:00',4.2),('12664','2013-07-01','13:05:00',4.39),('12664','2013-07-01','13:10:00',4.31),('12664','2013-07-01','13:15:00',4.3),('12664','2013-07-01','13:20:00',4.33),('12664','2013-07-01','13:25:00',4.22),('12664','2013-07-01','13:30:00',4.25),('12664','2013-07-01','13:35:00',4.28),('12664','2013-07-01','13:40:00',4.32),('12664','2013-07-01','13:45:00',4.37),('12664','2013-07-01','13:50:00',4.32),('12664','2013-07-01','13:55:00',4.31),('12664','2013-07-01','14:00:00',4.33),('12664','2013-07-01','14:05:00',4.27),('12664','2013-07-01','14:10:00',4.29),('12664','2013-07-01','14:15:00',4.25),('12664','2013-07-01','14:20:00',4.2),('12664','2013-07-01','14:25:00',4.14),('12664','2013-07-01','14:30:00',4.14),('12664','2013-07-01','14:35:00',4.14),('12664','2013-07-01','14:40:00',4.09),('12664','2013-07-01','14:45:00',4.08),('12664','2013-07-01','14:50:00',4.02),('12664','2013-07-01','14:55:00',4.01),('12664','2013-07-01','15:00:00',3.97),('12664','2013-07-01','15:05:00',3.97),('12664','2013-07-01','15:10:00',3.93),('12664','2013-07-01','15:15:00',3.91),('12664','2013-07-01','15:20:00',3.83),('12664','2013-07-01','15:25:00',3.77),('12664','2013-07-01','15:30:00',3.73),('12664','2013-07-01','15:35:00',3.68),('12664','2013-07-01','15:40:00',3.63),('12664','2013-07-01','15:45:00',3.61),('12664','2013-07-01','15:50:00',3.53),('12664','2013-07-01','15:55:00',3.48),('12664','2013-07-01','16:00:00',3.44),('12664','2013-07-01','16:05:00',3.31),('12664','2013-07-01','16:10:00',3.28),('12664','2013-07-01','16:15:00',3.26),('12664','2013-07-01','16:20:00',3.19),('12664','2013-07-01','16:25:00',3.13),('12664','2013-07-01','16:30:00',3.06),('12664','2013-07-01','16:35:00',3),('12664','2013-07-01','16:40:00',2.92),('12664','2013-07-01','16:45:00',2.86),('12664','2013-07-01','16:50:00',2.79),('12664','2013-07-01','16:55:00',2.72),('12664','2013-07-01','17:00:00',2.65),('12664','2013-07-01','17:05:00',2.58),('12664','2013-07-01','17:10:00',2.49),('12664','2013-07-01','17:15:00',2.39),('12664','2013-07-01','17:20:00',2.33),('12664','2013-07-01','17:25:00',2.26),('12664','2013-07-01','17:30:00',2.17),('12664','2013-07-01','17:35:00',2.07),('12664','2013-07-01','17:40:00',2),('12664','2013-07-01','17:45:00',1.92),('12664','2013-07-01','17:50:00',1.83),('12664','2013-07-01','17:55:00',1.74),('12664','2013-07-01','18:00:00',1.67),('12664','2013-07-01','18:05:00',1.5),('12664','2013-07-01','18:10:00',1.4),('12664','2013-07-01','18:15:00',1.4),('12664','2013-07-01','18:20:00',1.36),('12664','2013-07-01','18:25:00',1.27),('12664','2013-07-01','18:30:00',1.09),('12664','2013-06-30','07:35:00',1.01),('12664','2013-06-30','07:40:00',1.11),('12664','2013-06-30','07:45:00',1.2),('12664','2013-06-30','07:50:00',1.29),('12664','2013-06-30','07:55:00',1.39),('12664','2013-06-30','08:00:00',1.48),('12664','2013-06-30','08:05:00',1.57),('12664','2013-06-30','08:10:00',1.67),('12664','2013-06-30','08:15:00',1.76),('12664','2013-06-30','08:20:00',1.84),('12664','2013-06-30','08:25:00',1.93),('12664','2013-06-30','08:30:00',2.01),('12664','2013-06-30','08:35:00',2.1),('12664','2013-06-30','08:40:00',2.19),('12664','2013-06-30','08:45:00',2.28),('12664','2013-06-30','08:50:00',2.36),('12664','2013-06-30','08:55:00',2.44),('12664','2013-06-30','09:00:00',2.52),('12664','2013-06-30','09:05:00',2.6),('12664','2013-06-30','09:10:00',2.68),('12664','2013-06-30','09:15:00',2.76),('12664','2013-06-30','09:20:00',2.85),('12664','2013-06-30','09:25:00',2.91),('12664','2013-06-30','09:30:00',2.97),('12664','2013-06-30','09:35:00',3.04),('12664','2013-06-30','09:40:00',3.11),('12664','2013-06-30','09:45:00',3.17),('12664','2013-06-30','09:50:00',3.22),('12664','2013-06-30','09:55:00',3.29),('12664','2013-06-30','10:00:00',3.35),('12664','2013-06-30','10:05:00',3.4),('12664','2013-06-30','10:10:00',3.45),('12664','2013-06-30','10:15:00',3.49),('12664','2013-06-30','10:20:00',3.56),('12664','2013-06-30','10:25:00',3.61),('12664','2013-06-30','10:30:00',3.66),('12664','2013-06-30','10:35:00',3.69),('12664','2013-06-30','10:40:00',3.72),('12664','2013-06-30','10:45:00',3.76),('12664','2013-06-30','10:50:00',3.81),('12664','2013-06-30','10:55:00',3.84),('12664','2013-06-30','11:00:00',3.89),('12664','2013-06-30','11:05:00',3.92),('12664','2013-06-30','11:10:00',3.93),('12664','2013-06-30','11:15:00',3.99),('12664','2013-06-30','11:20:00',4.05),('12664','2013-06-30','11:25:00',4.05),('12664','2013-06-30','11:30:00',4.06),('12664','2013-06-30','11:35:00',4.1),('12664','2013-06-30','11:40:00',4.1),('12664','2013-06-30','11:45:00',4.15),('12664','2013-06-30','11:50:00',4.18),('12664','2013-06-30','11:55:00',4.21),('12664','2013-06-30','12:00:00',4.21),('12664','2013-06-30','12:05:00',4.24),('12664','2013-06-30','12:10:00',4.26),('12664','2013-06-30','12:15:00',4.26),('12664','2013-06-30','12:20:00',4.29),('12664','2013-06-30','12:25:00',4.29),('12664','2013-06-30','12:30:00',4.29),('12664','2013-06-30','12:35:00',4.35),('12664','2013-06-30','12:40:00',4.44),('12664','2013-06-30','12:45:00',4.01),('12664','2013-06-30','12:50:00',4.64),('12664','2013-06-30','12:55:00',2.99),('12664','2013-06-30','13:00:00',3.34),('12664','2013-06-30','13:05:00',4.59),('12664','2013-06-30','13:10:00',2.08),('12664','2013-06-30','13:15:00',1.63),('12664','2013-06-30','13:20:00',4.25),('12664','2013-06-30','13:25:00',4.07),('12664','2013-06-30','13:30:00',2.3),('12664','2013-06-30','13:35:00',3.68),('12664','2013-06-30','13:40:00',3.33),('12664','2013-06-30','13:45:00',3.33),('12664','2013-06-30','13:50:00',3.62),('12664','2013-06-30','13:55:00',4.54),('12664','2013-06-30','14:00:00',4.5),('12664','2013-06-30','14:05:00',4.44),('12664','2013-06-30','14:10:00',4.38),('12664','2013-06-30','14:15:00',4.35),('12664','2013-06-30','14:20:00',4.31),('12664','2013-06-30','14:25:00',4.26),('12664','2013-06-30','14:30:00',4.26),('12664','2013-06-30','14:35:00',4.21),('12664','2013-06-30','14:40:00',4.2),('12664','2013-06-30','14:45:00',4.18),('12664','2013-06-30','14:50:00',4.14),('12664','2013-06-30','14:55:00',4.11),('12664','2013-06-30','15:00:00',4.07),('12664','2013-06-30','15:05:00',4.04),('12664','2013-06-30','15:10:00',4.01),('12664','2013-06-30','15:15:00',3.97),('12664','2013-06-30','15:20:00',3.92),('12664','2013-06-30','15:25:00',3.86),('12664','2013-06-30','15:30:00',3.93),('12664','2013-06-30','15:35:00',2.97),('12664','2013-06-30','15:40:00',3.93),('12664','2013-06-30','15:45:00',3.37),('12664','2013-06-30','15:50:00',3.62),('12664','2013-06-30','15:55:00',2.47),('12664','2013-06-30','16:00:00',3.64),('12664','2013-06-30','16:05:00',3.58),('12664','2013-06-30','16:10:00',2.96),('12664','2013-06-30','16:15:00',2.78),('12664','2013-06-30','16:20:00',3.37),('12664','2013-06-30','16:25:00',3.29),('12664','2013-06-30','16:30:00',3.2),('12664','2013-06-30','16:35:00',3.08),('12664','2013-06-30','16:40:00',2.97),('12664','2013-06-30','16:45:00',2.93),('12664','2013-06-30','16:50:00',2.82),('12664','2013-06-30','16:55:00',2.77),('12664','2013-06-30','17:00:00',2.67),('12664','2013-06-30','17:05:00',2.6),('12664','2013-06-30','17:10:00',2.52),('12664','2013-06-30','17:15:00',2.27),('12664','2013-06-30','17:20:00',2.28),('12664','2013-06-30','17:25:00',2.25),('12664','2013-06-30','17:30:00',2.19),('12664','2013-06-30','17:35:00',2.13),('12664','2013-06-30','17:40:00',2.04),('12664','2013-06-30','17:45:00',1.94),('12664','2013-06-30','17:50:00',1.87),('12664','2013-06-30','17:55:00',1.76),('12664','2013-06-30','18:00:00',1.62),('12664','2013-06-30','18:05:00',1.53),('12664','2013-06-30','18:10:00',1.45),('12664','2013-06-30','18:15:00',1.37),('12664','2013-06-30','18:20:00',1.29),('12664','2013-06-30','18:25:00',1.17),('12664','2013-06-30','18:30:00',1.1),('12664','2013-06-30','18:35:00',1.03),('12664','2014-04-04','12:35:00',1.15),('12664','2014-04-04','12:55:00',1.22),('12664','2014-04-04','13:00:00',1.81),('12664','2014-04-04','13:05:00',1.35),('12664','2014-04-04','13:10:00',3.02),('12664','2014-04-04','13:15:00',3.76),('12664','2014-04-04','13:20:00',1.43),('12664','2014-04-04','13:25:00',2.05),('12664','2014-04-04','13:30:00',3.86),('12664','2014-04-04','13:35:00',1.94),('12664','2014-04-04','13:40:00',1.8),('12664','2014-04-04','13:45:00',1.93),('12664','2014-04-04','13:50:00',2.58),('12664','2014-04-04','13:55:00',2.64),('12664','2014-04-04','14:00:00',2.43),('12664','2014-04-04','14:05:00',2.13),('12664','2014-04-04','14:10:00',1.33),('12664','2014-04-04','14:15:00',1.81),('12664','2014-04-04','14:20:00',1.34),('12664','2014-04-04','14:25:00',1.23),('12664','2014-04-04','14:30:00',1.28),('12664','2014-04-04','14:35:00',1.38),('12664','2014-04-04','14:40:00',2.07),('12664','2014-04-04','14:45:00',1.97),('12664','2014-04-04','14:50:00',2.1),('12664','2014-04-04','14:55:00',2.09),('12664','2014-04-04','15:00:00',2.38),('12664','2014-04-04','15:05:00',1.79),('12664','2014-04-04','15:10:00',1.48),('12664','2014-04-04','15:15:00',3.06),('12664','2014-04-04','15:20:00',2.3),('12664','2014-04-04','15:25:00',2.91),('12664','2014-04-04','15:30:00',2.27),('12664','2014-04-04','15:35:00',2.69),('12664','2014-04-04','15:40:00',1.34),('12664','2014-04-04','15:45:00',1.6),('12664','2014-04-04','15:50:00',2.97),('12664','2014-04-04','15:55:00',3.89),('12664','2014-04-04','16:00:00',2.01),('12664','2014-04-04','16:05:00',1.9),('12664','2014-04-04','16:10:00',1.53),('12664','2014-04-04','16:15:00',2.36),('12664','2014-04-04','16:20:00',1.34),('12664','2014-04-04','16:25:00',1.07),('12664','2014-04-04','16:30:00',2.77),('12664','2014-04-04','16:35:00',2.63),('12664','2014-04-04','16:40:00',3.4),('12664','2014-04-04','16:45:00',1.48),('12664','2014-04-04','16:50:00',1.48),('12664','2014-04-04','16:55:00',1.26),('12664','2014-04-04','17:00:00',1.48),('12664','2014-04-04','17:05:00',1.43),('12664','2014-04-04','17:15:00',1.55),('12664','2014-04-04','17:20:00',2.02),('12664','2014-04-04','17:25:00',1.79),('12664','2014-04-04','17:30:00',1.72),('12664','2014-04-04','17:35:00',1.24),('12664','2014-04-04','17:50:00',1.14),('12664','2013-06-29','07:20:00',1.09),('12664','2013-06-29','07:25:00',1.25),('12664','2013-06-29','07:30:00',1.36),('12664','2013-06-29','07:50:00',1.35),('12664','2013-06-29','08:15:00',1.82),('12664','2013-06-29','08:20:00',1.89),('12664','2013-06-29','08:25:00',1.93),('12664','2013-06-29','08:30:00',1.97),('12664','2013-06-29','08:35:00',2.04),('12664','2013-06-29','08:40:00',2.14),('12664','2013-06-29','08:45:00',2.22),('12664','2013-06-29','08:50:00',2.3),('12664','2013-06-29','08:55:00',2.38),('12664','2013-06-29','09:00:00',2.47),('12664','2013-06-29','09:05:00',2.54),('12664','2013-06-29','09:10:00',2.63),('12664','2013-06-29','09:15:00',2.71),('12664','2013-06-29','09:20:00',2.77),('12664','2013-06-29','09:25:00',2.82),('12664','2013-06-29','09:30:00',2.91),('12664','2013-06-29','09:35:00',2.96),('12664','2013-06-29','09:40:00',3.04),('12664','2013-06-29','09:45:00',3.12),('12664','2013-06-29','09:50:00',3.19),('12664','2013-06-29','09:55:00',3.25),('12664','2013-06-29','10:00:00',3.31),('12664','2013-06-29','10:05:00',3.37),('12664','2013-06-29','10:10:00',3.42),('12664','2013-06-29','10:15:00',3.46),('12664','2013-06-29','10:20:00',3.53),('12664','2013-06-29','10:25:00',3.59),('12664','2013-06-29','10:30:00',3.61),('12664','2013-06-29','10:35:00',3.66),('12664','2013-06-29','10:40:00',3.48),('12664','2013-06-29','10:45:00',2.94),('12664','2013-06-29','10:50:00',3.76),('12664','2013-06-29','10:55:00',3.92),('12664','2013-06-29','11:00:00',2.39),('12664','2013-06-29','11:10:00',4.37),('12664','2013-06-29','11:15:00',4.38),('12664','2013-06-29','11:20:00',4.4),('12664','2013-06-29','11:25:00',4.25),('12664','2013-06-29','11:30:00',4.28),('12664','2013-06-29','11:35:00',3.97),('12664','2013-06-29','11:40:00',1.74),('12664','2013-06-29','11:45:00',4.49),('12664','2013-06-29','11:50:00',4.45),('12664','2013-06-29','11:55:00',4.37),('12664','2013-06-29','12:00:00',4.34),('12664','2013-06-29','12:05:00',4.4),('12664','2013-06-29','12:10:00',3),('12664','2013-06-29','12:15:00',4.68),('12664','2013-06-29','12:20:00',4.72),('12664','2013-06-29','12:25:00',3.33),('12664','2013-06-29','12:30:00',1.49),('12664','2013-06-29','12:35:00',1.29),('12664','2013-06-29','12:40:00',3.98),('12664','2013-06-29','12:45:00',5.04),('12664','2013-06-29','12:50:00',4.92),('12664','2013-06-29','12:55:00',4.97),('12664','2013-06-29','13:00:00',4.78),('12664','2013-06-29','13:05:00',3.95),('12664','2013-06-29','13:10:00',2),('12664','2013-06-29','13:15:00',5.04),('12664','2013-06-29','13:20:00',4.09),('12664','2013-06-29','13:25:00',4.6),('12664','2013-06-29','13:30:00',4.14),('12664','2013-06-29','13:35:00',4.79),('12664','2013-06-29','13:40:00',4.62),('12664','2013-06-29','13:45:00',4.62),('12664','2013-06-29','13:50:00',4.56),('12664','2013-06-29','13:55:00',4.51),('12664','2013-06-29','14:00:00',3.84),('12664','2013-06-29','14:05:00',2.06),('12664','2013-06-29','14:10:00',4.06),('12664','2013-06-29','14:15:00',4.64),('12664','2013-06-29','14:20:00',4.56),('12664','2013-06-29','14:25:00',4.48),('12664','2013-06-29','14:30:00',4.5),('12664','2013-06-29','14:35:00',4.53),('12664','2013-06-29','14:40:00',4.48),('12664','2013-06-29','14:45:00',4.36),('12664','2013-06-29','14:50:00',4.46),('12664','2013-06-29','14:55:00',4.48),('12664','2013-06-29','15:00:00',4.51),('12664','2013-06-29','15:05:00',4.7),('12664','2013-06-29','15:10:00',4.63),('12664','2013-06-29','15:15:00',3.16),('12664','2013-06-29','15:20:00',1.91),('12664','2013-06-29','15:25:00',1.55),('12664','2013-06-29','15:30:00',2.04),('12664','2013-06-29','15:35:00',1.85),('12664','2013-06-29','16:20:00',1.22),('12664','2013-06-29','16:25:00',2.4),('12664','2013-06-29','16:30:00',3.16),('12664','2013-06-29','16:35:00',4.14),('12664','2013-06-29','16:40:00',2.95),('12664','2013-06-29','16:45:00',1.54),('12664','2013-06-29','16:50:00',1.82),('12664','2013-06-29','16:55:00',2.09),('12664','2013-06-29','17:00:00',2.16),('12664','2013-06-29','17:05:00',1.87),('12664','2013-06-29','17:10:00',1.91),('12664','2013-06-29','17:15:00',2.84),('12664','2013-06-29','17:20:00',1.97),('12664','2013-06-29','17:25:00',2.49),('12664','2013-06-29','17:30:00',2.38),('12664','2013-06-29','17:35:00',2.37),('12664','2013-06-29','17:40:00',1.73),('12664','2013-06-29','18:30:00',1.2),('12664','2013-06-29','18:55:00',1.02),('12664','2013-06-29','19:00:00',1.04),('12664','2013-06-28','07:45:00',1.18),('12664','2013-06-28','07:50:00',1.29),('12664','2013-06-28','07:55:00',1.17),('12664','2013-06-28','08:00:00',1.47),('12664','2013-06-28','08:05:00',1.55),('12664','2013-06-28','08:10:00',1.56),('12664','2013-06-28','08:15:00',1.51),('12664','2013-06-28','08:20:00',1.76),('12664','2013-06-28','08:25:00',1.9),('12664','2013-06-28','08:30:00',1.98),('12664','2013-06-28','08:35:00',2.07),('12664','2013-06-28','08:40:00',2.16),('12664','2013-06-28','08:45:00',2.32),('12664','2013-06-28','08:50:00',2.44),('12664','2013-06-28','08:55:00',2.44),('12664','2013-06-28','09:00:00',2.53),('12664','2013-06-28','09:05:00',2.3),('12664','2013-06-28','09:10:00',3.07),('12664','2013-06-28','09:15:00',2.89),('12664','2013-06-28','09:20:00',2.85),('12664','2013-06-28','09:25:00',2.68),('12664','2013-06-28','09:30:00',2.68),('12664','2013-06-28','09:35:00',2.56),('12664','2013-06-28','09:40:00',1.77),('12664','2013-06-28','09:45:00',1.03),('12664','2013-06-28','09:55:00',1.48),('12664','2013-06-28','10:00:00',3.8),('12664','2013-06-28','10:05:00',3.78),('12664','2013-06-28','10:10:00',2.55),('12664','2013-06-28','10:15:00',1.52),('12664','2013-06-28','10:20:00',1.22),('12664','2013-06-28','10:25:00',4.12),('12664','2013-06-28','10:30:00',4),('12664','2013-06-28','10:35:00',1.78),('12664','2013-06-28','10:40:00',1.51),('12664','2013-06-28','10:45:00',3.16),('12664','2013-06-28','10:50:00',4.33),('12664','2013-06-28','10:55:00',3.38),('12664','2013-06-28','11:00:00',3.59),('12664','2013-06-28','11:05:00',3.95),('12664','2013-06-28','11:10:00',4.18),('12664','2013-06-28','11:15:00',3.78),('12664','2013-06-28','11:20:00',4.1),('12664','2013-06-28','11:25:00',4.61),('12664','2013-06-28','11:30:00',4.16),('12664','2013-06-28','11:35:00',4.24),('12664','2013-06-28','11:40:00',3.37),('12664','2013-06-28','11:45:00',4.51),('12664','2013-06-28','11:50:00',4.08),('12664','2013-06-28','11:55:00',2.63),('12664','2013-06-28','12:00:00',3.23),('12664','2013-06-28','12:05:00',4.81),('12664','2013-06-28','12:10:00',3.29),('12664','2013-06-28','12:15:00',3.93),('12664','2013-06-28','12:20:00',4.5),('12664','2013-06-28','12:25:00',4.07),('12664','2013-06-28','12:30:00',4.62),('12664','2013-06-28','12:35:00',4.59),('12664','2013-06-28','12:40:00',4.67),('12664','2013-06-28','12:45:00',4.56),('12664','2013-06-28','12:50:00',4.47),('12664','2013-06-28','12:55:00',4.27),('12664','2013-06-28','13:00:00',2.07),('12664','2013-06-28','13:05:00',3.05),('12664','2013-06-28','13:10:00',3.56),('12664','2013-06-28','13:15:00',4.79),('12664','2013-06-28','13:20:00',4.64),('12664','2013-06-28','13:25:00',4.57),('12664','2013-06-28','13:30:00',2.2),('12664','2013-06-28','13:35:00',4.52),('12664','2013-06-28','13:40:00',4.36),('12664','2013-06-28','13:45:00',4.12),('12664','2013-06-28','13:50:00',4.06),('12664','2013-06-28','13:55:00',4.19),('12664','2013-06-28','14:00:00',4.63),('12664','2013-06-28','14:05:00',4.65),('12664','2013-06-28','14:10:00',4.56),('12664','2013-06-28','14:15:00',3.43),('12664','2013-06-28','14:20:00',4.74),('12664','2013-06-28','14:25:00',2.76),('12664','2013-06-28','14:30:00',2.43),('12664','2013-06-28','14:35:00',4.35),('12664','2013-06-28','14:40:00',4.33),('12664','2013-06-28','14:45:00',2.77),('12664','2013-06-28','14:50:00',1.67),('12664','2013-06-28','14:55:00',2.51),('12664','2013-06-28','15:00:00',3.11),('12664','2013-06-28','15:05:00',3.51),('12664','2013-06-28','15:10:00',3.29),('12664','2013-06-28','15:15:00',3.16),('12664','2013-06-28','15:20:00',2.64),('12664','2013-06-28','15:25:00',4.57),('12664','2013-06-28','15:30:00',4),('12664','2013-06-28','15:35:00',3.56),('12664','2013-06-28','15:40:00',2.49),('12664','2013-06-28','15:45:00',3.75),('12664','2013-06-28','15:50:00',2.92),('12664','2013-06-28','15:55:00',3.88),('12664','2013-06-28','16:00:00',3.9),('12664','2013-06-28','16:05:00',3.99),('12664','2013-06-28','16:10:00',2.59),('12664','2013-06-28','16:15:00',2.67),('12664','2013-06-28','16:20:00',3.66),('12664','2013-06-28','16:25:00',2.96),('12664','2013-06-28','16:30:00',2.57),('12664','2013-06-28','16:35:00',1.15),('12664','2013-06-28','16:40:00',1.99),('12664','2013-06-28','16:45:00',3.47),('12664','2013-06-28','16:50:00',1.84),('12664','2013-06-28','16:55:00',3.15),('12664','2013-06-28','17:00:00',2.61),('12664','2013-06-28','17:05:00',2.72),('12664','2013-06-28','17:10:00',2.74),('12664','2013-06-28','17:15:00',2.5),('12664','2013-06-28','17:20:00',2.4),('12664','2013-06-28','17:25:00',2.29),('12664','2013-06-28','17:30:00',2.19),('12664','2013-06-28','17:35:00',2.13),('12664','2013-06-28','17:40:00',2.06),('12664','2013-06-28','17:45:00',1.98),('12664','2013-06-28','17:50:00',1.88),('12664','2013-06-28','17:55:00',1.8),('12664','2013-06-28','18:00:00',1.72),('12664','2013-06-28','18:05:00',1.7),('12664','2013-06-28','18:10:00',1.64),('12664','2013-06-28','18:15:00',1.44),('12664','2013-06-28','18:20:00',1.35),('12664','2013-06-28','18:25:00',1.27),('12664','2013-06-28','18:30:00',1.23),('12664','2013-06-28','18:35:00',1.11),('12664','2013-06-28','18:40:00',1.01),('12664','2013-06-27','07:40:00',1.06),('12664','2013-06-27','07:45:00',1.17),('12664','2013-06-27','07:50:00',1.28),('12664','2013-06-27','07:55:00',1.37),('12664','2013-06-27','08:00:00',1.43),('12664','2013-06-27','08:05:00',1.57),('12664','2013-06-27','08:10:00',1.64),('12664','2013-06-27','08:15:00',1.72),('12664','2013-06-27','08:20:00',1.83),('12664','2013-06-27','08:25:00',1.9),('12664','2013-06-27','08:30:00',1.96),('12664','2013-06-27','08:35:00',2.04),('12664','2013-06-27','08:40:00',2.12),('12664','2013-06-27','08:45:00',2.21),('12664','2013-06-27','08:50:00',2.3),('12664','2013-06-27','08:55:00',2.41),('12664','2013-06-27','09:00:00',2.49),('12664','2013-06-27','09:05:00',2.58),('12664','2013-06-27','09:10:00',2.66),('12664','2013-06-27','09:15:00',2.73),('12664','2013-06-27','09:20:00',2.79),('12664','2013-06-27','09:25:00',2.88),('12664','2013-06-27','09:30:00',2.97),('12664','2013-06-27','09:35:00',3.03),('12664','2013-06-27','09:40:00',3.06),('12664','2013-06-27','09:45:00',3.13),('12664','2013-06-27','09:50:00',3.19),('12664','2013-06-27','09:55:00',3.23),('12664','2013-06-27','10:00:00',3.28),('12664','2013-06-27','10:05:00',3.35),('12664','2013-06-27','10:10:00',3.42),('12664','2013-06-27','10:15:00',3.45),('12664','2013-06-27','10:20:00',3.54),('12664','2013-06-27','10:25:00',3.62),('12664','2013-06-27','10:30:00',3.82),('12664','2013-06-27','10:35:00',3.98),('12664','2013-06-27','10:40:00',3.82),('12664','2013-06-27','10:45:00',3.98),('12664','2013-06-27','10:50:00',4.07),('12664','2013-06-27','10:55:00',4.11),('12664','2013-06-27','11:00:00',4.24),('12664','2013-06-27','11:05:00',4.26),('12664','2013-06-27','11:10:00',4.25),('12664','2013-06-27','11:15:00',4.25),('12664','2013-06-27','11:20:00',2.3),('12664','2013-06-27','11:25:00',1.05),('12664','2013-06-27','11:30:00',1.08),('12664','2013-06-27','11:35:00',1.08),('12664','2013-06-27','11:40:00',1.14),('12664','2013-06-27','11:45:00',1.02),('12664','2013-06-27','11:50:00',1.07),('12664','2013-06-27','11:55:00',1.12),('12664','2013-06-27','12:00:00',1.16),('12664','2013-06-27','12:05:00',1.07),('12664','2013-06-27','12:10:00',1.07),('12664','2013-06-27','12:15:00',1.14),('12664','2013-06-27','12:20:00',1.06),('12664','2013-06-27','12:25:00',1.02),('12664','2013-06-27','12:30:00',1.07),('12664','2013-06-27','12:35:00',1.18),('12664','2013-06-27','12:40:00',1.26),('12664','2013-06-27','12:45:00',1.4),('12664','2013-06-27','12:50:00',1.47),('12664','2013-06-27','12:55:00',1.61),('12664','2013-06-27','13:00:00',2.99),('12664','2013-06-27','13:05:00',5.03),('12664','2013-06-27','13:10:00',2.4),('12664','2013-06-27','13:15:00',2.64),('12664','2013-06-27','13:20:00',2.08),('12664','2013-06-27','13:25:00',3.95),('12664','2013-06-27','13:30:00',4.56),('12664','2013-06-27','13:35:00',3.61),('12664','2013-06-27','13:40:00',2.69),('12664','2013-06-27','13:45:00',3.36),('12664','2013-06-27','13:50:00',4.49),('12664','2013-06-27','13:55:00',4.46),('12664','2013-06-27','14:00:00',4.34),('12664','2013-06-27','14:05:00',4.31),('12664','2013-06-27','14:10:00',4.3),('12664','2013-06-27','14:15:00',4.3),('12664','2013-06-27','14:20:00',4.29),('12664','2013-06-27','14:25:00',3.68),('12664','2013-06-27','14:30:00',3.87),('12664','2013-06-27','14:35:00',4.27),('12664','2013-06-27','14:40:00',4.18),('12664','2013-06-27','14:45:00',4.08),('12664','2013-06-27','14:50:00',4.01),('12664','2013-06-27','14:55:00',3.97),('12664','2013-06-27','15:00:00',3.99),('12664','2013-06-27','15:05:00',3.93),('12664','2013-06-27','15:10:00',3.94),('12664','2013-06-27','15:15:00',3.91),('12664','2013-06-27','15:20:00',3.9),('12664','2013-06-27','15:25:00',3.87),('12664','2013-06-27','15:30:00',3.81),('12664','2013-06-27','15:35:00',3.73),('12664','2013-06-27','15:40:00',3.63),('12664','2013-06-27','15:45:00',3.59),('12664','2013-06-27','15:50:00',3.52),('12664','2013-06-27','15:55:00',3.45),('12664','2013-06-27','16:00:00',3.4),('12664','2013-06-27','16:05:00',3.36),('12664','2013-06-27','16:10:00',3.33),('12664','2013-06-27','16:15:00',3.24),('12664','2013-06-27','16:20:00',3.21),('12664','2013-06-27','16:25:00',3.14),('12664','2013-06-27','16:30:00',2.98),('12664','2013-06-27','16:35:00',2.95),('12664','2013-06-27','16:40:00',2.94),('12664','2013-06-27','16:45:00',2.83),('12664','2013-06-27','16:50:00',2.77),('12664','2013-06-27','16:55:00',2.71),('12664','2013-06-27','17:00:00',2.6),('12664','2013-06-27','17:05:00',2.49),('12664','2013-06-27','17:10:00',2.38),('12664','2013-06-27','17:15:00',2.43),('12664','2013-06-27','17:20:00',2.34),('12664','2013-06-27','17:25:00',2.32),('12664','2013-06-27','17:30:00',2.23),('12664','2013-06-27','17:35:00',2.14),('12664','2013-06-27','17:40:00',2.01),('12664','2013-06-27','17:45:00',1.95),('12664','2013-06-27','17:50:00',1.87),('12664','2013-06-27','17:55:00',1.79),('12664','2013-06-27','18:00:00',1.72),('12664','2013-06-27','18:05:00',1.64),('12664','2013-06-27','18:10:00',1.52),('12664','2013-06-27','18:15:00',1.37),('12664','2013-06-27','18:20:00',1.3),('12664','2013-06-27','18:25:00',1.16),('12664','2013-06-27','18:30:00',1.07),('12664','2013-06-26','07:40:00',1.09),('12664','2013-06-26','07:45:00',1.18),('12664','2013-06-26','07:50:00',1.25),('12664','2013-06-26','07:55:00',1.34),('12664','2013-06-26','08:00:00',1.44),('12664','2013-06-26','08:05:00',1.54),('12664','2013-06-26','08:10:00',1.63),('12664','2013-06-26','08:15:00',1.72),('12664','2013-06-26','08:20:00',1.82),('12664','2013-06-26','08:25:00',1.9),('12664','2013-06-26','08:30:00',1.98),('12664','2013-06-26','08:35:00',2.07),('12664','2013-06-26','08:40:00',2.16),('12664','2013-06-26','08:45:00',2.23),('12664','2013-06-26','08:50:00',2.33),('12664','2013-06-26','08:55:00',2.41),('12664','2013-06-26','09:00:00',2.48),('12664','2013-06-26','09:05:00',2.53),('12664','2013-06-26','09:10:00',2.6),('12664','2013-06-26','09:15:00',2.69),('12664','2013-06-26','09:20:00',2.77),('12664','2013-06-26','09:25:00',2.83),('12664','2013-06-26','09:30:00',2.9),('12664','2013-06-26','09:35:00',2.96),('12664','2013-06-26','09:40:00',3),('12664','2013-06-26','09:45:00',3.07),('12664','2013-06-26','09:50:00',3.13),('12664','2013-06-26','09:55:00',3.18),('12664','2013-06-26','10:00:00',3.25),('12664','2013-06-26','10:05:00',3.34),('12664','2013-06-26','10:10:00',3.39),('12664','2013-06-26','10:15:00',3.44),('12664','2013-06-26','10:20:00',3.48),('12664','2013-06-26','10:25:00',3.53),('12664','2013-06-26','10:30:00',3.55),('12664','2013-06-26','10:35:00',3.6),('12664','2013-06-26','10:40:00',3.68),('12664','2013-06-26','10:45:00',3.71),('12664','2013-06-26','10:50:00',3.77),('12664','2013-06-26','10:55:00',3.8),('12664','2013-06-26','11:00:00',3.84),('12664','2013-06-26','11:05:00',3.86),('12664','2013-06-26','11:10:00',3.9),('12664','2013-06-26','11:15:00',3.91),('12664','2013-06-26','11:20:00',3.97),('12664','2013-06-26','11:25:00',4),('12664','2013-06-26','11:30:00',4.01),('12664','2013-06-26','11:35:00',4.06),('12664','2013-06-26','11:40:00',4.09),('12664','2013-06-26','11:45:00',4.13),('12664','2013-06-26','11:50:00',4.14),('12664','2013-06-26','11:55:00',4.16),('12664','2013-06-26','12:00:00',4.16),('12664','2013-06-26','12:05:00',4.17),('12664','2013-06-26','12:10:00',4.2),('12664','2013-06-26','12:15:00',4.19),('12664','2013-06-26','12:20:00',2.28),('12664','2013-06-26','12:25:00',4.21),('12664','2013-06-26','12:30:00',4.4),('12664','2013-06-26','12:35:00',4.46),('12664','2013-06-26','12:40:00',4.03),('12664','2013-06-26','12:45:00',1.83),('12664','2013-06-26','12:50:00',3.71),('12664','2013-06-26','12:55:00',2.96),('12664','2013-06-26','13:00:00',1.84),('12664','2013-06-26','13:05:00',1.08),('12664','2013-06-26','13:10:00',1.41),('12664','2013-06-26','13:15:00',2.63),('12664','2013-06-26','13:20:00',1.16),('12664','2013-06-26','13:25:00',1.55),('12664','2013-06-26','13:30:00',4.81),('12664','2013-06-26','13:35:00',4.7),('12664','2013-06-26','13:40:00',4.61),('12664','2013-06-26','13:45:00',4.54),('12664','2013-06-26','13:50:00',4.39),('12664','2013-06-26','13:55:00',4.34),('12664','2013-06-26','14:00:00',4.3),('12664','2013-06-26','14:05:00',4.28),('12664','2013-06-26','14:10:00',4.31),('12664','2013-06-26','14:15:00',4.3),('12664','2013-06-26','14:20:00',4.24),('12664','2013-06-26','14:25:00',4.23),('12664','2013-06-26','14:30:00',4.2),('12664','2013-06-26','14:35:00',4.19),('12664','2013-06-26','14:40:00',4.17),('12664','2013-06-26','14:45:00',4.15),('12664','2013-06-26','14:50:00',4.12),('12664','2013-06-26','14:55:00',4.08),('12664','2013-06-26','15:00:00',4.06),('12664','2013-06-26','15:05:00',4.01),('12664','2013-06-26','15:10:00',3.97),('12664','2013-06-26','15:15:00',3.92),('12664','2013-06-26','15:20:00',3.88),('12664','2013-06-26','15:25:00',3.83),('12664','2013-06-26','15:30:00',3.78),('12664','2013-06-26','15:35:00',3.72),('12664','2013-06-26','15:40:00',3.68),('12664','2013-06-26','15:45:00',3.63),('12664','2013-06-26','15:50:00',3.61),('12664','2013-06-26','15:55:00',3.56),('12664','2013-06-26','16:00:00',3.49),('12664','2013-06-26','16:05:00',3.41),('12664','2013-06-26','16:10:00',3.36),('12664','2013-06-26','16:15:00',3.3),('12664','2013-06-26','16:20:00',3.24),('12664','2013-06-26','16:25:00',3.17),('12664','2013-06-26','16:30:00',3.1),('12664','2013-06-26','16:35:00',3.02),('12664','2013-06-26','16:40:00',2.95),('12664','2013-06-26','16:45:00',2.88),('12664','2013-06-26','16:50:00',2.82),('12664','2013-06-26','16:55:00',2.75),('12664','2013-06-26','17:00:00',2.66),('12664','2013-06-26','17:05:00',2.59),('12664','2013-06-26','17:10:00',2.51),('12664','2013-06-26','17:15:00',2.43),('12664','2013-06-26','17:20:00',2.35),('12664','2013-06-26','17:25:00',2.27),('12664','2013-06-26','17:30:00',2.2),('12664','2013-06-26','17:35:00',2.13),('12664','2013-06-26','17:40:00',2.02),('12664','2013-06-26','17:45:00',1.95),('12664','2013-06-26','17:50:00',1.86),('12664','2013-06-26','17:55:00',1.76),('12664','2013-06-26','18:00:00',1.64),('12664','2013-06-26','18:05:00',1.55),('12664','2013-06-26','18:10:00',1.44),('12664','2013-06-26','18:15:00',1.22),('12664','2013-06-26','18:25:00',1.22),('12664','2013-06-26','18:30:00',1.38),('12664','2013-06-26','18:35:00',1.04),('12664','2013-06-26','18:40:00',1.07),('12664','2013-06-25','07:50:00',1.22),('12664','2013-06-25','07:55:00',1.5),('12664','2013-06-25','08:00:00',1.52),('12664','2013-06-25','08:05:00',1.6),('12664','2013-06-25','08:10:00',1.71),('12664','2013-06-25','08:15:00',1.77),('12664','2013-06-25','08:20:00',1.83),('12664','2013-06-25','08:25:00',1.95),('12664','2013-06-25','08:30:00',2.02),('12664','2013-06-25','08:35:00',2.09),('12664','2013-06-25','08:40:00',2.19),('12664','2013-06-25','08:45:00',2.17),('12664','2013-06-25','08:50:00',1.87),('12664','2013-06-25','08:55:00',2.43),('12664','2013-06-25','09:00:00',2.56),('12664','2013-06-25','09:05:00',2.61),('12664','2013-06-25','09:10:00',2.65),('12664','2013-06-25','09:15:00',2.75),('12664','2013-06-25','09:20:00',2.83),('12664','2013-06-25','09:25:00',2.92),('12664','2013-06-25','09:30:00',2.99),('12664','2013-06-25','09:35:00',3.08),('12664','2013-06-25','09:40:00',3.16),('12664','2013-06-25','09:45:00',3.18),('12664','2013-06-25','09:50:00',3.29),('12664','2013-06-25','09:55:00',1.24),('12664','2013-06-25','10:05:00',2.3),('12664','2013-06-25','10:10:00',3.52),('12664','2013-06-25','10:15:00',1.02),('12664','2013-06-25','10:30:00',1.45),('12664','2013-06-25','10:35:00',4.14),('12664','2013-06-25','10:40:00',3.95),('12664','2013-06-25','10:45:00',4.01),('12664','2013-06-25','10:50:00',4.07),('12664','2013-06-25','10:55:00',4.03),('12664','2013-06-25','11:00:00',4.08),('12664','2013-06-25','11:05:00',4.17),('12664','2013-06-25','11:10:00',3.97),('12664','2013-06-25','11:15:00',4.47),('12664','2013-06-25','11:20:00',1.52),('12664','2013-06-25','11:25:00',1.36),('12664','2013-06-25','11:30:00',1.43),('12664','2013-06-25','11:35:00',1.62),('12664','2013-06-25','11:40:00',2.43),('12664','2013-06-25','11:45:00',4.67),('12664','2013-06-25','11:50:00',4.39),('12664','2013-06-25','11:55:00',2.69),('12664','2013-06-25','12:00:00',3.17),('12664','2013-06-25','12:05:00',3.88),('12664','2013-06-25','12:10:00',3.17),('12664','2013-06-25','12:15:00',4.71),('12664','2013-06-25','12:20:00',4.6),('12664','2013-06-25','12:25:00',4.49),('12664','2013-06-25','12:30:00',4.52),('12664','2013-06-25','12:35:00',4.5),('12664','2013-06-25','12:40:00',3.05),('12664','2013-06-25','12:45:00',4.61),('12664','2013-06-25','12:50:00',4.7),('12664','2013-06-25','12:55:00',4.62),('12664','2013-06-25','13:00:00',4.55),('12664','2013-06-25','13:05:00',4.45),('12664','2013-06-25','13:10:00',4.41),('12664','2013-06-25','13:15:00',4.44),('12664','2013-06-25','13:20:00',4.45),('12664','2013-06-25','13:25:00',4.43),('12664','2013-06-25','13:30:00',4.45),('12664','2013-06-25','13:35:00',4.44),('12664','2013-06-25','13:40:00',4.39),('12664','2013-06-25','13:45:00',4.39),('12664','2013-06-25','13:50:00',4.37),('12664','2013-06-25','13:55:00',4.34),('12664','2013-06-25','14:00:00',4.33),('12664','2013-06-25','14:05:00',4.28),('12664','2013-06-25','14:10:00',4.3),('12664','2013-06-25','14:15:00',4.27),('12664','2013-06-25','14:20:00',4.28),('12664','2013-06-25','14:25:00',4.25),('12664','2013-06-25','14:30:00',4.2),('12664','2013-06-25','14:35:00',4.18),('12664','2013-06-25','14:40:00',4.18),('12664','2013-06-25','14:45:00',4.1),('12664','2013-06-25','14:50:00',4.13),('12664','2013-06-25','14:55:00',4.04),('12664','2013-06-25','15:00:00',4.04),('12664','2013-06-25','15:05:00',4.01),('12664','2013-06-25','15:10:00',3.99),('12664','2013-06-25','15:15:00',3.94),('12664','2013-06-25','15:20:00',3.88),('12664','2013-06-25','15:25:00',3.83),('12664','2013-06-25','15:30:00',3.79),('12664','2013-06-25','15:35:00',3.72),('12664','2013-06-25','15:40:00',3.65),('12664','2013-06-25','15:45:00',3.6),('12664','2013-06-25','15:50:00',3.55),('12664','2013-06-25','15:55:00',3.49),('12664','2013-06-25','16:00:00',3.45),('12664','2013-06-25','16:05:00',3.39),('12664','2013-06-25','16:10:00',3.33),('12664','2013-06-25','16:15:00',3.27),('12664','2013-06-25','16:20:00',3.22),('12664','2013-06-25','16:25:00',3.15),('12664','2013-06-25','16:30:00',3.06),('12664','2013-06-25','16:35:00',3.01),('12664','2013-06-25','16:40:00',2.93),('12664','2013-06-25','16:45:00',2.87),('12664','2013-06-25','16:50:00',2.8),('12664','2013-06-25','16:55:00',2.73),('12664','2013-06-25','17:00:00',2.65),('12664','2013-06-25','17:05:00',2.58),('12664','2013-06-25','17:10:00',2.49),('12664','2013-06-25','17:15:00',2.42),('12664','2013-06-25','17:20:00',2.34),('12664','2013-06-25','17:25:00',2.25),('12664','2013-06-25','17:30:00',2.17),('12664','2013-06-25','17:35:00',2.08),('12664','2013-06-25','17:40:00',2),('12664','2013-06-25','17:45:00',1.93),('12664','2013-06-25','17:50:00',1.83),('12664','2013-06-25','17:55:00',1.73),('12664','2013-06-25','18:00:00',1.64),('12664','2013-06-25','18:05:00',1.56),('12664','2013-06-25','18:10:00',1.46),('12664','2013-06-25','18:15:00',1.38),('12664','2013-06-25','18:20:00',1.29),('12664','2013-06-25','18:25:00',1.22),('12664','2013-06-25','18:30:00',1.13),('12664','2013-06-25','18:35:00',1.04),('12664','2013-06-24','08:10:00',1.57),('12664','2013-06-24','08:15:00',2.03),('12664','2013-06-24','08:20:00',1.49),('12664','2013-06-24','08:25:00',1.72),('12664','2013-06-24','08:30:00',1.41),('12664','2013-06-24','08:40:00',2.24),('12664','2013-06-24','08:45:00',2.2),('12664','2013-06-24','08:50:00',2.63),('12664','2013-06-24','08:55:00',1.59),('12664','2013-06-24','09:00:00',2.82),('12664','2013-06-24','09:05:00',2.97),('12664','2013-06-24','09:10:00',2.64),('12664','2013-06-24','09:15:00',3.05),('12664','2013-06-24','09:20:00',2.57),('12664','2013-06-24','09:25:00',1.19),('12664','2013-06-24','09:30:00',2.98),('12664','2013-06-24','09:35:00',3.27),('12664','2013-06-24','09:40:00',3.53),('12664','2013-06-24','09:45:00',2.59),('12664','2013-06-24','09:50:00',2.61),('12664','2013-06-24','09:55:00',3.52),('12664','2013-06-24','10:00:00',3.68),('12664','2013-06-24','10:05:00',3.32),('12664','2013-06-24','10:10:00',3.77),('12664','2013-06-24','10:15:00',3.79),('12664','2013-06-24','10:20:00',3.93),('12664','2013-06-24','10:25:00',3.04),('12664','2013-06-24','10:30:00',4.09),('12664','2013-06-24','10:35:00',3.1),('12664','2013-06-24','10:40:00',4.32),('12664','2013-06-24','10:45:00',3.82),('12664','2013-06-24','10:50:00',2.25),('12664','2013-06-24','10:55:00',2.65),('12664','2013-06-24','11:00:00',2.28),('12664','2013-06-24','11:05:00',1.96),('12664','2013-06-24','11:10:00',4.98),('12664','2013-06-24','11:15:00',1.21),('12664','2013-06-24','11:20:00',2.5),('12664','2013-06-24','11:25:00',1.34),('12664','2013-06-24','11:30:00',1.36),('12664','2013-06-24','11:35:00',2.2),('12664','2013-06-24','11:40:00',2.57),('12664','2013-06-24','11:45:00',1.7),('12664','2013-06-24','11:50:00',2.32),('12664','2013-06-24','11:55:00',2.98),('12664','2013-06-24','12:00:00',2.16),('12664','2013-06-24','12:05:00',4.07),('12664','2013-06-24','12:10:00',4.71),('12664','2013-06-24','12:15:00',2.84),('12664','2013-06-24','12:20:00',4.08),('12664','2013-06-24','12:25:00',2.82),('12664','2013-06-24','12:30:00',3.05),('12664','2013-06-24','12:35:00',3.7),('12664','2013-06-24','12:40:00',4.37),('12664','2013-06-24','12:45:00',3.73),('12664','2013-06-24','12:50:00',4.06),('12664','2013-06-24','12:55:00',4.31),('12664','2013-06-24','13:00:00',4.1),('12664','2013-06-24','13:05:00',3.56),('12664','2013-06-24','13:10:00',4.2),('12664','2013-06-24','13:15:00',4.34),('12664','2013-06-24','13:20:00',3.73),('12664','2013-06-24','13:25:00',2.56),('12664','2013-06-24','13:30:00',3.48),('12664','2013-06-24','13:35:00',4.52),('12664','2013-06-24','13:40:00',4.56),('12664','2013-06-24','13:45:00',4.64),('12664','2013-06-24','13:50:00',4.82),('12664','2013-06-24','13:55:00',4.05),('12664','2013-06-24','14:00:00',4.49),('12664','2013-06-24','14:05:00',4.58),('12664','2013-06-24','14:10:00',4.28),('12664','2013-06-24','14:15:00',4.43),('12664','2013-06-24','14:20:00',4.61),('12664','2013-06-24','14:25:00',4.72),('12664','2013-06-24','14:30:00',4.49),('12664','2013-06-24','14:35:00',3.41),('12664','2013-06-24','14:40:00',3.14),('12664','2013-06-24','14:45:00',2.81),('12664','2013-06-24','14:50:00',2.54),('12664','2013-06-24','14:55:00',2.65),('12664','2013-06-24','15:00:00',2.49),('12664','2013-06-24','15:05:00',3.82),('12664','2013-06-24','15:10:00',4.45),('12664','2013-06-24','15:15:00',3.62),('12664','2013-06-24','15:20:00',3.8),('12664','2013-06-24','15:25:00',3.21),('12664','2013-06-24','15:30:00',3.46),('12664','2013-06-24','15:35:00',4.24),('12664','2013-06-24','15:40:00',3.02),('12664','2013-06-24','15:45:00',3.12),('12664','2013-06-24','15:50:00',4.07),('12664','2013-06-24','15:55:00',2.46),('12664','2013-06-24','16:00:00',2.4),('12664','2013-06-24','16:05:00',3.55),('12664','2013-06-24','16:10:00',3.13),('12664','2013-06-24','16:15:00',3.64),('12664','2013-06-24','16:20:00',2.45),('12664','2013-06-24','16:25:00',2.61),('12664','2013-06-24','16:30:00',2.53),('12664','2013-06-24','16:35:00',1.89),('12664','2013-06-24','16:40:00',1.79),('12664','2013-06-24','16:45:00',2.42),('12664','2013-06-24','16:50:00',1.35),('12664','2013-06-24','16:55:00',1.35),('12664','2013-06-24','17:00:00',1.7),('12664','2013-06-24','17:05:00',2.34),('12664','2013-06-24','17:10:00',2.12),('12664','2013-06-24','17:15:00',2.66),('12664','2013-06-24','17:20:00',1.35),('12664','2013-06-24','17:25:00',1.33),('12664','2013-06-24','17:30:00',1.73),('12664','2013-06-24','17:45:00',1.4),('12664','2013-06-24','17:50:00',1.23),('12664','2013-06-24','17:55:00',1.17),('12664','2013-06-24','18:05:00',1.71),('12664','2013-06-24','18:10:00',1.15),('12664','2013-06-24','18:20:00',1.36),('12664','2013-06-24','18:25:00',1.23),('12664','2013-06-24','18:30:00',1.3),('12664','2013-06-24','18:35:00',1.12),('12664','2013-06-23','08:50:00',1.28),('12664','2013-06-23','08:55:00',1.1),('12664','2013-06-23','09:00:00',1.07),('12664','2013-06-23','09:10:00',2.04),('12664','2013-06-23','09:15:00',2.78),('12664','2013-06-23','09:20:00',2.95),('12664','2013-06-23','09:25:00',2.97),('12664','2013-06-23','09:30:00',3.03),('12664','2013-06-23','09:35:00',3.26),('12664','2013-06-23','09:40:00',2.94),('12664','2013-06-23','09:45:00',3.3),('12664','2013-06-23','09:50:00',3.18),('12664','2013-06-23','09:55:00',2.94),('12664','2013-06-23','10:00:00',3.38),('12664','2013-06-23','10:05:00',3.3),('12664','2013-06-23','10:10:00',3.35),('12664','2013-06-23','10:15:00',3.39),('12664','2013-06-23','10:20:00',3.53),('12664','2013-06-23','10:25:00',3.61),('12664','2013-06-23','10:30:00',3.61),('12664','2013-06-23','10:35:00',3.58),('12664','2013-06-23','10:40:00',3.64),('12664','2013-06-23','10:45:00',3.72),('12664','2013-06-23','10:50:00',3.72),('12664','2013-06-23','10:55:00',3.77),('12664','2013-06-23','11:00:00',3.77),('12664','2013-06-23','11:05:00',3.77),('12664','2013-06-23','11:10:00',3.9),('12664','2013-06-23','11:15:00',3.9),('12664','2013-06-23','11:20:00',3.96),('12664','2013-06-23','11:25:00',3.89),('12664','2013-06-23','11:30:00',3.98),('12664','2013-06-23','11:35:00',4.07),('12664','2013-06-23','11:40:00',4.01),('12664','2013-06-23','11:45:00',4.12),('12664','2013-06-23','11:50:00',4.22),('12664','2013-06-23','11:55:00',4.15),('12664','2013-06-23','12:00:00',4.24),('12664','2013-06-23','12:05:00',4.26),('12664','2013-06-23','12:10:00',4.24),('12664','2013-06-23','12:15:00',4.27),('12664','2013-06-23','12:20:00',4.31),('12664','2013-06-23','12:25:00',4.35),('12664','2013-06-23','12:30:00',4.36),('12664','2013-06-23','12:35:00',4.38),('12664','2013-06-23','12:40:00',4.35),('12664','2013-06-23','12:45:00',4.34),('12664','2013-06-23','12:50:00',4.39),('12664','2013-06-23','12:55:00',4.41),('12664','2013-06-23','13:00:00',4.4),('12664','2013-06-23','13:05:00',4.41),('12664','2013-06-23','13:10:00',4.41),('12664','2013-06-23','13:15:00',4.41),('12664','2013-06-23','13:20:00',4.42),('12664','2013-06-23','13:25:00',4.43),('12664','2013-06-23','13:30:00',4.45),('12664','2013-06-23','13:35:00',4.44),('12664','2013-06-23','13:40:00',4.46),('12664','2013-06-23','13:45:00',4.46),('12664','2013-06-23','13:50:00',4.46),('12664','2013-06-23','13:55:00',4.46),('12664','2013-06-23','14:00:00',4.44),('12664','2013-06-23','14:05:00',4.42),('12664','2013-06-23','14:10:00',4.4),('12664','2013-06-23','14:15:00',4.38),('12664','2013-06-23','14:20:00',4.37),('12664','2013-06-23','14:25:00',4.33),('12664','2013-06-23','14:30:00',4.28),('12664','2013-06-23','14:35:00',4.28),('12664','2013-06-23','14:40:00',4.05),('12664','2013-06-23','14:45:00',4.23),('12664','2013-06-23','14:50:00',4.16),('12664','2013-06-23','14:55:00',4.14),('12664','2013-06-23','15:00:00',4.07),('12664','2013-06-23','15:05:00',4.09),('12664','2013-06-23','15:10:00',3.96),('12664','2013-06-23','15:15:00',4.01),('12664','2013-06-23','15:20:00',3.92),('12664','2013-06-23','15:25:00',3.87),('12664','2013-06-23','15:30:00',3.85),('12664','2013-06-23','15:35:00',3.8),('12664','2013-06-23','15:40:00',3.75),('12664','2013-06-23','15:45:00',3.71),('12664','2013-06-23','15:50:00',3.67),('12664','2013-06-23','15:55:00',3.59),('12664','2013-06-23','16:00:00',3.55),('12664','2013-06-23','16:05:00',3.48),('12664','2013-06-23','16:10:00',3.41),('12664','2013-06-23','16:15:00',3.36),('12664','2013-06-23','16:20:00',3.3),('12664','2013-06-23','16:25:00',3.24),('12664','2013-06-23','16:30:00',3.17),('12664','2013-06-23','16:35:00',3.08),('12664','2013-06-23','16:40:00',3.03),('12664','2013-06-23','16:45:00',2.95),('12664','2013-06-23','16:50:00',2.89),('12664','2013-06-23','16:55:00',2.82),('12664','2013-06-23','17:00:00',2.75),('12664','2013-06-23','17:05:00',2.72),('12664','2013-06-23','17:10:00',2.7),('12664','2013-06-23','17:15:00',2.48),('12664','2013-06-23','17:20:00',2.33),('12664','2013-06-23','17:25:00',2.32),('12664','2013-06-23','17:30:00',2.26),('12664','2013-06-23','17:35:00',2.13),('12664','2013-06-23','17:40:00',2.09),('12664','2013-06-23','17:45:00',1.27),('12664','2013-06-23','17:50:00',1.83),('12664','2013-06-23','17:55:00',1.9),('12664','2013-06-23','18:00:00',1.75),('12664','2013-06-23','18:05:00',1.64),('12664','2013-06-23','18:10:00',1.56),('12664','2013-06-23','18:15:00',1.44),('12664','2013-06-23','18:20:00',1.34),('12664','2013-06-23','18:25:00',1.24),('12664','2013-06-23','18:30:00',1.16),('12664','2013-06-23','18:35:00',1.07),('12664','2013-06-22','07:40:00',1.01),('12664','2013-06-22','07:45:00',1.09),('12664','2013-06-22','07:50:00',1.16),('12664','2013-06-22','07:55:00',1.28),('12664','2013-06-22','08:00:00',1.36),('12664','2013-06-22','08:05:00',1.43),('12664','2013-06-22','08:10:00',1.55),('12664','2013-06-22','08:15:00',1.63),('12664','2013-06-22','08:20:00',1.7),('12664','2013-06-22','08:25:00',1.81),('12664','2013-06-22','08:30:00',1.82),('12664','2013-06-22','08:35:00',1.94),('12664','2013-06-22','08:40:00',2.06),('12664','2013-06-22','08:45:00',2.16),('12664','2013-06-22','08:50:00',2.19),('12664','2013-06-22','08:55:00',2.27),('12664','2013-06-22','09:00:00',2.36),('12664','2013-06-22','09:05:00',2.43),('12664','2013-06-22','09:10:00',2.54),('12664','2013-06-22','09:15:00',2.59),('12664','2013-06-22','09:20:00',2.7),('12664','2013-06-22','09:25:00',2.78),('12664','2013-06-22','09:30:00',2.82),('12664','2013-06-22','09:35:00',2.91),('12664','2013-06-22','09:40:00',2.93),('12664','2013-06-22','09:45:00',3.03),('12664','2013-06-22','09:50:00',3.09),('12664','2013-06-22','09:55:00',3.17),('12664','2013-06-22','10:00:00',3.24),('12664','2013-06-22','10:05:00',3.29),('12664','2013-06-22','10:10:00',3.38),('12664','2013-06-22','10:15:00',3.44),('12664','2013-06-22','10:20:00',3.45),('12664','2013-06-22','10:25:00',3.5),('12664','2013-06-22','10:30:00',3.55),('12664','2013-06-22','10:35:00',3.63),('12664','2013-06-22','10:40:00',3.68),('12664','2013-06-22','10:45:00',3.71),('12664','2013-06-22','10:50:00',3.75),('12664','2013-06-22','10:55:00',3.79),('12664','2013-06-22','11:00:00',3.82),('12664','2013-06-22','11:05:00',3.84),('12664','2013-06-22','11:10:00',3.89),('12664','2013-06-22','11:15:00',3.92),('12664','2013-06-22','11:20:00',3.95),('12664','2013-06-22','11:25:00',3.97),('12664','2013-06-22','11:30:00',4),('12664','2013-06-22','11:35:00',4.05),('12664','2013-06-22','11:40:00',4.07),('12664','2013-06-22','11:45:00',4.1),('12664','2013-06-22','11:50:00',4.14),('12664','2013-06-22','11:55:00',4.11),('12664','2013-06-22','12:00:00',4.21),('12664','2013-06-22','12:05:00',4.22),('12664','2013-06-22','12:10:00',4.23),('12664','2013-06-22','12:15:00',4.24),('12664','2013-06-22','12:20:00',4.23),('12664','2013-06-22','12:25:00',4.23),('12664','2013-06-22','12:30:00',4.18),('12664','2013-06-22','12:35:00',4.22),('12664','2013-06-22','12:40:00',4.23),('12664','2013-06-22','12:45:00',4.17),('12664','2013-06-22','12:50:00',4.14),('12664','2013-06-22','12:55:00',4.12),('12664','2013-06-22','13:00:00',4.1),('12664','2013-06-22','13:05:00',4.21),('12664','2013-06-22','13:10:00',4.23),('12664','2013-06-22','13:15:00',4.25),('12664','2013-06-22','13:20:00',4.35),('12664','2013-06-22','13:25:00',4.44),('12664','2013-06-22','13:30:00',4.47),('12664','2013-06-22','13:35:00',4.36),('12664','2013-06-22','13:40:00',3.91),('12664','2013-06-22','13:45:00',4.03),('12664','2013-06-22','13:50:00',3.2),('12664','2013-06-22','13:55:00',4.5),('12664','2013-06-22','14:00:00',4.55),('12664','2013-06-22','14:05:00',4.58),('12664','2013-06-22','14:10:00',4.22),('12664','2013-06-22','14:15:00',2.53),('12664','2013-06-22','14:20:00',3.04),('12664','2013-06-22','14:25:00',3.42),('12664','2013-06-22','14:30:00',2.05),('12664','2013-06-22','14:35:00',2.28),('12664','2013-06-22','14:40:00',3.19),('12664','2013-06-22','14:45:00',3.74),('12664','2013-06-22','14:50:00',4.46),('12664','2013-06-22','14:55:00',4.01),('12664','2013-06-22','15:00:00',4.25),('12664','2013-06-22','15:05:00',3.89),('12664','2013-06-22','15:10:00',3.77),('12664','2013-06-22','15:15:00',4.02),('12664','2013-06-22','15:20:00',3.9),('12664','2013-06-22','15:25:00',3.6),('12664','2013-06-22','15:30:00',3.25),('12664','2013-06-22','15:35:00',1.92),('12664','2013-06-22','15:40:00',1.37),('12664','2013-06-22','15:45:00',1.35),('12664','2013-06-22','15:50:00',1.6),('12664','2013-06-22','15:55:00',1.69),('12664','2013-06-22','16:00:00',1.37),('12664','2013-06-22','16:05:00',1.45),('12664','2013-06-22','16:10:00',1.55),('12664','2013-06-22','16:15:00',1.55),('12664','2013-06-22','16:20:00',1.42),('12664','2013-06-22','16:25:00',1.37),('12664','2013-06-22','16:30:00',1.22),('12664','2013-06-22','16:35:00',1.15),('12664','2013-06-22','16:40:00',1.05),('12664','2013-06-22','16:45:00',1.07),('12664','2013-06-22','16:50:00',1.38),('12664','2013-06-22','16:55:00',2.56),('12664','2013-06-22','17:00:00',3.09),('12664','2013-06-22','17:05:00',2.97),('12664','2013-06-22','17:10:00',2.73),('12664','2013-06-22','17:15:00',2.11),('12664','2013-06-22','17:20:00',2.52),('12664','2013-06-22','17:25:00',2.52),('12664','2013-06-22','17:30:00',2.16),('12664','2013-06-22','17:35:00',2.04),('12664','2013-06-22','17:40:00',1.98),('12664','2013-06-22','17:45:00',1.96),('12664','2013-06-22','17:50:00',1.69),('12664','2013-06-22','17:55:00',1.53),('12664','2013-06-22','18:00:00',1.4),('12664','2013-06-22','18:05:00',1.1),('12664','2013-06-21','07:40:00',1.02),('12664','2013-06-21','07:45:00',1.1),('12664','2013-06-21','07:50:00',1.18),('12664','2013-06-21','07:55:00',1.27),('12664','2013-06-21','08:00:00',1.36),('12664','2013-06-21','08:05:00',1.43),('12664','2013-06-21','08:10:00',1.51),('12664','2013-06-21','08:15:00',1.6),('12664','2013-06-21','08:20:00',1.69),('12664','2013-06-21','08:25:00',1.76),('12664','2013-06-21','08:30:00',1.83),('12664','2013-06-21','08:35:00',1.91),('12664','2013-06-21','08:40:00',1.98),('12664','2013-06-21','08:45:00',2.03),('12664','2013-06-21','08:50:00',2.03),('12664','2013-06-21','08:55:00',2.22),('12664','2013-06-21','09:00:00',2.28),('12664','2013-06-21','09:05:00',2.38),('12664','2013-06-21','09:10:00',2.45),('12664','2013-06-21','09:15:00',2.53),('12664','2013-06-21','09:20:00',2.6),('12664','2013-06-21','09:25:00',2.67),('12664','2013-06-21','09:30:00',2.73),('12664','2013-06-21','09:35:00',2.8),('12664','2013-06-21','09:40:00',2.71),('12664','2013-06-21','09:45:00',2.94),('12664','2013-06-21','09:50:00',3.01),('12664','2013-06-21','09:55:00',3.09),('12664','2013-06-21','10:00:00',3.12),('12664','2013-06-21','10:05:00',3.16),('12664','2013-06-21','10:10:00',3.2),('12664','2013-06-21','10:15:00',3.26),('12664','2013-06-21','10:20:00',3.33),('12664','2013-06-21','10:25:00',3.38),('12664','2013-06-21','10:30:00',3.4),('12664','2013-06-21','10:35:00',3.45),('12664','2013-06-21','10:40:00',3.54),('12664','2013-06-21','10:45:00',3.59),('12664','2013-06-21','10:50:00',3.63),('12664','2013-06-21','10:55:00',3.65),('12664','2013-06-21','11:00:00',3.67),('12664','2013-06-21','11:05:00',3.68),('12664','2013-06-21','11:10:00',3.74),('12664','2013-06-21','11:15:00',3.66),('12664','2013-06-21','11:20:00',3.71),('12664','2013-06-21','11:25:00',3.84),('12664','2013-06-21','11:30:00',3.84),('12664','2013-06-21','11:35:00',3.8),('12664','2013-06-21','11:40:00',3.83),('12664','2013-06-21','11:45:00',3.92),('12664','2013-06-21','11:50:00',3.95),('12664','2013-06-21','11:55:00',3.95),('12664','2013-06-21','12:00:00',4.02),('12664','2013-06-21','12:05:00',4.06),('12664','2013-06-21','12:10:00',4.11),('12664','2013-06-21','12:15:00',4.11),('12664','2013-06-21','12:20:00',4.11),('12664','2013-06-21','12:25:00',4.14),('12664','2013-06-21','12:30:00',4.17),('12664','2013-06-21','12:35:00',4.17),('12664','2013-06-21','12:40:00',4.16),('12664','2013-06-21','12:45:00',4.14),('12664','2013-06-21','12:50:00',4.18),('12664','2013-06-21','12:55:00',4.2),('12664','2013-06-21','13:00:00',4.2),('12664','2013-06-21','13:05:00',4.19),('12664','2013-06-21','13:10:00',4.18),('12664','2013-06-21','13:15:00',4.22),('12664','2013-06-21','13:20:00',4.23),('12664','2013-06-21','13:25:00',4.27),('12664','2013-06-21','13:30:00',4.27),('12664','2013-06-21','13:35:00',4.27),('12664','2013-06-21','13:40:00',4.25),('12664','2013-06-21','13:45:00',4.24),('12664','2013-06-21','13:50:00',4.22),('12664','2013-06-21','13:55:00',4.21),('12664','2013-06-21','14:00:00',4.21),('12664','2013-06-21','14:05:00',4.19),('12664','2013-06-21','14:10:00',4.21),('12664','2013-06-21','14:15:00',4.19),('12664','2013-06-21','14:20:00',4.16),('12664','2013-06-21','14:25:00',4.13),('12664','2013-06-21','14:30:00',4.11),('12664','2013-06-21','14:35:00',4.09),('12664','2013-06-21','14:40:00',4.06),('12664','2013-06-21','14:45:00',4.04),('12664','2013-06-21','14:50:00',4.01),('12664','2013-06-21','14:55:00',3.97),('12664','2013-06-21','15:00:00',3.93),('12664','2013-06-21','15:05:00',3.89),('12664','2013-06-21','15:10:00',3.86),('12664','2013-06-21','15:15:00',3.83),('12664','2013-06-21','15:20:00',3.78),('12664','2013-06-21','15:25:00',3.75),('12664','2013-06-21','15:30:00',3.67),('12664','2013-06-21','15:35:00',3.63),('12664','2013-06-21','15:40:00',3.6),('12664','2013-06-21','15:45:00',3.53),('12664','2013-06-21','15:50:00',3.48),('12664','2013-06-21','15:55:00',3.43),('12664','2013-06-21','16:00:00',3.38),('12664','2013-06-21','16:05:00',3.32),('12664','2013-06-21','16:10:00',3.25),('12664','2013-06-21','16:15:00',3.19),('12664','2013-06-21','16:20:00',3.12),('12664','2013-06-21','16:25:00',3.06),('12664','2013-06-21','16:30:00',3),('12664','2013-06-21','16:35:00',2.94),('12664','2013-06-21','16:40:00',2.88),('12664','2013-06-21','16:45:00',2.81),('12664','2013-06-21','16:50:00',2.74),('12664','2013-06-21','16:55:00',2.68),('12664','2013-06-21','17:00:00',2.61),('12664','2013-06-21','17:05:00',2.52),('12664','2013-06-21','17:10:00',2.44),('12664','2013-06-21','17:15:00',2.36),('12664','2013-06-21','17:20:00',2.28),('12664','2013-06-21','17:25:00',2.2),('12664','2013-06-21','17:30:00',2.12),('12664','2013-06-21','17:35:00',2.03),('12664','2013-06-21','17:40:00',1.96),('12664','2013-06-21','17:45:00',1.86),('12664','2013-06-21','17:50:00',1.78),('12664','2013-06-21','17:55:00',1.7),('12664','2013-06-21','18:00:00',1.62),('12664','2013-06-21','18:05:00',1.52),('12664','2013-06-21','18:10:00',1.43),('12664','2013-06-21','18:15:00',1.35),('12664','2013-06-21','18:20:00',1.26),('12664','2013-06-21','18:25:00',1.16),('12664','2013-06-21','18:30:00',1.07),('12664','2013-06-20','07:40:00',1.03),('12664','2013-06-20','07:45:00',1.12),('12664','2013-06-20','07:50:00',1.19),('12664','2013-06-20','07:55:00',1.29),('12664','2013-06-20','08:00:00',1.38),('12664','2013-06-20','08:05:00',1.46),('12664','2013-06-20','08:10:00',1.54),('12664','2013-06-20','08:15:00',1.64),('12664','2013-06-20','08:20:00',1.72),('12664','2013-06-20','08:25:00',1.81),('12664','2013-06-20','08:30:00',1.88),('12664','2013-06-20','08:35:00',1.95),('12664','2013-06-20','08:40:00',2.02),('12664','2013-06-20','08:45:00',2.11),('12664','2013-06-20','08:50:00',2.2),('12664','2013-06-20','08:55:00',2.27),('12664','2013-06-20','09:00:00',2.35),('12664','2013-06-20','09:05:00',2.43),('12664','2013-06-20','09:10:00',2.51),('12664','2013-06-20','09:15:00',2.59),('12664','2013-06-20','09:20:00',2.65),('12664','2013-06-20','09:25:00',2.72),('12664','2013-06-20','09:30:00',2.78),('12664','2013-06-20','09:35:00',2.83),('12664','2013-06-20','09:40:00',2.92),('12664','2013-06-20','09:45:00',2.99),('12664','2013-06-20','09:50:00',3.05),('12664','2013-06-20','09:55:00',3.08),('12664','2013-06-20','10:00:00',3.14),('12664','2013-06-20','10:05:00',3.23),('12664','2013-06-20','10:10:00',3.27),('12664','2013-06-20','10:15:00',3.33),('12664','2013-06-20','10:20:00',3.38),('12664','2013-06-20','10:25:00',3.41),('12664','2013-06-20','10:30:00',3.46),('12664','2013-06-20','10:35:00',3.49),('12664','2013-06-20','10:40:00',3.52),('12664','2013-06-20','10:45:00',3.52),('12664','2013-06-20','10:50:00',3.58),('12664','2013-06-20','10:55:00',3.62),('12664','2013-06-20','11:00:00',3.64),('12664','2013-06-20','11:05:00',3.7),('12664','2013-06-20','11:10:00',3.74),('12664','2013-06-20','11:15:00',3.7),('12664','2013-06-20','11:20:00',3.75),('12664','2013-06-20','11:25:00',3.63),('12664','2013-06-20','11:30:00',3.86),('12664','2013-06-20','11:35:00',3.9),('12664','2013-06-20','11:40:00',3.86),('12664','2013-06-20','11:45:00',3.82),('12664','2013-06-20','11:50:00',3.98),('12664','2013-06-20','11:55:00',4.03),('12664','2013-06-20','12:00:00',4.05),('12664','2013-06-20','12:05:00',4.09),('12664','2013-06-20','12:10:00',4.11),('12664','2013-06-20','12:15:00',4.07),('12664','2013-06-20','12:20:00',4.11),('12664','2013-06-20','12:25:00',4.07),('12664','2013-06-20','12:30:00',3.99),('12664','2013-06-20','12:35:00',3.98),('12664','2013-06-20','12:40:00',4),('12664','2013-06-20','12:45:00',3.97),('12664','2013-06-20','12:50:00',3.98),('12664','2013-06-20','12:55:00',4.07),('12664','2013-06-20','13:00:00',4.13),('12664','2013-06-20','13:05:00',4.23),('12664','2013-06-20','13:10:00',4.29),('12664','2013-06-20','13:15:00',4.25),('12664','2013-06-20','13:20:00',4.23),('12664','2013-06-20','13:25:00',4.26),('12664','2013-06-20','13:30:00',4.29),('12664','2013-06-20','13:35:00',4.29),('12664','2013-06-20','13:40:00',4.3),('12664','2013-06-20','13:45:00',4.29),('12664','2013-06-20','13:50:00',4.27),('12664','2013-06-20','13:55:00',4.29),('12664','2013-06-20','14:00:00',4.32),('12664','2013-06-20','14:05:00',4.31),('12664','2013-06-20','14:10:00',4.26),('12664','2013-06-20','14:15:00',4.26),('12664','2013-06-20','14:20:00',4.25),('12664','2013-06-20','14:25:00',4.23),('12664','2013-06-20','14:30:00',4.22),('12664','2013-06-20','14:35:00',4.2),('12664','2013-06-20','14:40:00',4.16),('12664','2013-06-20','14:45:00',4.12),('12664','2013-06-20','14:50:00',4.09),('12664','2013-06-20','14:55:00',4.05),('12664','2013-06-20','15:00:00',4.01),('12664','2013-06-20','15:05:00',3.97),('12664','2013-06-20','15:10:00',3.93),('12664','2013-06-20','15:15:00',3.89),('12664','2013-06-20','15:20:00',3.83),('12664','2013-06-20','15:25:00',3.77),('12664','2013-06-20','15:30:00',3.72),('12664','2013-06-20','15:35:00',3.69),('12664','2013-06-20','15:40:00',3.65),('12664','2013-06-20','15:45:00',3.59),('12664','2013-06-20','15:50:00',3.53),('12664','2013-06-20','15:55:00',3.48),('12664','2013-06-20','16:00:00',3.43),('12664','2013-06-20','16:05:00',3.37),('12664','2013-06-20','16:10:00',3.32),('12664','2013-06-20','16:15:00',3.25),('12664','2013-06-20','16:20:00',3.19),('12664','2013-06-20','16:25:00',3.13),('12664','2013-06-20','16:30:00',3.06),('12664','2013-06-20','16:35:00',2.99),('12664','2013-06-20','16:40:00',2.91),('12664','2013-06-20','16:45:00',2.85),('12664','2013-06-20','16:50:00',2.77),('12664','2013-06-20','16:55:00',2.71),('12664','2013-06-20','17:00:00',2.64),('12664','2013-06-20','17:05:00',2.57),('12664','2013-06-20','17:10:00',2.49),('12664','2013-06-20','17:15:00',2.41),('12664','2013-06-20','17:20:00',2.34),('12664','2013-06-20','17:25:00',2.26),('12664','2013-06-20','17:30:00',2.17),('12664','2013-06-20','17:35:00',2.09),('12664','2013-06-20','17:40:00',2.01),('12664','2013-06-20','17:45:00',1.93),('12664','2013-06-20','17:50:00',1.85),('12664','2013-06-20','17:55:00',1.76),('12664','2013-06-20','18:00:00',1.66),('12664','2013-06-20','18:05:00',1.57),('12664','2013-06-20','18:10:00',1.49),('12664','2013-06-20','18:15:00',1.39),('12664','2013-06-20','18:20:00',1.29),('12664','2013-06-20','18:25:00',1.2),('12664','2013-06-20','18:30:00',1.1),('12664','2013-06-20','18:35:00',1.01),('12664','2014-04-03','08:55:00',1.02),('12664','2014-04-03','09:00:00',1.19),('12664','2014-04-03','09:05:00',1.26),('12664','2014-04-03','09:10:00',1.12),('12664','2014-04-03','09:15:00',1.06),('12664','2014-04-03','09:20:00',1.2),('12664','2014-04-03','09:25:00',1.28),('12664','2014-04-03','09:30:00',1.41),('12664','2014-04-03','09:35:00',1.54),('12664','2014-04-03','09:40:00',1.54),('12664','2014-04-03','09:45:00',1.55),('12664','2014-04-03','09:50:00',1.61),('12664','2014-04-03','09:55:00',1.85),('12664','2014-04-03','10:00:00',2.15),('12664','2014-04-03','10:05:00',2.17),('12664','2014-04-03','10:10:00',2.62),('12664','2014-04-03','10:15:00',2.9),('12664','2014-04-03','10:20:00',2.54),('12664','2014-04-03','10:25:00',2.31),('12664','2014-04-03','10:30:00',2.66),('12664','2014-04-03','10:35:00',2.28),('12664','2014-04-03','10:40:00',2.32),('12664','2014-04-03','10:45:00',2.46),('12664','2014-04-03','10:50:00',1.97),('12664','2014-04-03','10:55:00',1.65),('12664','2014-04-03','11:00:00',1.69),('12664','2014-04-03','11:05:00',1.77),('12664','2014-04-03','11:10:00',1.53),('12664','2014-04-03','11:15:00',1.42),('12664','2014-04-03','11:20:00',1.27),('12664','2014-04-03','11:25:00',1.18),('12664','2014-04-03','11:30:00',1.23),('12664','2014-04-03','11:35:00',1.39),('12664','2014-04-03','11:40:00',1.46),('12664','2014-04-03','11:45:00',1.55),('12664','2014-04-03','11:50:00',1.77),('12664','2014-04-03','11:55:00',2),('12664','2014-04-03','12:00:00',2.33),('12664','2014-04-03','12:05:00',2.2),('12664','2014-04-03','12:10:00',1.96),('12664','2014-04-03','12:15:00',2.13),('12664','2014-04-03','12:20:00',2.34),('12664','2014-04-03','12:25:00',3.18),('12664','2014-04-03','12:30:00',4.13),('12664','2014-04-03','12:35:00',3.55),('12664','2014-04-03','12:40:00',2.48),('12664','2014-04-03','12:45:00',2),('12664','2014-04-03','12:50:00',2.3),('12664','2014-04-03','12:55:00',2.44),('12664','2014-04-03','13:00:00',1.86),('12664','2014-04-03','13:05:00',2),('12664','2014-04-03','13:10:00',2.81),('12664','2014-04-03','13:15:00',3.55),('12664','2014-04-03','13:20:00',2.11),('12664','2014-04-03','13:25:00',3.12),('12664','2014-04-03','13:30:00',3.88),('12664','2014-04-03','13:35:00',3.1),('12664','2014-04-03','13:40:00',2.65),('12664','2014-04-03','13:45:00',1.69),('12664','2014-04-03','13:50:00',2.49),('12664','2014-04-03','13:55:00',2.58),('12664','2014-04-03','14:00:00',2.5),('12664','2014-04-03','14:05:00',3.6),('12664','2014-04-03','14:10:00',3.24),('12664','2014-04-03','14:15:00',3.56),('12664','2014-04-03','14:20:00',3.18),('12664','2014-04-03','14:25:00',2.72),('12664','2014-04-03','14:30:00',3.73),('12664','2014-04-03','14:35:00',3.78),('12664','2014-04-03','14:40:00',3.66),('12664','2014-04-03','14:45:00',3.59),('12664','2014-04-03','14:50:00',3.51),('12664','2014-04-03','14:55:00',3.44),('12664','2014-04-03','15:00:00',3.39),('12664','2014-04-03','15:05:00',3.3),('12664','2014-04-03','15:10:00',3.2),('12664','2014-04-03','15:15:00',3.24),('12664','2014-04-03','15:20:00',3.23),('12664','2014-04-03','15:25:00',3.22),('12664','2014-04-03','15:30:00',3.16),('12664','2014-04-03','15:35:00',3.1),('12664','2014-04-03','15:40:00',3.06),('12664','2014-04-03','15:45:00',3.01),('12664','2014-04-03','15:50:00',3.02),('12664','2014-04-03','15:55:00',2.9),('12664','2014-04-03','16:00:00',2.97),('12664','2014-04-03','16:05:00',2.89),('12664','2014-04-03','16:10:00',2.83),('12664','2014-04-03','16:15:00',2.76),('12664','2014-04-03','16:20:00',2.7),('12664','2014-04-03','16:25:00',2.59),('12664','2014-04-03','16:30:00',2.47),('12664','2014-04-03','16:35:00',2.42),('12664','2014-04-03','16:40:00',2.37),('12664','2014-04-03','16:45:00',2.31),('12664','2014-04-03','16:50:00',2.25),('12664','2014-04-03','16:55:00',1.78),('12664','2014-04-03','17:00:00',1.63),('12664','2014-04-03','17:05:00',1.3),('12664','2014-04-03','17:10:00',1.44),('12664','2014-04-03','17:15:00',1.62),('12664','2014-04-03','17:20:00',1.14),('12664','2014-04-03','17:25:00',1.21),('12664','2014-04-03','17:45:00',1.21),('12664','2014-04-03','17:50:00',1.24),('12664','2014-04-03','17:55:00',1.06),('12664','2013-06-19','07:40:00',1.02),('12664','2013-06-19','07:45:00',1.11),('12664','2013-06-19','07:50:00',1.19),('12664','2013-06-19','07:55:00',1.28),('12664','2013-06-19','08:00:00',1.36),('12664','2013-06-19','08:05:00',1.44),('12664','2013-06-19','08:10:00',1.51),('12664','2013-06-19','08:15:00',1.59),('12664','2013-06-19','08:20:00',1.69),('12664','2013-06-19','08:25:00',1.77),('12664','2013-06-19','08:30:00',1.85),('12664','2013-06-19','08:35:00',1.93),('12664','2013-06-19','08:40:00',2),('12664','2013-06-19','08:45:00',2.08),('12664','2013-06-19','08:50:00',2.16),('12664','2013-06-19','08:55:00',2.23),('12664','2013-06-19','09:00:00',2.3),('12664','2013-06-19','09:05:00',2.37),('12664','2013-06-19','09:10:00',2.43),('12664','2013-06-19','09:15:00',2.5),('12664','2013-06-19','09:20:00',2.56),('12664','2013-06-19','09:25:00',2.63),('12664','2013-06-19','09:30:00',2.7),('12664','2013-06-19','09:35:00',2.76),('12664','2013-06-19','09:40:00',2.82),('12664','2013-06-19','09:45:00',2.87),('12664','2013-06-19','09:50:00',2.93),('12664','2013-06-19','09:55:00',2.98),('12664','2013-06-19','10:00:00',3.02),('12664','2013-06-19','10:05:00',3.06),('12664','2013-06-19','10:10:00',3.1),('12664','2013-06-19','10:15:00',3.16),('12664','2013-06-19','10:20:00',3.21),('12664','2013-06-19','10:25:00',3.23),('12664','2013-06-19','10:30:00',3.26),('12664','2013-06-19','10:35:00',3.31),('12664','2013-06-19','10:40:00',3.28),('12664','2013-06-19','10:45:00',3.41),('12664','2013-06-19','10:50:00',3.45),('12664','2013-06-19','10:55:00',3.49),('12664','2013-06-19','11:00:00',3.56),('12664','2013-06-19','11:05:00',3.6),('12664','2013-06-19','11:10:00',3.66),('12664','2013-06-19','11:15:00',3.67),('12664','2013-06-19','11:20:00',3.73),('12664','2013-06-19','11:25:00',3.73),('12664','2013-06-19','11:30:00',3.74),('12664','2013-06-19','11:35:00',3.79),('12664','2013-06-19','11:40:00',3.86),('12664','2013-06-19','11:45:00',3.85),('12664','2013-06-19','11:50:00',3.88),('12664','2013-06-19','11:55:00',3.95),('12664','2013-06-19','12:00:00',4),('12664','2013-06-19','12:05:00',4.04),('12664','2013-06-19','12:10:00',4.12),('12664','2013-06-19','12:15:00',4.1),('12664','2013-06-19','12:20:00',4.13),('12664','2013-06-19','12:25:00',4.12),('12664','2013-06-19','12:30:00',4.15),('12664','2013-06-19','12:35:00',4.13),('12664','2013-06-19','12:40:00',4.14),('12664','2013-06-19','12:45:00',4.15),('12664','2013-06-19','12:50:00',4.15),('12664','2013-06-19','12:55:00',4.16),('12664','2013-06-19','13:00:00',4.19),('12664','2013-06-19','13:05:00',4.19),('12664','2013-06-19','13:10:00',4.2),('12664','2013-06-19','13:15:00',4.19),('12664','2013-06-19','13:20:00',4.22),('12664','2013-06-19','13:25:00',4.22),('12664','2013-06-19','13:30:00',4.21),('12664','2013-06-19','13:35:00',4.21),('12664','2013-06-19','13:40:00',4.22),('12664','2013-06-19','13:45:00',4.23),('12664','2013-06-19','13:50:00',4.23),('12664','2013-06-19','13:55:00',4.21),('12664','2013-06-19','14:00:00',4.21),('12664','2013-06-19','14:05:00',4.18),('12664','2013-06-19','14:10:00',4.16),('12664','2013-06-19','14:15:00',4.13),('12664','2013-06-19','14:20:00',4.1),('12664','2013-06-19','14:25:00',4.07),('12664','2013-06-19','14:30:00',4.05),('12664','2013-06-19','14:35:00',4.04),('12664','2013-06-19','14:40:00',4),('12664','2013-06-19','14:45:00',3.98),('12664','2013-06-19','14:50:00',3.94),('12664','2013-06-19','14:55:00',3.89),('12664','2013-06-19','15:00:00',3.84),('12664','2013-06-19','15:05:00',3.79),('12664','2013-06-19','15:10:00',3.76),('12664','2013-06-19','15:15:00',3.71),('12664','2013-06-19','15:20:00',3.67),('12664','2013-06-19','15:25:00',3.63),('12664','2013-06-19','15:30:00',3.61),('12664','2013-06-19','15:35:00',3.57),('12664','2013-06-19','15:40:00',3.52),('12664','2013-06-19','15:45:00',3.48),('12664','2013-06-19','15:50:00',3.43),('12664','2013-06-19','15:55:00',3.38),('12664','2013-06-19','16:00:00',3.32),('12664','2013-06-19','16:05:00',3.26),('12664','2013-06-19','16:10:00',3.21),('12664','2013-06-19','16:15:00',3.15),('12664','2013-06-19','16:20:00',3.1),('12664','2013-06-19','16:25:00',3.04),('12664','2013-06-19','16:30:00',2.96),('12664','2013-06-19','16:35:00',2.91),('12664','2013-06-19','16:40:00',2.85),('12664','2013-06-19','16:45:00',2.78),('12664','2013-06-19','16:50:00',2.72),('12664','2013-06-19','16:55:00',2.67),('12664','2013-06-19','17:00:00',2.6),('12664','2013-06-19','17:05:00',2.53),('12664','2013-06-19','17:10:00',2.44),('12664','2013-06-19','17:15:00',2.34),('12664','2013-06-19','17:20:00',2.26),('12664','2013-06-19','17:25:00',2.17),('12664','2013-06-19','17:30:00',2.09),('12664','2013-06-19','17:35:00',2.02),('12664','2013-06-19','17:40:00',1.93),('12664','2013-06-19','17:45:00',1.86),('12664','2013-06-19','17:50:00',1.77),('12664','2013-06-19','17:55:00',1.68),('12664','2013-06-19','18:00:00',1.59),('12664','2013-06-19','18:05:00',1.5),('12664','2013-06-19','18:10:00',1.41),('12664','2013-06-19','18:15:00',1.32),('12664','2013-06-19','18:20:00',1.23),('12664','2013-06-19','18:25:00',1.14),('12664','2013-06-19','18:30:00',1.06),('12664','2013-06-18','07:40:00',1.01),('12664','2013-06-18','07:45:00',1.08),('12664','2013-06-18','07:50:00',1.17),('12664','2013-06-18','07:55:00',1.25),('12664','2013-06-18','08:00:00',1.33),('12664','2013-06-18','08:05:00',1.41),('12664','2013-06-18','08:10:00',1.5),('12664','2013-06-18','08:15:00',1.58),('12664','2013-06-18','08:20:00',1.67),('12664','2013-06-18','08:25:00',1.75),('12664','2013-06-18','08:30:00',1.84),('12664','2013-06-18','08:35:00',1.91),('12664','2013-06-18','08:40:00',1.99),('12664','2013-06-18','08:45:00',2.05),('12664','2013-06-18','08:50:00',2.13),('12664','2013-06-18','08:55:00',2.19),('12664','2013-06-18','09:00:00',2.27),('12664','2013-06-18','09:05:00',2.35),('12664','2013-06-18','09:10:00',2.42),('12664','2013-06-18','09:15:00',2.5),('12664','2013-06-18','09:20:00',2.56),('12664','2013-06-18','09:25:00',2.62),('12664','2013-06-18','09:30:00',2.68),('12664','2013-06-18','09:35:00',2.75),('12664','2013-06-18','09:40:00',2.8),('12664','2013-06-18','09:45:00',2.86),('12664','2013-06-18','09:50:00',2.92),('12664','2013-06-18','09:55:00',2.98),('12664','2013-06-18','10:00:00',3.03),('12664','2013-06-18','10:05:00',3.07),('12664','2013-06-18','10:10:00',3.13),('12664','2013-06-18','10:15:00',3.18),('12664','2013-06-18','10:20:00',3.26),('12664','2013-06-18','10:25:00',3.3),('12664','2013-06-18','10:30:00',3.32),('12664','2013-06-18','10:35:00',3.38),('12664','2013-06-18','10:40:00',3.44),('12664','2013-06-18','10:45:00',3.5),('12664','2013-06-18','10:50:00',3.5),('12664','2013-06-18','10:55:00',3.54),('12664','2013-06-18','11:00:00',3.55),('12664','2013-06-18','11:05:00',3.59),('12664','2013-06-18','11:10:00',3.62),('12664','2013-06-18','11:15:00',3.65),('12664','2013-06-18','11:20:00',3.69),('12664','2013-06-18','11:25:00',3.76),('12664','2013-06-18','11:30:00',3.75),('12664','2013-06-18','11:35:00',3.75),('12664','2013-06-18','11:40:00',3.79),('12664','2013-06-18','11:45:00',3.81),('12664','2013-06-18','11:50:00',3.85),('12664','2013-06-18','11:55:00',3.89),('12664','2013-06-18','12:00:00',3.88),('12664','2013-06-18','12:05:00',3.72),('12664','2013-06-18','12:10:00',3.85),('12664','2013-06-18','12:15:00',3.84),('12664','2013-06-18','12:20:00',3.78),('12664','2013-06-18','12:25:00',3.87),('12664','2013-06-18','12:30:00',3.91),('12664','2013-06-18','12:35:00',3.89),('12664','2013-06-18','12:40:00',3.74),('12664','2013-06-18','12:45:00',3.81),('12664','2013-06-18','12:50:00',3.94),('12664','2013-06-18','12:55:00',4),('12664','2013-06-18','13:00:00',4.01),('12664','2013-06-18','13:05:00',4),('12664','2013-06-18','13:10:00',4.13),('12664','2013-06-18','13:15:00',4.18),('12664','2013-06-18','13:20:00',4.09),('12664','2013-06-18','13:25:00',4.04),('12664','2013-06-18','13:30:00',4.02),('12664','2013-06-18','13:35:00',4.02),('12664','2013-06-18','13:40:00',4.04),('12664','2013-06-18','13:45:00',4.03),('12664','2013-06-18','13:50:00',4.04),('12664','2013-06-18','13:55:00',4.04),('12664','2013-06-18','14:00:00',4.16),('12664','2013-06-18','14:05:00',4.24),('12664','2013-06-18','14:10:00',4.2),('12664','2013-06-18','14:15:00',4.25),('12664','2013-06-18','14:20:00',4.17),('12664','2013-06-18','14:25:00',4.13),('12664','2013-06-18','14:30:00',4.14),('12664','2013-06-18','14:35:00',4.25),('12664','2013-06-18','14:40:00',4.27),('12664','2013-06-18','14:45:00',3.76),('12664','2013-06-18','14:50:00',4.11),('12664','2013-06-18','14:55:00',4.06),('12664','2013-06-18','15:00:00',3.95),('12664','2013-06-18','15:05:00',3.86),('12664','2013-06-18','15:10:00',3.76),('12664','2013-06-18','15:15:00',3.72),('12664','2013-06-18','15:20:00',3.69),('12664','2013-06-18','15:25:00',3.64),('12664','2013-06-18','15:30:00',3.6),('12664','2013-06-18','15:35:00',3.57),('12664','2013-06-18','15:40:00',3.54),('12664','2013-06-18','15:45:00',3.48),('12664','2013-06-18','15:50:00',3.41),('12664','2013-06-18','15:55:00',3.38),('12664','2013-06-18','16:00:00',3.36),('12664','2013-06-18','16:05:00',3.31),('12664','2013-06-18','16:10:00',3.23),('12664','2013-06-18','16:15:00',3.21),('12664','2013-06-18','16:20:00',3.18),('12664','2013-06-18','16:25:00',3.16),('12664','2013-06-18','17:30:00',2.06),('12664','2013-06-18','17:35:00',1.99),('12664','2013-06-17','07:40:00',1.06),('12664','2013-06-17','07:45:00',1.15),('12664','2013-06-17','07:50:00',1.23),('12664','2013-06-17','07:55:00',1.31),('12664','2013-06-17','08:00:00',1.4),('12664','2013-06-17','08:05:00',1.48),('12664','2013-06-17','08:10:00',1.56),('12664','2013-06-17','08:15:00',1.64),('12664','2013-06-17','08:20:00',1.72),('12664','2013-06-17','08:25:00',1.82),('12664','2013-06-17','08:30:00',1.91),('12664','2013-06-17','08:35:00',1.99),('12664','2013-06-17','08:40:00',2.06),('12664','2013-06-17','08:45:00',2.14),('12664','2013-06-17','08:50:00',2.21),('12664','2013-06-17','08:55:00',2.29),('12664','2013-06-17','09:00:00',2.36),('12664','2013-06-17','09:05:00',2.44),('12664','2013-06-17','09:10:00',2.51),('12664','2013-06-17','09:15:00',2.61),('12664','2013-06-17','09:20:00',2.68),('12664','2013-06-17','09:25:00',2.75),('12664','2013-06-17','09:30:00',2.81),('12664','2013-06-17','09:35:00',2.88),('12664','2013-06-17','09:40:00',2.94),('12664','2013-06-17','09:45:00',3.02),('12664','2013-06-17','09:50:00',3.08),('12664','2013-06-17','09:55:00',3.14),('12664','2013-06-17','10:00:00',3.2),('12664','2013-06-17','10:05:00',3.25),('12664','2013-06-17','10:10:00',3.29),('12664','2013-06-17','10:15:00',3.35),('12664','2013-06-17','10:20:00',3.39),('12664','2013-06-17','10:25:00',3.42),('12664','2013-06-17','10:30:00',3.46),('12664','2013-06-17','10:35:00',3.52),('12664','2013-06-17','10:40:00',3.55),('12664','2013-06-17','10:45:00',3.59),('12664','2013-06-17','10:50:00',3.63),('12664','2013-06-17','10:55:00',3.66),('12664','2013-06-17','11:00:00',3.69),('12664','2013-06-17','11:05:00',3.72),('12664','2013-06-17','11:10:00',3.76),('12664','2013-06-17','11:15:00',3.81),('12664','2013-06-17','11:20:00',3.85),('12664','2013-06-17','11:25:00',3.85),('12664','2013-06-17','11:30:00',3.92),('12664','2013-06-17','11:35:00',3.97),('12664','2013-06-17','11:40:00',3.98),('12664','2013-06-17','11:45:00',4.02),('12664','2013-06-17','11:50:00',4.04),('12664','2013-06-17','11:55:00',4.06),('12664','2013-06-17','12:00:00',4.08),('12664','2013-06-17','12:05:00',4.16),('12664','2013-06-17','12:10:00',4.18),('12664','2013-06-17','12:15:00',4.19),('12664','2013-06-17','12:20:00',4.19),('12664','2013-06-17','12:25:00',4.22),('12664','2013-06-17','12:30:00',4.24),('12664','2013-06-17','12:35:00',4.23),('12664','2013-06-17','12:40:00',4.28),('12664','2013-06-17','12:45:00',4.28),('12664','2013-06-17','12:50:00',4.28),('12664','2013-06-17','12:55:00',4.3),('12664','2013-06-17','13:00:00',4.29),('12664','2013-06-17','13:05:00',4.28),('12664','2013-06-17','13:10:00',4.26),('12664','2013-06-17','13:15:00',4.25),('12664','2013-06-17','13:20:00',4.25),('12664','2013-06-17','13:25:00',4.24),('12664','2013-06-17','13:30:00',4.22),('12664','2013-06-17','13:35:00',4.22),('12664','2013-06-17','13:40:00',4.19),('12664','2013-06-17','13:45:00',4.14),('12664','2013-06-17','13:50:00',4.12),('12664','2013-06-17','13:55:00',4.14),('12664','2013-06-17','14:00:00',4.14),('12664','2013-06-17','14:05:00',4.12),('12664','2013-06-17','14:10:00',4.11),('12664','2013-06-17','14:15:00',4.08),('12664','2013-06-17','14:20:00',4.1),('12664','2013-06-17','14:25:00',4.07),('12664','2013-06-17','14:30:00',4.05),('12664','2013-06-17','14:35:00',4.03),('12664','2013-06-17','14:40:00',4),('12664','2013-06-17','14:45:00',3.97),('12664','2013-06-17','14:50:00',3.94),('12664','2013-06-17','14:55:00',3.89),('12664','2013-06-17','15:00:00',3.86),('12664','2013-06-17','15:05:00',3.83),('12664','2013-06-17','15:10:00',3.8),('12664','2013-06-17','15:15:00',3.76),('12664','2013-06-17','15:20:00',3.73),('12664','2013-06-17','15:25:00',3.71),('12664','2013-06-17','15:30:00',3.67),('12664','2013-06-17','15:35:00',3.62),('12664','2013-06-17','15:40:00',3.58),('12664','2013-06-17','15:45:00',3.53),('12664','2013-06-17','15:50:00',3.47),('12664','2013-06-17','15:55:00',3.41),('12664','2013-06-17','16:00:00',3.36),('12664','2013-06-17','16:05:00',3.3),('12664','2013-06-17','16:10:00',3.25),('12664','2013-06-17','16:15:00',3.18),('12664','2013-06-17','16:20:00',3.13),('12664','2013-06-17','16:25:00',3.09),('12664','2013-06-17','16:30:00',3.03),('12664','2013-06-17','16:35:00',2.96),('12664','2013-06-17','16:40:00',2.9),('12664','2013-06-17','16:45:00',2.85),('12664','2013-06-17','16:50:00',2.77),('12664','2013-06-17','16:55:00',2.69),('12664','2013-06-17','17:00:00',2.62),('12664','2013-06-17','17:05:00',2.55),('12664','2013-06-17','17:10:00',2.47),('12664','2013-06-17','17:15:00',2.38),('12664','2013-06-17','17:20:00',2.31),('12664','2013-06-17','17:25:00',2.24),('12664','2013-06-17','17:30:00',2.17),('12664','2013-06-17','17:35:00',2.1),('12664','2013-06-17','17:40:00',2.02),('12664','2013-06-17','17:45:00',1.94),('12664','2013-06-17','17:50:00',1.85),('12664','2013-06-17','17:55:00',1.77),('12664','2013-06-17','18:00:00',1.68),('12664','2013-06-17','18:05:00',1.6),('12664','2013-06-17','18:10:00',1.51),('12664','2013-06-17','18:15:00',1.43),('12664','2013-06-17','18:20:00',1.34),('12664','2013-06-17','18:25:00',1.25),('12664','2013-06-17','18:30:00',1.16),('12664','2013-06-17','18:35:00',1.08),('12664','2013-06-16','07:40:00',1.08),('12664','2013-06-16','07:45:00',1.18),('12664','2013-06-16','07:50:00',1.26),('12664','2013-06-16','07:55:00',1.34),('12664','2013-06-16','08:00:00',1.43),('12664','2013-06-16','08:05:00',1.52),('12664','2013-06-16','08:10:00',1.59),('12664','2013-06-16','08:15:00',1.69),('12664','2013-06-16','08:20:00',1.77),('12664','2013-06-16','08:25:00',1.85),('12664','2013-06-16','08:30:00',1.95),('12664','2013-06-16','08:35:00',2.04),('12664','2013-06-16','08:40:00',2.12),('12664','2013-06-16','08:45:00',2.19),('12664','2013-06-16','08:50:00',2.27),('12664','2013-06-16','08:55:00',2.34),('12664','2013-06-16','09:00:00',2.42),('12664','2013-06-16','09:05:00',2.48),('12664','2013-06-16','09:10:00',2.56),('12664','2013-06-16','09:15:00',2.67),('12664','2013-06-16','09:20:00',2.72),('12664','2013-06-16','09:25:00',2.79),('12664','2013-06-16','09:30:00',2.81),('12664','2013-06-16','09:35:00',2.93),('12664','2013-06-16','09:40:00',3),('12664','2013-06-16','09:45:00',3.05),('12664','2013-06-16','09:50:00',3.13),('12664','2013-06-16','09:55:00',3.19),('12664','2013-06-16','10:00:00',3.26),('12664','2013-06-16','10:05:00',3.33),('12664','2013-06-16','10:10:00',3.42),('12664','2013-06-16','10:15:00',3.45),('12664','2013-06-16','10:20:00',3.47),('12664','2013-06-16','10:25:00',3.53),('12664','2013-06-16','10:30:00',3.59),('12664','2013-06-16','10:35:00',3.63),('12664','2013-06-16','10:40:00',3.65),('12664','2013-06-16','10:45:00',3.69),('12664','2013-06-16','10:50:00',3.74),('12664','2013-06-16','10:55:00',3.78),('12664','2013-06-16','11:00:00',3.81),('12664','2013-06-16','11:05:00',3.86),('12664','2013-06-16','11:10:00',3.92),('12664','2013-06-16','11:15:00',3.93),('12664','2013-06-16','11:20:00',3.95),('12664','2013-06-16','11:25:00',3.96),('12664','2013-06-16','11:30:00',3.99),('12664','2013-06-16','11:35:00',4.01),('12664','2013-06-16','11:40:00',4.06),('12664','2013-06-16','11:45:00',4.1),('12664','2013-06-16','11:50:00',4.1),('12664','2013-06-16','11:55:00',4.16),('12664','2013-06-16','12:00:00',4.21),('12664','2013-06-16','12:05:00',4.22),('12664','2013-06-16','12:10:00',4.23),('12664','2013-06-16','12:15:00',4.27),('12664','2013-06-16','12:20:00',4.29),('12664','2013-06-16','12:25:00',4.3),('12664','2013-06-16','12:30:00',4.31),('12664','2013-06-16','12:35:00',4.33),('12664','2013-06-16','12:40:00',4.36),('12664','2013-06-16','12:45:00',4.36),('12664','2013-06-16','12:50:00',4.16),('12664','2013-06-16','12:55:00',4.39),('12664','2013-06-16','13:00:00',4.39),('12664','2013-06-16','13:05:00',4.37),('12664','2013-06-16','13:10:00',4.38),('12664','2013-06-16','13:15:00',4.38),('12664','2013-06-16','13:20:00',4.39),('12664','2013-06-16','13:25:00',4.36),('12664','2013-06-16','13:30:00',4.37),('12664','2013-06-16','13:35:00',4.38),('12664','2013-06-16','13:40:00',4.38),('12664','2013-06-16','13:45:00',4.36),('12664','2013-06-16','13:50:00',4.36),('12664','2013-06-16','13:55:00',4.34),('12664','2013-06-16','14:00:00',4.32),('12664','2013-06-16','14:05:00',4.3),('12664','2013-06-16','14:10:00',4.29),('12664','2013-06-16','14:15:00',4.24),('12664','2013-06-16','14:20:00',4.21),('12664','2013-06-16','14:25:00',4.17),('12664','2013-06-16','14:30:00',4.14),('12664','2013-06-16','14:35:00',4.12),('12664','2013-06-16','14:40:00',4.1),('12664','2013-06-16','14:45:00',4.05),('12664','2013-06-16','14:50:00',4.04),('12664','2013-06-16','14:55:00',3.5),('12664','2013-06-16','15:00:00',3.97),('12664','2013-06-16','15:05:00',3.95),('12664','2013-06-16','15:10:00',3.89),('12664','2013-06-16','15:15:00',3.86),('12664','2013-06-16','15:20:00',3.83),('12664','2013-06-16','15:25:00',3.77),('12664','2013-06-16','15:30:00',3.74),('12664','2013-06-16','15:35:00',3.7),('12664','2013-06-16','15:40:00',3.65),('12664','2013-06-16','15:45:00',3.59),('12664','2013-06-16','15:50:00',3.53),('12664','2013-06-16','15:55:00',3.48),('12664','2013-06-16','16:00:00',3.43),('12664','2013-06-16','16:05:00',3.37),('12664','2013-06-16','16:10:00',3.3),('12664','2013-06-16','16:15:00',3.24),('12664','2013-06-16','16:20:00',3.18),('12664','2013-06-16','16:25:00',3.12),('12664','2013-06-16','16:30:00',3.05),('12664','2013-06-16','16:35:00',2.99),('12664','2013-06-16','16:40:00',2.92),('12664','2013-06-16','16:45:00',2.85),('12664','2013-06-16','16:50:00',2.77),('12664','2013-06-16','16:55:00',2.7),('12664','2013-06-16','17:00:00',2.63),('12664','2013-06-16','17:05:00',2.56),('12664','2013-06-16','17:10:00',2.47),('12664','2013-06-16','17:15:00',2.38),('12664','2013-06-16','17:20:00',2.3),('12664','2013-06-16','17:25:00',2.22),('12664','2013-06-16','17:30:00',2.14),('12664','2013-06-16','17:35:00',2.05),('12664','2013-06-16','17:40:00',1.97),('12664','2013-06-16','17:45:00',1.88),('12664','2013-06-16','17:50:00',1.79),('12664','2013-06-16','17:55:00',1.71),('12664','2013-06-16','18:00:00',1.62),('12664','2013-06-16','18:05:00',1.53),('12664','2013-06-16','18:10:00',1.44),('12664','2013-06-16','18:15:00',1.35),('12664','2013-06-16','18:20:00',1.26),('12664','2013-06-16','18:25:00',1.17),('12664','2013-06-16','18:30:00',1.08),('12664','2013-06-15','07:40:00',1.05),('12664','2013-06-15','07:45:00',1.15),('12664','2013-06-15','07:50:00',1.24),('12664','2013-06-15','07:55:00',1.31),('12664','2013-06-15','08:00:00',1.39),('12664','2013-06-15','08:05:00',1.47),('12664','2013-06-15','08:10:00',1.58),('12664','2013-06-15','08:15:00',1.63),('12664','2013-06-15','08:20:00',1.74),('12664','2013-06-15','08:25:00',1.76),('12664','2013-06-15','08:30:00',1.79),('12664','2013-06-15','08:35:00',2.13),('12664','2013-06-15','08:40:00',2.26),('12664','2013-06-15','08:45:00',1.79),('12664','2013-06-15','08:50:00',1.46),('12664','2013-06-15','08:55:00',1.05),('12664','2013-06-15','09:00:00',1.02),('12664','2013-06-15','09:05:00',2.15),('12664','2013-06-15','09:10:00',2.75),('12664','2013-06-15','09:15:00',2.79),('12664','2013-06-15','09:20:00',2.85),('12664','2013-06-15','09:25:00',2.92),('12664','2013-06-15','09:30:00',2.94),('12664','2013-06-15','09:35:00',2.86),('12664','2013-06-15','09:40:00',3.03),('12664','2013-06-15','09:45:00',3.11),('12664','2013-06-15','09:50:00',3.13),('12664','2013-06-15','09:55:00',3.23),('12664','2013-06-15','10:00:00',3.23),('12664','2013-06-15','10:05:00',3.33),('12664','2013-06-15','10:10:00',3.41),('12664','2013-06-15','10:15:00',3.46),('12664','2013-06-15','10:20:00',3.51),('12664','2013-06-15','10:25:00',3.54),('12664','2013-06-15','10:30:00',3.6),('12664','2013-06-15','10:35:00',3.65),('12664','2013-06-15','10:40:00',3.65),('12664','2013-06-15','10:45:00',3.74),('12664','2013-06-15','10:50:00',3.78),('12664','2013-06-15','10:55:00',3.79),('12664','2013-06-15','11:00:00',3.8),('12664','2013-06-15','11:05:00',3.72),('12664','2013-06-15','11:10:00',4.01),('12664','2013-06-15','11:15:00',2.31),('12664','2013-06-15','11:20:00',2.92),('12664','2013-06-15','11:25:00',4.08),('12664','2013-06-15','11:30:00',4.15),('12664','2013-06-15','11:35:00',3.94),('12664','2013-06-15','11:40:00',4.26),('12664','2013-06-15','11:45:00',3.95),('12664','2013-06-15','11:50:00',4.15),('12664','2013-06-15','11:55:00',3.86),('12664','2013-06-15','12:00:00',4.25),('12664','2013-06-15','12:05:00',4.28),('12664','2013-06-15','12:10:00',4.3),('12664','2013-06-15','12:15:00',4.37),('12664','2013-06-15','12:20:00',4.39),('12664','2013-06-15','12:25:00',4.35),('12664','2013-06-15','12:30:00',4.37),('12664','2013-06-15','12:35:00',4.33),('12664','2013-06-15','12:40:00',4.34),('12664','2013-06-15','12:45:00',4.38),('12664','2013-06-15','12:50:00',4.38),('12664','2013-06-15','12:55:00',4.33),('12664','2013-06-15','13:00:00',4.34),('12664','2013-06-15','13:05:00',4.32),('12664','2013-06-15','13:10:00',4.34),('12664','2013-06-15','13:15:00',4.34),('12664','2013-06-15','13:20:00',4.36),('12664','2013-06-15','13:25:00',4.36),('12664','2013-06-15','13:30:00',4.38),('12664','2013-06-15','13:35:00',4.39),('12664','2013-06-15','13:40:00',4.37),('12664','2013-06-15','13:45:00',4.33),('12664','2013-06-15','13:50:00',4.14),('12664','2013-06-15','13:55:00',4.34),('12664','2013-06-15','14:00:00',4.32),('12664','2013-06-15','14:05:00',4.31),('12664','2013-06-15','14:10:00',4.29),('12664','2013-06-15','14:15:00',4.26),('12664','2013-06-15','14:20:00',4.18),('12664','2013-06-15','14:25:00',4.21),('12664','2013-06-15','14:30:00',4.15),('12664','2013-06-15','14:35:00',4.16),('12664','2013-06-15','14:40:00',4.12),('12664','2013-06-15','14:45:00',4.08),('12664','2013-06-15','14:50:00',4.06),('12664','2013-06-15','14:55:00',4.01),('12664','2013-06-15','15:00:00',4.01),('12664','2013-06-15','15:05:00',3.97),('12664','2013-06-15','15:10:00',3.91),('12664','2013-06-15','15:15:00',3.89),('12664','2013-06-15','15:20:00',3.85),('12664','2013-06-15','15:25:00',3.8),('12664','2013-06-15','15:30:00',3.74),('12664','2013-06-15','15:35:00',3.7),('12664','2013-06-15','15:40:00',3.65),('12664','2013-06-15','15:45:00',3.6),('12664','2013-06-15','15:50:00',3.55),('12664','2013-06-15','15:55:00',3.48),('12664','2013-06-15','16:00:00',3.42),('12664','2013-06-15','16:05:00',3.36),('12664','2013-06-15','16:10:00',3.31),('12664','2013-06-15','16:15:00',3.25),('12664','2013-06-15','16:20:00',3.17),('12664','2013-06-15','16:25:00',3.11),('12664','2013-06-15','16:30:00',3.02),('12664','2013-06-15','16:35:00',2.96),('12664','2013-06-15','16:40:00',2.89),('12664','2013-06-15','16:45:00',2.81),('12664','2013-06-15','16:50:00',2.74),('12664','2013-06-15','16:55:00',2.67),('12664','2013-06-15','17:00:00',2.61),('12664','2013-06-15','17:05:00',2.52),('12664','2013-06-15','17:10:00',2.44),('12664','2013-06-15','17:15:00',2.38),('12664','2013-06-15','17:20:00',2.28),('12664','2013-06-15','17:25:00',2.2),('12664','2013-06-15','17:30:00',2.11),('12664','2013-06-15','17:35:00',2.02),('12664','2013-06-15','17:40:00',1.95),('12664','2013-06-15','17:45:00',1.87),('12664','2013-06-15','17:50:00',1.78),('12664','2013-06-15','17:55:00',1.68),('12664','2013-06-15','18:00:00',1.6),('12664','2013-06-15','18:05:00',1.53),('12664','2013-06-15','18:10:00',1.43),('12664','2013-06-15','18:15:00',1.35),('12664','2013-06-15','18:20:00',1.26),('12664','2013-06-15','18:25:00',1.17),('12664','2013-06-15','18:30:00',1.08),('12664','2013-06-14','07:35:00',1.08),('12664','2013-06-14','07:40:00',1.17),('12664','2013-06-14','07:45:00',1.26),('12664','2013-06-14','07:50:00',1.36),('12664','2013-06-14','07:55:00',1.45),('12664','2013-06-14','08:00:00',1.54),('12664','2013-06-14','08:05:00',1.64),('12664','2013-06-14','08:10:00',1.74),('12664','2013-06-14','08:15:00',1.83),('12664','2013-06-14','08:20:00',1.93),('12664','2013-06-14','08:25:00',2.01),('12664','2013-06-14','08:30:00',2.1),('12664','2013-06-14','08:35:00',2.19),('12664','2013-06-14','08:40:00',2.28),('12664','2013-06-14','08:45:00',2.36),('12664','2013-06-14','08:50:00',2.44),('12664','2013-06-14','08:55:00',2.52),('12664','2013-06-14','09:00:00',2.59),('12664','2013-06-14','09:05:00',2.66),('12664','2013-06-14','09:10:00',2.72),('12664','2013-06-14','09:15:00',2.79),('12664','2013-06-14','09:20:00',2.86),('12664','2013-06-14','09:25:00',2.94),('12664','2013-06-14','09:30:00',3.01),('12664','2013-06-14','09:35:00',3.09),('12664','2013-06-14','09:40:00',3.15),('12664','2013-06-14','09:45:00',3.21),('12664','2013-06-14','09:50:00',3.27),('12664','2013-06-14','09:55:00',3.29),('12664','2013-06-14','10:00:00',3.33),('12664','2013-06-14','10:05:00',3.37),('12664','2013-06-14','10:10:00',3.4),('12664','2013-06-14','10:15:00',3.52),('12664','2013-06-14','10:20:00',3.57),('12664','2013-06-14','10:25:00',3.51),('12664','2013-06-14','10:30:00',3.6),('12664','2013-06-14','10:35:00',3.65),('12664','2013-06-14','10:40:00',3.75),('12664','2013-06-14','10:45:00',3.78),('12664','2013-06-14','10:50:00',3.8),('12664','2013-06-14','10:55:00',3.87),('12664','2013-06-14','11:00:00',3.87),('12664','2013-06-14','11:05:00',3.89),('12664','2013-06-14','11:10:00',3.97),('12664','2013-06-14','11:15:00',3.99),('12664','2013-06-14','11:20:00',4.07),('12664','2013-06-14','11:25:00',4.08),('12664','2013-06-14','11:30:00',4.1),('12664','2013-06-14','11:35:00',4.09),('12664','2013-06-14','11:40:00',4.14),('12664','2013-06-14','11:45:00',4.12),('12664','2013-06-14','11:50:00',4.08),('12664','2013-06-14','11:55:00',4.2),('12664','2013-06-14','12:00:00',4.26),('12664','2013-06-14','12:05:00',4.26),('12664','2013-06-14','12:10:00',4.28),('12664','2013-06-14','12:15:00',4.36),('12664','2013-06-14','12:20:00',4.38),('12664','2013-06-14','12:25:00',4.41),('12664','2013-06-14','12:30:00',4.4),('12664','2013-06-14','12:35:00',4.4),('12664','2013-06-14','12:40:00',4.38),('12664','2013-06-14','12:45:00',4.42),('12664','2013-06-14','12:50:00',4.41),('12664','2013-06-14','12:55:00',4.38),('12664','2013-06-14','13:00:00',4.36),('12664','2013-06-14','13:05:00',4.37),('12664','2013-06-14','13:10:00',4.42),('12664','2013-06-14','13:15:00',4.45),('12664','2013-06-14','13:20:00',4.41),('12664','2013-06-14','13:25:00',4.4),('12664','2013-06-14','13:30:00',4.39),('12664','2013-06-14','13:35:00',4.39),('12664','2013-06-14','13:40:00',4.39),('12664','2013-06-14','13:45:00',4.37),('12664','2013-06-14','13:50:00',4.33),('12664','2013-06-14','13:55:00',4.32),('12664','2013-06-14','14:00:00',4.32),('12664','2013-06-14','14:05:00',4.32),('12664','2013-06-14','14:10:00',4.28),('12664','2013-06-14','14:15:00',4.29),('12664','2013-06-14','14:20:00',4.29),('12664','2013-06-14','14:25:00',4.27),('12664','2013-06-14','14:30:00',4.26),('12664','2013-06-14','14:35:00',4.23),('12664','2013-06-14','14:40:00',4.2),('12664','2013-06-14','14:45:00',4.13),('12664','2013-06-14','14:50:00',4.09),('12664','2013-06-14','14:55:00',4.07),('12664','2013-06-14','15:00:00',4.03),('12664','2013-06-14','15:05:00',4.04),('12664','2013-06-14','15:10:00',3.99),('12664','2013-06-14','15:15:00',3.94),('12664','2013-06-14','15:20:00',3.91),('12664','2013-06-14','15:25:00',3.88),('12664','2013-06-14','15:30:00',3.86),('12664','2013-06-14','15:35:00',3.8),('12664','2013-06-14','15:40:00',3.75),('12664','2013-06-14','15:45:00',3.7),('12664','2013-06-14','15:50:00',3.64),('12664','2013-06-14','15:55:00',3.59),('12664','2013-06-14','16:00:00',3.52),('12664','2013-06-14','16:05:00',3.46),('12664','2013-06-14','16:10:00',3.41),('12664','2013-06-14','16:15:00',3.34),('12664','2013-06-14','16:20:00',3.28),('12664','2013-06-14','16:25:00',3.22),('12664','2013-06-14','16:30:00',3.15),('12664','2013-06-14','16:35:00',3.08),('12664','2013-06-14','16:40:00',3),('12664','2013-06-14','16:45:00',2.91),('12664','2013-06-14','16:50:00',2.83),('12664','2013-06-14','16:55:00',2.73),('12664','2013-06-14','17:00:00',2.7),('12664','2013-06-14','17:05:00',2.55),('12664','2013-06-14','17:10:00',2.51),('12664','2013-06-14','17:15:00',2.43),('12664','2013-06-14','17:20:00',2.37),('12664','2013-06-14','17:25:00',2.25),('12664','2013-06-14','17:30:00',2.22),('12664','2013-06-14','17:35:00',2.15),('12664','2013-06-14','17:40:00',2.06),('12664','2013-06-14','17:45:00',1.96),('12664','2013-06-14','17:50:00',1.86),('12664','2013-06-14','17:55:00',1.78),('12664','2013-06-14','18:00:00',1.69),('12664','2013-06-14','18:05:00',1.6),('12664','2013-06-14','18:10:00',1.5),('12664','2013-06-14','18:15:00',1.4),('12664','2013-06-14','18:20:00',1.31),('12664','2013-06-14','18:25:00',1.23),('12664','2013-06-14','18:30:00',1.14),('12664','2013-06-14','18:35:00',1.05),('12664','2013-06-13','07:30:00',1),('12664','2013-06-13','07:35:00',1.1),('12664','2013-06-13','07:40:00',1.19),('12664','2013-06-13','07:45:00',1.3),('12664','2013-06-13','07:50:00',1.4),('12664','2013-06-13','07:55:00',1.49),('12664','2013-06-13','08:00:00',1.59),('12664','2013-06-13','08:05:00',1.68),('12664','2013-06-13','08:10:00',1.77),('12664','2013-06-13','08:15:00',1.87),('12664','2013-06-13','08:20:00',1.95),('12664','2013-06-13','08:25:00',2.03),('12664','2013-06-13','08:30:00',2.12),('12664','2013-06-13','08:35:00',2.21),('12664','2013-06-13','08:40:00',2.3),('12664','2013-06-13','08:45:00',2.38),('12664','2013-06-13','08:50:00',2.46),('12664','2013-06-13','08:55:00',2.54),('12664','2013-06-13','09:00:00',2.63),('12664','2013-06-13','09:05:00',2.7),('12664','2013-06-13','09:10:00',2.78),('12664','2013-06-13','09:15:00',2.86),('12664','2013-06-13','09:20:00',2.93),('12664','2013-06-13','09:25:00',3.01),('12664','2013-06-13','09:30:00',3.07),('12664','2013-06-13','09:35:00',3.13),('12664','2013-06-13','09:40:00',3.2),('12664','2013-06-13','09:45:00',3.26),('12664','2013-06-13','09:50:00',3.33),('12664','2013-06-13','09:55:00',3.39),('12664','2013-06-13','10:00:00',3.45),('12664','2013-06-13','10:05:00',3.51),('12664','2013-06-13','10:10:00',3.56),('12664','2013-06-13','10:15:00',3.62),('12664','2013-06-13','10:20:00',3.67),('12664','2013-06-13','10:25:00',3.72),('12664','2013-06-13','10:30:00',3.78),('12664','2013-06-13','10:35:00',3.82),('12664','2013-06-13','10:40:00',3.87),('12664','2013-06-13','10:45:00',3.92),('12664','2013-06-13','10:50:00',3.95),('12664','2013-06-13','10:55:00',4.01),('12664','2013-06-13','11:00:00',4.06),('12664','2013-06-13','11:05:00',4.09),('12664','2013-06-13','11:10:00',4.12),('12664','2013-06-13','11:15:00',4.12),('12664','2013-06-13','11:20:00',4.16),('12664','2013-06-13','11:25:00',4.21),('12664','2013-06-13','11:30:00',4.23),('12664','2013-06-13','11:35:00',4.27),('12664','2013-06-13','11:40:00',4.29),('12664','2013-06-13','11:45:00',4.3),('12664','2013-06-13','11:50:00',4.34),('12664','2013-06-13','11:55:00',4.35),('12664','2013-06-13','12:00:00',4.38),('12664','2013-06-13','12:05:00',4.37),('12664','2013-06-13','12:10:00',4.39),('12664','2013-06-13','12:15:00',4.41),('12664','2013-06-13','12:20:00',4.42),('12664','2013-06-13','12:25:00',4.44),('12664','2013-06-13','12:30:00',4.4),('12664','2013-06-13','12:35:00',4.42),('12664','2013-06-13','12:40:00',4.47),('12664','2013-06-13','12:45:00',4.46),('12664','2013-06-13','12:50:00',4.45),('12664','2013-06-13','12:55:00',4.43),('12664','2013-06-13','13:00:00',4.41),('12664','2013-06-13','13:05:00',4.4),('12664','2013-06-13','13:10:00',4.4),('12664','2013-06-13','13:15:00',4.41),('12664','2013-06-13','13:20:00',4.42),('12664','2013-06-13','13:25:00',4.41),('12664','2013-06-13','13:30:00',4.39),('12664','2013-06-13','13:35:00',4.38),('12664','2013-06-13','13:40:00',4.35),('12664','2013-06-13','13:45:00',4.42),('12664','2013-06-13','13:50:00',4.38),('12664','2013-06-13','13:55:00',4.3),('12664','2013-06-13','14:00:00',4.24),('12664','2013-06-13','14:05:00',4.31),('12664','2013-06-13','14:10:00',4.2),('12664','2013-06-13','14:15:00',4.21),('12664','2013-06-13','14:20:00',4.21),('12664','2013-06-13','14:25:00',4.39),('12664','2013-06-13','14:30:00',2.29),('12664','2013-06-13','14:35:00',2.63),('12664','2013-06-13','14:40:00',4.56),('12664','2013-06-13','14:45:00',4.37),('12664','2013-06-13','14:50:00',4.29),('12664','2013-06-13','14:55:00',4.17),('12664','2013-06-13','15:00:00',4.02),('12664','2013-06-13','15:05:00',3.95),('12664','2013-06-13','15:10:00',4.01),('12664','2013-06-13','15:15:00',3.83),('12664','2013-06-13','15:20:00',3.8),('12664','2013-06-13','15:25:00',3.73),('12664','2013-06-13','15:30:00',3.68),('12664','2013-06-13','15:35:00',3.61),('12664','2013-06-13','15:40:00',3.47),('12664','2013-06-13','15:45:00',3.22),('12664','2013-06-13','15:50:00',2.84),('12664','2013-06-13','15:55:00',3.42),('12664','2013-06-13','16:00:00',3.41),('12664','2013-06-13','16:05:00',3.33),('12664','2013-06-13','16:10:00',3.26),('12664','2013-06-13','16:15:00',3.2),('12664','2013-06-13','16:20:00',3.2),('12664','2013-06-13','16:25:00',3.14),('12664','2013-06-13','16:30:00',3.09),('12664','2013-06-13','16:35:00',2.99),('12664','2013-06-13','16:40:00',2.93),('12664','2013-06-13','16:45:00',2.85),('12664','2013-06-13','16:50:00',2.74),('12664','2013-06-13','16:55:00',2.73),('12664','2013-06-13','17:00:00',2.68),('12664','2013-06-13','17:05:00',2.59),('12664','2013-06-13','17:10:00',2.5),('12664','2013-06-13','17:15:00',2.42),('12664','2013-06-13','17:20:00',2.32),('12664','2013-06-13','17:25:00',2.22),('12664','2013-06-13','17:30:00',2.15),('12664','2013-06-13','17:35:00',2.05),('12664','2013-06-13','17:40:00',1.97),('12664','2013-06-13','17:45:00',1.9),('12664','2013-06-13','17:50:00',1.83),('12664','2013-06-13','17:55:00',1.74),('12664','2013-06-13','18:00:00',1.64),('12664','2013-06-13','18:05:00',1.55),('12664','2013-06-13','18:10:00',1.47),('12664','2013-06-13','18:15:00',1.38),('12664','2013-06-13','18:20:00',1.28),('12664','2013-06-13','18:25:00',1.19),('12664','2013-06-13','18:30:00',1.1),('12664','2013-06-13','18:35:00',1),('12664','2013-06-12','07:30:00',1),('12664','2013-06-12','07:35:00',1.1),('12664','2013-06-12','07:40:00',1.19),('12664','2013-06-12','07:45:00',1.29),('12664','2013-06-12','07:50:00',1.39),('12664','2013-06-12','07:55:00',1.5),('12664','2013-06-12','08:00:00',1.6),('12664','2013-06-12','08:05:00',1.69),('12664','2013-06-12','08:10:00',1.78),('12664','2013-06-12','08:15:00',1.87),('12664','2013-06-12','08:20:00',1.96),('12664','2013-06-12','08:25:00',2.04),('12664','2013-06-12','08:30:00',2.13),('12664','2013-06-12','08:35:00',2.22),('12664','2013-06-12','08:40:00',2.3),('12664','2013-06-12','08:45:00',2.38),('12664','2013-06-12','08:50:00',2.46),('12664','2013-06-12','08:55:00',2.53),('12664','2013-06-12','09:00:00',2.6),('12664','2013-06-12','09:05:00',2.68),('12664','2013-06-12','09:10:00',2.74),('12664','2013-06-12','09:15:00',2.81),('12664','2013-06-12','09:20:00',2.92),('12664','2013-06-12','09:25:00',2.98),('12664','2013-06-12','09:30:00',3.05),('12664','2013-06-12','09:35:00',3.14),('12664','2013-06-12','09:40:00',3.2),('12664','2013-06-12','09:45:00',3.25),('12664','2013-06-12','09:50:00',3.32),('12664','2013-06-12','09:55:00',3.39),('12664','2013-06-12','10:00:00',3.46),('12664','2013-06-12','10:05:00',3.52),('12664','2013-06-12','10:10:00',3.57),('12664','2013-06-12','10:15:00',3.66),('12664','2013-06-12','10:20:00',3.67),('12664','2013-06-12','10:25:00',3.7),('12664','2013-06-12','10:30:00',3.76),('12664','2013-06-12','10:35:00',3.79),('12664','2013-06-12','10:40:00',3.81),('12664','2013-06-12','10:45:00',3.87),('12664','2013-06-12','10:50:00',3.91),('12664','2013-06-12','10:55:00',4),('12664','2013-06-12','11:00:00',4),('12664','2013-06-12','11:05:00',4.03),('12664','2013-06-12','11:10:00',4.06),('12664','2013-06-12','11:15:00',4.13),('12664','2013-06-12','11:20:00',4.13),('12664','2013-06-12','11:25:00',4.2),('12664','2013-06-12','11:30:00',4.23),('12664','2013-06-12','11:35:00',4.25),('12664','2013-06-12','11:40:00',4.29),('12664','2013-06-12','11:45:00',4.29),('12664','2013-06-12','11:50:00',4.29),('12664','2013-06-12','11:55:00',4.33),('12664','2013-06-12','12:00:00',4.35),('12664','2013-06-12','12:05:00',4.38),('12664','2013-06-12','12:10:00',4.34),('12664','2013-06-12','12:15:00',4.32),('12664','2013-06-12','12:20:00',4.4),('12664','2013-06-12','12:25:00',3.57),('12664','2013-06-12','12:30:00',4.05),('12664','2013-06-12','12:35:00',4.44),('12664','2013-06-12','12:40:00',4.55),('12664','2013-06-12','12:45:00',3.63),('12664','2013-06-12','12:50:00',4.56),('12664','2013-06-12','12:55:00',4.61),('12664','2013-06-12','13:00:00',4.53),('12664','2013-06-12','13:05:00',4.51),('12664','2013-06-12','13:10:00',4.5),('12664','2013-06-12','13:15:00',4.17),('12664','2013-06-12','13:20:00',4.43),('12664','2013-06-12','13:25:00',3.22),('12664','2013-06-12','13:30:00',2.85),('12664','2013-06-12','13:35:00',3.47),('12664','2013-06-12','13:40:00',3.3),('12664','2013-06-12','13:45:00',4.42),('12664','2013-06-12','13:50:00',4.31),('12664','2013-06-12','13:55:00',4.59),('12664','2013-06-12','14:00:00',4.6),('12664','2013-06-12','14:05:00',4.47),('12664','2013-06-12','14:10:00',4.45),('12664','2013-06-12','14:15:00',4.43),('12664','2013-06-12','14:20:00',4.39),('12664','2013-06-12','14:25:00',4.21),('12664','2013-06-12','14:30:00',4.31),('12664','2013-06-12','14:35:00',4.29),('12664','2013-06-12','14:40:00',4.28),('12664','2013-06-12','14:45:00',4.24),('12664','2013-06-12','14:50:00',4.19),('12664','2013-06-12','14:55:00',4.2),('12664','2013-06-12','15:00:00',4.17),('12664','2013-06-12','15:05:00',4.11),('12664','2013-06-12','15:10:00',4.03),('12664','2013-06-12','15:15:00',4.04),('12664','2013-06-12','15:20:00',4.01),('12664','2013-06-12','15:25:00',3.95),('12664','2013-06-12','15:30:00',3.9),('12664','2013-06-12','15:35:00',3.85),('12664','2013-06-12','15:40:00',3.82),('12664','2013-06-12','15:45:00',3.8),('12664','2013-06-12','15:50:00',3.76),('12664','2013-06-12','15:55:00',3.7),('12664','2013-06-12','16:00:00',3.62),('12664','2013-06-12','16:05:00',3.54),('12664','2013-06-12','16:10:00',3.48),('12664','2013-06-12','16:15:00',3.42),('12664','2013-06-12','16:20:00',3.36),('12664','2013-06-12','16:25:00',3.32),('12664','2013-06-12','16:30:00',3.26),('12664','2013-06-12','16:35:00',3.2),('12664','2013-06-12','16:40:00',3.22),('12664','2013-06-12','16:45:00',3.1),('12664','2013-06-12','16:50:00',2.89),('12664','2013-06-12','16:55:00',1.26),('12664','2013-06-12','17:00:00',2.73),('12664','2013-06-12','17:05:00',2.55),('12664','2013-06-12','17:10:00',2.66),('12664','2013-06-12','17:15:00',2.54),('12664','2013-06-12','17:20:00',2.45),('12664','2013-06-12','17:25:00',2.39),('12664','2013-06-12','17:30:00',2.39),('12664','2013-06-12','17:35:00',2.37),('12664','2013-06-12','17:40:00',2.26),('12664','2013-06-12','17:45:00',2.13),('12664','2013-06-12','17:50:00',2.01),('12664','2013-06-12','17:55:00',1.95),('12664','2013-06-12','18:00:00',1.84),('12664','2013-06-12','18:05:00',1.3),('12664','2013-06-12','18:10:00',1.57),('12664','2013-06-12','18:15:00',1.45),('12664','2013-06-12','18:25:00',1.03),('12664','2013-06-12','18:30:00',1.1),('12664','2013-06-12','18:35:00',1.06),('12664','2013-06-11','07:30:00',1.04),('12664','2013-06-11','07:35:00',1.09),('12664','2013-06-11','07:40:00',1.16),('12664','2013-06-11','07:45:00',1.25),('12664','2013-06-11','07:50:00',1.34),('12664','2013-06-11','07:55:00',1.43),('12664','2013-06-11','08:00:00',1.53),('12664','2013-06-11','08:05:00',1.63),('12664','2013-06-11','08:10:00',1.73),('12664','2013-06-11','08:15:00',1.82),('12664','2013-06-11','08:20:00',1.91),('12664','2013-06-11','08:25:00',1.99),('12664','2013-06-11','08:30:00',2.08),('12664','2013-06-11','08:35:00',2.18),('12664','2013-06-11','08:40:00',2.27),('12664','2013-06-11','08:45:00',2.35),('12664','2013-06-11','08:50:00',2.41),('12664','2013-06-11','08:55:00',2.54),('12664','2013-06-11','09:00:00',2.58),('12664','2013-06-11','09:05:00',2.69),('12664','2013-06-11','09:10:00',2.78),('12664','2013-06-11','09:15:00',2.86),('12664','2013-06-11','09:20:00',2.9),('12664','2013-06-11','09:25:00',2.97),('12664','2013-06-11','09:30:00',3.07),('12664','2013-06-11','09:35:00',3.11),('12664','2013-06-11','09:40:00',3.13),('12664','2013-06-11','09:45:00',3.14),('12664','2013-06-11','09:50:00',3.34),('12664','2013-06-11','09:55:00',3.38),('12664','2013-06-11','10:00:00',3.46),('12664','2013-06-11','10:05:00',3.61),('12664','2013-06-11','10:10:00',3.65),('12664','2013-06-11','10:15:00',3.78),('12664','2013-06-11','10:20:00',3.64),('12664','2013-06-11','10:25:00',4.04),('12664','2013-06-11','10:30:00',3.02),('12664','2013-06-11','10:35:00',4.12),('12664','2013-06-11','10:40:00',3.96),('12664','2013-06-11','10:45:00',2.64),('12664','2013-06-11','10:50:00',3.33),('12664','2013-06-11','10:55:00',4.2),('12664','2013-06-11','11:00:00',4.21),('12664','2013-06-11','11:05:00',4.19),('12664','2013-06-11','11:10:00',4.24),('12664','2013-06-11','11:15:00',4.25),('12664','2013-06-11','11:20:00',4.28),('12664','2013-06-11','11:25:00',4.33),('12664','2013-06-11','11:30:00',4.37),('12664','2013-06-11','11:35:00',4.42),('12664','2013-06-11','11:40:00',4.41),('12664','2013-06-11','11:45:00',4.39),('12664','2013-06-11','11:50:00',4.1),('12664','2013-06-11','11:55:00',4.53),('12664','2013-06-11','12:00:00',4.58),('12664','2013-06-11','12:05:00',4.55),('12664','2013-06-11','12:10:00',4.64),('12664','2013-06-11','12:15:00',4.57),('12664','2013-06-11','12:20:00',4.54),('12664','2013-06-11','12:25:00',4.56),('12664','2013-06-11','12:30:00',4.59),('12664','2013-06-11','12:35:00',4.59),('12664','2013-06-11','12:40:00',4.64),('12664','2013-06-11','12:45:00',4.67),('12664','2013-06-11','12:50:00',4.67),('12664','2013-06-11','12:55:00',4.64),('12664','2013-06-11','13:00:00',4.69),('12664','2013-06-11','13:05:00',4.76),('12664','2013-06-11','13:10:00',4.69),('12664','2013-06-11','13:15:00',4.7),('12664','2013-06-11','13:20:00',4.69),('12664','2013-06-11','13:25:00',4.69),('12664','2013-06-11','13:30:00',4.71),('12664','2013-06-11','13:35:00',4.7),('12664','2013-06-11','13:40:00',4.69),('12664','2013-06-11','13:45:00',4.65),('12664','2013-06-11','13:50:00',4.6),('12664','2013-06-11','13:55:00',4.6),('12664','2013-06-11','14:00:00',4.57),('12664','2013-06-11','14:05:00',4.56),('12664','2013-06-11','14:10:00',4.51),('12664','2013-06-11','14:15:00',4.49),('12664','2013-06-11','14:20:00',4.46),('12664','2013-06-11','14:25:00',4.44),('12664','2013-06-11','14:30:00',4.39),('12664','2013-06-11','14:35:00',4.34),('12664','2013-06-11','14:40:00',4.34),('12664','2013-06-11','14:45:00',3.45),('12664','2013-06-11','14:50:00',4.39),('12664','2013-06-11','14:55:00',4.3),('12664','2013-06-11','15:00:00',4.18),('12664','2013-06-11','15:05:00',4.13),('12664','2013-06-11','15:10:00',4.1),('12664','2013-06-11','15:15:00',3.81),('12664','2013-06-11','15:20:00',4.07),('12664','2013-06-11','15:25:00',3.96),('12664','2013-06-11','15:30:00',4.09),('12664','2013-06-11','15:35:00',3.98),('12664','2013-06-11','15:40:00',3.86),('12664','2013-06-11','15:45:00',3.88),('12664','2013-06-11','15:50:00',3.78),('12664','2013-06-11','15:55:00',3.62),('12664','2013-06-11','16:00:00',3.62),('12664','2013-06-11','16:05:00',3.56),('12664','2013-06-11','16:10:00',3.48),('12664','2013-06-11','16:15:00',3.42),('12664','2013-06-11','16:20:00',3.34),('12664','2013-06-11','16:25:00',3.29),('12664','2013-06-11','16:30:00',3.25),('12664','2013-06-11','16:35:00',3.22),('12664','2013-06-11','16:40:00',3.26),('12664','2013-06-11','16:45:00',3.28),('12664','2013-06-11','16:50:00',3.19),('12664','2013-06-11','16:55:00',1.88),('12664','2013-06-11','17:00:00',1.29),('12664','2013-06-11','17:05:00',1.04),('12664','2013-06-10','07:25:00',1.1),('12664','2013-06-10','07:30:00',1.15),('12664','2013-06-10','07:55:00',1.45),('12664','2013-06-10','08:00:00',1.09),('12664','2013-06-10','08:05:00',1.1),('12664','2013-06-10','08:10:00',1.43),('12664','2013-06-10','08:15:00',1.27),('12664','2013-06-10','08:20:00',1.94),('12664','2013-06-10','08:25:00',1.21),('12664','2013-06-10','08:45:00',1.78),('12664','2013-06-10','08:50:00',2.27),('12664','2013-06-10','08:55:00',1.76),('12664','2013-06-10','09:00:00',1.44),('12664','2013-06-10','09:05:00',1.43),('12664','2013-06-10','09:10:00',1.69),('12664','2013-06-10','09:15:00',3.23),('12664','2013-06-10','09:20:00',2.95),('12664','2013-06-10','09:25:00',2.14),('12664','2013-06-10','09:30:00',2.96),('12664','2013-06-10','09:35:00',2.13),('12664','2013-06-10','09:40:00',2.27),('12664','2013-06-10','09:45:00',3.23),('12664','2013-06-10','09:50:00',2.05),('12664','2013-06-10','09:55:00',2.06),('12664','2013-06-10','10:00:00',2.01),('12664','2013-06-10','10:05:00',1.76),('12664','2013-06-10','10:10:00',1.69),('12664','2013-06-10','10:15:00',1.64),('12664','2013-06-10','10:20:00',2.43),('12664','2013-06-10','10:25:00',2.73),('12664','2013-06-10','10:30:00',3.16),('12664','2013-06-10','10:35:00',3.7),('12664','2013-06-10','10:40:00',2.5),('12664','2013-06-10','10:45:00',1.73),('12664','2013-06-10','10:50:00',3.76),('12664','2013-06-10','10:55:00',3.01),('12664','2013-06-10','11:00:00',2.93),('12664','2013-06-10','11:05:00',3.96),('12664','2013-06-10','11:10:00',4.47),('12664','2013-06-10','11:15:00',3.82),('12664','2013-06-10','11:20:00',2.28),('12664','2013-06-10','11:25:00',1.57),('12664','2013-06-10','11:30:00',1.8),('12664','2013-06-10','11:35:00',2.56),('12664','2013-06-10','11:40:00',4.23),('12664','2013-06-10','11:45:00',2.35),('12664','2013-06-10','11:50:00',4.1),('12664','2013-06-10','11:55:00',3.22),('12664','2013-06-10','12:00:00',3.61),('12664','2013-06-10','12:05:00',4.97),('12664','2013-06-10','12:10:00',4.11),('12664','2013-06-10','12:15:00',4.36),('12664','2013-06-10','12:20:00',1.77),('12664','2013-06-10','12:25:00',4.3),('12664','2013-06-10','12:30:00',4.37),('12664','2013-06-10','12:35:00',1.85),('12664','2013-06-10','12:40:00',3.76),('12664','2013-06-10','12:45:00',3.39),('12664','2013-06-10','12:50:00',4.79),('12664','2013-06-10','12:55:00',2.27),('12664','2013-06-10','13:00:00',1.91),('12664','2013-06-10','13:05:00',2.54),('12664','2013-06-10','13:10:00',2.41),('12664','2013-06-10','13:15:00',2.9),('12664','2013-06-10','13:20:00',2.55),('12664','2013-06-10','13:25:00',1.89),('12664','2013-06-10','13:30:00',1.69),('12664','2013-06-10','13:35:00',2.05),('12664','2013-06-10','13:40:00',2.66),('12664','2013-06-10','13:45:00',3.04),('12664','2013-06-10','13:50:00',3.57),('12664','2013-06-10','13:55:00',4.8),('12664','2013-06-10','14:00:00',3.12),('12664','2013-06-10','14:05:00',4.51),('12664','2013-06-10','14:10:00',4.66),('12664','2013-06-10','14:15:00',4.61),('12664','2013-06-10','14:20:00',4.39),('12664','2013-06-10','14:25:00',4.5),('12664','2013-06-10','14:30:00',4.47),('12664','2013-06-10','14:35:00',4.43),('12664','2013-06-10','14:40:00',4.39),('12664','2013-06-10','14:45:00',4.36),('12664','2013-06-10','14:50:00',4.31),('12664','2013-06-10','14:55:00',4.24),('12664','2013-06-10','15:00:00',3.98),('12664','2013-06-10','15:05:00',4.18),('12664','2013-06-10','15:10:00',4.16),('12664','2013-06-10','15:15:00',4.13),('12664','2013-06-10','15:20:00',4.09),('12664','2013-06-10','15:25:00',4.04),('12664','2013-06-10','15:30:00',3.99),('12664','2013-06-10','15:35:00',3.98),('12664','2013-06-10','15:40:00',3.91),('12664','2013-06-10','15:45:00',3.84),('12664','2013-06-10','15:50:00',3.79),('12664','2013-06-10','15:55:00',3.72),('12664','2013-06-10','16:00:00',3.67),('12664','2013-06-10','16:05:00',3.6),('12664','2013-06-10','16:10:00',3.54),('12664','2013-06-10','16:15:00',3.48),('12664','2013-06-10','16:20:00',3.42),('12664','2013-06-10','16:25:00',3.35),('12664','2013-06-10','16:30:00',3.28),('12664','2013-06-10','16:35:00',3.19),('12664','2013-06-10','16:40:00',3.11),('12664','2013-06-10','16:45:00',3.04),('12664','2013-06-10','16:50:00',2.98),('12664','2013-06-10','16:55:00',2.89),('12664','2013-06-10','17:00:00',2.8),('12664','2013-06-10','17:05:00',2.74),('12664','2013-06-10','17:10:00',2.67),('12664','2013-06-10','17:15:00',2.59),('12664','2013-06-10','17:20:00',2.49),('12664','2013-06-10','17:25:00',2.41),('12664','2013-06-10','17:30:00',2.3),('12664','2013-06-10','17:35:00',2.21),('12664','2013-06-10','17:40:00',2.13),('12664','2013-06-10','17:45:00',2.04),('12664','2013-06-10','17:50:00',1.95),('12664','2013-06-10','17:55:00',1.84),('12664','2013-06-10','18:00:00',1.74),('12664','2013-06-10','18:05:00',1.65),('12664','2013-06-10','18:10:00',1.55),('12664','2013-06-10','18:15:00',1.46),('12664','2013-06-10','18:20:00',1.36),('12664','2013-06-10','18:25:00',1.26),('12664','2013-06-10','18:30:00',1.16),('12664','2013-06-10','18:35:00',1.06),('12664','2014-04-02','08:20:00',1.05),('12664','2014-04-02','09:00:00',1.48),('12664','2014-04-02','09:05:00',1.69),('12664','2014-04-02','09:10:00',1.72),('12664','2014-04-02','09:45:00',1.6),('12664','2014-04-02','09:50:00',2.65),('12664','2014-04-02','09:55:00',2.87),('12664','2014-04-02','10:00:00',2.51),('12664','2014-04-02','10:05:00',1.05),('12664','2014-04-02','10:25:00',1.11),('12664','2014-04-02','10:30:00',2.88),('12664','2014-04-02','10:35:00',1.85),('12664','2014-04-02','10:40:00',1.24),('12664','2014-04-02','11:00:00',1.31),('12664','2014-04-02','11:05:00',2),('12664','2014-04-02','11:10:00',1.31),('12664','2014-04-02','11:25:00',1.07),('12664','2014-04-02','11:30:00',1.49),('12664','2014-04-02','11:35:00',2.5),('12664','2014-04-02','11:40:00',2.97),('12664','2014-04-02','11:45:00',4.66),('12664','2014-04-02','11:50:00',4.01),('12664','2014-04-02','11:55:00',1.89),('12664','2014-04-02','12:00:00',1.45),('12664','2014-04-02','12:05:00',4.02),('12664','2014-04-02','12:10:00',4.42),('12664','2014-04-02','12:15:00',4.1),('12664','2014-04-02','12:20:00',3.97),('12664','2014-04-02','12:25:00',3.41),('12664','2014-04-02','12:30:00',2.91),('12664','2014-04-02','12:35:00',4.01),('12664','2014-04-02','12:40:00',4.45),('12664','2014-04-02','12:45:00',4.45),('12664','2014-04-02','12:50:00',4.59),('12664','2014-04-02','12:55:00',2.64),('12664','2014-04-02','13:00:00',3.75),('12664','2014-04-02','13:05:00',2.73),('12664','2014-04-02','13:10:00',3.81),('12664','2014-04-02','13:15:00',3.32),('12664','2014-04-02','13:20:00',3.11),('12664','2014-04-02','13:25:00',3.44),('12664','2014-04-02','13:30:00',4.3),('12664','2014-04-02','13:35:00',4.16),('12664','2014-04-02','13:40:00',2.7),('12664','2014-04-02','13:45:00',4.38),('12664','2014-04-02','13:50:00',3.17),('12664','2014-04-02','13:55:00',2.78),('12664','2014-04-02','14:00:00',3.92),('12664','2014-04-02','14:05:00',3.78),('12664','2014-04-02','14:10:00',3.5),('12664','2014-04-02','14:15:00',3.51),('12664','2014-04-02','14:20:00',4.29),('12664','2014-04-02','14:25:00',3.85),('12664','2014-04-02','14:30:00',3.98),('12664','2014-04-02','14:35:00',2.31),('12664','2014-04-02','14:40:00',3.96),('12664','2014-04-02','14:45:00',3.76),('12664','2014-04-02','14:50:00',3.43),('12664','2014-04-02','14:55:00',3.58),('12664','2014-04-02','15:00:00',3.62),('12664','2014-04-02','15:05:00',3.46),('12664','2014-04-02','15:10:00',3.41),('12664','2014-04-02','15:15:00',3.5),('12664','2014-04-02','15:20:00',3.35),('12664','2014-04-02','15:25:00',3.14),('12664','2014-04-02','15:30:00',3.01),('12664','2014-04-02','15:35:00',3.29),('12664','2014-04-02','15:40:00',3.3),('12664','2014-04-02','15:45:00',3.22),('12664','2014-04-02','15:50:00',2.86),('12664','2014-04-02','15:55:00',2.86),('12664','2014-04-02','16:00:00',2.88),('12664','2014-04-02','16:05:00',2.8),('12664','2014-04-02','16:10:00',2.75),('12664','2014-04-02','16:15:00',2.69),('12664','2014-04-02','16:20:00',2.58),('12664','2014-04-02','16:25:00',2.56),('12664','2014-04-02','16:30:00',2.47),('12664','2014-04-02','16:35:00',2.43),('12664','2014-04-02','16:40:00',2.38),('12664','2014-04-02','16:45:00',2.16),('12664','2014-04-02','16:50:00',2.02),('12664','2014-04-02','16:55:00',2.18),('12664','2014-04-02','17:00:00',2.03),('12664','2014-04-02','17:05:00',1.88),('12664','2014-04-02','17:10:00',1.79),('12664','2014-04-02','17:15:00',1.65),('12664','2014-04-02','17:20:00',1.58),('12664','2014-04-02','17:25:00',1.49),('12664','2014-04-02','17:30:00',1.34),('12664','2014-04-02','17:35:00',1.14),('12664','2014-04-02','17:40:00',1.03),('12664','2014-04-02','17:45:00',1.14),('12664','2014-04-02','17:50:00',1.1),('12664','2013-06-09','07:55:00',1.4),('12664','2013-06-09','08:00:00',1.05),('12664','2013-06-09','08:05:00',1.23),('12664','2013-06-09','08:10:00',1.51),('12664','2013-06-09','08:15:00',1.76),('12664','2013-06-09','08:20:00',1.86),('12664','2013-06-09','08:25:00',1.9),('12664','2013-06-09','08:30:00',1.94),('12664','2013-06-09','08:35:00',2.08),('12664','2013-06-09','08:40:00',2.13),('12664','2013-06-09','08:45:00',2.21),('12664','2013-06-09','08:50:00',2.37),('12664','2013-06-09','08:55:00',2.42),('12664','2013-06-09','09:00:00',2.5),('12664','2013-06-09','09:05:00',2.6),('12664','2013-06-09','09:10:00',2.65),('12664','2013-06-09','09:15:00',2.7),('12664','2013-06-09','09:20:00',2.77),('12664','2013-06-09','09:25:00',2.82),('12664','2013-06-09','09:30:00',2.91),('12664','2013-06-09','09:35:00',2.97),('12664','2013-06-09','09:40:00',3.07),('12664','2013-06-09','09:45:00',3.12),('12664','2013-06-09','09:50:00',3.15),('12664','2013-06-09','09:55:00',3.25),('12664','2013-06-09','10:00:00',3.25),('12664','2013-06-09','10:05:00',3.33),('12664','2013-06-09','10:10:00',3.42),('12664','2013-06-09','10:15:00',3.46),('12664','2013-06-09','10:20:00',3.51),('12664','2013-06-09','10:25:00',3.53),('12664','2013-06-09','10:30:00',3.56),('12664','2013-06-09','10:35:00',3.65),('12664','2013-06-09','10:40:00',3.73),('12664','2013-06-09','10:45:00',3.77),('12664','2013-06-09','10:50:00',3.78),('12664','2013-06-09','10:55:00',3.85),('12664','2013-06-09','11:00:00',3.84),('12664','2013-06-09','11:05:00',3.87),('12664','2013-06-09','11:10:00',3.88),('12664','2013-06-09','11:15:00',3.97),('12664','2013-06-09','11:20:00',4.03),('12664','2013-06-09','11:25:00',4.02),('12664','2013-06-09','11:30:00',4.05),('12664','2013-06-09','11:35:00',4.1),('12664','2013-06-09','11:40:00',4.08),('12664','2013-06-09','11:45:00',4.17),('12664','2013-06-09','11:50:00',4.16),('12664','2013-06-09','11:55:00',4.23),('12664','2013-06-09','12:00:00',4.24),('12664','2013-06-09','12:05:00',3.76),('12664','2013-06-09','12:10:00',4.02),('12664','2013-06-09','12:15:00',4.27),('12664','2013-06-09','12:20:00',3.89),('12664','2013-06-09','12:25:00',4.3),('12664','2013-06-09','12:30:00',4.26),('12664','2013-06-09','12:35:00',4.38),('12664','2013-06-09','12:40:00',4.45),('12664','2013-06-09','12:45:00',4.35),('12664','2013-06-09','12:50:00',4.29),('12664','2013-06-09','12:55:00',3.61),('12664','2013-06-09','13:00:00',4.46),('12664','2013-06-09','13:05:00',4.29),('12664','2013-06-09','13:10:00',4.41),('12664','2013-06-09','13:15:00',4.43),('12664','2013-06-09','13:20:00',4.5),('12664','2013-06-09','13:25:00',4.62),('12664','2013-06-09','13:30:00',3.95),('12664','2013-06-09','13:35:00',3.76),('12664','2013-06-09','13:40:00',3.92),('12664','2013-06-09','13:45:00',2.73),('12664','2013-06-09','13:50:00',4.87),('12664','2013-06-09','13:55:00',4.68),('12664','2013-06-09','14:00:00',4.3),('12664','2013-06-09','14:05:00',4.05),('12664','2013-06-09','14:10:00',4.72),('12664','2013-06-09','14:15:00',3.25),('12664','2013-06-09','14:20:00',1.57),('12664','2013-06-09','14:25:00',1.18),('12664','2013-06-09','14:30:00',1.61),('12664','2013-06-09','14:35:00',3.54),('12664','2013-06-09','14:40:00',4.42),('12664','2013-06-09','14:45:00',3.63),('12664','2013-06-09','14:50:00',3.91),('12664','2013-06-09','14:55:00',4.32),('12664','2013-06-09','15:00:00',4.12),('12664','2013-06-09','15:05:00',4.17),('12664','2013-06-09','15:10:00',4.13),('12664','2013-06-09','15:15:00',4),('12664','2013-06-09','15:20:00',3.99),('12664','2013-06-09','15:25:00',3.92),('12664','2013-06-09','15:30:00',3.86),('12664','2013-06-09','15:35:00',3.55),('12664','2013-06-09','15:40:00',3.05),('12664','2013-06-09','15:45:00',3.09),('12664','2013-06-09','15:50:00',3.61),('12664','2013-06-09','15:55:00',3.5),('12664','2013-06-09','16:00:00',3.5),('12664','2013-06-09','16:05:00',3.42),('12664','2013-06-09','16:10:00',3),('12664','2013-06-09','16:15:00',2.58),('12664','2013-06-09','16:20:00',2.52),('12664','2013-06-09','16:25:00',1.92),('12664','2013-06-09','16:30:00',1.06),('12664','2013-06-09','16:35:00',1.09),('12664','2013-06-09','16:45:00',1),('12664','2013-06-09','16:55:00',1.04),('12664','2013-06-09','17:00:00',1.08),('12664','2013-06-09','17:05:00',1.02),('12664','2013-06-09','18:00:00',1.15),('12664','2013-06-09','18:05:00',1.89),('12664','2013-06-09','18:10:00',1.2),('12664','2013-06-08','07:35:00',1.03),('12664','2013-06-08','07:40:00',1.12),('12664','2013-06-08','07:45:00',1.21),('12664','2013-06-08','07:50:00',1.31),('12664','2013-06-08','07:55:00',1.39),('12664','2013-06-08','08:00:00',1.5),('12664','2013-06-08','08:05:00',1.59),('12664','2013-06-08','08:10:00',1.69),('12664','2013-06-08','08:15:00',1.77),('12664','2013-06-08','08:20:00',1.85),('12664','2013-06-08','08:25:00',1.95),('12664','2013-06-08','08:30:00',2.04),('12664','2013-06-08','08:35:00',2.11),('12664','2013-06-08','08:40:00',2.19),('12664','2013-06-08','08:45:00',2.27),('12664','2013-06-08','08:50:00',2.33),('12664','2013-06-08','08:55:00',2.45),('12664','2013-06-08','09:00:00',2.55),('12664','2013-06-08','09:05:00',2.63),('12664','2013-06-08','09:10:00',2.69),('12664','2013-06-08','09:15:00',2.75),('12664','2013-06-08','09:20:00',2.8),('12664','2013-06-08','09:25:00',2.87),('12664','2013-06-08','09:30:00',2.97),('12664','2013-06-08','09:35:00',2.68),('12664','2013-06-08','09:40:00',2.56),('12664','2013-06-08','09:45:00',2.17),('12664','2013-06-08','09:50:00',3.23),('12664','2013-06-08','09:55:00',3.63),('12664','2013-06-08','10:00:00',3.55),('12664','2013-06-08','10:05:00',3.33),('12664','2013-06-08','10:10:00',3.57),('12664','2013-06-08','10:15:00',3.59),('12664','2013-06-08','10:20:00',3.7),('12664','2013-06-08','10:25:00',3.76),('12664','2013-06-08','10:30:00',3.78),('12664','2013-06-08','10:35:00',3.73),('12664','2013-06-08','10:40:00',3.94),('12664','2013-06-08','10:45:00',4.12),('12664','2013-06-08','10:50:00',4.17),('12664','2013-06-08','10:55:00',4.41),('12664','2013-06-08','11:00:00',4.51),('12664','2013-06-08','11:05:00',4.39),('12664','2013-06-08','11:10:00',3.62),('12664','2013-06-08','11:15:00',1.7),('12664','2013-06-08','11:20:00',3.74),('12664','2013-06-08','11:25:00',4.34),('12664','2013-06-08','11:30:00',4.3),('12664','2013-06-08','11:35:00',4.29),('12664','2013-06-08','11:40:00',4.38),('12664','2013-06-08','11:45:00',4.38),('12664','2013-06-08','11:50:00',3.41),('12664','2013-06-08','11:55:00',2.04),('12664','2013-06-08','12:00:00',4.19),('12664','2013-06-08','12:05:00',4.4),('12664','2013-06-08','12:10:00',4.52),('12664','2013-06-08','12:15:00',4.42),('12664','2013-06-08','12:20:00',4.38),('12664','2013-06-08','12:25:00',4.32),('12664','2013-06-08','12:30:00',4.4),('12664','2013-06-08','12:35:00',4.33),('12664','2013-06-08','12:40:00',4.37),('12664','2013-06-08','12:45:00',4.51),('12664','2013-06-08','12:50:00',4.53),('12664','2013-06-08','12:55:00',4.57),('12664','2013-06-08','13:00:00',4.49),('12664','2013-06-08','13:05:00',4.47),('12664','2013-06-08','13:10:00',4.46),('12664','2013-06-08','13:15:00',4.53),('12664','2013-06-08','13:20:00',4.45),('12664','2013-06-08','13:25:00',4.5),('12664','2013-06-08','13:30:00',4.33),('12664','2013-06-08','13:35:00',4.5),('12664','2013-06-08','13:40:00',4.43),('12664','2013-06-08','13:45:00',4.5),('12664','2013-06-08','13:50:00',4.59),('12664','2013-06-08','13:55:00',4.48),('12664','2013-06-08','14:00:00',4.49),('12664','2013-06-08','14:05:00',4.46),('12664','2013-06-08','14:10:00',4.44),('12664','2013-06-08','14:15:00',4.42),('12664','2013-06-08','14:20:00',4.39),('12664','2013-06-08','14:25:00',4.38),('12664','2013-06-08','14:30:00',4.35),('12664','2013-06-08','14:35:00',4.32),('12664','2013-06-08','14:40:00',4.26),('12664','2013-06-08','14:45:00',4.27),('12664','2013-06-08','14:50:00',4.19),('12664','2013-06-08','14:55:00',4.19),('12664','2013-06-08','15:00:00',4.14),('12664','2013-06-08','15:05:00',3.92),('12664','2013-06-08','15:10:00',4.13),('12664','2013-06-08','15:15:00',4.09),('12664','2013-06-08','15:20:00',3.99),('12664','2013-06-08','15:25:00',4.04),('12664','2013-06-08','15:30:00',4.04),('12664','2013-06-08','15:35:00',4.03),('12664','2013-06-08','15:40:00',4.06),('12664','2013-06-08','15:45:00',3.96),('12664','2013-06-08','15:50:00',3.77),('12664','2013-06-08','15:55:00',3.74),('12664','2013-06-08','16:00:00',3.58),('12664','2013-06-08','16:05:00',3.52),('12664','2013-06-08','16:10:00',3.73),('12664','2013-06-08','16:15:00',3.62),('12664','2013-06-08','16:20:00',3.44),('12664','2013-06-08','16:25:00',3.31),('12664','2013-06-08','16:30:00',3.2),('12664','2013-06-08','16:35:00',3.12),('12664','2013-06-08','16:40:00',3.07),('12664','2013-06-08','16:45:00',2.57),('12664','2013-06-08','16:50:00',2.65),('12664','2013-06-08','16:55:00',2.48),('12664','2013-06-08','17:00:00',1.75),('12664','2013-06-08','17:05:00',2.99),('12664','2013-06-08','17:10:00',2.96),('12664','2013-06-08','17:15:00',2.76),('12664','2013-06-08','17:20:00',2.34),('12664','2013-06-08','17:35:00',2.02),('12664','2013-06-08','17:40:00',2.09),('12664','2013-06-08','17:45:00',2.01),('12664','2013-06-08','17:50:00',2.08),('12664','2013-06-08','17:55:00',1.35),('12664','2013-06-08','18:00:00',1.4),('12664','2013-06-08','18:05:00',1.21),('12664','2013-06-08','18:10:00',1.09),('12664','2013-06-08','18:15:00',1.18),('12664','2013-06-07','07:30:00',1.02),('12664','2013-06-07','07:35:00',1.11),('12664','2013-06-07','07:40:00',1.21),('12664','2013-06-07','07:45:00',1.31),('12664','2013-06-07','07:50:00',1.41),('12664','2013-06-07','07:55:00',1.51),('12664','2013-06-07','08:00:00',1.61),('12664','2013-06-07','08:05:00',1.71),('12664','2013-06-07','08:10:00',1.8),('12664','2013-06-07','08:15:00',1.9),('12664','2013-06-07','08:20:00',1.99),('12664','2013-06-07','08:25:00',2.08),('12664','2013-06-07','08:30:00',2.18),('12664','2013-06-07','08:35:00',2.26),('12664','2013-06-07','08:40:00',2.35),('12664','2013-06-07','08:45:00',2.44),('12664','2013-06-07','08:50:00',2.53),('12664','2013-06-07','08:55:00',2.61),('12664','2013-06-07','09:00:00',2.69),('12664','2013-06-07','09:05:00',2.77),('12664','2013-06-07','09:10:00',2.84),('12664','2013-06-07','09:15:00',2.92),('12664','2013-06-07','09:20:00',2.99),('12664','2013-06-07','09:25:00',3.06),('12664','2013-06-07','09:30:00',3.14),('12664','2013-06-07','09:35:00',3.2),('12664','2013-06-07','09:40:00',3.27),('12664','2013-06-07','09:45:00',3.32),('12664','2013-06-07','09:50:00',3.4),('12664','2013-06-07','09:55:00',3.45),('12664','2013-06-07','10:00:00',3.51),('12664','2013-06-07','10:05:00',3.58),('12664','2013-06-07','10:10:00',3.63),('12664','2013-06-07','10:15:00',3.68),('12664','2013-06-07','10:20:00',3.74),('12664','2013-06-07','10:25:00',3.8),('12664','2013-06-07','10:30:00',3.85),('12664','2013-06-07','10:35:00',3.88),('12664','2013-06-07','10:40:00',3.93),('12664','2013-06-07','10:45:00',3.98),('12664','2013-06-07','10:50:00',4.02),('12664','2013-06-07','10:55:00',4.04),('12664','2013-06-07','11:00:00',4.09),('12664','2013-06-07','11:05:00',4.11),('12664','2013-06-07','11:10:00',4.13),('12664','2013-06-07','11:15:00',4.16),('12664','2013-06-07','11:20:00',4.21),('12664','2013-06-07','11:25:00',4.23),('12664','2013-06-07','11:30:00',4.26),('12664','2013-06-07','11:35:00',4.29),('12664','2013-06-07','11:40:00',4.3),('12664','2013-06-07','11:45:00',4.33),('12664','2013-06-07','11:50:00',4.36),('12664','2013-06-07','11:55:00',4.39),('12664','2013-06-07','12:00:00',4.39),('12664','2013-06-07','12:05:00',4.38),('12664','2013-06-07','12:10:00',4.42),('12664','2013-06-07','12:15:00',4.41),('12664','2013-06-07','12:20:00',4.44),('12664','2013-06-07','12:25:00',4.44),('12664','2013-06-07','12:30:00',4.46),('12664','2013-06-07','12:35:00',4.48),('12664','2013-06-07','12:40:00',4.45),('12664','2013-06-07','12:45:00',4.48),('12664','2013-06-07','12:50:00',4.48),('12664','2013-06-07','12:55:00',4.49),('12664','2013-06-07','13:00:00',4.43),('12664','2013-06-07','13:05:00',4.4),('12664','2013-06-07','13:10:00',4.44),('12664','2013-06-07','13:15:00',4.46),('12664','2013-06-07','13:20:00',4.45),('12664','2013-06-07','13:25:00',4.42),('12664','2013-06-07','13:30:00',4.39),('12664','2013-06-07','13:35:00',4.38),('12664','2013-06-07','13:40:00',4.37),('12664','2013-06-07','13:45:00',4.38),('12664','2013-06-07','13:50:00',4.33),('12664','2013-06-07','13:55:00',4.31),('12664','2013-06-07','14:00:00',4.27),('12664','2013-06-07','14:05:00',4.26),('12664','2013-06-07','14:10:00',4.26),('12664','2013-06-07','14:15:00',4.3),('12664','2013-06-07','14:20:00',4.21),('12664','2013-06-07','14:25:00',4.16),('12664','2013-06-07','14:30:00',4.15),('12664','2013-06-07','14:35:00',4.14),('12664','2013-06-07','14:40:00',4.07),('12664','2013-06-07','14:45:00',4.09),('12664','2013-06-07','14:50:00',4.11),('12664','2013-06-07','14:55:00',4.1),('12664','2013-06-07','15:00:00',4.08),('12664','2013-06-07','15:05:00',4.03),('12664','2013-06-07','15:10:00',4.03),('12664','2013-06-07','15:15:00',4),('12664','2013-06-07','15:20:00',3.97),('12664','2013-06-07','15:25:00',3.94),('12664','2013-06-07','15:30:00',3.89),('12664','2013-06-07','15:35:00',3.85),('12664','2013-06-07','15:40:00',3.8),('12664','2013-06-07','15:45:00',3.76),('12664','2013-06-07','15:50:00',3.72),('12664','2013-06-07','15:55:00',3.66),('12664','2013-06-07','16:00:00',3.59),('12664','2013-06-07','16:05:00',3.54),('12664','2013-06-07','16:10:00',3.49),('12664','2013-06-07','16:15:00',3.41),('12664','2013-06-07','16:20:00',3.35),('12664','2013-06-07','16:25:00',3.29),('12664','2013-06-07','16:30:00',3.23),('12664','2013-06-07','16:35:00',3.15),('12664','2013-06-07','16:40:00',3.06),('12664','2013-06-07','16:45:00',2.98),('12664','2013-06-07','16:50:00',2.9),('12664','2013-06-07','16:55:00',2.81),('12664','2013-06-07','17:00:00',2.73),('12664','2013-06-07','17:05:00',2.67),('12664','2013-06-07','17:10:00',2.58),('12664','2013-06-07','17:15:00',2.5),('12664','2013-06-07','17:20:00',2.42),('12664','2013-06-07','17:25:00',2.34),('12664','2013-06-07','17:30:00',2.28),('12664','2013-06-07','17:35:00',2.21),('12664','2013-06-07','17:40:00',2.19),('12664','2013-06-07','17:45:00',2.16),('12664','2013-06-07','17:50:00',2.04),('12664','2013-06-07','17:55:00',1.85),('12664','2013-06-07','18:00:00',1.76),('12664','2013-06-07','18:05:00',1.67),('12664','2013-06-07','18:10:00',1.33),('12664','2013-06-07','18:15:00',1.32),('12664','2013-06-07','18:20:00',1.28),('12664','2013-06-07','18:25:00',1.18),('12664','2013-06-07','18:30:00',1.08),('12664','2013-06-06','07:45:00',1.32),('12664','2013-06-06','07:50:00',1.42),('12664','2013-06-06','07:55:00',1.16),('12664','2013-06-06','08:00:00',1.63),('12664','2013-06-06','08:05:00',1.33),('12664','2013-06-06','08:10:00',1.44),('12664','2013-06-06','08:15:00',1.8),('12664','2013-06-06','08:20:00',1.95),('12664','2013-06-06','08:25:00',2.02),('12664','2013-06-06','08:30:00',2.1),('12664','2013-06-06','08:35:00',2.22),('12664','2013-06-06','08:40:00',2.31),('12664','2013-06-06','08:45:00',2.4),('12664','2013-06-06','08:50:00',2.38),('12664','2013-06-06','08:55:00',2.39),('12664','2013-06-06','09:00:00',2.55),('12664','2013-06-06','09:05:00',2.63),('12664','2013-06-06','09:10:00',2.68),('12664','2013-06-06','09:15:00',2.81),('12664','2013-06-06','09:20:00',2.93),('12664','2013-06-06','09:25:00',3.03),('12664','2013-06-06','09:30:00',3.11),('12664','2013-06-06','09:35:00',3.09),('12664','2013-06-06','09:40:00',3.2),('12664','2013-06-06','09:45:00',3.25),('12664','2013-06-06','09:50:00',3.34),('12664','2013-06-06','09:55:00',3.38),('12664','2013-06-06','10:00:00',3.45),('12664','2013-06-06','10:05:00',3.5),('12664','2013-06-06','10:10:00',3.48),('12664','2013-06-06','10:15:00',3.48),('12664','2013-06-06','10:20:00',3.63),('12664','2013-06-06','10:25:00',3.73),('12664','2013-06-06','10:30:00',3.8),('12664','2013-06-06','10:35:00',3.77),('12664','2013-06-06','10:40:00',3.88),('12664','2013-06-06','10:45:00',3.89),('12664','2013-06-06','10:50:00',3.91),('12664','2013-06-06','10:55:00',3.93),('12664','2013-06-06','11:00:00',4.08),('12664','2013-06-06','11:05:00',4.07),('12664','2013-06-06','11:10:00',4.1),('12664','2013-06-06','11:15:00',4.12),('12664','2013-06-06','11:20:00',4),('12664','2013-06-06','11:25:00',2.06),('12664','2013-06-06','11:30:00',3.42),('12664','2013-06-06','11:35:00',4.4),('12664','2013-06-06','11:40:00',4.31),('12664','2013-06-06','11:45:00',4.39),('12664','2013-06-06','11:50:00',4.39),('12664','2013-06-06','11:55:00',4.25),('12664','2013-06-06','12:00:00',4.35),('12664','2013-06-06','12:05:00',4.3),('12664','2013-06-06','12:10:00',4.37),('12664','2013-06-06','12:15:00',4.33),('12664','2013-06-06','12:20:00',4.4),('12664','2013-06-06','12:25:00',4.39),('12664','2013-06-06','12:30:00',4.41),('12664','2013-06-06','12:35:00',4.44),('12664','2013-06-06','12:40:00',4.45),('12664','2013-06-06','12:45:00',4.43),('12664','2013-06-06','12:50:00',4.55),('12664','2013-06-06','12:55:00',4.6),('12664','2013-06-06','13:00:00',4.63),('12664','2013-06-06','13:05:00',4.71),('12664','2013-06-06','13:10:00',4.59),('12664','2013-06-06','13:15:00',4),('12664','2013-06-06','13:20:00',1.38),('12664','2013-06-06','13:25:00',1.36),('12664','2013-06-06','13:30:00',4.59),('12664','2013-06-06','13:35:00',4.73),('12664','2013-06-06','13:40:00',4.55),('12664','2013-06-06','13:45:00',4.45),('12664','2013-06-06','13:50:00',4.4),('12664','2013-06-06','13:55:00',4.42),('12664','2013-06-06','14:00:00',4.35),('12664','2013-06-06','14:05:00',4.39),('12664','2013-06-06','14:10:00',4.37),('12664','2013-06-06','14:15:00',4.32),('12664','2013-06-06','14:20:00',4.29),('12664','2013-06-06','14:25:00',4.28),('12664','2013-06-06','14:30:00',4.28),('12664','2013-06-06','14:35:00',4.23),('12664','2013-06-06','14:40:00',4.17),('12664','2013-06-06','14:45:00',4.19),('12664','2013-06-06','14:50:00',4.15),('12664','2013-06-06','14:55:00',4.1),('12664','2013-06-06','15:00:00',4.08),('12664','2013-06-06','15:05:00',4),('12664','2013-06-06','15:10:00',3.96),('12664','2013-06-06','15:15:00',3.98),('12664','2013-06-06','15:20:00',3.88),('12664','2013-06-06','15:25:00',3.84),('12664','2013-06-06','15:30:00',3.8),('12664','2013-06-06','15:35:00',3.78),('12664','2013-06-06','15:40:00',3.7),('12664','2013-06-06','15:45:00',3.6),('12664','2013-06-06','15:50:00',3.56),('12664','2013-06-06','15:55:00',3.52),('12664','2013-06-06','16:00:00',3.44),('12664','2013-06-06','16:05:00',3.38),('12664','2013-06-06','16:10:00',3.34),('12664','2013-06-06','16:15:00',3.28),('12664','2013-06-06','16:20:00',3.26),('12664','2013-06-06','16:25:00',3.17),('12664','2013-06-06','16:30:00',3.13),('12664','2013-06-06','16:35:00',3.04),('12664','2013-06-06','16:40:00',2.96),('12664','2013-06-06','16:45:00',2.88),('12664','2013-06-06','16:50:00',2.8),('12664','2013-06-06','16:55:00',2.73),('12664','2013-06-06','17:00:00',2.64),('12664','2013-06-06','17:05:00',2.56),('12664','2013-06-06','17:10:00',2.48),('12664','2013-06-06','17:15:00',2.37),('12664','2013-06-06','17:20:00',2.34),('12664','2013-06-06','17:25:00',2.27),('12664','2013-06-06','17:30:00',2.17),('12664','2013-06-06','17:35:00',2.09),('12664','2013-06-06','17:40:00',2),('12664','2013-06-06','17:45:00',1.91),('12664','2013-06-06','17:50:00',1.83),('12664','2013-06-06','17:55:00',1.72),('12664','2013-06-06','18:00:00',1.63),('12664','2013-06-06','18:05:00',1.56),('12664','2013-06-06','18:10:00',1.46),('12664','2013-06-06','18:15:00',1.35),('12664','2013-06-06','18:20:00',1.25),('12664','2013-06-06','18:25:00',1.16),('12664','2013-06-06','18:30:00',1.06),('12664','2013-06-05','07:30:00',1.05),('12664','2013-06-05','07:35:00',1.14),('12664','2013-06-05','07:40:00',1.16),('12664','2013-06-05','07:45:00',1.27),('12664','2013-06-05','07:50:00',1.4),('12664','2013-06-05','07:55:00',1.46),('12664','2013-06-05','08:00:00',1.57),('12664','2013-06-05','08:05:00',1.66),('12664','2013-06-05','08:10:00',1.77),('12664','2013-06-05','08:15:00',1.84),('12664','2013-06-05','08:20:00',1.94),('12664','2013-06-05','08:25:00',2.02),('12664','2013-06-05','08:30:00',2.09),('12664','2013-06-05','08:35:00',2.22),('12664','2013-06-05','08:40:00',2.27),('12664','2013-06-05','08:45:00',2.38),('12664','2013-06-05','08:50:00',2.45),('12664','2013-06-05','08:55:00',2.54),('12664','2013-06-05','09:00:00',2.75),('12664','2013-06-05','09:05:00',3.05),('12664','2013-06-05','09:10:00',2.52),('12664','2013-06-05','09:15:00',1.4),('12664','2013-06-05','09:20:00',1.49),('12664','2013-06-05','09:25:00',1.56),('12664','2013-06-05','09:30:00',1.64),('12664','2013-06-05','09:35:00',1.26),('12664','2013-06-05','09:40:00',1.44),('12664','2013-06-05','09:45:00',3.6),('12664','2013-06-05','09:50:00',3.32),('12664','2013-06-05','09:55:00',1.59),('12664','2013-06-05','10:00:00',1.78),('12664','2013-06-05','10:05:00',2.89),('12664','2013-06-05','10:10:00',2.46),('12664','2013-06-05','10:15:00',2.62),('12664','2013-06-05','10:20:00',3.99),('12664','2013-06-05','10:25:00',3.89),('12664','2013-06-05','10:30:00',3.19),('12664','2013-06-05','10:35:00',3.85),('12664','2013-06-05','10:40:00',4.36),('12664','2013-06-05','10:45:00',4.59),('12664','2013-06-05','10:50:00',3.58),('12664','2013-06-05','10:55:00',2.69),('12664','2013-06-05','11:00:00',2.97),('12664','2013-06-05','11:05:00',2.29),('12664','2013-06-05','11:10:00',1.61),('12664','2013-06-05','11:15:00',1.72),('12664','2013-06-05','11:20:00',1.67),('12664','2013-06-05','11:25:00',2),('12664','2013-06-05','11:30:00',4.4),('12664','2013-06-05','11:35:00',2.75),('12664','2013-06-05','11:40:00',2.73),('12664','2013-06-05','11:45:00',1.35),('12664','2013-06-05','11:50:00',3.42),('12664','2013-06-05','11:55:00',3.79),('12664','2013-06-05','12:00:00',1.7),('12664','2013-06-05','12:05:00',3.04),('12664','2013-06-05','12:10:00',3.63),('12664','2013-06-05','12:15:00',4.47),('12664','2013-06-05','12:20:00',4.47),('12664','2013-06-05','12:25:00',3.82),('12664','2013-06-05','12:30:00',5.02),('12664','2013-06-05','12:35:00',5),('12664','2013-06-05','12:40:00',3.71),('12664','2013-06-05','12:45:00',4.54),('12664','2013-06-05','12:50:00',3.14),('12664','2013-06-05','12:55:00',4.79),('12664','2013-06-05','13:00:00',4.71),('12664','2013-06-05','13:05:00',4.87),('12664','2013-06-05','13:10:00',5.02),('12664','2013-06-05','13:15:00',3.79),('12664','2013-06-05','13:20:00',4.55),('12664','2013-06-05','13:25:00',4.5),('12664','2013-06-05','13:30:00',4.83),('12664','2013-06-05','13:35:00',4.99),('12664','2013-06-05','13:40:00',3.69),('12664','2013-06-05','13:45:00',4.76),('12664','2013-06-05','13:50:00',4.68),('12664','2013-06-05','13:55:00',4.65),('12664','2013-06-05','14:00:00',4.63),('12664','2013-06-05','14:05:00',4.62),('12664','2013-06-05','14:10:00',4.25),('12664','2013-06-05','14:15:00',3.89),('12664','2013-06-05','14:20:00',3.86),('12664','2013-06-05','14:25:00',4.59),('12664','2013-06-05','14:30:00',4.58),('12664','2013-06-05','14:35:00',4.62),('12664','2013-06-05','14:40:00',4.5),('12664','2013-06-05','14:45:00',4.4),('12664','2013-06-05','14:50:00',4.37),('12664','2013-06-05','14:55:00',4.42),('12664','2013-06-05','15:00:00',4.19),('12664','2013-06-05','15:05:00',3.86),('12664','2013-06-05','15:10:00',4.1),('12664','2013-06-05','15:15:00',3.04),('12664','2013-06-05','15:20:00',4.23),('12664','2013-06-05','15:25:00',3.93),('12664','2013-06-05','15:30:00',3.95),('12664','2013-06-05','15:35:00',4.07),('12664','2013-06-05','15:40:00',3.22),('12664','2013-06-05','15:45:00',3.92),('12664','2013-06-05','15:50:00',3.24),('12664','2013-06-05','15:55:00',3.94),('12664','2013-06-05','16:00:00',3.2),('12664','2013-06-05','16:05:00',3.16),('12664','2013-06-05','16:10:00',2.25),('12664','2013-06-05','16:15:00',2.99),('12664','2013-06-05','16:20:00',3.48),('12664','2013-06-05','16:25:00',1.57),('12664','2013-06-05','16:30:00',3.04),('12664','2013-06-05','16:35:00',3.59),('12664','2013-06-05','16:40:00',2.99),('12664','2013-06-05','16:45:00',2.68),('12664','2013-06-05','16:50:00',1.99),('12664','2013-06-05','16:55:00',1.61),('12664','2013-06-05','17:00:00',2.09),('12664','2013-06-05','17:05:00',1.7),('12664','2013-06-05','17:10:00',1.64),('12664','2013-06-05','17:15:00',1.22),('12664','2013-06-05','17:25:00',1.91),('12664','2013-06-05','17:30:00',1.47),('12664','2013-06-05','17:35:00',2.26),('12664','2013-06-05','17:40:00',2.09),('12664','2013-06-05','17:45:00',1.98),('12664','2013-06-05','17:50:00',1.27),('12664','2013-06-05','17:55:00',1.16),('12664','2013-06-05','18:00:00',1.76),('12664','2013-06-05','18:15:00',1.32),('12664','2013-06-05','18:30:00',1.23),('12664','2013-06-04','07:30:00',1.21),('12664','2013-06-04','07:35:00',1.42),('12664','2013-06-04','07:40:00',1.6),('12664','2013-06-04','07:45:00',1.87),('12664','2013-06-04','07:50:00',2.06),('12664','2013-06-04','07:55:00',2.14),('12664','2013-06-04','08:00:00',2.26),('12664','2013-06-04','08:05:00',2.31),('12664','2013-06-04','08:10:00',2.43),('12664','2013-06-04','08:15:00',2.47),('12664','2013-06-04','08:20:00',2.37),('12664','2013-06-04','08:25:00',2.75),('12664','2013-06-04','08:30:00',2.2),('12664','2013-06-04','08:35:00',1.9),('12664','2013-06-04','08:40:00',1.38),('12664','2013-06-04','08:45:00',1.29),('12664','2013-06-04','08:50:00',1.64),('12664','2013-06-04','08:55:00',1.62),('12664','2013-06-04','09:00:00',1.75),('12664','2013-06-04','09:05:00',1.96),('12664','2013-06-04','09:10:00',2.9),('12664','2013-06-04','09:15:00',2.12),('12664','2013-06-04','09:20:00',1.69),('12664','2013-06-04','09:25:00',1.6),('12664','2013-06-04','09:30:00',1.59),('12664','2013-06-04','09:35:00',1.71),('12664','2013-06-04','09:40:00',1.68),('12664','2013-06-04','09:45:00',1.74),('12664','2013-06-04','09:50:00',1.51),('12664','2013-06-04','09:55:00',1.31),('12664','2013-06-04','10:00:00',1.42),('12664','2013-06-04','10:05:00',1.78),('12664','2013-06-04','10:10:00',2.55),('12664','2013-06-04','10:15:00',2),('12664','2013-06-04','10:20:00',1.65),('12664','2013-06-04','10:25:00',1.63),('12664','2013-06-04','10:30:00',1.74),('12664','2013-06-04','10:35:00',2.14),('12664','2013-06-04','10:40:00',2.39),('12664','2013-06-04','10:45:00',2.65),('12664','2013-06-04','10:50:00',2.36),('12664','2013-06-04','10:55:00',2.39),('12664','2013-06-04','11:00:00',3.1),('12664','2013-06-04','11:05:00',2.99),('12664','2013-06-04','11:10:00',2.31),('12664','2013-06-04','11:15:00',2.69),('12664','2013-06-04','11:20:00',3.15),('12664','2013-06-04','11:25:00',3.1),('12664','2013-06-04','11:30:00',3.06),('12664','2013-06-04','11:35:00',3.49),('12664','2013-06-04','11:40:00',4.23),('12664','2013-06-04','11:45:00',4.52),('12664','2013-06-04','11:50:00',3.58),('12664','2013-06-04','11:55:00',4.1),('12664','2013-06-04','12:00:00',3.21),('12664','2013-06-04','12:05:00',2.49),('12664','2013-06-04','12:10:00',2.19),('12664','2013-06-04','12:15:00',3.11),('12664','2013-06-04','12:20:00',2.62),('12664','2013-06-04','12:25:00',2.8),('12664','2013-06-04','12:30:00',1.7),('12664','2013-06-04','12:35:00',1.2),('12664','2013-06-04','12:40:00',1.22),('12664','2013-06-04','12:45:00',1.3),('12664','2013-06-04','12:50:00',1.55),('12664','2013-06-04','12:55:00',1.32),('12664','2013-06-04','13:00:00',1.2),('12664','2013-06-04','13:05:00',1.35),('12664','2013-06-04','13:10:00',1.66),('12664','2013-06-04','13:15:00',1.9),('12664','2013-06-04','13:20:00',3.13),('12664','2013-06-04','13:25:00',2.65),('12664','2013-06-04','13:30:00',2.6),('12664','2013-06-04','13:35:00',2.68),('12664','2013-06-04','13:40:00',2.99),('12664','2013-06-04','13:45:00',3.68),('12664','2013-06-04','13:50:00',2.9),('12664','2013-06-04','13:55:00',2.57),('12664','2013-06-04','14:00:00',4.35),('12664','2013-06-04','14:05:00',4.31),('12664','2013-06-04','14:10:00',2.99),('12664','2013-06-04','14:15:00',1.04),('12664','2013-06-04','14:25:00',1.15),('12664','2013-06-04','14:30:00',1.81),('12664','2013-06-04','14:35:00',3.48),('12664','2013-06-04','14:40:00',4.75),('12664','2013-06-04','14:45:00',5.03),('12664','2013-06-04','14:50:00',2.73),('12664','2013-06-04','14:55:00',3.67),('12664','2013-06-04','15:00:00',2.4),('12664','2013-06-04','15:05:00',2.3),('12664','2013-06-04','15:10:00',4.74),('12664','2013-06-04','15:15:00',3.49),('12664','2013-06-04','15:20:00',2.08),('12664','2013-06-04','15:25:00',1.8),('12664','2013-06-04','15:30:00',1.39),('12664','2013-06-04','15:50:00',1.02),('12664','2013-06-04','16:10:00',1.2),('12664','2013-06-04','16:15:00',1),('12664','2013-06-04','16:40:00',1.22),('12664','2013-06-04','18:40:00',1.11),('12664','2013-06-04','18:45:00',1.01),('12664','2013-06-03','07:20:00',1.03),('12664','2013-06-03','07:25:00',1.27),('12664','2013-06-03','07:30:00',1.42),('12664','2013-06-03','07:35:00',1.46),('12664','2013-06-03','07:40:00',1.39),('12664','2013-06-03','07:45:00',1.27),('12664','2013-06-03','07:50:00',1.23),('12664','2013-06-03','07:55:00',1.47),('12664','2013-06-03','08:00:00',1.59),('12664','2013-06-03','08:05:00',1.67),('12664','2013-06-03','08:10:00',1.76),('12664','2013-06-03','08:15:00',1.87),('12664','2013-06-03','08:20:00',1.97),('12664','2013-06-03','08:25:00',2.05),('12664','2013-06-03','08:30:00',1.89),('12664','2013-06-03','08:35:00',1.9),('12664','2013-06-03','08:40:00',2.04),('12664','2013-06-03','08:45:00',1.62),('12664','2013-06-03','08:50:00',2.13),('12664','2013-06-03','08:55:00',2.54),('12664','2013-06-03','09:05:00',1.04),('12664','2013-06-03','09:10:00',2.37),('12664','2013-06-03','09:15:00',2.36),('12664','2013-06-03','09:20:00',1.74),('12664','2013-06-03','09:25:00',1.85),('12664','2013-06-03','09:30:00',2.47),('12664','2013-06-03','09:35:00',2.07),('12664','2013-06-03','09:40:00',1.47),('12664','2013-06-03','09:45:00',1.28),('12664','2013-06-03','09:50:00',1.5),('12664','2013-06-03','09:55:00',1.45),('12664','2013-06-03','10:00:00',1.05),('12664','2013-06-03','10:25:00',1.27),('12664','2013-06-03','10:30:00',1.49),('12664','2013-06-03','10:35:00',1.86),('12664','2013-06-03','10:40:00',2.98),('12664','2013-06-03','10:45:00',4.48),('12664','2013-06-03','10:50:00',2.62),('12664','2013-06-03','10:55:00',1.85),('12664','2013-06-03','11:00:00',2.98),('12664','2013-06-03','11:05:00',2.62),('12664','2013-06-03','11:10:00',4.72),('12664','2013-06-03','11:15:00',3.46),('12664','2013-06-03','11:20:00',2.35),('12664','2013-06-03','11:25:00',2.53),('12664','2013-06-03','11:30:00',3.12),('12664','2013-06-03','11:35:00',3.09),('12664','2013-06-03','11:40:00',3.28),('12664','2013-06-03','11:45:00',4.9),('12664','2013-06-03','11:50:00',4.28),('12664','2013-06-03','11:55:00',2.37),('12664','2013-06-03','12:00:00',2.09),('12664','2013-06-03','12:05:00',4.95),('12664','2013-06-03','12:10:00',2.89),('12664','2013-06-03','12:15:00',2.78),('12664','2013-06-03','12:20:00',2.12),('12664','2013-06-03','12:25:00',2.03),('12664','2013-06-03','12:30:00',1.71),('12664','2013-06-03','12:35:00',1.29),('12664','2013-06-03','12:40:00',1.14),('12664','2013-06-03','12:45:00',1.21),('12664','2013-06-03','12:50:00',1.29),('12664','2013-06-03','12:55:00',1.22),('12664','2013-06-03','13:00:00',1.32),('12664','2013-06-03','13:05:00',1.2),('12664','2013-06-03','13:10:00',1.45),('12664','2013-06-03','13:15:00',2.44),('12664','2013-06-03','13:20:00',4.8),('12664','2013-06-03','13:25:00',4.24),('12664','2013-06-03','13:30:00',1.81),('12664','2013-06-03','13:35:00',2.05),('12664','2013-06-03','13:40:00',1.8),('12664','2013-06-03','13:45:00',3.53),('12664','2013-06-03','13:50:00',2.57),('12664','2013-06-03','13:55:00',1.82),('12664','2013-06-03','14:00:00',1.09),('12664','2013-06-03','14:10:00',1.85),('12664','2013-06-03','14:15:00',3.76),('12664','2013-06-03','14:20:00',4.41),('12664','2013-06-03','14:25:00',5.01),('12664','2013-06-03','14:30:00',4.75),('12664','2013-06-03','14:35:00',4.56),('12664','2013-06-03','14:40:00',4.58),('12664','2013-06-03','14:45:00',4.5),('12664','2013-06-03','14:50:00',4.33),('12664','2013-06-03','14:55:00',4.35),('12664','2013-06-03','15:00:00',4.11),('12664','2013-06-03','15:05:00',4.05),('12664','2013-06-03','15:10:00',4.41),('12664','2013-06-03','15:15:00',4.38),('12664','2013-06-03','15:20:00',3.88),('12664','2013-06-03','15:25:00',4.31),('12664','2013-06-03','15:30:00',4.12),('12664','2013-06-03','15:35:00',2.64),('12664','2013-06-03','15:40:00',2.48),('12664','2013-06-03','15:45:00',3.95),('12664','2013-06-03','15:50:00',3.87),('12664','2013-06-03','15:55:00',3.87),('12664','2013-06-03','16:00:00',3.74),('12664','2013-06-03','16:05:00',3.65),('12664','2013-06-03','16:10:00',3.58),('12664','2013-06-03','16:15:00',3.29),('12664','2013-06-03','16:20:00',3.39),('12664','2013-06-03','16:25:00',3.26),('12664','2013-06-03','16:30:00',2.59),('12664','2013-06-03','16:35:00',2.59),('12664','2013-06-03','16:40:00',2.41),('12664','2013-06-03','16:45:00',2.21),('12664','2013-06-03','16:50:00',3.27),('12664','2013-06-03','16:55:00',3.12),('12664','2013-06-03','17:00:00',3.09),('12664','2013-06-03','17:05:00',2.49),('12664','2013-06-03','17:10:00',2.15),('12664','2013-06-03','17:15:00',1.92),('12664','2013-06-03','17:20:00',2.02),('12664','2013-06-03','17:25:00',1.55),('12664','2013-06-03','17:30:00',1.56),('12664','2013-06-03','17:45:00',1.01),('12664','2013-06-03','17:50:00',1.05),('12664','2013-06-02','08:40:00',2.28),('12664','2013-06-02','08:45:00',1.05),('12664','2013-06-02','08:50:00',1),('12664','2013-06-02','09:10:00',1.34),('12664','2013-06-02','09:15:00',1.47),('12664','2013-06-02','09:20:00',3.28),('12664','2013-06-02','09:25:00',3.27),('12664','2013-06-02','09:30:00',3.3),('12664','2013-06-02','09:35:00',3.37),('12664','2013-06-02','09:40:00',3.4),('12664','2013-06-02','09:45:00',3.44),('12664','2013-06-02','09:50:00',3.5),('12664','2013-06-02','09:55:00',3.55),('12664','2013-06-02','10:00:00',3.61),('12664','2013-06-02','10:05:00',3.64),('12664','2013-06-02','10:10:00',3.72),('12664','2013-06-02','10:15:00',3.77),('12664','2013-06-02','10:20:00',3.85),('12664','2013-06-02','10:25:00',3.84),('12664','2013-06-02','10:30:00',3.98),('12664','2013-06-02','10:35:00',3.97),('12664','2013-06-02','10:40:00',4.3),('12664','2013-06-02','10:45:00',4.05),('12664','2013-06-02','10:50:00',4.33),('12664','2013-06-02','10:55:00',3.71),('12664','2013-06-02','11:00:00',2.59),('12664','2013-06-02','11:05:00',2.39),('12664','2013-06-02','11:10:00',3.12),('12664','2013-06-02','11:15:00',4.08),('12664','2013-06-02','11:20:00',3.6),('12664','2013-06-02','11:25:00',4.52),('12664','2013-06-02','11:30:00',3.73),('12664','2013-06-02','11:35:00',5.01),('12664','2013-06-02','11:40:00',4.12),('12664','2013-06-02','11:45:00',3.85),('12664','2013-06-02','11:50:00',5.01),('12664','2013-06-02','11:55:00',3.94),('12664','2013-06-02','12:00:00',2.16),('12664','2013-06-02','12:05:00',5.03),('12664','2013-06-02','12:10:00',4.74),('12664','2013-06-02','12:15:00',4.57),('12664','2013-06-02','12:20:00',4.89),('12664','2013-06-02','12:25:00',4.78),('12664','2013-06-02','12:30:00',4.45),('12664','2013-06-02','12:35:00',4.73),('12664','2013-06-02','12:40:00',4.72),('12664','2013-06-02','12:45:00',4.73),('12664','2013-06-02','12:50:00',3.76),('12664','2013-06-02','12:55:00',4.78),('12664','2013-06-02','13:00:00',4.18),('12664','2013-06-02','13:05:00',4.86),('12664','2013-06-02','13:10:00',4.81),('12664','2013-06-02','13:15:00',4.72),('12664','2013-06-02','13:20:00',4.71),('12664','2013-06-02','13:25:00',4.48),('12664','2013-06-02','13:30:00',4.7),('12664','2013-06-02','13:35:00',4.65),('12664','2013-06-02','13:40:00',4.67),('12664','2013-06-02','13:45:00',4.66),('12664','2013-06-02','13:50:00',4.4),('12664','2013-06-02','13:55:00',4.67),('12664','2013-06-02','14:00:00',4.68),('12664','2013-06-02','14:05:00',4.66),('12664','2013-06-02','14:10:00',4.73),('12664','2013-06-02','14:15:00',4.73),('12664','2013-06-02','14:20:00',4.5),('12664','2013-06-02','14:25:00',4.67),('12664','2013-06-02','14:30:00',4.48),('12664','2013-06-02','14:35:00',4.34),('12664','2013-06-02','14:40:00',4.45),('12664','2013-06-02','14:45:00',4.41),('12664','2013-06-02','14:50:00',4.41),('12664','2013-06-02','14:55:00',4.33),('12664','2013-06-02','15:00:00',4.33),('12664','2013-06-02','15:05:00',4.16),('12664','2013-06-02','15:10:00',3.41),('12664','2013-06-02','15:15:00',4.39),('12664','2013-06-02','15:20:00',4),('12664','2013-06-02','15:25:00',2.68),('12664','2013-06-02','15:30:00',2.9),('12664','2013-06-02','15:35:00',4.39),('12664','2013-06-02','15:40:00',2.91),('12664','2013-06-02','15:45:00',4.46),('12664','2013-06-02','15:50:00',2.5),('12664','2013-06-02','15:55:00',2.92),('12664','2013-06-02','16:00:00',2.86),('12664','2013-06-02','16:05:00',4.23),('12664','2013-06-02','16:10:00',3.2),('12664','2013-06-02','16:15:00',2.96),('12664','2013-06-02','16:20:00',3.59),('12664','2013-06-02','16:25:00',3.6),('12664','2013-06-02','16:30:00',3.43),('12664','2013-06-02','16:35:00',3.17),('12664','2013-06-02','16:40:00',3.13),('12664','2013-06-02','16:45:00',1.79),('12664','2013-06-02','16:50:00',2.39),('12664','2013-06-02','16:55:00',2.97),('12664','2013-06-02','17:00:00',2.52),('12664','2013-06-02','17:05:00',2.76),('12664','2013-06-02','17:10:00',2.7),('12664','2013-06-02','17:15:00',2.58),('12664','2013-06-02','17:20:00',1.84),('12664','2013-06-02','17:25:00',1.99),('12664','2013-06-02','17:30:00',1.69),('12664','2013-06-02','17:35:00',2.04),('12664','2013-06-02','17:40:00',1.41),('12664','2013-06-02','17:45:00',1.19),('12664','2013-06-02','17:50:00',1.7),('12664','2013-06-02','17:55:00',1.95),('12664','2013-06-02','18:00:00',1.06),('12664','2013-06-02','18:35:00',1.16),('12664','2013-06-01','07:30:00',1.06),('12664','2013-06-01','07:35:00',1.19),('12664','2013-06-01','07:40:00',1.37),('12664','2013-06-01','07:45:00',1.77),('12664','2013-06-01','07:50:00',1.41),('12664','2013-06-01','08:10:00',2.14),('12664','2013-06-01','08:15:00',1.02),('12664','2013-06-01','08:25:00',1.57),('12664','2013-06-01','08:40:00',1.14),('12664','2013-06-01','08:45:00',1.59),('12664','2013-06-01','10:40:00',1.13),('12664','2013-06-01','10:45:00',1.54),('12664','2013-06-01','10:50:00',2.78),('12664','2013-06-01','10:55:00',2.66),('12664','2013-06-01','11:00:00',1.84),('12664','2013-06-01','11:05:00',1.81),('12664','2013-06-01','11:10:00',1.44),('12664','2013-06-01','11:15:00',1.54),('12664','2013-06-01','11:20:00',1.86),('12664','2013-06-01','11:25:00',1.91),('12664','2013-06-01','11:30:00',2.15),('12664','2013-06-01','11:35:00',3.81),('12664','2013-06-01','11:40:00',3.83),('12664','2013-06-01','11:45:00',3.43),('12664','2013-06-01','11:50:00',1.86),('12664','2013-06-01','11:55:00',1.06),('12664','2013-06-01','12:00:00',1.31),('12664','2013-06-01','12:05:00',1.41),('12664','2013-06-01','12:10:00',1.89),('12664','2013-06-01','12:15:00',1.58),('12664','2013-06-01','12:20:00',3.91),('12664','2013-06-01','12:25:00',3.2),('12664','2013-06-01','12:30:00',2.94),('12664','2013-06-01','12:35:00',2.37),('12664','2013-06-01','12:40:00',2.32),('12664','2013-06-01','12:45:00',2.19),('12664','2013-06-01','12:50:00',2.32),('12664','2013-06-01','12:55:00',2.39),('12664','2013-06-01','13:00:00',2.44),('12664','2013-06-01','13:05:00',2.46),('12664','2013-06-01','13:10:00',2.69),('12664','2013-06-01','13:15:00',2.76),('12664','2013-06-01','13:20:00',2.5),('12664','2013-06-01','13:25:00',2.37),('12664','2013-06-01','13:30:00',2.04),('12664','2013-06-01','13:35:00',2.07),('12664','2013-06-01','13:40:00',2.38),('12664','2013-06-01','13:45:00',1.88),('12664','2013-06-01','13:50:00',1.99),('12664','2013-06-01','13:55:00',2.18),('12664','2013-06-01','14:00:00',2.74),('12664','2013-06-01','14:05:00',2.7),('12664','2013-06-01','14:10:00',2.23),('12664','2013-06-01','14:15:00',2.72),('12664','2013-06-01','14:20:00',2.61),('12664','2013-06-01','14:25:00',1.78),('12664','2013-06-01','14:30:00',1.74),('12664','2013-06-01','14:35:00',1.72),('12664','2013-06-01','14:40:00',1.54),('12664','2013-06-01','14:45:00',1.44),('12664','2013-06-01','14:50:00',1.5),('12664','2013-06-01','14:55:00',1.01),('12664','2013-06-01','15:40:00',1.12),('12664','2013-06-01','15:45:00',1.56),('12664','2013-06-01','15:50:00',1.89),('12664','2013-06-01','15:55:00',1.63),('12664','2013-06-01','16:00:00',1.22),('12664','2013-06-01','16:15:00',1.29),('12664','2013-06-01','16:20:00',1.3),('12664','2013-06-01','16:25:00',1.24),('12664','2013-06-01','16:30:00',1.01),('12664','2013-06-01','16:35:00',1.08),('12664','2013-06-01','16:40:00',1.06),('12664','2013-06-01','18:20:00',1.34),('12664','2013-06-01','18:25:00',1.09),('12664','2013-06-01','18:30:00',1.19),('12664','2013-06-01','18:35:00',1.37),('12664','2013-06-01','18:40:00',1.31),('12664','2013-06-01','18:45:00',1.19),('12664','2013-06-01','18:50:00',1.33),('12664','2013-05-31','07:30:00',1.05),('12664','2013-05-31','07:35:00',1.16),('12664','2013-05-31','07:40:00',1.28),('12664','2013-05-31','07:45:00',1.36),('12664','2013-05-31','07:50:00',1.51),('12664','2013-05-31','07:55:00',1.68),('12664','2013-05-31','08:00:00',1.1),('12664','2013-05-31','08:10:00',1.7),('12664','2013-05-31','08:15:00',1.94),('12664','2013-05-31','08:20:00',2.05),('12664','2013-05-31','08:25:00',2.08),('12664','2013-05-31','08:30:00',2.25),('12664','2013-05-31','08:35:00',2.35),('12664','2013-05-31','08:40:00',2.7),('12664','2013-05-31','08:45:00',1.4),('12664','2013-05-31','08:50:00',1.29),('12664','2013-05-31','08:55:00',1.82),('12664','2013-05-31','09:00:00',1.85),('12664','2013-05-31','09:05:00',1.87),('12664','2013-05-31','09:10:00',1.43),('12664','2013-05-31','09:20:00',2.58),('12664','2013-05-31','09:25:00',3.47),('12664','2013-05-31','09:30:00',2.96),('12664','2013-05-31','09:35:00',2.68),('12664','2013-05-31','09:40:00',3.46),('12664','2013-05-31','09:45:00',3.37),('12664','2013-05-31','09:50:00',3.72),('12664','2013-05-31','09:55:00',4.09),('12664','2013-05-31','10:00:00',4.23),('12664','2013-05-31','10:05:00',4.06),('12664','2013-05-31','10:10:00',2.66),('12664','2013-05-31','10:15:00',1.38),('12664','2013-05-31','10:20:00',2.53),('12664','2013-05-31','10:25:00',3.46),('12664','2013-05-31','10:30:00',4.39),('12664','2013-05-31','10:35:00',4.31),('12664','2013-05-31','10:40:00',4.57),('12664','2013-05-31','10:45:00',4.81),('12664','2013-05-31','10:50:00',3.3),('12664','2013-05-31','10:55:00',3.04),('12664','2013-05-31','11:00:00',2.18),('12664','2013-05-31','11:05:00',1.94),('12664','2013-05-31','11:10:00',2.69),('12664','2013-05-31','11:15:00',2.2),('12664','2013-05-31','11:20:00',3.32),('12664','2013-05-31','11:25:00',3.57),('12664','2013-05-31','11:30:00',1.27),('12664','2013-05-31','11:35:00',2.9),('12664','2013-05-31','11:40:00',2.65),('12664','2013-05-31','11:45:00',2.05),('12664','2013-05-31','11:50:00',3.3),('12664','2013-05-31','11:55:00',2.81),('12664','2013-05-31','12:00:00',3.34),('12664','2013-05-31','12:05:00',3.63),('12664','2013-05-31','12:10:00',2.26),('12664','2013-05-31','12:15:00',3.19),('12664','2013-05-31','12:20:00',4.1),('12664','2013-05-31','12:25:00',2.1),('12664','2013-05-31','12:30:00',1.74),('12664','2013-05-31','12:35:00',1.18),('12664','2013-05-31','12:45:00',1.37),('12664','2013-05-31','12:50:00',4.63),('12664','2013-05-31','12:55:00',3.86),('12664','2013-05-31','13:00:00',1.69),('12664','2013-05-31','13:05:00',1.31),('12664','2013-05-31','13:10:00',1.97),('12664','2013-05-31','13:15:00',3.38),('12664','2013-05-31','13:20:00',3.19),('12664','2013-05-31','13:25:00',3.91),('12664','2013-05-31','13:30:00',1.33),('12664','2013-05-31','13:35:00',1.06),('12664','2013-05-31','13:40:00',2.31),('12664','2013-05-31','13:45:00',3.66),('12664','2013-05-31','13:50:00',2.76),('12664','2013-05-31','13:55:00',1.62),('12664','2013-05-31','14:25:00',2.16),('12664','2013-05-31','14:30:00',2.07),('12664','2013-05-31','14:35:00',1.18),('12664','2013-05-31','14:55:00',1.74),('12664','2013-05-31','15:00:00',1.18),('12664','2013-05-31','15:05:00',1.63),('12664','2013-05-31','15:10:00',3.09),('12664','2013-05-31','15:15:00',2.68),('12664','2013-05-31','15:20:00',1.96),('12664','2013-05-31','15:25:00',2.01),('12664','2013-05-31','15:30:00',1.91),('12664','2013-05-31','15:35:00',1.85),('12664','2013-05-31','15:40:00',1.69),('12664','2013-05-31','15:45:00',2.93),('12664','2013-05-31','15:50:00',2.27),('12664','2013-05-31','15:55:00',2.09),('12664','2013-05-31','16:00:00',1.3),('12664','2013-05-31','16:15:00',1.04),('12664','2013-05-31','16:20:00',1.43),('12664','2013-05-31','16:25:00',1.16),('12664','2013-05-31','16:40:00',1.12),('12664','2014-04-01','08:25:00',1.06),('12664','2014-04-01','08:30:00',1.15),('12664','2014-04-01','08:35:00',1.25),('12664','2014-04-01','08:40:00',1.34),('12664','2014-04-01','08:45:00',1.44),('12664','2014-04-01','08:50:00',1.54),('12664','2014-04-01','08:55:00',1.63),('12664','2014-04-01','09:00:00',1.73),('12664','2014-04-01','09:05:00',1.83),('12664','2014-04-01','09:10:00',1.91),('12664','2014-04-01','09:15:00',2.01),('12664','2014-04-01','09:20:00',2.08),('12664','2014-04-01','09:25:00',2.16),('12664','2014-04-01','09:30:00',2.21),('12664','2014-04-01','09:35:00',2.25),('12664','2014-04-01','09:40:00',2.36),('12664','2014-04-01','09:45:00',2.44),('12664','2014-04-01','09:50:00',2.59),('12664','2014-04-01','09:55:00',2.68),('12664','2014-04-01','10:00:00',2.77),('12664','2014-04-01','10:05:00',2.84),('12664','2014-04-01','10:10:00',2.91),('12664','2014-04-01','10:15:00',2.96),('12664','2014-04-01','10:20:00',3.02),('12664','2014-04-01','10:25:00',3.07),('12664','2014-04-01','10:30:00',3.14),('12664','2014-04-01','10:35:00',3.16),('12664','2014-04-01','10:40:00',3.27),('12664','2014-04-01','10:45:00',3.28),('12664','2014-04-01','10:50:00',3.34),('12664','2014-04-01','10:55:00',3.49),('12664','2014-04-01','11:00:00',3.48),('12664','2014-04-01','11:05:00',3.52),('12664','2014-04-01','11:10:00',3.62),('12664','2014-04-01','11:15:00',3.58),('12664','2014-04-01','11:20:00',3.63),('12664','2014-04-01','11:25:00',3.68),('12664','2014-04-01','11:30:00',3.63),('12664','2014-04-01','11:35:00',3.59),('12664','2014-04-01','11:40:00',3.73),('12664','2014-04-01','11:45:00',3.81),('12664','2014-04-01','11:50:00',3.58),('12664','2014-04-01','11:55:00',3.64),('12664','2014-04-01','12:00:00',3.94),('12664','2014-04-01','12:05:00',3.98),('12664','2014-04-01','12:10:00',4.01),('12664','2014-04-01','12:15:00',4.08),('12664','2014-04-01','12:20:00',4.1),('12664','2014-04-01','12:25:00',4.13),('12664','2014-04-01','12:30:00',4.16),('12664','2014-04-01','12:35:00',4.22),('12664','2014-04-01','12:40:00',4.35),('12664','2014-04-01','12:45:00',4.01),('12664','2014-04-01','12:50:00',4.21),('12664','2014-04-01','12:55:00',4.12),('12664','2014-04-01','13:00:00',4.25),('12664','2014-04-01','13:05:00',4.25),('12664','2014-04-01','13:10:00',4.24),('12664','2014-04-01','13:15:00',4.11),('12664','2014-04-01','13:20:00',4.26),('12664','2014-04-01','13:25:00',4.35),('12664','2014-04-01','13:30:00',3.89),('12664','2014-04-01','13:35:00',4.45),('12664','2014-04-01','13:40:00',4.42),('12664','2014-04-01','13:45:00',3.96),('12664','2014-04-01','13:50:00',4.28),('12664','2014-04-01','13:55:00',3.81),('12664','2014-04-01','14:00:00',3.98),('12664','2014-04-01','14:05:00',3.98),('12664','2014-04-01','14:10:00',4.21),('12664','2014-04-01','14:15:00',4.09),('12664','2014-04-01','14:20:00',4.05),('12664','2014-04-01','14:25:00',3.63),('12664','2014-04-01','14:30:00',4.17),('12664','2014-04-01','14:35:00',4.2),('12664','2014-04-01','14:40:00',4.08),('12664','2014-04-01','14:45:00',3.76),('12664','2014-04-01','14:50:00',3.55),('12664','2014-04-01','14:55:00',3.95),('12664','2014-04-01','15:00:00',3.75),('12664','2014-04-01','15:05:00',3.42),('12664','2014-04-01','15:10:00',3.16),('12664','2014-04-01','15:15:00',3.09),('12664','2014-04-01','15:20:00',3.71),('12664','2014-04-01','15:25:00',3.31),('12664','2014-04-01','15:30:00',3.69),('12664','2014-04-01','15:35:00',3.01),('12664','2014-04-01','15:40:00',2.89),('12664','2014-04-01','15:45:00',3.45),('12664','2014-04-01','15:50:00',3.45),('12664','2014-04-01','15:55:00',2.15),('12664','2014-04-01','16:00:00',1.93),('12664','2014-04-01','16:05:00',1.7),('12664','2014-04-01','16:10:00',2.86),('12664','2014-04-01','16:15:00',3.03),('12664','2014-04-01','16:20:00',2.13),('12664','2014-04-01','16:25:00',2.76),('12664','2014-04-01','16:30:00',2.69),('12664','2014-04-01','16:35:00',1.65),('12664','2014-04-01','16:40:00',2.06),('12664','2014-04-01','16:50:00',2.23),('12664','2014-04-01','16:55:00',2.08),('12664','2014-04-01','17:00:00',2.21),('12664','2014-04-01','17:05:00',2.11),('12664','2014-04-01','17:10:00',1.44),('12664','2014-04-01','17:15:00',1.4),('12664','2014-04-01','17:20:00',1.54),('12664','2014-04-01','17:25:00',1.58),('12664','2014-04-01','17:30:00',1.49),('12664','2014-04-01','17:35:00',1.39),('12664','2014-04-01','17:40:00',1.3),('12664','2014-04-01','17:45:00',1.15),('12664','2014-04-01','17:50:00',1.06),('12664','2014-04-01','17:55:00',1.02),('12664','2013-05-30','07:40:00',1.43),('12664','2013-05-30','07:45:00',1.62),('12664','2013-05-30','07:50:00',1.14),('12664','2013-05-30','08:25:00',1.79),('12664','2013-05-30','08:30:00',2.36),('12664','2013-05-30','08:35:00',2.43),('12664','2013-05-30','08:40:00',2.5),('12664','2013-05-30','08:45:00',2.57),('12664','2013-05-30','08:50:00',2.67),('12664','2013-05-30','08:55:00',2.78),('12664','2013-05-30','09:00:00',2.9),('12664','2013-05-30','09:05:00',2.99),('12664','2013-05-30','09:10:00',3.14),('12664','2013-05-30','09:15:00',3.1),('12664','2013-05-30','09:20:00',3.2),('12664','2013-05-30','09:25:00',2.77),('12664','2013-05-30','09:30:00',2.92),('12664','2013-05-30','09:35:00',3.61),('12664','2013-05-30','09:40:00',3.45),('12664','2013-05-30','09:45:00',3.5),('12664','2013-05-30','09:50:00',3.05),('12664','2013-05-30','09:55:00',3),('12664','2013-05-30','10:00:00',2.97),('12664','2013-05-30','10:05:00',3.36),('12664','2013-05-30','10:10:00',2.87),('12664','2013-05-30','10:15:00',3.88),('12664','2013-05-30','10:20:00',4.01),('12664','2013-05-30','10:30:00',1.44),('12664','2013-05-30','10:35:00',3.75),('12664','2013-05-30','10:40:00',4.52),('12664','2013-05-30','10:45:00',4.65),('12664','2013-05-30','10:50:00',4.74),('12664','2013-05-30','10:55:00',2.94),('12664','2013-05-30','11:00:00',2.8),('12664','2013-05-30','11:05:00',3.47),('12664','2013-05-30','11:10:00',5.02),('12664','2013-05-30','11:15:00',2.76),('12664','2013-05-30','11:20:00',4.85),('12664','2013-05-30','11:25:00',1.5),('12664','2013-05-30','11:30:00',3.5),('12664','2013-05-30','11:35:00',2.83),('12664','2013-05-30','11:40:00',2.96),('12664','2013-05-30','11:45:00',3.33),('12664','2013-05-30','11:50:00',3.28),('12664','2013-05-30','11:55:00',2.7),('12664','2013-05-30','12:00:00',1.06),('12664','2013-05-30','12:05:00',3.37),('12664','2013-05-30','12:10:00',3.67),('12664','2013-05-30','12:15:00',3.77),('12664','2013-05-30','12:20:00',3.81),('12664','2013-05-30','12:25:00',3.77),('12664','2013-05-30','12:30:00',4.76),('12664','2013-05-30','12:35:00',3.64),('12664','2013-05-30','12:40:00',2.67),('12664','2013-05-30','12:45:00',3.99),('12664','2013-05-30','12:50:00',2.43),('12664','2013-05-30','12:55:00',3.56),('12664','2013-05-30','13:00:00',3.2),('12664','2013-05-30','13:05:00',2.98),('12664','2013-05-30','13:10:00',1.46),('12664','2013-05-30','13:15:00',2.16),('12664','2013-05-30','13:20:00',4.03),('12664','2013-05-30','13:25:00',4.7),('12664','2013-05-30','13:30:00',3.75),('12664','2013-05-30','13:35:00',4.29),('12664','2013-05-30','13:40:00',3.05),('12664','2013-05-30','13:45:00',4.03),('12664','2013-05-30','13:50:00',4.62),('12664','2013-05-30','13:55:00',4.34),('12664','2013-05-30','14:00:00',3.47),('12664','2013-05-30','14:05:00',3.88),('12664','2013-05-30','14:10:00',1.25),('12664','2013-05-30','14:15:00',1.99),('12664','2013-05-30','14:20:00',1.36),('12664','2013-05-30','14:25:00',2.93),('12664','2013-05-30','14:30:00',1.42),('12664','2013-05-30','14:35:00',3.56),('12664','2013-05-30','14:40:00',2.45),('12664','2013-05-30','14:45:00',1.72),('12664','2013-05-30','14:50:00',1.76),('12664','2013-05-30','14:55:00',2.64),('12664','2013-05-30','15:00:00',1.84),('12664','2013-05-30','15:05:00',3.2),('12664','2013-05-30','15:10:00',1.82),('12664','2013-05-30','15:15:00',4.75),('12664','2013-05-30','15:20:00',1.4),('12664','2013-05-30','15:25:00',4.54),('12664','2013-05-30','15:30:00',2.74),('12664','2013-05-30','15:35:00',2.94),('12664','2013-05-30','15:40:00',4),('12664','2013-05-30','15:45:00',3.57),('12664','2013-05-30','15:50:00',2.38),('12664','2013-05-30','15:55:00',3.54),('12664','2013-05-30','16:00:00',4.45),('12664','2013-05-30','16:05:00',4.14),('12664','2013-05-30','16:10:00',2.38),('12664','2013-05-30','16:15:00',1.14),('12664','2013-05-30','16:20:00',1.11),('12664','2013-05-30','16:25:00',1.37),('12664','2013-05-30','16:30:00',1.18),('12664','2013-05-30','16:35:00',2.31),('12664','2013-05-30','16:40:00',2.01),('12664','2013-05-30','16:45:00',1.24),('12664','2013-05-30','16:50:00',2.03),('12664','2013-05-30','16:55:00',3.64),('12664','2013-05-30','17:00:00',2.33),('12664','2013-05-30','17:50:00',1.21),('12664','2013-05-30','17:55:00',1.32),('12664','2013-05-30','18:00:00',2),('12664','2013-05-30','18:05:00',1.56),('12664','2013-05-30','18:20:00',1.17),('12664','2013-05-30','18:25:00',1.75),('12664','2013-05-30','18:30:00',1.85),('12664','2013-05-30','18:35:00',1.59),('12664','2013-05-30','18:40:00',1.08),('12664','2013-05-29','07:30:00',1.03),('12664','2013-05-29','07:35:00',1.13),('12664','2013-05-29','07:40:00',1.22),('12664','2013-05-29','07:45:00',1.32),('12664','2013-05-29','07:50:00',1.42),('12664','2013-05-29','07:55:00',1.51),('12664','2013-05-29','08:00:00',1.6),('12664','2013-05-29','08:05:00',1.7),('12664','2013-05-29','08:10:00',1.79),('12664','2013-05-29','08:15:00',1.88),('12664','2013-05-29','08:20:00',1.98),('12664','2013-05-29','08:25:00',2.07),('12664','2013-05-29','08:30:00',2.18),('12664','2013-05-29','08:35:00',2.26),('12664','2013-05-29','08:40:00',2.35),('12664','2013-05-29','08:45:00',2.45),('12664','2013-05-29','08:50:00',2.55),('12664','2013-05-29','08:55:00',2.65),('12664','2013-05-29','09:00:00',2.73),('12664','2013-05-29','09:05:00',2.82),('12664','2013-05-29','09:10:00',2.9),('12664','2013-05-29','09:15:00',2.97),('12664','2013-05-29','09:20:00',3.05),('12664','2013-05-29','09:25:00',3.13),('12664','2013-05-29','09:30:00',3.2),('12664','2013-05-29','09:35:00',3.29),('12664','2013-05-29','09:40:00',3.36),('12664','2013-05-29','09:45:00',3.42),('12664','2013-05-29','09:50:00',3.51),('12664','2013-05-29','09:55:00',3.56),('12664','2013-05-29','10:00:00',3.66),('12664','2013-05-29','10:05:00',3.67),('12664','2013-05-29','10:10:00',3.75),('12664','2013-05-29','10:15:00',3.81),('12664','2013-05-29','10:20:00',3.94),('12664','2013-05-29','10:25:00',3.99),('12664','2013-05-29','10:30:00',4.01),('12664','2013-05-29','10:35:00',4.08),('12664','2013-05-29','10:40:00',4.08),('12664','2013-05-29','10:45:00',4.29),('12664','2013-05-29','10:50:00',3.81),('12664','2013-05-29','10:55:00',2.99),('12664','2013-05-29','11:00:00',4.86),('12664','2013-05-29','11:05:00',4.38),('12664','2013-05-29','11:10:00',2.19),('12664','2013-05-29','11:15:00',2.4),('12664','2013-05-29','11:20:00',2.81),('12664','2013-05-29','11:25:00',3.1),('12664','2013-05-29','11:30:00',2.92),('12664','2013-05-29','11:35:00',4.29),('12664','2013-05-29','11:40:00',4.51),('12664','2013-05-29','11:45:00',4.49),('12664','2013-05-29','11:50:00',3.93),('12664','2013-05-29','11:55:00',4.99),('12664','2013-05-29','12:00:00',4.93),('12664','2013-05-29','12:05:00',4.84),('12664','2013-05-29','12:10:00',4.4),('12664','2013-05-29','12:15:00',4.52),('12664','2013-05-29','12:20:00',4.88),('12664','2013-05-29','12:25:00',4.18),('12664','2013-05-29','12:30:00',4.34),('12664','2013-05-29','12:35:00',4.91),('12664','2013-05-29','12:40:00',4.29),('12664','2013-05-29','12:45:00',4.87),('12664','2013-05-29','12:50:00',4.84),('12664','2013-05-29','12:55:00',4.93),('12664','2013-05-29','13:00:00',4.79),('12664','2013-05-29','13:05:00',4.91),('12664','2013-05-29','13:10:00',4.9),('12664','2013-05-29','13:15:00',2.82),('12664','2013-05-29','13:20:00',3.6),('12664','2013-05-29','13:25:00',4.96),('12664','2013-05-29','13:30:00',3.64),('12664','2013-05-29','13:35:00',3.28),('12664','2013-05-29','13:40:00',4.26),('12664','2013-05-29','13:45:00',3.77),('12664','2013-05-29','13:50:00',3.45),('12664','2013-05-29','13:55:00',4.67),('12664','2013-05-29','14:00:00',4.84),('12664','2013-05-29','14:05:00',4.97),('12664','2013-05-29','14:10:00',4.98),('12664','2013-05-29','14:15:00',4.66),('12664','2013-05-29','14:20:00',4.66),('12664','2013-05-29','14:25:00',4.67),('12664','2013-05-29','14:30:00',3.74),('12664','2013-05-29','14:35:00',2.72),('12664','2013-05-29','14:40:00',3.88),('12664','2013-05-29','14:45:00',3.86),('12664','2013-05-29','14:50:00',4.28),('12664','2013-05-29','14:55:00',3.28),('12664','2013-05-29','15:00:00',3.8),('12664','2013-05-29','15:05:00',3.68),('12664','2013-05-29','15:10:00',2.78),('12664','2013-05-29','15:15:00',3.52),('12664','2013-05-29','15:20:00',4.09),('12664','2013-05-29','15:25:00',3.3),('12664','2013-05-29','15:30:00',3.19),('12664','2013-05-29','15:35:00',3.39),('12664','2013-05-29','15:40:00',3.02),('12664','2013-05-29','15:45:00',3.74),('12664','2013-05-29','15:50:00',3.71),('12664','2013-05-29','15:55:00',3.58),('12664','2013-05-29','16:00:00',2.75),('12664','2013-05-29','16:05:00',2.75),('12664','2013-05-29','16:10:00',2.66),('12664','2013-05-29','16:15:00',2.93),('12664','2013-05-29','16:20:00',4.27),('12664','2013-05-29','16:25:00',2.95),('12664','2013-05-29','16:30:00',2.17),('12664','2013-05-29','16:35:00',2.02),('12664','2013-05-29','16:40:00',1.9),('12664','2013-05-29','16:45:00',1.36),('12664','2013-05-29','16:50:00',1),('12664','2013-05-29','17:25:00',1.11),('12664','2013-05-29','17:30:00',1.87),('12664','2013-05-29','17:35:00',2.05),('12664','2013-05-29','17:40:00',1.5),('12664','2013-05-29','17:55:00',1.21),('12664','2013-05-29','18:00:00',1.15),('12664','2013-05-29','18:05:00',1.24),('12664','2013-05-29','18:10:00',1.72),('12664','2013-05-29','18:15:00',1.43),('12664','2013-05-28','07:25:00',1.03),('12664','2013-05-28','07:30:00',1.19),('12664','2013-05-28','07:35:00',1.12),('12664','2013-05-28','07:45:00',1.35),('12664','2013-05-28','07:50:00',1.22),('12664','2013-05-28','07:55:00',1.1),('12664','2013-05-28','08:00:00',1.16),('12664','2013-05-28','08:05:00',1.51),('12664','2013-05-28','08:10:00',1.49),('12664','2013-05-28','08:15:00',1.79),('12664','2013-05-28','08:20:00',1.87),('12664','2013-05-28','08:25:00',1.66),('12664','2013-05-28','08:30:00',1.82),('12664','2013-05-28','08:35:00',1.87),('12664','2013-05-28','08:40:00',1.74),('12664','2013-05-28','08:45:00',1.55),('12664','2013-05-28','08:50:00',1.6),('12664','2013-05-28','08:55:00',1.94),('12664','2013-05-28','09:00:00',1.66),('12664','2013-05-28','09:05:00',1.73),('12664','2013-05-28','09:10:00',1.94),('12664','2013-05-28','09:15:00',2.1),('12664','2013-05-28','09:20:00',2.13),('12664','2013-05-28','09:25:00',2.4),('12664','2013-05-28','09:30:00',2.67),('12664','2013-05-28','09:35:00',2.78),('12664','2013-05-28','09:40:00',2.5),('12664','2013-05-28','09:45:00',2.82),('12664','2013-05-28','09:50:00',2.68),('12664','2013-05-28','09:55:00',2.57),('12664','2013-05-28','10:00:00',2.14),('12664','2013-05-28','10:05:00',2.16),('12664','2013-05-28','10:10:00',2.42),('12664','2013-05-28','10:15:00',2.6),('12664','2013-05-28','10:20:00',2.4),('12664','2013-05-28','10:25:00',2.49),('12664','2013-05-28','10:30:00',2.78),('12664','2013-05-28','10:35:00',2.91),('12664','2013-05-28','10:40:00',3.22),('12664','2013-05-28','10:45:00',3.17),('12664','2013-05-28','10:50:00',2.61),('12664','2013-05-28','10:55:00',3.01),('12664','2013-05-28','11:00:00',3.17),('12664','2013-05-28','11:05:00',3.33),('12664','2013-05-28','11:10:00',3.41),('12664','2013-05-28','11:15:00',2.26),('12664','2013-05-28','11:20:00',2.47),('12664','2013-05-28','11:25:00',2.51),('12664','2013-05-28','11:30:00',3.69),('12664','2013-05-28','11:35:00',4.29),('12664','2013-05-28','11:40:00',4.39),('12664','2013-05-28','11:45:00',1.34),('12664','2013-05-28','11:50:00',1.15),('12664','2013-05-28','11:55:00',1.22),('12664','2013-05-28','12:00:00',1.98),('12664','2013-05-28','12:05:00',2.69),('12664','2013-05-28','12:10:00',3.33),('12664','2013-05-28','12:15:00',2.83),('12664','2013-05-28','12:20:00',2.76),('12664','2013-05-28','12:25:00',3.34),('12664','2013-05-28','12:30:00',2.67),('12664','2013-05-28','12:35:00',2.1),('12664','2013-05-28','12:40:00',2.31),('12664','2013-05-28','12:45:00',2.23),('12664','2013-05-28','12:50:00',2.25),('12664','2013-05-28','12:55:00',2.57),('12664','2013-05-28','13:00:00',2.77),('12664','2013-05-28','13:05:00',2.83),('12664','2013-05-28','13:10:00',2.22),('12664','2013-05-28','13:15:00',1.65),('12664','2013-05-28','13:20:00',2.19),('12664','2013-05-28','13:25:00',3.73),('12664','2013-05-28','13:30:00',4.21),('12664','2013-05-28','13:35:00',3.05),('12664','2013-05-28','13:40:00',2.32),('12664','2013-05-28','13:45:00',2.29),('12664','2013-05-28','13:50:00',2.07),('12664','2013-05-28','13:55:00',2.42),('12664','2013-05-28','14:00:00',1.93),('12664','2013-05-28','14:05:00',2.23),('12664','2013-05-28','14:10:00',2.31),('12664','2013-05-28','14:15:00',2.81),('12664','2013-05-28','14:20:00',3.58),('12664','2013-05-28','14:25:00',3.1),('12664','2013-05-28','14:30:00',3.23),('12664','2013-05-28','14:35:00',3.28),('12664','2013-05-28','14:40:00',2.9),('12664','2013-05-28','14:45:00',2.88),('12664','2013-05-28','14:50:00',3.58),('12664','2013-05-28','14:55:00',3.63),('12664','2013-05-28','15:00:00',3.87),('12664','2013-05-28','15:05:00',2.6),('12664','2013-05-28','15:10:00',1.99),('12664','2013-05-28','15:15:00',2.03),('12664','2013-05-28','15:20:00',2.07),('12664','2013-05-28','15:25:00',1.83),('12664','2013-05-28','15:30:00',2),('12664','2013-05-28','15:35:00',2.22),('12664','2013-05-28','15:40:00',1.96),('12664','2013-05-28','15:45:00',1.97),('12664','2013-05-28','15:50:00',2.44),('12664','2013-05-28','15:55:00',3.13),('12664','2013-05-28','16:00:00',2.85),('12664','2013-05-28','16:05:00',2.92),('12664','2013-05-28','16:10:00',1.79),('12664','2013-05-28','16:15:00',1.97),('12664','2013-05-28','16:20:00',2.04),('12664','2013-05-28','16:25:00',1.34),('12664','2013-05-28','16:30:00',1.29),('12664','2013-05-28','16:35:00',1.34),('12664','2013-05-28','16:40:00',1.88),('12664','2013-05-28','16:45:00',2.99),('12664','2013-05-28','16:50:00',2.79),('12664','2013-05-28','16:55:00',2.67),('12664','2013-05-28','17:00:00',2.61),('12664','2013-05-28','17:05:00',2.54),('12664','2013-05-28','17:10:00',2.46),('12664','2013-05-28','17:15:00',2.36),('12664','2013-05-28','17:20:00',2.27),('12664','2013-05-28','17:25:00',2.2),('12664','2013-05-28','17:30:00',2.13),('12664','2013-05-28','17:35:00',2.03),('12664','2013-05-28','17:40:00',1.94),('12664','2013-05-28','17:45:00',1.83),('12664','2013-05-28','17:50:00',1.69),('12664','2013-05-28','18:15:00',1.34),('12664','2013-05-28','18:20:00',1.43),('12664','2013-05-28','18:25:00',1.25),('12664','2013-05-28','18:30:00',1.07),('12664','2013-05-27','07:35:00',1.16),('12664','2013-05-27','07:40:00',1.29),('12664','2013-05-27','07:45:00',1.39),('12664','2013-05-27','08:00:00',1.83),('12664','2013-05-27','08:05:00',1.58),('12664','2013-05-27','08:10:00',1.47),('12664','2013-05-27','08:15:00',1.4),('12664','2013-05-27','08:20:00',1.94),('12664','2013-05-27','08:25:00',2.17),('12664','2013-05-27','08:30:00',2.37),('12664','2013-05-27','08:35:00',2.65),('12664','2013-05-27','08:40:00',2.19),('12664','2013-05-27','08:45:00',2.14),('12664','2013-05-27','08:50:00',2.11),('12664','2013-05-27','08:55:00',2.24),('12664','2013-05-27','09:00:00',3.21),('12664','2013-05-27','09:05:00',1.69),('12664','2013-05-27','09:10:00',2.33),('12664','2013-05-27','09:15:00',3.6),('12664','2013-05-27','09:20:00',2.08),('12664','2013-05-27','09:30:00',3.51),('12664','2013-05-27','09:35:00',3.5),('12664','2013-05-27','09:40:00',3.57),('12664','2013-05-27','09:45:00',3.7),('12664','2013-05-27','09:50:00',3.61),('12664','2013-05-27','09:55:00',3.63),('12664','2013-05-27','10:00:00',3.69),('12664','2013-05-27','10:05:00',2.82),('12664','2013-05-27','10:10:00',4.11),('12664','2013-05-27','10:15:00',3.98),('12664','2013-05-27','10:20:00',4.19),('12664','2013-05-27','10:25:00',4.38),('12664','2013-05-27','10:30:00',4.56),('12664','2013-05-27','10:35:00',4.01),('12664','2013-05-27','10:40:00',1.74),('12664','2013-05-27','10:45:00',3.92),('12664','2013-05-27','10:50:00',1.97),('12664','2013-05-27','10:55:00',3.19),('12664','2013-05-27','11:00:00',3.13),('12664','2013-05-27','11:05:00',3.27),('12664','2013-05-27','11:10:00',4.62),('12664','2013-05-27','11:15:00',3.76),('12664','2013-05-27','11:20:00',3.16),('12664','2013-05-27','11:25:00',2.35),('12664','2013-05-27','11:30:00',3.33),('12664','2013-05-27','11:35:00',3.23),('12664','2013-05-27','11:40:00',3.78),('12664','2013-05-27','11:45:00',1.47),('12664','2013-05-27','11:50:00',3.08),('12664','2013-05-27','11:55:00',4.65),('12664','2013-05-27','12:00:00',4.96),('12664','2013-05-27','12:05:00',5),('12664','2013-05-27','12:10:00',5.04),('12664','2013-05-27','12:15:00',5.05),('12664','2013-05-27','12:20:00',5.03),('12664','2013-05-27','12:25:00',4.93),('12664','2013-05-27','12:30:00',5),('12664','2013-05-27','12:35:00',4.96),('12664','2013-05-27','12:40:00',4.87),('12664','2013-05-27','12:45:00',4.89),('12664','2013-05-27','12:50:00',4.83),('12664','2013-05-27','12:55:00',4.96),('12664','2013-05-27','13:00:00',4.95),('12664','2013-05-27','13:05:00',4.77),('12664','2013-05-27','13:10:00',4.45),('12664','2013-05-27','13:15:00',3.38),('12664','2013-05-27','13:20:00',4.83),('12664','2013-05-27','13:25:00',4.83),('12664','2013-05-27','13:30:00',4.59),('12664','2013-05-27','13:35:00',4.12),('12664','2013-05-27','13:40:00',4.74),('12664','2013-05-27','13:45:00',4.83),('12664','2013-05-27','13:50:00',4.76),('12664','2013-05-27','13:55:00',4.73),('12664','2013-05-27','14:00:00',4.6),('12664','2013-05-27','14:05:00',4.76),('12664','2013-05-27','14:10:00',4.64),('12664','2013-05-27','14:15:00',4.61),('12664','2013-05-27','14:20:00',4.55),('12664','2013-05-27','14:25:00',4.54),('12664','2013-05-27','14:30:00',4.59),('12664','2013-05-27','14:35:00',4.54),('12664','2013-05-27','14:40:00',4.54),('12664','2013-05-27','14:45:00',4.52),('12664','2013-05-27','14:50:00',4.15),('12664','2013-05-27','14:55:00',3.58),('12664','2013-05-27','15:00:00',2.31),('12664','2013-05-27','15:05:00',4.7),('12664','2013-05-27','15:10:00',3.95),('12664','2013-05-27','15:15:00',3.08),('12664','2013-05-27','15:20:00',3.46),('12664','2013-05-27','15:25:00',3.57),('12664','2013-05-27','15:30:00',4.23),('12664','2013-05-27','15:35:00',3.79),('12664','2013-05-27','15:40:00',2.42),('12664','2013-05-27','15:45:00',4.02),('12664','2013-05-27','15:50:00',3.51),('12664','2013-05-27','15:55:00',3.41),('12664','2013-05-27','16:00:00',3.32),('12664','2013-05-27','16:05:00',3.01),('12664','2013-05-27','16:10:00',2.26),('12664','2013-05-27','16:15:00',3.04),('12664','2013-05-27','16:20:00',3.98),('12664','2013-05-27','16:25:00',3.36),('12664','2013-05-27','16:30:00',3.4),('12664','2013-05-27','16:35:00',2.89),('12664','2013-05-27','16:40:00',1.62),('12664','2013-05-27','16:45:00',1.28),('12664','2013-05-27','16:50:00',1.38),('12664','2013-05-27','16:55:00',1.45),('12664','2013-05-27','17:00:00',1.53),('12664','2013-05-27','17:05:00',1.75),('12664','2013-05-27','17:10:00',1.69),('12664','2013-05-27','17:15:00',1.35),('12664','2013-05-27','17:20:00',1.24),('12664','2013-05-27','17:25:00',1.22),('12664','2013-05-27','17:30:00',1.14),('12664','2013-05-27','17:35:00',1.05),('12664','2013-05-27','18:15:00',1.05),('12664','2013-05-27','18:20:00',1.66),('12664','2013-05-27','18:25:00',1.7),('12664','2013-05-27','18:30:00',1.46),('12664','2013-05-26','07:35:00',1.25),('12664','2013-05-26','07:40:00',1.53),('12664','2013-05-26','07:45:00',1.68),('12664','2013-05-26','08:00:00',1.59),('12664','2013-05-26','08:05:00',1.02),('12664','2013-05-26','08:10:00',1.71),('12664','2013-05-26','08:15:00',2.52),('12664','2013-05-26','08:20:00',1.15),('12664','2013-05-26','08:25:00',1.52),('12664','2013-05-26','08:35:00',2.4),('12664','2013-05-26','08:40:00',2.64),('12664','2013-05-26','08:45:00',1.31),('12664','2013-05-26','08:55:00',1.99),('12664','2013-05-26','09:00:00',1.59),('12664','2013-05-26','09:05:00',2.45),('12664','2013-05-26','09:10:00',1.59),('12664','2013-05-26','09:15:00',1.24),('12664','2013-05-26','09:20:00',1.33),('12664','2013-05-26','09:25:00',3.02),('12664','2013-05-26','09:30:00',1.12),('12664','2013-05-26','09:35:00',2.2),('12664','2013-05-26','09:40:00',1.75),('12664','2013-05-26','09:50:00',2.75),('12664','2013-05-26','09:55:00',4.1),('12664','2013-05-26','10:00:00',4.05),('12664','2013-05-26','10:05:00',4.2),('12664','2013-05-26','10:10:00',3.81),('12664','2013-05-26','10:15:00',4.08),('12664','2013-05-26','10:20:00',3.92),('12664','2013-05-26','10:25:00',4.27),('12664','2013-05-26','10:30:00',4.29),('12664','2013-05-26','10:35:00',4.3),('12664','2013-05-26','10:40:00',4.36),('12664','2013-05-26','10:45:00',4.4),('12664','2013-05-26','10:50:00',4.43),('12664','2013-05-26','10:55:00',4.48),('12664','2013-05-26','11:00:00',4.54),('12664','2013-05-26','11:05:00',4.64),('12664','2013-05-26','11:10:00',4.63),('12664','2013-05-26','11:15:00',4.74),('12664','2013-05-26','11:20:00',4.24),('12664','2013-05-26','11:25:00',4.75),('12664','2013-05-26','11:30:00',4.81),('12664','2013-05-26','11:35:00',4.8),('12664','2013-05-26','11:40:00',4.84),('12664','2013-05-26','11:45:00',4.84),('12664','2013-05-26','11:50:00',4.89),('12664','2013-05-26','11:55:00',4.99),('12664','2013-05-26','12:00:00',4.96),('12664','2013-05-26','12:05:00',5),('12664','2013-05-26','12:10:00',5.02),('12664','2013-05-26','12:15:00',5.03),('12664','2013-05-26','12:20:00',5.03),('12664','2013-05-26','12:25:00',5.02),('12664','2013-05-26','12:30:00',5),('12664','2013-05-26','12:35:00',4.59),('12664','2013-05-26','12:40:00',5.02),('12664','2013-05-26','12:45:00',5.03),('12664','2013-05-26','12:50:00',5.03),('12664','2013-05-26','12:55:00',5.04),('12664','2013-05-26','13:00:00',4.92),('12664','2013-05-26','13:05:00',4.43),('12664','2013-05-26','13:10:00',4.98),('12664','2013-05-26','13:15:00',5.03),('12664','2013-05-26','13:20:00',5.03),('12664','2013-05-26','13:25:00',5.01),('12664','2013-05-26','13:30:00',5.01),('12664','2013-05-26','13:35:00',4.76),('12664','2013-05-26','13:40:00',4.99),('12664','2013-05-26','13:45:00',4.99),('12664','2013-05-26','13:50:00',4.52),('12664','2013-05-26','13:55:00',4.95),('12664','2013-05-26','14:00:00',4.92),('12664','2013-05-26','14:05:00',4.89),('12664','2013-05-26','14:10:00',4.87),('12664','2013-05-26','14:15:00',4.84),('12664','2013-05-26','14:20:00',4.81),('12664','2013-05-26','14:25:00',4.77),('12664','2013-05-26','14:30:00',4.72),('12664','2013-05-26','14:35:00',4.68),('12664','2013-05-26','14:40:00',4.67),('12664','2013-05-26','14:45:00',4.64),('12664','2013-05-26','14:50:00',4.58),('12664','2013-05-26','14:55:00',3.18),('12664','2013-05-26','15:00:00',3.6),('12664','2013-05-26','15:05:00',4.44),('12664','2013-05-26','15:10:00',4.4),('12664','2013-05-26','15:15:00',4.35),('12664','2013-05-26','15:20:00',4.3),('12664','2013-05-26','15:25:00',4.25),('12664','2013-05-26','15:30:00',4.18),('12664','2013-05-26','15:35:00',4.13),('12664','2013-05-26','15:40:00',4.08),('12664','2013-05-26','15:45:00',4.03),('12664','2013-05-26','15:50:00',3.76),('12664','2013-05-26','15:55:00',3.92),('12664','2013-05-26','16:00:00',3.82),('12664','2013-05-26','16:05:00',3.76),('12664','2013-05-26','16:10:00',3.7),('12664','2013-05-26','16:15:00',3.62),('12664','2013-05-26','16:20:00',3.56),('12664','2013-05-26','16:25:00',3.49),('12664','2013-05-26','16:30:00',3.4),('12664','2013-05-26','16:35:00',3.32),('12664','2013-05-26','16:40:00',3.25),('12664','2013-05-26','16:45:00',3.16),('12664','2013-05-26','16:50:00',3.06),('12664','2013-05-26','16:55:00',2.99),('12664','2013-05-26','17:00:00',2.9),('12664','2013-05-26','17:05:00',2.8),('12664','2013-05-26','17:10:00',2.71),('12664','2013-05-26','17:15:00',2.62),('12664','2013-05-26','17:20:00',2.53),('12664','2013-05-26','17:25:00',2.45),('12664','2013-05-26','17:30:00',2.35),('12664','2013-05-26','17:35:00',2.25),('12664','2013-05-26','17:40:00',2.15),('12664','2013-05-26','17:45:00',2.05),('12664','2013-05-26','17:50:00',1.96),('12664','2013-05-26','17:55:00',1.85),('12664','2013-05-26','18:00:00',1.75),('12664','2013-05-26','18:05:00',1.64),('12664','2013-05-26','18:10:00',1.54),('12664','2013-05-26','18:15:00',1.43),('12664','2013-05-26','18:20:00',1.33),('12664','2013-05-26','18:25:00',1.22),('12664','2013-05-26','18:30:00',1.12),('12664','2013-05-26','18:35:00',1.01),('12664','2013-05-25','07:25:00',1.1),('12664','2013-05-25','07:30:00',1.15),('12664','2013-05-25','07:40:00',1.07),('12664','2013-05-25','07:45:00',1.11),('12664','2013-05-25','08:10:00',2.02),('12664','2013-05-25','08:15:00',2.82),('12664','2013-05-25','08:20:00',2.12),('12664','2013-05-25','08:30:00',1.47),('12664','2013-05-25','08:35:00',2.77),('12664','2013-05-25','08:40:00',1.99),('12664','2013-05-25','08:45:00',1.53),('12664','2013-05-25','08:50:00',1.91),('12664','2013-05-25','08:55:00',3.06),('12664','2013-05-25','09:00:00',3.46),('12664','2013-05-25','09:05:00',2.35),('12664','2013-05-25','09:20:00',2.6),('12664','2013-05-25','09:25:00',2.63),('12664','2013-05-25','09:30:00',1.11),('12664','2013-05-25','09:35:00',1.78),('12664','2013-05-25','09:40:00',3.68),('12664','2013-05-25','09:45:00',3.08),('12664','2013-05-25','09:50:00',1.44),('12664','2013-05-25','10:05:00',1.32),('12664','2013-05-25','10:10:00',1.3),('12664','2013-05-25','10:15:00',1.39),('12664','2013-05-25','10:25:00',1.13),('12664','2013-05-25','10:30:00',1.7),('12664','2013-05-25','10:35:00',1.19),('12664','2013-05-25','10:45:00',1.01),('12664','2013-05-25','10:50:00',1.1),('12664','2013-05-25','10:55:00',1.28),('12664','2013-05-25','11:00:00',3.75),('12664','2013-05-25','11:05:00',2.5),('12664','2013-05-25','11:10:00',1.13),('12664','2013-05-25','11:25:00',2.31),('12664','2013-05-25','11:30:00',1.97),('12664','2013-05-25','11:35:00',1.6),('12664','2013-05-25','11:40:00',2.53),('12664','2013-05-25','11:45:00',3.2),('12664','2013-05-25','11:50:00',1.59),('12664','2013-05-25','11:55:00',1.76),('12664','2013-05-25','12:00:00',2.63),('12664','2013-05-25','12:05:00',2.87),('12664','2013-05-25','12:10:00',2.34),('12664','2013-05-25','12:15:00',1.69),('12664','2013-05-25','12:20:00',1.08),('12664','2013-05-25','12:35:00',1.83),('12664','2013-05-25','12:40:00',2.84),('12664','2013-05-25','12:45:00',3.26),('12664','2013-05-25','12:50:00',4.05),('12664','2013-05-25','12:55:00',2.77),('12664','2013-05-25','13:00:00',2.57),('12664','2013-05-25','13:05:00',1.93),('12664','2013-05-25','13:10:00',2.15),('12664','2013-05-25','13:15:00',2.72),('12664','2013-05-25','13:20:00',2.94),('12664','2013-05-25','13:25:00',2.59),('12664','2013-05-25','13:30:00',3.24),('12664','2013-05-25','13:35:00',2.69),('12664','2013-05-25','13:40:00',3),('12664','2013-05-25','13:45:00',3.25),('12664','2013-05-25','13:50:00',3.04),('12664','2013-05-25','13:55:00',4.5),('12664','2013-05-25','14:00:00',3.37),('12664','2013-05-25','14:05:00',4.33),('12664','2013-05-25','14:10:00',3.24),('12664','2013-05-25','14:15:00',3.79),('12664','2013-05-25','14:20:00',3.36),('12664','2013-05-25','14:25:00',4.11),('12664','2013-05-25','14:30:00',3.63),('12664','2013-05-25','14:35:00',4.84),('12664','2013-05-25','14:40:00',4.71),('12664','2013-05-25','14:45:00',4.33),('12664','2013-05-25','14:50:00',3.78),('12664','2013-05-25','14:55:00',3.44),('12664','2013-05-25','15:00:00',1.98),('12664','2013-05-25','15:05:00',3.61),('12664','2013-05-25','15:10:00',4.49),('12664','2013-05-25','15:15:00',4.07),('12664','2013-05-25','15:20:00',1.62),('12664','2013-05-25','15:25:00',4.87),('12664','2013-05-25','15:30:00',3.17),('12664','2013-05-25','15:35:00',2.39),('12664','2013-05-25','15:40:00',3.34),('12664','2013-05-25','15:45:00',3.13),('12664','2013-05-25','15:50:00',4.57),('12664','2013-05-25','15:55:00',3.64),('12664','2013-05-25','16:00:00',2.31),('12664','2013-05-25','16:05:00',1.26),('12664','2013-05-25','16:10:00',2.17),('12664','2013-05-25','16:15:00',1.92),('12664','2013-05-25','16:20:00',3.19),('12664','2013-05-25','16:25:00',2.54),('12664','2013-05-25','16:30:00',2.52),('12664','2013-05-25','16:35:00',3.11),('12664','2013-05-25','16:40:00',1.77),('12664','2013-05-25','16:45:00',3.32),('12664','2013-05-25','16:50:00',2.31),('12664','2013-05-25','16:55:00',1.2),('12664','2013-05-25','17:00:00',3.36),('12664','2013-05-25','17:05:00',2.02),('12664','2013-05-25','17:10:00',2.68),('12664','2013-05-25','17:15:00',2.83),('12664','2013-05-25','17:20:00',2.36),('12664','2013-05-25','17:25:00',2.22),('12664','2013-05-25','17:30:00',2.18),('12664','2013-05-25','17:35:00',2.21),('12664','2013-05-25','17:40:00',1.7),('12664','2013-05-25','17:45:00',1.21),('12664','2013-05-25','17:50:00',1.94),('12664','2013-05-25','18:00:00',1.46),('12664','2013-05-24','08:10:00',1.03),('12664','2013-05-24','08:15:00',1.56),('12664','2013-05-24','08:20:00',1.35),('12664','2013-05-24','08:25:00',1.77),('12664','2013-05-24','08:30:00',1.25),('12664','2013-05-24','08:35:00',1.99),('12664','2013-05-24','08:40:00',2.41),('12664','2013-05-24','08:45:00',2.49),('12664','2013-05-24','08:50:00',2.61),('12664','2013-05-24','08:55:00',2.94),('12664','2013-05-24','09:00:00',2.53),('12664','2013-05-24','09:05:00',2.22),('12664','2013-05-24','09:10:00',3.12),('12664','2013-05-24','09:15:00',2.86),('12664','2013-05-24','09:25:00',1.34),('12664','2013-05-24','09:30:00',3.56),('12664','2013-05-24','09:35:00',2.56),('12664','2013-05-24','09:50:00',1.54),('12664','2013-05-24','09:55:00',4.13),('12664','2013-05-24','10:00:00',3.99),('12664','2013-05-24','10:15:00',1.37),('12664','2013-05-24','10:25:00',2.73),('12664','2013-05-24','10:30:00',4.11),('12664','2013-05-24','10:35:00',4.45),('12664','2013-05-24','10:40:00',4.57),('12664','2013-05-24','10:45:00',4.64),('12664','2013-05-24','10:50:00',4.64),('12664','2013-05-24','10:55:00',1.78),('12664','2013-05-24','11:00:00',3.1),('12664','2013-05-24','11:05:00',2.6),('12664','2013-05-24','11:10:00',2.96),('12664','2013-05-24','11:15:00',4.81),('12664','2013-05-24','11:20:00',3.88),('12664','2013-05-24','11:25:00',4.9),('12664','2013-05-24','11:30:00',4.29),('12664','2013-05-24','11:35:00',4.75),('12664','2013-05-24','11:40:00',2.19),('12664','2013-05-24','11:45:00',1.18),('12664','2013-05-24','11:50:00',3.3),('12664','2013-05-24','11:55:00',2.29),('12664','2013-05-24','12:00:00',3.07),('12664','2013-05-24','12:05:00',3.63),('12664','2013-05-24','12:10:00',3.41),('12664','2013-05-24','12:15:00',2.45),('12664','2013-05-24','12:20:00',2.07),('12664','2013-05-24','12:25:00',2.47),('12664','2013-05-24','12:30:00',2.35),('12664','2013-05-24','12:35:00',2.75),('12664','2013-05-24','12:40:00',2.75),('12664','2013-05-24','12:45:00',2.53),('12664','2013-05-24','12:50:00',3.34),('12664','2013-05-24','12:55:00',2.21),('12664','2013-05-24','13:00:00',3.02),('12664','2013-05-24','13:05:00',4.62),('12664','2013-05-24','13:10:00',4.93),('12664','2013-05-24','13:15:00',3.99),('12664','2013-05-24','13:20:00',3.45),('12664','2013-05-24','13:25:00',3.66),('12664','2013-05-24','13:30:00',4.95),('12664','2013-05-24','13:35:00',2.92),('12664','2013-05-24','13:40:00',1.6),('12664','2013-05-24','13:45:00',1.38),('12664','2013-05-24','13:50:00',3.86),('12664','2013-05-24','13:55:00',3.9),('12664','2013-05-24','14:00:00',4.59),('12664','2013-05-24','14:05:00',3.63),('12664','2013-05-24','14:10:00',1.8),('12664','2013-05-24','14:15:00',2.11),('12664','2013-05-24','14:20:00',3.42),('12664','2013-05-24','14:25:00',4.58),('12664','2013-05-24','14:30:00',4.92),('12664','2013-05-24','14:35:00',4.8),('12664','2013-05-24','14:40:00',2.84),('12664','2013-05-24','14:45:00',3.03),('12664','2013-05-24','14:50:00',1.71),('12664','2013-05-24','14:55:00',2.23),('12664','2013-05-24','15:00:00',2.37),('12664','2013-05-24','15:05:00',1.77),('12664','2013-05-24','15:10:00',3.53),('12664','2013-05-24','15:15:00',4.07),('12664','2013-05-24','15:20:00',2.65),('12664','2013-05-24','15:25:00',2.75),('12664','2013-05-24','15:30:00',2.75),('12664','2013-05-24','15:35:00',2.71),('12664','2013-05-24','15:40:00',3.59),('12664','2013-05-24','15:45:00',3.36),('12664','2013-05-24','15:50:00',2.21),('12664','2013-05-24','15:55:00',1.98),('12664','2013-05-24','16:00:00',1.89),('12664','2013-05-24','16:05:00',1.82),('12664','2013-05-24','16:10:00',1.63),('12664','2013-05-24','16:15:00',1.49),('12664','2013-05-24','16:20:00',1.68),('12664','2013-05-24','16:25:00',1.5),('12664','2013-05-24','16:30:00',1.3),('12664','2013-05-24','16:35:00',1.23),('12664','2013-05-24','16:40:00',1.21),('12664','2013-05-24','16:45:00',1.36),('12664','2013-05-24','16:50:00',1.18),('12664','2013-05-24','16:55:00',1.08),('12664','2013-05-24','17:00:00',1.15),('12664','2013-05-24','17:05:00',1.28),('12664','2013-05-24','17:10:00',1.32),('12664','2013-05-24','17:15:00',1.42),('12664','2013-05-24','17:25:00',1.26),('12664','2013-05-24','17:30:00',1.19),('12664','2013-05-24','17:35:00',1.09),('12664','2013-05-24','17:40:00',1.03),('12664','2013-05-23','07:00:00',1.11),('12664','2013-05-23','07:45:00',1.78),('12664','2013-05-23','07:50:00',1.02),('12664','2013-05-23','08:20:00',1.16),('12664','2013-05-23','08:25:00',1.67),('12664','2013-05-23','08:30:00',2.19),('12664','2013-05-23','08:35:00',1.92),('12664','2013-05-23','08:40:00',1.05),('12664','2013-05-23','08:45:00',1.79),('12664','2013-05-23','09:10:00',1.58),('12664','2013-05-23','09:15:00',1.75),('12664','2013-05-23','09:20:00',2.98),('12664','2013-05-23','09:25:00',3.55),('12664','2013-05-23','09:30:00',2.74),('12664','2013-05-23','09:35:00',2.51),('12664','2013-05-23','09:40:00',1.09),('12664','2013-05-23','09:45:00',2.34),('12664','2013-05-23','09:55:00',2.84),('12664','2013-05-23','10:00:00',2.32),('12664','2013-05-23','10:05:00',2.99),('12664','2013-05-23','10:10:00',3.62),('12664','2013-05-23','10:15:00',2.75),('12664','2013-05-23','10:20:00',3.73),('12664','2013-05-23','10:25:00',3.1),('12664','2013-05-23','10:30:00',1.77),('12664','2013-05-23','10:35:00',3.2),('12664','2013-05-23','10:40:00',2.27),('12664','2013-05-23','10:45:00',2.3),('12664','2013-05-23','10:50:00',2.94),('12664','2013-05-23','10:55:00',3.18),('12664','2013-05-23','11:00:00',1.74),('12664','2013-05-23','11:05:00',4.38),('12664','2013-05-23','11:10:00',2.56),('12664','2013-05-23','11:15:00',1.75),('12664','2013-05-23','11:20:00',1.36),('12664','2013-05-23','11:30:00',2.09),('12664','2013-05-23','11:35:00',2.95),('12664','2013-05-23','11:40:00',2.18),('12664','2013-05-23','11:45:00',1.41),('12664','2013-05-23','11:50:00',1.29),('12664','2013-05-23','11:55:00',1.97),('12664','2013-05-23','12:00:00',2.74),('12664','2013-05-23','12:05:00',2.01),('12664','2013-05-23','12:10:00',4.01),('12664','2013-05-23','12:15:00',4.58),('12664','2013-05-23','12:20:00',2.82),('12664','2013-05-23','12:25:00',2.64),('12664','2013-05-23','12:30:00',1.14),('12664','2013-05-23','12:35:00',3.25),('12664','2013-05-23','12:40:00',5),('12664','2013-05-23','12:45:00',5),('12664','2013-05-23','12:50:00',3.13),('12664','2013-05-23','12:55:00',4.12),('12664','2013-05-23','13:00:00',3.64),('12664','2013-05-23','13:05:00',4.82),('12664','2013-05-23','13:10:00',4.7),('12664','2013-05-23','13:15:00',4.61),('12664','2013-05-23','13:20:00',2.8),('12664','2013-05-23','13:25:00',4.59),('12664','2013-05-23','13:30:00',3.65),('12664','2013-05-23','13:35:00',4.9),('12664','2013-05-23','13:40:00',4.96),('12664','2013-05-23','13:45:00',4.82),('12664','2013-05-23','13:50:00',5.02),('12664','2013-05-23','13:55:00',3.8),('12664','2013-05-23','14:00:00',2.31),('12664','2013-05-23','14:05:00',3.35),('12664','2013-05-23','14:10:00',3.25),('12664','2013-05-23','14:15:00',3.82),('12664','2013-05-23','14:20:00',2.99),('12664','2013-05-23','14:25:00',3.05),('12664','2013-05-23','14:30:00',4.96),('12664','2013-05-23','14:35:00',5.02),('12664','2013-05-23','14:40:00',2.89),('12664','2013-05-23','14:45:00',3.92),('12664','2013-05-23','14:50:00',2.12),('12664','2013-05-23','14:55:00',4.69),('12664','2013-05-23','15:00:00',3.85),('12664','2013-05-23','15:05:00',3.49),('12664','2013-05-23','15:10:00',3.33),('12664','2013-05-23','15:15:00',2.46),('12664','2013-05-23','15:20:00',4.04),('12664','2013-05-23','15:25:00',2.16),('12664','2013-05-23','15:30:00',2.04),('12664','2013-05-23','15:35:00',2.59),('12664','2013-05-23','15:40:00',3.16),('12664','2013-05-23','15:45:00',4.28),('12664','2013-05-23','15:50:00',4.16),('12664','2013-05-23','15:55:00',3.44),('12664','2013-05-23','16:00:00',2.16),('12664','2013-05-23','16:05:00',3.25),('12664','2013-05-23','16:10:00',3.32),('12664','2013-05-23','16:15:00',2.88),('12664','2013-05-23','16:20:00',1.48),('12664','2013-05-23','16:25:00',1.23),('12664','2013-05-23','16:30:00',3.7),('12664','2013-05-23','16:35:00',1.07),('12664','2013-05-23','16:40:00',1.32),('12664','2013-05-23','16:45:00',1.81),('12664','2013-05-23','16:50:00',1.52),('12664','2013-05-23','16:55:00',2.23),('12664','2013-05-23','17:00:00',1.19),('12664','2013-05-23','17:15:00',1.25),('12664','2013-05-23','17:30:00',1.18),('12664','2013-05-23','17:35:00',1.56),('12664','2013-05-23','17:40:00',1.3),('12664','2013-05-23','17:45:00',1.83),('12664','2013-05-23','17:50:00',2.32),('12664','2013-05-23','17:55:00',1.47),('12664','2013-05-22','08:05:00',1.48),('12664','2013-05-22','08:10:00',1.42),('12664','2013-05-22','08:15:00',1.04),('12664','2013-05-22','08:20:00',1.32),('12664','2013-05-22','08:25:00',2.59),('12664','2013-05-22','08:30:00',2.29),('12664','2013-05-22','09:25:00',1.31),('12664','2013-05-22','09:30:00',2.74),('12664','2013-05-22','09:35:00',3.29),('12664','2013-05-22','09:40:00',3.22),('12664','2013-05-22','09:45:00',3.22),('12664','2013-05-22','09:50:00',3.25),('12664','2013-05-22','09:55:00',3.33),('12664','2013-05-22','10:00:00',3.42),('12664','2013-05-22','10:05:00',3.52),('12664','2013-05-22','10:10:00',3.57),('12664','2013-05-22','10:15:00',3.6),('12664','2013-05-22','10:20:00',3.67),('12664','2013-05-22','10:25:00',3.74),('12664','2013-05-22','10:30:00',3.71),('12664','2013-05-22','10:35:00',3.1),('12664','2013-05-22','10:40:00',2.16),('12664','2013-05-22','10:45:00',3.49),('12664','2013-05-22','10:50:00',4.06),('12664','2013-05-22','10:55:00',4.01),('12664','2013-05-22','11:00:00',4.06),('12664','2013-05-22','11:05:00',4.06),('12664','2013-05-22','11:10:00',4.08),('12664','2013-05-22','11:15:00',4.12),('12664','2013-05-22','11:20:00',4.16),('12664','2013-05-22','11:25:00',4.36),('12664','2013-05-22','11:30:00',4.32),('12664','2013-05-22','11:35:00',4.46),('12664','2013-05-22','11:40:00',3.68),('12664','2013-05-22','11:45:00',4.04),('12664','2013-05-22','11:50:00',3.86),('12664','2013-05-22','11:55:00',3.75),('12664','2013-05-22','12:00:00',2.34),('12664','2013-05-22','12:05:00',2.77),('12664','2013-05-22','12:10:00',2.06),('12664','2013-05-22','12:15:00',2.22),('12664','2013-05-22','12:20:00',4.7),('12664','2013-05-22','12:25:00',5.04),('12664','2013-05-22','12:30:00',2.97),('12664','2013-05-22','12:35:00',1.56),('12664','2013-05-22','12:40:00',1.37),('12664','2013-05-22','13:10:00',1.9),('12664','2013-05-22','13:15:00',2.29),('12664','2013-05-22','13:20:00',2.61),('12664','2013-05-22','13:25:00',1.35),('12664','2013-05-22','13:30:00',3.1),('12664','2013-05-22','13:35:00',2.91),('12664','2013-05-22','13:40:00',4.54),('12664','2013-05-22','13:45:00',3.77),('12664','2013-05-22','13:50:00',4.96),('12664','2013-05-22','13:55:00',3.94),('12664','2013-05-22','14:00:00',4.01),('12664','2013-05-22','14:05:00',4),('12664','2013-05-22','14:10:00',4.44),('12664','2013-05-22','14:15:00',4.33),('12664','2013-05-22','14:20:00',4.28),('12664','2013-05-22','14:25:00',4.26),('12664','2013-05-22','14:30:00',4.21),('12664','2013-05-22','14:35:00',4.17),('12664','2013-05-22','14:40:00',4.13),('12664','2013-05-22','14:45:00',4.11),('12664','2013-05-22','14:50:00',4.07),('12664','2013-05-22','14:55:00',4.01),('12664','2013-05-22','15:00:00',3.99),('12664','2013-05-22','15:05:00',3.97),('12664','2013-05-22','15:10:00',3.65),('12664','2013-05-22','15:15:00',3.85),('12664','2013-05-22','15:20:00',3.79),('12664','2013-05-22','15:25:00',3.84),('12664','2013-05-22','15:30:00',3.52),('12664','2013-05-22','15:35:00',3.97),('12664','2013-05-22','15:40:00',3.88),('12664','2013-05-22','15:45:00',3.66),('12664','2013-05-22','15:50:00',3.56),('12664','2013-05-22','15:55:00',3.44),('12664','2013-05-22','16:00:00',3.37),('12664','2013-05-22','16:05:00',3.31),('12664','2013-05-22','16:10:00',3.23),('12664','2013-05-22','16:15:00',3.19),('12664','2013-05-22','16:20:00',3.1),('12664','2013-05-22','16:25:00',3.09),('12664','2013-05-22','16:30:00',2.84),('12664','2013-05-22','16:35:00',3.11),('12664','2013-05-22','16:40:00',1.76),('12664','2013-05-22','16:45:00',2.7),('12664','2013-05-22','16:50:00',2.22),('12664','2013-05-22','17:25:00',1.23),('12664','2013-05-22','17:30:00',1.24),('12664','2013-05-22','17:35:00',1.47),('12664','2013-05-22','17:40:00',1.45),('12664','2013-05-22','17:45:00',1.38),('12664','2013-05-22','17:55:00',1.12),('12664','2013-05-22','18:00:00',1.12),('12664','2013-05-22','18:05:00',1.52),('12664','2013-05-22','18:10:00',1.43),('12664','2013-05-22','18:15:00',1.11),('12664','2013-05-22','18:35:00',1.16),('12664','2013-05-22','18:40:00',1.25),('12664','2013-05-22','18:45:00',1.26),('12664','2013-05-21','07:30:00',1.13),('12664','2013-05-21','07:35:00',1.47),('12664','2013-05-21','07:40:00',1.45),('12664','2013-05-21','07:50:00',1.07),('12664','2013-05-21','07:55:00',1.06),('12664','2013-05-21','08:00:00',1.05),('12664','2013-05-21','08:05:00',1.82),('12664','2013-05-21','08:10:00',1.75),('12664','2013-05-21','08:15:00',1.45),('12664','2013-05-21','08:20:00',1.5),('12664','2013-05-21','08:25:00',1.42),('12664','2013-05-21','08:30:00',1.24),('12664','2013-05-21','08:35:00',1.57),('12664','2013-05-21','08:40:00',1.45),('12664','2013-05-21','08:45:00',1.24),('12664','2013-05-21','08:50:00',1.27),('12664','2013-05-21','08:55:00',1.49),('12664','2013-05-21','09:00:00',1.42),('12664','2013-05-21','09:05:00',1.35),('12664','2013-05-21','09:10:00',1.73),('12664','2013-05-21','09:15:00',2),('12664','2013-05-21','09:20:00',2.45),('12664','2013-05-21','09:25:00',2.03),('12664','2013-05-21','09:30:00',1.93),('12664','2013-05-21','09:35:00',2.25),('12664','2013-05-21','09:40:00',1.82),('12664','2013-05-21','09:45:00',1.74),('12664','2013-05-21','09:50:00',1.79),('12664','2013-05-21','09:55:00',1.86),('12664','2013-05-21','10:00:00',2.16),('12664','2013-05-21','10:05:00',2.1),('12664','2013-05-21','10:10:00',1.88),('12664','2013-05-21','10:15:00',1.82),('12664','2013-05-21','10:20:00',1.9),('12664','2013-05-21','10:25:00',2.69),('12664','2013-05-21','10:30:00',1.82),('12664','2013-05-21','10:35:00',1.91),('12664','2013-05-21','10:40:00',2.79),('12664','2013-05-21','10:45:00',2.56),('12664','2013-05-21','10:50:00',2.38),('12664','2013-05-21','10:55:00',1.67),('12664','2013-05-21','11:00:00',1.39),('12664','2013-05-21','11:05:00',1.86),('12664','2013-05-21','11:10:00',2.48),('12664','2013-05-21','11:15:00',3.76),('12664','2013-05-21','11:20:00',3.25),('12664','2013-05-21','11:25:00',4.3),('12664','2013-05-21','11:30:00',2.73),('12664','2013-05-21','11:35:00',2.92),('12664','2013-05-21','11:40:00',3.06),('12664','2013-05-21','11:45:00',2.93),('12664','2013-05-21','11:50:00',3.18),('12664','2013-05-21','11:55:00',2.71),('12664','2013-05-21','12:00:00',2.35),('12664','2013-05-21','12:05:00',4.37),('12664','2013-05-21','12:10:00',3.15),('12664','2013-05-21','12:15:00',3.17),('12664','2013-05-21','12:20:00',2.33),('12664','2013-05-21','12:25:00',2.91),('12664','2013-05-21','12:30:00',2.71),('12664','2013-05-21','12:35:00',2.97),('12664','2013-05-21','12:40:00',3.2),('12664','2013-05-21','12:45:00',2.51),('12664','2013-05-21','12:50:00',3.76),('12664','2013-05-21','12:55:00',3.32),('12664','2013-05-21','13:00:00',3.25),('12664','2013-05-21','13:05:00',2.94),('12664','2013-05-21','13:10:00',3.7),('12664','2013-05-21','13:15:00',3.78),('12664','2013-05-21','13:20:00',3.23),('12664','2013-05-21','13:25:00',2.33),('12664','2013-05-21','13:30:00',1.56),('12664','2013-05-21','13:35:00',1.35),('12664','2013-05-21','13:40:00',1.19),('12664','2013-05-21','14:10:00',1.76),('12664','2013-05-21','14:15:00',2.16),('12664','2013-05-21','14:20:00',2.71),('12664','2013-05-21','14:25:00',4.72),('12664','2013-05-21','14:30:00',4.5),('12664','2013-05-21','14:35:00',2.85),('12664','2013-05-21','14:40:00',1.97),('12664','2013-05-21','14:45:00',1.18),('12664','2013-05-21','15:15:00',1.25),('12664','2013-05-21','15:20:00',1.7),('12664','2013-05-21','15:25:00',2.37),('12664','2013-05-21','15:30:00',4.08),('12664','2013-05-21','15:35:00',3.43),('12664','2013-05-21','15:40:00',2.24),('12664','2013-05-21','15:45:00',2.03),('12664','2013-05-21','15:50:00',1.22),('12664','2013-05-21','16:05:00',1.21),('12664','2013-05-21','16:10:00',1.05),('12664','2013-05-21','16:25:00',1.18),('12664','2013-05-21','16:30:00',1.53),('12664','2013-05-21','16:35:00',1.42),('12664','2013-05-21','16:40:00',1.32),('12664','2013-05-21','16:45:00',1.06),('12664','2014-03-31','08:25:00',1.04),('12664','2014-03-31','08:30:00',1.14),('12664','2014-03-31','08:35:00',1.22),('12664','2014-03-31','08:40:00',1.32),('12664','2014-03-31','08:45:00',1.44),('12664','2014-03-31','08:50:00',1.55),('12664','2014-03-31','08:55:00',1.65),('12664','2014-03-31','09:00:00',1.75),('12664','2014-03-31','09:05:00',1.83),('12664','2014-03-31','09:10:00',1.91),('12664','2014-03-31','09:15:00',1.99),('12664','2014-03-31','09:20:00',2.08),('12664','2014-03-31','09:25:00',2.16),('12664','2014-03-31','09:30:00',2.24),('12664','2014-03-31','09:35:00',2.32),('12664','2014-03-31','09:40:00',2.39),('12664','2014-03-31','09:45:00',2.48),('12664','2014-03-31','09:50:00',2.55),('12664','2014-03-31','09:55:00',2.6),('12664','2014-03-31','10:00:00',2.68),('12664','2014-03-31','10:05:00',2.73),('12664','2014-03-31','10:10:00',2.78),('12664','2014-03-31','10:15:00',2.84),('12664','2014-03-31','10:20:00',2.89),('12664','2014-03-31','10:25:00',2.97),('12664','2014-03-31','10:30:00',3.04),('12664','2014-03-31','10:35:00',3.1),('12664','2014-03-31','10:40:00',3.14),('12664','2014-03-31','10:45:00',3.2),('12664','2014-03-31','10:50:00',3.23),('12664','2014-03-31','10:55:00',3.31),('12664','2014-03-31','11:00:00',3.38),('12664','2014-03-31','11:05:00',3.41),('12664','2014-03-31','11:10:00',3.42),('12664','2014-03-31','11:15:00',3.46),('12664','2014-03-31','11:20:00',3.5),('12664','2014-03-31','11:25:00',3.53),('12664','2014-03-31','11:30:00',3.62),('12664','2014-03-31','11:35:00',3.63),('12664','2014-03-31','11:40:00',3.66),('12664','2014-03-31','11:45:00',3.69),('12664','2014-03-31','11:50:00',3.73),('12664','2014-03-31','11:55:00',3.76),('12664','2014-03-31','12:00:00',3.81),('12664','2014-03-31','12:05:00',3.81),('12664','2014-03-31','12:10:00',3.84),('12664','2014-03-31','12:15:00',3.84),('12664','2014-03-31','12:20:00',3.88),('12664','2014-03-31','12:25:00',3.95),('12664','2014-03-31','12:30:00',3.95),('12664','2014-03-31','12:35:00',3.94),('12664','2014-03-31','12:40:00',3.98),('12664','2014-03-31','12:45:00',3.99),('12664','2014-03-31','12:50:00',3.98),('12664','2014-03-31','12:55:00',3.96),('12664','2014-03-31','13:00:00',3.96),('12664','2014-03-31','13:05:00',4),('12664','2014-03-31','13:10:00',4),('12664','2014-03-31','13:15:00',3.98),('12664','2014-03-31','13:20:00',4.01),('12664','2014-03-31','13:25:00',4),('12664','2014-03-31','13:30:00',4),('12664','2014-03-31','13:35:00',4),('12664','2014-03-31','13:40:00',4),('12664','2014-03-31','13:45:00',4.01),('12664','2014-03-31','13:50:00',3.96),('12664','2014-03-31','13:55:00',3.94),('12664','2014-03-31','14:00:00',3.93),('12664','2014-03-31','14:05:00',3.91),('12664','2014-03-31','14:10:00',3.9),('12664','2014-03-31','14:15:00',3.88),('12664','2014-03-31','14:20:00',3.86),('12664','2014-03-31','14:25:00',3.84),('12664','2014-03-31','14:30:00',3.82),('12664','2014-03-31','14:35:00',3.79),('12664','2014-03-31','14:40:00',3.78),('12664','2014-03-31','14:45:00',3.74),('12664','2014-03-31','14:50:00',3.69),('12664','2014-03-31','14:55:00',3.66),('12664','2014-03-31','15:00:00',3.62),('12664','2014-03-31','15:05:00',3.59),('12664','2014-03-31','15:10:00',3.53),('12664','2014-03-31','15:15:00',3.46),('12664','2014-03-31','15:20:00',3.44),('12664','2014-03-31','15:25:00',3.37),('12664','2014-03-31','15:30:00',3.33),('12664','2014-03-31','15:35:00',3.28),('12664','2014-03-31','15:40:00',3.22),('12664','2014-03-31','15:45:00',3.11),('12664','2014-03-31','15:50:00',3.03),('12664','2014-03-31','15:55:00',3),('12664','2014-03-31','16:00:00',2.92),('12664','2014-03-31','16:05:00',2.85),('12664','2014-03-31','16:10:00',2.77),('12664','2014-03-31','16:15:00',2.75),('12664','2014-03-31','16:20:00',2.68),('12664','2014-03-31','16:25:00',2.61),('12664','2014-03-31','16:30:00',2.49),('12664','2014-03-31','16:35:00',2.41),('12664','2014-03-31','16:40:00',2.33),('12664','2014-03-31','16:45:00',2.23),('12664','2014-03-31','16:50:00',2.17),('12664','2014-03-31','16:55:00',2.09),('12664','2014-03-31','17:00:00',1.98),('12664','2014-03-31','17:05:00',1.9),('12664','2014-03-31','17:10:00',1.81),('12664','2014-03-31','17:15:00',1.74),('12664','2014-03-31','17:20:00',1.63),('12664','2014-03-31','17:25:00',1.53),('12664','2014-03-31','17:30:00',1.45),('12664','2014-03-31','17:35:00',1.35),('12664','2014-03-31','17:40:00',1.25),('12664','2014-03-31','17:45:00',1.14),('12664','2014-03-31','17:50:00',1.05),('12664','2013-05-20','07:15:00',1.06),('12664','2013-05-20','07:45:00',1.31),('12664','2013-05-20','07:50:00',1.18),('12664','2013-05-20','07:55:00',1),('12664','2013-05-20','08:05:00',1.54),('12664','2013-05-20','08:10:00',1.69),('12664','2013-05-20','08:15:00',1.97),('12664','2013-05-20','08:20:00',1.28),('12664','2013-05-20','08:30:00',1.86),('12664','2013-05-20','08:35:00',1.93),('12664','2013-05-20','08:55:00',2.98),('12664','2013-05-20','09:00:00',3.11),('12664','2013-05-20','09:05:00',3.24),('12664','2013-05-20','09:10:00',3.18),('12664','2013-05-20','09:15:00',3.2),('12664','2013-05-20','09:20:00',1.84),('12664','2013-05-20','09:25:00',1.61),('12664','2013-05-20','09:30:00',3.74),('12664','2013-05-20','09:35:00',3.51),('12664','2013-05-20','09:40:00',2.27),('12664','2013-05-20','09:45:00',1.6),('12664','2013-05-20','09:50:00',2.64),('12664','2013-05-20','09:55:00',2.73),('12664','2013-05-20','10:00:00',3.48),('12664','2013-05-20','10:05:00',2.67),('12664','2013-05-20','10:10:00',2.63),('12664','2013-05-20','10:15:00',4.12),('12664','2013-05-20','10:20:00',4.24),('12664','2013-05-20','10:25:00',4.36),('12664','2013-05-20','10:30:00',3.78),('12664','2013-05-20','10:35:00',3.75),('12664','2013-05-20','10:40:00',4.38),('12664','2013-05-20','10:45:00',3.99),('12664','2013-05-20','10:50:00',4.57),('12664','2013-05-20','10:55:00',4.1),('12664','2013-05-20','11:00:00',3.24),('12664','2013-05-20','11:05:00',3.69),('12664','2013-05-20','11:10:00',2.32),('12664','2013-05-20','11:15:00',4.17),('12664','2013-05-20','11:20:00',2.24),('12664','2013-05-20','11:25:00',1.33),('12664','2013-05-20','11:30:00',4.08),('12664','2013-05-20','11:35:00',2.2),('12664','2013-05-20','11:40:00',3.09),('12664','2013-05-20','11:45:00',4.89),('12664','2013-05-20','11:50:00',3.48),('12664','2013-05-20','11:55:00',4.81),('12664','2013-05-20','12:00:00',4.71),('12664','2013-05-20','12:05:00',4.79),('12664','2013-05-20','12:10:00',4.59),('12664','2013-05-20','12:15:00',4.64),('12664','2013-05-20','12:20:00',4.76),('12664','2013-05-20','12:25:00',4.86),('12664','2013-05-20','12:30:00',4.79),('12664','2013-05-20','12:35:00',4.81),('12664','2013-05-20','12:40:00',4.83),('12664','2013-05-20','12:45:00',4.84),('12664','2013-05-20','12:50:00',4.83),('12664','2013-05-20','12:55:00',4.81),('12664','2013-05-20','13:00:00',4.81),('12664','2013-05-20','13:05:00',4.84),('12664','2013-05-20','13:10:00',4.86),('12664','2013-05-20','13:15:00',4.8),('12664','2013-05-20','13:20:00',4.82),('12664','2013-05-20','13:25:00',4.8),('12664','2013-05-20','13:30:00',4.79),('12664','2013-05-20','13:35:00',4.79),('12664','2013-05-20','13:40:00',4.78),('12664','2013-05-20','13:45:00',4.78),('12664','2013-05-20','13:50:00',4.75),('12664','2013-05-20','13:55:00',4.47),('12664','2013-05-20','14:00:00',4.26),('12664','2013-05-20','14:05:00',4.67),('12664','2013-05-20','14:10:00',4.65),('12664','2013-05-20','14:15:00',4.59),('12664','2013-05-20','14:20:00',4.59),('12664','2013-05-20','14:25:00',4.57),('12664','2013-05-20','14:30:00',4.5),('12664','2013-05-20','14:35:00',4.44),('12664','2013-05-20','14:40:00',4.43),('12664','2013-05-20','14:45:00',4.38),('12664','2013-05-20','14:50:00',4.38),('12664','2013-05-20','14:55:00',4.36),('12664','2013-05-20','15:00:00',4.31),('12664','2013-05-20','15:05:00',4.27),('12664','2013-05-20','15:10:00',4.23),('12664','2013-05-20','15:15:00',4.15),('12664','2013-05-20','15:20:00',4.11),('12664','2013-05-20','15:25:00',4.05),('12664','2013-05-20','15:30:00',3.98),('12664','2013-05-20','15:35:00',3.91),('12664','2013-05-20','15:40:00',3.87),('12664','2013-05-20','15:45:00',3.82),('12664','2013-05-20','15:50:00',3.78),('12664','2013-05-20','15:55:00',3.73),('12664','2013-05-20','16:00:00',3.66),('12664','2013-05-20','16:05:00',3.59),('12664','2013-05-20','16:10:00',3.52),('12664','2013-05-20','16:15:00',3.44),('12664','2013-05-20','16:20:00',3.39),('12664','2013-05-20','16:25:00',3.34),('12664','2013-05-20','16:30:00',3.25),('12664','2013-05-20','16:35:00',3.09),('12664','2013-05-20','16:40:00',2.9),('12664','2013-05-20','16:45:00',2.87),('12664','2013-05-20','16:50:00',2.99),('12664','2013-05-20','16:55:00',2.21),('12664','2013-05-20','17:00:00',2.05),('12664','2013-05-20','17:05:00',2.39),('12664','2013-05-20','17:10:00',2.12),('12664','2013-05-20','17:15:00',1.75),('12664','2013-05-20','17:20:00',2.8),('12664','2013-05-20','17:25:00',2.43),('12664','2013-05-20','17:30:00',2.23),('12664','2013-05-20','17:35:00',1.96),('12664','2013-05-20','17:40:00',1.97),('12664','2013-05-20','17:45:00',1.87),('12664','2013-05-20','17:50:00',1.78),('12664','2013-05-20','17:55:00',1.71),('12664','2013-05-20','18:00:00',1.42),('12664','2013-05-20','18:05:00',1.39),('12664','2013-05-20','18:10:00',1.55),('12664','2013-05-20','18:15:00',1.33),('12664','2013-05-20','18:20:00',1.2),('12664','2013-05-20','18:25:00',1.09),('12664','2013-05-19','08:25:00',1.07),('12664','2013-05-19','08:30:00',1.32),('12664','2013-05-19','08:35:00',1.24),('12664','2013-05-19','08:40:00',1.15),('12664','2013-05-19','08:45:00',1),('12664','2013-05-19','08:50:00',1.14),('12664','2013-05-19','08:55:00',1.29),('12664','2013-05-19','09:05:00',1.12),('12664','2013-05-19','09:25:00',1.34),('12664','2013-05-19','09:30:00',1.48),('12664','2013-05-19','09:35:00',1.23),('12664','2013-05-19','09:40:00',1.33),('12664','2013-05-19','09:45:00',1.67),('12664','2013-05-19','09:50:00',1.49),('12664','2013-05-19','09:55:00',1.94),('12664','2013-05-19','10:00:00',2.16),('12664','2013-05-19','10:05:00',2.18),('12664','2013-05-19','10:10:00',2.37),('12664','2013-05-19','10:15:00',2.79),('12664','2013-05-19','10:20:00',4.12),('12664','2013-05-19','10:25:00',3.64),('12664','2013-05-19','10:30:00',3.12),('12664','2013-05-19','10:35:00',3.34),('12664','2013-05-19','10:40:00',2.02),('12664','2013-05-19','10:45:00',2.33),('12664','2013-05-19','10:50:00',4.09),('12664','2013-05-19','10:55:00',4.68),('12664','2013-05-19','11:00:00',3.03),('12664','2013-05-19','11:05:00',3.26),('12664','2013-05-19','11:10:00',3.89),('12664','2013-05-19','11:15:00',4.74),('12664','2013-05-19','11:20:00',4),('12664','2013-05-19','11:25:00',4.03),('12664','2013-05-19','11:30:00',4.69),('12664','2013-05-19','11:35:00',4.66),('12664','2013-05-19','11:40:00',4.69),('12664','2013-05-19','11:45:00',4.72),('12664','2013-05-19','11:50:00',4.77),('12664','2013-05-19','11:55:00',4.82),('12664','2013-05-19','12:00:00',4.8),('12664','2013-05-19','12:05:00',4.8),('12664','2013-05-19','12:10:00',4.82),('12664','2013-05-19','12:15:00',4.86),('12664','2013-05-19','12:20:00',4.89),('12664','2013-05-19','12:25:00',4.93),('12664','2013-05-19','12:30:00',4.9),('12664','2013-05-19','12:35:00',4.92),('12664','2013-05-19','12:40:00',4.98),('12664','2013-05-19','12:45:00',5.02),('12664','2013-05-19','12:50:00',4.99),('12664','2013-05-19','12:55:00',4.95),('12664','2013-05-19','13:00:00',4.93),('12664','2013-05-19','13:05:00',4.9),('12664','2013-05-19','13:10:00',4.85),('12664','2013-05-19','13:15:00',4.83),('12664','2013-05-19','13:20:00',4.87),('12664','2013-05-19','13:25:00',4.84),('12664','2013-05-19','13:30:00',4.83),('12664','2013-05-19','13:35:00',4.81),('12664','2013-05-19','13:40:00',4.81),('12664','2013-05-19','13:45:00',4.82),('12664','2013-05-19','13:50:00',4.81),('12664','2013-05-19','13:55:00',4.8),('12664','2013-05-19','14:00:00',4.78),('12664','2013-05-19','14:05:00',4.73),('12664','2013-05-19','14:10:00',4.74),('12664','2013-05-19','14:15:00',4.48),('12664','2013-05-19','14:20:00',3.97),('12664','2013-05-19','14:25:00',4.67),('12664','2013-05-19','14:30:00',4.06),('12664','2013-05-19','14:35:00',4.55),('12664','2013-05-19','14:40:00',4.52),('12664','2013-05-19','14:45:00',4.5),('12664','2013-05-19','14:50:00',3.8),('12664','2013-05-19','14:55:00',4.4),('12664','2013-05-19','15:00:00',4.27),('12664','2013-05-19','15:05:00',4.39),('12664','2013-05-19','15:10:00',4.32),('12664','2013-05-19','15:15:00',4.27),('12664','2013-05-19','15:20:00',4.19),('12664','2013-05-19','15:25:00',4.14),('12664','2013-05-19','15:30:00',4.09),('12664','2013-05-19','15:35:00',3.21),('12664','2013-05-19','15:40:00',3.96),('12664','2013-05-19','15:45:00',3.93),('12664','2013-05-19','15:50:00',3.87),('12664','2013-05-19','15:55:00',3.79),('12664','2013-05-19','16:00:00',3.75),('12664','2013-05-19','16:05:00',3.67),('12664','2013-05-19','16:10:00',3.59),('12664','2013-05-19','16:15:00',3.54),('12664','2013-05-19','16:20:00',3.46),('12664','2013-05-19','16:25:00',3.4),('12664','2013-05-19','16:30:00',3.32),('12664','2013-05-19','16:35:00',3.24),('12664','2013-05-19','16:40:00',3.17),('12664','2013-05-19','16:45:00',3.08),('12664','2013-05-19','16:50:00',2.98),('12664','2013-05-19','16:55:00',2.93),('12664','2013-05-19','17:00:00',2.83),('12664','2013-05-19','17:05:00',2.74),('12664','2013-05-19','17:10:00',2.64),('12664','2013-05-19','17:15:00',2.56),('12664','2013-05-19','17:20:00',2.48),('12664','2013-05-19','17:25:00',2.38),('12664','2013-05-19','17:30:00',2.3),('12664','2013-05-19','17:35:00',2.2),('12664','2013-05-19','17:40:00',2.09),('12664','2013-05-19','17:45:00',1.99),('12664','2013-05-19','17:50:00',1.89),('12664','2013-05-19','17:55:00',1.8),('12664','2013-05-19','18:00:00',1.7),('12664','2013-05-19','18:05:00',1.6),('12664','2013-05-19','18:10:00',1.46),('12664','2013-05-19','18:15:00',1.35),('12664','2013-05-19','18:20:00',1.26),('12664','2013-05-19','18:25:00',1.16),('12664','2013-05-19','18:30:00',1.06),('12664','2013-05-18','07:35:00',1.06),('12664','2013-05-18','07:40:00',1.18),('12664','2013-05-18','07:45:00',1.17),('12664','2013-05-18','07:50:00',1.55),('12664','2013-05-18','07:55:00',1.7),('12664','2013-05-18','08:00:00',1.99),('12664','2013-05-18','08:05:00',1.27),('12664','2013-05-18','08:15:00',1.08),('12664','2013-05-18','08:20:00',1.38),('12664','2013-05-18','08:25:00',1.6),('12664','2013-05-18','08:30:00',1.57),('12664','2013-05-18','08:35:00',1.55),('12664','2013-05-18','08:40:00',2.21),('12664','2013-05-18','08:45:00',2.48),('12664','2013-05-18','08:50:00',2.52),('12664','2013-05-18','08:55:00',2.28),('12664','2013-05-18','09:00:00',2.61),('12664','2013-05-18','09:05:00',2.79),('12664','2013-05-18','09:10:00',2.88),('12664','2013-05-18','09:15:00',2.92),('12664','2013-05-18','09:20:00',2.97),('12664','2013-05-18','09:25:00',3.04),('12664','2013-05-18','09:30:00',3.11),('12664','2013-05-18','09:35:00',3.19),('12664','2013-05-18','09:40:00',3.25),('12664','2013-05-18','09:45:00',3.31),('12664','2013-05-18','09:50:00',3.38),('12664','2013-05-18','09:55:00',3.45),('12664','2013-05-18','10:00:00',3.5),('12664','2013-05-18','10:05:00',3.54),('12664','2013-05-18','10:10:00',3.62),('12664','2013-05-18','10:15:00',3.66),('12664','2013-05-18','10:20:00',3.69),('12664','2013-05-18','10:25:00',3.74),('12664','2013-05-18','10:30:00',3.79),('12664','2013-05-18','10:35:00',3.84),('12664','2013-05-18','10:40:00',3.87),('12664','2013-05-18','10:45:00',3.95),('12664','2013-05-18','10:50:00',4.02),('12664','2013-05-18','10:55:00',4.13),('12664','2013-05-18','11:00:00',4.26),('12664','2013-05-18','11:05:00',4.57),('12664','2013-05-18','11:10:00',3.78),('12664','2013-05-18','11:15:00',3.7),('12664','2013-05-18','11:20:00',3.89),('12664','2013-05-18','11:25:00',3.29),('12664','2013-05-18','11:30:00',4.34),('12664','2013-05-18','11:35:00',4.2),('12664','2013-05-18','11:40:00',4.24),('12664','2013-05-18','11:45:00',4.29),('12664','2013-05-18','11:50:00',4.28),('12664','2013-05-18','11:55:00',4.3),('12664','2013-05-18','12:00:00',4.31),('12664','2013-05-18','12:05:00',4.31),('12664','2013-05-18','12:10:00',4.34),('12664','2013-05-18','12:15:00',4.31),('12664','2013-05-18','12:20:00',4.34),('12664','2013-05-18','12:25:00',4.42),('12664','2013-05-18','12:30:00',4.42),('12664','2013-05-18','12:35:00',4.4),('12664','2013-05-18','12:40:00',4.4),('12664','2013-05-18','12:45:00',4.4),('12664','2013-05-18','12:50:00',4.39),('12664','2013-05-18','12:55:00',4.36),('12664','2013-05-18','13:00:00',4.37),('12664','2013-05-18','13:05:00',4.37),('12664','2013-05-18','13:10:00',4.37),('12664','2013-05-18','13:15:00',4.36),('12664','2013-05-18','13:20:00',4.36),('12664','2013-05-18','13:25:00',4.34),('12664','2013-05-18','13:30:00',4.35),('12664','2013-05-18','13:35:00',4.37),('12664','2013-05-18','13:40:00',4.37),('12664','2013-05-18','13:45:00',4.37),('12664','2013-05-18','13:50:00',4.36),('12664','2013-05-18','13:55:00',4.35),('12664','2013-05-18','14:00:00',4.67),('12664','2013-05-18','14:05:00',3.82),('12664','2013-05-18','14:10:00',3.35),('12664','2013-05-18','14:15:00',3.54),('12664','2013-05-18','14:20:00',3.42),('12664','2013-05-18','14:25:00',3.54),('12664','2013-05-18','14:30:00',4.01),('12664','2013-05-18','14:35:00',4.15),('12664','2013-05-18','14:40:00',4.23),('12664','2013-05-18','14:45:00',3.01),('12664','2013-05-18','14:50:00',3.21),('12664','2013-05-18','14:55:00',3.24),('12664','2013-05-18','15:00:00',3.81),('12664','2013-05-18','15:05:00',3.82),('12664','2013-05-18','15:10:00',3.73),('12664','2013-05-18','15:15:00',3.67),('12664','2013-05-18','15:20:00',3.61),('12664','2013-05-18','15:25:00',3.55),('12664','2013-05-18','15:30:00',3.54),('12664','2013-05-18','15:35:00',3.38),('12664','2013-05-18','15:40:00',3.46),('12664','2013-05-18','15:45:00',3.35),('12664','2013-05-18','15:50:00',3.28),('12664','2013-05-18','15:55:00',3.2),('12664','2013-05-18','16:00:00',3.14),('12664','2013-05-18','16:05:00',3.1),('12664','2013-05-18','16:10:00',3.04),('12664','2013-05-18','16:15:00',2.94),('12664','2013-05-18','16:20:00',2.87),('12664','2013-05-18','16:25:00',2.8),('12664','2013-05-18','16:30:00',2.77),('12664','2013-05-18','16:35:00',2.67),('12664','2013-05-18','16:40:00',2.61),('12664','2013-05-18','16:45:00',2.53),('12664','2013-05-18','16:50:00',2.45),('12664','2013-05-18','16:55:00',2.39),('12664','2013-05-18','17:00:00',2.29),('12664','2013-05-18','17:05:00',2.24),('12664','2013-05-18','17:10:00',2.17),('12664','2013-05-18','17:15:00',2.08),('12664','2013-05-18','17:20:00',2),('12664','2013-05-18','17:25:00',1.92),('12664','2013-05-18','17:30:00',1.84),('12664','2013-05-18','17:35:00',1.75),('12664','2013-05-18','17:40:00',1.68),('12664','2013-05-18','17:45:00',1.6),('12664','2013-05-18','17:50:00',1.52),('12664','2013-05-18','17:55:00',1.44),('12664','2013-05-18','18:00:00',1.36),('12664','2013-05-18','18:05:00',1.27),('12664','2013-05-18','18:10:00',1.18),('12664','2013-05-18','18:15:00',1.09),('12664','2013-05-18','18:20:00',1.02),('12664','2013-05-17','07:40:00',1.19),('12664','2013-05-17','07:45:00',1.35),('12664','2013-05-17','07:50:00',1.68),('12664','2013-05-17','07:55:00',1.54),('12664','2013-05-17','08:00:00',1.1),('12664','2013-05-17','08:05:00',1.65),('12664','2013-05-17','08:10:00',2.13),('12664','2013-05-17','08:15:00',2.05),('12664','2013-05-17','08:20:00',1.65),('12664','2013-05-17','09:10:00',1.04),('12664','2013-05-17','09:15:00',1.43),('12664','2013-05-17','09:20:00',1.05),('12664','2013-05-17','10:15:00',1.01),('12664','2013-05-17','10:20:00',1.23),('12664','2013-05-17','10:25:00',1.21),('12664','2013-05-17','10:30:00',1.31),('12664','2013-05-17','10:35:00',1.28),('12664','2013-05-17','10:40:00',1.73),('12664','2013-05-17','10:45:00',3.02),('12664','2013-05-17','10:50:00',3.36),('12664','2013-05-17','10:55:00',3.18),('12664','2013-05-17','11:00:00',2.01),('12664','2013-05-17','11:05:00',1.84),('12664','2013-05-17','11:10:00',3.28),('12664','2013-05-17','11:15:00',3.64),('12664','2013-05-17','11:20:00',2.85),('12664','2013-05-17','11:25:00',3.99),('12664','2013-05-17','11:30:00',3.18),('12664','2013-05-17','11:35:00',2.65),('12664','2013-05-17','11:40:00',2.37),('12664','2013-05-17','11:45:00',3.33),('12664','2013-05-17','11:50:00',4.71),('12664','2013-05-17','11:55:00',4.45),('12664','2013-05-17','12:00:00',4.64),('12664','2013-05-17','12:05:00',4.73),('12664','2013-05-17','12:10:00',4.91),('12664','2013-05-17','12:15:00',4.11),('12664','2013-05-17','12:20:00',4.02),('12664','2013-05-17','12:25:00',2.93),('12664','2013-05-17','12:30:00',3.72),('12664','2013-05-17','12:35:00',3.86),('12664','2013-05-17','12:40:00',3.91),('12664','2013-05-17','12:45:00',4.28),('12664','2013-05-17','12:50:00',3.77),('12664','2013-05-17','12:55:00',3.69),('12664','2013-05-17','13:00:00',1.14),('12664','2013-05-17','13:05:00',1.25),('12664','2013-05-17','13:15:00',1.46),('12664','2013-05-17','13:20:00',3.09),('12664','2013-05-17','13:25:00',4.08),('12664','2013-05-17','13:30:00',3.08),('12664','2013-05-17','13:35:00',4.06),('12664','2013-05-17','13:40:00',3.86),('12664','2013-05-17','13:45:00',3.8),('12664','2013-05-17','13:50:00',4.15),('12664','2013-05-17','13:55:00',4.03),('12664','2013-05-17','14:00:00',4.18),('12664','2013-05-17','14:05:00',3.94),('12664','2013-05-17','14:10:00',4.18),('12664','2013-05-17','14:15:00',4.1),('12664','2013-05-17','14:20:00',4.27),('12664','2013-05-17','14:25:00',2.98),('12664','2013-05-17','14:30:00',4.34),('12664','2013-05-17','14:35:00',3.48),('12664','2013-05-17','14:40:00',3.86),('12664','2013-05-17','14:45:00',3.7),('12664','2013-05-17','14:50:00',3.33),('12664','2013-05-17','14:55:00',4.17),('12664','2013-05-17','15:00:00',4.27),('12664','2013-05-17','15:05:00',3.52),('12664','2013-05-17','15:10:00',4.2),('12664','2013-05-17','15:15:00',4.32),('12664','2013-05-17','15:20:00',4.22),('12664','2013-05-17','15:25:00',4.21),('12664','2013-05-17','15:30:00',4.11),('12664','2013-05-17','15:35:00',4.08),('12664','2013-05-17','15:40:00',3.77),('12664','2013-05-17','15:45:00',4.03),('12664','2013-05-17','15:50:00',3.77),('12664','2013-05-17','15:55:00',3.77),('12664','2013-05-17','16:00:00',3.73),('12664','2013-05-17','16:05:00',3.6),('12664','2013-05-17','16:10:00',3.55),('12664','2013-05-17','16:15:00',3.47),('12664','2013-05-17','16:20:00',3.44),('12664','2013-05-17','16:25:00',3.41),('12664','2013-05-17','16:30:00',3.08),('12664','2013-05-17','16:35:00',3.24),('12664','2013-05-17','16:40:00',3.13),('12664','2013-05-17','16:45:00',3.05),('12664','2013-05-17','16:50:00',2.97),('12664','2013-05-17','16:55:00',2.79),('12664','2013-05-17','17:00:00',2.83),('12664','2013-05-17','17:05:00',2.88),('12664','2013-05-17','17:10:00',2.72),('12664','2013-05-17','17:15:00',2.6),('12664','2013-05-17','17:20:00',2.44),('12664','2013-05-17','17:25:00',2.3),('12664','2013-05-17','17:30:00',2.22),('12664','2013-05-17','17:35:00',2.14),('12664','2013-05-17','17:40:00',2.06),('12664','2013-05-17','17:45:00',1.94),('12664','2013-05-17','17:50:00',1.82),('12664','2013-05-17','17:55:00',1.72),('12664','2013-05-17','18:00:00',1.62),('12664','2013-05-17','18:05:00',1.51),('12664','2013-05-17','18:10:00',1.42),('12664','2013-05-17','18:15:00',1.33),('12664','2013-05-17','18:20:00',1.22),('12664','2013-05-17','18:25:00',1.12),('12664','2013-05-17','18:30:00',1.02),('12664','2013-05-16','09:20:00',1.26),('12664','2013-05-16','09:25:00',1.9),('12664','2013-05-16','09:30:00',1.67),('12664','2013-05-16','09:35:00',1.89),('12664','2013-05-16','09:40:00',2.35),('12664','2013-05-16','09:45:00',3.5),('12664','2013-05-16','09:50:00',2.99),('12664','2013-05-16','09:55:00',1.11),('12664','2013-05-16','10:00:00',2.1),('12664','2013-05-16','10:05:00',1.44),('12664','2013-05-16','10:10:00',1.27),('12664','2013-05-16','10:15:00',1.58),('12664','2013-05-16','10:20:00',2.56),('12664','2013-05-16','10:25:00',1.41),('12664','2013-05-16','10:30:00',1.85),('12664','2013-05-16','10:35:00',1.75),('12664','2013-05-16','10:40:00',2.44),('12664','2013-05-16','10:45:00',3.3),('12664','2013-05-16','10:50:00',2.08),('12664','2013-05-16','10:55:00',1.79),('12664','2013-05-16','11:00:00',2.54),('12664','2013-05-16','11:05:00',3.37),('12664','2013-05-16','11:10:00',2.86),('12664','2013-05-16','11:15:00',3.79),('12664','2013-05-16','11:20:00',3.2),('12664','2013-05-16','11:25:00',2.14),('12664','2013-05-16','11:30:00',2.43),('12664','2013-05-16','11:35:00',2.23),('12664','2013-05-16','11:40:00',3.93),('12664','2013-05-16','11:45:00',4.46),('12664','2013-05-16','11:50:00',4.7),('12664','2013-05-16','11:55:00',3.64),('12664','2013-05-16','12:00:00',1.87),('12664','2013-05-16','12:05:00',1.34),('12664','2013-05-16','12:10:00',1.26),('12664','2013-05-16','12:15:00',1.25),('12664','2013-05-16','12:20:00',1.68),('12664','2013-05-16','12:25:00',2.03),('12664','2013-05-16','12:30:00',2.69),('12664','2013-05-16','12:35:00',4.89),('12664','2013-05-16','12:40:00',4.63),('12664','2013-05-16','12:45:00',3.39),('12664','2013-05-16','12:50:00',3.34),('12664','2013-05-16','12:55:00',4.62),('12664','2013-05-16','13:00:00',4.39),('12664','2013-05-16','13:05:00',4.34),('12664','2013-05-16','13:10:00',4.38),('12664','2013-05-16','13:15:00',4.36),('12664','2013-05-16','13:20:00',4.3),('12664','2013-05-16','13:25:00',4.34),('12664','2013-05-16','13:30:00',4.3),('12664','2013-05-16','13:35:00',4.29),('12664','2013-05-16','13:40:00',4.3),('12664','2013-05-16','13:45:00',4.27),('12664','2013-05-16','13:50:00',4.21),('12664','2013-05-16','13:55:00',4.23),('12664','2013-05-16','14:00:00',4.23),('12664','2013-05-16','14:05:00',4.15),('12664','2013-05-16','14:10:00',4.13),('12664','2013-05-16','14:15:00',4.08),('12664','2013-05-16','14:20:00',4.07),('12664','2013-05-16','14:25:00',4.07),('12664','2013-05-16','14:30:00',4),('12664','2013-05-16','14:35:00',3.91),('12664','2013-05-16','14:40:00',3.88),('12664','2013-05-16','14:45:00',3.88),('12664','2013-05-16','14:50:00',3.87),('12664','2013-05-16','14:55:00',3.82),('12664','2013-05-16','15:00:00',3.79),('12664','2013-05-16','15:05:00',3.74),('12664','2013-05-16','15:10:00',3.72),('12664','2013-05-16','15:15:00',3.05),('12664','2013-05-16','15:20:00',3.01),('12664','2013-05-16','15:25:00',3.44),('12664','2013-05-16','15:30:00',3.46),('12664','2013-05-16','15:35:00',3.35),('12664','2013-05-16','15:40:00',3.37),('12664','2013-05-16','15:45:00',3.32),('12664','2013-05-16','15:50:00',3.28),('12664','2013-05-16','15:55:00',3.16),('12664','2013-05-16','16:00:00',3.07),('12664','2013-05-16','16:05:00',2.9),('12664','2013-05-16','16:10:00',3.01),('12664','2013-05-16','16:15:00',2.58),('12664','2013-05-16','16:20:00',2.73),('12664','2013-05-16','16:25:00',2.76),('12664','2013-05-16','16:30:00',2.68),('12664','2013-05-16','16:35:00',2.65),('12664','2013-05-16','16:40:00',2.65),('12664','2013-05-16','16:45:00',2.23),('12664','2013-05-16','16:50:00',1.75),('12664','2013-05-16','16:55:00',1.84),('12664','2013-05-16','17:00:00',1.66),('12664','2013-05-16','17:05:00',1.3),('12664','2013-05-16','17:10:00',1.26),('12664','2013-05-16','17:15:00',1.3),('12664','2013-05-16','17:20:00',1.42),('12664','2013-05-16','17:25:00',1.92),('12664','2013-05-16','17:30:00',1.8),('12664','2013-05-16','17:35:00',1.08),('12664','2013-05-16','18:20:00',1.02),('12664','2013-05-16','18:25:00',1.09),('12664','2013-05-16','18:30:00',1.12),('12664','2013-05-16','18:35:00',1.12),('12664','2013-05-16','18:40:00',1.12),('12664','2013-05-16','18:45:00',1.12),('12664','2013-05-16','18:50:00',1.02),('12664','2013-05-15','07:35:00',1.1),('12664','2013-05-15','07:40:00',1.19),('12664','2013-05-15','07:45:00',1.24),('12664','2013-05-15','07:50:00',1.5),('12664','2013-05-15','07:55:00',1.48),('12664','2013-05-15','08:00:00',1.32),('12664','2013-05-15','08:05:00',1.34),('12664','2013-05-15','08:10:00',1.71),('12664','2013-05-15','08:15:00',1.78),('12664','2013-05-15','08:20:00',1.9),('12664','2013-05-15','08:25:00',1.85),('12664','2013-05-15','08:30:00',2.02),('12664','2013-05-15','08:35:00',2.19),('12664','2013-05-15','08:40:00',2.29),('12664','2013-05-15','08:45:00',2.36),('12664','2013-05-15','08:50:00',2.43),('12664','2013-05-15','08:55:00',2.42),('12664','2013-05-15','09:00:00',2.53),('12664','2013-05-15','09:05:00',2.52),('12664','2013-05-15','09:10:00',2.62),('12664','2013-05-15','09:15:00',2.67),('12664','2013-05-15','09:20:00',2.68),('12664','2013-05-15','09:25:00',2.88),('12664','2013-05-15','09:30:00',3.02),('12664','2013-05-15','09:35:00',2.97),('12664','2013-05-15','09:40:00',3.02),('12664','2013-05-15','09:45:00',3.18),('12664','2013-05-15','09:50:00',3.24),('12664','2013-05-15','09:55:00',3.35),('12664','2013-05-15','10:00:00',3.38),('12664','2013-05-15','10:05:00',3.47),('12664','2013-05-15','10:10:00',3.41),('12664','2013-05-15','10:15:00',3.56),('12664','2013-05-15','10:20:00',3.66),('12664','2013-05-15','10:25:00',3.75),('12664','2013-05-15','10:30:00',3.7),('12664','2013-05-15','10:35:00',3.65),('12664','2013-05-15','10:40:00',3.7),('12664','2013-05-15','10:45:00',3.8),('12664','2013-05-15','10:50:00',3.93),('12664','2013-05-15','10:55:00',3.88),('12664','2013-05-15','11:00:00',3.9),('12664','2013-05-15','11:05:00',4.01),('12664','2013-05-15','11:10:00',4.05),('12664','2013-05-15','11:15:00',3.89),('12664','2013-05-15','11:20:00',4),('12664','2013-05-15','11:25:00',4.32),('12664','2013-05-15','11:30:00',4.19),('12664','2013-05-15','11:35:00',4.46),('12664','2013-05-15','11:40:00',4.38),('12664','2013-05-15','11:45:00',4.17),('12664','2013-05-15','11:50:00',2.5),('12664','2013-05-15','11:55:00',3.25),('12664','2013-05-15','12:00:00',4.26),('12664','2013-05-15','12:05:00',4.29),('12664','2013-05-15','12:10:00',4.79),('12664','2013-05-15','12:15:00',3.6),('12664','2013-05-15','12:20:00',3.77),('12664','2013-05-15','12:25:00',4.39),('12664','2013-05-15','12:30:00',4.45),('12664','2013-05-15','12:35:00',3.98),('12664','2013-05-15','12:40:00',3.06),('12664','2013-05-15','12:45:00',2.58),('12664','2013-05-15','12:50:00',2.6),('12664','2013-05-15','12:55:00',2.54),('12664','2013-05-15','13:00:00',2.47),('12664','2013-05-15','13:05:00',2.7),('12664','2013-05-15','13:10:00',2.7),('12664','2013-05-15','13:15:00',2.6),('12664','2013-05-15','13:20:00',2.52),('12664','2013-05-15','13:25:00',2.52),('12664','2013-05-15','13:30:00',2.65),('12664','2013-05-15','13:35:00',2.55),('12664','2013-05-15','13:40:00',2.39),('12664','2013-05-15','13:45:00',2.13),('12664','2013-05-15','13:50:00',2.44),('12664','2013-05-15','13:55:00',2.2),('12664','2013-05-15','14:00:00',2.26),('12664','2013-05-15','14:05:00',2.77),('12664','2013-05-15','14:10:00',2.66),('12664','2013-05-15','14:15:00',2.7),('12664','2013-05-15','14:20:00',2.57),('12664','2013-05-15','14:25:00',2.12),('12664','2013-05-15','14:30:00',1.69),('12664','2013-05-15','14:35:00',1.46),('12664','2013-05-15','14:40:00',1.31),('12664','2013-05-15','14:45:00',1.26),('12664','2013-05-15','14:50:00',1.26),('12664','2013-05-15','14:55:00',1.38),('12664','2013-05-15','15:00:00',1.32),('12664','2013-05-15','15:05:00',1.09),('12664','2013-05-15','15:30:00',1),('12664','2013-05-15','15:35:00',1.06),('12664','2013-05-15','15:40:00',1.18),('12664','2013-05-15','15:45:00',1.42),('12664','2013-05-15','15:50:00',1.84),('12664','2013-05-15','15:55:00',1.9),('12664','2013-05-15','16:00:00',1.88),('12664','2013-05-15','16:05:00',1.8),('12664','2013-05-15','16:10:00',1.64),('12664','2013-05-15','16:15:00',1.65),('12664','2013-05-15','16:20:00',1.73),('12664','2013-05-15','16:25:00',1.74),('12664','2013-05-15','16:30:00',1.58),('12664','2013-05-15','16:35:00',1.6),('12664','2013-05-15','16:40:00',1.5),('12664','2013-05-15','16:45:00',1.33),('12664','2013-05-15','16:50:00',1.25),('12664','2013-05-15','16:55:00',1.37),('12664','2013-05-15','17:00:00',1.7),('12664','2013-05-15','17:05:00',2.02),('12664','2013-05-15','17:10:00',2.11),('12664','2013-05-15','17:15:00',1.67),('12664','2013-05-15','17:20:00',1.9),('12664','2013-05-15','17:25:00',1.57),('12664','2013-05-15','17:30:00',1.15),('12664','2013-05-14','07:35:00',1.07),('12664','2013-05-14','07:40:00',1.18),('12664','2013-05-14','07:45:00',1.28),('12664','2013-05-14','07:50:00',1.39),('12664','2013-05-14','07:55:00',1.49),('12664','2013-05-14','08:00:00',1.59),('12664','2013-05-14','08:05:00',1.7),('12664','2013-05-14','08:10:00',1.8),('12664','2013-05-14','08:15:00',1.9),('12664','2013-05-14','08:20:00',2),('12664','2013-05-14','08:25:00',2.1),('12664','2013-05-14','08:30:00',2.2),('12664','2013-05-14','08:35:00',2.29),('12664','2013-05-14','08:40:00',2.39),('12664','2013-05-14','08:45:00',2.48),('12664','2013-05-14','08:50:00',2.56),('12664','2013-05-14','08:55:00',2.65),('12664','2013-05-14','09:00:00',2.73),('12664','2013-05-14','09:05:00',2.82),('12664','2013-05-14','09:10:00',2.89),('12664','2013-05-14','09:15:00',2.97),('12664','2013-05-14','09:20:00',3.05),('12664','2013-05-14','09:25:00',3.13),('12664','2013-05-14','09:30:00',3.2),('12664','2013-05-14','09:35:00',3.27),('12664','2013-05-14','09:40:00',3.33),('12664','2013-05-14','09:45:00',3.41),('12664','2013-05-14','09:50:00',3.48),('12664','2013-05-14','09:55:00',3.53),('12664','2013-05-14','10:00:00',3.6),('12664','2013-05-14','10:05:00',3.65),('12664','2013-05-14','10:10:00',3.71),('12664','2013-05-14','10:15:00',3.77),('12664','2013-05-14','10:20:00',3.82),('12664','2013-05-14','10:25:00',3.88),('12664','2013-05-14','10:30:00',3.94),('12664','2013-05-14','10:35:00',4),('12664','2013-05-14','10:40:00',4.02),('12664','2013-05-14','10:45:00',4.05),('12664','2013-05-14','10:50:00',4.1),('12664','2013-05-14','10:55:00',4.14),('12664','2013-05-14','11:00:00',4.19),('12664','2013-05-14','11:05:00',4.22),('12664','2013-05-14','11:10:00',4.23),('12664','2013-05-14','11:15:00',4.27),('12664','2013-05-14','11:20:00',4.29),('12664','2013-05-14','11:25:00',3.86),('12664','2013-05-14','11:30:00',4.35),('12664','2013-05-14','11:35:00',4.14),('12664','2013-05-14','11:40:00',4.35),('12664','2013-05-14','11:45:00',4.37),('12664','2013-05-14','11:50:00',4.39),('12664','2013-05-14','11:55:00',4.4),('12664','2013-05-14','12:00:00',4.43),('12664','2013-05-14','12:05:00',3.98),('12664','2013-05-14','12:10:00',4.46),('12664','2013-05-14','12:15:00',4.5),('12664','2013-05-14','12:20:00',4.31),('12664','2013-05-14','12:25:00',1.78),('12664','2013-05-14','12:30:00',3.38),('12664','2013-05-14','12:35:00',2.66),('12664','2013-05-14','12:40:00',3.94),('12664','2013-05-14','12:45:00',2.49),('12664','2013-05-14','12:50:00',2.18),('12664','2013-05-14','12:55:00',2.26),('12664','2013-05-14','13:05:00',1.33),('12664','2013-05-14','13:10:00',1.73),('12664','2013-05-14','13:45:00',2.46),('12664','2013-05-14','13:50:00',4.4),('12664','2013-05-14','13:55:00',4.41),('12664','2013-05-14','14:00:00',4.38),('12664','2013-05-14','14:05:00',4.36),('12664','2013-05-14','14:10:00',4.41),('12664','2013-05-14','14:15:00',4.43),('12664','2013-05-14','14:20:00',4.4),('12664','2013-05-14','14:25:00',4.4),('12664','2013-05-14','14:30:00',4.38),('12664','2013-05-14','14:35:00',4.36),('12664','2013-05-14','14:40:00',4.34),('12664','2013-05-14','14:45:00',4.33),('12664','2013-05-14','14:50:00',4.32),('12664','2013-05-14','14:55:00',4.27),('12664','2013-05-14','15:00:00',4.22),('12664','2013-05-14','15:05:00',4.19),('12664','2013-05-14','15:10:00',4.14),('12664','2013-05-14','15:15:00',4.09),('12664','2013-05-14','15:20:00',4.06),('12664','2013-05-14','15:25:00',4.01),('12664','2013-05-14','15:30:00',3.98),('12664','2013-05-14','15:35:00',3.91),('12664','2013-05-14','15:40:00',3.85),('12664','2013-05-14','15:45:00',3.79),('12664','2013-05-14','15:50:00',3.74),('12664','2013-05-14','15:55:00',3.68),('12664','2013-05-14','16:00:00',3.6),('12664','2013-05-14','16:05:00',3.55),('12664','2013-05-14','16:10:00',3.49),('12664','2013-05-14','16:15:00',3.43),('12664','2013-05-14','16:20:00',3.35),('12664','2013-05-14','16:25:00',3.27),('12664','2013-05-14','16:30:00',3.18),('12664','2013-05-14','16:35:00',3.1),('12664','2013-05-14','16:40:00',3.02),('12664','2013-05-14','16:45:00',2.94),('12664','2013-05-14','16:50:00',2.86),('12664','2013-05-14','16:55:00',2.77),('12664','2013-05-14','17:00:00',2.68),('12664','2013-05-14','17:05:00',2.59),('12664','2013-05-14','17:10:00',2.51),('12664','2013-05-14','17:15:00',2.42),('12664','2013-05-14','17:20:00',2.32),('12664','2013-05-14','17:25:00',2.23),('12664','2013-05-14','17:30:00',2.14),('12664','2013-05-14','17:35:00',2.04),('12664','2013-05-14','17:40:00',1.94),('12664','2013-05-14','17:45:00',1.85),('12664','2013-05-14','17:50:00',1.75),('12664','2013-05-14','17:55:00',1.65),('12664','2013-05-14','18:00:00',1.54),('12664','2013-05-14','18:05:00',1.45),('12664','2013-05-14','18:10:00',1.35),('12664','2013-05-14','18:15:00',1.25),('12664','2013-05-14','18:20:00',1.14),('12664','2013-05-14','18:25:00',1.04),('12664','2013-05-13','07:30:00',1.22),('12664','2013-05-13','07:35:00',1.23),('12664','2013-05-13','07:40:00',1.2),('12664','2013-05-13','07:45:00',1.35),('12664','2013-05-13','07:50:00',1.35),('12664','2013-05-13','07:55:00',1.38),('12664','2013-05-13','08:00:00',1.47),('12664','2013-05-13','08:05:00',1.56),('12664','2013-05-13','08:10:00',1.65),('12664','2013-05-13','08:15:00',1.74),('12664','2013-05-13','08:20:00',1.83),('12664','2013-05-13','08:25:00',1.93),('12664','2013-05-13','08:30:00',2.03),('12664','2013-05-13','08:35:00',2.13),('12664','2013-05-13','08:40:00',2.23),('12664','2013-05-13','08:45:00',2.29),('12664','2013-05-13','08:50:00',2.39),('12664','2013-05-13','08:55:00',2.46),('12664','2013-05-13','09:00:00',2.54),('12664','2013-05-13','09:05:00',2.63),('12664','2013-05-13','09:10:00',2.73),('12664','2013-05-13','09:15:00',2.83),('12664','2013-05-13','09:20:00',2.87),('12664','2013-05-13','09:25:00',3.02),('12664','2013-05-13','09:30:00',1.9),('12664','2013-05-13','09:35:00',3.41),('12664','2013-05-13','09:40:00',2.34),('12664','2013-05-13','09:45:00',3.74),('12664','2013-05-13','09:50:00',4.03),('12664','2013-05-13','09:55:00',2.71),('12664','2013-05-13','10:00:00',2.72),('12664','2013-05-13','10:05:00',1.72),('12664','2013-05-13','10:10:00',2.83),('12664','2013-05-13','10:15:00',2.29),('12664','2013-05-13','10:20:00',1.92),('12664','2013-05-13','10:25:00',3.27),('12664','2013-05-13','10:30:00',4.34),('12664','2013-05-13','10:35:00',3.14),('12664','2013-05-13','10:40:00',3.56),('12664','2013-05-13','10:45:00',1.52),('12664','2013-05-13','10:50:00',2.29),('12664','2013-05-13','10:55:00',4.07),('12664','2013-05-13','11:00:00',4.34),('12664','2013-05-13','11:05:00',4.43),('12664','2013-05-13','11:10:00',4.69),('12664','2013-05-13','11:15:00',4.7),('12664','2013-05-13','11:20:00',1.58),('12664','2013-05-13','11:25:00',3),('12664','2013-05-13','11:30:00',4.88),('12664','2013-05-13','11:35:00',4.79),('12664','2013-05-13','11:40:00',4.75),('12664','2013-05-13','11:45:00',4.91),('12664','2013-05-13','11:50:00',5.01),('12664','2013-05-13','11:55:00',2.93),('12664','2013-05-13','12:00:00',2.81),('12664','2013-05-13','12:05:00',3.9),('12664','2013-05-13','12:10:00',1.38),('12664','2013-05-13','12:30:00',3.74),('12664','2013-05-13','12:35:00',5.03),('12664','2013-05-13','12:40:00',2.55),('12664','2013-05-13','12:45:00',4.42),('12664','2013-05-13','12:50:00',3.14),('12664','2013-05-13','12:55:00',3.23),('12664','2013-05-13','13:00:00',2.93),('12664','2013-05-13','13:05:00',2.43),('12664','2013-05-13','13:10:00',2),('12664','2013-05-13','13:15:00',1.12),('12664','2013-05-13','13:25:00',2.67),('12664','2013-05-13','13:30:00',1.35),('12664','2013-05-13','13:35:00',1.17),('12664','2013-05-13','13:55:00',1.11),('12664','2013-05-13','14:00:00',3.93),('12664','2013-05-13','14:05:00',4.47),('12664','2013-05-13','14:10:00',1.61),('12664','2013-05-13','14:20:00',1.1),('12664','2013-05-13','14:25:00',1.35),('12664','2013-05-13','14:35:00',1.08),('12664','2013-05-13','14:40:00',3.21),('12664','2013-05-13','14:45:00',1.82),('12664','2013-05-13','14:50:00',2.33),('12664','2013-05-13','15:30:00',1.48),('12664','2013-05-13','15:35:00',2.79),('12664','2013-05-13','15:40:00',3.24),('12664','2013-05-13','15:45:00',4.1),('12664','2013-05-13','15:50:00',1.98),('12664','2013-05-13','15:55:00',1.04),('12664','2013-05-13','16:00:00',1.15),('12664','2013-05-13','16:05:00',1.3),('12664','2013-05-13','16:10:00',1.36),('12664','2013-05-13','16:15:00',1.22),('12664','2013-05-13','16:20:00',1.03),('12664','2013-05-13','16:25:00',1.02),('12664','2013-05-13','16:55:00',2.08),('12664','2013-05-13','17:00:00',2.15),('12664','2013-05-13','17:05:00',2.2),('12664','2013-05-13','17:10:00',1.59),('12664','2013-05-13','17:15:00',2.58),('12664','2013-05-13','17:20:00',2.54),('12664','2013-05-13','17:25:00',2.01),('12664','2013-05-13','17:30:00',2.23),('12664','2013-05-13','17:35:00',2.07),('12664','2013-05-13','17:40:00',1.96),('12664','2013-05-13','17:45:00',1.85),('12664','2013-05-13','17:50:00',1.77),('12664','2013-05-13','17:55:00',1.36),('12664','2013-05-13','18:00:00',1.37),('12664','2013-05-13','18:05:00',1.65),('12664','2013-05-13','18:10:00',1.61),('12664','2013-05-13','18:15:00',1.47),('12664','2013-05-13','18:20:00',1.52),('12664','2013-05-13','18:25:00',1.62),('12664','2013-05-13','18:30:00',1.53),('12664','2013-05-13','18:35:00',1.37),('12664','2013-05-12','07:35:00',1.07),('12664','2013-05-12','07:45:00',1.33),('12664','2013-05-12','07:50:00',1.34),('12664','2013-05-12','08:05:00',1.07),('12664','2013-05-12','08:25:00',1.35),('12664','2013-05-12','08:30:00',2.01),('12664','2013-05-12','08:35:00',1.75),('12664','2013-05-12','08:40:00',1.67),('12664','2013-05-12','08:45:00',1.54),('12664','2013-05-12','08:50:00',1.48),('12664','2013-05-12','08:55:00',2.71),('12664','2013-05-12','09:00:00',3.1),('12664','2013-05-12','09:05:00',2.96),('12664','2013-05-12','09:10:00',2.47),('12664','2013-05-12','09:15:00',3.24),('12664','2013-05-12','09:20:00',3.6),('12664','2013-05-12','09:25:00',2.94),('12664','2013-05-12','09:30:00',2.17),('12664','2013-05-12','09:35:00',2.68),('12664','2013-05-12','09:40:00',1.44),('12664','2013-05-12','09:45:00',3),('12664','2013-05-12','09:50:00',2.08),('12664','2013-05-12','09:55:00',4.19),('12664','2013-05-12','10:00:00',4.08),('12664','2013-05-12','10:05:00',3.52),('12664','2013-05-12','10:10:00',2.7),('12664','2013-05-12','10:15:00',2.35),('12664','2013-05-12','10:20:00',4.52),('12664','2013-05-12','10:25:00',4.54),('12664','2013-05-12','10:30:00',4.49),('12664','2013-05-12','10:35:00',4.45),('12664','2013-05-12','10:40:00',2.45),('12664','2013-05-12','10:45:00',2.59),('12664','2013-05-12','10:50:00',1.03),('12664','2013-05-12','10:55:00',4.03),('12664','2013-05-12','11:00:00',4.55),('12664','2013-05-12','11:05:00',4.02),('12664','2013-05-12','11:10:00',4.66),('12664','2013-05-12','11:15:00',4.27),('12664','2013-05-12','11:20:00',2.61),('12664','2013-05-12','11:25:00',1.42),('12664','2013-05-12','11:30:00',1.49),('12664','2013-05-12','11:35:00',1.25),('12664','2013-05-12','11:40:00',2.39),('12664','2013-05-12','11:45:00',3.21),('12664','2013-05-12','11:50:00',4.78),('12664','2013-05-12','11:55:00',4.92),('12664','2013-05-12','12:00:00',1.42),('12664','2013-05-12','12:05:00',1.37),('12664','2013-05-12','12:10:00',2.81),('12664','2013-05-12','12:15:00',2.88),('12664','2013-05-12','12:20:00',4.5),('12664','2013-05-12','12:25:00',3.47),('12664','2013-05-12','12:30:00',3.55),('12664','2013-05-12','12:35:00',1.81),('12664','2013-05-12','12:40:00',2.44),('12664','2013-05-12','12:45:00',2.5),('12664','2013-05-12','12:50:00',5.03),('12664','2013-05-12','12:55:00',4.87),('12664','2013-05-12','13:00:00',4.72),('12664','2013-05-12','13:05:00',4.72),('12664','2013-05-12','13:10:00',4.73),('12664','2013-05-12','13:15:00',4.73),('12664','2013-05-12','13:20:00',4.7),('12664','2013-05-12','13:25:00',4.72),('12664','2013-05-12','13:30:00',4.75),('12664','2013-05-12','13:35:00',4.75),('12664','2013-05-12','13:40:00',4.77),('12664','2013-05-12','13:45:00',4.91),('12664','2013-05-12','13:50:00',4.38),('12664','2013-05-12','13:55:00',4.67),('12664','2013-05-12','14:00:00',4.76),('12664','2013-05-12','14:05:00',4.76),('12664','2013-05-12','14:10:00',4.75),('12664','2013-05-12','14:15:00',4.1),('12664','2013-05-12','14:20:00',4.35),('12664','2013-05-12','14:25:00',2.66),('12664','2013-05-12','14:30:00',2.94),('12664','2013-05-12','14:35:00',1.36),('12664','2013-05-12','14:40:00',2.5),('12664','2013-05-12','14:45:00',3.34),('12664','2013-05-12','14:50:00',2.1),('12664','2013-05-12','14:55:00',1.45),('12664','2013-05-12','15:00:00',3.49),('12664','2013-05-12','15:05:00',4.39),('12664','2013-05-12','15:10:00',3.55),('12664','2013-05-12','15:15:00',3.78),('12664','2013-05-12','15:20:00',4.12),('12664','2013-05-12','15:25:00',4.09),('12664','2013-05-12','15:30:00',3.96),('12664','2013-05-12','15:35:00',3.87),('12664','2013-05-12','15:40:00',3.81),('12664','2013-05-12','15:45:00',3.73),('12664','2013-05-12','15:50:00',3.67),('12664','2013-05-12','15:55:00',3.61),('12664','2013-05-12','16:00:00',3.55),('12664','2013-05-12','16:05:00',3.47),('12664','2013-05-12','16:10:00',3.2),('12664','2013-05-12','16:15:00',3.39),('12664','2013-05-12','16:20:00',2.47),('12664','2013-05-12','16:25:00',2.41),('12664','2013-05-12','16:30:00',3.31),('12664','2013-05-12','16:35:00',2.16),('12664','2013-05-12','16:40:00',2.51),('12664','2013-05-12','16:45:00',3.36),('12664','2013-05-12','16:50:00',2.5),('12664','2013-05-12','16:55:00',1.48),('12664','2013-05-12','17:00:00',2.36),('12664','2013-05-12','17:05:00',2.2),('12664','2013-05-12','17:10:00',2.56),('12664','2013-05-12','17:15:00',2.37),('12664','2013-05-12','17:20:00',2.12),('12664','2013-05-12','17:25:00',1.53),('12664','2013-05-12','17:30:00',2.04),('12664','2013-05-12','17:35:00',2.03),('12664','2013-05-12','17:40:00',1.49),('12664','2013-05-12','17:45:00',1.99),('12664','2013-05-12','17:50:00',2.73),('12664','2013-05-12','17:55:00',2.43),('12664','2013-05-12','18:00:00',1.85),('12664','2013-05-12','18:05:00',1.73),('12664','2013-05-12','18:10:00',1.68),('12664','2013-05-12','18:15:00',1.26),('12664','2013-05-12','18:20:00',1.13),('12664','2013-05-12','18:25:00',1.2),('12664','2013-05-12','18:30:00',1.19),('12664','2013-05-12','18:35:00',1.21),('12664','2013-05-11','07:35:00',1.08),('12664','2013-05-11','07:40:00',1.43),('12664','2013-05-11','07:45:00',1.45),('12664','2013-05-11','07:55:00',1.01),('12664','2013-05-11','08:10:00',1.27),('12664','2013-05-11','08:15:00',1.53),('12664','2013-05-11','08:25:00',1.66),('12664','2013-05-11','08:30:00',1.65),('12664','2013-05-11','08:35:00',1.68),('12664','2013-05-11','08:40:00',1.93),('12664','2013-05-11','08:45:00',1.76),('12664','2013-05-11','08:50:00',2.22),('12664','2013-05-11','08:55:00',1.71),('12664','2013-05-11','09:00:00',1.36),('12664','2013-05-11','09:05:00',1.85),('12664','2013-05-11','09:10:00',2.88),('12664','2013-05-11','09:15:00',2.23),('12664','2013-05-11','09:20:00',2.17),('12664','2013-05-11','09:25:00',2.67),('12664','2013-05-11','09:30:00',1.63),('12664','2013-05-11','09:35:00',3.53),('12664','2013-05-11','09:40:00',1.64),('12664','2013-05-11','09:45:00',2.83),('12664','2013-05-11','09:50:00',1.68),('12664','2013-05-11','09:55:00',1.79),('12664','2013-05-11','10:10:00',3.28),('12664','2013-05-11','10:15:00',4.1),('12664','2013-05-11','10:20:00',4.07),('12664','2013-05-11','10:25:00',3.23),('12664','2013-05-11','10:30:00',2.49),('12664','2013-05-11','10:35:00',3.99),('12664','2013-05-11','10:40:00',4.09),('12664','2013-05-11','10:45:00',4.02),('12664','2013-05-11','10:50:00',4.26),('12664','2013-05-11','10:55:00',4.09),('12664','2013-05-11','11:00:00',4.34),('12664','2013-05-11','11:05:00',1.55),('12664','2013-05-11','11:10:00',4.12),('12664','2013-05-11','11:15:00',4.21),('12664','2013-05-11','11:20:00',1.7),('12664','2013-05-11','11:25:00',4.87),('12664','2013-05-11','11:30:00',4.75),('12664','2013-05-11','11:35:00',2.93),('12664','2013-05-11','11:40:00',3.17),('12664','2013-05-11','11:45:00',2.68),('12664','2013-05-11','11:50:00',4.89),('12664','2013-05-11','11:55:00',2.35),('12664','2013-05-11','12:00:00',3.38),('12664','2013-05-11','12:05:00',2.9),('12664','2013-05-11','12:10:00',4.42),('12664','2013-05-11','12:15:00',2.32),('12664','2013-05-11','12:20:00',4.4),('12664','2013-05-11','12:25:00',4.21),('12664','2013-05-11','12:30:00',5.05),('12664','2013-05-11','12:35:00',2.97),('12664','2013-05-11','12:40:00',3.49),('12664','2013-05-11','12:45:00',3.21),('12664','2013-05-11','12:50:00',2.59),('12664','2013-05-11','12:55:00',4.14),('12664','2013-05-11','13:00:00',4.85),('12664','2013-05-11','13:05:00',3.06),('12664','2013-05-11','13:10:00',3.55),('12664','2013-05-11','13:15:00',3.18),('12664','2013-05-11','13:20:00',3.61),('12664','2013-05-11','13:25:00',2.33),('12664','2013-05-11','13:30:00',2.69),('12664','2013-05-11','13:35:00',3.07),('12664','2013-05-11','13:40:00',3.16),('12664','2013-05-11','13:45:00',2.91),('12664','2013-05-11','13:50:00',4.03),('12664','2013-05-11','13:55:00',4.27),('12664','2013-05-11','14:00:00',4.99),('12664','2013-05-11','14:05:00',3.75),('12664','2013-05-11','14:10:00',3.81),('12664','2013-05-11','14:15:00',3.26),('12664','2013-05-11','14:20:00',2.17),('12664','2013-05-11','14:25:00',3.17),('12664','2013-05-11','14:30:00',3.56),('12664','2013-05-11','14:35:00',3.51),('12664','2013-05-11','14:40:00',2.5),('12664','2013-05-11','14:45:00',2.91),('12664','2013-05-11','14:50:00',4.11),('12664','2013-05-11','14:55:00',3.63),('12664','2013-05-11','15:00:00',3.07),('12664','2013-05-11','15:05:00',3.34),('12664','2013-05-11','15:10:00',2.18),('12664','2013-05-11','15:15:00',2.86),('12664','2013-05-11','15:20:00',3.18),('12664','2013-05-11','15:25:00',3.64),('12664','2013-05-11','15:30:00',3.66),('12664','2013-05-11','15:35:00',4.01),('12664','2013-05-11','15:40:00',3.55),('12664','2013-05-11','15:45:00',1.93),('12664','2013-05-11','15:50:00',3.66),('12664','2013-05-11','15:55:00',4.03),('12664','2013-05-11','16:00:00',2.72),('12664','2013-05-11','16:05:00',3.85),('12664','2013-05-11','16:10:00',3.61),('12664','2013-05-11','16:15:00',3.64),('12664','2013-05-11','16:20:00',3.4),('12664','2013-05-11','16:25:00',3.39),('12664','2013-05-11','16:30:00',2.82),('12664','2013-05-11','16:35:00',2.94),('12664','2013-05-11','16:40:00',2.84),('12664','2013-05-11','16:45:00',3.05),('12664','2013-05-11','16:50:00',3.38),('12664','2013-05-11','16:55:00',2.59),('12664','2013-05-11','17:00:00',2.78),('12664','2013-05-11','17:05:00',2.39),('12664','2013-05-11','17:10:00',1.75),('12664','2013-05-11','17:15:00',1.67),('12664','2013-05-11','17:20:00',2.29),('12664','2013-05-11','17:25:00',1.86),('12664','2013-05-11','17:30:00',2.21),('12664','2013-05-11','17:35:00',1.47),('12664','2013-05-11','17:40:00',1.99),('12664','2013-05-11','17:45:00',1.21),('12664','2013-05-11','17:50:00',1.3),('12664','2013-05-11','17:55:00',1.84),('12664','2013-05-11','18:05:00',1.1),('12664','2013-05-11','18:15:00',1.3),('12664','2014-03-30','08:25:00',1.07),('12664','2014-03-30','08:30:00',1.2),('12664','2014-03-30','08:35:00',1.23),('12664','2014-03-30','08:40:00',1.23),('12664','2014-03-30','08:45:00',1.23),('12664','2014-03-30','08:50:00',1.22),('12664','2014-03-30','08:55:00',1.26),('12664','2014-03-30','09:00:00',1.32),('12664','2014-03-30','09:05:00',1.36),('12664','2014-03-30','09:10:00',1.47),('12664','2014-03-30','09:15:00',1.67),('12664','2014-03-30','09:20:00',1.8),('12664','2014-03-30','09:25:00',1.9),('12664','2014-03-30','09:30:00',1.97),('12664','2014-03-30','09:35:00',2.08),('12664','2014-03-30','09:40:00',2.2),('12664','2014-03-30','09:45:00',2.23),('12664','2014-03-30','09:50:00',2.23),('12664','2014-03-30','09:55:00',2.35),('12664','2014-03-30','10:00:00',2.54),('12664','2014-03-30','10:05:00',2.63),('12664','2014-03-30','10:10:00',2.78),('12664','2014-03-30','10:15:00',2.91),('12664','2014-03-30','10:20:00',2.88),('12664','2014-03-30','10:25:00',2.95),('12664','2014-03-30','10:30:00',2.99),('12664','2014-03-30','10:35:00',3.02),('12664','2014-03-30','10:40:00',3.03),('12664','2014-03-30','10:45:00',3.08),('12664','2014-03-30','10:50:00',3.07),('12664','2014-03-30','10:55:00',3.17),('12664','2014-03-30','11:00:00',3.11),('12664','2014-03-30','11:05:00',3.04),('12664','2014-03-30','11:10:00',3.21),('12664','2014-03-30','11:15:00',3.15),('12664','2014-03-30','11:20:00',3.16),('12664','2014-03-30','11:25:00',3.25),('12664','2014-03-30','11:30:00',3.48),('12664','2014-03-30','11:35:00',3.54),('12664','2014-03-30','11:40:00',3.64),('12664','2014-03-30','11:45:00',3.63),('12664','2014-03-30','11:50:00',3.71),('12664','2014-03-30','11:55:00',3.71),('12664','2014-03-30','12:00:00',3.7),('12664','2014-03-30','12:05:00',3.72),('12664','2014-03-30','12:10:00',3.74),('12664','2014-03-30','12:15:00',3.89),('12664','2014-03-30','12:20:00',3.97),('12664','2014-03-30','12:25:00',3.74),('12664','2014-03-30','12:30:00',3.79),('12664','2014-03-30','12:35:00',3.99),('12664','2014-03-30','12:40:00',4.09),('12664','2014-03-30','12:45:00',4.1),('12664','2014-03-30','12:50:00',4.09),('12664','2014-03-30','12:55:00',4.07),('12664','2014-03-30','13:00:00',4.08),('12664','2014-03-30','13:05:00',4.07),('12664','2014-03-30','13:10:00',4),('12664','2014-03-30','13:15:00',4),('12664','2014-03-30','13:20:00',4.07),('12664','2014-03-30','13:25:00',4.18),('12664','2014-03-30','13:30:00',4.19),('12664','2014-03-30','13:35:00',4.15),('12664','2014-03-30','13:40:00',4.15),('12664','2014-03-30','13:45:00',4.16),('12664','2014-03-30','13:50:00',4.14),('12664','2014-03-30','13:55:00',4.15),('12664','2014-03-30','14:00:00',4.07),('12664','2014-03-30','14:05:00',4.07),('12664','2014-03-30','14:10:00',3.92),('12664','2014-03-30','14:15:00',3.51),('12664','2014-03-30','14:20:00',2.99),('12664','2014-03-30','14:25:00',2.38),('12664','2014-03-30','14:30:00',2.82),('12664','2014-03-30','14:35:00',2.42),('12664','2014-03-30','14:40:00',2.44),('12664','2014-03-30','14:45:00',2.48),('12664','2014-03-30','14:50:00',2.13),('12664','2014-03-30','14:55:00',2.37),('12664','2014-03-30','15:00:00',2.87),('12664','2014-03-30','15:05:00',2.97),('12664','2014-03-30','15:10:00',3.06),('12664','2014-03-30','15:15:00',3.05),('12664','2014-03-30','15:20:00',2.52),('12664','2014-03-30','15:25:00',2.66),('12664','2014-03-30','15:30:00',2.99),('12664','2014-03-30','15:35:00',3.17),('12664','2014-03-30','15:40:00',3.14),('12664','2014-03-30','15:45:00',3.22),('12664','2014-03-30','15:50:00',3.28),('12664','2014-03-30','15:55:00',3.22),('12664','2014-03-30','16:00:00',3.23),('12664','2014-03-30','16:05:00',3.11),('12664','2014-03-30','16:10:00',2.94),('12664','2014-03-30','16:15:00',2.89),('12664','2014-03-30','16:20:00',2.85),('12664','2014-03-30','16:25:00',2.37),('12664','2014-03-30','16:30:00',2.04),('12664','2014-03-30','16:35:00',2.1),('12664','2014-03-30','16:40:00',2.46),('12664','2014-03-30','16:45:00',2.43),('12664','2014-03-30','16:50:00',2.28),('12664','2014-03-30','16:55:00',2.27),('12664','2014-03-30','17:00:00',2.15),('12664','2014-03-30','17:05:00',2.03),('12664','2014-03-30','17:10:00',1.89),('12664','2014-03-30','17:15:00',1.8),('12664','2014-03-30','17:20:00',1.76),('12664','2014-03-30','17:25:00',1.66),('12664','2014-03-30','17:30:00',1.55),('12664','2014-03-30','17:35:00',1.45),('12664','2014-03-30','17:40:00',1.38),('12664','2014-03-30','17:45:00',1.26),('12664','2014-03-30','17:50:00',1.15),('12664','2014-03-30','17:55:00',1.03),('12664','2013-05-10','07:45:00',1.12),('12664','2013-05-10','07:50:00',1.45),('12664','2013-05-10','07:55:00',1.27),('12664','2013-05-10','08:00:00',1.38),('12664','2013-05-10','08:05:00',1.37),('12664','2013-05-10','08:10:00',1.49),('12664','2013-05-10','08:15:00',1.74),('12664','2013-05-10','08:20:00',1.59),('12664','2013-05-10','08:25:00',1.07),('12664','2013-05-10','08:45:00',1.29),('12664','2013-05-10','08:50:00',2.34),('12664','2013-05-10','08:55:00',2.53),('12664','2013-05-10','09:00:00',2.52),('12664','2013-05-10','09:05:00',2.65),('12664','2013-05-10','09:10:00',2.75),('12664','2013-05-10','09:15:00',1.76),('12664','2013-05-10','09:20:00',2.81),('12664','2013-05-10','09:25:00',3.08),('12664','2013-05-10','09:30:00',2.49),('12664','2013-05-10','09:35:00',3.1),('12664','2013-05-10','09:40:00',2.09),('12664','2013-05-10','09:45:00',2.28),('12664','2013-05-10','09:50:00',2.15),('12664','2013-05-10','09:55:00',2.97),('12664','2013-05-10','10:00:00',1.39),('12664','2013-05-10','10:05:00',1.19),('12664','2013-05-10','10:10:00',2.48),('12664','2013-05-10','10:15:00',3.5),('12664','2013-05-10','10:20:00',3.85),('12664','2013-05-10','10:25:00',3.84),('12664','2013-05-10','10:30:00',3.87),('12664','2013-05-10','10:35:00',3.92),('12664','2013-05-10','10:40:00',3.97),('12664','2013-05-10','10:45:00',4.18),('12664','2013-05-10','10:50:00',2.73),('12664','2013-05-10','10:55:00',3.99),('12664','2013-05-10','11:00:00',2.89),('12664','2013-05-10','11:05:00',3.71),('12664','2013-05-10','11:10:00',4.36),('12664','2013-05-10','11:15:00',2.28),('12664','2013-05-10','11:20:00',2.36),('12664','2013-05-10','11:25:00',4.66),('12664','2013-05-10','11:30:00',3),('12664','2013-05-10','11:35:00',3.64),('12664','2013-05-10','11:40:00',4.54),('12664','2013-05-10','11:45:00',3.95),('12664','2013-05-10','11:50:00',3.2),('12664','2013-05-10','11:55:00',3.6),('12664','2013-05-10','12:00:00',3.27),('12664','2013-05-10','12:05:00',3.32),('12664','2013-05-10','12:10:00',3.11),('12664','2013-05-10','12:15:00',3.14),('12664','2013-05-10','12:20:00',3.67),('12664','2013-05-10','12:25:00',4.36),('12664','2013-05-10','12:30:00',4.16),('12664','2013-05-10','12:35:00',3.99),('12664','2013-05-10','12:40:00',3.88),('12664','2013-05-10','12:45:00',3.52),('12664','2013-05-10','12:50:00',4.92),('12664','2013-05-10','12:55:00',3.88),('12664','2013-05-10','13:00:00',3.84),('12664','2013-05-10','13:05:00',4.25),('12664','2013-05-10','13:10:00',4.93),('12664','2013-05-10','13:15:00',5.02),('12664','2013-05-10','13:20:00',4.76),('12664','2013-05-10','13:25:00',4.94),('12664','2013-05-10','13:30:00',4.44),('12664','2013-05-10','13:35:00',3.93),('12664','2013-05-10','13:40:00',2.51),('12664','2013-05-10','13:45:00',2.1),('12664','2013-05-10','13:50:00',2.16),('12664','2013-05-10','13:55:00',2.63),('12664','2013-05-10','14:00:00',2.98),('12664','2013-05-10','14:05:00',3.41),('12664','2013-05-10','14:10:00',3.31),('12664','2013-05-10','14:15:00',2.58),('12664','2013-05-10','14:20:00',2.51),('12664','2013-05-10','14:25:00',2.74),('12664','2013-05-10','14:30:00',2.33),('12664','2013-05-10','14:35:00',2.02),('12664','2013-05-10','14:40:00',1.58),('12664','2013-05-10','14:45:00',1.52),('12664','2013-05-10','14:50:00',1.89),('12664','2013-05-10','14:55:00',3.46),('12664','2013-05-10','15:00:00',3.63),('12664','2013-05-10','15:05:00',3.16),('12664','2013-05-10','15:10:00',2.14),('12664','2013-05-10','15:15:00',2.12),('12664','2013-05-10','15:20:00',2.41),('12664','2013-05-10','15:25:00',2.72),('12664','2013-05-10','15:30:00',2.46),('12664','2013-05-10','15:35:00',2.24),('12664','2013-05-10','15:40:00',2.11),('12664','2013-05-10','15:45:00',1.99),('12664','2013-05-10','15:50:00',1.92),('12664','2013-05-10','15:55:00',1.83),('12664','2013-05-10','16:00:00',1.68),('12664','2013-05-10','16:05:00',1.63),('12664','2013-05-10','16:10:00',1.73),('12664','2013-05-10','16:15:00',1.89),('12664','2013-05-10','16:20:00',1.91),('12664','2013-05-10','16:25:00',1.84),('12664','2013-05-10','16:30:00',1.76),('12664','2013-05-10','16:35:00',1.72),('12664','2013-05-10','16:40:00',1.44),('12664','2013-05-10','16:45:00',1.2),('12664','2013-05-10','16:50:00',1.34),('12664','2013-05-10','16:55:00',2.07),('12664','2013-05-10','17:00:00',1.93),('12664','2013-05-10','17:05:00',1.88),('12664','2013-05-10','17:10:00',2.19),('12664','2013-05-10','17:15:00',3.22),('12664','2013-05-10','17:20:00',2.72),('12664','2013-05-10','17:25:00',2.45),('12664','2013-05-10','17:30:00',1.22),('12664','2013-05-10','17:35:00',1.48),('12664','2013-05-10','17:40:00',1.15),('12664','2013-05-10','17:45:00',1.01),('12664','2013-05-09','07:40:00',1.05),('12664','2013-05-09','07:45:00',1.16),('12664','2013-05-09','07:50:00',1.27),('12664','2013-05-09','07:55:00',1.37),('12664','2013-05-09','08:00:00',1.47),('12664','2013-05-09','08:05:00',1.57),('12664','2013-05-09','08:10:00',1.67),('12664','2013-05-09','08:15:00',1.77),('12664','2013-05-09','08:20:00',1.86),('12664','2013-05-09','08:25:00',1.96),('12664','2013-05-09','08:30:00',2.05),('12664','2013-05-09','08:35:00',2.15),('12664','2013-05-09','08:40:00',2.24),('12664','2013-05-09','08:45:00',2.33),('12664','2013-05-09','08:50:00',2.43),('12664','2013-05-09','08:55:00',2.52),('12664','2013-05-09','09:00:00',2.6),('12664','2013-05-09','09:05:00',2.69),('12664','2013-05-09','09:10:00',2.76),('12664','2013-05-09','09:15:00',2.83),('12664','2013-05-09','09:20:00',2.9),('12664','2013-05-09','09:25:00',2.96),('12664','2013-05-09','09:30:00',3.06),('12664','2013-05-09','09:35:00',3.14),('12664','2013-05-09','09:40:00',3.21),('12664','2013-05-09','09:45:00',3.27),('12664','2013-05-09','09:50:00',3.35),('12664','2013-05-09','09:55:00',3.4),('12664','2013-05-09','10:00:00',3.49),('12664','2013-05-09','10:05:00',3.53),('12664','2013-05-09','10:10:00',3.61),('12664','2013-05-09','10:15:00',3.67),('12664','2013-05-09','10:20:00',3.72),('12664','2013-05-09','10:25:00',3.75),('12664','2013-05-09','10:30:00',3.77),('12664','2013-05-09','10:35:00',3.82),('12664','2013-05-09','10:40:00',3.87),('12664','2013-05-09','10:45:00',3.91),('12664','2013-05-09','10:50:00',3.96),('12664','2013-05-09','10:55:00',3.99),('12664','2013-05-09','11:00:00',4.03),('12664','2013-05-09','11:05:00',4.07),('12664','2013-05-09','11:10:00',4.11),('12664','2013-05-09','11:15:00',4.15),('12664','2013-05-09','11:20:00',4.14),('12664','2013-05-09','11:25:00',4.17),('12664','2013-05-09','11:30:00',4.24),('12664','2013-05-09','11:35:00',4.27),('12664','2013-05-09','11:40:00',4.29),('12664','2013-05-09','11:45:00',4.25),('12664','2013-05-09','11:50:00',4.34),('12664','2013-05-09','11:55:00',4.44),('12664','2013-05-09','12:00:00',4.47),('12664','2013-05-09','12:05:00',4.46),('12664','2013-05-09','12:10:00',4.47),('12664','2013-05-09','12:15:00',4.48),('12664','2013-05-09','12:20:00',3.99),('12664','2013-05-09','12:25:00',4.45),('12664','2013-05-09','12:30:00',4.56),('12664','2013-05-09','12:35:00',4.55),('12664','2013-05-09','12:40:00',4.63),('12664','2013-05-09','12:45:00',4.66),('12664','2013-05-09','12:50:00',4.33),('12664','2013-05-09','12:55:00',3.01),('12664','2013-05-09','13:00:00',4.58),('12664','2013-05-09','13:05:00',4.56),('12664','2013-05-09','13:10:00',3.55),('12664','2013-05-09','13:15:00',4.33),('12664','2013-05-09','13:20:00',4.74),('12664','2013-05-09','13:25:00',4.61),('12664','2013-05-09','13:30:00',4.58),('12664','2013-05-09','13:35:00',4.58),('12664','2013-05-09','13:40:00',4.71),('12664','2013-05-09','13:45:00',4.73),('12664','2013-05-09','13:50:00',2.79),('12664','2013-05-09','14:00:00',4.4),('12664','2013-05-09','14:05:00',3.29),('12664','2013-05-09','14:10:00',3.66),('12664','2013-05-09','14:15:00',4.8),('12664','2013-05-09','14:20:00',2.43),('12664','2013-05-09','14:25:00',3.57),('12664','2013-05-09','14:30:00',4.44),('12664','2013-05-09','14:35:00',4.43),('12664','2013-05-09','14:40:00',4.39),('12664','2013-05-09','14:45:00',4.29),('12664','2013-05-09','14:50:00',4.18),('12664','2013-05-09','14:55:00',4.15),('12664','2013-05-09','15:00:00',4.02),('12664','2013-05-09','15:05:00',4.02),('12664','2013-05-09','15:10:00',4.01),('12664','2013-05-09','15:15:00',3.42),('12664','2013-05-09','15:20:00',3.24),('12664','2013-05-09','15:25:00',3.92),('12664','2013-05-09','15:30:00',3.88),('12664','2013-05-09','15:35:00',3.81),('12664','2013-05-09','15:40:00',3.74),('12664','2013-05-09','15:45:00',3.65),('12664','2013-05-09','15:50:00',3.58),('12664','2013-05-09','15:55:00',3.54),('12664','2013-05-09','16:00:00',3.54),('12664','2013-05-09','16:05:00',3.47),('12664','2013-05-09','16:10:00',3.38),('12664','2013-05-09','16:15:00',3.32),('12664','2013-05-09','16:20:00',3.25),('12664','2013-05-09','16:25:00',3.17),('12664','2013-05-09','16:30:00',3.1),('12664','2013-05-09','16:35:00',3.01),('12664','2013-05-09','16:40:00',2.94),('12664','2013-05-09','16:45:00',2.86),('12664','2013-05-09','16:50:00',2.79),('12664','2013-05-09','16:55:00',2.7),('12664','2013-05-09','17:00:00',2.61),('12664','2013-05-09','17:05:00',2.51),('12664','2013-05-09','17:10:00',2.43),('12664','2013-05-09','17:15:00',2.34),('12664','2013-05-09','17:20:00',2.25),('12664','2013-05-09','17:25:00',2.15),('12664','2013-05-09','17:30:00',2.06),('12664','2013-05-09','17:35:00',1.97),('12664','2013-05-09','17:40:00',1.87),('12664','2013-05-09','17:45:00',1.77),('12664','2013-05-09','17:50:00',1.67),('12664','2013-05-09','17:55:00',1.58),('12664','2013-05-09','18:00:00',1.47),('12664','2013-05-09','18:05:00',1.36),('12664','2013-05-09','18:10:00',1.28),('12664','2013-05-09','18:15:00',1.18),('12664','2013-05-09','18:20:00',1.08),('12664','2013-05-08','07:40:00',1.04),('12664','2013-05-08','07:45:00',1.12),('12664','2013-05-08','07:50:00',1.23),('12664','2013-05-08','07:55:00',1.36),('12664','2013-05-08','08:00:00',1.45),('12664','2013-05-08','08:05:00',1.56),('12664','2013-05-08','08:10:00',1.64),('12664','2013-05-08','08:15:00',1.72),('12664','2013-05-08','08:20:00',1.85),('12664','2013-05-08','08:25:00',1.88),('12664','2013-05-08','08:30:00',2.06),('12664','2013-05-08','08:35:00',2.45),('12664','2013-05-08','08:40:00',2.82),('12664','2013-05-08','08:45:00',2.18),('12664','2013-05-08','08:50:00',1.2),('12664','2013-05-08','08:55:00',1.66),('12664','2013-05-08','09:25:00',1.4),('12664','2013-05-08','09:30:00',1.85),('12664','2013-05-08','09:35:00',3.63),('12664','2013-05-08','09:40:00',2.2),('12664','2013-05-08','09:45:00',2.73),('12664','2013-05-08','09:50:00',3.01),('12664','2013-05-08','09:55:00',2.95),('12664','2013-05-08','10:00:00',3.98),('12664','2013-05-08','10:05:00',3.74),('12664','2013-05-08','10:10:00',2.63),('12664','2013-05-08','10:15:00',1.6),('12664','2013-05-08','10:20:00',1.94),('12664','2013-05-08','10:25:00',4.26),('12664','2013-05-08','10:30:00',4.31),('12664','2013-05-08','10:35:00',4.6),('12664','2013-05-08','10:40:00',3.33),('12664','2013-05-08','10:45:00',2.12),('12664','2013-05-08','10:50:00',1.24),('12664','2013-05-08','10:55:00',1.29),('12664','2013-05-08','11:00:00',1.48),('12664','2013-05-08','11:05:00',1.19),('12664','2013-05-08','11:10:00',1.09),('12664','2013-05-08','11:15:00',1.19),('12664','2013-05-08','11:20:00',4.06),('12664','2013-05-08','11:25:00',4.73),('12664','2013-05-08','11:30:00',4.73),('12664','2013-05-08','11:35:00',4.88),('12664','2013-05-08','11:40:00',2.14),('12664','2013-05-08','11:45:00',1.31),('12664','2013-05-08','11:50:00',1.34),('12664','2013-05-08','11:55:00',4.7),('12664','2013-05-08','12:00:00',3.91),('12664','2013-05-08','12:05:00',2.9),('12664','2013-05-08','12:10:00',1.49),('12664','2013-05-08','12:15:00',2.64),('12664','2013-05-08','12:20:00',4.92),('12664','2013-05-08','12:25:00',4.92),('12664','2013-05-08','12:30:00',4.06),('12664','2013-05-08','12:35:00',1.46),('12664','2013-05-08','12:40:00',1.38),('12664','2013-05-08','12:45:00',1.36),('12664','2013-05-08','12:50:00',1.46),('12664','2013-05-08','12:55:00',2.6),('12664','2013-05-08','13:00:00',4.45),('12664','2013-05-08','13:05:00',4.46),('12664','2013-05-08','13:10:00',4.14),('12664','2013-05-08','13:15:00',3.66),('12664','2013-05-08','13:20:00',3.69),('12664','2013-05-08','13:25:00',2.82),('12664','2013-05-08','13:30:00',4.07),('12664','2013-05-08','13:35:00',4.65),('12664','2013-05-08','13:40:00',5.05),('12664','2013-05-08','13:45:00',5.03),('12664','2013-05-08','13:50:00',4.81),('12664','2013-05-08','13:55:00',4.96),('12664','2013-05-08','14:00:00',4.38),('12664','2013-05-08','14:05:00',1.53),('12664','2013-05-08','14:10:00',3.92),('12664','2013-05-08','14:15:00',4.74),('12664','2013-05-08','14:20:00',4.88),('12664','2013-05-08','14:25:00',3.11),('12664','2013-05-08','14:30:00',3.5),('12664','2013-05-08','14:35:00',5),('12664','2013-05-08','14:40:00',4.59),('12664','2013-05-08','14:45:00',1.68),('12664','2013-05-08','14:50:00',1.3),('12664','2013-05-08','14:55:00',3.35),('12664','2013-05-08','15:00:00',4.47),('12664','2013-05-08','15:05:00',4.45),('12664','2013-05-08','15:10:00',4.38),('12664','2013-05-08','15:15:00',4.22),('12664','2013-05-08','15:20:00',4.05),('12664','2013-05-08','15:25:00',3.97),('12664','2013-05-08','15:30:00',3.9),('12664','2013-05-08','15:35:00',3.85),('12664','2013-05-08','15:40:00',3.79),('12664','2013-05-08','15:45:00',3.72),('12664','2013-05-08','15:50:00',3.66),('12664','2013-05-08','15:55:00',3.61),('12664','2013-05-08','16:00:00',3.53),('12664','2013-05-08','16:05:00',3.47),('12664','2013-05-08','16:10:00',3.4),('12664','2013-05-08','16:15:00',2.91),('12664','2013-05-08','16:20:00',3.29),('12664','2013-05-08','16:25:00',3.23),('12664','2013-05-08','16:30:00',3.19),('12664','2013-05-08','16:35:00',2.86),('12664','2013-05-08','16:40:00',2.98),('12664','2013-05-08','16:45:00',3),('12664','2013-05-08','16:50:00',2.96),('12664','2013-05-08','16:55:00',2.19),('12664','2013-05-08','17:00:00',1.11),('12664','2013-05-08','17:05:00',1.13),('12664','2013-05-08','17:10:00',1.27),('12664','2013-05-08','17:15:00',1.49),('12664','2013-05-08','17:20:00',1.15),('12664','2013-05-08','17:25:00',1.48),('12664','2013-05-08','17:30:00',1.96),('12664','2013-05-08','17:35:00',2.12),('12664','2013-05-08','17:40:00',2.08),('12664','2013-05-08','17:45:00',2.12),('12664','2013-05-08','17:50:00',2.23),('12664','2013-05-08','17:55:00',2.21),('12664','2013-05-08','18:00:00',2.14),('12664','2013-05-08','18:05:00',1.95),('12664','2013-05-08','18:10:00',1.68),('12664','2013-05-08','18:15:00',1.44),('12664','2013-05-08','18:20:00',1.25),('12664','2013-05-07','07:40:00',1.06),('12664','2013-05-07','07:45:00',1.16),('12664','2013-05-07','07:50:00',1.25),('12664','2013-05-07','07:55:00',1.36),('12664','2013-05-07','08:00:00',1.47),('12664','2013-05-07','08:05:00',1.58),('12664','2013-05-07','08:10:00',1.66),('12664','2013-05-07','08:15:00',1.73),('12664','2013-05-07','08:20:00',1.84),('12664','2013-05-07','08:25:00',1.96),('12664','2013-05-07','08:30:00',2.07),('12664','2013-05-07','08:35:00',2.17),('12664','2013-05-07','08:40:00',2.3),('12664','2013-05-07','08:45:00',2.55),('12664','2013-05-07','08:50:00',1.71),('12664','2013-05-07','08:55:00',1.77),('12664','2013-05-07','09:05:00',1.57),('12664','2013-05-07','09:10:00',2.62),('12664','2013-05-07','09:15:00',3.18),('12664','2013-05-07','09:20:00',3.26),('12664','2013-05-07','09:25:00',2.56),('12664','2013-05-07','09:30:00',1.48),('12664','2013-05-07','09:55:00',1.14),('12664','2013-05-07','10:00:00',3.79),('12664','2013-05-07','10:05:00',3.89),('12664','2013-05-07','10:10:00',3.93),('12664','2013-05-07','10:15:00',4.14),('12664','2013-05-07','10:20:00',4.37),('12664','2013-05-07','10:25:00',3.96),('12664','2013-05-07','10:50:00',1.31),('12664','2013-05-07','10:55:00',2.34),('12664','2013-05-07','11:00:00',2.94),('12664','2013-05-07','11:05:00',1.4),('12664','2013-05-07','11:10:00',1.2),('12664','2013-05-07','11:15:00',1.06),('12664','2013-05-07','11:20:00',1.34),('12664','2013-05-07','11:25:00',1.44),('12664','2013-05-07','11:30:00',1.62),('12664','2013-05-07','11:35:00',2.07),('12664','2013-05-07','11:40:00',4.94),('12664','2013-05-07','11:45:00',4.85),('12664','2013-05-07','11:50:00',3.11),('12664','2013-05-07','11:55:00',1.62),('12664','2013-05-07','12:00:00',1.42),('12664','2013-05-07','12:05:00',1.55),('12664','2013-05-07','12:10:00',1.5),('12664','2013-05-07','12:15:00',1.31),('12664','2013-05-07','12:20:00',1.2),('12664','2013-05-07','12:25:00',1.1),('12664','2013-05-07','12:30:00',1.01),('12664','2013-05-07','12:35:00',1.38),('12664','2013-05-07','12:40:00',1.52),('12664','2013-05-07','12:45:00',2.75),('12664','2013-05-07','12:50:00',3.4),('12664','2013-05-07','12:55:00',3.49),('12664','2013-05-07','13:00:00',4.29),('12664','2013-05-07','13:05:00',2.02),('12664','2013-05-07','13:10:00',2.37),('12664','2013-05-07','13:15:00',3.15),('12664','2013-05-07','13:20:00',5.03),('12664','2013-05-07','13:25:00',4.58),('12664','2013-05-07','13:30:00',3.7),('12664','2013-05-07','13:35:00',4.99),('12664','2013-05-07','13:40:00',4.87),('12664','2013-05-07','13:45:00',2.16),('12664','2013-05-07','13:50:00',4.05),('12664','2013-05-07','13:55:00',3.52),('12664','2013-05-07','14:00:00',3.19),('12664','2013-05-07','14:05:00',2.12),('12664','2013-05-07','14:10:00',4.34),('12664','2013-05-07','14:15:00',2.24),('12664','2013-05-07','14:20:00',3.17),('12664','2013-05-07','14:25:00',4.62),('12664','2013-05-07','14:30:00',4.87),('12664','2013-05-07','14:35:00',4.97),('12664','2013-05-07','14:40:00',4.43),('12664','2013-05-07','14:45:00',4.34),('12664','2013-05-07','14:50:00',4.25),('12664','2013-05-07','14:55:00',4.4),('12664','2013-05-07','15:00:00',2.39),('12664','2013-05-07','15:05:00',2.96),('12664','2013-05-07','15:10:00',3.24),('12664','2013-05-07','15:15:00',3.85),('12664','2013-05-07','15:20:00',2.61),('12664','2013-05-07','15:25:00',2.91),('12664','2013-05-07','15:30:00',3.33),('12664','2013-05-07','15:35:00',4.33),('12664','2013-05-07','15:40:00',3.43),('12664','2013-05-07','15:45:00',3.1),('12664','2013-05-07','15:50:00',4),('12664','2013-05-07','15:55:00',4.34),('12664','2013-05-07','16:00:00',3.92),('12664','2013-05-07','16:05:00',3.57),('12664','2013-05-07','16:10:00',3.7),('12664','2013-05-07','16:15:00',3.52),('12664','2013-05-07','16:20:00',3.92),('12664','2013-05-07','16:25:00',3.86),('12664','2013-05-07','16:30:00',3.72),('12664','2013-05-07','16:35:00',3.61),('12664','2013-05-07','16:40:00',1.55),('12664','2013-05-07','16:45:00',1.72),('12664','2013-05-07','16:50:00',2.17),('12664','2013-05-07','16:55:00',1.71),('12664','2013-05-07','17:00:00',1.48),('12664','2013-05-07','17:05:00',1.32),('12664','2013-05-07','17:10:00',1.3),('12664','2013-05-07','17:15:00',1.38),('12664','2013-05-07','17:20:00',2.02),('12664','2013-05-07','17:25:00',1.5),('12664','2013-05-07','17:30:00',1.03),('12664','2013-05-06','08:25:00',1.15),('12664','2013-05-06','08:30:00',1.05),('12664','2013-05-06','08:35:00',1.11),('12664','2013-05-06','08:40:00',1.02),('12664','2013-05-06','08:45:00',1.39),('12664','2013-05-06','08:50:00',1.73),('12664','2013-05-06','08:55:00',1.4),('12664','2013-05-06','09:00:00',1.12),('12664','2013-05-06','09:05:00',1.22),('12664','2013-05-06','09:10:00',2.3),('12664','2013-05-06','09:40:00',1.02),('12664','2013-05-06','09:45:00',1.22),('12664','2013-05-06','09:55:00',1.17),('12664','2013-05-06','10:00:00',1.19),('12664','2013-05-06','10:05:00',2.11),('12664','2013-05-06','10:10:00',1.72),('12664','2013-05-06','10:15:00',1.9),('12664','2013-05-06','10:20:00',2.4),('12664','2013-05-06','10:25:00',2.02),('12664','2013-05-06','10:30:00',1.88),('12664','2013-05-06','10:35:00',1.87),('12664','2013-05-06','10:40:00',1.64),('12664','2013-05-06','10:45:00',1.86),('12664','2013-05-06','10:50:00',1.75),('12664','2013-05-06','10:55:00',1.45),('12664','2013-05-06','11:05:00',1.21),('12664','2013-05-06','11:10:00',1.99),('12664','2013-05-06','11:15:00',1.5),('12664','2013-05-06','11:25:00',2.37),('12664','2013-05-06','11:30:00',2.98),('12664','2013-05-06','11:35:00',1.71),('12664','2013-05-06','11:40:00',1.59),('12664','2013-05-06','11:45:00',2.14),('12664','2013-05-06','11:50:00',2.27),('12664','2013-05-06','11:55:00',2.95),('12664','2013-05-06','12:00:00',3.24),('12664','2013-05-06','12:05:00',2.26),('12664','2013-05-06','12:10:00',2.34),('12664','2013-05-06','12:15:00',4.07),('12664','2013-05-06','12:20:00',2.13),('12664','2013-05-06','12:25:00',3.02),('12664','2013-05-06','12:30:00',4.04),('12664','2013-05-06','12:35:00',3.18),('12664','2013-05-06','12:40:00',4.06),('12664','2013-05-06','12:45:00',2.93),('12664','2013-05-06','12:50:00',4.37),('12664','2013-05-06','12:55:00',3.12),('12664','2013-05-06','13:00:00',4.49),('12664','2013-05-06','13:05:00',4.36),('12664','2013-05-06','13:10:00',4.28),('12664','2013-05-06','13:15:00',5.06),('12664','2013-05-06','13:20:00',3.43),('12664','2013-05-06','13:25:00',4.3),('12664','2013-05-06','13:30:00',4.21),('12664','2013-05-06','13:35:00',4.12),('12664','2013-05-06','13:40:00',4.46),('12664','2013-05-06','13:45:00',3.56),('12664','2013-05-06','13:50:00',4.5),('12664','2013-05-06','13:55:00',2.6),('12664','2013-05-06','14:00:00',3.49),('12664','2013-05-06','14:05:00',4.54),('12664','2013-05-06','14:10:00',3.53),('12664','2013-05-06','14:15:00',3.1),('12664','2013-05-06','14:20:00',3.68),('12664','2013-05-06','14:25:00',4.99),('12664','2013-05-06','14:30:00',3.17),('12664','2013-05-06','14:35:00',3.62),('12664','2013-05-06','14:40:00',2.76),('12664','2013-05-06','14:45:00',3.09),('12664','2013-05-06','14:50:00',3.36),('12664','2013-05-06','14:55:00',2.56),('12664','2013-05-06','15:00:00',2.55),('12664','2013-05-06','15:05:00',4.59),('12664','2013-05-06','15:10:00',4.68),('12664','2013-05-06','15:15:00',2.72),('12664','2013-05-06','15:20:00',1.95),('12664','2013-05-06','15:25:00',3.12),('12664','2013-05-06','15:30:00',1.98),('12664','2013-05-06','15:35:00',2.38),('12664','2013-05-06','15:40:00',3.16),('12664','2013-05-06','15:45:00',4.3),('12664','2013-05-06','15:50:00',2.78),('12664','2013-05-06','15:55:00',1.69),('12664','2013-05-06','16:00:00',2.24),('12664','2013-05-06','16:05:00',3.56),('12664','2013-05-06','16:10:00',3.23),('12664','2013-05-06','16:15:00',2.31),('12664','2013-05-06','16:20:00',1.31),('12664','2013-05-06','16:25:00',1.85),('12664','2013-05-06','16:30:00',1.19),('12664','2013-05-06','16:35:00',1.83),('12664','2013-05-06','16:40:00',1.02),('12664','2013-05-06','16:45:00',1.01),('12664','2013-05-06','17:00:00',1.22),('12664','2013-05-06','17:05:00',3.31),('12664','2013-05-06','17:10:00',1.07),('12664','2013-05-06','17:15:00',1.64),('12664','2013-05-06','17:20:00',1.05),('12664','2013-05-06','17:25:00',1.98),('12664','2013-05-06','17:30:00',2.54),('12664','2013-05-06','17:35:00',2.5),('12664','2013-05-06','17:40:00',2.15),('12664','2013-05-06','17:45:00',1.25),('12664','2013-05-06','17:50:00',1.35),('12664','2013-05-06','17:55:00',1.49),('12664','2013-05-06','18:00:00',1.22),('12664','2013-05-06','18:05:00',1.36),('12664','2013-05-06','18:10:00',1.65),('12664','2013-05-06','18:15:00',1.35),('12664','2013-05-06','18:20:00',1.2),('12664','2013-05-05','07:45:00',1.05),('12664','2013-05-05','07:50:00',1.1),('12664','2013-05-05','07:55:00',1.14),('12664','2013-05-05','08:00:00',1.14),('12664','2013-05-05','08:05:00',1.35),('12664','2013-05-05','08:10:00',1.51),('12664','2013-05-05','08:15:00',1.61),('12664','2013-05-05','08:20:00',1.84),('12664','2013-05-05','08:25:00',1.16),('12664','2013-05-05','08:30:00',1.02),('12664','2013-05-05','08:35:00',1.23),('12664','2013-05-05','08:40:00',1.64),('12664','2013-05-05','08:45:00',1.42),('12664','2013-05-05','08:50:00',1.34),('12664','2013-05-05','08:55:00',1.37),('12664','2013-05-05','09:00:00',1.72),('12664','2013-05-05','09:05:00',2.02),('12664','2013-05-05','09:10:00',1.56),('12664','2013-05-05','09:15:00',1.51),('12664','2013-05-05','09:20:00',1.85),('12664','2013-05-05','09:25:00',3.14),('12664','2013-05-05','09:30:00',1.65),('12664','2013-05-05','09:35:00',3.37),('12664','2013-05-05','09:40:00',2.11),('12664','2013-05-05','09:45:00',2.08),('12664','2013-05-05','09:50:00',1.85),('12664','2013-05-05','09:55:00',1.56),('12664','2013-05-05','10:00:00',1.21),('12664','2013-05-05','10:05:00',1.33),('12664','2013-05-05','10:10:00',1.41),('12664','2013-05-05','10:15:00',1.51),('12664','2013-05-05','10:20:00',1.42),('12664','2013-05-05','10:25:00',1.59),('12664','2013-05-05','10:30:00',1.73),('12664','2013-05-05','10:35:00',1.52),('12664','2013-05-05','10:40:00',1.19),('12664','2013-05-05','10:45:00',1.06),('12664','2013-05-05','10:50:00',1.09),('12664','2013-05-05','10:55:00',1.25),('12664','2013-05-05','11:00:00',1.51),('12664','2013-05-05','11:05:00',1.61),('12664','2013-05-05','11:10:00',3.85),('12664','2013-05-05','11:15:00',4.34),('12664','2013-05-05','11:20:00',3.62),('12664','2013-05-05','11:25:00',4.67),('12664','2013-05-05','11:30:00',3.46),('12664','2013-05-05','11:35:00',2.99),('12664','2013-05-05','11:40:00',2.51),('12664','2013-05-05','11:45:00',2.55),('12664','2013-05-05','11:50:00',3.29),('12664','2013-05-05','11:55:00',4.56),('12664','2013-05-05','12:00:00',3.89),('12664','2013-05-05','12:05:00',4.23),('12664','2013-05-05','12:10:00',4.9),('12664','2013-05-05','12:15:00',5.03),('12664','2013-05-05','12:20:00',4.4),('12664','2013-05-05','12:25:00',4.47),('12664','2013-05-05','12:30:00',4.8),('12664','2013-05-05','12:35:00',4.6),('12664','2013-05-05','12:40:00',4.63),('12664','2013-05-05','12:45:00',4.59),('12664','2013-05-05','12:50:00',4.77),('12664','2013-05-05','12:55:00',1.65),('12664','2013-05-05','13:00:00',1.46),('12664','2013-05-05','13:05:00',4.42),('12664','2013-05-05','13:10:00',4.47),('12664','2013-05-05','13:15:00',4.36),('12664','2013-05-05','13:20:00',4.43),('12664','2013-05-05','13:25:00',4.3),('12664','2013-05-05','13:30:00',3.07),('12664','2013-05-05','13:35:00',2.92),('12664','2013-05-05','13:40:00',3.01),('12664','2013-05-05','13:45:00',3.56),('12664','2013-05-05','13:50:00',3.2),('12664','2013-05-05','13:55:00',3.53),('12664','2013-05-05','14:00:00',4.16),('12664','2013-05-05','14:05:00',4.94),('12664','2013-05-05','14:10:00',3.94),('12664','2013-05-05','14:15:00',4.36),('12664','2013-05-05','14:20:00',4.28),('12664','2013-05-05','14:25:00',4.11),('12664','2013-05-05','14:30:00',4.06),('12664','2013-05-05','14:35:00',4.06),('12664','2013-05-05','14:40:00',4.05),('12664','2013-05-05','14:45:00',3.99),('12664','2013-05-05','14:50:00',3.92),('12664','2013-05-05','14:55:00',3.89),('12664','2013-05-05','15:00:00',3.85),('12664','2013-05-05','15:05:00',3.83),('12664','2013-05-05','15:10:00',3.78),('12664','2013-05-05','15:15:00',3.71),('12664','2013-05-05','15:20:00',3.49),('12664','2013-05-05','15:25:00',3.65),('12664','2013-05-05','15:30:00',3.6),('12664','2013-05-05','15:35:00',3.53),('12664','2013-05-05','15:40:00',3.5),('12664','2013-05-05','15:45:00',3.44),('12664','2013-05-05','15:50:00',3.36),('12664','2013-05-05','15:55:00',3.3),('12664','2013-05-05','16:00:00',3.28),('12664','2013-05-05','16:05:00',3.19),('12664','2013-05-05','16:10:00',3.13),('12664','2013-05-05','16:15:00',3.09),('12664','2013-05-05','16:20:00',3.04),('12664','2013-05-05','16:25:00',2.95),('12664','2013-05-05','16:30:00',2.89),('12664','2013-05-05','16:35:00',2.83),('12664','2013-05-05','16:40:00',2.75),('12664','2013-05-05','16:45:00',2.68),('12664','2013-05-05','16:50:00',2.59),('12664','2013-05-05','16:55:00',2.5),('12664','2013-05-05','17:00:00',2.42),('12664','2013-05-05','17:05:00',2.33),('12664','2013-05-05','17:10:00',2.26),('12664','2013-05-05','17:15:00',2.18),('12664','2013-05-05','17:20:00',2.07),('12664','2013-05-05','17:25:00',1.97),('12664','2013-05-05','17:30:00',1.89),('12664','2013-05-05','17:35:00',1.81),('12664','2013-05-05','17:40:00',1.7),('12664','2013-05-05','17:45:00',1.6),('12664','2013-05-05','17:50:00',1.52),('12664','2013-05-05','17:55:00',1.43),('12664','2013-05-05','18:00:00',1.33),('12664','2013-05-05','18:05:00',1.24),('12664','2013-05-05','18:10:00',1.14),('12664','2013-05-05','18:15:00',1.06),('12664','2013-05-04','07:45:00',1.02),('12664','2013-05-04','07:50:00',1.09),('12664','2013-05-04','07:55:00',1.2),('12664','2013-05-04','08:00:00',1.26),('12664','2013-05-04','08:05:00',1.33),('12664','2013-05-04','08:10:00',1.43),('12664','2013-05-04','08:15:00',1.52),('12664','2013-05-04','08:20:00',1.59),('12664','2013-05-04','08:25:00',1.68),('12664','2013-05-04','08:30:00',1.77),('12664','2013-05-04','08:35:00',1.85),('12664','2013-05-04','08:40:00',1.94),('12664','2013-05-04','08:45:00',2.03),('12664','2013-05-04','08:50:00',2.11),('12664','2013-05-04','08:55:00',2.21),('12664','2013-05-04','09:00:00',2.3),('12664','2013-05-04','09:05:00',2.38),('12664','2013-05-04','09:10:00',2.4),('12664','2013-05-04','09:15:00',2.42),('12664','2013-05-04','09:20:00',2.51),('12664','2013-05-04','09:25:00',2.68),('12664','2013-05-04','09:30:00',2.73),('12664','2013-05-04','09:35:00',2.77),('12664','2013-05-04','09:40:00',2.88),('12664','2013-05-04','09:45:00',2.98),('12664','2013-05-04','09:50:00',3.06),('12664','2013-05-04','09:55:00',3.23),('12664','2013-05-04','10:00:00',3.05),('12664','2013-05-04','10:05:00',3.29),('12664','2013-05-04','10:10:00',3.36),('12664','2013-05-04','10:15:00',3.41),('12664','2013-05-04','10:20:00',3.49),('12664','2013-05-04','10:25:00',3.53),('12664','2013-05-04','10:30:00',3.55),('12664','2013-05-04','10:35:00',3.51),('12664','2013-05-04','10:40:00',3.49),('12664','2013-05-04','10:45:00',3.46),('12664','2013-05-04','10:50:00',3.57),('12664','2013-05-04','10:55:00',3.78),('12664','2013-05-04','11:00:00',3.86),('12664','2013-05-04','11:05:00',3.88),('12664','2013-05-04','11:10:00',3.84),('12664','2013-05-04','11:15:00',3.5),('12664','2013-05-04','11:20:00',3.46),('12664','2013-05-04','11:25:00',3.95),('12664','2013-05-04','11:30:00',3.73),('12664','2013-05-04','11:35:00',3.66),('12664','2013-05-04','11:40:00',3.73),('12664','2013-05-04','11:45:00',3.56),('12664','2013-05-04','11:50:00',3.47),('12664','2013-05-04','11:55:00',3.57),('12664','2013-05-04','12:00:00',3.68),('12664','2013-05-04','12:05:00',3.68),('12664','2013-05-04','12:10:00',3.7),('12664','2013-05-04','12:15:00',3.9),('12664','2013-05-04','12:20:00',4.06),('12664','2013-05-04','12:25:00',4.04),('12664','2013-05-04','12:30:00',4.16),('12664','2013-05-04','12:35:00',4.12),('12664','2013-05-04','12:40:00',4.18),('12664','2013-05-04','12:45:00',4.16),('12664','2013-05-04','12:50:00',4.1),('12664','2013-05-04','12:55:00',3.96),('12664','2013-05-04','13:00:00',4),('12664','2013-05-04','13:05:00',4.07),('12664','2013-05-04','13:10:00',4.11),('12664','2013-05-04','13:15:00',4.1),('12664','2013-05-04','13:20:00',4.13),('12664','2013-05-04','13:25:00',4.18),('12664','2013-05-04','13:30:00',4.12),('12664','2013-05-04','13:35:00',3.97),('12664','2013-05-04','13:40:00',4.19),('12664','2013-05-04','13:45:00',3.77),('12664','2013-05-04','13:50:00',3.28),('12664','2013-05-04','13:55:00',3.65),('12664','2013-05-04','14:00:00',3.99),('12664','2013-05-04','14:05:00',3.73),('12664','2013-05-04','14:10:00',3.8),('12664','2013-05-04','14:15:00',3.87),('12664','2013-05-04','14:20:00',3.62),('12664','2013-05-04','14:25:00',3.72),('12664','2013-05-04','14:30:00',3.63),('12664','2013-05-04','14:35:00',3.56),('12664','2013-05-04','14:40:00',3.5),('12664','2013-05-04','14:45:00',3.48),('12664','2013-05-04','14:50:00',3.3),('12664','2013-05-04','14:55:00',3.5),('12664','2013-05-04','15:00:00',3.55),('12664','2013-05-04','15:05:00',3.27),('12664','2013-05-04','15:10:00',3.45),('12664','2013-05-04','15:15:00',3.5),('12664','2013-05-04','15:20:00',3.52),('12664','2013-05-04','15:25:00',3.53),('12664','2013-05-04','15:30:00',3.49),('12664','2013-05-04','15:35:00',3.34),('12664','2013-05-04','15:40:00',3.47),('12664','2013-05-04','15:45:00',3.39),('12664','2013-05-04','15:50:00',3.29),('12664','2013-05-04','15:55:00',3.22),('12664','2013-05-04','16:00:00',3.15),('12664','2013-05-04','16:05:00',3.07),('12664','2013-05-04','16:10:00',3.02),('12664','2013-05-04','16:15:00',2.95),('12664','2013-05-04','16:20:00',2.88),('12664','2013-05-04','16:25:00',2.81),('12664','2013-05-04','16:30:00',2.73),('12664','2013-05-04','16:35:00',2.66),('12664','2013-05-04','16:40:00',2.59),('12664','2013-05-04','16:45:00',2.51),('12664','2013-05-04','16:50:00',2.43),('12664','2013-05-04','16:55:00',2.36),('12664','2013-05-04','17:00:00',2.28),('12664','2013-05-04','17:05:00',2.21),('12664','2013-05-04','17:10:00',2.05),('12664','2013-05-04','17:15:00',1.56),('12664','2013-05-04','17:20:00',1.97),('12664','2013-05-04','17:25:00',1.9),('12664','2013-05-04','17:30:00',1.78),('12664','2013-05-04','17:35:00',1.67),('12664','2013-05-04','17:40:00',1.53),('12664','2013-05-04','17:45:00',1.35),('12664','2013-05-04','17:50:00',1.46),('12664','2013-05-04','17:55:00',1.36),('12664','2013-05-04','18:00:00',1.26),('12664','2013-05-04','18:05:00',1.17),('12664','2013-05-04','18:10:00',1.02),('12664','2013-05-03','08:15:00',1.11),('12664','2013-05-03','08:20:00',1.39),('12664','2013-05-03','08:25:00',1.45),('12664','2013-05-03','08:30:00',1.35),('12664','2013-05-03','08:35:00',1.24),('12664','2013-05-03','08:40:00',1.21),('12664','2013-05-03','08:45:00',1.19),('12664','2013-05-03','08:50:00',1.77),('12664','2013-05-03','08:55:00',1.86),('12664','2013-05-03','09:00:00',2.09),('12664','2013-05-03','09:05:00',2.19),('12664','2013-05-03','09:10:00',2.44),('12664','2013-05-03','09:15:00',2.59),('12664','2013-05-03','09:20:00',2.77),('12664','2013-05-03','09:25:00',2.84),('12664','2013-05-03','09:30:00',2.88),('12664','2013-05-03','09:35:00',2.97),('12664','2013-05-03','09:40:00',3.05),('12664','2013-05-03','09:45:00',3.13),('12664','2013-05-03','09:50:00',3.2),('12664','2013-05-03','09:55:00',3.26),('12664','2013-05-03','10:00:00',3.32),('12664','2013-05-03','10:05:00',3.4),('12664','2013-05-03','10:10:00',3.48),('12664','2013-05-03','10:15:00',3.54),('12664','2013-05-03','10:20:00',3.59),('12664','2013-05-03','10:25:00',3.64),('12664','2013-05-03','10:30:00',3.7),('12664','2013-05-03','10:35:00',3.74),('12664','2013-05-03','10:40:00',3.79),('12664','2013-05-03','10:45:00',3.82),('12664','2013-05-03','10:50:00',3.86),('12664','2013-05-03','10:55:00',3.9),('12664','2013-05-03','11:00:00',3.92),('12664','2013-05-03','11:05:00',3.95),('12664','2013-05-03','11:10:00',3.98),('12664','2013-05-03','11:15:00',4.02),('12664','2013-05-03','11:20:00',4.05),('12664','2013-05-03','11:25:00',4.07),('12664','2013-05-03','11:30:00',4.12),('12664','2013-05-03','11:35:00',4.13),('12664','2013-05-03','11:40:00',4.14),('12664','2013-05-03','11:45:00',4.19),('12664','2013-05-03','11:50:00',4.2),('12664','2013-05-03','11:55:00',4.22),('12664','2013-05-03','12:00:00',4.23),('12664','2013-05-03','12:05:00',4.23),('12664','2013-05-03','12:10:00',4.21),('12664','2013-05-03','12:15:00',4.24),('12664','2013-05-03','12:20:00',4.24),('12664','2013-05-03','12:25:00',4.24),('12664','2013-05-03','12:30:00',4.27),('12664','2013-05-03','12:35:00',4.24),('12664','2013-05-03','12:40:00',4.34),('12664','2013-05-03','12:45:00',4.3),('12664','2013-05-03','12:50:00',4.37),('12664','2013-05-03','12:55:00',4.32),('12664','2013-05-03','13:00:00',4.35),('12664','2013-05-03','13:05:00',4.37),('12664','2013-05-03','13:10:00',4.36),('12664','2013-05-03','13:15:00',4.31),('12664','2013-05-03','13:20:00',4.29),('12664','2013-05-03','13:25:00',4.22),('12664','2013-05-03','13:30:00',4.09),('12664','2013-05-03','13:35:00',4.21),('12664','2013-05-03','13:40:00',4.13),('12664','2013-05-03','13:45:00',4.24),('12664','2013-05-03','13:50:00',4.16),('12664','2013-05-03','13:55:00',4.15),('12664','2013-05-03','14:00:00',4.16),('12664','2013-05-03','14:05:00',4.07),('12664','2013-05-03','14:10:00',4.21),('12664','2013-05-03','14:15:00',4.28),('12664','2013-05-03','14:20:00',4.24),('12664','2013-05-03','14:25:00',4.2),('12664','2013-05-03','14:30:00',4.19),('12664','2013-05-03','14:35:00',4.16),('12664','2013-05-03','14:40:00',4.12),('12664','2013-05-03','14:45:00',4.05),('12664','2013-05-03','14:50:00',4.01),('12664','2013-05-03','14:55:00',3.95),('12664','2013-05-03','15:00:00',3.91),('12664','2013-05-03','15:05:00',3.87),('12664','2013-05-03','15:10:00',3.84),('12664','2013-05-03','15:15:00',3.79),('12664','2013-05-03','15:20:00',3.71),('12664','2013-05-03','15:25:00',3.68),('12664','2013-05-03','15:30:00',3.59),('12664','2013-05-03','15:35:00',3.55),('12664','2013-05-03','15:40:00',3.47),('12664','2013-05-03','15:45:00',3.42),('12664','2013-05-03','15:50:00',3.37),('12664','2013-05-03','15:55:00',3.33),('12664','2013-05-03','16:00:00',3.28),('12664','2013-05-03','16:05:00',3.23),('12664','2013-05-03','16:10:00',3.16),('12664','2013-05-03','16:15:00',3.1),('12664','2013-05-03','16:20:00',3.02),('12664','2013-05-03','16:25:00',2.94),('12664','2013-05-03','16:30:00',2.85),('12664','2013-05-03','16:35:00',2.79),('12664','2013-05-03','16:40:00',2.69),('12664','2013-05-03','16:45:00',2.61),('12664','2013-05-03','16:50:00',2.54),('12664','2013-05-03','16:55:00',2.44),('12664','2013-05-03','17:00:00',2.36),('12664','2013-05-03','17:05:00',2.28),('12664','2013-05-03','17:10:00',2.18),('12664','2013-05-03','17:15:00',2.1),('12664','2013-05-03','17:20:00',2),('12664','2013-05-03','17:25:00',1.9),('12664','2013-05-03','17:30:00',1.84),('12664','2013-05-03','17:35:00',1.74),('12664','2013-05-03','17:40:00',1.63),('12664','2013-05-03','17:45:00',1.52),('12664','2013-05-03','17:50:00',1.43),('12664','2013-05-03','17:55:00',1.36),('12664','2013-05-03','18:00:00',1.26),('12664','2013-05-03','18:05:00',1.17),('12664','2013-05-03','18:10:00',1.08),('12664','2013-05-02','08:50:00',2.31),('12664','2013-05-02','08:55:00',1.11),('12664','2013-05-02','09:00:00',1.05),('12664','2013-05-02','09:30:00',2.12),('12664','2013-05-02','09:35:00',1.44),('12664','2013-05-02','09:45:00',1.07),('12664','2013-05-02','09:50:00',2.09),('12664','2013-05-02','09:55:00',1.18),('12664','2013-05-02','10:15:00',1.5),('12664','2013-05-02','10:20:00',2.77),('12664','2013-05-02','10:25:00',3.35),('12664','2013-05-02','10:30:00',2.51),('12664','2013-05-02','10:35:00',4.36),('12664','2013-05-02','10:40:00',3.76),('12664','2013-05-02','10:45:00',3.32),('12664','2013-05-02','10:50:00',2.8),('12664','2013-05-02','10:55:00',3.34),('12664','2013-05-02','11:00:00',3.94),('12664','2013-05-02','11:05:00',3.73),('12664','2013-05-02','11:10:00',2.92),('12664','2013-05-02','11:15:00',3.93),('12664','2013-05-02','11:20:00',4.08),('12664','2013-05-02','11:25:00',4.17),('12664','2013-05-02','11:30:00',4.11),('12664','2013-05-02','11:35:00',3.63),('12664','2013-05-02','11:40:00',4.27),('12664','2013-05-02','11:45:00',4.1),('12664','2013-05-02','11:50:00',4.11),('12664','2013-05-02','11:55:00',4.12),('12664','2013-05-02','12:00:00',3.93),('12664','2013-05-02','12:05:00',4.2),('12664','2013-05-02','12:10:00',4.17),('12664','2013-05-02','12:15:00',4.19),('12664','2013-05-02','12:20:00',4.17),('12664','2013-05-02','12:25:00',4.18),('12664','2013-05-02','12:30:00',4.16),('12664','2013-05-02','12:35:00',4.22),('12664','2013-05-02','12:40:00',4.25),('12664','2013-05-02','12:45:00',4.2),('12664','2013-05-02','12:50:00',4.24),('12664','2013-05-02','12:55:00',4.22),('12664','2013-05-02','13:00:00',4.29),('12664','2013-05-02','13:05:00',4.31),('12664','2013-05-02','13:10:00',4.25),('12664','2013-05-02','13:15:00',4.31),('12664','2013-05-02','13:20:00',4.4),('12664','2013-05-02','13:25:00',4.41),('12664','2013-05-02','13:30:00',4.38),('12664','2013-05-02','13:35:00',4.36),('12664','2013-05-02','13:40:00',4.36),('12664','2013-05-02','13:45:00',4.36),('12664','2013-05-02','13:50:00',4.33),('12664','2013-05-02','13:55:00',4.28),('12664','2013-05-02','14:00:00',4.27),('12664','2013-05-02','14:05:00',4.28),('12664','2013-05-02','14:10:00',4.25),('12664','2013-05-02','14:15:00',4.17),('12664','2013-05-02','14:20:00',4.17),('12664','2013-05-02','14:25:00',4.13),('12664','2013-05-02','14:30:00',4.1),('12664','2013-05-02','14:35:00',4.09),('12664','2013-05-02','14:40:00',4.05),('12664','2013-05-02','14:45:00',4.01),('12664','2013-05-02','14:50:00',3.97),('12664','2013-05-02','14:55:00',3.95),('12664','2013-05-02','15:00:00',3.94),('12664','2013-05-02','15:05:00',3.86),('12664','2013-05-02','15:10:00',3.8),('12664','2013-05-02','15:15:00',3.78),('12664','2013-05-02','15:20:00',3.73),('12664','2013-05-02','15:25:00',3.72),('12664','2013-05-02','15:30:00',3.67),('12664','2013-05-02','15:35:00',3.62),('12664','2013-05-02','15:40:00',3.56),('12664','2013-05-02','15:45:00',3.51),('12664','2013-05-02','15:50:00',3.44),('12664','2013-05-02','15:55:00',3.38),('12664','2013-05-02','16:00:00',3.33),('12664','2013-05-02','16:05:00',3.26),('12664','2013-05-02','16:10:00',3.19),('12664','2013-05-02','16:15:00',3.12),('12664','2013-05-02','16:20:00',3.05),('12664','2013-05-02','16:25:00',2.98),('12664','2013-05-02','16:30:00',2.9),('12664','2013-05-02','16:35:00',2.82),('12664','2013-05-02','16:40:00',2.75),('12664','2013-05-02','16:45:00',2.68),('12664','2013-05-02','16:50:00',2.59),('12664','2013-05-02','16:55:00',2.51),('12664','2013-05-02','17:00:00',2.42),('12664','2013-05-02','17:05:00',2.33),('12664','2013-05-02','17:10:00',2.23),('12664','2013-05-02','17:15:00',2.14),('12664','2013-05-02','17:20:00',2.05),('12664','2013-05-02','17:25:00',1.96),('12664','2013-05-02','17:30:00',1.88),('12664','2013-05-02','17:35:00',1.79),('12664','2013-05-02','17:40:00',1.7),('12664','2013-05-02','17:45:00',1.61),('12664','2013-05-02','17:50:00',1.51),('12664','2013-05-02','17:55:00',1.42),('12664','2013-05-02','18:00:00',1.33),('12664','2013-05-02','18:05:00',1.23),('12664','2013-05-02','18:10:00',1.14),('12664','2013-05-02','18:15:00',1.05),('12664','2013-05-01','07:55:00',1.05),('12664','2013-05-01','08:00:00',1.12),('12664','2013-05-01','08:05:00',1.17),('12664','2013-05-01','08:10:00',1.29),('12664','2013-05-01','08:15:00',1.39),('12664','2013-05-01','08:20:00',1.49),('12664','2013-05-01','08:25:00',1.6),('12664','2013-05-01','08:30:00',1.7),('12664','2013-05-01','08:35:00',1.8),('12664','2013-05-01','08:40:00',1.88),('12664','2013-05-01','08:45:00',1.99),('12664','2013-05-01','08:50:00',2.08),('12664','2013-05-01','08:55:00',2.19),('12664','2013-05-01','09:00:00',2.26),('12664','2013-05-01','09:05:00',2.32),('12664','2013-05-01','09:10:00',2.38),('12664','2013-05-01','09:15:00',2.44),('12664','2013-05-01','09:20:00',2.49),('12664','2013-05-01','09:25:00',2.5),('12664','2013-05-01','09:30:00',2.64),('12664','2013-05-01','09:35:00',2.71),('12664','2013-05-01','09:40:00',2.77),('12664','2013-05-01','09:45:00',2.83),('12664','2013-05-01','09:50:00',2.9),('12664','2013-05-01','09:55:00',2.95),('12664','2013-05-01','10:00:00',3.04),('12664','2013-05-01','10:05:00',3.12),('12664','2013-05-01','10:10:00',3.19),('12664','2013-05-01','10:15:00',3.23),('12664','2013-05-01','10:20:00',3.3),('12664','2013-05-01','10:25:00',3.41),('12664','2013-05-01','10:30:00',3.51),('12664','2013-05-01','10:35:00',3.62),('12664','2013-05-01','10:40:00',3.68),('12664','2013-05-01','10:45:00',3.71),('12664','2013-05-01','10:50:00',3.77),('12664','2013-05-01','10:55:00',3.83),('12664','2013-05-01','11:00:00',3.85),('12664','2013-05-01','11:05:00',3.85),('12664','2013-05-01','11:10:00',3.97),('12664','2013-05-01','11:15:00',3.93),('12664','2013-05-01','11:20:00',3.93),('12664','2013-05-01','11:25:00',4.08),('12664','2013-05-01','11:30:00',3.88),('12664','2013-05-01','11:35:00',3.97),('12664','2013-05-01','11:40:00',3.28),('12664','2013-05-01','11:45:00',4.08),('12664','2013-05-01','11:50:00',4.17),('12664','2013-05-01','11:55:00',4.12),('12664','2013-05-01','12:00:00',4.11),('12664','2013-05-01','12:05:00',4.14),('12664','2013-05-01','12:10:00',4.08),('12664','2013-05-01','12:15:00',4.09),('12664','2013-05-01','12:20:00',4.09),('12664','2013-05-01','12:25:00',4.12),('12664','2013-05-01','12:30:00',4.15),('12664','2013-05-01','12:35:00',4.27),('12664','2013-05-01','12:40:00',4.15),('12664','2013-05-01','12:45:00',2.35),('12664','2013-05-01','12:50:00',1.64),('12664','2013-05-01','12:55:00',1.54),('12664','2013-05-01','13:00:00',1.55),('12664','2013-05-01','13:05:00',1.74),('12664','2013-05-01','13:10:00',2.31),('12664','2013-05-01','13:15:00',3.9),('12664','2013-05-01','13:20:00',4.74),('12664','2013-05-01','13:25:00',3.58),('12664','2013-05-01','13:30:00',4.92),('12664','2013-05-01','13:35:00',4.38),('12664','2013-05-01','13:40:00',4.2),('12664','2013-05-01','13:45:00',4.47),('12664','2013-05-01','13:50:00',4.38),('12664','2013-05-01','13:55:00',4.22),('12664','2013-05-01','14:00:00',4.28),('12664','2013-05-01','14:05:00',4.34),('12664','2013-05-01','14:10:00',4.09),('12664','2013-05-01','14:15:00',4.18),('12664','2013-05-01','14:20:00',3.92),('12664','2013-05-01','14:25:00',4.3),('12664','2013-05-01','14:30:00',4.27),('12664','2013-05-01','14:35:00',4.21),('12664','2013-05-01','14:40:00',3.34),('12664','2013-05-01','14:45:00',3.21),('12664','2013-05-01','14:50:00',2.88),('12664','2013-05-01','14:55:00',3.08),('12664','2013-05-01','15:00:00',2.49),('12664','2013-05-01','15:05:00',3.07),('12664','2013-05-01','15:10:00',3.85),('12664','2013-05-01','15:15:00',2.96),('12664','2013-05-01','15:20:00',3.11),('12664','2013-05-01','15:25:00',2.67),('12664','2013-05-01','15:30:00',2.49),('12664','2013-05-01','15:35:00',2.33),('12664','2013-05-01','15:40:00',2.25),('12664','2013-05-01','15:45:00',2.02),('12664','2013-05-01','15:50:00',1.8),('12664','2013-05-01','15:55:00',1.84),('12664','2013-05-01','16:00:00',2.14),('12664','2013-05-01','16:05:00',2.14),('12664','2013-05-01','16:10:00',2.04),('12664','2013-05-01','16:15:00',1.9),('12664','2013-05-01','16:20:00',1.77),('12664','2013-05-01','16:25:00',1.38),('12664','2013-05-01','16:30:00',1.17),('12664','2013-05-01','16:35:00',1.18),('12664','2013-05-01','16:40:00',1.21),('12664','2013-05-01','16:45:00',1.12),('12664','2014-03-29','07:25:00',1.01),('12664','2014-03-29','07:30:00',1.09),('12664','2014-03-29','07:35:00',1.19),('12664','2014-03-29','07:40:00',1.29),('12664','2014-03-29','07:45:00',1.4),('12664','2014-03-29','07:50:00',1.49),('12664','2014-03-29','07:55:00',1.59),('12664','2014-03-29','08:00:00',1.69),('12664','2014-03-29','08:05:00',1.78),('12664','2014-03-29','08:10:00',1.89),('12664','2014-03-29','08:15:00',1.98),('12664','2014-03-29','08:20:00',2.07),('12664','2014-03-29','08:25:00',2.14),('12664','2014-03-29','08:30:00',2.24),('12664','2014-03-29','08:35:00',2.32),('12664','2014-03-29','08:40:00',2.4),('12664','2014-03-29','08:45:00',2.46),('12664','2014-03-29','08:50:00',2.52),('12664','2014-03-29','08:55:00',2.61),('12664','2014-03-29','09:00:00',2.67),('12664','2014-03-29','09:05:00',2.73),('12664','2014-03-29','09:10:00',2.82),('12664','2014-03-29','09:15:00',2.88),('12664','2014-03-29','09:20:00',2.93),('12664','2014-03-29','09:25:00',2.99),('12664','2014-03-29','09:30:00',3.06),('12664','2014-03-29','09:35:00',3.12),('12664','2014-03-29','09:40:00',3.19),('12664','2014-03-29','09:45:00',3.24),('12664','2014-03-29','09:50:00',3.28),('12664','2014-03-29','09:55:00',3.33),('12664','2014-03-29','10:00:00',3.39),('12664','2014-03-29','10:05:00',3.44),('12664','2014-03-29','10:10:00',3.46),('12664','2014-03-29','10:15:00',3.53),('12664','2014-03-29','10:20:00',3.58),('12664','2014-03-29','10:25:00',3.58),('12664','2014-03-29','10:30:00',3.6),('12664','2014-03-29','10:35:00',3.64),('12664','2014-03-29','10:40:00',3.68),('12664','2014-03-29','10:45:00',3.71),('12664','2014-03-29','10:50:00',3.74),('12664','2014-03-29','10:55:00',3.78),('12664','2014-03-29','11:00:00',3.81),('12664','2014-03-29','11:05:00',3.8),('12664','2014-03-29','11:10:00',3.79),('12664','2014-03-29','11:15:00',3.83),('12664','2014-03-29','11:20:00',3.87),('12664','2014-03-29','11:25:00',3.89),('12664','2014-03-29','11:30:00',3.88),('12664','2014-03-29','11:35:00',3.75),('12664','2014-03-29','11:40:00',3.89),('12664','2014-03-29','11:45:00',3.85),('12664','2014-03-29','11:50:00',3.91),('12664','2014-03-29','11:55:00',3.94),('12664','2014-03-29','12:00:00',3.96),('12664','2014-03-29','12:05:00',3.95),('12664','2014-03-29','12:10:00',3.96),('12664','2014-03-29','12:15:00',3.97),('12664','2014-03-29','12:20:00',3.93),('12664','2014-03-29','12:25:00',3.89),('12664','2014-03-29','12:30:00',3.54),('12664','2014-03-29','12:35:00',3.67),('12664','2014-03-29','12:40:00',3.83),('12664','2014-03-29','12:45:00',3.16),('12664','2014-03-29','12:50:00',3.88),('12664','2014-03-29','12:55:00',2.5),('12664','2014-03-29','13:00:00',3),('12664','2014-03-29','13:05:00',3.92),('12664','2014-03-29','13:10:00',3.89),('12664','2014-03-29','13:15:00',3.83),('12664','2014-03-29','13:20:00',4.07),('12664','2014-03-29','13:25:00',3.98),('12664','2014-03-29','13:30:00',3.67),('12664','2014-03-29','13:35:00',2.78),('12664','2014-03-29','13:40:00',2.62),('12664','2014-03-29','13:45:00',3.76),('12664','2014-03-29','13:50:00',3.11),('12664','2014-03-29','13:55:00',2.08),('12664','2014-03-29','14:00:00',3.41),('12664','2014-03-29','14:05:00',3.45),('12664','2014-03-29','14:10:00',3.47),('12664','2014-03-29','14:15:00',3.43),('12664','2014-03-29','14:20:00',3.34),('12664','2014-03-29','14:25:00',3.3),('12664','2014-03-29','14:30:00',3.22),('12664','2014-03-29','14:35:00',3.19),('12664','2014-03-29','14:40:00',3.15),('12664','2014-03-29','14:45:00',3.05),('12664','2014-03-29','14:50:00',3),('12664','2014-03-29','14:55:00',2.9),('12664','2014-03-29','15:00:00',2.84),('12664','2014-03-29','15:05:00',2.79),('12664','2014-03-29','15:10:00',2.68),('12664','2014-03-29','15:15:00',2.62),('12664','2014-03-29','15:20:00',2.55),('12664','2014-03-29','15:25:00',2.49),('12664','2014-03-29','15:30:00',2.39),('12664','2014-03-29','15:35:00',2.31),('12664','2014-03-29','15:40:00',2.22),('12664','2014-03-29','15:45:00',2.15),('12664','2014-03-29','15:50:00',2.06),('12664','2014-03-29','15:55:00',1.99),('12664','2014-03-29','16:00:00',1.92),('12664','2014-03-29','16:05:00',1.8),('12664','2014-03-29','16:10:00',1.71),('12664','2014-03-29','16:15:00',1.53),('12664','2014-03-29','16:20:00',1.5),('12664','2014-03-29','16:25:00',1.45),('12664','2014-03-29','16:30:00',1.35),('12664','2014-03-29','16:35:00',1.1),('12664','2014-03-29','16:50:00',1),('12664','2013-04-30','08:40:00',1.07),('12664','2013-04-30','08:45:00',1.12),('12664','2013-04-30','08:50:00',1.69),('12664','2013-04-30','08:55:00',2.41),('12664','2013-04-30','09:00:00',2.61),('12664','2013-04-30','09:05:00',1.91),('12664','2013-04-30','09:10:00',1.82),('12664','2013-04-30','09:15:00',2.83),('12664','2013-04-30','09:20:00',2.64),('12664','2013-04-30','09:25:00',1.99),('12664','2013-04-30','09:30:00',1.73),('12664','2013-04-30','09:35:00',2.81),('12664','2013-04-30','09:40:00',2.35),('12664','2013-04-30','09:45:00',2.52),('12664','2013-04-30','09:50:00',2.94),('12664','2013-04-30','09:55:00',2.87),('12664','2013-04-30','10:00:00',2.94),('12664','2013-04-30','10:05:00',1.91),('12664','2013-04-30','10:10:00',1.91),('12664','2013-04-30','10:15:00',2.2),('12664','2013-04-30','10:20:00',2.7),('12664','2013-04-30','10:25:00',2.41),('12664','2013-04-30','10:30:00',1.87),('12664','2013-04-30','10:35:00',1.54),('12664','2013-04-30','10:40:00',1.69),('12664','2013-04-30','10:45:00',2.16),('12664','2013-04-30','10:50:00',1.92),('12664','2013-04-30','10:55:00',2.04),('12664','2013-04-30','11:00:00',2.58),('12664','2013-04-30','11:05:00',2),('12664','2013-04-30','11:10:00',2.35),('12664','2013-04-30','11:15:00',2.16),('12664','2013-04-30','11:20:00',2.36),('12664','2013-04-30','11:25:00',2.24),('12664','2013-04-30','11:30:00',2.16),('12664','2013-04-30','11:35:00',2.46),('12664','2013-04-30','11:40:00',2.2),('12664','2013-04-30','11:45:00',1.6),('12664','2013-04-30','11:50:00',1.47),('12664','2013-04-30','11:55:00',1.65),('12664','2013-04-30','12:00:00',2.52),('12664','2013-04-30','12:05:00',1.98),('12664','2013-04-30','12:10:00',2.07),('12664','2013-04-30','12:15:00',2.87),('12664','2013-04-30','12:20:00',2.47),('12664','2013-04-30','12:25:00',1.64),('12664','2013-04-30','12:30:00',1.68),('12664','2013-04-30','12:35:00',3.31),('12664','2013-04-30','12:40:00',4.95),('12664','2013-04-30','12:45:00',4.51),('12664','2013-04-30','12:50:00',4.16),('12664','2013-04-30','12:55:00',3.94),('12664','2013-04-30','13:00:00',4.19),('12664','2013-04-30','13:05:00',4.37),('12664','2013-04-30','13:10:00',4.26),('12664','2013-04-30','13:15:00',4.22),('12664','2013-04-30','13:20:00',4.18),('12664','2013-04-30','13:25:00',4.07),('12664','2013-04-30','13:30:00',4.16),('12664','2013-04-30','13:35:00',4.12),('12664','2013-04-30','13:40:00',4.08),('12664','2013-04-30','13:45:00',4.04),('12664','2013-04-30','13:50:00',4.01),('12664','2013-04-30','13:55:00',3.99),('12664','2013-04-30','14:00:00',3.99),('12664','2013-04-30','14:05:00',3.96),('12664','2013-04-30','14:10:00',3.92),('12664','2013-04-30','14:15:00',3.9),('12664','2013-04-30','14:20:00',3.86),('12664','2013-04-30','14:25:00',3.81),('12664','2013-04-30','14:30:00',3.76),('12664','2013-04-30','14:35:00',3.76),('12664','2013-04-30','14:40:00',3.72),('12664','2013-04-30','14:45:00',3.69),('12664','2013-04-30','14:50:00',3.64),('12664','2013-04-30','14:55:00',3.61),('12664','2013-04-30','15:00:00',3.56),('12664','2013-04-30','15:05:00',3.59),('12664','2013-04-30','15:10:00',3.58),('12664','2013-04-30','15:15:00',3.54),('12664','2013-04-30','15:20:00',3.48),('12664','2013-04-30','15:25:00',3.43),('12664','2013-04-30','15:30:00',3.38),('12664','2013-04-30','15:35:00',3.32),('12664','2013-04-30','15:40:00',3.25),('12664','2013-04-30','15:45:00',3.21),('12664','2013-04-30','15:50:00',3.16),('12664','2013-04-30','15:55:00',3.1),('12664','2013-04-30','16:00:00',3.04),('12664','2013-04-30','16:05:00',2.98),('12664','2013-04-30','16:10:00',2.91),('12664','2013-04-30','16:15:00',2.82),('12664','2013-04-30','16:20:00',2.74),('12664','2013-04-30','16:25:00',2.69),('12664','2013-04-30','16:30:00',2.6),('12664','2013-04-30','16:35:00',2.45),('12664','2013-04-30','16:40:00',2.05),('12664','2013-04-30','16:45:00',1.26),('12664','2013-04-30','16:50:00',1.46),('12664','2013-04-30','16:55:00',1.67),('12664','2013-04-30','17:00:00',1.62),('12664','2013-04-30','17:05:00',1.15),('12664','2013-04-30','17:15:00',1.05),('12664','2013-04-30','17:20:00',1.27),('12664','2013-04-30','17:25:00',1.54),('12664','2013-04-30','17:30:00',1.58),('12664','2013-04-30','17:35:00',1.52),('12664','2013-04-30','17:40:00',1.44),('12664','2013-04-30','17:45:00',1.35),('12664','2013-04-30','17:50:00',1.26),('12664','2013-04-30','17:55:00',1.18),('12664','2013-04-30','18:00:00',1.09),('12664','2013-04-30','18:05:00',1.01),('12664','2013-04-29','07:50:00',1.05),('12664','2013-04-29','07:55:00',1.19),('12664','2013-04-29','08:00:00',1.24),('12664','2013-04-29','08:05:00',1.26),('12664','2013-04-29','08:10:00',1.17),('12664','2013-04-29','08:15:00',1.4),('12664','2013-04-29','08:20:00',1.64),('12664','2013-04-29','08:25:00',1.84),('12664','2013-04-29','08:30:00',2.1),('12664','2013-04-29','08:35:00',2.23),('12664','2013-04-29','08:40:00',1.92),('12664','2013-04-29','08:45:00',2.08),('12664','2013-04-29','08:50:00',2.07),('12664','2013-04-29','08:55:00',2.13),('12664','2013-04-29','09:00:00',2.28),('12664','2013-04-29','09:05:00',2.45),('12664','2013-04-29','09:10:00',1.99),('12664','2013-04-29','09:15:00',2.13),('12664','2013-04-29','09:20:00',2.48),('12664','2013-04-29','09:25:00',2.54),('12664','2013-04-29','09:30:00',2.53),('12664','2013-04-29','09:35:00',2.6),('12664','2013-04-29','09:40:00',2.6),('12664','2013-04-29','09:45:00',2.75),('12664','2013-04-29','09:50:00',2.55),('12664','2013-04-29','09:55:00',2.76),('12664','2013-04-29','10:00:00',2.9),('12664','2013-04-29','10:05:00',2.99),('12664','2013-04-29','10:10:00',2.59),('12664','2013-04-29','10:15:00',2.82),('12664','2013-04-29','10:20:00',3.49),('12664','2013-04-29','10:25:00',3.7),('12664','2013-04-29','10:30:00',3.59),('12664','2013-04-29','10:35:00',2.89),('12664','2013-04-29','10:40:00',3.02),('12664','2013-04-29','10:45:00',3.34),('12664','2013-04-29','10:50:00',3.46),('12664','2013-04-29','10:55:00',3.31),('12664','2013-04-29','11:00:00',3.2),('12664','2013-04-29','11:05:00',3.67),('12664','2013-04-29','11:10:00',3.68),('12664','2013-04-29','11:15:00',3.69),('12664','2013-04-29','11:20:00',4.1),('12664','2013-04-29','11:25:00',3.38),('12664','2013-04-29','11:30:00',3.77),('12664','2013-04-29','11:35:00',3.45),('12664','2013-04-29','11:40:00',3.91),('12664','2013-04-29','11:45:00',3.98),('12664','2013-04-29','11:50:00',3.94),('12664','2013-04-29','11:55:00',4.16),('12664','2013-04-29','12:00:00',4.12),('12664','2013-04-29','12:05:00',4.11),('12664','2013-04-29','12:10:00',4.13),('12664','2013-04-29','12:15:00',4.1),('12664','2013-04-29','12:20:00',4.16),('12664','2013-04-29','12:25:00',4.26),('12664','2013-04-29','12:30:00',4.26),('12664','2013-04-29','12:35:00',4.22),('12664','2013-04-29','12:40:00',4.17),('12664','2013-04-29','12:45:00',4.1),('12664','2013-04-29','12:50:00',3.87),('12664','2013-04-29','12:55:00',3.95),('12664','2013-04-29','13:00:00',4.02),('12664','2013-04-29','13:05:00',3.92),('12664','2013-04-29','13:10:00',3.93),('12664','2013-04-29','13:15:00',3.87),('12664','2013-04-29','13:20:00',4.26),('12664','2013-04-29','13:25:00',4.22),('12664','2013-04-29','13:30:00',4.2),('12664','2013-04-29','13:35:00',4.29),('12664','2013-04-29','13:40:00',4.26),('12664','2013-04-29','13:45:00',4.07),('12664','2013-04-29','13:50:00',4.05),('12664','2013-04-29','13:55:00',4.21),('12664','2013-04-29','14:00:00',4.16),('12664','2013-04-29','14:05:00',4.18),('12664','2013-04-29','14:10:00',4.12),('12664','2013-04-29','14:15:00',4.12),('12664','2013-04-29','14:20:00',4.05),('12664','2013-04-29','14:25:00',3.91),('12664','2013-04-29','14:30:00',3.66),('12664','2013-04-29','14:35:00',3.49),('12664','2013-04-29','14:40:00',3.52),('12664','2013-04-29','14:45:00',3.56),('12664','2013-04-29','14:50:00',3.43),('12664','2013-04-29','14:55:00',3.44),('12664','2013-04-29','15:00:00',3.06),('12664','2013-04-29','15:05:00',2.95),('12664','2013-04-29','15:10:00',3.54),('12664','2013-04-29','15:15:00',3.72),('12664','2013-04-29','15:20:00',3.7),('12664','2013-04-29','15:25:00',3.37),('12664','2013-04-29','15:30:00',3.03),('12664','2013-04-29','15:35:00',2.92),('12664','2013-04-29','15:40:00',2.8),('12664','2013-04-29','15:45:00',2.71),('12664','2013-04-29','15:50:00',2.87),('12664','2013-04-29','15:55:00',3.24),('12664','2013-04-29','16:00:00',3.13),('12664','2013-04-29','16:05:00',3.29),('12664','2013-04-29','16:10:00',3.32),('12664','2013-04-29','16:15:00',3.03),('12664','2013-04-29','16:20:00',2.56),('12664','2013-04-29','16:25:00',2.82),('12664','2013-04-29','16:30:00',2.75),('12664','2013-04-29','16:35:00',2.94),('12664','2013-04-29','16:40:00',2.79),('12664','2013-04-29','16:45:00',2.92),('12664','2013-04-29','16:50:00',2.91),('12664','2013-04-29','16:55:00',2.76),('12664','2013-04-29','17:00:00',2.63),('12664','2013-04-29','17:05:00',2.56),('12664','2013-04-29','17:10:00',2.22),('12664','2013-04-29','17:15:00',2.01),('12664','2013-04-29','17:20:00',2.07),('12664','2013-04-29','17:25:00',1.92),('12664','2013-04-29','17:30:00',1.91),('12664','2013-04-29','17:35:00',1.85),('12664','2013-04-29','17:40:00',1.4),('12664','2013-04-29','17:45:00',1.21),('12664','2013-04-29','17:50:00',1.53),('12664','2013-04-29','17:55:00',1.7),('12664','2013-04-29','18:00:00',1.56),('12664','2013-04-29','18:05:00',1.62),('12664','2013-04-29','18:10:00',1.43),('12664','2013-04-29','18:15:00',1.34),('12664','2013-04-29','18:20:00',1.21),('12664','2013-04-29','18:25:00',1.11),('12664','2013-04-28','07:50:00',1.06),('12664','2013-04-28','07:55:00',1.16),('12664','2013-04-28','08:00:00',1.26),('12664','2013-04-28','08:05:00',1.38),('12664','2013-04-28','08:10:00',1.49),('12664','2013-04-28','08:15:00',1.6),('12664','2013-04-28','08:20:00',1.72),('12664','2013-04-28','08:25:00',1.83),('12664','2013-04-28','08:30:00',1.92),('12664','2013-04-28','08:35:00',2.01),('12664','2013-04-28','08:40:00',2.07),('12664','2013-04-28','08:45:00',2.2),('12664','2013-04-28','08:50:00',2.29),('12664','2013-04-28','08:55:00',2.38),('12664','2013-04-28','09:00:00',2.48),('12664','2013-04-28','09:05:00',2.55),('12664','2013-04-28','09:10:00',2.63),('12664','2013-04-28','09:15:00',2.73),('12664','2013-04-28','09:20:00',2.81),('12664','2013-04-28','09:25:00',2.9),('12664','2013-04-28','09:30:00',2.98),('12664','2013-04-28','09:35:00',3.05),('12664','2013-04-28','09:40:00',3.13),('12664','2013-04-28','09:45:00',3.2),('12664','2013-04-28','09:50:00',3.27),('12664','2013-04-28','09:55:00',3.35),('12664','2013-04-28','10:00:00',3.41),('12664','2013-04-28','10:05:00',3.46),('12664','2013-04-28','10:10:00',3.52),('12664','2013-04-28','10:15:00',3.48),('12664','2013-04-28','10:20:00',3.64),('12664','2013-04-28','10:25:00',3.7),('12664','2013-04-28','10:30:00',3.47),('12664','2013-04-28','10:35:00',3.7),('12664','2013-04-28','10:40:00',3.44),('12664','2013-04-28','10:45:00',3.67),('12664','2013-04-28','10:50:00',3.72),('12664','2013-04-28','10:55:00',3.91),('12664','2013-04-28','11:00:00',3.97),('12664','2013-04-28','11:05:00',3.82),('12664','2013-04-28','11:10:00',3.98),('12664','2013-04-28','11:15:00',4.12),('12664','2013-04-28','11:20:00',4.1),('12664','2013-04-28','11:25:00',4.22),('12664','2013-04-28','11:30:00',4.26),('12664','2013-04-28','11:35:00',4.13),('12664','2013-04-28','11:40:00',4),('12664','2013-04-28','11:45:00',4.14),('12664','2013-04-28','11:50:00',3.94),('12664','2013-04-28','11:55:00',3.56),('12664','2013-04-28','12:00:00',3.41),('12664','2013-04-28','12:05:00',3.55),('12664','2013-04-28','12:10:00',3.97),('12664','2013-04-28','12:15:00',3.9),('12664','2013-04-28','12:20:00',4.15),('12664','2013-04-28','12:25:00',4.15),('12664','2013-04-28','12:30:00',4.01),('12664','2013-04-28','12:35:00',3.8),('12664','2013-04-28','12:40:00',2.99),('12664','2013-04-28','12:45:00',3.76),('12664','2013-04-28','12:50:00',4.33),('12664','2013-04-28','12:55:00',4.26),('12664','2013-04-28','13:00:00',4.4),('12664','2013-04-28','13:05:00',4.52),('12664','2013-04-28','13:10:00',4.11),('12664','2013-04-28','13:15:00',4.01),('12664','2013-04-28','13:20:00',4.24),('12664','2013-04-28','13:25:00',3.92),('12664','2013-04-28','13:30:00',4.08),('12664','2013-04-28','13:35:00',3.31),('12664','2013-04-28','13:40:00',4.35),('12664','2013-04-28','13:45:00',4.22),('12664','2013-04-28','13:50:00',4.38),('12664','2013-04-28','13:55:00',4.31),('12664','2013-04-28','14:00:00',4.26),('12664','2013-04-28','14:05:00',4.12),('12664','2013-04-28','14:10:00',3.96),('12664','2013-04-28','14:15:00',4.24),('12664','2013-04-28','14:20:00',4.15),('12664','2013-04-28','14:25:00',4.1),('12664','2013-04-28','14:30:00',4.12),('12664','2013-04-28','14:35:00',4.08),('12664','2013-04-28','14:40:00',4.02),('12664','2013-04-28','14:45:00',3.98),('12664','2013-04-28','14:50:00',3.93),('12664','2013-04-28','14:55:00',3.46),('12664','2013-04-28','15:00:00',3.8),('12664','2013-04-28','15:05:00',3.8),('12664','2013-04-28','15:10:00',3.79),('12664','2013-04-28','15:15:00',3.75),('12664','2013-04-28','15:20:00',3.5),('12664','2013-04-28','15:25:00',3.63),('12664','2013-04-28','15:30:00',3.59),('12664','2013-04-28','15:35:00',3.52),('12664','2013-04-28','15:40:00',3.44),('12664','2013-04-28','15:45:00',3.38),('12664','2013-04-28','15:50:00',3.34),('12664','2013-04-28','15:55:00',3.28),('12664','2013-04-28','16:00:00',3.23),('12664','2013-04-28','16:05:00',3.14),('12664','2013-04-28','16:10:00',3.08),('12664','2013-04-28','16:15:00',2.99),('12664','2013-04-28','16:20:00',2.91),('12664','2013-04-28','16:25:00',2.84),('12664','2013-04-28','16:30:00',2.81),('12664','2013-04-28','16:35:00',2.78),('12664','2013-04-28','16:40:00',2.71),('12664','2013-04-28','16:45:00',2.64),('12664','2013-04-28','16:50:00',2.58),('12664','2013-04-28','16:55:00',2.49),('12664','2013-04-28','17:00:00',2.27),('12664','2013-04-28','17:05:00',2.15),('12664','2013-04-28','17:10:00',2.18),('12664','2013-04-28','17:15:00',2.04),('12664','2013-04-28','17:20:00',2.03),('12664','2013-04-28','17:25:00',2),('12664','2013-04-28','17:30:00',1.62),('12664','2013-04-28','17:35:00',1.67),('12664','2013-04-28','17:40:00',1.62),('12664','2013-04-28','17:45:00',1.59),('12664','2013-04-28','17:50:00',1.48),('12664','2013-04-28','17:55:00',1.27),('12664','2013-04-28','18:00:00',1.23),('12664','2013-04-28','18:05:00',1.16),('12664','2013-04-28','18:15:00',1.08),('12664','2013-04-28','18:20:00',1.04),('12664','2013-04-27','12:40:00',1.03),('12664','2013-04-27','12:45:00',1.09),('12664','2013-04-27','12:50:00',1.25),('12664','2013-04-27','12:55:00',1.34),('12664','2013-04-27','13:00:00',1.25),('12664','2013-04-27','13:05:00',1.22),('12664','2013-04-27','13:10:00',1.26),('12664','2013-04-27','13:15:00',2.05),('12664','2013-04-27','13:20:00',1.92),('12664','2013-04-27','13:25:00',1.24),('12664','2013-04-27','14:35:00',1.01),('12664','2013-04-27','14:40:00',1.57),('12664','2013-04-27','16:55:00',1.28),('12664','2013-04-27','17:00:00',1.55),('12664','2013-04-27','17:05:00',1.2),('12664','2013-04-27','17:10:00',1.34),('12664','2013-04-27','17:40:00',1.84),('12664','2013-04-27','17:45:00',1.3),('12664','2013-04-26','08:05:00',1.09),('12664','2013-04-26','08:10:00',1.23),('12664','2013-04-26','08:15:00',1.36),('12664','2013-04-26','08:20:00',1.43),('12664','2013-04-26','08:25:00',1.48),('12664','2013-04-26','08:30:00',1.59),('12664','2013-04-26','08:35:00',1.57),('12664','2013-04-26','08:40:00',1.67),('12664','2013-04-26','08:45:00',1.96),('12664','2013-04-26','08:50:00',2.23),('12664','2013-04-26','08:55:00',2.4),('12664','2013-04-26','09:00:00',2.45),('12664','2013-04-26','09:05:00',1.85),('12664','2013-04-26','09:10:00',1.58),('12664','2013-04-26','09:15:00',1.6),('12664','2013-04-26','09:20:00',2),('12664','2013-04-26','09:25:00',2.12),('12664','2013-04-26','09:30:00',2.74),('12664','2013-04-26','09:35:00',2.84),('12664','2013-04-26','09:40:00',2.86),('12664','2013-04-26','09:45:00',2.52),('12664','2013-04-26','09:50:00',2.53),('12664','2013-04-26','09:55:00',2.31),('12664','2013-04-26','10:00:00',2.85),('12664','2013-04-26','10:05:00',3.32),('12664','2013-04-26','10:10:00',3.43),('12664','2013-04-26','10:15:00',3.43),('12664','2013-04-26','10:20:00',3.44),('12664','2013-04-26','10:25:00',3.59),('12664','2013-04-26','10:30:00',3.61),('12664','2013-04-26','10:35:00',3.74),('12664','2013-04-26','10:40:00',3.73),('12664','2013-04-26','10:45:00',3.87),('12664','2013-04-26','10:50:00',3.95),('12664','2013-04-26','10:55:00',3.95),('12664','2013-04-26','11:00:00',3.95),('12664','2013-04-26','11:05:00',3.98),('12664','2013-04-26','11:10:00',4.03),('12664','2013-04-26','11:15:00',4.02),('12664','2013-04-26','11:20:00',3.32),('12664','2013-04-26','11:25:00',3.34),('12664','2013-04-26','11:30:00',3.15),('12664','2013-04-26','11:35:00',2.79),('12664','2013-04-26','11:40:00',3.42),('12664','2013-04-26','11:45:00',3.63),('12664','2013-04-26','11:50:00',3.02),('12664','2013-04-26','11:55:00',2.9),('12664','2013-04-26','12:00:00',2.83),('12664','2013-04-26','12:05:00',3.13),('12664','2013-04-26','12:10:00',2.51),('12664','2013-04-26','12:15:00',3.38),('12664','2013-04-26','12:20:00',3.32),('12664','2013-04-26','12:25:00',2.23),('12664','2013-04-26','12:30:00',2.09),('12664','2013-04-26','12:35:00',2.53),('12664','2013-04-26','12:40:00',3.23),('12664','2013-04-26','12:45:00',2.61),('12664','2013-04-26','12:50:00',2.03),('12664','2013-04-26','12:55:00',1.51),('12664','2013-04-26','13:00:00',1.4),('12664','2013-04-26','13:05:00',1.55),('12664','2013-04-26','13:10:00',2.26),('12664','2013-04-26','13:15:00',4.94),('12664','2013-04-26','13:20:00',4.27),('12664','2013-04-26','13:25:00',4.34),('12664','2013-04-26','13:30:00',3.88),('12664','2013-04-26','13:35:00',2.84),('12664','2013-04-26','13:40:00',2.99),('12664','2013-04-26','13:45:00',3.18),('12664','2013-04-26','13:50:00',4.09),('12664','2013-04-26','13:55:00',3.78),('12664','2013-04-26','14:00:00',2.84),('12664','2013-04-26','14:05:00',3.63),('12664','2013-04-26','14:10:00',2.57),('12664','2013-04-26','14:15:00',3.31),('12664','2013-04-26','14:20:00',4.11),('12664','2013-04-26','14:25:00',3.88),('12664','2013-04-26','14:30:00',2.54),('12664','2013-04-26','14:35:00',2.14),('12664','2013-04-26','14:40:00',2.15),('12664','2013-04-26','14:45:00',2.07),('12664','2013-04-26','14:50:00',1.66),('12664','2013-04-26','14:55:00',1.48),('12664','2013-04-26','15:00:00',1.8),('12664','2013-04-26','15:05:00',1.71),('12664','2013-04-26','15:10:00',2.61),('12664','2013-04-26','15:15:00',3.71),('12664','2013-04-26','15:20:00',2),('12664','2013-04-26','15:25:00',2.64),('12664','2013-04-26','15:30:00',4.12),('12664','2013-04-26','15:35:00',3.37),('12664','2013-04-26','15:40:00',4.19),('12664','2013-04-26','15:45:00',2.14),('12664','2013-04-26','15:50:00',1.34),('12664','2013-04-25','08:10:00',1.2),('12664','2013-04-25','08:25:00',1.01),('12664','2013-04-25','08:30:00',1.08),('12664','2013-04-25','08:35:00',1.4),('12664','2013-04-25','08:40:00',1.73),('12664','2013-04-25','08:45:00',2.06),('12664','2013-04-25','08:50:00',1.42),('12664','2013-04-25','08:55:00',1.27),('12664','2013-04-25','09:00:00',1.36),('12664','2013-04-25','09:05:00',1.41),('12664','2013-04-25','09:10:00',1.44),('12664','2013-04-25','09:15:00',1.55),('12664','2013-04-25','09:20:00',1.64),('12664','2013-04-25','09:25:00',1.75),('12664','2013-04-25','09:30:00',2.34),('12664','2013-04-25','09:35:00',2.68),('12664','2013-04-25','09:40:00',2.95),('12664','2013-04-25','09:45:00',3.13),('12664','2013-04-25','09:50:00',3.06),('12664','2013-04-25','09:55:00',2.6),('12664','2013-04-25','10:00:00',2.72),('12664','2013-04-25','10:05:00',3.12),('12664','2013-04-25','10:10:00',3.42),('12664','2013-04-25','10:15:00',3.46),('12664','2013-04-25','10:20:00',3.57),('12664','2013-04-25','10:25:00',3.56),('12664','2013-04-25','10:30:00',3.58),('12664','2013-04-25','10:35:00',3.66),('12664','2013-04-25','10:40:00',3.68),('12664','2013-04-25','10:45:00',3.7),('12664','2013-04-25','10:50:00',3.74),('12664','2013-04-25','10:55:00',3.77),('12664','2013-04-25','11:00:00',3.77),('12664','2013-04-25','11:05:00',3.79),('12664','2013-04-25','11:10:00',3.78),('12664','2013-04-25','11:15:00',3.92),('12664','2013-04-25','11:20:00',3.94),('12664','2013-04-25','11:25:00',3.94),('12664','2013-04-25','11:30:00',4.07),('12664','2013-04-25','11:35:00',4.1),('12664','2013-04-25','11:40:00',4.14),('12664','2013-04-25','11:45:00',4.19),('12664','2013-04-25','11:50:00',4.24),('12664','2013-04-25','11:55:00',4.26),('12664','2013-04-25','12:00:00',4.24),('12664','2013-04-25','12:05:00',4.25),('12664','2013-04-25','12:10:00',4.35),('12664','2013-04-25','12:15:00',4.35),('12664','2013-04-25','12:20:00',4.19),('12664','2013-04-25','12:25:00',4.26),('12664','2013-04-25','12:30:00',4.3),('12664','2013-04-25','12:35:00',4.32),('12664','2013-04-25','12:40:00',4.31),('12664','2013-04-25','12:45:00',4.32),('12664','2013-04-25','12:50:00',4.34),('12664','2013-04-25','12:55:00',4.34),('12664','2013-04-25','13:00:00',3.74),('12664','2013-04-25','13:05:00',4.08),('12664','2013-04-25','13:10:00',4.37),('12664','2013-04-25','13:15:00',3.99),('12664','2013-04-25','13:20:00',3.83),('12664','2013-04-25','13:25:00',3.04),('12664','2013-04-25','13:30:00',2.58),('12664','2013-04-25','13:35:00',2.3),('12664','2013-04-25','13:40:00',2.23),('12664','2013-04-25','13:45:00',2.14),('12664','2013-04-25','13:50:00',2.03),('12664','2013-04-25','13:55:00',2.23),('12664','2013-04-25','14:00:00',2.25),('12664','2013-04-25','14:05:00',2.43),('12664','2013-04-25','14:10:00',2.36),('12664','2013-04-25','14:15:00',2.63),('12664','2013-04-25','14:20:00',3.16),('12664','2013-04-25','14:25:00',3.18),('12664','2013-04-25','14:30:00',3.73),('12664','2013-04-25','14:35:00',4.06),('12664','2013-04-25','14:40:00',3.84),('12664','2013-04-25','14:45:00',3.97),('12664','2013-04-25','14:50:00',3.55),('12664','2013-04-25','14:55:00',3.12),('12664','2013-04-25','15:00:00',3.68),('12664','2013-04-25','15:05:00',3.33),('12664','2013-04-25','15:10:00',3.28),('12664','2013-04-25','15:15:00',2.63),('12664','2013-04-25','15:20:00',3.42),('12664','2013-04-25','15:25:00',3.43),('12664','2013-04-25','15:30:00',3.18),('12664','2013-04-25','15:35:00',2.78),('12664','2013-04-25','15:40:00',2.64),('12664','2013-04-25','15:45:00',2.67),('12664','2013-04-25','15:50:00',2.19),('12664','2013-04-25','15:55:00',2.38),('12664','2013-04-25','16:00:00',2.44),('12664','2013-04-25','16:05:00',2.54),('12664','2013-04-25','16:10:00',2.81),('12664','2013-04-25','16:15:00',2.88),('12664','2013-04-25','16:20:00',2.72),('12664','2013-04-25','16:25:00',2.28),('12664','2013-04-25','16:30:00',2.25),('12664','2013-04-25','16:35:00',1.68),('12664','2013-04-25','16:40:00',1.88),('12664','2013-04-25','16:45:00',2.06),('12664','2013-04-25','16:50:00',2.07),('12664','2013-04-25','16:55:00',2.04),('12664','2013-04-25','17:00:00',1.96),('12664','2013-04-25','17:05:00',2.25),('12664','2013-04-25','17:10:00',1.95),('12664','2013-04-25','17:15:00',2.12),('12664','2013-04-25','17:20:00',1.98),('12664','2013-04-25','17:25:00',1.66),('12664','2013-04-25','17:30:00',1.57),('12664','2013-04-25','17:35:00',1.26),('12664','2013-04-25','17:40:00',1.3),('12664','2013-04-25','17:45:00',1.3),('12664','2013-04-25','17:50:00',1.2),('12664','2013-04-25','18:05:00',1.05),('12664','2013-04-24','07:55:00',1.05),('12664','2013-04-24','08:00:00',1.1),('12664','2013-04-24','08:05:00',1.15),('12664','2013-04-24','08:10:00',1.35),('12664','2013-04-24','08:15:00',1.52),('12664','2013-04-24','08:20:00',1.7),('12664','2013-04-24','08:25:00',1.75),('12664','2013-04-24','08:30:00',1.69),('12664','2013-04-24','08:35:00',1.68),('12664','2013-04-24','08:40:00',1.77),('12664','2013-04-24','08:45:00',1.94),('12664','2013-04-24','08:50:00',2.1),('12664','2013-04-24','08:55:00',2.29),('12664','2013-04-24','09:00:00',2.48),('12664','2013-04-24','09:05:00',2.69),('12664','2013-04-24','09:10:00',2.99),('12664','2013-04-24','09:15:00',2.29),('12664','2013-04-24','09:20:00',1.87),('12664','2013-04-24','09:25:00',1.77),('12664','2013-04-24','09:30:00',2.2),('12664','2013-04-24','09:35:00',2.15),('12664','2013-04-24','09:40:00',2.15),('12664','2013-04-24','09:45:00',2.54),('12664','2013-04-24','09:50:00',2.7),('12664','2013-04-24','09:55:00',2.88),('12664','2013-04-24','10:00:00',3.55),('12664','2013-04-24','10:05:00',3.69),('12664','2013-04-24','10:10:00',3.49),('12664','2013-04-24','10:15:00',3.33),('12664','2013-04-24','10:20:00',3.75),('12664','2013-04-24','10:25:00',3.72),('12664','2013-04-24','10:30:00',3.69),('12664','2013-04-24','10:35:00',3.56),('12664','2013-04-24','10:40:00',3.55),('12664','2013-04-24','10:45:00',3.43),('12664','2013-04-24','10:50:00',3.9),('12664','2013-04-24','10:55:00',3.95),('12664','2013-04-24','11:00:00',3.9),('12664','2013-04-24','11:05:00',4.04),('12664','2013-04-24','11:10:00',4.29),('12664','2013-04-24','11:15:00',4.35),('12664','2013-04-24','11:20:00',4.36),('12664','2013-04-24','11:25:00',4.2),('12664','2013-04-24','11:30:00',3.38),('12664','2013-04-24','11:35:00',3.56),('12664','2013-04-24','11:40:00',4.37),('12664','2013-04-24','11:45:00',4.28),('12664','2013-04-24','11:50:00',4.12),('12664','2013-04-24','11:55:00',3.25),('12664','2013-04-24','12:00:00',2.96),('12664','2013-04-24','12:05:00',3.5),('12664','2013-04-24','12:10:00',2.67),('12664','2013-04-24','12:15:00',3.88),('12664','2013-04-24','12:20:00',4.13),('12664','2013-04-24','12:25:00',3.22),('12664','2013-04-24','12:30:00',3.44),('12664','2013-04-24','12:35:00',3.22),('12664','2013-04-24','12:40:00',3.95),('12664','2013-04-24','12:45:00',3.67),('12664','2013-04-24','12:50:00',4.27),('12664','2013-04-24','12:55:00',4.34),('12664','2013-04-24','13:00:00',4.47),('12664','2013-04-24','13:05:00',4.89),('12664','2013-04-24','13:10:00',4.69),('12664','2013-04-24','13:15:00',3.91),('12664','2013-04-24','13:20:00',4),('12664','2013-04-24','13:25:00',3.92),('12664','2013-04-24','13:30:00',3.86),('12664','2013-04-24','13:35:00',4.01),('12664','2013-04-24','13:40:00',3.18),('12664','2013-04-24','13:45:00',2.93),('12664','2013-04-24','13:50:00',3.12),('12664','2013-04-24','13:55:00',3.5),('12664','2013-04-24','14:00:00',3.15),('12664','2013-04-24','14:05:00',3.08),('12664','2013-04-24','14:10:00',3.23),('12664','2013-04-24','14:15:00',2.73),('12664','2013-04-24','14:20:00',3.5),('12664','2013-04-24','14:25:00',3.74),('12664','2013-04-24','14:30:00',2.78),('12664','2013-04-24','14:35:00',3.07),('12664','2013-04-24','14:40:00',3.46),('12664','2013-04-24','14:45:00',2.59),('12664','2013-04-24','14:50:00',2.38),('12664','2013-04-24','14:55:00',2.55),('12664','2013-04-24','15:00:00',2.53),('12664','2013-04-24','15:05:00',2.3),('12664','2013-04-24','15:10:00',2.39),('12664','2013-04-24','15:15:00',2.18),('12664','2013-04-24','15:20:00',2.17),('12664','2013-04-24','15:25:00',2.12),('12664','2013-04-24','15:30:00',1.91),('12664','2013-04-24','15:35:00',2.05),('12664','2013-04-24','15:40:00',2.15),('12664','2013-04-24','15:45:00',1.93),('12664','2013-04-24','15:50:00',2),('12664','2013-04-24','15:55:00',2.26),('12664','2013-04-24','16:00:00',2.22),('12664','2013-04-24','16:05:00',2.21),('12664','2013-04-24','16:10:00',2.43),('12664','2013-04-24','16:15:00',3.2),('12664','2013-04-24','16:20:00',2.65),('12664','2013-04-24','16:25:00',2.04),('12664','2013-04-24','16:30:00',2.24),('12664','2013-04-24','16:35:00',2.07),('12664','2013-04-24','16:40:00',2.35),('12664','2013-04-24','16:45:00',2.49),('12664','2013-04-24','16:50:00',2.54),('12664','2013-04-24','16:55:00',2.67),('12664','2013-04-24','17:00:00',2.63),('12664','2013-04-24','17:05:00',2.55),('12664','2013-04-24','17:10:00',2.27),('12664','2013-04-24','17:15:00',2.17),('12664','2013-04-24','17:20:00',1.68),('12664','2013-04-24','17:35:00',1.1),('12664','2013-04-24','17:40:00',1.37),('12664','2013-04-24','17:45:00',1.47),('12664','2013-04-24','17:50:00',1.4),('12664','2013-04-24','17:55:00',1.17),('12664','2013-04-24','18:00:00',1.33),('12664','2013-04-23','07:50:00',1.07),('12664','2013-04-23','07:55:00',1.19),('12664','2013-04-23','08:00:00',1.3),('12664','2013-04-23','08:05:00',1.42),('12664','2013-04-23','08:10:00',1.53),('12664','2013-04-23','08:15:00',1.64),('12664','2013-04-23','08:20:00',1.75),('12664','2013-04-23','08:25:00',1.86),('12664','2013-04-23','08:30:00',1.96),('12664','2013-04-23','08:35:00',2.07),('12664','2013-04-23','08:40:00',2.16),('12664','2013-04-23','08:45:00',2.27),('12664','2013-04-23','08:50:00',2.36),('12664','2013-04-23','08:55:00',2.46),('12664','2013-04-23','09:00:00',2.54),('12664','2013-04-23','09:05:00',2.61),('12664','2013-04-23','09:10:00',2.7),('12664','2013-04-23','09:15:00',2.8),('12664','2013-04-23','09:20:00',2.87),('12664','2013-04-23','09:25:00',2.93),('12664','2013-04-23','09:30:00',3.04),('12664','2013-04-23','09:35:00',3.12),('12664','2013-04-23','09:40:00',3.17),('12664','2013-04-23','09:45:00',3.27),('12664','2013-04-23','09:50:00',3.37),('12664','2013-04-23','09:55:00',3.36),('12664','2013-04-23','10:00:00',3.48),('12664','2013-04-23','10:05:00',3.57),('12664','2013-04-23','10:10:00',3.65),('12664','2013-04-23','10:15:00',3.7),('12664','2013-04-23','10:20:00',3.75),('12664','2013-04-23','10:25:00',3.75),('12664','2013-04-23','10:30:00',3.83),('12664','2013-04-23','10:35:00',3.91),('12664','2013-04-23','10:40:00',3.98),('12664','2013-04-23','10:45:00',3.91),('12664','2013-04-23','10:50:00',4.1),('12664','2013-04-23','10:55:00',4.09),('12664','2013-04-23','11:00:00',4.14),('12664','2013-04-23','11:05:00',4.21),('12664','2013-04-23','11:10:00',4.26),('12664','2013-04-23','11:15:00',4.29),('12664','2013-04-23','11:20:00',4.29),('12664','2013-04-23','11:25:00',4.3),('12664','2013-04-23','11:30:00',4.35),('12664','2013-04-23','11:35:00',4.4),('12664','2013-04-23','11:40:00',4.42),('12664','2013-04-23','11:45:00',4.44),('12664','2013-04-23','11:50:00',4.44),('12664','2013-04-23','11:55:00',4.47),('12664','2013-04-23','12:00:00',4.46),('12664','2013-04-23','12:05:00',4.46),('12664','2013-04-23','12:10:00',4.49),('12664','2013-04-23','12:15:00',4.56),('12664','2013-04-23','12:20:00',4.48),('12664','2013-04-23','12:25:00',4.48),('12664','2013-04-23','12:30:00',4.53),('12664','2013-04-23','12:35:00',4.62),('12664','2013-04-23','12:40:00',4.74),('12664','2013-04-23','12:45:00',4.94),('12664','2013-04-23','12:50:00',4.36),('12664','2013-04-23','12:55:00',4.8),('12664','2013-04-23','13:00:00',4.77),('12664','2013-04-23','13:05:00',4.72),('12664','2013-04-23','13:10:00',4.81),('12664','2013-04-23','13:15:00',4.87),('12664','2013-04-23','13:20:00',4.85),('12664','2013-04-23','13:25:00',4.67),('12664','2013-04-23','13:30:00',4.26),('12664','2013-04-23','13:35:00',4.37),('12664','2013-04-23','13:40:00',4.48),('12664','2013-04-23','13:45:00',4.59),('12664','2013-04-23','13:50:00',3.81),('12664','2013-04-23','13:55:00',4.48),('12664','2013-04-23','14:00:00',4.94),('12664','2013-04-23','14:05:00',4.7),('12664','2013-04-23','14:10:00',4.26),('12664','2013-04-23','14:15:00',4.61),('12664','2013-04-23','14:20:00',4.5),('12664','2013-04-23','14:25:00',4.26),('12664','2013-04-23','14:30:00',3.12),('12664','2013-04-23','14:35:00',2.58),('12664','2013-04-23','14:40:00',2.77),('12664','2013-04-23','14:45:00',4.11),('12664','2013-04-23','14:50:00',3.41),('12664','2013-04-23','14:55:00',1.99),('12664','2013-04-23','15:00:00',1.81),('12664','2013-04-23','15:05:00',2.24),('12664','2013-04-23','15:10:00',3.2),('12664','2013-04-23','15:15:00',3.52),('12664','2013-04-23','15:20:00',3.24),('12664','2013-04-23','15:25:00',2.94),('12664','2013-04-23','15:30:00',2.65),('12664','2013-04-23','15:35:00',2.92),('12664','2013-04-23','15:40:00',3.12),('12664','2013-04-23','15:45:00',2.75),('12664','2013-04-23','15:50:00',2.81),('12664','2013-04-23','15:55:00',3.01),('12664','2013-04-23','16:00:00',2.87),('12664','2013-04-23','16:05:00',2.09),('12664','2013-04-23','16:10:00',2.46),('12664','2013-04-23','16:15:00',2.21),('12664','2013-04-23','16:20:00',1.75),('12664','2013-04-23','16:25:00',1.7),('12664','2013-04-23','16:30:00',1.64),('12664','2013-04-23','16:35:00',1.38),('12664','2013-04-23','16:40:00',1.33),('12664','2013-04-23','16:45:00',1.24),('12664','2013-04-23','16:50:00',2.01),('12664','2013-04-23','16:55:00',2.32),('12664','2013-04-23','17:00:00',2.41),('12664','2013-04-23','17:05:00',2.3),('12664','2013-04-23','17:10:00',2.37),('12664','2013-04-23','17:15:00',2.23),('12664','2013-04-23','17:20:00',1.95),('12664','2013-04-23','17:25:00',1.68),('12664','2013-04-23','17:30:00',2.1),('12664','2013-04-23','17:35:00',1.71),('12664','2013-04-23','17:40:00',1.92),('12664','2013-04-23','17:45:00',1.69),('12664','2013-04-23','17:50:00',1.47),('12664','2013-04-23','17:55:00',1.44),('12664','2013-04-23','18:00:00',1.33),('12664','2013-04-23','18:05:00',1.11),('12664','2013-04-22','08:45:00',1.31),('12664','2013-04-22','09:40:00',1.03),('12664','2013-04-22','10:35:00',2.08),('12664','2013-04-22','10:40:00',2.99),('12664','2013-04-22','10:45:00',3.26),('12664','2013-04-22','10:50:00',2.97),('12664','2013-04-22','11:20:00',1.27),('12664','2013-04-22','11:25:00',1.7),('12664','2013-04-22','11:30:00',1.53),('12664','2013-04-22','11:45:00',3.97),('12664','2013-04-22','11:50:00',4.94),('12664','2013-04-22','11:55:00',4.89),('12664','2013-04-22','12:00:00',4.85),('12664','2013-04-22','12:05:00',4.67),('12664','2013-04-22','12:10:00',4.79),('12664','2013-04-22','12:15:00',4.81),('12664','2013-04-22','12:20:00',4.85),('12664','2013-04-22','12:25:00',5),('12664','2013-04-22','12:30:00',5.05),('12664','2013-04-22','12:35:00',4.35),('12664','2013-04-22','12:40:00',4.64),('12664','2013-04-22','12:45:00',4.49),('12664','2013-04-22','12:50:00',5.04),('12664','2013-04-22','12:55:00',3.72),('12664','2013-04-22','13:00:00',3.55),('12664','2013-04-22','13:05:00',1.19),('12664','2013-04-22','13:10:00',1.31),('12664','2013-04-22','13:15:00',1.63),('12664','2013-04-22','13:20:00',2.4),('12664','2013-04-22','13:25:00',2.28),('12664','2013-04-22','13:30:00',1.27),('12664','2013-04-22','13:35:00',1.23),('12664','2013-04-22','13:40:00',1.04),('12664','2013-04-22','14:05:00',1.44),('12664','2013-04-22','14:10:00',4.1),('12664','2013-04-22','14:15:00',2.95),('12664','2013-04-22','14:20:00',2.91),('12664','2013-04-22','14:25:00',1.68),('12664','2013-04-22','14:30:00',1.27),('12664','2013-04-22','14:35:00',2.58),('12664','2013-04-22','14:40:00',4.78),('12664','2013-04-22','14:45:00',4.3),('12664','2013-04-22','14:50:00',4.21),('12664','2013-04-22','14:55:00',2.9),('12664','2013-04-22','15:00:00',1.11),('12664','2013-04-22','15:05:00',1.36),('12664','2013-04-22','15:10:00',1.17),('12664','2013-04-22','15:15:00',1.12),('12664','2013-04-22','15:20:00',1.19),('12664','2013-04-22','15:25:00',2.28),('12664','2013-04-22','15:30:00',1.42),('12664','2013-04-22','15:35:00',2.78),('12664','2013-04-22','15:40:00',1.34),('12664','2013-04-22','15:45:00',1.93),('12664','2013-04-22','15:50:00',3.16),('12664','2013-04-22','15:55:00',2.84),('12664','2013-04-22','16:00:00',1.78),('12664','2013-04-22','17:05:00',1.13),('12664','2013-04-22','17:10:00',1.93),('12664','2013-04-22','17:15:00',1.86),('12664','2013-04-22','17:20:00',1.79),('12664','2013-04-22','17:25:00',2.92),('12664','2013-04-22','17:30:00',2.93),('12664','2013-04-22','17:35:00',2.68),('12664','2013-04-22','17:40:00',2.48),('12664','2013-04-22','17:45:00',2.5),('12664','2013-04-22','17:50:00',2.52),('12664','2013-04-22','17:55:00',1.68),('12664','2013-04-22','18:00:00',2.02),('12664','2013-04-22','18:05:00',1.07),('12664','2013-04-22','18:10:00',1.19),('12664','2013-04-22','18:15:00',1.41),('12664','2013-04-22','18:20:00',1.28),('12664','2013-04-22','18:25:00',1.12),('12664','2013-04-21','08:45:00',1.36),('12664','2013-04-21','08:50:00',1.14),('12664','2013-04-21','09:15:00',1.16),('12664','2013-04-21','09:25:00',1.25),('12664','2013-04-21','09:30:00',2.69),('12664','2013-04-21','09:35:00',2.37),('12664','2013-04-21','09:40:00',2.4),('12664','2013-04-21','09:45:00',2.04),('12664','2013-04-21','09:50:00',2.27),('12664','2013-04-21','09:55:00',2.19),('12664','2013-04-21','10:00:00',2.07),('12664','2013-04-21','10:05:00',2.07),('12664','2013-04-21','10:10:00',3.2),('12664','2013-04-21','10:15:00',3.67),('12664','2013-04-21','10:20:00',3.73),('12664','2013-04-21','10:25:00',3.81),('12664','2013-04-21','10:30:00',3.96),('12664','2013-04-21','10:35:00',3.76),('12664','2013-04-21','10:40:00',3.49),('12664','2013-04-21','10:45:00',3.42),('12664','2013-04-21','10:50:00',4.03),('12664','2013-04-21','10:55:00',4.08),('12664','2013-04-21','11:00:00',4.14),('12664','2013-04-21','11:05:00',4.27),('12664','2013-04-21','11:10:00',4.3),('12664','2013-04-21','11:15:00',4.46),('12664','2013-04-21','11:20:00',4.54),('12664','2013-04-21','11:25:00',3.24),('12664','2013-04-21','11:30:00',2.95),('12664','2013-04-21','11:35:00',2.89),('12664','2013-04-21','11:40:00',2.86),('12664','2013-04-21','11:45:00',2.74),('12664','2013-04-21','11:50:00',2.62),('12664','2013-04-21','11:55:00',2.57),('12664','2013-04-21','12:00:00',2.87),('12664','2013-04-21','12:05:00',2.67),('12664','2013-04-21','12:10:00',2.43),('12664','2013-04-21','12:15:00',2.22),('12664','2013-04-21','12:20:00',2.14),('12664','2013-04-21','12:25:00',2.23),('12664','2013-04-21','12:30:00',2.33),('12664','2013-04-21','12:35:00',2.38),('12664','2013-04-21','12:40:00',2.54),('12664','2013-04-21','12:45:00',2.57),('12664','2013-04-21','12:50:00',2.49),('12664','2013-04-21','12:55:00',2.47),('12664','2013-04-21','13:00:00',2.63),('12664','2013-04-21','13:05:00',3.37),('12664','2013-04-21','13:10:00',2.98),('12664','2013-04-21','13:15:00',2.6),('12664','2013-04-21','13:20:00',2.65),('12664','2013-04-21','13:25:00',2.89),('12664','2013-04-21','13:30:00',3.12),('12664','2013-04-21','13:35:00',3.39),('12664','2013-04-21','13:40:00',4.15),('12664','2013-04-21','13:45:00',3.61),('12664','2013-04-21','13:50:00',4.41),('12664','2013-04-21','13:55:00',3.68),('12664','2013-04-21','14:00:00',2.9),('12664','2013-04-21','14:05:00',4.29),('12664','2013-04-21','14:10:00',4.65),('12664','2013-04-21','14:15:00',4.9),('12664','2013-04-21','14:20:00',4.27),('12664','2013-04-21','14:25:00',4.66),('12664','2013-04-21','14:30:00',4.51),('12664','2013-04-21','14:35:00',4.36),('12664','2013-04-21','14:40:00',4.24),('12664','2013-04-21','14:45:00',2.81),('12664','2013-04-21','14:50:00',3.4),('12664','2013-04-21','14:55:00',4.5),('12664','2013-04-21','15:00:00',4.19),('12664','2013-04-21','15:05:00',4.12),('12664','2013-04-21','15:10:00',4.2),('12664','2013-04-21','15:15:00',3.39),('12664','2013-04-21','15:20:00',3.1),('12664','2013-04-21','15:25:00',3.28),('12664','2013-04-21','15:30:00',3.87),('12664','2013-04-21','15:35:00',2.7),('12664','2013-04-21','15:40:00',2.56),('12664','2013-04-21','15:45:00',1.81),('12664','2013-04-21','15:50:00',1.2),('12664','2014-03-28','07:30:00',1.15),('12664','2014-03-28','07:35:00',1.28),('12664','2014-03-28','07:40:00',1.37),('12664','2014-03-28','07:45:00',1.45),('12664','2014-03-28','07:50:00',1.55),('12664','2014-03-28','07:55:00',1.66),('12664','2014-03-28','08:00:00',1.76),('12664','2014-03-28','08:05:00',1.85),('12664','2014-03-28','08:10:00',1.93),('12664','2014-03-28','08:15:00',2.01),('12664','2014-03-28','08:20:00',2.11),('12664','2014-03-28','08:25:00',2.2),('12664','2014-03-28','08:30:00',2.27),('12664','2014-03-28','08:35:00',2.37),('12664','2014-03-28','08:40:00',2.48),('12664','2014-03-28','08:45:00',2.58),('12664','2014-03-28','08:50:00',2.7),('12664','2014-03-28','08:55:00',2.83),('12664','2014-03-28','09:00:00',3),('12664','2014-03-28','09:05:00',3),('12664','2014-03-28','09:10:00',2.83),('12664','2014-03-28','09:15:00',3.16),('12664','2014-03-28','09:20:00',3.55),('12664','2014-03-28','09:25:00',2.28),('12664','2014-03-28','09:30:00',1.98),('12664','2014-03-28','09:35:00',1.93),('12664','2014-03-28','09:40:00',3.37),('12664','2014-03-28','09:45:00',3.19),('12664','2014-03-28','09:50:00',3.3),('12664','2014-03-28','09:55:00',3.78),('12664','2014-03-28','10:00:00',3.16),('12664','2014-03-28','10:05:00',2.86),('12664','2014-03-28','10:10:00',3.06),('12664','2014-03-28','10:15:00',2.92),('12664','2014-03-28','10:20:00',2.75),('12664','2014-03-28','10:25:00',3.37),('12664','2014-03-28','10:30:00',3.77),('12664','2014-03-28','10:35:00',3.84),('12664','2014-03-28','10:40:00',3.84),('12664','2014-03-28','10:45:00',3.89),('12664','2014-03-28','10:50:00',3.91),('12664','2014-03-28','10:55:00',3.92),('12664','2014-03-28','11:00:00',3.93),('12664','2014-03-28','11:05:00',3.95),('12664','2014-03-28','11:10:00',3.98),('12664','2014-03-28','11:15:00',3.99),('12664','2014-03-28','11:20:00',4.09),('12664','2014-03-28','11:25:00',4.1),('12664','2014-03-28','11:30:00',4.07),('12664','2014-03-28','11:35:00',4.06),('12664','2014-03-28','11:40:00',4.09),('12664','2014-03-28','11:45:00',4.11),('12664','2014-03-28','11:50:00',4.14),('12664','2014-03-28','11:55:00',4.18),('12664','2014-03-28','12:00:00',4.24),('12664','2014-03-28','12:05:00',4.26),('12664','2014-03-28','12:10:00',4.37),('12664','2014-03-28','12:15:00',4.33),('12664','2014-03-28','12:20:00',4.07),('12664','2014-03-28','12:25:00',4.29),('12664','2014-03-28','12:30:00',3.99),('12664','2014-03-28','12:35:00',4.36),('12664','2014-03-28','12:40:00',4.04),('12664','2014-03-28','12:45:00',3.76),('12664','2014-03-28','12:50:00',4.43),('12664','2014-03-28','12:55:00',3.01),('12664','2014-03-28','13:00:00',1.84),('12664','2014-03-28','13:05:00',1.92),('12664','2014-03-28','13:10:00',2.29),('12664','2014-03-28','13:15:00',1.72),('12664','2014-03-28','13:20:00',1.5),('12664','2014-03-28','13:25:00',1.65),('12664','2014-03-28','13:30:00',1.71),('12664','2014-03-28','13:35:00',4.27),('12664','2014-03-28','13:40:00',4.02),('12664','2014-03-28','13:45:00',3.95),('12664','2014-03-28','13:50:00',3.87),('12664','2014-03-28','13:55:00',3.83),('12664','2014-03-28','14:00:00',3.78),('12664','2014-03-28','14:05:00',3.71),('12664','2014-03-28','14:10:00',3.66),('12664','2014-03-28','14:15:00',3.62),('12664','2014-03-28','14:20:00',3.56),('12664','2014-03-28','14:25:00',3.52),('12664','2014-03-28','14:30:00',3.46),('12664','2014-03-28','14:35:00',3.39),('12664','2014-03-28','14:40:00',3.34),('12664','2014-03-28','14:45:00',3.29),('12664','2014-03-28','14:50:00',3.23),('12664','2014-03-28','14:55:00',3.16),('12664','2014-03-28','15:00:00',3.07),('12664','2014-03-28','15:05:00',3.01),('12664','2014-03-28','15:10:00',2.94),('12664','2014-03-28','15:15:00',2.86),('12664','2014-03-28','15:20:00',2.79),('12664','2014-03-28','15:25:00',2.71),('12664','2014-03-28','15:30:00',2.63),('12664','2014-03-28','15:35:00',2.6),('12664','2014-03-28','15:40:00',2.5),('12664','2014-03-28','15:45:00',2.43),('12664','2014-03-28','15:50:00',2.41),('12664','2014-03-28','15:55:00',2.44),('12664','2014-03-28','16:00:00',2.44),('12664','2014-03-28','16:05:00',2.26),('12664','2014-03-28','16:10:00',2.09),('12664','2014-03-28','16:15:00',1.98),('12664','2014-03-28','16:20:00',1.95),('12664','2014-03-28','16:25:00',1.33),('12664','2014-03-28','16:35:00',1.52),('12664','2014-03-28','16:50:00',1.25),('12664','2014-03-28','17:00:00',1.04),('12664','2013-04-20','08:05:00',1.13),('12664','2013-04-20','08:15:00',1.08),('12664','2013-04-20','08:25:00',1.28),('12664','2013-04-20','08:30:00',1.62),('12664','2013-04-20','08:35:00',1.88),('12664','2013-04-20','08:40:00',2.02),('12664','2013-04-20','08:45:00',2.11),('12664','2013-04-20','08:50:00',2.31),('12664','2013-04-20','08:55:00',2.38),('12664','2013-04-20','09:00:00',2.52),('12664','2013-04-20','09:05:00',2.61),('12664','2013-04-20','09:10:00',1.95),('12664','2013-04-20','09:15:00',2.08),('12664','2013-04-20','09:20:00',1.77),('12664','2013-04-20','09:25:00',1.56),('12664','2013-04-20','09:30:00',1.14),('12664','2013-04-20','10:25:00',1.02),('12664','2013-04-20','10:30:00',1.49),('12664','2013-04-20','10:35:00',1.81),('12664','2013-04-20','10:40:00',3.69),('12664','2013-04-20','10:45:00',3.53),('12664','2013-04-20','10:50:00',4.12),('12664','2013-04-20','10:55:00',4),('12664','2013-04-20','11:00:00',1.99),('12664','2013-04-20','11:05:00',2.23),('12664','2013-04-20','11:10:00',1.76),('12664','2013-04-20','11:15:00',3.11),('12664','2013-04-20','11:20:00',3.32),('12664','2013-04-20','11:25:00',3.44),('12664','2013-04-20','11:30:00',3.61),('12664','2013-04-20','11:35:00',3.8),('12664','2013-04-20','11:40:00',2.06),('12664','2013-04-20','11:45:00',1.97),('12664','2013-04-20','11:50:00',3.03),('12664','2013-04-20','11:55:00',2.75),('12664','2013-04-20','12:00:00',5.03),('12664','2013-04-20','12:05:00',3.6),('12664','2013-04-20','12:10:00',3.24),('12664','2013-04-20','12:15:00',4.88),('12664','2013-04-20','12:20:00',4.7),('12664','2013-04-20','12:25:00',4.54),('12664','2013-04-20','12:30:00',2.58),('12664','2013-04-20','12:35:00',1.26),('12664','2013-04-20','12:40:00',1.68),('12664','2013-04-20','12:45:00',3.07),('12664','2013-04-20','12:50:00',4.93),('12664','2013-04-20','12:55:00',4.76),('12664','2013-04-20','13:00:00',2.17),('12664','2013-04-20','13:05:00',2.75),('12664','2013-04-20','13:10:00',3.48),('12664','2013-04-20','13:15:00',4.73),('12664','2013-04-20','13:20:00',4.74),('12664','2013-04-20','13:25:00',4.72),('12664','2013-04-20','13:30:00',4.66),('12664','2013-04-20','13:35:00',4.78),('12664','2013-04-20','13:40:00',2),('12664','2013-04-20','13:45:00',2.72),('12664','2013-04-20','13:50:00',3.68),('12664','2013-04-20','13:55:00',3.76),('12664','2013-04-20','14:00:00',4.78),('12664','2013-04-20','14:05:00',4.48),('12664','2013-04-20','14:10:00',4.3),('12664','2013-04-20','14:15:00',3.92),('12664','2013-04-20','14:20:00',4.38),('12664','2013-04-20','14:25:00',3.4),('12664','2013-04-20','14:30:00',4.44),('12664','2013-04-20','14:35:00',4.29),('12664','2013-04-20','14:40:00',4.16),('12664','2013-04-20','14:45:00',4.1),('12664','2013-04-20','14:50:00',4.06),('12664','2013-04-20','14:55:00',4.04),('12664','2013-04-20','15:00:00',4.18),('12664','2013-04-20','15:05:00',1.98),('12664','2013-04-20','15:10:00',2.02),('12664','2013-04-20','15:15:00',3.2),('12664','2013-04-20','15:20:00',2.2),('12664','2013-04-20','15:25:00',1.49),('12664','2013-04-20','15:30:00',1.08),('12664','2013-04-20','15:55:00',1.08),('12664','2013-04-20','16:00:00',1.52),('12664','2013-04-20','16:05:00',2.76),('12664','2013-04-20','16:10:00',3.63),('12664','2013-04-20','16:15:00',3.2),('12664','2013-04-20','16:20:00',2.59),('12664','2013-04-20','16:25:00',3.34),('12664','2013-04-20','16:30:00',3.27),('12664','2013-04-20','16:35:00',3.1),('12664','2013-04-20','16:40:00',2.94),('12664','2013-04-20','16:45:00',2.73),('12664','2013-04-20','16:50:00',2.46),('12664','2013-04-20','16:55:00',2.38),('12664','2013-04-20','17:00:00',2.42),('12664','2013-04-20','17:05:00',2.32),('12664','2013-04-20','17:10:00',2.19),('12664','2013-04-20','17:15:00',2.11),('12664','2013-04-20','17:20:00',2.08),('12664','2013-04-20','17:25:00',2.05),('12664','2013-04-20','17:30:00',2.03),('12664','2013-04-20','17:35:00',1.71),('12664','2013-04-20','17:45:00',1.25),('12664','2013-04-20','17:50:00',1.44),('12664','2013-04-20','17:55:00',1.31),('12664','2013-04-20','18:00:00',1.3),('12664','2013-04-20','18:05:00',1.34),('12664','2013-04-20','18:10:00',1.06),('12664','2013-04-19','08:25:00',1.23),('12664','2013-04-19','08:30:00',1.12),('12664','2013-04-19','08:45:00',1.45),('12664','2013-04-19','08:50:00',1.26),('12664','2013-04-19','08:55:00',1.44),('12664','2013-04-19','09:00:00',1.34),('12664','2013-04-19','09:05:00',1.6),('12664','2013-04-19','09:10:00',2.23),('12664','2013-04-19','09:15:00',2.84),('12664','2013-04-19','09:20:00',2.64),('12664','2013-04-19','09:25:00',2.7),('12664','2013-04-19','09:30:00',2.73),('12664','2013-04-19','09:35:00',2.75),('12664','2013-04-19','09:40:00',2.8),('12664','2013-04-19','09:45:00',2.81),('12664','2013-04-19','09:50:00',2.91),('12664','2013-04-19','09:55:00',2.98),('12664','2013-04-19','10:00:00',3.07),('12664','2013-04-19','10:05:00',3.12),('12664','2013-04-19','10:10:00',3.18),('12664','2013-04-19','10:15:00',3.25),('12664','2013-04-19','10:20:00',3.33),('12664','2013-04-19','10:25:00',3.41),('12664','2013-04-19','10:30:00',3.48),('12664','2013-04-19','10:35:00',3.49),('12664','2013-04-19','10:40:00',3.51),('12664','2013-04-19','10:45:00',3.59),('12664','2013-04-19','10:50:00',3.65),('12664','2013-04-19','10:55:00',3.69),('12664','2013-04-19','11:00:00',3.74),('12664','2013-04-19','11:05:00',3.78),('12664','2013-04-19','11:10:00',3.81),('12664','2013-04-19','11:15:00',3.85),('12664','2013-04-19','11:20:00',3.93),('12664','2013-04-19','11:25:00',3.97),('12664','2013-04-19','11:30:00',4.01),('12664','2013-04-19','11:35:00',4.01),('12664','2013-04-19','11:40:00',4.06),('12664','2013-04-19','11:45:00',4.1),('12664','2013-04-19','11:50:00',4.07),('12664','2013-04-19','11:55:00',4.05),('12664','2013-04-19','12:00:00',4.08),('12664','2013-04-19','12:05:00',4.13),('12664','2013-04-19','12:10:00',4.16),('12664','2013-04-19','12:15:00',4.18),('12664','2013-04-19','12:20:00',4.15),('12664','2013-04-19','12:25:00',4.2),('12664','2013-04-19','12:30:00',4.2),('12664','2013-04-19','12:35:00',4.3),('12664','2013-04-19','12:40:00',4.28),('12664','2013-04-19','12:45:00',4.32),('12664','2013-04-19','12:50:00',4.32),('12664','2013-04-19','12:55:00',4.3),('12664','2013-04-19','13:00:00',4.37),('12664','2013-04-19','13:05:00',4.33),('12664','2013-04-19','13:10:00',4.34),('12664','2013-04-19','13:15:00',4.32),('12664','2013-04-19','13:20:00',4.35),('12664','2013-04-19','13:25:00',4.3),('12664','2013-04-19','13:30:00',4.32),('12664','2013-04-19','13:35:00',4.33),('12664','2013-04-19','13:40:00',4.28),('12664','2013-04-19','13:45:00',4.27),('12664','2013-04-19','13:50:00',4.22),('12664','2013-04-19','13:55:00',4.26),('12664','2013-04-19','14:00:00',4.23),('12664','2013-04-19','14:05:00',4.2),('12664','2013-04-19','14:10:00',4.2),('12664','2013-04-19','14:15:00',4.19),('12664','2013-04-19','14:20:00',4.14),('12664','2013-04-19','14:25:00',4.11),('12664','2013-04-19','14:30:00',4.1),('12664','2013-04-19','14:35:00',4.07),('12664','2013-04-19','14:40:00',4.02),('12664','2013-04-19','14:45:00',3.97),('12664','2013-04-19','14:50:00',3.92),('12664','2013-04-19','14:55:00',3.89),('12664','2013-04-19','15:00:00',3.87),('12664','2013-04-19','15:05:00',3.82),('12664','2013-04-19','15:10:00',3.75),('12664','2013-04-19','15:15:00',3.71),('12664','2013-04-19','15:20:00',3.67),('12664','2013-04-19','15:25:00',3.63),('12664','2013-04-19','15:30:00',3.57),('12664','2013-04-19','15:35:00',3.55),('12664','2013-04-19','15:40:00',3.5),('12664','2013-04-19','15:45:00',3.43),('12664','2013-04-19','15:50:00',3.37),('12664','2013-04-19','15:55:00',3.29),('12664','2013-04-19','16:00:00',3.22),('12664','2013-04-19','16:05:00',3.14),('12664','2013-04-19','16:10:00',3.06),('12664','2013-04-19','16:15:00',2.98),('12664','2013-04-19','16:20:00',2.92),('12664','2013-04-19','16:25:00',2.81),('12664','2013-04-19','16:30:00',2.7),('12664','2013-04-19','16:35:00',2.62),('12664','2013-04-19','16:40:00',2.55),('12664','2013-04-19','16:45:00',2.47),('12664','2013-04-19','16:50:00',2.38),('12664','2013-04-19','16:55:00',2.27),('12664','2013-04-19','17:00:00',2.16),('12664','2013-04-19','17:05:00',2.1),('12664','2013-04-19','17:10:00',2.01),('12664','2013-04-19','17:15:00',1.94),('12664','2013-04-19','17:20:00',1.85),('12664','2013-04-19','17:25:00',1.76),('12664','2013-04-19','17:30:00',1.65),('12664','2013-04-19','17:35:00',1.56),('12664','2013-04-19','17:40:00',1.48),('12664','2013-04-19','17:45:00',1.38),('12664','2013-04-19','17:50:00',1.28),('12664','2013-04-19','17:55:00',1.19),('12664','2013-04-19','18:00:00',1.1),('12664','2013-04-19','18:05:00',1.01),('12664','2013-04-18','08:05:00',1.02),('12664','2013-04-18','08:10:00',1.02),('12664','2013-04-18','08:15:00',1.15),('12664','2013-04-18','08:20:00',1.2),('12664','2013-04-18','08:25:00',1.15),('12664','2013-04-18','08:30:00',1.06),('12664','2013-04-18','08:35:00',1.04),('12664','2013-04-18','08:40:00',1.11),('12664','2013-04-18','08:45:00',1.2),('12664','2013-04-18','08:50:00',1.4),('12664','2013-04-18','08:55:00',1.39),('12664','2013-04-18','09:00:00',1.11),('12664','2013-04-18','09:05:00',1.41),('12664','2013-04-18','09:10:00',1.59),('12664','2013-04-18','09:15:00',1.61),('12664','2013-04-18','09:20:00',1.95),('12664','2013-04-18','09:25:00',2.1),('12664','2013-04-18','09:30:00',2.16),('12664','2013-04-18','09:35:00',1.84),('12664','2013-04-18','09:40:00',1.9),('12664','2013-04-18','09:45:00',1.99),('12664','2013-04-18','09:50:00',2.36),('12664','2013-04-18','09:55:00',2.86),('12664','2013-04-18','10:00:00',3.11),('12664','2013-04-18','10:05:00',3.08),('12664','2013-04-18','10:10:00',3.26),('12664','2013-04-18','10:15:00',3.27),('12664','2013-04-18','10:20:00',3.34),('12664','2013-04-18','10:25:00',3.45),('12664','2013-04-18','10:30:00',3.58),('12664','2013-04-18','10:35:00',3.68),('12664','2013-04-18','10:40:00',3.71),('12664','2013-04-18','10:45:00',3.73),('12664','2013-04-18','10:50:00',3.77),('12664','2013-04-18','10:55:00',3.79),('12664','2013-04-18','11:00:00',3.83),('12664','2013-04-18','11:05:00',3.86),('12664','2013-04-18','11:10:00',3.92),('12664','2013-04-18','11:15:00',3.95),('12664','2013-04-18','11:20:00',4.01),('12664','2013-04-18','11:25:00',4.08),('12664','2013-04-18','11:30:00',4.14),('12664','2013-04-18','11:35:00',4.18),('12664','2013-04-18','11:40:00',4.21),('12664','2013-04-18','11:55:00',4.33),('12664','2013-04-18','12:00:00',4.2),('12664','2013-04-18','12:05:00',4.41),('12664','2013-04-18','12:10:00',4.39),('12664','2013-04-18','12:15:00',4.35),('12664','2013-04-18','12:20:00',4.45),('12664','2013-04-18','12:25:00',4.47),('12664','2013-04-18','12:30:00',4.47),('12664','2013-04-18','12:35:00',4.47),('12664','2013-04-18','12:40:00',4.48),('12664','2013-04-18','12:45:00',4.47),('12664','2013-04-18','12:50:00',4.45),('12664','2013-04-18','12:55:00',4.42),('12664','2013-04-18','13:00:00',4.43),('12664','2013-04-18','13:05:00',4.41),('12664','2013-04-18','13:10:00',4.43),('12664','2013-04-18','13:15:00',4.43),('12664','2013-04-18','13:20:00',4.46),('12664','2013-04-18','13:25:00',4.47),('12664','2013-04-18','13:30:00',4.41),('12664','2013-04-18','13:35:00',4.39),('12664','2013-04-18','13:40:00',4.4),('12664','2013-04-18','13:45:00',4.41),('12664','2013-04-18','13:50:00',4.4),('12664','2013-04-18','13:55:00',4.37),('12664','2013-04-18','14:00:00',4.37),('12664','2013-04-18','14:05:00',4.36),('12664','2013-04-18','14:10:00',4.32),('12664','2013-04-18','14:15:00',4.29),('12664','2013-04-18','14:20:00',4.25),('12664','2013-04-18','14:25:00',4.22),('12664','2013-04-18','14:30:00',4.21),('12664','2013-04-18','14:35:00',4.17),('12664','2013-04-18','14:40:00',4.14),('12664','2013-04-18','14:45:00',4.1),('12664','2013-04-18','14:50:00',4.06),('12664','2013-04-18','14:55:00',4.02),('12664','2013-04-18','15:00:00',3.98),('12664','2013-04-18','15:05:00',3.9),('12664','2013-04-18','15:10:00',3.85),('12664','2013-04-18','15:15:00',3.83),('12664','2013-04-18','15:20:00',3.78),('12664','2013-04-18','15:25:00',3.71),('12664','2013-04-18','15:30:00',3.65),('12664','2013-04-18','15:35:00',3.58),('12664','2013-04-18','15:40:00',3.53),('12664','2013-04-18','15:45:00',3.47),('12664','2013-04-18','15:50:00',3.41),('12664','2013-04-18','15:55:00',3.31),('12664','2013-04-18','16:00:00',3.24),('12664','2013-04-18','16:05:00',3.17),('12664','2013-04-18','16:10:00',3.09),('12664','2013-04-18','16:15:00',3.01),('12664','2013-04-18','16:20:00',2.93),('12664','2013-04-18','16:25:00',2.86),('12664','2013-04-18','16:30:00',2.8),('12664','2013-04-18','16:35:00',2.75),('12664','2013-04-18','16:40:00',2.65),('12664','2013-04-18','16:45:00',2.57),('12664','2013-04-18','16:50:00',2.46),('12664','2013-04-18','16:55:00',2.35),('12664','2013-04-18','17:00:00',2.3),('12664','2013-04-18','17:05:00',2.21),('12664','2013-04-18','17:10:00',2.1),('12664','2013-04-18','17:15:00',2.01),('12664','2013-04-18','17:20:00',1.93),('12664','2013-04-18','17:25:00',1.84),('12664','2013-04-18','17:30:00',1.73),('12664','2013-04-18','17:35:00',1.63),('12664','2013-04-18','17:40:00',1.52),('12664','2013-04-18','17:45:00',1.39),('12664','2013-04-18','17:50:00',1.29),('12664','2013-04-18','17:55:00',1.22),('12664','2013-04-18','18:00:00',1.13),('12664','2013-04-18','18:05:00',1.04),('12664','2013-04-17','07:55:00',1.01),('12664','2013-04-17','08:00:00',1.11),('12664','2013-04-17','08:05:00',1.21),('12664','2013-04-17','08:10:00',1.31),('12664','2013-04-17','08:15:00',1.4),('12664','2013-04-17','08:20:00',1.5),('12664','2013-04-17','08:25:00',1.6),('12664','2013-04-17','08:30:00',1.7),('12664','2013-04-17','08:35:00',1.79),('12664','2013-04-17','08:40:00',1.88),('12664','2013-04-17','08:45:00',1.97),('12664','2013-04-17','08:50:00',2.07),('12664','2013-04-17','08:55:00',2.16),('12664','2013-04-17','09:00:00',2.23),('12664','2013-04-17','09:05:00',2.33),('12664','2013-04-17','09:10:00',2.43),('12664','2013-04-17','09:15:00',2.52),('12664','2013-04-17','09:20:00',2.6),('12664','2013-04-17','09:25:00',2.69),('12664','2013-04-17','09:30:00',2.75),('12664','2013-04-17','09:35:00',2.82),('12664','2013-04-17','09:40:00',2.89),('12664','2013-04-17','09:45:00',2.99),('12664','2013-04-17','09:50:00',3.07),('12664','2013-04-17','09:55:00',3.14),('12664','2013-04-17','10:00:00',3.23),('12664','2013-04-17','10:05:00',3.31),('12664','2013-04-17','10:10:00',3.37),('12664','2013-04-17','10:15:00',3.45),('12664','2013-04-17','10:20:00',3.51),('12664','2013-04-17','10:25:00',3.58),('12664','2013-04-17','10:30:00',3.62),('12664','2013-04-17','10:35:00',3.67),('12664','2013-04-17','10:40:00',3.72),('12664','2013-04-17','10:45:00',3.77),('12664','2013-04-17','10:50:00',3.82),('12664','2013-04-17','10:55:00',3.87),('12664','2013-04-17','11:00:00',3.92),('12664','2013-04-17','11:05:00',3.96),('12664','2013-04-17','11:10:00',4.02),('12664','2013-04-17','11:15:00',4.06),('12664','2013-04-17','11:20:00',4.09),('12664','2013-04-17','11:25:00',4.11),('12664','2013-04-17','11:30:00',4.15),('12664','2013-04-17','11:35:00',4.17),('12664','2013-04-17','11:40:00',4.19),('12664','2013-04-17','11:45:00',4.21),('12664','2013-04-17','11:50:00',4.23),('12664','2013-04-17','11:55:00',4.28),('12664','2013-04-17','12:00:00',4.27),('12664','2013-04-17','12:05:00',4.26),('12664','2013-04-17','12:10:00',4.31),('12664','2013-04-17','12:15:00',4.33),('12664','2013-04-17','12:20:00',4.36),('12664','2013-04-17','12:25:00',4.36),('12664','2013-04-17','12:30:00',4.37),('12664','2013-04-17','12:35:00',4.39),('12664','2013-04-17','12:40:00',4.4),('12664','2013-04-17','12:45:00',4.42),('12664','2013-04-17','12:50:00',4.44),('12664','2013-04-17','12:55:00',4.44),('12664','2013-04-17','13:00:00',4.07),('12664','2013-04-17','13:05:00',3.99),('12664','2013-04-17','13:10:00',4.4),('12664','2013-04-17','13:15:00',4.53),('12664','2013-04-17','13:20:00',4.41),('12664','2013-04-17','13:25:00',4.33),('12664','2013-04-17','13:30:00',4.55),('12664','2013-04-17','13:35:00',4.47),('12664','2013-04-17','13:40:00',4.58),('12664','2013-04-17','13:45:00',4.23),('12664','2013-04-17','13:50:00',4.16),('12664','2013-04-17','13:55:00',4.24),('12664','2013-04-17','14:00:00',3.39),('12664','2013-04-17','14:05:00',3.41),('12664','2013-04-17','14:10:00',4.41),('12664','2013-04-17','14:15:00',4.49),('12664','2013-04-17','14:20:00',4.71),('12664','2013-04-17','14:25:00',4.1),('12664','2013-04-17','14:30:00',4.39),('12664','2013-04-17','14:35:00',4.62),('12664','2013-04-17','14:40:00',4.39),('12664','2013-04-17','14:45:00',2.36),('12664','2013-04-17','14:50:00',2.65),('12664','2013-04-17','14:55:00',2),('12664','2013-04-17','15:00:00',2.48),('12664','2013-04-17','15:05:00',3.85),('12664','2013-04-17','15:10:00',3.57),('12664','2013-04-17','15:15:00',2.96),('12664','2013-04-17','15:20:00',2.75),('12664','2013-04-17','15:25:00',1.63),('12664','2013-04-17','15:30:00',2.69),('12664','2013-04-17','15:35:00',3.62),('12664','2013-04-17','15:40:00',3.84),('12664','2013-04-17','15:45:00',3.45),('12664','2013-04-17','15:50:00',3.66),('12664','2013-04-17','15:55:00',3.06),('12664','2013-04-17','16:00:00',3.38),('12664','2013-04-17','16:05:00',3.34),('12664','2013-04-17','16:10:00',3.17),('12664','2013-04-17','16:15:00',3.21),('12664','2013-04-17','16:20:00',3),('12664','2013-04-17','16:25:00',3.01),('12664','2013-04-17','16:30:00',2.91),('12664','2013-04-17','16:35:00',2.86),('12664','2013-04-17','16:40:00',2.29),('12664','2013-04-17','16:45:00',2.62),('12664','2013-04-17','16:50:00',2.54),('12664','2013-04-17','16:55:00',2.45),('12664','2013-04-17','17:00:00',2.35),('12664','2013-04-17','17:05:00',2.25),('12664','2013-04-17','17:10:00',2.15),('12664','2013-04-17','17:15:00',2.05),('12664','2013-04-17','17:20:00',1.96),('12664','2013-04-17','17:25:00',1.87),('12664','2013-04-17','17:30:00',1.76),('12664','2013-04-17','17:35:00',1.66),('12664','2013-04-17','17:40:00',1.57),('12664','2013-04-17','17:45:00',1.47),('12664','2013-04-17','17:50:00',1.37),('12664','2013-04-17','17:55:00',1.26),('12664','2013-04-17','18:00:00',1.17),('12664','2013-04-17','18:05:00',1.08),('12664','2013-04-16','08:05:00',1.16),('12664','2013-04-16','08:55:00',1.17),('12664','2013-04-16','09:00:00',2.05),('12664','2013-04-16','09:05:00',2.26),('12664','2013-04-16','09:10:00',2.33),('12664','2013-04-16','09:15:00',2.37),('12664','2013-04-16','09:20:00',1.84),('12664','2013-04-16','09:25:00',1.73),('12664','2013-04-16','09:30:00',1.84),('12664','2013-04-16','09:35:00',1.48),('12664','2013-04-16','09:40:00',1.64),('12664','2013-04-16','09:45:00',1.68),('12664','2013-04-16','09:50:00',1.66),('12664','2013-04-16','09:55:00',1.68),('12664','2013-04-16','10:00:00',1.74),('12664','2013-04-16','10:05:00',1.45),('12664','2013-04-16','10:10:00',1.37),('12664','2013-04-16','10:15:00',1.36),('12664','2013-04-16','10:20:00',1.33),('12664','2013-04-16','10:25:00',1.32),('12664','2013-04-16','10:30:00',1.36),('12664','2013-04-16','10:35:00',1.44),('12664','2013-04-16','10:40:00',1.5),('12664','2013-04-16','10:45:00',1.54),('12664','2013-04-16','10:50:00',1.58),('12664','2013-04-16','10:55:00',1.56),('12664','2013-04-16','11:00:00',1.57),('12664','2013-04-16','11:05:00',1.65),('12664','2013-04-16','11:10:00',1.74),('12664','2013-04-16','11:15:00',1.76),('12664','2013-04-16','11:20:00',1.78),('12664','2013-04-16','11:25:00',1.83),('12664','2013-04-16','11:30:00',1.71),('12664','2013-04-16','11:35:00',1.65),('12664','2013-04-16','11:40:00',1.94),('12664','2013-04-16','11:45:00',2.34),('12664','2013-04-16','11:50:00',2.53),('12664','2013-04-16','11:55:00',2.98),('12664','2013-04-16','12:00:00',3.28),('12664','2013-04-16','12:05:00',3.2),('12664','2013-04-16','12:10:00',3.66),('12664','2013-04-16','12:15:00',4.05),('12664','2013-04-16','12:20:00',3.7),('12664','2013-04-16','12:25:00',3.79),('12664','2013-04-16','12:30:00',3.94),('12664','2013-04-16','12:35:00',4.1),('12664','2013-04-16','12:40:00',3.45),('12664','2013-04-16','12:45:00',4.1),('12664','2013-04-16','12:50:00',3.58),('12664','2013-04-16','12:55:00',4.23),('12664','2013-04-16','13:00:00',4.27),('12664','2013-04-16','13:05:00',4.2),('12664','2013-04-16','13:10:00',4.18),('12664','2013-04-16','13:15:00',4.27),('12664','2013-04-16','13:20:00',4.32),('12664','2013-04-16','13:25:00',4.2),('12664','2013-04-16','13:30:00',4.36),('12664','2013-04-16','13:35:00',4.32),('12664','2013-04-16','13:40:00',4.33),('12664','2013-04-16','13:45:00',4.23),('12664','2013-04-16','13:50:00',4.33),('12664','2013-04-16','13:55:00',4.31),('12664','2013-04-16','14:00:00',4.29),('12664','2013-04-16','14:05:00',4.24),('12664','2013-04-16','14:10:00',4.3),('12664','2013-04-16','14:15:00',4.25),('12664','2013-04-16','14:30:00',3.32),('12664','2013-04-16','14:35:00',3.16),('12664','2013-04-16','14:40:00',4.06),('12664','2013-04-16','14:45:00',4.1),('12664','2013-04-16','14:50:00',4.05),('12664','2013-04-16','14:55:00',3.86),('12664','2013-04-16','15:00:00',4.02),('12664','2013-04-16','15:05:00',3.99),('12664','2013-04-16','15:10:00',3.82),('12664','2013-04-16','15:15:00',2.91),('12664','2013-04-16','15:20:00',3.11),('12664','2013-04-16','15:25:00',3.58),('12664','2013-04-16','15:30:00',3.42),('12664','2013-04-16','15:35:00',3.57),('12664','2013-04-16','15:40:00',3.45),('12664','2013-04-16','15:45:00',3.43),('12664','2013-04-16','15:50:00',3.37),('12664','2013-04-16','15:55:00',3.3),('12664','2013-04-16','16:00:00',3.23),('12664','2013-04-16','16:05:00',3.14),('12664','2013-04-16','16:10:00',3.09),('12664','2013-04-16','16:15:00',2.99),('12664','2013-04-16','16:20:00',2.89),('12664','2013-04-16','16:25:00',2.82),('12664','2013-04-16','16:30:00',2.77),('12664','2013-04-16','16:35:00',2.71),('12664','2013-04-16','16:40:00',2.67),('12664','2013-04-16','16:45:00',2.53),('12664','2013-04-16','16:50:00',2.46),('12664','2013-04-16','16:55:00',2.3),('12664','2013-04-16','17:00:00',2.28),('12664','2013-04-16','17:05:00',2.13),('12664','2013-04-16','17:10:00',2.1),('12664','2013-04-16','17:15:00',2),('12664','2013-04-16','17:20:00',1.9),('12664','2013-04-16','17:25:00',1.8),('12664','2013-04-16','17:30:00',1.73),('12664','2013-04-16','17:35:00',1.62),('12664','2013-04-16','17:40:00',1.52),('12664','2013-04-16','17:45:00',1.43),('12664','2013-04-16','17:50:00',1.39),('12664','2013-04-16','17:55:00',1.39),('12664','2013-04-16','18:00:00',1.38),('12664','2013-04-16','18:05:00',1.2),('12664','2013-04-15','08:00:00',1.08),('12664','2013-04-15','08:05:00',1.18),('12664','2013-04-15','08:10:00',1.29),('12664','2013-04-15','08:15:00',1.4),('12664','2013-04-15','08:20:00',1.5),('12664','2013-04-15','08:25:00',1.61),('12664','2013-04-15','08:30:00',1.71),('12664','2013-04-15','08:35:00',1.81),('12664','2013-04-15','08:40:00',1.91),('12664','2013-04-15','08:45:00',2.02),('12664','2013-04-15','08:50:00',2.12),('12664','2013-04-15','08:55:00',2.21),('12664','2013-04-15','09:00:00',2.31),('12664','2013-04-15','09:05:00',2.41),('12664','2013-04-15','09:10:00',2.51),('12664','2013-04-15','09:15:00',2.58),('12664','2013-04-15','09:20:00',2.67),('12664','2013-04-15','09:25:00',2.75),('12664','2013-04-15','09:30:00',2.82),('12664','2013-04-15','09:35:00',2.89),('12664','2013-04-15','09:40:00',2.97),('12664','2013-04-15','09:45:00',3.05),('12664','2013-04-15','09:50:00',3.12),('12664','2013-04-15','09:55:00',3.19),('12664','2013-04-15','10:00:00',3.27),('12664','2013-04-15','10:05:00',3.34),('12664','2013-04-15','10:10:00',3.39),('12664','2013-04-15','10:15:00',3.46),('12664','2013-04-15','10:20:00',3.52),('12664','2013-04-15','10:25:00',3.58),('12664','2013-04-15','10:30:00',3.63),('12664','2013-04-15','10:35:00',3.69),('12664','2013-04-15','10:40:00',3.75),('12664','2013-04-15','10:45:00',3.8),('12664','2013-04-15','10:50:00',3.85),('12664','2013-04-15','10:55:00',3.89),('12664','2013-04-15','11:00:00',3.93),('12664','2013-04-15','11:05:00',3.95),('12664','2013-04-15','11:10:00',3.99),('12664','2013-04-15','11:15:00',4.03),('12664','2013-04-15','11:20:00',4.08),('12664','2013-04-15','11:25:00',4.11),('12664','2013-04-15','11:30:00',4.13),('12664','2013-04-15','11:35:00',4.15),('12664','2013-04-15','11:40:00',4.16),('12664','2013-04-15','11:45:00',4.18),('12664','2013-04-15','11:50:00',4.22),('12664','2013-04-15','11:55:00',4.24),('12664','2013-04-15','12:00:00',4.24),('12664','2013-04-15','12:05:00',4.27),('12664','2013-04-15','12:10:00',4.32),('12664','2013-04-15','12:15:00',4.35),('12664','2013-04-15','12:20:00',4.36),('12664','2013-04-15','12:25:00',4.36),('12664','2013-04-15','12:30:00',4.36),('12664','2013-04-15','12:35:00',4.37),('12664','2013-04-15','12:40:00',4.38),('12664','2013-04-15','12:45:00',4.38),('12664','2013-04-15','12:50:00',4.39),('12664','2013-04-15','12:55:00',4.4),('12664','2013-04-15','13:00:00',4.43),('12664','2013-04-15','13:05:00',4.44),('12664','2013-04-15','13:10:00',4.4),('12664','2013-04-15','13:15:00',4.4),('12664','2013-04-15','13:20:00',4.4),('12664','2013-04-15','13:25:00',4.37),('12664','2013-04-15','13:30:00',4.42),('12664','2013-04-15','13:35:00',4.43),('12664','2013-04-15','13:40:00',4.44),('12664','2013-04-15','13:45:00',4.47),('12664','2013-04-15','13:50:00',4.47),('12664','2013-04-15','13:55:00',4.45),('12664','2013-04-15','14:00:00',4.43),('12664','2013-04-15','14:05:00',4.41),('12664','2013-04-15','14:10:00',4.38),('12664','2013-04-15','14:15:00',4.37),('12664','2013-04-15','14:20:00',4.34),('12664','2013-04-15','14:25:00',4.3),('12664','2013-04-15','14:30:00',4.26),('12664','2013-04-15','14:35:00',4.21),('12664','2013-04-15','14:40:00',4.17),('12664','2013-04-15','14:45:00',4.13),('12664','2013-04-15','14:50:00',4.1),('12664','2013-04-15','14:55:00',4.05),('12664','2013-04-15','15:00:00',4.01),('12664','2013-04-15','15:05:00',3.96),('12664','2013-04-15','15:10:00',3.91),('12664','2013-04-15','15:15:00',3.88),('12664','2013-04-15','15:20:00',3.82),('12664','2013-04-15','15:25:00',3.77),('12664','2013-04-15','15:30:00',3.71),('12664','2013-04-15','15:35:00',3.64),('12664','2013-04-15','15:40:00',3.57),('12664','2013-04-15','15:45:00',3.51),('12664','2013-04-15','15:50:00',3.43),('12664','2013-04-15','15:55:00',3.37),('12664','2013-04-15','16:00:00',3.3),('12664','2013-04-15','16:05:00',3.22),('12664','2013-04-15','16:10:00',3.15),('12664','2013-04-15','16:15:00',3.08),('12664','2013-04-15','16:20:00',3.01),('12664','2013-04-15','16:25:00',2.94),('12664','2013-04-15','16:30:00',2.86),('12664','2013-04-15','16:35:00',2.77),('12664','2013-04-15','16:40:00',2.68),('12664','2013-04-15','16:45:00',2.6),('12664','2013-04-15','16:50:00',2.51),('12664','2013-04-15','16:55:00',2.42),('12664','2013-04-15','17:00:00',2.33),('12664','2013-04-15','17:05:00',2.24),('12664','2013-04-15','17:10:00',2.15),('12664','2013-04-15','17:15:00',2.05),('12664','2013-04-15','17:20:00',1.96),('12664','2013-04-15','17:25:00',1.86),('12664','2013-04-15','17:30:00',1.76),('12664','2013-04-15','17:35:00',1.66),('12664','2013-04-15','17:40:00',1.56),('12664','2013-04-15','17:45:00',1.46),('12664','2013-04-15','17:50:00',1.36),('12664','2013-04-15','17:55:00',1.25),('12664','2013-04-15','18:00:00',1.15),('12664','2013-04-15','18:05:00',1.06),('12664','2013-04-14','08:00:00',1.01),('12664','2013-04-14','08:05:00',1.12),('12664','2013-04-14','08:10:00',1.23),('12664','2013-04-14','08:15:00',1.32),('12664','2013-04-14','08:20:00',1.41),('12664','2013-04-14','08:25:00',1.5),('12664','2013-04-14','08:30:00',1.6),('12664','2013-04-14','08:35:00',1.68),('12664','2013-04-14','08:40:00',1.77),('12664','2013-04-14','08:45:00',1.85),('12664','2013-04-14','08:50:00',1.95),('12664','2013-04-14','08:55:00',2.04),('12664','2013-04-14','09:00:00',2.13),('12664','2013-04-14','09:05:00',2.23),('12664','2013-04-14','09:10:00',2.33),('12664','2013-04-14','09:15:00',2.41),('12664','2013-04-14','09:20:00',2.51),('12664','2013-04-14','09:25:00',2.58),('12664','2013-04-14','09:30:00',2.67),('12664','2013-04-14','09:35:00',2.75),('12664','2013-04-14','09:40:00',2.82),('12664','2013-04-14','09:45:00',2.91),('12664','2013-04-14','09:50:00',2.99),('12664','2013-04-14','09:55:00',3.05),('12664','2013-04-14','10:00:00',3.12),('12664','2013-04-14','10:05:00',3.19),('12664','2013-04-14','10:10:00',3.26),('12664','2013-04-14','10:15:00',3.33),('12664','2013-04-14','10:20:00',3.38),('12664','2013-04-14','10:25:00',3.44),('12664','2013-04-14','10:30:00',3.5),('12664','2013-04-14','10:35:00',3.56),('12664','2013-04-14','10:40:00',3.6),('12664','2013-04-14','10:45:00',3.67),('12664','2013-04-14','10:50:00',3.7),('12664','2013-04-14','10:55:00',3.76),('12664','2013-04-14','11:00:00',3.81),('12664','2013-04-14','11:05:00',3.85),('12664','2013-04-14','11:10:00',3.88),('12664','2013-04-14','11:15:00',3.92),('12664','2013-04-14','11:20:00',3.96),('12664','2013-04-14','11:25:00',4),('12664','2013-04-14','11:30:00',4.03),('12664','2013-04-14','11:35:00',4.04),('12664','2013-04-14','11:40:00',4.08),('12664','2013-04-14','11:45:00',4.11),('12664','2013-04-14','11:50:00',4.15),('12664','2013-04-14','11:55:00',4.16),('12664','2013-04-14','12:00:00',4.18),('12664','2013-04-14','12:05:00',4.19),('12664','2013-04-14','12:10:00',4.16),('12664','2013-04-14','12:15:00',4.21),('12664','2013-04-14','12:20:00',4.24),('12664','2013-04-14','12:25:00',4.24),('12664','2013-04-14','12:30:00',4.22),('12664','2013-04-14','12:35:00',4.26),('12664','2013-04-14','12:40:00',4.26),('12664','2013-04-14','12:45:00',4.27),('12664','2013-04-14','12:50:00',4.21),('12664','2013-04-14','12:55:00',4.23),('12664','2013-04-14','13:00:00',4.29),('12664','2013-04-14','13:05:00',4.3),('12664','2013-04-14','13:10:00',4.19),('12664','2013-04-14','13:15:00',4.33),('12664','2013-04-14','13:20:00',4.31),('12664','2013-04-14','13:25:00',4.34),('12664','2013-04-14','13:30:00',4.34),('12664','2013-04-14','13:35:00',4.35),('12664','2013-04-14','13:40:00',4.42),('12664','2013-04-14','13:45:00',4.49),('12664','2013-04-14','13:50:00',4.44),('12664','2013-04-14','13:55:00',4.25),('12664','2013-04-14','14:00:00',4.25),('12664','2013-04-14','14:05:00',4.28),('12664','2013-04-14','14:10:00',4.13),('12664','2013-04-14','14:15:00',4.05),('12664','2013-04-14','14:20:00',4.19),('12664','2013-04-14','14:25:00',4.13),('12664','2013-04-14','14:30:00',4.09),('12664','2013-04-14','14:35:00',4.1),('12664','2013-04-14','14:40:00',4.06),('12664','2013-04-14','14:45:00',3.99),('12664','2013-04-14','14:50:00',3.93),('12664','2013-04-14','14:55:00',3.92),('12664','2013-04-14','15:00:00',3.89),('12664','2013-04-14','15:05:00',3.89),('12664','2013-04-14','15:10:00',3.8),('12664','2013-04-14','15:15:00',3.78),('12664','2013-04-14','15:20:00',3.7),('12664','2013-04-14','15:25:00',3.64),('12664','2013-04-14','15:30:00',3.57),('12664','2013-04-14','15:35:00',3.52),('12664','2013-04-14','15:40:00',3.48),('12664','2013-04-14','15:45:00',3.4),('12664','2013-04-14','15:50:00',3.36),('12664','2013-04-14','15:55:00',3.26),('12664','2013-04-14','16:00:00',3.18),('12664','2013-04-14','16:05:00',3.1),('12664','2013-04-14','16:10:00',3.04),('12664','2013-04-14','16:15:00',2.96),('12664','2013-04-14','16:20:00',2.89),('12664','2013-04-14','16:25:00',2.8),('12664','2013-04-14','16:30:00',2.74),('12664','2013-04-14','16:35:00',2.7),('12664','2013-04-14','16:40:00',2.58),('12664','2013-04-14','16:45:00',2.5),('12664','2013-04-14','16:50:00',2.4),('12664','2013-04-14','16:55:00',2.33),('12664','2013-04-14','17:00:00',2.23),('12664','2013-04-14','17:05:00',2.14),('12664','2013-04-14','17:10:00',2.06),('12664','2013-04-14','17:15:00',1.97),('12664','2013-04-14','17:20:00',1.87),('12664','2013-04-14','17:25:00',1.78),('12664','2013-04-14','17:30:00',1.69),('12664','2013-04-14','17:35:00',1.58),('12664','2013-04-14','17:40:00',1.5),('12664','2013-04-14','17:45:00',1.4),('12664','2013-04-14','17:50:00',1.3),('12664','2013-04-14','17:55:00',1.21),('12664','2013-04-14','18:00:00',1.11),('12664','2013-04-14','18:05:00',1.02),('12664','2013-04-13','08:40:00',1.74),('12664','2013-04-13','08:45:00',1.89),('12664','2013-04-13','08:50:00',1.98),('12664','2013-04-13','08:55:00',2.1),('12664','2013-04-13','09:00:00',2.14),('12664','2013-04-13','09:05:00',2.27),('12664','2013-04-13','09:10:00',2.36),('12664','2013-04-13','09:15:00',2.43),('12664','2013-04-13','09:20:00',2.61),('12664','2013-04-13','09:25:00',2.91),('12664','2013-04-13','09:30:00',2.06),('12664','2013-04-13','09:35:00',2.89),('12664','2013-04-13','09:40:00',3.1),('12664','2013-04-13','09:45:00',2.91),('12664','2013-04-13','09:50:00',3.44),('12664','2013-04-13','09:55:00',3),('12664','2013-04-13','10:00:00',1.82),('12664','2013-04-13','10:05:00',1.09),('12664','2013-04-13','10:10:00',2.18),('12664','2013-04-13','10:15:00',2.1),('12664','2013-04-13','10:20:00',3.98),('12664','2013-04-13','10:25:00',3.46),('12664','2013-04-13','10:30:00',2.14),('12664','2013-04-13','10:35:00',3.71),('12664','2013-04-13','10:40:00',3.76),('12664','2013-04-13','10:45:00',2.86),('12664','2013-04-13','10:50:00',1.88),('12664','2013-04-13','10:55:00',3.58),('12664','2013-04-13','11:00:00',2.58),('12664','2013-04-13','11:05:00',1.51),('12664','2013-04-13','11:10:00',3.92),('12664','2013-04-13','11:15:00',4.28),('12664','2013-04-13','11:20:00',4.18),('12664','2013-04-13','11:25:00',1.87),('12664','2013-04-13','11:30:00',2.72),('12664','2013-04-13','11:35:00',4.57),('12664','2013-04-13','11:40:00',3.88),('12664','2013-04-13','11:45:00',3.95),('12664','2013-04-13','11:50:00',2.61),('12664','2013-04-13','11:55:00',4.51),('12664','2013-04-13','12:00:00',4.77),('12664','2013-04-13','12:05:00',4.11),('12664','2013-04-13','12:10:00',4.59),('12664','2013-04-13','12:15:00',4.68),('12664','2013-04-13','12:20:00',4.09),('12664','2013-04-13','12:25:00',4.77),('12664','2013-04-13','12:30:00',4.12),('12664','2013-04-13','12:35:00',4.7),('12664','2013-04-13','12:40:00',4.59),('12664','2013-04-13','12:45:00',4.48),('12664','2013-04-13','12:50:00',4.51),('12664','2013-04-13','12:55:00',4.5),('12664','2013-04-13','13:00:00',4.43),('12664','2013-04-13','13:05:00',4.31),('12664','2013-04-13','13:10:00',4.35),('12664','2013-04-13','13:15:00',4.16),('12664','2013-04-13','13:20:00',4.28),('12664','2013-04-13','13:25:00',4.24),('12664','2013-04-13','13:30:00',3.95),('12664','2013-04-13','13:35:00',4.03),('12664','2013-04-13','13:40:00',3.8),('12664','2013-04-13','13:45:00',3.85),('12664','2013-04-13','13:50:00',3.64),('12664','2013-04-13','13:55:00',3.7),('12664','2013-04-13','14:00:00',3.71),('12664','2013-04-13','14:05:00',3.7),('12664','2013-04-13','14:10:00',3.63),('12664','2013-04-13','14:15:00',3.62),('12664','2013-04-13','14:20:00',3.65),('12664','2013-04-13','14:25:00',3.85),('12664','2013-04-13','14:30:00',4.06),('12664','2013-04-13','14:35:00',4),('12664','2013-04-13','14:40:00',3.91),('12664','2013-04-13','14:45:00',3.82),('12664','2013-04-13','14:50:00',3.68),('12664','2013-04-13','14:55:00',3.45),('12664','2013-04-13','15:00:00',3.43),('12664','2013-04-13','15:05:00',3.44),('12664','2013-04-13','15:10:00',3.25),('12664','2013-04-13','15:15:00',2.95),('12664','2013-04-13','15:20:00',2.95),('12664','2013-04-13','15:25:00',2.97),('12664','2013-04-13','15:30:00',2.87),('12664','2013-04-13','15:35:00',3.05),('12664','2013-04-13','15:40:00',3),('12664','2013-04-13','15:45:00',3.07),('12664','2013-04-13','15:50:00',3.11),('12664','2013-04-13','15:55:00',2.54),('12664','2013-04-13','16:00:00',2.61),('12664','2013-04-13','16:05:00',2.62),('12664','2013-04-13','16:10:00',2.64),('12664','2013-04-13','16:15:00',2.52),('12664','2013-04-13','16:20:00',2.26),('12664','2013-04-13','16:25:00',2.09),('12664','2013-04-13','16:30:00',2.07),('12664','2013-04-13','16:35:00',1.81),('12664','2013-04-13','16:40:00',1.82),('12664','2013-04-13','16:45:00',1.91),('12664','2013-04-13','16:50:00',1.63),('12664','2013-04-13','16:55:00',1.36),('12664','2013-04-13','17:00:00',1.84),('12664','2013-04-13','17:05:00',2.32),('12664','2013-04-13','17:10:00',2.13),('12664','2013-04-13','17:15:00',1.81),('12664','2013-04-13','17:20:00',1.92),('12664','2013-04-13','17:25:00',1.85),('12664','2013-04-13','17:30:00',1.64),('12664','2013-04-13','17:35:00',1.67),('12664','2013-04-13','17:40:00',1.57),('12664','2013-04-13','17:45:00',1.32),('12664','2013-04-13','17:50:00',1.25),('12664','2013-04-13','17:55:00',1.1),('12664','2013-04-13','18:05:00',1),('12664','2013-04-12','08:21:00',1.42),('12664','2013-04-12','08:25:00',1.05),('12664','2013-04-12','08:40:00',2.01),('12664','2013-04-12','08:50:00',1.03),('12664','2013-04-12','08:55:00',1.06),('12664','2013-04-12','09:00:00',1.17),('12664','2013-04-12','09:05:00',1.18),('12664','2013-04-12','09:10:00',1.16),('12664','2013-04-12','09:15:00',1.11),('12664','2013-04-12','09:25:00',1.36),('12664','2013-04-12','09:30:00',1.34),('12664','2013-04-12','09:35:00',1.11),('12664','2013-04-12','09:40:00',1.4),('12664','2013-04-12','09:45:00',1.45),('12664','2013-04-12','10:00:00',1.05),('12664','2013-04-12','10:05:00',1.19),('12664','2013-04-12','10:10:00',1.25),('12664','2013-04-12','10:15:00',1.15),('12664','2013-04-12','10:30:00',1.05),('12664','2013-04-12','10:35:00',1.13),('12664','2013-04-12','10:40:00',1.23),('12664','2013-04-12','10:45:00',1.32),('12664','2013-04-12','10:50:00',1.63),('12664','2013-04-12','10:55:00',1.85),('12664','2013-04-12','11:00:00',2.41),('12664','2013-04-12','11:05:00',3.67),('12664','2013-04-12','11:10:00',2.77),('12664','2013-04-12','11:15:00',2.46),('12664','2013-04-12','11:20:00',4.61),('12664','2013-04-12','11:25:00',4.53),('12664','2013-04-12','11:30:00',4.44),('12664','2013-04-12','11:35:00',4.38),('12664','2013-04-12','11:40:00',4.56),('12664','2013-04-12','11:45:00',4.54),('12664','2013-04-12','11:50:00',4.51),('12664','2013-04-12','11:55:00',4.19),('12664','2013-04-12','12:00:00',4.35),('12664','2013-04-12','12:05:00',4.11),('12664','2013-04-12','12:10:00',4.54),('12664','2013-04-12','12:15:00',4.08),('12664','2013-04-12','12:20:00',4.54),('12664','2013-04-12','12:25:00',4.63),('12664','2013-04-12','12:30:00',4.58),('12664','2013-04-12','12:35:00',4.66),('12664','2013-04-12','12:40:00',4.52),('12664','2013-04-12','12:45:00',4.26),('12664','2013-04-12','12:50:00',4.47),('12664','2013-04-12','12:55:00',4.87),('12664','2013-04-12','13:00:00',4.78),('12664','2013-04-12','13:05:00',4.63),('12664','2013-04-12','13:10:00',4.54),('12664','2013-04-12','13:15:00',4.23),('12664','2013-04-12','13:20:00',4.47),('12664','2013-04-12','13:25:00',4.49),('12664','2013-04-12','13:30:00',4.47),('12664','2013-04-12','13:35:00',4.44),('12664','2013-04-12','13:40:00',4.49),('12664','2013-04-12','13:45:00',4.47),('12664','2013-04-12','13:50:00',4.47),('12664','2013-04-12','13:55:00',4.43),('12664','2013-04-12','14:00:00',4.28),('12664','2013-04-12','14:05:00',4.36),('12664','2013-04-12','14:10:00',4.33),('12664','2013-04-12','14:15:00',4.31),('12664','2013-04-12','14:20:00',4.25),('12664','2013-04-12','14:25:00',4.24),('12664','2013-04-12','14:30:00',4.21),('12664','2013-04-12','14:35:00',3.73),('12664','2013-04-12','14:40:00',4.1),('12664','2013-04-12','14:45:00',4.09),('12664','2013-04-12','14:50:00',4.07),('12664','2013-04-12','14:55:00',4.02),('12664','2013-04-12','15:00:00',3.96),('12664','2013-04-12','15:05:00',3.91),('12664','2013-04-12','15:10:00',3.88),('12664','2013-04-12','15:15:00',3.83),('12664','2013-04-12','15:20:00',3.79),('12664','2013-04-12','15:25:00',3.71),('12664','2013-04-12','15:30:00',3.65),('12664','2013-04-12','15:35:00',3.57),('12664','2013-04-12','15:40:00',3.51),('12664','2013-04-12','15:45:00',3.44),('12664','2013-04-12','15:50:00',3.42),('12664','2013-04-12','15:55:00',3.32),('12664','2013-04-12','16:00:00',3.27),('12664','2013-04-12','16:05:00',3.22),('12664','2013-04-12','16:10:00',2.74),('12664','2013-04-12','16:15:00',3.13),('12664','2013-04-12','16:20:00',2.98),('12664','2013-04-12','16:25:00',2.48),('12664','2013-04-12','16:30:00',2.83),('12664','2013-04-12','16:35:00',2.3),('12664','2013-04-12','16:40:00',2.11),('12664','2013-04-12','16:45:00',2.63),('12664','2013-04-12','16:50:00',2.5),('12664','2013-04-12','16:55:00',2.52),('12664','2013-04-12','17:00:00',2.56),('12664','2013-04-12','17:05:00',2.32),('12664','2013-04-12','17:10:00',2.27),('12664','2013-04-12','17:15:00',2.05),('12664','2013-04-12','17:20:00',1.92),('12664','2013-04-12','17:25:00',1.82),('12664','2013-04-12','17:30:00',1.53),('12664','2013-04-12','17:35:00',1.34),('12664','2013-04-12','17:40:00',1.47),('12664','2013-04-12','17:45:00',1.4),('12664','2013-04-12','17:50:00',1.31),('12664','2013-04-12','17:55:00',1.22),('12664','2013-04-12','18:00:00',1.17),('12664','2013-04-12','18:05:00',1.26),('12664','2013-04-12','18:10:00',1.23),('12664','2013-04-11','08:05:00',1.09),('12664','2013-04-11','08:10:00',1.19),('12664','2013-04-11','08:15:00',1.28),('12664','2013-04-11','08:20:00',1.37),('12664','2013-04-11','08:25:00',1.46),('12664','2013-04-11','08:30:00',1.56),('12664','2013-04-11','08:35:00',1.66),('12664','2013-04-11','08:40:00',1.76),('12664','2013-04-11','08:45:00',1.86),('12664','2013-04-11','08:50:00',1.97),('12664','2013-04-11','08:55:00',2.07),('12664','2013-04-11','09:00:00',2.16),('12664','2013-04-11','09:05:00',2.24),('12664','2013-04-11','09:10:00',2.34),('12664','2013-04-11','09:15:00',2.43),('12664','2013-04-11','09:20:00',2.5),('12664','2013-04-11','09:25:00',2.52),('12664','2013-04-11','09:30:00',2.64),('12664','2013-04-11','09:35:00',2.67),('12664','2013-04-11','09:40:00',3.12),('12664','2013-04-11','09:45:00',3.22),('12664','2013-04-11','09:50:00',3.34),('12664','2013-04-11','09:55:00',3.59),('12664','2013-04-11','10:00:00',3.08),('12664','2013-04-11','10:05:00',1.49),('12664','2013-04-11','10:15:00',3.59),('12664','2013-04-11','10:20:00',3.55),('12664','2013-04-11','10:25:00',3.33),('12664','2013-04-11','10:30:00',1.17),('12664','2013-04-11','10:35:00',1.09),('12664','2013-04-11','10:40:00',1.64),('12664','2013-04-11','10:45:00',1.93),('12664','2013-04-11','10:50:00',4),('12664','2013-04-11','10:55:00',4.17),('12664','2013-04-11','11:00:00',4.26),('12664','2013-04-11','11:05:00',4.08),('12664','2013-04-11','11:10:00',1.43),('12664','2013-04-11','11:15:00',1.86),('12664','2013-04-11','11:20:00',1.56),('12664','2013-04-11','11:25:00',1.47),('12664','2013-04-11','11:30:00',1.56),('12664','2013-04-11','11:35:00',3.34),('12664','2013-04-11','11:40:00',4.31),('12664','2013-04-11','11:45:00',4.81),('12664','2013-04-11','11:50:00',4.71),('12664','2013-04-11','11:55:00',4.63),('12664','2013-04-11','12:00:00',4.66),('12664','2013-04-11','12:05:00',4.81),('12664','2013-04-11','12:10:00',4.08),('12664','2013-04-11','12:15:00',4.33),('12664','2013-04-11','12:20:00',4.81),('12664','2013-04-11','12:25:00',4.75),('12664','2013-04-11','12:30:00',3.98),('12664','2013-04-11','12:35:00',3.37),('12664','2013-04-11','12:40:00',4.8),('12664','2013-04-11','12:45:00',4.74),('12664','2013-04-11','12:50:00',2.53),('12664','2013-04-11','12:55:00',2.01),('12664','2013-04-11','13:00:00',3.18),('12664','2013-04-11','13:05:00',3.15),('12664','2013-04-11','13:10:00',4.6),('12664','2013-04-11','13:15:00',4.82),('12664','2013-04-11','13:20:00',2.96),('12664','2013-04-11','13:25:00',3.61),('12664','2013-04-11','13:30:00',4.74),('12664','2013-04-11','13:35:00',4.65),('12664','2013-04-11','13:40:00',3.88),('12664','2013-04-11','13:45:00',3.05),('12664','2013-04-11','13:50:00',2.01),('12664','2013-04-11','13:55:00',4.74),('12664','2013-04-11','14:00:00',3.21),('12664','2013-04-11','14:05:00',1.59),('12664','2013-04-11','14:10:00',4.43),('12664','2013-04-11','14:15:00',3.62),('12664','2013-04-11','14:20:00',3.6),('12664','2013-04-11','14:25:00',3.76),('12664','2013-04-11','14:30:00',3.76),('12664','2013-04-11','14:35:00',3.29),('12664','2013-04-11','14:40:00',3.74),('12664','2013-04-11','14:45:00',3.41),('12664','2013-04-11','14:50:00',3.4),('12664','2013-04-11','14:55:00',4.25),('12664','2013-04-11','15:00:00',4.06),('12664','2013-04-11','15:05:00',4.01),('12664','2013-04-11','15:10:00',3.99),('12664','2013-04-11','15:15:00',3.88),('12664','2013-04-11','15:20:00',3.82),('12664','2013-04-11','15:25:00',3.79),('12664','2013-04-11','15:30:00',3.71),('12664','2013-04-11','15:35:00',3.66),('12664','2013-04-11','15:40:00',3.6),('12664','2013-04-11','15:45:00',3.53),('12664','2013-04-11','15:50:00',3.47),('12664','2013-04-11','15:55:00',3.41),('12664','2013-04-11','16:00:00',3.33),('12664','2013-04-11','16:05:00',3.26),('12664','2013-04-11','16:10:00',3.21),('12664','2013-04-11','16:15:00',3.12),('12664','2013-04-11','16:20:00',3.03),('12664','2013-04-11','16:25:00',2.96),('12664','2013-04-11','16:30:00',2.88),('12664','2013-04-11','16:35:00',2.79),('12664','2013-04-11','16:40:00',2.72),('12664','2013-04-11','16:45:00',2.62),('12664','2013-04-11','16:50:00',2.52),('12664','2013-04-11','16:55:00',2.44),('12664','2013-04-11','17:00:00',2.34),('12664','2013-04-11','17:05:00',2.26),('12664','2013-04-11','17:10:00',2.16),('12664','2013-04-11','17:15:00',2.06),('12664','2013-04-11','17:20:00',1.97),('12664','2013-04-11','17:25:00',1.88),('12664','2013-04-11','17:30:00',1.77),('12664','2013-04-11','17:35:00',1.67),('12664','2013-04-11','17:40:00',1.57),('12664','2013-04-11','17:45:00',1.47),('12664','2013-04-11','17:50:00',1.36),('12664','2013-04-11','17:55:00',1.24),('12664','2013-04-11','18:00:00',1.07),('12664','2013-04-11','18:05:00',1),('12664','2014-03-27','09:25:00',1.08),('12664','2014-03-27','09:30:00',1.02),('12664','2014-03-27','10:05:00',1.19),('12664','2014-03-27','10:10:00',1.37),('12664','2014-03-27','10:15:00',1.31),('12664','2014-03-27','10:20:00',1.31),('12664','2014-03-27','10:25:00',1.49),('12664','2014-03-27','10:30:00',1.49),('12664','2014-03-27','10:35:00',1.63),('12664','2014-03-27','10:40:00',1.88),('12664','2014-03-27','10:45:00',2.01),('12664','2014-03-27','10:50:00',2.15),('12664','2014-03-27','10:55:00',2.07),('12664','2014-03-27','11:00:00',4.25),('12664','2014-03-27','11:05:00',2.4),('12664','2014-03-27','11:10:00',1.59),('12664','2014-03-27','11:15:00',1.43),('12664','2014-03-27','11:20:00',1.59),('12664','2014-03-27','11:25:00',1.12),('12664','2014-03-27','11:45:00',1.32),('12664','2014-03-27','11:50:00',1.49),('12664','2014-03-27','12:50:00',1.17),('12664','2014-03-27','12:55:00',1.35),('12664','2014-03-27','13:00:00',1.34),('12664','2014-03-27','13:05:00',1.7),('12664','2014-03-27','13:10:00',2.48),('12664','2014-03-27','13:15:00',2.89),('12664','2014-03-27','13:20:00',3.02),('12664','2014-03-27','13:25:00',3.42),('12664','2014-03-27','13:30:00',2.95),('12664','2014-03-27','13:35:00',2.5),('12664','2014-03-27','13:40:00',2.28),('12664','2014-03-27','13:45:00',2.07),('12664','2014-03-27','13:50:00',1.77),('12664','2014-03-27','13:55:00',1.08),('12664','2014-03-27','14:05:00',2.31),('12664','2014-03-27','14:10:00',1.91),('12664','2014-03-27','14:20:00',1.39),('12664','2014-03-27','14:25:00',1.67),('12664','2014-03-27','14:30:00',1.03),('12664','2014-03-27','15:40:00',2.38),('12664','2014-03-27','15:45:00',1.88),('12664','2014-03-27','15:50:00',1.53),('12664','2014-03-27','15:55:00',1.58),('12664','2014-03-27','16:20:00',1.16),('12664','2014-03-27','16:25:00',1.12),('12664','2013-04-10','08:45:00',1.46),('12664','2013-04-10','08:50:00',1.6),('12664','2013-04-10','08:55:00',1.85),('12664','2013-04-10','09:00:00',1.48),('12664','2013-04-10','09:05:00',2.15),('12664','2013-04-10','09:10:00',2.43),('12664','2013-04-10','09:15:00',2.54),('12664','2013-04-10','09:20:00',2.55),('12664','2013-04-10','09:25:00',2.56),('12664','2013-04-10','09:30:00',2.74),('12664','2013-04-10','09:35:00',2.86),('12664','2013-04-10','09:40:00',2.98),('12664','2013-04-10','09:45:00',2.68),('12664','2013-04-10','09:50:00',2.49),('12664','2013-04-10','09:55:00',3.27),('12664','2013-04-10','10:00:00',1.77),('12664','2013-04-10','10:10:00',1.48),('12664','2013-04-10','10:15:00',3.13),('12664','2013-04-10','10:20:00',2.26),('12664','2013-04-10','10:25:00',2.64),('12664','2013-04-10','10:30:00',2.1),('12664','2013-04-10','10:35:00',1.65),('12664','2013-04-10','10:40:00',1.51),('12664','2013-04-10','10:45:00',2.49),('12664','2013-04-10','10:50:00',1.01),('12664','2013-04-10','10:55:00',3.07),('12664','2013-04-10','11:00:00',4.22),('12664','2013-04-10','11:05:00',2.86),('12664','2013-04-10','11:10:00',3.17),('12664','2013-04-10','11:15:00',3.2),('12664','2013-04-10','11:20:00',4.06),('12664','2013-04-10','11:25:00',4.57),('12664','2013-04-10','11:30:00',4.19),('12664','2013-04-10','11:35:00',4.54),('12664','2013-04-10','11:40:00',4.57),('12664','2013-04-10','11:45:00',4.5),('12664','2013-04-10','11:50:00',4.53),('12664','2013-04-10','11:55:00',4.79),('12664','2013-04-10','12:00:00',4.08),('12664','2013-04-10','12:05:00',4.04),('12664','2013-04-10','12:10:00',3.57),('12664','2013-04-10','12:15:00',5.04),('12664','2013-04-10','12:20:00',3.74),('12664','2013-04-10','12:25:00',4.94),('12664','2013-04-10','12:30:00',4.78),('12664','2013-04-10','12:35:00',3.2),('12664','2013-04-10','12:40:00',4.85),('12664','2013-04-10','12:45:00',4.71),('12664','2013-04-10','12:50:00',3.29),('12664','2013-04-10','12:55:00',4.83),('12664','2013-04-10','13:00:00',3.75),('12664','2013-04-10','13:05:00',4.91),('12664','2013-04-10','13:10:00',4.75),('12664','2013-04-10','13:15:00',4.3),('12664','2013-04-10','13:20:00',4.19),('12664','2013-04-10','13:25:00',4.41),('12664','2013-04-10','13:30:00',4.55),('12664','2013-04-10','13:35:00',4.42),('12664','2013-04-10','13:40:00',4.45),('12664','2013-04-10','13:45:00',4.82),('12664','2013-04-10','13:50:00',4.95),('12664','2013-04-10','13:55:00',2.28),('12664','2013-04-10','14:00:00',3.62),('12664','2013-04-10','14:05:00',2.36),('12664','2013-04-10','14:10:00',4.23),('12664','2013-04-10','14:15:00',4.72),('12664','2013-04-10','14:20:00',4.64),('12664','2013-04-10','14:25:00',4.65),('12664','2013-04-10','14:30:00',4.28),('12664','2013-04-10','14:35:00',3.65),('12664','2013-04-10','14:40:00',2.42),('12664','2013-04-10','14:45:00',4.15),('12664','2013-04-10','14:50:00',4.53),('12664','2013-04-10','14:55:00',4.12),('12664','2013-04-10','15:00:00',4.15),('12664','2013-04-10','15:05:00',4.19),('12664','2013-04-10','15:10:00',3.73),('12664','2013-04-10','15:15:00',3.49),('12664','2013-04-10','15:20:00',4.03),('12664','2013-04-10','15:25:00',3.82),('12664','2013-04-10','15:30:00',3.8),('12664','2013-04-10','15:35:00',3.72),('12664','2013-04-10','15:40:00',3.36),('12664','2013-04-10','15:45:00',3.81),('12664','2013-04-10','15:50:00',3.63),('12664','2013-04-10','15:55:00',2.96),('12664','2013-04-10','16:00:00',2.48),('12664','2013-04-10','16:05:00',1.26),('12664','2013-04-10','16:10:00',2.94),('12664','2013-04-10','16:15:00',2.58),('12664','2013-04-10','16:20:00',2.5),('12664','2013-04-10','16:25:00',3.16),('12664','2013-04-10','16:30:00',1.16),('12664','2013-04-10','16:35:00',1.42),('12664','2013-04-10','16:40:00',1.17),('12664','2013-04-10','16:45:00',1.28),('12664','2013-04-10','16:50:00',1.24),('12664','2013-04-10','16:55:00',1.61),('12664','2013-04-10','17:00:00',2.4),('12664','2013-04-10','17:05:00',2.65),('12664','2013-04-10','17:10:00',2.72),('12664','2013-04-10','17:15:00',2.5),('12664','2013-04-10','17:20:00',2.29),('12664','2013-04-10','17:25:00',2.09),('12664','2013-04-10','17:30:00',1.8),('12664','2013-04-10','17:35:00',1.73),('12664','2013-04-10','17:40:00',1.25),('12664','2013-04-10','17:45:00',1.78),('12664','2013-04-10','17:50:00',1.8),('12664','2013-04-10','17:55:00',1.75),('12664','2013-04-10','18:00:00',1.67),('12664','2013-04-10','18:05:00',1.49),('12664','2013-04-10','18:10:00',1.43),('12664','2013-04-10','18:15:00',1.29),('12664','2013-04-10','18:20:00',1.4),('12664','2013-04-10','18:25:00',1.18),('12664','2013-04-09','08:05:00',1.04),('12664','2013-04-09','08:10:00',1.2),('12664','2013-04-09','08:15:00',1.56),('12664','2013-04-09','08:20:00',1.14),('12664','2013-04-09','08:25:00',1.04),('12664','2013-04-09','08:30:00',1.06),('12664','2013-04-09','08:35:00',1.09),('12664','2013-04-09','08:40:00',1.46),('12664','2013-04-09','08:45:00',1.65),('12664','2013-04-09','08:50:00',1.88),('12664','2013-04-09','08:55:00',1.68),('12664','2013-04-09','09:00:00',1.82),('12664','2013-04-09','09:05:00',1.17),('12664','2013-04-09','09:10:00',1.14),('12664','2013-04-09','09:15:00',1.55),('12664','2013-04-09','09:20:00',1.36),('12664','2013-04-09','09:25:00',1.7),('12664','2013-04-09','09:30:00',2.1),('12664','2013-04-09','09:35:00',1.63),('12664','2013-04-09','09:40:00',1.44),('12664','2013-04-09','09:45:00',1.88),('12664','2013-04-09','09:50:00',2.23),('12664','2013-04-09','09:55:00',3.84),('12664','2013-04-09','10:00:00',2),('12664','2013-04-09','10:05:00',2.55),('12664','2013-04-09','10:10:00',2.88),('12664','2013-04-09','10:15:00',3.48),('12664','2013-04-09','10:20:00',1.92),('12664','2013-04-09','10:25:00',3.74),('12664','2013-04-09','10:30:00',4.13),('12664','2013-04-09','10:35:00',3.73),('12664','2013-04-09','10:40:00',1.21),('12664','2013-04-09','10:45:00',4.31),('12664','2013-04-09','10:50:00',4.25),('12664','2013-04-09','10:55:00',2.73),('12664','2013-04-09','11:00:00',3.81),('12664','2013-04-09','11:05:00',2.86),('12664','2013-04-09','11:10:00',4.53),('12664','2013-04-09','11:15:00',4.44),('12664','2013-04-09','11:20:00',1.98),('12664','2013-04-09','11:25:00',4.32),('12664','2013-04-09','11:30:00',1.65),('12664','2013-04-09','11:35:00',1.43),('12664','2013-04-09','11:40:00',1.05),('12664','2013-04-09','11:45:00',1.24),('12664','2013-04-09','11:50:00',2.75),('12664','2013-04-09','11:55:00',5.02),('12664','2013-04-09','12:00:00',4.99),('12664','2013-04-09','12:05:00',4.92),('12664','2013-04-09','12:10:00',4.02),('12664','2013-04-09','12:15:00',2.82),('12664','2013-04-09','12:20:00',3.72),('12664','2013-04-09','12:25:00',2.37),('12664','2013-04-09','12:30:00',3.92),('12664','2013-04-09','12:35:00',1.32),('12664','2013-04-09','12:40:00',2.73),('12664','2013-04-09','12:45:00',3.16),('12664','2013-04-09','12:50:00',3.41),('12664','2013-04-09','12:55:00',3.64),('12664','2013-04-09','13:00:00',2.57),('12664','2013-04-09','13:05:00',2.16),('12664','2013-04-09','13:10:00',4.84),('12664','2013-04-09','13:15:00',3.98),('12664','2013-04-09','13:20:00',4.42),('12664','2013-04-09','13:25:00',2.62),('12664','2013-04-09','13:30:00',3),('12664','2013-04-09','13:35:00',2.88),('12664','2013-04-09','13:40:00',3.99),('12664','2013-04-09','13:45:00',4.8),('12664','2013-04-09','13:50:00',4.51),('12664','2013-04-09','13:55:00',4.24),('12664','2013-04-09','14:00:00',4.44),('12664','2013-04-09','14:05:00',4.39),('12664','2013-04-09','14:10:00',4.21),('12664','2013-04-09','14:15:00',1.98),('12664','2013-04-09','14:20:00',3.66),('12664','2013-04-09','14:25:00',3.87),('12664','2013-04-09','14:30:00',3.8),('12664','2013-04-09','14:35:00',4.25),('12664','2013-04-09','14:40:00',3.87),('12664','2013-04-09','14:45:00',3.57),('12664','2013-04-09','14:50:00',4.2),('12664','2013-04-09','14:55:00',4.12),('12664','2013-04-09','15:00:00',4.21),('12664','2013-04-09','15:05:00',4.03),('12664','2013-04-09','15:10:00',3.87),('12664','2013-04-09','15:15:00',3.92),('12664','2013-04-09','15:20:00',3.98),('12664','2013-04-09','15:25:00',3.95),('12664','2013-04-09','15:30:00',3.9),('12664','2013-04-09','15:35:00',3.65),('12664','2013-04-09','15:40:00',3.78),('12664','2013-04-09','15:45:00',3.63),('12664','2013-04-09','15:50:00',3.28),('12664','2013-04-09','15:55:00',2.95),('12664','2013-04-09','16:00:00',3.19),('12664','2013-04-09','16:05:00',3.45),('12664','2013-04-09','16:10:00',3.16),('12664','2013-04-09','16:15:00',3),('12664','2013-04-09','16:20:00',3.1),('12664','2013-04-09','16:25:00',2.92),('12664','2013-04-09','16:30:00',2.5),('12664','2013-04-09','16:35:00',2.62),('12664','2013-04-09','16:40:00',2.39),('12664','2013-04-09','16:45:00',2.74),('12664','2013-04-09','16:50:00',2.65),('12664','2013-04-09','16:55:00',2.21),('12664','2013-04-09','17:00:00',2.71),('12664','2013-04-09','17:05:00',2.44),('12664','2013-04-09','17:10:00',2.35),('12664','2013-04-09','17:15:00',2.23),('12664','2013-04-09','17:20:00',2.03),('12664','2013-04-09','17:25:00',1.63),('12664','2013-04-09','17:30:00',1.68),('12664','2013-04-09','17:35:00',1.29),('12664','2013-04-09','17:40:00',1.04),('12664','2013-04-08','08:25:00',1.1),('12664','2013-04-08','08:30:00',1.24),('12664','2013-04-08','08:35:00',1.73),('12664','2013-04-08','08:40:00',1.19),('12664','2013-04-08','08:50:00',1.02),('12664','2013-04-08','08:55:00',1.38),('12664','2013-04-08','09:00:00',2.06),('12664','2013-04-08','09:05:00',2.34),('12664','2013-04-08','09:10:00',2.51),('12664','2013-04-08','09:15:00',2.22),('12664','2013-04-08','09:20:00',2.49),('12664','2013-04-08','09:25:00',2.89),('12664','2013-04-08','09:30:00',2.88),('12664','2013-04-08','09:35:00',3.11),('12664','2013-04-08','09:40:00',3.1),('12664','2013-04-08','09:45:00',2.73),('12664','2013-04-08','09:50:00',1.46),('12664','2013-04-08','09:55:00',2.66),('12664','2013-04-08','10:00:00',3.08),('12664','2013-04-08','10:05:00',2.6),('12664','2013-04-08','10:10:00',3.36),('12664','2013-04-08','10:15:00',3.5),('12664','2013-04-08','10:20:00',3.53),('12664','2013-04-08','10:25:00',3.29),('12664','2013-04-08','10:30:00',3.49),('12664','2013-04-08','10:35:00',3.66),('12664','2013-04-08','10:40:00',3.82),('12664','2013-04-08','10:45:00',3.77),('12664','2013-04-08','10:50:00',3.79),('12664','2013-04-08','10:55:00',3.29),('12664','2013-04-08','11:00:00',3.28),('12664','2013-04-08','11:05:00',2.91),('12664','2013-04-08','11:10:00',2.93),('12664','2013-04-08','11:15:00',2.42),('12664','2013-04-08','11:20:00',2.13),('12664','2013-04-08','11:25:00',2.31),('12664','2013-04-08','11:30:00',2.94),('12664','2013-04-08','11:35:00',2.59),('12664','2013-04-08','11:40:00',2.74),('12664','2013-04-08','11:45:00',2.71),('12664','2013-04-08','11:50:00',2.69),('12664','2013-04-08','11:55:00',2.61),('12664','2013-04-08','12:00:00',2.34),('12664','2013-04-08','12:05:00',2.74),('12664','2013-04-08','12:10:00',3.32),('12664','2013-04-08','12:15:00',3.17),('12664','2013-04-08','12:20:00',3.23),('12664','2013-04-08','12:25:00',3.13),('12664','2013-04-08','12:30:00',3.33),('12664','2013-04-08','12:35:00',3.58),('12664','2013-04-08','12:40:00',3.35),('12664','2013-04-08','12:45:00',3.07),('12664','2013-04-08','12:50:00',3.85),('12664','2013-04-08','12:55:00',3.89),('12664','2013-04-08','13:00:00',3.49),('12664','2013-04-08','13:05:00',3.45),('12664','2013-04-08','13:10:00',3.82),('12664','2013-04-08','13:15:00',3.37),('12664','2013-04-08','13:20:00',3.89),('12664','2013-04-08','13:25:00',3.82),('12664','2013-04-08','13:30:00',2.99),('12664','2013-04-08','13:35:00',2.42),('12664','2013-04-08','13:40:00',4.14),('12664','2013-04-08','13:45:00',4.1),('12664','2013-04-08','13:50:00',3.68),('12664','2013-04-08','13:55:00',3.62),('12664','2013-04-08','14:00:00',3.72),('12664','2013-04-08','14:05:00',4.24),('12664','2013-04-08','14:10:00',3.97),('12664','2013-04-08','14:15:00',3.4),('12664','2013-04-08','14:20:00',3.86),('12664','2013-04-08','14:25:00',3.71),('12664','2013-04-08','14:30:00',3.72),('12664','2013-04-08','14:35:00',3.75),('12664','2013-04-08','14:40:00',4.09),('12664','2013-04-08','14:45:00',3.93),('12664','2013-04-08','14:50:00',4.2),('12664','2013-04-08','14:55:00',3.27),('12664','2013-04-08','15:00:00',3.6),('12664','2013-04-08','15:05:00',3.78),('12664','2013-04-08','15:10:00',3.26),('12664','2013-04-08','15:15:00',3.71),('12664','2013-04-08','15:20:00',3.93),('12664','2013-04-08','15:25:00',3.85),('12664','2013-04-08','15:30:00',3.72),('12664','2013-04-08','15:35:00',3.68),('12664','2013-04-08','15:40:00',3.59),('12664','2013-04-08','15:45:00',3.57),('12664','2013-04-08','15:50:00',3.51),('12664','2013-04-08','15:55:00',3.43),('12664','2013-04-08','16:00:00',3.33),('12664','2013-04-08','16:05:00',3.06),('12664','2013-04-08','16:10:00',3.17),('12664','2013-04-08','16:15:00',3.2),('12664','2013-04-08','16:20:00',3.04),('12664','2013-04-08','16:25:00',2.96),('12664','2013-04-08','16:30:00',2.92),('12664','2013-04-08','16:35:00',2.82),('12664','2013-04-08','16:40:00',2.75),('12664','2013-04-08','16:45:00',2.66),('12664','2013-04-08','16:50:00',2.56),('12664','2013-04-08','16:55:00',2.48),('12664','2013-04-08','17:00:00',2.41),('12664','2013-04-08','17:05:00',2.3),('12664','2013-04-08','17:10:00',2.2),('12664','2013-04-08','17:15:00',2.05),('12664','2013-04-08','17:20:00',2.01),('12664','2013-04-08','17:25:00',1.92),('12664','2013-04-08','17:30:00',1.75),('12664','2013-04-08','17:35:00',1.6),('12664','2013-04-08','17:40:00',1.34),('12664','2013-04-08','17:45:00',1.3),('12664','2013-04-08','17:55:00',1.04),('12664','2013-04-08','18:15:00',1.15),('12664','2013-04-08','18:20:00',1.17),('12664','2013-04-07','08:30:00',1.02),('12664','2013-04-07','08:35:00',1.09),('12664','2013-04-07','08:40:00',1.2),('12664','2013-04-07','08:45:00',1.31),('12664','2013-04-07','08:50:00',1.47),('12664','2013-04-07','08:55:00',1.67),('12664','2013-04-07','09:00:00',1.72),('12664','2013-04-07','09:05:00',1.85),('12664','2013-04-07','09:10:00',1.88),('12664','2013-04-07','09:15:00',1.82),('12664','2013-04-07','09:20:00',1.98),('12664','2013-04-07','09:25:00',1.9),('12664','2013-04-07','09:30:00',1.81),('12664','2013-04-07','09:35:00',1.94),('12664','2013-04-07','09:40:00',2.14),('12664','2013-04-07','09:45:00',2.35),('12664','2013-04-07','09:50:00',2.36),('12664','2013-04-07','09:55:00',2.31),('12664','2013-04-07','10:00:00',2.07),('12664','2013-04-07','10:05:00',1.91),('12664','2013-04-07','10:10:00',1.99),('12664','2013-04-07','10:15:00',2.41),('12664','2013-04-07','10:20:00',2.54),('12664','2013-04-07','10:25:00',3.05),('12664','2013-04-07','10:30:00',3.28),('12664','2013-04-07','10:35:00',3.31),('12664','2013-04-07','10:40:00',3.45),('12664','2013-04-07','10:45:00',3.51),('12664','2013-04-07','10:50:00',3.29),('12664','2013-04-07','10:55:00',2.86),('12664','2013-04-07','11:00:00',3.02),('12664','2013-04-07','11:05:00',2.77),('12664','2013-04-07','11:10:00',2.71),('12664','2013-04-07','11:15:00',2.6),('12664','2013-04-07','11:20:00',2.39),('12664','2013-04-07','11:25:00',2.27),('12664','2013-04-07','11:30:00',2.38),('12664','2013-04-07','11:35:00',2.81),('12664','2013-04-07','11:40:00',3.64),('12664','2013-04-07','11:45:00',4.26),('12664','2013-04-07','11:50:00',4.29),('12664','2013-04-07','11:55:00',4.31),('12664','2013-04-07','12:00:00',3.66),('12664','2013-04-07','12:05:00',3.38),('12664','2013-04-07','12:10:00',3.12),('12664','2013-04-07','12:15:00',3.22),('12664','2013-04-07','12:20:00',2.91),('12664','2013-04-07','12:25:00',3.11),('12664','2013-04-07','12:30:00',3.62),('12664','2013-04-07','12:35:00',3.68),('12664','2013-04-07','12:40:00',3.48),('12664','2013-04-07','12:45:00',3.35),('12664','2013-04-07','12:50:00',3.09),('12664','2013-04-07','12:55:00',3.29),('12664','2013-04-07','13:00:00',3.57),('12664','2013-04-07','13:05:00',3.33),('12664','2013-04-07','13:10:00',3.1),('12664','2013-04-07','13:15:00',3.41),('12664','2013-04-07','13:20:00',3.43),('12664','2013-04-07','13:25:00',3.2),('12664','2013-04-07','13:30:00',2.8),('12664','2013-04-07','13:35:00',3.04),('12664','2013-04-07','13:40:00',3.34),('12664','2013-04-07','13:45:00',3.3),('12664','2013-04-07','13:50:00',3.22),('12664','2013-04-07','13:55:00',3.09),('12664','2013-04-07','14:00:00',2.77),('12664','2013-04-07','14:05:00',2.76),('12664','2013-04-07','14:10:00',2.76),('12664','2013-04-07','14:15:00',2.7),('12664','2013-04-07','14:20:00',2.66),('12664','2013-04-07','14:25:00',2.66),('12664','2013-04-07','14:30:00',2.84),('12664','2013-04-07','14:35:00',2.92),('12664','2013-04-07','14:40:00',2.77),('12664','2013-04-07','14:45:00',2.72),('12664','2013-04-07','14:50:00',2.62),('12664','2013-04-07','14:55:00',2.57),('12664','2013-04-07','15:00:00',2.55),('12664','2013-04-07','15:05:00',2.55),('12664','2013-04-07','15:10:00',2.59),('12664','2013-04-07','15:15:00',2.57),('12664','2013-04-07','15:20:00',2.55),('12664','2013-04-07','15:25:00',2.55),('12664','2013-04-07','15:30:00',2.59),('12664','2013-04-07','15:35:00',1.91),('12664','2013-04-07','15:40:00',2.19),('12664','2013-04-07','15:45:00',2.42),('12664','2013-04-07','15:50:00',2.18),('12664','2013-04-07','15:55:00',1.74),('12664','2013-04-07','16:00:00',1.48),('12664','2013-04-07','16:05:00',1.52),('12664','2013-04-07','16:10:00',1.59),('12664','2013-04-07','16:15:00',1.37),('12664','2013-04-07','16:20:00',1.85),('12664','2013-04-07','16:25:00',2.11),('12664','2013-04-07','16:30:00',2.12),('12664','2013-04-07','16:35:00',2.58),('12664','2013-04-07','16:40:00',1.4),('12664','2013-04-07','16:45:00',1.15),('12664','2013-04-07','16:50:00',1.02),('12664','2013-04-07','17:05:00',1.83),('12664','2013-04-07','17:10:00',2.6),('12664','2013-04-07','17:15:00',2.57),('12664','2013-04-07','17:20:00',2),('12664','2013-04-07','17:25:00',1.06),('12664','2013-04-07','17:35:00',1.15),('12664','2013-04-07','17:40:00',1.36),('12664','2013-04-07','17:45:00',1.36),('12664','2013-04-06','08:10:00',1.1),('12664','2013-04-06','08:15:00',1.11),('12664','2013-04-06','08:20:00',1.31),('12664','2013-04-06','08:25:00',1.42),('12664','2013-04-06','08:30:00',1.52),('12664','2013-04-06','08:35:00',1.61),('12664','2013-04-06','08:40:00',1.71),('12664','2013-04-06','08:45:00',1.83),('12664','2013-04-06','08:50:00',1.93),('12664','2013-04-06','08:55:00',2.04),('12664','2013-04-06','09:00:00',2.14),('12664','2013-04-06','09:05:00',2.23),('12664','2013-04-06','09:10:00',2.32),('12664','2013-04-06','09:15:00',2.4),('12664','2013-04-06','09:20:00',2.5),('12664','2013-04-06','09:25:00',2.55),('12664','2013-04-06','09:30:00',2.64),('12664','2013-04-06','09:35:00',2.74),('12664','2013-04-06','09:40:00',2.79),('12664','2013-04-06','09:45:00',2.88),('12664','2013-04-06','09:50:00',2.95),('12664','2013-04-06','09:55:00',3.05),('12664','2013-04-06','10:00:00',3.09),('12664','2013-04-06','10:05:00',3.18),('12664','2013-04-06','10:10:00',3.39),('12664','2013-04-06','10:15:00',3.39),('12664','2013-04-06','10:20:00',3.54),('12664','2013-04-06','10:25:00',3.55),('12664','2013-04-06','10:30:00',3.56),('12664','2013-04-06','10:35:00',3.61),('12664','2013-04-06','10:40:00',3.74),('12664','2013-04-06','10:45:00',3.77),('12664','2013-04-06','10:50:00',3.82),('12664','2013-04-06','10:55:00',3.86),('12664','2013-04-06','11:00:00',3.91),('12664','2013-04-06','11:05:00',3.88),('12664','2013-04-06','11:10:00',3.95),('12664','2013-04-06','11:15:00',3.98),('12664','2013-04-06','11:20:00',4.04),('12664','2013-04-06','11:25:00',4.16),('12664','2013-04-06','11:30:00',4.23),('12664','2013-04-06','11:35:00',4.39),('12664','2013-04-06','11:40:00',4.27),('12664','2013-04-06','11:45:00',4.39),('12664','2013-04-06','11:50:00',4.33),('12664','2013-04-06','11:55:00',4.33),('12664','2013-04-06','12:00:00',4.33),('12664','2013-04-06','12:05:00',4.32),('12664','2013-04-06','12:10:00',4.36),('12664','2013-04-06','12:15:00',4.41),('12664','2013-04-06','12:20:00',3.73),('12664','2013-04-06','12:25:00',4.24),('12664','2013-04-06','12:30:00',4.5),('12664','2013-04-06','12:35:00',4.49),('12664','2013-04-06','12:40:00',4.5),('12664','2013-04-06','12:45:00',4.58),('12664','2013-04-06','12:50:00',4.66),('12664','2013-04-06','12:55:00',4.25),('12664','2013-04-06','13:00:00',1.73),('12664','2013-04-06','13:05:00',3.38),('12664','2013-04-06','13:10:00',3.98),('12664','2013-04-06','13:15:00',4.95),('12664','2013-04-06','13:20:00',4.83),('12664','2013-04-06','13:25:00',4.69),('12664','2013-04-06','13:30:00',4.73),('12664','2013-04-06','13:35:00',4.58),('12664','2013-04-06','13:40:00',4.54),('12664','2013-04-06','13:45:00',4.58),('12664','2013-04-06','13:50:00',4.56),('12664','2013-04-06','13:55:00',4.51),('12664','2013-04-06','14:00:00',4.56),('12664','2013-04-06','14:05:00',4.47),('12664','2013-04-06','14:10:00',4.42),('12664','2013-04-06','14:15:00',4.35),('12664','2013-04-06','14:20:00',4.33),('12664','2013-04-06','14:25:00',4.26),('12664','2013-04-06','14:30:00',4.23),('12664','2013-04-06','14:35:00',4.18),('12664','2013-04-06','14:40:00',4.14),('12664','2013-04-06','14:45:00',4.11),('12664','2013-04-06','14:50:00',4.07),('12664','2013-04-06','14:55:00',4.04),('12664','2013-04-06','15:00:00',3.94),('12664','2013-04-06','15:05:00',3.95),('12664','2013-04-06','15:10:00',3.85),('12664','2013-04-06','15:15:00',3.78),('12664','2013-04-06','15:20:00',3.78),('12664','2013-04-06','15:25:00',3.72),('12664','2013-04-06','15:30:00',3.62),('12664','2013-04-06','15:35:00',3.46),('12664','2013-04-06','15:40:00',3.51),('12664','2013-04-06','15:45:00',3.54),('12664','2013-04-06','15:50:00',3.4),('12664','2013-04-06','15:55:00',3.38),('12664','2013-04-06','16:00:00',3.19),('12664','2013-04-06','16:05:00',2.35),('12664','2013-04-06','16:10:00',2.25),('12664','2013-04-06','16:15:00',2.68),('12664','2013-04-06','16:20:00',2.95),('12664','2013-04-06','16:25:00',2.03),('12664','2013-04-06','16:30:00',1.94),('12664','2013-04-06','16:35:00',2.91),('12664','2013-04-06','16:40:00',1.88),('12664','2013-04-06','16:45:00',1.88),('12664','2013-04-06','16:50:00',2.27),('12664','2013-04-06','16:55:00',2.13),('12664','2013-04-06','17:00:00',1.76),('12664','2013-04-06','17:05:00',1.92),('12664','2013-04-06','17:10:00',1.69),('12664','2013-04-06','17:15:00',1.42),('12664','2013-04-06','17:20:00',1.15),('12664','2013-04-06','17:25:00',1.13),('12664','2013-04-05','08:40:00',1.63),('12664','2013-04-05','08:45:00',1.44),('12664','2013-04-05','08:50:00',1.12),('12664','2013-04-05','08:55:00',1.39),('12664','2013-04-05','09:15:00',1.1),('12664','2013-04-05','09:20:00',1.05),('12664','2013-04-05','09:25:00',1.3),('12664','2013-04-05','09:30:00',1.96),('12664','2013-04-05','09:35:00',1.99),('12664','2013-04-05','09:40:00',2.19),('12664','2013-04-05','09:45:00',1.61),('12664','2013-04-05','09:50:00',1.17),('12664','2013-04-05','09:55:00',1.42),('12664','2013-04-05','10:00:00',1.4),('12664','2013-04-05','10:05:00',1.71),('12664','2013-04-05','10:10:00',2.31),('12664','2013-04-05','10:15:00',2.86),('12664','2013-04-05','10:20:00',3.22),('12664','2013-04-05','10:25:00',2.8),('12664','2013-04-05','10:30:00',2.88),('12664','2013-04-05','10:35:00',3.89),('12664','2013-04-05','10:40:00',4.17),('12664','2013-04-05','10:45:00',3.66),('12664','2013-04-05','10:50:00',2.93),('12664','2013-04-05','10:55:00',2.08),('12664','2013-04-05','11:00:00',2.8),('12664','2013-04-05','11:05:00',4.26),('12664','2013-04-05','11:10:00',4.01),('12664','2013-04-05','11:15:00',3.57),('12664','2013-04-05','11:20:00',3.94),('12664','2013-04-05','11:25:00',4.34),('12664','2013-04-05','11:30:00',4.45),('12664','2013-04-05','11:35:00',4.38),('12664','2013-04-05','11:40:00',4.61),('12664','2013-04-05','11:45:00',2.18),('12664','2013-04-05','11:50:00',4.72),('12664','2013-04-05','11:55:00',4.81),('12664','2013-04-05','12:00:00',4.13),('12664','2013-04-05','12:05:00',2.34),('12664','2013-04-05','12:10:00',1.98),('12664','2013-04-05','12:15:00',1.76),('12664','2013-04-05','12:20:00',1.35),('12664','2013-04-05','12:25:00',3.05),('12664','2013-04-05','12:30:00',4.67),('12664','2013-04-05','12:35:00',1.44),('12664','2013-04-05','12:40:00',1.53),('12664','2013-04-05','12:45:00',2.05),('12664','2013-04-05','12:50:00',3.4),('12664','2013-04-05','12:55:00',4.49),('12664','2013-04-05','13:00:00',4.64),('12664','2013-04-05','13:05:00',4.69),('12664','2013-04-05','13:10:00',4),('12664','2013-04-05','13:15:00',4.74),('12664','2013-04-05','13:20:00',3.92),('12664','2013-04-05','13:25:00',4.79),('12664','2013-04-05','13:30:00',4.98),('12664','2013-04-05','13:35:00',4.1),('12664','2013-04-05','13:40:00',3.96),('12664','2013-04-05','13:45:00',4.7),('12664','2013-04-05','13:50:00',4.71),('12664','2013-04-05','13:55:00',4.19),('12664','2013-04-05','14:00:00',2.76),('12664','2013-04-05','14:05:00',2.46),('12664','2013-04-05','14:10:00',3.24),('12664','2013-04-05','14:15:00',4.78),('12664','2013-04-05','14:20:00',4.37),('12664','2013-04-05','14:25:00',3.86),('12664','2013-04-05','14:30:00',4.31),('12664','2013-04-05','14:35:00',2.95),('12664','2013-04-05','14:40:00',2.77),('12664','2013-04-05','14:45:00',2.34),('12664','2013-04-05','14:50:00',2.56),('12664','2013-04-05','14:55:00',2.96),('12664','2013-04-05','15:00:00',2.52),('12664','2013-04-05','15:05:00',1.72),('12664','2013-04-05','15:10:00',1.55),('12664','2013-04-05','15:15:00',1.66),('12664','2013-04-05','15:20:00',1.6),('12664','2013-04-05','15:25:00',1.25),('12664','2013-04-05','15:30:00',1.01),('12664','2013-04-05','15:35:00',1.24),('12664','2013-04-05','15:40:00',1.09),('12664','2013-04-05','15:55:00',1.2),('12664','2013-04-05','16:00:00',2.37),('12664','2013-04-05','16:05:00',2.23),('12664','2013-04-05','16:10:00',1.68),('12664','2013-04-05','16:15:00',2.34),('12664','2013-04-05','16:20:00',1.51),('12664','2013-04-05','16:25:00',1.78),('12664','2013-04-05','16:30:00',2.22),('12664','2013-04-05','16:35:00',1.92),('12664','2013-04-05','16:40:00',1.95),('12664','2013-04-05','16:45:00',2.93),('12664','2013-04-05','16:50:00',3.57),('12664','2013-04-05','16:55:00',1.84),('12664','2013-04-05','17:00:00',1.27),('12664','2013-04-05','17:05:00',1.82),('12664','2013-04-05','17:10:00',1.03),('12664','2013-04-05','17:15:00',2.11),('12664','2013-04-05','17:20:00',1.31),('12664','2013-04-05','17:35:00',1.59),('12664','2013-04-05','17:40:00',1.07),('12664','2013-04-05','17:55:00',1.19),('12664','2013-04-04','08:50:00',1.15),('12664','2013-04-04','08:55:00',2.1),('12664','2013-04-04','09:00:00',1.23),('12664','2013-04-04','09:05:00',1.03),('12664','2013-04-04','09:10:00',1.12),('12664','2013-04-04','09:15:00',1.13),('12664','2013-04-04','09:20:00',1.04),('12664','2013-04-04','09:25:00',1.28),('12664','2013-04-04','09:30:00',2.53),('12664','2013-04-04','09:35:00',2.66),('12664','2013-04-04','09:40:00',1.87),('12664','2013-04-04','09:45:00',1.2),('12664','2013-04-04','09:50:00',1.21),('12664','2013-04-04','09:55:00',1.66),('12664','2013-04-04','10:00:00',2.48),('12664','2013-04-04','10:05:00',2.66),('12664','2013-04-04','10:10:00',1.81),('12664','2013-04-04','10:15:00',1.52),('12664','2013-04-04','10:20:00',2.21),('12664','2013-04-04','10:25:00',3.33),('12664','2013-04-04','10:30:00',3.32),('12664','2013-04-04','10:35:00',3.88),('12664','2013-04-04','10:40:00',2.31),('12664','2013-04-04','10:45:00',2.17),('12664','2013-04-04','10:50:00',2.71),('12664','2013-04-04','10:55:00',2.05),('12664','2013-04-04','11:00:00',1.26),('12664','2013-04-04','11:05:00',1.18),('12664','2013-04-04','11:10:00',1.59),('12664','2013-04-04','11:15:00',1.45),('12664','2013-04-04','11:20:00',1.22),('12664','2013-04-04','11:25:00',1.2),('12664','2013-04-04','11:30:00',1.45),('12664','2013-04-04','11:35:00',2.18),('12664','2013-04-04','11:40:00',2.55),('12664','2013-04-04','11:45:00',3.31),('12664','2013-04-04','11:50:00',3.99),('12664','2013-04-04','11:55:00',4.11),('12664','2013-04-04','12:00:00',4.04),('12664','2013-04-04','12:05:00',3.96),('12664','2013-04-04','12:10:00',3.01),('12664','2013-04-04','12:15:00',2.03),('12664','2013-04-04','12:20:00',2.06),('12664','2013-04-04','12:25:00',3.77),('12664','2013-04-04','12:30:00',4.69),('12664','2013-04-04','12:35:00',4.65),('12664','2013-04-04','12:40:00',4.61),('12664','2013-04-04','12:45:00',4.43),('12664','2013-04-04','12:50:00',3.56),('12664','2013-04-04','12:55:00',2.98),('12664','2013-04-04','13:00:00',3.22),('12664','2013-04-04','13:05:00',1.95),('12664','2013-04-04','13:10:00',2.05),('12664','2013-04-04','13:15:00',2.89),('12664','2013-04-04','13:20:00',2.89),('12664','2013-04-04','13:25:00',2.95),('12664','2013-04-04','13:30:00',3.2),('12664','2013-04-04','13:35:00',4.32),('12664','2013-04-04','13:40:00',3.88),('12664','2013-04-04','13:45:00',3.58),('12664','2013-04-04','13:50:00',2.89),('12664','2013-04-04','13:55:00',2.62),('12664','2013-04-04','14:00:00',3.12),('12664','2013-04-04','14:05:00',3.93),('12664','2013-04-04','14:10:00',4.34),('12664','2013-04-04','14:15:00',4.19),('12664','2013-04-04','14:20:00',4.15),('12664','2013-04-04','14:25:00',4.05),('12664','2013-04-04','14:30:00',3.75),('12664','2013-04-04','14:35:00',3.57),('12664','2013-04-04','14:40:00',3.96),('12664','2013-04-04','14:45:00',3.9),('12664','2013-04-04','14:50:00',3.88),('12664','2013-04-04','14:55:00',3.91),('12664','2013-04-04','15:00:00',3.71),('12664','2013-04-04','15:05:00',3.59),('12664','2013-04-04','15:10:00',3.6),('12664','2013-04-04','15:15:00',3.66),('12664','2013-04-04','15:20:00',3.34),('12664','2013-04-04','15:25:00',3.46),('12664','2013-04-04','15:30:00',3.46),('12664','2013-04-04','15:35:00',3.35),('12664','2013-04-04','15:40:00',3.32),('12664','2013-04-04','15:45:00',3.23),('12664','2013-04-04','15:50:00',3.16),('12664','2013-04-04','15:55:00',3.14),('12664','2013-04-04','16:00:00',2.9),('12664','2013-04-04','16:05:00',2.9),('12664','2013-04-04','16:10:00',2.83),('12664','2013-04-04','16:15:00',2.48),('12664','2013-04-04','16:20:00',1.83),('12664','2013-04-04','16:25:00',2.98),('12664','2013-04-04','16:30:00',2.51),('12664','2013-04-04','16:35:00',2.08),('12664','2013-04-04','16:40:00',2.32),('12664','2013-04-04','16:45:00',1.91),('12664','2013-04-04','16:50:00',2),('12664','2013-04-04','16:55:00',1.91),('12664','2013-04-04','17:00:00',1.69),('12664','2013-04-04','17:05:00',1.82),('12664','2013-04-04','17:10:00',1.46),('12664','2013-04-04','17:15:00',1.48),('12664','2013-04-04','17:20:00',1.23),('12664','2013-04-04','17:25:00',1.04),('12664','2013-04-04','17:50:00',1.14),('12664','2013-04-04','17:55:00',1.32),('12664','2013-04-04','18:00:00',1.17),('12664','2013-04-03','08:05:00',1.02),('12664','2013-04-03','08:25:00',1.11),('12664','2013-04-03','08:30:00',1.46),('12664','2013-04-03','08:35:00',1.54),('12664','2013-04-03','08:40:00',1.79),('12664','2013-04-03','08:45:00',1.88),('12664','2013-04-03','08:50:00',1.77),('12664','2013-04-03','08:55:00',2.14),('12664','2013-04-03','09:00:00',2.27),('12664','2013-04-03','09:05:00',2.32),('12664','2013-04-03','09:10:00',2.5),('12664','2013-04-03','09:15:00',2.38),('12664','2013-04-03','09:20:00',2.06),('12664','2013-04-03','09:25:00',2.75),('12664','2013-04-03','09:30:00',2.9),('12664','2013-04-03','09:35:00',2.94),('12664','2013-04-03','09:40:00',3.04),('12664','2013-04-03','09:47:00',3.15),('12664','2013-04-03','09:50:00',3.6),('12664','2013-04-03','09:55:00',1.49),('12664','2013-04-03','10:00:00',1.49),('12664','2013-04-03','10:05:00',3.54),('12664','2013-04-03','10:10:00',3.51),('12664','2013-04-03','10:15:00',2.25),('12664','2013-04-03','10:20:00',2.25),('12664','2013-04-03','10:25:00',2.87),('12664','2013-04-03','10:30:00',3.54),('12664','2013-04-03','10:35:00',1.49),('12664','2013-04-03','10:40:00',1.79),('12664','2013-04-03','10:45:00',2.53),('12664','2013-04-03','10:50:00',3.15),('12664','2013-04-03','10:55:00',2.38),('12664','2013-04-03','11:00:00',2.07),('12664','2013-04-03','11:05:00',2.83),('12664','2013-04-03','11:10:00',2.61),('12664','2013-04-03','11:15:00',2.47),('12664','2013-04-03','11:20:00',1.83),('12664','2013-04-03','11:25:00',3.05),('12664','2013-04-03','11:30:00',1.76),('12664','2013-04-03','11:35:00',1.75),('12664','2013-04-03','11:40:00',3.85),('12664','2013-04-03','11:45:00',3.63),('12664','2013-04-03','11:50:00',2.53),('12664','2013-04-03','11:55:00',3.77),('12664','2013-04-03','12:00:00',3.23),('12664','2013-04-03','12:05:00',5.02),('12664','2013-04-03','12:10:00',2.96),('12664','2013-04-03','12:15:00',3.82),('12664','2013-04-03','12:20:00',4.1),('12664','2013-04-03','12:25:00',4.24),('12664','2013-04-03','12:30:00',4.4),('12664','2013-04-03','12:35:00',2.79),('12664','2013-04-03','12:40:00',4.33),('12664','2013-04-03','12:45:00',2.65),('12664','2013-04-03','12:50:00',4.29),('12664','2013-04-03','12:55:00',4.8),('12664','2013-04-03','13:00:00',4.21),('12664','2013-04-03','13:05:00',4.08),('12664','2013-04-03','13:10:00',2.8),('12664','2013-04-03','13:15:00',3.43),('12664','2013-04-03','13:20:00',4.19),('12664','2013-04-03','13:25:00',4.77),('12664','2013-04-03','13:30:00',3.92),('12664','2013-04-03','13:35:00',4.23),('12664','2013-04-03','13:40:00',3.51),('12664','2013-04-03','13:45:00',3.86),('12664','2013-04-03','13:50:00',4.59),('12664','2013-04-03','13:55:00',5.01),('12664','2013-04-03','14:00:00',4.06),('12664','2013-04-03','14:05:00',4.38),('12664','2013-04-03','14:10:00',4.78),('12664','2013-04-03','14:15:00',3.28),('12664','2013-04-03','14:20:00',3.28),('12664','2013-04-03','14:25:00',4.23),('12664','2013-04-03','14:30:00',4.23),('12664','2013-04-03','14:35:00',4.49),('12664','2013-04-03','14:40:00',4.77),('12664','2013-04-03','14:45:00',4.75),('12664','2013-04-03','14:50:00',3.65),('12664','2013-04-03','14:55:00',4.56),('12664','2013-04-03','15:00:00',3.9),('12664','2013-04-03','15:05:00',4.62),('12664','2013-04-03','15:10:00',3.62),('12664','2013-04-03','15:15:00',4.62),('12664','2013-04-03','15:20:00',4.6),('12664','2013-04-03','15:25:00',4.36),('12664','2013-04-03','15:30:00',3.94),('12664','2013-04-03','15:35:00',4.2),('12664','2013-04-03','15:40:00',3.71),('12664','2013-04-03','15:45:00',3.86),('12664','2013-04-03','15:50:00',3.65),('12664','2013-04-03','15:55:00',3.7),('12664','2013-04-03','16:00:00',3.65),('12664','2013-04-03','16:05:00',3.53),('12664','2013-04-03','16:10:00',3.49),('12664','2013-04-03','16:15:00',3.41),('12664','2013-04-03','16:20:00',3.3),('12664','2013-04-03','16:25:00',3.21),('12664','2013-04-03','16:30:00',3.13),('12664','2013-04-03','16:35:00',3.05),('12664','2013-04-03','16:40:00',2.95),('12664','2013-04-03','16:45:00',2.85),('12664','2013-04-03','16:50:00',2.75),('12664','2013-04-03','16:55:00',2.66),('12664','2013-04-03','17:00:00',2.55),('12664','2013-04-03','17:05:00',2.46),('12664','2013-04-03','17:10:00',2.34),('12664','2013-04-03','17:15:00',2.23),('12664','2013-04-03','17:20:00',2.12),('12664','2013-04-03','17:25:00',2.01),('12664','2013-04-03','17:30:00',1.91),('12664','2013-04-03','17:35:00',1.78),('12664','2013-04-03','17:40:00',1.66),('12664','2013-04-03','17:45:00',1.49),('12664','2013-04-03','17:50:00',1.45),('12664','2013-04-03','17:55:00',1.35),('12664','2013-04-03','18:00:00',1.23),('12664','2013-04-03','18:05:00',1.12),('12664','2013-04-02','08:55:00',2.04),('12664','2013-04-02','09:00:00',2.2),('12664','2013-04-02','09:05:00',2.27),('12664','2013-04-02','09:10:00',2.48),('12664','2013-04-02','09:15:00',2.63),('12664','2013-04-02','09:20:00',1.89),('12664','2013-04-02','09:25:00',2.38),('12664','2013-04-02','09:30:00',2.22),('12664','2013-04-02','09:35:00',1.76),('12664','2013-04-02','09:55:00',2.8),('12664','2013-04-02','10:00:00',4.12),('12664','2013-04-02','10:05:00',3.78),('12664','2013-04-02','10:10:00',1.48),('12664','2013-04-02','10:20:00',2.3),('12664','2013-04-02','10:30:00',1.21),('12664','2013-04-02','10:40:00',1.5),('12664','2013-04-02','10:45:00',3.95),('12664','2013-04-02','10:50:00',4.59),('12664','2013-04-02','10:55:00',4.09),('12664','2013-04-02','11:00:00',4.67),('12664','2013-04-02','11:05:00',3.97),('12664','2013-04-02','11:10:00',3.51),('12664','2013-04-02','11:15:00',3.73),('12664','2013-04-02','11:20:00',1.53),('12664','2013-04-02','11:25:00',1.61),('12664','2013-04-02','11:30:00',4),('12664','2013-04-02','11:35:00',3.85),('12664','2013-04-02','11:40:00',4.31),('12664','2013-04-02','11:45:00',3.82),('12664','2013-04-02','11:50:00',3.42),('12664','2013-04-02','11:55:00',1.12),('12664','2013-04-02','12:00:00',1.56),('12664','2013-04-02','12:05:00',3.25),('12664','2013-04-02','12:10:00',1.91),('12664','2013-04-02','12:15:00',1.38),('12664','2013-04-02','12:20:00',1.18),('12664','2013-04-02','12:35:00',1.73),('12664','2013-04-02','12:40:00',1.35),('12664','2013-04-02','12:45:00',2.08),('12664','2013-04-02','12:50:00',1.74),('12664','2013-04-02','12:55:00',1.38),('12664','2013-04-02','13:00:00',1.39),('12664','2013-04-02','13:05:00',1.25),('12664','2013-04-02','13:10:00',1.29),('12664','2013-04-02','13:15:00',1.35),('12664','2013-04-02','13:20:00',1.41),('12664','2013-04-02','13:25:00',1.63),('12664','2013-04-02','13:30:00',1.41),('12664','2013-04-02','13:35:00',1.4),('12664','2013-04-02','13:45:00',1.46),('12664','2013-04-02','13:50:00',4.05),('12664','2013-04-02','13:55:00',2.93),('12664','2013-04-02','14:00:00',4.21),('12664','2013-04-02','14:05:00',3.97),('12664','2013-04-02','14:10:00',3.8),('12664','2013-04-02','14:15:00',1.01),('12664','2013-04-02','14:20:00',3.28),('12664','2013-04-02','14:25:00',4.08),('12664','2013-04-02','14:30:00',2.94),('12664','2013-04-02','14:45:00',1.01),('12664','2013-04-02','14:50:00',1.2),('12664','2013-04-02','14:55:00',1.08),('12664','2013-04-02','15:00:00',1.14),('12664','2013-04-02','15:15:00',1.37),('12664','2013-04-02','15:40:00',1.03),('12664','2013-04-02','15:50:00',1.15),('12664','2013-04-02','15:55:00',1.37),('12664','2013-04-02','16:00:00',1.37),('12664','2013-04-02','16:05:00',1.32),('12664','2013-04-02','16:10:00',1.03),('12664','2013-04-02','16:30:00',1.1),('12664','2013-04-01','08:10:00',1.01),('12664','2013-04-01','08:15:00',1.14),('12664','2013-04-01','08:20:00',1.36),('12664','2013-04-01','08:25:00',1.67),('12664','2013-04-01','08:30:00',1.59),('12664','2013-04-01','08:40:00',1.61),('12664','2013-04-01','08:45:00',1.54),('12664','2013-04-01','08:50:00',1.55),('12664','2013-04-01','08:55:00',2.07),('12664','2013-04-01','09:00:00',2.2),('12664','2013-04-01','09:05:00',2.33),('12664','2013-04-01','09:10:00',2.46),('12664','2013-04-01','09:15:00',2.38),('12664','2013-04-01','09:20:00',2.3),('12664','2013-04-01','09:25:00',1.06),('12664','2013-04-01','09:30:00',1.24),('12664','2013-04-01','09:35:00',2.01),('12664','2013-04-01','09:40:00',2.78),('12664','2013-04-01','09:45:00',2.11),('12664','2013-04-01','09:50:00',1.44),('12664','2013-04-01','09:55:00',3.02),('12664','2013-04-01','10:00:00',3.13),('12664','2013-04-01','10:05:00',3.83),('12664','2013-04-01','10:10:00',1.98),('12664','2013-04-01','10:15:00',2.74),('12664','2013-04-01','10:20:00',3.4),('12664','2013-04-01','10:25:00',3.65),('12664','2013-04-01','10:30:00',1.93),('12664','2013-04-01','10:35:00',1.75),('12664','2013-04-01','10:40:00',2.72),('12664','2013-04-01','10:45:00',1.55),('12664','2013-04-01','10:50:00',1.79),('12664','2013-04-01','10:55:00',3.61),('12664','2013-04-01','11:00:00',3.17),('12664','2013-04-01','11:05:00',3.8),('12664','2013-04-01','11:10:00',3.06),('12664','2013-04-01','11:15:00',2.92),('12664','2013-04-01','11:20:00',3.12),('12664','2013-04-01','11:25:00',3.3),('12664','2013-04-01','11:30:00',2.29),('12664','2013-04-01','11:35:00',2.23),('12664','2013-04-01','11:40:00',2.34),('12664','2013-04-01','11:45:00',2.08),('12664','2013-04-01','11:50:00',2.31),('12664','2013-04-01','11:55:00',2.28),('12664','2013-04-01','12:00:00',1.9),('12664','2013-04-01','12:05:00',2.09),('12664','2013-04-01','12:10:00',2.66),('12664','2013-04-01','12:15:00',2.25),('12664','2013-04-01','12:20:00',2.26),('12664','2013-04-01','12:25:00',2.59),('12664','2013-04-01','12:30:00',2.57),('12664','2013-04-01','12:35:00',2.39),('12664','2013-04-01','12:40:00',2.72),('12664','2013-04-01','12:45:00',2.71),('12664','2013-04-01','12:50:00',3.09),('12664','2013-04-01','12:55:00',2.96),('12664','2013-04-01','13:00:00',2.77),('12664','2013-04-01','13:05:00',2.8),('12664','2013-04-01','13:10:00',3.16),('12664','2013-04-01','13:15:00',2.98),('12664','2013-04-01','13:20:00',2.89),('12664','2013-04-01','13:25:00',2.35),('12664','2013-04-01','13:30:00',2.25),('12664','2013-04-01','13:35:00',2.41),('12664','2013-04-01','13:40:00',2.83),('12664','2013-04-01','13:45:00',3.16),('12664','2013-04-01','13:50:00',3.54),('12664','2013-04-01','13:55:00',3.44),('12664','2013-04-01','14:00:00',2.15),('12664','2013-04-01','14:05:00',1.97),('12664','2013-04-01','14:10:00',2.1),('12664','2013-04-01','14:15:00',2.72),('12664','2013-04-01','14:20:00',3.58),('12664','2013-04-01','14:25:00',3.77),('12664','2013-04-01','14:30:00',4.31),('12664','2013-04-01','14:35:00',3.45),('12664','2013-04-01','14:40:00',2.99),('12664','2013-04-01','14:45:00',2.95),('12664','2013-04-01','14:50:00',2.67),('12664','2013-04-01','14:55:00',2.09),('12664','2013-04-01','15:00:00',1.93),('12664','2013-04-01','15:05:00',1.93),('12664','2013-04-01','15:10:00',2.24),('12664','2013-04-01','15:15:00',2.21),('12664','2013-04-01','15:20:00',2.45),('12664','2013-04-01','15:25:00',2.74),('12664','2013-04-01','15:30:00',2.45),('12664','2013-04-01','15:35:00',2.49),('12664','2013-04-01','15:40:00',1.98),('12664','2013-04-01','15:45:00',2.8),('12664','2013-04-01','15:50:00',3.13),('12664','2013-04-01','15:55:00',2.51),('12664','2013-04-01','16:00:00',2.09),('12664','2013-04-01','16:05:00',1.68),('12664','2013-04-01','16:10:00',1.28),('12664','2014-05-01','07:50:00',1.06),('12664','2014-05-01','07:55:00',1.04),('12664','2014-05-01','08:05:00',1.28),('12664','2014-05-01','08:10:00',1.38),('12664','2014-05-01','08:15:00',1.47),('12664','2014-05-01','08:20:00',1.57),('12664','2014-05-01','08:25:00',1.66),('12664','2014-05-01','08:30:00',1.75),('12664','2014-05-01','08:35:00',1.72),('12664','2014-05-01','08:45:00',1.09),('12664','2014-05-01','08:50:00',1.32),('12664','2014-05-01','08:55:00',1.57),('12664','2014-05-01','09:00:00',2.97),('12664','2014-05-01','09:05:00',1.55),('12664','2014-05-01','09:10:00',1.64),('12664','2014-05-01','09:15:00',2.13),('12664','2014-05-01','09:20:00',2.79),('12664','2014-05-01','09:25:00',3.23),('12664','2014-05-01','09:30:00',2.44),('12664','2014-05-01','09:35:00',1.37),('12664','2014-05-01','09:55:00',1.38),('12664','2014-05-01','10:00:00',1.95),('12664','2014-05-01','10:05:00',1.74),('12664','2014-05-01','10:10:00',3.2),('12664','2014-05-01','10:15:00',1.91),('12664','2014-05-01','10:20:00',1.98),('12664','2014-05-01','10:25:00',3.45),('12664','2014-05-01','10:30:00',2.61),('12664','2014-05-01','10:35:00',3.94),('12664','2014-05-01','10:40:00',3.96),('12664','2014-05-01','10:45:00',4.03),('12664','2014-05-01','10:50:00',4.08),('12664','2014-05-01','10:55:00',1.94),('12664','2014-05-01','11:00:00',4.24),('12664','2014-05-01','11:05:00',2.95),('12664','2014-05-01','11:10:00',4.13),('12664','2014-05-01','11:15:00',4.43),('12664','2014-05-01','11:20:00',2.43),('12664','2014-05-01','11:25:00',2.2),('12664','2014-05-01','11:30:00',2.1),('12664','2014-05-01','11:35:00',3.25),('12664','2014-05-01','11:40:00',4.38),('12664','2014-05-01','11:45:00',4.42),('12664','2014-05-01','11:50:00',4.33),('12664','2014-05-01','11:55:00',4.45),('12664','2014-05-01','12:00:00',1.61),('12664','2014-05-01','12:05:00',2.43),('12664','2014-05-01','12:10:00',4.51),('12664','2014-05-01','12:15:00',4.64),('12664','2014-05-01','12:20:00',3.6),('12664','2014-05-01','12:25:00',2.61),('12664','2014-05-01','12:30:00',4.86),('12664','2014-05-01','12:35:00',3.36),('12664','2014-05-01','12:40:00',2.73),('12664','2014-05-01','12:45:00',1.17),('12664','2014-05-01','12:50:00',1.3),('12664','2014-05-01','12:55:00',2.61),('12664','2014-05-01','13:00:00',3.59),('12664','2014-05-01','13:10:00',4.51),('12664','2014-05-01','13:15:00',4.31),('12664','2014-05-01','13:20:00',4.66),('12664','2014-05-01','13:25:00',4.75),('12664','2014-05-01','13:30:00',4.69),('12664','2014-05-01','13:35:00',4.71),('12664','2014-05-01','13:40:00',4.71),('12664','2014-05-01','13:45:00',4.51),('12664','2014-05-01','13:50:00',4.19),('12664','2014-05-01','13:55:00',3.87),('12664','2014-05-01','14:00:00',4.25),('12664','2014-05-01','14:05:00',4.2),('12664','2014-05-01','14:10:00',4.19),('12664','2014-05-01','14:15:00',4.14),('12664','2014-05-01','14:20:00',4.11),('12664','2014-05-01','14:25:00',4.09),('12664','2014-05-01','14:30:00',4.06),('12664','2014-05-01','14:35:00',4.09),('12664','2014-05-01','14:40:00',4.06),('12664','2014-05-01','14:45:00',4.09),('12664','2014-05-01','14:50:00',3.88),('12664','2014-05-01','14:55:00',3.89),('12664','2014-05-01','15:00:00',3.92),('12664','2014-05-01','15:05:00',3.9),('12664','2014-05-01','15:10:00',3.59),('12664','2014-05-01','15:15:00',3.73),('12664','2014-05-01','15:20:00',3.72),('12664','2014-05-01','15:25:00',3.69),('12664','2014-05-01','15:30:00',3.65),('12664','2014-05-01','15:35:00',3.57),('12664','2014-05-01','15:40:00',3.52),('12664','2014-05-01','15:45:00',3.45),('12664','2014-05-01','15:50:00',3.36),('12664','2014-05-01','15:55:00',3.18),('12664','2014-05-01','16:00:00',3.28),('12664','2014-05-01','16:05:00',3.24),('12664','2014-05-01','16:10:00',3.18),('12664','2014-05-01','16:15:00',3.01),('12664','2014-05-01','16:20:00',2.77),('12664','2014-05-01','16:25:00',2.84),('12664','2014-05-01','16:30:00',2.74),('12664','2014-05-01','16:35:00',2.63),('12664','2014-05-01','16:40:00',2.38),('12664','2014-05-01','16:45:00',2.39),('12664','2014-05-01','16:50:00',2.59),('12664','2014-05-01','16:55:00',2.36),('12664','2014-05-01','17:00:00',2.36),('12664','2014-05-01','17:05:00',2.32),('12664','2014-05-01','17:10:00',2.22),('12664','2014-05-01','17:15:00',1.71),('12664','2014-05-01','17:20:00',2.05),('12664','2014-05-01','17:25:00',1.99),('12664','2014-05-01','17:30:00',1.64),('12664','2014-05-01','17:35:00',1.31),('12664','2014-05-01','17:40:00',1.73),('12664','2014-05-01','17:45:00',1.31),('12664','2014-05-01','17:50:00',1.4),('12664','2014-05-01','17:55:00',1.14),('12664','2014-05-01','18:05:00',1.21),('12664','2014-03-26','07:25:00',1.3),('12664','2014-03-26','07:55:00',1.3),('12664','2014-03-26','08:00:00',1.88),('12664','2014-03-26','08:05:00',1.9),('12664','2014-03-26','08:10:00',1.94),('12664','2014-03-26','08:15:00',2.35),('12664','2014-03-26','08:20:00',1.66),('12664','2014-03-26','08:25:00',1.05),('12664','2014-03-26','08:45:00',1.05),('12664','2014-03-26','08:50:00',1.07),('12664','2014-03-26','08:55:00',1.14),('12664','2014-03-26','09:00:00',1.27),('12664','2014-03-26','09:05:00',1.53),('12664','2014-03-26','09:10:00',1.72),('12664','2014-03-26','09:15:00',1.16),('12664','2014-03-26','09:20:00',1.54),('12664','2014-03-26','09:25:00',3.39),('12664','2014-03-26','09:30:00',3.21),('12664','2014-03-26','09:35:00',3.22),('12664','2014-03-26','09:40:00',3.37),('12664','2014-03-26','09:45:00',3.44),('12664','2014-03-26','09:50:00',3.4),('12664','2014-03-26','09:55:00',3.44),('12664','2014-03-26','10:00:00',2.62),('12664','2014-03-26','10:05:00',3.69),('12664','2014-03-26','10:10:00',3.65),('12664','2014-03-26','10:15:00',3.69),('12664','2014-03-26','10:20:00',3.64),('12664','2014-03-26','10:25:00',3.8),('12664','2014-03-26','10:30:00',3.77),('12664','2014-03-26','10:40:00',1.67),('12664','2014-03-26','10:45:00',2.37),('12664','2014-03-26','10:50:00',1.18),('12664','2014-03-26','10:55:00',1.17),('12664','2014-03-26','11:00:00',1.63),('12664','2014-03-26','11:15:00',1.29),('12664','2014-03-26','11:20:00',2.2),('12664','2014-03-26','11:25:00',2.6),('12664','2014-03-26','11:30:00',1.34),('12664','2014-03-26','11:55:00',1.83),('12664','2014-03-26','12:00:00',2.16),('12664','2014-03-26','12:05:00',2.37),('12664','2014-03-26','12:10:00',1.54),('12664','2014-03-26','12:20:00',1.02),('12664','2014-03-26','12:25:00',1.26),('12664','2014-03-26','12:30:00',2.21),('12664','2014-03-26','12:35:00',2.27),('12664','2014-03-26','12:40:00',3.56),('12664','2014-03-26','12:45:00',3.77),('12664','2014-03-26','12:50:00',4.76),('12664','2014-03-26','12:55:00',3.8),('12664','2014-03-26','13:00:00',4.45),('12664','2014-03-26','13:05:00',3.91),('12664','2014-03-26','13:10:00',4.63),('12664','2014-03-26','13:15:00',4.53),('12664','2014-03-26','13:20:00',4.19),('12664','2014-03-26','13:25:00',1.91),('12664','2014-03-26','13:35:00',1.1),('12664','2014-03-26','13:40:00',2.53),('12664','2014-03-26','13:45:00',1.25),('12664','2014-03-26','13:50:00',3.01),('12664','2014-03-26','13:55:00',4.16),('12664','2014-03-26','14:00:00',3.52),('12664','2014-03-26','14:05:00',3.78),('12664','2014-03-26','14:10:00',4.1),('12664','2014-03-26','14:15:00',3.8),('12664','2014-03-26','14:20:00',2.66),('12664','2014-03-26','15:00:00',1.03),('12664','2014-03-26','15:05:00',2.58),('12664','2014-03-26','15:10:00',2.85),('12664','2014-03-26','15:15:00',2.69),('12664','2014-03-26','15:20:00',2.76),('12664','2014-03-26','15:25:00',2.57),('12664','2014-03-26','15:30:00',2.08),('12664','2014-03-26','15:35:00',1.5),('12664','2014-03-26','15:40:00',2.51),('12664','2014-03-26','15:45:00',2.03),('12664','2014-03-26','15:50:00',2.07),('12664','2014-03-26','16:20:00',1.8),('12664','2014-03-26','16:25:00',1.71),('12664','2014-03-26','16:30:00',1.35),('12664','2013-03-31','08:15:00',1.01),('12664','2013-03-31','08:50:00',1.02),('12664','2013-03-31','09:00:00',1.11),('12664','2013-03-31','09:05:00',1.09),('12664','2013-03-31','09:10:00',1.89),('12664','2013-03-31','09:20:00',1.15),('12664','2013-03-31','09:25:00',1.14),('12664','2013-03-31','09:45:00',2.99),('12664','2013-03-31','10:05:00',1.03),('12664','2013-03-31','10:10:00',1.9),('12664','2013-03-31','10:15:00',1.85),('12664','2013-03-31','10:20:00',1.79),('12664','2013-03-31','10:25:00',1.84),('12664','2013-03-31','10:30:00',1.59),('12664','2013-03-31','10:35:00',1.45),('12664','2013-03-31','10:40:00',1.26),('12664','2013-03-31','10:50:00',2.79),('12664','2013-03-31','10:55:00',2.02),('12664','2013-03-31','11:00:00',4.71),('12664','2013-03-31','11:05:00',2.13),('12664','2013-03-31','11:10:00',1.43),('12664','2013-03-31','11:15:00',1.26),('12664','2013-03-31','11:20:00',1.8),('12664','2013-03-31','11:25:00',2.41),('12664','2013-03-31','11:30:00',2.17),('12664','2013-03-31','11:35:00',3.16),('12664','2013-03-31','11:40:00',2.86),('12664','2013-03-31','11:45:00',1.72),('12664','2013-03-31','11:50:00',1.52),('12664','2013-03-31','11:55:00',1.8),('12664','2013-03-31','12:25:00',1.05),('12664','2013-03-31','12:30:00',1.33),('12664','2013-03-31','12:35:00',3.13),('12664','2013-03-31','12:40:00',2.75),('12664','2013-03-31','12:45:00',2.2),('12664','2013-03-31','12:50:00',1.41),('12664','2013-03-31','12:55:00',2.77),('12664','2013-03-31','13:00:00',2.46),('12664','2013-03-31','13:05:00',1.94),('12664','2013-03-31','13:10:00',2.38),('12664','2013-03-31','13:15:00',4.11),('12664','2013-03-31','13:20:00',3.22),('12664','2013-03-31','13:25:00',3.11),('12664','2013-03-31','13:30:00',2.37),('12664','2013-03-31','13:35:00',1.96),('12664','2013-03-31','13:40:00',3.09),('12664','2013-03-31','13:45:00',2.69),('12664','2013-03-31','13:50:00',2.99),('12664','2013-03-31','13:55:00',3.51),('12664','2013-03-31','14:00:00',3.2),('12664','2013-03-31','14:05:00',4.28),('12664','2013-03-31','14:10:00',4.48),('12664','2013-03-31','14:15:00',4.79),('12664','2013-03-31','14:20:00',3.26),('12664','2013-03-31','14:25:00',4.51),('12664','2013-03-31','14:30:00',3.34),('12664','2013-03-31','14:35:00',3.56),('12664','2013-03-31','14:40:00',4.1),('12664','2013-03-31','14:45:00',5.02),('12664','2013-03-31','14:50:00',4.63),('12664','2013-03-31','14:55:00',2.77),('12664','2013-03-31','15:00:00',4.53),('12664','2013-03-31','15:05:00',4.05),('12664','2013-03-31','15:10:00',3.83),('12664','2013-03-31','15:15:00',4.55),('12664','2013-03-31','15:20:00',4.45),('12664','2013-03-31','15:25:00',4.38),('12664','2013-03-31','15:30:00',3.83),('12664','2013-03-31','15:35:00',2.36),('12664','2013-03-31','15:40:00',2.74),('12664','2013-03-31','15:45:00',3.25),('12664','2013-03-31','16:20:00',1.14),('12664','2013-03-31','16:30:00',1.31),('12664','2013-03-31','16:35:00',1.18),('12664','2013-03-31','16:40:00',1.03),('12664','2013-03-31','16:50:00',1.07),('12664','2013-03-31','16:55:00',1.09),('12664','2013-03-31','17:00:00',1.56),('12664','2013-03-31','17:05:00',1.01),('12664','2013-03-31','17:30:00',1.12),('12664','2013-03-31','17:40:00',1.31),('12664','2013-03-31','17:45:00',1.82),('12664','2013-03-31','17:50:00',1.6),('12664','2013-03-31','18:10:00',1.31),('12664','2013-03-31','18:15:00',1.05),('12664','2013-03-30','09:20:00',1.09),('12664','2013-03-30','09:25:00',1.32),('12664','2013-03-30','09:30:00',1.38),('12664','2013-03-30','09:35:00',1.15),('12664','2013-03-30','09:40:00',1.3),('12664','2013-03-30','09:45:00',1.3),('12664','2013-03-30','09:50:00',1.54),('12664','2013-03-30','09:55:00',2.11),('12664','2013-03-30','10:00:00',2.5),('12664','2013-03-30','10:05:00',2.01),('12664','2013-03-30','10:10:00',1.61),('12664','2013-03-30','10:15:00',1.55),('12664','2013-03-30','10:20:00',1.6),('12664','2013-03-30','10:25:00',1.79),('12664','2013-03-30','10:30:00',2.11),('12664','2013-03-30','10:35:00',2.18),('12664','2013-03-30','10:40:00',1.94),('12664','2013-03-30','10:45:00',1.94),('12664','2013-03-30','10:50:00',2.2),('12664','2013-03-30','10:55:00',2.67),('12664','2013-03-30','11:00:00',2.7),('12664','2013-03-30','11:05:00',2.91),('12664','2013-03-30','11:10:00',2.66),('12664','2013-03-30','11:15:00',2.99),('12664','2013-03-30','11:20:00',2.41),('12664','2013-03-30','11:25:00',2.31),('12664','2013-03-30','11:30:00',3.97),('12664','2013-03-30','11:35:00',3.27),('12664','2013-03-30','11:40:00',3.42),('12664','2013-03-30','11:45:00',3.18),('12664','2013-03-30','11:50:00',2.35),('12664','2013-03-30','11:55:00',3.04),('12664','2013-03-30','12:00:00',2.59),('12664','2013-03-30','12:05:00',1.8),('12664','2013-03-30','12:10:00',1.13),('12664','2013-03-30','12:20:00',1.02),('12664','2013-03-30','12:30:00',1.06),('12664','2013-03-30','12:50:00',1.11),('12664','2013-03-30','12:55:00',1.58),('12664','2013-03-30','13:00:00',2.62),('12664','2013-03-30','13:05:00',2.16),('12664','2013-03-30','13:10:00',2.89),('12664','2013-03-30','13:15:00',1.3),('12664','2013-03-30','13:20:00',1.68),('12664','2013-03-30','13:40:00',1.04),('12664','2013-03-30','13:45:00',1.96),('12664','2013-03-30','13:50:00',2.51),('12664','2013-03-30','13:55:00',2.2),('12664','2013-03-30','14:00:00',2.76),('12664','2013-03-30','14:05:00',1.81),('12664','2013-03-30','14:10:00',1.61),('12664','2013-03-30','14:15:00',2.03),('12664','2013-03-30','14:20:00',3.08),('12664','2013-03-30','14:25:00',1.63),('12664','2013-03-30','14:30:00',1.15),('12664','2013-03-30','14:35:00',1.33),('12664','2013-03-30','14:40:00',1.05),('12664','2013-03-30','14:45:00',1.35),('12664','2013-03-29','07:10:00',1.09),('12664','2013-03-29','07:15:00',1.18),('12664','2013-03-29','07:30:00',1.16),('12664','2013-03-29','07:35:00',1.12),('12664','2013-03-29','07:40:00',1.1),('12664','2013-03-29','07:45:00',1.73),('12664','2013-03-29','07:50:00',1.86),('12664','2013-03-29','07:55:00',1.91),('12664','2013-03-29','08:00:00',2.09),('12664','2013-03-29','08:05:00',1.96),('12664','2013-03-29','08:10:00',1.87),('12664','2013-03-29','08:16:00',2.54),('12664','2013-03-29','08:20:00',2.33),('12664','2013-03-29','08:25:00',2.53),('12664','2013-03-29','08:30:00',2.64),('12664','2013-03-29','08:35:00',2.72),('12664','2013-03-29','08:40:00',2.62),('12664','2013-03-29','08:45:00',2.59),('12664','2013-03-29','08:50:00',2.39),('12664','2013-03-29','08:55:00',2.93),('12664','2013-03-29','09:00:00',2.79),('12664','2013-03-29','09:05:00',3.06),('12664','2013-03-29','09:10:00',3.34),('12664','2013-03-29','09:15:00',3.46),('12664','2013-03-29','09:20:00',3.19),('12664','2013-03-29','09:25:00',3.62),('12664','2013-03-29','09:30:00',3.61),('12664','2013-03-29','09:35:00',3.36),('12664','2013-03-29','09:40:00',3.32),('12664','2013-03-29','09:45:00',3.66),('12664','2013-03-29','09:50:00',3.62),('12664','2013-03-29','09:55:00',3.5),('12664','2013-03-29','10:00:00',3.32),('12664','2013-03-29','10:05:00',3.18),('12664','2013-03-29','10:10:00',3.47),('12664','2013-03-29','10:15:00',3.32),('12664','2013-03-29','10:20:00',3.07),('12664','2013-03-29','10:25:00',3.58),('12664','2013-03-29','10:30:00',3.11),('12664','2013-03-29','10:35:00',3.58),('12664','2013-03-29','10:40:00',3.5),('12664','2013-03-29','10:45:00',3.73),('12664','2013-03-29','10:50:00',4.18),('12664','2013-03-29','10:55:00',4.14),('12664','2013-03-29','11:00:00',4.23),('12664','2013-03-29','11:05:00',3.7),('12664','2013-03-29','11:10:00',1.12),('12664','2013-03-29','11:15:00',2.28),('12664','2013-03-29','11:20:00',4.96),('12664','2013-03-29','11:25:00',4.69),('12664','2013-03-29','11:30:00',4.55),('12664','2013-03-29','11:35:00',4.66),('12664','2013-03-29','11:40:00',4.68),('12664','2013-03-29','11:45:00',4.68),('12664','2013-03-29','11:50:00',4.66),('12664','2013-03-29','11:55:00',4.65),('12664','2013-03-29','12:00:00',4.72),('12664','2013-03-29','12:05:00',4.72),('12664','2013-03-29','12:10:00',4.49),('12664','2013-03-29','12:15:00',4.61),('12664','2013-03-29','12:20:00',4.44),('12664','2013-03-29','12:25:00',4.79),('12664','2013-03-29','12:30:00',4.66),('12664','2013-03-29','12:35:00',3.26),('12664','2013-03-29','12:40:00',4.98),('12664','2013-03-29','12:45:00',4.6),('12664','2013-03-29','12:50:00',3.27),('12664','2013-03-29','12:55:00',4.63),('12664','2013-03-29','13:00:00',4.6),('12664','2013-03-29','13:05:00',4.42),('12664','2013-03-29','13:10:00',3.57),('12664','2013-03-29','13:15:00',4.58),('12664','2013-03-29','13:20:00',4.72),('12664','2013-03-29','13:25:00',3.64),('12664','2013-03-29','13:30:00',3.89),('12664','2013-03-29','13:35:00',3.54),('12664','2013-03-29','13:40:00',4.01),('12664','2013-03-29','13:45:00',3.91),('12664','2013-03-29','13:50:00',3.95),('12664','2013-03-29','13:55:00',3.96),('12664','2013-03-29','14:00:00',3.24),('12664','2013-03-29','14:05:00',2.61),('12664','2013-03-29','14:10:00',2.54),('12664','2013-03-29','14:15:00',2.43),('12664','2013-03-29','14:20:00',2.56),('12664','2013-03-29','14:25:00',2.24),('12664','2013-03-29','14:30:00',2.03),('12664','2013-03-29','14:35:00',2.16),('12664','2013-03-29','14:40:00',1.92),('12664','2013-03-29','14:45:00',1.92),('12664','2013-03-29','14:50:00',1.84),('12664','2013-03-29','14:55:00',1.68),('12664','2013-03-29','15:00:00',1.65),('12664','2013-03-29','15:05:00',1.62),('12664','2013-03-29','15:10:00',1.55),('12664','2013-03-29','15:15:00',1.46),('12664','2013-03-29','15:20:00',1.31),('12664','2013-03-29','15:25:00',1.22),('12664','2013-03-29','15:30:00',1.16),('12664','2013-03-29','15:35:00',1.1),('12664','2013-03-29','15:40:00',1.1),('12664','2013-03-29','15:45:00',1.2),('12664','2013-03-29','15:50:00',1.39),('12664','2013-03-29','15:55:00',1.39),('12664','2013-03-29','16:00:00',1.36),('12664','2013-03-29','16:05:00',1.21),('12664','2013-03-29','16:10:00',1.07),('12664','2013-03-29','16:20:00',1.24),('12664','2013-03-29','16:25:00',1.35),('12664','2013-03-29','16:30:00',1.09),('12664','2013-03-29','16:35:00',2.2),('12664','2013-03-29','16:40:00',1.77),('12664','2013-03-29','16:45:00',1.39),('12664','2013-03-29','16:50:00',1.07),('12664','2013-03-29','16:55:00',1.28),('12664','2013-03-29','17:00:00',1.44),('12664','2013-03-29','17:20:00',1.05),('12664','2013-03-28','09:10:00',1.21),('12664','2013-03-28','09:15:00',1.4),('12664','2013-03-28','09:20:00',1.97),('12664','2013-03-28','09:25:00',1.86),('12664','2013-03-28','09:30:00',1.06),('12664','2013-03-28','12:45:00',1.65),('12664','2013-03-28','12:50:00',2.48),('12664','2013-03-28','12:55:00',1.57),('12664','2013-03-28','13:00:00',1.06),('12664','2013-03-28','13:10:00',1.04),('12664','2013-03-28','13:15:00',1.14),('12664','2013-03-28','13:20:00',1.18),('12664','2013-03-28','13:25:00',1.64),('12664','2013-03-28','13:30:00',1.58),('12664','2013-03-28','13:35:00',1.29),('12664','2013-03-28','13:40:00',1.38),('12664','2013-03-28','13:45:00',1.04),('12664','2013-03-28','14:00:00',1.87),('12664','2013-03-28','14:05:00',1.9),('12664','2013-03-28','14:10:00',1.83),('12664','2013-03-28','14:15:00',2.21),('12664','2013-03-28','14:20:00',1.5),('12664','2013-03-28','14:25:00',1.54),('12664','2013-03-28','14:30:00',1.99),('12664','2013-03-28','14:35:00',1.69),('12664','2013-03-28','14:40:00',1.24),('12664','2013-03-28','14:45:00',1),('12664','2013-03-28','15:05:00',1.05),('12664','2013-03-28','15:10:00',1.55),('12664','2013-03-28','15:15:00',2.14),('12664','2013-03-28','15:20:00',2.86),('12664','2013-03-28','15:25:00',1.42),('12664','2013-03-28','15:30:00',1.18),('12664','2013-03-28','15:40:00',1.41),('12664','2013-03-28','15:45:00',2.03),('12664','2013-03-28','15:50:00',1.84),('12664','2013-03-28','15:55:00',1.58),('12664','2013-03-28','16:00:00',1),('12664','2013-03-28','16:05:00',1.16),('12664','2013-03-28','16:10:00',1.37),('12664','2013-03-28','16:30:00',1.06),('12664','2013-03-28','16:35:00',1.57),('12664','2013-03-28','16:40:00',2),('12664','2013-03-28','16:45:00',1.32),('12664','2013-03-28','17:00:00',1.25),('12664','2013-03-28','17:05:00',1.39),('12664','2013-03-28','17:10:00',1.14),('12664','2013-03-27','07:10:00',1.01),('12664','2013-03-27','07:20:00',1.15),('12664','2013-03-27','07:25:00',1.35),('12664','2013-03-27','07:30:00',1.36),('12664','2013-03-27','07:35:00',1.46),('12664','2013-03-27','07:40:00',1.38),('12664','2013-03-27','08:05:00',1.08),('12664','2013-03-27','08:10:00',1.34),('12664','2013-03-27','08:15:00',1.25),('12664','2013-03-27','08:20:00',1.15),('12664','2013-03-27','08:25:00',1.9),('12664','2013-03-27','08:30:00',2.32),('12664','2013-03-27','08:35:00',2.89),('12664','2013-03-27','08:40:00',2.59),('12664','2013-03-27','08:45:00',2.79),('12664','2013-03-27','08:50:00',1.85),('12664','2013-03-27','08:55:00',3.26),('12664','2013-03-27','09:00:00',1.59),('12664','2013-03-27','09:05:00',1.85),('12664','2013-03-27','09:10:00',2.12),('12664','2013-03-27','09:15:00',1.22),('12664','2013-03-27','09:35:00',2.03),('12664','2013-03-27','09:40:00',2.86),('12664','2013-03-27','09:45:00',3.4),('12664','2013-03-27','09:50:00',2.74),('12664','2013-03-27','09:55:00',1.29),('12664','2013-03-27','10:00:00',1.69),('12664','2013-03-27','10:05:00',2.04),('12664','2013-03-27','10:10:00',3.35),('12664','2013-03-27','10:15:00',4.35),('12664','2013-03-27','10:20:00',4.83),('12664','2013-03-27','10:25:00',3.07),('12664','2013-03-27','10:30:00',3.43),('12664','2013-03-27','10:35:00',3.6),('12664','2013-03-27','10:40:00',3.18),('12664','2013-03-27','10:45:00',2.65),('12664','2013-03-27','10:50:00',2.32),('12664','2013-03-27','10:55:00',2.01),('12664','2013-03-27','11:00:00',1.92),('12664','2013-03-27','11:05:00',1.79),('12664','2013-03-27','11:10:00',1.97),('12664','2013-03-27','11:15:00',2.12),('12664','2013-03-27','11:20:00',1.52),('12664','2013-03-27','11:25:00',1.11),('12664','2013-03-27','11:30:00',1.48),('12664','2013-03-27','11:35:00',1.38),('12664','2013-03-27','11:40:00',1.19),('12664','2013-03-27','11:45:00',1.3),('12664','2013-03-27','11:50:00',2.52),('12664','2013-03-27','11:55:00',2.35),('12664','2013-03-27','12:00:00',2.02),('12664','2013-03-27','12:05:00',1.86),('12664','2013-03-27','12:10:00',1.91),('12664','2013-03-27','12:15:00',1.38),('12664','2013-03-27','12:20:00',1.26),('12664','2013-03-27','12:25:00',1.57),('12664','2013-03-27','12:30:00',1.67),('12664','2013-03-27','12:35:00',1.57),('12664','2013-03-27','12:40:00',2.41),('12664','2013-03-27','12:45:00',2.84),('12664','2013-03-27','12:50:00',2.15),('12664','2013-03-27','12:55:00',2.75),('12664','2013-03-27','13:00:00',3.01),('12664','2013-03-27','13:05:00',2.47),('12664','2013-03-27','13:10:00',2.49),('12664','2013-03-27','13:15:00',2.06),('12664','2013-03-27','13:20:00',1.96),('12664','2013-03-27','13:25:00',1.86),('12664','2013-03-27','13:30:00',2.05),('12664','2013-03-27','13:35:00',2.18),('12664','2013-03-27','13:40:00',2.33),('12664','2013-03-27','13:45:00',2.32),('12664','2013-03-27','13:50:00',1.85),('12664','2013-03-27','13:55:00',1.76),('12664','2013-03-27','14:00:00',1.74),('12664','2013-03-27','14:05:00',1.93),('12664','2013-03-27','14:10:00',2.02),('12664','2013-03-27','14:15:00',2),('12664','2013-03-27','14:20:00',1.97),('12664','2013-03-27','14:25:00',1.65),('12664','2013-03-27','14:30:00',1.58),('12664','2013-03-27','14:35:00',1.7),('12664','2013-03-27','14:40:00',1.88),('12664','2013-03-27','14:45:00',2.35),('12664','2013-03-27','14:50:00',2.16),('12664','2013-03-27','14:55:00',3.04),('12664','2013-03-27','15:00:00',2.1),('12664','2013-03-27','15:05:00',1.97),('12664','2013-03-27','15:10:00',1.33),('12664','2013-03-27','15:15:00',1.08),('12664','2013-03-27','15:20:00',1.55),('12664','2013-03-27','15:25:00',1.5),('12664','2013-03-27','15:30:00',1.02),('12664','2013-03-27','16:15:00',1.05),('12664','2013-03-27','16:20:00',1.51),('12664','2013-03-27','16:25:00',1.19),('12664','2013-03-27','16:30:00',1.27),('12664','2013-03-27','16:35:00',1.48),('12664','2013-03-27','16:40:00',1.44),('12664','2013-03-27','16:55:00',1.21),('12664','2013-03-27','17:00:00',1.43),('12664','2013-03-27','17:05:00',1.02),('12664','2013-03-26','08:30:00',1.39),('12664','2013-03-26','08:35:00',1.23),('12664','2013-03-26','08:40:00',1.04),('12664','2013-03-26','09:05:00',1.32),('12664','2013-03-26','09:10:00',1.55),('12664','2013-03-26','09:55:00',1.64),('12664','2013-03-26','10:00:00',1.77),('12664','2013-03-26','10:05:00',1.22),('12664','2013-03-26','10:25:00',1.01),('12664','2013-03-26','10:30:00',1.17),('12664','2013-03-26','10:35:00',1.12),('12664','2013-03-26','10:40:00',1.56),('12664','2013-03-26','10:45:00',1.6),('12664','2013-03-26','10:50:00',2.09),('12664','2013-03-26','10:55:00',2.72),('12664','2013-03-26','11:00:00',1.68),('12664','2013-03-26','11:35:00',2.48),('12664','2013-03-26','11:40:00',3.91),('12664','2013-03-26','11:45:00',3.8),('12664','2013-03-26','11:50:00',4.26),('12664','2013-03-26','11:55:00',3.36),('12664','2013-03-26','12:00:00',1.34),('12664','2013-03-26','12:05:00',1.15),('12664','2013-03-26','12:10:00',1.33),('12664','2013-03-26','12:15:00',1.66),('12664','2013-03-26','12:20:00',3.52),('12664','2013-03-26','12:25:00',4.08),('12664','2013-03-26','12:30:00',2.66),('12664','2013-03-26','12:35:00',1.99),('12664','2013-03-26','12:40:00',1.41),('12664','2013-03-26','12:45:00',3.15),('12664','2013-03-26','12:50:00',3.31),('12664','2013-03-26','12:55:00',2.15),('12664','2013-03-26','13:00:00',2.83),('12664','2013-03-26','13:05:00',2.52),('12664','2013-03-26','13:10:00',1.64),('12664','2013-03-26','13:15:00',2.03),('12664','2013-03-26','13:20:00',2.01),('12664','2013-03-26','13:25:00',1.93),('12664','2013-03-26','13:30:00',2.04),('12664','2013-03-26','13:35:00',2.55),('12664','2013-03-26','13:40:00',3.01),('12664','2013-03-26','13:45:00',2.46),('12664','2013-03-26','13:50:00',1.86),('12664','2013-03-26','13:55:00',1.19),('12664','2013-03-26','14:00:00',1.36),('12664','2013-03-26','14:05:00',2.15),('12664','2013-03-26','14:10:00',2.19),('12664','2013-03-26','14:15:00',1.58),('12664','2013-03-26','14:20:00',1.34),('12664','2013-03-26','14:25:00',1.05),('12664','2013-03-26','14:30:00',1.21),('12664','2013-03-26','14:35:00',1.23),('12664','2013-03-26','14:40:00',1.17),('12664','2013-03-26','15:05:00',1.01),('12664','2013-03-25','08:20:00',2.62),('12664','2013-03-25','08:25:00',2.74),('12664','2013-03-25','08:30:00',2.27),('12664','2013-03-25','08:35:00',1.5),('12664','2013-03-25','08:40:00',1.05),('12664','2013-03-25','08:45:00',1.27),('12664','2013-03-25','08:50:00',1.19),('12664','2013-03-25','08:55:00',1.1),('12664','2013-03-25','09:20:00',2.94),('12664','2013-03-25','09:25:00',3.03),('12664','2013-03-25','09:35:00',1.29),('12664','2013-03-25','09:50:00',1.09),('12664','2013-03-25','09:55:00',1.19),('12664','2013-03-25','10:00:00',1.21),('12664','2013-03-25','10:05:00',1.48),('12664','2013-03-25','10:10:00',3.55),('12664','2013-03-25','10:15:00',3.34),('12664','2013-03-25','10:20:00',2.04),('12664','2013-03-25','10:25:00',2.42),('12664','2013-03-25','10:30:00',1.9),('12664','2013-03-25','10:35:00',2.6),('12664','2013-03-25','10:40:00',3.03),('12664','2013-03-25','10:45:00',2.58),('12664','2013-03-25','10:50:00',1.41),('12664','2013-03-25','10:55:00',1.54),('12664','2013-03-25','11:00:00',2.07),('12664','2013-03-25','11:05:00',1.07),('12664','2013-03-25','11:10:00',1.09),('12664','2013-03-25','11:20:00',2.98),('12664','2013-03-25','11:25:00',1.66),('12664','2013-03-25','11:30:00',3.55),('12664','2013-03-25','11:35:00',3.76),('12664','2013-03-25','11:40:00',4.76),('12664','2013-03-25','11:45:00',3.21),('12664','2013-03-25','11:50:00',5.01),('12664','2013-03-25','11:55:00',2.1),('12664','2013-03-25','12:00:00',3.17),('12664','2013-03-25','12:05:00',1.35),('12664','2013-03-25','12:10:00',1.96),('12664','2013-03-25','12:15:00',3.91),('12664','2013-03-25','12:20:00',3.64),('12664','2013-03-25','12:25:00',4.78),('12664','2013-03-25','12:30:00',5.04),('12664','2013-03-25','12:35:00',4.95),('12664','2013-03-25','12:40:00',4.44),('12664','2013-03-25','12:45:00',2.34),('12664','2013-03-25','12:50:00',2.73),('12664','2013-03-25','12:55:00',1.89),('12664','2013-03-25','13:00:00',2.58),('12664','2013-03-25','13:05:00',4.68),('12664','2013-03-25','13:10:00',4.58),('12664','2013-03-25','13:15:00',3.42),('12664','2013-03-25','13:20:00',4.8),('12664','2013-03-25','13:25:00',3.97),('12664','2013-03-25','13:30:00',3.97),('12664','2013-03-25','13:35:00',3.31),('12664','2013-03-25','13:40:00',3.51),('12664','2013-03-25','13:45:00',3.22),('12664','2013-03-25','13:50:00',3.88),('12664','2013-03-25','13:55:00',3.42),('12664','2013-03-25','14:00:00',3.37),('12664','2013-03-25','14:05:00',4.59),('12664','2013-03-25','14:10:00',3.87),('12664','2013-03-25','14:15:00',3.33),('12664','2013-03-25','14:20:00',2.88),('12664','2013-03-25','14:25:00',4.11),('12664','2013-03-25','14:30:00',2.8),('12664','2013-03-25','14:35:00',2.45),('12664','2013-03-25','14:40:00',3.04),('12664','2013-03-25','14:45:00',2.29),('12664','2013-03-25','14:50:00',2.54),('12664','2013-03-25','14:55:00',2.55),('12664','2013-03-25','15:00:00',3.62),('12664','2013-03-25','15:05:00',3.88),('12664','2013-03-25','15:10:00',3.9),('12664','2013-03-25','15:15:00',2.81),('12664','2013-03-25','15:20:00',3.61),('12664','2013-03-25','15:25:00',3.3),('12664','2013-03-25','15:30:00',3.32),('12664','2013-03-25','15:35:00',3.03),('12664','2013-03-25','15:40:00',3.25),('12664','2013-03-25','15:45:00',2.75),('12664','2013-03-25','15:50:00',2.67),('12664','2013-03-25','15:55:00',1.95),('12664','2013-03-25','16:15:00',1.01),('12664','2013-03-25','16:20:00',1.39),('12664','2013-03-25','16:25:00',2.46),('12664','2013-03-25','16:30:00',2.29),('12664','2013-03-25','16:35:00',1.24),('12664','2013-03-25','16:40:00',1.49),('12664','2013-03-25','16:45:00',1.02),('12664','2013-03-24','07:25:00',1.02),('12664','2013-03-24','07:30:00',1.01),('12664','2013-03-24','07:40:00',1.05),('12664','2013-03-24','07:45:00',1.13),('12664','2013-03-24','07:50:00',1.28),('12664','2013-03-24','07:55:00',1.44),('12664','2013-03-24','08:00:00',1.68),('12664','2013-03-24','08:05:00',1.92),('12664','2013-03-24','08:10:00',1.98),('12664','2013-03-24','08:15:00',2.18),('12664','2013-03-24','08:20:00',2.27),('12664','2013-03-24','08:25:00',2.34),('12664','2013-03-24','08:30:00',2.45),('12664','2013-03-24','08:35:00',2.54),('12664','2013-03-24','08:40:00',2.63),('12664','2013-03-24','08:45:00',2.72),('12664','2013-03-24','08:50:00',2.79),('12664','2013-03-24','08:55:00',2.84),('12664','2013-03-24','09:00:00',2.92),('12664','2013-03-24','09:05:00',2.96),('12664','2013-03-24','09:10:00',3.07),('12664','2013-03-24','09:15:00',3.16),('12664','2013-03-24','09:20:00',3.23),('12664','2013-03-24','09:25:00',3.27),('12664','2013-03-24','09:30:00',3.34),('12664','2013-03-24','09:35:00',3.39),('12664','2013-03-24','09:40:00',3.44),('12664','2013-03-24','09:45:00',3.48),('12664','2013-03-24','09:50:00',3.55),('12664','2013-03-24','09:55:00',3.6),('12664','2013-03-24','10:00:00',3.66),('12664','2013-03-24','10:05:00',3.73),('12664','2013-03-24','10:10:00',3.74),('12664','2013-03-24','10:15:00',3.79),('12664','2013-03-24','10:20:00',3.83),('12664','2013-03-24','10:25:00',3.87),('12664','2013-03-24','10:30:00',3.91),('12664','2013-03-24','10:35:00',3.95),('12664','2013-03-24','10:40:00',3.98),('12664','2013-03-24','10:45:00',3.99),('12664','2013-03-24','10:50:00',4.02),('12664','2013-03-24','10:55:00',4.04),('12664','2013-03-24','11:00:00',4.07),('12664','2013-03-24','11:05:00',4.1),('12664','2013-03-24','11:10:00',4.12),('12664','2013-03-24','11:15:00',4.16),('12664','2013-03-24','11:20:00',4.18),('12664','2013-03-24','11:25:00',4.18),('12664','2013-03-24','11:30:00',4.22),('12664','2013-03-24','11:35:00',4.25),('12664','2013-03-24','11:40:00',4.22),('12664','2013-03-24','11:45:00',4.22),('12664','2013-03-24','11:50:00',4.24),('12664','2013-03-24','11:55:00',4.25),('12664','2013-03-24','12:00:00',4.2),('12664','2013-03-24','12:05:00',4.24),('12664','2013-03-24','12:10:00',4.26),('12664','2013-03-24','12:15:00',4.28),('12664','2013-03-24','12:20:00',4.36),('12664','2013-03-24','12:25:00',4.44),('12664','2013-03-24','12:30:00',4.46),('12664','2013-03-24','12:35:00',4.47),('12664','2013-03-24','12:40:00',4.48),('12664','2013-03-24','12:45:00',4.5),('12664','2013-03-24','12:50:00',4.45),('12664','2013-03-24','12:55:00',4.41),('12664','2013-03-24','13:00:00',4.44),('12664','2013-03-24','13:05:00',4.43),('12664','2013-03-24','13:10:00',4.38),('12664','2013-03-24','13:15:00',4.35),('12664','2013-03-24','13:20:00',4.31),('12664','2013-03-24','13:25:00',4.27),('12664','2013-03-24','13:30:00',4.27),('12664','2013-03-24','13:35:00',4.21),('12664','2013-03-24','13:40:00',4.19),('12664','2013-03-24','13:45:00',4.16),('12664','2013-03-24','13:50:00',4.11),('12664','2013-03-24','13:55:00',4.04),('12664','2013-03-24','14:00:00',3.98),('12664','2013-03-24','14:05:00',3.96),('12664','2013-03-24','14:10:00',3.9),('12664','2013-03-24','14:15:00',3.82),('12664','2013-03-24','14:20:00',3.74),('12664','2013-03-24','14:25:00',3.62),('12664','2013-03-24','14:30:00',3.55),('12664','2013-03-24','14:35:00',3.37),('12664','2013-03-24','14:40:00',3.48),('12664','2013-03-24','14:45:00',3.44),('12664','2013-03-24','14:50:00',3.31),('12664','2013-03-24','14:55:00',3.19),('12664','2013-03-24','15:00:00',3.13),('12664','2013-03-24','15:05:00',3.01),('12664','2013-03-24','15:10:00',2.96),('12664','2013-03-24','15:15:00',2.92),('12664','2013-03-24','15:20:00',2.9),('12664','2013-03-24','15:25:00',2.78),('12664','2013-03-24','15:30:00',2.69),('12664','2013-03-24','15:35:00',2.64),('12664','2013-03-24','15:40:00',2.54),('12664','2013-03-24','15:45:00',1.85),('12664','2013-03-24','15:50:00',1.36),('12664','2013-03-24','15:55:00',1.51),('12664','2013-03-24','16:00:00',1.42),('12664','2013-03-24','16:05:00',1.19),('12664','2013-03-24','16:10:00',1.11),('12664','2013-03-24','16:15:00',1.77),('12664','2013-03-24','16:20:00',1.26),('12664','2013-03-24','16:25:00',1.07),('12664','2013-03-24','16:30:00',1.21),('12664','2013-03-24','16:35:00',1.01),('12664','2013-03-23','07:30:00',1.1),('12664','2013-03-23','07:35:00',1.14),('12664','2013-03-23','07:40:00',1.3),('12664','2013-03-23','07:45:00',1.32),('12664','2013-03-23','07:50:00',1.54),('12664','2013-03-23','07:55:00',1.68),('12664','2013-03-23','08:00:00',1.87),('12664','2013-03-23','08:05:00',1.99),('12664','2013-03-23','08:10:00',2.09),('12664','2013-03-23','08:15:00',2.18),('12664','2013-03-23','08:20:00',2.29),('12664','2013-03-23','08:25:00',2.39),('12664','2013-03-23','08:30:00',2.47),('12664','2013-03-23','08:35:00',2.52),('12664','2013-03-23','08:40:00',2.67),('12664','2013-03-23','08:45:00',2.7),('12664','2013-03-23','08:50:00',2.92),('12664','2013-03-23','08:55:00',2.91),('12664','2013-03-23','09:00:00',3.02),('12664','2013-03-23','09:05:00',3.1),('12664','2013-03-23','09:10:00',3.19),('12664','2013-03-23','09:15:00',3.17),('12664','2013-03-23','09:20:00',3.34),('12664','2013-03-23','09:25:00',3.45),('12664','2013-03-23','09:30:00',3.52),('12664','2013-03-23','09:35:00',3.43),('12664','2013-03-23','09:40:00',3.54),('12664','2013-03-23','09:45:00',3.62),('12664','2013-03-23','09:50:00',3.67),('12664','2013-03-23','09:55:00',3.72),('12664','2013-03-23','10:00:00',3.71),('12664','2013-03-23','10:05:00',3.72),('12664','2013-03-23','10:10:00',3.89),('12664','2013-03-23','10:15:00',3.63),('12664','2013-03-23','10:20:00',2.91),('12664','2013-03-23','10:25:00',3.13),('12664','2013-03-23','10:30:00',3.21),('12664','2013-03-23','10:35:00',3.76),('12664','2013-03-23','10:40:00',4.03),('12664','2013-03-23','10:45:00',4.13),('12664','2013-03-23','10:50:00',3.86),('12664','2013-03-23','10:55:00',3.74),('12664','2013-03-23','11:00:00',3.42),('12664','2013-03-23','11:05:00',3.07),('12664','2013-03-23','11:10:00',3.88),('12664','2013-03-23','11:15:00',3.95),('12664','2013-03-23','11:20:00',3.68),('12664','2013-03-23','11:25:00',3.96),('12664','2013-03-23','11:30:00',4.19),('12664','2013-03-23','11:35:00',4.29),('12664','2013-03-23','11:40:00',3.99),('12664','2013-03-23','11:45:00',3.86),('12664','2013-03-23','11:50:00',4.19),('12664','2013-03-23','11:55:00',4.23),('12664','2013-03-23','12:00:00',4.22),('12664','2013-03-23','12:05:00',4.25),('12664','2013-03-23','12:10:00',4.28),('12664','2013-03-23','12:15:00',4.15),('12664','2013-03-23','12:20:00',4.32),('12664','2013-03-23','12:25:00',4.29),('12664','2013-03-23','12:30:00',4.26),('12664','2013-03-23','12:35:00',4.25),('12664','2013-03-23','12:40:00',4.37),('12664','2013-03-23','12:45:00',3.49),('12664','2013-03-23','12:50:00',3.77),('12664','2013-03-23','12:55:00',4.15),('12664','2013-03-23','13:00:00',3.81),('12664','2013-03-23','13:05:00',4.11),('12664','2013-03-23','13:10:00',4.17),('12664','2013-03-23','13:15:00',4.26),('12664','2013-03-23','13:20:00',4.24),('12664','2013-03-23','13:25:00',4.33),('12664','2013-03-23','13:30:00',4.21),('12664','2013-03-23','13:35:00',4.22),('12664','2013-03-23','13:40:00',4.09),('12664','2013-03-23','13:45:00',4.02),('12664','2013-03-23','13:50:00',4.03),('12664','2013-03-23','13:55:00',4.03),('12664','2013-03-23','14:00:00',4.07),('12664','2013-03-23','14:05:00',3.92),('12664','2013-03-23','14:10:00',3.75),('12664','2013-03-23','14:15:00',3.71),('12664','2013-03-23','14:20:00',3.77),('12664','2013-03-23','14:25:00',3.72),('12664','2013-03-23','14:30:00',3.63),('12664','2013-03-23','14:35:00',3.57),('12664','2013-03-23','14:40:00',3.3),('12664','2013-03-23','14:45:00',3.25),('12664','2013-03-23','14:50:00',3.27),('12664','2013-03-23','14:55:00',3.16),('12664','2013-03-23','15:00:00',3.11),('12664','2013-03-23','15:05:00',3.19),('12664','2013-03-23','15:10:00',2.72),('12664','2013-03-23','15:15:00',2.73),('12664','2013-03-23','15:20:00',2.84),('12664','2013-03-23','15:25:00',2.78),('12664','2013-03-23','15:30:00',2.43),('12664','2013-03-23','15:35:00',2.53),('12664','2013-03-23','15:40:00',2.39),('12664','2013-03-23','15:45:00',1.98),('12664','2013-03-23','15:50:00',1.72),('12664','2013-03-23','15:55:00',1.92),('12664','2013-03-23','16:00:00',1.81),('12664','2013-03-23','16:05:00',1.76),('12664','2013-03-23','16:10:00',2.11),('12664','2013-03-23','16:15:00',1.96),('12664','2013-03-23','16:20:00',1.79),('12664','2013-03-23','16:25:00',1.65),('12664','2013-03-23','16:30:00',1.46),('12664','2013-03-23','16:35:00',1.32),('12664','2013-03-23','16:40:00',1.12),('12664','2013-03-23','16:45:00',1.03),('12664','2013-03-23','16:50:00',1.07),('12664','2013-03-23','16:55:00',1.01),('12664','2013-03-23','17:00:00',1.24),('12664','2013-03-23','17:05:00',1.15),('12664','2013-03-22','07:25:00',1.04),('12664','2013-03-22','07:30:00',1.15),('12664','2013-03-22','07:35:00',1.26),('12664','2013-03-22','07:40:00',1.37),('12664','2013-03-22','07:45:00',1.48),('12664','2013-03-22','07:50:00',1.61),('12664','2013-03-22','07:55:00',1.72),('12664','2013-03-22','08:00:00',1.84),('12664','2013-03-22','08:05:00',1.95),('12664','2013-03-22','08:10:00',2.06),('12664','2013-03-22','08:15:00',2.17),('12664','2013-03-22','08:20:00',2.27),('12664','2013-03-22','08:25:00',2.37),('12664','2013-03-22','08:30:00',2.46),('12664','2013-03-22','08:35:00',2.58),('12664','2013-03-22','08:40:00',2.67),('12664','2013-03-22','08:45:00',2.76),('12664','2013-03-22','08:50:00',2.86),('12664','2013-03-22','08:55:00',2.94),('12664','2013-03-22','09:00:00',3.04),('12664','2013-03-22','09:05:00',3.11),('12664','2013-03-22','09:10:00',3.17),('12664','2013-03-22','09:15:00',3.22),('12664','2013-03-22','09:20:00',3.31),('12664','2013-03-22','09:25:00',3.37),('12664','2013-03-22','09:30:00',3.46),('12664','2013-03-22','09:35:00',3.51),('12664','2013-03-22','09:40:00',3.53),('12664','2013-03-22','09:45:00',3.56),('12664','2013-03-22','09:50:00',3.68),('12664','2013-03-22','09:55:00',3.73),('12664','2013-03-22','10:00:00',3.76),('12664','2013-03-22','10:05:00',3.84),('12664','2013-03-22','10:10:00',3.88),('12664','2013-03-22','10:15:00',3.92),('12664','2013-03-22','10:20:00',3.95),('12664','2013-03-22','10:25:00',4),('12664','2013-03-22','10:30:00',4.07),('12664','2013-03-22','10:35:00',4.08),('12664','2013-03-22','10:40:00',4.18),('12664','2013-03-22','10:45:00',4.23),('12664','2013-03-22','10:50:00',4.28),('12664','2013-03-22','10:55:00',4.33),('12664','2013-03-22','11:00:00',4.36),('12664','2013-03-22','11:05:00',4.4),('12664','2013-03-22','11:10:00',4.44),('12664','2013-03-22','11:15:00',4.43),('12664','2013-03-22','11:20:00',4.43),('12664','2013-03-22','11:25:00',4.49),('12664','2013-03-22','11:30:00',4.53),('12664','2013-03-22','11:35:00',4.58),('12664','2013-03-22','11:40:00',4.61),('12664','2013-03-22','11:45:00',4.61),('12664','2013-03-22','11:50:00',4.61),('12664','2013-03-22','11:55:00',4.65),('12664','2013-03-22','12:00:00',4.65),('12664','2013-03-22','12:05:00',4.65),('12664','2013-03-22','12:10:00',4.64),('12664','2013-03-22','12:15:00',4.64),('12664','2013-03-22','12:20:00',4.64),('12664','2013-03-22','12:25:00',4.65),('12664','2013-03-22','12:30:00',4.67),('12664','2013-03-22','12:35:00',4.64),('12664','2013-03-22','12:40:00',4.63),('12664','2013-03-22','12:45:00',4.59),('12664','2013-03-22','12:50:00',4.39),('12664','2013-03-22','12:55:00',4.58),('12664','2013-03-22','13:00:00',4.53),('12664','2013-03-22','13:05:00',4.59),('12664','2013-03-22','13:10:00',4.57),('12664','2013-03-22','13:15:00',4.53),('12664','2013-03-22','13:20:00',4.28),('12664','2013-03-22','13:25:00',4.17),('12664','2013-03-22','13:30:00',4.44),('12664','2013-03-22','13:35:00',3.93),('12664','2013-03-22','13:40:00',3.64),('12664','2013-03-22','13:45:00',4.39),('12664','2013-03-22','13:50:00',4.32),('12664','2013-03-22','13:55:00',4.23),('12664','2013-03-22','14:00:00',4.17),('12664','2013-03-22','14:05:00',4.12),('12664','2013-03-22','14:10:00',4.08),('12664','2013-03-22','14:15:00',4.03),('12664','2013-03-22','14:20:00',4),('12664','2013-03-22','14:25:00',3.92),('12664','2013-03-22','14:30:00',3.85),('12664','2013-03-22','14:35:00',3.81),('12664','2013-03-22','14:40:00',3.76),('12664','2013-03-22','14:45:00',3.64),('12664','2013-03-22','14:50:00',3.17),('12664','2013-03-22','14:55:00',3.63),('12664','2013-03-22','15:00:00',2.76),('12664','2013-03-22','15:05:00',3.32),('12664','2013-03-22','15:10:00',2.18),('12664','2013-03-22','15:15:00',2.18),('12664','2013-03-22','15:20:00',2.72),('12664','2013-03-22','15:25:00',2.47),('12664','2013-03-22','15:30:00',2.71),('12664','2013-03-22','15:35:00',2.72),('12664','2013-03-22','15:40:00',2.45),('12664','2013-03-22','15:45:00',2.55),('12664','2013-03-22','15:50:00',2.31),('12664','2013-03-22','15:55:00',1.69),('12664','2013-03-22','16:00:00',1.5),('12664','2013-03-22','16:05:00',1.81),('12664','2013-03-22','16:10:00',2.16),('12664','2013-03-22','16:15:00',1.85),('12664','2013-03-22','16:20:00',1.4),('12664','2013-03-22','16:25:00',1.85),('12664','2013-03-22','16:30:00',1.26),('12664','2013-03-22','16:35:00',1.46),('12664','2013-03-22','16:40:00',1.39),('12664','2013-03-22','16:45:00',1.69),('12664','2013-03-22','16:50:00',1.16),('12664','2013-03-22','16:55:00',1.28),('12664','2013-03-22','17:00:00',1.26),('12664','2013-03-22','17:05:00',1.08),('12664','2014-03-25','07:15:00',1.1),('12664','2014-03-25','07:20:00',1.24),('12664','2014-03-25','07:25:00',1.21),('12664','2014-03-25','07:30:00',1.21),('12664','2014-03-25','07:45:00',1.06),('12664','2014-03-25','07:50:00',1.09),('12664','2014-03-25','07:55:00',1),('12664','2014-03-25','08:00:00',1.02),('12664','2014-03-25','08:05:00',1.04),('12664','2014-03-25','08:10:00',1.11),('12664','2014-03-25','08:15:00',1.06),('12664','2014-03-25','08:35:00',1.1),('12664','2014-03-25','08:40:00',1.42),('12664','2014-03-25','08:45:00',1.6),('12664','2014-03-25','08:50:00',1.66),('12664','2014-03-25','08:55:00',1.65),('12664','2014-03-25','09:00:00',1.63),('12664','2014-03-25','09:05:00',1.76),('12664','2014-03-25','09:10:00',1.95),('12664','2014-03-25','09:15:00',2.23),('12664','2014-03-25','09:20:00',2.18),('12664','2014-03-25','09:25:00',1.88),('12664','2014-03-25','09:30:00',1.7),('12664','2014-03-25','09:35:00',1.72),('12664','2014-03-25','09:40:00',1.65),('12664','2014-03-25','09:45:00',1.72),('12664','2014-03-25','09:50:00',1.85),('12664','2014-03-25','09:55:00',2.21),('12664','2014-03-25','10:00:00',2.37),('12664','2014-03-25','10:05:00',2.48),('12664','2014-03-25','10:10:00',2.76),('12664','2014-03-25','10:15:00',3.05),('12664','2014-03-25','10:20:00',3.18),('12664','2014-03-25','10:25:00',2.64),('12664','2014-03-25','10:30:00',2.35),('12664','2014-03-25','10:35:00',2.14),('12664','2014-03-25','10:40:00',1.87),('12664','2014-03-25','10:45:00',1.73),('12664','2014-03-25','10:50:00',1.94),('12664','2014-03-25','10:55:00',2.21),('12664','2014-03-25','11:00:00',2.35),('12664','2014-03-25','11:05:00',2.5),('12664','2014-03-25','11:10:00',2.56),('12664','2014-03-25','11:15:00',2.67),('12664','2014-03-25','11:20:00',2.88),('12664','2014-03-25','11:25:00',3.03),('12664','2014-03-25','11:30:00',3.06),('12664','2014-03-25','11:35:00',2.96),('12664','2014-03-25','11:40:00',2.87),('12664','2014-03-25','11:45:00',2.61),('12664','2014-03-25','11:50:00',2.18),('12664','2014-03-25','11:55:00',1.67),('12664','2014-03-25','12:00:00',1.21),('12664','2014-03-25','12:05:00',1.17),('12664','2014-03-25','12:10:00',1.31),('12664','2014-03-25','12:15:00',1.31),('12664','2014-03-25','12:20:00',1.28),('12664','2014-03-25','12:25:00',1.09),('12664','2014-03-25','12:50:00',1.21),('12664','2014-03-25','12:55:00',1.03),('12664','2013-03-21','07:35:00',1.25),('12664','2013-03-21','07:55:00',1.76),('12664','2013-03-21','08:00:00',1.97),('12664','2013-03-21','08:05:00',2.06),('12664','2013-03-21','08:10:00',2.17),('12664','2013-03-21','08:15:00',2.34),('12664','2013-03-21','08:20:00',2.57),('12664','2013-03-21','08:25:00',2.58),('12664','2013-03-21','08:30:00',2.59),('12664','2013-03-21','08:35:00',2.3),('12664','2013-03-21','08:40:00',2.92),('12664','2013-03-21','08:45:00',3.09),('12664','2013-03-21','09:00:00',2.98),('12664','2013-03-21','09:05:00',3.41),('12664','2013-03-21','09:10:00',3.46),('12664','2013-03-21','09:15:00',3.54),('12664','2013-03-21','09:20:00',3.63),('12664','2013-03-21','09:25:00',3.79),('12664','2013-03-21','09:30:00',3.86),('12664','2013-03-21','09:35:00',3.67),('12664','2013-03-21','09:40:00',3.89),('12664','2013-03-21','09:45:00',3.87),('12664','2013-03-21','09:50:00',3.81),('12664','2013-03-21','09:55:00',3.99),('12664','2013-03-21','10:00:00',4.13),('12664','2013-03-21','10:05:00',3.67),('12664','2013-03-21','10:10:00',4.15),('12664','2013-03-21','10:15:00',4.29),('12664','2013-03-21','10:20:00',4.23),('12664','2013-03-21','10:25:00',4.26),('12664','2013-03-21','10:30:00',4.32),('12664','2013-03-21','10:35:00',4.4),('12664','2013-03-21','10:40:00',4.44),('12664','2013-03-21','10:45:00',4.48),('12664','2013-03-21','10:50:00',4.52),('12664','2013-03-21','10:55:00',4.55),('12664','2013-03-21','11:00:00',4.61),('12664','2013-03-21','11:05:00',4.66),('12664','2013-03-21','11:10:00',4.7),('12664','2013-03-21','11:15:00',4.76),('12664','2013-03-21','11:20:00',4.75),('12664','2013-03-21','11:25:00',4.74),('12664','2013-03-21','11:30:00',4.79),('12664','2013-03-21','11:35:00',4.8),('12664','2013-03-21','11:40:00',4.82),('12664','2013-03-21','11:45:00',4.84),('12664','2013-03-21','11:50:00',4.86),('12664','2013-03-21','11:55:00',4.85),('12664','2013-03-21','12:00:00',4.89),('12664','2013-03-21','12:05:00',4.9),('12664','2013-03-21','12:10:00',4.91),('12664','2013-03-21','12:15:00',4.89),('12664','2013-03-21','12:20:00',4.9),('12664','2013-03-21','12:25:00',4.9),('12664','2013-03-21','12:30:00',4.87),('12664','2013-03-21','12:35:00',4.85),('12664','2013-03-21','12:40:00',4.87),('12664','2013-03-21','12:45:00',4.85),('12664','2013-03-21','12:50:00',4.83),('12664','2013-03-21','12:55:00',4.8),('12664','2013-03-21','13:00:00',4.77),('12664','2013-03-21','13:05:00',4.74),('12664','2013-03-21','13:10:00',4.72),('12664','2013-03-21','13:15:00',4.69),('12664','2013-03-21','13:20:00',4.66),('12664','2013-03-21','13:25:00',4.63),('12664','2013-03-21','13:30:00',4.58),('12664','2013-03-21','13:35:00',4.55),('12664','2013-03-21','13:40:00',4.49),('12664','2013-03-21','13:45:00',4.45),('12664','2013-03-21','13:50:00',4.4),('12664','2013-03-21','13:55:00',4.34),('12664','2013-03-21','14:00:00',4.29),('12664','2013-03-21','14:05:00',4.24),('12664','2013-03-21','14:10:00',4.19),('12664','2013-03-21','14:15:00',4.13),('12664','2013-03-21','14:20:00',4.07),('12664','2013-03-21','14:25:00',4.02),('12664','2013-03-21','14:30:00',3.93),('12664','2013-03-21','14:35:00',3.87),('12664','2013-03-21','14:40:00',3.8),('12664','2013-03-21','14:45:00',3.74),('12664','2013-03-21','14:50:00',3.67),('12664','2013-03-21','14:55:00',3.62),('12664','2013-03-21','15:00:00',3.55),('12664','2013-03-21','15:05:00',3.45),('12664','2013-03-21','15:10:00',3.36),('12664','2013-03-21','15:15:00',3.27),('12664','2013-03-21','15:20:00',3.18),('12664','2013-03-21','15:25:00',3.11),('12664','2013-03-21','15:30:00',3.03),('12664','2013-03-21','15:35:00',2.93),('12664','2013-03-21','15:40:00',2.83),('12664','2013-03-21','15:45:00',2.73),('12664','2013-03-21','15:50:00',2.63),('12664','2013-03-21','15:55:00',2.51),('12664','2013-03-21','16:00:00',2.43),('12664','2013-03-21','16:05:00',2.33),('12664','2013-03-21','16:10:00',2.21),('12664','2013-03-21','16:15:00',2.12),('12664','2013-03-21','16:20:00',2.01),('12664','2013-03-21','16:25:00',1.89),('12664','2013-03-21','16:30:00',1.74),('12664','2013-03-21','16:35:00',1.67),('12664','2013-03-21','16:40:00',1.55),('12664','2013-03-21','16:45:00',1.43),('12664','2013-03-21','16:50:00',1.31),('12664','2013-03-21','16:55:00',1.19),('12664','2013-03-21','17:00:00',1.07),('12664','2013-03-20','07:25:00',1.05),('12664','2013-03-20','07:30:00',1.2),('12664','2013-03-20','07:35:00',1.32),('12664','2013-03-20','07:40:00',1.37),('12664','2013-03-20','07:45:00',1.51),('12664','2013-03-20','07:50:00',1.65),('12664','2013-03-20','08:05:00',1.9),('12664','2013-03-20','08:10:00',2.02),('12664','2013-03-20','08:15:00',2.12),('12664','2013-03-20','08:20:00',2.24),('12664','2013-03-20','08:25:00',2.31),('12664','2013-03-20','08:30:00',2.41),('12664','2013-03-20','08:35:00',2.41),('12664','2013-03-20','08:40:00',2.25),('12664','2013-03-20','08:45:00',2.59),('12664','2013-03-20','08:50:00',2.56),('12664','2013-03-20','08:55:00',2.65),('12664','2013-03-20','09:00:00',2.77),('12664','2013-03-20','09:05:00',1.87),('12664','2013-03-20','09:10:00',1.92),('12664','2013-03-20','09:15:00',3.05),('12664','2013-03-20','09:20:00',3.18),('12664','2013-03-20','09:25:00',2.17),('12664','2013-03-20','09:30:00',3.44),('12664','2013-03-20','09:35:00',3.15),('12664','2013-03-20','09:40:00',3.57),('12664','2013-03-20','09:45:00',3.68),('12664','2013-03-20','09:50:00',3.77),('12664','2013-03-20','09:55:00',3.54),('12664','2013-03-20','10:00:00',2.97),('12664','2013-03-20','10:05:00',3.77),('12664','2013-03-20','10:10:00',2.92),('12664','2013-03-20','10:15:00',2.99),('12664','2013-03-20','10:20:00',3.07),('12664','2013-03-20','10:25:00',3.52),('12664','2013-03-20','10:30:00',3.56),('12664','2013-03-20','10:35:00',2.58),('12664','2013-03-20','10:40:00',2.99),('12664','2013-03-20','10:45:00',2.74),('12664','2013-03-20','10:50:00',3.19),('12664','2013-03-20','10:55:00',3.05),('12664','2013-03-20','11:00:00',2.75),('12664','2013-03-20','11:05:00',2.89),('12664','2013-03-20','11:10:00',2.52),('12664','2013-03-20','11:15:00',2.6),('12664','2013-03-20','11:20:00',2.99),('12664','2013-03-20','11:25:00',2.45),('12664','2013-03-20','11:30:00',2.58),('12664','2013-03-20','11:35:00',3),('12664','2013-03-20','11:40:00',2.48),('12664','2013-03-20','11:45:00',2.12),('12664','2013-03-20','11:50:00',2.2),('12664','2013-03-20','11:55:00',2.13),('12664','2013-03-20','12:00:00',2.38),('12664','2013-03-20','12:05:00',2.21),('12664','2013-03-20','12:10:00',1.99),('12664','2013-03-20','12:15:00',1.55),('12664','2013-03-20','12:20:00',1.36),('12664','2013-03-20','12:25:00',1.22),('12664','2013-03-20','12:30:00',1.29),('12664','2013-03-20','12:35:00',1.28),('12664','2013-03-20','12:40:00',1.03),('12664','2013-03-20','12:50:00',1.51),('12664','2013-03-20','12:55:00',1.83),('12664','2013-03-20','13:00:00',1.27),('12664','2013-03-20','13:05:00',1.17),('12664','2013-03-20','13:10:00',1.25),('12664','2013-03-20','13:15:00',1.14),('12664','2013-03-20','13:20:00',1.24),('12664','2013-03-20','13:25:00',1.46),('12664','2013-03-20','13:30:00',1.58),('12664','2013-03-20','13:35:00',1.54),('12664','2013-03-20','13:40:00',2.03),('12664','2013-03-20','13:45:00',1.98),('12664','2013-03-20','13:50:00',1.71),('12664','2013-03-20','13:55:00',1.78),('12664','2013-03-20','14:00:00',1.55),('12664','2013-03-20','14:05:00',1.29),('12664','2013-03-20','14:10:00',1.34),('12664','2013-03-20','14:15:00',1.81),('12664','2013-03-20','14:20:00',2.05),('12664','2013-03-20','14:25:00',2.32),('12664','2013-03-20','14:30:00',2.01),('12664','2013-03-20','14:35:00',1.45),('12664','2013-03-20','14:40:00',1.17),('12664','2013-03-20','14:45:00',1.01),('12664','2013-03-19','07:30:00',1.12),('12664','2013-03-19','07:35:00',1.22),('12664','2013-03-19','07:40:00',1.33),('12664','2013-03-19','07:45:00',1.47),('12664','2013-03-19','07:50:00',1.62),('12664','2013-03-19','07:55:00',1.52),('12664','2013-03-19','08:00:00',1.47),('12664','2013-03-19','08:05:00',1.86),('12664','2013-03-19','08:10:00',1.77),('12664','2013-03-19','08:15:00',1.93),('12664','2013-03-19','08:20:00',2.05),('12664','2013-03-19','08:25:00',2.27),('12664','2013-03-19','08:30:00',2.43),('12664','2013-03-19','08:35:00',2.55),('12664','2013-03-19','08:40:00',2.63),('12664','2013-03-19','08:45:00',2.72),('12664','2013-03-19','08:50:00',2.64),('12664','2013-03-19','08:55:00',2.91),('12664','2013-03-19','09:00:00',3.01),('12664','2013-03-19','09:05:00',3.11),('12664','2013-03-19','09:10:00',3.2),('12664','2013-03-19','09:15:00',3.29),('12664','2013-03-19','09:20:00',3.35),('12664','2013-03-19','09:25:00',3.45),('12664','2013-03-19','09:30:00',3.52),('12664','2013-03-19','09:35:00',3.57),('12664','2013-03-19','09:40:00',3.66),('12664','2013-03-19','09:45:00',3.77),('12664','2013-03-19','09:50:00',3.89),('12664','2013-03-19','09:55:00',3.72),('12664','2013-03-19','10:00:00',3.99),('12664','2013-03-19','10:05:00',4.05),('12664','2013-03-19','10:10:00',4.1),('12664','2013-03-19','10:15:00',4.14),('12664','2013-03-19','10:20:00',4.22),('12664','2013-03-19','10:25:00',4.28),('12664','2013-03-19','10:30:00',4.31),('12664','2013-03-19','10:35:00',4.37),('12664','2013-03-19','10:40:00',4.4),('12664','2013-03-19','10:45:00',4.46),('12664','2013-03-19','10:50:00',4.53),('12664','2013-03-19','10:55:00',4.58),('12664','2013-03-19','11:00:00',4.6),('12664','2013-03-19','11:05:00',4.63),('12664','2013-03-19','11:10:00',4.66),('12664','2013-03-19','11:15:00',4.61),('12664','2013-03-19','11:20:00',4.67),('12664','2013-03-19','11:25:00',4.71),('12664','2013-03-19','11:30:00',4.33),('12664','2013-03-19','11:35:00',3.7),('12664','2013-03-19','11:40:00',3.94),('12664','2013-03-19','11:45:00',4.14),('12664','2013-03-19','11:50:00',4.59),('12664','2013-03-19','11:55:00',4.83),('12664','2013-03-19','12:00:00',4.84),('12664','2013-03-19','12:05:00',4.83),('12664','2013-03-19','12:10:00',4.81),('12664','2013-03-19','12:15:00',4.8),('12664','2013-03-19','12:20:00',4.75),('12664','2013-03-19','12:25:00',4.62),('12664','2013-03-19','12:30:00',4.76),('12664','2013-03-19','12:35:00',4.73),('12664','2013-03-19','12:40:00',4.73),('12664','2013-03-19','12:45:00',4.62),('12664','2013-03-19','12:50:00',4.63),('12664','2013-03-19','12:55:00',4.66),('12664','2013-03-19','13:00:00',4.66),('12664','2013-03-19','13:05:00',4.56),('12664','2013-03-19','13:10:00',4.59),('12664','2013-03-19','13:15:00',4.55),('12664','2013-03-19','13:20:00',4.53),('12664','2013-03-19','13:25:00',4.49),('12664','2013-03-19','13:30:00',4.47),('12664','2013-03-19','13:35:00',4.42),('12664','2013-03-19','13:40:00',4.33),('12664','2013-03-19','13:45:00',4.13),('12664','2013-03-19','13:50:00',4.28),('12664','2013-03-19','13:55:00',4.21),('12664','2013-03-19','14:00:00',4.16),('12664','2013-03-19','14:05:00',4.13),('12664','2013-03-19','14:10:00',4.08),('12664','2013-03-19','14:15:00',4.02),('12664','2013-03-19','14:20:00',3.94),('12664','2013-03-19','14:25:00',3.89),('12664','2013-03-19','14:30:00',3.82),('12664','2013-03-19','14:35:00',3.78),('12664','2013-03-19','14:40:00',3.72),('12664','2013-03-19','14:45:00',3.66),('12664','2013-03-19','14:50:00',3.59),('12664','2013-03-19','14:55:00',3.51),('12664','2013-03-19','15:00:00',3.43),('12664','2013-03-19','15:05:00',3.35),('12664','2013-03-19','15:10:00',3.28),('12664','2013-03-19','15:15:00',3.21),('12664','2013-03-19','15:20:00',3.11),('12664','2013-03-19','15:25:00',3.03),('12664','2013-03-19','15:30:00',2.94),('12664','2013-03-19','15:35:00',2.85),('12664','2013-03-19','15:40:00',2.75),('12664','2013-03-19','15:45:00',2.66),('12664','2013-03-19','15:50:00',2.56),('12664','2013-03-19','15:55:00',2.46),('12664','2013-03-19','16:00:00',2.36),('12664','2013-03-19','16:05:00',2.28),('12664','2013-03-19','16:10:00',2.16),('12664','2013-03-19','16:15:00',2.06),('12664','2013-03-19','16:20:00',1.94),('12664','2013-03-19','16:25:00',1.84),('12664','2013-03-19','16:30:00',1.76),('12664','2013-03-19','16:35:00',1.48),('12664','2013-03-19','16:40:00',1.52),('12664','2013-03-19','16:45:00',1.25),('12664','2013-03-19','16:55:00',1.13),('12664','2013-03-18','08:40:00',1.68),('12664','2013-03-18','08:45:00',1.11),('12664','2013-03-18','09:55:00',1.23),('12664','2013-03-18','10:00:00',1.48),('12664','2013-03-18','10:05:00',1.42),('12664','2013-03-18','10:10:00',1.51),('12664','2013-03-18','10:15:00',2.44),('12664','2013-03-18','10:20:00',2.43),('12664','2013-03-18','10:25:00',2.32),('12664','2013-03-18','10:30:00',1.82),('12664','2013-03-18','10:35:00',1.5),('12664','2013-03-18','10:40:00',1.65),('12664','2013-03-18','10:45:00',1.4),('12664','2013-03-18','11:00:00',1.18),('12664','2013-03-18','11:05:00',1.4),('12664','2013-03-18','11:10:00',1.71),('12664','2013-03-18','11:15:00',1.95),('12664','2013-03-18','11:20:00',2.08),('12664','2013-03-18','11:25:00',2.36),('12664','2013-03-18','11:30:00',2.14),('12664','2013-03-18','11:35:00',1.75),('12664','2013-03-18','11:40:00',1.34),('12664','2013-03-18','11:45:00',1.14),('12664','2013-03-18','11:50:00',1.08),('12664','2013-03-18','11:55:00',1.19),('12664','2013-03-18','12:00:00',1.41),('12664','2013-03-18','12:05:00',1.79),('12664','2013-03-18','12:10:00',2.1),('12664','2013-03-18','12:15:00',2.96),('12664','2013-03-18','12:20:00',3.96),('12664','2013-03-18','12:25:00',4.39),('12664','2013-03-18','12:30:00',3.51),('12664','2013-03-18','12:35:00',1.89),('12664','2013-03-18','12:40:00',2.24),('12664','2013-03-18','12:45:00',3.24),('12664','2013-03-18','12:50:00',3.66),('12664','2013-03-18','12:55:00',2.09),('12664','2013-03-18','13:00:00',1.27),('12664','2013-03-18','13:05:00',1.43),('12664','2013-03-18','13:10:00',1.14),('12664','2013-03-18','13:15:00',1.14),('12664','2013-03-18','13:20:00',2.33),('12664','2013-03-18','13:25:00',1.82),('12664','2013-03-18','13:30:00',1.04),('12664','2013-03-18','13:35:00',1.52),('12664','2013-03-18','13:40:00',1.49),('12664','2013-03-18','13:45:00',1.37),('12664','2013-03-18','13:55:00',1.29),('12664','2013-03-18','14:00:00',1.97),('12664','2013-03-18','14:05:00',1.72),('12664','2013-03-18','14:10:00',1.69),('12664','2013-03-18','14:20:00',1.02),('12664','2013-03-18','14:35:00',1.09),('12664','2013-03-18','14:40:00',1.02),('12664','2013-03-18','14:55:00',1),('12664','2013-03-17','08:15:00',1.02),('12664','2013-03-17','08:20:00',1.51),('12664','2013-03-17','08:25:00',1.48),('12664','2013-03-17','08:30:00',1.37),('12664','2013-03-17','08:35:00',1.24),('12664','2013-03-17','08:40:00',1.41),('12664','2013-03-17','08:45:00',1.48),('12664','2013-03-17','08:50:00',1.3),('12664','2013-03-17','08:55:00',1.22),('12664','2013-03-17','09:00:00',1.5),('12664','2013-03-17','09:05:00',1.8),('12664','2013-03-17','09:10:00',1.78),('12664','2013-03-17','09:15:00',1.65),('12664','2013-03-17','09:20:00',1.46),('12664','2013-03-17','09:25:00',1.33),('12664','2013-03-17','09:30:00',1.65),('12664','2013-03-17','09:35:00',1.58),('12664','2013-03-17','09:40:00',1.56),('12664','2013-03-17','09:45:00',1.71),('12664','2013-03-17','09:50:00',1.8),('12664','2013-03-17','09:55:00',1.96),('12664','2013-03-17','10:00:00',1.85),('12664','2013-03-17','10:05:00',1.69),('12664','2013-03-17','10:10:00',1.78),('12664','2013-03-17','10:15:00',1.85),('12664','2013-03-17','10:20:00',1.94),('12664','2013-03-17','10:25:00',2.02),('12664','2013-03-17','10:30:00',1.93),('12664','2013-03-17','10:35:00',1.93),('12664','2013-03-17','10:40:00',1.91),('12664','2013-03-17','10:45:00',1.79),('12664','2013-03-17','10:50:00',1.46),('12664','2013-03-17','10:55:00',1.36),('12664','2013-03-17','11:00:00',1.49),('12664','2013-03-17','11:05:00',1.62),('12664','2013-03-17','11:10:00',1.67),('12664','2013-03-17','11:15:00',2.12),('12664','2013-03-17','11:20:00',2.45),('12664','2013-03-17','11:25:00',1.98),('12664','2013-03-17','11:30:00',1.8),('12664','2013-03-17','11:35:00',1.73),('12664','2013-03-17','11:40:00',1.56),('12664','2013-03-17','11:45:00',1.37),('12664','2013-03-17','11:50:00',1.26),('12664','2013-03-17','11:55:00',1.16),('12664','2013-03-17','12:00:00',1.1),('12664','2013-03-17','12:05:00',1.38),('12664','2013-03-17','12:10:00',1.91),('12664','2013-03-17','12:15:00',2.52),('12664','2013-03-17','12:20:00',2.64),('12664','2013-03-17','12:25:00',2.7),('12664','2013-03-17','12:30:00',2.37),('12664','2013-03-17','12:35:00',2.42),('12664','2013-03-17','12:40:00',2.46),('12664','2013-03-17','12:45:00',2.25),('12664','2013-03-17','12:50:00',1.8),('12664','2013-03-17','12:55:00',1.92),('12664','2013-03-17','13:00:00',1.94),('12664','2013-03-17','13:05:00',1.87),('12664','2013-03-17','13:10:00',1.77),('12664','2013-03-17','13:15:00',1.59),('12664','2013-03-17','13:20:00',1.58),('12664','2013-03-17','13:25:00',2.59),('12664','2013-03-17','13:30:00',2.42),('12664','2013-03-17','13:35:00',2.14),('12664','2013-03-17','13:40:00',1.76),('12664','2013-03-17','13:45:00',1.4),('12664','2013-03-17','13:50:00',1.94),('12664','2013-03-17','13:55:00',2.14),('12664','2013-03-17','14:00:00',2.1),('12664','2013-03-17','14:05:00',2.66),('12664','2013-03-17','14:10:00',2.65),('12664','2013-03-17','14:15:00',2.92),('12664','2013-03-17','14:20:00',2.27),('12664','2013-03-17','14:25:00',2.34),('12664','2013-03-17','14:30:00',2.74),('12664','2013-03-17','14:35:00',2.59),('12664','2013-03-17','14:40:00',1.79),('12664','2013-03-17','14:45:00',1.46),('12664','2013-03-17','14:50:00',1.32),('12664','2013-03-17','14:55:00',1.99),('12664','2013-03-17','15:00:00',1.95),('12664','2013-03-17','15:05:00',3.88),('12664','2013-03-17','15:10:00',3.95),('12664','2013-03-17','15:15:00',3.68),('12664','2013-03-17','15:20:00',2.09),('12664','2013-03-17','15:25:00',2.36),('12664','2013-03-17','15:30:00',1.51),('12664','2013-03-17','15:35:00',1.13),('12664','2013-03-17','15:40:00',1.25),('12664','2013-03-17','15:45:00',1.02),('12664','2013-03-16','07:50:00',1.36),('12664','2013-03-16','07:55:00',1.18),('12664','2013-03-16','08:00:00',1.58),('12664','2013-03-16','08:05:00',1.46),('12664','2013-03-16','08:10:00',2.03),('12664','2013-03-16','08:15:00',1.95),('12664','2013-03-16','08:20:00',2.44),('12664','2013-03-16','08:25:00',2.37),('12664','2013-03-16','08:30:00',2.45),('12664','2013-03-16','08:35:00',2.72),('12664','2013-03-16','08:40:00',2.99),('12664','2013-03-16','08:45:00',3.22),('12664','2013-03-16','08:50:00',2.11),('12664','2013-03-16','08:55:00',2.27),('12664','2013-03-16','09:00:00',3.25),('12664','2013-03-16','09:05:00',3.34),('12664','2013-03-16','09:10:00',3.33),('12664','2013-03-16','09:15:00',3.31),('12664','2013-03-16','09:20:00',3.38),('12664','2013-03-16','09:25:00',3.51),('12664','2013-03-16','09:30:00',3.42),('12664','2013-03-16','09:35:00',3.56),('12664','2013-03-16','09:40:00',3.7),('12664','2013-03-16','09:45:00',3.88),('12664','2013-03-16','09:50:00',3.35),('12664','2013-03-16','09:55:00',2.72),('12664','2013-03-16','10:00:00',2.57),('12664','2013-03-16','10:05:00',2.14),('12664','2013-03-16','10:10:00',2.28),('12664','2013-03-16','10:15:00',2.51),('12664','2013-03-16','10:20:00',2.3),('12664','2013-03-16','10:25:00',4.07),('12664','2013-03-16','10:30:00',4.26),('12664','2013-03-16','10:35:00',4.43),('12664','2013-03-16','10:40:00',4.42),('12664','2013-03-16','10:45:00',4.45),('12664','2013-03-16','10:50:00',4.47),('12664','2013-03-16','10:55:00',4.45),('12664','2013-03-16','11:00:00',4.49),('12664','2013-03-16','11:05:00',4.48),('12664','2013-03-16','11:10:00',4.54),('12664','2013-03-16','11:15:00',4.56),('12664','2013-03-16','11:20:00',4.55),('12664','2013-03-16','11:25:00',4.56),('12664','2013-03-16','11:30:00',4.58),('12664','2013-03-16','11:35:00',4.59),('12664','2013-03-16','11:40:00',4.6),('12664','2013-03-16','11:45:00',4.58),('12664','2013-03-16','11:50:00',4.65),('12664','2013-03-16','11:55:00',4.74),('12664','2013-03-16','12:00:00',4.69),('12664','2013-03-16','12:05:00',4.69),('12664','2013-03-16','12:10:00',4.74),('12664','2013-03-16','12:15:00',4.75),('12664','2013-03-16','12:20:00',4.8),('12664','2013-03-16','12:25:00',4.9),('12664','2013-03-16','12:30:00',5.03),('12664','2013-03-16','12:35:00',4.12),('12664','2013-03-16','12:40:00',5.02),('12664','2013-03-16','12:45:00',4.89),('12664','2013-03-16','12:50:00',2.01),('12664','2013-03-16','13:10:00',1.52),('12664','2013-03-16','13:15:00',2.64),('12664','2013-03-16','13:20:00',3.12),('12664','2013-03-16','13:25:00',4.84),('12664','2013-03-16','13:30:00',4.73),('12664','2013-03-16','13:35:00',4.83),('12664','2013-03-16','13:40:00',4.72),('12664','2013-03-16','13:45:00',4.29),('12664','2013-03-16','13:50:00',2.21),('12664','2013-03-16','13:55:00',4.51),('12664','2013-03-16','14:00:00',3.58),('12664','2013-03-16','14:05:00',4.12),('12664','2013-03-16','14:10:00',4.13),('12664','2013-03-16','14:15:00',2.34),('12664','2013-03-16','14:25:00',1.02),('12664','2013-03-16','14:30:00',3.04),('12664','2013-03-16','14:35:00',3),('12664','2013-03-16','15:10:00',3.4),('12664','2013-03-16','15:15:00',3.4),('12664','2013-03-16','15:20:00',3.24),('12664','2013-03-16','15:25:00',3.07),('12664','2013-03-16','15:30:00',2.74),('12664','2013-03-16','15:35:00',1.82),('12664','2013-03-16','15:40:00',2.67),('12664','2013-03-16','15:45:00',2.13),('12664','2013-03-16','15:50:00',2.59),('12664','2013-03-16','15:55:00',2.23),('12664','2013-03-16','16:05:00',1.85),('12664','2013-03-16','16:10:00',1.31),('12664','2013-03-16','16:15:00',2.31),('12664','2013-03-16','16:20:00',2.32),('12664','2013-03-16','16:25:00',2.14),('12664','2013-03-16','16:30:00',1.91),('12664','2013-03-16','16:35:00',1.79),('12664','2013-03-16','16:40:00',1.34),('12664','2013-03-16','16:55:00',1.05),('12664','2013-03-16','17:00:00',1.09),('12664','2013-03-15','10:25:00',1.23),('12664','2013-03-15','10:30:00',1.42),('12664','2013-03-15','10:35:00',1.39),('12664','2013-03-15','10:40:00',1.38),('12664','2013-03-15','10:45:00',1.18),('12664','2013-03-15','10:50:00',1.18),('12664','2013-03-15','10:55:00',1.59),('12664','2013-03-15','11:00:00',1.53),('12664','2013-03-15','11:05:00',1.25),('12664','2013-03-15','11:10:00',1.08),('12664','2013-03-15','11:15:00',1.03),('12664','2013-03-15','11:20:00',1.09),('12664','2013-03-15','11:25:00',1.17),('12664','2013-03-15','11:30:00',1.4),('12664','2013-03-15','11:35:00',1.69),('12664','2013-03-15','11:40:00',1.94),('12664','2013-03-15','11:45:00',1.59),('12664','2013-03-15','11:50:00',1.45),('12664','2013-03-15','11:55:00',1.85),('12664','2013-03-15','12:00:00',2.14),('12664','2013-03-15','12:05:00',1.89),('12664','2013-03-15','12:10:00',2.06),('12664','2013-03-15','12:15:00',2.39),('12664','2013-03-15','12:20:00',2.33),('12664','2013-03-15','12:25:00',2.09),('12664','2013-03-15','12:30:00',1.72),('12664','2013-03-15','12:35:00',1.58),('12664','2013-03-15','12:40:00',1.63),('12664','2013-03-15','12:45:00',1.61),('12664','2013-03-15','12:50:00',1.48),('12664','2013-03-15','12:55:00',1.4),('12664','2013-03-15','13:00:00',1.52),('12664','2013-03-15','13:05:00',1.68),('12664','2013-03-15','13:10:00',1.97),('12664','2013-03-15','13:15:00',2.61),('12664','2013-03-15','13:20:00',2.46),('12664','2013-03-15','13:25:00',1.84),('12664','2013-03-15','13:30:00',1.58),('12664','2013-03-15','13:35:00',1.36),('12664','2013-03-15','13:40:00',1.13),('12664','2013-03-15','13:45:00',1.04),('12664','2013-03-15','13:50:00',1.16),('12664','2013-03-15','13:55:00',1.18),('12664','2013-03-15','14:00:00',1.01),('12664','2013-03-15','14:35:00',1.2),('12664','2013-03-15','14:40:00',1.31),('12664','2013-03-15','14:45:00',1.34),('12664','2013-03-15','14:50:00',1.35),('12664','2013-03-15','14:55:00',1.32),('12664','2013-03-15','15:00:00',1.34),('12664','2013-03-15','15:05:00',1.29),('12664','2013-03-15','15:10:00',1.32),('12664','2013-03-15','15:15:00',1.4),('12664','2013-03-15','15:20:00',1.34),('12664','2013-03-15','15:25:00',1.2),('12664','2013-03-15','15:30:00',1.19),('12664','2013-03-15','15:35:00',1.1),('12664','2013-03-15','17:00:00',1.06),('12664','2013-03-14','12:30:00',1.08),('12664','2013-03-14','12:35:00',1.15),('12664','2013-03-14','12:40:00',1.24),('12664','2013-03-14','12:45:00',1.29),('12664','2013-03-14','12:50:00',1.35),('12664','2013-03-14','12:55:00',1.43),('12664','2013-03-14','13:00:00',1.35),('12664','2013-03-14','13:05:00',1.29),('12664','2013-03-14','13:10:00',1.4),('12664','2013-03-14','13:15:00',1.7),('12664','2013-03-14','13:20:00',1.84),('12664','2013-03-14','13:25:00',1.8),('12664','2013-03-14','13:30:00',1.79),('12664','2013-03-14','13:35:00',1.38),('12664','2013-03-14','13:40:00',1.52),('12664','2013-03-14','13:45:00',1.6),('12664','2013-03-14','13:50:00',1.35),('12664','2013-03-14','13:55:00',1.43),('12664','2013-03-14','14:00:00',1.23),('12664','2013-03-14','14:05:00',1.55),('12664','2013-03-14','14:10:00',1.51),('12664','2013-03-14','14:15:00',1.58),('12664','2013-03-14','14:20:00',1.19),('12664','2013-03-14','15:15:00',1.05),('12664','2013-03-13','09:15:00',1.33),('12664','2013-03-13','09:20:00',1.55),('12664','2013-03-13','09:25:00',1.41),('12664','2013-03-13','09:30:00',1.25),('12664','2013-03-13','10:40:00',3.14),('12664','2013-03-13','10:45:00',3.15),('12664','2013-03-13','10:50:00',2.68),('12664','2013-03-13','10:55:00',1.81),('12664','2013-03-13','11:10:00',1.26),('12664','2013-03-13','11:15:00',1.34),('12664','2013-03-13','11:30:00',1.49),('12664','2013-03-13','11:35:00',1.87),('12664','2013-03-13','11:40:00',1.67),('12664','2013-03-13','11:45:00',1.64),('12664','2013-03-13','11:50:00',1.63),('12664','2013-03-13','11:55:00',1.43),('12664','2013-03-13','12:40:00',1.08),('12664','2013-03-13','12:45:00',1.12),('12664','2013-03-13','12:50:00',1.2),('12664','2013-03-13','12:55:00',1.23),('12664','2013-03-13','13:00:00',1.17),('12664','2013-03-13','13:05:00',1.12),('12664','2013-03-13','13:10:00',1.11),('12664','2013-03-13','13:30:00',1.08),('12664','2013-03-13','13:35:00',1.29),('12664','2013-03-13','13:40:00',1.77),('12664','2013-03-13','13:45:00',1.49),('12664','2013-03-13','13:50:00',1.25),('12664','2013-03-12','08:15:00',2.12),('12664','2013-03-12','08:25:00',2),('12664','2013-03-12','08:30:00',2.27),('12664','2013-03-12','08:35:00',2.15),('12664','2013-03-12','08:40:00',2.29),('12664','2013-03-12','08:45:00',2.52),('12664','2013-03-12','08:50:00',2.57),('12664','2013-03-12','08:55:00',2.74),('12664','2013-03-12','09:00:00',2.82),('12664','2013-03-12','09:05:00',2.89),('12664','2013-03-12','09:10:00',2.98),('12664','2013-03-12','09:15:00',3.08),('12664','2013-03-12','09:20:00',3.17),('12664','2013-03-12','09:25:00',3.25),('12664','2013-03-12','09:30:00',3.33),('12664','2013-03-12','09:35:00',3.42),('12664','2013-03-12','09:40:00',3.49),('12664','2013-03-12','09:45:00',3.48),('12664','2013-03-12','09:50:00',3.02),('12664','2013-03-12','09:55:00',3.09),('12664','2013-03-12','10:00:00',3.13),('12664','2013-03-12','10:05:00',3.01),('12664','2013-03-12','10:10:00',2.99),('12664','2013-03-12','10:15:00',3.41),('12664','2013-03-12','10:20:00',4.38),('12664','2013-03-12','10:25:00',3.39),('12664','2013-03-12','10:30:00',4.03),('12664','2013-03-12','10:35:00',3.66),('12664','2013-03-12','10:40:00',4.34),('12664','2013-03-12','10:45:00',4.09),('12664','2013-03-12','10:50:00',3.71),('12664','2013-03-12','10:55:00',4.48),('12664','2013-03-12','11:00:00',4.49),('12664','2013-03-12','11:05:00',2.63),('12664','2013-03-12','11:10:00',4.16),('12664','2013-03-12','11:15:00',4.3),('12664','2013-03-12','11:20:00',3.49),('12664','2013-03-12','11:25:00',1.47),('12664','2013-03-12','11:35:00',2.45),('12664','2013-03-12','11:40:00',1.79),('12664','2013-03-12','11:45:00',1.62),('12664','2013-03-12','11:50:00',4.71),('12664','2013-03-12','11:55:00',5),('12664','2013-03-12','12:00:00',3),('12664','2013-03-12','12:05:00',1.42),('12664','2013-03-12','12:15:00',1.4),('12664','2013-03-12','12:20:00',2.02),('12664','2013-03-12','12:25:00',2.55),('12664','2013-03-12','12:30:00',2.4),('12664','2013-03-12','12:35:00',2.77),('12664','2013-03-12','12:40:00',3.26),('12664','2013-03-12','12:45:00',4.31),('12664','2013-03-12','12:50:00',1.59),('12664','2013-03-12','12:55:00',2.77),('12664','2013-03-12','13:00:00',3.85),('12664','2013-03-12','13:05:00',3.36),('12664','2013-03-12','13:10:00',3.14),('12664','2013-03-12','13:15:00',2.05),('12664','2013-03-12','13:20:00',2.38),('12664','2013-03-12','13:25:00',1.75),('12664','2013-03-12','13:30:00',3.27),('12664','2013-03-12','13:35:00',2.45),('12664','2013-03-12','13:40:00',2.82),('12664','2013-03-12','13:45:00',3.74),('12664','2013-03-12','13:50:00',4),('12664','2013-03-12','13:55:00',2.91),('12664','2013-03-12','14:00:00',3.35),('12664','2013-03-12','14:05:00',2.8),('12664','2013-03-12','14:10:00',3.81),('12664','2013-03-12','14:15:00',2.45),('12664','2013-03-12','14:20:00',3.45),('12664','2013-03-12','14:25:00',2.82),('12664','2013-03-12','14:55:00',2.24),('12664','2013-03-12','15:00:00',2.23),('12664','2013-03-12','15:05:00',1.66),('12664','2013-03-12','15:10:00',2.13),('12664','2013-03-12','15:15:00',1.79),('12664','2013-03-12','15:20:00',2.03),('12664','2013-03-12','15:25:00',1.17),('12664','2014-03-24','08:45:00',1.57),('12664','2014-03-24','08:50:00',1.44),('12664','2014-03-24','09:15:00',3.24),('12664','2014-03-24','09:20:00',1.72),('12664','2014-03-24','09:25:00',1.95),('12664','2014-03-24','09:30:00',1.05),('12664','2014-03-24','09:35:00',3.16),('12664','2014-03-24','09:40:00',1.22),('12664','2014-03-24','09:45:00',1.17),('12664','2014-03-24','09:55:00',3.1),('12664','2014-03-24','10:00:00',3.9),('12664','2014-03-24','10:05:00',1.63),('12664','2014-03-24','10:10:00',1.49),('12664','2014-03-24','10:15:00',1.14),('12664','2014-03-24','10:20:00',2.51),('12664','2014-03-24','10:25:00',1.76),('12664','2014-03-24','10:30:00',2.04),('12664','2014-03-24','10:35:00',1.42),('12664','2014-03-24','10:40:00',1.65),('12664','2014-03-24','10:45:00',3.42),('12664','2014-03-24','10:50:00',4.34),('12664','2014-03-24','10:55:00',4.12),('12664','2014-03-24','11:00:00',3.3),('12664','2014-03-24','11:05:00',3.71),('12664','2014-03-24','11:10:00',3.19),('12664','2014-03-24','11:15:00',3.67),('12664','2014-03-24','11:20:00',3.68),('12664','2014-03-24','11:25:00',4),('12664','2014-03-24','11:30:00',1.37),('12664','2014-03-24','12:20:00',1.1),('12664','2014-03-24','12:25:00',1.6),('12664','2014-03-24','12:30:00',2),('12664','2014-03-24','12:35:00',1.82),('12664','2014-03-24','12:40:00',1.4),('12664','2014-03-24','12:45:00',1.41),('12664','2014-03-24','12:50:00',1.4),('12664','2014-03-24','12:55:00',1.4),('12664','2014-03-24','13:00:00',1.47),('12664','2014-03-24','13:05:00',1.5),('12664','2014-03-24','13:10:00',1.99),('12664','2014-03-24','13:15:00',2.3),('12664','2014-03-24','13:20:00',2.29),('12664','2014-03-24','13:25:00',2.21),('12664','2014-03-24','13:30:00',1.91),('12664','2014-03-24','13:35:00',1.29),('12664','2014-03-24','13:40:00',1.16),('12664','2014-03-24','13:45:00',1.13),('12664','2014-03-24','14:00:00',1.12),('12664','2014-03-24','14:05:00',1.21),('12664','2014-03-24','14:10:00',1.45),('12664','2014-03-24','14:15:00',2.04),('12664','2014-03-24','14:20:00',2.45),('12664','2014-03-24','14:25:00',2.14),('12664','2014-03-24','14:30:00',2.55),('12664','2014-03-24','14:35:00',2.71),('12664','2014-03-24','14:40:00',2.41),('12664','2014-03-24','14:45:00',1.96),('12664','2014-03-24','14:50:00',2.35),('12664','2014-03-24','14:55:00',1.58),('12664','2014-03-24','15:00:00',2.38),('12664','2014-03-24','15:05:00',2.33),('12664','2014-03-24','15:10:00',1.95),('12664','2014-03-24','15:15:00',1.94),('12664','2014-03-24','15:20:00',1.99),('12664','2014-03-24','15:25:00',1.65),('12664','2014-03-24','15:30:00',1.57),('12664','2014-03-24','15:35:00',1.15),('12664','2014-03-24','15:40:00',1.02),('12664','2014-03-24','15:45:00',1.19),('12664','2014-03-24','15:50:00',1.91),('12664','2014-03-24','15:55:00',1.01),('12664','2013-03-11','08:00:00',1.12),('12664','2013-03-11','08:05:00',1.65),('12664','2013-03-11','08:10:00',1.78),('12664','2013-03-11','08:15:00',1.98),('12664','2013-03-11','08:20:00',2.03),('12664','2013-03-11','08:25:00',2.07),('12664','2013-03-11','08:30:00',2.21),('12664','2013-03-11','08:35:00',2.15),('12664','2013-03-11','08:40:00',1.47),('12664','2013-03-11','08:45:00',1.8),('12664','2013-03-11','08:50:00',2.64),('12664','2013-03-11','08:55:00',2.65),('12664','2013-03-11','09:00:00',3),('12664','2013-03-11','09:05:00',3.11),('12664','2013-03-11','09:10:00',3),('12664','2013-03-11','09:15:00',3.07),('12664','2013-03-11','09:20:00',2.81),('12664','2013-03-11','09:25:00',3.61),('12664','2013-03-11','09:30:00',3.19),('12664','2013-03-11','09:35:00',3.77),('12664','2013-03-11','09:40:00',3.46),('12664','2013-03-11','09:45:00',2.87),('12664','2013-03-11','09:50:00',1.49),('12664','2013-03-11','09:55:00',1.25),('12664','2013-03-11','10:00:00',1.53),('12664','2013-03-11','10:05:00',2.13),('12664','2013-03-11','10:10:00',1.83),('12664','2013-03-11','10:15:00',1.62),('12664','2013-03-11','10:20:00',1.78),('12664','2013-03-11','10:25:00',1.91),('12664','2013-03-11','10:30:00',2.27),('12664','2013-03-11','10:35:00',2.98),('12664','2013-03-11','10:40:00',2.23),('12664','2013-03-11','10:45:00',3.86),('12664','2013-03-11','10:50:00',3.18),('12664','2013-03-11','10:55:00',2.11),('12664','2013-03-11','11:00:00',2.02),('12664','2013-03-11','11:05:00',1.71),('12664','2013-03-11','11:10:00',1.7),('12664','2013-03-11','11:15:00',1.77),('12664','2013-03-11','11:20:00',1.42),('12664','2013-03-11','11:25:00',1.34),('12664','2013-03-11','11:30:00',1.55),('12664','2013-03-11','11:35:00',1.69),('12664','2013-03-11','11:40:00',1.92),('12664','2013-03-11','11:45:00',2.57),('12664','2013-03-11','11:50:00',2.4),('12664','2013-03-11','11:55:00',2.81),('12664','2013-03-11','12:00:00',2.04),('12664','2013-03-11','12:05:00',2.69),('12664','2013-03-11','12:10:00',2.96),('12664','2013-03-11','12:15:00',3.99),('12664','2013-03-11','12:20:00',4.52),('12664','2013-03-11','12:25:00',3.54),('12664','2013-03-11','12:30:00',4.43),('12664','2013-03-11','12:35:00',4.61),('12664','2013-03-11','12:40:00',3.28),('12664','2013-03-11','12:45:00',4.36),('12664','2013-03-11','12:50:00',5.02),('12664','2013-03-11','12:55:00',4.75),('12664','2013-03-11','13:00:00',4.88),('12664','2013-03-11','13:05:00',3.88),('12664','2013-03-11','13:10:00',4.61),('12664','2013-03-11','13:15:00',4.21),('12664','2013-03-11','13:20:00',4.39),('12664','2013-03-11','13:25:00',4.51),('12664','2013-03-11','13:30:00',4.44),('12664','2013-03-11','13:35:00',4),('12664','2013-03-11','13:40:00',1.66),('12664','2013-03-11','13:45:00',4.69),('12664','2013-03-11','13:50:00',4.43),('12664','2013-03-11','13:55:00',4.32),('12664','2013-03-11','14:00:00',4.17),('12664','2013-03-11','14:05:00',4.25),('12664','2013-03-11','14:10:00',4.31),('12664','2013-03-11','14:15:00',4.19),('12664','2013-03-11','14:20:00',4.15),('12664','2013-03-11','14:25:00',3.75),('12664','2013-03-11','14:30:00',2.87),('12664','2013-03-11','14:35:00',4.05),('12664','2013-03-11','14:40:00',3.78),('12664','2013-03-11','14:45:00',3.67),('12664','2013-03-11','14:50:00',3.63),('12664','2013-03-11','14:55:00',2.72),('12664','2013-03-11','15:00:00',3.41),('12664','2013-03-11','15:05:00',3.4),('12664','2013-03-11','15:10:00',3.35),('12664','2013-03-11','15:15:00',3.19),('12664','2013-03-11','15:20:00',3.11),('12664','2013-03-11','15:25:00',2.91),('12664','2013-03-11','15:30:00',3.1),('12664','2013-03-11','15:35:00',2.91),('12664','2013-03-11','15:40:00',2.74),('12664','2013-03-11','15:45:00',2.71),('12664','2013-03-11','15:50:00',2.42),('12664','2013-03-11','15:55:00',2.24),('12664','2013-03-11','16:00:00',1.99),('12664','2013-03-11','16:05:00',1.85),('12664','2013-03-11','16:10:00',1.7),('12664','2013-03-11','16:15:00',1.84),('12664','2013-03-11','16:20:00',1.71),('12664','2013-03-11','16:25:00',1.57),('12664','2013-03-11','16:30:00',1.46),('12664','2013-03-10','07:40:00',1.07),('12664','2013-03-10','07:45:00',1.19),('12664','2013-03-10','07:50:00',1.31),('12664','2013-03-10','07:55:00',1.44),('12664','2013-03-10','08:00:00',1.57),('12664','2013-03-10','08:05:00',1.67),('12664','2013-03-10','08:10:00',1.67),('12664','2013-03-10','08:15:00',1.86),('12664','2013-03-10','08:20:00',2),('12664','2013-03-10','08:25:00',2.1),('12664','2013-03-10','08:30:00',2.21),('12664','2013-03-10','08:35:00',2.15),('12664','2013-03-10','08:40:00',2.4),('12664','2013-03-10','08:45:00',2.51),('12664','2013-03-10','08:50:00',2.61),('12664','2013-03-10','08:55:00',2.68),('12664','2013-03-10','09:00:00',2.78),('12664','2013-03-10','09:05:00',2.86),('12664','2013-03-10','09:10:00',2.93),('12664','2013-03-10','09:15:00',3.05),('12664','2013-03-10','09:20:00',3.14),('12664','2013-03-10','09:25:00',3.22),('12664','2013-03-10','09:30:00',3.33),('12664','2013-03-10','09:35:00',3.49),('12664','2013-03-10','09:40:00',3.68),('12664','2013-03-10','09:45:00',3.61),('12664','2013-03-10','09:50:00',3.62),('12664','2013-03-10','09:55:00',3.64),('12664','2013-03-10','10:00:00',3.63),('12664','2013-03-10','10:05:00',3.74),('12664','2013-03-10','10:10:00',3.81),('12664','2013-03-10','10:15:00',3.47),('12664','2013-03-10','10:20:00',3.89),('12664','2013-03-10','10:25:00',3.28),('12664','2013-03-10','10:30:00',1.56),('12664','2013-03-10','10:35:00',3.52),('12664','2013-03-10','10:40:00',1.3),('12664','2013-03-10','10:45:00',4.09),('12664','2013-03-10','10:50:00',3.97),('12664','2013-03-10','10:55:00',4.33),('12664','2013-03-10','11:00:00',4.29),('12664','2013-03-10','11:05:00',3.52),('12664','2013-03-10','11:10:00',3.72),('12664','2013-03-10','11:15:00',4.34),('12664','2013-03-10','11:20:00',4.38),('12664','2013-03-10','11:25:00',3.39),('12664','2013-03-10','11:30:00',3.97),('12664','2013-03-10','11:35:00',3.4),('12664','2013-03-10','11:40:00',2.17),('12664','2013-03-10','11:45:00',4.56),('12664','2013-03-10','11:50:00',4.53),('12664','2013-03-10','11:55:00',4.53),('12664','2013-03-10','12:00:00',3.81),('12664','2013-03-10','12:05:00',4.59),('12664','2013-03-10','12:10:00',4.29),('12664','2013-03-10','12:15:00',4.5),('12664','2013-03-10','12:20:00',3.56),('12664','2013-03-10','12:25:00',4.66),('12664','2013-03-10','12:30:00',4.52),('12664','2013-03-10','12:35:00',4.19),('12664','2013-03-10','12:40:00',4.36),('12664','2013-03-10','12:45:00',2.87),('12664','2013-03-10','12:50:00',4.55),('12664','2013-03-10','12:55:00',4.96),('12664','2013-03-10','13:00:00',4.7),('12664','2013-03-10','13:05:00',4.57),('12664','2013-03-10','13:10:00',3.89),('12664','2013-03-10','13:15:00',3.34),('12664','2013-03-10','13:20:00',4.69),('12664','2013-03-10','13:25:00',4.39),('12664','2013-03-10','13:30:00',3.44),('12664','2013-03-10','13:35:00',2.75),('12664','2013-03-10','13:40:00',2.71),('12664','2013-03-10','13:45:00',2.13),('12664','2013-03-10','13:50:00',1.83),('12664','2013-03-10','13:55:00',1.67),('12664','2013-03-10','14:00:00',1.52),('12664','2013-03-10','14:05:00',1.75),('12664','2013-03-10','14:10:00',1.79),('12664','2013-03-10','14:15:00',1.81),('12664','2013-03-10','14:20:00',1.88),('12664','2013-03-10','14:25:00',2.1),('12664','2013-03-10','14:30:00',1.68),('12664','2013-03-10','14:35:00',1.6),('12664','2013-03-10','14:40:00',1.75),('12664','2013-03-10','14:45:00',1.43),('12664','2013-03-10','14:50:00',1.54),('12664','2013-03-10','14:55:00',1.09),('12664','2013-03-10','15:15:00',1.11),('12664','2013-03-09','07:45:00',1.15),('12664','2013-03-09','08:05:00',1.59),('12664','2013-03-09','08:10:00',1.7),('12664','2013-03-09','08:15:00',1.84),('12664','2013-03-09','08:20:00',2.11),('12664','2013-03-09','08:25:00',2.1),('12664','2013-03-09','08:30:00',2.16),('12664','2013-03-09','08:35:00',2.25),('12664','2013-03-09','08:40:00',2.36),('12664','2013-03-09','08:45:00',2.46),('12664','2013-03-09','08:50:00',2.55),('12664','2013-03-09','08:55:00',2.65),('12664','2013-03-09','09:00:00',2.67),('12664','2013-03-09','09:05:00',1.7),('12664','2013-03-09','09:10:00',1.45),('12664','2013-03-09','09:15:00',1.68),('12664','2013-03-09','09:20:00',3.57),('12664','2013-03-09','09:25:00',1.84),('12664','2013-03-09','09:30:00',1.09),('12664','2013-03-09','09:35:00',1.73),('12664','2013-03-09','09:40:00',2.02),('12664','2013-03-09','09:45:00',3.16),('12664','2013-03-09','09:50:00',3.52),('12664','2013-03-09','09:55:00',1.16),('12664','2013-03-09','10:00:00',1.2),('12664','2013-03-09','10:05:00',1.04),('12664','2013-03-09','10:10:00',3.97),('12664','2013-03-09','10:15:00',1.98),('12664','2013-03-09','10:20:00',3.1),('12664','2013-03-09','10:25:00',1.91),('12664','2013-03-09','10:30:00',1.54),('12664','2013-03-09','10:35:00',2.56),('12664','2013-03-09','10:40:00',4.76),('12664','2013-03-09','10:45:00',4.59),('12664','2013-03-09','10:50:00',4.28),('12664','2013-03-09','10:55:00',4.23),('12664','2013-03-09','11:00:00',4.23),('12664','2013-03-09','11:05:00',4.35),('12664','2013-03-09','11:10:00',4.35),('12664','2013-03-09','11:15:00',4.43),('12664','2013-03-09','11:20:00',4.48),('12664','2013-03-09','11:25:00',4.44),('12664','2013-03-09','11:30:00',4.49),('12664','2013-03-09','11:35:00',4.26),('12664','2013-03-09','11:40:00',4.38),('12664','2013-03-09','11:45:00',4.43),('12664','2013-03-09','11:50:00',4.5),('12664','2013-03-09','11:55:00',4.45),('12664','2013-03-09','12:00:00',4.44),('12664','2013-03-09','12:05:00',4.52),('12664','2013-03-09','12:10:00',3.96),('12664','2013-03-09','12:15:00',3.56),('12664','2013-03-09','12:20:00',3.59),('12664','2013-03-09','12:25:00',3.71),('12664','2013-03-09','12:30:00',2.58),('12664','2013-03-09','12:35:00',2.58),('12664','2013-03-09','12:40:00',4.85),('12664','2013-03-09','12:45:00',4.3),('12664','2013-03-09','12:50:00',4.6),('12664','2013-03-09','12:55:00',4.27),('12664','2013-03-09','13:00:00',4.38),('12664','2013-03-09','13:05:00',4.35),('12664','2013-03-09','13:10:00',4.4),('12664','2013-03-09','13:15:00',3.74),('12664','2013-03-09','13:20:00',3.67),('12664','2013-03-09','13:25:00',4.44),('12664','2013-03-09','13:30:00',4.21),('12664','2013-03-09','13:35:00',4.15),('12664','2013-03-09','13:40:00',4.16),('12664','2013-03-09','13:45:00',4.12),('12664','2013-03-09','13:50:00',3.55),('12664','2013-03-09','13:55:00',4.11),('12664','2013-03-09','14:00:00',3.97),('12664','2013-03-09','14:05:00',3.88),('12664','2013-03-09','14:10:00',3.81),('12664','2013-03-09','14:15:00',3.28),('12664','2013-03-09','14:20:00',3.78),('12664','2013-03-09','14:25:00',2.09),('12664','2013-03-09','14:30:00',2.66),('12664','2013-03-09','14:35:00',1.72),('12664','2013-03-09','14:40:00',3.74),('12664','2013-03-09','14:45:00',3.07),('12664','2013-03-09','14:50:00',1.66),('12664','2013-03-09','14:55:00',3.39),('12664','2013-03-09','15:00:00',3.23),('12664','2013-03-09','15:05:00',3.16),('12664','2013-03-09','15:10:00',3.06),('12664','2013-03-09','15:15:00',2.99),('12664','2013-03-09','15:20:00',2.91),('12664','2013-03-09','15:25:00',2.81),('12664','2013-03-09','15:30:00',2.7),('12664','2013-03-09','15:35:00',2.63),('12664','2013-03-09','15:40:00',2.56),('12664','2013-03-09','15:45:00',2.46),('12664','2013-03-09','15:50:00',2.34),('12664','2013-03-09','15:55:00',2.16),('12664','2013-03-09','16:00:00',1.82),('12664','2013-03-09','16:05:00',1.64),('12664','2013-03-09','16:10:00',1.69),('12664','2013-03-09','16:15:00',1.14),('12664','2013-03-09','16:25:00',1.03),('12664','2013-03-09','16:40:00',1.17),('12664','2013-03-08','08:25:00',1.24),('12664','2013-03-08','08:30:00',1.63),('12664','2013-03-08','09:10:00',1.57),('12664','2013-03-08','09:15:00',2.88),('12664','2013-03-08','09:20:00',3.49),('12664','2013-03-08','09:25:00',3.13),('12664','2013-03-08','09:30:00',2.67),('12664','2013-03-08','09:35:00',3.75),('12664','2013-03-08','09:40:00',1.8),('12664','2013-03-08','09:45:00',1.96),('12664','2013-03-08','09:50:00',1.71),('12664','2013-03-08','09:55:00',2.65),('12664','2013-03-08','10:00:00',3.02),('12664','2013-03-08','10:05:00',1.24),('12664','2013-03-08','10:10:00',1.74),('12664','2013-03-08','10:15:00',1.41),('12664','2013-03-08','10:45:00',1.36),('12664','2013-03-08','10:50:00',1.07),('12664','2013-03-08','12:20:00',1.24),('12664','2013-03-08','12:25:00',1.2),('12664','2013-03-08','12:30:00',1.24),('12664','2013-03-08','12:35:00',1.81),('12664','2013-03-08','12:40:00',1.95),('12664','2013-03-08','12:45:00',1.88),('12664','2013-03-08','12:50:00',2.44),('12664','2013-03-08','12:55:00',2.79),('12664','2013-03-08','13:00:00',2.03),('12664','2013-03-08','13:05:00',1.67),('12664','2013-03-08','13:10:00',1.6),('12664','2013-03-08','13:15:00',1.51),('12664','2013-03-08','13:20:00',1.21),('12664','2013-03-08','13:25:00',1.33),('12664','2013-03-08','13:30:00',1.79),('12664','2013-03-08','13:35:00',1.51),('12664','2013-03-08','13:40:00',1.24),('12664','2013-03-08','13:45:00',1.31),('12664','2013-03-08','13:50:00',1.1),('12664','2013-03-07','10:40:00',1.92),('12664','2013-03-07','10:45:00',2.1),('12664','2013-03-07','10:50:00',1.68),('12664','2013-03-07','10:55:00',2.07),('12664','2013-03-07','11:00:00',1.41),('12664','2013-03-07','11:05:00',1.07),('12664','2013-03-07','11:35:00',1.8),('12664','2013-03-07','11:40:00',3.39),('12664','2013-03-07','11:45:00',2.37),('12664','2013-03-07','11:50:00',1.79),('12664','2013-03-07','11:55:00',1.46),('12664','2013-03-07','12:00:00',1.58),('12664','2013-03-07','12:05:00',1.26),('12664','2013-03-07','12:15:00',1.09),('12664','2013-03-07','12:20:00',1.26),('12664','2013-03-07','12:25:00',1.52),('12664','2013-03-07','12:30:00',1.45),('12664','2013-03-07','12:35:00',1.39),('12664','2013-03-07','12:50:00',1.22),('12664','2013-03-07','12:55:00',1.67),('12664','2013-03-07','13:00:00',2.51),('12664','2013-03-07','13:05:00',2.6),('12664','2013-03-07','13:10:00',2.83),('12664','2013-03-07','13:15:00',2.27),('12664','2013-03-07','13:20:00',1.3),('12664','2013-03-07','13:25:00',1.36),('12664','2013-03-07','13:30:00',1.58),('12664','2013-03-07','13:35:00',1.61),('12664','2013-03-07','13:40:00',1.33),('12664','2013-03-07','14:05:00',1.27),('12664','2013-03-07','14:10:00',1.05),('12664','2013-03-07','14:20:00',1.06),('12664','2013-03-07','15:20:00',1.17),('12664','2013-03-07','15:25:00',1),('12664','2013-03-07','16:30:00',1.29),('12664','2013-03-07','16:35:00',1),('12664','2013-03-05','08:05:00',1.06),('12664','2013-03-05','08:10:00',1.28),('12664','2013-03-05','08:15:00',1.55),('12664','2013-03-05','08:25:00',1.65),('12664','2013-03-05','08:30:00',1.45),('12664','2013-03-05','08:35:00',1.92),('12664','2013-03-05','08:40:00',2),('12664','2013-03-05','08:45:00',1.78),('12664','2013-03-05','08:50:00',2.09),('12664','2013-03-05','08:55:00',1.81),('12664','2013-03-05','09:00:00',1.59),('12664','2013-03-05','09:05:00',1.48),('12664','2013-03-05','09:10:00',1.43),('12664','2013-03-05','09:15:00',1.47),('12664','2013-03-05','09:20:00',1.51),('12664','2013-03-05','09:25:00',1.48),('12664','2013-03-05','09:30:00',1.62),('12664','2013-03-05','09:35:00',1.67),('12664','2013-03-05','09:40:00',1.76),('12664','2013-03-05','09:45:00',1.75),('12664','2013-03-05','09:50:00',1.76),('12664','2013-03-05','09:55:00',2.16),('12664','2013-03-05','10:00:00',2.18),('12664','2013-03-05','10:05:00',1.82),('12664','2013-03-05','10:10:00',1.7),('12664','2013-03-05','10:15:00',1.87),('12664','2013-03-05','10:20:00',2.16),('12664','2013-03-05','10:25:00',1.8),('12664','2013-03-05','10:30:00',1.76),('12664','2013-03-05','10:35:00',2.08),('12664','2013-03-05','10:40:00',2.62),('12664','2013-03-05','10:45:00',2.74),('12664','2013-03-05','10:50:00',3.07),('12664','2013-03-05','10:55:00',2.98),('12664','2013-03-05','11:00:00',2.97),('12664','2013-03-05','11:05:00',3.05),('12664','2013-03-05','11:10:00',3.08),('12664','2013-03-05','11:15:00',2.76),('12664','2013-03-05','11:20:00',2.75),('12664','2013-03-05','11:25:00',2.68),('12664','2013-03-05','11:30:00',2.82),('12664','2013-03-05','11:35:00',3.24),('12664','2013-03-05','11:40:00',3.26),('12664','2013-03-05','11:45:00',3.4),('12664','2013-03-05','11:50:00',3.53),('12664','2013-03-05','11:55:00',3.5),('12664','2013-03-05','12:00:00',3.65),('12664','2013-03-05','12:05:00',3.73),('12664','2013-03-05','12:10:00',3.51),('12664','2013-03-05','12:15:00',3.41),('12664','2013-03-05','12:20:00',3.62),('12664','2013-03-05','12:25:00',3.12),('12664','2013-03-05','12:30:00',3.1),('12664','2013-03-05','12:35:00',2.88),('12664','2013-03-05','12:40:00',2.81),('12664','2013-03-05','12:45:00',2.67),('12664','2013-03-05','12:50:00',2.45),('12664','2013-03-05','12:55:00',1.96),('12664','2013-03-05','13:00:00',1.74),('12664','2013-03-05','13:05:00',1.77),('12664','2013-03-05','13:10:00',1.93),('12664','2013-03-05','13:15:00',1.93),('12664','2013-03-05','13:20:00',1.77),('12664','2013-03-05','13:25:00',1.59),('12664','2013-03-05','13:30:00',1.42),('12664','2013-03-05','13:35:00',1.34),('12664','2013-03-05','13:40:00',1.23),('12664','2013-03-05','13:45:00',1.11),('12664','2013-03-05','13:50:00',1.09),('12664','2013-03-05','13:55:00',1.16),('12664','2013-03-05','14:00:00',1.19),('12664','2013-03-05','14:05:00',1.17),('12664','2013-03-05','14:10:00',1.09),('12664','2013-03-05','14:20:00',1.02),('12664','2013-03-05','14:25:00',1.05),('12664','2013-03-05','14:30:00',1.06),('12664','2013-03-05','14:35:00',1.05),('12664','2013-03-05','14:40:00',1.05),('12664','2013-03-05','14:45:00',1.06),('12664','2013-03-05','15:30:00',1),('12664','2013-03-05','15:35:00',1.08),('12664','2013-03-05','15:40:00',1.26),('12664','2013-03-05','15:45:00',1.29),('12664','2013-03-05','15:50:00',1.06),('12664','2013-03-04','07:50:00',1.08),('12664','2013-03-04','07:55:00',1.18),('12664','2013-03-04','08:00:00',1.3),('12664','2013-03-04','08:05:00',1.42),('12664','2013-03-04','08:10:00',1.53),('12664','2013-03-04','08:15:00',1.65),('12664','2013-03-04','08:20:00',1.75),('12664','2013-03-04','08:25:00',1.87),('12664','2013-03-04','08:30:00',1.95),('12664','2013-03-04','08:35:00',2.04),('12664','2013-03-04','08:40:00',2.15),('12664','2013-03-04','08:45:00',2.24),('12664','2013-03-04','08:50:00',2.34),('12664','2013-03-04','08:55:00',2.43),('12664','2013-03-04','09:00:00',2.5),('12664','2013-03-04','09:05:00',2.61),('12664','2013-03-04','09:10:00',2.7),('12664','2013-03-04','09:15:00',2.78),('12664','2013-03-04','09:20:00',2.83),('12664','2013-03-04','09:25:00',2.88),('12664','2013-03-04','09:30:00',2.96),('12664','2013-03-04','09:35:00',3.08),('12664','2013-03-04','09:40:00',3.18),('12664','2013-03-04','09:46:00',3.26),('12664','2013-03-04','09:50:00',3.32),('12664','2013-03-04','09:55:00',3.38),('12664','2013-03-04','10:00:00',3.43),('12664','2013-03-04','10:05:00',3.51),('12664','2013-03-04','10:10:00',3.56),('12664','2013-03-04','10:16:00',3.59),('12664','2013-03-04','10:20:00',3.62),('12664','2013-03-04','10:25:00',3.69),('12664','2013-03-04','10:30:00',3.6),('12664','2013-03-04','10:35:00',3.75),('12664','2013-03-04','10:40:00',3.73),('12664','2013-03-04','10:45:00',3.81),('12664','2013-03-04','10:50:00',3.85),('12664','2013-03-04','10:55:00',3.9),('12664','2013-03-04','11:00:00',3.98),('12664','2013-03-04','11:05:00',4.03),('12664','2013-03-04','11:10:00',4.05),('12664','2013-03-04','11:15:00',4.08),('12664','2013-03-04','11:20:00',4.11),('12664','2013-03-04','11:25:00',4.09),('12664','2013-03-04','11:30:00',4.07),('12664','2013-03-04','11:35:00',4.06),('12664','2013-03-04','11:40:00',4.11),('12664','2013-03-04','11:45:00',4.14),('12664','2013-03-04','11:50:00',4.15),('12664','2013-03-04','11:55:00',4.22),('12664','2013-03-04','12:00:00',4.21),('12664','2013-03-04','12:05:00',4.2),('12664','2013-03-04','12:10:00',4.17),('12664','2013-03-04','12:15:00',4.21),('12664','2013-03-04','12:20:00',4.2),('12664','2013-03-04','12:25:00',4.16),('12664','2013-03-04','12:30:00',4.11),('12664','2013-03-04','12:35:00',4.18),('12664','2013-03-04','12:40:00',4.19),('12664','2013-03-04','12:45:00',4.12),('12664','2013-03-04','12:50:00',4.13),('12664','2013-03-04','12:55:00',4.1),('12664','2013-03-04','13:00:00',4.06),('12664','2013-03-04','13:05:00',4.04),('12664','2013-03-04','13:10:00',4.03),('12664','2013-03-04','13:15:00',3.93),('12664','2013-03-04','13:20:00',4.04),('12664','2013-03-04','13:25:00',4.03),('12664','2013-03-04','13:30:00',4.13),('12664','2013-03-04','13:35:00',3.96),('12664','2013-03-04','13:40:00',3.83),('12664','2013-03-04','13:45:00',3.84),('12664','2013-03-04','13:50:00',3.76),('12664','2013-03-04','13:55:00',3.74),('12664','2013-03-04','14:00:00',3.68),('12664','2013-03-04','14:05:00',3.6),('12664','2013-03-04','14:10:00',3.58),('12664','2013-03-04','14:15:00',3.54),('12664','2013-03-04','14:20:00',3.45),('12664','2013-03-04','14:25:00',3.39),('12664','2013-03-04','14:30:00',3.31),('12664','2013-03-04','14:35:00',3.22),('12664','2013-03-04','14:40:00',3.19),('12664','2013-03-04','14:45:00',3.13),('12664','2013-03-04','14:50:00',3.06),('12664','2013-03-04','14:55:00',3.03),('12664','2013-03-04','15:00:00',2.97),('12664','2013-03-04','15:05:00',2.88),('12664','2013-03-04','15:10:00',2.82),('12664','2013-03-04','15:15:00',2.72),('12664','2013-03-04','15:20:00',2.63),('12664','2013-03-04','15:25:00',2.55),('12664','2013-03-04','15:30:00',2.47),('12664','2013-03-04','15:35:00',2.39),('12664','2013-03-04','15:40:00',2.3),('12664','2013-03-04','15:45:00',2.17),('12664','2013-03-04','15:50:00',2.1),('12664','2013-03-04','15:55:00',2.02),('12664','2013-03-04','16:00:00',1.92),('12664','2013-03-04','16:05:00',1.83),('12664','2013-03-04','16:10:00',1.74),('12664','2013-03-04','16:15:00',1.65),('12664','2013-03-04','16:20:00',1.57),('12664','2013-03-04','16:25:00',1.46),('12664','2013-03-04','16:30:00',1.34),('12664','2013-03-04','16:35:00',1.22),('12664','2013-03-04','16:40:00',1.11),('12664','2013-03-04','16:45:00',1.01),('12664','2013-03-03','07:45:00',1.1),('12664','2013-03-03','07:50:00',1.21),('12664','2013-03-03','07:55:00',1.33),('12664','2013-03-03','08:00:00',1.45),('12664','2013-03-03','08:05:00',1.57),('12664','2013-03-03','08:10:00',1.68),('12664','2013-03-03','08:15:00',1.8),('12664','2013-03-03','08:20:00',1.91),('12664','2013-03-03','08:25:00',2.02),('12664','2013-03-03','08:30:00',2.13),('12664','2013-03-03','08:35:00',2.24),('12664','2013-03-03','08:40:00',2.34),('12664','2013-03-03','08:45:00',2.45),('12664','2013-03-03','08:50:00',2.55),('12664','2013-03-03','08:55:00',2.64),('12664','2013-03-03','09:00:00',2.74),('12664','2013-03-03','09:05:00',2.83),('12664','2013-03-03','09:10:00',2.93),('12664','2013-03-03','09:15:00',3.02),('12664','2013-03-03','09:20:00',3.11),('12664','2013-03-03','09:25:00',3.18),('12664','2013-03-03','09:30:00',3.26),('12664','2013-03-03','09:35:00',3.32),('12664','2013-03-03','09:40:00',3.39),('12664','2013-03-03','09:45:00',3.45),('12664','2013-03-03','09:50:00',3.51),('12664','2013-03-03','09:55:00',3.57),('12664','2013-03-03','10:00:00',3.62),('12664','2013-03-03','10:05:00',3.72),('12664','2013-03-03','10:10:00',3.75),('12664','2013-03-03','10:15:00',3.79),('12664','2013-03-03','10:20:00',3.86),('12664','2013-03-03','10:25:00',3.92),('12664','2013-03-03','10:30:00',3.94),('12664','2013-03-03','10:35:00',3.98),('12664','2013-03-03','10:40:00',4.02),('12664','2013-03-03','10:45:00',4.08),('12664','2013-03-03','10:50:00',4.12),('12664','2013-03-03','10:55:00',4.14),('12664','2013-03-03','11:00:00',4.12),('12664','2013-03-03','11:05:00',4.13),('12664','2013-03-03','11:10:00',4.19),('12664','2013-03-03','11:15:00',4.23),('12664','2013-03-03','11:20:00',4.22),('12664','2013-03-03','11:25:00',4.26),('12664','2013-03-03','11:30:00',4.29),('12664','2013-03-03','11:35:00',4.29),('12664','2013-03-03','11:40:00',4.3),('12664','2013-03-03','11:45:00',4.3),('12664','2013-03-03','11:50:00',4.3),('12664','2013-03-03','11:55:00',4.28),('12664','2013-03-03','12:00:00',4.31),('12664','2013-03-03','12:05:00',4.31),('12664','2013-03-03','12:10:00',4.34),('12664','2013-03-03','12:15:00',4.35),('12664','2013-03-03','12:20:00',4.34),('12664','2013-03-03','12:25:00',4.32),('12664','2013-03-03','12:30:00',4.33),('12664','2013-03-03','12:35:00',4.31),('12664','2013-03-03','12:40:00',4.3),('12664','2013-03-03','12:45:00',4.3),('12664','2013-03-03','12:50:00',4.26),('12664','2013-03-03','12:55:00',4.24),('12664','2013-03-03','13:00:00',4.23),('12664','2013-03-03','13:05:00',4.21),('12664','2013-03-03','13:10:00',4.2),('12664','2013-03-03','13:15:00',4.16),('12664','2013-03-03','13:20:00',4.13),('12664','2013-03-03','13:25:00',4.13),('12664','2013-03-03','13:30:00',4.09),('12664','2013-03-03','13:35:00',4.07),('12664','2013-03-03','13:40:00',4.03),('12664','2013-03-03','13:45:00',3.99),('12664','2013-03-03','13:50:00',3.97),('12664','2013-03-03','13:55:00',3.92),('12664','2013-03-03','14:00:00',3.86),('12664','2013-03-03','14:05:00',3.82),('12664','2013-03-03','14:10:00',3.76),('12664','2013-03-03','14:15:00',3.7),('12664','2013-03-03','14:20:00',3.64),('12664','2013-03-03','14:25:00',3.61),('12664','2013-03-03','14:30:00',3.55),('12664','2013-03-03','14:35:00',3.48),('12664','2013-03-03','14:40:00',3.41),('12664','2013-03-03','14:45:00',3.35),('12664','2013-03-03','14:50:00',3.29),('12664','2013-03-03','14:55:00',3.21),('12664','2013-03-03','15:00:00',3.13),('12664','2013-03-03','15:05:00',3.06),('12664','2013-03-03','15:10:00',3.01),('12664','2013-03-03','15:15:00',2.9),('12664','2013-03-03','15:20:00',2.82),('12664','2013-03-03','15:25:00',2.74),('12664','2013-03-03','15:30:00',2.65),('12664','2013-03-03','15:35:00',2.57),('12664','2013-03-03','15:40:00',2.48),('12664','2013-03-03','15:45:00',2.4),('12664','2013-03-03','15:50:00',2.28),('12664','2013-03-03','15:55:00',2.18),('12664','2013-03-03','16:00:00',2.08),('12664','2013-03-03','16:05:00',1.98),('12664','2013-03-03','16:10:00',1.88),('12664','2013-03-03','16:15:00',1.78),('12664','2013-03-03','16:20:00',1.67),('12664','2013-03-03','16:25:00',1.55),('12664','2013-03-03','16:30:00',1.44),('12664','2013-03-03','16:35:00',1.32),('12664','2013-03-03','16:40:00',1.22),('12664','2013-03-03','16:45:00',1.11),('12664','2013-03-02','09:55:00',1.16),('12664','2013-03-02','10:00:00',1.1),('12664','2013-03-02','10:45:00',1.04),('12664','2013-03-02','10:50:00',1.18),('12664','2013-03-02','10:55:00',1.25),('12664','2013-03-02','11:00:00',1.34),('12664','2013-03-02','11:05:00',1.44),('12664','2013-03-02','11:10:00',1.53),('12664','2013-03-02','11:15:00',1.47),('12664','2013-03-02','11:20:00',1.73),('12664','2013-03-02','11:25:00',2.09),('12664','2013-03-02','11:30:00',2.15),('12664','2013-03-02','11:35:00',2.34),('12664','2013-03-02','11:40:00',2.76),('12664','2013-03-02','11:45:00',2.39),('12664','2013-03-02','11:50:00',3.12),('12664','2013-03-02','11:55:00',2.18),('12664','2013-03-02','12:00:00',3.52),('12664','2013-03-02','12:05:00',1.68),('12664','2013-03-02','12:10:00',1.45),('12664','2013-03-02','12:15:00',1.28),('12664','2013-03-02','12:20:00',1.31),('12664','2013-03-02','12:25:00',1.49),('12664','2013-03-02','12:30:00',1.45),('12664','2013-03-02','12:35:00',1.43),('12664','2013-03-02','12:40:00',1.44),('12664','2013-03-02','12:45:00',1.36),('12664','2013-03-02','12:50:00',1.29),('12664','2013-03-02','12:55:00',1.51),('12664','2013-03-02','13:00:00',1.11),('12664','2013-03-02','13:05:00',1.03),('12664','2013-03-02','13:20:00',1.01),('12664','2013-03-02','13:25:00',1.11),('12664','2013-03-02','13:30:00',1.2),('12664','2013-03-02','13:35:00',1.25),('12664','2013-03-02','13:40:00',1.26),('12664','2013-03-02','13:45:00',1.33),('12664','2013-03-02','13:50:00',1.33),('12664','2013-03-02','13:55:00',1.44),('12664','2013-03-02','14:00:00',1.63),('12664','2013-03-02','14:05:00',1.55),('12664','2013-03-02','14:10:00',1.23),('12664','2014-03-23','08:20:00',1.09),('12664','2014-03-23','08:25:00',1.14),('12664','2014-03-23','08:30:00',1.77),('12664','2014-03-23','08:50:00',1.49),('12664','2014-03-23','08:55:00',1.41),('12664','2014-03-23','09:00:00',2.17),('12664','2014-03-23','09:05:00',2.54),('12664','2014-03-23','09:10:00',2.35),('12664','2014-03-23','09:15:00',1.76),('12664','2014-03-23','09:25:00',1.04),('12664','2014-03-23','09:30:00',1.15),('12664','2014-03-23','10:20:00',1.23),('12664','2014-03-23','10:25:00',1.67),('12664','2014-03-23','10:35:00',1.57),('12664','2014-03-23','10:40:00',1.33),('12664','2014-03-23','10:45:00',1.4),('12664','2014-03-23','10:50:00',1.22),('12664','2014-03-23','11:05:00',1.2),('12664','2014-03-23','11:20:00',1.01),('12664','2014-03-23','11:25:00',1.11),('12664','2014-03-23','11:30:00',1.11),('12664','2014-03-23','11:35:00',1.07),('12664','2014-03-23','13:30:00',1.2),('12664','2014-03-23','13:35:00',2.2),('12664','2014-03-23','13:40:00',1.25),('12664','2014-03-23','13:45:00',1.14),('12664','2014-03-23','13:50:00',1.15),('12664','2014-03-23','14:50:00',1.04),('12664','2014-03-23','15:05:00',1.37),('12664','2014-03-23','15:10:00',1.56),('12664','2014-03-23','15:15:00',1.08),('12664','2013-03-01','07:55:00',1.02),('12664','2013-03-01','08:00:00',1.08),('12664','2013-03-01','08:05:00',1.08),('12664','2013-03-01','08:10:00',1.1),('12664','2013-03-01','08:15:00',1.11),('12664','2013-03-01','08:20:00',1.16),('12664','2013-03-01','08:25:00',1.23),('12664','2013-03-01','08:30:00',1.29),('12664','2013-03-01','08:35:00',1.45),('12664','2013-03-01','08:40:00',1.73),('12664','2013-03-01','08:45:00',1.82),('12664','2013-03-01','08:50:00',1.94),('12664','2013-03-01','08:55:00',2.07),('12664','2013-03-01','09:00:00',2.22),('12664','2013-03-01','09:05:00',2.35),('12664','2013-03-01','09:10:00',2.34),('12664','2013-03-01','09:15:00',2.36),('12664','2013-03-01','09:20:00',2.39),('12664','2013-03-01','09:25:00',2.39),('12664','2013-03-01','09:30:00',2.62),('12664','2013-03-01','09:35:00',2.7),('12664','2013-03-01','09:40:00',2.67),('12664','2013-03-01','09:45:00',2.77),('12664','2013-03-01','09:50:00',2.97),('12664','2013-03-01','09:55:00',2.94),('12664','2013-03-01','10:00:00',2.6),('12664','2013-03-01','10:05:00',2.29),('12664','2013-03-01','10:10:00',2.14),('12664','2013-03-01','10:15:00',2.17),('12664','2013-03-01','10:20:00',2.18),('12664','2013-03-01','10:25:00',2.26),('12664','2013-03-01','10:30:00',2.47),('12664','2013-03-01','10:35:00',2.76),('12664','2013-03-01','10:40:00',2.73),('12664','2013-03-01','10:45:00',2.39),('12664','2013-03-01','10:50:00',2.31),('12664','2013-03-01','10:55:00',2.22),('12664','2013-03-01','11:00:00',2.12),('12664','2013-03-01','11:05:00',2.03),('12664','2013-03-01','11:10:00',1.94),('12664','2013-03-01','11:15:00',2.04),('12664','2013-03-01','11:20:00',2.05),('12664','2013-03-01','11:25:00',1.96),('12664','2013-03-01','11:30:00',1.91),('12664','2013-03-01','11:35:00',1.82),('12664','2013-03-01','11:45:00',1.63),('12664','2013-03-01','11:50:00',1.58),('12664','2013-03-01','11:55:00',1.47),('12664','2013-03-01','12:00:00',1.37),('12664','2013-03-01','12:05:00',1.3),('12664','2013-03-01','12:10:00',1.22),('12664','2013-03-01','12:15:00',1.17),('12664','2013-03-01','12:20:00',1.15),('12664','2013-03-01','12:25:00',1.18),('12664','2013-03-01','12:30:00',1.21),('12664','2013-03-01','12:35:00',1.18),('12664','2013-03-01','12:40:00',1.19),('12664','2013-03-01','12:45:00',1.27),('12664','2013-03-01','12:50:00',1.37),('12664','2013-03-01','12:55:00',1.42),('12664','2013-03-01','13:00:00',1.45),('12664','2013-03-01','13:05:00',1.47),('12664','2013-03-01','13:10:00',1.52),('12664','2013-03-01','13:15:00',1.62),('12664','2013-03-01','13:20:00',1.82),('12664','2013-03-01','13:25:00',1.81),('12664','2013-03-01','13:30:00',1.67),('12664','2013-03-01','13:35:00',1.52),('12664','2013-03-01','13:40:00',1.45),('12664','2013-03-01','13:45:00',1.49),('12664','2013-03-01','13:50:00',1.49),('12664','2013-03-01','13:55:00',1.45),('12664','2013-03-01','14:00:00',1.37),('12664','2013-03-01','14:05:00',1.28),('12664','2013-03-01','14:10:00',1.22),('12664','2013-03-01','14:15:00',1.2),('12664','2013-03-01','14:20:00',1.19),('12664','2013-03-01','14:25:00',1.19),('12664','2013-03-01','14:30:00',1.18),('12664','2013-03-01','14:35:00',1.13),('12664','2013-03-01','14:40:00',1.08),('12664','2013-03-01','14:45:00',1.04),('12664','2013-03-01','14:50:00',1.01),('12664','2013-02-28','08:00:00',1.07),('12664','2013-02-28','08:05:00',1.19),('12664','2013-02-28','08:10:00',1.29),('12664','2013-02-28','08:15:00',1.41),('12664','2013-02-28','08:20:00',1.53),('12664','2013-02-28','08:25:00',1.65),('12664','2013-02-28','08:30:00',1.76),('12664','2013-02-28','08:35:00',1.87),('12664','2013-02-28','08:40:00',1.97),('12664','2013-02-28','08:45:00',2.06),('12664','2013-02-28','08:50:00',2.18),('12664','2013-02-28','08:55:00',2.27),('12664','2013-02-28','09:00:00',2.37),('12664','2013-02-28','09:05:00',2.46),('12664','2013-02-28','09:10:00',2.55),('12664','2013-02-28','09:15:00',2.65),('12664','2013-02-28','09:20:00',2.74),('12664','2013-02-28','09:25:00',2.81),('12664','2013-02-28','09:30:00',2.9),('12664','2013-02-28','09:35:00',2.96),('12664','2013-02-28','09:40:00',3.04),('12664','2013-02-28','09:45:00',2.91),('12664','2013-02-28','09:50:00',3.16),('12664','2013-02-28','09:55:00',3.23),('12664','2013-02-28','10:00:00',3.28),('12664','2013-02-28','10:05:00',3.32),('12664','2013-02-28','10:10:00',3.4),('12664','2013-02-28','10:15:00',3.45),('12664','2013-02-28','10:20:00',3.48),('12664','2013-02-28','10:25:00',3.52),('12664','2013-02-28','10:30:00',3.53),('12664','2013-02-28','10:35:00',3.62),('12664','2013-02-28','10:40:00',3.64),('12664','2013-02-28','10:45:00',3.66),('12664','2013-02-28','10:50:00',3.75),('12664','2013-02-28','10:55:00',3.78),('12664','2013-02-28','11:00:00',3.83),('12664','2013-02-28','11:05:00',3.82),('12664','2013-02-28','11:10:00',3.8),('12664','2013-02-28','11:15:00',3.89),('12664','2013-02-28','11:20:00',3.92),('12664','2013-02-28','11:25:00',3.97),('12664','2013-02-28','11:30:00',4.01),('12664','2013-02-28','11:35:00',3.96),('12664','2013-02-28','11:40:00',4.01),('12664','2013-02-28','11:45:00',3.95),('12664','2013-02-28','11:50:00',4.03),('12664','2013-02-28','11:55:00',4.02),('12664','2013-02-28','12:00:00',4.03),('12664','2013-02-28','12:05:00',3.98),('12664','2013-02-28','12:10:00',4.06),('12664','2013-02-28','12:15:00',4.08),('12664','2013-02-28','12:20:00',4.07),('12664','2013-02-28','12:25:00',4.08),('12664','2013-02-28','12:30:00',4.12),('12664','2013-02-28','12:35:00',4.1),('12664','2013-02-28','12:40:00',3.97),('12664','2013-02-28','12:45:00',4.01),('12664','2013-02-28','12:50:00',4.08),('12664','2013-02-28','12:55:00',3.86),('12664','2013-02-28','13:00:00',4.04),('12664','2013-02-28','13:05:00',4.01),('12664','2013-02-28','13:10:00',3.94),('12664','2013-02-28','13:15:00',3.81),('12664','2013-02-28','13:20:00',3.61),('12664','2013-02-28','13:25:00',3.44),('12664','2013-02-28','13:30:00',3.76),('12664','2013-02-28','13:35:00',4.1),('12664','2013-02-28','13:40:00',4),('12664','2013-02-28','13:45:00',4.02),('12664','2013-02-28','13:50:00',4.07),('12664','2013-02-28','13:55:00',4.03),('12664','2013-02-28','14:00:00',3.86),('12664','2013-02-28','14:05:00',3.71),('12664','2013-02-28','14:10:00',3.44),('12664','2013-02-28','14:15:00',3.49),('12664','2013-02-28','14:20:00',3.31),('12664','2013-02-28','14:25:00',3.23),('12664','2013-02-28','14:30:00',3.28),('12664','2013-02-28','14:35:00',1.7),('12664','2013-02-28','14:40:00',2.92),('12664','2013-02-28','14:45:00',3.02),('12664','2013-02-28','14:50:00',2.88),('12664','2013-02-28','14:55:00',2.81),('12664','2013-02-28','15:00:00',2.77),('12664','2013-02-28','15:05:00',2.69),('12664','2013-02-28','15:10:00',2.63),('12664','2013-02-28','15:15:00',2.59),('12664','2013-02-28','15:20:00',2.47),('12664','2013-02-28','15:25:00',2.41),('12664','2013-02-28','15:30:00',2.33),('12664','2013-02-28','15:35:00',2.25),('12664','2013-02-28','15:40:00',2.17),('12664','2013-02-28','15:45:00',2.07),('12664','2013-02-28','15:50:00',1.96),('12664','2013-02-28','15:55:00',1.88),('12664','2013-02-28','16:00:00',1.78),('12664','2013-02-28','16:05:00',1.67),('12664','2013-02-28','16:10:00',1.59),('12664','2013-02-28','16:15:00',1.48),('12664','2013-02-28','16:20:00',1.36),('12664','2013-02-28','16:25:00',1.24),('12664','2013-02-28','16:30:00',1.2),('12664','2013-02-28','16:35:00',1.09),('12664','2013-02-27','08:00:00',1.04),('12664','2013-02-27','08:05:00',1.15),('12664','2013-02-27','08:10:00',1.27),('12664','2013-02-27','08:15:00',1.38),('12664','2013-02-27','08:20:00',1.51),('12664','2013-02-27','08:25:00',1.63),('12664','2013-02-27','08:30:00',1.74),('12664','2013-02-27','08:35:00',1.84),('12664','2013-02-27','08:40:00',1.94),('12664','2013-02-27','08:45:00',2.04),('12664','2013-02-27','08:50:00',2.14),('12664','2013-02-27','08:55:00',2.23),('12664','2013-02-27','09:00:00',2.34),('12664','2013-02-27','09:05:00',2.44),('12664','2013-02-27','09:10:00',2.55),('12664','2013-02-27','09:15:00',2.66),('12664','2013-02-27','09:20:00',2.74),('12664','2013-02-27','09:25:00',2.82),('12664','2013-02-27','09:30:00',2.9),('12664','2013-02-27','09:35:00',2.97),('12664','2013-02-27','09:40:00',3.03),('12664','2013-02-27','09:45:00',3.1),('12664','2013-02-27','10:05:00',3.33),('12664','2013-02-27','10:10:00',3.38),('12664','2013-02-27','10:30:00',3.59),('12664','2013-02-27','10:35:00',3.64),('12664','2013-02-27','10:40:00',3.7),('12664','2013-02-27','11:15:00',3.83),('12664','2013-02-27','11:20:00',3.89),('12664','2013-02-27','11:25:00',3.91),('12664','2013-02-27','11:30:00',4.04),('12664','2013-02-27','11:35:00',4.02),('12664','2013-02-27','11:40:00',3.92),('12664','2013-02-27','11:45:00',4.03),('12664','2013-02-27','11:50:00',4.25),('12664','2013-02-27','11:55:00',3.86),('12664','2013-02-27','12:00:00',3.4),('12664','2013-02-27','12:05:00',4.23),('12664','2013-02-27','12:10:00',4.23),('12664','2013-02-27','12:15:00',4.29),('12664','2013-02-27','12:20:00',4.29),('12664','2013-02-27','12:25:00',4.22),('12664','2013-02-27','12:30:00',4.16),('12664','2013-02-27','12:35:00',4.12),('12664','2013-02-27','12:40:00',4.1),('12664','2013-02-27','12:45:00',4.12),('12664','2013-02-27','12:50:00',3.85),('12664','2013-02-27','12:55:00',3.94),('12664','2013-02-27','13:00:00',4.14),('12664','2013-02-27','13:05:00',4.1),('12664','2013-02-27','13:10:00',4.13),('12664','2013-02-27','13:15:00',4.05),('12664','2013-02-27','13:20:00',3.19),('12664','2013-02-27','13:25:00',3.24),('12664','2013-02-27','13:30:00',2.51),('12664','2013-02-27','13:35:00',3.55),('12664','2013-02-27','13:45:00',3.62),('12664','2013-02-27','13:50:00',3.89),('12664','2013-02-27','13:55:00',3.89),('12664','2013-02-27','14:00:00',2.78),('12664','2013-02-27','14:05:00',1.6),('12664','2013-02-27','14:10:00',1.67),('12664','2013-02-27','14:15:00',2.15),('12664','2013-02-27','14:20:00',2.15),('12664','2013-02-27','14:25:00',1.07),('12664','2013-02-27','14:35:00',2.36),('12664','2013-02-27','14:40:00',3.52),('12664','2013-02-27','14:45:00',3.46),('12664','2013-02-27','14:50:00',3.39),('12664','2013-02-27','14:55:00',3.16),('12664','2013-02-27','15:00:00',3.05),('12664','2013-02-27','15:05:00',2.89),('12664','2013-02-27','15:10:00',2.77),('12664','2013-02-27','15:15:00',2.7),('12664','2013-02-27','15:20:00',2.63),('12664','2013-02-27','15:25:00',2.54),('12664','2013-02-27','15:30:00',2.39),('12664','2013-02-27','15:35:00',2.33),('12664','2013-02-27','15:40:00',2.28),('12664','2013-02-27','15:45:00',2.18),('12664','2013-02-27','15:50:00',2.09),('12664','2013-02-27','15:55:00',2.03),('12664','2013-02-27','16:00:00',1.91),('12664','2013-02-27','16:05:00',1.8),('12664','2013-02-27','16:10:00',1.69),('12664','2013-02-27','16:15:00',1.59),('12664','2013-02-27','16:20:00',1.48),('12664','2013-02-27','16:25:00',1.38),('12664','2013-02-27','16:30:00',1.27),('12664','2013-02-27','16:35:00',1.16),('12664','2013-02-27','16:40:00',1.05),('12664','2013-02-26','09:15:00',1.01),('12664','2013-02-26','09:20:00',1.15),('12664','2013-02-26','09:25:00',1.34),('12664','2013-02-26','09:30:00',1.59),('12664','2013-02-26','09:35:00',1.86),('12664','2013-02-26','09:40:00',2.08),('12664','2013-02-26','09:45:00',2.25),('12664','2013-02-26','09:50:00',2.44),('12664','2013-02-26','09:55:00',2.61),('12664','2013-02-26','10:00:00',2.45),('12664','2013-02-26','10:05:00',2.86),('12664','2013-02-26','10:10:00',3.24),('12664','2013-02-26','10:15:00',2.98),('12664','2013-02-26','10:20:00',3.14),('12664','2013-02-26','10:25:00',1.77),('12664','2013-02-26','10:30:00',1.43),('12664','2013-02-26','10:35:00',1.61),('12664','2013-02-26','10:40:00',1.55),('12664','2013-02-26','10:45:00',1.53),('12664','2013-02-26','10:50:00',1.62),('12664','2013-02-26','10:55:00',1.65),('12664','2013-02-26','11:00:00',1.78),('12664','2013-02-26','11:05:00',1.71),('12664','2013-02-26','11:10:00',1.61),('12664','2013-02-26','11:15:00',1.67),('12664','2013-02-26','11:20:00',1.9),('12664','2013-02-26','11:25:00',2.21),('12664','2013-02-26','11:30:00',2.26),('12664','2013-02-26','11:35:00',2.48),('12664','2013-02-26','11:40:00',3.23),('12664','2013-02-26','11:45:00',3.29),('12664','2013-02-26','11:50:00',3.13),('12664','2013-02-26','11:55:00',3.89),('12664','2013-02-26','12:00:00',4.21),('12664','2013-02-26','12:05:00',2.85),('12664','2013-02-26','12:10:00',2.27),('12664','2013-02-26','12:15:00',1.79),('12664','2013-02-26','12:20:00',1.66),('12664','2013-02-26','12:25:00',1.56),('12664','2013-02-26','12:30:00',1.56),('12664','2013-02-26','12:35:00',1.42),('12664','2013-02-26','12:40:00',1.48),('12664','2013-02-26','12:45:00',1.41),('12664','2013-02-26','12:50:00',1.32),('12664','2013-02-26','12:55:00',1.29),('12664','2013-02-26','13:00:00',1.36),('12664','2013-02-26','13:05:00',1.17),('12664','2013-02-26','13:10:00',1.34),('12664','2013-02-26','13:15:00',1.58),('12664','2013-02-26','13:20:00',1.48),('12664','2013-02-26','13:25:00',1.43),('12664','2013-02-26','13:30:00',1.2),('12664','2013-02-25','10:35:00',1.03),('12664','2013-02-25','10:40:00',1.49),('12664','2013-02-25','10:45:00',1.8),('12664','2013-02-25','10:50:00',2.61),('12664','2013-02-25','10:55:00',3.79),('12664','2013-02-25','11:00:00',3.47),('12664','2013-02-25','11:05:00',3.77),('12664','2013-02-25','11:10:00',4.22),('12664','2013-02-25','11:15:00',4),('12664','2013-02-25','11:20:00',4.47),('12664','2013-02-25','11:25:00',1.71),('12664','2013-02-25','11:30:00',1.98),('12664','2013-02-25','11:35:00',1.38),('12664','2013-02-25','11:40:00',1.23),('12664','2013-02-25','11:45:00',1.09),('12664','2013-02-25','11:50:00',1.12),('12664','2013-02-25','11:55:00',1.28),('12664','2013-02-25','12:00:00',1.36),('12664','2013-02-25','12:05:00',1.62),('12664','2013-02-25','12:10:00',1.74),('12664','2013-02-25','12:15:00',1.92),('12664','2013-02-25','12:20:00',2.99),('12664','2013-02-25','12:25:00',3.55),('12664','2013-02-25','12:30:00',4.59),('12664','2013-02-25','12:35:00',3.06),('12664','2013-02-25','12:40:00',3.56),('12664','2013-02-25','12:45:00',4.61),('12664','2013-02-25','12:50:00',4.52),('12664','2013-02-25','12:55:00',4.49),('12664','2013-02-25','13:00:00',4.47),('12664','2013-02-25','13:05:00',4.05),('12664','2013-02-25','13:10:00',3.89),('12664','2013-02-25','13:15:00',2.46),('12664','2013-02-25','13:20:00',2.62),('12664','2013-02-25','13:25:00',1.5),('12664','2013-02-25','13:30:00',1.28),('12664','2013-02-25','13:35:00',1.17),('12664','2013-02-25','13:40:00',1.13),('12664','2013-02-25','13:45:00',1.95),('12664','2013-02-25','13:50:00',1.64),('12664','2013-02-25','13:55:00',1.2),('12664','2013-02-25','14:00:00',1.23),('12664','2013-02-25','14:05:00',1.19),('12664','2013-02-25','14:15:00',1.05),('12664','2013-02-25','16:35:00',1.15),('12664','2013-02-25','16:40:00',1.54),('12664','2013-02-24','10:15:00',1.05),('12664','2013-02-24','10:45:00',1.73),('12664','2013-02-24','10:50:00',2.21),('12664','2013-02-24','10:55:00',3.21),('12664','2013-02-24','11:00:00',2.42),('12664','2013-02-24','11:05:00',1.25),('12664','2013-02-24','11:35:00',1.03),('12664','2013-02-24','11:40:00',1.26),('12664','2013-02-24','11:45:00',1.29),('12664','2013-02-24','11:50:00',1.24),('12664','2013-02-24','11:55:00',1.17),('12664','2013-02-24','12:30:00',1.12),('12664','2013-02-24','12:35:00',1.46),('12664','2013-02-24','12:40:00',1.48),('12664','2013-02-24','12:45:00',1.86),('12664','2013-02-24','12:50:00',2.17),('12664','2013-02-24','12:55:00',2.47),('12664','2013-02-24','13:00:00',4.17),('12664','2013-02-24','13:05:00',3.79),('12664','2013-02-24','13:10:00',1.14),('12664','2013-02-24','13:20:00',1.51),('12664','2013-02-24','13:25:00',1.49),('12664','2013-02-24','13:30:00',2.28),('12664','2013-02-24','13:35:00',2.26),('12664','2013-02-24','13:40:00',1.96),('12664','2013-02-24','13:45:00',1.49),('12664','2013-02-24','13:50:00',1.27),('12664','2013-02-24','13:55:00',1.48),('12664','2013-02-24','14:00:00',1.59),('12664','2013-02-24','14:05:00',1.79),('12664','2013-02-24','14:10:00',1.79),('12664','2013-02-24','14:15:00',1.05),('12664','2013-02-24','14:20:00',1.29),('12664','2013-02-24','14:25:00',1.27),('12664','2013-02-24','14:50:00',2.34),('12664','2013-02-24','14:55:00',2.55),('12664','2013-02-24','15:00:00',2.71),('12664','2013-02-24','15:05:00',2.24),('12664','2013-02-24','15:10:00',1),('12664','2013-02-24','15:15:00',1.43),('12664','2013-02-24','15:20:00',2.05),('12664','2013-02-24','15:25:00',2.51),('12664','2013-02-24','15:30:00',1.72),('12664','2013-02-24','15:35:00',1.34),('12664','2013-02-24','15:40:00',1.66),('12664','2013-02-24','15:45:00',2.59),('12664','2013-02-24','15:50:00',1.2),('12664','2013-02-24','15:55:00',1.17),('12664','2013-02-24','16:00:00',1.49),('12664','2013-02-24','16:05:00',1.77),('12664','2013-02-24','16:10:00',1.59),('12664','2013-02-24','16:15:00',1.78),('12664','2013-02-23','07:50:00',1.06),('12664','2013-02-23','07:55:00',1.24),('12664','2013-02-23','08:00:00',1.31),('12664','2013-02-23','08:05:00',1.56),('12664','2013-02-23','08:10:00',1.93),('12664','2013-02-23','08:15:00',1.67),('12664','2013-02-23','08:55:00',1.09),('12664','2013-02-23','09:00:00',1.22),('12664','2013-02-23','09:05:00',1.2),('12664','2013-02-23','09:55:00',1),('12664','2013-02-23','10:30:00',1.03),('12664','2013-02-23','10:40:00',1.01),('12664','2013-02-23','10:45:00',1.19),('12664','2013-02-23','10:50:00',1.31),('12664','2013-02-23','10:55:00',1.24),('12664','2013-02-23','11:25:00',1.13),('12664','2013-02-23','11:30:00',1.31),('12664','2013-02-23','11:35:00',1.17),('12664','2013-02-23','11:45:00',1.01),('12664','2013-02-22','14:35:00',2.13),('12664','2013-02-22','14:40:00',1.76),('12664','2013-02-22','15:00:00',1.39),('12664','2013-02-22','15:30:00',1.23),('12664','2013-02-22','15:35:00',1.93),('12664','2013-02-21','11:45:00',1),('12664','2013-02-21','12:00:00',1.11),('12664','2013-02-21','12:05:00',1.2),('12664','2013-02-21','12:10:00',1.19),('12664','2013-02-21','12:15:00',1.19),('12664','2013-02-21','12:20:00',1.15),('12664','2013-02-21','12:25:00',1.12),('12664','2013-02-21','12:30:00',1.2),('12664','2013-02-21','12:35:00',1.3),('12664','2013-02-21','12:40:00',1.25),('12664','2013-02-21','12:45:00',1.14),('12664','2013-02-21','12:50:00',1.1),('12664','2013-02-21','12:55:00',1.18),('12664','2013-02-21','13:00:00',1.23),('12664','2013-02-21','13:05:00',1.15),('12664','2013-02-21','13:10:00',1.12),('12664','2013-02-21','13:15:00',1.28),('12664','2013-02-21','13:20:00',1.35),('12664','2013-02-21','13:25:00',1.23),('12664','2013-02-21','13:30:00',1.14),('12664','2013-02-21','13:35:00',1.11),('12664','2013-02-21','13:40:00',1.06),('12664','2013-02-21','13:45:00',1.05),('12664','2013-02-21','15:25:00',1.06),('12664','2013-02-21','15:30:00',1.07),('12664','2013-02-21','15:35:00',1.15),('12664','2013-02-21','15:40:00',1.22),('12664','2013-02-21','15:45:00',1.14),('12664','2013-02-21','15:50:00',1.28),('12664','2013-02-21','15:55:00',1.93),('12664','2013-02-21','16:00:00',1.56),('12664','2013-02-21','16:05:00',1.3),('12664','2013-02-21','16:10:00',1.93),('12664','2013-02-21','16:15:00',1.8),('12664','2013-02-21','16:20:00',1.59),('12664','2013-02-21','16:25:00',1.38),('12664','2013-02-21','16:30:00',1.2),('12664','2013-02-21','16:35:00',1.02),('12664','2013-02-20','08:10:00',1.44),('12664','2013-02-20','08:15:00',1.57),('12664','2013-02-20','08:20:00',1.55),('12664','2013-02-20','08:25:00',1.62),('12664','2013-02-20','08:30:00',1.72),('12664','2013-02-20','08:35:00',1.82),('12664','2013-02-20','08:40:00',1.92),('12664','2013-02-20','08:45:00',2.03),('12664','2013-02-20','08:50:00',2.13),('12664','2013-02-20','08:55:00',2.25),('12664','2013-02-20','09:00:00',2.37),('12664','2013-02-20','09:05:00',2.5),('12664','2013-02-20','09:15:00',1.3),('12664','2013-02-20','09:20:00',1.51),('12664','2013-02-20','09:25:00',1.86),('12664','2013-02-20','09:30:00',1.08),('12664','2013-02-20','09:35:00',2.9),('12664','2013-02-20','09:40:00',2.8),('12664','2013-02-20','09:45:00',1.47),('12664','2013-02-20','09:50:00',2.41),('12664','2013-02-20','09:55:00',2.24),('12664','2013-02-20','10:00:00',3.4),('12664','2013-02-20','10:05:00',3.39),('12664','2013-02-20','10:10:00',1.59),('12664','2013-02-20','10:15:00',2.39),('12664','2013-02-20','10:20:00',3.43),('12664','2013-02-20','10:25:00',3.57),('12664','2013-02-20','10:30:00',1.79),('12664','2013-02-20','10:35:00',2.64),('12664','2013-02-20','10:40:00',1.68),('12664','2013-02-20','10:55:00',2.89),('12664','2013-02-20','11:00:00',3.17),('12664','2013-02-20','11:05:00',4.06),('12664','2013-02-20','11:10:00',3.71),('12664','2013-02-20','11:15:00',3.64),('12664','2013-02-20','11:20:00',4.6),('12664','2013-02-20','11:25:00',3.19),('12664','2013-02-20','11:30:00',2.45),('12664','2013-02-20','11:35:00',2.86),('12664','2013-02-20','11:40:00',1.71),('12664','2013-02-20','11:45:00',1.34),('12664','2013-02-20','11:50:00',2.84),('12664','2013-02-20','11:55:00',2.92),('12664','2013-02-20','12:00:00',1.76),('12664','2013-02-20','12:05:00',1.5),('12664','2013-02-20','12:10:00',1.39),('12664','2013-02-20','12:15:00',2.83),('12664','2013-02-20','12:20:00',2.85),('12664','2013-02-20','12:25:00',4.56),('12664','2013-02-20','12:30:00',1.13),('12664','2013-02-20','12:35:00',1.12),('12664','2013-02-20','12:40:00',1.48),('12664','2013-02-20','12:45:00',2.03),('12664','2013-02-20','12:50:00',2.21),('12664','2013-02-20','12:55:00',3.49),('12664','2013-02-20','13:00:00',2.52),('12664','2013-02-20','13:05:00',2.38),('12664','2013-02-20','13:10:00',2.81),('12664','2013-02-20','13:15:00',1.26),('12664','2013-02-20','13:20:00',1.87),('12664','2013-02-20','13:25:00',2.13),('12664','2013-02-20','13:30:00',4.94),('12664','2013-02-20','13:35:00',4.47),('12664','2013-02-20','13:40:00',4.56),('12664','2013-02-20','13:45:00',4.16),('12664','2013-02-20','13:50:00',3.93),('12664','2013-02-20','13:55:00',3.16),('12664','2013-02-20','14:10:00',1.08),('12664','2013-02-20','14:15:00',2.21),('12664','2013-02-20','14:20:00',3.28),('12664','2013-02-20','14:25:00',1.42),('12664','2013-02-20','14:30:00',1.25),('12664','2013-02-20','14:35:00',2.91),('12664','2013-02-20','14:40:00',1.64),('12664','2013-02-20','14:45:00',1.22),('12664','2013-02-20','14:50:00',1.61),('12664','2013-02-20','14:55:00',1.84),('12664','2013-02-20','15:00:00',2.3),('12664','2013-02-20','15:05:00',2.42),('12664','2013-02-20','15:10:00',2.28),('12664','2013-02-20','15:15:00',2.44),('12664','2013-02-20','15:20:00',1.53),('12664','2013-02-20','15:25:00',1.3),('12664','2013-02-20','15:30:00',1.78),('12664','2013-02-20','15:35:00',1.06),('12664','2013-02-20','15:50:00',1.04),('12664','2013-02-20','16:05:00',1.3),('12664','2013-02-20','16:10:00',1.12),('12664','2013-02-20','16:15:00',1.16),('12664','2013-02-20','16:25:00',1.01),('12664','2013-02-20','16:30:00',1.22),('12664','2014-03-22','08:10:00',1.39),('12664','2014-03-22','08:15:00',1.47),('12664','2014-03-22','08:20:00',1.51),('12664','2014-03-22','08:25:00',1.4),('12664','2014-03-22','08:30:00',1.6),('12664','2014-03-22','08:40:00',1.36),('12664','2014-03-22','08:50:00',1.51),('12664','2014-03-22','08:55:00',1.16),('12664','2014-03-22','09:00:00',1.05),('12664','2014-03-22','09:05:00',1.12),('12664','2014-03-22','09:10:00',1.07),('12664','2014-03-22','09:15:00',1.19),('12664','2014-03-22','09:20:00',1.21),('12664','2014-03-22','09:25:00',2.04),('12664','2014-03-22','09:30:00',2.48),('12664','2014-03-22','09:35:00',1.09),('12664','2014-03-22','09:40:00',2.47),('12664','2014-03-22','09:45:00',2.15),('12664','2014-03-22','09:50:00',1.89),('12664','2014-03-22','09:55:00',2.75),('12664','2014-03-22','10:00:00',2.5),('12664','2014-03-22','10:05:00',3.43),('12664','2014-03-22','10:10:00',1.54),('12664','2014-03-22','10:15:00',1.41),('12664','2014-03-22','10:20:00',1.13),('12664','2014-03-22','10:25:00',1.03),('12664','2014-03-22','10:30:00',1.19),('12664','2014-03-22','10:35:00',1.1),('12664','2014-03-22','10:40:00',1.71),('12664','2014-03-22','10:45:00',2.15),('12664','2014-03-22','10:50:00',2.37),('12664','2014-03-22','10:55:00',1.69),('12664','2014-03-22','11:00:00',2.11),('12664','2014-03-22','11:05:00',2.08),('12664','2014-03-22','11:10:00',1.42),('12664','2014-03-22','11:15:00',1.84),('12664','2014-03-22','11:20:00',2.07),('12664','2014-03-22','11:25:00',3.06),('12664','2014-03-22','11:30:00',2.37),('12664','2014-03-22','11:35:00',3.87),('12664','2014-03-22','11:40:00',1.59),('12664','2014-03-22','11:45:00',3.37),('12664','2014-03-22','11:50:00',1.17),('12664','2014-03-22','11:55:00',2.31),('12664','2014-03-22','12:00:00',3.97),('12664','2014-03-22','12:05:00',4.39),('12664','2014-03-22','12:10:00',3.15),('12664','2014-03-22','12:15:00',1.73),('12664','2014-03-22','12:20:00',1.25),('12664','2014-03-22','12:25:00',2.12),('12664','2014-03-22','12:30:00',3.24),('12664','2014-03-22','12:35:00',4.04),('12664','2014-03-22','12:40:00',3.54),('12664','2014-03-22','12:45:00',2.97),('12664','2014-03-22','12:50:00',3.36),('12664','2014-03-22','12:55:00',3.78),('12664','2014-03-22','13:00:00',1.65),('12664','2014-03-22','13:05:00',2.9),('12664','2014-03-22','13:10:00',3.71),('12664','2014-03-22','13:15:00',3.98),('12664','2014-03-22','13:20:00',3.74),('12664','2014-03-22','13:25:00',3.5),('12664','2014-03-22','13:30:00',3.23),('12664','2014-03-22','13:35:00',3.51),('12664','2014-03-22','13:40:00',2.01),('12664','2014-03-22','13:45:00',3.54),('12664','2014-03-22','13:50:00',3.11),('12664','2014-03-22','13:55:00',3.11),('12664','2014-03-22','14:00:00',3.03),('12664','2014-03-22','14:05:00',3.28),('12664','2014-03-22','14:10:00',3.25),('12664','2014-03-22','14:15:00',3.23),('12664','2014-03-22','14:20:00',3.21),('12664','2014-03-22','14:25:00',2.49),('12664','2014-03-22','14:30:00',2.54),('12664','2014-03-22','14:35:00',2.45),('12664','2014-03-22','14:40:00',2.96),('12664','2014-03-22','14:45:00',2.85),('12664','2014-03-22','14:50:00',2.85),('12664','2014-03-22','14:55:00',1.07),('12664','2014-03-22','15:00:00',2.81),('12664','2014-03-22','15:05:00',2.65),('12664','2014-03-22','15:10:00',2.14),('12664','2014-03-22','15:15:00',2.48),('12664','2014-03-22','15:20:00',2.38),('12664','2014-03-22','15:25:00',2.31),('12664','2014-03-22','15:30:00',2.57),('12664','2014-03-22','15:35:00',1.28),('12664','2014-03-22','15:40:00',1.4),('12664','2014-03-22','15:45:00',2.22),('12664','2014-03-22','15:50:00',2.04),('12664','2014-03-22','15:55:00',1.94),('12664','2014-03-22','16:00:00',1.47),('12664','2014-03-22','16:10:00',1.49),('12664','2013-02-19','08:05:00',1.11),('12664','2013-02-19','08:10:00',1.22),('12664','2013-02-19','08:15:00',1.34),('12664','2013-02-19','08:20:00',1.46),('12664','2013-02-19','08:25:00',1.59),('12664','2013-02-19','08:30:00',1.7),('12664','2013-02-19','08:35:00',1.81),('12664','2013-02-19','08:40:00',1.92),('12664','2013-02-19','08:45:00',2.01),('12664','2013-02-19','08:50:00',2.11),('12664','2013-02-19','08:55:00',2.24),('12664','2013-02-19','09:00:00',2.33),('12664','2013-02-19','09:05:00',2.43),('12664','2013-02-19','09:10:00',2.52),('12664','2013-02-19','09:15:00',2.61),('12664','2013-02-19','09:20:00',2.69),('12664','2013-02-19','09:25:00',2.77),('12664','2013-02-19','09:30:00',2.85),('12664','2013-02-19','09:35:00',2.93),('12664','2013-02-19','09:40:00',2.98),('12664','2013-02-19','09:45:00',3.06),('12664','2013-02-19','09:50:00',3.15),('12664','2013-02-19','09:55:00',3.21),('12664','2013-02-19','10:00:00',3.26),('12664','2013-02-19','10:05:00',3.33),('12664','2013-02-19','10:10:00',3.39),('12664','2013-02-19','10:15:00',3.44),('12664','2013-02-19','10:20:00',3.49),('12664','2013-02-19','10:25:00',3.53),('12664','2013-02-19','10:30:00',3.58),('12664','2013-02-19','10:35:00',3.64),('12664','2013-02-19','10:40:00',3.68),('12664','2013-02-19','10:45:00',3.73),('12664','2013-02-19','10:50:00',3.75),('12664','2013-02-19','10:55:00',3.79),('12664','2013-02-19','11:00:00',3.84),('12664','2013-02-19','11:05:00',3.87),('12664','2013-02-19','11:10:00',3.89),('12664','2013-02-19','11:15:00',3.91),('12664','2013-02-19','11:20:00',3.94),('12664','2013-02-19','11:25:00',3.96),('12664','2013-02-19','11:30:00',3.98),('12664','2013-02-19','11:35:00',3.98),('12664','2013-02-19','11:40:00',4),('12664','2013-02-19','11:45:00',4.01),('12664','2013-02-19','11:50:00',4.02),('12664','2013-02-19','11:55:00',4.04),('12664','2013-02-19','12:00:00',4.02),('12664','2013-02-19','12:05:00',4.04),('12664','2013-02-19','12:10:00',4.02),('12664','2013-02-19','12:15:00',4.05),('12664','2013-02-19','12:20:00',4.04),('12664','2013-02-19','12:25:00',4),('12664','2013-02-19','12:30:00',3.97),('12664','2013-02-19','12:35:00',4),('12664','2013-02-19','12:40:00',4.03),('12664','2013-02-19','12:45:00',4.01),('12664','2013-02-19','12:50:00',3.99),('12664','2013-02-19','12:55:00',3.98),('12664','2013-02-19','13:00:00',3.98),('12664','2013-02-19','13:05:00',3.97),('12664','2013-02-19','13:10:00',3.93),('12664','2013-02-19','13:15:00',3.91),('12664','2013-02-19','13:20:00',3.91),('12664','2013-02-19','13:25:00',3.87),('12664','2013-02-19','13:30:00',3.83),('12664','2013-02-19','13:35:00',3.79),('12664','2013-02-19','13:40:00',3.77),('12664','2013-02-19','13:45:00',3.7),('12664','2013-02-19','13:50:00',3.68),('12664','2013-02-19','13:55:00',3.67),('12664','2013-02-19','14:00:00',3.58),('12664','2013-02-19','14:05:00',3.45),('12664','2013-02-19','14:10:00',3.4),('12664','2013-02-19','14:15:00',3.32),('12664','2013-02-19','14:20:00',3.3),('12664','2013-02-19','14:25:00',3.26),('12664','2013-02-19','14:30:00',3.11),('12664','2013-02-19','14:35:00',3.13),('12664','2013-02-19','14:40:00',3.07),('12664','2013-02-19','14:45:00',3.03),('12664','2013-02-19','14:50:00',3.02),('12664','2013-02-19','14:55:00',2.89),('12664','2013-02-19','15:00:00',2.82),('12664','2013-02-19','15:05:00',2.72),('12664','2013-02-19','15:10:00',2.66),('12664','2013-02-19','15:15:00',2.6),('12664','2013-02-19','15:20:00',2.49),('12664','2013-02-19','15:25:00',2.48),('12664','2013-02-19','15:30:00',2.37),('12664','2013-02-19','15:35:00',2.29),('12664','2013-02-19','15:40:00',2.21),('12664','2013-02-19','15:45:00',2.11),('12664','2013-02-19','15:50:00',2.02),('12664','2013-02-19','15:55:00',1.93),('12664','2013-02-19','16:00:00',1.83),('12664','2013-02-19','16:05:00',1.71),('12664','2013-02-19','16:10:00',1.61),('12664','2013-02-19','16:15:00',1.49),('12664','2013-02-19','16:20:00',1.38),('12664','2013-02-19','16:25:00',1.28),('12664','2013-02-19','16:30:00',1.16),('12664','2013-02-19','16:35:00',1.06),('12664','2013-02-18','08:00:00',1.07),('12664','2013-02-18','08:05:00',1.01),('12664','2013-02-18','08:10:00',1.04),('12664','2013-02-18','08:15:00',1.19),('12664','2013-02-18','08:20:00',1.34),('12664','2013-02-18','08:25:00',1.47),('12664','2013-02-18','08:30:00',1.56),('12664','2013-02-18','08:35:00',1.69),('12664','2013-02-18','08:40:00',1.8),('12664','2013-02-18','08:45:00',1.89),('12664','2013-02-18','08:50:00',1.97),('12664','2013-02-18','08:55:00',2.09),('12664','2013-02-18','09:00:00',2.19),('12664','2013-02-18','09:05:00',2.28),('12664','2013-02-18','09:10:00',2.32),('12664','2013-02-18','09:15:00',2.44),('12664','2013-02-18','09:20:00',2.55),('12664','2013-02-18','09:25:00',1.28),('12664','2013-02-18','09:35:00',2.41),('12664','2013-02-18','09:40:00',2.62),('12664','2013-02-18','09:45:00',1.07),('12664','2013-02-18','10:00:00',1.02),('12664','2013-02-18','10:05:00',3.57),('12664','2013-02-18','10:10:00',3.26),('12664','2013-02-18','10:15:00',3.3),('12664','2013-02-18','10:20:00',2.87),('12664','2013-02-18','10:25:00',3.21),('12664','2013-02-18','10:30:00',3.08),('12664','2013-02-18','10:35:00',3.52),('12664','2013-02-18','10:40:00',3.14),('12664','2013-02-18','10:45:00',1.89),('12664','2013-02-18','10:50:00',3.37),('12664','2013-02-18','10:55:00',1.44),('12664','2013-02-18','11:00:00',1.65),('12664','2013-02-18','11:05:00',1.46),('12664','2013-02-18','11:10:00',1.53),('12664','2013-02-18','11:15:00',1.79),('12664','2013-02-18','11:20:00',1.67),('12664','2013-02-18','11:25:00',1.87),('12664','2013-02-18','11:30:00',2.09),('12664','2013-02-18','11:35:00',2.33),('12664','2013-02-18','11:40:00',2.37),('12664','2013-02-18','11:45:00',2.57),('12664','2013-02-18','11:50:00',2.75),('12664','2013-02-18','11:55:00',2.14),('12664','2013-02-18','12:00:00',1.63),('12664','2013-02-18','12:05:00',1.48),('12664','2013-02-18','12:10:00',1.41),('12664','2013-02-18','12:15:00',1.27),('12664','2013-02-18','12:20:00',1.4),('12664','2013-02-18','12:25:00',1.73),('12664','2013-02-18','12:30:00',1.44),('12664','2013-02-18','12:35:00',1.43),('12664','2013-02-18','12:40:00',1.57),('12664','2013-02-18','12:45:00',1.73),('12664','2013-02-18','12:50:00',2.44),('12664','2013-02-18','12:55:00',2.79),('12664','2013-02-18','13:00:00',2.9),('12664','2013-02-18','13:05:00',2.5),('12664','2013-02-18','13:10:00',2.36),('12664','2013-02-18','13:15:00',3.07),('12664','2013-02-18','13:20:00',1.84),('12664','2013-02-18','13:25:00',1.53),('12664','2013-02-18','13:30:00',1.15),('12664','2013-02-18','13:35:00',1.05),('12664','2013-02-18','13:40:00',1.24),('12664','2013-02-18','13:45:00',1.32),('12664','2013-02-18','13:50:00',1.54),('12664','2013-02-18','13:55:00',2.18),('12664','2013-02-18','14:00:00',2.14),('12664','2013-02-18','14:05:00',1.92),('12664','2013-02-18','14:10:00',2.31),('12664','2013-02-18','14:15:00',2.82),('12664','2013-02-18','14:20:00',1.55),('12664','2013-02-18','14:35:00',1.17),('12664','2013-02-18','14:40:00',1.65),('12664','2013-02-18','14:45:00',1.24),('12664','2013-02-18','14:50:00',1.47),('12664','2013-02-18','14:55:00',1.58),('12664','2013-02-18','15:00:00',1.44),('12664','2013-02-18','15:05:00',1.07),('12664','2013-02-17','08:10:00',1.05),('12664','2013-02-17','08:15:00',1.17),('12664','2013-02-17','08:20:00',1.3),('12664','2013-02-17','08:25:00',1.45),('12664','2013-02-17','08:30:00',1.58),('12664','2013-02-17','08:35:00',1.71),('12664','2013-02-17','08:40:00',1.32),('12664','2013-02-17','08:45:00',1.18),('12664','2013-02-17','08:50:00',1.74),('12664','2013-02-17','08:55:00',1.89),('12664','2013-02-17','09:00:00',2.07),('12664','2013-02-17','09:05:00',2.04),('12664','2013-02-17','09:10:00',2.23),('12664','2013-02-17','09:15:00',2.27),('12664','2013-02-17','09:20:00',2.43),('12664','2013-02-17','09:25:00',2.52),('12664','2013-02-17','09:30:00',2.59),('12664','2013-02-17','09:35:00',2.71),('12664','2013-02-17','09:40:00',2.76),('12664','2013-02-17','09:45:00',2.83),('12664','2013-02-17','09:50:00',2.91),('12664','2013-02-17','09:55:00',2.96),('12664','2013-02-17','10:00:00',3.03),('12664','2013-02-17','10:05:00',3.09),('12664','2013-02-17','10:10:00',3.12),('12664','2013-02-17','10:15:00',3.19),('12664','2013-02-17','10:20:00',3.26),('12664','2013-02-17','10:25:00',3.32),('12664','2013-02-17','10:30:00',3.39),('12664','2013-02-17','10:35:00',3.42),('12664','2013-02-17','10:40:00',3.51),('12664','2013-02-17','10:45:00',3.54),('12664','2013-02-17','10:50:00',3.59),('12664','2013-02-17','10:55:00',3.63),('12664','2013-02-17','11:00:00',3.66),('12664','2013-02-17','11:05:00',3.7),('12664','2013-02-17','11:10:00',3.75),('12664','2013-02-17','11:15:00',3.76),('12664','2013-02-17','11:20:00',3.78),('12664','2013-02-17','11:25:00',3.74),('12664','2013-02-17','11:30:00',3.81),('12664','2013-02-17','11:35:00',3.86),('12664','2013-02-17','11:40:00',3.87),('12664','2013-02-17','11:45:00',3.86),('12664','2013-02-17','11:50:00',3.87),('12664','2013-02-17','11:55:00',3.83),('12664','2013-02-17','12:00:00',3.76),('12664','2013-02-17','12:05:00',3.86),('12664','2013-02-17','12:10:00',3.82),('12664','2013-02-17','12:15:00',3.8),('12664','2013-02-17','12:20:00',3.83),('12664','2013-02-17','12:25:00',3.79),('12664','2013-02-17','12:30:00',3.8),('12664','2013-02-17','12:35:00',3.79),('12664','2013-02-17','12:40:00',3.79),('12664','2013-02-17','12:45:00',3.78),('12664','2013-02-17','12:50:00',3.73),('12664','2013-02-17','12:55:00',3.74),('12664','2013-02-17','13:00:00',3.76),('12664','2013-02-17','13:05:00',3.74),('12664','2013-02-17','13:10:00',3.76),('12664','2013-02-17','13:15:00',3.74),('12664','2013-02-17','13:20:00',3.72),('12664','2013-02-17','13:25:00',3.69),('12664','2013-02-17','13:30:00',3.63),('12664','2013-02-17','13:35:00',3.18),('12664','2013-02-17','13:40:00',2.37),('12664','2013-02-17','13:45:00',3.62),('12664','2013-02-17','13:50:00',3.48),('12664','2013-02-17','13:55:00',3.46),('12664','2013-02-17','14:00:00',3.42),('12664','2013-02-17','14:05:00',3.08),('12664','2013-02-17','14:10:00',3.3),('12664','2013-02-17','14:15:00',3.28),('12664','2013-02-17','14:20:00',3.15),('12664','2013-02-17','14:25:00',3.03),('12664','2013-02-17','14:30:00',3.15),('12664','2013-02-17','14:35:00',3.05),('12664','2013-02-17','14:40:00',3.01),('12664','2013-02-17','14:45:00',2.94),('12664','2013-02-17','14:50:00',2.86),('12664','2013-02-17','14:55:00',2.82),('12664','2013-02-17','15:00:00',2.72),('12664','2013-02-17','15:05:00',2.62),('12664','2013-02-17','15:10:00',2.56),('12664','2013-02-17','15:15:00',2.46),('12664','2013-02-17','15:20:00',2.27),('12664','2013-02-17','15:25:00',2.08),('12664','2013-02-17','15:30:00',1.95),('12664','2013-02-17','15:35:00',2.1),('12664','2013-02-17','15:40:00',2.07),('12664','2013-02-17','15:45:00',1.87),('12664','2013-02-17','15:50:00',1.35),('12664','2013-02-17','15:55:00',1.75),('12664','2013-02-17','16:15:00',1),('12664','2013-02-17','16:20:00',1.07),('12664','2013-02-17','16:25:00',1.05),('12664','2013-02-16','08:10:00',1.06),('12664','2013-02-16','08:15:00',1.14),('12664','2013-02-16','08:20:00',1.23),('12664','2013-02-16','08:25:00',1.35),('12664','2013-02-16','08:30:00',1.41),('12664','2013-02-16','08:35:00',1.54),('12664','2013-02-16','08:40:00',1.67),('12664','2013-02-16','08:45:00',1.8),('12664','2013-02-16','08:50:00',1.9),('12664','2013-02-16','08:55:00',2.02),('12664','2013-02-16','09:00:00',2.13),('12664','2013-02-16','09:05:00',2.23),('12664','2013-02-16','09:10:00',2.29),('12664','2013-02-16','09:15:00',2.49),('12664','2013-02-16','09:20:00',2.68),('12664','2013-02-16','09:25:00',2.75),('12664','2013-02-16','09:30:00',2.81),('12664','2013-02-16','09:35:00',2.83),('12664','2013-02-16','09:40:00',2.9),('12664','2013-02-16','09:45:00',2.73),('12664','2013-02-16','09:50:00',2.87),('12664','2013-02-16','09:55:00',2.93),('12664','2013-02-16','10:00:00',3),('12664','2013-02-16','10:05:00',3.07),('12664','2013-02-16','10:10:00',3.2),('12664','2013-02-16','10:15:00',3.2),('12664','2013-02-16','10:20:00',3.31),('12664','2013-02-16','10:25:00',3.37),('12664','2013-02-16','10:30:00',3.43),('12664','2013-02-16','10:35:00',3.41),('12664','2013-02-16','10:40:00',3.46),('12664','2013-02-16','10:45:00',3.5),('12664','2013-02-16','10:50:00',3.55),('12664','2013-02-16','10:55:00',3.61),('12664','2013-02-16','11:00:00',3.65),('12664','2013-02-16','11:05:00',3.68),('12664','2013-02-16','11:10:00',3.7),('12664','2013-02-16','11:15:00',3.68),('12664','2013-02-16','11:20:00',3.72),('12664','2013-02-16','11:25:00',3.78),('12664','2013-02-16','11:30:00',3.73),('12664','2013-02-16','11:35:00',3.8),('12664','2013-02-16','11:40:00',3.89),('12664','2013-02-16','11:45:00',3.84),('12664','2013-02-16','11:50:00',3.92),('12664','2013-02-16','11:55:00',3.94),('12664','2013-02-16','12:00:00',3.94),('12664','2013-02-16','12:05:00',3.9),('12664','2013-02-16','12:10:00',3.91),('12664','2013-02-16','12:15:00',3.93),('12664','2013-02-16','12:20:00',3.95),('12664','2013-02-16','12:25:00',3.94),('12664','2013-02-16','12:30:00',3.98),('12664','2013-02-16','12:35:00',3.95),('12664','2013-02-16','12:40:00',3.95),('12664','2013-02-16','12:45:00',3.95),('12664','2013-02-16','12:50:00',3.96),('12664','2013-02-16','12:55:00',3.93),('12664','2013-02-16','13:00:00',3.92),('12664','2013-02-16','13:05:00',3.79),('12664','2013-02-16','13:10:00',3.85),('12664','2013-02-16','13:15:00',3.76),('12664','2013-02-16','13:20:00',3.58),('12664','2013-02-16','13:25:00',3.7),('12664','2013-02-16','13:30:00',3.7),('12664','2013-02-16','13:35:00',3.12),('12664','2013-02-16','13:40:00',3.64),('12664','2013-02-16','13:45:00',3.53),('12664','2013-02-16','13:50:00',3.58),('12664','2013-02-16','13:55:00',3.54),('12664','2013-02-16','14:00:00',3.46),('12664','2013-02-16','14:05:00',2.87),('12664','2013-02-16','14:10:00',3.38),('12664','2013-02-16','14:15:00',3.32),('12664','2013-02-16','14:20:00',3.27),('12664','2013-02-16','14:25:00',3.25),('12664','2013-02-16','14:30:00',2.71),('12664','2013-02-16','14:35:00',2.87),('12664','2013-02-16','14:40:00',3.19),('12664','2013-02-16','14:45:00',3.06),('12664','2013-02-16','14:50:00',2.95),('12664','2013-02-16','14:55:00',2.89),('12664','2013-02-16','15:00:00',2.67),('12664','2013-02-16','15:05:00',2.31),('12664','2013-02-16','15:10:00',3),('12664','2013-02-16','15:15:00',2.11),('12664','2013-02-16','15:20:00',1.23),('12664','2013-02-16','15:25:00',1.22),('12664','2013-02-16','15:30:00',1.49),('12664','2013-02-16','15:35:00',1.16),('12664','2013-02-16','15:40:00',1),('12664','2013-02-15','09:20:00',1.57),('12664','2013-02-15','09:25:00',1.35),('12664','2013-02-15','09:30:00',1.46),('12664','2013-02-15','09:35:00',1.8),('12664','2013-02-15','09:40:00',2.17),('12664','2013-02-15','09:45:00',1.8),('12664','2013-02-15','09:50:00',2.6),('12664','2013-02-15','09:55:00',2.54),('12664','2013-02-15','10:00:00',2.77),('12664','2013-02-15','10:05:00',2.67),('12664','2013-02-15','10:10:00',1.85),('12664','2013-02-15','10:15:00',2.21),('12664','2013-02-15','10:20:00',2.3),('12664','2013-02-15','10:25:00',3.26),('12664','2013-02-15','10:30:00',3.35),('12664','2013-02-15','10:35:00',3.26),('12664','2013-02-15','10:40:00',3.47),('12664','2013-02-15','10:45:00',1.98),('12664','2013-02-15','10:50:00',1.98),('12664','2013-02-15','10:55:00',2.25),('12664','2013-02-15','11:00:00',2.11),('12664','2013-02-15','11:05:00',2.75),('12664','2013-02-15','11:10:00',4.04),('12664','2013-02-15','11:15:00',3.99),('12664','2013-02-15','11:20:00',3.98),('12664','2013-02-15','11:25:00',4.02),('12664','2013-02-15','11:30:00',3.99),('12664','2013-02-15','11:35:00',4.07),('12664','2013-02-15','11:40:00',4.16),('12664','2013-02-15','11:45:00',3.22),('12664','2013-02-15','11:50:00',3.6),('12664','2013-02-15','11:55:00',3.06),('12664','2013-02-15','12:00:00',2.52),('12664','2013-02-15','12:05:00',2.67),('12664','2013-02-15','12:10:00',4.19),('12664','2013-02-15','12:15:00',3.5),('12664','2013-02-15','12:20:00',4.35),('12664','2013-02-15','12:25:00',4.12),('12664','2013-02-15','12:30:00',3.94),('12664','2013-02-15','12:35:00',3.94),('12664','2013-02-15','12:40:00',3.95),('12664','2013-02-15','12:45:00',3.93),('12664','2013-02-15','12:50:00',3.99),('12664','2013-02-15','12:55:00',3.97),('12664','2013-02-15','13:00:00',4.03),('12664','2013-02-15','13:05:00',4.01),('12664','2013-02-15','13:10:00',2.32),('12664','2013-02-15','13:15:00',2.37),('12664','2013-02-15','13:20:00',2.43),('12664','2013-02-15','13:25:00',1.95),('12664','2013-02-15','13:30:00',3.46),('12664','2013-02-15','13:35:00',2.6),('12664','2013-02-15','13:40:00',2.4),('12664','2013-02-15','13:45:00',3.67),('12664','2013-02-15','13:50:00',3.83),('12664','2013-02-15','13:55:00',4.11),('12664','2013-02-15','14:00:00',3.28),('12664','2013-02-15','14:05:00',2.79),('12664','2013-02-15','14:10:00',3.34),('12664','2013-02-15','14:15:00',3.01),('12664','2013-02-15','14:20:00',2.48),('12664','2013-02-15','14:25:00',2.75),('12664','2013-02-15','14:30:00',3.14),('12664','2013-02-15','14:35:00',2.84),('12664','2013-02-15','14:40:00',3.2),('12664','2013-02-15','14:45:00',2.14),('12664','2013-02-15','14:50:00',2.53),('12664','2013-02-15','14:55:00',1.5),('12664','2013-02-15','15:00:00',1.73),('12664','2013-02-15','15:05:00',2.69),('12664','2013-02-15','15:10:00',2.23),('12664','2013-02-15','15:15:00',2.52),('12664','2013-02-15','15:20:00',2.09),('12664','2013-02-15','15:25:00',1.31),('12664','2013-02-15','15:30:00',1.17),('12664','2013-02-15','15:35:00',1.44),('12664','2013-02-15','15:40:00',1.29),('12664','2013-02-14','08:05:00',1.03),('12664','2013-02-14','08:10:00',1.16),('12664','2013-02-14','08:15:00',1.24),('12664','2013-02-14','08:20:00',1.35),('12664','2013-02-14','08:25:00',1.56),('12664','2013-02-14','08:30:00',1.66),('12664','2013-02-14','08:35:00',1.76),('12664','2013-02-14','08:40:00',1.86),('12664','2013-02-14','08:45:00',1.97),('12664','2013-02-14','08:50:00',2.07),('12664','2013-02-14','08:55:00',2.17),('12664','2013-02-14','09:00:00',2.27),('12664','2013-02-14','09:05:00',2.38),('12664','2013-02-14','09:10:00',2.47),('12664','2013-02-14','09:15:00',2.56),('12664','2013-02-14','09:20:00',2.64),('12664','2013-02-14','09:25:00',2.73),('12664','2013-02-14','09:30:00',2.81),('12664','2013-02-14','09:35:00',2.89),('12664','2013-02-14','09:40:00',2.97),('12664','2013-02-14','09:45:00',3.05),('12664','2013-02-14','09:50:00',3.11),('12664','2013-02-14','09:55:00',3.2),('12664','2013-02-14','10:00:00',3.27),('12664','2013-02-14','10:05:00',3.34),('12664','2013-02-14','10:10:00',3.4),('12664','2013-02-14','10:15:00',3.45),('12664','2013-02-14','10:20:00',3.52),('12664','2013-02-14','10:25:00',3.57),('12664','2013-02-14','10:30:00',3.61),('12664','2013-02-14','10:35:00',3.66),('12664','2013-02-14','10:40:00',3.71),('12664','2013-02-14','10:45:00',3.76),('12664','2013-02-14','10:50:00',3.81),('12664','2013-02-14','10:55:00',3.83),('12664','2013-02-14','11:00:00',3.85),('12664','2013-02-14','11:05:00',3.91),('12664','2013-02-14','11:10:00',3.62),('12664','2013-02-14','11:15:00',3.73),('12664','2013-02-14','11:20:00',4),('12664','2013-02-14','11:25:00',4.01),('12664','2013-02-14','11:30:00',4.02),('12664','2013-02-14','11:35:00',4.05),('12664','2013-02-14','11:40:00',4.06),('12664','2013-02-14','11:45:00',4.07),('12664','2013-02-14','11:50:00',4.07),('12664','2013-02-14','11:55:00',4.09),('12664','2013-02-14','12:00:00',4.1),('12664','2013-02-14','12:05:00',4.12),('12664','2013-02-14','12:10:00',4.14),('12664','2013-02-14','12:15:00',4.14),('12664','2013-02-14','12:20:00',4.12),('12664','2013-02-14','12:25:00',4.09),('12664','2013-02-14','12:30:00',4.09),('12664','2013-02-14','12:35:00',4.07),('12664','2013-02-14','12:40:00',4.06),('12664','2013-02-14','12:45:00',4.05),('12664','2013-02-14','12:50:00',4.06),('12664','2013-02-14','12:55:00',4.05),('12664','2013-02-14','13:00:00',4.02),('12664','2013-02-14','13:05:00',4.01),('12664','2013-02-14','13:10:00',3.99),('12664','2013-02-14','13:15:00',3.97),('12664','2013-02-14','13:20:00',3.96),('12664','2013-02-14','13:25:00',3.92),('12664','2013-02-14','13:30:00',3.86),('12664','2013-02-14','13:35:00',3.83),('12664','2013-02-14','13:40:00',3.79),('12664','2013-02-14','13:45:00',3.7),('12664','2013-02-14','13:50:00',3.67),('12664','2013-02-14','13:55:00',3.64),('12664','2013-02-14','14:00:00',3.58),('12664','2013-02-14','14:05:00',3.55),('12664','2013-02-14','14:10:00',3.49),('12664','2013-02-14','14:15:00',3.42),('12664','2013-02-14','14:20:00',3.36),('12664','2013-02-14','14:25:00',3.27),('12664','2013-02-14','14:30:00',3.25),('12664','2013-02-14','14:35:00',3.18),('12664','2013-02-14','14:40:00',3.12),('12664','2013-02-14','14:45:00',3.04),('12664','2013-02-14','14:50:00',2.98),('12664','2013-02-14','14:55:00',2.9),('12664','2013-02-14','15:00:00',2.82),('12664','2013-02-14','15:05:00',2.73),('12664','2013-02-14','15:10:00',2.64),('12664','2013-02-14','15:15:00',2.55),('12664','2013-02-14','15:20:00',2.47),('12664','2013-02-14','15:25:00',2.39),('12664','2013-02-14','15:30:00',2.31),('12664','2013-02-14','15:35:00',2.21),('12664','2013-02-14','15:40:00',2.09),('12664','2013-02-14','15:45:00',2.01),('12664','2013-02-14','15:50:00',1.9),('12664','2013-02-14','15:55:00',1.8),('12664','2013-02-14','16:00:00',1.69),('12664','2013-02-14','16:05:00',1.56),('12664','2013-02-14','16:10:00',1.42),('12664','2013-02-14','16:15:00',1.34),('12664','2013-02-14','16:20:00',1.25),('12664','2013-02-14','16:25:00',1.15),('12664','2013-02-14','16:30:00',1.04),('12664','2013-02-13','09:00:00',1.04),('12664','2013-02-13','09:05:00',1.11),('12664','2013-02-13','09:10:00',1.12),('12664','2013-02-13','09:15:00',1.29),('12664','2013-02-13','09:20:00',1.85),('12664','2013-02-13','09:25:00',2.16),('12664','2013-02-13','09:30:00',2.26),('12664','2013-02-13','09:35:00',2.38),('12664','2013-02-13','09:40:00',2.52),('12664','2013-02-13','09:45:00',2.59),('12664','2013-02-13','09:50:00',2.48),('12664','2013-02-13','09:55:00',2.53),('12664','2013-02-13','10:00:00',2.88),('12664','2013-02-13','10:05:00',3.18),('12664','2013-02-13','10:10:00',3.25),('12664','2013-02-13','10:15:00',3.29),('12664','2013-02-13','10:20:00',3.27),('12664','2013-02-13','10:25:00',2.96),('12664','2013-02-13','10:30:00',3.14),('12664','2013-02-13','10:35:00',3.28),('12664','2013-02-13','10:40:00',3.53),('12664','2013-02-13','10:45:00',3.67),('12664','2013-02-13','10:50:00',3.6),('12664','2013-02-13','10:55:00',3.7),('12664','2013-02-13','11:00:00',3.83),('12664','2013-02-13','11:05:00',3.92),('12664','2013-02-13','11:10:00',3.86),('12664','2013-02-13','11:15:00',3.81),('12664','2013-02-13','11:20:00',3.29),('12664','2013-02-13','11:25:00',3.36),('12664','2013-02-13','11:30:00',3.27),('12664','2013-02-13','11:35:00',1.62),('12664','2013-02-13','11:40:00',2.35),('12664','2013-02-13','11:45:00',4.23),('12664','2013-02-13','11:50:00',3.63),('12664','2013-02-13','11:55:00',3.22),('12664','2013-02-13','12:00:00',2.32),('12664','2013-02-13','12:05:00',4.05),('12664','2013-02-13','12:10:00',4.08),('12664','2013-02-13','12:15:00',2.71),('12664','2013-02-13','12:20:00',2.78),('12664','2013-02-13','12:25:00',3.21),('12664','2013-02-13','12:30:00',1.57),('12664','2013-02-13','12:35:00',1.37),('12664','2013-02-13','12:40:00',1.5),('12664','2013-02-13','12:45:00',1.73),('12664','2013-02-13','12:50:00',1.23),('12664','2013-02-13','12:55:00',1.15),('12664','2013-02-13','13:00:00',1.88),('12664','2013-02-13','13:05:00',1.62),('12664','2013-02-13','13:10:00',1.23),('12664','2013-02-13','13:15:00',1.43),('12664','2013-02-13','13:20:00',1.23),('12664','2013-02-13','13:25:00',1),('12664','2013-02-13','13:30:00',1.17),('12664','2013-02-13','13:35:00',2.64),('12664','2013-02-13','13:40:00',3.79),('12664','2013-02-13','13:45:00',3.61),('12664','2013-02-13','13:50:00',3.81),('12664','2013-02-13','13:55:00',3.8),('12664','2013-02-13','14:00:00',3.56),('12664','2013-02-13','14:05:00',3.62),('12664','2013-02-13','14:10:00',3.58),('12664','2013-02-13','14:15:00',3.17),('12664','2013-02-13','14:20:00',2.83),('12664','2013-02-13','14:25:00',2.83),('12664','2013-02-13','14:30:00',2.72),('12664','2013-02-13','14:35:00',2.6),('12664','2013-02-13','14:40:00',2.92),('12664','2013-02-13','14:45:00',2.86),('12664','2013-02-13','14:50:00',2.88),('12664','2013-02-13','14:55:00',2.97),('12664','2013-02-13','15:00:00',2.87),('12664','2013-02-13','15:05:00',2.71),('12664','2013-02-13','15:10:00',2.68),('12664','2013-02-13','15:15:00',2.59),('12664','2013-02-13','15:20:00',2.52),('12664','2013-02-13','15:25:00',2.43),('12664','2013-02-13','15:30:00',2.31),('12664','2013-02-13','15:35:00',2.21),('12664','2013-02-13','15:40:00',2.13),('12664','2013-02-13','15:45:00',2.06),('12664','2013-02-13','15:50:00',1.93),('12664','2013-02-13','15:55:00',1.85),('12664','2013-02-13','16:00:00',1.76),('12664','2013-02-13','16:05:00',1.66),('12664','2013-02-13','16:10:00',1.53),('12664','2013-02-13','16:15:00',1.41),('12664','2013-02-13','16:20:00',1.29),('12664','2013-02-13','16:25:00',1.2),('12664','2013-02-13','16:30:00',1.09),('12664','2013-02-11','10:10:00',1.08),('12664','2013-02-11','10:15:00',1.14),('12664','2013-02-11','10:20:00',1.05),('12664','2013-02-11','11:15:00',1.22),('12664','2013-02-11','11:20:00',1.44),('12664','2013-02-11','11:40:00',1.01),('12664','2013-02-11','11:45:00',1.01),('12664','2013-02-11','14:10:00',1.04),('12664','2013-02-11','14:40:00',1.35),('12664','2013-02-11','14:45:00',1.16),('12664','2013-02-11','14:50:00',1.06),('12664','2013-02-10','09:15:00',1.31),('12664','2013-02-10','09:20:00',1.84),('12664','2013-02-10','09:25:00',2.84),('12664','2013-02-10','09:30:00',2.45),('12664','2013-02-10','09:35:00',1.67),('12664','2013-02-10','09:40:00',2.72),('12664','2013-02-10','09:45:00',3.02),('12664','2013-02-10','09:50:00',3.06),('12664','2013-02-10','09:55:00',3.06),('12664','2013-02-10','10:00:00',3.14),('12664','2013-02-10','10:05:00',3.18),('12664','2013-02-10','10:10:00',3.25),('12664','2013-02-10','10:15:00',3.31),('12664','2013-02-10','10:20:00',3.39),('12664','2013-02-10','10:25:00',3.46),('12664','2013-02-10','10:30:00',3.46),('12664','2013-02-10','10:35:00',3.5),('12664','2013-02-10','10:40:00',3.52),('12664','2013-02-10','10:45:00',3.56),('12664','2013-02-10','10:50:00',3.61),('12664','2013-02-10','10:55:00',3.66),('12664','2013-02-10','11:00:00',3.7),('12664','2013-02-10','11:05:00',3.72),('12664','2013-02-10','11:10:00',3.75),('12664','2013-02-10','11:15:00',3.77),('12664','2013-02-10','11:20:00',3.79),('12664','2013-02-10','11:25:00',3.83),('12664','2013-02-10','11:30:00',3.87),('12664','2013-02-10','11:35:00',3.88),('12664','2013-02-10','11:40:00',3.88),('12664','2013-02-10','11:45:00',3.94),('12664','2013-02-10','11:50:00',3.91),('12664','2013-02-10','11:55:00',3.8),('12664','2013-02-10','12:00:00',3.98),('12664','2013-02-10','12:05:00',3.97),('12664','2013-02-10','12:10:00',3.99),('12664','2013-02-10','12:15:00',4.03),('12664','2013-02-10','12:20:00',3.98),('12664','2013-02-10','12:25:00',3.94),('12664','2013-02-10','12:30:00',3.97),('12664','2013-02-10','12:35:00',3.94),('12664','2013-02-10','12:40:00',3.9),('12664','2013-02-10','12:45:00',3.93),('12664','2013-02-10','12:50:00',3.91),('12664','2013-02-10','12:55:00',3.92),('12664','2013-02-10','13:00:00',3.89),('12664','2013-02-10','13:05:00',3.86),('12664','2013-02-10','13:10:00',3.86),('12664','2013-02-10','13:15:00',3.84),('12664','2013-02-10','13:20:00',3.79),('12664','2013-02-10','13:25:00',3.77),('12664','2013-02-10','13:30:00',3.74),('12664','2013-02-10','13:35:00',3.69),('12664','2013-02-10','13:40:00',3.59),('12664','2013-02-10','13:45:00',3.55),('12664','2013-02-10','13:50:00',3.55),('12664','2013-02-10','13:55:00',3.5),('12664','2013-02-10','14:00:00',3.44),('12664','2013-02-10','14:05:00',3.41),('12664','2013-02-10','14:10:00',3.36),('12664','2013-02-10','14:15:00',3.31),('12664','2013-02-10','14:20:00',3.34),('12664','2013-02-10','14:25:00',3.22),('12664','2013-02-10','14:30:00',3.09),('12664','2013-02-10','14:35:00',3),('12664','2013-02-10','14:40:00',2.97),('12664','2013-02-10','14:45:00',2.87),('12664','2013-02-10','14:50:00',2.74),('12664','2013-02-10','14:55:00',2.69),('12664','2013-02-10','15:00:00',2.72),('12664','2013-02-10','15:05:00',2.11),('12664','2013-02-10','15:10:00',2),('12664','2013-02-10','15:15:00',1.06),('12664','2013-02-10','15:30:00',1),('12664','2013-02-10','15:45:00',1.24),('12664','2013-02-10','15:50:00',1.62),('12664','2013-02-10','15:55:00',1.32),('12664','2013-02-10','16:00:00',1.25),('12664','2013-02-10','16:05:00',1.12),('12664','2013-02-10','16:10:00',1.02),('12664','2013-02-10','16:15:00',1.67),('12664','2013-02-10','16:20:00',1.69),('12664','2013-02-10','16:25:00',1.33),('12664','2013-02-10','16:30:00',1.13),('12664','2014-03-21','07:45:00',1.03),('12664','2014-03-21','07:50:00',1.17),('12664','2014-03-21','07:55:00',1.28),('12664','2014-03-21','08:00:00',1.36),('12664','2014-03-21','08:05:00',1.43),('12664','2014-03-21','08:10:00',1.38),('12664','2014-03-21','08:15:00',1.6),('12664','2014-03-21','08:20:00',1.68),('12664','2014-03-21','08:25:00',1.79),('12664','2014-03-21','08:30:00',1.88),('12664','2014-03-21','08:35:00',1.96),('12664','2014-03-21','08:40:00',2.04),('12664','2014-03-21','08:45:00',2.1),('12664','2014-03-21','08:50:00',2.16),('12664','2014-03-21','08:55:00',2.27),('12664','2014-03-21','09:00:00',2.35),('12664','2014-03-21','09:05:00',2.41),('12664','2014-03-21','09:10:00',2.5),('12664','2014-03-21','09:15:00',2.58),('12664','2014-03-21','09:20:00',2.63),('12664','2014-03-21','09:25:00',2.63),('12664','2014-03-21','09:30:00',2.66),('12664','2014-03-21','09:35:00',2.8),('12664','2014-03-21','09:40:00',2.85),('12664','2014-03-21','09:45:00',2.89),('12664','2014-03-21','09:50:00',2.92),('12664','2014-03-21','09:55:00',2.71),('12664','2014-03-21','10:00:00',3.06),('12664','2014-03-21','10:05:00',3.03),('12664','2014-03-21','10:10:00',3.06),('12664','2014-03-21','10:15:00',3.06),('12664','2014-03-21','10:20:00',3.14),('12664','2014-03-21','10:25:00',3.15),('12664','2014-03-21','10:30:00',3.09),('12664','2014-03-21','10:35:00',3.16),('12664','2014-03-21','10:40:00',3.15),('12664','2014-03-21','10:45:00',3.19),('12664','2014-03-21','10:50:00',3.21),('12664','2014-03-21','10:55:00',3.32),('12664','2014-03-21','11:00:00',3.37),('12664','2014-03-21','11:05:00',3.33),('12664','2014-03-21','11:10:00',3.41),('12664','2014-03-21','11:15:00',3.51),('12664','2014-03-21','11:20:00',3.5),('12664','2014-03-21','11:25:00',3.57),('12664','2014-03-21','11:30:00',3.58),('12664','2014-03-21','11:35:00',3.58),('12664','2014-03-21','11:40:00',3.57),('12664','2014-03-21','11:45:00',3.66),('12664','2014-03-21','11:50:00',3.62),('12664','2014-03-21','11:55:00',3.66),('12664','2014-03-21','12:00:00',3.7),('12664','2014-03-21','12:05:00',3.74),('12664','2014-03-21','12:10:00',3.72),('12664','2014-03-21','12:15:00',3.72),('12664','2014-03-21','12:20:00',3.72),('12664','2014-03-21','12:25:00',3.77),('12664','2014-03-21','12:30:00',3.74),('12664','2014-03-21','12:35:00',3.72),('12664','2014-03-21','12:40:00',3.73),('12664','2014-03-21','12:45:00',3.75),('12664','2014-03-21','12:50:00',3.75),('12664','2014-03-21','12:55:00',3.7),('12664','2014-03-21','13:00:00',3.65),('12664','2014-03-21','13:05:00',3.69),('12664','2014-03-21','13:10:00',3.67),('12664','2014-03-21','13:15:00',3.68),('12664','2014-03-21','13:20:00',3.67),('12664','2014-03-21','13:25:00',3.63),('12664','2014-03-21','13:30:00',3.6),('12664','2014-03-21','13:35:00',3.57),('12664','2014-03-21','13:40:00',3.52),('12664','2014-03-21','13:45:00',3.49),('12664','2014-03-21','13:50:00',3.48),('12664','2014-03-21','13:55:00',3.47),('12664','2014-03-21','14:00:00',3.45),('12664','2014-03-21','14:05:00',3.4),('12664','2014-03-21','14:10:00',3.34),('12664','2014-03-21','14:15:00',3.31),('12664','2014-03-21','14:20:00',3.25),('12664','2014-03-21','14:25:00',3.19),('12664','2014-03-21','14:30:00',3.12),('12664','2014-03-21','14:35:00',2.97),('12664','2014-03-21','14:40:00',2.13),('12664','2014-03-21','14:45:00',2.14),('12664','2014-03-21','14:55:00',1.62),('12664','2014-03-21','15:00:00',2.62),('12664','2014-03-21','15:05:00',2.87),('12664','2014-03-21','15:10:00',3.04),('12664','2014-03-21','15:15:00',2.85),('12664','2014-03-21','15:20:00',1.97),('12664','2014-03-21','15:25:00',1.82),('12664','2014-03-21','15:30:00',2.62),('12664','2014-03-21','15:35:00',2.55),('12664','2014-03-21','15:40:00',2.48),('12664','2014-03-21','15:45:00',2.14),('12664','2014-03-21','15:50:00',2.33),('12664','2014-03-21','15:55:00',2.28),('12664','2014-03-21','16:00:00',2.13),('12664','2014-03-21','16:05:00',1.97),('12664','2014-03-21','16:10:00',1.79),('12664','2014-03-21','16:15:00',1.67),('12664','2014-03-21','16:20:00',1.5),('12664','2014-03-21','16:25:00',1.42),('12664','2014-03-21','16:30:00',1.3),('12664','2014-03-21','16:35:00',1.2),('12664','2014-03-21','16:40:00',1.11),('12664','2013-02-09','10:50:00',1.14),('12664','2013-02-09','10:55:00',1.21),('12664','2013-02-09','11:00:00',1.25),('12664','2013-02-09','11:05:00',1.33),('12664','2013-02-09','11:10:00',1.38),('12664','2013-02-09','11:15:00',1.43),('12664','2013-02-09','11:20:00',1.4),('12664','2013-02-09','11:25:00',1.32),('12664','2013-02-09','11:30:00',1.34),('12664','2013-02-09','11:35:00',1.36),('12664','2013-02-09','11:40:00',1.35),('12664','2013-02-09','11:45:00',1.33),('12664','2013-02-09','11:50:00',1.31),('12664','2013-02-09','11:55:00',1.32),('12664','2013-02-09','12:00:00',1.41),('12664','2013-02-09','12:05:00',1.43),('12664','2013-02-09','12:10:00',1.31),('12664','2013-02-09','12:15:00',1.26),('12664','2013-02-09','12:20:00',1.26),('12664','2013-02-09','12:25:00',1.27),('12664','2013-02-09','12:30:00',1.3),('12664','2013-02-09','12:35:00',1.3),('12664','2013-02-09','12:40:00',1.3),('12664','2013-02-09','12:45:00',1.43),('12664','2013-02-09','12:50:00',1.64),('12664','2013-02-09','12:55:00',1.81),('12664','2013-02-09','13:00:00',2.12),('12664','2013-02-09','13:05:00',2.45),('12664','2013-02-09','13:10:00',2.46),('12664','2013-02-09','13:15:00',2.62),('12664','2013-02-09','13:20:00',2.97),('12664','2013-02-09','13:25:00',3.21),('12664','2013-02-09','13:30:00',3.79),('12664','2013-02-09','13:35:00',3.9),('12664','2013-02-09','13:40:00',3.91),('12664','2013-02-09','13:45:00',3.75),('12664','2013-02-09','13:50:00',3.78),('12664','2013-02-09','13:55:00',3.58),('12664','2013-02-09','14:00:00',3.3),('12664','2013-02-09','14:05:00',1.19),('12664','2013-02-09','14:10:00',2.97),('12664','2013-02-09','14:15:00',3.94),('12664','2013-02-09','14:20:00',3.62),('12664','2013-02-09','14:25:00',3.3),('12664','2013-02-09','14:30:00',2.82),('12664','2013-02-09','14:35:00',2.2),('12664','2013-02-09','14:40:00',2.82),('12664','2013-02-09','14:45:00',2.97),('12664','2013-02-09','14:50:00',2.82),('12664','2013-02-09','14:55:00',2.71),('12664','2013-02-09','15:00:00',2.54),('12664','2013-02-09','15:05:00',2.16),('12664','2013-02-09','15:10:00',2.51),('12664','2013-02-09','15:15:00',2.33),('12664','2013-02-09','15:20:00',1.97),('12664','2013-02-09','15:25:00',1),('12664','2013-02-09','15:30:00',1.99),('12664','2013-02-09','15:35:00',2.15),('12664','2013-02-09','15:40:00',2.21),('12664','2013-02-09','15:45:00',1.28),('12664','2013-02-09','15:50:00',1.29),('12664','2013-02-09','15:55:00',1.58),('12664','2013-02-09','16:00:00',1.8),('12664','2013-02-09','16:05:00',1.75),('12664','2013-02-09','16:10:00',1.37),('12664','2013-02-09','16:15:00',1.53),('12664','2013-02-09','16:20:00',1.55),('12664','2013-02-09','16:25:00',1.38),('12664','2013-02-09','16:30:00',1.25),('12664','2013-02-09','16:40:00',1.13),('12664','2013-02-08','09:25:00',1.01),('12664','2013-02-08','09:55:00',1.71),('12664','2013-02-08','10:00:00',3.52),('12664','2013-02-08','10:05:00',3.43),('12664','2013-02-08','10:10:00',3.23),('12664','2013-02-08','10:15:00',3.52),('12664','2013-02-08','10:20:00',3.53),('12664','2013-02-08','10:25:00',3.58),('12664','2013-02-08','10:30:00',3.69),('12664','2013-02-08','10:35:00',3.92),('12664','2013-02-08','10:40:00',3.84),('12664','2013-02-08','10:45:00',2.54),('12664','2013-02-08','10:50:00',2.07),('12664','2013-02-08','10:55:00',1.76),('12664','2013-02-08','11:00:00',2.94),('12664','2013-02-08','11:05:00',2.32),('12664','2013-02-08','11:10:00',3.62),('12664','2013-02-08','11:15:00',3.85),('12664','2013-02-08','11:20:00',3.84),('12664','2013-02-08','11:25:00',3.86),('12664','2013-02-08','11:30:00',3.83),('12664','2013-02-08','11:35:00',3.84),('12664','2013-02-08','11:40:00',3.89),('12664','2013-02-08','11:45:00',3.91),('12664','2013-02-08','11:50:00',3.89),('12664','2013-02-08','11:55:00',3.91),('12664','2013-02-08','12:00:00',3.95),('12664','2013-02-08','12:05:00',3.95),('12664','2013-02-08','12:10:00',3.95),('12664','2013-02-08','12:15:00',4.14),('12664','2013-02-08','12:20:00',4.41),('12664','2013-02-08','12:25:00',3.7),('12664','2013-02-08','12:30:00',3.31),('12664','2013-02-08','12:35:00',3.39),('12664','2013-02-08','12:40:00',2.44),('12664','2013-02-08','12:45:00',2.51),('12664','2013-02-08','12:50:00',2.84),('12664','2013-02-08','12:55:00',2.82),('12664','2013-02-08','13:00:00',1.79),('12664','2013-02-08','13:05:00',1.7),('12664','2013-02-08','13:10:00',1.74),('12664','2013-02-08','13:15:00',1.94),('12664','2013-02-08','13:20:00',1.72),('12664','2013-02-08','13:25:00',1.6),('12664','2013-02-08','13:30:00',1.39),('12664','2013-02-08','13:35:00',1.42),('12664','2013-02-08','13:40:00',1.39),('12664','2013-02-08','13:45:00',1.49),('12664','2013-02-08','13:50:00',1.54),('12664','2013-02-08','13:55:00',1.7),('12664','2013-02-08','14:00:00',1.99),('12664','2013-02-08','14:05:00',2.4),('12664','2013-02-08','14:10:00',1.82),('12664','2013-02-08','14:15:00',1.76),('12664','2013-02-08','14:20:00',2.34),('12664','2013-02-08','14:25:00',3.25),('12664','2013-02-08','14:30:00',2.08),('12664','2013-02-08','14:35:00',2.13),('12664','2013-02-08','14:40:00',2.95),('12664','2013-02-08','14:45:00',3.02),('12664','2013-02-08','14:50:00',3.36),('12664','2013-02-08','14:55:00',3.38),('12664','2013-02-08','15:00:00',3.01),('12664','2013-02-08','15:05:00',2.97),('12664','2013-02-08','15:10:00',2.69),('12664','2013-02-08','15:15:00',2.6),('12664','2013-02-08','15:20:00',2.57),('12664','2013-02-08','15:25:00',2.46),('12664','2013-02-08','15:30:00',2.44),('12664','2013-02-08','15:35:00',2.38),('12664','2013-02-08','15:40:00',2.13),('12664','2013-02-08','15:45:00',2.11),('12664','2013-02-08','15:50:00',1.95),('12664','2013-02-08','16:00:00',1.74),('12664','2013-02-07','09:15:00',1.11),('12664','2013-02-07','10:15:00',1.32),('12664','2013-02-07','10:20:00',1.38),('12664','2013-02-07','10:25:00',2.02),('12664','2013-02-07','10:30:00',1.88),('12664','2013-02-07','10:35:00',2.39),('12664','2013-02-07','10:40:00',2.74),('12664','2013-02-07','10:45:00',2.41),('12664','2013-02-07','10:50:00',2.41),('12664','2013-02-07','10:55:00',3.08),('12664','2013-02-07','11:00:00',3.14),('12664','2013-02-07','11:05:00',1.88),('12664','2013-02-07','11:10:00',4.28),('12664','2013-02-07','11:15:00',1.2),('12664','2013-02-07','12:15:00',1.06),('12664','2013-02-07','12:20:00',2.71),('12664','2013-02-07','12:25:00',2.1),('12664','2013-02-07','12:30:00',2.18),('12664','2013-02-07','12:35:00',1.33),('12664','2013-02-07','12:40:00',1.09),('12664','2013-02-07','12:45:00',1.03),('12664','2013-02-07','13:05:00',1.19),('12664','2013-02-07','13:10:00',3.92),('12664','2013-02-07','13:15:00',4.69),('12664','2013-02-07','13:20:00',3.87),('12664','2013-02-07','13:25:00',1.75),('12664','2013-02-07','13:30:00',1.09),('12664','2013-02-07','13:45:00',1.02),('12664','2013-02-07','13:50:00',1.03),('12664','2013-02-07','13:55:00',1.74),('12664','2013-02-07','14:00:00',1.94),('12664','2013-02-07','14:05:00',3.35),('12664','2013-02-07','14:10:00',2.57),('12664','2013-02-07','14:15:00',2.78),('12664','2013-02-07','14:20:00',1.95),('12664','2013-02-07','14:25:00',1.43),('12664','2013-02-07','14:30:00',1.46),('12664','2013-02-07','14:40:00',1.62),('12664','2013-02-07','14:45:00',2.12),('12664','2013-02-07','14:50:00',1.42),('12664','2013-02-07','14:55:00',2.16),('12664','2013-02-07','15:00:00',2.35),('12664','2013-02-07','15:05:00',3.16),('12664','2013-02-07','15:10:00',2.72),('12664','2013-02-07','15:15:00',2.51),('12664','2013-02-07','15:20:00',1.16),('12664','2013-02-07','15:25:00',1.44),('12664','2013-02-07','15:30:00',2.45),('12664','2013-02-07','15:35:00',1.79),('12664','2013-02-06','08:45:00',1.05),('12664','2013-02-06','08:50:00',1.04),('12664','2013-02-06','08:55:00',1.08),('12664','2013-02-06','09:00:00',1.25),('12664','2013-02-06','09:05:00',1.23),('12664','2013-02-06','09:10:00',1.06),('12664','2013-02-06','09:15:00',1.04),('12664','2013-02-06','09:20:00',1.11),('12664','2013-02-06','09:25:00',1.27),('12664','2013-02-06','09:30:00',1.38),('12664','2013-02-06','09:35:00',1.24),('12664','2013-02-06','09:40:00',1.25),('12664','2013-02-06','09:45:00',1.51),('12664','2013-02-06','09:50:00',1.87),('12664','2013-02-06','09:55:00',1.54),('12664','2013-02-06','10:00:00',1.31),('12664','2013-02-06','10:05:00',1.49),('12664','2013-02-06','10:10:00',1.43),('12664','2013-02-06','10:15:00',1.84),('12664','2013-02-06','10:20:00',3.63),('12664','2013-02-06','10:25:00',2.28),('12664','2013-02-06','10:30:00',1.35),('12664','2013-02-06','10:35:00',1.29),('12664','2013-02-06','10:40:00',1.07),('12664','2013-02-06','10:45:00',1.19),('12664','2013-02-06','10:50:00',1.66),('12664','2013-02-06','10:55:00',1.63),('12664','2013-02-06','11:00:00',1.5),('12664','2013-02-06','11:05:00',1.85),('12664','2013-02-06','11:10:00',1.54),('12664','2013-02-06','11:15:00',2.4),('12664','2013-02-06','11:20:00',2.15),('12664','2013-02-06','11:25:00',1.49),('12664','2013-02-06','11:30:00',1.69),('12664','2013-02-06','11:35:00',1.63),('12664','2013-02-06','11:40:00',1.5),('12664','2013-02-06','11:45:00',1.54),('12664','2013-02-06','11:50:00',1.44),('12664','2013-02-06','11:55:00',1.04),('12664','2013-02-06','12:05:00',1.37),('12664','2013-02-06','12:10:00',1.38),('12664','2013-02-06','12:15:00',1.18),('12664','2013-02-06','12:20:00',1.03),('12664','2013-02-06','13:10:00',1.07),('12664','2013-02-06','13:15:00',1.31),('12664','2013-02-06','13:20:00',1.91),('12664','2013-02-06','13:25:00',2.25),('12664','2013-02-06','13:30:00',2.27),('12664','2013-02-06','13:35:00',1.65),('12664','2013-02-06','13:40:00',1.54),('12664','2013-02-06','13:45:00',2.28),('12664','2013-02-06','13:50:00',2.65),('12664','2013-02-06','13:55:00',1.52),('12664','2013-02-06','14:00:00',1.08),('12664','2013-02-06','14:05:00',1.01),('12664','2013-02-06','14:25:00',1.13),('12664','2013-02-06','14:30:00',2.15),('12664','2013-02-06','15:15:00',1.71),('12664','2013-02-06','15:20:00',2.19),('12664','2013-02-05','08:15:00',1),('12664','2013-02-05','08:20:00',1.11),('12664','2013-02-05','08:25:00',1.22),('12664','2013-02-05','08:30:00',1.33),('12664','2013-02-05','08:35:00',1.44),('12664','2013-02-05','08:40:00',1.55),('12664','2013-02-05','08:45:00',1.66),('12664','2013-02-05','08:50:00',1.78),('12664','2013-02-05','08:55:00',1.88),('12664','2013-02-05','09:00:00',1.98),('12664','2013-02-05','09:05:00',2.08),('12664','2013-02-05','09:10:00',2.18),('12664','2013-02-05','09:15:00',2.26),('12664','2013-02-05','09:20:00',2.34),('12664','2013-02-05','09:25:00',2.43),('12664','2013-02-05','09:30:00',2.5),('12664','2013-02-05','09:35:00',2.59),('12664','2013-02-05','09:40:00',2.65),('12664','2013-02-05','09:45:00',2.73),('12664','2013-02-05','09:50:00',2.78),('12664','2013-02-05','09:55:00',2.84),('12664','2013-02-05','10:00:00',2.87),('12664','2013-02-05','10:05:00',2.77),('12664','2013-02-05','10:10:00',2.93),('12664','2013-02-05','10:15:00',3.1),('12664','2013-02-05','10:20:00',3.15),('12664','2013-02-05','10:25:00',3.19),('12664','2013-02-05','10:30:00',3.23),('12664','2013-02-05','10:35:00',3.26),('12664','2013-02-05','10:40:00',3.31),('12664','2013-02-05','10:45:00',3.35),('12664','2013-02-05','10:50:00',3.41),('12664','2013-02-05','10:55:00',3.47),('12664','2013-02-05','11:00:00',3.41),('12664','2013-02-05','11:05:00',3.46),('12664','2013-02-05','11:10:00',3.49),('12664','2013-02-05','11:15:00',3.6),('12664','2013-02-05','11:20:00',3.62),('12664','2013-02-05','11:25:00',2.53),('12664','2013-02-05','11:30:00',3.68),('12664','2013-02-05','11:35:00',2.41),('12664','2013-02-05','11:40:00',3.02),('12664','2013-02-05','11:45:00',3.5),('12664','2013-02-05','11:50:00',3.97),('12664','2013-02-05','11:55:00',3.67),('12664','2013-02-05','12:00:00',3.85),('12664','2013-02-05','12:05:00',4.15),('12664','2013-02-05','12:10:00',1.92),('12664','2013-02-05','12:15:00',2.06),('12664','2013-02-05','12:20:00',2.96),('12664','2013-02-05','12:25:00',3.28),('12664','2013-02-05','12:30:00',3.63),('12664','2013-02-05','12:35:00',2.74),('12664','2013-02-05','12:40:00',1.87),('12664','2013-02-05','12:45:00',2.16),('12664','2013-02-05','12:50:00',1.41),('12664','2013-02-05','13:00:00',1.61),('12664','2013-02-05','13:05:00',2.28),('12664','2013-02-05','13:10:00',2.38),('12664','2013-02-05','13:15:00',1.77),('12664','2013-02-05','13:20:00',1.54),('12664','2013-02-05','13:25:00',1.2),('12664','2013-02-05','13:30:00',1.41),('12664','2013-02-05','13:35:00',1.33),('12664','2013-02-05','13:40:00',1.61),('12664','2013-02-05','13:45:00',1.57),('12664','2013-02-05','13:50:00',1.48),('12664','2013-02-05','13:55:00',1.59),('12664','2013-02-05','14:00:00',1.3),('12664','2013-02-05','14:05:00',1.09),('12664','2013-02-05','14:10:00',1.47),('12664','2013-02-05','14:15:00',1.62),('12664','2013-02-05','14:20:00',1.82),('12664','2013-02-05','14:25:00',1.67),('12664','2013-02-05','14:30:00',1.51),('12664','2013-02-05','14:35:00',1.8),('12664','2013-02-05','14:40:00',1.86),('12664','2013-02-05','14:45:00',1.57),('12664','2013-02-05','14:50:00',1.2),('12664','2013-02-04','08:15:00',1.09),('12664','2013-02-04','08:20:00',1.2),('12664','2013-02-04','08:25:00',1.32),('12664','2013-02-04','08:30:00',1.44),('12664','2013-02-04','08:35:00',1.57),('12664','2013-02-04','08:40:00',1.69),('12664','2013-02-04','08:45:00',1.79),('12664','2013-02-04','08:50:00',1.9),('12664','2013-02-04','08:55:00',2.02),('12664','2013-02-04','09:00:00',2.14),('12664','2013-02-04','09:05:00',2.29),('12664','2013-02-04','09:10:00',2.29),('12664','2013-02-04','09:15:00',1.85),('12664','2013-02-04','09:20:00',2.12),('12664','2013-02-04','09:25:00',2.52),('12664','2013-02-04','09:30:00',2.47),('12664','2013-02-04','09:35:00',2.91),('12664','2013-02-04','09:40:00',2.91),('12664','2013-02-04','09:45:00',3),('12664','2013-02-04','09:50:00',3.11),('12664','2013-02-04','09:55:00',3.22),('12664','2013-02-04','10:00:00',3.31),('12664','2013-02-04','10:05:00',3.36),('12664','2013-02-04','10:10:00',3.28),('12664','2013-02-04','10:15:00',2.86),('12664','2013-02-04','10:20:00',3.12),('12664','2013-02-04','10:25:00',3.37),('12664','2013-02-04','10:30:00',3.25),('12664','2013-02-04','10:35:00',3.52),('12664','2013-02-04','10:40:00',3.57),('12664','2013-02-04','10:45:00',3.61),('12664','2013-02-04','10:50:00',3.62),('12664','2013-02-04','10:55:00',3.62),('12664','2013-02-04','11:00:00',3.71),('12664','2013-02-04','11:05:00',3.72),('12664','2013-02-04','11:10:00',3.74),('12664','2013-02-04','11:15:00',3.77),('12664','2013-02-04','11:20:00',3.78),('12664','2013-02-04','11:25:00',3.81),('12664','2013-02-04','11:30:00',3.84),('12664','2013-02-04','11:35:00',3.85),('12664','2013-02-04','11:40:00',3.86),('12664','2013-02-04','11:45:00',3.85),('12664','2013-02-04','11:50:00',3.86),('12664','2013-02-04','11:55:00',3.88),('12664','2013-02-04','12:00:00',3.91),('12664','2013-02-04','12:05:00',3.9),('12664','2013-02-04','12:10:00',3.9),('12664','2013-02-04','12:15:00',3.9),('12664','2013-02-04','12:20:00',3.9),('12664','2013-02-04','12:25:00',3.9),('12664','2013-02-04','12:30:00',3.89),('12664','2013-02-04','12:35:00',3.88),('12664','2013-02-04','12:40:00',3.87),('12664','2013-02-04','12:45:00',3.85),('12664','2013-02-04','12:50:00',3.84),('12664','2013-02-04','12:55:00',3.83),('12664','2013-02-04','13:00:00',3.82),('12664','2013-02-04','13:05:00',3.78),('12664','2013-02-04','13:10:00',3.76),('12664','2013-02-04','13:15:00',3.76),('12664','2013-02-04','13:20:00',3.71),('12664','2013-02-04','13:25:00',3.7),('12664','2013-02-04','13:30:00',3.65),('12664','2013-02-04','13:35:00',3.61),('12664','2013-02-04','13:40:00',3.56),('12664','2013-02-04','13:45:00',3.54),('12664','2013-02-04','13:50:00',3.49),('12664','2013-02-04','13:55:00',3.43),('12664','2013-02-04','14:00:00',3.38),('12664','2013-02-04','14:05:00',3.35),('12664','2013-02-04','14:10:00',3.3),('12664','2013-02-04','14:15:00',3.25),('12664','2013-02-04','14:20:00',3.19),('12664','2013-02-04','14:25:00',3.14),('12664','2013-02-04','14:30:00',3.1),('12664','2013-02-04','14:35:00',3.03),('12664','2013-02-04','14:40:00',2.96),('12664','2013-02-04','14:45:00',2.89),('12664','2013-02-04','14:50:00',2.82),('12664','2013-02-04','14:55:00',2.75),('12664','2013-02-04','15:00:00',2.67),('12664','2013-02-04','15:05:00',2.57),('12664','2013-02-04','15:10:00',2.5),('12664','2013-02-04','15:15:00',2.41),('12664','2013-02-04','15:20:00',2.3),('12664','2013-02-04','15:25:00',2.21),('12664','2013-02-04','15:30:00',2.14),('12664','2013-02-04','15:35:00',2.02),('12664','2013-02-04','15:40:00',1.92),('12664','2013-02-04','15:45:00',1.83),('12664','2013-02-04','15:50:00',1.73),('12664','2013-02-04','15:55:00',1.63),('12664','2013-02-04','16:00:00',1.53),('12664','2013-02-04','16:05:00',1.42),('12664','2013-02-04','16:10:00',1.31),('12664','2013-02-04','16:15:00',1.19),('12664','2013-02-04','16:20:00',1.09),('12664','2013-02-03','09:10:00',1.6),('12664','2013-02-03','09:15:00',1.15),('12664','2013-02-03','09:20:00',1.03),('12664','2013-02-03','09:25:00',1.13),('12664','2013-02-03','09:30:00',1.46),('12664','2013-02-03','09:35:00',1.68),('12664','2013-02-03','09:40:00',2.28),('12664','2013-02-03','09:45:00',3.2),('12664','2013-02-03','09:50:00',1.15),('12664','2013-02-03','10:55:00',1.14),('12664','2013-02-03','11:00:00',1.14),('12664','2013-02-03','11:20:00',1.53),('12664','2013-02-03','11:25:00',3.55),('12664','2013-02-03','11:30:00',1.61),('12664','2013-02-03','11:50:00',1.12),('12664','2013-02-03','12:15:00',1.99),('12664','2013-02-03','12:20:00',1.08),('12664','2013-02-02','10:10:00',1.19),('12664','2013-02-02','10:15:00',2.02),('12664','2013-02-02','10:20:00',1.66),('12664','2013-02-02','10:25:00',1.28),('12664','2013-02-02','10:30:00',1.35),('12664','2013-02-02','10:35:00',1.69),('12664','2013-02-02','10:40:00',2.22),('12664','2013-02-02','10:45:00',2.44),('12664','2013-02-02','10:50:00',2.46),('12664','2013-02-02','10:55:00',2.21),('12664','2013-02-02','11:00:00',2.33),('12664','2013-02-02','11:05:00',2.36),('12664','2013-02-02','11:10:00',2.38),('12664','2013-02-02','11:15:00',2.09),('12664','2013-02-02','11:20:00',2.46),('12664','2013-02-02','11:25:00',2.44),('12664','2013-02-02','11:30:00',2.07),('12664','2013-02-02','11:35:00',1.93),('12664','2013-02-02','11:40:00',1.7),('12664','2013-02-02','11:45:00',1.05),('12664','2013-02-02','11:50:00',1.15),('12664','2013-02-02','12:35:00',1.02),('12664','2013-02-02','12:40:00',2.39),('12664','2013-02-02','12:45:00',2.52),('12664','2013-02-02','12:50:00',2.86),('12664','2013-02-02','12:55:00',2.32),('12664','2013-02-02','13:00:00',1.95),('12664','2013-02-02','13:05:00',1.96),('12664','2013-02-02','13:10:00',2.33),('12664','2013-02-02','13:15:00',2.93),('12664','2013-02-02','13:20:00',1.63),('12664','2013-02-02','13:25:00',1.3),('12664','2013-02-02','13:30:00',1.35),('12664','2013-02-02','13:35:00',1.34),('12664','2013-02-02','13:40:00',1.6),('12664','2013-02-02','13:45:00',1.27),('12664','2013-02-02','13:50:00',1.11),('12664','2013-02-01','08:35:00',1.24),('12664','2013-02-01','08:40:00',1.42),('12664','2013-02-01','08:45:00',1.4),('12664','2013-02-01','08:50:00',1.46),('12664','2013-02-01','08:55:00',1.35),('12664','2013-02-01','09:00:00',1.36),('12664','2013-02-01','09:05:00',1.91),('12664','2013-02-01','09:10:00',2.07),('12664','2013-02-01','09:15:00',2.16),('12664','2013-02-01','09:20:00',1.85),('12664','2013-02-01','09:25:00',2.09),('12664','2013-02-01','09:30:00',1.36),('12664','2013-02-01','09:40:00',1.3),('12664','2013-02-01','09:45:00',1.62),('12664','2013-02-01','09:50:00',1.95),('12664','2013-02-01','09:55:00',1.94),('12664','2013-02-01','10:00:00',2.56),('12664','2013-02-01','10:05:00',2.41),('12664','2013-02-01','10:10:00',2.07),('12664','2013-02-01','10:15:00',1.1),('12664','2013-02-01','10:20:00',2.3),('12664','2013-02-01','10:25:00',2.97),('12664','2013-02-01','10:30:00',2.15),('12664','2013-02-01','10:40:00',1.39),('12664','2013-02-01','10:45:00',1.68),('12664','2013-02-01','10:50:00',1.03),('12664','2013-02-01','11:20:00',2.86),('12664','2013-02-01','11:25:00',2.23),('12664','2013-02-01','11:30:00',2.9),('12664','2013-02-01','11:35:00',1.72),('12664','2013-02-01','11:40:00',1.6),('12664','2013-02-01','11:45:00',1.81),('12664','2013-02-01','11:50:00',1.52),('12664','2013-02-01','11:55:00',1.42),('12664','2013-02-01','12:00:00',1.24),('12664','2013-02-01','12:05:00',1.35),('12664','2013-02-01','12:10:00',2.11),('12664','2013-02-01','12:15:00',1.99),('12664','2013-02-01','12:20:00',4.09),('12664','2013-02-01','12:25:00',2.84),('12664','2013-02-01','12:30:00',4.49),('12664','2013-02-01','12:35:00',3.77),('12664','2013-02-01','12:40:00',3.83),('12664','2013-02-01','12:45:00',2.57),('12664','2013-02-01','12:50:00',2.61),('12664','2013-02-01','12:55:00',3.28),('12664','2013-02-01','13:00:00',2.55),('12664','2013-02-01','13:05:00',3.68),('12664','2013-02-01','13:10:00',3.57),('12664','2013-02-01','13:15:00',3.59),('12664','2013-02-01','13:20:00',3.02),('12664','2013-02-01','13:25:00',3.19),('12664','2013-02-01','13:30:00',1.95),('12664','2013-02-01','13:35:00',2.63),('12664','2013-02-01','13:40:00',2.58),('12664','2013-02-01','13:45:00',2.63),('12664','2013-02-01','13:50:00',3.02),('12664','2013-02-01','13:55:00',2.94),('12664','2013-02-01','14:00:00',2.74),('12664','2013-02-01','14:05:00',2.69),('12664','2013-02-01','14:10:00',3.16),('12664','2013-02-01','14:15:00',2.99),('12664','2013-02-01','14:20:00',2.53),('12664','2013-02-01','14:25:00',1.83),('12664','2013-02-01','14:30:00',1.07),('12664','2013-02-01','14:35:00',1.25),('12664','2013-02-01','14:40:00',1.08),('12664','2013-02-01','14:55:00',1.12),('12664','2013-02-01','15:15:00',1.63),('12664','2013-02-01','15:20:00',2.36),('12664','2013-02-01','15:25:00',2.03),('12664','2013-02-01','15:30:00',1.66),('12664','2013-01-31','09:25:00',1.09),('12664','2013-01-31','09:30:00',2.05),('12664','2013-01-31','09:35:00',2.37),('12664','2013-01-31','09:40:00',2.4),('12664','2013-01-31','09:45:00',2.48),('12664','2013-01-31','09:50:00',2.58),('12664','2013-01-31','09:55:00',2.63),('12664','2013-01-31','10:00:00',2.68),('12664','2013-01-31','10:05:00',2.74),('12664','2013-01-31','10:10:00',2.79),('12664','2013-01-31','10:15:00',2.9),('12664','2013-01-31','10:20:00',2.95),('12664','2013-01-31','10:25:00',3.01),('12664','2013-01-31','10:30:00',3.01),('12664','2013-01-31','10:35:00',3.16),('12664','2013-01-31','10:40:00',3.3),('12664','2013-01-31','10:45:00',3.07),('12664','2013-01-31','10:50:00',3.33),('12664','2013-01-31','10:55:00',1.25),('12664','2013-01-31','11:00:00',1.31),('12664','2013-01-31','11:10:00',1.35),('12664','2013-01-31','11:15:00',3.69),('12664','2013-01-31','11:20:00',3.57),('12664','2013-01-31','11:25:00',3.54),('12664','2013-01-31','11:30:00',3.6),('12664','2013-01-31','11:35:00',3.54),('12664','2013-01-31','11:40:00',2.95),('12664','2013-01-31','11:45:00',2.42),('12664','2013-01-31','11:50:00',3.59),('12664','2013-01-31','11:55:00',3.66),('12664','2013-01-31','12:00:00',3.6),('12664','2013-01-31','12:05:00',3.57),('12664','2013-01-31','12:10:00',3.54),('12664','2013-01-31','12:15:00',3.52),('12664','2013-01-31','12:20:00',3.47),('12664','2013-01-31','12:25:00',3.52),('12664','2013-01-31','12:30:00',3.5),('12664','2013-01-31','12:35:00',3.37),('12664','2013-01-31','12:40:00',3.43),('12664','2013-01-31','12:45:00',3.51),('12664','2013-01-31','12:50:00',3.5),('12664','2013-01-31','12:55:00',3.5),('12664','2013-01-31','13:00:00',3.47),('12664','2013-01-31','13:05:00',3.46),('12664','2013-01-31','13:10:00',3.42),('12664','2013-01-31','13:15:00',3.38),('12664','2013-01-31','13:20:00',3.34),('12664','2013-01-31','13:25:00',3.31),('12664','2013-01-31','13:30:00',3.22),('12664','2013-01-31','13:35:00',3.19),('12664','2013-01-31','13:40:00',3.16),('12664','2013-01-31','13:45:00',3.17),('12664','2013-01-31','13:50:00',3.05),('12664','2013-01-31','13:55:00',3.09),('12664','2013-01-31','14:00:00',3.03),('12664','2013-01-31','14:05:00',2.92),('12664','2013-01-31','14:10:00',2.93),('12664','2013-01-31','14:15:00',2.82),('12664','2013-01-31','14:20:00',2.75),('12664','2013-01-31','14:25:00',2.63),('12664','2013-01-31','14:30:00',2.53),('12664','2013-01-31','14:35:00',2.54),('12664','2013-01-31','14:40:00',2.55),('12664','2013-01-31','14:45:00',2.53),('12664','2013-01-31','14:50:00',2.43),('12664','2013-01-31','14:55:00',2.32),('12664','2013-01-31','15:00:00',2.25),('12664','2013-01-31','15:05:00',2.17),('12664','2013-01-31','15:10:00',2.14),('12664','2013-01-31','15:15:00',2.09),('12664','2013-01-31','15:20:00',1.97),('12664','2013-01-31','15:25:00',1.76),('12664','2013-01-31','15:30:00',1.86),('12664','2013-01-31','15:35:00',1.77),('12664','2013-01-31','15:40:00',1.66),('12664','2013-01-31','15:45:00',1.54),('12664','2013-01-31','15:50:00',1.47),('12664','2013-01-31','15:55:00',1.22),('12664','2013-01-31','16:00:00',1.01),('12664','2013-01-31','16:05:00',1.1),('12664','2013-01-31','16:10:00',1.09),('12664','2014-03-20','07:40:00',1.04),('12664','2014-03-20','07:45:00',1.16),('12664','2014-03-20','07:50:00',1.22),('12664','2014-03-20','07:55:00',1.21),('12664','2014-03-20','08:00:00',1.26),('12664','2014-03-20','08:05:00',1.25),('12664','2014-03-20','08:10:00',1.17),('12664','2014-03-20','08:15:00',1.33),('12664','2014-03-20','08:20:00',1.52),('12664','2014-03-20','08:25:00',1.66),('12664','2014-03-20','08:30:00',1.78),('12664','2014-03-20','08:35:00',1.88),('12664','2014-03-20','08:40:00',1.99),('12664','2014-03-20','08:45:00',2.08),('12664','2014-03-20','08:50:00',2.12),('12664','2014-03-20','08:55:00',2.2),('12664','2014-03-20','09:00:00',2.23),('12664','2014-03-20','09:05:00',2.32),('12664','2014-03-20','09:10:00',2.42),('12664','2014-03-20','09:15:00',2.47),('12664','2014-03-20','09:20:00',2.58),('12664','2014-03-20','09:25:00',2.72),('12664','2014-03-20','09:30:00',2.76),('12664','2014-03-20','09:35:00',2.77),('12664','2014-03-20','09:40:00',2.78),('12664','2014-03-20','09:45:00',2.9),('12664','2014-03-20','09:50:00',2.91),('12664','2014-03-20','09:55:00',3.01),('12664','2014-03-20','10:00:00',3.05),('12664','2014-03-20','10:05:00',3.1),('12664','2014-03-20','10:10:00',3.2),('12664','2014-03-20','10:15:00',3.25),('12664','2014-03-20','10:20:00',3.3),('12664','2014-03-20','10:25:00',3.3),('12664','2014-03-20','10:30:00',3.36),('12664','2014-03-20','10:35:00',3.33),('12664','2014-03-20','10:40:00',3.27),('12664','2014-03-20','10:45:00',3.39),('12664','2014-03-20','10:50:00',3.43),('12664','2014-03-20','10:55:00',3.47),('12664','2014-03-20','11:00:00',3.51),('12664','2014-03-20','11:05:00',3.46),('12664','2014-03-20','11:10:00',3.42),('12664','2014-03-20','11:15:00',3.34),('12664','2014-03-20','11:20:00',3.45),('12664','2014-03-20','11:25:00',3.32),('12664','2014-03-20','11:30:00',3.46),('12664','2014-03-20','11:35:00',3.59),('12664','2014-03-20','11:40:00',3.4),('12664','2014-03-20','11:45:00',3.41),('12664','2014-03-20','11:50:00',3.47),('12664','2014-03-20','11:55:00',3.49),('12664','2014-03-20','12:00:00',3.39),('12664','2014-03-20','12:05:00',3.15),('12664','2014-03-20','12:10:00',3.52),('12664','2014-03-20','12:15:00',3.72),('12664','2014-03-20','12:20:00',3.7),('12664','2014-03-20','12:25:00',3.52),('12664','2014-03-20','12:30:00',3.52),('12664','2014-03-20','12:35:00',3.71),('12664','2014-03-20','12:40:00',3.82),('12664','2014-03-20','12:45:00',3.82),('12664','2014-03-20','12:50:00',3.8),('12664','2014-03-20','12:55:00',3.81),('12664','2014-03-20','13:00:00',3.78),('12664','2014-03-20','13:05:00',3.65),('12664','2014-03-20','13:10:00',3.52),('12664','2014-03-20','13:15:00',3.5),('12664','2014-03-20','13:20:00',3.51),('12664','2014-03-20','13:25:00',3.5),('12664','2014-03-20','13:30:00',3.43),('12664','2014-03-20','13:35:00',3.33),('12664','2014-03-20','13:40:00',3.2),('12664','2014-03-20','13:45:00',3.15),('12664','2014-03-20','13:50:00',3.03),('12664','2014-03-20','13:55:00',2.96),('12664','2014-03-20','14:00:00',2.76),('12664','2014-03-20','14:05:00',2.83),('12664','2014-03-20','14:10:00',2.94),('12664','2014-03-20','14:15:00',2.51),('12664','2014-03-20','14:20:00',2.35),('12664','2014-03-20','14:25:00',2.2),('12664','2014-03-20','14:30:00',2.48),('12664','2014-03-20','14:35:00',2.51),('12664','2014-03-20','14:40:00',2.52),('12664','2014-03-20','14:45:00',2.54),('12664','2014-03-20','14:50:00',2.52),('12664','2014-03-20','14:55:00',2.49),('12664','2014-03-20','15:00:00',2.35),('12664','2014-03-20','15:05:00',2.19),('12664','2014-03-20','15:10:00',2.13),('12664','2014-03-20','15:15:00',2.1),('12664','2014-03-20','15:20:00',2.09),('12664','2014-03-20','15:25:00',2.04),('12664','2014-03-20','15:30:00',1.76),('12664','2014-03-20','15:35:00',1.56),('12664','2014-03-20','15:40:00',1.48),('12664','2014-03-20','15:45:00',1.31),('12664','2014-03-20','15:50:00',1.06),('12664','2014-03-20','15:55:00',1.05),('12664','2014-03-20','16:00:00',1.03),('12664','2014-03-20','16:05:00',1.05),('12664','2013-01-30','09:25:00',1.11),('12664','2013-01-30','09:30:00',1.52),('12664','2013-01-30','09:35:00',2.54),('12664','2013-01-30','09:40:00',2.55),('12664','2013-01-30','09:45:00',2.48),('12664','2013-01-30','09:50:00',1.38),('12664','2013-01-30','09:55:00',1.35),('12664','2013-01-30','10:00:00',1.44),('12664','2013-01-30','10:05:00',1.83),('12664','2013-01-30','10:10:00',1.45),('12664','2013-01-30','10:15:00',1.52),('12664','2013-01-30','10:20:00',1.49),('12664','2013-01-30','10:25:00',1.97),('12664','2013-01-30','10:30:00',2.02),('12664','2013-01-30','10:35:00',3.12),('12664','2013-01-30','10:40:00',2.17),('12664','2013-01-30','10:45:00',2.58),('12664','2013-01-30','10:50:00',3.02),('12664','2013-01-30','10:55:00',3.09),('12664','2013-01-30','11:00:00',3.08),('12664','2013-01-30','11:05:00',3.27),('12664','2013-01-30','11:10:00',3.29),('12664','2013-01-30','11:15:00',3.26),('12664','2013-01-30','11:20:00',3.31),('12664','2013-01-30','11:25:00',3.3),('12664','2013-01-30','11:30:00',2.95),('12664','2013-01-30','11:35:00',2.86),('12664','2013-01-30','11:40:00',3.11),('12664','2013-01-30','11:45:00',2.22),('12664','2013-01-30','11:50:00',1.57),('12664','2013-01-30','11:55:00',1.26),('12664','2013-01-30','12:00:00',1.94),('12664','2013-01-30','12:05:00',1.71),('12664','2013-01-30','12:10:00',3.09),('12664','2013-01-30','12:15:00',3.05),('12664','2013-01-30','12:20:00',4.19),('12664','2013-01-30','12:25:00',3.92),('12664','2013-01-30','12:30:00',3.12),('12664','2013-01-30','12:35:00',2.96),('12664','2013-01-30','12:40:00',1.93),('12664','2013-01-30','12:45:00',2.48),('12664','2013-01-30','12:50:00',2.55),('12664','2013-01-30','12:55:00',1.32),('12664','2013-01-30','13:00:00',2.65),('12664','2013-01-30','13:10:00',1.86),('12664','2013-01-30','13:15:00',3.63),('12664','2013-01-30','13:20:00',2.8),('12664','2013-01-30','13:25:00',2.01),('12664','2013-01-30','13:30:00',3.52),('12664','2013-01-30','13:45:00',1.3),('12664','2013-01-30','13:50:00',1.14),('12664','2013-01-30','13:55:00',1.13),('12664','2013-01-30','14:00:00',2.65),('12664','2013-01-30','14:05:00',3),('12664','2013-01-30','14:10:00',2.56),('12664','2013-01-30','14:15:00',2.25),('12664','2013-01-30','14:20:00',2.22),('12664','2013-01-30','14:25:00',2.49),('12664','2013-01-30','14:30:00',2.46),('12664','2013-01-30','14:35:00',2.59),('12664','2013-01-30','14:40:00',2.39),('12664','2013-01-30','14:45:00',2.09),('12664','2013-01-30','14:50:00',1.87),('12664','2013-01-30','14:55:00',2.08),('12664','2013-01-30','15:00:00',1.64),('12664','2013-01-30','15:05:00',1.35),('12664','2013-01-30','15:10:00',1.18),('12664','2013-01-30','15:15:00',1.04),('12664','2013-01-29','08:25:00',1.09),('12664','2013-01-29','08:30:00',1.19),('12664','2013-01-29','08:35:00',1.3),('12664','2013-01-29','08:40:00',1.41),('12664','2013-01-29','08:45:00',1.52),('12664','2013-01-29','08:50:00',1.62),('12664','2013-01-29','08:55:00',1.72),('12664','2013-01-29','09:00:00',1.82),('12664','2013-01-29','09:05:00',1.91),('12664','2013-01-29','09:10:00',2.01),('12664','2013-01-29','09:15:00',2.1),('12664','2013-01-29','09:20:00',2.18),('12664','2013-01-29','09:25:00',2.27),('12664','2013-01-29','09:30:00',2.35),('12664','2013-01-29','09:35:00',2.44),('12664','2013-01-29','09:40:00',2.53),('12664','2013-01-29','09:45:00',2.61),('12664','2013-01-29','09:50:00',2.66),('12664','2013-01-29','09:55:00',2.73),('12664','2013-01-29','10:00:00',2.78),('12664','2013-01-29','10:05:00',2.84),('12664','2013-01-29','10:10:00',2.9),('12664','2013-01-29','10:15:00',2.93),('12664','2013-01-29','10:20:00',3.02),('12664','2013-01-29','10:25:00',3.09),('12664','2013-01-29','10:30:00',3.14),('12664','2013-01-29','10:35:00',3.2),('12664','2013-01-29','10:40:00',3.23),('12664','2013-01-29','10:45:00',3.24),('12664','2013-01-29','10:50:00',3.26),('12664','2013-01-29','10:55:00',3.26),('12664','2013-01-29','11:00:00',3.31),('12664','2013-01-29','11:05:00',3.35),('12664','2013-01-29','11:10:00',3.35),('12664','2013-01-29','11:15:00',3.38),('12664','2013-01-29','11:20:00',3.46),('12664','2013-01-29','11:25:00',3.46),('12664','2013-01-29','11:30:00',3.42),('12664','2013-01-29','11:35:00',3.56),('12664','2013-01-29','11:40:00',3.56),('12664','2013-01-29','11:45:00',3.56),('12664','2013-01-29','11:50:00',3.6),('12664','2013-01-29','11:55:00',3.61),('12664','2013-01-29','12:00:00',3.65),('12664','2013-01-29','12:05:00',3.68),('12664','2013-01-29','12:10:00',3.68),('12664','2013-01-29','12:15:00',3.62),('12664','2013-01-29','12:20:00',3.67),('12664','2013-01-29','12:25:00',3.68),('12664','2013-01-29','12:30:00',3.68),('12664','2013-01-29','12:35:00',3.68),('12664','2013-01-29','12:40:00',3.59),('12664','2013-01-29','12:45:00',3.54),('12664','2013-01-29','12:50:00',3.62),('12664','2013-01-29','12:55:00',3.63),('12664','2013-01-29','13:00:00',3.59),('12664','2013-01-29','13:05:00',3.52),('12664','2013-01-29','13:10:00',3.55),('12664','2013-01-29','13:15:00',3.54),('12664','2013-01-29','13:20:00',3.49),('12664','2013-01-29','13:25:00',3.42),('12664','2013-01-29','13:30:00',3.39),('12664','2013-01-29','13:35:00',3.37),('12664','2013-01-29','13:40:00',3.27),('12664','2013-01-29','13:45:00',3.24),('12664','2013-01-29','13:50:00',3.22),('12664','2013-01-29','13:55:00',3.25),('12664','2013-01-29','14:00:00',3.23),('12664','2013-01-29','14:05:00',3.16),('12664','2013-01-29','14:10:00',3.07),('12664','2013-01-29','14:15:00',3),('12664','2013-01-29','14:20:00',2.94),('12664','2013-01-29','14:25:00',2.82),('12664','2013-01-29','14:30:00',2.81),('12664','2013-01-29','14:35:00',2.71),('12664','2013-01-29','14:40:00',2.63),('12664','2013-01-29','14:45:00',2.58),('12664','2013-01-29','14:50:00',2.48),('12664','2013-01-29','14:55:00',2.42),('12664','2013-01-29','15:00:00',2.34),('12664','2013-01-29','15:05:00',2.27),('12664','2013-01-29','15:10:00',2.18),('12664','2013-01-29','15:15:00',2.09),('12664','2013-01-29','15:20:00',2.06),('12664','2013-01-29','15:25:00',1.99),('12664','2013-01-29','15:30:00',1.95),('12664','2013-01-29','15:35:00',1.85),('12664','2013-01-29','15:40:00',1.75),('12664','2013-01-29','15:45:00',1.65),('12664','2013-01-29','15:50:00',1.52),('12664','2013-01-29','15:55:00',1.45),('12664','2013-01-29','16:00:00',1.35),('12664','2013-01-29','16:05:00',1.24),('12664','2013-01-29','16:10:00',1.14),('12664','2013-01-29','16:15:00',1.03),('12664','2013-01-28','12:35:00',1.06),('12664','2013-01-28','12:40:00',1.21),('12664','2013-01-28','12:45:00',1.3),('12664','2013-01-28','12:50:00',1.28),('12664','2013-01-28','12:55:00',1.22),('12664','2013-01-28','13:00:00',1.3),('12664','2013-01-28','13:05:00',1.27),('12664','2013-01-28','13:10:00',1.04),('12664','2013-01-27','08:25:00',1.1),('12664','2013-01-27','08:30:00',1.05),('12664','2013-01-27','08:45:00',1.7),('12664','2013-01-27','08:50:00',1.39),('12664','2013-01-27','08:55:00',1.3),('12664','2013-01-27','09:00:00',1.71),('12664','2013-01-27','09:05:00',1.9),('12664','2013-01-27','09:10:00',1.97),('12664','2013-01-27','09:15:00',2.07),('12664','2013-01-27','09:20:00',2.19),('12664','2013-01-27','09:25:00',2.27),('12664','2013-01-27','09:30:00',2.34),('12664','2013-01-27','09:35:00',2.39),('12664','2013-01-27','09:40:00',2.43),('12664','2013-01-27','09:45:00',2.52),('12664','2013-01-27','09:50:00',2.59),('12664','2013-01-27','09:55:00',2.66),('12664','2013-01-27','10:00:00',2.75),('12664','2013-01-27','10:05:00',2.83),('12664','2013-01-27','10:10:00',2.89),('12664','2013-01-27','10:15:00',2.94),('12664','2013-01-27','10:20:00',2.99),('12664','2013-01-27','10:25:00',3.05),('12664','2013-01-27','10:30:00',3.09),('12664','2013-01-27','10:35:00',3.14),('12664','2013-01-27','10:40:00',3.17),('12664','2013-01-27','10:45:00',3.22),('12664','2013-01-27','10:50:00',3.27),('12664','2013-01-27','10:55:00',3.32),('12664','2013-01-27','11:00:00',3.35),('12664','2013-01-27','11:05:00',3.38),('12664','2013-01-27','11:10:00',3.41),('12664','2013-01-27','11:15:00',3.43),('12664','2013-01-27','11:20:00',3.46),('12664','2013-01-27','11:25:00',3.5),('12664','2013-01-27','11:30:00',3.52),('12664','2013-01-27','11:35:00',3.54),('12664','2013-01-27','11:40:00',3.56),('12664','2013-01-27','11:45:00',3.54),('12664','2013-01-27','11:50:00',3.53),('12664','2013-01-27','11:55:00',3.55),('12664','2013-01-27','12:00:00',3.59),('12664','2013-01-27','12:05:00',3.58),('12664','2013-01-27','12:10:00',3.57),('12664','2013-01-27','12:15:00',3.6),('12664','2013-01-27','12:20:00',3.61),('12664','2013-01-27','12:25:00',3.6),('12664','2013-01-27','12:30:00',3.57),('12664','2013-01-27','12:35:00',3.56),('12664','2013-01-27','12:40:00',3.54),('12664','2013-01-27','12:45:00',3.52),('12664','2013-01-27','12:50:00',3.48),('12664','2013-01-27','12:55:00',3.47),('12664','2013-01-27','13:00:00',3.34),('12664','2013-01-27','13:05:00',3.35),('12664','2013-01-27','13:10:00',3.33),('12664','2013-01-27','13:15:00',3.34),('12664','2013-01-27','13:20:00',3.39),('12664','2013-01-27','13:25:00',3.38),('12664','2013-01-27','13:30:00',3.4),('12664','2013-01-27','13:35:00',3.35),('12664','2013-01-27','13:40:00',3.27),('12664','2013-01-27','13:45:00',3.18),('12664','2013-01-27','13:50:00',3.15),('12664','2013-01-27','13:55:00',3.05),('12664','2013-01-27','14:00:00',2.97),('12664','2013-01-27','14:05:00',2.95),('12664','2013-01-27','14:10:00',2.94),('12664','2013-01-27','14:15:00',2.88),('12664','2013-01-27','14:20:00',2.81),('12664','2013-01-27','14:25:00',2.77),('12664','2013-01-27','14:30:00',2.72),('12664','2013-01-27','14:35:00',2.64),('12664','2013-01-27','14:40:00',2.56),('12664','2013-01-27','14:45:00',2.48),('12664','2013-01-27','14:50:00',2.29),('12664','2013-01-27','14:55:00',2.28),('12664','2013-01-27','15:00:00',2.28),('12664','2013-01-27','15:05:00',2.09),('12664','2013-01-27','15:10:00',2.13),('12664','2013-01-27','15:15:00',2.06),('12664','2013-01-27','15:20:00',1.91),('12664','2013-01-27','15:25:00',1.83),('12664','2013-01-27','15:30:00',1.73),('12664','2013-01-27','15:35:00',1.62),('12664','2013-01-27','15:40:00',1.55),('12664','2013-01-27','15:45:00',1.23),('12664','2013-01-27','15:50:00',1.28),('12664','2013-01-27','15:55:00',1.27),('12664','2013-01-27','16:00:00',1.16),('12664','2013-01-27','16:05:00',1.04),('12664','2013-01-26','10:25:00',1.04),('12664','2013-01-26','10:30:00',1.22),('12664','2013-01-26','10:35:00',1.24),('12664','2013-01-26','10:45:00',1.01),('12664','2013-01-26','11:00:00',1.01),('12664','2013-01-26','11:05:00',1.1),('12664','2013-01-26','11:10:00',1.05),('12664','2013-01-26','11:15:00',1.01),('12664','2013-01-26','11:20:00',1.03),('12664','2013-01-26','11:30:00',1.02),('12664','2013-01-26','11:35:00',1.14),('12664','2013-01-26','11:40:00',1.11),('12664','2013-01-25','08:20:00',1.04),('12664','2013-01-25','08:25:00',1.2),('12664','2013-01-25','08:30:00',1.38),('12664','2013-01-25','08:35:00',1.5),('12664','2013-01-25','08:40:00',1.56),('12664','2013-01-25','08:45:00',1.58),('12664','2013-01-25','08:50:00',1.36),('12664','2013-01-25','08:55:00',1.33),('12664','2013-01-25','09:00:00',1.16),('12664','2013-01-25','09:05:00',1.23),('12664','2013-01-25','09:10:00',1.35),('12664','2013-01-25','09:15:00',1.4),('12664','2013-01-25','09:20:00',1.52),('12664','2013-01-25','09:25:00',1.49),('12664','2013-01-25','09:30:00',1.57),('12664','2013-01-25','09:35:00',1.83),('12664','2013-01-25','09:40:00',1.95),('12664','2013-01-25','09:45:00',1.85),('12664','2013-01-25','09:50:00',1.82),('12664','2013-01-25','09:55:00',2.16),('12664','2013-01-25','10:00:00',2.57),('12664','2013-01-25','10:05:00',3.09),('12664','2013-01-25','10:10:00',3.25),('12664','2013-01-25','10:15:00',3.29),('12664','2013-01-25','10:20:00',3.25),('12664','2013-01-25','10:25:00',3.27),('12664','2013-01-25','10:30:00',3.34),('12664','2013-01-25','10:35:00',3.43),('12664','2013-01-25','10:40:00',3.43),('12664','2013-01-25','10:45:00',3.52),('12664','2013-01-25','10:50:00',3.55),('12664','2013-01-25','10:55:00',3.58),('12664','2013-01-25','11:00:00',3.35),('12664','2013-01-25','11:05:00',3.38),('12664','2013-01-25','11:10:00',3.5),('12664','2013-01-25','11:15:00',3.52),('12664','2013-01-25','11:20:00',3.53),('12664','2013-01-25','11:25:00',3.38),('12664','2013-01-25','11:30:00',3.53),('12664','2013-01-25','11:35:00',3.67),('12664','2013-01-25','11:40:00',3.73),('12664','2013-01-25','11:45:00',3.76),('12664','2013-01-25','11:50:00',3.78),('12664','2013-01-25','11:55:00',3.79),('12664','2013-01-25','12:00:00',3.75),('12664','2013-01-25','12:05:00',3.72),('12664','2013-01-25','12:10:00',3.64),('12664','2013-01-25','12:15:00',3.68),('12664','2013-01-25','12:20:00',3.72),('12664','2013-01-25','12:25:00',3.77),('12664','2013-01-25','12:30:00',3.13),('12664','2013-01-25','12:35:00',3.35),('12664','2013-01-25','12:40:00',3.82),('12664','2013-01-25','12:45:00',3.78),('12664','2013-01-25','12:50:00',3.75),('12664','2013-01-25','12:55:00',3.69),('12664','2013-01-25','13:00:00',3.62),('12664','2013-01-25','13:05:00',3.58),('12664','2013-01-25','13:10:00',3.52),('12664','2013-01-25','13:15:00',3.47),('12664','2013-01-25','13:20:00',3.43),('12664','2013-01-25','13:25:00',3.47),('12664','2013-01-25','13:30:00',3.48),('12664','2013-01-25','13:35:00',3.4),('12664','2013-01-25','13:40:00',3.39),('12664','2013-01-25','13:45:00',3.35),('12664','2013-01-25','13:50:00',3.17),('12664','2013-01-25','13:55:00',2.86),('12664','2013-01-25','14:00:00',2.83),('12664','2013-01-25','14:05:00',2.82),('12664','2013-01-25','14:10:00',2.82),('12664','2013-01-25','14:15:00',2.79),('12664','2013-01-25','14:20:00',2.72),('12664','2013-01-25','14:25:00',2.68),('12664','2013-01-25','14:30:00',2.6),('12664','2013-01-25','14:35:00',2.52),('12664','2013-01-25','14:40:00',2.47),('12664','2013-01-25','14:45:00',2.44),('12664','2013-01-25','14:50:00',2.41),('12664','2013-01-25','14:55:00',2.27),('12664','2013-01-25','15:00:00',2.11),('12664','2013-01-25','15:05:00',1.96),('12664','2013-01-25','15:10:00',1.77),('12664','2013-01-25','15:15:00',1.81),('12664','2013-01-25','15:20:00',1.76),('12664','2013-01-25','15:25:00',1.83),('12664','2013-01-25','15:30:00',1.79),('12664','2013-01-25','15:35:00',1.7),('12664','2013-01-25','15:40:00',1.65),('12664','2013-01-25','15:45:00',1.53),('12664','2013-01-25','15:50:00',1.25),('12664','2013-01-24','08:50:00',1.22),('12664','2013-01-24','09:20:00',1.32),('12664','2013-01-24','09:30:00',1.54),('12664','2013-01-24','09:35:00',2.85),('12664','2013-01-24','09:40:00',2.7),('12664','2013-01-24','09:45:00',1.87),('12664','2013-01-24','09:50:00',2.06),('12664','2013-01-24','09:55:00',2.62),('12664','2013-01-24','10:00:00',1.78),('12664','2013-01-24','10:05:00',2.76),('12664','2013-01-24','10:10:00',3.25),('12664','2013-01-24','10:15:00',3.19),('12664','2013-01-24','10:20:00',2.85),('12664','2013-01-24','10:25:00',3.1),('12664','2013-01-24','10:30:00',3.27),('12664','2013-01-24','10:35:00',3.28),('12664','2013-01-24','10:40:00',3.31),('12664','2013-01-24','10:45:00',3.35),('12664','2013-01-24','10:50:00',3.31),('12664','2013-01-24','10:55:00',1.8),('12664','2013-01-24','12:35:00',1.11),('12664','2013-01-24','12:40:00',1.19),('12664','2013-01-24','12:45:00',1.15),('12664','2013-01-24','12:50:00',1.06),('12664','2013-01-24','12:55:00',1.01),('12664','2013-01-24','13:00:00',1),('12664','2013-01-24','13:50:00',1.08),('12664','2013-01-24','13:55:00',1.14),('12664','2013-01-24','14:00:00',1.19),('12664','2013-01-24','14:05:00',1.26),('12664','2013-01-24','14:10:00',1.33),('12664','2013-01-24','14:15:00',3.92),('12664','2013-01-24','14:20:00',3.76),('12664','2013-01-24','14:25:00',3.37),('12664','2013-01-24','14:30:00',2.52),('12664','2013-01-24','14:35:00',2.62),('12664','2013-01-24','14:40:00',2.76),('12664','2013-01-24','14:45:00',2.31),('12664','2013-01-24','14:50:00',1.98),('12664','2013-01-24','14:55:00',1.83),('12664','2013-01-24','15:00:00',2.3),('12664','2013-01-24','15:05:00',2.17),('12664','2013-01-24','15:10:00',1.59),('12664','2013-01-24','15:35:00',1.7),('12664','2013-01-24','15:40:00',1.8),('12664','2013-01-24','15:45:00',1.66),('12664','2013-01-24','15:50:00',1.45),('12664','2013-01-24','15:55:00',1.2),('12664','2013-01-24','16:10:00',1.02),('12664','2013-01-23','09:10:00',1.45),('12664','2013-01-23','09:15:00',2.71),('12664','2013-01-23','09:20:00',2.42),('12664','2013-01-23','09:35:00',1.03),('12664','2013-01-23','09:40:00',2.84),('12664','2013-01-23','09:45:00',2.89),('12664','2013-01-23','09:50:00',2.29),('12664','2013-01-23','09:55:00',1.68),('12664','2013-01-23','10:00:00',1.58),('12664','2013-01-23','10:05:00',2.95),('12664','2013-01-23','10:10:00',2.41),('12664','2013-01-23','10:15:00',2.6),('12664','2013-01-23','10:20:00',2.39),('12664','2013-01-23','10:25:00',1.53),('12664','2013-01-23','10:30:00',1.11),('12664','2013-01-22','08:40:00',1.23),('12664','2013-01-22','08:45:00',1.48),('12664','2013-01-22','08:50:00',1.52),('12664','2013-01-22','09:20:00',1.52),('12664','2013-01-22','09:25:00',2.38),('12664','2013-01-22','09:30:00',2.42),('12664','2013-01-22','09:35:00',2.39),('12664','2013-01-22','09:45:00',2.12),('12664','2013-01-22','09:50:00',2.62),('12664','2013-01-22','09:55:00',2.56),('12664','2013-01-22','10:00:00',2.7),('12664','2013-01-22','10:05:00',2.06),('12664','2013-01-22','10:10:00',2.81),('12664','2013-01-22','10:15:00',1.9),('12664','2013-01-22','10:20:00',1.82),('12664','2013-01-22','10:25:00',3.35),('12664','2013-01-22','10:30:00',1.05),('12664','2013-01-22','10:35:00',2.82),('12664','2013-01-22','10:45:00',1.34),('12664','2013-01-22','10:50:00',1.28),('12664','2013-01-22','10:55:00',1.2),('12664','2013-01-22','11:00:00',3.23),('12664','2013-01-22','11:10:00',3.09),('12664','2013-01-22','11:15:00',4.09),('12664','2013-01-22','11:20:00',2.74),('12664','2013-01-22','11:50:00',1.71),('12664','2013-01-22','11:55:00',2.33),('12664','2013-01-22','12:00:00',2.47),('12664','2013-01-22','12:05:00',1.24),('12664','2013-01-22','12:10:00',1.44),('12664','2013-01-22','12:15:00',3.99),('12664','2013-01-22','12:20:00',1.41),('12664','2013-01-22','12:25:00',1.53),('12664','2013-01-22','12:30:00',3.96),('12664','2013-01-22','12:35:00',2.44),('12664','2013-01-22','12:40:00',2),('12664','2013-01-22','12:45:00',1.21),('12664','2013-01-22','12:50:00',1.2),('12664','2013-01-22','13:00:00',2.69),('12664','2013-01-22','13:05:00',2.59),('12664','2013-01-22','13:10:00',2.21),('12664','2013-01-22','13:15:00',1.94),('12664','2013-01-22','13:20:00',1.85),('12664','2013-01-22','13:25:00',1.48),('12664','2013-01-22','13:30:00',1.23),('12664','2013-01-22','13:35:00',1.12),('12664','2013-01-22','13:45:00',1.09),('12664','2013-01-22','13:50:00',1.19),('12664','2013-01-22','13:55:00',2.9),('12664','2013-01-22','14:00:00',1.72),('12664','2013-01-22','14:05:00',3.37),('12664','2013-01-22','14:10:00',3.18),('12664','2013-01-22','14:15:00',1.69),('12664','2013-01-22','14:20:00',2.07),('12664','2013-01-22','14:25:00',2.99),('12664','2013-01-22','14:30:00',2.06),('12664','2013-01-22','14:35:00',2.78),('12664','2013-01-22','14:40:00',2.76),('12664','2013-01-22','14:45:00',1.8),('12664','2013-01-22','14:55:00',2.14),('12664','2013-01-21','10:45:00',1.02),('12664','2013-01-21','11:10:00',1.33),('12664','2013-01-21','11:15:00',1.1),('12664','2013-01-21','11:20:00',1.07),('12664','2013-01-21','11:35:00',1.09),('12664','2013-01-21','11:50:00',3.7),('12664','2013-01-21','11:55:00',3.57),('12664','2013-01-21','12:00:00',3.47),('12664','2013-01-21','12:05:00',3.16),('12664','2013-01-21','12:10:00',1.77),('12664','2013-01-21','12:15:00',2.69),('12664','2013-01-21','12:20:00',3.43),('12664','2013-01-21','12:25:00',1.96),('12664','2013-01-21','12:30:00',1.52),('12664','2013-01-21','12:35:00',2.11),('12664','2013-01-21','13:05:00',1.18),('12664','2013-01-21','13:10:00',1.09),('12664','2013-01-21','13:15:00',1.04),('12664','2013-01-21','13:20:00',2.6),('12664','2013-01-21','13:25:00',4.01),('12664','2013-01-21','13:30:00',3.69),('12664','2013-01-21','13:35:00',3.21),('12664','2013-01-21','13:40:00',2.92),('12664','2013-01-21','13:50:00',2.78),('12664','2013-01-21','13:55:00',3.76),('12664','2013-01-21','14:00:00',2.78),('12664','2013-01-21','14:05:00',2.75),('12664','2013-01-21','14:10:00',2.34),('12664','2013-01-21','14:15:00',2),('12664','2013-01-21','14:20:00',2.21),('12664','2013-01-21','15:25:00',1.19),('12664','2013-01-21','15:30:00',1.64),('12664','2014-03-19','09:00:00',1.06),('12664','2014-03-19','09:05:00',1.19),('12664','2014-03-19','09:10:00',1.19),('12664','2014-03-19','09:15:00',1.33),('12664','2014-03-19','09:20:00',1.55),('12664','2014-03-19','09:25:00',1.59),('12664','2014-03-19','09:30:00',1.73),('12664','2014-03-19','09:35:00',1.89),('12664','2014-03-19','09:40:00',2.19),('12664','2014-03-19','09:45:00',1.83),('12664','2014-03-19','09:50:00',1.64),('12664','2014-03-19','09:55:00',1.47),('12664','2014-03-19','10:00:00',1.17),('12664','2014-03-19','10:05:00',1.12),('12664','2014-03-19','10:10:00',1.24),('12664','2014-03-19','10:15:00',1.11),('12664','2014-03-19','10:20:00',1.33),('12664','2014-03-19','10:25:00',1.63),('12664','2014-03-19','10:30:00',2.14),('12664','2014-03-19','10:35:00',2.52),('12664','2014-03-19','10:40:00',1.74),('12664','2014-03-19','10:45:00',1.6),('12664','2014-03-19','10:50:00',1.48),('12664','2014-03-19','10:55:00',1.3),('12664','2014-03-19','11:00:00',1.32),('12664','2014-03-19','11:05:00',1.33),('12664','2014-03-19','11:10:00',1.41),('12664','2014-03-19','11:15:00',3.83),('12664','2014-03-19','11:20:00',2.24),('12664','2014-03-19','11:25:00',1.77),('12664','2014-03-19','11:30:00',1.81),('12664','2014-03-19','11:35:00',1.87),('12664','2014-03-19','11:40:00',3.19),('12664','2014-03-19','11:45:00',4.46),('12664','2014-03-19','11:50:00',2.96),('12664','2014-03-19','11:55:00',2.65),('12664','2014-03-19','12:00:00',3.79),('12664','2014-03-19','12:05:00',4.03),('12664','2014-03-19','12:10:00',4.17),('12664','2014-03-19','12:15:00',2.98),('12664','2014-03-19','12:20:00',3.51),('12664','2014-03-19','12:25:00',3.62),('12664','2014-03-19','12:30:00',4.14),('12664','2014-03-19','12:35:00',4.07),('12664','2014-03-19','12:40:00',3.7),('12664','2014-03-19','12:45:00',3.72),('12664','2014-03-19','12:50:00',3.71),('12664','2014-03-19','12:55:00',3.55),('12664','2014-03-19','13:00:00',3.7),('12664','2014-03-19','13:05:00',3.53),('12664','2014-03-19','13:10:00',3.22),('12664','2014-03-19','13:15:00',3.21),('12664','2014-03-19','13:20:00',3.5),('12664','2014-03-19','13:25:00',3.49),('12664','2014-03-19','13:30:00',3.56),('12664','2014-03-19','13:35:00',3.47),('12664','2014-03-19','13:40:00',3.48),('12664','2014-03-19','13:45:00',3.46),('12664','2014-03-19','13:50:00',3.4),('12664','2014-03-19','13:55:00',3.38),('12664','2014-03-19','14:00:00',3.34),('12664','2014-03-19','14:05:00',3.27),('12664','2014-03-19','14:10:00',3.22),('12664','2014-03-19','14:15:00',3.14),('12664','2014-03-19','14:20:00',3.03),('12664','2014-03-19','14:25:00',2.97),('12664','2014-03-19','14:30:00',3.02),('12664','2014-03-19','14:35:00',3.01),('12664','2014-03-19','14:40:00',2.94),('12664','2014-03-19','14:45:00',2.9),('12664','2014-03-19','14:50:00',2.83),('12664','2014-03-19','14:55:00',2.77),('12664','2014-03-19','15:00:00',2.7),('12664','2014-03-19','15:05:00',2.64),('12664','2014-03-19','15:10:00',2.59),('12664','2014-03-19','15:15:00',2.49),('12664','2014-03-19','15:20:00',2.44),('12664','2014-03-19','15:25:00',2.37),('12664','2014-03-19','15:30:00',2.22),('12664','2014-03-19','15:35:00',2.19),('12664','2014-03-19','15:40:00',2.12),('12664','2014-03-19','15:45:00',2.06),('12664','2014-03-19','15:50:00',1.97),('12664','2014-03-19','15:55:00',1.86),('12664','2014-03-19','16:00:00',1.8),('12664','2014-03-19','16:05:00',1.74),('12664','2014-03-19','16:10:00',1.63),('12664','2014-03-19','16:15:00',1.53),('12664','2014-03-19','16:20:00',1.42),('12664','2014-03-19','16:25:00',1.37),('12664','2014-03-19','16:30:00',1.16),('12664','2014-03-19','16:35:00',1.1),('12664','2014-03-19','16:40:00',1.01),('12664','2013-01-20','11:00:00',1.08),('12664','2013-01-20','11:05:00',1.13),('12664','2013-01-20','11:10:00',1.93),('12664','2013-01-20','11:15:00',2.09),('12664','2013-01-20','11:20:00',1.34),('12664','2013-01-20','11:25:00',1.67),('12664','2013-01-20','11:30:00',1.65),('12664','2013-01-20','11:35:00',1.15),('12664','2013-01-19','09:10:00',1.4),('12664','2013-01-19','09:15:00',1.44),('12664','2013-01-19','09:45:00',1.05),('12664','2013-01-19','09:50:00',1.51),('12664','2013-01-19','09:55:00',1.44),('12664','2013-01-19','10:00:00',1.12),('12664','2013-01-19','10:40:00',1.18),('12664','2013-01-19','10:45:00',1.31),('12664','2013-01-19','11:15:00',1.19),('12664','2013-01-19','11:20:00',1.19),('12664','2013-01-18','10:10:00',1.48),('12664','2013-01-18','10:15:00',2.66),('12664','2013-01-18','10:20:00',1.45),('12664','2013-01-18','10:25:00',1.43),('12664','2013-01-18','10:30:00',1.13),('12664','2013-01-18','11:20:00',1.09),('12664','2013-01-18','11:25:00',1.37),('12664','2013-01-18','11:30:00',1.49),('12664','2013-01-18','11:35:00',1.15),('12664','2013-01-18','11:50:00',1.07),('12664','2013-01-18','11:55:00',1.02),('12664','2013-01-18','12:00:00',1.08),('12664','2013-01-18','12:05:00',1.23),('12664','2013-01-18','12:10:00',1.33),('12664','2013-01-18','12:15:00',1.46),('12664','2013-01-18','12:20:00',1.33),('12664','2013-01-18','12:25:00',1.45),('12664','2013-01-18','12:30:00',1.48),('12664','2013-01-18','12:35:00',1.33),('12664','2013-01-18','12:40:00',1.34),('12664','2013-01-18','12:45:00',1.65),('12664','2013-01-18','12:50:00',2.08),('12664','2013-01-18','12:55:00',2.94),('12664','2013-01-18','13:00:00',2.69),('12664','2013-01-18','13:05:00',2.36),('12664','2013-01-18','13:10:00',2.78),('12664','2013-01-18','13:15:00',2.23),('12664','2013-01-18','13:20:00',2.15),('12664','2013-01-18','13:25:00',2.07),('12664','2013-01-18','13:30:00',1.97),('12664','2013-01-18','13:35:00',1.77),('12664','2013-01-18','13:40:00',3.32),('12664','2013-01-18','13:45:00',3.48),('12664','2013-01-18','13:50:00',3.3),('12664','2013-01-18','13:55:00',3.48),('12664','2013-01-18','14:00:00',2.47),('12664','2013-01-18','14:05:00',2.39),('12664','2013-01-18','14:10:00',3.54),('12664','2013-01-18','14:15:00',3.69),('12664','2013-01-18','14:20:00',2.99),('12664','2013-01-18','14:25:00',2.58),('12664','2013-01-18','14:30:00',1.26),('12664','2013-01-18','14:45:00',1.04),('12664','2013-01-18','14:50:00',1.12),('12664','2013-01-18','14:55:00',1.73),('12664','2013-01-18','15:00:00',2.12),('12664','2013-01-18','15:05:00',1.26),('12664','2013-01-18','15:25:00',1.08),('12664','2013-01-18','15:35:00',1.17),('12664','2013-01-18','15:40:00',1.43),('12664','2013-01-18','15:45:00',1.47),('12664','2013-01-18','15:50:00',1.42),('12664','2013-01-18','15:55:00',1.3),('12664','2013-01-18','16:00:00',1.19),('12664','2013-01-18','16:05:00',1.07),('12664','2013-01-18','16:10:00',1),('12664','2013-01-17','09:40:00',1.19),('12664','2013-01-17','09:45:00',1.8),('12664','2013-01-17','09:50:00',2.03),('12664','2013-01-17','09:55:00',1.57),('12664','2013-01-17','10:00:00',1.28),('12664','2013-01-17','10:05:00',1.3),('12664','2013-01-17','10:10:00',1.56),('12664','2013-01-17','10:15:00',1.73),('12664','2013-01-17','10:20:00',1.88),('12664','2013-01-17','10:25:00',1.95),('12664','2013-01-17','10:30:00',2.15),('12664','2013-01-17','10:35:00',1.93),('12664','2013-01-17','10:40:00',1.78),('12664','2013-01-17','10:45:00',1.46),('12664','2013-01-17','10:50:00',1.46),('12664','2013-01-17','10:55:00',1.45),('12664','2013-01-17','11:00:00',1.42),('12664','2013-01-17','11:05:00',1.8),('12664','2013-01-17','11:10:00',2.13),('12664','2013-01-17','11:15:00',2.01),('12664','2013-01-17','11:20:00',1.57),('12664','2013-01-17','11:25:00',1.5),('12664','2013-01-17','11:30:00',1.62),('12664','2013-01-17','11:35:00',2),('12664','2013-01-17','11:40:00',2.05),('12664','2013-01-17','11:45:00',2.04),('12664','2013-01-17','11:50:00',1.89),('12664','2013-01-17','11:55:00',1.77),('12664','2013-01-17','12:00:00',1.99),('12664','2013-01-17','12:05:00',2.04),('12664','2013-01-17','12:10:00',2),('12664','2013-01-17','12:15:00',2.12),('12664','2013-01-17','12:20:00',2.26),('12664','2013-01-17','12:25:00',2.05),('12664','2013-01-17','12:30:00',2.52),('12664','2013-01-17','12:35:00',2.37),('12664','2013-01-17','12:40:00',2.27),('12664','2013-01-17','12:45:00',2.24),('12664','2013-01-17','12:50:00',1.66),('12664','2013-01-17','12:55:00',2.12),('12664','2013-01-17','13:00:00',1.8),('12664','2013-01-17','13:05:00',2.03),('12664','2013-01-17','13:10:00',1.67),('12664','2013-01-17','13:15:00',1.71),('12664','2013-01-17','13:20:00',1.83),('12664','2013-01-17','13:25:00',2.02),('12664','2013-01-17','13:30:00',2.49),('12664','2013-01-17','13:35:00',2.76),('12664','2013-01-17','13:40:00',2.83),('12664','2013-01-17','13:45:00',2.95),('12664','2013-01-17','13:50:00',1.71),('12664','2013-01-17','13:55:00',1.05),('12664','2013-01-17','14:05:00',1.17),('12664','2013-01-17','14:45:00',1.37),('12664','2013-01-16','09:10:00',1.51),('12664','2013-01-16','09:15:00',1.73),('12664','2013-01-16','09:20:00',2.27),('12664','2013-01-16','09:25:00',2.4),('12664','2013-01-16','09:30:00',2.36),('12664','2013-01-16','09:35:00',2.36),('12664','2013-01-16','09:40:00',2.28),('12664','2013-01-16','09:45:00',1.97),('12664','2013-01-16','09:50:00',1.37),('12664','2013-01-16','10:20:00',1.21),('12664','2013-01-16','10:25:00',2.39),('12664','2013-01-16','10:30:00',2.14),('12664','2013-01-16','10:35:00',2.96),('12664','2013-01-16','10:40:00',3),('12664','2013-01-16','10:45:00',3.71),('12664','2013-01-16','10:50:00',1.1),('12664','2013-01-16','10:55:00',1.2),('12664','2013-01-16','12:00:00',1.94),('12664','2013-01-16','12:05:00',2.36),('12664','2013-01-16','12:10:00',3.88),('12664','2013-01-16','12:15:00',3.47),('12664','2013-01-16','13:10:00',2.54),('12664','2013-01-16','13:15:00',2.93),('12664','2013-01-16','15:55:00',1.38),('12664','2013-01-16','16:00:00',1.09),('12664','2013-01-15','10:00:00',1.15),('12664','2013-01-15','10:05:00',1.03),('12664','2013-01-15','10:10:00',1.13),('12664','2013-01-15','10:15:00',1.74),('12664','2013-01-15','10:20:00',1.21),('12664','2013-01-15','10:25:00',2.48),('12664','2013-01-15','10:30:00',1.48),('12664','2013-01-15','10:35:00',1.03),('12664','2013-01-15','10:45:00',1.07),('12664','2013-01-15','10:50:00',1.39),('12664','2013-01-15','10:55:00',1.59),('12664','2013-01-15','11:00:00',1.59),('12664','2013-01-15','11:05:00',1.71),('12664','2013-01-15','11:10:00',2.06),('12664','2013-01-15','11:15:00',2.14),('12664','2013-01-15','11:20:00',1.84),('12664','2013-01-15','11:25:00',1.73),('12664','2013-01-15','11:30:00',1.62),('12664','2013-01-15','11:35:00',1.57),('12664','2013-01-15','11:40:00',1.5),('12664','2013-01-15','11:45:00',1.34),('12664','2013-01-15','11:50:00',1.38),('12664','2013-01-15','11:55:00',1.49),('12664','2013-01-15','12:00:00',1.46),('12664','2013-01-15','12:05:00',1.41),('12664','2013-01-15','12:10:00',1.45),('12664','2013-01-15','12:15:00',1.4),('12664','2013-01-15','12:20:00',1.41),('12664','2013-01-15','12:25:00',1.4),('12664','2013-01-15','12:30:00',1.41),('12664','2013-01-15','12:35:00',1.43),('12664','2013-01-15','12:40:00',1.52),('12664','2013-01-15','12:45:00',1.5),('12664','2013-01-15','12:50:00',1.39),('12664','2013-01-15','12:55:00',1.2),('12664','2013-01-15','13:00:00',1.31),('12664','2013-01-15','13:05:00',1.41),('12664','2013-01-15','13:10:00',1.27),('12664','2013-01-15','13:15:00',1.3),('12664','2013-01-15','13:20:00',1.34),('12664','2013-01-15','13:25:00',1.2),('12664','2013-01-15','13:30:00',1.33),('12664','2013-01-15','13:35:00',1.26),('12664','2013-01-15','13:40:00',1.31),('12664','2013-01-15','13:45:00',1.37),('12664','2013-01-15','13:50:00',1.16),('12664','2013-01-15','13:55:00',1.4),('12664','2013-01-15','14:00:00',1.29),('12664','2013-01-15','14:05:00',1.21),('12664','2013-01-15','14:10:00',1.19),('12664','2013-01-15','14:15:00',1.57),('12664','2013-01-15','14:20:00',2.71),('12664','2013-01-15','14:25:00',2.85),('12664','2013-01-15','14:30:00',2.62),('12664','2013-01-15','14:35:00',2.51),('12664','2013-01-15','14:40:00',2.42),('12664','2013-01-15','14:45:00',2.29),('12664','2013-01-15','14:50:00',2.15),('12664','2013-01-15','14:55:00',2.17),('12664','2013-01-15','15:00:00',1.86),('12664','2013-01-15','15:05:00',2),('12664','2013-01-15','15:10:00',1.96),('12664','2013-01-15','15:15:00',1.91),('12664','2013-01-15','15:20:00',1.88),('12664','2013-01-15','15:25:00',1.79),('12664','2013-01-15','15:30:00',1.71),('12664','2013-01-15','15:35:00',1.5),('12664','2013-01-15','15:40:00',1.32),('12664','2013-01-15','15:45:00',1.14),('12664','2013-01-15','15:50:00',1.16),('12664','2013-01-15','15:55:00',1.34),('12664','2013-01-15','16:00:00',1.4),('12664','2013-01-15','16:05:00',1.23),('12664','2013-01-15','16:10:00',1.08),('12664','2013-01-14','15:10:00',1.4),('12664','2013-01-13','09:25:00',1.02),('12664','2013-01-13','09:30:00',1.52),('12664','2013-01-13','09:35:00',1.89),('12664','2013-01-13','09:50:00',1.3),('12664','2013-01-13','09:55:00',2.49),('12664','2013-01-13','10:00:00',2.45),('12664','2013-01-13','10:05:00',1.32),('12664','2013-01-13','10:10:00',1.22),('12664','2013-01-13','10:15:00',1.61),('12664','2013-01-13','10:20:00',3.19),('12664','2013-01-13','10:25:00',1.39),('12664','2013-01-13','10:35:00',1.08),('12664','2013-01-13','10:40:00',1.17),('12664','2013-01-12','08:35:00',1.03),('12664','2013-01-12','08:40:00',1.13),('12664','2013-01-12','08:45:00',1.24),('12664','2013-01-12','08:50:00',1.32),('12664','2013-01-12','08:55:00',1.44),('12664','2013-01-12','09:00:00',1.55),('12664','2013-01-12','09:05:00',1.65),('12664','2013-01-12','09:10:00',1.74),('12664','2013-01-12','09:15:00',1.81),('12664','2013-01-12','09:20:00',1.88),('12664','2013-01-12','09:25:00',1.94),('12664','2013-01-12','09:30:00',1.99),('12664','2013-01-12','09:35:00',2.05),('12664','2013-01-12','09:40:00',2.14),('12664','2013-01-12','09:45:00',2.22),('12664','2013-01-12','09:50:00',2.27),('12664','2013-01-12','09:55:00',2.33),('12664','2013-01-12','10:00:00',2.39),('12664','2013-01-12','10:05:00',2.48),('12664','2013-01-12','10:10:00',2.54),('12664','2013-01-12','10:15:00',2.62),('12664','2013-01-12','10:20:00',2.69),('12664','2013-01-12','10:25:00',2.61),('12664','2013-01-12','10:30:00',2.8),('12664','2013-01-12','10:35:00',2.84),('12664','2013-01-12','10:40:00',2.9),('12664','2013-01-12','10:45:00',2.94),('12664','2013-01-12','10:50:00',2.98),('12664','2013-01-12','10:55:00',3.03),('12664','2013-01-12','11:00:00',3.04),('12664','2013-01-12','11:05:00',3.06),('12664','2013-01-12','11:10:00',3.05),('12664','2013-01-12','11:15:00',3.06),('12664','2013-01-12','11:20:00',3.11),('12664','2013-01-12','11:25:00',3.16),('12664','2013-01-12','11:30:00',3.03),('12664','2013-01-12','11:35:00',3.07),('12664','2013-01-12','11:40:00',3.21),('12664','2013-01-12','11:45:00',3.19),('12664','2013-01-12','11:50:00',3.16),('12664','2013-01-12','11:55:00',3.22),('12664','2013-01-12','12:00:00',3.24),('12664','2013-01-12','12:05:00',3.23),('12664','2013-01-12','12:10:00',3.22),('12664','2013-01-12','12:15:00',3.2),('12664','2013-01-12','12:20:00',3.19),('12664','2013-01-12','12:25:00',3.23),('12664','2013-01-12','12:30:00',3.24),('12664','2013-01-12','12:35:00',3.18),('12664','2013-01-12','12:40:00',3.2),('12664','2013-01-12','12:45:00',3.14),('12664','2013-01-12','12:50:00',3.12),('12664','2013-01-12','12:55:00',3.1),('12664','2013-01-12','13:00:00',3.02),('12664','2013-01-12','13:05:00',2.87),('12664','2013-01-12','13:10:00',2.98),('12664','2013-01-12','13:15:00',2.86),('12664','2013-01-12','13:20:00',3.05),('12664','2013-01-12','13:25:00',3),('12664','2013-01-12','13:30:00',2.79),('12664','2013-01-12','13:35:00',2.76),('12664','2013-01-12','13:40:00',2.9),('12664','2013-01-12','13:45:00',2.9),('12664','2013-01-12','13:50:00',2.11),('12664','2013-01-12','13:55:00',2.47),('12664','2013-01-12','14:00:00',2.7),('12664','2013-01-12','14:05:00',2.65),('12664','2013-01-12','14:10:00',2.58),('12664','2013-01-12','14:15:00',2.51),('12664','2013-01-12','14:20:00',2.39),('12664','2013-01-12','14:25:00',2.37),('12664','2013-01-12','14:30:00',2.29),('12664','2013-01-12','14:35:00',2.24),('12664','2013-01-12','14:40:00',2.17),('12664','2013-01-12','14:45:00',2.12),('12664','2013-01-12','14:50:00',2.02),('12664','2013-01-12','14:55:00',1.98),('12664','2013-01-12','15:00:00',1.89),('12664','2013-01-12','15:05:00',1.79),('12664','2013-01-12','15:10:00',1.69),('12664','2013-01-12','15:15:00',1.6),('12664','2013-01-12','15:20:00',1.48),('12664','2013-01-12','15:25:00',1.43),('12664','2013-01-12','15:30:00',1.39),('12664','2013-01-12','15:35:00',1.29),('12664','2013-01-12','15:40:00',1.2),('12664','2013-01-12','15:45:00',1.12),('12664','2013-01-12','15:50:00',1.01),('12664','2013-01-11','09:40:00',1.72),('12664','2013-01-11','09:45:00',2.19),('12664','2013-01-11','09:50:00',2.66),('12664','2013-01-11','09:55:00',1.87),('12664','2013-01-11','10:00:00',2.25),('12664','2013-01-11','10:10:00',1.23),('12664','2013-01-11','10:15:00',2.54),('12664','2013-01-11','10:20:00',2.55),('12664','2013-01-11','10:25:00',2.57),('12664','2013-01-11','10:30:00',2.7),('12664','2013-01-11','10:35:00',2.73),('12664','2013-01-11','10:40:00',2.76),('12664','2013-01-11','10:45:00',2.82),('12664','2013-01-11','10:50:00',2.85),('12664','2013-01-11','10:55:00',2.84),('12664','2013-01-11','11:00:00',2.82),('12664','2013-01-11','11:05:00',2.9),('12664','2013-01-11','11:10:00',2.91),('12664','2013-01-11','11:15:00',2.88),('12664','2013-01-11','11:20:00',2.22),('12664','2013-01-11','11:25:00',1.66),('12664','2013-01-11','11:30:00',1.96),('12664','2013-01-11','11:35:00',1.85),('12664','2013-01-11','11:40:00',1.97),('12664','2013-01-11','11:45:00',1.31),('12664','2013-01-11','12:45:00',1.99),('12664','2013-01-11','12:50:00',2.33),('12664','2013-01-11','12:55:00',1.03),('12664','2013-01-11','13:30:00',1.63),('12664','2013-01-11','13:35:00',1.63),('12664','2013-01-11','13:40:00',1.44),('12664','2013-01-11','14:40:00',1.89),('12664','2013-01-11','14:45:00',2.44),('12664','2013-01-11','14:50:00',1.16),('12664','2013-01-11','14:55:00',1.63),('12664','2013-01-11','15:00:00',1.76),('12664','2014-03-18','08:15:00',1.35),('12664','2014-03-18','08:20:00',1.18),('12664','2014-03-18','08:25:00',1),('12664','2014-03-18','08:35:00',1.09),('12664','2014-03-18','08:40:00',1.33),('12664','2014-03-18','08:45:00',1.51),('12664','2014-03-18','08:50:00',2.75),('12664','2014-03-18','08:55:00',2.12),('12664','2014-03-18','09:00:00',1.62),('12664','2014-03-18','09:15:00',1.16),('12664','2014-03-18','09:20:00',1.06),('12664','2014-03-18','09:35:00',1.51),('12664','2014-03-18','09:40:00',1.05),('12664','2014-03-18','09:50:00',1.2),('12664','2014-03-18','09:55:00',1.09),('12664','2014-03-18','10:00:00',1.08),('12664','2014-03-18','10:05:00',1.12),('12664','2014-03-18','10:10:00',2.67),('12664','2014-03-18','10:15:00',2.11),('12664','2014-03-18','10:20:00',2.89),('12664','2014-03-18','10:25:00',1.39),('12664','2014-03-18','10:30:00',1.28),('12664','2014-03-18','10:35:00',1.15),('12664','2014-03-18','10:40:00',1.06),('12664','2014-03-18','10:45:00',1.08),('12664','2014-03-18','10:50:00',1.13),('12664','2014-03-18','10:55:00',1.45),('12664','2014-03-18','11:00:00',2.26),('12664','2014-03-18','11:05:00',2.71),('12664','2014-03-18','11:10:00',4.05),('12664','2014-03-18','11:15:00',3.91),('12664','2014-03-18','11:20:00',3.81),('12664','2014-03-18','11:25:00',3.82),('12664','2014-03-18','11:30:00',1.65),('12664','2014-03-18','11:35:00',2.1),('12664','2014-03-18','11:40:00',2.12),('12664','2014-03-18','11:45:00',4.15),('12664','2014-03-18','11:50:00',3.54),('12664','2014-03-18','11:55:00',1.51),('12664','2014-03-18','12:00:00',3.17),('12664','2014-03-18','12:05:00',3.85),('12664','2014-03-18','12:10:00',4.12),('12664','2014-03-18','12:15:00',2.95),('12664','2014-03-18','12:20:00',2.47),('12664','2014-03-18','12:25:00',4.04),('12664','2014-03-18','12:30:00',3.18),('12664','2014-03-18','12:35:00',3.78),('12664','2014-03-18','12:40:00',3.86),('12664','2014-03-18','12:45:00',3.36),('12664','2014-03-18','12:50:00',3.62),('12664','2014-03-18','12:55:00',3.45),('12664','2014-03-18','13:00:00',3.95),('12664','2014-03-18','13:05:00',3.72),('12664','2014-03-18','13:10:00',3.8),('12664','2014-03-18','13:15:00',3.8),('12664','2014-03-18','13:20:00',3.57),('12664','2014-03-18','13:25:00',3.62),('12664','2014-03-18','13:30:00',3.62),('12664','2014-03-18','13:35:00',3.56),('12664','2014-03-18','13:40:00',3.56),('12664','2014-03-18','13:45:00',3.51),('12664','2014-03-18','13:50:00',3.48),('12664','2014-03-18','13:55:00',3.39),('12664','2014-03-18','14:00:00',3.36),('12664','2014-03-18','14:05:00',3.29),('12664','2014-03-18','14:10:00',3.31),('12664','2014-03-18','14:15:00',3.28),('12664','2014-03-18','14:20:00',3.19),('12664','2014-03-18','14:25:00',3.17),('12664','2014-03-18','14:30:00',3.12),('12664','2014-03-18','14:35:00',2.99),('12664','2014-03-18','14:40:00',2.92),('12664','2014-03-18','14:45:00',2.87),('12664','2014-03-18','14:50:00',2.84),('12664','2014-03-18','14:55:00',2.79),('12664','2014-03-18','15:00:00',2.73),('12664','2014-03-18','15:05:00',2.67),('12664','2014-03-18','15:10:00',2.61),('12664','2014-03-18','15:15:00',2.51),('12664','2014-03-18','15:20:00',2.42),('12664','2014-03-18','15:25:00',2.29),('12664','2014-03-18','15:30:00',2.22),('12664','2014-03-18','15:35:00',2.04),('12664','2014-03-18','15:40:00',2.1),('12664','2014-03-18','15:45:00',2.01),('12664','2014-03-18','15:50:00',1.92),('12664','2014-03-18','15:55:00',1.88),('12664','2014-03-18','16:00:00',1.78),('12664','2014-03-18','16:05:00',1.68),('12664','2014-03-18','16:10:00',1.6),('12664','2014-03-18','16:15:00',1.51),('12664','2014-03-18','16:20:00',1.4),('12664','2014-03-18','16:25:00',1.04),('12664','2014-03-18','16:30:00',1.22),('12664','2014-03-18','16:35:00',1.15),('12664','2014-03-18','16:40:00',1.06),('12664','2013-01-10','11:25:00',1),('12664','2013-01-10','11:30:00',1.05),('12664','2013-01-10','12:00:00',1.17),('12664','2013-01-10','12:05:00',1.01),('12664','2013-01-10','13:55:00',1.37),('12664','2013-01-09','10:40:00',1.4),('12664','2013-01-09','10:45:00',1.97),('12664','2013-01-09','10:50:00',1.47),('12664','2013-01-09','10:55:00',1.25),('12664','2013-01-09','11:00:00',1.3),('12664','2013-01-09','11:05:00',2.41),('12664','2013-01-09','11:10:00',2.23),('12664','2013-01-09','11:15:00',1.58),('12664','2013-01-09','11:20:00',1.57),('12664','2013-01-09','11:25:00',2.09),('12664','2013-01-09','11:30:00',1.5),('12664','2013-01-09','11:35:00',1.59),('12664','2013-01-09','11:40:00',1.81),('12664','2013-01-09','11:45:00',1.57),('12664','2013-01-09','11:50:00',2.12),('12664','2013-01-09','11:55:00',2.42),('12664','2013-01-09','12:00:00',2.47),('12664','2013-01-09','12:05:00',2.12),('12664','2013-01-09','12:10:00',2.6),('12664','2013-01-09','12:15:00',2.6),('12664','2013-01-09','12:20:00',2.16),('12664','2013-01-09','12:25:00',2.13),('12664','2013-01-09','12:30:00',1.38),('12664','2013-01-09','12:35:00',1.51),('12664','2013-01-09','12:40:00',2.17),('12664','2013-01-09','12:45:00',3),('12664','2013-01-09','12:50:00',3.27),('12664','2013-01-09','12:55:00',2.86),('12664','2013-01-09','13:00:00',2.01),('12664','2013-01-09','13:05:00',1.95),('12664','2013-01-09','13:10:00',1.51),('12664','2013-01-09','13:15:00',1.36),('12664','2013-01-09','13:20:00',1.47),('12664','2013-01-09','13:25:00',1.72),('12664','2013-01-09','13:30:00',1.94),('12664','2013-01-09','13:35:00',1.7),('12664','2013-01-09','13:40:00',1.8),('12664','2013-01-09','13:45:00',1.4),('12664','2013-01-09','13:50:00',1.39),('12664','2013-01-09','13:55:00',1.48),('12664','2013-01-09','14:00:00',1.46),('12664','2013-01-09','14:05:00',1.74),('12664','2013-01-09','14:10:00',1.43),('12664','2013-01-09','14:15:00',1.8),('12664','2013-01-09','14:20:00',1.3),('12664','2013-01-09','14:25:00',1.37),('12664','2013-01-09','15:35:00',1.18),('12664','2013-01-09','15:40:00',1.12),('12664','2013-01-09','15:45:00',1.02),('12664','2013-01-08','08:30:00',1.18),('12664','2013-01-08','08:35:00',1.36),('12664','2013-01-08','08:40:00',1.47),('12664','2013-01-08','08:45:00',1.5),('12664','2013-01-08','08:50:00',1.71),('12664','2013-01-08','08:55:00',1.88),('12664','2013-01-08','09:00:00',1.89),('12664','2013-01-08','09:05:00',1.26),('12664','2013-01-08','09:10:00',1.37),('12664','2013-01-08','09:15:00',1.78),('12664','2013-01-08','09:20:00',2.26),('12664','2013-01-08','09:25:00',2.28),('12664','2013-01-08','09:30:00',2.16),('12664','2013-01-08','09:35:00',2.52),('12664','2013-01-08','09:40:00',2.72),('12664','2013-01-08','09:45:00',2.68),('12664','2013-01-08','09:50:00',2.61),('12664','2013-01-08','09:55:00',2.33),('12664','2013-01-08','10:00:00',2.2),('12664','2013-01-08','10:05:00',2.36),('12664','2013-01-08','10:10:00',2),('12664','2013-01-08','10:15:00',1.92),('12664','2013-01-08','10:20:00',2.25),('12664','2013-01-08','10:25:00',2.29),('12664','2013-01-08','10:30:00',2.27),('12664','2013-01-08','10:35:00',2.63),('12664','2013-01-08','10:40:00',2.34),('12664','2013-01-08','10:45:00',2.08),('12664','2013-01-08','10:50:00',2.88),('12664','2013-01-08','10:55:00',2.97),('12664','2013-01-08','11:00:00',3),('12664','2013-01-08','11:05:00',3.04),('12664','2013-01-08','11:10:00',3.08),('12664','2013-01-08','11:15:00',3.09),('12664','2013-01-08','11:20:00',3.08),('12664','2013-01-08','11:25:00',3.05),('12664','2013-01-08','11:30:00',3.15),('12664','2013-01-08','11:35:00',3.14),('12664','2013-01-08','11:40:00',3.19),('12664','2013-01-08','11:45:00',2.74),('12664','2013-01-08','11:50:00',2.76),('12664','2013-01-08','11:55:00',3.39),('12664','2013-01-08','12:00:00',2.13),('12664','2013-01-08','12:05:00',1.88),('12664','2013-01-08','12:10:00',2.07),('12664','2013-01-08','12:15:00',2.13),('12664','2013-01-08','12:20:00',1.66),('12664','2013-01-08','12:25:00',1.38),('12664','2013-01-08','12:30:00',1.38),('12664','2013-01-08','12:35:00',1.48),('12664','2013-01-08','12:40:00',1.42),('12664','2013-01-08','12:45:00',1.18),('12664','2013-01-08','12:50:00',1.15),('12664','2013-01-08','12:55:00',1.1),('12664','2013-01-08','13:05:00',1.16),('12664','2013-01-08','13:15:00',1.02),('12664','2013-01-08','13:20:00',1.2),('12664','2013-01-08','13:25:00',1.41),('12664','2013-01-08','13:30:00',1.2),('12664','2013-01-08','13:35:00',1.16),('12664','2013-01-08','13:40:00',1.16),('12664','2013-01-08','13:45:00',1.5),('12664','2013-01-08','13:50:00',2.49),('12664','2013-01-08','13:55:00',1.2),('12664','2013-01-08','14:10:00',1.37),('12664','2013-01-08','14:20:00',1.29),('12664','2013-01-08','14:25:00',1.95),('12664','2013-01-08','14:30:00',2.21),('12664','2013-01-08','14:35:00',1.09),('12664','2013-01-08','14:40:00',1.41),('12664','2013-01-08','14:45:00',1.72),('12664','2013-01-08','14:50:00',1.29),('12664','2013-01-07','08:45:00',1.1),('12664','2013-01-07','08:50:00',1.23),('12664','2013-01-07','08:55:00',1.31),('12664','2013-01-07','09:00:00',1.35),('12664','2013-01-07','09:05:00',1.07),('12664','2013-01-07','09:10:00',1.23),('12664','2013-01-07','09:15:00',1.67),('12664','2013-01-07','09:20:00',1.77),('12664','2013-01-07','09:25:00',1.86),('12664','2013-01-07','09:30:00',1.96),('12664','2013-01-07','09:35:00',2.05),('12664','2013-01-07','09:40:00',2.14),('12664','2013-01-07','09:45:00',2.15),('12664','2013-01-07','09:50:00',2.2),('12664','2013-01-07','09:55:00',2.29),('12664','2013-01-07','10:00:00',2.34),('12664','2013-01-07','10:05:00',2.49),('12664','2013-01-07','10:10:00',2.57),('12664','2013-01-07','10:15:00',2.64),('12664','2013-01-07','10:20:00',2.63),('12664','2013-01-07','10:25:00',2.67),('12664','2013-01-07','10:30:00',2.71),('12664','2013-01-07','10:35:00',2.75),('12664','2013-01-07','10:40:00',2.83),('12664','2013-01-07','10:45:00',2.92),('12664','2013-01-07','10:50:00',2.9),('12664','2013-01-07','10:55:00',2.87),('12664','2013-01-07','11:00:00',2.91),('12664','2013-01-07','11:05:00',2.94),('12664','2013-01-07','11:10:00',2.96),('12664','2013-01-07','11:15:00',3.05),('12664','2013-01-07','11:20:00',3.03),('12664','2013-01-07','11:25:00',3.05),('12664','2013-01-07','11:30:00',3.1),('12664','2013-01-07','11:35:00',3.11),('12664','2013-01-07','11:40:00',3.11),('12664','2013-01-07','11:45:00',3.1),('12664','2013-01-07','11:50:00',3.12),('12664','2013-01-07','11:55:00',3.12),('12664','2013-01-07','12:00:00',3.11),('12664','2013-01-07','12:05:00',3.08),('12664','2013-01-07','12:10:00',3.07),('12664','2013-01-07','12:15:00',3.07),('12664','2013-01-07','12:20:00',3.08),('12664','2013-01-07','12:25:00',3.09),('12664','2013-01-07','12:30:00',3.07),('12664','2013-01-07','12:35:00',3.04),('12664','2013-01-07','12:40:00',3.03),('12664','2013-01-07','12:45:00',3.05),('12664','2013-01-07','12:50:00',3.05),('12664','2013-01-07','12:55:00',3.01),('12664','2013-01-07','13:00:00',2.99),('12664','2013-01-07','13:05:00',2.96),('12664','2013-01-07','13:10:00',2.95),('12664','2013-01-07','13:15:00',2.92),('12664','2013-01-07','13:20:00',2.88),('12664','2013-01-07','13:25:00',2.85),('12664','2013-01-07','13:30:00',2.83),('12664','2013-01-07','13:35:00',2.8),('12664','2013-01-07','13:40:00',2.75),('12664','2013-01-07','13:45:00',2.71),('12664','2013-01-07','13:50:00',2.69),('12664','2013-01-07','13:55:00',2.66),('12664','2013-01-07','14:00:00',2.63),('12664','2013-01-07','14:05:00',2.59),('12664','2013-01-07','14:10:00',2.53),('12664','2013-01-07','14:15:00',2.46),('12664','2013-01-07','14:20:00',2.4),('12664','2013-01-07','14:25:00',2.34),('12664','2013-01-07','14:30:00',2.27),('12664','2013-01-07','14:35:00',2.18),('12664','2013-01-07','14:40:00',2.14),('12664','2013-01-07','14:45:00',2.08),('12664','2013-01-07','14:50:00',2.01),('12664','2013-01-07','14:55:00',1.93),('12664','2013-01-07','15:00:00',1.84),('12664','2013-01-07','15:05:00',1.77),('12664','2013-01-07','15:10:00',1.68),('12664','2013-01-07','15:15:00',1.6),('12664','2013-01-07','15:20:00',1.5),('12664','2013-01-07','15:25:00',1.4),('12664','2013-01-07','15:30:00',1.31),('12664','2013-01-07','15:35:00',1.22),('12664','2013-01-07','15:40:00',1.13),('12664','2013-01-07','15:45:00',1.03),('12664','2013-01-06','08:35:00',1.05),('12664','2013-01-06','08:40:00',1.14),('12664','2013-01-06','08:45:00',1.23),('12664','2013-01-06','08:50:00',1.33),('12664','2013-01-06','08:55:00',1.44),('12664','2013-01-06','09:00:00',1.54),('12664','2013-01-06','09:05:00',1.63),('12664','2013-01-06','09:10:00',1.73),('12664','2013-01-06','09:15:00',1.82),('12664','2013-01-06','09:20:00',1.91),('12664','2013-01-06','09:25:00',1.99),('12664','2013-01-06','09:30:00',2.08),('12664','2013-01-06','09:35:00',2.15),('12664','2013-01-06','09:40:00',2.22),('12664','2013-01-06','09:45:00',2.29),('12664','2013-01-06','09:50:00',2.35),('12664','2013-01-06','09:55:00',2.4),('12664','2013-01-06','10:00:00',2.43),('12664','2013-01-06','10:05:00',2.51),('12664','2013-01-06','10:10:00',2.51),('12664','2013-01-06','10:15:00',2.5),('12664','2013-01-06','10:20:00',2.59),('12664','2013-01-06','10:25:00',2.66),('12664','2013-01-06','10:30:00',2.72),('12664','2013-01-06','10:35:00',2.78),('12664','2013-01-06','10:40:00',2.8),('12664','2013-01-06','10:45:00',2.85),('12664','2013-01-06','10:50:00',2.88),('12664','2013-01-06','10:55:00',2.91),('12664','2013-01-06','11:00:00',2.96),('12664','2013-01-06','11:05:00',2.95),('12664','2013-01-06','11:10:00',2.97),('12664','2013-01-06','11:15:00',3.01),('12664','2013-01-06','11:20:00',3.01),('12664','2013-01-06','11:25:00',3.06),('12664','2013-01-06','11:30:00',3.09),('12664','2013-01-06','11:35:00',3.11),('12664','2013-01-06','11:40:00',3.1),('12664','2013-01-06','11:45:00',3.13),('12664','2013-01-06','11:50:00',3.12),('12664','2013-01-06','11:55:00',3.14),('12664','2013-01-06','12:00:00',3.2),('12664','2013-01-06','12:05:00',3.2),('12664','2013-01-06','12:10:00',3.14),('12664','2013-01-06','12:15:00',3.19),('12664','2013-01-06','12:20:00',3.23),('12664','2013-01-06','12:25:00',3.23),('12664','2013-01-06','12:30:00',3.23),('12664','2013-01-06','12:35:00',3.23),('12664','2013-01-06','12:40:00',3.21),('12664','2013-01-06','12:45:00',3.19),('12664','2013-01-06','12:50:00',3.16),('12664','2013-01-06','12:55:00',3.13),('12664','2013-01-06','13:00:00',3.09),('12664','2013-01-06','13:05:00',3.07),('12664','2013-01-06','13:10:00',3.04),('12664','2013-01-06','13:15:00',2.99),('12664','2013-01-06','13:20:00',2.93),('12664','2013-01-06','13:25:00',2.92),('12664','2013-01-06','13:30:00',2.88),('12664','2013-01-06','13:35:00',2.86),('12664','2013-01-06','13:40:00',2.78),('12664','2013-01-06','13:45:00',2.71),('12664','2013-01-06','13:50:00',2.64),('12664','2013-01-06','13:55:00',2.59),('12664','2013-01-06','14:00:00',2.58),('12664','2013-01-06','14:05:00',2.54),('12664','2013-01-06','14:10:00',2.46),('12664','2013-01-06','14:15:00',2.39),('12664','2013-01-06','14:20:00',2.34),('12664','2013-01-06','14:25:00',2.26),('12664','2013-01-06','14:30:00',2.18),('12664','2013-01-06','14:35:00',2.09),('12664','2013-01-06','14:40:00',2.03),('12664','2013-01-06','14:45:00',1.92),('12664','2013-01-06','14:50:00',1.85),('12664','2013-01-06','14:55:00',1.79),('12664','2013-01-06','15:00:00',1.7),('12664','2013-01-06','15:05:00',1.61),('12664','2013-01-06','15:10:00',1.55),('12664','2013-01-06','15:15:00',1.45),('12664','2013-01-06','15:20:00',1.36),('12664','2013-01-06','15:25:00',1.25),('12664','2013-01-06','15:30:00',1.18),('12664','2013-01-06','15:35:00',1.12),('12664','2013-01-06','15:40:00',1.03),('12664','2013-01-05','10:15:00',1.19),('12664','2013-01-05','10:20:00',1.21),('12664','2013-01-05','10:25:00',1.1),('12664','2013-01-05','10:30:00',1.16),('12664','2013-01-05','10:35:00',1.53),('12664','2013-01-05','10:40:00',1.66),('12664','2013-01-05','10:45:00',1.68),('12664','2013-01-05','10:50:00',1.77),('12664','2013-01-05','10:55:00',2.5),('12664','2013-01-05','11:00:00',2.58),('12664','2013-01-05','11:05:00',2.36),('12664','2013-01-05','11:10:00',2.53),('12664','2013-01-05','11:15:00',2.71),('12664','2013-01-05','11:20:00',2.96),('12664','2013-01-05','11:25:00',2.96),('12664','2013-01-05','11:30:00',2.76),('12664','2013-01-05','11:35:00',2.61),('12664','2013-01-05','11:40:00',2.5),('12664','2013-01-05','11:45:00',2.61),('12664','2013-01-05','11:50:00',2.34),('12664','2013-01-05','11:55:00',1.95),('12664','2013-01-05','12:00:00',1.87),('12664','2013-01-05','12:05:00',1.83),('12664','2013-01-05','12:10:00',2.03),('12664','2013-01-05','12:15:00',2.03),('12664','2013-01-05','12:20:00',1.8),('12664','2013-01-05','12:25:00',1.46),('12664','2013-01-05','12:30:00',1.54),('12664','2013-01-05','12:35:00',2.12),('12664','2013-01-05','12:40:00',2.67),('12664','2013-01-05','12:45:00',2.61),('12664','2013-01-05','12:50:00',1.95),('12664','2013-01-05','12:55:00',1.63),('12664','2013-01-05','13:00:00',1.46),('12664','2013-01-05','13:05:00',1.3),('12664','2013-01-05','13:10:00',1.55),('12664','2013-01-05','13:15:00',1.3),('12664','2013-01-05','13:30:00',2.28),('12664','2013-01-05','13:35:00',1.64),('12664','2013-01-05','13:50:00',1.2),('12664','2013-01-05','13:55:00',1.86),('12664','2013-01-05','14:00:00',1.77),('12664','2013-01-05','14:05:00',2.26),('12664','2013-01-05','14:10:00',2.08),('12664','2013-01-05','14:15:00',2.1),('12664','2013-01-05','14:20:00',1.51),('12664','2013-01-05','14:25:00',1.11),('12664','2013-01-05','14:30:00',1.6),('12664','2013-01-05','14:35:00',1.43),('12664','2013-01-05','14:40:00',1.22),('12664','2013-01-05','14:45:00',1.58),('12664','2013-01-05','14:50:00',1.47),('12664','2013-01-05','14:55:00',1.07),('12664','2013-01-04','08:40:00',1.03),('12664','2013-01-04','08:45:00',1.34),('12664','2013-01-04','08:50:00',1.47),('12664','2013-01-04','08:55:00',1.58),('12664','2013-01-04','09:00:00',1.52),('12664','2013-01-04','09:05:00',1.41),('12664','2013-01-04','09:10:00',1.37),('12664','2013-01-04','09:15:00',1.66),('12664','2013-01-04','09:20:00',1.53),('12664','2013-01-04','09:25:00',1.67),('12664','2013-01-04','09:30:00',1.87),('12664','2013-01-04','09:35:00',1.76),('12664','2013-01-04','09:40:00',1.84),('12664','2013-01-04','09:45:00',2.18),('12664','2013-01-04','09:50:00',1.94),('12664','2013-01-04','09:55:00',2.3),('12664','2013-01-04','10:00:00',2.47),('12664','2013-01-04','10:05:00',2.77),('12664','2013-01-04','10:10:00',2.52),('12664','2013-01-04','10:15:00',2.31),('12664','2013-01-04','10:20:00',2.59),('12664','2013-01-04','10:25:00',2.66),('12664','2013-01-04','10:30:00',2.7),('12664','2013-01-04','10:35:00',2.81),('12664','2013-01-04','10:40:00',2.76),('12664','2013-01-04','10:45:00',2.86),('12664','2013-01-04','10:50:00',3.02),('12664','2013-01-04','10:55:00',3.09),('12664','2013-01-04','11:00:00',3.5),('12664','2013-01-04','11:05:00',3.48),('12664','2013-01-04','11:10:00',2.27),('12664','2013-01-04','11:45:00',1.58),('12664','2013-01-04','11:50:00',2.84),('12664','2013-01-04','11:55:00',3.55),('12664','2013-01-04','12:00:00',3.81),('12664','2013-01-04','12:05:00',2.38),('12664','2013-01-04','12:10:00',1.46),('12664','2013-01-04','12:15:00',1.02),('12664','2013-01-04','12:25:00',1.39),('12664','2013-01-04','12:30:00',2.88),('12664','2013-01-04','12:35:00',3.35),('12664','2013-01-04','12:40:00',3.12),('12664','2013-01-04','12:45:00',2.87),('12664','2013-01-04','12:50:00',2.96),('12664','2013-01-04','12:55:00',3.3),('12664','2013-01-04','13:00:00',2.71),('12664','2013-01-04','13:05:00',1.95),('12664','2013-01-04','13:10:00',1.72),('12664','2013-01-04','13:15:00',2.8),('12664','2013-01-04','13:20:00',2.92),('12664','2013-01-04','13:25:00',2.85),('12664','2013-01-04','13:30:00',2.8),('12664','2013-01-04','13:35:00',2.76),('12664','2013-01-04','13:40:00',2.7),('12664','2013-01-04','13:45:00',2.64),('12664','2013-01-04','13:50:00',2.56),('12664','2013-01-04','13:55:00',2.5),('12664','2013-01-04','14:00:00',2.48),('12664','2013-01-04','14:05:00',2.43),('12664','2013-01-04','14:10:00',2.35),('12664','2013-01-04','14:15:00',2.31),('12664','2013-01-04','14:20:00',2.25),('12664','2013-01-04','14:25:00',2.21),('12664','2013-01-04','14:30:00',2.12),('12664','2013-01-04','14:35:00',2.05),('12664','2013-01-04','14:40:00',1.99),('12664','2013-01-04','14:45:00',1.91),('12664','2013-01-04','14:50:00',1.83),('12664','2013-01-04','14:55:00',1.77),('12664','2013-01-04','15:00:00',1.7),('12664','2013-01-04','15:05:00',1.61),('12664','2013-01-04','15:10:00',1.42),('12664','2013-01-04','15:15:00',1.43),('12664','2013-01-04','15:20:00',1.33),('12664','2013-01-04','15:25:00',1.26),('12664','2013-01-04','15:30:00',1.18),('12664','2013-01-04','15:35:00',1.07),('12664','2013-01-03','08:40:00',1.1),('12664','2013-01-03','08:45:00',1.17),('12664','2013-01-03','08:50:00',1.28),('12664','2013-01-03','08:55:00',1.4),('12664','2013-01-03','09:00:00',1.51),('12664','2013-01-03','09:05:00',1.63),('12664','2013-01-03','09:10:00',1.75),('12664','2013-01-03','09:15:00',1.84),('12664','2013-01-03','09:20:00',1.94),('12664','2013-01-03','09:25:00',2.04),('12664','2013-01-03','09:30:00',2.13),('12664','2013-01-03','09:35:00',2.25),('12664','2013-01-03','09:40:00',2.44),('12664','2013-01-03','09:45:00',2.64),('12664','2013-01-03','09:50:00',2.8),('12664','2013-01-03','09:55:00',2.78),('12664','2013-01-03','10:00:00',1.95),('12664','2013-01-03','10:05:00',1.58),('12664','2013-01-03','10:10:00',1.98),('12664','2013-01-03','10:15:00',1.66),('12664','2013-01-03','10:20:00',1.65),('12664','2013-01-03','10:25:00',1.65),('12664','2013-01-03','10:30:00',1.85),('12664','2013-01-03','10:35:00',1.93),('12664','2013-01-03','10:40:00',2.01),('12664','2013-01-03','10:45:00',1.9),('12664','2013-01-03','10:50:00',1.72),('12664','2013-01-03','10:55:00',1.74),('12664','2013-01-03','11:00:00',1.64),('12664','2013-01-03','11:05:00',1.81),('12664','2013-01-03','11:10:00',2.03),('12664','2013-01-03','11:15:00',1.82),('12664','2013-01-03','11:20:00',1.44),('12664','2013-01-03','11:25:00',1.95),('12664','2013-01-03','11:30:00',3.12),('12664','2013-01-03','11:35:00',3.29),('12664','2013-01-03','11:40:00',3.2),('12664','2013-01-03','11:45:00',3.18),('12664','2013-01-03','11:50:00',3.16),('12664','2013-01-03','11:55:00',3.14),('12664','2013-01-03','12:00:00',3.11),('12664','2013-01-03','12:05:00',3.13),('12664','2013-01-03','12:10:00',3.12),('12664','2013-01-03','12:15:00',3.11),('12664','2013-01-03','12:20:00',3.12),('12664','2013-01-03','12:25:00',3.1),('12664','2013-01-03','12:30:00',3.07),('12664','2013-01-03','12:35:00',3.08),('12664','2013-01-03','12:40:00',3.06),('12664','2013-01-03','12:45:00',3.03),('12664','2013-01-03','12:50:00',3.01),('12664','2013-01-03','12:55:00',2.97),('12664','2013-01-03','13:00:00',2.96),('12664','2013-01-03','13:05:00',2.95),('12664','2013-01-03','13:10:00',2.94),('12664','2013-01-03','13:15:00',2.88),('12664','2013-01-03','13:20:00',2.87),('12664','2013-01-03','13:25:00',2.82),('12664','2013-01-03','13:30:00',2.79),('12664','2013-01-03','13:35:00',2.76),('12664','2013-01-03','13:40:00',2.72),('12664','2013-01-03','13:45:00',2.68),('12664','2013-01-03','13:50:00',2.62),('12664','2013-01-03','13:55:00',2.57),('12664','2013-01-03','14:00:00',2.55),('12664','2013-01-03','14:05:00',2.47),('12664','2013-01-03','14:10:00',2.42),('12664','2013-01-03','14:15:00',2.32),('12664','2013-01-03','14:20:00',2.26),('12664','2013-01-03','14:25:00',2.19),('12664','2013-01-03','14:30:00',2.11),('12664','2013-01-03','14:35:00',2.05),('12664','2013-01-03','14:40:00',2),('12664','2013-01-03','14:45:00',1.84),('12664','2013-01-03','14:50:00',1.86),('12664','2013-01-03','14:55:00',1.81),('12664','2013-01-03','15:00:00',1.72),('12664','2013-01-03','15:05:00',1.63),('12664','2013-01-03','15:10:00',1.54),('12664','2013-01-03','15:15:00',1.46),('12664','2013-01-03','15:20:00',1.33),('12664','2013-01-03','15:25:00',1.15),('12664','2013-01-03','15:30:00',1.05),('12664','2013-01-03','15:35:00',1.1),('12664','2013-01-03','15:40:00',1.01),('12664','2013-01-02','11:40:00',2.34),('12664','2013-01-02','11:45:00',1.57),('12664','2013-01-02','11:50:00',1.15),('12664','2013-01-02','12:30:00',1.14),('12664','2013-01-02','12:35:00',1.15),('12664','2013-01-02','12:50:00',1.1),('12664','2013-01-02','12:55:00',1.26),('12664','2013-01-02','13:00:00',1.16),('12664','2013-01-02','13:10:00',1.38),('12664','2013-01-02','13:15:00',1.55),('12664','2013-01-02','13:30:00',1.01),('12664','2013-01-02','13:45:00',1.18),('12664','2013-01-02','13:50:00',1.02),('12664','2013-01-01','08:45:00',1.08),('12664','2013-01-01','08:50:00',1.19),('12664','2013-01-01','08:55:00',1.27),('12664','2013-01-01','09:00:00',1.35),('12664','2013-01-01','09:05:00',1.45),('12664','2013-01-01','09:10:00',1.56),('12664','2013-01-01','09:15:00',1.64),('12664','2013-01-01','09:20:00',1.71),('12664','2013-01-01','09:25:00',1.79),('12664','2013-01-01','09:30:00',1.89),('12664','2013-01-01','09:35:00',1.99),('12664','2013-01-01','09:40:00',2.07),('12664','2013-01-01','09:45:00',2.13),('12664','2013-01-01','09:50:00',2.19),('12664','2013-01-01','09:55:00',2.23),('12664','2013-01-01','10:00:00',2.28),('12664','2013-01-01','10:05:00',2.32),('12664','2013-01-01','10:10:00',2.41),('12664','2013-01-01','10:15:00',2.47),('12664','2013-01-01','10:20:00',2.53),('12664','2013-01-01','10:25:00',2.63),('12664','2013-01-01','10:30:00',2.52),('12664','2013-01-01','10:35:00',1.24),('12664','2013-01-01','10:45:00',1.99),('12664','2013-01-01','10:50:00',3.06),('12664','2013-01-01','10:55:00',2.85),('12664','2013-01-01','11:00:00',2.81),('12664','2013-01-01','11:05:00',2.8),('12664','2013-01-01','11:10:00',1.93),('12664','2013-01-01','11:15:00',2.5),('12664','2013-01-01','11:20:00',1.06),('12664','2013-01-01','11:25:00',1.49),('12664','2013-01-01','11:30:00',2.91),('12664','2013-01-01','11:35:00',2.75),('12664','2013-01-01','11:40:00',2.79),('12664','2013-01-01','11:45:00',3.17),('12664','2013-01-01','11:50:00',1.84),('12664','2013-01-01','11:55:00',1.56),('12664','2013-01-01','12:00:00',1.73),('12664','2013-01-01','12:05:00',1.9),('12664','2013-01-01','12:10:00',1.51),('12664','2013-01-01','12:15:00',1.5),('12664','2013-01-01','12:20:00',1.29),('12664','2013-01-01','12:25:00',1.11),('12664','2013-01-01','12:35:00',1.05),('12664','2013-01-01','12:40:00',1.02),('12664','2013-01-01','12:45:00',1.08),('12664','2014-03-17','09:20:00',1.06),('12664','2014-03-17','09:30:00',1.09),('12664','2014-03-17','09:35:00',1.07),('12664','2014-03-17','09:40:00',1.12),('12664','2014-03-17','09:45:00',1.03),('12664','2014-03-17','10:10:00',1.01),('12664','2014-03-17','10:30:00',1.09),('12664','2014-03-17','10:35:00',1.64),('12664','2014-03-17','10:40:00',1.53),('12664','2014-03-17','10:45:00',1.09),('12664','2014-03-17','10:50:00',1.38),('12664','2014-03-17','10:55:00',1.54),('12664','2014-03-17','11:00:00',1.44),('12664','2014-03-17','11:05:00',1.28),('12664','2014-03-17','11:10:00',2.07),('12664','2014-03-17','11:15:00',1.3),('12664','2014-03-17','11:20:00',1.21),('12664','2014-03-17','11:25:00',1.65),('12664','2014-03-17','11:30:00',1.11),('12664','2014-03-17','11:40:00',1.51),('12664','2014-03-17','11:45:00',1.65),('12664','2014-03-17','11:50:00',1.11),('12664','2014-03-17','11:55:00',1.66),('12664','2014-03-17','12:00:00',1.59),('12664','2014-03-17','12:05:00',1.94),('12664','2014-03-17','12:10:00',1.69),('12664','2014-03-17','12:15:00',2.32),('12664','2014-03-17','12:20:00',2.52),('12664','2014-03-17','12:25:00',3.65),('12664','2014-03-17','12:30:00',4.5),('12664','2014-03-17','12:35:00',4.07),('12664','2014-03-17','12:40:00',3.29),('12664','2014-03-17','12:45:00',2.38),('12664','2014-03-17','12:50:00',2.48),('12664','2014-03-17','12:55:00',2.95),('12664','2014-03-17','13:00:00',3.89),('12664','2014-03-17','13:05:00',1.84),('12664','2014-03-17','13:10:00',3.58),('12664','2014-03-17','13:15:00',3.5),('12664','2014-03-17','13:20:00',3.53),('12664','2014-03-17','13:25:00',3.58),('12664','2014-03-17','13:30:00',3.5),('12664','2014-03-17','13:35:00',3.6),('12664','2014-03-17','13:40:00',3.28),('12664','2014-03-17','13:45:00',2.75),('12664','2014-03-17','13:50:00',2.82),('12664','2014-03-17','13:55:00',3.57),('12664','2014-03-17','14:00:00',2.98),('12664','2014-03-17','14:05:00',3.27),('12664','2014-03-17','14:10:00',3.36),('12664','2014-03-17','14:15:00',3.4),('12664','2014-03-17','14:20:00',3.2),('12664','2014-03-17','14:25:00',2.5),('12664','2014-03-17','14:30:00',3.03),('12664','2014-03-17','14:35:00',1.74),('12664','2014-03-17','14:40:00',2.46),('12664','2014-03-17','14:45:00',2.99),('12664','2014-03-17','14:50:00',2.87),('12664','2014-03-17','14:55:00',2.75),('12664','2014-03-17','15:00:00',2.69),('12664','2014-03-17','15:05:00',2.58),('12664','2014-03-17','15:10:00',2.4),('12664','2014-03-17','15:15:00',1.59),('12664','2014-03-17','15:20:00',1.28),('12664','2014-03-17','15:35:00',1.82),('12664','2014-03-17','15:40:00',2.31),('12664','2014-03-17','15:45:00',2.1),('12664','2014-03-17','15:50:00',1.93),('12664','2014-03-17','15:55:00',1.8),('12664','2014-03-17','16:00:00',1.54),('12664','2014-03-17','16:05:00',1.59),('12664','2014-03-17','16:10:00',1.39),('12664','2014-03-17','16:15:00',1.31),('12664','2012-12-31','08:45:00',1.07),('12664','2012-12-31','08:55:00',1.11),('12664','2012-12-31','09:00:00',1.23),('12664','2012-12-31','09:05:00',1.51),('12664','2012-12-31','09:10:00',1.83),('12664','2012-12-31','09:15:00',1.94),('12664','2012-12-31','09:20:00',2.04),('12664','2012-12-31','09:25:00',2.15),('12664','2012-12-31','09:30:00',2.26),('12664','2012-12-31','09:35:00',2.33),('12664','2012-12-31','09:40:00',2.4),('12664','2012-12-31','09:45:00',2.47),('12664','2012-12-31','09:50:00',2.56),('12664','2012-12-31','09:55:00',2.62),('12664','2012-12-31','10:00:00',2.66),('12664','2012-12-31','10:05:00',2.7),('12664','2012-12-31','10:10:00',2.72),('12664','2012-12-31','10:15:00',2.76),('12664','2012-12-31','10:20:00',2.8),('12664','2012-12-31','10:25:00',2.78),('12664','2012-12-31','10:30:00',2.76),('12664','2012-12-31','10:35:00',2.86),('12664','2012-12-31','10:40:00',2.92),('12664','2012-12-31','10:45:00',2.95),('12664','2012-12-31','10:50:00',2.95),('12664','2012-12-31','10:55:00',2.96),('12664','2012-12-31','11:00:00',3.03),('12664','2012-12-31','11:05:00',3.07),('12664','2012-12-31','11:10:00',3.13),('12664','2012-12-31','11:15:00',3.15),('12664','2012-12-31','11:20:00',3.17),('12664','2012-12-31','11:25:00',3.18),('12664','2012-12-31','11:30:00',3.21),('12664','2012-12-31','11:35:00',3.22),('12664','2012-12-31','11:40:00',3.22),('12664','2012-12-31','11:45:00',3.24),('12664','2012-12-31','11:50:00',3.24),('12664','2012-12-31','11:55:00',3.23),('12664','2012-12-31','12:00:00',3.24),('12664','2012-12-31','12:05:00',3.24),('12664','2012-12-31','12:10:00',3.22),('12664','2012-12-31','12:15:00',3.24),('12664','2012-12-31','12:20:00',3.22),('12664','2012-12-31','12:25:00',3.22),('12664','2012-12-31','12:30:00',3.21),('12664','2012-12-31','12:35:00',3.2),('12664','2012-12-31','12:40:00',3.2),('12664','2012-12-31','12:45:00',3.18),('12664','2012-12-31','12:50:00',3.16),('12664','2012-12-31','12:55:00',3.14),('12664','2012-12-31','13:00:00',3.13),('12664','2012-12-31','13:05:00',3.12),('12664','2012-12-31','13:10:00',3.07),('12664','2012-12-31','13:15:00',3.01),('12664','2012-12-31','13:20:00',2.97),('12664','2012-12-31','13:25:00',2.94),('12664','2012-12-31','13:30:00',2.93),('12664','2012-12-31','13:35:00',2.88),('12664','2012-12-31','13:40:00',2.84),('12664','2012-12-31','13:45:00',2.8),('12664','2012-12-31','13:50:00',2.77),('12664','2012-12-31','13:55:00',2.7),('12664','2012-12-31','14:00:00',2.65),('12664','2012-12-31','14:05:00',2.58),('12664','2012-12-31','14:10:00',2.53),('12664','2012-12-31','14:15:00',2.46),('12664','2012-12-31','14:20:00',2.4),('12664','2012-12-31','14:25:00',2.33),('12664','2012-12-31','14:30:00',2.26),('12664','2012-12-31','14:35:00',2.18),('12664','2012-12-31','14:40:00',2.11),('12664','2012-12-31','14:45:00',2.02),('12664','2012-12-31','14:50:00',1.95),('12664','2012-12-31','14:55:00',1.87),('12664','2012-12-31','15:00:00',1.77),('12664','2012-12-31','15:05:00',1.68),('12664','2012-12-31','15:10:00',1.62),('12664','2012-12-31','15:15:00',1.55),('12664','2012-12-31','15:20:00',1.46),('12664','2012-12-31','15:25:00',1.36),('12664','2012-12-31','15:30:00',1.26),('12664','2012-12-31','15:35:00',1.15),('12664','2012-12-31','15:40:00',1.05),('12664','2012-12-30','08:35:00',1.07),('12664','2012-12-30','08:40:00',1.15),('12664','2012-12-30','08:45:00',1.26),('12664','2012-12-30','08:50:00',1.36),('12664','2012-12-30','08:55:00',1.47),('12664','2012-12-30','09:00:00',1.57),('12664','2012-12-30','09:05:00',1.65),('12664','2012-12-30','09:10:00',1.75),('12664','2012-12-30','09:15:00',1.81),('12664','2012-12-30','09:20:00',1.92),('12664','2012-12-30','09:25:00',2),('12664','2012-12-30','09:30:00',2.06),('12664','2012-12-30','09:35:00',2.09),('12664','2012-12-30','09:40:00',2.2),('12664','2012-12-30','09:45:00',2.26),('12664','2012-12-30','09:50:00',2.31),('12664','2012-12-30','09:55:00',2.4),('12664','2012-12-30','10:00:00',2.49),('12664','2012-12-30','10:05:00',2.56),('12664','2012-12-30','10:10:00',2.61),('12664','2012-12-30','10:15:00',2.67),('12664','2012-12-30','10:20:00',2.7),('12664','2012-12-30','10:25:00',2.77),('12664','2012-12-30','10:30:00',2.81),('12664','2012-12-30','10:35:00',2.85),('12664','2012-12-30','10:40:00',2.91),('12664','2012-12-30','10:45:00',2.95),('12664','2012-12-30','10:50:00',2.97),('12664','2012-12-30','10:55:00',3),('12664','2012-12-30','11:00:00',3.03),('12664','2012-12-30','11:05:00',3.04),('12664','2012-12-30','11:10:00',3.04),('12664','2012-12-30','11:15:00',3.07),('12664','2012-12-30','11:20:00',3.1),('12664','2012-12-30','11:25:00',3.13),('12664','2012-12-30','11:30:00',3.16),('12664','2012-12-30','11:35:00',3.18),('12664','2012-12-30','11:40:00',3.17),('12664','2012-12-30','11:45:00',3.18),('12664','2012-12-30','11:50:00',3.21),('12664','2012-12-30','11:55:00',3.23),('12664','2012-12-30','12:00:00',3.24),('12664','2012-12-30','12:05:00',3.23),('12664','2012-12-30','12:10:00',3.23),('12664','2012-12-30','12:15:00',3.25),('12664','2012-12-30','12:20:00',3.24),('12664','2012-12-30','12:25:00',3.23),('12664','2012-12-30','12:30:00',3.24),('12664','2012-12-30','12:35:00',3.23),('12664','2012-12-30','12:40:00',3.22),('12664','2012-12-30','12:45:00',3.22),('12664','2012-12-30','12:50:00',3.18),('12664','2012-12-30','12:55:00',3.15),('12664','2012-12-30','13:00:00',3.14),('12664','2012-12-30','13:05:00',3.1),('12664','2012-12-30','13:10:00',3.05),('12664','2012-12-30','13:15:00',3.03),('12664','2012-12-30','13:20:00',2.99),('12664','2012-12-30','13:25:00',2.96),('12664','2012-12-30','13:30:00',2.91),('12664','2012-12-30','13:35:00',2.87),('12664','2012-12-30','13:40:00',2.82),('12664','2012-12-30','13:45:00',2.76),('12664','2012-12-30','13:50:00',2.71),('12664','2012-12-30','13:55:00',2.68),('12664','2012-12-30','14:00:00',2.6),('12664','2012-12-30','14:05:00',2.58),('12664','2012-12-30','14:10:00',2.51),('12664','2012-12-30','14:15:00',2.44),('12664','2012-12-30','14:20:00',2.37),('12664','2012-12-30','14:25:00',2.31),('12664','2012-12-30','14:30:00',2.23),('12664','2012-12-30','14:35:00',2.13),('12664','2012-12-30','14:40:00',2.05),('12664','2012-12-30','14:45:00',1.98),('12664','2012-12-30','14:50:00',1.92),('12664','2012-12-30','14:55:00',1.83),('12664','2012-12-30','15:00:00',1.77),('12664','2012-12-30','15:05:00',1.66),('12664','2012-12-30','15:10:00',1.59),('12664','2012-12-30','15:15:00',1.5),('12664','2012-12-30','15:20:00',1.39),('12664','2012-12-30','15:25:00',1.31),('12664','2012-12-30','15:30:00',1.22),('12664','2012-12-30','15:35:00',1.13),('12664','2012-12-30','15:40:00',1.03),('12664','2012-12-29','08:35:00',1.04),('12664','2012-12-29','08:40:00',1.15),('12664','2012-12-29','08:45:00',1.25),('12664','2012-12-29','08:50:00',1.36),('12664','2012-12-29','08:55:00',1.45),('12664','2012-12-29','09:00:00',1.56),('12664','2012-12-29','09:05:00',1.66),('12664','2012-12-29','09:10:00',1.74),('12664','2012-12-29','09:15:00',1.82),('12664','2012-12-29','09:20:00',1.89),('12664','2012-12-29','09:25:00',1.97),('12664','2012-12-29','09:30:00',2.04),('12664','2012-12-29','09:35:00',2.12),('12664','2012-12-29','09:40:00',2.22),('12664','2012-12-29','09:45:00',2.3),('12664','2012-12-29','09:50:00',2.38),('12664','2012-12-29','09:55:00',2.44),('12664','2012-12-29','10:00:00',2.5),('12664','2012-12-29','10:05:00',2.56),('12664','2012-12-29','10:10:00',2.63),('12664','2012-12-29','10:15:00',2.68),('12664','2012-12-29','10:20:00',2.71),('12664','2012-12-29','10:25:00',2.77),('12664','2012-12-29','10:30:00',2.8),('12664','2012-12-29','10:35:00',2.71),('12664','2012-12-29','10:40:00',2.88),('12664','2012-12-29','10:45:00',2.81),('12664','2012-12-29','10:50:00',3.02),('12664','2012-12-29','10:55:00',3.07),('12664','2012-12-29','11:00:00',3.08),('12664','2012-12-29','11:05:00',3.1),('12664','2012-12-29','11:10:00',3.15),('12664','2012-12-29','11:15:00',3.19),('12664','2012-12-29','11:20:00',3.21),('12664','2012-12-29','11:25:00',3.23),('12664','2012-12-29','11:30:00',3.27),('12664','2012-12-29','11:35:00',3.31),('12664','2012-12-29','11:40:00',3.34),('12664','2012-12-29','11:45:00',3.35),('12664','2012-12-29','11:50:00',3.36),('12664','2012-12-29','11:55:00',3.37),('12664','2012-12-29','12:00:00',3.37),('12664','2012-12-29','12:05:00',3.36),('12664','2012-12-29','12:10:00',3.35),('12664','2012-12-29','12:15:00',3.33),('12664','2012-12-29','12:20:00',3.33),('12664','2012-12-29','12:25:00',3.33),('12664','2012-12-29','12:30:00',3.32),('12664','2012-12-29','12:35:00',3.31),('12664','2012-12-29','12:40:00',3.29),('12664','2012-12-29','12:45:00',3.27),('12664','2012-12-29','12:50:00',3.25),('12664','2012-12-29','12:55:00',3.2),('12664','2012-12-29','13:00:00',3.17),('12664','2012-12-29','13:05:00',3.16),('12664','2012-12-29','13:10:00',3.12),('12664','2012-12-29','13:15:00',3.08),('12664','2012-12-29','13:20:00',3),('12664','2012-12-29','13:25:00',2.97),('12664','2012-12-29','13:30:00',2.94),('12664','2012-12-29','13:35:00',2.9),('12664','2012-12-29','13:40:00',2.85),('12664','2012-12-29','13:45:00',2.81),('12664','2012-12-29','13:50:00',2.74),('12664','2012-12-29','13:55:00',2.68),('12664','2012-12-29','14:00:00',2.64),('12664','2012-12-29','14:05:00',2.59),('12664','2012-12-29','14:10:00',2.53),('12664','2012-12-29','14:15:00',2.46),('12664','2012-12-29','14:20:00',2.42),('12664','2012-12-29','14:25:00',2.35),('12664','2012-12-29','14:30:00',2.29),('12664','2012-12-29','14:35:00',2.23),('12664','2012-12-29','14:40:00',2.15),('12664','2012-12-29','14:45:00',2.06),('12664','2012-12-29','14:50:00',1.95),('12664','2012-12-29','14:55:00',1.9),('12664','2012-12-29','15:00:00',1.82),('12664','2012-12-29','15:05:00',1.74),('12664','2012-12-29','15:10:00',1.65),('12664','2012-12-29','15:15:00',1.56),('12664','2012-12-29','15:20:00',1.46),('12664','2012-12-29','15:25:00',1.37),('12664','2012-12-29','15:30:00',1.24),('12664','2012-12-29','15:35:00',1.15),('12664','2012-12-29','15:40:00',1.06),('12664','2012-12-28','08:40:00',1.03),('12664','2012-12-28','08:45:00',1.11),('12664','2012-12-28','08:50:00',1.19),('12664','2012-12-28','08:55:00',1.29),('12664','2012-12-28','09:00:00',1.37),('12664','2012-12-28','09:05:00',1.5),('12664','2012-12-28','09:10:00',1.6),('12664','2012-12-28','09:15:00',1.67),('12664','2012-12-28','09:20:00',1.73),('12664','2012-12-28','09:25:00',1.8),('12664','2012-12-28','09:30:00',1.84),('12664','2012-12-28','09:35:00',1.91),('12664','2012-12-28','09:40:00',2.04),('12664','2012-12-28','09:45:00',2.17),('12664','2012-12-28','09:50:00',2.24),('12664','2012-12-28','09:55:00',2.3),('12664','2012-12-28','10:00:00',2.38),('12664','2012-12-28','10:05:00',2.42),('12664','2012-12-28','10:10:00',2.48),('12664','2012-12-28','10:15:00',2.55),('12664','2012-12-28','10:20:00',2.59),('12664','2012-12-28','10:25:00',2.65),('12664','2012-12-28','10:30:00',2.65),('12664','2012-12-28','10:35:00',2.72),('12664','2012-12-28','10:40:00',2.79),('12664','2012-12-28','10:45:00',2.44),('12664','2012-12-28','10:50:00',2.89),('12664','2012-12-28','10:55:00',2.93),('12664','2012-12-28','11:00:00',2.97),('12664','2012-12-28','11:05:00',2.7),('12664','2012-12-28','11:10:00',2.81),('12664','2012-12-28','11:15:00',3.05),('12664','2012-12-28','11:20:00',3.15),('12664','2012-12-28','11:25:00',3.14),('12664','2012-12-28','11:30:00',3.05),('12664','2012-12-28','11:35:00',3.1),('12664','2012-12-28','11:40:00',2.6),('12664','2012-12-28','11:45:00',3.16),('12664','2012-12-28','11:50:00',3.1),('12664','2012-12-28','11:55:00',3.17),('12664','2012-12-28','12:00:00',3.12),('12664','2012-12-28','12:05:00',3.15),('12664','2012-12-28','12:10:00',3.21),('12664','2012-12-28','12:15:00',3.17),('12664','2012-12-28','12:20:00',3.2),('12664','2012-12-28','12:25:00',3.23),('12664','2012-12-28','12:30:00',3.24),('12664','2012-12-28','12:35:00',3.19),('12664','2012-12-28','12:40:00',3.15),('12664','2012-12-28','12:45:00',3.09),('12664','2012-12-28','12:50:00',3.07),('12664','2012-12-28','12:55:00',3.02),('12664','2012-12-28','13:00:00',2.96),('12664','2012-12-28','13:05:00',2.92),('12664','2012-12-28','13:10:00',2.93),('12664','2012-12-28','13:15:00',2.94),('12664','2012-12-28','13:20:00',2.92),('12664','2012-12-28','13:25:00',2.86),('12664','2012-12-28','13:30:00',2.78),('12664','2012-12-28','13:35:00',2.76),('12664','2012-12-28','13:40:00',2.72),('12664','2012-12-28','13:45:00',2.64),('12664','2012-12-28','13:50:00',2.54),('12664','2012-12-28','13:55:00',2.49),('12664','2012-12-28','14:00:00',2.45),('12664','2012-12-28','14:05:00',2.41),('12664','2012-12-28','14:10:00',2.33),('12664','2012-12-28','14:15:00',2.31),('12664','2012-12-28','14:20:00',2.26),('12664','2012-12-28','14:25:00',2.17),('12664','2012-12-28','14:30:00',2.09),('12664','2012-12-28','14:35:00',2.03),('12664','2012-12-28','14:40:00',1.96),('12664','2012-12-28','14:45:00',1.88),('12664','2012-12-28','14:50:00',1.81),('12664','2012-12-28','14:55:00',1.73),('12664','2012-12-28','15:00:00',1.64),('12664','2012-12-28','15:05:00',1.57),('12664','2012-12-28','15:10:00',1.49),('12664','2012-12-28','15:15:00',1.39),('12664','2012-12-28','15:20:00',1.3),('12664','2012-12-28','15:25:00',1.21),('12664','2012-12-28','15:30:00',1.11),('12664','2012-12-28','15:35:00',1.02),('12664','2012-12-27','08:50:00',1.09),('12664','2012-12-27','08:55:00',1.21),('12664','2012-12-27','09:00:00',1.34),('12664','2012-12-27','09:05:00',1.44),('12664','2012-12-27','09:10:00',1.53),('12664','2012-12-27','09:15:00',1.41),('12664','2012-12-27','09:25:00',1.77),('12664','2012-12-27','09:30:00',2.08),('12664','2012-12-27','09:35:00',2.46),('12664','2012-12-27','09:40:00',1.56),('12664','2012-12-27','10:10:00',1.29),('12664','2012-12-27','10:15:00',2.18),('12664','2012-12-27','10:20:00',2.38),('12664','2012-12-27','10:25:00',2.34),('12664','2012-12-27','10:30:00',2.51),('12664','2012-12-27','10:35:00',2.55),('12664','2012-12-27','10:40:00',2.59),('12664','2012-12-27','10:45:00',2.63),('12664','2012-12-27','10:50:00',2.69),('12664','2012-12-27','10:55:00',2.69),('12664','2012-12-27','11:00:00',2.76),('12664','2012-12-27','11:05:00',2.74),('12664','2012-12-27','11:10:00',2.78),('12664','2012-12-27','11:15:00',2.78),('12664','2012-12-27','11:20:00',2.83),('12664','2012-12-27','11:25:00',2.93),('12664','2012-12-27','11:30:00',2.89),('12664','2012-12-27','11:35:00',2.97),('12664','2012-12-27','11:40:00',2.97),('12664','2012-12-27','11:45:00',3.01),('12664','2012-12-27','11:50:00',2.96),('12664','2012-12-27','11:55:00',2.11),('12664','2012-12-27','12:00:00',1.36),('12664','2012-12-27','12:05:00',1.46),('12664','2012-12-27','12:10:00',1.75),('12664','2012-12-27','12:20:00',3.41),('12664','2012-12-27','12:25:00',2.82),('12664','2012-12-27','12:30:00',1.98),('12664','2012-12-27','12:35:00',1.88),('12664','2012-12-27','12:40:00',3.16),('12664','2012-12-27','12:45:00',3.07),('12664','2012-12-27','12:50:00',3.08),('12664','2012-12-27','12:55:00',2.7),('12664','2012-12-27','13:00:00',2.21),('12664','2012-12-27','13:05:00',2.22),('12664','2012-12-27','13:10:00',1.74),('12664','2012-12-27','13:15:00',1.67),('12664','2012-12-27','13:20:00',2.2),('12664','2012-12-27','13:25:00',2.45),('12664','2012-12-27','13:30:00',1.29),('12664','2012-12-27','13:50:00',1.72),('12664','2012-12-27','13:55:00',2.62),('12664','2012-12-27','14:00:00',2.54),('12664','2012-12-27','14:05:00',2.5),('12664','2012-12-27','14:10:00',2.42),('12664','2012-12-27','14:15:00',2.37),('12664','2012-12-27','14:20:00',2.13),('12664','2012-12-27','14:25:00',2.24),('12664','2012-12-27','14:30:00',2.27),('12664','2012-12-27','14:35:00',2.47),('12664','2012-12-27','14:40:00',2.33),('12664','2012-12-27','14:45:00',2.13),('12664','2012-12-27','14:50:00',1.87),('12664','2012-12-27','14:55:00',1.81),('12664','2012-12-27','15:00:00',1.7),('12664','2012-12-27','15:15:00',1.39),('12664','2012-12-27','15:20:00',1.34),('12664','2012-12-27','15:25:00',1.24),('12664','2012-12-27','15:30:00',1.13),('12664','2012-12-27','15:35:00',1.03),('12664','2012-12-26','09:05:00',1.43),('12664','2012-12-26','09:10:00',1.37),('12664','2012-12-26','09:15:00',1.66),('12664','2012-12-26','09:20:00',1.78),('12664','2012-12-26','09:25:00',1.86),('12664','2012-12-26','09:30:00',1.93),('12664','2012-12-26','09:35:00',2.01),('12664','2012-12-26','09:40:00',2.08),('12664','2012-12-26','09:45:00',2.14),('12664','2012-12-26','09:50:00',2.18),('12664','2012-12-26','09:55:00',2.25),('12664','2012-12-26','10:00:00',2.37),('12664','2012-12-26','10:05:00',2.66),('12664','2012-12-26','10:10:00',2.57),('12664','2012-12-26','10:15:00',2.51),('12664','2012-12-26','10:20:00',2.49),('12664','2012-12-26','10:25:00',2.56),('12664','2012-12-26','10:30:00',2.6),('12664','2012-12-26','10:35:00',2.62),('12664','2012-12-26','10:40:00',2.66),('12664','2012-12-26','10:45:00',2.69),('12664','2012-12-26','10:50:00',2.74),('12664','2012-12-26','10:55:00',2.74),('12664','2012-12-26','11:00:00',2.77),('12664','2012-12-26','11:05:00',2.78),('12664','2012-12-26','11:10:00',2.77),('12664','2012-12-26','11:15:00',2.8),('12664','2012-12-26','11:20:00',2.59),('12664','2012-12-26','11:25:00',2.58),('12664','2012-12-26','11:30:00',2.9),('12664','2012-12-26','11:35:00',2.96),('12664','2012-12-26','11:40:00',3.02),('12664','2012-12-26','11:45:00',3.3),('12664','2012-12-26','11:50:00',3.47),('12664','2012-12-26','11:55:00',3.55),('12664','2012-12-26','12:00:00',3.76),('12664','2012-12-26','12:05:00',3.88),('12664','2012-12-26','12:10:00',3.87),('12664','2012-12-26','12:15:00',3.92),('12664','2012-12-26','12:20:00',3.2),('12664','2012-12-26','12:25:00',2.62),('12664','2012-12-26','12:30:00',3.7),('12664','2012-12-26','12:35:00',2.53),('12664','2012-12-26','12:40:00',3.37),('12664','2012-12-26','12:45:00',3.24),('12664','2012-12-26','12:50:00',3.29),('12664','2012-12-26','12:55:00',3.21),('12664','2012-12-26','13:00:00',3.13),('12664','2012-12-26','13:05:00',2.32),('12664','2012-12-26','13:10:00',2.36),('12664','2012-12-26','13:15:00',3.18),('12664','2012-12-26','13:20:00',2.36),('12664','2012-12-26','13:25:00',2.19),('12664','2012-12-26','13:30:00',1.55),('12664','2012-12-26','13:35:00',1.58),('12664','2012-12-26','13:40:00',1.77),('12664','2012-12-26','13:45:00',1.07),('12664','2012-12-26','13:50:00',1.93),('12664','2012-12-26','13:55:00',1.47),('12664','2012-12-26','14:00:00',1.86),('12664','2012-12-26','14:05:00',1.46),('12664','2012-12-25','12:00:00',1.04),('12664','2012-12-23','08:35:00',1.05),('12664','2012-12-23','08:40:00',1.15),('12664','2012-12-23','08:45:00',1.24),('12664','2012-12-23','08:50:00',1.35),('12664','2012-12-23','08:55:00',1.47),('12664','2012-12-23','09:00:00',1.54),('12664','2012-12-23','09:05:00',1.6),('12664','2012-12-23','09:10:00',1.71),('12664','2012-12-23','09:15:00',1.75),('12664','2012-12-23','09:20:00',1.78),('12664','2012-12-23','09:25:00',1.87),('12664','2012-12-23','09:30:00',2),('12664','2012-12-23','09:35:00',2.12),('12664','2012-12-23','09:40:00',2.16),('12664','2012-12-23','09:45:00',2.25),('12664','2012-12-23','09:50:00',2.31),('12664','2012-12-23','09:55:00',2.32),('12664','2012-12-23','10:00:00',2.36),('12664','2012-12-23','10:05:00',2.4),('12664','2012-12-23','10:10:00',2.47),('12664','2012-12-23','10:15:00',2.46),('12664','2012-12-23','10:20:00',2.47),('12664','2012-12-23','10:25:00',2.61),('12664','2012-12-23','10:30:00',2.65),('12664','2012-12-23','10:35:00',2.69),('12664','2012-12-23','10:40:00',2.73),('12664','2012-12-23','10:45:00',2.79),('12664','2012-12-23','10:50:00',2.79),('12664','2012-12-23','10:55:00',2.78),('12664','2012-12-23','11:00:00',2.87),('12664','2012-12-23','11:05:00',2.95),('12664','2012-12-23','11:10:00',2.96),('12664','2012-12-23','11:15:00',3),('12664','2012-12-23','11:20:00',3.05),('12664','2012-12-23','11:25:00',3.06),('12664','2012-12-23','11:30:00',2.76),('12664','2012-12-23','11:35:00',3.04),('12664','2012-12-23','11:40:00',3.03),('12664','2012-12-23','11:45:00',3.02),('12664','2012-12-23','11:50:00',3.07),('12664','2012-12-23','11:55:00',2.73),('12664','2012-12-23','12:00:00',2.81),('12664','2012-12-23','12:05:00',2.95),('12664','2012-12-23','12:10:00',2.55),('12664','2012-12-23','12:15:00',2.3),('12664','2012-12-23','12:20:00',2.7),('12664','2012-12-23','12:25:00',2.69),('12664','2012-12-23','12:30:00',2.68),('12664','2012-12-23','12:35:00',2.73),('12664','2012-12-23','12:40:00',2.52),('12664','2012-12-23','12:45:00',2.02),('12664','2012-12-23','12:50:00',1.98),('12664','2012-12-23','12:55:00',2.92),('12664','2012-12-23','13:00:00',2.4),('12664','2012-12-23','13:05:00',2.33),('12664','2012-12-23','13:10:00',2.46),('12664','2012-12-23','13:15:00',2.13),('12664','2012-12-23','13:25:00',1.54),('12664','2012-12-23','13:30:00',1.76),('12664','2012-12-23','13:35:00',2.17),('12664','2012-12-23','13:40:00',1.58),('12664','2012-12-23','13:45:00',1.39),('12664','2012-12-23','13:50:00',1.39),('12664','2012-12-23','13:55:00',2.08),('12664','2012-12-23','14:00:00',2.63),('12664','2012-12-23','14:05:00',2.41),('12664','2012-12-23','14:10:00',2),('12664','2012-12-23','14:15:00',1.38),('12664','2012-12-23','14:25:00',1.23),('12664','2012-12-23','14:30:00',1.31),('12664','2012-12-23','14:35:00',1.26),('12664','2012-12-23','14:40:00',1.45),('12664','2012-12-23','14:45:00',1.12),('12664','2012-12-23','15:00:00',1.08),('12664','2012-12-23','15:10:00',1.2),('12664','2012-12-23','15:15:00',1.34),('12664','2012-12-23','15:20:00',1.28),('12664','2012-12-23','15:25:00',1.22),('12664','2012-12-23','15:30:00',1.15),('12664','2012-12-23','15:35:00',1.08),('12664','2012-12-22','10:35:00',1.44),('12664','2012-12-22','10:40:00',2.2),('12664','2012-12-22','10:45:00',2.04),('12664','2012-12-22','10:50:00',3.71),('12664','2012-12-22','10:55:00',3.74),('12664','2012-12-22','11:00:00',3.13),('12664','2012-12-22','11:05:00',3.94),('12664','2012-12-22','11:10:00',3.96),('12664','2012-12-22','11:15:00',4.01),('12664','2012-12-22','11:20:00',3.79),('12664','2012-12-22','11:25:00',3.69),('12664','2012-12-22','11:30:00',3.57),('12664','2012-12-22','11:35:00',3.64),('12664','2012-12-22','11:40:00',2.83),('12664','2012-12-22','11:45:00',3.44),('12664','2012-12-22','11:50:00',3.33),('12664','2012-12-22','11:55:00',3.45),('12664','2012-12-22','12:00:00',3.51),('12664','2012-12-22','12:05:00',3.81),('12664','2012-12-22','12:10:00',2.63),('12664','2012-12-22','12:15:00',1.13),('12664','2012-12-22','12:20:00',1.95),('12664','2012-12-22','12:25:00',3.38),('12664','2012-12-22','12:30:00',3.56),('12664','2012-12-22','12:35:00',2.28),('12664','2012-12-22','12:40:00',1.9),('12664','2012-12-22','12:45:00',1.06),('12664','2012-12-22','12:50:00',1.22),('12664','2012-12-22','12:55:00',1.21),('12664','2012-12-22','13:00:00',2.52),('12664','2012-12-22','13:05:00',3.57),('12664','2012-12-22','13:10:00',3.55),('12664','2012-12-22','13:15:00',3.47),('12664','2012-12-22','13:20:00',3.27),('12664','2012-12-22','13:25:00',3.6),('12664','2012-12-22','13:30:00',3.56),('12664','2012-12-22','13:35:00',2.81),('12664','2012-12-22','13:40:00',1.94),('12664','2012-12-22','13:50:00',1.29),('12664','2012-12-22','13:55:00',1.16),('12664','2012-12-22','14:05:00',2.27),('12664','2012-12-22','14:10:00',2.48),('12664','2012-12-22','15:00:00',1.61),('12664','2012-12-22','15:05:00',1.49),('12664','2012-12-22','15:10:00',1.47),('12664','2012-12-22','15:15:00',1.47),('12664','2012-12-22','15:25:00',1.06),('12664','2012-12-22','15:30:00',1.14),('12664','2012-12-22','15:35:00',1.17),('12664','2014-04-30','07:55:00',1.06),('12664','2014-04-30','08:00:00',1.11),('12664','2014-04-30','08:05:00',1.24),('12664','2014-04-30','08:10:00',1.32),('12664','2014-04-30','08:15:00',1.4),('12664','2014-04-30','08:20:00',1.49),('12664','2014-04-30','08:25:00',1.6),('12664','2014-04-30','08:30:00',1.7),('12664','2014-04-30','08:35:00',1.79),('12664','2014-04-30','08:40:00',1.87),('12664','2014-04-30','08:45:00',1.95),('12664','2014-04-30','08:50:00',2.02),('12664','2014-04-30','08:55:00',2.15),('12664','2014-04-30','09:00:00',2.2),('12664','2014-04-30','09:05:00',2.29),('12664','2014-04-30','09:10:00',2.37),('12664','2014-04-30','09:15:00',2.45),('12664','2014-04-30','09:20:00',2.54),('12664','2014-04-30','09:25:00',2.61),('12664','2014-04-30','09:30:00',2.7),('12664','2014-04-30','09:35:00',2.84),('12664','2014-04-30','09:40:00',2.85),('12664','2014-04-30','09:45:00',2.68),('12664','2014-04-30','09:50:00',3.16),('12664','2014-04-30','09:55:00',3.05),('12664','2014-04-30','10:00:00',3.37),('12664','2014-04-30','10:05:00',2.03),('12664','2014-04-30','10:10:00',3.19),('12664','2014-04-30','10:15:00',1.58),('12664','2014-04-30','10:20:00',3.19),('12664','2014-04-30','10:25:00',2.16),('12664','2014-04-30','10:30:00',1.01),('12664','2014-04-30','10:35:00',1.73),('12664','2014-04-30','10:40:00',2.94),('12664','2014-04-30','10:45:00',1.62),('12664','2014-04-30','10:50:00',2.48),('12664','2014-04-30','10:55:00',1.54),('12664','2014-04-30','11:00:00',1.66),('12664','2014-04-30','11:05:00',2.34),('12664','2014-04-30','11:10:00',2.84),('12664','2014-04-30','11:15:00',4.34),('12664','2014-04-30','11:20:00',4.42),('12664','2014-04-30','11:25:00',4.39),('12664','2014-04-30','11:30:00',3.21),('12664','2014-04-30','11:35:00',4.46),('12664','2014-04-30','11:40:00',3.75),('12664','2014-04-30','11:45:00',2.77),('12664','2014-04-30','11:50:00',2),('12664','2014-04-30','11:55:00',3.05),('12664','2014-04-30','12:00:00',2.68),('12664','2014-04-30','12:05:00',2.11),('12664','2014-04-30','12:10:00',2.26),('12664','2014-04-30','12:15:00',4.04),('12664','2014-04-30','12:20:00',2.7),('12664','2014-04-30','12:25:00',1.85),('12664','2014-04-30','12:30:00',2.84),('12664','2014-04-30','12:35:00',4.06),('12664','2014-04-30','12:40:00',4.12),('12664','2014-04-30','12:45:00',3.21),('12664','2014-04-30','12:50:00',2.43),('12664','2014-04-30','12:55:00',3.34),('12664','2014-04-30','13:05:00',2.96),('12664','2014-04-30','13:10:00',2.31),('12664','2014-04-30','13:15:00',1.77),('12664','2014-04-30','13:20:00',2.29),('12664','2014-04-30','13:25:00',2.29),('12664','2014-04-30','13:30:00',1.43),('12664','2014-04-30','13:35:00',3.61),('12664','2014-04-30','13:40:00',2.51),('12664','2014-04-30','13:45:00',1.51),('12664','2014-04-30','13:50:00',1.59),('12664','2014-04-30','13:55:00',2.38),('12664','2014-04-30','14:00:00',1.92),('12664','2014-04-30','14:05:00',1.09),('12664','2014-04-30','14:10:00',1.21),('12664','2014-04-30','14:15:00',1.41),('12664','2014-04-30','14:20:00',1.68),('12664','2014-04-30','14:25:00',1.26),('12664','2014-04-30','14:30:00',1.07),('12664','2014-04-30','14:35:00',1.16),('12664','2014-04-30','14:40:00',1.44),('12664','2014-04-30','14:45:00',1.9),('12664','2014-04-30','14:50:00',1.8),('12664','2014-04-30','14:55:00',1.39),('12664','2014-04-30','15:00:00',1.35),('12664','2014-04-30','15:05:00',2.3),('12664','2014-04-30','15:10:00',1.74),('12664','2014-04-30','15:15:00',1.43),('12664','2014-04-30','15:20:00',2.44),('12664','2014-04-30','15:25:00',2.05),('12664','2014-04-30','15:30:00',2.11),('12664','2014-04-30','15:35:00',3.04),('12664','2014-04-30','15:40:00',3.59),('12664','2014-04-30','15:45:00',3.47),('12664','2014-04-30','15:50:00',2.79),('12664','2014-04-30','15:55:00',1.81),('12664','2014-04-30','16:00:00',2.05),('12664','2014-04-30','16:05:00',1.12),('12664','2014-04-30','16:10:00',2.46),('12664','2014-04-30','16:15:00',2.27),('12664','2014-04-30','16:20:00',2.96),('12664','2014-04-30','16:25:00',2.3),('12664','2014-04-30','16:30:00',1.97),('12664','2014-04-30','16:35:00',3.21),('12664','2014-04-30','16:40:00',2.43),('12664','2014-04-30','16:45:00',1.57),('12664','2014-04-30','16:50:00',1.97),('12664','2014-04-30','16:55:00',1.78),('12664','2014-04-30','17:00:00',1.8),('12664','2014-04-30','17:05:00',1.24),('12664','2014-04-30','17:10:00',1.48),('12664','2014-04-30','17:25:00',1.42),('12664','2014-04-30','17:35:00',1.75),('12664','2014-03-16','08:00:00',1.07),('12664','2014-03-16','08:05:00',1.21),('12664','2014-03-16','08:10:00',1.28),('12664','2014-03-16','08:15:00',1.27),('12664','2014-03-16','08:20:00',1.34),('12664','2014-03-16','08:25:00',1.48),('12664','2014-03-16','08:30:00',1.59),('12664','2014-03-16','08:35:00',1.71),('12664','2014-03-16','08:40:00',1.76),('12664','2014-03-16','08:45:00',1.85),('12664','2014-03-16','08:50:00',1.92),('12664','2014-03-16','08:55:00',1.98),('12664','2014-03-16','09:00:00',1.89),('12664','2014-03-16','09:05:00',2.05),('12664','2014-03-16','09:10:00',2.18),('12664','2014-03-16','09:15:00',2.31),('12664','2014-03-16','09:20:00',2.3),('12664','2014-03-16','09:25:00',2.38),('12664','2014-03-16','09:30:00',2.38),('12664','2014-03-16','09:35:00',2.4),('12664','2014-03-16','09:40:00',2.48),('12664','2014-03-16','09:45:00',2.62),('12664','2014-03-16','09:50:00',2.78),('12664','2014-03-16','09:55:00',2.76),('12664','2014-03-16','10:00:00',2.82),('12664','2014-03-16','10:05:00',2.88),('12664','2014-03-16','10:10:00',2.92),('12664','2014-03-16','10:15:00',2.98),('12664','2014-03-16','10:20:00',2.99),('12664','2014-03-16','10:25:00',2.99),('12664','2014-03-16','10:30:00',3.1),('12664','2014-03-16','10:35:00',3.13),('12664','2014-03-16','10:40:00',3.16),('12664','2014-03-16','10:45:00',3.23),('12664','2014-03-16','10:50:00',3.23),('12664','2014-03-16','10:55:00',3.28),('12664','2014-03-16','11:00:00',3.29),('12664','2014-03-16','11:05:00',3.39),('12664','2014-03-16','11:10:00',3.44),('12664','2014-03-16','11:15:00',3.48),('12664','2014-03-16','11:20:00',3.4),('12664','2014-03-16','11:25:00',3.35),('12664','2014-03-16','11:30:00',3.39),('12664','2014-03-16','11:35:00',3.47),('12664','2014-03-16','11:40:00',3.5),('12664','2014-03-16','11:45:00',3.48),('12664','2014-03-16','11:50:00',3.49),('12664','2014-03-16','11:55:00',3.54),('12664','2014-03-16','12:00:00',3.61),('12664','2014-03-16','12:05:00',3.58),('12664','2014-03-16','12:10:00',3.53),('12664','2014-03-16','12:15:00',3.47),('12664','2014-03-16','12:20:00',3.46),('12664','2014-03-16','12:25:00',3.46),('12664','2014-03-16','12:30:00',3.47),('12664','2014-03-16','12:35:00',3.5),('12664','2014-03-16','12:40:00',3.52),('12664','2014-03-16','12:45:00',3.49),('12664','2014-03-16','12:50:00',3.54),('12664','2014-03-16','12:55:00',3.5),('12664','2014-03-16','13:00:00',3.41),('12664','2014-03-16','13:05:00',3.4),('12664','2014-03-16','13:10:00',3.52),('12664','2014-03-16','13:15:00',3.43),('12664','2014-03-16','13:20:00',3.32),('12664','2014-03-16','13:25:00',3.38),('12664','2014-03-16','13:30:00',3.36),('12664','2014-03-16','13:35:00',3.31),('12664','2014-03-16','13:40:00',3.19),('12664','2014-03-16','13:45:00',3.31),('12664','2014-03-16','13:50:00',3.21),('12664','2014-03-16','13:55:00',3.2),('12664','2014-03-16','14:00:00',3.16),('12664','2014-03-16','14:05:00',3.12),('12664','2014-03-16','14:10:00',3.08),('12664','2014-03-16','14:15:00',3.05),('12664','2014-03-16','14:20:00',2.99),('12664','2014-03-16','14:25:00',2.98),('12664','2014-03-16','14:30:00',2.89),('12664','2014-03-16','14:35:00',2.79),('12664','2014-03-16','14:40:00',2.65),('12664','2014-03-16','14:45:00',2.42),('12664','2014-03-16','14:50:00',2.47),('12664','2014-03-16','14:55:00',2.66),('12664','2014-03-16','15:00:00',2.21),('12664','2014-03-16','15:05:00',2.08),('12664','2014-03-16','15:10:00',1.92),('12664','2014-03-16','15:15:00',1.6),('12664','2014-03-16','15:20:00',1.71),('12664','2014-03-16','15:25:00',1.74),('12664','2014-03-16','15:30:00',1.55),('12664','2014-03-16','15:35:00',1.19),('12664','2014-03-16','15:40:00',1.35),('12664','2014-03-16','15:45:00',1.63),('12664','2014-03-16','15:50:00',1.38),('12664','2014-03-16','15:55:00',1.19),('12664','2014-03-16','16:00:00',1.32),('12664','2014-03-16','16:05:00',1.52),('12664','2014-03-16','16:10:00',1.49),('12664','2014-03-16','16:15:00',1.38),('12664','2014-03-16','16:20:00',1.29),('12664','2014-03-16','16:25:00',1.21),('12664','2014-03-16','16:30:00',1.07),('12664','2014-03-16','16:35:00',1.1),('12664','2014-03-15','08:05:00',1.07),('12664','2014-03-15','08:10:00',1.15),('12664','2014-03-15','08:15:00',1.24),('12664','2014-03-15','08:20:00',1.33),('12664','2014-03-15','08:25:00',1.41),('12664','2014-03-15','08:30:00',1.5),('12664','2014-03-15','08:35:00',1.57),('12664','2014-03-15','08:40:00',1.63),('12664','2014-03-15','08:45:00',1.7),('12664','2014-03-15','08:50:00',1.79),('12664','2014-03-15','08:55:00',1.86),('12664','2014-03-15','09:00:00',1.94),('12664','2014-03-15','09:05:00',2.02),('12664','2014-03-15','09:10:00',2.09),('12664','2014-03-15','09:15:00',2.14),('12664','2014-03-15','09:20:00',2.17),('12664','2014-03-15','09:25:00',2.23),('12664','2014-03-15','09:30:00',2.33),('12664','2014-03-15','09:35:00',2.4),('12664','2014-03-15','09:40:00',2.48),('12664','2014-03-15','09:45:00',2.54),('12664','2014-03-15','09:50:00',2.61),('12664','2014-03-15','09:55:00',2.66),('12664','2014-03-15','10:00:00',2.71),('12664','2014-03-15','10:05:00',2.77),('12664','2014-03-15','10:10:00',2.8),('12664','2014-03-15','10:15:00',2.84),('12664','2014-03-15','10:20:00',2.9),('12664','2014-03-15','10:25:00',2.95),('12664','2014-03-15','10:30:00',2.96),('12664','2014-03-15','10:35:00',2.97),('12664','2014-03-15','10:40:00',3.07),('12664','2014-03-15','10:45:00',3.06),('12664','2014-03-15','10:50:00',3.06),('12664','2014-03-15','10:55:00',3.14),('12664','2014-03-15','11:00:00',3.26),('12664','2014-03-15','11:05:00',3.31),('12664','2014-03-15','11:10:00',3.29),('12664','2014-03-15','11:15:00',3.3),('12664','2014-03-15','11:20:00',3.27),('12664','2014-03-15','11:25:00',3.33),('12664','2014-03-15','11:30:00',3.42),('12664','2014-03-15','11:35:00',3.41),('12664','2014-03-15','11:40:00',3.4),('12664','2014-03-15','11:45:00',3.43),('12664','2014-03-15','11:50:00',3.47),('12664','2014-03-15','11:55:00',3.44),('12664','2014-03-15','12:00:00',3.49),('12664','2014-03-15','12:05:00',3.42),('12664','2014-03-15','12:10:00',3.46),('12664','2014-03-15','12:15:00',3.51),('12664','2014-03-15','12:20:00',3.45),('12664','2014-03-15','12:25:00',3.51),('12664','2014-03-15','12:30:00',3.51),('12664','2014-03-15','12:35:00',3.56),('12664','2014-03-15','12:40:00',3.57),('12664','2014-03-15','12:45:00',3.52),('12664','2014-03-15','12:50:00',3.54),('12664','2014-03-15','12:55:00',3.49),('12664','2014-03-15','13:00:00',3.49),('12664','2014-03-15','13:05:00',3.49),('12664','2014-03-15','13:10:00',3.48),('12664','2014-03-15','13:15:00',3.49),('12664','2014-03-15','13:20:00',3.47),('12664','2014-03-15','13:25:00',3.45),('12664','2014-03-15','13:30:00',3.43),('12664','2014-03-15','13:35:00',3.42),('12664','2014-03-15','13:40:00',3.39),('12664','2014-03-15','13:45:00',3.36),('12664','2014-03-15','13:50:00',3.28),('12664','2014-03-15','13:55:00',3.23),('12664','2014-03-15','14:00:00',3.17),('12664','2014-03-15','14:05:00',3.16),('12664','2014-03-15','14:10:00',3.11),('12664','2014-03-15','14:15:00',3.07),('12664','2014-03-15','14:20:00',3),('12664','2014-03-15','14:25:00',2.93),('12664','2014-03-15','14:30:00',2.88),('12664','2014-03-15','14:35:00',2.81),('12664','2014-03-15','14:40:00',2.8),('12664','2014-03-15','14:45:00',2.76),('12664','2014-03-15','14:50:00',2.7),('12664','2014-03-15','14:55:00',2.59),('12664','2014-03-15','15:00:00',2.54),('12664','2014-03-15','15:05:00',2.48),('12664','2014-03-15','15:10:00',2.37),('12664','2014-03-15','15:15:00',2.35),('12664','2014-03-15','15:20:00',2.26),('12664','2014-03-15','15:25:00',2.18),('12664','2014-03-15','15:30:00',2.1),('12664','2014-03-15','15:35:00',2.02),('12664','2014-03-15','15:40:00',1.91),('12664','2014-03-15','15:45:00',1.77),('12664','2014-03-15','15:50:00',1.7),('12664','2014-03-15','15:55:00',1.6),('12664','2014-03-15','16:00:00',1.5),('12664','2014-03-15','16:05:00',1.41),('12664','2014-03-15','16:10:00',1.33),('12664','2014-03-15','16:15:00',1.28),('12664','2014-03-15','16:20:00',1.2),('12664','2014-03-15','16:25:00',1.11),('12664','2014-03-15','16:30:00',1.04),('12664','2014-03-14','08:35:00',1.06),('12664','2014-03-14','09:10:00',1.14),('12664','2014-03-14','09:15:00',1.41),('12664','2014-03-14','09:20:00',1.81),('12664','2014-03-14','09:25:00',1.92),('12664','2014-03-14','09:30:00',1.73),('12664','2014-03-14','09:35:00',1.78),('12664','2014-03-14','09:40:00',1.83),('12664','2014-03-14','09:45:00',1.93),('12664','2014-03-14','09:50:00',2.22),('12664','2014-03-14','09:55:00',2.57),('12664','2014-03-14','10:00:00',2.87),('12664','2014-03-14','10:05:00',3.02),('12664','2014-03-14','10:10:00',3.21),('12664','2014-03-14','10:15:00',3.3),('12664','2014-03-14','10:20:00',3.37),('12664','2014-03-14','10:25:00',3.39),('12664','2014-03-14','10:30:00',3.33),('12664','2014-03-14','10:35:00',3.22),('12664','2014-03-14','10:40:00',3.29),('12664','2014-03-14','10:45:00',3.34),('12664','2014-03-14','10:50:00',3.34),('12664','2014-03-14','10:55:00',3),('12664','2014-03-14','11:00:00',2.48),('12664','2014-03-14','11:05:00',3.32),('12664','2014-03-14','11:10:00',3.28),('12664','2014-03-14','11:15:00',3.4),('12664','2014-03-14','11:20:00',3.58),('12664','2014-03-14','11:25:00',3.58),('12664','2014-03-14','11:30:00',3.44),('12664','2014-03-14','11:35:00',3.31),('12664','2014-03-14','11:40:00',3.43),('12664','2014-03-14','11:45:00',3.33),('12664','2014-03-14','11:50:00',3.33),('12664','2014-03-14','11:55:00',3.56),('12664','2014-03-14','12:00:00',3.6),('12664','2014-03-14','12:05:00',3.51),('12664','2014-03-14','12:10:00',3.55),('12664','2014-03-14','12:15:00',3.5),('12664','2014-03-14','12:20:00',3.42),('12664','2014-03-14','12:25:00',3.36),('12664','2014-03-14','12:30:00',3.21),('12664','2014-03-14','12:35:00',3.13),('12664','2014-03-14','12:40:00',2.32),('12664','2014-03-14','12:45:00',2.04),('12664','2014-03-14','12:50:00',1.89),('12664','2014-03-14','12:55:00',1.95),('12664','2014-03-14','13:00:00',2.16),('12664','2014-03-14','13:05:00',1.98),('12664','2014-03-14','13:10:00',1.54),('12664','2014-03-14','13:15:00',1.82),('12664','2014-03-14','13:20:00',2.32),('12664','2014-03-14','13:25:00',2.47),('12664','2014-03-14','13:30:00',2.18),('12664','2014-03-14','13:35:00',2.53),('12664','2014-03-14','13:40:00',2.42),('12664','2014-03-14','13:45:00',1.91),('12664','2014-03-14','13:50:00',2.09),('12664','2014-03-14','13:55:00',2.14),('12664','2014-03-14','14:00:00',2.34),('12664','2014-03-14','14:05:00',2.23),('12664','2014-03-14','14:10:00',2.17),('12664','2014-03-14','14:15:00',2.04),('12664','2014-03-14','14:20:00',1.85),('12664','2014-03-14','14:25:00',2.38),('12664','2014-03-14','14:30:00',2.81),('12664','2014-03-14','14:35:00',2.51),('12664','2014-03-14','14:40:00',2.4),('12664','2014-03-14','14:45:00',2.11),('12664','2014-03-14','14:50:00',1.66),('12664','2014-03-14','14:55:00',1.48),('12664','2014-03-14','15:00:00',1.4),('12664','2014-03-14','15:05:00',1.27),('12664','2014-03-14','15:10:00',1.2),('12664','2014-03-14','15:15:00',1.12),('12664','2014-03-14','15:20:00',1.09),('12664','2014-03-14','15:25:00',1.08),('12664','2014-03-14','15:30:00',1.17),('12664','2014-03-14','15:35:00',1.19),('12664','2014-03-14','15:40:00',1.36),('12664','2014-03-14','15:45:00',1.53),('12664','2014-03-14','15:50:00',1.39),('12664','2014-03-14','15:55:00',1.09),('12664','2014-03-13','07:50:00',1.08),('12664','2014-03-13','07:55:00',1.17),('12664','2014-03-13','08:00:00',1.27),('12664','2014-03-13','08:05:00',1.37),('12664','2014-03-13','08:10:00',1.46),('12664','2014-03-13','08:15:00',1.56),('12664','2014-03-13','08:20:00',1.66),('12664','2014-03-13','08:25:00',1.75),('12664','2014-03-13','08:30:00',1.84),('12664','2014-03-13','08:35:00',1.92),('12664','2014-03-13','08:40:00',2),('12664','2014-03-13','08:45:00',2.09),('12664','2014-03-13','08:50:00',2.18),('12664','2014-03-13','08:55:00',2.27),('12664','2014-03-13','09:00:00',2.35),('12664','2014-03-13','09:05:00',2.42),('12664','2014-03-13','09:10:00',2.49),('12664','2014-03-13','09:15:00',2.57),('12664','2014-03-13','09:20:00',2.63),('12664','2014-03-13','09:25:00',2.7),('12664','2014-03-13','09:30:00',2.77),('12664','2014-03-13','09:35:00',2.84),('12664','2014-03-13','09:40:00',2.9),('12664','2014-03-13','09:45:00',2.94),('12664','2014-03-13','09:50:00',3.01),('12664','2014-03-13','09:55:00',3.05),('12664','2014-03-13','10:00:00',3.11),('12664','2014-03-13','10:05:00',3.15),('12664','2014-03-13','10:10:00',3.2),('12664','2014-03-13','10:15:00',3.24),('12664','2014-03-13','10:20:00',3.29),('12664','2014-03-13','10:25:00',3.31),('12664','2014-03-13','10:30:00',3.35),('12664','2014-03-13','10:35:00',3.38),('12664','2014-03-13','10:40:00',3.4),('12664','2014-03-13','10:45:00',3.45),('12664','2014-03-13','10:50:00',3.47),('12664','2014-03-13','10:55:00',3.52),('12664','2014-03-13','11:00:00',3.51),('12664','2014-03-13','11:05:00',3.52),('12664','2014-03-13','11:10:00',3.55),('12664','2014-03-13','11:15:00',3.56),('12664','2014-03-13','11:20:00',3.59),('12664','2014-03-13','11:25:00',3.6),('12664','2014-03-13','11:30:00',3.6),('12664','2014-03-13','11:35:00',3.61),('12664','2014-03-13','11:40:00',3.63),('12664','2014-03-13','11:45:00',3.64),('12664','2014-03-13','11:50:00',3.64),('12664','2014-03-13','11:55:00',3.65),('12664','2014-03-13','12:00:00',3.65),('12664','2014-03-13','12:05:00',3.68),('12664','2014-03-13','12:10:00',3.71),('12664','2014-03-13','12:15:00',3.7),('12664','2014-03-13','12:20:00',3.68),('12664','2014-03-13','12:25:00',3.65),('12664','2014-03-13','12:30:00',3.65),('12664','2014-03-13','12:35:00',3.64),('12664','2014-03-13','12:40:00',3.64),('12664','2014-03-13','12:45:00',3.66),('12664','2014-03-13','12:50:00',3.68),('12664','2014-03-13','12:55:00',3.66),('12664','2014-03-13','13:00:00',3.66),('12664','2014-03-13','13:05:00',3.65),('12664','2014-03-13','13:10:00',3.63),('12664','2014-03-13','13:15:00',3.61),('12664','2014-03-13','13:20:00',3.6),('12664','2014-03-13','13:25:00',3.58),('12664','2014-03-13','13:30:00',3.56),('12664','2014-03-13','13:35:00',3.52),('12664','2014-03-13','13:40:00',3.47),('12664','2014-03-13','13:45:00',3.43),('12664','2014-03-13','13:50:00',3.39),('12664','2014-03-13','13:55:00',3.36),('12664','2014-03-13','14:00:00',3.31),('12664','2014-03-13','14:05:00',3.25),('12664','2014-03-13','14:10:00',3.2),('12664','2014-03-13','14:15:00',3.16),('12664','2014-03-13','14:20:00',3.12),('12664','2014-03-13','14:25:00',3.08),('12664','2014-03-13','14:30:00',3.02),('12664','2014-03-13','14:35:00',2.94),('12664','2014-03-13','14:40:00',2.88),('12664','2014-03-13','14:45:00',2.81),('12664','2014-03-13','14:50:00',2.75),('12664','2014-03-13','14:55:00',2.67),('12664','2014-03-13','15:00:00',2.59),('12664','2014-03-13','15:05:00',2.49),('12664','2014-03-13','15:10:00',2.43),('12664','2014-03-13','15:15:00',2.34),('12664','2014-03-13','15:20:00',2.26),('12664','2014-03-13','15:25:00',2.18),('12664','2014-03-13','15:30:00',2.11),('12664','2014-03-13','15:35:00',2.03),('12664','2014-03-13','15:40:00',1.95),('12664','2014-03-13','15:45:00',1.87),('12664','2014-03-13','15:50:00',1.8),('12664','2014-03-13','15:55:00',1.71),('12664','2014-03-13','16:00:00',1.62),('12664','2014-03-13','16:05:00',1.53),('12664','2014-03-13','16:10:00',1.45),('12664','2014-03-13','16:15:00',1.36),('12664','2014-03-13','16:20:00',1.27),('12664','2014-03-13','16:25:00',1.21),('12664','2014-03-13','16:30:00',1.13),('12664','2014-03-13','16:35:00',1.03),('12664','2014-03-12','07:50:00',1.04),('12664','2014-03-12','07:55:00',1.13),('12664','2014-03-12','08:00:00',1.23),('12664','2014-03-12','08:05:00',1.32),('12664','2014-03-12','08:10:00',1.42),('12664','2014-03-12','08:15:00',1.52),('12664','2014-03-12','08:20:00',1.61),('12664','2014-03-12','08:25:00',1.71),('12664','2014-03-12','08:30:00',1.79),('12664','2014-03-12','08:35:00',1.89),('12664','2014-03-12','08:40:00',1.97),('12664','2014-03-12','08:45:00',2.06),('12664','2014-03-12','08:50:00',2.13),('12664','2014-03-12','08:55:00',2.21),('12664','2014-03-12','09:00:00',2.31),('12664','2014-03-12','09:05:00',2.38),('12664','2014-03-12','09:10:00',2.46),('12664','2014-03-12','09:15:00',2.54),('12664','2014-03-12','09:20:00',2.6),('12664','2014-03-12','09:25:00',2.67),('12664','2014-03-12','09:30:00',2.72),('12664','2014-03-12','09:35:00',2.77),('12664','2014-03-12','09:40:00',2.86),('12664','2014-03-12','09:45:00',2.92),('12664','2014-03-12','09:50:00',2.97),('12664','2014-03-12','09:55:00',3.02),('12664','2014-03-12','10:00:00',3.09),('12664','2014-03-12','10:05:00',3.11),('12664','2014-03-12','10:10:00',3.14),('12664','2014-03-12','10:15:00',3.21),('12664','2014-03-12','10:20:00',3.26),('12664','2014-03-12','10:25:00',3.3),('12664','2014-03-12','10:30:00',3.33),('12664','2014-03-12','10:35:00',3.36),('12664','2014-03-12','10:40:00',3.42),('12664','2014-03-12','10:45:00',3.46),('12664','2014-03-12','10:50:00',3.49),('12664','2014-03-12','10:55:00',3.51),('12664','2014-03-12','11:00:00',3.5),('12664','2014-03-12','11:05:00',3.53),('12664','2014-03-12','11:10:00',3.59),('12664','2014-03-12','11:15:00',3.62),('12664','2014-03-12','11:20:00',3.66),('12664','2014-03-12','11:25:00',3.67),('12664','2014-03-12','11:30:00',3.65),('12664','2014-03-12','11:35:00',3.65),('12664','2014-03-12','11:40:00',3.69),('12664','2014-03-12','11:45:00',3.71),('12664','2014-03-12','11:50:00',3.73),('12664','2014-03-12','11:55:00',3.7),('12664','2014-03-12','12:00:00',3.7),('12664','2014-03-12','12:05:00',3.69),('12664','2014-03-12','12:10:00',3.66),('12664','2014-03-12','12:15:00',3.7),('12664','2014-03-12','12:20:00',3.68),('12664','2014-03-12','12:25:00',3.67),('12664','2014-03-12','12:30:00',3.65),('12664','2014-03-12','12:35:00',3.66),('12664','2014-03-12','12:40:00',3.65),('12664','2014-03-12','12:45:00',3.64),('12664','2014-03-12','12:50:00',3.63),('12664','2014-03-12','12:55:00',3.63),('12664','2014-03-12','13:00:00',3.6),('12664','2014-03-12','13:05:00',3.57),('12664','2014-03-12','13:10:00',3.56),('12664','2014-03-12','13:15:00',3.54),('12664','2014-03-12','13:20:00',3.52),('12664','2014-03-12','13:25:00',3.52),('12664','2014-03-12','13:30:00',3.47),('12664','2014-03-12','13:35:00',3.45),('12664','2014-03-12','13:40:00',3.41),('12664','2014-03-12','13:45:00',3.4),('12664','2014-03-12','13:50:00',3.37),('12664','2014-03-12','13:55:00',3.31),('12664','2014-03-12','14:00:00',3.31),('12664','2014-03-12','14:05:00',3.27),('12664','2014-03-12','14:10:00',3.15),('12664','2014-03-12','14:15:00',3.11),('12664','2014-03-12','14:20:00',3.04),('12664','2014-03-12','14:25:00',3.02),('12664','2014-03-12','14:30:00',2.92),('12664','2014-03-12','14:35:00',2.88),('12664','2014-03-12','14:40:00',2.85),('12664','2014-03-12','14:45:00',2.81),('12664','2014-03-12','14:50:00',2.7),('12664','2014-03-12','14:55:00',2.7),('12664','2014-03-12','15:00:00',2.63),('12664','2014-03-12','15:05:00',2.53),('12664','2014-03-12','15:10:00',2.46),('12664','2014-03-12','15:15:00',2.38),('12664','2014-03-12','15:20:00',2.29),('12664','2014-03-12','15:25:00',2.21),('12664','2014-03-12','15:30:00',2.13),('12664','2014-03-12','15:35:00',2.06),('12664','2014-03-12','15:40:00',1.99),('12664','2014-03-12','15:45:00',1.92),('12664','2014-03-12','15:50:00',1.85),('12664','2014-03-12','15:55:00',1.76),('12664','2014-03-12','16:00:00',1.64),('12664','2014-03-12','16:05:00',1.56),('12664','2014-03-12','16:10:00',1.47),('12664','2014-03-12','16:15:00',1.37),('12664','2014-03-12','16:20:00',1.28),('12664','2014-03-12','16:25:00',1.19),('12664','2014-03-12','16:30:00',1.1),('12664','2014-03-12','16:35:00',1.02),('12664','2014-03-11','11:55:00',1.09),('12664','2014-03-11','12:00:00',1.26),('12664','2014-03-11','12:05:00',1.31),('12664','2014-03-11','12:10:00',1.4),('12664','2014-03-11','12:15:00',1.7),('12664','2014-03-11','12:20:00',1.87),('12664','2014-03-11','12:25:00',1.6),('12664','2014-03-11','12:30:00',1.47),('12664','2014-03-11','12:35:00',1.48),('12664','2014-03-11','12:40:00',1.33),('12664','2014-03-11','12:45:00',1.55),('12664','2014-03-11','12:50:00',1.58),('12664','2014-03-11','12:55:00',1.52),('12664','2014-03-11','13:00:00',1.96),('12664','2014-03-11','13:05:00',1.99),('12664','2014-03-11','13:10:00',2.49),('12664','2014-03-11','13:15:00',2.01),('12664','2014-03-11','13:20:00',1.45),('12664','2014-03-11','13:25:00',1.39),('12664','2014-03-11','13:30:00',1.2),('12664','2014-03-11','13:35:00',1.27),('12664','2014-03-11','13:40:00',1.31),('12664','2014-03-11','13:45:00',1.43),('12664','2014-03-11','13:50:00',1.73),('12664','2014-03-11','13:55:00',1.85),('12664','2014-03-11','14:00:00',2.03),('12664','2014-03-11','14:05:00',2.07),('12664','2014-03-11','14:10:00',1.88),('12664','2014-03-11','14:15:00',2.14),('12664','2014-03-11','14:20:00',1.94),('12664','2014-03-11','14:25:00',1.87),('12664','2014-03-11','14:30:00',1.92),('12664','2014-03-11','14:35:00',1.73),('12664','2014-03-11','14:40:00',1.61),('12664','2014-03-11','14:45:00',1.75),('12664','2014-03-11','14:50:00',1.46),('12664','2014-03-11','14:55:00',1.42),('12664','2014-03-11','15:00:00',1.61),('12664','2014-03-11','15:05:00',1.5),('12664','2014-03-11','15:10:00',1.45),('12664','2014-03-11','15:15:00',1.34),('12664','2014-03-11','15:20:00',1.09),('12664','2014-03-10','08:55:00',1.01),('12664','2014-03-10','09:00:00',1.06),('12664','2014-03-10','09:05:00',1.04),('12664','2014-03-10','09:35:00',1.05),('12664','2014-03-10','09:40:00',1.24),('12664','2014-03-10','09:45:00',1.47),('12664','2014-03-10','09:50:00',1.44),('12664','2014-03-10','09:55:00',1.2),('12664','2014-03-10','10:15:00',1.05),('12664','2014-03-10','10:20:00',1.14),('12664','2014-03-10','13:10:00',1.04),('12664','2014-03-10','13:15:00',1.08),('12664','2014-03-10','15:05:00',1.14),('12664','2014-03-10','15:10:00',2.93),('12664','2014-03-10','15:15:00',2.86),('12664','2014-03-10','15:20:00',2.64),('12664','2014-03-10','15:25:00',2.12),('12664','2014-03-10','15:30:00',2.1),('12664','2014-03-10','15:35:00',2.15),('12664','2014-03-10','15:40:00',1.48),('12664','2014-03-10','15:45:00',1.17),('12664','2014-03-09','07:55:00',1.07),('12664','2014-03-09','08:00:00',1.16),('12664','2014-03-09','08:05:00',1.25),('12664','2014-03-09','08:10:00',1.34),('12664','2014-03-09','08:15:00',1.43),('12664','2014-03-09','08:20:00',1.53),('12664','2014-03-09','08:25:00',1.61),('12664','2014-03-09','08:30:00',1.53),('12664','2014-03-09','08:35:00',1.82),('12664','2014-03-09','08:40:00',1.93),('12664','2014-03-09','08:45:00',2.03),('12664','2014-03-09','08:50:00',2.09),('12664','2014-03-09','08:55:00',2.15),('12664','2014-03-09','09:00:00',2.23),('12664','2014-03-09','09:05:00',2.33),('12664','2014-03-09','09:10:00',2.4),('12664','2014-03-09','09:15:00',2.48),('12664','2014-03-09','09:20:00',2.58),('12664','2014-03-09','09:25:00',2.67),('12664','2014-03-09','09:30:00',2.76),('12664','2014-03-09','09:35:00',2.88),('12664','2014-03-09','09:40:00',2.98),('12664','2014-03-09','09:45:00',3.11),('12664','2014-03-09','09:50:00',3.2),('12664','2014-03-09','09:55:00',3.25),('12664','2014-03-09','10:00:00',3.27),('12664','2014-03-09','10:05:00',3.31),('12664','2014-03-09','10:10:00',3.37),('12664','2014-03-09','10:15:00',3.41),('12664','2014-03-09','10:20:00',3.43),('12664','2014-03-09','10:25:00',3.51),('12664','2014-03-09','10:30:00',3.54),('12664','2014-03-09','10:35:00',3.59),('12664','2014-03-09','10:40:00',3.63),('12664','2014-03-09','10:45:00',3.69),('12664','2014-03-09','10:50:00',3.71),('12664','2014-03-09','10:55:00',3.72),('12664','2014-03-09','11:00:00',3.77),('12664','2014-03-09','11:05:00',2.98),('12664','2014-03-09','11:10:00',1.85),('12664','2014-03-09','11:15:00',1.29),('12664','2014-03-09','11:35:00',1.37),('12664','2014-03-09','11:40:00',4.35),('12664','2014-03-09','11:45:00',4.07),('12664','2014-03-09','11:50:00',1.26),('12664','2014-03-09','11:55:00',3.95),('12664','2014-03-09','12:00:00',1.56),('12664','2014-03-09','12:05:00',3.12),('12664','2014-03-09','12:10:00',2.56),('12664','2014-03-09','12:15:00',2.25),('12664','2014-03-09','12:20:00',3.81),('12664','2014-03-09','12:25:00',4.21),('12664','2014-03-09','12:30:00',4.11),('12664','2014-03-09','12:35:00',4.13),('12664','2014-03-09','12:40:00',4.05),('12664','2014-03-09','12:45:00',3.38),('12664','2014-03-09','12:50:00',1.46),('12664','2014-03-09','12:55:00',3.91),('12664','2014-03-09','13:00:00',3.92),('12664','2014-03-09','13:05:00',3.94),('12664','2014-03-09','13:10:00',3.99),('12664','2014-03-09','13:15:00',4.02),('12664','2014-03-09','13:20:00',4.2),('12664','2014-03-09','13:25:00',4.04),('12664','2014-03-09','13:30:00',3.89),('12664','2014-03-09','13:35:00',3.79),('12664','2014-03-09','13:40:00',3.54),('12664','2014-03-09','13:45:00',3.73),('12664','2014-03-09','13:50:00',1.94),('12664','2014-03-09','14:00:00',2.45),('12664','2014-03-09','14:05:00',3.55),('12664','2014-03-09','14:10:00',3.09),('12664','2014-03-09','14:15:00',2.98),('12664','2014-03-09','14:20:00',3.2),('12664','2014-03-09','14:25:00',3.07),('12664','2014-03-09','14:30:00',3.07),('12664','2014-03-09','14:35:00',2.88),('12664','2014-03-09','14:40:00',3.03),('12664','2014-03-09','14:45:00',2.29),('12664','2014-03-09','14:50:00',2.73),('12664','2014-03-09','14:55:00',2.77),('12664','2014-03-09','15:00:00',2.83),('12664','2014-03-09','15:05:00',2.59),('12664','2014-03-09','15:10:00',3),('12664','2014-03-09','15:15:00',2.95),('12664','2014-03-09','15:20:00',2.77),('12664','2014-03-09','15:25:00',1.59),('12664','2014-03-09','15:55:00',1.85),('12664','2014-03-09','16:00:00',1.01),('12664','2014-03-09','16:15:00',1.29),('12664','2014-03-09','16:20:00',1.43),('12664','2014-03-09','16:25:00',1.36),('12664','2014-03-09','16:30:00',1.24),('12664','2014-03-09','16:35:00',1.07),('12664','2014-03-08','07:55:00',1.06),('12664','2014-03-08','08:00:00',1.15),('12664','2014-03-08','08:05:00',1.25),('12664','2014-03-08','08:10:00',1.35),('12664','2014-03-08','08:15:00',1.44),('12664','2014-03-08','08:20:00',1.54),('12664','2014-03-08','08:25:00',1.64),('12664','2014-03-08','08:30:00',1.73),('12664','2014-03-08','08:35:00',1.81),('12664','2014-03-08','08:40:00',1.9),('12664','2014-03-08','08:45:00',1.98),('12664','2014-03-08','08:50:00',2.07),('12664','2014-03-08','08:55:00',2.15),('12664','2014-03-08','09:00:00',2.23),('12664','2014-03-08','09:05:00',2.31),('12664','2014-03-08','09:10:00',2.38),('12664','2014-03-08','09:15:00',2.44),('12664','2014-03-08','09:20:00',2.51),('12664','2014-03-08','09:25:00',2.57),('12664','2014-03-08','09:30:00',2.65),('12664','2014-03-08','09:35:00',2.71),('12664','2014-03-08','09:40:00',2.77),('12664','2014-03-08','09:45:00',2.84),('12664','2014-03-08','09:50:00',2.92),('12664','2014-03-08','09:55:00',2.99),('12664','2014-03-08','10:00:00',3.07),('12664','2014-03-08','10:05:00',3.12),('12664','2014-03-08','10:10:00',3.18),('12664','2014-03-08','10:15:00',3.22),('12664','2014-03-08','10:20:00',3.25),('12664','2014-03-08','10:25:00',3.3),('12664','2014-03-08','10:30:00',3.04),('12664','2014-03-08','10:35:00',3.11),('12664','2014-03-08','10:40:00',3.36),('12664','2014-03-08','10:45:00',3.56),('12664','2014-03-08','10:50:00',2.52),('12664','2014-03-08','10:55:00',3.62),('12664','2014-03-08','11:00:00',3.6),('12664','2014-03-08','11:05:00',3.62),('12664','2014-03-08','11:10:00',3.68),('12664','2014-03-08','11:15:00',3.8),('12664','2014-03-08','11:20:00',3.9),('12664','2014-03-08','11:25:00',3.27),('12664','2014-03-08','11:30:00',3.69),('12664','2014-03-08','11:35:00',4.47),('12664','2014-03-08','11:40:00',4.67),('12664','2014-03-08','11:45:00',3.36),('12664','2014-03-08','11:50:00',4.62),('12664','2014-03-08','11:55:00',4.85),('12664','2014-03-08','12:00:00',4.63),('12664','2014-03-08','12:05:00',4.73),('12664','2014-03-08','12:10:00',3.92),('12664','2014-03-08','12:15:00',4.07),('12664','2014-03-08','12:20:00',3.06),('12664','2014-03-08','12:25:00',2.46),('12664','2014-03-08','12:30:00',1.95),('12664','2014-03-08','12:35:00',1.76),('12664','2014-03-08','12:40:00',1.67),('12664','2014-03-08','12:45:00',1.67),('12664','2014-03-08','12:50:00',1.57),('12664','2014-03-08','12:55:00',1.44),('12664','2014-03-08','13:00:00',1.46),('12664','2014-03-08','13:05:00',1.94),('12664','2014-03-08','13:10:00',2.04),('12664','2014-03-08','13:15:00',1.51),('12664','2014-03-08','13:20:00',1.31),('12664','2014-03-08','13:25:00',1.06),('12664','2014-03-08','13:40:00',1.09),('12664','2014-03-08','13:45:00',1.47),('12664','2014-03-08','13:50:00',1.43),('12664','2014-03-08','13:55:00',1.7),('12664','2014-03-08','14:00:00',1.45),('12664','2014-03-08','14:05:00',1.24),('12664','2014-03-08','14:10:00',1.03),('12664','2014-03-08','15:25:00',1.28),('12664','2014-03-08','15:30:00',1.17),('12664','2014-03-07','10:05:00',1.96),('12664','2014-03-07','10:10:00',2.46),('12664','2014-03-07','10:15:00',2.93),('12664','2014-03-07','10:20:00',3.93),('12664','2014-03-07','10:25:00',3.53),('12664','2014-03-07','10:30:00',3.73),('12664','2014-03-07','10:35:00',3.99),('12664','2014-03-07','10:40:00',1.79),('12664','2014-03-07','10:45:00',3.6),('12664','2014-03-07','10:50:00',4.28),('12664','2014-03-07','10:55:00',4.25),('12664','2014-03-07','11:00:00',4.26),('12664','2014-03-07','11:05:00',2.67),('12664','2014-03-07','11:10:00',3.76),('12664','2014-03-07','11:15:00',4.07),('12664','2014-03-07','11:20:00',4.32),('12664','2014-03-07','11:25:00',4.21),('12664','2014-03-07','11:30:00',4.2),('12664','2014-03-07','11:35:00',4.34),('12664','2014-03-07','11:40:00',4.37),('12664','2014-03-07','11:45:00',3.03),('12664','2014-03-07','11:50:00',3.36),('12664','2014-03-07','11:55:00',3.9),('12664','2014-03-07','12:00:00',3.07),('12664','2014-03-07','12:05:00',2.41),('12664','2014-03-07','12:10:00',4.11),('12664','2014-03-07','12:15:00',3.95),('12664','2014-03-07','12:20:00',3.87),('12664','2014-03-07','12:25:00',3.95),('12664','2014-03-07','12:30:00',4.05),('12664','2014-03-07','12:35:00',4.04),('12664','2014-03-07','12:40:00',4.02),('12664','2014-03-07','12:45:00',3.97),('12664','2014-03-07','12:50:00',3.94),('12664','2014-03-07','12:55:00',3),('12664','2014-03-07','13:00:00',1.01),('12664','2014-03-07','13:05:00',1.29),('12664','2014-03-07','13:10:00',2.11),('12664','2014-03-07','13:15:00',2.52),('12664','2014-03-07','13:20:00',2.87),('12664','2014-03-07','13:25:00',1.61),('12664','2014-03-07','13:30:00',1.69),('12664','2014-03-07','13:35:00',1.94),('12664','2014-03-07','13:40:00',1.89),('12664','2014-03-07','13:45:00',1.91),('12664','2014-03-07','13:50:00',1.73),('12664','2014-03-07','13:55:00',1.46),('12664','2014-03-07','14:00:00',1.28),('12664','2014-03-07','14:05:00',1.21),('12664','2014-03-07','14:10:00',1.16),('12664','2014-03-07','14:15:00',1.12),('12664','2014-03-07','14:20:00',1.15),('12664','2014-03-07','14:25:00',1.24),('12664','2014-03-07','14:30:00',1.38),('12664','2014-03-07','14:35:00',1.5),('12664','2014-03-07','14:40:00',1.55),('12664','2014-03-07','14:45:00',1.69),('12664','2014-03-07','14:50:00',1.98),('12664','2014-03-07','14:55:00',2.02),('12664','2014-03-07','15:00:00',2.42),('12664','2014-03-07','15:05:00',2.76),('12664','2014-03-07','15:10:00',3.01),('12664','2014-03-07','15:15:00',2.76),('12664','2014-03-07','15:20:00',2.38),('12664','2014-03-07','15:25:00',2.02),('12664','2014-03-07','15:30:00',2.13),('12664','2014-03-07','15:35:00',1.37),('12664','2014-03-07','16:05:00',1.76),('12664','2014-03-07','16:10:00',1.08),('12664','2014-03-07','16:35:00',1.1),('12664','2014-03-07','16:40:00',1.04),('12664','2014-04-29','09:45:00',1.39),('12664','2014-04-29','09:50:00',2.62),('12664','2014-04-29','09:55:00',3.19),('12664','2014-04-29','10:00:00',3.62),('12664','2014-04-29','10:05:00',3.64),('12664','2014-04-29','10:10:00',3.63),('12664','2014-04-29','10:15:00',3.74),('12664','2014-04-29','10:20:00',3.71),('12664','2014-04-29','10:25:00',3.6),('12664','2014-04-29','10:30:00',3.61),('12664','2014-04-29','10:35:00',3.77),('12664','2014-04-29','10:40:00',3.56),('12664','2014-04-29','10:45:00',3.76),('12664','2014-04-29','10:50:00',3.91),('12664','2014-04-29','10:55:00',3.87),('12664','2014-04-29','11:00:00',3.95),('12664','2014-04-29','11:05:00',3.98),('12664','2014-04-29','11:10:00',4.02),('12664','2014-04-29','11:15:00',4.08),('12664','2014-04-29','11:20:00',4.13),('12664','2014-04-29','11:25:00',4.3),('12664','2014-04-29','11:30:00',3.93),('12664','2014-04-29','11:35:00',1.54),('12664','2014-04-29','11:40:00',1.27),('12664','2014-04-29','11:50:00',1.03),('12664','2014-04-29','11:55:00',1.07),('12664','2014-04-29','12:00:00',1.39),('12664','2014-04-29','12:05:00',2.36),('12664','2014-04-29','12:10:00',4.67),('12664','2014-04-29','12:15:00',4.56),('12664','2014-04-29','12:20:00',4.71),('12664','2014-04-29','12:25:00',4.64),('12664','2014-04-29','12:30:00',4.8),('12664','2014-04-29','12:35:00',4.79),('12664','2014-04-29','12:40:00',2.91),('12664','2014-04-29','12:45:00',2.89),('12664','2014-04-29','12:50:00',2.77),('12664','2014-04-29','12:55:00',1.37),('12664','2014-04-29','13:00:00',1.23),('12664','2014-04-29','13:05:00',1.38),('12664','2014-04-29','13:10:00',2.42),('12664','2014-04-29','13:15:00',3.88),('12664','2014-04-29','13:20:00',2.16),('12664','2014-04-29','13:25:00',4.42),('12664','2014-04-29','13:30:00',2.02),('12664','2014-04-29','13:35:00',1.46),('12664','2014-04-29','13:40:00',1.76),('12664','2014-04-29','13:45:00',4.66),('12664','2014-04-29','13:50:00',4.92),('12664','2014-04-29','13:55:00',3.22),('12664','2014-04-29','14:00:00',1.66),('12664','2014-04-29','14:05:00',1.51),('12664','2014-04-29','14:10:00',1.09),('12664','2014-04-29','14:15:00',1.01),('12664','2014-04-29','14:20:00',1.52),('12664','2014-04-29','14:25:00',1.81),('12664','2014-04-29','14:30:00',1.52),('12664','2014-04-29','14:35:00',1.19),('12664','2014-04-29','14:40:00',1.35),('12664','2014-04-29','14:45:00',1.66),('12664','2014-04-29','14:50:00',1.88),('12664','2014-04-29','14:55:00',2.85),('12664','2014-04-29','15:00:00',2.64),('12664','2014-04-29','15:05:00',3.27),('12664','2014-04-29','15:10:00',4.28),('12664','2014-04-29','15:15:00',3.34),('12664','2014-04-29','15:20:00',1.95),('12664','2014-04-29','15:25:00',1.42),('12664','2014-04-29','15:30:00',1.61),('12664','2014-04-29','15:35:00',1.76),('12664','2014-04-29','15:40:00',2.11),('12664','2014-04-29','15:45:00',2.45),('12664','2014-04-29','15:50:00',2.14),('12664','2014-04-29','15:55:00',1.16),('12664','2014-04-29','16:30:00',1.17),('12664','2014-04-29','16:35:00',1.01),('12664','2014-04-29','17:00:00',1.02),('12664','2014-04-29','17:05:00',1.76),('12664','2014-04-29','17:10:00',2.28),('12664','2014-04-29','17:15:00',2.32),('12664','2014-04-29','17:20:00',2.25),('12664','2014-04-29','17:25:00',1.75),('12664','2014-04-29','17:45:00',1.08),('12664','2014-03-06','08:45:00',1.01),('12664','2014-03-06','08:50:00',1.02),('12664','2014-03-06','09:05:00',1.21),('12664','2014-03-06','09:10:00',2.6),('12664','2014-03-06','09:15:00',2.12),('12664','2014-03-06','09:20:00',2.93),('12664','2014-03-06','09:25:00',2.44),('12664','2014-03-06','09:30:00',2.53),('12664','2014-03-06','09:35:00',2.14),('12664','2014-03-06','09:40:00',1.72),('12664','2014-03-06','09:45:00',1.77),('12664','2014-03-06','09:50:00',2.01),('12664','2014-03-06','09:55:00',2.3),('12664','2014-03-06','10:00:00',2.51),('12664','2014-03-06','10:05:00',2.62),('12664','2014-03-06','10:10:00',2.52),('12664','2014-03-06','10:15:00',2.62),('12664','2014-03-06','10:20:00',2.83),('12664','2014-03-06','10:25:00',3.37),('12664','2014-03-06','10:30:00',3.45),('12664','2014-03-06','10:35:00',2.22),('12664','2014-03-06','10:40:00',3.36),('12664','2014-03-06','10:45:00',2.31),('12664','2014-03-06','10:50:00',2.05),('12664','2014-03-06','10:55:00',3.79),('12664','2014-03-06','11:00:00',4.07),('12664','2014-03-06','11:05:00',4.29),('12664','2014-03-06','11:10:00',3.74),('12664','2014-03-06','11:15:00',4.04),('12664','2014-03-06','11:20:00',3.97),('12664','2014-03-06','11:25:00',3.99),('12664','2014-03-06','11:30:00',4.4),('12664','2014-03-06','11:35:00',4.22),('12664','2014-03-06','11:40:00',2.37),('12664','2014-03-06','11:45:00',2.86),('12664','2014-03-06','11:50:00',4.22),('12664','2014-03-06','11:55:00',2.96),('12664','2014-03-06','12:00:00',3.69),('12664','2014-03-06','12:05:00',2.15),('12664','2014-03-06','12:10:00',3.36),('12664','2014-03-06','12:15:00',3.6),('12664','2014-03-06','12:20:00',2.28),('12664','2014-03-06','12:30:00',1.13),('12664','2014-03-06','12:35:00',1.02),('12664','2014-03-06','12:40:00',3.51),('12664','2014-03-06','12:45:00',3.08),('12664','2014-03-06','12:50:00',2.14),('12664','2014-03-06','12:55:00',1.64),('12664','2014-03-06','13:00:00',1.52),('12664','2014-03-06','13:05:00',1.51),('12664','2014-03-06','13:10:00',1.39),('12664','2014-03-06','13:15:00',1.4),('12664','2014-03-06','13:20:00',1.51),('12664','2014-03-06','13:25:00',3.22),('12664','2014-03-06','13:30:00',2.44),('12664','2014-03-06','13:35:00',1.15),('12664','2014-03-06','13:45:00',1.03),('12664','2014-03-06','13:50:00',1.18),('12664','2014-03-06','13:55:00',1.12),('12664','2014-03-06','14:00:00',1.17),('12664','2014-03-06','14:05:00',1.29),('12664','2014-03-06','14:10:00',1.23),('12664','2014-03-06','14:15:00',1.25),('12664','2014-03-06','14:20:00',1.61),('12664','2014-03-06','14:25:00',1.33),('12664','2014-03-06','14:30:00',1.3),('12664','2014-03-06','14:35:00',1.17),('12664','2014-03-06','15:00:00',1.11),('12664','2014-03-06','15:05:00',1.17),('12664','2014-03-06','15:10:00',1.27),('12664','2014-03-06','15:15:00',1.47),('12664','2014-03-06','15:20:00',1.23),('12664','2014-03-06','15:25:00',1.17),('12664','2014-03-06','15:30:00',1.05),('12664','2014-03-06','16:45:00',1.04),('12664','2014-03-06','16:50:00',1.11),('12664','2014-03-05','07:55:00',1.29),('12664','2014-03-05','08:00:00',1.41),('12664','2014-03-05','08:05:00',1.51),('12664','2014-03-05','08:10:00',1.58),('12664','2014-03-05','08:15:00',1.7),('12664','2014-03-05','08:20:00',1.18),('12664','2014-03-05','08:25:00',1.85),('12664','2014-03-05','08:30:00',1.99),('12664','2014-03-05','08:35:00',1.11),('12664','2014-03-05','08:40:00',1.03),('12664','2014-03-05','08:45:00',1.93),('12664','2014-03-05','08:50:00',2.63),('12664','2014-03-05','08:55:00',2.53),('12664','2014-03-05','09:00:00',2.5),('12664','2014-03-05','09:05:00',2.43),('12664','2014-03-05','09:10:00',2.45),('12664','2014-03-05','09:15:00',2.51),('12664','2014-03-05','09:20:00',2.56),('12664','2014-03-05','09:25:00',2.62),('12664','2014-03-05','09:30:00',2.67),('12664','2014-03-05','09:35:00',2.74),('12664','2014-03-05','09:40:00',2.81),('12664','2014-03-05','09:45:00',2.89),('12664','2014-03-05','09:50:00',2.96),('12664','2014-03-05','09:55:00',2.98),('12664','2014-03-05','10:00:00',3.01),('12664','2014-03-05','10:05:00',3.08),('12664','2014-03-05','10:10:00',3.14),('12664','2014-03-05','10:15:00',3.23),('12664','2014-03-05','10:20:00',3.27),('12664','2014-03-05','10:25:00',3.29),('12664','2014-03-05','10:30:00',3.33),('12664','2014-03-05','10:35:00',3.42),('12664','2014-03-05','10:40:00',3.43),('12664','2014-03-05','10:45:00',3.48),('12664','2014-03-05','10:50:00',3.51),('12664','2014-03-05','10:55:00',3.54),('12664','2014-03-05','11:00:00',3.55),('12664','2014-03-05','11:05:00',3.6),('12664','2014-03-05','11:10:00',3.72),('12664','2014-03-05','11:15:00',3.79),('12664','2014-03-05','11:20:00',3.79),('12664','2014-03-05','11:25:00',3.82),('12664','2014-03-05','11:30:00',3.88),('12664','2014-03-05','11:35:00',3.93),('12664','2014-03-05','11:40:00',4.17),('12664','2014-03-05','11:45:00',3.78),('12664','2014-03-05','11:50:00',3.82),('12664','2014-03-05','11:55:00',3.93),('12664','2014-03-05','12:00:00',3.43),('12664','2014-03-05','12:05:00',3.32),('12664','2014-03-05','12:10:00',2.26),('12664','2014-03-05','12:15:00',3.53),('12664','2014-03-05','12:20:00',3.94),('12664','2014-03-05','12:25:00',4),('12664','2014-03-05','12:30:00',3.58),('12664','2014-03-05','12:35:00',3.91),('12664','2014-03-05','12:40:00',3.87),('12664','2014-03-05','12:45:00',3.72),('12664','2014-03-05','12:50:00',2.45),('12664','2014-03-05','12:55:00',2.17),('12664','2014-03-05','13:00:00',2.38),('12664','2014-03-05','13:05:00',2.22),('12664','2014-03-05','13:10:00',1.8),('12664','2014-03-05','13:15:00',3.69),('12664','2014-03-05','13:20:00',4),('12664','2014-03-05','13:25:00',3.96),('12664','2014-03-05','13:30:00',3.76),('12664','2014-03-05','13:35:00',4.25),('12664','2014-03-05','13:40:00',4.61),('12664','2014-03-05','13:45:00',4.63),('12664','2014-03-05','13:50:00',3.25),('12664','2014-03-05','13:55:00',2.19),('12664','2014-03-05','14:00:00',1.09),('12664','2014-03-05','14:10:00',2.51),('12664','2014-03-05','14:15:00',2.32),('12664','2014-03-05','14:20:00',1.46),('12664','2014-03-05','14:25:00',1.48),('12664','2014-03-05','14:30:00',1.45),('12664','2014-03-05','14:35:00',1.59),('12664','2014-03-05','14:40:00',1.52),('12664','2014-03-05','14:45:00',1.97),('12664','2014-03-05','14:50:00',2.23),('12664','2014-03-05','14:55:00',3.32),('12664','2014-03-05','15:00:00',2.72),('12664','2014-03-05','15:05:00',1.77),('12664','2014-03-05','15:30:00',1.01),('12664','2014-03-05','15:50:00',1.4),('12664','2014-03-05','15:55:00',2.75),('12664','2014-03-05','16:00:00',2.31),('12664','2014-03-05','16:05:00',1.37),('12664','2014-03-04','09:05:00',1.76),('12664','2014-03-04','09:55:00',1.64),('12664','2014-03-04','10:00:00',2.82),('12664','2014-03-04','10:05:00',2.05),('12664','2014-03-04','10:30:00',1.49),('12664','2014-03-04','10:35:00',1.3),('12664','2014-03-04','10:40:00',1.17),('12664','2014-03-04','10:45:00',2.72),('12664','2014-03-04','10:50:00',4.75),('12664','2014-03-04','10:55:00',2.57),('12664','2014-03-04','11:00:00',1.3),('12664','2014-03-04','11:20:00',1.18),('12664','2014-03-04','11:25:00',3.02),('12664','2014-03-04','11:30:00',2.47),('12664','2014-03-04','11:35:00',1.43),('12664','2014-03-04','11:40:00',3.75),('12664','2014-03-04','11:45:00',4.17),('12664','2014-03-04','11:50:00',4.15),('12664','2014-03-04','11:55:00',1.44),('12664','2014-03-04','12:00:00',4.09),('12664','2014-03-04','12:05:00',3.49),('12664','2014-03-04','12:10:00',4.08),('12664','2014-03-04','12:15:00',3.2),('12664','2014-03-04','12:20:00',2.67),('12664','2014-03-04','12:25:00',3.26),('12664','2014-03-04','12:30:00',3.9),('12664','2014-03-04','12:35:00',3.86),('12664','2014-03-04','12:40:00',3.71),('12664','2014-03-04','12:45:00',3.87),('12664','2014-03-04','12:50:00',3.85),('12664','2014-03-04','12:55:00',3.85),('12664','2014-03-04','13:00:00',3.72),('12664','2014-03-04','13:05:00',3.95),('12664','2014-03-04','13:10:00',3.56),('12664','2014-03-04','13:15:00',1.48),('12664','2014-03-04','13:20:00',1.24),('12664','2014-03-04','13:45:00',1.86),('12664','2014-03-04','13:50:00',3.62),('12664','2014-03-04','13:55:00',2.88),('12664','2014-03-04','14:00:00',3.5),('12664','2014-03-04','14:05:00',3.69),('12664','2014-03-04','14:10:00',3.75),('12664','2014-03-04','14:15:00',3.46),('12664','2014-03-04','14:20:00',2.53),('12664','2014-03-04','14:25:00',3.59),('12664','2014-03-04','14:30:00',3.23),('12664','2014-03-04','14:35:00',3.17),('12664','2014-03-04','14:40:00',3.06),('12664','2014-03-04','14:45:00',2.82),('12664','2014-03-04','14:50:00',2.75),('12664','2014-03-04','14:55:00',2.92),('12664','2014-03-04','15:00:00',2.78),('12664','2014-03-04','15:05:00',2.72),('12664','2014-03-04','15:10:00',2.6),('12664','2014-03-04','15:15:00',2.5),('12664','2014-03-04','15:20:00',2.47),('12664','2014-03-04','15:25:00',2.5),('12664','2014-03-04','15:30:00',2.06),('12664','2014-03-04','15:35:00',1.23),('12664','2014-03-04','15:40:00',1.65),('12664','2014-03-04','15:45:00',1.17),('12664','2014-03-04','16:00:00',1.37),('12664','2014-03-04','16:05:00',1.02),('12664','2014-03-04','16:25:00',1.61),('12664','2014-03-04','16:30:00',1.2),('12664','2014-03-04','16:40:00',1.01),('12664','2014-03-03','07:55:00',1.03),('12664','2014-03-03','08:00:00',1.16),('12664','2014-03-03','08:05:00',1.25),('12664','2014-03-03','08:10:00',1.37),('12664','2014-03-03','08:15:00',1.46),('12664','2014-03-03','08:20:00',1.54),('12664','2014-03-03','08:25:00',1.63),('12664','2014-03-03','08:30:00',1.72),('12664','2014-03-03','08:35:00',1.82),('12664','2014-03-03','08:40:00',1.92),('12664','2014-03-03','08:45:00',1.98),('12664','2014-03-03','08:50:00',1.9),('12664','2014-03-03','08:55:00',1.94),('12664','2014-03-03','09:00:00',1.63),('12664','2014-03-03','09:05:00',2.42),('12664','2014-03-03','09:10:00',2.49),('12664','2014-03-03','09:15:00',2.51),('12664','2014-03-03','09:20:00',2.47),('12664','2014-03-03','09:25:00',2.54),('12664','2014-03-03','09:30:00',2.67),('12664','2014-03-03','09:35:00',2.61),('12664','2014-03-03','09:40:00',2.51),('12664','2014-03-03','09:45:00',2.72),('12664','2014-03-03','09:50:00',2.86),('12664','2014-03-03','09:55:00',2.85),('12664','2014-03-03','10:00:00',2.99),('12664','2014-03-03','10:05:00',3.08),('12664','2014-03-03','10:10:00',3.11),('12664','2014-03-03','10:15:00',3.14),('12664','2014-03-03','10:20:00',3.19),('12664','2014-03-03','10:25:00',3.26),('12664','2014-03-03','10:30:00',3.29),('12664','2014-03-03','10:35:00',3.33),('12664','2014-03-03','10:40:00',3.38),('12664','2014-03-03','10:45:00',3.39),('12664','2014-03-03','10:50:00',3.41),('12664','2014-03-03','10:55:00',3.47),('12664','2014-03-03','11:00:00',3.48),('12664','2014-03-03','11:05:00',3.54),('12664','2014-03-03','11:10:00',3.55),('12664','2014-03-03','11:15:00',3.6),('12664','2014-03-03','11:20:00',3.66),('12664','2014-03-03','11:25:00',3.7),('12664','2014-03-03','11:30:00',3.76),('12664','2014-03-03','11:35:00',3.78),('12664','2014-03-03','11:40:00',3.8),('12664','2014-03-03','11:45:00',3.83),('12664','2014-03-03','11:50:00',3.84),('12664','2014-03-03','11:55:00',3.85),('12664','2014-03-03','12:00:00',3.85),('12664','2014-03-03','12:05:00',3.83),('12664','2014-03-03','12:10:00',3.85),('12664','2014-03-03','12:15:00',3.85),('12664','2014-03-03','12:20:00',3.86),('12664','2014-03-03','12:25:00',3.85),('12664','2014-03-03','12:30:00',3.85),('12664','2014-03-03','12:35:00',3.85),('12664','2014-03-03','12:40:00',3.84),('12664','2014-03-03','12:45:00',3.82),('12664','2014-03-03','12:50:00',3.79),('12664','2014-03-03','12:55:00',3.78),('12664','2014-03-03','13:00:00',3.77),('12664','2014-03-03','13:05:00',3.76),('12664','2014-03-03','13:10:00',3.74),('12664','2014-03-03','13:15:00',3.73),('12664','2014-03-03','13:20:00',3.72),('12664','2014-03-03','13:25:00',3.7),('12664','2014-03-03','13:30:00',3.69),('12664','2014-03-03','13:35:00',3.59),('12664','2014-03-03','13:40:00',3.22),('12664','2014-03-03','13:45:00',3.65),('12664','2014-03-03','13:50:00',3.59),('12664','2014-03-03','13:55:00',3.52),('12664','2014-03-03','14:00:00',3.17),('12664','2014-03-03','14:05:00',3.43),('12664','2014-03-03','14:10:00',3.39),('12664','2014-03-03','14:15:00',3.32),('12664','2014-03-03','14:20:00',3.03),('12664','2014-03-03','14:25:00',3.14),('12664','2014-03-03','14:30:00',3.14),('12664','2014-03-03','14:35:00',3.1),('12664','2014-03-03','14:40:00',3.02),('12664','2014-03-03','14:45:00',2.92),('12664','2014-03-03','14:50:00',2.88),('12664','2014-03-03','14:55:00',2.84),('12664','2014-03-03','15:00:00',2.63),('12664','2014-03-03','15:05:00',2.5),('12664','2014-03-03','15:10:00',2.57),('12664','2014-03-03','15:15:00',2.57),('12664','2014-03-03','15:20:00',2.53),('12664','2014-03-03','15:25:00',2.43),('12664','2014-03-03','15:30:00',2.08),('12664','2014-03-03','15:35:00',2.25),('12664','2014-03-03','15:40:00',1.66),('12664','2014-03-03','15:45:00',1.31),('12664','2014-03-03','15:50:00',1.82),('12664','2014-03-03','15:55:00',1.88),('12664','2014-03-03','16:00:00',1.75),('12664','2014-03-03','16:05:00',1.66),('12664','2014-03-03','16:10:00',1.58),('12664','2014-03-03','16:15:00',1.48),('12664','2014-03-03','16:20:00',1.38),('12664','2014-03-03','16:25:00',1.28),('12664','2014-03-03','16:30:00',1.19),('12664','2014-03-03','16:35:00',1.08),('12664','2014-03-02','08:15:00',1.06),('12664','2014-03-02','08:30:00',1.65),('12664','2014-03-02','08:35:00',1.85),('12664','2014-03-02','08:40:00',1.94),('12664','2014-03-02','08:45:00',2.04),('12664','2014-03-02','08:50:00',2.11),('12664','2014-03-02','08:55:00',2.22),('12664','2014-03-02','09:00:00',2.35),('12664','2014-03-02','09:05:00',2.48),('12664','2014-03-02','09:10:00',2.21),('12664','2014-03-02','09:15:00',2.75),('12664','2014-03-02','09:20:00',2.61),('12664','2014-03-02','09:25:00',2.34),('12664','2014-03-02','09:30:00',1.63),('12664','2014-03-02','09:35:00',2.74),('12664','2014-03-02','09:40:00',1.11),('12664','2014-03-02','10:15:00',1.34),('12664','2014-03-02','10:20:00',1.36),('12664','2014-03-02','10:25:00',2.23),('12664','2014-03-02','10:30:00',3.94),('12664','2014-03-02','10:35:00',3.85),('12664','2014-03-02','10:40:00',3.53),('12664','2014-03-02','10:45:00',3.37),('12664','2014-03-02','10:50:00',3.81),('12664','2014-03-02','10:55:00',1.58),('12664','2014-03-02','11:00:00',1.22),('12664','2014-03-02','11:05:00',1.54),('12664','2014-03-02','11:10:00',1.74),('12664','2014-03-02','11:15:00',1.84),('12664','2014-03-02','11:20:00',2.26),('12664','2014-03-02','11:25:00',1.88),('12664','2014-03-02','11:30:00',1.58),('12664','2014-03-02','11:35:00',1.64),('12664','2014-03-02','11:40:00',1.99),('12664','2014-03-02','11:45:00',3.03),('12664','2014-03-02','11:50:00',3.91),('12664','2014-03-02','11:55:00',3.62),('12664','2014-03-02','12:00:00',3.14),('12664','2014-03-02','12:05:00',2.54),('12664','2014-03-02','12:10:00',2.62),('12664','2014-03-02','12:15:00',1.23),('12664','2014-03-02','15:10:00',1),('12664','2014-03-02','15:15:00',1.02),('12664','2014-03-02','15:20:00',1.04),('12664','2014-03-02','15:25:00',1.09),('12664','2014-03-02','15:30:00',1.05),('12664','2014-03-02','15:35:00',1.03),('12664','2014-03-02','15:40:00',1.13),('12664','2014-03-02','15:45:00',1.18),('12664','2014-03-02','15:50:00',1.23),('12664','2014-03-02','15:55:00',1.23),('12664','2014-03-02','16:00:00',1),('12664','2014-02-28','07:50:00',1.18),('12664','2014-02-28','07:55:00',1.11),('12664','2014-02-28','09:05:00',1.71),('12664','2014-02-28','09:10:00',1.38),('12664','2014-02-28','09:15:00',2.17),('12664','2014-02-28','09:20:00',2.32),('12664','2014-02-28','09:25:00',2.44),('12664','2014-02-28','09:30:00',2.9),('12664','2014-02-28','09:35:00',3.23),('12664','2014-02-28','09:40:00',1.92),('12664','2014-02-28','09:45:00',1.24),('12664','2014-02-28','09:50:00',1.13),('12664','2014-02-28','09:55:00',1.26),('12664','2014-02-28','10:00:00',1.15),('12664','2014-02-28','10:05:00',1.06),('12664','2014-02-28','10:10:00',1.23),('12664','2014-02-28','10:15:00',2.81),('12664','2014-02-28','10:20:00',3.41),('12664','2014-02-28','10:25:00',3.38),('12664','2014-02-28','10:30:00',1.94),('12664','2014-02-28','10:35:00',1.43),('12664','2014-02-28','10:40:00',1.12),('12664','2014-02-28','10:45:00',1.06),('12664','2014-02-28','11:00:00',1.19),('12664','2014-02-28','11:05:00',1.1),('12664','2014-02-28','11:10:00',1.16),('12664','2014-02-28','11:15:00',1.2),('12664','2014-02-28','11:50:00',1.15),('12664','2014-02-28','11:55:00',1.03),('12664','2014-02-28','12:20:00',3.2),('12664','2014-02-28','12:25:00',4.24),('12664','2014-02-28','12:30:00',4.18),('12664','2014-02-28','12:35:00',3.47),('12664','2014-02-28','12:40:00',1.42),('12664','2014-02-28','12:45:00',1.03),('12664','2014-02-28','12:50:00',1.31),('12664','2014-02-28','12:55:00',1.36),('12664','2014-02-28','13:35:00',1.03),('12664','2014-02-28','13:40:00',1.05),('12664','2014-02-28','13:45:00',1.17),('12664','2014-02-28','13:50:00',1.19),('12664','2014-02-28','14:10:00',1.27),('12664','2014-02-28','14:15:00',2.48),('12664','2014-02-28','14:20:00',1.51),('12664','2014-02-28','15:30:00',2.74),('12664','2014-02-28','15:35:00',1.72),('12664','2014-02-27','10:35:00',1.09),('12664','2014-02-27','10:40:00',1.24),('12664','2014-02-27','10:45:00',1.14),('12664','2014-02-27','10:50:00',1.06),('12664','2014-02-27','10:55:00',1.19),('12664','2014-02-27','11:00:00',1.27),('12664','2014-02-27','11:05:00',1.3),('12664','2014-02-27','11:10:00',1.27),('12664','2014-02-27','11:15:00',1.26),('12664','2014-02-27','11:20:00',1.3),('12664','2014-02-27','11:25:00',1.37),('12664','2014-02-27','11:30:00',1.26),('12664','2014-02-27','11:35:00',1.12),('12664','2014-02-27','11:40:00',1.09),('12664','2014-02-27','11:45:00',1.1),('12664','2014-02-27','11:50:00',1.11),('12664','2014-02-27','11:55:00',1.03),('12664','2014-02-27','12:00:00',1.21),('12664','2014-02-27','12:05:00',1.23),('12664','2014-02-27','12:10:00',1.28),('12664','2014-02-27','12:15:00',1.28),('12664','2014-02-27','12:20:00',1.24),('12664','2014-02-27','12:25:00',1.23),('12664','2014-02-27','12:30:00',1.21),('12664','2014-02-27','12:35:00',1.2),('12664','2014-02-27','12:40:00',1.23),('12664','2014-02-27','12:45:00',1.24),('12664','2014-02-27','12:50:00',1.21),('12664','2014-02-27','12:55:00',1.21),('12664','2014-02-27','13:00:00',1.21),('12664','2014-02-27','13:05:00',1.08),('12664','2014-02-27','13:10:00',1.19),('12664','2014-02-27','13:15:00',1.39),('12664','2014-02-27','13:20:00',1.48),('12664','2014-02-27','13:25:00',1.54),('12664','2014-02-27','13:30:00',1.57),('12664','2014-02-27','13:35:00',1.52),('12664','2014-02-27','13:40:00',1.47),('12664','2014-02-27','13:45:00',1.49),('12664','2014-02-27','13:50:00',1.61),('12664','2014-02-27','13:55:00',1.34),('12664','2014-02-27','14:00:00',1.32),('12664','2014-02-27','14:05:00',1.79),('12664','2014-02-27','14:10:00',1.51),('12664','2014-02-27','14:15:00',1.52),('12664','2014-02-27','14:20:00',1.5),('12664','2014-02-27','14:25:00',1.28),('12664','2014-02-27','14:30:00',1.19),('12664','2014-02-27','14:35:00',1.19),('12664','2014-02-27','14:40:00',1.51),('12664','2014-02-27','14:45:00',1.52),('12664','2014-02-27','14:50:00',1.39),('12664','2014-02-27','14:55:00',1.3),('12664','2014-02-27','15:00:00',1.16),('12664','2014-02-27','15:05:00',1.53),('12664','2014-02-27','15:10:00',1.5),('12664','2014-02-27','15:15:00',1.25),('12664','2014-02-27','15:20:00',1.72),('12664','2014-02-27','15:25:00',1.76),('12664','2014-02-27','15:30:00',1.15),('12664','2014-02-27','16:40:00',1.12),('12664','2014-02-27','16:45:00',1.13),('12664','2014-02-26','08:05:00',1.08),('12664','2014-02-26','08:10:00',1.17),('12664','2014-02-26','08:15:00',1.21),('12664','2014-02-26','08:20:00',1.36),('12664','2014-02-26','08:25:00',1.45),('12664','2014-02-26','08:30:00',1.58),('12664','2014-02-26','08:35:00',1.75),('12664','2014-02-26','08:40:00',1.69),('12664','2014-02-26','08:45:00',1.51),('12664','2014-02-26','08:50:00',1.7),('12664','2014-02-26','08:55:00',1.94),('12664','2014-02-26','09:00:00',2.02),('12664','2014-02-26','09:05:00',1.9),('12664','2014-02-26','09:10:00',2.1),('12664','2014-02-26','09:15:00',2.22),('12664','2014-02-26','09:20:00',1.6),('12664','2014-02-26','09:25:00',1.65),('12664','2014-02-26','09:30:00',1.59),('12664','2014-02-26','09:35:00',1.81),('12664','2014-02-26','09:40:00',1.78),('12664','2014-02-26','09:45:00',1.64),('12664','2014-02-26','09:50:00',1.75),('12664','2014-02-26','09:55:00',1.13),('12664','2014-02-26','12:10:00',1.02),('12664','2014-02-26','12:15:00',1.15),('12664','2014-02-26','12:20:00',3.11),('12664','2014-02-26','12:25:00',2.1),('12664','2014-02-26','12:30:00',2.03),('12664','2014-02-26','12:35:00',1.34),('12664','2014-02-26','12:40:00',1.93),('12664','2014-02-26','12:45:00',2.06),('12664','2014-02-26','12:50:00',2.88),('12664','2014-02-26','12:55:00',1.82),('12664','2014-02-26','13:00:00',1.8),('12664','2014-02-26','13:05:00',1.96),('12664','2014-02-26','13:10:00',1.92),('12664','2014-02-26','13:15:00',3.37),('12664','2014-02-26','13:20:00',3.67),('12664','2014-02-26','13:25:00',3.64),('12664','2014-02-26','13:30:00',1.4),('12664','2014-02-26','13:35:00',1.16),('12664','2014-02-26','13:40:00',3.46),('12664','2014-02-26','13:45:00',4.04),('12664','2014-02-26','13:50:00',3.76),('12664','2014-02-26','13:55:00',2.36),('12664','2014-02-26','14:00:00',2.93),('12664','2014-02-26','14:05:00',1.56),('12664','2014-02-26','14:10:00',1.65),('12664','2014-02-26','14:20:00',1.04),('12664','2014-02-26','14:25:00',1.45),('12664','2014-02-26','14:30:00',1.68),('12664','2014-02-26','14:35:00',2.38),('12664','2014-02-26','14:40:00',3.12),('12664','2014-02-26','14:45:00',2.58),('12664','2014-02-26','14:50:00',2.95),('12664','2014-02-26','14:55:00',2.75),('12664','2014-02-26','15:00:00',2.69),('12664','2014-02-26','15:05:00',2.39),('12664','2014-02-26','15:10:00',2.21),('12664','2014-02-26','15:15:00',1.65),('12664','2014-02-26','15:20:00',1.24),('12664','2014-02-26','15:25:00',1.6),('12664','2014-02-26','15:30:00',1.93),('12664','2014-02-26','15:35:00',1.68),('12664','2014-02-26','15:40:00',1.52),('12664','2014-02-26','15:45:00',1.87),('12664','2014-02-26','15:50:00',1.82),('12664','2014-02-26','15:55:00',1.66),('12664','2014-02-26','16:00:00',1.44),('12664','2014-02-26','16:05:00',1.07),('12664','2014-02-26','16:10:00',1.32),('12664','2014-02-26','16:15:00',1.12),('12664','2014-02-25','08:05:00',1.03),('12664','2014-02-25','08:10:00',1.12),('12664','2014-02-25','08:15:00',1.2),('12664','2014-02-25','08:20:00',1.28),('12664','2014-02-25','08:25:00',1.37),('12664','2014-02-25','08:30:00',1.45),('12664','2014-02-25','08:35:00',1.54),('12664','2014-02-25','08:40:00',1.64),('12664','2014-02-25','08:45:00',1.74),('12664','2014-02-25','08:50:00',1.84),('12664','2014-02-25','08:55:00',1.89),('12664','2014-02-25','09:00:00',1.98),('12664','2014-02-25','09:05:00',2.07),('12664','2014-02-25','09:10:00',2.16),('12664','2014-02-25','09:15:00',2.23),('12664','2014-02-25','09:20:00',2.31),('12664','2014-02-25','09:25:00',2.36),('12664','2014-02-25','09:30:00',2.42),('12664','2014-02-25','09:35:00',2.49),('12664','2014-02-25','09:40:00',2.55),('12664','2014-02-25','09:45:00',2.62),('12664','2014-02-25','09:50:00',2.66),('12664','2014-02-25','09:55:00',2.7),('12664','2014-02-25','10:00:00',2.76),('12664','2014-02-25','10:05:00',2.82),('12664','2014-02-25','10:10:00',2.89),('12664','2014-02-25','10:15:00',2.95),('12664','2014-02-25','10:20:00',3.03),('12664','2014-02-25','10:25:00',3.04),('12664','2014-02-25','10:30:00',3.1),('12664','2014-02-25','10:35:00',3.13),('12664','2014-02-25','10:40:00',3.16),('12664','2014-02-25','10:45:00',3.17),('12664','2014-02-25','10:50:00',3.24),('12664','2014-02-25','10:55:00',3.28),('12664','2014-02-25','11:00:00',3.35),('12664','2014-02-25','11:05:00',3.36),('12664','2014-02-25','11:10:00',3.35),('12664','2014-02-25','11:15:00',3.37),('12664','2014-02-25','11:20:00',3.4),('12664','2014-02-25','11:25:00',3.42),('12664','2014-02-25','11:30:00',3.46),('12664','2014-02-25','11:35:00',3.49),('12664','2014-02-25','11:40:00',3.52),('12664','2014-02-25','11:45:00',3.53),('12664','2014-02-25','11:50:00',3.56),('12664','2014-02-25','11:55:00',3.56),('12664','2014-02-25','12:00:00',3.57),('12664','2014-02-25','12:05:00',3.56),('12664','2014-02-25','12:10:00',3.55),('12664','2014-02-25','12:15:00',3.57),('12664','2014-02-25','12:20:00',3.58),('12664','2014-02-25','12:25:00',3.58),('12664','2014-02-25','12:30:00',3.57),('12664','2014-02-25','12:35:00',3.59),('12664','2014-02-25','12:40:00',3.57),('12664','2014-02-25','12:45:00',3.53),('12664','2014-02-25','12:50:00',3.5),('12664','2014-02-25','12:55:00',3.49),('12664','2014-02-25','13:00:00',3.47),('12664','2014-02-25','13:05:00',3.45),('12664','2014-02-25','13:10:00',3.42),('12664','2014-02-25','13:15:00',3.38),('12664','2014-02-25','13:20:00',3.36),('12664','2014-02-25','13:25:00',3.4),('12664','2014-02-25','13:30:00',3.42),('12664','2014-02-25','13:35:00',3.4),('12664','2014-02-25','13:40:00',3.19),('12664','2014-02-25','13:45:00',3.22),('12664','2014-02-25','13:50:00',2.85),('12664','2014-02-25','14:00:00',2.66),('12664','2014-02-25','14:05:00',3.14),('12664','2014-02-25','14:10:00',2.94),('12664','2014-02-25','14:15:00',2.86),('12664','2014-02-25','14:20:00',2.74),('12664','2014-02-25','14:25:00',2.45),('12664','2014-02-25','14:30:00',2.35),('12664','2014-02-25','14:35:00',2.53),('12664','2014-02-25','14:40:00',2.6),('12664','2014-02-25','14:45:00',2.42),('12664','2014-02-25','14:50:00',2.51),('12664','2014-02-25','14:55:00',2.58),('12664','2014-02-25','15:00:00',2.42),('12664','2014-02-25','15:05:00',2.42),('12664','2014-02-25','15:10:00',2.31),('12664','2014-02-25','15:15:00',2.15),('12664','2014-02-25','15:20:00',2.11),('12664','2014-02-25','15:25:00',1.97),('12664','2014-02-25','15:30:00',1.92),('12664','2014-02-25','15:35:00',1.27),('12664','2014-02-25','15:45:00',1.08),('12664','2014-02-25','15:50:00',1.33),('12664','2014-02-25','15:55:00',1.2),('12664','2014-02-25','16:00:00',1.23),('12664','2014-02-25','16:05:00',1.03),('12664','2014-04-28','08:05:00',1.4),('12664','2014-04-28','08:10:00',1.7),('12664','2014-04-28','08:15:00',1.74),('12664','2014-04-28','08:20:00',1.17),('12664','2014-04-28','08:25:00',1.13),('12664','2014-04-28','08:40:00',1.04),('12664','2014-04-28','08:50:00',1.05),('12664','2014-04-28','08:55:00',2),('12664','2014-04-28','09:00:00',2.24),('12664','2014-04-28','09:05:00',2.58),('12664','2014-04-28','09:10:00',2.62),('12664','2014-04-28','09:15:00',2.53),('12664','2014-04-28','09:20:00',3.11),('12664','2014-04-28','09:25:00',2.49),('12664','2014-04-28','09:30:00',1.75),('12664','2014-04-28','09:35:00',1.25),('12664','2014-04-28','09:40:00',1.27),('12664','2014-04-28','09:45:00',1.37),('12664','2014-04-28','09:50:00',1.54),('12664','2014-04-28','09:55:00',1.42),('12664','2014-04-28','10:00:00',1.19),('12664','2014-04-28','10:25:00',1.01),('12664','2014-04-28','10:30:00',1.14),('12664','2014-04-28','10:35:00',1.13),('12664','2014-04-28','10:50:00',1.19),('12664','2014-04-28','10:55:00',1.41),('12664','2014-04-28','11:00:00',1.58),('12664','2014-04-28','11:05:00',1.62),('12664','2014-04-28','11:10:00',1.35),('12664','2014-04-28','11:15:00',1.47),('12664','2014-04-28','11:20:00',1.24),('12664','2014-04-28','11:25:00',1.36),('12664','2014-04-28','11:30:00',1.58),('12664','2014-04-28','11:35:00',1.59),('12664','2014-04-28','11:40:00',1.52),('12664','2014-04-28','11:45:00',1.46),('12664','2014-04-28','11:50:00',1.59),('12664','2014-04-28','11:55:00',1.81),('12664','2014-04-28','12:00:00',1.99),('12664','2014-04-28','12:05:00',1.77),('12664','2014-04-28','12:10:00',1.48),('12664','2014-04-28','12:15:00',1.69),('12664','2014-04-28','12:20:00',2.28),('12664','2014-04-28','12:25:00',2.74),('12664','2014-04-28','12:30:00',2.91),('12664','2014-04-28','12:35:00',2.14),('12664','2014-04-28','12:40:00',2.16),('12664','2014-04-28','12:45:00',2.11),('12664','2014-04-28','12:50:00',2.11),('12664','2014-04-28','12:55:00',2.7),('12664','2014-04-28','13:00:00',2.9),('12664','2014-04-28','13:05:00',3.43),('12664','2014-04-28','13:10:00',3.52),('12664','2014-04-28','13:15:00',4.21),('12664','2014-04-28','13:20:00',2.53),('12664','2014-04-28','13:25:00',3.2),('12664','2014-04-28','13:30:00',2.86),('12664','2014-04-28','13:35:00',2.61),('12664','2014-04-28','13:40:00',2.06),('12664','2014-04-28','13:45:00',1.88),('12664','2014-04-28','13:50:00',1.73),('12664','2014-04-28','13:55:00',1.97),('12664','2014-04-28','14:00:00',4.13),('12664','2014-04-28','14:05:00',4.9),('12664','2014-04-28','14:10:00',3.34),('12664','2014-04-28','14:15:00',4.41),('12664','2014-04-28','14:20:00',3.44),('12664','2014-04-28','14:25:00',2.53),('12664','2014-04-28','14:30:00',2.53),('12664','2014-04-28','14:35:00',1.98),('12664','2014-04-28','14:40:00',3.05),('12664','2014-04-28','14:45:00',1.92),('12664','2014-04-28','14:50:00',1.88),('12664','2014-04-28','14:55:00',2.35),('12664','2014-04-28','15:00:00',2.26),('12664','2014-04-28','15:05:00',4.2),('12664','2014-04-28','15:10:00',1.87),('12664','2014-04-28','15:15:00',2.24),('12664','2014-04-28','15:20:00',1.19),('12664','2014-04-28','15:25:00',1.45),('12664','2014-04-28','15:30:00',1.2),('12664','2014-04-28','15:35:00',2.54),('12664','2014-04-28','15:40:00',1.98),('12664','2014-04-28','15:45:00',1.13),('12664','2014-04-28','15:50:00',3.48),('12664','2014-04-28','15:55:00',1.22),('12664','2014-04-28','16:05:00',1.47),('12664','2014-04-28','16:10:00',1.9),('12664','2014-04-28','16:15:00',1.31),('12664','2014-04-28','16:20:00',2.4),('12664','2014-04-28','16:25:00',4.01),('12664','2014-04-28','16:30:00',1.58),('12664','2014-04-28','16:55:00',1.53),('12664','2014-04-28','17:00:00',2.04),('12664','2014-02-24','08:00:00',1.18),('12664','2014-02-24','08:05:00',1.33),('12664','2014-02-24','08:20:00',1.15),('12664','2014-02-24','08:45:00',1.01),('12664','2014-02-24','08:50:00',2.32),('12664','2014-02-24','08:55:00',2.16),('12664','2014-02-24','09:00:00',2.15),('12664','2014-02-24','09:05:00',2.16),('12664','2014-02-24','09:10:00',2.21),('12664','2014-02-24','09:15:00',2.29),('12664','2014-02-24','09:20:00',2.35),('12664','2014-02-24','09:25:00',2.44),('12664','2014-02-24','09:30:00',2.5),('12664','2014-02-24','09:35:00',2.56),('12664','2014-02-24','09:40:00',2.63),('12664','2014-02-24','09:45:00',2.7),('12664','2014-02-24','09:50:00',2.77),('12664','2014-02-24','09:55:00',2.81),('12664','2014-02-24','10:00:00',2.86),('12664','2014-02-24','10:05:00',2.91),('12664','2014-02-24','10:10:00',2.95),('12664','2014-02-24','10:15:00',3.01),('12664','2014-02-24','10:20:00',3.06),('12664','2014-02-24','10:25:00',3.09),('12664','2014-02-24','10:30:00',3.16),('12664','2014-02-24','10:35:00',3.19),('12664','2014-02-24','10:40:00',3.23),('12664','2014-02-24','10:45:00',3.27),('12664','2014-02-24','10:50:00',3.31),('12664','2014-02-24','10:55:00',3.33),('12664','2014-02-24','11:00:00',3.39),('12664','2014-02-24','11:05:00',3.44),('12664','2014-02-24','11:10:00',3.49),('12664','2014-02-24','11:15:00',3.51),('12664','2014-02-24','11:20:00',3.64),('12664','2014-02-24','11:25:00',3.93),('12664','2014-02-24','11:30:00',4.01),('12664','2014-02-24','11:35:00',1.8),('12664','2014-02-24','11:40:00',1.08),('12664','2014-02-24','11:45:00',4.03),('12664','2014-02-24','11:50:00',3.72),('12664','2014-02-24','11:55:00',3.61),('12664','2014-02-24','12:00:00',3.62),('12664','2014-02-24','12:05:00',3.63),('12664','2014-02-24','12:10:00',3.62),('12664','2014-02-24','12:15:00',3.62),('12664','2014-02-24','12:20:00',3.61),('12664','2014-02-24','12:25:00',3.61),('12664','2014-02-24','12:30:00',3.59),('12664','2014-02-24','12:35:00',3.57),('12664','2014-02-24','12:40:00',3.6),('12664','2014-02-24','12:45:00',3.67),('12664','2014-02-24','12:50:00',3.61),('12664','2014-02-24','12:55:00',3.6),('12664','2014-02-24','13:00:00',1.27),('12664','2014-02-24','13:05:00',2.89),('12664','2014-02-24','13:10:00',3.5),('12664','2014-02-24','13:15:00',3.19),('12664','2014-02-24','13:20:00',1.21),('12664','2014-02-24','13:25:00',1.06),('12664','2014-02-24','13:30:00',1.06),('12664','2014-02-24','13:35:00',1.14),('12664','2014-02-24','13:40:00',1.08),('12664','2014-02-24','13:45:00',1.02),('12664','2014-02-24','13:55:00',1.13),('12664','2014-02-24','14:00:00',1.23),('12664','2014-02-24','14:05:00',1.14),('12664','2014-02-24','14:10:00',1.05),('12664','2014-02-24','14:15:00',1.13),('12664','2014-02-24','14:20:00',1.2),('12664','2014-02-24','14:25:00',1.03),('12664','2014-02-24','14:55:00',1.04),('12664','2014-02-24','15:00:00',1.23),('12664','2014-02-24','15:05:00',1.91),('12664','2014-02-24','15:10:00',2.18),('12664','2014-02-24','15:15:00',2.18),('12664','2014-02-24','15:20:00',2.01),('12664','2014-02-24','15:25:00',2.32),('12664','2014-02-24','15:30:00',2.18),('12664','2014-02-24','15:35:00',1.95),('12664','2014-02-24','15:40:00',1.87),('12664','2014-02-24','15:45:00',1.87),('12664','2014-02-24','15:50:00',1.77),('12664','2014-02-24','15:55:00',1.67),('12664','2014-02-24','16:00:00',1.6),('12664','2014-02-24','16:05:00',1.57),('12664','2014-02-24','16:10:00',1.56),('12664','2014-02-24','16:30:00',1.04),('12664','2014-02-23','08:10:00',1.06),('12664','2014-02-23','08:15:00',1.14),('12664','2014-02-23','08:20:00',1.22),('12664','2014-02-23','08:25:00',1.32),('12664','2014-02-23','08:30:00',1.41),('12664','2014-02-23','08:35:00',1.51),('12664','2014-02-23','08:40:00',1.62),('12664','2014-02-23','08:45:00',1.71),('12664','2014-02-23','08:50:00',1.81),('12664','2014-02-23','08:55:00',1.92),('12664','2014-02-23','09:00:00',2.01),('12664','2014-02-23','09:05:00',2.1),('12664','2014-02-23','09:10:00',2.21),('12664','2014-02-23','09:15:00',2.26),('12664','2014-02-23','09:20:00',2.16),('12664','2014-02-23','09:25:00',2.23),('12664','2014-02-23','09:30:00',2.46),('12664','2014-02-23','09:35:00',2.53),('12664','2014-02-23','09:40:00',2.56),('12664','2014-02-23','09:45:00',2.63),('12664','2014-02-23','09:50:00',2.68),('12664','2014-02-23','09:55:00',2.71),('12664','2014-02-23','10:00:00',2.79),('12664','2014-02-23','10:05:00',2.85),('12664','2014-02-23','10:10:00',2.9),('12664','2014-02-23','10:15:00',2.96),('12664','2014-02-23','10:20:00',3.01),('12664','2014-02-23','10:25:00',3.07),('12664','2014-02-23','10:30:00',3.12),('12664','2014-02-23','10:35:00',3.17),('12664','2014-02-23','10:40:00',3.22),('12664','2014-02-23','10:45:00',3.25),('12664','2014-02-23','10:50:00',3.3),('12664','2014-02-23','10:55:00',3.33),('12664','2014-02-23','11:00:00',3.35),('12664','2014-02-23','11:05:00',3.38),('12664','2014-02-23','11:10:00',3.4),('12664','2014-02-23','11:15:00',3.46),('12664','2014-02-23','11:20:00',3.5),('12664','2014-02-23','11:25:00',3.55),('12664','2014-02-23','11:30:00',3.57),('12664','2014-02-23','11:35:00',3.59),('12664','2014-02-23','11:40:00',3.61),('12664','2014-02-23','11:45:00',3.67),('12664','2014-02-23','11:50:00',3.64),('12664','2014-02-23','11:55:00',2.75),('12664','2014-02-23','12:00:00',3.74),('12664','2014-02-23','12:05:00',3.93),('12664','2014-02-23','12:10:00',3.53),('12664','2014-02-23','12:15:00',2.33),('12664','2014-02-23','12:20:00',2.21),('12664','2014-02-23','12:25:00',3.81),('12664','2014-02-23','12:30:00',1.81),('12664','2014-02-23','12:35:00',2.62),('12664','2014-02-23','12:40:00',1.93),('12664','2014-02-23','12:45:00',2.91),('12664','2014-02-23','12:50:00',3.77),('12664','2014-02-23','12:55:00',3.68),('12664','2014-02-23','13:00:00',3.59),('12664','2014-02-23','13:05:00',3.62),('12664','2014-02-23','13:10:00',3.55),('12664','2014-02-23','13:15:00',3.54),('12664','2014-02-23','13:20:00',3.05),('12664','2014-02-23','13:25:00',3.44),('12664','2014-02-23','13:30:00',2.65),('12664','2014-02-23','13:35:00',3.17),('12664','2014-02-23','13:40:00',2.47),('12664','2014-02-23','13:45:00',2.42),('12664','2014-02-23','13:50:00',2.03),('12664','2014-02-23','13:55:00',2.47),('12664','2014-02-23','14:00:00',2.7),('12664','2014-02-23','14:05:00',1.4),('12664','2014-02-23','14:10:00',2.65),('12664','2014-02-23','14:15:00',3.23),('12664','2014-02-23','14:20:00',2.97),('12664','2014-02-23','14:25:00',2.16),('12664','2014-02-23','14:30:00',1.67),('12664','2014-02-23','14:35:00',3.62),('12664','2014-02-23','14:40:00',3.55),('12664','2014-02-23','14:45:00',2.48),('12664','2014-02-23','14:50:00',1.07),('12664','2014-02-23','15:00:00',1.04),('12664','2014-02-23','15:10:00',2.25),('12664','2014-02-23','15:15:00',2.1),('12664','2014-02-23','15:25:00',2.3),('12664','2014-02-23','15:30:00',2.29),('12664','2014-02-23','15:35:00',2.58),('12664','2014-02-23','15:40:00',2.42),('12664','2014-02-23','15:45:00',2.51),('12664','2014-02-23','15:50:00',2.49),('12664','2014-02-23','15:55:00',2.41),('12664','2014-02-23','16:00:00',2.56),('12664','2014-02-23','16:05:00',2.25),('12664','2014-02-23','16:10:00',1.82),('12664','2014-02-23','16:15:00',1.16),('12664','2014-02-22','09:15:00',1.14),('12664','2014-02-22','09:25:00',1.08),('12664','2014-02-22','09:30:00',1.03),('12664','2014-02-22','09:35:00',1.08),('12664','2014-02-22','09:40:00',1.64),('12664','2014-02-22','09:45:00',1.82),('12664','2014-02-22','09:50:00',2.29),('12664','2014-02-22','09:55:00',1.26),('12664','2014-02-22','10:00:00',1.83),('12664','2014-02-22','10:05:00',1.1),('12664','2014-02-22','10:20:00',2),('12664','2014-02-22','10:25:00',2.32),('12664','2014-02-22','10:30:00',1.44),('12664','2014-02-22','10:35:00',1.81),('12664','2014-02-22','10:40:00',1.34),('12664','2014-02-22','12:00:00',1.19),('12664','2014-02-22','12:05:00',1.2),('12664','2014-02-22','12:10:00',1.39),('12664','2014-02-22','12:15:00',1.15),('12664','2014-02-22','12:20:00',1.42),('12664','2014-02-22','12:25:00',1.34),('12664','2014-02-22','12:30:00',2.45),('12664','2014-02-22','12:35:00',3.45),('12664','2014-02-22','12:40:00',3.98),('12664','2014-02-22','12:45:00',4.03),('12664','2014-02-22','12:50:00',2.36),('12664','2014-02-22','12:55:00',3.95),('12664','2014-02-22','13:00:00',3.15),('12664','2014-02-22','13:15:00',1.2),('12664','2014-02-22','13:20:00',2.37),('12664','2014-02-22','13:25:00',2.73),('12664','2014-02-22','13:30:00',2.23),('12664','2014-02-22','13:35:00',3.93),('12664','2014-02-22','13:40:00',3.02),('12664','2014-02-22','13:45:00',2.05),('12664','2014-02-22','13:50:00',1.29),('12664','2014-02-22','13:55:00',1.13),('12664','2014-02-22','14:00:00',1.35),('12664','2014-02-22','14:05:00',2.29),('12664','2014-02-22','14:10:00',1.56),('12664','2014-02-22','14:15:00',3.17),('12664','2014-02-22','14:20:00',3.07),('12664','2014-02-22','14:25:00',1.75),('12664','2014-02-22','14:30:00',2.13),('12664','2014-02-22','14:35:00',2.54),('12664','2014-02-22','14:40:00',1.76),('12664','2014-02-22','14:45:00',1.51),('12664','2014-02-22','14:50:00',2.08),('12664','2014-02-22','14:55:00',2.48),('12664','2014-02-22','15:00:00',1.92),('12664','2014-02-22','15:05:00',1.93),('12664','2014-02-22','15:10:00',1.87),('12664','2014-02-22','15:15:00',2.37),('12664','2014-02-22','15:20:00',1.75),('12664','2014-02-22','15:25:00',1.41),('12664','2014-02-22','15:35:00',1.67),('12664','2014-02-22','15:40:00',2.36),('12664','2014-02-22','15:45:00',1.55),('12664','2014-02-22','15:50:00',1.71),('12664','2014-02-22','15:55:00',1.74),('12664','2014-02-22','16:00:00',1.65),('12664','2014-02-22','16:05:00',1.45),('12664','2014-02-22','16:10:00',1.07),('12664','2014-02-22','16:15:00',1.2),('12664','2014-02-22','16:20:00',1.19),('12664','2014-02-22','16:25:00',1.08),('12664','2014-02-21','09:10:00',1),('12664','2014-02-21','09:15:00',1.04),('12664','2014-02-21','09:20:00',1.08),('12664','2014-02-21','09:25:00',1.06),('12664','2014-02-21','09:35:00',1),('12664','2014-02-21','09:40:00',1),('12664','2014-02-21','09:45:00',1.02),('12664','2014-02-21','09:50:00',1.13),('12664','2014-02-21','09:55:00',1.29),('12664','2014-02-21','10:00:00',1.41),('12664','2014-02-21','10:05:00',1.74),('12664','2014-02-21','10:10:00',2.16),('12664','2014-02-21','10:15:00',1.83),('12664','2014-02-21','10:20:00',1.78),('12664','2014-02-21','10:25:00',1.79),('12664','2014-02-21','10:30:00',1.38),('12664','2014-02-21','10:35:00',1.27),('12664','2014-02-21','10:40:00',1.8),('12664','2014-02-21','10:45:00',2.38),('12664','2014-02-21','10:50:00',3.6),('12664','2014-02-21','10:55:00',3.57),('12664','2014-02-21','11:00:00',3.48),('12664','2014-02-21','11:05:00',3.76),('12664','2014-02-21','11:10:00',3.56),('12664','2014-02-21','11:15:00',4.09),('12664','2014-02-21','11:20:00',2.5),('12664','2014-02-21','11:25:00',2.04),('12664','2014-02-21','11:30:00',3.01),('12664','2014-02-21','11:35:00',3.87),('12664','2014-02-21','11:40:00',4.04),('12664','2014-02-21','11:45:00',1.36),('12664','2014-02-21','11:50:00',1.06),('12664','2014-02-21','11:55:00',3.14),('12664','2014-02-21','12:00:00',1.63),('12664','2014-02-21','12:05:00',1.47),('12664','2014-02-21','12:10:00',1.32),('12664','2014-02-21','12:15:00',1.36),('12664','2014-02-21','12:20:00',1.12),('12664','2014-02-21','14:05:00',1.26),('12664','2014-02-21','14:10:00',1.57),('12664','2014-02-21','14:15:00',1.3),('12664','2014-02-21','14:20:00',1.14),('12664','2014-02-21','14:25:00',2.14),('12664','2014-02-21','14:30:00',2.52),('12664','2014-02-21','14:35:00',2.92),('12664','2014-02-21','14:40:00',3.16),('12664','2014-02-21','14:45:00',1.95),('12664','2014-02-21','14:50:00',1.67),('12664','2014-02-21','14:55:00',2.65),('12664','2014-02-21','15:00:00',3.02),('12664','2014-02-21','15:05:00',2.75),('12664','2014-02-21','15:10:00',1.65),('12664','2014-02-21','15:15:00',2.19),('12664','2014-02-21','15:20:00',2.19),('12664','2014-02-21','15:25:00',2.05),('12664','2014-02-21','15:30:00',1.93),('12664','2014-02-21','15:35:00',1.82),('12664','2014-02-21','15:40:00',1.74),('12664','2014-02-21','15:45:00',1.65),('12664','2014-02-21','15:50:00',1.59),('12664','2014-02-21','15:55:00',1.32),('12664','2014-02-21','16:00:00',1.44),('12664','2014-02-21','16:05:00',1.34),('12664','2014-02-21','16:10:00',1.24),('12664','2014-02-21','16:15:00',1.16),('12664','2014-02-21','16:20:00',1.07),('12664','2014-02-20','10:15:00',1.02),('12664','2014-02-20','10:20:00',1.07),('12664','2014-02-20','10:25:00',1.05),('12664','2014-02-20','10:35:00',1.06),('12664','2014-02-20','10:40:00',1.18),('12664','2014-02-20','10:45:00',1.14),('12664','2014-02-20','10:50:00',1.08),('12664','2014-02-20','10:55:00',1.11),('12664','2014-02-20','11:00:00',1.08),('12664','2014-02-20','11:25:00',1.19),('12664','2014-02-20','11:30:00',1.37),('12664','2014-02-20','11:35:00',1.31),('12664','2014-02-20','11:40:00',1.16),('12664','2014-02-20','12:00:00',1.07),('12664','2014-02-20','13:00:00',1.12),('12664','2014-02-20','13:05:00',1.04),('12664','2014-02-20','13:10:00',1.32),('12664','2014-02-20','13:15:00',1.24),('12664','2014-02-20','13:25:00',1.17),('12664','2014-02-20','13:30:00',1.13),('12664','2014-02-20','13:35:00',1.15),('12664','2014-02-20','13:40:00',1.23),('12664','2014-02-20','13:45:00',1.12),('12664','2014-02-20','13:50:00',1.25),('12664','2014-02-20','13:55:00',1.05),('12664','2014-02-20','14:00:00',1.12),('12664','2014-02-20','14:05:00',1.04),('12664','2014-02-20','14:10:00',1.06),('12664','2014-02-19','09:40:00',1.05),('12664','2014-02-19','09:45:00',1.4),('12664','2014-02-19','09:50:00',1.3),('12664','2014-02-19','09:55:00',1.14),('12664','2014-02-19','10:00:00',1.22),('12664','2014-02-19','10:05:00',1.31),('12664','2014-02-19','10:10:00',1.28),('12664','2014-02-19','10:15:00',1.42),('12664','2014-02-19','10:20:00',1.35),('12664','2014-02-19','10:25:00',1.23),('12664','2014-02-19','10:30:00',1.1),('12664','2014-02-19','10:35:00',1.13),('12664','2014-02-19','10:40:00',1.22),('12664','2014-02-19','10:45:00',1.23),('12664','2014-02-19','10:50:00',1.27),('12664','2014-02-19','10:55:00',1.28),('12664','2014-02-19','11:00:00',1.17),('12664','2014-02-19','11:10:00',1.09),('12664','2014-02-19','11:15:00',1.32),('12664','2014-02-19','11:20:00',1.34),('12664','2014-02-19','11:25:00',1.25),('12664','2014-02-19','11:40:00',1.49),('12664','2014-02-19','11:45:00',1.62),('12664','2014-02-19','11:50:00',1.62),('12664','2014-02-19','11:55:00',1.36),('12664','2014-02-19','12:00:00',1.29),('12664','2014-02-19','12:05:00',1.29),('12664','2014-02-19','12:10:00',1.17),('12664','2014-02-19','13:00:00',1.11),('12664','2014-02-19','13:05:00',1.15),('12664','2014-02-19','13:10:00',1.24),('12664','2014-02-19','13:15:00',1.39),('12664','2014-02-19','13:20:00',1.37),('12664','2014-02-19','13:25:00',1.23),('12664','2014-02-19','13:30:00',1.55),('12664','2014-02-19','13:35:00',1.81),('12664','2014-02-19','13:40:00',1.63),('12664','2014-02-19','13:45:00',1.97),('12664','2014-02-19','13:50:00',1.92),('12664','2014-02-19','13:55:00',1.98),('12664','2014-02-19','14:00:00',1.49),('12664','2014-02-19','14:05:00',1.11),('12664','2014-02-19','14:15:00',1),('12664','2014-02-19','14:20:00',1.07),('12664','2014-02-19','14:25:00',1.34),('12664','2014-02-19','14:30:00',1.51),('12664','2014-02-18','08:15:00',1.05),('12664','2014-02-18','08:20:00',1.13),('12664','2014-02-18','08:25:00',1.23),('12664','2014-02-18','08:30:00',1.33),('12664','2014-02-18','08:35:00',1.42),('12664','2014-02-18','08:40:00',1.51),('12664','2014-02-18','08:45:00',1.61),('12664','2014-02-18','08:50:00',1.69),('12664','2014-02-18','08:55:00',1.78),('12664','2014-02-18','09:00:00',1.86),('12664','2014-02-18','09:05:00',1.94),('12664','2014-02-18','09:10:00',2.01),('12664','2014-02-18','09:15:00',2.09),('12664','2014-02-18','09:20:00',2.17),('12664','2014-02-18','09:25:00',2.21),('12664','2014-02-18','09:30:00',2.3),('12664','2014-02-18','09:35:00',2.37),('12664','2014-02-18','09:40:00',2.42),('12664','2014-02-18','09:45:00',2.5),('12664','2014-02-18','09:50:00',2.56),('12664','2014-02-18','09:55:00',2.62),('12664','2014-02-18','10:00:00',2.68),('12664','2014-02-18','10:05:00',2.73),('12664','2014-02-18','10:10:00',2.78),('12664','2014-02-18','10:15:00',2.84),('12664','2014-02-18','10:20:00',2.89),('12664','2014-02-18','10:25:00',2.93),('12664','2014-02-18','10:30:00',2.97),('12664','2014-02-18','10:35:00',3),('12664','2014-02-18','10:40:00',3.04),('12664','2014-02-18','10:45:00',3.08),('12664','2014-02-18','10:50:00',3.13),('12664','2014-02-18','10:55:00',3.19),('12664','2014-02-18','11:00:00',3.25),('12664','2014-02-18','11:05:00',3.13),('12664','2014-02-18','11:10:00',2.92),('12664','2014-02-18','11:15:00',2.94),('12664','2014-02-18','11:20:00',3.34),('12664','2014-02-18','11:25:00',3.24),('12664','2014-02-18','11:30:00',2.09),('12664','2014-02-18','11:35:00',1.56),('12664','2014-02-18','11:40:00',1.65),('12664','2014-02-18','11:45:00',1.4),('12664','2014-02-18','11:50:00',1.25),('12664','2014-02-18','11:55:00',1.35),('12664','2014-02-18','12:00:00',1.39),('12664','2014-02-18','12:05:00',1.36),('12664','2014-02-18','12:10:00',1.39),('12664','2014-02-18','12:15:00',1.53),('12664','2014-02-18','12:20:00',1.78),('12664','2014-02-18','12:25:00',1.93),('12664','2014-02-18','12:30:00',1.67),('12664','2014-02-18','12:35:00',1.48),('12664','2014-02-18','12:40:00',1.42),('12664','2014-02-18','12:45:00',1.37),('12664','2014-02-18','12:50:00',1.25),('12664','2014-02-18','12:55:00',1.32),('12664','2014-02-18','13:00:00',1.29),('12664','2014-02-18','13:05:00',1.2),('12664','2014-02-18','13:10:00',1.22),('12664','2014-02-18','13:15:00',1.5),('12664','2014-02-18','13:20:00',2.25),('12664','2014-02-18','13:25:00',2.81),('12664','2014-02-18','13:30:00',1.87),('12664','2014-02-18','13:35:00',1.63),('12664','2014-02-18','13:40:00',1.84),('12664','2014-02-18','13:45:00',2.01),('12664','2014-02-18','13:50:00',1.56),('12664','2014-02-18','13:55:00',1.46),('12664','2014-02-18','14:00:00',1.47),('12664','2014-02-18','14:05:00',1.82),('12664','2014-02-18','14:10:00',1.66),('12664','2014-02-18','14:15:00',1.39),('12664','2014-02-18','14:20:00',1.13),('12664','2014-02-18','14:25:00',1.05),('12664','2014-02-18','14:30:00',1.19),('12664','2014-02-18','14:35:00',1.18),('12664','2014-02-18','14:40:00',1.04),('12664','2014-02-18','15:35:00',1.18),('12664','2014-02-18','15:40:00',1.08),('12664','2014-02-18','16:00:00',1.04),('12664','2014-02-18','16:05:00',1),('12664','2014-02-17','08:25:00',1.07),('12664','2014-02-17','08:30:00',1.18),('12664','2014-02-17','08:35:00',1.26),('12664','2014-02-17','08:40:00',1.32),('12664','2014-02-17','08:45:00',1.39),('12664','2014-02-17','08:50:00',1.46),('12664','2014-02-17','08:55:00',1.56),('12664','2014-02-17','09:00:00',1.63),('12664','2014-02-17','09:05:00',1.72),('12664','2014-02-17','09:10:00',1.8),('12664','2014-02-17','09:15:00',1.88),('12664','2014-02-17','09:20:00',1.96),('12664','2014-02-17','09:25:00',2.04),('12664','2014-02-17','09:30:00',2.12),('12664','2014-02-17','09:35:00',2.2),('12664','2014-02-17','09:40:00',2.24),('12664','2014-02-17','09:45:00',2.3),('12664','2014-02-17','09:50:00',2.34),('12664','2014-02-17','09:55:00',2.4),('12664','2014-02-17','10:00:00',2.44),('12664','2014-02-17','10:05:00',2.48),('12664','2014-02-17','10:10:00',2.53),('12664','2014-02-17','10:15:00',2.59),('12664','2014-02-17','10:20:00',2.64),('12664','2014-02-17','10:25:00',2.68),('12664','2014-02-17','10:30:00',2.71),('12664','2014-02-17','10:35:00',2.75),('12664','2014-02-17','10:40:00',2.79),('12664','2014-02-17','10:45:00',2.79),('12664','2014-02-17','10:50:00',2.8),('12664','2014-02-17','10:55:00',2.84),('12664','2014-02-17','11:00:00',2.85),('12664','2014-02-17','11:05:00',2.86),('12664','2014-02-17','11:10:00',2.88),('12664','2014-02-17','11:15:00',2.91),('12664','2014-02-17','11:20:00',2.92),('12664','2014-02-17','11:25:00',2.92),('12664','2014-02-17','11:30:00',2.93),('12664','2014-02-17','11:35:00',2.95),('12664','2014-02-17','11:40:00',2.95),('12664','2014-02-17','11:45:00',2.98),('12664','2014-02-17','11:50:00',3.04),('12664','2014-02-17','11:55:00',3.09),('12664','2014-02-17','12:00:00',3.15),('12664','2014-02-17','12:05:00',3.19),('12664','2014-02-17','12:10:00',3.2),('12664','2014-02-17','12:15:00',3.2),('12664','2014-02-17','12:20:00',3.23),('12664','2014-02-17','12:25:00',3.22),('12664','2014-02-17','12:30:00',3.2),('12664','2014-02-17','12:35:00',3.18),('12664','2014-02-17','12:40:00',3.17),('12664','2014-02-17','12:45:00',3.18),('12664','2014-02-17','12:50:00',3.17),('12664','2014-02-17','12:55:00',3.13),('12664','2014-02-17','13:00:00',3.11),('12664','2014-02-17','13:05:00',3.11),('12664','2014-02-17','13:10:00',3.1),('12664','2014-02-17','13:15:00',3.08),('12664','2014-02-17','13:20:00',3.06),('12664','2014-02-17','13:25:00',3.03),('12664','2014-02-17','13:30:00',2.98),('12664','2014-02-17','13:35:00',2.91),('12664','2014-02-17','13:40:00',2.93),('12664','2014-02-17','13:45:00',2.89),('12664','2014-02-17','13:50:00',2.86),('12664','2014-02-17','13:55:00',2.84),('12664','2014-02-17','14:00:00',2.77),('12664','2014-02-17','14:05:00',2.76),('12664','2014-02-17','14:10:00',2.6),('12664','2014-02-17','14:15:00',2.69),('12664','2014-02-17','14:20:00',2.63),('12664','2014-02-17','14:25:00',2.54),('12664','2014-02-17','14:30:00',2.44),('12664','2014-02-17','14:35:00',2.36),('12664','2014-02-17','14:40:00',2.34),('12664','2014-02-17','14:45:00',2.3),('12664','2014-02-17','14:50:00',2.26),('12664','2014-02-17','14:55:00',2.21),('12664','2014-02-17','15:00:00',2.14),('12664','2014-02-17','15:05:00',1.97),('12664','2014-02-17','15:10:00',1.86),('12664','2014-02-17','15:15:00',1.95),('12664','2014-02-17','15:20:00',1.82),('12664','2014-02-17','15:25:00',1.79),('12664','2014-02-17','15:30:00',1.76),('12664','2014-02-17','15:35:00',1.62),('12664','2014-02-17','15:40:00',1.6),('12664','2014-02-17','15:45:00',1.51),('12664','2014-02-17','15:50:00',1.43),('12664','2014-02-17','15:55:00',1.36),('12664','2014-02-17','16:00:00',1.22),('12664','2014-02-17','16:05:00',1.18),('12664','2014-02-17','16:10:00',1.08),('12664','2014-02-16','08:15:00',1.03),('12664','2014-02-16','08:20:00',1.13),('12664','2014-02-16','08:25:00',1.22),('12664','2014-02-16','08:30:00',1.32),('12664','2014-02-16','08:35:00',1.32),('12664','2014-02-16','08:40:00',1.47),('12664','2014-02-16','08:45:00',1.57),('12664','2014-02-16','08:50:00',1.72),('12664','2014-02-16','08:55:00',1.84),('12664','2014-02-16','09:00:00',1.84),('12664','2014-02-16','09:05:00',1.81),('12664','2014-02-16','09:10:00',1.85),('12664','2014-02-16','09:15:00',2.09),('12664','2014-02-16','09:20:00',2.06),('12664','2014-02-16','09:25:00',2.02),('12664','2014-02-16','09:30:00',1.86),('12664','2014-02-16','09:35:00',2.34),('12664','2014-02-16','09:40:00',2.31),('12664','2014-02-16','09:45:00',2.46),('12664','2014-02-16','09:50:00',2.41),('12664','2014-02-16','09:55:00',2.51),('12664','2014-02-16','10:00:00',2.52),('12664','2014-02-16','10:05:00',2.7),('12664','2014-02-16','10:10:00',2.73),('12664','2014-02-16','10:15:00',2.66),('12664','2014-02-16','10:20:00',2.8),('12664','2014-02-16','10:25:00',2.92),('12664','2014-02-16','10:30:00',3.02),('12664','2014-02-16','10:35:00',3.06),('12664','2014-02-16','10:40:00',3.03),('12664','2014-02-16','10:45:00',2.93),('12664','2014-02-16','10:50:00',2.83),('12664','2014-02-16','10:55:00',3.14),('12664','2014-02-16','11:00:00',3.05),('12664','2014-02-16','11:05:00',2.85),('12664','2014-02-16','11:10:00',3.07),('12664','2014-02-16','11:15:00',2.93),('12664','2014-02-16','11:20:00',2.73),('12664','2014-02-16','11:25:00',3.07),('12664','2014-02-16','11:30:00',3.31),('12664','2014-02-16','11:35:00',3.21),('12664','2014-02-16','11:40:00',2.92),('12664','2014-02-16','11:45:00',3.09),('12664','2014-02-16','11:50:00',3.17),('12664','2014-02-16','11:55:00',3.36),('12664','2014-02-16','12:00:00',3.3),('12664','2014-02-16','12:05:00',3.35),('12664','2014-02-16','12:10:00',3.37),('12664','2014-02-16','12:15:00',3.35),('12664','2014-02-16','12:20:00',3.33),('12664','2014-02-16','12:25:00',3.31),('12664','2014-02-16','12:30:00',3.31),('12664','2014-02-16','12:35:00',3.27),('12664','2014-02-16','12:40:00',3.26),('12664','2014-02-16','12:45:00',3.24),('12664','2014-02-16','12:50:00',3.24),('12664','2014-02-16','12:55:00',3.25),('12664','2014-02-16','13:00:00',3.28),('12664','2014-02-16','13:05:00',3.08),('12664','2014-02-16','13:10:00',3.26),('12664','2014-02-16','13:15:00',3.23),('12664','2014-02-16','13:20:00',3.16),('12664','2014-02-16','13:25:00',3.11),('12664','2014-02-16','13:30:00',3.11),('12664','2014-02-16','13:35:00',3.07),('12664','2014-02-16','13:40:00',3.12),('12664','2014-02-16','13:45:00',2.94),('12664','2014-02-16','13:50:00',3.01),('12664','2014-02-16','13:55:00',3.03),('12664','2014-02-16','14:00:00',3),('12664','2014-02-16','14:05:00',2.96),('12664','2014-02-16','14:10:00',2.91),('12664','2014-02-16','14:15:00',2.88),('12664','2014-02-16','14:20:00',2.77),('12664','2014-02-16','14:25:00',2.82),('12664','2014-02-16','14:30:00',2.73),('12664','2014-02-16','14:35:00',2.58),('12664','2014-02-16','14:40:00',2.63),('12664','2014-02-16','14:45:00',2.58),('12664','2014-02-16','14:50:00',2.14),('12664','2014-02-16','14:55:00',2.02),('12664','2014-02-16','15:00:00',2.36),('12664','2014-02-16','15:05:00',2.32),('12664','2014-02-16','15:10:00',2.24),('12664','2014-02-16','15:15:00',2.15),('12664','2014-02-16','15:20:00',2.08),('12664','2014-02-16','15:25:00',2),('12664','2014-02-16','15:30:00',1.82),('12664','2014-02-16','15:35:00',1.66),('12664','2014-02-16','16:10:00',1.32),('12664','2014-02-16','16:15:00',1.24),('12664','2014-02-16','16:20:00',1.39),('12664','2014-02-16','16:25:00',1.24),('12664','2014-02-15','08:20:00',1.04),('12664','2014-02-15','08:25:00',1.13),('12664','2014-02-15','08:30:00',1.22),('12664','2014-02-15','08:35:00',1.32),('12664','2014-02-15','08:40:00',1.42),('12664','2014-02-15','08:45:00',1.5),('12664','2014-02-15','08:50:00',1.6),('12664','2014-02-15','08:55:00',1.69),('12664','2014-02-15','09:00:00',1.78),('12664','2014-02-15','09:05:00',1.85),('12664','2014-02-15','09:10:00',1.93),('12664','2014-02-15','09:15:00',2.01),('12664','2014-02-15','09:20:00',2.09),('12664','2014-02-15','09:25:00',2.16),('12664','2014-02-15','09:30:00',2.23),('12664','2014-02-15','09:35:00',2.29),('12664','2014-02-15','09:40:00',2.35),('12664','2014-02-15','09:45:00',2.41),('12664','2014-02-15','09:50:00',2.46),('12664','2014-02-15','09:55:00',2.5),('12664','2014-02-15','10:00:00',2.55),('12664','2014-02-15','10:05:00',2.6),('12664','2014-02-15','10:10:00',2.63),('12664','2014-02-15','10:15:00',2.65),('12664','2014-02-15','10:20:00',2.65),('12664','2014-02-15','10:25:00',2.72),('12664','2014-02-15','10:30:00',2.77),('12664','2014-02-15','10:35:00',2.81),('12664','2014-02-15','10:40:00',2.8),('12664','2014-02-15','10:45:00',2.77),('12664','2014-02-15','10:50:00',2.92),('12664','2014-02-15','10:55:00',2.92),('12664','2014-02-15','11:00:00',2.97),('12664','2014-02-15','11:05:00',3.01),('12664','2014-02-15','11:10:00',3.04),('12664','2014-02-15','11:15:00',3.06),('12664','2014-02-15','11:20:00',3.09),('12664','2014-02-15','11:25:00',3.11),('12664','2014-02-15','11:30:00',3.05),('12664','2014-02-15','11:35:00',3.13),('12664','2014-02-15','11:40:00',2.71),('12664','2014-02-15','11:45:00',2.55),('12664','2014-02-15','11:50:00',1.63),('12664','2014-02-15','11:55:00',3.41),('12664','2014-02-15','12:00:00',3.5),('12664','2014-02-15','12:05:00',2.63),('12664','2014-02-15','12:10:00',3.14),('12664','2014-02-15','12:15:00',3.54),('12664','2014-02-15','12:20:00',3.64),('12664','2014-02-15','12:25:00',3.68),('12664','2014-02-15','12:30:00',3.5),('12664','2014-02-15','12:35:00',2.61),('12664','2014-02-15','12:40:00',3.46),('12664','2014-02-15','12:45:00',2.86),('12664','2014-02-15','12:50:00',3.36),('12664','2014-02-15','12:55:00',3.29),('12664','2014-02-15','13:00:00',3.49),('12664','2014-02-15','13:05:00',3.34),('12664','2014-02-15','13:10:00',3.33),('12664','2014-02-15','13:15:00',3.34),('12664','2014-02-15','13:20:00',3.28),('12664','2014-02-15','13:25:00',3.28),('12664','2014-02-15','13:30:00',2.73),('12664','2014-02-15','13:35:00',2.28),('12664','2014-02-15','13:40:00',3.02),('12664','2014-02-15','13:45:00',3.13),('12664','2014-02-15','13:50:00',3.06),('12664','2014-02-15','13:55:00',2.99),('12664','2014-02-15','14:00:00',2.94),('12664','2014-02-15','14:05:00',2.9),('12664','2014-02-15','14:10:00',2.86),('12664','2014-02-15','14:15:00',2.83),('12664','2014-02-15','14:20:00',2.78),('12664','2014-02-15','14:25:00',2.71),('12664','2014-02-15','14:30:00',2.63),('12664','2014-02-15','14:35:00',2.6),('12664','2014-02-15','14:40:00',2.53),('12664','2014-02-15','14:45:00',2.47),('12664','2014-02-15','14:50:00',2.43),('12664','2014-02-15','14:55:00',2.36),('12664','2014-02-15','15:00:00',2.27),('12664','2014-02-15','15:05:00',2.22),('12664','2014-02-15','15:10:00',2.16),('12664','2014-02-15','15:15:00',2.1),('12664','2014-02-15','15:20:00',2.01),('12664','2014-02-15','15:25:00',1.93),('12664','2014-02-15','15:30:00',1.85),('12664','2014-02-15','15:35:00',1.78),('12664','2014-02-15','15:40:00',1.7),('12664','2014-02-15','15:45:00',1.62),('12664','2014-02-15','15:50:00',1.53),('12664','2014-02-15','15:55:00',1.44),('12664','2014-02-15','16:00:00',1.35),('12664','2014-02-15','16:05:00',1.28),('12664','2014-02-15','16:10:00',1.18),('12664','2014-02-15','16:15:00',1.1),('12664','2014-04-27','08:45:00',1.11),('12664','2014-04-27','08:50:00',1.09),('12664','2014-04-27','10:05:00',1.2),('12664','2014-04-27','10:10:00',1.14),('12664','2014-04-27','10:15:00',1.2),('12664','2014-04-27','10:20:00',1.22),('12664','2014-04-27','10:35:00',1.23),('12664','2014-04-27','10:40:00',1.03),('12664','2014-04-27','11:00:00',1.13),('12664','2014-04-27','11:05:00',1.22),('12664','2014-04-27','11:20:00',1.1),('12664','2014-04-27','11:25:00',2.77),('12664','2014-04-27','11:30:00',2.85),('12664','2014-04-27','11:35:00',2.7),('12664','2014-04-27','11:40:00',2.43),('12664','2014-04-27','11:45:00',1.8),('12664','2014-04-27','11:50:00',1.26),('12664','2014-04-27','11:55:00',1.65),('12664','2014-04-27','12:00:00',1.38),('12664','2014-04-27','12:05:00',1.8),('12664','2014-04-27','12:10:00',1.63),('12664','2014-04-27','12:15:00',1.12),('12664','2014-04-27','12:20:00',1.18),('12664','2014-04-27','12:25:00',1.71),('12664','2014-04-27','12:30:00',2.98),('12664','2014-04-27','12:35:00',2.83),('12664','2014-04-27','12:40:00',2.12),('12664','2014-04-27','12:45:00',2.27),('12664','2014-04-27','12:50:00',1.42),('12664','2014-04-27','12:55:00',1.05),('12664','2014-04-27','13:00:00',1.39),('12664','2014-04-27','13:05:00',1.59),('12664','2014-04-27','13:10:00',1.38),('12664','2014-04-27','13:15:00',1.68),('12664','2014-04-27','13:20:00',1.84),('12664','2014-04-27','13:25:00',2.54),('12664','2014-04-27','13:30:00',1.91),('12664','2014-04-27','13:35:00',1.15),('12664','2014-04-27','13:40:00',1.17),('12664','2014-04-27','13:45:00',1.31),('12664','2014-04-27','13:50:00',2.34),('12664','2014-04-27','13:55:00',1.61),('12664','2014-04-27','14:00:00',1.91),('12664','2014-04-27','14:05:00',1.52),('12664','2014-04-27','14:10:00',1.45),('12664','2014-04-27','14:15:00',1.77),('12664','2014-04-27','14:20:00',1.99),('12664','2014-04-27','14:25:00',2.26),('12664','2014-04-27','14:30:00',2.13),('12664','2014-04-27','14:35:00',2.42),('12664','2014-04-27','14:40:00',2.61),('12664','2014-04-27','14:45:00',1.93),('12664','2014-04-27','14:50:00',1.65),('12664','2014-04-27','14:55:00',1.88),('12664','2014-04-27','15:00:00',2.35),('12664','2014-04-27','15:05:00',2.44),('12664','2014-04-27','15:10:00',2.53),('12664','2014-04-27','15:15:00',2.31),('12664','2014-04-27','15:20:00',1.26),('12664','2014-04-27','15:35:00',1.19),('12664','2014-04-27','15:40:00',1.03),('12664','2014-02-14','08:30:00',1.18),('12664','2014-02-14','08:35:00',1.31),('12664','2014-02-14','08:40:00',1.39),('12664','2014-02-14','08:45:00',1.49),('12664','2014-02-14','08:50:00',1.59),('12664','2014-02-14','08:55:00',1.67),('12664','2014-02-14','09:00:00',1.75),('12664','2014-02-14','09:05:00',1.83),('12664','2014-02-14','09:10:00',1.9),('12664','2014-02-14','09:15:00',1.98),('12664','2014-02-14','09:20:00',2.02),('12664','2014-02-14','09:25:00',2.09),('12664','2014-02-14','09:30:00',2.02),('12664','2014-02-14','09:35:00',2.26),('12664','2014-02-14','09:40:00',2.36),('12664','2014-02-14','09:45:00',2.39),('12664','2014-02-14','09:50:00',2.5),('12664','2014-02-14','09:55:00',2.5),('12664','2014-02-14','10:00:00',2.36),('12664','2014-02-14','10:05:00',2.73),('12664','2014-02-14','10:10:00',2.64),('12664','2014-02-14','10:15:00',2.9),('12664','2014-02-14','10:20:00',2.68),('12664','2014-02-14','10:25:00',2.73),('12664','2014-02-14','10:30:00',2.72),('12664','2014-02-14','10:35:00',2.61),('12664','2014-02-14','10:40:00',2.88),('12664','2014-02-14','10:45:00',3.2),('12664','2014-02-14','10:50:00',3.14),('12664','2014-02-14','10:55:00',3.26),('12664','2014-02-14','11:00:00',3.29),('12664','2014-02-14','11:05:00',3.29),('12664','2014-02-14','11:10:00',3.31),('12664','2014-02-14','11:15:00',3.21),('12664','2014-02-14','11:20:00',3.4),('12664','2014-02-14','11:25:00',3.43),('12664','2014-02-14','11:30:00',3.47),('12664','2014-02-14','11:35:00',3.41),('12664','2014-02-14','11:40:00',2.92),('12664','2014-02-14','11:45:00',3.44),('12664','2014-02-14','11:50:00',3.5),('12664','2014-02-14','11:55:00',3.52),('12664','2014-02-14','12:00:00',3.51),('12664','2014-02-14','12:05:00',3.53),('12664','2014-02-14','12:10:00',3.51),('12664','2014-02-14','12:15:00',3.54),('12664','2014-02-14','12:20:00',3.51),('12664','2014-02-14','12:25:00',3.52),('12664','2014-02-14','12:30:00',3.53),('12664','2014-02-14','12:35:00',3.52),('12664','2014-02-14','12:40:00',3.51),('12664','2014-02-14','12:45:00',3.5),('12664','2014-02-14','12:50:00',3.46),('12664','2014-02-14','12:55:00',3.46),('12664','2014-02-14','13:00:00',3.46),('12664','2014-02-14','13:05:00',3.45),('12664','2014-02-14','13:10:00',3.41),('12664','2014-02-14','13:15:00',3.4),('12664','2014-02-14','13:20:00',3.37),('12664','2014-02-14','13:25:00',3.34),('12664','2014-02-14','13:30:00',3.3),('12664','2014-02-14','13:35:00',3.29),('12664','2014-02-14','13:40:00',3.24),('12664','2014-02-14','13:45:00',3.23),('12664','2014-02-14','13:50:00',3.18),('12664','2014-02-14','13:55:00',3.14),('12664','2014-02-14','14:00:00',3.12),('12664','2014-02-14','14:05:00',3.07),('12664','2014-02-14','14:10:00',3),('12664','2014-02-14','14:15:00',2.96),('12664','2014-02-14','14:20:00',2.88),('12664','2014-02-14','14:25:00',2.83),('12664','2014-02-14','14:30:00',2.78),('12664','2014-02-14','14:35:00',2.73),('12664','2014-02-14','14:40:00',2.67),('12664','2014-02-14','14:45:00',2.61),('12664','2014-02-14','14:50:00',2.53),('12664','2014-02-14','14:55:00',2.45),('12664','2014-02-14','15:00:00',2.36),('12664','2014-02-14','15:05:00',2.29),('12664','2014-02-14','15:10:00',2.22),('12664','2014-02-14','15:15:00',2.15),('12664','2014-02-14','15:20:00',2.06),('12664','2014-02-14','15:25:00',1.98),('12664','2014-02-14','15:30:00',1.9),('12664','2014-02-14','15:35:00',1.81),('12664','2014-02-14','15:40:00',1.73),('12664','2014-02-14','15:45:00',1.64),('12664','2014-02-14','15:50:00',1.55),('12664','2014-02-14','15:55:00',1.46),('12664','2014-02-14','16:00:00',1.37),('12664','2014-02-14','16:05:00',1.29),('12664','2014-02-14','16:10:00',1.18),('12664','2014-02-14','16:15:00',1.08),('12664','2014-02-13','08:20:00',1.05),('12664','2014-02-13','08:25:00',1.12),('12664','2014-02-13','08:30:00',1.2),('12664','2014-02-13','08:35:00',1.3),('12664','2014-02-13','08:40:00',1.41),('12664','2014-02-13','08:45:00',1.5),('12664','2014-02-13','08:50:00',1.6),('12664','2014-02-13','08:55:00',1.68),('12664','2014-02-13','09:00:00',1.77),('12664','2014-02-13','09:05:00',1.85),('12664','2014-02-13','09:10:00',1.92),('12664','2014-02-13','09:15:00',2.01),('12664','2014-02-13','09:20:00',2.11),('12664','2014-02-13','09:25:00',2.18),('12664','2014-02-13','09:30:00',2.25),('12664','2014-02-13','09:35:00',2.31),('12664','2014-02-13','09:40:00',2.38),('12664','2014-02-13','09:45:00',2.45),('12664','2014-02-13','09:50:00',2.52),('12664','2014-02-13','09:55:00',2.57),('12664','2014-02-13','10:00:00',2.63),('12664','2014-02-13','10:05:00',2.66),('12664','2014-02-13','10:10:00',2.7),('12664','2014-02-13','10:15:00',2.76),('12664','2014-02-13','10:20:00',2.81),('12664','2014-02-13','10:25:00',2.86),('12664','2014-02-13','10:30:00',2.89),('12664','2014-02-13','10:35:00',2.93),('12664','2014-02-13','10:40:00',2.99),('12664','2014-02-13','10:45:00',3.03),('12664','2014-02-13','10:50:00',3.07),('12664','2014-02-13','10:55:00',3.08),('12664','2014-02-13','11:00:00',3.12),('12664','2014-02-13','11:05:00',3.06),('12664','2014-02-13','11:10:00',2.53),('12664','2014-02-13','11:15:00',2.93),('12664','2014-02-13','11:20:00',3.2),('12664','2014-02-13','11:25:00',2.14),('12664','2014-02-13','11:30:00',2.85),('12664','2014-02-13','11:35:00',2.13),('12664','2014-02-13','11:40:00',2.85),('12664','2014-02-13','11:45:00',1.46),('12664','2014-02-13','11:50:00',1.83),('12664','2014-02-13','11:55:00',3.53),('12664','2014-02-13','12:00:00',3.53),('12664','2014-02-13','12:05:00',3.55),('12664','2014-02-13','12:10:00',3.14),('12664','2014-02-13','12:15:00',1.13),('12664','2014-02-13','12:20:00',2.36),('12664','2014-02-13','12:25:00',3.87),('12664','2014-02-13','12:30:00',3.43),('12664','2014-02-13','12:35:00',3.74),('12664','2014-02-13','12:40:00',3.71),('12664','2014-02-13','12:45:00',3.74),('12664','2014-02-13','12:50:00',3.78),('12664','2014-02-13','12:55:00',3.71),('12664','2014-02-13','13:00:00',3.67),('12664','2014-02-13','13:05:00',3.54),('12664','2014-02-13','13:10:00',3.38),('12664','2014-02-13','13:15:00',3.36),('12664','2014-02-13','13:20:00',3.36),('12664','2014-02-13','13:25:00',3.34),('12664','2014-02-13','13:30:00',3.31),('12664','2014-02-13','13:35:00',3.3),('12664','2014-02-13','13:40:00',3.26),('12664','2014-02-13','13:45:00',3.23),('12664','2014-02-13','13:50:00',2.93),('12664','2014-02-13','13:55:00',3.15),('12664','2014-02-13','14:00:00',3.15),('12664','2014-02-13','14:05:00',3.07),('12664','2014-02-13','14:10:00',3.02),('12664','2014-02-13','14:15:00',2.96),('12664','2014-02-13','14:20:00',2.92),('12664','2014-02-13','14:25:00',2.95),('12664','2014-02-13','14:30:00',2.93),('12664','2014-02-13','14:35:00',2.93),('12664','2014-02-13','14:40:00',1.1),('12664','2014-02-13','14:45:00',2.34),('12664','2014-02-13','14:50:00',1.73),('12664','2014-02-13','14:55:00',2.15),('12664','2014-02-13','15:00:00',2.46),('12664','2014-02-13','15:05:00',1.53),('12664','2014-02-13','15:10:00',1.91),('12664','2014-02-13','15:15:00',1.57),('12664','2014-02-13','15:20:00',1.52),('12664','2014-02-13','15:25:00',1.26),('12664','2014-02-13','15:30:00',1.08),('12664','2014-02-13','15:35:00',1.4),('12664','2014-02-13','15:40:00',1.34),('12664','2014-02-13','15:45:00',1.7),('12664','2014-02-13','15:50:00',1.64),('12664','2014-02-13','15:55:00',1.32),('12664','2014-02-13','16:00:00',1.43),('12664','2014-02-13','16:05:00',1.32),('12664','2014-02-12','08:25:00',1.08),('12664','2014-02-12','08:30:00',1.18),('12664','2014-02-12','08:35:00',1.29),('12664','2014-02-12','08:40:00',1.39),('12664','2014-02-12','08:45:00',1.49),('12664','2014-02-12','08:50:00',1.58),('12664','2014-02-12','08:55:00',1.24),('12664','2014-02-12','09:00:00',1.6),('12664','2014-02-12','09:05:00',1.4),('12664','2014-02-12','09:10:00',1.95),('12664','2014-02-12','09:15:00',2.05),('12664','2014-02-12','09:20:00',2.16),('12664','2014-02-12','09:25:00',1.78),('12664','2014-02-12','09:40:00',1.02),('12664','2014-02-12','09:45:00',1.37),('12664','2014-02-12','09:50:00',1.83),('12664','2014-02-12','09:55:00',1.93),('12664','2014-02-12','10:00:00',1.4),('12664','2014-02-12','10:05:00',1.17),('12664','2014-02-12','10:10:00',1.06),('12664','2014-02-12','10:20:00',1.11),('12664','2014-02-12','10:25:00',1.12),('12664','2014-02-12','10:30:00',1.34),('12664','2014-02-12','10:35:00',1.03),('12664','2014-02-12','10:40:00',1.01),('12664','2014-02-12','10:45:00',1.13),('12664','2014-02-12','11:00:00',1.01),('12664','2014-02-12','11:05:00',1.09),('12664','2014-02-12','11:10:00',1.55),('12664','2014-02-12','11:15:00',1.92),('12664','2014-02-12','11:20:00',1.09),('12664','2014-02-12','11:25:00',1.94),('12664','2014-02-12','11:30:00',3.09),('12664','2014-02-12','11:35:00',3.79),('12664','2014-02-12','11:40:00',3.75),('12664','2014-02-12','11:45:00',3.57),('12664','2014-02-12','11:50:00',2.23),('12664','2014-02-12','11:55:00',1.05),('12664','2014-02-12','12:00:00',1.06),('12664','2014-02-12','12:05:00',1.09),('12664','2014-02-12','12:10:00',1.22),('12664','2014-02-12','12:15:00',1.09),('12664','2014-02-12','12:20:00',1.06),('12664','2014-02-12','12:25:00',1.14),('12664','2014-02-12','12:30:00',1.22),('12664','2014-02-12','12:35:00',1.29),('12664','2014-02-12','12:40:00',1.34),('12664','2014-02-12','12:45:00',1.57),('12664','2014-02-12','12:50:00',1.88),('12664','2014-02-12','12:55:00',1.73),('12664','2014-02-12','13:00:00',2),('12664','2014-02-12','13:05:00',1.7),('12664','2014-02-12','13:10:00',1.79),('12664','2014-02-12','13:15:00',2.7),('12664','2014-02-12','13:20:00',2.21),('12664','2014-02-12','13:25:00',2.08),('12664','2014-02-12','13:30:00',2.76),('12664','2014-02-12','13:35:00',1.5),('12664','2014-02-12','13:40:00',1.52),('12664','2014-02-12','13:45:00',1.31),('12664','2014-02-12','13:50:00',1.28),('12664','2014-02-12','13:55:00',1.37),('12664','2014-02-12','14:00:00',1.57),('12664','2014-02-12','14:05:00',3.23),('12664','2014-02-12','14:10:00',3.09),('12664','2014-02-12','14:15:00',2.28),('12664','2014-02-12','14:20:00',3.05),('12664','2014-02-12','14:25:00',3.23),('12664','2014-02-12','14:30:00',2.84),('12664','2014-02-12','14:35:00',3.14),('12664','2014-02-12','14:40:00',1.94),('12664','2014-02-12','14:45:00',2.66),('12664','2014-02-12','14:50:00',2.72),('12664','2014-02-12','14:55:00',2.33),('12664','2014-02-12','15:00:00',1.13),('12664','2014-02-12','15:05:00',1.84),('12664','2014-02-12','15:10:00',1.58),('12664','2014-02-12','15:15:00',1.66),('12664','2014-02-12','15:20:00',1.66),('12664','2014-02-12','15:30:00',1.11),('12664','2014-02-12','15:35:00',2.04),('12664','2014-02-12','15:40:00',1.59),('12664','2014-02-12','15:45:00',1.02),('12664','2014-02-12','15:50:00',1.15),('12664','2014-02-11','09:25:00',1.06),('12664','2014-02-11','09:30:00',1.16),('12664','2014-02-11','09:45:00',1.22),('12664','2014-02-11','09:50:00',1.26),('12664','2014-02-11','09:55:00',1.09),('12664','2014-02-11','10:00:00',1.08),('12664','2014-02-11','10:05:00',1.09),('12664','2014-02-11','10:10:00',1.25),('12664','2014-02-11','10:15:00',1.53),('12664','2014-02-11','10:20:00',1.6),('12664','2014-02-11','10:25:00',1.91),('12664','2014-02-11','10:30:00',1.83),('12664','2014-02-11','10:35:00',1.86),('12664','2014-02-11','10:40:00',1.85),('12664','2014-02-11','10:45:00',1.6),('12664','2014-02-11','10:50:00',1.78),('12664','2014-02-11','10:55:00',1.64),('12664','2014-02-11','11:00:00',2.24),('12664','2014-02-11','11:05:00',2.44),('12664','2014-02-11','11:10:00',1.84),('12664','2014-02-11','11:15:00',2.25),('12664','2014-02-11','11:20:00',2.04),('12664','2014-02-11','11:25:00',2.39),('12664','2014-02-11','11:30:00',2.74),('12664','2014-02-11','11:35:00',2.4),('12664','2014-02-11','11:40:00',2.16),('12664','2014-02-11','11:45:00',1.91),('12664','2014-02-11','11:50:00',2.36),('12664','2014-02-11','11:55:00',2.04),('12664','2014-02-11','12:00:00',1.77),('12664','2014-02-11','12:05:00',1.39),('12664','2014-02-11','12:10:00',2.03),('12664','2014-02-11','12:15:00',1.93),('12664','2014-02-11','12:20:00',1.26),('12664','2014-02-11','12:25:00',1.59),('12664','2014-02-11','12:30:00',2.05),('12664','2014-02-11','12:35:00',2.22),('12664','2014-02-11','12:40:00',1.84),('12664','2014-02-11','12:45:00',1.45),('12664','2014-02-11','12:50:00',2.51),('12664','2014-02-11','12:55:00',1.71),('12664','2014-02-11','13:00:00',2.64),('12664','2014-02-11','13:05:00',1.95),('12664','2014-02-11','13:10:00',2.88),('12664','2014-02-11','13:15:00',3.39),('12664','2014-02-11','13:20:00',3.04),('12664','2014-02-11','13:25:00',2.74),('12664','2014-02-11','13:30:00',2.58),('12664','2014-02-11','13:35:00',2.52),('12664','2014-02-11','13:40:00',2.73),('12664','2014-02-11','13:45:00',1.93),('12664','2014-02-11','13:50:00',2.08),('12664','2014-02-11','13:55:00',2.03),('12664','2014-02-11','14:00:00',1.38),('12664','2014-02-11','14:05:00',1.15),('12664','2014-02-11','14:10:00',1.55),('12664','2014-02-11','14:15:00',1.58),('12664','2014-02-11','14:20:00',1.4),('12664','2014-02-11','14:25:00',1.44),('12664','2014-02-11','14:30:00',1.15),('12664','2014-02-11','14:35:00',1.27),('12664','2014-02-11','15:05:00',1.12),('12664','2014-02-11','15:10:00',1.2),('12664','2014-02-11','15:15:00',1.34),('12664','2014-02-11','15:20:00',1.48),('12664','2014-02-11','16:15:00',1.02),('12664','2014-02-09','12:05:00',2.7),('12664','2014-02-09','12:15:00',2.04),('12664','2014-02-09','12:35:00',1.05),('12664','2014-02-09','12:40:00',1.33),('12664','2014-02-09','12:50:00',1.05),('12664','2014-02-09','12:55:00',3.73),('12664','2014-02-09','13:00:00',3.07),('12664','2014-02-09','13:05:00',1.08),('12664','2014-02-09','13:10:00',1.97),('12664','2014-02-09','13:15:00',1.17),('12664','2014-02-09','13:20:00',1.73),('12664','2014-02-09','13:25:00',1.46),('12664','2014-02-09','13:30:00',1.66),('12664','2014-02-09','13:35:00',2.98),('12664','2014-02-09','13:40:00',1.46),('12664','2014-02-09','13:45:00',2.42),('12664','2014-02-09','13:50:00',2.71),('12664','2014-02-09','13:55:00',3.17),('12664','2014-02-09','14:00:00',3.05),('12664','2014-02-09','14:05:00',1.68),('12664','2014-02-09','14:15:00',1.52),('12664','2014-02-09','14:20:00',2.75),('12664','2014-02-09','14:25:00',2.64),('12664','2014-02-09','14:30:00',2.1),('12664','2014-02-09','14:35:00',1.44),('12664','2014-02-09','14:40:00',1.8),('12664','2014-02-09','14:45:00',1.48),('12664','2014-02-09','14:50:00',2.11),('12664','2014-02-09','14:55:00',1.9),('12664','2014-02-09','15:00:00',1.24),('12664','2014-02-09','15:05:00',2.15),('12664','2014-02-09','15:10:00',1.74),('12664','2014-02-09','15:15:00',1.45),('12664','2014-02-09','15:20:00',1.9),('12664','2014-02-09','15:25:00',1.82),('12664','2014-02-09','15:30:00',1.76),('12664','2014-02-09','15:35:00',1.7),('12664','2014-02-09','15:40:00',1.46),('12664','2014-02-09','15:45:00',1.38),('12664','2014-02-09','15:50:00',1.25),('12664','2014-02-09','15:55:00',1.29),('12664','2014-02-09','16:00:00',1.14),('12664','2014-02-09','16:05:00',1.11),('12664','2014-02-08','09:50:00',1.9),('12664','2014-02-08','09:55:00',2.42),('12664','2014-02-08','10:00:00',2.6),('12664','2014-02-08','10:05:00',2.65),('12664','2014-02-08','10:10:00',2.78),('12664','2014-02-08','10:15:00',2.53),('12664','2014-02-08','10:20:00',1.99),('12664','2014-02-08','10:25:00',3.16),('12664','2014-02-08','10:30:00',1.18),('12664','2014-02-08','10:40:00',1.93),('12664','2014-02-08','10:45:00',1.79),('12664','2014-02-08','10:50:00',3.17),('12664','2014-02-08','10:55:00',2.02),('12664','2014-02-08','11:00:00',3.51),('12664','2014-02-08','11:05:00',2.63),('12664','2014-02-08','11:15:00',1.3),('12664','2014-02-08','11:20:00',1.85),('12664','2014-02-08','11:25:00',1.83),('12664','2014-02-08','11:30:00',2.37),('12664','2014-02-08','11:35:00',1),('12664','2014-02-08','11:50:00',3.68),('12664','2014-02-08','11:55:00',3.74),('12664','2014-02-08','12:00:00',2.7),('12664','2014-02-08','12:05:00',2.32),('12664','2014-02-08','12:10:00',2.06),('12664','2014-02-08','12:15:00',1.63),('12664','2014-02-08','12:20:00',3.95),('12664','2014-02-08','12:25:00',2.69),('12664','2014-02-08','12:30:00',2.49),('12664','2014-02-08','12:35:00',3.55),('12664','2014-02-08','12:40:00',2.6),('12664','2014-02-08','12:45:00',1.91),('12664','2014-02-08','12:50:00',3.97),('12664','2014-02-08','12:55:00',4.01),('12664','2014-02-08','13:00:00',2.52),('12664','2014-02-08','13:05:00',2.62),('12664','2014-02-08','13:10:00',2.15),('12664','2014-02-08','13:15:00',2.56),('12664','2014-02-08','13:20:00',2.96),('12664','2014-02-08','13:25:00',2.45),('12664','2014-02-08','13:30:00',2.68),('12664','2014-02-08','13:35:00',1.57),('12664','2014-02-08','13:40:00',1.78),('12664','2014-02-08','13:45:00',1.96),('12664','2014-02-08','13:50:00',1.13),('12664','2014-02-08','13:55:00',3.43),('12664','2014-02-08','14:00:00',3.29),('12664','2014-02-08','14:05:00',3.27),('12664','2014-02-08','14:10:00',2.73),('12664','2014-02-08','14:15:00',2.13),('12664','2014-02-08','14:20:00',2.54),('12664','2014-02-08','14:25:00',2.1),('12664','2014-02-08','14:35:00',2.77),('12664','2014-02-08','14:40:00',2.37),('12664','2014-02-08','14:45:00',1.05),('12664','2014-02-08','14:50:00',1.45),('12664','2014-02-08','14:55:00',1.41),('12664','2014-02-08','15:00:00',2.47),('12664','2014-02-08','15:15:00',1.25),('12664','2014-02-08','15:20:00',1.36),('12664','2014-02-08','15:25:00',1.55),('12664','2014-02-08','15:40:00',1.25),('12664','2014-02-08','15:55:00',1.18),('12664','2014-02-07','08:20:00',1.14),('12664','2014-02-07','08:25:00',1.28),('12664','2014-02-07','08:30:00',1.25),('12664','2014-02-07','08:35:00',1.15),('12664','2014-02-07','08:40:00',1.24),('12664','2014-02-07','08:45:00',1.35),('12664','2014-02-07','08:50:00',1.46),('12664','2014-02-07','08:55:00',1.54),('12664','2014-02-07','09:00:00',1.62),('12664','2014-02-07','09:05:00',1.71),('12664','2014-02-07','09:10:00',1.77),('12664','2014-02-07','09:15:00',1.83),('12664','2014-02-07','09:20:00',1.92),('12664','2014-02-07','09:25:00',1.99),('12664','2014-02-07','09:30:00',2.05),('12664','2014-02-07','09:35:00',2.11),('12664','2014-02-07','09:40:00',2.18),('12664','2014-02-07','09:45:00',2.25),('12664','2014-02-07','09:50:00',2.32),('12664','2014-02-07','09:55:00',2.35),('12664','2014-02-07','10:00:00',2.41),('12664','2014-02-07','10:05:00',2.49),('12664','2014-02-07','10:10:00',2.49),('12664','2014-02-07','10:15:00',2.66),('12664','2014-02-07','10:20:00',2.76),('12664','2014-02-07','10:25:00',2.89),('12664','2014-02-07','10:30:00',2.87),('12664','2014-02-07','10:35:00',1.87),('12664','2014-02-07','10:40:00',2.93),('12664','2014-02-07','10:45:00',3.1),('12664','2014-02-07','10:50:00',2.59),('12664','2014-02-07','10:55:00',1.47),('12664','2014-02-07','11:00:00',1.84),('12664','2014-02-07','11:05:00',3.6),('12664','2014-02-07','11:10:00',2.73),('12664','2014-02-07','11:15:00',1.07),('12664','2014-02-07','11:20:00',1.07),('12664','2014-02-07','11:35:00',2.44),('12664','2014-02-07','11:40:00',1.34),('12664','2014-02-07','11:45:00',3.05),('12664','2014-02-07','11:50:00',3.55),('12664','2014-02-07','11:55:00',3.86),('12664','2014-02-07','12:00:00',3.78),('12664','2014-02-07','12:05:00',3.29),('12664','2014-02-07','12:10:00',3.02),('12664','2014-02-07','12:15:00',2.8),('12664','2014-02-07','12:20:00',2.86),('12664','2014-02-07','12:25:00',3.62),('12664','2014-02-07','12:30:00',3.64),('12664','2014-02-07','12:35:00',3.66),('12664','2014-02-07','12:40:00',3.57),('12664','2014-02-07','12:45:00',2.23),('12664','2014-02-07','12:50:00',1.82),('12664','2014-02-07','12:55:00',3.31),('12664','2014-02-07','13:00:00',2.31),('12664','2014-02-07','13:10:00',3.29),('12664','2014-02-07','13:15:00',3.71),('12664','2014-02-07','13:20:00',2.26),('12664','2014-02-07','13:25:00',3.58),('12664','2014-02-07','13:30:00',3.46),('12664','2014-02-07','13:35:00',3.25),('12664','2014-02-07','13:40:00',3.21),('12664','2014-02-07','13:45:00',2.64),('12664','2014-02-07','13:50:00',3.15),('12664','2014-02-07','13:55:00',3.06),('12664','2014-02-07','14:00:00',2.91),('12664','2014-02-07','14:05:00',2.24),('12664','2014-02-07','14:10:00',3.04),('12664','2014-02-07','14:15:00',2.94),('12664','2014-02-07','14:20:00',2.77),('12664','2014-02-07','14:25:00',2.74),('12664','2014-02-07','14:30:00',2.68),('12664','2014-02-07','14:35:00',2.63),('12664','2014-02-07','14:40:00',2.18),('12664','2014-02-07','14:45:00',2.01),('12664','2014-02-07','14:50:00',2.05),('12664','2014-02-07','14:55:00',2.44),('12664','2014-02-07','15:00:00',1.67),('12664','2014-02-07','15:05:00',2.24),('12664','2014-02-07','15:10:00',2.21),('12664','2014-02-07','15:15:00',2.1),('12664','2014-02-07','15:20:00',1.99),('12664','2014-02-07','15:25:00',1.89),('12664','2014-02-07','15:30:00',1.79),('12664','2014-02-07','15:35:00',1.71),('12664','2014-02-07','15:40:00',1.63),('12664','2014-02-07','15:45:00',1.54),('12664','2014-02-07','15:50:00',1.46),('12664','2014-02-07','15:55:00',1.36),('12664','2014-02-07','16:00:00',1.27),('12664','2014-02-07','16:05:00',1.17),('12664','2014-02-07','16:10:00',1.09),('12664','2014-02-07','16:15:00',1.01),('12664','2014-02-06','08:30:00',1.09),('12664','2014-02-06','08:35:00',1.2),('12664','2014-02-06','08:40:00',1.27),('12664','2014-02-06','08:45:00',1.44),('12664','2014-02-06','08:50:00',1.73),('12664','2014-02-06','08:55:00',1.92),('12664','2014-02-06','09:00:00',1.71),('12664','2014-02-06','09:05:00',1.02),('12664','2014-02-06','09:15:00',1.6),('12664','2014-02-06','09:20:00',2.12),('12664','2014-02-06','09:30:00',2.18),('12664','2014-02-06','09:35:00',2.22),('12664','2014-02-06','09:40:00',2.29),('12664','2014-02-06','09:45:00',2.32),('12664','2014-02-06','09:50:00',2.38),('12664','2014-02-06','09:55:00',2.46),('12664','2014-02-06','10:00:00',2.54),('12664','2014-02-06','10:05:00',2.59),('12664','2014-02-06','10:10:00',2.63),('12664','2014-02-06','10:15:00',2.7),('12664','2014-02-06','10:20:00',2.76),('12664','2014-02-06','10:25:00',2.68),('12664','2014-02-06','10:35:00',1.42),('12664','2014-02-06','10:40:00',2.89),('12664','2014-02-06','10:45:00',2.5),('12664','2014-02-06','10:50:00',1.67),('12664','2014-02-06','10:55:00',2.89),('12664','2014-02-06','11:00:00',1.87),('12664','2014-02-06','11:05:00',3.31),('12664','2014-02-06','11:10:00',3.21),('12664','2014-02-06','11:15:00',3.36),('12664','2014-02-06','11:20:00',3.51),('12664','2014-02-06','11:25:00',3.2),('12664','2014-02-06','11:30:00',3.47),('12664','2014-02-06','11:35:00',3.37),('12664','2014-02-06','11:40:00',3.38),('12664','2014-02-06','11:45:00',3.39),('12664','2014-02-06','11:50:00',3.41),('12664','2014-02-06','11:55:00',3.43),('12664','2014-02-06','12:00:00',3.44),('12664','2014-02-06','12:05:00',3.52),('12664','2014-02-06','12:10:00',3.47),('12664','2014-02-06','12:15:00',3.46),('12664','2014-02-06','12:20:00',3.44),('12664','2014-02-06','12:25:00',3.43),('12664','2014-02-06','12:30:00',3.4),('12664','2014-02-06','12:35:00',3.44),('12664','2014-02-06','12:40:00',3.45),('12664','2014-02-06','12:45:00',3.42),('12664','2014-02-06','12:50:00',3.4),('12664','2014-02-06','12:55:00',3.4),('12664','2014-02-06','13:00:00',3.39),('12664','2014-02-06','13:05:00',3.36),('12664','2014-02-06','13:10:00',3.33),('12664','2014-02-06','13:15:00',3.32),('12664','2014-02-06','13:20:00',3.32),('12664','2014-02-06','13:25:00',3.28),('12664','2014-02-06','13:30:00',3.14),('12664','2014-02-06','13:35:00',3.19),('12664','2014-02-06','13:40:00',3.15),('12664','2014-02-06','13:45:00',3.12),('12664','2014-02-06','13:50:00',3.06),('12664','2014-02-06','13:55:00',3.04),('12664','2014-02-06','14:00:00',2.98),('12664','2014-02-06','14:05:00',2.93),('12664','2014-02-06','14:10:00',2.88),('12664','2014-02-06','14:15:00',2.81),('12664','2014-02-06','14:20:00',2.76),('12664','2014-02-06','14:25:00',2.73),('12664','2014-02-06','14:30:00',2.67),('12664','2014-02-06','14:35:00',2.6),('12664','2014-02-06','14:40:00',2.53),('12664','2014-02-06','14:45:00',2.45),('12664','2014-02-06','14:50:00',2.41),('12664','2014-02-06','14:55:00',2.32),('12664','2014-02-06','15:00:00',2.24),('12664','2014-02-06','15:05:00',2.17),('12664','2014-02-06','15:10:00',2.07),('12664','2014-02-06','15:15:00',1.99),('12664','2014-02-06','15:20:00',1.93),('12664','2014-02-06','15:25:00',1.86),('12664','2014-02-06','15:30:00',1.79),('12664','2014-02-06','15:35:00',1.7),('12664','2014-02-06','15:40:00',1.62),('12664','2014-02-06','15:45:00',1.52),('12664','2014-02-06','15:50:00',1.43),('12664','2014-02-06','15:55:00',1.34),('12664','2014-02-06','16:00:00',1.24),('12664','2014-02-06','16:05:00',1.15),('12664','2014-02-06','16:10:00',1.06),('12664','2014-02-05','09:25:00',1.19),('12664','2014-02-05','10:10:00',1.17),('12664','2014-02-05','10:15:00',1.71),('12664','2014-02-05','10:20:00',1.45),('12664','2014-02-05','10:25:00',1.42),('12664','2014-02-05','10:30:00',3.02),('12664','2014-02-05','10:35:00',2.98),('12664','2014-02-05','10:40:00',2.96),('12664','2014-02-05','10:45:00',2.98),('12664','2014-02-05','10:50:00',2.87),('12664','2014-02-05','10:55:00',1.98),('12664','2014-02-05','11:00:00',2.01),('12664','2014-02-05','11:05:00',2.1),('12664','2014-02-05','11:10:00',1.15),('12664','2014-02-05','11:15:00',1.5),('12664','2014-02-05','11:20:00',1.05),('12664','2014-02-05','12:30:00',1.5),('12664','2014-02-05','12:35:00',1.19),('12664','2014-02-05','12:40:00',1.28),('12664','2014-02-05','12:45:00',1.7),('12664','2014-02-05','12:50:00',1.08),('12664','2014-02-05','12:55:00',1.04),('12664','2014-02-05','13:00:00',1.2),('12664','2014-02-05','13:30:00',1.2),('12664','2014-02-05','13:35:00',1.43),('12664','2014-02-05','13:40:00',1.44),('12664','2014-02-05','13:45:00',1.39),('12664','2014-02-05','14:05:00',1.04),('12664','2014-02-05','14:10:00',1.28),('12664','2014-02-05','14:15:00',1.51),('12664','2014-02-05','14:20:00',2.52),('12664','2014-02-05','14:25:00',2.38),('12664','2014-02-05','14:45:00',1.13),('12664','2014-02-05','14:50:00',1.47),('12664','2014-02-05','14:55:00',1),('12664','2014-02-05','15:20:00',1.09),('12664','2014-04-26','09:45:00',1.05),('12664','2014-04-26','09:50:00',1.1),('12664','2014-04-26','09:55:00',1.25),('12664','2014-04-26','10:00:00',1.61),('12664','2014-04-26','10:05:00',2.29),('12664','2014-04-26','10:10:00',1.72),('12664','2014-04-26','10:15:00',2.06),('12664','2014-04-26','10:20:00',2.35),('12664','2014-04-26','10:25:00',2.17),('12664','2014-04-26','10:30:00',2.42),('12664','2014-04-26','10:35:00',1.9),('12664','2014-04-26','10:40:00',1.57),('12664','2014-04-26','10:45:00',1.48),('12664','2014-04-26','10:50:00',1.73),('12664','2014-04-26','10:55:00',1.96),('12664','2014-04-26','11:00:00',2.31),('12664','2014-04-26','11:05:00',2.76),('12664','2014-04-26','11:10:00',3.58),('12664','2014-04-26','11:15:00',3.84),('12664','2014-04-26','11:20:00',3.83),('12664','2014-04-26','11:25:00',3.56),('12664','2014-04-26','11:30:00',3.81),('12664','2014-04-26','11:35:00',3.72),('12664','2014-04-26','11:40:00',3.8),('12664','2014-04-26','11:45:00',3.7),('12664','2014-04-26','11:50:00',3.49),('12664','2014-04-26','11:55:00',3.22),('12664','2014-04-26','12:00:00',2.04),('12664','2014-04-26','12:05:00',3.5),('12664','2014-04-26','12:10:00',3.7),('12664','2014-04-26','12:15:00',2.18),('12664','2014-04-26','12:20:00',2.5),('12664','2014-04-26','12:25:00',2.72),('12664','2014-04-26','12:30:00',2.59),('12664','2014-04-26','12:35:00',2.73),('12664','2014-04-26','12:40:00',3.78),('12664','2014-04-26','12:45:00',3.4),('12664','2014-04-26','12:50:00',3.52),('12664','2014-04-26','12:55:00',3.37),('12664','2014-04-26','13:00:00',3.46),('12664','2014-04-26','13:05:00',2.84),('12664','2014-04-26','13:10:00',2.95),('12664','2014-04-26','13:15:00',3.27),('12664','2014-04-26','13:20:00',3.65),('12664','2014-04-26','13:25:00',3.18),('12664','2014-04-26','13:30:00',3.41),('12664','2014-04-26','13:35:00',3.19),('12664','2014-04-26','13:40:00',1.63),('12664','2014-04-26','13:45:00',1.13),('12664','2014-04-26','13:50:00',1.97),('12664','2014-04-26','13:55:00',1.6),('12664','2014-04-26','14:00:00',1.68),('12664','2014-04-26','14:05:00',1.81),('12664','2014-04-26','14:10:00',1.49),('12664','2014-04-26','14:15:00',1.09),('12664','2014-04-26','14:20:00',1.17),('12664','2014-04-26','14:25:00',1.63),('12664','2014-04-26','14:30:00',1.36),('12664','2014-04-26','14:35:00',2.07),('12664','2014-04-26','14:45:00',2.19),('12664','2014-04-26','14:50:00',2.78),('12664','2014-04-26','14:55:00',1.1),('12664','2014-02-04','09:25:00',1.16),('12664','2014-02-04','09:30:00',1.09),('12664','2014-02-04','09:35:00',1.42),('12664','2014-02-04','09:40:00',2.37),('12664','2014-02-04','09:45:00',2.48),('12664','2014-02-04','09:50:00',2.38),('12664','2014-02-04','09:55:00',2.46),('12664','2014-02-04','10:00:00',2.55),('12664','2014-02-04','10:05:00',2.61),('12664','2014-02-04','10:10:00',2.66),('12664','2014-02-04','10:15:00',2.7),('12664','2014-02-04','10:20:00',2.51),('12664','2014-02-04','10:25:00',3),('12664','2014-02-04','10:30:00',2.84),('12664','2014-02-04','10:35:00',2.52),('12664','2014-02-04','10:40:00',2.69),('12664','2014-02-04','10:45:00',3.18),('12664','2014-02-04','10:50:00',2.03),('12664','2014-02-04','10:55:00',2.53),('12664','2014-02-04','11:00:00',2.45),('12664','2014-02-04','11:05:00',1.51),('12664','2014-02-04','11:15:00',2.18),('12664','2014-02-04','11:20:00',1.47),('12664','2014-02-04','11:25:00',1),('12664','2014-02-04','11:30:00',1.13),('12664','2014-02-04','11:50:00',1.02),('12664','2014-02-04','11:55:00',1.41),('12664','2014-02-04','12:00:00',1.1),('12664','2014-02-04','12:50:00',1.26),('12664','2014-02-04','12:55:00',1.05),('12664','2014-02-04','13:00:00',1.28),('12664','2014-02-04','13:05:00',1.51),('12664','2014-02-04','13:10:00',1.62),('12664','2014-02-04','13:15:00',1.37),('12664','2014-02-04','13:20:00',1.02),('12664','2014-02-03','10:25:00',1.09),('12664','2014-02-03','10:30:00',1.1),('12664','2014-02-03','11:40:00',1.04),('12664','2014-02-03','11:45:00',1.1),('12664','2014-02-03','11:50:00',1.13),('12664','2014-02-03','11:55:00',1.14),('12664','2014-02-03','12:00:00',1.03),('12664','2014-02-01','11:00:00',1.18),('12664','2014-02-01','11:05:00',1.24),('12664','2014-02-01','11:10:00',1.4),('12664','2014-02-01','11:15:00',1.82),('12664','2014-02-01','11:20:00',2.04),('12664','2014-02-01','11:25:00',2.33),('12664','2014-02-01','11:30:00',2.15),('12664','2014-02-01','11:35:00',2.46),('12664','2014-02-01','11:40:00',2.47),('12664','2014-02-01','11:45:00',1.76),('12664','2014-02-01','11:50:00',2),('12664','2014-02-01','11:55:00',1.94),('12664','2014-02-01','12:00:00',1.39),('12664','2014-02-01','12:05:00',2.44),('12664','2014-02-01','12:10:00',2.35),('12664','2014-02-01','12:15:00',2),('12664','2014-02-01','12:30:00',1.56),('12664','2014-02-01','12:35:00',2.17),('12664','2014-02-01','12:40:00',2.44),('12664','2014-02-01','12:45:00',1.9),('12664','2014-02-01','12:50:00',2.14),('12664','2014-02-01','12:55:00',1.76),('12664','2014-02-01','13:00:00',1.1),('12664','2014-01-30','09:50:00',1.08),('12664','2014-01-30','09:55:00',1.39),('12664','2014-01-30','10:00:00',1.98),('12664','2014-01-30','10:05:00',2.61),('12664','2014-01-30','10:10:00',2.1),('12664','2014-01-30','10:15:00',1.55),('12664','2014-01-30','10:20:00',1.33),('12664','2014-01-30','10:25:00',1.32),('12664','2014-01-30','10:30:00',1.43),('12664','2014-01-30','10:35:00',1.57),('12664','2014-01-30','10:40:00',1.22),('12664','2014-01-30','10:45:00',1.51),('12664','2014-01-30','10:50:00',1.46),('12664','2014-01-30','10:55:00',1.37),('12664','2014-01-30','11:00:00',1.62),('12664','2014-01-30','11:05:00',1.78),('12664','2014-01-30','11:10:00',2.04),('12664','2014-01-30','11:15:00',2.49),('12664','2014-01-30','11:20:00',2.85),('12664','2014-01-30','11:25:00',2.95),('12664','2014-01-30','11:30:00',2.75),('12664','2014-01-30','11:35:00',2.45),('12664','2014-01-30','11:40:00',3.04),('12664','2014-01-30','11:45:00',3.31),('12664','2014-01-30','11:50:00',3.3),('12664','2014-01-30','11:55:00',2.61),('12664','2014-01-30','12:00:00',3.27),('12664','2014-01-30','12:05:00',3.05),('12664','2014-01-30','12:10:00',1.66),('12664','2014-01-30','12:15:00',1.7),('12664','2014-01-30','12:20:00',2.46),('12664','2014-01-30','12:25:00',2.73),('12664','2014-01-30','12:30:00',2.73),('12664','2014-01-30','12:35:00',3.15),('12664','2014-01-30','12:40:00',3.13),('12664','2014-01-30','12:45:00',3.06),('12664','2014-01-30','12:50:00',3.07),('12664','2014-01-30','12:55:00',3.13),('12664','2014-01-30','13:00:00',3.1),('12664','2014-01-30','13:05:00',3.18),('12664','2014-01-30','13:10:00',3.19),('12664','2014-01-30','13:15:00',3.07),('12664','2014-01-30','13:20:00',3.02),('12664','2014-01-30','13:25:00',2.24),('12664','2014-01-30','13:30:00',2.23),('12664','2014-01-30','13:35:00',2.19),('12664','2014-01-30','13:40:00',2.47),('12664','2014-01-30','13:45:00',3.02),('12664','2014-01-30','13:50:00',3.02),('12664','2014-01-30','13:55:00',2.6),('12664','2014-01-30','14:00:00',2.2),('12664','2014-01-30','14:05:00',2.06),('12664','2014-01-30','14:10:00',2.07),('12664','2014-01-30','14:15:00',1.92),('12664','2014-01-30','14:20:00',1.48),('12664','2014-01-30','14:25:00',1.82),('12664','2014-01-30','14:30:00',1.87),('12664','2014-01-30','14:35:00',1.48),('12664','2014-01-30','14:40:00',2.24),('12664','2014-01-30','14:45:00',2.46),('12664','2014-01-30','14:50:00',2.25),('12664','2014-01-30','14:55:00',2.21),('12664','2014-01-30','15:00:00',1.71),('12664','2014-01-30','15:05:00',1.86),('12664','2014-01-30','15:10:00',1.57),('12664','2014-01-30','15:20:00',1.85),('12664','2014-01-30','15:25:00',1.72),('12664','2014-01-30','15:30:00',1.6),('12664','2014-01-30','15:35:00',1.48),('12664','2014-01-29','09:15:00',1.32),('12664','2014-01-29','09:20:00',1.52),('12664','2014-01-29','09:25:00',1.47),('12664','2014-01-29','09:30:00',1.45),('12664','2014-01-29','09:35:00',1.41),('12664','2014-01-29','09:40:00',1.29),('12664','2014-01-29','09:45:00',1.08),('12664','2014-01-29','10:05:00',1.05),('12664','2014-01-29','10:10:00',1.36),('12664','2014-01-29','10:15:00',1.38),('12664','2014-01-29','10:20:00',3.2),('12664','2014-01-29','10:25:00',2.88),('12664','2014-01-29','10:30:00',2.23),('12664','2014-01-29','10:35:00',2),('12664','2014-01-29','10:40:00',1.59),('12664','2014-01-29','10:45:00',1.42),('12664','2014-01-29','10:50:00',1.46),('12664','2014-01-29','10:55:00',1.58),('12664','2014-01-29','11:00:00',1.82),('12664','2014-01-29','11:05:00',2),('12664','2014-01-29','11:10:00',1.85),('12664','2014-01-29','11:15:00',1.81),('12664','2014-01-29','11:20:00',2.07),('12664','2014-01-29','11:25:00',2),('12664','2014-01-29','11:30:00',2.23),('12664','2014-01-29','11:35:00',2.53),('12664','2014-01-29','11:40:00',3.23),('12664','2014-01-29','11:45:00',2.78),('12664','2014-01-29','11:50:00',1.32),('12664','2014-01-29','12:15:00',1.3),('12664','2014-01-29','12:20:00',1.77),('12664','2014-01-29','12:25:00',1.06),('12664','2014-01-29','12:35:00',1.31),('12664','2014-01-29','12:40:00',2.46),('12664','2014-01-29','12:45:00',2.77),('12664','2014-01-29','12:50:00',3.36),('12664','2014-01-29','12:55:00',3.05),('12664','2014-01-29','13:00:00',2.58),('12664','2014-01-29','13:05:00',2.75),('12664','2014-01-29','13:35:00',1.78),('12664','2014-01-29','13:40:00',2.97),('12664','2014-01-29','13:45:00',2.54),('12664','2014-01-29','13:50:00',2.99),('12664','2014-01-29','13:55:00',3.32),('12664','2014-01-29','14:00:00',2.34),('12664','2014-01-29','14:05:00',1.41),('12664','2014-01-28','09:15:00',1.15),('12664','2014-01-28','09:20:00',1.2),('12664','2014-01-28','09:25:00',1.44),('12664','2014-01-28','09:30:00',1.39),('12664','2014-01-28','09:35:00',1.25),('12664','2014-01-28','09:40:00',1.35),('12664','2014-01-28','09:45:00',1.62),('12664','2014-01-28','09:50:00',2.01),('12664','2014-01-28','09:55:00',2.09),('12664','2014-01-28','10:00:00',2.28),('12664','2014-01-28','10:05:00',2.43),('12664','2014-01-28','10:10:00',2.6),('12664','2014-01-28','10:15:00',2.72),('12664','2014-01-28','10:20:00',2.73),('12664','2014-01-28','10:25:00',2.78),('12664','2014-01-28','10:30:00',2.68),('12664','2014-01-28','10:35:00',2.67),('12664','2014-01-28','10:40:00',3.04),('12664','2014-01-28','10:45:00',3.14),('12664','2014-01-28','10:50:00',2.91),('12664','2014-01-28','10:55:00',2.43),('12664','2014-01-28','11:00:00',2.56),('12664','2014-01-28','11:10:00',2.63),('12664','2014-01-28','11:15:00',2.41),('12664','2014-01-28','11:20:00',2.23),('12664','2014-01-28','11:25:00',1.3),('12664','2014-01-28','11:30:00',2.61),('12664','2014-01-28','11:35:00',1.96),('12664','2014-01-28','11:40:00',1.82),('12664','2014-01-28','11:45:00',1.49),('12664','2014-01-28','11:50:00',3.38),('12664','2014-01-28','11:55:00',3.56),('12664','2014-01-28','12:00:00',1.69),('12664','2014-01-28','12:05:00',2.82),('12664','2014-01-28','12:10:00',1.46),('12664','2014-01-28','12:15:00',1.27),('12664','2014-01-28','12:20:00',1.23),('12664','2014-01-28','12:25:00',1.21),('12664','2014-01-28','12:30:00',1.25),('12664','2014-01-28','12:35:00',1.31),('12664','2014-01-28','12:40:00',1.5),('12664','2014-01-28','12:45:00',3.58),('12664','2014-01-28','12:50:00',3.63),('12664','2014-01-28','12:55:00',3.3),('12664','2014-01-28','13:00:00',2.7),('12664','2014-01-28','13:05:00',2.1),('12664','2014-01-28','13:10:00',3.17),('12664','2014-01-28','13:15:00',3.13),('12664','2014-01-28','13:20:00',3.12),('12664','2014-01-28','13:25:00',2.84),('12664','2014-01-28','13:30:00',3.05),('12664','2014-01-28','13:35:00',3.23),('12664','2014-01-28','13:40:00',3.16),('12664','2014-01-28','13:45:00',3.07),('12664','2014-01-28','13:50:00',2.97),('12664','2014-01-28','13:55:00',2.92),('12664','2014-01-28','14:00:00',2.87),('12664','2014-01-28','14:05:00',2.84),('12664','2014-01-28','14:10:00',2.79),('12664','2014-01-28','14:15:00',2.68),('12664','2014-01-28','14:20:00',2.66),('12664','2014-01-28','14:25:00',2.6),('12664','2014-01-28','14:30:00',2.55),('12664','2014-01-28','14:35:00',2.48),('12664','2014-01-28','14:40:00',2.4),('12664','2014-01-28','14:45:00',2.34),('12664','2014-01-28','14:50:00',2.28),('12664','2014-01-28','14:55:00',2.2),('12664','2014-01-28','15:00:00',2.13),('12664','2014-01-28','15:05:00',2.05),('12664','2014-01-28','15:10:00',1.96),('12664','2014-01-28','15:15:00',1.88),('12664','2014-01-28','15:20:00',1.8),('12664','2014-01-28','15:25:00',1.71),('12664','2014-01-28','15:30:00',1.63),('12664','2014-01-28','15:35:00',1.54),('12664','2014-01-28','15:40:00',1.44),('12664','2014-01-28','15:45:00',1.36),('12664','2014-01-28','15:50:00',1.27),('12664','2014-01-28','15:55:00',1.16),('12664','2014-01-28','16:00:00',1.07),('12664','2014-01-26','09:00:00',1.32),('12664','2014-01-26','09:05:00',1.02),('12664','2014-01-26','09:25:00',1.64),('12664','2014-01-26','09:30:00',1.55),('12664','2014-01-26','09:45:00',1.33),('12664','2014-01-26','09:50:00',1.03),('12664','2014-01-26','10:05:00',1.3),('12664','2014-01-26','10:10:00',1.49),('12664','2014-01-26','10:15:00',1.29),('12664','2014-01-26','11:00:00',1.07),('12664','2014-01-26','11:05:00',1.01),('12664','2014-01-26','11:20:00',1.51),('12664','2014-01-26','11:25:00',2),('12664','2014-01-26','12:10:00',1.21),('12664','2014-01-26','12:15:00',1.27),('12664','2014-01-26','12:20:00',1.69),('12664','2014-01-26','12:25:00',2.55),('12664','2014-01-26','12:30:00',1.47),('12664','2014-01-26','12:35:00',1.12),('12664','2014-01-26','13:00:00',1.18),('12664','2014-01-26','13:05:00',1.18),('12664','2014-01-26','13:10:00',1.21),('12664','2014-01-26','13:15:00',1.33),('12664','2014-01-26','13:20:00',1.26),('12664','2014-01-26','13:25:00',1.12),('12664','2014-01-26','13:45:00',1.17),('12664','2014-01-26','15:40:00',1.66),('1444','2014-05-05','07:50:00',1),('1444','2014-05-05','07:55:00',1.07),('1444','2014-05-05','08:00:00',1.14),('1444','2014-05-05','08:05:00',1.2),('1444','2014-05-05','08:10:00',1.27),('1444','2014-05-05','08:15:00',1.35),('1444','2014-05-05','08:20:00',1.42),('1444','2014-05-05','08:25:00',1.5),('1444','2014-05-05','08:30:00',1.57),('1444','2014-05-05','08:35:00',1.65),('1444','2014-05-05','08:40:00',1.72),('1444','2014-05-05','08:45:00',1.78),('1444','2014-05-05','08:50:00',1.84),('1444','2014-05-05','08:55:00',1.9),('1444','2014-05-05','09:00:00',1.95),('1444','2014-05-05','09:05:00',2),('1444','2014-05-05','09:10:00',2.07),('1444','2014-05-05','09:15:00',2.14),('1444','2014-05-05','09:20:00',2.2),('1444','2014-05-05','09:25:00',2.24),('1444','2014-05-05','09:30:00',2.31),('1444','2014-05-05','09:35:00',2.37),('1444','2014-05-05','09:40:00',2.41),('1444','2014-05-05','09:45:00',2.47),('1444','2014-05-05','09:50:00',2.54),('1444','2014-05-05','09:55:00',2.6),('1444','2014-05-05','10:00:00',2.64),('1444','2014-05-05','10:05:00',2.72),('1444','2014-05-05','10:10:00',2.76),('1444','2014-05-05','10:15:00',2.79),('1444','2014-05-05','10:20:00',2.81),('1444','2014-05-05','10:25:00',2.85),('1444','2014-05-05','10:30:00',2.88),('1444','2014-05-05','10:35:00',2.92),('1444','2014-05-05','10:40:00',2.96),('1444','2014-05-05','10:45:00',2.97),('1444','2014-05-05','10:50:00',2.99),('1444','2014-05-05','10:55:00',3.02),('1444','2014-05-05','11:00:00',3.07),('1444','2014-05-05','11:05:00',3.09),('1444','2014-05-05','11:10:00',3.1),('1444','2014-05-05','11:15:00',3.17),('1444','2014-05-05','11:20:00',3.15),('1444','2014-05-05','11:25:00',3.21),('1444','2014-05-05','11:30:00',3.2),('1444','2014-05-05','11:35:00',3.22),('1444','2014-05-05','11:40:00',3.24),('1444','2014-05-05','11:45:00',3.31),('1444','2014-05-05','11:50:00',3.35),('1444','2014-05-05','11:55:00',3.36),('1444','2014-05-05','12:00:00',3.47),('1444','2014-05-05','12:05:00',2.37),('1444','2014-05-05','12:10:00',1.27),('1444','2014-05-05','12:15:00',1.58),('1444','2014-05-05','12:20:00',1.81),('1444','2014-05-05','12:25:00',1.4),('1444','2014-05-05','12:30:00',2.51),('1444','2014-05-05','12:35:00',2.83),('1444','2014-05-05','12:40:00',1.22),('1444','2014-05-05','12:45:00',2.98),('1444','2014-05-05','12:50:00',3.14),('1444','2014-05-05','12:55:00',1.7),('1444','2014-05-05','13:00:00',1.03),('1444','2014-05-05','13:05:00',1.04),('1444','2014-05-05','13:10:00',3.8),('1444','2014-05-05','13:15:00',3.66),('1444','2014-05-05','13:20:00',3.5),('1444','2014-05-05','13:25:00',3.45),('1444','2014-05-05','13:30:00',3.47),('1444','2014-05-05','13:35:00',3.53),('1444','2014-05-05','13:40:00',3.52),('1444','2014-05-05','13:45:00',3.22),('1444','2014-05-05','13:50:00',3.54),('1444','2014-05-05','13:55:00',3.53),('1444','2014-05-05','14:00:00',3.5),('1444','2014-05-05','14:05:00',2.75),('1444','2014-05-05','14:10:00',1.26),('1444','2014-05-05','14:15:00',3.74),('1444','2014-05-05','14:20:00',3.3),('1444','2014-05-05','14:25:00',3.32),('1444','2014-05-05','14:30:00',3.52),('1444','2014-05-05','14:35:00',2.15),('1444','2014-05-05','14:40:00',2.26),('1444','2014-05-05','14:45:00',1.78),('1444','2014-05-05','14:50:00',1.13),('1444','2014-05-05','14:55:00',1.32),('1444','2014-05-05','15:00:00',2.67),('1444','2014-05-05','15:05:00',3.32),('1444','2014-05-05','15:10:00',3.21),('1444','2014-05-05','15:15:00',1.08),('1444','2014-05-05','15:20:00',1.09),('1444','2014-05-05','15:25:00',1.55),('1444','2014-05-05','15:30:00',1.49),('1444','2014-05-05','15:40:00',3.11),('1444','2014-05-05','15:45:00',2.61),('1444','2014-05-05','15:50:00',1.11),('1444','2014-05-05','16:00:00',1.03),('1444','2014-05-05','16:05:00',1.78),('1444','2014-05-05','16:10:00',2.68),('1444','2014-05-05','16:15:00',1.04),('1444','2014-05-05','16:20:00',1.75),('1444','2014-05-05','16:25:00',1.5),('1444','2014-05-05','16:30:00',1.04),('1444','2014-05-05','16:35:00',2.55),('1444','2014-05-05','16:40:00',2.49),('1444','2014-05-05','16:45:00',2.27),('1444','2014-05-05','16:50:00',2.27),('1444','2014-05-05','16:55:00',2.14),('1444','2014-05-05','17:00:00',2),('1444','2014-05-05','17:05:00',1.91),('1444','2014-05-05','17:10:00',1.93),('1444','2014-05-05','17:15:00',1.86),('1444','2014-05-05','17:20:00',1.77),('1444','2014-05-05','17:25:00',1.68),('1444','2014-05-05','17:30:00',1.59),('1444','2014-05-05','17:35:00',1.49),('1444','2014-05-05','17:40:00',1.43),('1444','2014-05-05','17:45:00',1.37),('1444','2014-05-05','17:50:00',1.3),('1444','2014-05-05','17:55:00',1.23),('1444','2014-05-05','18:00:00',1.15),('1444','2014-05-05','18:05:00',1.09),('1444','2014-05-05','18:10:00',1.03),('1444','2014-04-26','09:55:00',1.08),('1444','2014-04-26','10:00:00',1.15),('1444','2014-04-26','10:05:00',1.01),('1444','2014-04-26','10:15:00',1.04),('1444','2014-04-26','10:20:00',1.21),('1444','2014-04-26','10:25:00',1.42),('1444','2014-04-26','10:30:00',1.59),('1444','2014-04-26','10:35:00',1.65),('1444','2014-04-26','10:40:00',1.48),('1444','2014-04-26','10:45:00',1.69),('1444','2014-04-26','10:50:00',2.27),('1444','2014-04-26','10:55:00',2.74),('1444','2014-04-26','11:00:00',2.8),('1444','2014-04-26','11:05:00',2.76),('1444','2014-04-26','11:10:00',2.46),('1444','2014-04-26','11:15:00',2.44),('1444','2014-04-26','11:20:00',2.39),('1444','2014-04-26','11:25:00',2.28),('1444','2014-04-26','11:30:00',2.37),('1444','2014-04-26','11:35:00',2.43),('1444','2014-04-26','11:40:00',2.34),('1444','2014-04-26','11:45:00',2.42),('1444','2014-04-26','11:50:00',2.36),('1444','2014-04-26','11:55:00',2.29),('1444','2014-04-26','12:00:00',2.4),('1444','2014-04-26','12:05:00',2.66),('1444','2014-04-26','12:10:00',2.76),('1444','2014-04-26','12:15:00',1.8),('1444','2014-04-26','12:20:00',2.18),('1444','2014-04-26','12:25:00',2.55),('1444','2014-04-26','12:30:00',1.67),('1444','2014-04-26','12:35:00',2.97),('1444','2014-04-26','12:40:00',2.75),('1444','2014-04-26','12:45:00',3.15),('1444','2014-04-26','12:50:00',3.32),('1444','2014-04-26','12:55:00',3.33),('1444','2014-04-26','13:00:00',3),('1444','2014-04-26','13:05:00',2.76),('1444','2014-04-26','13:10:00',2.4),('1444','2014-04-26','13:15:00',3.24),('1444','2014-04-26','13:20:00',3.55),('1444','2014-04-26','13:25:00',3.56),('1444','2014-04-26','13:30:00',1.19),('1444','2014-04-26','13:35:00',1.38),('1444','2014-04-26','13:40:00',3.46),('1444','2014-04-26','13:45:00',3.4),('1444','2014-04-26','13:50:00',3.25),('1444','2014-04-26','13:55:00',3.36),('1444','2014-04-26','14:00:00',2.8),('1444','2014-04-26','14:10:00',1.09),('1444','2014-04-26','14:15:00',2.01),('1444','2014-04-26','14:35:00',1.2),('1444','2014-04-26','14:40:00',1.83),('1444','2014-01-26','10:10:00',1.19),('1444','2014-01-26','10:15:00',1.34),('1444','2014-01-26','12:30:00',1.76),('1444','2014-01-26','12:35:00',1.25),('1444','2014-01-26','13:20:00',1.05),('1444','2014-01-25','09:55:00',1.26),('1444','2014-01-25','10:05:00',1.47),('1444','2014-01-25','10:10:00',1.56),('1444','2014-01-25','10:15:00',1.7),('1444','2014-01-25','10:20:00',1.7),('1444','2014-01-25','10:25:00',1.19),('1444','2014-01-25','10:30:00',1.15),('1444','2014-01-25','10:40:00',1.27),('1444','2014-01-25','10:50:00',1.21),('1444','2014-01-25','10:55:00',1.28),('1444','2014-01-25','11:15:00',1.07),('1444','2014-01-25','11:30:00',2.23),('1444','2014-01-25','11:35:00',2.44),('1444','2014-01-25','11:40:00',1.27),('1444','2014-01-25','11:50:00',1.14),('1444','2014-01-25','11:55:00',1.18),('1444','2014-01-25','12:00:00',1.14),('1444','2014-01-25','12:05:00',1.22),('1444','2014-01-25','12:10:00',1.3),('1444','2014-01-25','12:15:00',1.25),('1444','2014-01-25','12:20:00',1.3),('1444','2014-01-25','12:25:00',1.39),('1444','2014-01-25','12:30:00',1.36),('1444','2014-01-25','12:35:00',1.22),('1444','2014-01-25','12:40:00',1.28),('1444','2014-01-25','12:45:00',1.5),('1444','2014-01-25','12:50:00',1.52),('1444','2014-01-25','12:55:00',1.71),('1444','2014-01-25','13:00:00',1.71),('1444','2014-01-25','13:05:00',1.57),('1444','2014-01-25','13:10:00',1.82),('1444','2014-01-25','13:15:00',1.58),('1444','2014-01-25','13:25:00',1.13),('1444','2014-01-25','13:35:00',1.06),('1444','2014-01-25','14:10:00',1.37),('1444','2014-01-25','14:20:00',1.17),('1444','2014-01-25','14:25:00',1.37),('1444','2014-01-25','14:30:00',1.52),('1444','2014-01-25','14:35:00',1.66),('1444','2014-01-25','14:40:00',1.58),('1444','2014-01-25','14:45:00',1.55),('1444','2014-01-25','14:50:00',1.41),('1444','2014-01-25','14:55:00',1.28),('1444','2014-01-25','15:00:00',1.11),('1444','2014-01-25','15:05:00',1.01),('1444','2014-01-24','10:35:00',1.06),('1444','2014-01-24','10:40:00',1.37),('1444','2014-01-24','10:45:00',1.04),('1444','2014-01-24','11:45:00',1.33),('1444','2014-01-24','11:50:00',1.97),('1444','2014-01-24','11:55:00',2.14),('1444','2014-01-24','12:00:00',1.37),('1444','2014-01-24','12:25:00',1.1),('1444','2014-01-24','12:35:00',1.95),('1444','2014-01-24','12:40:00',1.59),('1444','2014-01-24','12:45:00',1.12),('1444','2014-01-24','12:55:00',1.07),('1444','2014-01-24','13:00:00',1.27),('1444','2014-01-24','13:05:00',1.4),('1444','2014-01-24','13:35:00',1.27),('1444','2014-01-24','13:40:00',1.03),('1444','2014-01-24','13:45:00',1.33),('1444','2014-01-24','13:50:00',1.52),('1444','2014-01-24','13:55:00',1.37),('1444','2014-01-24','14:10:00',1.93),('1444','2014-01-24','14:15:00',1.53),('1444','2014-01-24','14:20:00',1.36),('1444','2014-01-24','14:25:00',1.19),('1444','2014-01-22','13:15:00',1.23),('1444','2014-01-21','10:55:00',1.01),('1444','2014-01-21','11:00:00',1.46),('1444','2014-01-21','12:10:00',1.21),('1444','2014-01-21','12:30:00',1.13),('1444','2014-01-21','12:35:00',1.01),('1444','2014-01-21','12:50:00',1),('1444','2014-01-20','11:20:00',1.14),('1444','2014-01-20','11:25:00',1.31),('1444','2014-01-20','11:30:00',1.32),('1444','2014-01-20','11:35:00',1.38),('1444','2014-01-20','11:40:00',1.96),('1444','2014-01-20','11:45:00',1.95),('1444','2014-01-20','11:50:00',1.23),('1444','2014-01-20','13:20:00',2.43),('1444','2014-01-20','13:25:00',2),('1444','2014-01-20','13:30:00',1.74),('1444','2014-01-20','13:35:00',1.71),('1444','2014-01-20','13:40:00',1.37),('1444','2014-01-20','13:45:00',1.3),('1444','2014-01-20','13:55:00',1.06),('1444','2014-01-20','14:00:00',1.78),('1444','2014-01-20','14:05:00',1.19),('1444','2014-01-19','14:25:00',1.08),('1444','2014-01-19','14:30:00',1.23),('1444','2014-01-18','10:05:00',1.07),('1444','2014-01-18','10:10:00',1.37),('1444','2014-01-18','10:15:00',1.46),('1444','2014-01-18','10:20:00',1.24),('1444','2014-01-18','10:25:00',1.01),('1444','2014-01-18','10:30:00',1.06),('1444','2014-01-18','11:10:00',1.21),('1444','2014-01-18','11:15:00',1.69),('1444','2014-01-18','11:20:00',1.6),('1444','2014-01-18','11:25:00',1.53),('1444','2014-01-18','11:30:00',1.57),('1444','2014-01-18','11:35:00',1.62),('1444','2014-01-18','11:40:00',1.69),('1444','2014-01-18','11:45:00',1.86),('1444','2014-01-18','11:50:00',1.84),('1444','2014-01-18','11:55:00',1.91),('1444','2014-01-18','12:00:00',1.84),('1444','2014-01-18','12:05:00',1.34),('1444','2014-01-18','12:10:00',1.75),('1444','2014-01-18','12:15:00',1.64),('1444','2014-01-18','12:20:00',1.64),('1444','2014-01-18','12:25:00',1.62),('1444','2014-01-18','12:30:00',1.64),('1444','2014-01-18','12:35:00',1.63),('1444','2014-01-18','12:40:00',1.64),('1444','2014-01-18','12:45:00',1.56),('1444','2014-01-18','12:50:00',1.48),('1444','2014-01-18','12:55:00',1.7),('1444','2014-01-18','13:00:00',1.12),('1444','2014-01-18','13:05:00',1.07),('1444','2014-01-18','13:10:00',1.38),('1444','2014-01-18','13:15:00',1.65),('1444','2014-01-18','13:20:00',1.07),('1444','2014-01-18','13:30:00',1.41),('1444','2014-01-18','13:40:00',1.29),('1444','2014-01-18','13:45:00',1.42),('1444','2014-01-18','13:50:00',1.06),('1444','2014-01-18','13:55:00',1.36),('1444','2014-01-18','14:00:00',1.34),('1444','2014-01-18','14:05:00',1.26),('1444','2014-01-18','14:10:00',1.17),('1444','2014-01-18','14:15:00',1.11),('1444','2014-01-18','14:20:00',1.14),('1444','2014-01-18','14:25:00',1.08),('1444','2014-01-18','14:30:00',1.04),('1444','2014-01-18','14:35:00',1.02),('1444','2014-01-17','09:40:00',1.01),('1444','2014-01-17','09:45:00',1.12),('1444','2014-01-17','11:30:00',1.25),('1444','2014-01-17','11:35:00',1.32),('1444','2014-01-17','11:40:00',1.19),('1444','2014-01-17','12:05:00',1.01),('1444','2014-04-25','08:10:00',1.04),('1444','2014-04-25','08:15:00',1.08),('1444','2014-04-25','08:20:00',1.14),('1444','2014-04-25','08:25:00',1.2),('1444','2014-04-25','08:30:00',1.24),('1444','2014-04-25','08:35:00',1.31),('1444','2014-04-25','08:40:00',1.36),('1444','2014-04-25','08:45:00',1.44),('1444','2014-04-25','08:50:00',1.53),('1444','2014-04-25','08:55:00',1.64),('1444','2014-04-25','09:00:00',1.28),('1444','2014-04-25','09:25:00',1.21),('1444','2014-04-25','10:00:00',1.04),('1444','2014-04-25','10:05:00',1),('1444','2014-04-25','10:10:00',1.06),('1444','2014-04-25','10:20:00',1.04),('1444','2014-04-25','10:25:00',1.06),('1444','2014-04-25','10:37:00',1.28),('1444','2014-04-25','10:40:00',1.68),('1444','2014-04-25','10:45:00',2.22),('1444','2014-04-25','10:50:00',2.21),('1444','2014-04-25','10:55:00',2.63),('1444','2014-04-25','11:00:00',2.09),('1444','2014-04-25','11:05:00',1.49),('1444','2014-04-25','11:10:00',1.68),('1444','2014-04-25','11:15:00',2.88),('1444','2014-04-25','11:20:00',1.65),('1444','2014-04-25','11:25:00',3.25),('1444','2014-04-25','11:30:00',2.26),('1444','2014-04-25','11:35:00',1.83),('1444','2014-04-25','11:40:00',2.58),('1444','2014-04-25','11:45:00',2.29),('1444','2014-04-25','11:50:00',2.63),('1444','2014-04-25','11:55:00',3.39),('1444','2014-04-25','12:00:00',3),('1444','2014-04-25','12:05:00',2.92),('1444','2014-04-25','12:10:00',2.93),('1444','2014-04-25','12:15:00',1.06),('1444','2014-04-25','12:20:00',2.1),('1444','2014-04-25','12:25:00',3.17),('1444','2014-04-25','12:30:00',3.34),('1444','2014-04-25','12:35:00',3.43),('1444','2014-04-25','12:40:00',3.48),('1444','2014-04-25','12:45:00',3.49),('1444','2014-04-25','12:50:00',3.64),('1444','2014-04-25','12:55:00',3.09),('1444','2014-04-25','13:00:00',3.43),('1444','2014-04-25','13:05:00',3.43),('1444','2014-04-25','13:10:00',3.46),('1444','2014-04-25','13:15:00',3.47),('1444','2014-04-25','13:20:00',2.02),('1444','2014-04-25','13:25:00',2.37),('1444','2014-04-25','13:30:00',1.08),('1444','2014-04-25','13:40:00',1.43),('1444','2014-04-25','13:45:00',1.12),('1444','2014-04-25','13:55:00',1.21),('1444','2014-04-25','14:00:00',1.1),('1444','2014-04-25','14:05:00',1.25),('1444','2014-04-25','14:15:00',1.22),('1444','2014-04-25','14:20:00',1.69),('1444','2014-04-25','14:25:00',1.23),('1444','2014-04-25','14:30:00',3.32),('1444','2014-04-25','14:35:00',2.93),('1444','2014-04-25','14:40:00',2.15),('1444','2014-04-25','14:45:00',2.96),('1444','2014-04-25','14:50:00',2.93),('1444','2014-04-25','14:55:00',2.89),('1444','2014-04-25','15:00:00',2.84),('1444','2014-04-25','15:05:00',2.79),('1444','2014-04-25','15:10:00',2.79),('1444','2014-04-25','15:15:00',2.74),('1444','2014-04-25','15:20:00',2.62),('1444','2014-04-25','15:25:00',2.59),('1444','2014-04-25','15:30:00',2.53),('1444','2014-04-25','15:35:00',2.61),('1444','2014-04-25','15:40:00',2.55),('1444','2014-04-25','15:45:00',2.49),('1444','2014-04-25','15:50:00',2.46),('1444','2014-04-25','15:55:00',2.41),('1444','2014-04-25','16:00:00',2.37),('1444','2014-04-25','16:05:00',2.29),('1444','2014-04-25','16:10:00',2.14),('1444','2014-04-25','16:15:00',2.1),('1444','2014-04-25','16:20:00',1.95),('1444','2014-04-25','16:25:00',2.01),('1444','2014-04-25','16:30:00',2.06),('1444','2014-04-25','16:35:00',2.07),('1444','2014-04-25','16:40:00',2.03),('1444','2014-04-25','16:45:00',1.98),('1444','2014-04-25','16:50:00',1.76),('1444','2014-04-25','16:55:00',1.49),('1444','2014-04-25','17:00:00',1.54),('1444','2014-04-25','17:05:00',1.62),('1444','2014-04-25','17:10:00',1.38),('1444','2014-04-25','17:15:00',1.47),('1444','2014-01-16','09:35:00',1.04),('1444','2014-01-16','09:40:00',1.15),('1444','2014-01-16','09:45:00',1.05),('1444','2014-01-16','10:30:00',1.34),('1444','2014-01-16','10:35:00',1.64),('1444','2014-01-16','10:40:00',1.46),('1444','2014-01-16','10:45:00',1.11),('1444','2014-01-16','10:50:00',1.19),('1444','2014-01-16','10:55:00',1.29),('1444','2014-01-16','11:00:00',1.3),('1444','2014-01-16','11:05:00',1.3),('1444','2014-01-16','11:10:00',1.36),('1444','2014-01-16','11:15:00',1.3),('1444','2014-01-16','11:20:00',1.21),('1444','2014-01-16','11:25:00',1.25),('1444','2014-01-16','11:30:00',1.16),('1444','2014-01-16','11:35:00',1.07),('1444','2014-01-16','11:40:00',1.09),('1444','2014-01-16','11:45:00',1.12),('1444','2014-01-16','11:55:00',1.09),('1444','2014-01-16','12:05:00',1.07),('1444','2014-01-16','12:10:00',1.07),('1444','2014-01-16','12:30:00',1.03),('1444','2014-01-16','12:35:00',1.25),('1444','2014-01-16','12:40:00',1.27),('1444','2014-01-16','12:45:00',1.28),('1444','2014-01-16','12:50:00',1.35),('1444','2014-01-16','12:55:00',1.35),('1444','2014-01-16','13:00:00',1.43),('1444','2014-01-16','13:05:00',1.37),('1444','2014-01-16','13:10:00',1.24),('1444','2014-01-16','13:15:00',1.09),('1444','2014-01-16','13:20:00',1.04),('1444','2014-01-16','13:25:00',1.11),('1444','2014-01-16','13:45:00',1.44),('1444','2014-01-16','13:50:00',1.18),('1444','2014-01-16','13:55:00',1.43),('1444','2014-01-15','10:20:00',1.16),('1444','2014-01-15','10:25:00',1.15),('1444','2014-01-15','10:30:00',1.13),('1444','2014-01-15','10:40:00',1.14),('1444','2014-01-15','11:05:00',1.12),('1444','2014-01-15','11:10:00',1.64),('1444','2014-01-15','11:15:00',1.58),('1444','2014-01-15','11:20:00',1.51),('1444','2014-01-15','11:25:00',1.43),('1444','2014-01-15','11:30:00',1.06),('1444','2014-01-15','11:40:00',1.06),('1444','2014-01-15','11:45:00',1.46),('1444','2014-01-15','11:50:00',1.49),('1444','2014-01-15','11:55:00',1.24),('1444','2014-01-15','12:00:00',1.22),('1444','2014-01-15','12:05:00',1.11),('1444','2014-01-15','12:10:00',1.07),('1444','2014-01-15','12:15:00',1.26),('1444','2014-01-15','12:20:00',1.6),('1444','2014-01-15','12:25:00',1.25),('1444','2014-01-15','12:35:00',1.07),('1444','2014-01-15','13:10:00',1.18),('1444','2014-01-15','13:15:00',1.68),('1444','2014-01-15','13:20:00',1.56),('1444','2014-01-15','13:25:00',1.62),('1444','2014-01-15','13:30:00',1.55),('1444','2014-01-15','13:35:00',1.42),('1444','2014-01-15','13:40:00',1.39),('1444','2014-01-15','13:45:00',1.33),('1444','2014-01-15','14:00:00',1.2),('1444','2014-01-15','14:05:00',1.18),('1444','2014-01-15','14:10:00',1.12),('1444','2014-01-15','14:15:00',1.07),('1444','2014-01-15','14:20:00',1.08),('1444','2014-01-15','14:25:00',1.07),('1444','2014-01-15','14:30:00',1.06),('1444','2014-01-15','14:35:00',1.03),('1444','2014-01-15','14:40:00',1.03),('1444','2014-01-15','14:45:00',1.03),('1444','2014-01-14','10:25:00',1.13),('1444','2014-01-14','10:30:00',1.73),('1444','2014-01-14','10:35:00',1.74),('1444','2014-01-14','10:40:00',1.54),('1444','2014-01-14','10:45:00',1.44),('1444','2014-01-14','11:00:00',1.01),('1444','2014-01-13','10:10:00',1.02),('1444','2014-01-13','10:15:00',1.05),('1444','2014-01-13','10:20:00',1.1),('1444','2014-01-13','10:25:00',1.12),('1444','2014-01-13','10:30:00',1.15),('1444','2014-01-13','10:35:00',1.18),('1444','2014-01-13','10:40:00',1.21),('1444','2014-01-13','10:45:00',1.25),('1444','2014-01-13','10:50:00',1.28),('1444','2014-01-13','10:55:00',1.33),('1444','2014-01-13','11:00:00',1.35),('1444','2014-01-13','11:05:00',1.37),('1444','2014-01-13','11:10:00',1.38),('1444','2014-01-13','11:15:00',1.41),('1444','2014-01-13','11:20:00',1.43),('1444','2014-01-13','11:25:00',1.42),('1444','2014-01-13','11:30:00',1.43),('1444','2014-01-13','11:35:00',1.46),('1444','2014-01-13','11:40:00',1.46),('1444','2014-01-13','11:45:00',1.45),('1444','2014-01-13','11:50:00',1.46),('1444','2014-01-13','11:55:00',1.45),('1444','2014-01-13','12:00:00',1.45),('1444','2014-01-13','12:05:00',1.44),('1444','2014-01-13','12:10:00',1.44),('1444','2014-01-13','12:15:00',1.46),('1444','2014-01-13','12:20:00',1.47),('1444','2014-01-13','12:25:00',1.46),('1444','2014-01-13','12:30:00',1.41),('1444','2014-01-13','12:35:00',1.38),('1444','2014-01-13','12:40:00',1.4),('1444','2014-01-13','12:45:00',1.37),('1444','2014-01-13','12:50:00',1.33),('1444','2014-01-13','12:55:00',1.27),('1444','2014-01-13','13:00:00',1.3),('1444','2014-01-13','13:05:00',1.29),('1444','2014-01-13','13:10:00',1.29),('1444','2014-01-13','13:15:00',1.29),('1444','2014-01-13','13:20:00',1.28),('1444','2014-01-13','13:25:00',1.23),('1444','2014-01-13','13:30:00',1.23),('1444','2014-01-13','13:35:00',1.19),('1444','2014-01-13','13:40:00',1.13),('1444','2014-01-13','13:45:00',1.09),('1444','2014-01-13','13:50:00',1.13),('1444','2014-01-13','13:55:00',1.09),('1444','2014-01-13','14:00:00',1.09),('1444','2014-01-13','14:05:00',1.04),('1444','2014-01-13','14:10:00',1.01),('1444','2014-01-12','10:50:00',1.06),('1444','2014-01-12','10:55:00',1.11),('1444','2014-01-12','11:00:00',1.07),('1444','2014-01-12','11:05:00',1.12),('1444','2014-01-12','11:10:00',1.3),('1444','2014-01-12','11:15:00',1.11),('1444','2014-01-12','11:20:00',1.01),('1444','2014-01-12','11:25:00',1.08),('1444','2014-01-12','11:30:00',1.01),('1444','2014-01-12','11:40:00',1.22),('1444','2014-01-12','11:45:00',1.22),('1444','2014-01-12','11:50:00',1.37),('1444','2014-01-12','11:55:00',1.2),('1444','2014-01-12','12:00:00',1),('1444','2014-01-12','12:05:00',1.01),('1444','2014-01-11','10:35:00',1.02),('1444','2014-01-11','10:40:00',1.29),('1444','2014-01-11','10:45:00',1.36),('1444','2014-01-11','10:50:00',1.38),('1444','2014-01-11','10:55:00',1.39),('1444','2014-01-11','11:00:00',1.36),('1444','2014-01-11','11:05:00',1.29),('1444','2014-01-11','11:10:00',1.43),('1444','2014-01-11','11:15:00',1.24),('1444','2014-01-11','11:20:00',1.2),('1444','2014-01-11','11:25:00',1.21),('1444','2014-01-11','11:30:00',1.21),('1444','2014-01-11','11:35:00',1.06),('1444','2014-01-11','11:45:00',1.03),('1444','2014-01-11','11:50:00',1.14),('1444','2014-01-11','11:55:00',1.16),('1444','2014-01-11','12:00:00',1.23),('1444','2014-01-11','12:05:00',1.36),('1444','2014-01-11','12:10:00',1.23),('1444','2014-01-11','12:15:00',1.2),('1444','2014-01-11','12:20:00',1.21),('1444','2014-01-11','12:25:00',1.1),('1444','2014-01-11','12:30:00',1.02),('1444','2014-01-11','12:50:00',1.16),('1444','2014-01-11','12:55:00',1.21),('1444','2014-01-11','13:00:00',1.2),('1444','2014-01-11','13:05:00',1.05),('1444','2014-01-11','13:15:00',1.28),('1444','2014-01-11','13:20:00',1.06),('1444','2014-01-09','09:40:00',1.04),('1444','2014-01-09','09:45:00',1.12),('1444','2014-01-09','09:50:00',1.15),('1444','2014-01-09','09:55:00',1.12),('1444','2014-01-09','10:00:00',1.16),('1444','2014-01-09','10:05:00',1.11),('1444','2014-01-09','10:10:00',1.01),('1444','2014-01-09','10:15:00',1.02),('1444','2014-01-09','10:20:00',1.06),('1444','2014-01-09','10:25:00',1.14),('1444','2014-01-09','10:30:00',1.16),('1444','2014-01-09','10:35:00',1.25),('1444','2014-01-09','10:40:00',1.39),('1444','2014-01-09','10:45:00',1.1),('1444','2014-01-09','11:20:00',1.07),('1444','2014-01-09','11:35:00',1.1),('1444','2014-01-09','11:40:00',1.29),('1444','2014-01-08','10:15:00',1.01),('1444','2014-01-08','10:20:00',1.13),('1444','2014-01-08','10:25:00',1.16),('1444','2014-01-08','10:30:00',1.19),('1444','2014-01-08','10:35:00',1.17),('1444','2014-01-08','10:40:00',1.15),('1444','2014-01-08','10:45:00',1.26),('1444','2014-01-08','10:50:00',1.31),('1444','2014-01-08','10:55:00',1.35),('1444','2014-01-08','11:00:00',1.37),('1444','2014-01-08','11:05:00',1.4),('1444','2014-01-08','11:10:00',1.42),('1444','2014-01-08','11:15:00',1.44),('1444','2014-01-08','11:20:00',1.45),('1444','2014-01-08','11:25:00',1.45),('1444','2014-01-08','11:30:00',1.44),('1444','2014-01-08','11:35:00',1.52),('1444','2014-01-08','11:40:00',1.53),('1444','2014-01-08','11:45:00',1.54),('1444','2014-01-08','11:50:00',1.49),('1444','2014-01-08','11:55:00',1.48),('1444','2014-01-08','12:00:00',1.48),('1444','2014-01-08','12:05:00',1.47),('1444','2014-01-08','12:10:00',1.45),('1444','2014-01-08','12:15:00',1.48),('1444','2014-01-08','12:20:00',1.45),('1444','2014-01-08','12:25:00',1.43),('1444','2014-01-08','12:30:00',1.43),('1444','2014-01-08','12:35:00',1.41),('1444','2014-01-08','12:40:00',1.37),('1444','2014-01-08','12:45:00',1.33),('1444','2014-01-08','12:50:00',1.35),('1444','2014-01-08','12:55:00',1.35),('1444','2014-01-08','13:00:00',1.31),('1444','2014-01-08','13:05:00',1.34),('1444','2014-01-08','13:10:00',1.28),('1444','2014-01-08','13:15:00',1.27),('1444','2014-01-08','13:20:00',1.24),('1444','2014-01-08','13:25:00',1.24),('1444','2014-01-08','13:30:00',1.2),('1444','2014-01-08','13:35:00',1.18),('1444','2014-01-08','13:40:00',1.14),('1444','2014-01-08','13:45:00',1.12),('1444','2014-01-08','13:50:00',1.12),('1444','2014-01-08','13:55:00',1.08),('1444','2014-01-08','14:00:00',1.05),('1444','2014-01-08','14:05:00',1.04),('1444','2014-01-08','14:10:00',1.02),('1444','2014-01-08','14:15:00',1.02),('1444','2014-01-08','14:20:00',1.02),('1444','2014-01-07','10:05:00',1.04),('1444','2014-01-07','10:10:00',1.06),('1444','2014-01-07','10:15:00',1.1),('1444','2014-01-07','10:20:00',1.13),('1444','2014-01-07','10:25:00',1.16),('1444','2014-01-07','10:30:00',1.21),('1444','2014-01-07','10:35:00',1.24),('1444','2014-01-07','10:40:00',1.28),('1444','2014-01-07','10:45:00',1.31),('1444','2014-01-07','10:50:00',1.34),('1444','2014-01-07','10:55:00',1.38),('1444','2014-01-07','11:00:00',1.4),('1444','2014-01-07','11:05:00',1.42),('1444','2014-01-07','11:10:00',1.43),('1444','2014-01-07','11:15:00',1.46),('1444','2014-01-07','11:20:00',1.48),('1444','2014-01-07','11:25:00',1.48),('1444','2014-01-07','11:30:00',1.51),('1444','2014-01-07','11:35:00',1.52),('1444','2014-01-07','11:40:00',1.52),('1444','2014-01-07','11:45:00',1.54),('1444','2014-01-07','11:50:00',1.54),('1444','2014-01-07','11:55:00',1.54),('1444','2014-01-07','12:00:00',1.55),('1444','2014-01-07','12:05:00',1.53),('1444','2014-01-07','12:10:00',1.52),('1444','2014-01-07','12:15:00',1.5),('1444','2014-01-07','12:20:00',1.46),('1444','2014-01-07','12:25:00',1.48),('1444','2014-01-07','12:30:00',1.49),('1444','2014-01-07','12:35:00',1.46),('1444','2014-01-07','12:40:00',1.39),('1444','2014-01-07','12:45:00',1.44),('1444','2014-01-07','12:50:00',1.41),('1444','2014-01-07','12:55:00',1.37),('1444','2014-01-07','13:00:00',1.29),('1444','2014-01-07','13:05:00',1.26),('1444','2014-01-07','13:10:00',1.3),('1444','2014-01-07','13:15:00',1.31),('1444','2014-01-07','13:20:00',1.28),('1444','2014-01-07','13:25:00',1.17),('1444','2014-01-07','13:30:00',1.15),('1444','2014-01-07','13:35:00',1.18),('1444','2014-01-07','13:40:00',1.18),('1444','2014-01-07','13:45:00',1.19),('1444','2014-01-07','13:50:00',1.18),('1444','2014-01-07','13:55:00',1.13),('1444','2014-01-07','14:00:00',1.09),('1444','2014-01-07','14:05:00',1.05),('1444','2014-01-07','14:10:00',1),('1444','2014-01-07','14:22:00',1),('1444','2014-04-24','08:10:00',1.06),('1444','2014-04-24','08:15:00',1.11),('1444','2014-04-24','08:20:00',1.17),('1444','2014-04-24','08:25:00',1.24),('1444','2014-04-24','08:30:00',1.29),('1444','2014-04-24','08:35:00',1.36),('1444','2014-04-24','08:40:00',1.42),('1444','2014-04-24','08:45:00',1.49),('1444','2014-04-24','08:50:00',1.55),('1444','2014-04-24','08:55:00',1.61),('1444','2014-04-24','09:00:00',1.68),('1444','2014-04-24','09:05:00',1.72),('1444','2014-04-24','09:10:00',1.79),('1444','2014-04-24','09:15:00',1.85),('1444','2014-04-24','09:20:00',1.89),('1444','2014-04-24','09:25:00',1.94),('1444','2014-04-24','09:30:00',2),('1444','2014-04-24','09:35:00',2.07),('1444','2014-04-24','09:40:00',2.11),('1444','2014-04-24','09:45:00',2.17),('1444','2014-04-24','09:50:00',2.2),('1444','2014-04-24','09:55:00',2.26),('1444','2014-04-24','10:00:00',2.29),('1444','2014-04-24','10:05:00',2.35),('1444','2014-04-24','10:10:00',2.4),('1444','2014-04-24','10:15:00',2.44),('1444','2014-04-24','10:20:00',2.48),('1444','2014-04-24','10:25:00',2.51),('1444','2014-04-24','10:30:00',2.55),('1444','2014-04-24','10:35:00',2.58),('1444','2014-04-24','10:40:00',2.59),('1444','2014-04-24','10:45:00',2.64),('1444','2014-04-24','10:50:00',2.69),('1444','2014-04-24','10:55:00',2.74),('1444','2014-04-24','11:00:00',2.74),('1444','2014-04-24','11:05:00',2.79),('1444','2014-04-24','11:10:00',2.78),('1444','2014-04-24','11:15:00',2.8),('1444','2014-04-24','11:20:00',2.83),('1444','2014-04-24','11:25:00',2.83),('1444','2014-04-24','11:30:00',2.84),('1444','2014-04-24','11:35:00',2.87),('1444','2014-04-24','11:40:00',2.95),('1444','2014-04-24','11:45:00',2.95),('1444','2014-04-24','11:50:00',2.98),('1444','2014-04-24','11:55:00',2.98),('1444','2014-04-24','12:00:00',2.96),('1444','2014-04-24','12:05:00',3.04),('1444','2014-04-24','12:10:00',1.83),('1444','2014-04-24','12:15:00',2.25),('1444','2014-04-24','12:20:00',3.26),('1444','2014-04-24','12:25:00',3.17),('1444','2014-04-24','12:30:00',3.02),('1444','2014-04-24','12:35:00',3.25),('1444','2014-04-24','12:40:00',3.22),('1444','2014-04-24','12:45:00',3.15),('1444','2014-04-24','12:50:00',3.22),('1444','2014-04-24','12:55:00',3.05),('1444','2014-04-24','13:00:00',3.19),('1444','2014-04-24','13:05:00',3.2),('1444','2014-04-24','13:10:00',3.25),('1444','2014-04-24','13:15:00',3.31),('1444','2014-04-24','13:20:00',3.27),('1444','2014-04-24','13:25:00',2.94),('1444','2014-04-24','13:30:00',1.52),('1444','2014-04-24','13:35:00',2.7),('1444','2014-04-24','13:40:00',1.62),('1444','2014-04-24','13:45:00',1.73),('1444','2014-04-24','13:50:00',3.63),('1444','2014-04-24','13:55:00',3.58),('1444','2014-04-24','14:00:00',3.59),('1444','2014-04-24','14:05:00',3.51),('1444','2014-04-24','14:10:00',3.21),('1444','2014-04-24','14:15:00',3.55),('1444','2014-04-24','14:20:00',3.38),('1444','2014-04-24','14:25:00',3.34),('1444','2014-04-24','14:30:00',2.61),('1444','2014-04-24','14:35:00',2.89),('1444','2014-04-24','14:40:00',2.47),('1444','2014-04-24','14:45:00',1.65),('1444','2014-04-24','14:50:00',2.02),('1444','2014-04-24','14:55:00',3.53),('1444','2014-04-24','15:00:00',3.33),('1444','2014-04-24','15:05:00',3.28),('1444','2014-04-24','15:10:00',3.43),('1444','2014-04-24','15:15:00',3.17),('1444','2014-04-24','15:20:00',2.46),('1444','2014-04-24','15:25:00',1.73),('1444','2014-04-24','15:30:00',2.19),('1444','2014-04-24','15:35:00',2.13),('1444','2014-04-24','15:40:00',1.93),('1444','2014-04-24','15:45:00',1.69),('1444','2014-04-24','15:50:00',1.99),('1444','2014-04-24','15:55:00',2.13),('1444','2014-04-24','16:00:00',2.96),('1444','2014-04-24','16:05:00',2.62),('1444','2014-04-24','16:10:00',2.29),('1444','2014-04-24','16:15:00',2.87),('1444','2014-04-24','16:20:00',2.66),('1444','2014-04-24','16:25:00',2.05),('1444','2014-04-24','16:30:00',1.9),('1444','2014-04-24','16:35:00',1.57),('1444','2014-04-24','16:40:00',1.55),('1444','2014-04-24','16:45:00',1.21),('1444','2014-04-24','16:55:00',1.02),('1444','2014-04-24','17:00:00',1.07),('1444','2014-01-06','11:40:00',1.56),('1444','2014-01-06','11:45:00',1.65),('1444','2014-01-06','11:50:00',1.32),('1444','2014-01-06','12:00:00',1.5),('1444','2014-01-06','12:05:00',1.44),('1444','2014-01-06','12:10:00',1.54),('1444','2014-01-06','12:15:00',1.51),('1444','2014-01-06','12:20:00',1.44),('1444','2014-01-06','12:25:00',1.42),('1444','2014-01-06','12:30:00',1.45),('1444','2014-01-06','12:35:00',1.45),('1444','2014-01-06','12:40:00',1.44),('1444','2014-01-06','12:45:00',1.44),('1444','2014-01-06','12:50:00',1.44),('1444','2014-01-06','12:55:00',1.36),('1444','2014-01-06','13:00:00',1.36),('1444','2014-01-06','13:05:00',1.34),('1444','2014-01-06','13:10:00',1.35),('1444','2014-01-06','13:15:00',1.43),('1444','2014-01-06','13:20:00',1.36),('1444','2014-01-06','13:25:00',1.3),('1444','2014-01-06','13:30:00',1.24),('1444','2014-01-06','13:35:00',1.19),('1444','2014-01-06','13:40:00',1.16),('1444','2014-01-06','13:45:00',1.14),('1444','2014-01-06','13:50:00',1.12),('1444','2014-01-06','13:55:00',1.09),('1444','2014-01-06','14:15:00',1.13),('1444','2014-01-06','14:45:00',1.1),('1444','2014-01-03','09:40:00',1.07),('1444','2014-01-03','09:45:00',1.09),('1444','2014-01-03','10:00:00',1.03),('1444','2014-01-03','12:00:00',1.22),('1444','2014-01-03','12:05:00',1.34),('1444','2014-01-03','12:10:00',1.74),('1444','2014-01-03','12:15:00',1.44),('1444','2014-01-03','12:20:00',1.65),('1444','2014-01-03','12:25:00',1.5),('1444','2014-01-03','12:30:00',1.37),('1444','2014-01-03','12:35:00',1.12),('1444','2014-01-03','12:40:00',1.1),('1444','2014-01-03','12:45:00',1.11),('1444','2014-01-03','12:50:00',1.04),('1444','2014-01-03','13:05:00',1.14),('1444','2014-01-03','13:10:00',1.09),('1444','2014-01-03','13:35:00',1.06),('1444','2014-01-02','10:05:00',1.01),('1444','2014-01-02','10:10:00',1.04),('1444','2014-01-02','10:15:00',1.08),('1444','2014-01-02','10:20:00',1.1),('1444','2014-01-02','10:25:00',1.13),('1444','2014-01-02','10:30:00',1.16),('1444','2014-01-02','10:35:00',1.18),('1444','2014-01-02','10:40:00',1.22),('1444','2014-01-02','10:45:00',1.25),('1444','2014-01-02','10:50:00',1.31),('1444','2014-01-02','10:55:00',1.41),('1444','2014-01-02','11:00:00',1.45),('1444','2014-01-02','11:05:00',1.4),('1444','2014-01-02','11:25:00',1.09),('1444','2014-01-02','11:30:00',1.16),('1444','2014-01-02','11:35:00',1.47),('1444','2014-01-02','11:40:00',1.3),('1444','2014-01-02','11:45:00',1.13),('1444','2014-01-02','12:50:00',1.08),('1444','2014-01-02','12:55:00',1.06),('1444','2014-01-02','13:30:00',1.01),('1444','2014-01-02','13:35:00',1.27),('1444','2014-01-02','13:40:00',1.25),('1444','2014-01-01','09:35:00',1.06),('1444','2014-01-01','09:45:00',1.08),('1444','2014-01-01','09:50:00',1.27),('1444','2014-01-01','09:55:00',1.14),('1444','2014-01-01','13:50:00',1.53),('1444','2014-01-01','13:55:00',1.04),('1444','2013-12-31','11:30:00',1.64),('1444','2013-12-31','11:35:00',1.29),('1444','2013-12-31','11:40:00',1.47),('1444','2013-12-31','12:00:00',1.48),('1444','2013-12-31','12:05:00',1.59),('1444','2013-12-31','12:10:00',1.55),('1444','2013-12-31','12:15:00',1.54),('1444','2013-12-31','12:20:00',1.52),('1444','2013-12-31','12:25:00',1.49),('1444','2013-12-31','12:30:00',1.47),('1444','2013-12-31','12:35:00',1.44),('1444','2013-12-31','12:40:00',1.43),('1444','2013-12-31','12:45:00',1.44),('1444','2013-12-31','12:50:00',1.4),('1444','2013-12-31','12:55:00',1.38),('1444','2013-12-31','13:00:00',1.38),('1444','2013-12-31','13:05:00',1.36),('1444','2013-12-31','13:10:00',1.33),('1444','2013-12-31','13:15:00',1.33),('1444','2013-12-31','13:20:00',1.29),('1444','2013-12-31','13:25:00',1.26),('1444','2013-12-31','13:30:00',1.23),('1444','2013-12-31','13:35:00',1.22),('1444','2013-12-31','13:40:00',1.17),('1444','2013-12-31','13:45:00',1.14),('1444','2013-12-31','13:50:00',1.11),('1444','2013-12-31','13:55:00',1.08),('1444','2013-12-31','14:00:00',1.08),('1444','2013-12-31','14:05:00',1.05),('1444','2013-12-31','14:10:00',1.01),('1444','2013-12-29','10:10:00',1.01),('1444','2013-12-29','10:15:00',1.05),('1444','2013-12-29','10:20:00',1.15),('1444','2013-12-29','10:25:00',1.1),('1444','2013-12-29','10:30:00',1.3),('1444','2013-12-29','10:35:00',1.58),('1444','2013-12-29','10:40:00',1.04),('1444','2013-12-29','10:55:00',1.08),('1444','2013-12-28','10:05:00',1.02),('1444','2013-12-28','10:10:00',1.06),('1444','2013-12-28','10:15:00',1.08),('1444','2013-12-28','10:20:00',1.12),('1444','2013-12-28','10:25:00',1.15),('1444','2013-12-28','10:30:00',1.2),('1444','2013-12-28','10:35:00',1.23),('1444','2013-12-28','10:40:00',1.26),('1444','2013-12-28','10:45:00',1.3),('1444','2013-12-28','10:50:00',1.35),('1444','2013-12-28','10:55:00',1.37),('1444','2013-12-28','11:00:00',1.39),('1444','2013-12-28','11:05:00',1.41),('1444','2013-12-28','11:10:00',1.43),('1444','2013-12-28','11:15:00',1.45),('1444','2013-12-28','11:20:00',1.46),('1444','2013-12-28','11:25:00',1.48),('1444','2013-12-28','11:30:00',1.49),('1444','2013-12-28','11:35:00',1.5),('1444','2013-12-28','11:40:00',1.5),('1444','2013-12-28','11:45:00',1.5),('1444','2013-12-28','11:50:00',1.48),('1444','2013-12-28','11:55:00',1.46),('1444','2013-12-28','12:00:00',1.5),('1444','2013-12-28','12:05:00',1.48),('1444','2013-12-28','12:10:00',1.49),('1444','2013-12-28','12:15:00',1.47),('1444','2013-12-28','12:20:00',1.44),('1444','2013-12-28','12:25:00',1.42),('1444','2013-12-28','12:30:00',1.41),('1444','2013-12-28','12:35:00',1.4),('1444','2013-12-28','12:40:00',1.4),('1444','2013-12-28','12:45:00',1.36),('1444','2013-12-28','12:50:00',1.31),('1444','2013-12-28','12:55:00',1.32),('1444','2013-12-28','13:00:00',1.3),('1444','2013-12-28','13:05:00',1.28),('1444','2013-12-28','13:10:00',1.27),('1444','2013-12-28','13:15:00',1.22),('1444','2013-12-28','13:20:00',1.18),('1444','2013-12-28','13:25:00',1.15),('1444','2013-12-28','13:30:00',1.12),('1444','2013-12-28','13:35:00',1.11),('1444','2013-12-28','13:40:00',1.08),('1444','2013-12-28','13:45:00',1.04),('1444','2013-12-28','13:50:00',1.03),('1444','2013-12-28','13:55:00',1.02),('1444','2014-04-23','13:20:00',1.04),('1444','2014-04-23','13:25:00',1.08),('1444','2014-04-23','13:30:00',1.16),('1444','2014-04-23','13:35:00',1.2),('1444','2014-04-23','13:40:00',1.27),('1444','2014-04-23','13:45:00',1.29),('1444','2014-04-23','13:50:00',1.27),('1444','2014-04-23','13:55:00',1.28),('1444','2014-04-23','14:00:00',1.21),('1444','2014-04-23','14:05:00',1.22),('1444','2014-04-23','14:10:00',1.17),('1444','2014-04-23','14:55:00',1.16),('1444','2014-04-23','15:00:00',1.29),('1444','2014-04-23','15:05:00',1.35),('1444','2014-04-23','15:10:00',1.33),('1444','2014-04-23','15:15:00',1.45),('1444','2014-04-23','15:20:00',1.23),('1444','2014-04-23','15:25:00',1.09),('1444','2014-04-23','15:30:00',1.02),('1444','2013-12-27','12:10:00',1.09),('1444','2013-12-27','12:15:00',1.1),('1444','2013-12-27','12:20:00',1.29),('1444','2013-12-27','12:45:00',1.1),('1444','2013-12-27','12:50:00',1.28),('1444','2013-12-27','12:55:00',1.29),('1444','2013-12-27','13:00:00',1.32),('1444','2013-12-27','13:05:00',1.15),('1444','2013-12-27','13:20:00',1.08),('1444','2013-12-27','13:25:00',1.01),('1444','2013-12-27','13:30:00',1.44),('1444','2013-12-27','13:35:00',1.34),('1444','2013-12-25','11:20:00',1.3),('1444','2013-12-25','11:30:00',1.1),('1444','2013-12-25','11:40:00',1.15),('1444','2013-12-25','11:45:00',1.27),('1444','2013-12-25','11:55:00',1.46),('1444','2013-12-25','12:00:00',1.03),('1444','2013-12-25','12:25:00',1.06),('1444','2013-12-24','10:20:00',1.03),('1444','2013-12-24','10:25:00',1.06),('1444','2013-12-24','10:30:00',1.09),('1444','2013-12-24','10:35:00',1.11),('1444','2013-12-24','10:40:00',1.14),('1444','2013-12-24','10:45:00',1.16),('1444','2013-12-24','10:50:00',1.2),('1444','2013-12-24','10:55:00',1.21),('1444','2013-12-24','11:00:00',1.22),('1444','2013-12-24','11:05:00',1.23),('1444','2013-12-24','11:10:00',1.24),('1444','2013-12-24','11:15:00',1.25),('1444','2013-12-24','11:20:00',1.27),('1444','2013-12-24','11:25:00',1.3),('1444','2013-12-24','11:30:00',1.31),('1444','2013-12-24','11:35:00',1.33),('1444','2013-12-24','11:40:00',1.33),('1444','2013-12-24','11:45:00',1.34),('1444','2013-12-24','11:50:00',1.28),('1444','2013-12-24','11:55:00',1.33),('1444','2013-12-24','12:00:00',1.33),('1444','2013-12-24','12:05:00',1.29),('1444','2013-12-24','12:10:00',1.3),('1444','2013-12-24','12:15:00',1.29),('1444','2013-12-24','12:20:00',1.25),('1444','2013-12-24','12:25:00',1.25),('1444','2013-12-24','12:30:00',1.23),('1444','2013-12-24','12:35:00',1.2),('1444','2013-12-24','12:40:00',1.2),('1444','2013-12-24','12:45:00',1.17),('1444','2013-12-24','12:50:00',1.16),('1444','2013-12-24','12:55:00',1.14),('1444','2013-12-24','13:00:00',1.12),('1444','2013-12-24','13:05:00',1.12),('1444','2013-12-24','13:10:00',1.12),('1444','2013-12-24','13:15:00',1.06),('1444','2013-12-24','13:20:00',1.03),('1444','2013-12-24','13:25:00',1.02),('1444','2013-12-23','10:00:00',1.07),('1444','2013-12-23','10:05:00',1.14),('1444','2013-12-23','10:10:00',1.09),('1444','2013-12-23','10:15:00',1.14),('1444','2013-12-23','10:20:00',1.16),('1444','2013-12-23','10:25:00',1.13),('1444','2013-12-23','10:30:00',1.09),('1444','2013-12-23','10:35:00',1.12),('1444','2013-12-23','10:40:00',1.17),('1444','2013-12-23','10:45:00',1.19),('1444','2013-12-23','10:50:00',1.22),('1444','2013-12-23','10:55:00',1.37),('1444','2013-12-23','11:00:00',1.46),('1444','2013-12-23','11:05:00',1.48),('1444','2013-12-23','11:10:00',1.48),('1444','2013-12-23','11:15:00',1.42),('1444','2013-12-23','11:20:00',1.46),('1444','2013-12-23','11:25:00',1.4),('1444','2013-12-23','11:30:00',1.46),('1444','2013-12-23','11:35:00',1.51),('1444','2013-12-23','11:40:00',1.35),('1444','2013-12-23','11:45:00',1.29),('1444','2013-12-23','11:50:00',1.34),('1444','2013-12-23','11:55:00',1.39),('1444','2013-12-23','12:00:00',1.42),('1444','2013-12-23','12:05:00',1.4),('1444','2013-12-23','12:10:00',1.39),('1444','2013-12-23','12:15:00',1.37),('1444','2013-12-23','12:20:00',1.34),('1444','2013-12-23','12:25:00',1.29),('1444','2013-12-23','12:30:00',1.25),('1444','2013-12-23','12:35:00',1.23),('1444','2013-12-23','12:40:00',1.32),('1444','2013-12-23','12:45:00',1.29),('1444','2013-12-23','12:50:00',1.27),('1444','2013-12-23','12:55:00',1.28),('1444','2013-12-23','13:00:00',1.27),('1444','2013-12-23','13:05:00',1.24),('1444','2013-12-23','13:10:00',1.22),('1444','2013-12-23','13:15:00',1.13),('1444','2013-12-23','13:25:00',1.08),('1444','2013-12-22','09:35:00',1.04),('1444','2013-12-22','09:40:00',1.16),('1444','2013-12-22','09:45:00',1.21),('1444','2013-12-22','09:50:00',1.27),('1444','2013-12-22','09:55:00',1.24),('1444','2013-12-22','10:00:00',1.23),('1444','2013-12-22','10:05:00',1.23),('1444','2013-12-22','10:10:00',1.26),('1444','2013-12-22','10:15:00',1.24),('1444','2013-12-22','10:20:00',1.2),('1444','2013-12-22','10:25:00',1.23),('1444','2013-12-22','10:30:00',1.3),('1444','2013-12-22','10:35:00',1.21),('1444','2013-12-22','10:40:00',1.15),('1444','2013-12-22','10:45:00',1.27),('1444','2013-12-22','10:50:00',1.25),('1444','2013-12-22','10:55:00',1.19),('1444','2013-12-22','11:00:00',1.07),('1444','2013-12-22','11:05:00',1.25),('1444','2013-12-22','11:10:00',1.5),('1444','2013-12-22','11:15:00',1.42),('1444','2013-12-22','11:20:00',1.31),('1444','2013-12-22','11:25:00',1.33),('1444','2013-12-22','11:30:00',1.24),('1444','2013-12-22','11:35:00',1.28),('1444','2013-12-22','11:40:00',1.34),('1444','2013-12-22','11:45:00',1.21),('1444','2013-12-22','12:30:00',1.04),('1444','2013-12-22','12:35:00',1.14),('1444','2013-12-22','12:40:00',1.09),('1444','2013-12-22','12:45:00',1.1),('1444','2013-12-22','12:50:00',1.27),('1444','2013-12-22','12:55:00',1.47),('1444','2013-12-22','13:00:00',1.42),('1444','2013-12-22','13:05:00',1.63),('1444','2013-12-22','13:10:00',1.55),('1444','2013-12-22','13:15:00',1.25),('1444','2013-12-22','13:20:00',1.19),('1444','2013-12-22','13:25:00',1.17),('1444','2013-12-22','13:30:00',1.08),('1444','2013-12-21','10:10:00',1.01),('1444','2013-12-21','10:15:00',1.04),('1444','2013-12-21','10:20:00',1.07),('1444','2013-12-21','10:25:00',1.1),('1444','2013-12-21','10:30:00',1.14),('1444','2013-12-21','10:35:00',1.17),('1444','2013-12-21','10:40:00',1.21),('1444','2013-12-21','10:45:00',1.24),('1444','2013-12-21','10:50:00',1.26),('1444','2013-12-21','10:55:00',1.29),('1444','2013-12-21','11:00:00',1.31),('1444','2013-12-21','11:05:00',1.34),('1444','2013-12-21','11:10:00',1.35),('1444','2013-12-21','11:15:00',1.37),('1444','2013-12-21','11:20:00',1.38),('1444','2013-12-21','11:25:00',1.39),('1444','2013-12-21','11:30:00',1.41),('1444','2013-12-21','11:35:00',1.42),('1444','2013-12-21','11:40:00',1.44),('1444','2013-12-21','11:45:00',1.44),('1444','2013-12-21','11:50:00',1.45),('1444','2013-12-21','11:55:00',1.45),('1444','2013-12-21','12:00:00',1.44),('1444','2013-12-21','12:05:00',1.43),('1444','2013-12-21','12:10:00',1.43),('1444','2013-12-21','12:15:00',1.42),('1444','2013-12-21','12:20:00',1.4),('1444','2013-12-21','12:25:00',1.39),('1444','2013-12-21','12:30:00',1.37),('1444','2013-12-21','12:35:00',1.36),('1444','2013-12-21','12:40:00',1.37),('1444','2013-12-21','12:45:00',1.29),('1444','2013-12-21','12:50:00',1.31),('1444','2013-12-21','12:55:00',1.31),('1444','2013-12-21','13:00:00',1.28),('1444','2013-12-21','13:05:00',1.25),('1444','2013-12-21','13:10:00',1.24),('1444','2013-12-21','13:15:00',1.19),('1444','2013-12-21','13:20:00',1.19),('1444','2013-12-21','13:25:00',1.14),('1444','2013-12-21','13:30:00',1.14),('1444','2013-12-21','13:35:00',1.1),('1444','2013-12-21','13:40:00',1.07),('1444','2013-12-21','13:45:00',1.04),('1444','2013-12-21','13:50:00',1.01),('1444','2013-12-21','13:55:00',1.01),('1444','2013-12-20','10:25:00',1.03),('1444','2013-12-20','10:30:00',1.07),('1444','2013-12-20','10:35:00',1.14),('1444','2013-12-20','10:40:00',1.17),('1444','2013-12-20','10:45:00',1.2),('1444','2013-12-20','10:50:00',1.23),('1444','2013-12-20','10:55:00',1.26),('1444','2013-12-20','11:00:00',1.28),('1444','2013-12-20','11:05:00',1.3),('1444','2013-12-20','11:10:00',1.31),('1444','2013-12-20','11:15:00',1.32),('1444','2013-12-20','11:20:00',1.33),('1444','2013-12-20','11:25:00',1.34),('1444','2013-12-20','11:30:00',1.36),('1444','2013-12-20','11:35:00',1.37),('1444','2013-12-20','11:40:00',1.36),('1444','2013-12-20','11:45:00',1.37),('1444','2013-12-20','11:50:00',1.4),('1444','2013-12-20','11:55:00',1.37),('1444','2013-12-20','12:00:00',1.37),('1444','2013-12-20','12:05:00',1.37),('1444','2013-12-20','12:10:00',1.36),('1444','2013-12-20','12:15:00',1.34),('1444','2013-12-20','12:20:00',1.34),('1444','2013-12-20','12:25:00',1.32),('1444','2013-12-20','12:30:00',1.3),('1444','2013-12-20','12:35:00',1.3),('1444','2013-12-20','12:40:00',1.29),('1444','2013-12-20','12:45:00',1.25),('1444','2013-12-20','12:50:00',1.24),('1444','2013-12-20','12:55:00',1.22),('1444','2013-12-20','13:00:00',1.19),('1444','2013-12-20','13:05:00',1.18),('1444','2013-12-20','13:10:00',1.15),('1444','2013-12-20','13:15:00',1.11),('1444','2013-12-20','13:20:00',1.07),('1444','2013-12-20','13:25:00',1.02),('1444','2013-12-19','09:50:00',1.04),('1444','2013-12-19','09:55:00',1.12),('1444','2013-12-19','10:00:00',1.03),('1444','2013-12-19','10:05:00',1.18),('1444','2013-12-19','10:10:00',1.26),('1444','2013-12-19','10:15:00',1.13),('1444','2013-12-19','10:40:00',1.16),('1444','2013-12-19','10:45:00',1.46),('1444','2013-12-19','14:30:00',1.02),('1444','2013-12-18','10:05:00',1.01),('1444','2013-12-18','10:10:00',1.05),('1444','2013-12-18','10:15:00',1.08),('1444','2013-12-18','10:20:00',1.11),('1444','2013-12-18','10:25:00',1.15),('1444','2013-12-18','10:30:00',1.18),('1444','2013-12-18','10:35:00',1.24),('1444','2013-12-18','10:40:00',1.26),('1444','2013-12-18','10:45:00',1.29),('1444','2013-12-18','10:50:00',1.32),('1444','2013-12-18','10:55:00',1.33),('1444','2013-12-18','11:00:00',1.35),('1444','2013-12-18','11:05:00',1.38),('1444','2013-12-18','11:10:00',1.39),('1444','2013-12-18','11:15:00',1.4),('1444','2013-12-18','11:20:00',1.4),('1444','2013-12-18','11:25:00',1.41),('1444','2013-12-18','11:30:00',1.43),('1444','2013-12-18','11:35:00',1.44),('1444','2013-12-18','11:40:00',1.44),('1444','2013-12-18','11:45:00',1.43),('1444','2013-12-18','11:50:00',1.44),('1444','2013-12-18','11:55:00',1.44),('1444','2013-12-18','12:00:00',1.41),('1444','2013-12-18','12:05:00',1.41),('1444','2013-12-18','12:10:00',1.4),('1444','2013-12-18','12:15:00',1.38),('1444','2013-12-18','12:20:00',1.39),('1444','2013-12-18','12:25:00',1.38),('1444','2013-12-18','12:30:00',1.36),('1444','2013-12-18','12:35:00',1.34),('1444','2013-12-18','12:40:00',1.36),('1444','2013-12-18','12:45:00',1.28),('1444','2013-12-18','12:50:00',1.28),('1444','2013-12-18','12:55:00',1.31),('1444','2013-12-18','13:00:00',1.28),('1444','2013-12-18','13:05:00',1.22),('1444','2013-12-18','13:10:00',1.22),('1444','2013-12-18','13:15:00',1.15),('1444','2013-12-18','13:20:00',1.14),('1444','2013-12-18','13:25:00',1.12),('1444','2013-12-18','13:30:00',1.1),('1444','2013-12-18','13:35:00',1.07),('1444','2013-12-18','13:40:00',1.03),('1444','2013-12-18','13:45:00',1),('1444','2014-04-22','08:10:00',1.01),('1444','2014-04-22','08:15:00',1.07),('1444','2014-04-22','08:20:00',1.15),('1444','2014-04-22','08:25:00',1.2),('1444','2014-04-22','08:30:00',1.27),('1444','2014-04-22','08:35:00',1.31),('1444','2014-04-22','08:40:00',1.4),('1444','2014-04-22','08:45:00',1.45),('1444','2014-04-22','08:50:00',1.48),('1444','2014-04-22','08:55:00',1.49),('1444','2014-04-22','09:00:00',1.14),('1444','2014-04-22','09:05:00',1.79),('1444','2014-04-22','09:10:00',1.67),('1444','2014-04-22','09:15:00',1.65),('1444','2014-04-22','09:20:00',1.88),('1444','2014-04-22','09:25:00',1.69),('1444','2014-04-22','09:30:00',1.77),('1444','2014-04-22','09:35:00',2.13),('1444','2014-04-22','09:40:00',2.1),('1444','2014-04-22','09:45:00',2.31),('1444','2014-04-22','09:50:00',1.75),('1444','2014-04-22','09:55:00',1.11),('1444','2014-04-22','10:00:00',1.06),('1444','2014-04-22','10:05:00',1.14),('1444','2014-04-22','10:10:00',1.52),('1444','2014-04-22','10:15:00',1.74),('1444','2014-04-22','10:20:00',2.46),('1444','2014-04-22','10:25:00',1.7),('1444','2014-04-22','10:30:00',2.84),('1444','2014-04-22','10:35:00',2.8),('1444','2014-04-22','10:40:00',2.73),('1444','2014-04-22','10:45:00',2.94),('1444','2014-04-22','10:50:00',2.92),('1444','2014-04-22','10:55:00',2.16),('1444','2014-04-22','11:00:00',1.58),('1444','2014-04-22','11:05:00',1.94),('1444','2014-04-22','11:10:00',1.34),('1444','2014-04-22','11:15:00',1.16),('1444','2014-04-22','11:20:00',1),('1444','2014-04-22','12:20:00',1.01),('1444','2014-04-22','12:25:00',1.09),('1444','2014-04-22','12:30:00',1.26),('1444','2014-04-22','12:35:00',1.07),('1444','2014-04-22','13:15:00',1.2),('1444','2014-04-22','13:20:00',1.79),('1444','2014-04-22','13:25:00',2.08),('1444','2014-04-22','13:30:00',2.17),('1444','2014-04-22','13:35:00',2.09),('1444','2014-04-22','13:40:00',2.47),('1444','2014-04-22','13:45:00',2.55),('1444','2014-04-22','13:50:00',2.05),('1444','2014-04-22','13:55:00',1.23),('1444','2014-04-22','14:00:00',1.1),('1444','2014-04-22','14:05:00',1.56),('1444','2014-04-22','14:10:00',2.74),('1444','2014-04-22','14:15:00',2.5),('1444','2014-04-22','14:20:00',3.13),('1444','2014-04-22','14:25:00',1.76),('1444','2014-04-22','14:30:00',1.71),('1444','2014-04-22','14:35:00',2.06),('1444','2014-04-22','14:40:00',2.66),('1444','2014-04-22','14:45:00',3.26),('1444','2014-04-22','14:50:00',2.98),('1444','2014-04-22','14:55:00',2.21),('1444','2014-04-22','15:00:00',1.04),('1444','2014-04-22','15:05:00',1.02),('1444','2014-04-22','15:20:00',1.04),('1444','2014-04-22','15:25:00',1.17),('1444','2014-04-22','15:30:00',1.48),('1444','2014-04-22','15:35:00',2.02),('1444','2014-04-22','15:40:00',1.62),('1444','2014-04-22','15:45:00',1.47),('1444','2014-04-22','15:50:00',1.73),('1444','2014-04-22','15:55:00',1.43),('1444','2014-04-22','16:00:00',1.66),('1444','2014-04-22','16:05:00',1.19),('1444','2014-04-22','16:10:00',1.15),('1444','2014-04-22','16:15:00',1.11),('1444','2014-04-22','16:20:00',1.28),('1444','2014-04-22','16:25:00',1.2),('1444','2014-04-22','16:30:00',1.02),('1444','2014-04-22','16:35:00',1.13),('1444','2014-04-22','16:40:00',1.39),('1444','2014-04-22','16:45:00',1.3),('1444','2014-04-22','16:50:00',1.02),('1444','2014-04-22','17:00:00',1.03),('1444','2014-04-22','17:05:00',1.12),('1444','2013-12-17','10:00:00',1.01),('1444','2013-12-17','10:05:00',1.03),('1444','2013-12-17','10:10:00',1.04),('1444','2013-12-17','10:15:00',1.11),('1444','2013-12-17','10:20:00',1.14),('1444','2013-12-17','10:25:00',1.19),('1444','2013-12-17','10:30:00',1.22),('1444','2013-12-17','10:35:00',1.27),('1444','2013-12-17','10:40:00',1.29),('1444','2013-12-17','10:45:00',1.33),('1444','2013-12-17','10:50:00',1.35),('1444','2013-12-17','10:55:00',1.37),('1444','2013-12-17','11:00:00',1.39),('1444','2013-12-17','11:05:00',1.4),('1444','2013-12-17','11:10:00',1.43),('1444','2013-12-17','11:15:00',1.45),('1444','2013-12-17','11:20:00',1.46),('1444','2013-12-17','11:25:00',1.46),('1444','2013-12-17','11:30:00',1.46),('1444','2013-12-17','11:35:00',1.48),('1444','2013-12-17','11:40:00',1.48),('1444','2013-12-17','11:45:00',1.49),('1444','2013-12-17','11:50:00',1.5),('1444','2013-12-17','11:55:00',1.51),('1444','2013-12-17','12:00:00',1.49),('1444','2013-12-17','12:05:00',1.49),('1444','2013-12-17','12:10:00',1.48),('1444','2013-12-17','12:15:00',1.46),('1444','2013-12-17','12:20:00',1.46),('1444','2013-12-17','12:25:00',1.45),('1444','2013-12-17','12:30:00',1.43),('1444','2013-12-17','12:35:00',1.44),('1444','2013-12-17','12:40:00',1.42),('1444','2013-12-17','12:45:00',1.33),('1444','2013-12-17','12:50:00',1.36),('1444','2013-12-17','12:55:00',1.36),('1444','2013-12-17','13:00:00',1.33),('1444','2013-12-17','13:05:00',1.31),('1444','2013-12-17','13:10:00',1.27),('1444','2013-12-17','13:15:00',1.22),('1444','2013-12-17','13:20:00',1.2),('1444','2013-12-17','13:25:00',1.17),('1444','2013-12-17','13:30:00',1.17),('1444','2013-12-17','13:35:00',1.14),('1444','2013-12-17','13:40:00',1.1),('1444','2013-12-17','13:45:00',1.07),('1444','2013-12-17','13:50:00',1.07),('1444','2013-12-17','13:55:00',1.05),('1444','2013-12-17','14:00:00',1.02),('1444','2013-12-16','10:05:00',1.03),('1444','2013-12-16','10:10:00',1.06),('1444','2013-12-16','10:15:00',1.09),('1444','2013-12-16','10:20:00',1.11),('1444','2013-12-16','10:25:00',1.15),('1444','2013-12-16','10:30:00',1.17),('1444','2013-12-16','10:35:00',1.22),('1444','2013-12-16','10:40:00',1.25),('1444','2013-12-16','10:45:00',1.29),('1444','2013-12-16','10:50:00',1.32),('1444','2013-12-16','10:55:00',1.34),('1444','2013-12-16','11:00:00',1.35),('1444','2013-12-16','11:05:00',1.37),('1444','2013-12-16','11:10:00',1.38),('1444','2013-12-16','11:15:00',1.38),('1444','2013-12-16','11:20:00',1.42),('1444','2013-12-16','11:25:00',1.44),('1444','2013-12-16','11:30:00',1.44),('1444','2013-12-16','11:35:00',1.44),('1444','2013-12-16','11:40:00',1.45),('1444','2013-12-16','11:45:00',1.46),('1444','2013-12-16','11:50:00',1.48),('1444','2013-12-16','11:55:00',1.49),('1444','2013-12-16','12:00:00',1.47),('1444','2013-12-16','12:05:00',1.47),('1444','2013-12-16','12:10:00',1.47),('1444','2013-12-16','12:15:00',1.45),('1444','2013-12-16','12:20:00',1.45),('1444','2013-12-16','12:25:00',1.44),('1444','2013-12-16','12:30:00',1.42),('1444','2013-12-16','12:35:00',1.42),('1444','2013-12-16','12:40:00',1.39),('1444','2013-12-16','12:45:00',1.32),('1444','2013-12-16','12:50:00',1.34),('1444','2013-12-16','12:55:00',1.35),('1444','2013-12-16','13:00:00',1.32),('1444','2013-12-16','13:05:00',1.3),('1444','2013-12-16','13:10:00',1.28),('1444','2013-12-16','13:15:00',1.22),('1444','2013-12-16','13:20:00',1.2),('1444','2013-12-16','13:25:00',1.18),('1444','2013-12-16','13:30:00',1.16),('1444','2013-12-16','13:35:00',1.12),('1444','2013-12-16','13:40:00',1.08),('1444','2013-12-16','13:45:00',1.05),('1444','2013-12-16','13:50:00',1.03),('1444','2013-12-16','13:55:00',1.03),('1444','2013-12-14','10:00:00',1.02),('1444','2013-12-14','10:05:00',1.06),('1444','2013-12-14','10:10:00',1.08),('1444','2013-12-14','10:15:00',1.11),('1444','2013-12-14','10:20:00',1.14),('1444','2013-12-14','10:25:00',1.17),('1444','2013-12-14','10:30:00',1.2),('1444','2013-12-14','10:35:00',1.24),('1444','2013-12-14','10:40:00',1.26),('1444','2013-12-14','10:45:00',1.3),('1444','2013-12-14','10:50:00',1.32),('1444','2013-12-14','10:55:00',1.33),('1444','2013-12-14','11:00:00',1.34),('1444','2013-12-14','11:05:00',1.37),('1444','2013-12-14','11:10:00',1.38),('1444','2013-12-14','11:15:00',1.4),('1444','2013-12-14','11:20:00',1.41),('1444','2013-12-14','11:25:00',1.43),('1444','2013-12-14','11:30:00',1.43),('1444','2013-12-14','11:35:00',1.44),('1444','2013-12-14','11:40:00',1.44),('1444','2013-12-14','11:45:00',1.41),('1444','2013-12-14','11:50:00',1.41),('1444','2013-12-14','11:55:00',1.4),('1444','2013-12-14','12:00:00',1.36),('1444','2013-12-14','12:05:00',1.38),('1444','2013-12-14','12:10:00',1.39),('1444','2013-12-14','12:15:00',1.33),('1444','2013-12-14','12:20:00',1.36),('1444','2013-12-14','12:25:00',1.35),('1444','2013-12-14','12:30:00',1.14),('1444','2013-12-14','12:35:00',1.33),('1444','2013-12-14','12:40:00',1.2),('1444','2013-12-14','12:45:00',1.16),('1444','2013-12-14','12:50:00',1.29),('1444','2013-12-14','12:55:00',1.26),('1444','2013-12-14','13:00:00',1.23),('1444','2013-12-14','13:05:00',1.23),('1444','2013-12-14','13:10:00',1.2),('1444','2013-12-14','13:15:00',1.17),('1444','2013-12-14','13:20:00',1.17),('1444','2013-12-14','13:25:00',1.15),('1444','2013-12-14','13:30:00',1.15),('1444','2013-12-14','13:35:00',1.11),('1444','2013-12-14','13:40:00',1.07),('1444','2013-12-14','13:45:00',1.02),('1444','2013-12-14','13:50:00',1.03),('1444','2013-12-14','13:55:00',1.02),('1444','2013-12-13','10:10:00',1.02),('1444','2013-12-13','10:15:00',1.03),('1444','2013-12-13','10:20:00',1.06),('1444','2013-12-13','10:25:00',1.1),('1444','2013-12-13','10:30:00',1.14),('1444','2013-12-13','10:35:00',1.18),('1444','2013-12-13','10:40:00',1.21),('1444','2013-12-13','10:45:00',1.25),('1444','2013-12-13','10:50:00',1.26),('1444','2013-12-13','10:55:00',1.27),('1444','2013-12-13','11:00:00',1.31),('1444','2013-12-13','11:05:00',1.33),('1444','2013-12-13','11:10:00',1.35),('1444','2013-12-13','11:15:00',1.36),('1444','2013-12-13','11:20:00',1.35),('1444','2013-12-13','11:25:00',1.35),('1444','2013-12-13','11:30:00',1.35),('1444','2013-12-13','11:35:00',1.38),('1444','2013-12-13','11:40:00',1.39),('1444','2013-12-13','11:45:00',1.41),('1444','2013-12-13','11:50:00',1.42),('1444','2013-12-13','11:55:00',1.43),('1444','2013-12-13','12:00:00',1.4),('1444','2013-12-13','12:05:00',1.38),('1444','2013-12-13','12:10:00',1.41),('1444','2013-12-13','12:15:00',1.37),('1444','2013-12-13','12:20:00',1.36),('1444','2013-12-13','12:25:00',1.34),('1444','2013-12-13','12:30:00',1.31),('1444','2013-12-13','12:35:00',1.32),('1444','2013-12-13','12:40:00',1.29),('1444','2013-12-13','12:45:00',1.25),('1444','2013-12-13','12:50:00',1.26),('1444','2013-12-13','12:55:00',1.25),('1444','2013-12-13','13:00:00',1.26),('1444','2013-12-13','13:05:00',1.27),('1444','2013-12-13','13:10:00',1.24),('1444','2013-12-13','13:15:00',1.19),('1444','2013-12-13','13:20:00',1.19),('1444','2013-12-13','13:25:00',1.16),('1444','2013-12-13','13:30:00',1.15),('1444','2013-12-13','13:35:00',1.13),('1444','2013-12-13','13:40:00',1.1),('1444','2013-12-13','13:45:00',1.05),('1444','2013-12-13','13:50:00',1.04),('1444','2013-12-13','13:55:00',1.02),('1444','2013-12-13','14:00:00',1.01),('1444','2013-12-12','10:05:00',1.04),('1444','2013-12-12','10:10:00',1.08),('1444','2013-12-12','10:15:00',1.11),('1444','2013-12-12','10:20:00',1.14),('1444','2013-12-12','10:25:00',1.18),('1444','2013-12-12','10:30:00',1.22),('1444','2013-12-12','10:35:00',1.25),('1444','2013-12-12','10:40:00',1.28),('1444','2013-12-12','10:45:00',1.32),('1444','2013-12-12','10:50:00',1.34),('1444','2013-12-12','10:55:00',1.34),('1444','2013-12-12','11:00:00',1.36),('1444','2013-12-12','11:05:00',1.37),('1444','2013-12-12','11:10:00',1.39),('1444','2013-12-12','11:15:00',1.4),('1444','2013-12-12','11:20:00',1.4),('1444','2013-12-12','11:25:00',1.4),('1444','2013-12-12','11:30:00',1.41),('1444','2013-12-12','11:35:00',1.42),('1444','2013-12-12','11:40:00',1.43),('1444','2013-12-12','11:45:00',1.43),('1444','2013-12-12','11:50:00',1.44),('1444','2013-12-12','11:55:00',1.44),('1444','2013-12-12','12:00:00',1.41),('1444','2013-12-12','12:05:00',1.42),('1444','2013-12-12','12:10:00',1.42),('1444','2013-12-12','12:15:00',1.39),('1444','2013-12-12','12:20:00',1.39),('1444','2013-12-12','12:25:00',1.4),('1444','2013-12-12','12:30:00',1.38),('1444','2013-12-12','12:35:00',1.39),('1444','2013-12-12','12:40:00',1.35),('1444','2013-12-12','12:45:00',1.26),('1444','2013-12-12','12:50:00',1.3),('1444','2013-12-12','12:55:00',1.28),('1444','2013-12-12','13:00:00',1.25),('1444','2013-12-12','13:05:00',1.24),('1444','2013-12-12','13:10:00',1.2),('1444','2013-12-12','13:15:00',1.14),('1444','2013-12-12','13:20:00',1.14),('1444','2013-12-12','13:25:00',1.14),('1444','2013-12-12','13:30:00',1.11),('1444','2013-12-12','13:35:00',1.09),('1444','2013-12-12','13:40:00',1.05),('1444','2013-12-12','13:45:00',1.05),('1444','2013-12-12','13:50:00',1.04),('1444','2013-12-12','13:55:00',1.01),('1444','2013-12-11','10:00:00',1.02),('1444','2013-12-11','10:05:00',1.06),('1444','2013-12-11','10:10:00',1.1),('1444','2013-12-11','10:15:00',1.13),('1444','2013-12-11','10:20:00',1.17),('1444','2013-12-11','10:25:00',1.21),('1444','2013-12-11','10:30:00',1.24),('1444','2013-12-11','10:35:00',1.29),('1444','2013-12-11','10:40:00',1.32),('1444','2013-12-11','10:45:00',1.35),('1444','2013-12-11','10:50:00',1.36),('1444','2013-12-11','10:55:00',1.39),('1444','2013-12-11','11:00:00',1.41),('1444','2013-12-11','11:05:00',1.44),('1444','2013-12-11','11:10:00',1.46),('1444','2013-12-11','11:15:00',1.47),('1444','2013-12-11','11:20:00',1.48),('1444','2013-12-11','11:25:00',1.5),('1444','2013-12-11','11:30:00',1.47),('1444','2013-12-11','11:35:00',1.47),('1444','2013-12-11','11:40:00',1.48),('1444','2013-12-11','11:45:00',1.5),('1444','2013-12-11','11:50:00',1.51),('1444','2013-12-11','11:55:00',1.5),('1444','2013-12-11','12:00:00',1.48),('1444','2013-12-11','12:05:00',1.49),('1444','2013-12-11','12:10:00',1.48),('1444','2013-12-11','12:15:00',1.43),('1444','2013-12-11','12:20:00',1.42),('1444','2013-12-11','12:25:00',1.41),('1444','2013-12-11','12:30:00',1.39),('1444','2013-12-11','12:35:00',1.41),('1444','2013-12-11','12:40:00',1.38),('1444','2013-12-11','12:45:00',1.35),('1444','2013-12-11','12:50:00',1.38),('1444','2013-12-11','12:55:00',1.36),('1444','2013-12-11','13:00:00',1.34),('1444','2013-12-11','13:05:00',1.32),('1444','2013-12-11','13:10:00',1.26),('1444','2013-12-11','13:15:00',1.22),('1444','2013-12-11','13:20:00',1.21),('1444','2013-12-11','13:25:00',1.18),('1444','2013-12-11','13:30:00',1.15),('1444','2013-12-11','13:35:00',1.15),('1444','2013-12-11','13:40:00',1.11),('1444','2013-12-11','13:45:00',1.07),('1444','2013-12-11','13:50:00',1.06),('1444','2013-12-11','13:55:00',1.02),('1444','2013-12-10','09:55:00',1.04),('1444','2013-12-10','10:00:00',1.07),('1444','2013-12-10','10:05:00',1.11),('1444','2013-12-10','10:10:00',1.13),('1444','2013-12-10','10:15:00',1.17),('1444','2013-12-10','10:20:00',1.2),('1444','2013-12-10','10:25:00',1.24),('1444','2013-12-10','10:30:00',1.29),('1444','2013-12-10','10:35:00',1.31),('1444','2013-12-10','10:40:00',1.36),('1444','2013-12-10','10:45:00',1.37),('1444','2013-12-10','10:50:00',1.38),('1444','2013-12-10','10:55:00',1.4),('1444','2013-12-10','11:00:00',1.42),('1444','2013-12-10','11:05:00',1.45),('1444','2013-12-10','11:10:00',1.47),('1444','2013-12-10','11:15:00',1.48),('1444','2013-12-10','11:20:00',1.49),('1444','2013-12-10','11:25:00',1.51),('1444','2013-12-10','11:30:00',1.52),('1444','2013-12-10','11:35:00',1.53),('1444','2013-12-10','11:40:00',1.54),('1444','2013-12-10','11:45:00',1.54),('1444','2013-12-10','11:50:00',1.54),('1444','2013-12-10','11:55:00',1.52),('1444','2013-12-10','12:00:00',1.5),('1444','2013-12-10','12:05:00',1.5),('1444','2013-12-10','12:10:00',1.48),('1444','2013-12-10','12:15:00',1.46),('1444','2013-12-10','12:20:00',1.45),('1444','2013-12-10','12:25:00',1.44),('1444','2013-12-10','12:30:00',1.4),('1444','2013-12-10','12:35:00',1.4),('1444','2013-12-10','12:40:00',1.37),('1444','2013-12-10','12:45:00',1.32),('1444','2013-12-10','12:50:00',1.35),('1444','2013-12-10','12:55:00',1.32),('1444','2013-12-10','13:00:00',1.29),('1444','2013-12-10','13:05:00',1.27),('1444','2013-12-10','13:10:00',1.24),('1444','2013-12-10','13:15:00',1.17),('1444','2013-12-10','13:20:00',1.15),('1444','2013-12-10','13:25:00',1.13),('1444','2013-12-10','13:30:00',1.12),('1444','2013-12-10','13:35:00',1.12),('1444','2013-12-10','13:40:00',1.11),('1444','2013-12-10','13:45:00',1.08),('1444','2013-12-10','13:50:00',1.07),('1444','2013-12-10','13:55:00',1.05),('1444','2013-12-10','14:00:00',1.02),('1444','2013-12-09','09:55:00',1.02),('1444','2013-12-09','10:00:00',1.07),('1444','2013-12-09','10:05:00',1.21),('1444','2013-12-09','10:10:00',1.39),('1444','2013-12-09','10:15:00',1.62),('1444','2013-12-09','10:20:00',1.71),('1444','2013-12-09','10:25:00',1.12),('1444','2013-12-09','12:30:00',1.21),('1444','2013-12-09','12:45:00',1.22),('1444','2013-12-09','12:50:00',1.09),('1444','2013-12-09','12:55:00',1.34),('1444','2013-12-09','13:00:00',1.14),('1444','2013-12-09','13:15:00',1.2),('1444','2013-12-09','13:20:00',1.16),('1444','2013-12-08','11:10:00',1.08),('1444','2013-12-08','11:15:00',1.13),('1444','2013-12-08','12:55:00',1.14),('1444','2013-12-08','13:10:00',1.18),('1444','2013-12-08','13:15:00',1.07),('1444','2014-04-21','09:20:00',1.33),('1444','2014-04-21','10:00:00',1.12),('1444','2014-04-21','10:05:00',2.35),('1444','2014-04-21','10:10:00',2.53),('1444','2014-04-21','10:15:00',2.54),('1444','2014-04-21','10:20:00',2.5),('1444','2014-04-21','10:25:00',2.52),('1444','2014-04-21','10:30:00',2.52),('1444','2014-04-21','10:35:00',2.53),('1444','2014-04-21','10:40:00',2.57),('1444','2014-04-21','10:45:00',2.61),('1444','2014-04-21','10:50:00',2.63),('1444','2014-04-21','10:55:00',2.66),('1444','2014-04-21','11:00:00',2.68),('1444','2014-04-21','11:05:00',2.71),('1444','2014-04-21','11:10:00',2.74),('1444','2014-04-21','11:15:00',2.77),('1444','2014-04-21','11:20:00',2.79),('1444','2014-04-21','11:25:00',2.82),('1444','2014-04-21','11:30:00',2.85),('1444','2014-04-21','11:35:00',2.88),('1444','2014-04-21','11:40:00',2.94),('1444','2014-04-21','11:45:00',2.93),('1444','2014-04-21','11:50:00',2.97),('1444','2014-04-21','11:55:00',3),('1444','2014-04-21','12:00:00',3.01),('1444','2014-04-21','12:05:00',3.05),('1444','2014-04-21','12:10:00',3.06),('1444','2014-04-21','12:15:00',3.08),('1444','2014-04-21','12:20:00',3.11),('1444','2014-04-21','12:25:00',3.11),('1444','2014-04-21','12:30:00',3.12),('1444','2014-04-21','12:35:00',3.15),('1444','2014-04-21','12:40:00',3.15),('1444','2014-04-21','12:45:00',3.17),('1444','2014-04-21','12:50:00',3.19),('1444','2014-04-21','12:55:00',3.18),('1444','2014-04-21','13:00:00',3.19),('1444','2014-04-21','13:05:00',3.21),('1444','2014-04-21','13:10:00',3.19),('1444','2014-04-21','13:15:00',3.18),('1444','2014-04-21','13:20:00',3.16),('1444','2014-04-21','13:25:00',3.15),('1444','2014-04-21','13:30:00',3.16),('1444','2014-04-21','13:35:00',3.14),('1444','2014-04-21','13:40:00',3.14),('1444','2014-04-21','13:45:00',3.16),('1444','2014-04-21','13:50:00',3.17),('1444','2014-04-21','13:55:00',3.16),('1444','2014-04-21','14:00:00',3.15),('1444','2014-04-21','14:05:00',3.14),('1444','2014-04-21','14:10:00',3.12),('1444','2014-04-21','14:15:00',3.12),('1444','2014-04-21','14:20:00',3.1),('1444','2014-04-21','14:25:00',3.06),('1444','2014-04-21','14:30:00',3.04),('1444','2014-04-21','14:35:00',3.02),('1444','2014-04-21','14:40:00',2.99),('1444','2014-04-21','14:45:00',2.96),('1444','2014-04-21','14:50:00',2.93),('1444','2014-04-21','14:55:00',2.91),('1444','2014-04-21','15:00:00',2.88),('1444','2014-04-21','15:05:00',2.85),('1444','2014-04-21','15:10:00',2.81),('1444','2014-04-21','15:15:00',2.77),('1444','2014-04-21','15:20:00',2.74),('1444','2014-04-21','15:25:00',2.69),('1444','2014-04-21','15:30:00',2.65),('1444','2014-04-21','15:35:00',2.62),('1444','2014-04-21','15:40:00',2.58),('1444','2014-04-21','15:45:00',2.53),('1444','2014-04-21','15:50:00',2.49),('1444','2014-04-21','15:55:00',2.45),('1444','2014-04-21','16:00:00',2.41),('1444','2014-04-21','16:05:00',2.37),('1444','2014-04-21','16:10:00',2.33),('1444','2014-04-21','16:15:00',2.44),('1444','2014-04-21','16:20:00',2.24),('1444','2014-04-21','16:25:00',2.13),('1444','2014-04-21','16:30:00',2.13),('1444','2014-04-21','16:35:00',2.06),('1444','2014-04-21','16:40:00',2.02),('1444','2014-04-21','16:45:00',1.97),('1444','2014-04-21','16:50:00',1.91),('1444','2014-04-21','16:55:00',1.84),('1444','2014-04-21','17:00:00',1.78),('1444','2014-04-21','17:05:00',1.72),('1444','2014-04-21','17:10:00',1.67),('1444','2014-04-21','17:15:00',1.6),('1444','2014-04-21','17:20:00',1.54),('1444','2014-04-21','17:25:00',1.48),('1444','2014-04-21','17:30:00',1.43),('1444','2014-04-21','17:35:00',1.37),('1444','2014-04-21','17:40:00',1.25),('1444','2014-04-21','17:45:00',1.24),('1444','2014-04-21','17:50:00',1.18),('1444','2014-04-21','17:55:00',1.1),('1444','2014-04-21','18:00:00',1.03),('1444','2013-12-07','09:50:00',1.01),('1444','2013-12-07','09:55:00',1.05),('1444','2013-12-07','10:00:00',1.09),('1444','2013-12-07','10:05:00',1.1),('1444','2013-12-07','10:10:00',1.1),('1444','2013-12-07','10:15:00',1.11),('1444','2013-12-07','10:20:00',1.18),('1444','2013-12-07','10:25:00',1.2),('1444','2013-12-07','10:30:00',1.25),('1444','2013-12-07','10:35:00',1.29),('1444','2013-12-07','10:40:00',1.33),('1444','2013-12-07','10:45:00',1.39),('1444','2013-12-07','10:50:00',1.4),('1444','2013-12-07','10:55:00',1.39),('1444','2013-12-07','11:00:00',1.41),('1444','2013-12-07','11:05:00',1.43),('1444','2013-12-07','11:10:00',1.44),('1444','2013-12-07','11:15:00',1.45),('1444','2013-12-07','11:20:00',1.46),('1444','2013-12-07','11:25:00',1.47),('1444','2013-12-07','11:30:00',1.47),('1444','2013-12-07','11:35:00',1.47),('1444','2013-12-07','11:40:00',1.47),('1444','2013-12-07','11:45:00',1.46),('1444','2013-12-07','11:50:00',1.47),('1444','2013-12-07','11:55:00',1.46),('1444','2013-12-07','12:00:00',1.42),('1444','2013-12-07','12:05:00',1.44),('1444','2013-12-07','12:10:00',1.43),('1444','2013-12-07','12:15:00',1.42),('1444','2013-12-07','12:20:00',1.42),('1444','2013-12-07','12:25:00',1.4),('1444','2013-12-07','12:30:00',1.39),('1444','2013-12-07','12:35:00',1.38),('1444','2013-12-07','12:40:00',1.36),('1444','2013-12-07','12:45:00',1.32),('1444','2013-12-07','12:50:00',1.33),('1444','2013-12-07','12:55:00',1.24),('1444','2013-12-07','13:00:00',1.1),('1444','2013-12-07','13:05:00',1.29),('1444','2013-12-07','13:10:00',1.25),('1444','2013-12-07','13:15:00',1.23),('1444','2013-12-07','13:20:00',1.21),('1444','2013-12-07','13:25:00',1.17),('1444','2013-12-07','13:30:00',1.15),('1444','2013-12-07','13:35:00',1.16),('1444','2013-12-07','13:40:00',1.14),('1444','2013-12-07','13:45:00',1.09),('1444','2013-12-07','13:50:00',1.05),('1444','2013-12-07','13:55:00',1.04),('1444','2013-12-07','14:00:00',1.01),('1444','2013-12-06','11:40:00',1.19),('1444','2013-12-06','11:45:00',1.07),('1444','2013-12-06','11:50:00',1.4),('1444','2013-12-06','11:55:00',1.36),('1444','2013-12-06','12:00:00',1.62),('1444','2013-12-06','12:05:00',1.04),('1444','2013-12-06','12:10:00',1.31),('1444','2013-12-06','12:15:00',1.05),('1444','2013-12-06','12:20:00',1.2),('1444','2013-12-06','12:40:00',1.41),('1444','2013-12-05','09:45:00',1.02),('1444','2013-12-05','09:50:00',1.05),('1444','2013-12-05','09:55:00',1.08),('1444','2013-12-05','10:00:00',1.13),('1444','2013-12-05','10:05:00',1.15),('1444','2013-12-05','10:10:00',1.18),('1444','2013-12-05','10:15:00',1.22),('1444','2013-12-05','10:20:00',1.25),('1444','2013-12-05','10:25:00',1.29),('1444','2013-12-05','10:30:00',1.32),('1444','2013-12-05','10:35:00',1.37),('1444','2013-12-05','10:40:00',1.4),('1444','2013-12-05','10:45:00',1.42),('1444','2013-12-05','10:50:00',1.44),('1444','2013-12-05','10:55:00',1.45),('1444','2013-12-05','11:00:00',1.47),('1444','2013-12-05','11:05:00',1.47),('1444','2013-12-05','11:10:00',1.51),('1444','2013-12-05','11:15:00',1.52),('1444','2013-12-05','11:20:00',1.53),('1444','2013-12-05','11:25:00',1.52),('1444','2013-12-05','11:30:00',1.52),('1444','2013-12-05','11:35:00',1.54),('1444','2013-12-05','11:40:00',1.54),('1444','2013-12-05','11:45:00',1.55),('1444','2013-12-05','11:50:00',1.57),('1444','2013-12-05','11:55:00',1.53),('1444','2013-12-05','12:00:00',1.52),('1444','2013-12-05','12:05:00',1.5),('1444','2013-12-05','12:10:00',1.5),('1444','2013-12-05','12:15:00',1.46),('1444','2013-12-05','12:20:00',1.48),('1444','2013-12-05','12:25:00',1.43),('1444','2013-12-05','12:30:00',1.42),('1444','2013-12-05','12:35:00',1.43),('1444','2013-12-05','12:40:00',1.38),('1444','2013-12-05','12:45:00',1.38),('1444','2013-12-05','12:50:00',1.46),('1444','2013-12-05','12:55:00',1.41),('1444','2013-12-05','13:00:00',1.45),('1444','2013-12-05','13:05:00',1.43),('1444','2013-12-05','13:10:00',1.36),('1444','2013-12-05','13:15:00',1.31),('1444','2013-12-05','13:20:00',1.31),('1444','2013-12-05','13:25:00',1.29),('1444','2013-12-05','13:30:00',1.23),('1444','2013-12-05','13:35:00',1.21),('1444','2013-12-05','13:40:00',1.1),('1444','2013-12-05','13:45:00',1.03),('1444','2013-12-05','13:50:00',1.07),('1444','2013-12-05','13:55:00',1.03),('1444','2013-12-05','14:00:00',1.02),('1444','2013-12-05','14:05:00',1.01),('1444','2013-12-04','09:35:00',1),('1444','2013-12-04','09:40:00',1.03),('1444','2013-12-04','09:45:00',1.07),('1444','2013-12-04','09:50:00',1.12),('1444','2013-12-04','09:55:00',1.15),('1444','2013-12-04','10:00:00',1.2),('1444','2013-12-04','10:05:00',1.23),('1444','2013-12-04','10:10:00',1.26),('1444','2013-12-04','10:15:00',1.3),('1444','2013-12-04','10:20:00',1.34),('1444','2013-12-04','10:25:00',1.38),('1444','2013-12-04','10:30:00',1.42),('1444','2013-12-04','10:35:00',1.45),('1444','2013-12-04','10:40:00',1.49),('1444','2013-12-04','10:45:00',1.52),('1444','2013-12-04','10:50:00',1.53),('1444','2013-12-04','10:55:00',1.55),('1444','2013-12-04','11:00:00',1.57),('1444','2013-12-04','11:05:00',1.59),('1444','2013-12-04','11:10:00',1.61),('1444','2013-12-04','11:15:00',1.61),('1444','2013-12-04','11:20:00',1.62),('1444','2013-12-04','11:25:00',1.63),('1444','2013-12-04','11:30:00',1.64),('1444','2013-12-04','11:35:00',1.65),('1444','2013-12-04','11:40:00',1.65),('1444','2013-12-04','11:45:00',1.66),('1444','2013-12-04','11:50:00',1.65),('1444','2013-12-04','11:55:00',1.65),('1444','2013-12-04','12:00:00',1.64),('1444','2013-12-04','12:05:00',1.61),('1444','2013-12-04','12:10:00',1.59),('1444','2013-12-04','12:15:00',1.59),('1444','2013-12-04','12:20:00',1.58),('1444','2013-12-04','12:25:00',1.57),('1444','2013-12-04','12:30:00',1.56),('1444','2013-12-04','12:35:00',1.55),('1444','2013-12-04','12:40:00',1.53),('1444','2013-12-04','12:45:00',1.43),('1444','2013-12-04','12:50:00',1.49),('1444','2013-12-04','12:55:00',1.46),('1444','2013-12-04','13:00:00',1.44),('1444','2013-12-04','13:05:00',1.43),('1444','2013-12-04','13:10:00',1.38),('1444','2013-12-04','13:15:00',1.32),('1444','2013-12-04','13:20:00',1.29),('1444','2013-12-04','13:25:00',1.27),('1444','2013-12-04','13:30:00',1.24),('1444','2013-12-04','13:35:00',1.24),('1444','2013-12-04','13:40:00',1.19),('1444','2013-12-04','13:45:00',1.17),('1444','2013-12-04','13:50:00',1.14),('1444','2013-12-04','13:55:00',1.12),('1444','2013-12-04','14:00:00',1.11),('1444','2013-12-04','14:05:00',1.07),('1444','2013-12-04','14:10:00',1.03),('1444','2013-12-03','10:00:00',1.16),('1444','2013-12-03','10:05:00',1.22),('1444','2013-12-03','10:10:00',1.24),('1444','2013-12-03','10:15:00',1.29),('1444','2013-12-03','10:20:00',1.31),('1444','2013-12-03','10:25:00',1.37),('1444','2013-12-03','10:30:00',1.4),('1444','2013-12-03','10:35:00',1.43),('1444','2013-12-03','10:40:00',1.47),('1444','2013-12-03','10:45:00',1.5),('1444','2013-12-03','10:50:00',1.53),('1444','2013-12-03','10:55:00',1.57),('1444','2013-12-03','11:00:00',1.59),('1444','2013-12-03','11:05:00',1.62),('1444','2013-12-03','11:10:00',1.64),('1444','2013-12-03','11:15:00',1.65),('1444','2013-12-03','11:20:00',1.66),('1444','2013-12-03','11:25:00',1.66),('1444','2013-12-03','11:30:00',1.66),('1444','2013-12-03','11:35:00',1.67),('1444','2013-12-03','11:40:00',1.67),('1444','2013-12-03','11:45:00',1.69),('1444','2013-12-03','11:50:00',1.7),('1444','2013-12-03','11:55:00',1.69),('1444','2013-12-03','12:00:00',1.69),('1444','2013-12-03','12:05:00',1.69),('1444','2013-12-03','12:10:00',1.68),('1444','2013-12-03','12:15:00',1.68),('1444','2013-12-03','12:20:00',1.69),('1444','2013-12-03','12:25:00',1.71),('1444','2013-12-03','12:30:00',1.73),('1444','2013-12-03','12:35:00',1.75),('1444','2013-12-03','12:40:00',1.77),('1444','2013-12-03','12:45:00',1.78),('1444','2013-12-03','12:50:00',1.86),('1444','2013-12-03','12:55:00',1.86),('1444','2013-12-03','13:00:00',1.9),('1444','2013-12-03','13:05:00',1.95),('1444','2013-12-03','13:10:00',1.93),('1444','2013-12-03','13:15:00',1.87),('1444','2013-12-03','13:20:00',1.82),('1444','2013-12-03','13:25:00',1.74),('1444','2013-12-03','13:30:00',1.62),('1444','2013-12-03','13:35:00',1.58),('1444','2013-12-03','13:40:00',1.48),('1444','2013-12-03','13:45:00',1.41),('1444','2013-12-03','13:50:00',1.31),('1444','2013-12-03','13:55:00',1.25),('1444','2013-12-03','14:00:00',1.21),('1444','2013-12-03','14:05:00',1.12),('1444','2013-12-03','14:10:00',1.05),('1444','2013-12-01','12:10:00',1.15),('1444','2013-11-30','09:20:00',1.05),('1444','2013-11-30','09:25:00',1.05),('1444','2013-11-30','09:30:00',1.2),('1444','2013-11-30','09:35:00',1.35),('1444','2013-11-30','09:40:00',1.28),('1444','2013-11-30','09:45:00',1.02),('1444','2013-11-30','10:40:00',1.06),('1444','2013-11-30','10:45:00',1.01),('1444','2013-11-30','11:10:00',1.01),('1444','2013-11-29','09:35:00',1.04),('1444','2013-11-29','09:40:00',1.08),('1444','2013-11-29','09:45:00',1.12),('1444','2013-11-29','09:50:00',1.16),('1444','2013-11-29','09:55:00',1.2),('1444','2013-11-29','10:00:00',1.24),('1444','2013-11-29','10:05:00',1.28),('1444','2013-11-29','10:10:00',1.31),('1444','2013-11-29','10:15:00',1.35),('1444','2013-11-29','10:20:00',1.39),('1444','2013-11-29','10:25:00',1.44),('1444','2013-11-29','10:30:00',1.47),('1444','2013-11-29','10:35:00',1.52),('1444','2013-11-29','10:40:00',1.54),('1444','2013-11-29','10:45:00',1.57),('1444','2013-11-29','10:50:00',1.59),('1444','2013-11-29','10:55:00',1.61),('1444','2013-11-29','11:00:00',1.62),('1444','2013-11-29','11:05:00',1.64),('1444','2013-11-29','11:10:00',1.66),('1444','2013-11-29','11:15:00',1.67),('1444','2013-11-29','11:20:00',1.68),('1444','2013-11-29','11:25:00',1.69),('1444','2013-11-29','11:30:00',1.7),('1444','2013-11-29','11:35:00',1.71),('1444','2013-11-29','11:40:00',1.72),('1444','2013-11-29','11:45:00',1.71),('1444','2013-11-29','11:50:00',1.7),('1444','2013-11-29','11:55:00',1.7),('1444','2013-11-29','12:00:00',1.7),('1444','2013-11-29','12:05:00',1.69),('1444','2013-11-29','12:10:00',1.66),('1444','2013-11-29','12:15:00',1.64),('1444','2013-11-29','12:20:00',1.65),('1444','2013-11-29','12:25:00',1.63),('1444','2013-11-29','12:30:00',1.61),('1444','2013-11-29','12:35:00',1.59),('1444','2013-11-29','12:40:00',1.58),('1444','2013-11-29','12:45:00',1.57),('1444','2013-11-29','12:50:00',1.56),('1444','2013-11-29','12:55:00',1.52),('1444','2013-11-29','13:00:00',1.51),('1444','2013-11-29','13:05:00',1.47),('1444','2013-11-29','13:10:00',1.44),('1444','2013-11-29','13:15:00',1.41),('1444','2013-11-29','13:20:00',1.38),('1444','2013-11-29','13:25:00',1.33),('1444','2013-11-29','13:30:00',1.3),('1444','2013-11-29','13:35:00',1.27),('1444','2013-11-29','13:40:00',1.24),('1444','2013-11-29','13:45:00',1.21),('1444','2013-11-29','13:50:00',1.16),('1444','2013-11-29','13:55:00',1.11),('1444','2013-11-29','14:00:00',1.12),('1444','2013-11-29','14:05:00',1.09),('1444','2013-11-29','14:10:00',1.06),('1444','2013-11-29','14:15:00',1.02),('1444','2014-04-20','08:15:00',1.09),('1444','2014-04-20','08:20:00',1.45),('1444','2014-04-20','08:25:00',1.67),('1444','2014-04-20','08:30:00',1.8),('1444','2014-04-20','08:35:00',1.44),('1444','2014-04-20','08:45:00',1.62),('1444','2014-04-20','09:00:00',1.32),('1444','2014-04-20','09:10:00',1.7),('1444','2014-04-20','09:15:00',1.99),('1444','2014-04-20','09:20:00',2.11),('1444','2014-04-20','09:25:00',2.36),('1444','2014-04-20','09:30:00',2.56),('1444','2014-04-20','09:35:00',2.28),('1444','2014-04-20','09:40:00',1.49),('1444','2014-04-20','09:45:00',1.14),('1444','2014-04-20','09:50:00',1.28),('1444','2014-04-20','09:55:00',1.51),('1444','2014-04-20','10:00:00',1.8),('1444','2014-04-20','10:05:00',2.2),('1444','2014-04-20','10:10:00',2.07),('1444','2014-04-20','10:15:00',2.36),('1444','2014-04-20','10:20:00',2.4),('1444','2014-04-20','10:25:00',2.28),('1444','2014-04-20','10:30:00',2.09),('1444','2014-04-20','10:35:00',2.22),('1444','2014-04-20','10:40:00',2.06),('1444','2014-04-20','10:45:00',2.12),('1444','2014-04-20','10:50:00',2.22),('1444','2014-04-20','10:55:00',2.32),('1444','2014-04-20','11:00:00',2.71),('1444','2014-04-20','11:05:00',2.52),('1444','2014-04-20','11:10:00',2.7),('1444','2014-04-20','11:15:00',1.65),('1444','2014-04-20','11:20:00',3.04),('1444','2014-04-20','11:25:00',3.02),('1444','2014-04-20','11:30:00',3),('1444','2014-04-20','11:35:00',3.12),('1444','2014-04-20','11:40:00',1.87),('1444','2014-04-20','11:45:00',3.4),('1444','2014-04-20','11:50:00',2.44),('1444','2014-04-20','11:55:00',3.44),('1444','2014-04-20','12:00:00',3.32),('1444','2014-04-20','12:05:00',3.3),('1444','2014-04-20','12:10:00',2.57),('1444','2014-04-20','12:15:00',1.11),('1444','2014-04-20','12:20:00',2.36),('1444','2014-04-20','12:25:00',2.14),('1444','2014-04-20','12:30:00',3.55),('1444','2014-04-20','12:35:00',3.37),('1444','2014-04-20','12:40:00',3.39),('1444','2014-04-20','12:45:00',3.36),('1444','2014-04-20','12:50:00',3.37),('1444','2014-04-20','12:55:00',3.36),('1444','2014-04-20','13:00:00',3.37),('1444','2014-04-20','13:05:00',3.39),('1444','2014-04-20','13:10:00',3.2),('1444','2014-04-20','13:15:00',3.09),('1444','2014-04-20','13:20:00',3.33),('1444','2014-04-20','13:25:00',3.34),('1444','2014-04-20','13:30:00',3.32),('1444','2014-04-20','13:35:00',3.33),('1444','2014-04-20','13:40:00',3.32),('1444','2014-04-20','13:45:00',3.29),('1444','2014-04-20','13:50:00',3.3),('1444','2014-04-20','13:55:00',3.28),('1444','2014-04-20','14:00:00',3.24),('1444','2014-04-20','14:05:00',3.23),('1444','2014-04-20','14:10:00',3.25),('1444','2014-04-20','14:15:00',3.4),('1444','2014-04-20','14:20:00',2.5),('1444','2014-04-20','14:25:00',2.45),('1444','2014-04-20','14:30:00',2.32),('1444','2014-04-20','14:35:00',1.98),('1444','2014-04-20','14:40:00',1.99),('1444','2014-04-20','14:45:00',2.15),('1444','2014-04-20','14:50:00',2.1),('1444','2014-04-20','14:55:00',2.34),('1444','2014-04-20','15:00:00',3.13),('1444','2014-04-20','15:05:00',2.7),('1444','2014-04-20','15:10:00',3.02),('1444','2014-04-20','15:15:00',2.88),('1444','2014-04-20','15:20:00',2.84),('1444','2014-04-20','15:25:00',2.79),('1444','2014-04-20','15:30:00',2.75),('1444','2014-04-20','15:35:00',2.64),('1444','2014-04-20','15:40:00',2.77),('1444','2014-04-20','15:45:00',1.79),('1444','2014-04-20','15:50:00',2.32),('1444','2014-04-20','15:55:00',2.6),('1444','2014-04-20','16:00:00',2.5),('1444','2014-04-20','16:05:00',2.43),('1444','2014-04-20','16:10:00',2.41),('1444','2014-04-20','16:15:00',2.39),('1444','2014-04-20','16:20:00',2.34),('1444','2014-04-20','16:25:00',2.28),('1444','2014-04-20','16:30:00',2.07),('1444','2014-04-20','16:35:00',2.14),('1444','2014-04-20','16:40:00',1.92),('1444','2014-04-20','16:45:00',1.67),('1444','2014-04-20','16:50:00',1.82),('1444','2014-04-20','16:55:00',1.98),('1444','2014-04-20','17:00:00',1.87),('1444','2014-04-20','17:05:00',1.78),('1444','2014-04-20','17:10:00',1.69),('1444','2014-04-20','17:15:00',1.62),('1444','2014-04-20','17:20:00',1.56),('1444','2014-04-20','17:25:00',1.49),('1444','2014-04-20','17:30:00',1.43),('1444','2014-04-20','17:35:00',1.36),('1444','2014-04-20','17:40:00',1.3),('1444','2014-04-20','17:45:00',1.23),('1444','2014-04-20','17:50:00',1.16),('1444','2014-04-20','17:55:00',1.1),('1444','2014-04-20','18:00:00',1.03),('1444','2013-11-27','10:45:00',1.02),('1444','2013-11-27','11:05:00',1.13),('1444','2013-11-27','11:10:00',1.27),('1444','2013-11-27','11:15:00',1.01),('1444','2013-11-27','11:20:00',1.03),('1444','2013-11-27','11:25:00',1.1),('1444','2013-11-27','11:30:00',1.67),('1444','2013-11-27','11:35:00',1.39),('1444','2013-11-27','11:40:00',1.16),('1444','2013-11-27','11:45:00',1.14),('1444','2013-11-27','11:50:00',1.75),('1444','2013-11-27','11:55:00',1.98),('1444','2013-11-27','12:00:00',1.97),('1444','2013-11-27','12:05:00',1.53),('1444','2013-11-27','12:10:00',1.07),('1444','2013-11-27','12:15:00',1.24),('1444','2013-11-27','12:20:00',1.91),('1444','2013-11-27','12:25:00',1.18),('1444','2013-11-27','12:35:00',1.62),('1444','2013-11-26','09:40:00',1.07),('1444','2013-11-26','09:55:00',1.16),('1444','2013-11-26','10:05:00',1.04),('1444','2013-11-26','10:20:00',1.06),('1444','2013-11-26','10:25:00',1.17),('1444','2013-11-26','10:30:00',1.23),('1444','2013-11-26','10:35:00',1.69),('1444','2013-11-26','10:40:00',1.68),('1444','2013-11-26','10:45:00',1.73),('1444','2013-11-26','10:50:00',1.71),('1444','2013-11-26','10:55:00',1.78),('1444','2013-11-26','11:00:00',1.81),('1444','2013-11-26','11:05:00',1.83),('1444','2013-11-26','11:10:00',2.1),('1444','2013-11-26','11:15:00',2.23),('1444','2013-11-26','11:20:00',1.56),('1444','2013-11-26','11:25:00',2.07),('1444','2013-11-26','11:30:00',2.11),('1444','2013-11-26','11:35:00',1.62),('1444','2013-11-26','11:40:00',1.55),('1444','2013-11-26','11:45:00',2.23),('1444','2013-11-26','11:50:00',1.88),('1444','2013-11-26','11:55:00',1.62),('1444','2013-11-26','12:05:00',1.17),('1444','2013-11-26','12:20:00',1.84),('1444','2013-11-26','12:25:00',1.74),('1444','2013-11-26','12:30:00',1.64),('1444','2013-11-26','12:35:00',1.73),('1444','2013-11-26','12:40:00',1.72),('1444','2013-11-26','12:45:00',1.72),('1444','2013-11-26','12:50:00',1.7),('1444','2013-11-26','12:55:00',1.66),('1444','2013-11-26','13:00:00',1.66),('1444','2013-11-26','13:05:00',1.62),('1444','2013-11-26','13:10:00',1.6),('1444','2013-11-26','13:15:00',1.56),('1444','2013-11-26','13:20:00',1.52),('1444','2013-11-26','13:25:00',1.49),('1444','2013-11-26','13:30:00',1.45),('1444','2013-11-26','13:35:00',1.42),('1444','2013-11-26','13:40:00',1.4),('1444','2013-11-26','13:45:00',1.36),('1444','2013-11-26','13:50:00',1.36),('1444','2013-11-26','13:55:00',1.3),('1444','2013-11-26','14:00:00',1.46),('1444','2013-11-26','14:05:00',1.54),('1444','2013-11-26','14:10:00',1.58),('1444','2013-11-26','14:15:00',1.82),('1444','2013-11-26','14:20:00',1.64),('1444','2013-11-26','14:25:00',1.09),('1444','2013-11-26','14:35:00',1.02),('1444','2013-11-26','14:45:00',1.08),('1444','2013-11-26','14:50:00',1.07),('1444','2013-11-26','14:55:00',1.21),('1444','2013-11-26','15:00:00',1.09),('1444','2013-11-25','08:55:00',1.12),('1444','2013-11-25','09:00:00',1.24),('1444','2013-11-25','09:05:00',1.3),('1444','2013-11-25','09:10:00',1.3),('1444','2013-11-25','09:15:00',1.36),('1444','2013-11-25','09:20:00',1.52),('1444','2013-11-25','09:25:00',1.22),('1444','2013-11-25','09:35:00',1.12),('1444','2013-11-25','09:40:00',1.23),('1444','2013-11-25','09:50:00',1.38),('1444','2013-11-25','09:55:00',1.27),('1444','2013-11-25','10:00:00',1.27),('1444','2013-11-25','10:05:00',1.42),('1444','2013-11-25','10:15:00',1.36),('1444','2013-11-25','10:25:00',1.06),('1444','2013-11-25','10:30:00',1.32),('1444','2013-11-25','10:35:00',1.48),('1444','2013-11-25','10:40:00',1.94),('1444','2013-11-25','10:45:00',1.87),('1444','2013-11-25','10:50:00',1.57),('1444','2013-11-25','10:55:00',1.54),('1444','2013-11-25','11:00:00',1.76),('1444','2013-11-25','11:05:00',1.88),('1444','2013-11-25','11:10:00',2.2),('1444','2013-11-25','11:15:00',1.96),('1444','2013-11-25','11:30:00',1.24),('1444','2013-11-25','11:50:00',1.15),('1444','2013-11-25','12:00:00',1.15),('1444','2013-11-25','12:05:00',1.14),('1444','2013-11-25','12:10:00',1.37),('1444','2013-11-25','12:15:00',1.19),('1444','2013-11-25','12:25:00',1.05),('1444','2013-11-25','12:40:00',1.85),('1444','2013-11-25','12:45:00',1.84),('1444','2013-11-25','12:50:00',1.48),('1444','2013-11-25','12:55:00',1.55),('1444','2013-11-25','13:00:00',1.96),('1444','2013-11-25','13:05:00',1.88),('1444','2013-11-25','13:10:00',1.55),('1444','2013-11-25','13:15:00',1.25),('1444','2013-11-25','13:20:00',2.11),('1444','2013-11-25','13:25:00',1.97),('1444','2013-11-25','13:30:00',1.43),('1444','2013-11-24','10:00:00',1.07),('1444','2013-11-24','10:05:00',1.11),('1444','2013-11-24','10:10:00',1.13),('1444','2013-11-24','10:15:00',1.05),('1444','2013-11-24','10:25:00',1.2),('1444','2013-11-24','10:30:00',1.13),('1444','2013-11-24','11:20:00',1.03),('1444','2013-11-24','11:25:00',1.06),('1444','2013-11-24','11:30:00',1.07),('1444','2013-11-24','13:05:00',1.1),('1444','2013-11-24','13:10:00',1.08),('1444','2013-11-24','13:15:00',1.04),('1444','2013-11-23','10:25:00',1.1),('1444','2013-11-23','10:30:00',1.18),('1444','2013-11-23','10:40:00',1.58),('1444','2013-11-23','13:35:00',1.1),('1444','2013-11-21','09:45:00',1.15),('1444','2013-11-21','09:55:00',1.12),('1444','2013-11-21','10:00:00',1.33),('1444','2013-11-21','10:05:00',1.33),('1444','2013-11-21','10:15:00',1.41),('1444','2013-11-21','10:20:00',1.28),('1444','2013-11-21','10:25:00',1.01),('1444','2013-11-21','10:30:00',1.42),('1444','2013-11-21','10:35:00',1.47),('1444','2013-11-21','10:40:00',1.67),('1444','2013-11-21','10:45:00',1.19),('1444','2013-11-21','11:20:00',1.05),('1444','2013-11-21','11:30:00',1.12),('1444','2013-11-21','11:35:00',1.53),('1444','2013-11-21','11:40:00',1.28),('1444','2013-11-21','11:50:00',1.38),('1444','2013-11-21','11:55:00',1.6),('1444','2013-11-21','12:05:00',1.69),('1444','2013-11-21','12:10:00',1.65),('1444','2013-11-21','12:15:00',1.64),('1444','2013-11-21','12:20:00',1.66),('1444','2013-11-21','12:25:00',1.73),('1444','2013-11-21','12:30:00',1.85),('1444','2013-11-21','12:35:00',1.82),('1444','2013-11-21','12:40:00',1.91),('1444','2013-11-21','12:45:00',1.84),('1444','2013-11-21','12:50:00',1.55),('1444','2013-11-21','12:55:00',1.85),('1444','2013-11-21','13:00:00',1.84),('1444','2013-11-21','13:05:00',1.76),('1444','2013-11-21','13:10:00',1.71),('1444','2013-11-21','13:15:00',1.74),('1444','2013-11-21','13:20:00',1.54),('1444','2013-11-21','13:25:00',1.34),('1444','2013-11-21','13:40:00',1.36),('1444','2013-11-21','13:45:00',1.31),('1444','2013-11-21','13:55:00',1.13),('1444','2013-11-21','14:00:00',1.29),('1444','2013-11-20','09:25:00',1),('1444','2013-11-20','09:30:00',1.14),('1444','2013-11-20','10:15:00',1.27),('1444','2013-11-20','11:45:00',2.51),('1444','2013-11-20','11:50:00',2.05),('1444','2013-11-20','11:55:00',1.21),('1444','2013-11-20','12:50:00',1.82),('1444','2013-11-20','12:55:00',1.84),('1444','2013-11-20','13:00:00',1.27),('1444','2013-11-20','13:05:00',1.21),('1444','2013-11-20','13:20:00',1.14),('1444','2013-11-19','09:40:00',1.17),('1444','2013-11-19','09:45:00',1.11),('1444','2013-11-19','11:20:00',1.13),('1444','2013-11-19','11:25:00',1.34),('1444','2013-11-19','11:30:00',1.57),('1444','2013-11-19','11:35:00',1.76),('1444','2013-11-19','11:40:00',1.34),('1444','2013-11-19','11:45:00',1.58),('1444','2013-11-19','11:50:00',1.47),('1444','2013-11-19','11:55:00',1.32),('1444','2013-11-19','12:00:00',1.32),('1444','2013-11-19','12:05:00',1.43),('1444','2013-11-19','12:10:00',1.14),('1444','2013-11-19','12:15:00',1.55),('1444','2013-11-19','12:30:00',1.1),('1444','2013-11-19','12:40:00',1.1),('1444','2013-11-19','12:45:00',1.3),('1444','2013-11-19','12:50:00',1.32),('1444','2013-11-19','12:55:00',1.81),('1444','2013-11-19','13:15:00',1.38),('1444','2013-11-19','13:20:00',1.11),('1444','2013-11-18','09:35:00',1.14),('1444','2013-11-18','10:10:00',1.09),('1444','2013-11-18','10:15:00',1.14),('1444','2013-11-18','12:05:00',1.03),('1444','2013-11-18','12:10:00',1.02),('1444','2013-11-18','12:15:00',1.06),('1444','2013-11-18','12:20:00',1.12),('1444','2013-11-18','12:25:00',1.14),('1444','2013-11-18','12:30:00',1.01),('1444','2014-04-19','07:55:00',1.46),('1444','2014-04-19','08:00:00',1.15),('1444','2014-04-19','08:25:00',1.34),('1444','2014-04-19','08:30:00',1.8),('1444','2014-04-19','08:35:00',1.63),('1444','2014-04-19','08:40:00',1.54),('1444','2014-04-19','08:45:00',1.42),('1444','2014-04-19','08:50:00',1.12),('1444','2014-04-19','09:25:00',1.23),('1444','2014-04-19','09:30:00',1.66),('1444','2014-04-19','09:35:00',1.47),('1444','2014-04-19','10:55:00',1.29),('1444','2014-04-19','11:00:00',1.28),('1444','2014-04-19','11:05:00',1.02),('1444','2014-04-19','11:10:00',1.03),('1444','2014-04-19','11:15:00',1.59),('1444','2014-04-19','11:20:00',2.31),('1444','2014-04-19','11:25:00',1.8),('1444','2014-04-19','11:30:00',2.06),('1444','2014-04-19','11:35:00',1.97),('1444','2014-04-19','11:40:00',1.71),('1444','2014-04-19','11:45:00',1.65),('1444','2014-04-19','11:50:00',1.29),('1444','2014-04-19','13:15:00',1.28),('1444','2014-04-19','14:30:00',1.12),('1444','2014-04-19','14:35:00',1.25),('1444','2014-04-19','14:40:00',1.52),('1444','2014-04-19','14:45:00',1.56),('1444','2014-04-19','15:00:00',1.2),('1444','2014-04-19','15:50:00',2.91),('1444','2014-04-19','15:55:00',1.94),('1444','2014-04-19','16:00:00',1.91),('1444','2014-04-19','16:05:00',1.64),('1444','2014-04-19','16:10:00',1.44),('1444','2014-04-19','16:15:00',1.46),('1444','2014-04-19','16:20:00',1.67),('1444','2014-04-19','16:25:00',1.57),('1444','2014-04-19','16:30:00',1.81),('1444','2014-04-19','16:35:00',1.23),('1444','2014-04-19','17:20:00',1.35),('1444','2014-04-19','17:25:00',1.05),('1444','2013-11-17','08:50:00',1.07),('1444','2013-11-17','08:55:00',1.07),('1444','2013-11-17','09:25:00',1.09),('1444','2013-11-17','09:30:00',1.13),('1444','2013-11-17','09:35:00',1.07),('1444','2013-11-17','09:40:00',1.1),('1444','2013-11-17','09:45:00',1.13),('1444','2013-11-17','09:50:00',1.15),('1444','2013-11-17','09:55:00',1.19),('1444','2013-11-17','10:00:00',1.23),('1444','2013-11-17','10:05:00',1.27),('1444','2013-11-17','10:10:00',1.29),('1444','2013-11-17','10:15:00',1.35),('1444','2013-11-17','10:20:00',1.38),('1444','2013-11-17','10:25:00',1.4),('1444','2013-11-17','10:30:00',1.43),('1444','2013-11-17','10:35:00',1.45),('1444','2013-11-17','10:40:00',1.46),('1444','2013-11-17','10:45:00',1.48),('1444','2013-11-17','10:50:00',1.49),('1444','2013-11-17','10:55:00',1.51),('1444','2013-11-17','11:00:00',1.53),('1444','2013-11-17','11:05:00',1.55),('1444','2013-11-17','11:10:00',1.56),('1444','2013-11-17','11:15:00',1.57),('1444','2013-11-17','11:20:00',1.58),('1444','2013-11-17','11:25:00',1.58),('1444','2013-11-17','11:30:00',1.58),('1444','2013-11-17','11:35:00',1.58),('1444','2013-11-17','11:40:00',1.58),('1444','2013-11-17','11:45:00',1.59),('1444','2013-11-17','11:50:00',1.6),('1444','2013-11-17','11:55:00',1.59),('1444','2013-11-17','12:00:00',1.57),('1444','2013-11-17','12:05:00',1.58),('1444','2013-11-17','12:10:00',1.57),('1444','2013-11-17','12:15:00',1.57),('1444','2013-11-17','12:20:00',1.55),('1444','2013-11-17','12:25:00',1.53),('1444','2013-11-17','12:30:00',1.53),('1444','2013-11-17','12:35:00',1.51),('1444','2013-11-17','12:40:00',1.51),('1444','2013-11-17','12:45:00',1.48),('1444','2013-11-17','12:50:00',1.45),('1444','2013-11-17','12:55:00',1.42),('1444','2013-11-17','13:00:00',1.39),('1444','2013-11-17','13:05:00',1.37),('1444','2013-11-17','13:10:00',1.34),('1444','2013-11-17','13:15:00',1.33),('1444','2013-11-17','13:20:00',1.28),('1444','2013-11-17','13:25:00',1.17),('1444','2013-11-17','13:30:00',1.3),('1444','2013-11-17','13:35:00',1.33),('1444','2013-11-17','13:40:00',1),('1444','2013-11-15','11:20:00',1.13),('1444','2013-11-15','11:25:00',1.15),('1444','2013-11-15','11:30:00',1.22),('1444','2013-11-15','11:35:00',1.15),('1444','2013-11-15','11:40:00',1.22),('1444','2013-11-15','11:45:00',1.04),('1444','2013-11-15','12:20:00',1.01),('1444','2013-11-15','13:45:00',1.1),('1444','2013-11-15','13:50:00',1.09),('1444','2013-11-14','09:05:00',1.01),('1444','2013-11-14','09:20:00',1.02),('1444','2013-11-14','09:25:00',1.03),('1444','2013-11-14','09:30:00',1.06),('1444','2013-11-14','09:35:00',1.11),('1444','2013-11-14','09:40:00',1.13),('1444','2013-11-14','09:45:00',1.15),('1444','2013-11-14','10:15:00',1.36),('1444','2013-11-14','10:20:00',1.44),('1444','2013-11-14','10:25:00',1.43),('1444','2013-11-14','10:30:00',1.46),('1444','2013-11-14','10:35:00',1.47),('1444','2013-11-14','10:40:00',1.46),('1444','2013-11-14','10:45:00',1.45),('1444','2013-11-14','10:50:00',1.5),('1444','2013-11-14','10:55:00',1.54),('1444','2013-11-14','11:00:00',1.55),('1444','2013-11-14','11:05:00',1.6),('1444','2013-11-14','11:10:00',1.65),('1444','2013-11-14','11:15:00',1.67),('1444','2013-11-14','11:20:00',1.72),('1444','2013-11-14','11:25:00',1.73),('1444','2013-11-14','11:30:00',1.74),('1444','2013-11-14','11:35:00',1.56),('1444','2013-11-14','11:40:00',1.39),('1444','2013-11-14','11:45:00',1.02),('1444','2013-11-14','11:55:00',1.65),('1444','2013-11-14','12:00:00',1.82),('1444','2013-11-14','12:05:00',1.72),('1444','2013-11-13','10:20:00',1.76),('1444','2013-11-13','10:25:00',1.96),('1444','2013-11-13','10:30:00',1.93),('1444','2013-11-13','10:35:00',2.18),('1444','2013-11-13','10:40:00',2.01),('1444','2013-11-13','10:45:00',1.97),('1444','2013-11-13','10:50:00',2.17),('1444','2013-11-13','10:55:00',1.51),('1444','2013-11-13','14:00:00',1.11),('1444','2013-11-13','14:05:00',1.05),('1444','2013-11-13','14:10:00',1.01),('1444','2013-11-13','14:15:00',1.03),('1444','2013-11-13','14:25:00',1.01),('1444','2013-11-12','11:50:00',1.14),('1444','2013-11-12','12:00:00',1.65),('1444','2013-11-12','12:30:00',2.46),('1444','2013-11-12','12:35:00',2.3),('1444','2013-11-12','12:40:00',1.43),('1444','2013-11-12','12:45:00',1.36),('1444','2013-11-12','12:50:00',1.28),('1444','2013-11-12','12:55:00',1.48),('1444','2013-11-12','13:00:00',1.33),('1444','2013-11-12','13:05:00',1.29),('1444','2013-11-12','13:10:00',1.43),('1444','2013-11-12','13:15:00',1.37),('1444','2013-11-12','13:20:00',1.17),('1444','2013-11-12','13:25:00',1.22),('1444','2013-11-12','13:30:00',1.27),('1444','2013-11-12','13:35:00',1.33),('1444','2013-11-12','13:40:00',1.31),('1444','2013-11-12','13:45:00',1.09),('1444','2013-11-12','14:10:00',1.54),('1444','2013-11-12','14:15:00',1.63),('1444','2013-11-12','14:20:00',1.31),('1444','2013-11-12','14:30:00',1),('1444','2013-11-11','10:15:00',1.48),('1444','2013-11-11','10:20:00',1.38),('1444','2013-11-11','11:05:00',1.21);
INSERT INTO `solarlog` VALUES ('1444','2013-11-11','11:10:00',2.45),('1444','2013-11-11','11:15:00',2.32),('1444','2013-11-11','11:20:00',1.22),('1444','2013-11-11','11:25:00',1.33),('1444','2013-11-11','11:30:00',2.38),('1444','2013-11-11','11:35:00',2.04),('1444','2013-11-11','11:40:00',2.03),('1444','2013-11-11','11:45:00',1.74),('1444','2013-11-11','11:50:00',2.13),('1444','2013-11-11','11:55:00',2.15),('1444','2013-11-11','12:00:00',1.84),('1444','2013-11-11','12:05:00',1.88),('1444','2013-11-11','12:10:00',1.5),('1444','2013-11-11','12:15:00',1.68),('1444','2013-11-11','12:20:00',1.79),('1444','2013-11-11','12:25:00',1.9),('1444','2013-11-11','12:40:00',1.06),('1444','2013-11-11','12:45:00',1.03),('1444','2013-11-11','13:40:00',1.04),('1444','2013-11-11','14:00:00',1.42),('1444','2013-11-11','14:25:00',1.24),('1444','2013-11-11','14:30:00',1.1),('1444','2013-11-11','14:35:00',1.06),('1444','2013-11-10','08:50:00',1.02),('1444','2013-11-10','09:20:00',1.07),('1444','2013-11-10','09:25:00',1.16),('1444','2013-11-10','09:35:00',1.01),('1444','2013-11-10','09:40:00',1.11),('1444','2013-11-10','09:45:00',1.25),('1444','2013-11-10','09:50:00',1.29),('1444','2013-11-10','09:55:00',1.3),('1444','2013-11-10','10:00:00',1.22),('1444','2013-11-10','10:05:00',1.36),('1444','2013-11-10','10:10:00',1.58),('1444','2013-11-10','10:15:00',1.57),('1444','2013-11-10','10:20:00',1.46),('1444','2013-11-10','10:25:00',1.78),('1444','2013-11-10','10:30:00',1.64),('1444','2013-11-10','10:35:00',1.21),('1444','2013-11-10','10:40:00',1.62),('1444','2013-11-10','10:45:00',1.71),('1444','2013-11-10','10:50:00',2.04),('1444','2013-11-10','10:55:00',2.03),('1444','2013-11-10','11:25:00',1.03),('1444','2013-11-10','11:40:00',1.56),('1444','2013-11-10','11:45:00',1.63),('1444','2013-11-10','11:55:00',1.12),('1444','2013-11-10','12:10:00',1.04),('1444','2013-11-10','12:15:00',1.78),('1444','2013-11-10','12:20:00',1.55),('1444','2013-11-10','12:25:00',1.68),('1444','2013-11-10','12:35:00',1.61),('1444','2013-11-10','12:40:00',1.87),('1444','2013-11-10','12:45:00',1.99),('1444','2013-11-10','12:50:00',1.92),('1444','2013-11-10','12:55:00',1.28),('1444','2013-11-10','13:50:00',1.4),('1444','2013-11-09','09:45:00',1.17),('1444','2013-11-09','09:50:00',1.76),('1444','2013-11-09','09:55:00',1.61),('1444','2013-11-09','10:00:00',1.56),('1444','2013-11-09','10:05:00',1.46),('1444','2013-11-09','10:10:00',1.39),('1444','2013-11-09','10:15:00',1.41),('1444','2013-11-09','10:20:00',1.14),('1444','2013-11-09','10:50:00',1.26),('1444','2013-11-09','10:55:00',1.22),('1444','2013-11-09','11:00:00',1.33),('1444','2013-11-09','11:05:00',1.35),('1444','2013-11-09','11:10:00',1.68),('1444','2013-11-09','11:15:00',1.41),('1444','2013-11-09','11:20:00',1.24),('1444','2013-11-09','11:25:00',1.65),('1444','2013-11-09','11:30:00',1.45),('1444','2013-11-09','11:35:00',1.18),('1444','2013-11-09','11:40:00',1.68),('1444','2013-11-09','11:45:00',1.98),('1444','2013-11-09','11:50:00',1.57),('1444','2013-11-09','11:55:00',2.09),('1444','2013-11-09','12:00:00',2.3),('1444','2013-11-09','12:05:00',2.13),('1444','2013-11-09','12:10:00',1.11),('1444','2013-11-09','12:15:00',1.38),('1444','2013-11-09','12:25:00',1.17),('1444','2013-11-09','12:30:00',1.5),('1444','2013-11-09','12:35:00',2.33),('1444','2013-11-09','12:40:00',2.21),('1444','2013-11-09','12:45:00',1.03),('1444','2013-11-09','12:55:00',1.68),('1444','2013-11-09','13:00:00',1.51),('1444','2013-11-09','13:05:00',1.53),('1444','2013-11-09','13:10:00',1.8),('1444','2013-11-09','13:15:00',1.47),('1444','2013-11-09','13:25:00',1.69),('1444','2013-11-09','13:30:00',1.47),('1444','2013-11-09','13:35:00',1.44),('1444','2013-11-09','13:40:00',1.37),('1444','2013-11-09','13:45:00',1.34),('1444','2013-11-09','13:50:00',1.36),('1444','2013-11-09','13:55:00',1.31),('1444','2013-11-09','14:00:00',1.1),('1444','2013-11-09','14:05:00',1.13),('1444','2013-11-09','14:20:00',1.17),('1444','2013-11-08','09:30:00',1.06),('1444','2013-11-08','09:50:00',1.32),('1444','2013-11-08','09:55:00',1.66),('1444','2013-11-08','10:00:00',1.44),('1444','2013-11-08','10:05:00',1.33),('1444','2013-11-08','10:10:00',1.28),('1444','2013-11-08','10:50:00',1.55),('1444','2013-11-08','11:40:00',1.09),('1444','2013-11-08','11:45:00',1.09),('1444','2013-11-08','11:50:00',1.99),('1444','2013-11-08','11:55:00',1.99),('1444','2013-11-08','12:00:00',1.83),('1444','2013-11-08','12:05:00',1.72),('1444','2013-11-08','12:10:00',1.33),('1444','2013-11-08','12:20:00',1.21),('1444','2013-11-08','12:30:00',1.83),('1444','2013-11-08','12:35:00',1.89),('1444','2013-11-08','12:40:00',1.9),('1444','2013-11-08','12:45:00',1.9),('1444','2013-11-08','12:50:00',1.86),('1444','2013-11-08','12:55:00',1.78),('1444','2013-11-08','13:00:00',1.69),('1444','2013-11-08','13:05:00',1.72),('1444','2013-11-08','13:10:00',1.33),('1444','2013-11-08','13:20:00',1.07),('1444','2013-11-08','13:35:00',1.46),('1444','2013-11-08','13:40:00',1.39),('1444','2013-11-08','13:45:00',1.33),('1444','2013-11-08','13:50:00',1.32),('1444','2013-11-08','13:55:00',1.27),('1444','2013-11-08','14:00:00',1.23),('1444','2013-11-08','14:05:00',1.09),('1444','2013-11-08','14:10:00',1.16),('1444','2013-11-08','14:15:00',1.1),('1444','2013-11-08','14:25:00',1.06),('1444','2013-11-08','14:30:00',1.07),('1444','2013-11-08','14:35:00',1.08),('1444','2014-04-18','08:05:00',1.25),('1444','2014-04-18','08:10:00',1.24),('1444','2014-04-18','08:40:00',1.09),('1444','2014-04-18','08:45:00',1.25),('1444','2014-04-18','09:05:00',1.8),('1444','2014-04-18','09:10:00',2.45),('1444','2014-04-18','09:15:00',2.28),('1444','2014-04-18','09:20:00',2.14),('1444','2014-04-18','09:25:00',1.3),('1444','2014-04-18','09:30:00',2.36),('1444','2014-04-18','09:35:00',1.5),('1444','2014-04-18','09:45:00',1.36),('1444','2014-04-18','09:50:00',2.18),('1444','2014-04-18','09:55:00',2.47),('1444','2014-04-18','10:00:00',2.05),('1444','2014-04-18','10:05:00',1.38),('1444','2014-04-18','10:10:00',1.21),('1444','2014-04-18','10:15:00',1.2),('1444','2014-04-18','10:20:00',1.21),('1444','2014-04-18','10:25:00',1.23),('1444','2014-04-18','10:30:00',1.04),('1444','2014-04-18','10:40:00',1.09),('1444','2014-04-18','10:45:00',1.8),('1444','2014-04-18','10:50:00',2.04),('1444','2014-04-18','10:55:00',2.28),('1444','2014-04-18','11:00:00',1.52),('1444','2014-04-18','11:05:00',1.36),('1444','2014-04-18','11:10:00',1.46),('1444','2014-04-18','11:15:00',2.61),('1444','2014-04-18','11:20:00',1.6),('1444','2014-04-18','11:25:00',1.15),('1444','2014-04-18','11:30:00',1.34),('1444','2014-04-18','11:35:00',1.35),('1444','2014-04-18','11:40:00',1.38),('1444','2014-04-18','11:45:00',1.31),('1444','2014-04-18','11:50:00',1.6),('1444','2014-04-18','11:55:00',1.42),('1444','2014-04-18','12:00:00',1.48),('1444','2014-04-18','12:05:00',2.6),('1444','2014-04-18','12:10:00',2.88),('1444','2014-04-18','12:15:00',2.95),('1444','2014-04-18','12:20:00',2.88),('1444','2014-04-18','12:25:00',2.29),('1444','2014-04-18','12:30:00',3.42),('1444','2014-04-18','12:35:00',3.26),('1444','2014-04-18','12:40:00',3.53),('1444','2014-04-18','12:45:00',2.73),('1444','2014-04-18','12:50:00',2.85),('1444','2014-04-18','12:55:00',2.15),('1444','2014-04-18','13:00:00',3.35),('1444','2014-04-18','13:05:00',1.89),('1444','2014-04-18','13:10:00',1.91),('1444','2014-04-18','13:15:00',1.87),('1444','2014-04-18','13:20:00',1.77),('1444','2014-04-18','13:25:00',1.36),('1444','2014-04-18','13:30:00',1.09),('1444','2014-04-18','13:35:00',1.12),('1444','2014-04-18','13:40:00',1.09),('1444','2014-04-18','13:50:00',1.08),('1444','2014-04-18','13:55:00',1.83),('1444','2014-04-18','14:00:00',1.63),('1444','2014-04-18','14:05:00',1.46),('1444','2014-04-18','14:10:00',1.24),('1444','2014-04-18','14:15:00',1.1),('1444','2014-04-18','14:20:00',1.27),('1444','2014-04-18','14:25:00',1.62),('1444','2014-04-18','14:30:00',1.84),('1444','2014-04-18','14:35:00',2.05),('1444','2014-04-18','14:40:00',1.79),('1444','2014-04-18','14:45:00',2.09),('1444','2014-04-18','14:50:00',2.15),('1444','2014-04-18','14:55:00',1.83),('1444','2014-04-18','15:00:00',3.29),('1444','2014-04-18','15:05:00',2.11),('1444','2014-04-18','15:10:00',1.45),('1444','2014-04-18','15:15:00',1.66),('1444','2014-04-18','15:20:00',1.44),('1444','2014-04-18','15:25:00',1.81),('1444','2014-04-18','15:30:00',2.52),('1444','2014-04-18','15:35:00',2.84),('1444','2014-04-18','15:40:00',2.59),('1444','2014-04-18','15:45:00',1.9),('1444','2014-04-18','15:50:00',2.13),('1444','2014-04-18','15:55:00',2.17),('1444','2014-04-18','16:00:00',1.88),('1444','2014-04-18','16:05:00',1.46),('1444','2014-04-18','16:10:00',1.19),('1444','2014-04-18','16:15:00',1.04),('1444','2014-04-18','16:20:00',1.07),('1444','2014-04-18','16:25:00',2.03),('1444','2014-04-18','16:30:00',1.86),('1444','2014-04-18','16:35:00',2.42),('1444','2014-04-18','16:40:00',2.27),('1444','2014-04-18','16:45:00',2.09),('1444','2014-04-18','16:50:00',2.09),('1444','2014-04-18','16:55:00',2.05),('1444','2014-04-18','17:00:00',2.04),('1444','2014-04-18','17:05:00',2.1),('1444','2014-04-18','17:10:00',1.69),('1444','2014-04-18','17:15:00',1.6),('1444','2014-04-18','17:20:00',1.58),('1444','2014-04-18','17:25:00',1.57),('1444','2014-04-18','17:30:00',1.42),('1444','2014-04-18','17:35:00',1.34),('1444','2014-04-18','17:40:00',1.3),('1444','2014-04-18','17:45:00',1.22),('1444','2014-04-18','17:50:00',1.16),('1444','2014-04-18','17:55:00',1.1),('1444','2014-04-18','18:00:00',1.06),('1444','2013-11-07','09:15:00',1.02),('1444','2013-11-07','09:20:00',1.06),('1444','2013-11-07','09:25:00',1.09),('1444','2013-11-07','09:30:00',1.14),('1444','2013-11-07','09:35:00',1.19),('1444','2013-11-07','09:40:00',1.23),('1444','2013-11-07','09:45:00',1.27),('1444','2013-11-07','09:50:00',1.31),('1444','2013-11-07','09:55:00',1.34),('1444','2013-11-07','10:00:00',1.37),('1444','2013-11-07','10:05:00',1.39),('1444','2013-11-07','10:10:00',1.41),('1444','2013-11-07','10:15:00',1.42),('1444','2013-11-07','10:20:00',1.43),('1444','2013-11-07','10:25:00',1.47),('1444','2013-11-07','10:30:00',1.49),('1444','2013-11-07','10:35:00',1.51),('1444','2013-11-07','10:40:00',1.53),('1444','2013-11-07','10:45:00',1.55),('1444','2013-11-07','10:50:00',1.55),('1444','2013-11-07','10:55:00',1.55),('1444','2013-11-07','11:00:00',1.56),('1444','2013-11-07','11:05:00',1.57),('1444','2013-11-07','11:10:00',1.57),('1444','2013-11-07','11:15:00',1.59),('1444','2013-11-07','11:20:00',1.61),('1444','2013-11-07','11:25:00',1.6),('1444','2013-11-07','11:30:00',1.62),('1444','2013-11-07','11:35:00',1.65),('1444','2013-11-07','11:40:00',1.63),('1444','2013-11-07','11:45:00',1.62),('1444','2013-11-07','11:50:00',1.65),('1444','2013-11-07','11:55:00',1.62),('1444','2013-11-07','12:00:00',1.62),('1444','2013-11-07','12:05:00',1.62),('1444','2013-11-07','12:10:00',1.6),('1444','2013-11-07','12:15:00',1.56),('1444','2013-11-07','12:20:00',1.55),('1444','2013-11-07','12:25:00',1.51),('1444','2013-11-07','12:30:00',1.51),('1444','2013-11-07','12:35:00',1.56),('1444','2013-11-07','12:40:00',1.59),('1444','2013-11-07','12:45:00',1.57),('1444','2013-11-07','12:50:00',1.54),('1444','2013-11-07','12:55:00',1.66),('1444','2013-11-07','13:00:00',1.59),('1444','2013-11-07','13:20:00',1.19),('1444','2013-11-07','13:25:00',1.59),('1444','2013-11-07','13:30:00',1.74),('1444','2013-11-07','13:35:00',1.14),('1444','2013-11-07','13:45:00',1.34),('1444','2013-11-07','13:50:00',1.03),('1444','2013-11-07','14:05:00',1.08),('1444','2013-11-07','14:10:00',1.07),('1444','2013-11-07','14:30:00',1.12),('1444','2013-11-07','14:35:00',1.01),('1444','2013-11-06','09:25:00',1.14),('1444','2013-11-06','09:30:00',1.2),('1444','2013-11-06','09:35:00',1.25),('1444','2013-11-06','09:40:00',1.3),('1444','2013-11-06','09:45:00',1.33),('1444','2013-11-06','09:50:00',1.37),('1444','2013-11-06','09:55:00',1.4),('1444','2013-11-06','10:00:00',1.43),('1444','2013-11-06','10:05:00',1.46),('1444','2013-11-06','10:10:00',1.49),('1444','2013-11-06','10:15:00',1.52),('1444','2013-11-06','10:20:00',1.55),('1444','2013-11-06','10:25:00',1.57),('1444','2013-11-06','10:30:00',1.59),('1444','2013-11-06','10:35:00',1.61),('1444','2013-11-06','10:40:00',1.63),('1444','2013-11-06','10:45:00',1.65),('1444','2013-11-06','10:50:00',1.67),('1444','2013-11-06','10:55:00',1.69),('1444','2013-11-06','11:00:00',1.7),('1444','2013-11-06','11:05:00',1.71),('1444','2013-11-06','11:10:00',1.72),('1444','2013-11-06','11:15:00',1.74),('1444','2013-11-06','11:20:00',1.75),('1444','2013-11-06','11:25:00',1.75),('1444','2013-11-06','11:30:00',1.75),('1444','2013-11-06','11:35:00',1.76),('1444','2013-11-06','11:40:00',1.75),('1444','2013-11-06','11:45:00',1.77),('1444','2013-11-06','11:50:00',1.77),('1444','2013-11-06','11:55:00',1.78),('1444','2013-11-06','12:00:00',1.77),('1444','2013-11-06','12:05:00',1.76),('1444','2013-11-06','12:10:00',1.75),('1444','2013-11-06','12:15:00',1.74),('1444','2013-11-06','12:20:00',1.74),('1444','2013-11-06','12:25:00',1.73),('1444','2013-11-06','12:30:00',1.73),('1444','2013-11-06','12:35:00',1.72),('1444','2013-11-06','12:40:00',1.69),('1444','2013-11-06','12:45:00',1.68),('1444','2013-11-06','12:50:00',1.67),('1444','2013-11-06','12:55:00',1.65),('1444','2013-11-06','13:00:00',1.62),('1444','2013-11-06','13:05:00',1.6),('1444','2013-11-06','13:10:00',1.57),('1444','2013-11-06','13:15:00',1.55),('1444','2013-11-06','13:20:00',1.53),('1444','2013-11-06','13:25:00',1.51),('1444','2013-11-06','13:30:00',1.46),('1444','2013-11-06','13:35:00',1.43),('1444','2013-11-06','13:40:00',1.39),('1444','2013-11-06','13:45:00',1.34),('1444','2013-11-06','13:50:00',1.31),('1444','2013-11-06','13:55:00',1.27),('1444','2013-11-06','14:00:00',1.23),('1444','2013-11-06','14:05:00',1.19),('1444','2013-11-06','14:10:00',1.09),('1444','2013-11-06','14:15:00',1.1),('1444','2013-11-06','14:20:00',1.11),('1444','2013-11-06','14:25:00',1.08),('1444','2013-11-06','14:30:00',1.04),('1444','2013-11-06','14:35:00',1.01),('1444','2013-11-05','08:35:00',1.02),('1444','2013-11-05','08:40:00',1.01),('1444','2013-11-05','10:20:00',1.21),('1444','2013-11-05','10:25:00',1.52),('1444','2013-11-05','10:30:00',1.05),('1444','2013-11-05','10:35:00',1.46),('1444','2013-11-05','10:40:00',1.03),('1444','2013-11-05','10:45:00',1.07),('1444','2013-11-05','11:40:00',1.05),('1444','2013-11-05','12:10:00',1.09),('1444','2013-11-05','12:15:00',1.05),('1444','2013-11-05','12:20:00',1.04),('1444','2013-11-05','12:30:00',1.01),('1444','2013-11-05','13:35:00',1.46),('1444','2013-11-05','13:40:00',1.55),('1444','2013-11-05','13:45:00',1.39),('1444','2013-11-05','13:50:00',1.01),('1444','2013-11-05','13:55:00',1.71),('1444','2013-11-05','14:00:00',1.14),('1444','2013-11-05','14:05:00',1.49),('1444','2013-11-05','14:10:00',1.14),('1444','2013-11-05','14:25:00',1.07),('1444','2013-11-05','14:30:00',1.29),('1444','2013-11-05','14:35:00',1.31),('1444','2013-11-05','14:40:00',1.17),('1444','2013-11-05','14:45:00',1.07),('1444','2013-11-04','09:10:00',1.08),('1444','2013-11-04','09:15:00',1.14),('1444','2013-11-04','09:20:00',1.35),('1444','2013-11-04','09:25:00',1.66),('1444','2013-11-04','10:00:00',1.29),('1444','2013-11-04','10:05:00',1.53),('1444','2013-11-04','10:10:00',1.57),('1444','2013-11-04','10:15:00',1.61),('1444','2013-11-04','10:20:00',1.62),('1444','2013-11-04','10:25:00',1.83),('1444','2013-11-04','10:30:00',1.73),('1444','2013-11-04','10:35:00',1.94),('1444','2013-11-04','10:40:00',1.9),('1444','2013-11-04','10:45:00',1.27),('1444','2013-11-04','10:50:00',1.24),('1444','2013-11-04','10:55:00',1.92),('1444','2013-11-04','11:00:00',1.92),('1444','2013-11-04','11:05:00',1.58),('1444','2013-11-04','11:10:00',1.13),('1444','2013-11-04','11:15:00',1.39),('1444','2013-11-04','11:20:00',1.17),('1444','2013-11-04','11:25:00',1.13),('1444','2013-11-04','11:30:00',1.66),('1444','2013-11-04','11:35:00',1.35),('1444','2013-11-04','11:40:00',1.46),('1444','2013-11-04','11:45:00',1.87),('1444','2013-11-04','11:50:00',2.36),('1444','2013-11-04','11:55:00',2.05),('1444','2013-11-04','12:00:00',2.07),('1444','2013-11-04','12:05:00',1.9),('1444','2013-11-04','12:10:00',1.88),('1444','2013-11-04','12:15:00',1.85),('1444','2013-11-04','12:20:00',1.85),('1444','2013-11-04','12:25:00',1.82),('1444','2013-11-04','12:30:00',1.81),('1444','2013-11-04','12:35:00',1.81),('1444','2013-11-04','12:40:00',1.79),('1444','2013-11-04','12:45:00',1.77),('1444','2013-11-04','12:50:00',1.72),('1444','2013-11-04','12:55:00',1.69),('1444','2013-11-04','13:00:00',1.69),('1444','2013-11-04','13:05:00',1.55),('1444','2013-11-04','13:10:00',1.57),('1444','2013-11-04','13:15:00',1.56),('1444','2013-11-04','13:20:00',1.44),('1444','2013-11-04','13:25:00',1.61),('1444','2013-11-04','13:30:00',1.57),('1444','2013-11-04','13:35:00',1.48),('1444','2013-11-04','13:40:00',1.24),('1444','2013-11-04','13:45:00',1.6),('1444','2013-11-04','13:50:00',1.43),('1444','2013-11-04','14:05:00',1.33),('1444','2013-11-04','14:10:00',1.36),('1444','2013-11-04','14:15:00',1.39),('1444','2013-11-04','14:20:00',1.38),('1444','2013-11-04','14:30:00',1.01),('1444','2013-11-04','14:35:00',1.26),('1444','2013-11-04','14:40:00',1.1),('1444','2013-11-04','14:45:00',1.03),('1444','2013-11-04','14:50:00',1.01),('1444','2013-11-03','09:40:00',1.61),('1444','2013-11-03','10:20:00',1.41),('1444','2013-11-03','10:30:00',1.58),('1444','2013-11-03','11:20:00',1.04),('1444','2013-11-03','11:30:00',1.48),('1444','2013-11-03','11:35:00',1.29),('1444','2013-11-03','11:40:00',1.95),('1444','2013-11-03','11:45:00',1.99),('1444','2013-11-03','11:50:00',2.03),('1444','2013-11-03','11:55:00',1.69),('1444','2013-11-03','12:00:00',2.31),('1444','2013-11-03','12:05:00',2.05),('1444','2013-11-03','12:10:00',1.75),('1444','2013-11-03','12:15:00',1.06),('1444','2013-11-03','12:25:00',1.24),('1444','2013-11-03','13:45:00',1.73),('1444','2013-11-03','14:00:00',1.18),('1444','2013-11-03','14:05:00',1.33),('1444','2013-11-03','14:10:00',1.13),('1444','2013-11-03','14:15:00',1.24),('1444','2013-11-03','14:25:00',1.22),('1444','2013-11-03','14:40:00',1.06),('1444','2013-11-02','09:05:00',1.08),('1444','2013-11-02','09:10:00',1.06),('1444','2013-11-02','09:15:00',1.06),('1444','2013-11-02','09:25:00',1.16),('1444','2013-11-02','09:30:00',1.23),('1444','2013-11-02','09:35:00',1.16),('1444','2013-11-02','09:40:00',1.28),('1444','2013-11-02','09:45:00',1.36),('1444','2013-11-02','09:50:00',1.43),('1444','2013-11-02','10:00:00',1.27),('1444','2013-11-02','10:05:00',1.55),('1444','2013-11-02','11:55:00',1.53),('1444','2013-11-02','12:00:00',2.01),('1444','2013-11-02','12:05:00',2.05),('1444','2013-11-02','12:10:00',1.75),('1444','2013-11-02','12:15:00',1.65),('1444','2013-11-02','12:20:00',2.08),('1444','2013-11-02','12:25:00',1.96),('1444','2013-11-02','12:30:00',2.32),('1444','2013-11-02','12:35:00',1.87),('1444','2013-11-02','12:40:00',1.86),('1444','2013-11-02','12:45:00',1.31),('1444','2013-11-02','12:50:00',1.88),('1444','2013-11-02','12:55:00',1.98),('1444','2013-11-02','13:00:00',1.51),('1444','2013-11-02','13:05:00',2.03),('1444','2013-11-02','13:10:00',2.02),('1444','2013-11-02','13:15:00',1.37),('1444','2013-11-02','13:30:00',1.77),('1444','2013-11-02','13:35:00',1.73),('1444','2013-11-02','13:40:00',1.62),('1444','2013-11-02','13:45:00',1.89),('1444','2013-11-02','13:50:00',1.93),('1444','2013-11-02','13:55:00',1.84),('1444','2013-11-02','14:00:00',1.57),('1444','2013-11-02','14:05:00',1.37),('1444','2013-11-02','14:10:00',1.25),('1444','2013-11-02','14:15:00',1.19),('1444','2013-11-02','14:20:00',1.15),('1444','2013-11-02','14:25:00',1.11),('1444','2013-11-02','14:30:00',1.08),('1444','2013-11-02','14:35:00',1.04),('1444','2013-11-02','14:40:00',1.01),('1444','2013-11-01','09:10:00',1.02),('1444','2013-11-01','09:15:00',1.07),('1444','2013-11-01','09:20:00',1.1),('1444','2013-11-01','09:25:00',1.16),('1444','2013-11-01','09:30:00',1.21),('1444','2013-11-01','09:35:00',1.24),('1444','2013-11-01','09:40:00',1.27),('1444','2013-11-01','09:45:00',1.31),('1444','2013-11-01','09:50:00',1.35),('1444','2013-11-01','09:55:00',1.38),('1444','2013-11-01','10:00:00',1.42),('1444','2013-11-01','10:05:00',1.45),('1444','2013-11-01','10:10:00',1.48),('1444','2013-11-01','10:15:00',1.5),('1444','2013-11-01','10:20:00',1.54),('1444','2013-11-01','10:25:00',1.56),('1444','2013-11-01','10:30:00',1.53),('1444','2013-11-01','10:35:00',1.56),('1444','2013-11-01','10:40:00',1.58),('1444','2013-11-01','10:45:00',1.54),('1444','2013-11-01','10:50:00',1.56),('1444','2013-11-01','10:55:00',1.59),('1444','2013-11-01','11:00:00',1.62),('1444','2013-11-01','11:05:00',1.47),('1444','2013-11-01','11:10:00',1.31),('1444','2013-11-01','11:15:00',1.52),('1444','2013-11-01','11:20:00',1.74),('1444','2013-11-01','11:25:00',1.81),('1444','2013-11-01','11:30:00',1.82),('1444','2013-11-01','11:35:00',1.77),('1444','2013-11-01','11:40:00',1.53),('1444','2013-11-01','11:45:00',1.67),('1444','2013-11-01','11:50:00',1.83),('1444','2013-11-01','11:55:00',1.82),('1444','2013-11-01','12:00:00',1.79),('1444','2013-11-01','12:05:00',1.76),('1444','2013-11-01','12:10:00',1.6),('1444','2013-11-01','12:15:00',1.48),('1444','2013-11-01','12:20:00',1.49),('1444','2013-11-01','12:25:00',1.49),('1444','2013-10-31','09:30:00',1.05),('1444','2013-10-31','09:35:00',1.07),('1444','2013-10-31','09:45:00',1.02),('1444','2013-10-31','09:50:00',1.01),('1444','2013-10-31','09:55:00',1.08),('1444','2013-10-31','10:00:00',1.12),('1444','2013-10-31','10:05:00',1.03),('1444','2013-10-31','10:10:00',1),('1444','2013-10-31','10:30:00',1.04),('1444','2013-10-31','10:35:00',1.18),('1444','2013-10-31','10:40:00',1.16),('1444','2013-10-31','10:45:00',1.08),('1444','2013-10-31','10:50:00',1.12),('1444','2013-10-31','10:55:00',1.22),('1444','2013-10-31','11:00:00',1.48),('1444','2013-10-31','11:05:00',1.68),('1444','2013-10-31','11:10:00',1.65),('1444','2013-10-31','11:15:00',1.71),('1444','2013-10-31','11:20:00',1.59),('1444','2013-10-31','11:25:00',1.47),('1444','2013-10-31','11:30:00',1.61),('1444','2013-10-31','11:35:00',1.56),('1444','2013-10-31','11:40:00',1.74),('1444','2013-10-31','11:45:00',1.8),('1444','2013-10-31','11:50:00',1.77),('1444','2013-10-31','11:55:00',1.74),('1444','2013-10-31','12:00:00',1.71),('1444','2013-10-31','12:05:00',1.66),('1444','2013-10-31','12:10:00',1.73),('1444','2013-10-31','12:15:00',1.69),('1444','2013-10-31','12:20:00',1.69),('1444','2013-10-31','12:25:00',1.7),('1444','2013-10-31','12:30:00',1.64),('1444','2013-10-31','12:35:00',1.59),('1444','2013-10-31','12:40:00',1.63),('1444','2013-10-31','12:45:00',1.69),('1444','2013-10-31','12:50:00',1.72),('1444','2013-10-31','12:55:00',1.72),('1444','2013-10-31','13:00:00',1.69),('1444','2013-10-31','13:05:00',1.66),('1444','2013-10-31','13:10:00',1.59),('1444','2013-10-31','13:15:00',1.56),('1444','2013-10-31','13:20:00',1.54),('1444','2013-10-31','13:25:00',1.51),('1444','2013-10-31','13:30:00',1.46),('1444','2013-10-31','13:35:00',1.38),('1444','2013-10-31','13:40:00',1.29),('1444','2013-10-31','13:45:00',1.26),('1444','2013-10-31','13:55:00',1),('1444','2013-10-31','14:00:00',1.26),('1444','2013-10-31','14:05:00',1.23),('1444','2013-10-31','14:10:00',1.01),('1444','2013-10-30','09:10:00',1.04),('1444','2013-10-30','09:15:00',1.09),('1444','2013-10-30','09:20:00',1.13),('1444','2013-10-30','09:25:00',1.19),('1444','2013-10-30','09:30:00',1.22),('1444','2013-10-30','09:35:00',1.26),('1444','2013-10-30','09:40:00',1.28),('1444','2013-10-30','09:45:00',1.32),('1444','2013-10-30','09:50:00',1.34),('1444','2013-10-30','09:55:00',1.24),('1444','2013-10-30','10:00:00',1.15),('1444','2013-10-30','10:05:00',1.27),('1444','2013-10-30','10:10:00',1.51),('1444','2013-10-30','10:15:00',1.49),('1444','2013-10-30','10:20:00',1.45),('1444','2013-10-30','10:25:00',1.5),('1444','2013-10-30','10:30:00',1.5),('1444','2013-10-30','10:35:00',1.45),('1444','2013-10-30','10:40:00',1.44),('1444','2013-10-30','10:45:00',1.41),('1444','2013-10-30','10:55:00',1.46),('1444','2013-10-30','11:00:00',1.35),('1444','2013-10-30','11:05:00',1.75),('1444','2013-10-30','11:10:00',1.7),('1444','2013-10-30','11:15:00',1.4),('1444','2013-10-30','11:20:00',1.38),('1444','2013-10-30','12:15:00',1.54),('1444','2013-10-30','12:20:00',2.05),('1444','2013-10-30','12:25:00',1.3),('1444','2013-10-30','12:30:00',1.23),('1444','2013-10-30','12:50:00',1.04),('1444','2013-10-30','12:55:00',1.78),('1444','2013-10-30','13:00:00',1.76),('1444','2013-10-30','13:05:00',1.94),('1444','2013-10-30','13:10:00',1.84),('1444','2013-10-30','13:15:00',1.96),('1444','2013-10-30','13:20:00',1.89),('1444','2013-10-30','13:25:00',1.88),('1444','2013-10-30','13:35:00',1.69),('1444','2013-10-30','13:40:00',1.67),('1444','2013-10-30','13:45:00',1.41),('1444','2013-10-30','13:50:00',1.49),('1444','2013-10-30','13:55:00',1.63),('1444','2013-10-30','14:00:00',1.45),('1444','2013-10-30','14:40:00',1.02),('1444','2013-10-29','09:05:00',1.03),('1444','2013-10-29','09:10:00',1.07),('1444','2013-10-29','09:15:00',1.11),('1444','2013-10-29','09:20:00',1.18),('1444','2013-10-29','09:25:00',1.18),('1444','2013-10-29','09:30:00',1.25),('1444','2013-10-29','09:35:00',1.29),('1444','2013-10-29','09:45:00',1.06),('1444','2013-10-29','09:50:00',1.39),('1444','2013-10-29','09:55:00',1.48),('1444','2013-10-29','10:00:00',1.35),('1444','2013-10-29','10:05:00',1.59),('1444','2013-10-29','10:10:00',1.6),('1444','2013-10-29','10:15:00',1.69),('1444','2013-10-29','10:20:00',1.56),('1444','2013-10-29','10:25:00',1.24),('1444','2013-10-29','10:35:00',1.04),('1444','2013-10-29','10:55:00',1.94),('1444','2013-10-29','11:00:00',1.92),('1444','2013-10-29','11:05:00',1.98),('1444','2013-10-29','11:10:00',1.94),('1444','2013-10-29','11:15:00',1.83),('1444','2013-10-29','11:20:00',1.82),('1444','2013-10-29','11:25:00',1.82),('1444','2013-10-29','11:30:00',1.82),('1444','2013-10-29','11:35:00',1.82),('1444','2013-10-29','11:40:00',1.8),('1444','2013-10-29','11:45:00',1.78),('1444','2013-10-29','11:50:00',1.79),('1444','2013-10-29','11:55:00',1.76),('1444','2013-10-29','12:00:00',1.74),('1444','2013-10-29','12:05:00',1.76),('1444','2013-10-29','12:10:00',1.74),('1444','2013-10-29','12:15:00',1.76),('1444','2013-10-29','12:20:00',1.72),('1444','2013-10-29','12:25:00',1.69),('1444','2013-10-29','12:30:00',1.68),('1444','2013-10-29','12:35:00',1.71),('1444','2013-10-29','12:40:00',1.66),('1444','2013-10-29','12:45:00',1.62),('1444','2013-10-29','12:50:00',1.64),('1444','2013-10-29','12:55:00',1.64),('1444','2013-10-29','13:00:00',1.62),('1444','2013-10-29','13:05:00',1.6),('1444','2013-10-29','13:10:00',1.58),('1444','2013-10-29','13:15:00',1.5),('1444','2013-10-29','13:20:00',1.52),('1444','2013-10-29','13:25:00',1.53),('1444','2013-10-29','13:30:00',1.49),('1444','2013-10-29','13:35:00',1.39),('1444','2013-10-29','13:40:00',1.37),('1444','2013-10-29','13:45:00',1.34),('1444','2013-10-29','13:50:00',1.33),('1444','2013-10-29','13:55:00',1.31),('1444','2013-10-29','14:00:00',1.28),('1444','2013-10-29','14:05:00',1.23),('1444','2013-10-29','14:10:00',1.18),('1444','2013-10-29','14:15:00',1.13),('1444','2013-10-29','14:20:00',1.06),('1444','2013-10-29','14:25:00',1.05),('1444','2013-10-29','14:30:00',1.02),('1444','2014-04-17','08:10:00',1.05),('1444','2014-04-17','08:15:00',1.13),('1444','2014-04-17','08:20:00',1.16),('1444','2014-04-17','08:25:00',1.24),('1444','2014-04-17','08:30:00',1.31),('1444','2014-04-17','08:35:00',1.37),('1444','2014-04-17','08:40:00',1.45),('1444','2014-04-17','08:45:00',1.52),('1444','2014-04-17','08:50:00',1.6),('1444','2014-04-17','08:55:00',1.55),('1444','2014-04-17','09:00:00',1.4),('1444','2014-04-17','09:05:00',1.72),('1444','2014-04-17','09:10:00',1.85),('1444','2014-04-17','09:15:00',1.93),('1444','2014-04-17','09:20:00',2),('1444','2014-04-17','09:25:00',2.06),('1444','2014-04-17','09:30:00',2.13),('1444','2014-04-17','09:35:00',2.2),('1444','2014-04-17','09:40:00',2.27),('1444','2014-04-17','09:45:00',2.32),('1444','2014-04-17','09:50:00',2.37),('1444','2014-04-17','09:55:00',2.46),('1444','2014-04-17','10:00:00',2.57),('1444','2014-04-17','10:05:00',2.79),('1444','2014-04-17','10:10:00',2.7),('1444','2014-04-17','10:15:00',2.01),('1444','2014-04-17','10:20:00',2.82),('1444','2014-04-17','10:25:00',2.95),('1444','2014-04-17','10:30:00',3.15),('1444','2014-04-17','10:35:00',3.34),('1444','2014-04-17','10:40:00',3.12),('1444','2014-04-17','10:45:00',2.93),('1444','2014-04-17','10:50:00',2.15),('1444','2014-04-17','10:55:00',1.92),('1444','2014-04-17','11:00:00',2.17),('1444','2014-04-17','11:05:00',2.39),('1444','2014-04-17','11:10:00',2.44),('1444','2014-04-17','11:15:00',1.78),('1444','2014-04-17','11:20:00',2.19),('1444','2014-04-17','11:25:00',3.2),('1444','2014-04-17','11:30:00',2.03),('1444','2014-04-17','11:35:00',1.78),('1444','2014-04-17','11:40:00',1.8),('1444','2014-04-17','11:45:00',3.2),('1444','2014-04-17','11:50:00',2.59),('1444','2014-04-17','11:55:00',1.88),('1444','2014-04-17','12:00:00',2.32),('1444','2014-04-17','12:05:00',2.45),('1444','2014-04-17','12:10:00',2.04),('1444','2014-04-17','12:15:00',1.83),('1444','2014-04-17','12:20:00',1.96),('1444','2014-04-17','12:25:00',2.24),('1444','2014-04-17','12:30:00',2.6),('1444','2014-04-17','12:35:00',2.76),('1444','2014-04-17','12:40:00',3.35),('1444','2014-04-17','12:45:00',3.22),('1444','2014-04-17','12:50:00',2.54),('1444','2014-04-17','13:00:00',3.37),('1444','2014-04-17','13:05:00',3.63),('1444','2014-04-17','13:10:00',3.6),('1444','2014-04-17','13:15:00',3.68),('1444','2014-04-17','13:20:00',1.22),('1444','2014-04-17','13:25:00',3),('1444','2014-04-17','13:30:00',3.94),('1444','2014-04-17','13:35:00',2.22),('1444','2014-04-17','13:50:00',1.21),('1444','2014-04-17','13:55:00',1.87),('1444','2014-04-17','14:10:00',1.28),('1444','2014-04-17','14:15:00',3.06),('1444','2014-04-17','14:20:00',1.17),('1444','2014-04-17','14:25:00',1.36),('1444','2014-04-17','14:30:00',1.9),('1444','2014-04-17','14:35:00',1.74),('1444','2014-04-17','14:40:00',1.91),('1444','2014-04-17','14:45:00',1.46),('1444','2014-04-17','15:30:00',1.47),('1444','2014-04-17','15:35:00',2.02),('1444','2014-04-17','15:40:00',1.66),('1444','2014-04-17','15:45:00',1.15),('1444','2014-04-17','15:55:00',1.08),('1444','2014-04-17','16:45:00',1.52),('1444','2014-04-17','16:50:00',1.37),('1444','2013-10-28','09:00:00',1.04),('1444','2013-10-28','09:05:00',1.18),('1444','2013-10-28','09:10:00',1.28),('1444','2013-10-28','09:15:00',1.28),('1444','2013-10-28','09:20:00',1.32),('1444','2013-10-28','09:25:00',1.31),('1444','2013-10-28','09:30:00',1.33),('1444','2013-10-28','09:35:00',1.42),('1444','2013-10-28','09:40:00',1.57),('1444','2013-10-28','09:45:00',1.48),('1444','2013-10-28','09:50:00',1.78),('1444','2013-10-28','10:50:00',1.76),('1444','2013-10-28','10:55:00',1.74),('1444','2013-10-28','11:00:00',1.75),('1444','2013-10-28','11:05:00',1.76),('1444','2013-10-28','11:10:00',1.78),('1444','2013-10-28','11:15:00',1.79),('1444','2013-10-28','11:20:00',1.78),('1444','2013-10-28','11:25:00',1.78),('1444','2013-10-28','11:30:00',1.79),('1444','2013-10-28','11:35:00',1.8),('1444','2013-10-28','11:40:00',1.8),('1444','2013-10-28','11:45:00',1.8),('1444','2013-10-28','11:50:00',1.78),('1444','2013-10-28','11:55:00',1.55),('1444','2013-10-28','12:00:00',1.37),('1444','2013-10-28','12:05:00',1.5),('1444','2013-10-28','12:10:00',1.93),('1444','2013-10-28','12:15:00',1.89),('1444','2013-10-28','12:20:00',1.59),('1444','2013-10-28','12:25:00',1.04),('1444','2013-10-28','12:30:00',1.97),('1444','2013-10-28','12:35:00',2.1),('1444','2013-10-28','12:40:00',1.63),('1444','2013-10-28','12:45:00',1.92),('1444','2013-10-28','12:50:00',1.88),('1444','2013-10-28','12:55:00',1.76),('1444','2013-10-28','13:00:00',1.72),('1444','2013-10-28','13:05:00',1.69),('1444','2013-10-28','13:10:00',1.65),('1444','2013-10-28','13:15:00',1.65),('1444','2013-10-28','13:20:00',1.52),('1444','2013-10-28','13:25:00',1.56),('1444','2013-10-28','13:30:00',1.56),('1444','2013-10-28','13:35:00',1.54),('1444','2013-10-28','13:40:00',1.54),('1444','2013-10-28','13:45:00',1.5),('1444','2013-10-28','13:50:00',1.48),('1444','2013-10-28','13:55:00',1.47),('1444','2013-10-28','14:00:00',1.33),('1444','2013-10-28','14:05:00',1.51),('1444','2013-10-28','14:10:00',1.41),('1444','2013-10-28','14:15:00',1.31),('1444','2013-10-28','14:20:00',1.26),('1444','2013-10-28','14:25:00',1.06),('1444','2013-10-28','14:45:00',1.07),('1444','2013-10-27','11:35:00',1.07),('1444','2013-10-27','11:40:00',1.13),('1444','2013-10-27','11:45:00',1.23),('1444','2013-10-27','12:15:00',1.29),('1444','2013-10-27','12:20:00',1.72),('1444','2013-10-27','12:25:00',1.56),('1444','2013-10-27','12:30:00',1.64),('1444','2013-10-27','12:35:00',2.21),('1444','2013-10-27','12:40:00',1.14),('1444','2013-10-27','12:45:00',1.79),('1444','2013-10-27','12:50:00',2.07),('1444','2013-10-27','12:55:00',1.39),('1444','2013-10-27','13:00:00',1.06),('1444','2013-10-27','13:30:00',1.05),('1444','2013-10-27','14:30:00',1.26),('1444','2013-10-27','14:35:00',1.02),('1444','2013-10-26','10:00:00',1.04),('1444','2013-10-26','10:05:00',1.09),('1444','2013-10-26','10:10:00',1.13),('1444','2013-10-26','10:15:00',1.17),('1444','2013-10-26','10:20:00',1.19),('1444','2013-10-26','10:25:00',1.23),('1444','2013-10-26','10:30:00',1.28),('1444','2013-10-26','10:35:00',1.31),('1444','2013-10-26','10:40:00',1.35),('1444','2013-10-26','10:45:00',1.39),('1444','2013-10-26','10:50:00',1.44),('1444','2013-10-26','10:55:00',1.46),('1444','2013-10-26','11:00:00',1.5),('1444','2013-10-26','11:05:00',1.52),('1444','2013-10-26','11:10:00',1.53),('1444','2013-10-26','11:15:00',1.57),('1444','2013-10-26','11:20:00',1.59),('1444','2013-10-26','11:25:00',1.61),('1444','2013-10-26','11:30:00',1.64),('1444','2013-10-26','11:35:00',1.66),('1444','2013-10-26','11:40:00',1.67),('1444','2013-10-26','11:45:00',1.68),('1444','2013-10-26','11:50:00',1.7),('1444','2013-10-26','11:55:00',1.69),('1444','2013-10-26','12:00:00',1.68),('1444','2013-10-26','12:05:00',1.7),('1444','2013-10-26','12:10:00',1.74),('1444','2013-10-26','12:15:00',1.74),('1444','2013-10-26','12:20:00',1.77),('1444','2013-10-26','12:25:00',1.77),('1444','2013-10-26','12:30:00',1.79),('1444','2013-10-26','12:35:00',1.73),('1444','2013-10-26','12:40:00',1.75),('1444','2013-10-26','12:45:00',1.61),('1444','2013-10-26','12:50:00',1.75),('1444','2013-10-26','12:55:00',1.41),('1444','2013-10-26','13:00:00',1.73),('1444','2013-10-26','13:05:00',1.75),('1444','2013-10-26','13:10:00',1.79),('1444','2013-10-26','13:15:00',1.72),('1444','2013-10-26','13:20:00',1.74),('1444','2013-10-26','13:25:00',1.7),('1444','2013-10-26','13:30:00',1.72),('1444','2013-10-26','13:40:00',1.72),('1444','2013-10-26','13:45:00',1.59),('1444','2013-10-26','13:50:00',1.62),('1444','2013-10-26','13:55:00',1.59),('1444','2013-10-26','14:00:00',1.32),('1444','2013-10-26','14:05:00',1.24),('1444','2013-10-26','14:10:00',1.05),('1444','2013-10-26','14:20:00',1.44),('1444','2013-10-26','14:25:00',1.35),('1444','2013-10-26','14:30:00',1.19),('1444','2013-10-26','14:35:00',1.23),('1444','2013-10-26','14:40:00',1.05),('1444','2013-10-26','14:50:00',1),('1444','2013-10-26','14:55:00',1.33),('1444','2013-10-26','15:00:00',1.29),('1444','2013-10-26','15:05:00',1.23),('1444','2013-10-26','15:10:00',1.22),('1444','2013-10-26','15:15:00',1.16),('1444','2013-10-26','15:20:00',1.17),('1444','2013-10-26','15:25:00',1.2),('1444','2013-10-26','15:30:00',1.14),('1444','2013-10-26','15:35:00',1.1),('1444','2013-10-26','15:40:00',1),('1444','2013-10-25','10:00:00',1.06),('1444','2013-10-25','10:05:00',1.12),('1444','2013-10-25','10:10:00',1.16),('1444','2013-10-25','10:15:00',1.2),('1444','2013-10-25','10:20:00',1.24),('1444','2013-10-25','10:25:00',1.29),('1444','2013-10-25','10:30:00',1.33),('1444','2013-10-25','10:35:00',1.37),('1444','2013-10-25','10:40:00',1.4),('1444','2013-10-25','10:45:00',1.43),('1444','2013-10-25','10:50:00',1.44),('1444','2013-10-25','10:55:00',1.48),('1444','2013-10-25','11:00:00',1.51),('1444','2013-10-25','11:05:00',1.53),('1444','2013-10-25','11:10:00',1.56),('1444','2013-10-25','11:15:00',1.59),('1444','2013-10-25','11:20:00',1.59),('1444','2013-10-25','11:25:00',1.63),('1444','2013-10-25','11:30:00',1.67),('1444','2013-10-25','11:35:00',1.71),('1444','2013-10-25','11:40:00',1.73),('1444','2013-10-25','11:45:00',1.74),('1444','2013-10-25','11:50:00',1.76),('1444','2013-10-25','11:55:00',1.76),('1444','2013-10-25','12:00:00',1.79),('1444','2013-10-25','12:05:00',1.82),('1444','2013-10-25','12:10:00',1.83),('1444','2013-10-25','12:15:00',1.83),('1444','2013-10-25','12:20:00',1.83),('1444','2013-10-25','12:25:00',1.85),('1444','2013-10-25','12:30:00',1.84),('1444','2013-10-25','12:35:00',1.83),('1444','2013-10-25','12:40:00',1.85),('1444','2013-10-25','12:45:00',1.85),('1444','2013-10-25','12:50:00',1.84),('1444','2013-10-25','12:55:00',1.84),('1444','2013-10-25','13:00:00',1.84),('1444','2013-10-25','13:05:00',1.83),('1444','2013-10-25','13:10:00',1.83),('1444','2013-10-25','13:15:00',1.82),('1444','2013-10-25','13:20:00',1.82),('1444','2013-10-25','13:25:00',1.81),('1444','2013-10-25','13:30:00',1.79),('1444','2013-10-25','13:35:00',1.76),('1444','2013-10-25','13:40:00',1.73),('1444','2013-10-25','13:45:00',1.73),('1444','2013-10-25','13:50:00',1.72),('1444','2013-10-25','13:55:00',1.71),('1444','2013-10-25','14:00:00',1.68),('1444','2013-10-25','14:05:00',1.67),('1444','2013-10-25','14:10:00',1.64),('1444','2013-10-25','14:15:00',1.63),('1444','2013-10-25','14:20:00',1.62),('1444','2013-10-25','14:25:00',1.58),('1444','2013-10-25','14:30:00',1.56),('1444','2013-10-25','14:35:00',1.52),('1444','2013-10-25','14:40:00',1.49),('1444','2013-10-25','14:45:00',1.48),('1444','2013-10-25','14:50:00',1.44),('1444','2013-10-25','14:55:00',1.4),('1444','2013-10-25','15:00:00',1.35),('1444','2013-10-25','15:05:00',1.34),('1444','2013-10-25','15:10:00',1.3),('1444','2013-10-25','15:15:00',1.24),('1444','2013-10-25','15:20:00',1.2),('1444','2013-10-25','15:25:00',1.17),('1444','2013-10-25','15:30:00',1.12),('1444','2013-10-25','15:35:00',1.07),('1444','2013-10-25','15:40:00',1.07),('1444','2013-10-25','15:45:00',1.02),('1444','2013-10-24','10:35:00',1.07),('1444','2013-10-24','10:45:00',1.22),('1444','2013-10-24','10:50:00',1.01),('1444','2013-10-24','10:55:00',1.27),('1444','2013-10-24','11:00:00',1.83),('1444','2013-10-24','11:05:00',1.87),('1444','2013-10-24','11:10:00',1.39),('1444','2013-10-24','11:15:00',1.23),('1444','2013-10-24','11:20:00',1.22),('1444','2013-10-24','11:50:00',1.07),('1444','2013-10-24','11:55:00',1.46),('1444','2013-10-24','12:00:00',1.18),('1444','2013-10-24','12:25:00',1.03),('1444','2013-10-24','12:30:00',1.09),('1444','2013-10-24','12:35:00',1.19),('1444','2013-10-24','12:40:00',1.41),('1444','2013-10-24','12:45:00',1.58),('1444','2013-10-24','12:50:00',1.35),('1444','2013-10-24','12:55:00',2.13),('1444','2013-10-24','13:00:00',2.31),('1444','2013-10-24','13:05:00',1.93),('1444','2013-10-24','13:10:00',1.59),('1444','2013-10-24','13:15:00',1.61),('1444','2013-10-24','13:20:00',1.43),('1444','2013-10-24','13:25:00',1.09),('1444','2013-10-24','13:45:00',1.06),('1444','2013-10-24','13:50:00',1.27),('1444','2013-10-24','13:55:00',1.61),('1444','2013-10-24','14:00:00',1.54),('1444','2013-10-24','14:25:00',1),('1444','2013-10-24','14:30:00',1.04),('1444','2013-10-24','14:35:00',1.12),('1444','2013-10-24','14:40:00',1.29),('1444','2013-10-24','14:45:00',1.5),('1444','2013-10-24','15:10:00',1.14),('1444','2013-10-24','15:35:00',1.42),('1444','2013-10-24','15:40:00',1.1),('1444','2013-10-24','15:45:00',1.25),('1444','2013-10-23','10:50:00',1.04),('1444','2013-10-23','10:55:00',1.05),('1444','2013-10-23','11:00:00',1.3),('1444','2013-10-23','11:05:00',1.66),('1444','2013-10-23','11:10:00',1.76),('1444','2013-10-23','11:15:00',1.25),('1444','2013-10-23','11:20:00',1.53),('1444','2013-10-23','11:25:00',1.49),('1444','2013-10-23','11:30:00',1.56),('1444','2013-10-23','11:35:00',1.68),('1444','2013-10-23','11:40:00',1.72),('1444','2013-10-23','11:45:00',1.68),('1444','2013-10-23','11:50:00',1.62),('1444','2013-10-23','11:55:00',1.55),('1444','2013-10-23','12:00:00',1.73),('1444','2013-10-23','12:05:00',1.59),('1444','2013-10-23','12:10:00',1.64),('1444','2013-10-23','12:15:00',1.67),('1444','2013-10-23','12:20:00',1.75),('1444','2013-10-23','12:25:00',1.72),('1444','2013-10-23','12:30:00',1.69),('1444','2013-10-23','12:35:00',1.81),('1444','2013-10-23','12:40:00',1.76),('1444','2013-10-23','12:45:00',1.61),('1444','2013-10-23','12:50:00',1.57),('1444','2013-10-23','12:55:00',1.61),('1444','2013-10-23','13:00:00',1.67),('1444','2013-10-23','13:05:00',1.69),('1444','2013-10-23','13:10:00',1.67),('1444','2013-10-23','13:15:00',1.6),('1444','2013-10-23','13:20:00',1.69),('1444','2013-10-23','13:25:00',1.69),('1444','2013-10-23','13:30:00',1.62),('1444','2013-10-23','13:35:00',1.65),('1444','2013-10-23','13:40:00',1.66),('1444','2013-10-23','13:45:00',1.69),('1444','2013-10-23','13:50:00',1.58),('1444','2013-10-23','13:55:00',1.42),('1444','2013-10-23','14:00:00',1.62),('1444','2013-10-23','14:05:00',1.68),('1444','2013-10-23','14:10:00',1.58),('1444','2013-10-23','14:15:00',1.41),('1444','2013-10-23','14:20:00',1.47),('1444','2013-10-23','14:25:00',1.43),('1444','2013-10-23','14:30:00',1.44),('1444','2013-10-23','14:35:00',1.39),('1444','2013-10-23','14:40:00',1.41),('1444','2013-10-23','14:45:00',1.43),('1444','2013-10-23','14:50:00',1.42),('1444','2013-10-23','14:55:00',1.46),('1444','2013-10-23','15:00:00',1.43),('1444','2013-10-23','15:05:00',1.38),('1444','2013-10-23','15:10:00',1.3),('1444','2013-10-23','15:15:00',1.25),('1444','2013-10-23','15:20:00',1.25),('1444','2013-10-23','15:25:00',1.23),('1444','2013-10-23','15:30:00',1.08),('1444','2013-10-23','15:35:00',1.01),('1444','2013-10-23','15:40:00',1.14),('1444','2013-10-23','15:45:00',1.14),('1444','2013-10-23','15:50:00',1.04),('1444','2013-10-22','09:50:00',1.01),('1444','2013-10-22','09:55:00',1.06),('1444','2013-10-22','10:00:00',1.1),('1444','2013-10-22','10:05:00',1.13),('1444','2013-10-22','10:10:00',1.18),('1444','2013-10-22','10:15:00',1.22),('1444','2013-10-22','10:20:00',1.27),('1444','2013-10-22','10:25:00',1.29),('1444','2013-10-22','10:30:00',1.33),('1444','2013-10-22','10:35:00',1.37),('1444','2013-10-22','10:40:00',1.4),('1444','2013-10-22','10:45:00',1.42),('1444','2013-10-22','10:50:00',1.45),('1444','2013-10-22','10:55:00',1.5),('1444','2013-10-22','11:00:00',1.54),('1444','2013-10-22','11:05:00',1.56),('1444','2013-10-22','11:10:00',1.56),('1444','2013-10-22','11:15:00',1.58),('1444','2013-10-22','11:20:00',1.61),('1444','2013-10-22','11:25:00',1.62),('1444','2013-10-22','11:30:00',1.61),('1444','2013-10-22','11:35:00',1.62),('1444','2013-10-22','11:40:00',1.66),('1444','2013-10-22','11:45:00',1.67),('1444','2013-10-22','11:50:00',1.68),('1444','2013-10-22','11:55:00',1.7),('1444','2013-10-22','12:00:00',1.73),('1444','2013-10-22','12:05:00',1.75),('1444','2013-10-22','12:10:00',1.74),('1444','2013-10-22','12:15:00',1.77),('1444','2013-10-22','12:20:00',1.78),('1444','2013-10-22','12:25:00',1.78),('1444','2013-10-22','12:30:00',1.79),('1444','2013-10-22','12:35:00',1.8),('1444','2013-10-22','12:40:00',1.81),('1444','2013-10-22','12:45:00',1.8),('1444','2013-10-22','12:50:00',1.79),('1444','2013-10-22','12:55:00',1.78),('1444','2013-10-22','13:00:00',1.75),('1444','2013-10-22','13:05:00',1.73),('1444','2013-10-22','13:10:00',1.78),('1444','2013-10-22','13:15:00',1.78),('1444','2013-10-22','13:20:00',1.76),('1444','2013-10-22','13:25:00',1.77),('1444','2013-10-22','13:30:00',1.72),('1444','2013-10-22','13:35:00',1.71),('1444','2013-10-22','13:40:00',1.67),('1444','2013-10-22','13:45:00',1.55),('1444','2013-10-22','13:50:00',1.7),('1444','2013-10-22','13:55:00',1.74),('1444','2013-10-22','14:00:00',1.56),('1444','2013-10-22','14:05:00',1.59),('1444','2013-10-22','14:10:00',1.67),('1444','2013-10-22','14:15:00',1.79),('1444','2013-10-22','14:20:00',1.84),('1444','2013-10-22','14:25:00',1.87),('1444','2013-10-22','14:30:00',1.73),('1444','2013-10-22','14:35:00',1.76),('1444','2013-10-22','14:40:00',1.65),('1444','2013-10-22','14:45:00',1.58),('1444','2013-10-22','14:50:00',1.45),('1444','2013-10-22','14:55:00',1.43),('1444','2013-10-22','15:00:00',1.38),('1444','2013-10-22','15:05:00',1.3),('1444','2013-10-22','15:10:00',1.29),('1444','2013-10-22','15:15:00',1.26),('1444','2013-10-22','15:20:00',1.22),('1444','2013-10-22','15:25:00',1.12),('1444','2013-10-22','15:30:00',1.15),('1444','2013-10-22','15:35:00',1.15),('1444','2013-10-22','15:40:00',1.15),('1444','2013-10-22','15:45:00',1.03),('1444','2013-10-21','09:55:00',1.08),('1444','2013-10-21','10:00:00',1.05),('1444','2013-10-21','10:05:00',1.23),('1444','2013-10-21','10:10:00',1.23),('1444','2013-10-21','10:15:00',1.29),('1444','2013-10-21','10:20:00',1.3),('1444','2013-10-21','10:25:00',1.38),('1444','2013-10-21','10:30:00',1.36),('1444','2013-10-21','10:35:00',1.37),('1444','2013-10-21','10:40:00',1.35),('1444','2013-10-21','10:45:00',1.39),('1444','2013-10-21','10:50:00',1.49),('1444','2013-10-21','10:55:00',1.47),('1444','2013-10-21','11:00:00',1.62),('1444','2013-10-21','11:05:00',1.39),('1444','2013-10-21','11:10:00',1.52),('1444','2013-10-21','11:15:00',1.69),('1444','2013-10-21','11:20:00',1.67),('1444','2013-10-21','11:25:00',1.65),('1444','2013-10-21','11:30:00',1.73),('1444','2013-10-21','11:35:00',1.68),('1444','2013-10-21','11:40:00',1.71),('1444','2013-10-21','11:45:00',1.78),('1444','2013-10-21','11:50:00',1.81),('1444','2013-10-21','11:55:00',1.81),('1444','2013-10-21','12:00:00',1.85),('1444','2013-10-21','12:05:00',1.89),('1444','2013-10-21','12:10:00',1.9),('1444','2013-10-21','12:15:00',1.88),('1444','2013-10-21','12:20:00',1.89),('1444','2013-10-21','12:25:00',1.86),('1444','2013-10-21','12:30:00',1.85),('1444','2013-10-21','12:35:00',1.91),('1444','2013-10-21','12:40:00',1.92),('1444','2013-10-21','12:45:00',1.91),('1444','2013-10-21','12:50:00',1.91),('1444','2013-10-21','12:55:00',1.9),('1444','2013-10-21','13:00:00',1.88),('1444','2013-10-21','13:05:00',1.83),('1444','2013-10-21','13:10:00',1.83),('1444','2013-10-21','13:15:00',1.85),('1444','2013-10-21','13:20:00',1.82),('1444','2013-10-21','13:25:00',1.88),('1444','2013-10-21','13:30:00',1.86),('1444','2013-10-21','13:35:00',1.85),('1444','2013-10-21','13:40:00',1.83),('1444','2013-10-21','13:45:00',1.81),('1444','2013-10-21','13:50:00',1.74),('1444','2013-10-21','13:55:00',1.71),('1444','2013-10-21','14:00:00',1.72),('1444','2013-10-21','14:05:00',1.73),('1444','2013-10-21','14:10:00',1.69),('1444','2013-10-21','14:15:00',1.69),('1444','2013-10-21','14:20:00',1.69),('1444','2013-10-21','14:25:00',1.61),('1444','2013-10-21','14:30:00',1.58),('1444','2013-10-21','14:35:00',1.51),('1444','2013-10-21','14:40:00',1.46),('1444','2013-10-21','14:45:00',1.44),('1444','2013-10-21','14:50:00',1.39),('1444','2013-10-21','14:55:00',1.4),('1444','2013-10-21','15:00:00',1.4),('1444','2013-10-21','15:05:00',1.38),('1444','2013-10-21','15:10:00',1.35),('1444','2013-10-21','15:15:00',1.32),('1444','2013-10-21','15:20:00',1.28),('1444','2013-10-21','15:25:00',1.24),('1444','2013-10-21','15:30:00',1.19),('1444','2013-10-21','15:35:00',1.14),('1444','2013-10-21','15:40:00',1.11),('1444','2013-10-21','15:45:00',1.07),('1444','2013-10-21','15:50:00',1.04),('1444','2013-10-20','09:45:00',1.05),('1444','2013-10-20','09:50:00',1.09),('1444','2013-10-20','09:55:00',1.14),('1444','2013-10-20','10:00:00',1.19),('1444','2013-10-20','10:05:00',1.24),('1444','2013-10-20','10:10:00',1.27),('1444','2013-10-20','10:15:00',1.31),('1444','2013-10-20','10:20:00',1.35),('1444','2013-10-20','10:25:00',1.4),('1444','2013-10-20','10:30:00',1.44),('1444','2013-10-20','10:35:00',1.47),('1444','2013-10-20','10:40:00',1.5),('1444','2013-10-20','10:45:00',1.54),('1444','2013-10-20','10:50:00',1.57),('1444','2013-10-20','10:55:00',1.61),('1444','2013-10-20','11:00:00',1.63),('1444','2013-10-20','11:05:00',1.67),('1444','2013-10-20','11:10:00',1.69),('1444','2013-10-20','11:15:00',1.72),('1444','2013-10-20','11:20:00',1.76),('1444','2013-10-20','11:25:00',1.78),('1444','2013-10-20','11:30:00',1.79),('1444','2013-10-20','11:35:00',1.82),('1444','2013-10-20','11:40:00',1.83),('1444','2013-10-20','11:45:00',1.84),('1444','2013-10-20','11:50:00',1.86),('1444','2013-10-20','11:55:00',1.8),('1444','2013-10-20','12:00:00',1.86),('1444','2013-10-20','12:05:00',1.91),('1444','2013-10-20','12:10:00',1.66),('1444','2013-10-20','12:15:00',1.82),('1444','2013-10-20','12:20:00',1.23),('1444','2013-10-20','12:25:00',2.18),('1444','2013-10-20','12:30:00',1.78),('1444','2013-10-20','12:35:00',1.34),('1444','2013-10-20','12:40:00',1.86),('1444','2013-10-20','12:45:00',1.82),('1444','2013-10-20','12:50:00',1.39),('1444','2013-10-20','12:55:00',1.54),('1444','2013-10-20','13:00:00',1.45),('1444','2013-10-20','13:05:00',1.09),('1444','2013-10-20','13:10:00',1.25),('1444','2013-10-20','13:20:00',1.8),('1444','2013-10-20','13:25:00',1.07),('1444','2013-10-20','13:55:00',1.19),('1444','2013-10-19','09:30:00',1.04),('1444','2013-10-19','09:35:00',1.1),('1444','2013-10-19','09:40:00',1.18),('1444','2013-10-19','09:45:00',1.23),('1444','2013-10-19','09:50:00',1.29),('1444','2013-10-19','09:55:00',1.36),('1444','2013-10-19','10:00:00',1.31),('1444','2013-10-19','10:05:00',1.26),('1444','2013-10-19','10:10:00',1.4),('1444','2013-10-19','10:15:00',1.34),('1444','2013-10-19','10:20:00',1.43),('1444','2013-10-19','10:25:00',1.62),('1444','2013-10-19','10:30:00',1.67),('1444','2013-10-19','10:35:00',1.67),('1444','2013-10-19','10:40:00',1.69),('1444','2013-10-19','10:45:00',1.68),('1444','2013-10-19','10:50:00',1.74),('1444','2013-10-19','10:55:00',1.59),('1444','2013-10-19','11:00:00',1.68),('1444','2013-10-19','11:05:00',1.75),('1444','2013-10-19','11:20:00',1.91),('1444','2013-10-19','11:25:00',1.8),('1444','2013-10-19','11:30:00',2.06),('1444','2013-10-19','11:35:00',2),('1444','2013-10-19','11:40:00',1.96),('1444','2013-10-19','11:45:00',2.04),('1444','2013-10-19','11:50:00',1.84),('1444','2013-10-19','11:55:00',2.09),('1444','2013-10-19','12:00:00',2.1),('1444','2013-10-19','12:05:00',2.11),('1444','2013-10-19','12:10:00',2.07),('1444','2013-10-19','12:15:00',2.1),('1444','2013-10-19','12:20:00',2.03),('1444','2013-10-19','12:25:00',2),('1444','2013-10-19','12:30:00',2.12),('1444','2013-10-19','12:35:00',2.14),('1444','2013-10-19','12:40:00',2.21),('1444','2013-10-19','12:45:00',2.27),('1444','2013-10-19','12:50:00',2.27),('1444','2013-10-19','12:55:00',2.37),('1444','2013-10-19','13:00:00',2.57),('1444','2013-10-19','13:05:00',2.07),('1444','2013-10-19','13:10:00',2.17),('1444','2013-10-19','13:15:00',2.05),('1444','2013-10-19','13:20:00',1.97),('1444','2013-10-19','13:25:00',2.2),('1444','2013-10-19','13:30:00',2.32),('1444','2013-10-19','13:35:00',1.55),('1444','2013-10-19','13:40:00',1.54),('1444','2013-10-19','13:45:00',1.27),('1444','2013-10-19','13:50:00',1.79),('1444','2013-10-19','13:55:00',2.15),('1444','2013-10-19','14:00:00',1.8),('1444','2013-10-19','14:05:00',1.55),('1444','2013-10-19','14:10:00',1.17),('1444','2013-10-19','14:15:00',1.67),('1444','2013-10-19','14:20:00',1.35),('1444','2013-10-19','14:25:00',1.07),('1444','2013-10-19','14:30:00',1.42),('1444','2013-10-19','14:35:00',1.8),('1444','2013-10-19','14:40:00',1.52),('1444','2013-10-19','14:45:00',1.36),('1444','2013-10-19','14:50:00',1.86),('1444','2013-10-19','14:55:00',1.77),('1444','2013-10-19','15:00:00',1.71),('1444','2013-10-19','15:05:00',1.65),('1444','2013-10-19','15:10:00',1.61),('1444','2013-10-19','15:15:00',1.57),('1444','2013-10-19','15:20:00',1.43),('1444','2013-10-19','15:25:00',1.38),('1444','2013-10-19','15:30:00',1.31),('1444','2013-10-19','15:35:00',1.32),('1444','2013-10-19','15:40:00',1.21),('1444','2013-10-19','15:45:00',1.05),('1444','2013-10-19','15:50:00',1.13),('1444','2013-10-19','15:55:00',1.21),('1444','2013-10-19','16:05:00',1.06),('1444','2013-10-19','16:15:00',1.04),('1444','2014-05-04','07:45:00',1),('1444','2014-05-04','07:50:00',1.06),('1444','2014-05-04','07:55:00',1.11),('1444','2014-05-04','08:00:00',1.18),('1444','2014-05-04','08:05:00',1.27),('1444','2014-05-04','08:10:00',1.31),('1444','2014-05-04','08:15:00',1.39),('1444','2014-05-04','08:20:00',1.47),('1444','2014-05-04','08:25:00',1.56),('1444','2014-05-04','08:30:00',1.59),('1444','2014-05-04','08:35:00',1.8),('1444','2014-05-04','08:40:00',1.12),('1444','2014-05-04','08:45:00',1.28),('1444','2014-05-04','08:50:00',1.32),('1444','2014-05-04','09:00:00',1.04),('1444','2014-05-04','09:05:00',1.54),('1444','2014-05-04','09:10:00',1.82),('1444','2014-05-04','09:15:00',1.47),('1444','2014-05-04','09:20:00',2.59),('1444','2014-05-04','09:25:00',2.87),('1444','2014-05-04','09:30:00',1.81),('1444','2014-05-04','09:35:00',1.05),('1444','2014-05-04','09:40:00',1.11),('1444','2014-05-04','09:45:00',1.41),('1444','2014-05-04','09:50:00',1.75),('1444','2014-05-04','09:55:00',1.57),('1444','2014-05-04','10:00:00',2.58),('1444','2014-05-04','10:05:00',3.11),('1444','2014-05-04','10:10:00',2.97),('1444','2014-05-04','10:15:00',2.23),('1444','2014-05-04','10:20:00',1.61),('1444','2014-05-04','10:25:00',1.63),('1444','2014-05-04','10:30:00',1.79),('1444','2014-05-04','10:35:00',1.83),('1444','2014-05-04','10:40:00',1.8),('1444','2014-05-04','10:45:00',2.02),('1444','2014-05-04','10:50:00',2.01),('1444','2014-05-04','10:55:00',1.98),('1444','2014-05-04','11:00:00',1.9),('1444','2014-05-04','11:05:00',1.95),('1444','2014-05-04','11:10:00',3.37),('1444','2014-05-04','11:15:00',3.11),('1444','2014-05-04','11:20:00',3.58),('1444','2014-05-04','11:25:00',3.49),('1444','2014-05-04','11:30:00',3.1),('1444','2014-05-04','11:35:00',3.37),('1444','2014-05-04','11:40:00',2.63),('1444','2014-05-04','11:45:00',2.96),('1444','2014-05-04','11:50:00',2.37),('1444','2014-05-04','11:55:00',3.35),('1444','2014-05-04','12:00:00',2.42),('1444','2014-05-04','12:05:00',2.16),('1444','2014-05-04','12:10:00',1.5),('1444','2014-05-04','12:15:00',1.36),('1444','2014-05-04','12:20:00',1.28),('1444','2014-05-04','12:25:00',1.34),('1444','2014-05-04','12:30:00',1.74),('1444','2014-05-04','12:35:00',4.18),('1444','2014-05-04','12:40:00',1.82),('1444','2014-05-04','12:45:00',1.36),('1444','2014-05-04','12:50:00',1.27),('1444','2014-05-04','12:55:00',1.45),('1444','2014-05-04','13:00:00',1.51),('1444','2014-05-04','13:05:00',1.29),('1444','2014-05-04','13:10:00',1.29),('1444','2014-05-04','13:15:00',1.32),('1444','2014-05-04','13:20:00',1.26),('1444','2014-05-04','13:25:00',1.23),('1444','2014-05-04','13:30:00',1.17),('1444','2014-05-04','13:35:00',1.32),('1444','2014-05-04','13:40:00',1.31),('1444','2014-05-04','13:45:00',1.15),('1444','2014-05-04','13:50:00',1.06),('1444','2014-05-04','13:55:00',1.11),('1444','2014-05-04','14:00:00',1.11),('1444','2014-05-04','14:05:00',1.12),('1444','2014-05-04','14:10:00',1.11),('1444','2014-05-04','14:15:00',1.05),('1444','2014-05-04','14:55:00',1.33),('1444','2014-05-04','15:00:00',1.54),('1444','2014-05-04','15:05:00',1.75),('1444','2014-05-04','15:10:00',2.75),('1444','2014-05-04','15:15:00',2.22),('1444','2014-05-04','15:20:00',1.84),('1444','2014-05-04','15:25:00',1.34),('1444','2014-05-04','15:30:00',1.13),('1444','2014-05-04','16:10:00',1.06),('1444','2014-05-04','16:15:00',1.01),('1444','2014-04-16','08:10:00',1.01),('1444','2014-04-16','08:15:00',1.1),('1444','2014-04-16','08:20:00',1.17),('1444','2014-04-16','08:25:00',1.22),('1444','2014-04-16','08:45:00',1.34),('1444','2014-04-16','08:50:00',1.45),('1444','2014-04-16','08:55:00',1.67),('1444','2014-04-16','09:00:00',1.73),('1444','2014-04-16','09:05:00',1.79),('1444','2014-04-16','09:10:00',1.85),('1444','2014-04-16','09:15:00',1.9),('1444','2014-04-16','09:20:00',1.97),('1444','2014-04-16','09:25:00',2.08),('1444','2014-04-16','09:30:00',1.36),('1444','2014-04-16','09:35:00',1.02),('1444','2014-04-16','09:55:00',2.32),('1444','2014-04-16','10:00:00',2.55),('1444','2014-04-16','10:05:00',2.58),('1444','2014-04-16','10:10:00',2.64),('1444','2014-04-16','10:15:00',2.7),('1444','2014-04-16','10:20:00',2.76),('1444','2014-04-16','10:25:00',2.8),('1444','2014-04-16','10:30:00',2.85),('1444','2014-04-16','10:35:00',2.89),('1444','2014-04-16','10:40:00',2.94),('1444','2014-04-16','10:45:00',3),('1444','2014-04-16','10:50:00',3.11),('1444','2014-04-16','10:55:00',2.8),('1444','2014-04-16','11:00:00',2.88),('1444','2014-04-16','11:05:00',1.63),('1444','2014-04-16','11:10:00',1.3),('1444','2014-04-16','11:15:00',1.46),('1444','2014-04-16','11:20:00',2.68),('1444','2014-04-16','11:25:00',3.07),('1444','2014-04-16','11:30:00',3.21),('1444','2014-04-16','11:35:00',2.34),('1444','2014-04-16','11:40:00',2.57),('1444','2014-04-16','11:45:00',3.4),('1444','2014-04-16','11:50:00',3.83),('1444','2014-04-16','11:55:00',3.8),('1444','2014-04-16','12:00:00',3.75),('1444','2014-04-16','12:05:00',3.03),('1444','2014-04-16','12:10:00',3.09),('1444','2014-04-16','12:15:00',3.42),('1444','2014-04-16','12:20:00',2.26),('1444','2014-04-16','12:35:00',3.66),('1444','2014-04-16','12:40:00',3.65),('1444','2014-04-16','12:45:00',3.64),('1444','2014-04-16','12:50:00',3.39),('1444','2014-04-16','13:00:00',1.88),('1444','2014-04-16','13:05:00',1.1),('1444','2014-04-16','13:20:00',1.14),('1444','2014-04-16','13:35:00',1.22),('1444','2014-04-16','13:40:00',2.18),('1444','2014-04-16','13:45:00',3.89),('1444','2014-04-16','13:50:00',3.41),('1444','2014-04-16','13:55:00',3.73),('1444','2014-04-16','14:00:00',1.42),('1444','2014-04-16','14:05:00',2.65),('1444','2014-04-16','14:10:00',3.4),('1444','2014-04-16','14:15:00',3.96),('1444','2014-04-16','14:20:00',2.94),('1444','2014-04-16','14:25:00',3.32),('1444','2014-04-16','14:30:00',3.59),('1444','2014-04-16','14:35:00',3.37),('1444','2014-04-16','14:40:00',3.33),('1444','2014-04-16','14:45:00',3.51),('1444','2014-04-16','14:50:00',3.58),('1444','2014-04-16','14:55:00',1.72),('1444','2014-04-16','15:05:00',2.11),('1444','2014-04-16','15:10:00',3.65),('1444','2014-04-16','15:15:00',2.67),('1444','2014-04-16','15:30:00',1.79),('1444','2014-04-16','15:35:00',3.18),('1444','2014-04-16','15:40:00',3.07),('1444','2014-04-16','15:45:00',2.93),('1444','2014-04-16','15:50:00',2.84),('1444','2014-04-16','15:55:00',2.74),('1444','2014-04-16','16:00:00',2.67),('1444','2014-04-16','16:05:00',2.59),('1444','2014-04-16','16:10:00',2.52),('1444','2014-04-16','16:15:00',2.47),('1444','2014-04-16','16:20:00',2.47),('1444','2014-04-16','16:25:00',2.36),('1444','2014-04-16','16:30:00',2.31),('1444','2014-04-16','16:35:00',2.24),('1444','2014-04-16','16:40:00',2.19),('1444','2014-04-16','16:45:00',2.12),('1444','2014-04-16','16:50:00',2.05),('1444','2014-04-16','16:55:00',1.99),('1444','2014-04-16','17:00:00',1.92),('1444','2014-04-16','17:05:00',1.85),('1444','2014-04-16','17:10:00',1.78),('1444','2014-04-16','17:15:00',1.73),('1444','2014-04-16','17:20:00',1.64),('1444','2014-04-16','17:25:00',1.56),('1444','2014-04-16','17:30:00',1.5),('1444','2014-04-16','17:35:00',1.45),('1444','2014-04-16','17:40:00',1.37),('1444','2014-04-16','17:45:00',1.32),('1444','2014-04-16','17:50:00',1.32),('1444','2014-04-16','17:55:00',1.33),('1444','2014-04-16','18:00:00',1.19),('1444','2014-04-16','18:05:00',1.13),('1444','2014-04-16','18:10:00',1.03),('1444','2013-10-18','09:35:00',1.07),('1444','2013-10-18','09:40:00',1.15),('1444','2013-10-18','09:45:00',1.2),('1444','2013-10-18','09:50:00',1.25),('1444','2013-10-18','09:55:00',1.3),('1444','2013-10-18','10:00:00',1.34),('1444','2013-10-18','10:05:00',1.4),('1444','2013-10-18','10:10:00',1.44),('1444','2013-10-18','10:15:00',1.47),('1444','2013-10-18','10:20:00',1.49),('1444','2013-10-18','10:25:00',1.55),('1444','2013-10-18','10:30:00',1.6),('1444','2013-10-18','10:35:00',1.65),('1444','2013-10-18','10:40:00',1.67),('1444','2013-10-18','10:45:00',1.69),('1444','2013-10-18','10:50:00',1.72),('1444','2013-10-18','10:55:00',1.74),('1444','2013-10-18','11:00:00',1.76),('1444','2013-10-18','11:05:00',1.68),('1444','2013-10-18','11:10:00',1.78),('1444','2013-10-18','11:15:00',1.79),('1444','2013-10-18','11:20:00',1.92),('1444','2013-10-18','11:25:00',1.91),('1444','2013-10-18','11:30:00',1.9),('1444','2013-10-18','11:35:00',1.95),('1444','2013-10-18','11:40:00',2.02),('1444','2013-10-18','11:45:00',1.93),('1444','2013-10-18','11:50:00',1.95),('1444','2013-10-18','11:55:00',2.06),('1444','2013-10-18','12:00:00',2.03),('1444','2013-10-18','12:05:00',2.02),('1444','2013-10-18','12:10:00',2.04),('1444','2013-10-18','12:15:00',2.02),('1444','2013-10-18','12:20:00',1.99),('1444','2013-10-18','12:25:00',2.02),('1444','2013-10-18','12:30:00',2.04),('1444','2013-10-18','12:35:00',2.01),('1444','2013-10-18','12:40:00',2.02),('1444','2013-10-18','12:45:00',2),('1444','2013-10-18','12:50:00',1.97),('1444','2013-10-18','12:55:00',2.04),('1444','2013-10-18','13:00:00',2.01),('1444','2013-10-18','13:05:00',1.99),('1444','2013-10-18','13:10:00',1.89),('1444','2013-10-18','13:15:00',1.91),('1444','2013-10-18','13:20:00',2.02),('1444','2013-10-18','13:25:00',2.02),('1444','2013-10-18','13:30:00',2.04),('1444','2013-10-18','13:35:00',2.01),('1444','2013-10-18','13:40:00',1.97),('1444','2013-10-18','13:45:00',1.94),('1444','2013-10-18','13:50:00',1.94),('1444','2013-10-18','13:55:00',1.94),('1444','2013-10-18','14:00:00',1.8),('1444','2013-10-18','14:05:00',1.78),('1444','2013-10-18','14:10:00',1.77),('1444','2013-10-18','14:15:00',1.79),('1444','2013-10-18','14:20:00',1.78),('1444','2013-10-18','14:25:00',1.76),('1444','2013-10-18','14:30:00',1.74),('1444','2013-10-18','14:35:00',1.67),('1444','2013-10-18','14:40:00',1.67),('1444','2013-10-18','14:45:00',1.58),('1444','2013-10-18','14:50:00',1.57),('1444','2013-10-18','14:55:00',1.59),('1444','2013-10-18','15:00:00',1.33),('1444','2013-10-18','15:05:00',1.26),('1444','2013-10-18','15:10:00',1.39),('1444','2013-10-18','15:15:00',1.37),('1444','2013-10-18','15:20:00',1.43),('1444','2013-10-18','15:25:00',1.33),('1444','2013-10-18','15:30:00',1.25),('1444','2013-10-18','15:35:00',1.25),('1444','2013-10-18','15:40:00',1.17),('1444','2013-10-18','15:45:00',1.08),('1444','2013-10-18','15:50:00',1.01),('1444','2013-10-18','16:00:00',1.01),('1444','2013-10-17','09:30:00',1.03),('1444','2013-10-17','09:35:00',1.09),('1444','2013-10-17','09:40:00',1.15),('1444','2013-10-17','09:45:00',1.21),('1444','2013-10-17','09:50:00',1.26),('1444','2013-10-17','09:55:00',1.3),('1444','2013-10-17','10:00:00',1.34),('1444','2013-10-17','10:05:00',1.38),('1444','2013-10-17','10:10:00',1.43),('1444','2013-10-17','10:15:00',1.47),('1444','2013-10-17','10:20:00',1.52),('1444','2013-10-17','10:25:00',1.56),('1444','2013-10-17','10:30:00',1.59),('1444','2013-10-17','10:35:00',1.64),('1444','2013-10-17','10:40:00',1.68),('1444','2013-10-17','10:45:00',1.73),('1444','2013-10-17','10:50:00',1.76),('1444','2013-10-17','10:55:00',1.8),('1444','2013-10-17','11:00:00',1.84),('1444','2013-10-17','11:05:00',1.87),('1444','2013-10-17','11:10:00',1.9),('1444','2013-10-17','11:15:00',1.92),('1444','2013-10-17','11:20:00',1.95),('1444','2013-10-17','11:25:00',1.97),('1444','2013-10-17','11:30:00',2),('1444','2013-10-17','11:35:00',2.03),('1444','2013-10-17','11:40:00',2.05),('1444','2013-10-17','11:45:00',2.07),('1444','2013-10-17','11:50:00',2.08),('1444','2013-10-17','11:55:00',2.08),('1444','2013-10-17','12:00:00',2.09),('1444','2013-10-17','12:05:00',2.12),('1444','2013-10-17','12:10:00',2.12),('1444','2013-10-17','12:15:00',2.13),('1444','2013-10-17','12:20:00',2.12),('1444','2013-10-17','12:25:00',2.13),('1444','2013-10-17','12:30:00',2.14),('1444','2013-10-17','12:35:00',2.15),('1444','2013-10-17','12:40:00',2.17),('1444','2013-10-17','12:45:00',2.18),('1444','2013-10-17','12:50:00',2.18),('1444','2013-10-17','12:55:00',2.17),('1444','2013-10-17','13:00:00',2.15),('1444','2013-10-17','13:05:00',2.15),('1444','2013-10-17','13:10:00',2.15),('1444','2013-10-17','13:15:00',2.15),('1444','2013-10-17','13:20:00',2.14),('1444','2013-10-17','13:25:00',2.12),('1444','2013-10-17','13:30:00',2.09),('1444','2013-10-17','13:35:00',2.11),('1444','2013-10-17','13:40:00',2.09),('1444','2013-10-17','13:45:00',2.08),('1444','2013-10-17','13:50:00',2.06),('1444','2013-10-17','13:55:00',2.03),('1444','2013-10-17','14:00:00',2.02),('1444','2013-10-17','14:05:00',2),('1444','2013-10-17','14:10:00',1.98),('1444','2013-10-17','14:15:00',1.96),('1444','2013-10-17','14:20:00',1.95),('1444','2013-10-17','14:25:00',1.92),('1444','2013-10-17','14:30:00',1.88),('1444','2013-10-17','14:35:00',1.84),('1444','2013-10-17','14:40:00',1.82),('1444','2013-10-17','14:45:00',1.78),('1444','2013-10-17','14:50:00',1.76),('1444','2013-10-17','14:55:00',1.71),('1444','2013-10-17','15:00:00',1.67),('1444','2013-10-17','15:05:00',1.64),('1444','2013-10-17','15:10:00',1.6),('1444','2013-10-17','15:15:00',1.57),('1444','2013-10-17','15:20:00',1.53),('1444','2013-10-17','15:25:00',1.49),('1444','2013-10-17','15:30:00',1.45),('1444','2013-10-17','15:35:00',1.39),('1444','2013-10-17','15:40:00',1.35),('1444','2013-10-17','15:45:00',1.3),('1444','2013-10-17','15:50:00',1.25),('1444','2013-10-17','15:55:00',1.2),('1444','2013-10-17','16:00:00',1.15),('1444','2013-10-17','16:05:00',1.1),('1444','2013-10-17','16:10:00',1.05),('1444','2013-10-17','16:15:00',1),('1444','2013-10-16','09:45:00',1.2),('1444','2013-10-16','09:50:00',1.03),('1444','2013-10-16','12:15:00',1.64),('1444','2013-10-16','12:20:00',1.01),('1444','2013-10-16','12:30:00',1.14),('1444','2013-10-16','12:35:00',1.03),('1444','2013-10-16','12:40:00',2.5),('1444','2013-10-16','12:45:00',1.53),('1444','2013-10-16','12:50:00',1.95),('1444','2013-10-16','12:55:00',1.63),('1444','2013-10-16','13:00:00',1.39),('1444','2013-10-16','13:05:00',1.97),('1444','2013-10-16','13:10:00',1.27),('1444','2013-10-16','13:15:00',2.47),('1444','2013-10-16','13:20:00',2.32),('1444','2013-10-16','13:25:00',2.22),('1444','2013-10-16','13:30:00',2.16),('1444','2013-10-16','13:35:00',2.09),('1444','2013-10-16','13:40:00',2.11),('1444','2013-10-16','13:45:00',2.1),('1444','2013-10-16','13:50:00',1.73),('1444','2013-10-16','13:55:00',2.17),('1444','2013-10-16','14:00:00',1.83),('1444','2013-10-16','14:05:00',1.29),('1444','2013-10-16','14:10:00',2.18),('1444','2013-10-16','14:15:00',2.02),('1444','2013-10-16','14:20:00',1.95),('1444','2013-10-16','14:25:00',2.03),('1444','2013-10-16','14:30:00',1.98),('1444','2013-10-16','14:35:00',2.07),('1444','2013-10-16','14:40:00',1.91),('1444','2013-10-16','14:45:00',1.73),('1444','2013-10-16','14:50:00',1.68),('1444','2013-10-16','14:55:00',1.72),('1444','2013-10-16','15:00:00',1.64),('1444','2013-10-16','15:10:00',1.71),('1444','2013-10-16','15:15:00',1.58),('1444','2013-10-16','15:20:00',1.5),('1444','2013-10-16','15:25:00',1.25),('1444','2013-10-16','15:40:00',1.42),('1444','2013-10-16','15:45:00',1.33),('1444','2013-10-16','15:50:00',1.27),('1444','2013-10-16','15:55:00',1.21),('1444','2013-10-16','16:00:00',1.17),('1444','2013-10-16','16:05:00',1.12),('1444','2013-10-16','16:10:00',1.08),('1444','2013-10-16','16:15:00',1.01),('1444','2013-10-15','09:45:00',1.14),('1444','2013-10-15','09:50:00',1.25),('1444','2013-10-15','09:55:00',1.34),('1444','2013-10-15','10:00:00',1.35),('1444','2013-10-15','10:05:00',1.54),('1444','2013-10-15','10:10:00',1.18),('1444','2013-10-15','10:25:00',1.02),('1444','2013-10-15','10:30:00',1.3),('1444','2013-10-15','10:35:00',1.03),('1444','2013-10-15','10:40:00',1.24),('1444','2013-10-15','10:45:00',1.49),('1444','2013-10-15','10:50:00',1.43),('1444','2013-10-15','10:55:00',1.26),('1444','2013-10-15','11:00:00',1.24),('1444','2013-10-15','11:05:00',1.34),('1444','2013-10-15','11:10:00',1.7),('1444','2013-10-15','11:15:00',1.88),('1444','2013-10-15','11:20:00',1.9),('1444','2013-10-15','11:25:00',1.74),('1444','2013-10-15','11:30:00',1.84),('1444','2013-10-15','11:35:00',1.55),('1444','2013-10-15','11:40:00',1.27),('1444','2013-10-15','11:45:00',1.05),('1444','2013-10-15','11:50:00',1.01),('1444','2013-10-15','11:55:00',1.01),('1444','2013-10-15','12:00:00',1.06),('1444','2013-10-15','12:05:00',1.06),('1444','2013-10-15','12:10:00',1.08),('1444','2013-10-15','12:15:00',1.06),('1444','2013-10-15','12:20:00',1.12),('1444','2013-10-15','12:25:00',1.01),('1444','2013-10-15','12:45:00',1.02),('1444','2013-10-15','13:05:00',1.13),('1444','2013-10-15','13:10:00',1.25),('1444','2013-10-15','13:15:00',1.25),('1444','2013-10-15','13:20:00',1.76),('1444','2013-10-15','13:25:00',1.97),('1444','2013-10-15','13:30:00',1.27),('1444','2013-10-15','13:35:00',1.09),('1444','2013-10-15','13:40:00',1.06),('1444','2013-10-15','13:45:00',1.08),('1444','2013-10-15','13:50:00',1.02),('1444','2013-10-15','14:15:00',1.26),('1444','2013-10-15','14:20:00',1.33),('1444','2013-10-15','14:25:00',1.46),('1444','2013-10-15','14:30:00',1.36),('1444','2013-10-15','14:40:00',1.23),('1444','2013-10-15','14:45:00',1.3),('1444','2013-10-15','14:50:00',1.74),('1444','2013-10-15','14:55:00',1.27),('1444','2013-10-14','09:30:00',1.07),('1444','2013-10-14','09:35:00',1.05),('1444','2013-10-14','09:55:00',1.16),('1444','2013-10-14','10:00:00',1.16),('1444','2013-10-14','10:05:00',1.26),('1444','2013-10-14','10:10:00',1.35),('1444','2013-10-14','10:15:00',1.45),('1444','2013-10-14','10:20:00',1.48),('1444','2013-10-14','10:25:00',1.52),('1444','2013-10-14','10:30:00',1.55),('1444','2013-10-14','10:35:00',1.56),('1444','2013-10-14','10:40:00',1.56),('1444','2013-10-14','10:45:00',1.61),('1444','2013-10-14','10:50:00',1.66),('1444','2013-10-14','10:55:00',1.71),('1444','2013-10-14','11:00:00',1.74),('1444','2013-10-14','11:05:00',1.75),('1444','2013-10-14','11:10:00',1.84),('1444','2013-10-14','11:15:00',1.82),('1444','2013-10-14','11:20:00',1.85),('1444','2013-10-14','11:25:00',1.9),('1444','2013-10-14','11:30:00',1.94),('1444','2013-10-14','11:35:00',1.9),('1444','2013-10-14','11:40:00',1.93),('1444','2013-10-14','11:45:00',1.92),('1444','2013-10-14','11:50:00',1.94),('1444','2013-10-14','11:55:00',1.95),('1444','2013-10-14','12:00:00',1.97),('1444','2013-10-14','12:05:00',1.99),('1444','2013-10-14','12:10:00',2.04),('1444','2013-10-14','12:15:00',1.99),('1444','2013-10-14','12:20:00',1.86),('1444','2013-10-14','12:25:00',2),('1444','2013-10-14','12:30:00',2.08),('1444','2013-10-14','12:35:00',2.05),('1444','2013-10-14','12:40:00',2.04),('1444','2013-10-14','12:45:00',2.05),('1444','2013-10-14','12:50:00',2.05),('1444','2013-10-14','12:55:00',2.05),('1444','2013-10-14','13:00:00',2.05),('1444','2013-10-14','13:05:00',2.02),('1444','2013-10-14','13:10:00',2.02),('1444','2013-10-14','13:15:00',2.01),('1444','2013-10-14','13:20:00',2.02),('1444','2013-10-14','13:25:00',2),('1444','2013-10-14','13:30:00',1.98),('1444','2013-10-14','13:35:00',1.98),('1444','2013-10-14','13:40:00',1.98),('1444','2013-10-14','13:45:00',1.96),('1444','2013-10-14','13:50:00',1.94),('1444','2013-10-14','13:55:00',1.94),('1444','2013-10-14','14:00:00',1.91),('1444','2013-10-14','14:05:00',1.91),('1444','2013-10-14','14:10:00',1.88),('1444','2013-10-14','14:15:00',1.86),('1444','2013-10-14','14:20:00',1.84),('1444','2013-10-14','14:25:00',1.81),('1444','2013-10-14','14:30:00',1.79),('1444','2013-10-14','14:35:00',1.76),('1444','2013-10-14','14:40:00',1.74),('1444','2013-10-14','14:45:00',1.71),('1444','2013-10-14','14:50:00',1.68),('1444','2013-10-14','14:55:00',1.63),('1444','2013-10-14','15:00:00',1.6),('1444','2013-10-14','15:05:00',1.56),('1444','2013-10-14','15:10:00',1.51),('1444','2013-10-14','15:15:00',1.46),('1444','2013-10-14','15:20:00',1.43),('1444','2013-10-14','15:25:00',1.39),('1444','2013-10-14','15:30:00',1.34),('1444','2013-10-14','15:35:00',1.28),('1444','2013-10-14','15:40:00',1.16),('1444','2013-10-13','09:15:00',1.02),('1444','2013-10-13','09:20:00',1.09),('1444','2013-10-13','09:40:00',1.37),('1444','2013-10-13','09:45:00',1.67),('1444','2013-10-13','09:50:00',1.66),('1444','2013-10-13','09:55:00',1.7),('1444','2013-10-13','10:00:00',1.16),('1444','2013-10-13','10:10:00',1.41),('1444','2013-10-13','10:15:00',1.4),('1444','2013-10-13','10:20:00',1.25),('1444','2013-10-13','10:25:00',1.47),('1444','2013-10-13','10:30:00',1.79),('1444','2013-10-13','10:35:00',2),('1444','2013-10-13','10:40:00',2.07),('1444','2013-10-13','10:45:00',2.14),('1444','2013-10-13','10:50:00',1.67),('1444','2013-10-13','10:55:00',1.58),('1444','2013-10-13','11:00:00',1.88),('1444','2013-10-13','11:05:00',1.92),('1444','2013-10-13','11:10:00',1.98),('1444','2013-10-13','11:15:00',2.03),('1444','2013-10-13','11:20:00',1.96),('1444','2013-10-13','11:25:00',1.92),('1444','2013-10-13','11:30:00',1.98),('1444','2013-10-13','11:35:00',1.97),('1444','2013-10-13','11:40:00',1.98),('1444','2013-10-13','11:45:00',1.99),('1444','2013-10-13','11:50:00',2.01),('1444','2013-10-13','11:55:00',2.04),('1444','2013-10-13','12:00:00',2.04),('1444','2013-10-13','12:05:00',2.05),('1444','2013-10-13','12:10:00',2.04),('1444','2013-10-13','12:15:00',2.07),('1444','2013-10-13','12:20:00',1.99),('1444','2013-10-13','12:25:00',1.99),('1444','2013-10-13','12:30:00',2.08),('1444','2013-10-13','12:35:00',2.1),('1444','2013-10-13','12:40:00',2.11),('1444','2013-10-13','12:45:00',2.07),('1444','2013-10-13','12:50:00',2.05),('1444','2013-10-13','12:55:00',2.05),('1444','2013-10-13','13:00:00',2.06),('1444','2013-10-13','13:05:00',2.05),('1444','2013-10-13','13:10:00',2.07),('1444','2013-10-13','13:15:00',2.09),('1444','2013-10-13','13:20:00',2.1),('1444','2013-10-13','13:25:00',1.8),('1444','2013-10-13','13:30:00',1.56),('1444','2013-10-13','13:35:00',1.59),('1444','2013-10-13','13:40:00',1.25),('1444','2013-10-13','13:45:00',1.34),('1444','2013-10-13','13:50:00',1.49),('1444','2013-10-13','13:55:00',1.71),('1444','2013-10-13','14:00:00',2.06),('1444','2013-10-13','14:05:00',2),('1444','2013-10-13','14:10:00',1.93),('1444','2013-10-13','14:15:00',1.84),('1444','2013-10-13','14:20:00',2.02),('1444','2013-10-13','14:25:00',2.01),('1444','2013-10-13','14:30:00',1.59),('1444','2013-10-13','14:35:00',1.65),('1444','2013-10-13','14:40:00',1.74),('1444','2013-10-13','14:45:00',1.27),('1444','2013-10-13','14:50:00',1.17),('1444','2013-10-13','14:55:00',1.39),('1444','2013-10-13','15:00:00',1.72),('1444','2013-10-13','15:05:00',1.34),('1444','2013-10-13','15:10:00',1.02),('1444','2013-10-13','15:15:00',1.28),('1444','2013-10-13','15:20:00',1.43),('1444','2013-10-13','15:25:00',1.5),('1444','2013-10-13','15:30:00',1.15),('1444','2013-10-13','15:35:00',1.01),('1444','2013-10-13','16:05:00',1.11),('1444','2013-10-13','16:25:00',1.13),('1444','2013-10-13','16:30:00',1.08),('1444','2013-10-12','11:35:00',1.32),('1444','2013-10-12','11:40:00',2),('1444','2013-10-12','11:45:00',1.07),('1444','2013-10-12','11:50:00',1.02),('1444','2013-10-12','12:20:00',1.51),('1444','2013-10-12','12:25:00',2.35),('1444','2013-10-12','12:30:00',1.79),('1444','2013-10-12','12:35:00',2.12),('1444','2013-10-12','12:40:00',2.05),('1444','2013-10-12','12:45:00',1.91),('1444','2013-10-12','12:50:00',1.95),('1444','2013-10-12','12:55:00',1.34),('1444','2013-10-12','13:00:00',1.17),('1444','2013-10-12','13:25:00',1.18),('1444','2013-10-12','13:30:00',2.77),('1444','2013-10-12','13:35:00',1.03),('1444','2013-10-12','16:15:00',1.17),('1444','2013-10-12','16:20:00',1.23),('1444','2013-10-11','09:45:00',1.29),('1444','2013-10-11','09:50:00',1.33),('1444','2013-10-11','09:55:00',1.38),('1444','2013-10-11','10:00:00',1.43),('1444','2013-10-11','10:05:00',1.5),('1444','2013-10-11','10:10:00',1.54),('1444','2013-10-11','10:15:00',1.23),('1444','2013-10-11','10:20:00',1.41),('1444','2013-10-11','10:25:00',1.49),('1444','2013-10-11','10:30:00',1.7),('1444','2013-10-11','10:35:00',1.75),('1444','2013-10-11','11:05:00',1.93),('1444','2013-10-11','11:10:00',1.42),('1444','2013-10-11','11:40:00',1.11),('1444','2013-10-11','11:45:00',1.32),('1444','2013-10-11','11:50:00',1.49),('1444','2013-10-11','11:55:00',1.26),('1444','2013-10-11','12:00:00',2.14),('1444','2013-10-11','12:05:00',1.92),('1444','2013-10-11','13:05:00',1.7),('1444','2013-10-11','13:10:00',1.49),('1444','2013-10-11','13:15:00',1.22),('1444','2013-10-11','13:20:00',1.92),('1444','2013-10-11','13:25:00',2.55),('1444','2013-10-11','13:30:00',1.01),('1444','2013-10-11','13:40:00',2.45),('1444','2013-10-11','13:45:00',1.85),('1444','2013-10-11','15:40:00',1.14),('1444','2013-10-11','16:00:00',1.43),('1444','2013-10-10','09:15:00',1.01),('1444','2013-10-10','09:20:00',1.03),('1444','2013-10-10','09:25:00',1.05),('1444','2013-10-10','09:30:00',1.07),('1444','2013-10-10','09:40:00',1.06),('1444','2013-10-10','09:50:00',1.29),('1444','2013-10-10','10:10:00',1.25),('1444','2013-10-10','10:15:00',1.57),('1444','2013-10-10','10:20:00',1.59),('1444','2013-10-10','10:40:00',1.71),('1444','2013-10-10','10:45:00',1.84),('1444','2013-10-10','10:50:00',1.48),('1444','2013-10-10','11:20:00',1.85),('1444','2013-10-10','11:25:00',1.58),('1444','2013-10-10','11:35:00',1.8),('1444','2013-10-10','11:40:00',1.27),('1444','2013-10-10','11:50:00',1.88),('1444','2013-10-10','11:55:00',2.48),('1444','2013-10-10','12:00:00',2.35),('1444','2013-10-10','12:05:00',2.37),('1444','2013-10-10','12:20:00',2.09),('1444','2013-10-10','12:25:00',2.02),('1444','2013-10-10','12:35:00',2.72),('1444','2013-10-10','12:40:00',2.52),('1444','2013-10-10','12:45:00',1.71),('1444','2013-10-10','12:50:00',1.57),('1444','2013-10-10','12:55:00',2.72),('1444','2013-10-10','13:00:00',2.54),('1444','2013-10-10','13:05:00',2.64),('1444','2013-10-10','13:10:00',2.58),('1444','2013-10-10','13:15:00',1.74),('1444','2013-10-10','13:20:00',1),('1444','2013-10-10','13:25:00',2.88),('1444','2013-10-10','13:30:00',2.26),('1444','2013-10-10','13:35:00',1.73),('1444','2013-10-10','13:40:00',1.62),('1444','2013-10-10','13:45:00',2.28),('1444','2013-10-10','13:50:00',2.25),('1444','2013-10-10','13:55:00',2.33),('1444','2013-10-10','14:00:00',2.27),('1444','2013-10-10','14:05:00',2.33),('1444','2013-10-10','14:10:00',2.08),('1444','2013-10-10','14:15:00',1.2),('1444','2013-10-10','14:20:00',2.09),('1444','2013-10-10','14:25:00',2.43),('1444','2013-10-10','14:30:00',2.34),('1444','2013-10-10','14:35:00',2.37),('1444','2013-10-10','14:40:00',2.17),('1444','2013-10-10','14:45:00',2.09),('1444','2013-10-10','14:50:00',2),('1444','2013-10-10','14:55:00',1.94),('1444','2013-10-10','15:00:00',1.95),('1444','2013-10-10','15:05:00',1.6),('1444','2013-10-10','15:10:00',1.73),('1444','2013-10-10','15:15:00',1.33),('1444','2013-10-10','15:20:00',1.84),('1444','2013-10-10','15:30:00',1.22),('1444','2013-10-10','15:40:00',1.46),('1444','2013-10-10','15:50:00',1.18),('1444','2013-10-10','15:55:00',1.62),('1444','2013-10-10','16:25:00',1.22),('1444','2014-04-15','09:00:00',1.55),('1444','2014-04-15','09:05:00',1.09),('1444','2014-04-15','09:10:00',1.53),('1444','2014-04-15','09:15:00',1.81),('1444','2014-04-15','09:20:00',1.86),('1444','2014-04-15','09:25:00',1.89),('1444','2014-04-15','09:30:00',1.02),('1444','2014-04-15','09:50:00',1.26),('1444','2014-04-15','10:00:00',1.77),('1444','2014-04-15','10:05:00',1.79),('1444','2014-04-15','10:10:00',2.19),('1444','2014-04-15','10:15:00',1.34),('1444','2014-04-15','10:20:00',1.77),('1444','2014-04-15','10:25:00',1.91),('1444','2014-04-15','10:30:00',3.03),('1444','2014-04-15','10:35:00',1.56),('1444','2014-04-15','10:40:00',2.26),('1444','2014-04-15','10:45:00',2.15),('1444','2014-04-15','10:50:00',1.87),('1444','2014-04-15','10:55:00',1.07),('1444','2014-04-15','11:00:00',2.22),('1444','2014-04-15','11:05:00',2.47),('1444','2014-04-15','11:10:00',1.44),('1444','2014-04-15','11:15:00',1.43),('1444','2014-04-15','11:25:00',1.2),('1444','2014-04-15','11:45:00',1),('1444','2014-04-15','11:50:00',1.09),('1444','2014-04-15','12:15:00',1.26),('1444','2014-04-15','12:20:00',1.12),('1444','2014-04-15','13:10:00',1.08),('1444','2014-04-15','13:15:00',1.91),('1444','2014-04-15','13:20:00',2.11),('1444','2014-04-15','13:25:00',1.78),('1444','2014-04-15','13:30:00',1.76),('1444','2014-04-15','13:35:00',2.68),('1444','2014-04-15','13:40:00',1.36),('1444','2014-04-15','14:00:00',2.65),('1444','2014-04-15','14:05:00',1.33),('1444','2014-04-15','14:10:00',3.1),('1444','2014-04-15','14:15:00',1.88),('1444','2014-04-15','14:20:00',2.07),('1444','2014-04-15','14:25:00',2.84),('1444','2014-04-15','14:30:00',1.84),('1444','2014-04-15','14:35:00',1.15),('1444','2014-04-15','14:40:00',1.53),('1444','2014-04-15','14:45:00',1.52),('1444','2014-04-15','14:50:00',1.11),('1444','2014-04-15','15:10:00',1.03),('1444','2014-04-15','15:15:00',1.29),('1444','2014-04-15','15:20:00',1.44),('1444','2014-04-15','15:25:00',1.5),('1444','2014-04-15','15:30:00',1.25),('1444','2014-04-15','15:35:00',1.16),('1444','2014-04-15','15:40:00',1.17),('1444','2014-04-15','15:45:00',1.07),('1444','2014-04-15','15:50:00',1.09),('1444','2014-04-15','15:55:00',1.25),('1444','2014-04-15','16:00:00',1.31),('1444','2014-04-15','16:05:00',1.19),('1444','2013-10-08','10:55:00',1),('1444','2013-10-08','11:07:00',1.26),('1444','2013-10-08','11:10:00',1.22),('1444','2013-10-08','11:15:00',2.14),('1444','2013-10-08','11:20:00',2.28),('1444','2013-10-08','11:25:00',1.37),('1444','2013-10-08','11:30:00',1.72),('1444','2013-10-08','11:37:00',1.35),('1444','2013-10-08','11:40:00',1.07),('1444','2013-10-08','12:25:00',1.11),('1444','2013-10-08','12:30:00',1.46),('1444','2013-10-08','12:35:00',1.68),('1444','2013-10-08','12:40:00',2.56),('1444','2013-10-08','12:45:00',2.32),('1444','2013-10-08','12:50:00',2.43),('1444','2013-10-08','12:55:00',2.5),('1444','2013-10-08','13:00:00',2.3),('1444','2013-10-08','13:05:00',1.69),('1444','2013-10-08','13:10:00',1.18),('1444','2013-10-08','13:15:00',1.89),('1444','2013-10-08','13:20:00',1.03),('1444','2013-10-08','13:25:00',2.32),('1444','2013-10-08','13:30:00',1.37),('1444','2013-10-08','14:05:00',1.06),('1444','2013-10-08','14:10:00',1.29),('1444','2013-10-08','14:15:00',1.61),('1444','2013-10-08','14:20:00',1.7),('1444','2013-10-08','14:25:00',1.95),('1444','2013-10-08','14:30:00',1.59),('1444','2013-10-08','14:45:00',1.99),('1444','2013-10-08','14:50:00',2.05),('1444','2013-10-08','14:55:00',1.89),('1444','2013-10-08','15:00:00',1.89),('1444','2013-10-08','15:05:00',1.88),('1444','2013-10-08','15:10:00',1.85),('1444','2013-10-08','15:15:00',1.48),('1444','2013-10-08','15:20:00',1.9),('1444','2013-10-08','15:25:00',2.08),('1444','2013-10-08','15:30:00',2.04),('1444','2013-10-08','15:35:00',1.78),('1444','2013-10-08','15:50:00',1.3),('1444','2013-10-07','09:00:00',1.01),('1444','2013-10-07','09:15:00',1.03),('1444','2013-10-07','09:20:00',1.07),('1444','2013-10-07','09:25:00',1.13),('1444','2013-10-07','09:30:00',1.18),('1444','2013-10-07','09:35:00',1.23),('1444','2013-10-07','09:40:00',1.28),('1444','2013-10-07','09:45:00',1.33),('1444','2013-10-07','09:50:00',1.38),('1444','2013-10-07','09:55:00',1.43),('1444','2013-10-07','10:00:00',1.47),('1444','2013-10-07','10:05:00',1.52),('1444','2013-10-07','10:10:00',1.55),('1444','2013-10-07','10:15:00',1.6),('1444','2013-10-07','10:20:00',1.65),('1444','2013-10-07','10:25:00',1.65),('1444','2013-10-07','10:30:00',1.77),('1444','2013-10-07','10:35:00',1.91),('1444','2013-10-07','10:40:00',1.83),('1444','2013-10-07','10:45:00',1.86),('1444','2013-10-07','10:50:00',1.91),('1444','2013-10-07','10:55:00',1.68),('1444','2013-10-07','11:00:00',1.76),('1444','2013-10-07','11:05:00',1.94),('1444','2013-10-07','11:10:00',1.74),('1444','2013-10-07','11:15:00',2.01),('1444','2013-10-07','11:20:00',1.96),('1444','2013-10-07','11:25:00',2.09),('1444','2013-10-07','11:30:00',2.09),('1444','2013-10-07','11:35:00',2.13),('1444','2013-10-07','11:40:00',2.16),('1444','2013-10-07','11:45:00',2.18),('1444','2013-10-07','11:50:00',2.21),('1444','2013-10-07','11:55:00',2.23),('1444','2013-10-07','12:00:00',2.24),('1444','2013-10-07','12:05:00',2.32),('1444','2013-10-07','12:10:00',2.2),('1444','2013-10-07','12:20:00',1.92),('1444','2013-10-07','12:25:00',2.68),('1444','2013-10-07','12:30:00',2.6),('1444','2013-10-07','12:35:00',2.4),('1444','2013-10-07','12:40:00',1.57),('1444','2013-10-07','12:45:00',2.34),('1444','2013-10-07','12:50:00',1.75),('1444','2013-10-07','12:55:00',2.56),('1444','2013-10-07','13:00:00',2.51),('1444','2013-10-07','13:05:00',2.51),('1444','2013-10-07','13:10:00',2.62),('1444','2013-10-07','13:15:00',2.5),('1444','2013-10-07','13:20:00',1.93),('1444','2013-10-07','13:25:00',1.07),('1444','2013-10-07','13:35:00',2.03),('1444','2013-10-07','13:40:00',2.29),('1444','2013-10-07','13:50:00',2.15),('1444','2013-10-07','13:55:00',2.57),('1444','2013-10-07','14:00:00',1.13),('1444','2013-10-07','14:30:00',2.39),('1444','2013-10-07','14:35:00',2.54),('1444','2013-10-07','14:40:00',1.89),('1444','2013-10-07','14:45:00',2.19),('1444','2013-10-07','14:50:00',2.34),('1444','2013-10-07','14:55:00',2.24),('1444','2013-10-07','15:00:00',1.44),('1444','2013-10-07','15:05:00',2.08),('1444','2013-10-07','15:10:00',1.01),('1444','2013-10-07','15:15:00',1.92),('1444','2013-10-07','15:25:00',1.8),('1444','2013-10-07','15:30:00',1.01),('1444','2013-10-07','15:40:00',1.25),('1444','2013-10-07','15:45:00',2.02),('1444','2013-10-07','16:05:00',1.66),('1444','2013-10-07','16:10:00',1.53),('1444','2013-10-07','16:15:00',1.39),('1444','2013-10-07','16:20:00',1.27),('1444','2013-10-07','16:25:00',1.27),('1444','2013-10-07','16:30:00',1.22),('1444','2013-10-07','16:35:00',1.13),('1444','2013-10-07','16:45:00',1.06),('1444','2013-10-06','09:35:00',1),('1444','2013-10-06','09:50:00',1.39),('1444','2013-10-06','09:55:00',1.62),('1444','2013-10-06','10:00:00',1.86),('1444','2013-10-06','10:05:00',1.9),('1444','2013-10-06','10:10:00',1.86),('1444','2013-10-06','10:15:00',1.74),('1444','2013-10-06','10:20:00',1.75),('1444','2013-10-06','10:25:00',1.97),('1444','2013-10-06','10:30:00',1.93),('1444','2013-10-06','10:35:00',1.9),('1444','2013-10-06','10:40:00',1.62),('1444','2013-10-06','10:45:00',1.29),('1444','2013-10-06','10:50:00',1.55),('1444','2013-10-06','10:55:00',1.57),('1444','2013-10-06','11:00:00',1.67),('1444','2013-10-06','11:05:00',1.81),('1444','2013-10-06','11:10:00',1.87),('1444','2013-10-06','11:15:00',1.78),('1444','2013-10-06','11:20:00',1.9),('1444','2013-10-06','11:25:00',1.92),('1444','2013-10-06','11:30:00',1.89),('1444','2013-10-06','11:35:00',1.85),('1444','2013-10-06','11:40:00',1.23),('1444','2013-10-06','11:45:00',1.16),('1444','2013-10-06','11:50:00',1.13),('1444','2013-10-06','11:55:00',1.69),('1444','2013-10-06','12:00:00',1.71),('1444','2013-10-06','12:05:00',1.81),('1444','2013-10-06','12:10:00',2.23),('1444','2013-10-06','12:15:00',2.02),('1444','2013-10-06','12:20:00',1.73),('1444','2013-10-06','12:25:00',1.61),('1444','2013-10-06','12:30:00',1.35),('1444','2013-10-06','12:35:00',1.75),('1444','2013-10-06','12:40:00',1.69),('1444','2013-10-06','12:45:00',1.54),('1444','2013-10-06','12:50:00',1.8),('1444','2013-10-06','12:55:00',2.03),('1444','2013-10-06','13:00:00',1.89),('1444','2013-10-06','13:05:00',2.14),('1444','2013-10-06','13:10:00',2.07),('1444','2013-10-06','13:15:00',2.28),('1444','2013-10-06','13:20:00',1.03),('1444','2013-10-06','13:45:00',1.56),('1444','2013-10-06','13:50:00',2.55),('1444','2013-10-06','13:55:00',2.36),('1444','2013-10-06','14:00:00',1.95),('1444','2013-10-06','14:05:00',1.38),('1444','2013-10-06','14:10:00',1.05),('1444','2013-10-06','14:25:00',1.03),('1444','2013-10-06','14:30:00',1.57),('1444','2013-10-06','14:35:00',1.55),('1444','2013-10-06','14:40:00',1.45),('1444','2013-10-06','14:45:00',1.18),('1444','2013-10-06','14:50:00',1.38),('1444','2013-10-06','14:55:00',1.7),('1444','2013-10-06','15:00:00',1.27),('1444','2013-10-04','09:55:00',1.61),('1444','2013-10-04','10:00:00',1.45),('1444','2013-10-04','10:05:00',1.01),('1444','2013-10-04','10:10:00',1.04),('1444','2013-10-04','10:15:00',1.14),('1444','2013-10-04','10:20:00',1.11),('1444','2013-10-04','10:25:00',1.39),('1444','2013-10-04','10:30:00',1.6),('1444','2013-10-04','10:35:00',1.51),('1444','2013-10-04','10:40:00',1.56),('1444','2013-10-04','10:45:00',1.79),('1444','2013-10-04','10:50:00',1.3),('1444','2013-10-04','10:55:00',1.46),('1444','2013-10-04','11:00:00',1.47),('1444','2013-10-04','11:05:00',1.17),('1444','2013-10-04','11:10:00',1.09),('1444','2013-10-04','11:15:00',1.9),('1444','2013-10-04','11:20:00',1.88),('1444','2013-10-04','11:25:00',1.84),('1444','2013-10-04','11:30:00',2.42),('1444','2013-10-04','11:35:00',2.2),('1444','2013-10-04','11:40:00',2.21),('1444','2013-10-04','11:45:00',2.31),('1444','2013-10-04','11:50:00',2.31),('1444','2013-10-04','11:55:00',2.31),('1444','2013-10-04','12:00:00',2.34),('1444','2013-10-04','12:05:00',2.36),('1444','2013-10-04','12:10:00',2.37),('1444','2013-10-04','12:15:00',2.29),('1444','2013-10-04','12:20:00',2.22),('1444','2013-10-04','12:25:00',2.42),('1444','2013-10-04','12:30:00',2.51),('1444','2013-10-04','12:35:00',2.39),('1444','2013-10-04','12:40:00',2.34),('1444','2013-10-04','12:45:00',2.38),('1444','2013-10-04','12:50:00',2.33),('1444','2013-10-04','12:55:00',2.29),('1444','2013-10-04','13:00:00',2.32),('1444','2013-10-04','13:05:00',2.36),('1444','2013-10-04','13:10:00',2.39),('1444','2013-10-04','13:15:00',2.48),('1444','2013-10-04','13:20:00',2.41),('1444','2013-10-04','13:25:00',2.23),('1444','2013-10-04','13:30:00',2.4),('1444','2013-10-04','13:35:00',2.42),('1444','2013-10-04','13:40:00',2.27),('1444','2013-10-04','13:45:00',2.22),('1444','2013-10-04','13:50:00',2.23),('1444','2013-10-04','13:55:00',2.19),('1444','2013-10-04','14:00:00',2.2),('1444','2013-10-04','14:05:00',2.19),('1444','2013-10-04','14:10:00',1.98),('1444','2013-10-04','14:15:00',1.65),('1444','2013-10-04','14:20:00',2.04),('1444','2013-10-04','14:25:00',2.07),('1444','2013-10-04','14:30:00',1.81),('1444','2013-10-04','14:35:00',1.28),('1444','2013-10-04','14:40:00',1.08),('1444','2013-10-04','14:45:00',1.33),('1444','2013-10-04','14:50:00',1.67),('1444','2013-10-04','14:55:00',1.64),('1444','2013-10-04','15:00:00',1.41),('1444','2013-10-04','15:05:00',1.57),('1444','2013-10-04','15:10:00',1.28),('1444','2013-10-04','15:15:00',1.05),('1444','2013-10-04','15:25:00',1.71),('1444','2013-10-04','15:30:00',1.39),('1444','2013-10-03','09:05:00',1.01),('1444','2013-10-03','09:10:00',1.07),('1444','2013-10-03','09:15:00',1.14),('1444','2013-10-03','09:20:00',1.19),('1444','2013-10-03','09:25:00',1.25),('1444','2013-10-03','09:30:00',1.31),('1444','2013-10-03','09:35:00',1.37),('1444','2013-10-03','09:40:00',1.42),('1444','2013-10-03','09:45:00',1.47),('1444','2013-10-03','09:50:00',1.53),('1444','2013-10-03','09:55:00',1.58),('1444','2013-10-03','10:00:00',1.64),('1444','2013-10-03','10:05:00',1.69),('1444','2013-10-03','10:10:00',1.73),('1444','2013-10-03','10:15:00',1.78),('1444','2013-10-03','10:20:00',1.83),('1444','2013-10-03','10:25:00',1.88),('1444','2013-10-03','10:30:00',1.92),('1444','2013-10-03','10:35:00',1.96),('1444','2013-10-03','10:40:00',2),('1444','2013-10-03','10:45:00',2.04),('1444','2013-10-03','10:50:00',2.07),('1444','2013-10-03','10:55:00',2.12),('1444','2013-10-03','11:00:00',2.15),('1444','2013-10-03','11:05:00',2.17),('1444','2013-10-03','11:10:00',2.22),('1444','2013-10-03','11:15:00',2.24),('1444','2013-10-03','11:20:00',2.27),('1444','2013-10-03','11:25:00',2.3),('1444','2013-10-03','11:30:00',2.32),('1444','2013-10-03','11:35:00',2.35),('1444','2013-10-03','11:40:00',2.37),('1444','2013-10-03','11:45:00',2.38),('1444','2013-10-03','11:50:00',2.41),('1444','2013-10-03','11:55:00',2.43),('1444','2013-10-03','12:00:00',2.44),('1444','2013-10-03','12:05:00',2.47),('1444','2013-10-03','12:10:00',2.48),('1444','2013-10-03','12:15:00',2.48),('1444','2013-10-03','12:20:00',2.48),('1444','2013-10-03','12:25:00',2.49),('1444','2013-10-03','12:30:00',2.49),('1444','2013-10-03','12:35:00',2.5),('1444','2013-10-03','12:40:00',2.5),('1444','2013-10-03','12:45:00',2.5),('1444','2013-10-03','12:50:00',2.5),('1444','2013-10-03','12:55:00',2.49),('1444','2013-10-03','13:00:00',2.49),('1444','2013-10-03','13:05:00',2.44),('1444','2013-10-03','13:10:00',2.46),('1444','2013-10-03','13:15:00',2.46),('1444','2013-10-03','13:20:00',2.46),('1444','2013-10-03','13:25:00',2.46),('1444','2013-10-03','13:30:00',2.46),('1444','2013-10-03','13:35:00',2.46),('1444','2013-10-03','13:40:00',2.44),('1444','2013-10-03','13:45:00',2.4),('1444','2013-10-03','13:50:00',2.39),('1444','2013-10-03','13:55:00',2.39),('1444','2013-10-03','14:00:00',2.38),('1444','2013-10-03','14:05:00',2.36),('1444','2013-10-03','14:10:00',2.34),('1444','2013-10-03','14:15:00',2.31),('1444','2013-10-03','14:20:00',2.28),('1444','2013-10-03','14:25:00',2.26),('1444','2013-10-03','14:30:00',2.24),('1444','2013-10-03','14:35:00',2.21),('1444','2013-10-03','14:40:00',2.18),('1444','2013-10-03','14:45:00',2.15),('1444','2013-10-03','14:50:00',2.11),('1444','2013-10-03','14:55:00',2.07),('1444','2013-10-03','15:00:00',2.04),('1444','2013-10-03','15:05:00',1.99),('1444','2013-10-03','15:10:00',1.95),('1444','2013-10-03','15:15:00',1.91),('1444','2013-10-03','15:20:00',1.88),('1444','2013-10-03','15:25:00',1.83),('1444','2013-10-03','15:30:00',1.79),('1444','2013-10-03','15:35:00',1.74),('1444','2013-10-03','15:40:00',1.69),('1444','2013-10-03','15:45:00',1.64),('1444','2013-10-03','15:50:00',1.59),('1444','2013-10-03','15:55:00',1.55),('1444','2013-10-03','16:00:00',1.49),('1444','2013-10-03','16:05:00',1.44),('1444','2013-10-03','16:10:00',1.39),('1444','2013-10-03','16:15:00',1.33),('1444','2013-10-03','16:20:00',1.27),('1444','2013-10-03','16:25:00',1.22),('1444','2013-10-03','16:30:00',1.17),('1444','2013-10-03','16:35:00',1.11),('1444','2013-10-03','16:40:00',1.05),('1444','2013-10-02','09:10:00',1.02),('1444','2013-10-02','09:15:00',1.08),('1444','2013-10-02','09:20:00',1.13),('1444','2013-10-02','09:25:00',1.19),('1444','2013-10-02','09:30:00',1.24),('1444','2013-10-02','09:35:00',1.29),('1444','2013-10-02','09:40:00',1.34),('1444','2013-10-02','09:45:00',1.39),('1444','2013-10-02','09:50:00',1.45),('1444','2013-10-02','09:55:00',1.49),('1444','2013-10-02','10:00:00',1.23),('1444','2013-10-02','10:05:00',1.58),('1444','2013-10-02','10:10:00',1.62),('1444','2013-10-02','10:15:00',1.66),('1444','2013-10-02','10:20:00',1.72),('1444','2013-10-02','10:25:00',1.77),('1444','2013-10-02','10:30:00',1.81),('1444','2013-10-02','10:35:00',1.86),('1444','2013-10-02','10:40:00',1.9),('1444','2013-10-02','10:45:00',1.95),('1444','2013-10-02','10:50:00',2),('1444','2013-10-02','10:55:00',2.03),('1444','2013-10-02','11:00:00',2.06),('1444','2013-10-02','11:05:00',2.1),('1444','2013-10-02','11:10:00',2.13),('1444','2013-10-02','11:15:00',2.15),('1444','2013-10-02','11:20:00',2.18),('1444','2013-10-02','11:25:00',2.2),('1444','2013-10-02','11:30:00',2.23),('1444','2013-10-02','11:35:00',2.25),('1444','2013-10-02','11:40:00',2.27),('1444','2013-10-02','11:45:00',2.29),('1444','2013-10-02','11:50:00',2.3),('1444','2013-10-02','11:55:00',2.32),('1444','2013-10-02','12:00:00',2.34),('1444','2013-10-02','12:05:00',2.36),('1444','2013-10-02','12:10:00',2.38),('1444','2013-10-02','12:15:00',2.38),('1444','2013-10-02','12:20:00',2.4),('1444','2013-10-02','12:25:00',2.39),('1444','2013-10-02','12:30:00',2.39),('1444','2013-10-02','12:35:00',2.41),('1444','2013-10-02','12:40:00',2.41),('1444','2013-10-02','12:45:00',2.41),('1444','2013-10-02','12:50:00',2.42),('1444','2013-10-02','12:55:00',2.42),('1444','2013-10-02','13:00:00',2.42),('1444','2013-10-02','13:05:00',2.44),('1444','2013-10-02','13:10:00',2.42),('1444','2013-10-02','13:15:00',2.41),('1444','2013-10-02','13:20:00',2.41),('1444','2013-10-02','13:25:00',2.41),('1444','2013-10-02','13:30:00',2.4),('1444','2013-10-02','13:35:00',2.39),('1444','2013-10-02','13:40:00',2.37),('1444','2013-10-02','13:45:00',2.35),('1444','2013-10-02','13:50:00',2.33),('1444','2013-10-02','13:55:00',2.32),('1444','2013-10-02','14:00:00',2.3),('1444','2013-10-02','14:05:00',2.29),('1444','2013-10-02','14:10:00',2.27),('1444','2013-10-02','14:15:00',2.24),('1444','2013-10-02','14:20:00',2.22),('1444','2013-10-02','14:25:00',2.19),('1444','2013-10-02','14:30:00',2.17),('1444','2013-10-02','14:35:00',2.15),('1444','2013-10-02','14:40:00',2.12),('1444','2013-10-02','14:45:00',2.09),('1444','2013-10-02','14:50:00',2.06),('1444','2013-10-02','14:55:00',2.03),('1444','2013-10-02','15:00:00',1.99),('1444','2013-10-02','15:05:00',1.95),('1444','2013-10-02','15:10:00',1.92),('1444','2013-10-02','15:15:00',1.88),('1444','2013-10-02','15:20:00',1.83),('1444','2013-10-02','15:25:00',1.79),('1444','2013-10-02','15:30:00',1.74),('1444','2013-10-02','15:35:00',1.7),('1444','2013-10-02','15:40:00',1.65),('1444','2013-10-02','15:45:00',1.6),('1444','2013-10-02','15:50:00',1.57),('1444','2013-10-02','15:55:00',1.52),('1444','2013-10-02','16:00:00',1.47),('1444','2013-10-02','16:05:00',1.42),('1444','2013-10-02','16:10:00',1.36),('1444','2013-10-02','16:15:00',1.3),('1444','2013-10-02','16:20:00',1.25),('1444','2013-10-02','16:25:00',1.2),('1444','2013-10-02','16:30:00',1.14),('1444','2013-10-02','16:35:00',1.09),('1444','2013-10-02','16:40:00',1.04),('1444','2013-10-01','09:10:00',1.02),('1444','2013-10-01','09:15:00',1.07),('1444','2013-10-01','09:20:00',1.12),('1444','2013-10-01','09:25:00',1.18),('1444','2013-10-01','09:30:00',1.22),('1444','2013-10-01','09:35:00',1.28),('1444','2013-10-01','09:40:00',1.33),('1444','2013-10-01','09:45:00',1.37),('1444','2013-10-01','09:50:00',1.42),('1444','2013-10-01','09:55:00',1.46),('1444','2013-10-01','10:00:00',1.51),('1444','2013-10-01','10:05:00',1.56),('1444','2013-10-01','10:10:00',1.6),('1444','2013-10-01','10:15:00',1.65),('1444','2013-10-01','10:20:00',1.7),('1444','2013-10-01','10:25:00',1.64),('1444','2013-10-01','10:30:00',1.8),('1444','2013-10-01','10:35:00',1.85),('1444','2013-10-01','10:40:00',1.85),('1444','2013-10-01','10:45:00',1.91),('1444','2013-10-01','10:50:00',1.8),('1444','2013-10-01','10:55:00',1.83),('1444','2013-10-01','11:00:00',1.91),('1444','2013-10-01','11:10:00',1.2),('1444','2013-10-01','11:15:00',2.17),('1444','2013-10-01','11:20:00',1.05),('1444','2013-10-01','11:35:00',2.37),('1444','2013-10-01','11:40:00',2.39),('1444','2013-10-01','11:45:00',2.39),('1444','2013-10-01','11:50:00',1.41),('1444','2013-10-01','12:10:00',1.94),('1444','2013-10-01','12:15:00',2.1),('1444','2013-10-01','12:20:00',2.22),('1444','2013-10-01','12:25:00',2.6),('1444','2013-10-01','12:30:00',2.39),('1444','2013-10-01','12:55:00',1.4),('1444','2013-10-01','13:00:00',2.62),('1444','2013-10-01','13:05:00',1.34),('1444','2013-10-01','13:10:00',1.03),('1444','2013-10-01','13:15:00',1.32),('1444','2013-10-01','13:20:00',2.66),('1444','2013-10-01','13:25:00',2.66),('1444','2013-10-01','13:30:00',2.63),('1444','2013-10-01','13:35:00',2.59),('1444','2013-10-01','13:40:00',2.53),('1444','2013-10-01','13:45:00',2.02),('1444','2013-10-01','13:50:00',2.28),('1444','2013-10-01','13:55:00',2.33),('1444','2013-10-01','14:00:00',2.24),('1444','2013-10-01','14:05:00',2.25),('1444','2013-10-01','14:10:00',2.19),('1444','2013-10-01','14:15:00',2.19),('1444','2013-10-01','14:20:00',2.18),('1444','2013-10-01','14:25:00',2.12),('1444','2013-10-01','14:30:00',2.14),('1444','2013-10-01','14:35:00',2.13),('1444','2013-10-01','14:40:00',2.11),('1444','2013-10-01','14:45:00',2.14),('1444','2013-10-01','14:50:00',2.13),('1444','2013-10-01','14:55:00',2.07),('1444','2013-10-01','15:00:00',2),('1444','2013-10-01','15:05:00',1.95),('1444','2013-10-01','15:10:00',1.9),('1444','2013-10-01','15:15:00',1.87),('1444','2013-10-01','15:20:00',1.83),('1444','2013-10-01','15:25:00',1.79),('1444','2013-10-01','15:30:00',1.76),('1444','2013-10-01','15:35:00',1.72),('1444','2013-10-01','15:40:00',1.67),('1444','2013-10-01','15:45:00',1.61),('1444','2013-10-01','15:50:00',1.56),('1444','2013-10-01','15:55:00',1.51),('1444','2013-10-01','16:00:00',1.46),('1444','2013-10-01','16:05:00',1.41),('1444','2013-10-01','16:10:00',1.37),('1444','2013-10-01','16:15:00',1.32),('1444','2013-10-01','16:20:00',1.26),('1444','2013-10-01','16:25:00',1.21),('1444','2013-10-01','16:30:00',1.16),('1444','2013-10-01','16:35:00',1.1),('1444','2013-10-01','16:40:00',1.04),('1444','2013-09-30','10:35:00',1.08),('1444','2013-09-30','10:40:00',1.44),('1444','2013-09-30','10:45:00',2.11),('1444','2013-09-30','10:50:00',2.11),('1444','2013-09-30','10:55:00',1.91),('1444','2013-09-30','11:00:00',1.55),('1444','2013-09-30','11:10:00',1.75),('1444','2013-09-30','11:15:00',2.09),('1444','2013-09-30','11:20:00',2.26),('1444','2013-09-30','11:25:00',1.52),('1444','2013-09-30','11:30:00',1.91),('1444','2013-09-30','11:35:00',1.51),('1444','2013-09-30','11:40:00',2.65),('1444','2013-09-30','11:45:00',1.15),('1444','2013-09-30','11:50:00',1.07),('1444','2013-09-30','12:00:00',1.31),('1444','2013-09-30','12:15:00',2.55),('1444','2013-09-30','12:20:00',2.55),('1444','2013-09-30','12:25:00',2.54),('1444','2013-09-30','12:30:00',2.5),('1444','2013-09-30','12:35:00',2.36),('1444','2013-09-30','12:40:00',2.07),('1444','2013-09-30','12:45:00',1.69),('1444','2013-09-30','12:50:00',2.61),('1444','2013-09-30','12:55:00',2.55),('1444','2013-09-30','13:00:00',2.58),('1444','2013-09-30','13:05:00',2.62),('1444','2013-09-30','13:10:00',2.59),('1444','2013-09-30','13:15:00',2.76),('1444','2013-09-30','13:20:00',2.78),('1444','2013-09-30','13:25:00',2.87),('1444','2013-09-30','13:30:00',2.72),('1444','2013-09-30','13:35:00',2.38),('1444','2013-09-30','13:40:00',2.6),('1444','2013-09-30','13:45:00',1.26),('1444','2013-09-30','13:50:00',1.72),('1444','2013-09-30','13:55:00',1.81),('1444','2013-09-30','14:00:00',1.54),('1444','2013-09-30','14:30:00',2.01),('1444','2013-09-30','14:35:00',1.69),('1444','2013-09-30','14:40:00',2.35),('1444','2013-09-30','14:45:00',2.66),('1444','2013-09-30','14:50:00',1.43),('1444','2013-09-30','14:55:00',1.81),('1444','2013-09-30','15:00:00',1.46),('1444','2013-09-30','15:05:00',1.65),('1444','2013-09-30','15:10:00',2.48),('1444','2013-09-30','15:15:00',2.28),('1444','2013-09-30','15:20:00',1.67),('1444','2013-09-30','15:25:00',1.87),('1444','2013-09-30','15:30:00',1.92),('1444','2013-09-30','15:35:00',2.24),('1444','2013-09-30','15:40:00',2.05),('1444','2013-09-30','15:45:00',1.19),('1444','2013-09-30','16:15:00',1.01),('1444','2013-09-30','16:20:00',1.27),('1444','2013-09-30','16:45:00',1.07),('1444','2013-09-29','10:05:00',1.1),('1444','2013-09-29','10:10:00',1.29),('1444','2013-09-29','10:15:00',1.62),('1444','2013-09-29','10:20:00',1.39),('1444','2013-09-29','10:25:00',1.29),('1444','2013-09-29','10:30:00',1.45),('1444','2013-09-29','10:35:00',1.5),('1444','2013-09-29','10:40:00',1.35),('1444','2013-09-29','10:45:00',1.64),('1444','2013-09-29','10:50:00',1.8),('1444','2013-09-29','10:55:00',1.79),('1444','2013-09-29','11:00:00',1.81),('1444','2013-09-29','11:05:00',1.75),('1444','2013-09-29','11:10:00',1.75),('1444','2013-09-29','11:15:00',1.9),('1444','2013-09-29','11:20:00',1.86),('1444','2013-09-29','11:25:00',1.76),('1444','2013-09-29','11:30:00',1.92),('1444','2013-09-29','11:35:00',1.9),('1444','2013-09-29','11:40:00',1.99),('1444','2013-09-29','11:45:00',2.04),('1444','2013-09-29','11:50:00',2.13),('1444','2013-09-29','11:55:00',2.12),('1444','2013-09-29','12:00:00',1.88),('1444','2013-09-29','12:05:00',1.23),('1444','2013-09-29','12:10:00',2.23),('1444','2013-09-29','12:15:00',2.4),('1444','2013-09-29','12:20:00',1.22),('1444','2013-09-29','12:25:00',1.16),('1444','2013-09-29','12:30:00',1.28),('1444','2013-09-29','12:35:00',1.24),('1444','2013-09-29','12:40:00',1.1),('1444','2013-09-29','13:25:00',1),('1444','2013-09-29','13:30:00',1.14),('1444','2013-09-29','13:35:00',1.32),('1444','2013-09-29','13:40:00',1.15),('1444','2013-09-29','13:45:00',1.05),('1444','2013-09-29','13:50:00',1.2),('1444','2013-09-29','13:55:00',1.36),('1444','2013-09-29','14:00:00',1.25),('1444','2013-09-29','14:05:00',1.42),('1444','2013-09-29','14:15:00',1.14),('1444','2013-09-29','14:20:00',2.01),('1444','2013-09-29','14:25:00',1.04),('1444','2013-09-29','14:30:00',1.23),('1444','2014-04-14','08:20:00',1.06),('1444','2014-04-14','08:25:00',1.13),('1444','2014-04-14','08:30:00',1.19),('1444','2014-04-14','08:35:00',1.26),('1444','2014-04-14','08:40:00',1.33),('1444','2014-04-14','08:45:00',1.39),('1444','2014-04-14','08:50:00',1.46),('1444','2014-04-14','08:55:00',1.52),('1444','2014-04-14','09:00:00',1.6),('1444','2014-04-14','09:05:00',1.66),('1444','2014-04-14','09:10:00',1.72),('1444','2014-04-14','09:15:00',1.77),('1444','2014-04-14','09:20:00',1.83),('1444','2014-04-14','09:25:00',1.89),('1444','2014-04-14','09:30:00',1.96),('1444','2014-04-14','09:35:00',2.01),('1444','2014-04-14','09:40:00',2.06),('1444','2014-04-14','09:45:00',2.12),('1444','2014-04-14','09:50:00',2.19),('1444','2014-04-14','09:55:00',2.25),('1444','2014-04-14','10:00:00',2.29),('1444','2014-04-14','10:05:00',2.34),('1444','2014-04-14','10:10:00',2.4),('1444','2014-04-14','10:15:00',2.45),('1444','2014-04-14','10:20:00',2.5),('1444','2014-04-14','10:25:00',2.55),('1444','2014-04-14','10:30:00',2.59),('1444','2014-04-14','10:35:00',2.63),('1444','2014-04-14','10:40:00',2.67),('1444','2014-04-14','10:45:00',2.71),('1444','2014-04-14','10:50:00',2.73),('1444','2014-04-14','10:55:00',2.77),('1444','2014-04-14','11:00:00',2.8),('1444','2014-04-14','11:05:00',2.83),('1444','2014-04-14','11:10:00',2.86),('1444','2014-04-14','11:15:00',2.88),('1444','2014-04-14','11:20:00',2.91),('1444','2014-04-14','11:25:00',2.96),('1444','2014-04-14','11:30:00',2.97),('1444','2014-04-14','11:35:00',3),('1444','2014-04-14','11:40:00',3.01),('1444','2014-04-14','11:45:00',3.02),('1444','2014-04-14','11:50:00',3.04),('1444','2014-04-14','11:55:00',3.07),('1444','2014-04-14','12:00:00',3.1),('1444','2014-04-14','12:05:00',3.12),('1444','2014-04-14','12:10:00',3.12),('1444','2014-04-14','12:15:00',3.14),('1444','2014-04-14','12:20:00',3.15),('1444','2014-04-14','12:25:00',3.18),('1444','2014-04-14','12:30:00',3.19),('1444','2014-04-14','12:35:00',3.21),('1444','2014-04-14','12:40:00',3.2),('1444','2014-04-14','12:45:00',3.2),('1444','2014-04-14','12:50:00',3.22),('1444','2014-04-14','12:55:00',3.24),('1444','2014-04-14','13:00:00',3.24),('1444','2014-04-14','13:05:00',3.2),('1444','2014-04-14','13:10:00',3.21),('1444','2014-04-14','13:15:00',3.24),('1444','2014-04-14','13:20:00',3.23),('1444','2014-04-14','13:25:00',3.23),('1444','2014-04-14','13:30:00',3.23),('1444','2014-04-14','13:35:00',3.22),('1444','2014-04-14','13:40:00',3.23),('1444','2014-04-14','13:45:00',3.21),('1444','2014-04-14','13:50:00',3.2),('1444','2014-04-14','13:55:00',3.19),('1444','2014-04-14','14:00:00',3.17),('1444','2014-04-14','14:05:00',3.18),('1444','2014-04-14','14:10:00',3.17),('1444','2014-04-14','14:15:00',3.14),('1444','2014-04-14','14:20:00',3.14),('1444','2014-04-14','14:25:00',3.11),('1444','2014-04-14','14:30:00',3.08),('1444','2014-04-14','14:35:00',3.05),('1444','2014-04-14','14:40:00',3.04),('1444','2014-04-14','14:45:00',3.02),('1444','2014-04-14','14:50:00',3),('1444','2014-04-14','14:55:00',2.96),('1444','2014-04-14','15:00:00',2.93),('1444','2014-04-14','15:05:00',2.89),('1444','2014-04-14','15:10:00',2.86),('1444','2014-04-14','15:15:00',2.83),('1444','2014-04-14','15:20:00',2.8),('1444','2014-04-14','15:25:00',2.77),('1444','2014-04-14','15:30:00',2.72),('1444','2014-04-14','15:35:00',2.67),('1444','2014-04-14','15:40:00',2.63),('1444','2014-04-14','15:45:00',2.59),('1444','2014-04-14','15:50:00',2.55),('1444','2014-04-14','15:55:00',2.5),('1444','2014-04-14','16:00:00',2.45),('1444','2014-04-14','16:05:00',2.39),('1444','2014-04-14','16:10:00',2.34),('1444','2014-04-14','16:15:00',2.29),('1444','2014-04-14','16:20:00',2.24),('1444','2014-04-14','16:25:00',2.18),('1444','2014-04-14','16:30:00',2.12),('1444','2014-04-14','16:35:00',2.06),('1444','2014-04-14','16:40:00',2),('1444','2014-04-14','16:45:00',1.94),('1444','2014-04-14','16:50:00',1.88),('1444','2014-04-14','16:55:00',1.82),('1444','2014-04-14','17:00:00',1.76),('1444','2014-04-14','17:05:00',1.69),('1444','2014-04-14','17:10:00',1.62),('1444','2014-04-14','17:15:00',1.56),('1444','2014-04-14','17:20:00',1.5),('1444','2014-04-14','17:25:00',1.43),('1444','2014-04-14','17:30:00',1.36),('1444','2014-04-14','17:35:00',1.29),('1444','2014-04-14','17:40:00',1.22),('1444','2014-04-14','17:45:00',1.15),('1444','2014-04-14','17:50:00',1.08),('1444','2014-04-14','17:55:00',1.02),('1444','2013-09-28','09:15:00',1.02),('1444','2013-09-28','09:20:00',1.07),('1444','2013-09-28','09:25:00',1.13),('1444','2013-09-28','09:30:00',1.17),('1444','2013-09-28','09:35:00',1.23),('1444','2013-09-28','09:40:00',1.26),('1444','2013-09-28','09:45:00',1.31),('1444','2013-09-28','09:50:00',1.49),('1444','2013-09-28','09:55:00',1.6),('1444','2013-09-28','10:00:00',1.06),('1444','2013-09-28','10:10:00',1.35),('1444','2013-09-28','10:15:00',1.41),('1444','2013-09-28','10:20:00',1.27),('1444','2013-09-28','10:35:00',1.12),('1444','2013-09-28','10:40:00',1.89),('1444','2013-09-28','10:45:00',2.24),('1444','2013-09-28','10:50:00',2.36),('1444','2013-09-28','10:55:00',2.26),('1444','2013-09-28','11:00:00',1.8),('1444','2013-09-28','11:05:00',1.53),('1444','2013-09-28','11:10:00',2.09),('1444','2013-09-28','11:15:00',2.3),('1444','2013-09-28','11:20:00',2.38),('1444','2013-09-28','11:25:00',2.44),('1444','2013-09-28','11:30:00',2.41),('1444','2013-09-28','11:35:00',1.97),('1444','2013-09-28','11:50:00',1.87),('1444','2013-09-28','11:55:00',2.43),('1444','2013-09-28','12:00:00',2.55),('1444','2013-09-28','12:05:00',1.8),('1444','2013-09-28','12:10:00',2.27),('1444','2013-09-28','12:15:00',1.99),('1444','2013-09-28','12:20:00',1.78),('1444','2013-09-28','12:25:00',1.77),('1444','2013-09-28','12:30:00',1.55),('1444','2013-09-28','12:35:00',2.24),('1444','2013-09-28','12:40:00',2.52),('1444','2013-09-28','12:45:00',2.61),('1444','2013-09-28','12:50:00',2.68),('1444','2013-09-28','12:55:00',2.6),('1444','2013-09-28','13:00:00',1.52),('1444','2013-09-28','13:05:00',1.42),('1444','2013-09-28','13:10:00',2.73),('1444','2013-09-28','13:15:00',2.45),('1444','2013-09-28','13:20:00',2.39),('1444','2013-09-28','13:25:00',2.4),('1444','2013-09-28','13:30:00',1.52),('1444','2013-09-28','13:35:00',1.37),('1444','2013-09-28','13:40:00',1.99),('1444','2013-09-28','13:45:00',2.09),('1444','2013-09-28','13:50:00',2.61),('1444','2013-09-28','13:55:00',2.77),('1444','2013-09-28','14:00:00',2.53),('1444','2013-09-28','14:05:00',2.63),('1444','2013-09-28','14:10:00',2.6),('1444','2013-09-28','14:15:00',2.52),('1444','2013-09-28','14:20:00',2.42),('1444','2013-09-28','14:25:00',2.33),('1444','2013-09-28','14:30:00',2.29),('1444','2013-09-28','14:35:00',2.29),('1444','2013-09-28','14:40:00',2.24),('1444','2013-09-28','14:45:00',2.2),('1444','2013-09-28','14:50:00',2.09),('1444','2013-09-28','14:55:00',2.06),('1444','2013-09-28','15:00:00',2.1),('1444','2013-09-28','15:05:00',1.67),('1444','2013-09-28','15:10:00',1.99),('1444','2013-09-28','15:15:00',1.93),('1444','2013-09-28','15:20:00',1.91),('1444','2013-09-28','15:25:00',1.86),('1444','2013-09-28','15:30:00',1.78),('1444','2013-09-28','15:35:00',1.68),('1444','2013-09-28','15:40:00',1.7),('1444','2013-09-28','15:45:00',1.68),('1444','2013-09-28','15:50:00',1.6),('1444','2013-09-28','15:55:00',1.62),('1444','2013-09-28','16:00:00',1.61),('1444','2013-09-28','16:05:00',1.55),('1444','2013-09-28','16:10:00',1.47),('1444','2013-09-28','16:15:00',1.04),('1444','2013-09-28','16:20:00',1.27),('1444','2013-09-28','16:25:00',1.16),('1444','2013-09-28','16:30:00',1.09),('1444','2013-09-28','16:35:00',1.11),('1444','2013-09-28','16:40:00',1.05),('1444','2013-09-27','09:00:00',1.06),('1444','2013-09-27','09:50:00',1.07),('1444','2013-09-27','09:55:00',1.58),('1444','2013-09-27','10:00:00',1.12),('1444','2013-09-27','10:05:00',1.41),('1444','2013-09-27','10:10:00',1.2),('1444','2013-09-27','10:15:00',1.09),('1444','2013-09-27','10:20:00',1.1),('1444','2013-09-27','10:25:00',1.07),('1444','2013-09-27','10:30:00',1.03),('1444','2013-09-27','10:55:00',1.04),('1444','2013-09-27','11:00:00',1.12),('1444','2013-09-27','11:10:00',1.76),('1444','2013-09-27','11:15:00',1.52),('1444','2013-09-27','11:20:00',2.08),('1444','2013-09-27','11:25:00',2.21),('1444','2013-09-27','11:30:00',1.06),('1444','2013-09-27','11:55:00',1.38),('1444','2013-09-27','12:00:00',2.58),('1444','2013-09-27','12:05:00',1.78),('1444','2013-09-27','12:10:00',2.27),('1444','2013-09-27','12:50:00',1.68),('1444','2013-09-27','12:55:00',2.05),('1444','2013-09-27','13:00:00',2.35),('1444','2013-09-27','13:05:00',2.55),('1444','2013-09-27','13:10:00',2.16),('1444','2013-09-27','13:15:00',1.21),('1444','2013-09-27','13:20:00',1.06),('1444','2013-09-27','13:50:00',1.47),('1444','2013-09-27','13:55:00',1.59),('1444','2013-09-27','14:00:00',2.4),('1444','2013-09-27','14:05:00',1.97),('1444','2013-09-27','14:10:00',2.33),('1444','2013-09-27','14:15:00',2.35),('1444','2013-09-27','14:20:00',2.29),('1444','2013-09-27','14:25:00',1.79),('1444','2013-09-27','14:30:00',2.17),('1444','2013-09-27','14:35:00',1.98),('1444','2013-09-27','14:40:00',2.04),('1444','2013-09-27','14:45:00',2.1),('1444','2013-09-27','14:50:00',1.86),('1444','2013-09-27','14:55:00',2.1),('1444','2013-09-27','15:00:00',2.05),('1444','2013-09-27','15:05:00',1.55),('1444','2013-09-27','15:10:00',1.92),('1444','2013-09-27','15:15:00',1.88),('1444','2013-09-27','15:20:00',1.9),('1444','2013-09-27','15:25:00',1.87),('1444','2013-09-27','15:30:00',1.31),('1444','2013-09-27','15:35:00',1.77),('1444','2013-09-27','15:40:00',1.54),('1444','2013-09-27','15:45:00',1.76),('1444','2013-09-27','15:50:00',1.72),('1444','2013-09-27','15:55:00',1.55),('1444','2013-09-27','16:00:00',1.5),('1444','2013-09-27','16:05:00',1.02),('1444','2013-09-27','16:10:00',1.17),('1444','2013-09-27','16:15:00',1.25),('1444','2013-09-27','16:20:00',1.26),('1444','2013-09-27','16:25:00',1.26),('1444','2013-09-27','16:35:00',1.15),('1444','2013-09-27','16:40:00',1.1),('1444','2013-09-27','16:45:00',1.06),('1444','2013-09-26','09:05:00',1.02),('1444','2013-09-26','09:10:00',1.07),('1444','2013-09-26','09:15:00',1.11),('1444','2013-09-26','09:20:00',1.17),('1444','2013-09-26','09:25:00',1.21),('1444','2013-09-26','09:30:00',1.26),('1444','2013-09-26','09:35:00',1.32),('1444','2013-09-26','09:40:00',1.38),('1444','2013-09-26','09:45:00',1.42),('1444','2013-09-26','09:50:00',1.47),('1444','2013-09-26','09:55:00',1.49),('1444','2013-09-26','10:00:00',1.56),('1444','2013-09-26','10:05:00',1.6),('1444','2013-09-26','10:10:00',1.64),('1444','2013-09-26','10:15:00',1.67),('1444','2013-09-26','10:20:00',1.71),('1444','2013-09-26','10:25:00',1.73),('1444','2013-09-26','10:30:00',1.78),('1444','2013-09-26','10:35:00',1.83),('1444','2013-09-26','10:40:00',1.63),('1444','2013-09-26','10:45:00',1.85),('1444','2013-09-26','10:50:00',1.91),('1444','2013-09-26','10:55:00',1.9),('1444','2013-09-26','11:00:00',1.95),('1444','2013-09-26','11:05:00',1.57),('1444','2013-09-26','11:10:00',2.06),('1444','2013-09-26','11:15:00',2.05),('1444','2013-09-26','11:20:00',2.03),('1444','2013-09-26','11:25:00',2.01),('1444','2013-09-26','11:30:00',2.1),('1444','2013-09-26','11:35:00',2.17),('1444','2013-09-26','11:40:00',2.12),('1444','2013-09-26','11:45:00',2.19),('1444','2013-09-26','11:50:00',1.97),('1444','2013-09-26','11:55:00',2.22),('1444','2013-09-26','12:00:00',2.34),('1444','2013-09-26','12:05:00',2.66),('1444','2013-09-26','12:10:00',1.36),('1444','2013-09-26','12:15:00',1.21),('1444','2013-09-26','12:20:00',1.43),('1444','2013-09-26','12:35:00',1.09),('1444','2013-09-26','12:40:00',1.08),('1444','2013-09-26','12:45:00',1.08),('1444','2013-09-26','12:50:00',1.1),('1444','2013-09-26','12:55:00',2.43),('1444','2013-09-26','13:00:00',1.21),('1444','2013-09-26','13:05:00',1.24),('1444','2013-09-26','13:10:00',1.95),('1444','2013-09-26','13:15:00',2.23),('1444','2013-09-26','13:20:00',1.53),('1444','2013-09-26','13:25:00',1.57),('1444','2013-09-26','13:30:00',1.8),('1444','2013-09-26','13:35:00',1.6),('1444','2013-09-26','13:40:00',1.03),('1444','2013-09-26','13:45:00',1.4),('1444','2013-09-26','13:50:00',2.35),('1444','2013-09-26','13:55:00',1.21),('1444','2013-09-26','14:00:00',2.18),('1444','2013-09-26','14:05:00',2.62),('1444','2013-09-26','14:10:00',1.39),('1444','2013-09-26','14:30:00',1.29),('1444','2013-09-26','14:40:00',1.38),('1444','2013-09-26','14:45:00',2.55),('1444','2013-09-26','14:50:00',2.52),('1444','2013-09-26','14:55:00',2.2),('1444','2013-09-26','15:00:00',1.13),('1444','2013-09-26','15:05:00',2.16),('1444','2013-09-26','15:20:00',1.87),('1444','2013-09-26','15:35:00',1.91),('1444','2013-09-26','15:50:00',1.12),('1444','2013-09-26','15:55:00',1.58),('1444','2013-09-26','16:00:00',1.05),('1444','2013-09-26','16:10:00',1.16),('1444','2013-09-26','16:15:00',1.3),('1444','2013-09-26','16:20:00',1.33),('1444','2013-09-26','16:25:00',1.31),('1444','2013-09-26','16:30:00',1.23),('1444','2013-09-26','16:35:00',1.17),('1444','2013-09-26','16:40:00',1.11),('1444','2013-09-26','16:45:00',1.05),('1444','2013-09-25','09:35:00',1.51),('1444','2013-09-25','09:50:00',1.61),('1444','2013-09-25','09:55:00',1.11),('1444','2013-09-25','10:20:00',1.11),('1444','2013-09-25','10:40:00',1.07),('1444','2013-09-25','10:45:00',2.4),('1444','2013-09-25','10:50:00',2.07),('1444','2013-09-25','10:55:00',2.19),('1444','2013-09-25','11:00:00',1.66),('1444','2013-09-25','11:05:00',1.17),('1444','2013-09-25','11:10:00',1.59),('1444','2013-09-25','11:15:00',1.4),('1444','2013-09-25','11:20:00',2.23),('1444','2013-09-25','11:25:00',2.24),('1444','2013-09-25','11:30:00',2.31),('1444','2013-09-25','11:35:00',2.38),('1444','2013-09-25','11:40:00',2.47),('1444','2013-09-25','11:45:00',1.75),('1444','2013-09-25','12:10:00',2.23),('1444','2013-09-25','12:15:00',2.03),('1444','2013-09-25','12:30:00',2.45),('1444','2013-09-25','12:35:00',2.27),('1444','2013-09-25','13:10:00',1.04),('1444','2013-09-25','13:15:00',2.8),('1444','2013-09-25','13:20:00',2.82),('1444','2013-09-25','13:25:00',2.96),('1444','2013-09-25','13:30:00',2.91),('1444','2013-09-25','13:35:00',2.88),('1444','2013-09-25','13:40:00',2.83),('1444','2013-09-25','13:45:00',2.8),('1444','2013-09-25','13:50:00',1.64),('1444','2013-09-25','14:20:00',1.53),('1444','2013-09-25','14:25:00',1.95),('1444','2013-09-25','14:30:00',2.64),('1444','2013-09-25','14:35:00',2.6),('1444','2013-09-25','14:40:00',2.17),('1444','2013-09-25','14:45:00',1.76),('1444','2013-09-25','14:50:00',2.29),('1444','2013-09-25','14:55:00',1.74),('1444','2013-09-25','15:00:00',1.79),('1444','2013-09-25','15:05:00',2.24),('1444','2013-09-25','15:10:00',2.11),('1444','2013-09-25','15:15:00',2.06),('1444','2013-09-25','15:20:00',1.59),('1444','2013-09-25','15:25:00',1.93),('1444','2013-09-25','15:30:00',1.91),('1444','2013-09-25','15:35:00',2.06),('1444','2013-09-25','15:40:00',1.92),('1444','2013-09-25','15:45:00',1.76),('1444','2013-09-25','15:50:00',1.79),('1444','2013-09-25','15:55:00',1.74),('1444','2013-09-25','16:00:00',1.69),('1444','2013-09-25','16:05:00',1.59),('1444','2013-09-25','16:10:00',1.56),('1444','2013-09-25','16:15:00',1.5),('1444','2013-09-25','16:20:00',1.43),('1444','2013-09-25','16:25:00',1.39),('1444','2013-09-25','16:30:00',1.34),('1444','2013-09-25','16:35:00',1.15),('1444','2013-09-25','16:40:00',1.19),('1444','2013-09-25','16:45:00',1.14),('1444','2013-09-25','16:50:00',1.08),('1444','2013-09-25','16:55:00',1.03),('1444','2013-09-24','09:00:00',1.03),('1444','2013-09-24','09:05:00',1.09),('1444','2013-09-24','09:10:00',1.14),('1444','2013-09-24','09:15:00',1.2),('1444','2013-09-24','09:20:00',1.25),('1444','2013-09-24','09:25:00',1.32),('1444','2013-09-24','09:30:00',1.37),('1444','2013-09-24','09:35:00',1.43),('1444','2013-09-24','09:40:00',1.46),('1444','2013-09-24','09:45:00',1.52),('1444','2013-09-24','09:50:00',1.57),('1444','2013-09-24','09:55:00',1.61),('1444','2013-09-24','10:00:00',1.66),('1444','2013-09-24','10:05:00',1.72),('1444','2013-09-24','10:10:00',1.77),('1444','2013-09-24','10:15:00',1.81),('1444','2013-09-24','10:20:00',1.86),('1444','2013-09-24','10:25:00',1.9),('1444','2013-09-24','10:30:00',1.94),('1444','2013-09-24','10:35:00',1.97),('1444','2013-09-24','10:40:00',2.01),('1444','2013-09-24','10:45:00',2.04),('1444','2013-09-24','10:50:00',2.08),('1444','2013-09-24','10:55:00',2.1),('1444','2013-09-24','11:00:00',2.14),('1444','2013-09-24','11:05:00',2.15),('1444','2013-09-24','11:10:00',2.16),('1444','2013-09-24','11:15:00',2.19),('1444','2013-09-24','11:20:00',2.23),('1444','2013-09-24','11:25:00',2.25),('1444','2013-09-24','11:30:00',2.28),('1444','2013-09-24','11:35:00',2.28),('1444','2013-09-24','11:40:00',2.29),('1444','2013-09-24','11:45:00',2.31),('1444','2013-09-24','11:50:00',2.33),('1444','2013-09-24','11:55:00',2.34),('1444','2013-09-24','12:00:00',2.37),('1444','2013-09-24','12:05:00',2.39),('1444','2013-09-24','12:10:00',2.38),('1444','2013-09-24','12:15:00',2.35),('1444','2013-09-24','12:20:00',2.36),('1444','2013-09-24','12:25:00',2.39),('1444','2013-09-24','12:30:00',2.42),('1444','2013-09-24','12:35:00',2.45),('1444','2013-09-24','12:40:00',2.46),('1444','2013-09-24','12:45:00',2.43),('1444','2013-09-24','12:50:00',2.42),('1444','2013-09-24','12:55:00',2.43),('1444','2013-09-24','13:00:00',2.47),('1444','2013-09-24','13:05:00',2.46),('1444','2013-09-24','13:10:00',2.47),('1444','2013-09-24','13:15:00',2.45),('1444','2013-09-24','13:20:00',2.45),('1444','2013-09-24','13:25:00',2.42),('1444','2013-09-24','13:30:00',2.44),('1444','2013-09-24','13:35:00',2.45),('1444','2013-09-24','13:40:00',2.46),('1444','2013-09-24','13:45:00',2.42),('1444','2013-09-24','13:50:00',2.4),('1444','2013-09-24','13:55:00',2.39),('1444','2013-09-24','14:00:00',2.37),('1444','2013-09-24','14:05:00',2.35),('1444','2013-09-24','14:10:00',2.35),('1444','2013-09-24','14:15:00',2.33),('1444','2013-09-24','14:20:00',2.3),('1444','2013-09-24','14:25:00',2.3),('1444','2013-09-24','14:30:00',2.25),('1444','2013-09-24','14:35:00',2.23),('1444','2013-09-24','14:40:00',2.21),('1444','2013-09-24','14:45:00',2.18),('1444','2013-09-24','14:50:00',2.15),('1444','2013-09-24','14:55:00',2.12),('1444','2013-09-24','15:00:00',2.09),('1444','2013-09-24','15:05:00',2.06),('1444','2013-09-24','15:10:00',2),('1444','2013-09-24','15:15:00',2.01),('1444','2013-09-24','15:20:00',1.98),('1444','2013-09-24','15:25:00',1.94),('1444','2013-09-24','15:30:00',1.9),('1444','2013-09-24','15:35:00',1.86),('1444','2013-09-24','15:40:00',1.81),('1444','2013-09-24','15:45:00',1.78),('1444','2013-09-24','15:50:00',1.73),('1444','2013-09-24','15:55:00',1.69),('1444','2013-09-24','16:00:00',1.64),('1444','2013-09-24','16:05:00',1.58),('1444','2013-09-24','16:10:00',1.54),('1444','2013-09-24','16:15:00',1.49),('1444','2013-09-24','16:20:00',1.46),('1444','2013-09-24','16:25:00',1.39),('1444','2013-09-24','16:30:00',1.32),('1444','2013-09-24','16:35:00',1.28),('1444','2013-09-24','16:40:00',1.22),('1444','2013-09-24','16:45:00',1.18),('1444','2013-09-24','16:50:00',1.12),('1444','2013-09-24','16:55:00',1.07),('1444','2013-09-24','17:00:00',1),('1444','2013-09-23','08:55:00',1.01),('1444','2013-09-23','09:00:00',1.07),('1444','2013-09-23','09:05:00',1.12),('1444','2013-09-23','09:10:00',1.18),('1444','2013-09-23','09:15:00',1.24),('1444','2013-09-23','09:20:00',1.3),('1444','2013-09-23','09:25:00',1.35),('1444','2013-09-23','09:30:00',1.4),('1444','2013-09-23','09:35:00',1.46),('1444','2013-09-23','09:40:00',1.52),('1444','2013-09-23','09:45:00',1.56),('1444','2013-09-23','09:50:00',1.61),('1444','2013-09-23','09:55:00',1.66),('1444','2013-09-23','10:00:00',1.71),('1444','2013-09-23','10:05:00',1.76),('1444','2013-09-23','10:10:00',1.8),('1444','2013-09-23','10:15:00',1.85),('1444','2013-09-23','10:20:00',1.89),('1444','2013-09-23','10:25:00',1.94),('1444','2013-09-23','10:30:00',1.98),('1444','2013-09-23','10:35:00',2.01),('1444','2013-09-23','10:40:00',2.06),('1444','2013-09-23','10:45:00',2.09),('1444','2013-09-23','10:50:00',2.12),('1444','2013-09-23','10:55:00',2.12),('1444','2013-09-23','11:00:00',2.19),('1444','2013-09-23','11:05:00',2.21),('1444','2013-09-23','11:10:00',2.25),('1444','2013-09-23','11:15:00',2.28),('1444','2013-09-23','11:20:00',2.33),('1444','2013-09-23','11:25:00',2.35),('1444','2013-09-23','11:30:00',2.38),('1444','2013-09-23','11:35:00',2.39),('1444','2013-09-23','11:40:00',2.43),('1444','2013-09-23','11:45:00',2.45),('1444','2013-09-23','11:50:00',2.46),('1444','2013-09-23','11:55:00',2.5),('1444','2013-09-23','12:00:00',2.5),('1444','2013-09-23','12:05:00',2.51),('1444','2013-09-23','12:10:00',2.53),('1444','2013-09-23','12:15:00',2.54),('1444','2013-09-23','12:20:00',2.54),('1444','2013-09-23','12:25:00',2.57),('1444','2013-09-23','12:30:00',2.59),('1444','2013-09-23','12:35:00',2.58),('1444','2013-09-23','12:40:00',2.56),('1444','2013-09-23','12:45:00',2.56),('1444','2013-09-23','12:50:00',2.57),('1444','2013-09-23','12:55:00',2.56),('1444','2013-09-23','13:00:00',2.57),('1444','2013-09-23','13:05:00',2.55),('1444','2013-09-23','13:10:00',2.54),('1444','2013-09-23','13:15:00',2.51),('1444','2013-09-23','13:20:00',2.49),('1444','2013-09-23','13:25:00',2.46),('1444','2013-09-23','13:30:00',2.46),('1444','2013-09-23','13:35:00',2.5),('1444','2013-09-23','13:40:00',2.49),('1444','2013-09-23','13:45:00',2.49),('1444','2013-09-23','13:50:00',2.46),('1444','2013-09-23','13:55:00',2.46),('1444','2013-09-23','14:00:00',2.41),('1444','2013-09-23','14:05:00',2.37),('1444','2013-09-23','14:10:00',2.33),('1444','2013-09-23','14:15:00',2.38),('1444','2013-09-23','14:20:00',2.35),('1444','2013-09-23','14:25:00',2.33),('1444','2013-09-23','14:30:00',2.33),('1444','2013-09-23','14:35:00',2.28),('1444','2013-09-23','14:40:00',1.99),('1444','2013-09-23','14:45:00',2.2),('1444','2013-09-23','14:50:00',2.18),('1444','2013-09-23','14:55:00',1.92),('1444','2013-09-23','15:00:00',2.15),('1444','2013-09-23','15:05:00',2.17),('1444','2013-09-23','15:10:00',1.37),('1444','2013-09-23','15:15:00',1.12),('1444','2013-09-23','15:20:00',1.75),('1444','2013-09-23','15:25:00',1.08),('1444','2013-09-23','15:30:00',1.93),('1444','2013-09-23','15:35:00',1.78),('1444','2013-09-23','15:40:00',1.86),('1444','2013-09-23','15:45:00',1.82),('1444','2013-09-23','15:50:00',1.76),('1444','2013-09-23','15:55:00',1.7),('1444','2013-09-23','16:00:00',1.64),('1444','2013-09-23','16:05:00',1.59),('1444','2013-09-23','16:10:00',1.56),('1444','2013-09-23','16:15:00',1.32),('1444','2013-09-23','16:20:00',1.42),('1444','2013-09-23','16:25:00',1.37),('1444','2013-09-23','16:30:00',1.33),('1444','2013-09-23','16:35:00',1.25),('1444','2013-09-23','16:40:00',1.19),('1444','2013-09-23','16:45:00',1.14),('1444','2013-09-23','16:50:00',1.09),('1444','2013-09-23','16:55:00',1.03),('1444','2013-09-22','09:00:00',1.05),('1444','2013-09-22','09:05:00',1.11),('1444','2013-09-22','09:10:00',1.17),('1444','2013-09-22','09:15:00',1.23),('1444','2013-09-22','09:20:00',1.29),('1444','2013-09-22','09:25:00',1.35),('1444','2013-09-22','09:30:00',1.41),('1444','2013-09-22','09:35:00',1.47),('1444','2013-09-22','09:40:00',1.51),('1444','2013-09-22','09:45:00',1.56),('1444','2013-09-22','09:50:00',1.61),('1444','2013-09-22','09:55:00',1.66),('1444','2013-09-22','10:00:00',1.72),('1444','2013-09-22','10:05:00',1.76),('1444','2013-09-22','10:10:00',1.82),('1444','2013-09-22','10:15:00',1.87),('1444','2013-09-22','10:20:00',1.92),('1444','2013-09-22','10:25:00',1.96),('1444','2013-09-22','10:30:00',2),('1444','2013-09-22','10:35:00',2.05),('1444','2013-09-22','10:40:00',2.08),('1444','2013-09-22','10:45:00',2.12),('1444','2013-09-22','10:50:00',2.15),('1444','2013-09-22','10:55:00',2.18),('1444','2013-09-22','11:00:00',2.21),('1444','2013-09-22','11:05:00',2.23),('1444','2013-09-22','11:10:00',2.25),('1444','2013-09-22','11:15:00',2.3),('1444','2013-09-22','11:20:00',2.33),('1444','2013-09-22','11:25:00',2.35),('1444','2013-09-22','11:30:00',2.38),('1444','2013-09-22','11:35:00',2.42),('1444','2013-09-22','11:40:00',2.45),('1444','2013-09-22','11:45:00',2.49),('1444','2013-09-22','11:50:00',2.51),('1444','2013-09-22','11:55:00',2.53),('1444','2013-09-22','12:00:00',2.55),('1444','2013-09-22','12:05:00',2.57),('1444','2013-09-22','12:10:00',2.58),('1444','2013-09-22','12:15:00',2.58),('1444','2013-09-22','12:20:00',2.6),('1444','2013-09-22','12:25:00',2.63),('1444','2013-09-22','12:30:00',2.63),('1444','2013-09-22','12:35:00',2.62),('1444','2013-09-22','12:40:00',2.63),('1444','2013-09-22','12:45:00',2.64),('1444','2013-09-22','12:50:00',2.67),('1444','2013-09-22','12:55:00',2.69),('1444','2013-09-22','13:00:00',2.66),('1444','2013-09-22','13:05:00',2.64),('1444','2013-09-22','13:10:00',2.65),('1444','2013-09-22','13:15:00',2.63),('1444','2013-09-22','13:20:00',2.61),('1444','2013-09-22','13:25:00',2.59),('1444','2013-09-22','13:30:00',2.36),('1444','2013-09-22','13:35:00',2.59),('1444','2013-09-22','13:40:00',2.56),('1444','2013-09-22','13:45:00',2.56),('1444','2013-09-22','13:50:00',2.57),('1444','2013-09-22','13:55:00',2.55),('1444','2013-09-22','14:00:00',2.52),('1444','2013-09-22','14:05:00',2.52),('1444','2013-09-22','14:10:00',2.44),('1444','2013-09-22','14:15:00',2.51),('1444','2013-09-22','14:20:00',2.56),('1444','2013-09-22','14:25:00',2.68),('1444','2013-09-22','14:35:00',1.85),('1444','2013-09-22','14:40:00',2.47),('1444','2013-09-22','14:45:00',2.19),('1444','2013-09-22','14:50:00',2.3),('1444','2013-09-22','14:55:00',2.27),('1444','2013-09-22','15:00:00',2.3),('1444','2013-09-22','15:05:00',2.34),('1444','2013-09-22','15:10:00',2.28),('1444','2013-09-22','15:15:00',2.36),('1444','2013-09-22','15:20:00',2.53),('1444','2013-09-22','15:25:00',1.77),('1444','2013-09-22','15:30:00',1.13),('1444','2013-09-22','15:40:00',1.89),('1444','2013-09-22','15:45:00',1.97),('1444','2013-09-22','15:50:00',1.85),('1444','2013-09-22','15:55:00',1.84),('1444','2013-09-22','16:00:00',1.95),('1444','2013-09-22','16:05:00',2.08),('1444','2013-09-22','16:10:00',2.11),('1444','2013-09-22','16:15:00',1.97),('1444','2013-09-22','16:20:00',1.39),('1444','2013-09-22','16:25:00',1.08),('1444','2013-09-22','16:30:00',1.06),('1444','2013-09-22','16:35:00',1.02),('1444','2013-09-22','16:45:00',1.02),('1444','2013-09-22','16:50:00',1.68),('1444','2013-09-22','17:00:00',1.24),('1444','2013-09-22','17:05:00',1.2),('1444','2013-09-22','17:10:00',1.14),('1444','2013-09-21','09:00:00',1.04),('1444','2013-09-21','09:05:00',1.1),('1444','2013-09-21','09:10:00',1.16),('1444','2013-09-21','09:15:00',1.21),('1444','2013-09-21','09:20:00',1.26),('1444','2013-09-21','09:25:00',1.32),('1444','2013-09-21','09:30:00',1.37),('1444','2013-09-21','09:35:00',1.43),('1444','2013-09-21','09:40:00',1.46),('1444','2013-09-21','09:45:00',1.53),('1444','2013-09-21','09:50:00',1.58),('1444','2013-09-21','09:55:00',1.62),('1444','2013-09-21','10:00:00',1.65),('1444','2013-09-21','10:05:00',1.72),('1444','2013-09-21','10:10:00',1.77),('1444','2013-09-21','10:15:00',1.81),('1444','2013-09-21','10:20:00',1.85),('1444','2013-09-21','10:25:00',1.9),('1444','2013-09-21','10:30:00',1.95),('1444','2013-09-21','10:35:00',2),('1444','2013-09-21','10:40:00',2.03),('1444','2013-09-21','10:45:00',2.07),('1444','2013-09-21','10:50:00',2.1),('1444','2013-09-21','10:55:00',2.14),('1444','2013-09-21','11:00:00',2.18),('1444','2013-09-21','11:05:00',2.18),('1444','2013-09-21','11:10:00',2.21),('1444','2013-09-21','11:15:00',2.24),('1444','2013-09-21','11:20:00',2.28),('1444','2013-09-21','11:25:00',2.3),('1444','2013-09-21','11:30:00',2.33),('1444','2013-09-21','11:35:00',2.36),('1444','2013-09-21','11:40:00',2.41),('1444','2013-09-21','11:45:00',2.42),('1444','2013-09-21','11:50:00',2.45),('1444','2013-09-21','11:55:00',2.43),('1444','2013-09-21','12:00:00',2.46),('1444','2013-09-21','12:05:00',2.5),('1444','2013-09-21','12:10:00',2.5),('1444','2013-09-21','12:15:00',2.53),('1444','2013-09-21','12:20:00',2.41),('1444','2013-09-21','12:25:00',2.4),('1444','2013-09-21','12:30:00',2.59),('1444','2013-09-21','12:35:00',2.52),('1444','2013-09-21','12:40:00',2.45),('1444','2013-09-21','12:45:00',2.5),('1444','2013-09-21','12:50:00',2.52),('1444','2013-09-21','12:55:00',2.59),('1444','2013-09-21','13:00:00',2.59),('1444','2013-09-21','13:05:00',2.52),('1444','2013-09-21','13:10:00',2.55),('1444','2013-09-21','13:15:00',2.63),('1444','2013-09-21','13:20:00',2.25),('1444','2013-09-21','13:25:00',2.5),('1444','2013-09-21','13:30:00',2.49),('1444','2013-09-21','13:35:00',2.39),('1444','2013-09-21','13:40:00',2.27),('1444','2013-09-21','13:45:00',2.23),('1444','2013-09-21','13:50:00',2.12),('1444','2013-09-21','13:55:00',2.1),('1444','2013-09-21','14:00:00',2.32),('1444','2013-09-21','14:05:00',2.4),('1444','2013-09-21','14:10:00',2.36),('1444','2013-09-21','14:15:00',2.42),('1444','2013-09-21','14:20:00',2.39),('1444','2013-09-21','14:25:00',2.37),('1444','2013-09-21','14:30:00',2.33),('1444','2013-09-21','14:35:00',2.3),('1444','2013-09-21','14:40:00',2.27),('1444','2013-09-21','14:45:00',2.24),('1444','2013-09-21','14:50:00',2.21),('1444','2013-09-21','14:55:00',2.17),('1444','2013-09-21','15:00:00',2.15),('1444','2013-09-21','15:05:00',2.12),('1444','2013-09-21','15:10:00',2.07),('1444','2013-09-21','15:15:00',2.01),('1444','2013-09-21','15:20:00',2.01),('1444','2013-09-21','15:25:00',1.97),('1444','2013-09-21','15:30:00',1.92),('1444','2013-09-21','15:35:00',1.89),('1444','2013-09-21','15:40:00',1.76),('1444','2013-09-21','15:45:00',1.35),('1444','2013-09-21','15:50:00',1.77),('1444','2013-09-21','15:55:00',1.63),('1444','2013-09-21','16:00:00',1.21),('1444','2013-09-21','16:20:00',1.05),('1444','2013-09-20','09:55:00',1.2),('1444','2013-09-20','10:00:00',1.35),('1444','2013-09-20','10:05:00',1.26),('1444','2013-09-20','10:10:00',1.79),('1444','2013-09-20','10:15:00',2.14),('1444','2013-09-20','10:20:00',2.37),('1444','2013-09-20','10:25:00',2.27),('1444','2013-09-20','10:30:00',2.68),('1444','2013-09-20','10:35:00',2.41),('1444','2013-09-20','10:40:00',2.68),('1444','2013-09-20','10:45:00',1.98),('1444','2013-09-20','10:50:00',1.8),('1444','2013-09-20','10:55:00',1.4),('1444','2013-09-20','11:00:00',1.32),('1444','2013-09-20','11:05:00',1.46),('1444','2013-09-20','11:10:00',1.78),('1444','2013-09-20','11:15:00',1.77),('1444','2013-09-20','11:20:00',1.51),('1444','2013-09-20','11:25:00',1.45),('1444','2013-09-20','11:30:00',2.42),('1444','2013-09-20','11:35:00',1.76),('1444','2013-09-20','11:40:00',2.77),('1444','2013-09-20','11:45:00',2.71),('1444','2013-09-20','11:50:00',2.59),('1444','2013-09-20','11:55:00',2.52),('1444','2013-09-20','12:00:00',2.5),('1444','2013-09-20','12:05:00',2.53),('1444','2013-09-20','12:10:00',2.56),('1444','2013-09-20','12:15:00',2.63),('1444','2013-09-20','12:20:00',2.71),('1444','2013-09-20','12:25:00',2.36),('1444','2013-09-20','12:30:00',1.9),('1444','2013-09-20','12:35:00',2.09),('1444','2013-09-20','12:40:00',1.59),('1444','2013-09-20','12:45:00',1.39),('1444','2013-09-20','12:50:00',2.76),('1444','2013-09-20','12:55:00',2.67),('1444','2013-09-20','13:00:00',2.63),('1444','2013-09-20','13:05:00',2.58),('1444','2013-09-20','13:10:00',2.15),('1444','2013-09-20','13:15:00',1.9),('1444','2013-09-20','13:20:00',1.74),('1444','2013-09-20','13:25:00',1.84),('1444','2013-09-20','13:30:00',2.7),('1444','2013-09-20','13:35:00',2.65),('1444','2013-09-20','13:40:00',2.56),('1444','2013-09-20','13:45:00',2.57),('1444','2013-09-20','13:50:00',2.37),('1444','2013-09-20','13:55:00',1.9),('1444','2013-09-20','14:10:00',1.22),('1444','2013-09-20','14:15:00',2.62),('1444','2013-09-20','14:20:00',1.71),('1444','2013-09-20','14:25:00',1.67),('1444','2013-09-20','14:30:00',2.35),('1444','2013-09-20','14:35:00',2.18),('1444','2013-09-20','14:40:00',2.23),('1444','2013-09-20','14:45:00',2.43),('1444','2013-09-20','14:50:00',2.36),('1444','2013-09-20','14:55:00',2.33),('1444','2013-09-20','15:00:00',1.6),('1444','2013-09-20','15:05:00',2.46),('1444','2013-09-20','15:10:00',1.74),('1444','2013-09-20','15:15:00',1.59),('1444','2013-09-20','15:20:00',1.64),('1444','2013-09-20','15:25:00',1.25),('1444','2013-09-20','15:30:00',1.3),('1444','2013-09-20','15:35:00',1.97),('1444','2013-09-20','15:40:00',2.08),('1444','2013-09-20','15:45:00',1.97),('1444','2013-09-20','15:50:00',1.94),('1444','2013-09-20','15:55:00',1.96),('1444','2013-09-20','16:00:00',2.1),('1444','2013-09-20','16:05:00',1.39),('1444','2013-09-20','16:10:00',1.08),('1444','2013-09-20','16:15:00',1.35),('1444','2013-09-20','16:20:00',1.34),('1444','2013-09-20','16:25:00',1.66),('1444','2013-09-20','16:45:00',1.27),('1444','2013-09-20','16:50:00',1.61),('1444','2013-09-20','16:55:00',1.2),('1444','2013-09-20','17:00:00',1.13),('1444','2013-09-20','17:05:00',1.41),('1444','2013-09-20','17:10:00',1.47),('1444','2013-09-20','17:15:00',1.39),('1444','2013-09-20','17:20:00',1.38),('1444','2013-09-20','17:25:00',1.18),('1444','2013-09-19','09:10:00',1.14),('1444','2013-09-19','09:15:00',1.26),('1444','2013-09-19','10:05:00',1.93),('1444','2013-09-19','10:30:00',1.05),('1444','2013-09-19','10:35:00',2.62),('1444','2013-09-19','10:40:00',2.02),('1444','2013-09-19','10:45:00',1.76),('1444','2013-09-19','10:55:00',2.53),('1444','2013-09-19','11:00:00',2.65),('1444','2013-09-19','11:05:00',2.26),('1444','2013-09-19','11:10:00',1.98),('1444','2013-09-19','11:15:00',1.19),('1444','2013-09-19','11:20:00',1.45),('1444','2013-09-19','11:25:00',1.56),('1444','2013-09-19','11:30:00',2),('1444','2013-09-19','11:35:00',1.91),('1444','2013-09-19','11:40:00',1.39),('1444','2013-09-19','11:45:00',2.24),('1444','2013-09-19','11:50:00',2.74),('1444','2013-09-19','11:55:00',1.28),('1444','2013-09-19','12:00:00',1.12),('1444','2013-09-19','12:05:00',1.16),('1444','2013-09-19','12:10:00',2.23),('1444','2013-09-19','12:15:00',1.5),('1444','2013-09-19','12:20:00',2.4),('1444','2013-09-19','12:25:00',2.42),('1444','2013-09-19','12:30:00',2.79),('1444','2013-09-19','12:35:00',2.72),('1444','2013-09-19','12:40:00',2.86),('1444','2013-09-19','12:45:00',2.41),('1444','2013-09-19','12:50:00',2.82),('1444','2013-09-19','12:55:00',2.79),('1444','2013-09-19','13:00:00',2.78),('1444','2013-09-19','13:05:00',2.83),('1444','2013-09-19','13:10:00',2.95),('1444','2013-09-19','13:15:00',2.93),('1444','2013-09-19','13:20:00',2.94),('1444','2013-09-19','13:25:00',2.86),('1444','2013-09-19','13:30:00',2.71),('1444','2013-09-19','13:35:00',2.77),('1444','2013-09-19','13:40:00',2.92),('1444','2013-09-19','13:45:00',2.99),('1444','2013-09-19','13:50:00',2.52),('1444','2013-09-19','14:00:00',1.72),('1444','2013-09-19','14:05:00',2.81),('1444','2013-09-19','14:10:00',2.43),('1444','2013-09-19','14:15:00',2.34),('1444','2013-09-19','14:20:00',2.51),('1444','2013-09-19','14:25:00',2.47),('1444','2013-09-19','14:30:00',2.44),('1444','2013-09-19','14:35:00',2.43),('1444','2013-09-19','14:40:00',2.21),('1444','2013-09-19','14:45:00',2.33),('1444','2013-09-19','14:50:00',2.31),('1444','2013-09-19','14:55:00',2.35),('1444','2013-09-19','15:00:00',2.33),('1444','2013-09-19','15:05:00',2.23),('1444','2013-09-19','15:10:00',2.22),('1444','2013-09-19','15:15:00',1.74),('1444','2013-09-19','15:20:00',2.22),('1444','2013-09-19','15:25:00',2.2),('1444','2013-09-19','15:30:00',2.12),('1444','2013-09-19','15:35:00',2.07),('1444','2013-09-19','15:40:00',2.16),('1444','2013-09-19','15:45:00',2.04),('1444','2013-09-19','15:50:00',1.61),('1444','2013-09-19','15:55:00',1.72),('1444','2013-09-19','16:00:00',1.77),('1444','2013-09-19','16:05:00',1.73),('1444','2013-09-19','16:10:00',1.69),('1444','2013-09-19','16:15:00',1.57),('1444','2013-09-19','16:20:00',1.67),('1444','2013-09-19','16:25:00',1.54),('1444','2013-09-19','16:30:00',1.35),('1444','2013-09-19','16:35:00',1.3),('1444','2013-09-19','16:40:00',1.21),('1444','2013-09-19','16:45:00',1.27),('1444','2013-09-19','16:50:00',1.35),('1444','2013-09-19','16:55:00',1.26),('1444','2013-09-19','17:00:00',1.01),('1444','2013-09-19','17:05:00',1.03),('1444','2014-04-13','09:10:00',1.2),('1444','2014-04-13','09:15:00',1.01),('1444','2014-04-13','09:20:00',1.05),('1444','2014-04-13','09:25:00',1.17),('1444','2014-04-13','09:30:00',1.51),('1444','2014-04-13','09:35:00',1.32),('1444','2014-04-13','09:40:00',1.63),('1444','2014-04-13','09:45:00',1.57),('1444','2014-04-13','09:50:00',1.1),('1444','2014-04-13','09:55:00',1.14),('1444','2014-04-13','10:00:00',1.86),('1444','2014-04-13','10:05:00',2.66),('1444','2014-04-13','10:10:00',2.1),('1444','2014-04-13','10:15:00',1.88),('1444','2014-04-13','10:20:00',2),('1444','2014-04-13','10:25:00',1.44),('1444','2014-04-13','10:30:00',2.37),('1444','2014-04-13','10:35:00',2.63),('1444','2014-04-13','10:40:00',2.51),('1444','2014-04-13','10:45:00',2.75),('1444','2014-04-13','10:50:00',2.54),('1444','2014-04-13','10:55:00',2.78),('1444','2014-04-13','11:00:00',2.8),('1444','2014-04-13','11:05:00',2.89),('1444','2014-04-13','11:10:00',2.83),('1444','2014-04-13','11:15:00',2.96),('1444','2014-04-13','11:20:00',3.51),('1444','2014-04-13','11:25:00',2.36),('1444','2014-04-13','11:30:00',1.69),('1444','2014-04-13','11:35:00',2.62),('1444','2014-04-13','11:40:00',3.19),('1444','2014-04-13','11:45:00',2.73),('1444','2014-04-13','11:50:00',3.06),('1444','2014-04-13','11:55:00',2.41),('1444','2014-04-13','12:00:00',1.62),('1444','2014-04-13','12:05:00',1.36),('1444','2014-04-13','12:10:00',1.2),('1444','2014-04-13','12:15:00',1.15),('1444','2014-04-13','12:20:00',1.07),('1444','2014-04-13','13:05:00',1.02),('1444','2014-04-13','13:10:00',1.55),('1444','2014-04-13','13:15:00',1.59),('1444','2014-04-13','13:20:00',1.99),('1444','2014-04-13','13:25:00',2.33),('1444','2014-04-13','13:30:00',3.43),('1444','2014-04-13','13:35:00',3.11),('1444','2014-04-13','13:40:00',2.86),('1444','2014-04-13','13:45:00',1.63),('1444','2014-04-13','13:50:00',2.34),('1444','2014-04-13','13:55:00',2.04),('1444','2014-04-13','14:00:00',3.21),('1444','2014-04-13','14:05:00',3.01),('1444','2014-04-13','14:10:00',2.94),('1444','2014-04-13','14:15:00',3.41),('1444','2014-04-13','14:20:00',1.58),('1444','2014-04-13','14:25:00',1.34),('1444','2014-04-13','14:30:00',1.42),('1444','2014-04-13','14:35:00',1.28),('1444','2014-04-13','14:40:00',1.09),('1444','2014-04-13','14:45:00',1.82),('1444','2014-04-13','14:50:00',2.7),('1444','2014-04-13','14:55:00',2.72),('1444','2014-04-13','15:00:00',2.28),('1444','2014-04-13','15:05:00',2.85),('1444','2014-04-13','15:10:00',2.93),('1444','2014-04-13','15:15:00',2.49),('1444','2014-04-13','15:20:00',2.43),('1444','2014-04-13','15:25:00',2.68),('1444','2014-04-13','15:30:00',2.54),('1444','2014-04-13','15:35:00',1.7),('1444','2014-04-13','15:40:00',1.12),('1444','2014-04-13','15:45:00',1.07),('1444','2014-04-13','15:50:00',1.44),('1444','2014-04-13','15:55:00',1.37),('1444','2014-04-13','16:00:00',2.51),('1444','2014-04-13','16:05:00',2.25),('1444','2014-04-13','16:10:00',1.01),('1444','2014-04-13','16:20:00',1.02),('1444','2014-04-13','16:25:00',1.47),('1444','2014-04-13','16:30:00',1.22),('1444','2014-04-13','16:35:00',1.13),('1444','2014-04-13','16:40:00',1.6),('1444','2014-04-13','16:45:00',2.21),('1444','2014-04-13','16:50:00',1.89),('1444','2014-04-13','16:55:00',1.9),('1444','2014-04-13','17:00:00',1.33),('1444','2014-04-13','17:05:00',1.2),('1444','2014-04-13','17:20:00',1.19),('1444','2014-04-13','17:25:00',1.08),('1444','2013-09-18','09:00:00',1.17),('1444','2013-09-18','09:15:00',1.23),('1444','2013-09-18','09:20:00',1.56),('1444','2013-09-18','09:30:00',1.18),('1444','2013-09-18','09:35:00',1.14),('1444','2013-09-18','09:55:00',1.49),('1444','2013-09-18','10:00:00',1.83),('1444','2013-09-18','10:05:00',2.04),('1444','2013-09-18','10:10:00',1.9),('1444','2013-09-18','10:15:00',1.85),('1444','2013-09-18','10:20:00',1.89),('1444','2013-09-18','10:25:00',1.92),('1444','2013-09-18','10:30:00',1.96),('1444','2013-09-18','10:35:00',1.99),('1444','2013-09-18','10:40:00',2.02),('1444','2013-09-18','10:45:00',2.07),('1444','2013-09-18','10:50:00',2.13),('1444','2013-09-18','10:55:00',2.25),('1444','2013-09-18','11:00:00',2.28),('1444','2013-09-18','11:05:00',2.32),('1444','2013-09-18','11:10:00',1.7),('1444','2013-09-18','11:15:00',1.14),('1444','2013-09-18','11:20:00',2.34),('1444','2013-09-18','11:25:00',2.63),('1444','2013-09-18','11:30:00',2.37),('1444','2013-09-18','11:35:00',1.54),('1444','2013-09-18','11:40:00',2.07),('1444','2013-09-18','11:45:00',2.56),('1444','2013-09-18','11:50:00',2.54),('1444','2013-09-18','11:55:00',2.48),('1444','2013-09-18','12:00:00',2.59),('1444','2013-09-18','12:05:00',2.66),('1444','2013-09-18','12:10:00',2.67),('1444','2013-09-18','12:15:00',2.73),('1444','2013-09-18','12:20:00',2.77),('1444','2013-09-18','12:25:00',1.3),('1444','2013-09-18','12:30:00',2.02),('1444','2013-09-18','12:35:00',3.03),('1444','2013-09-18','12:40:00',2.34),('1444','2013-09-18','12:45:00',2.75),('1444','2013-09-18','12:50:00',1.75),('1444','2013-09-18','12:55:00',1.24),('1444','2013-09-18','13:00:00',1.02),('1444','2013-09-18','13:05:00',2.9),('1444','2013-09-18','13:10:00',2.81),('1444','2013-09-18','13:15:00',2.74),('1444','2013-09-18','13:20:00',2.71),('1444','2013-09-18','13:25:00',2.74),('1444','2013-09-18','13:30:00',2.7),('1444','2013-09-18','13:35:00',2.7),('1444','2013-09-18','13:40:00',2.74),('1444','2013-09-18','13:45:00',2.78),('1444','2013-09-18','13:50:00',2.83),('1444','2013-09-18','13:55:00',2.74),('1444','2013-09-18','14:00:00',2.08),('1444','2013-09-18','14:05:00',1.74),('1444','2013-09-18','14:10:00',2.61),('1444','2013-09-18','14:15:00',2.58),('1444','2013-09-18','14:20:00',2.54),('1444','2013-09-18','14:25:00',2.5),('1444','2013-09-18','14:30:00',2.37),('1444','2013-09-18','14:35:00',2.39),('1444','2013-09-18','14:40:00',2.43),('1444','2013-09-18','14:45:00',2.27),('1444','2013-09-18','14:50:00',2.36),('1444','2013-09-18','14:55:00',1.82),('1444','2013-09-18','15:00:00',1.82),('1444','2013-09-18','15:05:00',1.4),('1444','2013-09-18','15:10:00',1.05),('1444','2013-09-18','15:15:00',1.88),('1444','2013-09-18','15:20:00',1.59),('1444','2013-09-18','15:25:00',2.16),('1444','2013-09-18','15:30:00',1.94),('1444','2013-09-18','15:35:00',1.74),('1444','2013-09-18','15:40:00',2.05),('1444','2013-09-18','15:45:00',1.96),('1444','2013-09-18','15:50:00',1.42),('1444','2013-09-18','15:55:00',1.86),('1444','2013-09-18','16:00:00',1.95),('1444','2013-09-18','16:05:00',1.95),('1444','2013-09-18','16:10:00',1.77),('1444','2013-09-18','16:15:00',1.69),('1444','2013-09-18','16:20:00',1.6),('1444','2013-09-18','16:25:00',1.4),('1444','2013-09-18','16:30:00',1.35),('1444','2013-09-18','16:35:00',1.24),('1444','2013-09-18','16:40:00',1.29),('1444','2013-09-18','16:45:00',1.28),('1444','2013-09-18','16:50:00',1.13),('1444','2013-09-18','16:55:00',1.1),('1444','2013-09-18','17:00:00',1.15),('1444','2013-09-18','17:05:00',1.04),('1444','2013-09-18','17:10:00',1.04),('1444','2013-09-17','09:20:00',1.05),('1444','2013-09-17','09:45:00',1.37),('1444','2013-09-17','09:55:00',1.42),('1444','2013-09-17','10:00:00',1.56),('1444','2013-09-17','10:05:00',1.13),('1444','2013-09-17','10:10:00',1.17),('1444','2013-09-17','10:20:00',1.16),('1444','2013-09-17','10:25:00',1.73),('1444','2013-09-17','10:30:00',2.1),('1444','2013-09-17','10:35:00',1.13),('1444','2013-09-17','10:40:00',1.13),('1444','2013-09-17','10:45:00',1.69),('1444','2013-09-17','10:50:00',2.47),('1444','2013-09-17','10:55:00',2.01),('1444','2013-09-17','11:00:00',1.67),('1444','2013-09-17','11:05:00',1.71),('1444','2013-09-17','11:10:00',2.44),('1444','2013-09-17','11:15:00',2),('1444','2013-09-17','11:20:00',1.7),('1444','2013-09-17','11:25:00',1.17),('1444','2013-09-17','11:30:00',1.36),('1444','2013-09-17','11:35:00',2.18),('1444','2013-09-17','11:40:00',2.13),('1444','2013-09-17','11:45:00',1.97),('1444','2013-09-17','11:50:00',2.54),('1444','2013-09-17','11:55:00',2.36),('1444','2013-09-17','12:00:00',2.29),('1444','2013-09-17','12:05:00',2.18),('1444','2013-09-17','12:10:00',1.3),('1444','2013-09-17','12:15:00',1.29),('1444','2013-09-17','12:20:00',1.5),('1444','2013-09-17','12:25:00',2.83),('1444','2013-09-17','12:30:00',1.73),('1444','2013-09-17','12:35:00',1.84),('1444','2013-09-17','12:40:00',2.3),('1444','2013-09-17','12:45:00',3.16),('1444','2013-09-17','12:50:00',2.13),('1444','2013-09-17','12:55:00',2.17),('1444','2013-09-17','13:00:00',1.39),('1444','2013-09-17','13:10:00',2.08),('1444','2013-09-17','13:15:00',1.81),('1444','2013-09-17','13:20:00',1.67),('1444','2013-09-17','13:25:00',1.46),('1444','2013-09-17','13:30:00',1.07),('1444','2013-09-17','13:35:00',1.74),('1444','2013-09-17','13:40:00',1.63),('1444','2013-09-17','13:55:00',1.17),('1444','2013-09-17','14:00:00',1.3),('1444','2013-09-17','14:25:00',1.34),('1444','2013-09-17','14:50:00',1.39),('1444','2013-09-17','14:55:00',2.47),('1444','2013-09-17','15:00:00',2.09),('1444','2013-09-17','15:05:00',1.89),('1444','2013-09-17','15:10:00',1.62),('1444','2013-09-17','15:15:00',2.11),('1444','2013-09-17','15:20:00',2.06),('1444','2013-09-17','15:25:00',1.82),('1444','2013-09-17','15:30:00',1.85),('1444','2013-09-17','15:50:00',1.18),('1444','2013-09-17','15:55:00',1.36),('1444','2013-09-17','16:05:00',1.4),('1444','2013-09-17','16:10:00',1.2),('1444','2013-09-17','16:15:00',1.08),('1444','2013-09-17','16:45:00',1.09),('1444','2013-09-17','17:00:00',1.07),('1444','2013-09-17','17:05:00',1.19),('1444','2013-09-17','17:10:00',1.1),('1444','2013-09-17','17:15:00',1.08),('1444','2013-09-16','09:05:00',1.35),('1444','2013-09-16','09:10:00',1.01),('1444','2013-09-16','09:15:00',1.35),('1444','2013-09-16','09:20:00',1.38),('1444','2013-09-16','09:25:00',1.43),('1444','2013-09-16','09:35:00',1.52),('1444','2013-09-16','09:40:00',1.56),('1444','2013-09-16','09:45:00',1.64),('1444','2013-09-16','09:50:00',1.34),('1444','2013-09-16','09:55:00',1.78),('1444','2013-09-16','10:00:00',1.82),('1444','2013-09-16','10:05:00',1.96),('1444','2013-09-16','10:10:00',1.09),('1444','2013-09-16','10:15:00',1.21),('1444','2013-09-16','10:20:00',1.51),('1444','2013-09-16','10:25:00',1.92),('1444','2013-09-16','10:30:00',1.98),('1444','2013-09-16','10:35:00',2.33),('1444','2013-09-16','10:40:00',2.47),('1444','2013-09-16','10:45:00',2.69),('1444','2013-09-16','10:50:00',1.76),('1444','2013-09-16','10:55:00',1.32),('1444','2013-09-16','11:00:00',1.52),('1444','2013-09-16','11:05:00',1.45),('1444','2013-09-16','11:25:00',2.2),('1444','2013-09-16','11:30:00',1.04),('1444','2013-09-16','11:35:00',2.66),('1444','2013-09-16','11:40:00',2.67),('1444','2013-09-16','11:45:00',2.52),('1444','2013-09-16','11:50:00',2.69),('1444','2013-09-16','11:55:00',2.67),('1444','2013-09-16','12:00:00',2.75),('1444','2013-09-16','12:05:00',1.91),('1444','2013-09-16','12:10:00',2.59),('1444','2013-09-16','12:15:00',1.58),('1444','2013-09-16','12:20:00',2.78),('1444','2013-09-16','12:25:00',2.73),('1444','2013-09-16','12:30:00',2.7),('1444','2013-09-16','12:35:00',2.73),('1444','2013-09-16','12:40:00',2.85),('1444','2013-09-16','12:45:00',3.03),('1444','2013-09-16','12:50:00',3.28),('1444','2013-09-16','12:55:00',3.38),('1444','2013-09-16','13:00:00',3.35),('1444','2013-09-16','13:05:00',1.87),('1444','2013-09-16','13:10:00',3.01),('1444','2013-09-16','13:15:00',2.78),('1444','2013-09-16','13:20:00',2.72),('1444','2013-09-16','13:25:00',2.71),('1444','2013-09-16','13:30:00',2.68),('1444','2013-09-16','13:35:00',2.69),('1444','2013-09-16','13:40:00',2.68),('1444','2013-09-16','13:45:00',2.68),('1444','2013-09-16','13:50:00',2.7),('1444','2013-09-16','13:55:00',2.72),('1444','2013-09-16','14:00:00',2.69),('1444','2013-09-16','14:05:00',2.59),('1444','2013-09-16','14:10:00',2.56),('1444','2013-09-16','14:15:00',2.54),('1444','2013-09-16','14:20:00',2.5),('1444','2013-09-16','14:25:00',2.5),('1444','2013-09-16','14:30:00',2.47),('1444','2013-09-16','14:35:00',2.45),('1444','2013-09-16','14:40:00',2.42),('1444','2013-09-16','14:45:00',2.39),('1444','2013-09-16','14:50:00',2.38),('1444','2013-09-16','14:55:00',2.28),('1444','2013-09-16','15:00:00',2.32),('1444','2013-09-16','15:05:00',2.28),('1444','2013-09-16','15:10:00',2.25),('1444','2013-09-16','15:15:00',2.22),('1444','2013-09-16','15:20:00',2.17),('1444','2013-09-16','15:25:00',2.14),('1444','2013-09-16','15:30:00',2.09),('1444','2013-09-16','15:35:00',2.07),('1444','2013-09-16','15:40:00',2.04),('1444','2013-09-16','15:45:00',1.99),('1444','2013-09-16','15:50:00',1.95),('1444','2013-09-16','15:55:00',1.91),('1444','2013-09-16','16:00:00',1.84),('1444','2013-09-16','16:05:00',1.91),('1444','2013-09-16','16:10:00',1.8),('1444','2013-09-16','16:15:00',1.71),('1444','2013-09-16','16:20:00',1.65),('1444','2013-09-16','16:25:00',1.6),('1444','2013-09-16','16:30:00',1.55),('1444','2013-09-16','16:35:00',1.49),('1444','2013-09-16','16:40:00',1.45),('1444','2013-09-16','16:45:00',1.38),('1444','2013-09-16','16:50:00',1.33),('1444','2013-09-16','16:55:00',1.28),('1444','2013-09-16','17:00:00',1.22),('1444','2013-09-16','17:05:00',1.16),('1444','2013-09-16','17:10:00',1.09),('1444','2013-09-16','17:15:00',1.03),('1444','2013-09-15','08:45:00',1.02),('1444','2013-09-15','08:50:00',1.04),('1444','2013-09-15','08:55:00',1.01),('1444','2013-09-15','09:00:00',1.1),('1444','2013-09-15','09:05:00',1.12),('1444','2013-09-15','09:10:00',1.25),('1444','2013-09-15','09:15:00',1.36),('1444','2013-09-15','09:20:00',1.32),('1444','2013-09-15','09:25:00',1.41),('1444','2013-09-15','09:30:00',1.43),('1444','2013-09-15','09:35:00',1.54),('1444','2013-09-15','09:40:00',1.59),('1444','2013-09-15','09:45:00',1.62),('1444','2013-09-15','09:50:00',1.65),('1444','2013-09-15','09:55:00',1.73),('1444','2013-09-15','10:00:00',1.8),('1444','2013-09-15','10:05:00',1.86),('1444','2013-09-15','10:10:00',1.89),('1444','2013-09-15','10:15:00',1.88),('1444','2013-09-15','10:20:00',1.91),('1444','2013-09-15','10:25:00',1.94),('1444','2013-09-15','10:30:00',1.88),('1444','2013-09-15','10:55:00',2.28),('1444','2013-09-15','11:00:00',2.55),('1444','2013-09-15','11:05:00',2.22),('1444','2013-09-15','11:10:00',1.08),('1444','2013-09-15','11:20:00',1.15),('1444','2013-09-15','11:30:00',1.79),('1444','2013-09-15','11:35:00',1.35),('1444','2013-09-15','11:40:00',1.08),('1444','2013-09-15','11:45:00',1.67),('1444','2013-09-15','11:50:00',1.18),('1444','2013-09-15','11:55:00',1.18),('1444','2013-09-15','12:20:00',1.19),('1444','2013-09-15','12:25:00',1.25),('1444','2013-09-15','12:30:00',1.16),('1444','2013-09-15','12:35:00',1.07),('1444','2013-09-15','12:40:00',1.09),('1444','2013-09-15','12:50:00',1.11),('1444','2013-09-15','13:45:00',1.31),('1444','2013-09-15','13:50:00',1.16),('1444','2013-09-15','14:00:00',1.4),('1444','2013-09-15','14:05:00',1.27),('1444','2013-09-15','14:10:00',1.09),('1444','2013-09-15','14:15:00',1.08),('1444','2013-09-15','14:20:00',1.05),('1444','2013-09-15','14:25:00',1.02),('1444','2013-09-15','15:10:00',1.01),('1444','2013-09-15','15:15:00',2.09),('1444','2013-09-15','15:20:00',1.45),('1444','2013-09-15','15:25:00',1.08),('1444','2013-09-14','08:50:00',1.03),('1444','2013-09-14','08:55:00',1.09),('1444','2013-09-14','09:00:00',1.14),('1444','2013-09-14','09:05:00',1.2),('1444','2013-09-14','09:10:00',1.26),('1444','2013-09-14','09:15:00',1.32),('1444','2013-09-14','09:20:00',1.37),('1444','2013-09-14','09:25:00',1.43),('1444','2013-09-14','09:30:00',1.49),('1444','2013-09-14','09:35:00',1.52),('1444','2013-09-14','09:40:00',1.58),('1444','2013-09-14','09:45:00',1.61),('1444','2013-09-14','09:50:00',1.67),('1444','2013-09-14','10:00:00',1.78),('1444','2013-09-14','10:05:00',1.79),('1444','2013-09-14','10:10:00',1.68),('1444','2013-09-14','10:15:00',1.7),('1444','2013-09-14','10:20:00',1.85),('1444','2013-09-14','10:25:00',1.97),('1444','2013-09-14','10:30:00',2.02),('1444','2013-09-14','10:35:00',2.18),('1444','2013-09-14','10:40:00',2.18),('1444','2013-09-14','10:45:00',1.94),('1444','2013-09-14','10:50:00',2.13),('1444','2013-09-14','10:55:00',1.88),('1444','2013-09-14','11:00:00',2.1),('1444','2013-09-14','11:05:00',1.35),('1444','2013-09-14','11:10:00',1.64),('1444','2013-09-14','11:20:00',1.31),('1444','2013-09-14','11:25:00',2.48),('1444','2013-09-14','11:30:00',2.19),('1444','2013-09-14','11:35:00',1.63),('1444','2013-09-14','11:40:00',2.51),('1444','2013-09-14','11:45:00',2.66),('1444','2013-09-14','12:10:00',1.16),('1444','2013-09-14','12:35:00',1.77),('1444','2013-09-14','13:10:00',1.4),('1444','2013-09-14','13:15:00',2.96),('1444','2013-09-14','13:20:00',2.14),('1444','2013-09-14','13:25:00',2.97),('1444','2013-09-14','13:30:00',1.76),('1444','2013-09-14','13:35:00',1.11),('1444','2013-09-14','13:40:00',2.84),('1444','2013-09-14','13:45:00',1.52),('1444','2013-09-14','13:50:00',2.42),('1444','2013-09-14','13:55:00',2.91),('1444','2013-09-14','14:00:00',2.84),('1444','2013-09-14','14:05:00',2.66),('1444','2013-09-14','14:10:00',2.6),('1444','2013-09-14','14:15:00',2.6),('1444','2013-09-14','14:20:00',2.51),('1444','2013-09-14','14:25:00',2.57),('1444','2013-09-14','14:30:00',2.53),('1444','2013-09-14','14:35:00',2.47),('1444','2013-09-14','14:40:00',2.49),('1444','2013-09-14','14:45:00',2.43),('1444','2013-09-14','14:50:00',2.41),('1444','2013-09-14','14:55:00',2.38),('1444','2013-09-14','15:00:00',2.31),('1444','2013-09-14','15:05:00',2.28),('1444','2013-09-14','15:10:00',2.25),('1444','2013-09-14','15:15:00',2.22),('1444','2013-09-14','15:20:00',2.19),('1444','2013-09-14','15:25:00',1.4),('1444','2013-09-14','15:30:00',2.17),('1444','2013-09-14','15:35:00',2.08),('1444','2013-09-14','15:40:00',2.04),('1444','2013-09-14','15:45:00',1.98),('1444','2013-09-14','15:50:00',1.94),('1444','2013-09-14','15:55:00',1.89),('1444','2013-09-14','16:00:00',1.84),('1444','2013-09-14','16:05:00',1.79),('1444','2013-09-14','16:10:00',1.73),('1444','2013-09-14','16:15:00',1.7),('1444','2013-09-14','16:20:00',1.64),('1444','2013-09-14','16:25:00',1.61),('1444','2013-09-14','16:30:00',1.56),('1444','2013-09-14','16:35:00',1.49),('1444','2013-09-14','16:40:00',1.43),('1444','2013-09-14','16:45:00',1.39),('1444','2013-09-14','16:50:00',1.34),('1444','2013-09-14','16:55:00',1.29),('1444','2013-09-14','17:00:00',1.25),('1444','2013-09-14','17:05:00',1.18),('1444','2013-09-14','17:10:00',1.03),('1444','2013-09-14','17:20:00',1.01),('1444','2013-09-13','09:40:00',1),('1444','2013-09-13','09:50:00',1.34),('1444','2013-09-13','09:55:00',2.1),('1444','2013-09-13','10:00:00',1.24),('1444','2013-09-13','10:05:00',1.05),('1444','2013-09-13','10:10:00',1.61),('1444','2013-09-13','10:15:00',2.55),('1444','2013-09-13','10:20:00',2.18),('1444','2013-09-13','10:25:00',1.21),('1444','2013-09-13','10:30:00',1.92),('1444','2013-09-13','10:35:00',2.04),('1444','2013-09-13','10:40:00',2.12),('1444','2013-09-13','10:45:00',2.2),('1444','2013-09-13','10:50:00',2.22),('1444','2013-09-13','10:55:00',2.25),('1444','2013-09-13','11:00:00',2.29),('1444','2013-09-13','11:05:00',2.32),('1444','2013-09-13','11:10:00',2.34),('1444','2013-09-13','11:15:00',2.37),('1444','2013-09-13','11:20:00',2.42),('1444','2013-09-13','11:25:00',2.44),('1444','2013-09-13','11:30:00',2.46),('1444','2013-09-13','11:35:00',2.5),('1444','2013-09-13','11:40:00',2.51),('1444','2013-09-13','11:45:00',2.52),('1444','2013-09-13','11:50:00',2.56),('1444','2013-09-13','11:55:00',2.54),('1444','2013-09-13','12:00:00',2.58),('1444','2013-09-13','12:05:00',2.66),('1444','2013-09-13','12:10:00',2.63),('1444','2013-09-13','12:15:00',2.66),('1444','2013-09-13','12:20:00',2.69),('1444','2013-09-13','12:25:00',2.71),('1444','2013-09-13','12:30:00',2.74),('1444','2013-09-13','12:35:00',2.74),('1444','2013-09-13','12:40:00',2.78),('1444','2013-09-13','12:45:00',2.79),('1444','2013-09-13','12:50:00',2.81),('1444','2013-09-13','12:55:00',2.76),('1444','2013-09-13','13:00:00',2.74),('1444','2013-09-13','13:05:00',2.73),('1444','2013-09-13','13:10:00',2.69),('1444','2013-09-13','13:15:00',2.7),('1444','2013-09-13','13:20:00',2.69),('1444','2013-09-13','13:25:00',2.67),('1444','2013-09-13','13:30:00',2.66),('1444','2013-09-13','13:36:00',2.66),('1444','2013-09-13','13:40:00',2.64),('1444','2013-09-13','13:45:00',2.62),('1444','2013-09-13','13:50:00',2.59),('1444','2013-09-13','13:56:00',2.57),('1444','2013-09-13','14:00:00',2.55),('1444','2013-09-13','14:12:00',2.55),('1444','2013-09-13','14:15:00',2.56),('1444','2013-09-13','14:20:00',2.57),('1444','2013-09-13','14:26:00',2.2),('1444','2013-09-13','14:35:00',1.7),('1444','2013-09-13','14:47:00',2.52),('1444','2013-09-13','14:50:00',2.44),('1444','2013-09-13','14:56:00',2.4),('1444','2013-09-13','15:00:00',2.35),('1444','2013-09-13','15:05:00',2.33),('1444','2013-09-13','15:10:00',2.3),('1444','2013-09-13','15:15:00',2.25),('1444','2013-09-13','15:20:00',2.24),('1444','2013-09-13','15:25:00',2.17),('1444','2013-09-13','15:30:00',2.15),('1444','2013-09-13','15:35:00',2.11),('1444','2013-09-13','15:40:00',2.08),('1444','2013-09-13','15:45:00',2.03),('1444','2013-09-13','15:50:00',1.99),('1444','2013-09-13','15:55:00',1.94),('1444','2013-09-13','16:00:00',1.86),('1444','2013-09-13','16:05:00',1.84),('1444','2013-09-13','16:10:00',1.79),('1444','2013-09-13','16:15:00',1.74),('1444','2013-09-13','16:20:00',1.7),('1444','2013-09-13','16:25:00',1.66),('1444','2013-09-13','16:30:00',1.58),('1444','2013-09-13','16:35:00',1.52),('1444','2013-09-13','16:40:00',1.48),('1444','2013-09-13','16:45:00',1.43),('1444','2013-09-13','16:50:00',1.36),('1444','2013-09-13','16:55:00',1.31),('1444','2013-09-13','17:00:00',1.24),('1444','2013-09-13','17:05:00',1.18),('1444','2013-09-13','17:10:00',1.13),('1444','2013-09-13','17:15:00',1.07),('1444','2013-09-13','17:20:00',1.01),('1444','2013-09-12','08:30:00',1.07),('1444','2013-09-12','08:35:00',1.04),('1444','2013-09-12','09:00:00',1.12),('1444','2013-09-12','09:05:00',1.05),('1444','2013-09-12','09:15:00',1.34),('1444','2013-09-12','09:20:00',1.37),('1444','2013-09-12','09:25:00',1.46),('1444','2013-09-12','09:30:00',1.47),('1444','2013-09-12','09:35:00',1.36),('1444','2013-09-12','09:40:00',1.16),('1444','2013-09-12','09:45:00',1.57),('1444','2013-09-12','09:50:00',1.55),('1444','2013-09-12','10:05:00',1.05),('1444','2013-09-12','10:10:00',1.24),('1444','2013-09-12','10:15:00',1.3),('1444','2013-09-12','10:30:00',1.5),('1444','2013-09-12','10:35:00',1.3),('1444','2013-09-12','10:55:00',1.43),('1444','2013-09-12','11:00:00',1.68),('1444','2013-09-12','11:05:00',2.43),('1444','2013-09-12','11:10:00',1.83),('1444','2013-09-12','11:15:00',1.59),('1444','2013-09-12','11:20:00',1.33),('1444','2013-09-12','11:45:00',1.74),('1444','2013-09-12','11:50:00',1.15),('1444','2013-09-12','11:55:00',1),('1444','2013-09-12','12:00:00',2),('1444','2013-09-12','12:05:00',2.29),('1444','2013-09-12','12:10:00',1.66),('1444','2013-09-12','12:15:00',1.37),('1444','2013-09-12','12:25:00',1.15),('1444','2013-09-12','12:35:00',2.09),('1444','2013-09-12','12:40:00',1.59),('1444','2013-09-12','12:55:00',1.67),('1444','2013-09-12','13:00:00',2.48),('1444','2013-09-12','13:05:00',1.38),('1444','2013-09-12','13:10:00',2.24),('1444','2013-09-12','13:15:00',2.7),('1444','2013-09-12','13:20:00',3.1),('1444','2013-09-12','13:25:00',2.73),('1444','2013-09-12','13:30:00',2.34),('1444','2013-09-12','13:35:00',1.38),('1444','2013-09-12','13:40:00',1.8),('1444','2013-09-12','13:45:00',1.6),('1444','2013-09-12','13:50:00',2.46),('1444','2013-09-12','13:55:00',2.77),('1444','2013-09-12','14:00:00',2.19),('1444','2013-09-12','14:05:00',2.61),('1444','2013-09-12','14:10:00',2.67),('1444','2013-09-12','14:15:00',2.29),('1444','2013-09-12','14:20:00',2.66),('1444','2013-09-12','14:25:00',2.44),('1444','2013-09-12','14:30:00',2.72),('1444','2013-09-12','14:35:00',1.18),('1444','2013-09-12','14:40:00',2.33),('1444','2013-09-12','14:45:00',2.5),('1444','2013-09-12','14:50:00',2.5),('1444','2013-09-12','14:55:00',2.45),('1444','2013-09-12','15:00:00',1.85),('1444','2013-09-12','15:05:00',1.7),('1444','2013-09-12','15:10:00',2.43),('1444','2013-09-12','15:15:00',2.35),('1444','2013-09-12','15:20:00',2.25),('1444','2013-09-12','15:25:00',2.23),('1444','2013-09-12','15:30:00',2.2),('1444','2013-09-12','15:35:00',2.14),('1444','2013-09-12','15:40:00',2.12),('1444','2013-09-12','15:45:00',2.09),('1444','2013-09-12','15:50:00',2.05),('1444','2013-09-12','15:55:00',2.02),('1444','2013-09-12','16:00:00',1.95),('1444','2013-09-12','16:05:00',1.53),('1444','2013-09-12','16:10:00',1.98),('1444','2013-09-12','16:15:00',1.19),('1444','2013-09-12','16:20:00',1.63),('1444','2013-09-12','16:25:00',1.33),('1444','2013-09-12','16:30:00',1.83),('1444','2013-09-12','16:35:00',1.09),('1444','2013-09-12','16:40:00',1.81),('1444','2013-09-12','16:45:00',1.1),('1444','2013-09-12','17:00:00',1.44),('1444','2013-09-12','17:05:00',1.46),('1444','2013-09-12','17:10:00',1.28),('1444','2013-09-12','17:30:00',1.06),('1444','2013-09-11','09:00:00',1.1),('1444','2013-09-11','09:05:00',1.22),('1444','2013-09-11','09:10:00',1.16),('1444','2013-09-11','09:15:00',1.57),('1444','2013-09-11','09:20:00',1.67),('1444','2013-09-11','09:25:00',1.05),('1444','2013-09-11','09:35:00',1.6),('1444','2013-09-11','10:00:00',1.22),('1444','2013-09-11','10:05:00',1.24),('1444','2013-09-11','10:15:00',1.91),('1444','2013-09-11','10:20:00',1.09),('1444','2013-09-11','10:25:00',1.83),('1444','2013-09-11','10:30:00',2.15),('1444','2013-09-11','10:35:00',2.29),('1444','2013-09-11','10:40:00',2.01),('1444','2013-09-11','10:45:00',2.45),('1444','2013-09-11','10:50:00',1.41),('1444','2013-09-11','10:55:00',1.68),('1444','2013-09-11','11:00:00',1.02),('1444','2013-09-11','11:05:00',2.87),('1444','2013-09-11','11:10:00',2.25),('1444','2013-09-11','11:15:00',2.46),('1444','2013-09-11','11:20:00',2.34),('1444','2013-09-11','11:25:00',1.33),('1444','2013-09-11','11:40:00',2.68),('1444','2013-09-11','11:45:00',2.66),('1444','2013-09-11','11:50:00',2.67),('1444','2013-09-11','11:55:00',2.5),('1444','2013-09-11','12:00:00',2.48),('1444','2013-09-11','12:05:00',1.86),('1444','2013-09-11','12:10:00',2.31),('1444','2013-09-11','12:15:00',1.75),('1444','2013-09-11','12:20:00',2.28),('1444','2013-09-11','12:25:00',2.21),('1444','2013-09-11','12:30:00',1.32),('1444','2013-09-11','12:35:00',2.38),('1444','2013-09-11','12:40:00',2.6),('1444','2013-09-11','12:45:00',2.78),('1444','2013-09-11','12:50:00',3.01),('1444','2013-09-11','13:00:00',2.83),('1444','2013-09-11','13:05:00',2.83),('1444','2013-09-11','13:10:00',2.87),('1444','2013-09-11','13:15:00',2.94),('1444','2013-09-11','13:20:00',2.41),('1444','2013-09-11','13:25:00',2.34),('1444','2013-09-11','13:30:00',1.82),('1444','2013-09-11','13:35:00',3.12),('1444','2013-09-11','13:40:00',1.7),('1444','2013-09-11','13:45:00',2.84),('1444','2013-09-11','13:50:00',2.56),('1444','2013-09-11','13:55:00',1.9),('1444','2013-09-11','14:00:00',2.6),('1444','2013-09-11','14:05:00',2.53),('1444','2013-09-11','14:10:00',2.22),('1444','2013-09-11','14:15:00',2.54),('1444','2013-09-11','14:20:00',1.97),('1444','2013-09-11','14:25:00',1.94),('1444','2013-09-11','14:30:00',1.7),('1444','2013-09-11','14:35:00',1.55),('1444','2013-09-11','14:40:00',1.26),('1444','2013-09-11','14:45:00',2.36),('1444','2013-09-11','14:50:00',1.63),('1444','2013-09-11','14:55:00',1.75),('1444','2013-09-11','15:00:00',2.71),('1444','2013-09-11','15:05:00',1.6),('1444','2013-09-11','15:10:00',1.84),('1444','2013-09-11','15:15:00',2.56),('1444','2013-09-11','15:20:00',1.64),('1444','2013-09-11','15:25:00',1.05),('1444','2013-09-11','15:30:00',1.57),('1444','2013-09-11','15:45:00',1.97),('1444','2013-09-11','15:50:00',1.76),('1444','2013-09-11','15:55:00',2.16),('1444','2013-09-11','16:00:00',1.76),('1444','2013-09-11','16:05:00',2.1),('1444','2013-09-11','16:10:00',1.94),('1444','2013-09-11','16:15:00',1.82),('1444','2013-09-11','16:20:00',1.45),('1444','2013-09-11','16:25:00',1),('1444','2013-09-11','16:30:00',1.24),('1444','2013-09-11','16:35:00',1.32),('1444','2013-09-11','16:40:00',1.38),('1444','2013-09-11','16:45:00',1.39),('1444','2013-09-11','16:50:00',1.44),('1444','2013-09-11','16:55:00',1.04),('1444','2013-09-11','17:00:00',1.36),('1444','2013-09-11','17:05:00',1.25),('1444','2013-09-11','17:10:00',1.18),('1444','2013-09-11','17:15:00',1.1),('1444','2013-09-10','08:55:00',1.07),('1444','2013-09-10','09:00:00',1.11),('1444','2013-09-10','09:05:00',1.31),('1444','2013-09-10','09:10:00',1.53),('1444','2013-09-10','09:15:00',1.27),('1444','2013-09-10','09:20:00',1.02),('1444','2013-09-10','09:25:00',1.06),('1444','2013-09-10','09:30:00',1.79),('1444','2013-09-10','09:35:00',1.88),('1444','2013-09-10','09:40:00',1.16),('1444','2013-09-10','10:40:00',1.09),('1444','2013-09-10','10:45:00',1.4),('1444','2013-09-10','11:00:00',1.13),('1444','2013-09-10','11:55:00',1.05),('1444','2013-09-10','13:40:00',1.31),('1444','2013-09-10','13:45:00',1.9),('1444','2013-09-10','13:50:00',1.24),('1444','2013-09-10','13:55:00',1.05),('1444','2013-09-10','14:15:00',1.11),('1444','2013-09-10','14:20:00',1.1),('1444','2013-09-10','14:25:00',1.52),('1444','2013-09-10','14:30:00',1.3),('1444','2013-09-10','14:35:00',1.02),('1444','2013-09-10','14:40:00',1.24),('1444','2013-09-10','14:45:00',1.3),('1444','2013-09-10','14:50:00',1.47),('1444','2013-09-10','14:55:00',1.28),('1444','2013-09-10','15:00:00',1.77),('1444','2013-09-10','15:05:00',1.5),('1444','2013-09-10','15:10:00',1.13),('1444','2013-09-10','15:15:00',1.13),('1444','2013-09-10','15:20:00',1.33),('1444','2013-09-10','15:25:00',1.2),('1444','2013-09-10','15:30:00',1.41),('1444','2013-09-10','15:35:00',1.14),('1444','2013-09-09','10:00:00',1.09),('1444','2013-09-09','10:05:00',1.25),('1444','2013-09-09','10:10:00',1.22),('1444','2013-09-09','10:15:00',1.17),('1444','2013-09-09','10:20:00',1.15),('1444','2013-09-09','10:25:00',1.17),('1444','2013-09-09','10:30:00',1.1),('1444','2013-09-09','10:35:00',1.17),('1444','2013-09-09','10:40:00',1.22),('1444','2013-09-09','10:45:00',1.38),('1444','2013-09-09','10:50:00',1.72),('1444','2013-09-09','10:55:00',1.69),('1444','2013-09-09','11:00:00',1.86),('1444','2013-09-09','11:05:00',1.61),('1444','2013-09-09','11:10:00',1.48),('1444','2013-09-09','11:15:00',1.47),('1444','2013-09-09','11:20:00',1.55),('1444','2013-09-09','11:25:00',1.73),('1444','2013-09-09','11:30:00',1.48),('1444','2013-09-09','11:35:00',1.6),('1444','2013-09-09','11:40:00',2.13),('1444','2013-09-09','11:45:00',2.32),('1444','2013-09-09','11:50:00',2.49),('1444','2013-09-09','11:55:00',2.27),('1444','2013-09-09','12:00:00',2.05),('1444','2013-09-09','12:05:00',2.05),('1444','2013-09-09','12:10:00',1.68),('1444','2013-09-09','12:15:00',1.41),('1444','2013-09-09','12:20:00',1.01),('1444','2013-09-09','12:40:00',1.19),('1444','2013-09-09','12:45:00',1.06),('1444','2013-09-09','12:55:00',1.38),('1444','2013-09-09','13:00:00',1.32),('1444','2013-09-09','13:05:00',1.63),('1444','2013-09-09','13:10:00',1.82),('1444','2013-09-09','13:15:00',1.92),('1444','2013-09-09','13:20:00',1.85),('1444','2013-09-09','13:25:00',2.11),('1444','2013-09-09','13:30:00',2.39),('1444','2013-09-09','13:35:00',2.54),('1444','2013-09-09','13:40:00',2.14),('1444','2013-09-09','13:45:00',2.69),('1444','2013-09-09','13:50:00',2.52),('1444','2013-09-09','13:55:00',2.53),('1444','2013-09-09','14:00:00',2.4),('1444','2013-09-09','14:05:00',2.06),('1444','2013-09-09','14:10:00',2.13),('1444','2013-09-09','14:15:00',1.32),('1444','2013-09-09','14:20:00',1.24),('1444','2013-09-09','14:25:00',1.06),('1444','2013-09-09','14:30:00',2.04),('1444','2013-09-09','14:35:00',2.5),('1444','2013-09-09','14:40:00',2.21),('1444','2013-09-09','14:45:00',1.98),('1444','2013-09-09','14:50:00',2.2),('1444','2013-09-09','14:55:00',1.71),('1444','2013-09-09','15:00:00',1.55),('1444','2013-09-09','15:05:00',1.73),('1444','2013-09-09','15:10:00',1.58),('1444','2013-09-09','15:20:00',1.6),('1444','2013-09-09','15:25:00',1.02),('1444','2013-09-09','15:30:00',2.02),('1444','2013-09-09','15:35:00',1.68),('1444','2013-09-09','15:40:00',1.35),('1444','2013-09-09','15:50:00',1.03),('1444','2013-09-09','15:55:00',1.21),('1444','2013-09-09','16:00:00',1.42),('1444','2013-09-09','16:10:00',1.3),('1444','2013-09-09','16:15:00',1.54),('1444','2013-09-09','16:20:00',1.25),('1444','2013-09-09','16:45:00',1.4),('1444','2014-04-12','09:15:00',1.26),('1444','2014-04-12','09:20:00',1.81),('1444','2014-04-12','09:25:00',1.77),('1444','2014-04-12','09:30:00',1.28),('1444','2014-04-12','09:35:00',1.09),('1444','2014-04-12','09:50:00',1.07),('1444','2014-04-12','09:55:00',1.02),('1444','2014-04-12','10:00:00',1.04),('1444','2014-04-12','10:05:00',1.09),('1444','2014-04-12','10:10:00',1.2),('1444','2014-04-12','10:15:00',1.34),('1444','2014-04-12','10:20:00',1.41),('1444','2014-04-12','10:25:00',1.48),('1444','2014-04-12','10:30:00',1.67),('1444','2014-04-12','10:35:00',1.76),('1444','2014-04-12','10:40:00',1.78),('1444','2014-04-12','10:45:00',2.03),('1444','2014-04-12','10:50:00',2.11),('1444','2014-04-12','10:55:00',2.05),('1444','2014-04-12','11:00:00',2.15),('1444','2014-04-12','11:05:00',1.71),('1444','2014-04-12','11:10:00',2.7),('1444','2014-04-12','11:15:00',2.3),('1444','2014-04-12','11:20:00',2.48),('1444','2014-04-12','11:25:00',2.7),('1444','2014-04-12','11:30:00',2.75),('1444','2014-04-12','11:35:00',2.97),('1444','2014-04-12','11:40:00',2.79),('1444','2014-04-12','11:45:00',2.56),('1444','2014-04-12','11:50:00',2.11),('1444','2014-04-12','11:55:00',1.65),('1444','2014-04-12','12:00:00',1.45),('1444','2014-04-12','12:05:00',1.22),('1444','2014-04-12','12:10:00',1.24),('1444','2014-04-12','12:15:00',1.8),('1444','2014-04-12','12:20:00',2.16),('1444','2014-04-12','12:25:00',1.44),('1444','2014-04-12','12:30:00',1.71),('1444','2014-04-12','12:35:00',2.02),('1444','2014-04-12','12:40:00',2.23),('1444','2014-04-12','12:45:00',1.87),('1444','2014-04-12','12:50:00',1.47),('1444','2014-04-12','12:55:00',1.75),('1444','2014-04-12','13:00:00',1.66),('1444','2014-04-12','13:05:00',1.34),('1444','2014-04-12','13:10:00',1.73),('1444','2014-04-12','13:15:00',1.91),('1444','2014-04-12','13:20:00',2.48),('1444','2014-04-12','13:25:00',3.06),('1444','2014-04-12','13:30:00',1.15),('1444','2014-04-12','13:35:00',1.6),('1444','2014-04-12','13:40:00',1.54),('1444','2014-04-12','13:45:00',2.39),('1444','2014-04-12','13:50:00',1.46),('1444','2014-04-12','13:55:00',2.96),('1444','2014-04-12','14:00:00',2.98),('1444','2014-04-12','14:05:00',2.02),('1444','2014-04-12','14:10:00',1.05),('1444','2014-04-12','14:15:00',1.82),('1444','2014-04-12','14:20:00',2.99),('1444','2014-04-12','14:25:00',1.39),('1444','2014-04-12','14:30:00',2.01),('1444','2014-04-12','14:35:00',2.02),('1444','2014-04-12','14:40:00',2.01),('1444','2014-04-12','14:45:00',1.92),('1444','2014-04-12','14:50:00',2.44),('1444','2014-04-12','14:55:00',2.16),('1444','2014-04-12','15:00:00',2.4),('1444','2014-04-12','15:05:00',2.61),('1444','2014-04-12','15:10:00',2.75),('1444','2014-04-12','15:15:00',2.66),('1444','2014-04-12','15:20:00',2.07),('1444','2014-04-12','15:25:00',2.07),('1444','2014-04-12','15:30:00',1.85),('1444','2014-04-12','15:35:00',1.53),('1444','2014-04-12','15:40:00',1.71),('1444','2014-04-12','15:45:00',2.21),('1444','2014-04-12','15:50:00',2.5),('1444','2014-04-12','15:55:00',2.51),('1444','2014-04-12','16:00:00',2.47),('1444','2014-04-12','16:05:00',2.42),('1444','2014-04-12','16:10:00',2.29),('1444','2014-04-12','16:15:00',2.38),('1444','2014-04-12','16:20:00',2.4),('1444','2014-04-12','16:25:00',2.15),('1444','2014-04-12','16:30:00',2.03),('1444','2014-04-12','16:35:00',1.59),('1444','2014-04-12','16:40:00',1.62),('1444','2014-04-12','16:45:00',1.52),('1444','2014-04-12','16:50:00',1.17),('1444','2014-04-12','16:55:00',1.84),('1444','2014-04-12','17:00:00',1.68),('1444','2014-04-12','17:05:00',1.56),('1444','2014-04-12','17:10:00',1.54),('1444','2014-04-12','17:15:00',1.5),('1444','2014-04-12','17:20:00',1.22),('1444','2014-04-12','17:25:00',1.37),('1444','2014-04-12','17:30:00',1.29),('1444','2014-04-12','17:35:00',1.13),('1444','2014-04-12','17:40:00',1.42),('1444','2014-04-12','17:45:00',1.39),('1444','2014-04-12','17:50:00',1.27),('1444','2014-04-12','17:55:00',1.04),('1444','2013-09-08','09:20:00',1.21),('1444','2013-09-08','09:25:00',1.28),('1444','2013-09-08','09:30:00',1.09),('1444','2013-09-08','09:35:00',1.15),('1444','2013-09-08','09:40:00',1.07),('1444','2013-09-08','09:45:00',1.25),('1444','2013-09-08','09:50:00',1.6),('1444','2013-09-08','09:55:00',1.62),('1444','2013-09-08','10:00:00',1.66),('1444','2013-09-08','10:05:00',1.71),('1444','2013-09-08','10:10:00',1.64),('1444','2013-09-08','10:15:00',1.76),('1444','2013-09-08','10:20:00',1.82),('1444','2013-09-08','10:25:00',1.88),('1444','2013-09-08','10:30:00',1.91),('1444','2013-09-08','10:35:00',1.96),('1444','2013-09-08','10:40:00',1.88),('1444','2013-09-08','10:45:00',1.98),('1444','2013-09-08','10:50:00',1.99),('1444','2013-09-08','10:55:00',1.97),('1444','2013-09-08','11:00:00',2.09),('1444','2013-09-08','11:05:00',2.12),('1444','2013-09-08','11:10:00',2.15),('1444','2013-09-08','11:15:00',2.2),('1444','2013-09-08','11:20:00',2.14),('1444','2013-09-08','11:25:00',2.13),('1444','2013-09-08','11:30:00',2.13),('1444','2013-09-08','11:35:00',2.16),('1444','2013-09-08','11:40:00',2.2),('1444','2013-09-08','11:45:00',2.29),('1444','2013-09-08','11:50:00',2.22),('1444','2013-09-08','11:55:00',2.24),('1444','2013-09-08','12:00:00',2.16),('1444','2013-09-08','12:05:00',2.12),('1444','2013-09-08','12:10:00',2.28),('1444','2013-09-08','12:15:00',2.44),('1444','2013-09-08','12:20:00',2.36),('1444','2013-09-08','12:25:00',2.4),('1444','2013-09-08','12:30:00',2.25),('1444','2013-09-08','12:35:00',2.36),('1444','2013-09-08','12:40:00',2.36),('1444','2013-09-08','12:45:00',2.32),('1444','2013-09-08','12:50:00',2.35),('1444','2013-09-08','12:55:00',2.43),('1444','2013-09-08','13:00:00',2.39),('1444','2013-09-08','13:05:00',2.44),('1444','2013-09-08','13:10:00',2.41),('1444','2013-09-08','13:15:00',2.37),('1444','2013-09-08','13:20:00',2.37),('1444','2013-09-08','13:25:00',2.17),('1444','2013-09-08','13:30:00',2.18),('1444','2013-09-08','13:35:00',2.03),('1444','2013-09-08','13:40:00',1.49),('1444','2013-09-08','13:45:00',1.43),('1444','2013-09-08','13:50:00',2.01),('1444','2013-09-08','13:55:00',2.04),('1444','2013-09-08','14:00:00',2.31),('1444','2013-09-08','14:05:00',2.16),('1444','2013-09-08','14:10:00',2.49),('1444','2013-09-08','14:15:00',2.27),('1444','2013-09-08','14:20:00',2.64),('1444','2013-09-08','14:25:00',2.66),('1444','2013-09-08','14:30:00',2.34),('1444','2013-09-08','14:35:00',2.43),('1444','2013-09-08','14:40:00',2.35),('1444','2013-09-08','14:45:00',2.28),('1444','2013-09-08','14:50:00',2.29),('1444','2013-09-08','14:55:00',2.29),('1444','2013-09-08','15:00:00',2.26),('1444','2013-09-08','15:05:00',1.78),('1444','2013-09-08','15:10:00',1.2),('1444','2013-09-08','15:15:00',1.68),('1444','2013-09-08','15:20:00',2.17),('1444','2013-09-08','15:25:00',2.17),('1444','2013-09-08','15:30:00',2.16),('1444','2013-09-08','15:35:00',2.08),('1444','2013-09-08','15:40:00',1.93),('1444','2013-09-08','15:45:00',1.97),('1444','2013-09-08','15:50:00',1.89),('1444','2013-09-08','15:55:00',1.61),('1444','2013-09-08','16:00:00',1.62),('1444','2013-09-08','16:05:00',1.61),('1444','2013-09-08','16:10:00',1.49),('1444','2013-09-08','16:15:00',1.66),('1444','2013-09-08','16:20:00',1.46),('1444','2013-09-08','16:25:00',1.42),('1444','2013-09-08','16:30:00',1.51),('1444','2013-09-08','16:35:00',1.37),('1444','2013-09-08','16:40:00',1.15),('1444','2013-09-08','17:00:00',1.19),('1444','2013-09-08','17:05:00',1.3),('1444','2013-09-08','17:10:00',1.21),('1444','2013-09-08','17:15:00',1.11),('1444','2013-09-07','08:50:00',1.02),('1444','2013-09-07','08:55:00',1.07),('1444','2013-09-07','09:00:00',1.11),('1444','2013-09-07','09:05:00',1.18),('1444','2013-09-07','09:10:00',1.25),('1444','2013-09-07','09:15:00',1.29),('1444','2013-09-07','09:20:00',1.34),('1444','2013-09-07','09:25:00',1.4),('1444','2013-09-07','09:30:00',1.45),('1444','2013-09-07','09:35:00',1.5),('1444','2013-09-07','09:40:00',1.54),('1444','2013-09-07','09:45:00',1.59),('1444','2013-09-07','09:50:00',1.64),('1444','2013-09-07','09:55:00',1.66),('1444','2013-09-07','10:00:00',1.72),('1444','2013-09-07','10:05:00',1.75),('1444','2013-09-07','10:10:00',1.8),('1444','2013-09-07','10:15:00',1.83),('1444','2013-09-07','10:20:00',1.87),('1444','2013-09-07','10:25:00',1.91),('1444','2013-09-07','10:30:00',1.93),('1444','2013-09-07','10:35:00',1.97),('1444','2013-09-07','10:40:00',2.02),('1444','2013-09-07','10:45:00',2.04),('1444','2013-09-07','10:50:00',2.08),('1444','2013-09-07','10:55:00',2.12),('1444','2013-09-07','11:00:00',2.15),('1444','2013-09-07','11:05:00',2.18),('1444','2013-09-07','11:10:00',2.22),('1444','2013-09-07','11:15:00',2.23),('1444','2013-09-07','11:20:00',2.25),('1444','2013-09-07','11:25:00',2.28),('1444','2013-09-07','11:30:00',2.32),('1444','2013-09-07','11:35:00',2.34),('1444','2013-09-07','11:40:00',2.38),('1444','2013-09-07','11:45:00',2.4),('1444','2013-09-07','11:50:00',2.4),('1444','2013-09-07','11:55:00',2.42),('1444','2013-09-07','12:00:00',2.41),('1444','2013-09-07','12:05:00',2.48),('1444','2013-09-07','12:10:00',2.49),('1444','2013-09-07','12:15:00',2.5),('1444','2013-09-07','12:20:00',2.52),('1444','2013-09-07','12:25:00',2.51),('1444','2013-09-07','12:30:00',2.49),('1444','2013-09-07','12:35:00',2.48),('1444','2013-09-07','12:40:00',2.49),('1444','2013-09-07','12:45:00',2.51),('1444','2013-09-07','12:50:00',2.54),('1444','2013-09-07','12:57:00',2.5),('1444','2013-09-07','13:00:00',2.54),('1444','2013-09-07','13:05:00',2.54),('1444','2013-09-07','13:10:00',2.54),('1444','2013-09-07','13:15:00',2.52),('1444','2013-09-07','13:20:00',2.54),('1444','2013-09-07','13:25:00',2.57),('1444','2013-09-07','13:30:00',2.55),('1444','2013-09-07','13:35:00',1.65),('1444','2013-09-07','13:40:00',1.62),('1444','2013-09-07','13:50:00',2.51),('1444','2013-09-07','13:55:00',2.56),('1444','2013-09-07','14:00:00',2.57),('1444','2013-09-07','14:05:00',2.54),('1444','2013-09-07','14:10:00',2.5),('1444','2013-09-07','14:15:00',2.44),('1444','2013-09-07','14:20:00',2.4),('1444','2013-09-07','14:25:00',2.4),('1444','2013-09-07','14:30:00',2.42),('1444','2013-09-07','14:35:00',2.42),('1444','2013-09-07','14:40:00',2.39),('1444','2013-09-07','14:45:00',2.35),('1444','2013-09-07','14:50:00',2.32),('1444','2013-09-07','14:55:00',2.29),('1444','2013-09-07','15:00:00',2.27),('1444','2013-09-07','15:05:00',2.24),('1444','2013-09-07','15:10:00',2.21),('1444','2013-09-07','15:15:00',2.19),('1444','2013-09-07','15:20:00',2.18),('1444','2013-09-07','15:25:00',2.15),('1444','2013-09-07','15:30:00',2.1),('1444','2013-09-07','15:35:00',2.06),('1444','2013-09-07','15:40:00',1.98),('1444','2013-09-07','15:45:00',1.96),('1444','2013-09-07','15:50:00',1.92),('1444','2013-09-07','15:55:00',1.87),('1444','2013-09-07','16:00:00',1.83),('1444','2013-09-07','16:05:00',1.78),('1444','2013-09-07','16:10:00',1.73),('1444','2013-09-07','16:15:00',1.69),('1444','2013-09-07','16:20:00',1.63),('1444','2013-09-07','16:25:00',1.57),('1444','2013-09-07','16:30:00',1.5),('1444','2013-09-07','16:35:00',1.46),('1444','2013-09-07','16:40:00',1.42),('1444','2013-09-07','16:45:00',1.38),('1444','2013-09-07','16:50:00',1.33),('1444','2013-09-07','16:55:00',1.29),('1444','2013-09-07','17:00:00',1.22),('1444','2013-09-07','17:05:00',1.17),('1444','2013-09-07','17:10:00',1.12),('1444','2013-09-07','17:15:00',1.07),('1444','2013-09-07','17:20:00',1.02),('1444','2013-09-06','08:50:00',1.06),('1444','2013-09-06','08:55:00',1.12),('1444','2013-09-06','09:00:00',1.17),('1444','2013-09-06','09:05:00',1.22),('1444','2013-09-06','09:10:00',1.28),('1444','2013-09-06','09:15:00',1.33),('1444','2013-09-06','09:20:00',1.38),('1444','2013-09-06','09:25:00',1.43),('1444','2013-09-06','09:30:00',1.48),('1444','2013-09-06','09:35:00',1.54),('1444','2013-09-06','09:40:00',1.59),('1444','2013-09-06','09:45:00',1.63),('1444','2013-09-06','09:50:00',1.68),('1444','2013-09-06','09:55:00',1.73),('1444','2013-09-06','10:00:00',1.76),('1444','2013-09-06','10:05:00',1.81),('1444','2013-09-06','10:10:00',1.84),('1444','2013-09-06','10:15:00',1.87),('1444','2013-09-06','10:20:00',1.92),('1444','2013-09-06','10:25:00',1.96),('1444','2013-09-06','10:30:00',2),('1444','2013-09-06','10:35:00',2.06),('1444','2013-09-06','10:40:00',2.1),('1444','2013-09-06','10:45:00',2.16),('1444','2013-09-06','10:50:00',2.19),('1444','2013-09-06','10:55:00',2.21),('1444','2013-09-06','11:00:00',2.22),('1444','2013-09-06','11:05:00',2.24),('1444','2013-09-06','11:10:00',2.28),('1444','2013-09-06','11:15:00',2.31),('1444','2013-09-06','11:20:00',2.33),('1444','2013-09-06','11:25:00',2.35),('1444','2013-09-06','11:30:00',2.37),('1444','2013-09-06','11:35:00',2.38),('1444','2013-09-06','11:40:00',2.42),('1444','2013-09-06','11:45:00',2.45),('1444','2013-09-06','11:50:00',2.47),('1444','2013-09-06','11:55:00',2.47),('1444','2013-09-06','12:00:00',2.47),('1444','2013-09-06','12:05:00',2.48),('1444','2013-09-06','12:10:00',2.5),('1444','2013-09-06','12:15:00',2.55),('1444','2013-09-06','12:20:00',2.56),('1444','2013-09-06','12:25:00',2.56),('1444','2013-09-06','12:30:00',2.59),('1444','2013-09-06','12:35:00',2.6),('1444','2013-09-06','12:40:00',2.6),('1444','2013-09-06','12:45:00',2.6),('1444','2013-09-06','12:50:00',2.59),('1444','2013-09-06','12:55:00',2.6),('1444','2013-09-06','13:00:00',2.6),('1444','2013-09-06','13:05:00',2.6),('1444','2013-09-06','13:10:00',2.6),('1444','2013-09-06','13:15:00',2.58),('1444','2013-09-06','13:20:00',2.57),('1444','2013-09-06','13:25:00',2.55),('1444','2013-09-06','13:30:00',2.56),('1444','2013-09-06','13:35:00',2.57),('1444','2013-09-06','13:40:00',2.56),('1444','2013-09-06','13:45:00',2.53),('1444','2013-09-06','13:50:00',2.51),('1444','2013-09-06','13:55:00',2.48),('1444','2013-09-06','14:00:00',2.46),('1444','2013-09-06','14:05:00',2.45),('1444','2013-09-06','14:10:00',2.44),('1444','2013-09-06','14:15:00',2.43),('1444','2013-09-06','14:20:00',2.4),('1444','2013-09-06','14:25:00',2.39),('1444','2013-09-06','14:30:00',2.35),('1444','2013-09-06','14:35:00',2.27),('1444','2013-09-06','14:40:00',2.28),('1444','2013-09-06','14:45:00',2.27),('1444','2013-09-06','14:50:00',2.31),('1444','2013-09-06','14:55:00',2.3),('1444','2013-09-06','15:00:00',2.27),('1444','2013-09-06','15:05:00',2.23),('1444','2013-09-06','15:10:00',2.2),('1444','2013-09-06','15:15:00',2.17),('1444','2013-09-06','15:20:00',2.14),('1444','2013-09-06','15:25:00',2.09),('1444','2013-09-06','15:30:00',2.03),('1444','2013-09-06','15:35:00',1.98),('1444','2013-09-06','15:40:00',1.96),('1444','2013-09-06','15:45:00',1.94),('1444','2013-09-06','15:50:00',1.9),('1444','2013-09-06','15:55:00',1.87),('1444','2013-09-06','16:00:00',1.81),('1444','2013-09-06','16:05:00',1.78),('1444','2013-09-06','16:10:00',1.74),('1444','2013-09-06','16:15:00',1.7),('1444','2013-09-06','16:20:00',1.65),('1444','2013-09-06','16:25:00',1.63),('1444','2013-09-06','16:30:00',1.6),('1444','2013-09-06','16:35:00',1.54),('1444','2013-09-06','16:40:00',1.49),('1444','2013-09-06','16:45:00',1.42),('1444','2013-09-06','16:50:00',1.38),('1444','2013-09-06','16:55:00',1.3),('1444','2013-09-06','17:00:00',1.27),('1444','2013-09-06','17:05:00',1.2),('1444','2013-09-06','17:10:00',1.15),('1444','2013-09-06','17:15:00',1.1),('1444','2013-09-06','17:20:00',1.05),('1444','2013-09-05','08:40:00',1.03),('1444','2013-09-05','08:45:00',1.08),('1444','2013-09-05','08:50:00',1.14),('1444','2013-09-05','08:55:00',1.2),('1444','2013-09-05','09:00:00',1.26),('1444','2013-09-05','09:05:00',1.31),('1444','2013-09-05','09:10:00',1.37),('1444','2013-09-05','09:15:00',1.42),('1444','2013-09-05','09:20:00',1.48),('1444','2013-09-05','09:25:00',1.53),('1444','2013-09-05','09:30:00',1.58),('1444','2013-09-05','09:35:00',1.63),('1444','2013-09-05','09:40:00',1.67),('1444','2013-09-05','09:45:00',1.72),('1444','2013-09-05','09:50:00',1.76),('1444','2013-09-05','09:55:00',1.82),('1444','2013-09-05','10:00:00',1.86),('1444','2013-09-05','10:05:00',1.9),('1444','2013-09-05','10:10:00',1.95),('1444','2013-09-05','10:15:00',1.99),('1444','2013-09-05','10:20:00',2.03),('1444','2013-09-05','10:25:00',2.07),('1444','2013-09-05','10:30:00',2.1),('1444','2013-09-05','10:35:00',2.14),('1444','2013-09-05','10:40:00',2.17),('1444','2013-09-05','10:45:00',2.2),('1444','2013-09-05','10:50:00',2.23),('1444','2013-09-05','10:55:00',2.25),('1444','2013-09-05','11:00:00',2.3),('1444','2013-09-05','11:05:00',2.33),('1444','2013-09-05','11:10:00',2.35),('1444','2013-09-05','11:15:00',2.37),('1444','2013-09-05','11:20:00',2.39),('1444','2013-09-05','11:25:00',2.44),('1444','2013-09-05','11:30:00',2.46),('1444','2013-09-05','11:35:00',2.44),('1444','2013-09-05','11:40:00',2.46),('1444','2013-09-05','11:45:00',2.46),('1444','2013-09-05','11:50:00',2.52),('1444','2013-09-05','11:55:00',2.57),('1444','2013-09-05','12:00:00',2.56),('1444','2013-09-05','12:05:00',2.57),('1444','2013-09-05','12:10:00',2.57),('1444','2013-09-05','12:15:00',2.58),('1444','2013-09-05','12:20:00',2.61),('1444','2013-09-05','12:25:00',2.64),('1444','2013-09-05','12:30:00',2.62),('1444','2013-09-05','12:35:00',2.61),('1444','2013-09-05','12:40:00',2.63),('1444','2013-09-05','12:45:00',2.64),('1444','2013-09-05','12:50:00',2.67),('1444','2013-09-05','12:55:00',2.68),('1444','2013-09-05','13:00:00',2.66),('1444','2013-09-05','13:05:00',2.65),('1444','2013-09-05','13:10:00',2.63),('1444','2013-09-05','13:15:00',2.66),('1444','2013-09-05','13:20:00',2.63),('1444','2013-09-05','13:25:00',2.63),('1444','2013-09-05','13:30:00',2.66),('1444','2013-09-05','13:35:00',2.66),('1444','2013-09-05','13:40:00',2.62),('1444','2013-09-05','13:45:00',2.58),('1444','2013-09-05','13:50:00',2.56),('1444','2013-09-05','13:55:00',2.54),('1444','2013-09-05','14:00:00',2.54),('1444','2013-09-05','14:05:00',2.55),('1444','2013-09-05','14:10:00',2.52),('1444','2013-09-05','14:15:00',2.49),('1444','2013-09-05','14:20:00',2.46),('1444','2013-09-05','14:25:00',2.45),('1444','2013-09-05','14:30:00',2.44),('1444','2013-09-05','14:35:00',2.4),('1444','2013-09-05','14:40:00',2.4),('1444','2013-09-05','14:45:00',2.36),('1444','2013-09-05','14:50:00',2.35),('1444','2013-09-05','14:55:00',2.35),('1444','2013-09-05','15:00:00',2.34),('1444','2013-09-05','15:05:00',2.31),('1444','2013-09-05','15:10:00',2.26),('1444','2013-09-05','15:15:00',2.24),('1444','2013-09-05','15:20:00',2.2),('1444','2013-09-05','15:25:00',2.15),('1444','2013-09-05','15:30:00',2.12),('1444','2013-09-05','15:35:00',2.1),('1444','2013-09-05','15:40:00',2.07),('1444','2013-09-05','15:45:00',2.03),('1444','2013-09-05','15:50:00',1.99),('1444','2013-09-05','15:55:00',1.95),('1444','2013-09-05','16:00:00',1.9),('1444','2013-09-05','16:05:00',1.88),('1444','2013-09-05','16:10:00',1.84),('1444','2013-09-05','16:15:00',1.79),('1444','2013-09-05','16:20:00',1.73),('1444','2013-09-05','16:25:00',1.69),('1444','2013-09-05','16:30:00',1.66),('1444','2013-09-05','16:35:00',1.64),('1444','2013-09-05','16:40:00',1.6),('1444','2013-09-05','16:45:00',1.57),('1444','2013-09-05','16:50:00',1.23),('1444','2013-09-05','16:55:00',1),('1444','2013-09-05','17:40:00',1.02),('1444','2013-09-04','08:40:00',1.03),('1444','2013-09-04','08:45:00',1.09),('1444','2013-09-04','08:50:00',1.15),('1444','2013-09-04','08:55:00',1.21),('1444','2013-09-04','09:00:00',1.27),('1444','2013-09-04','09:05:00',1.33),('1444','2013-09-04','09:10:00',1.39),('1444','2013-09-04','09:15:00',1.46),('1444','2013-09-04','09:20:00',1.52),('1444','2013-09-04','09:25:00',1.58),('1444','2013-09-04','09:30:00',1.61),('1444','2013-09-04','09:35:00',1.69),('1444','2013-09-04','09:40:00',1.74),('1444','2013-09-04','09:45:00',1.8),('1444','2013-09-04','09:50:00',1.85),('1444','2013-09-04','09:55:00',1.89),('1444','2013-09-04','10:00:00',1.94),('1444','2013-09-04','10:05:00',1.98),('1444','2013-09-04','10:10:00',2.04),('1444','2013-09-04','10:15:00',2.07),('1444','2013-09-04','10:20:00',2.11),('1444','2013-09-04','10:25:00',2.15),('1444','2013-09-04','10:30:00',2.18),('1444','2013-09-04','10:35:00',2.23),('1444','2013-09-04','10:40:00',2.27),('1444','2013-09-04','10:45:00',2.3),('1444','2013-09-04','10:50:00',2.34),('1444','2013-09-04','10:55:00',2.37),('1444','2013-09-04','11:00:00',2.41),('1444','2013-09-04','11:05:00',2.44),('1444','2013-09-04','11:10:00',2.46),('1444','2013-09-04','11:15:00',2.49),('1444','2013-09-04','11:20:00',2.52),('1444','2013-09-04','11:25:00',2.54),('1444','2013-09-04','11:30:00',2.56),('1444','2013-09-04','11:35:00',2.59),('1444','2013-09-04','11:40:00',2.61),('1444','2013-09-04','11:45:00',2.63),('1444','2013-09-04','11:50:00',2.66),('1444','2013-09-04','11:55:00',2.69),('1444','2013-09-04','12:00:00',2.7),('1444','2013-09-04','12:05:00',2.71),('1444','2013-09-04','12:10:00',2.72),('1444','2013-09-04','12:15:00',2.71),('1444','2013-09-04','12:20:00',2.73),('1444','2013-09-04','12:25:00',2.76),('1444','2013-09-04','12:30:00',2.77),('1444','2013-09-04','12:35:00',2.78),('1444','2013-09-04','12:40:00',2.79),('1444','2013-09-04','12:45:00',2.79),('1444','2013-09-04','12:50:00',2.77),('1444','2013-09-04','12:55:00',2.78),('1444','2013-09-04','13:00:00',2.78),('1444','2013-09-04','13:05:00',2.77),('1444','2013-09-04','13:10:00',2.77),('1444','2013-09-04','13:15:00',2.77),('1444','2013-09-04','13:20:00',2.76),('1444','2013-09-04','13:25:00',2.75),('1444','2013-09-04','13:30:00',2.75),('1444','2013-09-04','13:35:00',2.74),('1444','2013-09-04','13:40:00',2.73),('1444','2013-09-04','13:45:00',2.72),('1444','2013-09-04','13:50:00',2.7),('1444','2013-09-04','13:55:00',2.71),('1444','2013-09-04','14:00:00',2.68),('1444','2013-09-04','14:05:00',2.68),('1444','2013-09-04','14:10:00',2.67),('1444','2013-09-04','14:15:00',2.65),('1444','2013-09-04','14:20:00',2.61),('1444','2013-09-04','14:25:00',2.6),('1444','2013-09-04','14:30:00',2.58),('1444','2013-09-04','14:35:00',2.57),('1444','2013-09-04','14:40:00',2.53),('1444','2013-09-04','14:45:00',2.52),('1444','2013-09-04','14:50:00',2.49),('1444','2013-09-04','14:55:00',2.45),('1444','2013-09-04','15:00:00',2.41),('1444','2013-09-04','15:05:00',2.38),('1444','2013-09-04','15:10:00',2.37),('1444','2013-09-04','15:15:00',2.33),('1444','2013-09-04','15:20:00',2.3),('1444','2013-09-04','15:25:00',2.25),('1444','2013-09-04','15:30:00',2.22),('1444','2013-09-04','15:35:00',2.18),('1444','2013-09-04','15:40:00',2.15),('1444','2013-09-04','15:45:00',2.11),('1444','2013-09-04','15:50:00',2.06),('1444','2013-09-04','15:55:00',2.01),('1444','2013-09-04','16:00:00',1.97),('1444','2013-09-04','16:05:00',1.92),('1444','2013-09-04','16:10:00',1.87),('1444','2013-09-04','16:15:00',1.83),('1444','2013-09-04','16:20:00',1.79),('1444','2013-09-04','16:25:00',1.73),('1444','2013-09-04','16:30:00',1.68),('1444','2013-09-04','16:35:00',1.63),('1444','2013-09-04','16:40:00',1.57),('1444','2013-09-04','16:45:00',1.52),('1444','2013-09-04','16:50:00',1.47),('1444','2013-09-04','16:55:00',1.41),('1444','2013-09-04','17:00:00',1.36),('1444','2013-09-04','17:05:00',1.31),('1444','2013-09-04','17:10:00',1.25),('1444','2013-09-04','17:15:00',1.19),('1444','2013-09-04','17:20:00',1.13),('1444','2013-09-04','17:25:00',1.08),('1444','2013-09-04','17:30:00',1.02),('1444','2013-09-03','08:45:00',1.01),('1444','2013-09-03','08:50:00',1.07),('1444','2013-09-03','08:55:00',1.13),('1444','2013-09-03','09:00:00',1.18),('1444','2013-09-03','09:05:00',1.23),('1444','2013-09-03','09:10:00',1.3),('1444','2013-09-03','09:15:00',1.36),('1444','2013-09-03','09:20:00',1.42),('1444','2013-09-03','09:25:00',1.48),('1444','2013-09-03','09:30:00',1.54),('1444','2013-09-03','09:35:00',1.59),('1444','2013-09-03','09:40:00',1.64),('1444','2013-09-03','09:45:00',1.69),('1444','2013-09-03','09:50:00',1.72),('1444','2013-09-03','09:55:00',1.75),('1444','2013-09-03','10:00:00',1.79),('1444','2013-09-03','10:05:00',1.84),('1444','2013-09-03','10:10:00',1.87),('1444','2013-09-03','10:15:00',1.93),('1444','2013-09-03','10:20:00',1.98),('1444','2013-09-03','10:25:00',2.03),('1444','2013-09-03','10:30:00',2.08),('1444','2013-09-03','10:35:00',2.12),('1444','2013-09-03','10:40:00',2.17),('1444','2013-09-03','10:45:00',2.23),('1444','2013-09-03','10:50:00',2.27),('1444','2013-09-03','10:55:00',2.29),('1444','2013-09-03','11:00:00',2.3),('1444','2013-09-03','11:05:00',2.34),('1444','2013-09-03','11:10:00',2.35),('1444','2013-09-03','11:15:00',2.39),('1444','2013-09-03','11:20:00',2.42),('1444','2013-09-03','11:25:00',2.43),('1444','2013-09-03','11:30:00',2.45),('1444','2013-09-03','11:35:00',2.47),('1444','2013-09-03','11:40:00',2.51),('1444','2013-09-03','11:45:00',2.53),('1444','2013-09-03','11:50:00',2.57),('1444','2013-09-03','11:55:00',2.6),('1444','2013-09-03','12:00:00',2.61),('1444','2013-09-03','12:05:00',2.62),('1444','2013-09-03','12:10:00',2.62),('1444','2013-09-03','12:15:00',2.64),('1444','2013-09-03','12:20:00',2.66),('1444','2013-09-03','12:25:00',2.67),('1444','2013-09-03','12:30:00',2.7),('1444','2013-09-03','12:35:00',2.71),('1444','2013-09-03','12:40:00',2.72),('1444','2013-09-03','12:45:00',2.73),('1444','2013-09-03','12:50:00',2.72),('1444','2013-09-03','12:55:00',2.71),('1444','2013-09-03','13:00:00',2.72),('1444','2013-09-03','13:05:00',2.73),('1444','2013-09-03','13:10:00',2.72),('1444','2013-09-03','13:15:00',2.7),('1444','2013-09-03','13:20:00',2.72),('1444','2013-09-03','13:25:00',2.7),('1444','2013-09-03','13:30:00',2.69),('1444','2013-09-03','13:35:00',2.68),('1444','2013-09-03','13:40:00',2.67),('1444','2013-09-03','13:45:00',2.66),('1444','2013-09-03','13:50:00',2.67),('1444','2013-09-03','13:55:00',2.68),('1444','2013-09-03','14:00:00',2.65),('1444','2013-09-03','14:05:00',2.58),('1444','2013-09-03','14:10:00',2.54),('1444','2013-09-03','14:15:00',2.55),('1444','2013-09-03','14:20:00',2.54),('1444','2013-09-03','14:25:00',2.53),('1444','2013-09-03','14:30:00',2.53),('1444','2013-09-03','14:35:00',2.52),('1444','2013-09-03','14:40:00',2.52),('1444','2013-09-03','14:45:00',2.48),('1444','2013-09-03','14:50:00',2.48),('1444','2013-09-03','14:55:00',2.46),('1444','2013-09-03','15:00:00',2.42),('1444','2013-09-03','15:05:00',2.36),('1444','2013-09-03','15:10:00',2.3),('1444','2013-09-03','15:15:00',2.29),('1444','2013-09-03','15:20:00',2.27),('1444','2013-09-03','15:25:00',2.23),('1444','2013-09-03','15:30:00',2.21),('1444','2013-09-03','15:35:00',2.15),('1444','2013-09-03','15:40:00',2.1),('1444','2013-09-03','15:45:00',2.06),('1444','2013-09-03','15:50:00',2.03),('1444','2013-09-03','15:55:00',1.99),('1444','2013-09-03','16:00:00',1.94),('1444','2013-09-03','16:05:00',1.92),('1444','2013-09-03','16:10:00',1.88),('1444','2013-09-03','16:15:00',1.83),('1444','2013-09-03','16:20:00',1.78),('1444','2013-09-03','16:25:00',1.73),('1444','2013-09-03','16:30:00',1.68),('1444','2013-09-03','16:35:00',1.63),('1444','2013-09-03','16:40:00',1.58),('1444','2013-09-03','16:45:00',1.52),('1444','2013-09-03','16:50:00',1.46),('1444','2013-09-03','16:55:00',1.42),('1444','2013-09-03','17:00:00',1.37),('1444','2013-09-03','17:05:00',1.31),('1444','2013-09-03','17:10:00',1.26),('1444','2013-09-03','17:15:00',1.2),('1444','2013-09-03','17:20:00',1.15),('1444','2013-09-03','17:25:00',1.09),('1444','2013-09-03','17:30:00',1.03),('1444','2013-09-02','08:45:00',1.06),('1444','2013-09-02','08:50:00',1.12),('1444','2013-09-02','08:55:00',1.17),('1444','2013-09-02','09:00:00',1.23),('1444','2013-09-02','09:05:00',1.29),('1444','2013-09-02','09:10:00',1.34),('1444','2013-09-02','09:15:00',1.38),('1444','2013-09-02','09:20:00',1.43),('1444','2013-09-02','09:25:00',1.5),('1444','2013-09-02','09:30:00',1.57),('1444','2013-09-02','09:35:00',1.62),('1444','2013-09-02','09:40:00',1.67),('1444','2013-09-02','09:45:00',1.73),('1444','2013-09-02','09:50:00',1.78),('1444','2013-09-02','09:55:00',1.82),('1444','2013-09-02','10:00:00',1.87),('1444','2013-09-02','10:05:00',1.92),('1444','2013-09-02','10:10:00',1.96),('1444','2013-09-02','10:15:00',2.01),('1444','2013-09-02','10:20:00',2.06),('1444','2013-09-02','10:25:00',2.09),('1444','2013-09-02','10:30:00',2.13),('1444','2013-09-02','10:35:00',2.17),('1444','2013-09-02','10:40:00',2.2),('1444','2013-09-02','10:45:00',2.23),('1444','2013-09-02','10:50:00',2.26),('1444','2013-09-02','10:55:00',2.29),('1444','2013-09-02','11:00:00',2.31),('1444','2013-09-02','11:05:00',2.33),('1444','2013-09-02','11:10:00',2.37),('1444','2013-09-02','11:15:00',2.41),('1444','2013-09-02','11:20:00',2.42),('1444','2013-09-02','11:25:00',2.45),('1444','2013-09-02','11:30:00',2.47),('1444','2013-09-02','11:35:00',2.5),('1444','2013-09-02','11:40:00',2.53),('1444','2013-09-02','11:45:00',2.56),('1444','2013-09-02','11:50:00',2.54),('1444','2013-09-02','11:55:00',2.55),('1444','2013-09-02','12:00:00',2.58),('1444','2013-09-02','12:05:00',2.59),('1444','2013-09-02','12:10:00',2.61),('1444','2013-09-02','12:15:00',2.66),('1444','2013-09-02','12:20:00',2.67),('1444','2013-09-02','12:25:00',2.67),('1444','2013-09-02','12:30:00',2.68),('1444','2013-09-02','12:35:00',2.62),('1444','2013-09-02','12:40:00',2.66),('1444','2013-09-02','12:45:00',2.66),('1444','2013-09-02','12:50:00',2.68),('1444','2013-09-02','12:55:00',2.7),('1444','2013-09-02','13:00:00',2.71),('1444','2013-09-02','13:05:00',2.71),('1444','2013-09-02','13:10:00',2.68),('1444','2013-09-02','13:15:00',2.68),('1444','2013-09-02','13:20:00',2.65),('1444','2013-09-02','13:25:00',2.66),('1444','2013-09-02','13:30:00',2.64),('1444','2013-09-02','13:35:00',2.6),('1444','2013-09-02','13:40:00',2.56),('1444','2013-09-02','13:45:00',2.69),('1444','2013-09-02','13:50:00',2.67),('1444','2013-09-02','13:55:00',1.18),('1444','2013-09-02','14:00:00',2.26),('1444','2013-09-02','14:05:00',1.76),('1444','2013-09-02','14:10:00',2.68),('1444','2013-09-02','14:15:00',2.62),('1444','2013-09-02','14:20:00',2.45),('1444','2013-09-02','14:25:00',2.56),('1444','2013-09-02','14:30:00',2.59),('1444','2013-09-02','14:35:00',2.54),('1444','2013-09-02','14:40:00',2.53),('1444','2013-09-02','14:45:00',2.56),('1444','2013-09-02','14:50:00',2.56),('1444','2013-09-02','14:55:00',1.7),('1444','2013-09-02','15:00:00',1.98),('1444','2013-09-02','15:05:00',2.27),('1444','2013-09-02','15:10:00',1.01),('1444','2013-09-02','15:15:00',1.41),('1444','2013-09-02','15:25:00',1.43),('1444','2013-09-02','15:30:00',2.19),('1444','2013-09-02','15:35:00',1.91),('1444','2013-09-02','15:40:00',1.89),('1444','2013-09-02','15:45:00',2.04),('1444','2013-09-02','15:50:00',2.06),('1444','2013-09-02','15:55:00',2.03),('1444','2013-09-02','16:00:00',2.01),('1444','2013-09-02','16:05:00',1.95),('1444','2013-09-02','16:10:00',1.9),('1444','2013-09-02','16:15:00',1.87),('1444','2013-09-02','16:20:00',1.83),('1444','2013-09-02','16:25:00',1.75),('1444','2013-09-02','16:30:00',1.68),('1444','2013-09-02','16:35:00',1.65),('1444','2013-09-02','16:40:00',1.58),('1444','2013-09-02','16:45:00',1.51),('1444','2013-09-02','16:50:00',1.44),('1444','2013-09-02','16:55:00',1.35),('1444','2013-09-02','17:00:00',1.32),('1444','2013-09-02','17:05:00',1.26),('1444','2013-09-02','17:10:00',1.21),('1444','2013-09-02','17:15:00',1.16),('1444','2013-09-02','17:20:00',1.11),('1444','2013-09-02','17:25:00',1.07),('1444','2013-09-02','17:30:00',1.02),('1444','2013-09-01','08:40:00',1.05),('1444','2013-09-01','08:45:00',1.1),('1444','2013-09-01','08:50:00',1.16),('1444','2013-09-01','08:55:00',1.21),('1444','2013-09-01','09:00:00',1.26),('1444','2013-09-01','09:05:00',1.32),('1444','2013-09-01','09:10:00',1.39),('1444','2013-09-01','09:15:00',1.45),('1444','2013-09-01','09:20:00',1.5),('1444','2013-09-01','09:25:00',1.55),('1444','2013-09-01','09:30:00',1.61),('1444','2013-09-01','09:35:00',1.66),('1444','2013-09-01','09:40:00',1.72),('1444','2013-09-01','09:45:00',1.77),('1444','2013-09-01','09:50:00',1.81),('1444','2013-09-01','09:55:00',1.86),('1444','2013-09-01','10:00:00',1.9),('1444','2013-09-01','10:05:00',1.94),('1444','2013-09-01','10:10:00',1.99),('1444','2013-09-01','10:15:00',2.03),('1444','2013-09-01','10:20:00',2.06),('1444','2013-09-01','10:25:00',2.1),('1444','2013-09-01','10:30:00',2.14),('1444','2013-09-01','10:35:00',2.16),('1444','2013-09-01','10:40:00',2.22),('1444','2013-09-01','10:45:00',2.25),('1444','2013-09-01','10:50:00',2.27),('1444','2013-09-01','10:55:00',2.32),('1444','2013-09-01','11:00:00',2.33),('1444','2013-09-01','11:05:00',2.37),('1444','2013-09-01','11:10:00',2.4),('1444','2013-09-01','11:15:00',2.43),('1444','2013-09-01','11:20:00',2.42),('1444','2013-09-01','11:25:00',2.48),('1444','2013-09-01','11:30:00',2.49),('1444','2013-09-01','11:35:00',2.51),('1444','2013-09-01','11:40:00',2.53),('1444','2013-09-01','11:45:00',2.56),('1444','2013-09-01','11:50:00',2.6),('1444','2013-09-01','11:55:00',2.61),('1444','2013-09-01','12:00:00',2.57),('1444','2013-09-01','12:05:00',2.53),('1444','2013-09-01','12:10:00',2.62),('1444','2013-09-01','12:15:00',2.65),('1444','2013-09-01','12:20:00',2.68),('1444','2013-09-01','12:25:00',2.61),('1444','2013-09-01','12:30:00',2.7),('1444','2013-09-01','12:35:00',2.69),('1444','2013-09-01','12:40:00',2.73),('1444','2013-09-01','12:45:00',2.64),('1444','2013-09-01','12:50:00',2.68),('1444','2013-09-01','12:55:00',2.68),('1444','2013-09-01','13:00:00',2.73),('1444','2013-09-01','13:05:00',2.74),('1444','2013-09-01','13:10:00',2.75),('1444','2013-09-01','13:15:00',2.34),('1444','2013-09-01','13:20:00',2.78),('1444','2013-09-01','13:25:00',2.77),('1444','2013-09-01','13:30:00',2.78),('1444','2013-09-01','13:35:00',2.7),('1444','2013-09-01','13:40:00',2.72),('1444','2013-09-01','13:45:00',2.55),('1444','2013-09-01','13:50:00',2.3),('1444','2013-09-01','13:55:00',2.36),('1444','2013-09-01','14:00:00',2.04),('1444','2013-09-01','14:05:00',2.05),('1444','2013-09-01','14:10:00',2.37),('1444','2013-09-01','14:15:00',2.43),('1444','2013-09-01','14:20:00',2.24),('1444','2013-09-01','14:25:00',2.2),('1444','2013-09-01','14:30:00',2.24),('1444','2013-09-01','14:35:00',2.24),('1444','2013-09-01','14:40:00',2.29),('1444','2013-09-01','14:45:00',2.32),('1444','2013-09-01','14:50:00',2.29),('1444','2013-09-01','14:55:00',2.22),('1444','2013-09-01','15:00:00',2.21),('1444','2013-09-01','15:05:00',2.17),('1444','2013-09-01','15:10:00',2.16),('1444','2013-09-01','15:15:00',2.15),('1444','2013-09-01','15:20:00',1.98),('1444','2013-09-01','15:25:00',1.7),('1444','2013-09-01','15:30:00',1.42),('1444','2013-09-01','15:35:00',1.65),('1444','2013-09-01','15:40:00',1.93),('1444','2013-09-01','15:45:00',1.73),('1444','2013-09-01','15:50:00',1.3),('1444','2013-09-01','15:55:00',1.55),('1444','2013-09-01','16:00:00',1.88),('1444','2013-09-01','16:05:00',1.94),('1444','2013-09-01','16:10:00',1.86),('1444','2013-09-01','16:15:00',1.85),('1444','2013-09-01','16:20:00',1.65),('1444','2013-09-01','16:25:00',1.72),('1444','2013-09-01','16:30:00',1.77),('1444','2013-09-01','16:35:00',1.69),('1444','2013-09-01','16:40:00',1.68),('1444','2013-09-01','16:45:00',1.53),('1444','2013-09-01','16:50:00',1.46),('1444','2013-09-01','16:55:00',1.28),('1444','2013-09-01','17:00:00',1.11),('1444','2013-09-01','17:05:00',1.16),('1444','2013-09-01','17:20:00',1.05),('1444','2013-08-31','08:40:00',1.07),('1444','2013-08-31','08:45:00',1.16),('1444','2013-08-31','08:50:00',1.27),('1444','2013-08-31','08:55:00',1.39),('1444','2013-08-31','09:00:00',1.43),('1444','2013-08-31','09:05:00',1.24),('1444','2013-08-31','09:10:00',1.03),('1444','2013-08-31','09:15:00',1.34),('1444','2013-08-31','09:20:00',1.42),('1444','2013-08-31','09:25:00',1.62),('1444','2013-08-31','09:30:00',1.69),('1444','2013-08-31','09:35:00',1.77),('1444','2013-08-31','09:40:00',1.8),('1444','2013-08-31','09:45:00',1.74),('1444','2013-08-31','09:50:00',1.74),('1444','2013-08-31','09:55:00',1.89),('1444','2013-08-31','10:00:00',1.99),('1444','2013-08-31','10:05:00',1.96),('1444','2013-08-31','10:10:00',2.05),('1444','2013-08-31','10:15:00',2.08),('1444','2013-08-31','10:20:00',2.12),('1444','2013-08-31','10:25:00',2.16),('1444','2013-08-31','10:30:00',2.2),('1444','2013-08-31','10:35:00',2.27),('1444','2013-08-31','10:40:00',2.29),('1444','2013-08-31','10:45:00',2.32),('1444','2013-08-31','10:50:00',2.4),('1444','2013-08-31','10:55:00',2.41),('1444','2013-08-31','11:00:00',2.47),('1444','2013-08-31','11:05:00',2.5),('1444','2013-08-31','11:10:00',2.53),('1444','2013-08-31','11:15:00',2.56),('1444','2013-08-31','11:20:00',2.58),('1444','2013-08-31','11:25:00',2.6),('1444','2013-08-31','11:30:00',2.63),('1444','2013-08-31','11:35:00',2.66),('1444','2013-08-31','11:40:00',2.7),('1444','2013-08-31','11:45:00',2.72),('1444','2013-08-31','11:50:00',2.74),('1444','2013-08-31','11:55:00',2.75),('1444','2013-08-31','12:00:00',2.71),('1444','2013-08-31','12:05:00',2.14),('1444','2013-08-31','12:10:00',2.26),('1444','2013-08-31','12:15:00',2.57),('1444','2013-08-31','12:20:00',2.75),('1444','2013-08-31','12:25:00',2.73),('1444','2013-08-31','12:30:00',2.72),('1444','2013-08-31','12:35:00',2.76),('1444','2013-08-31','12:40:00',2.73),('1444','2013-08-31','12:45:00',2.78),('1444','2013-08-31','12:50:00',2.77),('1444','2013-08-31','12:55:00',2.78),('1444','2013-08-31','13:00:00',2.78),('1444','2013-08-31','13:05:00',2.79),('1444','2013-08-31','13:10:00',2.77),('1444','2013-08-31','13:15:00',2.72),('1444','2013-08-31','13:20:00',2.67),('1444','2013-08-31','13:25:00',2.76),('1444','2013-08-31','13:30:00',2.77),('1444','2013-08-31','13:35:00',2.74),('1444','2013-08-31','13:40:00',2.69),('1444','2013-08-31','13:45:00',2.62),('1444','2013-08-31','13:50:00',2.7),('1444','2013-08-31','13:55:00',2.7),('1444','2013-08-31','14:00:00',2.7),('1444','2013-08-31','14:05:00',2.69),('1444','2013-08-31','14:10:00',2.67),('1444','2013-08-31','14:15:00',2.63),('1444','2013-08-31','14:20:00',2.6),('1444','2013-08-31','14:25:00',2.55),('1444','2013-08-31','14:30:00',2.52),('1444','2013-08-31','14:35:00',2.42),('1444','2013-08-31','14:40:00',2.47),('1444','2013-08-31','14:45:00',2.46),('1444','2013-08-31','14:50:00',2.48),('1444','2013-08-31','14:55:00',2.4),('1444','2013-08-31','15:00:00',2.38),('1444','2013-08-31','15:05:00',2.36),('1444','2013-08-31','15:10:00',2.35),('1444','2013-08-31','15:15:00',2.3),('1444','2013-08-31','15:20:00',2.26),('1444','2013-08-31','15:25:00',2.24),('1444','2013-08-31','15:30:00',2.22),('1444','2013-08-31','15:35:00',2.14),('1444','2013-08-31','15:40:00',2.13),('1444','2013-08-31','15:45:00',2.08),('1444','2013-08-31','15:50:00',2.05),('1444','2013-08-31','15:55:00',1.99),('1444','2013-08-31','16:00:00',1.96),('1444','2013-08-31','16:05:00',1.92),('1444','2013-08-31','16:10:00',1.87),('1444','2013-08-31','16:15:00',1.83),('1444','2013-08-31','16:20:00',1.81),('1444','2013-08-31','16:25:00',1.74),('1444','2013-08-31','16:30:00',1.68),('1444','2013-08-31','16:35:00',1.68),('1444','2013-08-31','16:40:00',1.63),('1444','2013-08-31','16:45:00',1.53),('1444','2013-08-31','16:50:00',1.46),('1444','2013-08-31','16:55:00',1.42),('1444','2013-08-31','17:00:00',1.35),('1444','2013-08-31','17:05:00',1.33),('1444','2013-08-31','17:10:00',1.28),('1444','2013-08-31','17:15:00',1.21),('1444','2013-08-31','17:20:00',1.17),('1444','2013-08-31','17:25:00',1.11),('1444','2013-08-31','17:30:00',1.06),('1444','2013-08-30','08:35:00',1.03),('1444','2013-08-30','08:40:00',1.06),('1444','2013-08-30','09:00:00',1.02),('1444','2013-08-30','09:05:00',1.12),('1444','2013-08-30','09:30:00',1.12),('1444','2013-08-30','09:35:00',1.25),('1444','2013-08-30','09:40:00',1.19),('1444','2013-08-30','09:45:00',1.22),('1444','2013-08-30','09:50:00',1.23),('1444','2013-08-30','09:55:00',1.34),('1444','2013-08-30','10:00:00',1.36),('1444','2013-08-30','10:05:00',1.37),('1444','2013-08-30','10:10:00',1.36),('1444','2013-08-30','10:15:00',1.45),('1444','2013-08-30','10:20:00',1.53),('1444','2013-08-30','10:25:00',1.41),('1444','2013-08-30','10:30:00',1.55),('1444','2013-08-30','10:35:00',1.5),('1444','2013-08-30','10:40:00',1.41),('1444','2013-08-30','10:45:00',1.39),('1444','2013-08-30','10:50:00',1.47),('1444','2013-08-30','10:55:00',1.39),('1444','2013-08-30','11:00:00',1.48),('1444','2013-08-30','11:05:00',1.55),('1444','2013-08-30','11:10:00',1.63),('1444','2013-08-30','11:15:00',1.64),('1444','2013-08-30','11:20:00',1.66),('1444','2013-08-30','11:25:00',1.7),('1444','2013-08-30','11:30:00',1.8),('1444','2013-08-30','11:35:00',1.72),('1444','2013-08-30','11:40:00',1.86),('1444','2013-08-30','11:45:00',1.86),('1444','2013-08-30','11:50:00',2.08),('1444','2013-08-30','11:55:00',1.84),('1444','2013-08-30','12:00:00',1.67),('1444','2013-08-30','12:05:00',1.45),('1444','2013-08-30','12:10:00',1.56),('1444','2013-08-30','12:15:00',1.71),('1444','2013-08-30','12:20:00',1.85),('1444','2013-08-30','12:25:00',1.98),('1444','2013-08-30','12:30:00',2.22),('1444','2013-08-30','12:35:00',2.15),('1444','2013-08-30','12:40:00',2.11),('1444','2013-08-30','12:45:00',2.21),('1444','2013-08-30','12:50:00',2.17),('1444','2013-08-30','12:55:00',2.02),('1444','2013-08-30','13:00:00',2),('1444','2013-08-30','13:05:00',2),('1444','2013-08-30','13:10:00',1.97),('1444','2013-08-30','13:15:00',1.83),('1444','2013-08-30','13:20:00',2.37),('1444','2013-08-30','13:25:00',2.68),('1444','2013-08-30','13:30:00',2.77),('1444','2013-08-30','13:35:00',2.57),('1444','2013-08-30','13:40:00',2.7),('1444','2013-08-30','13:45:00',2.4),('1444','2013-08-30','13:50:00',2.42),('1444','2013-08-30','13:55:00',2.67),('1444','2013-08-30','14:00:00',2.75),('1444','2013-08-30','14:05:00',2.61),('1444','2013-08-30','14:10:00',2.66),('1444','2013-08-30','14:15:00',2.62),('1444','2013-08-30','14:20:00',2.69),('1444','2013-08-30','14:25:00',2.65),('1444','2013-08-30','14:30:00',2.59),('1444','2013-08-30','14:35:00',2.67),('1444','2013-08-30','14:40:00',2.53),('1444','2013-08-30','14:45:00',1.95),('1444','2013-08-30','14:50:00',1.75),('1444','2013-08-30','14:55:00',1.97),('1444','2013-08-30','15:00:00',1.73),('1444','2013-08-30','15:05:00',1.58),('1444','2013-08-30','15:10:00',1.62),('1444','2013-08-30','15:15:00',1.99),('1444','2013-08-30','15:20:00',1.65),('1444','2013-08-30','15:25:00',1.53),('1444','2013-08-30','15:30:00',1.48),('1444','2013-08-30','15:35:00',1.2),('1444','2013-08-30','15:40:00',1.32),('1444','2013-08-30','15:45:00',1.54),('1444','2013-08-30','15:50:00',1.66),('1444','2013-08-30','15:55:00',1.62),('1444','2013-08-30','16:00:00',1.53),('1444','2013-08-30','16:05:00',1.33),('1444','2013-08-30','16:10:00',1.12),('1444','2013-08-30','16:15:00',1.02),('1444','2013-08-30','16:20:00',1.14),('1444','2013-08-30','16:25:00',1.04),('1444','2013-08-30','16:30:00',1.27),('1444','2013-08-30','16:35:00',1.23),('1444','2013-08-30','16:40:00',1.57),('1444','2013-08-30','16:45:00',1.68),('1444','2013-08-30','16:50:00',1.59),('1444','2013-08-30','16:55:00',1.37),('1444','2013-08-30','17:00:00',1.34),('1444','2013-08-30','17:10:00',1.09),('1444','2013-08-30','17:35:00',1.09),('1444','2014-04-11','08:35:00',1.31),('1444','2014-04-11','08:40:00',1.39),('1444','2014-04-11','08:45:00',1.46),('1444','2014-04-11','08:50:00',1.46),('1444','2014-04-11','08:55:00',1.47),('1444','2014-04-11','09:00:00',1.24),('1444','2014-04-11','09:05:00',1.54),('1444','2014-04-11','09:10:00',1.64),('1444','2014-04-11','09:15:00',1.71),('1444','2014-04-11','09:20:00',1.74),('1444','2014-04-11','09:25:00',1.79),('1444','2014-04-11','09:30:00',1.85),('1444','2014-04-11','09:35:00',1.92),('1444','2014-04-11','09:40:00',1.97),('1444','2014-04-11','09:45:00',2.04),('1444','2014-04-11','09:50:00',2.1),('1444','2014-04-11','09:55:00',2.15),('1444','2014-04-11','10:00:00',2.21),('1444','2014-04-11','10:05:00',2.29),('1444','2014-04-11','10:10:00',2.33),('1444','2014-04-11','10:15:00',2.37),('1444','2014-04-11','10:20:00',2.42),('1444','2014-04-11','10:25:00',2.47),('1444','2014-04-11','10:30:00',2.5),('1444','2014-04-11','10:35:00',2.54),('1444','2014-04-11','10:40:00',2.59),('1444','2014-04-11','10:45:00',2.63),('1444','2014-04-11','10:50:00',2.69),('1444','2014-04-11','10:55:00',2.72),('1444','2014-04-11','11:00:00',2.77),('1444','2014-04-11','11:05:00',2.8),('1444','2014-04-11','11:10:00',2.82),('1444','2014-04-11','11:15:00',2.84),('1444','2014-04-11','11:20:00',2.89),('1444','2014-04-11','11:25:00',2.93),('1444','2014-04-11','11:30:00',2.96),('1444','2014-04-11','11:35:00',2.99),('1444','2014-04-11','11:40:00',3.01),('1444','2014-04-11','11:45:00',3.06),('1444','2014-04-11','11:50:00',3),('1444','2014-04-11','11:55:00',2.99),('1444','2014-04-11','12:00:00',2.98),('1444','2014-04-11','12:05:00',3.17),('1444','2014-04-11','12:10:00',3.12),('1444','2014-04-11','12:15:00',2.77),('1444','2014-04-11','12:20:00',3.21),('1444','2014-04-11','12:25:00',3.21),('1444','2014-04-11','12:30:00',3.27),('1444','2014-04-11','12:35:00',3.36),('1444','2014-04-11','12:40:00',3.35),('1444','2014-04-11','12:45:00',2.35),('1444','2014-04-11','12:50:00',3.52),('1444','2014-04-11','12:55:00',3.33),('1444','2014-04-11','13:00:00',3.55),('1444','2014-04-11','13:05:00',3.47),('1444','2014-04-11','13:10:00',3.5),('1444','2014-04-11','13:15:00',2.19),('1444','2014-04-11','13:20:00',2.73),('1444','2014-04-11','13:25:00',3.41),('1444','2014-04-11','13:30:00',2.75),('1444','2014-04-11','13:35:00',1.87),('1444','2014-04-11','13:40:00',2.39),('1444','2014-04-11','13:45:00',3.37),('1444','2014-04-11','13:50:00',3.24),('1444','2014-04-11','13:55:00',2.86),('1444','2014-04-11','14:00:00',3.01),('1444','2014-04-11','14:05:00',2.88),('1444','2014-04-11','14:10:00',1.62),('1444','2014-04-11','14:15:00',1.47),('1444','2014-04-11','14:20:00',2.22),('1444','2014-04-11','14:25:00',2.03),('1444','2014-04-11','14:30:00',2.72),('1444','2014-04-11','14:35:00',3.19),('1444','2014-04-11','14:40:00',1.82),('1444','2014-04-11','14:45:00',2.29),('1444','2014-04-11','14:50:00',2.94),('1444','2014-04-11','14:55:00',1.74),('1444','2014-04-11','15:00:00',2.75),('1444','2014-04-11','15:05:00',2.11),('1444','2014-04-11','15:10:00',2.72),('1444','2014-04-11','15:15:00',2.88),('1444','2014-04-11','15:20:00',2.34),('1444','2014-04-11','15:25:00',2.78),('1444','2014-04-11','15:30:00',2.65),('1444','2014-04-11','15:35:00',2.31),('1444','2014-04-11','15:40:00',2.59),('1444','2014-04-11','15:45:00',2.52),('1444','2014-04-11','15:50:00',2.49),('1444','2014-04-11','15:55:00',2.48),('1444','2014-04-11','16:00:00',2.39),('1444','2014-04-11','16:05:00',2.3),('1444','2014-04-11','16:10:00',1.94),('1444','2014-04-11','16:15:00',2.15),('1444','2014-04-11','16:20:00',2.14),('1444','2014-04-11','16:25:00',2.1),('1444','2014-04-11','16:30:00',2.06),('1444','2014-04-11','16:35:00',1.74),('1444','2014-04-11','16:40:00',1.91),('1444','2014-04-11','16:45:00',1.9),('1444','2014-04-11','16:50:00',1.22),('1444','2014-04-11','16:55:00',1.9),('1444','2014-04-11','17:00:00',1.75),('1444','2014-04-11','17:05:00',1.55),('1444','2014-04-11','17:10:00',1.39),('1444','2014-04-11','17:15:00',1.33),('1444','2014-04-11','17:20:00',1.49),('1444','2014-04-11','17:25:00',1.41),('1444','2014-04-11','17:30:00',1.42),('1444','2014-04-11','17:35:00',1.38),('1444','2014-04-11','17:40:00',1.3),('1444','2014-04-11','17:45:00',1.17),('1444','2014-04-11','17:50:00',1.06),('1444','2013-08-29','08:25:00',1.1),('1444','2013-08-29','08:30:00',1.26),('1444','2013-08-29','08:35:00',1.2),('1444','2013-08-29','08:55:00',1.18),('1444','2013-08-29','09:00:00',1.15),('1444','2013-08-29','09:05:00',1.14),('1444','2013-08-29','09:10:00',1.1),('1444','2013-08-29','09:15:00',1.17),('1444','2013-08-29','09:20:00',1.15),('1444','2013-08-29','09:25:00',1.06),('1444','2013-08-29','09:30:00',1.11),('1444','2013-08-29','09:35:00',1.22),('1444','2013-08-29','09:40:00',1.2),('1444','2013-08-29','09:45:00',1.1),('1444','2013-08-29','09:50:00',1.06),('1444','2013-08-29','09:55:00',1.11),('1444','2013-08-29','10:00:00',1.17),('1444','2013-08-29','10:05:00',1.11),('1444','2013-08-29','10:10:00',1.09),('1444','2013-08-29','10:15:00',1.09),('1444','2013-08-29','10:20:00',1.11),('1444','2013-08-29','10:25:00',1.12),('1444','2013-08-29','10:30:00',1.15),('1444','2013-08-29','10:35:00',1.08),('1444','2013-08-29','10:55:00',1.04),('1444','2013-08-29','11:00:00',1.1),('1444','2013-08-29','11:05:00',1.12),('1444','2013-08-29','11:10:00',1.66),('1444','2013-08-29','11:15:00',1.86),('1444','2013-08-29','11:20:00',1.7),('1444','2013-08-29','11:25:00',1.27),('1444','2013-08-29','11:30:00',1.11),('1444','2013-08-29','11:35:00',1.01),('1444','2013-08-29','11:40:00',1.15),('1444','2013-08-29','11:45:00',1.35),('1444','2013-08-29','11:50:00',1.39),('1444','2013-08-29','11:55:00',1.34),('1444','2013-08-29','12:00:00',1.32),('1444','2013-08-29','12:05:00',1.58),('1444','2013-08-29','12:10:00',1.81),('1444','2013-08-29','12:15:00',2.08),('1444','2013-08-29','12:20:00',1.85),('1444','2013-08-29','12:25:00',1.89),('1444','2013-08-29','12:30:00',1.92),('1444','2013-08-29','12:35:00',2.5),('1444','2013-08-29','12:40:00',3.31),('1444','2013-08-29','12:45:00',2.93),('1444','2013-08-29','12:50:00',1.87),('1444','2013-08-29','12:55:00',2.92),('1444','2013-08-29','13:00:00',1.91),('1444','2013-08-29','13:05:00',1.83),('1444','2013-08-29','13:10:00',1.77),('1444','2013-08-29','13:15:00',1.72),('1444','2013-08-29','13:20:00',1.64),('1444','2013-08-29','13:25:00',1.44),('1444','2013-08-29','13:30:00',1.33),('1444','2013-08-29','13:35:00',1.26),('1444','2013-08-29','13:40:00',1.21),('1444','2013-08-29','13:45:00',1.14),('1444','2013-08-29','13:50:00',1.12),('1444','2013-08-29','13:55:00',1.31),('1444','2013-08-29','14:00:00',1.61),('1444','2013-08-29','14:05:00',1.23),('1444','2013-08-29','14:10:00',1.11),('1444','2013-08-29','14:55:00',1.02),('1444','2013-08-29','15:00:00',1.12),('1444','2013-08-29','15:05:00',1.24),('1444','2013-08-29','15:25:00',1.08),('1444','2013-08-29','15:30:00',1.76),('1444','2013-08-29','15:35:00',1.57),('1444','2013-08-29','15:40:00',1.54),('1444','2013-08-29','15:45:00',1.75),('1444','2013-08-29','15:50:00',2.05),('1444','2013-08-29','15:55:00',2.09),('1444','2013-08-29','16:00:00',2.08),('1444','2013-08-29','16:05:00',2.27),('1444','2013-08-29','16:10:00',2.16),('1444','2013-08-29','16:15:00',1.98),('1444','2013-08-29','16:20:00',1.93),('1444','2013-08-29','16:25:00',1.84),('1444','2013-08-29','16:30:00',1.82),('1444','2013-08-29','16:35:00',1.76),('1444','2013-08-29','16:40:00',1.71),('1444','2013-08-29','16:45:00',1.66),('1444','2013-08-29','16:50:00',1.6),('1444','2013-08-29','16:55:00',1.55),('1444','2013-08-29','17:00:00',1.5),('1444','2013-08-29','17:05:00',1.44),('1444','2013-08-29','17:10:00',1.38),('1444','2013-08-29','17:15:00',1.33),('1444','2013-08-29','17:20:00',1.27),('1444','2013-08-29','17:25:00',1.19),('1444','2013-08-29','17:30:00',1.14),('1444','2013-08-29','17:35:00',1.08),('1444','2013-08-29','17:40:00',1.02),('1444','2013-08-28','08:35:00',1.07),('1444','2013-08-28','09:15:00',1.15),('1444','2013-08-28','09:35:00',1.4),('1444','2013-08-28','09:40:00',1.69),('1444','2013-08-28','09:45:00',1.8),('1444','2013-08-28','09:50:00',1.87),('1444','2013-08-28','09:55:00',1.88),('1444','2013-08-28','10:00:00',1.85),('1444','2013-08-28','10:05:00',1.95),('1444','2013-08-28','10:10:00',2.04),('1444','2013-08-28','10:15:00',2.14),('1444','2013-08-28','10:20:00',2.3),('1444','2013-08-28','10:30:00',1.14),('1444','2013-08-28','10:35:00',1.51),('1444','2013-08-28','10:40:00',2.15),('1444','2013-08-28','10:45:00',2.56),('1444','2013-08-28','10:50:00',2.48),('1444','2013-08-28','10:55:00',2.46),('1444','2013-08-28','11:00:00',1.14),('1444','2013-08-28','11:05:00',2.75),('1444','2013-08-28','11:10:00',1.66),('1444','2013-08-28','11:15:00',2.92),('1444','2013-08-28','11:20:00',2.7),('1444','2013-08-28','11:25:00',2.77),('1444','2013-08-28','11:30:00',2.83),('1444','2013-08-28','11:35:00',2.87),('1444','2013-08-28','11:40:00',2.89),('1444','2013-08-28','11:45:00',2.77),('1444','2013-08-28','11:50:00',2.62),('1444','2013-08-28','12:00:00',2.61),('1444','2013-08-28','12:05:00',2.88),('1444','2013-08-28','12:10:00',1.6),('1444','2013-08-28','12:15:00',2.96),('1444','2013-08-28','12:20:00',2.75),('1444','2013-08-28','12:25:00',2.9),('1444','2013-08-28','12:30:00',2.88),('1444','2013-08-28','12:35:00',2.89),('1444','2013-08-28','12:40:00',2.92),('1444','2013-08-28','12:45:00',3),('1444','2013-08-28','12:50:00',2.93),('1444','2013-08-28','12:55:00',2.92),('1444','2013-08-28','13:00:00',2.98),('1444','2013-08-28','13:05:00',3.04),('1444','2013-08-28','13:10:00',2.95),('1444','2013-08-28','13:15:00',2.97),('1444','2013-08-28','13:20:00',2.91),('1444','2013-08-28','13:25:00',2.49),('1444','2013-08-28','13:30:00',2.82),('1444','2013-08-28','13:35:00',2.96),('1444','2013-08-28','13:40:00',1.67),('1444','2013-08-28','13:45:00',3.04),('1444','2013-08-28','13:50:00',2.95),('1444','2013-08-28','13:55:00',1.98),('1444','2013-08-28','14:00:00',2.83),('1444','2013-08-28','14:05:00',2.86),('1444','2013-08-28','14:10:00',2.85),('1444','2013-08-28','14:15:00',2.82),('1444','2013-08-28','14:20:00',2.8),('1444','2013-08-28','14:25:00',2.79),('1444','2013-08-28','14:30:00',2.7),('1444','2013-08-28','14:35:00',2.85),('1444','2013-08-28','14:40:00',2.76),('1444','2013-08-28','14:45:00',2.69),('1444','2013-08-28','14:50:00',2.66),('1444','2013-08-28','14:55:00',2.63),('1444','2013-08-28','15:00:00',2.59),('1444','2013-08-28','15:05:00',2.5),('1444','2013-08-28','15:10:00',2.42),('1444','2013-08-28','15:15:00',2.58),('1444','2013-08-28','15:20:00',2.34),('1444','2013-08-28','15:25:00',1.91),('1444','2013-08-28','15:30:00',2.27),('1444','2013-08-28','15:35:00',2.61),('1444','2013-08-28','15:50:00',1.74),('1444','2013-08-28','15:55:00',2.46),('1444','2013-08-28','16:00:00',2.3),('1444','2013-08-28','16:05:00',1.32),('1444','2013-08-28','16:10:00',1.69),('1444','2013-08-28','16:15:00',1.62),('1444','2013-08-28','16:20:00',1.97),('1444','2013-08-28','16:25:00',2.05),('1444','2013-08-28','16:30:00',1.93),('1444','2013-08-28','16:35:00',1.88),('1444','2013-08-28','16:40:00',1.82),('1444','2013-08-28','16:45:00',1.72),('1444','2013-08-28','16:50:00',1.66),('1444','2013-08-28','16:55:00',1.63),('1444','2013-08-28','17:00:00',1.58),('1444','2013-08-28','17:05:00',1.49),('1444','2013-08-28','17:10:00',1.45),('1444','2013-08-28','17:15:00',1.14),('1444','2013-08-28','17:25:00',1.48),('1444','2013-08-28','17:30:00',1.13),('1444','2013-08-28','17:35:00',1.1),('1444','2013-08-28','17:40:00',1.14),('1444','2013-08-27','08:25:00',1.04),('1444','2013-08-27','08:30:00',1.02),('1444','2013-08-27','09:20:00',1.07),('1444','2013-08-27','09:25:00',1.38),('1444','2013-08-27','09:30:00',1.47),('1444','2013-08-27','09:55:00',1.01),('1444','2013-08-27','10:00:00',1.32),('1444','2013-08-27','10:05:00',1.56),('1444','2013-08-27','10:10:00',1.96),('1444','2013-08-27','10:15:00',1.98),('1444','2013-08-27','10:20:00',2.08),('1444','2013-08-27','10:25:00',2.13),('1444','2013-08-27','10:30:00',2.13),('1444','2013-08-27','10:35:00',2.15),('1444','2013-08-27','10:40:00',2.16),('1444','2013-08-27','10:45:00',2.21),('1444','2013-08-27','10:50:00',2.25),('1444','2013-08-27','10:55:00',2.2),('1444','2013-08-27','11:00:00',2.26),('1444','2013-08-27','11:05:00',2.36),('1444','2013-08-27','11:10:00',2.37),('1444','2013-08-27','11:15:00',2.35),('1444','2013-08-27','11:20:00',2.42),('1444','2013-08-27','11:25:00',2.43),('1444','2013-08-27','11:30:00',2.46),('1444','2013-08-27','11:35:00',2.4),('1444','2013-08-27','11:40:00',2.19),('1444','2013-08-27','11:45:00',2.82),('1444','2013-08-27','11:50:00',1.9),('1444','2013-08-27','11:55:00',2.73),('1444','2013-08-27','12:00:00',2.99),('1444','2013-08-27','12:05:00',2.67),('1444','2013-08-27','12:10:00',2.13),('1444','2013-08-27','12:15:00',2.33),('1444','2013-08-27','12:20:00',2.63),('1444','2013-08-27','12:25:00',2.51),('1444','2013-08-27','12:30:00',2.81),('1444','2013-08-27','12:35:00',2.97),('1444','2013-08-27','12:40:00',2.94),('1444','2013-08-27','12:45:00',2.09),('1444','2013-08-27','12:50:00',1.56),('1444','2013-08-27','12:55:00',1.17),('1444','2013-08-27','13:05:00',1.2),('1444','2013-08-27','13:10:00',1.18),('1444','2013-08-27','13:15:00',1.34),('1444','2013-08-27','13:20:00',1.48),('1444','2013-08-27','13:25:00',1.62),('1444','2013-08-27','13:30:00',1.74),('1444','2013-08-27','13:35:00',1.55),('1444','2013-08-27','13:40:00',1.46),('1444','2013-08-27','13:45:00',2.23),('1444','2013-08-27','13:50:00',2.47),('1444','2013-08-27','13:55:00',2.36),('1444','2013-08-27','14:00:00',2.89),('1444','2013-08-27','14:05:00',1.44),('1444','2013-08-27','14:10:00',1.66),('1444','2013-08-27','14:15:00',2.07),('1444','2013-08-27','14:20:00',1.37),('1444','2013-08-27','15:55:00',1),('1444','2013-08-27','16:00:00',1.03),('1444','2013-08-27','16:05:00',1.58),('1444','2013-08-27','16:10:00',2.49),('1444','2013-08-27','16:15:00',2.24),('1444','2013-08-27','16:20:00',1.63),('1444','2013-08-27','16:25:00',1.56),('1444','2013-08-27','16:40:00',1.47),('1444','2013-08-27','16:45:00',1.03),('1444','2013-08-27','16:50:00',1.94),('1444','2013-08-27','16:55:00',1.48),('1444','2013-08-27','17:10:00',1.83),('1444','2013-08-27','17:50:00',1.03),('1444','2013-08-27','17:55:00',1.05),('1444','2014-04-10','08:20:00',1.03),('1444','2014-04-10','08:25:00',1.1),('1444','2014-04-10','08:30:00',1.17),('1444','2014-04-10','08:35:00',1.24),('1444','2014-04-10','08:40:00',1.32),('1444','2014-04-10','08:45:00',1.39),('1444','2014-04-10','08:50:00',1.46),('1444','2014-04-10','08:55:00',1.52),('1444','2014-04-10','09:00:00',1.58),('1444','2014-04-10','09:05:00',1.67),('1444','2014-04-10','09:10:00',1.72),('1444','2014-04-10','09:15:00',1.76),('1444','2014-04-10','09:20:00',1.77),('1444','2014-04-10','09:25:00',1.9),('1444','2014-04-10','09:30:00',1.98),('1444','2014-04-10','09:35:00',2.04),('1444','2014-04-10','09:40:00',2.08),('1444','2014-04-10','09:45:00',2.13),('1444','2014-04-10','09:50:00',2.21),('1444','2014-04-10','09:55:00',2.26),('1444','2014-04-10','10:00:00',2.31),('1444','2014-04-10','10:05:00',2.37),('1444','2014-04-10','10:10:00',2.44),('1444','2014-04-10','10:15:00',2.43),('1444','2014-04-10','10:20:00',2.49),('1444','2014-04-10','10:25:00',2.53),('1444','2014-04-10','10:30:00',2.56),('1444','2014-04-10','10:35:00',2.64),('1444','2014-04-10','10:40:00',2.69),('1444','2014-04-10','10:45:00',2.69),('1444','2014-04-10','10:50:00',2.67),('1444','2014-04-10','10:55:00',2.75),('1444','2014-04-10','11:00:00',2.75),('1444','2014-04-10','11:05:00',2.87),('1444','2014-04-10','11:10:00',2.78),('1444','2014-04-10','11:15:00',2.9),('1444','2014-04-10','11:20:00',2.98),('1444','2014-04-10','11:25:00',3.04),('1444','2014-04-10','11:30:00',3.05),('1444','2014-04-10','11:35:00',3.1),('1444','2014-04-10','11:40:00',2.97),('1444','2014-04-10','11:45:00',3.09),('1444','2014-04-10','11:50:00',2.99),('1444','2014-04-10','11:55:00',3.14),('1444','2014-04-10','12:00:00',3.1),('1444','2014-04-10','12:05:00',2.94),('1444','2014-04-10','12:10:00',3.04),('1444','2014-04-10','12:15:00',3.11),('1444','2014-04-10','12:20:00',3.14),('1444','2014-04-10','12:25:00',2.99),('1444','2014-04-10','12:30:00',3.05),('1444','2014-04-10','12:35:00',3.24),('1444','2014-04-10','12:40:00',3.05),('1444','2014-04-10','12:45:00',3.14),('1444','2014-04-10','12:50:00',3.15),('1444','2014-04-10','12:55:00',3.12),('1444','2014-04-10','13:00:00',3.03),('1444','2014-04-10','13:05:00',2.94),('1444','2014-04-10','13:10:00',3.03),('1444','2014-04-10','13:15:00',3.06),('1444','2014-04-10','13:20:00',2.94),('1444','2014-04-10','13:25:00',3.2),('1444','2014-04-10','13:30:00',3.12),('1444','2014-04-10','13:35:00',3.2),('1444','2014-04-10','13:40:00',3.03),('1444','2014-04-10','13:45:00',3.16),('1444','2014-04-10','13:50:00',3.18),('1444','2014-04-10','13:55:00',3.18),('1444','2014-04-10','14:00:00',3.14),('1444','2014-04-10','14:05:00',3.07),('1444','2014-04-10','14:10:00',3.02),('1444','2014-04-10','14:15:00',3.03),('1444','2014-04-10','14:20:00',3.09),('1444','2014-04-10','14:25:00',3.07),('1444','2014-04-10','14:30:00',3.01),('1444','2014-04-10','14:35:00',2.99),('1444','2014-04-10','14:40:00',2.95),('1444','2014-04-10','14:45:00',2.64),('1444','2014-04-10','14:50:00',2.96),('1444','2014-04-10','14:55:00',2.9),('1444','2014-04-10','15:00:00',2.86),('1444','2014-04-10','15:05:00',2.83),('1444','2014-04-10','15:10:00',2.75),('1444','2014-04-10','15:15:00',2.73),('1444','2014-04-10','15:20:00',2.71),('1444','2014-04-10','15:25:00',2.65),('1444','2014-04-10','15:30:00',2.43),('1444','2014-04-10','15:35:00',2.35),('1444','2014-04-10','15:40:00',2.35),('1444','2014-04-10','15:45:00',2.42),('1444','2014-04-10','15:50:00',2.41),('1444','2014-04-10','15:55:00',2.36),('1444','2014-04-10','16:00:00',2.33),('1444','2014-04-10','16:05:00',2.34),('1444','2014-04-10','16:10:00',2.31),('1444','2014-04-10','16:15:00',2.36),('1444','2014-04-10','16:20:00',2.25),('1444','2014-04-10','16:25:00',2.21),('1444','2014-04-10','16:30:00',2.19),('1444','2014-04-10','16:35:00',2.08),('1444','2014-04-10','16:40:00',2.05),('1444','2014-04-10','16:45:00',2.06),('1444','2014-04-10','16:50:00',1.89),('1444','2014-04-10','16:55:00',1.86),('1444','2014-04-10','17:00:00',1.78),('1444','2014-04-10','17:05:00',1.72),('1444','2014-04-10','17:10:00',1.64),('1444','2014-04-10','17:15:00',1.54),('1444','2014-04-10','17:20:00',1.51),('1444','2014-04-10','17:25:00',1.42),('1444','2014-04-10','17:30:00',1.34),('1444','2014-04-10','17:35:00',1.26),('1444','2014-04-10','17:40:00',1.19),('1444','2014-04-10','17:45:00',1.12),('1444','2014-04-10','17:50:00',1.05),('1444','2014-04-09','09:50:00',1.75),('1444','2014-04-09','09:55:00',2.16),('1444','2014-04-09','10:00:00',2.19),('1444','2014-04-09','10:05:00',2.17),('1444','2014-04-09','10:10:00',2.24),('1444','2014-04-09','10:15:00',2.25),('1444','2014-04-09','10:20:00',2.43),('1444','2014-04-09','10:25:00',2.64),('1444','2014-04-09','10:30:00',2.81),('1444','2014-04-09','10:35:00',1.49),('1444','2014-04-09','10:45:00',1.56),('1444','2014-04-09','10:55:00',2.94),('1444','2014-04-09','11:00:00',3.04),('1444','2014-04-09','11:05:00',3.05),('1444','2014-04-09','11:10:00',3.12),('1444','2014-04-09','11:15:00',3.25),('1444','2014-04-09','11:20:00',3.27),('1444','2014-04-09','11:25:00',3.16),('1444','2014-04-09','11:30:00',2.09),('1444','2014-04-09','11:35:00',3.23),('1444','2014-04-09','11:40:00',3.32),('1444','2014-04-09','11:45:00',2.99),('1444','2014-04-09','11:50:00',3.35),('1444','2014-04-09','11:55:00',3.22),('1444','2014-04-09','12:00:00',3.43),('1444','2014-04-09','12:05:00',3.02),('1444','2014-04-09','12:10:00',3.17),('1444','2014-04-09','12:15:00',1.38),('1444','2014-04-09','12:20:00',2.06),('1444','2014-04-09','13:20:00',1),('1444','2014-04-09','14:05:00',1.08),('1444','2014-04-09','14:10:00',1.12),('1444','2014-04-09','14:15:00',1.06),('1444','2014-04-09','14:30:00',1.08),('1444','2014-04-09','14:35:00',1.05),('1444','2014-04-09','14:40:00',1.49),('1444','2014-04-09','14:45:00',1.64),('1444','2014-04-09','14:50:00',1.76),('1444','2014-04-09','14:55:00',1.5),('1444','2014-04-09','15:00:00',1.33),('1444','2014-04-09','15:05:00',1.3),('1444','2014-04-09','15:10:00',2.77),('1444','2014-04-09','15:15:00',3.07),('1444','2014-04-09','15:20:00',2.38),('1444','2014-04-09','15:25:00',2.02),('1444','2014-04-09','15:30:00',2.23),('1444','2014-04-09','15:35:00',1.43),('1444','2014-04-09','15:40:00',1.34),('1444','2014-04-09','15:45:00',1.2),('1444','2014-04-09','15:50:00',1.02),('1444','2014-04-09','16:00:00',1.18),('1444','2014-04-09','16:05:00',1.46),('1444','2014-04-09','16:10:00',1.65),('1444','2014-04-09','16:15:00',2.08),('1444','2014-04-09','16:20:00',2.19),('1444','2014-04-09','16:25:00',2.14),('1444','2014-04-09','16:30:00',2.34),('1444','2014-04-09','16:35:00',2.42),('1444','2014-04-09','16:40:00',1.97),('1444','2014-04-09','16:45:00',2.32),('1444','2014-04-09','16:50:00',2.12),('1444','2014-04-09','16:55:00',1.86),('1444','2014-04-09','17:00:00',1.83),('1444','2014-04-09','17:05:00',1.86),('1444','2014-04-09','17:10:00',1.6),('1444','2014-04-09','17:15:00',1.46),('1444','2014-04-09','17:20:00',1.41),('1444','2014-04-09','17:25:00',1.36),('1444','2014-04-09','17:30:00',1.22),('1444','2013-08-03','08:20:00',1.04),('1444','2013-08-03','08:25:00',1.09),('1444','2013-08-03','08:30:00',1.15),('1444','2013-08-03','08:35:00',1.2),('1444','2013-08-03','08:40:00',1.25),('1444','2013-08-03','08:45:00',1.3),('1444','2013-08-03','08:50:00',1.36),('1444','2013-08-03','08:55:00',1.41),('1444','2013-08-03','09:00:00',1.46),('1444','2013-08-03','09:05:00',1.52),('1444','2013-08-03','09:10:00',1.57),('1444','2013-08-03','09:15:00',1.63),('1444','2013-08-03','09:20:00',1.67),('1444','2013-08-03','09:25:00',1.72),('1444','2013-08-03','09:30:00',1.76),('1444','2013-08-03','09:35:00',1.8),('1444','2013-08-03','09:40:00',1.85),('1444','2013-08-03','09:45:00',1.9),('1444','2013-08-03','09:50:00',1.95),('1444','2013-08-03','09:55:00',2),('1444','2013-08-03','10:00:00',2.03),('1444','2013-08-03','10:05:00',2.06),('1444','2013-08-03','10:10:00',2.11),('1444','2013-08-03','10:15:00',2.15),('1444','2013-08-03','10:20:00',2.2),('1444','2013-08-03','10:25:00',2.25),('1444','2013-08-03','10:30:00',2.28),('1444','2013-08-03','10:35:00',2.3),('1444','2013-08-03','10:40:00',2.34),('1444','2013-08-03','10:45:00',2.38),('1444','2013-08-03','10:50:00',2.39),('1444','2013-08-03','10:55:00',2.41),('1444','2013-08-03','11:00:00',2.46),('1444','2013-08-03','11:05:00',2.47),('1444','2013-08-03','11:10:00',2.5),('1444','2013-08-03','11:15:00',2.54),('1444','2013-08-03','11:20:00',2.57),('1444','2013-08-03','11:25:00',2.59),('1444','2013-08-03','11:30:00',2.59),('1444','2013-08-03','11:35:00',2.6),('1444','2013-08-03','11:40:00',2.63),('1444','2013-08-03','11:45:00',2.64),('1444','2013-08-03','11:50:00',2.67),('1444','2013-08-03','11:55:00',2.69),('1444','2013-08-03','12:00:00',2.68),('1444','2013-08-03','12:05:00',2.69),('1444','2013-08-03','12:10:00',2.67),('1444','2013-08-03','12:15:00',2.67),('1444','2013-08-03','12:20:00',2.71),('1444','2013-08-03','12:25:00',2.7),('1444','2013-08-03','12:30:00',2.71),('1444','2013-08-03','12:35:00',2.7),('1444','2013-08-03','12:40:00',2.7),('1444','2013-08-03','12:45:00',2.73),('1444','2013-08-03','12:50:00',2.7),('1444','2013-08-03','12:55:00',2.71),('1444','2013-08-03','13:00:00',2.72),('1444','2013-08-03','13:05:00',2.73),('1444','2013-08-03','13:10:00',2.74),('1444','2013-08-03','13:15:00',2.73),('1444','2013-08-03','13:20:00',2.72),('1444','2013-08-03','13:25:00',2.71),('1444','2013-08-03','13:30:00',2.71),('1444','2013-08-03','13:35:00',2.76),('1444','2013-08-03','13:40:00',2.75),('1444','2013-08-03','13:45:00',2.72),('1444','2013-08-03','13:50:00',2.71),('1444','2013-08-03','13:55:00',2.68),('1444','2013-08-03','14:00:00',2.67),('1444','2013-08-03','14:05:00',2.66),('1444','2013-08-03','14:10:00',2.62),('1444','2013-08-03','14:15:00',2.62),('1444','2013-08-03','14:20:00',2.67),('1444','2013-08-03','14:25:00',2.66),('1444','2013-08-03','14:30:00',2.64),('1444','2013-08-03','14:35:00',2.68),('1444','2013-08-03','14:40:00',2.67),('1444','2013-08-03','14:45:00',2.66),('1444','2013-08-03','14:50:00',2.64),('1444','2013-08-03','14:55:00',2.61),('1444','2013-08-03','15:00:00',2.59),('1444','2013-08-03','15:05:00',2.56),('1444','2013-08-03','15:10:00',2.54),('1444','2013-08-03','15:15:00',2.53),('1444','2013-08-03','15:20:00',2.49),('1444','2013-08-03','15:25:00',2.48),('1444','2013-08-03','15:30:00',2.45),('1444','2013-08-03','15:35:00',2.42),('1444','2013-08-03','15:40:00',2.38),('1444','2013-08-03','15:45:00',2.35),('1444','2013-08-03','15:50:00',2.33),('1444','2013-08-03','15:55:00',2.28),('1444','2013-08-03','16:00:00',2.23),('1444','2013-08-03','16:05:00',2.17),('1444','2013-08-03','16:10:00',2.12),('1444','2013-08-03','16:15:00',2.08),('1444','2013-08-03','16:20:00',2.04),('1444','2013-08-03','16:25:00',1.99),('1444','2013-08-03','16:30:00',1.97),('1444','2013-08-03','16:35:00',1.92),('1444','2013-08-03','16:40:00',1.87),('1444','2013-08-03','16:45:00',1.8),('1444','2013-08-03','16:50:00',1.68),('1444','2013-08-03','16:55:00',1.45),('1444','2013-08-03','17:00:00',1.57),('1444','2013-08-03','17:05:00',1.63),('1444','2013-08-03','17:10:00',1.6),('1444','2013-08-03','17:15:00',1.55),('1444','2013-08-03','17:20:00',1.5),('1444','2013-08-03','17:25:00',1.44),('1444','2013-08-03','17:30:00',1.39),('1444','2013-08-03','17:35:00',1.35),('1444','2013-08-03','17:40:00',1.28),('1444','2013-08-03','17:45:00',1.23),('1444','2013-08-03','17:50:00',1.18),('1444','2013-08-03','17:55:00',1.12),('1444','2013-08-03','18:00:00',1.07),('1444','2013-08-03','18:05:00',1.01),('1444','2013-08-02','08:15:00',1.04),('1444','2013-08-02','08:20:00',1.1),('1444','2013-08-02','08:25:00',1.16),('1444','2013-08-02','08:30:00',1.21),('1444','2013-08-02','08:35:00',1.27),('1444','2013-08-02','08:40:00',1.33),('1444','2013-08-02','08:45:00',1.38),('1444','2013-08-02','08:50:00',1.43),('1444','2013-08-02','08:55:00',1.48),('1444','2013-08-02','09:00:00',1.54),('1444','2013-08-02','09:05:00',1.6),('1444','2013-08-02','09:10:00',1.65),('1444','2013-08-02','09:15:00',1.7),('1444','2013-08-02','09:20:00',1.75),('1444','2013-08-02','09:25:00',1.79),('1444','2013-08-02','09:30:00',1.85),('1444','2013-08-02','09:35:00',1.88),('1444','2013-08-02','09:40:00',1.93),('1444','2013-08-02','09:45:00',1.97),('1444','2013-08-02','09:50:00',2.02),('1444','2013-08-02','09:55:00',2.06),('1444','2013-08-02','10:00:00',2.09),('1444','2013-08-02','10:05:00',2.13),('1444','2013-08-02','10:10:00',2.17),('1444','2013-08-02','10:15:00',2.22),('1444','2013-08-02','10:20:00',2.26),('1444','2013-08-02','10:25:00',2.28),('1444','2013-08-02','10:30:00',2.34),('1444','2013-08-02','10:35:00',2.37),('1444','2013-08-02','10:40:00',2.41),('1444','2013-08-02','10:45:00',2.46),('1444','2013-08-02','10:50:00',2.49),('1444','2013-08-02','10:55:00',2.5),('1444','2013-08-02','11:00:00',2.51),('1444','2013-08-02','11:05:00',2.53),('1444','2013-08-02','11:10:00',2.55),('1444','2013-08-02','11:15:00',2.59),('1444','2013-08-02','11:20:00',2.61),('1444','2013-08-02','11:25:00',2.66),('1444','2013-08-02','11:30:00',2.67),('1444','2013-08-02','11:35:00',2.69),('1444','2013-08-02','11:40:00',2.71),('1444','2013-08-02','11:45:00',2.73),('1444','2013-08-02','11:50:00',2.73),('1444','2013-08-02','11:55:00',2.75),('1444','2013-08-02','12:00:00',2.78),('1444','2013-08-02','12:05:00',2.8),('1444','2013-08-02','12:10:00',2.8),('1444','2013-08-02','12:15:00',2.83),('1444','2013-08-02','12:20:00',2.84),('1444','2013-08-02','12:25:00',2.83),('1444','2013-08-02','12:30:00',2.83),('1444','2013-08-02','12:35:00',2.83),('1444','2013-08-02','12:40:00',2.86),('1444','2013-08-02','12:45:00',2.87),('1444','2013-08-02','12:50:00',2.88),('1444','2013-08-02','12:55:00',2.85),('1444','2013-08-02','13:00:00',2.84),('1444','2013-08-02','13:05:00',2.85),('1444','2013-08-02','13:10:00',2.84),('1444','2013-08-02','13:15:00',2.85),('1444','2013-08-02','13:20:00',2.85),('1444','2013-08-02','13:25:00',2.87),('1444','2013-08-02','13:30:00',2.84),('1444','2013-08-02','13:35:00',2.82),('1444','2013-08-02','13:40:00',2.85),('1444','2013-08-02','13:45:00',2.84),('1444','2013-08-02','13:50:00',2.84),('1444','2013-08-02','13:55:00',2.84),('1444','2013-08-02','14:00:00',2.84),('1444','2013-08-02','14:05:00',2.82),('1444','2013-08-02','14:10:00',2.8),('1444','2013-08-02','14:15:00',2.77),('1444','2013-08-02','14:20:00',2.73),('1444','2013-08-02','14:25:00',2.72),('1444','2013-08-02','14:30:00',2.74),('1444','2013-08-02','14:35:00',2.76),('1444','2013-08-02','14:40:00',2.74),('1444','2013-08-02','14:45:00',2.72),('1444','2013-08-02','14:50:00',2.7),('1444','2013-08-02','14:55:00',2.68),('1444','2013-08-02','15:00:00',2.64),('1444','2013-08-02','15:05:00',2.61),('1444','2013-08-02','15:10:00',2.58),('1444','2013-08-02','15:15:00',2.55),('1444','2013-08-02','15:20:00',2.54),('1444','2013-08-02','15:25:00',2.52),('1444','2013-08-02','15:30:00',2.49),('1444','2013-08-02','15:35:00',2.46),('1444','2013-08-02','15:40:00',2.42),('1444','2013-08-02','15:45:00',2.4),('1444','2013-08-02','15:50:00',2.36),('1444','2013-08-02','15:55:00',2.33),('1444','2013-08-02','16:00:00',2.3),('1444','2013-08-02','16:05:00',2.25),('1444','2013-08-02','16:10:00',2.19),('1444','2013-08-02','16:15:00',2.16),('1444','2013-08-02','16:20:00',2.13),('1444','2013-08-02','16:25:00',2.09),('1444','2013-08-02','16:30:00',2.05),('1444','2013-08-02','16:35:00',2.01),('1444','2013-08-02','16:40:00',1.97),('1444','2013-08-02','16:45:00',1.92),('1444','2013-08-02','16:50:00',1.87),('1444','2013-08-02','16:55:00',1.81),('1444','2013-08-02','17:00:00',1.76),('1444','2013-08-02','17:05:00',1.71),('1444','2013-08-02','17:10:00',1.67),('1444','2013-08-02','17:15:00',1.62),('1444','2013-08-02','17:20:00',1.56),('1444','2013-08-02','17:25:00',1.5),('1444','2013-08-02','17:30:00',1.44),('1444','2013-08-02','17:35:00',1.39),('1444','2013-08-02','17:40:00',1.34),('1444','2013-08-02','17:45:00',1.27),('1444','2013-08-02','17:50:00',1.21),('1444','2013-08-02','17:55:00',1.16),('1444','2013-08-02','18:00:00',1.11),('1444','2013-08-02','18:05:00',1.06),('1444','2013-08-02','18:10:00',1),('1444','2013-08-01','08:15:00',1.05),('1444','2013-08-01','08:20:00',1.11),('1444','2013-08-01','08:25:00',1.17),('1444','2013-08-01','08:30:00',1.23),('1444','2013-08-01','08:35:00',1.3),('1444','2013-08-01','08:40:00',1.35),('1444','2013-08-01','08:45:00',1.42),('1444','2013-08-01','08:50:00',1.47),('1444','2013-08-01','08:55:00',1.52),('1444','2013-08-01','09:00:00',1.58),('1444','2013-08-01','09:05:00',1.63),('1444','2013-08-01','09:10:00',1.69),('1444','2013-08-01','09:15:00',1.75),('1444','2013-08-01','09:20:00',1.81),('1444','2013-08-01','09:25:00',1.86),('1444','2013-08-01','09:30:00',1.91),('1444','2013-08-01','09:35:00',1.96),('1444','2013-08-01','09:40:00',2.01),('1444','2013-08-01','09:45:00',2.06),('1444','2013-08-01','09:50:00',2.1),('1444','2013-08-01','09:55:00',2.15),('1444','2013-08-01','10:00:00',2.19),('1444','2013-08-01','10:05:00',2.23),('1444','2013-08-01','10:10:00',2.29),('1444','2013-08-01','10:15:00',2.33),('1444','2013-08-01','10:20:00',2.35),('1444','2013-08-01','10:25:00',2.39),('1444','2013-08-01','10:30:00',2.44),('1444','2013-08-01','10:35:00',2.46),('1444','2013-08-01','10:40:00',2.49),('1444','2013-08-01','10:45:00',2.53),('1444','2013-08-01','10:50:00',2.58),('1444','2013-08-01','10:55:00',2.61),('1444','2013-08-01','11:00:00',2.63),('1444','2013-08-01','11:05:00',2.68),('1444','2013-08-01','11:10:00',2.71),('1444','2013-08-01','11:15:00',2.76),('1444','2013-08-01','11:20:00',2.78),('1444','2013-08-01','11:25:00',2.8),('1444','2013-08-01','11:30:00',2.82),('1444','2013-08-01','11:35:00',2.86),('1444','2013-08-01','11:40:00',2.89),('1444','2013-08-01','11:45:00',2.9),('1444','2013-08-01','11:50:00',2.92),('1444','2013-08-01','11:55:00',2.91),('1444','2013-08-01','12:00:00',2.92),('1444','2013-08-01','12:05:00',2.92),('1444','2013-08-01','12:10:00',2.95),('1444','2013-08-01','12:15:00',2.96),('1444','2013-08-01','12:20:00',2.99),('1444','2013-08-01','12:25:00',2.99),('1444','2013-08-01','12:30:00',3.03),('1444','2013-08-01','12:35:00',3.03),('1444','2013-08-01','12:40:00',3.05),('1444','2013-08-01','12:45:00',3.03),('1444','2013-08-01','12:50:00',3.05),('1444','2013-08-01','12:55:00',3.01),('1444','2013-08-01','13:00:00',3.04),('1444','2013-08-01','13:05:00',3.02),('1444','2013-08-01','13:10:00',3.03),('1444','2013-08-01','13:15:00',2.94),('1444','2013-08-01','13:20:00',3.09),('1444','2013-08-01','13:25:00',3.05),('1444','2013-08-01','13:30:00',2.92),('1444','2013-08-01','13:35:00',3.08),('1444','2013-08-01','13:40:00',3.07),('1444','2013-08-01','13:45:00',2.03),('1444','2013-08-01','13:50:00',2.55),('1444','2013-08-01','13:55:00',2.73),('1444','2013-08-01','14:00:00',2.67),('1444','2013-08-01','14:05:00',3.01),('1444','2013-08-01','14:10:00',2.89),('1444','2013-08-01','14:15:00',2.81),('1444','2013-08-01','14:20:00',2.78),('1444','2013-08-01','14:25:00',2.87),('1444','2013-08-01','14:30:00',2.85),('1444','2013-08-01','14:35:00',2.61),('1444','2013-08-01','14:40:00',2.85),('1444','2013-08-01','14:45:00',2.84),('1444','2013-08-01','14:50:00',2.28),('1444','2013-08-01','14:55:00',2.78),('1444','2013-08-01','15:00:00',2.7),('1444','2013-08-01','15:05:00',2.72),('1444','2013-08-01','15:10:00',2.71),('1444','2013-08-01','15:15:00',2.73),('1444','2013-08-01','15:20:00',2.66),('1444','2013-08-01','15:25:00',2.56),('1444','2013-08-01','15:30:00',2.57),('1444','2013-08-01','15:35:00',2.57),('1444','2013-08-01','15:40:00',2.34),('1444','2013-08-01','15:45:00',2.48),('1444','2013-08-01','15:50:00',2.43),('1444','2013-08-01','15:55:00',2.42),('1444','2013-08-01','16:00:00',2.42),('1444','2013-08-01','16:05:00',2.38),('1444','2013-08-01','16:10:00',2.3),('1444','2013-08-01','16:15:00',2.24),('1444','2013-08-01','16:20:00',2.21),('1444','2013-08-01','16:25:00',2.16),('1444','2013-08-01','16:30:00',2.1),('1444','2013-08-01','16:35:00',2.06),('1444','2013-08-01','16:40:00',2.02),('1444','2013-08-01','16:45:00',1.97),('1444','2013-08-01','16:50:00',1.92),('1444','2013-08-01','16:55:00',1.87),('1444','2013-08-01','17:00:00',1.81),('1444','2013-08-01','17:05:00',1.76),('1444','2013-08-01','17:10:00',1.71),('1444','2013-08-01','17:15:00',1.65),('1444','2013-08-01','17:20:00',1.6),('1444','2013-08-01','17:25:00',1.54),('1444','2013-08-01','17:30:00',1.5),('1444','2013-08-01','17:35:00',1.45),('1444','2013-08-01','17:40:00',1.38),('1444','2013-08-01','17:45:00',1.32),('1444','2013-08-01','17:50:00',1.26),('1444','2013-08-01','17:55:00',1.21),('1444','2013-08-01','18:00:00',1.16),('1444','2013-08-01','18:05:00',1.1),('1444','2013-08-01','18:10:00',1.04),('1444','2013-07-31','08:10:00',1.02),('1444','2013-07-31','08:15:00',1.08),('1444','2013-07-31','08:20:00',1.14),('1444','2013-07-31','08:25:00',1.2),('1444','2013-07-31','08:30:00',1.26),('1444','2013-07-31','08:35:00',1.32),('1444','2013-07-31','08:40:00',1.38),('1444','2013-07-31','08:45:00',1.44),('1444','2013-07-31','08:50:00',1.49),('1444','2013-07-31','08:55:00',1.56),('1444','2013-07-31','09:00:00',1.61),('1444','2013-07-31','09:05:00',1.66),('1444','2013-07-31','09:10:00',1.71),('1444','2013-07-31','09:15:00',1.77),('1444','2013-07-31','09:20:00',1.82),('1444','2013-07-31','09:25:00',1.87),('1444','2013-07-31','09:30:00',1.92),('1444','2013-07-31','09:35:00',1.98),('1444','2013-07-31','09:40:00',2.02),('1444','2013-07-31','09:45:00',2.07),('1444','2013-07-31','09:50:00',2.12),('1444','2013-07-31','09:55:00',2.16),('1444','2013-07-31','10:00:00',2.2),('1444','2013-07-31','10:05:00',2.26),('1444','2013-07-31','10:10:00',2.28),('1444','2013-07-31','10:15:00',2.33),('1444','2013-07-31','10:20:00',2.36),('1444','2013-07-31','10:25:00',2.4),('1444','2013-07-31','10:30:00',2.45),('1444','2013-07-31','10:35:00',2.5),('1444','2013-07-31','10:40:00',2.54),('1444','2013-07-31','10:45:00',2.58),('1444','2013-07-31','10:52:00',2.62),('1444','2013-07-31','10:55:00',2.65),('1444','2013-07-31','11:00:00',2.68),('1444','2013-07-31','11:05:00',2.71),('1444','2013-07-31','11:10:00',2.74),('1444','2013-07-31','11:15:00',2.77),('1444','2013-07-31','11:20:00',2.77),('1444','2013-07-31','11:25:00',2.81),('1444','2013-07-31','11:30:00',2.82),('1444','2013-07-31','11:35:00',2.85),('1444','2013-07-31','11:40:00',2.88),('1444','2013-07-31','11:45:00',2.91),('1444','2013-07-31','11:52:00',2.94),('1444','2013-07-31','11:55:00',2.96),('1444','2013-07-31','12:00:00',2.94),('1444','2013-07-31','12:05:00',2.95),('1444','2013-07-31','12:10:00',2.98),('1444','2013-07-31','12:15:00',3.03),('1444','2013-07-31','12:20:00',3.02),('1444','2013-07-31','12:25:00',3.06),('1444','2013-07-31','12:30:00',3.05),('1444','2013-07-31','12:35:00',3.03),('1444','2013-07-31','12:40:00',3.07),('1444','2013-07-31','12:45:00',2.95),('1444','2013-07-31','12:50:00',1.65),('1444','2013-07-31','12:55:00',3.25),('1444','2013-07-31','13:05:00',2.09),('1444','2013-07-31','13:10:00',3.24),('1444','2013-07-31','13:15:00',3.14),('1444','2013-07-31','13:20:00',3.04),('1444','2013-07-31','13:25:00',2.97),('1444','2013-07-31','13:30:00',2.76),('1444','2013-07-31','13:35:00',3),('1444','2013-07-31','13:40:00',3.05),('1444','2013-07-31','13:45:00',3.05),('1444','2013-07-31','13:50:00',3.21),('1444','2013-07-31','13:55:00',2.27),('1444','2013-07-31','14:00:00',2.19),('1444','2013-07-31','14:05:00',3),('1444','2013-07-31','14:10:00',2.83),('1444','2013-07-31','14:15:00',2.64),('1444','2013-07-31','14:20:00',3.03),('1444','2013-07-31','14:25:00',2.89),('1444','2013-07-31','14:30:00',2.95),('1444','2013-07-31','14:35:00',2.91),('1444','2013-07-31','14:40:00',2.94),('1444','2013-07-31','14:45:00',2.87),('1444','2013-07-31','14:50:00',3.03),('1444','2013-07-31','14:55:00',2.43),('1444','2013-07-31','15:05:00',2.11),('1444','2013-07-31','15:10:00',2.84),('1444','2013-07-31','15:15:00',2.37),('1444','2013-07-31','15:20:00',2.54),('1444','2013-07-31','15:25:00',2.69),('1444','2013-07-31','15:30:00',2.02),('1444','2013-07-31','15:35:00',2.54),('1444','2013-07-31','15:40:00',2.67),('1444','2013-07-31','15:45:00',2.21),('1444','2013-07-31','15:50:00',2.48),('1444','2013-07-31','15:55:00',2.44),('1444','2013-07-31','16:00:00',2.39),('1444','2013-07-31','16:05:00',2.4),('1444','2013-07-31','16:10:00',2.38),('1444','2013-07-31','16:15:00',2.31),('1444','2013-07-31','16:20:00',2.32),('1444','2013-07-31','16:25:00',2.31),('1444','2013-07-31','16:30:00',2.26),('1444','2013-07-31','16:35:00',2.12),('1444','2013-07-31','16:40:00',2.03),('1444','2013-07-31','16:45:00',1.95),('1444','2013-07-31','16:50:00',1.95),('1444','2013-07-31','16:55:00',1.89),('1444','2013-07-31','17:00:00',1.85),('1444','2013-07-31','17:05:00',1.79),('1444','2013-07-31','17:10:00',1.63),('1444','2013-07-31','17:15:00',1.65),('1444','2013-07-31','17:20:00',1.24),('1444','2013-07-31','17:25:00',1.51),('1444','2013-07-31','17:30:00',1.49),('1444','2013-07-31','17:35:00',1.42),('1444','2013-07-31','17:40:00',1.37),('1444','2013-07-31','17:45:00',1.32),('1444','2013-07-31','17:50:00',1.28),('1444','2013-07-31','17:55:00',1.2),('1444','2013-07-31','18:00:00',1.16),('1444','2013-07-31','18:05:00',1.1),('1444','2013-07-31','18:10:00',1.03),('1444','2014-04-08','08:20:00',1.06),('1444','2014-04-08','08:25:00',1),('1444','2014-04-08','08:30:00',1.07),('1444','2014-04-08','08:35:00',1.08),('1444','2014-04-08','08:40:00',1.09),('1444','2014-04-08','08:45:00',1.19),('1444','2014-04-08','08:50:00',1.21),('1444','2014-04-08','08:55:00',1.32),('1444','2014-04-08','09:00:00',1.38),('1444','2014-04-08','09:05:00',1.44),('1444','2014-04-08','09:10:00',1.49),('1444','2014-04-08','09:15:00',1.55),('1444','2014-04-08','09:20:00',1.62),('1444','2014-04-08','09:25:00',1.68),('1444','2014-04-08','09:30:00',1.75),('1444','2014-04-08','09:35:00',1.79),('1444','2014-04-08','09:40:00',1.81),('1444','2014-04-08','09:45:00',1.86),('1444','2014-04-08','09:50:00',1.92),('1444','2014-04-08','09:55:00',1.95),('1444','2014-04-08','10:00:00',1.99),('1444','2014-04-08','10:05:00',2),('1444','2014-04-08','10:10:00',2.11),('1444','2014-04-08','10:15:00',2.2),('1444','2014-04-08','10:20:00',2.26),('1444','2014-04-08','10:25:00',2.29),('1444','2014-04-08','10:30:00',2.36),('1444','2014-04-08','10:35:00',2.38),('1444','2014-04-08','10:40:00',2.4),('1444','2014-04-08','10:45:00',2.43),('1444','2014-04-08','10:50:00',2.52),('1444','2014-04-08','10:55:00',2.55),('1444','2014-04-08','11:00:00',2.57),('1444','2014-04-08','11:05:00',2.61),('1444','2014-04-08','11:10:00',2.6),('1444','2014-04-08','11:15:00',2.58),('1444','2014-04-08','11:20:00',2.64),('1444','2014-04-08','11:25:00',2.75),('1444','2014-04-08','11:30:00',2.68),('1444','2014-04-08','11:35:00',2.63),('1444','2014-04-08','11:40:00',2.73),('1444','2014-04-08','11:45:00',2.74),('1444','2014-04-08','11:50:00',2.77),('1444','2014-04-08','11:55:00',2.83),('1444','2014-04-08','12:00:00',2.83),('1444','2014-04-08','12:05:00',2.83),('1444','2014-04-08','12:10:00',2.75),('1444','2014-04-08','12:15:00',2.58),('1444','2014-04-08','12:20:00',2.56),('1444','2014-04-08','12:25:00',2.57),('1444','2014-04-08','12:30:00',3.03),('1444','2014-04-08','12:35:00',3),('1444','2014-04-08','12:40:00',2.53),('1444','2014-04-08','12:45:00',1.95),('1444','2014-04-08','12:50:00',2.63),('1444','2014-04-08','12:55:00',2.98),('1444','2014-04-08','13:00:00',2.87),('1444','2014-04-08','13:05:00',2.96),('1444','2014-04-08','13:10:00',3.03),('1444','2014-04-08','13:15:00',3.08),('1444','2014-04-08','13:20:00',3.08),('1444','2014-04-08','13:25:00',3.09),('1444','2014-04-08','13:30:00',3.05),('1444','2014-04-08','13:35:00',3.08),('1444','2014-04-08','13:40:00',3.08),('1444','2014-04-08','13:45:00',3.04),('1444','2014-04-08','13:50:00',3.03),('1444','2014-04-08','13:55:00',3.06),('1444','2014-04-08','14:00:00',3.03),('1444','2014-04-08','14:05:00',3.02),('1444','2014-04-08','14:10:00',2.99),('1444','2014-04-08','14:15:00',2.96),('1444','2014-04-08','14:20:00',2.76),('1444','2014-04-08','14:25:00',2.79),('1444','2014-04-08','14:30:00',2.97),('1444','2014-04-08','14:35:00',2.88),('1444','2014-04-08','14:40:00',2.45),('1444','2014-04-08','14:45:00',2.56),('1444','2014-04-08','14:50:00',2.76),('1444','2014-04-08','14:55:00',2.82),('1444','2014-04-08','15:00:00',2.74),('1444','2014-04-08','15:05:00',2.68),('1444','2014-04-08','15:10:00',2.69),('1444','2014-04-08','15:15:00',2.62),('1444','2014-04-08','15:20:00',2.56),('1444','2014-04-08','15:25:00',2.5),('1444','2014-04-08','15:30:00',2.33),('1444','2014-04-08','15:35:00',2.49),('1444','2014-04-08','15:40:00',2.43),('1444','2014-04-08','15:45:00',2.29),('1444','2014-04-08','15:50:00',2.33),('1444','2014-04-08','15:55:00',2.32),('1444','2014-04-08','16:00:00',2.2),('1444','2014-04-08','16:05:00',2.18),('1444','2014-04-08','16:10:00',2.09),('1444','2014-04-08','16:15:00',1.96),('1444','2014-04-08','16:20:00',1.81),('1444','2014-04-08','16:25:00',1.87),('1444','2014-04-08','16:30:00',2),('1444','2014-04-08','16:35:00',1.91),('1444','2014-04-08','16:40:00',1.82),('1444','2014-04-08','16:45:00',1.73),('1444','2014-04-08','16:50:00',1.73),('1444','2014-04-08','16:55:00',1.62),('1444','2014-04-08','17:00:00',1.5),('1444','2014-04-08','17:05:00',1.56),('1444','2014-04-08','17:10:00',1.45),('1444','2014-04-08','17:15:00',1.4),('1444','2014-04-08','17:20:00',1.33),('1444','2014-04-08','17:25:00',1.18),('1444','2014-04-08','17:30:00',1.12),('1444','2014-04-08','17:35:00',1.03),('1444','2014-04-08','17:40:00',1.02),('1444','2013-07-30','08:10:00',1.09),('1444','2013-07-30','08:15:00',1.17),('1444','2013-07-30','08:20:00',1.3),('1444','2013-07-30','08:25:00',1.25),('1444','2013-07-30','08:30:00',1.13),('1444','2013-07-30','08:35:00',1.27),('1444','2013-07-30','08:40:00',1.34),('1444','2013-07-30','08:45:00',1.4),('1444','2013-07-30','08:50:00',1.49),('1444','2013-07-30','08:55:00',1.58),('1444','2013-07-30','09:00:00',1.64),('1444','2013-07-30','09:05:00',1.66),('1444','2013-07-30','09:10:00',1.72),('1444','2013-07-30','09:15:00',1.78),('1444','2013-07-30','09:20:00',1.85),('1444','2013-07-30','09:25:00',1.93),('1444','2013-07-30','09:30:00',1.96),('1444','2013-07-30','09:35:00',1.91),('1444','2013-07-30','09:40:00',1.88),('1444','2013-07-30','09:45:00',1.75),('1444','2013-07-30','09:50:00',1.62),('1444','2013-07-30','10:10:00',1.1),('1444','2013-07-30','10:15:00',2.52),('1444','2013-07-30','10:20:00',2.55),('1444','2013-07-30','10:25:00',2.58),('1444','2013-07-30','10:30:00',2.58),('1444','2013-07-30','10:35:00',2.53),('1444','2013-07-30','10:40:00',2.52),('1444','2013-07-30','10:45:00',2.56),('1444','2013-07-30','10:50:00',2.52),('1444','2013-07-30','10:55:00',2.57),('1444','2013-07-30','11:00:00',2.67),('1444','2013-07-30','11:05:00',2.68),('1444','2013-07-30','11:10:00',2.7),('1444','2013-07-30','11:15:00',2.63),('1444','2013-07-30','11:20:00',2.7),('1444','2013-07-30','11:25:00',2.79),('1444','2013-07-30','11:30:00',2.79),('1444','2013-07-30','11:35:00',2.87),('1444','2013-07-30','11:40:00',2.82),('1444','2013-07-30','11:45:00',2.8),('1444','2013-07-30','11:50:00',2.54),('1444','2013-07-30','11:55:00',2.58),('1444','2013-07-30','12:00:00',2.82),('1444','2013-07-30','12:05:00',2.88),('1444','2013-07-30','12:10:00',2.79),('1444','2013-07-30','12:15:00',2.77),('1444','2013-07-30','12:20:00',2.9),('1444','2013-07-30','12:25:00',2.92),('1444','2013-07-30','12:30:00',2.89),('1444','2013-07-30','12:35:00',2.77),('1444','2013-07-30','12:40:00',1.99),('1444','2013-07-30','12:45:00',2.99),('1444','2013-07-30','12:50:00',3.11),('1444','2013-07-30','12:55:00',2.85),('1444','2013-07-30','13:00:00',2.66),('1444','2013-07-30','13:05:00',1.6),('1444','2013-07-30','13:10:00',2.24),('1444','2013-07-30','13:15:00',2.26),('1444','2013-07-30','13:20:00',3.18),('1444','2013-07-30','13:25:00',3.07),('1444','2013-07-30','13:30:00',3.07),('1444','2013-07-30','13:35:00',3.01),('1444','2013-07-30','13:40:00',3.09),('1444','2013-07-30','13:45:00',2.97),('1444','2013-07-30','13:50:00',2.99),('1444','2013-07-30','13:55:00',3.01),('1444','2013-07-30','14:00:00',2.13),('1444','2013-07-30','14:05:00',1.88),('1444','2013-07-30','14:10:00',3.16),('1444','2013-07-30','14:15:00',3.02),('1444','2013-07-30','14:20:00',2.58),('1444','2013-07-30','14:25:00',2.85),('1444','2013-07-30','14:30:00',2.87),('1444','2013-07-30','14:35:00',2.86),('1444','2013-07-30','14:40:00',2.78),('1444','2013-07-30','14:45:00',2.76),('1444','2013-07-30','14:50:00',2.68),('1444','2013-07-30','14:55:00',2.7),('1444','2013-07-30','15:00:00',2.68),('1444','2013-07-30','15:05:00',2.64),('1444','2013-07-30','15:10:00',2.59),('1444','2013-07-30','15:15:00',2.56),('1444','2013-07-30','15:20:00',2.54),('1444','2013-07-30','15:25:00',2.52),('1444','2013-07-30','15:30:00',2.49),('1444','2013-07-30','15:35:00',2.45),('1444','2013-07-30','15:40:00',2.44),('1444','2013-07-30','15:45:00',2.4),('1444','2013-07-30','15:50:00',2.37),('1444','2013-07-30','15:55:00',2.32),('1444','2013-07-30','16:00:00',2.3),('1444','2013-07-30','16:05:00',2.26),('1444','2013-07-30','16:10:00',2.22),('1444','2013-07-30','16:15:00',2.17),('1444','2013-07-30','16:20:00',2.14),('1444','2013-07-30','16:25:00',2.1),('1444','2013-07-30','16:30:00',2.04),('1444','2013-07-30','16:35:00',2),('1444','2013-07-30','16:40:00',1.98),('1444','2013-07-30','16:45:00',1.92),('1444','2013-07-30','16:50:00',1.87),('1444','2013-07-30','16:55:00',1.82),('1444','2013-07-30','17:00:00',1.77),('1444','2013-07-30','17:05:00',1.73),('1444','2013-07-30','17:10:00',1.67),('1444','2013-07-30','17:15:00',1.61),('1444','2013-07-30','17:20:00',1.58),('1444','2013-07-30','17:25:00',1.53),('1444','2013-07-30','17:30:00',1.47),('1444','2013-07-30','17:35:00',1.41),('1444','2013-07-30','17:40:00',1.37),('1444','2013-07-30','17:45:00',1.31),('1444','2013-07-30','17:50:00',1.25),('1444','2013-07-30','17:55:00',1.18),('1444','2013-07-30','18:00:00',1.12),('1444','2013-07-30','18:05:00',1.06),('1444','2013-07-30','18:10:00',1.01),('1444','2013-07-29','08:20:00',1.03),('1444','2013-07-29','08:25:00',1.08),('1444','2013-07-29','08:30:00',1.13),('1444','2013-07-29','08:35:00',1.19),('1444','2013-07-29','08:40:00',1.22),('1444','2013-07-29','08:45:00',1.26),('1444','2013-07-29','08:50:00',1.33),('1444','2013-07-29','08:55:00',1.39),('1444','2013-07-29','09:00:00',1.41),('1444','2013-07-29','09:05:00',1.48),('1444','2013-07-29','09:10:00',1.54),('1444','2013-07-29','09:15:00',1.58),('1444','2013-07-29','09:20:00',1.62),('1444','2013-07-29','09:25:00',1.66),('1444','2013-07-29','09:30:00',1.71),('1444','2013-07-29','09:35:00',1.78),('1444','2013-07-29','09:40:00',1.84),('1444','2013-07-29','09:45:00',1.9),('1444','2013-07-29','09:50:00',1.95),('1444','2013-07-29','09:55:00',2),('1444','2013-07-29','10:00:00',2.03),('1444','2013-07-29','10:05:00',2.07),('1444','2013-07-29','10:10:00',2.11),('1444','2013-07-29','10:15:00',2.13),('1444','2013-07-29','10:20:00',2.2),('1444','2013-07-29','10:25:00',2.23),('1444','2013-07-29','10:30:00',2.27),('1444','2013-07-29','10:35:00',2.3),('1444','2013-07-29','10:40:00',2.35),('1444','2013-07-29','10:45:00',2.35),('1444','2013-07-29','10:50:00',2.38),('1444','2013-07-29','10:55:00',2.41),('1444','2013-07-29','11:00:00',2.43),('1444','2013-07-29','11:05:00',2.46),('1444','2013-07-29','11:10:00',2.47),('1444','2013-07-29','11:15:00',2.52),('1444','2013-07-29','11:20:00',2.56),('1444','2013-07-29','11:25:00',2.56),('1444','2013-07-29','11:30:00',2.56),('1444','2013-07-29','11:35:00',2.6),('1444','2013-07-29','11:40:00',2.63),('1444','2013-07-29','11:45:00',2.61),('1444','2013-07-29','11:50:00',2.62),('1444','2013-07-29','11:55:00',2.64),('1444','2013-07-29','12:00:00',2.67),('1444','2013-07-29','12:05:00',2.71),('1444','2013-07-29','12:10:00',2.69),('1444','2013-07-29','12:15:00',2.68),('1444','2013-07-29','12:20:00',2.71),('1444','2013-07-29','12:25:00',2.72),('1444','2013-07-29','12:30:00',2.71),('1444','2013-07-29','12:35:00',2.74),('1444','2013-07-29','12:40:00',2.76),('1444','2013-07-29','12:45:00',2.77),('1444','2013-07-29','12:50:00',2.71),('1444','2013-07-29','12:55:00',2.7),('1444','2013-07-29','13:00:00',2.8),('1444','2013-07-29','13:05:00',2.77),('1444','2013-07-29','13:10:00',2.81),('1444','2013-07-29','13:15:00',2.82),('1444','2013-07-29','13:20:00',2.86),('1444','2013-07-29','13:25:00',2.87),('1444','2013-07-29','13:30:00',2.89),('1444','2013-07-29','13:35:00',2.87),('1444','2013-07-29','13:40:00',2.86),('1444','2013-07-29','13:45:00',2.9),('1444','2013-07-29','13:50:00',2.9),('1444','2013-07-29','13:55:00',2.88),('1444','2013-07-29','14:00:00',2.86),('1444','2013-07-29','14:05:00',2.85),('1444','2013-07-29','14:10:00',2.83),('1444','2013-07-29','14:15:00',2.82),('1444','2013-07-29','14:20:00',2.82),('1444','2013-07-29','14:25:00',2.78),('1444','2013-07-29','14:30:00',2.77),('1444','2013-07-29','14:35:00',2.75),('1444','2013-07-29','14:40:00',2.72),('1444','2013-07-29','14:45:00',2.7),('1444','2013-07-29','14:50:00',2.69),('1444','2013-07-29','14:55:00',2.68),('1444','2013-07-29','15:00:00',2.65),('1444','2013-07-29','15:05:00',2.63),('1444','2013-07-29','15:10:00',2.61),('1444','2013-07-29','15:15:00',2.58),('1444','2013-07-29','15:20:00',2.54),('1444','2013-07-29','15:25:00',2.52),('1444','2013-07-29','15:30:00',2.49),('1444','2013-07-29','15:35:00',2.47),('1444','2013-07-29','15:40:00',2.5),('1444','2013-07-29','15:45:00',2.56),('1444','2013-07-29','15:50:00',1.95),('1444','2013-07-29','15:55:00',1.43),('1444','2013-07-29','16:00:00',1.32),('1444','2013-07-29','16:05:00',2.04),('1444','2013-07-29','16:10:00',2.06),('1444','2013-07-29','16:15:00',1.72),('1444','2013-07-29','16:20:00',1.75),('1444','2013-07-29','16:25:00',1.99),('1444','2013-07-29','16:30:00',2.11),('1444','2013-07-29','16:35:00',1.67),('1444','2013-07-29','16:40:00',1.82),('1444','2013-07-29','16:45:00',2.13),('1444','2013-07-29','16:50:00',1.86),('1444','2013-07-29','16:55:00',1.29),('1444','2013-07-29','17:05:00',1.46),('1444','2013-07-29','17:20:00',1.66),('1444','2013-07-29','17:25:00',1.43),('1444','2013-07-29','17:45:00',1.41),('1444','2013-07-29','17:50:00',1.26),('1444','2013-07-29','17:55:00',1.13),('1444','2013-07-29','18:10:00',1),('1444','2013-07-28','08:20:00',1.02),('1444','2013-07-28','08:25:00',1.09),('1444','2013-07-28','08:30:00',1.15),('1444','2013-07-28','08:35:00',1.21),('1444','2013-07-28','08:40:00',1.26),('1444','2013-07-28','08:45:00',1.31),('1444','2013-07-28','08:50:00',1.37),('1444','2013-07-28','08:55:00',1.41),('1444','2013-07-28','09:00:00',1.47),('1444','2013-07-28','09:05:00',1.53),('1444','2013-07-28','09:10:00',1.58),('1444','2013-07-28','09:15:00',1.63),('1444','2013-07-28','09:20:00',1.67),('1444','2013-07-28','09:25:00',1.7),('1444','2013-07-28','09:30:00',1.79),('1444','2013-07-28','09:35:00',1.85),('1444','2013-07-28','09:40:00',1.88),('1444','2013-07-28','09:45:00',1.94),('1444','2013-07-28','09:50:00',1.97),('1444','2013-07-28','09:55:00',2.01),('1444','2013-07-28','10:00:00',2.05),('1444','2013-07-28','10:05:00',2.08),('1444','2013-07-28','10:10:00',2.13),('1444','2013-07-28','10:15:00',2.17),('1444','2013-07-28','10:20:00',2.22),('1444','2013-07-28','10:25:00',2.25),('1444','2013-07-28','10:30:00',2.27),('1444','2013-07-28','10:35:00',2.3),('1444','2013-07-28','10:40:00',2.32),('1444','2013-07-28','10:45:00',2.35),('1444','2013-07-28','10:50:00',2.36),('1444','2013-07-28','10:55:00',2.4),('1444','2013-07-28','11:00:00',2.45),('1444','2013-07-28','11:05:00',2.46),('1444','2013-07-28','11:10:00',2.48),('1444','2013-07-28','11:15:00',2.5),('1444','2013-07-28','11:20:00',2.52),('1444','2013-07-28','11:25:00',2.56),('1444','2013-07-28','11:30:00',2.59),('1444','2013-07-28','11:35:00',2.64),('1444','2013-07-28','11:40:00',2.63),('1444','2013-07-28','11:45:00',2.66),('1444','2013-07-28','11:50:00',2.64),('1444','2013-07-28','11:55:00',2.66),('1444','2013-07-28','12:00:00',2.68),('1444','2013-07-28','12:05:00',2.69),('1444','2013-07-28','12:10:00',2.72),('1444','2013-07-28','12:15:00',2.68),('1444','2013-07-28','12:20:00',2.69),('1444','2013-07-28','12:25:00',2.69),('1444','2013-07-28','12:30:00',2.67),('1444','2013-07-28','12:35:00',2.74),('1444','2013-07-28','12:40:00',2.74),('1444','2013-07-28','12:45:00',2.81),('1444','2013-07-28','12:50:00',2.75),('1444','2013-07-28','12:55:00',2.8),('1444','2013-07-28','13:00:00',2.84),('1444','2013-07-28','13:05:00',2.8),('1444','2013-07-28','13:10:00',2.82),('1444','2013-07-28','13:15:00',2.7),('1444','2013-07-28','13:20:00',2.86),('1444','2013-07-28','13:25:00',2.86),('1444','2013-07-28','13:30:00',2.84),('1444','2013-07-28','13:35:00',2.82),('1444','2013-07-28','13:40:00',2.83),('1444','2013-07-28','13:45:00',2.84),('1444','2013-07-28','13:50:00',2.77),('1444','2013-07-28','13:55:00',2.83),('1444','2013-07-28','14:00:00',2.82),('1444','2013-07-28','14:05:00',2.8),('1444','2013-07-28','14:10:00',2.81),('1444','2013-07-28','14:15:00',2.8),('1444','2013-07-28','14:20:00',2.78),('1444','2013-07-28','14:25:00',2.75),('1444','2013-07-28','14:30:00',2.73),('1444','2013-07-28','14:35:00',2.71),('1444','2013-07-28','14:40:00',2.71),('1444','2013-07-28','14:45:00',2.67),('1444','2013-07-28','14:50:00',2.68),('1444','2013-07-28','14:55:00',2.64),('1444','2013-07-28','15:00:00',2.62),('1444','2013-07-28','15:05:00',2.61),('1444','2013-07-28','15:10:00',2.58),('1444','2013-07-28','15:15:00',2.52),('1444','2013-07-28','15:20:00',2.51),('1444','2013-07-28','15:25:00',2.48),('1444','2013-07-28','15:30:00',2.44),('1444','2013-07-28','15:35:00',2.41),('1444','2013-07-28','15:40:00',2.39),('1444','2013-07-28','15:45:00',2.36),('1444','2013-07-28','15:50:00',2.34),('1444','2013-07-28','15:55:00',2.3),('1444','2013-07-28','16:00:00',2.28),('1444','2013-07-28','16:05:00',2.26),('1444','2013-07-28','16:10:00',2.21),('1444','2013-07-28','16:15:00',2.18),('1444','2013-07-28','16:20:00',2.17),('1444','2013-07-28','16:25:00',2.12),('1444','2013-07-28','16:30:00',2.08),('1444','2013-07-28','16:35:00',2.04),('1444','2013-07-28','16:40:00',2),('1444','2013-07-28','16:45:00',1.95),('1444','2013-07-28','16:50:00',1.9),('1444','2013-07-28','16:55:00',1.85),('1444','2013-07-28','17:00:00',1.8),('1444','2013-07-28','17:05:00',1.75),('1444','2013-07-28','17:10:00',1.7),('1444','2013-07-28','17:15:00',1.65),('1444','2013-07-28','17:20:00',1.6),('1444','2013-07-28','17:25:00',1.55),('1444','2013-07-28','17:30:00',1.5),('1444','2013-07-28','17:35:00',1.45),('1444','2013-07-28','17:40:00',1.39),('1444','2013-07-28','17:45:00',1.34),('1444','2013-07-28','17:50:00',1.28),('1444','2013-07-28','17:55:00',1.22),('1444','2013-07-28','18:00:00',1.15),('1444','2013-07-28','18:05:00',1.1),('1444','2013-07-28','18:10:00',1.04),('1444','2013-07-27','08:20:00',1.06),('1444','2013-07-27','08:25:00',1.12),('1444','2013-07-27','08:30:00',1.16),('1444','2013-07-27','08:35:00',1.22),('1444','2013-07-27','08:40:00',1.28),('1444','2013-07-27','08:45:00',1.33),('1444','2013-07-27','08:50:00',1.38),('1444','2013-07-27','08:55:00',1.45),('1444','2013-07-27','09:00:00',1.48),('1444','2013-07-27','09:05:00',1.53),('1444','2013-07-27','09:10:00',1.59),('1444','2013-07-27','09:15:00',1.66),('1444','2013-07-27','09:20:00',1.7),('1444','2013-07-27','09:25:00',1.75),('1444','2013-07-27','09:30:00',1.81),('1444','2013-07-27','09:35:00',1.86),('1444','2013-07-27','09:40:00',1.88),('1444','2013-07-27','09:45:00',1.92),('1444','2013-07-27','09:50:00',1.97),('1444','2013-07-27','09:55:00',2.04),('1444','2013-07-27','10:00:00',2.08),('1444','2013-07-27','10:05:00',2.11),('1444','2013-07-27','10:10:00',2.15),('1444','2013-07-27','10:15:00',2.19),('1444','2013-07-27','10:20:00',2.25),('1444','2013-07-27','10:25:00',2.26),('1444','2013-07-27','10:30:00',2.3),('1444','2013-07-27','10:35:00',2.34),('1444','2013-07-27','10:40:00',2.35),('1444','2013-07-27','10:45:00',2.35),('1444','2013-07-27','10:50:00',2.39),('1444','2013-07-27','10:55:00',2.42),('1444','2013-07-27','11:00:00',2.48),('1444','2013-07-27','11:05:00',2.53),('1444','2013-07-27','11:10:00',2.53),('1444','2013-07-27','11:15:00',2.52),('1444','2013-07-27','11:20:00',2.57),('1444','2013-07-27','11:25:00',2.6),('1444','2013-07-27','11:30:00',2.64),('1444','2013-07-27','11:35:00',2.67),('1444','2013-07-27','11:40:00',2.7),('1444','2013-07-27','11:45:00',2.7),('1444','2013-07-27','11:50:00',2.71),('1444','2013-07-27','11:55:00',2.69),('1444','2013-07-27','12:00:00',2.71),('1444','2013-07-27','12:05:00',2.72),('1444','2013-07-27','12:10:00',2.74),('1444','2013-07-27','12:15:00',2.71),('1444','2013-07-27','12:20:00',2.67),('1444','2013-07-27','12:25:00',2.76),('1444','2013-07-27','12:30:00',2.81),('1444','2013-07-27','12:35:00',2.77),('1444','2013-07-27','12:40:00',2.74),('1444','2013-07-27','12:45:00',2.79),('1444','2013-07-27','12:50:00',2.82),('1444','2013-07-27','12:55:00',2.81),('1444','2013-07-27','13:00:00',2.88),('1444','2013-07-27','13:05:00',1.33),('1444','2013-07-27','13:10:00',2.01),('1444','2013-07-27','13:15:00',2.81),('1444','2013-07-27','13:20:00',2.9),('1444','2013-07-27','13:25:00',2.89),('1444','2013-07-27','13:30:00',2.86),('1444','2013-07-27','13:35:00',2.83),('1444','2013-07-27','13:40:00',2.49),('1444','2013-07-27','13:45:00',2.87),('1444','2013-07-27','13:50:00',2.85),('1444','2013-07-27','13:55:00',2.86),('1444','2013-07-27','14:00:00',2.8),('1444','2013-07-27','14:05:00',2.87),('1444','2013-07-27','14:10:00',2.88),('1444','2013-07-27','14:15:00',2.71),('1444','2013-07-27','14:20:00',2.76),('1444','2013-07-27','14:25:00',2.75),('1444','2013-07-27','14:30:00',2.74),('1444','2013-07-27','14:35:00',2.73),('1444','2013-07-27','14:40:00',2.69),('1444','2013-07-27','14:45:00',2.69),('1444','2013-07-27','14:50:00',2.67),('1444','2013-07-27','14:55:00',2.65),('1444','2013-07-27','15:00:00',2.63),('1444','2013-07-27','15:05:00',2.64),('1444','2013-07-27','15:10:00',2.59),('1444','2013-07-27','15:15:00',2.59),('1444','2013-07-27','15:20:00',2.57),('1444','2013-07-27','15:25:00',2.53),('1444','2013-07-27','15:30:00',2.5),('1444','2013-07-27','15:35:00',2.47),('1444','2013-07-27','15:40:00',2.43),('1444','2013-07-27','15:45:00',2.4),('1444','2013-07-27','15:50:00',2.37),('1444','2013-07-27','15:55:00',2.34),('1444','2013-07-27','16:00:00',2.31),('1444','2013-07-27','16:05:00',2.28),('1444','2013-07-27','16:10:00',2.23),('1444','2013-07-27','16:15:00',2.19),('1444','2013-07-27','16:20:00',2.16),('1444','2013-07-27','16:25:00',2.13),('1444','2013-07-27','16:30:00',2.1),('1444','2013-07-27','16:35:00',2.06),('1444','2013-07-27','16:40:00',2.01),('1444','2013-07-27','16:45:00',1.96),('1444','2013-07-27','16:50:00',1.91),('1444','2013-07-27','16:55:00',1.84),('1444','2013-07-27','17:00:00',1.8),('1444','2013-07-27','17:05:00',1.75),('1444','2013-07-27','17:10:00',1.71),('1444','2013-07-27','17:15:00',1.65),('1444','2013-07-27','17:20:00',1.6),('1444','2013-07-27','17:25:00',1.53),('1444','2013-07-27','17:30:00',1.5),('1444','2013-07-27','17:35:00',1.44),('1444','2013-07-27','17:40:00',1.38),('1444','2013-07-27','17:45:00',1.32),('1444','2013-07-27','17:50:00',1.27),('1444','2013-07-27','17:55:00',1.23),('1444','2013-07-27','18:00:00',1.17),('1444','2013-07-27','18:05:00',1.12),('1444','2013-07-27','18:10:00',1.07),('1444','2013-07-27','18:15:00',1.02),('1444','2013-07-26','08:20:00',1.05),('1444','2013-07-26','08:25:00',1.1),('1444','2013-07-26','08:30:00',1.16),('1444','2013-07-26','08:35:00',1.2),('1444','2013-07-26','08:40:00',1.25),('1444','2013-07-26','08:45:00',1.31),('1444','2013-07-26','08:50:00',1.38),('1444','2013-07-26','08:55:00',1.45),('1444','2013-07-26','09:00:00',1.48),('1444','2013-07-26','09:05:00',1.53),('1444','2013-07-26','09:10:00',1.57),('1444','2013-07-26','09:15:00',1.64),('1444','2013-07-26','09:20:00',1.67),('1444','2013-07-26','09:25:00',1.64),('1444','2013-07-26','09:30:00',1.85),('1444','2013-07-26','09:35:00',1.76),('1444','2013-07-26','09:40:00',1.87),('1444','2013-07-26','09:45:00',1.92),('1444','2013-07-26','09:50:00',1.97),('1444','2013-07-26','09:55:00',1.74),('1444','2013-07-26','10:00:00',2),('1444','2013-07-26','10:05:00',2.07),('1444','2013-07-26','10:10:00',2.13),('1444','2013-07-26','10:15:00',2.19),('1444','2013-07-26','10:20:00',2.16),('1444','2013-07-26','10:25:00',2.17),('1444','2013-07-26','10:30:00',2.27),('1444','2013-07-26','10:35:00',2.32),('1444','2013-07-26','10:40:00',2.36),('1444','2013-07-26','10:45:00',2.36),('1444','2013-07-26','10:50:00',2.4),('1444','2013-07-26','10:55:00',2.49),('1444','2013-07-26','11:00:00',2.4),('1444','2013-07-26','11:05:00',2.39),('1444','2013-07-26','11:10:00',2.56),('1444','2013-07-26','11:15:00',2.48),('1444','2013-07-26','11:20:00',2.52),('1444','2013-07-26','11:25:00',2.62),('1444','2013-07-26','11:30:00',2.66),('1444','2013-07-26','11:35:00',2.6),('1444','2013-07-26','11:40:00',2.66),('1444','2013-07-26','11:45:00',2.75),('1444','2013-07-26','11:50:00',2.83),('1444','2013-07-26','11:55:00',2.14),('1444','2013-07-26','12:00:00',2.78),('1444','2013-07-26','12:05:00',2.64),('1444','2013-07-26','12:10:00',2.81),('1444','2013-07-26','12:15:00',2.79),('1444','2013-07-26','12:20:00',2.8),('1444','2013-07-26','12:25:00',2.86),('1444','2013-07-26','12:30:00',2.34),('1444','2013-07-26','12:35:00',2.87),('1444','2013-07-26','12:40:00',3.04),('1444','2013-07-26','12:45:00',3.07),('1444','2013-07-26','12:50:00',3.11),('1444','2013-07-26','12:55:00',3.03),('1444','2013-07-26','13:00:00',2.64),('1444','2013-07-26','13:10:00',1.29),('1444','2013-07-26','13:15:00',1.37),('1444','2013-07-26','13:20:00',1.22),('1444','2013-07-26','13:25:00',1.56),('1444','2013-07-26','13:30:00',2.64),('1444','2013-07-26','13:35:00',3.13),('1444','2013-07-26','13:40:00',3.04),('1444','2013-07-26','13:45:00',2.22),('1444','2013-07-26','13:50:00',1.75),('1444','2013-07-26','13:55:00',3.06),('1444','2013-07-26','14:00:00',2.94),('1444','2013-07-26','14:05:00',3.08),('1444','2013-07-26','14:10:00',3.01),('1444','2013-07-26','14:15:00',2.52),('1444','2013-07-26','14:20:00',2.89),('1444','2013-07-26','14:25:00',2.86),('1444','2013-07-26','14:30:00',2.85),('1444','2013-07-26','14:35:00',2.85),('1444','2013-07-26','14:40:00',2.79),('1444','2013-07-26','14:45:00',2.78),('1444','2013-07-26','14:50:00',2.74),('1444','2013-07-26','14:55:00',2.71),('1444','2013-07-26','15:00:00',2.69),('1444','2013-07-26','15:05:00',2.65),('1444','2013-07-26','15:10:00',2.63),('1444','2013-07-26','15:15:00',2.63),('1444','2013-07-26','15:20:00',2.57),('1444','2013-07-26','15:25:00',2.54),('1444','2013-07-26','15:30:00',2.51),('1444','2013-07-26','15:35:00',2.49),('1444','2013-07-26','15:40:00',2.48),('1444','2013-07-26','15:45:00',2.44),('1444','2013-07-26','15:50:00',2.42),('1444','2013-07-26','15:55:00',2.38),('1444','2013-07-26','16:00:00',2.34),('1444','2013-07-26','16:05:00',2.31),('1444','2013-07-26','16:10:00',2.26),('1444','2013-07-26','16:15:00',2.23),('1444','2013-07-26','16:20:00',2.18),('1444','2013-07-26','16:25:00',2.16),('1444','2013-07-26','16:30:00',2.11),('1444','2013-07-26','16:35:00',2.06),('1444','2013-07-26','16:40:00',2),('1444','2013-07-26','16:45:00',1.97),('1444','2013-07-26','16:50:00',1.93),('1444','2013-07-26','16:55:00',1.85),('1444','2013-07-26','17:00:00',1.81),('1444','2013-07-26','17:05:00',1.77),('1444','2013-07-26','17:10:00',1.72),('1444','2013-07-26','17:15:00',1.65),('1444','2013-07-26','17:20:00',1.6),('1444','2013-07-26','17:25:00',1.56),('1444','2013-07-26','17:30:00',1.5),('1444','2013-07-26','17:35:00',1.43),('1444','2013-07-26','17:40:00',1.38),('1444','2013-07-26','17:45:00',1.33),('1444','2013-07-26','17:50:00',1.23),('1444','2013-07-26','17:55:00',1.17),('1444','2013-07-26','18:00:00',1.11),('1444','2013-07-26','18:05:00',1.08),('1444','2013-07-26','18:10:00',1.01),('1444','2013-07-25','08:15:00',1),('1444','2013-07-25','08:20:00',1.06),('1444','2013-07-25','08:25:00',1.11),('1444','2013-07-25','08:30:00',1.14),('1444','2013-07-25','08:35:00',1.2),('1444','2013-07-25','08:40:00',1.17),('1444','2013-07-25','08:45:00',1.33),('1444','2013-07-25','08:50:00',1.41),('1444','2013-07-25','08:55:00',1.48),('1444','2013-07-25','09:00:00',1.49),('1444','2013-07-25','09:05:00',1.6),('1444','2013-07-25','09:10:00',1.7),('1444','2013-07-25','09:15:00',1.6),('1444','2013-07-25','09:25:00',1.85),('1444','2013-07-25','09:30:00',2.04),('1444','2013-07-25','09:35:00',1.25),('1444','2013-07-25','09:40:00',1.72),('1444','2013-07-25','09:45:00',1.6),('1444','2013-07-25','09:50:00',1.97),('1444','2013-07-25','09:55:00',1.25),('1444','2013-07-25','10:00:00',1.58),('1444','2013-07-25','10:05:00',2.11),('1444','2013-07-25','10:10:00',2.21),('1444','2013-07-25','10:15:00',2.11),('1444','2013-07-25','10:20:00',1.17),('1444','2013-07-25','10:25:00',2.35),('1444','2013-07-25','10:30:00',1.91),('1444','2013-07-25','10:35:00',1.68),('1444','2013-07-25','10:40:00',2.59),('1444','2013-07-25','10:45:00',2.57),('1444','2013-07-25','10:50:00',2.54),('1444','2013-07-25','10:55:00',2.57),('1444','2013-07-25','11:00:00',2.63),('1444','2013-07-25','11:05:00',2.68),('1444','2013-07-25','11:10:00',2.69),('1444','2013-07-25','11:15:00',2.77),('1444','2013-07-25','11:20:00',2.79),('1444','2013-07-25','11:25:00',2.77),('1444','2013-07-25','11:30:00',2.68),('1444','2013-07-25','11:35:00',2.78),('1444','2013-07-25','11:40:00',1.45),('1444','2013-07-25','11:45:00',1.1),('1444','2013-07-25','11:50:00',3.18),('1444','2013-07-25','11:55:00',3.07),('1444','2013-07-25','12:00:00',2.01),('1444','2013-07-25','12:10:00',1.72),('1444','2013-07-25','12:15:00',2.63),('1444','2013-07-25','12:20:00',2.47),('1444','2013-07-25','12:25:00',3.24),('1444','2013-07-25','12:30:00',3.18),('1444','2013-07-25','12:35:00',2.92),('1444','2013-07-25','12:40:00',3.08),('1444','2013-07-25','12:45:00',1.86),('1444','2013-07-25','12:50:00',3.12),('1444','2013-07-25','12:55:00',3.08),('1444','2013-07-25','13:00:00',3.07),('1444','2013-07-25','13:05:00',3.02),('1444','2013-07-25','13:10:00',3.09),('1444','2013-07-25','13:15:00',3.08),('1444','2013-07-25','13:20:00',3.05),('1444','2013-07-25','13:25:00',3),('1444','2013-07-25','13:30:00',3.06),('1444','2013-07-25','13:35:00',3.03),('1444','2013-07-25','13:40:00',3.02),('1444','2013-07-25','13:45:00',3.03),('1444','2013-07-25','13:50:00',3.08),('1444','2013-07-25','13:55:00',3.03),('1444','2013-07-25','14:00:00',3.02),('1444','2013-07-25','14:05:00',3.01),('1444','2013-07-25','14:10:00',2.98),('1444','2013-07-25','14:15:00',2.94),('1444','2013-07-25','14:20:00',2.94),('1444','2013-07-25','14:25:00',2.95),('1444','2013-07-25','14:30:00',2.93),('1444','2013-07-25','14:35:00',2.93),('1444','2013-07-25','14:40:00',2.92),('1444','2013-07-25','14:45:00',2.89),('1444','2013-07-25','14:50:00',2.86),('1444','2013-07-25','14:55:00',2.84),('1444','2013-07-25','15:00:00',2.81),('1444','2013-07-25','15:05:00',2.77),('1444','2013-07-25','15:10:00',2.73),('1444','2013-07-25','15:15:00',2.72),('1444','2013-07-25','15:20:00',2.7),('1444','2013-07-25','15:25:00',2.66),('1444','2013-07-25','15:30:00',2.64),('1444','2013-07-25','15:35:00',2.61),('1444','2013-07-25','15:40:00',2.57),('1444','2013-07-25','15:45:00',2.55),('1444','2013-07-25','15:50:00',2.52),('1444','2013-07-25','15:55:00',2.48),('1444','2013-07-25','16:00:00',2.44),('1444','2013-07-25','16:05:00',2.4),('1444','2013-07-25','16:10:00',2.36),('1444','2013-07-25','16:15:00',2.31),('1444','2013-07-25','16:20:00',2.26),('1444','2013-07-25','16:25:00',2.22),('1444','2013-07-25','16:30:00',2.15),('1444','2013-07-25','16:35:00',2.12),('1444','2013-07-25','16:40:00',2.08),('1444','2013-07-25','16:45:00',2.07),('1444','2013-07-25','16:50:00',1.99),('1444','2013-07-25','16:55:00',1.94),('1444','2013-07-25','17:00:00',1.9),('1444','2013-07-25','17:05:00',1.87),('1444','2013-07-25','17:10:00',1.81),('1444','2013-07-25','17:15:00',1.76),('1444','2013-07-25','17:20:00',1.69),('1444','2013-07-25','17:25:00',1.65),('1444','2013-07-25','17:30:00',1.59),('1444','2013-07-25','17:35:00',1.54),('1444','2013-07-25','17:40:00',1.49),('1444','2013-07-25','17:45:00',1.42),('1444','2013-07-25','17:50:00',1.35),('1444','2013-07-25','17:55:00',1.31),('1444','2013-07-25','18:00:00',1.24),('1444','2013-07-25','18:05:00',1.18),('1444','2013-07-25','18:10:00',1.12),('1444','2013-07-25','18:15:00',1.05),('1444','2013-07-24','08:40:00',1.01),('1444','2013-07-24','08:45:00',1.43),('1444','2013-07-24','08:50:00',1.45),('1444','2013-07-24','08:55:00',1.48),('1444','2013-07-24','09:00:00',1.48),('1444','2013-07-24','09:05:00',1.63),('1444','2013-07-24','09:10:00',1.04),('1444','2013-07-24','09:15:00',1.1),('1444','2013-07-24','09:20:00',1.72),('1444','2013-07-24','09:25:00',1.36),('1444','2013-07-24','09:30:00',1.76),('1444','2013-07-24','09:35:00',1.57),('1444','2013-07-24','09:40:00',1.15),('1444','2013-07-24','09:45:00',1.23),('1444','2013-07-24','10:20:00',1.95),('1444','2013-07-24','10:25:00',2.58),('1444','2013-07-24','10:30:00',2.5),('1444','2013-07-24','10:35:00',2.59),('1444','2013-07-24','10:40:00',1.3),('1444','2013-07-24','10:45:00',1.65),('1444','2013-07-24','10:50:00',1.63),('1444','2013-07-24','10:55:00',1.32),('1444','2013-07-24','11:05:00',2.36),('1444','2013-07-24','11:10:00',2.85),('1444','2013-07-24','11:15:00',2.84),('1444','2013-07-24','11:20:00',2.72),('1444','2013-07-24','11:25:00',2.47),('1444','2013-07-24','11:30:00',1.27),('1444','2013-07-24','11:35:00',2.13),('1444','2013-07-24','11:40:00',2.91),('1444','2013-07-24','11:45:00',2.88),('1444','2013-07-24','11:50:00',2.7),('1444','2013-07-24','11:55:00',2.82),('1444','2013-07-24','12:00:00',2.93),('1444','2013-07-24','12:05:00',2.73),('1444','2013-07-24','12:10:00',3.22),('1444','2013-07-24','12:15:00',3.19),('1444','2013-07-24','12:20:00',1.91),('1444','2013-07-24','12:25:00',1.66),('1444','2013-07-24','12:30:00',1.24),('1444','2013-07-24','12:35:00',2.19),('1444','2013-07-24','12:40:00',3.37),('1444','2013-07-24','12:45:00',2.44),('1444','2013-07-24','12:50:00',2.94),('1444','2013-07-24','12:55:00',3.12),('1444','2013-07-24','13:00:00',3.14),('1444','2013-07-24','13:05:00',3.08),('1444','2013-07-24','13:10:00',3.08),('1444','2013-07-24','13:15:00',2.45),('1444','2013-07-24','13:20:00',2.17),('1444','2013-07-24','13:25:00',2.43),('1444','2013-07-24','13:30:00',3.03),('1444','2013-07-24','13:35:00',1.04),('1444','2013-07-24','13:45:00',1.9),('1444','2013-07-24','13:50:00',3.14),('1444','2013-07-24','13:55:00',1.6),('1444','2013-07-24','14:00:00',3.27),('1444','2013-07-24','14:05:00',3.03),('1444','2013-07-24','14:10:00',3.02),('1444','2013-07-24','14:15:00',2.17),('1444','2013-07-24','14:20:00',2.99),('1444','2013-07-24','14:25:00',2.95),('1444','2013-07-24','14:30:00',3.15),('1444','2013-07-24','14:35:00',3.11),('1444','2013-07-24','14:40:00',2.86),('1444','2013-07-24','14:45:00',3.02),('1444','2013-07-24','14:50:00',2.99),('1444','2013-07-24','14:55:00',2.96),('1444','2013-07-24','15:00:00',2.9),('1444','2013-07-24','15:05:00',2.85),('1444','2013-07-24','15:10:00',2.82),('1444','2013-07-24','15:15:00',2.8),('1444','2013-07-24','15:20:00',2.77),('1444','2013-07-24','15:25:00',2.75),('1444','2013-07-24','15:30:00',2.63),('1444','2013-07-24','15:35:00',2.56),('1444','2013-07-24','15:40:00',2.64),('1444','2013-07-24','15:45:00',2.58),('1444','2013-07-24','15:50:00',2.5),('1444','2013-07-24','15:55:00',2.5),('1444','2013-07-24','16:00:00',2.46),('1444','2013-07-24','16:05:00',2.39),('1444','2013-07-24','16:10:00',2.39),('1444','2013-07-24','16:15:00',2.32),('1444','2013-07-24','16:20:00',2.35),('1444','2013-07-24','16:25:00',2.31),('1444','2013-07-24','16:30:00',2.29),('1444','2013-07-24','16:35:00',2.24),('1444','2013-07-24','16:40:00',2.2),('1444','2013-07-24','16:45:00',2.11),('1444','2013-07-24','16:50:00',2.11),('1444','2013-07-24','16:55:00',2.14),('1444','2013-07-24','17:00:00',2.08),('1444','2013-07-24','17:05:00',2.01),('1444','2013-07-24','17:10:00',1.87),('1444','2013-07-24','17:15:00',1.82),('1444','2013-07-24','17:20:00',1.76),('1444','2013-07-24','17:25:00',1.69),('1444','2013-07-24','17:30:00',1.63),('1444','2013-07-24','17:35:00',1.58),('1444','2013-07-24','17:40:00',1.49),('1444','2013-07-24','17:45:00',1.42),('1444','2013-07-24','17:50:00',1.34),('1444','2013-07-24','17:55:00',1.29),('1444','2013-07-24','18:00:00',1.22),('1444','2013-07-24','18:05:00',1.15),('1444','2013-07-24','18:10:00',1.12),('1444','2013-07-24','18:15:00',1.03),('1444','2013-07-23','08:10:00',1.05),('1444','2013-07-23','08:15:00',1.12),('1444','2013-07-23','08:20:00',1.19),('1444','2013-07-23','08:25:00',1.25),('1444','2013-07-23','08:30:00',1.3),('1444','2013-07-23','08:35:00',1.35),('1444','2013-07-23','08:40:00',1.41),('1444','2013-07-23','08:45:00',1.47),('1444','2013-07-23','08:50:00',1.53),('1444','2013-07-23','08:55:00',1.59),('1444','2013-07-23','09:00:00',1.64),('1444','2013-07-23','09:05:00',1.69),('1444','2013-07-23','09:10:00',1.73),('1444','2013-07-23','09:15:00',1.76),('1444','2013-07-23','09:20:00',1.82),('1444','2013-07-23','09:25:00',1.85),('1444','2013-07-23','09:30:00',1.88),('1444','2013-07-23','09:35:00',1.94),('1444','2013-07-23','09:40:00',1.97),('1444','2013-07-23','09:45:00',2.01),('1444','2013-07-23','09:50:00',2.06),('1444','2013-07-23','09:55:00',2.09),('1444','2013-07-23','10:00:00',2.11),('1444','2013-07-23','10:05:00',2.18),('1444','2013-07-23','10:10:00',2.19),('1444','2013-07-23','10:15:00',2.2),('1444','2013-07-23','10:20:00',2.31),('1444','2013-07-23','10:25:00',2.37),('1444','2013-07-23','10:30:00',2.42),('1444','2013-07-23','10:35:00',2.47),('1444','2013-07-23','10:40:00',2.49),('1444','2013-07-23','10:45:00',2.51),('1444','2013-07-23','10:50:00',2.56),('1444','2013-07-23','10:55:00',2.58),('1444','2013-07-23','11:00:00',2.61),('1444','2013-07-23','11:05:00',2.64),('1444','2013-07-23','11:10:00',2.68),('1444','2013-07-23','11:15:00',2.73),('1444','2013-07-23','11:20:00',2.72),('1444','2013-07-23','11:25:00',2.75),('1444','2013-07-23','11:30:00',2.75),('1444','2013-07-23','11:35:00',2.8),('1444','2013-07-23','11:40:00',2.85),('1444','2013-07-23','11:45:00',2.88),('1444','2013-07-23','11:50:00',2.91),('1444','2013-07-23','11:55:00',2.9),('1444','2013-07-23','12:00:00',2.97),('1444','2013-07-23','12:05:00',2.95),('1444','2013-07-23','12:10:00',3),('1444','2013-07-23','12:15:00',3.05),('1444','2013-07-23','12:20:00',3.04),('1444','2013-07-23','12:25:00',2.93),('1444','2013-07-23','12:30:00',2.56),('1444','2013-07-23','12:45:00',1.29),('1444','2013-07-23','12:50:00',1.02),('1444','2013-07-23','12:55:00',2.27),('1444','2013-07-23','13:00:00',1.56),('1444','2013-07-23','13:35:00',2.65),('1444','2013-07-23','13:40:00',1.23),('1444','2013-07-23','13:55:00',1.23),('1444','2013-07-23','14:00:00',2.78),('1444','2013-07-23','14:05:00',3.08),('1444','2013-07-23','14:25:00',1.17),('1444','2013-07-23','14:30:00',2.14),('1444','2013-07-23','14:35:00',1.16),('1444','2013-07-23','14:45:00',2.31),('1444','2013-07-23','14:50:00',2.37),('1444','2013-07-23','14:55:00',2.94),('1444','2013-07-23','15:00:00',3.2),('1444','2013-07-23','15:05:00',2.79),('1444','2013-07-23','15:10:00',2.88),('1444','2013-07-23','15:15:00',2.82),('1444','2013-07-23','15:20:00',2.74),('1444','2013-07-23','15:25:00',2.71),('1444','2013-07-23','15:30:00',2.68),('1444','2013-07-23','15:35:00',2.65),('1444','2013-07-23','15:40:00',2.51),('1444','2013-07-23','15:45:00',2.49),('1444','2013-07-23','15:50:00',2.51),('1444','2013-07-23','15:55:00',2.48),('1444','2013-07-23','16:00:00',2.41),('1444','2013-07-23','16:05:00',2.38),('1444','2013-07-23','16:10:00',2.33),('1444','2013-07-23','16:15:00',2.29),('1444','2013-07-23','16:20:00',2.26),('1444','2013-07-23','16:25:00',2.21),('1444','2013-07-23','16:30:00',2.17),('1444','2013-07-23','16:35:00',2.11),('1444','2013-07-23','16:40:00',2.07),('1444','2013-07-23','16:45:00',2.04),('1444','2013-07-23','16:50:00',2.01),('1444','2013-07-23','16:55:00',1.95),('1444','2013-07-23','17:00:00',1.9),('1444','2013-07-23','17:05:00',1.84),('1444','2013-07-23','17:10:00',1.81),('1444','2013-07-23','17:15:00',1.76),('1444','2013-07-23','17:20:00',1.71),('1444','2013-07-23','17:25:00',1.68),('1444','2013-07-23','17:30:00',1.61),('1444','2013-07-23','17:35:00',1.57),('1444','2013-07-23','17:40:00',1.52),('1444','2013-07-23','17:45:00',1.46),('1444','2013-07-23','17:50:00',1.39),('1444','2013-07-23','17:55:00',1.34),('1444','2013-07-23','18:00:00',1.29),('1444','2013-07-23','18:05:00',1.22),('1444','2013-07-23','18:10:00',1.16),('1444','2013-07-23','18:15:00',1.11),('1444','2013-07-23','18:20:00',1.05),('1444','2013-07-22','08:10:00',1.05),('1444','2013-07-22','08:15:00',1.11),('1444','2013-07-22','08:20:00',1.17),('1444','2013-07-22','08:25:00',1.22),('1444','2013-07-22','08:30:00',1.29),('1444','2013-07-22','08:35:00',1.34),('1444','2013-07-22','08:40:00',1.4),('1444','2013-07-22','08:45:00',1.47),('1444','2013-07-22','08:50:00',1.52),('1444','2013-07-22','08:55:00',1.58),('1444','2013-07-22','09:00:00',1.63),('1444','2013-07-22','09:05:00',1.68),('1444','2013-07-22','09:10:00',1.73),('1444','2013-07-22','09:15:00',1.78),('1444','2013-07-22','09:20:00',1.84),('1444','2013-07-22','09:25:00',1.88),('1444','2013-07-22','09:30:00',1.93),('1444','2013-07-22','09:35:00',1.98),('1444','2013-07-22','09:40:00',2.02),('1444','2013-07-22','09:45:00',2.07),('1444','2013-07-22','09:50:00',2.11),('1444','2013-07-22','09:55:00',2.15),('1444','2013-07-22','10:00:00',2.19),('1444','2013-07-22','10:05:00',2.24),('1444','2013-07-22','10:10:00',2.29),('1444','2013-07-22','10:15:00',2.33),('1444','2013-07-22','10:20:00',2.39),('1444','2013-07-22','10:25:00',2.43),('1444','2013-07-22','10:30:00',2.46),('1444','2013-07-22','10:35:00',2.49),('1444','2013-07-22','10:40:00',2.52),('1444','2013-07-22','10:45:00',2.55),('1444','2013-07-22','10:50:00',2.58),('1444','2013-07-22','10:55:00',2.59),('1444','2013-07-22','11:00:00',2.62),('1444','2013-07-22','11:05:00',2.65),('1444','2013-07-22','11:10:00',2.68),('1444','2013-07-22','11:15:00',2.68),('1444','2013-07-22','11:20:00',2.73),('1444','2013-07-22','11:25:00',2.77),('1444','2013-07-22','11:30:00',2.76),('1444','2013-07-22','11:35:00',2.77),('1444','2013-07-22','11:40:00',2.78),('1444','2013-07-22','11:45:00',2.81),('1444','2013-07-22','11:50:00',2.83),('1444','2013-07-22','11:55:00',2.84),('1444','2013-07-22','12:00:00',2.85),('1444','2013-07-22','12:05:00',2.88),('1444','2013-07-22','12:10:00',2.92),('1444','2013-07-22','12:15:00',2.93),('1444','2013-07-22','12:20:00',2.94),('1444','2013-07-22','12:25:00',2.93),('1444','2013-07-22','12:30:00',2.95),('1444','2013-07-22','12:35:00',2.97),('1444','2013-07-22','12:40:00',3.01),('1444','2013-07-22','12:45:00',3.01),('1444','2013-07-22','12:50:00',2.98),('1444','2013-07-22','12:55:00',2.97),('1444','2013-07-22','13:00:00',2.97),('1444','2013-07-22','13:05:00',3),('1444','2013-07-22','13:10:00',3.03),('1444','2013-07-22','13:15:00',3.01),('1444','2013-07-22','13:20:00',3.01),('1444','2013-07-22','13:25:00',3.03),('1444','2013-07-22','13:30:00',3.01),('1444','2013-07-22','13:35:00',3),('1444','2013-07-22','13:40:00',2.99),('1444','2013-07-22','13:45:00',3.05),('1444','2013-07-22','13:50:00',3.01),('1444','2013-07-22','13:55:00',2.98),('1444','2013-07-22','14:00:00',2.95),('1444','2013-07-22','14:05:00',2.93),('1444','2013-07-22','14:10:00',2.91),('1444','2013-07-22','14:15:00',2.91),('1444','2013-07-22','14:20:00',2.89),('1444','2013-07-22','14:25:00',2.87),('1444','2013-07-22','14:30:00',2.85),('1444','2013-07-22','14:35:00',2.84),('1444','2013-07-22','14:40:00',2.82),('1444','2013-07-22','14:45:00',2.81),('1444','2013-07-22','14:50:00',2.83),('1444','2013-07-22','14:55:00',2.8),('1444','2013-07-22','15:00:00',2.74),('1444','2013-07-22','15:05:00',2.72),('1444','2013-07-22','15:10:00',2.77),('1444','2013-07-22','15:15:00',2.69),('1444','2013-07-22','15:20:00',2.65),('1444','2013-07-22','15:25:00',2.65),('1444','2013-07-22','15:30:00',1.63),('1444','2013-07-22','15:45:00',1.31),('1444','2013-07-22','15:50:00',2.74),('1444','2013-07-22','15:55:00',2.77),('1444','2013-07-22','16:00:00',2.79),('1444','2013-07-22','16:05:00',2.66),('1444','2013-07-22','16:10:00',2.45),('1444','2013-07-22','16:15:00',2.55),('1444','2013-07-22','16:20:00',2.48),('1444','2013-07-22','16:25:00',2.38),('1444','2013-07-22','16:30:00',2.25),('1444','2013-07-22','16:35:00',2.2),('1444','2013-07-22','16:40:00',2.05),('1444','2013-07-22','16:45:00',1.98),('1444','2013-07-22','16:50:00',1.97),('1444','2013-07-22','16:55:00',1.94),('1444','2013-07-22','17:00:00',1.88),('1444','2013-07-22','17:05:00',1.84),('1444','2013-07-22','17:10:00',1.78),('1444','2013-07-22','17:15:00',1.73),('1444','2013-07-22','17:20:00',1.69),('1444','2013-07-22','17:25:00',1.58),('1444','2013-07-22','17:30:00',1.51),('1444','2013-07-22','17:35:00',1.54),('1444','2013-07-22','17:40:00',1.49),('1444','2013-07-22','17:45:00',1.34),('1444','2013-07-22','17:50:00',1.25),('1444','2013-07-22','17:55:00',1.27),('1444','2013-07-22','18:00:00',1.27),('1444','2013-07-22','18:05:00',1.19),('1444','2013-07-22','18:10:00',1.09),('1444','2013-07-22','18:15:00',1.01),('1444','2013-07-21','08:15:00',1.05),('1444','2013-07-21','08:20:00',1.09),('1444','2013-07-21','08:25:00',1.16),('1444','2013-07-21','08:30:00',1.23),('1444','2013-07-21','08:35:00',1.29),('1444','2013-07-21','08:40:00',1.34),('1444','2013-07-21','08:45:00',1.38),('1444','2013-07-21','08:50:00',1.44),('1444','2013-07-21','08:55:00',1.5),('1444','2013-07-21','09:00:00',1.56),('1444','2013-07-21','09:05:00',1.61),('1444','2013-07-21','09:10:00',1.66),('1444','2013-07-21','09:15:00',1.72),('1444','2013-07-21','09:20:00',1.76),('1444','2013-07-21','09:25:00',1.81),('1444','2013-07-21','09:30:00',1.86),('1444','2013-07-21','09:35:00',1.91),('1444','2013-07-21','09:40:00',1.95),('1444','2013-07-21','09:45:00',2),('1444','2013-07-21','09:50:00',2.04),('1444','2013-07-21','09:55:00',2.09),('1444','2013-07-21','10:00:00',2.12),('1444','2013-07-21','10:05:00',2.2),('1444','2013-07-21','10:10:00',2.22),('1444','2013-07-21','10:15:00',2.26),('1444','2013-07-21','10:20:00',2.31),('1444','2013-07-21','10:25:00',2.35),('1444','2013-07-21','10:30:00',2.38),('1444','2013-07-21','10:35:00',2.41),('1444','2013-07-21','10:40:00',2.45),('1444','2013-07-21','10:45:00',2.45),('1444','2013-07-21','10:50:00',2.5),('1444','2013-07-21','10:55:00',2.53),('1444','2013-07-21','11:00:00',2.57),('1444','2013-07-21','11:05:00',2.61),('1444','2013-07-21','11:10:00',2.63),('1444','2013-07-21','11:15:00',2.67),('1444','2013-07-21','11:20:00',2.67),('1444','2013-07-21','11:25:00',2.7),('1444','2013-07-21','11:30:00',2.77),('1444','2013-07-21','11:35:00',2.77),('1444','2013-07-21','11:40:00',2.83),('1444','2013-07-21','11:45:00',2.86),('1444','2013-07-21','11:50:00',2.83),('1444','2013-07-21','11:55:00',2.84),('1444','2013-07-21','12:00:00',2.87),('1444','2013-07-21','12:05:00',2.91),('1444','2013-07-21','12:17:00',2.85),('1444','2013-07-21','12:25:00',3.36),('1444','2013-07-21','12:30:00',2.89),('1444','2013-07-21','12:35:00',3.12),('1444','2013-07-21','12:40:00',3.57),('1444','2013-07-21','12:45:00',3.6),('1444','2013-07-21','12:57:00',3.52),('1444','2013-07-21','13:05:00',3.54),('1444','2013-07-21','13:10:00',2.98),('1444','2013-07-21','13:15:00',1.96),('1444','2013-07-21','13:20:00',3.02),('1444','2013-07-21','13:25:00',3.34),('1444','2013-07-21','13:37:00',3.4),('1444','2013-07-21','13:45:00',3.02),('1444','2013-07-21','13:50:00',2.24),('1444','2013-07-21','14:21:00',1.09),('1444','2013-07-21','14:25:00',1.06),('1444','2013-07-21','14:55:00',1.2),('1444','2013-07-21','15:01:00',1.25),('1444','2013-07-21','15:05:00',1.35),('1444','2013-07-21','15:10:00',1.33),('1444','2013-07-21','15:15:00',2.69),('1444','2013-07-21','15:27:00',3.06),('1444','2013-07-21','15:30:00',1.08),('1444','2013-07-21','15:35:00',1.24),('1444','2013-07-21','15:40:00',2.4),('1444','2013-07-21','15:45:00',2.63),('1444','2013-07-21','15:50:00',2.23),('1444','2013-07-21','15:55:00',1.73),('1444','2013-07-21','17:10:00',1.02),('1444','2014-04-07','08:35:00',1.2),('1444','2014-04-07','08:40:00',1.27),('1444','2014-04-07','08:45:00',1.14),('1444','2014-04-07','08:50:00',1.09),('1444','2014-04-07','09:10:00',1.09),('1444','2014-04-07','09:15:00',1.27),('1444','2014-04-07','09:50:00',1.04),('1444','2014-04-07','09:55:00',1.08),('1444','2014-04-07','10:00:00',1.09),('1444','2014-04-07','10:05:00',1.09),('1444','2014-04-07','10:10:00',1.11),('1444','2014-04-07','10:15:00',1.03),('1444','2014-04-07','10:20:00',1.03),('1444','2014-04-07','10:25:00',1.06),('1444','2014-04-07','10:30:00',1.08),('1444','2014-04-07','10:35:00',1.15),('1444','2014-04-07','10:40:00',1.17),('1444','2014-04-07','10:45:00',1.21),('1444','2014-04-07','10:50:00',1.27),('1444','2014-04-07','10:55:00',1.36),('1444','2014-04-07','11:00:00',1.51),('1444','2014-04-07','11:05:00',1.49),('1444','2014-04-07','11:10:00',1.67),('1444','2014-04-07','11:15:00',1.77),('1444','2014-04-07','11:20:00',1.76),('1444','2014-04-07','11:25:00',1.58),('1444','2014-04-07','11:30:00',1.56),('1444','2014-04-07','11:35:00',1.55),('1444','2014-04-07','11:40:00',1.55),('1444','2014-04-07','11:45:00',1.45),('1444','2014-04-07','11:50:00',1.37),('1444','2014-04-07','11:55:00',1.32),('1444','2014-04-07','12:00:00',1.41),('1444','2014-04-07','12:05:00',1.75),('1444','2014-04-07','12:10:00',1.85),('1444','2014-04-07','12:15:00',2.45),('1444','2014-04-07','12:20:00',2.98),('1444','2014-04-07','12:25:00',2.81),('1444','2014-04-07','12:30:00',1.8),('1444','2014-04-07','12:35:00',1.61),('1444','2014-04-07','12:40:00',1.82),('1444','2014-04-07','12:45:00',3),('1444','2014-04-07','12:50:00',3.03),('1444','2014-04-07','12:55:00',2.98),('1444','2014-04-07','13:00:00',2.99),('1444','2014-04-07','13:05:00',2.99),('1444','2014-04-07','13:10:00',2.98),('1444','2014-04-07','13:15:00',2.95),('1444','2014-04-07','13:20:00',2.94),('1444','2014-04-07','13:25:00',2.94),('1444','2014-04-07','13:30:00',2.96),('1444','2014-04-07','13:35:00',2.97),('1444','2014-04-07','13:40:00',2.93),('1444','2014-04-07','13:45:00',2.93),('1444','2014-04-07','13:50:00',2.95),('1444','2014-04-07','13:55:00',2.97),('1444','2014-04-07','14:00:00',2.95),('1444','2014-04-07','14:05:00',2.93),('1444','2014-04-07','14:10:00',2.9),('1444','2014-04-07','14:15:00',2.85),('1444','2014-04-07','14:20:00',2.84),('1444','2014-04-07','14:25:00',2.89),('1444','2014-04-07','14:30:00',2.89),('1444','2014-04-07','14:35:00',2.81),('1444','2014-04-07','14:40:00',2.77),('1444','2014-04-07','14:45:00',2.77),('1444','2014-04-07','14:50:00',2.75),('1444','2014-04-07','14:55:00',2.71),('1444','2014-04-07','15:00:00',2.35),('1444','2014-04-07','15:05:00',2.73),('1444','2014-04-07','15:10:00',2.68),('1444','2014-04-07','15:15:00',2.76),('1444','2014-04-07','15:20:00',2.83),('1444','2014-04-07','15:25:00',2.82),('1444','2014-04-07','15:30:00',2.62),('1444','2014-04-07','15:35:00',2.58),('1444','2014-04-07','15:40:00',2.55),('1444','2014-04-07','15:45:00',2.57),('1444','2014-04-07','15:50:00',2.7),('1444','2014-04-07','15:55:00',2.68),('1444','2014-04-07','16:00:00',2.1),('1444','2014-04-07','16:05:00',1.45),('1444','2014-04-07','16:10:00',2.28),('1444','2014-04-07','16:15:00',2.17),('1444','2014-04-07','16:20:00',2.02),('1444','2014-04-07','16:25:00',1.96),('1444','2014-04-07','16:30:00',1.85),('1444','2014-04-07','16:35:00',1.05),('1444','2014-04-07','16:40:00',1.28),('1444','2014-04-07','16:45:00',1.29),('1444','2014-04-07','16:50:00',1.77),('1444','2014-04-07','16:55:00',1.84),('1444','2014-04-07','17:00:00',1.89),('1444','2014-04-07','17:05:00',1.79),('1444','2014-04-07','17:10:00',1.43),('1444','2014-04-07','17:15:00',1.45),('1444','2014-04-07','17:20:00',1.26),('1444','2013-07-20','08:10:00',1.06),('1444','2013-07-20','08:15:00',1.11),('1444','2013-07-20','08:20:00',1.17),('1444','2013-07-20','08:25:00',1.23),('1444','2013-07-20','08:30:00',1.29),('1444','2013-07-20','08:35:00',1.34),('1444','2013-07-20','08:40:00',1.41),('1444','2013-07-20','08:45:00',1.48),('1444','2013-07-20','08:50:00',1.51),('1444','2013-07-20','08:55:00',1.59),('1444','2013-07-20','09:00:00',1.63),('1444','2013-07-20','09:05:00',1.72),('1444','2013-07-20','09:10:00',1.81),('1444','2013-07-20','09:15:00',1.88),('1444','2013-07-20','09:20:00',1.9),('1444','2013-07-20','09:25:00',1.86),('1444','2013-07-20','09:30:00',1.83),('1444','2013-07-20','09:35:00',1.82),('1444','2013-07-20','09:40:00',1.8),('1444','2013-07-20','09:45:00',2.09),('1444','2013-07-20','09:50:00',2.01),('1444','2013-07-20','09:55:00',1.95),('1444','2013-07-20','10:00:00',2.07),('1444','2013-07-20','10:05:00',2.2),('1444','2013-07-20','10:10:00',2.27),('1444','2013-07-20','10:15:00',2.32),('1444','2013-07-20','10:20:00',2.36),('1444','2013-07-20','10:25:00',2.38),('1444','2013-07-20','10:30:00',2.43),('1444','2013-07-20','10:35:00',2.44),('1444','2013-07-20','10:40:00',2.49),('1444','2013-07-20','10:45:00',2.49),('1444','2013-07-20','10:50:00',2.55),('1444','2013-07-20','10:55:00',2.6),('1444','2013-07-20','11:00:00',2.64),('1444','2013-07-20','11:05:00',2.64),('1444','2013-07-20','11:10:00',2.66),('1444','2013-07-20','11:15:00',2.66),('1444','2013-07-20','11:20:00',2.65),('1444','2013-07-20','11:25:00',2.69),('1444','2013-07-20','11:30:00',2.64),('1444','2013-07-20','11:35:00',2.75),('1444','2013-07-20','11:40:00',2.78),('1444','2013-07-20','11:45:00',2.77),('1444','2013-07-20','11:50:00',2.66),('1444','2013-07-20','11:55:00',2.87),('1444','2013-07-20','12:00:00',2.87),('1444','2013-07-20','12:05:00',2.93),('1444','2013-07-20','12:10:00',2.89),('1444','2013-07-20','12:15:00',2.89),('1444','2013-07-20','12:20:00',2.97),('1444','2013-07-20','12:25:00',2.92),('1444','2013-07-20','12:30:00',2.93),('1444','2013-07-20','12:35:00',2.99),('1444','2013-07-20','12:40:00',3.03),('1444','2013-07-20','12:45:00',3.04),('1444','2013-07-20','12:50:00',3.02),('1444','2013-07-20','12:55:00',3),('1444','2013-07-20','13:00:00',3.14),('1444','2013-07-20','13:05:00',2.16),('1444','2013-07-20','13:20:00',1.02),('1444','2013-07-20','13:25:00',1.7),('1444','2013-07-20','13:30:00',2.15),('1444','2013-07-20','13:35:00',3.33),('1444','2013-07-20','13:40:00',3.19),('1444','2013-07-20','13:45:00',2.86),('1444','2013-07-20','13:50:00',1.48),('1444','2013-07-20','13:55:00',1.43),('1444','2013-07-20','14:00:00',2.8),('1444','2013-07-20','14:05:00',3.09),('1444','2013-07-20','14:10:00',3.13),('1444','2013-07-20','14:15:00',3.14),('1444','2013-07-20','14:20:00',3.09),('1444','2013-07-20','14:25:00',2.95),('1444','2013-07-20','14:30:00',2.95),('1444','2013-07-20','14:35:00',3),('1444','2013-07-20','14:40:00',2.97),('1444','2013-07-20','14:45:00',2.96),('1444','2013-07-20','14:50:00',3.02),('1444','2013-07-20','14:55:00',3.01),('1444','2013-07-20','15:00:00',2.93),('1444','2013-07-20','15:05:00',2.88),('1444','2013-07-20','15:10:00',2.82),('1444','2013-07-20','15:15:00',2.77),('1444','2013-07-20','15:20:00',2.69),('1444','2013-07-20','15:25:00',2.66),('1444','2013-07-20','15:30:00',2.65),('1444','2013-07-20','15:35:00',2.63),('1444','2013-07-20','15:40:00',2.61),('1444','2013-07-20','15:45:00',2.57),('1444','2013-07-20','15:50:00',2.53),('1444','2013-07-20','15:55:00',2.48),('1444','2013-07-20','16:00:00',2.46),('1444','2013-07-20','16:05:00',2.42),('1444','2013-07-20','16:10:00',2.37),('1444','2013-07-20','16:15:00',2.36),('1444','2013-07-20','16:20:00',2.32),('1444','2013-07-20','16:25:00',2.27),('1444','2013-07-20','16:30:00',2.23),('1444','2013-07-20','16:35:00',2.16),('1444','2013-07-20','16:40:00',2.11),('1444','2013-07-20','16:45:00',2.05),('1444','2013-07-20','16:50:00',2.02),('1444','2013-07-20','16:55:00',1.95),('1444','2013-07-20','17:00:00',1.9),('1444','2013-07-20','17:05:00',1.86),('1444','2013-07-20','17:10:00',1.81),('1444','2013-07-20','17:15:00',1.76),('1444','2013-07-20','17:20:00',1.7),('1444','2013-07-20','17:25:00',1.65),('1444','2013-07-20','17:30:00',1.59),('1444','2013-07-20','17:35:00',1.55),('1444','2013-07-20','17:40:00',1.49),('1444','2013-07-20','17:45:00',1.44),('1444','2013-07-20','17:50:00',1.39),('1444','2013-07-20','17:55:00',1.33),('1444','2013-07-20','18:00:00',1.27),('1444','2013-07-20','18:05:00',1.21),('1444','2013-07-20','18:10:00',1.15),('1444','2013-07-20','18:15:00',1.1),('1444','2013-07-20','18:20:00',1.04),('1444','2013-07-19','08:10:00',1.02),('1444','2013-07-19','08:15:00',1.08),('1444','2013-07-19','08:20:00',1.14),('1444','2013-07-19','08:30:00',1.23),('1444','2013-07-19','08:35:00',1.3),('1444','2013-07-19','08:40:00',1.37),('1444','2013-07-19','08:45:00',1.42),('1444','2013-07-19','08:50:00',1.48),('1444','2013-07-19','08:55:00',1.54),('1444','2013-07-19','09:00:00',1.57),('1444','2013-07-19','09:05:00',1.63),('1444','2013-07-19','09:10:00',1.68),('1444','2013-07-19','09:15:00',1.73),('1444','2013-07-19','09:20:00',1.78),('1444','2013-07-19','09:25:00',1.83),('1444','2013-07-19','09:30:00',1.88),('1444','2013-07-19','09:40:00',1.83),('1444','2013-07-19','09:45:00',2),('1444','2013-07-19','09:50:00',2.02),('1444','2013-07-19','09:55:00',2.05),('1444','2013-07-19','10:00:00',2.08),('1444','2013-07-19','10:05:00',2.12),('1444','2013-07-19','10:10:00',2.18),('1444','2013-07-19','10:15:00',2.23),('1444','2013-07-19','10:20:00',2.26),('1444','2013-07-19','10:25:00',2.27),('1444','2013-07-19','10:30:00',2.31),('1444','2013-07-19','10:35:00',2.37),('1444','2013-07-19','10:40:00',2.4),('1444','2013-07-19','10:45:00',2.42),('1444','2013-07-19','10:50:00',2.43),('1444','2013-07-19','10:55:00',2.46),('1444','2013-07-19','11:00:00',2.47),('1444','2013-07-19','11:05:00',2.53),('1444','2013-07-19','11:10:00',2.58),('1444','2013-07-19','11:15:00',2.6),('1444','2013-07-19','11:20:00',2.6),('1444','2013-07-19','11:25:00',2.63),('1444','2013-07-19','11:30:00',2.67),('1444','2013-07-19','11:35:00',2.67),('1444','2013-07-19','11:40:00',2.73),('1444','2013-07-19','11:45:00',2.78),('1444','2013-07-19','11:50:00',2.79),('1444','2013-07-19','11:55:00',2.75),('1444','2013-07-19','12:00:00',2.89),('1444','2013-07-19','12:05:00',3),('1444','2013-07-19','12:10:00',2.98),('1444','2013-07-19','12:15:00',3.04),('1444','2013-07-19','12:20:00',2.98),('1444','2013-07-19','12:25:00',2.97),('1444','2013-07-19','12:30:00',2.97),('1444','2013-07-19','12:35:00',2.94),('1444','2013-07-19','12:40:00',2.91),('1444','2013-07-19','12:45:00',2.91),('1444','2013-07-19','12:50:00',3.02),('1444','2013-07-19','12:55:00',2.99),('1444','2013-07-19','13:00:00',2.89),('1444','2013-07-19','13:05:00',3.01),('1444','2013-07-19','13:10:00',2.47),('1444','2013-07-19','13:15:00',1.87),('1444','2013-07-19','13:20:00',3.14),('1444','2013-07-19','13:25:00',3.14),('1444','2013-07-19','13:30:00',3.16),('1444','2013-07-19','13:35:00',3.08),('1444','2013-07-19','13:40:00',3.11),('1444','2013-07-19','13:45:00',3.09),('1444','2013-07-19','13:50:00',3.1),('1444','2013-07-19','13:55:00',3.11),('1444','2013-07-19','14:00:00',3.08),('1444','2013-07-19','14:05:00',3),('1444','2013-07-19','14:10:00',2.6),('1444','2013-07-19','14:15:00',3.04),('1444','2013-07-19','14:20:00',3.07),('1444','2013-07-19','14:25:00',3.06),('1444','2013-07-19','14:30:00',3.07),('1444','2013-07-19','14:35:00',2.69),('1444','2013-07-19','14:40:00',2.96),('1444','2013-07-19','14:45:00',2.77),('1444','2013-07-19','14:50:00',2.84),('1444','2013-07-19','14:55:00',2.97),('1444','2013-07-19','15:00:00',2.88),('1444','2013-07-19','15:05:00',2.91),('1444','2013-07-19','15:10:00',2.7),('1444','2013-07-19','15:15:00',1.61),('1444','2013-07-19','15:20:00',2.42),('1444','2013-07-19','15:25:00',2.57),('1444','2013-07-19','15:30:00',2.82),('1444','2013-07-19','15:35:00',2.81),('1444','2013-07-19','15:40:00',2.22),('1444','2013-07-19','15:45:00',2.71),('1444','2013-07-19','15:50:00',2.62),('1444','2013-07-19','15:55:00',2.58),('1444','2013-07-19','16:00:00',2.51),('1444','2013-07-19','16:05:00',2.49),('1444','2013-07-19','16:10:00',2.46),('1444','2013-07-19','16:15:00',2.43),('1444','2013-07-19','16:20:00',2.41),('1444','2013-07-19','16:25:00',2.35),('1444','2013-07-19','16:30:00',2.33),('1444','2013-07-19','16:35:00',2.3),('1444','2013-07-19','16:40:00',2.24),('1444','2013-07-19','16:45:00',2.22),('1444','2013-07-19','16:50:00',2.21),('1444','2013-07-19','16:55:00',2.16),('1444','2013-07-19','17:00:00',2.2),('1444','2013-07-19','17:05:00',1.83),('1444','2013-07-19','17:10:00',1.95),('1444','2013-07-19','17:15:00',1.74),('1444','2013-07-19','17:20:00',1.74),('1444','2013-07-19','17:25:00',1.32),('1444','2013-07-19','17:30:00',1.66),('1444','2013-07-19','17:35:00',1.82),('1444','2013-07-19','17:40:00',1.48),('1444','2013-07-19','17:45:00',1.14),('1444','2013-07-18','08:05:00',1.04),('1444','2013-07-18','08:10:00',1.1),('1444','2013-07-18','08:15:00',1.15),('1444','2013-07-18','08:20:00',1.21),('1444','2013-07-18','08:25:00',1.27),('1444','2013-07-18','08:30:00',1.33),('1444','2013-07-18','08:35:00',1.38),('1444','2013-07-18','08:40:00',1.44),('1444','2013-07-18','08:45:00',1.5),('1444','2013-07-18','08:50:00',1.56),('1444','2013-07-18','08:55:00',1.61),('1444','2013-07-18','09:00:00',1.66),('1444','2013-07-18','09:05:00',1.71),('1444','2013-07-18','09:10:00',1.76),('1444','2013-07-18','09:15:00',1.81),('1444','2013-07-18','09:20:00',1.85),('1444','2013-07-18','09:25:00',1.89),('1444','2013-07-18','09:30:00',1.94),('1444','2013-07-18','09:35:00',2),('1444','2013-07-18','09:40:00',2.05),('1444','2013-07-18','09:45:00',2.09),('1444','2013-07-18','09:50:00',2.14),('1444','2013-07-18','09:55:00',2.17),('1444','2013-07-18','10:00:00',2.23),('1444','2013-07-18','10:05:00',2.26),('1444','2013-07-18','10:10:00',2.28),('1444','2013-07-18','10:15:00',2.34),('1444','2013-07-18','10:20:00',2.37),('1444','2013-07-18','10:25:00',2.41),('1444','2013-07-18','10:30:00',2.44),('1444','2013-07-18','10:35:00',2.46),('1444','2013-07-18','10:40:00',2.51),('1444','2013-07-18','10:45:00',2.55),('1444','2013-07-18','10:50:00',2.57),('1444','2013-07-18','10:55:00',2.6),('1444','2013-07-18','11:00:00',2.62),('1444','2013-07-18','11:05:00',2.65),('1444','2013-07-18','11:10:00',2.67),('1444','2013-07-18','11:15:00',2.7),('1444','2013-07-18','11:20:00',2.71),('1444','2013-07-18','11:25:00',2.74),('1444','2013-07-18','11:30:00',2.75),('1444','2013-07-18','11:35:00',2.78),('1444','2013-07-18','11:40:00',2.78),('1444','2013-07-18','11:45:00',2.78),('1444','2013-07-18','11:50:00',2.8),('1444','2013-07-18','11:55:00',2.84),('1444','2013-07-18','12:00:00',2.86),('1444','2013-07-18','12:05:00',2.81),('1444','2013-07-18','12:10:00',2.85),('1444','2013-07-18','12:15:00',2.87),('1444','2013-07-18','12:20:00',2.93),('1444','2013-07-18','12:25:00',2.95),('1444','2013-07-18','12:30:00',3.03),('1444','2013-07-18','12:35:00',3.01),('1444','2013-07-18','12:40:00',3.05),('1444','2013-07-18','12:45:00',3.19),('1444','2013-07-18','12:50:00',3.12),('1444','2013-07-18','12:55:00',3.08),('1444','2013-07-18','13:00:00',3.11),('1444','2013-07-18','13:05:00',3.04),('1444','2013-07-18','13:10:00',3.08),('1444','2013-07-18','13:15:00',3.06),('1444','2013-07-18','13:20:00',3.02),('1444','2013-07-18','13:25:00',3.09),('1444','2013-07-18','13:30:00',2.71),('1444','2013-07-18','13:35:00',3.09),('1444','2013-07-18','13:40:00',3.03),('1444','2013-07-18','13:45:00',3.07),('1444','2013-07-18','13:50:00',3.09),('1444','2013-07-18','13:55:00',3.03),('1444','2013-07-18','14:00:00',2.98),('1444','2013-07-18','14:05:00',2.98),('1444','2013-07-18','14:10:00',2.99),('1444','2013-07-18','14:15:00',2.98),('1444','2013-07-18','14:20:00',2.87),('1444','2013-07-18','14:25:00',2.89),('1444','2013-07-18','14:30:00',2.92),('1444','2013-07-18','14:35:00',2.92),('1444','2013-07-18','14:40:00',2.87),('1444','2013-07-18','14:45:00',2.84),('1444','2013-07-18','14:50:00',2.8),('1444','2013-07-18','14:55:00',2.81),('1444','2013-07-18','15:00:00',2.81),('1444','2013-07-18','15:05:00',2.78),('1444','2013-07-18','15:10:00',2.74),('1444','2013-07-18','15:15:00',2.72),('1444','2013-07-18','15:20:00',2.72),('1444','2013-07-18','15:25:00',2.69),('1444','2013-07-18','15:30:00',2.66),('1444','2013-07-18','15:35:00',2.63),('1444','2013-07-18','15:40:00',2.59),('1444','2013-07-18','15:45:00',2.55),('1444','2013-07-18','15:50:00',2.52),('1444','2013-07-18','15:55:00',2.48),('1444','2013-07-18','16:00:00',2.44),('1444','2013-07-18','16:05:00',2.4),('1444','2013-07-18','16:10:00',2.36),('1444','2013-07-18','16:15:00',2.32),('1444','2013-07-18','16:20:00',2.27),('1444','2013-07-18','16:25:00',2.24),('1444','2013-07-18','16:30:00',2.19),('1444','2013-07-18','16:35:00',2.13),('1444','2013-07-18','16:40:00',2.08),('1444','2013-07-18','16:45:00',2.05),('1444','2013-07-18','16:50:00',2),('1444','2013-07-18','16:55:00',1.92),('1444','2013-07-18','17:00:00',1.88),('1444','2013-07-18','17:05:00',1.83),('1444','2013-07-18','17:10:00',1.79),('1444','2013-07-18','17:15:00',1.73),('1444','2013-07-18','17:20:00',1.7),('1444','2013-07-18','17:25:00',1.64),('1444','2013-07-18','17:30:00',1.57),('1444','2013-07-18','17:35:00',1.48),('1444','2013-07-18','17:40:00',1.38),('1444','2013-07-18','17:45:00',1.38),('1444','2013-07-18','17:50:00',1.31),('1444','2013-07-18','17:55:00',1.18),('1444','2013-07-18','18:00:00',1.13),('1444','2013-07-18','18:10:00',1.04),('1444','2013-07-17','08:00:00',1.01),('1444','2013-07-17','08:05:00',1.08),('1444','2013-07-17','08:10:00',1.14),('1444','2013-07-17','08:15:00',1.21),('1444','2013-07-17','08:20:00',1.28),('1444','2013-07-17','08:25:00',1.33),('1444','2013-07-17','08:30:00',1.39),('1444','2013-07-17','08:35:00',1.46),('1444','2013-07-17','08:40:00',1.52),('1444','2013-07-17','08:45:00',1.58),('1444','2013-07-17','08:50:00',1.63),('1444','2013-07-17','08:55:00',1.69),('1444','2013-07-17','09:00:00',1.74),('1444','2013-07-17','09:05:00',1.79),('1444','2013-07-17','09:10:00',1.86),('1444','2013-07-17','09:15:00',1.91),('1444','2013-07-17','09:20:00',1.97),('1444','2013-07-17','09:25:00',2.03),('1444','2013-07-17','09:30:00',2.07),('1444','2013-07-17','09:35:00',2.11),('1444','2013-07-17','09:40:00',2.15),('1444','2013-07-17','09:45:00',2.21),('1444','2013-07-17','09:50:00',2.24),('1444','2013-07-17','09:55:00',2.28),('1444','2013-07-17','10:00:00',2.33),('1444','2013-07-17','10:05:00',2.36),('1444','2013-07-17','10:10:00',2.4),('1444','2013-07-17','10:15:00',2.44),('1444','2013-07-17','10:20:00',2.48),('1444','2013-07-17','10:25:00',2.5),('1444','2013-07-17','10:30:00',2.54),('1444','2013-07-17','10:35:00',2.6),('1444','2013-07-17','10:40:00',2.61),('1444','2013-07-17','10:45:00',2.62),('1444','2013-07-17','10:50:00',2.67),('1444','2013-07-17','10:55:00',2.7),('1444','2013-07-17','11:00:00',2.73),('1444','2013-07-17','11:05:00',2.78),('1444','2013-07-17','11:10:00',2.82),('1444','2013-07-17','11:15:00',2.84),('1444','2013-07-17','11:20:00',2.87),('1444','2013-07-17','11:25:00',2.89),('1444','2013-07-17','11:30:00',2.9),('1444','2013-07-17','11:35:00',2.9),('1444','2013-07-17','11:40:00',2.93),('1444','2013-07-17','11:45:00',2.95),('1444','2013-07-17','11:50:00',2.97),('1444','2013-07-17','11:55:00',2.98),('1444','2013-07-17','12:00:00',3.02),('1444','2013-07-17','12:05:00',3.05),('1444','2013-07-17','12:10:00',3.04),('1444','2013-07-17','12:15:00',3.06),('1444','2013-07-17','12:20:00',3.06),('1444','2013-07-17','12:25:00',3.04),('1444','2013-07-17','12:30:00',3.08),('1444','2013-07-17','12:35:00',3.09),('1444','2013-07-17','12:40:00',3.07),('1444','2013-07-17','12:45:00',3.07),('1444','2013-07-17','12:50:00',3.06),('1444','2013-07-17','12:55:00',3.06),('1444','2013-07-17','13:00:00',3.06),('1444','2013-07-17','13:05:00',3.11),('1444','2013-07-17','13:10:00',3.08),('1444','2013-07-17','13:15:00',3.07),('1444','2013-07-17','13:20:00',3.09),('1444','2013-07-17','13:25:00',3.05),('1444','2013-07-17','13:30:00',3.02),('1444','2013-07-17','13:35:00',3.05),('1444','2013-07-17','13:40:00',3.01),('1444','2013-07-17','13:45:00',3.02),('1444','2013-07-17','13:50:00',3),('1444','2013-07-17','13:55:00',2.9),('1444','2013-07-17','14:00:00',3.03),('1444','2013-07-17','14:05:00',3.03),('1444','2013-07-17','14:10:00',3.04),('1444','2013-07-17','14:15:00',3.02),('1444','2013-07-17','14:20:00',2.97),('1444','2013-07-17','14:25:00',2.95),('1444','2013-07-17','14:30:00',2.94),('1444','2013-07-17','14:35:00',2.92),('1444','2013-07-17','14:40:00',2.95),('1444','2013-07-17','14:45:00',2.91),('1444','2013-07-17','14:50:00',2.86),('1444','2013-07-17','14:55:00',2.11),('1444','2013-07-17','15:00:00',2.46),('1444','2013-07-17','15:05:00',2.86),('1444','2013-07-17','15:10:00',2.78),('1444','2013-07-17','15:15:00',2.76),('1444','2013-07-17','15:20:00',2.75),('1444','2013-07-17','15:25:00',2.74),('1444','2013-07-17','15:30:00',2.73),('1444','2013-07-17','15:35:00',2.7),('1444','2013-07-17','15:40:00',2.69),('1444','2013-07-17','15:45:00',2.58),('1444','2013-07-17','15:50:00',2.48),('1444','2013-07-17','15:55:00',2.38),('1444','2013-07-17','16:00:00',2.49),('1444','2013-07-17','16:05:00',2.46),('1444','2013-07-17','16:10:00',2.46),('1444','2013-07-17','16:15:00',2.42),('1444','2013-07-17','16:20:00',2.33),('1444','2013-07-17','16:25:00',2.21),('1444','2013-07-17','16:30:00',2.18),('1444','2013-07-17','16:35:00',2.2),('1444','2013-07-17','16:40:00',1.8),('1444','2013-07-17','16:45:00',2.06),('1444','2013-07-17','16:50:00',2.03),('1444','2013-07-17','16:55:00',1.96),('1444','2013-07-17','17:00:00',1.97),('1444','2013-07-17','17:05:00',1.91),('1444','2013-07-17','17:10:00',1.88),('1444','2013-07-17','17:15:00',1.82),('1444','2013-07-17','17:20:00',1.75),('1444','2013-07-17','17:25:00',1.67),('1444','2013-07-17','17:30:00',1.61),('1444','2013-07-17','17:35:00',1.58),('1444','2013-07-17','17:40:00',1.5),('1444','2013-07-17','17:45:00',1.45),('1444','2013-07-17','17:50:00',1.4),('1444','2013-07-17','17:55:00',1.33),('1444','2013-07-17','18:00:00',1.27),('1444','2013-07-17','18:05:00',1.23),('1444','2013-07-17','18:10:00',1.16),('1444','2013-07-17','18:15:00',1.11),('1444','2013-07-17','18:20:00',1.05),('1444','2013-07-16','08:05:00',1.04),('1444','2013-07-16','08:10:00',1.1),('1444','2013-07-16','08:15:00',1.15),('1444','2013-07-16','08:20:00',1.21),('1444','2013-07-16','08:25:00',1.28),('1444','2013-07-16','08:30:00',1.34),('1444','2013-07-16','08:35:00',1.4),('1444','2013-07-16','08:40:00',1.45),('1444','2013-07-16','08:45:00',1.5),('1444','2013-07-16','08:50:00',1.56),('1444','2013-07-16','08:55:00',1.63),('1444','2013-07-16','09:00:00',1.69),('1444','2013-07-16','09:05:00',1.74),('1444','2013-07-16','09:10:00',1.79),('1444','2013-07-16','09:15:00',1.83),('1444','2013-07-16','09:20:00',1.87),('1444','2013-07-16','09:25:00',1.91),('1444','2013-07-16','09:30:00',1.96),('1444','2013-07-16','09:35:00',2.02),('1444','2013-07-16','09:40:00',2.08),('1444','2013-07-16','09:45:00',2.12),('1444','2013-07-16','09:50:00',2.15),('1444','2013-07-16','09:55:00',2.22),('1444','2013-07-16','10:00:00',2.26),('1444','2013-07-16','10:05:00',2.3),('1444','2013-07-16','10:10:00',2.34),('1444','2013-07-16','10:15:00',2.38),('1444','2013-07-16','10:20:00',2.45),('1444','2013-07-16','10:25:00',2.48),('1444','2013-07-16','10:30:00',2.55),('1444','2013-07-16','10:35:00',2.57),('1444','2013-07-16','10:40:00',2.6),('1444','2013-07-16','10:45:00',2.63),('1444','2013-07-16','10:50:00',2.66),('1444','2013-07-16','10:55:00',2.7),('1444','2013-07-16','11:00:00',2.73),('1444','2013-07-16','11:05:00',2.75),('1444','2013-07-16','11:10:00',2.79),('1444','2013-07-16','11:15:00',2.81),('1444','2013-07-16','11:20:00',2.83),('1444','2013-07-16','11:25:00',2.85),('1444','2013-07-16','11:30:00',2.86),('1444','2013-07-16','11:35:00',2.87),('1444','2013-07-16','11:40:00',2.87),('1444','2013-07-16','11:45:00',2.9),('1444','2013-07-16','11:50:00',2.95),('1444','2013-07-16','11:55:00',3),('1444','2013-07-16','12:00:00',3.01),('1444','2013-07-16','12:05:00',3.04),('1444','2013-07-16','12:10:00',3.07),('1444','2013-07-16','12:15:00',3.08),('1444','2013-07-16','12:20:00',3.09),('1444','2013-07-16','12:25:00',3.09),('1444','2013-07-16','12:30:00',3.05),('1444','2013-07-16','12:35:00',3.05),('1444','2013-07-16','12:40:00',3.05),('1444','2013-07-16','12:45:00',3.07),('1444','2013-07-16','12:50:00',3.02),('1444','2013-07-16','12:55:00',3.01),('1444','2013-07-16','13:00:00',3),('1444','2013-07-16','13:05:00',3.04),('1444','2013-07-16','13:10:00',3.05),('1444','2013-07-16','13:15:00',3.06),('1444','2013-07-16','13:20:00',3.11),('1444','2013-07-16','13:25:00',3.08),('1444','2013-07-16','13:30:00',3.1),('1444','2013-07-16','13:35:00',3.06),('1444','2013-07-16','13:40:00',3.11),('1444','2013-07-16','13:45:00',3.16),('1444','2013-07-16','13:50:00',3.22),('1444','2013-07-16','13:55:00',3.13),('1444','2013-07-16','14:00:00',3),('1444','2013-07-16','14:05:00',3.07),('1444','2013-07-16','14:10:00',1.72),('1444','2013-07-16','14:15:00',3.02),('1444','2013-07-16','14:20:00',1.34),('1444','2013-07-16','14:25:00',2.16),('1444','2013-07-16','14:30:00',3.05),('1444','2013-07-16','14:35:00',2.98),('1444','2013-07-16','14:40:00',2.98),('1444','2013-07-16','14:45:00',2.92),('1444','2013-07-16','14:50:00',2.91),('1444','2013-07-16','14:55:00',2.93),('1444','2013-07-16','15:00:00',2.9),('1444','2013-07-16','15:05:00',2.84),('1444','2013-07-16','15:10:00',2.8),('1444','2013-07-16','15:15:00',2.77),('1444','2013-07-16','15:20:00',2.75),('1444','2013-07-16','15:25:00',2.75),('1444','2013-07-16','15:30:00',2.75),('1444','2013-07-16','15:35:00',2.38),('1444','2013-07-16','15:40:00',2.64),('1444','2013-07-16','15:45:00',2.08),('1444','2013-07-16','15:50:00',2.46),('1444','2013-07-16','15:55:00',2.52),('1444','2013-07-16','16:00:00',2.44),('1444','2013-07-16','16:05:00',1.84),('1444','2013-07-16','16:10:00',1.76),('1444','2013-07-16','16:15:00',1.54),('1444','2013-07-16','16:20:00',1.21),('1444','2013-07-16','16:25:00',1.5),('1444','2013-07-16','16:50:00',1.1),('1444','2013-07-16','16:55:00',1.37),('1444','2013-07-16','17:00:00',1.93),('1444','2013-07-16','17:05:00',2.23),('1444','2013-07-16','17:10:00',2.12),('1444','2013-07-16','17:15:00',1.86),('1444','2013-07-16','17:20:00',1),('1444','2013-07-16','17:25:00',1.61),('1444','2013-07-16','17:30:00',1.46),('1444','2013-07-16','17:35:00',1.33),('1444','2013-07-16','17:40:00',1.63),('1444','2013-07-16','17:45:00',1.66),('1444','2013-07-16','17:50:00',1.47),('1444','2013-07-16','18:05:00',1.06),('1444','2013-07-16','18:15:00',1.1),('1444','2013-07-15','08:00:00',1.04),('1444','2013-07-15','08:05:00',1.1),('1444','2013-07-15','08:10:00',1.16),('1444','2013-07-15','08:15:00',1.23),('1444','2013-07-15','08:20:00',1.29),('1444','2013-07-15','08:25:00',1.35),('1444','2013-07-15','08:30:00',1.4),('1444','2013-07-15','08:35:00',1.46),('1444','2013-07-15','08:40:00',1.53),('1444','2013-07-15','08:45:00',1.58),('1444','2013-07-15','08:50:00',1.64),('1444','2013-07-15','08:55:00',1.69),('1444','2013-07-15','09:00:00',1.75),('1444','2013-07-15','09:05:00',1.8),('1444','2013-07-15','09:10:00',1.86),('1444','2013-07-15','09:15:00',1.91),('1444','2013-07-15','09:20:00',1.96),('1444','2013-07-15','09:25:00',2.01),('1444','2013-07-15','09:30:00',2.06),('1444','2013-07-15','09:35:00',2.11),('1444','2013-07-15','09:40:00',2.14),('1444','2013-07-15','09:45:00',2.18),('1444','2013-07-15','09:50:00',2.23),('1444','2013-07-15','09:55:00',2.27),('1444','2013-07-15','10:00:00',2.32),('1444','2013-07-15','10:05:00',2.36),('1444','2013-07-15','10:10:00',2.4),('1444','2013-07-15','10:15:00',2.43),('1444','2013-07-15','10:20:00',2.47),('1444','2013-07-15','10:25:00',2.5),('1444','2013-07-15','10:30:00',2.52),('1444','2013-07-15','10:35:00',2.56),('1444','2013-07-15','10:40:00',2.59),('1444','2013-07-15','10:45:00',2.61),('1444','2013-07-15','10:50:00',2.63),('1444','2013-07-15','10:55:00',2.68),('1444','2013-07-15','11:00:00',2.72),('1444','2013-07-15','11:05:00',2.73),('1444','2013-07-15','11:10:00',2.77),('1444','2013-07-15','11:15:00',2.78),('1444','2013-07-15','11:20:00',2.79),('1444','2013-07-15','11:25:00',2.82),('1444','2013-07-15','11:30:00',2.83),('1444','2013-07-15','11:35:00',2.85),('1444','2013-07-15','11:40:00',2.88),('1444','2013-07-15','11:45:00',2.89),('1444','2013-07-15','11:50:00',2.9),('1444','2013-07-15','11:55:00',2.91),('1444','2013-07-15','12:00:00',2.96),('1444','2013-07-15','12:05:00',3),('1444','2013-07-15','12:10:00',3.02),('1444','2013-07-15','12:15:00',3),('1444','2013-07-15','12:20:00',3.06),('1444','2013-07-15','12:25:00',3.08),('1444','2013-07-15','12:30:00',3.08),('1444','2013-07-15','12:35:00',3.08),('1444','2013-07-15','12:40:00',3.07),('1444','2013-07-15','12:45:00',3.04),('1444','2013-07-15','12:50:00',2.99),('1444','2013-07-15','12:55:00',2.93),('1444','2013-07-15','13:00:00',3.07),('1444','2013-07-15','13:05:00',3.1),('1444','2013-07-15','13:10:00',2.5),('1444','2013-07-15','13:15:00',3.1),('1444','2013-07-15','13:20:00',3.1),('1444','2013-07-15','13:25:00',3.01),('1444','2013-07-15','13:30:00',3.24),('1444','2013-07-15','13:35:00',3.34),('1444','2013-07-15','13:40:00',2.11),('1444','2013-07-15','13:45:00',1.78),('1444','2013-07-15','13:55:00',1.61),('1444','2013-07-15','14:00:00',2.81),('1444','2013-07-15','14:05:00',3.06),('1444','2013-07-15','14:10:00',2.85),('1444','2013-07-15','14:25:00',2.61),('1444','2013-07-15','14:30:00',3.22),('1444','2013-07-15','14:35:00',3.14),('1444','2013-07-15','14:40:00',3),('1444','2013-07-15','14:45:00',1.93),('1444','2013-07-15','14:50:00',3.08),('1444','2013-07-15','14:55:00',3.06),('1444','2013-07-15','15:00:00',3.01),('1444','2013-07-15','15:05:00',2.94),('1444','2013-07-15','15:10:00',2.87),('1444','2013-07-15','15:15:00',2.83),('1444','2013-07-15','15:20:00',2.55),('1444','2013-07-15','15:30:00',2.58),('1444','2013-07-15','15:35:00',2.85),('1444','2013-07-15','15:40:00',2.78),('1444','2013-07-15','15:45:00',2.68),('1444','2013-07-15','15:50:00',2.61),('1444','2013-07-15','15:55:00',2.58),('1444','2013-07-15','16:00:00',2.49),('1444','2013-07-15','16:05:00',2.45),('1444','2013-07-15','16:10:00',2.41),('1444','2013-07-15','16:15:00',2.36),('1444','2013-07-15','16:20:00',2.28),('1444','2013-07-15','16:25:00',2.24),('1444','2013-07-15','16:30:00',2.23),('1444','2013-07-15','16:35:00',2.18),('1444','2013-07-15','16:40:00',2.14),('1444','2013-07-15','16:45:00',2.09),('1444','2013-07-15','16:50:00',2.04),('1444','2013-07-15','16:55:00',2),('1444','2013-07-15','17:00:00',1.93),('1444','2013-07-15','17:05:00',1.89),('1444','2013-07-15','17:10:00',1.84),('1444','2013-07-15','17:15:00',1.78),('1444','2013-07-15','17:20:00',1.73),('1444','2013-07-15','17:25:00',1.69),('1444','2013-07-15','17:30:00',1.63),('1444','2013-07-15','17:35:00',1.55),('1444','2013-07-15','17:40:00',1.5),('1444','2013-07-15','17:45:00',1.44),('1444','2013-07-15','17:50:00',1.38),('1444','2013-07-15','17:55:00',1.32),('1444','2013-07-15','18:00:00',1.26),('1444','2013-07-15','18:05:00',1.2),('1444','2013-07-15','18:10:00',1.15),('1444','2013-07-15','18:15:00',1.08),('1444','2013-07-15','18:20:00',1.02),('1444','2013-07-14','07:50:00',1.11),('1444','2013-07-14','07:55:00',1.24),('1444','2013-07-14','08:00:00',1.22),('1444','2013-07-14','08:05:00',1.34),('1444','2013-07-14','08:10:00',1.31),('1444','2013-07-14','08:20:00',1.18),('1444','2013-07-14','09:10:00',1.18),('1444','2013-07-14','09:15:00',1.16),('1444','2013-07-14','09:20:00',1.52),('1444','2013-07-14','09:25:00',1.63),('1444','2013-07-14','09:30:00',1.6),('1444','2013-07-14','09:35:00',1.66),('1444','2013-07-14','09:40:00',1.28),('1444','2013-07-14','09:45:00',1.23),('1444','2013-07-14','09:50:00',1.21),('1444','2013-07-14','09:55:00',1.18),('1444','2013-07-14','10:00:00',1.15),('1444','2013-07-14','10:05:00',1.31),('1444','2013-07-14','10:10:00',1.24),('1444','2013-07-14','10:15:00',1.18),('1444','2013-07-14','10:20:00',1.48),('1444','2013-07-14','10:25:00',2.27),('1444','2013-07-14','10:30:00',1.97),('1444','2013-07-14','10:35:00',2.46),('1444','2013-07-14','10:40:00',2.39),('1444','2013-07-14','10:45:00',1.99),('1444','2013-07-14','10:50:00',2.81),('1444','2013-07-14','10:55:00',2.47),('1444','2013-07-14','11:00:00',1.66),('1444','2013-07-14','11:05:00',1.24),('1444','2013-07-14','11:10:00',1.14),('1444','2013-07-14','11:15:00',2.72),('1444','2013-07-14','11:20:00',3.03),('1444','2013-07-14','11:25:00',2.19),('1444','2013-07-14','11:30:00',1.74),('1444','2013-07-14','11:35:00',1.99),('1444','2013-07-14','11:40:00',1.49),('1444','2013-07-14','11:45:00',1.01),('1444','2013-07-14','11:50:00',1.24),('1444','2013-07-14','11:55:00',3.06),('1444','2013-07-14','12:00:00',2.69),('1444','2013-07-14','12:05:00',3.3),('1444','2013-07-14','12:10:00',3.38),('1444','2013-07-14','12:15:00',3),('1444','2013-07-14','12:20:00',2.86),('1444','2013-07-14','12:25:00',3.28),('1444','2013-07-14','12:30:00',3.31),('1444','2013-07-14','12:35:00',2.28),('1444','2013-07-14','12:40:00',3.42),('1444','2013-07-14','12:45:00',2.96),('1444','2013-07-14','12:50:00',3.26),('1444','2013-07-14','12:55:00',2.88),('1444','2013-07-14','13:00:00',1.22),('1444','2013-07-14','13:05:00',2.65),('1444','2013-07-14','13:10:00',3.39),('1444','2013-07-14','13:15:00',3.26),('1444','2013-07-14','13:20:00',3.21),('1444','2013-07-14','13:25:00',3.14),('1444','2013-07-14','13:30:00',3.08),('1444','2013-07-14','13:35:00',3.09),('1444','2013-07-14','13:40:00',3.15),('1444','2013-07-14','13:45:00',3.16),('1444','2013-07-14','13:50:00',3.18),('1444','2013-07-14','13:55:00',3.14),('1444','2013-07-14','14:00:00',3.14),('1444','2013-07-14','14:05:00',3.15),('1444','2013-07-14','14:10:00',3.14),('1444','2013-07-14','14:15:00',3.13),('1444','2013-07-14','14:20:00',3.12),('1444','2013-07-14','14:25:00',3.07),('1444','2013-07-14','14:30:00',3.03),('1444','2013-07-14','14:35:00',3.01),('1444','2013-07-14','14:40:00',2.96),('1444','2013-07-14','14:45:00',2.92),('1444','2013-07-14','14:50:00',2.89),('1444','2013-07-14','14:55:00',2.84),('1444','2013-07-14','15:00:00',2.84),('1444','2013-07-14','15:05:00',2.82),('1444','2013-07-14','15:10:00',2.79),('1444','2013-07-14','15:15:00',2.77),('1444','2013-07-14','15:20:00',2.75),('1444','2013-07-14','15:25:00',2.71),('1444','2013-07-14','15:30:00',2.67),('1444','2013-07-14','15:35:00',2.65),('1444','2013-07-14','15:40:00',2.62),('1444','2013-07-14','15:45:00',2.56),('1444','2013-07-14','15:50:00',2.52),('1444','2013-07-14','15:55:00',2.5),('1444','2013-07-14','16:00:00',2.51),('1444','2013-07-14','16:05:00',2.46),('1444','2013-07-14','16:10:00',2.42),('1444','2013-07-14','16:15:00',2.31),('1444','2013-07-14','16:20:00',2.17),('1444','2013-07-14','16:25:00',1.82),('1444','2013-07-14','16:30:00',1.99),('1444','2013-07-14','16:35:00',2.36),('1444','2013-07-14','16:40:00',2.29),('1444','2013-07-14','16:45:00',1.94),('1444','2013-07-14','16:55:00',1.74),('1444','2013-07-14','17:00:00',1.77),('1444','2013-07-14','17:05:00',1.46),('1444','2013-07-14','17:10:00',1.62),('1444','2013-07-14','17:15:00',1.88),('1444','2013-07-14','17:25:00',1.83),('1444','2013-07-14','17:30:00',1.7),('1444','2013-07-14','17:35:00',1.55),('1444','2013-07-14','17:40:00',1.48),('1444','2013-07-14','17:45:00',1.32),('1444','2013-07-14','17:55:00',1.02),('1444','2013-07-14','18:00:00',1.38),('1444','2013-07-14','18:05:00',1.07),('1444','2013-07-13','08:05:00',1.03),('1444','2013-07-13','08:10:00',1.08),('1444','2013-07-13','08:15:00',1.14),('1444','2013-07-13','08:20:00',1.21),('1444','2013-07-13','08:25:00',1.25),('1444','2013-07-13','08:30:00',1.31),('1444','2013-07-13','08:35:00',1.36),('1444','2013-07-13','08:40:00',1.41),('1444','2013-07-13','08:45:00',1.45),('1444','2013-07-13','08:50:00',1.52),('1444','2013-07-13','08:55:00',1.58),('1444','2013-07-13','09:00:00',1.65),('1444','2013-07-13','09:05:00',1.7),('1444','2013-07-13','09:10:00',1.76),('1444','2013-07-13','09:15:00',1.81),('1444','2013-07-13','09:20:00',1.86),('1444','2013-07-13','09:25:00',1.92),('1444','2013-07-13','09:30:00',1.96),('1444','2013-07-13','09:35:00',1.99),('1444','2013-07-13','09:40:00',2.03),('1444','2013-07-13','09:45:00',2.08),('1444','2013-07-13','09:50:00',2.13),('1444','2013-07-13','09:55:00',2.17),('1444','2013-07-13','10:00:00',2.21),('1444','2013-07-13','10:05:00',2.26),('1444','2013-07-13','10:10:00',2.29),('1444','2013-07-13','10:15:00',2.23),('1444','2013-07-13','10:20:00',1.89),('1444','2013-07-13','10:25:00',1.8),('1444','2013-07-13','10:30:00',2.38),('1444','2013-07-13','10:35:00',2.51),('1444','2013-07-13','10:40:00',2.56),('1444','2013-07-13','10:45:00',2.64),('1444','2013-07-13','10:50:00',2.7),('1444','2013-07-13','10:55:00',2.74),('1444','2013-07-13','11:00:00',2.91),('1444','2013-07-13','11:05:00',1.91),('1444','2013-07-13','11:10:00',2.29),('1444','2013-07-13','11:15:00',2.23),('1444','2013-07-13','11:30:00',2.81),('1444','2013-07-13','11:35:00',3.13),('1444','2013-07-13','11:40:00',1.07),('1444','2013-07-13','11:50:00',2.94),('1444','2013-07-13','11:55:00',2.65),('1444','2013-07-13','12:00:00',1.78),('1444','2013-07-13','12:05:00',2.16),('1444','2013-07-13','12:10:00',2.56),('1444','2013-07-13','12:15:00',3.21),('1444','2013-07-13','12:25:00',2.71),('1444','2013-07-13','12:30:00',3),('1444','2013-07-13','12:35:00',2.32),('1444','2013-07-13','12:40:00',3.29),('1444','2013-07-13','12:45:00',2.85),('1444','2013-07-13','12:55:00',1.34),('1444','2013-07-13','13:00:00',3.4),('1444','2013-07-13','13:05:00',3.32),('1444','2013-07-13','13:10:00',3.21),('1444','2013-07-13','13:15:00',2.97),('1444','2013-07-13','13:20:00',3.14),('1444','2013-07-13','13:25:00',3.1),('1444','2013-07-13','13:30:00',3.12),('1444','2013-07-13','13:35:00',3.15),('1444','2013-07-13','13:40:00',3.12),('1444','2013-07-13','13:45:00',3.12),('1444','2013-07-13','13:50:00',3.1),('1444','2013-07-13','13:55:00',3.09),('1444','2013-07-13','14:00:00',3.1),('1444','2013-07-13','14:05:00',3.1),('1444','2013-07-13','14:10:00',3.08),('1444','2013-07-13','14:15:00',3.04),('1444','2013-07-13','14:20:00',3.03),('1444','2013-07-13','14:25:00',3.03),('1444','2013-07-13','14:30:00',3.02),('1444','2013-07-13','14:35:00',2.98),('1444','2013-07-13','14:40:00',2.96),('1444','2013-07-13','14:45:00',2.97),('1444','2013-07-13','14:50:00',2.94),('1444','2013-07-13','14:55:00',2.93),('1444','2013-07-13','15:00:00',2.9),('1444','2013-07-13','15:05:00',2.91),('1444','2013-07-13','15:10:00',2.9),('1444','2013-07-13','15:15:00',2.86),('1444','2013-07-13','15:20:00',2.69),('1444','2013-07-13','15:25:00',2.84),('1444','2013-07-13','15:30:00',2.73),('1444','2013-07-13','15:35:00',2.77),('1444','2013-07-13','15:40:00',2.72),('1444','2013-07-13','15:45:00',2.68),('1444','2013-07-13','15:50:00',2.64),('1444','2013-07-13','15:55:00',2.61),('1444','2013-07-13','16:00:00',2.58),('1444','2013-07-13','16:05:00',2.53),('1444','2013-07-13','16:10:00',2.5),('1444','2013-07-13','16:15:00',2.43),('1444','2013-07-13','16:20:00',2.4),('1444','2013-07-13','16:25:00',2.38),('1444','2013-07-13','16:30:00',2.33),('1444','2013-07-13','16:35:00',2.28),('1444','2013-07-13','16:40:00',2.23),('1444','2013-07-13','16:45:00',2.19),('1444','2013-07-13','16:50:00',2.11),('1444','2013-07-13','16:55:00',2.06),('1444','2013-07-13','17:00:00',1.99),('1444','2013-07-13','17:05:00',1.9),('1444','2013-07-13','17:10:00',1.9),('1444','2013-07-13','17:15:00',1.85),('1444','2013-07-13','17:20:00',1.74),('1444','2013-07-13','17:25:00',1.77),('1444','2013-07-13','17:30:00',1.65),('1444','2013-07-13','17:35:00',1.6),('1444','2013-07-13','17:40:00',1.57),('1444','2013-07-13','17:45:00',1.51),('1444','2013-07-13','17:50:00',1.42),('1444','2013-07-13','17:55:00',1.44),('1444','2013-07-13','18:00:00',1.32),('1444','2013-07-13','18:05:00',1.21),('1444','2013-07-13','18:10:00',1.21),('1444','2013-07-13','18:15:00',1.16),('1444','2013-07-13','18:20:00',1.11),('1444','2013-07-13','18:25:00',1.08),('1444','2013-07-12','09:15:00',1.08),('1444','2013-07-12','09:20:00',1.62),('1444','2013-07-12','09:25:00',1.8),('1444','2013-07-12','09:30:00',1.27),('1444','2013-07-12','09:35:00',1.85),('1444','2013-07-12','09:40:00',2.03),('1444','2013-07-12','09:45:00',2.1),('1444','2013-07-12','09:50:00',2.17),('1444','2013-07-12','09:55:00',2.18),('1444','2013-07-12','10:00:00',2.17),('1444','2013-07-12','10:05:00',1.98),('1444','2013-07-12','10:10:00',2.25),('1444','2013-07-12','10:15:00',2.48),('1444','2013-07-12','10:20:00',2.09),('1444','2013-07-12','10:25:00',1.46),('1444','2013-07-12','10:45:00',1.84),('1444','2013-07-12','10:50:00',3.01),('1444','2013-07-12','10:55:00',2.95),('1444','2013-07-12','11:00:00',1.83),('1444','2013-07-12','11:05:00',1.45),('1444','2013-07-12','11:10:00',2.6),('1444','2013-07-12','11:15:00',2.13),('1444','2013-07-12','11:20:00',3.12),('1444','2013-07-12','11:25:00',2.31),('1444','2013-07-12','11:30:00',2.4),('1444','2013-07-12','11:35:00',2.94),('1444','2013-07-12','11:40:00',3.18),('1444','2013-07-12','11:45:00',1.12),('1444','2013-07-12','11:50:00',2.79),('1444','2013-07-12','11:55:00',3),('1444','2013-07-12','12:00:00',3.2),('1444','2013-07-12','12:05:00',1.21),('1444','2013-07-12','12:10:00',1.57),('1444','2013-07-12','12:15:00',3.56),('1444','2013-07-12','12:20:00',2.32),('1444','2013-07-12','12:25:00',2.18),('1444','2013-07-12','12:30:00',3.43),('1444','2013-07-12','12:35:00',3.38),('1444','2013-07-12','12:40:00',2.74),('1444','2013-07-12','12:45:00',3.33),('1444','2013-07-12','12:50:00',3.3),('1444','2013-07-12','12:55:00',3.2),('1444','2013-07-12','13:00:00',3.19),('1444','2013-07-12','13:05:00',2.66),('1444','2013-07-12','13:10:00',3.26),('1444','2013-07-12','13:15:00',3.23),('1444','2013-07-12','13:20:00',3.18),('1444','2013-07-12','13:25:00',3.13),('1444','2013-07-12','13:30:00',3.16),('1444','2013-07-12','13:35:00',3.12),('1444','2013-07-12','13:40:00',3.08),('1444','2013-07-12','13:45:00',2.87),('1444','2013-07-12','13:50:00',3.21),('1444','2013-07-12','13:55:00',2.79),('1444','2013-07-12','14:00:00',2.5),('1444','2013-07-12','14:05:00',2.13),('1444','2013-07-12','14:10:00',1.82),('1444','2013-07-12','14:15:00',3.39),('1444','2013-07-12','14:20:00',1.95),('1444','2013-07-12','14:25:00',2.74),('1444','2013-07-12','14:30:00',2.99),('1444','2013-07-12','14:35:00',3.03),('1444','2013-07-12','14:40:00',2.96),('1444','2013-07-12','14:45:00',2.82),('1444','2013-07-12','14:50:00',2.93),('1444','2013-07-12','14:55:00',2.89),('1444','2013-07-12','15:00:00',2.82),('1444','2013-07-12','15:05:00',2.86),('1444','2013-07-12','15:10:00',2.83),('1444','2013-07-12','15:15:00',2.81),('1444','2013-07-12','15:20:00',2.79),('1444','2013-07-12','15:25:00',2.72),('1444','2013-07-12','15:30:00',2.63),('1444','2013-07-12','15:35:00',2.66),('1444','2013-07-12','15:40:00',2.65),('1444','2013-07-12','15:45:00',2.61),('1444','2013-07-12','15:50:00',2.53),('1444','2013-07-12','15:55:00',2.5),('1444','2013-07-12','16:00:00',2.5),('1444','2013-07-12','16:05:00',2.43),('1444','2013-07-12','16:10:00',2.38),('1444','2013-07-12','16:15:00',2.36),('1444','2013-07-12','16:20:00',2.34),('1444','2013-07-12','16:25:00',2.28),('1444','2013-07-12','16:30:00',2.24),('1444','2013-07-12','16:35:00',2.2),('1444','2013-07-12','16:40:00',2.15),('1444','2013-07-12','16:45:00',2.11),('1444','2013-07-12','16:50:00',2.06),('1444','2013-07-12','16:55:00',2.02),('1444','2013-07-12','17:00:00',1.96),('1444','2013-07-12','17:05:00',1.92),('1444','2013-07-12','17:10:00',1.87),('1444','2013-07-12','17:15:00',1.81),('1444','2013-07-12','17:20:00',1.73),('1444','2013-07-12','17:25:00',1.68),('1444','2013-07-12','17:30:00',1.63),('1444','2013-07-12','17:35:00',1.58),('1444','2013-07-12','17:40:00',1.52),('1444','2013-07-12','17:45:00',1.46),('1444','2013-07-12','17:50:00',1.42),('1444','2013-07-12','17:55:00',1.34),('1444','2013-07-12','18:00:00',1.29),('1444','2013-07-12','18:05:00',1.24),('1444','2013-07-12','18:10:00',1.19),('1444','2013-07-12','18:15:00',1.12),('1444','2013-07-12','18:20:00',1.06),('1444','2013-07-11','08:05:00',1.04),('1444','2013-07-11','08:10:00',1.1),('1444','2013-07-11','08:15:00',1.15),('1444','2013-07-11','08:20:00',1.22),('1444','2013-07-11','08:25:00',1.28),('1444','2013-07-11','08:30:00',1.33),('1444','2013-07-11','08:35:00',1.38),('1444','2013-07-11','08:40:00',1.43),('1444','2013-07-11','08:45:00',1.48),('1444','2013-07-11','08:50:00',1.54),('1444','2013-07-11','08:55:00',1.62),('1444','2013-07-11','09:00:00',1.67),('1444','2013-07-11','09:05:00',1.71),('1444','2013-07-11','09:10:00',1.82),('1444','2013-07-11','09:15:00',1.8),('1444','2013-07-11','09:20:00',1.45),('1444','2013-07-11','09:25:00',1.9),('1444','2013-07-11','09:30:00',2.1),('1444','2013-07-11','09:35:00',2.15),('1444','2013-07-11','09:40:00',2.28),('1444','2013-07-11','09:45:00',2.26),('1444','2013-07-11','09:50:00',2.12),('1444','2013-07-11','09:55:00',1.35),('1444','2013-07-11','10:05:00',2.27),('1444','2013-07-11','10:10:00',2.52),('1444','2013-07-11','10:15:00',2.29),('1444','2013-07-11','10:20:00',2.49),('1444','2013-07-11','10:25:00',1.72),('1444','2013-07-11','10:30:00',1.5),('1444','2013-07-11','10:35:00',1.64),('1444','2013-07-11','10:40:00',2.03),('1444','2013-07-11','10:45:00',2.8),('1444','2013-07-11','10:50:00',1.58),('1444','2013-07-11','10:55:00',1.71),('1444','2013-07-11','11:00:00',2.98),('1444','2013-07-11','11:05:00',2.96),('1444','2013-07-11','11:10:00',2.77),('1444','2013-07-11','11:15:00',2.64),('1444','2013-07-11','11:20:00',2.86),('1444','2013-07-11','11:25:00',2.99),('1444','2013-07-11','11:30:00',1.74),('1444','2013-07-11','11:35:00',1.14),('1444','2013-07-11','11:40:00',3.29),('1444','2013-07-11','11:45:00',1.78),('1444','2013-07-11','11:50:00',3.07),('1444','2013-07-11','11:55:00',3.4),('1444','2013-07-11','12:00:00',2.58),('1444','2013-07-11','12:10:00',1.87),('1444','2013-07-11','12:15:00',3.13),('1444','2013-07-11','12:20:00',3.3),('1444','2013-07-11','12:25:00',3.27),('1444','2013-07-11','12:30:00',3.26),('1444','2013-07-11','12:35:00',3.24),('1444','2013-07-11','12:40:00',3.33),('1444','2013-07-11','12:45:00',3.23),('1444','2013-07-11','12:50:00',2.31),('1444','2013-07-11','12:55:00',3.16),('1444','2013-07-11','13:00:00',3.27),('1444','2013-07-11','13:05:00',3.29),('1444','2013-07-11','13:10:00',2.39),('1444','2013-07-11','13:15:00',3.28),('1444','2013-07-11','13:20:00',2.82),('1444','2013-07-11','13:25:00',2.34),('1444','2013-07-11','13:30:00',3.37),('1444','2013-07-11','13:35:00',3.39),('1444','2013-07-11','13:40:00',2.29),('1444','2013-07-11','13:45:00',2.5),('1444','2013-07-11','13:50:00',1.61),('1444','2013-07-11','13:55:00',2.79),('1444','2013-07-11','14:00:00',3.14),('1444','2013-07-11','14:05:00',3.17),('1444','2013-07-11','14:10:00',2.95),('1444','2013-07-11','14:15:00',3.17),('1444','2013-07-11','14:20:00',3.13),('1444','2013-07-11','14:25:00',3.11),('1444','2013-07-11','14:30:00',3.12),('1444','2013-07-11','14:35:00',3.06),('1444','2013-07-11','14:40:00',2.71),('1444','2013-07-11','14:45:00',3.09),('1444','2013-07-11','14:50:00',2.72),('1444','2013-07-11','14:55:00',2.94),('1444','2013-07-11','15:00:00',1.87),('1444','2013-07-11','15:05:00',1.33),('1444','2013-07-11','15:10:00',2.23),('1444','2013-07-11','15:20:00',1.8),('1444','2013-07-11','15:25:00',2.23),('1444','2013-07-11','15:30:00',2.84),('1444','2013-07-11','15:35:00',1.47),('1444','2013-07-11','15:40:00',2.35),('1444','2013-07-11','15:45:00',2.11),('1444','2013-07-11','15:50:00',1.41),('1444','2013-07-11','15:55:00',1.06),('1444','2013-07-11','16:00:00',2.33),('1444','2013-07-11','16:05:00',2.3),('1444','2013-07-11','16:10:00',1.85),('1444','2013-07-11','16:15:00',1.95),('1444','2013-07-11','16:20:00',1.81),('1444','2013-07-11','16:25:00',1.07),('1444','2013-07-11','16:30:00',2.18),('1444','2013-07-11','16:35:00',1.67),('1444','2013-07-11','16:40:00',2.39),('1444','2013-07-11','16:45:00',2.35),('1444','2013-07-11','16:50:00',2.19),('1444','2013-07-11','16:55:00',2.09),('1444','2013-07-11','17:00:00',1.84),('1444','2013-07-11','17:05:00',2.03),('1444','2013-07-11','17:10:00',1.71),('1444','2013-07-11','17:15:00',1.74),('1444','2013-07-11','17:20:00',1.97),('1444','2013-07-11','17:25:00',1.95),('1444','2013-07-11','17:30:00',1.75),('1444','2013-07-11','17:35:00',1.61),('1444','2013-07-11','17:40:00',1.29),('1444','2013-07-11','17:45:00',1.63),('1444','2013-07-11','17:50:00',1.31),('1444','2013-07-11','17:55:00',1.47),('1444','2013-07-11','18:00:00',1.28),('1444','2013-07-11','18:05:00',1.07),('1444','2013-07-11','18:10:00',1.43),('1444','2013-07-11','18:15:00',1.32),('1444','2013-07-11','18:20:00',1.06),('1444','2014-05-03','07:55:00',1.07),('1444','2014-05-03','08:00:00',1.21),('1444','2014-05-03','08:05:00',1.21),('1444','2014-05-03','08:10:00',1.56),('1444','2014-05-03','08:45:00',1.53),('1444','2014-05-03','08:50:00',2.01),('1444','2014-05-03','08:55:00',2.11),('1444','2014-05-03','09:00:00',1.76),('1444','2014-05-03','09:05:00',1.58),('1444','2014-05-03','09:10:00',1.44),('1444','2014-05-03','09:15:00',1.62),('1444','2014-05-03','09:20:00',2.31),('1444','2014-05-03','09:25:00',1.21),('1444','2014-05-03','09:30:00',2.54),('1444','2014-05-03','09:35:00',2.36),('1444','2014-05-03','09:40:00',1.8),('1444','2014-05-03','09:45:00',2.01),('1444','2014-05-03','09:50:00',1.43),('1444','2014-05-03','09:55:00',2.87),('1444','2014-05-03','10:00:00',2.82),('1444','2014-05-03','10:05:00',2.84),('1444','2014-05-03','10:10:00',2.66),('1444','2014-05-03','10:15:00',2.66),('1444','2014-05-03','10:20:00',1.03),('1444','2014-05-03','10:25:00',1.13),('1444','2014-05-03','10:30:00',2.3),('1444','2014-05-03','10:40:00',1.36),('1444','2014-05-03','10:55:00',2.48),('1444','2014-05-03','11:00:00',1.8),('1444','2014-05-03','11:05:00',3.13),('1444','2014-05-03','11:10:00',3.26),('1444','2014-05-03','11:15:00',3.93),('1444','2014-05-03','11:20:00',3.61),('1444','2014-05-03','11:25:00',3.37),('1444','2014-05-03','11:30:00',3.39),('1444','2014-05-03','11:35:00',2.17),('1444','2014-05-03','11:40:00',2.5),('1444','2014-05-03','11:45:00',2.01),('1444','2014-05-03','11:50:00',1.85),('1444','2014-05-03','11:55:00',1.78),('1444','2014-05-03','12:00:00',1.32),('1444','2014-05-03','12:05:00',1.09),('1444','2014-05-03','12:30:00',1.34),('1444','2014-05-03','12:35:00',1.77),('1444','2014-05-03','12:40:00',1.75),('1444','2014-05-03','12:45:00',1.65),('1444','2014-05-03','12:50:00',1.39),('1444','2014-05-03','12:55:00',1.37),('1444','2014-05-03','13:00:00',1.57),('1444','2014-05-03','13:05:00',1.94),('1444','2014-05-03','13:10:00',2.39),('1444','2014-05-03','13:15:00',2.19),('1444','2014-05-03','13:20:00',2.35),('1444','2014-05-03','13:25:00',2.49),('1444','2014-05-03','13:30:00',2.62),('1444','2014-05-03','13:35:00',2.32),('1444','2014-05-03','13:40:00',1.55),('1444','2014-05-03','13:45:00',1.48),('1444','2014-05-03','13:50:00',1.47),('1444','2014-05-03','13:55:00',1.49),('1444','2014-05-03','14:00:00',1.48),('1444','2014-05-03','14:05:00',1.55),('1444','2014-05-03','14:10:00',1.73),('1444','2014-05-03','14:15:00',2.07),('1444','2014-05-03','14:20:00',2.37),('1444','2014-05-03','14:25:00',2.57),('1444','2014-05-03','14:30:00',1.52),('1444','2014-05-03','14:35:00',1.17),('1444','2014-05-03','14:50:00',1.25),('1444','2014-05-03','14:55:00',3.46),('1444','2014-05-03','15:00:00',2.49),('1444','2014-05-03','15:05:00',1.24),('1444','2014-04-06','08:30:00',1.04),('1444','2014-04-06','08:35:00',1.13),('1444','2014-04-06','08:40:00',1.21),('1444','2014-04-06','08:45:00',1.26),('1444','2014-04-06','08:50:00',1.34),('1444','2014-04-06','09:15:00',1.82),('1444','2014-04-06','09:20:00',1.51),('1444','2014-04-06','09:25:00',1.13),('1444','2014-04-06','09:30:00',1.39),('1444','2014-04-06','09:35:00',1.72),('1444','2014-04-06','09:40:00',1.89),('1444','2014-04-06','09:45:00',2.29),('1444','2014-04-06','09:50:00',2.74),('1444','2014-04-06','09:55:00',2.78),('1444','2014-04-06','10:00:00',2.79),('1444','2014-04-06','10:05:00',1.37),('1444','2014-04-06','10:10:00',1.12),('1444','2014-04-06','10:15:00',1.27),('1444','2014-04-06','10:20:00',1.09),('1444','2014-04-06','10:30:00',1.08),('1444','2014-04-06','10:35:00',1.19),('1444','2014-04-06','10:40:00',1.35),('1444','2014-04-06','10:45:00',2.15),('1444','2014-04-06','10:50:00',2.82),('1444','2014-04-06','10:55:00',1.17),('1444','2014-04-06','11:00:00',2.48),('1444','2014-04-06','11:05:00',3.1),('1444','2014-04-06','11:10:00',2.83),('1444','2014-04-06','11:15:00',1.97),('1444','2014-04-06','11:20:00',2.3),('1444','2014-04-06','11:25:00',3.09),('1444','2014-04-06','11:30:00',3.19),('1444','2014-04-06','11:35:00',3.47),('1444','2014-04-06','11:40:00',3.5),('1444','2014-04-06','11:45:00',3.35),('1444','2014-04-06','11:50:00',3.2),('1444','2014-04-06','11:55:00',3.02),('1444','2014-04-06','12:00:00',3.39),('1444','2014-04-06','12:05:00',3.15),('1444','2014-04-06','12:10:00',3.26),('1444','2014-04-06','12:15:00',3.35),('1444','2014-04-06','12:20:00',2.83),('1444','2014-04-06','12:25:00',2.02),('1444','2014-04-06','12:30:00',1.41),('1444','2014-04-06','12:35:00',1.94),('1444','2014-04-06','12:40:00',1.02),('1444','2014-04-06','13:00:00',2.12),('1444','2014-04-06','13:05:00',2.62),('1444','2014-04-06','13:10:00',2.87),('1444','2014-04-06','13:15:00',1.9),('1444','2014-04-06','13:20:00',2.61),('1444','2014-04-06','13:25:00',1.12),('1444','2014-04-06','13:30:00',1.87),('1444','2014-04-06','13:35:00',2.85),('1444','2014-04-06','13:40:00',1.05),('1444','2014-04-06','13:45:00',2.58),('1444','2014-04-06','13:50:00',3.14),('1444','2014-04-06','13:55:00',3.38),('1444','2014-04-06','14:00:00',3.24),('1444','2014-04-06','14:05:00',3.16),('1444','2014-04-06','14:10:00',2.79),('1444','2014-04-06','14:15:00',3.34),('1444','2014-04-06','14:20:00',1.77),('1444','2014-04-06','14:25:00',1.16),('1444','2014-04-06','14:35:00',1.04),('1444','2014-04-06','14:40:00',1.01),('1444','2014-04-06','14:45:00',2.59),('1444','2014-04-06','14:50:00',2.72),('1444','2014-04-06','14:55:00',1.75),('1444','2014-04-06','15:00:00',2.67),('1444','2014-04-06','15:10:00',1.54),('1444','2014-04-06','15:15:00',2.71),('1444','2014-04-06','15:20:00',2.36),('1444','2014-04-06','15:25:00',1.17),('1444','2014-04-06','15:30:00',1.05),('1444','2014-04-06','15:55:00',2.78),('1444','2014-04-06','16:00:00',2.73),('1444','2014-04-06','16:05:00',1.61),('1444','2014-04-06','16:10:00',1.62),('1444','2014-04-06','16:15:00',1.17),('1444','2014-04-06','16:35:00',1.23),('1444','2014-04-06','16:40:00',1.53),('1444','2014-04-06','16:45:00',2.28),('1444','2014-04-06','16:50:00',2.3),('1444','2014-04-06','16:55:00',1.93),('1444','2014-04-06','17:25:00',1.21),('1444','2014-04-06','17:30:00',1.38),('1444','2014-04-06','17:35:00',1.03),('1444','2014-04-06','17:50:00',1.12),('1444','2013-07-10','07:35:00',1.11),('1444','2013-07-10','07:40:00',1.21),('1444','2013-07-10','07:45:00',1.29),('1444','2013-07-10','07:50:00',1.39),('1444','2013-07-10','07:55:00',1.41),('1444','2013-07-10','08:00:00',1.06),('1444','2013-07-10','08:05:00',1.25),('1444','2013-07-10','08:10:00',1.31),('1444','2013-07-10','08:15:00',1.38),('1444','2013-07-10','08:20:00',1.48),('1444','2013-07-10','08:25:00',1.42),('1444','2013-07-10','08:30:00',1.34),('1444','2013-07-10','08:35:00',1.39),('1444','2013-07-10','08:40:00',1.9),('1444','2013-07-10','08:45:00',1.78),('1444','2013-07-10','08:50:00',1.77),('1444','2013-07-10','08:55:00',1.74),('1444','2013-07-10','09:00:00',1.71),('1444','2013-07-10','09:05:00',1.76),('1444','2013-07-10','09:10:00',1.95),('1444','2013-07-10','09:15:00',2.03),('1444','2013-07-10','09:20:00',1.63),('1444','2013-07-10','09:25:00',1.29),('1444','2013-07-10','09:30:00',1.83),('1444','2013-07-10','09:35:00',2.04),('1444','2013-07-10','09:40:00',2.11),('1444','2013-07-10','09:45:00',2.15),('1444','2013-07-10','09:50:00',2.1),('1444','2013-07-10','09:55:00',1.72),('1444','2013-07-10','10:00:00',2.28),('1444','2013-07-10','10:05:00',2.31),('1444','2013-07-10','10:10:00',2.34),('1444','2013-07-10','10:15:00',2.38),('1444','2013-07-10','10:20:00',2.44),('1444','2013-07-10','10:25:00',2.48),('1444','2013-07-10','10:30:00',2.51),('1444','2013-07-10','10:35:00',2.55),('1444','2013-07-10','10:40:00',2.58),('1444','2013-07-10','10:45:00',2.6),('1444','2013-07-10','10:50:00',2.62),('1444','2013-07-10','10:55:00',2.65),('1444','2013-07-10','11:00:00',2.67),('1444','2013-07-10','11:05:00',2.7),('1444','2013-07-10','11:10:00',2.72),('1444','2013-07-10','11:15:00',2.74),('1444','2013-07-10','11:20:00',2.76),('1444','2013-07-10','11:25:00',2.74),('1444','2013-07-10','11:30:00',2.8),('1444','2013-07-10','11:35:00',2.83),('1444','2013-07-10','11:40:00',2.87),('1444','2013-07-10','11:45:00',2.89),('1444','2013-07-10','11:50:00',2.91),('1444','2013-07-10','11:55:00',2.93),('1444','2013-07-10','12:00:00',2.94),('1444','2013-07-10','12:05:00',2.94),('1444','2013-07-10','12:10:00',2.95),('1444','2013-07-10','12:15:00',2.98),('1444','2013-07-10','12:20:00',3.02),('1444','2013-07-10','12:25:00',3.02),('1444','2013-07-10','12:30:00',3.01),('1444','2013-07-10','12:35:00',3.08),('1444','2013-07-10','12:40:00',3.09),('1444','2013-07-10','12:45:00',3.07),('1444','2013-07-10','12:50:00',3.1),('1444','2013-07-10','12:55:00',3.1),('1444','2013-07-10','13:00:00',3.13),('1444','2013-07-10','13:05:00',3.1),('1444','2013-07-10','13:10:00',3.09),('1444','2013-07-10','13:15:00',3.09),('1444','2013-07-10','13:20:00',3.08),('1444','2013-07-10','13:25:00',3.09),('1444','2013-07-10','13:30:00',3.07),('1444','2013-07-10','13:35:00',3.1),('1444','2013-07-10','13:40:00',3.1),('1444','2013-07-10','13:45:00',3.1),('1444','2013-07-10','13:50:00',3.1),('1444','2013-07-10','13:55:00',3.1),('1444','2013-07-10','14:00:00',3.1),('1444','2013-07-10','14:05:00',3.11),('1444','2013-07-10','14:10:00',3.1),('1444','2013-07-10','14:15:00',3.09),('1444','2013-07-10','14:20:00',3.08),('1444','2013-07-10','14:25:00',3.07),('1444','2013-07-10','14:30:00',3.05),('1444','2013-07-10','14:35:00',3.01),('1444','2013-07-10','14:40:00',3),('1444','2013-07-10','14:45:00',2.97),('1444','2013-07-10','14:50:00',2.96),('1444','2013-07-10','14:55:00',2.94),('1444','2013-07-10','15:00:00',2.92),('1444','2013-07-10','15:05:00',2.91),('1444','2013-07-10','15:10:00',2.88),('1444','2013-07-10','15:15:00',2.84),('1444','2013-07-10','15:20:00',2.81),('1444','2013-07-10','15:25:00',2.79),('1444','2013-07-10','15:30:00',2.77),('1444','2013-07-10','15:35:00',2.73),('1444','2013-07-10','15:40:00',2.15),('1444','2013-07-10','15:45:00',2.66),('1444','2013-07-10','15:50:00',2.63),('1444','2013-07-10','15:55:00',2.58),('1444','2013-07-10','16:00:00',2.54),('1444','2013-07-10','16:05:00',2.5),('1444','2013-07-10','16:10:00',2.48),('1444','2013-07-10','16:15:00',2.43),('1444','2013-07-10','16:20:00',2.39),('1444','2013-07-10','16:25:00',2.34),('1444','2013-07-10','16:30:00',2.3),('1444','2013-07-10','16:35:00',2.26),('1444','2013-07-10','16:40:00',2.19),('1444','2013-07-10','16:45:00',2.16),('1444','2013-07-10','16:50:00',2.14),('1444','2013-07-10','16:55:00',2.11),('1444','2013-07-10','17:00:00',2.12),('1444','2013-07-10','17:05:00',1.87),('1444','2013-07-10','17:10:00',1.5),('1444','2013-07-10','17:15:00',1.24),('1444','2013-07-10','17:20:00',1.45),('1444','2013-07-10','17:35:00',1.13),('1444','2013-07-10','17:40:00',1.33),('1444','2013-07-10','17:45:00',1.28),('1444','2013-07-10','17:50:00',1.52),('1444','2013-07-10','17:55:00',1.25),('1444','2013-07-10','18:00:00',1.33),('1444','2013-07-10','18:05:00',1.2),('1444','2013-07-10','18:10:00',1.16),('1444','2013-07-09','07:55:00',1.01),('1444','2013-07-09','08:00:00',1.05),('1444','2013-07-09','08:05:00',1.11),('1444','2013-07-09','08:10:00',1.16),('1444','2013-07-09','08:15:00',1.22),('1444','2013-07-09','08:20:00',1.27),('1444','2013-07-09','08:25:00',1.33),('1444','2013-07-09','08:30:00',1.39),('1444','2013-07-09','08:35:00',1.45),('1444','2013-07-09','08:40:00',1.5),('1444','2013-07-09','08:45:00',1.55),('1444','2013-07-09','08:50:00',1.61),('1444','2013-07-09','08:55:00',1.66),('1444','2013-07-09','09:00:00',1.71),('1444','2013-07-09','09:05:00',1.77),('1444','2013-07-09','09:10:00',1.81),('1444','2013-07-09','09:15:00',1.87),('1444','2013-07-09','09:20:00',1.91),('1444','2013-07-09','09:25:00',1.97),('1444','2013-07-09','09:30:00',2.02),('1444','2013-07-09','09:35:00',2.05),('1444','2013-07-09','09:40:00',2.09),('1444','2013-07-09','09:45:00',2.15),('1444','2013-07-09','09:50:00',2.18),('1444','2013-07-09','09:55:00',2.23),('1444','2013-07-09','10:00:00',2.25),('1444','2013-07-09','10:05:00',2.24),('1444','2013-07-09','10:10:00',2.32),('1444','2013-07-09','10:15:00',2.37),('1444','2013-07-09','10:20:00',2.4),('1444','2013-07-09','10:25:00',2.44),('1444','2013-07-09','10:30:00',2.48),('1444','2013-07-09','10:35:00',2.53),('1444','2013-07-09','10:40:00',2.54),('1444','2013-07-09','10:45:00',2.6),('1444','2013-07-09','10:50:00',2.64),('1444','2013-07-09','10:55:00',2.66),('1444','2013-07-09','11:00:00',2.71),('1444','2013-07-09','11:05:00',2.74),('1444','2013-07-09','11:10:00',2.78),('1444','2013-07-09','11:15:00',2.82),('1444','2013-07-09','11:20:00',2.71),('1444','2013-07-09','11:25:00',1.72),('1444','2013-07-09','11:30:00',2.31),('1444','2013-07-09','11:35:00',1.72),('1444','2013-07-09','11:40:00',1.73),('1444','2013-07-09','11:45:00',2.02),('1444','2013-07-09','11:50:00',3.2),('1444','2013-07-09','11:55:00',3.26),('1444','2013-07-09','12:00:00',3.2),('1444','2013-07-09','12:05:00',3.17),('1444','2013-07-09','12:10:00',3.08),('1444','2013-07-09','12:15:00',3.05),('1444','2013-07-09','12:20:00',2.96),('1444','2013-07-09','12:25:00',2.99),('1444','2013-07-09','12:30:00',2.98),('1444','2013-07-09','12:35:00',3.03),('1444','2013-07-09','12:40:00',3.04),('1444','2013-07-09','12:45:00',3.05),('1444','2013-07-09','12:50:00',3.02),('1444','2013-07-09','12:55:00',3),('1444','2013-07-09','13:00:00',3.05),('1444','2013-07-09','13:05:00',3.16),('1444','2013-07-09','13:10:00',3.17),('1444','2013-07-09','13:15:00',3.11),('1444','2013-07-09','13:20:00',3.13),('1444','2013-07-09','13:25:00',3.18),('1444','2013-07-09','13:30:00',3.3),('1444','2013-07-09','13:35:00',3.08),('1444','2013-07-09','13:40:00',3),('1444','2013-07-09','13:45:00',2.81),('1444','2013-07-09','13:50:00',2.32),('1444','2013-07-09','13:55:00',2.4),('1444','2013-07-09','14:00:00',2.5),('1444','2013-07-09','14:05:00',2.31),('1444','2013-07-09','14:10:00',2.58),('1444','2013-07-09','14:15:00',2.72),('1444','2013-07-09','14:20:00',2.18),('1444','2013-07-09','14:25:00',2.61),('1444','2013-07-09','14:30:00',1.43),('1444','2013-07-08','07:45:00',1.03),('1444','2013-07-08','08:10:00',1.08),('1444','2013-07-08','08:15:00',1.2),('1444','2013-07-08','08:20:00',1.27),('1444','2013-07-08','08:25:00',1.33),('1444','2013-07-08','08:30:00',1.38),('1444','2013-07-08','08:35:00',1.45),('1444','2013-07-08','08:40:00',1.51),('1444','2013-07-08','08:45:00',1.57),('1444','2013-07-08','08:50:00',1.61),('1444','2013-07-08','08:55:00',1.67),('1444','2013-07-08','09:00:00',1.7),('1444','2013-07-08','09:05:00',1.75),('1444','2013-07-08','09:10:00',1.79),('1444','2013-07-08','09:15:00',1.83),('1444','2013-07-08','09:20:00',1.89),('1444','2013-07-08','09:25:00',1.86),('1444','2013-07-08','09:30:00',1.97),('1444','2013-07-08','09:35:00',2.06),('1444','2013-07-08','09:40:00',2.14),('1444','2013-07-08','09:45:00',2.2),('1444','2013-07-08','09:50:00',2.23),('1444','2013-07-08','09:55:00',2.28),('1444','2013-07-08','10:00:00',2.33),('1444','2013-07-08','10:05:00',2.36),('1444','2013-07-08','10:10:00',2.38),('1444','2013-07-08','10:15:00',2.43),('1444','2013-07-08','10:20:00',2.45),('1444','2013-07-08','10:25:00',2.5),('1444','2013-07-08','10:30:00',2.55),('1444','2013-07-08','10:35:00',2.57),('1444','2013-07-08','10:40:00',2.56),('1444','2013-07-08','10:45:00',2.61),('1444','2013-07-08','10:50:00',2.64),('1444','2013-07-08','10:55:00',2.66),('1444','2013-07-08','11:00:00',2.68),('1444','2013-07-08','11:05:00',2.73),('1444','2013-07-08','11:10:00',2.76),('1444','2013-07-08','11:15:00',2.81),('1444','2013-07-08','11:20:00',2.84),('1444','2013-07-08','11:25:00',2.89),('1444','2013-07-08','11:30:00',2.9),('1444','2013-07-08','11:35:00',2.93),('1444','2013-07-08','11:40:00',2.84),('1444','2013-07-08','11:45:00',2.86),('1444','2013-07-08','11:50:00',2.99),('1444','2013-07-08','11:55:00',2.97),('1444','2013-07-08','12:00:00',2.99),('1444','2013-07-08','12:05:00',3.09),('1444','2013-07-08','12:10:00',3.19),('1444','2013-07-08','12:15:00',3.26),('1444','2013-07-08','12:20:00',2.79),('1444','2013-07-08','12:25:00',3.13),('1444','2013-07-08','12:30:00',2.51),('1444','2013-07-08','12:35:00',3.08),('1444','2013-07-08','12:40:00',3.14),('1444','2013-07-08','12:45:00',3.14),('1444','2013-07-08','12:50:00',3.11),('1444','2013-07-08','12:55:00',3.17),('1444','2013-07-08','13:00:00',3.25),('1444','2013-07-08','13:05:00',2.97),('1444','2013-07-08','13:10:00',3.37),('1444','2013-07-08','13:15:00',3.48),('1444','2013-07-08','13:20:00',2.81),('1444','2013-07-07','07:55:00',1.05),('1444','2013-07-07','08:00:00',1.11),('1444','2013-07-07','08:05:00',1.17),('1444','2013-07-07','08:10:00',1.24),('1444','2013-07-07','08:15:00',1.29),('1444','2013-07-07','08:25:00',1.1),('1444','2013-07-07','08:30:00',1.27),('1444','2013-07-07','08:35:00',1.57),('1444','2013-07-07','08:40:00',1.55),('1444','2013-07-07','08:50:00',1.23),('1444','2013-07-07','08:55:00',1.75),('1444','2013-07-07','09:00:00',1.78),('1444','2013-07-07','09:05:00',1.67),('1444','2013-07-07','09:10:00',1.79),('1444','2013-07-07','09:15:00',1.91),('1444','2013-07-07','09:20:00',1.14),('1444','2013-07-07','09:25:00',1.4),('1444','2013-07-07','09:30:00',2.07),('1444','2013-07-07','09:35:00',2.18),('1444','2013-07-07','09:40:00',2.16),('1444','2013-07-07','09:45:00',2.12),('1444','2013-07-07','09:50:00',2.33),('1444','2013-07-07','09:55:00',2.43),('1444','2013-07-07','10:00:00',2.49),('1444','2013-07-07','10:05:00',2.33),('1444','2013-07-07','10:10:00',2.37),('1444','2013-07-07','10:15:00',2.41),('1444','2013-07-07','10:20:00',2.24),('1444','2013-07-07','10:25:00',2.47),('1444','2013-07-07','10:30:00',2.16),('1444','2013-07-07','10:35:00',2.67),('1444','2013-07-07','10:40:00',2.58),('1444','2013-07-07','10:45:00',2.59),('1444','2013-07-07','10:50:00',2.76),('1444','2013-07-07','10:55:00',2.77),('1444','2013-07-07','11:00:00',2.79),('1444','2013-07-07','11:05:00',2.81),('1444','2013-07-07','11:10:00',2.9),('1444','2013-07-07','11:15:00',2.9),('1444','2013-07-07','11:20:00',2.73),('1444','2013-07-07','11:25:00',2.53),('1444','2013-07-07','11:30:00',2.52),('1444','2013-07-07','11:35:00',2.52),('1444','2013-07-07','11:40:00',2.54),('1444','2013-07-07','11:45:00',2.29),('1444','2013-07-07','11:50:00',2.13),('1444','2013-07-07','11:55:00',1.71),('1444','2013-07-07','12:00:00',1.41),('1444','2013-07-07','12:05:00',2.79),('1444','2013-07-07','12:10:00',2.96),('1444','2013-07-07','12:15:00',2.99),('1444','2013-07-07','12:20:00',3.15),('1444','2013-07-07','12:25:00',2.93),('1444','2013-07-07','12:30:00',2.86),('1444','2013-07-07','12:35:00',3.01),('1444','2013-07-07','12:40:00',3.13),('1444','2013-07-07','12:45:00',3.19),('1444','2013-07-07','12:50:00',3.07),('1444','2013-07-07','12:55:00',3.23),('1444','2013-07-07','13:00:00',3.18),('1444','2013-07-07','13:05:00',2.73),('1444','2013-07-07','13:10:00',3.18),('1444','2013-07-07','13:15:00',3.19),('1444','2013-07-07','13:20:00',3.1),('1444','2013-07-07','13:25:00',2.83),('1444','2013-07-07','13:30:00',2.28),('1444','2013-07-07','13:35:00',3.25),('1444','2013-07-07','13:40:00',3.19),('1444','2013-07-07','13:45:00',3.12),('1444','2013-07-07','13:50:00',3.52),('1444','2013-07-07','13:55:00',3.18),('1444','2013-07-07','14:00:00',1.83),('1444','2013-07-07','14:05:00',2.37),('1444','2013-07-07','14:10:00',1.54),('1444','2013-07-07','14:15:00',1.09),('1444','2013-07-06','07:55:00',1.01),('1444','2013-07-06','08:00:00',1.07),('1444','2013-07-06','08:05:00',1.13),('1444','2013-07-06','08:10:00',1.19),('1444','2013-07-06','08:15:00',1.24),('1444','2013-07-06','08:20:00',1.29),('1444','2013-07-06','08:25:00',1.36),('1444','2013-07-06','08:30:00',1.42),('1444','2013-07-06','08:35:00',1.47),('1444','2013-07-06','08:40:00',1.54),('1444','2013-07-06','08:45:00',1.59),('1444','2013-07-06','08:50:00',1.65),('1444','2013-07-06','08:55:00',1.69),('1444','2013-07-06','09:00:00',1.74),('1444','2013-07-06','09:05:00',1.8),('1444','2013-07-06','09:10:00',1.86),('1444','2013-07-06','09:15:00',1.9),('1444','2013-07-06','09:20:00',1.96),('1444','2013-07-06','09:25:00',2.01),('1444','2013-07-06','09:30:00',2.04),('1444','2013-07-06','09:35:00',2.08),('1444','2013-07-06','09:40:00',2.13),('1444','2013-07-06','09:45:00',2.16),('1444','2013-07-06','09:50:00',2.22),('1444','2013-07-06','09:55:00',2.29),('1444','2013-07-06','10:00:00',2.34),('1444','2013-07-06','10:05:00',2.39),('1444','2013-07-06','10:10:00',2.44),('1444','2013-07-06','10:15:00',2.48),('1444','2013-07-06','10:20:00',2.5),('1444','2013-07-06','10:25:00',2.53),('1444','2013-07-06','10:30:00',2.57),('1444','2013-07-06','10:35:00',2.59),('1444','2013-07-06','10:40:00',2.6),('1444','2013-07-06','10:45:00',2.66),('1444','2013-07-06','10:50:00',2.71),('1444','2013-07-06','10:55:00',2.75),('1444','2013-07-06','11:00:00',2.77),('1444','2013-07-06','11:05:00',2.8),('1444','2013-07-06','11:10:00',2.81),('1444','2013-07-06','11:15:00',2.86),('1444','2013-07-06','11:20:00',2.84),('1444','2013-07-06','11:25:00',2.86),('1444','2013-07-06','11:30:00',2.91),('1444','2013-07-06','11:35:00',2.94),('1444','2013-07-06','11:40:00',2.95),('1444','2013-07-06','11:45:00',2.99),('1444','2013-07-06','11:50:00',3.01),('1444','2013-07-06','11:55:00',2.99),('1444','2013-07-06','12:00:00',3.01),('1444','2013-07-06','12:05:00',3.03),('1444','2013-07-06','12:10:00',3.12),('1444','2013-07-06','12:15:00',3.14),('1444','2013-07-06','12:20:00',3.17),('1444','2013-07-06','12:25:00',3.2),('1444','2013-07-06','12:30:00',3.19),('1444','2013-07-06','12:35:00',3.19),('1444','2013-07-06','12:40:00',3.14),('1444','2013-07-06','12:45:00',3.15),('1444','2013-07-06','12:50:00',3.16),('1444','2013-07-06','12:55:00',3.16),('1444','2013-07-06','13:00:00',3.19),('1444','2013-07-06','13:05:00',3.17),('1444','2013-07-06','13:10:00',3.14),('1444','2013-07-06','13:15:00',3.14),('1444','2013-07-06','13:20:00',3.16),('1444','2013-07-06','13:25:00',3.16),('1444','2013-07-06','13:30:00',3.2),('1444','2013-07-06','13:35:00',3.17),('1444','2013-07-06','13:40:00',3.19),('1444','2013-07-06','13:45:00',3.19),('1444','2013-07-06','13:50:00',3.15),('1444','2013-07-06','13:55:00',3.13),('1444','2013-07-06','14:00:00',3.14),('1444','2013-07-06','14:05:00',3.16),('1444','2013-07-06','14:10:00',3.14),('1444','2013-07-06','14:15:00',3.14),('1444','2013-07-06','14:20:00',1.75),('1444','2013-07-06','14:25:00',3.21),('1444','2013-07-06','14:30:00',3.08),('1444','2013-07-06','14:35:00',3.04),('1444','2013-07-06','14:40:00',3.04),('1444','2013-07-06','14:45:00',3.02),('1444','2013-07-06','14:50:00',2.63),('1444','2013-07-06','14:55:00',2.26),('1444','2013-07-06','15:00:00',1.88),('1444','2013-07-06','15:05:00',3),('1444','2013-07-06','15:10:00',3.01),('1444','2013-07-06','15:15:00',2.91),('1444','2013-07-06','15:20:00',2.72),('1444','2013-07-06','15:25:00',2.86),('1444','2013-07-06','15:30:00',2.59),('1444','2013-07-06','15:35:00',1.14),('1444','2013-07-06','16:50:00',1.24),('1444','2013-07-06','16:55:00',1.09),('1444','2013-07-06','17:15:00',1.16),('1444','2013-07-05','07:55:00',1.03),('1444','2013-07-05','08:00:00',1.1),('1444','2013-07-05','08:05:00',1.15),('1444','2013-07-05','08:10:00',1.21),('1444','2013-07-05','08:15:00',1.26),('1444','2013-07-05','08:20:00',1.3),('1444','2013-07-05','08:25:00',1.35),('1444','2013-07-05','08:30:00',1.41),('1444','2013-07-05','08:35:00',1.47),('1444','2013-07-05','08:40:00',1.52),('1444','2013-07-05','08:45:00',1.57),('1444','2013-07-05','08:50:00',1.62),('1444','2013-07-05','08:55:00',1.67),('1444','2013-07-05','09:00:00',1.73),('1444','2013-07-05','09:05:00',1.8),('1444','2013-07-05','09:10:00',1.86),('1444','2013-07-05','09:15:00',1.91),('1444','2013-07-05','09:20:00',1.97),('1444','2013-07-05','09:25:00',2.02),('1444','2013-07-05','09:30:00',2.05),('1444','2013-07-05','09:35:00',2.08),('1444','2013-07-05','09:40:00',2.14),('1444','2013-07-05','09:45:00',2.19),('1444','2013-07-05','09:50:00',2.23),('1444','2013-07-05','09:55:00',2.27),('1444','2013-07-05','10:00:00',2.32),('1444','2013-07-05','10:05:00',2.37),('1444','2013-07-05','10:10:00',2.41),('1444','2013-07-05','10:15:00',2.44),('1444','2013-07-05','10:20:00',2.48),('1444','2013-07-05','10:25:00',2.5),('1444','2013-07-05','10:30:00',2.54),('1444','2013-07-05','10:35:00',2.57),('1444','2013-07-05','10:40:00',2.59),('1444','2013-07-05','10:45:00',2.62),('1444','2013-07-05','10:50:00',2.65),('1444','2013-07-05','10:55:00',2.68),('1444','2013-07-05','11:00:00',2.68),('1444','2013-07-05','11:05:00',2.7),('1444','2013-07-05','11:10:00',2.74),('1444','2013-07-05','11:15:00',2.76),('1444','2013-07-05','11:20:00',2.8),('1444','2013-07-05','11:25:00',2.84),('1444','2013-07-05','11:30:00',2.91),('1444','2013-07-05','11:35:00',2.91),('1444','2013-07-05','11:40:00',2.92),('1444','2013-07-05','11:45:00',2.94),('1444','2013-07-05','11:50:00',2.93),('1444','2013-07-05','11:55:00',2.98),('1444','2013-07-05','12:00:00',2.99),('1444','2013-07-05','12:05:00',3.01),('1444','2013-07-05','12:10:00',3),('1444','2013-07-05','12:15:00',3.02),('1444','2013-07-05','12:20:00',3.09),('1444','2013-07-05','12:25:00',2.37),('1444','2013-07-05','12:30:00',2.55),('1444','2013-07-05','12:35:00',3.15),('1444','2013-07-05','12:40:00',3.08),('1444','2013-07-05','12:45:00',3.05),('1444','2013-07-05','12:50:00',3.12),('1444','2013-07-05','12:55:00',3.14),('1444','2013-07-05','13:00:00',2.48),('1444','2013-07-05','13:05:00',1.98),('1444','2013-07-05','13:10:00',2.79),('1444','2013-07-05','13:15:00',3.01),('1444','2013-07-05','13:20:00',2.44),('1444','2013-07-05','13:25:00',2.77),('1444','2013-07-05','13:30:00',2.89),('1444','2013-07-05','13:35:00',3.25),('1444','2013-07-05','13:40:00',3.23),('1444','2013-07-05','13:45:00',3.18),('1444','2013-07-05','13:50:00',3.16),('1444','2013-07-05','13:55:00',3.16),('1444','2013-07-05','14:00:00',3.2),('1444','2013-07-05','14:05:00',3.18),('1444','2013-07-05','14:10:00',2.71),('1444','2013-07-05','14:15:00',3.11),('1444','2013-07-05','14:20:00',3.06),('1444','2013-07-05','14:25:00',3.06),('1444','2013-07-05','14:30:00',3.03),('1444','2013-07-05','14:35:00',2.7),('1444','2013-07-05','14:40:00',2.77),('1444','2013-07-05','14:45:00',2.52),('1444','2013-07-05','14:50:00',2.35),('1444','2013-07-05','14:55:00',2.88),('1444','2013-07-05','15:00:00',2.97),('1444','2013-07-05','15:05:00',2.09),('1444','2013-07-05','15:10:00',2.99),('1444','2013-07-05','15:15:00',2.92),('1444','2013-07-05','15:20:00',2.3),('1444','2013-07-05','15:25:00',2.32),('1444','2013-07-05','15:30:00',1.96),('1444','2013-07-05','15:35:00',2.84),('1444','2013-07-05','15:40:00',2.74),('1444','2013-07-05','15:45:00',2.74),('1444','2013-07-05','15:50:00',2.69),('1444','2013-07-05','15:55:00',2.45),('1444','2013-07-05','16:00:00',2.55),('1444','2013-07-05','16:05:00',2.54),('1444','2013-07-05','16:10:00',2.48),('1444','2013-07-05','16:15:00',2.42),('1444','2013-07-05','16:20:00',2.41),('1444','2013-07-05','16:25:00',2.38),('1444','2013-07-05','16:30:00',2.33),('1444','2013-07-05','16:35:00',2.29),('1444','2013-07-05','16:40:00',2.22),('1444','2013-07-05','16:45:00',2.2),('1444','2013-07-05','16:50:00',2.11),('1444','2013-07-05','16:55:00',2.03),('1444','2013-07-05','17:00:00',1.99),('1444','2013-07-05','17:05:00',1.94),('1444','2013-07-05','17:10:00',1.92),('1444','2013-07-05','17:15:00',1.91),('1444','2013-07-05','17:20:00',1.87),('1444','2013-07-05','17:25:00',1.77),('1444','2013-07-05','17:30:00',1.73),('1444','2013-07-05','17:35:00',1.66),('1444','2013-07-05','17:40:00',1.56),('1444','2013-07-05','17:45:00',1.49),('1444','2013-07-05','17:50:00',1.41),('1444','2013-07-05','17:55:00',1.37),('1444','2013-07-05','18:00:00',1.36),('1444','2013-07-05','18:05:00',1.32),('1444','2013-07-05','18:10:00',1.18),('1444','2013-07-05','18:15:00',1.04),('1444','2013-07-04','11:35:00',1.09),('1444','2013-07-04','11:40:00',1.22),('1444','2013-07-04','11:45:00',1.29),('1444','2013-07-04','11:50:00',1.27),('1444','2013-07-04','11:55:00',1.11),('1444','2013-07-04','12:00:00',1.1),('1444','2013-07-04','12:05:00',1.51),('1444','2013-07-04','12:10:00',1.83),('1444','2013-07-04','12:15:00',1.73),('1444','2013-07-04','12:20:00',2.11),('1444','2013-07-04','12:25:00',2.42),('1444','2013-07-04','12:30:00',2.06),('1444','2013-07-04','12:35:00',1.62),('1444','2013-07-04','12:40:00',1.28),('1444','2013-07-04','13:05:00',1.05),('1444','2013-07-04','13:10:00',1.4),('1444','2013-07-04','13:15:00',2.14),('1444','2013-07-04','13:20:00',1.61),('1444','2013-07-04','13:25:00',2.68),('1444','2013-07-04','13:30:00',1.77),('1444','2013-07-04','13:35:00',2),('1444','2013-07-04','13:40:00',2.9),('1444','2013-07-04','13:45:00',3.92),('1444','2013-07-04','13:50:00',3.86),('1444','2013-07-04','13:55:00',2.88),('1444','2013-07-04','14:00:00',2.02),('1444','2013-07-04','14:05:00',1.78),('1444','2013-07-04','14:10:00',1.74),('1444','2013-07-04','14:15:00',1.76),('1444','2013-07-04','14:20:00',1.75),('1444','2013-07-04','14:25:00',1.67),('1444','2013-07-04','14:30:00',1.58),('1444','2013-07-04','14:35:00',1.61),('1444','2013-07-04','14:40:00',1.73),('1444','2013-07-04','14:45:00',2.1),('1444','2013-07-04','14:50:00',2.39),('1444','2013-07-04','14:55:00',1.55),('1444','2013-07-04','15:00:00',1.4),('1444','2013-07-04','15:05:00',1.42),('1444','2013-07-04','15:10:00',2.38),('1444','2013-07-04','15:15:00',1.84),('1444','2013-07-04','15:20:00',2.13),('1444','2013-07-04','15:25:00',3.03),('1444','2013-07-04','15:30:00',1.96),('1444','2013-07-04','15:35:00',1.62),('1444','2013-07-04','15:40:00',1.96),('1444','2013-07-04','15:45:00',2.75),('1444','2013-07-04','15:50:00',1.52),('1444','2013-07-04','15:55:00',1.53),('1444','2013-07-04','16:00:00',1.58),('1444','2013-07-04','16:05:00',1.72),('1444','2013-07-04','16:10:00',1.39),('1444','2013-07-04','16:15:00',1.38),('1444','2013-07-04','16:20:00',1.48),('1444','2013-07-04','16:25:00',1.83),('1444','2013-07-04','16:30:00',1.62),('1444','2013-07-04','16:35:00',2.11),('1444','2013-07-04','16:40:00',1.28),('1444','2013-07-04','16:45:00',1.27),('1444','2013-07-04','16:50:00',1.16),('1444','2013-07-04','16:55:00',1.1),('1444','2013-07-04','17:10:00',1.24),('1444','2013-07-04','17:15:00',2.04),('1444','2013-07-04','17:20:00',1.47),('1444','2013-07-04','17:25:00',2.03),('1444','2013-07-04','17:30:00',1.64),('1444','2013-07-04','17:35:00',1.89),('1444','2013-07-04','17:40:00',1.75),('1444','2013-07-04','17:45:00',1.72),('1444','2013-07-04','17:50:00',1.7),('1444','2013-07-04','17:55:00',1.42),('1444','2013-07-04','18:00:00',1.59),('1444','2013-07-04','18:05:00',1.5),('1444','2013-07-04','18:10:00',1.44),('1444','2013-07-04','18:15:00',1.41),('1444','2013-07-04','18:20:00',1.3),('1444','2013-07-04','18:25:00',1.07),('1444','2013-07-03','07:50:00',1.01),('1444','2013-07-03','07:55:00',1.07),('1444','2013-07-03','08:00:00',1.13),('1444','2013-07-03','08:05:00',1.19),('1444','2013-07-03','08:10:00',1.24),('1444','2013-07-03','08:15:00',1.32),('1444','2013-07-03','08:20:00',1.37),('1444','2013-07-03','08:25:00',1.44),('1444','2013-07-03','08:30:00',1.49),('1444','2013-07-03','08:35:00',1.54),('1444','2013-07-03','08:40:00',1.6),('1444','2013-07-03','08:45:00',1.65),('1444','2013-07-03','08:50:00',1.7),('1444','2013-07-03','08:55:00',1.76),('1444','2013-07-03','09:00:00',1.81),('1444','2013-07-03','09:05:00',1.87),('1444','2013-07-03','09:10:00',1.92),('1444','2013-07-03','09:15:00',1.97),('1444','2013-07-03','09:20:00',2.02),('1444','2013-07-03','09:25:00',2.05),('1444','2013-07-03','09:30:00',2.09),('1444','2013-07-03','09:35:00',2.13),('1444','2013-07-03','09:40:00',2.15),('1444','2013-07-03','09:45:00',2.21),('1444','2013-07-03','09:50:00',2.26),('1444','2013-07-03','09:55:00',2.28),('1444','2013-07-03','10:00:00',2.33),('1444','2013-07-03','10:05:00',2.39),('1444','2013-07-03','10:10:00',2.41),('1444','2013-07-03','10:15:00',2.43),('1444','2013-07-03','10:20:00',2.45),('1444','2013-07-03','10:25:00',2.47),('1444','2013-07-03','10:30:00',2.54),('1444','2013-07-03','10:35:00',2.58),('1444','2013-07-03','10:40:00',2.6),('1444','2013-07-03','10:45:00',2.61),('1444','2013-07-03','10:50:00',2.64),('1444','2013-07-03','10:55:00',2.68),('1444','2013-07-03','11:00:00',2.74),('1444','2013-07-03','11:05:00',2.75),('1444','2013-07-03','11:10:00',2.81),('1444','2013-07-03','11:15:00',2.86),('1444','2013-07-03','11:20:00',2.85),('1444','2013-07-03','11:25:00',2.85),('1444','2013-07-03','11:30:00',2.89),('1444','2013-07-03','11:35:00',2.91),('1444','2013-07-03','11:40:00',2.98),('1444','2013-07-03','11:45:00',3.01),('1444','2013-07-03','11:50:00',2.99),('1444','2013-07-03','11:55:00',3),('1444','2013-07-03','12:00:00',3.03),('1444','2013-07-03','12:05:00',3.05),('1444','2013-07-03','12:10:00',3.06),('1444','2013-07-03','12:15:00',3.08),('1444','2013-07-03','12:20:00',3.08),('1444','2013-07-03','12:25:00',3.1),('1444','2013-07-03','12:30:00',3.12),('1444','2013-07-03','12:35:00',3.14),('1444','2013-07-03','12:40:00',3.16),('1444','2013-07-03','12:45:00',3.16),('1444','2013-07-03','12:50:00',3.18),('1444','2013-07-03','12:55:00',3.18),('1444','2013-07-03','13:00:00',3.18),('1444','2013-07-03','13:05:00',3.19),('1444','2013-07-03','13:10:00',3.19),('1444','2013-07-03','13:15:00',3.19),('1444','2013-07-03','13:20:00',3.18),('1444','2013-07-03','13:25:00',3.19),('1444','2013-07-03','13:30:00',3.18),('1444','2013-07-03','13:35:00',3.18),('1444','2013-07-03','13:40:00',3.18),('1444','2013-07-03','13:45:00',3.18),('1444','2013-07-03','13:50:00',3.18),('1444','2013-07-03','13:55:00',3.17),('1444','2013-07-03','14:00:00',3.16),('1444','2013-07-03','14:05:00',3.16),('1444','2013-07-03','14:10:00',3.13),('1444','2013-07-03','14:15:00',3.13),('1444','2013-07-03','14:20:00',3.13),('1444','2013-07-03','14:25:00',3.13),('1444','2013-07-03','14:30:00',3.1),('1444','2013-07-03','14:35:00',3.08),('1444','2013-07-03','14:40:00',3.06),('1444','2013-07-03','14:45:00',3.03),('1444','2013-07-03','14:50:00',3.02),('1444','2013-07-03','14:55:00',3),('1444','2013-07-03','15:00:00',2.99),('1444','2013-07-03','15:05:00',2.96),('1444','2013-07-03','15:10:00',2.93),('1444','2013-07-03','15:15:00',2.91),('1444','2013-07-03','15:20:00',2.87),('1444','2013-07-03','15:25:00',2.85),('1444','2013-07-03','15:30:00',2.83),('1444','2013-07-03','15:35:00',2.78),('1444','2013-07-03','15:40:00',2.75),('1444','2013-07-03','15:45:00',2.72),('1444','2013-07-03','15:50:00',2.68),('1444','2013-07-03','15:55:00',2.65),('1444','2013-07-03','16:00:00',2.62),('1444','2013-07-03','16:05:00',2.58),('1444','2013-07-03','16:10:00',2.53),('1444','2013-07-03','16:15:00',2.5),('1444','2013-07-03','16:20:00',2.45),('1444','2013-07-03','16:25:00',2.4),('1444','2013-07-03','16:30:00',2.37),('1444','2013-07-03','16:35:00',2.32),('1444','2013-07-03','16:40:00',2.28),('1444','2013-07-03','16:45:00',2.22),('1444','2013-07-03','16:50:00',2.17),('1444','2013-07-03','16:55:00',2.14),('1444','2013-07-03','17:00:00',2.09),('1444','2013-07-03','17:05:00',2.04),('1444','2013-07-03','17:10:00',1.99),('1444','2013-07-03','17:15:00',1.93),('1444','2013-07-03','17:20:00',1.89),('1444','2013-07-03','17:25:00',1.83),('1444','2013-07-03','17:30:00',1.78),('1444','2013-07-03','17:35:00',1.72),('1444','2013-07-03','17:40:00',1.67),('1444','2013-07-03','17:45:00',1.62),('1444','2013-07-03','17:50:00',1.55),('1444','2013-07-03','17:55:00',1.49),('1444','2013-07-03','18:00:00',1.43),('1444','2013-07-03','18:05:00',1.35),('1444','2013-07-03','18:10:00',1.3),('1444','2013-07-03','18:15:00',1.25),('1444','2013-07-03','18:20:00',1.2),('1444','2013-07-03','18:25:00',1.14),('1444','2013-07-03','18:30:00',1.08),('1444','2013-07-03','18:35:00',1.02),('1444','2013-07-02','07:55:00',1.06),('1444','2013-07-02','08:00:00',1.11),('1444','2013-07-02','08:05:00',1.17),('1444','2013-07-02','08:10:00',1.24),('1444','2013-07-02','08:15:00',1.28),('1444','2013-07-02','08:20:00',1.36),('1444','2013-07-02','08:25:00',1.41),('1444','2013-07-02','08:30:00',1.47),('1444','2013-07-02','08:35:00',1.54),('1444','2013-07-02','08:40:00',1.59),('1444','2013-07-02','08:45:00',1.63),('1444','2013-07-02','08:50:00',1.68),('1444','2013-07-02','08:55:00',1.74),('1444','2013-07-02','09:00:00',1.81),('1444','2013-07-02','09:05:00',1.86),('1444','2013-07-02','09:10:00',1.91),('1444','2013-07-02','09:15:00',1.95),('1444','2013-07-02','09:20:00',1.99),('1444','2013-07-02','09:25:00',2.03),('1444','2013-07-02','09:30:00',2.07),('1444','2013-07-02','09:35:00',2.12),('1444','2013-07-02','09:40:00',2.16),('1444','2013-07-02','09:45:00',2.2),('1444','2013-07-02','09:50:00',2.24),('1444','2013-07-02','09:55:00',2.3),('1444','2013-07-02','10:00:00',2.35),('1444','2013-07-02','10:05:00',2.36),('1444','2013-07-02','10:10:00',2.39),('1444','2013-07-02','10:15:00',2.42),('1444','2013-07-02','10:20:00',2.44),('1444','2013-07-02','10:25:00',2.49),('1444','2013-07-02','10:30:00',2.51),('1444','2013-07-02','10:35:00',2.53),('1444','2013-07-02','10:40:00',2.58),('1444','2013-07-02','10:45:00',2.62),('1444','2013-07-02','10:50:00',2.64),('1444','2013-07-02','10:55:00',2.69),('1444','2013-07-02','11:00:00',2.71),('1444','2013-07-02','11:05:00',2.69),('1444','2013-07-02','11:10:00',2.7),('1444','2013-07-02','11:15:00',2.74),('1444','2013-07-02','11:20:00',2.78),('1444','2013-07-02','11:25:00',2.79),('1444','2013-07-02','11:30:00',2.79),('1444','2013-07-02','11:35:00',2.83),('1444','2013-07-02','11:40:00',2.88),('1444','2013-07-02','11:45:00',2.87),('1444','2013-07-02','11:50:00',2.89),('1444','2013-07-02','11:55:00',2.92),('1444','2013-07-02','12:00:00',2.94),('1444','2013-07-02','12:05:00',2.94),('1444','2013-07-02','12:10:00',2.94),('1444','2013-07-02','12:15:00',2.92),('1444','2013-07-02','12:20:00',2.99),('1444','2013-07-02','12:25:00',2.99),('1444','2013-07-02','12:30:00',2.53),('1444','2013-07-02','12:40:00',2.93),('1444','2013-07-02','12:45:00',3.05),('1444','2013-07-02','12:50:00',2.88),('1444','2013-07-02','12:55:00',2.7),('1444','2013-07-02','13:00:00',2.1),('1444','2013-07-02','13:05:00',2.2),('1444','2013-07-02','13:10:00',3),('1444','2013-07-02','13:15:00',2.82),('1444','2013-07-02','13:20:00',3.13),('1444','2013-07-02','13:25:00',3.17),('1444','2013-07-02','13:30:00',3.09),('1444','2013-07-02','13:35:00',3.12),('1444','2013-07-02','13:40:00',3.07),('1444','2013-07-02','13:45:00',3.09),('1444','2013-07-02','13:50:00',3.05),('1444','2013-07-02','13:55:00',3.05),('1444','2013-07-02','14:00:00',3.04),('1444','2013-07-02','14:05:00',3.02),('1444','2013-07-02','14:10:00',3.05),('1444','2013-07-02','14:15:00',3.06),('1444','2013-07-02','14:20:00',3.05),('1444','2013-07-02','14:25:00',3.03),('1444','2013-07-02','14:30:00',2.99),('1444','2013-07-02','14:35:00',2.99),('1444','2013-07-02','14:40:00',2.99),('1444','2013-07-02','14:45:00',2.96),('1444','2013-07-02','14:50:00',2.93),('1444','2013-07-02','14:55:00',2.93),('1444','2013-07-02','15:00:00',2.92),('1444','2013-07-02','15:05:00',2.9),('1444','2013-07-02','15:10:00',2.87),('1444','2013-07-02','15:15:00',2.83),('1444','2013-07-02','15:20:00',2.81),('1444','2013-07-02','15:25:00',2.79),('1444','2013-07-02','15:30:00',2.77),('1444','2013-07-02','15:35:00',2.74),('1444','2013-07-02','15:40:00',2.72),('1444','2013-07-02','15:45:00',2.68),('1444','2013-07-02','15:50:00',2.63),('1444','2013-07-02','15:55:00',2.59),('1444','2013-07-02','16:00:00',2.56),('1444','2013-07-02','16:05:00',2.53),('1444','2013-07-02','16:10:00',2.49),('1444','2013-07-02','16:15:00',2.44),('1444','2013-07-02','16:20:00',2.4),('1444','2013-07-02','16:25:00',2.35),('1444','2013-07-02','16:30:00',2.31),('1444','2013-07-02','16:35:00',2.27),('1444','2013-07-02','16:40:00',2.23),('1444','2013-07-02','16:45:00',2.17),('1444','2013-07-02','16:50:00',2.12),('1444','2013-07-02','16:55:00',2.1),('1444','2013-07-02','17:00:00',2.03),('1444','2013-07-02','17:05:00',1.97),('1444','2013-07-02','17:10:00',1.93),('1444','2013-07-02','17:15:00',1.87),('1444','2013-07-02','17:20:00',1.82),('1444','2013-07-02','17:25:00',1.78),('1444','2013-07-02','17:30:00',1.71),('1444','2013-07-02','17:35:00',1.65),('1444','2013-07-02','17:40:00',1.59),('1444','2013-07-02','17:45:00',1.53),('1444','2013-07-02','17:50:00',1.48),('1444','2013-07-02','17:55:00',1.43),('1444','2013-07-02','18:00:00',1.37),('1444','2013-07-02','18:05:00',1.31),('1444','2013-07-02','18:10:00',1.25),('1444','2013-07-02','18:15:00',1.21),('1444','2013-07-02','18:20:00',1.15),('1444','2013-07-02','18:25:00',1.08),('1444','2013-07-02','18:30:00',1.02),('1444','2013-07-01','07:50:00',1.01),('1444','2013-07-01','07:55:00',1.08),('1444','2013-07-01','08:00:00',1.15),('1444','2013-07-01','08:05:00',1.2),('1444','2013-07-01','08:10:00',1.24),('1444','2013-07-01','08:15:00',1.32),('1444','2013-07-01','08:20:00',1.39),('1444','2013-07-01','08:25:00',1.44),('1444','2013-07-01','08:30:00',1.51),('1444','2013-07-01','08:35:00',1.57),('1444','2013-07-01','08:40:00',1.63),('1444','2013-07-01','08:45:00',1.7),('1444','2013-07-01','08:50:00',1.75),('1444','2013-07-01','08:55:00',1.8),('1444','2013-07-01','09:00:00',1.85),('1444','2013-07-01','09:05:00',1.9),('1444','2013-07-01','09:10:00',1.96),('1444','2013-07-01','09:15:00',2.01),('1444','2013-07-01','09:20:00',2.06),('1444','2013-07-01','09:25:00',2.11),('1444','2013-07-01','09:30:00',2.16),('1444','2013-07-01','09:35:00',2.2),('1444','2013-07-01','09:40:00',2.23),('1444','2013-07-01','09:45:00',2.28),('1444','2013-07-01','09:50:00',2.32),('1444','2013-07-01','09:55:00',2.35),('1444','2013-07-01','10:00:00',2.4),('1444','2013-07-01','10:05:00',2.43),('1444','2013-07-01','10:10:00',2.46),('1444','2013-07-01','10:15:00',2.5),('1444','2013-07-01','10:20:00',2.56),('1444','2013-07-01','10:25:00',2.58),('1444','2013-07-01','10:30:00',2.63),('1444','2013-07-01','10:35:00',2.65),('1444','2013-07-01','10:40:00',2.69),('1444','2013-07-01','10:45:00',2.73),('1444','2013-07-01','10:50:00',2.78),('1444','2013-07-01','10:55:00',2.82),('1444','2013-07-01','11:00:00',2.85),('1444','2013-07-01','11:05:00',2.89),('1444','2013-07-01','11:10:00',2.87),('1444','2013-07-01','11:15:00',2.91),('1444','2013-07-01','11:20:00',2.97),('1444','2013-07-01','11:25:00',3.02),('1444','2013-07-01','11:30:00',3.04),('1444','2013-07-01','11:35:00',3.02),('1444','2013-07-01','11:40:00',3.02),('1444','2013-07-01','11:45:00',3.06),('1444','2013-07-01','11:50:00',3.08),('1444','2013-07-01','11:55:00',3.11),('1444','2013-07-01','12:00:00',3.09),('1444','2013-07-01','12:05:00',3.09),('1444','2013-07-01','12:10:00',3.1),('1444','2013-07-01','12:15:00',3.11),('1444','2013-07-01','12:20:00',3.11),('1444','2013-07-01','12:25:00',3.1),('1444','2013-07-01','12:30:00',3.1),('1444','2013-07-01','12:35:00',3.16),('1444','2013-07-01','12:40:00',3.16),('1444','2013-07-01','12:45:00',3.18),('1444','2013-07-01','12:50:00',3.18),('1444','2013-07-01','12:55:00',3.17),('1444','2013-07-01','13:00:00',3.17),('1444','2013-07-01','13:05:00',3.16),('1444','2013-07-01','13:10:00',3.2),('1444','2013-07-01','13:15:00',3.18),('1444','2013-07-01','13:20:00',3.16),('1444','2013-07-01','13:25:00',3.2),('1444','2013-07-01','13:30:00',3.21),('1444','2013-07-01','13:35:00',3.21),('1444','2013-07-01','13:40:00',3.16),('1444','2013-07-01','13:45:00',3.15),('1444','2013-07-01','13:50:00',3.12),('1444','2013-07-01','13:55:00',3.14),('1444','2013-07-01','14:00:00',3.15),('1444','2013-07-01','14:05:00',3.17),('1444','2013-07-01','14:10:00',3.17),('1444','2013-07-01','14:15:00',3.13),('1444','2013-07-01','14:20:00',3.1),('1444','2013-07-01','14:25:00',3.07),('1444','2013-07-01','14:30:00',3.06),('1444','2013-07-01','14:35:00',3.03),('1444','2013-07-01','14:40:00',3),('1444','2013-07-01','14:45:00',3),('1444','2013-07-01','14:50:00',2.96),('1444','2013-07-01','14:55:00',2.9),('1444','2013-07-01','15:00:00',2.91),('1444','2013-07-01','15:05:00',2.87),('1444','2013-07-01','15:10:00',2.87),('1444','2013-07-01','15:15:00',2.85),('1444','2013-07-01','15:20:00',2.81),('1444','2013-07-01','15:25:00',2.78),('1444','2013-07-01','15:30:00',2.74),('1444','2013-07-01','15:35:00',2.7),('1444','2013-07-01','15:40:00',2.67),('1444','2013-07-01','15:45:00',2.66),('1444','2013-07-01','15:50:00',2.62),('1444','2013-07-01','15:55:00',2.57),('1444','2013-07-01','16:00:00',2.54),('1444','2013-07-01','16:05:00',2.52),('1444','2013-07-01','16:10:00',2.46),('1444','2013-07-01','16:15:00',2.43),('1444','2013-07-01','16:20:00',2.36),('1444','2013-07-01','16:25:00',2.32),('1444','2013-07-01','16:30:00',2.28),('1444','2013-07-01','16:35:00',2.24),('1444','2013-07-01','16:40:00',2.18),('1444','2013-07-01','16:45:00',2.15),('1444','2013-07-01','16:50:00',2.12),('1444','2013-07-01','16:55:00',2.08),('1444','2013-07-01','17:00:00',2.03),('1444','2013-07-01','17:05:00',1.98),('1444','2013-07-01','17:10:00',1.92),('1444','2013-07-01','17:15:00',1.87),('1444','2013-07-01','17:20:00',1.83),('1444','2013-07-01','17:25:00',1.76),('1444','2013-07-01','17:30:00',1.7),('1444','2013-07-01','17:35:00',1.64),('1444','2013-07-01','17:40:00',1.59),('1444','2013-07-01','17:45:00',1.54),('1444','2013-07-01','17:50:00',1.49),('1444','2013-07-01','17:55:00',1.43),('1444','2013-07-01','18:00:00',1.26),('1444','2013-07-01','18:05:00',1.3),('1444','2013-07-01','18:10:00',1.23),('1444','2013-07-01','18:20:00',1.05),('1444','2013-07-01','18:25:00',1.12),('1444','2013-07-01','18:30:00',1.06),('1444','2014-04-05','09:20:00',1.24),('1444','2014-04-05','09:25:00',1.38),('1444','2014-04-05','09:30:00',2.77),('1444','2014-04-05','09:35:00',2.78),('1444','2014-04-05','09:40:00',2.65),('1444','2014-04-05','09:45:00',2.51),('1444','2014-04-05','09:50:00',1.45),('1444','2014-04-05','09:55:00',1.26),('1444','2014-04-05','10:00:00',1.56),('1444','2014-04-05','10:05:00',1.47),('1444','2014-04-05','10:10:00',1.59),('1444','2014-04-05','10:15:00',1.65),('1444','2014-04-05','10:20:00',1.58),('1444','2014-04-05','10:25:00',2.1),('1444','2014-04-05','10:30:00',1.96),('1444','2014-04-05','10:35:00',2.08),('1444','2014-04-05','10:40:00',2.39),('1444','2014-04-05','10:45:00',2.53),('1444','2014-04-05','10:50:00',2.17),('1444','2014-04-05','10:55:00',2.12),('1444','2014-04-05','11:00:00',2.39),('1444','2014-04-05','11:05:00',2.68),('1444','2014-04-05','11:10:00',2.92),('1444','2014-04-05','11:15:00',3.03),('1444','2014-04-05','11:20:00',3.24),('1444','2014-04-05','11:25:00',3.05),('1444','2014-04-05','11:30:00',2.13),('1444','2014-04-05','11:35:00',1.66),('1444','2014-04-05','11:40:00',2.1),('1444','2014-04-05','11:45:00',2.86),('1444','2014-04-05','11:50:00',3.16),('1444','2014-04-05','11:55:00',3.03),('1444','2014-04-05','12:00:00',3.1),('1444','2014-04-05','12:05:00',2.41),('1444','2014-04-05','12:10:00',2.31),('1444','2014-04-05','12:15:00',2.62),('1444','2014-04-05','12:20:00',2.68),('1444','2014-04-05','12:25:00',2.89),('1444','2014-04-05','12:30:00',2.26),('1444','2014-04-05','12:35:00',2.1),('1444','2014-04-05','12:40:00',2.19),('1444','2014-04-05','12:45:00',3.47),('1444','2014-04-05','12:50:00',3.41),('1444','2014-04-05','12:55:00',3.23),('1444','2014-04-05','13:00:00',2.96),('1444','2014-04-05','13:05:00',2.55),('1444','2014-04-05','13:10:00',1.79),('1444','2014-04-05','13:15:00',1.6),('1444','2014-04-05','13:20:00',1.54),('1444','2014-04-05','13:25:00',3.71),('1444','2014-04-05','13:30:00',3.23),('1444','2014-04-05','13:35:00',2.28),('1444','2014-04-05','13:40:00',1.54),('1444','2014-04-05','13:45:00',2.97),('1444','2014-04-05','13:50:00',3.12),('1444','2014-04-05','13:55:00',3.19),('1444','2014-04-05','14:00:00',2.37),('1444','2014-04-05','14:05:00',3.83),('1444','2014-04-05','14:10:00',2.99),('1444','2014-04-05','14:25:00',1.01),('1444','2014-04-05','14:30:00',3.03),('1444','2014-04-05','14:55:00',1.65),('1444','2014-04-05','15:00:00',3.02),('1444','2014-04-05','15:05:00',2.43),('1444','2014-04-05','15:10:00',2.81),('1444','2014-04-05','15:15:00',1.54),('1444','2014-04-05','15:20:00',3.14),('1444','2014-04-05','15:25:00',1.6),('1444','2014-04-05','15:30:00',1.34),('1444','2014-04-05','15:35:00',1.15),('1444','2014-04-05','15:40:00',1.58),('1444','2014-04-05','15:45:00',1.52),('1444','2014-04-05','15:50:00',1.73),('1444','2014-04-05','15:55:00',1.09),('1444','2014-04-05','16:00:00',1),('1444','2014-04-05','16:05:00',1.01),('1444','2014-04-05','16:15:00',1.77),('1444','2014-04-05','16:20:00',2.69),('1444','2014-04-05','16:25:00',2.54),('1444','2014-04-05','16:30:00',1.44),('1444','2014-04-05','16:35:00',2.45),('1444','2014-04-05','16:40:00',1.26),('1444','2014-04-05','16:45:00',1.74),('1444','2014-04-05','16:50:00',1.25),('1444','2014-04-05','16:55:00',1.97),('1444','2014-04-05','17:00:00',1.12),('1444','2014-04-05','17:05:00',1.54),('1444','2014-04-05','17:10:00',1.33),('1444','2013-06-30','07:45:00',1),('1444','2013-06-30','07:50:00',1.08),('1444','2013-06-30','07:55:00',1.14),('1444','2013-06-30','08:00:00',1.2),('1444','2013-06-30','08:05:00',1.26),('1444','2013-06-30','08:10:00',1.32),('1444','2013-06-30','08:15:00',1.39),('1444','2013-06-30','08:20:00',1.45),('1444','2013-06-30','08:25:00',1.51),('1444','2013-06-30','08:30:00',1.57),('1444','2013-06-30','08:35:00',1.59),('1444','2013-06-30','08:40:00',1.68),('1444','2013-06-30','08:45:00',1.74),('1444','2013-06-30','08:50:00',1.8),('1444','2013-06-30','08:55:00',1.85),('1444','2013-06-30','09:00:00',1.9),('1444','2013-06-30','09:05:00',1.95),('1444','2013-06-30','09:10:00',2),('1444','2013-06-30','09:15:00',2.06),('1444','2013-06-30','09:20:00',2.11),('1444','2013-06-30','09:25:00',2.16),('1444','2013-06-30','09:30:00',2.22),('1444','2013-06-30','09:35:00',2.26),('1444','2013-06-30','09:40:00',2.32),('1444','2013-06-30','09:45:00',2.36),('1444','2013-06-30','09:50:00',2.4),('1444','2013-06-30','09:55:00',2.45),('1444','2013-06-30','10:00:00',2.49),('1444','2013-06-30','10:05:00',2.52),('1444','2013-06-30','10:10:00',2.56),('1444','2013-06-30','10:15:00',2.62),('1444','2013-06-30','10:20:00',2.67),('1444','2013-06-30','10:25:00',2.71),('1444','2013-06-30','10:30:00',2.73),('1444','2013-06-30','10:35:00',2.75),('1444','2013-06-30','10:40:00',2.79),('1444','2013-06-30','10:45:00',2.82),('1444','2013-06-30','10:50:00',2.86),('1444','2013-06-30','10:55:00',2.87),('1444','2013-06-30','11:00:00',2.87),('1444','2013-06-30','11:05:00',2.88),('1444','2013-06-30','11:10:00',2.91),('1444','2013-06-30','11:15:00',2.93),('1444','2013-06-30','11:20:00',2.96),('1444','2013-06-30','11:25:00',2.99),('1444','2013-06-30','11:30:00',3.01),('1444','2013-06-30','11:35:00',3.03),('1444','2013-06-30','11:40:00',3.05),('1444','2013-06-30','11:45:00',3.05),('1444','2013-06-30','11:50:00',3.06),('1444','2013-06-30','11:55:00',3.1),('1444','2013-06-30','12:00:00',3.13),('1444','2013-06-30','12:05:00',3.15),('1444','2013-06-30','12:10:00',3.18),('1444','2013-06-30','12:15:00',3.18),('1444','2013-06-30','12:20:00',3.19),('1444','2013-06-30','12:25:00',3.17),('1444','2013-06-30','12:30:00',3.17),('1444','2013-06-30','12:35:00',3.18),('1444','2013-06-30','12:40:00',3.21),('1444','2013-06-30','12:45:00',3.17),('1444','2013-06-30','12:50:00',3.21),('1444','2013-06-30','12:55:00',3.28),('1444','2013-06-30','13:00:00',3.31),('1444','2013-06-30','13:05:00',3.28),('1444','2013-06-30','13:10:00',3.24),('1444','2013-06-30','13:15:00',3.26),('1444','2013-06-30','13:20:00',3.28),('1444','2013-06-30','13:25:00',3.31),('1444','2013-06-30','13:30:00',3.29),('1444','2013-06-30','13:35:00',3.26),('1444','2013-06-30','13:40:00',3.02),('1444','2013-06-30','13:45:00',2.4),('1444','2013-06-30','13:50:00',3.27),('1444','2013-06-30','13:55:00',3.22),('1444','2013-06-30','14:00:00',3.13),('1444','2013-06-30','14:05:00',3.23),('1444','2013-06-30','14:10:00',3.22),('1444','2013-06-30','14:15:00',3.18),('1444','2013-06-30','14:20:00',3.16),('1444','2013-06-30','14:25:00',3.14),('1444','2013-06-30','14:30:00',3.07),('1444','2013-06-30','14:35:00',3.06),('1444','2013-06-30','14:40:00',3.08),('1444','2013-06-30','14:45:00',3.1),('1444','2013-06-30','14:50:00',3.06),('1444','2013-06-30','14:55:00',3.02),('1444','2013-06-30','15:00:00',2.99),('1444','2013-06-30','15:05:00',2.93),('1444','2013-06-30','15:10:00',2.93),('1444','2013-06-30','15:15:00',2.93),('1444','2013-06-30','15:20:00',2.93),('1444','2013-06-30','15:25:00',2.9),('1444','2013-06-30','15:30:00',2.85),('1444','2013-06-30','15:35:00',2.84),('1444','2013-06-30','15:40:00',2.81),('1444','2013-06-30','15:45:00',2.78),('1444','2013-06-30','15:50:00',2.77),('1444','2013-06-30','15:55:00',2.71),('1444','2013-06-30','16:00:00',2.67),('1444','2013-06-30','16:05:00',2.62),('1444','2013-06-30','16:10:00',2.61),('1444','2013-06-30','16:15:00',2.55),('1444','2013-06-30','16:20:00',2.5),('1444','2013-06-30','16:25:00',2.56),('1444','2013-06-30','16:30:00',2.58),('1444','2013-06-30','16:35:00',2.4),('1444','2013-06-30','16:40:00',2.29),('1444','2013-06-30','16:45:00',2.24),('1444','2013-06-30','16:50:00',2.2),('1444','2013-06-30','16:55:00',2.13),('1444','2013-06-30','17:00:00',2.05),('1444','2013-06-30','17:05:00',1.99),('1444','2013-06-30','17:10:00',1.96),('1444','2013-06-30','17:15:00',1.89),('1444','2013-06-30','17:20:00',1.84),('1444','2013-06-30','17:25:00',1.79),('1444','2013-06-30','17:30:00',1.71),('1444','2013-06-30','17:35:00',1.65),('1444','2013-06-30','17:40:00',1.62),('1444','2013-06-30','17:45:00',1.56),('1444','2013-06-30','17:50:00',1.51),('1444','2013-06-30','17:55:00',1.44),('1444','2013-06-30','18:00:00',1.34),('1444','2013-06-30','18:05:00',1.17),('1444','2013-06-30','18:10:00',1.24),('1444','2013-06-30','18:15:00',1.2),('1444','2013-06-30','18:20:00',1.14),('1444','2013-06-30','18:25:00',1.09),('1444','2013-06-30','18:30:00',1.02),('1444','2013-06-29','07:30:00',1.01),('1444','2013-06-29','07:35:00',1.19),('1444','2013-06-29','07:40:00',1.24),('1444','2013-06-29','07:45:00',1.24),('1444','2013-06-29','07:50:00',1.31),('1444','2013-06-29','07:55:00',1.46),('1444','2013-06-29','08:00:00',1.61),('1444','2013-06-29','08:05:00',1.72),('1444','2013-06-29','08:10:00',1.76),('1444','2013-06-29','08:15:00',1.39),('1444','2013-06-29','08:20:00',1.09),('1444','2013-06-29','08:25:00',1.55),('1444','2013-06-29','08:30:00',1.67),('1444','2013-06-29','08:35:00',1.65),('1444','2013-06-29','08:40:00',1.03),('1444','2013-06-29','08:45:00',1.72),('1444','2013-06-29','08:50:00',1.81),('1444','2013-06-29','08:55:00',1.86),('1444','2013-06-29','09:00:00',1.9),('1444','2013-06-29','09:05:00',1.94),('1444','2013-06-29','09:10:00',1.98),('1444','2013-06-29','09:15:00',2.03),('1444','2013-06-29','09:20:00',2.09),('1444','2013-06-29','09:25:00',2.14),('1444','2013-06-29','09:30:00',2.17),('1444','2013-06-29','09:35:00',2.21),('1444','2013-06-29','09:40:00',2.27),('1444','2013-06-29','09:45:00',2.34),('1444','2013-06-29','09:50:00',2.39),('1444','2013-06-29','09:55:00',2.41),('1444','2013-06-29','10:00:00',2.44),('1444','2013-06-29','10:05:00',2.49),('1444','2013-06-29','10:10:00',2.54),('1444','2013-06-29','10:15:00',2.58),('1444','2013-06-29','10:20:00',2.61),('1444','2013-06-29','10:25:00',2.59),('1444','2013-06-29','10:30:00',2.69),('1444','2013-06-29','10:35:00',2.72),('1444','2013-06-29','10:40:00',2.78),('1444','2013-06-29','10:45:00',2.79),('1444','2013-06-29','10:50:00',2.49),('1444','2013-06-29','10:55:00',1.5),('1444','2013-06-29','11:00:00',2.99),('1444','2013-06-29','11:05:00',2.99),('1444','2013-06-29','11:10:00',2.99),('1444','2013-06-29','11:15:00',3.07),('1444','2013-06-29','11:20:00',3.23),('1444','2013-06-29','11:25:00',3.33),('1444','2013-06-29','11:30:00',3.33),('1444','2013-06-29','11:35:00',2.39),('1444','2013-06-29','11:40:00',1.01),('1444','2013-06-29','11:45:00',3.62),('1444','2013-06-29','11:50:00',3.65),('1444','2013-06-29','11:55:00',3.18),('1444','2013-06-29','12:00:00',3.23),('1444','2013-06-29','12:05:00',3.13),('1444','2013-06-29','12:10:00',3.39),('1444','2013-06-29','12:15:00',3.49),('1444','2013-06-29','12:20:00',2.27),('1444','2013-06-29','12:25:00',3.43),('1444','2013-06-29','12:30:00',3.5),('1444','2013-06-29','12:35:00',1.22),('1444','2013-06-29','12:40:00',1.25),('1444','2013-06-29','12:45:00',3.27),('1444','2013-06-29','12:50:00',3.29),('1444','2013-06-29','12:55:00',3.45),('1444','2013-06-29','13:00:00',1.97),('1444','2013-06-29','13:05:00',2.22),('1444','2013-06-29','13:10:00',3.78),('1444','2013-06-29','13:15:00',3.08),('1444','2013-06-29','13:20:00',1.18),('1444','2013-06-29','13:25:00',2.78),('1444','2013-06-29','13:45:00',1.06),('1444','2013-06-29','13:50:00',1.27),('1444','2013-06-29','13:55:00',2.11),('1444','2013-06-29','14:00:00',3.72),('1444','2013-06-29','14:05:00',3.64),('1444','2013-06-29','14:10:00',3.59),('1444','2013-06-29','14:15:00',3.55),('1444','2013-06-29','14:20:00',3.7),('1444','2013-06-29','14:25:00',3.66),('1444','2013-06-29','14:30:00',3.5),('1444','2013-06-29','14:35:00',3.45),('1444','2013-06-29','14:40:00',3.44),('1444','2013-06-29','14:45:00',3.46),('1444','2013-06-29','14:50:00',3.65),('1444','2013-06-29','14:55:00',2.67),('1444','2013-06-29','15:00:00',3.06),('1444','2013-06-29','15:05:00',3.86),('1444','2013-06-29','15:10:00',2.21),('1444','2013-06-29','15:15:00',2.21),('1444','2013-06-29','15:20:00',1.16),('1444','2013-06-29','15:25:00',1.05),('1444','2013-06-29','16:45:00',1.19),('1444','2013-06-29','16:50:00',1.87),('1444','2013-06-29','16:55:00',1.03),('1444','2013-06-29','17:00:00',1.01),('1444','2013-06-29','17:05:00',1.48),('1444','2013-06-29','17:20:00',1.15),('1444','2013-06-29','17:25:00',1.46),('1444','2013-06-29','17:30:00',2.06),('1444','2013-06-29','17:35:00',1.56),('1444','2013-06-29','17:45:00',1.63),('1444','2013-06-29','17:50:00',1.46),('1444','2013-06-29','17:55:00',1.49),('1444','2013-06-29','18:00:00',1.4),('1444','2013-06-29','18:05:00',1.32),('1444','2013-06-29','18:20:00',1.11),('1444','2013-06-28','07:45:00',1.03),('1444','2013-06-28','07:50:00',1.07),('1444','2013-06-28','07:55:00',1.12),('1444','2013-06-28','08:00:00',1.14),('1444','2013-06-28','08:05:00',1.05),('1444','2013-06-28','08:10:00',1.15),('1444','2013-06-28','08:15:00',1.3),('1444','2013-06-28','08:20:00',1.31),('1444','2013-06-28','08:25:00',1.33),('1444','2013-06-28','08:30:00',1.48),('1444','2013-06-28','08:35:00',1.53),('1444','2013-06-28','08:40:00',1.59),('1444','2013-06-28','08:45:00',1.64),('1444','2013-06-28','08:50:00',1.69),('1444','2013-06-28','08:55:00',1.79),('1444','2013-06-28','09:00:00',1.86),('1444','2013-06-28','09:05:00',1.9),('1444','2013-06-28','09:10:00',2.06),('1444','2013-06-28','09:15:00',1.39),('1444','2013-06-28','09:25:00',1.68),('1444','2013-06-28','09:30:00',2.28),('1444','2013-06-28','09:35:00',2.3),('1444','2013-06-28','09:40:00',2.46),('1444','2013-06-28','09:45:00',2.53),('1444','2013-06-28','09:50:00',2.27),('1444','2013-06-28','09:55:00',1.49),('1444','2013-06-28','10:00:00',1.41),('1444','2013-06-28','10:05:00',2.66),('1444','2013-06-28','10:10:00',2.74),('1444','2013-06-28','10:15:00',2.08),('1444','2013-06-28','10:25:00',1.03),('1444','2013-06-28','10:30:00',3.2),('1444','2013-06-28','10:35:00',2.73),('1444','2013-06-28','10:40:00',2.04),('1444','2013-06-28','10:45:00',2.14),('1444','2013-06-28','10:50:00',1.78),('1444','2013-06-28','10:55:00',1.69),('1444','2013-06-28','11:00:00',2.48),('1444','2013-06-28','11:05:00',1.32),('1444','2013-06-28','11:10:00',1.34),('1444','2013-06-28','11:15:00',1.2),('1444','2013-06-28','11:20:00',1.29),('1444','2013-06-28','11:25:00',2.19),('1444','2013-06-28','11:30:00',3.06),('1444','2013-06-28','11:35:00',2.76),('1444','2013-06-28','11:40:00',3.35),('1444','2013-06-28','11:45:00',2.89),('1444','2013-06-28','11:50:00',2.51),('1444','2013-06-28','11:55:00',3.09),('1444','2013-06-28','12:00:00',1.59),('1444','2013-06-28','12:05:00',2.96),('1444','2013-06-28','12:10:00',3.64),('1444','2013-06-28','12:15:00',3.34),('1444','2013-06-28','12:20:00',3.24),('1444','2013-06-28','12:25:00',3.44),('1444','2013-06-28','12:30:00',3.4),('1444','2013-06-28','12:35:00',2.24),('1444','2013-06-28','12:40:00',2.47),('1444','2013-06-28','12:45:00',3.41),('1444','2013-06-28','12:50:00',3.39),('1444','2013-06-28','12:55:00',3.31),('1444','2013-06-28','13:00:00',3.37),('1444','2013-06-28','13:05:00',3.44),('1444','2013-06-28','13:10:00',3.44),('1444','2013-06-28','13:15:00',2.87),('1444','2013-06-28','13:20:00',3.26),('1444','2013-06-28','13:25:00',3.31),('1444','2013-06-28','13:30:00',3.32),('1444','2013-06-28','13:35:00',3.03),('1444','2013-06-28','13:40:00',3.02),('1444','2013-06-28','13:45:00',2.92),('1444','2013-06-28','13:50:00',2.64),('1444','2013-06-28','13:55:00',3.13),('1444','2013-06-28','14:00:00',2.81),('1444','2013-06-28','14:05:00',3.22),('1444','2013-06-28','14:10:00',2.78),('1444','2013-06-28','14:15:00',3.16),('1444','2013-06-28','14:20:00',2.88),('1444','2013-06-28','14:25:00',1.74),('1444','2013-06-28','14:30:00',3.05),('1444','2013-06-28','14:35:00',2.68),('1444','2013-06-28','14:40:00',2.76),('1444','2013-06-28','14:45:00',3.4),('1444','2013-06-28','14:50:00',3.24),('1444','2013-06-28','14:55:00',3.14),('1444','2013-06-28','15:00:00',2.91),('1444','2013-06-28','15:05:00',3.05),('1444','2013-06-28','15:10:00',3.02),('1444','2013-06-28','15:15:00',3.07),('1444','2013-06-28','15:20:00',3.16),('1444','2013-06-28','15:25:00',2.98),('1444','2013-06-28','15:30:00',2.75),('1444','2013-06-28','15:35:00',2.56),('1444','2013-06-28','15:40:00',1.31),('1444','2013-06-28','15:45:00',2.94),('1444','2013-06-28','15:50:00',2.33),('1444','2013-06-28','15:55:00',2.89),('1444','2013-06-28','16:00:00',2.6),('1444','2013-06-28','16:05:00',2.17),('1444','2013-06-28','16:10:00',1.35),('1444','2013-06-28','16:15:00',2.09),('1444','2013-06-28','16:20:00',2.41),('1444','2013-06-28','16:25:00',2.2),('1444','2013-06-28','16:30:00',2.02),('1444','2013-06-28','16:40:00',1.58),('1444','2013-06-28','16:45:00',1.73),('1444','2013-06-28','16:50:00',2.48),('1444','2013-06-28','16:55:00',2.33),('1444','2013-06-28','17:00:00',2.1),('1444','2013-06-28','17:05:00',2.01),('1444','2013-06-28','17:10:00',1.96),('1444','2013-06-28','17:15:00',1.91),('1444','2013-06-28','17:20:00',1.83),('1444','2013-06-28','17:25:00',1.85),('1444','2013-06-28','17:30:00',1.76),('1444','2013-06-28','17:35:00',1.69),('1444','2013-06-28','17:40:00',1.6),('1444','2013-06-28','17:45:00',1.58),('1444','2013-06-28','17:50:00',1.53),('1444','2013-06-28','17:55:00',1.48),('1444','2013-06-28','18:00:00',1.42),('1444','2013-06-28','18:05:00',1.34),('1444','2013-06-28','18:10:00',1.28),('1444','2013-06-28','18:15:00',1.26),('1444','2013-06-28','18:20:00',1.2),('1444','2013-06-28','18:25:00',1.14),('1444','2013-06-27','07:50:00',1.06),('1444','2013-06-27','07:55:00',1.11),('1444','2013-06-27','08:00:00',1.17),('1444','2013-06-27','08:05:00',1.23),('1444','2013-06-27','08:10:00',1.25),('1444','2013-06-27','08:15:00',1.33),('1444','2013-06-27','08:20:00',1.41),('1444','2013-06-27','08:25:00',1.46),('1444','2013-06-27','08:30:00',1.51),('1444','2013-06-27','08:35:00',1.56),('1444','2013-06-27','08:40:00',1.61),('1444','2013-06-27','08:45:00',1.67),('1444','2013-06-27','08:50:00',1.73),('1444','2013-06-27','08:55:00',1.83),('1444','2013-06-27','09:00:00',1.87),('1444','2013-06-27','09:05:00',1.91),('1444','2013-06-27','09:10:00',1.98),('1444','2013-06-27','09:15:00',2.03),('1444','2013-06-27','09:20:00',2.1),('1444','2013-06-27','09:25:00',2.14),('1444','2013-06-27','09:30:00',2.17),('1444','2013-06-27','09:35:00',2.22),('1444','2013-06-27','09:40:00',2.28),('1444','2013-06-27','09:45:00',2.28),('1444','2013-06-27','09:50:00',2.4),('1444','2013-06-27','09:55:00',2.48),('1444','2013-06-27','10:00:00',2.2),('1444','2013-06-27','10:05:00',1.54),('1444','2013-06-27','10:10:00',2.29),('1444','2013-06-27','10:15:00',1.57),('1444','2013-06-27','10:20:00',2.67),('1444','2013-06-27','10:25:00',2.68),('1444','2013-06-27','10:30:00',2.75),('1444','2013-06-27','10:35:00',2.63),('1444','2013-06-27','10:40:00',3.04),('1444','2013-06-27','10:45:00',3.06),('1444','2013-06-27','10:50:00',2.7),('1444','2013-06-27','10:55:00',3.07),('1444','2013-06-27','11:00:00',3.04),('1444','2013-06-27','11:05:00',3.1),('1444','2013-06-27','11:10:00',3.1),('1444','2013-06-27','11:15:00',3.11),('1444','2013-06-27','11:20:00',2.1),('1444','2013-06-27','11:25:00',2.98),('1444','2013-06-27','11:30:00',3.2),('1444','2013-06-27','11:35:00',3.18),('1444','2013-06-27','11:40:00',3.27),('1444','2013-06-27','11:45:00',3.36),('1444','2013-06-27','11:50:00',1.59),('1444','2013-06-27','12:25:00',1.1),('1444','2013-06-27','12:30:00',1.75),('1444','2013-06-27','12:35:00',2.15),('1444','2013-06-27','12:40:00',1.25),('1444','2013-06-27','12:45:00',1.48),('1444','2013-06-27','12:50:00',1.49),('1444','2013-06-27','13:15:00',1.03),('1444','2013-06-27','13:20:00',1.04),('1444','2013-06-27','13:25:00',1.1),('1444','2013-06-27','13:30:00',1.01),('1444','2013-06-27','13:45:00',1.01),('1444','2013-06-27','13:50:00',1.1),('1444','2013-06-27','14:00:00',1.01),('1444','2013-06-27','14:05:00',1.03),('1444','2013-06-27','14:10:00',1.31),('1444','2013-06-27','14:15:00',2.23),('1444','2013-06-27','14:20:00',2.98),('1444','2013-06-27','14:25:00',1.42),('1444','2013-06-27','14:30:00',1.2),('1444','2013-06-27','14:35:00',1.18),('1444','2013-06-27','14:40:00',2.5),('1444','2013-06-27','14:45:00',2.92),('1444','2013-06-27','14:50:00',2.98),('1444','2013-06-27','14:55:00',2.98),('1444','2013-06-27','15:00:00',2.9),('1444','2013-06-27','15:05:00',2.86),('1444','2013-06-27','15:10:00',2.84),('1444','2013-06-27','15:15:00',2.81),('1444','2013-06-27','15:20:00',2.8),('1444','2013-06-27','15:25:00',2.79),('1444','2013-06-27','15:30:00',2.77),('1444','2013-06-27','15:35:00',2.73),('1444','2013-06-27','15:40:00',2.69),('1444','2013-06-27','15:45:00',2.66),('1444','2013-06-27','15:50:00',2.57),('1444','2013-06-27','15:55:00',2.6),('1444','2013-06-27','16:00:00',2.5),('1444','2013-06-27','16:05:00',2.46),('1444','2013-06-27','16:10:00',2.44),('1444','2013-06-27','16:15:00',2.41),('1444','2013-06-27','16:20:00',2.39),('1444','2013-06-27','16:25:00',2.35),('1444','2013-06-27','16:30:00',2.31),('1444','2013-06-27','16:35:00',2.15),('1444','2013-06-27','16:40:00',2.19),('1444','2013-06-27','16:45:00',2.19),('1444','2013-06-27','16:50:00',2.11),('1444','2013-06-27','16:55:00',2.06),('1444','2013-06-27','17:00:00',2.01),('1444','2013-06-27','17:05:00',1.95),('1444','2013-06-27','17:10:00',1.85),('1444','2013-06-27','17:15:00',1.8),('1444','2013-06-27','17:20:00',1.86),('1444','2013-06-27','17:25:00',1.79),('1444','2013-06-27','17:30:00',1.75),('1444','2013-06-27','17:35:00',1.67),('1444','2013-06-27','17:40:00',1.39),('1444','2013-06-27','17:50:00',1.43),('1444','2013-06-27','17:55:00',1.39),('1444','2013-06-27','18:00:00',1.33),('1444','2013-06-27','18:05:00',1.28),('1444','2013-06-27','18:10:00',1.21),('1444','2013-06-27','18:15:00',1.13),('1444','2013-06-27','18:20:00',1.08),('1444','2013-06-27','18:25:00',1.08),('1444','2013-06-27','18:30:00',1.03),('1444','2013-06-26','07:45:00',1),('1444','2013-06-26','07:50:00',1.07),('1444','2013-06-26','07:55:00',1.11),('1444','2013-06-26','08:00:00',1.16),('1444','2013-06-26','08:05:00',1.23),('1444','2013-06-26','08:10:00',1.3),('1444','2013-06-26','08:15:00',1.35),('1444','2013-06-26','08:20:00',1.4),('1444','2013-06-26','08:25:00',1.46),('1444','2013-06-26','08:30:00',1.51),('1444','2013-06-26','08:35:00',1.56),('1444','2013-06-26','08:40:00',1.62),('1444','2013-06-26','08:45:00',1.68),('1444','2013-06-26','08:50:00',1.72),('1444','2013-06-26','08:55:00',1.78),('1444','2013-06-26','09:00:00',1.84),('1444','2013-06-26','09:05:00',1.9),('1444','2013-06-26','09:10:00',1.93),('1444','2013-06-26','09:15:00',1.97),('1444','2013-06-26','09:20:00',2.02),('1444','2013-06-26','09:25:00',2.08),('1444','2013-06-26','09:30:00',2.13),('1444','2013-06-26','09:35:00',2.16),('1444','2013-06-26','09:40:00',2.2),('1444','2013-06-26','09:45:00',2.24),('1444','2013-06-26','09:50:00',2.28),('1444','2013-06-26','09:55:00',2.32),('1444','2013-06-26','10:00:00',2.38),('1444','2013-06-26','10:05:00',2.42),('1444','2013-06-26','10:10:00',2.48),('1444','2013-06-26','10:15:00',2.53),('1444','2013-06-26','10:20:00',2.56),('1444','2013-06-26','10:25:00',2.56),('1444','2013-06-26','10:30:00',2.58),('1444','2013-06-26','10:35:00',2.62),('1444','2013-06-26','10:40:00',2.68),('1444','2013-06-26','10:45:00',2.72),('1444','2013-06-26','10:50:00',2.76),('1444','2013-06-26','10:55:00',2.78),('1444','2013-06-26','11:00:00',2.8),('1444','2013-06-26','11:05:00',2.82),('1444','2013-06-26','11:10:00',2.86),('1444','2013-06-26','11:15:00',2.89),('1444','2013-06-26','11:20:00',2.93),('1444','2013-06-26','11:25:00',2.93),('1444','2013-06-26','11:30:00',2.92),('1444','2013-06-26','11:35:00',2.98),('1444','2013-06-26','11:40:00',2.99),('1444','2013-06-26','11:45:00',3),('1444','2013-06-26','11:50:00',3),('1444','2013-06-26','11:55:00',3.05),('1444','2013-06-26','12:00:00',3.1),('1444','2013-06-26','12:05:00',3.12),('1444','2013-06-26','12:10:00',3.07),('1444','2013-06-26','12:15:00',3.1),('1444','2013-06-26','12:20:00',3.1),('1444','2013-06-26','12:25:00',3.09),('1444','2013-06-26','12:30:00',3.14),('1444','2013-06-26','12:35:00',3.14),('1444','2013-06-26','12:40:00',3.08),('1444','2013-06-26','12:45:00',1.42),('1444','2013-06-26','12:50:00',2.26),('1444','2013-06-26','12:55:00',1.23),('1444','2013-06-26','13:00:00',3.31),('1444','2013-06-26','13:05:00',1.8),('1444','2013-06-26','13:10:00',3.43),('1444','2013-06-26','13:15:00',3.34),('1444','2013-06-26','13:20:00',1.99),('1444','2013-06-26','13:25:00',2.84),('1444','2013-06-26','13:30:00',1.41),('1444','2013-06-26','13:35:00',1.11),('1444','2013-06-26','13:40:00',2.25),('1444','2013-06-26','13:45:00',1.31),('1444','2013-06-26','13:50:00',2.41),('1444','2013-06-26','13:55:00',2.15),('1444','2013-06-26','14:00:00',3.02),('1444','2013-06-26','14:05:00',3.41),('1444','2013-06-26','14:10:00',2.64),('1444','2013-06-26','14:15:00',1.56),('1444','2013-06-26','14:20:00',3.31),('1444','2013-06-26','14:25:00',3),('1444','2013-06-26','14:30:00',1.96),('1444','2013-06-26','14:35:00',2.72),('1444','2013-06-26','14:40:00',2.95),('1444','2013-06-26','14:45:00',2.31),('1444','2013-06-26','14:50:00',3.23),('1444','2013-06-26','14:55:00',3.14),('1444','2013-06-26','15:00:00',2.96),('1444','2013-06-26','15:05:00',2.91),('1444','2013-06-26','15:10:00',2.87),('1444','2013-06-26','15:15:00',2.83),('1444','2013-06-26','15:20:00',2.84),('1444','2013-06-26','15:25:00',2.8),('1444','2013-06-26','15:30:00',2.76),('1444','2013-06-26','15:35:00',2.77),('1444','2013-06-26','15:40:00',2.43),('1444','2013-06-26','15:45:00',2.68),('1444','2013-06-26','15:50:00',2.7),('1444','2013-06-26','15:55:00',2.62),('1444','2013-06-26','16:00:00',2.6),('1444','2013-06-26','16:05:00',2.54),('1444','2013-06-26','16:10:00',2.49),('1444','2013-06-26','16:15:00',2.44),('1444','2013-06-26','16:20:00',2.41),('1444','2013-06-26','16:25:00',2.37),('1444','2013-06-26','16:30:00',2.32),('1444','2013-06-26','16:35:00',2.24),('1444','2013-06-26','16:40:00',2.2),('1444','2013-06-26','16:45:00',2.17),('1444','2013-06-26','16:50:00',2.13),('1444','2013-06-26','16:55:00',2.07),('1444','2013-06-26','17:00:00',2.04),('1444','2013-06-26','17:05:00',1.99),('1444','2013-06-26','17:10:00',1.94),('1444','2013-06-26','17:15:00',1.87),('1444','2013-06-26','17:20:00',1.82),('1444','2013-06-26','17:25:00',1.76),('1444','2013-06-26','17:30:00',1.71),('1444','2013-06-26','17:35:00',1.66),('1444','2013-06-26','17:40:00',1.59),('1444','2013-06-26','17:45:00',1.53),('1444','2013-06-26','17:50:00',1.47),('1444','2013-06-26','17:55:00',1.41),('1444','2013-06-26','18:00:00',1.36),('1444','2013-06-26','18:05:00',1.37),('1444','2013-06-26','18:10:00',1.51),('1444','2013-06-26','18:15:00',1.2),('1444','2013-06-25','07:45:00',1.04),('1444','2013-06-25','07:50:00',1.06),('1444','2013-06-25','08:00:00',1.22),('1444','2013-06-25','08:20:00',1.03),('1444','2013-06-25','08:25:00',1.49),('1444','2013-06-25','08:30:00',1.54),('1444','2013-06-25','08:35:00',1.6),('1444','2013-06-25','08:40:00',1.65),('1444','2013-06-25','08:45:00',1.7),('1444','2013-06-25','08:50:00',1.75),('1444','2013-06-25','08:55:00',1.82),('1444','2013-06-25','09:00:00',1.88),('1444','2013-06-25','09:05:00',1.93),('1444','2013-06-25','09:10:00',1.96),('1444','2013-06-25','09:15:00',1.99),('1444','2013-06-25','09:20:00',2.06),('1444','2013-06-25','09:25:00',2.08),('1444','2013-06-25','09:30:00',2.17),('1444','2013-06-25','09:35:00',2.33),('1444','2013-06-25','09:40:00',2.38),('1444','2013-06-25','09:45:00',2.51),('1444','2013-06-25','09:50:00',2.6),('1444','2013-06-25','09:55:00',2.66),('1444','2013-06-25','10:00:00',2.72),('1444','2013-06-25','10:05:00',2.78),('1444','2013-06-25','10:10:00',2.9),('1444','2013-06-25','10:15:00',2.12),('1444','2013-06-25','10:25:00',1.66),('1444','2013-06-25','10:30:00',3.07),('1444','2013-06-25','10:35:00',2.79),('1444','2013-06-25','10:40:00',2.5),('1444','2013-06-25','10:55:00',1.77),('1444','2013-06-25','11:00:00',2.29),('1444','2013-06-25','11:10:00',1.97),('1444','2013-06-25','11:15:00',3.35),('1444','2013-06-25','11:35:00',1.7),('1444','2013-06-25','11:40:00',3.59),('1444','2013-06-25','11:45:00',3.19),('1444','2013-06-25','11:50:00',3.54),('1444','2013-06-25','11:55:00',1.08),('1444','2013-06-25','12:30:00',1.07),('1444','2013-06-25','12:35:00',3.08),('1444','2013-06-25','12:40:00',2.59),('1444','2013-06-25','12:45:00',2.74),('1444','2013-06-25','12:50:00',2.07),('1444','2013-06-25','12:55:00',1.73),('1444','2013-06-25','13:00:00',3.65),('1444','2013-06-25','13:05:00',3.19),('1444','2013-06-25','13:10:00',1.19),('1444','2013-06-25','13:15:00',3.42),('1444','2013-06-25','13:20:00',2.38),('1444','2013-06-25','13:25:00',3.45),('1444','2013-06-25','13:30:00',2.06),('1444','2013-06-25','13:35:00',3.17),('1444','2013-06-25','13:40:00',3.5),('1444','2013-06-25','13:45:00',3.33),('1444','2013-06-25','13:50:00',2.31),('1444','2013-06-25','13:55:00',1.71),('1444','2013-06-25','14:00:00',2.49),('1444','2013-06-25','14:05:00',3.37),('1444','2013-06-25','14:10:00',3.15),('1444','2013-06-25','14:15:00',2.87),('1444','2013-06-25','14:20:00',3.14),('1444','2013-06-25','14:25:00',3.17),('1444','2013-06-25','14:30:00',3.1),('1444','2013-06-25','14:35:00',3.09),('1444','2013-06-25','14:40:00',3.12),('1444','2013-06-25','14:45:00',3.09),('1444','2013-06-25','14:50:00',3.05),('1444','2013-06-25','14:55:00',3.02),('1444','2013-06-25','15:00:00',2.97),('1444','2013-06-25','15:05:00',2.96),('1444','2013-06-25','15:10:00',2.93),('1444','2013-06-25','15:15:00',2.89),('1444','2013-06-25','15:20:00',2.86),('1444','2013-06-25','15:25:00',2.81),('1444','2013-06-25','15:30:00',2.79),('1444','2013-06-25','15:35:00',2.73),('1444','2013-06-25','15:40:00',2.71),('1444','2013-06-25','15:45:00',2.65),('1444','2013-06-25','15:50:00',2.63),('1444','2013-06-25','15:55:00',2.59),('1444','2013-06-25','16:00:00',2.56),('1444','2013-06-25','16:05:00',2.51),('1444','2013-06-25','16:10:00',2.47),('1444','2013-06-25','16:15:00',2.44),('1444','2013-06-25','16:20:00',2.39),('1444','2013-06-25','16:25:00',2.34),('1444','2013-06-25','16:30:00',2.3),('1444','2013-06-25','16:35:00',2.25),('1444','2013-06-25','16:40:00',2.21),('1444','2013-06-25','16:45:00',2.17),('1444','2013-06-25','16:50:00',2.11),('1444','2013-06-25','16:55:00',2.06),('1444','2013-06-25','17:00:00',2.01),('1444','2013-06-25','17:05:00',1.96),('1444','2013-06-25','17:10:00',1.9),('1444','2013-06-25','17:15:00',1.86),('1444','2013-06-25','17:20:00',1.81),('1444','2013-06-25','17:25:00',1.75),('1444','2013-06-25','17:30:00',1.7),('1444','2013-06-25','17:35:00',1.65),('1444','2013-06-25','17:40:00',1.58),('1444','2013-06-25','17:45:00',1.52),('1444','2013-06-25','17:50:00',1.45),('1444','2013-06-25','17:55:00',1.42),('1444','2013-06-25','18:00:00',1.37),('1444','2013-06-25','18:05:00',1.29),('1444','2013-06-25','18:10:00',1.22),('1444','2013-06-25','18:15:00',1.16),('1444','2013-06-25','18:20:00',1.12),('1444','2013-06-25','18:25:00',1.05),('1444','2013-06-25','18:30:00',1),('1444','2013-06-24','08:40:00',1.68),('1444','2013-06-24','08:45:00',1.83),('1444','2013-06-24','08:50:00',1.86),('1444','2013-06-24','08:55:00',1.99),('1444','2013-06-24','09:00:00',1.92),('1444','2013-06-24','09:05:00',1.24),('1444','2013-06-24','09:10:00',1.54),('1444','2013-06-24','09:15:00',1.92),('1444','2013-06-24','09:20:00',2.01),('1444','2013-06-24','09:25:00',2.71),('1444','2013-06-24','09:30:00',2.34),('1444','2013-06-24','09:35:00',2.06),('1444','2013-06-24','09:40:00',2.49),('1444','2013-06-24','09:45:00',2.73),('1444','2013-06-24','09:50:00',2.57),('1444','2013-06-24','09:55:00',2.35),('1444','2013-06-24','10:00:00',2.54),('1444','2013-06-24','10:05:00',2.61),('1444','2013-06-24','10:10:00',2.41),('1444','2013-06-24','10:15:00',2.2),('1444','2013-06-24','10:20:00',1.98),('1444','2013-06-24','10:25:00',2.87),('1444','2013-06-24','10:30:00',1.82),('1444','2013-06-24','10:35:00',2.78),('1444','2013-06-24','10:40:00',1.44),('1444','2013-06-24','10:45:00',2.64),('1444','2013-06-24','10:50:00',2.59),('1444','2013-06-24','10:55:00',2.17),('1444','2013-06-24','11:00:00',2.85),('1444','2013-06-24','11:05:00',1.99),('1444','2013-06-24','11:15:00',2.82),('1444','2013-06-24','11:20:00',2.56),('1444','2013-06-24','11:25:00',2.15),('1444','2013-06-24','11:30:00',2.32),('1444','2013-06-24','11:35:00',1.05),('1444','2013-06-24','11:45:00',1.72),('1444','2013-06-24','11:50:00',1.59),('1444','2013-06-24','11:55:00',2.58),('1444','2013-06-24','12:00:00',2.88),('1444','2013-06-24','12:05:00',2.74),('1444','2013-06-24','12:10:00',3.44),('1444','2013-06-24','12:15:00',1.41),('1444','2013-06-24','12:20:00',3.75),('1444','2013-06-24','12:25:00',2.9),('1444','2013-06-24','12:30:00',1.95),('1444','2013-06-24','12:35:00',3),('1444','2013-06-24','12:40:00',2.19),('1444','2013-06-24','12:45:00',3.02),('1444','2013-06-24','12:50:00',3.01),('1444','2013-06-24','12:55:00',2.6),('1444','2013-06-24','13:00:00',2.73),('1444','2013-06-24','13:05:00',3.49),('1444','2013-06-24','13:10:00',3.61),('1444','2013-06-24','13:15:00',2.48),('1444','2013-06-24','13:20:00',1.76),('1444','2013-06-24','13:25:00',2.78),('1444','2013-06-24','13:30:00',3.36),('1444','2013-06-24','13:35:00',3.29),('1444','2013-06-24','13:40:00',3.06),('1444','2013-06-24','13:45:00',3.04),('1444','2013-06-24','13:50:00',3.39),('1444','2013-06-24','13:55:00',3.28),('1444','2013-06-24','14:00:00',3.24),('1444','2013-06-24','14:05:00',3.25),('1444','2013-06-24','14:10:00',3.28),('1444','2013-06-24','14:15:00',3.27),('1444','2013-06-24','14:20:00',3.24),('1444','2013-06-24','14:25:00',3.25),('1444','2013-06-24','14:30:00',3.17),('1444','2013-06-24','14:35:00',3.28),('1444','2013-06-24','14:40:00',3.17),('1444','2013-06-24','14:45:00',3.02),('1444','2013-06-24','14:50:00',2.92),('1444','2013-06-24','14:55:00',1.73),('1444','2013-06-24','15:00:00',2.95),('1444','2013-06-24','15:05:00',1.32),('1444','2013-06-24','15:10:00',2.44),('1444','2013-06-24','15:15:00',2.34),('1444','2013-06-24','15:20:00',2.86),('1444','2013-06-24','15:25:00',2.31),('1444','2013-06-24','15:30:00',2.66),('1444','2013-06-24','15:35:00',1.13),('1444','2013-06-24','15:40:00',1.98),('1444','2013-06-24','15:45:00',2.03),('1444','2013-06-24','15:50:00',3.11),('1444','2013-06-24','15:55:00',2.92),('1444','2013-06-24','16:00:00',2.77),('1444','2013-06-24','16:05:00',3),('1444','2013-06-24','16:10:00',2.57),('1444','2013-06-24','16:15:00',2.62),('1444','2013-06-24','16:20:00',1.77),('1444','2013-06-24','16:25:00',1.58),('1444','2013-06-24','16:30:00',2.41),('1444','2013-06-24','16:35:00',2.7),('1444','2013-06-24','16:40:00',1.62),('1444','2013-06-24','16:45:00',1.08),('1444','2013-06-24','16:50:00',1.38),('1444','2013-06-24','17:00:00',1.01),('1444','2013-06-24','17:05:00',1.79),('1444','2013-06-24','17:10:00',1.31),('1444','2013-06-24','17:15:00',2.03),('1444','2013-06-24','17:20:00',1.65),('1444','2013-06-24','17:25:00',1.35),('1444','2013-06-24','17:55:00',1.22),('1444','2013-06-24','18:00:00',1.65),('1444','2013-06-24','18:05:00',1.49),('1444','2013-06-24','18:10:00',1.16),('1444','2013-06-24','18:15:00',1.27),('1444','2013-06-24','18:20:00',1.02),('1444','2013-06-23','08:50:00',1.04),('1444','2013-06-23','09:00:00',1.34),('1444','2013-06-23','09:05:00',1.07),('1444','2013-06-23','09:20:00',1.3),('1444','2013-06-23','09:25:00',2.03),('1444','2013-06-23','09:30:00',2.08),('1444','2013-06-23','09:35:00',2.23),('1444','2013-06-23','09:40:00',2.63),('1444','2013-06-23','09:45:00',1.27),('1444','2013-06-23','09:55:00',1.5),('1444','2013-06-23','10:00:00',1.31),('1444','2013-06-23','10:05:00',1.41),('1444','2013-06-23','10:10:00',2.07),('1444','2013-06-23','10:15:00',1.42),('1444','2013-06-23','10:20:00',1.71),('1444','2013-06-23','10:25:00',1.27),('1444','2013-06-23','10:30:00',1.19),('1444','2013-06-23','10:35:00',1.61),('1444','2013-06-23','10:40:00',2.56),('1444','2013-06-23','10:45:00',2.71),('1444','2013-06-23','10:50:00',2.69),('1444','2013-06-23','10:55:00',2.69),('1444','2013-06-23','11:00:00',2.73),('1444','2013-06-23','11:05:00',2.8),('1444','2013-06-23','11:10:00',2.79),('1444','2013-06-23','11:15:00',2.75),('1444','2013-06-23','11:20:00',2.89),('1444','2013-06-23','11:25:00',2.66),('1444','2013-06-23','11:30:00',2.35),('1444','2013-06-23','11:35:00',2.85),('1444','2013-06-23','11:40:00',2.89),('1444','2013-06-23','11:45:00',2.92),('1444','2013-06-23','11:50:00',2.89),('1444','2013-06-23','11:55:00',2.54),('1444','2013-06-23','12:00:00',3.08),('1444','2013-06-23','12:05:00',3.07),('1444','2013-06-23','12:10:00',3.12),('1444','2013-06-23','12:15:00',3.08),('1444','2013-06-23','12:20:00',3.08),('1444','2013-06-23','12:25:00',3.15),('1444','2013-06-23','12:30:00',3.13),('1444','2013-06-23','12:35:00',3.1),('1444','2013-06-23','12:40:00',3.15),('1444','2013-06-23','12:45:00',3.16),('1444','2013-06-23','12:50:00',3.16),('1444','2013-06-23','12:55:00',3.15),('1444','2013-06-23','13:00:00',3.14),('1444','2013-06-23','13:05:00',3.16),('1444','2013-06-23','13:10:00',3.17),('1444','2013-06-23','13:15:00',3.16),('1444','2013-06-23','13:20:00',3.14),('1444','2013-06-23','13:25:00',3.15),('1444','2013-06-23','13:30:00',3.16),('1444','2013-06-23','13:35:00',3.19),('1444','2013-06-23','13:40:00',3.18),('1444','2013-06-23','13:45:00',3.18),('1444','2013-06-23','13:50:00',3.17),('1444','2013-06-23','13:55:00',3.18),('1444','2013-06-23','14:00:00',3.14),('1444','2013-06-23','14:05:00',3.13),('1444','2013-06-23','14:10:00',3.11),('1444','2013-06-23','14:15:00',3.1),('1444','2013-06-23','14:20:00',3.08),('1444','2013-06-23','14:25:00',3.09),('1444','2013-06-23','14:30:00',3.08),('1444','2013-06-23','14:35:00',3.06),('1444','2013-06-23','14:40:00',3.03),('1444','2013-06-23','14:45:00',3.03),('1444','2013-06-23','14:50:00',3.01),('1444','2013-06-23','14:55:00',2.99),('1444','2013-06-23','15:00:00',2.96),('1444','2013-06-23','15:05:00',2.93),('1444','2013-06-23','15:10:00',2.91),('1444','2013-06-23','15:15:00',2.87),('1444','2013-06-23','15:20:00',2.85),('1444','2013-06-23','15:25:00',2.81),('1444','2013-06-23','15:30:00',2.78),('1444','2013-06-23','15:35:00',2.74),('1444','2013-06-23','15:40:00',2.71),('1444','2013-06-23','15:45:00',2.67),('1444','2013-06-23','15:50:00',2.64),('1444','2013-06-23','15:55:00',2.6),('1444','2013-06-23','16:00:00',2.56),('1444','2013-06-23','16:05:00',2.52),('1444','2013-06-23','16:10:00',2.47),('1444','2013-06-23','16:15:00',2.42),('1444','2013-06-23','16:20:00',2.36),('1444','2013-06-23','16:25:00',2.34),('1444','2013-06-23','16:30:00',2.28),('1444','2013-06-23','16:35:00',2.26),('1444','2013-06-23','16:40:00',2.21),('1444','2013-06-23','16:45:00',2.18),('1444','2013-06-23','16:50:00',2.11),('1444','2013-06-23','16:55:00',2.06),('1444','2013-06-23','17:00:00',2.02),('1444','2013-06-23','17:05:00',1.97),('1444','2013-06-23','17:10:00',1.92),('1444','2013-06-23','17:15:00',1.88),('1444','2013-06-23','17:20:00',1.82),('1444','2013-06-23','17:25:00',1.77),('1444','2013-06-23','17:30:00',1.71),('1444','2013-06-23','17:35:00',1.63),('1444','2013-06-23','17:40:00',1.61),('1444','2013-06-23','17:45:00',1.56),('1444','2013-06-23','17:50:00',1.5),('1444','2013-06-23','17:55:00',1.44),('1444','2013-06-23','18:00:00',1.4),('1444','2013-06-23','18:05:00',1.32),('1444','2013-06-23','18:10:00',1.25),('1444','2013-06-23','18:15:00',1.18),('1444','2013-06-23','18:20:00',1.15),('1444','2013-06-23','18:25:00',1.08),('1444','2013-06-23','18:30:00',1.02),('1444','2013-06-22','07:55:00',1.01),('1444','2013-06-22','08:00:00',1.06),('1444','2013-06-22','08:05:00',1.09),('1444','2013-06-22','08:10:00',1.16),('1444','2013-06-22','08:15:00',1.21),('1444','2013-06-22','08:20:00',1.27),('1444','2013-06-22','08:25:00',1.34),('1444','2013-06-22','08:30:00',1.4),('1444','2013-06-22','08:35:00',1.47),('1444','2013-06-22','08:40:00',1.53),('1444','2013-06-22','08:45:00',1.58),('1444','2013-06-22','08:50:00',1.63),('1444','2013-06-22','08:55:00',1.67),('1444','2013-06-22','09:00:00',1.72),('1444','2013-06-22','09:05:00',1.76),('1444','2013-06-22','09:10:00',1.81),('1444','2013-06-22','09:15:00',1.85),('1444','2013-06-22','09:20:00',1.9),('1444','2013-06-22','09:25:00',1.93),('1444','2013-06-22','09:30:00',1.98),('1444','2013-06-22','09:35:00',2.03),('1444','2013-06-22','09:40:00',2.07),('1444','2013-06-22','09:45:00',2.13),('1444','2013-06-22','09:50:00',2.18),('1444','2013-06-22','09:55:00',2.22),('1444','2013-06-22','10:00:00',2.26),('1444','2013-06-22','10:05:00',2.3),('1444','2013-06-22','10:10:00',2.34),('1444','2013-06-22','10:15:00',2.4),('1444','2013-06-22','10:20:00',2.45),('1444','2013-06-22','10:25:00',2.47),('1444','2013-06-22','10:30:00',2.47),('1444','2013-06-22','10:35:00',2.51),('1444','2013-06-22','10:40:00',2.56),('1444','2013-06-22','10:45:00',2.61),('1444','2013-06-22','10:50:00',2.65),('1444','2013-06-22','10:55:00',2.67),('1444','2013-06-22','11:00:00',2.71),('1444','2013-06-22','11:05:00',2.73),('1444','2013-06-22','11:10:00',2.76),('1444','2013-06-22','11:15:00',2.78),('1444','2013-06-22','11:20:00',2.79),('1444','2013-06-22','11:25:00',2.81),('1444','2013-06-22','11:30:00',2.84),('1444','2013-06-22','11:35:00',2.85),('1444','2013-06-22','11:40:00',2.88),('1444','2013-06-22','11:45:00',2.9),('1444','2013-06-22','11:50:00',2.89),('1444','2013-06-22','11:55:00',2.9),('1444','2013-06-22','12:00:00',2.94),('1444','2013-06-22','12:05:00',2.89),('1444','2013-06-22','12:10:00',2.87),('1444','2013-06-22','12:15:00',2.98),('1444','2013-06-22','12:20:00',2.92),('1444','2013-06-22','12:25:00',2.97),('1444','2013-06-22','12:30:00',3),('1444','2013-06-22','12:35:00',3.02),('1444','2013-06-22','12:40:00',3.04),('1444','2013-06-22','12:45:00',2.99),('1444','2013-06-22','12:50:00',2.96),('1444','2013-06-22','12:55:00',2.94),('1444','2013-06-22','13:00:00',2.9),('1444','2013-06-22','13:05:00',2.92),('1444','2013-06-22','13:10:00',2.91),('1444','2013-06-22','13:15:00',2.85),('1444','2013-06-22','13:20:00',2.78),('1444','2013-06-22','13:25:00',3.04),('1444','2013-06-22','13:30:00',3.16),('1444','2013-06-22','13:35:00',3.21),('1444','2013-06-22','13:40:00',2.84),('1444','2013-06-22','13:45:00',3.07),('1444','2013-06-22','13:50:00',3.09),('1444','2013-06-22','13:55:00',2.2),('1444','2013-06-22','14:00:00',2.17),('1444','2013-06-22','14:05:00',3.38),('1444','2013-06-22','14:10:00',3.21),('1444','2013-06-22','14:15:00',3.15),('1444','2013-06-22','14:20:00',2.7),('1444','2013-06-22','14:25:00',3.08),('1444','2013-06-22','14:30:00',2.18),('1444','2013-06-22','14:35:00',1.66),('1444','2013-06-22','14:40:00',1.27),('1444','2013-06-22','14:45:00',1.7),('1444','2013-06-22','14:50:00',2.93),('1444','2013-06-22','14:55:00',2.95),('1444','2013-06-22','15:00:00',2.95),('1444','2013-06-22','15:05:00',2.19),('1444','2013-06-22','15:10:00',3),('1444','2013-06-22','15:15:00',3.01),('1444','2013-06-22','15:20:00',2.67),('1444','2013-06-22','15:25:00',2.33),('1444','2013-06-22','15:30:00',1.73),('1444','2013-06-22','15:35:00',1.29),('1444','2013-06-22','15:40:00',1.55),('1444','2013-06-22','15:45:00',2.06),('1444','2013-06-22','15:50:00',1.84),('1444','2013-06-22','15:55:00',1.84),('1444','2013-06-22','16:00:00',1.34),('1444','2013-06-22','16:15:00',1.24),('1444','2013-06-22','16:20:00',1.35),('1444','2013-06-22','17:00:00',1.15),('1444','2013-06-22','17:05:00',1.11),('1444','2013-06-22','17:10:00',1.65),('1444','2013-06-22','17:15:00',2.21),('1444','2013-06-22','17:20:00',2.05),('1444','2013-06-22','17:25:00',2.03),('1444','2013-06-22','17:30:00',1.53),('1444','2013-06-22','17:35:00',1.52),('1444','2013-06-22','17:40:00',1.65),('1444','2013-06-22','17:45:00',1.62),('1444','2013-06-22','17:50:00',1.47),('1444','2013-06-22','17:55:00',1.45),('1444','2013-06-22','18:00:00',1.31),('1444','2013-06-22','18:05:00',1.07),('1444','2013-06-21','07:55:00',1.02),('1444','2013-06-21','08:00:00',1.08),('1444','2013-06-21','08:05:00',1.13),('1444','2013-06-21','08:10:00',1.18),('1444','2013-06-21','08:15:00',1.23),('1444','2013-06-21','08:20:00',1.28),('1444','2013-06-21','08:25:00',1.33),('1444','2013-06-21','08:30:00',1.38),('1444','2013-06-21','08:35:00',1.45),('1444','2013-06-21','08:40:00',1.49),('1444','2013-06-21','08:45:00',1.53),('1444','2013-06-21','08:50:00',1.57),('1444','2013-06-21','08:55:00',1.62),('1444','2013-06-21','09:00:00',1.67),('1444','2013-06-21','09:05:00',1.71),('1444','2013-06-21','09:10:00',1.76),('1444','2013-06-21','09:15:00',1.8),('1444','2013-06-21','09:20:00',1.83),('1444','2013-06-21','09:25:00',1.87),('1444','2013-06-21','09:30:00',1.91),('1444','2013-06-21','09:35:00',1.95),('1444','2013-06-21','09:40:00',1.99),('1444','2013-06-21','09:45:00',2.04),('1444','2013-06-21','09:50:00',2.1),('1444','2013-06-21','09:55:00',2.13),('1444','2013-06-21','10:00:00',2.16),('1444','2013-06-21','10:05:00',2.18),('1444','2013-06-21','10:10:00',2.23),('1444','2013-06-21','10:15:00',2.25),('1444','2013-06-21','10:20:00',2.28),('1444','2013-06-21','10:25:00',2.32),('1444','2013-06-21','10:30:00',2.36),('1444','2013-06-21','10:35:00',2.38),('1444','2013-06-21','10:40:00',2.41),('1444','2013-06-21','10:45:00',2.43),('1444','2013-06-21','10:50:00',2.43),('1444','2013-06-21','10:55:00',2.43),('1444','2013-06-21','11:00:00',2.48),('1444','2013-06-21','11:05:00',2.52),('1444','2013-06-21','11:10:00',2.55),('1444','2013-06-21','11:15:00',2.61),('1444','2013-06-21','11:20:00',2.65),('1444','2013-06-21','11:25:00',2.67),('1444','2013-06-21','11:30:00',2.7),('1444','2013-06-21','11:35:00',2.69),('1444','2013-06-21','11:40:00',2.68),('1444','2013-06-21','11:45:00',2.75),('1444','2013-06-21','11:50:00',2.79),('1444','2013-06-21','11:55:00',2.77),('1444','2013-06-21','12:00:00',2.79),('1444','2013-06-21','12:05:00',2.78),('1444','2013-06-21','12:10:00',2.77),('1444','2013-06-21','12:15:00',2.78),('1444','2013-06-21','12:20:00',2.77),('1444','2013-06-21','12:25:00',2.79),('1444','2013-06-21','12:30:00',2.8),('1444','2013-06-21','12:35:00',2.8),('1444','2013-06-21','12:40:00',2.83),('1444','2013-06-21','12:45:00',2.87),('1444','2013-06-21','12:50:00',2.8),('1444','2013-06-21','12:55:00',2.79),('1444','2013-06-21','13:00:00',2.81),('1444','2013-06-21','13:05:00',2.8),('1444','2013-06-21','13:10:00',2.86),('1444','2013-06-21','13:15:00',2.9),('1444','2013-06-21','13:20:00',2.88),('1444','2013-06-21','13:25:00',2.89),('1444','2013-06-21','13:30:00',2.91),('1444','2013-06-21','13:35:00',2.9),('1444','2013-06-21','13:40:00',2.9),('1444','2013-06-21','13:45:00',2.9),('1444','2013-06-21','13:50:00',2.89),('1444','2013-06-21','13:55:00',2.9),('1444','2013-06-21','14:00:00',2.91),('1444','2013-06-21','14:05:00',2.9),('1444','2013-06-21','14:10:00',2.91),('1444','2013-06-21','14:15:00',2.89),('1444','2013-06-21','14:20:00',2.89),('1444','2013-06-21','14:25:00',2.9),('1444','2013-06-21','14:30:00',2.89),('1444','2013-06-21','14:35:00',2.86),('1444','2013-06-21','14:40:00',2.86),('1444','2013-06-21','14:45:00',2.84),('1444','2013-06-21','14:50:00',2.84),('1444','2013-06-21','14:55:00',2.82),('1444','2013-06-21','15:00:00',2.79),('1444','2013-06-21','15:05:00',2.78),('1444','2013-06-21','15:10:00',2.72),('1444','2013-06-21','15:15:00',2.71),('1444','2013-06-21','15:20:00',2.7),('1444','2013-06-21','15:25:00',2.67),('1444','2013-06-21','15:30:00',2.65),('1444','2013-06-21','15:35:00',2.63),('1444','2013-06-21','15:40:00',2.58),('1444','2013-06-21','15:45:00',2.56),('1444','2013-06-21','15:50:00',2.52),('1444','2013-06-21','15:55:00',2.48),('1444','2013-06-21','16:00:00',2.44),('1444','2013-06-21','16:05:00',2.41),('1444','2013-06-21','16:10:00',2.37),('1444','2013-06-21','16:15:00',2.33),('1444','2013-06-21','16:20:00',2.29),('1444','2013-06-21','16:25:00',2.25),('1444','2013-06-21','16:30:00',2.21),('1444','2013-06-21','16:35:00',2.17),('1444','2013-06-21','16:40:00',2.12),('1444','2013-06-21','16:45:00',2.07),('1444','2013-06-21','16:50:00',2.02),('1444','2013-06-21','16:55:00',1.99),('1444','2013-06-21','17:00:00',1.95),('1444','2013-06-21','17:05:00',1.9),('1444','2013-06-21','17:10:00',1.85),('1444','2013-06-21','17:15:00',1.79),('1444','2013-06-21','17:20:00',1.74),('1444','2013-06-21','17:25:00',1.69),('1444','2013-06-21','17:30:00',1.63),('1444','2013-06-21','17:35:00',1.58),('1444','2013-06-21','17:40:00',1.53),('1444','2013-06-21','17:45:00',1.47),('1444','2013-06-21','17:50:00',1.42),('1444','2013-06-21','17:55:00',1.36),('1444','2013-06-21','18:00:00',1.31),('1444','2013-06-21','18:05:00',1.25),('1444','2013-06-21','18:10:00',1.19),('1444','2013-06-21','18:15:00',1.13),('1444','2013-06-21','18:20:00',1.07),('1444','2013-06-21','18:25:00',1.01),('1444','2014-04-04','09:05:00',1.34),('1444','2014-04-04','09:10:00',1.61),('1444','2014-04-04','09:15:00',1.59),('1444','2014-04-04','09:20:00',1.14),('1444','2014-04-04','13:20:00',1.48),('1444','2014-04-04','13:25:00',1.6),('1444','2014-04-04','13:30:00',1.73),('1444','2014-04-04','13:35:00',2.28),('1444','2014-04-04','13:40:00',3.33),('1444','2014-04-04','13:45:00',2.57),('1444','2014-04-04','13:50:00',3.36),('1444','2014-04-04','13:55:00',1.53),('1444','2014-04-04','14:00:00',2.6),('1444','2014-04-04','14:05:00',3.25),('1444','2014-04-04','14:10:00',3.81),('1444','2014-04-04','14:15:00',2.42),('1444','2014-04-04','14:20:00',2.48),('1444','2014-04-04','14:25:00',2.54),('1444','2014-04-04','14:30:00',1),('1444','2014-04-04','14:35:00',1.58),('1444','2014-04-04','14:40:00',1.07),('1444','2014-04-04','14:45:00',1.26),('1444','2014-04-04','14:50:00',2.82),('1444','2014-04-04','14:55:00',3.17),('1444','2014-04-04','15:00:00',2.76),('1444','2014-04-04','15:05:00',2.47),('1444','2014-04-04','15:10:00',2.93),('1444','2014-04-04','15:15:00',2.62),('1444','2014-04-04','15:20:00',1.61),('1444','2014-04-04','15:25:00',1.51),('1444','2014-04-04','15:30:00',1.18),('1444','2014-04-04','15:35:00',1.29),('1444','2014-04-04','15:40:00',1.61),('1444','2014-04-04','15:45:00',1.26),('1444','2014-04-04','15:50:00',1.7),('1444','2014-04-04','15:55:00',2.5),('1444','2014-04-04','16:00:00',1.65),('1444','2014-04-04','16:05:00',1.66),('1444','2014-04-04','16:10:00',2.19),('1444','2014-04-04','16:15:00',1.39),('1444','2014-04-04','16:25:00',1.03),('1444','2014-04-04','16:30:00',1.74),('1444','2014-04-04','16:35:00',1.5),('1444','2014-04-04','16:40:00',1.14),('1444','2014-04-04','16:45:00',1.96),('1444','2014-04-04','16:50:00',2.41),('1444','2014-04-04','16:55:00',2),('1444','2014-04-04','17:00:00',1.59),('1444','2014-04-04','17:05:00',1.43),('1444','2014-04-04','17:10:00',1.65),('1444','2014-04-04','17:15:00',1.58),('1444','2014-04-04','17:20:00',1.17),('1444','2014-04-04','17:25:00',1.31),('1444','2014-04-04','17:30:00',1.5),('1444','2014-04-04','17:35:00',1.01),('1444','2014-04-04','17:40:00',1.34),('1444','2014-04-04','17:45:00',1.21),('1444','2014-04-04','17:50:00',1.13),('1444','2013-06-20','08:00:00',1.06),('1444','2013-06-20','08:05:00',1.12),('1444','2013-06-20','08:10:00',1.18),('1444','2013-06-20','08:15:00',1.24),('1444','2013-06-20','08:20:00',1.29),('1444','2013-06-20','08:25:00',1.34),('1444','2013-06-20','08:30:00',1.4),('1444','2013-06-20','08:35:00',1.46),('1444','2013-06-20','08:40:00',1.51),('1444','2013-06-20','08:45:00',1.57),('1444','2013-06-20','08:50:00',1.62),('1444','2013-06-20','08:55:00',1.65),('1444','2013-06-20','09:00:00',1.71),('1444','2013-06-20','09:05:00',1.76),('1444','2013-06-20','09:10:00',1.81),('1444','2013-06-20','09:15:00',1.86),('1444','2013-06-20','09:20:00',1.92),('1444','2013-06-20','09:25:00',1.95),('1444','2013-06-20','09:30:00',1.98),('1444','2013-06-20','09:35:00',2.04),('1444','2013-06-20','09:40:00',2.1),('1444','2013-06-20','09:45:00',2.12),('1444','2013-06-20','09:50:00',2.17),('1444','2013-06-20','09:55:00',2.22),('1444','2013-06-20','10:00:00',2.26),('1444','2013-06-20','10:05:00',2.29),('1444','2013-06-20','10:10:00',2.32),('1444','2013-06-20','10:15:00',2.34),('1444','2013-06-20','10:20:00',2.39),('1444','2013-06-20','10:25:00',2.43),('1444','2013-06-20','10:30:00',2.44),('1444','2013-06-20','10:35:00',2.48),('1444','2013-06-20','10:40:00',2.5),('1444','2013-06-20','10:45:00',2.52),('1444','2013-06-20','10:50:00',2.56),('1444','2013-06-20','10:55:00',2.59),('1444','2013-06-20','11:00:00',2.57),('1444','2013-06-20','11:05:00',2.61),('1444','2013-06-20','11:10:00',2.61),('1444','2013-06-20','11:15:00',2.63),('1444','2013-06-20','11:20:00',2.63),('1444','2013-06-20','11:25:00',2.68),('1444','2013-06-20','11:30:00',2.74),('1444','2013-06-20','11:35:00',2.73),('1444','2013-06-20','11:40:00',2.73),('1444','2013-06-20','11:45:00',2.68),('1444','2013-06-20','11:50:00',2.66),('1444','2013-06-20','11:55:00',2.69),('1444','2013-06-20','12:00:00',2.69),('1444','2013-06-20','12:05:00',2.72),('1444','2013-06-20','12:10:00',1.96),('1444','2013-06-20','12:15:00',2.77),('1444','2013-06-20','12:20:00',1.77),('1444','2013-06-20','12:25:00',1.93),('1444','2013-06-20','12:30:00',2.92),('1444','2013-06-20','12:35:00',2.73),('1444','2013-06-20','12:40:00',2.77),('1444','2013-06-20','12:45:00',1.66),('1444','2013-06-20','12:50:00',2.97),('1444','2013-06-20','12:55:00',2.95),('1444','2013-06-20','13:00:00',2.99),('1444','2013-06-20','13:05:00',2.95),('1444','2013-06-20','13:10:00',2.04),('1444','2013-06-20','13:15:00',2.12),('1444','2013-06-20','13:20:00',2.93),('1444','2013-06-20','13:25:00',2.96),('1444','2013-06-20','13:30:00',2.72),('1444','2013-06-20','13:35:00',2.99),('1444','2013-06-20','13:40:00',2.99),('1444','2013-06-20','13:45:00',3),('1444','2013-06-20','13:50:00',3),('1444','2013-06-20','13:55:00',2.99),('1444','2013-06-20','14:00:00',3.04),('1444','2013-06-20','14:05:00',2.99),('1444','2013-06-20','14:10:00',3),('1444','2013-06-20','14:15:00',3),('1444','2013-06-20','14:20:00',3.01),('1444','2013-06-20','14:25:00',2.96),('1444','2013-06-20','14:30:00',2.98),('1444','2013-06-20','14:35:00',2.97),('1444','2013-06-20','14:40:00',2.95),('1444','2013-06-20','14:45:00',2.92),('1444','2013-06-20','14:50:00',2.91),('1444','2013-06-20','14:55:00',2.9),('1444','2013-06-20','15:00:00',2.86),('1444','2013-06-20','15:05:00',2.85),('1444','2013-06-20','15:10:00',2.84),('1444','2013-06-20','15:15:00',2.8),('1444','2013-06-20','15:20:00',2.76),('1444','2013-06-20','15:25:00',2.72),('1444','2013-06-20','15:30:00',2.69),('1444','2013-06-20','15:35:00',2.65),('1444','2013-06-20','15:40:00',2.63),('1444','2013-06-20','15:45:00',2.59),('1444','2013-06-20','15:50:00',2.54),('1444','2013-06-20','15:55:00',2.51),('1444','2013-06-20','16:00:00',2.48),('1444','2013-06-20','16:05:00',2.43),('1444','2013-06-20','16:10:00',2.4),('1444','2013-06-20','16:15:00',2.38),('1444','2013-06-20','16:20:00',2.33),('1444','2013-06-20','16:25:00',2.3),('1444','2013-06-20','16:30:00',2.25),('1444','2013-06-20','16:35:00',2.2),('1444','2013-06-20','16:40:00',2.15),('1444','2013-06-20','16:45:00',2.11),('1444','2013-06-20','16:50:00',2.06),('1444','2013-06-20','16:55:00',1.99),('1444','2013-06-20','17:00:00',1.95),('1444','2013-06-20','17:05:00',1.91),('1444','2013-06-20','17:10:00',1.86),('1444','2013-06-20','17:15:00',1.82),('1444','2013-06-20','17:20:00',1.76),('1444','2013-06-20','17:25:00',1.71),('1444','2013-06-20','17:30:00',1.65),('1444','2013-06-20','17:35:00',1.58),('1444','2013-06-20','17:40:00',1.54),('1444','2013-06-20','17:45:00',1.49),('1444','2013-06-20','17:50:00',1.43),('1444','2013-06-20','17:55:00',1.38),('1444','2013-06-20','18:00:00',1.33),('1444','2013-06-20','18:05:00',1.28),('1444','2013-06-20','18:10:00',1.22),('1444','2013-06-20','18:15:00',1.16),('1444','2013-06-20','18:20:00',1.1),('1444','2013-06-20','18:25:00',1.04),('1444','2013-06-19','08:00:00',1.05),('1444','2013-06-19','08:05:00',1.09),('1444','2013-06-19','08:10:00',1.15),('1444','2013-06-19','08:15:00',1.21),('1444','2013-06-19','08:20:00',1.27),('1444','2013-06-19','08:25:00',1.32),('1444','2013-06-19','08:30:00',1.37),('1444','2013-06-19','08:35:00',1.42),('1444','2013-06-19','08:40:00',1.48),('1444','2013-06-19','08:45:00',1.52),('1444','2013-06-19','08:50:00',1.57),('1444','2013-06-19','08:55:00',1.62),('1444','2013-06-19','09:00:00',1.67),('1444','2013-06-19','09:05:00',1.73),('1444','2013-06-19','09:10:00',1.78),('1444','2013-06-19','09:15:00',1.82),('1444','2013-06-19','09:20:00',1.87),('1444','2013-06-19','09:25:00',1.91),('1444','2013-06-19','09:30:00',1.94),('1444','2013-06-19','09:35:00',1.99),('1444','2013-06-19','09:40:00',2.03),('1444','2013-06-19','09:45:00',2.07),('1444','2013-06-19','09:50:00',2.12),('1444','2013-06-19','09:55:00',2.16),('1444','2013-06-19','10:00:00',2.18),('1444','2013-06-19','10:05:00',2.21),('1444','2013-06-19','10:10:00',2.24),('1444','2013-06-19','10:15:00',2.3),('1444','2013-06-19','10:20:00',2.34),('1444','2013-06-19','10:25:00',2.37),('1444','2013-06-19','10:30:00',2.41),('1444','2013-06-19','10:35:00',2.44),('1444','2013-06-19','10:40:00',2.45),('1444','2013-06-19','10:45:00',2.48),('1444','2013-06-19','10:50:00',2.48),('1444','2013-06-19','10:55:00',2.49),('1444','2013-06-19','11:00:00',2.52),('1444','2013-06-19','11:05:00',2.54),('1444','2013-06-19','11:10:00',2.57),('1444','2013-06-19','11:15:00',2.59),('1444','2013-06-19','11:20:00',2.62),('1444','2013-06-19','11:25:00',2.61),('1444','2013-06-19','11:30:00',2.66),('1444','2013-06-19','11:35:00',2.66),('1444','2013-06-19','11:40:00',2.69),('1444','2013-06-19','11:45:00',2.7),('1444','2013-06-19','11:50:00',2.72),('1444','2013-06-19','11:55:00',2.74),('1444','2013-06-19','12:00:00',2.76),('1444','2013-06-19','12:05:00',2.75),('1444','2013-06-19','12:10:00',2.75),('1444','2013-06-19','12:15:00',2.79),('1444','2013-06-19','12:20:00',2.79),('1444','2013-06-19','12:25:00',2.8),('1444','2013-06-19','12:30:00',2.86),('1444','2013-06-19','12:35:00',2.9),('1444','2013-06-19','12:40:00',2.91),('1444','2013-06-19','12:45:00',2.87),('1444','2013-06-19','12:50:00',2.92),('1444','2013-06-19','12:55:00',2.9),('1444','2013-06-19','13:00:00',2.87),('1444','2013-06-19','13:05:00',2.93),('1444','2013-06-19','13:10:00',2.91),('1444','2013-06-19','13:15:00',2.87),('1444','2013-06-19','13:20:00',2.91),('1444','2013-06-19','13:25:00',2.95),('1444','2013-06-19','13:30:00',2.93),('1444','2013-06-19','13:35:00',2.94),('1444','2013-06-19','13:40:00',2.93),('1444','2013-06-19','13:45:00',2.93),('1444','2013-06-19','13:50:00',2.94),('1444','2013-06-19','13:55:00',2.93),('1444','2013-06-19','14:00:00',2.95),('1444','2013-06-19','14:05:00',2.92),('1444','2013-06-19','14:10:00',2.9),('1444','2013-06-19','14:15:00',2.88),('1444','2013-06-19','14:20:00',2.88),('1444','2013-06-19','14:25:00',2.89),('1444','2013-06-19','14:30:00',2.85),('1444','2013-06-19','14:35:00',2.83),('1444','2013-06-19','14:40:00',2.79),('1444','2013-06-19','14:45:00',2.78),('1444','2013-06-19','14:50:00',2.77),('1444','2013-06-19','14:55:00',2.76),('1444','2013-06-19','15:00:00',2.74),('1444','2013-06-19','15:05:00',2.71),('1444','2013-06-19','15:10:00',2.68),('1444','2013-06-19','15:15:00',2.66),('1444','2013-06-19','15:20:00',2.64),('1444','2013-06-19','15:25:00',2.62),('1444','2013-06-19','15:30:00',2.57),('1444','2013-06-19','15:35:00',2.53),('1444','2013-06-19','15:40:00',2.49),('1444','2013-06-19','15:45:00',2.47),('1444','2013-06-19','15:50:00',2.43),('1444','2013-06-19','15:55:00',2.39),('1444','2013-06-19','16:00:00',2.36),('1444','2013-06-19','16:05:00',2.3),('1444','2013-06-19','16:10:00',2.25),('1444','2013-06-19','16:15:00',2.23),('1444','2013-06-19','16:20:00',2.2),('1444','2013-06-19','16:25:00',2.16),('1444','2013-06-19','16:30:00',2.13),('1444','2013-06-19','16:35:00',2.08),('1444','2013-06-19','16:40:00',2.05),('1444','2013-06-19','16:45:00',2.01),('1444','2013-06-19','16:50:00',1.97),('1444','2013-06-19','16:55:00',1.92),('1444','2013-06-19','17:00:00',1.88),('1444','2013-06-19','17:05:00',1.84),('1444','2013-06-19','17:10:00',1.79),('1444','2013-06-19','17:15:00',1.75),('1444','2013-06-19','17:20:00',1.72),('1444','2013-06-19','17:25:00',1.68),('1444','2013-06-19','17:30:00',1.63),('1444','2013-06-19','17:35:00',1.57),('1444','2013-06-19','17:40:00',1.52),('1444','2013-06-19','17:45:00',1.46),('1444','2013-06-19','17:50:00',1.4),('1444','2013-06-19','17:55:00',1.35),('1444','2013-06-19','18:00:00',1.29),('1444','2013-06-19','18:05:00',1.23),('1444','2013-06-19','18:10:00',1.16),('1444','2013-06-19','18:15:00',1.1),('1444','2013-06-19','18:20:00',1.04),('1444','2013-06-18','08:00:00',1.03),('1444','2013-06-18','08:05:00',1.09),('1444','2013-06-18','08:10:00',1.15),('1444','2013-06-18','08:15:00',1.2),('1444','2013-06-18','08:20:00',1.25),('1444','2013-06-18','08:25:00',1.3),('1444','2013-06-18','08:30:00',1.36),('1444','2013-06-18','08:35:00',1.41),('1444','2013-06-18','08:40:00',1.45),('1444','2013-06-18','08:45:00',1.51),('1444','2013-06-18','08:50:00',1.56),('1444','2013-06-18','08:55:00',1.61),('1444','2013-06-18','09:00:00',1.65),('1444','2013-06-18','09:05:00',1.7),('1444','2013-06-18','09:10:00',1.75),('1444','2013-06-18','09:15:00',1.79),('1444','2013-06-18','09:20:00',1.82),('1444','2013-06-18','09:25:00',1.88),('1444','2013-06-18','09:30:00',1.91),('1444','2013-06-18','09:35:00',1.96),('1444','2013-06-18','09:40:00',2),('1444','2013-06-18','09:45:00',2.03),('1444','2013-06-18','09:50:00',1.65),('1444','2013-06-18','09:55:00',2.11),('1444','2013-06-18','10:00:00',2.14),('1444','2013-06-18','10:05:00',2.17),('1444','2013-06-18','10:10:00',2.21),('1444','2013-06-18','10:15:00',2.26),('1444','2013-06-18','10:20:00',2.3),('1444','2013-06-18','10:25:00',2.33),('1444','2013-06-18','10:30:00',2.36),('1444','2013-06-18','10:35:00',2.42),('1444','2013-06-18','10:40:00',2.45),('1444','2013-06-18','10:45:00',2.48),('1444','2013-06-18','10:50:00',2.46),('1444','2013-06-18','10:55:00',2.45),('1444','2013-06-18','11:00:00',2.51),('1444','2013-06-18','11:05:00',2.55),('1444','2013-06-18','11:10:00',2.54),('1444','2013-06-18','11:15:00',2.56),('1444','2013-06-18','11:20:00',2.64),('1444','2013-06-18','11:25:00',2.63),('1444','2013-06-18','11:30:00',2.64),('1444','2013-06-18','11:35:00',2.65),('1444','2013-06-18','11:40:00',2.66),('1444','2013-06-18','11:45:00',2.67),('1444','2013-06-18','11:50:00',2.69),('1444','2013-06-18','11:55:00',2.7),('1444','2013-06-18','12:00:00',2.71),('1444','2013-06-18','12:05:00',2.69),('1444','2013-06-18','12:10:00',2.63),('1444','2013-06-18','12:15:00',2.42),('1444','2013-06-18','12:20:00',2.65),('1444','2013-06-18','12:25:00',2.78),('1444','2013-06-18','12:30:00',2.7),('1444','2013-06-18','12:35:00',2.7),('1444','2013-06-18','12:40:00',2.12),('1444','2013-06-18','12:45:00',2.06),('1444','2013-06-18','12:50:00',2.2),('1444','2013-06-18','12:55:00',2.14),('1444','2013-06-18','13:00:00',1.33),('1444','2013-06-18','13:05:00',2.56),('1444','2013-06-18','13:10:00',2.38),('1444','2013-06-18','13:15:00',2.27),('1444','2013-06-18','13:20:00',2.92),('1444','2013-06-18','13:25:00',2.05),('1444','2013-06-18','13:30:00',2.21),('1444','2013-06-18','13:35:00',3.02),('1444','2013-06-18','13:40:00',2.32),('1444','2013-06-18','13:45:00',1.93),('1444','2013-06-18','13:50:00',2.94),('1444','2013-06-18','13:55:00',2.27),('1444','2013-06-18','14:00:00',2.93),('1444','2013-06-18','14:05:00',2.97),('1444','2013-06-18','14:10:00',2.87),('1444','2013-06-18','14:15:00',2.92),('1444','2013-06-18','14:20:00',2.9),('1444','2013-06-18','14:25:00',2.87),('1444','2013-06-18','14:30:00',2.84),('1444','2013-06-18','14:35:00',2.93),('1444','2013-06-18','14:40:00',2.94),('1444','2013-06-18','14:45:00',2.89),('1444','2013-06-18','14:50:00',2.85),('1444','2013-06-18','14:55:00',2.84),('1444','2013-06-18','15:00:00',2.82),('1444','2013-06-18','15:05:00',2.76),('1444','2013-06-18','15:10:00',2.73),('1444','2013-06-18','15:15:00',2.69),('1444','2013-06-18','15:20:00',2.65),('1444','2013-06-18','15:25:00',2.64),('1444','2013-06-18','15:30:00',2.6),('1444','2013-06-18','15:35:00',2.59),('1444','2013-06-18','15:40:00',2.58),('1444','2013-06-18','15:45:00',2.54),('1444','2013-06-18','15:50:00',2.52),('1444','2013-06-18','15:55:00',2.52),('1444','2013-06-18','16:00:00',2.49),('1444','2013-06-18','16:05:00',2.46),('1444','2013-06-18','16:10:00',2.42),('1444','2013-06-18','16:15:00',2.4),('1444','2013-06-18','16:20:00',2.37),('1444','2013-06-18','16:25:00',2.31),('1444','2013-06-18','16:30:00',2.24),('1444','2013-06-18','16:35:00',2.16),('1444','2013-06-18','16:40:00',2.11),('1444','2013-06-18','16:45:00',2.04),('1444','2013-06-18','16:50:00',1.97),('1444','2013-06-18','16:55:00',1.96),('1444','2013-06-18','17:00:00',1.91),('1444','2013-06-18','17:05:00',1.87),('1444','2013-06-18','17:10:00',1.82),('1444','2013-06-18','17:15:00',1.77),('1444','2013-06-18','17:20:00',1.72),('1444','2013-06-18','17:25:00',1.68),('1444','2013-06-18','17:30:00',1.62),('1444','2013-06-18','17:35:00',1.56),('1444','2013-06-18','17:40:00',1.51),('1444','2013-06-18','17:45:00',1.46),('1444','2013-06-18','17:50:00',1.39),('1444','2013-06-18','17:55:00',1.35),('1444','2013-06-18','18:00:00',1.3),('1444','2013-06-18','18:05:00',1.24),('1444','2013-06-18','18:10:00',1.17),('1444','2013-06-18','18:15:00',1.12),('1444','2013-06-18','18:20:00',1.09),('1444','2013-06-18','18:25:00',1.03),('1444','2014-04-03','09:05:00',1.03),('1444','2014-04-03','09:30:00',1.18),('1444','2014-04-03','09:35:00',1.4),('1444','2014-04-03','09:40:00',1.46),('1444','2014-04-03','09:45:00',1.44),('1444','2014-04-03','09:50:00',1.37),('1444','2014-04-03','09:55:00',1.45),('1444','2014-04-03','10:00:00',1.7),('1444','2014-04-03','10:05:00',1.97),('1444','2014-04-03','10:10:00',2.09),('1444','2014-04-03','10:15:00',2.36),('1444','2014-04-03','10:20:00',2.41),('1444','2014-04-03','10:25:00',2.03),('1444','2014-04-03','10:30:00',2.05),('1444','2014-04-03','10:35:00',2.15),('1444','2014-04-03','10:40:00',1.74),('1444','2014-04-03','10:45:00',1.84),('1444','2014-04-03','10:50:00',1.59),('1444','2014-04-03','10:55:00',1.69),('1444','2014-04-03','11:00:00',1.56),('1444','2014-04-03','11:05:00',1.35),('1444','2014-04-03','11:10:00',1.28),('1444','2014-04-03','11:15:00',1.21),('1444','2014-04-03','11:20:00',1.15),('1444','2014-04-03','11:25:00',1.07),('1444','2014-04-03','11:30:00',1.06),('1444','2014-04-03','11:35:00',1.14),('1444','2014-04-03','11:40:00',1.25),('1444','2014-04-03','11:45:00',1.43),('1444','2014-04-03','11:50:00',1.75),('1444','2014-04-03','11:55:00',1.88),('1444','2014-04-03','12:00:00',1.8),('1444','2014-04-03','12:05:00',1.8),('1444','2014-04-03','12:10:00',1.74),('1444','2014-04-03','12:15:00',1.71),('1444','2014-04-03','12:20:00',1.94),('1444','2014-04-03','12:25:00',2.33),('1444','2014-04-03','12:30:00',2.95),('1444','2014-04-03','12:35:00',2.86),('1444','2014-04-03','12:40:00',3.17),('1444','2014-04-03','12:45:00',1.74),('1444','2014-04-03','12:50:00',2.19),('1444','2014-04-03','12:55:00',2.06),('1444','2014-04-03','13:00:00',2.07),('1444','2014-04-03','13:05:00',2.59),('1444','2014-04-03','13:10:00',2.07),('1444','2014-04-03','13:15:00',3.53),('1444','2014-04-03','13:20:00',2.01),('1444','2014-04-03','13:25:00',2.19),('1444','2014-04-03','13:30:00',2.29),('1444','2014-04-03','13:35:00',3.48),('1444','2014-04-03','13:40:00',2.87),('1444','2014-04-03','13:45:00',1.64),('1444','2014-04-03','13:50:00',1.64),('1444','2014-04-03','13:55:00',2.18),('1444','2014-04-03','14:00:00',2.85),('1444','2014-04-03','14:05:00',2.57),('1444','2014-04-03','14:10:00',2.03),('1444','2014-04-03','14:15:00',2.83),('1444','2014-04-03','14:20:00',2.78),('1444','2014-04-03','14:25:00',2.9),('1444','2014-04-03','14:30:00',2.94),('1444','2014-04-03','14:35:00',2.94),('1444','2014-04-03','14:40:00',2.83),('1444','2014-04-03','14:45:00',2.75),('1444','2014-04-03','14:50:00',2.71),('1444','2014-04-03','14:55:00',2.66),('1444','2014-04-03','15:00:00',2.61),('1444','2014-04-03','15:05:00',2.59),('1444','2014-04-03','15:10:00',2.57),('1444','2014-04-03','15:15:00',2.56),('1444','2014-04-03','15:20:00',2.54),('1444','2014-04-03','15:25:00',2.51),('1444','2014-04-03','15:30:00',2.47),('1444','2014-04-03','15:35:00',2.44),('1444','2014-04-03','15:40:00',2.4),('1444','2014-04-03','15:45:00',2.39),('1444','2014-04-03','15:50:00',2.33),('1444','2014-04-03','15:55:00',2.31),('1444','2014-04-03','16:00:00',2.3),('1444','2014-04-03','16:05:00',2.23),('1444','2014-04-03','16:10:00',2.2),('1444','2014-04-03','16:15:00',2.13),('1444','2014-04-03','16:20:00',2.09),('1444','2014-04-03','16:25:00',2.03),('1444','2014-04-03','16:30:00',1.95),('1444','2014-04-03','16:35:00',1.9),('1444','2014-04-03','16:40:00',1.86),('1444','2014-04-03','16:45:00',1.74),('1444','2014-04-03','16:50:00',1.3),('1444','2014-04-03','16:55:00',1.05),('1444','2014-04-03','17:50:00',1.01),('1444','2014-04-02','08:55:00',1.04),('1444','2014-04-02','09:55:00',2.27),('1444','2014-04-02','10:00:00',1.68),('1444','2014-04-02','10:05:00',1.5),('1444','2014-04-02','10:10:00',2.38),('1444','2014-04-02','10:15:00',2.55),('1444','2014-04-02','10:20:00',2.41),('1444','2014-04-02','10:25:00',1.62),('1444','2014-04-02','10:45:00',2.1),('1444','2014-04-02','10:50:00',2.85),('1444','2014-04-02','10:55:00',2.86),('1444','2014-04-02','11:00:00',1.05),('1444','2014-04-02','11:15:00',2.61),('1444','2014-04-02','11:20:00',2.84),('1444','2014-04-02','11:25:00',3.03),('1444','2014-04-02','11:30:00',2.61),('1444','2014-04-02','11:45:00',2.02),('1444','2014-04-02','11:50:00',3.22),('1444','2014-04-02','11:55:00',2.55),('1444','2014-04-02','12:00:00',1.76),('1444','2014-04-02','12:05:00',2),('1444','2014-04-02','12:10:00',1.23),('1444','2014-04-02','12:15:00',1.05),('1444','2014-04-02','12:20:00',1.92),('1444','2014-04-02','12:25:00',1.31),('1444','2014-04-02','12:30:00',3.05),('1444','2014-04-02','12:35:00',1.39),('1444','2014-04-02','12:40:00',2.84),('1444','2014-04-02','12:45:00',2.42),('1444','2014-04-02','12:50:00',2.62),('1444','2014-04-02','12:55:00',1.02),('1444','2014-04-02','13:00:00',2.64),('1444','2014-04-02','13:05:00',3.61),('1444','2014-04-02','13:10:00',3.58),('1444','2014-04-02','13:15:00',3.47),('1444','2014-04-02','13:20:00',3.3),('1444','2014-04-02','13:25:00',3.11),('1444','2014-04-02','13:30:00',3.25),('1444','2014-04-02','13:35:00',3.24),('1444','2014-04-02','13:40:00',3.22),('1444','2014-04-02','13:45:00',3.11),('1444','2014-04-02','13:50:00',3.11),('1444','2014-04-02','13:55:00',3.11),('1444','2014-04-02','14:00:00',3.09),('1444','2014-04-02','14:05:00',3.04),('1444','2014-04-02','14:10:00',2.87),('1444','2014-04-02','14:15:00',2.98),('1444','2014-04-02','14:20:00',2.99),('1444','2014-04-02','14:25:00',2.99),('1444','2014-04-02','14:30:00',2.98),('1444','2014-04-02','14:35:00',2.95),('1444','2014-04-02','14:40:00',2.91),('1444','2014-04-02','14:45:00',1.76),('1444','2014-04-02','14:50:00',2.66),('1444','2014-04-02','14:55:00',2.52),('1444','2014-04-02','15:00:00',2.54),('1444','2014-04-02','15:05:00',2.72),('1444','2014-04-02','15:10:00',2.52),('1444','2014-04-02','15:15:00',2.58),('1444','2014-04-02','15:20:00',2.58),('1444','2014-04-02','15:25:00',2.55),('1444','2014-04-02','15:30:00',2.39),('1444','2014-04-02','15:35:00',2.34),('1444','2014-04-02','15:40:00',2.34),('1444','2014-04-02','15:45:00',2.43),('1444','2014-04-02','15:50:00',2.39),('1444','2014-04-02','15:55:00',2.1),('1444','2014-04-02','16:00:00',2.18),('1444','2014-04-02','16:05:00',2.15),('1444','2014-04-02','16:10:00',2.1),('1444','2014-04-02','16:15:00',2.02),('1444','2014-04-02','16:20:00',1.97),('1444','2014-04-02','16:25:00',1.82),('1444','2014-04-02','16:30:00',1.96),('1444','2014-04-02','16:35:00',1.88),('1444','2014-04-02','16:40:00',1.81),('1444','2014-04-02','16:45:00',1.74),('1444','2014-04-02','16:50:00',1.62),('1444','2014-04-02','16:55:00',1.6),('1444','2014-04-02','17:00:00',1.6),('1444','2014-04-02','17:05:00',1.44),('1444','2014-04-02','17:10:00',1.37),('1444','2014-04-02','17:15:00',1.22),('1444','2014-04-02','17:20:00',1.22),('1444','2014-04-02','17:25:00',1.16),('1444','2014-04-02','17:30:00',1.04),('1444','2014-04-02','17:35:00',1.02),('1444','2014-04-01','08:40:00',1.04),('1444','2014-04-01','08:45:00',1.11),('1444','2014-04-01','08:50:00',1.18),('1444','2014-04-01','08:55:00',1.25),('1444','2014-04-01','09:00:00',1.32),('1444','2014-04-01','09:05:00',1.38),('1444','2014-04-01','09:10:00',1.44),('1444','2014-04-01','09:15:00',1.5),('1444','2014-04-01','09:20:00',1.56),('1444','2014-04-01','09:25:00',1.6),('1444','2014-04-01','09:30:00',1.66),('1444','2014-04-01','09:35:00',1.78),('1444','2014-04-01','09:40:00',1.84),('1444','2014-04-01','09:45:00',1.87),('1444','2014-04-01','09:50:00',1.96),('1444','2014-04-01','09:55:00',2.02),('1444','2014-04-01','10:00:00',2.06),('1444','2014-04-01','10:05:00',2.07),('1444','2014-04-01','10:10:00',2.15),('1444','2014-04-01','10:15:00',2.26),('1444','2014-04-01','10:20:00',2.41),('1444','2014-04-01','10:25:00',2.29),('1444','2014-04-01','10:30:00',2.27),('1444','2014-04-01','10:35:00',2.73),('1444','2014-04-01','10:40:00',2.57),('1444','2014-04-01','10:45:00',2.59),('1444','2014-04-01','10:50:00',2.55),('1444','2014-04-01','10:55:00',2.57),('1444','2014-04-01','11:00:00',2.63),('1444','2014-04-01','11:05:00',2.65),('1444','2014-04-01','11:10:00',2.67),('1444','2014-04-01','11:15:00',2.71),('1444','2014-04-01','11:20:00',2.79),('1444','2014-04-01','11:25:00',2.82),('1444','2014-04-01','11:30:00',2.87),('1444','2014-04-01','11:35:00',2.84),('1444','2014-04-01','11:40:00',2.88),('1444','2014-04-01','11:45:00',2.9),('1444','2014-04-01','11:50:00',2.91),('1444','2014-04-01','11:55:00',2.87),('1444','2014-04-01','12:00:00',2.98),('1444','2014-04-01','12:05:00',3.01),('1444','2014-04-01','12:10:00',3.02),('1444','2014-04-01','12:15:00',3.04),('1444','2014-04-01','12:20:00',3.07),('1444','2014-04-01','12:25:00',3.09),('1444','2014-04-01','12:30:00',3.13),('1444','2014-04-01','12:35:00',3.15),('1444','2014-04-01','12:40:00',3.16),('1444','2014-04-01','12:45:00',3.16),('1444','2014-04-01','12:50:00',2.98),('1444','2014-04-01','12:55:00',3.17),('1444','2014-04-01','13:00:00',3.18),('1444','2014-04-01','13:05:00',3.11),('1444','2014-04-01','13:10:00',3.17),('1444','2014-04-01','13:15:00',3.21),('1444','2014-04-01','13:20:00',3.08),('1444','2014-04-01','13:25:00',3.14),('1444','2014-04-01','13:30:00',2.95),('1444','2014-04-01','13:35:00',2.94),('1444','2014-04-01','13:40:00',2.51),('1444','2014-04-01','13:45:00',3.2),('1444','2014-04-01','13:50:00',3.15),('1444','2014-04-01','13:55:00',3.15),('1444','2014-04-01','14:00:00',3.1),('1444','2014-04-01','14:05:00',2.85),('1444','2014-04-01','14:10:00',2.71),('1444','2014-04-01','14:15:00',2.76),('1444','2014-04-01','14:20:00',2.78),('1444','2014-04-01','14:25:00',2.81),('1444','2014-04-01','14:30:00',3.11),('1444','2014-04-01','14:35:00',2.85),('1444','2014-04-01','14:40:00',2.5),('1444','2014-04-01','14:45:00',3.13),('1444','2014-04-01','14:50:00',2.61),('1444','2014-04-01','14:55:00',2.46),('1444','2014-04-01','15:00:00',2.55),('1444','2014-04-01','15:05:00',2.39),('1444','2014-04-01','15:10:00',2.86),('1444','2014-04-01','15:15:00',2.86),('1444','2014-04-01','15:20:00',1.87),('1444','2014-04-01','15:25:00',2.81),('1444','2014-04-01','15:30:00',2.24),('1444','2014-04-01','15:35:00',2.69),('1444','2014-04-01','15:40:00',2.58),('1444','2014-04-01','15:45:00',2.13),('1444','2014-04-01','15:50:00',2.56),('1444','2014-04-01','15:55:00',2.43),('1444','2014-04-01','16:00:00',2.31),('1444','2014-04-01','16:05:00',2.4),('1444','2014-04-01','16:10:00',2.19),('1444','2014-04-01','16:15:00',2.38),('1444','2014-04-01','16:20:00',1.1),('1444','2014-04-01','16:25:00',1.74),('1444','2014-04-01','16:30:00',2.2),('1444','2014-04-01','16:35:00',2.06),('1444','2014-04-01','16:40:00',1.75),('1444','2014-04-01','16:45:00',1.08),('1444','2014-04-01','16:50:00',1.6),('1444','2014-04-01','16:55:00',1.05),('1444','2014-04-01','17:00:00',1.5),('1444','2014-04-01','17:05:00',1.59),('1444','2014-04-01','17:10:00',1.46),('1444','2014-04-01','17:15:00',1.35),('1444','2014-04-01','17:20:00',1.37),('1444','2014-04-01','17:25:00',1.31),('1444','2014-04-01','17:30:00',1.21),('1444','2014-04-01','17:35:00',1.12),('1444','2014-04-01','17:40:00',1.08),('1444','2014-04-01','17:45:00',1.01),('1444','2014-03-31','08:40:00',1.03),('1444','2014-03-31','08:45:00',1.09),('1444','2014-03-31','08:50:00',1.16),('1444','2014-03-31','08:55:00',1.22),('1444','2014-03-31','09:00:00',1.28),('1444','2014-03-31','09:05:00',1.36),('1444','2014-03-31','09:10:00',1.43),('1444','2014-03-31','09:15:00',1.49),('1444','2014-03-31','09:20:00',1.56),('1444','2014-03-31','09:25:00',1.62),('1444','2014-03-31','09:30:00',1.67),('1444','2014-03-31','09:35:00',1.75),('1444','2014-03-31','09:40:00',1.81),('1444','2014-03-31','09:45:00',1.87),('1444','2014-03-31','09:50:00',1.92),('1444','2014-03-31','09:55:00',1.95),('1444','2014-03-31','10:00:00',2.01),('1444','2014-03-31','10:05:00',2.05),('1444','2014-03-31','10:10:00',2.11),('1444','2014-03-31','10:15:00',2.17),('1444','2014-03-31','10:20:00',2.22),('1444','2014-03-31','10:25:00',2.25),('1444','2014-03-31','10:30:00',2.29),('1444','2014-03-31','10:35:00',2.34),('1444','2014-03-31','10:40:00',2.38),('1444','2014-03-31','10:45:00',2.42),('1444','2014-03-31','10:50:00',2.48),('1444','2014-03-31','10:55:00',2.51),('1444','2014-03-31','11:00:00',2.54),('1444','2014-03-31','11:05:00',2.58),('1444','2014-03-31','11:10:00',2.61),('1444','2014-03-31','11:15:00',2.64),('1444','2014-03-31','11:20:00',2.67),('1444','2014-03-31','11:25:00',2.71),('1444','2014-03-31','11:30:00',2.73),('1444','2014-03-31','11:35:00',2.73),('1444','2014-03-31','11:40:00',2.78),('1444','2014-03-31','11:45:00',2.8),('1444','2014-03-31','11:50:00',2.85),('1444','2014-03-31','11:55:00',2.84),('1444','2014-03-31','12:00:00',2.85),('1444','2014-03-31','12:05:00',2.87),('1444','2014-03-31','12:10:00',2.9),('1444','2014-03-31','12:15:00',2.93),('1444','2014-03-31','12:20:00',2.93),('1444','2014-03-31','12:25:00',2.95),('1444','2014-03-31','12:30:00',2.96),('1444','2014-03-31','12:35:00',2.97),('1444','2014-03-31','12:40:00',2.98),('1444','2014-03-31','12:45:00',2.96),('1444','2014-03-31','12:50:00',2.96),('1444','2014-03-31','12:55:00',2.97),('1444','2014-03-31','13:00:00',2.99),('1444','2014-03-31','13:05:00',3.02),('1444','2014-03-31','13:10:00',3.02),('1444','2014-03-31','13:15:00',3.01),('1444','2014-03-31','13:20:00',3),('1444','2014-03-31','13:25:00',2.99),('1444','2014-03-31','13:30:00',2.98),('1444','2014-03-31','13:35:00',2.99),('1444','2014-03-31','13:40:00',3.01),('1444','2014-03-31','13:45:00',3),('1444','2014-03-31','13:50:00',2.98),('1444','2014-03-31','13:55:00',2.98),('1444','2014-03-31','14:00:00',2.97),('1444','2014-03-31','14:05:00',2.97),('1444','2014-03-31','14:10:00',2.95),('1444','2014-03-31','14:15:00',2.94),('1444','2014-03-31','14:20:00',2.9),('1444','2014-03-31','14:25:00',2.88),('1444','2014-03-31','14:30:00',2.86),('1444','2014-03-31','14:35:00',2.86),('1444','2014-03-31','14:40:00',2.84),('1444','2014-03-31','14:45:00',2.82),('1444','2014-03-31','14:50:00',2.78),('1444','2014-03-31','14:55:00',2.73),('1444','2014-03-31','15:00:00',2.73),('1444','2014-03-31','15:05:00',2.7),('1444','2014-03-31','15:10:00',2.65),('1444','2014-03-31','15:15:00',2.62),('1444','2014-03-31','15:20:00',2.59),('1444','2014-03-31','15:25:00',2.54),('1444','2014-03-31','15:30:00',2.5),('1444','2014-03-31','15:35:00',2.45),('1444','2014-03-31','15:40:00',2.41),('1444','2014-03-31','15:45:00',2.37),('1444','2014-03-31','15:50:00',2.32),('1444','2014-03-31','15:55:00',2.25),('1444','2014-03-31','16:00:00',2.21),('1444','2014-03-31','16:05:00',2.15),('1444','2014-03-31','16:10:00',2.09),('1444','2014-03-31','16:15:00',2.04),('1444','2014-03-31','16:20:00',1.99),('1444','2014-03-31','16:25:00',1.93),('1444','2014-03-31','16:30:00',1.88),('1444','2014-03-31','16:35:00',1.82),('1444','2014-03-31','16:40:00',1.77),('1444','2014-03-31','16:45:00',1.71),('1444','2014-03-31','16:50:00',1.65),('1444','2014-03-31','16:55:00',1.58),('1444','2014-03-31','17:00:00',1.51),('1444','2014-03-31','17:05:00',1.46),('1444','2014-03-31','17:10:00',1.4),('1444','2014-03-31','17:15:00',1.33),('1444','2014-03-31','17:20:00',1.25),('1444','2014-03-31','17:25:00',1.19),('1444','2014-03-31','17:30:00',1.14),('1444','2014-03-31','17:35:00',1.06),('1444','2014-03-31','17:40:00',1.02),('1444','2014-03-30','08:40:00',1),('1444','2014-03-30','08:50:00',1.02),('1444','2014-03-30','08:55:00',1.06),('1444','2014-03-30','09:00:00',1.09),('1444','2014-03-30','09:05:00',1.09),('1444','2014-03-30','09:10:00',1.04),('1444','2014-03-30','09:15:00',1.15),('1444','2014-03-30','09:20:00',1.23),('1444','2014-03-30','09:25:00',1.42),('1444','2014-03-30','09:30:00',1.57),('1444','2014-03-30','09:35:00',1.66),('1444','2014-03-30','09:40:00',1.68),('1444','2014-03-30','09:45:00',1.76),('1444','2014-03-30','09:50:00',1.78),('1444','2014-03-30','09:55:00',1.72),('1444','2014-03-30','10:00:00',1.86),('1444','2014-03-30','10:05:00',1.96),('1444','2014-03-30','10:10:00',2.02),('1444','2014-03-30','10:15:00',2),('1444','2014-03-30','10:20:00',2.13),('1444','2014-03-30','10:25:00',2.19),('1444','2014-03-30','10:30:00',2.24),('1444','2014-03-30','10:35:00',2.31),('1444','2014-03-30','10:40:00',2.35),('1444','2014-03-30','10:45:00',2.37),('1444','2014-03-30','10:50:00',2.35),('1444','2014-03-30','10:55:00',2.35),('1444','2014-03-30','11:00:00',2.3),('1444','2014-03-30','11:05:00',2.31),('1444','2014-03-30','11:10:00',2.34),('1444','2014-03-30','11:15:00',2.28),('1444','2014-03-30','11:20:00',2.34),('1444','2014-03-30','11:25:00',2.52),('1444','2014-03-30','11:30:00',2.56),('1444','2014-03-30','11:35:00',2.59),('1444','2014-03-30','11:40:00',2.69),('1444','2014-03-30','11:45:00',2.75),('1444','2014-03-30','11:50:00',2.81),('1444','2014-03-30','11:55:00',2.88),('1444','2014-03-30','12:00:00',2.95),('1444','2014-03-30','12:05:00',3),('1444','2014-03-30','12:10:00',3.07),('1444','2014-03-30','12:15:00',3.09),('1444','2014-03-30','12:20:00',2.94),('1444','2014-03-30','12:25:00',2.91),('1444','2014-03-30','12:30:00',2.69),('1444','2014-03-30','12:35:00',2.91),('1444','2014-03-30','12:40:00',2.89),('1444','2014-03-30','12:45:00',2.9),('1444','2014-03-30','12:50:00',2.93),('1444','2014-03-30','12:55:00',2.98),('1444','2014-03-30','13:00:00',3.08),('1444','2014-03-30','13:05:00',3.11),('1444','2014-03-30','13:10:00',3.06),('1444','2014-03-30','13:15:00',3.08),('1444','2014-03-30','13:20:00',3.07),('1444','2014-03-30','13:25:00',3.06),('1444','2014-03-30','13:30:00',3.09),('1444','2014-03-30','13:35:00',3.08),('1444','2014-03-30','13:40:00',3.09),('1444','2014-03-30','13:45:00',3.07),('1444','2014-03-30','13:50:00',3),('1444','2014-03-30','13:55:00',2.93),('1444','2014-03-30','14:00:00',2.89),('1444','2014-03-30','14:05:00',2.86),('1444','2014-03-30','14:10:00',2.8),('1444','2014-03-30','14:15:00',2.82),('1444','2014-03-30','14:20:00',2.91),('1444','2014-03-30','14:25:00',2.92),('1444','2014-03-30','14:30:00',2.81),('1444','2014-03-30','14:35:00',2.54),('1444','2014-03-30','14:40:00',2.51),('1444','2014-03-30','14:45:00',2.18),('1444','2014-03-30','14:50:00',1.75),('1444','2014-03-30','14:55:00',1.12),('1444','2014-03-30','15:00:00',1.16),('1444','2014-03-30','15:05:00',1.37),('1444','2014-03-30','15:10:00',2.02),('1444','2014-03-30','15:15:00',2.24),('1444','2014-03-30','15:20:00',2.31),('1444','2014-03-30','15:25:00',2.37),('1444','2014-03-30','15:30:00',2.39),('1444','2014-03-30','15:35:00',2.37),('1444','2014-03-30','15:40:00',2.39),('1444','2014-03-30','15:45:00',2.36),('1444','2014-03-30','15:50:00',2.31),('1444','2014-03-30','15:55:00',2.25),('1444','2014-03-30','16:00:00',2.03),('1444','2014-03-30','16:05:00',2),('1444','2014-03-30','16:10:00',1.95),('1444','2014-03-30','16:15:00',2.13),('1444','2014-03-30','16:20:00',2.11),('1444','2014-03-30','16:25:00',2.04),('1444','2014-03-30','16:30:00',2.04),('1444','2014-03-30','16:35:00',1.98),('1444','2014-03-30','16:40:00',1.82),('1444','2014-03-30','16:45:00',1.62),('1444','2014-03-30','16:50:00',1.37),('1444','2014-03-30','16:55:00',1.34),('1444','2014-03-30','17:00:00',1.44),('1444','2014-03-30','17:05:00',1.53),('1444','2014-03-30','17:10:00',1.56),('1444','2014-03-30','17:15:00',1.5),('1444','2014-03-30','17:20:00',1.41),('1444','2014-03-30','17:25:00',1.26),('1444','2014-03-30','17:30:00',1.25),('1444','2014-03-30','17:35:00',1.17),('1444','2014-03-30','17:40:00',1.05),('1444','2014-03-30','17:45:00',1.01),('1444','2014-03-29','07:45:00',1.05),('1444','2014-03-29','07:50:00',1.12),('1444','2014-03-29','07:55:00',1.18),('1444','2014-03-29','08:00:00',1.25),('1444','2014-03-29','08:05:00',1.32),('1444','2014-03-29','08:10:00',1.39),('1444','2014-03-29','08:15:00',1.46),('1444','2014-03-29','08:20:00',1.51),('1444','2014-03-29','08:25:00',1.6),('1444','2014-03-29','08:30:00',1.64),('1444','2014-03-29','08:35:00',1.69),('1444','2014-03-29','08:40:00',1.75),('1444','2014-03-29','08:45:00',1.79),('1444','2014-03-29','08:50:00',1.85),('1444','2014-03-29','08:55:00',1.92),('1444','2014-03-29','09:00:00',1.95),('1444','2014-03-29','09:05:00',2.02),('1444','2014-03-29','09:10:00',2.09),('1444','2014-03-29','09:15:00',2.14),('1444','2014-03-29','09:20:00',2.19),('1444','2014-03-29','09:25:00',2.25),('1444','2014-03-29','09:30:00',2.28),('1444','2014-03-29','09:35:00',2.34),('1444','2014-03-29','09:40:00',2.4),('1444','2014-03-29','09:45:00',2.44),('1444','2014-03-29','09:50:00',2.49),('1444','2014-03-29','09:55:00',2.53),('1444','2014-03-29','10:00:00',2.55),('1444','2014-03-29','10:05:00',2.57),('1444','2014-03-29','10:10:00',2.63),('1444','2014-03-29','10:15:00',2.7),('1444','2014-03-29','10:20:00',2.72),('1444','2014-03-29','10:25:00',2.75),('1444','2014-03-29','10:30:00',2.79),('1444','2014-03-29','10:35:00',2.8),('1444','2014-03-29','10:40:00',2.84),('1444','2014-03-29','10:45:00',2.84),('1444','2014-03-29','10:50:00',2.9),('1444','2014-03-29','10:55:00',2.92),('1444','2014-03-29','11:00:00',2.94),('1444','2014-03-29','11:05:00',2.96),('1444','2014-03-29','11:10:00',2.96),('1444','2014-03-29','11:15:00',2.98),('1444','2014-03-29','11:20:00',2.99),('1444','2014-03-29','11:25:00',2.99),('1444','2014-03-29','11:30:00',2.99),('1444','2014-03-29','11:35:00',3),('1444','2014-03-29','11:40:00',2.91),('1444','2014-03-29','11:45:00',3.04),('1444','2014-03-29','11:50:00',3.05),('1444','2014-03-29','11:55:00',3.06),('1444','2014-03-29','12:00:00',3.05),('1444','2014-03-29','12:05:00',3.07),('1444','2014-03-29','12:10:00',3.06),('1444','2014-03-29','12:15:00',3.06),('1444','2014-03-29','12:20:00',3.05),('1444','2014-03-29','12:25:00',3.06),('1444','2014-03-29','12:30:00',3.08),('1444','2014-03-29','12:35:00',3.06),('1444','2014-03-29','12:40:00',3.02),('1444','2014-03-29','12:45:00',3.02),('1444','2014-03-29','12:50:00',3.01),('1444','2014-03-29','12:55:00',2.97),('1444','2014-03-29','13:00:00',2.92),('1444','2014-03-29','13:05:00',2.97),('1444','2014-03-29','13:10:00',2.93),('1444','2014-03-29','13:15:00',2.91),('1444','2014-03-29','13:20:00',2.91),('1444','2014-03-29','13:25:00',2.86),('1444','2014-03-29','13:30:00',2.81),('1444','2014-03-29','13:35:00',2.77),('1444','2014-03-29','13:40:00',2.75),('1444','2014-03-29','13:45:00',2.73),('1444','2014-03-29','13:50:00',2.68),('1444','2014-03-29','13:55:00',2.66),('1444','2014-03-29','14:00:00',2.65),('1444','2014-03-29','14:05:00',2.6),('1444','2014-03-29','14:10:00',2.57),('1444','2014-03-29','14:15:00',2.54),('1444','2014-03-29','14:20:00',2.48),('1444','2014-03-29','14:25:00',2.23),('1444','2014-03-29','14:30:00',2.39),('1444','2014-03-29','14:35:00',2.2),('1444','2014-03-29','14:40:00',2.01),('1444','2014-03-29','14:45:00',2.31),('1444','2014-03-29','14:50:00',2.26),('1444','2014-03-29','14:55:00',2.22),('1444','2014-03-29','15:00:00',2.19),('1444','2014-03-29','15:05:00',2.1),('1444','2014-03-29','15:10:00',2.04),('1444','2014-03-29','15:15:00',2.01),('1444','2014-03-29','15:20:00',1.96),('1444','2014-03-29','15:25:00',1.86),('1444','2014-03-29','15:30:00',1.75),('1444','2014-03-29','15:35:00',1.69),('1444','2014-03-29','15:40:00',1.66),('1444','2014-03-29','15:45:00',1.63),('1444','2014-03-29','15:50:00',1.57),('1444','2014-03-29','15:55:00',1.51),('1444','2014-03-29','16:00:00',1.47),('1444','2014-03-29','16:05:00',1.39),('1444','2014-03-29','16:10:00',1.31),('1444','2014-03-29','16:15:00',1.26),('1444','2014-03-29','16:20:00',1.14),('1444','2014-03-29','16:25:00',1.14),('1444','2014-03-29','16:30:00',1.08),('1444','2014-03-28','07:45:00',1.08),('1444','2014-03-28','07:50:00',1.16),('1444','2014-03-28','07:55:00',1.21),('1444','2014-03-28','08:00:00',1.27),('1444','2014-03-28','08:05:00',1.35),('1444','2014-03-28','08:10:00',1.43),('1444','2014-03-28','08:15:00',1.5),('1444','2014-03-28','08:20:00',1.57),('1444','2014-03-28','08:25:00',1.63),('1444','2014-03-28','08:30:00',1.69),('1444','2014-03-28','08:35:00',1.76),('1444','2014-03-28','08:40:00',1.83),('1444','2014-03-28','08:45:00',1.88),('1444','2014-03-28','08:50:00',1.95),('1444','2014-03-28','08:55:00',2.04),('1444','2014-03-28','09:00:00',2.1),('1444','2014-03-28','09:05:00',2.18),('1444','2014-03-28','09:10:00',2.28),('1444','2014-03-28','09:15:00',2.36),('1444','2014-03-28','09:20:00',2.22),('1444','2014-03-28','09:25:00',2.65),('1444','2014-03-28','09:30:00',2.65),('1444','2014-03-28','09:35:00',2.47),('1444','2014-03-28','09:40:00',1.53),('1444','2014-03-28','09:45:00',1.48),('1444','2014-03-28','09:50:00',1.88),('1444','2014-03-28','09:55:00',2.75),('1444','2014-03-28','10:00:00',2.66),('1444','2014-03-28','10:05:00',2.73),('1444','2014-03-28','10:10:00',2.76),('1444','2014-03-28','10:15:00',2.14),('1444','2014-03-28','10:20:00',1.78),('1444','2014-03-28','10:25:00',2.6),('1444','2014-03-28','10:30:00',2.81),('1444','2014-03-28','10:35:00',2.78),('1444','2014-03-28','10:40:00',2.68),('1444','2014-03-28','10:45:00',2.31),('1444','2014-03-28','10:50:00',2.97),('1444','2014-03-28','10:55:00',3.02),('1444','2014-03-28','11:00:00',3.02),('1444','2014-03-28','11:05:00',2.98),('1444','2014-03-28','11:10:00',2.4),('1444','2014-03-28','11:15:00',1.49),('1444','2014-03-28','11:25:00',1.93),('1444','2014-03-28','11:30:00',1.84),('1444','2014-03-28','11:35:00',1.27),('1444','2014-03-28','11:40:00',1.18),('1444','2014-03-28','11:45:00',2.03),('1444','2014-03-28','11:50:00',2.6),('1444','2014-03-28','11:55:00',1.09),('1444','2014-03-28','12:05:00',2.92),('1444','2014-03-28','12:10:00',3.41),('1444','2014-03-28','12:15:00',3.52),('1444','2014-03-28','12:20:00',3.62),('1444','2014-03-28','12:25:00',1.85),('1444','2014-03-28','12:35:00',1.4),('1444','2014-03-28','12:40:00',1.75),('1444','2014-03-28','12:45:00',3.36),('1444','2014-03-28','12:50:00',2.86),('1444','2014-03-28','12:55:00',3.16),('1444','2014-03-28','13:00:00',3.04),('1444','2014-03-28','13:05:00',2.89),('1444','2014-03-28','13:10:00',2.52),('1444','2014-03-28','13:15:00',1.54),('1444','2014-03-28','13:20:00',2.03),('1444','2014-03-28','13:25:00',1.51),('1444','2014-03-28','13:30:00',1.33),('1444','2014-03-28','13:35:00',2.68),('1444','2014-03-28','13:40:00',3.06),('1444','2014-03-28','13:45:00',3.02),('1444','2014-03-28','13:50:00',2.9),('1444','2014-03-28','13:55:00',2.83),('1444','2014-03-28','14:00:00',2.81),('1444','2014-03-28','14:05:00',2.76),('1444','2014-03-28','14:10:00',2.73),('1444','2014-03-28','14:15:00',2.68),('1444','2014-03-28','14:20:00',2.63),('1444','2014-03-28','14:25:00',2.6),('1444','2014-03-28','14:30:00',2.56),('1444','2014-03-28','14:35:00',2.52),('1444','2014-03-28','14:40:00',2.5),('1444','2014-03-28','14:45:00',2.45),('1444','2014-03-28','14:50:00',2.41),('1444','2014-03-28','14:55:00',2.37),('1444','2014-03-28','15:00:00',2.33),('1444','2014-03-28','15:05:00',2.28),('1444','2014-03-28','15:10:00',2.2),('1444','2014-03-28','15:15:00',2.15),('1444','2014-03-28','15:20:00',2.09),('1444','2014-03-28','15:25:00',2.03),('1444','2014-03-28','15:30:00',1.97),('1444','2014-03-28','15:35:00',1.92),('1444','2014-03-28','15:40:00',1.86),('1444','2014-03-28','15:45:00',1.84),('1444','2014-03-28','15:50:00',1.82),('1444','2014-03-28','15:55:00',1.65),('1444','2014-03-28','16:00:00',1.76),('1444','2014-03-28','16:05:00',1.83),('1444','2014-03-28','16:10:00',1.76),('1444','2014-03-28','16:15:00',1.68),('1444','2014-03-28','16:20:00',1.44),('1444','2014-03-28','16:25:00',1.27),('1444','2014-03-28','16:30:00',1.21),('1444','2014-05-02','08:00:00',1.08),('1444','2014-05-02','08:05:00',1.01),('1444','2014-05-02','08:15:00',1.56),('1444','2014-05-02','08:20:00',1.17),('1444','2014-05-02','08:45:00',1.42),('1444','2014-05-02','08:50:00',1.11),('1444','2014-05-02','09:20:00',1.21),('1444','2014-05-02','09:25:00',1.55),('1444','2014-05-02','09:30:00',1.65),('1444','2014-05-02','09:35:00',1.52),('1444','2014-05-02','09:40:00',1.47),('1444','2014-05-02','09:45:00',1.26),('1444','2014-05-02','09:50:00',1.33),('1444','2014-05-02','09:55:00',1.24),('1444','2014-05-02','10:00:00',1.43),('1444','2014-05-02','10:05:00',1.67),('1444','2014-05-02','10:10:00',1.47),('1444','2014-05-02','10:15:00',1.35),('1444','2014-05-02','10:20:00',1.13),('1444','2014-05-02','12:45:00',1.26),('1444','2014-05-02','12:50:00',1.52),('1444','2014-05-02','12:55:00',1.19),('1444','2014-05-02','13:00:00',1.34),('1444','2014-05-02','13:05:00',1.59),('1444','2014-05-02','13:10:00',1.5),('1444','2014-05-02','13:15:00',2.14),('1444','2014-05-02','13:20:00',2.52),('1444','2014-05-02','13:25:00',2.83),('1444','2014-05-02','13:30:00',1.92),('1444','2014-05-02','13:35:00',1.88),('1444','2014-05-02','13:40:00',1.93),('1444','2014-05-02','13:45:00',1.59),('1444','2014-05-02','13:50:00',1.31),('1444','2014-05-02','13:55:00',1.03),('1444','2014-05-02','14:00:00',1.27),('1444','2014-05-02','14:05:00',2.09),('1444','2014-05-02','14:30:00',1.01),('1444','2014-05-02','14:35:00',1.48),('1444','2014-05-02','14:40:00',2.25),('1444','2014-05-02','14:45:00',1.18),('1444','2014-05-02','14:50:00',1.15),('1444','2014-05-02','14:55:00',1.62),('1444','2014-05-02','15:00:00',1.95),('1444','2014-05-02','15:05:00',1.52),('1444','2014-05-02','15:10:00',2.7),('1444','2014-05-02','15:15:00',1.81),('1444','2014-05-02','15:20:00',2.03),('1444','2014-05-02','15:25:00',1.09),('1444','2014-05-02','15:30:00',1.11),('1444','2014-05-02','15:35:00',2.57),('1444','2014-05-02','15:40:00',2.52),('1444','2014-05-02','15:45:00',1.01),('1444','2014-05-02','16:00:00',1.18),('1444','2014-05-02','16:05:00',1.28),('1444','2014-05-02','16:15:00',1.2),('1444','2014-05-02','16:20:00',1.64),('1444','2014-03-27','08:00:00',1.18),('1444','2014-03-27','08:05:00',1.13),('1444','2014-03-27','10:20:00',1.33),('1444','2014-03-27','10:25:00',1.6),('1444','2014-03-27','10:30:00',1.63),('1444','2014-03-27','10:35:00',1.55),('1444','2014-03-27','10:40:00',1.63),('1444','2014-03-27','11:10:00',2.68),('1444','2014-03-27','11:15:00',1.56),('1444','2014-03-27','11:55:00',1.12),('1444','2014-03-27','13:10:00',1.34),('1444','2014-03-27','13:15:00',1.75),('1444','2014-03-27','13:20:00',1.86),('1444','2014-03-27','13:25:00',1.86),('1444','2014-03-27','13:30:00',1.58),('1444','2014-03-27','13:35:00',1.49),('1444','2014-03-27','13:40:00',1.4),('1444','2014-03-27','13:45:00',1.33),('1444','2014-03-27','13:50:00',1.79),('1444','2014-03-27','13:55:00',2.07),('1444','2014-03-27','14:00:00',1.54),('1444','2014-03-27','14:15:00',2.23),('1444','2014-03-27','14:20:00',2.77),('1444','2014-03-27','14:25:00',2.96),('1444','2014-03-27','14:30:00',2.6),('1444','2014-03-27','14:35:00',1.69),('1444','2014-03-27','14:40:00',1.44),('1444','2014-03-27','14:45:00',1.38),('1444','2014-03-27','14:50:00',1.73),('1444','2014-03-27','14:55:00',1.48),('1444','2014-03-27','15:00:00',2.62),('1444','2014-03-27','15:05:00',1.01),('1444','2014-03-27','15:25:00',2.39),('1444','2014-03-27','15:30:00',1.85),('1444','2014-03-27','15:35:00',2.15),('1444','2014-03-26','07:45:00',1.03),('1444','2014-03-26','07:50:00',1.1),('1444','2014-03-26','07:55:00',1.17),('1444','2014-03-26','08:00:00',1.23),('1444','2014-03-26','08:05:00',1.32),('1444','2014-03-26','08:10:00',1.41),('1444','2014-03-26','08:15:00',1.61),('1444','2014-03-26','08:20:00',1.18),('1444','2014-03-26','08:50:00',1.08),('1444','2014-03-26','09:00:00',1.1),('1444','2014-03-26','09:05:00',1.01),('1444','2014-03-26','09:10:00',1.2),('1444','2014-03-26','09:15:00',1),('1444','2014-03-26','09:25:00',1.96),('1444','2014-03-26','09:30:00',2.4),('1444','2014-03-26','09:35:00',2.4),('1444','2014-03-26','09:40:00',2.42),('1444','2014-03-26','09:45:00',2.48),('1444','2014-03-26','09:50:00',2.51),('1444','2014-03-26','09:55:00',2.54),('1444','2014-03-26','10:00:00',2.62),('1444','2014-03-26','10:05:00',1.76),('1444','2014-03-26','10:10:00',3.03),('1444','2014-03-26','10:15:00',2.39),('1444','2014-03-26','10:20:00',1.78),('1444','2014-03-26','10:25:00',3.07),('1444','2014-03-26','10:30:00',1.69),('1444','2014-03-26','10:45:00',1.4),('1444','2014-03-26','10:50:00',2.23),('1444','2014-03-26','10:55:00',3.59),('1444','2014-03-26','11:00:00',2.43),('1444','2014-03-26','11:05:00',1.39),('1444','2014-03-26','11:10:00',3.48),('1444','2014-03-26','11:15:00',3.86),('1444','2014-03-26','11:20:00',1.26),('1444','2014-03-26','11:30:00',1.34),('1444','2014-03-26','11:35:00',1.35),('1444','2014-03-26','11:40:00',1.47),('1444','2014-03-26','11:45:00',3.12),('1444','2014-03-26','11:50:00',2.66),('1444','2014-03-26','11:55:00',3.7),('1444','2014-03-26','12:00:00',3.09),('1444','2014-03-26','12:05:00',2.73),('1444','2014-03-26','12:10:00',2.63),('1444','2014-03-26','12:15:00',1.34),('1444','2014-03-26','12:20:00',1.5),('1444','2014-03-26','12:25:00',1.37),('1444','2014-03-26','12:30:00',1.36),('1444','2014-03-26','12:35:00',1.3),('1444','2014-03-26','12:40:00',1.69),('1444','2014-03-26','12:45:00',1.56),('1444','2014-03-26','12:50:00',1.2),('1444','2014-03-26','13:00:00',1.05),('1444','2014-03-26','13:20:00',2.97),('1444','2014-03-26','13:25:00',3.38),('1444','2014-03-26','13:30:00',2.44),('1444','2014-03-26','13:35:00',1.68),('1444','2014-03-26','13:55:00',1.61),('1444','2014-03-26','14:00:00',3.63),('1444','2014-03-26','14:05:00',3.55),('1444','2014-03-26','14:10:00',1.19),('1444','2014-03-26','14:45:00',2.07),('1444','2014-03-26','14:50:00',2.32),('1444','2014-03-26','14:55:00',2.58),('1444','2014-03-26','15:00:00',2.18),('1444','2014-03-26','15:05:00',2.27),('1444','2014-03-26','15:10:00',2.35),('1444','2014-03-26','15:15:00',2.47),('1444','2014-03-26','15:20:00',2.2),('1444','2014-03-26','15:25:00',2.3),('1444','2014-03-26','15:30:00',2.29),('1444','2014-03-26','15:35:00',2.13),('1444','2014-03-26','15:40:00',1.78),('1444','2014-03-26','15:45:00',1.63),('1444','2014-03-26','15:50:00',1.22),('1444','2014-03-26','15:55:00',1.11),('1444','2014-03-26','16:10:00',1.02),('1444','2014-03-26','16:15:00',1.08),('1444','2014-03-25','07:25:00',1.03),('1444','2014-03-25','07:30:00',1.06),('1444','2014-03-25','08:10:00',1.06),('1444','2014-03-25','08:15:00',1.11),('1444','2014-03-25','08:20:00',1.02),('1444','2014-03-25','08:40:00',1.04),('1444','2014-03-25','08:45:00',1.38),('1444','2014-03-25','08:50:00',1.49),('1444','2014-03-25','08:55:00',1.57),('1444','2014-03-25','09:00:00',1.43),('1444','2014-03-25','09:05:00',1.41),('1444','2014-03-25','09:10:00',1.39),('1444','2014-03-25','09:15:00',1.78),('1444','2014-03-25','09:20:00',1.95),('1444','2014-03-25','09:25:00',1.68),('1444','2014-03-25','09:30:00',1.52),('1444','2014-03-25','09:35:00',1.44),('1444','2014-03-25','09:40:00',1.44),('1444','2014-03-25','09:45:00',1.35),('1444','2014-03-25','09:50:00',1.41),('1444','2014-03-25','09:55:00',1.59),('1444','2014-03-25','10:00:00',1.78),('1444','2014-03-25','10:05:00',1.93),('1444','2014-03-25','10:10:00',2),('1444','2014-03-25','10:15:00',2.18),('1444','2014-03-25','10:20:00',2.14),('1444','2014-03-25','10:25:00',2.08),('1444','2014-03-25','10:30:00',2.27),('1444','2014-03-25','10:35:00',1.91),('1444','2014-03-25','10:40:00',1.63),('1444','2014-03-25','10:45:00',1.52),('1444','2014-03-25','10:50:00',1.49),('1444','2014-03-25','10:55:00',1.49),('1444','2014-03-25','11:00:00',1.6),('1444','2014-03-25','11:05:00',1.78),('1444','2014-03-25','11:10:00',1.95),('1444','2014-03-25','11:15:00',2.17),('1444','2014-03-25','11:20:00',2.17),('1444','2014-03-25','11:25:00',1.84),('1444','2014-03-25','11:30:00',2.24),('1444','2014-03-25','11:35:00',1.95),('1444','2014-03-25','11:40:00',2.17),('1444','2014-03-25','11:45:00',1.44),('1444','2014-03-25','11:50:00',1.73),('1444','2014-03-25','11:55:00',1.28),('1444','2014-03-24','08:55:00',1.27),('1444','2014-03-24','09:00:00',1.39),('1444','2014-03-24','09:20:00',1.06),('1444','2014-03-24','09:40:00',1.21),('1444','2014-03-24','10:00:00',1.69),('1444','2014-03-24','10:05:00',1.89),('1444','2014-03-24','10:10:00',2.65),('1444','2014-03-24','10:15:00',1.55),('1444','2014-03-24','10:35:00',1.18),('1444','2014-03-24','10:45:00',1.71),('1444','2014-03-24','10:50:00',3.39),('1444','2014-03-24','10:55:00',2.41),('1444','2014-03-24','11:00:00',1.4),('1444','2014-03-24','11:05:00',1.77),('1444','2014-03-24','11:10:00',2.1),('1444','2014-03-24','11:15:00',2.57),('1444','2014-03-24','11:20:00',1.96),('1444','2014-03-24','11:25:00',2.5),('1444','2014-03-24','11:30:00',2.56),('1444','2014-03-24','11:35:00',1.15),('1444','2014-03-24','12:35:00',1.56),('1444','2014-03-24','12:40:00',1.54),('1444','2014-03-24','12:45:00',1.39),('1444','2014-03-24','12:50:00',1.17),('1444','2014-03-24','12:55:00',1.12),('1444','2014-03-24','13:00:00',1.14),('1444','2014-03-24','13:05:00',1.12),('1444','2014-03-24','13:30:00',1.1),('1444','2014-03-24','13:50:00',1.08),('1444','2014-03-24','13:55:00',1.05),('1444','2014-03-24','14:10:00',1.03),('1444','2014-03-24','14:15:00',1.36),('1444','2014-03-24','14:20:00',1.71),('1444','2014-03-24','14:25:00',1.62),('1444','2014-03-24','14:30:00',1.57),('1444','2014-03-24','14:35:00',1.88),('1444','2014-03-24','14:40:00',2.26),('1444','2014-03-24','14:45:00',2.49),('1444','2014-03-24','14:50:00',2.44),('1444','2014-03-24','14:55:00',2.16),('1444','2014-03-24','15:00:00',1.99),('1444','2014-03-24','15:05:00',1.77),('1444','2014-03-24','15:10:00',1.58),('1444','2014-03-24','15:15:00',1.34),('1444','2014-03-24','15:20:00',1.3),('1444','2014-03-24','15:25:00',1.26),('1444','2014-03-24','15:30:00',1.22),('1444','2014-03-24','15:35:00',1.16),('1444','2014-03-24','15:50:00',1.03),('1444','2014-03-24','15:55:00',1.38),('1444','2014-03-24','16:00:00',1.84),('1444','2014-03-24','16:05:00',1.07),('1444','2014-03-23','08:55:00',1.12),('1444','2014-03-23','09:05:00',1.32),('1444','2014-03-23','09:10:00',2.01),('1444','2014-03-23','09:15:00',1.86),('1444','2014-03-23','09:20:00',1.3),('1444','2014-03-23','09:30:00',1.11),('1444','2014-03-23','09:35:00',1.15),('1444','2014-03-23','10:40:00',1.01),('1444','2014-03-23','10:50:00',1.11),('1444','2014-03-23','10:55:00',1.34),('1444','2014-03-23','11:10:00',1.12),('1444','2014-03-23','11:35:00',1.3),('1444','2014-03-23','11:40:00',2.43),('1444','2014-03-23','13:45:00',1.66),('1444','2014-03-23','13:50:00',1.25),('1444','2014-03-23','15:10:00',1.16),('1444','2014-03-23','15:15:00',1.17),('1444','2014-03-23','15:20:00',1.24),('1444','2014-03-23','15:25:00',1.2),('1444','2014-03-22','08:15:00',1.02),('1444','2014-03-22','08:20:00',1.19),('1444','2014-03-22','08:25:00',1.22),('1444','2014-03-22','08:30:00',1.13),('1444','2014-03-22','08:40:00',1.5),('1444','2014-03-22','08:45:00',1.59),('1444','2014-03-22','08:50:00',1.28),('1444','2014-03-22','08:55:00',1.77),('1444','2014-03-22','09:00:00',1.46),('1444','2014-03-22','09:05:00',1.01),('1444','2014-03-22','09:10:00',1.19),('1444','2014-03-22','09:20:00',1.06),('1444','2014-03-22','09:25:00',1.58),('1444','2014-03-22','09:30:00',1.44),('1444','2014-03-22','09:40:00',1.76),('1444','2014-03-22','09:45:00',2.17),('1444','2014-03-22','09:50:00',2.22),('1444','2014-03-22','09:55:00',2.19),('1444','2014-03-22','10:00:00',1.97),('1444','2014-03-22','10:05:00',1.46),('1444','2014-03-22','10:10:00',1.86),('1444','2014-03-22','10:15:00',1.42),('1444','2014-03-22','10:35:00',1.25),('1444','2014-03-22','10:40:00',1.48),('1444','2014-03-22','10:45:00',1.82),('1444','2014-03-22','10:50:00',1.34),('1444','2014-03-22','11:10:00',1.14),('1444','2014-03-22','11:15:00',1.46),('1444','2014-03-22','11:20:00',2.88),('1444','2014-03-22','11:25:00',3.26),('1444','2014-03-22','11:30:00',2),('1444','2014-03-22','11:35:00',2.05),('1444','2014-03-22','11:40:00',1.37),('1444','2014-03-22','11:45:00',1.14),('1444','2014-03-22','11:50:00',2.55),('1444','2014-03-22','11:55:00',2.92),('1444','2014-03-22','12:00:00',1.3),('1444','2014-03-22','12:05:00',1.03),('1444','2014-03-22','12:10:00',1.12),('1444','2014-03-22','12:15:00',2.54),('1444','2014-03-22','12:20:00',2.6),('1444','2014-03-22','12:25:00',1.13),('1444','2014-03-22','12:30:00',1.46),('1444','2014-03-22','12:35:00',1.57),('1444','2014-03-22','12:40:00',3.12),('1444','2014-03-22','12:45:00',2.3),('1444','2014-03-22','12:50:00',2),('1444','2014-03-22','12:55:00',1.76),('1444','2014-03-22','13:00:00',1.22),('1444','2014-03-22','13:05:00',2.74),('1444','2014-03-22','13:10:00',2.76),('1444','2014-03-22','13:15:00',2.95),('1444','2014-03-22','13:20:00',2.49),('1444','2014-03-22','13:25:00',2.07),('1444','2014-03-22','13:30:00',2.33),('1444','2014-03-22','13:35:00',2.23),('1444','2014-03-22','13:40:00',2.96),('1444','2014-03-22','13:45:00',2.43),('1444','2014-03-22','13:50:00',1.54),('1444','2014-03-22','13:55:00',2.36),('1444','2014-03-22','14:00:00',1.9),('1444','2014-03-22','14:05:00',2.04),('1444','2014-03-22','14:10:00',2.12),('1444','2014-03-22','14:15:00',1.68),('1444','2014-03-22','14:20:00',2.44),('1444','2014-03-22','14:25:00',2.33),('1444','2014-03-22','14:30:00',2.28),('1444','2014-03-22','14:35:00',2.23),('1444','2014-03-22','14:40:00',2.17),('1444','2014-03-22','14:45:00',2.12),('1444','2014-03-22','14:50:00',2.08),('1444','2014-03-22','14:55:00',2.02),('1444','2014-03-22','15:00:00',1.95),('1444','2014-03-22','15:05:00',1.8),('1444','2014-03-22','15:10:00',1.77),('1444','2014-03-22','15:15:00',1.82),('1444','2014-03-22','15:20:00',1.77),('1444','2014-03-22','15:25:00',1.36),('1444','2014-03-22','15:35:00',1.64),('1444','2014-03-22','15:40:00',1.79),('1444','2014-03-22','15:45:00',1.88),('1444','2014-03-22','15:50:00',1.92),('1444','2014-03-22','15:55:00',1.68),('1444','2014-03-22','16:00:00',1.55),('1444','2014-03-22','16:05:00',1.35),('1444','2014-03-22','16:10:00',1.21),('1444','2014-03-22','16:15:00',1.08),('1444','2014-03-22','16:20:00',1.16),('1444','2014-03-21','08:05:00',1.04),('1444','2014-03-21','08:10:00',1.1),('1444','2014-03-21','08:15:00',1.15),('1444','2014-03-21','08:20:00',1.19),('1444','2014-03-21','08:25:00',1.25),('1444','2014-03-21','08:30:00',1.34),('1444','2014-03-21','08:35:00',1.41),('1444','2014-03-21','08:40:00',1.47),('1444','2014-03-21','08:45:00',1.5),('1444','2014-03-21','08:50:00',1.55),('1444','2014-03-21','08:55:00',1.62),('1444','2014-03-21','09:00:00',1.68),('1444','2014-03-21','09:05:00',1.72),('1444','2014-03-21','09:10:00',1.8),('1444','2014-03-21','09:15:00',1.85),('1444','2014-03-21','09:20:00',1.93),('1444','2014-03-21','09:25:00',1.88),('1444','2014-03-21','09:30:00',1.99),('1444','2014-03-21','09:35:00',2.03),('1444','2014-03-21','09:40:00',2.1),('1444','2014-03-21','09:45:00',2.13),('1444','2014-03-21','09:50:00',2.17),('1444','2014-03-21','09:55:00',2.18),('1444','2014-03-21','10:00:00',2.25),('1444','2014-03-21','10:05:00',2.29),('1444','2014-03-21','10:10:00',2.31),('1444','2014-03-21','10:15:00',2.34),('1444','2014-03-21','10:20:00',2.33),('1444','2014-03-21','10:25:00',2.41),('1444','2014-03-21','10:30:00',2.44),('1444','2014-03-21','10:35:00',2.45),('1444','2014-03-21','10:40:00',2.42),('1444','2014-03-21','10:45:00',2.44),('1444','2014-03-21','10:50:00',2.47),('1444','2014-03-21','10:55:00',2.48),('1444','2014-03-21','11:00:00',2.52),('1444','2014-03-21','11:05:00',2.51),('1444','2014-03-21','11:10:00',2.55),('1444','2014-03-21','11:15:00',2.58),('1444','2014-03-21','11:20:00',2.61),('1444','2014-03-21','11:25:00',2.62),('1444','2014-03-21','11:30:00',2.67),('1444','2014-03-21','11:35:00',2.03),('1444','2014-03-21','11:40:00',2.51),('1444','2014-03-21','11:45:00',2.84),('1444','2014-03-21','11:50:00',2.76),('1444','2014-03-21','11:55:00',2.47),('1444','2014-03-21','12:00:00',2.56),('1444','2014-03-21','12:05:00',2.8),('1444','2014-03-21','12:10:00',2.82),('1444','2014-03-21','12:15:00',2.81),('1444','2014-03-21','12:20:00',2.77),('1444','2014-03-21','12:25:00',2.73),('1444','2014-03-21','12:30:00',2.74),('1444','2014-03-21','12:35:00',2.74),('1444','2014-03-21','12:40:00',2.76),('1444','2014-03-21','12:45:00',2.78),('1444','2014-03-21','12:50:00',2.73),('1444','2014-03-21','12:55:00',2.67),('1444','2014-03-21','13:00:00',2.71),('1444','2014-03-21','13:05:00',2.67),('1444','2014-03-21','13:10:00',2.69),('1444','2014-03-21','13:15:00',2.67),('1444','2014-03-21','13:20:00',2.64),('1444','2014-03-21','13:25:00',2.62),('1444','2014-03-21','13:30:00',2.61),('1444','2014-03-21','13:35:00',2.58),('1444','2014-03-21','13:40:00',2.52),('1444','2014-03-21','13:45:00',2.46),('1444','2014-03-21','13:50:00',2.43),('1444','2014-03-21','13:55:00',2.39),('1444','2014-03-21','14:00:00',2.45),('1444','2014-03-21','14:05:00',2.43),('1444','2014-03-21','14:10:00',2.41),('1444','2014-03-21','14:15:00',2.37),('1444','2014-03-21','14:20:00',2.31),('1444','2014-03-21','14:25:00',2.27),('1444','2014-03-21','14:30:00',2.2),('1444','2014-03-21','14:35:00',2.11),('1444','2014-03-21','14:40:00',2.11),('1444','2014-03-21','14:45:00',1.99),('1444','2014-03-21','14:50:00',1.64),('1444','2014-03-21','15:05:00',1.48),('1444','2014-03-21','15:10:00',2.22),('1444','2014-03-21','15:15:00',2.17),('1444','2014-03-21','15:20:00',1.81),('1444','2014-03-21','15:25:00',2.19),('1444','2014-03-21','15:30:00',2.03),('1444','2014-03-21','15:35:00',1.91),('1444','2014-03-21','15:40:00',1.92),('1444','2014-03-21','15:45:00',1.9),('1444','2014-03-21','15:50:00',1.81),('1444','2014-03-21','15:55:00',1.77),('1444','2014-03-21','16:00:00',1.63),('1444','2014-03-21','16:05:00',1.53),('1444','2014-03-21','16:10:00',1.4),('1444','2014-03-21','16:15:00',1.28),('1444','2014-03-21','16:20:00',1.16),('1444','2014-03-21','16:25:00',1.06),('1444','2014-03-20','08:00:00',1.04),('1444','2014-03-20','08:05:00',1.09),('1444','2014-03-20','08:10:00',1.13),('1444','2014-03-20','08:15:00',1.17),('1444','2014-03-20','08:20:00',1.2),('1444','2014-03-20','08:25:00',1.26),('1444','2014-03-20','08:30:00',1.34),('1444','2014-03-20','08:35:00',1.42),('1444','2014-03-20','08:40:00',1.5),('1444','2014-03-20','08:45:00',1.57),('1444','2014-03-20','08:50:00',1.61),('1444','2014-03-20','08:55:00',1.66),('1444','2014-03-20','09:00:00',1.69),('1444','2014-03-20','09:05:00',1.76),('1444','2014-03-20','09:10:00',1.83),('1444','2014-03-20','09:15:00',1.86),('1444','2014-03-20','09:20:00',1.92),('1444','2014-03-20','09:25:00',1.94),('1444','2014-03-20','09:30:00',1.98),('1444','2014-03-20','09:35:00',2.05),('1444','2014-03-20','09:40:00',2.06),('1444','2014-03-20','09:45:00',2.08),('1444','2014-03-20','09:50:00',2.09),('1444','2014-03-20','09:55:00',2.13),('1444','2014-03-20','10:00:00',2.24),('1444','2014-03-20','10:05:00',2.33),('1444','2014-03-20','10:10:00',2.33),('1444','2014-03-20','10:15:00',2.33),('1444','2014-03-20','10:20:00',2.37),('1444','2014-03-20','10:25:00',2.39),('1444','2014-03-20','10:30:00',2.42),('1444','2014-03-20','10:35:00',2.34),('1444','2014-03-20','10:40:00',2.3),('1444','2014-03-20','10:45:00',2.33),('1444','2014-03-20','10:50:00',2.5),('1444','2014-03-20','10:55:00',2.62),('1444','2014-03-20','11:00:00',2.66),('1444','2014-03-20','11:05:00',2.64),('1444','2014-03-20','11:10:00',2.61),('1444','2014-03-20','11:15:00',2.49),('1444','2014-03-20','11:20:00',2.6),('1444','2014-03-20','11:25:00',2.61),('1444','2014-03-20','11:30:00',2.71),('1444','2014-03-20','11:35:00',2.77),('1444','2014-03-20','11:40:00',2.74),('1444','2014-03-20','11:45:00',2.72),('1444','2014-03-20','11:50:00',2.77),('1444','2014-03-20','11:55:00',2.5),('1444','2014-03-20','12:00:00',2.43),('1444','2014-03-20','12:05:00',2.64),('1444','2014-03-20','12:10:00',2.74),('1444','2014-03-20','12:15:00',2.71),('1444','2014-03-20','12:20:00',2.66),('1444','2014-03-20','12:25:00',2.59),('1444','2014-03-20','12:30:00',2.65),('1444','2014-03-20','12:35:00',2.71),('1444','2014-03-20','12:40:00',2.72),('1444','2014-03-20','12:45:00',2.77),('1444','2014-03-20','12:50:00',2.72),('1444','2014-03-20','12:55:00',2.7),('1444','2014-03-20','13:00:00',2.68),('1444','2014-03-20','13:05:00',2.65),('1444','2014-03-20','13:10:00',2.63),('1444','2014-03-20','13:15:00',2.58),('1444','2014-03-20','13:20:00',2.58),('1444','2014-03-20','13:25:00',2.49),('1444','2014-03-20','13:30:00',2.56),('1444','2014-03-20','13:35:00',2.44),('1444','2014-03-20','13:40:00',2.34),('1444','2014-03-20','13:45:00',2.26),('1444','2014-03-20','13:50:00',2.16),('1444','2014-03-20','13:55:00',1.97),('1444','2014-03-20','14:00:00',2.14),('1444','2014-03-20','14:05:00',2.35),('1444','2014-03-20','14:10:00',2.22),('1444','2014-03-20','14:15:00',2.1),('1444','2014-03-20','14:20:00',2.04),('1444','2014-03-20','14:25:00',2.01),('1444','2014-03-20','14:30:00',1.69),('1444','2014-03-20','14:35:00',1.64),('1444','2014-03-20','14:40:00',1.8),('1444','2014-03-20','14:45:00',1.73),('1444','2014-03-20','14:50:00',1.65),('1444','2014-03-20','14:55:00',1.58),('1444','2014-03-20','15:00:00',1.47),('1444','2014-03-20','15:05:00',1.48),('1444','2014-03-20','15:10:00',1.49),('1444','2014-03-20','15:15:00',1.44),('1444','2014-03-20','15:20:00',1.52),('1444','2014-03-20','15:25:00',1.39),('1444','2014-03-20','15:30:00',1.33),('1444','2014-03-20','15:35:00',1.24),('1444','2014-03-20','15:40:00',1.16),('1444','2014-03-20','15:45:00',1.17),('1444','2014-03-20','15:50:00',1.01),('1444','2014-03-19','09:10:00',1.12),('1444','2014-03-19','09:15:00',1.19),('1444','2014-03-19','09:20:00',1.22),('1444','2014-03-19','09:25:00',2.32),('1444','2014-03-19','09:30:00',2.18),('1444','2014-03-19','09:35:00',2.53),('1444','2014-03-19','09:40:00',2.24),('1444','2014-03-19','09:45:00',1.84),('1444','2014-03-19','09:50:00',1.79),('1444','2014-03-19','09:55:00',1.19),('1444','2014-03-19','10:30:00',1.34),('1444','2014-03-19','10:35:00',1.79),('1444','2014-03-19','10:40:00',1.2),('1444','2014-03-19','10:45:00',1.13),('1444','2014-03-19','10:50:00',1.08),('1444','2014-03-19','10:55:00',1.26),('1444','2014-03-19','11:00:00',3.07),('1444','2014-03-19','11:05:00',3),('1444','2014-03-19','11:10:00',1.49),('1444','2014-03-19','11:15:00',1.5),('1444','2014-03-19','11:20:00',1.3),('1444','2014-03-19','11:25:00',1.46),('1444','2014-03-19','11:30:00',1.85),('1444','2014-03-19','11:35:00',2.5),('1444','2014-03-19','11:40:00',1.54),('1444','2014-03-19','11:45:00',1.44),('1444','2014-03-19','11:50:00',1.32),('1444','2014-03-19','11:55:00',1.27),('1444','2014-03-19','12:00:00',1.79),('1444','2014-03-19','12:05:00',1.51),('1444','2014-03-19','12:10:00',2.2),('1444','2014-03-19','12:15:00',1.24),('1444','2014-03-19','12:20:00',2.17),('1444','2014-03-19','12:25:00',2.93),('1444','2014-03-19','12:30:00',2.65),('1444','2014-03-19','12:35:00',1.97),('1444','2014-03-19','12:40:00',2.93),('1444','2014-03-19','12:45:00',1.61),('1444','2014-03-19','12:50:00',1.83),('1444','2014-03-19','12:55:00',2.93),('1444','2014-03-19','13:00:00',2.69),('1444','2014-03-19','13:05:00',2.65),('1444','2014-03-19','13:10:00',2.62),('1444','2014-03-19','13:15:00',2.12),('1444','2014-03-19','13:20:00',2.47),('1444','2014-03-19','13:25:00',2.28),('1444','2014-03-19','13:30:00',2.54),('1444','2014-03-19','13:35:00',2.53),('1444','2014-03-19','13:40:00',2.5),('1444','2014-03-19','13:45:00',2.49),('1444','2014-03-19','13:50:00',2.38),('1444','2014-03-19','13:55:00',2.47),('1444','2014-03-19','14:00:00',2.27),('1444','2014-03-19','14:05:00',2.43),('1444','2014-03-19','14:10:00',2.38),('1444','2014-03-19','14:15:00',2.31),('1444','2014-03-19','14:20:00',2.29),('1444','2014-03-19','14:25:00',2.25),('1444','2014-03-19','14:30:00',2.16),('1444','2014-03-19','14:35:00',2.2),('1444','2014-03-19','14:40:00',2.14),('1444','2014-03-19','14:45:00',2.08),('1444','2014-03-19','14:50:00',1.98),('1444','2014-03-19','14:55:00',1.92),('1444','2014-03-19','15:00:00',1.87),('1444','2014-03-19','15:05:00',1.83),('1444','2014-03-19','15:10:00',1.79),('1444','2014-03-19','15:15:00',1.73),('1444','2014-03-19','15:20:00',1.69),('1444','2014-03-19','15:25:00',1.7),('1444','2014-03-19','15:30:00',1.63),('1444','2014-03-19','15:35:00',1.53),('1444','2014-03-19','15:40:00',1.52),('1444','2014-03-19','15:45:00',1.46),('1444','2014-03-19','15:50:00',1.4),('1444','2014-03-19','15:55:00',1.37),('1444','2014-03-19','16:00:00',1.3),('1444','2014-03-19','16:05:00',1.24),('1444','2014-03-19','16:10:00',1.18),('1444','2014-03-19','16:15:00',1.13),('1444','2014-03-19','16:20:00',1.04),('1444','2014-03-18','08:15:00',1.03),('1444','2014-03-18','08:50:00',1.89),('1444','2014-03-18','08:55:00',1.86),('1444','2014-03-18','09:00:00',1.52),('1444','2014-03-18','09:05:00',1.31),('1444','2014-03-18','09:10:00',1.92),('1444','2014-03-18','09:15:00',1.35),('1444','2014-03-18','09:20:00',1.49),('1444','2014-03-18','09:25:00',1.05),('1444','2014-03-18','09:30:00',1.66),('1444','2014-03-18','09:40:00',1.06),('1444','2014-03-18','09:45:00',1.48),('1444','2014-03-18','09:50:00',1.03),('1444','2014-03-18','10:00:00',2.35),('1444','2014-03-18','10:05:00',2.35),('1444','2014-03-18','10:10:00',1.87),('1444','2014-03-18','10:15:00',2.27),('1444','2014-03-18','10:20:00',2.65),('1444','2014-03-18','10:25:00',2.94),('1444','2014-03-18','10:30:00',2.52),('1444','2014-03-18','10:35:00',1.86),('1444','2014-03-18','10:40:00',1.61),('1444','2014-03-18','10:45:00',2),('1444','2014-03-18','10:50:00',2.75),('1444','2014-03-18','10:55:00',1.7),('1444','2014-03-18','11:00:00',1.47),('1444','2014-03-18','11:05:00',2.48),('1444','2014-03-18','11:10:00',1.68),('1444','2014-03-18','11:15:00',1.83),('1444','2014-03-18','11:20:00',2.05),('1444','2014-03-18','11:25:00',1.59),('1444','2014-03-18','11:30:00',2.16),('1444','2014-03-18','11:35:00',2.62),('1444','2014-03-18','11:40:00',1.29),('1444','2014-03-18','11:45:00',2.97),('1444','2014-03-18','11:50:00',2.08),('1444','2014-03-18','11:55:00',2.09),('1444','2014-03-18','12:00:00',2.6),('1444','2014-03-18','12:05:00',2.34),('1444','2014-03-18','12:10:00',1.24),('1444','2014-03-18','12:15:00',1.35),('1444','2014-03-18','12:20:00',1.1),('1444','2014-03-18','12:25:00',1.08),('1444','2014-03-18','12:30:00',1.97),('1444','2014-03-18','12:35:00',1.25),('1444','2014-03-18','12:40:00',2.17),('1444','2014-03-18','12:45:00',2.91),('1444','2014-03-18','12:50:00',2.81),('1444','2014-03-18','12:55:00',2.85),('1444','2014-03-18','13:00:00',2.81),('1444','2014-03-18','13:05:00',2.75),('1444','2014-03-18','13:10:00',2.76),('1444','2014-03-18','13:15:00',2.78),('1444','2014-03-18','13:20:00',2.58),('1444','2014-03-18','13:25:00',2.45),('1444','2014-03-18','13:30:00',2.61),('1444','2014-03-18','13:35:00',2.57),('1444','2014-03-18','13:40:00',2.57),('1444','2014-03-18','13:45:00',2.48),('1444','2014-03-18','13:50:00',2.48),('1444','2014-03-18','13:55:00',2.4),('1444','2014-03-18','14:00:00',2.34),('1444','2014-03-18','14:05:00',2.35),('1444','2014-03-18','14:10:00',2.32),('1444','2014-03-18','14:15:00',2.28),('1444','2014-03-18','14:20:00',2.25),('1444','2014-03-18','14:25:00',2.24),('1444','2014-03-18','14:30:00',2.2),('1444','2014-03-18','14:35:00',2.15),('1444','2014-03-18','14:40:00',2.09),('1444','2014-03-18','14:45:00',2.12),('1444','2014-03-18','14:50:00',2.09),('1444','2014-03-18','14:55:00',2.03),('1444','2014-03-18','15:00:00',1.97),('1444','2014-03-18','15:05:00',1.92),('1444','2014-03-18','15:10:00',1.87),('1444','2014-03-18','15:15:00',1.83),('1444','2014-03-18','15:20:00',1.78),('1444','2014-03-18','15:25:00',1.69),('1444','2014-03-18','15:30:00',1.66),('1444','2014-03-18','15:35:00',1.59),('1444','2014-03-18','15:40:00',1.52),('1444','2014-03-18','15:45:00',1.48),('1444','2014-03-18','15:50:00',1.42),('1444','2014-03-18','15:55:00',1.35),('1444','2014-03-18','16:00:00',1.31),('1444','2014-03-18','16:05:00',1.24),('1444','2014-03-18','16:10:00',1.18),('1444','2014-03-18','16:15:00',1.1),('1444','2014-03-18','16:20:00',1.05),('1444','2014-03-18','16:25:00',1),('1444','2012-12-31','10:10:00',1.03),('1444','2012-12-31','10:15:00',1.2),('1444','2012-12-31','10:20:00',1.21),('1444','2012-12-31','10:25:00',1.23),('1444','2012-12-31','10:30:00',1.25),('1444','2012-12-31','10:35:00',1.28),('1444','2012-12-31','10:40:00',1.31),('1444','2012-12-31','10:45:00',1.31),('1444','2012-12-31','10:50:00',1.35),('1444','2012-12-31','10:55:00',1.39),('1444','2012-12-31','11:00:00',1.41),('1444','2012-12-31','11:05:00',1.38),('1444','2012-12-31','11:10:00',1.39),('1444','2012-12-31','11:15:00',1.46),('1444','2012-12-31','11:20:00',1.48),('1444','2012-12-31','11:25:00',1.5),('1444','2012-12-31','11:30:00',1.51),('1444','2012-12-31','11:35:00',1.52),('1444','2012-12-31','11:40:00',1.54),('1444','2012-12-31','11:45:00',1.55),('1444','2012-12-31','11:50:00',1.55),('1444','2012-12-31','11:55:00',1.56),('1444','2012-12-31','12:00:00',1.56),('1444','2012-12-31','12:05:00',1.56),('1444','2012-12-31','12:10:00',1.55),('1444','2012-12-31','12:15:00',1.55),('1444','2012-12-31','12:20:00',1.55),('1444','2012-12-31','12:25:00',1.52),('1444','2012-12-31','12:30:00',1.52),('1444','2012-12-31','12:35:00',1.5),('1444','2012-12-31','12:40:00',1.47),('1444','2012-12-31','12:45:00',1.49),('1444','2012-12-31','12:50:00',1.45),('1444','2012-12-31','12:55:00',1.41),('1444','2012-12-31','13:00:00',1.41),('1444','2012-12-31','13:05:00',1.4),('1444','2012-12-31','13:10:00',1.36),('1444','2012-12-31','13:15:00',1.36),('1444','2012-12-31','13:20:00',1.31),('1444','2012-12-31','13:25:00',1.26),('1444','2012-12-31','13:30:00',1.24),('1444','2012-12-31','13:35:00',1.21),('1444','2012-12-31','13:40:00',1.18),('1444','2012-12-31','13:45:00',1.17),('1444','2012-12-31','13:50:00',1.15),('1444','2012-12-31','13:55:00',1.11),('1444','2012-12-31','14:00:00',1.09),('1444','2012-12-31','14:05:00',1.04),('1444','2012-12-31','14:10:00',1.03),('1444','2012-12-31','14:15:00',1.02),('1444','2012-12-30','10:05:00',1.01),('1444','2012-12-30','10:10:00',1.04),('1444','2012-12-30','10:15:00',1.09),('1444','2012-12-30','10:20:00',1.12),('1444','2012-12-30','10:25:00',1.16),('1444','2012-12-30','10:30:00',1.2),('1444','2012-12-30','10:35:00',1.24),('1444','2012-12-30','10:40:00',1.28),('1444','2012-12-30','10:45:00',1.32),('1444','2012-12-30','10:50:00',1.35),('1444','2012-12-30','10:55:00',1.38),('1444','2012-12-30','11:00:00',1.41),('1444','2012-12-30','11:05:00',1.43),('1444','2012-12-30','11:10:00',1.44),('1444','2012-12-30','11:15:00',1.46),('1444','2012-12-30','11:20:00',1.48),('1444','2012-12-30','11:25:00',1.48),('1444','2012-12-30','11:30:00',1.5),('1444','2012-12-30','11:35:00',1.52),('1444','2012-12-30','11:40:00',1.52),('1444','2012-12-30','11:45:00',1.54),('1444','2012-12-30','11:50:00',1.55),('1444','2012-12-30','11:55:00',1.55),('1444','2012-12-30','12:00:00',1.56),('1444','2012-12-30','12:05:00',1.53),('1444','2012-12-30','12:10:00',1.51),('1444','2012-12-30','12:15:00',1.51),('1444','2012-12-30','12:20:00',1.5),('1444','2012-12-30','12:25:00',1.47),('1444','2012-12-30','12:30:00',1.46),('1444','2012-12-30','12:35:00',1.45),('1444','2012-12-30','12:40:00',1.44),('1444','2012-12-30','12:45:00',1.43),('1444','2012-12-30','12:50:00',1.37),('1444','2012-12-30','12:55:00',1.37),('1444','2012-12-30','13:00:00',1.39),('1444','2012-12-30','13:05:00',1.39),('1444','2012-12-30','13:10:00',1.35),('1444','2012-12-30','13:15:00',1.34),('1444','2012-12-30','13:20:00',1.29),('1444','2012-12-30','13:25:00',1.28),('1444','2012-12-30','13:30:00',1.23),('1444','2012-12-30','13:35:00',1.2),('1444','2012-12-30','13:40:00',1.17),('1444','2012-12-30','13:45:00',1.19),('1444','2012-12-30','13:50:00',1.16),('1444','2012-12-30','13:55:00',1.11),('1444','2012-12-30','14:00:00',1.1),('1444','2012-12-30','14:05:00',1.07),('1444','2012-12-30','14:10:00',1.05),('1444','2012-12-30','14:15:00',1.02),('1444','2012-12-29','10:00:00',1),('1444','2012-12-29','10:05:00',1.04),('1444','2012-12-29','10:10:00',1.08),('1444','2012-12-29','10:15:00',1.12),('1444','2012-12-29','10:20:00',1.15),('1444','2012-12-29','10:25:00',1.18),('1444','2012-12-29','10:30:00',1.22),('1444','2012-12-29','10:35:00',1.25),('1444','2012-12-29','10:40:00',1.29),('1444','2012-12-29','10:45:00',1.33),('1444','2012-12-29','10:50:00',1.37),('1444','2012-12-29','10:55:00',1.41),('1444','2012-12-29','11:00:00',1.42),('1444','2012-12-29','11:05:00',1.43),('1444','2012-12-29','11:10:00',1.46),('1444','2012-12-29','11:15:00',1.48),('1444','2012-12-29','11:20:00',1.5),('1444','2012-12-29','11:25:00',1.51),('1444','2012-12-29','11:30:00',1.52),('1444','2012-12-29','11:35:00',1.54),('1444','2012-12-29','11:40:00',1.55),('1444','2012-12-29','11:45:00',1.55),('1444','2012-12-29','11:50:00',1.56),('1444','2012-12-29','11:55:00',1.56),('1444','2012-12-29','12:00:00',1.57),('1444','2012-12-29','12:05:00',1.56),('1444','2012-12-29','12:10:00',1.56),('1444','2012-12-29','12:15:00',1.56),('1444','2012-12-29','12:20:00',1.51),('1444','2012-12-29','12:25:00',1.5),('1444','2012-12-29','12:30:00',1.49),('1444','2012-12-29','12:35:00',1.47),('1444','2012-12-29','12:40:00',1.48),('1444','2012-12-29','12:45:00',1.47),('1444','2012-12-29','12:50:00',1.4),('1444','2012-12-29','12:55:00',1.41),('1444','2012-12-29','13:00:00',1.42),('1444','2012-12-29','13:05:00',1.4),('1444','2012-12-29','13:10:00',1.37),('1444','2012-12-29','13:15:00',1.36),('1444','2012-12-29','13:20:00',1.29),('1444','2012-12-29','13:25:00',1.27),('1444','2012-12-29','13:30:00',1.25),('1444','2012-12-29','13:35:00',1.25),('1444','2012-12-29','13:40:00',1.22),('1444','2012-12-29','13:45:00',1.19),('1444','2012-12-29','13:50:00',1.16),('1444','2012-12-29','13:55:00',1.11),('1444','2012-12-29','14:00:00',1.1),('1444','2012-12-29','14:05:00',1.08),('1444','2012-12-29','14:10:00',1.05),('1444','2012-12-29','14:15:00',1.03),('1444','2012-12-28','10:15:00',1.03),('1444','2012-12-28','10:20:00',1.07),('1444','2012-12-28','10:25:00',1.11),('1444','2012-12-28','10:30:00',1.14),('1444','2012-12-28','10:35:00',1.19),('1444','2012-12-28','10:40:00',1.23),('1444','2012-12-28','10:45:00',1.25),('1444','2012-12-28','10:50:00',1.29),('1444','2012-12-28','10:55:00',1.34),('1444','2012-12-28','11:00:00',1.35),('1444','2012-12-28','11:05:00',1.37),('1444','2012-12-28','11:10:00',1.4),('1444','2012-12-28','11:15:00',1.26),('1444','2012-12-28','11:20:00',1.43),('1444','2012-12-28','11:25:00',1.46),('1444','2012-12-28','11:30:00',1.43),('1444','2012-12-28','11:35:00',1.39),('1444','2012-12-28','11:40:00',1.49),('1444','2012-12-28','11:45:00',1.49),('1444','2012-12-28','11:50:00',1.5),('1444','2012-12-28','11:55:00',1.52),('1444','2012-12-28','12:00:00',1.57),('1444','2012-12-28','12:05:00',1.48),('1444','2012-12-28','12:10:00',1.47),('1444','2012-12-28','12:15:00',1.48),('1444','2012-12-28','12:20:00',1.46),('1444','2012-12-28','12:25:00',1.46),('1444','2012-12-28','12:30:00',1.44),('1444','2012-12-28','12:35:00',1.4),('1444','2012-12-28','12:40:00',1.43),('1444','2012-12-28','12:45:00',1.41),('1444','2012-12-28','12:50:00',1.35),('1444','2012-12-28','12:55:00',1.31),('1444','2012-12-28','13:00:00',1.3),('1444','2012-12-28','13:05:00',1.3),('1444','2012-12-28','13:10:00',1.3),('1444','2012-12-28','13:15:00',1.28),('1444','2012-12-28','13:20:00',1.23),('1444','2012-12-28','13:25:00',1.23),('1444','2012-12-28','13:30:00',1.17),('1444','2012-12-28','13:40:00',1.13),('1444','2012-12-28','13:45:00',1.11),('1444','2012-12-28','13:50:00',1.08),('1444','2012-12-28','13:55:00',1.05),('1444','2012-12-28','14:00:00',1.02),('1444','2012-12-27','09:50:00',1.08),('1444','2012-12-27','09:55:00',1.07),('1444','2012-12-27','10:00:00',1.02),('1444','2012-12-27','10:05:00',1.02),('1444','2012-12-27','10:10:00',1.01),('1444','2012-12-27','10:15:00',1.02),('1444','2012-12-27','10:25:00',1.05),('1444','2012-12-27','10:30:00',1.09),('1444','2012-12-27','10:35:00',1.08),('1444','2012-12-27','10:40:00',1.18),('1444','2012-12-27','10:45:00',1.22),('1444','2012-12-27','10:50:00',1.21),('1444','2012-12-27','11:00:00',1.33),('1444','2012-12-27','11:05:00',1.09),('1444','2012-12-27','11:50:00',1.27),('1444','2012-12-27','11:55:00',1.34),('1444','2012-12-27','12:00:00',1.47),('1444','2012-12-27','12:05:00',1.52),('1444','2012-12-27','12:10:00',1.43),('1444','2012-12-27','12:25:00',1.32),('1444','2012-12-27','12:30:00',1.4),('1444','2012-12-27','12:35:00',1.38),('1444','2012-12-27','12:40:00',1.46),('1444','2012-12-27','12:45:00',1.67),('1444','2012-12-27','12:50:00',1.38),('1444','2012-12-27','12:55:00',1.26),('1444','2012-12-27','13:00:00',1.4),('1444','2012-12-27','13:05:00',1.48),('1444','2012-12-27','13:10:00',1.47),('1444','2012-12-27','13:15:00',1.56),('1444','2012-12-27','13:20:00',1.56),('1444','2012-12-27','13:25:00',1.47),('1444','2012-12-27','13:30:00',1.29),('1444','2012-12-27','14:00:00',1.28),('1444','2012-12-27','14:05:00',1.15),('1444','2012-12-27','14:10:00',1.27),('1444','2012-12-27','14:15:00',1),('1444','2012-12-26','10:10:00',1.01),('1444','2012-12-26','10:15:00',1.04),('1444','2012-12-26','10:20:00',1.07),('1444','2012-12-26','10:25:00',1.08),('1444','2012-12-26','10:30:00',1.12),('1444','2012-12-26','10:35:00',1.15),('1444','2012-12-26','10:40:00',1.19),('1444','2012-12-26','10:45:00',1.21),('1444','2012-12-26','10:50:00',1.24),('1444','2012-12-26','10:55:00',1.27),('1444','2012-12-26','11:00:00',1.28),('1444','2012-12-26','11:05:00',1.31),('1444','2012-12-26','11:10:00',1.31),('1444','2012-12-26','11:15:00',1.33),('1444','2012-12-26','11:20:00',1.34),('1444','2012-12-26','11:25:00',1.37),('1444','2012-12-26','11:30:00',1.38),('1444','2012-12-26','11:35:00',1.38),('1444','2012-12-26','11:40:00',1.41),('1444','2012-12-26','11:45:00',1.42),('1444','2012-12-26','11:50:00',1.45),('1444','2012-12-26','11:55:00',1.48),('1444','2012-12-26','12:00:00',1.49),('1444','2012-12-26','12:05:00',1.47),('1444','2012-12-26','12:10:00',1.46),('1444','2012-12-26','12:15:00',1.44),('1444','2012-12-26','12:20:00',1.43),('1444','2012-12-26','12:25:00',1.43),('1444','2012-12-26','12:30:00',1.42),('1444','2012-12-26','12:35:00',1.39),('1444','2012-12-26','12:40:00',1.42),('1444','2012-12-26','12:45:00',1.39),('1444','2012-12-26','12:50:00',1.33),('1444','2012-12-26','12:55:00',1.13),('1444','2012-12-26','13:00:00',1.37),('1444','2012-12-26','13:10:00',1.32),('1444','2012-12-26','13:15:00',1.2),('1444','2012-12-26','13:20:00',1.37),('1444','2012-12-26','13:25:00',1.29),('1444','2012-12-26','13:30:00',1.44),('1444','2012-12-26','13:35:00',1.44),('1444','2012-12-26','13:40:00',1.45),('1444','2012-12-26','13:45:00',1.46),('1444','2012-12-26','13:50:00',1.42),('1444','2012-12-26','13:55:00',1.33),('1444','2012-12-26','14:00:00',1.42),('1444','2012-12-26','14:05:00',1.34),('1444','2012-12-23','10:05:00',1),('1444','2012-12-23','10:10:00',1.05),('1444','2012-12-23','10:15:00',1.07),('1444','2012-12-23','10:20:00',1.1),('1444','2012-12-23','10:25:00',1.1),('1444','2012-12-23','10:30:00',1.11),('1444','2012-12-23','10:35:00',1.14),('1444','2012-12-23','10:40:00',1.22),('1444','2012-12-23','10:45:00',1.25),('1444','2012-12-23','10:50:00',1.28),('1444','2012-12-23','10:55:00',1.24),('1444','2012-12-23','11:00:00',1.32),('1444','2012-12-23','11:05:00',1.35),('1444','2012-12-23','11:10:00',1.36),('1444','2012-12-23','11:15:00',1.41),('1444','2012-12-23','11:20:00',1.44),('1444','2012-12-23','11:25:00',1.31),('1444','2012-12-23','11:30:00',1.39),('1444','2012-12-23','11:35:00',1.48),('1444','2012-12-23','11:40:00',1.5),('1444','2012-12-23','11:45:00',1.47),('1444','2012-12-23','11:50:00',1.53),('1444','2012-12-23','11:55:00',1.43),('1444','2012-12-23','12:00:00',1.36),('1444','2012-12-23','12:05:00',1.34),('1444','2012-12-23','12:10:00',1.35),('1444','2012-12-23','12:20:00',1.16),('1444','2012-12-23','12:55:00',1.34),('1444','2012-12-23','13:00:00',1.41),('1444','2012-12-23','13:05:00',1.22),('1444','2012-12-23','13:10:00',1.24),('1444','2012-12-23','13:15:00',1.12),('1444','2012-12-23','14:00:00',1.17),('1444','2012-12-23','14:05:00',1.04),('1444','2014-05-01','08:00:00',1.15),('1444','2014-05-01','08:05:00',1.21),('1444','2014-05-01','08:10:00',1.19),('1444','2014-05-01','08:15:00',1.29),('1444','2014-05-01','08:20:00',1.36),('1444','2014-05-01','08:25:00',1.43),('1444','2014-05-01','08:30:00',1.5),('1444','2014-05-01','08:35:00',1.56),('1444','2014-05-01','08:40:00',1.63),('1444','2014-05-01','08:45:00',1.69),('1444','2014-05-01','08:50:00',1.88),('1444','2014-05-01','08:55:00',1.81),('1444','2014-05-01','09:00:00',1.09),('1444','2014-05-01','09:05:00',1.12),('1444','2014-05-01','09:10:00',1.42),('1444','2014-05-01','09:15:00',1.14),('1444','2014-05-01','09:25:00',1.12),('1444','2014-05-01','09:30:00',2.12),('1444','2014-05-01','09:35:00',2.32),('1444','2014-05-01','09:40:00',2.67),('1444','2014-05-01','09:45:00',1.84),('1444','2014-05-01','09:50:00',2.17),('1444','2014-05-01','09:55:00',2.16),('1444','2014-05-01','10:00:00',1.37),('1444','2014-05-01','10:05:00',1.02),('1444','2014-05-01','10:10:00',1.23),('1444','2014-05-01','10:15:00',2.19),('1444','2014-05-01','10:20:00',2.18),('1444','2014-05-01','10:25:00',1.28),('1444','2014-05-01','10:30:00',1.69),('1444','2014-05-01','10:35:00',2.46),('1444','2014-05-01','10:40:00',2.27),('1444','2014-05-01','10:45:00',2.7),('1444','2014-05-01','10:50:00',3.25),('1444','2014-05-01','10:55:00',3.37),('1444','2014-05-01','11:00:00',2.15),('1444','2014-05-01','11:05:00',1.66),('1444','2014-05-01','11:10:00',2.95),('1444','2014-05-01','11:20:00',1.31),('1444','2014-05-01','11:25:00',3.58),('1444','2014-05-01','11:30:00',2.56),('1444','2014-05-01','11:35:00',2.15),('1444','2014-05-01','11:45:00',2.54),('1444','2014-05-01','11:50:00',3.79),('1444','2014-05-01','11:55:00',1.88),('1444','2014-05-01','12:05:00',3.17),('1444','2014-05-01','12:10:00',2.92),('1444','2014-05-01','12:15:00',3.69),('1444','2014-05-01','12:20:00',3.59),('1444','2014-05-01','12:25:00',3.2),('1444','2014-05-01','12:30:00',1.23),('1444','2014-05-01','12:35:00',2.23),('1444','2014-05-01','12:40:00',3.89),('1444','2014-05-01','12:45:00',2.7),('1444','2014-05-01','12:50:00',3.17),('1444','2014-05-01','12:55:00',3.83),('1444','2014-05-01','13:00:00',3.72),('1444','2014-05-01','13:05:00',3.64),('1444','2014-05-01','13:10:00',3.73),('1444','2014-05-01','13:15:00',3.62),('1444','2014-05-01','13:20:00',3.37),('1444','2014-05-01','13:25:00',1.61),('1444','2014-05-01','13:30:00',1.94),('1444','2014-05-01','13:35:00',3.15),('1444','2014-05-01','13:40:00',3.62),('1444','2014-05-01','13:45:00',3.74),('1444','2014-05-01','13:50:00',3.53),('1444','2014-05-01','13:55:00',2.98),('1444','2014-05-01','14:00:00',3.78),('1444','2014-05-01','14:05:00',3.51),('1444','2014-05-01','14:10:00',3.43),('1444','2014-05-01','14:15:00',3.37),('1444','2014-05-01','14:20:00',3.32),('1444','2014-05-01','14:25:00',3.33),('1444','2014-05-01','14:30:00',3.21),('1444','2014-05-01','14:35:00',3.15),('1444','2014-05-01','14:40:00',3.37),('1444','2014-05-01','14:45:00',3.37),('1444','2014-05-01','14:50:00',3.33),('1444','2014-05-01','14:55:00',2.82),('1444','2014-05-01','15:00:00',2.83),('1444','2014-05-01','15:05:00',3.3),('1444','2014-05-01','15:10:00',3.18),('1444','2014-05-01','15:15:00',2.27),('1444','2014-05-01','15:20:00',3.04),('1444','2014-05-01','15:25:00',2.96),('1444','2014-05-01','15:30:00',2.91),('1444','2014-05-01','15:35:00',2.86),('1444','2014-05-01','15:40:00',2.82),('1444','2014-05-01','15:45:00',2.71),('1444','2014-05-01','15:50:00',2.77),('1444','2014-05-01','15:55:00',2.62),('1444','2014-05-01','16:00:00',2.64),('1444','2014-05-01','16:05:00',2.62),('1444','2014-05-01','16:10:00',2.49),('1444','2014-05-01','16:15:00',2.46),('1444','2014-05-01','16:20:00',2.35),('1444','2014-05-01','16:25:00',2.15),('1444','2014-05-01','16:30:00',2.26),('1444','2014-05-01','16:35:00',2.3),('1444','2014-05-01','16:40:00',2.15),('1444','2014-05-01','16:45:00',1.82),('1444','2014-05-01','16:50:00',1.49),('1444','2014-05-01','16:55:00',1.92),('1444','2014-05-01','17:00:00',1.86),('1444','2014-05-01','17:05:00',1.75),('1444','2014-05-01','17:10:00',1.89),('1444','2014-05-01','17:15:00',1.8),('1444','2014-05-01','17:20:00',1.72),('1444','2014-05-01','17:25:00',1.66),('1444','2014-05-01','17:30:00',1.59),('1444','2014-05-01','17:35:00',1.52),('1444','2014-05-01','17:40:00',1.44),('1444','2014-05-01','17:45:00',1.37),('1444','2014-05-01','17:50:00',1.31),('1444','2014-05-01','17:55:00',1.25),('1444','2014-05-01','18:00:00',1.19),('1444','2014-05-01','18:05:00',1.14),('1444','2014-05-01','18:10:00',1.03),('1444','2014-03-17','09:25:00',1.1),('1444','2014-03-17','09:30:00',1.15),('1444','2014-03-17','09:35:00',1.02),('1444','2014-03-17','09:45:00',1.05),('1444','2014-03-17','09:50:00',1.64),('1444','2014-03-17','09:55:00',1.4),('1444','2014-03-17','10:00:00',1.42),('1444','2014-03-17','10:05:00',1.35),('1444','2014-03-17','10:10:00',1.22),('1444','2014-03-17','10:15:00',1.34),('1444','2014-03-17','10:20:00',1.43),('1444','2014-03-17','10:25:00',1.22),('1444','2014-03-17','10:30:00',1.06),('1444','2014-03-17','10:40:00',1.13),('1444','2014-03-17','10:45:00',1.33),('1444','2014-03-17','10:50:00',1.13),('1444','2014-03-17','10:55:00',1.23),('1444','2014-03-17','11:00:00',1.3),('1444','2014-03-17','11:05:00',1.12),('1444','2014-03-17','11:10:00',1.55),('1444','2014-03-17','11:15:00',1.02),('1444','2014-03-17','11:25:00',1.29),('1444','2014-03-17','11:30:00',1.28),('1444','2014-03-17','11:35:00',1.07),('1444','2014-03-17','11:45:00',1.33),('1444','2014-03-17','11:50:00',1.86),('1444','2014-03-17','11:55:00',1.35),('1444','2014-03-17','12:00:00',1.32),('1444','2014-03-17','12:05:00',1.22),('1444','2014-03-17','12:10:00',1.06),('1444','2014-03-17','12:15:00',1.34),('1444','2014-03-17','12:20:00',3.03),('1444','2014-03-17','12:25:00',1.33),('1444','2014-03-17','12:30:00',1.44),('1444','2014-03-17','12:35:00',1.32),('1444','2014-03-17','12:40:00',2.03),('1444','2014-03-17','12:45:00',1.97),('1444','2014-03-17','12:50:00',2.31),('1444','2014-03-17','12:55:00',2.75),('1444','2014-03-17','13:00:00',1.46),('1444','2014-03-17','13:05:00',1.56),('1444','2014-03-17','13:10:00',2.56),('1444','2014-03-17','13:15:00',2.71),('1444','2014-03-17','13:20:00',2.29),('1444','2014-03-17','13:25:00',2.74),('1444','2014-03-17','13:30:00',2.72),('1444','2014-03-17','13:35:00',2.65),('1444','2014-03-17','13:40:00',2.62),('1444','2014-03-17','13:45:00',2.53),('1444','2014-03-17','13:50:00',2.53),('1444','2014-03-17','13:55:00',1.87),('1444','2014-03-17','14:00:00',2.41),('1444','2014-03-17','14:05:00',1.41),('1444','2014-03-17','14:15:00',1.97),('1444','2014-03-17','14:20:00',1.45),('1444','2014-03-17','14:25:00',2.29),('1444','2014-03-17','14:30:00',1.09),('1444','2014-03-17','14:35:00',1.68),('1444','2014-03-17','14:40:00',2.11),('1444','2014-03-17','14:45:00',2.11),('1444','2014-03-17','14:50:00',2.12),('1444','2014-03-17','14:55:00',2.04),('1444','2014-03-17','15:00:00',1.99),('1444','2014-03-17','15:05:00',1.95),('1444','2014-03-17','15:10:00',1.89),('1444','2014-03-17','15:20:00',1.78),('1444','2014-03-17','15:25:00',1.69),('1444','2014-03-17','15:30:00',1.56),('1444','2014-03-17','15:35:00',1.49),('1444','2014-03-17','15:40:00',1.45),('1444','2014-03-17','15:50:00',1.24),('1444','2014-03-17','15:55:00',1),('1444','2014-03-17','16:00:00',1.09),('1444','2014-03-17','16:05:00',1.15),('1444','2014-03-17','16:20:00',1.08),('1444','2012-12-22','10:35:00',1.65),('1444','2012-12-22','10:40:00',1.61),('1444','2012-12-22','10:45:00',1.57),('1444','2012-12-22','10:50:00',1.5),('1444','2012-12-22','11:40:00',1.81),('1444','2012-12-22','11:45:00',1.86),('1444','2012-12-22','11:50:00',1.39),('1444','2012-12-22','11:55:00',1.2),('1444','2012-12-22','12:00:00',1.4),('1444','2012-12-22','12:30:00',1.42),('1444','2012-12-22','12:35:00',1.08),('1444','2012-12-22','12:40:00',1.7),('1444','2012-12-22','12:45:00',1.9),('1444','2012-12-22','12:50:00',1.7),('1444','2012-12-22','12:55:00',1.64),('1444','2012-12-22','13:00:00',1.71),('1444','2012-12-22','13:05:00',1.46),('1444','2012-12-22','13:10:00',1.72),('1444','2012-12-22','13:15:00',1.81),('1444','2012-12-22','13:20:00',1.81),('1444','2012-12-22','13:25:00',1.77),('1444','2012-12-22','13:30:00',1.6),('1444','2012-12-22','13:35:00',1.51),('1444','2014-03-16','08:20:00',1.05),('1444','2014-03-16','08:25:00',1.11),('1444','2014-03-16','08:30:00',1.17),('1444','2014-03-16','08:35:00',1.19),('1444','2014-03-16','08:40:00',1.26),('1444','2014-03-16','08:45:00',1.32),('1444','2014-03-16','08:50:00',1.38),('1444','2014-03-16','08:55:00',1.41),('1444','2014-03-16','09:00:00',1.4),('1444','2014-03-16','09:05:00',1.45),('1444','2014-03-16','09:10:00',1.56),('1444','2014-03-16','09:15:00',1.68),('1444','2014-03-16','09:20:00',1.72),('1444','2014-03-16','09:25:00',1.72),('1444','2014-03-16','09:30:00',1.78),('1444','2014-03-16','09:35:00',1.78),('1444','2014-03-16','09:40:00',1.8),('1444','2014-03-16','09:45:00',1.89),('1444','2014-03-16','09:50:00',2.03),('1444','2014-03-16','09:55:00',2.03),('1444','2014-03-16','10:00:00',2.05),('1444','2014-03-16','10:05:00',2.06),('1444','2014-03-16','10:10:00',2.13),('1444','2014-03-16','10:15:00',2.17),('1444','2014-03-16','10:20:00',2.19),('1444','2014-03-16','10:25:00',2.21),('1444','2014-03-16','10:30:00',2.24),('1444','2014-03-16','10:35:00',2.29),('1444','2014-03-16','10:40:00',2.32),('1444','2014-03-16','10:45:00',2.35),('1444','2014-03-16','10:50:00',2.34),('1444','2014-03-16','10:55:00',2.45),('1444','2014-03-16','11:00:00',2.45),('1444','2014-03-16','11:05:00',2.49),('1444','2014-03-16','11:10:00',2.48),('1444','2014-03-16','11:15:00',2.52),('1444','2014-03-16','11:20:00',2.53),('1444','2014-03-16','11:25:00',2.55),('1444','2014-03-16','11:30:00',2.54),('1444','2014-03-16','11:35:00',2.52),('1444','2014-03-16','11:40:00',2.51),('1444','2014-03-16','11:45:00',2.5),('1444','2014-03-16','11:50:00',2.51),('1444','2014-03-16','11:55:00',2.5),('1444','2014-03-16','12:00:00',2.52),('1444','2014-03-16','12:05:00',2.58),('1444','2014-03-16','12:10:00',2.56),('1444','2014-03-16','12:15:00',2.51),('1444','2014-03-16','12:20:00',2.54),('1444','2014-03-16','12:25:00',2.54),('1444','2014-03-16','12:30:00',2.54),('1444','2014-03-16','12:35:00',2.6),('1444','2014-03-16','12:40:00',2.55),('1444','2014-03-16','12:45:00',2.53),('1444','2014-03-16','12:50:00',2.51),('1444','2014-03-16','12:55:00',2.5),('1444','2014-03-16','13:00:00',2.43),('1444','2014-03-16','13:05:00',2.45),('1444','2014-03-16','13:10:00',2.42),('1444','2014-03-16','13:15:00',2.43),('1444','2014-03-16','13:20:00',2.37),('1444','2014-03-16','13:25:00',2.41),('1444','2014-03-16','13:30:00',2.43),('1444','2014-03-16','13:35:00',2.39),('1444','2014-03-16','13:40:00',2.46),('1444','2014-03-16','13:45:00',2.38),('1444','2014-03-16','13:50:00',2.39),('1444','2014-03-16','13:55:00',2.36),('1444','2014-03-16','14:00:00',2.28),('1444','2014-03-16','14:05:00',2.26),('1444','2014-03-16','14:10:00',2.15),('1444','2014-03-16','14:15:00',2.14),('1444','2014-03-16','14:20:00',2.12),('1444','2014-03-16','14:25:00',2.1),('1444','2014-03-16','14:30:00',2.03),('1444','2014-03-16','14:35:00',1.97),('1444','2014-03-16','14:40:00',1.92),('1444','2014-03-16','14:45:00',1.91),('1444','2014-03-16','14:50:00',1.78),('1444','2014-03-16','14:55:00',1.73),('1444','2014-03-16','15:00:00',1.82),('1444','2014-03-16','15:05:00',1.75),('1444','2014-03-16','15:10:00',1.62),('1444','2014-03-16','15:15:00',1.56),('1444','2014-03-16','15:20:00',1.33),('1444','2014-03-16','15:25:00',1.5),('1444','2014-03-16','15:30:00',1.37),('1444','2014-03-16','15:35:00',1.27),('1444','2014-03-16','15:40:00',1),('1444','2014-03-16','15:50:00',1.07),('1444','2014-03-16','16:10:00',1.05),('1444','2014-03-16','16:15:00',1.03),('1444','2014-03-15','08:20:00',1.03),('1444','2014-03-15','08:25:00',1.08),('1444','2014-03-15','08:30:00',1.13),('1444','2014-03-15','08:35:00',1.18),('1444','2014-03-15','08:40:00',1.24),('1444','2014-03-15','08:45:00',1.28),('1444','2014-03-15','08:50:00',1.34),('1444','2014-03-15','08:55:00',1.39),('1444','2014-03-15','09:00:00',1.45),('1444','2014-03-15','09:05:00',1.49),('1444','2014-03-15','09:10:00',1.56),('1444','2014-03-15','09:15:00',1.61),('1444','2014-03-15','09:20:00',1.67),('1444','2014-03-15','09:25:00',1.71),('1444','2014-03-15','09:30:00',1.74),('1444','2014-03-15','09:35:00',1.8),('1444','2014-03-15','09:40:00',1.84),('1444','2014-03-15','09:45:00',1.87),('1444','2014-03-15','09:50:00',1.9),('1444','2014-03-15','09:55:00',1.93),('1444','2014-03-15','10:00:00',1.99),('1444','2014-03-15','10:05:00',2.04),('1444','2014-03-15','10:10:00',2.07),('1444','2014-03-15','10:15:00',2.11),('1444','2014-03-15','10:20:00',2.14),('1444','2014-03-15','10:25:00',2.14),('1444','2014-03-15','10:30:00',2.2),('1444','2014-03-15','10:35:00',2.22),('1444','2014-03-15','10:40:00',2.23),('1444','2014-03-15','10:45:00',2.3),('1444','2014-03-15','10:50:00',2.3),('1444','2014-03-15','10:55:00',2.32),('1444','2014-03-15','11:00:00',2.38),('1444','2014-03-15','11:05:00',2.4),('1444','2014-03-15','11:10:00',2.38),('1444','2014-03-15','11:15:00',2.48),('1444','2014-03-15','11:20:00',2.47),('1444','2014-03-15','11:25:00',2.5),('1444','2014-03-15','11:30:00',2.46),('1444','2014-03-15','11:35:00',2.51),('1444','2014-03-15','11:40:00',2.52),('1444','2014-03-15','11:45:00',2.54),('1444','2014-03-15','11:50:00',2.5),('1444','2014-03-15','11:55:00',2.5),('1444','2014-03-15','12:00:00',2.53),('1444','2014-03-15','12:05:00',2.47),('1444','2014-03-15','12:10:00',2.48),('1444','2014-03-15','12:15:00',2.5),('1444','2014-03-15','12:20:00',2.49),('1444','2014-03-15','12:25:00',2.54),('1444','2014-03-15','12:30:00',2.55),('1444','2014-03-15','12:35:00',2.54),('1444','2014-03-15','12:40:00',2.55),('1444','2014-03-15','12:45:00',2.54),('1444','2014-03-15','12:50:00',2.54),('1444','2014-03-15','12:55:00',2.53),('1444','2014-03-15','13:00:00',2.53),('1444','2014-03-15','13:05:00',2.53),('1444','2014-03-15','13:10:00',2.56),('1444','2014-03-15','13:15:00',2.54),('1444','2014-03-15','13:20:00',2.51),('1444','2014-03-15','13:25:00',2.48),('1444','2014-03-15','13:30:00',2.49),('1444','2014-03-15','13:35:00',2.46),('1444','2014-03-15','13:40:00',2.45),('1444','2014-03-15','13:45:00',2.42),('1444','2014-03-15','13:50:00',2.39),('1444','2014-03-15','13:55:00',2.38),('1444','2014-03-15','14:00:00',2.36),('1444','2014-03-15','14:05:00',2.33),('1444','2014-03-15','14:10:00',2.3),('1444','2014-03-15','14:15:00',2.23),('1444','2014-03-15','14:20:00',2.17),('1444','2014-03-15','14:25:00',2.12),('1444','2014-03-15','14:30:00',2.06),('1444','2014-03-15','14:35:00',2.04),('1444','2014-03-15','14:40:00',1.99),('1444','2014-03-15','14:45:00',1.91),('1444','2014-03-15','14:50:00',1.84),('1444','2014-03-15','14:55:00',1.85),('1444','2014-03-15','15:00:00',1.81),('1444','2014-03-15','15:05:00',1.78),('1444','2014-03-15','15:10:00',1.71),('1444','2014-03-15','15:15:00',1.64),('1444','2014-03-15','15:20:00',1.6),('1444','2014-03-15','15:25:00',1.54),('1444','2014-03-15','15:30:00',1.5),('1444','2014-03-15','15:35:00',1.44),('1444','2014-03-15','15:40:00',1.39),('1444','2014-03-15','15:45:00',1.34),('1444','2014-03-15','15:50:00',1.27),('1444','2014-03-15','15:55:00',1.2),('1444','2014-03-15','16:00:00',1.15),('1444','2014-03-15','16:05:00',1.04),('1444','2014-03-15','16:10:00',1.01),('1444','2014-03-14','09:05:00',1.01),('1444','2014-03-14','09:10:00',1.11),('1444','2014-03-14','09:15:00',1.16),('1444','2014-03-14','09:20:00',1.13),('1444','2014-03-14','09:25:00',1.15),('1444','2014-03-14','09:30:00',1.15),('1444','2014-03-14','09:35:00',1.33),('1444','2014-03-14','09:40:00',1.64),('1444','2014-03-14','09:45:00',1.93),('1444','2014-03-14','09:50:00',2.25),('1444','2014-03-14','09:55:00',2.35),('1444','2014-03-14','10:00:00',2.52),('1444','2014-03-14','10:05:00',2.52),('1444','2014-03-14','10:10:00',2.46),('1444','2014-03-14','10:15:00',2.39),('1444','2014-03-14','10:20:00',2.34),('1444','2014-03-14','10:25:00',2.22),('1444','2014-03-14','10:30:00',2.24),('1444','2014-03-14','10:35:00',2.35),('1444','2014-03-14','10:40:00',2.44),('1444','2014-03-14','10:45:00',2.02),('1444','2014-03-14','10:50:00',1.41),('1444','2014-03-14','10:55:00',2.03),('1444','2014-03-14','11:00:00',2.31),('1444','2014-03-14','11:05:00',2.47),('1444','2014-03-14','11:10:00',2.71),('1444','2014-03-14','11:15:00',2.67),('1444','2014-03-14','11:20:00',2.59),('1444','2014-03-14','11:25:00',2.5),('1444','2014-03-14','11:30:00',2.54),('1444','2014-03-14','11:35:00',2.58),('1444','2014-03-14','11:40:00',2.66),('1444','2014-03-14','11:45:00',2.72),('1444','2014-03-14','11:50:00',2.78),('1444','2014-03-14','11:55:00',2.74),('1444','2014-03-14','12:00:00',2.74),('1444','2014-03-14','12:05:00',2.71),('1444','2014-03-14','12:10:00',2.55),('1444','2014-03-14','12:15:00',2.44),('1444','2014-03-14','12:20:00',1.91),('1444','2014-03-14','12:25:00',1.68),('1444','2014-03-14','12:30:00',1.52),('1444','2014-03-14','12:35:00',1.32),('1444','2014-03-14','12:40:00',1.62),('1444','2014-03-14','12:45:00',1.95),('1444','2014-03-14','12:50:00',2.21),('1444','2014-03-14','12:55:00',2.31),('1444','2014-03-14','13:00:00',1.53),('1444','2014-03-14','13:05:00',1.48),('1444','2014-03-14','13:10:00',1.71),('1444','2014-03-14','13:15:00',1.87),('1444','2014-03-14','13:20:00',2.1),('1444','2014-03-14','13:25:00',1.86),('1444','2014-03-14','13:30:00',1.75),('1444','2014-03-14','13:35:00',1.51),('1444','2014-03-14','13:40:00',1.55),('1444','2014-03-14','13:45:00',1.65),('1444','2014-03-14','13:50:00',1.67),('1444','2014-03-14','13:55:00',1.54),('1444','2014-03-14','14:00:00',1.91),('1444','2014-03-14','14:05:00',2.12),('1444','2014-03-14','14:10:00',2.01),('1444','2014-03-14','14:15:00',2.09),('1444','2014-03-14','14:20:00',2.13),('1444','2014-03-14','14:25:00',1.9),('1444','2014-03-14','14:30:00',1.82),('1444','2014-03-14','14:35:00',1.75),('1444','2014-03-14','14:40:00',1.4),('1444','2014-03-14','14:45:00',1.19),('1444','2014-03-14','14:50:00',1.13),('1444','2014-03-14','14:55:00',1.03),('1444','2014-03-14','15:30:00',1.03),('1444','2014-03-14','15:35:00',1.21),('1444','2014-03-14','15:40:00',1.12),('1444','2014-03-13','08:15:00',1.05),('1444','2014-03-13','08:20:00',1.16),('1444','2014-03-13','08:25:00',1.21),('1444','2014-03-13','08:30:00',1.28),('1444','2014-03-13','08:35:00',1.34),('1444','2014-03-13','08:40:00',1.4),('1444','2014-03-13','08:45:00',1.45),('1444','2014-03-13','08:50:00',1.51),('1444','2014-03-13','08:55:00',1.57),('1444','2014-03-13','09:00:00',1.65),('1444','2014-03-13','09:05:00',1.71),('1444','2014-03-13','09:10:00',1.76),('1444','2014-03-13','09:15:00',1.81),('1444','2014-03-13','09:20:00',1.86),('1444','2014-03-13','09:25:00',1.9),('1444','2014-03-13','09:30:00',1.95),('1444','2014-03-13','09:35:00',2),('1444','2014-03-13','09:40:00',2.06),('1444','2014-03-13','09:45:00',2.11),('1444','2014-03-13','09:50:00',2.17),('1444','2014-03-13','09:55:00',2.21),('1444','2014-03-13','10:00:00',2.25),('1444','2014-03-13','10:05:00',2.3),('1444','2014-03-13','10:10:00',2.34),('1444','2014-03-13','10:15:00',2.32),('1444','2014-03-13','10:20:00',2.4),('1444','2014-03-13','10:25:00',2.42),('1444','2014-03-13','10:30:00',2.44),('1444','2014-03-13','10:35:00',2.47),('1444','2014-03-13','10:40:00',2.49),('1444','2014-03-13','10:45:00',2.52),('1444','2014-03-13','10:50:00',2.54),('1444','2014-03-13','10:55:00',2.56),('1444','2014-03-13','11:00:00',2.59),('1444','2014-03-13','11:05:00',2.62),('1444','2014-03-13','11:10:00',2.63),('1444','2014-03-13','11:15:00',2.63),('1444','2014-03-13','11:20:00',2.68),('1444','2014-03-13','11:25:00',2.69),('1444','2014-03-13','11:30:00',2.69),('1444','2014-03-13','11:35:00',2.7),('1444','2014-03-13','11:40:00',2.74),('1444','2014-03-13','11:45:00',2.73),('1444','2014-03-13','11:50:00',2.73),('1444','2014-03-13','11:55:00',2.75),('1444','2014-03-13','12:00:00',2.74),('1444','2014-03-13','12:05:00',2.76),('1444','2014-03-13','12:10:00',2.75),('1444','2014-03-13','12:15:00',2.75),('1444','2014-03-13','12:20:00',2.71),('1444','2014-03-13','12:25:00',2.7),('1444','2014-03-13','12:30:00',2.7),('1444','2014-03-13','12:35:00',2.7),('1444','2014-03-13','12:40:00',2.69),('1444','2014-03-13','12:45:00',2.67),('1444','2014-03-13','12:50:00',2.67),('1444','2014-03-13','12:55:00',2.64),('1444','2014-03-13','13:00:00',2.61),('1444','2014-03-13','13:05:00',2.58),('1444','2014-03-13','13:10:00',2.54),('1444','2014-03-13','13:15:00',2.54),('1444','2014-03-13','13:20:00',2.56),('1444','2014-03-13','13:25:00',2.54),('1444','2014-03-13','13:30:00',2.52),('1444','2014-03-13','13:35:00',2.49),('1444','2014-03-13','13:40:00',2.47),('1444','2014-03-13','13:45:00',2.44),('1444','2014-03-13','13:50:00',2.4),('1444','2014-03-13','13:55:00',2.36),('1444','2014-03-13','14:00:00',2.33),('1444','2014-03-13','14:05:00',2.29),('1444','2014-03-13','14:10:00',2.27),('1444','2014-03-13','14:15:00',2.24),('1444','2014-03-13','14:20:00',2.19),('1444','2014-03-13','14:25:00',2.16),('1444','2014-03-13','14:30:00',2.12),('1444','2014-03-13','14:35:00',2.09),('1444','2014-03-13','14:40:00',2.01),('1444','2014-03-13','14:45:00',1.94),('1444','2014-03-13','14:50:00',1.94),('1444','2014-03-13','14:55:00',1.9),('1444','2014-03-13','15:00:00',1.85),('1444','2014-03-13','15:05:00',1.8),('1444','2014-03-13','15:10:00',1.74),('1444','2014-03-13','15:15:00',1.7),('1444','2014-03-13','15:20:00',1.64),('1444','2014-03-13','15:25:00',1.59),('1444','2014-03-13','15:30:00',1.54),('1444','2014-03-13','15:35:00',1.47),('1444','2014-03-13','15:40:00',1.42),('1444','2014-03-13','15:45:00',1.36),('1444','2014-03-13','15:50:00',1.3),('1444','2014-03-13','15:55:00',1.24),('1444','2014-03-13','16:00:00',1.17),('1444','2014-03-13','16:05:00',1.11),('1444','2014-03-13','16:10:00',1.05),('1444','2014-03-12','08:15:00',1.05),('1444','2014-03-12','08:20:00',1.12),('1444','2014-03-12','08:25:00',1.17),('1444','2014-03-12','08:30:00',1.25),('1444','2014-03-12','08:35:00',1.32),('1444','2014-03-12','08:40:00',1.38),('1444','2014-03-12','08:45:00',1.45),('1444','2014-03-12','08:50:00',1.51),('1444','2014-03-12','08:55:00',1.57),('1444','2014-03-12','09:00:00',1.64),('1444','2014-03-12','09:05:00',1.69),('1444','2014-03-12','09:10:00',1.74),('1444','2014-03-12','09:15:00',1.79),('1444','2014-03-12','09:20:00',1.85),('1444','2014-03-12','09:25:00',1.91),('1444','2014-03-12','09:30:00',1.96),('1444','2014-03-12','09:35:00',2),('1444','2014-03-12','09:40:00',2.05),('1444','2014-03-12','09:45:00',2.09),('1444','2014-03-12','09:50:00',2.13),('1444','2014-03-12','09:55:00',2.18),('1444','2014-03-12','10:00:00',2.23),('1444','2014-03-12','10:05:00',2.28),('1444','2014-03-12','10:10:00',2.32),('1444','2014-03-12','10:15:00',2.35),('1444','2014-03-12','10:20:00',2.37),('1444','2014-03-12','10:25:00',2.41),('1444','2014-03-12','10:30:00',2.45),('1444','2014-03-12','10:35:00',2.49),('1444','2014-03-12','10:40:00',2.52),('1444','2014-03-12','10:45:00',2.56),('1444','2014-03-12','10:50:00',2.6),('1444','2014-03-12','10:55:00',2.62),('1444','2014-03-12','11:00:00',2.62),('1444','2014-03-12','11:05:00',2.66),('1444','2014-03-12','11:10:00',2.7),('1444','2014-03-12','11:15:00',2.73),('1444','2014-03-12','11:20:00',2.75),('1444','2014-03-12','11:25:00',2.76),('1444','2014-03-12','11:30:00',2.78),('1444','2014-03-12','11:35:00',2.79),('1444','2014-03-12','11:40:00',2.79),('1444','2014-03-12','11:45:00',2.79),('1444','2014-03-12','11:50:00',2.8),('1444','2014-03-12','11:55:00',2.81),('1444','2014-03-12','12:00:00',2.81),('1444','2014-03-12','12:05:00',2.81),('1444','2014-03-12','12:10:00',2.82),('1444','2014-03-12','12:15:00',2.8),('1444','2014-03-12','12:20:00',2.79),('1444','2014-03-12','12:25:00',2.8),('1444','2014-03-12','12:30:00',2.79),('1444','2014-03-12','12:35:00',2.78),('1444','2014-03-12','12:40:00',2.78),('1444','2014-03-12','12:45:00',2.76),('1444','2014-03-12','12:50:00',2.75),('1444','2014-03-12','12:55:00',2.72),('1444','2014-03-12','13:00:00',2.73),('1444','2014-03-12','13:05:00',2.71),('1444','2014-03-12','13:10:00',2.68),('1444','2014-03-12','13:15:00',2.65),('1444','2014-03-12','13:20:00',2.64),('1444','2014-03-12','13:25:00',2.63),('1444','2014-03-12','13:30:00',2.6),('1444','2014-03-12','13:35:00',2.55),('1444','2014-03-12','13:40:00',2.51),('1444','2014-03-12','13:45:00',2.51),('1444','2014-03-12','13:50:00',2.48),('1444','2014-03-12','13:55:00',2.45),('1444','2014-03-12','14:00:00',2.43),('1444','2014-03-12','14:05:00',2.4),('1444','2014-03-12','14:10:00',2.37),('1444','2014-03-12','14:15:00',2.31),('1444','2014-03-12','14:20:00',2.29),('1444','2014-03-12','14:25:00',2.26),('1444','2014-03-12','14:30:00',2.22),('1444','2014-03-12','14:35:00',2.13),('1444','2014-03-12','14:40:00',2.04),('1444','2014-03-12','14:45:00',2.01),('1444','2014-03-12','14:50:00',1.95),('1444','2014-03-12','14:55:00',1.93),('1444','2014-03-12','15:00:00',1.74),('1444','2014-03-12','15:05:00',1.77),('1444','2014-03-12','15:10:00',1.74),('1444','2014-03-12','15:15:00',1.69),('1444','2014-03-12','15:20:00',1.62),('1444','2014-03-12','15:25:00',1.56),('1444','2014-03-12','15:30:00',1.51),('1444','2014-03-12','15:35:00',1.45),('1444','2014-03-12','15:40:00',1.42),('1444','2014-03-12','15:45:00',1.37),('1444','2014-03-12','15:50:00',1.31),('1444','2014-03-12','15:55:00',1.25),('1444','2014-03-12','16:00:00',1.21),('1444','2014-03-12','16:05:00',1.15),('1444','2014-03-12','16:10:00',1.07),('1444','2014-03-12','16:15:00',1.01),('1444','2014-03-11','12:20:00',1.06),('1444','2014-03-11','12:35:00',1.01),('1444','2014-03-11','12:40:00',1.09),('1444','2014-03-11','12:45:00',1.08),('1444','2014-03-11','12:50:00',1.03),('1444','2014-03-11','13:05:00',1.06),('1444','2014-03-11','13:10:00',1.06),('1444','2014-03-11','13:20:00',1.04),('1444','2014-03-11','13:45:00',1.09),('1444','2014-03-11','13:50:00',1.29),('1444','2014-03-11','13:55:00',1.48),('1444','2014-03-11','14:00:00',1.53),('1444','2014-03-11','14:05:00',1.5),('1444','2014-03-11','14:10:00',1.8),('1444','2014-03-11','14:15:00',2.09),('1444','2014-03-11','14:20:00',1.97),('1444','2014-03-11','14:25:00',1.49),('1444','2014-03-11','14:30:00',1.09),('1444','2014-03-11','14:35:00',1.15),('1444','2014-03-11','14:40:00',1.08),('1444','2014-03-11','14:45:00',1.13),('1444','2014-03-11','14:50:00',1.04),('1444','2014-03-11','14:55:00',1.03),('1444','2014-03-11','15:00:00',1.19),('1444','2014-03-11','15:05:00',1.26),('1444','2014-03-11','15:10:00',1.39),('1444','2014-03-11','15:15:00',1.28),('1444','2014-03-11','15:20:00',1.21),('1444','2014-03-11','15:25:00',1.04),('1444','2014-03-10','13:05:00',1.01),('1444','2014-03-10','13:10:00',1.07),('1444','2014-03-10','13:15:00',1.17),('1444','2014-03-10','13:20:00',1.18),('1444','2014-03-10','13:25:00',1.08),('1444','2014-03-10','13:55:00',1.01),('1444','2014-03-10','14:05:00',1.34),('1444','2014-03-10','14:10:00',1.54),('1444','2014-03-10','14:15:00',2.18),('1444','2014-03-10','14:20:00',1.48),('1444','2014-03-10','14:25:00',1.24),('1444','2014-03-10','14:30:00',1.11),('1444','2014-03-10','14:35:00',1.49),('1444','2014-03-10','14:40:00',2.14),('1444','2014-03-10','14:45:00',2.19),('1444','2014-03-10','14:50:00',1.99),('1444','2014-03-10','15:00:00',1.39),('1444','2014-03-10','15:05:00',1.14),('1444','2014-03-10','15:15:00',1.03),('1444','2014-03-10','15:20:00',1.38),('1444','2014-03-10','15:25:00',1.7),('1444','2014-03-10','15:30:00',1.39),('1444','2014-03-10','15:35:00',1.04),('1444','2014-03-09','08:20:00',1.01),('1444','2014-03-09','08:25:00',1),('1444','2014-03-09','08:55:00',1.18),('1444','2014-03-09','09:00:00',1.45),('1444','2014-03-09','09:05:00',1.42),('1444','2014-03-09','09:15:00',1.71),('1444','2014-03-09','09:20:00',1.84),('1444','2014-03-09','09:25:00',1.94),('1444','2014-03-09','09:30:00',2),('1444','2014-03-09','09:35:00',2.14),('1444','2014-03-09','09:40:00',2.19),('1444','2014-03-09','09:45:00',2.23),('1444','2014-03-09','09:50:00',2.25),('1444','2014-03-09','09:55:00',2.26),('1444','2014-03-09','10:00:00',2.28),('1444','2014-03-09','10:05:00',2.3),('1444','2014-03-09','10:10:00',2.37),('1444','2014-03-09','10:15:00',2.39),('1444','2014-03-09','10:20:00',2.4),('1444','2014-03-09','10:25:00',2.46),('1444','2014-03-09','10:30:00',2.51),('1444','2014-03-09','10:35:00',2.54),('1444','2014-03-09','10:40:00',2.54),('1444','2014-03-09','10:45:00',2.58),('1444','2014-03-09','10:50:00',2.61),('1444','2014-03-09','10:55:00',2.74),('1444','2014-03-09','11:00:00',2.89),('1444','2014-03-09','11:05:00',2.89),('1444','2014-03-09','11:10:00',3),('1444','2014-03-09','11:15:00',3.12),('1444','2014-03-09','11:20:00',2.36),('1444','2014-03-09','11:25:00',1.47),('1444','2014-03-09','11:30:00',1),('1444','2014-03-09','11:35:00',1.85),('1444','2014-03-09','11:40:00',1.71),('1444','2014-03-09','11:45:00',1.19),('1444','2014-03-09','11:50:00',2.44),('1444','2014-03-09','11:55:00',2.47),('1444','2014-03-09','12:00:00',2.63),('1444','2014-03-09','12:05:00',2.58),('1444','2014-03-09','12:10:00',3.11),('1444','2014-03-09','12:15:00',3.14),('1444','2014-03-09','12:20:00',3.21),('1444','2014-03-09','12:25:00',3.14),('1444','2014-03-09','12:30:00',3.13),('1444','2014-03-09','12:35:00',3.27),('1444','2014-03-09','12:40:00',3.09),('1444','2014-03-09','12:45:00',3.01),('1444','2014-03-09','12:50:00',3.02),('1444','2014-03-09','12:55:00',3.05),('1444','2014-03-09','13:00:00',3.14),('1444','2014-03-09','13:05:00',3.15),('1444','2014-03-09','13:10:00',3.08),('1444','2014-03-09','13:15:00',2.92),('1444','2014-03-09','13:20:00',2.89),('1444','2014-03-09','13:25:00',2.78),('1444','2014-03-09','13:30:00',2.8),('1444','2014-03-09','13:35:00',2.59),('1444','2014-03-09','13:40:00',1.08),('1444','2014-03-09','13:50:00',2.28),('1444','2014-03-09','14:05:00',2.59),('1444','2014-03-09','14:10:00',2.48),('1444','2014-03-09','14:15:00',2.42),('1444','2014-03-09','14:20:00',1.3),('1444','2014-03-09','14:25:00',2.54),('1444','2014-03-09','14:30:00',1.55),('1444','2014-03-09','14:45:00',1.25),('1444','2014-03-09','14:50:00',1.36),('1444','2014-03-09','14:55:00',2.09),('1444','2014-03-09','15:00:00',2.02),('1444','2014-03-09','15:05:00',1.95),('1444','2014-03-09','15:10:00',1.86),('1444','2014-03-09','15:15:00',1.81),('1444','2014-03-09','15:20:00',1.77),('1444','2014-03-09','15:25:00',1.76),('1444','2014-03-09','15:30:00',1.71),('1444','2014-03-09','15:35:00',1.62),('1444','2014-03-09','15:40:00',1.53),('1444','2014-03-09','15:45:00',1.37),('1444','2014-03-09','15:55:00',1.29),('1444','2014-03-09','16:00:00',1.34),('1444','2014-03-09','16:05:00',1.2),('1444','2014-03-08','08:20:00',1.04),('1444','2014-03-08','08:25:00',1.1),('1444','2014-03-08','08:30:00',1.17),('1444','2014-03-08','08:35:00',1.23),('1444','2014-03-08','08:40:00',1.3),('1444','2014-03-08','08:45:00',1.36),('1444','2014-03-08','08:50:00',1.43),('1444','2014-03-08','08:55:00',1.49),('1444','2014-03-08','09:00:00',1.56),('1444','2014-03-08','09:05:00',1.62),('1444','2014-03-08','09:10:00',1.67),('1444','2014-03-08','09:15:00',1.72),('1444','2014-03-08','09:20:00',1.79),('1444','2014-03-08','09:25:00',1.85),('1444','2014-03-08','09:30:00',1.9),('1444','2014-03-08','09:35:00',1.95),('1444','2014-03-08','09:40:00',1.99),('1444','2014-03-08','09:45:00',2.04),('1444','2014-03-08','09:50:00',2.09),('1444','2014-03-08','09:55:00',2.14),('1444','2014-03-08','10:00:00',2.17),('1444','2014-03-08','10:05:00',2.22),('1444','2014-03-08','10:10:00',2.27),('1444','2014-03-08','10:15:00',2.3),('1444','2014-03-08','10:20:00',2.33),('1444','2014-03-08','10:25:00',2.39),('1444','2014-03-08','10:30:00',2.44),('1444','2014-03-08','10:35:00',2.46),('1444','2014-03-08','10:40:00',2.51),('1444','2014-03-08','10:45:00',2.55),('1444','2014-03-08','10:50:00',2.55),('1444','2014-03-08','10:55:00',2.58),('1444','2014-03-08','11:00:00',2.61),('1444','2014-03-08','11:05:00',2.63),('1444','2014-03-08','11:10:00',2.66),('1444','2014-03-08','11:15:00',2.71),('1444','2014-03-08','11:20:00',2.75),('1444','2014-03-08','11:25:00',2.82),('1444','2014-03-08','11:30:00',2.97),('1444','2014-03-08','11:35:00',2.81),('1444','2014-03-08','11:40:00',2.14),('1444','2014-03-08','11:45:00',1.51),('1444','2014-03-08','11:50:00',1.11),('1444','2014-03-08','11:55:00',2.08),('1444','2014-03-08','12:00:00',1.54),('1444','2014-03-08','12:20:00',1.01),('1444','2014-03-08','12:25:00',1.14),('1444','2014-03-08','12:30:00',1.23),('1444','2014-03-08','12:35:00',2.43),('1444','2014-03-08','12:40:00',1.58),('1444','2014-03-08','12:45:00',1.66),('1444','2014-03-08','12:50:00',2.11),('1444','2014-03-08','12:55:00',2.45),('1444','2014-03-08','13:00:00',1.71),('1444','2014-03-08','13:05:00',1.31),('1444','2014-03-08','13:10:00',1.16),('1444','2014-03-08','13:30:00',1.23),('1444','2014-03-08','13:35:00',1.28),('1444','2014-03-08','13:40:00',1.85),('1444','2014-03-08','13:45:00',2.11),('1444','2014-03-08','13:50:00',1.9),('1444','2014-03-08','13:55:00',1.1),('1444','2014-03-08','15:20:00',1.12),('1444','2014-03-08','15:25:00',1.04),('1444','2014-03-08','15:30:00',1.5),('1444','2014-04-30','08:00:00',1.05),('1444','2014-04-30','08:05:00',1.1),('1444','2014-04-30','08:10:00',1.19),('1444','2014-04-30','08:15:00',1.24),('1444','2014-04-30','08:20:00',1.3),('1444','2014-04-30','08:25:00',1.36),('1444','2014-04-30','08:30:00',1.43),('1444','2014-04-30','08:35:00',1.49),('1444','2014-04-30','08:40:00',1.55),('1444','2014-04-30','08:45:00',1.59),('1444','2014-04-30','08:50:00',1.45),('1444','2014-04-30','08:55:00',1.35),('1444','2014-04-30','09:00:00',1.97),('1444','2014-04-30','09:05:00',2),('1444','2014-04-30','09:10:00',1.76),('1444','2014-04-30','09:15:00',1.39),('1444','2014-04-30','09:20:00',1.78),('1444','2014-04-30','09:25:00',1.42),('1444','2014-04-30','09:35:00',2.22),('1444','2014-04-30','09:40:00',2.41),('1444','2014-04-30','09:45:00',2.12),('1444','2014-04-30','09:50:00',1.81),('1444','2014-04-30','09:55:00',2.7),('1444','2014-04-30','10:00:00',2.91),('1444','2014-04-30','10:05:00',1.97),('1444','2014-04-30','10:10:00',2.16),('1444','2014-04-30','10:15:00',2.21),('1444','2014-04-30','10:20:00',1.31),('1444','2014-04-30','10:25:00',1.5),('1444','2014-04-30','10:30:00',1.73),('1444','2014-04-30','10:35:00',1.56),('1444','2014-04-30','10:40:00',1.82),('1444','2014-04-30','10:45:00',1.29),('1444','2014-04-30','10:50:00',1.59),('1444','2014-04-30','10:55:00',3.52),('1444','2014-04-30','11:00:00',3.06),('1444','2014-04-30','11:05:00',2.26),('1444','2014-04-30','11:10:00',2.57),('1444','2014-04-30','11:15:00',1.58),('1444','2014-04-30','11:20:00',1.51),('1444','2014-04-30','11:25:00',1.78),('1444','2014-04-30','11:30:00',1.83),('1444','2014-04-30','11:35:00',2.33),('1444','2014-04-30','11:40:00',1.78),('1444','2014-04-30','11:45:00',1.89),('1444','2014-04-30','11:50:00',3.31),('1444','2014-04-30','11:55:00',3.16),('1444','2014-04-30','12:00:00',2.08),('1444','2014-04-30','12:05:00',1.23),('1444','2014-04-30','12:10:00',1.53),('1444','2014-04-30','12:15:00',1.56),('1444','2014-04-30','12:20:00',1.34),('1444','2014-04-30','12:25:00',1.65),('1444','2014-04-30','12:30:00',2.36),('1444','2014-04-30','12:35:00',1.43),('1444','2014-04-30','12:40:00',1.19),('1444','2014-04-30','12:45:00',1.09),('1444','2014-04-30','12:50:00',1.49),('1444','2014-04-30','12:55:00',3.06),('1444','2014-04-30','13:00:00',3.38),('1444','2014-04-30','13:05:00',1.42),('1444','2014-04-30','13:10:00',2.54),('1444','2014-04-30','13:15:00',1.82),('1444','2014-04-30','13:20:00',1.99),('1444','2014-04-30','13:25:00',2.55),('1444','2014-04-30','13:30:00',2.05),('1444','2014-04-30','13:35:00',1.96),('1444','2014-04-30','13:40:00',2.78),('1444','2014-04-30','13:45:00',2.74),('1444','2014-04-30','13:50:00',1.99),('1444','2014-04-30','13:55:00',3.11),('1444','2014-04-30','14:00:00',1.61),('1444','2014-04-30','14:05:00',1.47),('1444','2014-04-30','14:10:00',1.3),('1444','2014-04-30','14:15:00',1.57),('1444','2014-04-30','14:20:00',2.81),('1444','2014-04-30','14:25:00',3.33),('1444','2014-04-30','14:30:00',3.99),('1444','2014-04-30','14:35:00',2.73),('1444','2014-04-30','14:40:00',1.58),('1444','2014-04-30','14:45:00',1.2),('1444','2014-04-30','14:50:00',1.38),('1444','2014-04-30','14:55:00',1.47),('1444','2014-04-30','15:00:00',1.27),('1444','2014-04-30','15:05:00',1.23),('1444','2014-04-30','15:10:00',1.27),('1444','2014-04-30','15:15:00',1.12),('1444','2014-04-30','15:25:00',1.05),('1444','2014-04-30','15:30:00',1.4),('1444','2014-04-30','15:35:00',2.2),('1444','2014-04-30','15:40:00',3.37),('1444','2014-04-30','15:45:00',2.58),('1444','2014-04-30','15:50:00',3.2),('1444','2014-04-30','15:55:00',1.63),('1444','2014-04-30','16:00:00',1.55),('1444','2014-04-30','16:05:00',1.52),('1444','2014-04-30','16:10:00',1.54),('1444','2014-04-30','16:15:00',2.81),('1444','2014-04-30','16:20:00',1.2),('1444','2014-04-30','16:25:00',2.02),('1444','2014-04-30','16:30:00',2.32),('1444','2014-04-30','16:35:00',1.5),('1444','2014-04-30','16:40:00',2.41),('1444','2014-04-30','16:45:00',1.13),('1444','2014-04-30','16:50:00',1.48),('1444','2014-04-30','16:55:00',1.29),('1444','2014-04-30','17:00:00',2.11),('1444','2014-04-30','17:05:00',1.37),('1444','2014-04-30','17:10:00',1.48),('1444','2014-04-30','17:15:00',1.06),('1444','2014-04-30','17:35:00',1.07),('1444','2014-03-07','11:45:00',1.46),('1444','2014-03-07','11:50:00',2.85),('1444','2014-03-07','11:55:00',3.01),('1444','2014-03-07','12:00:00',3.41),('1444','2014-03-07','12:05:00',3.22),('1444','2014-03-07','12:10:00',3.12),('1444','2014-03-07','12:15:00',3.02),('1444','2014-03-07','12:20:00',3.05),('1444','2014-03-07','12:25:00',2.76),('1444','2014-03-07','12:30:00',1.16),('1444','2014-03-07','12:35:00',1.95),('1444','2014-03-07','12:40:00',1.57),('1444','2014-03-07','12:50:00',1.24),('1444','2014-03-07','12:55:00',1.8),('1444','2014-03-07','13:00:00',2.99),('1444','2014-03-07','13:05:00',2.87),('1444','2014-03-07','13:10:00',1.61),('1444','2014-03-07','13:15:00',1.37),('1444','2014-03-07','13:20:00',2.05),('1444','2014-03-07','13:25:00',2.76),('1444','2014-03-07','13:30:00',2.74),('1444','2014-03-07','13:35:00',2.11),('1444','2014-03-07','13:40:00',2.11),('1444','2014-03-07','13:45:00',1.91),('1444','2014-03-07','13:50:00',1.24),('1444','2014-03-07','14:40:00',1.01),('1444','2014-03-07','14:45:00',1.03),('1444','2014-03-07','14:50:00',1.32),('1444','2014-03-07','14:55:00',1.84),('1444','2014-03-07','15:00:00',2.2),('1444','2014-03-07','15:05:00',2.36),('1444','2014-03-07','15:10:00',2.38),('1444','2014-03-07','15:15:00',2.39),('1444','2014-03-07','15:20:00',2.35),('1444','2014-03-07','15:25:00',2.22),('1444','2014-03-07','15:30:00',2.09),('1444','2014-03-07','15:35:00',1.95),('1444','2014-03-07','15:40:00',1.43),('1444','2014-03-07','15:45:00',1.36),('1444','2014-03-07','15:50:00',1.26),('1444','2014-03-07','15:55:00',1.22),('1444','2014-03-07','16:00:00',1.38),('1444','2014-03-07','16:05:00',1.3),('1444','2014-03-07','16:10:00',1.24),('1444','2014-03-07','16:15:00',1.24),('1444','2014-03-07','16:20:00',1.12),('1444','2014-03-07','16:25:00',1.05),('1444','2014-03-06','08:10:00',1.1),('1444','2014-03-06','08:15:00',1.37),('1444','2014-03-06','08:20:00',1.28),('1444','2014-03-06','09:40:00',1.05),('1444','2014-03-06','09:45:00',1.16),('1444','2014-03-06','09:50:00',1.32),('1444','2014-03-06','09:55:00',1.64),('1444','2014-03-06','10:00:00',1.75),('1444','2014-03-06','10:05:00',1.8),('1444','2014-03-06','10:10:00',1.91),('1444','2014-03-06','10:15:00',2.28),('1444','2014-03-06','10:20:00',2.37),('1444','2014-03-06','10:25:00',1.31),('1444','2014-03-06','10:40:00',1.73),('1444','2014-03-06','10:50:00',1.34),('1444','2014-03-06','10:55:00',1.07),('1444','2014-03-06','11:00:00',2.07),('1444','2014-03-06','11:05:00',2.42),('1444','2014-03-06','11:10:00',2.34),('1444','2014-03-06','11:15:00',1.77),('1444','2014-03-06','11:20:00',2.05),('1444','2014-03-06','11:25:00',2.06),('1444','2014-03-06','11:30:00',1.46),('1444','2014-03-06','11:35:00',1.11),('1444','2014-03-06','11:40:00',1.45),('1444','2014-03-06','11:45:00',2.37),('1444','2014-03-06','11:50:00',2.99),('1444','2014-03-06','11:55:00',2.75),('1444','2014-03-06','12:00:00',1.32),('1444','2014-03-06','12:05:00',1.42),('1444','2014-03-06','12:10:00',3.21),('1444','2014-03-06','12:15:00',2.08),('1444','2014-03-06','12:20:00',1.04),('1444','2014-03-06','12:25:00',1.5),('1444','2014-03-06','12:30:00',2.82),('1444','2014-03-06','12:35:00',1.72),('1444','2014-03-06','12:40:00',1.15),('1444','2014-03-06','12:55:00',1.03),('1444','2014-03-06','13:00:00',1.62),('1444','2014-03-06','13:05:00',1.2),('1444','2014-03-06','13:10:00',1.01),('1444','2014-03-06','13:15:00',1.04),('1444','2014-03-06','14:35:00',1.41),('1444','2014-03-06','14:40:00',1.03),('1444','2014-03-06','15:05:00',1),('1444','2014-03-05','08:10:00',1.01),('1444','2014-03-05','08:15:00',1.16),('1444','2014-03-05','08:35:00',1.51),('1444','2014-03-05','08:40:00',1.19),('1444','2014-03-05','08:45:00',1.58),('1444','2014-03-05','08:50:00',1.21),('1444','2014-03-05','09:00:00',1.26),('1444','2014-03-05','09:05:00',1.75),('1444','2014-03-05','09:15:00',1.47),('1444','2014-03-05','09:20:00',1.84),('1444','2014-03-05','09:25:00',1.86),('1444','2014-03-05','09:30:00',1.91),('1444','2014-03-05','09:35:00',1.97),('1444','2014-03-05','09:40:00',2.01),('1444','2014-03-05','09:45:00',2.06),('1444','2014-03-05','09:50:00',2.1),('1444','2014-03-05','09:55:00',2.14),('1444','2014-03-05','10:00:00',2.19),('1444','2014-03-05','10:05:00',2.23),('1444','2014-03-05','10:10:00',1.79),('1444','2014-03-05','10:15:00',2.35),('1444','2014-03-05','10:20:00',2.29),('1444','2014-03-05','10:25:00',2.38),('1444','2014-03-05','10:30:00',2.41),('1444','2014-03-05','10:35:00',2.45),('1444','2014-03-05','10:40:00',2.47),('1444','2014-03-05','10:45:00',2.49),('1444','2014-03-05','10:50:00',2.51),('1444','2014-03-05','10:55:00',2.55),('1444','2014-03-05','11:00:00',2.59),('1444','2014-03-05','11:05:00',2.64),('1444','2014-03-05','11:10:00',2.66),('1444','2014-03-05','11:15:00',2.59),('1444','2014-03-05','11:20:00',2.74),('1444','2014-03-05','11:25:00',2.76),('1444','2014-03-05','11:30:00',2.8),('1444','2014-03-05','11:35:00',2.87),('1444','2014-03-05','11:40:00',2.85),('1444','2014-03-05','11:45:00',2.88),('1444','2014-03-05','11:50:00',2.82),('1444','2014-03-05','11:55:00',2.46),('1444','2014-03-05','12:00:00',2.54),('1444','2014-03-05','12:05:00',2.29),('1444','2014-03-05','12:10:00',1.71),('1444','2014-03-05','12:15:00',1.14),('1444','2014-03-05','12:35:00',1.34),('1444','2014-03-05','12:40:00',1.49),('1444','2014-03-05','12:50:00',1.21),('1444','2014-03-05','12:55:00',1.01),('1444','2014-03-05','13:00:00',1.23),('1444','2014-03-05','13:05:00',1.59),('1444','2014-03-05','13:10:00',2.44),('1444','2014-03-05','13:15:00',2.17),('1444','2014-03-05','13:20:00',1.68),('1444','2014-03-05','13:30:00',1.01),('1444','2014-03-05','13:40:00',1.22),('1444','2014-03-05','13:45:00',1.23),('1444','2014-03-05','13:50:00',1.01),('1444','2014-03-05','14:25:00',1.25),('1444','2014-03-05','14:30:00',1.13),('1444','2014-03-05','14:40:00',1.18),('1444','2014-03-05','14:45:00',1.75),('1444','2014-03-05','14:50:00',2.45),('1444','2014-03-05','14:55:00',1.89),('1444','2014-03-05','15:45:00',1.35),('1444','2014-03-05','15:50:00',1.05),('1444','2014-03-05','15:55:00',1.55),('1444','2014-03-05','16:00:00',1.99),('1444','2014-03-05','16:05:00',1.83),('1444','2014-03-05','16:10:00',1.54),('1444','2014-03-05','16:15:00',1.17),('1444','2014-03-04','09:05:00',1.03),('1444','2014-03-04','09:15:00',1.77),('1444','2014-03-04','09:20:00',1.46),('1444','2014-03-04','09:40:00',1.48),('1444','2014-03-04','09:55:00',1.53),('1444','2014-03-04','10:00:00',1.02),('1444','2014-03-04','10:25:00',2.88),('1444','2014-03-04','10:30:00',1.27),('1444','2014-03-04','10:35:00',2.71),('1444','2014-03-04','10:40:00',3.02),('1444','2014-03-04','10:45:00',2.59),('1444','2014-03-04','10:55:00',2.73),('1444','2014-03-04','11:00:00',1.12),('1444','2014-03-04','11:05:00',1.38),('1444','2014-03-04','11:10:00',2.95),('1444','2014-03-04','11:15:00',3.38),('1444','2014-03-04','11:20:00',1.91),('1444','2014-03-04','11:45:00',1.61),('1444','2014-03-04','11:50:00',3.55),('1444','2014-03-04','11:55:00',2.97),('1444','2014-03-04','12:00:00',2.9),('1444','2014-03-04','12:05:00',2.86),('1444','2014-03-04','12:10:00',2.84),('1444','2014-03-04','12:15:00',2.82),('1444','2014-03-04','12:20:00',2.79),('1444','2014-03-04','12:25:00',2.88),('1444','2014-03-04','12:30:00',2.79),('1444','2014-03-04','12:35:00',2.77),('1444','2014-03-04','12:40:00',2.82),('1444','2014-03-04','12:45:00',1.97),('1444','2014-03-04','12:50:00',2.38),('1444','2014-03-04','12:55:00',2.09),('1444','2014-03-04','13:00:00',2.6),('1444','2014-03-04','13:05:00',2.36),('1444','2014-03-04','13:10:00',2.94),('1444','2014-03-04','13:15:00',1.6),('1444','2014-03-04','13:20:00',1.19),('1444','2014-03-04','14:05:00',1.33),('1444','2014-03-04','14:10:00',1.63),('1444','2014-03-04','14:15:00',2.2),('1444','2014-03-04','14:20:00',1.51),('1444','2014-03-04','14:25:00',2.44),('1444','2014-03-04','14:30:00',2.29),('1444','2014-03-04','14:35:00',2.2),('1444','2014-03-04','14:40:00',2),('1444','2014-03-04','14:45:00',2.03),('1444','2014-03-04','14:50:00',1.81),('1444','2014-03-04','14:55:00',1.37),('1444','2014-03-04','15:00:00',1.98),('1444','2014-03-04','15:05:00',1.96),('1444','2014-03-04','15:10:00',1.74),('1444','2014-03-04','15:15:00',1.45),('1444','2014-03-04','15:20:00',1.04),('1444','2014-03-04','15:25:00',1.49),('1444','2014-03-04','15:35:00',1.91),('1444','2014-03-04','15:40:00',1.6),('1444','2014-03-04','15:45:00',1.07),('1444','2014-03-04','15:50:00',1.18),('1444','2014-03-03','08:20:00',1.01),('1444','2014-03-03','08:25:00',1.07),('1444','2014-03-03','08:30:00',1.14),('1444','2014-03-03','08:35:00',1.2),('1444','2014-03-03','08:40:00',1.28),('1444','2014-03-03','08:45:00',1.35),('1444','2014-03-03','08:50:00',1.34),('1444','2014-03-03','08:55:00',1.49),('1444','2014-03-03','09:00:00',1.5),('1444','2014-03-03','09:05:00',1.46),('1444','2014-03-03','09:10:00',1.36),('1444','2014-03-03','09:15:00',1.5),('1444','2014-03-03','09:20:00',1.69),('1444','2014-03-03','09:25:00',1.79),('1444','2014-03-03','09:30:00',1.86),('1444','2014-03-03','09:35:00',1.75),('1444','2014-03-03','09:40:00',1.5),('1444','2014-03-03','09:45:00',1.68),('1444','2014-03-03','09:50:00',1.75),('1444','2014-03-03','09:55:00',1.87),('1444','2014-03-03','10:00:00',2.01),('1444','2014-03-03','10:05:00',2.15),('1444','2014-03-03','10:10:00',2.18),('1444','2014-03-03','10:15:00',2.23),('1444','2014-03-03','10:20:00',2.22),('1444','2014-03-03','10:25:00',2.24),('1444','2014-03-03','10:30:00',2.29),('1444','2014-03-03','10:35:00',2.36),('1444','2014-03-03','10:40:00',2.39),('1444','2014-03-03','10:45:00',2.4),('1444','2014-03-03','10:50:00',2.42),('1444','2014-03-03','10:55:00',2.46),('1444','2014-03-03','11:00:00',2.5),('1444','2014-03-03','11:05:00',2.51),('1444','2014-03-03','11:10:00',2.53),('1444','2014-03-03','11:15:00',2.55),('1444','2014-03-03','11:20:00',2.56),('1444','2014-03-03','11:25:00',2.61),('1444','2014-03-03','11:30:00',2.66),('1444','2014-03-03','11:35:00',1.38),('1444','2014-03-03','11:40:00',2.36),('1444','2014-03-03','11:45:00',2.72),('1444','2014-03-03','11:50:00',2.7),('1444','2014-03-03','11:55:00',2.75),('1444','2014-03-03','12:00:00',2.73),('1444','2014-03-03','12:05:00',2.75),('1444','2014-03-03','12:10:00',2.76),('1444','2014-03-03','12:15:00',2.75),('1444','2014-03-03','12:20:00',2.76),('1444','2014-03-03','12:25:00',2.76),('1444','2014-03-03','12:30:00',2.76),('1444','2014-03-03','12:35:00',2.75),('1444','2014-03-03','12:40:00',2.74),('1444','2014-03-03','12:45:00',2.73),('1444','2014-03-03','12:50:00',2.72),('1444','2014-03-03','12:55:00',2.7),('1444','2014-03-03','13:00:00',2.69),('1444','2014-03-03','13:05:00',2.67),('1444','2014-03-03','13:10:00',2.65),('1444','2014-03-03','13:15:00',2.62),('1444','2014-03-03','13:20:00',2.63),('1444','2014-03-03','13:25:00',2.6),('1444','2014-03-03','13:30:00',2.59),('1444','2014-03-03','13:35:00',2.57),('1444','2014-03-03','13:40:00',2.55),('1444','2014-03-03','13:45:00',2.52),('1444','2014-03-03','13:50:00',2.51),('1444','2014-03-03','13:55:00',2.45),('1444','2014-03-03','14:00:00',2.43),('1444','2014-03-03','14:05:00',2.38),('1444','2014-03-03','14:10:00',2.39),('1444','2014-03-03','14:15:00',2.38),('1444','2014-03-03','14:20:00',2.29),('1444','2014-03-03','14:25:00',2.28),('1444','2014-03-03','14:30:00',2.22),('1444','2014-03-03','14:35:00',2.17),('1444','2014-03-03','14:40:00',2.12),('1444','2014-03-03','14:45:00',2.04),('1444','2014-03-03','14:50:00',1.98),('1444','2014-03-03','14:55:00',1.94),('1444','2014-03-03','15:00:00',1.88),('1444','2014-03-03','15:05:00',1.85),('1444','2014-03-03','15:10:00',1.78),('1444','2014-03-03','15:15:00',1.74),('1444','2014-03-03','15:20:00',1.69),('1444','2014-03-03','15:25:00',1.63),('1444','2014-03-03','15:30:00',1.56),('1444','2014-03-03','15:35:00',1.5),('1444','2014-03-03','15:40:00',1.44),('1444','2014-03-03','15:45:00',1.36),('1444','2014-03-03','15:50:00',1.31),('1444','2014-03-03','15:55:00',1.23),('1444','2014-03-03','16:00:00',1.17),('1444','2014-03-03','16:05:00',1.11),('1444','2014-03-03','16:10:00',1.06),('1444','2014-03-02','08:10:00',1.26),('1444','2014-03-02','08:15:00',1.18),('1444','2014-03-02','08:20:00',1.15),('1444','2014-03-02','08:25:00',1.09),('1444','2014-03-02','08:30:00',1.11),('1444','2014-03-02','08:35:00',1.15),('1444','2014-03-02','08:40:00',1.23),('1444','2014-03-02','08:45:00',1.3),('1444','2014-03-02','08:50:00',1.38),('1444','2014-03-02','08:55:00',1.44),('1444','2014-03-02','09:00:00',1.52),('1444','2014-03-02','09:05:00',1.6),('1444','2014-03-02','09:10:00',1.71),('1444','2014-03-02','09:15:00',1.75),('1444','2014-03-02','09:20:00',1.51),('1444','2014-03-02','09:25:00',1.97),('1444','2014-03-02','09:30:00',2.05),('1444','2014-03-02','09:35:00',2.05),('1444','2014-03-02','09:40:00',1.54),('1444','2014-03-02','09:55:00',1.05),('1444','2014-03-02','10:00:00',1.19),('1444','2014-03-02','10:05:00',1.24),('1444','2014-03-02','10:10:00',1.06),('1444','2014-03-02','10:25:00',1.15),('1444','2014-03-02','10:30:00',1.22),('1444','2014-03-02','10:35:00',2.09),('1444','2014-03-02','10:40:00',1.16),('1444','2014-03-02','10:50:00',1.3),('1444','2014-03-02','10:55:00',1.14),('1444','2014-03-02','11:00:00',2.83),('1444','2014-03-02','11:05:00',1.8),('1444','2014-03-02','11:10:00',1.17),('1444','2014-03-02','11:15:00',1.05),('1444','2014-03-02','11:20:00',1.42),('1444','2014-03-02','11:25:00',1.51),('1444','2014-03-02','11:30:00',1.79),('1444','2014-03-02','11:35:00',1.99),('1444','2014-03-02','11:40:00',2.26),('1444','2014-03-02','11:45:00',3.47),('1444','2014-03-02','11:50:00',3.18),('1444','2014-03-02','11:55:00',3.02),('1444','2014-03-02','12:00:00',1.9),('1444','2014-03-02','12:05:00',1.38),('1444','2014-03-02','12:10:00',1.6),('1444','2014-03-02','12:15:00',1.84),('1444','2014-03-02','12:20:00',1.71),('1444','2014-03-02','12:25:00',1.73),('1444','2014-03-02','12:30:00',1.11),('1444','2014-03-02','12:55:00',1.05),('1444','2014-03-02','13:00:00',1.16),('1444','2014-03-02','13:05:00',1.2),('1444','2014-03-02','13:10:00',1.14),('1444','2014-03-02','14:05:00',1.06),('1444','2014-03-02','14:10:00',1.03),('1444','2014-03-02','15:05:00',1.03),('1444','2014-03-02','15:10:00',1.05),('1444','2014-03-02','15:15:00',1.03),('1444','2014-03-02','15:20:00',1.06),('1444','2014-03-02','15:25:00',1.06),('1444','2014-03-02','15:30:00',1.04),('1444','2014-03-02','15:35:00',1.03),('1444','2014-03-02','15:40:00',1),('1444','2014-02-28','08:20:00',1.11),('1444','2014-02-28','08:35:00',1.59),('1444','2014-02-28','09:25:00',1.19),('1444','2014-02-28','09:30:00',1.27),('1444','2014-02-28','09:40:00',1.88),('1444','2014-02-28','09:45:00',2.14),('1444','2014-02-28','09:50:00',2.53),('1444','2014-02-28','09:55:00',1.56),('1444','2014-02-28','10:10:00',1.08),('1444','2014-02-28','10:20:00',1.38),('1444','2014-02-28','10:25:00',2.4),('1444','2014-02-28','10:30:00',2.76),('1444','2014-02-28','10:35:00',1.94),('1444','2014-02-28','11:20:00',1.06),('1444','2014-02-28','12:00:00',1.2),('1444','2014-02-28','12:05:00',1.68),('1444','2014-02-28','12:10:00',1.47),('1444','2014-02-28','12:25:00',1.76),('1444','2014-02-28','12:30:00',1.43),('1444','2014-02-28','12:35:00',2.68),('1444','2014-02-28','12:40:00',1.48),('1444','2014-02-28','12:45:00',1.04),('1444','2014-02-28','12:50:00',1.84),('1444','2014-02-28','12:55:00',1.25),('1444','2014-02-28','13:00:00',2.17),('1444','2014-02-28','13:05:00',1.43),('1444','2014-02-28','13:10:00',1.26),('1444','2014-02-28','13:45:00',1.02),('1444','2014-02-28','13:50:00',2.78),('1444','2014-02-28','13:55:00',1.82),('1444','2014-02-28','14:00:00',1.1),('1444','2014-02-28','14:15:00',1.05),('1444','2014-02-28','14:20:00',1.22),('1444','2014-02-28','14:25:00',2.35),('1444','2014-02-28','14:30:00',1.48),('1444','2014-02-28','14:35:00',1.14),('1444','2014-02-28','14:40:00',1.08),('1444','2014-02-28','14:45:00',1.03),('1444','2014-02-28','14:50:00',1.11),('1444','2014-02-28','14:55:00',1.22),('1444','2014-02-28','15:00:00',1.74),('1444','2014-02-28','15:05:00',1),('1444','2014-02-28','15:25:00',1.69),('1444','2014-02-28','15:30:00',1.32),('1444','2014-02-28','15:35:00',1.39),('1444','2014-02-28','15:40:00',1.33),('1444','2014-02-28','16:15:00',1.45),('1444','2014-02-28','16:20:00',1.1),('1444','2014-02-28','16:45:00',1.02),('1444','2014-02-27','10:45:00',1),('1444','2014-02-27','10:50:00',1.05),('1444','2014-02-27','10:55:00',1.08),('1444','2014-02-27','11:00:00',1.25),('1444','2014-02-27','11:05:00',1.36),('1444','2014-02-27','11:10:00',1.29),('1444','2014-02-27','11:15:00',1.27),('1444','2014-02-27','11:20:00',1.15),('1444','2014-02-27','11:25:00',1.33),('1444','2014-02-27','11:30:00',1.55),('1444','2014-02-27','11:35:00',1.39),('1444','2014-02-27','11:40:00',1.2),('1444','2014-02-27','11:45:00',1.03),('1444','2014-02-27','11:50:00',1.02),('1444','2014-02-27','11:55:00',1.06),('1444','2014-02-27','12:00:00',1.02),('1444','2014-02-27','12:20:00',1.02),('1444','2014-02-27','12:25:00',1.04),('1444','2014-02-27','13:00:00',1),('1444','2014-02-27','13:15:00',1.05),('1444','2014-02-27','13:20:00',1.05),('1444','2014-02-27','13:25:00',1.1),('1444','2014-02-27','13:30:00',1.25),('1444','2014-02-27','13:35:00',1.34),('1444','2014-02-27','13:40:00',1.37),('1444','2014-02-27','13:45:00',1.37),('1444','2014-02-27','13:50:00',1.46),('1444','2014-02-27','13:55:00',1.6),('1444','2014-02-27','14:00:00',1.54),('1444','2014-02-27','14:05:00',1.36),('1444','2014-02-27','14:10:00',1.23),('1444','2014-02-27','14:15:00',1.15),('1444','2014-02-27','14:20:00',1.15),('1444','2014-02-27','14:25:00',1.15),('1444','2014-02-27','14:30:00',1.16),('1444','2014-02-27','14:35:00',1.1),('1444','2014-02-27','14:40:00',1.01),('1444','2014-02-27','14:45:00',1.05),('1444','2014-02-27','15:15:00',1.12),('1444','2014-02-27','15:20:00',1.19),('1444','2014-02-27','15:25:00',1.04),('1444','2014-02-27','15:30:00',1.02),('1444','2014-02-27','15:35:00',1),('1444','2014-02-26','08:30:00',1.02),('1444','2014-02-26','08:35:00',1.1),('1444','2014-02-26','08:40:00',1.18),('1444','2014-02-26','08:45:00',1.31),('1444','2014-02-26','08:50:00',1.27),('1444','2014-02-26','08:55:00',1.34),('1444','2014-02-26','09:00:00',1.36),('1444','2014-02-26','09:05:00',1.37),('1444','2014-02-26','09:10:00',1.41),('1444','2014-02-26','09:15:00',1.5),('1444','2014-02-26','09:20:00',1.6),('1444','2014-02-26','09:25:00',1.83),('1444','2014-02-26','09:30:00',1.46),('1444','2014-02-26','09:35:00',1.34),('1444','2014-02-26','09:40:00',1.41),('1444','2014-02-26','09:45:00',1.37),('1444','2014-02-26','09:50:00',1.22),('1444','2014-02-26','12:00:00',1.12),('1444','2014-02-26','12:05:00',1.37),('1444','2014-02-26','12:10:00',1.07),('1444','2014-02-26','12:20:00',1.12),('1444','2014-02-26','12:25:00',1.61),('1444','2014-02-26','12:30:00',2.33),('1444','2014-02-26','12:35:00',2.15),('1444','2014-02-26','12:40:00',2.13),('1444','2014-02-26','12:45:00',1.72),('1444','2014-02-26','12:50:00',2.23),('1444','2014-02-26','12:55:00',2.67),('1444','2014-02-26','13:00:00',2.05),('1444','2014-02-26','13:05:00',2.15),('1444','2014-02-26','13:10:00',2.22),('1444','2014-02-26','13:15:00',2.2),('1444','2014-02-26','13:20:00',2.04),('1444','2014-02-26','13:25:00',2.56),('1444','2014-02-26','13:30:00',2.55),('1444','2014-02-26','13:35:00',2.48),('1444','2014-02-26','13:40:00',2.53),('1444','2014-02-26','13:45:00',1.11),('1444','2014-02-26','13:50:00',1.14),('1444','2014-02-26','13:55:00',2.28),('1444','2014-02-26','14:00:00',2.57),('1444','2014-02-26','14:05:00',1.17),('1444','2014-02-26','14:10:00',1.46),('1444','2014-02-26','14:15:00',2.52),('1444','2014-02-26','14:20:00',2.54),('1444','2014-02-26','14:25:00',2.33),('1444','2014-02-26','14:30:00',1.13),('1444','2014-02-26','14:35:00',2.34),('1444','2014-02-26','14:40:00',1.73),('1444','2014-02-26','14:45:00',2.03),('1444','2014-02-26','14:50:00',2.1),('1444','2014-02-26','14:55:00',2.05),('1444','2014-02-26','15:00:00',1.02),('1444','2014-02-26','15:05:00',1.68),('1444','2014-02-26','15:10:00',1.75),('1444','2014-02-26','15:15:00',1.5),('1444','2014-02-26','15:20:00',1.25),('1444','2014-02-26','15:35:00',1.15),('1444','2014-02-26','15:40:00',1.12),('1444','2014-02-26','15:55:00',1.1),('1444','2014-02-26','16:00:00',1.27),('1444','2014-02-26','16:05:00',1.11),('1444','2014-04-29','10:05:00',1.42),('1444','2014-04-29','10:10:00',2.86),('1444','2014-04-29','10:15:00',2.2),('1444','2014-04-29','10:20:00',2.35),('1444','2014-04-29','10:25:00',3.17),('1444','2014-04-29','10:30:00',2.99),('1444','2014-04-29','10:35:00',2.99),('1444','2014-04-29','10:40:00',3.03),('1444','2014-04-29','10:45:00',3.04),('1444','2014-04-29','10:50:00',3.1),('1444','2014-04-29','10:55:00',2.94),('1444','2014-04-29','11:00:00',3.07),('1444','2014-04-29','11:05:00',3.1),('1444','2014-04-29','11:10:00',2.69),('1444','2014-04-29','11:15:00',3.42),('1444','2014-04-29','11:20:00',1.72),('1444','2014-04-29','11:25:00',2.62),('1444','2014-04-29','11:30:00',1.3),('1444','2014-04-29','11:35:00',1.75),('1444','2014-04-29','11:40:00',2.12),('1444','2014-04-29','11:45:00',1.2),('1444','2014-04-29','12:00:00',1.33),('1444','2014-04-29','12:05:00',1.49),('1444','2014-04-29','12:10:00',1.46),('1444','2014-04-29','12:15:00',1.47),('1444','2014-04-29','12:20:00',2.71),('1444','2014-04-29','12:25:00',1.4),('1444','2014-04-29','12:30:00',1.32),('1444','2014-04-29','12:35:00',1.5),('1444','2014-04-29','12:40:00',1.41),('1444','2014-04-29','12:45:00',2.72),('1444','2014-04-29','12:50:00',1.47),('1444','2014-04-29','12:55:00',1.56),('1444','2014-04-29','13:00:00',2.51),('1444','2014-04-29','13:05:00',1.89),('1444','2014-04-29','13:10:00',2.29),('1444','2014-04-29','13:15:00',2.67),('1444','2014-04-29','13:20:00',3.12),('1444','2014-04-29','13:25:00',2.64),('1444','2014-04-29','13:30:00',1.61),('1444','2014-04-29','13:35:00',1.14),('1444','2014-04-29','13:40:00',1.34),('1444','2014-04-29','13:45:00',2.41),('1444','2014-04-29','13:50:00',1.86),('1444','2014-04-29','17:25:00',1.47),('1444','2014-04-29','17:30:00',1.11),('1444','2014-04-29','17:40:00',1.65),('1444','2014-04-29','17:45:00',1.52),('1444','2014-02-25','08:35:00',1.01),('1444','2014-02-25','08:40:00',1.06),('1444','2014-02-25','08:45:00',1.1),('1444','2014-02-25','08:50:00',1.16),('1444','2014-02-25','08:55:00',1.22),('1444','2014-02-25','09:00:00',1.3),('1444','2014-02-25','09:05:00',1.36),('1444','2014-02-25','09:10:00',1.43),('1444','2014-02-25','09:15:00',1.48),('1444','2014-02-25','09:20:00',1.53),('1444','2014-02-25','09:25:00',1.58),('1444','2014-02-25','09:30:00',1.62),('1444','2014-02-25','09:35:00',1.67),('1444','2014-02-25','09:40:00',1.72),('1444','2014-02-25','09:45:00',1.78),('1444','2014-02-25','09:50:00',1.82),('1444','2014-02-25','09:55:00',1.86),('1444','2014-02-25','10:00:00',1.91),('1444','2014-02-25','10:05:00',1.96),('1444','2014-02-25','10:10:00',2),('1444','2014-02-25','10:15:00',2.02),('1444','2014-02-25','10:20:00',2.06),('1444','2014-02-25','10:25:00',2.11),('1444','2014-02-25','10:30:00',2.14),('1444','2014-02-25','10:35:00',2.16),('1444','2014-02-25','10:40:00',2.2),('1444','2014-02-25','10:45:00',2.22),('1444','2014-02-25','10:50:00',2.23),('1444','2014-02-25','10:55:00',2.27),('1444','2014-02-25','11:00:00',2.26),('1444','2014-02-25','11:05:00',2.3),('1444','2014-02-25','11:10:00',2.32),('1444','2014-02-25','11:15:00',2.35),('1444','2014-02-25','11:20:00',2.34),('1444','2014-02-25','11:25:00',2.36),('1444','2014-02-25','11:30:00',2.39),('1444','2014-02-25','11:35:00',2.41),('1444','2014-02-25','11:40:00',2.41),('1444','2014-02-25','11:45:00',2.4),('1444','2014-02-25','11:50:00',2.44),('1444','2014-02-25','11:55:00',2.42),('1444','2014-02-25','12:00:00',2.45),('1444','2014-02-25','12:05:00',2.46),('1444','2014-02-25','12:10:00',2.48),('1444','2014-02-25','12:15:00',2.52),('1444','2014-02-25','12:20:00',2.55),('1444','2014-02-25','12:25:00',2.53),('1444','2014-02-25','12:30:00',2.48),('1444','2014-02-25','12:35:00',2.46),('1444','2014-02-25','12:40:00',2.41),('1444','2014-02-25','12:45:00',2.46),('1444','2014-02-25','12:50:00',2.46),('1444','2014-02-25','12:55:00',2.42),('1444','2014-02-25','13:00:00',2.38),('1444','2014-02-25','13:05:00',2.3),('1444','2014-02-25','13:40:00',1.02),('1444','2014-02-25','14:25:00',1.42),('1444','2014-02-25','14:30:00',1.58),('1444','2014-02-25','14:35:00',1.92),('1444','2014-02-25','14:40:00',2.04),('1444','2014-02-25','14:45:00',2.04),('1444','2014-02-25','14:50:00',1.1),('1444','2014-02-25','15:00:00',1.66),('1444','2014-02-25','15:05:00',1.72),('1444','2014-02-25','15:10:00',1.65),('1444','2014-02-25','15:15:00',1.54),('1444','2014-02-25','15:20:00',1.47),('1444','2014-02-25','15:25:00',1.27),('1444','2014-02-25','15:30:00',1.17),('1444','2014-02-25','15:35:00',1.05),('1444','2014-02-25','15:40:00',1.12),('1444','2014-02-24','08:15:00',1.02),('1444','2014-02-24','08:20:00',1.08),('1444','2014-02-24','08:25:00',1.13),('1444','2014-02-24','08:35:00',1.17),('1444','2014-02-24','08:50:00',1.02),('1444','2014-02-24','08:55:00',1.27),('1444','2014-02-24','09:00:00',1.3),('1444','2014-02-24','09:05:00',1.35),('1444','2014-02-24','09:10:00',1.41),('1444','2014-02-24','09:15:00',1.46),('1444','2014-02-24','09:20:00',1.51),('1444','2014-02-24','09:25:00',1.58),('1444','2014-02-24','09:30:00',1.64),('1444','2014-02-24','09:35:00',1.68),('1444','2014-02-24','09:40:00',1.73),('1444','2014-02-24','09:45:00',1.79),('1444','2014-02-24','09:50:00',1.84),('1444','2014-02-24','09:55:00',1.87),('1444','2014-02-24','10:00:00',1.93),('1444','2014-02-24','10:05:00',1.97),('1444','2014-02-24','10:10:00',2.02),('1444','2014-02-24','10:15:00',2.07),('1444','2014-02-24','10:20:00',2.11),('1444','2014-02-24','10:25:00',2.15),('1444','2014-02-24','10:30:00',2.18),('1444','2014-02-24','10:35:00',2.22),('1444','2014-02-24','10:40:00',2.25),('1444','2014-02-24','10:45:00',2.27),('1444','2014-02-24','10:50:00',2.3),('1444','2014-02-24','10:55:00',2.34),('1444','2014-02-24','11:00:00',2.35),('1444','2014-02-24','11:05:00',2.37),('1444','2014-02-24','11:10:00',2.42),('1444','2014-02-24','11:15:00',2.46),('1444','2014-02-24','11:20:00',2.46),('1444','2014-02-24','11:25:00',2.48),('1444','2014-02-24','11:30:00',2.74),('1444','2014-02-24','11:35:00',2.07),('1444','2014-02-24','11:40:00',1.8),('1444','2014-02-24','11:45:00',2.43),('1444','2014-02-24','11:50:00',2.48),('1444','2014-02-24','11:55:00',2.21),('1444','2014-02-24','12:00:00',2.58),('1444','2014-02-24','12:05:00',2.59),('1444','2014-02-24','12:10:00',2.5),('1444','2014-02-24','12:15:00',2.59),('1444','2014-02-24','12:20:00',2.63),('1444','2014-02-24','12:25:00',2.59),('1444','2014-02-24','12:30:00',1.74),('1444','2014-02-24','12:35:00',2.76),('1444','2014-02-24','12:40:00',2.86),('1444','2014-02-24','12:45:00',2.14),('1444','2014-02-24','12:50:00',1.58),('1444','2014-02-24','12:55:00',2.22),('1444','2014-02-24','13:00:00',2.06),('1444','2014-02-24','13:05:00',2.32),('1444','2014-02-24','13:10:00',2.79),('1444','2014-02-24','13:15:00',2.39),('1444','2014-02-24','15:35:00',1.54),('1444','2014-02-24','15:40:00',1.69),('1444','2014-02-24','15:45:00',1.6),('1444','2014-02-24','15:50:00',1.56),('1444','2014-02-24','15:55:00',1.5),('1444','2014-02-24','16:00:00',1.39),('1444','2014-02-24','16:05:00',1.45),('1444','2014-02-24','16:10:00',1.35),('1444','2014-02-24','16:15:00',1.22),('1444','2014-02-24','16:20:00',1.02),('1444','2014-02-23','08:40:00',1.04),('1444','2014-02-23','08:45:00',1.07),('1444','2014-02-23','08:50:00',1.1),('1444','2014-02-23','08:55:00',1.18),('1444','2014-02-23','09:00:00',1.24),('1444','2014-02-23','09:05:00',1.33),('1444','2014-02-23','09:10:00',1.4),('1444','2014-02-23','09:15:00',1.48),('1444','2014-02-23','09:20:00',1.54),('1444','2014-02-23','09:25:00',1.41),('1444','2014-02-23','09:30:00',1.43),('1444','2014-02-23','09:35:00',1.63),('1444','2014-02-23','09:40:00',1.72),('1444','2014-02-23','09:45:00',1.77),('1444','2014-02-23','09:50:00',1.78),('1444','2014-02-23','09:55:00',1.82),('1444','2014-02-23','10:00:00',1.87),('1444','2014-02-23','10:05:00',1.91),('1444','2014-02-23','10:10:00',1.94),('1444','2014-02-23','10:15:00',1.97),('1444','2014-02-23','10:20:00',2.03),('1444','2014-02-23','10:25:00',2.09),('1444','2014-02-23','10:30:00',2.11),('1444','2014-02-23','10:35:00',2.16),('1444','2014-02-23','10:40:00',2.18),('1444','2014-02-23','10:45:00',2.22),('1444','2014-02-23','10:50:00',2.26),('1444','2014-02-23','10:55:00',2.27),('1444','2014-02-23','11:00:00',2.32),('1444','2014-02-23','11:05:00',2.34),('1444','2014-02-23','11:10:00',2.39),('1444','2014-02-23','11:15:00',2.46),('1444','2014-02-23','11:20:00',2.47),('1444','2014-02-23','11:25:00',2.45),('1444','2014-02-23','11:30:00',2.5),('1444','2014-02-23','11:35:00',2.42),('1444','2014-02-23','11:40:00',2.05),('1444','2014-02-23','11:45:00',2.43),('1444','2014-02-23','11:50:00',2.7),('1444','2014-02-23','11:55:00',2.63),('1444','2014-02-23','12:00:00',2.66),('1444','2014-02-23','12:05:00',1.15),('1444','2014-02-23','12:10:00',1.63),('1444','2014-02-23','12:15:00',2.39),('1444','2014-02-23','12:20:00',2.53),('1444','2014-02-23','12:25:00',1.62),('1444','2014-02-23','12:30:00',1.98),('1444','2014-02-23','12:35:00',2.72),('1444','2014-02-23','12:40:00',1.54),('1444','2014-02-23','12:45:00',1.9),('1444','2014-02-23','12:50:00',1.45),('1444','2014-02-23','12:55:00',1.46),('1444','2014-02-23','13:00:00',2.03),('1444','2014-02-23','13:05:00',2.54),('1444','2014-02-23','13:10:00',2.53),('1444','2014-02-23','13:15:00',2.5),('1444','2014-02-23','13:20:00',2.48),('1444','2014-02-23','13:25:00',2.48),('1444','2014-02-23','13:30:00',2.39),('1444','2014-02-23','13:35:00',2.32),('1444','2014-02-23','13:40:00',2.06),('1444','2014-02-23','13:45:00',1.8),('1444','2014-02-23','13:50:00',2.15),('1444','2014-02-23','13:55:00',1.11),('1444','2014-02-23','14:05:00',2.02),('1444','2014-02-23','14:10:00',2.28),('1444','2014-02-23','14:15:00',1.79),('1444','2014-02-23','14:20:00',1.17),('1444','2014-02-23','14:25:00',1.47),('1444','2014-02-23','14:30:00',2.57),('1444','2014-02-23','14:35:00',2.1),('1444','2014-02-23','14:40:00',1.62),('1444','2014-02-23','14:45:00',1.36),('1444','2014-02-23','14:50:00',1.58),('1444','2014-02-23','14:55:00',1.03),('1444','2014-02-22','10:00:00',1.35),('1444','2014-02-22','10:05:00',1.37),('1444','2014-02-22','10:10:00',2.05),('1444','2014-02-22','10:15:00',1.44),('1444','2014-02-22','10:20:00',1.09),('1444','2014-02-22','10:25:00',1.72),('1444','2014-02-22','10:30:00',1.7),('1444','2014-02-22','10:35:00',1.37),('1444','2014-02-22','10:40:00',1.21),('1444','2014-02-22','10:45:00',2.71),('1444','2014-02-22','10:50:00',2.24),('1444','2014-02-22','12:05:00',1.1),('1444','2014-02-22','12:10:00',1.27),('1444','2014-02-22','12:15:00',1.38),('1444','2014-02-22','12:20:00',1.39),('1444','2014-02-22','12:25:00',1.24),('1444','2014-02-22','12:40:00',1.21),('1444','2014-02-22','12:45:00',2.52),('1444','2014-02-22','12:50:00',2.42),('1444','2014-02-22','12:55:00',1.18),('1444','2014-02-22','13:00:00',1.12),('1444','2014-02-22','13:05:00',2.07),('1444','2014-02-22','13:10:00',3.42),('1444','2014-02-22','13:15:00',1.94),('1444','2014-02-22','13:20:00',1.17),('1444','2014-02-22','13:35:00',1.34),('1444','2014-02-22','13:50:00',1.51),('1444','2014-02-22','13:55:00',2.45),('1444','2014-02-22','14:00:00',2.3),('1444','2014-02-22','14:10:00',1.28),('1444','2014-02-22','14:15:00',2.05),('1444','2014-02-22','14:20:00',2.19),('1444','2014-02-22','14:25:00',1.6),('1444','2014-02-22','14:30:00',1.28),('1444','2014-02-22','14:35:00',1.66),('1444','2014-02-22','14:40:00',1.91),('1444','2014-02-22','14:45:00',2.06),('1444','2014-02-22','14:50:00',1.68),('1444','2014-02-22','15:05:00',1.52),('1444','2014-02-22','15:30:00',1.47),('1444','2014-02-22','15:45:00',1.3),('1444','2014-02-21','10:05:00',1.11),('1444','2014-02-21','10:15:00',1.22),('1444','2014-02-21','10:20:00',1.59),('1444','2014-02-21','10:25:00',1.77),('1444','2014-02-21','10:30:00',1.87),('1444','2014-02-21','10:35:00',1.34),('1444','2014-02-21','10:40:00',1.32),('1444','2014-02-21','10:45:00',1.2),('1444','2014-02-21','10:50:00',1.41),('1444','2014-02-21','10:55:00',1.73),('1444','2014-02-21','11:00:00',1.28),('1444','2014-02-21','11:05:00',1.26),('1444','2014-02-21','11:10:00',1.2),('1444','2014-02-21','11:15:00',1.3),('1444','2014-02-21','11:20:00',1.2),('1444','2014-02-21','11:25:00',1.25),('1444','2014-02-21','11:30:00',1.29),('1444','2014-02-21','11:35:00',1.33),('1444','2014-02-21','11:40:00',1.4),('1444','2014-02-21','11:45:00',1.21),('1444','2014-02-21','11:50:00',1.17),('1444','2014-02-21','11:55:00',1.25),('1444','2014-02-21','12:00:00',1.12),('1444','2014-02-21','12:05:00',1.81),('1444','2014-02-21','12:10:00',2.84),('1444','2014-02-21','12:15:00',2.34),('1444','2014-02-21','12:20:00',2.42),('1444','2014-02-21','12:25:00',1.6),('1444','2014-02-21','12:30:00',1.06),('1444','2014-02-21','15:05:00',1.08),('1444','2014-02-21','15:35:00',1.09),('1444','2014-02-21','15:40:00',1.19),('1444','2014-02-21','15:45:00',1.14),('1444','2014-02-21','15:50:00',1.06),('1444','2014-02-20','13:00:00',1.15),('1444','2014-02-19','09:40:00',1.01),('1444','2014-02-19','09:45:00',1.19),('1444','2014-02-19','09:50:00',1.11),('1444','2014-02-19','09:55:00',1.04),('1444','2014-02-19','10:00:00',1),('1444','2014-02-19','10:05:00',1.01),('1444','2014-02-19','10:10:00',1.1),('1444','2014-02-19','10:15:00',1.14),('1444','2014-02-19','10:20:00',1.05),('1444','2014-02-19','10:25:00',1.08),('1444','2014-02-19','10:30:00',1.14),('1444','2014-02-19','10:35:00',1.2),('1444','2014-02-19','10:40:00',1.38),('1444','2014-02-19','10:45:00',1.49),('1444','2014-02-19','10:50:00',1.39),('1444','2014-02-19','10:55:00',1.25),('1444','2014-02-19','11:00:00',1.15),('1444','2014-02-19','11:05:00',1.18),('1444','2014-02-19','11:10:00',1.34),('1444','2014-02-19','11:15:00',1.31),('1444','2014-02-19','11:20:00',1.41),('1444','2014-02-19','11:25:00',1.31),('1444','2014-02-19','11:30:00',1.24),('1444','2014-02-19','11:35:00',1.31),('1444','2014-02-19','11:40:00',1.19),('1444','2014-02-19','11:45:00',1.18),('1444','2014-02-19','11:50:00',1.2),('1444','2014-02-19','11:55:00',1.03),('1444','2014-02-19','12:00:00',1.04),('1444','2014-02-19','12:05:00',1.12),('1444','2014-02-19','12:10:00',1.07),('1444','2014-02-19','12:15:00',1.02),('1444','2014-02-19','12:25:00',1.09),('1444','2014-02-19','12:30:00',1.19),('1444','2014-02-19','13:25:00',1.19),('1444','2014-02-19','13:30:00',1.17),('1444','2014-02-19','13:35:00',1.28),('1444','2014-02-19','13:40:00',1.19),('1444','2014-02-19','13:45:00',1.56),('1444','2014-02-19','13:50:00',1.58),('1444','2014-02-19','13:55:00',1.41),('1444','2014-02-19','14:00:00',1.31),('1444','2014-02-19','14:05:00',1.38),('1444','2014-02-19','14:10:00',1.11),('1444','2014-02-19','14:15:00',1.05),('1444','2014-02-19','14:20:00',1.58),('1444','2014-02-19','14:25:00',1.24),('1444','2014-02-19','14:30:00',1.17),('1444','2014-02-19','14:35:00',1.26),('1444','2014-02-19','14:50:00',1.19),('1444','2014-02-19','14:55:00',1.01),('1444','2014-02-18','09:10:00',1.04),('1444','2014-02-18','09:15:00',1.1),('1444','2014-02-18','09:20:00',1.16),('1444','2014-02-18','09:25:00',1.22),('1444','2014-02-18','09:30:00',1.28),('1444','2014-02-18','09:35:00',1.33),('1444','2014-02-18','09:40:00',1.37),('1444','2014-02-18','09:45:00',1.4),('1444','2014-02-18','09:50:00',1.46),('1444','2014-02-18','09:55:00',1.51),('1444','2014-02-18','10:00:00',1.55),('1444','2014-02-18','10:05:00',1.59),('1444','2014-02-18','10:10:00',1.61),('1444','2014-02-18','10:15:00',1.65),('1444','2014-02-18','10:20:00',1.68),('1444','2014-02-18','10:25:00',1.72),('1444','2014-02-18','10:30:00',1.74),('1444','2014-02-18','10:35:00',1.77),('1444','2014-02-18','10:40:00',1.8),('1444','2014-02-18','10:45:00',1.83),('1444','2014-02-18','10:50:00',1.86),('1444','2014-02-18','10:55:00',1.89),('1444','2014-02-18','11:00:00',1.9),('1444','2014-02-18','11:05:00',1.61),('1444','2014-02-18','11:10:00',1.57),('1444','2014-02-18','11:15:00',1.52),('1444','2014-02-18','11:20:00',1.79),('1444','2014-02-18','11:25:00',1.96),('1444','2014-02-18','11:30:00',1.75),('1444','2014-02-18','11:35:00',1.67),('1444','2014-02-18','11:40:00',1.39),('1444','2014-02-18','11:45:00',1.42),('1444','2014-02-18','11:50:00',1.2),('1444','2014-02-18','11:55:00',1.06),('1444','2014-02-18','12:00:00',1.06),('1444','2014-02-18','12:05:00',1.08),('1444','2014-02-18','12:10:00',1.24),('1444','2014-02-18','12:15:00',1.29),('1444','2014-02-18','12:20:00',1.3),('1444','2014-02-18','12:25:00',1.5),('1444','2014-02-18','12:30:00',1.61),('1444','2014-02-18','12:35:00',1.22),('1444','2014-02-18','12:40:00',1.14),('1444','2014-02-18','12:45:00',1.1),('1444','2014-02-18','12:50:00',1.19),('1444','2014-02-18','12:55:00',1.24),('1444','2014-02-18','13:10:00',1.02),('1444','2014-02-18','13:15:00',1.32),('1444','2014-02-18','13:20:00',1.42),('1444','2014-02-18','13:25:00',1.67),('1444','2014-02-18','13:30:00',1.18),('1444','2014-02-18','13:35:00',1.01),('1444','2014-02-18','13:40:00',1.31),('1444','2014-02-18','13:45:00',1.46),('1444','2014-02-18','13:50:00',1.14),('1444','2014-02-18','13:55:00',1.14),('1444','2014-02-18','14:00:00',1.26),('1444','2014-02-18','14:05:00',1.78),('1444','2014-02-18','14:10:00',1.05),('1444','2014-02-17','09:15:00',1.02),('1444','2014-02-17','09:20:00',1.09),('1444','2014-02-17','09:25:00',1.14),('1444','2014-02-17','09:30:00',1.22),('1444','2014-02-17','09:35:00',1.25),('1444','2014-02-17','09:40:00',1.3),('1444','2014-02-17','09:45:00',1.33),('1444','2014-02-17','09:50:00',1.36),('1444','2014-02-17','09:55:00',1.39),('1444','2014-02-17','10:00:00',1.43),('1444','2014-02-17','10:05:00',1.48),('1444','2014-02-17','10:10:00',1.51),('1444','2014-02-17','10:15:00',1.53),('1444','2014-02-17','10:20:00',1.51),('1444','2014-02-17','10:25:00',1.57),('1444','2014-02-17','10:30:00',1.61),('1444','2014-02-17','10:35:00',1.62),('1444','2014-02-17','10:40:00',1.63),('1444','2014-02-17','10:45:00',1.65),('1444','2014-02-17','10:50:00',1.67),('1444','2014-02-17','10:55:00',1.7),('1444','2014-02-17','11:00:00',1.72),('1444','2014-02-17','11:05:00',1.75),('1444','2014-02-17','11:10:00',1.77),('1444','2014-02-17','11:15:00',1.78),('1444','2014-02-17','11:20:00',1.82),('1444','2014-02-17','11:25:00',1.86),('1444','2014-02-17','11:30:00',1.92),('1444','2014-02-17','11:35:00',1.95),('1444','2014-02-17','11:40:00',1.96),('1444','2014-02-17','11:45:00',1.98),('1444','2014-02-17','11:50:00',1.99),('1444','2014-02-17','11:55:00',2),('1444','2014-02-17','12:00:00',2),('1444','2014-02-17','12:05:00',2),('1444','2014-02-17','12:10:00',2),('1444','2014-02-17','12:15:00',1.99),('1444','2014-02-17','12:20:00',1.99),('1444','2014-02-17','12:25:00',1.99),('1444','2014-02-17','12:30:00',1.98),('1444','2014-02-17','12:35:00',1.98),('1444','2014-02-17','12:40:00',1.96),('1444','2014-02-17','12:45:00',1.95),('1444','2014-02-17','12:50:00',1.93),('1444','2014-02-17','12:55:00',1.92),('1444','2014-02-17','13:00:00',1.92),('1444','2014-02-17','13:05:00',1.9),('1444','2014-02-17','13:10:00',1.89),('1444','2014-02-17','13:15:00',1.87),('1444','2014-02-17','13:20:00',1.86),('1444','2014-02-17','13:25:00',1.86),('1444','2014-02-17','13:30:00',1.85),('1444','2014-02-17','13:35:00',1.83),('1444','2014-02-17','13:40:00',1.81),('1444','2014-02-17','13:45:00',1.73),('1444','2014-02-17','13:50:00',1.74),('1444','2014-02-17','13:55:00',1.73),('1444','2014-02-17','14:00:00',1.69),('1444','2014-02-17','14:05:00',1.68),('1444','2014-02-17','14:10:00',1.6),('1444','2014-02-17','14:15:00',1.55),('1444','2014-02-17','14:20:00',1.6),('1444','2014-02-17','14:25:00',1.53),('1444','2014-02-17','14:30:00',1.47),('1444','2014-02-17','14:35:00',1.41),('1444','2014-02-17','14:40:00',1.3),('1444','2014-02-17','14:45:00',1.42),('1444','2014-02-17','14:50:00',1.33),('1444','2014-02-17','14:55:00',1.31),('1444','2014-02-17','15:00:00',1.23),('1444','2014-02-17','15:05:00',1.21),('1444','2014-02-17','15:10:00',1.17),('1444','2014-02-17','15:15:00',1.17),('1444','2014-02-17','15:20:00',1.13),('1444','2014-02-17','15:25:00',1.05),('1444','2014-02-17','15:30:00',1.02),('1444','2014-02-16','09:05:00',1.03),('1444','2014-02-16','09:10:00',1.02),('1444','2014-02-16','09:20:00',1.12),('1444','2014-02-16','09:25:00',1.09),('1444','2014-02-16','09:30:00',1.14),('1444','2014-02-16','09:40:00',1.31),('1444','2014-02-16','09:45:00',1.37),('1444','2014-02-16','09:50:00',1.45),('1444','2014-02-16','09:55:00',1.4),('1444','2014-02-16','10:00:00',1.42),('1444','2014-02-16','10:05:00',1.54),('1444','2014-02-16','10:10:00',1.6),('1444','2014-02-16','10:15:00',1.64),('1444','2014-02-16','10:20:00',1.69),('1444','2014-02-16','10:25:00',1.75),('1444','2014-02-16','10:30:00',1.78),('1444','2014-02-16','10:35:00',1.85),('1444','2014-02-16','10:40:00',1.86),('1444','2014-02-16','10:45:00',1.86),('1444','2014-02-16','10:50:00',1.58),('1444','2014-02-16','10:55:00',1.69),('1444','2014-02-16','11:00:00',1.92),('1444','2014-02-16','11:05:00',1.96),('1444','2014-02-16','11:10:00',1.88),('1444','2014-02-16','11:15:00',1.94),('1444','2014-02-16','11:20:00',1.84),('1444','2014-02-16','11:25:00',1.91),('1444','2014-02-16','11:30:00',1.93),('1444','2014-02-16','11:35:00',2),('1444','2014-02-16','11:40:00',2),('1444','2014-02-16','11:45:00',1.83),('1444','2014-02-16','11:50:00',2.03),('1444','2014-02-16','11:55:00',1.71),('1444','2014-02-16','12:00:00',2.03),('1444','2014-02-16','12:05:00',1.99),('1444','2014-02-16','12:10:00',1.98),('1444','2014-02-16','12:15:00',2.04),('1444','2014-02-16','12:20:00',2.05),('1444','2014-02-16','12:25:00',2.01),('1444','2014-02-16','12:30:00',2.01),('1444','2014-02-16','12:35:00',2.01),('1444','2014-02-16','12:40:00',2.02),('1444','2014-02-16','12:45:00',2.02),('1444','2014-02-16','12:50:00',2.01),('1444','2014-02-16','12:55:00',2),('1444','2014-02-16','13:00:00',1.99),('1444','2014-02-16','13:05:00',2),('1444','2014-02-16','13:10:00',1.91),('1444','2014-02-16','13:15:00',1.93),('1444','2014-02-16','13:20:00',1.91),('1444','2014-02-16','13:25:00',1.89),('1444','2014-02-16','13:30:00',1.9),('1444','2014-02-16','13:35:00',1.86),('1444','2014-02-16','13:40:00',1.89),('1444','2014-02-16','13:45:00',1.88),('1444','2014-02-16','13:50:00',1.85),('1444','2014-02-16','13:55:00',1.83),('1444','2014-02-16','14:00:00',1.81),('1444','2014-02-16','14:05:00',1.78),('1444','2014-02-16','14:10:00',1.75),('1444','2014-02-16','14:15:00',1.7),('1444','2014-02-16','14:20:00',1.68),('1444','2014-02-16','14:25:00',1.67),('1444','2014-02-16','14:30:00',1.63),('1444','2014-02-16','14:35:00',1.58),('1444','2014-02-16','14:40:00',1.51),('1444','2014-02-16','14:45:00',1.48),('1444','2014-02-16','14:50:00',1.44),('1444','2014-02-16','14:55:00',1.41),('1444','2014-02-16','15:00:00',1.35),('1444','2014-02-16','15:05:00',1.33),('1444','2014-02-16','15:10:00',1.26),('1444','2014-02-16','15:15:00',1.21),('1444','2014-02-16','15:20:00',1.14),('1444','2014-02-16','15:25:00',1.09),('1444','2014-02-16','15:30:00',1.04),('1444','2014-04-28','08:15:00',1.36),('1444','2014-04-28','08:20:00',1.33),('1444','2014-04-28','08:25:00',1.3),('1444','2014-04-28','08:40:00',1.01),('1444','2014-04-28','08:45:00',1.04),('1444','2014-04-28','08:50:00',1.13),('1444','2014-04-28','09:05:00',1.39),('1444','2014-04-28','09:10:00',2.19),('1444','2014-04-28','09:15:00',2.49),('1444','2014-04-28','09:20:00',1.46),('1444','2014-04-28','09:25:00',1.47),('1444','2014-04-28','09:30:00',2.26),('1444','2014-04-28','09:35:00',1.95),('1444','2014-04-28','09:40:00',1.27),('1444','2014-04-28','09:45:00',1.52),('1444','2014-04-28','09:50:00',1.35),('1444','2014-04-28','09:55:00',1.25),('1444','2014-04-28','10:00:00',1.94),('1444','2014-04-28','10:05:00',1.85),('1444','2014-04-28','10:10:00',1.87),('1444','2014-04-28','10:15:00',1.51),('1444','2014-04-28','10:20:00',1.2),('1444','2014-04-28','10:45:00',1.38),('1444','2014-04-28','10:50:00',1.55),('1444','2014-04-28','10:55:00',1.35),('1444','2014-04-28','11:00:00',1.65),('1444','2014-04-28','11:05:00',1.98),('1444','2014-04-28','11:10:00',2.19),('1444','2014-04-28','11:15:00',2.09),('1444','2014-04-28','11:20:00',1.75),('1444','2014-04-28','11:25:00',1.58),('1444','2014-04-28','11:30:00',1.54),('1444','2014-04-28','11:35:00',1.31),('1444','2014-04-28','11:40:00',1.2),('1444','2014-04-28','11:45:00',1.37),('1444','2014-04-28','11:50:00',1.58),('1444','2014-04-28','11:55:00',1.65),('1444','2014-04-28','12:00:00',1.41),('1444','2014-04-28','12:05:00',1.22),('1444','2014-04-28','12:10:00',1.76),('1444','2014-04-28','12:15:00',2.21),('1444','2014-04-28','12:20:00',2.25),('1444','2014-04-28','12:25:00',2.21),('1444','2014-04-28','12:30:00',2.27),('1444','2014-04-28','12:35:00',2.02),('1444','2014-04-28','12:40:00',1.71),('1444','2014-04-28','12:45:00',1.61),('1444','2014-04-28','12:50:00',1.82),('1444','2014-04-28','12:55:00',1.8),('1444','2014-04-28','13:00:00',1.86),('1444','2014-04-28','13:05:00',2.81),('1444','2014-04-28','13:10:00',2.05),('1444','2014-04-28','13:15:00',1.83),('1444','2014-04-28','13:20:00',2.11),('1444','2014-04-28','13:25:00',2.68),('1444','2014-04-28','13:30:00',3.94),('1444','2014-04-28','13:35:00',2.35),('1444','2014-04-28','13:40:00',1.47),('1444','2014-04-28','13:45:00',3.65),('1444','2014-04-28','13:50:00',2.9),('1444','2014-04-28','13:55:00',1.88),('1444','2014-04-28','14:00:00',1.39),('1444','2014-04-28','14:05:00',2.82),('1444','2014-04-28','14:10:00',3.1),('1444','2014-04-28','14:15:00',2.26),('1444','2014-04-28','14:20:00',3.18),('1444','2014-04-28','14:25:00',2.21),('1444','2014-04-28','14:30:00',2.62),('1444','2014-04-28','14:35:00',1.84),('1444','2014-04-28','14:40:00',2.4),('1444','2014-04-28','14:45:00',1.98),('1444','2014-04-28','14:50:00',2.95),('1444','2014-04-28','14:55:00',1.83),('1444','2014-04-28','15:00:00',3.05),('1444','2014-04-28','15:05:00',3.65),('1444','2014-04-28','15:10:00',1.11),('1444','2014-04-28','15:20:00',1.04),('1444','2014-04-28','15:25:00',1.76),('1444','2014-04-28','15:30:00',1.39),('1444','2014-04-28','15:35:00',3.83),('1444','2014-04-28','15:40:00',3.05),('1444','2014-04-28','15:45:00',2.16),('1444','2014-04-28','15:50:00',1.25),('1444','2014-04-28','15:55:00',1.08),('1444','2014-04-28','16:00:00',2.36),('1444','2014-04-28','16:05:00',1.83),('1444','2014-04-28','16:10:00',2.95),('1444','2014-04-28','16:15:00',2.11),('1444','2014-04-28','16:20:00',1.76),('1444','2014-04-28','16:25:00',2.09),('1444','2014-04-28','16:30:00',2.39),('1444','2014-04-28','16:35:00',1.67),('1444','2014-04-28','16:55:00',1.07),('1444','2014-04-28','17:35:00',1.13),('1444','2014-04-28','17:40:00',1.05),('1444','2014-02-15','09:15:00',1.03),('1444','2014-02-15','09:20:00',1.08),('1444','2014-02-15','09:25:00',1.13),('1444','2014-02-15','09:30:00',1.16),('1444','2014-02-15','09:35:00',1.24),('1444','2014-02-15','09:40:00',1.29),('1444','2014-02-15','09:45:00',1.35),('1444','2014-02-15','09:50:00',1.38),('1444','2014-02-15','09:55:00',1.42),('1444','2014-02-15','10:00:00',1.46),('1444','2014-02-15','10:05:00',1.49),('1444','2014-02-15','10:10:00',1.53),('1444','2014-02-15','10:15:00',1.57),('1444','2014-02-15','10:20:00',1.59),('1444','2014-02-15','10:25:00',1.62),('1444','2014-02-15','10:30:00',1.65),('1444','2014-02-15','10:35:00',1.66),('1444','2014-02-15','10:40:00',1.7),('1444','2014-02-15','10:45:00',1.76),('1444','2014-02-15','10:50:00',1.77),('1444','2014-02-15','10:55:00',1.77),('1444','2014-02-15','11:00:00',1.78),('1444','2014-02-15','11:05:00',1.93),('1444','2014-02-15','11:10:00',1.94),('1444','2014-02-15','11:15:00',1.71),('1444','2014-02-15','11:20:00',1.29),('1444','2014-02-15','11:25:00',2.27),('1444','2014-02-15','11:30:00',1.17),('1444','2014-02-15','11:35:00',2.34),('1444','2014-02-15','11:40:00',1.9),('1444','2014-02-15','11:45:00',2.25),('1444','2014-02-15','11:50:00',1.69),('1444','2014-02-15','11:55:00',1.27),('1444','2014-02-15','12:05:00',1.12),('1444','2014-02-15','12:10:00',2.21),('1444','2014-02-15','12:15:00',2.17),('1444','2014-02-15','12:20:00',2.02),('1444','2014-02-15','12:30:00',2.42),('1444','2014-02-15','12:35:00',2.02),('1444','2014-02-15','12:40:00',2.43),('1444','2014-02-15','12:45:00',2.29),('1444','2014-02-15','12:50:00',1.13),('1444','2014-02-15','12:55:00',1.56),('1444','2014-02-15','13:00:00',2.17),('1444','2014-02-15','13:05:00',2.27),('1444','2014-02-15','13:10:00',2.21),('1444','2014-02-15','13:15:00',2.09),('1444','2014-02-15','13:20:00',2.06),('1444','2014-02-15','13:25:00',1.99),('1444','2014-02-15','13:30:00',1.95),('1444','2014-02-15','13:35:00',1.91),('1444','2014-02-15','13:40:00',1.88),('1444','2014-02-15','13:45:00',1.85),('1444','2014-02-15','13:50:00',1.86),('1444','2014-02-15','13:55:00',1.78),('1444','2014-02-15','14:00:00',1.75),('1444','2014-02-15','14:05:00',1.74),('1444','2014-02-15','14:10:00',1.69),('1444','2014-02-15','14:15:00',1.67),('1444','2014-02-15','14:20:00',1.61),('1444','2014-02-15','14:25:00',1.59),('1444','2014-02-15','14:30:00',1.55),('1444','2014-02-15','14:35:00',1.51),('1444','2014-02-15','14:40:00',1.44),('1444','2014-02-15','14:45:00',1.42),('1444','2014-02-15','14:50:00',1.3),('1444','2014-02-15','14:55:00',1.22),('1444','2014-02-15','15:00:00',1.3),('1444','2014-02-15','15:05:00',1.26),('1444','2014-02-15','15:10:00',1.22),('1444','2014-02-15','15:15:00',1.17),('1444','2014-02-15','15:20:00',1.13),('1444','2014-02-15','15:25:00',1.08),('1444','2014-02-15','15:30:00',1.03),('1444','2014-02-14','09:15:00',1.09),('1444','2014-02-14','09:30:00',1.4),('1444','2014-02-14','09:45:00',1.02),('1444','2014-02-14','09:50:00',1.62),('1444','2014-02-14','09:55:00',1.51),('1444','2014-02-14','10:00:00',1.51),('1444','2014-02-14','10:05:00',1.53),('1444','2014-02-14','10:10:00',1.27),('1444','2014-02-14','10:15:00',1.29),('1444','2014-02-14','10:20:00',1.78),('1444','2014-02-14','10:25:00',1.75),('1444','2014-02-14','10:30:00',1.77),('1444','2014-02-14','10:35:00',1.75),('1444','2014-02-14','10:40:00',1.78),('1444','2014-02-14','10:45:00',1.84),('1444','2014-02-14','10:50:00',1.8),('1444','2014-02-14','10:55:00',1.89),('1444','2014-02-14','11:00:00',1.81),('1444','2014-02-14','11:05:00',1.95),('1444','2014-02-14','11:10:00',1.96),('1444','2014-02-14','11:15:00',1.98),('1444','2014-02-14','11:20:00',2),('1444','2014-02-14','11:25:00',2.04),('1444','2014-02-14','11:30:00',2.06),('1444','2014-02-14','11:35:00',2.06),('1444','2014-02-14','11:40:00',2.1),('1444','2014-02-14','11:45:00',2.1),('1444','2014-02-14','11:50:00',2.13),('1444','2014-02-14','11:55:00',2.13),('1444','2014-02-14','12:00:00',1.81),('1444','2014-02-14','12:05:00',2.08),('1444','2014-02-14','12:10:00',2.15),('1444','2014-02-14','12:15:00',2.14),('1444','2014-02-14','12:20:00',2.14),('1444','2014-02-14','12:25:00',2.13),('1444','2014-02-14','12:30:00',2.13),('1444','2014-02-14','12:35:00',2.13),('1444','2014-02-14','12:40:00',2.12),('1444','2014-02-14','12:45:00',2.1),('1444','2014-02-14','12:50:00',2.08),('1444','2014-02-14','12:55:00',2.08),('1444','2014-02-14','13:00:00',2.07),('1444','2014-02-14','13:05:00',2.05),('1444','2014-02-14','13:10:00',2.05),('1444','2014-02-14','13:15:00',2.02),('1444','2014-02-14','13:20:00',2),('1444','2014-02-14','13:25:00',2),('1444','2014-02-14','13:30:00',1.96),('1444','2014-02-14','13:35:00',1.94),('1444','2014-02-14','13:40:00',1.91),('1444','2014-02-14','13:45:00',1.89),('1444','2014-02-14','13:50:00',1.86),('1444','2014-02-14','13:55:00',1.85),('1444','2014-02-14','14:00:00',1.82),('1444','2014-02-14','14:05:00',1.78),('1444','2014-02-14','14:10:00',1.74),('1444','2014-02-14','14:15:00',1.7),('1444','2014-02-14','14:20:00',1.67),('1444','2014-02-14','14:25:00',1.63),('1444','2014-02-14','14:30:00',1.6),('1444','2014-02-14','14:35:00',1.56),('1444','2014-02-14','14:40:00',1.5),('1444','2014-02-14','14:45:00',1.45),('1444','2014-02-14','14:50:00',1.41),('1444','2014-02-14','14:55:00',1.33),('1444','2014-02-14','15:00:00',1.3),('1444','2014-02-14','15:05:00',1.28),('1444','2014-02-14','15:10:00',1.23),('1444','2014-02-14','15:15:00',1.18),('1444','2014-02-14','15:20:00',1.14),('1444','2014-02-14','15:25:00',1.08),('1444','2014-02-14','15:30:00',1.04),('1444','2014-02-13','09:15:00',1.04),('1444','2014-02-13','09:20:00',1.09),('1444','2014-02-13','09:25:00',1.14),('1444','2014-02-13','09:30:00',1.17),('1444','2014-02-13','09:35:00',1.19),('1444','2014-02-13','09:40:00',1.23),('1444','2014-02-13','09:45:00',1.27),('1444','2014-02-13','09:50:00',1.38),('1444','2014-02-13','09:55:00',1.45),('1444','2014-02-13','10:00:00',1.49),('1444','2014-02-13','10:05:00',1.53),('1444','2014-02-13','10:10:00',1.57),('1444','2014-02-13','10:15:00',1.57),('1444','2014-02-13','10:20:00',1.62),('1444','2014-02-13','10:25:00',1.66),('1444','2014-02-13','10:30:00',1.69),('1444','2014-02-13','10:35:00',1.72),('1444','2014-02-13','10:40:00',1.7),('1444','2014-02-13','10:45:00',1.73),('1444','2014-02-13','10:50:00',1.76),('1444','2014-02-13','10:55:00',1.83),('1444','2014-02-13','11:00:00',1.85),('1444','2014-02-13','11:05:00',1.89),('1444','2014-02-13','11:10:00',1.92),('1444','2014-02-13','11:15:00',1.95),('1444','2014-02-13','11:20:00',1.94),('1444','2014-02-13','11:25:00',2),('1444','2014-02-13','11:30:00',1.25),('1444','2014-02-13','11:35:00',1.02),('1444','2014-02-13','11:40:00',1.95),('1444','2014-02-13','11:45:00',2.11),('1444','2014-02-13','11:50:00',2.3),('1444','2014-02-13','11:55:00',1.73),('1444','2014-02-13','12:00:00',1.08),('1444','2014-02-13','12:05:00',1.69),('1444','2014-02-13','12:10:00',1.68),('1444','2014-02-13','12:15:00',1.72),('1444','2014-02-13','12:20:00',1.93),('1444','2014-02-13','12:25:00',2.58),('1444','2014-02-13','12:30:00',2.54),('1444','2014-02-13','12:35:00',2.44),('1444','2014-02-13','12:50:00',1.43),('1444','2014-02-13','12:55:00',2.07),('1444','2014-02-13','13:00:00',2.18),('1444','2014-02-13','13:05:00',2.13),('1444','2014-02-13','13:10:00',2.08),('1444','2014-02-13','13:15:00',2.06),('1444','2014-02-13','13:20:00',2.04),('1444','2014-02-13','13:25:00',2.03),('1444','2014-02-13','13:30:00',2),('1444','2014-02-13','13:35:00',1.97),('1444','2014-02-13','13:40:00',1.93),('1444','2014-02-13','13:45:00',1.92),('1444','2014-02-13','13:50:00',1.9),('1444','2014-02-13','13:55:00',1.87),('1444','2014-02-13','14:00:00',1.84),('1444','2014-02-13','14:05:00',1.81),('1444','2014-02-13','14:10:00',1.76),('1444','2014-02-13','14:15:00',1.72),('1444','2014-02-13','14:20:00',1.71),('1444','2014-02-13','14:25:00',1.66),('1444','2014-02-13','14:30:00',1.63),('1444','2014-02-13','14:35:00',1.61),('1444','2014-02-13','14:40:00',1.05),('1444','2014-02-13','14:50:00',1.3),('1444','2014-02-13','14:55:00',1.51),('1444','2014-02-13','15:00:00',1.07),('1444','2014-02-13','15:05:00',1.44),('1444','2014-02-13','15:10:00',1.06),('1444','2014-02-13','15:15:00',1.29),('1444','2014-02-13','15:20:00',1.24),('1444','2014-02-13','15:40:00',1.06),('1444','2014-02-12','09:15:00',1.04),('1444','2014-02-12','09:45:00',1.27),('1444','2014-02-12','09:50:00',1.57),('1444','2014-02-12','10:05:00',1.12),('1444','2014-02-12','10:30:00',1.01),('1444','2014-02-12','10:35:00',1.12),('1444','2014-02-12','10:40:00',1.03),('1444','2014-02-12','10:45:00',1.2),('1444','2014-02-12','11:00:00',1.09),('1444','2014-02-12','11:05:00',1.38),('1444','2014-02-12','11:10:00',1.06),('1444','2014-02-12','11:15:00',1),('1444','2014-02-12','11:25:00',1.11),('1444','2014-02-12','11:30:00',1.07),('1444','2014-02-12','11:35:00',1.13),('1444','2014-02-12','12:30:00',1.05),('1444','2014-02-12','12:35:00',1.01),('1444','2014-02-12','12:45:00',1.11),('1444','2014-02-12','12:50:00',1.22),('1444','2014-02-12','12:55:00',1.24),('1444','2014-02-12','13:00:00',1.31),('1444','2014-02-12','13:05:00',1.26),('1444','2014-02-12','13:10:00',1.08),('1444','2014-02-12','13:25:00',1.04),('1444','2014-02-12','13:30:00',1.85),('1444','2014-02-12','13:35:00',2.31),('1444','2014-02-12','13:40:00',1.67),('1444','2014-02-12','13:45:00',1.62),('1444','2014-02-12','13:50:00',1.48),('1444','2014-02-12','13:55:00',1.16),('1444','2014-02-12','14:00:00',1.86),('1444','2014-02-12','14:05:00',2),('1444','2014-02-12','14:10:00',1.92),('1444','2014-02-12','14:15:00',1.78),('1444','2014-02-12','14:20:00',1.79),('1444','2014-02-12','14:25:00',1.19),('1444','2014-02-12','14:30:00',1.33),('1444','2014-02-12','14:35:00',1.27),('1444','2014-02-12','14:40:00',1.31),('1444','2014-02-12','14:45:00',1.67),('1444','2014-02-12','14:50:00',1.51),('1444','2014-02-12','14:55:00',1.28),('1444','2014-02-12','15:15:00',1.11),('1444','2014-02-12','15:20:00',1.05),('1444','2014-02-12','15:30:00',1.2),('1444','2014-02-12','15:35:00',1.36),('1444','2014-02-12','15:40:00',1.23),('1444','2014-02-11','10:15:00',1.07),('1444','2014-02-11','10:20:00',1.27),('1444','2014-02-11','10:25:00',1.29),('1444','2014-02-11','10:30:00',1.41),('1444','2014-02-11','10:35:00',1.54),('1444','2014-02-11','10:40:00',1.5),('1444','2014-02-11','10:45:00',1.46),('1444','2014-02-11','10:50:00',1.57),('1444','2014-02-11','10:55:00',1.41),('1444','2014-02-11','11:00:00',1.52),('1444','2014-02-11','11:05:00',1.45),('1444','2014-02-11','11:10:00',1.47),('1444','2014-02-11','11:15:00',1.35),('1444','2014-02-11','11:20:00',1.09),('1444','2014-02-11','11:25:00',1.04),('1444','2014-02-11','11:30:00',1.28),('1444','2014-02-11','11:35:00',1.24),('1444','2014-02-11','11:40:00',1.33),('1444','2014-02-11','11:45:00',1.46),('1444','2014-02-11','11:50:00',1.22),('1444','2014-02-11','12:05:00',1.27),('1444','2014-02-11','12:10:00',1.34),('1444','2014-02-11','12:15:00',1.14),('1444','2014-02-11','12:20:00',1.22),('1444','2014-02-11','12:25:00',1.59),('1444','2014-02-11','12:30:00',1.51),('1444','2014-02-11','12:35:00',1.35),('1444','2014-02-11','12:40:00',1.03),('1444','2014-02-11','12:45:00',1.2),('1444','2014-02-11','12:55:00',1.2),('1444','2014-02-11','13:00:00',1.23),('1444','2014-02-11','13:05:00',1.52),('1444','2014-02-11','13:10:00',1.82),('1444','2014-02-11','13:15:00',1.79),('1444','2014-02-11','13:20:00',1.98),('1444','2014-02-11','13:25:00',1.78),('1444','2014-02-11','13:30:00',1.65),('1444','2014-02-11','13:35:00',1.53),('1444','2014-02-11','13:40:00',1.84),('1444','2014-02-11','13:45:00',1.32),('1444','2014-02-11','13:50:00',1.12),('1444','2014-02-11','14:00:00',1.26),('1444','2014-02-11','14:05:00',1.45),('1444','2014-02-11','14:10:00',1.07),('1444','2014-02-11','14:15:00',1.39),('1444','2014-02-11','14:20:00',1),('1444','2014-02-09','12:25:00',1.06),('1444','2014-02-09','12:30:00',1.01),('1444','2014-02-09','12:45:00',1.69),('1444','2014-02-09','12:55:00',1.35),('1444','2014-02-09','13:00:00',1.43),('1444','2014-02-09','13:05:00',2.21),('1444','2014-02-09','13:10:00',1.28),('1444','2014-02-09','13:45:00',1.56),('1444','2014-02-09','13:55:00',1.29),('1444','2014-02-09','14:00:00',1.15),('1444','2014-02-09','14:05:00',1.8),('1444','2014-02-09','14:10:00',1.54),('1444','2014-02-09','14:25:00',1.06),('1444','2014-02-09','14:30:00',1.27),('1444','2014-02-09','14:35:00',1.27),('1444','2014-02-09','14:50:00',1.24),('1444','2014-02-08','09:50:00',1.49),('1444','2014-02-08','10:30:00',1.48),('1444','2014-02-08','10:35:00',1.51),('1444','2014-02-08','10:50:00',1.3),('1444','2014-02-08','10:55:00',1.3),('1444','2014-02-08','11:00:00',1.32),('1444','2014-02-08','11:05:00',1.7),('1444','2014-02-08','11:10:00',1.24),('1444','2014-02-08','11:15:00',1.41),('1444','2014-02-08','11:30:00',1.48),('1444','2014-02-08','11:35:00',2.47),('1444','2014-02-08','11:40:00',1.04),('1444','2014-02-08','11:50:00',1.33),('1444','2014-02-08','11:55:00',2.08),('1444','2014-02-08','12:10:00',1.72),('1444','2014-02-08','12:15:00',1.9),('1444','2014-02-08','12:25:00',1.71),('1444','2014-02-08','12:30:00',1.9),('1444','2014-02-08','12:35:00',1.51),('1444','2014-02-08','12:40:00',1.72),('1444','2014-02-08','12:45:00',2.27),('1444','2014-02-08','12:50:00',1.27),('1444','2014-02-08','12:55:00',1.13),('1444','2014-02-08','13:00:00',1.46),('1444','2014-02-08','13:10:00',1.73),('1444','2014-02-08','13:15:00',2.49),('1444','2014-02-08','13:20:00',2.33),('1444','2014-02-08','13:25:00',2.07),('1444','2014-02-08','13:30:00',1.48),('1444','2014-02-08','13:35:00',1.11),('1444','2014-02-08','13:40:00',1.61),('1444','2014-02-08','13:45:00',2.02),('1444','2014-02-08','13:50:00',1.54),('1444','2014-02-08','13:55:00',1.83),('1444','2014-02-08','14:00:00',1.7),('1444','2014-02-08','14:05:00',1.24),('1444','2014-02-08','14:10:00',1.62),('1444','2014-02-08','14:20:00',1.51),('1444','2014-02-08','14:25:00',1.14),('1444','2014-02-08','14:30:00',1.76),('1444','2014-02-08','14:35:00',1.13),('1444','2014-02-08','14:40:00',1.06),('1444','2014-02-08','14:50:00',1.58),('1444','2014-02-08','15:15:00',1.04),('1444','2014-02-08','15:20:00',1.21),('1444','2014-02-08','15:40:00',1.2),('1444','2014-02-07','09:25:00',1),('1444','2014-02-07','09:30:00',1.05),('1444','2014-02-07','09:35:00',1.1),('1444','2014-02-07','09:40:00',1.14),('1444','2014-02-07','09:45:00',1.18),('1444','2014-02-07','09:50:00',1.23),('1444','2014-02-07','09:55:00',1.27),('1444','2014-02-07','10:00:00',1.33),('1444','2014-02-07','10:05:00',1.39),('1444','2014-02-07','10:10:00',1.42),('1444','2014-02-07','10:15:00',1.53),('1444','2014-02-07','10:20:00',1.59),('1444','2014-02-07','10:25:00',1.2),('1444','2014-02-07','10:30:00',1.68),('1444','2014-02-07','10:35:00',1.77),('1444','2014-02-07','10:40:00',1.37),('1444','2014-02-07','10:45:00',1.84),('1444','2014-02-07','10:50:00',1.74),('1444','2014-02-07','10:55:00',1.81),('1444','2014-02-07','11:00:00',1.74),('1444','2014-02-07','11:05:00',2.04),('1444','2014-02-07','11:10:00',2.07),('1444','2014-02-07','11:15:00',2.1),('1444','2014-02-07','11:20:00',1.64),('1444','2014-02-07','11:25:00',1.85),('1444','2014-02-07','11:30:00',1.6),('1444','2014-02-07','11:35:00',1.98),('1444','2014-02-07','11:40:00',2.07),('1444','2014-02-07','11:45:00',1.37),('1444','2014-02-07','11:50:00',2.23),('1444','2014-02-07','11:55:00',1.52),('1444','2014-02-07','12:00:00',1.44),('1444','2014-02-07','12:05:00',1.35),('1444','2014-02-07','12:10:00',1.79),('1444','2014-02-07','12:15:00',2.36),('1444','2014-02-07','12:20:00',2.17),('1444','2014-02-07','12:25:00',1.11),('1444','2014-02-07','12:40:00',1.15),('1444','2014-02-07','12:45:00',1.42),('1444','2014-02-07','12:50:00',2.52),('1444','2014-02-07','12:55:00',1.3),('1444','2014-02-07','13:05:00',1.63),('1444','2014-02-07','13:10:00',1.99),('1444','2014-02-07','13:15:00',1.33),('1444','2014-02-07','13:20:00',1.41),('1444','2014-02-07','13:35:00',1.12),('1444','2014-02-07','13:45:00',2.19),('1444','2014-02-07','13:50:00',1.85),('1444','2014-02-07','13:55:00',1.77),('1444','2014-02-07','14:00:00',1.29),('1444','2014-02-07','14:05:00',1.7),('1444','2014-02-07','14:10:00',1.77),('1444','2014-02-07','14:15:00',1.77),('1444','2014-02-07','14:20:00',1.23),('1444','2014-02-07','14:25:00',1.16),('1444','2014-02-07','14:30:00',1.7),('1444','2014-02-07','14:35:00',1.75),('1444','2014-02-07','14:40:00',1.56),('1444','2014-02-07','14:45:00',1.39),('1444','2014-02-07','14:50:00',1.36),('1444','2014-02-07','14:55:00',1.29),('1444','2014-02-07','15:00:00',1.24),('1444','2014-02-07','15:05:00',1.19),('1444','2014-02-07','15:10:00',1.14),('1444','2014-02-07','15:15:00',1.09),('1444','2014-02-07','15:20:00',1.09),('1444','2014-02-06','09:00:00',1.07),('1444','2014-02-06','09:05:00',1.22),('1444','2014-02-06','09:10:00',1.11),('1444','2014-02-06','09:15:00',1.03),('1444','2014-02-06','09:35:00',1.14),('1444','2014-02-06','09:40:00',1.17),('1444','2014-02-06','09:45:00',1.2),('1444','2014-02-06','09:50:00',1.26),('1444','2014-02-06','09:55:00',1.29),('1444','2014-02-06','10:00:00',1.33),('1444','2014-02-06','10:05:00',1.4),('1444','2014-02-06','10:10:00',1.45),('1444','2014-02-06','10:15:00',1.5),('1444','2014-02-06','10:20:00',1.54),('1444','2014-02-06','10:25:00',1.52),('1444','2014-02-06','10:30:00',1.64),('1444','2014-02-06','10:35:00',1.37),('1444','2014-02-06','10:40:00',1.71),('1444','2014-02-06','10:45:00',1.22),('1444','2014-02-06','10:50:00',1.41),('1444','2014-02-06','10:55:00',1.29),('1444','2014-02-06','11:05:00',1.49),('1444','2014-02-06','11:20:00',2.03),('1444','2014-02-06','11:25:00',1.24),('1444','2014-02-06','11:30:00',2.16),('1444','2014-02-06','11:35:00',1.99),('1444','2014-02-06','11:40:00',1.97),('1444','2014-02-06','11:45:00',1.99),('1444','2014-02-06','11:50:00',2),('1444','2014-02-06','11:55:00',2.02),('1444','2014-02-06','12:00:00',2.04),('1444','2014-02-06','12:05:00',2.08),('1444','2014-02-06','12:10:00',2.06),('1444','2014-02-06','12:15:00',2.06),('1444','2014-02-06','12:20:00',1.99),('1444','2014-02-06','12:25:00',2.04),('1444','2014-02-06','12:30:00',2.03),('1444','2014-02-06','12:35:00',1.94),('1444','2014-02-06','12:40:00',1.98),('1444','2014-02-06','12:45:00',2.04),('1444','2014-02-06','12:50:00',2),('1444','2014-02-06','12:55:00',1.99),('1444','2014-02-06','13:00:00',1.99),('1444','2014-02-06','13:05:00',1.79),('1444','2014-02-06','13:10:00',2.05),('1444','2014-02-06','13:15:00',1.99),('1444','2014-02-06','13:20:00',1.98),('1444','2014-02-06','13:25:00',1.54),('1444','2014-02-06','13:30:00',1.66),('1444','2014-02-06','13:35:00',1.95),('1444','2014-02-06','13:40:00',1.87),('1444','2014-02-06','13:45:00',1.83),('1444','2014-02-06','13:50:00',1.85),('1444','2014-02-06','13:55:00',1.82),('1444','2014-02-06','14:00:00',1.72),('1444','2014-02-06','14:05:00',1.75),('1444','2014-02-06','14:10:00',1.7),('1444','2014-02-06','14:15:00',1.6),('1444','2014-02-06','14:20:00',1.52),('1444','2014-02-06','14:25:00',1.54),('1444','2014-02-06','14:30:00',1.54),('1444','2014-02-06','14:35:00',1.27),('1444','2014-02-06','14:40:00',1.23),('1444','2014-02-06','14:50:00',1.42),('1444','2014-02-06','14:55:00',1.29),('1444','2014-02-06','15:00:00',1.25),('1444','2014-02-06','15:05:00',1.21),('1444','2014-02-06','15:10:00',1.15),('1444','2014-02-06','15:15:00',1.11),('1444','2014-02-06','15:20:00',1.08),('1444','2014-04-27','11:15:00',1.02),('1444','2014-04-27','11:35:00',1.19),('1444','2014-04-27','11:40:00',1.44),('1444','2014-04-27','11:45:00',3.05),('1444','2014-04-27','11:50:00',2.53),('1444','2014-04-27','11:55:00',2.25),('1444','2014-04-27','12:00:00',2.04),('1444','2014-04-27','12:05:00',2.36),('1444','2014-04-27','12:10:00',2.51),('1444','2014-04-27','12:15:00',2.58),('1444','2014-04-27','12:20:00',2.21),('1444','2014-04-27','12:25:00',2.15),('1444','2014-04-27','12:30:00',2.08),('1444','2014-04-27','12:35:00',2.05),('1444','2014-04-27','12:40:00',1.92),('1444','2014-04-27','12:45:00',2.27),('1444','2014-04-27','12:50:00',1.8),('1444','2014-04-27','12:55:00',1.97),('1444','2014-04-27','13:00:00',2.15),('1444','2014-04-27','13:05:00',1.71),('1444','2014-04-27','13:10:00',1.49),('1444','2014-04-27','13:15:00',1.58),('1444','2014-04-27','13:20:00',1.97),('1444','2014-04-27','13:25:00',1.76),('1444','2014-04-27','13:30:00',1.63),('1444','2014-04-27','13:35:00',1.43),('1444','2014-04-27','13:40:00',1.4),('1444','2014-04-27','13:45:00',1.4),('1444','2014-04-27','13:50:00',1.37),('1444','2014-04-27','13:55:00',1.26),('1444','2014-04-27','14:00:00',1.57),('1444','2014-04-27','14:05:00',1.77),('1444','2014-04-27','14:10:00',1.22),('1444','2014-04-27','14:15:00',1.25),('1444','2014-04-27','14:20:00',1.52),('1444','2014-04-27','14:25:00',1.83),('1444','2014-04-27','14:30:00',1.86),('1444','2014-04-27','14:35:00',1.91),('1444','2014-04-27','14:40:00',1.96),('1444','2014-04-27','14:45:00',1.62),('1444','2014-04-27','14:50:00',1.56),('1444','2014-04-27','14:55:00',1.66),('1444','2014-04-27','15:00:00',1.83),('1444','2014-04-27','15:05:00',2.69),('1444','2014-04-27','15:10:00',3.19),('1444','2014-04-27','15:15:00',2.09),('1444','2014-04-27','15:20:00',1.47),('1444','2014-02-05','10:15:00',1.39),('1444','2014-02-05','10:20:00',1.93),('1444','2014-02-05','10:25:00',1.41),('1444','2014-02-05','11:10:00',1.21),('1444','2014-02-05','11:15:00',1.77),('1444','2014-02-05','11:20:00',2.15),('1444','2014-02-05','11:25:00',1.08),('1444','2014-02-05','13:10:00',1.08),('1444','2014-02-05','13:20:00',1.03),('1444','2014-02-05','13:25:00',1.12),('1444','2014-02-05','13:37:00',1.13),('1444','2014-02-05','13:40:00',1.39),('1444','2014-02-05','13:45:00',1.33),('1444','2014-02-05','13:50:00',1.19),('1444','2014-02-05','14:30:00',1.8),('1444','2014-02-05','14:35:00',1.04),('1444','2014-02-04','09:35:00',1.08),('1444','2014-02-04','09:40:00',1.24),('1444','2014-02-04','09:45:00',1.13),('1444','2014-02-04','09:50:00',1.19),('1444','2014-02-04','10:00:00',1.3),('1444','2014-02-04','10:05:00',1.52),('1444','2014-02-04','10:10:00',1.21),('1444','2014-02-04','10:15:00',1.16),('1444','2014-02-04','10:45:00',1.29),('1444','2014-02-04','10:50:00',1.37),('1444','2014-02-04','10:55:00',1.82),('1444','2014-02-04','11:00:00',2.13),('1444','2014-02-04','11:05:00',1.03),('1444','2014-02-04','11:50:00',1.48),('1444','2014-02-04','11:55:00',2.36),('1444','2014-02-04','12:00:00',1.16),('1444','2014-02-04','12:05:00',1.28),('1444','2014-02-04','12:10:00',1.42),('1444','2014-02-04','12:15:00',1.13),('1444','2014-02-04','12:20:00',1.13),('1444','2014-02-04','13:20:00',1.14),('1444','2014-02-01','11:20:00',1.13),('1444','2014-02-01','11:35:00',1.02),('1444','2014-02-01','11:55:00',1.12),('1444','2014-02-01','12:10:00',1.35),('1444','2014-02-01','12:20:00',1.56),('1444','2014-02-01','12:25:00',1.13),('1444','2014-02-01','12:45:00',1.46),('1444','2014-02-01','12:50:00',1.41),('1444','2014-02-01','12:55:00',1.14),('1444','2014-02-01','13:00:00',1.14),('1444','2014-01-30','09:55:00',1.19),('1444','2014-01-30','10:00:00',1.01),('1444','2014-01-30','10:10:00',1.11),('1444','2014-01-30','10:15:00',1.38),('1444','2014-01-30','10:20:00',1.19),('1444','2014-01-30','10:25:00',1.54),('1444','2014-01-30','10:30:00',1.6),('1444','2014-01-30','10:35:00',1.59),('1444','2014-01-30','10:40:00',1.62),('1444','2014-01-30','10:45:00',1.42),('1444','2014-01-30','10:50:00',1.75),('1444','2014-01-30','10:55:00',2.09),('1444','2014-01-30','11:00:00',2.06),('1444','2014-01-30','11:05:00',1.78),('1444','2014-01-30','11:10:00',1.58),('1444','2014-01-30','11:15:00',1.54),('1444','2014-01-30','11:20:00',1.06),('1444','2014-01-30','11:25:00',1.74),('1444','2014-01-30','11:30:00',1.47),('1444','2014-01-30','11:35:00',1.62),('1444','2014-01-30','11:40:00',1.59),('1444','2014-01-30','11:45:00',1.8),('1444','2014-01-30','11:50:00',1.91),('1444','2014-01-30','11:55:00',1.84),('1444','2014-01-30','12:00:00',1.65),('1444','2014-01-30','12:05:00',1.98),('1444','2014-01-30','12:10:00',2.11),('1444','2014-01-30','12:15:00',1.9),('1444','2014-01-30','12:20:00',2.09),('1444','2014-01-30','12:25:00',1.64),('1444','2014-01-30','12:30:00',1.51),('1444','2014-01-30','12:35:00',1.56),('1444','2014-01-30','12:40:00',1.53),('1444','2014-01-30','12:45:00',1.85),('1444','2014-01-30','12:50:00',1.86),('1444','2014-01-30','12:55:00',1.87),('1444','2014-01-30','13:00:00',1.91),('1444','2014-01-30','13:05:00',2.03),('1444','2014-01-30','13:10:00',1.82),('1444','2014-01-30','13:15:00',1.88),('1444','2014-01-30','13:20:00',1.57),('1444','2014-01-30','13:25:00',1.66),('1444','2014-01-30','13:30:00',1.35),('1444','2014-01-30','13:35:00',1.24),('1444','2014-01-30','13:40:00',1.62),('1444','2014-01-30','13:45:00',1.75),('1444','2014-01-30','13:50:00',1.57),('1444','2014-01-30','13:55:00',1.35),('1444','2014-01-30','14:00:00',1.35),('1444','2014-01-30','14:05:00',1.27),('1444','2014-01-30','14:10:00',1.26),('1444','2014-01-30','14:15:00',1.08),('1444','2014-01-30','14:25:00',1.07),('1444','2014-01-30','14:30:00',1.11),('1444','2014-01-30','14:35:00',1.09),('1444','2014-01-30','14:40:00',1.22),('1444','2014-01-30','14:45:00',1.14),('1444','2014-01-30','14:50:00',1.2),('1444','2014-01-30','14:55:00',1.13),('1444','2014-01-30','15:00:00',1.07),('1444','2014-01-30','15:05:00',1.05),('1444','2014-01-30','15:10:00',1),('1444','2014-01-29','09:35:00',1.25),('1444','2014-01-29','09:40:00',1.06),('1444','2014-01-29','09:45:00',1.15),('1444','2014-01-29','09:50:00',1.06),('1444','2014-01-29','09:55:00',1.07),('1444','2014-01-29','10:10:00',1.16),('1444','2014-01-29','10:15:00',1.35),('1444','2014-01-29','10:25:00',1.87),('1444','2014-01-29','10:30:00',1.88),('1444','2014-01-29','10:35:00',1.55),('1444','2014-01-29','10:40:00',1.52),('1444','2014-01-29','10:45:00',1.4),('1444','2014-01-29','10:50:00',1.4),('1444','2014-01-29','10:55:00',1.24),('1444','2014-01-29','11:00:00',1.3),('1444','2014-01-29','11:05:00',1.41),('1444','2014-01-29','11:10:00',1.21),('1444','2014-01-29','11:15:00',1.24),('1444','2014-01-29','11:20:00',1.32),('1444','2014-01-29','11:25:00',1.32),('1444','2014-01-29','11:30:00',1.74),('1444','2014-01-29','11:35:00',1.49),('1444','2014-01-29','12:50:00',1.9),('1444','2014-01-29','12:55:00',1.97),('1444','2014-01-29','13:00:00',1.23),('1444','2014-01-29','13:35:00',1.24),('1444','2014-01-29','13:40:00',1.73),('1444','2014-01-29','13:45:00',1.23),('1444','2014-01-29','13:50:00',1.35),('1444','2014-01-29','13:55:00',1.51),('1444','2014-01-29','15:15:00',1.12),('1444','2014-01-28','09:50:00',1.08),('1444','2014-01-28','09:55:00',1.11),('1444','2014-01-28','10:00:00',1.18),('1444','2014-01-28','10:05:00',1.16),('1444','2014-01-28','10:10:00',1.12),('1444','2014-01-28','10:15:00',1.24),('1444','2014-01-28','10:20:00',1.37),('1444','2014-01-28','10:25:00',1.4),('1444','2014-01-28','10:30:00',1.43),('1444','2014-01-28','10:35:00',1.51),('1444','2014-01-28','10:40:00',1.57),('1444','2014-01-28','10:45:00',1.49),('1444','2014-01-28','10:50:00',1.67),('1444','2014-01-28','10:55:00',1.07),('1444','2014-01-28','11:00:00',1.02),('1444','2014-01-28','11:05:00',1.17),('1444','2014-01-28','11:10:00',1.9),('1444','2014-01-28','11:15:00',1.06),('1444','2014-01-28','11:25:00',1.14),('1444','2014-01-28','11:30:00',1.21),('1444','2014-01-28','11:35:00',1.27),('1444','2014-01-28','11:40:00',2.16),('1444','2014-01-28','11:45:00',2.09),('1444','2014-01-28','11:50:00',1.72),('1444','2014-01-28','12:00:00',1.6),('1444','2014-01-28','12:05:00',1.35),('1444','2014-01-28','12:10:00',1.12),('1444','2014-01-28','12:35:00',1.11),('1444','2014-01-28','12:40:00',1.1),('1444','2014-01-28','12:45:00',1.71),('1444','2014-01-28','12:50:00',1.68),('1444','2014-01-28','12:55:00',2.19),('1444','2014-01-28','13:00:00',2.07),('1444','2014-01-28','13:05:00',2.1),('1444','2014-01-28','13:10:00',1.42),('1444','2014-01-28','13:15:00',1.81),('1444','2014-01-28','13:20:00',1.72),('1444','2014-01-28','13:25:00',1.74),('1444','2014-01-28','13:30:00',1.87),('1444','2014-01-28','13:35:00',1.87),('1444','2014-01-28','13:40:00',1.74),('1444','2014-01-28','13:45:00',1.66),('1444','2014-01-28','13:50:00',1.59),('1444','2014-01-28','13:55:00',1.56),('1444','2014-01-28','14:00:00',1.51),('1444','2014-01-28','14:05:00',1.39),('1444','2014-01-28','14:10:00',1.38),('1444','2014-01-28','14:15:00',1.38),('1444','2014-01-28','14:20:00',1.38),('1444','2014-01-28','14:25:00',1.39),('1444','2014-01-28','14:30:00',1.33),('1444','2014-01-28','14:35:00',1.27),('1444','2014-01-28','14:40:00',1.24),('1444','2014-01-28','14:45:00',1.21),('1444','2014-01-28','14:50:00',1.16),('1444','2014-01-28','14:55:00',1.1),('1444','2014-01-28','15:00:00',1.05),('1444','2014-01-28','15:05:00',1.02),('14598','2014-05-05','08:05:00',1.07),('14598','2014-05-05','08:10:00',1.16),('14598','2014-05-05','08:15:00',1.26),('14598','2014-05-05','08:20:00',1.36),('14598','2014-05-05','08:25:00',1.48),('14598','2014-05-05','08:30:00',1.61),('14598','2014-05-05','08:35:00',1.73),('14598','2014-05-05','08:40:00',1.84),('14598','2014-05-05','08:45:00',1.95),('14598','2014-05-05','08:50:00',2.04),('14598','2014-05-05','08:55:00',2.17),('14598','2014-05-05','09:00:00',2.29),('14598','2014-05-05','09:05:00',2.41),('14598','2014-05-05','09:10:00',2.5),('14598','2014-05-05','09:15:00',2.59),('14598','2014-05-05','09:20:00',2.68),('14598','2014-05-05','09:25:00',2.78),('14598','2014-05-05','09:30:00',2.87),('14598','2014-05-05','09:35:00',2.97),('14598','2014-05-05','09:40:00',3.05),('14598','2014-05-05','09:45:00',3.12),('14598','2014-05-05','09:50:00',3.23),('14598','2014-05-05','09:55:00',3.31),('14598','2014-05-05','10:00:00',3.39),('14598','2014-05-05','10:05:00',3.47),('14598','2014-05-05','10:10:00',3.54),('14598','2014-05-05','10:15:00',3.62),('14598','2014-05-05','10:20:00',3.7),('14598','2014-05-05','10:25:00',3.77),('14598','2014-05-05','10:30:00',3.84),('14598','2014-05-05','10:35:00',3.92),('14598','2014-05-05','10:40:00',3.98),('14598','2014-05-05','10:45:00',4.03),('14598','2014-05-05','10:50:00',4.07),('14598','2014-05-05','10:55:00',4.13),('14598','2014-05-05','11:00:00',4.12),('14598','2014-05-05','11:05:00',4.22),('14598','2014-05-05','11:10:00',4.27),('14598','2014-05-05','11:15:00',4.32),('14598','2014-05-05','11:20:00',4.35),('14598','2014-05-05','11:25:00',4.39),('14598','2014-05-05','11:30:00',4.47),('14598','2014-05-05','11:35:00',4.49),('14598','2014-05-05','11:40:00',4.51),('14598','2014-05-05','11:45:00',4.56),('14598','2014-05-05','11:50:00',4.58),('14598','2014-05-05','11:55:00',4.63),('14598','2014-05-05','12:00:00',4.64),('14598','2014-05-05','12:05:00',4.68),('14598','2014-05-05','12:10:00',4.72),('14598','2014-05-05','12:15:00',4.76),('14598','2014-05-05','12:20:00',4.56),('14598','2014-05-05','12:25:00',4.27),('14598','2014-05-05','12:30:00',4.78),('14598','2014-05-05','12:35:00',5.12),('14598','2014-05-05','12:40:00',5.19),('14598','2014-05-05','12:45:00',5.2),('14598','2014-05-05','12:50:00',5.21),('14598','2014-05-05','12:55:00',5.23),('14598','2014-05-05','13:00:00',5.24),('14598','2014-05-05','13:05:00',5.25),('14598','2014-05-05','13:10:00',5.27),('14598','2014-05-05','13:15:00',5.3),('14598','2014-05-05','13:20:00',5.31),('14598','2014-05-05','13:25:00',5.3),('14598','2014-05-05','13:30:00',5.33),('14598','2014-05-05','13:35:00',5.32),('14598','2014-05-05','13:40:00',5.31),('14598','2014-05-05','13:45:00',5.28),('14598','2014-05-05','13:50:00',5.3),('14598','2014-05-05','13:55:00',5.31),('14598','2014-05-05','14:00:00',5.3),('14598','2014-05-05','14:05:00',5.2),('14598','2014-05-05','14:10:00',5.27),('14598','2014-05-05','14:15:00',5.27),('14598','2014-05-05','14:20:00',5.25),('14598','2014-05-05','14:25:00',5.22),('14598','2014-05-05','14:30:00',5.19),('14598','2014-05-05','14:35:00',5.18),('14598','2014-05-05','14:40:00',5.17),('14598','2014-05-05','14:45:00',5.16),('14598','2014-05-05','14:50:00',5.13),('14598','2014-05-05','14:55:00',5.11),('14598','2014-05-05','15:00:00',5.06),('14598','2014-05-05','15:05:00',5.02),('14598','2014-05-05','15:10:00',4.98),('14598','2014-05-05','15:15:00',4.94),('14598','2014-05-05','15:20:00',4.88),('14598','2014-05-05','15:25:00',4.83),('14598','2014-05-05','15:30:00',4.8),('14598','2014-05-05','15:35:00',4.75),('14598','2014-05-05','15:40:00',4.71),('14598','2014-05-05','15:45:00',4.64),('14598','2014-05-05','15:50:00',4.58),('14598','2014-05-05','15:55:00',4.54),('14598','2014-05-05','16:00:00',4.5),('14598','2014-05-05','16:05:00',4.42),('14598','2014-05-05','16:10:00',4.34),('14598','2014-05-05','16:15:00',4.29),('14598','2014-05-05','16:20:00',4.23),('14598','2014-05-05','16:25:00',4.15),('14598','2014-05-05','16:30:00',4.08),('14598','2014-05-05','16:35:00',4.02),('14598','2014-05-05','16:40:00',3.92),('14598','2014-05-05','16:45:00',3.84),('14598','2014-05-05','16:50:00',3.75),('14598','2014-05-05','16:55:00',3.7),('14598','2014-05-05','17:00:00',3.6),('14598','2014-05-05','17:05:00',3.5),('14598','2014-05-05','17:10:00',3.43),('14598','2014-05-05','17:15:00',3.34),('14598','2014-05-05','17:20:00',3.25),('14598','2014-05-05','17:25:00',3.14),('14598','2014-05-05','17:30:00',3.04),('14598','2014-05-05','17:35:00',2.94),('14598','2014-05-05','17:40:00',2.84),('14598','2014-05-05','17:45:00',2.72),('14598','2014-05-05','17:50:00',2.63),('14598','2014-05-05','17:55:00',2.51),('14598','2014-05-05','18:00:00',2.41),('14598','2014-05-05','18:05:00',2.29),('14598','2014-05-05','18:10:00',2.19),('14598','2014-05-05','18:15:00',2.08),('14598','2014-05-05','18:20:00',1.98),('14598','2014-05-05','18:25:00',1.86),('14598','2014-05-05','18:30:00',1.76),('14598','2014-05-05','18:35:00',1.64),('14598','2014-05-05','18:40:00',1.53),('14598','2014-05-05','18:45:00',1.41),('14598','2014-05-05','18:50:00',1.28),('14598','2014-05-05','18:55:00',1.17),('14598','2014-05-05','19:00:00',1.06),('14598','2014-04-26','08:40:00',1.13),('14598','2014-04-26','08:45:00',1.19),('14598','2014-04-26','08:50:00',1.22),('14598','2014-04-26','08:55:00',1.24),('14598','2014-04-26','09:00:00',1.4),('14598','2014-04-26','09:05:00',1.64),('14598','2014-04-26','09:10:00',1.42),('14598','2014-04-26','09:15:00',1.4),('14598','2014-04-26','09:20:00',1.19),('14598','2014-04-26','09:25:00',1.27),('14598','2014-04-26','09:30:00',1.37),('14598','2014-04-26','09:35:00',1.23),('14598','2014-04-26','09:40:00',1.48),('14598','2014-04-26','09:45:00',1.59),('14598','2014-04-26','09:50:00',1.52),('14598','2014-04-26','10:05:00',1.13),('14598','2014-04-26','10:10:00',1.94),('14598','2014-04-26','10:15:00',2.23),('14598','2014-04-26','10:20:00',2.75),('14598','2014-04-26','10:25:00',2.22),('14598','2014-04-26','10:30:00',1.92),('14598','2014-04-26','10:35:00',2.29),('14598','2014-04-26','10:40:00',3.42),('14598','2014-04-26','10:45:00',3.49),('14598','2014-04-26','10:50:00',4.11),('14598','2014-04-26','10:55:00',4.14),('14598','2014-04-26','11:00:00',3.89),('14598','2014-04-26','11:05:00',3.81),('14598','2014-04-26','11:10:00',3.62),('14598','2014-04-26','11:15:00',2.84),('14598','2014-04-26','11:20:00',4.21),('14598','2014-04-26','11:25:00',4.55),('14598','2014-04-26','11:30:00',4.55),('14598','2014-04-26','11:35:00',3.79),('14598','2014-04-26','11:40:00',2.5),('14598','2014-04-26','11:45:00',3.81),('14598','2014-04-26','11:50:00',4.6),('14598','2014-04-26','11:55:00',3.17),('14598','2014-04-26','12:00:00',2.54),('14598','2014-04-26','12:05:00',3.8),('14598','2014-04-26','12:10:00',4.02),('14598','2014-04-26','12:15:00',4.83),('14598','2014-04-26','12:20:00',4.19),('14598','2014-04-26','12:25:00',2.6),('14598','2014-04-26','12:30:00',2.45),('14598','2014-04-26','12:35:00',4.04),('14598','2014-04-26','12:40:00',3.68),('14598','2014-04-26','12:45:00',2.96),('14598','2014-04-26','12:50:00',5.33),('14598','2014-04-26','12:55:00',5.3),('14598','2014-04-26','13:00:00',5.26),('14598','2014-04-26','13:05:00',5.41),('14598','2014-04-26','13:10:00',5.49),('14598','2014-04-26','13:15:00',4.58),('14598','2014-04-26','13:20:00',4.4),('14598','2014-04-26','13:25:00',5.16),('14598','2014-04-26','13:30:00',4.93),('14598','2014-04-26','13:35:00',4.96),('14598','2014-04-26','13:40:00',4.86),('14598','2014-04-26','13:45:00',5.03),('14598','2014-04-26','13:50:00',5.13),('14598','2014-04-26','13:55:00',5.12),('14598','2014-04-26','14:00:00',5.08),('14598','2014-04-26','14:05:00',5.33),('14598','2014-04-26','14:10:00',5.01),('14598','2014-04-26','14:15:00',5.35),('14598','2014-04-26','14:20:00',5.32),('14598','2014-04-26','14:25:00',5.24),('14598','2014-04-26','14:30:00',5.24),('14598','2014-04-26','14:35:00',5.23),('14598','2014-04-26','14:40:00',4.74),('14598','2014-04-26','14:45:00',3.79),('14598','2014-04-26','14:50:00',5.4),('14598','2014-04-26','14:55:00',5.04),('14598','2014-04-26','15:00:00',4.15),('14598','2014-04-26','15:05:00',2.49),('14598','2014-04-26','15:10:00',2.07),('14598','2014-04-26','15:15:00',1.98),('14598','2014-04-26','15:20:00',1.73),('14598','2014-04-26','15:25:00',1.31),('14598','2014-04-26','15:30:00',1.02),('14598','2014-04-26','15:50:00',1.3),('14598','2014-01-26','08:55:00',1.09),('14598','2014-01-26','09:15:00',1.01),('14598','2014-01-26','09:20:00',1.13),('14598','2014-01-26','09:45:00',1.03),('14598','2014-01-26','09:50:00',1.11),('14598','2014-01-26','10:00:00',2.5),('14598','2014-01-26','10:05:00',2.88),('14598','2014-01-26','10:10:00',1.54),('14598','2014-01-26','10:20:00',1.14),('14598','2014-01-26','10:25:00',1),('14598','2014-01-26','10:30:00',1.11),('14598','2014-01-26','10:35:00',2.04),('14598','2014-01-26','10:40:00',1.65),('14598','2014-01-26','10:45:00',1.38),('14598','2014-01-26','10:50:00',1.5),('14598','2014-01-26','10:55:00',1.18),('14598','2014-01-26','11:00:00',1.14),('14598','2014-01-26','11:05:00',1.53),('14598','2014-01-26','11:10:00',2.6),('14598','2014-01-26','11:15:00',1.73),('14598','2014-01-26','11:20:00',1.28),('14598','2014-01-26','11:25:00',1.39),('14598','2014-01-26','11:30:00',2.31),('14598','2014-01-26','11:35:00',2.3),('14598','2014-01-26','11:40:00',1.71),('14598','2014-01-26','11:45:00',1.38),('14598','2014-01-26','11:50:00',1.56),('14598','2014-01-26','11:55:00',1.71),('14598','2014-01-26','12:00:00',1.44),('14598','2014-01-26','12:05:00',1.6),('14598','2014-01-26','12:10:00',1.91),('14598','2014-01-26','12:15:00',1.95),('14598','2014-01-26','12:20:00',1.33),('14598','2014-01-26','12:25:00',1.19),('14598','2014-01-26','12:30:00',1.17),('14598','2014-01-26','12:35:00',1.18),('14598','2014-01-26','12:40:00',1.17),('14598','2014-01-26','12:45:00',1.22),('14598','2014-01-26','12:50:00',1.28),('14598','2014-01-26','12:55:00',1.36),('14598','2014-01-26','13:00:00',1.52),('14598','2014-01-26','13:05:00',1.79),('14598','2014-01-26','13:10:00',1.98),('14598','2014-01-26','13:15:00',2.92),('14598','2014-01-26','13:20:00',1.94),('14598','2014-01-26','13:25:00',1.55),('14598','2014-01-26','13:30:00',1.33),('14598','2014-01-26','13:35:00',1.05),('14598','2014-01-26','13:45:00',1.02),('14598','2014-01-26','13:50:00',1.28),('14598','2014-01-26','13:55:00',1.14),('14598','2014-01-25','09:50:00',1.09),('14598','2014-01-25','09:55:00',1.21),('14598','2014-01-25','10:00:00',1.19),('14598','2014-01-25','10:05:00',1.1),('14598','2014-01-25','10:10:00',1.06),('14598','2014-01-25','10:15:00',1.24),('14598','2014-01-25','10:20:00',1.41),('14598','2014-01-25','10:25:00',1.61),('14598','2014-01-25','10:30:00',1.91),('14598','2014-01-25','10:35:00',2.41),('14598','2014-01-25','10:40:00',2.9),('14598','2014-01-25','10:45:00',2.62),('14598','2014-01-25','10:50:00',3.5),('14598','2014-01-25','10:55:00',3.49),('14598','2014-01-25','11:00:00',1.74),('14598','2014-01-25','11:05:00',1.94),('14598','2014-01-25','11:10:00',1.96),('14598','2014-01-25','11:15:00',2.64),('14598','2014-01-25','11:20:00',3.82),('14598','2014-01-25','11:25:00',3.84),('14598','2014-01-25','11:30:00',3.69),('14598','2014-01-25','11:35:00',2.48),('14598','2014-01-25','11:40:00',2.5),('14598','2014-01-25','11:45:00',2.3),('14598','2014-01-25','11:50:00',2.47),('14598','2014-01-25','11:55:00',2.43),('14598','2014-01-25','12:00:00',1.42),('14598','2014-01-25','12:05:00',1.51),('14598','2014-01-25','12:10:00',1.74),('14598','2014-01-25','12:15:00',1.83),('14598','2014-01-25','12:20:00',1.96),('14598','2014-01-25','12:25:00',2.35),('14598','2014-01-25','12:30:00',2.6),('14598','2014-01-25','12:35:00',3.57),('14598','2014-01-25','12:40:00',3.62),('14598','2014-01-25','12:45:00',3.72),('14598','2014-01-25','12:50:00',3.56),('14598','2014-01-25','12:55:00',3.49),('14598','2014-01-25','13:00:00',3.59),('14598','2014-01-25','13:05:00',3.49),('14598','2014-01-25','13:10:00',3.32),('14598','2014-01-25','13:15:00',3.51),('14598','2014-01-25','13:20:00',3.55),('14598','2014-01-25','13:25:00',3.47),('14598','2014-01-25','13:30:00',3.45),('14598','2014-01-25','13:35:00',3.34),('14598','2014-01-25','13:40:00',3.34),('14598','2014-01-25','13:45:00',3.34),('14598','2014-01-25','13:50:00',3.36),('14598','2014-01-25','13:55:00',3.36),('14598','2014-01-25','14:00:00',2.49),('14598','2014-01-25','14:05:00',2.54),('14598','2014-01-25','14:10:00',2.51),('14598','2014-01-25','14:15:00',2.63),('14598','2014-01-25','14:20:00',2.84),('14598','2014-01-25','14:25:00',2.87),('14598','2014-01-25','14:30:00',2.42),('14598','2014-01-25','14:35:00',2.53),('14598','2014-01-25','14:40:00',2.61),('14598','2014-01-25','14:45:00',2.87),('14598','2014-01-25','14:50:00',2.81),('14598','2014-01-25','14:55:00',2.69),('14598','2014-01-25','15:00:00',2.62),('14598','2014-01-25','15:05:00',2.48),('14598','2014-01-25','15:10:00',2.37),('14598','2014-01-25','15:15:00',2.27),('14598','2014-01-25','15:20:00',2.19),('14598','2014-01-25','15:25:00',2.08),('14598','2014-01-25','15:30:00',1.99),('14598','2014-01-25','15:35:00',1.9),('14598','2014-01-25','15:40:00',1.78),('14598','2014-01-25','15:45:00',1.71),('14598','2014-01-25','15:50:00',1.6),('14598','2014-01-25','15:55:00',1.52),('14598','2014-01-25','16:00:00',1.43),('14598','2014-01-25','16:05:00',1.31),('14598','2014-01-25','16:10:00',1.2),('14598','2014-01-25','16:15:00',1.1),('14598','2014-01-24','09:55:00',1.21),('14598','2014-01-24','10:00:00',1.43),('14598','2014-01-24','10:05:00',2.21),('14598','2014-01-24','10:10:00',1.95),('14598','2014-01-24','10:15:00',2.19),('14598','2014-01-24','10:20:00',1.01),('14598','2014-01-24','10:30:00',1.07),('14598','2014-01-24','10:40:00',1.84),('14598','2014-01-24','10:45:00',1.19),('14598','2014-01-24','11:00:00',1.1),('14598','2014-01-24','11:05:00',1.79),('14598','2014-01-24','11:10:00',1.5),('14598','2014-01-24','11:15:00',1.07),('14598','2014-01-24','11:20:00',1.97),('14598','2014-01-24','11:25:00',2.87),('14598','2014-01-24','11:30:00',2.44),('14598','2014-01-24','11:35:00',1.53),('14598','2014-01-24','11:40:00',1.21),('14598','2014-01-24','11:45:00',1.05),('14598','2014-01-24','11:50:00',1.18),('14598','2014-01-24','11:55:00',2.97),('14598','2014-01-24','12:00:00',2.4),('14598','2014-01-24','12:10:00',1.01),('14598','2014-01-24','12:15:00',1.42),('14598','2014-01-24','12:20:00',1.86),('14598','2014-01-24','12:25:00',1.86),('14598','2014-01-24','12:30:00',1.76),('14598','2014-01-24','12:40:00',3.31),('14598','2014-01-24','12:45:00',1.23),('14598','2014-01-24','12:50:00',2.54),('14598','2014-01-24','12:55:00',3.5),('14598','2014-01-24','13:00:00',2.56),('14598','2014-01-24','13:05:00',3.2),('14598','2014-01-24','13:10:00',2.43),('14598','2014-01-24','13:15:00',2.41),('14598','2014-01-24','13:20:00',3.09),('14598','2014-01-24','13:25:00',2.62),('14598','2014-01-24','13:30:00',2.25),('14598','2014-01-24','13:35:00',1.39),('14598','2014-01-24','13:55:00',2.47),('14598','2014-01-24','14:00:00',3.62),('14598','2014-01-24','14:05:00',3.12),('14598','2014-01-24','14:10:00',3.04),('14598','2014-01-24','14:15:00',3.01),('14598','2014-01-24','14:20:00',2.97),('14598','2014-01-24','14:25:00',2.87),('14598','2014-01-24','14:30:00',2.32),('14598','2014-01-24','14:35:00',2.13),('14598','2014-01-24','14:40:00',1.41),('14598','2014-01-23','10:35:00',1.16),('14598','2014-01-23','10:40:00',1.71),('14598','2014-01-23','10:45:00',3.12),('14598','2014-01-23','10:50:00',2.7),('14598','2014-01-23','10:55:00',2.01),('14598','2014-01-23','11:00:00',1.41),('14598','2014-01-23','11:05:00',1.3),('14598','2014-01-23','11:10:00',1.15),('14598','2014-01-23','11:15:00',1.07),('14598','2014-01-23','11:20:00',1.39),('14598','2014-01-23','11:25:00',1.59),('14598','2014-01-23','11:30:00',1.68),('14598','2014-01-23','11:35:00',2.24),('14598','2014-01-23','11:40:00',1.99),('14598','2014-01-23','11:45:00',1.71),('14598','2014-01-23','11:50:00',1.31),('14598','2014-01-23','11:55:00',1.23),('14598','2014-01-23','12:00:00',1.36),('14598','2014-01-23','12:05:00',1.23),('14598','2014-01-22','11:55:00',1.01),('14598','2014-01-22','12:00:00',1.36),('14598','2014-01-22','12:05:00',1.37),('14598','2014-01-22','12:10:00',1.63),('14598','2014-01-22','12:15:00',1.22),('14598','2014-01-22','12:20:00',1),('14598','2014-01-22','12:25:00',1.01),('14598','2014-01-22','12:30:00',1.02),('14598','2014-01-22','12:50:00',1.26),('14598','2014-01-22','14:25:00',1.01),('14598','2014-01-22','14:30:00',1.48),('14598','2014-01-22','14:35:00',1.34),('14598','2014-01-22','14:40:00',1.21),('14598','2014-01-22','14:45:00',1.02),('14598','2014-01-22','14:50:00',1.05),('14598','2014-01-22','14:55:00',1.18),('14598','2014-01-22','15:25:00',1.28),('14598','2014-01-22','15:30:00',1.88),('14598','2014-01-22','15:35:00',1.66),('14598','2014-01-22','15:40:00',2.11),('14598','2014-01-22','15:45:00',2.08),('14598','2014-01-22','15:50:00',1.87),('14598','2014-01-22','15:55:00',1.56),('14598','2014-01-22','16:00:00',1.41),('14598','2014-01-22','16:05:00',1.27),('14598','2014-01-22','16:10:00',1.14),('14598','2014-01-22','16:15:00',1.03),('14598','2014-01-21','10:10:00',1.36),('14598','2014-01-21','10:15:00',1.43),('14598','2014-01-21','10:25:00',1.45),('14598','2014-01-21','10:30:00',1.49),('14598','2014-01-21','10:40:00',1.03),('14598','2014-01-21','10:45:00',1.62),('14598','2014-01-21','11:05:00',1.59),('14598','2014-01-21','11:10:00',2.13),('14598','2014-01-21','11:25:00',1.24),('14598','2014-01-21','11:30:00',2.43),('14598','2014-01-21','11:35:00',2.03),('14598','2014-01-21','11:40:00',1.81),('14598','2014-01-21','11:45:00',2.11),('14598','2014-01-21','11:50:00',2.17),('14598','2014-01-21','11:55:00',1.69),('14598','2014-01-21','12:00:00',1.41),('14598','2014-01-21','12:05:00',1.07),('14598','2014-01-21','12:10:00',1.06),('14598','2014-01-21','12:15:00',1.17),('14598','2014-01-21','12:35:00',1.29),('14598','2014-01-21','12:40:00',1.64),('14598','2014-01-21','12:45:00',1.69),('14598','2014-01-21','12:50:00',1.4),('14598','2014-01-21','12:55:00',1.13),('14598','2014-01-21','13:15:00',1.18),('14598','2014-01-21','13:20:00',1.59),('14598','2014-01-21','13:25:00',1.59),('14598','2014-01-21','13:30:00',1.23),('14598','2014-01-21','14:25:00',1.01),('14598','2014-01-21','14:30:00',1.59),('14598','2014-01-21','14:35:00',1.45),('14598','2014-01-21','14:40:00',1.22),('14598','2014-01-21','14:45:00',1.19),('14598','2014-01-21','14:55:00',1.06),('14598','2014-01-21','15:00:00',2.3),('14598','2014-01-21','15:05:00',2.16),('14598','2014-01-21','15:10:00',1.54),('14598','2014-01-21','15:15:00',1.9),('14598','2014-01-21','15:20:00',1.65),('14598','2014-01-20','09:55:00',1.4),('14598','2014-01-20','10:00:00',1.77),('14598','2014-01-20','10:05:00',1.21),('14598','2014-01-20','11:45:00',1.08),('14598','2014-01-20','11:50:00',1.49),('14598','2014-01-20','11:55:00',2.12),('14598','2014-01-20','12:00:00',1.04),('14598','2014-01-20','12:10:00',1.54),('14598','2014-01-20','12:15:00',3.74),('14598','2014-01-20','12:20:00',3.68),('14598','2014-01-20','12:25:00',3.47),('14598','2014-01-20','12:30:00',2.24),('14598','2014-01-20','12:35:00',3.31),('14598','2014-01-20','12:40:00',3.32),('14598','2014-01-20','12:45:00',3.41),('14598','2014-01-20','12:50:00',3.48),('14598','2014-01-20','12:55:00',2.45),('14598','2014-01-20','13:20:00',2.76),('14598','2014-01-20','13:25:00',1.93),('14598','2014-01-20','13:30:00',1.15),('14598','2014-01-20','13:45:00',1.47),('14598','2014-01-20','13:50:00',1.01),('14598','2014-01-20','13:55:00',1.22),('14598','2014-01-20','14:00:00',1.64),('14598','2014-01-19','11:35:00',1.11),('14598','2014-01-19','11:40:00',1.34),('14598','2014-01-19','11:45:00',1.41),('14598','2014-01-19','11:50:00',1.43),('14598','2014-01-19','11:55:00',1.47),('14598','2014-01-19','12:00:00',1.29),('14598','2014-01-19','12:05:00',1.02),('14598','2014-01-19','12:15:00',1.01),('14598','2014-01-19','12:20:00',1.23),('14598','2014-01-19','12:25:00',1.41),('14598','2014-01-19','12:30:00',1.34),('14598','2014-01-19','12:35:00',1.21),('14598','2014-01-19','12:40:00',1.21),('14598','2014-01-19','12:45:00',1.2),('14598','2014-01-19','12:50:00',1.33),('14598','2014-01-19','12:55:00',1.41),('14598','2014-01-19','13:00:00',1.44),('14598','2014-01-19','13:05:00',1.41),('14598','2014-01-19','13:10:00',1.28),('14598','2014-01-19','13:15:00',1.14),('14598','2014-01-19','13:20:00',1.13),('14598','2014-01-19','13:25:00',1.07),('14598','2014-01-19','13:30:00',1.02),('14598','2014-01-19','13:35:00',1.24),('14598','2014-01-19','13:40:00',1.33),('14598','2014-01-19','13:45:00',1.22),('14598','2014-01-19','13:50:00',1.22),('14598','2014-01-19','13:55:00',1.21),('14598','2014-01-19','14:00:00',1.03),('14598','2014-01-19','14:05:00',1.01),('14598','2014-01-19','14:10:00',1.41),('14598','2014-01-19','14:15:00',1.92),('14598','2014-01-19','14:20:00',2.03),('14598','2014-01-19','14:25:00',1.56),('14598','2014-01-19','14:30:00',1.31),('14598','2014-01-18','09:35:00',1.52),('14598','2014-01-18','09:40:00',1.55),('14598','2014-01-18','09:45:00',1.06),('14598','2014-01-18','09:50:00',1.4),('14598','2014-01-18','09:55:00',1.63),('14598','2014-01-18','10:00:00',1.87),('14598','2014-01-18','10:05:00',1.54),('14598','2014-01-18','10:10:00',1.37),('14598','2014-01-18','10:15:00',1.32),('14598','2014-01-18','10:20:00',1.19),('14598','2014-01-18','10:25:00',1.34),('14598','2014-01-18','10:30:00',2.15),('14598','2014-01-18','10:35:00',1.21),('14598','2014-01-18','10:40:00',1.04),('14598','2014-01-18','10:45:00',1.59),('14598','2014-01-18','10:50:00',2.06),('14598','2014-01-18','10:55:00',2.51),('14598','2014-01-18','11:00:00',2.52),('14598','2014-01-18','11:05:00',2.55),('14598','2014-01-18','11:10:00',2.58),('14598','2014-01-18','11:15:00',2.63),('14598','2014-01-18','11:20:00',2.69),('14598','2014-01-18','11:25:00',2.82),('14598','2014-01-18','11:30:00',2.57),('14598','2014-01-18','11:35:00',1.56),('14598','2014-01-18','11:40:00',1.46),('14598','2014-01-18','11:45:00',2.74),('14598','2014-01-18','11:50:00',3.14),('14598','2014-01-18','11:55:00',2.97),('14598','2014-01-18','12:00:00',2.92),('14598','2014-01-18','12:05:00',2.93),('14598','2014-01-18','12:10:00',2.94),('14598','2014-01-18','12:15:00',2.8),('14598','2014-01-18','12:20:00',2.88),('14598','2014-01-18','12:25:00',2.99),('14598','2014-01-18','12:30:00',2.86),('14598','2014-01-18','12:35:00',3.11),('14598','2014-01-18','12:40:00',2.73),('14598','2014-01-18','12:45:00',3.24),('14598','2014-01-18','12:50:00',3),('14598','2014-01-18','12:55:00',1.81),('14598','2014-01-18','13:00:00',2.03),('14598','2014-01-18','13:05:00',2.83),('14598','2014-01-18','13:10:00',2.92),('14598','2014-01-18','13:15:00',2.72),('14598','2014-01-18','13:20:00',2.2),('14598','2014-01-18','13:25:00',3.26),('14598','2014-01-18','13:30:00',2.94),('14598','2014-01-18','13:35:00',2.71),('14598','2014-01-18','13:40:00',2.71),('14598','2014-01-18','13:45:00',2.96),('14598','2014-01-18','13:50:00',3.09),('14598','2014-01-18','13:55:00',2.68),('14598','2014-01-18','14:00:00',2.7),('14598','2014-01-18','14:05:00',2.68),('14598','2014-01-18','14:10:00',2.35),('14598','2014-01-18','14:15:00',2.01),('14598','2014-01-18','14:20:00',2.58),('14598','2014-01-18','14:25:00',2.58),('14598','2014-01-18','14:30:00',2.26),('14598','2014-01-18','14:35:00',2.06),('14598','2014-01-18','14:40:00',2.31),('14598','2014-01-18','15:10:00',1.29),('14598','2014-01-18','15:15:00',2.26),('14598','2014-01-18','15:20:00',1.59),('14598','2014-01-18','15:40:00',1.64),('14598','2014-01-18','15:45:00',1.45),('14598','2014-01-18','15:50:00',1.03),('14598','2014-01-18','15:55:00',1.16),('14598','2014-01-17','09:15:00',1.17),('14598','2014-01-17','09:20:00',1.4),('14598','2014-01-17','09:25:00',1.56),('14598','2014-04-25','08:10:00',1),('14598','2014-04-25','08:15:00',1.03),('14598','2014-04-25','08:20:00',1.12),('14598','2014-04-25','08:25:00',1.19),('14598','2014-04-25','08:30:00',1.31),('14598','2014-04-25','08:35:00',1.41),('14598','2014-04-25','08:40:00',1.49),('14598','2014-04-25','08:45:00',1.59),('14598','2014-04-25','08:50:00',1.6),('14598','2014-04-25','08:55:00',1.78),('14598','2014-04-25','09:00:00',1.92),('14598','2014-04-25','09:05:00',2.02),('14598','2014-04-25','09:10:00',2.14),('14598','2014-04-25','09:15:00',2.4),('14598','2014-04-25','09:20:00',1.93),('14598','2014-04-25','09:25:00',2.36),('14598','2014-04-25','09:30:00',1.13),('14598','2014-04-25','09:40:00',1.05),('14598','2014-04-25','09:45:00',1.17),('14598','2014-04-25','09:50:00',1.13),('14598','2014-04-25','09:55:00',1.28),('14598','2014-04-25','10:00:00',1.94),('14598','2014-04-25','10:05:00',2.63),('14598','2014-04-25','10:10:00',3.59),('14598','2014-04-25','10:15:00',3.47),('14598','2014-04-25','10:20:00',3.48),('14598','2014-04-25','10:25:00',3.57),('14598','2014-04-25','10:30:00',3.65),('14598','2014-04-25','10:35:00',3.74),('14598','2014-04-25','10:40:00',3.83),('14598','2014-04-25','10:45:00',3.81),('14598','2014-04-25','10:50:00',3.91),('14598','2014-04-25','10:55:00',3.98),('14598','2014-04-25','11:00:00',4.03),('14598','2014-04-25','11:05:00',4.1),('14598','2014-04-25','11:10:00',4.13),('14598','2014-04-25','11:15:00',4.21),('14598','2014-04-25','11:20:00',4.3),('14598','2014-04-25','11:25:00',4.33),('14598','2014-04-25','11:30:00',4.37),('14598','2014-04-25','11:35:00',4.41),('14598','2014-04-25','11:40:00',4.45),('14598','2014-04-25','11:45:00',4.5),('14598','2014-04-25','11:50:00',4.54),('14598','2014-04-25','11:55:00',4.59),('14598','2014-04-25','12:00:00',4.62),('14598','2014-04-25','12:05:00',4.67),('14598','2014-04-25','12:10:00',4.72),('14598','2014-04-25','12:15:00',4.74),('14598','2014-04-25','12:20:00',4.8),('14598','2014-04-25','12:25:00',4.8),('14598','2014-04-25','12:30:00',4.84),('14598','2014-04-25','12:35:00',4.87),('14598','2014-04-25','12:40:00',4.88),('14598','2014-04-25','12:45:00',4.9),('14598','2014-04-25','12:50:00',4.91),('14598','2014-04-25','12:55:00',4.93),('14598','2014-04-25','13:00:00',4.95),('14598','2014-04-25','13:05:00',4.97),('14598','2014-04-25','13:10:00',5),('14598','2014-04-25','13:15:00',5.03),('14598','2014-04-25','13:20:00',5.04),('14598','2014-04-25','13:25:00',5.05),('14598','2014-04-25','13:30:00',4.78),('14598','2014-04-25','13:35:00',5.03),('14598','2014-04-25','13:40:00',5.03),('14598','2014-04-25','13:45:00',5.07),('14598','2014-04-25','13:50:00',5.08),('14598','2014-04-25','13:55:00',5.04),('14598','2014-04-25','14:00:00',4.99),('14598','2014-04-25','14:05:00',4.97),('14598','2014-04-25','14:10:00',5),('14598','2014-04-25','14:15:00',5),('14598','2014-04-25','14:20:00',5),('14598','2014-04-25','14:25:00',4.99),('14598','2014-04-25','14:30:00',4.95),('14598','2014-04-25','14:35:00',4.95),('14598','2014-04-25','14:40:00',4.95),('14598','2014-04-25','14:45:00',4.93),('14598','2014-04-25','14:50:00',4.88),('14598','2014-04-25','14:55:00',4.79),('14598','2014-04-25','15:00:00',4.75),('14598','2014-04-25','15:05:00',4.68),('14598','2014-04-25','15:10:00',4.73),('14598','2014-04-25','15:15:00',4.64),('14598','2014-04-25','15:20:00',4.56),('14598','2014-04-25','15:25:00',4.49),('14598','2014-04-25','15:30:00',4.45),('14598','2014-04-25','15:35:00',4.39),('14598','2014-04-25','15:40:00',4.48),('14598','2014-04-25','15:45:00',4.43),('14598','2014-04-25','15:50:00',4.22),('14598','2014-04-25','15:55:00',3.86),('14598','2014-04-25','16:00:00',3.73),('14598','2014-04-25','16:05:00',3.59),('14598','2014-04-25','16:10:00',3.46),('14598','2014-04-25','16:15:00',3.56),('14598','2014-04-25','16:20:00',3.66),('14598','2014-04-25','16:25:00',3.73),('14598','2014-04-25','16:30:00',3.31),('14598','2014-04-25','16:35:00',3),('14598','2014-04-25','16:40:00',3.1),('14598','2014-04-25','16:45:00',2.79),('14598','2014-04-25','16:50:00',3.01),('14598','2014-04-25','16:55:00',2.96),('14598','2014-04-25','17:00:00',2.65),('14598','2014-04-25','17:05:00',2.73),('14598','2014-04-25','17:10:00',2.88),('14598','2014-04-25','17:15:00',2.58),('14598','2014-04-25','17:20:00',2.11),('14598','2014-04-25','17:25:00',1.98),('14598','2014-04-25','17:30:00',1.59),('14598','2014-04-25','17:35:00',1.35),('14598','2014-04-25','17:40:00',1.42),('14598','2014-04-25','17:45:00',1.31),('14598','2014-04-25','17:50:00',1.22),('14598','2014-04-25','17:55:00',1.18),('14598','2014-04-25','18:00:00',1.2),('14598','2014-04-25','18:05:00',1.19),('14598','2014-04-25','18:10:00',1.2),('14598','2014-04-25','18:15:00',1.13),('14598','2014-04-25','18:20:00',1.02),('14598','2014-04-25','18:50:00',1.18),('14598','2014-04-25','18:55:00',1.34),('14598','2014-04-25','19:00:00',1.19),('14598','2014-04-25','19:05:00',1.06),('14598','2014-01-16','09:05:00',1.03),('14598','2014-01-16','09:10:00',1.12),('14598','2014-01-16','09:15:00',1.19),('14598','2014-01-16','09:20:00',1.25),('14598','2014-01-16','09:25:00',1.29),('14598','2014-01-16','09:30:00',1.22),('14598','2014-01-16','09:35:00',1.16),('14598','2014-01-16','09:40:00',1.15),('14598','2014-01-16','09:45:00',1.03),('14598','2014-01-16','09:50:00',1.06),('14598','2014-01-16','09:55:00',1.16),('14598','2014-01-16','10:00:00',1.21),('14598','2014-01-16','10:05:00',1.59),('14598','2014-01-16','10:10:00',1.83),('14598','2014-01-16','10:15:00',2.09),('14598','2014-01-16','10:20:00',2.06),('14598','2014-01-16','10:25:00',1.86),('14598','2014-01-16','10:30:00',1.93),('14598','2014-01-16','10:35:00',2.01),('14598','2014-01-16','10:40:00',2.08),('14598','2014-01-16','10:45:00',2.32),('14598','2014-01-16','10:50:00',2.35),('14598','2014-01-16','10:55:00',2.25),('14598','2014-01-16','11:00:00',1.89),('14598','2014-01-16','11:05:00',1.88),('14598','2014-01-16','11:10:00',1.92),('14598','2014-01-16','11:15:00',1.98),('14598','2014-01-16','11:20:00',2.03),('14598','2014-01-16','11:25:00',2.17),('14598','2014-01-16','11:30:00',2.19),('14598','2014-01-16','11:35:00',2.25),('14598','2014-01-16','11:40:00',2.09),('14598','2014-01-16','11:45:00',2.18),('14598','2014-01-16','11:50:00',2.08),('14598','2014-01-16','11:55:00',2.09),('14598','2014-01-16','12:00:00',1.93),('14598','2014-01-16','12:05:00',1.92),('14598','2014-01-16','12:10:00',1.99),('14598','2014-01-16','12:15:00',2.13),('14598','2014-01-16','12:20:00',2.17),('14598','2014-01-16','12:25:00',2.09),('14598','2014-01-16','12:30:00',2.32),('14598','2014-01-16','12:35:00',2.55),('14598','2014-01-16','12:40:00',2.81),('14598','2014-01-16','12:45:00',2.8),('14598','2014-01-16','12:50:00',2.71),('14598','2014-01-16','12:55:00',2.77),('14598','2014-01-16','13:00:00',2.82),('14598','2014-01-16','13:05:00',2.83),('14598','2014-01-16','13:10:00',2.86),('14598','2014-01-16','13:15:00',2.82),('14598','2014-01-16','13:20:00',3.04),('14598','2014-01-16','13:25:00',3.33),('14598','2014-01-16','13:30:00',3.07),('14598','2014-01-16','13:35:00',1.75),('14598','2014-01-16','13:40:00',1.78),('14598','2014-01-16','13:45:00',1.63),('14598','2014-01-16','13:50:00',1.48),('14598','2014-01-16','13:55:00',1.41),('14598','2014-01-16','14:00:00',1.35),('14598','2014-01-16','14:05:00',1.32),('14598','2014-01-16','14:10:00',1.29),('14598','2014-01-16','14:15:00',1.22),('14598','2014-01-16','14:20:00',1.17),('14598','2014-01-16','14:25:00',1.1),('14598','2014-01-16','14:30:00',1.14),('14598','2014-01-16','14:35:00',1.36),('14598','2014-01-16','14:40:00',1.25),('14598','2014-01-16','14:45:00',1.12),('14598','2014-01-15','09:40:00',1.04),('14598','2014-01-15','09:45:00',1.14),('14598','2014-01-15','09:50:00',1.34),('14598','2014-01-15','09:55:00',1.55),('14598','2014-01-15','10:00:00',1.47),('14598','2014-01-15','10:05:00',1.57),('14598','2014-01-15','10:10:00',1.62),('14598','2014-01-15','10:15:00',1.74),('14598','2014-01-15','10:20:00',2.04),('14598','2014-01-15','10:25:00',2.13),('14598','2014-01-15','10:30:00',2),('14598','2014-01-15','10:35:00',2.03),('14598','2014-01-15','10:40:00',2),('14598','2014-01-15','10:45:00',2.35),('14598','2014-01-15','10:50:00',2.32),('14598','2014-01-15','10:55:00',2.01),('14598','2014-01-15','11:00:00',2.4),('14598','2014-01-15','11:05:00',2.46),('14598','2014-01-15','11:10:00',2.64),('14598','2014-01-15','11:15:00',2.68),('14598','2014-01-15','11:20:00',2.54),('14598','2014-01-15','11:25:00',2.67),('14598','2014-01-15','11:30:00',2.74),('14598','2014-01-15','11:35:00',2.76),('14598','2014-01-15','11:40:00',2.8),('14598','2014-01-15','11:45:00',2.8),('14598','2014-01-15','11:50:00',2.89),('14598','2014-01-15','11:55:00',2.97),('14598','2014-01-15','12:00:00',2.9),('14598','2014-01-15','12:05:00',2.9),('14598','2014-01-15','12:10:00',2.94),('14598','2014-01-15','12:15:00',2.45),('14598','2014-01-15','12:20:00',3.11),('14598','2014-01-15','12:25:00',3.19),('14598','2014-01-15','12:30:00',3.35),('14598','2014-01-15','12:35:00',3.47),('14598','2014-01-15','12:40:00',3.52),('14598','2014-01-15','12:45:00',3.61),('14598','2014-01-15','12:50:00',3.51),('14598','2014-01-15','12:55:00',3.51),('14598','2014-01-15','13:00:00',3.45),('14598','2014-01-15','13:05:00',3.34),('14598','2014-01-15','13:10:00',3.29),('14598','2014-01-15','13:15:00',3.24),('14598','2014-01-15','13:20:00',3.13),('14598','2014-01-15','13:25:00',3.05),('14598','2014-01-15','13:30:00',3),('14598','2014-01-15','13:35:00',2.96),('14598','2014-01-15','13:40:00',2.93),('14598','2014-01-15','13:45:00',2.88),('14598','2014-01-15','13:50:00',2.84),('14598','2014-01-15','13:55:00',2.8),('14598','2014-01-15','14:00:00',2.78),('14598','2014-01-15','14:05:00',2.73),('14598','2014-01-15','14:10:00',2.68),('14598','2014-01-15','14:15:00',2.62),('14598','2014-01-15','14:20:00',2.58),('14598','2014-01-15','14:25:00',2.49),('14598','2014-01-15','14:30:00',2.47),('14598','2014-01-15','14:35:00',2.41),('14598','2014-01-15','14:40:00',2.35),('14598','2014-01-15','14:45:00',2.29),('14598','2014-01-15','14:50:00',2.24),('14598','2014-01-15','14:55:00',2.18),('14598','2014-01-15','15:00:00',2.11),('14598','2014-01-15','15:05:00',2.04),('14598','2014-01-15','15:10:00',1.97),('14598','2014-01-15','15:15:00',1.89),('14598','2014-01-15','15:20:00',1.82),('14598','2014-01-15','15:25:00',1.74),('14598','2014-01-15','15:30:00',1.66),('14598','2014-01-15','15:35:00',1.57),('14598','2014-01-15','15:40:00',1.48),('14598','2014-01-15','15:45:00',1.38),('14598','2014-01-15','15:50:00',1.28),('14598','2014-01-15','15:55:00',1.19),('14598','2014-01-15','16:00:00',1.09),('14598','2014-01-14','09:50:00',1.12),('14598','2014-01-14','09:55:00',1.84),('14598','2014-01-14','10:00:00',1.69),('14598','2014-01-14','10:05:00',1.58),('14598','2014-01-14','10:10:00',1.57),('14598','2014-01-14','10:15:00',1.54),('14598','2014-01-14','10:20:00',1.27),('14598','2014-01-14','10:40:00',1.15),('14598','2014-01-14','10:45:00',1.52),('14598','2014-01-14','10:50:00',1.66),('14598','2014-01-14','10:55:00',1.41),('14598','2014-01-13','09:30:00',1.03),('14598','2014-01-13','09:35:00',1.2),('14598','2014-01-13','09:40:00',1.3),('14598','2014-01-13','09:45:00',1.38),('14598','2014-01-13','09:50:00',1.44),('14598','2014-01-13','09:55:00',1.51),('14598','2014-01-13','10:00:00',1.59),('14598','2014-01-13','10:05:00',1.66),('14598','2014-01-13','10:10:00',1.74),('14598','2014-01-13','10:15:00',1.8),('14598','2014-01-13','10:20:00',1.87),('14598','2014-01-13','10:25:00',1.94),('14598','2014-01-13','10:30:00',2),('14598','2014-01-13','10:35:00',2.01),('14598','2014-01-13','10:40:00',2.1),('14598','2014-01-13','10:45:00',2.17),('14598','2014-01-13','10:50:00',2.22),('14598','2014-01-13','10:55:00',2.27),('14598','2014-01-13','11:00:00',2.33),('14598','2014-01-13','11:05:00',2.38),('14598','2014-01-13','11:10:00',2.39),('14598','2014-01-13','11:15:00',2.42),('14598','2014-01-13','11:20:00',2.47),('14598','2014-01-13','11:25:00',2.51),('14598','2014-01-13','11:30:00',2.54),('14598','2014-01-13','11:35:00',2.55),('14598','2014-01-13','11:40:00',2.59),('14598','2014-01-13','11:45:00',2.63),('14598','2014-01-13','11:50:00',2.63),('14598','2014-01-13','11:55:00',2.69),('14598','2014-01-13','12:00:00',2.69),('14598','2014-01-13','12:05:00',2.74),('14598','2014-01-13','12:10:00',2.72),('14598','2014-01-13','12:15:00',2.71),('14598','2014-01-13','12:20:00',2.73),('14598','2014-01-13','12:25:00',2.73),('14598','2014-01-13','12:30:00',2.74),('14598','2014-01-13','12:35:00',2.72),('14598','2014-01-13','12:40:00',2.73),('14598','2014-01-13','12:45:00',2.73),('14598','2014-01-13','12:50:00',2.74),('14598','2014-01-13','12:55:00',2.72),('14598','2014-01-13','13:00:00',2.73),('14598','2014-01-13','13:05:00',2.71),('14598','2014-01-13','13:10:00',2.68),('14598','2014-01-13','13:15:00',2.67),('14598','2014-01-13','13:20:00',2.68),('14598','2014-01-13','13:25:00',2.69),('14598','2014-01-13','13:30:00',2.68),('14598','2014-01-13','13:35:00',2.63),('14598','2014-01-13','13:40:00',2.63),('14598','2014-01-13','13:45:00',2.58),('14598','2014-01-13','13:50:00',2.53),('14598','2014-01-13','13:55:00',2.49),('14598','2014-01-13','14:00:00',2.47),('14598','2014-01-13','14:05:00',2.43),('14598','2014-01-13','14:10:00',2.39),('14598','2014-01-13','14:15:00',2.37),('14598','2014-01-13','14:20:00',2.32),('14598','2014-01-13','14:25:00',2.28),('14598','2014-01-13','14:30:00',2.22),('14598','2014-01-13','14:35:00',2.17),('14598','2014-01-13','14:40:00',2.13),('14598','2014-01-13','14:45:00',2.06),('14598','2014-01-13','14:50:00',2),('14598','2014-01-13','14:55:00',1.95),('14598','2014-01-13','15:00:00',1.87),('14598','2014-01-13','15:05:00',1.78),('14598','2014-01-13','15:10:00',1.68),('14598','2014-01-13','15:15:00',1.63),('14598','2014-01-13','15:20:00',1.55),('14598','2014-01-13','15:25:00',1.47),('14598','2014-01-13','15:30:00',1.39),('14598','2014-01-13','15:35:00',1.31),('14598','2014-01-13','15:40:00',1.21),('14598','2014-01-13','15:45:00',1.12),('14598','2014-01-13','15:50:00',1.04),('14598','2014-01-12','10:05:00',1.11),('14598','2014-01-12','10:10:00',1.29),('14598','2014-01-12','10:15:00',1.17),('14598','2014-01-12','10:20:00',1.23),('14598','2014-01-12','10:25:00',1.29),('14598','2014-01-12','10:30:00',1.51),('14598','2014-01-12','10:35:00',1.46),('14598','2014-01-12','10:40:00',1.36),('14598','2014-01-12','10:45:00',1.69),('14598','2014-01-12','10:50:00',2.19),('14598','2014-01-12','10:55:00',2.08),('14598','2014-01-12','11:00:00',2.33),('14598','2014-01-12','11:05:00',2.46),('14598','2014-01-12','11:10:00',2.19),('14598','2014-01-12','11:15:00',2.22),('14598','2014-01-12','11:20:00',2.41),('14598','2014-01-12','11:25:00',2.55),('14598','2014-01-12','11:30:00',1.74),('14598','2014-01-12','11:35:00',1.81),('14598','2014-01-12','11:40:00',1.5),('14598','2014-01-12','11:45:00',1.4),('14598','2014-01-12','11:50:00',1.64),('14598','2014-01-12','11:55:00',1.57),('14598','2014-01-12','12:00:00',1.49),('14598','2014-01-12','12:05:00',1.31),('14598','2014-01-12','12:10:00',1.16),('14598','2014-01-12','12:15:00',1.17),('14598','2014-01-12','12:20:00',1.22),('14598','2014-01-12','12:25:00',1.19),('14598','2014-01-12','12:30:00',1.15),('14598','2014-01-12','12:35:00',1.18),('14598','2014-01-12','12:40:00',1.14),('14598','2014-01-12','12:45:00',1.06),('14598','2014-01-12','12:50:00',1.02),('14598','2014-01-12','13:00:00',1.01),('14598','2014-01-12','13:05:00',1.1),('14598','2014-01-12','13:10:00',1.17),('14598','2014-01-12','13:15:00',1.19),('14598','2014-01-12','13:20:00',1.22),('14598','2014-01-12','13:25:00',1.28),('14598','2014-01-12','13:30:00',1.29),('14598','2014-01-12','13:35:00',1.24),('14598','2014-01-12','13:40:00',1.23),('14598','2014-01-12','13:45:00',1.16),('14598','2014-01-12','13:50:00',1.08),('14598','2014-01-12','13:55:00',1.01),('14598','2014-01-11','09:55:00',1.03),('14598','2014-01-11','10:00:00',1.18),('14598','2014-01-11','10:05:00',1.22),('14598','2014-01-11','10:10:00',1.42),('14598','2014-01-11','10:15:00',1.36),('14598','2014-01-11','10:20:00',1.71),('14598','2014-01-11','10:25:00',1.84),('14598','2014-01-11','10:30:00',2.02),('14598','2014-01-11','10:35:00',1.97),('14598','2014-01-11','10:40:00',2.19),('14598','2014-01-11','10:45:00',2.28),('14598','2014-01-11','10:50:00',2.21),('14598','2014-01-11','10:55:00',1.84),('14598','2014-01-11','11:00:00',1.6),('14598','2014-01-11','11:05:00',1.63),('14598','2014-01-11','11:10:00',1.73),('14598','2014-01-11','11:15:00',1.71),('14598','2014-01-11','11:20:00',2.06),('14598','2014-01-11','11:25:00',2.03),('14598','2014-01-11','11:30:00',1.89),('14598','2014-01-11','11:35:00',1.93),('14598','2014-01-11','11:40:00',2.18),('14598','2014-01-11','11:45:00',1.93),('14598','2014-01-11','11:50:00',1.96),('14598','2014-01-11','11:55:00',2.6),('14598','2014-01-11','12:00:00',2.89),('14598','2014-01-11','12:05:00',1.8),('14598','2014-01-11','12:10:00',1.77),('14598','2014-01-11','12:15:00',2.35),('14598','2014-01-11','12:20:00',2.31),('14598','2014-01-11','12:25:00',2.45),('14598','2014-01-11','12:30:00',2.68),('14598','2014-01-11','12:35:00',2.7),('14598','2014-01-11','12:40:00',3.06),('14598','2014-01-11','12:45:00',2.99),('14598','2014-01-11','12:50:00',2.88),('14598','2014-01-11','12:55:00',2.5),('14598','2014-01-11','13:00:00',2.12),('14598','2014-01-11','13:05:00',2.52),('14598','2014-01-11','13:10:00',2.2),('14598','2014-01-11','13:15:00',2),('14598','2014-01-11','13:20:00',1.83),('14598','2014-01-11','13:25:00',1.69),('14598','2014-01-11','13:30:00',1.64),('14598','2014-01-11','13:35:00',1.61),('14598','2014-01-11','13:40:00',1.88),('14598','2014-01-11','13:45:00',2.01),('14598','2014-01-11','13:50:00',1.41),('14598','2014-01-11','13:55:00',1.1),('14598','2014-01-11','14:00:00',1.02),('14598','2014-01-11','14:05:00',1.06),('14598','2014-01-11','14:10:00',1.11),('14598','2014-01-11','14:15:00',1.15),('14598','2014-01-11','14:20:00',1.13),('14598','2014-01-11','14:25:00',1.12),('14598','2014-01-11','14:30:00',1.08),('14598','2014-01-11','14:35:00',1.03),('14598','2014-01-11','14:50:00',1.01),('14598','2014-01-11','15:15:00',1.22),('14598','2014-01-09','09:15:00',1.04),('14598','2014-01-09','09:20:00',1.16),('14598','2014-01-09','09:25:00',1.27),('14598','2014-01-09','09:30:00',1.35),('14598','2014-01-09','09:35:00',1.43),('14598','2014-01-09','09:40:00',1.42),('14598','2014-01-09','09:45:00',1.45),('14598','2014-01-09','09:50:00',1.46),('14598','2014-01-09','09:55:00',1.48),('14598','2014-01-09','10:00:00',1.56),('14598','2014-01-09','10:05:00',1.64),('14598','2014-01-09','10:10:00',1.72),('14598','2014-01-09','10:15:00',1.73),('14598','2014-01-09','10:20:00',1.71),('14598','2014-01-09','10:25:00',1.59),('14598','2014-01-09','10:30:00',1.54),('14598','2014-01-09','10:35:00',1.51),('14598','2014-01-09','10:40:00',1.53),('14598','2014-01-09','10:45:00',1.34),('14598','2014-01-09','10:50:00',1.21),('14598','2014-01-09','10:55:00',1.17),('14598','2014-01-09','11:00:00',1.23),('14598','2014-01-09','11:05:00',1.23),('14598','2014-01-09','11:10:00',1.16),('14598','2014-01-09','11:15:00',1.17),('14598','2014-01-09','11:20:00',1.16),('14598','2014-01-09','11:25:00',1.17),('14598','2014-01-09','11:30:00',1.22),('14598','2014-01-09','11:35:00',1.35),('14598','2014-01-09','11:40:00',1.46),('14598','2014-01-09','11:45:00',1.62),('14598','2014-01-09','11:50:00',1.5),('14598','2014-01-09','11:55:00',1.5),('14598','2014-01-09','12:00:00',1.81),('14598','2014-01-09','12:05:00',1.92),('14598','2014-01-09','12:10:00',1.64),('14598','2014-01-09','12:15:00',1.5),('14598','2014-01-09','12:20:00',1.62),('14598','2014-01-09','12:25:00',1.82),('14598','2014-01-09','12:30:00',1.6),('14598','2014-01-09','12:35:00',1.13),('14598','2014-01-09','12:40:00',1.34),('14598','2014-01-09','12:45:00',1.28),('14598','2014-01-09','12:50:00',1.18),('14598','2014-01-09','12:55:00',1.15),('14598','2014-01-09','13:00:00',1.23),('14598','2014-01-09','13:05:00',1.23),('14598','2014-01-09','13:10:00',1.13),('14598','2014-01-09','13:15:00',1.06),('14598','2014-01-09','13:20:00',1.05),('14598','2014-01-09','13:25:00',1.22),('14598','2014-01-09','13:30:00',1.12),('14598','2014-01-09','13:35:00',1.07),('14598','2014-01-09','13:40:00',1.01),('14598','2014-01-08','09:25:00',1.01),('14598','2014-01-08','09:30:00',1.09),('14598','2014-01-08','09:35:00',1.09),('14598','2014-01-08','09:40:00',1.17),('14598','2014-01-08','09:45:00',1.25),('14598','2014-01-08','09:50:00',1.3),('14598','2014-01-08','09:55:00',1.44),('14598','2014-01-08','10:00:00',1.53),('14598','2014-01-08','10:05:00',1.63),('14598','2014-01-08','10:10:00',1.72),('14598','2014-01-08','10:15:00',1.73),('14598','2014-01-08','10:20:00',1.65),('14598','2014-01-08','10:25:00',1.85),('14598','2014-01-08','10:30:00',1.92),('14598','2014-01-08','10:35:00',2.02),('14598','2014-01-08','10:40:00',2.13),('14598','2014-01-08','10:45:00',2.2),('14598','2014-01-08','10:50:00',2.26),('14598','2014-01-08','10:55:00',2.31),('14598','2014-01-08','11:00:00',2.35),('14598','2014-01-08','11:05:00',2.38),('14598','2014-01-08','11:10:00',2.29),('14598','2014-01-08','11:15:00',2.47),('14598','2014-01-08','11:20:00',2.52),('14598','2014-01-08','11:25:00',2.55),('14598','2014-01-08','11:30:00',2.58),('14598','2014-01-08','11:35:00',2.61),('14598','2014-01-08','11:40:00',2.65),('14598','2014-01-08','11:45:00',2.59),('14598','2014-01-08','11:50:00',2.48),('14598','2014-01-08','11:55:00',2.39),('14598','2014-01-08','12:00:00',2.65),('14598','2014-01-08','12:05:00',2.58),('14598','2014-01-08','12:10:00',2.67),('14598','2014-01-08','12:15:00',2.72),('14598','2014-01-08','12:20:00',2.63),('14598','2014-01-08','12:25:00',2.55),('14598','2014-01-08','12:30:00',2.51),('14598','2014-01-08','12:35:00',2.41),('14598','2014-01-08','12:40:00',2.55),('14598','2014-01-08','12:45:00',2.67),('14598','2014-01-08','12:50:00',2.68),('14598','2014-01-08','12:55:00',2.7),('14598','2014-01-08','13:00:00',2.77),('14598','2014-01-08','13:05:00',2.78),('14598','2014-01-08','13:10:00',2.76),('14598','2014-01-08','13:15:00',2.69),('14598','2014-01-08','13:20:00',2.68),('14598','2014-01-08','13:25:00',2.71),('14598','2014-01-08','13:30:00',2.69),('14598','2014-01-08','13:35:00',2.6),('14598','2014-01-08','13:40:00',2.64),('14598','2014-01-08','13:45:00',2.6),('14598','2014-01-08','13:50:00',2.58),('14598','2014-01-08','13:55:00',2.52),('14598','2014-01-08','14:00:00',2.45),('14598','2014-01-08','14:05:00',2.46),('14598','2014-01-08','14:10:00',2.32),('14598','2014-01-08','14:15:00',2.17),('14598','2014-01-08','14:20:00',2.01),('14598','2014-01-08','14:25:00',1.89),('14598','2014-01-08','14:30:00',1.77),('14598','2014-01-08','14:35:00',1.79),('14598','2014-01-08','14:40:00',2.15),('14598','2014-01-08','14:45:00',2.15),('14598','2014-01-08','14:50:00',2.01),('14598','2014-01-08','14:55:00',1.78),('14598','2014-01-08','15:00:00',1.86),('14598','2014-01-08','15:05:00',1.77),('14598','2014-01-08','15:10:00',1.54),('14598','2014-01-08','15:15:00',1.58),('14598','2014-01-08','15:20:00',1.59),('14598','2014-01-08','15:25:00',1.49),('14598','2014-01-08','15:30:00',1.29),('14598','2014-01-08','15:35:00',1.22),('14598','2014-01-08','15:40:00',1.05),('14598','2014-01-07','09:35:00',1.04),('14598','2014-01-07','09:55:00',1.1),('14598','2014-01-07','10:00:00',1.23),('14598','2014-01-07','10:05:00',1.07),('14598','2014-01-07','10:10:00',1.23),('14598','2014-01-07','10:15:00',1.47),('14598','2014-01-07','10:20:00',1.33),('14598','2014-01-07','10:25:00',1.62),('14598','2014-01-07','10:30:00',1.77),('14598','2014-01-07','10:35:00',2.05),('14598','2014-01-07','10:40:00',2.26),('14598','2014-01-07','10:45:00',2.25),('14598','2014-01-07','10:50:00',2.33),('14598','2014-01-07','10:55:00',2.31),('14598','2014-01-07','11:00:00',2.4),('14598','2014-01-07','11:05:00',2.45),('14598','2014-01-07','11:10:00',2.49),('14598','2014-01-07','11:15:00',2.51),('14598','2014-01-07','11:20:00',2.56),('14598','2014-01-07','11:25:00',2.61),('14598','2014-01-07','11:30:00',2.59),('14598','2014-01-07','11:35:00',2.67),('14598','2014-01-07','11:40:00',2.71),('14598','2014-01-07','11:45:00',2.73),('14598','2014-01-07','11:50:00',2.76),('14598','2014-01-07','11:55:00',2.78),('14598','2014-01-07','12:00:00',2.8),('14598','2014-01-07','12:05:00',2.8),('14598','2014-01-07','12:10:00',2.83),('14598','2014-01-07','12:15:00',2.85),('14598','2014-01-07','12:20:00',2.86),('14598','2014-01-07','12:25:00',2.88),('14598','2014-01-07','12:30:00',2.89),('14598','2014-01-07','12:35:00',2.91),('14598','2014-01-07','12:40:00',2.91),('14598','2014-01-07','12:45:00',2.86),('14598','2014-01-07','12:50:00',2.77),('14598','2014-01-07','12:55:00',2.69),('14598','2014-01-07','13:00:00',2.8),('14598','2014-01-07','13:05:00',2.53),('14598','2014-01-07','13:10:00',2.72),('14598','2014-01-07','13:15:00',2.69),('14598','2014-01-07','13:20:00',2.68),('14598','2014-01-07','13:25:00',2.7),('14598','2014-01-07','13:30:00',2.62),('14598','2014-01-07','13:35:00',2.71),('14598','2014-01-07','13:40:00',2.71),('14598','2014-01-07','13:45:00',2.31),('14598','2014-01-07','13:50:00',2.4),('14598','2014-01-07','13:55:00',2.5),('14598','2014-01-07','14:00:00',2.51),('14598','2014-01-07','14:05:00',2.37),('14598','2014-01-07','14:10:00',2.37),('14598','2014-01-07','14:15:00',2.4),('14598','2014-01-07','14:20:00',2.32),('14598','2014-01-07','14:25:00',2.31),('14598','2014-01-07','14:30:00',2.25),('14598','2014-01-07','14:35:00',2.2),('14598','2014-01-07','14:40:00',2.15),('14598','2014-01-07','14:45:00',2.13),('14598','2014-01-07','14:50:00',2.12),('14598','2014-01-07','14:55:00',2.06),('14598','2014-01-07','15:00:00',1.98),('14598','2014-01-07','15:05:00',1.91),('14598','2014-01-07','15:10:00',1.74),('14598','2014-01-07','15:15:00',1.6),('14598','2014-01-07','15:20:00',1.34),('14598','2014-01-07','15:25:00',1.3),('14598','2014-01-07','15:30:00',1.29),('14598','2014-01-07','15:35:00',1.08),('14598','2014-01-07','15:40:00',1.07),('14598','2014-01-07','15:45:00',1.05),('14598','2014-01-07','15:50:00',1.06),('14598','2014-01-07','15:55:00',1.09),('14598','2014-01-07','16:00:00',1.03),('14598','2014-04-24','08:15:00',1.04),('14598','2014-04-24','08:20:00',1.12),('14598','2014-04-24','08:25:00',1.22),('14598','2014-04-24','08:30:00',1.32),('14598','2014-04-24','08:35:00',1.43),('14598','2014-04-24','08:40:00',1.53),('14598','2014-04-24','08:45:00',1.62),('14598','2014-04-24','08:50:00',1.71),('14598','2014-04-24','08:55:00',1.82),('14598','2014-04-24','09:00:00',1.95),('14598','2014-04-24','09:05:00',2.1),('14598','2014-04-24','09:10:00',2.2),('14598','2014-04-24','09:15:00',2.27),('14598','2014-04-24','09:20:00',2.36),('14598','2014-04-24','09:25:00',2.48),('14598','2014-04-24','09:30:00',2.54),('14598','2014-04-24','09:35:00',2.63),('14598','2014-04-24','09:40:00',2.69),('14598','2014-04-24','09:45:00',2.78),('14598','2014-04-24','09:50:00',2.84),('14598','2014-04-24','09:55:00',2.93),('14598','2014-04-24','10:00:00',3.07),('14598','2014-04-24','10:05:00',3.16),('14598','2014-04-24','10:10:00',3.25),('14598','2014-04-24','10:15:00',3.37),('14598','2014-04-24','10:20:00',3.39),('14598','2014-04-24','10:25:00',3.49),('14598','2014-04-24','10:30:00',3.57),('14598','2014-04-24','10:35:00',3.63),('14598','2014-04-24','10:40:00',3.71),('14598','2014-04-24','10:45:00',3.75),('14598','2014-04-24','10:50:00',3.85),('14598','2014-04-24','10:55:00',3.91),('14598','2014-04-24','11:00:00',3.97),('14598','2014-04-24','11:05:00',4.01),('14598','2014-04-24','11:10:00',4.06),('14598','2014-04-24','11:15:00',4.09),('14598','2014-04-24','11:20:00',4.12),('14598','2014-04-24','11:25:00',4.21),('14598','2014-04-24','11:30:00',4.26),('14598','2014-04-24','11:35:00',4.31),('14598','2014-04-24','11:40:00',4.36),('14598','2014-04-24','11:45:00',4.41),('14598','2014-04-24','11:50:00',4.47),('14598','2014-04-24','11:55:00',4.51),('14598','2014-04-24','12:00:00',4.54),('14598','2014-04-24','12:05:00',4.52),('14598','2014-04-24','12:10:00',4.61),('14598','2014-04-24','12:15:00',4.64),('14598','2014-04-24','12:20:00',4.7),('14598','2014-04-24','12:25:00',4.74),('14598','2014-04-24','12:30:00',4.78),('14598','2014-04-24','12:35:00',4.83),('14598','2014-04-24','12:40:00',4.86),('14598','2014-04-24','12:45:00',4.87),('14598','2014-04-24','12:50:00',4.9),('14598','2014-04-24','12:55:00',4.92),('14598','2014-04-24','13:00:00',4.95),('14598','2014-04-24','13:05:00',4.97),('14598','2014-04-24','13:10:00',4.99),('14598','2014-04-24','13:15:00',5.01),('14598','2014-04-24','13:20:00',5.02),('14598','2014-04-24','13:25:00',5.04),('14598','2014-04-24','13:30:00',5.04),('14598','2014-04-24','13:35:00',5.03),('14598','2014-04-24','13:40:00',5.01),('14598','2014-04-24','13:45:00',5.03),('14598','2014-04-24','13:50:00',5.01),('14598','2014-04-24','13:55:00',5.02),('14598','2014-04-24','14:00:00',5.03),('14598','2014-04-24','14:05:00',5.03),('14598','2014-04-24','14:10:00',5.01),('14598','2014-04-24','14:15:00',4.99),('14598','2014-04-24','14:20:00',5),('14598','2014-04-24','14:25:00',4.98),('14598','2014-04-24','14:30:00',4.95),('14598','2014-04-24','14:35:00',4.94),('14598','2014-04-24','14:40:00',4.91),('14598','2014-04-24','14:45:00',4.9),('14598','2014-04-24','14:50:00',4.88),('14598','2014-04-24','14:55:00',4.85),('14598','2014-04-24','15:00:00',4.79),('14598','2014-04-24','15:05:00',4.72),('14598','2014-04-24','15:10:00',4.73),('14598','2014-04-24','15:15:00',4.68),('14598','2014-04-24','15:20:00',4.6),('14598','2014-04-24','15:25:00',4.57),('14598','2014-04-24','15:30:00',4.57),('14598','2014-04-24','15:35:00',4.87),('14598','2014-04-24','15:40:00',2.27),('14598','2014-04-24','15:45:00',2.18),('14598','2014-04-24','15:50:00',3.85),('14598','2014-04-24','15:55:00',3.74),('14598','2014-04-24','16:00:00',2.07),('14598','2014-04-24','16:05:00',3.18),('14598','2014-04-24','16:10:00',4.41),('14598','2014-04-24','16:15:00',4.39),('14598','2014-04-24','16:20:00',4.05),('14598','2014-04-24','16:25:00',4.17),('14598','2014-04-24','16:30:00',4.35),('14598','2014-04-24','16:35:00',3.48),('14598','2014-04-24','16:40:00',2.63),('14598','2014-04-24','16:45:00',1.75),('14598','2014-04-24','16:50:00',1.79),('14598','2014-04-24','16:55:00',2.18),('14598','2014-04-24','17:00:00',1.68),('14598','2014-04-24','17:05:00',1.6),('14598','2014-04-24','17:10:00',1.54),('14598','2014-04-24','17:15:00',1.45),('14598','2014-04-24','17:20:00',1.45),('14598','2014-04-24','17:25:00',2.13),('14598','2014-04-24','17:30:00',2.37),('14598','2014-04-24','17:35:00',1.83),('14598','2014-04-24','17:40:00',2.41),('14598','2014-04-24','17:45:00',1.63),('14598','2014-04-24','17:50:00',1.25),('14598','2014-01-06','10:15:00',1.07),('14598','2014-01-06','10:20:00',1.17),('14598','2014-01-06','10:25:00',1.61),('14598','2014-01-06','10:30:00',1.25),('14598','2014-01-06','10:45:00',1.47),('14598','2014-01-06','10:50:00',2.31),('14598','2014-01-06','10:55:00',2.35),('14598','2014-01-06','11:00:00',2.39),('14598','2014-01-06','11:05:00',2.44),('14598','2014-01-06','11:10:00',2.49),('14598','2014-01-06','11:15:00',2.55),('14598','2014-01-06','11:20:00',2.59),('14598','2014-01-06','11:25:00',1.13),('14598','2014-01-06','11:35:00',1.27),('14598','2014-01-06','11:40:00',1.83),('14598','2014-01-06','11:45:00',2.82),('14598','2014-01-06','11:50:00',2.8),('14598','2014-01-06','11:55:00',2.78),('14598','2014-01-06','12:00:00',2.79),('14598','2014-01-06','12:05:00',2.79),('14598','2014-01-06','12:10:00',2.81),('14598','2014-01-06','12:15:00',2.81),('14598','2014-01-06','12:20:00',2.81),('14598','2014-01-06','12:25:00',2.81),('14598','2014-01-06','12:30:00',2.81),('14598','2014-01-06','12:35:00',2.83),('14598','2014-01-06','12:40:00',2.83),('14598','2014-01-06','12:45:00',2.82),('14598','2014-01-06','12:50:00',2.82),('14598','2014-01-06','12:55:00',2.81),('14598','2014-01-06','13:00:00',2.81),('14598','2014-01-06','13:05:00',2.79),('14598','2014-01-06','13:10:00',2.78),('14598','2014-01-06','13:15:00',2.77),('14598','2014-01-06','13:20:00',2.74),('14598','2014-01-06','13:25:00',2.74),('14598','2014-01-06','13:30:00',2.73),('14598','2014-01-06','13:35:00',2.71),('14598','2014-01-06','13:40:00',2.67),('14598','2014-01-06','13:45:00',2.62),('14598','2014-01-06','13:50:00',2.58),('14598','2014-01-06','13:55:00',2.55),('14598','2014-01-06','14:00:00',2.54),('14598','2014-01-06','14:05:00',2.51),('14598','2014-01-06','14:10:00',2.59),('14598','2014-01-06','14:15:00',2.23),('14598','2014-01-06','14:20:00',1.03),('14598','2014-01-06','14:30:00',1.35),('14598','2014-01-06','14:35:00',2.41),('14598','2014-01-06','14:40:00',2.8),('14598','2014-01-06','14:45:00',2.75),('14598','2014-01-06','14:50:00',2.64),('14598','2014-01-06','14:55:00',2.52),('14598','2014-01-06','15:00:00',2.51),('14598','2014-01-06','15:05:00',2.31),('14598','2014-01-06','15:10:00',2.24),('14598','2014-01-06','15:15:00',2.08),('14598','2014-01-06','15:20:00',1.83),('14598','2014-01-06','15:25:00',1.62),('14598','2014-01-06','15:30:00',1.74),('14598','2014-01-06','15:35:00',1.72),('14598','2014-01-06','15:40:00',1.4),('14598','2014-01-06','15:45:00',1.07),('14598','2014-01-04','12:05:00',1.27),('14598','2014-01-04','12:10:00',1.33),('14598','2014-01-04','12:15:00',1.11),('14598','2014-01-04','14:30:00',1.02),('14598','2014-01-03','09:45:00',1.23),('14598','2014-01-03','09:50:00',1.17),('14598','2014-01-03','10:10:00',1.04),('14598','2014-01-03','10:20:00',1.78),('14598','2014-01-03','10:25:00',1.43),('14598','2014-01-03','10:30:00',1.56),('14598','2014-01-03','10:35:00',1.66),('14598','2014-01-03','10:40:00',1.06),('14598','2014-01-03','10:45:00',1.12),('14598','2014-01-03','11:10:00',1.22),('14598','2014-01-03','11:15:00',1.27),('14598','2014-01-03','11:20:00',1.22),('14598','2014-01-03','11:30:00',1.36),('14598','2014-01-03','11:35:00',1.29),('14598','2014-01-03','11:40:00',1.14),('14598','2014-01-03','11:45:00',1.13),('14598','2014-01-03','12:05:00',2.44),('14598','2014-01-03','12:10:00',2.8),('14598','2014-01-03','12:15:00',3.09),('14598','2014-01-03','12:20:00',2.82),('14598','2014-01-03','12:25:00',3.27),('14598','2014-01-03','12:30:00',3.61),('14598','2014-01-03','12:35:00',2.83),('14598','2014-01-03','12:40:00',2.43),('14598','2014-01-03','12:45:00',3.22),('14598','2014-01-03','12:50:00',2.5),('14598','2014-01-03','12:55:00',1.83),('14598','2014-01-03','13:00:00',2.12),('14598','2014-01-03','13:05:00',1.8),('14598','2014-01-03','13:10:00',1.46),('14598','2014-01-03','13:15:00',1.56),('14598','2014-01-03','13:20:00',1.72),('14598','2014-01-03','13:25:00',1.77),('14598','2014-01-03','13:30:00',1.61),('14598','2014-01-03','13:35:00',1.8),('14598','2014-01-03','13:40:00',2.1),('14598','2014-01-03','13:45:00',1.59),('14598','2014-01-03','13:50:00',1.3),('14598','2014-01-03','13:55:00',1.16),('14598','2014-01-03','14:40:00',1.34),('14598','2014-01-02','09:25:00',1),('14598','2014-01-02','09:30:00',1.08),('14598','2014-01-02','09:35:00',1.17),('14598','2014-01-02','09:40:00',1.25),('14598','2014-01-02','09:45:00',1.33),('14598','2014-01-02','09:50:00',1.41),('14598','2014-01-02','09:55:00',1.49),('14598','2014-01-02','10:00:00',1.6),('14598','2014-01-02','10:05:00',1.71),('14598','2014-01-02','10:10:00',1.37),('14598','2014-01-02','10:15:00',1.66),('14598','2014-01-02','10:20:00',1.33),('14598','2014-01-02','10:25:00',1.38),('14598','2014-01-02','10:30:00',1.35),('14598','2014-01-02','10:35:00',1.21),('14598','2014-01-02','10:40:00',1.17),('14598','2014-01-02','10:45:00',1.14),('14598','2014-01-02','10:50:00',1.16),('14598','2014-01-02','10:55:00',1.28),('14598','2014-01-02','11:00:00',1.5),('14598','2014-01-02','11:05:00',1.9),('14598','2014-01-02','11:10:00',1.84),('14598','2014-01-02','11:15:00',1.77),('14598','2014-01-02','11:20:00',1.74),('14598','2014-01-02','11:25:00',1.75),('14598','2014-01-02','11:30:00',1.42),('14598','2014-01-02','11:35:00',1.25),('14598','2014-01-02','11:40:00',1.24),('14598','2014-01-02','11:45:00',1.23),('14598','2014-01-02','11:50:00',1.12),('14598','2014-01-02','11:55:00',1.05),('14598','2014-01-02','12:00:00',1.08),('14598','2014-01-02','12:05:00',1.14),('14598','2014-01-02','12:10:00',1.16),('14598','2014-01-02','12:15:00',1.35),('14598','2014-01-02','12:20:00',1.48),('14598','2014-01-02','12:25:00',2.28),('14598','2014-01-02','12:30:00',3.42),('14598','2014-01-02','12:35:00',3),('14598','2014-01-02','12:40:00',2.82),('14598','2014-01-02','12:45:00',2.98),('14598','2014-01-02','12:50:00',2.35),('14598','2014-01-02','12:55:00',1.71),('14598','2014-01-02','13:00:00',2.68),('14598','2014-01-02','13:05:00',1.61),('14598','2014-01-02','13:10:00',1.63),('14598','2014-01-02','13:15:00',1.14),('14598','2014-01-02','13:20:00',1),('14598','2014-01-02','13:45:00',1.14),('14598','2014-01-01','09:25:00',1.08),('14598','2014-01-01','09:30:00',1.18),('14598','2014-01-01','09:35:00',1.29),('14598','2014-01-01','09:40:00',1.39),('14598','2014-01-01','09:45:00',1.55),('14598','2014-01-01','09:50:00',1.84),('14598','2014-01-01','09:55:00',1.35),('14598','2014-01-01','10:10:00',1.81),('14598','2014-01-01','10:15:00',1.82),('14598','2014-01-01','10:20:00',1.87),('14598','2014-01-01','10:25:00',1.93),('14598','2014-01-01','10:30:00',2),('14598','2014-01-01','10:35:00',2.06),('14598','2014-01-01','10:40:00',2.11),('14598','2014-01-01','10:45:00',2.14),('14598','2014-01-01','10:50:00',2.22),('14598','2014-01-01','10:55:00',2.26),('14598','2014-01-01','11:00:00',2.3),('14598','2014-01-01','11:05:00',2.33),('14598','2014-01-01','11:10:00',2.39),('14598','2014-01-01','11:15:00',2.43),('14598','2014-01-01','11:20:00',2.45),('14598','2014-01-01','11:25:00',2.48),('14598','2014-01-01','11:30:00',2.51),('14598','2014-01-01','11:35:00',2.56),('14598','2014-01-01','11:40:00',2.58),('14598','2014-01-01','11:45:00',2.61),('14598','2014-01-01','11:50:00',2.64),('14598','2014-01-01','11:55:00',2.66),('14598','2014-01-01','12:00:00',2.67),('14598','2014-01-01','12:05:00',2.72),('14598','2014-01-01','12:10:00',2.77),('14598','2014-01-01','12:15:00',2.79),('14598','2014-01-01','12:20:00',2.82),('14598','2014-01-01','12:25:00',2.79),('14598','2014-01-01','12:30:00',2.86),('14598','2014-01-01','12:35:00',2.4),('14598','2014-01-01','12:40:00',1.69),('14598','2014-01-01','12:45:00',2.11),('14598','2014-01-01','12:50:00',1.96),('14598','2014-01-01','12:55:00',2.05),('14598','2014-01-01','13:00:00',2.86),('14598','2014-01-01','13:05:00',3.04),('14598','2014-01-01','13:10:00',3.22),('14598','2014-01-01','13:15:00',2.82),('14598','2014-01-01','13:20:00',2.69),('14598','2014-01-01','13:25:00',2.26),('14598','2014-01-01','13:30:00',2.57),('14598','2014-01-01','13:35:00',2.54),('14598','2014-01-01','13:40:00',2.58),('14598','2014-01-01','13:45:00',2.67),('14598','2014-01-01','13:50:00',2.77),('14598','2014-01-01','13:55:00',2.73),('14598','2014-01-01','14:00:00',1.73),('14598','2014-01-01','14:05:00',1.76),('14598','2014-01-01','14:10:00',2.04),('14598','2014-01-01','14:15:00',1.39),('14598','2014-01-01','14:20:00',1.71),('14598','2014-01-01','14:25:00',2.3),('14598','2014-01-01','14:30:00',1.66),('14598','2014-01-01','14:35:00',1.43),('14598','2014-01-01','14:40:00',1.84),('14598','2014-01-01','14:45:00',1.99),('14598','2014-01-01','14:50:00',1.88),('14598','2014-01-01','14:55:00',1.8),('14598','2014-01-01','15:00:00',1.71),('14598','2014-01-01','15:05:00',1.64),('14598','2014-01-01','15:10:00',1.57),('14598','2014-01-01','15:15:00',1.49),('14598','2014-01-01','15:20:00',1.4),('14598','2014-01-01','15:25:00',1.3),('14598','2014-01-01','15:30:00',1.22),('14598','2014-01-01','15:35:00',1.17),('14598','2014-01-01','15:40:00',1.08),('14598','2013-12-31','09:05:00',1.16),('14598','2013-12-31','09:10:00',1.16),('14598','2013-12-31','09:15:00',1.14),('14598','2013-12-31','09:35:00',1.04),('14598','2013-12-31','09:45:00',1.15),('14598','2013-12-31','10:10:00',1.07),('14598','2013-12-31','10:15:00',1.31),('14598','2013-12-31','10:35:00',1.1),('14598','2013-12-31','10:40:00',1.2),('14598','2013-12-31','10:45:00',1.28),('14598','2013-12-31','10:50:00',1.3),('14598','2013-12-31','10:55:00',1.32),('14598','2013-12-31','11:00:00',1.42),('14598','2013-12-31','11:05:00',1.18),('14598','2013-12-31','11:10:00',1.2),('14598','2013-12-31','11:15:00',1.23),('14598','2013-12-31','11:20:00',1.26),('14598','2013-12-31','11:25:00',1.28),('14598','2013-12-31','11:30:00',1.26),('14598','2013-12-31','11:35:00',1.38),('14598','2013-12-31','11:40:00',1.35),('14598','2013-12-31','11:45:00',1.33),('14598','2013-12-31','11:50:00',1.27),('14598','2013-12-31','12:25:00',1.17),('14598','2013-12-31','12:35:00',2.87),('14598','2013-12-31','12:40:00',3.06),('14598','2013-12-31','12:45:00',2.9),('14598','2013-12-31','12:50:00',2.83),('14598','2013-12-31','12:55:00',2.81),('14598','2013-12-31','13:00:00',2.78),('14598','2013-12-31','13:05:00',2.76),('14598','2013-12-31','13:10:00',2.74),('14598','2013-12-31','13:15:00',2.72),('14598','2013-12-31','13:20:00',2.72),('14598','2013-12-31','13:25:00',2.7),('14598','2013-12-31','13:30:00',2.66),('14598','2013-12-31','13:35:00',2.62),('14598','2013-12-31','13:40:00',2.61),('14598','2013-12-31','13:45:00',2.56),('14598','2013-12-31','13:50:00',2.54),('14598','2013-12-31','13:55:00',2.51),('14598','2013-12-31','14:00:00',2.47),('14598','2013-12-31','14:05:00',2.41),('14598','2013-12-31','14:10:00',2.36),('14598','2013-12-31','14:15:00',2.32),('14598','2013-12-31','14:20:00',2.22),('14598','2013-12-31','14:25:00',2.21),('14598','2013-12-31','14:30:00',2.15),('14598','2013-12-31','14:35:00',2.09),('14598','2013-12-31','14:40:00',2.02),('14598','2013-12-31','14:45:00',1.96),('14598','2013-12-31','14:50:00',1.9),('14598','2013-12-31','14:55:00',1.82),('14598','2013-12-31','15:00:00',1.73),('14598','2013-12-31','15:05:00',1.65),('14598','2013-12-31','15:10:00',1.58),('14598','2013-12-31','15:15:00',1.51),('14598','2013-12-31','15:20:00',1.42),('14598','2013-12-31','15:25:00',1.34),('14598','2013-12-31','15:30:00',1.26),('14598','2013-12-31','15:35:00',1.17),('14598','2013-12-31','15:40:00',1.09),('14598','2013-12-29','09:40:00',1.25),('14598','2013-12-29','09:45:00',1.33),('14598','2013-12-29','09:50:00',1.35),('14598','2013-12-29','09:55:00',1.54),('14598','2013-12-29','10:00:00',1.8),('14598','2013-12-29','10:05:00',1.65),('14598','2013-12-29','10:10:00',1.84),('14598','2013-12-29','10:15:00',1.95),('14598','2013-12-29','10:20:00',1.56),('14598','2013-12-29','10:25:00',2.07),('14598','2013-12-29','10:30:00',2.52),('14598','2013-12-29','10:35:00',2.67),('14598','2013-12-29','10:40:00',2.2),('14598','2013-12-29','10:45:00',2.2),('14598','2013-12-29','10:50:00',2.72),('14598','2013-12-29','10:55:00',2.89),('14598','2013-12-29','11:00:00',1.66),('14598','2013-12-29','11:05:00',1.36),('14598','2013-12-29','11:10:00',1.36),('14598','2013-12-29','11:15:00',1.06),('14598','2013-12-28','09:25:00',1.05),('14598','2013-12-28','09:30:00',1.13),('14598','2013-12-28','09:35:00',1.23),('14598','2013-12-28','09:40:00',1.31),('14598','2013-12-28','09:45:00',1.4),('14598','2013-12-28','09:50:00',1.48),('14598','2013-12-28','09:55:00',1.56),('14598','2013-12-28','10:00:00',1.63),('14598','2013-12-28','10:05:00',1.71),('14598','2013-12-28','10:10:00',1.78),('14598','2013-12-28','10:15:00',1.85),('14598','2013-12-28','10:20:00',1.92),('14598','2013-12-28','10:25:00',1.98),('14598','2013-12-28','10:30:00',2.04),('14598','2013-12-28','10:35:00',2.1),('14598','2013-12-28','10:40:00',2.16),('14598','2013-12-28','10:45:00',2.22),('14598','2013-12-28','10:50:00',2.27),('14598','2013-12-28','10:55:00',2.32),('14598','2013-12-28','11:00:00',2.37),('14598','2013-12-28','11:05:00',2.41),('14598','2013-12-28','11:10:00',2.45),('14598','2013-12-28','11:15:00',2.49),('14598','2013-12-28','11:20:00',2.54),('14598','2013-12-28','11:25:00',2.57),('14598','2013-12-28','11:30:00',2.61),('14598','2013-12-28','11:35:00',2.64),('14598','2013-12-28','11:40:00',2.67),('14598','2013-12-28','11:45:00',2.7),('14598','2013-12-28','11:50:00',2.73),('14598','2013-12-28','11:55:00',2.75),('14598','2013-12-28','12:00:00',2.75),('14598','2013-12-28','12:05:00',2.78),('14598','2013-12-28','12:10:00',2.79),('14598','2013-12-28','12:15:00',2.77),('14598','2013-12-28','12:20:00',2.81),('14598','2013-12-28','12:25:00',2.82),('14598','2013-12-28','12:30:00',2.82),('14598','2013-12-28','12:35:00',2.82),('14598','2013-12-28','12:40:00',2.81),('14598','2013-12-28','12:45:00',2.78),('14598','2013-12-28','12:50:00',2.77),('14598','2013-12-28','12:55:00',2.75),('14598','2013-12-28','13:00:00',2.75),('14598','2013-12-28','13:05:00',2.74),('14598','2013-12-28','13:10:00',2.71),('14598','2013-12-28','13:15:00',2.69),('14598','2013-12-28','13:20:00',2.68),('14598','2013-12-28','13:25:00',2.67),('14598','2013-12-28','13:30:00',2.63),('14598','2013-12-28','13:35:00',2.61),('14598','2013-12-28','13:40:00',2.58),('14598','2013-12-28','13:45:00',2.56),('14598','2013-12-28','13:50:00',2.54),('14598','2013-12-28','13:55:00',2.5),('14598','2013-12-28','14:00:00',2.43),('14598','2013-12-28','14:05:00',2.42),('14598','2013-12-28','14:10:00',2.38),('14598','2013-12-28','14:15:00',2.31),('14598','2013-12-28','14:20:00',2.2),('14598','2013-12-28','14:25:00',2.23),('14598','2013-12-28','14:30:00',2.25),('14598','2013-12-28','14:35:00',2.29),('14598','2013-12-28','14:40:00',2.22),('14598','2013-12-28','14:45:00',2.18),('14598','2013-12-28','14:50:00',2.04),('14598','2013-12-28','14:55:00',1.9),('14598','2013-12-28','15:00:00',1.77),('14598','2013-12-28','15:05:00',1.69),('14598','2013-12-28','15:10:00',1.61),('14598','2013-12-28','15:15:00',1.47),('14598','2013-12-28','15:20:00',1.48),('14598','2013-12-28','15:25:00',1.4),('14598','2013-12-28','15:30:00',1.32),('14598','2013-12-28','15:35:00',1.23),('14598','2013-12-28','15:40:00',1.14),('14598','2013-12-28','15:45:00',1),('14598','2014-04-23','10:55:00',1.27),('14598','2014-04-23','11:00:00',1.47),('14598','2014-04-23','11:05:00',1.52),('14598','2014-04-23','11:10:00',1.47),('14598','2014-04-23','11:15:00',1.35),('14598','2014-04-23','11:20:00',1.33),('14598','2014-04-23','11:25:00',1.21),('14598','2014-04-23','11:30:00',1.21),('14598','2014-04-23','11:35:00',1.16),('14598','2014-04-23','11:40:00',1.09),('14598','2014-04-23','11:45:00',1.25),('14598','2014-04-23','11:50:00',1.47),('14598','2014-04-23','11:55:00',1.45),('14598','2014-04-23','12:00:00',1.33),('14598','2014-04-23','12:05:00',1.17),('14598','2014-04-23','12:10:00',1.04),('14598','2014-04-23','12:20:00',1.04),('14598','2014-04-23','12:25:00',1.21),('14598','2014-04-23','12:30:00',1.36),('14598','2014-04-23','12:35:00',1.51),('14598','2014-04-23','12:40:00',1.57),('14598','2014-04-23','12:45:00',1.54),('14598','2014-04-23','12:50:00',1.47),('14598','2014-04-23','12:55:00',1.51),('14598','2014-04-23','13:00:00',1.6),('14598','2014-04-23','13:05:00',1.72),('14598','2014-04-23','13:10:00',1.82),('14598','2014-04-23','13:15:00',2.01),('14598','2014-04-23','13:20:00',2.13),('14598','2014-04-23','13:25:00',2.16),('14598','2014-04-23','13:30:00',2.24),('14598','2014-04-23','13:35:00',2.55),('14598','2014-04-23','13:40:00',2.87),('14598','2014-04-23','13:45:00',3.29),('14598','2014-04-23','13:50:00',3.35),('14598','2014-04-23','13:55:00',3.3),('14598','2014-04-23','14:00:00',3.08),('14598','2014-04-23','14:05:00',3.19),('14598','2014-04-23','14:10:00',3.22),('14598','2014-04-23','14:15:00',3.1),('14598','2014-04-23','14:20:00',2.54),('14598','2014-04-23','14:25:00',2.15),('14598','2014-04-23','14:30:00',1.99),('14598','2014-04-23','14:35:00',1.94),('14598','2014-04-23','14:40:00',1.73),('14598','2014-04-23','14:45:00',1.54),('14598','2014-04-23','14:50:00',1.46),('14598','2014-04-23','14:55:00',1.37),('14598','2014-04-23','15:00:00',1.26),('14598','2014-04-23','15:05:00',1.26),('14598','2014-04-23','15:10:00',1.25),('14598','2014-04-23','15:15:00',1.26),('14598','2014-04-23','15:20:00',1.28),('14598','2014-04-23','15:25:00',1.28),('14598','2014-04-23','15:30:00',1.28),('14598','2014-04-23','15:35:00',1.28),('14598','2014-04-23','15:40:00',1.3),('14598','2014-04-23','15:45:00',1.32),('14598','2014-04-23','15:50:00',1.39),('14598','2014-04-23','15:55:00',1.34),('14598','2014-04-23','16:00:00',1.26),('14598','2014-04-23','16:05:00',1.24),('14598','2014-04-23','16:10:00',1.24),('14598','2014-04-23','16:15:00',1.24),('14598','2014-04-23','16:20:00',1.27),('14598','2014-04-23','16:25:00',1.33),('14598','2014-04-23','16:30:00',1.28),('14598','2014-04-23','16:35:00',1.15),('14598','2014-04-23','16:40:00',1.02),('14598','2013-12-27','11:10:00',1.15),('14598','2013-12-27','11:15:00',1.76),('14598','2013-12-27','11:20:00',1.83),('14598','2013-12-27','11:25:00',1.38),('14598','2013-12-27','11:30:00',1.19),('14598','2013-12-27','11:35:00',1.23),('14598','2013-12-27','11:40:00',1.34),('14598','2013-12-27','11:45:00',1.34),('14598','2013-12-27','11:50:00',1.28),('14598','2013-12-27','11:55:00',1.29),('14598','2013-12-27','12:00:00',1.39),('14598','2013-12-27','12:05:00',1.45),('14598','2013-12-27','12:10:00',1.42),('14598','2013-12-27','12:15:00',1.4),('14598','2013-12-27','12:20:00',1.38),('14598','2013-12-27','12:25:00',1.27),('14598','2013-12-27','12:30:00',1.22),('14598','2013-12-27','12:35:00',1.18),('14598','2013-12-27','12:40:00',1.63),('14598','2013-12-27','12:45:00',1.78),('14598','2013-12-27','12:50:00',1.97),('14598','2013-12-27','12:55:00',2.15),('14598','2013-12-27','13:00:00',2.12),('14598','2013-12-27','13:05:00',2.32),('14598','2013-12-27','13:10:00',2.63),('14598','2013-12-27','13:15:00',2.31),('14598','2013-12-27','13:20:00',2.03),('14598','2013-12-27','13:25:00',1.53),('14598','2013-12-27','13:30:00',1.73),('14598','2013-12-27','13:35:00',1.56),('14598','2013-12-27','13:40:00',1.33),('14598','2013-12-27','13:45:00',1.35),('14598','2013-12-27','13:50:00',1.46),('14598','2013-12-27','13:55:00',1.28),('14598','2013-12-27','14:00:00',1.19),('14598','2013-12-27','14:05:00',1.13),('14598','2013-12-27','14:10:00',1.13),('14598','2013-12-27','14:15:00',1.14),('14598','2013-12-27','14:20:00',1.16),('14598','2013-12-27','14:25:00',1.08),('14598','2013-12-27','14:30:00',1.02),('14598','2013-12-25','10:25:00',1.17),('14598','2013-12-25','10:30:00',1.11),('14598','2013-12-25','10:40:00',1.19),('14598','2013-12-25','10:45:00',1.79),('14598','2013-12-25','10:50:00',1.61),('14598','2013-12-25','10:55:00',1.35),('14598','2013-12-25','11:00:00',1.17),('14598','2013-12-25','11:05:00',1.53),('14598','2013-12-25','11:10:00',1.18),('14598','2013-12-25','11:15:00',2.35),('14598','2013-12-25','11:20:00',2.6),('14598','2013-12-25','11:25:00',2.01),('14598','2013-12-25','11:30:00',1.42),('14598','2013-12-25','11:50:00',1.06),('14598','2013-12-25','11:55:00',1.57),('14598','2013-12-25','12:00:00',2.69),('14598','2013-12-25','12:05:00',1.32),('14598','2013-12-25','12:10:00',1.62),('14598','2013-12-25','12:15:00',2.31),('14598','2013-12-25','12:20:00',1.07),('14598','2013-12-25','12:45:00',1.23),('14598','2013-12-25','12:50:00',1.32),('14598','2013-12-25','12:55:00',1.38),('14598','2013-12-25','13:00:00',1.82),('14598','2013-12-25','13:05:00',1.68),('14598','2013-12-25','13:10:00',1.71),('14598','2013-12-25','13:15:00',1.25),('14598','2013-12-25','13:20:00',1.22),('14598','2013-12-25','13:25:00',1.2),('14598','2013-12-25','13:30:00',1.11),('14598','2013-12-25','13:35:00',1.12),('14598','2013-12-25','13:40:00',1.21),('14598','2013-12-25','13:45:00',1.01),('14598','2013-12-25','13:50:00',1.08),('14598','2013-12-25','13:55:00',1.11),('14598','2013-12-25','15:00:00',1.39),('14598','2013-12-25','15:05:00',1.51),('14598','2013-12-25','15:10:00',1.03),('14598','2013-12-24','09:25:00',1.03),('14598','2013-12-24','09:30:00',1.11),('14598','2013-12-24','09:35:00',1.2),('14598','2013-12-24','09:40:00',1.28),('14598','2013-12-24','09:45:00',1.36),('14598','2013-12-24','09:50:00',1.44),('14598','2013-12-24','09:55:00',1.51),('14598','2013-12-24','10:00:00',1.58),('14598','2013-12-24','10:05:00',1.65),('14598','2013-12-24','10:10:00',1.71),('14598','2013-12-24','10:15:00',1.78),('14598','2013-12-24','10:20:00',1.85),('14598','2013-12-24','10:25:00',1.92),('14598','2013-12-24','10:30:00',1.98),('14598','2013-12-24','10:35:00',2.05),('14598','2013-12-24','10:40:00',2.11),('14598','2013-12-24','10:45:00',2.17),('14598','2013-12-24','10:50:00',2.22),('14598','2013-12-24','10:55:00',2.26),('14598','2013-12-24','11:00:00',2.31),('14598','2013-12-24','11:05:00',2.34),('14598','2013-12-24','11:10:00',2.39),('14598','2013-12-24','11:15:00',2.4),('14598','2013-12-24','11:20:00',2.47),('14598','2013-12-24','11:25:00',2.5),('14598','2013-12-24','11:30:00',2.54),('14598','2013-12-24','11:35:00',2.57),('14598','2013-12-24','11:40:00',2.58),('14598','2013-12-24','11:45:00',2.6),('14598','2013-12-24','11:50:00',2.62),('14598','2013-12-24','11:55:00',2.63),('14598','2013-12-24','12:00:00',2.65),('14598','2013-12-24','12:05:00',2.67),('14598','2013-12-24','12:10:00',2.67),('14598','2013-12-24','12:15:00',2.68),('14598','2013-12-24','12:20:00',2.69),('14598','2013-12-24','12:25:00',2.7),('14598','2013-12-24','12:30:00',2.67),('14598','2013-12-24','12:35:00',2.69),('14598','2013-12-24','12:40:00',2.67),('14598','2013-12-24','12:45:00',2.64),('14598','2013-12-24','12:50:00',2.63),('14598','2013-12-24','12:55:00',2.61),('14598','2013-12-24','13:00:00',2.58),('14598','2013-12-24','13:05:00',2.58),('14598','2013-12-24','13:10:00',2.56),('14598','2013-12-24','13:15:00',2.56),('14598','2013-12-24','13:20:00',2.51),('14598','2013-12-24','13:25:00',2.47),('14598','2013-12-24','13:30:00',2.46),('14598','2013-12-24','13:35:00',2.45),('14598','2013-12-24','13:40:00',2.42),('14598','2013-12-24','13:45:00',2.36),('14598','2013-12-24','13:50:00',2.32),('14598','2013-12-24','13:55:00',2.28),('14598','2013-12-24','14:00:00',2.21),('14598','2013-12-24','14:05:00',2.16),('14598','2013-12-24','14:10:00',2.13),('14598','2013-12-24','14:15:00',2.06),('14598','2013-12-24','14:20:00',2),('14598','2013-12-24','14:25:00',1.98),('14598','2013-12-24','14:30:00',1.92),('14598','2013-12-24','14:35:00',1.86),('14598','2013-12-24','14:40:00',1.8),('14598','2013-12-24','14:45:00',1.74),('14598','2013-12-24','14:50:00',1.67),('14598','2013-12-24','14:55:00',1.61),('14598','2013-12-24','15:00:00',1.55),('14598','2013-12-24','15:05:00',1.48),('14598','2013-12-24','15:10:00',1.41),('14598','2013-12-24','15:15:00',1.33),('14598','2013-12-24','15:20:00',1.26),('14598','2013-12-24','15:25:00',1.18),('14598','2013-12-24','15:30:00',1.09),('14598','2013-12-23','09:30:00',1.11),('14598','2013-12-23','09:35:00',1.19),('14598','2013-12-23','09:40:00',1.14),('14598','2013-12-23','10:00:00',1.09),('14598','2013-12-23','10:10:00',1.02),('14598','2013-12-23','10:15:00',1.03),('14598','2013-12-23','10:25:00',1.05),('14598','2013-12-23','10:30:00',1.39),('14598','2013-12-23','10:35:00',1.54),('14598','2013-12-23','10:40:00',2.21),('14598','2013-12-23','10:45:00',2.31),('14598','2013-12-23','10:50:00',2.22),('14598','2013-12-23','10:55:00',2.49),('14598','2013-12-23','11:00:00',2.44),('14598','2013-12-23','11:05:00',2.59),('14598','2013-12-23','11:10:00',2.57),('14598','2013-12-23','11:15:00',2.57),('14598','2013-12-23','11:20:00',2.55),('14598','2013-12-23','11:25:00',2.52),('14598','2013-12-23','11:30:00',2.5),('14598','2013-12-23','11:35:00',2.54),('14598','2013-12-23','11:40:00',2.45),('14598','2013-12-23','11:45:00',2.54),('14598','2013-12-23','11:50:00',2.66),('14598','2013-12-23','11:55:00',2.68),('14598','2013-12-23','12:00:00',2.73),('14598','2013-12-23','12:05:00',2.75),('14598','2013-12-23','12:10:00',2.74),('14598','2013-12-23','12:15:00',2.74),('14598','2013-12-23','12:20:00',2.75),('14598','2013-12-23','12:25:00',2.77),('14598','2013-12-23','12:30:00',2.77),('14598','2013-12-23','12:35:00',2.76),('14598','2013-12-23','12:40:00',2.77),('14598','2013-12-23','12:45:00',2.77),('14598','2013-12-23','12:50:00',2.77),('14598','2013-12-23','12:55:00',2.74),('14598','2013-12-23','13:00:00',2.6),('14598','2013-12-23','13:05:00',2.26),('14598','2013-12-23','13:10:00',2.58),('14598','2013-12-23','13:15:00',2.68),('14598','2013-12-23','13:20:00',2.66),('14598','2013-12-23','13:25:00',2.63),('14598','2013-12-23','13:30:00',2.6),('14598','2013-12-23','13:35:00',2.57),('14598','2013-12-23','13:40:00',2.54),('14598','2013-12-23','13:45:00',2.53),('14598','2013-12-23','13:50:00',2.26),('14598','2013-12-23','13:55:00',1.63),('14598','2013-12-23','14:00:00',1.85),('14598','2013-12-23','14:05:00',2.02),('14598','2013-12-23','14:10:00',2.28),('14598','2013-12-23','14:15:00',2.23),('14598','2013-12-23','14:20:00',2.14),('14598','2013-12-23','14:25:00',2.09),('14598','2013-12-23','14:30:00',1.8),('14598','2013-12-23','14:35:00',1.91),('14598','2013-12-23','14:40:00',1.9),('14598','2013-12-23','14:45:00',1.8),('14598','2013-12-23','14:50:00',1.72),('14598','2013-12-23','14:55:00',1.65),('14598','2013-12-23','15:00:00',1.55),('14598','2013-12-23','15:05:00',1.51),('14598','2013-12-23','15:10:00',1.43),('14598','2013-12-23','15:15:00',1.36),('14598','2013-12-23','15:20:00',1.28),('14598','2013-12-23','15:25:00',1.21),('14598','2013-12-23','15:30:00',1.11),('14598','2013-12-23','15:35:00',1.03),('14598','2013-12-22','09:20:00',1.01),('14598','2013-12-22','09:25:00',1.26),('14598','2013-12-22','09:30:00',1.57),('14598','2013-12-22','09:35:00',1.67),('14598','2013-12-22','09:40:00',1.82),('14598','2013-12-22','09:45:00',1.9),('14598','2013-12-22','09:50:00',1.88),('14598','2013-12-22','09:55:00',1.86),('14598','2013-12-22','10:00:00',1.91),('14598','2013-12-22','10:05:00',2.03),('14598','2013-12-22','10:10:00',2.09),('14598','2013-12-22','10:15:00',1.86),('14598','2013-12-22','10:20:00',1.98),('14598','2013-12-22','10:25:00',2.08),('14598','2013-12-22','10:30:00',1.94),('14598','2013-12-22','10:35:00',2.01),('14598','2013-12-22','10:40:00',1.88),('14598','2013-12-22','10:45:00',2.09),('14598','2013-12-22','10:50:00',2.25),('14598','2013-12-22','10:55:00',2.4),('14598','2013-12-22','11:00:00',2.54),('14598','2013-12-22','11:05:00',2.45),('14598','2013-12-22','11:10:00',2.55),('14598','2013-12-22','11:15:00',2.52),('14598','2013-12-22','11:20:00',2.32),('14598','2013-12-22','11:25:00',2.38),('14598','2013-12-22','11:30:00',2.45),('14598','2013-12-22','11:35:00',2.47),('14598','2013-12-22','11:40:00',2.64),('14598','2013-12-22','11:45:00',2.45),('14598','2013-12-22','11:50:00',1.94),('14598','2013-12-22','11:55:00',1.24),('14598','2013-12-22','12:05:00',1.03),('14598','2013-12-22','12:10:00',1.05),('14598','2013-12-22','12:15:00',1.11),('14598','2013-12-22','12:20:00',1.32),('14598','2013-12-22','12:25:00',1.42),('14598','2013-12-22','12:30:00',1.6),('14598','2013-12-22','12:35:00',2.03),('14598','2013-12-22','12:40:00',1.89),('14598','2013-12-22','12:45:00',1.74),('14598','2013-12-22','12:50:00',2.24),('14598','2013-12-22','12:55:00',2.86),('14598','2013-12-22','13:00:00',2.81),('14598','2013-12-22','13:05:00',2.91),('14598','2013-12-22','13:10:00',2.97),('14598','2013-12-22','13:15:00',2.89),('14598','2013-12-22','13:20:00',3.08),('14598','2013-12-22','13:25:00',2.94),('14598','2013-12-22','13:30:00',2.53),('14598','2013-12-22','13:35:00',2.53),('14598','2013-12-22','13:40:00',2.21),('14598','2013-12-22','13:45:00',1.66),('14598','2013-12-22','13:50:00',1.51),('14598','2013-12-22','13:55:00',1.61),('14598','2013-12-22','14:00:00',1.64),('14598','2013-12-22','14:05:00',1.39),('14598','2013-12-22','14:10:00',1.37),('14598','2013-12-22','14:15:00',1.19),('14598','2013-12-22','14:20:00',1.55),('14598','2013-12-22','14:25:00',1.35),('14598','2013-12-22','14:30:00',1.57),('14598','2013-12-22','14:35:00',1.84),('14598','2013-12-22','14:40:00',2.07),('14598','2013-12-22','14:45:00',1.7),('14598','2013-12-22','14:50:00',1.75),('14598','2013-12-22','14:55:00',1.41),('14598','2013-12-22','15:00:00',1.1),('14598','2013-12-22','15:05:00',1.23),('14598','2013-12-22','15:10:00',1.09),('14598','2013-12-21','09:25:00',1.05),('14598','2013-12-21','09:30:00',1.13),('14598','2013-12-21','09:35:00',1.21),('14598','2013-12-21','09:40:00',1.28),('14598','2013-12-21','09:45:00',1.37),('14598','2013-12-21','09:50:00',1.45),('14598','2013-12-21','09:55:00',1.53),('14598','2013-12-21','10:00:00',1.6),('14598','2013-12-21','10:05:00',1.68),('14598','2013-12-21','10:10:00',1.75),('14598','2013-12-21','10:15:00',1.82),('14598','2013-12-21','10:20:00',1.88),('14598','2013-12-21','10:25:00',1.94),('14598','2013-12-21','10:30:00',1.99),('14598','2013-12-21','10:35:00',2.04),('14598','2013-12-21','10:40:00',2.08),('14598','2013-12-21','10:45:00',2.12),('14598','2013-12-21','10:50:00',2.17),('14598','2013-12-21','10:55:00',2.21),('14598','2013-12-21','11:00:00',2.27),('14598','2013-12-21','11:05:00',2.31),('14598','2013-12-21','11:10:00',2.35),('14598','2013-12-21','11:15:00',2.39),('14598','2013-12-21','11:20:00',2.43),('14598','2013-12-21','11:25:00',2.45),('14598','2013-12-21','11:30:00',2.51),('14598','2013-12-21','11:35:00',2.54),('14598','2013-12-21','11:40:00',2.57),('14598','2013-12-21','11:45:00',2.59),('14598','2013-12-21','11:50:00',2.61),('14598','2013-12-21','11:55:00',2.63),('14598','2013-12-21','12:00:00',2.64),('14598','2013-12-21','12:05:00',2.66),('14598','2013-12-21','12:10:00',2.66),('14598','2013-12-21','12:15:00',2.65),('14598','2013-12-21','12:20:00',2.66),('14598','2013-12-21','12:25:00',2.66),('14598','2013-12-21','12:30:00',2.66),('14598','2013-12-21','12:35:00',2.68),('14598','2013-12-21','12:40:00',2.65),('14598','2013-12-21','12:45:00',2.64),('14598','2013-12-21','12:50:00',2.64),('14598','2013-12-21','12:55:00',2.62),('14598','2013-12-21','13:00:00',2.6),('14598','2013-12-21','13:05:00',2.6),('14598','2013-12-21','13:10:00',2.55),('14598','2013-12-21','13:15:00',2.55),('14598','2013-12-21','13:20:00',2.52),('14598','2013-12-21','13:25:00',2.5),('14598','2013-12-21','13:30:00',2.48),('14598','2013-12-21','13:35:00',2.45),('14598','2013-12-21','13:40:00',2.42),('14598','2013-12-21','13:45:00',2.37),('14598','2013-12-21','13:50:00',2.35),('14598','2013-12-21','13:55:00',2.34),('14598','2013-12-21','14:00:00',2.31),('14598','2013-12-21','14:05:00',2.29),('14598','2013-12-21','14:10:00',2.25),('14598','2013-12-21','14:15:00',2.19),('14598','2013-12-21','14:20:00',2.14),('14598','2013-12-21','14:25:00',2.08),('14598','2013-12-21','14:30:00',2.02),('14598','2013-12-21','14:35:00',1.96),('14598','2013-12-21','14:40:00',1.89),('14598','2013-12-21','14:45:00',1.82),('14598','2013-12-21','14:50:00',1.75),('14598','2013-12-21','14:55:00',1.68),('14598','2013-12-21','15:00:00',1.6),('14598','2013-12-21','15:05:00',1.53),('14598','2013-12-21','15:10:00',1.46),('14598','2013-12-21','15:15:00',1.38),('14598','2013-12-21','15:20:00',1.3),('14598','2013-12-21','15:25:00',1.23),('14598','2013-12-21','15:30:00',1.14),('14598','2013-12-21','15:35:00',1.03),('14598','2013-12-20','09:25:00',1.17),('14598','2013-12-20','09:30:00',1.21),('14598','2013-12-20','09:35:00',1.27),('14598','2013-12-20','09:40:00',1.34),('14598','2013-12-20','09:45:00',1.41),('14598','2013-12-20','09:50:00',1.47),('14598','2013-12-20','09:55:00',1.49),('14598','2013-12-20','10:00:00',1.54),('14598','2013-12-20','10:05:00',1.62),('14598','2013-12-20','10:10:00',1.69),('14598','2013-12-20','10:15:00',1.73),('14598','2013-12-20','10:20:00',1.78),('14598','2013-12-20','10:25:00',1.86),('14598','2013-12-20','10:30:00',1.87),('14598','2013-12-20','10:35:00',1.95),('14598','2013-12-20','10:40:00',2.01),('14598','2013-12-20','10:45:00',2.06),('14598','2013-12-20','10:50:00',2.09),('14598','2013-12-20','10:55:00',2.13),('14598','2013-12-20','11:00:00',2.19),('14598','2013-12-20','11:05:00',2.24),('14598','2013-12-20','11:10:00',2.24),('14598','2013-12-20','11:15:00',2.27),('14598','2013-12-20','11:20:00',2.34),('14598','2013-12-20','11:25:00',2.39),('14598','2013-12-20','11:30:00',2.41),('14598','2013-12-20','11:35:00',1.89),('14598','2013-12-20','11:40:00',2.59),('14598','2013-12-20','11:45:00',1.8),('14598','2013-12-20','11:50:00',1.24),('14598','2013-12-20','11:55:00',2.3),('14598','2013-12-20','12:00:00',2.59),('14598','2013-12-20','12:05:00',2.54),('14598','2013-12-20','12:10:00',2.51),('14598','2013-12-20','12:15:00',2.57),('14598','2013-12-20','12:20:00',2.58),('14598','2013-12-20','12:25:00',2.58),('14598','2013-12-20','12:30:00',2.51),('14598','2013-12-20','12:35:00',2.14),('14598','2013-12-20','12:40:00',2.34),('14598','2013-12-20','12:45:00',2.45),('14598','2013-12-20','12:50:00',2.31),('14598','2013-12-20','12:55:00',2.46),('14598','2013-12-20','13:00:00',2.14),('14598','2013-12-20','13:05:00',1.48),('14598','2013-12-20','13:10:00',1.01),('14598','2013-12-20','13:15:00',1.58),('14598','2013-12-20','13:20:00',1.62),('14598','2013-12-20','13:25:00',1.68),('14598','2013-12-20','13:30:00',1.88),('14598','2013-12-20','13:35:00',1.36),('14598','2013-12-20','14:40:00',1.3),('14598','2013-12-20','14:45:00',1.82),('14598','2013-12-20','14:50:00',1.91),('14598','2013-12-20','14:55:00',1.79),('14598','2013-12-20','15:00:00',1.88),('14598','2013-12-20','15:05:00',1.62),('14598','2013-12-20','15:10:00',1.07),('14598','2013-12-20','15:15:00',1.18),('14598','2013-12-20','15:20:00',1.19),('14598','2013-12-19','09:10:00',1.03),('14598','2013-12-19','09:15:00',1.11),('14598','2013-12-19','09:20:00',1.01),('14598','2013-12-19','09:30:00',1.17),('14598','2013-12-19','09:35:00',1.43),('14598','2013-12-19','09:45:00',1.11),('14598','2013-12-19','09:50:00',1.58),('14598','2013-12-19','09:55:00',1.44),('14598','2013-12-19','10:00:00',1.24),('14598','2013-12-19','10:05:00',1.16),('14598','2013-12-19','10:15:00',1.11),('14598','2013-12-19','10:20:00',2.03),('14598','2013-12-19','10:25:00',2.32),('14598','2013-12-19','10:30:00',2.44),('14598','2013-12-19','10:35:00',2.57),('14598','2013-12-19','10:40:00',2.84),('14598','2013-12-19','10:45:00',2.85),('14598','2013-12-19','10:50:00',2.38),('14598','2013-12-19','10:55:00',1.85),('14598','2013-12-19','11:00:00',1.4),('14598','2013-12-19','11:05:00',2.14),('14598','2013-12-19','11:10:00',1.67),('14598','2013-12-19','11:15:00',1.57),('14598','2013-12-19','11:20:00',1.39),('14598','2013-12-19','11:25:00',2.01),('14598','2013-12-19','11:30:00',1.18),('14598','2013-12-19','11:35:00',1.32),('14598','2013-12-19','11:40:00',1.18),('14598','2013-12-19','11:45:00',2.47),('14598','2013-12-19','11:50:00',2.79),('14598','2013-12-19','11:55:00',2.21),('14598','2013-12-19','12:00:00',1.82),('14598','2013-12-19','12:05:00',1.19),('14598','2013-12-19','12:10:00',1.73),('14598','2013-12-19','12:15:00',1.93),('14598','2013-12-19','12:20:00',2),('14598','2013-12-19','12:25:00',1.9),('14598','2013-12-19','12:30:00',2.04),('14598','2013-12-19','12:35:00',2.79),('14598','2013-12-19','12:40:00',2.49),('14598','2013-12-19','12:45:00',1.43),('14598','2013-12-19','12:50:00',1.74),('14598','2013-12-19','12:55:00',2.72),('14598','2013-12-19','13:00:00',2.96),('14598','2013-12-19','13:05:00',2.77),('14598','2013-12-19','13:10:00',2.62),('14598','2013-12-19','13:15:00',1.28),('14598','2013-12-19','13:20:00',1.12),('14598','2013-12-19','13:25:00',2.67),('14598','2013-12-19','13:30:00',1.58),('14598','2013-12-19','13:35:00',1.35),('14598','2013-12-19','13:40:00',1.13),('14598','2013-12-19','13:45:00',2.44),('14598','2013-12-19','13:50:00',1.67),('14598','2013-12-19','13:55:00',1.57),('14598','2013-12-19','14:00:00',2.24),('14598','2013-12-19','14:05:00',2.43),('14598','2013-12-19','14:10:00',2.22),('14598','2013-12-19','14:15:00',2.03),('14598','2013-12-19','14:20:00',2.05),('14598','2013-12-19','14:25:00',1.98),('14598','2013-12-19','14:30:00',1.91),('14598','2013-12-19','14:35:00',1.86),('14598','2013-12-19','14:40:00',1.8),('14598','2013-12-19','14:45:00',1.75),('14598','2013-12-19','14:50:00',1.67),('14598','2013-12-19','14:55:00',1.63),('14598','2013-12-19','15:00:00',1.53),('14598','2013-12-19','15:05:00',1.45),('14598','2013-12-19','15:10:00',1.39),('14598','2013-12-19','15:15:00',1.36),('14598','2013-12-19','15:20:00',1.28),('14598','2013-12-19','15:25:00',1.2),('14598','2013-12-19','15:30:00',1.18),('14598','2013-12-19','15:35:00',1.06),('14598','2013-12-18','09:20:00',1.04),('14598','2013-12-18','09:25:00',1.12),('14598','2013-12-18','09:30:00',1.2),('14598','2013-12-18','09:35:00',1.28),('14598','2013-12-18','09:40:00',1.37),('14598','2013-12-18','09:45:00',1.46),('14598','2013-12-18','09:50:00',1.54),('14598','2013-12-18','09:55:00',1.62),('14598','2013-12-18','10:00:00',1.68),('14598','2013-12-18','10:05:00',1.75),('14598','2013-12-18','10:10:00',1.82),('14598','2013-12-18','10:15:00',1.89),('14598','2013-12-18','10:20:00',1.93),('14598','2013-12-18','10:25:00',2),('14598','2013-12-18','10:30:00',2.08),('14598','2013-12-18','10:35:00',2.13),('14598','2013-12-18','10:40:00',2.19),('14598','2013-12-18','10:45:00',2.25),('14598','2013-12-18','10:50:00',2.29),('14598','2013-12-18','10:55:00',2.36),('14598','2013-12-18','11:00:00',2.42),('14598','2013-12-18','11:05:00',2.47),('14598','2013-12-18','11:10:00',2.5),('14598','2013-12-18','11:15:00',2.54),('14598','2013-12-18','11:20:00',2.58),('14598','2013-12-18','11:25:00',2.6),('14598','2013-12-18','11:30:00',2.63),('14598','2013-12-18','11:35:00',2.65),('14598','2013-12-18','11:40:00',2.62),('14598','2013-12-18','11:45:00',2.67),('14598','2013-12-18','11:50:00',2.68),('14598','2013-12-18','11:55:00',2.7),('14598','2013-12-18','12:00:00',2.74),('14598','2013-12-18','12:05:00',2.75),('14598','2013-12-18','12:10:00',2.73),('14598','2013-12-18','12:15:00',2.73),('14598','2013-12-18','12:20:00',2.74),('14598','2013-12-18','12:25:00',2.75),('14598','2013-12-18','12:30:00',2.72),('14598','2013-12-18','12:35:00',2.74),('14598','2013-12-18','12:40:00',2.74),('14598','2013-12-18','12:45:00',2.72),('14598','2013-12-18','12:50:00',2.72),('14598','2013-12-18','12:55:00',2.7),('14598','2013-12-18','13:00:00',2.68),('14598','2013-12-18','13:05:00',2.66),('14598','2013-12-18','13:10:00',2.62),('14598','2013-12-18','13:15:00',2.61),('14598','2013-12-18','13:20:00',2.57),('14598','2013-12-18','13:25:00',2.54),('14598','2013-12-18','13:30:00',2.52),('14598','2013-12-18','13:35:00',2.49),('14598','2013-12-18','13:40:00',2.47),('14598','2013-12-18','13:45:00',2.43),('14598','2013-12-18','13:50:00',2.41),('14598','2013-12-18','13:55:00',2.35),('14598','2013-12-18','14:00:00',2.31),('14598','2013-12-18','14:05:00',2.26),('14598','2013-12-18','14:10:00',2.22),('14598','2013-12-18','14:15:00',2.15),('14598','2013-12-18','14:20:00',2.1),('14598','2013-12-18','14:25:00',2.03),('14598','2013-12-18','14:30:00',1.96),('14598','2013-12-18','14:35:00',1.9),('14598','2013-12-18','14:40:00',1.79),('14598','2013-12-18','14:45:00',1.75),('14598','2013-12-18','14:50:00',1.67),('14598','2013-12-18','14:55:00',1.59),('14598','2013-12-18','15:00:00',1.55),('14598','2013-12-18','15:05:00',1.46),('14598','2013-12-18','15:10:00',1.41),('14598','2013-12-18','15:15:00',1.32),('14598','2013-12-18','15:20:00',1.26),('14598','2013-12-18','15:25:00',1.16),('14598','2013-12-18','15:30:00',1.07),('14598','2014-04-22','08:20:00',1.07),('14598','2014-04-22','08:25:00',1.12),('14598','2014-04-22','08:30:00',1.21),('14598','2014-04-22','08:35:00',1.36),('14598','2014-04-22','08:40:00',1.55),('14598','2014-04-22','08:45:00',1.39),('14598','2014-04-22','08:50:00',1.37),('14598','2014-04-22','08:55:00',1.76),('14598','2014-04-22','09:00:00',1.66),('14598','2014-04-22','09:05:00',1.85),('14598','2014-04-22','09:10:00',2.01),('14598','2014-04-22','09:15:00',2.27),('14598','2014-04-22','09:20:00',2.29),('14598','2014-04-22','09:25:00',2.22),('14598','2014-04-22','09:30:00',2.6),('14598','2014-04-22','09:35:00',2.02),('14598','2014-04-22','09:40:00',2.98),('14598','2014-04-22','09:45:00',2),('14598','2014-04-22','09:50:00',2.42),('14598','2014-04-22','09:55:00',2.05),('14598','2014-04-22','10:00:00',1.67),('14598','2014-04-22','10:05:00',1.8),('14598','2014-04-22','10:10:00',1.75),('14598','2014-04-22','10:15:00',1.47),('14598','2014-04-22','10:20:00',1.75),('14598','2014-04-22','10:25:00',2),('14598','2014-04-22','10:30:00',2.37),('14598','2014-04-22','10:35:00',2.69),('14598','2014-04-22','10:40:00',2.35),('14598','2014-04-22','10:45:00',3.06),('14598','2014-04-22','10:50:00',3.47),('14598','2014-04-22','10:55:00',3.58),('14598','2014-04-22','11:00:00',3.06),('14598','2014-04-22','11:05:00',2.31),('14598','2014-04-22','11:10:00',2.27),('14598','2014-04-22','11:15:00',2.01),('14598','2014-04-22','11:20:00',1.97),('14598','2014-04-22','11:25:00',1.83),('14598','2014-04-22','11:30:00',1.48),('14598','2014-04-22','11:35:00',1.42),('14598','2014-04-22','11:40:00',1.68),('14598','2014-04-22','11:45:00',2.16),('14598','2014-04-22','11:50:00',1.71),('14598','2014-04-22','11:55:00',1.7),('14598','2014-04-22','12:00:00',1.96),('14598','2014-04-22','12:05:00',2.28),('14598','2014-04-22','12:10:00',1.99),('14598','2014-04-22','12:15:00',1.82),('14598','2014-04-22','12:20:00',1.44),('14598','2014-04-22','12:25:00',1.46),('14598','2014-04-22','12:30:00',1.69),('14598','2014-04-22','12:35:00',1.56),('14598','2014-04-22','12:40:00',1.36),('14598','2014-04-22','12:45:00',1.43),('14598','2014-04-22','12:50:00',1.29),('14598','2014-04-22','12:55:00',1.27),('14598','2014-04-22','13:00:00',1.21),('14598','2014-04-22','13:05:00',1.31),('14598','2014-04-22','13:10:00',1.34),('14598','2014-04-22','13:15:00',1.5),('14598','2014-04-22','13:20:00',1.54),('14598','2014-04-22','13:25:00',1.54),('14598','2014-04-22','13:30:00',2.16),('14598','2014-04-22','13:35:00',3.47),('14598','2014-04-22','13:40:00',3.77),('14598','2014-04-22','13:45:00',2.65),('14598','2014-04-22','13:50:00',3.06),('14598','2014-04-22','13:55:00',3.41),('14598','2014-04-22','14:00:00',2.55),('14598','2014-04-22','14:05:00',1.75),('14598','2014-04-22','14:10:00',2.13),('14598','2014-04-22','14:15:00',2.06),('14598','2014-04-22','14:20:00',1.82),('14598','2014-04-22','14:25:00',1.92),('14598','2014-04-22','14:30:00',2.05),('14598','2014-04-22','14:35:00',3.33),('14598','2014-04-22','14:40:00',3.1),('14598','2014-04-22','14:45:00',2.47),('14598','2014-04-22','14:50:00',2.81),('14598','2014-04-22','14:55:00',2.25),('14598','2014-04-22','15:00:00',3.59),('14598','2014-04-22','15:05:00',3.06),('14598','2014-04-22','15:10:00',2.28),('14598','2014-04-22','15:15:00',2.85),('14598','2014-04-22','15:20:00',4.41),('14598','2014-04-22','15:25:00',2.91),('14598','2014-04-22','15:30:00',3.67),('14598','2014-04-22','15:35:00',3.89),('14598','2014-04-22','15:40:00',3.22),('14598','2014-04-22','15:45:00',3.26),('14598','2014-04-22','15:50:00',2.48),('14598','2014-04-22','15:55:00',1.61),('14598','2014-04-22','16:00:00',1.54),('14598','2014-04-22','16:05:00',1.56),('14598','2014-04-22','16:10:00',1.57),('14598','2014-04-22','16:15:00',1.52),('14598','2014-04-22','16:20:00',1.44),('14598','2014-04-22','16:25:00',2.11),('14598','2014-04-22','16:30:00',2.45),('14598','2014-04-22','16:35:00',2.05),('14598','2014-04-22','16:40:00',1.67),('14598','2014-04-22','16:45:00',1.51),('14598','2014-04-22','16:50:00',1.3),('14598','2014-04-22','16:55:00',1.21),('14598','2014-04-22','17:05:00',1.05),('14598','2014-04-22','17:10:00',1.83),('14598','2014-04-22','17:15:00',1.99),('14598','2014-04-22','17:20:00',1.41),('14598','2014-04-22','17:25:00',1.07),('14598','2013-12-17','09:15:00',1.02),('14598','2013-12-17','09:20:00',1.11),('14598','2013-12-17','09:25:00',1.2),('14598','2013-12-17','09:30:00',1.29),('14598','2013-12-17','09:35:00',1.37),('14598','2013-12-17','09:40:00',1.46),('14598','2013-12-17','09:45:00',1.53),('14598','2013-12-17','09:50:00',1.61),('14598','2013-12-17','09:55:00',1.69),('14598','2013-12-17','10:00:00',1.76),('14598','2013-12-17','10:05:00',1.83),('14598','2013-12-17','10:10:00',1.91),('14598','2013-12-17','10:15:00',1.98),('14598','2013-12-17','10:20:00',2.05),('14598','2013-12-17','10:25:00',2.11),('14598','2013-12-17','10:30:00',2.17),('14598','2013-12-17','10:35:00',2.23),('14598','2013-12-17','10:40:00',2.29),('14598','2013-12-17','10:45:00',2.34),('14598','2013-12-17','10:50:00',2.38),('14598','2013-12-17','10:55:00',2.43),('14598','2013-12-17','11:00:00',2.48),('14598','2013-12-17','11:05:00',2.53),('14598','2013-12-17','11:10:00',2.56),('14598','2013-12-17','11:15:00',2.6),('14598','2013-12-17','11:20:00',2.63),('14598','2013-12-17','11:25:00',2.67),('14598','2013-12-17','11:30:00',2.69),('14598','2013-12-17','11:35:00',2.74),('14598','2013-12-17','11:40:00',2.77),('14598','2013-12-17','11:45:00',2.8),('14598','2013-12-17','11:50:00',2.83),('14598','2013-12-17','11:55:00',2.86),('14598','2013-12-17','12:00:00',2.87),('14598','2013-12-17','12:05:00',2.88),('14598','2013-12-17','12:10:00',2.88),('14598','2013-12-17','12:15:00',2.9),('14598','2013-12-17','12:20:00',2.9),('14598','2013-12-17','12:25:00',2.89),('14598','2013-12-17','12:30:00',2.89),('14598','2013-12-17','12:35:00',2.89),('14598','2013-12-17','12:40:00',2.86),('14598','2013-12-17','12:45:00',2.88),('14598','2013-12-17','12:50:00',2.87),('14598','2013-12-17','12:55:00',2.86),('14598','2013-12-17','13:00:00',2.84),('14598','2013-12-17','13:05:00',2.83),('14598','2013-12-17','13:10:00',2.81),('14598','2013-12-17','13:15:00',2.78),('14598','2013-12-17','13:20:00',2.75),('14598','2013-12-17','13:25:00',2.72),('14598','2013-12-17','13:30:00',2.69),('14598','2013-12-17','13:35:00',2.65),('14598','2013-12-17','13:40:00',2.63),('14598','2013-12-17','13:45:00',2.6),('14598','2013-12-17','13:50:00',2.56),('14598','2013-12-17','13:55:00',2.49),('14598','2013-12-17','14:00:00',2.49),('14598','2013-12-17','14:05:00',2.44),('14598','2013-12-17','14:10:00',2.39),('14598','2013-12-17','14:15:00',2.35),('14598','2013-12-17','14:20:00',2.29),('14598','2013-12-17','14:25:00',2.21),('14598','2013-12-17','14:30:00',2.14),('14598','2013-12-17','14:35:00',2.09),('14598','2013-12-17','14:40:00',2.03),('14598','2013-12-17','14:45:00',1.97),('14598','2013-12-17','14:50:00',1.9),('14598','2013-12-17','14:55:00',1.83),('14598','2013-12-17','15:00:00',1.75),('14598','2013-12-17','15:05:00',1.66),('14598','2013-12-17','15:10:00',1.57),('14598','2013-12-17','15:15:00',1.5),('14598','2013-12-17','15:20:00',1.42),('14598','2013-12-17','15:25:00',1.33),('14598','2013-12-17','15:30:00',1.24),('14598','2013-12-17','15:35:00',1.13),('14598','2013-12-17','15:40:00',1.04),('14598','2013-12-16','09:20:00',1.06),('14598','2013-12-16','09:25:00',1.15),('14598','2013-12-16','09:30:00',1.23),('14598','2013-12-16','09:35:00',1.31),('14598','2013-12-16','09:40:00',1.41),('14598','2013-12-16','09:45:00',1.5),('14598','2013-12-16','09:50:00',1.58),('14598','2013-12-16','09:55:00',1.66),('14598','2013-12-16','10:00:00',1.73),('14598','2013-12-16','10:05:00',1.78),('14598','2013-12-16','10:10:00',1.87),('14598','2013-12-16','10:15:00',1.94),('14598','2013-12-16','10:20:00',2),('14598','2013-12-16','10:25:00',2.07),('14598','2013-12-16','10:30:00',2.13),('14598','2013-12-16','10:35:00',2.19),('14598','2013-12-16','10:40:00',2.24),('14598','2013-12-16','10:45:00',2.3),('14598','2013-12-16','10:50:00',2.34),('14598','2013-12-16','10:55:00',2.37),('14598','2013-12-16','11:00:00',1.92),('14598','2013-12-16','11:05:00',2.45),('14598','2013-12-16','11:10:00',2.48),('14598','2013-12-16','11:15:00',2.54),('14598','2013-12-16','11:20:00',2.56),('14598','2013-12-16','11:25:00',2.6),('14598','2013-12-16','11:30:00',2.65),('14598','2013-12-16','11:35:00',2.67),('14598','2013-12-16','11:40:00',2.72),('14598','2013-12-16','11:45:00',2.74),('14598','2013-12-16','11:50:00',2.75),('14598','2013-12-16','11:55:00',2.79),('14598','2013-12-16','12:00:00',2.8),('14598','2013-12-16','12:05:00',2.81),('14598','2013-12-16','12:10:00',2.82),('14598','2013-12-16','12:15:00',2.83),('14598','2013-12-16','12:20:00',2.83),('14598','2013-12-16','12:25:00',2.83),('14598','2013-12-16','12:30:00',2.84),('14598','2013-12-16','12:35:00',2.83),('14598','2013-12-16','12:40:00',2.76),('14598','2013-12-16','12:45:00',2.77),('14598','2013-12-16','12:50:00',2.8),('14598','2013-12-16','12:55:00',2.78),('14598','2013-12-16','13:00:00',2.76),('14598','2013-12-16','13:05:00',2.76),('14598','2013-12-16','13:10:00',2.73),('14598','2013-12-16','13:15:00',2.73),('14598','2013-12-16','13:20:00',2.72),('14598','2013-12-16','13:25:00',2.7),('14598','2013-12-16','13:30:00',2.68),('14598','2013-12-16','13:35:00',2.64),('14598','2013-12-16','13:40:00',2.62),('14598','2013-12-16','13:45:00',2.58),('14598','2013-12-16','13:50:00',2.55),('14598','2013-12-16','13:55:00',2.52),('14598','2013-12-16','14:00:00',2.47),('14598','2013-12-16','14:05:00',2.43),('14598','2013-12-16','14:10:00',2.37),('14598','2013-12-16','14:15:00',2.3),('14598','2013-12-16','14:20:00',2.26),('14598','2013-12-16','14:25:00',2.2),('14598','2013-12-16','14:30:00',2.15),('14598','2013-12-16','14:35:00',2.08),('14598','2013-12-16','14:40:00',2),('14598','2013-12-16','14:45:00',1.94),('14598','2013-12-16','14:50:00',1.87),('14598','2013-12-16','14:55:00',1.79),('14598','2013-12-16','15:00:00',1.72),('14598','2013-12-16','15:05:00',1.63),('14598','2013-12-16','15:10:00',1.55),('14598','2013-12-16','15:15:00',1.47),('14598','2013-12-16','15:20:00',1.39),('14598','2013-12-16','15:25:00',1.3),('14598','2013-12-16','15:30:00',1.2),('14598','2013-12-16','15:35:00',1.1),('14598','2013-12-16','15:40:00',1),('14598','2013-12-15','09:50:00',1.19),('14598','2013-12-15','09:55:00',1.12),('14598','2013-12-15','10:00:00',1.06),('14598','2013-12-15','10:05:00',1.08),('14598','2013-12-15','10:10:00',1.07),('14598','2013-12-15','10:50:00',1.24),('14598','2013-12-15','10:55:00',1.74),('14598','2013-12-15','11:00:00',1.35),('14598','2013-12-15','11:05:00',1.48),('14598','2013-12-15','11:10:00',1.44),('14598','2013-12-15','11:15:00',1.71),('14598','2013-12-15','11:20:00',1.49),('14598','2013-12-15','11:25:00',1.32),('14598','2013-12-15','11:30:00',1.13),('14598','2013-12-15','11:35:00',1.15),('14598','2013-12-15','11:40:00',1.14),('14598','2013-12-14','09:20:00',1.03),('14598','2013-12-14','09:25:00',1.12),('14598','2013-12-14','09:30:00',1.19),('14598','2013-12-14','09:35:00',1.29),('14598','2013-12-14','09:40:00',1.37),('14598','2013-12-14','09:45:00',1.44),('14598','2013-12-14','09:50:00',1.49),('14598','2013-12-14','09:55:00',1.59),('14598','2013-12-14','10:00:00',1.66),('14598','2013-12-14','10:05:00',1.74),('14598','2013-12-14','10:10:00',1.8),('14598','2013-12-14','10:15:00',1.87),('14598','2013-12-14','10:20:00',1.94),('14598','2013-12-14','10:25:00',1.8),('14598','2013-12-14','10:30:00',1.78),('14598','2013-12-14','10:35:00',2.1),('14598','2013-12-14','10:40:00',2.16),('14598','2013-12-14','10:45:00',2.22),('14598','2013-12-14','10:50:00',2.28),('14598','2013-12-14','10:55:00',1.5),('14598','2013-12-14','11:00:00',1.89),('14598','2013-12-14','11:05:00',2.41),('14598','2013-12-14','11:10:00',2.45),('14598','2013-12-14','11:15:00',2.48),('14598','2013-12-14','11:20:00',2.52),('14598','2013-12-14','11:25:00',2.56),('14598','2013-12-14','11:30:00',2.58),('14598','2013-12-14','11:35:00',2.6),('14598','2013-12-14','11:40:00',2.63),('14598','2013-12-14','11:45:00',2.65),('14598','2013-12-14','11:50:00',2.68),('14598','2013-12-14','11:55:00',2.68),('14598','2013-12-14','12:00:00',2.7),('14598','2013-12-14','12:05:00',2.7),('14598','2013-12-14','12:10:00',2.72),('14598','2013-12-14','12:15:00',2.71),('14598','2013-12-14','12:20:00',2.7),('14598','2013-12-14','12:25:00',2.72),('14598','2013-12-14','12:30:00',2.73),('14598','2013-12-14','12:35:00',2.7),('14598','2013-12-14','12:40:00',2.71),('14598','2013-12-14','12:45:00',2.68),('14598','2013-12-14','12:50:00',2.61),('14598','2013-12-14','12:55:00',2.61),('14598','2013-12-14','13:00:00',2.6),('14598','2013-12-14','13:05:00',2.59),('14598','2013-12-14','13:10:00',2.6),('14598','2013-12-14','13:15:00',2.6),('14598','2013-12-14','13:20:00',2.59),('14598','2013-12-14','13:25:00',2.58),('14598','2013-12-14','13:30:00',2.58),('14598','2013-12-14','13:35:00',2.54),('14598','2013-12-14','13:40:00',2.5),('14598','2013-12-14','13:45:00',2.47),('14598','2013-12-14','13:50:00',2.4),('14598','2013-12-14','13:55:00',2.36),('14598','2013-12-14','14:00:00',2.32),('14598','2013-12-14','14:05:00',2.27),('14598','2013-12-14','14:10:00',2.22),('14598','2013-12-14','14:15:00',2.18),('14598','2013-12-14','14:20:00',2.12),('14598','2013-12-14','14:25:00',2.07),('14598','2013-12-14','14:30:00',1.99),('14598','2013-12-14','14:35:00',1.93),('14598','2013-12-14','14:40:00',1.87),('14598','2013-12-14','14:45:00',1.8),('14598','2013-12-14','14:50:00',1.73),('14598','2013-12-14','14:55:00',1.66),('14598','2013-12-14','15:00:00',1.59),('14598','2013-12-14','15:05:00',1.53),('14598','2013-12-14','15:10:00',1.46),('14598','2013-12-14','15:15:00',1.38),('14598','2013-12-14','15:20:00',1.29),('14598','2013-12-14','15:25:00',1.19),('14598','2013-12-14','15:30:00',1.09),('14598','2013-12-13','09:20:00',1.02),('14598','2013-12-13','09:25:00',1.11),('14598','2013-12-13','09:30:00',1.21),('14598','2013-12-13','09:35:00',1.21),('14598','2013-12-13','09:40:00',1.29),('14598','2013-12-13','09:45:00',1.38),('14598','2013-12-13','09:50:00',1.47),('14598','2013-12-13','09:55:00',1.54),('14598','2013-12-13','10:00:00',1.62),('14598','2013-12-13','10:05:00',1.65),('14598','2013-12-13','10:10:00',1.67),('14598','2013-12-13','10:15:00',1.79),('14598','2013-12-13','10:20:00',1.85),('14598','2013-12-13','10:25:00',1.91),('14598','2013-12-13','10:30:00',1.96),('14598','2013-12-13','10:35:00',2.04),('14598','2013-12-13','10:40:00',2.09),('14598','2013-12-13','10:45:00',2.14),('14598','2013-12-13','10:50:00',2.19),('14598','2013-12-13','10:55:00',2.24),('14598','2013-12-13','11:00:00',2.28),('14598','2013-12-13','11:05:00',2.33),('14598','2013-12-13','11:10:00',2.37),('14598','2013-12-13','11:15:00',2.41),('14598','2013-12-13','11:20:00',2.37),('14598','2013-12-13','11:25:00',2.45),('14598','2013-12-13','11:30:00',2.47),('14598','2013-12-13','11:35:00',2.53),('14598','2013-12-13','11:40:00',2.51),('14598','2013-12-13','11:45:00',2.55),('14598','2013-12-13','11:50:00',2.38),('14598','2013-12-13','11:55:00',2.58),('14598','2013-12-13','12:00:00',2.59),('14598','2013-12-13','12:05:00',2.62),('14598','2013-12-13','12:10:00',2.6),('14598','2013-12-13','12:15:00',2.59),('14598','2013-12-13','12:20:00',2.56),('14598','2013-12-13','12:25:00',2.62),('14598','2013-12-13','12:30:00',2.61),('14598','2013-12-13','12:35:00',2.56),('14598','2013-12-13','12:40:00',2.53),('14598','2013-12-13','12:45:00',2.55),('14598','2013-12-13','12:50:00',2.59),('14598','2013-12-13','12:55:00',2.52),('14598','2013-12-13','13:00:00',2.6),('14598','2013-12-13','13:05:00',2.66),('14598','2013-12-13','13:10:00',2.66),('14598','2013-12-13','13:15:00',2.57),('14598','2013-12-13','13:20:00',2.59),('14598','2013-12-13','13:25:00',2.58),('14598','2013-12-13','13:30:00',2.58),('14598','2013-12-13','13:35:00',2.54),('14598','2013-12-13','13:40:00',2.51),('14598','2013-12-13','13:45:00',2.49),('14598','2013-12-13','13:50:00',2.43),('14598','2013-12-13','13:55:00',2.39),('14598','2013-12-13','14:00:00',2.32),('14598','2013-12-13','14:05:00',2.29),('14598','2013-12-13','14:10:00',2.21),('14598','2013-12-13','14:15:00',2.15),('14598','2013-12-13','14:20:00',2.1),('14598','2013-12-13','14:25:00',2.06),('14598','2013-12-13','14:30:00',1.97),('14598','2013-12-13','14:35:00',1.93),('14598','2013-12-13','14:40:00',1.86),('14598','2013-12-13','14:45:00',1.78),('14598','2013-12-13','14:50:00',1.7),('14598','2013-12-13','14:55:00',1.63),('14598','2013-12-13','15:00:00',1.57),('14598','2013-12-13','15:05:00',1.5),('14598','2013-12-13','15:10:00',1.41),('14598','2013-12-13','15:15:00',1.3),('14598','2013-12-13','15:20:00',1.22),('14598','2013-12-13','15:25:00',1.12),('14598','2013-12-13','15:30:00',1.08),('14598','2013-12-13','15:35:00',1),('14598','2013-12-12','09:20:00',1.08),('14598','2013-12-12','09:25:00',1.16),('14598','2013-12-12','09:30:00',1.25),('14598','2013-12-12','09:35:00',1.05),('14598','2013-12-12','09:40:00',1.39),('14598','2013-12-12','09:45:00',1.47),('14598','2013-12-12','09:50:00',1.54),('14598','2013-12-12','09:55:00',1.61),('14598','2013-12-12','10:00:00',1.69),('14598','2013-12-12','10:05:00',1.76),('14598','2013-12-12','10:10:00',1.83),('14598','2013-12-12','10:15:00',1.9),('14598','2013-12-12','10:20:00',1.96),('14598','2013-12-12','10:25:00',2.01),('14598','2013-12-12','10:30:00',2.07),('14598','2013-12-12','10:35:00',2.12),('14598','2013-12-12','10:40:00',2.16),('14598','2013-12-12','10:45:00',2.21),('14598','2013-12-12','10:50:00',2.27),('14598','2013-12-12','10:55:00',2.32),('14598','2013-12-12','11:00:00',2.36),('14598','2013-12-12','11:05:00',2.39),('14598','2013-12-12','11:10:00',2.44),('14598','2013-12-12','11:15:00',2.47),('14598','2013-12-12','11:20:00',2.51),('14598','2013-12-12','11:25:00',2.55),('14598','2013-12-12','11:30:00',2.58),('14598','2013-12-12','11:35:00',2.61),('14598','2013-12-12','11:40:00',2.62),('14598','2013-12-12','11:45:00',2.64),('14598','2013-12-12','11:50:00',2.66),('14598','2013-12-12','11:55:00',2.68),('14598','2013-12-12','12:00:00',2.69),('14598','2013-12-12','12:05:00',2.71),('14598','2013-12-12','12:10:00',2.72),('14598','2013-12-12','12:15:00',2.72),('14598','2013-12-12','12:20:00',2.72),('14598','2013-12-12','12:25:00',2.72),('14598','2013-12-12','12:30:00',2.72),('14598','2013-12-12','12:35:00',2.7),('14598','2013-12-12','12:40:00',2.71),('14598','2013-12-12','12:45:00',2.7),('14598','2013-12-12','12:50:00',2.69),('14598','2013-12-12','12:55:00',2.65),('14598','2013-12-12','13:00:00',2.66),('14598','2013-12-12','13:05:00',2.63),('14598','2013-12-12','13:10:00',2.61),('14598','2013-12-12','13:15:00',2.58),('14598','2013-12-12','13:20:00',2.54),('14598','2013-12-12','13:25:00',2.49),('14598','2013-12-12','13:30:00',2.47),('14598','2013-12-12','13:35:00',2.42),('14598','2013-12-12','13:40:00',2.41),('14598','2013-12-12','13:45:00',2.37),('14598','2013-12-12','13:50:00',2.31),('14598','2013-12-12','13:55:00',2.29),('14598','2013-12-12','14:00:00',2.24),('14598','2013-12-12','14:05:00',2.2),('14598','2013-12-12','14:10:00',2.15),('14598','2013-12-12','14:15:00',2.11),('14598','2013-12-12','14:20:00',2.05),('14598','2013-12-12','14:25:00',1.98),('14598','2013-12-12','14:30:00',1.94),('14598','2013-12-12','14:35:00',1.87),('14598','2013-12-12','14:40:00',1.81),('14598','2013-12-12','14:45:00',1.73),('14598','2013-12-12','14:50:00',1.67),('14598','2013-12-12','14:55:00',1.59),('14598','2013-12-12','15:00:00',1.52),('14598','2013-12-12','15:05:00',1.47),('14598','2013-12-12','15:10:00',1.4),('14598','2013-12-12','15:15:00',1.31),('14598','2013-12-12','15:20:00',1.23),('14598','2013-12-12','15:25:00',1.16),('14598','2013-12-12','15:30:00',1.08),('14598','2013-12-11','09:15:00',1.02),('14598','2013-12-11','09:20:00',1.09),('14598','2013-12-11','09:25:00',1.19),('14598','2013-12-11','09:30:00',1.26),('14598','2013-12-11','09:35:00',1.34),('14598','2013-12-11','09:40:00',1.43),('14598','2013-12-11','09:45:00',1.51),('14598','2013-12-11','09:50:00',1.58),('14598','2013-12-11','09:55:00',1.66),('14598','2013-12-11','10:00:00',1.73),('14598','2013-12-11','10:05:00',1.8),('14598','2013-12-11','10:10:00',1.86),('14598','2013-12-11','10:15:00',1.92),('14598','2013-12-11','10:20:00',1.98),('14598','2013-12-11','10:25:00',2.04),('14598','2013-12-11','10:30:00',2.11),('14598','2013-12-11','10:35:00',2.17),('14598','2013-12-11','10:40:00',2.22),('14598','2013-12-11','10:45:00',2.27),('14598','2013-12-11','10:50:00',2.31),('14598','2013-12-11','10:55:00',2.36),('14598','2013-12-11','11:00:00',2.42),('14598','2013-12-11','11:05:00',2.43),('14598','2013-12-11','11:10:00',2.5),('14598','2013-12-11','11:15:00',2.53),('14598','2013-12-11','11:20:00',2.54),('14598','2013-12-11','11:25:00',2.55),('14598','2013-12-11','11:30:00',2.57),('14598','2013-12-11','11:35:00',2.58),('14598','2013-12-11','11:40:00',2.62),('14598','2013-12-11','11:45:00',2.64),('14598','2013-12-11','11:50:00',2.68),('14598','2013-12-11','11:55:00',2.69),('14598','2013-12-11','12:00:00',2.72),('14598','2013-12-11','12:05:00',2.74),('14598','2013-12-11','12:10:00',2.77),('14598','2013-12-11','12:15:00',2.75),('14598','2013-12-11','12:20:00',2.71),('14598','2013-12-11','12:25:00',2.69),('14598','2013-12-11','12:30:00',2.74),('14598','2013-12-11','12:35:00',2.72),('14598','2013-12-11','12:40:00',2.71),('14598','2013-12-11','12:45:00',2.7),('14598','2013-12-11','12:50:00',2.66),('14598','2013-12-11','12:55:00',2.69),('14598','2013-12-11','13:00:00',2.65),('14598','2013-12-11','13:05:00',2.61),('14598','2013-12-11','13:10:00',2.59),('14598','2013-12-11','13:15:00',2.57),('14598','2013-12-11','13:20:00',2.54),('14598','2013-12-11','13:25:00',2.49),('14598','2013-12-11','13:30:00',2.42),('14598','2013-12-11','13:35:00',2.39),('14598','2013-12-11','13:40:00',2.38),('14598','2013-12-11','13:45:00',2.35),('14598','2013-12-11','13:50:00',2.34),('14598','2013-12-11','13:55:00',2.3),('14598','2013-12-11','14:00:00',2.32),('14598','2013-12-11','14:05:00',2.29),('14598','2013-12-11','14:10:00',2.23),('14598','2013-12-11','14:15:00',2.19),('14598','2013-12-11','14:20:00',2.14),('14598','2013-12-11','14:25:00',2.08),('14598','2013-12-11','14:30:00',1.99),('14598','2013-12-11','14:35:00',1.93),('14598','2013-12-11','14:40:00',1.86),('14598','2013-12-11','14:45:00',1.78),('14598','2013-12-11','14:50:00',1.71),('14598','2013-12-11','14:55:00',1.63),('14598','2013-12-11','15:00:00',1.54),('14598','2013-12-11','15:05:00',1.46),('14598','2013-12-11','15:10:00',1.4),('14598','2013-12-11','15:15:00',1.32),('14598','2013-12-11','15:20:00',1.23),('14598','2013-12-11','15:25:00',1.16),('14598','2013-12-11','15:30:00',1.06),('14598','2013-12-10','09:15:00',1.04),('14598','2013-12-10','09:20:00',1.13),('14598','2013-12-10','09:25:00',1.21),('14598','2013-12-10','09:30:00',1.3),('14598','2013-12-10','09:35:00',1.38),('14598','2013-12-10','09:40:00',1.46),('14598','2013-12-10','09:45:00',1.54),('14598','2013-12-10','09:50:00',1.61),('14598','2013-12-10','09:55:00',1.68),('14598','2013-12-10','10:00:00',1.76),('14598','2013-12-10','10:05:00',1.84),('14598','2013-12-10','10:10:00',1.91),('14598','2013-12-10','10:15:00',1.97),('14598','2013-12-10','10:20:00',2.04),('14598','2013-12-10','10:25:00',2.1),('14598','2013-12-10','10:30:00',2.16),('14598','2013-12-10','10:35:00',2.21),('14598','2013-12-10','10:40:00',2.26),('14598','2013-12-10','10:45:00',2.3),('14598','2013-12-10','10:50:00',2.34),('14598','2013-12-10','10:55:00',2.39),('14598','2013-12-10','11:00:00',2.44),('14598','2013-12-10','11:05:00',2.48),('14598','2013-12-10','11:10:00',2.52),('14598','2013-12-10','11:15:00',2.57),('14598','2013-12-10','11:20:00',1.95),('14598','2013-12-10','11:25:00',2.64),('14598','2013-12-10','11:30:00',2.67),('14598','2013-12-10','11:35:00',2.71),('14598','2013-12-10','11:40:00',2.73),('14598','2013-12-10','11:45:00',2.75),('14598','2013-12-10','11:50:00',2.77),('14598','2013-12-10','11:55:00',2.78),('14598','2013-12-10','12:00:00',2.8),('14598','2013-12-10','12:05:00',2.79),('14598','2013-12-10','12:10:00',2.8),('14598','2013-12-10','12:15:00',2.8),('14598','2013-12-10','12:20:00',2.81),('14598','2013-12-10','12:25:00',2.81),('14598','2013-12-10','12:30:00',2.82),('14598','2013-12-10','12:35:00',2.83),('14598','2013-12-10','12:40:00',2.82),('14598','2013-12-10','12:45:00',2.82),('14598','2013-12-10','12:50:00',2.81),('14598','2013-12-10','12:55:00',2.8),('14598','2013-12-10','13:00:00',2.77),('14598','2013-12-10','13:05:00',2.74),('14598','2013-12-10','13:10:00',2.72),('14598','2013-12-10','13:15:00',2.69),('14598','2013-12-10','13:20:00',2.66),('14598','2013-12-10','13:25:00',2.63),('14598','2013-12-10','13:30:00',2.6),('14598','2013-12-10','13:35:00',2.56),('14598','2013-12-10','13:40:00',2.51),('14598','2013-12-10','13:45:00',2.48),('14598','2013-12-10','13:50:00',2.44),('14598','2013-12-10','13:55:00',2.41),('14598','2013-12-10','14:00:00',2.33),('14598','2013-12-10','14:05:00',2.26),('14598','2013-12-10','14:10:00',2.22),('14598','2013-12-10','14:15:00',2.18),('14598','2013-12-10','14:20:00',2.13),('14598','2013-12-10','14:25:00',2.07),('14598','2013-12-10','14:30:00',2.01),('14598','2013-12-10','14:35:00',1.97),('14598','2013-12-10','14:40:00',1.92),('14598','2013-12-10','14:45:00',1.83),('14598','2013-12-10','14:50:00',1.7),('14598','2013-12-10','14:55:00',1.58),('14598','2013-12-10','15:00:00',1.6),('14598','2013-12-10','15:05:00',1.48),('14598','2013-12-10','15:10:00',1.42),('14598','2013-12-10','15:15:00',1.33),('14598','2013-12-10','15:20:00',1.25),('14598','2013-12-10','15:25:00',1.15),('14598','2013-12-10','15:30:00',1.04),('14598','2013-12-09','09:00:00',1.23),('14598','2013-12-09','09:05:00',1.26),('14598','2013-12-09','09:25:00',1.2),('14598','2013-12-09','11:40:00',1.05),('14598','2013-12-09','11:50:00',2.28),('14598','2013-12-09','12:10:00',1.23),('14598','2013-12-09','12:15:00',1.69),('14598','2013-12-09','12:20:00',1.97),('14598','2013-12-09','12:25:00',2.33),('14598','2013-12-09','12:30:00',1.86),('14598','2013-12-09','12:35:00',2.91),('14598','2013-12-09','12:40:00',2.95),('14598','2013-12-09','12:45:00',2.92),('14598','2013-12-09','12:50:00',2.75),('14598','2013-12-09','12:55:00',2.97),('14598','2013-12-09','13:00:00',3.03),('14598','2013-12-09','13:05:00',3.2),('14598','2013-12-09','13:10:00',3.08),('14598','2013-12-09','13:15:00',2.99),('14598','2013-12-09','13:20:00',1.85),('14598','2013-12-09','13:25:00',1.38),('14598','2013-12-09','13:30:00',1.14),('14598','2013-12-09','13:55:00',1.01),('14598','2013-12-08','12:40:00',1.05),('14598','2013-12-08','12:45:00',1.5),('14598','2013-12-08','12:50:00',1.1),('14598','2013-12-08','13:00:00',1.11),('14598','2013-12-08','13:05:00',1.45),('14598','2013-12-08','13:10:00',2.63),('14598','2013-12-08','13:15:00',3.33),('14598','2013-12-08','13:20:00',3.3),('14598','2013-12-08','13:25:00',2.53),('14598','2013-12-08','13:30:00',1.33),('14598','2013-12-08','13:40:00',1.05),('14598','2013-12-08','13:45:00',1.11),('14598','2013-12-08','13:50:00',1.75),('14598','2013-12-08','13:55:00',1.66),('14598','2013-12-08','14:00:00',2.35),('14598','2013-12-08','14:05:00',2.34),('14598','2013-12-08','14:10:00',2.42),('14598','2013-12-08','14:15:00',2.28),('14598','2013-12-08','14:20:00',1.47),('14598','2013-12-08','14:25:00',1.95),('14598','2013-12-08','14:30:00',1.95),('14598','2013-12-08','14:35:00',1.88),('14598','2013-12-08','14:40:00',1.82),('14598','2013-12-08','14:45:00',1.73),('14598','2013-12-08','14:50:00',1.67),('14598','2013-12-08','14:55:00',1.61),('14598','2013-12-08','15:00:00',1.56),('14598','2013-12-08','15:05:00',1.49),('14598','2013-12-08','15:10:00',1.38),('14598','2013-12-08','15:15:00',1.28),('14598','2013-12-08','15:20:00',1.18),('14598','2013-12-08','15:25:00',1.07),('14598','2014-04-21','08:55:00',1.12),('14598','2014-04-21','09:00:00',1.53),('14598','2014-04-21','09:05:00',1.27),('14598','2014-04-21','09:10:00',1.79),('14598','2014-04-21','09:15:00',2.59),('14598','2014-04-21','09:20:00',2.66),('14598','2014-04-21','09:25:00',2.67),('14598','2014-04-21','09:30:00',2.45),('14598','2014-04-21','09:35:00',3.22),('14598','2014-04-21','09:40:00',3.25),('14598','2014-04-21','09:45:00',1.35),('14598','2014-04-21','09:50:00',1.26),('14598','2014-04-21','09:55:00',1.3),('14598','2014-04-21','10:00:00',1.81),('14598','2014-04-21','10:05:00',2.66),('14598','2014-04-21','10:10:00',2.78),('14598','2014-04-21','10:15:00',2.99),('14598','2014-04-21','10:20:00',2.26),('14598','2014-04-21','10:25:00',4.01),('14598','2014-04-21','10:30:00',3.38),('14598','2014-04-21','10:35:00',3.58),('14598','2014-04-21','10:40:00',3.61),('14598','2014-04-21','10:45:00',3.67),('14598','2014-04-21','10:50:00',3.72),('14598','2014-04-21','10:55:00',3.77),('14598','2014-04-21','11:00:00',3.83),('14598','2014-04-21','11:05:00',3.87),('14598','2014-04-21','11:10:00',3.92),('14598','2014-04-21','11:15:00',3.98),('14598','2014-04-21','11:20:00',4.02),('14598','2014-04-21','11:25:00',4.08),('14598','2014-04-21','11:30:00',4.2),('14598','2014-04-21','11:35:00',4.28),('14598','2014-04-21','11:40:00',4.31),('14598','2014-04-21','11:45:00',4.3),('14598','2014-04-21','11:50:00',4.37),('14598','2014-04-21','11:55:00',4.41),('14598','2014-04-21','12:00:00',4.46),('14598','2014-04-21','12:05:00',4.54),('14598','2014-04-21','12:10:00',4.58),('14598','2014-04-21','12:15:00',4.62),('14598','2014-04-21','12:20:00',4.69),('14598','2014-04-21','12:25:00',4.73),('14598','2014-04-21','12:30:00',4.76),('14598','2014-04-21','12:35:00',4.76),('14598','2014-04-21','12:40:00',4.76),('14598','2014-04-21','12:45:00',4.82),('14598','2014-04-21','12:50:00',4.86),('14598','2014-04-21','12:55:00',4.9),('14598','2014-04-21','13:00:00',4.92),('14598','2014-04-21','13:05:00',4.95),('14598','2014-04-21','13:10:00',4.96),('14598','2014-04-21','13:15:00',4.97),('14598','2014-04-21','13:20:00',4.98),('14598','2014-04-21','13:25:00',5),('14598','2014-04-21','13:30:00',4.98),('14598','2014-04-21','13:35:00',5.01),('14598','2014-04-21','13:40:00',5.01),('14598','2014-04-21','13:45:00',5.01),('14598','2014-04-21','13:50:00',5.01),('14598','2014-04-21','13:55:00',5),('14598','2014-04-21','14:00:00',5),('14598','2014-04-21','14:05:00',5.01),('14598','2014-04-21','14:10:00',5),('14598','2014-04-21','14:15:00',4.99),('14598','2014-04-21','14:20:00',4.97),('14598','2014-04-21','14:25:00',4.95),('14598','2014-04-21','14:30:00',4.9),('14598','2014-04-21','14:35:00',4.9),('14598','2014-04-21','14:40:00',4.88),('14598','2014-04-21','14:45:00',4.81),('14598','2014-04-21','14:50:00',4.79),('14598','2014-04-21','14:55:00',4.76),('14598','2014-04-21','15:00:00',4.73),('14598','2014-04-21','15:05:00',4.71),('14598','2014-04-21','15:10:00',4.65),('14598','2014-04-21','15:15:00',4.62),('14598','2014-04-21','15:20:00',4.57),('14598','2014-04-21','15:25:00',4.51),('14598','2014-04-21','15:30:00',4.46),('14598','2014-04-21','15:35:00',4.42),('14598','2014-04-21','15:40:00',4.38),('14598','2014-04-21','15:45:00',4.35),('14598','2014-04-21','15:50:00',4.29),('14598','2014-04-21','15:55:00',4.26),('14598','2014-04-21','16:00:00',4.2),('14598','2014-04-21','16:05:00',4.15),('14598','2014-04-21','16:10:00',4.11),('14598','2014-04-21','16:15:00',4.05),('14598','2014-04-21','16:20:00',3.98),('14598','2014-04-21','16:25:00',3.91),('14598','2014-04-21','16:30:00',3.83),('14598','2014-04-21','16:35:00',3.78),('14598','2014-04-21','16:40:00',3.71),('14598','2014-04-21','16:45:00',3.65),('14598','2014-04-21','16:50:00',3.58),('14598','2014-04-21','16:55:00',3.49),('14598','2014-04-21','17:00:00',3.41),('14598','2014-04-21','17:05:00',3.32),('14598','2014-04-21','17:10:00',3.23),('14598','2014-04-21','17:15:00',3.12),('14598','2014-04-21','17:20:00',3.03),('14598','2014-04-21','17:25:00',2.95),('14598','2014-04-21','17:30:00',2.84),('14598','2014-04-21','17:35:00',2.74),('14598','2014-04-21','17:40:00',2.63),('14598','2014-04-21','17:45:00',2.51),('14598','2014-04-21','17:50:00',2.41),('14598','2014-04-21','17:55:00',2.3),('14598','2014-04-21','18:00:00',2.19),('14598','2014-04-21','18:05:00',2.07),('14598','2014-04-21','18:10:00',1.97),('14598','2014-04-21','18:15:00',1.85),('14598','2014-04-21','18:20:00',1.75),('14598','2014-04-21','18:25:00',1.64),('14598','2014-04-21','18:30:00',1.52),('14598','2014-04-21','18:35:00',1.42),('14598','2014-04-21','18:40:00',1.31),('14598','2014-04-21','18:45:00',1.19),('14598','2014-04-21','18:50:00',1.08),('14598','2013-12-07','09:10:00',1.03),('14598','2013-12-07','09:15:00',1.11),('14598','2013-12-07','09:20:00',1.19),('14598','2013-12-07','09:25:00',1.27),('14598','2013-12-07','09:30:00',1.36),('14598','2013-12-07','09:35:00',1.44),('14598','2013-12-07','09:40:00',1.52),('14598','2013-12-07','09:45:00',1.6),('14598','2013-12-07','09:50:00',1.67),('14598','2013-12-07','09:55:00',1.75),('14598','2013-12-07','10:00:00',1.82),('14598','2013-12-07','10:05:00',1.87),('14598','2013-12-07','10:10:00',1.93),('14598','2013-12-07','10:15:00',2.01),('14598','2013-12-07','10:20:00',2.06),('14598','2013-12-07','10:25:00',2.12),('14598','2013-12-07','10:30:00',2.17),('14598','2013-12-07','10:35:00',2.23),('14598','2013-12-07','10:40:00',2.28),('14598','2013-12-07','10:45:00',2.33),('14598','2013-12-07','10:50:00',2.38),('14598','2013-12-07','10:55:00',2.43),('14598','2013-12-07','11:00:00',2.46),('14598','2013-12-07','11:05:00',2.49),('14598','2013-12-07','11:10:00',2.56),('14598','2013-12-07','11:15:00',2.61),('14598','2013-12-07','11:20:00',2.62),('14598','2013-12-07','11:25:00',2.64),('14598','2013-12-07','11:30:00',2.68),('14598','2013-12-07','11:35:00',2.69),('14598','2013-12-07','11:40:00',2.7),('14598','2013-12-07','11:45:00',2.69),('14598','2013-12-07','11:50:00',2.77),('14598','2013-12-07','11:55:00',2.76),('14598','2013-12-07','12:00:00',2.76),('14598','2013-12-07','12:05:00',2.77),('14598','2013-12-07','12:10:00',2.76),('14598','2013-12-07','12:15:00',2.76),('14598','2013-12-07','12:20:00',2.76),('14598','2013-12-07','12:25:00',2.76),('14598','2013-12-07','12:30:00',2.78),('14598','2013-12-07','12:35:00',2.79),('14598','2013-12-07','12:40:00',2.76),('14598','2013-12-07','12:45:00',2.73),('14598','2013-12-07','12:50:00',2.71),('14598','2013-12-07','12:55:00',2.7),('14598','2013-12-07','13:00:00',2.68),('14598','2013-12-07','13:05:00',2.64),('14598','2013-12-07','13:10:00',2.62),('14598','2013-12-07','13:15:00',2.6),('14598','2013-12-07','13:20:00',2.56),('14598','2013-12-07','13:25:00',2.53),('14598','2013-12-07','13:30:00',2.5),('14598','2013-12-07','13:35:00',2.47),('14598','2013-12-07','13:40:00',2.44),('14598','2013-12-07','13:45:00',2.4),('14598','2013-12-07','13:50:00',2.35),('14598','2013-12-07','13:55:00',2.3),('14598','2013-12-07','14:00:00',2.25),('14598','2013-12-07','14:05:00',2.2),('14598','2013-12-07','14:10:00',2.15),('14598','2013-12-07','14:15:00',2.1),('14598','2013-12-07','14:20:00',2.04),('14598','2013-12-07','14:25:00',1.98),('14598','2013-12-07','14:30:00',1.91),('14598','2013-12-07','14:35:00',1.85),('14598','2013-12-07','14:40:00',1.78),('14598','2013-12-07','14:45:00',1.68),('14598','2013-12-07','14:50:00',1.61),('14598','2013-12-07','14:55:00',1.55),('14598','2013-12-07','15:00:00',1.49),('14598','2013-12-07','15:05:00',1.42),('14598','2013-12-07','15:10:00',1.35),('14598','2013-12-07','15:15:00',1.27),('14598','2013-12-07','15:20:00',1.2),('14598','2013-12-07','15:25:00',1.11),('14598','2013-12-07','15:30:00',1.03),('14598','2013-12-06','10:55:00',1.04),('14598','2013-12-06','11:00:00',1.13),('14598','2013-12-06','11:05:00',1.17),('14598','2013-12-06','11:10:00',1.1),('14598','2013-12-06','11:15:00',1.16),('14598','2013-12-06','11:20:00',1.31),('14598','2013-12-06','11:25:00',1.59),('14598','2013-12-06','11:30:00',1.7),('14598','2013-12-06','11:35:00',1.68),('14598','2013-12-06','11:40:00',1.87),('14598','2013-12-06','11:45:00',1.42),('14598','2013-12-06','11:50:00',1.33),('14598','2013-12-06','11:55:00',1.32),('14598','2013-12-06','12:00:00',1.33),('14598','2013-12-06','12:05:00',1.25),('14598','2013-12-06','12:10:00',1.29),('14598','2013-12-06','12:15:00',1.29),('14598','2013-12-06','12:20:00',1.38),('14598','2013-12-06','12:25:00',1.28),('14598','2013-12-06','12:30:00',1.25),('14598','2013-12-06','12:35:00',1.14),('14598','2013-12-06','12:40:00',1.31),('14598','2013-12-06','12:45:00',1.59),('14598','2013-12-06','12:50:00',1.51),('14598','2013-12-06','12:55:00',1.67),('14598','2013-12-06','13:00:00',2.16),('14598','2013-12-06','13:05:00',1.51),('14598','2013-12-06','13:10:00',1.11),('14598','2013-12-06','13:15:00',1.24),('14598','2013-12-06','13:20:00',1.15),('14598','2013-12-06','13:25:00',1.04),('14598','2013-12-06','13:35:00',1.02),('14598','2013-12-06','14:10:00',1.03),('14598','2013-12-06','14:15:00',1.96),('14598','2013-12-06','14:20:00',1.26),('14598','2013-12-06','14:40:00',1.11),('14598','2013-12-06','14:45:00',1.62),('14598','2013-12-06','14:50:00',1.97),('14598','2013-12-06','14:55:00',1.89),('14598','2013-12-06','15:00:00',1.71),('14598','2013-12-06','15:05:00',1.54),('14598','2013-12-06','15:10:00',1.64),('14598','2013-12-06','15:15:00',1.88),('14598','2013-12-06','15:20:00',1.4),('14598','2013-12-06','15:25:00',1.18),('14598','2013-12-05','09:10:00',1.04),('14598','2013-12-05','09:15:00',1.13),('14598','2013-12-05','09:20:00',1.23),('14598','2013-12-05','09:25:00',1.31),('14598','2013-12-05','09:30:00',1.39),('14598','2013-12-05','09:35:00',1.47),('14598','2013-12-05','09:40:00',1.54),('14598','2013-12-05','09:45:00',1.63),('14598','2013-12-05','09:50:00',1.71),('14598','2013-12-05','09:55:00',1.78),('14598','2013-12-05','10:00:00',1.86),('14598','2013-12-05','10:05:00',1.93),('14598','2013-12-05','10:10:00',1.98),('14598','2013-12-05','10:15:00',2.05),('14598','2013-12-05','10:20:00',2.1),('14598','2013-12-05','10:25:00',2.17),('14598','2013-12-05','10:30:00',2.23),('14598','2013-12-05','10:35:00',2.28),('14598','2013-12-05','10:40:00',2.33),('14598','2013-12-05','10:45:00',2.39),('14598','2013-12-05','10:50:00',2.44),('14598','2013-12-05','10:55:00',2.48),('14598','2013-12-05','11:00:00',2.5),('14598','2013-12-05','11:05:00',2.55),('14598','2013-12-05','11:10:00',2.57),('14598','2013-12-05','11:15:00',2.62),('14598','2013-12-05','11:20:00',2.65),('14598','2013-12-05','11:25:00',2.68),('14598','2013-12-05','11:30:00',2.72),('14598','2013-12-05','11:35:00',2.73),('14598','2013-12-05','11:40:00',2.76),('14598','2013-12-05','11:45:00',2.77),('14598','2013-12-05','11:50:00',2.78),('14598','2013-12-05','11:55:00',2.81),('14598','2013-12-05','12:00:00',2.82),('14598','2013-12-05','12:05:00',2.82),('14598','2013-12-05','12:10:00',2.83),('14598','2013-12-05','12:15:00',2.82),('14598','2013-12-05','12:20:00',2.82),('14598','2013-12-05','12:25:00',2.83),('14598','2013-12-05','12:30:00',2.81),('14598','2013-12-05','12:35:00',2.8),('14598','2013-12-05','12:40:00',2.77),('14598','2013-12-05','12:45:00',2.77),('14598','2013-12-05','12:50:00',2.76),('14598','2013-12-05','12:55:00',2.75),('14598','2013-12-05','13:00:00',2.71),('14598','2013-12-05','13:05:00',2.7),('14598','2013-12-05','13:10:00',2.66),('14598','2013-12-05','13:15:00',2.65),('14598','2013-12-05','13:20:00',2.62),('14598','2013-12-05','13:25:00',2.07),('14598','2013-12-05','13:30:00',2.54),('14598','2013-12-05','13:35:00',2.54),('14598','2013-12-05','13:40:00',2.52),('14598','2013-12-05','13:45:00',2.53),('14598','2013-12-05','13:50:00',2.5),('14598','2013-12-05','13:55:00',2.47),('14598','2013-12-05','14:00:00',2.39),('14598','2013-12-05','14:05:00',2.36),('14598','2013-12-05','14:10:00',2.3),('14598','2013-12-05','14:15:00',2.25),('14598','2013-12-05','14:20:00',2.2),('14598','2013-12-05','14:25:00',2.13),('14598','2013-12-05','14:30:00',2.07),('14598','2013-12-05','14:35:00',2),('14598','2013-12-05','14:40:00',1.93),('14598','2013-12-05','14:45:00',1.85),('14598','2013-12-05','14:50:00',1.78),('14598','2013-12-05','14:55:00',1.71),('14598','2013-12-05','15:00:00',1.62),('14598','2013-12-05','15:05:00',1.54),('14598','2013-12-05','15:10:00',1.45),('14598','2013-12-05','15:15:00',1.35),('14598','2013-12-05','15:20:00',1.28),('14598','2013-12-05','15:25:00',1.17),('14598','2013-12-05','15:30:00',1.07),('14598','2013-12-04','09:05:00',1.06),('14598','2013-12-04','09:10:00',1.15),('14598','2013-12-04','09:15:00',1.24),('14598','2013-12-04','09:20:00',1.32),('14598','2013-12-04','09:25:00',1.41),('14598','2013-12-04','09:30:00',1.49),('14598','2013-12-04','09:35:00',1.57),('14598','2013-12-04','09:40:00',1.64),('14598','2013-12-04','09:45:00',1.73),('14598','2013-12-04','09:50:00',1.8),('14598','2013-12-04','09:55:00',1.88),('14598','2013-12-04','10:00:00',1.96),('14598','2013-12-04','10:05:00',2.03),('14598','2013-12-04','10:10:00',2.09),('14598','2013-12-04','10:15:00',2.17),('14598','2013-12-04','10:20:00',2.23),('14598','2013-12-04','10:25:00',2.29),('14598','2013-12-04','10:30:00',2.35),('14598','2013-12-04','10:35:00',2.41),('14598','2013-12-04','10:40:00',2.47),('14598','2013-12-04','10:45:00',2.52),('14598','2013-12-04','10:50:00',2.57),('14598','2013-12-04','10:55:00',2.61),('14598','2013-12-04','11:00:00',2.66),('14598','2013-12-04','11:05:00',2.7),('14598','2013-12-04','11:10:00',2.74),('14598','2013-12-04','11:15:00',2.78),('14598','2013-12-04','11:20:00',2.8),('14598','2013-12-04','11:25:00',2.83),('14598','2013-12-04','11:30:00',2.87),('14598','2013-12-04','11:35:00',2.89),('14598','2013-12-04','11:40:00',2.91),('14598','2013-12-04','11:45:00',2.92),('14598','2013-12-04','11:50:00',2.94),('14598','2013-12-04','11:55:00',2.96),('14598','2013-12-04','12:00:00',2.98),('14598','2013-12-04','12:05:00',2.99),('14598','2013-12-04','12:10:00',3),('14598','2013-12-04','12:15:00',3.01),('14598','2013-12-04','12:20:00',3.01),('14598','2013-12-04','12:25:00',3),('14598','2013-12-04','12:30:00',3),('14598','2013-12-04','12:35:00',2.99),('14598','2013-12-04','12:40:00',2.98),('14598','2013-12-04','12:45:00',2.9),('14598','2013-12-04','12:50:00',2.95),('14598','2013-12-04','12:55:00',2.93),('14598','2013-12-04','13:00:00',2.92),('14598','2013-12-04','13:05:00',2.91),('14598','2013-12-04','13:10:00',2.87),('14598','2013-12-04','13:15:00',2.85),('14598','2013-12-04','13:20:00',2.82),('14598','2013-12-04','13:25:00',2.8),('14598','2013-12-04','13:30:00',2.76),('14598','2013-12-04','13:35:00',2.74),('14598','2013-12-04','13:40:00',2.7),('14598','2013-12-04','13:45:00',2.66),('14598','2013-12-04','13:50:00',2.61),('14598','2013-12-04','13:55:00',2.58),('14598','2013-12-04','14:00:00',2.53),('14598','2013-12-04','14:05:00',2.49),('14598','2013-12-04','14:10:00',2.44),('14598','2013-12-04','14:15:00',2.38),('14598','2013-12-04','14:20:00',2.32),('14598','2013-12-04','14:25:00',2.27),('14598','2013-12-04','14:30:00',2.2),('14598','2013-12-04','14:35:00',2.14),('14598','2013-12-04','14:40:00',2.07),('14598','2013-12-04','14:45:00',1.99),('14598','2013-12-04','14:50:00',1.93),('14598','2013-12-04','14:55:00',1.85),('14598','2013-12-04','15:00:00',1.76),('14598','2013-12-04','15:05:00',1.67),('14598','2013-12-04','15:10:00',1.59),('14598','2013-12-04','15:15:00',1.51),('14598','2013-12-04','15:20:00',1.42),('14598','2013-12-04','15:25:00',1.31),('14598','2013-12-04','15:30:00',1.21),('14598','2013-12-04','15:35:00',1.11),('14598','2013-12-04','15:40:00',1.01),('14598','2013-12-03','09:10:00',1.06),('14598','2013-12-03','09:15:00',1.13),('14598','2013-12-03','09:20:00',1.21),('14598','2013-12-03','09:25:00',1.34),('14598','2013-12-03','09:30:00',1.44),('14598','2013-12-03','09:35:00',1.53),('14598','2013-12-03','09:40:00',1.6),('14598','2013-12-03','09:45:00',1.67),('14598','2013-12-03','09:50:00',1.75),('14598','2013-12-03','09:55:00',1.82),('14598','2013-12-03','10:00:00',1.89),('14598','2013-12-03','10:05:00',1.95),('14598','2013-12-03','10:10:00',2.02),('14598','2013-12-03','10:15:00',2.08),('14598','2013-12-03','10:20:00',2.15),('14598','2013-12-03','10:25:00',2.17),('14598','2013-12-03','10:30:00',2.29),('14598','2013-12-03','10:35:00',2.34),('14598','2013-12-03','10:40:00',2.4),('14598','2013-12-03','10:45:00',2.45),('14598','2013-12-03','10:50:00',2.5),('14598','2013-12-03','10:55:00',2.55),('14598','2013-12-03','11:00:00',2.6),('14598','2013-12-03','11:05:00',2.65),('14598','2013-12-03','11:10:00',2.7),('14598','2013-12-03','11:15:00',2.75),('14598','2013-12-03','11:20:00',2.81),('14598','2013-12-03','11:25:00',2.85),('14598','2013-12-03','11:30:00',2.88),('14598','2013-12-03','11:35:00',2.92),('14598','2013-12-03','11:40:00',2.92),('14598','2013-12-03','11:45:00',2.99),('14598','2013-12-03','11:50:00',3.09),('14598','2013-12-03','11:55:00',3.08),('14598','2013-12-03','12:00:00',3.09),('14598','2013-12-03','12:05:00',3.1),('14598','2013-12-03','12:10:00',3.12),('14598','2013-12-03','12:15:00',3.17),('14598','2013-12-03','12:20:00',3.2),('14598','2013-12-03','12:25:00',3.23),('14598','2013-12-03','12:30:00',3.25),('14598','2013-12-03','12:35:00',3.29),('14598','2013-12-03','12:40:00',3.3),('14598','2013-12-03','12:45:00',3.31),('14598','2013-12-03','12:50:00',3.34),('14598','2013-12-03','12:55:00',3.36),('14598','2013-12-03','13:00:00',3.06),('14598','2013-12-03','13:05:00',3.02),('14598','2013-12-03','13:10:00',3.24),('14598','2013-12-03','13:15:00',3.4),('14598','2013-12-03','13:20:00',3.36),('14598','2013-12-03','13:25:00',2.92),('14598','2013-12-03','13:30:00',2.89),('14598','2013-12-03','13:35:00',2.81),('14598','2013-12-03','13:40:00',2.36),('14598','2013-12-03','13:45:00',2.09),('14598','2013-12-03','13:50:00',2.41),('14598','2013-12-03','13:55:00',2.25),('14598','2013-12-03','14:00:00',1.69),('14598','2013-12-03','14:05:00',1.72),('14598','2013-12-03','14:10:00',2.24),('14598','2013-12-03','14:15:00',2.37),('14598','2013-12-03','14:20:00',2.31),('14598','2013-12-03','14:25:00',2.25),('14598','2013-12-03','14:30:00',2.18),('14598','2013-12-03','14:35:00',2.1),('14598','2013-12-03','14:40:00',2.01),('14598','2013-12-03','14:45:00',1.95),('14598','2013-12-03','14:50:00',1.87),('14598','2013-12-03','14:55:00',1.79),('14598','2013-12-03','15:00:00',1.7),('14598','2013-12-03','15:05:00',1.61),('14598','2013-12-03','15:10:00',1.53),('14598','2013-12-03','15:15:00',1.44),('14598','2013-12-03','15:20:00',1.34),('14598','2013-12-03','15:25:00',1.26),('14598','2013-12-03','15:30:00',1.16),('14598','2013-12-03','15:35:00',1.07),('14598','2013-12-01','11:45:00',1.29),('14598','2013-12-01','12:00:00',1.31),('14598','2013-12-01','12:05:00',1.51),('14598','2013-12-01','12:10:00',1.23),('14598','2013-12-01','12:15:00',1.41),('14598','2013-12-01','12:20:00',1.16),('14598','2013-12-01','12:55:00',1.15),('14598','2013-11-30','10:15:00',1.01),('14598','2013-11-30','10:20:00',1.22),('14598','2013-11-30','10:25:00',1.38),('14598','2013-11-30','10:30:00',1.36),('14598','2013-11-30','10:35:00',1.36),('14598','2013-11-30','10:40:00',1.17),('14598','2013-11-30','10:45:00',1.26),('14598','2013-11-30','10:50:00',1.3),('14598','2013-11-30','10:55:00',1.17),('14598','2013-11-30','11:00:00',1.08),('14598','2013-11-30','11:05:00',1.05),('14598','2013-11-30','11:10:00',1.11),('14598','2013-11-30','11:15:00',1.2),('14598','2013-11-30','11:20:00',1.27),('14598','2013-11-30','11:25:00',1.3),('14598','2013-11-30','11:30:00',1.25),('14598','2013-11-30','11:35:00',1.32),('14598','2013-11-30','11:40:00',1.25),('14598','2013-11-30','11:45:00',1.11),('14598','2013-11-30','11:50:00',1.07),('14598','2013-11-30','11:55:00',1.02),('14598','2013-11-29','09:00:00',1.02),('14598','2013-11-29','09:05:00',1.11),('14598','2013-11-29','09:10:00',1.2),('14598','2013-11-29','09:15:00',1.28),('14598','2013-11-29','09:20:00',1.36),('14598','2013-11-29','09:25:00',1.44),('14598','2013-11-29','09:30:00',1.52),('14598','2013-11-29','09:35:00',1.6),('14598','2013-11-29','09:40:00',1.68),('14598','2013-11-29','09:45:00',1.75),('14598','2013-11-29','09:50:00',1.83),('14598','2013-11-29','09:55:00',1.89),('14598','2013-11-29','10:00:00',1.97),('14598','2013-11-29','10:05:00',2.04),('14598','2013-11-29','10:10:00',2.11),('14598','2013-11-29','10:15:00',2.17),('14598','2013-11-29','10:20:00',2.23),('14598','2013-11-29','10:25:00',2.3),('14598','2013-11-29','10:30:00',2.35),('14598','2013-11-29','10:35:00',2.41),('14598','2013-11-29','10:40:00',2.46),('14598','2013-11-29','10:45:00',2.52),('14598','2013-11-29','10:50:00',2.57),('14598','2013-11-29','10:55:00',2.6),('14598','2013-11-29','11:00:00',2.65),('14598','2013-11-29','11:05:00',2.7),('14598','2013-11-29','11:10:00',2.69),('14598','2013-11-29','11:15:00',2.78),('14598','2013-11-29','11:20:00',2.81),('14598','2013-11-29','11:25:00',2.85),('14598','2013-11-29','11:30:00',2.88),('14598','2013-11-29','11:35:00',2.91),('14598','2013-11-29','11:40:00',2.92),('14598','2013-11-29','11:45:00',2.94),('14598','2013-11-29','11:50:00',2.96),('14598','2013-11-29','11:55:00',2.98),('14598','2013-11-29','12:00:00',2.99),('14598','2013-11-29','12:05:00',3),('14598','2013-11-29','12:10:00',3),('14598','2013-11-29','12:15:00',3.03),('14598','2013-11-29','12:20:00',3.02),('14598','2013-11-29','12:25:00',2.98),('14598','2013-11-29','12:30:00',3.01),('14598','2013-11-29','12:35:00',3.01),('14598','2013-11-29','12:40:00',3),('14598','2013-11-29','12:45:00',2.98),('14598','2013-11-29','12:50:00',2.97),('14598','2013-11-29','12:55:00',2.95),('14598','2013-11-29','13:00:00',2.94),('14598','2013-11-29','13:05:00',2.93),('14598','2013-11-29','13:10:00',2.9),('14598','2013-11-29','13:15:00',2.86),('14598','2013-11-29','13:20:00',2.84),('14598','2013-11-29','13:25:00',2.82),('14598','2013-11-29','13:30:00',2.77),('14598','2013-11-29','13:35:00',2.74),('14598','2013-11-29','13:40:00',2.71),('14598','2013-11-29','13:45:00',2.68),('14598','2013-11-29','13:50:00',2.63),('14598','2013-11-29','13:55:00',2.58),('14598','2013-11-29','14:00:00',2.56),('14598','2013-11-29','14:05:00',2.48),('14598','2013-11-29','14:10:00',2.38),('14598','2013-11-29','14:15:00',2.39),('14598','2013-11-29','14:20:00',2.33),('14598','2013-11-29','14:25:00',2.25),('14598','2013-11-29','14:30:00',2.19),('14598','2013-11-29','14:35:00',2.14),('14598','2013-11-29','14:40:00',2.05),('14598','2013-11-29','14:45:00',1.97),('14598','2013-11-29','14:50:00',1.9),('14598','2013-11-29','14:55:00',1.81),('14598','2013-11-29','15:00:00',1.72),('14598','2013-11-29','15:05:00',1.64),('14598','2013-11-29','15:10:00',1.55),('14598','2013-11-29','15:15:00',1.47),('14598','2013-11-29','15:20:00',1.39),('14598','2013-11-29','15:25:00',1.31),('14598','2013-11-29','15:30:00',1.23),('14598','2013-11-29','15:35:00',1.14),('14598','2013-11-29','15:40:00',1.03),('14598','2013-11-28','11:30:00',1.23),('14598','2013-11-28','11:35:00',1.37),('14598','2013-11-28','12:50:00',1.13),('14598','2013-11-28','13:35:00',1.06),('14598','2014-04-20','07:35:00',1.1),('14598','2014-04-20','08:20:00',1.08),('14598','2014-04-20','08:30:00',1.75),('14598','2014-04-20','08:35:00',1.55),('14598','2014-04-20','08:40:00',1.43),('14598','2014-04-20','08:45:00',1.48),('14598','2014-04-20','08:50:00',1.68),('14598','2014-04-20','08:55:00',1.81),('14598','2014-04-20','09:00:00',1.99),('14598','2014-04-20','09:05:00',2.17),('14598','2014-04-20','09:10:00',2.33),('14598','2014-04-20','09:15:00',2.5),('14598','2014-04-20','09:20:00',2.61),('14598','2014-04-20','09:25:00',2.69),('14598','2014-04-20','09:30:00',3.08),('14598','2014-04-20','09:35:00',2.56),('14598','2014-04-20','09:40:00',2.11),('14598','2014-04-20','09:45:00',2.24),('14598','2014-04-20','09:50:00',2.61),('14598','2014-04-20','09:55:00',2.2),('14598','2014-04-20','10:00:00',2.3),('14598','2014-04-20','10:05:00',2.24),('14598','2014-04-20','10:10:00',2.08),('14598','2014-04-20','10:15:00',2.05),('14598','2014-04-20','10:20:00',2.07),('14598','2014-04-20','10:25:00',2.36),('14598','2014-04-20','10:30:00',2.81),('14598','2014-04-20','10:35:00',3.04),('14598','2014-04-20','10:40:00',3.65),('14598','2014-04-20','10:45:00',4.38),('14598','2014-04-20','10:50:00',3.59),('14598','2014-04-20','10:55:00',3.33),('14598','2014-04-20','11:00:00',3.3),('14598','2014-04-20','11:05:00',3.28),('14598','2014-04-20','11:10:00',4.16),('14598','2014-04-20','11:15:00',4.42),('14598','2014-04-20','11:20:00',4.5),('14598','2014-04-20','11:25:00',4.39),('14598','2014-04-20','11:30:00',4.42),('14598','2014-04-20','11:35:00',4.49),('14598','2014-04-20','11:40:00',4.55),('14598','2014-04-20','11:45:00',4.61),('14598','2014-04-20','11:50:00',4.61),('14598','2014-04-20','11:55:00',4.68),('14598','2014-04-20','12:00:00',4.75),('14598','2014-04-20','12:05:00',4.76),('14598','2014-04-20','12:10:00',4.82),('14598','2014-04-20','12:15:00',4.87),('14598','2014-04-20','12:20:00',4.89),('14598','2014-04-20','12:25:00',4.88),('14598','2014-04-20','12:30:00',4.96),('14598','2014-04-20','12:35:00',4.98),('14598','2014-04-20','12:40:00',5.02),('14598','2014-04-20','12:45:00',5.06),('14598','2014-04-20','12:50:00',5.04),('14598','2014-04-20','12:55:00',5.07),('14598','2014-04-20','13:00:00',5.11),('14598','2014-04-20','13:05:00',5.11),('14598','2014-04-20','13:10:00',5.13),('14598','2014-04-20','13:15:00',5.12),('14598','2014-04-20','13:20:00',5.14),('14598','2014-04-20','13:25:00',5.18),('14598','2014-04-20','13:30:00',5.21),('14598','2014-04-20','13:35:00',5.18),('14598','2014-04-20','13:40:00',5.09),('14598','2014-04-20','13:45:00',5.08),('14598','2014-04-20','13:50:00',5.17),('14598','2014-04-20','13:55:00',5.24),('14598','2014-04-20','14:00:00',5.31),('14598','2014-04-20','14:05:00',5.49),('14598','2014-04-20','14:10:00',4.06),('14598','2014-04-20','14:15:00',3.6),('14598','2014-04-20','14:20:00',3.33),('14598','2014-04-20','14:25:00',3.19),('14598','2014-04-20','14:30:00',2.88),('14598','2014-04-20','14:35:00',3.02),('14598','2014-04-20','14:40:00',3.55),('14598','2014-04-20','14:45:00',5.27),('14598','2014-04-20','14:50:00',4.86),('14598','2014-04-20','14:55:00',5.12),('14598','2014-04-20','15:00:00',4.95),('14598','2014-04-20','15:05:00',4.88),('14598','2014-04-20','15:10:00',4.78),('14598','2014-04-20','15:15:00',4.72),('14598','2014-04-20','15:20:00',4.79),('14598','2014-04-20','15:25:00',3.51),('14598','2014-04-20','15:30:00',4.54),('14598','2014-04-20','15:35:00',4.74),('14598','2014-04-20','15:40:00',4.53),('14598','2014-04-20','15:45:00',4.47),('14598','2014-04-20','15:50:00',4.45),('14598','2014-04-20','15:55:00',4.39),('14598','2014-04-20','16:00:00',4.35),('14598','2014-04-20','16:05:00',4.2),('14598','2014-04-20','16:10:00',4.26),('14598','2014-04-20','16:15:00',3.58),('14598','2014-04-20','16:20:00',4.16),('14598','2014-04-20','16:25:00',3.88),('14598','2014-04-20','16:30:00',3.43),('14598','2014-04-20','16:35:00',4.13),('14598','2014-04-20','16:40:00',3.75),('14598','2014-04-20','16:45:00',3.74),('14598','2014-04-20','16:50:00',3.58),('14598','2014-04-20','16:55:00',3.49),('14598','2014-04-20','17:00:00',3.35),('14598','2014-04-20','17:05:00',3.27),('14598','2014-04-20','17:10:00',3.19),('14598','2014-04-20','17:15:00',3.14),('14598','2014-04-20','17:20:00',3.05),('14598','2014-04-20','17:25:00',2.92),('14598','2014-04-20','17:30:00',2.83),('14598','2014-04-20','17:35:00',2.72),('14598','2014-04-20','17:40:00',2.63),('14598','2014-04-20','17:45:00',2.53),('14598','2014-04-20','17:50:00',2.42),('14598','2014-04-20','17:55:00',2.33),('14598','2014-04-20','18:00:00',2.22),('14598','2014-04-20','18:05:00',1.9),('14598','2014-04-20','18:10:00',1.67),('14598','2014-04-20','18:15:00',1.2),('14598','2014-04-20','18:20:00',1.84),('14598','2014-04-20','18:25:00',1.66),('14598','2014-04-20','18:30:00',1.26),('14598','2013-11-27','08:55:00',1.01),('14598','2013-11-27','09:20:00',1.03),('14598','2013-11-27','09:25:00',1.06),('14598','2013-11-27','09:30:00',1.3),('14598','2013-11-27','09:45:00',1.11),('14598','2013-11-27','09:50:00',1.21),('14598','2013-11-27','09:55:00',1.58),('14598','2013-11-27','10:00:00',1.57),('14598','2013-11-27','10:05:00',1.49),('14598','2013-11-27','10:10:00',1.33),('14598','2013-11-27','10:15:00',1.23),('14598','2013-11-27','10:20:00',1.62),('14598','2013-11-27','10:25:00',1.61),('14598','2013-11-27','10:30:00',1.46),('14598','2013-11-27','10:35:00',1.37),('14598','2013-11-27','10:40:00',1.51),('14598','2013-11-27','10:45:00',1.32),('14598','2013-11-27','10:50:00',1.4),('14598','2013-11-27','10:55:00',1.46),('14598','2013-11-27','11:00:00',1.36),('14598','2013-11-27','11:05:00',1.4),('14598','2013-11-27','11:10:00',1.91),('14598','2013-11-27','11:15:00',2.24),('14598','2013-11-27','11:20:00',1.6),('14598','2013-11-27','11:25:00',1.42),('14598','2013-11-27','11:30:00',1.37),('14598','2013-11-27','11:35:00',1.22),('14598','2013-11-27','11:40:00',1.18),('14598','2013-11-27','11:45:00',1),('14598','2013-11-27','11:50:00',1.19),('14598','2013-11-27','11:55:00',1.35),('14598','2013-11-27','12:00:00',1.83),('14598','2013-11-27','12:05:00',2.67),('14598','2013-11-27','12:10:00',3.4),('14598','2013-11-27','12:15:00',3.79),('14598','2013-11-27','12:20:00',2.26),('14598','2013-11-27','12:25:00',4.48),('14598','2013-11-27','12:30:00',2.57),('14598','2013-11-27','12:35:00',1.41),('14598','2013-11-27','12:40:00',1.43),('14598','2013-11-27','12:45:00',1.09),('14598','2013-11-27','12:50:00',1.14),('14598','2013-11-27','12:55:00',1.05),('14598','2013-11-27','13:00:00',1.06),('14598','2013-11-27','13:05:00',1.17),('14598','2013-11-27','13:10:00',1.28),('14598','2013-11-27','13:15:00',1.37),('14598','2013-11-27','13:20:00',1.49),('14598','2013-11-27','13:25:00',1.2),('14598','2013-11-26','08:50:00',1.35),('14598','2013-11-26','08:55:00',1.35),('14598','2013-11-26','09:00:00',1.43),('14598','2013-11-26','09:05:00',1.51),('14598','2013-11-26','09:10:00',1.36),('14598','2013-11-26','10:15:00',1.85),('14598','2013-11-26','10:20:00',2.4),('14598','2013-11-26','10:25:00',2.48),('14598','2013-11-26','10:30:00',2.2),('14598','2013-11-26','10:35:00',2.3),('14598','2013-11-26','10:40:00',2.49),('14598','2013-11-26','10:45:00',2.97),('14598','2013-11-26','10:50:00',2.19),('14598','2013-11-26','10:55:00',2.97),('14598','2013-11-26','11:00:00',3.13),('14598','2013-11-26','11:05:00',3.41),('14598','2013-11-26','11:10:00',3.19),('14598','2013-11-26','11:15:00',3.84),('14598','2013-11-26','11:20:00',3.26),('14598','2013-11-26','11:25:00',2.47),('14598','2013-11-26','11:30:00',1.97),('14598','2013-11-26','11:40:00',1.09),('14598','2013-11-26','11:45:00',1.34),('14598','2013-11-26','11:50:00',1.55),('14598','2013-11-26','11:55:00',2.1),('14598','2013-11-26','12:00:00',3.66),('14598','2013-11-26','12:05:00',3.94),('14598','2013-11-26','12:10:00',3.59),('14598','2013-11-26','12:15:00',3.54),('14598','2013-11-26','12:20:00',3.41),('14598','2013-11-26','12:25:00',3.42),('14598','2013-11-26','12:30:00',3.26),('14598','2013-11-26','12:35:00',3.43),('14598','2013-11-26','12:40:00',3.44),('14598','2013-11-26','12:45:00',3.44),('14598','2013-11-26','12:50:00',2.77),('14598','2013-11-26','12:55:00',3.34),('14598','2013-11-26','13:00:00',3.22),('14598','2013-11-26','13:05:00',2.45),('14598','2013-11-26','13:10:00',2.18),('14598','2013-11-26','13:15:00',2.63),('14598','2013-11-26','13:20:00',3.05),('14598','2013-11-26','13:25:00',3.12),('14598','2013-11-26','13:30:00',3.09),('14598','2013-11-26','13:35:00',3.05),('14598','2013-11-26','13:40:00',2.72),('14598','2013-11-26','13:45:00',2.79),('14598','2013-11-26','13:50:00',2.73),('14598','2013-11-26','13:55:00',2.62),('14598','2013-11-26','14:00:00',2.63),('14598','2013-11-26','14:05:00',2.56),('14598','2013-11-26','14:10:00',2.55),('14598','2013-11-26','14:15:00',2.38),('14598','2013-11-26','14:20:00',2.34),('14598','2013-11-26','14:25:00',2.22),('14598','2013-11-26','14:30:00',1.98),('14598','2013-11-26','14:35:00',2.1),('14598','2013-11-26','14:40:00',2.07),('14598','2013-11-26','14:45:00',1.74),('14598','2013-11-26','14:50:00',1.68),('14598','2013-11-26','14:55:00',2.21),('14598','2013-11-26','15:00:00',1.64),('14598','2013-11-26','15:05:00',1.35),('14598','2013-11-26','15:10:00',2.04),('14598','2013-11-26','15:15:00',1.75),('14598','2013-11-26','15:20:00',1.45),('14598','2013-11-26','15:25:00',1.45),('14598','2013-11-26','15:30:00',1.41),('14598','2013-11-26','15:35:00',1.18),('14598','2013-11-25','08:55:00',1.06),('14598','2013-11-25','09:00:00',1.14),('14598','2013-11-25','09:05:00',1.7),('14598','2013-11-25','09:10:00',1.37),('14598','2013-11-25','09:15:00',1.31),('14598','2013-11-25','09:20:00',1.59),('14598','2013-11-25','09:25:00',1.9),('14598','2013-11-25','09:45:00',2),('14598','2013-11-25','09:50:00',1.16),('14598','2013-11-25','09:55:00',1.06),('14598','2013-11-25','10:00:00',1.82),('14598','2013-11-25','10:05:00',2.5),('14598','2013-11-25','10:10:00',2.84),('14598','2013-11-25','10:15:00',2.92),('14598','2013-11-25','10:20:00',2.37),('14598','2013-11-25','10:25:00',1.31),('14598','2013-11-25','10:30:00',2.33),('14598','2013-11-25','10:35:00',3.03),('14598','2013-11-25','10:40:00',3.03),('14598','2013-11-25','10:45:00',1.96),('14598','2013-11-25','10:50:00',1.69),('14598','2013-11-25','10:55:00',1.99),('14598','2013-11-25','11:00:00',2.06),('14598','2013-11-25','11:05:00',3.04),('14598','2013-11-25','11:10:00',3.24),('14598','2013-11-25','11:15:00',2.5),('14598','2013-11-25','11:20:00',1.03),('14598','2013-11-25','11:25:00',1.08),('14598','2013-11-25','11:30:00',1.22),('14598','2013-11-25','11:35:00',1.09),('14598','2013-11-25','11:40:00',1.03),('14598','2013-11-25','11:45:00',1.23),('14598','2013-11-25','11:50:00',1.63),('14598','2013-11-25','11:55:00',1.46),('14598','2013-11-25','12:00:00',2.13),('14598','2013-11-25','12:05:00',3.13),('14598','2013-11-25','12:10:00',1.91),('14598','2013-11-25','12:15:00',1.48),('14598','2013-11-25','12:20:00',1.77),('14598','2013-11-25','12:25:00',2.61),('14598','2013-11-25','12:30:00',2.31),('14598','2013-11-25','12:35:00',2.11),('14598','2013-11-25','12:40:00',1.77),('14598','2013-11-25','12:45:00',1.93),('14598','2013-11-25','12:50:00',2.26),('14598','2013-11-25','12:55:00',3.1),('14598','2013-11-25','13:00:00',2.05),('14598','2013-11-25','13:05:00',1.24),('14598','2013-11-25','13:10:00',1.21),('14598','2013-11-25','13:15:00',1.25),('14598','2013-11-25','13:20:00',1.56),('14598','2013-11-25','13:25:00',1.45),('14598','2013-11-25','13:30:00',2.03),('14598','2013-11-25','13:35:00',1.71),('14598','2013-11-25','13:40:00',1.59),('14598','2013-11-25','13:45:00',1.2),('14598','2013-11-24','10:00:00',1.3),('14598','2013-11-24','10:05:00',1.66),('14598','2013-11-24','10:10:00',1.67),('14598','2013-11-24','10:15:00',1.41),('14598','2013-11-24','10:20:00',1.99),('14598','2013-11-24','10:25:00',2.04),('14598','2013-11-24','10:30:00',2.42),('14598','2013-11-24','10:35:00',2.31),('14598','2013-11-24','10:40:00',2.7),('14598','2013-11-24','10:45:00',2.8),('14598','2013-11-24','10:50:00',2.88),('14598','2013-11-24','10:55:00',2.63),('14598','2013-11-24','11:00:00',1.82),('14598','2013-11-24','11:05:00',1.81),('14598','2013-11-24','11:10:00',1.34),('14598','2013-11-24','11:15:00',1.45),('14598','2013-11-24','11:20:00',1.68),('14598','2013-11-24','11:25:00',1.76),('14598','2013-11-24','11:30:00',1.49),('14598','2013-11-24','11:35:00',1.13),('14598','2013-11-24','12:45:00',1.04),('14598','2013-11-24','12:50:00',1.08),('14598','2013-11-24','12:55:00',1.06),('14598','2013-11-24','13:00:00',1.14),('14598','2013-11-24','13:05:00',1.24),('14598','2013-11-24','13:10:00',1.24),('14598','2013-11-24','13:15:00',1.2),('14598','2013-11-24','13:20:00',1.15),('14598','2013-11-24','13:25:00',1.12),('14598','2013-11-24','13:30:00',1.11),('14598','2013-11-24','13:35:00',1.08),('14598','2013-11-24','13:40:00',1.03),('14598','2013-11-23','10:10:00',1.11),('14598','2013-11-23','10:15:00',2.41),('14598','2013-11-23','11:35:00',1.04),('14598','2013-11-23','11:40:00',1.98),('14598','2013-11-23','11:45:00',1.37),('14598','2013-11-23','13:05:00',1.04),('14598','2013-11-22','09:00:00',1.08),('14598','2013-11-22','09:20:00',1.01),('14598','2013-11-22','12:00:00',1.3),('14598','2013-11-22','12:05:00',1.58),('14598','2013-11-22','12:10:00',1.83),('14598','2013-11-22','12:15:00',1.71),('14598','2013-11-22','12:20:00',1.76),('14598','2013-11-22','12:25:00',1.88),('14598','2013-11-22','12:30:00',1.05),('14598','2013-11-22','12:40:00',1.05),('14598','2013-11-21','09:15:00',1.09),('14598','2013-11-21','09:20:00',1.28),('14598','2013-11-21','09:30:00',1.39),('14598','2013-11-21','09:35:00',1.16),('14598','2013-11-21','09:50:00',1.12),('14598','2013-11-21','09:55:00',1.64),('14598','2013-11-21','10:00:00',1.51),('14598','2013-11-21','10:05:00',1.04),('14598','2013-11-21','10:10:00',1.76),('14598','2013-11-21','10:15:00',2.13),('14598','2013-11-21','10:20:00',1.25),('14598','2013-11-21','10:25:00',1.17),('14598','2013-11-21','10:30:00',1.2),('14598','2013-11-21','10:35:00',2.34),('14598','2013-11-21','10:40:00',3.32),('14598','2013-11-21','10:45:00',1.84),('14598','2013-11-21','10:50:00',2.57),('14598','2013-11-21','10:55:00',1.35),('14598','2013-11-21','11:00:00',2.57),('14598','2013-11-21','11:05:00',2.87),('14598','2013-11-21','11:10:00',3.07),('14598','2013-11-21','11:15:00',3.12),('14598','2013-11-21','11:20:00',3.36),('14598','2013-11-21','11:25:00',3.05),('14598','2013-11-21','11:30:00',1.8),('14598','2013-11-21','11:35:00',2.7),('14598','2013-11-21','11:40:00',3.38),('14598','2013-11-21','11:45:00',2.55),('14598','2013-11-21','11:50:00',3),('14598','2013-11-21','11:55:00',2.74),('14598','2013-11-21','12:00:00',1.65),('14598','2013-11-21','12:05:00',1.46),('14598','2013-11-21','12:10:00',2.02),('14598','2013-11-21','12:15:00',1.35),('14598','2013-11-21','12:20:00',1.6),('14598','2013-11-21','12:25:00',1.18),('14598','2013-11-21','12:30:00',1.42),('14598','2013-11-21','12:35:00',2.07),('14598','2013-11-21','12:40:00',2.34),('14598','2013-11-21','12:45:00',3.22),('14598','2013-11-21','12:50:00',3.14),('14598','2013-11-21','12:55:00',3.26),('14598','2013-11-21','13:00:00',3.74),('14598','2013-11-21','13:05:00',3.66),('14598','2013-11-21','13:10:00',2.78),('14598','2013-11-21','13:15:00',1.97),('14598','2013-11-21','13:20:00',2.86),('14598','2013-11-21','13:25:00',1.36),('14598','2013-11-21','13:30:00',3.39),('14598','2013-11-21','13:35:00',3.15),('14598','2013-11-21','13:40:00',3.02),('14598','2013-11-21','13:45:00',2.6),('14598','2013-11-21','13:50:00',1.15),('14598','2013-11-21','13:55:00',1.27),('14598','2013-11-21','14:00:00',1.46),('14598','2013-11-21','14:05:00',2.51),('14598','2013-11-21','14:10:00',1.55),('14598','2013-11-21','14:15:00',2.18),('14598','2013-11-21','14:20:00',1.9),('14598','2013-11-21','14:25:00',1.61),('14598','2013-11-21','14:30:00',2.43),('14598','2013-11-21','14:35:00',1.74),('14598','2013-11-21','14:40:00',1.25),('14598','2013-11-21','14:45:00',2.13),('14598','2013-11-21','14:50:00',2.07),('14598','2013-11-21','15:10:00',1.98),('14598','2013-11-21','15:15:00',1.72),('14598','2013-11-21','15:20:00',1.67),('14598','2013-11-21','15:25:00',1.69),('14598','2013-11-21','15:30:00',1.29),('14598','2013-11-20','08:45:00',1.2),('14598','2013-11-20','08:50:00',1.12),('14598','2013-11-20','09:50:00',1.2),('14598','2013-11-20','11:15:00',1.02),('14598','2013-11-20','11:20:00',1.88),('14598','2013-11-20','11:25:00',2.25),('14598','2013-11-20','11:30:00',1.14),('14598','2013-11-20','11:35:00',1.04),('14598','2013-11-20','11:40:00',1.14),('14598','2013-11-20','11:45:00',1.7),('14598','2013-11-20','11:50:00',2.14),('14598','2013-11-20','11:55:00',1.68),('14598','2013-11-20','12:00:00',1.34),('14598','2013-11-20','12:05:00',1.19),('14598','2013-11-20','12:10:00',1.23),('14598','2013-11-20','12:15:00',1.22),('14598','2013-11-20','12:20:00',1.35),('14598','2013-11-20','12:25:00',1.41),('14598','2013-11-20','12:30:00',1.77),('14598','2013-11-20','12:35:00',1.72),('14598','2013-11-20','12:40:00',1.96),('14598','2013-11-20','12:45:00',1.42),('14598','2013-11-20','12:50:00',2.12),('14598','2013-11-20','12:55:00',2.28),('14598','2013-11-20','13:00:00',3.01),('14598','2013-11-20','13:05:00',3.06),('14598','2013-11-20','13:10:00',1.95),('14598','2013-11-20','13:15:00',2.31),('14598','2013-11-20','13:20:00',2.3),('14598','2013-11-20','13:25:00',1.97),('14598','2013-11-20','13:30:00',2.47),('14598','2013-11-20','13:35:00',1.79),('14598','2013-11-20','13:40:00',1.14),('14598','2013-11-20','13:50:00',1.09),('14598','2013-11-20','13:55:00',1.41),('14598','2013-11-20','14:00:00',1.03),('14598','2013-11-20','14:10:00',2.03),('14598','2013-11-20','14:15:00',1.14),('14598','2013-11-20','14:25:00',1.6),('14598','2013-11-20','14:35:00',1.52),('14598','2013-11-20','14:40:00',2.61),('14598','2013-11-20','14:45:00',1.24),('14598','2013-11-19','09:15:00',1.14),('14598','2013-11-19','09:20:00',1.05),('14598','2013-11-19','09:25:00',1.34),('14598','2013-11-19','09:30:00',1.12),('14598','2013-11-19','10:15:00',1.82),('14598','2013-11-19','10:20:00',1.94),('14598','2013-11-19','10:25:00',1.63),('14598','2013-11-19','10:30:00',2.85),('14598','2013-11-19','10:35:00',1.85),('14598','2013-11-19','10:40:00',1.52),('14598','2013-11-19','10:45:00',1.93),('14598','2013-11-19','10:50:00',1.27),('14598','2013-11-19','10:55:00',1.14),('14598','2013-11-19','11:00:00',2.16),('14598','2013-11-19','11:05:00',1.46),('14598','2013-11-19','11:10:00',2.38),('14598','2013-11-19','11:15:00',1.23),('14598','2013-11-19','11:25:00',1.48),('14598','2013-11-19','11:30:00',1.49),('14598','2013-11-19','11:35:00',2.53),('14598','2013-11-19','11:40:00',2.39),('14598','2013-11-19','11:45:00',1.58),('14598','2013-11-19','11:50:00',1.09),('14598','2013-11-19','11:55:00',1.29),('14598','2013-11-19','12:00:00',1.11),('14598','2013-11-19','12:05:00',1.03),('14598','2013-11-19','12:10:00',1.5),('14598','2013-11-19','12:15:00',1.92),('14598','2013-11-19','12:20:00',3.03),('14598','2013-11-19','12:25:00',2.32),('14598','2013-11-19','12:30:00',2.17),('14598','2013-11-19','12:35:00',2.74),('14598','2013-11-19','12:40:00',2.48),('14598','2013-11-19','12:50:00',1.19),('14598','2013-11-19','12:55:00',1.87),('14598','2013-11-19','13:00:00',1.57),('14598','2013-11-19','13:05:00',1.92),('14598','2013-11-19','14:55:00',1.22),('14598','2013-11-19','15:00:00',2.26),('14598','2013-11-19','15:05:00',2.78),('14598','2013-11-19','15:10:00',2.23),('14598','2013-11-19','15:15:00',1.8),('14598','2013-11-19','15:20:00',1.66),('14598','2013-11-19','15:25:00',1.45),('14598','2013-11-19','15:30:00',1.33),('14598','2013-11-19','15:35:00',1.22),('14598','2013-11-19','15:40:00',1.1),('14598','2013-11-19','15:45:00',1.02),('14598','2013-11-18','09:05:00',1.04),('14598','2013-11-18','09:10:00',1.09),('14598','2013-11-18','09:15:00',1.25),('14598','2013-11-18','09:20:00',1.58),('14598','2013-11-18','09:25:00',1.3),('14598','2013-11-18','09:30:00',1.03),('14598','2013-11-18','09:40:00',1.03),('14598','2013-11-18','09:45:00',1.17),('14598','2013-11-18','09:50:00',1.2),('14598','2013-11-18','09:55:00',1.54),('14598','2013-11-18','10:00:00',1.44),('14598','2013-11-18','10:05:00',1.37),('14598','2013-11-18','10:10:00',1.29),('14598','2013-11-18','10:15:00',1.26),('14598','2013-11-18','10:20:00',1.16),('14598','2013-11-18','10:25:00',1.12),('14598','2013-11-18','10:30:00',1.14),('14598','2013-11-18','10:35:00',1.09),('14598','2013-11-18','10:40:00',1),('14598','2013-11-18','11:00:00',1.1),('14598','2013-11-18','11:05:00',1.27),('14598','2013-11-18','11:10:00',1.37),('14598','2013-11-18','11:15:00',1.39),('14598','2013-11-18','11:20:00',1.4),('14598','2013-11-18','11:25:00',1.39),('14598','2013-11-18','11:30:00',1.42),('14598','2013-11-18','11:35:00',1.52),('14598','2013-11-18','11:40:00',1.52),('14598','2013-11-18','11:45:00',1.55),('14598','2013-11-18','11:50:00',1.59),('14598','2013-11-18','11:55:00',1.63),('14598','2013-11-18','12:00:00',1.6),('14598','2013-11-18','12:05:00',1.64),('14598','2013-11-18','12:10:00',1.55),('14598','2013-11-18','12:15:00',1.96),('14598','2013-11-18','12:20:00',1.86),('14598','2013-11-18','12:25:00',1.77),('14598','2013-11-18','12:30:00',1.57),('14598','2013-11-18','12:35:00',1.35),('14598','2013-11-18','12:40:00',1.2),('14598','2013-11-18','12:45:00',1.12),('14598','2013-11-18','12:50:00',1.09),('14598','2013-11-18','12:55:00',1.08),('14598','2013-11-18','13:00:00',1.13),('14598','2013-11-18','13:05:00',1.47),('14598','2013-11-18','13:10:00',1.54),('14598','2013-11-18','13:15:00',1.53),('14598','2013-11-18','13:20:00',1.38),('14598','2013-11-18','13:25:00',1.23),('14598','2013-11-18','13:30:00',1.05),('14598','2013-11-18','13:35:00',1.02),('14598','2013-11-18','13:40:00',1.27),('14598','2013-11-18','13:45:00',1.21),('14598','2013-11-18','13:50:00',1.09),('14598','2013-11-18','13:55:00',1.01),('14598','2014-04-19','09:00:00',1.01),('14598','2014-04-19','09:05:00',1.08),('14598','2014-04-19','09:10:00',1.07),('14598','2014-04-19','10:10:00',1.64),('14598','2014-04-19','10:15:00',1.88),('14598','2014-04-19','10:20:00',2.05),('14598','2014-04-19','10:25:00',2.54),('14598','2014-04-19','10:30:00',1.42),('14598','2014-04-19','10:35:00',1.22),('14598','2014-04-19','10:40:00',1.03),('14598','2014-04-19','10:45:00',1.16),('14598','2014-04-19','10:50:00',1.51),('14598','2014-04-19','10:55:00',1.43),('14598','2014-04-19','11:00:00',1.57),('14598','2014-04-19','11:05:00',1.94),('14598','2014-04-19','11:10:00',2.33),('14598','2014-04-19','11:15:00',2.67),('14598','2014-04-19','11:20:00',1.31),('14598','2014-04-19','11:25:00',1.9),('14598','2014-04-19','11:30:00',1.4),('14598','2014-04-19','12:50:00',1.61),('14598','2014-04-19','13:00:00',1.51),('14598','2014-04-19','13:05:00',2.26),('14598','2014-04-19','13:10:00',1.8),('14598','2014-04-19','13:15:00',1.97),('14598','2014-04-19','13:20:00',2.21),('14598','2014-04-19','13:25:00',2.46),('14598','2014-04-19','13:30:00',2.66),('14598','2014-04-19','13:35:00',1.13),('14598','2014-04-19','13:45:00',1.04),('14598','2014-04-19','13:50:00',1.21),('14598','2014-04-19','13:55:00',1.22),('14598','2014-04-19','14:10:00',1.27),('14598','2014-04-19','14:15:00',1.81),('14598','2014-04-19','14:20:00',2.23),('14598','2014-04-19','14:25:00',1.88),('14598','2014-04-19','14:30:00',1.18),('14598','2014-04-19','14:35:00',1.07),('14598','2014-04-19','14:40:00',1.32),('14598','2014-04-19','14:45:00',1.11),('14598','2014-04-19','14:50:00',1.54),('14598','2014-04-19','14:55:00',1.35),('14598','2014-04-19','15:10:00',1.95),('14598','2014-04-19','15:15:00',1.12),('14598','2014-04-19','15:20:00',1.12),('14598','2014-04-19','15:25:00',4.79),('14598','2014-04-19','15:30:00',3.13),('14598','2014-04-19','15:35:00',2.28),('14598','2014-04-19','15:40:00',2.49),('14598','2014-04-19','15:45:00',2.18),('14598','2014-04-19','15:50:00',1.51),('14598','2014-04-19','15:55:00',2.52),('14598','2014-04-19','16:00:00',2.95),('14598','2014-04-19','16:05:00',2.42),('14598','2014-04-19','16:10:00',1.77),('14598','2014-04-19','16:15:00',1.39),('14598','2014-04-19','16:20:00',1.39),('14598','2014-04-19','16:25:00',1.1),('14598','2014-04-19','16:30:00',1.14),('14598','2014-04-19','16:35:00',1.07),('14598','2014-04-19','16:40:00',1.01),('14598','2014-04-19','16:45:00',1.21),('14598','2014-04-19','16:50:00',1.36),('14598','2014-04-19','16:55:00',1.48),('14598','2014-04-19','17:00:00',1.86),('14598','2014-04-19','17:05:00',1.39),('14598','2014-04-19','17:10:00',1.75),('14598','2013-11-17','08:40:00',1.23),('14598','2013-11-17','08:45:00',1.07),('14598','2013-11-17','08:50:00',1.11),('14598','2013-11-17','08:55:00',1.19),('14598','2013-11-17','09:00:00',1.27),('14598','2013-11-17','09:05:00',1.39),('14598','2013-11-17','09:10:00',1.52),('14598','2013-11-17','09:15:00',1.48),('14598','2013-11-17','09:20:00',1.58),('14598','2013-11-17','09:25:00',1.65),('14598','2013-11-17','09:30:00',1.56),('14598','2013-11-17','09:35:00',1.26),('14598','2013-11-17','09:40:00',2.26),('14598','2013-11-17','09:45:00',2.16),('14598','2013-11-17','09:50:00',2.51),('14598','2013-11-17','09:55:00',2.36),('14598','2013-11-17','10:00:00',1.48),('14598','2013-11-17','10:05:00',1.77),('14598','2013-11-17','10:10:00',2.02),('14598','2013-11-17','10:15:00',1.19),('14598','2013-11-17','10:20:00',1.19),('14598','2013-11-17','10:25:00',2.5),('14598','2013-11-17','10:30:00',3.15),('14598','2013-11-17','10:35:00',2.74),('14598','2013-11-17','10:40:00',2.6),('14598','2013-11-17','10:45:00',2.65),('14598','2013-11-17','10:50:00',2.68),('14598','2013-11-17','10:55:00',2.73),('14598','2013-11-17','11:00:00',2.77),('14598','2013-11-17','11:05:00',2.8),('14598','2013-11-17','11:10:00',2.86),('14598','2013-11-17','11:15:00',2.88),('14598','2013-11-17','11:20:00',2.91),('14598','2013-11-17','11:25:00',2.93),('14598','2013-11-17','11:30:00',2.95),('14598','2013-11-17','11:35:00',2.96),('14598','2013-11-17','11:40:00',2.99),('14598','2013-11-17','11:45:00',3),('14598','2013-11-17','11:50:00',3.02),('14598','2013-11-17','11:55:00',3.05),('14598','2013-11-17','12:00:00',3.05),('14598','2013-11-17','12:05:00',3.05),('14598','2013-11-17','12:10:00',3.06),('14598','2013-11-17','12:15:00',3.06),('14598','2013-11-17','12:20:00',3.08),('14598','2013-11-17','12:25:00',3.1),('14598','2013-11-17','12:30:00',3.08),('14598','2013-11-17','12:35:00',3.08),('14598','2013-11-17','12:40:00',3.05),('14598','2013-11-17','12:45:00',3.03),('14598','2013-11-17','12:50:00',3.06),('14598','2013-11-17','12:55:00',3.03),('14598','2013-11-17','13:00:00',2.98),('14598','2013-11-17','13:05:00',2.98),('14598','2013-11-17','13:10:00',2.93),('14598','2013-11-17','13:15:00',2.9),('14598','2013-11-17','13:20:00',2.88),('14598','2013-11-17','13:25:00',2.87),('14598','2013-11-17','13:30:00',2.85),('14598','2013-11-17','13:35:00',2.84),('14598','2013-11-17','13:40:00',2.82),('14598','2013-11-17','13:45:00',2.79),('14598','2013-11-17','13:50:00',2.73),('14598','2013-11-17','13:55:00',2.66),('14598','2013-11-17','14:00:00',2.57),('14598','2013-11-17','14:05:00',2.57),('14598','2013-11-17','14:10:00',2.44),('14598','2013-11-17','14:15:00',1.98),('14598','2013-11-17','14:20:00',2.25),('14598','2013-11-17','14:25:00',2.37),('14598','2013-11-17','14:30:00',2.38),('14598','2013-11-17','14:35:00',2.3),('14598','2013-11-17','14:40:00',2.2),('14598','2013-11-17','14:45:00',2.12),('14598','2013-11-17','14:50:00',2.02),('14598','2013-11-17','14:55:00',1.94),('14598','2013-11-17','15:00:00',1.86),('14598','2013-11-17','15:05:00',1.76),('14598','2013-11-17','15:10:00',1.68),('14598','2013-11-17','15:15:00',1.6),('14598','2013-11-17','15:20:00',1.46),('14598','2013-11-17','15:25:00',1.41),('14598','2013-11-17','15:30:00',1.29),('14598','2013-11-17','15:35:00',1.24),('14598','2013-11-17','15:40:00',1.15),('14598','2013-11-17','15:45:00',1.05),('14598','2013-11-15','10:25:00',1.01),('14598','2013-11-15','10:30:00',1),('14598','2013-11-15','11:45:00',1.13),('14598','2013-11-15','11:50:00',1.73),('14598','2013-11-15','11:55:00',1.91),('14598','2013-11-15','12:00:00',1.72),('14598','2013-11-15','12:05:00',1.64),('14598','2013-11-15','12:10:00',1.58),('14598','2013-11-15','12:15:00',1.3),('14598','2013-11-15','12:20:00',1.13),('14598','2013-11-15','12:25:00',1.03),('14598','2013-11-14','08:40:00',1.13),('14598','2013-11-14','08:45:00',1.16),('14598','2013-11-14','08:50:00',1.27),('14598','2013-11-14','08:55:00',1.36),('14598','2013-11-14','09:00:00',1.45),('14598','2013-11-14','09:05:00',1.52),('14598','2013-11-14','09:10:00',1.47),('14598','2013-11-14','09:20:00',1.02),('14598','2013-11-14','09:25:00',1.38),('14598','2013-11-14','09:30:00',1.3),('14598','2013-11-14','09:35:00',1.61),('14598','2013-11-14','09:40:00',1.9),('14598','2013-11-14','09:45:00',1.05),('14598','2013-11-14','09:50:00',1.66),('14598','2013-11-14','09:55:00',1.99),('14598','2013-11-14','10:00:00',2.06),('14598','2013-11-14','10:05:00',2.14),('14598','2013-11-14','10:10:00',2.28),('14598','2013-11-14','10:15:00',2.52),('14598','2013-11-14','10:20:00',2.58),('14598','2013-11-14','10:25:00',2.6),('14598','2013-11-14','10:30:00',2.63),('14598','2013-11-14','10:35:00',2.64),('14598','2013-11-14','10:40:00',2.58),('14598','2013-11-14','10:45:00',2.5),('14598','2013-11-14','10:50:00',2.56),('14598','2013-11-14','10:55:00',2.91),('14598','2013-11-14','11:00:00',3.02),('14598','2013-11-14','11:05:00',3.2),('14598','2013-11-14','11:10:00',3.41),('14598','2013-11-14','11:15:00',2.89),('14598','2013-11-14','11:20:00',2.27),('14598','2013-11-14','11:25:00',2.14),('14598','2013-11-14','11:30:00',3.41),('14598','2013-11-14','11:35:00',3.53),('14598','2013-11-14','11:40:00',2.57),('14598','2013-11-14','11:45:00',2.51),('14598','2013-11-14','11:50:00',1.69),('14598','2013-11-14','11:55:00',1.53),('14598','2013-11-14','12:00:00',1.68),('14598','2013-11-14','12:05:00',1.48),('14598','2013-11-14','12:10:00',1.81),('14598','2013-11-14','12:15:00',2.19),('14598','2013-11-14','12:20:00',1.96),('14598','2013-11-14','12:25:00',3.24),('14598','2013-11-14','12:30:00',3.64),('14598','2013-11-14','12:35:00',3.27),('14598','2013-11-14','12:40:00',2.71),('14598','2013-11-14','12:45:00',1.79),('14598','2013-11-14','12:50:00',2.48),('14598','2013-11-14','12:55:00',2.05),('14598','2013-11-14','13:00:00',1.84),('14598','2013-11-14','13:05:00',1.13),('14598','2013-11-14','13:25:00',1.36),('14598','2013-11-14','13:40:00',1.41),('14598','2013-11-14','13:45:00',2.86),('14598','2013-11-14','13:50:00',2.58),('14598','2013-11-14','13:55:00',1.41),('14598','2013-11-14','14:00:00',1.93),('14598','2013-11-14','14:05:00',1.08),('14598','2013-11-14','14:10:00',1.02),('14598','2013-11-14','14:15:00',1.7),('14598','2013-11-14','14:20:00',1.28),('14598','2013-11-13','10:10:00',1.12),('14598','2013-11-13','10:15:00',1.06),('14598','2013-11-13','10:20:00',1.37),('14598','2013-11-13','10:25:00',1.23),('14598','2013-11-13','10:30:00',1.61),('14598','2013-11-13','10:35:00',3.54),('14598','2013-11-13','10:40:00',3),('14598','2013-11-13','10:45:00',2.81),('14598','2013-11-13','10:50:00',2.66),('14598','2013-11-13','10:55:00',3.19),('14598','2013-11-13','11:00:00',1.28),('14598','2013-11-13','11:05:00',1.37),('14598','2013-11-13','11:10:00',2.44),('14598','2013-11-13','11:15:00',1.64),('14598','2013-11-13','11:20:00',1.37),('14598','2013-11-13','11:25:00',2.18),('14598','2013-11-13','11:30:00',3.05),('14598','2013-11-13','11:35:00',3.66),('14598','2013-11-13','11:40:00',2.92),('14598','2013-11-13','11:45:00',2.36),('14598','2013-11-13','11:50:00',1.37),('14598','2013-11-13','12:00:00',1.14),('14598','2013-11-13','12:05:00',1.8),('14598','2013-11-13','12:10:00',1.28),('14598','2013-11-13','12:15:00',1.39),('14598','2013-11-13','12:20:00',1.37),('14598','2013-11-13','12:25:00',1.18),('14598','2013-11-13','12:30:00',1.08),('14598','2013-11-13','12:35:00',1.02),('14598','2013-11-13','13:05:00',1.09),('14598','2013-11-13','13:10:00',1.22),('14598','2013-11-13','13:15:00',1.33),('14598','2013-11-13','13:20:00',1.41),('14598','2013-11-13','13:25:00',1.45),('14598','2013-11-13','13:30:00',1.76),('14598','2013-11-13','13:35:00',1.5),('14598','2013-11-13','13:50:00',1.09),('14598','2013-11-13','13:55:00',1.33),('14598','2013-11-13','14:00:00',1.97),('14598','2013-11-13','14:05:00',1.65),('14598','2013-11-13','14:10:00',2.24),('14598','2013-11-13','14:15:00',2.03),('14598','2013-11-13','14:20:00',2.19),('14598','2013-11-13','14:25:00',1.62),('14598','2013-11-13','14:30:00',1.78),('14598','2013-11-13','14:35:00',1.69),('14598','2013-11-13','14:40:00',1.7),('14598','2013-11-13','14:45:00',1.66),('14598','2013-11-13','14:50:00',1.14),('14598','2013-11-13','14:55:00',1.04),('14598','2013-11-13','15:05:00',1.11),('14598','2013-11-12','11:05:00',1.11),('14598','2013-11-12','11:10:00',1.04),('14598','2013-11-12','11:15:00',1.28),('14598','2013-11-12','11:20:00',1.34),('14598','2013-11-12','11:25:00',1.28),('14598','2013-11-12','11:30:00',1.41),('14598','2013-11-12','11:35:00',2.02),('14598','2013-11-12','11:40:00',1.1),('14598','2013-11-12','11:45:00',1.79),('14598','2013-11-12','11:50:00',3.66),('14598','2013-11-12','11:55:00',2.08),('14598','2013-11-12','12:00:00',1.61),('14598','2013-11-12','12:05:00',1.27),('14598','2013-11-12','12:10:00',3.47),('14598','2013-11-12','12:15:00',1.64),('14598','2013-11-12','12:20:00',1.01),('14598','2013-11-12','12:25:00',1.16),('14598','2013-11-12','12:30:00',1.02),('14598','2013-11-12','12:35:00',1.12),('14598','2013-11-12','12:40:00',2.37),('14598','2013-11-12','12:45:00',2.86),('14598','2013-11-12','12:50:00',2.59),('14598','2013-11-12','12:55:00',2.48),('14598','2013-11-12','13:00:00',2.04),('14598','2013-11-12','13:05:00',2.12),('14598','2013-11-12','13:10:00',2.89),('14598','2013-11-12','13:15:00',2.45),('14598','2013-11-12','13:20:00',1.93),('14598','2013-11-12','13:25:00',1.74),('14598','2013-11-12','13:30:00',1.82),('14598','2013-11-12','13:35:00',1.93),('14598','2013-11-12','13:40:00',2.43),('14598','2013-11-12','13:45:00',2.24),('14598','2013-11-12','13:50:00',1.82),('14598','2013-11-12','13:55:00',1.49),('14598','2013-11-12','14:00:00',1.13),('14598','2013-11-12','14:05:00',1.29),('14598','2013-11-12','14:10:00',1.65),('14598','2013-11-12','14:15:00',1.37),('14598','2013-11-12','14:20:00',2.38),('14598','2013-11-12','14:25:00',2.73),('14598','2013-11-12','14:30:00',2.62),('14598','2013-11-12','14:35:00',2.63),('14598','2013-11-12','14:40:00',2.5),('14598','2013-11-12','14:45:00',2.34),('14598','2013-11-12','14:50:00',2.3),('14598','2013-11-12','14:55:00',1.33),('14598','2013-11-11','09:05:00',1.29),('14598','2013-11-11','09:10:00',2.67),('14598','2013-11-11','09:15:00',2.58),('14598','2013-11-11','09:20:00',2.45),('14598','2013-11-11','09:25:00',2.33),('14598','2013-11-11','09:30:00',2.6),('14598','2013-11-11','09:35:00',3.14),('14598','2013-11-11','09:40:00',3.13),('14598','2013-11-11','09:45:00',3.27),('14598','2013-11-11','09:50:00',1.52),('14598','2013-11-11','09:55:00',1.92),('14598','2013-11-11','10:00:00',2.48),('14598','2013-11-11','10:05:00',2.37),('14598','2013-11-11','10:10:00',2.72),('14598','2013-11-11','10:15:00',1.84),('14598','2013-11-11','11:25:00',1.42),('14598','2013-11-11','11:30:00',3.1),('14598','2013-11-11','11:35:00',1.59),('14598','2013-11-11','11:40:00',4.29),('14598','2013-11-11','11:45:00',4),('14598','2013-11-11','11:50:00',2.96),('14598','2013-11-11','11:55:00',1.22),('14598','2013-11-11','12:00:00',1.94),('14598','2013-11-11','12:05:00',4.27),('14598','2013-11-11','12:10:00',4.15),('14598','2013-11-11','12:15:00',3.86),('14598','2013-11-11','12:20:00',3.13),('14598','2013-11-11','12:25:00',2.18),('14598','2013-11-11','13:45:00',1.01),('14598','2013-11-11','13:50:00',1.28),('14598','2013-11-11','14:05:00',2.95),('14598','2013-11-11','14:10:00',1.87),('14598','2013-11-11','15:30:00',1.2),('14598','2013-11-10','08:40:00',1.12),('14598','2013-11-10','08:45:00',1.17),('14598','2013-11-10','08:50:00',1.22),('14598','2013-11-10','09:00:00',1.2),('14598','2013-11-10','09:05:00',1.42),('14598','2013-11-10','09:10:00',1.78),('14598','2013-11-10','09:15:00',1.36),('14598','2013-11-10','09:20:00',1.39),('14598','2013-11-10','09:25:00',1.88),('14598','2013-11-10','09:30:00',2.09),('14598','2013-11-10','09:35:00',2.21),('14598','2013-11-10','09:40:00',2.08),('14598','2013-11-10','09:45:00',1.79),('14598','2013-11-10','09:50:00',2.04),('14598','2013-11-10','09:55:00',2.57),('14598','2013-11-10','10:00:00',2.22),('14598','2013-11-10','10:05:00',2.21),('14598','2013-11-10','10:10:00',2.41),('14598','2013-11-10','10:15:00',2.36),('14598','2013-11-10','10:20:00',2.67),('14598','2013-11-10','10:25:00',2.11),('14598','2013-11-10','10:30:00',1.51),('14598','2013-11-10','10:35:00',2.24),('14598','2013-11-10','10:40:00',1.79),('14598','2013-11-10','10:45:00',1.7),('14598','2013-11-10','10:50:00',1.51),('14598','2013-11-10','10:55:00',3.24),('14598','2013-11-10','11:00:00',1.23),('14598','2013-11-10','11:05:00',1.12),('14598','2013-11-10','11:10:00',1.54),('14598','2013-11-10','11:15:00',1.28),('14598','2013-11-10','11:20:00',1.07),('14598','2013-11-10','11:25:00',2.81),('14598','2013-11-10','11:30:00',3.17),('14598','2013-11-10','11:35:00',1.31),('14598','2013-11-10','11:45:00',3.3),('14598','2013-11-10','11:50:00',3.36),('14598','2013-11-10','11:55:00',3.28),('14598','2013-11-10','12:00:00',3.47),('14598','2013-11-10','12:05:00',3.32),('14598','2013-11-10','12:10:00',3.23),('14598','2013-11-10','12:15:00',3.33),('14598','2013-11-10','12:20:00',3.1),('14598','2013-11-10','12:25:00',1.09),('14598','2013-11-10','12:35:00',1.03),('14598','2013-11-10','12:40:00',1.17),('14598','2013-11-10','12:45:00',1.1),('14598','2013-11-10','12:55:00',1.2),('14598','2013-11-10','13:00:00',3.36),('14598','2013-11-10','13:05:00',1.71),('14598','2013-11-10','13:10:00',2.85),('14598','2013-11-10','13:15:00',2.12),('14598','2013-11-10','14:25:00',1.06),('14598','2013-11-10','14:30:00',1.29),('14598','2013-11-10','14:35:00',1.54),('14598','2013-11-09','08:30:00',1.06),('14598','2013-11-09','08:40:00',1.43),('14598','2013-11-09','08:45:00',1.64),('14598','2013-11-09','08:50:00',1.83),('14598','2013-11-09','08:55:00',1.36),('14598','2013-11-09','09:00:00',2.06),('14598','2013-11-09','09:05:00',2.24),('14598','2013-11-09','09:10:00',1.98),('14598','2013-11-09','09:15:00',1.89),('14598','2013-11-09','09:20:00',1.48),('14598','2013-11-09','09:25:00',2.23),('14598','2013-11-09','09:30:00',2.35),('14598','2013-11-09','09:50:00',1.1),('14598','2013-11-09','10:10:00',2.62),('14598','2013-11-09','10:15:00',2.2),('14598','2013-11-09','10:20:00',1.03),('14598','2013-11-09','10:25:00',1.14),('14598','2013-11-09','10:30:00',2.35),('14598','2013-11-09','10:35:00',1.35),('14598','2013-11-09','10:40:00',1.52),('14598','2013-11-09','10:45:00',1.09),('14598','2013-11-09','10:50:00',2.01),('14598','2013-11-09','10:55:00',1.32),('14598','2013-11-09','11:00:00',1.19),('14598','2013-11-09','11:05:00',1.08),('14598','2013-11-09','11:10:00',3.2),('14598','2013-11-09','11:15:00',3.81),('14598','2013-11-09','11:20:00',3.69),('14598','2013-11-09','11:25:00',3.07),('14598','2013-11-09','11:30:00',1.74),('14598','2013-11-09','11:35:00',1.28),('14598','2013-11-09','11:40:00',2.87),('14598','2013-11-09','11:45:00',1.61),('14598','2013-11-09','11:50:00',1.22),('14598','2013-11-09','11:55:00',2.06),('14598','2013-11-09','12:00:00',1.54),('14598','2013-11-09','12:05:00',1.1),('14598','2013-11-09','12:15:00',1.22),('14598','2013-11-09','12:20:00',1.79),('14598','2013-11-09','12:25:00',2.25),('14598','2013-11-09','12:30:00',2.52),('14598','2013-11-09','12:35:00',3.3),('14598','2013-11-09','12:40:00',1.93),('14598','2013-11-09','12:45:00',4.55),('14598','2013-11-09','12:50:00',4.17),('14598','2013-11-09','12:55:00',3.63),('14598','2013-11-09','13:00:00',3.92),('14598','2013-11-09','13:05:00',3.93),('14598','2013-11-09','13:10:00',3.91),('14598','2013-11-09','13:15:00',3.79),('14598','2013-11-09','13:20:00',3.47),('14598','2013-11-09','13:25:00',3.77),('14598','2013-11-09','13:30:00',2.57),('14598','2013-11-09','13:35:00',1.2),('14598','2013-11-09','13:40:00',1.77),('14598','2013-11-09','13:45:00',2.34),('14598','2013-11-09','13:50:00',1.94),('14598','2013-11-09','13:55:00',2.05),('14598','2013-11-09','14:00:00',1.51),('14598','2013-11-09','14:05:00',3.09),('14598','2013-11-09','14:10:00',2.84),('14598','2013-11-09','14:15:00',1.35),('14598','2013-11-09','14:55:00',2.48),('14598','2013-11-09','15:00:00',2.91),('14598','2013-11-09','15:05:00',2.29),('14598','2013-11-09','15:10:00',1.98),('14598','2013-11-09','15:15:00',1.92),('14598','2013-11-09','15:20:00',1.53),('14598','2013-11-09','15:25:00',1.57),('14598','2013-11-09','15:30:00',1.22),('14598','2013-11-09','15:35:00',1.02),('14598','2013-11-09','15:55:00',1.11),('14598','2013-11-08','08:40:00',1.1),('14598','2013-11-08','08:45:00',1.14),('14598','2013-11-08','08:50:00',1.23),('14598','2013-11-08','08:55:00',1.35),('14598','2013-11-08','09:00:00',1.41),('14598','2013-11-08','09:05:00',1.49),('14598','2013-11-08','09:10:00',1.59),('14598','2013-11-08','09:15:00',1.65),('14598','2013-11-08','09:20:00',1.77),('14598','2013-11-08','09:25:00',1.35),('14598','2013-11-08','09:30:00',1.92),('14598','2013-11-08','09:35:00',1.99),('14598','2013-11-08','09:40:00',2.03),('14598','2013-11-08','09:45:00',2.09),('14598','2013-11-08','09:50:00',2.18),('14598','2013-11-08','09:55:00',2.24),('14598','2013-11-08','10:00:00',2.32),('14598','2013-11-08','10:05:00',2.38),('14598','2013-11-08','10:10:00',2.44),('14598','2013-11-08','10:15:00',2.49),('14598','2013-11-08','10:20:00',2.57),('14598','2013-11-08','10:25:00',2.65),('14598','2013-11-08','10:30:00',2.75),('14598','2013-11-08','10:35:00',2.94),('14598','2013-11-08','10:40:00',2.76),('14598','2013-11-08','10:45:00',1.97),('14598','2013-11-08','10:50:00',2.74),('14598','2013-11-08','10:55:00',1.52),('14598','2013-11-08','11:00:00',1.95),('14598','2013-11-08','11:05:00',1.14),('14598','2013-11-08','11:10:00',3.03),('14598','2013-11-08','11:15:00',3.5),('14598','2013-11-08','11:20:00',2.67),('14598','2013-11-08','11:25:00',3.23),('14598','2013-11-08','11:30:00',3.32),('14598','2013-11-08','11:35:00',3.24),('14598','2013-11-08','11:40:00',3.22),('14598','2013-11-08','11:45:00',3.23),('14598','2013-11-08','11:50:00',3.25),('14598','2013-11-08','11:55:00',3.26),('14598','2013-11-08','12:00:00',3.26),('14598','2013-11-08','12:05:00',3.29),('14598','2013-11-08','12:10:00',3.31),('14598','2013-11-08','12:15:00',3.29),('14598','2013-11-08','12:20:00',3.3),('14598','2013-11-08','12:25:00',3.31),('14598','2013-11-08','12:30:00',3.32),('14598','2013-11-08','12:35:00',3.29),('14598','2013-11-08','12:40:00',3.29),('14598','2013-11-08','12:45:00',3.28),('14598','2013-11-08','12:50:00',3.26),('14598','2013-11-08','12:55:00',3.24),('14598','2013-11-08','13:00:00',3.21),('14598','2013-11-08','13:05:00',3.2),('14598','2013-11-08','13:10:00',3.18),('14598','2013-11-08','13:15:00',3.11),('14598','2013-11-08','13:20:00',3.12),('14598','2013-11-08','13:25:00',3.1),('14598','2013-11-08','13:30:00',3.07),('14598','2013-11-08','13:35:00',3.04),('14598','2013-11-08','13:40:00',2.99),('14598','2013-11-08','13:45:00',2.95),('14598','2013-11-08','13:50:00',2.91),('14598','2013-11-08','13:55:00',2.86),('14598','2013-11-08','14:00:00',2.81),('14598','2013-11-08','14:05:00',2.77),('14598','2013-11-08','14:10:00',2.72),('14598','2013-11-08','14:15:00',2.66),('14598','2013-11-08','14:20:00',2.62),('14598','2013-11-08','14:25:00',2.56),('14598','2013-11-08','14:30:00',2.47),('14598','2013-11-08','14:35:00',2.42),('14598','2013-11-08','14:40:00',2.35),('14598','2013-11-08','14:45:00',2.28),('14598','2013-11-08','14:50:00',2.21),('14598','2013-11-08','14:55:00',2.13),('14598','2013-11-08','15:00:00',2.04),('14598','2013-11-08','15:05:00',1.97),('14598','2013-11-08','15:10:00',1.89),('14598','2013-11-08','15:15:00',1.81),('14598','2013-11-08','15:20:00',1.73),('14598','2013-11-08','15:25:00',1.64),('14598','2013-11-08','15:30:00',1.55),('14598','2013-11-08','15:35:00',1.45),('14598','2013-11-08','15:40:00',1.37),('14598','2013-11-08','15:45:00',1.28),('14598','2013-11-08','15:50:00',1.18),('14598','2013-11-08','15:55:00',1.07),('14598','2014-04-18','08:15:00',1.21),('14598','2014-04-18','08:20:00',1.47),('14598','2014-04-18','08:25:00',1.34),('14598','2014-04-18','08:30:00',1.2),('14598','2014-04-18','08:35:00',1.1),('14598','2014-04-18','09:20:00',2.16),('14598','2014-04-18','09:25:00',2.28),('14598','2014-04-18','09:30:00',1.42),('14598','2014-04-18','09:35:00',1.29),('14598','2014-04-18','09:40:00',2.78),('14598','2014-04-18','09:45:00',2.82),('14598','2014-04-18','09:50:00',3.62),('14598','2014-04-18','09:55:00',1.82),('14598','2014-04-18','10:00:00',1.98),('14598','2014-04-18','10:05:00',2),('14598','2014-04-18','10:10:00',2.97),('14598','2014-04-18','10:15:00',2.32),('14598','2014-04-18','10:20:00',3.38),('14598','2014-04-18','10:25:00',3.85),('14598','2014-04-18','10:30:00',3.47),('14598','2014-04-18','10:35:00',2.36),('14598','2014-04-18','10:40:00',3.09),('14598','2014-04-18','10:45:00',4.16),('14598','2014-04-18','10:50:00',4.27),('14598','2014-04-18','10:55:00',3.28),('14598','2014-04-18','11:00:00',2.72),('14598','2014-04-18','11:05:00',2.13),('14598','2014-04-18','11:10:00',1.79),('14598','2014-04-18','11:15:00',2.23),('14598','2014-04-18','11:20:00',3.56),('14598','2014-04-18','11:25:00',4.94),('14598','2014-04-18','11:30:00',5.35),('14598','2014-04-18','11:35:00',5.32),('14598','2014-04-18','11:40:00',3.88),('14598','2014-04-18','11:45:00',2.75),('14598','2014-04-18','11:50:00',2.95),('14598','2014-04-18','11:55:00',2.65),('14598','2014-04-18','12:00:00',2.59),('14598','2014-04-18','12:05:00',2.8),('14598','2014-04-18','12:10:00',3.62),('14598','2014-04-18','12:15:00',4.19),('14598','2014-04-18','12:20:00',3),('14598','2014-04-18','12:25:00',2.34),('14598','2014-04-18','12:30:00',5.02),('14598','2014-04-18','12:35:00',3.6),('14598','2014-04-18','12:40:00',3.01),('14598','2014-04-18','12:45:00',5.61),('14598','2014-04-18','12:50:00',4.29),('14598','2014-04-18','12:55:00',2.84),('14598','2014-04-18','13:00:00',3.79),('14598','2014-04-18','13:05:00',3),('14598','2014-04-18','13:10:00',2.78),('14598','2014-04-18','13:15:00',3.11),('14598','2014-04-18','13:20:00',3.68),('14598','2014-04-18','13:25:00',4),('14598','2014-04-18','13:30:00',3.87),('14598','2014-04-18','13:35:00',5),('14598','2014-04-18','13:40:00',2.89),('14598','2014-04-18','13:45:00',2.59),('14598','2014-04-18','13:50:00',2.85),('14598','2014-04-18','13:55:00',3.29),('14598','2014-04-18','14:00:00',2.5),('14598','2014-04-18','14:05:00',4.8),('14598','2014-04-18','14:10:00',5.39),('14598','2014-04-18','14:15:00',3.37),('14598','2014-04-18','14:20:00',2.44),('14598','2014-04-18','14:25:00',3.7),('14598','2014-04-18','14:30:00',3.99),('14598','2014-04-18','14:35:00',2.88),('14598','2014-04-18','14:40:00',3.15),('14598','2014-04-18','14:45:00',5.01),('14598','2014-04-18','14:50:00',4.01),('14598','2014-04-18','14:55:00',4.78),('14598','2014-04-18','15:00:00',4.94),('14598','2014-04-18','15:05:00',4.67),('14598','2014-04-18','15:10:00',4.97),('14598','2014-04-18','15:15:00',4.93),('14598','2014-04-18','15:20:00',4.63),('14598','2014-04-18','15:25:00',4.83),('14598','2014-04-18','15:30:00',4.92),('14598','2014-04-18','15:35:00',2.45),('14598','2014-04-18','15:40:00',3.07),('14598','2014-04-18','15:45:00',4.5),('14598','2014-04-18','15:50:00',3.44),('14598','2014-04-18','15:55:00',4.57),('14598','2014-04-18','16:00:00',4.4),('14598','2014-04-18','16:05:00',4.3),('14598','2014-04-18','16:10:00',4.24),('14598','2014-04-18','16:15:00',4.16),('14598','2014-04-18','16:20:00',4.08),('14598','2014-04-18','16:25:00',4.01),('14598','2014-04-18','16:30:00',3.93),('14598','2014-04-18','16:35:00',3.83),('14598','2014-04-18','16:40:00',3.74),('14598','2014-04-18','16:45:00',3.67),('14598','2014-04-18','16:50:00',3.6),('14598','2014-04-18','16:55:00',3.49),('14598','2014-04-18','17:00:00',3.32),('14598','2014-04-18','17:05:00',3.32),('14598','2014-04-18','17:10:00',3.23),('14598','2014-04-18','17:15:00',3.11),('14598','2014-04-18','17:20:00',3.01),('14598','2014-04-18','17:25:00',2.92),('14598','2014-04-18','17:30:00',2.8),('14598','2014-04-18','17:35:00',2.7),('14598','2014-04-18','17:40:00',2.6),('14598','2014-04-18','17:45:00',2.5),('14598','2014-04-18','17:50:00',2.39),('14598','2014-04-18','17:55:00',2.29),('14598','2014-04-18','18:00:00',2.19),('14598','2014-04-18','18:05:00',2.08),('14598','2014-04-18','18:10:00',1.98),('14598','2014-04-18','18:15:00',1.87),('14598','2014-04-18','18:20:00',1.76),('14598','2014-04-18','18:25:00',1.65),('14598','2014-04-18','18:30:00',1.56),('14598','2014-04-18','18:35:00',1.44),('14598','2014-04-18','18:40:00',1.32),('14598','2014-04-18','18:45:00',1.12),('14598','2013-11-07','08:35:00',1.03),('14598','2013-11-07','08:40:00',1.12),('14598','2013-11-07','08:45:00',1.22),('14598','2013-11-07','08:50:00',1.31),('14598','2013-11-07','08:55:00',1.39),('14598','2013-11-07','09:00:00',1.49),('14598','2013-11-07','09:05:00',1.58),('14598','2013-11-07','09:10:00',1.66),('14598','2013-11-07','09:15:00',1.74),('14598','2013-11-07','09:20:00',1.82),('14598','2013-11-07','09:25:00',1.9),('14598','2013-11-07','09:30:00',1.97),('14598','2013-11-07','09:35:00',2.04),('14598','2013-11-07','09:40:00',2.04),('14598','2013-11-07','09:45:00',2.16),('14598','2013-11-07','09:50:00',2.24),('14598','2013-11-07','09:55:00',2.3),('14598','2013-11-07','10:00:00',2.37),('14598','2013-11-07','10:05:00',2.45),('14598','2013-11-07','10:10:00',2.51),('14598','2013-11-07','10:15:00',2.55),('14598','2013-11-07','10:20:00',2.59),('14598','2013-11-07','10:25:00',2.66),('14598','2013-11-07','10:30:00',2.7),('14598','2013-11-07','10:35:00',2.74),('14598','2013-11-07','10:40:00',2.79),('14598','2013-11-07','10:45:00',2.83),('14598','2013-11-07','10:50:00',2.87),('14598','2013-11-07','10:55:00',2.87),('14598','2013-11-07','11:00:00',2.94),('14598','2013-11-07','11:05:00',2.97),('14598','2013-11-07','11:10:00',2.99),('14598','2013-11-07','11:15:00',3.03),('14598','2013-11-07','11:20:00',3.04),('14598','2013-11-07','11:25:00',3.07),('14598','2013-11-07','11:30:00',3.12),('14598','2013-11-07','11:35:00',3.17),('14598','2013-11-07','11:40:00',3.21),('14598','2013-11-07','11:45:00',3.23),('14598','2013-11-07','11:50:00',3.24),('14598','2013-11-07','11:55:00',3.24),('14598','2013-11-07','12:00:00',3.27),('14598','2013-11-07','12:05:00',3.28),('14598','2013-11-07','12:10:00',3.29),('14598','2013-11-07','12:15:00',3.3),('14598','2013-11-07','12:20:00',3.28),('14598','2013-11-07','12:25:00',1.77),('14598','2013-11-07','12:30:00',1.62),('14598','2013-11-07','12:35:00',1.99),('14598','2013-11-07','12:40:00',3.29),('14598','2013-11-07','12:45:00',3.27),('14598','2013-11-07','12:50:00',3.28),('14598','2013-11-07','12:55:00',3.24),('14598','2013-11-07','13:00:00',3.2),('14598','2013-11-07','13:05:00',3.2),('14598','2013-11-07','13:10:00',3.19),('14598','2013-11-07','13:15:00',3.15),('14598','2013-11-07','13:20:00',3.12),('14598','2013-11-07','13:25:00',3.09),('14598','2013-11-07','13:30:00',3.08),('14598','2013-11-07','13:35:00',3.01),('14598','2013-11-07','13:40:00',2.97),('14598','2013-11-07','13:45:00',2.94),('14598','2013-11-07','13:50:00',2.89),('14598','2013-11-07','13:55:00',2.86),('14598','2013-11-07','14:00:00',2.77),('14598','2013-11-07','14:05:00',2.73),('14598','2013-11-07','14:10:00',2.65),('14598','2013-11-07','14:15:00',2.6),('14598','2013-11-07','14:20:00',2.56),('14598','2013-11-07','14:25:00',2.49),('14598','2013-11-07','14:30:00',2.45),('14598','2013-11-07','14:35:00',2.39),('14598','2013-11-07','14:40:00',2.34),('14598','2013-11-07','14:45:00',2.26),('14598','2013-11-07','14:50:00',2.19),('14598','2013-11-07','14:55:00',2.12),('14598','2013-11-07','15:00:00',2.05),('14598','2013-11-07','15:05:00',1.96),('14598','2013-11-07','15:10:00',1.88),('14598','2013-11-07','15:15:00',1.79),('14598','2013-11-07','15:20:00',1.73),('14598','2013-11-07','15:25:00',1.64),('14598','2013-11-07','15:30:00',1.55),('14598','2013-11-07','15:35:00',1.45),('14598','2013-11-07','15:40:00',1.36),('14598','2013-11-07','15:45:00',1.25),('14598','2013-11-07','15:50:00',1.15),('14598','2013-11-07','15:55:00',1.03),('14598','2013-11-06','08:40:00',1.17),('14598','2013-11-06','08:45:00',1.26),('14598','2013-11-06','08:50:00',1.37),('14598','2013-11-06','08:55:00',1.42),('14598','2013-11-06','09:00:00',1.52),('14598','2013-11-06','09:05:00',1.66),('14598','2013-11-06','09:10:00',1.75),('14598','2013-11-06','09:15:00',1.83),('14598','2013-11-06','09:20:00',1.92),('14598','2013-11-06','09:25:00',1.99),('14598','2013-11-06','09:30:00',2.08),('14598','2013-11-06','09:35:00',2.15),('14598','2013-11-06','09:40:00',2.23),('14598','2013-11-06','09:45:00',2.3),('14598','2013-11-06','09:50:00',2.36),('14598','2013-11-06','09:55:00',2.43),('14598','2013-11-06','10:00:00',2.49),('14598','2013-11-06','10:05:00',2.55),('14598','2013-11-06','10:10:00',2.61),('14598','2013-11-06','10:15:00',2.66),('14598','2013-11-06','10:20:00',2.71),('14598','2013-11-06','10:25:00',2.76),('14598','2013-11-06','10:30:00',2.82),('14598','2013-11-06','10:35:00',2.86),('14598','2013-11-06','10:40:00',2.85),('14598','2013-11-06','10:45:00',2.95),('14598','2013-11-06','10:50:00',2.99),('14598','2013-11-06','10:55:00',3.03),('14598','2013-11-06','11:00:00',3.08),('14598','2013-11-06','11:05:00',3.11),('14598','2013-11-06','11:10:00',3.15),('14598','2013-11-06','11:15:00',3.18),('14598','2013-11-06','11:20:00',3.2),('14598','2013-11-06','11:25:00',3.22),('14598','2013-11-06','11:30:00',3.26),('14598','2013-11-06','11:35:00',3.29),('14598','2013-11-06','11:40:00',3.32),('14598','2013-11-06','11:45:00',3.35),('14598','2013-11-06','11:50:00',3.36),('14598','2013-11-06','11:55:00',3.35),('14598','2013-11-06','12:00:00',3.35),('14598','2013-11-06','12:05:00',3.37),('14598','2013-11-06','12:10:00',3.37),('14598','2013-11-06','12:15:00',3.37),('14598','2013-11-06','12:20:00',3.38),('14598','2013-11-06','12:25:00',3.37),('14598','2013-11-06','12:30:00',3.35),('14598','2013-11-06','12:35:00',3.35),('14598','2013-11-06','12:40:00',3.34),('14598','2013-11-06','12:45:00',3.32),('14598','2013-11-06','12:50:00',3.31),('14598','2013-11-06','12:55:00',3.29),('14598','2013-11-06','13:00:00',3.29),('14598','2013-11-06','13:05:00',3.26),('14598','2013-11-06','13:10:00',3.23),('14598','2013-11-06','13:15:00',3.22),('14598','2013-11-06','13:20:00',3.19),('14598','2013-11-06','13:25:00',3.16),('14598','2013-11-06','13:30:00',3.13),('14598','2013-11-06','13:35:00',3.09),('14598','2013-11-06','13:40:00',3.02),('14598','2013-11-06','13:45:00',2.93),('14598','2013-11-06','13:50:00',2.93),('14598','2013-11-06','13:55:00',2.94),('14598','2013-11-06','14:00:00',2.9),('14598','2013-11-06','14:05:00',2.85),('14598','2013-11-06','14:10:00',2.81),('14598','2013-11-06','14:15:00',2.77),('14598','2013-11-06','14:20:00',2.72),('14598','2013-11-06','14:25:00',2.66),('14598','2013-11-06','14:30:00',2.6),('14598','2013-11-06','14:35:00',2.55),('14598','2013-11-06','14:40:00',2.48),('14598','2013-11-06','14:45:00',2.4),('14598','2013-11-06','14:50:00',2.32),('14598','2013-11-06','14:55:00',2.24),('14598','2013-11-06','15:00:00',2.14),('14598','2013-11-06','15:05:00',2.08),('14598','2013-11-06','15:10:00',2),('14598','2013-11-06','15:15:00',1.93),('14598','2013-11-06','15:20:00',1.85),('14598','2013-11-06','15:25:00',1.75),('14598','2013-11-06','15:30:00',1.66),('14598','2013-11-06','15:35:00',1.57),('14598','2013-11-06','15:40:00',1.46),('14598','2013-11-06','15:45:00',1.37),('14598','2013-11-06','15:50:00',1.27),('14598','2013-11-06','15:55:00',1.17),('14598','2013-11-06','16:00:00',1.07),('14598','2013-11-05','10:00:00',1.04),('14598','2013-11-05','10:05:00',1.44),('14598','2013-11-05','10:10:00',1.64),('14598','2013-11-05','10:15:00',1.6),('14598','2013-11-05','10:20:00',1.11),('14598','2013-11-05','10:40:00',1.01),('14598','2013-11-05','10:45:00',1.07),('14598','2013-11-05','10:50:00',1.13),('14598','2013-11-05','10:55:00',1.15),('14598','2013-11-05','11:00:00',1.22),('14598','2013-11-05','11:05:00',1.19),('14598','2013-11-05','11:10:00',1.26),('14598','2013-11-05','11:15:00',1.29),('14598','2013-11-05','11:20:00',1.14),('14598','2013-11-05','11:25:00',1.35),('14598','2013-11-05','11:30:00',1.56),('14598','2013-11-05','11:35:00',1.67),('14598','2013-11-05','11:40:00',1.72),('14598','2013-11-05','11:45:00',1.65),('14598','2013-11-05','11:50:00',1.78),('14598','2013-11-05','11:55:00',2.22),('14598','2013-11-05','12:00:00',1.87),('14598','2013-11-05','12:05:00',1.42),('14598','2013-11-05','12:10:00',1.47),('14598','2013-11-05','12:15:00',1.5),('14598','2013-11-05','12:20:00',1.71),('14598','2013-11-05','12:25:00',1.25),('14598','2013-11-05','12:30:00',1.13),('14598','2013-11-05','12:35:00',1.18),('14598','2013-11-05','12:40:00',1.33),('14598','2013-11-05','12:45:00',1.76),('14598','2013-11-05','12:50:00',1.99),('14598','2013-11-05','12:55:00',1.96),('14598','2013-11-05','13:00:00',1.62),('14598','2013-11-05','13:05:00',1.48),('14598','2013-11-05','13:10:00',1.67),('14598','2013-11-05','13:15:00',1.83),('14598','2013-11-05','13:20:00',1.99),('14598','2013-11-05','13:25:00',1.73),('14598','2013-11-05','13:30:00',2.73),('14598','2013-11-05','13:35:00',3.44),('14598','2013-11-05','13:40:00',2.43),('14598','2013-11-05','13:45:00',1.83),('14598','2013-11-05','13:50:00',1.5),('14598','2013-11-05','13:55:00',1.43),('14598','2013-11-05','14:00:00',1.98),('14598','2013-11-05','14:05:00',1.74),('14598','2013-11-05','14:10:00',2.32),('14598','2013-11-05','14:15:00',2.86),('14598','2013-11-05','14:20:00',2.93),('14598','2013-11-05','14:25:00',3.03),('14598','2013-11-05','14:30:00',2.08),('14598','2013-11-05','14:35:00',1.53),('14598','2013-11-05','14:40:00',1.2),('14598','2013-11-05','14:45:00',1.64),('14598','2013-11-05','14:50:00',1.19),('14598','2013-11-05','14:55:00',2.24),('14598','2013-11-05','15:00:00',2.67),('14598','2013-11-05','15:05:00',2.32),('14598','2013-11-05','15:10:00',2.03),('14598','2013-11-05','15:15:00',1.98),('14598','2013-11-05','15:20:00',1.83),('14598','2013-11-05','15:25:00',1.72),('14598','2013-11-05','15:30:00',1.34),('14598','2013-11-05','15:55:00',1.12),('14598','2013-11-05','16:00:00',1.12),('14598','2013-11-04','08:30:00',1.02),('14598','2013-11-04','09:25:00',1.42),('14598','2013-11-04','09:30:00',2.15),('14598','2013-11-04','09:35:00',2.18),('14598','2013-11-04','09:40:00',1.51),('14598','2013-11-04','09:45:00',1.71),('14598','2013-11-04','09:50:00',2.22),('14598','2013-11-04','09:55:00',1.8),('14598','2013-11-04','10:05:00',2.71),('14598','2013-11-04','10:10:00',2.76),('14598','2013-11-04','10:15:00',2.11),('14598','2013-11-04','10:20:00',2.1),('14598','2013-11-04','10:25:00',1.15),('14598','2013-11-04','10:40:00',1.62),('14598','2013-11-04','10:45:00',2.22),('14598','2013-11-04','10:50:00',2.58),('14598','2013-11-04','10:55:00',3.36),('14598','2013-11-04','11:00:00',3.31),('14598','2013-11-04','11:05:00',1.54),('14598','2013-11-04','11:15:00',1.26),('14598','2013-11-04','11:20:00',2.83),('14598','2013-11-04','11:25:00',2.77),('14598','2013-11-04','11:30:00',1.01),('14598','2013-11-04','11:35:00',1.24),('14598','2013-11-04','12:05:00',3.82),('14598','2013-11-04','12:10:00',3.72),('14598','2013-11-04','12:15:00',3.62),('14598','2013-11-04','12:20:00',3.56),('14598','2013-11-04','12:25:00',3.59),('14598','2013-11-04','12:30:00',3.28),('14598','2013-11-04','12:35:00',2.6),('14598','2013-11-04','12:40:00',3.23),('14598','2013-11-04','12:45:00',3.9),('14598','2013-11-04','12:50:00',3.94),('14598','2013-11-04','12:55:00',3.38),('14598','2013-11-04','13:00:00',3.8),('14598','2013-11-04','13:05:00',3.17),('14598','2013-11-04','13:10:00',2.19),('14598','2013-11-04','13:15:00',2.53),('14598','2013-11-04','13:20:00',2),('14598','2013-11-04','13:25:00',2.91),('14598','2013-11-04','13:30:00',2.55),('14598','2013-11-04','13:40:00',2.41),('14598','2013-11-04','13:45:00',2.54),('14598','2013-11-04','13:50:00',1.55),('14598','2013-11-04','13:55:00',1.82),('14598','2013-11-04','14:20:00',1.26),('14598','2013-11-04','14:25:00',1.45),('14598','2013-11-04','14:30:00',1.82),('14598','2013-11-04','14:35:00',1.1),('14598','2013-11-04','14:40:00',1.32),('14598','2013-11-04','14:50:00',1.14),('14598','2013-11-04','14:55:00',1.67),('14598','2013-11-04','15:00:00',1.3),('14598','2013-11-04','15:05:00',1.16),('14598','2013-11-04','15:10:00',1.3),('14598','2013-11-04','15:15:00',2.19),('14598','2013-11-04','15:20:00',1.88),('14598','2013-11-04','15:25:00',1.76),('14598','2013-11-04','15:30:00',1.74),('14598','2013-11-04','15:35:00',1.54),('14598','2013-11-04','15:40:00',1.44),('14598','2013-11-04','15:45:00',1.36),('14598','2013-11-04','15:50:00',1.18),('14598','2013-11-04','15:55:00',1.01),('14598','2013-11-03','08:30:00',1.09),('14598','2013-11-03','08:35:00',1.06),('14598','2013-11-03','08:45:00',1.03),('14598','2013-11-03','09:05:00',1.69),('14598','2013-11-03','09:25:00',1.1),('14598','2013-11-03','09:30:00',1.85),('14598','2013-11-03','09:35:00',1.75),('14598','2013-11-03','09:40:00',1.91),('14598','2013-11-03','09:45:00',2.14),('14598','2013-11-03','09:50:00',2.26),('14598','2013-11-03','09:55:00',2.33),('14598','2013-11-03','10:00:00',2.4),('14598','2013-11-03','10:05:00',1.8),('14598','2013-11-03','10:10:00',2.92),('14598','2013-11-03','10:15:00',2.69),('14598','2013-11-03','10:20:00',1.37),('14598','2013-11-03','10:30:00',1.66),('14598','2013-11-03','10:35:00',1.23),('14598','2013-11-03','10:40:00',1.35),('14598','2013-11-03','10:45:00',1.86),('14598','2013-11-03','10:50:00',1.87),('14598','2013-11-03','10:55:00',2.33),('14598','2013-11-03','11:05:00',1.75),('14598','2013-11-03','11:10:00',2.77),('14598','2013-11-03','11:25:00',1.82),('14598','2013-11-03','11:30:00',3.79),('14598','2013-11-03','11:35:00',1.69),('14598','2013-11-03','11:40:00',2.07),('14598','2013-11-03','11:45:00',4.19),('14598','2013-11-03','11:50:00',3.04),('14598','2013-11-03','11:55:00',2.58),('14598','2013-11-03','12:00:00',1.22),('14598','2013-11-03','12:05:00',2.64),('14598','2013-11-03','12:10:00',1.77),('14598','2013-11-03','12:25:00',1.65),('14598','2013-11-03','12:30:00',1.63),('14598','2013-11-03','12:35:00',1.32),('14598','2013-11-03','12:40:00',1.21),('14598','2013-11-03','12:45:00',1.38),('14598','2013-11-03','12:50:00',1.37),('14598','2013-11-03','12:55:00',1.67),('14598','2013-11-03','13:00:00',2.48),('14598','2013-11-03','13:05:00',1.16),('14598','2013-11-03','13:15:00',1.13),('14598','2013-11-03','13:20:00',2.08),('14598','2013-11-03','13:25:00',1.92),('14598','2013-11-03','13:30:00',2.77),('14598','2013-11-03','13:35:00',3.77),('14598','2013-11-03','13:40:00',3.2),('14598','2013-11-03','14:10:00',1.26),('14598','2013-11-03','14:15:00',2.66),('14598','2013-11-03','14:20:00',2.53),('14598','2013-11-03','14:25:00',2.63),('14598','2013-11-03','14:30:00',1.56),('14598','2013-11-03','14:35:00',1.08),('14598','2013-11-03','14:40:00',1.56),('14598','2013-11-03','14:50:00',1.12),('14598','2013-11-03','15:00:00',1.25),('14598','2013-11-03','15:05:00',1.8),('14598','2013-11-03','15:10:00',1.73),('14598','2013-11-03','15:15:00',1.32),('14598','2013-11-03','15:20:00',1.19),('14598','2013-11-03','15:25:00',1.69),('14598','2013-11-02','08:15:00',1.09),('14598','2013-11-02','08:20:00',1.23),('14598','2013-11-02','08:25:00',1.32),('14598','2013-11-02','08:30:00',1.37),('14598','2013-11-02','09:05:00',1.07),('14598','2013-11-02','09:20:00',1.77),('14598','2013-11-02','09:25:00',1.69),('14598','2013-11-02','09:30:00',1.63),('14598','2013-11-02','09:35:00',1.17),('14598','2013-11-02','09:40:00',1.16),('14598','2013-11-02','10:15:00',3.4),('14598','2013-11-02','10:20:00',2.56),('14598','2013-11-02','10:25:00',3.36),('14598','2013-11-02','10:30:00',3.13),('14598','2013-11-02','10:35:00',2.95),('14598','2013-11-02','10:40:00',3.13),('14598','2013-11-02','10:45:00',1.54),('14598','2013-11-02','10:55:00',2.74),('14598','2013-11-02','11:00:00',2.17),('14598','2013-11-02','11:05:00',2.94),('14598','2013-11-02','11:10:00',3.22),('14598','2013-11-02','11:15:00',3.17),('14598','2013-11-02','11:20:00',2.56),('14598','2013-11-02','11:25:00',1.28),('14598','2013-11-02','11:50:00',1.58),('14598','2013-11-02','11:55:00',2.38),('14598','2013-11-02','12:00:00',3.58),('14598','2013-11-02','12:05:00',2.78),('14598','2013-11-02','12:10:00',1.02),('14598','2013-11-02','12:15:00',1.81),('14598','2013-11-02','12:20:00',3.72),('14598','2013-11-02','12:25:00',3.81),('14598','2013-11-02','12:30:00',2.96),('14598','2013-11-02','12:35:00',1.16),('14598','2013-11-02','12:55:00',1.12),('14598','2013-11-02','13:00:00',2.49),('14598','2013-11-02','13:05:00',4.09),('14598','2013-11-02','13:10:00',3.56),('14598','2013-11-02','13:15:00',3.29),('14598','2013-11-02','13:20:00',3.45),('14598','2013-11-02','13:25:00',3.22),('14598','2013-11-02','13:30:00',3.15),('14598','2013-11-02','13:35:00',3.1),('14598','2013-11-02','13:40:00',3.07),('14598','2013-11-02','13:45:00',3.06),('14598','2013-11-02','13:50:00',3.01),('14598','2013-11-02','13:55:00',2.94),('14598','2013-11-02','14:00:00',2.92),('14598','2013-11-02','14:05:00',2.86),('14598','2013-11-02','14:10:00',2.76),('14598','2013-11-02','14:15:00',2.75),('14598','2013-11-02','14:20:00',2.71),('14598','2013-11-02','14:25:00',2.66),('14598','2013-11-02','14:30:00',2.59),('14598','2013-11-02','14:35:00',2.53),('14598','2013-11-02','14:40:00',2.42),('14598','2013-11-02','14:45:00',2.37),('14598','2013-11-02','14:50:00',2.21),('14598','2013-11-02','14:55:00',2.13),('14598','2013-11-02','15:05:00',1.56),('14598','2013-11-02','15:10:00',1.97),('14598','2013-11-02','15:15:00',1.87),('14598','2013-11-02','15:20:00',1.48),('14598','2013-11-02','15:25:00',1.52),('14598','2013-11-02','15:30:00',1.49),('14598','2013-11-02','15:35:00',1.4),('14598','2013-11-01','08:35:00',1.06),('14598','2013-11-01','08:40:00',1.23),('14598','2013-11-01','08:45:00',1.32),('14598','2013-11-01','08:50:00',1.41),('14598','2013-11-01','08:55:00',1.49),('14598','2013-11-01','09:00:00',1.58),('14598','2013-11-01','09:05:00',1.65),('14598','2013-11-01','09:10:00',1.76),('14598','2013-11-01','09:15:00',1.83),('14598','2013-11-01','09:20:00',1.91),('14598','2013-11-01','09:25:00',1.99),('14598','2013-11-01','09:30:00',2.07),('14598','2013-11-01','09:35:00',2.15),('14598','2013-11-01','09:40:00',2.23),('14598','2013-11-01','09:45:00',2.33),('14598','2013-11-01','09:50:00',2.4),('14598','2013-11-01','09:55:00',2.48),('14598','2013-11-01','10:00:00',2.57),('14598','2013-11-01','10:05:00',2.66),('14598','2013-11-01','10:10:00',2.72),('14598','2013-11-01','10:15:00',2.77),('14598','2013-11-01','10:20:00',2.83),('14598','2013-11-01','10:25:00',2.83),('14598','2013-11-01','10:30:00',2.78),('14598','2013-11-01','10:35:00',2.69),('14598','2013-11-01','10:40:00',2.77),('14598','2013-11-01','10:45:00',2.95),('14598','2013-11-01','10:50:00',3.11),('14598','2013-11-01','10:55:00',3.14),('14598','2013-11-01','11:00:00',2.85),('14598','2013-11-01','11:05:00',2.58),('14598','2013-11-01','11:10:00',2.01),('14598','2013-11-01','11:15:00',2.56),('14598','2013-11-01','11:20:00',2.48),('14598','2013-11-01','11:25:00',2.17),('14598','2013-11-01','11:30:00',2.91),('14598','2013-11-01','11:35:00',3.13),('14598','2013-11-01','11:40:00',3.08),('14598','2013-11-01','11:45:00',2.85),('14598','2013-11-01','11:50:00',3.27),('14598','2013-11-01','11:55:00',3.54),('14598','2013-11-01','12:00:00',3.53),('14598','2013-11-01','12:05:00',3.45),('14598','2013-11-01','12:10:00',3.46),('14598','2013-11-01','12:15:00',1.87),('14598','2013-11-01','12:20:00',1.59),('14598','2013-11-01','12:25:00',2.99),('14598','2013-11-01','12:30:00',2.83),('14598','2013-11-01','12:35:00',2.69),('14598','2013-11-01','12:40:00',2.44),('14598','2013-11-01','12:45:00',2.18),('14598','2013-11-01','12:50:00',1.78),('14598','2013-11-01','12:55:00',1.77),('14598','2013-11-01','13:00:00',2.09),('14598','2013-11-01','13:05:00',1.5),('14598','2013-11-01','13:10:00',1.01),('14598','2013-11-01','13:55:00',1.17),('14598','2013-11-01','14:00:00',1.64),('14598','2013-11-01','14:05:00',2.68),('14598','2013-11-01','14:10:00',2.62),('14598','2013-11-01','14:15:00',2.31),('14598','2013-11-01','14:20:00',1.66),('14598','2013-11-01','14:25:00',1.02),('14598','2013-11-01','14:55:00',1.15),('14598','2013-11-01','15:00:00',1.7),('14598','2013-11-01','15:05:00',1.56),('14598','2013-11-01','15:10:00',1.54),('14598','2013-11-01','15:15:00',1.52),('14598','2013-11-01','15:20:00',1.31),('14598','2013-11-01','15:25:00',1.09),('14598','2013-11-01','15:45:00',1.04),('14598','2013-11-01','15:50:00',1),('14598','2013-10-31','08:40:00',1.15),('14598','2013-10-31','08:45:00',1.35),('14598','2013-10-31','08:50:00',1.44),('14598','2013-10-31','08:55:00',1.5),('14598','2013-10-31','09:00:00',1.6),('14598','2013-10-31','09:05:00',1.68),('14598','2013-10-31','09:10:00',1.68),('14598','2013-10-31','09:15:00',1.75),('14598','2013-10-31','09:20:00',1.86),('14598','2013-10-31','09:25:00',1.92),('14598','2013-10-31','09:30:00',1.48),('14598','2013-10-31','09:35:00',1.8),('14598','2013-10-31','09:40:00',1.93),('14598','2013-10-31','09:45:00',2.12),('14598','2013-10-31','09:50:00',2.33),('14598','2013-10-31','09:55:00',2.46),('14598','2013-10-31','10:00:00',2.52),('14598','2013-10-31','10:05:00',2.55),('14598','2013-10-31','10:10:00',2.6),('14598','2013-10-31','10:15:00',2.66),('14598','2013-10-31','10:20:00',2.73),('14598','2013-10-31','10:25:00',2.8),('14598','2013-10-31','10:30:00',2.87),('14598','2013-10-31','10:35:00',2.89),('14598','2013-10-31','10:40:00',2.92),('14598','2013-10-31','10:45:00',2.96),('14598','2013-10-31','10:50:00',3),('14598','2013-10-31','10:55:00',3.02),('14598','2013-10-31','11:00:00',3),('14598','2013-10-31','11:05:00',3),('14598','2013-10-31','11:10:00',2.95),('14598','2013-10-31','11:15:00',3),('14598','2013-10-31','11:20:00',2.94),('14598','2013-10-31','11:25:00',2.88),('14598','2013-10-31','11:30:00',2.96),('14598','2013-10-31','11:35:00',3.08),('14598','2013-10-31','11:40:00',3.21),('14598','2013-10-31','11:45:00',3.22),('14598','2013-10-31','11:50:00',3.29),('14598','2013-10-31','11:55:00',3.38),('14598','2013-10-31','12:00:00',3.4),('14598','2013-10-31','12:05:00',3.39),('14598','2013-10-31','12:10:00',3.41),('14598','2013-10-31','12:15:00',3.45),('14598','2013-10-31','12:20:00',3.36),('14598','2013-10-31','12:25:00',3.39),('14598','2013-10-31','12:30:00',3.36),('14598','2013-10-31','12:35:00',3.3),('14598','2013-10-31','12:40:00',3.3),('14598','2013-10-31','12:45:00',3.27),('14598','2013-10-31','12:50:00',3.24),('14598','2013-10-31','12:55:00',3.2),('14598','2013-10-31','13:00:00',3.18),('14598','2013-10-31','13:05:00',3.18),('14598','2013-10-31','13:10:00',3.03),('14598','2013-10-31','13:15:00',3.07),('14598','2013-10-31','13:20:00',2.97),('14598','2013-10-31','13:25:00',2.43),('14598','2013-10-31','13:30:00',2.5),('14598','2013-10-31','13:35:00',2.89),('14598','2013-10-31','13:40:00',2.99),('14598','2013-10-31','13:45:00',2.83),('14598','2013-10-31','13:50:00',2.84),('14598','2013-10-31','13:55:00',2.84),('14598','2013-10-31','14:00:00',2.72),('14598','2013-10-31','14:05:00',2.73),('14598','2013-10-31','14:10:00',2.68),('14598','2013-10-31','14:15:00',2.63),('14598','2013-10-31','14:20:00',2.54),('14598','2013-10-31','14:25:00',2.4),('14598','2013-10-31','14:30:00',2.32),('14598','2013-10-31','14:35:00',2.22),('14598','2013-10-31','14:40:00',2.06),('14598','2013-10-31','14:45:00',1.78),('14598','2013-10-31','14:50:00',1.69),('14598','2013-10-31','14:55:00',1.67),('14598','2013-10-31','15:00:00',1.62),('14598','2013-10-31','15:05:00',1.56),('14598','2013-10-31','15:10:00',1.54),('14598','2013-10-31','15:15:00',1.58),('14598','2013-10-31','15:20:00',1.33),('14598','2013-10-31','15:25:00',1.23),('14598','2013-10-31','15:30:00',1.12),('14598','2013-10-31','15:35:00',1.11),('14598','2013-10-31','15:40:00',1.08),('14598','2013-10-30','08:50:00',1.04),('14598','2013-10-30','08:55:00',1.33),('14598','2013-10-30','09:10:00',1.02),('14598','2013-10-30','09:15:00',1.04),('14598','2013-10-30','09:20:00',1.27),('14598','2013-10-30','09:25:00',1.28),('14598','2013-10-30','09:30:00',1.27),('14598','2013-10-30','09:35:00',1.13),('14598','2013-10-30','09:40:00',1.44),('14598','2013-10-30','09:45:00',1.5),('14598','2013-10-30','09:50:00',1.51),('14598','2013-10-30','09:55:00',1.55),('14598','2013-10-30','10:00:00',1.96),('14598','2013-10-30','10:05:00',1.47),('14598','2013-10-30','10:10:00',2.45),('14598','2013-10-30','10:15:00',2.77),('14598','2013-10-30','10:20:00',2.84),('14598','2013-10-30','10:25:00',2.73),('14598','2013-10-30','10:30:00',2.69),('14598','2013-10-30','10:35:00',2.91),('14598','2013-10-30','10:40:00',2.81),('14598','2013-10-30','10:45:00',2.81),('14598','2013-10-30','10:50:00',2.64),('14598','2013-10-30','10:55:00',2.82),('14598','2013-10-30','11:00:00',3.02),('14598','2013-10-30','11:05:00',3.05),('14598','2013-10-30','11:10:00',3.08),('14598','2013-10-30','11:15:00',3.06),('14598','2013-10-30','11:20:00',3.17),('14598','2013-10-30','11:25:00',3.2),('14598','2013-10-30','11:30:00',1.65),('14598','2013-10-30','11:35:00',1.82),('14598','2013-10-30','11:40:00',2.72),('14598','2013-10-30','11:45:00',3.2),('14598','2013-10-30','11:50:00',3.43),('14598','2013-10-30','11:55:00',3.48),('14598','2013-10-30','12:00:00',3.56),('14598','2013-10-30','12:05:00',3.39),('14598','2013-10-30','12:10:00',3.37),('14598','2013-10-30','12:15:00',3.21),('14598','2013-10-30','12:20:00',2.95),('14598','2013-10-30','12:25:00',3.13),('14598','2013-10-30','12:30:00',3.09),('14598','2013-10-30','12:35:00',3.41),('14598','2013-10-30','12:40:00',3.46),('14598','2013-10-30','12:45:00',3.12),('14598','2013-10-30','12:50:00',3.06),('14598','2013-10-30','12:55:00',3.3),('14598','2013-10-30','13:00:00',3.43),('14598','2013-10-30','13:05:00',3.28),('14598','2013-10-30','13:10:00',3.3),('14598','2013-10-30','13:15:00',3.24),('14598','2013-10-30','13:20:00',3.25),('14598','2013-10-30','13:25:00',3.18),('14598','2013-10-30','13:30:00',3.17),('14598','2013-10-30','13:35:00',3.14),('14598','2013-10-30','13:40:00',3.12),('14598','2013-10-30','13:45:00',3.07),('14598','2013-10-30','13:50:00',2.92),('14598','2013-10-30','13:55:00',3),('14598','2013-10-30','14:00:00',2.94),('14598','2013-10-30','14:05:00',2.87),('14598','2013-10-30','14:10:00',2.58),('14598','2013-10-30','14:15:00',2.44),('14598','2013-10-30','14:20:00',2.6),('14598','2013-10-30','14:25:00',2.65),('14598','2013-10-30','14:30:00',2.59),('14598','2013-10-30','14:35:00',2.51),('14598','2013-10-30','14:40:00',2.47),('14598','2013-10-30','14:45:00',2.19),('14598','2013-10-30','14:50:00',2.12),('14598','2013-10-30','14:55:00',2.14),('14598','2013-10-30','15:00:00',1.87),('14598','2013-10-30','15:05:00',2.02),('14598','2013-10-30','15:10:00',2.05),('14598','2013-10-30','15:15:00',2.02),('14598','2013-10-30','15:20:00',1.92),('14598','2013-10-30','15:25:00',1.72),('14598','2013-10-30','15:30:00',1.29),('14598','2013-10-30','15:35:00',1.5),('14598','2013-10-30','15:40:00',1.29),('14598','2013-10-29','08:30:00',1.08),('14598','2013-10-29','08:35:00',1.17),('14598','2013-10-29','08:40:00',1.28),('14598','2013-10-29','08:45:00',1.36),('14598','2013-10-29','08:50:00',1.43),('14598','2013-10-29','08:55:00',1.48),('14598','2013-10-29','09:00:00',1.54),('14598','2013-10-29','09:05:00',1.61),('14598','2013-10-29','09:10:00',1.68),('14598','2013-10-29','09:15:00',1.76),('14598','2013-10-29','09:20:00',1.87),('14598','2013-10-29','09:25:00',1.89),('14598','2013-10-29','09:30:00',1.96),('14598','2013-10-29','09:35:00',1.93),('14598','2013-10-29','09:40:00',1.91),('14598','2013-10-29','09:45:00',2.25),('14598','2013-10-29','09:50:00',2.32),('14598','2013-10-29','09:55:00',2.39),('14598','2013-10-29','10:00:00',2.42),('14598','2013-10-29','10:05:00',2.51),('14598','2013-10-29','10:10:00',2.58),('14598','2013-10-29','10:15:00',2.67),('14598','2013-10-29','10:20:00',2.69),('14598','2013-10-29','10:25:00',2.64),('14598','2013-10-29','10:30:00',2.78),('14598','2013-10-29','10:35:00',2.84),('14598','2013-10-29','10:40:00',2.18),('14598','2013-10-29','10:45:00',1.19),('14598','2013-10-29','10:50:00',1.01),('14598','2013-10-29','10:55:00',1.22),('14598','2013-10-29','11:00:00',1.31),('14598','2013-10-29','11:05:00',1.43),('14598','2013-10-29','11:10:00',1.03),('14598','2013-10-29','11:20:00',2.27),('14598','2013-10-29','11:25:00',3.03),('14598','2013-10-29','11:30:00',3.86),('14598','2013-10-29','11:35:00',3.77),('14598','2013-10-29','11:40:00',3.69),('14598','2013-10-29','11:45:00',3.52),('14598','2013-10-29','11:50:00',3.45),('14598','2013-10-29','11:55:00',3.42),('14598','2013-10-29','12:00:00',3.4),('14598','2013-10-29','12:05:00',3.42),('14598','2013-10-29','12:10:00',3.43),('14598','2013-10-29','12:15:00',3.42),('14598','2013-10-29','12:20:00',3.42),('14598','2013-10-29','12:25:00',3.42),('14598','2013-10-29','12:30:00',3.4),('14598','2013-10-29','12:35:00',3.4),('14598','2013-10-29','12:40:00',3.4),('14598','2013-10-29','12:45:00',3.38),('14598','2013-10-29','12:50:00',3.36),('14598','2013-10-29','12:55:00',3.35),('14598','2013-10-29','13:00:00',3.33),('14598','2013-10-29','13:05:00',3.31),('14598','2013-10-29','13:10:00',3.28),('14598','2013-10-29','13:15:00',3.27),('14598','2013-10-29','13:20:00',3.23),('14598','2013-10-29','13:25:00',3.21),('14598','2013-10-29','13:30:00',3.17),('14598','2013-10-29','13:35:00',3.15),('14598','2013-10-29','13:40:00',3.12),('14598','2013-10-29','13:45:00',3.08),('14598','2013-10-29','13:50:00',2.97),('14598','2013-10-29','13:55:00',2.98),('14598','2013-10-29','14:00:00',2.93),('14598','2013-10-29','14:05:00',2.87),('14598','2013-10-29','14:10:00',2.83),('14598','2013-10-29','14:15:00',2.78),('14598','2013-10-29','14:20:00',2.72),('14598','2013-10-29','14:25:00',2.67),('14598','2013-10-29','14:30:00',2.59),('14598','2013-10-29','14:35:00',2.53),('14598','2013-10-29','14:40:00',2.46),('14598','2013-10-29','14:45:00',2.39),('14598','2013-10-29','14:50:00',2.32),('14598','2013-10-29','14:55:00',2.25),('14598','2013-10-29','15:00:00',2.15),('14598','2013-10-29','15:05:00',2.05),('14598','2013-10-29','15:10:00',1.99),('14598','2013-10-29','15:15:00',1.89),('14598','2013-10-29','15:20:00',1.82),('14598','2013-10-29','15:25:00',1.74),('14598','2013-10-29','15:30:00',1.64),('14598','2013-10-29','15:35:00',1.55),('14598','2013-10-29','15:40:00',1.46),('14598','2013-10-29','15:45:00',1.37),('14598','2013-10-29','15:50:00',1.27),('14598','2013-10-29','15:55:00',1.17),('14598','2013-10-29','16:00:00',1.07),('14598','2014-04-17','08:25:00',1.12),('14598','2014-04-17','08:30:00',1.25),('14598','2014-04-17','08:35:00',1.35),('14598','2014-04-17','08:40:00',1.46),('14598','2014-04-17','08:45:00',1.57),('14598','2014-04-17','08:50:00',1.68),('14598','2014-04-17','08:55:00',1.78),('14598','2014-04-17','09:00:00',1.91),('14598','2014-04-17','09:05:00',2.08),('14598','2014-04-17','09:10:00',2.15),('14598','2014-04-17','09:15:00',2.33),('14598','2014-04-17','09:20:00',2.44),('14598','2014-04-17','09:25:00',2.55),('14598','2014-04-17','09:30:00',2.63),('14598','2014-04-17','09:35:00',2.76),('14598','2014-04-17','09:40:00',2.84),('14598','2014-04-17','09:45:00',2.96),('14598','2014-04-17','09:50:00',3.05),('14598','2014-04-17','09:55:00',3.15),('14598','2014-04-17','10:00:00',3.24),('14598','2014-04-17','10:05:00',3.35),('14598','2014-04-17','10:10:00',3.46),('14598','2014-04-17','10:15:00',3.16),('14598','2014-04-17','10:20:00',3.19),('14598','2014-04-17','10:25:00',3.13),('14598','2014-04-17','10:30:00',3.48),('14598','2014-04-17','10:35:00',3.11),('14598','2014-04-17','10:40:00',2.66),('14598','2014-04-17','10:45:00',3.18),('14598','2014-04-17','10:50:00',4.37),('14598','2014-04-17','10:55:00',3.87),('14598','2014-04-17','11:00:00',2.74),('14598','2014-04-17','11:05:00',3.47),('14598','2014-04-17','11:10:00',4.42),('14598','2014-04-17','11:15:00',4.41),('14598','2014-04-17','11:20:00',4.23),('14598','2014-04-17','11:25:00',5.11),('14598','2014-04-17','11:30:00',4.48),('14598','2014-04-17','11:35:00',3.07),('14598','2014-04-17','11:40:00',2.55),('14598','2014-04-17','11:45:00',5.18),('14598','2014-04-17','11:50:00',4.36),('14598','2014-04-17','11:55:00',4.92),('14598','2014-04-17','12:00:00',5.09),('14598','2014-04-17','12:05:00',5.1),('14598','2014-04-17','12:10:00',5.18),('14598','2014-04-17','12:15:00',4.75),('14598','2014-04-17','12:20:00',4.81),('14598','2014-04-17','12:25:00',4.86),('14598','2014-04-17','12:30:00',5.11),('14598','2014-04-17','12:35:00',4.51),('14598','2014-04-17','12:40:00',5.03),('14598','2014-04-17','12:45:00',5.04),('14598','2014-04-17','12:50:00',5.08),('14598','2014-04-17','12:55:00',5.1),('14598','2014-04-17','13:00:00',5.1),('14598','2014-04-17','13:05:00',5.07),('14598','2014-04-17','13:10:00',5.06),('14598','2014-04-17','13:15:00',5.14),('14598','2014-04-17','13:20:00',5.2),('14598','2014-04-17','13:25:00',5.24),('14598','2014-04-17','13:30:00',5.14),('14598','2014-04-17','13:35:00',5.29),('14598','2014-04-17','13:40:00',5.49),('14598','2014-04-17','13:45:00',5.87),('14598','2014-04-17','13:50:00',3.59),('14598','2014-04-17','13:55:00',1.32),('14598','2014-04-17','14:15:00',1.16),('14598','2014-04-17','14:20:00',1.46),('14598','2014-04-17','14:25:00',1.69),('14598','2014-04-17','14:30:00',1.91),('14598','2014-04-17','14:35:00',4.23),('14598','2014-04-17','14:40:00',3.3),('14598','2014-04-17','14:45:00',2.18),('14598','2014-04-17','14:50:00',1.87),('14598','2014-04-17','14:55:00',1.71),('14598','2014-04-17','15:00:00',4.8),('14598','2014-04-17','15:05:00',5.32),('14598','2014-04-17','15:10:00',5.24),('14598','2014-04-17','15:15:00',4.47),('14598','2014-04-17','15:20:00',2.7),('14598','2014-04-17','15:25:00',3.88),('14598','2014-04-17','15:30:00',3.75),('14598','2014-04-17','15:35:00',3.07),('14598','2014-04-17','15:40:00',4.84),('14598','2014-04-17','15:45:00',3.14),('14598','2014-04-17','15:50:00',2.75),('14598','2014-04-17','15:55:00',2.81),('14598','2014-04-17','16:00:00',1.77),('14598','2014-04-17','16:05:00',2.1),('14598','2014-04-17','16:10:00',5.42),('14598','2014-04-17','16:15:00',2.72),('14598','2014-04-17','16:20:00',3.12),('14598','2014-04-17','16:25:00',2.67),('14598','2014-04-17','16:30:00',2.56),('14598','2014-04-17','16:35:00',1.54),('14598','2014-04-17','16:40:00',1.61),('14598','2014-04-17','16:45:00',1.74),('14598','2014-04-17','16:50:00',2.52),('14598','2014-04-17','16:55:00',2.63),('14598','2014-04-17','17:00:00',1.47),('14598','2014-04-17','17:05:00',1.02),('14598','2013-10-28','08:25:00',1.04),('14598','2013-10-28','08:30:00',1.12),('14598','2013-10-28','08:35:00',1.22),('14598','2013-10-28','08:40:00',1.34),('14598','2013-10-28','08:45:00',1.44),('14598','2013-10-28','08:50:00',1.06),('14598','2013-10-28','08:55:00',1.25),('14598','2013-10-28','09:00:00',1.37),('14598','2013-10-28','09:05:00',1.27),('14598','2013-10-28','09:10:00',1.1),('14598','2013-10-28','09:55:00',1.02),('14598','2013-10-28','10:00:00',1.1),('14598','2013-10-28','10:05:00',1.16),('14598','2013-10-28','10:10:00',1.87),('14598','2013-10-28','10:15:00',1.55),('14598','2013-10-28','10:20:00',1.52),('14598','2013-10-28','10:25:00',1.61),('14598','2013-10-28','10:30:00',1.7),('14598','2013-10-28','10:35:00',2.65),('14598','2013-10-28','10:40:00',3.03),('14598','2013-10-28','10:45:00',3.03),('14598','2013-10-28','10:50:00',3.06),('14598','2013-10-28','10:55:00',3.07),('14598','2013-10-28','11:00:00',3.08),('14598','2013-10-28','11:05:00',3.13),('14598','2013-10-28','11:10:00',3.24),('14598','2013-10-28','11:15:00',3.29),('14598','2013-10-28','11:20:00',3.41),('14598','2013-10-28','11:25:00',3.68),('14598','2013-10-28','11:30:00',2.45),('14598','2013-10-28','11:35:00',2.15),('14598','2013-10-28','11:40:00',2.04),('14598','2013-10-28','11:45:00',2.44),('14598','2013-10-28','11:50:00',2.41),('14598','2013-10-28','11:55:00',2.41),('14598','2013-10-28','12:00:00',2.23),('14598','2013-10-28','12:05:00',3.36),('14598','2013-10-28','12:10:00',3.59),('14598','2013-10-28','12:15:00',3.49),('14598','2013-10-28','12:20:00',3.42),('14598','2013-10-28','12:25:00',3.46),('14598','2013-10-28','12:30:00',3.47),('14598','2013-10-28','12:35:00',3.43),('14598','2013-10-28','12:40:00',3.46),('14598','2013-10-28','12:45:00',3.47),('14598','2013-10-28','12:50:00',3.24),('14598','2013-10-28','12:55:00',2.95),('14598','2013-10-28','13:00:00',3.16),('14598','2013-10-28','13:05:00',3.42),('14598','2013-10-28','13:10:00',3.36),('14598','2013-10-28','13:15:00',3.36),('14598','2013-10-28','13:20:00',3.31),('14598','2013-10-28','13:25:00',3.07),('14598','2013-10-28','13:30:00',3.32),('14598','2013-10-28','13:35:00',3.32),('14598','2013-10-28','13:40:00',3.39),('14598','2013-10-28','13:45:00',3.46),('14598','2013-10-28','13:50:00',3.1),('14598','2013-10-28','13:55:00',3.11),('14598','2013-10-28','14:00:00',3.29),('14598','2013-10-28','14:05:00',3.43),('14598','2013-10-28','14:10:00',3.72),('14598','2013-10-28','14:15:00',3.39),('14598','2013-10-28','14:20:00',2),('14598','2013-10-28','14:25:00',3.16),('14598','2013-10-28','14:30:00',2.55),('14598','2013-10-28','14:35:00',2.25),('14598','2013-10-28','14:40:00',2.08),('14598','2013-10-28','14:45:00',1.39),('14598','2013-10-28','14:50:00',1.5),('14598','2013-10-28','14:55:00',1.36),('14598','2013-10-28','15:00:00',1.74),('14598','2013-10-28','15:05:00',2.11),('14598','2013-10-28','15:10:00',2.03),('14598','2013-10-28','15:15:00',1.88),('14598','2013-10-28','15:20:00',1.79),('14598','2013-10-28','15:25:00',1.76),('14598','2013-10-28','15:30:00',1.68),('14598','2013-10-28','15:35:00',1.6),('14598','2013-10-28','15:40:00',1.49),('14598','2013-10-28','15:45:00',1.4),('14598','2013-10-28','15:50:00',1.29),('14598','2013-10-28','15:55:00',1.19),('14598','2013-10-28','16:00:00',1.09),('14598','2013-10-27','09:15:00',1.02),('14598','2013-10-27','09:20:00',1.13),('14598','2013-10-27','09:25:00',1.09),('14598','2013-10-27','09:30:00',1.07),('14598','2013-10-27','09:35:00',1.16),('14598','2013-10-27','09:40:00',1.11),('14598','2013-10-27','09:45:00',1.07),('14598','2013-10-27','09:55:00',1.09),('14598','2013-10-27','10:00:00',1.38),('14598','2013-10-27','10:05:00',1.77),('14598','2013-10-27','10:10:00',1.7),('14598','2013-10-27','10:15:00',1.66),('14598','2013-10-27','10:20:00',1.68),('14598','2013-10-27','10:25:00',1.74),('14598','2013-10-27','10:30:00',1.5),('14598','2013-10-27','10:35:00',1.39),('14598','2013-10-27','10:40:00',1.51),('14598','2013-10-27','10:45:00',1.82),('14598','2013-10-27','10:50:00',2.11),('14598','2013-10-27','10:55:00',2.23),('14598','2013-10-27','11:00:00',1.75),('14598','2013-10-27','11:05:00',1.81),('14598','2013-10-27','11:10:00',2.18),('14598','2013-10-27','11:15:00',1.82),('14598','2013-10-27','11:20:00',1.6),('14598','2013-10-27','11:25:00',1.45),('14598','2013-10-27','11:30:00',1.47),('14598','2013-10-27','11:35:00',1.63),('14598','2013-10-27','11:40:00',1.89),('14598','2013-10-27','11:45:00',1.95),('14598','2013-10-27','11:50:00',1.99),('14598','2013-10-27','11:55:00',2.72),('14598','2013-10-27','12:00:00',3.72),('14598','2013-10-27','12:05:00',2.97),('14598','2013-10-27','12:10:00',2.81),('14598','2013-10-27','12:15:00',3.38),('14598','2013-10-27','12:20:00',3.38),('14598','2013-10-27','12:25:00',3.38),('14598','2013-10-27','12:30:00',3.33),('14598','2013-10-27','12:35:00',3.27),('14598','2013-10-27','12:40:00',3.12),('14598','2013-10-27','12:45:00',2.59),('14598','2013-10-27','12:50:00',2.15),('14598','2013-10-27','12:55:00',1.87),('14598','2013-10-27','13:00:00',2.98),('14598','2013-10-27','13:05:00',2.86),('14598','2013-10-27','13:10:00',3.59),('14598','2013-10-27','13:15:00',3.48),('14598','2013-10-27','13:20:00',3.15),('14598','2013-10-27','13:25:00',3.16),('14598','2013-10-27','13:30:00',3.2),('14598','2013-10-27','13:35:00',3.06),('14598','2013-10-27','13:40:00',1.9),('14598','2013-10-27','13:45:00',2.36),('14598','2013-10-27','13:50:00',1.18),('14598','2013-10-27','13:55:00',1.13),('14598','2013-10-27','14:20:00',2.81),('14598','2013-10-27','14:25:00',2.81),('14598','2013-10-27','14:30:00',2.67),('14598','2013-10-27','14:35:00',2.61),('14598','2013-10-27','14:40:00',2.47),('14598','2013-10-27','14:45:00',2.38),('14598','2013-10-27','14:50:00',2.17),('14598','2013-10-27','14:55:00',1.92),('14598','2013-10-27','15:00:00',1.64),('14598','2013-10-27','15:05:00',2.1),('14598','2013-10-27','15:10:00',2.13),('14598','2013-10-27','15:15:00',1.98),('14598','2013-10-27','15:20:00',1.84),('14598','2013-10-27','15:25:00',1.74),('14598','2013-10-27','15:30:00',1.55),('14598','2013-10-27','15:35:00',1.56),('14598','2013-10-27','15:40:00',1.44),('14598','2013-10-27','15:45:00',1.33),('14598','2013-10-27','15:50:00',1.24),('14598','2013-10-27','15:55:00',1.12),('14598','2013-10-27','16:00:00',1.06),('14598','2013-10-26','09:25:00',1.06),('14598','2013-10-26','09:30:00',1.18),('14598','2013-10-26','09:35:00',1.28),('14598','2013-10-26','09:40:00',1.38),('14598','2013-10-26','09:45:00',1.44),('14598','2013-10-26','09:50:00',1.5),('14598','2013-10-26','09:55:00',1.59),('14598','2013-10-26','10:00:00',1.69),('14598','2013-10-26','10:05:00',1.77),('14598','2013-10-26','10:10:00',1.87),('14598','2013-10-26','10:15:00',1.94),('14598','2013-10-26','10:20:00',1.97),('14598','2013-10-26','10:25:00',2),('14598','2013-10-26','10:30:00',1.99),('14598','2013-10-26','10:35:00',1.98),('14598','2013-10-26','10:40:00',2.1),('14598','2013-10-26','10:45:00',2.46),('14598','2013-10-26','10:50:00',2.27),('14598','2013-10-26','10:55:00',1.92),('14598','2013-10-26','11:00:00',1.79),('14598','2013-10-26','11:05:00',1.84),('14598','2013-10-26','11:10:00',2.91),('14598','2013-10-26','11:15:00',2.59),('14598','2013-10-26','11:20:00',2.73),('14598','2013-10-26','11:25:00',2.84),('14598','2013-10-26','11:30:00',2.86),('14598','2013-10-26','11:35:00',2.89),('14598','2013-10-26','11:40:00',2.96),('14598','2013-10-26','11:45:00',2.99),('14598','2013-10-26','11:50:00',3.04),('14598','2013-10-26','11:55:00',3.01),('14598','2013-10-26','12:00:00',3),('14598','2013-10-26','12:05:00',3.07),('14598','2013-10-26','12:10:00',2.95),('14598','2013-10-26','12:15:00',3.02),('14598','2013-10-26','12:20:00',3.1),('14598','2013-10-26','12:25:00',3.16),('14598','2013-10-26','12:30:00',3.31),('14598','2013-10-26','12:35:00',3.32),('14598','2013-10-26','12:40:00',3.32),('14598','2013-10-26','12:45:00',3.31),('14598','2013-10-26','12:50:00',3.31),('14598','2013-10-26','12:55:00',3.31),('14598','2013-10-26','13:00:00',3.33),('14598','2013-10-26','13:05:00',3.38),('14598','2013-10-26','13:10:00',3.41),('14598','2013-10-26','13:15:00',3.41),('14598','2013-10-26','13:20:00',3.41),('14598','2013-10-26','13:25:00',3.44),('14598','2013-10-26','13:30:00',3.4),('14598','2013-10-26','13:35:00',3.41),('14598','2013-10-26','13:40:00',3.42),('14598','2013-10-26','13:45:00',3.43),('14598','2013-10-26','13:50:00',3.41),('14598','2013-10-26','13:55:00',3.41),('14598','2013-10-26','14:00:00',3.38),('14598','2013-10-26','14:05:00',3.34),('14598','2013-10-26','14:10:00',3.35),('14598','2013-10-26','14:15:00',3.32),('14598','2013-10-26','14:20:00',3.32),('14598','2013-10-26','14:25:00',3.29),('14598','2013-10-26','14:30:00',3.26),('14598','2013-10-26','14:35:00',3.22),('14598','2013-10-26','14:40:00',3.16),('14598','2013-10-26','14:45:00',3.13),('14598','2013-10-26','14:50:00',3.09),('14598','2013-10-26','14:55:00',3.03),('14598','2013-10-26','15:00:00',2.99),('14598','2013-10-26','15:05:00',2.93),('14598','2013-10-26','15:10:00',2.9),('14598','2013-10-26','15:15:00',2.82),('14598','2013-10-26','15:20:00',2.78),('14598','2013-10-26','15:25:00',2.71),('14598','2013-10-26','15:30:00',2.63),('14598','2013-10-26','15:35:00',2.6),('14598','2013-10-26','15:40:00',2.51),('14598','2013-10-26','15:45:00',2.45),('14598','2013-10-26','15:50:00',2.38),('14598','2013-10-26','15:55:00',2.28),('14598','2013-10-26','16:00:00',2.22),('14598','2013-10-26','16:05:00',2.12),('14598','2013-10-26','16:10:00',2.03),('14598','2013-10-26','16:15:00',1.97),('14598','2013-10-26','16:20:00',1.89),('14598','2013-10-26','16:25:00',1.8),('14598','2013-10-26','16:30:00',1.73),('14598','2013-10-26','16:35:00',1.64),('14598','2013-10-26','16:40:00',1.52),('14598','2013-10-26','16:45:00',1.43),('14598','2013-10-26','16:50:00',1.35),('14598','2013-10-26','16:55:00',1.26),('14598','2013-10-26','17:00:00',1.14),('14598','2013-10-26','17:05:00',1.04),('14598','2013-10-25','09:25:00',1.09),('14598','2013-10-25','09:30:00',1.2),('14598','2013-10-25','09:35:00',1.28),('14598','2013-10-25','09:40:00',1.37),('14598','2013-10-25','09:45:00',1.46),('14598','2013-10-25','09:50:00',1.55),('14598','2013-10-25','09:55:00',1.64),('14598','2013-10-25','10:00:00',1.55),('14598','2013-10-25','10:05:00',1.35),('14598','2013-10-25','10:10:00',1.87),('14598','2013-10-25','10:15:00',1.94),('14598','2013-10-25','10:20:00',2.03),('14598','2013-10-25','10:25:00',2.1),('14598','2013-10-25','10:30:00',2.17),('14598','2013-10-25','10:35:00',2.23),('14598','2013-10-25','10:40:00',2.31),('14598','2013-10-25','10:45:00',2.39),('14598','2013-10-25','10:50:00',2.45),('14598','2013-10-25','10:55:00',2.52),('14598','2013-10-25','11:00:00',2.59),('14598','2013-10-25','11:05:00',2.65),('14598','2013-10-25','11:10:00',2.7),('14598','2013-10-25','11:15:00',2.75),('14598','2013-10-25','11:20:00',2.82),('14598','2013-10-25','11:25:00',2.86),('14598','2013-10-25','11:30:00',2.88),('14598','2013-10-25','11:35:00',2.97),('14598','2013-10-25','11:40:00',2.98),('14598','2013-10-25','11:45:00',3.04),('14598','2013-10-25','11:50:00',3.09),('14598','2013-10-25','11:55:00',3.13),('14598','2013-10-25','12:00:00',3.12),('14598','2013-10-25','12:05:00',3.18),('14598','2013-10-25','12:10:00',3.17),('14598','2013-10-25','12:15:00',3.26),('14598','2013-10-25','12:20:00',3.26),('14598','2013-10-25','12:25:00',3.31),('14598','2013-10-25','12:30:00',3.33),('14598','2013-10-25','12:35:00',3.34),('14598','2013-10-25','12:40:00',3.3),('14598','2013-10-25','12:45:00',3.36),('14598','2013-10-25','12:50:00',3.39),('14598','2013-10-25','12:55:00',3.39),('14598','2013-10-25','13:00:00',3.37),('14598','2013-10-25','13:05:00',3.41),('14598','2013-10-25','13:10:00',3.42),('14598','2013-10-25','13:15:00',3.45),('14598','2013-10-25','13:20:00',3.48),('14598','2013-10-25','13:25:00',3.48),('14598','2013-10-25','13:30:00',3.51),('14598','2013-10-25','13:35:00',3.49),('14598','2013-10-25','13:40:00',3.5),('14598','2013-10-25','13:45:00',3.49),('14598','2013-10-25','13:50:00',3.49),('14598','2013-10-25','13:55:00',3.47),('14598','2013-10-25','14:00:00',3.47),('14598','2013-10-25','14:05:00',3.44),('14598','2013-10-25','14:10:00',3.44),('14598','2013-10-25','14:15:00',3.4),('14598','2013-10-25','14:20:00',3.38),('14598','2013-10-25','14:25:00',3.36),('14598','2013-10-25','14:30:00',3.3),('14598','2013-10-25','14:35:00',3.28),('14598','2013-10-25','14:40:00',3.25),('14598','2013-10-25','14:45:00',3.22),('14598','2013-10-25','14:50:00',3.18),('14598','2013-10-25','14:55:00',3.13),('14598','2013-10-25','15:00:00',3.1),('14598','2013-10-25','15:05:00',3.06),('14598','2013-10-25','15:10:00',3.02),('14598','2013-10-25','15:15:00',2.96),('14598','2013-10-25','15:20:00',2.89),('14598','2013-10-25','15:25:00',2.84),('14598','2013-10-25','15:30:00',2.78),('14598','2013-10-25','15:35:00',2.72),('14598','2013-10-25','15:40:00',2.65),('14598','2013-10-25','15:45:00',2.56),('14598','2013-10-25','15:50:00',2.5),('14598','2013-10-25','15:55:00',2.42),('14598','2013-10-25','16:00:00',2.34),('14598','2013-10-25','16:05:00',2.26),('14598','2013-10-25','16:10:00',2.18),('14598','2013-10-25','16:15:00',2.09),('14598','2013-10-25','16:20:00',2.01),('14598','2013-10-25','16:25:00',1.92),('14598','2013-10-25','16:30:00',1.82),('14598','2013-10-25','16:35:00',1.72),('14598','2013-10-25','16:40:00',1.63),('14598','2013-10-25','16:45:00',1.54),('14598','2013-10-25','16:50:00',1.44),('14598','2013-10-25','16:55:00',1.34),('14598','2013-10-25','17:00:00',1.24),('14598','2013-10-25','17:05:00',1.13),('14598','2013-10-25','17:10:00',1.02),('14598','2013-10-24','08:50:00',1.02),('14598','2013-10-24','09:05:00',1.29),('14598','2013-10-24','10:00:00',1.1),('14598','2013-10-24','10:05:00',1.36),('14598','2013-10-24','10:10:00',1.52),('14598','2013-10-24','10:15:00',2.16),('14598','2013-10-24','10:20:00',2.71),('14598','2013-10-24','10:25:00',1.7),('14598','2013-10-24','10:30:00',1.25),('14598','2013-10-24','10:35:00',1.21),('14598','2013-10-24','10:40:00',1.21),('14598','2013-10-24','10:45:00',1.2),('14598','2013-10-24','10:50:00',1.16),('14598','2013-10-24','10:55:00',1.15),('14598','2013-10-24','11:00:00',1.27),('14598','2013-10-24','11:05:00',2.56),('14598','2013-10-24','11:10:00',2.42),('14598','2013-10-24','11:15:00',1.91),('14598','2013-10-24','11:20:00',1.42),('14598','2013-10-24','11:25:00',1.36),('14598','2013-10-24','11:30:00',1.44),('14598','2013-10-24','11:35:00',1.5),('14598','2013-10-24','11:40:00',1.6),('14598','2013-10-24','11:45:00',1.66),('14598','2013-10-24','11:50:00',1.82),('14598','2013-10-24','11:55:00',1.71),('14598','2013-10-24','12:00:00',1.3),('14598','2013-10-24','12:05:00',2.03),('14598','2013-10-24','12:10:00',1.7),('14598','2013-10-24','12:15:00',1.79),('14598','2013-10-24','12:20:00',1.9),('14598','2013-10-24','12:25:00',2.02),('14598','2013-10-24','12:30:00',1.59),('14598','2013-10-24','12:35:00',1.52),('14598','2013-10-24','12:40:00',1.5),('14598','2013-10-24','12:45:00',1.48),('14598','2013-10-24','12:50:00',1.48),('14598','2013-10-24','12:55:00',1.53),('14598','2013-10-24','13:00:00',1.62),('14598','2013-10-24','13:05:00',1.73),('14598','2013-10-24','13:10:00',1.67),('14598','2013-10-24','13:15:00',1.6),('14598','2013-10-24','13:20:00',1.54),('14598','2013-10-24','13:25:00',1.51),('14598','2013-10-24','13:30:00',1.51),('14598','2013-10-24','13:35:00',1.46),('14598','2013-10-24','13:40:00',1.42),('14598','2013-10-24','13:45:00',1.43),('14598','2013-10-24','13:50:00',1.54),('14598','2013-10-24','13:55:00',1.65),('14598','2013-10-24','14:00:00',2.04),('14598','2013-10-24','14:05:00',1.58),('14598','2013-10-24','14:10:00',1.42),('14598','2013-10-24','14:15:00',1.34),('14598','2013-10-24','14:20:00',1.26),('14598','2013-10-24','14:25:00',1.22),('14598','2013-10-24','14:30:00',1.24),('14598','2013-10-24','14:35:00',1.24),('14598','2013-10-24','14:40:00',1.33),('14598','2013-10-24','14:45:00',1.43),('14598','2013-10-24','14:50:00',1.37),('14598','2013-10-24','14:55:00',1.22),('14598','2013-10-24','15:00:00',1.27),('14598','2013-10-24','15:05:00',2.43),('14598','2013-10-24','15:10:00',3.44),('14598','2013-10-24','15:15:00',3.09),('14598','2013-10-24','15:20:00',3.06),('14598','2013-10-23','10:30:00',1.02),('14598','2013-10-23','10:35:00',1.11),('14598','2013-10-23','10:40:00',1.23),('14598','2013-10-23','10:45:00',1.29),('14598','2013-10-23','10:50:00',1.16),('14598','2013-10-23','10:55:00',1.57),('14598','2013-10-23','11:00:00',1.93),('14598','2013-10-23','11:05:00',1.91),('14598','2013-10-23','11:10:00',2.33),('14598','2013-10-23','11:15:00',1.77),('14598','2013-10-23','11:20:00',2.1),('14598','2013-10-23','11:25:00',1.68),('14598','2013-10-23','11:30:00',2.84),('14598','2013-10-23','11:35:00',2.77),('14598','2013-10-23','11:40:00',3.09),('14598','2013-10-23','11:45:00',3.08),('14598','2013-10-23','11:50:00',3.12),('14598','2013-10-23','11:55:00',3.15),('14598','2013-10-23','12:00:00',3.15),('14598','2013-10-23','12:05:00',3.18),('14598','2013-10-23','12:10:00',3.16),('14598','2013-10-23','12:15:00',3.24),('14598','2013-10-23','12:20:00',3.26),('14598','2013-10-23','12:25:00',3.23),('14598','2013-10-23','12:30:00',3.22),('14598','2013-10-23','12:35:00',3.33),('14598','2013-10-23','12:40:00',3.29),('14598','2013-10-23','12:45:00',3.18),('14598','2013-10-23','12:50:00',3.24),('14598','2013-10-23','12:55:00',3.16),('14598','2013-10-23','13:00:00',3.36),('14598','2013-10-23','13:05:00',3.48),('14598','2013-10-23','13:10:00',3.48),('14598','2013-10-23','13:15:00',3.46),('14598','2013-10-23','13:20:00',3.45),('14598','2013-10-23','13:25:00',3.43),('14598','2013-10-23','13:30:00',3.43),('14598','2013-10-23','13:35:00',3.36),('14598','2013-10-23','13:40:00',3.33),('14598','2013-10-23','13:45:00',3.34),('14598','2013-10-23','13:50:00',3.38),('14598','2013-10-23','13:55:00',3.32),('14598','2013-10-23','14:00:00',3.31),('14598','2013-10-23','14:05:00',3.26),('14598','2013-10-23','14:10:00',3.26),('14598','2013-10-23','14:15:00',3.24),('14598','2013-10-23','14:20:00',3.2),('14598','2013-10-23','14:25:00',3.2),('14598','2013-10-23','14:30:00',3.15),('14598','2013-10-23','14:35:00',3.15),('14598','2013-10-23','14:40:00',3.14),('14598','2013-10-23','14:45:00',3.11),('14598','2013-10-23','14:50:00',3.08),('14598','2013-10-23','14:55:00',3.06),('14598','2013-10-23','15:00:00',3),('14598','2013-10-23','15:05:00',2.94),('14598','2013-10-23','15:10:00',2.55),('14598','2013-10-23','15:15:00',2.52),('14598','2013-10-23','15:20:00',2.65),('14598','2013-10-23','15:25:00',2.49),('14598','2013-10-23','15:30:00',2.36),('14598','2013-10-23','15:35:00',2.5),('14598','2013-10-23','15:40:00',2.22),('14598','2013-10-23','15:45:00',1.81),('14598','2013-10-23','15:50:00',1.19),('14598','2013-10-23','15:55:00',1.36),('14598','2013-10-23','16:00:00',1.53),('14598','2013-10-23','16:05:00',1.98),('14598','2013-10-23','16:10:00',2.02),('14598','2013-10-23','16:15:00',2.05),('14598','2013-10-23','16:20:00',2.17),('14598','2013-10-23','16:25:00',1.96),('14598','2013-10-23','16:30:00',1.76),('14598','2013-10-23','16:35:00',1.72),('14598','2013-10-23','16:40:00',1.52),('14598','2013-10-23','16:45:00',1.47),('14598','2013-10-23','16:50:00',1.25),('14598','2013-10-23','16:55:00',1.01),('14598','2013-10-22','09:20:00',1.04),('14598','2013-10-22','09:25:00',1.15),('14598','2013-10-22','09:30:00',1.25),('14598','2013-10-22','09:35:00',1.34),('14598','2013-10-22','09:40:00',1.4),('14598','2013-10-22','09:45:00',1.47),('14598','2013-10-22','09:50:00',1.54),('14598','2013-10-22','09:55:00',1.62),('14598','2013-10-22','10:00:00',1.71),('14598','2013-10-22','10:05:00',1.78),('14598','2013-10-22','10:10:00',1.86),('14598','2013-10-22','10:15:00',1.86),('14598','2013-10-22','10:20:00',1.97),('14598','2013-10-22','10:25:00',2.07),('14598','2013-10-22','10:30:00',2.11),('14598','2013-10-22','10:35:00',2.16),('14598','2013-10-22','10:40:00',2.28),('14598','2013-10-22','10:45:00',2.35),('14598','2013-10-22','10:50:00',2.43),('14598','2013-10-22','10:55:00',2.48),('14598','2013-10-22','11:00:00',2.46),('14598','2013-10-22','11:05:00',2.53),('14598','2013-10-22','11:10:00',2.58),('14598','2013-10-22','11:15:00',2.67),('14598','2013-10-22','11:20:00',2.68),('14598','2013-10-22','11:25:00',2.79),('14598','2013-10-22','11:30:00',2.91),('14598','2013-10-22','11:35:00',2.19),('14598','2013-10-22','11:40:00',2.63),('14598','2013-10-22','11:45:00',3.11),('14598','2013-10-22','11:50:00',1.68),('14598','2013-10-22','11:55:00',1.17),('14598','2013-10-22','12:00:00',2.35),('14598','2013-10-22','12:05:00',2.75),('14598','2013-10-22','12:10:00',3.17),('14598','2013-10-22','12:15:00',3.25),('14598','2013-10-22','12:20:00',3.24),('14598','2013-10-22','12:25:00',3.19),('14598','2013-10-22','12:30:00',3.28),('14598','2013-10-22','12:35:00',1.24),('14598','2013-10-22','12:40:00',3.08),('14598','2013-10-22','12:45:00',3.36),('14598','2013-10-22','12:50:00',3.42),('14598','2013-10-22','12:55:00',3.41),('14598','2013-10-22','13:00:00',3.48),('14598','2013-10-22','13:05:00',3.36),('14598','2013-10-22','13:10:00',3.37),('14598','2013-10-22','13:15:00',3.32),('14598','2013-10-22','13:20:00',3.4),('14598','2013-10-22','13:25:00',3.39),('14598','2013-10-22','13:30:00',2.7),('14598','2013-10-22','13:35:00',3.38),('14598','2013-10-22','13:40:00',3.43),('14598','2013-10-22','13:45:00',3.42),('14598','2013-10-22','13:50:00',3.39),('14598','2013-10-22','13:55:00',3.27),('14598','2013-10-22','14:00:00',3.32),('14598','2013-10-22','14:05:00',3.33),('14598','2013-10-22','14:10:00',3.29),('14598','2013-10-22','14:15:00',3.26),('14598','2013-10-22','14:20:00',3.24),('14598','2013-10-22','14:25:00',3.15),('14598','2013-10-22','14:30:00',3.19),('14598','2013-10-22','14:35:00',3.19),('14598','2013-10-22','14:40:00',3.18),('14598','2013-10-22','14:45:00',3.15),('14598','2013-10-22','14:50:00',3.1),('14598','2013-10-22','14:55:00',3.05),('14598','2013-10-22','15:00:00',3.02),('14598','2013-10-22','15:05:00',2.96),('14598','2013-10-22','15:10:00',2.9),('14598','2013-10-22','15:15:00',2.85),('14598','2013-10-22','15:20:00',2.82),('14598','2013-10-22','15:25:00',2.74),('14598','2013-10-22','15:30:00',2.68),('14598','2013-10-22','15:35:00',2.64),('14598','2013-10-22','15:40:00',2.58),('14598','2013-10-22','15:45:00',2.53),('14598','2013-10-22','15:50:00',2.46),('14598','2013-10-22','15:55:00',2.37),('14598','2013-10-22','16:00:00',2.3),('14598','2013-10-22','16:05:00',2.23),('14598','2013-10-22','16:10:00',2.14),('14598','2013-10-22','16:15:00',2.06),('14598','2013-10-22','16:20:00',1.97),('14598','2013-10-22','16:25:00',1.88),('14598','2013-10-22','16:30:00',1.79),('14598','2013-10-22','16:35:00',1.69),('14598','2013-10-22','16:40:00',1.6),('14598','2013-10-22','16:45:00',1.5),('14598','2013-10-22','16:50:00',1.4),('14598','2013-10-22','16:55:00',1.3),('14598','2013-10-22','17:00:00',1.2),('14598','2013-10-22','17:05:00',1.09),('14598','2013-10-21','09:25:00',1.04),('14598','2013-10-21','09:30:00',1.32),('14598','2013-10-21','09:35:00',1.38),('14598','2013-10-21','09:40:00',1.45),('14598','2013-10-21','09:45:00',1.54),('14598','2013-10-21','09:50:00',1.65),('14598','2013-10-21','09:55:00',1.75),('14598','2013-10-21','10:00:00',1.68),('14598','2013-10-21','10:05:00',1.66),('14598','2013-10-21','10:10:00',2.07),('14598','2013-10-21','10:15:00',2.14),('14598','2013-10-21','10:20:00',2.19),('14598','2013-10-21','10:25:00',2.04),('14598','2013-10-21','10:30:00',2.27),('14598','2013-10-21','10:35:00',1.98),('14598','2013-10-21','10:40:00',2.44),('14598','2013-10-21','10:45:00',2.5),('14598','2013-10-21','10:50:00',2.64),('14598','2013-10-21','10:55:00',2.65),('14598','2013-10-21','11:00:00',2.65),('14598','2013-10-21','11:05:00',2.79),('14598','2013-10-21','11:10:00',2.73),('14598','2013-10-21','11:15:00',2.78),('14598','2013-10-21','11:20:00',2.86),('14598','2013-10-21','11:25:00',2.89),('14598','2013-10-21','11:30:00',2.92),('14598','2013-10-21','11:35:00',2.82),('14598','2013-10-21','11:40:00',2.84),('14598','2013-10-21','11:45:00',2.9),('14598','2013-10-21','11:50:00',2.79),('14598','2013-10-21','11:55:00',2.76),('14598','2013-10-21','12:00:00',2.87),('14598','2013-10-21','12:05:00',2.97),('14598','2013-10-21','12:10:00',3.21),('14598','2013-10-21','12:15:00',3.08),('14598','2013-10-21','12:20:00',3.26),('14598','2013-10-21','12:25:00',3.32),('14598','2013-10-21','12:30:00',3.3),('14598','2013-10-21','12:35:00',3.42),('14598','2013-10-21','12:40:00',3.4),('14598','2013-10-21','12:45:00',3.29),('14598','2013-10-21','12:50:00',3.36),('14598','2013-10-21','12:55:00',3.07),('14598','2013-10-21','13:00:00',3.2),('14598','2013-10-21','13:05:00',3.4),('14598','2013-10-21','13:10:00',3.39),('14598','2013-10-21','13:15:00',3.41),('14598','2013-10-21','13:20:00',3.46),('14598','2013-10-21','13:25:00',3.57),('14598','2013-10-21','13:30:00',3.18),('14598','2013-10-21','13:35:00',3.4),('14598','2013-10-21','13:40:00',3.52),('14598','2013-10-21','13:45:00',3.5),('14598','2013-10-21','13:50:00',3.48),('14598','2013-10-21','13:55:00',3.51),('14598','2013-10-21','14:00:00',3.48),('14598','2013-10-21','14:05:00',3.44),('14598','2013-10-21','14:10:00',3.35),('14598','2013-10-21','14:15:00',3.38),('14598','2013-10-21','14:20:00',3.35),('14598','2013-10-21','14:25:00',3.31),('14598','2013-10-21','14:30:00',3.27),('14598','2013-10-21','14:35:00',3.2),('14598','2013-10-21','14:40:00',3.05),('14598','2013-10-21','14:45:00',3.07),('14598','2013-10-21','14:50:00',3.14),('14598','2013-10-21','14:55:00',3.11),('14598','2013-10-21','15:00:00',3.07),('14598','2013-10-21','15:05:00',3.02),('14598','2013-10-21','15:10:00',2.97),('14598','2013-10-21','15:15:00',2.91),('14598','2013-10-21','15:20:00',2.81),('14598','2013-10-21','15:25:00',2.75),('14598','2013-10-21','15:30:00',2.68),('14598','2013-10-21','15:35:00',2.56),('14598','2013-10-21','15:40:00',2.56),('14598','2013-10-21','15:45:00',2.53),('14598','2013-10-21','15:50:00',2.47),('14598','2013-10-21','15:55:00',2.41),('14598','2013-10-21','16:00:00',2.31),('14598','2013-10-21','16:05:00',2.25),('14598','2013-10-21','16:10:00',2.14),('14598','2013-10-21','16:15:00',2.02),('14598','2013-10-21','16:20:00',2),('14598','2013-10-21','16:25:00',1.94),('14598','2013-10-21','16:30:00',1.78),('14598','2013-10-21','16:35:00',1.45),('14598','2013-10-21','16:40:00',1.48),('14598','2013-10-21','16:45:00',1.48),('14598','2013-10-21','16:50:00',1.4),('14598','2013-10-21','16:55:00',1.43),('14598','2013-10-21','17:00:00',1.35),('14598','2013-10-21','17:05:00',1.23),('14598','2013-10-21','17:10:00',1.12),('14598','2013-10-21','17:15:00',1.04),('14598','2013-10-20','09:20:00',1.1),('14598','2013-10-20','09:25:00',1.23),('14598','2013-10-20','09:30:00',1.19),('14598','2013-10-20','09:35:00',1.33),('14598','2013-10-20','09:40:00',1.8),('14598','2013-10-20','09:45:00',2.2),('14598','2013-10-20','09:50:00',1.74),('14598','2013-10-20','09:55:00',1.87),('14598','2013-10-20','10:00:00',2),('14598','2013-10-20','10:05:00',2.12),('14598','2013-10-20','10:10:00',2.08),('14598','2013-10-20','10:15:00',1.74),('14598','2013-10-20','10:20:00',1.73),('14598','2013-10-20','10:25:00',1.67),('14598','2013-10-20','10:30:00',1.47),('14598','2013-10-20','10:35:00',1.39),('14598','2013-10-20','10:40:00',1.38),('14598','2013-10-20','10:45:00',1.27),('14598','2013-10-20','10:50:00',2.36),('14598','2013-10-20','10:55:00',2.17),('14598','2013-10-20','11:00:00',2.79),('14598','2013-10-20','11:05:00',2.63),('14598','2013-10-20','11:10:00',2.78),('14598','2013-10-20','11:15:00',2.94),('14598','2013-10-20','11:20:00',2.95),('14598','2013-10-20','11:25:00',2.99),('14598','2013-10-20','11:30:00',3.03),('14598','2013-10-20','11:35:00',3.06),('14598','2013-10-20','11:40:00',3.05),('14598','2013-10-20','11:45:00',3.13),('14598','2013-10-20','11:50:00',3.08),('14598','2013-10-20','11:55:00',3.2),('14598','2013-10-20','12:00:00',3.24),('14598','2013-10-20','12:05:00',3.23),('14598','2013-10-20','12:10:00',3.32),('14598','2013-10-20','12:15:00',3.25),('14598','2013-10-20','12:20:00',3.16),('14598','2013-10-20','12:25:00',3.09),('14598','2013-10-20','12:30:00',3.33),('14598','2013-10-20','12:35:00',3.3),('14598','2013-10-20','12:40:00',3.91),('14598','2013-10-20','12:45:00',3.75),('14598','2013-10-20','12:50:00',3.79),('14598','2013-10-20','12:55:00',3.6),('14598','2013-10-20','13:00:00',3.68),('14598','2013-10-20','13:05:00',3.68),('14598','2013-10-20','13:10:00',3.65),('14598','2013-10-20','13:15:00',3.67),('14598','2013-10-20','13:20:00',3.67),('14598','2013-10-20','13:25:00',3.66),('14598','2013-10-20','13:30:00',3.67),('14598','2013-10-20','13:35:00',3.67),('14598','2013-10-20','13:40:00',3.64),('14598','2013-10-20','13:45:00',3.63),('14598','2013-10-20','13:50:00',3.61),('14598','2013-10-20','13:55:00',3.61),('14598','2013-10-20','14:00:00',3.59),('14598','2013-10-20','14:05:00',3.59),('14598','2013-10-20','14:10:00',3.55),('14598','2013-10-20','14:15:00',3.52),('14598','2013-10-20','14:20:00',3.5),('14598','2013-10-20','14:25:00',3.47),('14598','2013-10-20','14:30:00',3.43),('14598','2013-10-20','14:35:00',3.41),('14598','2013-10-20','14:40:00',3.35),('14598','2013-10-20','14:45:00',3.34),('14598','2013-10-20','14:50:00',3.29),('14598','2013-10-20','14:55:00',3.26),('14598','2013-10-20','15:00:00',3.21),('14598','2013-10-20','15:05:00',3.16),('14598','2013-10-20','15:10:00',3.11),('14598','2013-10-20','15:15:00',3.06),('14598','2013-10-20','15:20:00',3),('14598','2013-10-20','15:25:00',2.94),('14598','2013-10-20','15:30:00',2.87),('14598','2013-10-20','15:35:00',2.82),('14598','2013-10-20','15:40:00',2.76),('14598','2013-10-20','15:45:00',2.68),('14598','2013-10-20','15:50:00',2.6),('14598','2013-10-20','15:55:00',2.49),('14598','2013-10-20','16:00:00',2.41),('14598','2013-10-20','16:05:00',2.35),('14598','2013-10-20','16:10:00',2.27),('14598','2013-10-20','16:15:00',2.19),('14598','2013-10-20','16:20:00',2.12),('14598','2013-10-20','16:25:00',2.04),('14598','2013-10-20','16:30:00',1.94),('14598','2013-10-20','16:35:00',1.86),('14598','2013-10-20','16:40:00',1.76),('14598','2013-10-20','16:45:00',1.66),('14598','2013-10-20','16:50:00',1.57),('14598','2013-10-20','16:55:00',1.48),('14598','2013-10-20','17:00:00',1.37),('14598','2013-10-20','17:05:00',1.26),('14598','2013-10-20','17:10:00',1.16),('14598','2013-10-20','17:15:00',1.06),('14598','2013-10-19','09:05:00',1.02),('14598','2013-10-19','09:10:00',1.15),('14598','2013-10-19','09:15:00',1.19),('14598','2013-10-19','09:20:00',1.28),('14598','2013-10-19','09:25:00',1.37),('14598','2013-10-19','09:30:00',1.5),('14598','2013-10-19','09:35:00',1.56),('14598','2013-10-19','09:40:00',1.64),('14598','2013-10-19','09:45:00',1.72),('14598','2013-10-19','09:50:00',1.87),('14598','2013-10-19','09:55:00',1.96),('14598','2013-10-19','10:00:00',2.05),('14598','2013-10-19','10:05:00',2.14),('14598','2013-10-19','10:10:00',2.23),('14598','2013-10-19','10:15:00',2.31),('14598','2013-10-19','10:20:00',2.37),('14598','2013-10-19','10:25:00',2.11),('14598','2013-10-19','10:30:00',2.57),('14598','2013-10-19','10:35:00',2.56),('14598','2013-10-19','10:40:00',2.53),('14598','2013-10-19','10:45:00',2.55),('14598','2013-10-19','10:50:00',2.83),('14598','2013-10-19','10:55:00',2.92),('14598','2013-10-19','11:00:00',2.99),('14598','2013-10-19','11:05:00',3.03),('14598','2013-10-19','11:10:00',3.1),('14598','2013-10-19','11:15:00',3.04),('14598','2013-10-19','11:20:00',3.03),('14598','2013-10-19','11:25:00',3.17),('14598','2013-10-19','11:30:00',3.34),('14598','2013-10-19','11:35:00',3.37),('14598','2013-10-19','11:40:00',3.32),('14598','2013-10-19','11:45:00',3.42),('14598','2013-10-19','11:50:00',3.44),('14598','2013-10-19','11:55:00',3.59),('14598','2013-10-19','12:00:00',3.63),('14598','2013-10-19','12:05:00',3.67),('14598','2013-10-19','12:10:00',3.7),('14598','2013-10-19','12:15:00',3.8),('14598','2013-10-19','12:20:00',4.03),('14598','2013-10-19','12:25:00',4.23),('14598','2013-10-19','12:30:00',3.17),('14598','2013-10-19','12:35:00',2.49),('14598','2013-10-19','12:40:00',3.01),('14598','2013-10-19','12:45:00',3.73),('14598','2013-10-19','12:50:00',4),('14598','2013-10-19','12:55:00',4.54),('14598','2013-10-19','13:00:00',3.59),('14598','2013-10-19','13:05:00',3.69),('14598','2013-10-19','13:10:00',3.25),('14598','2013-10-19','13:15:00',4.02),('14598','2013-10-19','13:20:00',4.26),('14598','2013-10-19','13:25:00',4.22),('14598','2013-10-19','13:30:00',4.14),('14598','2013-10-19','13:35:00',3.81),('14598','2013-10-19','13:40:00',3.83),('14598','2013-10-19','13:45:00',3.81),('14598','2013-10-19','13:50:00',3.87),('14598','2013-10-19','13:55:00',3.39),('14598','2013-10-19','14:00:00',3.15),('14598','2013-10-19','14:05:00',2.42),('14598','2013-10-19','14:10:00',3.75),('14598','2013-10-19','14:15:00',3.58),('14598','2013-10-19','14:20:00',3.6),('14598','2013-10-19','14:25:00',3.49),('14598','2013-10-19','14:30:00',3.5),('14598','2013-10-19','14:35:00',3.45),('14598','2013-10-19','14:40:00',3.35),('14598','2013-10-19','14:45:00',3.35),('14598','2013-10-19','14:50:00',3.3),('14598','2013-10-19','14:55:00',3.38),('14598','2013-10-19','15:00:00',3.21),('14598','2013-10-19','15:05:00',3.08),('14598','2013-10-19','15:10:00',3.14),('14598','2013-10-19','15:15:00',3.33),('14598','2013-10-19','15:20:00',3.3),('14598','2013-10-19','15:25:00',3.2),('14598','2013-10-19','15:30:00',3),('14598','2013-10-19','15:35:00',2.44),('14598','2013-10-19','15:40:00',3),('14598','2013-10-19','15:45:00',1.24),('14598','2013-10-19','15:50:00',1.65),('14598','2013-10-19','15:55:00',2.37),('14598','2013-10-19','16:00:00',2.75),('14598','2013-10-19','16:05:00',2.71),('14598','2013-10-19','16:10:00',2.55),('14598','2013-10-19','16:15:00',2.58),('14598','2013-10-19','16:20:00',2.47),('14598','2013-10-19','16:25:00',1.85),('14598','2013-10-19','16:30:00',2.39),('14598','2013-10-19','16:35:00',1.46),('14598','2013-10-19','16:40:00',1.63),('14598','2013-10-19','16:45:00',1.91),('14598','2013-10-19','16:50:00',1.59),('14598','2013-10-19','16:55:00',1.74),('14598','2013-10-19','17:00:00',1.81),('14598','2013-10-19','17:05:00',1.76),('14598','2013-10-19','17:10:00',1.55),('14598','2013-10-19','17:15:00',1.1),('14598','2013-10-19','17:20:00',1.07),('14598','2014-05-04','07:45:00',1.2),('14598','2014-05-04','07:50:00',1.29),('14598','2014-05-04','07:55:00',1.26),('14598','2014-05-04','08:00:00',1.21),('14598','2014-05-04','08:05:00',1.51),('14598','2014-05-04','08:10:00',1.18),('14598','2014-05-04','08:15:00',1.78),('14598','2014-05-04','08:20:00',1.7),('14598','2014-05-04','08:25:00',2.09),('14598','2014-05-04','08:30:00',1.88),('14598','2014-05-04','08:35:00',2.19),('14598','2014-05-04','08:40:00',1.86),('14598','2014-05-04','08:45:00',2.06),('14598','2014-05-04','08:50:00',2.14),('14598','2014-05-04','08:55:00',2.27),('14598','2014-05-04','09:00:00',2.25),('14598','2014-05-04','09:05:00',2.69),('14598','2014-05-04','09:10:00',3.04),('14598','2014-05-04','09:15:00',2.1),('14598','2014-05-04','09:20:00',1.45),('14598','2014-05-04','09:25:00',1.53),('14598','2014-05-04','09:30:00',1.45),('14598','2014-05-04','09:35:00',2.21),('14598','2014-05-04','09:40:00',3.49),('14598','2014-05-04','09:45:00',4.29),('14598','2014-05-04','09:50:00',3.62),('14598','2014-05-04','09:55:00',1.99),('14598','2014-05-04','10:00:00',1.76),('14598','2014-05-04','10:05:00',2.42),('14598','2014-05-04','10:10:00',2.11),('14598','2014-05-04','10:15:00',2.31),('14598','2014-05-04','10:20:00',1.7),('14598','2014-05-04','10:25:00',2),('14598','2014-05-04','10:30:00',3.25),('14598','2014-05-04','10:35:00',3.26),('14598','2014-05-04','10:40:00',2.7),('14598','2014-05-04','10:45:00',3.34),('14598','2014-05-04','10:50:00',3.11),('14598','2014-05-04','10:55:00',4.06),('14598','2014-05-04','11:00:00',3.79),('14598','2014-05-04','11:05:00',3.55),('14598','2014-05-04','11:10:00',3.46),('14598','2014-05-04','11:15:00',3.19),('14598','2014-05-04','11:20:00',4.82),('14598','2014-05-04','11:25:00',4.68),('14598','2014-05-04','11:30:00',4.47),('14598','2014-05-04','11:35:00',4.08),('14598','2014-05-04','11:40:00',5.08),('14598','2014-05-04','11:45:00',4.2),('14598','2014-05-04','11:50:00',4.67),('14598','2014-05-04','11:55:00',4.57),('14598','2014-05-04','12:00:00',4.91),('14598','2014-05-04','12:05:00',4.97),('14598','2014-05-04','12:10:00',4.92),('14598','2014-05-04','12:15:00',5.08),('14598','2014-05-04','12:20:00',5.05),('14598','2014-05-04','12:25:00',5.06),('14598','2014-05-04','12:30:00',5.21),('14598','2014-05-04','12:35:00',5.44),('14598','2014-05-04','12:40:00',3.38),('14598','2014-05-04','12:45:00',2.52),('14598','2014-05-04','12:50:00',3.47),('14598','2014-05-04','12:55:00',5.08),('14598','2014-05-04','13:00:00',4.64),('14598','2014-05-04','13:05:00',4.83),('14598','2014-05-04','13:10:00',3.92),('14598','2014-05-04','13:15:00',3.97),('14598','2014-05-04','13:20:00',4.05),('14598','2014-05-04','13:25:00',4.37),('14598','2014-05-04','13:30:00',1.86),('14598','2014-05-04','13:35:00',1.74),('14598','2014-05-04','13:40:00',1.17),('14598','2014-05-04','14:15:00',1.07),('14598','2014-05-04','15:25:00',1.21),('14598','2014-05-04','15:30:00',1.51),('14598','2014-05-04','15:35:00',1.74),('14598','2014-05-04','15:40:00',2.55),('14598','2014-05-04','15:45:00',3.25),('14598','2014-05-04','15:50:00',4.04),('14598','2014-05-04','15:55:00',5.48),('14598','2014-05-04','16:00:00',4.87),('14598','2014-05-04','16:05:00',3.49),('14598','2014-05-04','16:10:00',3.5),('14598','2014-05-04','16:15:00',2.56),('14598','2014-05-04','16:20:00',2.4),('14598','2014-05-04','16:25:00',1.74),('14598','2014-05-04','16:30:00',2.25),('14598','2014-04-16','08:20:00',1.01),('14598','2014-04-16','08:25:00',1.1),('14598','2014-04-16','08:30:00',1.22),('14598','2014-04-16','08:35:00',1.33),('14598','2014-04-16','08:40:00',1.45),('14598','2014-04-16','08:45:00',1.56),('14598','2014-04-16','08:50:00',1.67),('14598','2014-04-16','08:55:00',1.78),('14598','2014-04-16','09:00:00',1.91),('14598','2014-04-16','09:05:00',2.07),('14598','2014-04-16','09:10:00',2.2),('14598','2014-04-16','09:15:00',2.32),('14598','2014-04-16','09:20:00',2.43),('14598','2014-04-16','09:25:00',2.54),('14598','2014-04-16','09:30:00',2.65),('14598','2014-04-16','09:35:00',2.75),('14598','2014-04-16','09:40:00',2.83),('14598','2014-04-16','09:45:00',2.96),('14598','2014-04-16','09:50:00',3.07),('14598','2014-04-16','09:55:00',3.28),('14598','2014-04-16','10:00:00',3.51),('14598','2014-04-16','10:05:00',3.41),('14598','2014-04-16','10:10:00',3.47),('14598','2014-04-16','10:15:00',3.58),('14598','2014-04-16','10:20:00',3.69),('14598','2014-04-16','10:25:00',3.76),('14598','2014-04-16','10:30:00',3.89),('14598','2014-04-16','10:35:00',3.69),('14598','2014-04-16','10:40:00',4.06),('14598','2014-04-16','10:45:00',4.1),('14598','2014-04-16','10:50:00',4.15),('14598','2014-04-16','10:55:00',4.21),('14598','2014-04-16','11:00:00',4.4),('14598','2014-04-16','11:05:00',4.09),('14598','2014-04-16','11:10:00',3.8),('14598','2014-04-16','11:15:00',2.72),('14598','2014-04-16','11:20:00',3.15),('14598','2014-04-16','11:25:00',4.02),('14598','2014-04-16','11:30:00',3.77),('14598','2014-04-16','11:35:00',4.86),('14598','2014-04-16','11:40:00',4.33),('14598','2014-04-16','11:45:00',3.11),('14598','2014-04-16','11:50:00',3.16),('14598','2014-04-16','11:55:00',2.81),('14598','2014-04-16','12:00:00',5.23),('14598','2014-04-16','12:05:00',2.99),('14598','2014-04-16','12:10:00',4.06),('14598','2014-04-16','12:15:00',5.11),('14598','2014-04-16','12:20:00',4.77),('14598','2014-04-16','12:25:00',5.57),('14598','2014-04-16','12:30:00',4.51),('14598','2014-04-16','12:35:00',3.62),('14598','2014-04-16','12:40:00',4.64),('14598','2014-04-16','12:45:00',4.53),('14598','2014-04-16','12:50:00',2.53),('14598','2014-04-16','12:55:00',4.49),('14598','2014-04-16','13:00:00',4.79),('14598','2014-04-16','13:05:00',5.54),('14598','2014-04-16','13:10:00',5.79),('14598','2014-04-16','13:15:00',5.25),('14598','2014-04-16','13:20:00',4.52),('14598','2014-04-16','13:25:00',3.68),('14598','2014-04-16','13:30:00',2.47),('14598','2014-04-16','13:35:00',5.49),('14598','2014-04-16','13:40:00',4.07),('14598','2014-04-16','13:45:00',4.99),('14598','2014-04-16','13:50:00',5.57),('14598','2014-04-16','13:55:00',5.5),('14598','2014-04-16','14:00:00',5.47),('14598','2014-04-16','14:05:00',5.46),('14598','2014-04-16','14:10:00',5.46),('14598','2014-04-16','14:15:00',5.58),('14598','2014-04-16','14:20:00',5.79),('14598','2014-04-16','14:25:00',5.54),('14598','2014-04-16','14:30:00',5.39),('14598','2014-04-16','14:35:00',5.38),('14598','2014-04-16','14:40:00',4.16),('14598','2014-04-16','14:45:00',5.49),('14598','2014-04-16','14:50:00',5.02),('14598','2014-04-16','14:55:00',5.26),('14598','2014-04-16','15:00:00',5.13),('14598','2014-04-16','15:05:00',4.85),('14598','2014-04-16','15:10:00',5.09),('14598','2014-04-16','15:15:00',5.29),('14598','2014-04-16','15:20:00',4.06),('14598','2014-04-16','15:25:00',4.64),('14598','2014-04-16','15:30:00',5.17),('14598','2014-04-16','15:35:00',5.25),('14598','2014-04-16','15:40:00',5.22),('14598','2014-04-16','15:45:00',4.93),('14598','2014-04-16','15:50:00',4.73),('14598','2014-04-16','15:55:00',4.58),('14598','2014-04-16','16:00:00',4.29),('14598','2014-04-16','16:05:00',4.43),('14598','2014-04-16','16:10:00',4.5),('14598','2014-04-16','16:15:00',4.43),('14598','2014-04-16','16:20:00',1.82),('14598','2014-04-16','16:25:00',4.49),('14598','2014-04-16','16:30:00',4.17),('14598','2014-04-16','16:35:00',4.14),('14598','2014-04-16','16:40:00',4.33),('14598','2014-04-16','16:45:00',2.72),('14598','2014-04-16','17:05:00',2.6),('14598','2014-04-16','17:10:00',2.72),('14598','2014-04-16','17:15:00',3.17),('14598','2014-04-16','17:20:00',2.92),('14598','2014-04-16','17:25:00',3.09),('14598','2014-04-16','17:30:00',2.95),('14598','2014-04-16','17:35:00',2.87),('14598','2014-04-16','17:40:00',2.75),('14598','2014-04-16','17:45:00',2.63),('14598','2014-04-16','17:50:00',2.52),('14598','2014-04-16','17:55:00',2.5),('14598','2014-04-16','18:00:00',2.46),('14598','2014-04-16','18:05:00',2.39),('14598','2014-04-16','18:10:00',2.15),('14598','2014-04-16','18:15:00',2.05),('14598','2014-04-16','18:20:00',1.73),('14598','2014-04-16','18:25:00',1.39),('14598','2014-04-16','18:55:00',1.05),('14598','2013-10-18','09:10:00',1.03),('14598','2013-10-18','09:15:00',1.16),('14598','2013-10-18','09:20:00',1.28),('14598','2013-10-18','09:25:00',1.38),('14598','2013-10-18','09:30:00',1.5),('14598','2013-10-18','09:35:00',1.6),('14598','2013-10-18','09:40:00',1.7),('14598','2013-10-18','09:45:00',1.78),('14598','2013-10-18','09:50:00',1.89),('14598','2013-10-18','09:55:00',2),('14598','2013-10-18','10:00:00',2.08),('14598','2013-10-18','10:05:00',2.11),('14598','2013-10-18','10:10:00',2.18),('14598','2013-10-18','10:15:00',1.98),('14598','2013-10-18','10:20:00',2.1),('14598','2013-10-18','10:25:00',2.27),('14598','2013-10-18','10:30:00',2.4),('14598','2013-10-18','10:35:00',2.67),('14598','2013-10-18','10:40:00',2.7),('14598','2013-10-18','10:45:00',2.6),('14598','2013-10-18','10:50:00',2.68),('14598','2013-10-18','10:55:00',2.72),('14598','2013-10-18','11:00:00',2.82),('14598','2013-10-18','11:05:00',2.64),('14598','2013-10-18','11:10:00',2.83),('14598','2013-10-18','11:15:00',3.09),('14598','2013-10-18','11:20:00',3.13),('14598','2013-10-18','11:25:00',3.23),('14598','2013-10-18','11:30:00',3.3),('14598','2013-10-18','11:35:00',3.06),('14598','2013-10-18','11:40:00',2.77),('14598','2013-10-18','11:45:00',3.32),('14598','2013-10-18','11:50:00',3.37),('14598','2013-10-18','11:55:00',3.36),('14598','2013-10-18','12:00:00',3.44),('14598','2013-10-18','12:05:00',3.52),('14598','2013-10-18','12:10:00',3.54),('14598','2013-10-18','12:15:00',3.56),('14598','2013-10-18','12:20:00',3.55),('14598','2013-10-18','12:25:00',3.58),('14598','2013-10-18','12:30:00',3.46),('14598','2013-10-18','12:35:00',3.51),('14598','2013-10-18','12:40:00',3.59),('14598','2013-10-18','12:45:00',3.64),('14598','2013-10-18','12:50:00',3.7),('14598','2013-10-18','12:55:00',3.55),('14598','2013-10-18','13:00:00',3.61),('14598','2013-10-18','13:05:00',3.61),('14598','2013-10-18','13:10:00',3.63),('14598','2013-10-18','13:15:00',3.76),('14598','2013-10-18','13:20:00',3.27),('14598','2013-10-18','13:25:00',3.77),('14598','2013-10-18','13:30:00',3.68),('14598','2013-10-18','13:35:00',3.71),('14598','2013-10-18','13:40:00',3.82),('14598','2013-10-18','13:45:00',3.76),('14598','2013-10-18','13:50:00',3.73),('14598','2013-10-18','13:55:00',3.61),('14598','2013-10-18','14:00:00',3.65),('14598','2013-10-18','14:05:00',3.75),('14598','2013-10-18','14:10:00',3.75),('14598','2013-10-18','14:15:00',3.61),('14598','2013-10-18','14:20:00',3.73),('14598','2013-10-18','14:25:00',3.39),('14598','2013-10-18','14:30:00',3.49),('14598','2013-10-18','14:35:00',3.65),('14598','2013-10-18','14:40:00',3.5),('14598','2013-10-18','14:45:00',3.61),('14598','2013-10-18','14:50:00',3.57),('14598','2013-10-18','14:55:00',3.33),('14598','2013-10-18','15:00:00',3.12),('14598','2013-10-18','15:05:00',3.27),('14598','2013-10-18','15:10:00',3.12),('14598','2013-10-18','15:15:00',2.74),('14598','2013-10-18','15:20:00',2.66),('14598','2013-10-18','15:25:00',2.77),('14598','2013-10-18','15:30:00',2.53),('14598','2013-10-18','15:35:00',2.37),('14598','2013-10-18','15:40:00',2.55),('14598','2013-10-18','15:45:00',2.57),('14598','2013-10-18','15:50:00',2.68),('14598','2013-10-18','15:55:00',2.6),('14598','2013-10-18','16:00:00',2.28),('14598','2013-10-18','16:05:00',2.17),('14598','2013-10-18','16:10:00',2.04),('14598','2013-10-18','16:15:00',2.01),('14598','2013-10-18','16:20:00',1.93),('14598','2013-10-18','16:25:00',1.8),('14598','2013-10-18','16:30:00',1.46),('14598','2013-10-18','16:35:00',1.3),('14598','2013-10-18','16:40:00',1.39),('14598','2013-10-18','16:45:00',1.47),('14598','2013-10-18','16:50:00',1.3),('14598','2013-10-18','16:55:00',1.17),('14598','2013-10-18','17:00:00',1.15),('14598','2013-10-17','09:10:00',1.02),('14598','2013-10-17','09:15:00',1.14),('14598','2013-10-17','09:20:00',1.25),('14598','2013-10-17','09:25:00',1.38),('14598','2013-10-17','09:30:00',1.48),('14598','2013-10-17','09:35:00',1.58),('14598','2013-10-17','09:40:00',1.68),('14598','2013-10-17','09:45:00',1.78),('14598','2013-10-17','09:50:00',1.88),('14598','2013-10-17','09:55:00',1.96),('14598','2013-10-17','10:00:00',2.04),('14598','2013-10-17','10:05:00',2.15),('14598','2013-10-17','10:10:00',2.22),('14598','2013-10-17','10:15:00',2.31),('14598','2013-10-17','10:20:00',2.4),('14598','2013-10-17','10:25:00',2.47),('14598','2013-10-17','10:30:00',2.54),('14598','2013-10-17','10:35:00',2.62),('14598','2013-10-17','10:40:00',2.7),('14598','2013-10-17','10:45:00',2.78),('14598','2013-10-17','10:50:00',2.84),('14598','2013-10-17','10:55:00',2.91),('14598','2013-10-17','11:00:00',2.98),('14598','2013-10-17','11:05:00',3.04),('14598','2013-10-17','11:10:00',3.11),('14598','2013-10-17','11:15:00',3.17),('14598','2013-10-17','11:20:00',3.2),('14598','2013-10-17','11:25:00',3.27),('14598','2013-10-17','11:30:00',3.32),('14598','2013-10-17','11:35:00',3.38),('14598','2013-10-17','11:40:00',3.41),('14598','2013-10-17','11:45:00',3.45),('14598','2013-10-17','11:50:00',3.48),('14598','2013-10-17','11:55:00',3.52),('14598','2013-10-17','12:00:00',3.57),('14598','2013-10-17','12:05:00',3.62),('14598','2013-10-17','12:10:00',3.65),('14598','2013-10-17','12:15:00',3.66),('14598','2013-10-17','12:20:00',3.68),('14598','2013-10-17','12:25:00',3.7),('14598','2013-10-17','12:30:00',3.71),('14598','2013-10-17','12:35:00',3.74),('14598','2013-10-17','12:40:00',3.76),('14598','2013-10-17','12:45:00',3.75),('14598','2013-10-17','12:50:00',3.77),('14598','2013-10-17','12:55:00',3.81),('14598','2013-10-17','13:00:00',3.81),('14598','2013-10-17','13:05:00',3.8),('14598','2013-10-17','13:10:00',3.83),('14598','2013-10-17','13:15:00',3.84),('14598','2013-10-17','13:20:00',3.82),('14598','2013-10-17','13:25:00',3.83),('14598','2013-10-17','13:30:00',3.85),('14598','2013-10-17','13:35:00',3.86),('14598','2013-10-17','13:40:00',3.85),('14598','2013-10-17','13:45:00',3.88),('14598','2013-10-17','13:50:00',3.87),('14598','2013-10-17','13:55:00',3.86),('14598','2013-10-17','14:00:00',3.86),('14598','2013-10-17','14:05:00',3.83),('14598','2013-10-17','14:10:00',3.81),('14598','2013-10-17','14:15:00',3.78),('14598','2013-10-17','14:20:00',3.76),('14598','2013-10-17','14:25:00',3.75),('14598','2013-10-17','14:30:00',3.73),('14598','2013-10-17','14:35:00',3.68),('14598','2013-10-17','14:40:00',3.64),('14598','2013-10-17','14:45:00',3.61),('14598','2013-10-17','14:50:00',3.58),('14598','2013-10-17','14:55:00',3.54),('14598','2013-10-17','15:00:00',3.49),('14598','2013-10-17','15:05:00',3.47),('14598','2013-10-17','15:10:00',3.41),('14598','2013-10-17','15:15:00',3.36),('14598','2013-10-17','15:20:00',3.31),('14598','2013-10-17','15:25:00',3.25),('14598','2013-10-17','15:30:00',3.2),('14598','2013-10-17','15:35:00',3.14),('14598','2013-10-17','15:40:00',3.07),('14598','2013-10-17','15:45:00',3.01),('14598','2013-10-17','15:50:00',2.95),('14598','2013-10-17','15:55:00',2.88),('14598','2013-10-17','16:00:00',1.88),('14598','2013-10-17','16:05:00',2.4),('14598','2013-10-17','16:10:00',2.64),('14598','2013-10-17','16:15:00',2.55),('14598','2013-10-17','16:25:00',2.22),('14598','2013-10-17','16:30:00',2.28),('14598','2013-10-17','16:35:00',2.18),('14598','2013-10-17','16:40:00',2.09),('14598','2013-10-17','16:45:00',1.98),('14598','2013-10-17','16:50:00',1.89),('14598','2013-10-17','16:55:00',1.79),('14598','2013-10-17','17:00:00',1.68),('14598','2013-10-17','17:05:00',1.57),('14598','2013-10-17','17:10:00',1.46),('14598','2013-10-17','17:15:00',1.36),('14598','2013-10-17','17:20:00',1.25),('14598','2013-10-17','17:25:00',1.15),('14598','2013-10-17','17:30:00',1.03),('14598','2013-10-16','09:05:00',1),('14598','2013-10-16','09:20:00',1.08),('14598','2013-10-16','09:25:00',1.02),('14598','2013-10-16','09:35:00',1.65),('14598','2013-10-16','09:40:00',1.89),('14598','2013-10-16','09:45:00',1.9),('14598','2013-10-16','10:20:00',1.02),('14598','2013-10-16','10:25:00',1.15),('14598','2013-10-16','10:30:00',1.49),('14598','2013-10-16','10:40:00',1.96),('14598','2013-10-16','10:45:00',2.51),('14598','2013-10-16','10:50:00',1.85),('14598','2013-10-16','10:55:00',1.28),('14598','2013-10-16','11:00:00',1.71),('14598','2013-10-16','11:05:00',1.86),('14598','2013-10-16','11:10:00',2.29),('14598','2013-10-16','11:15:00',3.67),('14598','2013-10-16','11:20:00',3.5),('14598','2013-10-16','11:25:00',3.43),('14598','2013-10-16','11:30:00',3.83),('14598','2013-10-16','11:35:00',4.11),('14598','2013-10-16','11:40:00',2.1),('14598','2013-10-16','11:50:00',1.36),('14598','2013-10-16','11:55:00',1.68),('14598','2013-10-16','12:00:00',1.29),('14598','2013-10-16','12:05:00',1.23),('14598','2013-10-16','12:10:00',3.3),('14598','2013-10-16','12:15:00',3.93),('14598','2013-10-16','12:20:00',4.01),('14598','2013-10-16','12:25:00',4.02),('14598','2013-10-16','12:30:00',3.77),('14598','2013-10-16','12:35:00',3.97),('14598','2013-10-16','12:40:00',3.28),('14598','2013-10-16','12:45:00',3.32),('14598','2013-10-16','12:50:00',3.48),('14598','2013-10-16','12:55:00',2.77),('14598','2013-10-16','13:00:00',2.9),('14598','2013-10-16','13:05:00',4.02),('14598','2013-10-16','13:10:00',3.88),('14598','2013-10-16','13:15:00',3.93),('14598','2013-10-16','13:20:00',3.98),('14598','2013-10-16','13:25:00',3.85),('14598','2013-10-16','13:30:00',3.88),('14598','2013-10-16','13:35:00',3.71),('14598','2013-10-16','13:40:00',2.58),('14598','2013-10-16','13:45:00',3.59),('14598','2013-10-16','13:50:00',4.18),('14598','2013-10-16','13:55:00',4.1),('14598','2013-10-16','14:00:00',3.85),('14598','2013-10-16','14:05:00',3.66),('14598','2013-10-16','14:10:00',2.66),('14598','2013-10-16','14:15:00',3.75),('14598','2013-10-16','14:20:00',3.75),('14598','2013-10-16','14:25:00',3.72),('14598','2013-10-16','14:30:00',3.68),('14598','2013-10-16','14:35:00',3.65),('14598','2013-10-16','14:40:00',3.59),('14598','2013-10-16','14:45:00',3.59),('14598','2013-10-16','14:50:00',2.81),('14598','2013-10-16','14:55:00',3.08),('14598','2013-10-16','15:00:00',3.4),('14598','2013-10-16','15:05:00',3.36),('14598','2013-10-16','15:10:00',3.34),('14598','2013-10-16','15:15:00',3.24),('14598','2013-10-16','15:20:00',3.2),('14598','2013-10-16','15:25:00',3.14),('14598','2013-10-16','15:30:00',3.09),('14598','2013-10-16','15:35:00',3.02),('14598','2013-10-16','15:40:00',2.98),('14598','2013-10-16','15:45:00',2.91),('14598','2013-10-16','15:50:00',2.84),('14598','2013-10-16','15:55:00',2.76),('14598','2013-10-16','16:00:00',2.69),('14598','2013-10-16','16:05:00',2.62),('14598','2013-10-16','16:10:00',2.54),('14598','2013-10-16','16:15:00',2.46),('14598','2013-10-16','16:20:00',2.37),('14598','2013-10-16','16:25:00',2.28),('14598','2013-10-16','16:30:00',2.2),('14598','2013-10-16','16:35:00',2.11),('14598','2013-10-16','16:40:00',2.02),('14598','2013-10-16','16:45:00',1.93),('14598','2013-10-16','16:50:00',1.86),('14598','2013-10-16','16:55:00',1.76),('14598','2013-10-16','17:00:00',1.66),('14598','2013-10-16','17:05:00',1.56),('14598','2013-10-16','17:10:00',1.45),('14598','2013-10-16','17:15:00',1.34),('14598','2013-10-16','17:20:00',1.22),('14598','2013-10-16','17:25:00',1.09),('14598','2013-10-15','09:25:00',1.11),('14598','2013-10-15','09:30:00',1.47),('14598','2013-10-15','09:35:00',1.86),('14598','2013-10-15','09:40:00',2.01),('14598','2013-10-15','09:45:00',2.04),('14598','2013-10-15','09:50:00',2.28),('14598','2013-10-15','09:55:00',1.92),('14598','2013-10-15','10:00:00',1.33),('14598','2013-10-15','10:05:00',1.4),('14598','2013-10-15','10:10:00',1.76),('14598','2013-10-15','10:22:00',2.18),('14598','2013-10-15','10:25:00',2.53),('14598','2013-10-15','10:30:00',2.66),('14598','2013-10-15','10:35:00',2.04),('14598','2013-10-15','10:40:00',1.83),('14598','2013-10-15','10:45:00',1.89),('14598','2013-10-15','10:50:00',2.49),('14598','2013-10-15','10:55:00',2.94),('14598','2013-10-15','11:00:00',2.96),('14598','2013-10-15','11:05:00',2.77),('14598','2013-10-15','11:10:00',2.54),('14598','2013-10-15','11:15:00',2.78),('14598','2013-10-15','11:20:00',2.24),('14598','2013-10-15','11:25:00',1.91),('14598','2013-10-15','11:30:00',1.82),('14598','2013-10-15','11:35:00',1.84),('14598','2013-10-15','11:40:00',1.8),('14598','2013-10-15','11:45:00',1.71),('14598','2013-10-15','11:50:00',1.65),('14598','2013-10-15','11:55:00',1.68),('14598','2013-10-15','12:00:00',1.75),('14598','2013-10-15','12:05:00',1.82),('14598','2013-10-15','12:10:00',1.59),('14598','2013-10-15','12:15:00',1.57),('14598','2013-10-15','12:20:00',1.6),('14598','2013-10-15','12:25:00',1.73),('14598','2013-10-15','12:30:00',1.84),('14598','2013-10-15','12:35:00',1.69),('14598','2013-10-15','12:40:00',1.63),('14598','2013-10-15','12:45:00',1.75),('14598','2013-10-15','12:50:00',2.24),('14598','2013-10-15','12:55:00',1.98),('14598','2013-10-15','13:00:00',2.46),('14598','2013-10-15','13:05:00',3.46),('14598','2013-10-15','13:10:00',3),('14598','2013-10-15','13:15:00',2.5),('14598','2013-10-15','13:20:00',1.96),('14598','2013-10-15','13:25:00',2.06),('14598','2013-10-15','13:30:00',2),('14598','2013-10-15','13:40:00',1.53),('14598','2013-10-15','13:45:00',1.37),('14598','2013-10-15','13:50:00',1.53),('14598','2013-10-15','13:55:00',1.77),('14598','2013-10-15','14:00:00',2.19),('14598','2013-10-15','14:05:00',2.51),('14598','2013-10-15','14:10:00',2.71),('14598','2013-10-15','14:15:00',2.12),('14598','2013-10-15','14:20:00',1.91),('14598','2013-10-15','14:25:00',2.52),('14598','2013-10-15','14:30:00',3.3),('14598','2013-10-15','14:35:00',2.74),('14598','2013-10-15','14:40:00',1.81),('14598','2013-10-15','14:45:00',1.6),('14598','2013-10-15','14:50:00',1.95),('14598','2013-10-15','14:55:00',1.87),('14598','2013-10-15','15:00:00',1.57),('14598','2013-10-15','15:05:00',1.51),('14598','2013-10-15','15:10:00',1.31),('14598','2013-10-15','15:15:00',1.22),('14598','2013-10-15','15:20:00',1.27),('14598','2013-10-15','15:25:00',1.27),('14598','2013-10-15','15:30:00',1.17),('14598','2013-10-15','15:35:00',1.03),('14598','2013-10-15','16:05:00',1.19),('14598','2013-10-15','16:10:00',1.41),('14598','2013-10-15','16:15:00',1.42),('14598','2013-10-15','16:20:00',1.25),('14598','2013-10-15','16:25:00',1.01),('14598','2013-10-15','16:35:00',1.45),('14598','2013-10-15','16:40:00',1.62),('14598','2013-10-15','16:45:00',1.08),('14598','2013-10-14','09:10:00',1.14),('14598','2013-10-14','09:15:00',1.26),('14598','2013-10-14','09:20:00',1.15),('14598','2013-10-14','09:30:00',1.33),('14598','2013-10-14','09:35:00',1.41),('14598','2013-10-14','09:40:00',1.68),('14598','2013-10-14','09:45:00',1.7),('14598','2013-10-14','09:50:00',1.88),('14598','2013-10-14','09:55:00',1.94),('14598','2013-10-14','10:00:00',2.02),('14598','2013-10-14','10:05:00',2.06),('14598','2013-10-14','10:10:00',2.18),('14598','2013-10-14','10:15:00',2.23),('14598','2013-10-14','10:20:00',2.28),('14598','2013-10-14','10:25:00',2.33),('14598','2013-10-14','10:30:00',2.4),('14598','2013-10-14','10:35:00',2.43),('14598','2013-10-14','10:40:00',2.57),('14598','2013-10-14','10:45:00',2.69),('14598','2013-10-14','10:50:00',2.72),('14598','2013-10-14','10:55:00',2.73),('14598','2013-10-14','11:00:00',2.9),('14598','2013-10-14','11:05:00',2.85),('14598','2013-10-14','11:10:00',2.98),('14598','2013-10-14','11:15:00',3.09),('14598','2013-10-14','11:20:00',3.11),('14598','2013-10-14','11:25:00',3.02),('14598','2013-10-14','11:30:00',3.06),('14598','2013-10-14','11:35:00',2.99),('14598','2013-10-14','11:40:00',3.18),('14598','2013-10-14','11:45:00',3.27),('14598','2013-10-14','11:50:00',3.3),('14598','2013-10-14','11:55:00',3.4),('14598','2013-10-14','12:00:00',3.29),('14598','2013-10-14','12:05:00',3.12),('14598','2013-10-14','12:10:00',3.37),('14598','2013-10-14','12:15:00',3.43),('14598','2013-10-14','12:20:00',3.54),('14598','2013-10-14','12:25:00',3.52),('14598','2013-10-14','12:30:00',3.52),('14598','2013-10-14','12:35:00',3.56),('14598','2013-10-14','12:40:00',3.56),('14598','2013-10-14','12:45:00',3.59),('14598','2013-10-14','12:50:00',3.56),('14598','2013-10-14','12:55:00',3.64),('14598','2013-10-14','13:00:00',3.65),('14598','2013-10-14','13:05:00',3.65),('14598','2013-10-14','13:10:00',3.65),('14598','2013-10-14','13:15:00',3.68),('14598','2013-10-14','13:20:00',3.64),('14598','2013-10-14','13:25:00',3.65),('14598','2013-10-14','13:30:00',3.65),('14598','2013-10-14','13:35:00',3.65),('14598','2013-10-14','13:40:00',3.61),('14598','2013-10-14','13:45:00',3.62),('14598','2013-10-14','13:50:00',3.6),('14598','2013-10-14','13:55:00',3.59),('14598','2013-10-14','14:00:00',3.55),('14598','2013-10-14','14:05:00',3.53),('14598','2013-10-14','14:10:00',3.52),('14598','2013-10-14','14:15:00',3.5),('14598','2013-10-14','14:20:00',3.46),('14598','2013-10-14','14:25:00',3.44),('14598','2013-10-14','14:30:00',3.43),('14598','2013-10-14','14:35:00',3.37),('14598','2013-10-14','14:40:00',3.35),('14598','2013-10-14','14:45:00',3.32),('14598','2013-10-14','14:50:00',3.27),('14598','2013-10-14','14:55:00',3.21),('14598','2013-10-14','15:00:00',3.19),('14598','2013-10-14','15:05:00',3.14),('14598','2013-10-14','15:10:00',3.09),('14598','2013-10-14','15:15:00',3.08),('14598','2013-10-14','15:20:00',3.04),('14598','2013-10-14','15:25:00',3.01),('14598','2013-10-14','15:30:00',2.89),('14598','2013-10-14','15:35:00',2.76),('14598','2013-10-14','15:40:00',2.83),('14598','2013-10-14','15:45:00',2.37),('14598','2013-10-14','15:50:00',1.7),('14598','2013-10-14','15:55:00',2.09),('14598','2013-10-14','16:00:00',2.27),('14598','2013-10-14','16:05:00',1.82),('14598','2013-10-14','16:10:00',1.87),('14598','2013-10-14','16:25:00',1.33),('14598','2013-10-14','16:30:00',2.44),('14598','2013-10-14','16:35:00',1.35),('14598','2013-10-14','16:40:00',1.18),('14598','2013-10-14','16:55:00',1.01),('14598','2013-10-14','17:00:00',1.22),('14598','2013-10-14','17:05:00',1.43),('14598','2013-10-14','17:10:00',1.37),('14598','2013-10-14','17:15:00',1.32),('14598','2013-10-14','17:20:00',1.15),('14598','2013-10-14','17:25:00',1.02),('14598','2013-10-13','09:20:00',1.05),('14598','2013-10-13','09:25:00',1.24),('14598','2013-10-13','09:30:00',1.26),('14598','2013-10-13','09:35:00',1.4),('14598','2013-10-13','09:40:00',1.17),('14598','2013-10-13','09:45:00',1.02),('14598','2013-10-13','09:50:00',1.64),('14598','2013-10-13','09:55:00',1.39),('14598','2013-10-13','10:00:00',1.03),('14598','2013-10-13','10:05:00',1.01),('14598','2013-10-13','10:10:00',1.34),('14598','2013-10-13','10:15:00',2.48),('14598','2013-10-13','10:20:00',2.21),('14598','2013-10-13','10:25:00',2.36),('14598','2013-10-13','10:30:00',2.04),('14598','2013-10-13','10:35:00',2.86),('14598','2013-10-13','10:40:00',2.02),('14598','2013-10-13','10:45:00',1.88),('14598','2013-10-13','10:50:00',2.82),('14598','2013-10-13','10:55:00',2.19),('14598','2013-10-13','11:00:00',2.2),('14598','2013-10-13','11:05:00',2.22),('14598','2013-10-13','11:10:00',2.22),('14598','2013-10-13','11:15:00',2.41),('14598','2013-10-13','11:20:00',3.25),('14598','2013-10-13','11:25:00',3.33),('14598','2013-10-13','11:30:00',3.32),('14598','2013-10-13','11:35:00',3.15),('14598','2013-10-13','11:40:00',3.27),('14598','2013-10-13','11:45:00',3.37),('14598','2013-10-13','11:50:00',3.43),('14598','2013-10-13','11:55:00',3.49),('14598','2013-10-13','12:00:00',3.49),('14598','2013-10-13','12:05:00',3.55),('14598','2013-10-13','12:10:00',3.62),('14598','2013-10-13','12:15:00',3.57),('14598','2013-10-13','12:20:00',3.46),('14598','2013-10-13','12:25:00',3.69),('14598','2013-10-13','12:30:00',3.64),('14598','2013-10-13','12:35:00',3.65),('14598','2013-10-13','12:40:00',3.65),('14598','2013-10-13','12:45:00',3.66),('14598','2013-10-13','12:50:00',3.72),('14598','2013-10-13','12:55:00',3.77),('14598','2013-10-13','13:00:00',3.82),('14598','2013-10-13','13:05:00',3.88),('14598','2013-10-13','13:10:00',3.8),('14598','2013-10-13','13:15:00',3.79),('14598','2013-10-13','13:20:00',3.83),('14598','2013-10-13','13:25:00',3.89),('14598','2013-10-13','13:30:00',3.89),('14598','2013-10-13','13:35:00',3.37),('14598','2013-10-13','13:40:00',3.5),('14598','2013-10-13','13:45:00',3.89),('14598','2013-10-13','13:50:00',3.06),('14598','2013-10-13','13:55:00',3.77),('14598','2013-10-13','14:00:00',3.31),('14598','2013-10-13','14:05:00',4.13),('14598','2013-10-13','14:10:00',4.17),('14598','2013-10-13','14:15:00',3.35),('14598','2013-10-13','14:20:00',3.43),('14598','2013-10-13','14:25:00',2.81),('14598','2013-10-13','14:30:00',3.29),('14598','2013-10-13','14:35:00',3.4),('14598','2013-10-13','14:40:00',3),('14598','2013-10-13','14:45:00',2.85),('14598','2013-10-13','14:50:00',3.01),('14598','2013-10-13','14:55:00',2.8),('14598','2013-10-13','15:00:00',3.03),('14598','2013-10-13','15:05:00',3.07),('14598','2013-10-13','15:10:00',2.26),('14598','2013-10-13','15:15:00',2.53),('14598','2013-10-13','15:20:00',2.08),('14598','2013-10-13','15:25:00',1.61),('14598','2013-10-13','15:30:00',1.92),('14598','2013-10-13','15:35:00',2.33),('14598','2013-10-13','15:40:00',2.67),('14598','2013-10-13','15:45:00',2.34),('14598','2013-10-13','15:50:00',2.87),('14598','2013-10-13','15:55:00',2.72),('14598','2013-10-13','16:00:00',2.33),('14598','2013-10-13','16:05:00',2.54),('14598','2013-10-13','16:10:00',2.39),('14598','2013-10-13','16:15:00',2.23),('14598','2013-10-13','16:20:00',2.05),('14598','2013-10-13','16:25:00',2.26),('14598','2013-10-13','16:30:00',1.77),('14598','2013-10-13','16:35:00',1.38),('14598','2013-10-13','16:55:00',1.1),('14598','2013-10-13','17:00:00',1.02),('14598','2013-10-13','17:05:00',1.12),('14598','2013-10-13','17:10:00',1.51),('14598','2013-10-13','17:15:00',1.15),('14598','2013-10-13','17:20:00',1.25),('14598','2013-10-13','17:25:00',1.35),('14598','2013-10-13','17:30:00',1.03),('14598','2013-10-12','11:15:00',1.25),('14598','2013-10-12','11:20:00',1.87),('14598','2013-10-12','11:25:00',1.94),('14598','2013-10-12','11:30:00',1.66),('14598','2013-10-12','11:35:00',1.21),('14598','2013-10-12','11:50:00',1.1),('14598','2013-10-12','11:55:00',1.3),('14598','2013-10-12','12:00:00',1.43),('14598','2013-10-12','12:05:00',2.26),('14598','2013-10-12','12:10:00',3.69),('14598','2013-10-12','12:15:00',1.88),('14598','2013-10-12','12:20:00',1.75),('14598','2013-10-12','12:25:00',3.07),('14598','2013-10-12','12:30:00',3.9),('14598','2013-10-12','12:35:00',3.89),('14598','2013-10-12','12:40:00',2.78),('14598','2013-10-12','12:45:00',2.13),('14598','2013-10-12','12:50:00',1.88),('14598','2013-10-12','12:55:00',1.84),('14598','2013-10-12','13:00:00',1.49),('14598','2013-10-12','13:05:00',1.31),('14598','2013-10-12','13:10:00',1.23),('14598','2013-10-12','14:50:00',1.06),('14598','2013-10-12','14:55:00',1.04),('14598','2013-10-12','15:00:00',1.14),('14598','2013-10-12','15:05:00',1.22),('14598','2013-10-12','15:10:00',1.08),('14598','2013-10-12','15:15:00',1.02),('14598','2013-10-12','15:20:00',1.09),('14598','2013-10-12','15:25:00',1.08),('14598','2013-10-12','15:30:00',1.03),('14598','2013-10-12','15:40:00',1.03),('14598','2013-10-12','16:10:00',1.65),('14598','2013-10-12','16:15:00',1.5),('14598','2013-10-12','16:20:00',1.86),('14598','2013-10-12','16:25:00',2.48),('14598','2013-10-12','16:30:00',1.6),('14598','2013-10-12','16:35:00',1.46),('14598','2013-10-12','16:40:00',1.15),('14598','2013-10-12','17:00:00',1.09),('14598','2013-10-12','17:05:00',1.25),('14598','2013-10-11','08:50:00',1),('14598','2013-10-11','08:55:00',1.19),('14598','2013-10-11','09:30:00',1.43),('14598','2013-10-11','09:35:00',1.53),('14598','2013-10-11','09:40:00',2.12),('14598','2013-10-11','09:45:00',2.12),('14598','2013-10-11','09:50:00',2.16),('14598','2013-10-11','09:55:00',2.22),('14598','2013-10-11','10:00:00',2.03),('14598','2013-10-11','10:05:00',2.47),('14598','2013-10-11','10:10:00',2.51),('14598','2013-10-11','10:15:00',2.59),('14598','2013-10-11','10:20:00',1.93),('14598','2013-10-11','10:25:00',2.11),('14598','2013-10-11','10:30:00',2.16),('14598','2013-10-11','10:35:00',2.91),('14598','2013-10-11','10:40:00',1.63),('14598','2013-10-11','10:45:00',1.5),('14598','2013-10-11','10:50:00',1.95),('14598','2013-10-11','10:55:00',1.91),('14598','2013-10-11','11:00:00',1.85),('14598','2013-10-11','11:05:00',1.52),('14598','2013-10-11','11:10:00',1.42),('14598','2013-10-11','11:15:00',1.47),('14598','2013-10-11','11:20:00',1.54),('14598','2013-10-11','11:25:00',1.68),('14598','2013-10-11','11:30:00',2.64),('14598','2013-10-11','11:35:00',2.08),('14598','2013-10-11','11:40:00',2.62),('14598','2013-10-11','11:45:00',1.55),('14598','2013-10-11','11:50:00',2.81),('14598','2013-10-11','11:55:00',3.65),('14598','2013-10-11','12:00:00',1.63),('14598','2013-10-11','12:10:00',2.03),('14598','2013-10-11','12:15:00',4.71),('14598','2013-10-11','12:20:00',5.2),('14598','2013-10-11','12:25:00',5.19),('14598','2013-10-11','12:30:00',4.9),('14598','2013-10-11','12:35:00',4.9),('14598','2013-10-11','12:40:00',4.81),('14598','2013-10-11','12:45:00',2.4),('14598','2013-10-11','12:50:00',3.41),('14598','2013-10-11','12:55:00',3.95),('14598','2013-10-11','13:00:00',1.45),('14598','2013-10-11','13:05:00',2.09),('14598','2013-10-11','13:10:00',4.2),('14598','2013-10-11','13:15:00',4.16),('14598','2013-10-11','13:20:00',4.17),('14598','2013-10-11','13:25:00',4.45),('14598','2013-10-11','13:30:00',4.4),('14598','2013-10-11','13:35:00',3.2),('14598','2013-10-11','13:40:00',1.31),('14598','2013-10-11','13:45:00',1.2),('14598','2013-10-11','13:50:00',1.64),('14598','2013-10-11','13:55:00',1.7),('14598','2013-10-11','14:00:00',1.87),('14598','2013-10-11','14:05:00',1.59),('14598','2013-10-11','14:10:00',1.79),('14598','2013-10-11','14:15:00',2.15),('14598','2013-10-11','14:20:00',1.67),('14598','2013-10-11','14:25:00',4.07),('14598','2013-10-11','14:30:00',3.84),('14598','2013-10-11','14:35:00',4.4),('14598','2013-10-11','14:40:00',3.5),('14598','2013-10-11','14:45:00',1.1),('14598','2013-10-11','14:50:00',1.02),('14598','2013-10-11','14:55:00',4.13),('14598','2013-10-11','15:00:00',3.7),('14598','2013-10-11','15:05:00',3.41),('14598','2013-10-11','15:10:00',3.56),('14598','2013-10-11','15:15:00',3.52),('14598','2013-10-11','15:20:00',3.56),('14598','2013-10-11','15:25:00',3.32),('14598','2013-10-11','15:30:00',3.23),('14598','2013-10-11','15:35:00',3.12),('14598','2013-10-11','15:40:00',3.13),('14598','2013-10-11','15:45:00',3.06),('14598','2013-10-11','15:50:00',3),('14598','2013-10-11','15:55:00',2.9),('14598','2013-10-11','16:00:00',2.82),('14598','2013-10-11','16:05:00',2.72),('14598','2013-10-11','16:10:00',2.66),('14598','2013-10-11','16:15:00',2.58),('14598','2013-10-11','16:20:00',2.51),('14598','2013-10-11','16:25:00',2.43),('14598','2013-10-11','16:30:00',2.32),('14598','2013-10-11','16:35:00',2.23),('14598','2013-10-11','16:40:00',2.14),('14598','2013-10-11','16:45:00',2.06),('14598','2013-10-11','16:50:00',1.96),('14598','2013-10-11','16:55:00',1.86),('14598','2013-10-11','17:00:00',1.77),('14598','2013-10-11','17:05:00',1.67),('14598','2013-10-11','17:10:00',1.63),('14598','2013-10-11','17:15:00',1.69),('14598','2013-10-11','17:20:00',1.66),('14598','2013-10-11','17:25:00',1.28),('14598','2013-10-11','17:30:00',1.11),('14598','2013-10-11','17:35:00',1),('14598','2013-10-10','09:05:00',1.04),('14598','2013-10-10','09:10:00',1.13),('14598','2013-10-10','09:15:00',1.23),('14598','2013-10-10','09:20:00',1.4),('14598','2013-10-10','09:25:00',1.52),('14598','2013-10-10','09:30:00',1.61),('14598','2013-10-10','09:35:00',1.7),('14598','2013-10-10','09:40:00',1.72),('14598','2013-10-10','09:45:00',1.87),('14598','2013-10-10','09:50:00',1.98),('14598','2013-10-10','09:55:00',2.07),('14598','2013-10-10','10:00:00',2.15),('14598','2013-10-10','10:05:00',2.21),('14598','2013-10-10','10:10:00',2.31),('14598','2013-10-10','10:15:00',2.4),('14598','2013-10-10','10:20:00',2.45),('14598','2013-10-10','10:25:00',2.48),('14598','2013-10-10','10:30:00',2.61),('14598','2013-10-10','10:35:00',2.74),('14598','2013-10-10','10:40:00',2.82),('14598','2013-10-10','10:45:00',1.11),('14598','2013-10-10','10:55:00',1.32),('14598','2013-10-10','11:00:00',3.15),('14598','2013-10-10','11:05:00',3.41),('14598','2013-10-10','11:10:00',3.37),('14598','2013-10-10','11:15:00',3.36),('14598','2013-10-10','11:20:00',3.38),('14598','2013-10-10','11:25:00',3.47),('14598','2013-10-10','11:30:00',3.2),('14598','2013-10-10','11:35:00',3.6),('14598','2013-10-10','11:40:00',2.96),('14598','2013-10-10','11:45:00',3.7),('14598','2013-10-10','11:50:00',3.82),('14598','2013-10-10','11:55:00',3.68),('14598','2013-10-10','12:00:00',2.98),('14598','2013-10-10','12:05:00',4.59),('14598','2013-10-10','12:10:00',4.31),('14598','2013-10-10','12:15:00',3.93),('14598','2013-10-10','12:20:00',3.91),('14598','2013-10-10','12:25:00',3.92),('14598','2013-10-10','12:30:00',3.94),('14598','2013-10-10','12:35:00',3.98),('14598','2013-10-10','12:40:00',4.09),('14598','2013-10-10','12:45:00',4.11),('14598','2013-10-10','12:50:00',4.1),('14598','2013-10-10','12:55:00',4.1),('14598','2013-10-10','13:00:00',3.96),('14598','2013-10-10','13:05:00',4.04),('14598','2013-10-10','13:10:00',4.06),('14598','2013-10-10','13:15:00',4.06),('14598','2013-10-10','13:20:00',4.08),('14598','2013-10-10','13:25:00',4.09),('14598','2013-10-10','13:30:00',4),('14598','2013-10-10','13:35:00',4.1),('14598','2013-10-10','13:40:00',4.15),('14598','2013-10-10','13:45:00',4.22),('14598','2013-10-10','13:50:00',4.08),('14598','2013-10-10','13:55:00',4.12),('14598','2013-10-10','14:00:00',4.16),('14598','2013-10-10','14:05:00',4.19),('14598','2013-10-10','14:10:00',4.09),('14598','2013-10-10','14:15:00',4.08),('14598','2013-10-10','14:20:00',4),('14598','2013-10-10','14:25:00',4),('14598','2013-10-10','14:30:00',4.12),('14598','2013-10-10','14:35:00',3.97),('14598','2013-10-10','14:40:00',3.92),('14598','2013-10-10','14:45:00',3.78),('14598','2013-10-10','14:50:00',3.82),('14598','2013-10-10','14:55:00',3.74),('14598','2013-10-10','15:00:00',3.72),('14598','2013-10-10','15:05:00',2.94),('14598','2013-10-10','15:10:00',3.06),('14598','2013-10-10','15:15:00',3.33),('14598','2013-10-10','15:20:00',3.53),('14598','2013-10-10','15:25:00',1.24),('14598','2013-10-10','15:30:00',3.27),('14598','2013-10-10','15:35:00',2.93),('14598','2013-10-10','15:40:00',2.21),('14598','2013-10-10','15:45:00',2.01),('14598','2013-10-10','15:50:00',2.98),('14598','2013-10-10','15:55:00',1.7),('14598','2013-10-10','16:00:00',1.75),('14598','2013-10-10','16:10:00',3.45),('14598','2013-10-10','16:15:00',2.31),('14598','2013-10-10','16:30:00',1.42),('14598','2013-10-10','16:35:00',1.1),('14598','2013-10-10','16:40:00',2.22),('14598','2013-10-10','16:45:00',1.99),('14598','2013-10-10','16:50:00',2.14),('14598','2013-10-10','16:55:00',2.05),('14598','2013-10-10','17:00:00',1.95),('14598','2013-10-10','17:05:00',1.83),('14598','2013-10-10','17:10:00',1.72),('14598','2013-10-10','17:15:00',1.48),('14598','2013-10-10','17:20:00',1.29),('14598','2013-10-09','08:50:00',1.02),('14598','2013-10-09','08:55:00',1.25),('14598','2013-10-09','09:00:00',1.03),('14598','2013-10-09','09:10:00',1.41),('14598','2013-10-09','09:30:00',1.21),('14598','2013-10-09','09:55:00',1.64),('14598','2013-10-09','10:00:00',2.25),('14598','2013-10-09','10:05:00',2.44),('14598','2013-10-09','10:10:00',2.54),('14598','2013-10-09','10:15:00',2.64),('14598','2013-10-09','10:20:00',2.6),('14598','2013-10-09','10:25:00',2.63),('14598','2013-10-09','10:30:00',2.92),('14598','2013-10-09','10:35:00',2.97),('14598','2013-10-09','10:40:00',2.53),('14598','2013-10-09','10:45:00',3.06),('14598','2013-10-09','10:50:00',2.96),('14598','2013-10-09','10:55:00',3.35),('14598','2013-10-09','11:00:00',3.35),('14598','2013-10-09','11:05:00',1.4),('14598','2013-10-09','11:10:00',2.14),('14598','2013-10-09','11:15:00',3.56),('14598','2013-10-09','11:20:00',3.58),('14598','2013-10-09','11:25:00',3),('14598','2013-10-09','11:30:00',1.53),('14598','2013-10-09','11:35:00',1.75),('14598','2013-10-09','11:40:00',2.21),('14598','2013-10-09','11:45:00',2.72),('14598','2013-10-09','11:50:00',3.7),('14598','2013-10-09','11:55:00',2.34),('14598','2013-10-09','12:00:00',3.01),('14598','2013-10-09','12:05:00',2.12),('14598','2013-10-09','12:10:00',1.07),('14598','2013-10-09','12:15:00',3.3),('14598','2013-10-09','12:20:00',4.08),('14598','2013-10-09','12:25:00',4.43),('14598','2013-10-09','12:30:00',3.68),('14598','2013-10-09','12:35:00',2.08),('14598','2013-10-09','12:40:00',2.91),('14598','2013-10-09','12:45:00',3.25),('14598','2013-10-09','12:50:00',3.69),('14598','2013-10-09','12:55:00',4.6),('14598','2013-10-09','13:00:00',4.2),('14598','2013-10-09','13:05:00',4.33),('14598','2013-10-09','13:10:00',4.3),('14598','2013-10-09','13:15:00',4.31),('14598','2013-10-09','13:20:00',4.32),('14598','2013-10-09','13:25:00',4.34),('14598','2013-10-09','13:30:00',4.23),('14598','2013-10-09','13:35:00',2.16),('14598','2013-10-09','13:40:00',2.29),('14598','2013-10-09','13:45:00',4.47),('14598','2013-10-09','13:50:00',4.32),('14598','2013-10-09','13:55:00',4.24),('14598','2013-10-09','14:00:00',4.37),('14598','2013-10-09','14:05:00',4.36),('14598','2013-10-09','14:10:00',2.88),('14598','2013-10-09','14:15:00',1.42),('14598','2013-10-09','14:20:00',3.11),('14598','2013-10-09','14:25:00',1.32),('14598','2013-10-09','14:30:00',1.23),('14598','2013-10-09','14:35:00',1.34),('14598','2013-10-09','14:40:00',1.31),('14598','2013-10-09','14:45:00',1.54),('14598','2013-10-09','14:50:00',1.55),('14598','2013-10-09','14:55:00',1.49),('14598','2013-10-09','15:00:00',1.35),('14598','2013-10-09','15:05:00',1.29),('14598','2013-10-09','15:10:00',1.22),('14598','2013-10-09','15:15:00',1.56),('14598','2013-10-09','15:20:00',1.6),('14598','2013-10-09','15:25:00',1.46),('14598','2013-10-09','15:30:00',1.11),('14598','2013-10-09','15:35:00',1.65),('14598','2013-10-09','15:40:00',2.28),('14598','2013-10-09','15:45:00',1.37),('14598','2013-10-09','15:50:00',1.45),('14598','2013-10-09','15:55:00',1.27),('14598','2013-10-09','16:00:00',1.67),('14598','2013-10-09','16:05:00',1.87),('14598','2013-10-09','16:10:00',3.55),('14598','2013-10-09','16:15:00',2.89),('14598','2013-10-09','16:20:00',2.71),('14598','2013-10-09','16:25:00',2.63),('14598','2013-10-09','16:30:00',2.56),('14598','2013-10-09','16:35:00',2.49),('14598','2013-10-09','16:40:00',1.92),('14598','2013-10-09','16:45:00',2.34),('14598','2013-10-09','16:50:00',2.67),('14598','2013-10-09','16:55:00',1.85),('14598','2013-10-09','17:00:00',1.92),('14598','2013-10-09','17:05:00',1.77),('14598','2013-10-09','17:10:00',2.25),('14598','2013-10-09','17:15:00',1.94),('14598','2013-10-09','17:20:00',1.59),('14598','2013-10-09','17:25:00',1.48),('14598','2013-10-09','17:30:00',1.38),('14598','2013-10-09','17:35:00',1.23),('14598','2014-04-15','08:05:00',1.05),('14598','2014-04-15','08:45:00',1.1),('14598','2014-04-15','08:55:00',1.58),('14598','2014-04-15','09:05:00',1.11),('14598','2014-04-15','09:10:00',2.46),('14598','2014-04-15','09:15:00',2.57),('14598','2014-04-15','09:20:00',2.36),('14598','2014-04-15','09:25:00',2.07),('14598','2014-04-15','09:30:00',2.7),('14598','2014-04-15','09:35:00',1.54),('14598','2014-04-15','09:40:00',2.12),('14598','2014-04-15','09:45:00',2.05),('14598','2014-04-15','09:50:00',2.03),('14598','2014-04-15','09:55:00',1.79),('14598','2014-04-15','10:00:00',1.47),('14598','2014-04-15','10:05:00',1.29),('14598','2014-04-15','10:10:00',1.98),('14598','2014-04-15','10:15:00',2.49),('14598','2014-04-15','10:20:00',4),('14598','2014-04-15','10:25:00',3.99),('14598','2014-04-15','10:30:00',2.64),('14598','2014-04-15','10:35:00',3.66),('14598','2014-04-15','10:40:00',4.01),('14598','2014-04-15','10:45:00',1.92),('14598','2014-04-15','10:50:00',1.94),('14598','2014-04-15','10:55:00',2.09),('14598','2014-04-15','11:00:00',1.65),('14598','2014-04-15','11:05:00',2.26),('14598','2014-04-15','11:10:00',1.63),('14598','2014-04-15','11:15:00',1.72),('14598','2014-04-15','11:20:00',1.26),('14598','2014-04-15','11:25:00',1.13),('14598','2014-04-15','11:30:00',2.06),('14598','2014-04-15','11:35:00',4.47),('14598','2014-04-15','11:40:00',2.46),('14598','2014-04-15','11:45:00',3.12),('14598','2014-04-15','11:50:00',4.26),('14598','2014-04-15','11:55:00',2.14),('14598','2014-04-15','12:00:00',2.13),('14598','2014-04-15','12:05:00',1.85),('14598','2014-04-15','12:10:00',1.85),('14598','2014-04-15','12:15:00',1.5),('14598','2014-04-15','12:20:00',1.61),('14598','2014-04-15','12:25:00',1.08),('14598','2014-04-15','12:30:00',3.99),('14598','2014-04-15','12:35:00',2.4),('14598','2014-04-15','12:40:00',2.67),('14598','2014-04-15','12:45:00',2.45),('14598','2014-04-15','12:50:00',3.15),('14598','2014-04-15','12:55:00',2.76),('14598','2014-04-15','13:00:00',4.1),('14598','2014-04-15','13:05:00',2.51),('14598','2014-04-15','13:10:00',3.62),('14598','2014-04-15','13:15:00',5.28),('14598','2014-04-15','13:20:00',4.42),('14598','2014-04-15','13:25:00',2.95),('14598','2014-04-15','13:30:00',3.57),('14598','2014-04-15','13:35:00',3.81),('14598','2014-04-15','13:40:00',4.49),('14598','2014-04-15','13:45:00',4.07),('14598','2014-04-15','13:50:00',4.29),('14598','2014-04-15','13:55:00',4.97),('14598','2014-04-15','14:00:00',5.25),('14598','2014-04-15','14:05:00',5.06),('14598','2014-04-15','14:10:00',4.82),('14598','2014-04-15','14:15:00',3.99),('14598','2014-04-15','14:20:00',3.86),('14598','2014-04-15','14:25:00',4.15),('14598','2014-04-15','14:30:00',4.99),('14598','2014-04-15','14:35:00',4.66),('14598','2014-04-15','14:40:00',4.81),('14598','2014-04-15','14:45:00',4.39),('14598','2014-04-15','14:50:00',4.77),('14598','2014-04-15','14:55:00',4.77),('14598','2014-04-15','15:00:00',4.73),('14598','2014-04-15','15:05:00',4.06),('14598','2014-04-15','15:10:00',4.88),('14598','2014-04-15','15:15:00',4.73),('14598','2014-04-15','15:20:00',3.87),('14598','2014-04-15','15:25:00',4.5),('14598','2014-04-15','15:30:00',4.16),('14598','2014-04-15','15:35:00',4.68),('14598','2014-04-15','15:40:00',4.3),('14598','2014-04-15','15:45:00',4.55),('14598','2014-04-15','15:50:00',4.4),('14598','2014-04-15','15:55:00',4.21),('14598','2014-04-15','16:00:00',2.19),('14598','2014-04-15','16:05:00',1.46),('14598','2013-10-08','09:00:00',1),('14598','2013-10-08','09:05:00',1.08),('14598','2013-10-08','09:10:00',1.18),('14598','2013-10-08','09:15:00',1.32),('14598','2013-10-08','09:20:00',1.45),('14598','2013-10-08','09:25:00',1.57),('14598','2013-10-08','09:30:00',1.56),('14598','2013-10-08','09:50:00',2.18),('14598','2013-10-08','09:55:00',1.93),('14598','2013-10-08','10:00:00',1.5),('14598','2013-10-08','10:05:00',1.8),('14598','2013-10-08','10:10:00',1.25),('14598','2013-10-08','10:15:00',1.41),('14598','2013-10-08','10:20:00',1.35),('14598','2013-10-08','10:25:00',1.1),('14598','2013-10-08','10:35:00',1.13),('14598','2013-10-08','10:40:00',1.01),('14598','2013-10-08','11:10:00',1.05),('14598','2013-10-08','11:15:00',1.18),('14598','2013-10-08','11:20:00',1.12),('14598','2013-10-08','12:05:00',1.6),('14598','2013-10-08','12:10:00',2.73),('14598','2013-10-08','12:15:00',2.23),('14598','2013-10-08','12:20:00',3.55),('14598','2013-10-08','12:25:00',1.43),('14598','2013-10-08','12:30:00',1.12),('14598','2013-10-08','12:35:00',2.46),('14598','2013-10-08','12:40:00',2.66),('14598','2013-10-08','12:45:00',2.08),('14598','2013-10-08','12:50:00',1.6),('14598','2013-10-08','12:55:00',1.45),('14598','2013-10-08','13:00:00',1.07),('14598','2013-10-08','13:05:00',1.03),('14598','2013-10-08','13:10:00',1.2),('14598','2013-10-08','13:15:00',1.11),('14598','2013-10-08','13:30:00',1.04),('14598','2013-10-08','13:35:00',1.02),('14598','2013-10-08','13:50:00',1.21),('14598','2013-10-08','13:55:00',1.22),('14598','2013-10-08','14:00:00',1.08),('14598','2013-10-08','14:05:00',1.08),('14598','2013-10-08','14:10:00',1.06),('14598','2013-10-08','14:15:00',1.23),('14598','2013-10-08','14:20:00',1.53),('14598','2013-10-08','14:25:00',1.73),('14598','2013-10-08','14:30:00',2.3),('14598','2013-10-08','14:35:00',4.02),('14598','2013-10-08','14:40:00',4.04),('14598','2013-10-08','14:45:00',3.62),('14598','2013-10-08','14:50:00',4.34),('14598','2013-10-08','14:55:00',2.22),('14598','2013-10-08','15:00:00',2.12),('14598','2013-10-08','15:05:00',3.49),('14598','2013-10-08','15:10:00',3.03),('14598','2013-10-08','15:15:00',3.97),('14598','2013-10-08','15:20:00',3.74),('14598','2013-10-08','15:25:00',2.6),('14598','2013-10-08','16:15:00',1.44),('14598','2013-10-08','16:20:00',1.27),('14598','2013-10-08','16:40:00',1.12),('14598','2013-10-08','16:45:00',1.78),('14598','2013-10-08','16:50:00',1.23),('14598','2013-10-08','17:55:00',1.24),('14598','2013-10-08','18:00:00',1.17),('14598','2013-10-07','08:55:00',1.13),('14598','2013-10-07','09:00:00',1.2),('14598','2013-10-07','09:05:00',1.4),('14598','2013-10-07','09:10:00',1.15),('14598','2013-10-07','09:25:00',1.41),('14598','2013-10-07','09:30:00',1.73),('14598','2013-10-07','09:35:00',1.76),('14598','2013-10-07','09:40:00',1.88),('14598','2013-10-07','09:45:00',1.95),('14598','2013-10-07','09:50:00',2.02),('14598','2013-10-07','09:55:00',2.13),('14598','2013-10-07','10:00:00',2.21),('14598','2013-10-07','10:05:00',2.29),('14598','2013-10-07','10:10:00',2.35),('14598','2013-10-07','10:15:00',2.45),('14598','2013-10-07','10:20:00',2.53),('14598','2013-10-07','10:25:00',2.61),('14598','2013-10-07','10:30:00',2.69),('14598','2013-10-07','10:35:00',2.77),('14598','2013-10-07','10:40:00',2.85),('14598','2013-10-07','10:45:00',2.92),('14598','2013-10-07','10:50:00',2.98),('14598','2013-10-07','10:55:00',3.05),('14598','2013-10-07','11:00:00',3.11),('14598','2013-10-07','11:05:00',3.14),('14598','2013-10-07','11:10:00',3.21),('14598','2013-10-07','11:15:00',3.21),('14598','2013-10-07','11:20:00',3.29),('14598','2013-10-07','11:25:00',3.36),('14598','2013-10-07','11:30:00',3.12),('14598','2013-10-07','11:35:00',1.07),('14598','2013-10-07','11:40:00',1.16),('14598','2013-10-07','11:55:00',1.03),('14598','2013-10-07','12:00:00',1.78),('14598','2013-10-07','12:05:00',1.85),('14598','2013-10-07','12:10:00',1.9),('14598','2013-10-07','12:15:00',2.77),('14598','2013-10-07','12:20:00',4.67),('14598','2013-10-07','12:25:00',3.18),('14598','2013-10-07','12:30:00',3.87),('14598','2013-10-07','12:35:00',4.06),('14598','2013-10-07','12:40:00',3.99),('14598','2013-10-07','12:45:00',4),('14598','2013-10-07','12:50:00',4.03),('14598','2013-10-07','12:55:00',4.01),('14598','2013-10-07','13:00:00',4.05),('14598','2013-10-07','13:05:00',4.06),('14598','2013-10-07','13:10:00',4.07),('14598','2013-10-07','13:15:00',4.08),('14598','2013-10-07','13:20:00',4.1),('14598','2013-10-07','13:25:00',4.07),('14598','2013-10-07','13:30:00',4.07),('14598','2013-10-07','13:35:00',4.07),('14598','2013-10-07','13:40:00',4.06),('14598','2013-10-07','13:45:00',4.08),('14598','2013-10-07','13:50:00',4.09),('14598','2013-10-07','13:55:00',4.07),('14598','2013-10-07','14:00:00',4.05),('14598','2013-10-07','14:05:00',4.03),('14598','2013-10-07','14:10:00',4.01),('14598','2013-10-07','14:15:00',3.99),('14598','2013-10-07','14:20:00',3.98),('14598','2013-10-07','14:25:00',3.95),('14598','2013-10-07','14:30:00',3.93),('14598','2013-10-07','14:35:00',3.91),('14598','2013-10-07','14:40:00',3.89),('14598','2013-10-07','14:45:00',3.8),('14598','2013-10-07','14:50:00',3.87),('14598','2013-10-07','14:55:00',3.88),('14598','2013-10-07','15:00:00',3.88),('14598','2013-10-07','15:05:00',3.78),('14598','2013-10-07','15:10:00',3.66),('14598','2013-10-07','15:15:00',3.9),('14598','2013-10-07','15:20:00',3.71),('14598','2013-10-07','15:25:00',3.74),('14598','2013-10-07','15:30:00',3.49),('14598','2013-10-07','15:35:00',2.64),('14598','2013-10-07','15:40:00',3.03),('14598','2013-10-07','15:45:00',2.81),('14598','2013-10-07','15:50:00',3.31),('14598','2013-10-07','15:55:00',3.28),('14598','2013-10-07','16:00:00',3.18),('14598','2013-10-07','16:05:00',2.51),('14598','2013-10-07','16:10:00',2.74),('14598','2013-10-07','16:15:00',2.99),('14598','2013-10-07','16:20:00',2.79),('14598','2013-10-07','16:25:00',2.64),('14598','2013-10-07','16:30:00',2.53),('14598','2013-10-07','16:35:00',2.43),('14598','2013-10-07','16:40:00',2.38),('14598','2013-10-07','16:45:00',2.35),('14598','2013-10-07','16:50:00',2.2),('14598','2013-10-07','16:55:00',2.07),('14598','2013-10-07','17:00:00',1.97),('14598','2013-10-07','17:05:00',1.85),('14598','2013-10-07','17:10:00',1.76),('14598','2013-10-07','17:15:00',1.66),('14598','2013-10-07','17:20:00',1.55),('14598','2013-10-07','17:25:00',1.45),('14598','2013-10-07','17:30:00',1.34),('14598','2013-10-07','17:35:00',1.23),('14598','2013-10-07','17:40:00',1.12),('14598','2013-10-07','17:45:00',1),('14598','2013-10-06','08:50:00',1.09),('14598','2013-10-06','08:55:00',1.26),('14598','2013-10-06','09:05:00',1.33),('14598','2013-10-06','09:10:00',1.39),('14598','2013-10-06','09:15:00',1.29),('14598','2013-10-06','09:20:00',1.91),('14598','2013-10-06','09:25:00',2.03),('14598','2013-10-06','09:30:00',1.98),('14598','2013-10-06','09:35:00',2.05),('14598','2013-10-06','09:40:00',2.14),('14598','2013-10-06','09:45:00',1.85),('14598','2013-10-06','09:50:00',1.72),('14598','2013-10-06','10:00:00',1.31),('14598','2013-10-06','10:05:00',1.51),('14598','2013-10-06','10:10:00',1.44),('14598','2013-10-06','10:15:00',1.8),('14598','2013-10-06','10:20:00',1.76),('14598','2013-10-06','10:25:00',1.96),('14598','2013-10-06','10:30:00',1.84),('14598','2013-10-06','10:35:00',1.85),('14598','2013-10-06','10:40:00',1.74),('14598','2013-10-06','10:45:00',1.99),('14598','2013-10-06','10:50:00',1.95),('14598','2013-10-06','10:55:00',2.17),('14598','2013-10-06','11:00:00',2.57),('14598','2013-10-06','11:05:00',2.45),('14598','2013-10-06','11:10:00',2.41),('14598','2013-10-06','11:15:00',2.6),('14598','2013-10-06','11:20:00',2.02),('14598','2013-10-06','11:25:00',2.5),('14598','2013-10-06','11:30:00',2.21),('14598','2013-10-06','11:35:00',2.85),('14598','2013-10-06','11:40:00',2.72),('14598','2013-10-06','11:45:00',3.21),('14598','2013-10-06','11:50:00',3.13),('14598','2013-10-06','11:55:00',3.47),('14598','2013-10-06','12:00:00',3.07),('14598','2013-10-06','12:05:00',3.92),('14598','2013-10-06','12:10:00',4.05),('14598','2013-10-06','12:15:00',3.83),('14598','2013-10-06','12:20:00',3.6),('14598','2013-10-06','12:25:00',3.66),('14598','2013-10-06','12:30:00',3.12),('14598','2013-10-06','12:35:00',4.51),('14598','2013-10-06','12:40:00',4.16),('14598','2013-10-06','12:45:00',4.13),('14598','2013-10-06','12:50:00',4.37),('14598','2013-10-06','12:55:00',4.33),('14598','2013-10-06','13:00:00',4.59),('14598','2013-10-06','13:05:00',3.95),('14598','2013-10-06','13:10:00',3.28),('14598','2013-10-06','13:15:00',4.1),('14598','2013-10-06','13:20:00',4.56),('14598','2013-10-06','13:25:00',3.36),('14598','2013-10-06','13:30:00',3.47),('14598','2013-10-06','13:35:00',2.06),('14598','2013-10-06','13:40:00',2.04),('14598','2013-10-06','13:45:00',1.83),('14598','2013-10-06','13:50:00',2.46),('14598','2013-10-06','13:55:00',2.41),('14598','2013-10-06','14:00:00',2.17),('14598','2013-10-06','14:05:00',2.01),('14598','2013-10-06','14:10:00',2.63),('14598','2013-10-06','14:15:00',2.77),('14598','2013-10-06','14:20:00',3.24),('14598','2013-10-06','14:25:00',2.84),('14598','2013-10-06','14:30:00',2.98),('14598','2013-10-06','14:35:00',2.37),('14598','2013-10-06','14:40:00',1.9),('14598','2013-10-06','14:45:00',1.6),('14598','2013-10-06','14:50:00',2.17),('14598','2013-10-06','14:55:00',2.21),('14598','2013-10-06','15:00:00',1.51),('14598','2013-10-06','15:05:00',1.49),('14598','2013-10-06','15:10:00',1.46),('14598','2013-10-06','15:15:00',1.79),('14598','2013-10-06','15:20:00',1.57),('14598','2013-10-06','15:25:00',1.35),('14598','2013-10-06','15:30:00',1.14),('14598','2013-10-06','15:35:00',1.11),('14598','2013-10-06','15:40:00',1.16),('14598','2013-10-06','15:45:00',1.57),('14598','2013-10-06','15:50:00',1.75),('14598','2013-10-06','15:55:00',1.23),('14598','2013-10-06','16:15:00',1.05),('14598','2013-10-05','15:30:00',1.01),('14598','2013-10-05','15:35:00',1.22),('14598','2013-10-05','15:40:00',1.48),('14598','2013-10-05','15:45:00',1.64),('14598','2013-10-05','15:50:00',1.55),('14598','2013-10-05','15:55:00',1.21),('14598','2013-10-05','16:00:00',1.01),('14598','2013-10-05','16:15:00',1.03),('14598','2013-10-05','16:20:00',1.16),('14598','2013-10-05','16:25:00',1.4),('14598','2013-10-05','16:30:00',1.58),('14598','2013-10-05','16:35:00',1.5),('14598','2013-10-05','16:40:00',1.17),('14598','2013-10-05','16:45:00',1.51),('14598','2013-10-05','16:50:00',1.18),('14598','2013-10-05','16:55:00',1.04),('14598','2013-10-05','17:00:00',1.02),('14598','2013-10-04','08:45:00',1.44),('14598','2013-10-04','09:15:00',1.8),('14598','2013-10-04','09:20:00',1.56),('14598','2013-10-04','09:25:00',1.04),('14598','2013-10-04','09:30:00',1.1),('14598','2013-10-04','09:35:00',1.19),('14598','2013-10-04','09:50:00',1.26),('14598','2013-10-04','09:55:00',1.97),('14598','2013-10-04','10:00:00',2.62),('14598','2013-10-04','10:05:00',2.73),('14598','2013-10-04','10:10:00',2.3),('14598','2013-10-04','10:15:00',1.62),('14598','2013-10-04','10:20:00',1.75),('14598','2013-10-04','10:25:00',2.2),('14598','2013-10-04','10:30:00',1.83),('14598','2013-10-04','10:35:00',3.2),('14598','2013-10-04','10:40:00',2.42),('14598','2013-10-04','10:45:00',2.18),('14598','2013-10-04','10:50:00',3.19),('14598','2013-10-04','10:55:00',3.55),('14598','2013-10-04','11:00:00',3.4),('14598','2013-10-04','11:05:00',1.79),('14598','2013-10-04','11:10:00',1.52),('14598','2013-10-04','11:15:00',2.31),('14598','2013-10-04','11:20:00',1.82),('14598','2013-10-04','11:25:00',1.27),('14598','2013-10-04','11:30:00',1.78),('14598','2013-10-04','11:35:00',3.34),('14598','2013-10-04','11:40:00',3.69),('14598','2013-10-04','11:45:00',3.81),('14598','2013-10-04','11:50:00',3.58),('14598','2013-10-04','11:55:00',2.19),('14598','2013-10-04','12:00:00',3.06),('14598','2013-10-04','12:05:00',4.04),('14598','2013-10-04','12:10:00',3.92),('14598','2013-10-04','12:15:00',3.91),('14598','2013-10-04','12:20:00',3.88),('14598','2013-10-04','12:25:00',3.94),('14598','2013-10-04','12:30:00',3.95),('14598','2013-10-04','12:35:00',4.01),('14598','2013-10-04','12:40:00',4.01),('14598','2013-10-04','12:45:00',3.99),('14598','2013-10-04','12:50:00',3.98),('14598','2013-10-04','12:55:00',3.99),('14598','2013-10-04','13:00:00',3.98),('14598','2013-10-04','13:05:00',4.04),('14598','2013-10-04','13:10:00',4),('14598','2013-10-04','13:15:00',4.06),('14598','2013-10-04','13:20:00',4.07),('14598','2013-10-04','13:25:00',4),('14598','2013-10-04','13:30:00',3.97),('14598','2013-10-04','13:35:00',4.06),('14598','2013-10-04','13:40:00',4.08),('14598','2013-10-04','13:45:00',4.05),('14598','2013-10-04','13:50:00',4.1),('14598','2013-10-04','13:55:00',4.07),('14598','2013-10-04','14:00:00',3.43),('14598','2013-10-04','14:05:00',3.37),('14598','2013-10-04','14:10:00',2.98),('14598','2013-10-04','14:15:00',3.11),('14598','2013-10-04','14:20:00',2.8),('14598','2013-10-04','14:25:00',2.7),('14598','2013-10-04','14:30:00',2.29),('14598','2013-10-04','14:35:00',3.4),('14598','2013-10-04','14:40:00',2.82),('14598','2013-10-04','14:45:00',2.6),('14598','2013-10-04','14:50:00',3.41),('14598','2013-10-04','14:55:00',2.09),('14598','2013-10-04','15:00:00',1.95),('14598','2013-10-04','15:05:00',2.49),('14598','2013-10-04','15:10:00',2.75),('14598','2013-10-04','15:15:00',2.05),('14598','2013-10-04','15:20:00',1.83),('14598','2013-10-04','15:25:00',1.49),('14598','2013-10-04','15:30:00',1.38),('14598','2013-10-04','15:35:00',1.22),('14598','2013-10-04','15:40:00',1.24),('14598','2013-10-04','15:45:00',1.25),('14598','2013-10-04','15:50:00',1.2),('14598','2013-10-04','15:55:00',1.21),('14598','2013-10-04','16:00:00',1.14),('14598','2013-10-04','16:05:00',1.16),('14598','2013-10-04','16:10:00',1.03),('14598','2013-10-04','16:15:00',1.08),('14598','2013-10-04','16:20:00',1.17),('14598','2013-10-04','16:25:00',1.07),('14598','2013-10-04','16:30:00',1.03),('14598','2013-10-04','16:35:00',1.12),('14598','2013-10-03','08:55:00',1.01),('14598','2013-10-03','09:00:00',1.11),('14598','2013-10-03','09:05:00',1.22),('14598','2013-10-03','09:10:00',1.35),('14598','2013-10-03','09:15:00',1.45),('14598','2013-10-03','09:20:00',1.59),('14598','2013-10-03','09:25:00',1.71),('14598','2013-10-03','09:30:00',1.81),('14598','2013-10-03','09:35:00',1.92),('14598','2013-10-03','09:40:00',2.01),('14598','2013-10-03','09:45:00',2.1),('14598','2013-10-03','09:50:00',2.21),('14598','2013-10-03','09:55:00',2.3),('14598','2013-10-03','10:00:00',2.39),('14598','2013-10-03','10:05:00',2.48),('14598','2013-10-03','10:10:00',2.59),('14598','2013-10-03','10:15:00',2.68),('14598','2013-10-03','10:20:00',2.76),('14598','2013-10-03','10:25:00',2.85),('14598','2013-10-03','10:30:00',2.94),('14598','2013-10-03','10:35:00',3),('14598','2013-10-03','10:40:00',3.09),('14598','2013-10-03','10:45:00',3.15),('14598','2013-10-03','10:50:00',3.22),('14598','2013-10-03','10:55:00',3.3),('14598','2013-10-03','11:00:00',3.36),('14598','2013-10-03','11:05:00',3.42),('14598','2013-10-03','11:10:00',3.5),('14598','2013-10-03','11:15:00',3.56),('14598','2013-10-03','11:20:00',3.61),('14598','2013-10-03','11:25:00',3.67),('14598','2013-10-03','11:30:00',3.7),('14598','2013-10-03','11:35:00',3.76),('14598','2013-10-03','11:40:00',3.78),('14598','2013-10-03','11:45:00',3.86),('14598','2013-10-03','11:50:00',3.9),('14598','2013-10-03','11:55:00',3.95),('14598','2013-10-03','12:00:00',3.98),('14598','2013-10-03','12:05:00',4.02),('14598','2013-10-03','12:10:00',4.01),('14598','2013-10-03','12:15:00',4.03),('14598','2013-10-03','12:20:00',4.05),('14598','2013-10-03','12:25:00',4.11),('14598','2013-10-03','12:30:00',4.13),('14598','2013-10-03','12:35:00',4.11),('14598','2013-10-03','12:40:00',4.15),('14598','2013-10-03','12:45:00',4.21),('14598','2013-10-03','12:50:00',4.22),('14598','2013-10-03','12:55:00',4.19),('14598','2013-10-03','13:00:00',4.23),('14598','2013-10-03','13:05:00',4.23),('14598','2013-10-03','13:10:00',4.24),('14598','2013-10-03','13:15:00',4.23),('14598','2013-10-03','13:20:00',4.23),('14598','2013-10-03','13:25:00',4.24),('14598','2013-10-03','13:30:00',4.25),('14598','2013-10-03','13:35:00',4.23),('14598','2013-10-03','13:40:00',4.25),('14598','2013-10-03','13:45:00',4.26),('14598','2013-10-03','13:50:00',4.24),('14598','2013-10-03','13:55:00',4.2),('14598','2013-10-03','14:00:00',4.19),('14598','2013-10-03','14:05:00',4.15),('14598','2013-10-03','14:10:00',4.15),('14598','2013-10-03','14:15:00',4.12),('14598','2013-10-03','14:20:00',4.12),('14598','2013-10-03','14:25:00',4.1),('14598','2013-10-03','14:30:00',4.06),('14598','2013-10-03','14:35:00',4.02),('14598','2013-10-03','14:40:00',3.96),('14598','2013-10-03','14:45:00',3.96),('14598','2013-10-03','14:50:00',3.91),('14598','2013-10-03','14:55:00',3.86),('14598','2013-10-03','15:00:00',3.82),('14598','2013-10-03','15:05:00',3.77),('14598','2013-10-03','15:10:00',3.72),('14598','2013-10-03','15:15:00',3.65),('14598','2013-10-03','15:20:00',3.57),('14598','2013-10-03','15:25:00',3.57),('14598','2013-10-03','15:30:00',3.53),('14598','2013-10-03','15:35:00',3.46),('14598','2013-10-03','15:40:00',3.41),('14598','2013-10-03','15:45:00',3.34),('14598','2013-10-03','15:50:00',3.28),('14598','2013-10-03','15:55:00',3.19),('14598','2013-10-03','16:00:00',3.14),('14598','2013-10-03','16:05:00',3.06),('14598','2013-10-03','16:10:00',2.91),('14598','2013-10-03','16:15:00',2.88),('14598','2013-10-03','16:20:00',2.8),('14598','2013-10-03','16:25:00',2.7),('14598','2013-10-03','16:30:00',2.61),('14598','2013-10-03','16:35:00',2.54),('14598','2013-10-03','16:40:00',2.46),('14598','2013-10-03','16:45:00',2.37),('14598','2013-10-03','16:50:00',2.27),('14598','2013-10-03','16:55:00',2.17),('14598','2013-10-03','17:00:00',2.07),('14598','2013-10-03','17:05:00',1.98),('14598','2013-10-03','17:10:00',1.9),('14598','2013-10-03','17:15:00',1.8),('14598','2013-10-03','17:20:00',1.71),('14598','2013-10-03','17:25:00',1.6),('14598','2013-10-03','17:30:00',1.48),('14598','2013-10-03','17:35:00',1.37),('14598','2013-10-03','17:40:00',1.25),('14598','2013-10-03','17:45:00',1.13),('14598','2013-10-03','17:50:00',1.02),('14598','2013-10-02','09:00:00',1.08),('14598','2013-10-02','09:05:00',1.18),('14598','2013-10-02','09:10:00',1.31),('14598','2013-10-02','09:15:00',1.41),('14598','2013-10-02','09:20:00',1.52),('14598','2013-10-02','09:25:00',1.62),('14598','2013-10-02','09:30:00',1.72),('14598','2013-10-02','09:35:00',1.82),('14598','2013-10-02','09:40:00',1.9),('14598','2013-10-02','09:45:00',2),('14598','2013-10-02','09:50:00',2.1),('14598','2013-10-02','09:55:00',2.19),('14598','2013-10-02','10:00:00',2.27),('14598','2013-10-02','10:05:00',2.36),('14598','2013-10-02','10:10:00',2.45),('14598','2013-10-02','10:15:00',2.53),('14598','2013-10-02','10:20:00',2.6),('14598','2013-10-02','10:25:00',2.67),('14598','2013-10-02','10:30:00',2.75),('14598','2013-10-02','10:35:00',2.84),('14598','2013-10-02','10:40:00',2.91),('14598','2013-10-02','10:45:00',2.97),('14598','2013-10-02','10:50:00',3.04),('14598','2013-10-02','10:55:00',3.11),('14598','2013-10-02','11:00:00',3.16),('14598','2013-10-02','11:05:00',3.24),('14598','2013-10-02','11:10:00',3.32),('14598','2013-10-02','11:15:00',3.37),('14598','2013-10-02','11:20:00',3.4),('14598','2013-10-02','11:25:00',3.46),('14598','2013-10-02','11:30:00',3.52),('14598','2013-10-02','11:35:00',3.56),('14598','2013-10-02','11:40:00',3.6),('14598','2013-10-02','11:45:00',3.64),('14598','2013-10-02','11:50:00',3.69),('14598','2013-10-02','11:55:00',3.73),('14598','2013-10-02','12:00:00',3.76),('14598','2013-10-02','12:05:00',3.79),('14598','2013-10-02','12:10:00',3.82),('14598','2013-10-02','12:15:00',3.85),('14598','2013-10-02','12:20:00',3.87),('14598','2013-10-02','12:25:00',3.9),('14598','2013-10-02','12:30:00',3.94),('14598','2013-10-02','12:35:00',3.94),('14598','2013-10-02','12:40:00',3.99),('14598','2013-10-02','12:45:00',4),('14598','2013-10-02','12:50:00',4.01),('14598','2013-10-02','12:55:00',4.02),('14598','2013-10-02','13:00:00',4.03),('14598','2013-10-02','13:05:00',4.05),('14598','2013-10-02','13:10:00',4.04),('14598','2013-10-02','13:15:00',4.02),('14598','2013-10-02','13:20:00',4.02),('14598','2013-10-02','13:25:00',4.02),('14598','2013-10-02','13:30:00',4.1),('14598','2013-10-02','13:35:00',4.15),('14598','2013-10-02','13:40:00',4.12),('14598','2013-10-02','13:45:00',4.11),('14598','2013-10-02','13:50:00',4.08),('14598','2013-10-02','13:55:00',4.05),('14598','2013-10-02','14:00:00',4.1),('14598','2013-10-02','14:05:00',4.09),('14598','2013-10-02','14:10:00',4.11),('14598','2013-10-02','14:15:00',4.06),('14598','2013-10-02','14:20:00',3.66),('14598','2013-10-02','14:25:00',3.98),('14598','2013-10-02','14:30:00',3.8),('14598','2013-10-02','14:35:00',3.77),('14598','2013-10-02','14:40:00',3.67),('14598','2013-10-02','14:45:00',3.85),('14598','2013-10-02','14:50:00',3.78),('14598','2013-10-02','14:55:00',3.72),('14598','2013-10-02','15:00:00',3.72),('14598','2013-10-02','15:05:00',3.67),('14598','2013-10-02','15:10:00',3.72),('14598','2013-10-02','15:15:00',1.9),('14598','2013-10-02','15:20:00',3.45),('14598','2013-10-02','15:25:00',3.56),('14598','2013-10-02','15:30:00',3.41),('14598','2013-10-02','15:35:00',3.37),('14598','2013-10-02','15:40:00',3.28),('14598','2013-10-02','15:45:00',3.27),('14598','2013-10-02','15:50:00',3.21),('14598','2013-10-02','15:55:00',3.11),('14598','2013-10-02','16:00:00',3.06),('14598','2013-10-02','16:05:00',2.97),('14598','2013-10-02','16:10:00',2.86),('14598','2013-10-02','16:15:00',2.82),('14598','2013-10-02','16:20:00',2.75),('14598','2013-10-02','16:25:00',2.7),('14598','2013-10-02','16:30:00',2.6),('14598','2013-10-02','16:35:00',2.53),('14598','2013-10-02','16:40:00',2.41),('14598','2013-10-02','16:45:00',2.34),('14598','2013-10-02','16:50:00',2.22),('14598','2013-10-02','16:55:00',2.08),('14598','2013-10-02','17:00:00',1.99),('14598','2013-10-02','17:05:00',1.93),('14598','2013-10-02','17:10:00',1.81),('14598','2013-10-02','17:15:00',1.7),('14598','2013-10-02','17:20:00',1.6),('14598','2013-10-02','17:25:00',1.52),('14598','2013-10-02','17:30:00',1.42),('14598','2013-10-02','17:35:00',1.32),('14598','2013-10-02','17:40:00',1.21),('14598','2013-10-02','17:45:00',1.09),('14598','2013-10-01','09:00:00',1.09),('14598','2013-10-01','09:05:00',1.2),('14598','2013-10-01','09:10:00',1.33),('14598','2013-10-01','09:15:00',1.43),('14598','2013-10-01','09:20:00',1.55),('14598','2013-10-01','09:25:00',1.64),('14598','2013-10-01','09:30:00',1.74),('14598','2013-10-01','09:35:00',1.84),('14598','2013-10-01','09:40:00',1.93),('14598','2013-10-01','09:45:00',2.02),('14598','2013-10-01','09:50:00',2.1),('14598','2013-10-01','09:55:00',2.2),('14598','2013-10-01','10:00:00',2.27),('14598','2013-10-01','10:05:00',2.37),('14598','2013-10-01','10:10:00',2.47),('14598','2013-10-01','10:15:00',2.5),('14598','2013-10-01','10:20:00',2.56),('14598','2013-10-01','10:25:00',2.81),('14598','2013-10-01','10:30:00',2.95),('14598','2013-10-01','10:35:00',3.12),('14598','2013-10-01','10:40:00',3.24),('14598','2013-10-01','10:45:00',2.74),('14598','2013-10-01','10:50:00',2.32),('14598','2013-10-01','10:55:00',3.15),('14598','2013-10-01','11:00:00',3.22),('14598','2013-10-01','11:05:00',3.28),('14598','2013-10-01','11:10:00',3.35),('14598','2013-10-01','11:15:00',3.4),('14598','2013-10-01','11:20:00',3.45),('14598','2013-10-01','11:25:00',3.5),('14598','2013-10-01','11:30:00',3.57),('14598','2013-10-01','11:35:00',3.62),('14598','2013-10-01','11:40:00',3.66),('14598','2013-10-01','11:45:00',3.71),('14598','2013-10-01','11:50:00',3.73),('14598','2013-10-01','11:55:00',3.82),('14598','2013-10-01','12:00:00',3.86),('14598','2013-10-01','12:05:00',3.9),('14598','2013-10-01','12:10:00',3.92),('14598','2013-10-01','12:15:00',3.95),('14598','2013-10-01','12:20:00',3.98),('14598','2013-10-01','12:25:00',4.02),('14598','2013-10-01','12:30:00',4.06),('14598','2013-10-01','12:35:00',4.09),('14598','2013-10-01','12:40:00',4.12),('14598','2013-10-01','12:45:00',4.14),('14598','2013-10-01','12:50:00',4.15),('14598','2013-10-01','12:55:00',4.15),('14598','2013-10-01','13:00:00',4.16),('14598','2013-10-01','13:05:00',4.17),('14598','2013-10-01','13:10:00',4.18),('14598','2013-10-01','13:15:00',4.17),('14598','2013-10-01','13:20:00',4.19),('14598','2013-10-01','13:25:00',4.19),('14598','2013-10-01','13:30:00',4.2),('14598','2013-10-01','13:35:00',4.19),('14598','2013-10-01','13:40:00',4.2),('14598','2013-10-01','13:45:00',4.19),('14598','2013-10-01','13:50:00',4.17),('14598','2013-10-01','13:55:00',4.17),('14598','2013-10-01','14:00:00',4.17),('14598','2013-10-01','14:05:00',4.13),('14598','2013-10-01','14:10:00',4.11),('14598','2013-10-01','14:15:00',4.09),('14598','2013-10-01','14:20:00',4.07),('14598','2013-10-01','14:25:00',4.06),('14598','2013-10-01','14:30:00',4.03),('14598','2013-10-01','14:35:00',4),('14598','2013-10-01','14:40:00',3.96),('14598','2013-10-01','14:45:00',3.93),('14598','2013-10-01','14:50:00',3.91),('14598','2013-10-01','14:55:00',3.88),('14598','2013-10-01','15:00:00',3.86),('14598','2013-10-01','15:05:00',3.82),('14598','2013-10-01','15:10:00',3.78),('14598','2013-10-01','15:15:00',3.72),('14598','2013-10-01','15:20:00',3.67),('14598','2013-10-01','15:25:00',3.62),('14598','2013-10-01','15:30:00',3.56),('14598','2013-10-01','15:35:00',3.5),('14598','2013-10-01','15:40:00',3.43),('14598','2013-10-01','15:45:00',3.35),('14598','2013-10-01','15:50:00',3.3),('14598','2013-10-01','15:55:00',3.23),('14598','2013-10-01','16:00:00',3.16),('14598','2013-10-01','16:05:00',3.08),('14598','2013-10-01','16:10:00',3.01),('14598','2013-10-01','16:15:00',2.93),('14598','2013-10-01','16:20:00',2.86),('14598','2013-10-01','16:25:00',2.77),('14598','2013-10-01','16:30:00',2.68),('14598','2013-10-01','16:35:00',2.6),('14598','2013-10-01','16:40:00',2.52),('14598','2013-10-01','16:45:00',2.42),('14598','2013-10-01','16:50:00',2.34),('14598','2013-10-01','16:55:00',2.23),('14598','2013-10-01','17:00:00',2.13),('14598','2013-10-01','17:05:00',2.02),('14598','2013-10-01','17:10:00',1.91),('14598','2013-10-01','17:15:00',1.8),('14598','2013-10-01','17:20:00',1.68),('14598','2013-10-01','17:25:00',1.59),('14598','2013-10-01','17:30:00',1.48),('14598','2013-10-01','17:35:00',1.37),('14598','2013-10-01','17:40:00',1.26),('14598','2013-10-01','17:45:00',1.16),('14598','2013-10-01','17:50:00',1.01),('14598','2013-09-30','09:00:00',1.23),('14598','2013-09-30','09:05:00',1.28),('14598','2013-09-30','09:10:00',1.46),('14598','2013-09-30','09:15:00',1.27),('14598','2013-09-30','09:20:00',1.33),('14598','2013-09-30','09:25:00',1.22),('14598','2013-09-30','09:30:00',1.03),('14598','2013-09-30','09:35:00',1.04),('14598','2013-09-30','09:50:00',1.01),('14598','2013-09-30','09:55:00',1.16),('14598','2013-09-30','10:00:00',1.01),('14598','2013-09-30','10:05:00',1.09),('14598','2013-09-30','10:10:00',1.28),('14598','2013-09-30','10:15:00',1.6),('14598','2013-09-30','10:20:00',1.99),('14598','2013-09-30','10:25:00',2.51),('14598','2013-09-30','10:30:00',2.45),('14598','2013-09-30','10:35:00',2.3),('14598','2013-09-30','10:40:00',2.97),('14598','2013-09-30','10:45:00',3.35),('14598','2013-09-30','10:50:00',3.31),('14598','2013-09-30','10:55:00',3.11),('14598','2013-09-30','11:00:00',3.18),('14598','2013-09-30','11:05:00',3.51),('14598','2013-09-30','11:10:00',3.8),('14598','2013-09-30','11:15:00',3.73),('14598','2013-09-30','11:20:00',1.09),('14598','2013-09-30','11:35:00',2.05),('14598','2013-09-30','11:40:00',3.59),('14598','2013-09-30','11:45:00',4.02),('14598','2013-09-30','11:50:00',3.89),('14598','2013-09-30','11:55:00',3.9),('14598','2013-09-30','12:00:00',3.92),('14598','2013-09-30','12:05:00',4),('14598','2013-09-30','12:10:00',3.46),('14598','2013-09-30','12:15:00',4.1),('14598','2013-09-30','12:20:00',4.1),('14598','2013-09-30','12:25:00',4.16),('14598','2013-09-30','12:30:00',3.63),('14598','2013-09-30','12:35:00',4.39),('14598','2013-09-30','12:40:00',4.1),('14598','2013-09-30','12:45:00',4.16),('14598','2013-09-30','12:50:00',4.16),('14598','2013-09-30','12:55:00',4.12),('14598','2013-09-30','13:00:00',3.19),('14598','2013-09-30','13:05:00',3.71),('14598','2013-09-30','13:10:00',3.29),('14598','2013-09-30','13:15:00',4.52),('14598','2013-09-30','13:20:00',4.61),('14598','2013-09-30','13:25:00',3.76),('14598','2013-09-30','13:30:00',1.01),('14598','2013-09-30','13:35:00',1.08),('14598','2013-09-30','13:40:00',1.18),('14598','2013-09-30','13:45:00',1.51),('14598','2013-09-30','13:50:00',1.81),('14598','2013-09-30','14:10:00',2.27),('14598','2013-09-30','14:15:00',4.98),('14598','2013-09-30','14:20:00',5.26),('14598','2013-09-30','14:25:00',4.84),('14598','2013-09-30','14:30:00',4.18),('14598','2013-09-30','14:35:00',4.46),('14598','2013-09-30','14:40:00',4.5),('14598','2013-09-30','14:45:00',3.37),('14598','2013-09-30','14:50:00',4.63),('14598','2013-09-30','14:55:00',4.43),('14598','2013-09-30','15:00:00',4.53),('14598','2013-09-30','15:05:00',4.44),('14598','2013-09-30','15:10:00',4.65),('14598','2013-09-30','15:15:00',2.13),('14598','2013-09-30','15:35:00',1.65),('14598','2013-09-30','15:40:00',3.49),('14598','2013-09-30','15:45:00',3.38),('14598','2013-09-30','15:50:00',3.02),('14598','2013-09-30','15:55:00',3.18),('14598','2013-09-30','16:00:00',3.45),('14598','2013-09-30','16:05:00',3.25),('14598','2013-09-30','16:10:00',2.3),('14598','2013-09-30','16:15:00',2.96),('14598','2013-09-30','16:20:00',1.97),('14598','2013-09-30','16:25:00',2.71),('14598','2013-09-30','16:30:00',2.33),('14598','2013-09-30','16:35:00',2.54),('14598','2013-09-30','16:40:00',2.44),('14598','2013-09-30','16:45:00',2.52),('14598','2013-09-30','16:50:00',2.4),('14598','2013-09-30','16:55:00',2.31),('14598','2013-09-30','17:00:00',2.2),('14598','2013-09-30','17:05:00',2.11),('14598','2013-09-30','17:10:00',1.99),('14598','2013-09-30','17:15:00',1.87),('14598','2013-09-30','17:20:00',1.76),('14598','2013-09-30','17:25:00',1.69),('14598','2013-09-30','17:30:00',1.39),('14598','2013-09-30','17:55:00',1.04),('14598','2013-09-29','09:35:00',1.24),('14598','2013-09-29','09:40:00',1.65),('14598','2013-09-29','09:45:00',1.7),('14598','2013-09-29','09:50:00',1.97),('14598','2013-09-29','09:55:00',2),('14598','2013-09-29','10:00:00',1.46),('14598','2013-09-29','10:05:00',1.36),('14598','2013-09-29','10:10:00',1.71),('14598','2013-09-29','10:15:00',2.29),('14598','2013-09-29','10:20:00',2.34),('14598','2013-09-29','10:25:00',2.41),('14598','2013-09-29','10:30:00',2.56),('14598','2013-09-29','10:35:00',1.79),('14598','2013-09-29','10:40:00',2.83),('14598','2013-09-29','10:45:00',2.98),('14598','2013-09-29','10:50:00',1.88),('14598','2013-09-29','10:55:00',2.09),('14598','2013-09-29','11:00:00',2.73),('14598','2013-09-29','11:05:00',2.95),('14598','2013-09-29','11:10:00',2.97),('14598','2013-09-29','11:15:00',2.96),('14598','2013-09-29','11:20:00',3.13),('14598','2013-09-29','11:25:00',3.15),('14598','2013-09-29','11:30:00',3.38),('14598','2013-09-29','11:35:00',3.48),('14598','2013-09-29','11:40:00',3.35),('14598','2013-09-29','11:45:00',3.09),('14598','2013-09-29','11:50:00',2.19),('14598','2013-09-29','11:55:00',1.38),('14598','2013-09-29','12:00:00',1.18),('14598','2013-09-29','12:05:00',1.03),('14598','2013-09-29','12:10:00',1.28),('14598','2013-09-29','12:15:00',1.05),('14598','2013-09-29','12:20:00',1.3),('14598','2013-09-29','12:25:00',1.35),('14598','2013-09-29','12:35:00',1.35),('14598','2013-09-29','12:40:00',1.69),('14598','2013-09-29','12:45:00',1.58),('14598','2013-09-29','12:50:00',1.63),('14598','2013-09-29','12:55:00',1.64),('14598','2013-09-29','13:00:00',2),('14598','2013-09-29','13:05:00',1.93),('14598','2013-09-29','13:10:00',2.44),('14598','2013-09-29','13:15:00',3.69),('14598','2013-09-29','13:20:00',2.52),('14598','2013-09-29','13:25:00',3.14),('14598','2013-09-29','13:30:00',2.87),('14598','2013-09-29','13:35:00',2.8),('14598','2013-09-29','13:40:00',3.56),('14598','2013-09-29','13:45:00',4),('14598','2013-09-29','13:50:00',2.09),('14598','2013-09-29','13:55:00',1.82),('14598','2013-09-29','14:00:00',1.34),('14598','2013-09-29','14:05:00',1.11),('14598','2013-09-29','14:10:00',1.1),('14598','2013-09-29','14:15:00',1.2),('14598','2013-09-29','14:20:00',1.17),('14598','2013-09-29','14:25:00',1.11),('14598','2013-09-29','14:55:00',1.04),('14598','2013-09-29','15:00:00',1.05),('14598','2013-09-29','15:10:00',1),('14598','2013-09-29','15:15:00',1.21),('14598','2013-09-29','15:20:00',1.32),('14598','2013-09-29','15:50:00',1.32),('14598','2013-09-29','15:55:00',1.53),('14598','2013-09-29','16:00:00',1.19),('14598','2013-09-29','16:05:00',1.02),('14598','2013-09-29','16:10:00',1.13),('14598','2013-09-29','16:15:00',1.37),('14598','2013-09-29','16:20:00',1.38),('14598','2013-09-29','16:25:00',1.28),('14598','2013-09-29','16:30:00',1.31),('14598','2013-09-29','16:35:00',1.1),('14598','2013-09-29','16:45:00',1.42),('14598','2013-09-29','16:50:00',2.34),('14598','2013-09-29','16:55:00',1.95),('14598','2013-09-29','17:00:00',1.4),('14598','2013-09-29','17:05:00',1.02),('14598','2013-09-29','17:10:00',1.03),('14598','2014-04-14','08:25:00',1.02),('14598','2014-04-14','08:30:00',1.13),('14598','2014-04-14','08:35:00',1.26),('14598','2014-04-14','08:40:00',1.37),('14598','2014-04-14','08:45:00',1.47),('14598','2014-04-14','08:50:00',1.58),('14598','2014-04-14','08:55:00',1.7),('14598','2014-04-14','09:00:00',1.81),('14598','2014-04-14','09:05:00',1.94),('14598','2014-04-14','09:10:00',2.06),('14598','2014-04-14','09:15:00',2.2),('14598','2014-04-14','09:20:00',2.3),('14598','2014-04-14','09:25:00',2.4),('14598','2014-04-14','09:30:00',2.47),('14598','2014-04-14','09:35:00',2.59),('14598','2014-04-14','09:40:00',2.69),('14598','2014-04-14','09:45:00',2.79),('14598','2014-04-14','09:50:00',2.88),('14598','2014-04-14','09:55:00',2.97),('14598','2014-04-14','10:00:00',3.05),('14598','2014-04-14','10:05:00',3.13),('14598','2014-04-14','10:10:00',3.2),('14598','2014-04-14','10:15:00',3.28),('14598','2014-04-14','10:20:00',3.36),('14598','2014-04-14','10:25:00',3.44),('14598','2014-04-14','10:30:00',3.51),('14598','2014-04-14','10:35:00',3.59),('14598','2014-04-14','10:40:00',3.66),('14598','2014-04-14','10:45:00',3.72),('14598','2014-04-14','10:50:00',3.8),('14598','2014-04-14','10:55:00',3.85),('14598','2014-04-14','11:00:00',3.92),('14598','2014-04-14','11:05:00',3.99),('14598','2014-04-14','11:10:00',4.04),('14598','2014-04-14','11:15:00',4.08),('14598','2014-04-14','11:20:00',4.14),('14598','2014-04-14','11:25:00',4.2),('14598','2014-04-14','11:30:00',4.29),('14598','2014-04-14','11:35:00',4.36),('14598','2014-04-14','11:40:00',4.44),('14598','2014-04-14','11:45:00',4.51),('14598','2014-04-14','11:50:00',4.54),('14598','2014-04-14','11:55:00',4.59),('14598','2014-04-14','12:00:00',4.63),('14598','2014-04-14','12:05:00',4.66),('14598','2014-04-14','12:10:00',4.72),('14598','2014-04-14','12:15:00',4.76),('14598','2014-04-14','12:20:00',4.81),('14598','2014-04-14','12:25:00',4.82),('14598','2014-04-14','12:30:00',4.8),('14598','2014-04-14','12:35:00',4.88),('14598','2014-04-14','12:40:00',4.91),('14598','2014-04-14','12:45:00',4.91),('14598','2014-04-14','12:50:00',4.92),('14598','2014-04-14','12:55:00',4.95),('14598','2014-04-14','13:00:00',4.98),('14598','2014-04-14','13:05:00',5),('14598','2014-04-14','13:10:00',5.02),('14598','2014-04-14','13:15:00',5.03),('14598','2014-04-14','13:20:00',5.04),('14598','2014-04-14','13:25:00',5.05),('14598','2014-04-14','13:30:00',5.06),('14598','2014-04-14','13:35:00',5.09),('14598','2014-04-14','13:40:00',5.07),('14598','2014-04-14','13:45:00',5.05),('14598','2014-04-14','13:50:00',5.06),('14598','2014-04-14','13:55:00',5.06),('14598','2014-04-14','14:00:00',5.05),('14598','2014-04-14','14:05:00',5.04),('14598','2014-04-14','14:10:00',5.03),('14598','2014-04-14','14:15:00',5.03),('14598','2014-04-14','14:20:00',5.02),('14598','2014-04-14','14:25:00',4.99),('14598','2014-04-14','14:30:00',4.98),('14598','2014-04-14','14:35:00',4.97),('14598','2014-04-14','14:40:00',4.94),('14598','2014-04-14','14:45:00',4.9),('14598','2014-04-14','14:50:00',4.88),('14598','2014-04-14','14:55:00',4.85),('14598','2014-04-14','15:00:00',4.83),('14598','2014-04-14','15:05:00',4.79),('14598','2014-04-14','15:10:00',4.75),('14598','2014-04-14','15:15:00',4.67),('14598','2014-04-14','15:20:00',4.66),('14598','2014-04-14','15:25:00',4.61),('14598','2014-04-14','15:30:00',4.54),('14598','2014-04-14','15:35:00',4.52),('14598','2014-04-14','15:40:00',4.48),('14598','2014-04-14','15:45:00',4.41),('14598','2014-04-14','15:50:00',4.33),('14598','2014-04-14','15:55:00',4.27),('14598','2014-04-14','16:00:00',4.22),('14598','2014-04-14','16:05:00',4.16),('14598','2014-04-14','16:10:00',4.12),('14598','2014-04-14','16:15:00',4.03),('14598','2014-04-14','16:20:00',3.98),('14598','2014-04-14','16:25:00',3.92),('14598','2014-04-14','16:30:00',3.85),('14598','2014-04-14','16:35:00',3.77),('14598','2014-04-14','16:40:00',3.68),('14598','2014-04-14','16:45:00',3.6),('14598','2014-04-14','16:50:00',3.51),('14598','2014-04-14','16:55:00',3.43),('14598','2014-04-14','17:00:00',3.34),('14598','2014-04-14','17:05:00',3.25),('14598','2014-04-14','17:10:00',3.16),('14598','2014-04-14','17:15:00',3.06),('14598','2014-04-14','17:20:00',2.97),('14598','2014-04-14','17:25:00',2.87),('14598','2014-04-14','17:30:00',2.77),('14598','2014-04-14','17:35:00',2.63),('14598','2014-04-14','17:40:00',2.53),('14598','2014-04-14','17:45:00',2.43),('14598','2014-04-14','17:50:00',2.31),('14598','2014-04-14','17:55:00',2.2),('14598','2014-04-14','18:00:00',2.08),('14598','2014-04-14','18:05:00',1.99),('14598','2014-04-14','18:10:00',1.86),('14598','2014-04-14','18:15:00',1.76),('14598','2014-04-14','18:20:00',1.64),('14598','2014-04-14','18:25:00',1.52),('14598','2014-04-14','18:30:00',1.41),('14598','2014-04-14','18:35:00',1.25),('14598','2014-04-14','18:40:00',1.16),('14598','2014-04-14','18:45:00',1.03),('14598','2013-09-28','08:55:00',1.01),('14598','2013-09-28','09:00:00',1.1),('14598','2013-09-28','09:05:00',1.21),('14598','2013-09-28','09:10:00',1.34),('14598','2013-09-28','09:15:00',1.44),('14598','2013-09-28','09:20:00',1.55),('14598','2013-09-28','09:25:00',1.64),('14598','2013-09-28','09:30:00',1.75),('14598','2013-09-28','09:35:00',1.85),('14598','2013-09-28','09:40:00',1.94),('14598','2013-09-28','09:45:00',2.03),('14598','2013-09-28','09:50:00',2.07),('14598','2013-09-28','09:55:00',2.18),('14598','2013-09-28','10:00:00',2.28),('14598','2013-09-28','10:05:00',2.44),('14598','2013-09-28','10:10:00',2.54),('14598','2013-09-28','10:15:00',2.33),('14598','2013-09-28','10:20:00',1.73),('14598','2013-09-28','10:25:00',1.3),('14598','2013-09-28','10:30:00',3.12),('14598','2013-09-28','10:35:00',3.15),('14598','2013-09-28','10:40:00',3.19),('14598','2013-09-28','10:45:00',3.38),('14598','2013-09-28','10:50:00',2.33),('14598','2013-09-28','10:55:00',2.65),('14598','2013-09-28','11:00:00',3.31),('14598','2013-09-28','11:05:00',2.11),('14598','2013-09-28','11:10:00',3.57),('14598','2013-09-28','11:15:00',3.54),('14598','2013-09-28','11:20:00',3.52),('14598','2013-09-28','11:25:00',3.54),('14598','2013-09-28','11:30:00',3.56),('14598','2013-09-28','11:35:00',3.63),('14598','2013-09-28','11:40:00',3.66),('14598','2013-09-28','11:45:00',3.71),('14598','2013-09-28','11:50:00',3.76),('14598','2013-09-28','11:55:00',3.8),('14598','2013-09-28','12:00:00',3.84),('14598','2013-09-28','12:05:00',3.88),('14598','2013-09-28','12:10:00',3.91),('14598','2013-09-28','12:15:00',3.95),('14598','2013-09-28','12:20:00',3.97),('14598','2013-09-28','12:25:00',3.98),('14598','2013-09-28','12:30:00',4.03),('14598','2013-09-28','12:35:00',4.05),('14598','2013-09-28','12:40:00',4.07),('14598','2013-09-28','12:45:00',4.05),('14598','2013-09-28','12:50:00',4.1),('14598','2013-09-28','12:55:00',4.13),('14598','2013-09-28','13:00:00',4.14),('14598','2013-09-28','13:05:00',4.14),('14598','2013-09-28','13:10:00',4.12),('14598','2013-09-28','13:15:00',4.12),('14598','2013-09-28','13:20:00',4.12),('14598','2013-09-28','13:25:00',4.14),('14598','2013-09-28','13:30:00',4.13),('14598','2013-09-28','13:35:00',4.14),('14598','2013-09-28','13:40:00',4.14),('14598','2013-09-28','13:45:00',4.11),('14598','2013-09-28','13:50:00',4.12),('14598','2013-09-28','13:55:00',4.13),('14598','2013-09-28','14:00:00',4.12),('14598','2013-09-28','14:05:00',4.09),('14598','2013-09-28','14:10:00',4.08),('14598','2013-09-28','14:15:00',4.06),('14598','2013-09-28','14:20:00',4.04),('14598','2013-09-28','14:25:00',4.04),('14598','2013-09-28','14:30:00',3.95),('14598','2013-09-28','14:35:00',3.99),('14598','2013-09-28','14:40:00',3.96),('14598','2013-09-28','14:45:00',3.95),('14598','2013-09-28','14:50:00',3.9),('14598','2013-09-28','14:55:00',3.85),('14598','2013-09-28','15:00:00',3.8),('14598','2013-09-28','15:05:00',3.74),('14598','2013-09-28','15:10:00',3.71),('14598','2013-09-28','15:15:00',3.7),('14598','2013-09-28','15:20:00',3.65),('14598','2013-09-28','15:25:00',3.62),('14598','2013-09-28','15:30:00',3.39),('14598','2013-09-28','15:35:00',3.39),('14598','2013-09-28','15:40:00',3.41),('14598','2013-09-28','15:45:00',3.29),('14598','2013-09-28','15:50:00',3.08),('14598','2013-09-28','15:55:00',3.05),('14598','2013-09-28','16:00:00',2.74),('14598','2013-09-28','16:05:00',2.68),('14598','2013-09-28','16:10:00',1.56),('14598','2013-09-28','16:15:00',2.15),('14598','2013-09-28','16:20:00',2.65),('14598','2013-09-28','16:25:00',2.77),('14598','2013-09-28','16:30:00',2.57),('14598','2013-09-28','16:35:00',2.52),('14598','2013-09-28','16:40:00',2.45),('14598','2013-09-28','16:45:00',2.33),('14598','2013-09-28','16:50:00',2.25),('14598','2013-09-28','16:55:00',2.16),('14598','2013-09-28','17:00:00',2.07),('14598','2013-09-28','17:05:00',1.99),('14598','2013-09-28','17:10:00',1.91),('14598','2013-09-28','17:15:00',1.83),('14598','2013-09-28','17:20:00',1.75),('14598','2013-09-28','17:25:00',1.59),('14598','2013-09-28','17:30:00',1.31),('14598','2013-09-27','08:50:00',1),('14598','2013-09-27','08:55:00',1.19),('14598','2013-09-27','09:00:00',1.1),('14598','2013-09-27','09:45:00',1.29),('14598','2013-09-27','09:50:00',1.11),('14598','2013-09-27','09:55:00',1.24),('14598','2013-09-27','10:00:00',2.23),('14598','2013-09-27','10:05:00',2.15),('14598','2013-09-27','10:10:00',2.39),('14598','2013-09-27','10:15:00',2.28),('14598','2013-09-27','10:20:00',1.41),('14598','2013-09-27','10:25:00',1.22),('14598','2013-09-27','10:30:00',1.55),('14598','2013-09-27','10:35:00',3.02),('14598','2013-09-27','10:40:00',2.92),('14598','2013-09-27','10:45:00',2.94),('14598','2013-09-27','10:50:00',3.09),('14598','2013-09-27','10:55:00',3.27),('14598','2013-09-27','11:00:00',1.61),('14598','2013-09-27','11:05:00',3.06),('14598','2013-09-27','11:10:00',3.1),('14598','2013-09-27','11:15:00',3.95),('14598','2013-09-27','11:20:00',2.99),('14598','2013-09-27','11:25:00',2.31),('14598','2013-09-27','11:30:00',2.47),('14598','2013-09-27','11:35:00',1.61),('14598','2013-09-27','11:40:00',1.67),('14598','2013-09-27','11:45:00',1.63),('14598','2013-09-27','11:50:00',2.58),('14598','2013-09-27','11:55:00',4.26),('14598','2013-09-27','12:00:00',3.94),('14598','2013-09-27','12:05:00',3.96),('14598','2013-09-27','12:10:00',3.98),('14598','2013-09-27','12:15:00',3.94),('14598','2013-09-27','12:20:00',3.95),('14598','2013-09-27','12:25:00',3.94),('14598','2013-09-27','12:30:00',3.95),('14598','2013-09-27','12:35:00',3.98),('14598','2013-09-27','12:40:00',4),('14598','2013-09-27','12:45:00',4.07),('14598','2013-09-27','12:50:00',4.07),('14598','2013-09-27','12:55:00',4.13),('14598','2013-09-27','13:00:00',3.89),('14598','2013-09-27','13:05:00',4.09),('14598','2013-09-27','13:10:00',4.07),('14598','2013-09-27','13:15:00',4.03),('14598','2013-09-27','13:20:00',4.11),('14598','2013-09-27','13:25:00',4.09),('14598','2013-09-27','13:30:00',4.06),('14598','2013-09-27','13:35:00',4.06),('14598','2013-09-27','13:40:00',4.02),('14598','2013-09-27','13:45:00',4.01),('14598','2013-09-27','13:50:00',4.08),('14598','2013-09-27','13:55:00',4.05),('14598','2013-09-27','14:00:00',4.13),('14598','2013-09-27','14:05:00',3.63),('14598','2013-09-27','14:10:00',3),('14598','2013-09-27','14:15:00',1.88),('14598','2013-09-27','14:20:00',3.38),('14598','2013-09-27','14:25:00',2.69),('14598','2013-09-27','14:30:00',3.47),('14598','2013-09-27','14:35:00',4.13),('14598','2013-09-27','14:40:00',3.92),('14598','2013-09-27','14:45:00',3.86),('14598','2013-09-27','14:50:00',3.91),('14598','2013-09-27','14:55:00',3.91),('14598','2013-09-27','15:00:00',3.49),('14598','2013-09-27','15:05:00',3.65),('14598','2013-09-27','15:10:00',3.36),('14598','2013-09-27','15:15:00',3.56),('14598','2013-09-27','15:20:00',3.56),('14598','2013-09-27','15:25:00',3.61),('14598','2013-09-27','15:30:00',3.54),('14598','2013-09-27','15:35:00',3.48),('14598','2013-09-27','15:40:00',3.41),('14598','2013-09-27','15:45:00',3.31),('14598','2013-09-27','15:50:00',3.27),('14598','2013-09-27','15:55:00',3.21),('14598','2013-09-27','16:00:00',3.14),('14598','2013-09-27','16:05:00',3.07),('14598','2013-09-27','16:10:00',2.98),('14598','2013-09-27','16:15:00',2.95),('14598','2013-09-27','16:20:00',2.87),('14598','2013-09-27','16:25:00',2.79),('14598','2013-09-27','16:30:00',2.7),('14598','2013-09-27','16:35:00',2.58),('14598','2013-09-27','16:40:00',2.51),('14598','2013-09-27','16:45:00',2.4),('14598','2013-09-27','16:50:00',2.31),('14598','2013-09-27','16:55:00',2.21),('14598','2013-09-27','17:00:00',2.18),('14598','2013-09-27','17:05:00',2.09),('14598','2013-09-27','17:10:00',1.99),('14598','2013-09-27','17:15:00',1.87),('14598','2013-09-27','17:20:00',1.76),('14598','2013-09-27','17:25:00',1.66),('14598','2013-09-27','17:30:00',1.53),('14598','2013-09-27','17:35:00',1.41),('14598','2013-09-27','17:40:00',1.35),('14598','2013-09-27','17:45:00',1.19),('14598','2013-09-27','17:50:00',1.08),('14598','2013-09-27','17:55:00',1.02),('14598','2013-09-26','08:55:00',1.09),('14598','2013-09-26','09:00:00',1.22),('14598','2013-09-26','09:05:00',1.33),('14598','2013-09-26','09:10:00',1.45),('14598','2013-09-26','09:15:00',1.56),('14598','2013-09-26','09:20:00',1.69),('14598','2013-09-26','09:25:00',1.8),('14598','2013-09-26','09:30:00',1.86),('14598','2013-09-26','09:35:00',1.9),('14598','2013-09-26','09:40:00',2.03),('14598','2013-09-26','09:45:00',2.11),('14598','2013-09-26','09:50:00',2.21),('14598','2013-09-26','09:55:00',2.35),('14598','2013-09-26','10:00:00',2.15),('14598','2013-09-26','10:05:00',1.96),('14598','2013-09-26','10:10:00',1.8),('14598','2013-09-26','10:15:00',2),('14598','2013-09-26','10:20:00',2.48),('14598','2013-09-26','10:25:00',2.72),('14598','2013-09-26','10:30:00',2.7),('14598','2013-09-26','10:35:00',2.89),('14598','2013-09-26','10:40:00',2.85),('14598','2013-09-26','10:45:00',2.99),('14598','2013-09-26','10:50:00',3.09),('14598','2013-09-26','10:55:00',3.18),('14598','2013-09-26','11:00:00',3.23),('14598','2013-09-26','11:05:00',2.77),('14598','2013-09-26','11:10:00',1.91),('14598','2013-09-26','11:15:00',2.37),('14598','2013-09-26','11:20:00',2.13),('14598','2013-09-26','11:25:00',1.33),('14598','2013-09-26','11:30:00',2.38),('14598','2013-09-26','11:35:00',3.79),('14598','2013-09-26','11:40:00',3.68),('14598','2013-09-26','11:45:00',3.8),('14598','2013-09-26','11:50:00',3.85),('14598','2013-09-26','11:55:00',3.9),('14598','2013-09-26','12:00:00',4.02),('14598','2013-09-26','12:05:00',4.26),('14598','2013-09-26','12:10:00',3.62),('14598','2013-09-26','12:15:00',2.96),('14598','2013-09-26','12:20:00',3.8),('14598','2013-09-26','12:25:00',2.99),('14598','2013-09-26','12:30:00',3.56),('14598','2013-09-26','12:35:00',3.92),('14598','2013-09-26','12:40:00',4.28),('14598','2013-09-26','12:45:00',3.88),('14598','2013-09-26','12:50:00',4.2),('14598','2013-09-26','12:55:00',3.47),('14598','2013-09-26','13:00:00',3.38),('14598','2013-09-26','13:05:00',2.5),('14598','2013-09-26','13:10:00',4),('14598','2013-09-26','13:15:00',4.26),('14598','2013-09-26','13:20:00',4.27),('14598','2013-09-26','13:25:00',4.33),('14598','2013-09-26','13:30:00',3.06),('14598','2013-09-26','13:35:00',3.41),('14598','2013-09-26','13:40:00',3.3),('14598','2013-09-26','13:45:00',3.61),('14598','2013-09-26','13:50:00',3.65),('14598','2013-09-26','13:55:00',4.13),('14598','2013-09-26','14:00:00',4.36),('14598','2013-09-26','14:05:00',4.26),('14598','2013-09-26','14:10:00',4.2),('14598','2013-09-26','14:15:00',4.15),('14598','2013-09-26','14:20:00',4.17),('14598','2013-09-26','14:25:00',4.11),('14598','2013-09-26','14:30:00',1.44),('14598','2013-09-26','14:35:00',1.27),('14598','2013-09-26','14:40:00',3.14),('14598','2013-09-26','14:45:00',4),('14598','2013-09-26','14:50:00',4),('14598','2013-09-26','14:55:00',2.96),('14598','2013-09-26','15:00:00',2.99),('14598','2013-09-26','15:05:00',3.76),('14598','2013-09-26','15:10:00',2.96),('14598','2013-09-26','15:20:00',3.62),('14598','2013-09-26','15:25:00',3.88),('14598','2013-09-26','15:30:00',3.58),('14598','2013-09-26','15:35:00',3.64),('14598','2013-09-26','15:40:00',3.25),('14598','2013-09-26','15:45:00',2.92),('14598','2013-09-26','15:50:00',1.67),('14598','2013-09-26','15:55:00',1.14),('14598','2013-09-26','16:00:00',1.32),('14598','2013-09-26','16:05:00',2.13),('14598','2013-09-26','16:10:00',2.32),('14598','2013-09-26','16:15:00',2.05),('14598','2013-09-26','16:20:00',2.65),('14598','2013-09-26','16:25:00',2.73),('14598','2013-09-26','16:30:00',2.73),('14598','2013-09-26','16:35:00',2.64),('14598','2013-09-26','16:40:00',2.53),('14598','2013-09-26','16:45:00',2.44),('14598','2013-09-26','16:50:00',2.36),('14598','2013-09-26','16:55:00',1.92),('14598','2013-09-26','17:05:00',1.57),('14598','2013-09-26','17:10:00',1.75),('14598','2013-09-26','17:15:00',1.7),('14598','2013-09-26','17:20:00',1.61),('14598','2013-09-26','17:25:00',1.53),('14598','2013-09-26','17:30:00',1.3),('14598','2013-09-26','17:35:00',1.38),('14598','2013-09-26','17:40:00',1.33),('14598','2013-09-26','17:45:00',1.21),('14598','2013-09-26','17:50:00',1.06),('14598','2013-09-25','08:45:00',1.21),('14598','2013-09-25','08:50:00',1.25),('14598','2013-09-25','08:55:00',1.55),('14598','2013-09-25','09:00:00',1.69),('14598','2013-09-25','09:05:00',1.08),('14598','2013-09-25','09:10:00',1.7),('14598','2013-09-25','09:15:00',1.73),('14598','2013-09-25','09:20:00',1.16),('14598','2013-09-25','09:25:00',1.48),('14598','2013-09-25','09:30:00',1.75),('14598','2013-09-25','09:35:00',2.04),('14598','2013-09-25','09:40:00',2.33),('14598','2013-09-25','09:45:00',2.52),('14598','2013-09-25','09:50:00',1.63),('14598','2013-09-25','09:55:00',1.83),('14598','2013-09-25','10:00:00',2.22),('14598','2013-09-25','10:05:00',1.29),('14598','2013-09-25','10:10:00',1.21),('14598','2013-09-25','10:35:00',1.31),('14598','2013-09-25','10:40:00',3.11),('14598','2013-09-25','10:45:00',3.16),('14598','2013-09-25','10:50:00',3.21),('14598','2013-09-25','10:55:00',3.34),('14598','2013-09-25','11:00:00',3.22),('14598','2013-09-25','11:05:00',3.47),('14598','2013-09-25','11:10:00',3.52),('14598','2013-09-25','11:15:00',3.54),('14598','2013-09-25','11:20:00',3.63),('14598','2013-09-25','11:25:00',3.66),('14598','2013-09-25','11:30:00',3.72),('14598','2013-09-25','11:35:00',3.73),('14598','2013-09-25','11:40:00',3.78),('14598','2013-09-25','11:45:00',3.83),('14598','2013-09-25','11:50:00',3.89),('14598','2013-09-25','11:55:00',3.87),('14598','2013-09-25','12:00:00',3.96),('14598','2013-09-25','12:05:00',4.02),('14598','2013-09-25','12:10:00',4.04),('14598','2013-09-25','12:15:00',4.08),('14598','2013-09-25','12:20:00',4.12),('14598','2013-09-25','12:25:00',4.15),('14598','2013-09-25','12:30:00',4.16),('14598','2013-09-25','12:35:00',4.16),('14598','2013-09-25','12:40:00',4.2),('14598','2013-09-25','12:45:00',4.23),('14598','2013-09-25','12:50:00',4.26),('14598','2013-09-25','12:55:00',4.27),('14598','2013-09-25','13:00:00',4.29),('14598','2013-09-25','13:05:00',4.32),('14598','2013-09-25','13:10:00',4.31),('14598','2013-09-25','13:15:00',4.33),('14598','2013-09-25','13:20:00',4.33),('14598','2013-09-25','13:25:00',4.36),('14598','2013-09-25','13:30:00',4.36),('14598','2013-09-25','13:35:00',4.22),('14598','2013-09-25','13:40:00',4.21),('14598','2013-09-25','13:45:00',4.26),('14598','2013-09-25','13:50:00',4.24),('14598','2013-09-25','13:55:00',4.3),('14598','2013-09-25','14:00:00',4.27),('14598','2013-09-25','14:05:00',4.24),('14598','2013-09-25','14:10:00',4.23),('14598','2013-09-25','14:15:00',3.93),('14598','2013-09-25','14:20:00',4.28),('14598','2013-09-25','14:25:00',4.19),('14598','2013-09-25','14:30:00',4.17),('14598','2013-09-25','14:35:00',4.14),('14598','2013-09-25','14:40:00',4.1),('14598','2013-09-25','14:45:00',3.92),('14598','2013-09-25','14:50:00',3.94),('14598','2013-09-25','14:55:00',4.09),('14598','2013-09-25','15:00:00',3.53),('14598','2013-09-25','15:05:00',3.89),('14598','2013-09-25','15:10:00',4.01),('14598','2013-09-25','15:15:00',3.6),('14598','2013-09-25','15:20:00',3.65),('14598','2013-09-25','15:25:00',3.82),('14598','2013-09-25','15:30:00',3.74),('14598','2013-09-25','15:35:00',3.65),('14598','2013-09-25','15:40:00',3.63),('14598','2013-09-25','15:45:00',3.59),('14598','2013-09-25','15:50:00',3.52),('14598','2013-09-25','15:55:00',3.46),('14598','2013-09-25','16:00:00',3.37),('14598','2013-09-25','16:05:00',3.28),('14598','2013-09-25','16:10:00',3.23),('14598','2013-09-25','16:15:00',3.15),('14598','2013-09-25','16:20:00',3.08),('14598','2013-09-25','16:25:00',3.01),('14598','2013-09-25','16:30:00',2.94),('14598','2013-09-25','16:35:00',2.86),('14598','2013-09-25','16:40:00',2.77),('14598','2013-09-25','16:45:00',2.67),('14598','2013-09-25','16:50:00',2.59),('14598','2013-09-25','16:55:00',2.5),('14598','2013-09-25','17:00:00',2.41),('14598','2013-09-25','17:05:00',2.31),('14598','2013-09-25','17:10:00',2.21),('14598','2013-09-25','17:15:00',2.11),('14598','2013-09-25','17:20:00',2.01),('14598','2013-09-25','17:25:00',1.9),('14598','2013-09-25','17:30:00',1.8),('14598','2013-09-25','17:35:00',1.69),('14598','2013-09-25','17:40:00',1.58),('14598','2013-09-25','17:45:00',1.47),('14598','2013-09-25','17:50:00',1.36),('14598','2013-09-25','17:55:00',1.25),('14598','2013-09-25','18:00:00',1.11),('14598','2013-09-25','18:05:00',1.01),('14598','2013-09-24','08:50:00',1.06),('14598','2013-09-24','08:55:00',1.17),('14598','2013-09-24','09:00:00',1.28),('14598','2013-09-24','09:05:00',1.39),('14598','2013-09-24','09:10:00',1.48),('14598','2013-09-24','09:15:00',1.62),('14598','2013-09-24','09:20:00',1.74),('14598','2013-09-24','09:25:00',1.85),('14598','2013-09-24','09:30:00',1.95),('14598','2013-09-24','09:35:00',2.05),('14598','2013-09-24','09:40:00',2.14),('14598','2013-09-24','09:45:00',2.24),('14598','2013-09-24','09:50:00',2.33),('14598','2013-09-24','09:55:00',2.42),('14598','2013-09-24','10:00:00',2.52),('14598','2013-09-24','10:05:00',2.61),('14598','2013-09-24','10:10:00',2.7),('14598','2013-09-24','10:15:00',2.78),('14598','2013-09-24','10:20:00',2.86),('14598','2013-09-24','10:25:00',2.94),('14598','2013-09-24','10:30:00',3.01),('14598','2013-09-24','10:35:00',3.07),('14598','2013-09-24','10:40:00',3.13),('14598','2013-09-24','10:45:00',3.19),('14598','2013-09-24','10:50:00',3.25),('14598','2013-09-24','10:55:00',3.3),('14598','2013-09-24','11:00:00',3.38),('14598','2013-09-24','11:05:00',3.43),('14598','2013-09-24','11:10:00',3.49),('14598','2013-09-24','11:15:00',3.55),('14598','2013-09-24','11:20:00',3.59),('14598','2013-09-24','11:25:00',3.64),('14598','2013-09-24','11:30:00',3.67),('14598','2013-09-24','11:35:00',3.76),('14598','2013-09-24','11:40:00',3.85),('14598','2013-09-24','11:45:00',3.93),('14598','2013-09-24','11:50:00',3.96),('14598','2013-09-24','11:55:00',3.99),('14598','2013-09-24','12:00:00',4.03),('14598','2013-09-24','12:05:00',4.07),('14598','2013-09-24','12:10:00',4.09),('14598','2013-09-24','12:15:00',4.15),('14598','2013-09-24','12:20:00',4.19),('14598','2013-09-24','12:25:00',4.22),('14598','2013-09-24','12:30:00',4.25),('14598','2013-09-24','12:35:00',4.28),('14598','2013-09-24','12:40:00',4.31),('14598','2013-09-24','12:45:00',4.33),('14598','2013-09-24','12:50:00',4.34),('14598','2013-09-24','12:55:00',4.37),('14598','2013-09-24','13:00:00',4.39),('14598','2013-09-24','13:05:00',4.42),('14598','2013-09-24','13:10:00',4.45),('14598','2013-09-24','13:15:00',4.44),('14598','2013-09-24','13:20:00',4.46),('14598','2013-09-24','13:25:00',4.42),('14598','2013-09-24','13:30:00',4.41),('14598','2013-09-24','13:35:00',4.44),('14598','2013-09-24','13:40:00',4.43),('14598','2013-09-24','13:45:00',4.42),('14598','2013-09-24','13:50:00',4.42),('14598','2013-09-24','13:55:00',4.4),('14598','2013-09-24','14:00:00',4.4),('14598','2013-09-24','14:05:00',4.38),('14598','2013-09-24','14:10:00',4.36),('14598','2013-09-24','14:15:00',4.33),('14598','2013-09-24','14:20:00',4.31),('14598','2013-09-24','14:25:00',4.29),('14598','2013-09-24','14:30:00',4.28),('14598','2013-09-24','14:35:00',4.26),('14598','2013-09-24','14:40:00',4.24),('14598','2013-09-24','14:45:00',4.21),('14598','2013-09-24','14:50:00',4.17),('14598','2013-09-24','14:55:00',4.12),('14598','2013-09-24','15:00:00',4.07),('14598','2013-09-24','15:05:00',4.06),('14598','2013-09-24','15:10:00',3.94),('14598','2013-09-24','15:15:00',3.97),('14598','2013-09-24','15:20:00',3.92),('14598','2013-09-24','15:25:00',3.88),('14598','2013-09-24','15:30:00',3.82),('14598','2013-09-24','15:35:00',3.77),('14598','2013-09-24','15:40:00',3.71),('14598','2013-09-24','15:45:00',3.64),('14598','2013-09-24','15:50:00',3.58),('14598','2013-09-24','15:55:00',3.53),('14598','2013-09-24','16:00:00',3.46),('14598','2013-09-24','16:05:00',3.37),('14598','2013-09-24','16:10:00',3.33),('14598','2013-09-24','16:15:00',3.24),('14598','2013-09-24','16:20:00',3.17),('14598','2013-09-24','16:25:00',3.08),('14598','2013-09-24','16:30:00',2.98),('14598','2013-09-24','16:35:00',2.91),('14598','2013-09-24','16:40:00',2.82),('14598','2013-09-24','16:45:00',2.76),('14598','2013-09-24','16:50:00',2.67),('14598','2013-09-24','16:55:00',2.56),('14598','2013-09-24','17:00:00',2.47),('14598','2013-09-24','17:05:00',2.38),('14598','2013-09-24','17:10:00',2.27),('14598','2013-09-24','17:15:00',2.19),('14598','2013-09-24','17:20:00',2.08),('14598','2013-09-24','17:25:00',1.95),('14598','2013-09-24','17:30:00',1.85),('14598','2013-09-24','17:35:00',1.76),('14598','2013-09-24','17:40:00',1.62),('14598','2013-09-24','17:45:00',1.41),('14598','2013-09-24','17:50:00',1.01),('14598','2013-09-24','17:55:00',1.34),('14598','2013-09-24','18:00:00',1.19),('14598','2013-09-24','18:05:00',1.07),('14598','2013-09-23','08:50:00',1.1),('14598','2013-09-23','08:55:00',1.21),('14598','2013-09-23','09:00:00',1.31),('14598','2013-09-23','09:05:00',1.42),('14598','2013-09-23','09:10:00',1.53),('14598','2013-09-23','09:15:00',1.67),('14598','2013-09-23','09:20:00',1.8),('14598','2013-09-23','09:25:00',1.9),('14598','2013-09-23','09:30:00',1.99),('14598','2013-09-23','09:35:00',2.1),('14598','2013-09-23','09:40:00',2.19),('14598','2013-09-23','09:45:00',2.28),('14598','2013-09-23','09:50:00',2.38),('14598','2013-09-23','09:55:00',2.47),('14598','2013-09-23','10:00:00',2.55),('14598','2013-09-23','10:05:00',2.65),('14598','2013-09-23','10:10:00',2.74),('14598','2013-09-23','10:15:00',2.82),('14598','2013-09-23','10:20:00',2.9),('14598','2013-09-23','10:25:00',2.98),('14598','2013-09-23','10:30:00',3.07),('14598','2013-09-23','10:35:00',3.14),('14598','2013-09-23','10:40:00',3.22),('14598','2013-09-23','10:45:00',3.28),('14598','2013-09-23','10:50:00',3.34),('14598','2013-09-23','10:55:00',3.41),('14598','2013-09-23','11:00:00',3.47),('14598','2013-09-23','11:05:00',3.52),('14598','2013-09-23','11:10:00',3.59),('14598','2013-09-23','11:15:00',3.62),('14598','2013-09-23','11:20:00',3.68),('14598','2013-09-23','11:25:00',3.72),('14598','2013-09-23','11:30:00',3.77),('14598','2013-09-23','11:35:00',3.84),('14598','2013-09-23','11:40:00',3.79),('14598','2013-09-23','11:45:00',3.92),('14598','2013-09-23','11:50:00',3.9),('14598','2013-09-23','11:55:00',3.96),('14598','2013-09-23','12:00:00',3.99),('14598','2013-09-23','12:05:00',3.99),('14598','2013-09-23','12:10:00',4.07),('14598','2013-09-23','12:15:00',4.07),('14598','2013-09-23','12:20:00',4.09),('14598','2013-09-23','12:25:00',4.11),('14598','2013-09-23','12:30:00',4.12),('14598','2013-09-23','12:35:00',4.17),('14598','2013-09-23','12:40:00',4.21),('14598','2013-09-23','12:45:00',4.21),('14598','2013-09-23','12:50:00',4.24),('14598','2013-09-23','12:55:00',4.28),('14598','2013-09-23','13:00:00',4.28),('14598','2013-09-23','13:05:00',4.25),('14598','2013-09-23','13:10:00',4.28),('14598','2013-09-23','13:15:00',4.28),('14598','2013-09-23','13:20:00',4.28),('14598','2013-09-23','13:25:00',4.23),('14598','2013-09-23','13:30:00',4.28),('14598','2013-09-23','13:35:00',4.26),('14598','2013-09-23','13:40:00',4.24),('14598','2013-09-23','13:45:00',4.16),('14598','2013-09-23','13:50:00',4.22),('14598','2013-09-23','13:55:00',4.26),('14598','2013-09-23','14:00:00',4.25),('14598','2013-09-23','14:05:00',4.25),('14598','2013-09-23','14:10:00',4.32),('14598','2013-09-23','14:15:00',4.28),('14598','2013-09-23','14:20:00',4.26),('14598','2013-09-23','14:25:00',4.23),('14598','2013-09-23','14:30:00',4.19),('14598','2013-09-23','14:35:00',4.18),('14598','2013-09-23','14:40:00',4.16),('14598','2013-09-23','14:45:00',4.13),('14598','2013-09-23','14:50:00',4.09),('14598','2013-09-23','14:55:00',4.06),('14598','2013-09-23','15:00:00',4.04),('14598','2013-09-23','15:05:00',4),('14598','2013-09-23','15:10:00',3.97),('14598','2013-09-23','15:15:00',3.92),('14598','2013-09-23','15:20:00',3.89),('14598','2013-09-23','15:25:00',3.85),('14598','2013-09-23','15:30:00',3.79),('14598','2013-09-23','15:35:00',3.73),('14598','2013-09-23','15:40:00',3.68),('14598','2013-09-23','15:45:00',3.64),('14598','2013-09-23','15:50:00',3.59),('14598','2013-09-23','15:55:00',3.51),('14598','2013-09-23','16:00:00',3.42),('14598','2013-09-23','16:05:00',3.35),('14598','2013-09-23','16:10:00',3.28),('14598','2013-09-23','16:15:00',3.21),('14598','2013-09-23','16:20:00',3.13),('14598','2013-09-23','16:25:00',3.06),('14598','2013-09-23','16:30:00',2.98),('14598','2013-09-23','16:35:00',2.9),('14598','2013-09-23','16:40:00',2.83),('14598','2013-09-23','16:45:00',2.75),('14598','2013-09-23','16:50:00',2.65),('14598','2013-09-23','16:55:00',2.57),('14598','2013-09-23','17:00:00',2.48),('14598','2013-09-23','17:05:00',2.37),('14598','2013-09-23','17:10:00',2.26),('14598','2013-09-23','17:15:00',2.15),('14598','2013-09-23','17:20:00',2.06),('14598','2013-09-23','17:25:00',1.96),('14598','2013-09-23','17:30:00',1.85),('14598','2013-09-23','17:35:00',1.74),('14598','2013-09-23','17:40:00',1.61),('14598','2013-09-23','17:45:00',1.5),('14598','2013-09-23','17:50:00',1.39),('14598','2013-09-23','17:55:00',1.27),('14598','2013-09-23','18:00:00',1.14),('14598','2013-09-23','18:05:00',1.03),('14598','2013-09-22','08:50:00',1.09),('14598','2013-09-22','08:55:00',1.2),('14598','2013-09-22','09:00:00',1.29),('14598','2013-09-22','09:05:00',1.37),('14598','2013-09-22','09:10:00',1.49),('14598','2013-09-22','09:15:00',1.64),('14598','2013-09-22','09:20:00',1.77),('14598','2013-09-22','09:25:00',1.86),('14598','2013-09-22','09:30:00',1.96),('14598','2013-09-22','09:35:00',2.06),('14598','2013-09-22','09:40:00',2.15),('14598','2013-09-22','09:45:00',2.25),('14598','2013-09-22','09:50:00',2.34),('14598','2013-09-22','09:55:00',2.43),('14598','2013-09-22','10:00:00',2.52),('14598','2013-09-22','10:05:00',2.61),('14598','2013-09-22','10:10:00',2.7),('14598','2013-09-22','10:15:00',2.78),('14598','2013-09-22','10:20:00',2.87),('14598','2013-09-22','10:25:00',2.95),('14598','2013-09-22','10:30:00',3.03),('14598','2013-09-22','10:35:00',3.11),('14598','2013-09-22','10:40:00',3.17),('14598','2013-09-22','10:45:00',3.26),('14598','2013-09-22','10:50:00',3.32),('14598','2013-09-22','10:55:00',3.39),('14598','2013-09-22','11:00:00',3.46),('14598','2013-09-22','11:05:00',3.53),('14598','2013-09-22','11:10:00',3.61),('14598','2013-09-22','11:15:00',3.66),('14598','2013-09-22','11:20:00',3.72),('14598','2013-09-22','11:25:00',3.77),('14598','2013-09-22','11:30:00',3.82),('14598','2013-09-22','11:35:00',3.88),('14598','2013-09-22','11:40:00',3.92),('14598','2013-09-22','11:45:00',3.97),('14598','2013-09-22','11:50:00',4.03),('14598','2013-09-22','11:55:00',4.11),('14598','2013-09-22','12:00:00',4.03),('14598','2013-09-22','12:05:00',4.11),('14598','2013-09-22','12:10:00',4.11),('14598','2013-09-22','12:15:00',4.13),('14598','2013-09-22','12:20:00',4.2),('14598','2013-09-22','12:25:00',4.21),('14598','2013-09-22','12:30:00',4.29),('14598','2013-09-22','12:35:00',4.33),('14598','2013-09-22','12:40:00',4.35),('14598','2013-09-22','12:45:00',4.35),('14598','2013-09-22','12:50:00',4.34),('14598','2013-09-22','12:55:00',4.36),('14598','2013-09-22','13:00:00',4.36),('14598','2013-09-22','13:05:00',4.36),('14598','2013-09-22','13:10:00',4.35),('14598','2013-09-22','13:15:00',4.35),('14598','2013-09-22','13:20:00',4.4),('14598','2013-09-22','13:25:00',3.47),('14598','2013-09-22','13:30:00',4.13),('14598','2013-09-22','13:35:00',4.39),('14598','2013-09-22','13:40:00',3.95),('14598','2013-09-22','13:45:00',3.09),('14598','2013-09-22','13:50:00',4.59),('14598','2013-09-22','13:55:00',4.35),('14598','2013-09-22','14:00:00',3.79),('14598','2013-09-22','14:05:00',4.43),('14598','2013-09-22','14:10:00',4.6),('14598','2013-09-22','14:15:00',4.54),('14598','2013-09-22','14:20:00',4.58),('14598','2013-09-22','14:25:00',3.78),('14598','2013-09-22','14:30:00',2.58),('14598','2013-09-22','14:35:00',1.73),('14598','2013-09-22','14:40:00',2.29),('14598','2013-09-22','14:45:00',4.08),('14598','2013-09-22','14:50:00',3.27),('14598','2013-09-22','14:55:00',2.14),('14598','2013-09-22','15:00:00',1.62),('14598','2013-09-22','15:05:00',4.03),('14598','2013-09-22','15:10:00',1.66),('14598','2013-09-22','15:15:00',4.41),('14598','2013-09-22','15:20:00',3.04),('14598','2013-09-22','15:25:00',2.35),('14598','2013-09-22','15:30:00',2.53),('14598','2013-09-22','15:35:00',2.17),('14598','2013-09-22','15:40:00',2.07),('14598','2013-09-22','15:45:00',1.51),('14598','2013-09-22','15:50:00',1.58),('14598','2013-09-22','15:55:00',2.09),('14598','2013-09-22','16:00:00',1.9),('14598','2013-09-22','16:05:00',2.05),('14598','2013-09-22','16:10:00',1.81),('14598','2013-09-22','16:15:00',1.43),('14598','2013-09-22','16:20:00',1.46),('14598','2013-09-22','16:25:00',1.35),('14598','2013-09-22','16:30:00',1.1),('14598','2013-09-22','16:35:00',1.1),('14598','2013-09-22','16:40:00',1.06),('14598','2013-09-22','16:50:00',1),('14598','2013-09-22','17:15:00',1.63),('14598','2013-09-22','17:20:00',2.18),('14598','2013-09-22','17:25:00',2.04),('14598','2013-09-22','17:30:00',1.67),('14598','2013-09-22','17:35:00',1.05),('14598','2013-09-22','17:55:00',1.27),('14598','2013-09-22','18:00:00',1.15),('14598','2013-09-21','08:50:00',1.1),('14598','2013-09-21','08:55:00',1.2),('14598','2013-09-21','09:00:00',1.3),('14598','2013-09-21','09:05:00',1.39),('14598','2013-09-21','09:10:00',1.51),('14598','2013-09-21','09:15:00',1.66),('14598','2013-09-21','09:20:00',1.77),('14598','2013-09-21','09:25:00',1.86),('14598','2013-09-21','09:30:00',1.97),('14598','2013-09-21','09:35:00',2.06),('14598','2013-09-21','09:40:00',2.16),('14598','2013-09-21','09:45:00',2.24),('14598','2013-09-21','09:50:00',2.33),('14598','2013-09-21','09:55:00',2.44),('14598','2013-09-21','10:00:00',2.53),('14598','2013-09-21','10:05:00',2.62),('14598','2013-09-21','10:10:00',2.69),('14598','2013-09-21','10:15:00',2.78),('14598','2013-09-21','10:20:00',2.87),('14598','2013-09-21','10:25:00',2.94),('14598','2013-09-21','10:30:00',3.02),('14598','2013-09-21','10:35:00',3.09),('14598','2013-09-21','10:40:00',3.14),('14598','2013-09-21','10:45:00',3.21),('14598','2013-09-21','10:50:00',3.29),('14598','2013-09-21','10:55:00',3.36),('14598','2013-09-21','11:00:00',3.42),('14598','2013-09-21','11:05:00',3.41),('14598','2013-09-21','11:10:00',3.52),('14598','2013-09-21','11:15:00',3.58),('14598','2013-09-21','11:20:00',3.64),('14598','2013-09-21','11:25:00',3.69),('14598','2013-09-21','11:30:00',3.76),('14598','2013-09-21','11:35:00',3.81),('14598','2013-09-21','11:40:00',3.88),('14598','2013-09-21','11:45:00',3.93),('14598','2013-09-21','11:50:00',3.99),('14598','2013-09-21','11:55:00',4.02),('14598','2013-09-21','12:00:00',4.09),('14598','2013-09-21','12:05:00',3.73),('14598','2013-09-21','12:10:00',4.14),('14598','2013-09-21','12:15:00',4.25),('14598','2013-09-21','12:20:00',3.97),('14598','2013-09-21','12:25:00',4.23),('14598','2013-09-21','12:30:00',4.09),('14598','2013-09-21','12:35:00',4.23),('14598','2013-09-21','12:40:00',4.38),('14598','2013-09-21','12:45:00',4.37),('14598','2013-09-21','12:50:00',4.34),('14598','2013-09-21','12:55:00',4.35),('14598','2013-09-21','13:00:00',4.52),('14598','2013-09-21','13:05:00',4.11),('14598','2013-09-21','13:10:00',3.86),('14598','2013-09-21','13:15:00',4.12),('14598','2013-09-21','13:20:00',4.18),('14598','2013-09-21','13:25:00',3.96),('14598','2013-09-21','13:30:00',3.95),('14598','2013-09-21','13:35:00',4.04),('14598','2013-09-21','13:40:00',4.32),('14598','2013-09-21','13:45:00',4.4),('14598','2013-09-21','13:50:00',4.33),('14598','2013-09-21','13:55:00',4.41),('14598','2013-09-21','14:00:00',4.38),('14598','2013-09-21','14:05:00',4.37),('14598','2013-09-21','14:10:00',4.28),('14598','2013-09-21','14:15:00',4.34),('14598','2013-09-21','14:20:00',4.32),('14598','2013-09-21','14:25:00',4.25),('14598','2013-09-21','14:30:00',4.27),('14598','2013-09-21','14:35:00',4.24),('14598','2013-09-21','14:40:00',4.23),('14598','2013-09-21','14:45:00',4.19),('14598','2013-09-21','14:50:00',4.16),('14598','2013-09-21','14:55:00',4.02),('14598','2013-09-21','15:00:00',4.04),('14598','2013-09-21','15:05:00',4.04),('14598','2013-09-21','15:10:00',4.01),('14598','2013-09-21','15:15:00',3.97),('14598','2013-09-21','15:20:00',3.94),('14598','2013-09-21','15:25:00',3.88),('14598','2013-09-21','15:30:00',3.87),('14598','2013-09-21','15:35:00',3.85),('14598','2013-09-21','15:40:00',3.8),('14598','2013-09-21','15:45:00',1.6),('14598','2013-09-21','15:50:00',1.83),('14598','2013-09-21','15:55:00',1.84),('14598','2013-09-21','16:00:00',1.65),('14598','2013-09-21','16:05:00',1.69),('14598','2013-09-21','16:10:00',1.2),('14598','2013-09-21','16:15:00',1.92),('14598','2013-09-21','16:20:00',1.91),('14598','2013-09-21','16:25:00',1.87),('14598','2013-09-21','16:30:00',1.77),('14598','2013-09-21','16:35:00',1.85),('14598','2013-09-21','16:40:00',1.87),('14598','2013-09-21','16:45:00',1.08),('14598','2013-09-21','16:50:00',1.47),('14598','2013-09-21','16:55:00',1.87),('14598','2013-09-21','17:00:00',1.5),('14598','2013-09-21','17:15:00',1.09),('14598','2013-09-21','17:20:00',1.17),('14598','2013-09-21','17:25:00',1.45),('14598','2013-09-21','17:30:00',1.88),('14598','2013-09-21','17:35:00',1.68),('14598','2013-09-21','17:40:00',1.59),('14598','2013-09-21','17:45:00',1.59),('14598','2013-09-21','17:50:00',1.42),('14598','2013-09-21','17:55:00',1.2),('14598','2013-09-21','18:00:00',1.18),('14598','2013-09-21','18:05:00',1.04),('14598','2013-09-20','09:45:00',1.02),('14598','2013-09-20','09:50:00',1.08),('14598','2013-09-20','09:55:00',1.23),('14598','2013-09-20','10:00:00',1.4),('14598','2013-09-20','10:05:00',1.55),('14598','2013-09-20','10:10:00',1.63),('14598','2013-09-20','10:15:00',1.7),('14598','2013-09-20','10:20:00',1.8),('14598','2013-09-20','10:25:00',1.9),('14598','2013-09-20','10:30:00',2.4),('14598','2013-09-20','10:35:00',3.49),('14598','2013-09-20','10:40:00',2.79),('14598','2013-09-20','10:45:00',2.91),('14598','2013-09-20','10:50:00',2.26),('14598','2013-09-20','10:55:00',2.39),('14598','2013-09-20','11:00:00',2.7),('14598','2013-09-20','11:05:00',3.39),('14598','2013-09-20','11:10:00',2.56),('14598','2013-09-20','11:15:00',3.09),('14598','2013-09-20','11:20:00',3.76),('14598','2013-09-20','11:25:00',4.22),('14598','2013-09-20','11:30:00',4.55),('14598','2013-09-20','11:35:00',4.48),('14598','2013-09-20','11:40:00',4.18),('14598','2013-09-20','11:45:00',3.74),('14598','2013-09-20','11:50:00',3.36),('14598','2013-09-20','11:55:00',3.51),('14598','2013-09-20','12:00:00',2.44),('14598','2013-09-20','12:05:00',2.02),('14598','2013-09-20','12:10:00',3.2),('14598','2013-09-20','12:15:00',3.35),('14598','2013-09-20','12:20:00',3.14),('14598','2013-09-20','12:25:00',3.77),('14598','2013-09-20','12:30:00',3.5),('14598','2013-09-20','12:35:00',4.26),('14598','2013-09-20','12:40:00',4.2),('14598','2013-09-20','12:45:00',4.2),('14598','2013-09-20','12:50:00',4.09),('14598','2013-09-20','12:55:00',3.86),('14598','2013-09-20','13:00:00',4.21),('14598','2013-09-20','13:05:00',4.24),('14598','2013-09-20','13:10:00',4.24),('14598','2013-09-20','13:15:00',4.31),('14598','2013-09-20','13:20:00',4.27),('14598','2013-09-20','13:25:00',4.21),('14598','2013-09-20','13:30:00',4.23),('14598','2013-09-20','13:35:00',4.3),('14598','2013-09-20','13:40:00',4.31),('14598','2013-09-20','13:45:00',4.33),('14598','2013-09-20','13:50:00',4.33),('14598','2013-09-20','13:55:00',4.36),('14598','2013-09-20','14:00:00',4.36),('14598','2013-09-20','14:05:00',4.33),('14598','2013-09-20','14:10:00',4.33),('14598','2013-09-20','14:15:00',4.31),('14598','2013-09-20','14:20:00',4.32),('14598','2013-09-20','14:25:00',4.25),('14598','2013-09-20','14:30:00',4.23),('14598','2013-09-20','14:35:00',4.23),('14598','2013-09-20','14:40:00',4.28),('14598','2013-09-20','14:45:00',3.39),('14598','2013-09-20','14:50:00',4.29),('14598','2013-09-20','14:55:00',3.79),('14598','2013-09-20','15:00:00',4.34),('14598','2013-09-20','15:05:00',4.32),('14598','2013-09-20','15:10:00',4.18),('14598','2013-09-20','15:15:00',4.17),('14598','2013-09-20','15:20:00',4.26),('14598','2013-09-20','15:25:00',4.18),('14598','2013-09-20','15:30:00',4.15),('14598','2013-09-20','15:35:00',4.21),('14598','2013-09-20','15:40:00',4.44),('14598','2013-09-20','15:45:00',4.55);
INSERT INTO `solarlog` VALUES ('14598','2013-09-20','15:50:00',3.78),('14598','2013-09-20','15:55:00',2.13),('14598','2013-09-20','16:00:00',1.67),('14598','2013-09-20','16:05:00',1.87),('14598','2013-09-20','16:10:00',2.32),('14598','2013-09-20','16:15:00',2.31),('14598','2013-09-20','16:20:00',2.39),('14598','2013-09-20','16:25:00',2.91),('14598','2013-09-20','16:30:00',3.41),('14598','2013-09-20','16:35:00',3.2),('14598','2013-09-20','16:40:00',3.09),('14598','2013-09-20','16:45:00',2.9),('14598','2013-09-20','16:50:00',2.8),('14598','2013-09-20','16:55:00',2.71),('14598','2013-09-20','17:00:00',2.6),('14598','2013-09-20','17:05:00',2.47),('14598','2013-09-20','17:10:00',2.34),('14598','2013-09-20','17:15:00',2.24),('14598','2013-09-20','17:20:00',2.17),('14598','2013-09-20','17:25:00',2.03),('14598','2013-09-20','17:30:00',1.71),('14598','2013-09-20','17:45:00',1.54),('14598','2013-09-20','17:50:00',1.46),('14598','2013-09-20','17:55:00',1.37),('14598','2013-09-20','18:00:00',1.26),('14598','2013-09-20','18:05:00',1.14),('14598','2013-09-20','18:10:00',1.01),('14598','2013-09-19','08:50:00',1.12),('14598','2013-09-19','08:55:00',1.23),('14598','2013-09-19','09:00:00',1.36),('14598','2013-09-19','09:05:00',1.65),('14598','2013-09-19','09:10:00',1.52),('14598','2013-09-19','09:15:00',1.52),('14598','2013-09-19','09:20:00',1.2),('14598','2013-09-19','09:25:00',1.36),('14598','2013-09-19','09:40:00',1.95),('14598','2013-09-19','09:45:00',2.37),('14598','2013-09-19','09:50:00',1.98),('14598','2013-09-19','09:55:00',1.81),('14598','2013-09-19','10:00:00',2.71),('14598','2013-09-19','10:05:00',2.01),('14598','2013-09-19','10:10:00',1.14),('14598','2013-09-19','10:15:00',1.69),('14598','2013-09-19','10:20:00',2.13),('14598','2013-09-19','10:25:00',2.47),('14598','2013-09-19','10:30:00',2.45),('14598','2013-09-19','10:35:00',3.12),('14598','2013-09-19','10:40:00',3.19),('14598','2013-09-19','10:45:00',3.25),('14598','2013-09-19','10:50:00',3.32),('14598','2013-09-19','10:55:00',3.38),('14598','2013-09-19','11:00:00',3.44),('14598','2013-09-19','11:05:00',3.51),('14598','2013-09-19','11:10:00',3.58),('14598','2013-09-19','11:15:00',3.82),('14598','2013-09-19','11:20:00',3.28),('14598','2013-09-19','11:25:00',3.55),('14598','2013-09-19','11:30:00',3.9),('14598','2013-09-19','11:35:00',3.76),('14598','2013-09-19','11:40:00',3.93),('14598','2013-09-19','11:45:00',3.94),('14598','2013-09-19','11:50:00',3.97),('14598','2013-09-19','11:55:00',4.01),('14598','2013-09-19','12:00:00',4.09),('14598','2013-09-19','12:05:00',3.82),('14598','2013-09-19','12:10:00',4.17),('14598','2013-09-19','12:15:00',4.25),('14598','2013-09-19','12:20:00',4.27),('14598','2013-09-19','12:25:00',4.43),('14598','2013-09-19','12:30:00',4.34),('14598','2013-09-19','12:35:00',3.85),('14598','2013-09-19','12:40:00',4.72),('14598','2013-09-19','12:45:00',4.61),('14598','2013-09-19','12:50:00',4.42),('14598','2013-09-19','12:55:00',4.43),('14598','2013-09-19','13:00:00',4.57),('14598','2013-09-19','13:05:00',4.5),('14598','2013-09-19','13:10:00',4.15),('14598','2013-09-19','13:15:00',4.49),('14598','2013-09-19','13:20:00',4.49),('14598','2013-09-19','13:25:00',4.51),('14598','2013-09-19','13:30:00',4.49),('14598','2013-09-19','13:35:00',4.46),('14598','2013-09-19','13:40:00',4.48),('14598','2013-09-19','13:45:00',4.47),('14598','2013-09-19','13:50:00',4.46),('14598','2013-09-19','13:55:00',4.44),('14598','2013-09-19','14:00:00',4.41),('14598','2013-09-19','14:05:00',4.41),('14598','2013-09-19','14:10:00',4.41),('14598','2013-09-19','14:15:00',4.41),('14598','2013-09-19','14:20:00',4.27),('14598','2013-09-19','14:25:00',4.28),('14598','2013-09-19','14:30:00',4.36),('14598','2013-09-19','14:35:00',4.23),('14598','2013-09-19','14:40:00',4.03),('14598','2013-09-19','14:45:00',4.32),('14598','2013-09-19','14:50:00',4.27),('14598','2013-09-19','14:55:00',4.21),('14598','2013-09-19','15:00:00',4.13),('14598','2013-09-19','15:05:00',4.11),('14598','2013-09-19','15:10:00',4.16),('14598','2013-09-19','15:15:00',4.21),('14598','2013-09-19','15:20:00',3.78),('14598','2013-09-19','15:25:00',4.04),('14598','2013-09-19','15:30:00',3.68),('14598','2013-09-19','15:35:00',3.85),('14598','2013-09-19','15:40:00',3.8),('14598','2013-09-19','15:45:00',3.47),('14598','2013-09-19','15:50:00',2.87),('14598','2013-09-19','15:55:00',3.12),('14598','2013-09-19','16:00:00',4.14),('14598','2013-09-19','16:05:00',3.57),('14598','2013-09-19','16:10:00',2.96),('14598','2013-09-19','16:15:00',3.35),('14598','2013-09-19','16:20:00',3.29),('14598','2013-09-19','16:25:00',3.07),('14598','2013-09-19','16:30:00',3.12),('14598','2013-09-19','16:35:00',2.75),('14598','2013-09-19','16:40:00',2.76),('14598','2013-09-19','16:45:00',2.76),('14598','2013-09-19','16:50:00',2.74),('14598','2013-09-19','16:55:00',2.72),('14598','2013-09-19','17:00:00',2.57),('14598','2013-09-19','17:05:00',2.32),('14598','2013-09-19','17:10:00',2.26),('14598','2013-09-19','17:15:00',2),('14598','2013-09-19','17:20:00',1.69),('14598','2013-09-19','17:25:00',1.78),('14598','2013-09-19','17:30:00',2.13),('14598','2013-09-19','17:35:00',1.84),('14598','2013-09-19','17:40:00',1.57),('14598','2013-09-19','17:45:00',1.58),('14598','2013-09-19','17:50:00',1.37),('14598','2013-09-19','17:55:00',1.06),('14598','2013-09-19','18:00:00',1.35),('14598','2013-09-19','18:05:00',1.37),('14598','2013-09-19','18:10:00',1.31),('14598','2013-09-19','18:15:00',1.2),('14598','2013-09-19','18:20:00',1.06),('14598','2014-04-13','09:45:00',1.03),('14598','2014-04-13','09:50:00',1.37),('14598','2014-04-13','09:55:00',1.78),('14598','2014-04-13','10:00:00',1.9),('14598','2014-04-13','10:05:00',1.85),('14598','2014-04-13','10:10:00',2.33),('14598','2014-04-13','10:15:00',2.38),('14598','2014-04-13','10:20:00',3.66),('14598','2014-04-13','10:25:00',2.59),('14598','2014-04-13','10:30:00',1.87),('14598','2014-04-13','10:35:00',1.35),('14598','2014-04-13','10:40:00',1.21),('14598','2014-04-13','10:45:00',1.14),('14598','2014-04-13','10:50:00',1.07),('14598','2014-04-13','10:55:00',1.09),('14598','2014-04-13','11:00:00',1.18),('14598','2014-04-13','11:05:00',1.39),('14598','2014-04-13','11:10:00',1.57),('14598','2014-04-13','11:15:00',1.78),('14598','2014-04-13','11:20:00',3.97),('14598','2014-04-13','11:25:00',3.49),('14598','2014-04-13','11:30:00',4.15),('14598','2014-04-13','11:35:00',4.14),('14598','2014-04-13','11:40:00',4.42),('14598','2014-04-13','11:45:00',4.6),('14598','2014-04-13','11:50:00',3.24),('14598','2014-04-13','11:55:00',2.78),('14598','2014-04-13','12:00:00',2.65),('14598','2014-04-13','12:05:00',3.41),('14598','2014-04-13','12:10:00',1.87),('14598','2014-04-13','12:15:00',3.33),('14598','2014-04-13','12:20:00',3.45),('14598','2014-04-13','12:25:00',3.08),('14598','2014-04-13','12:30:00',3.76),('14598','2014-04-13','12:35:00',4.52),('14598','2014-04-13','12:40:00',4.3),('14598','2014-04-13','12:45:00',4.42),('14598','2014-04-13','12:50:00',5.38),('14598','2014-04-13','12:55:00',5.3),('14598','2014-04-13','13:00:00',2.61),('14598','2014-04-13','13:05:00',1.71),('14598','2014-04-13','13:10:00',1.43),('14598','2014-04-13','13:15:00',1.3),('14598','2014-04-13','13:20:00',1.28),('14598','2014-04-13','14:05:00',1.08),('14598','2014-04-13','14:10:00',1.29),('14598','2014-04-13','14:15:00',1.54),('14598','2014-04-13','14:20:00',1.95),('14598','2014-04-13','14:25:00',2.73),('14598','2014-04-13','14:30:00',4.95),('14598','2014-04-13','14:35:00',2.47),('14598','2014-04-13','14:40:00',1.98),('14598','2014-04-13','14:45:00',3.32),('14598','2014-04-13','14:50:00',3.45),('14598','2014-04-13','14:55:00',4.08),('14598','2014-04-13','15:00:00',2.92),('14598','2014-04-13','15:05:00',3.43),('14598','2014-04-13','15:10:00',4.16),('14598','2014-04-13','15:15:00',4.96),('14598','2014-04-13','15:20:00',4.57),('14598','2014-04-13','15:25:00',4.23),('14598','2014-04-13','15:30:00',2.54),('14598','2014-04-13','15:35:00',2.01),('14598','2014-04-13','15:40:00',2.53),('14598','2014-04-13','15:45:00',4.03),('14598','2014-04-13','15:50:00',3.44),('14598','2014-04-13','15:55:00',3.68),('14598','2014-04-13','16:00:00',3.19),('14598','2014-04-13','16:05:00',2.39),('14598','2014-04-13','16:10:00',1.68),('14598','2014-04-13','16:15:00',1.51),('14598','2014-04-13','16:20:00',1.85),('14598','2014-04-13','16:25:00',3.21),('14598','2014-04-13','16:30:00',3.33),('14598','2014-04-13','16:35:00',3.43),('14598','2014-04-13','16:40:00',2.44),('14598','2014-04-13','16:45:00',1.3),('14598','2014-04-13','16:50:00',1.85),('14598','2014-04-13','16:55:00',1.43),('14598','2014-04-13','17:00:00',2.05),('14598','2014-04-13','17:05:00',1.84),('14598','2014-04-13','17:10:00',1.62),('14598','2014-04-13','17:15:00',2.1),('14598','2014-04-13','17:20:00',2.46),('14598','2014-04-13','17:25:00',2.05),('14598','2014-04-13','17:30:00',1.58),('14598','2014-04-13','17:35:00',1.57),('14598','2014-04-13','17:40:00',1.68),('14598','2014-04-13','17:45:00',1.95),('14598','2014-04-13','17:50:00',1.25),('14598','2013-09-18','08:45:00',1.06),('14598','2013-09-18','08:50:00',1.22),('14598','2013-09-18','08:55:00',1.28),('14598','2013-09-18','09:00:00',1.35),('14598','2013-09-18','09:05:00',1.44),('14598','2013-09-18','09:10:00',1.82),('14598','2013-09-18','09:15:00',2.08),('14598','2013-09-18','09:20:00',1.73),('14598','2013-09-18','09:25:00',1.53),('14598','2013-09-18','09:30:00',1.64),('14598','2013-09-18','09:35:00',2.06),('14598','2013-09-18','09:40:00',2.21),('14598','2013-09-18','09:45:00',2.28),('14598','2013-09-18','09:50:00',2.35),('14598','2013-09-18','09:55:00',2.46),('14598','2013-09-18','10:00:00',2.56),('14598','2013-09-18','10:05:00',2.65),('14598','2013-09-18','10:10:00',2.72),('14598','2013-09-18','10:15:00',2.81),('14598','2013-09-18','10:20:00',2.88),('14598','2013-09-18','10:25:00',2.95),('14598','2013-09-18','10:30:00',3),('14598','2013-09-18','10:35:00',3.09),('14598','2013-09-18','10:40:00',3.17),('14598','2013-09-18','10:45:00',3.25),('14598','2013-09-18','10:50:00',3.34),('14598','2013-09-18','10:55:00',3.45),('14598','2013-09-18','11:00:00',3.1),('14598','2013-09-18','11:05:00',3.13),('14598','2013-09-18','11:10:00',3.63),('14598','2013-09-18','11:15:00',3.66),('14598','2013-09-18','11:20:00',3.65),('14598','2013-09-18','11:25:00',3.74),('14598','2013-09-18','11:30:00',3.8),('14598','2013-09-18','11:35:00',3.83),('14598','2013-09-18','11:40:00',3.9),('14598','2013-09-18','11:45:00',3.94),('14598','2013-09-18','11:50:00',4),('14598','2013-09-18','11:55:00',4.06),('14598','2013-09-18','12:00:00',4.17),('14598','2013-09-18','12:05:00',4.22),('14598','2013-09-18','12:10:00',4.22),('14598','2013-09-18','12:15:00',4.24),('14598','2013-09-18','12:20:00',4.29),('14598','2013-09-18','12:25:00',4.27),('14598','2013-09-18','12:30:00',4.3),('14598','2013-09-18','12:35:00',4.28),('14598','2013-09-18','12:40:00',4.38),('14598','2013-09-18','12:45:00',4.41),('14598','2013-09-18','12:50:00',4.49),('14598','2013-09-18','12:55:00',4.64),('14598','2013-09-18','13:00:00',4.54),('14598','2013-09-18','13:05:00',4.65),('14598','2013-09-18','13:10:00',4.38),('14598','2013-09-18','13:15:00',4.42),('14598','2013-09-18','13:20:00',4.44),('14598','2013-09-18','13:25:00',4.44),('14598','2013-09-18','13:30:00',4.43),('14598','2013-09-18','13:35:00',4.37),('14598','2013-09-18','13:40:00',4.48),('14598','2013-09-18','13:45:00',4.52),('14598','2013-09-18','13:50:00',4.49),('14598','2013-09-18','13:55:00',4.28),('14598','2013-09-18','14:00:00',4.45),('14598','2013-09-18','14:05:00',4.2),('14598','2013-09-18','14:10:00',4.52),('14598','2013-09-18','14:15:00',4.56),('14598','2013-09-18','14:20:00',2.92),('14598','2013-09-18','14:25:00',2.78),('14598','2013-09-18','14:30:00',3.49),('14598','2013-09-18','14:35:00',4.38),('14598','2013-09-18','14:40:00',3.57),('14598','2013-09-18','14:45:00',3.92),('14598','2013-09-18','14:50:00',2.88),('14598','2013-09-18','14:55:00',4.51),('14598','2013-09-18','15:00:00',4.23),('14598','2013-09-18','15:05:00',4.31),('14598','2013-09-18','15:10:00',3.54),('14598','2013-09-18','15:15:00',4.13),('14598','2013-09-18','15:20:00',4),('14598','2013-09-18','15:25:00',4.02),('14598','2013-09-18','15:30:00',3.89),('14598','2013-09-18','15:35:00',3.59),('14598','2013-09-18','15:40:00',3.86),('14598','2013-09-18','15:45:00',3.78),('14598','2013-09-18','15:50:00',3.67),('14598','2013-09-18','15:55:00',3.7),('14598','2013-09-18','16:00:00',3.54),('14598','2013-09-18','16:05:00',3.23),('14598','2013-09-18','16:10:00',3.27),('14598','2013-09-18','16:15:00',3.13),('14598','2013-09-18','16:20:00',3.19),('14598','2013-09-18','16:25:00',3.21),('14598','2013-09-18','16:30:00',2.99),('14598','2013-09-18','16:35:00',2.06),('14598','2013-09-18','16:40:00',2.96),('14598','2013-09-18','16:45:00',2.65),('14598','2013-09-18','16:50:00',2.91),('14598','2013-09-18','16:55:00',2.82),('14598','2013-09-18','17:00:00',2.69),('14598','2013-09-18','17:05:00',2.54),('14598','2013-09-18','17:10:00',2.45),('14598','2013-09-18','17:15:00',2.34),('14598','2013-09-18','17:20:00',2.29),('14598','2013-09-18','17:25:00',1.12),('14598','2013-09-18','17:30:00',1.32),('14598','2013-09-18','17:35:00',1.65),('14598','2013-09-18','17:45:00',1.33),('14598','2013-09-18','17:50:00',1.75),('14598','2013-09-18','18:00:00',1.29),('14598','2013-09-18','18:05:00',1.17),('14598','2013-09-18','18:10:00',1.14),('14598','2013-09-18','18:15:00',1.06),('14598','2013-09-17','09:05:00',1.04),('14598','2013-09-17','09:10:00',1.12),('14598','2013-09-17','09:15:00',1.15),('14598','2013-09-17','09:20:00',1.11),('14598','2013-09-17','09:30:00',1.08),('14598','2013-09-17','09:35:00',1.39),('14598','2013-09-17','09:40:00',1.73),('14598','2013-09-17','09:45:00',2.52),('14598','2013-09-17','09:50:00',2.64),('14598','2013-09-17','09:55:00',2.4),('14598','2013-09-17','10:00:00',1.44),('14598','2013-09-17','10:05:00',1.5),('14598','2013-09-17','10:10:00',1.46),('14598','2013-09-17','10:15:00',3.83),('14598','2013-09-17','10:20:00',3.14),('14598','2013-09-17','10:25:00',1.7),('14598','2013-09-17','10:30:00',2.9),('14598','2013-09-17','10:35:00',4.27),('14598','2013-09-17','10:40:00',3.81),('14598','2013-09-17','10:45:00',4.43),('14598','2013-09-17','10:50:00',2.37),('14598','2013-09-17','10:55:00',1.87),('14598','2013-09-17','11:00:00',1.83),('14598','2013-09-17','11:05:00',2.31),('14598','2013-09-17','11:10:00',2.79),('14598','2013-09-17','11:15:00',2.17),('14598','2013-09-17','11:20:00',1.91),('14598','2013-09-17','11:25:00',2.1),('14598','2013-09-17','11:30:00',1.84),('14598','2013-09-17','11:35:00',1.58),('14598','2013-09-17','11:40:00',4.41),('14598','2013-09-17','11:45:00',4.34),('14598','2013-09-17','11:50:00',2.55),('14598','2013-09-17','11:55:00',1.6),('14598','2013-09-17','12:00:00',2.54),('14598','2013-09-17','12:05:00',2.72),('14598','2013-09-17','12:10:00',3.21),('14598','2013-09-17','12:15:00',3.27),('14598','2013-09-17','12:20:00',3.09),('14598','2013-09-17','12:25:00',1.93),('14598','2013-09-17','12:30:00',1.87),('14598','2013-09-17','12:35:00',4.56),('14598','2013-09-17','12:40:00',3.76),('14598','2013-09-17','12:45:00',3.97),('14598','2013-09-17','12:50:00',4.39),('14598','2013-09-17','12:55:00',4.64),('14598','2013-09-17','13:00:00',3.46),('14598','2013-09-17','13:05:00',3.49),('14598','2013-09-17','13:10:00',2.1),('14598','2013-09-17','13:15:00',1.56),('14598','2013-09-17','13:20:00',1.63),('14598','2013-09-17','13:25:00',1.47),('14598','2013-09-17','13:30:00',1.55),('14598','2013-09-17','13:35:00',1.71),('14598','2013-09-17','13:40:00',1.73),('14598','2013-09-17','13:45:00',1.64),('14598','2013-09-17','13:50:00',2.34),('14598','2013-09-17','13:55:00',1.87),('14598','2013-09-17','14:00:00',1.26),('14598','2013-09-17','14:05:00',1.35),('14598','2013-09-17','14:10:00',1.25),('14598','2013-09-17','14:15:00',2.44),('14598','2013-09-17','14:20:00',2.83),('14598','2013-09-17','14:25:00',1.17),('14598','2013-09-17','14:30:00',1.04),('14598','2013-09-17','14:35:00',1.6),('14598','2013-09-17','14:40:00',3.63),('14598','2013-09-17','14:45:00',3.18),('14598','2013-09-17','14:50:00',5.01),('14598','2013-09-17','14:55:00',3.56),('14598','2013-09-17','15:00:00',3.54),('14598','2013-09-17','15:05:00',2.81),('14598','2013-09-17','15:20:00',1.36),('14598','2013-09-17','15:25:00',1.08),('14598','2013-09-17','15:30:00',1.23),('14598','2013-09-17','15:35:00',2.16),('14598','2013-09-17','15:40:00',2.31),('14598','2013-09-17','15:45:00',2.18),('14598','2013-09-17','15:50:00',2.66),('14598','2013-09-17','15:55:00',1.85),('14598','2013-09-17','16:00:00',1.57),('14598','2013-09-17','16:05:00',1.52),('14598','2013-09-17','16:10:00',1.5),('14598','2013-09-17','16:15:00',1.6),('14598','2013-09-17','16:20:00',1.88),('14598','2013-09-17','16:25:00',1.71),('14598','2013-09-17','16:30:00',1.68),('14598','2013-09-17','16:35:00',1.82),('14598','2013-09-17','16:40:00',2.18),('14598','2013-09-17','16:45:00',2.27),('14598','2013-09-17','16:50:00',2.5),('14598','2013-09-17','16:55:00',2.51),('14598','2013-09-17','17:00:00',2.24),('14598','2013-09-17','17:05:00',2.12),('14598','2013-09-17','17:10:00',2.44),('14598','2013-09-17','17:15:00',2.75),('14598','2013-09-17','17:20:00',2.22),('14598','2013-09-17','17:25:00',2.05),('14598','2013-09-17','17:30:00',2.01),('14598','2013-09-17','17:35:00',1.38),('14598','2013-09-16','08:55:00',1.4),('14598','2013-09-16','09:00:00',1.56),('14598','2013-09-16','09:05:00',1.66),('14598','2013-09-16','09:10:00',1.71),('14598','2013-09-16','09:15:00',1.68),('14598','2013-09-16','09:20:00',2.08),('14598','2013-09-16','09:25:00',1.32),('14598','2013-09-16','09:30:00',1.41),('14598','2013-09-16','09:35:00',2.04),('14598','2013-09-16','09:40:00',2.24),('14598','2013-09-16','09:45:00',2.33),('14598','2013-09-16','09:50:00',2.43),('14598','2013-09-16','09:55:00',2.51),('14598','2013-09-16','10:00:00',2.59),('14598','2013-09-16','10:05:00',2.67),('14598','2013-09-16','10:10:00',2.75),('14598','2013-09-16','10:15:00',2.87),('14598','2013-09-16','10:20:00',3),('14598','2013-09-16','10:25:00',2.38),('14598','2013-09-16','10:30:00',1.16),('14598','2013-09-16','10:35:00',2.85),('14598','2013-09-16','10:40:00',3.36),('14598','2013-09-16','10:45:00',3.22),('14598','2013-09-16','10:50:00',3.44),('14598','2013-09-16','10:55:00',3.49),('14598','2013-09-16','11:00:00',3.55),('14598','2013-09-16','11:05:00',3.6),('14598','2013-09-16','11:10:00',3.65),('14598','2013-09-16','11:15:00',3.73),('14598','2013-09-16','11:20:00',3.78),('14598','2013-09-16','11:25:00',3.83),('14598','2013-09-16','11:30:00',3.9),('14598','2013-09-16','11:35:00',3.92),('14598','2013-09-16','11:40:00',3.97),('14598','2013-09-16','11:45:00',4),('14598','2013-09-16','11:50:00',4.01),('14598','2013-09-16','11:55:00',4.08),('14598','2013-09-16','12:00:00',4.1),('14598','2013-09-16','12:05:00',4.17),('14598','2013-09-16','12:10:00',4.22),('14598','2013-09-16','12:15:00',4.23),('14598','2013-09-16','12:20:00',4.12),('14598','2013-09-16','12:25:00',4.38),('14598','2013-09-16','12:30:00',4.37),('14598','2013-09-16','12:35:00',4.41),('14598','2013-09-16','12:40:00',4.46),('14598','2013-09-16','12:45:00',4.45),('14598','2013-09-16','12:50:00',4.5),('14598','2013-09-16','12:55:00',4.51),('14598','2013-09-16','13:00:00',4.52),('14598','2013-09-16','13:05:00',4.55),('14598','2013-09-16','13:10:00',4.52),('14598','2013-09-16','13:15:00',4.58),('14598','2013-09-16','13:20:00',4.56),('14598','2013-09-16','13:25:00',4.55),('14598','2013-09-16','13:30:00',4.58),('14598','2013-09-16','13:35:00',4.56),('14598','2013-09-16','13:40:00',4.52),('14598','2013-09-16','13:45:00',4.57),('14598','2013-09-16','13:50:00',4.56),('14598','2013-09-16','13:55:00',4.53),('14598','2013-09-16','14:00:00',4.55),('14598','2013-09-16','14:05:00',4.53),('14598','2013-09-16','14:10:00',4.54),('14598','2013-09-16','14:15:00',4.52),('14598','2013-09-16','14:20:00',4.5),('14598','2013-09-16','14:25:00',4.48),('14598','2013-09-16','14:30:00',4.48),('14598','2013-09-16','14:35:00',4.45),('14598','2013-09-16','14:40:00',4.39),('14598','2013-09-16','14:45:00',4.36),('14598','2013-09-16','14:50:00',4.33),('14598','2013-09-16','14:55:00',4.29),('14598','2013-09-16','15:00:00',4.28),('14598','2013-09-16','15:05:00',4.23),('14598','2013-09-16','15:10:00',4.2),('14598','2013-09-16','15:15:00',4.17),('14598','2013-09-16','15:20:00',4.12),('14598','2013-09-16','15:25:00',4.04),('14598','2013-09-16','15:30:00',4.06),('14598','2013-09-16','15:35:00',4.02),('14598','2013-09-16','15:40:00',3.96),('14598','2013-09-16','15:45:00',3.9),('14598','2013-09-16','15:50:00',3.85),('14598','2013-09-16','15:55:00',3.77),('14598','2013-09-16','16:00:00',3.7),('14598','2013-09-16','16:05:00',3.63),('14598','2013-09-16','16:10:00',3.57),('14598','2013-09-16','16:15:00',3.52),('14598','2013-09-16','16:20:00',3.45),('14598','2013-09-16','16:25:00',3.36),('14598','2013-09-16','16:30:00',3.28),('14598','2013-09-16','16:35:00',3.22),('14598','2013-09-16','16:40:00',3.09),('14598','2013-09-16','16:45:00',3.02),('14598','2013-09-16','16:50:00',2.93),('14598','2013-09-16','16:55:00',2.85),('14598','2013-09-16','17:00:00',2.56),('14598','2013-09-16','17:05:00',2.68),('14598','2013-09-16','17:10:00',2.56),('14598','2013-09-16','17:15:00',2.46),('14598','2013-09-16','17:20:00',2.37),('14598','2013-09-16','17:25:00',2.26),('14598','2013-09-16','17:30:00',2.14),('14598','2013-09-16','17:35:00',2.03),('14598','2013-09-16','17:40:00',1.93),('14598','2013-09-16','17:45:00',1.81),('14598','2013-09-16','17:50:00',1.69),('14598','2013-09-16','17:55:00',1.57),('14598','2013-09-16','18:00:00',1.45),('14598','2013-09-16','18:05:00',1.35),('14598','2013-09-16','18:10:00',1.22),('14598','2013-09-16','18:15:00',1.09),('14598','2013-09-15','08:40:00',1.07),('14598','2013-09-15','08:45:00',1.05),('14598','2013-09-15','08:50:00',1.15),('14598','2013-09-15','08:55:00',1.2),('14598','2013-09-15','09:00:00',1.38),('14598','2013-09-15','09:05:00',1.56),('14598','2013-09-15','09:10:00',1.58),('14598','2013-09-15','09:15:00',1.73),('14598','2013-09-15','09:20:00',1.82),('14598','2013-09-15','09:25:00',1.98),('14598','2013-09-15','09:30:00',2.09),('14598','2013-09-15','09:35:00',2.15),('14598','2013-09-15','09:40:00',2.21),('14598','2013-09-15','09:45:00',2.38),('14598','2013-09-15','09:50:00',2.47),('14598','2013-09-15','09:55:00',2.53),('14598','2013-09-15','10:00:00',2.59),('14598','2013-09-15','10:05:00',2.75),('14598','2013-09-15','10:10:00',2.66),('14598','2013-09-15','10:15:00',2.75),('14598','2013-09-15','10:20:00',2.71),('14598','2013-09-15','10:25:00',2.75),('14598','2013-09-15','10:30:00',3.04),('14598','2013-09-15','10:35:00',3.01),('14598','2013-09-15','10:40:00',3.06),('14598','2013-09-15','10:45:00',3.25),('14598','2013-09-15','10:50:00',3.31),('14598','2013-09-15','10:55:00',3.46),('14598','2013-09-15','11:00:00',3.41),('14598','2013-09-15','11:05:00',3.49),('14598','2013-09-15','11:10:00',3.64),('14598','2013-09-15','11:15:00',3.67),('14598','2013-09-15','11:20:00',3.72),('14598','2013-09-15','11:25:00',3.78),('14598','2013-09-15','11:30:00',3.83),('14598','2013-09-15','11:35:00',3.91),('14598','2013-09-15','11:40:00',3.97),('14598','2013-09-15','11:45:00',4.01),('14598','2013-09-15','11:50:00',4.07),('14598','2013-09-15','11:55:00',4.08),('14598','2013-09-15','12:00:00',4.17),('14598','2013-09-15','12:05:00',4.27),('14598','2013-09-15','12:10:00',4.4),('14598','2013-09-15','12:15:00',4.54),('14598','2013-09-15','12:20:00',4.61),('14598','2013-09-15','12:25:00',4.58),('14598','2013-09-15','12:30:00',4.47),('14598','2013-09-15','12:35:00',3.07),('14598','2013-09-15','12:40:00',4.03),('14598','2013-09-15','12:45:00',3.4),('14598','2013-09-15','12:50:00',3.02),('14598','2013-09-15','12:55:00',3.2),('14598','2013-09-15','13:00:00',3.54),('14598','2013-09-15','13:05:00',3.4),('14598','2013-09-15','13:10:00',3.05),('14598','2013-09-15','13:15:00',2.99),('14598','2013-09-15','13:20:00',3.74),('14598','2013-09-15','13:25:00',4.99),('14598','2013-09-15','13:30:00',5.01),('14598','2013-09-15','13:35:00',3.31),('14598','2013-09-15','13:40:00',2.47),('14598','2013-09-15','13:45:00',1.86),('14598','2013-09-15','13:50:00',2.18),('14598','2013-09-15','13:55:00',2.09),('14598','2013-09-15','14:00:00',2.13),('14598','2013-09-15','14:05:00',1.79),('14598','2013-09-15','14:10:00',1.57),('14598','2013-09-15','14:15:00',1.44),('14598','2013-09-15','14:20:00',1.38),('14598','2013-09-15','14:25:00',1.37),('14598','2013-09-15','14:30:00',1.43),('14598','2013-09-15','14:35:00',1.4),('14598','2013-09-15','14:40:00',1.22),('14598','2013-09-15','14:45:00',1.14),('14598','2013-09-15','14:50:00',1.16),('14598','2013-09-15','14:55:00',1.31),('14598','2013-09-15','15:00:00',1.73),('14598','2013-09-15','15:05:00',1.95),('14598','2013-09-15','15:10:00',1.64),('14598','2013-09-15','15:15:00',1.35),('14598','2013-09-15','15:25:00',1.07),('14598','2013-09-15','15:30:00',1.25),('14598','2013-09-15','15:40:00',1.08),('14598','2013-09-15','15:45:00',1.04),('14598','2013-09-15','15:50:00',1.1),('14598','2013-09-15','15:55:00',1.18),('14598','2013-09-15','16:00:00',1.01),('14598','2013-09-15','16:05:00',1.2),('14598','2013-09-15','16:10:00',1.47),('14598','2013-09-15','16:15:00',1.23),('14598','2013-09-15','16:20:00',2.62),('14598','2013-09-15','16:25:00',1.89),('14598','2013-09-15','16:30:00',2.24),('14598','2013-09-15','16:35:00',1.74),('14598','2013-09-15','16:40:00',2.04),('14598','2013-09-15','16:45:00',1.38),('14598','2013-09-15','16:50:00',1.18),('14598','2013-09-15','16:55:00',1),('14598','2013-09-15','17:05:00',1.1),('14598','2013-09-15','17:50:00',1.52),('14598','2013-09-14','08:40:00',1.02),('14598','2013-09-14','08:45:00',1.12),('14598','2013-09-14','08:50:00',1.21),('14598','2013-09-14','08:55:00',1.31),('14598','2013-09-14','09:00:00',1.41),('14598','2013-09-14','09:05:00',1.53),('14598','2013-09-14','09:10:00',1.64),('14598','2013-09-14','09:15:00',1.77),('14598','2013-09-14','09:20:00',1.89),('14598','2013-09-14','09:25:00',2),('14598','2013-09-14','09:30:00',2.08),('14598','2013-09-14','09:35:00',2.16),('14598','2013-09-14','09:40:00',2.28),('14598','2013-09-14','09:45:00',2.38),('14598','2013-09-14','09:50:00',2.49),('14598','2013-09-14','09:55:00',2.51),('14598','2013-09-14','10:00:00',2.59),('14598','2013-09-14','10:05:00',1.8),('14598','2013-09-14','10:10:00',2.49),('14598','2013-09-14','10:15:00',2.58),('14598','2013-09-14','10:20:00',2.81),('14598','2013-09-14','10:25:00',3.07),('14598','2013-09-14','10:30:00',3.12),('14598','2013-09-14','10:35:00',3.18),('14598','2013-09-14','10:40:00',3.24),('14598','2013-09-14','10:45:00',3.32),('14598','2013-09-14','10:50:00',3.38),('14598','2013-09-14','10:55:00',3.42),('14598','2013-09-14','11:00:00',3.44),('14598','2013-09-14','11:05:00',3.49),('14598','2013-09-14','11:10:00',3.57),('14598','2013-09-14','11:15:00',3.54),('14598','2013-09-14','11:20:00',3.58),('14598','2013-09-14','11:25:00',3.68),('14598','2013-09-14','11:30:00',3.72),('14598','2013-09-14','11:35:00',3.77),('14598','2013-09-14','11:40:00',3.85),('14598','2013-09-14','11:45:00',3.93),('14598','2013-09-14','11:50:00',4.04),('14598','2013-09-14','11:55:00',4.08),('14598','2013-09-14','12:00:00',4.08),('14598','2013-09-14','12:05:00',4.14),('14598','2013-09-14','12:10:00',4.2),('14598','2013-09-14','12:15:00',4.23),('14598','2013-09-14','12:20:00',4.27),('14598','2013-09-14','12:25:00',4.3),('14598','2013-09-14','12:30:00',4.34),('14598','2013-09-14','12:35:00',4.38),('14598','2013-09-14','12:40:00',4.43),('14598','2013-09-14','12:45:00',4.45),('14598','2013-09-14','12:50:00',4.47),('14598','2013-09-14','12:55:00',4.48),('14598','2013-09-14','13:00:00',4.45),('14598','2013-09-14','13:05:00',4.57),('14598','2013-09-14','13:10:00',4.62),('14598','2013-09-14','13:15:00',4.61),('14598','2013-09-14','13:20:00',4.59),('14598','2013-09-14','13:25:00',4.57),('14598','2013-09-14','13:30:00',4.57),('14598','2013-09-14','13:35:00',4.6),('14598','2013-09-14','13:40:00',4.55),('14598','2013-09-14','13:45:00',4.59),('14598','2013-09-14','13:50:00',4.53),('14598','2013-09-14','13:55:00',4.52),('14598','2013-09-14','14:00:00',4.51),('14598','2013-09-14','14:05:00',4.51),('14598','2013-09-14','14:10:00',4.49),('14598','2013-09-14','14:15:00',4.47),('14598','2013-09-14','14:20:00',4.45),('14598','2013-09-14','14:25:00',4.41),('14598','2013-09-14','14:30:00',4.39),('14598','2013-09-14','14:35:00',4.38),('14598','2013-09-14','14:40:00',4.34),('14598','2013-09-14','14:45:00',4.26),('14598','2013-09-14','14:50:00',4.29),('14598','2013-09-14','14:55:00',4.25),('14598','2013-09-14','15:00:00',4.2),('14598','2013-09-14','15:05:00',4.18),('14598','2013-09-14','15:10:00',4.13),('14598','2013-09-14','15:15:00',4.08),('14598','2013-09-14','15:20:00',4.04),('14598','2013-09-14','15:25:00',3.99),('14598','2013-09-14','15:30:00',3.95),('14598','2013-09-14','15:35:00',3.89),('14598','2013-09-14','15:40:00',3.84),('14598','2013-09-14','15:45:00',3.78),('14598','2013-09-14','15:50:00',3.72),('14598','2013-09-14','15:55:00',3.67),('14598','2013-09-14','16:00:00',3.59),('14598','2013-09-14','16:05:00',3.56),('14598','2013-09-14','16:10:00',3.46),('14598','2013-09-14','16:15:00',3.42),('14598','2013-09-14','16:20:00',3.36),('14598','2013-09-14','16:25:00',3.28),('14598','2013-09-14','16:30:00',3.21),('14598','2013-09-14','16:35:00',3.13),('14598','2013-09-14','16:40:00',3.05),('14598','2013-09-14','16:45:00',2.97),('14598','2013-09-14','16:50:00',2.9),('14598','2013-09-14','16:55:00',2.8),('14598','2013-09-14','17:00:00',2.72),('14598','2013-09-14','17:05:00',2.61),('14598','2013-09-14','17:10:00',2.53),('14598','2013-09-14','17:15:00',2.47),('14598','2013-09-14','17:20:00',2.39),('14598','2013-09-14','17:25:00',2.28),('14598','2013-09-14','17:30:00',2.02),('14598','2013-09-14','17:35:00',1.63),('14598','2013-09-14','17:40:00',2.03),('14598','2013-09-14','17:45:00',1.85),('14598','2013-09-14','17:50:00',1.75),('14598','2013-09-14','17:55:00',1.57),('14598','2013-09-14','18:00:00',1.5),('14598','2013-09-14','18:05:00',1.43),('14598','2013-09-14','18:10:00',1.32),('14598','2013-09-14','18:15:00',1.21),('14598','2013-09-14','18:20:00',1.09),('14598','2013-09-13','09:10:00',1.07),('14598','2013-09-13','09:15:00',1.09),('14598','2013-09-13','09:20:00',1.16),('14598','2013-09-13','09:25:00',1.24),('14598','2013-09-13','09:30:00',1.34),('14598','2013-09-13','09:35:00',1.31),('14598','2013-09-13','09:40:00',1.58),('14598','2013-09-13','09:45:00',1.59),('14598','2013-09-13','09:50:00',1.47),('14598','2013-09-13','09:55:00',1.99),('14598','2013-09-13','10:00:00',2.67),('14598','2013-09-13','10:05:00',2.98),('14598','2013-09-13','10:10:00',2.98),('14598','2013-09-13','10:15:00',2.96),('14598','2013-09-13','10:20:00',3),('14598','2013-09-13','10:25:00',3.09),('14598','2013-09-13','10:30:00',3.16),('14598','2013-09-13','10:35:00',3.24),('14598','2013-09-13','10:40:00',3.31),('14598','2013-09-13','10:45:00',3.37),('14598','2013-09-13','10:50:00',3.44),('14598','2013-09-13','10:55:00',3.49),('14598','2013-09-13','11:00:00',3.55),('14598','2013-09-13','11:05:00',3.63),('14598','2013-09-13','11:10:00',3.67),('14598','2013-09-13','11:15:00',3.71),('14598','2013-09-13','11:20:00',3.76),('14598','2013-09-13','11:25:00',3.81),('14598','2013-09-13','11:30:00',3.84),('14598','2013-09-13','11:35:00',3.86),('14598','2013-09-13','11:40:00',3.94),('14598','2013-09-13','11:45:00',3.99),('14598','2013-09-13','11:50:00',4.05),('14598','2013-09-13','11:55:00',4.08),('14598','2013-09-13','12:00:00',4.08),('14598','2013-09-13','12:05:00',4.1),('14598','2013-09-13','12:10:00',4.15),('14598','2013-09-13','12:15:00',4.16),('14598','2013-09-13','12:20:00',4.18),('14598','2013-09-13','12:25:00',4.28),('14598','2013-09-13','12:30:00',4.33),('14598','2013-09-13','12:35:00',4.4),('14598','2013-09-13','12:40:00',4.37),('14598','2013-09-13','12:45:00',4.47),('14598','2013-09-13','12:50:00',4.49),('14598','2013-09-13','12:55:00',4.51),('14598','2013-09-13','13:00:00',4.54),('14598','2013-09-13','13:05:00',4.58),('14598','2013-09-13','13:10:00',4.58),('14598','2013-09-13','13:15:00',4.58),('14598','2013-09-13','13:20:00',4.6),('14598','2013-09-13','13:25:00',4.61),('14598','2013-09-13','13:30:00',4.61),('14598','2013-09-13','13:35:00',4.62),('14598','2013-09-13','13:40:00',4.61),('14598','2013-09-13','13:45:00',4.6),('14598','2013-09-13','13:50:00',4.62),('14598','2013-09-13','13:55:00',4.61),('14598','2013-09-13','14:00:00',4.63),('14598','2013-09-13','14:05:00',4.61),('14598','2013-09-13','14:10:00',4.59),('14598','2013-09-13','14:15:00',4.57),('14598','2013-09-13','14:20:00',4.57),('14598','2013-09-13','14:25:00',4.54),('14598','2013-09-13','14:30:00',4.52),('14598','2013-09-13','14:35:00',4.5),('14598','2013-09-13','14:40:00',4.46),('14598','2013-09-13','14:45:00',4.46),('14598','2013-09-13','14:50:00',4.41),('14598','2013-09-13','14:55:00',4.38),('14598','2013-09-13','15:00:00',4.35),('14598','2013-09-13','15:05:00',4.31),('14598','2013-09-13','15:10:00',4.25),('14598','2013-09-13','15:15:00',4.22),('14598','2013-09-13','15:20:00',4.16),('14598','2013-09-13','15:25:00',4.12),('14598','2013-09-13','15:30:00',4.07),('14598','2013-09-13','15:35:00',4.02),('14598','2013-09-13','15:40:00',3.97),('14598','2013-09-13','15:45:00',3.91),('14598','2013-09-13','15:50:00',3.86),('14598','2013-09-13','15:55:00',3.8),('14598','2013-09-13','16:00:00',3.72),('14598','2013-09-13','16:05:00',3.65),('14598','2013-09-13','16:10:00',3.59),('14598','2013-09-13','16:15:00',3.52),('14598','2013-09-13','16:20:00',3.46),('14598','2013-09-13','16:25:00',3.39),('14598','2013-09-13','16:30:00',3.3),('14598','2013-09-13','16:35:00',3.22),('14598','2013-09-13','16:40:00',3.13),('14598','2013-09-13','16:45:00',3.05),('14598','2013-09-13','16:50:00',2.97),('14598','2013-09-13','16:55:00',2.88),('14598','2013-09-13','17:00:00',2.79),('14598','2013-09-13','17:05:00',2.69),('14598','2013-09-13','17:10:00',2.59),('14598','2013-09-13','17:15:00',2.5),('14598','2013-09-13','17:20:00',2.4),('14598','2013-09-13','17:25:00',2.25),('14598','2013-09-13','17:30:00',2.19),('14598','2013-09-13','17:35:00',2.08),('14598','2013-09-13','17:40:00',1.97),('14598','2013-09-13','17:45:00',1.86),('14598','2013-09-13','17:50:00',1.74),('14598','2013-09-13','17:55:00',1.63),('14598','2013-09-13','18:00:00',1.52),('14598','2013-09-13','18:05:00',1.41),('14598','2013-09-13','18:10:00',1.29),('14598','2013-09-13','18:15:00',1.18),('14598','2013-09-13','18:20:00',1.06),('14598','2013-09-12','08:35:00',1.26),('14598','2013-09-12','08:40:00',1.21),('14598','2013-09-12','08:45:00',1.12),('14598','2013-09-12','08:50:00',1.22),('14598','2013-09-12','08:55:00',1.49),('14598','2013-09-12','09:00:00',1.5),('14598','2013-09-12','09:05:00',1.4),('14598','2013-09-12','09:10:00',1.33),('14598','2013-09-12','09:15:00',1.56),('14598','2013-09-12','09:20:00',2.17),('14598','2013-09-12','09:25:00',1.49),('14598','2013-09-12','09:30:00',2.01),('14598','2013-09-12','09:35:00',1.85),('14598','2013-09-12','09:40:00',1.57),('14598','2013-09-12','09:45:00',1.91),('14598','2013-09-12','09:50:00',2.27),('14598','2013-09-12','09:55:00',2.51),('14598','2013-09-12','10:00:00',2.18),('14598','2013-09-12','10:05:00',1.44),('14598','2013-09-12','10:15:00',1.65),('14598','2013-09-12','10:20:00',2.96),('14598','2013-09-12','10:25:00',3.29),('14598','2013-09-12','10:30:00',3.47),('14598','2013-09-12','10:35:00',3.89),('14598','2013-09-12','10:40:00',4.3),('14598','2013-09-12','10:45:00',3.54),('14598','2013-09-12','10:50:00',1.63),('14598','2013-09-12','11:15:00',1.41),('14598','2013-09-12','11:20:00',1.51),('14598','2013-09-12','11:25:00',3.54),('14598','2013-09-12','11:30:00',4.21),('14598','2013-09-12','11:35:00',4.11),('14598','2013-09-12','11:40:00',4.04),('14598','2013-09-12','11:45:00',4.24),('14598','2013-09-12','11:50:00',4.31),('14598','2013-09-12','11:55:00',4.37),('14598','2013-09-12','12:00:00',4.33),('14598','2013-09-12','12:05:00',4.51),('14598','2013-09-12','12:10:00',4.24),('14598','2013-09-12','12:15:00',4.47),('14598','2013-09-12','12:20:00',4.27),('14598','2013-09-12','12:25:00',3.98),('14598','2013-09-12','12:30:00',3.71),('14598','2013-09-12','12:35:00',3.9),('14598','2013-09-12','12:40:00',4.54),('14598','2013-09-12','12:45:00',4.58),('14598','2013-09-12','12:50:00',4.33),('14598','2013-09-12','12:55:00',4.57),('14598','2013-09-12','13:00:00',5.27),('14598','2013-09-12','13:05:00',3.43),('14598','2013-09-12','13:10:00',4.85),('14598','2013-09-12','13:15:00',4.69),('14598','2013-09-12','13:20:00',4.63),('14598','2013-09-12','13:25:00',4.59),('14598','2013-09-12','13:30:00',4.58),('14598','2013-09-12','13:35:00',3.71),('14598','2013-09-12','13:40:00',4.65),('14598','2013-09-12','13:45:00',3.65),('14598','2013-09-12','13:50:00',3.12),('14598','2013-09-12','13:55:00',4.53),('14598','2013-09-12','14:00:00',4.98),('14598','2013-09-12','14:05:00',4.72),('14598','2013-09-12','14:10:00',4.56),('14598','2013-09-12','14:15:00',4.26),('14598','2013-09-12','14:20:00',3.36),('14598','2013-09-12','14:25:00',4.91),('14598','2013-09-12','14:30:00',4.59),('14598','2013-09-12','14:35:00',4.72),('14598','2013-09-12','14:40:00',4.55),('14598','2013-09-12','14:45:00',4.51),('14598','2013-09-12','14:50:00',4.5),('14598','2013-09-12','14:55:00',4.48),('14598','2013-09-12','15:00:00',4.37),('14598','2013-09-12','15:05:00',4.42),('14598','2013-09-12','15:10:00',4.38),('14598','2013-09-12','15:15:00',3.59),('14598','2013-09-12','15:20:00',3.56),('14598','2013-09-12','15:25:00',4.16),('14598','2013-09-12','15:30:00',3.87),('14598','2013-09-12','15:35:00',3.87),('14598','2013-09-12','15:40:00',2.4),('14598','2013-09-12','15:45:00',3.24),('14598','2013-09-12','15:50:00',4.15),('14598','2013-09-12','15:55:00',4.11),('14598','2013-09-12','16:00:00',2.88),('14598','2013-09-12','16:05:00',3.83),('14598','2013-09-12','16:10:00',2.35),('14598','2013-09-12','16:15:00',3.91),('14598','2013-09-12','16:20:00',3.82),('14598','2013-09-12','16:25:00',3.67),('14598','2013-09-12','16:30:00',3.69),('14598','2013-09-12','16:35:00',3.05),('14598','2013-09-12','16:40:00',2.53),('14598','2013-09-12','16:45:00',1.15),('14598','2013-09-12','16:50:00',2),('14598','2013-09-12','16:55:00',3.34),('14598','2013-09-12','17:00:00',3.09),('14598','2013-09-12','17:05:00',2.4),('14598','2013-09-12','17:10:00',2.99),('14598','2013-09-12','17:15:00',2.27),('14598','2013-09-12','17:20:00',2.56),('14598','2013-09-12','17:25:00',2.3),('14598','2013-09-12','17:45:00',1.31),('14598','2013-09-12','17:50:00',1.29),('14598','2013-09-12','17:55:00',1.19),('14598','2013-09-12','18:00:00',1.72),('14598','2013-09-12','18:05:00',1.58),('14598','2013-09-12','18:10:00',1.42),('14598','2013-09-12','18:15:00',1.1),('14598','2013-09-12','18:25:00',1.07),('14598','2013-09-11','08:45:00',1.08),('14598','2013-09-11','09:35:00',1.13),('14598','2013-09-11','09:40:00',1.34),('14598','2013-09-11','09:45:00',2.25),('14598','2013-09-11','09:50:00',2.51),('14598','2013-09-11','09:55:00',2.58),('14598','2013-09-11','10:00:00',2.64),('14598','2013-09-11','10:05:00',2.71),('14598','2013-09-11','10:10:00',2.76),('14598','2013-09-11','10:15:00',2.86),('14598','2013-09-11','10:20:00',2.94),('14598','2013-09-11','10:25:00',3),('14598','2013-09-11','10:30:00',2.76),('14598','2013-09-11','10:35:00',3.13),('14598','2013-09-11','10:40:00',3.24),('14598','2013-09-11','10:45:00',3.29),('14598','2013-09-11','10:50:00',3.4),('14598','2013-09-11','10:55:00',3.47),('14598','2013-09-11','11:00:00',3.55),('14598','2013-09-11','11:05:00',3.64),('14598','2013-09-11','11:10:00',3.65),('14598','2013-09-11','11:15:00',3.76),('14598','2013-09-11','11:20:00',3.81),('14598','2013-09-11','11:25:00',3.86),('14598','2013-09-11','11:30:00',3.9),('14598','2013-09-11','11:35:00',3.96),('14598','2013-09-11','11:40:00',3.99),('14598','2013-09-11','11:45:00',4.04),('14598','2013-09-11','11:50:00',4.08),('14598','2013-09-11','11:55:00',4.1),('14598','2013-09-11','12:00:00',4.12),('14598','2013-09-11','12:05:00',4.18),('14598','2013-09-11','12:10:00',4.19),('14598','2013-09-11','12:15:00',4.25),('14598','2013-09-11','12:20:00',4.27),('14598','2013-09-11','12:25:00',4.32),('14598','2013-09-11','12:30:00',4.36),('14598','2013-09-11','12:35:00',4.44),('14598','2013-09-11','12:40:00',4.44),('14598','2013-09-11','12:45:00',4.48),('14598','2013-09-11','12:50:00',4.58),('14598','2013-09-11','12:55:00',2.63),('14598','2013-09-11','13:00:00',4.4),('14598','2013-09-11','13:05:00',3.44),('14598','2013-09-11','13:10:00',4.33),('14598','2013-09-11','13:15:00',4.58),('14598','2013-09-11','13:20:00',4.62),('14598','2013-09-11','13:25:00',4.56),('14598','2013-09-11','13:30:00',4.55),('14598','2013-09-11','13:35:00',4.57),('14598','2013-09-11','13:40:00',4.61),('14598','2013-09-11','13:45:00',4.61),('14598','2013-09-11','13:50:00',4.69),('14598','2013-09-11','13:55:00',4.77),('14598','2013-09-11','14:00:00',4.79),('14598','2013-09-11','14:05:00',4.98),('14598','2013-09-11','14:10:00',4.92),('14598','2013-09-11','14:15:00',1.83),('14598','2013-09-11','14:20:00',1.9),('14598','2013-09-11','14:25:00',2.41),('14598','2013-09-11','14:30:00',3.06),('14598','2013-09-11','14:35:00',2.93),('14598','2013-09-11','14:40:00',1.86),('14598','2013-09-11','14:45:00',2.28),('14598','2013-09-11','14:50:00',3.31),('14598','2013-09-11','14:55:00',1.92),('14598','2013-09-11','15:00:00',2.54),('14598','2013-09-11','15:05:00',4.08),('14598','2013-09-11','15:10:00',4.43),('14598','2013-09-11','15:15:00',4.26),('14598','2013-09-11','15:20:00',4.27),('14598','2013-09-11','15:25:00',4.21),('14598','2013-09-11','15:30:00',3.94),('14598','2013-09-11','15:35:00',1.68),('14598','2013-09-11','15:40:00',1.24),('14598','2013-09-11','15:45:00',1.54),('14598','2013-09-11','15:50:00',4.59),('14598','2013-09-11','15:55:00',3.95),('14598','2013-09-11','16:00:00',3.81),('14598','2013-09-11','16:05:00',3.75),('14598','2013-09-11','16:10:00',3.68),('14598','2013-09-11','16:15:00',3.58),('14598','2013-09-11','16:20:00',3.53),('14598','2013-09-11','16:25:00',3.47),('14598','2013-09-11','16:30:00',3.37),('14598','2013-09-11','16:35:00',2.58),('14598','2013-09-11','16:40:00',2.04),('14598','2013-09-11','16:45:00',3.15),('14598','2013-09-11','16:50:00',3.02),('14598','2013-09-11','16:55:00',2.93),('14598','2013-09-11','17:00:00',2.84),('14598','2013-09-11','17:05:00',2.75),('14598','2013-09-11','17:10:00',2.66),('14598','2013-09-11','17:15:00',2.33),('14598','2013-09-11','17:20:00',2.52),('14598','2013-09-11','17:25:00',2.37),('14598','2013-09-11','17:30:00',2.26),('14598','2013-09-11','17:35:00',2.16),('14598','2013-09-11','17:40:00',2.04),('14598','2013-09-11','17:45:00',1.96),('14598','2013-09-11','17:50:00',1.79),('14598','2013-09-11','17:55:00',1.7),('14598','2013-09-11','18:00:00',1.57),('14598','2013-09-11','18:05:00',1.15),('14598','2013-09-10','08:55:00',1.37),('14598','2013-09-10','09:00:00',2.15),('14598','2013-09-10','09:05:00',1.86),('14598','2013-09-10','09:10:00',1.64),('14598','2013-09-10','09:15:00',1.91),('14598','2013-09-10','09:20:00',1.76),('14598','2013-09-10','09:25:00',1.21),('14598','2013-09-10','10:20:00',1.04),('14598','2013-09-10','10:25:00',1.14),('14598','2013-09-10','10:30:00',1.29),('14598','2013-09-10','10:35:00',1.23),('14598','2013-09-10','10:40:00',1.33),('14598','2013-09-10','10:45:00',1.54),('14598','2013-09-10','10:50:00',1.75),('14598','2013-09-10','10:55:00',1.38),('14598','2013-09-10','11:00:00',1.13),('14598','2013-09-10','11:10:00',1.38),('14598','2013-09-10','11:15:00',1.52),('14598','2013-09-10','11:20:00',1.03),('14598','2013-09-10','11:30:00',1.26),('14598','2013-09-10','11:35:00',1.83),('14598','2013-09-10','11:40:00',1.39),('14598','2013-09-10','11:45:00',2.06),('14598','2013-09-10','11:50:00',2.39),('14598','2013-09-10','11:55:00',2.06),('14598','2013-09-10','12:00:00',1.48),('14598','2013-09-10','12:05:00',2.26),('14598','2013-09-10','12:10:00',2.34),('14598','2013-09-10','12:15:00',2.6),('14598','2013-09-10','12:20:00',2.06),('14598','2013-09-10','12:25:00',1.43),('14598','2013-09-10','13:10:00',1.09),('14598','2013-09-10','13:15:00',1.26),('14598','2013-09-10','13:20:00',1.14),('14598','2013-09-10','13:25:00',1.46),('14598','2013-09-10','13:30:00',1.77),('14598','2013-09-10','13:35:00',1.95),('14598','2013-09-10','13:40:00',2.35),('14598','2013-09-10','13:45:00',2.66),('14598','2013-09-10','13:50:00',1.82),('14598','2013-09-10','13:55:00',1.68),('14598','2013-09-10','14:00:00',1.81),('14598','2013-09-10','14:05:00',1.88),('14598','2013-09-10','14:10:00',1.93),('14598','2013-09-10','14:15:00',2.07),('14598','2013-09-10','14:20:00',2.41),('14598','2013-09-10','14:25:00',2.46),('14598','2013-09-10','14:30:00',2.25),('14598','2013-09-10','14:35:00',2.6),('14598','2013-09-10','14:40:00',2.4),('14598','2013-09-10','14:45:00',2.39),('14598','2013-09-10','14:50:00',2.66),('14598','2013-09-10','14:55:00',2.68),('14598','2013-09-10','15:00:00',2.66),('14598','2013-09-10','15:05:00',2.52),('14598','2013-09-10','15:10:00',2.7),('14598','2013-09-10','15:15:00',2.26),('14598','2013-09-10','15:20:00',1.64),('14598','2013-09-10','15:25:00',1.62),('14598','2013-09-10','15:30:00',1.49),('14598','2013-09-10','15:35:00',1.64),('14598','2013-09-10','15:40:00',1.56),('14598','2013-09-10','15:45:00',1.42),('14598','2013-09-10','15:50:00',1.16),('14598','2013-09-10','15:55:00',1.07),('14598','2013-09-10','16:15:00',1.21),('14598','2013-09-10','16:20:00',1.33),('14598','2013-09-10','16:25:00',1.18),('14598','2013-09-10','16:30:00',1.17),('14598','2013-09-10','16:35:00',1.93),('14598','2013-09-10','16:40:00',1.02),('14598','2013-09-09','09:25:00',1.14),('14598','2013-09-09','09:30:00',1.37),('14598','2013-09-09','09:35:00',1.29),('14598','2013-09-09','09:45:00',1.17),('14598','2013-09-09','10:00:00',1.11),('14598','2013-09-09','10:05:00',1.27),('14598','2013-09-09','10:10:00',1.32),('14598','2013-09-09','10:15:00',1.59),('14598','2013-09-09','10:20:00',1.74),('14598','2013-09-09','10:25:00',1.74),('14598','2013-09-09','10:30:00',2.08),('14598','2013-09-09','10:35:00',2.6),('14598','2013-09-09','10:40:00',2.62),('14598','2013-09-09','10:45:00',2.3),('14598','2013-09-09','10:50:00',1.88),('14598','2013-09-09','10:55:00',1.85),('14598','2013-09-09','11:00:00',2.03),('14598','2013-09-09','11:05:00',2.4),('14598','2013-09-09','11:10:00',2.44),('14598','2013-09-09','11:15:00',2.49),('14598','2013-09-09','11:20:00',3.03),('14598','2013-09-09','11:25:00',3.18),('14598','2013-09-09','11:30:00',2.9),('14598','2013-09-09','11:35:00',3.48),('14598','2013-09-09','11:40:00',3.66),('14598','2013-09-09','11:45:00',3.76),('14598','2013-09-09','11:50:00',3.89),('14598','2013-09-09','11:55:00',3.49),('14598','2013-09-09','12:00:00',3.36),('14598','2013-09-09','12:05:00',2.87),('14598','2013-09-09','12:10:00',3),('14598','2013-09-09','12:15:00',3.18),('14598','2013-09-09','12:20:00',2.89),('14598','2013-09-09','12:25:00',2.69),('14598','2013-09-09','12:30:00',2.59),('14598','2013-09-09','12:35:00',2.66),('14598','2013-09-09','12:40:00',2.65),('14598','2013-09-09','12:45:00',2.44),('14598','2013-09-09','12:50:00',3.14),('14598','2013-09-09','12:55:00',3.9),('14598','2013-09-09','13:00:00',4.21),('14598','2013-09-09','13:05:00',3.6),('14598','2013-09-09','13:10:00',3.33),('14598','2013-09-09','13:15:00',4.07),('14598','2013-09-09','13:20:00',4.28),('14598','2013-09-09','13:25:00',4.49),('14598','2013-09-09','13:30:00',4),('14598','2013-09-09','13:35:00',4.54),('14598','2013-09-09','13:40:00',4.58),('14598','2013-09-09','13:45:00',4.3),('14598','2013-09-09','13:50:00',4.26),('14598','2013-09-09','13:55:00',4.56),('14598','2013-09-09','14:00:00',4.43),('14598','2013-09-09','14:05:00',4.68),('14598','2013-09-09','14:10:00',4.66),('14598','2013-09-09','14:15:00',3.49),('14598','2013-09-09','14:20:00',3.47),('14598','2013-09-09','14:25:00',3.82),('14598','2013-09-09','14:30:00',3.96),('14598','2013-09-09','14:35:00',4.25),('14598','2013-09-09','14:40:00',3.56),('14598','2013-09-09','14:45:00',3.02),('14598','2013-09-09','14:50:00',2.95),('14598','2013-09-09','14:55:00',3.58),('14598','2013-09-09','15:00:00',4.11),('14598','2013-09-09','15:05:00',4.11),('14598','2013-09-09','15:10:00',3.88),('14598','2013-09-09','15:15:00',3.1),('14598','2013-09-09','15:20:00',4.13),('14598','2013-09-09','15:25:00',3.01),('14598','2013-09-09','15:30:00',2.53),('14598','2013-09-09','15:35:00',2.14),('14598','2013-09-09','15:40:00',3.1),('14598','2013-09-09','15:45:00',1.41),('14598','2013-09-09','15:50:00',1.61),('14598','2013-09-09','15:55:00',1.57),('14598','2013-09-09','16:00:00',1.79),('14598','2013-09-09','16:05:00',1.87),('14598','2013-09-09','16:10:00',1.83),('14598','2013-09-09','16:15:00',1.35),('14598','2013-09-09','16:20:00',1.48),('14598','2013-09-09','16:25:00',1.02),('14598','2013-09-09','16:40:00',1.05),('14598','2013-09-09','18:00:00',1.56),('14598','2013-09-09','18:05:00',1.59),('14598','2013-09-09','18:10:00',1.44),('14598','2013-09-09','18:15:00',1.23),('14598','2013-09-09','18:20:00',1.08),('14598','2014-04-12','08:10:00',1.05),('14598','2014-04-12','08:15:00',1.25),('14598','2014-04-12','08:20:00',1.49),('14598','2014-04-12','08:25:00',1.33),('14598','2014-04-12','08:30:00',1.49),('14598','2014-04-12','08:35:00',1.59),('14598','2014-04-12','08:40:00',1.89),('14598','2014-04-12','08:45:00',2.08),('14598','2014-04-12','08:50:00',1.62),('14598','2014-04-12','08:55:00',1.73),('14598','2014-04-12','09:00:00',1.9),('14598','2014-04-12','09:05:00',1.6),('14598','2014-04-12','09:10:00',1.37),('14598','2014-04-12','09:35:00',1.33),('14598','2014-04-12','09:40:00',1.59),('14598','2014-04-12','09:45:00',1.74),('14598','2014-04-12','09:50:00',1.7),('14598','2014-04-12','09:55:00',1.68),('14598','2014-04-12','10:00:00',1.75),('14598','2014-04-12','10:05:00',1.74),('14598','2014-04-12','10:10:00',1.86),('14598','2014-04-12','10:15:00',2.09),('14598','2014-04-12','10:20:00',2.67),('14598','2014-04-12','10:25:00',2.68),('14598','2014-04-12','10:30:00',2.44),('14598','2014-04-12','10:35:00',2.77),('14598','2014-04-12','10:40:00',2.62),('14598','2014-04-12','10:45:00',3.3),('14598','2014-04-12','10:50:00',2.71),('14598','2014-04-12','10:55:00',2.43),('14598','2014-04-12','11:00:00',2.66),('14598','2014-04-12','11:05:00',2.81),('14598','2014-04-12','11:10:00',3.24),('14598','2014-04-12','11:15:00',3.16),('14598','2014-04-12','11:20:00',3),('14598','2014-04-12','11:25:00',3.39),('14598','2014-04-12','11:30:00',3.86),('14598','2014-04-12','11:35:00',3),('14598','2014-04-12','11:40:00',3.45),('14598','2014-04-12','11:45:00',3.51),('14598','2014-04-12','11:50:00',3.3),('14598','2014-04-12','11:55:00',3.04),('14598','2014-04-12','12:00:00',3.3),('14598','2014-04-12','12:05:00',3.16),('14598','2014-04-12','12:10:00',3.88),('14598','2014-04-12','12:15:00',3.96),('14598','2014-04-12','12:20:00',3.71),('14598','2014-04-12','12:25:00',4.45),('14598','2014-04-12','12:30:00',4.82),('14598','2014-04-12','12:35:00',4.94),('14598','2014-04-12','12:40:00',4.75),('14598','2014-04-12','12:45:00',4.86),('14598','2014-04-12','12:50:00',4.86),('14598','2014-04-12','12:55:00',4.75),('14598','2014-04-12','13:00:00',4.91),('14598','2014-04-12','13:05:00',4.93),('14598','2014-04-12','13:10:00',4.98),('14598','2014-04-12','13:15:00',5.01),('14598','2014-04-12','13:20:00',4.85),('14598','2014-04-12','13:25:00',4.78),('14598','2014-04-12','13:30:00',3.96),('14598','2014-04-12','13:35:00',4.1),('14598','2014-04-12','13:40:00',4.91),('14598','2014-04-12','13:45:00',4.83),('14598','2014-04-12','13:50:00',4.6),('14598','2014-04-12','13:55:00',4.5),('14598','2014-04-12','14:00:00',4.15),('14598','2014-04-12','14:05:00',3.41),('14598','2014-04-12','14:10:00',3.98),('14598','2014-04-12','14:15:00',3.9),('14598','2014-04-12','14:20:00',4.05),('14598','2014-04-12','14:25:00',4.16),('14598','2014-04-12','14:30:00',4.24),('14598','2014-04-12','14:35:00',3.78),('14598','2014-04-12','14:40:00',3.6),('14598','2014-04-12','14:45:00',4.1),('14598','2014-04-12','14:50:00',4.25),('14598','2014-04-12','14:55:00',4.35),('14598','2014-04-12','15:00:00',4.26),('14598','2014-04-12','15:05:00',3.98),('14598','2014-04-12','15:10:00',4.45),('14598','2014-04-12','15:15:00',4.69),('14598','2014-04-12','15:20:00',4.65),('14598','2014-04-12','15:25:00',4.33),('14598','2014-04-12','15:30:00',4.11),('14598','2014-04-12','15:35:00',4.45),('14598','2014-04-12','15:40:00',4.51),('14598','2014-04-12','15:45:00',4.45),('14598','2014-04-12','15:50:00',4.36),('14598','2014-04-12','15:55:00',4.2),('14598','2014-04-12','16:00:00',4.25),('14598','2014-04-12','16:05:00',4.36),('14598','2014-04-12','16:10:00',3.56),('14598','2014-04-12','16:15:00',4.19),('14598','2014-04-12','16:20:00',3.97),('14598','2014-04-12','16:25:00',3.75),('14598','2014-04-12','16:30:00',3.55),('14598','2014-04-12','16:35:00',3.36),('14598','2014-04-12','16:40:00',3.18),('14598','2014-04-12','16:45:00',3.35),('14598','2014-04-12','16:50:00',3.12),('14598','2014-04-12','16:55:00',3.35),('14598','2014-04-12','17:00:00',3.2),('14598','2014-04-12','17:05:00',3.16),('14598','2014-04-12','17:10:00',3.08),('14598','2014-04-12','17:15:00',2.93),('14598','2014-04-12','17:20:00',2.8),('14598','2014-04-12','17:25:00',2.77),('14598','2014-04-12','17:30:00',2.7),('14598','2014-04-12','17:35:00',2.58),('14598','2014-04-12','17:40:00',2.49),('14598','2014-04-12','17:45:00',2.43),('14598','2014-04-12','17:50:00',2.3),('14598','2014-04-12','17:55:00',2.16),('14598','2014-04-12','18:00:00',2.19),('14598','2014-04-12','18:05:00',2.21),('14598','2014-04-12','18:10:00',1.56),('14598','2014-04-12','18:15:00',1.53),('14598','2014-04-12','18:20:00',1.26),('14598','2014-04-12','18:25:00',1.37),('14598','2013-09-08','08:40:00',1.03),('14598','2013-09-08','08:45:00',1.14),('14598','2013-09-08','08:50:00',1.21),('14598','2013-09-08','08:55:00',1.33),('14598','2013-09-08','09:00:00',1.4),('14598','2013-09-08','09:05:00',1.48),('14598','2013-09-08','09:10:00',1.57),('14598','2013-09-08','09:15:00',1.7),('14598','2013-09-08','09:20:00',1.81),('14598','2013-09-08','09:25:00',1.9),('14598','2013-09-08','09:30:00',2),('14598','2013-09-08','09:35:00',2.09),('14598','2013-09-08','09:40:00',2.17),('14598','2013-09-08','09:45:00',2.25),('14598','2013-09-08','09:50:00',2.31),('14598','2013-09-08','09:55:00',2.38),('14598','2013-09-08','10:00:00',2.49),('14598','2013-09-08','10:05:00',2.58),('14598','2013-09-08','10:10:00',2.65),('14598','2013-09-08','10:15:00',2.72),('14598','2013-09-08','10:20:00',2.78),('14598','2013-09-08','10:25:00',2.86),('14598','2013-09-08','10:30:00',2.87),('14598','2013-09-08','10:35:00',2.98),('14598','2013-09-08','10:40:00',3.1),('14598','2013-09-08','10:45:00',3.05),('14598','2013-09-08','10:50:00',3.04),('14598','2013-09-08','10:55:00',3.09),('14598','2013-09-08','11:00:00',2.87),('14598','2013-09-08','11:05:00',2.85),('14598','2013-09-08','11:10:00',3.42),('14598','2013-09-08','11:15:00',3.48),('14598','2013-09-08','11:20:00',3.47),('14598','2013-09-08','11:25:00',3.58),('14598','2013-09-08','11:30:00',3.66),('14598','2013-09-08','11:35:00',3.74),('14598','2013-09-08','11:40:00',3.68),('14598','2013-09-08','11:45:00',3.68),('14598','2013-09-08','11:50:00',3.88),('14598','2013-09-08','11:55:00',3.96),('14598','2013-09-08','12:00:00',3.98),('14598','2013-09-08','12:05:00',4.07),('14598','2013-09-08','12:10:00',3.91),('14598','2013-09-08','12:15:00',4.11),('14598','2013-09-08','12:20:00',4.14),('14598','2013-09-08','12:25:00',4.18),('14598','2013-09-08','12:30:00',4.24),('14598','2013-09-08','12:35:00',4.23),('14598','2013-09-08','12:40:00',4.15),('14598','2013-09-08','12:45:00',4.12),('14598','2013-09-08','12:50:00',4.27),('14598','2013-09-08','12:55:00',4.32),('14598','2013-09-08','13:00:00',4.09),('14598','2013-09-08','13:05:00',3.98),('14598','2013-09-08','13:10:00',3.88),('14598','2013-09-08','13:15:00',4.09),('14598','2013-09-08','13:20:00',3.02),('14598','2013-09-08','13:25:00',2.37),('14598','2013-09-08','13:30:00',3.61),('14598','2013-09-08','13:35:00',4.07),('14598','2013-09-08','13:40:00',4.71),('14598','2013-09-08','13:45:00',4.59),('14598','2013-09-08','13:50:00',4.24),('14598','2013-09-08','13:55:00',4.54),('14598','2013-09-08','14:00:00',4.94),('14598','2013-09-08','14:05:00',4.82),('14598','2013-09-08','14:10:00',4.36),('14598','2013-09-08','14:15:00',4.52),('14598','2013-09-08','14:20:00',4.51),('14598','2013-09-08','14:25:00',4.43),('14598','2013-09-08','14:30:00',4.2),('14598','2013-09-08','14:35:00',4.41),('14598','2013-09-08','14:40:00',4.49),('14598','2013-09-08','14:45:00',4.39),('14598','2013-09-08','14:50:00',2.38),('14598','2013-09-08','14:55:00',2.89),('14598','2013-09-08','15:00:00',4.12),('14598','2013-09-08','15:05:00',4.36),('14598','2013-09-08','15:10:00',4.3),('14598','2013-09-08','15:15:00',4.21),('14598','2013-09-08','15:20:00',3.85),('14598','2013-09-08','15:25:00',4.07),('14598','2013-09-08','15:30:00',4.04),('14598','2013-09-08','15:35:00',3.94),('14598','2013-09-08','15:40:00',3.78),('14598','2013-09-08','15:45:00',3.76),('14598','2013-09-08','15:50:00',3.44),('14598','2013-09-08','15:55:00',3.75),('14598','2013-09-08','16:00:00',3.5),('14598','2013-09-08','16:05:00',3.42),('14598','2013-09-08','16:10:00',3.21),('14598','2013-09-08','16:15:00',3.06),('14598','2013-09-08','16:20:00',2.61),('14598','2013-09-08','16:25:00',3.22),('14598','2013-09-08','16:30:00',3.25),('14598','2013-09-08','16:35:00',2.39),('14598','2013-09-08','16:40:00',1.51),('14598','2013-09-08','16:45:00',2.91),('14598','2013-09-08','16:50:00',3.16),('14598','2013-09-08','16:55:00',2.9),('14598','2013-09-08','17:00:00',2.72),('14598','2013-09-08','17:05:00',2.16),('14598','2013-09-08','17:10:00',2.51),('14598','2013-09-08','17:15:00',1.65),('14598','2013-09-08','17:20:00',1.58),('14598','2013-09-08','17:25:00',2.22),('14598','2013-09-08','17:30:00',2.16),('14598','2013-09-08','17:35:00',2.02),('14598','2013-09-08','17:40:00',1.9),('14598','2013-09-08','17:45:00',1.77),('14598','2013-09-08','17:50:00',1.56),('14598','2013-09-08','17:55:00',1.43),('14598','2013-09-08','18:00:00',1.31),('14598','2013-09-08','18:05:00',1.2),('14598','2013-09-08','18:10:00',1.16),('14598','2013-09-08','18:15:00',1.11),('14598','2013-09-07','08:40:00',1.05),('14598','2013-09-07','08:45:00',1.14),('14598','2013-09-07','08:50:00',1.23),('14598','2013-09-07','08:55:00',1.35),('14598','2013-09-07','09:00:00',1.44),('14598','2013-09-07','09:05:00',1.55),('14598','2013-09-07','09:10:00',1.66),('14598','2013-09-07','09:15:00',1.77),('14598','2013-09-07','09:20:00',1.87),('14598','2013-09-07','09:25:00',1.97),('14598','2013-09-07','09:30:00',2.06),('14598','2013-09-07','09:35:00',2.14),('14598','2013-09-07','09:40:00',2.22),('14598','2013-09-07','09:45:00',2.32),('14598','2013-09-07','09:50:00',2.39),('14598','2013-09-07','09:55:00',2.47),('14598','2013-09-07','10:00:00',2.56),('14598','2013-09-07','10:05:00',2.58),('14598','2013-09-07','10:10:00',2.7),('14598','2013-09-07','10:15:00',2.78),('14598','2013-09-07','10:20:00',2.87),('14598','2013-09-07','10:25:00',2.93),('14598','2013-09-07','10:30:00',2.99),('14598','2013-09-07','10:35:00',3.07),('14598','2013-09-07','10:40:00',3.13),('14598','2013-09-07','10:45:00',3.18),('14598','2013-09-07','10:50:00',3.24),('14598','2013-09-07','10:55:00',3.26),('14598','2013-09-07','11:00:00',3.38),('14598','2013-09-07','11:05:00',3.45),('14598','2013-09-07','11:10:00',3.52),('14598','2013-09-07','11:15:00',3.55),('14598','2013-09-07','11:20:00',3.61),('14598','2013-09-07','11:25:00',3.61),('14598','2013-09-07','11:30:00',3.67),('14598','2013-09-07','11:35:00',3.7),('14598','2013-09-07','11:40:00',3.78),('14598','2013-09-07','11:45:00',3.86),('14598','2013-09-07','11:50:00',3.9),('14598','2013-09-07','11:55:00',3.96),('14598','2013-09-07','12:00:00',4.04),('14598','2013-09-07','12:05:00',4.07),('14598','2013-09-07','12:10:00',4.12),('14598','2013-09-07','12:15:00',4.16),('14598','2013-09-07','12:20:00',4.18),('14598','2013-09-07','12:25:00',4.21),('14598','2013-09-07','12:30:00',4.25),('14598','2013-09-07','12:35:00',4.3),('14598','2013-09-07','12:40:00',4.33),('14598','2013-09-07','12:45:00',4.35),('14598','2013-09-07','12:50:00',4.38),('14598','2013-09-07','12:55:00',4.39),('14598','2013-09-07','13:00:00',4.39),('14598','2013-09-07','13:05:00',4.43),('14598','2013-09-07','13:10:00',4.4),('14598','2013-09-07','13:15:00',4.46),('14598','2013-09-07','13:20:00',4.46),('14598','2013-09-07','13:25:00',4.49),('14598','2013-09-07','13:30:00',4.49),('14598','2013-09-07','13:35:00',4.52),('14598','2013-09-07','13:40:00',4.53),('14598','2013-09-07','13:45:00',4.53),('14598','2013-09-07','13:50:00',4.53),('14598','2013-09-07','13:55:00',4.53),('14598','2013-09-07','14:00:00',4.52),('14598','2013-09-07','14:05:00',4.49),('14598','2013-09-07','14:10:00',4.47),('14598','2013-09-07','14:15:00',4.45),('14598','2013-09-07','14:20:00',4.45),('14598','2013-09-07','14:25:00',4.39),('14598','2013-09-07','14:30:00',4.41),('14598','2013-09-07','14:35:00',4.38),('14598','2013-09-07','14:40:00',3.43),('14598','2013-09-07','14:45:00',4.33),('14598','2013-09-07','14:50:00',4.31),('14598','2013-09-07','14:55:00',4.28),('14598','2013-09-07','15:00:00',4.26),('14598','2013-09-07','15:05:00',4.24),('14598','2013-09-07','15:10:00',4.22),('14598','2013-09-07','15:15:00',4.17),('14598','2013-09-07','15:20:00',4.13),('14598','2013-09-07','15:25:00',2.65),('14598','2013-09-07','15:30:00',4.02),('14598','2013-09-07','15:35:00',3.98),('14598','2013-09-07','15:40:00',3.92),('14598','2013-09-07','15:45:00',3.88),('14598','2013-09-07','15:50:00',3.8),('14598','2013-09-07','15:55:00',3.76),('14598','2013-09-07','16:00:00',3.71),('14598','2013-09-07','16:05:00',3.65),('14598','2013-09-07','16:10:00',3.61),('14598','2013-09-07','16:15:00',3.54),('14598','2013-09-07','16:20:00',3.45),('14598','2013-09-07','16:25:00',3.37),('14598','2013-09-07','16:30:00',3.29),('14598','2013-09-07','16:35:00',3.22),('14598','2013-09-07','16:40:00',3.13),('14598','2013-09-07','16:45:00',3.06),('14598','2013-09-07','16:50:00',2.98),('14598','2013-09-07','16:55:00',2.88),('14598','2013-09-07','17:00:00',2.79),('14598','2013-09-07','17:05:00',2.7),('14598','2013-09-07','17:10:00',2.6),('14598','2013-09-07','17:15:00',2.51),('14598','2013-09-07','17:20:00',2.41),('14598','2013-09-07','17:25:00',2.3),('14598','2013-09-07','17:30:00',2.2),('14598','2013-09-07','17:35:00',2.12),('14598','2013-09-07','17:40:00',2),('14598','2013-09-07','17:45:00',1.9),('14598','2013-09-07','17:50:00',1.8),('14598','2013-09-07','17:55:00',1.73),('14598','2013-09-07','18:00:00',1.61),('14598','2013-09-07','18:05:00',1.5),('14598','2013-09-07','18:10:00',1.39),('14598','2013-09-07','18:15:00',1.29),('14598','2013-09-07','18:20:00',1.19),('14598','2013-09-07','18:25:00',1.1),('14598','2013-09-06','08:40:00',1.08),('14598','2013-09-06','08:45:00',1.19),('14598','2013-09-06','08:50:00',1.28),('14598','2013-09-06','08:55:00',1.42),('14598','2013-09-06','09:00:00',1.52),('14598','2013-09-06','09:05:00',1.61),('14598','2013-09-06','09:10:00',1.72),('14598','2013-09-06','09:15:00',1.85),('14598','2013-09-06','09:20:00',1.95),('14598','2013-09-06','09:25:00',2.05),('14598','2013-09-06','09:30:00',2.14),('14598','2013-09-06','09:35:00',2.23),('14598','2013-09-06','09:40:00',2.31),('14598','2013-09-06','09:45:00',2.4),('14598','2013-09-06','09:50:00',2.49),('14598','2013-09-06','09:55:00',2.58),('14598','2013-09-06','10:00:00',2.66),('14598','2013-09-06','10:05:00',2.7),('14598','2013-09-06','10:10:00',2.83),('14598','2013-09-06','10:15:00',2.91),('14598','2013-09-06','10:20:00',2.98),('14598','2013-09-06','10:25:00',3.04),('14598','2013-09-06','10:30:00',3.1),('14598','2013-09-06','10:35:00',3.2),('14598','2013-09-06','10:40:00',3.1),('14598','2013-09-06','10:45:00',2.84),('14598','2013-09-06','10:50:00',3.4),('14598','2013-09-06','10:55:00',3.46),('14598','2013-09-06','11:00:00',3.52),('14598','2013-09-06','11:05:00',3.56),('14598','2013-09-06','11:10:00',3.58),('14598','2013-09-06','11:15:00',3.64),('14598','2013-09-06','11:20:00',3.67),('14598','2013-09-06','11:25:00',3.75),('14598','2013-09-06','11:30:00',3.78),('14598','2013-09-06','11:35:00',3.86),('14598','2013-09-06','11:40:00',3.87),('14598','2013-09-06','11:45:00',3.94),('14598','2013-09-06','11:50:00',3.94),('14598','2013-09-06','11:55:00',4.02),('14598','2013-09-06','12:00:00',4.02),('14598','2013-09-06','12:05:00',3.99),('14598','2013-09-06','12:10:00',4.03),('14598','2013-09-06','12:15:00',4.06),('14598','2013-09-06','12:20:00',4.09),('14598','2013-09-06','12:25:00',4.13),('14598','2013-09-06','12:30:00',4.13),('14598','2013-09-06','12:35:00',4.13),('14598','2013-09-06','12:40:00',4.1),('14598','2013-09-06','12:45:00',4.14),('14598','2013-09-06','12:50:00',4.24),('14598','2013-09-06','12:55:00',4.28),('14598','2013-09-06','13:00:00',4.32),('14598','2013-09-06','13:05:00',4.34),('14598','2013-09-06','13:10:00',4.34),('14598','2013-09-06','13:15:00',4.41),('14598','2013-09-06','13:20:00',4.45),('14598','2013-09-06','13:25:00',4.49),('14598','2013-09-06','13:30:00',4.49),('14598','2013-09-06','13:35:00',4.53),('14598','2013-09-06','13:40:00',4.51),('14598','2013-09-06','13:45:00',4.51),('14598','2013-09-06','13:50:00',4.48),('14598','2013-09-06','13:55:00',4.47),('14598','2013-09-06','14:00:00',4.46),('14598','2013-09-06','14:05:00',4.48),('14598','2013-09-06','14:10:00',4.48),('14598','2013-09-06','14:15:00',4.48),('14598','2013-09-06','14:20:00',4.45),('14598','2013-09-06','14:25:00',4.42),('14598','2013-09-06','14:30:00',4.43),('14598','2013-09-06','14:35:00',4.4),('14598','2013-09-06','14:40:00',4.38),('14598','2013-09-06','14:45:00',4.39),('14598','2013-09-06','14:50:00',4.37),('14598','2013-09-06','14:55:00',4.34),('14598','2013-09-06','15:00:00',4.3),('14598','2013-09-06','15:05:00',4.28),('14598','2013-09-06','15:10:00',4.24),('14598','2013-09-06','15:15:00',4.21),('14598','2013-09-06','15:20:00',4.16),('14598','2013-09-06','15:25:00',4.13),('14598','2013-09-06','15:30:00',4.08),('14598','2013-09-06','15:35:00',4.04),('14598','2013-09-06','15:40:00',3.99),('14598','2013-09-06','15:45:00',3.92),('14598','2013-09-06','15:50:00',3.85),('14598','2013-09-06','15:55:00',3.78),('14598','2013-09-06','16:00:00',3.74),('14598','2013-09-06','16:05:00',3.7),('14598','2013-09-06','16:10:00',3.6),('14598','2013-09-06','16:15:00',3.56),('14598','2013-09-06','16:20:00',3.49),('14598','2013-09-06','16:25:00',3.41),('14598','2013-09-06','16:30:00',3.34),('14598','2013-09-06','16:35:00',3.28),('14598','2013-09-06','16:40:00',3.2),('14598','2013-09-06','16:45:00',3.11),('14598','2013-09-06','16:50:00',3.02),('14598','2013-09-06','16:55:00',2.95),('14598','2013-09-06','17:00:00',2.88),('14598','2013-09-06','17:05:00',2.79),('14598','2013-09-06','17:10:00',2.7),('14598','2013-09-06','17:15:00',2.61),('14598','2013-09-06','17:20:00',2.52),('14598','2013-09-06','17:25:00',2.41),('14598','2013-09-06','17:30:00',2.32),('14598','2013-09-06','17:35:00',2.25),('14598','2013-09-06','17:40:00',2.13),('14598','2013-09-06','17:45:00',2.04),('14598','2013-09-06','17:50:00',1.91),('14598','2013-09-06','17:55:00',1.81),('14598','2013-09-06','18:00:00',1.69),('14598','2013-09-06','18:05:00',1.58),('14598','2013-09-06','18:10:00',1.45),('14598','2013-09-06','18:15:00',1.35),('14598','2013-09-06','18:20:00',1.26),('14598','2013-09-06','18:25:00',1.15),('14598','2013-09-06','18:30:00',1.03),('14598','2013-09-05','08:35:00',1.04),('14598','2013-09-05','08:40:00',1.15),('14598','2013-09-05','08:45:00',1.25),('14598','2013-09-05','08:50:00',1.36),('14598','2013-09-05','08:55:00',1.48),('14598','2013-09-05','09:00:00',1.59),('14598','2013-09-05','09:05:00',1.69),('14598','2013-09-05','09:10:00',1.79),('14598','2013-09-05','09:15:00',1.89),('14598','2013-09-05','09:20:00',2),('14598','2013-09-05','09:25:00',2.12),('14598','2013-09-05','09:30:00',2.22),('14598','2013-09-05','09:35:00',2.31),('14598','2013-09-05','09:40:00',2.4),('14598','2013-09-05','09:45:00',2.5),('14598','2013-09-05','09:50:00',2.57),('14598','2013-09-05','09:55:00',2.67),('14598','2013-09-05','10:00:00',2.75),('14598','2013-09-05','10:05:00',2.83),('14598','2013-09-05','10:10:00',2.91),('14598','2013-09-05','10:15:00',2.99),('14598','2013-09-05','10:20:00',3.06),('14598','2013-09-05','10:25:00',3.13),('14598','2013-09-05','10:30:00',3.2),('14598','2013-09-05','10:35:00',3.26),('14598','2013-09-05','10:40:00',3.31),('14598','2013-09-05','10:45:00',3.38),('14598','2013-09-05','10:50:00',3.43),('14598','2013-09-05','10:55:00',3.47),('14598','2013-09-05','11:00:00',3.5),('14598','2013-09-05','11:05:00',3.58),('14598','2013-09-05','11:10:00',3.64),('14598','2013-09-05','11:15:00',3.69),('14598','2013-09-05','11:20:00',3.74),('14598','2013-09-05','11:25:00',3.82),('14598','2013-09-05','11:30:00',3.9),('14598','2013-09-05','11:35:00',3.97),('14598','2013-09-05','11:40:00',4.02),('14598','2013-09-05','11:45:00',4.05),('14598','2013-09-05','11:50:00',4.07),('14598','2013-09-05','11:55:00',4.1),('14598','2013-09-05','12:00:00',4.13),('14598','2013-09-05','12:05:00',4.14),('14598','2013-09-05','12:10:00',4.23),('14598','2013-09-05','12:15:00',4.29),('14598','2013-09-05','12:20:00',4.3),('14598','2013-09-05','12:25:00',4.33),('14598','2013-09-05','12:30:00',4.35),('14598','2013-09-05','12:35:00',4.37),('14598','2013-09-05','12:40:00',4.38),('14598','2013-09-05','12:45:00',4.42),('14598','2013-09-05','12:50:00',4.47),('14598','2013-09-05','12:55:00',4.52),('14598','2013-09-05','13:00:00',4.55),('14598','2013-09-05','13:05:00',4.56),('14598','2013-09-05','13:10:00',4.55),('14598','2013-09-05','13:15:00',4.54),('14598','2013-09-05','13:20:00',4.51),('14598','2013-09-05','13:25:00',4.5),('14598','2013-09-05','13:30:00',4.54),('14598','2013-09-05','13:35:00',4.58),('14598','2013-09-05','13:40:00',4.6),('14598','2013-09-05','13:45:00',4.6),('14598','2013-09-05','13:50:00',4.62),('14598','2013-09-05','13:55:00',4.61),('14598','2013-09-05','14:00:00',4.6),('14598','2013-09-05','14:05:00',4.56),('14598','2013-09-05','14:10:00',4.58),('14598','2013-09-05','14:15:00',4.57),('14598','2013-09-05','14:20:00',4.57),('14598','2013-09-05','14:25:00',4.52),('14598','2013-09-05','14:30:00',4.51),('14598','2013-09-05','14:35:00',4.5),('14598','2013-09-05','14:40:00',4.46),('14598','2013-09-05','14:45:00',4.44),('14598','2013-09-05','14:50:00',4.41),('14598','2013-09-05','14:55:00',4.39),('14598','2013-09-05','15:00:00',4.37),('14598','2013-09-05','15:05:00',4.32),('14598','2013-09-05','15:10:00',4.29),('14598','2013-09-05','15:15:00',4.27),('14598','2013-09-05','15:20:00',4.23),('14598','2013-09-05','15:25:00',4.18),('14598','2013-09-05','15:30:00',4.15),('14598','2013-09-05','15:35:00',4.1),('14598','2013-09-05','15:40:00',4.05),('14598','2013-09-05','15:45:00',4.02),('14598','2013-09-05','15:50:00',3.97),('14598','2013-09-05','15:55:00',3.91),('14598','2013-09-05','16:00:00',3.86),('14598','2013-09-05','16:05:00',3.8),('14598','2013-09-05','16:10:00',3.76),('14598','2013-09-05','16:15:00',3.69),('14598','2013-09-05','16:20:00',3.65),('14598','2013-09-05','16:25:00',3.61),('14598','2013-09-05','16:30:00',3.54),('14598','2013-09-05','16:35:00',3.5),('14598','2013-09-05','16:40:00',3.44),('14598','2013-09-05','16:45:00',2.49),('14598','2013-09-05','16:50:00',2.47),('14598','2013-09-05','16:55:00',2.33),('14598','2013-09-05','17:00:00',2.48),('14598','2013-09-05','17:05:00',2.27),('14598','2013-09-05','17:10:00',2.09),('14598','2013-09-05','17:15:00',2.11),('14598','2013-09-05','17:20:00',2.2),('14598','2013-09-05','17:25:00',2.43),('14598','2013-09-05','17:30:00',2.34),('14598','2013-09-05','17:35:00',1.8),('14598','2013-09-05','17:40:00',2.1),('14598','2013-09-05','17:45:00',2.03),('14598','2013-09-05','17:50:00',1.86),('14598','2013-09-05','17:55:00',1.81),('14598','2013-09-05','18:00:00',1.63),('14598','2013-09-05','18:05:00',1.31),('14598','2013-09-05','18:10:00',1.43),('14598','2013-09-05','18:15:00',1.06),('14598','2013-09-05','18:25:00',1.08),('14598','2013-09-05','18:30:00',1.07),('14598','2013-09-05','18:35:00',1.02),('14598','2013-09-05','18:40:00',1.05),('14598','2013-09-04','08:35:00',1.05),('14598','2013-09-04','08:40:00',1.17),('14598','2013-09-04','08:45:00',1.28),('14598','2013-09-04','08:50:00',1.39),('14598','2013-09-04','08:55:00',1.49),('14598','2013-09-04','09:00:00',1.61),('14598','2013-09-04','09:05:00',1.71),('14598','2013-09-04','09:10:00',1.83),('14598','2013-09-04','09:15:00',1.95),('14598','2013-09-04','09:20:00',2.06),('14598','2013-09-04','09:25:00',2.16),('14598','2013-09-04','09:30:00',2.26),('14598','2013-09-04','09:35:00',2.36),('14598','2013-09-04','09:40:00',2.45),('14598','2013-09-04','09:45:00',2.54),('14598','2013-09-04','09:50:00',2.61),('14598','2013-09-04','09:55:00',2.72),('14598','2013-09-04','10:00:00',2.81),('14598','2013-09-04','10:05:00',2.88),('14598','2013-09-04','10:10:00',2.97),('14598','2013-09-04','10:15:00',3.04),('14598','2013-09-04','10:20:00',3.11),('14598','2013-09-04','10:25:00',3.16),('14598','2013-09-04','10:30:00',3.22),('14598','2013-09-04','10:35:00',3.29),('14598','2013-09-04','10:40:00',3.38),('14598','2013-09-04','10:45:00',3.46),('14598','2013-09-04','10:50:00',3.53),('14598','2013-09-04','10:55:00',3.57),('14598','2013-09-04','11:00:00',3.61),('14598','2013-09-04','11:05:00',3.61),('14598','2013-09-04','11:10:00',3.73),('14598','2013-09-04','11:15:00',3.78),('14598','2013-09-04','11:20:00',3.85),('14598','2013-09-04','11:25:00',3.91),('14598','2013-09-04','11:30:00',3.96),('14598','2013-09-04','11:35:00',4),('14598','2013-09-04','11:40:00',4.06),('14598','2013-09-04','11:45:00',4.08),('14598','2013-09-04','11:50:00',4.12),('14598','2013-09-04','11:55:00',4.16),('14598','2013-09-04','12:00:00',4.17),('14598','2013-09-04','12:05:00',4.17),('14598','2013-09-04','12:10:00',4.19),('14598','2013-09-04','12:15:00',4.23),('14598','2013-09-04','12:20:00',4.29),('14598','2013-09-04','12:25:00',4.35),('14598','2013-09-04','12:30:00',4.37),('14598','2013-09-04','12:35:00',4.42),('14598','2013-09-04','12:40:00',4.43),('14598','2013-09-04','12:45:00',4.48),('14598','2013-09-04','12:50:00',4.5),('14598','2013-09-04','12:55:00',4.52),('14598','2013-09-04','13:00:00',4.54),('14598','2013-09-04','13:05:00',4.55),('14598','2013-09-04','13:10:00',4.52),('14598','2013-09-04','13:15:00',4.51),('14598','2013-09-04','13:20:00',4.55),('14598','2013-09-04','13:25:00',4.56),('14598','2013-09-04','13:30:00',4.56),('14598','2013-09-04','13:35:00',4.57),('14598','2013-09-04','13:40:00',4.56),('14598','2013-09-04','13:45:00',4.55),('14598','2013-09-04','13:50:00',4.54),('14598','2013-09-04','13:55:00',4.54),('14598','2013-09-04','14:00:00',4.5),('14598','2013-09-04','14:05:00',4.51),('14598','2013-09-04','14:10:00',4.5),('14598','2013-09-04','14:15:00',4.45),('14598','2013-09-04','14:20:00',4.44),('14598','2013-09-04','14:25:00',4.45),('14598','2013-09-04','14:30:00',4.42),('14598','2013-09-04','14:35:00',4.38),('14598','2013-09-04','14:40:00',4.31),('14598','2013-09-04','14:45:00',4.3),('14598','2013-09-04','14:50:00',4.23),('14598','2013-09-04','14:55:00',4.23),('14598','2013-09-04','15:00:00',4.26),('14598','2013-09-04','15:05:00',4.22),('14598','2013-09-04','15:10:00',4.16),('14598','2013-09-04','15:15:00',4.15),('14598','2013-09-04','15:20:00',4.12),('14598','2013-09-04','15:25:00',4.14),('14598','2013-09-04','15:30:00',4.12),('14598','2013-09-04','15:35:00',4.09),('14598','2013-09-04','15:40:00',4.03),('14598','2013-09-04','15:45:00',4),('14598','2013-09-04','15:50:00',3.88),('14598','2013-09-04','15:55:00',3.88),('14598','2013-09-04','16:00:00',3.83),('14598','2013-09-04','16:05:00',3.76),('14598','2013-09-04','16:10:00',3.7),('14598','2013-09-04','16:15:00',3.63),('14598','2013-09-04','16:20:00',3.55),('14598','2013-09-04','16:25:00',3.51),('14598','2013-09-04','16:30:00',3.44),('14598','2013-09-04','16:35:00',3.36),('14598','2013-09-04','16:40:00',3.28),('14598','2013-09-04','16:45:00',3.2),('14598','2013-09-04','16:50:00',3.12),('14598','2013-09-04','16:55:00',3.04),('14598','2013-09-04','17:00:00',2.96),('14598','2013-09-04','17:05:00',2.86),('14598','2013-09-04','17:10:00',2.77),('14598','2013-09-04','17:15:00',2.7),('14598','2013-09-04','17:20:00',2.59),('14598','2013-09-04','17:25:00',2.49),('14598','2013-09-04','17:30:00',2.4),('14598','2013-09-04','17:35:00',2.3),('14598','2013-09-04','17:40:00',2.19),('14598','2013-09-04','17:45:00',2.1),('14598','2013-09-04','17:50:00',2),('14598','2013-09-04','17:55:00',1.9),('14598','2013-09-04','18:00:00',1.79),('14598','2013-09-04','18:05:00',1.68),('14598','2013-09-04','18:10:00',1.57),('14598','2013-09-04','18:15:00',1.46),('14598','2013-09-04','18:20:00',1.35),('14598','2013-09-04','18:25:00',1.24),('14598','2013-09-04','18:30:00',1.13),('14598','2013-09-04','18:35:00',1.01),('14598','2013-09-03','08:35:00',1.01),('14598','2013-09-03','08:40:00',1.13),('14598','2013-09-03','08:45:00',1.23),('14598','2013-09-03','08:50:00',1.33),('14598','2013-09-03','08:55:00',1.43),('14598','2013-09-03','09:00:00',1.53),('14598','2013-09-03','09:05:00',1.63),('14598','2013-09-03','09:10:00',1.74),('14598','2013-09-03','09:15:00',1.86),('14598','2013-09-03','09:20:00',1.95),('14598','2013-09-03','09:25:00',2.03),('14598','2013-09-03','09:30:00',2.12),('14598','2013-09-03','09:35:00',2.22),('14598','2013-09-03','09:40:00',2.33),('14598','2013-09-03','09:45:00',2.4),('14598','2013-09-03','09:50:00',2.46),('14598','2013-09-03','09:55:00',2.58),('14598','2013-09-03','10:00:00',2.66),('14598','2013-09-03','10:05:00',2.75),('14598','2013-09-03','10:10:00',2.83),('14598','2013-09-03','10:15:00',2.9),('14598','2013-09-03','10:20:00',2.98),('14598','2013-09-03','10:25:00',3.04),('14598','2013-09-03','10:30:00',3.1),('14598','2013-09-03','10:35:00',3.18),('14598','2013-09-03','10:40:00',3.24),('14598','2013-09-03','10:45:00',3.29),('14598','2013-09-03','10:50:00',3.34),('14598','2013-09-03','10:55:00',3.43),('14598','2013-09-03','11:00:00',3.48),('14598','2013-09-03','11:05:00',3.55),('14598','2013-09-03','11:10:00',3.61),('14598','2013-09-03','11:15:00',3.66),('14598','2013-09-03','11:20:00',3.68),('14598','2013-09-03','11:25:00',3.72),('14598','2013-09-03','11:30:00',3.77),('14598','2013-09-03','11:35:00',3.78),('14598','2013-09-03','11:40:00',3.84),('14598','2013-09-03','11:45:00',3.85),('14598','2013-09-03','11:50:00',3.91),('14598','2013-09-03','11:55:00',3.95),('14598','2013-09-03','12:00:00',4),('14598','2013-09-03','12:05:00',4.04),('14598','2013-09-03','12:10:00',4.12),('14598','2013-09-03','12:15:00',4.15),('14598','2013-09-03','12:20:00',4.15),('14598','2013-09-03','12:25:00',4.19),('14598','2013-09-03','12:30:00',4.24),('14598','2013-09-03','12:35:00',4.26),('14598','2013-09-03','12:40:00',4.3),('14598','2013-09-03','12:45:00',4.29),('14598','2013-09-03','12:50:00',4.24),('14598','2013-09-03','12:55:00',4.32),('14598','2013-09-03','13:00:00',4.31),('14598','2013-09-03','13:05:00',4.41),('14598','2013-09-03','13:10:00',4.49),('14598','2013-09-03','13:15:00',4.45),('14598','2013-09-03','13:20:00',4.35),('14598','2013-09-03','13:25:00',4.44),('14598','2013-09-03','13:30:00',4.46),('14598','2013-09-03','13:35:00',4.47),('14598','2013-09-03','13:40:00',4.49),('14598','2013-09-03','13:45:00',4.49),('14598','2013-09-03','13:50:00',4.42),('14598','2013-09-03','13:55:00',4.43),('14598','2013-09-03','14:00:00',4.42),('14598','2013-09-03','14:05:00',4.44),('14598','2013-09-03','14:10:00',4.42),('14598','2013-09-03','14:15:00',4.37),('14598','2013-09-03','14:20:00',4.34),('14598','2013-09-03','14:25:00',4.3),('14598','2013-09-03','14:30:00',4.32),('14598','2013-09-03','14:35:00',4.43),('14598','2013-09-03','14:40:00',4.42),('14598','2013-09-03','14:45:00',4.38),('14598','2013-09-03','14:50:00',4.33),('14598','2013-09-03','14:55:00',4.32),('14598','2013-09-03','15:00:00',4.3),('14598','2013-09-03','15:05:00',4.29),('14598','2013-09-03','15:10:00',4.24),('14598','2013-09-03','15:15:00',4.19),('14598','2013-09-03','15:20:00',4.15),('14598','2013-09-03','15:25:00',4.11),('14598','2013-09-03','15:30:00',4.08),('14598','2013-09-03','15:35:00',4.03),('14598','2013-09-03','15:40:00',3.99),('14598','2013-09-03','15:45:00',3.97),('14598','2013-09-03','15:50:00',3.95),('14598','2013-09-03','15:55:00',3.84),('14598','2013-09-03','16:00:00',3.8),('14598','2013-09-03','16:05:00',3.72),('14598','2013-09-03','16:10:00',3.62),('14598','2013-09-03','16:15:00',3.59),('14598','2013-09-03','16:20:00',3.52),('14598','2013-09-03','16:25:00',3.47),('14598','2013-09-03','16:30:00',3.4),('14598','2013-09-03','16:35:00',3.33),('14598','2013-09-03','16:40:00',3.21),('14598','2013-09-03','16:45:00',3.14),('14598','2013-09-03','16:50:00',3.08),('14598','2013-09-03','16:55:00',3),('14598','2013-09-03','17:00:00',2.92),('14598','2013-09-03','17:05:00',2.83),('14598','2013-09-03','17:10:00',2.75),('14598','2013-09-03','17:15:00',2.63),('14598','2013-09-03','17:20:00',2.54),('14598','2013-09-03','17:25:00',2.45),('14598','2013-09-03','17:30:00',2.36),('14598','2013-09-03','17:35:00',2.28),('14598','2013-09-03','17:40:00',2.16),('14598','2013-09-03','17:45:00',2.07),('14598','2013-09-03','17:50:00',1.97),('14598','2013-09-03','17:55:00',1.86),('14598','2013-09-03','18:00:00',1.75),('14598','2013-09-03','18:05:00',1.62),('14598','2013-09-03','18:10:00',1.52),('14598','2013-09-03','18:15:00',1.42),('14598','2013-09-03','18:20:00',1.31),('14598','2013-09-03','18:25:00',1.19),('14598','2013-09-03','18:30:00',1.08),('14598','2013-09-02','08:35:00',1.06),('14598','2013-09-02','08:40:00',1.17),('14598','2013-09-02','08:45:00',1.28),('14598','2013-09-02','08:50:00',1.38),('14598','2013-09-02','08:55:00',1.47),('14598','2013-09-02','09:00:00',1.58),('14598','2013-09-02','09:05:00',1.67),('14598','2013-09-02','09:10:00',1.78),('14598','2013-09-02','09:15:00',1.89),('14598','2013-09-02','09:20:00',2.01),('14598','2013-09-02','09:25:00',2.11),('14598','2013-09-02','09:30:00',2.2),('14598','2013-09-02','09:35:00',2.3),('14598','2013-09-02','09:40:00',2.39),('14598','2013-09-02','09:45:00',2.48),('14598','2013-09-02','09:50:00',2.57),('14598','2013-09-02','09:55:00',2.66),('14598','2013-09-02','10:00:00',2.75),('14598','2013-09-02','10:05:00',2.83),('14598','2013-09-02','10:10:00',2.92),('14598','2013-09-02','10:15:00',2.99),('14598','2013-09-02','10:20:00',3.06),('14598','2013-09-02','10:25:00',3.14),('14598','2013-09-02','10:30:00',3.21),('14598','2013-09-02','10:35:00',3.24),('14598','2013-09-02','10:40:00',3.34),('14598','2013-09-02','10:45:00',3.41),('14598','2013-09-02','10:50:00',3.47),('14598','2013-09-02','10:55:00',3.54),('14598','2013-09-02','11:00:00',3.59),('14598','2013-09-02','11:05:00',3.65),('14598','2013-09-02','11:10:00',3.7),('14598','2013-09-02','11:15:00',3.76),('14598','2013-09-02','11:20:00',3.8),('14598','2013-09-02','11:25:00',3.86),('14598','2013-09-02','11:30:00',3.9),('14598','2013-09-02','11:35:00',3.95),('14598','2013-09-02','11:40:00',3.99),('14598','2013-09-02','11:45:00',4.03),('14598','2013-09-02','11:50:00',4.04),('14598','2013-09-02','11:55:00',4.09),('14598','2013-09-02','12:00:00',4.14),('14598','2013-09-02','12:05:00',4.17),('14598','2013-09-02','12:10:00',4.22),('14598','2013-09-02','12:15:00',4.26),('14598','2013-09-02','12:20:00',4.24),('14598','2013-09-02','12:25:00',4.27),('14598','2013-09-02','12:30:00',4.27),('14598','2013-09-02','12:35:00',4.28),('14598','2013-09-02','12:40:00',4.31),('14598','2013-09-02','12:45:00',4.29),('14598','2013-09-02','12:50:00',4.3),('14598','2013-09-02','12:55:00',4.32),('14598','2013-09-02','13:00:00',4.36),('14598','2013-09-02','13:05:00',4.41),('14598','2013-09-02','13:10:00',4.46),('14598','2013-09-02','13:15:00',4.46),('14598','2013-09-02','13:20:00',4.51),('14598','2013-09-02','13:25:00',4.52),('14598','2013-09-02','13:30:00',4.56),('14598','2013-09-02','13:35:00',4.53),('14598','2013-09-02','13:40:00',4.63),('14598','2013-09-02','13:45:00',4.64),('14598','2013-09-02','13:50:00',4.62),('14598','2013-09-02','13:55:00',4.64),('14598','2013-09-02','14:00:00',4.63),('14598','2013-09-02','14:05:00',4.62),('14598','2013-09-02','14:10:00',4.6),('14598','2013-09-02','14:15:00',4.6),('14598','2013-09-02','14:20:00',4.59),('14598','2013-09-02','14:25:00',4.57),('14598','2013-09-02','14:30:00',4.56),('14598','2013-09-02','14:35:00',4.53),('14598','2013-09-02','14:40:00',4.51),('14598','2013-09-02','14:45:00',4.47),('14598','2013-09-02','14:50:00',4.44),('14598','2013-09-02','14:55:00',4.4),('14598','2013-09-02','15:00:00',4.37),('14598','2013-09-02','15:05:00',4.33),('14598','2013-09-02','15:10:00',4.31),('14598','2013-09-02','15:15:00',4.29),('14598','2013-09-02','15:20:00',4.25),('14598','2013-09-02','15:25:00',4.24),('14598','2013-09-02','15:30:00',4.2),('14598','2013-09-02','15:35:00',4.13),('14598','2013-09-02','15:40:00',4.08),('14598','2013-09-02','15:45:00',3.99),('14598','2013-09-02','15:50:00',3.93),('14598','2013-09-02','15:55:00',3.91),('14598','2013-09-02','16:00:00',3.83),('14598','2013-09-02','16:05:00',3.78),('14598','2013-09-02','16:10:00',3.71),('14598','2013-09-02','16:15:00',3.64),('14598','2013-09-02','16:20:00',3.55),('14598','2013-09-02','16:25:00',3.49),('14598','2013-09-02','16:30:00',3.43),('14598','2013-09-02','16:35:00',3.35),('14598','2013-09-02','16:40:00',3.32),('14598','2013-09-02','16:45:00',3.27),('14598','2013-09-02','16:50:00',3.14),('14598','2013-09-02','16:55:00',3.03),('14598','2013-09-02','17:00:00',2.95),('14598','2013-09-02','17:05:00',2.86),('14598','2013-09-02','17:10:00',2.77),('14598','2013-09-02','17:15:00',2.69),('14598','2013-09-02','17:20:00',2.59),('14598','2013-09-02','17:25:00',2.5),('14598','2013-09-02','17:30:00',2.39),('14598','2013-09-02','17:35:00',2.29),('14598','2013-09-02','17:40:00',2.18),('14598','2013-09-02','17:45:00',2.08),('14598','2013-09-02','17:50:00',1.96),('14598','2013-09-02','17:55:00',1.85),('14598','2013-09-02','18:00:00',1.75),('14598','2013-09-02','18:05:00',1.63),('14598','2013-09-02','18:10:00',1.5),('14598','2013-09-02','18:15:00',1.38),('14598','2013-09-02','18:20:00',1.24),('14598','2013-09-02','18:25:00',1.17),('14598','2013-09-02','18:30:00',1.06),('14598','2013-09-01','08:35:00',1.09),('14598','2013-09-01','08:40:00',1.2),('14598','2013-09-01','08:45:00',1.29),('14598','2013-09-01','08:50:00',1.39),('14598','2013-09-01','08:55:00',1.5),('14598','2013-09-01','09:00:00',1.59),('14598','2013-09-01','09:05:00',1.71),('14598','2013-09-01','09:10:00',1.82),('14598','2013-09-01','09:15:00',1.94),('14598','2013-09-01','09:20:00',2.05),('14598','2013-09-01','09:25:00',2.14),('14598','2013-09-01','09:30:00',2.24),('14598','2013-09-01','09:35:00',2.33),('14598','2013-09-01','09:40:00',2.41),('14598','2013-09-01','09:45:00',2.51),('14598','2013-09-01','09:50:00',2.59),('14598','2013-09-01','09:55:00',2.67),('14598','2013-09-01','10:00:00',2.75),('14598','2013-09-01','10:05:00',2.85),('14598','2013-09-01','10:10:00',2.95),('14598','2013-09-01','10:15:00',3.03),('14598','2013-09-01','10:20:00',3.11),('14598','2013-09-01','10:25:00',3.17),('14598','2013-09-01','10:30:00',3.24),('14598','2013-09-01','10:35:00',3.31),('14598','2013-09-01','10:40:00',3.39),('14598','2013-09-01','10:45:00',3.44),('14598','2013-09-01','10:50:00',3.49),('14598','2013-09-01','10:55:00',3.57),('14598','2013-09-01','11:00:00',3.64),('14598','2013-09-01','11:05:00',3.69),('14598','2013-09-01','11:10:00',3.71),('14598','2013-09-01','11:15:00',3.78),('14598','2013-09-01','11:20:00',3.83),('14598','2013-09-01','11:25:00',3.87),('14598','2013-09-01','11:30:00',3.94),('14598','2013-09-01','11:35:00',3.96),('14598','2013-09-01','11:40:00',4.02),('14598','2013-09-01','11:45:00',3.98),('14598','2013-09-01','11:50:00',4.11),('14598','2013-09-01','11:55:00',4.06),('14598','2013-09-01','12:00:00',4.13),('14598','2013-09-01','12:05:00',4.11),('14598','2013-09-01','12:10:00',4.09),('14598','2013-09-01','12:15:00',4.29),('14598','2013-09-01','12:20:00',4.33),('14598','2013-09-01','12:25:00',4.33),('14598','2013-09-01','12:30:00',4.34),('14598','2013-09-01','12:35:00',4.33),('14598','2013-09-01','12:40:00',4.42),('14598','2013-09-01','12:45:00',4.46),('14598','2013-09-01','12:50:00',4.41),('14598','2013-09-01','12:55:00',4.17),('14598','2013-09-01','13:00:00',4.62),('14598','2013-09-01','13:05:00',4.61),('14598','2013-09-01','13:10:00',4.69),('14598','2013-09-01','13:15:00',4.64),('14598','2013-09-01','13:20:00',4.24),('14598','2013-09-01','13:25:00',3.58),('14598','2013-09-01','13:30:00',4.66),('14598','2013-09-01','13:35:00',4.6),('14598','2013-09-01','13:40:00',4.59),('14598','2013-09-01','13:45:00',4.36),('14598','2013-09-01','13:50:00',4.41),('14598','2013-09-01','13:55:00',4.39),('14598','2013-09-01','14:00:00',4.43),('14598','2013-09-01','14:05:00',4.44),('14598','2013-09-01','14:10:00',4.3),('14598','2013-09-01','14:15:00',4.02),('14598','2013-09-01','14:20:00',3.55),('14598','2013-09-01','14:25:00',4.06),('14598','2013-09-01','14:30:00',3.69),('14598','2013-09-01','14:35:00',4.17),('14598','2013-09-01','14:40:00',4.01),('14598','2013-09-01','14:45:00',4.26),('14598','2013-09-01','14:50:00',4.33),('14598','2013-09-01','14:55:00',4.29),('14598','2013-09-01','15:00:00',4.28),('14598','2013-09-01','15:05:00',4.27),('14598','2013-09-01','15:10:00',4.2),('14598','2013-09-01','15:15:00',4.2),('14598','2013-09-01','15:20:00',4.21),('14598','2013-09-01','15:25:00',4.24),('14598','2013-09-01','15:30:00',4.11),('14598','2013-09-01','15:35:00',3.92),('14598','2013-09-01','15:40:00',3.82),('14598','2013-09-01','15:45:00',3.61),('14598','2013-09-01','15:50:00',3.55),('14598','2013-09-01','15:55:00',3.37),('14598','2013-09-01','16:00:00',3.5),('14598','2013-09-01','16:05:00',3.54),('14598','2013-09-01','16:10:00',3.26),('14598','2013-09-01','16:15:00',3.02),('14598','2013-09-01','16:20:00',2.66),('14598','2013-09-01','16:25:00',3.1),('14598','2013-09-01','16:30:00',3.19),('14598','2013-09-01','16:35:00',2.99),('14598','2013-09-01','16:40:00',3.06),('14598','2013-09-01','16:45:00',3.12),('14598','2013-09-01','16:50:00',3.08),('14598','2013-09-01','16:55:00',2.95),('14598','2013-09-01','17:00:00',2.86),('14598','2013-09-01','17:05:00',2.72),('14598','2013-09-01','17:10:00',2.41),('14598','2013-09-01','17:15:00',2.4),('14598','2013-09-01','17:20:00',2.45),('14598','2013-09-01','17:25:00',2.51),('14598','2013-09-01','17:30:00',2.39),('14598','2013-09-01','17:35:00',2.35),('14598','2013-09-01','17:40:00',2.38),('14598','2013-09-01','17:45:00',2.18),('14598','2013-09-01','17:50:00',2.14),('14598','2013-09-01','17:55:00',1.94),('14598','2013-09-01','18:00:00',1.76),('14598','2013-09-01','18:05:00',1.9),('14598','2013-09-01','18:10:00',1.74),('14598','2013-09-01','18:15:00',1.5),('14598','2013-09-01','18:20:00',1.37),('14598','2013-09-01','18:25:00',1.52),('14598','2013-09-01','18:30:00',1.4),('14598','2013-09-01','18:35:00',1.26),('14598','2013-09-01','18:40:00',1.13),('14598','2013-08-31','08:30:00',1.02),('14598','2013-08-31','08:35:00',1.17),('14598','2013-08-31','08:40:00',1.34),('14598','2013-08-31','08:45:00',1.55),('14598','2013-08-31','08:50:00',1.65),('14598','2013-08-31','08:55:00',1.41),('14598','2013-08-31','09:05:00',1.65),('14598','2013-08-31','09:10:00',1.84),('14598','2013-08-31','09:15:00',2.14),('14598','2013-08-31','09:20:00',2.21),('14598','2013-08-31','09:25:00',2.35),('14598','2013-08-31','09:30:00',2.33),('14598','2013-08-31','09:35:00',2.22),('14598','2013-08-31','09:40:00',2.42),('14598','2013-08-31','09:45:00',2.62),('14598','2013-08-31','09:50:00',2.71),('14598','2013-08-31','09:55:00',2.71),('14598','2013-08-31','10:00:00',2.84),('14598','2013-08-31','10:05:00',2.88),('14598','2013-08-31','10:10:00',2.92),('14598','2013-08-31','10:15:00',3),('14598','2013-08-31','10:20:00',3.09),('14598','2013-08-31','10:25:00',3.23),('14598','2013-08-31','10:30:00',3.26),('14598','2013-08-31','10:35:00',3.3),('14598','2013-08-31','10:40:00',3.4),('14598','2013-08-31','10:45:00',3.52),('14598','2013-08-31','10:50:00',3.6),('14598','2013-08-31','10:55:00',3.66),('14598','2013-08-31','11:00:00',3.72),('14598','2013-08-31','11:05:00',3.77),('14598','2013-08-31','11:10:00',3.81),('14598','2013-08-31','11:15:00',3.88),('14598','2013-08-31','11:20:00',3.92),('14598','2013-08-31','11:25:00',3.99),('14598','2013-08-31','11:30:00',4.06),('14598','2013-08-31','11:35:00',4.07),('14598','2013-08-31','11:40:00',4.11),('14598','2013-08-31','11:45:00',4.2),('14598','2013-08-31','11:50:00',4.21),('14598','2013-08-31','11:55:00',4.26),('14598','2013-08-31','12:00:00',4.29),('14598','2013-08-31','12:05:00',4.33),('14598','2013-08-31','12:10:00',4.34),('14598','2013-08-31','12:15:00',4.34),('14598','2013-08-31','12:20:00',4.38),('14598','2013-08-31','12:25:00',4.41),('14598','2013-08-31','12:30:00',4.45),('14598','2013-08-31','12:35:00',4.47),('14598','2013-08-31','12:40:00',4.48),('14598','2013-08-31','12:45:00',4.5),('14598','2013-08-31','12:50:00',4.52),('14598','2013-08-31','12:55:00',4.51),('14598','2013-08-31','13:00:00',4.55),('14598','2013-08-31','13:05:00',4.55),('14598','2013-08-31','13:10:00',4.56),('14598','2013-08-31','13:15:00',4.55),('14598','2013-08-31','13:20:00',4.56),('14598','2013-08-31','13:25:00',4.5),('14598','2013-08-31','13:30:00',4.5),('14598','2013-08-31','13:35:00',4.48),('14598','2013-08-31','13:40:00',4.48),('14598','2013-08-31','13:45:00',4.53),('14598','2013-08-31','13:50:00',4.51),('14598','2013-08-31','13:55:00',4.46),('14598','2013-08-31','14:00:00',4.44),('14598','2013-08-31','14:05:00',4.48),('14598','2013-08-31','14:10:00',4.43),('14598','2013-08-31','14:15:00',4.37),('14598','2013-08-31','14:20:00',4.34),('14598','2013-08-31','14:25:00',4.32),('14598','2013-08-31','14:30:00',4.26),('14598','2013-08-31','14:35:00',4.22),('14598','2013-08-31','14:40:00',4.2),('14598','2013-08-31','14:45:00',4.22),('14598','2013-08-31','14:50:00',4.21),('14598','2013-08-31','14:55:00',4.16),('14598','2013-08-31','15:00:00',4.18),('14598','2013-08-31','15:05:00',4.15),('14598','2013-08-31','15:10:00',4.1),('14598','2013-08-31','15:15:00',4.1),('14598','2013-08-31','15:20:00',4.12),('14598','2013-08-31','15:25:00',4.12),('14598','2013-08-31','15:30:00',4.13),('14598','2013-08-31','15:35:00',4.07),('14598','2013-08-31','15:40:00',4.02),('14598','2013-08-31','15:45:00',3.98),('14598','2013-08-31','15:50:00',3.94),('14598','2013-08-31','15:55:00',3.79),('14598','2013-08-31','16:00:00',3.71),('14598','2013-08-31','16:05:00',3.69),('14598','2013-08-31','16:10:00',3.66),('14598','2013-08-31','16:15:00',3.65),('14598','2013-08-31','16:20:00',3.58),('14598','2013-08-31','16:25:00',3.53),('14598','2013-08-31','16:30:00',3.4),('14598','2013-08-31','16:35:00',3.36),('14598','2013-08-31','16:40:00',3.23),('14598','2013-08-31','16:45:00',3.2),('14598','2013-08-31','16:50:00',3.11),('14598','2013-08-31','16:55:00',3.04),('14598','2013-08-31','17:00:00',3.01),('14598','2013-08-31','17:05:00',2.92),('14598','2013-08-31','17:10:00',2.88),('14598','2013-08-31','17:15:00',2.72),('14598','2013-08-31','17:20:00',2.55),('14598','2013-08-31','17:25:00',2.52),('14598','2013-08-31','17:30:00',2.44),('14598','2013-08-31','17:35:00',2.28),('14598','2013-08-31','17:40:00',1.72),('14598','2013-08-31','17:45:00',1.72),('14598','2013-08-31','17:50:00',1.53),('14598','2013-08-31','17:55:00',1.74),('14598','2013-08-31','18:00:00',1.51),('14598','2013-08-31','18:05:00',1.38),('14598','2013-08-30','08:15:00',1),('14598','2013-08-30','08:20:00',1.05),('14598','2013-08-30','08:25:00',1.12),('14598','2013-08-30','08:30:00',1.23),('14598','2013-08-30','08:35:00',1.2),('14598','2013-08-30','08:40:00',1.13),('14598','2013-08-30','08:45:00',1.18),('14598','2013-08-30','08:50:00',1.35),('14598','2013-08-30','08:55:00',1.46),('14598','2013-08-30','09:00:00',1.37),('14598','2013-08-30','09:05:00',1.24),('14598','2013-08-30','09:10:00',1.13),('14598','2013-08-30','09:15:00',1.17),('14598','2013-08-30','09:20:00',1.43),('14598','2013-08-30','09:25:00',1.67),('14598','2013-08-30','09:30:00',1.74),('14598','2013-08-30','09:35:00',1.66),('14598','2013-08-30','09:40:00',1.81),('14598','2013-08-30','09:45:00',1.87),('14598','2013-08-30','09:50:00',1.83),('14598','2013-08-30','09:55:00',1.8),('14598','2013-08-30','10:00:00',1.89),('14598','2013-08-30','10:05:00',1.97),('14598','2013-08-30','10:10:00',1.96),('14598','2013-08-30','10:15:00',2.02),('14598','2013-08-30','10:20:00',2.26),('14598','2013-08-30','10:25:00',2.18),('14598','2013-08-30','10:30:00',2.13),('14598','2013-08-30','10:35:00',2.15),('14598','2013-08-30','10:40:00',2.23),('14598','2013-08-30','10:45:00',2.14),('14598','2013-08-30','10:50:00',2.18),('14598','2013-08-30','10:55:00',2.33),('14598','2013-08-30','11:00:00',2.55),('14598','2013-08-30','11:05:00',2.54),('14598','2013-08-30','11:10:00',2.52),('14598','2013-08-30','11:15:00',2.67),('14598','2013-08-30','11:20:00',2.86),('14598','2013-08-30','11:25:00',2.76),('14598','2013-08-30','11:30:00',2.84),('14598','2013-08-30','11:35:00',2.87),('14598','2013-08-30','11:40:00',3.03),('14598','2013-08-30','11:45:00',2.98),('14598','2013-08-30','11:50:00',2.71),('14598','2013-08-30','11:55:00',2.67),('14598','2013-08-30','12:00:00',3.15),('14598','2013-08-30','12:05:00',2.72),('14598','2013-08-30','12:10:00',3.14),('14598','2013-08-30','12:15:00',3.38),('14598','2013-08-30','12:20:00',3.44),('14598','2013-08-30','12:25:00',3.46),('14598','2013-08-30','12:30:00',3.44),('14598','2013-08-30','12:35:00',3.41),('14598','2013-08-30','12:40:00',3.24),('14598','2013-08-30','12:45:00',3.19),('14598','2013-08-30','12:50:00',3.1),('14598','2013-08-30','12:55:00',2.83),('14598','2013-08-30','13:00:00',2.9),('14598','2013-08-30','13:05:00',3.11),('14598','2013-08-30','13:10:00',3.2),('14598','2013-08-30','13:15:00',4.21),('14598','2013-08-30','13:20:00',4.46),('14598','2013-08-30','13:25:00',4.09),('14598','2013-08-30','13:30:00',3.96),('14598','2013-08-30','13:35:00',3.04),('14598','2013-08-30','13:40:00',2.94),('14598','2013-08-30','13:45:00',4.57),('14598','2013-08-30','13:50:00',4.44),('14598','2013-08-30','13:55:00',4.79),('14598','2013-08-30','14:00:00',4.74),('14598','2013-08-30','14:05:00',4.16),('14598','2013-08-30','14:10:00',4.46),('14598','2013-08-30','14:15:00',4.08),('14598','2013-08-30','14:20:00',4.04),('14598','2013-08-30','14:25:00',4.32),('14598','2013-08-30','14:30:00',4.11),('14598','2013-08-30','14:35:00',3.76),('14598','2013-08-30','14:40:00',3.45),('14598','2013-08-30','14:45:00',3.44),('14598','2013-08-30','14:50:00',4.14),('14598','2013-08-30','14:55:00',4.01),('14598','2013-08-30','15:00:00',3.47),('14598','2013-08-30','15:05:00',3.45),('14598','2013-08-30','15:10:00',3.46),('14598','2013-08-30','15:15:00',3.51),('14598','2013-08-30','15:20:00',3.43),('14598','2013-08-30','15:25:00',3.62),('14598','2013-08-30','15:30:00',3.59),('14598','2013-08-30','15:35:00',3.08),('14598','2013-08-30','15:40:00',2.79),('14598','2013-08-30','15:45:00',2.58),('14598','2013-08-30','15:50:00',2.54),('14598','2013-08-30','15:55:00',2.74),('14598','2013-08-30','16:00:00',2.88),('14598','2013-08-30','16:05:00',2.81),('14598','2013-08-30','16:10:00',2.56),('14598','2013-08-30','16:15:00',2.12),('14598','2013-08-30','16:20:00',2.4),('14598','2013-08-30','16:25:00',2.88),('14598','2013-08-30','16:30:00',2.95),('14598','2013-08-30','16:35:00',2.83),('14598','2013-08-30','16:40:00',2.94),('14598','2013-08-30','16:45:00',2.57),('14598','2013-08-30','16:50:00',2.16),('14598','2013-08-30','16:55:00',2.37),('14598','2013-08-30','17:00:00',2.7),('14598','2013-08-30','17:05:00',2.43),('14598','2013-08-30','17:10:00',2.29),('14598','2013-08-30','17:15:00',2.2),('14598','2013-08-30','17:20:00',2.03),('14598','2013-08-30','17:25:00',2.25),('14598','2013-08-30','17:30:00',2.53),('14598','2013-08-30','17:35:00',2.48),('14598','2013-08-30','17:40:00',2.01),('14598','2013-08-30','17:45:00',1.79),('14598','2013-08-30','17:50:00',1.72),('14598','2013-08-30','17:55:00',1.77),('14598','2013-08-30','18:00:00',1.21),('14598','2014-04-11','08:30:00',1.07),('14598','2014-04-11','08:45:00',1.4),('14598','2014-04-11','08:50:00',1.54),('14598','2014-04-11','08:55:00',1.66),('14598','2014-04-11','09:00:00',1.73),('14598','2014-04-11','09:05:00',1.73),('14598','2014-04-11','09:10:00',1.92),('14598','2014-04-11','09:15:00',2.04),('14598','2014-04-11','09:20:00',2.15),('14598','2014-04-11','09:25:00',2.12),('14598','2014-04-11','09:30:00',2.39),('14598','2014-04-11','09:35:00',2.5),('14598','2014-04-11','09:40:00',2.6),('14598','2014-04-11','09:45:00',2.71),('14598','2014-04-11','09:50:00',2.75),('14598','2014-04-11','09:55:00',2.78),('14598','2014-04-11','10:00:00',2.88),('14598','2014-04-11','10:05:00',3.03),('14598','2014-04-11','10:10:00',3.13),('14598','2014-04-11','10:15:00',3.19),('14598','2014-04-11','10:20:00',3.28),('14598','2014-04-11','10:25:00',3.38),('14598','2014-04-11','10:30:00',3.51),('14598','2014-04-11','10:35:00',3.23),('14598','2014-04-11','10:40:00',2.77),('14598','2014-04-11','10:45:00',2.13),('14598','2014-04-11','10:50:00',2.55),('14598','2014-04-11','10:55:00',3.85),('14598','2014-04-11','11:00:00',3.1),('14598','2014-04-11','11:05:00',2.74),('14598','2014-04-11','11:10:00',4.09),('14598','2014-04-11','11:15:00',3.52),('14598','2014-04-11','11:20:00',3.1),('14598','2014-04-11','11:25:00',3.01),('14598','2014-04-11','11:30:00',3.1),('14598','2014-04-11','11:35:00',4.66),('14598','2014-04-11','11:40:00',4.22),('14598','2014-04-11','11:45:00',4.38),('14598','2014-04-11','11:50:00',4.1),('14598','2014-04-11','11:55:00',3.46),('14598','2014-04-11','12:00:00',3.03),('14598','2014-04-11','12:05:00',5.09),('14598','2014-04-11','12:10:00',5.23),('14598','2014-04-11','12:15:00',3.52),('14598','2014-04-11','12:20:00',4.5),('14598','2014-04-11','12:25:00',4.58),('14598','2014-04-11','12:30:00',3.71),('14598','2014-04-11','12:35:00',4.47),('14598','2014-04-11','12:40:00',5.08),('14598','2014-04-11','12:45:00',5.47),('14598','2014-04-11','12:50:00',3.23),('14598','2014-04-11','12:55:00',2.41),('14598','2014-04-11','13:00:00',4),('14598','2014-04-11','13:05:00',4.74),('14598','2014-04-11','13:10:00',5.4),('14598','2014-04-11','13:15:00',5.17),('14598','2014-04-11','13:20:00',4.05),('14598','2014-04-11','13:25:00',2.46),('14598','2014-04-11','13:30:00',5.11),('14598','2014-04-11','13:35:00',5.78),('14598','2014-04-11','13:40:00',3.49),('14598','2014-04-11','13:45:00',2.97),('14598','2014-04-11','13:50:00',4.49),('14598','2014-04-11','13:55:00',3.3),('14598','2014-04-11','14:00:00',3.74),('14598','2014-04-11','14:05:00',2.21),('14598','2014-04-11','14:10:00',4.63),('14598','2014-04-11','14:15:00',3.92),('14598','2014-04-11','14:20:00',3.72),('14598','2014-04-11','14:25:00',1.85),('14598','2014-04-11','14:30:00',3.83),('14598','2014-04-11','14:35:00',2.2),('14598','2014-04-11','14:40:00',4.06),('14598','2014-04-11','14:45:00',5.8),('14598','2014-04-11','14:50:00',5.4),('14598','2014-04-11','14:55:00',5.36),('14598','2014-04-11','15:00:00',3.98),('14598','2014-04-11','15:05:00',4.51),('14598','2014-04-11','15:10:00',3.58),('14598','2014-04-11','15:15:00',2.53),('14598','2014-04-11','15:20:00',3.64),('14598','2014-04-11','15:25:00',2.32),('14598','2014-04-11','15:30:00',3.64),('14598','2014-04-11','15:35:00',1.94),('14598','2014-04-11','15:40:00',2.66),('14598','2014-04-11','15:45:00',3.75),('14598','2014-04-11','15:50:00',3.15),('14598','2014-04-11','15:55:00',3.48),('14598','2014-04-11','16:00:00',1.68),('14598','2014-04-11','16:05:00',1.65),('14598','2014-04-11','16:10:00',2.95),('14598','2014-04-11','16:15:00',3.15),('14598','2014-04-11','16:20:00',1.82),('14598','2014-04-11','16:25:00',2.3),('14598','2014-04-11','16:30:00',2.5),('14598','2014-04-11','16:35:00',1.33),('14598','2014-04-11','16:40:00',2.13),('14598','2014-04-11','16:45:00',1.22),('14598','2014-04-11','16:50:00',1.28),('14598','2014-04-11','16:55:00',2.47),('14598','2014-04-11','17:00:00',2.53),('14598','2014-04-11','17:05:00',2.54),('14598','2014-04-11','17:10:00',3.06),('14598','2014-04-11','17:15:00',1.87),('14598','2014-04-11','17:20:00',3.1),('14598','2014-04-11','17:25:00',1.54),('14598','2014-04-11','17:30:00',1.26),('14598','2014-04-11','17:35:00',1.11),('14598','2014-04-11','17:40:00',1.21),('14598','2014-04-11','17:45:00',1.25),('14598','2014-04-11','17:50:00',1.43),('14598','2014-04-11','17:55:00',1.05),('14598','2014-04-11','18:45:00',1.11),('14598','2013-08-29','08:20:00',1.17),('14598','2013-08-29','08:25:00',1.31),('14598','2013-08-29','08:30:00',1.15),('14598','2013-08-29','08:35:00',1.11),('14598','2013-08-29','08:40:00',1.17),('14598','2013-08-29','08:45:00',1.27),('14598','2013-08-29','08:50:00',1.36),('14598','2013-08-29','08:55:00',1.3),('14598','2013-08-29','09:00:00',1.32),('14598','2013-08-29','09:05:00',1.32),('14598','2013-08-29','09:10:00',1.39),('14598','2013-08-29','09:15:00',1.48),('14598','2013-08-29','09:20:00',1.53),('14598','2013-08-29','09:25:00',1.61),('14598','2013-08-29','09:30:00',1.58),('14598','2013-08-29','09:35:00',1.44),('14598','2013-08-29','09:40:00',1.36),('14598','2013-08-29','09:45:00',1.33),('14598','2013-08-29','09:50:00',1.34),('14598','2013-08-29','09:55:00',1.36),('14598','2013-08-29','10:00:00',1.35),('14598','2013-08-29','10:05:00',1.39),('14598','2013-08-29','10:10:00',1.48),('14598','2013-08-29','10:15:00',1.51),('14598','2013-08-29','10:20:00',1.46),('14598','2013-08-29','10:25:00',1.36),('14598','2013-08-29','10:30:00',1.27),('14598','2013-08-29','10:35:00',1.32),('14598','2013-08-29','10:40:00',1.5),('14598','2013-08-29','10:45:00',1.72),('14598','2013-08-29','10:50:00',1.67),('14598','2013-08-29','10:55:00',1.78),('14598','2013-08-29','11:00:00',1.85),('14598','2013-08-29','11:05:00',1.57),('14598','2013-08-29','11:10:00',1.38),('14598','2013-08-29','11:15:00',1.3),('14598','2013-08-29','11:20:00',1.33),('14598','2013-08-29','11:25:00',1.5),('14598','2013-08-29','11:30:00',1.73),('14598','2013-08-29','11:35:00',1.93),('14598','2013-08-29','11:40:00',2.12),('14598','2013-08-29','11:45:00',2.46),('14598','2013-08-29','11:50:00',2.75),('14598','2013-08-29','11:55:00',3.09),('14598','2013-08-29','12:00:00',2.72),('14598','2013-08-29','12:05:00',2.44),('14598','2013-08-29','12:10:00',2.32),('14598','2013-08-29','12:15:00',2.64),('14598','2013-08-29','12:20:00',4.73),('14598','2013-08-29','12:25:00',5.2),('14598','2013-08-29','12:30:00',5.53),('14598','2013-08-29','12:35:00',4.2),('14598','2013-08-29','12:40:00',3.51),('14598','2013-08-29','12:45:00',2.67),('14598','2013-08-29','12:50:00',2.37),('14598','2013-08-29','12:55:00',2.19),('14598','2013-08-29','13:00:00',2.19),('14598','2013-08-29','13:05:00',2.17),('14598','2013-08-29','13:10:00',1.95),('14598','2013-08-29','13:15:00',1.72),('14598','2013-08-29','13:20:00',1.69),('14598','2013-08-29','13:25:00',1.73),('14598','2013-08-29','13:30:00',1.83),('14598','2013-08-29','13:35:00',1.86),('14598','2013-08-29','13:40:00',2.19),('14598','2013-08-29','13:45:00',2.75),('14598','2013-08-29','13:50:00',2.49),('14598','2013-08-29','13:55:00',2.01),('14598','2013-08-29','14:00:00',1.41),('14598','2013-08-29','14:05:00',1.44),('14598','2013-08-29','14:10:00',1.38),('14598','2013-08-29','14:15:00',1.32),('14598','2013-08-29','14:20:00',1.39),('14598','2013-08-29','14:25:00',1.55),('14598','2013-08-29','14:30:00',1.59),('14598','2013-08-29','14:35:00',1.8),('14598','2013-08-29','14:40:00',3.08),('14598','2013-08-29','14:45:00',3.41),('14598','2013-08-29','14:50:00',3.36),('14598','2013-08-29','14:55:00',1.81),('14598','2013-08-29','15:00:00',1.85),('14598','2013-08-29','15:05:00',1.85),('14598','2013-08-29','15:10:00',2.18),('14598','2013-08-29','15:15:00',2.16),('14598','2013-08-29','15:20:00',2.15),('14598','2013-08-29','15:25:00',2.6),('14598','2013-08-29','15:30:00',2.86),('14598','2013-08-29','15:35:00',2.56),('14598','2013-08-29','15:40:00',3.2),('14598','2013-08-29','15:45:00',4.22),('14598','2013-08-29','15:50:00',4.49),('14598','2013-08-29','15:55:00',4.07),('14598','2013-08-29','16:00:00',3.93),('14598','2013-08-29','16:05:00',3.96),('14598','2013-08-29','16:10:00',3.86),('14598','2013-08-29','16:15:00',3.83),('14598','2013-08-29','16:20:00',3.77),('14598','2013-08-29','16:25:00',3.68),('14598','2013-08-29','16:30:00',3.6),('14598','2013-08-29','16:35:00',3.53),('14598','2013-08-29','16:40:00',3.46),('14598','2013-08-29','16:45:00',3.37),('14598','2013-08-29','16:50:00',3.28),('14598','2013-08-29','16:55:00',3.18),('14598','2013-08-29','17:00:00',3.07),('14598','2013-08-29','17:05:00',3.02),('14598','2013-08-29','17:10:00',2.92),('14598','2013-08-29','17:15:00',2.82),('14598','2013-08-29','17:20:00',2.72),('14598','2013-08-29','17:25:00',2.63),('14598','2013-08-29','17:30:00',2.53),('14598','2013-08-29','17:35:00',2.43),('14598','2013-08-29','17:40:00',2.33),('14598','2013-08-29','17:45:00',2.24),('14598','2013-08-29','17:50:00',2.14),('14598','2013-08-29','17:55:00',2.02),('14598','2013-08-29','18:00:00',1.92),('14598','2013-08-29','18:05:00',1.82),('14598','2013-08-29','18:10:00',1.71),('14598','2013-08-29','18:15:00',1.59),('14598','2013-08-29','18:20:00',1.49),('14598','2013-08-29','18:25:00',1.38),('14598','2013-08-29','18:30:00',1.28),('14598','2013-08-29','18:35:00',1.17),('14598','2013-08-29','18:40:00',1.05),('14598','2013-08-28','08:30:00',1.02),('14598','2013-08-28','08:35:00',1.16),('14598','2013-08-28','08:40:00',1.26),('14598','2013-08-28','08:45:00',1.37),('14598','2013-08-28','08:50:00',1.43),('14598','2013-08-28','08:55:00',1.54),('14598','2013-08-28','09:00:00',1.62),('14598','2013-08-28','09:05:00',1.78),('14598','2013-08-28','09:10:00',1.88),('14598','2013-08-28','09:15:00',2),('14598','2013-08-28','09:20:00',2.12),('14598','2013-08-28','09:25:00',2.23),('14598','2013-08-28','09:30:00',2.31),('14598','2013-08-28','09:35:00',2.4),('14598','2013-08-28','09:40:00',2.5),('14598','2013-08-28','09:45:00',2.58),('14598','2013-08-28','09:50:00',2.67),('14598','2013-08-28','09:55:00',2.75),('14598','2013-08-28','10:00:00',2.85),('14598','2013-08-28','10:05:00',2.93),('14598','2013-08-28','10:10:00',2.99),('14598','2013-08-28','10:15:00',3.08),('14598','2013-08-28','10:20:00',3.1),('14598','2013-08-28','10:25:00',3.18),('14598','2013-08-28','10:30:00',3.27),('14598','2013-08-28','10:35:00',3.33),('14598','2013-08-28','10:40:00',3.42),('14598','2013-08-28','10:45:00',2.81),('14598','2013-08-28','10:50:00',3.64),('14598','2013-08-28','10:55:00',3.71),('14598','2013-08-28','11:00:00',3.75),('14598','2013-08-28','11:05:00',3.81),('14598','2013-08-28','11:10:00',3.87),('14598','2013-08-28','11:15:00',3.94),('14598','2013-08-28','11:20:00',4),('14598','2013-08-28','11:25:00',4.05),('14598','2013-08-28','11:30:00',4.1),('14598','2013-08-28','11:35:00',4.18),('14598','2013-08-28','11:40:00',4.22),('14598','2013-08-28','11:45:00',4.27),('14598','2013-08-28','11:50:00',4.31),('14598','2013-08-28','11:55:00',4.37),('14598','2013-08-28','12:00:00',4.4),('14598','2013-08-28','12:05:00',4.42),('14598','2013-08-28','12:10:00',4.47),('14598','2013-08-28','12:15:00',4.51),('14598','2013-08-28','12:20:00',4.53),('14598','2013-08-28','12:25:00',4.56),('14598','2013-08-28','12:30:00',4.59),('14598','2013-08-28','12:35:00',4.6),('14598','2013-08-28','12:40:00',4.64),('14598','2013-08-28','12:45:00',4.11),('14598','2013-08-28','12:50:00',4.72),('14598','2013-08-28','12:55:00',4.62),('14598','2013-08-28','13:00:00',4.48),('14598','2013-08-28','13:05:00',4.81),('14598','2013-08-28','13:10:00',4.83),('14598','2013-08-28','13:15:00',4.88),('14598','2013-08-28','13:20:00',4.84),('14598','2013-08-28','13:25:00',4.58),('14598','2013-08-28','13:30:00',4.9),('14598','2013-08-28','13:35:00',4.87),('14598','2013-08-28','13:40:00',4.88),('14598','2013-08-28','13:45:00',4.87),('14598','2013-08-28','13:50:00',4.88),('14598','2013-08-28','13:55:00',4.88),('14598','2013-08-28','14:00:00',4.87),('14598','2013-08-28','14:05:00',4.87),('14598','2013-08-28','14:10:00',4.79),('14598','2013-08-28','14:15:00',4.85),('14598','2013-08-28','14:20:00',4.78),('14598','2013-08-28','14:25:00',4.81),('14598','2013-08-28','14:30:00',4.78),('14598','2013-08-28','14:35:00',4.78),('14598','2013-08-28','14:40:00',4.75),('14598','2013-08-28','14:45:00',4.73),('14598','2013-08-28','14:50:00',4.69),('14598','2013-08-28','14:55:00',4.65),('14598','2013-08-28','15:00:00',4.63),('14598','2013-08-28','15:05:00',4.61),('14598','2013-08-28','15:10:00',4.58),('14598','2013-08-28','15:15:00',4.52),('14598','2013-08-28','15:20:00',4.46),('14598','2013-08-28','15:25:00',4.42),('14598','2013-08-28','15:30:00',4.39),('14598','2013-08-28','15:35:00',4.35),('14598','2013-08-28','15:40:00',4.3),('14598','2013-08-28','15:45:00',4.26),('14598','2013-08-28','15:50:00',4.21),('14598','2013-08-28','15:55:00',4.18),('14598','2013-08-28','16:00:00',4.12),('14598','2013-08-28','16:05:00',4.04),('14598','2013-08-28','16:10:00',3.97),('14598','2013-08-28','16:15:00',3.88),('14598','2013-08-28','16:20:00',3.8),('14598','2013-08-28','16:25:00',3.48),('14598','2013-08-28','16:30:00',3.59),('14598','2013-08-28','16:35:00',3.75),('14598','2013-08-28','16:40:00',3.52),('14598','2013-08-28','16:45:00',3.45),('14598','2013-08-28','16:50:00',3.36),('14598','2013-08-28','16:55:00',3.3),('14598','2013-08-28','17:00:00',3.19),('14598','2013-08-28','17:05:00',3.1),('14598','2013-08-28','17:10:00',3.03),('14598','2013-08-28','17:15:00',2.97),('14598','2013-08-28','17:20:00',2.29),('14598','2013-08-28','17:25:00',3.01),('14598','2013-08-28','17:30:00',2.42),('14598','2013-08-28','17:35:00',1.84),('14598','2013-08-28','17:40:00',2.14),('14598','2013-08-28','17:45:00',2.71),('14598','2013-08-28','17:55:00',1.34),('14598','2013-08-28','18:00:00',2.32),('14598','2013-08-28','18:05:00',1.21),('14598','2013-08-28','18:10:00',1.38),('14598','2013-08-28','18:15:00',1.9),('14598','2013-08-28','18:20:00',1.63),('14598','2013-08-28','18:30:00',1.26),('14598','2013-08-28','18:35:00',1.32),('14598','2013-08-28','18:45:00',1.03),('14598','2013-08-27','08:45:00',1.06),('14598','2013-08-27','08:50:00',1.32),('14598','2013-08-27','08:55:00',1.35),('14598','2013-08-27','09:00:00',1.48),('14598','2013-08-27','09:05:00',1.58),('14598','2013-08-27','09:10:00',1.87),('14598','2013-08-27','09:15:00',1.98),('14598','2013-08-27','09:20:00',2.09),('14598','2013-08-27','09:25:00',2.1),('14598','2013-08-27','09:30:00',1.81),('14598','2013-08-27','09:35:00',1.56),('14598','2013-08-27','09:40:00',1.73),('14598','2013-08-27','09:45:00',2.29),('14598','2013-08-27','09:50:00',2.64),('14598','2013-08-27','09:55:00',2.73),('14598','2013-08-27','10:00:00',2.75),('14598','2013-08-27','10:05:00',2.01),('14598','2013-08-27','10:10:00',2.84),('14598','2013-08-27','10:15:00',2.97),('14598','2013-08-27','10:20:00',3.03),('14598','2013-08-27','10:25:00',3.13),('14598','2013-08-27','10:30:00',3.17),('14598','2013-08-27','10:35:00',3.24),('14598','2013-08-27','10:40:00',3.26),('14598','2013-08-27','10:45:00',3.35),('14598','2013-08-27','10:50:00',3.4),('14598','2013-08-27','10:55:00',3.49),('14598','2013-08-27','11:00:00',3.55),('14598','2013-08-27','11:05:00',3.53),('14598','2013-08-27','11:10:00',3.66),('14598','2013-08-27','11:15:00',3.73),('14598','2013-08-27','11:20:00',3.76),('14598','2013-08-27','11:25:00',3.93),('14598','2013-08-27','11:30:00',3.99),('14598','2013-08-27','11:35:00',2.91),('14598','2013-08-27','11:40:00',4.18),('14598','2013-08-27','11:45:00',4.27),('14598','2013-08-27','11:50:00',4.52),('14598','2013-08-27','11:55:00',3.38),('14598','2013-08-27','12:00:00',4.66),('14598','2013-08-27','12:05:00',4.33),('14598','2013-08-27','12:10:00',3.44),('14598','2013-08-27','12:15:00',2.43),('14598','2013-08-27','12:20:00',3.5),('14598','2013-08-27','12:25:00',4.4),('14598','2013-08-27','12:30:00',4.02),('14598','2013-08-27','12:35:00',3.15),('14598','2013-08-27','12:40:00',2.32),('14598','2013-08-27','12:45:00',1.89),('14598','2013-08-27','12:50:00',1.91),('14598','2013-08-27','12:55:00',2.03),('14598','2013-08-27','13:00:00',2.62),('14598','2013-08-27','13:05:00',2.64),('14598','2013-08-27','13:10:00',2.98),('14598','2013-08-27','13:15:00',3.09),('14598','2013-08-27','13:20:00',2.17),('14598','2013-08-27','13:25:00',1.74),('14598','2013-08-27','13:30:00',2.19),('14598','2013-08-27','13:35:00',2.25),('14598','2013-08-27','13:40:00',2.37),('14598','2013-08-27','13:45:00',2.53),('14598','2013-08-27','13:50:00',3.7),('14598','2013-08-27','13:55:00',4.67),('14598','2013-08-27','14:00:00',3.45),('14598','2013-08-27','14:05:00',2.74),('14598','2013-08-27','14:10:00',2.18),('14598','2013-08-27','14:15:00',1.76),('14598','2013-08-27','14:20:00',1.51),('14598','2013-08-27','14:25:00',1.27),('14598','2013-08-27','15:40:00',2.18),('14598','2013-08-27','15:45:00',2.54),('14598','2013-08-27','15:50:00',2.16),('14598','2013-08-27','15:55:00',3.11),('14598','2013-08-27','16:00:00',4.4),('14598','2013-08-27','16:05:00',4.35),('14598','2013-08-27','16:10:00',4.19),('14598','2013-08-27','16:15:00',3.81),('14598','2013-08-27','16:20:00',3.7),('14598','2013-08-27','16:25:00',3.57),('14598','2013-08-27','16:30:00',1.77),('14598','2013-08-27','16:35:00',3),('14598','2013-08-27','16:40:00',2.06),('14598','2013-08-27','16:45:00',1.36),('14598','2013-08-27','16:50:00',1.24),('14598','2013-08-27','17:00:00',1.02),('14598','2013-08-27','17:30:00',1.13),('14598','2013-08-27','17:35:00',2.69),('14598','2013-08-27','17:40:00',2.21),('14598','2013-08-27','17:45:00',1.08),('14598','2013-08-26','08:30:00',1.06),('14598','2013-08-26','08:35:00',1.16),('14598','2013-08-26','08:40:00',1.27),('14598','2013-08-26','08:45:00',1.37),('14598','2013-08-26','08:50:00',1.45),('14598','2013-08-26','08:55:00',1.54),('14598','2013-08-26','09:00:00',1.65),('14598','2013-08-26','09:05:00',1.77),('14598','2013-08-26','09:10:00',1.88),('14598','2013-08-26','09:15:00',1.99),('14598','2013-08-26','09:20:00',2.09),('14598','2013-08-26','09:25:00',2.18),('14598','2013-08-26','09:30:00',2.26),('14598','2013-08-26','09:35:00',2.35),('14598','2013-08-26','09:40:00',2.45),('14598','2013-08-26','09:45:00',2.53),('14598','2013-08-26','09:50:00',2.62),('14598','2013-08-26','09:55:00',2.7),('14598','2013-08-26','10:00:00',2.78),('14598','2013-08-26','10:05:00',2.86),('14598','2013-08-26','10:10:00',2.95),('14598','2013-08-26','10:15:00',3.01),('14598','2013-08-26','10:20:00',3.07),('14598','2013-08-26','10:25:00',3.06),('14598','2013-08-26','10:30:00',3.21),('14598','2013-08-26','10:35:00',3.3),('14598','2013-08-26','10:40:00',3.35),('14598','2013-08-26','10:45:00',3.44),('14598','2013-08-26','10:50:00',3.53),('14598','2013-08-26','10:55:00',3.6),('14598','2013-08-26','11:00:00',3.65),('14598','2013-08-26','11:05:00',3.74),('14598','2013-08-26','11:10:00',3.8),('14598','2013-08-26','11:15:00',3.85),('14598','2013-08-26','11:20:00',3.91),('14598','2013-08-26','11:25:00',3.93),('14598','2013-08-26','11:30:00',3.96),('14598','2013-08-26','11:35:00',3.99),('14598','2013-08-26','11:40:00',4.03),('14598','2013-08-26','11:45:00',4.06),('14598','2013-08-26','11:50:00',4.12),('14598','2013-08-26','11:55:00',4.13),('14598','2013-08-26','12:00:00',4.15),('14598','2013-08-26','12:05:00',4.16),('14598','2013-08-26','12:10:00',4.14),('14598','2013-08-26','12:15:00',3.17),('14598','2013-08-26','12:20:00',3.38),('14598','2013-08-26','12:25:00',3.19),('14598','2013-08-26','12:30:00',2.89),('14598','2013-08-26','12:35:00',4.35),('14598','2013-08-26','12:40:00',4.17),('14598','2013-08-26','12:45:00',3.84),('14598','2013-08-26','12:50:00',2.55),('14598','2013-08-26','12:55:00',2.2),('14598','2013-08-26','13:00:00',2.41),('14598','2013-08-26','13:05:00',2.8),('14598','2013-08-26','13:10:00',2.73),('14598','2013-08-26','13:15:00',2.77),('14598','2013-08-26','13:20:00',3.11),('14598','2013-08-26','13:25:00',3.43),('14598','2013-08-26','13:30:00',4.19),('14598','2013-08-26','13:35:00',4.02),('14598','2013-08-26','13:40:00',3.92),('14598','2013-08-26','13:45:00',3.37),('14598','2013-08-26','13:50:00',4.91),('14598','2013-08-26','13:55:00',4.18),('14598','2013-08-26','14:00:00',4.63),('14598','2013-08-26','14:05:00',4.12),('14598','2013-08-26','14:10:00',4.36),('14598','2013-08-26','14:15:00',4.72),('14598','2013-08-26','14:20:00',4.57),('14598','2013-08-26','14:25:00',4.53),('14598','2013-08-26','14:30:00',4.11),('14598','2013-08-26','14:35:00',2.95),('14598','2013-08-26','14:40:00',3.91),('14598','2013-08-26','14:45:00',2.33),('14598','2013-08-26','14:50:00',2.56),('14598','2013-08-26','14:55:00',1.58),('14598','2013-08-26','15:00:00',1.2),('14598','2013-08-26','15:15:00',1.07),('14598','2013-08-26','15:20:00',1.1),('14598','2013-08-26','15:25:00',1.13),('14598','2013-08-26','15:30:00',1.84),('14598','2013-08-26','15:35:00',1.37),('14598','2013-08-26','15:40:00',1.66),('14598','2013-08-26','15:45:00',1.78),('14598','2013-08-26','15:50:00',2.31),('14598','2013-08-26','15:55:00',4.42),('14598','2013-08-26','16:00:00',3.95),('14598','2013-08-26','16:05:00',3.74),('14598','2013-08-26','16:10:00',3.3),('14598','2013-08-26','16:15:00',3.41),('14598','2013-08-26','16:20:00',3.51),('14598','2013-08-26','16:25:00',3.22),('14598','2013-08-26','16:30:00',2.49),('14598','2013-08-26','16:35:00',3.26),('14598','2013-08-26','16:40:00',3.2),('14598','2013-08-26','16:45:00',3.11),('14598','2013-08-26','16:50:00',2.91),('14598','2013-08-26','16:55:00',2.6),('14598','2013-08-26','17:00:00',2.91),('14598','2013-08-26','17:05:00',2.79),('14598','2013-08-26','17:10:00',2.43),('14598','2013-08-26','17:15:00',1.33),('14598','2013-08-26','17:20:00',2.04),('14598','2013-08-26','17:25:00',1.58),('14598','2013-08-26','17:30:00',1.28),('14598','2013-08-26','17:35:00',2.35),('14598','2013-08-26','17:40:00',2.5),('14598','2013-08-26','17:45:00',2.14),('14598','2013-08-26','17:50:00',1.99),('14598','2013-08-26','17:55:00',1.83),('14598','2013-08-26','18:00:00',1.7),('14598','2013-08-26','18:05:00',1.61),('14598','2013-08-26','18:10:00',1.51),('14598','2013-08-26','18:15:00',1.42),('14598','2013-08-26','18:20:00',1.3),('14598','2013-08-26','18:25:00',1.2),('14598','2013-08-26','18:30:00',1.1),('14598','2013-08-25','08:50:00',1.3),('14598','2013-08-25','08:55:00',1.92),('14598','2013-08-25','09:00:00',1.93),('14598','2013-08-25','09:05:00',2.19),('14598','2013-08-25','09:10:00',1.41),('14598','2013-08-25','09:15:00',1.18),('14598','2013-08-25','09:20:00',1.21),('14598','2013-08-25','09:25:00',1.2),('14598','2013-08-25','09:30:00',1.04),('14598','2013-08-25','09:35:00',1.63),('14598','2013-08-25','09:40:00',2.08),('14598','2013-08-25','09:45:00',1.55),('14598','2013-08-25','14:50:00',1.13),('14598','2013-08-25','14:55:00',1.36),('14598','2013-08-25','15:00:00',1.46),('14598','2013-08-25','15:05:00',1.62),('14598','2013-08-25','15:10:00',1.99),('14598','2013-08-25','15:15:00',2.92),('14598','2013-08-25','15:20:00',4.67),('14598','2013-08-25','15:25:00',4.73),('14598','2013-08-25','15:30:00',4.28),('14598','2013-08-25','15:35:00',2.37),('14598','2013-08-25','15:40:00',3.65),('14598','2013-08-25','15:45:00',2.68),('14598','2013-08-25','15:50:00',3.39),('14598','2013-08-25','15:55:00',4.41),('14598','2013-08-25','16:00:00',4.06),('14598','2013-08-25','16:05:00',3.89),('14598','2013-08-25','16:10:00',3.78),('14598','2013-08-25','16:15:00',3.68),('14598','2013-08-25','16:20:00',3.66),('14598','2013-08-25','16:25:00',3.52),('14598','2013-08-25','16:30:00',2.34),('14598','2013-08-25','16:35:00',1.91),('14598','2013-08-25','16:40:00',2.98),('14598','2013-08-25','16:45:00',3.71),('14598','2013-08-25','16:50:00',3.47),('14598','2013-08-25','16:55:00',3.33),('14598','2013-08-25','17:00:00',3.21),('14598','2013-08-25','17:05:00',2.98),('14598','2013-08-25','17:10:00',2.9),('14598','2013-08-25','17:15:00',2.77),('14598','2013-08-25','17:20:00',2.68),('14598','2013-08-25','17:25:00',2.25),('14598','2013-08-25','17:30:00',2.16),('14598','2013-08-25','17:35:00',2.24),('14598','2013-08-25','17:40:00',1.48),('14598','2013-08-25','17:50:00',1.34),('14598','2013-08-25','17:55:00',1.28),('14598','2013-08-25','18:00:00',1.51),('14598','2013-08-25','18:05:00',1.71),('14598','2013-08-25','18:10:00',1.73),('14598','2013-08-25','18:15:00',1.29),('14598','2013-08-25','18:20:00',1.17),('14598','2013-08-24','08:30:00',1.01),('14598','2013-08-24','08:35:00',1.09),('14598','2013-08-24','08:40:00',1.19),('14598','2013-08-24','08:45:00',1.28),('14598','2013-08-24','08:50:00',1.36),('14598','2013-08-24','08:55:00',1.41),('14598','2013-08-24','09:00:00',1.53),('14598','2013-08-24','09:05:00',1.65),('14598','2013-08-24','09:10:00',1.74),('14598','2013-08-24','09:15:00',1.87),('14598','2013-08-24','09:20:00',1.97),('14598','2013-08-24','09:25:00',2.04),('14598','2013-08-24','09:30:00',2.13),('14598','2013-08-24','09:35:00',2.21),('14598','2013-08-24','09:40:00',2.29),('14598','2013-08-24','09:45:00',2.34),('14598','2013-08-24','09:50:00',2.39),('14598','2013-08-24','09:55:00',2.49),('14598','2013-08-24','10:00:00',2.65),('14598','2013-08-24','10:05:00',2.73),('14598','2013-08-24','10:10:00',2.78),('14598','2013-08-24','10:15:00',2.89),('14598','2013-08-24','10:20:00',2.93),('14598','2013-08-24','10:25:00',3.03),('14598','2013-08-24','10:30:00',3.11),('14598','2013-08-24','10:35:00',3.2),('14598','2013-08-24','10:40:00',3.27),('14598','2013-08-24','10:45:00',3.33),('14598','2013-08-24','10:50:00',3.4),('14598','2013-08-24','10:55:00',3.48),('14598','2013-08-24','11:00:00',3.54),('14598','2013-08-24','11:05:00',3.59),('14598','2013-08-24','11:10:00',3.64),('14598','2013-08-24','11:15:00',3.72),('14598','2013-08-24','11:20:00',3.77),('14598','2013-08-24','11:25:00',3.8),('14598','2013-08-24','11:30:00',1.29),('14598','2013-08-24','11:35:00',3.89),('14598','2013-08-24','11:40:00',3.95),('14598','2013-08-24','11:45:00',4.04),('14598','2013-08-24','11:50:00',4.08),('14598','2013-08-24','11:55:00',4.13),('14598','2013-08-24','12:00:00',4.16),('14598','2013-08-24','12:05:00',4.18),('14598','2013-08-24','12:10:00',4.21),('14598','2013-08-24','12:15:00',4.27),('14598','2013-08-24','12:20:00',4.29),('14598','2013-08-24','12:25:00',4.3),('14598','2013-08-24','12:30:00',4.36),('14598','2013-08-24','12:35:00',4.38),('14598','2013-08-24','12:40:00',4.4),('14598','2013-08-24','12:45:00',4.42),('14598','2013-08-24','12:50:00',4.42),('14598','2013-08-24','12:55:00',4.45),('14598','2013-08-24','13:00:00',4.45),('14598','2013-08-24','13:05:00',4.48),('14598','2013-08-24','13:10:00',4.5),('14598','2013-08-24','13:15:00',4.53),('14598','2013-08-24','13:20:00',4.54),('14598','2013-08-24','13:25:00',4.53),('14598','2013-08-24','13:30:00',4.53),('14598','2013-08-24','13:35:00',4.53),('14598','2013-08-24','13:40:00',4.54),('14598','2013-08-24','13:45:00',4.52),('14598','2013-08-24','13:50:00',4.55),('14598','2013-08-24','13:55:00',4.54),('14598','2013-08-24','14:00:00',4.54),('14598','2013-08-24','14:05:00',4.51),('14598','2013-08-24','14:10:00',4.5),('14598','2013-08-24','14:15:00',4.48),('14598','2013-08-24','14:20:00',4.5),('14598','2013-08-24','14:25:00',4.49),('14598','2013-08-24','14:30:00',4.47),('14598','2013-08-24','14:35:00',4.45),('14598','2013-08-24','14:40:00',4.44),('14598','2013-08-24','14:45:00',4.42),('14598','2013-08-24','14:50:00',4.39),('14598','2013-08-24','14:55:00',4.33),('14598','2013-08-24','15:00:00',4.3),('14598','2013-08-24','15:05:00',4.3),('14598','2013-08-24','15:10:00',4.29),('14598','2013-08-24','15:15:00',4.25),('14598','2013-08-24','15:20:00',4.21),('14598','2013-08-24','15:25:00',4.15),('14598','2013-08-24','15:30:00',4.09),('14598','2013-08-24','15:35:00',4.08),('14598','2013-08-24','15:40:00',4.05),('14598','2013-08-24','15:45:00',4.01),('14598','2013-08-24','15:50:00',3.97),('14598','2013-08-24','15:55:00',3.9),('14598','2013-08-24','16:00:00',3.83),('14598','2013-08-24','16:05:00',3.79),('14598','2013-08-24','16:10:00',3.73),('14598','2013-08-24','16:15:00',3.67),('14598','2013-08-24','16:20:00',3.61),('14598','2013-08-24','16:25:00',3.55),('14598','2013-08-24','16:30:00',3.48),('14598','2013-08-24','16:35:00',3.4),('14598','2013-08-24','16:40:00',3.33),('14598','2013-08-24','16:45:00',3.22),('14598','2013-08-24','16:50:00',3.12),('14598','2013-08-24','16:55:00',3.1),('14598','2013-08-24','17:00:00',3.02),('14598','2013-08-24','17:05:00',2.96),('14598','2013-08-24','17:10:00',2.87),('14598','2013-08-24','17:15:00',2.77),('14598','2013-08-24','17:20:00',2.7),('14598','2013-08-24','17:25:00',2.6),('14598','2013-08-24','17:30:00',2.51),('14598','2013-08-24','17:35:00',2.42),('14598','2013-08-24','17:40:00',2.32),('14598','2013-08-24','17:45:00',2.22),('14598','2013-08-24','17:50:00',2.12),('14598','2013-08-24','17:55:00',2.03),('14598','2013-08-24','18:00:00',1.93),('14598','2013-08-24','18:05:00',1.82),('14598','2013-08-24','18:10:00',1.72),('14598','2013-08-24','18:15:00',1.62),('14598','2013-08-24','18:20:00',1.52),('14598','2013-08-24','18:25:00',1.41),('14598','2013-08-24','18:30:00',1.31),('14598','2013-08-24','18:35:00',1.2),('14598','2013-08-24','18:40:00',1.09),('14598','2013-08-23','08:20:00',1.03),('14598','2013-08-23','08:30:00',1.04),('14598','2013-08-23','08:35:00',1.07),('14598','2013-08-23','08:40:00',1.16),('14598','2013-08-23','08:45:00',1.22),('14598','2013-08-23','08:50:00',1.32),('14598','2013-08-23','08:55:00',1.39),('14598','2013-08-23','09:00:00',1.48),('14598','2013-08-23','09:05:00',1.59),('14598','2013-08-23','09:10:00',1.71),('14598','2013-08-23','09:15:00',1.81),('14598','2013-08-23','09:20:00',1.89),('14598','2013-08-23','09:25:00',1.97),('14598','2013-08-23','09:30:00',2.04),('14598','2013-08-23','09:35:00',2.13),('14598','2013-08-23','09:40:00',2.22),('14598','2013-08-23','09:45:00',2.27),('14598','2013-08-23','09:50:00',2.35),('14598','2013-08-23','09:55:00',2.4),('14598','2013-08-23','10:00:00',2.52),('14598','2013-08-23','10:05:00',2.53),('14598','2013-08-23','10:10:00',2.63),('14598','2013-08-23','10:15:00',2.69),('14598','2013-08-23','10:20:00',2.79),('14598','2013-08-23','10:25:00',2.97),('14598','2013-08-23','10:30:00',3.04),('14598','2013-08-23','10:35:00',3.13),('14598','2013-08-23','10:40:00',3.21),('14598','2013-08-23','10:45:00',3.27),('14598','2013-08-23','10:50:00',3.34),('14598','2013-08-23','10:55:00',3.41),('14598','2013-08-23','11:00:00',3.47),('14598','2013-08-23','11:05:00',3.54),('14598','2013-08-23','11:10:00',3.54),('14598','2013-08-23','11:15:00',3.64),('14598','2013-08-23','11:20:00',3.69),('14598','2013-08-23','11:25:00',3.76),('14598','2013-08-23','11:30:00',3.82),('14598','2013-08-23','11:35:00',3.87),('14598','2013-08-23','11:40:00',3.91),('14598','2013-08-23','11:45:00',3.95),('14598','2013-08-23','11:50:00',4.01),('14598','2013-08-23','11:55:00',4.06),('14598','2013-08-23','12:00:00',4.11),('14598','2013-08-23','12:05:00',4.15),('14598','2013-08-23','12:10:00',4.19),('14598','2013-08-23','12:15:00',4.24),('14598','2013-08-23','12:20:00',4.27),('14598','2013-08-23','12:25:00',4.3),('14598','2013-08-23','12:30:00',4.3),('14598','2013-08-23','12:35:00',4.34),('14598','2013-08-23','12:40:00',4.38),('14598','2013-08-23','12:45:00',4.41),('14598','2013-08-23','12:50:00',4.43),('14598','2013-08-23','12:55:00',4.45),('14598','2013-08-23','13:00:00',4.44),('14598','2013-08-23','13:05:00',4.49),('14598','2013-08-23','13:10:00',4.51),('14598','2013-08-23','13:15:00',4.53),('14598','2013-08-23','13:20:00',4.53),('14598','2013-08-23','13:25:00',4.54),('14598','2013-08-23','13:30:00',4.53),('14598','2013-08-23','13:35:00',4.55),('14598','2013-08-23','13:40:00',4.57),('14598','2013-08-23','13:45:00',4.57),('14598','2013-08-23','13:50:00',4.57),('14598','2013-08-23','13:55:00',4.58),('14598','2013-08-23','14:00:00',4.56),('14598','2013-08-23','14:05:00',4.53),('14598','2013-08-23','14:10:00',4.47),('14598','2013-08-23','14:15:00',4.52),('14598','2013-08-23','14:20:00',4.47),('14598','2013-08-23','14:25:00',4.39),('14598','2013-08-23','14:30:00',4.52),('14598','2013-08-23','14:35:00',4.36),('14598','2013-08-23','14:40:00',4.36),('14598','2013-08-23','14:45:00',4.21),('14598','2013-08-23','14:50:00',4.32),('14598','2013-08-23','14:55:00',4.19),('14598','2013-08-23','15:00:00',4.22),('14598','2013-08-23','15:05:00',4.13),('14598','2013-08-23','15:10:00',4.34),('14598','2013-08-23','15:15:00',4.12),('14598','2013-08-23','15:20:00',3.96),('14598','2013-08-23','15:25:00',3.93),('14598','2013-08-23','15:30:00',3.69),('14598','2013-08-23','15:35:00',4.03),('14598','2013-08-23','15:40:00',3.81),('14598','2013-08-23','15:45:00',3.6),('14598','2013-08-23','15:50:00',3.46),('14598','2013-08-23','15:55:00',3.97),('14598','2013-08-23','16:00:00',3.91),('14598','2013-08-23','16:05:00',3.89),('14598','2013-08-23','16:10:00',3.82),('14598','2013-08-23','16:15:00',3.77),('14598','2013-08-23','16:20:00',3.65),('14598','2013-08-23','16:25:00',3.54),('14598','2013-08-23','16:30:00',3.48),('14598','2013-08-23','16:35:00',3.4),('14598','2013-08-23','16:40:00',3.33),('14598','2013-08-23','16:45:00',3.2),('14598','2013-08-23','16:50:00',3.12),('14598','2013-08-23','16:55:00',3.02),('14598','2013-08-23','17:00:00',2.98),('14598','2013-08-23','17:05:00',2.93),('14598','2013-08-23','17:10:00',2.86),('14598','2013-08-23','17:15:00',2.79),('14598','2013-08-23','17:20:00',2.7),('14598','2013-08-23','17:25:00',2.61),('14598','2013-08-23','17:30:00',2.52),('14598','2013-08-23','17:35:00',2.44),('14598','2013-08-23','17:40:00',2.37),('14598','2013-08-23','17:45:00',2.23),('14598','2013-08-23','17:50:00',2),('14598','2013-08-23','17:55:00',1.49),('14598','2013-08-23','18:00:00',1.91),('14598','2013-08-23','18:05:00',1.88),('14598','2013-08-23','18:10:00',1.74),('14598','2013-08-23','18:15:00',1.63),('14598','2013-08-23','18:20:00',1.5),('14598','2013-08-23','18:25:00',1.4),('14598','2013-08-23','18:30:00',1.26),('14598','2013-08-23','18:35:00',1.2),('14598','2013-08-23','18:40:00',1.1),('14598','2013-08-22','08:25:00',1.04),('14598','2013-08-22','08:30:00',1.14),('14598','2013-08-22','08:35:00',1.23),('14598','2013-08-22','08:40:00',1.28),('14598','2013-08-22','08:45:00',1.3),('14598','2013-08-22','08:50:00',1.36),('14598','2013-08-22','08:55:00',1.45),('14598','2013-08-22','09:00:00',1.55),('14598','2013-08-22','09:05:00',1.68),('14598','2013-08-22','09:10:00',1.81),('14598','2013-08-22','09:15:00',1.91),('14598','2013-08-22','09:20:00',1.99),('14598','2013-08-22','09:25:00',2.1),('14598','2013-08-22','09:30:00',2.16),('14598','2013-08-22','09:35:00',2.24),('14598','2013-08-22','09:40:00',2.31),('14598','2013-08-22','09:45:00',2.43),('14598','2013-08-22','09:50:00',2.52),('14598','2013-08-22','09:55:00',2.59),('14598','2013-08-22','10:00:00',2.66),('14598','2013-08-22','10:05:00',2.7),('14598','2013-08-22','10:10:00',2.36),('14598','2013-08-22','10:15:00',2.89),('14598','2013-08-22','10:20:00',2.93),('14598','2013-08-22','10:25:00',3),('14598','2013-08-22','10:30:00',3.09),('14598','2013-08-22','10:35:00',3.18),('14598','2013-08-22','10:40:00',3.24),('14598','2013-08-22','10:45:00',3.28),('14598','2013-08-22','10:50:00',3.36),('14598','2013-08-22','10:55:00',3.36),('14598','2013-08-22','11:00:00',3.49),('14598','2013-08-22','11:05:00',3.54),('14598','2013-08-22','11:10:00',3.58),('14598','2013-08-22','11:15:00',3.64),('14598','2013-08-22','11:20:00',3.69),('14598','2013-08-22','11:25:00',3.73),('14598','2013-08-22','11:30:00',3.76),('14598','2013-08-22','11:35:00',3.8),('14598','2013-08-22','11:40:00',3.84),('14598','2013-08-22','11:45:00',3.86),('14598','2013-08-22','11:50:00',3.88),('14598','2013-08-22','11:55:00',3.94),('14598','2013-08-22','12:00:00',3.95),('14598','2013-08-22','12:05:00',4),('14598','2013-08-22','12:10:00',3.94),('14598','2013-08-22','12:15:00',4.02),('14598','2013-08-22','12:20:00',4.06),('14598','2013-08-22','12:25:00',4.11),('14598','2013-08-22','12:30:00',4.07),('14598','2013-08-22','12:35:00',4.09),('14598','2013-08-22','12:40:00',4.14),('14598','2013-08-22','12:45:00',4.2),('14598','2013-08-22','12:50:00',4.22),('14598','2013-08-22','12:55:00',4.24),('14598','2013-08-22','13:00:00',4.14),('14598','2013-08-22','13:05:00',4.15),('14598','2013-08-22','13:10:00',4.15),('14598','2013-08-22','13:15:00',4.18),('14598','2013-08-22','13:20:00',4.22),('14598','2013-08-22','13:25:00',4.23),('14598','2013-08-22','13:30:00',4.22),('14598','2013-08-22','13:35:00',4.25),('14598','2013-08-22','13:40:00',4.28),('14598','2013-08-22','13:45:00',4.31),('14598','2013-08-22','13:50:00',4.38),('14598','2013-08-22','13:55:00',4.36),('14598','2013-08-22','14:00:00',4.39),('14598','2013-08-22','14:05:00',4.41),('14598','2013-08-22','14:10:00',4.42),('14598','2013-08-22','14:15:00',4.42),('14598','2013-08-22','14:20:00',4.39),('14598','2013-08-22','14:25:00',4.41),('14598','2013-08-22','14:30:00',4.41),('14598','2013-08-22','14:35:00',4.37),('14598','2013-08-22','14:40:00',4.33),('14598','2013-08-22','14:45:00',4.32),('14598','2013-08-22','14:50:00',4.27),('14598','2013-08-22','14:55:00',4.24),('14598','2013-08-22','15:00:00',4.21),('14598','2013-08-22','15:05:00',4.19),('14598','2013-08-22','15:10:00',4.15),('14598','2013-08-22','15:15:00',4.14),('14598','2013-08-22','15:20:00',4.1),('14598','2013-08-22','15:25:00',4.07),('14598','2013-08-22','15:30:00',4.01),('14598','2013-08-22','15:35:00',3.97),('14598','2013-08-22','15:40:00',3.86),('14598','2013-08-22','15:45:00',3.87),('14598','2013-08-22','15:50:00',3.83),('14598','2013-08-22','15:55:00',3.76),('14598','2013-08-22','16:00:00',3.68),('14598','2013-08-22','16:05:00',3.61),('14598','2013-08-22','16:10:00',3.56),('14598','2013-08-22','16:15:00',3.51),('14598','2013-08-22','16:20:00',3.46),('14598','2013-08-22','16:25:00',3.38),('14598','2013-08-22','16:30:00',3.32),('14598','2013-08-22','16:35:00',3.24),('14598','2013-08-22','16:40:00',3.16),('14598','2013-08-22','16:45:00',3.07),('14598','2013-08-22','16:50:00',3),('14598','2013-08-22','16:55:00',2.92),('14598','2013-08-22','17:00:00',2.81),('14598','2013-08-22','17:05:00',2.77),('14598','2013-08-22','17:10:00',2.69),('14598','2013-08-22','17:15:00',2.58),('14598','2013-08-22','17:20:00',2.51),('14598','2013-08-22','17:25:00',2.43),('14598','2013-08-22','17:30:00',2.33),('14598','2013-08-22','17:35:00',2.24),('14598','2013-08-22','17:40:00',2.15),('14598','2013-08-22','17:45:00',2.06),('14598','2013-08-22','17:50:00',1.97),('14598','2013-08-22','17:55:00',1.87),('14598','2013-08-22','18:00:00',1.78),('14598','2013-08-22','18:05:00',1.67),('14598','2013-08-22','18:10:00',1.57),('14598','2013-08-22','18:15:00',1.47),('14598','2013-08-22','18:20:00',1.4),('14598','2013-08-22','18:25:00',1.25),('14598','2013-08-22','18:30:00',1.11),('14598','2013-08-22','18:35:00',1.06),('14598','2013-08-22','18:40:00',1),('14598','2013-08-21','08:50:00',1.19),('14598','2013-08-21','08:55:00',1.36),('14598','2013-08-21','09:00:00',1.22),('14598','2013-08-21','09:05:00',1.12),('14598','2013-08-21','09:25:00',1.12),('14598','2013-08-21','09:30:00',2.13),('14598','2013-08-21','09:35:00',2.21),('14598','2013-08-21','09:40:00',2.19),('14598','2013-08-21','09:45:00',1.65),('14598','2013-08-21','09:50:00',1.01),('14598','2013-08-21','09:55:00',2.16),('14598','2013-08-21','10:00:00',2.23),('14598','2013-08-21','10:05:00',2.46),('14598','2013-08-21','10:10:00',2.3),('14598','2013-08-21','10:15:00',2.79),('14598','2013-08-21','10:20:00',2.71),('14598','2013-08-21','10:25:00',3.14),('14598','2013-08-21','10:30:00',3.54),('14598','2013-08-21','10:35:00',3.75),('14598','2013-08-21','10:40:00',3.01),('14598','2013-08-21','10:45:00',2.36),('14598','2013-08-21','10:50:00',3.15),('14598','2013-08-21','10:55:00',3.45),('14598','2013-08-21','11:00:00',2.6),('14598','2013-08-21','11:05:00',2.23),('14598','2013-08-21','11:10:00',2.55),('14598','2013-08-21','11:15:00',2.34),('14598','2013-08-21','11:20:00',3.12),('14598','2013-08-21','11:25:00',2.6),('14598','2013-08-21','11:30:00',2.77),('14598','2013-08-21','11:35:00',3.01),('14598','2013-08-21','11:40:00',2.93),('14598','2013-08-21','11:45:00',3.23),('14598','2013-08-21','11:50:00',4.21),('14598','2013-08-21','11:55:00',4.12),('14598','2013-08-21','12:00:00',4.16),('14598','2013-08-21','12:05:00',3.68),('14598','2013-08-21','12:10:00',4.03),('14598','2013-08-21','12:15:00',4.11),('14598','2013-08-21','12:20:00',4.12),('14598','2013-08-21','12:25:00',3.96),('14598','2013-08-21','12:30:00',3.74),('14598','2013-08-21','12:35:00',3.82),('14598','2013-08-21','12:40:00',3.53),('14598','2013-08-21','12:45:00',3.82),('14598','2013-08-21','12:50:00',3.8),('14598','2013-08-21','12:55:00',3.54),('14598','2013-08-21','13:00:00',3.72),('14598','2013-08-21','13:05:00',3.83),('14598','2013-08-21','13:10:00',4.2),('14598','2013-08-21','13:15:00',4.27),('14598','2013-08-21','13:20:00',4.31),('14598','2013-08-21','13:25:00',4.13),('14598','2013-08-21','13:30:00',4.13),('14598','2013-08-21','13:35:00',4.13),('14598','2013-08-21','13:40:00',4.08),('14598','2013-08-21','13:45:00',4.08),('14598','2013-08-21','13:50:00',4.2),('14598','2013-08-21','13:55:00',4.21),('14598','2013-08-21','14:00:00',4.26),('14598','2013-08-21','14:05:00',4.22),('14598','2013-08-21','14:10:00',4.35),('14598','2013-08-21','14:15:00',4.29),('14598','2013-08-21','14:20:00',4.15),('14598','2013-08-21','14:25:00',3.47),('14598','2013-08-21','14:30:00',4.11),('14598','2013-08-21','14:35:00',3.09),('14598','2013-08-21','14:40:00',2.35),('14598','2013-08-21','14:45:00',3.77),('14598','2013-08-21','14:50:00',2.82),('14598','2013-08-21','14:55:00',3.26),('14598','2013-08-21','15:00:00',3.63),('14598','2013-08-21','15:05:00',3.17),('14598','2013-08-21','15:10:00',4.17),('14598','2013-08-21','15:15:00',3.84),('14598','2013-08-21','15:20:00',3.59),('14598','2013-08-21','15:25:00',3.43),('14598','2013-08-21','15:30:00',3.39),('14598','2013-08-21','15:35:00',3.16),('14598','2013-08-21','15:40:00',3),('14598','2013-08-21','15:45:00',3.07),('14598','2013-08-21','15:50:00',3.18),('14598','2013-08-21','15:55:00',3.19),('14598','2013-08-21','16:00:00',3.05),('14598','2013-08-21','16:05:00',3.12),('14598','2013-08-21','16:10:00',3.26),('14598','2013-08-21','16:15:00',3.33),('14598','2013-08-21','16:20:00',3.46),('14598','2013-08-21','16:25:00',3.45),('14598','2013-08-21','16:30:00',3.29),('14598','2013-08-21','16:35:00',3.3),('14598','2013-08-21','16:40:00',3.25),('14598','2013-08-21','16:45:00',3.19),('14598','2013-08-21','16:50:00',3.13),('14598','2013-08-21','16:55:00',3.02),('14598','2013-08-21','17:00:00',2.96),('14598','2013-08-21','17:05:00',2.9),('14598','2013-08-21','17:10:00',2.77),('14598','2013-08-21','17:15:00',2.71),('14598','2013-08-21','17:20:00',2.61),('14598','2013-08-21','17:25:00',2.54),('14598','2013-08-21','17:30:00',2.42),('14598','2013-08-21','17:35:00',2.27),('14598','2013-08-21','17:40:00',2.22),('14598','2013-08-21','17:45:00',2.13),('14598','2013-08-21','17:50:00',2.04),('14598','2013-08-21','17:55:00',1.86),('14598','2013-08-21','18:00:00',1.22),('14598','2013-08-21','18:05:00',1.16),('14598','2013-08-21','18:10:00',1.22),('14598','2013-08-21','18:15:00',1.27),('14598','2013-08-21','18:20:00',1.28),('14598','2013-08-21','18:25:00',1.29),('14598','2013-08-21','18:30:00',1.29),('14598','2013-08-21','18:35:00',1.24),('14598','2013-08-21','18:40:00',1.18),('14598','2013-08-21','18:45:00',1.06),('14598','2013-08-20','08:55:00',1.33),('14598','2013-08-20','09:00:00',1.86),('14598','2013-08-20','09:05:00',2.12),('14598','2013-08-20','09:10:00',2.42),('14598','2013-08-20','09:15:00',2.57),('14598','2013-08-20','09:20:00',1.56),('14598','2013-08-20','09:25:00',1.62),('14598','2013-08-20','09:30:00',1.43),('14598','2013-08-20','09:35:00',1.5),('14598','2013-08-20','09:40:00',1.49),('14598','2013-08-20','09:45:00',1.38),('14598','2013-08-20','09:50:00',1.4),('14598','2013-08-20','09:55:00',1.77),('14598','2013-08-20','10:00:00',2.28),('14598','2013-08-20','10:05:00',2.54),('14598','2013-08-20','10:10:00',1.74),('14598','2013-08-20','10:15:00',3.44),('14598','2013-08-20','10:20:00',3.56),('14598','2013-08-20','10:25:00',3.09),('14598','2013-08-20','10:30:00',4.38),('14598','2013-08-20','10:35:00',4.28),('14598','2013-08-20','10:40:00',4.3),('14598','2013-08-20','10:45:00',3.39),('14598','2013-08-20','10:50:00',4.22),('14598','2013-08-20','10:55:00',3.34),('14598','2013-08-20','11:00:00',3.59),('14598','2013-08-20','11:05:00',2.36),('14598','2013-08-20','11:10:00',1.95),('14598','2013-08-20','11:15:00',2.26),('14598','2013-08-20','11:20:00',2.05),('14598','2013-08-20','11:25:00',2.17),('14598','2013-08-20','11:30:00',2.06),('14598','2013-08-20','11:35:00',1.75),('14598','2013-08-20','11:40:00',1.48),('14598','2013-08-20','11:45:00',1.34),('14598','2013-08-20','11:50:00',1.18),('14598','2013-08-20','11:55:00',1.2),('14598','2013-08-20','12:00:00',1.25),('14598','2013-08-20','12:05:00',1.36),('14598','2013-08-20','12:10:00',1.48),('14598','2013-08-20','12:15:00',1.74),('14598','2013-08-20','12:20:00',2.06),('14598','2013-08-20','12:25:00',2.34),('14598','2013-08-20','12:30:00',2.9),('14598','2013-08-20','12:35:00',3.62),('14598','2013-08-20','12:40:00',3.86),('14598','2013-08-20','12:45:00',3.87),('14598','2013-08-20','12:50:00',3.48),('14598','2013-08-20','12:55:00',3.7),('14598','2013-08-20','13:00:00',3.28),('14598','2013-08-20','13:05:00',3.05),('14598','2013-08-20','13:10:00',3),('14598','2013-08-20','13:15:00',3.04),('14598','2013-08-20','13:20:00',2.81),('14598','2013-08-20','13:25:00',3.1),('14598','2013-08-20','13:30:00',3.35),('14598','2013-08-20','13:35:00',2.96),('14598','2013-08-20','13:40:00',3.21),('14598','2013-08-20','13:45:00',3.78),('14598','2013-08-20','13:50:00',2.14),('14598','2013-08-20','13:55:00',2.44),('14598','2013-08-20','14:00:00',2.09),('14598','2013-08-20','14:05:00',2.52),('14598','2013-08-20','14:10:00',3.84),('14598','2013-08-20','14:15:00',5.08),('14598','2013-08-20','14:20:00',4.95),('14598','2013-08-20','14:25:00',4.87),('14598','2013-08-20','14:30:00',4.87),('14598','2013-08-20','14:35:00',4.86),('14598','2013-08-20','14:40:00',4.9),('14598','2013-08-20','14:45:00',5.1),('14598','2013-08-20','14:50:00',4.32),('14598','2013-08-20','14:55:00',3.96),('14598','2013-08-20','15:00:00',1.89),('14598','2013-08-20','15:05:00',4.88),('14598','2013-08-20','15:10:00',5.07),('14598','2013-08-20','15:15:00',4.67),('14598','2013-08-20','15:20:00',4.57),('14598','2013-08-20','15:25:00',4.46),('14598','2013-08-20','15:30:00',4.44),('14598','2013-08-20','15:35:00',4.41),('14598','2013-08-20','15:40:00',4.3),('14598','2013-08-20','15:45:00',2.31),('14598','2013-08-20','15:50:00',4.32),('14598','2013-08-20','15:55:00',4.15),('14598','2013-08-20','16:00:00',4.09),('14598','2013-08-20','16:05:00',4.03),('14598','2013-08-20','16:10:00',3.97),('14598','2013-08-20','16:15:00',3.9),('14598','2013-08-20','16:20:00',3.82),('14598','2013-08-20','16:25:00',3.21),('14598','2013-08-20','16:30:00',3.75),('14598','2013-08-20','16:35:00',3.74),('14598','2013-08-20','16:40:00',3.5),('14598','2013-08-20','16:45:00',2.86),('14598','2013-08-20','16:50:00',4.07),('14598','2013-08-20','16:55:00',3.22),('14598','2013-08-20','17:00:00',2.02),('14598','2013-08-20','17:05:00',3.41),('14598','2013-08-20','17:10:00',2.59),('14598','2013-08-20','17:15:00',2.71),('14598','2013-08-20','17:20:00',2.86),('14598','2013-08-20','17:25:00',2.85),('14598','2013-08-20','17:30:00',2.78),('14598','2013-08-20','17:35:00',2.55),('14598','2013-08-20','17:40:00',1.77),('14598','2013-08-20','17:45:00',1.41),('14598','2013-08-20','17:50:00',2.3),('14598','2013-08-20','17:55:00',2.21),('14598','2013-08-20','18:00:00',2.04),('14598','2013-08-20','18:10:00',1.31),('14598','2013-08-20','18:15:00',1.67),('14598','2013-08-20','18:20:00',1.09),('14598','2013-08-20','18:40:00',1),('14598','2013-08-20','18:45:00',1.17),('14598','2013-08-20','18:50:00',1.08),('14598','2014-04-10','08:30:00',1.05),('14598','2014-04-10','08:35:00',1.15),('14598','2014-04-10','08:40:00',1.27),('14598','2014-04-10','08:45:00',1.39),('14598','2014-04-10','08:50:00',1.49),('14598','2014-04-10','08:55:00',1.61),('14598','2014-04-10','09:00:00',1.72),('14598','2014-04-10','09:05:00',1.85),('14598','2014-04-10','09:10:00',1.97),('14598','2014-04-10','09:15:00',2.09),('14598','2014-04-10','09:20:00',2.22),('14598','2014-04-10','09:25:00',2.33),('14598','2014-04-10','09:30:00',2.43),('14598','2014-04-10','09:35:00',2.52),('14598','2014-04-10','09:40:00',2.62),('14598','2014-04-10','09:45:00',2.73),('14598','2014-04-10','09:50:00',2.82),('14598','2014-04-10','09:55:00',2.91),('14598','2014-04-10','10:00:00',2.99),('14598','2014-04-10','10:05:00',3.07),('14598','2014-04-10','10:10:00',3.14),('14598','2014-04-10','10:15:00',3.23),('14598','2014-04-10','10:20:00',3.28),('14598','2014-04-10','10:25:00',3.32),('14598','2014-04-10','10:30:00',3.4),('14598','2014-04-10','10:35:00',3.55),('14598','2014-04-10','10:40:00',3.64),('14598','2014-04-10','10:45:00',3.63),('14598','2014-04-10','10:50:00',3.66),('14598','2014-04-10','10:55:00',3.74),('14598','2014-04-10','11:00:00',3.87),('14598','2014-04-10','11:05:00',3.99),('14598','2014-04-10','11:10:00',4.06),('14598','2014-04-10','11:15:00',4.13),('14598','2014-04-10','11:20:00',4.15),('14598','2014-04-10','11:25:00',4.21),('14598','2014-04-10','11:30:00',4.28),('14598','2014-04-10','11:35:00',4.38),('14598','2014-04-10','11:40:00',4.33),('14598','2014-04-10','11:45:00',4.36),('14598','2014-04-10','11:50:00',4.41),('14598','2014-04-10','11:55:00',4.35),('14598','2014-04-10','12:00:00',4.42),('14598','2014-04-10','12:05:00',4.5),('14598','2014-04-10','12:10:00',4.65),('14598','2014-04-10','12:15:00',4.7),('14598','2014-04-10','12:20:00',4.2),('14598','2014-04-10','12:25:00',4.58),('14598','2014-04-10','12:30:00',4.82),('14598','2014-04-10','12:35:00',4.7),('14598','2014-04-10','12:40:00',4.41),('14598','2014-04-10','12:45:00',4.85),('14598','2014-04-10','12:50:00',4.8),('14598','2014-04-10','12:55:00',4.75),('14598','2014-04-10','13:00:00',4.79),('14598','2014-04-10','13:05:00',4.76),('14598','2014-04-10','13:10:00',4.79),('14598','2014-04-10','13:15:00',4.95),('14598','2014-04-10','13:20:00',4.42),('14598','2014-04-10','13:25:00',4.83),('14598','2014-04-10','13:30:00',4.77),('14598','2014-04-10','13:35:00',4.86),('14598','2014-04-10','13:40:00',4.76),('14598','2014-04-10','13:45:00',4.79),('14598','2014-04-10','13:50:00',4.79),('14598','2014-04-10','13:55:00',4.8),('14598','2014-04-10','14:00:00',4.8),('14598','2014-04-10','14:05:00',4.84),('14598','2014-04-10','14:10:00',4.57),('14598','2014-04-10','14:15:00',4.78),('14598','2014-04-10','14:20:00',4.76),('14598','2014-04-10','14:25:00',4.63),('14598','2014-04-10','14:30:00',4.77),('14598','2014-04-10','14:35:00',4.79),('14598','2014-04-10','14:40:00',4.88),('14598','2014-04-10','14:45:00',4.6),('14598','2014-04-10','14:50:00',4.61),('14598','2014-04-10','14:55:00',4.34),('14598','2014-04-10','15:00:00',4.29),('14598','2014-04-10','15:05:00',4.4),('14598','2014-04-10','15:10:00',4.25),('14598','2014-04-10','15:15:00',4.31),('14598','2014-04-10','15:20:00',4.27),('14598','2014-04-10','15:25:00',4.35),('14598','2014-04-10','15:30:00',4.17),('14598','2014-04-10','15:35:00',4.01),('14598','2014-04-10','15:40:00',4.04),('14598','2014-04-10','15:45:00',4.03),('14598','2014-04-10','15:50:00',4.02),('14598','2014-04-10','15:55:00',4.02),('14598','2014-04-10','16:00:00',4.24),('14598','2014-04-10','16:05:00',4.2),('14598','2014-04-10','16:10:00',4.11),('14598','2014-04-10','16:15:00',4.02),('14598','2014-04-10','16:20:00',3.95),('14598','2014-04-10','16:25:00',3.86),('14598','2014-04-10','16:30:00',3.75),('14598','2014-04-10','16:35:00',3.71),('14598','2014-04-10','16:40:00',3.66),('14598','2014-04-10','16:45:00',3.63),('14598','2014-04-10','16:50:00',3.55),('14598','2014-04-10','16:55:00',3.44),('14598','2014-04-10','17:00:00',3.36),('14598','2014-04-10','17:05:00',3.27),('14598','2014-04-10','17:10:00',3.17),('14598','2014-04-10','17:15:00',3.05),('14598','2014-04-10','17:20:00',2.96),('14598','2014-04-10','17:25:00',2.81),('14598','2014-04-10','17:30:00',2.75),('14598','2014-04-10','17:35:00',2.64),('14598','2014-04-10','17:40:00',2.53),('14598','2014-04-10','17:45:00',2.4),('14598','2014-04-10','17:50:00',2.3),('14598','2014-04-10','17:55:00',2.15),('14598','2014-04-10','18:00:00',2.05),('14598','2014-04-10','18:05:00',1.92),('14598','2014-04-10','18:10:00',1.8),('14598','2014-04-10','18:15:00',1.64),('14598','2014-04-10','18:20:00',1.5),('14598','2014-04-10','18:25:00',1.22),('14598','2014-04-10','18:30:00',1.12),('14598','2014-04-10','18:35:00',1.02),('14598','2013-08-19','08:30:00',1.07),('14598','2013-08-19','08:35:00',1.16),('14598','2013-08-19','08:40:00',1.25),('14598','2013-08-19','08:45:00',1.35),('14598','2013-08-19','08:50:00',1.42),('14598','2013-08-19','08:55:00',1.51),('14598','2013-08-19','09:00:00',1.63),('14598','2013-08-19','09:05:00',1.78),('14598','2013-08-19','09:10:00',1.87),('14598','2013-08-19','09:15:00',1.98),('14598','2013-08-19','09:20:00',2.03),('14598','2013-08-19','09:25:00',2.17),('14598','2013-08-19','09:30:00',2.24),('14598','2013-08-19','09:35:00',2.33),('14598','2013-08-19','09:40:00',2.41),('14598','2013-08-19','09:45:00',2.48),('14598','2013-08-19','09:50:00',2.54),('14598','2013-08-19','09:55:00',2.62),('14598','2013-08-19','10:00:00',2.7),('14598','2013-08-19','10:05:00',2.81),('14598','2013-08-19','10:10:00',2.87),('14598','2013-08-19','10:15:00',2.95),('14598','2013-08-19','10:20:00',3.01),('14598','2013-08-19','10:25:00',3.08),('14598','2013-08-19','10:30:00',3.12),('14598','2013-08-19','10:35:00',3.17),('14598','2013-08-19','10:40:00',3.26),('14598','2013-08-19','10:45:00',3.31),('14598','2013-08-19','10:50:00',3.37),('14598','2013-08-19','10:55:00',3.48),('14598','2013-08-19','11:00:00',3.58),('14598','2013-08-19','11:05:00',3.61),('14598','2013-08-19','11:10:00',3.68),('14598','2013-08-19','11:15:00',3.74),('14598','2013-08-19','11:20:00',3.8),('14598','2013-08-19','11:25:00',3.85),('14598','2013-08-19','11:30:00',3.89),('14598','2013-08-19','11:35:00',3.97),('14598','2013-08-19','11:40:00',4.03),('14598','2013-08-19','11:45:00',4.05),('14598','2013-08-19','11:50:00',4.1),('14598','2013-08-19','11:55:00',4.2),('14598','2013-08-19','12:00:00',4.24),('14598','2013-08-19','12:05:00',4.31),('14598','2013-08-19','12:10:00',4.35),('14598','2013-08-19','12:15:00',4.41),('14598','2013-08-19','12:20:00',4.33),('14598','2013-08-19','12:25:00',4.44),('14598','2013-08-19','12:30:00',4.49),('14598','2013-08-19','12:35:00',4.49),('14598','2013-08-19','12:40:00',4.53),('14598','2013-08-19','12:45:00',4.53),('14598','2013-08-19','12:50:00',4.57),('14598','2013-08-19','12:55:00',4.56),('14598','2013-08-19','13:00:00',4.56),('14598','2013-08-19','13:05:00',4.6),('14598','2013-08-19','13:10:00',4.64),('14598','2013-08-19','13:15:00',4.65),('14598','2013-08-19','13:20:00',4.66),('14598','2013-08-19','13:25:00',4.66),('14598','2013-08-19','13:30:00',4.66),('14598','2013-08-19','13:35:00',4.64),('14598','2013-08-19','13:40:00',4.7),('14598','2013-08-19','13:45:00',4.7),('14598','2013-08-19','13:50:00',4.73),('14598','2013-08-19','13:55:00',4.71),('14598','2013-08-19','14:00:00',4.7),('14598','2013-08-19','14:05:00',4.69),('14598','2013-08-19','14:10:00',4.7),('14598','2013-08-19','14:15:00',4.69),('14598','2013-08-19','14:20:00',4.7),('14598','2013-08-19','14:25:00',4.68),('14598','2013-08-19','14:30:00',4.66),('14598','2013-08-19','14:35:00',4.65),('14598','2013-08-19','14:40:00',4.64),('14598','2013-08-19','14:45:00',4.62),('14598','2013-08-19','14:50:00',4.58),('14598','2013-08-19','14:55:00',4.56),('14598','2013-08-19','15:00:00',4.51),('14598','2013-08-19','15:05:00',4.48),('14598','2013-08-19','15:10:00',4.46),('14598','2013-08-19','15:15:00',4.43),('14598','2013-08-19','15:20:00',4.33),('14598','2013-08-19','15:25:00',4.37),('14598','2013-08-19','15:30:00',4.32),('14598','2013-08-19','15:35:00',4.27),('14598','2013-08-19','15:40:00',4.23),('14598','2013-08-19','15:45:00',4.17),('14598','2013-08-19','15:50:00',4.12),('14598','2013-08-19','15:55:00',4.06),('14598','2013-08-19','16:00:00',4.01),('14598','2013-08-19','16:05:00',3.87),('14598','2013-08-19','16:10:00',3.9),('14598','2013-08-19','16:15:00',3.84),('14598','2013-08-19','16:20:00',3.79),('14598','2013-08-19','16:25:00',3.71),('14598','2013-08-19','16:30:00',3.65),('14598','2013-08-19','16:35:00',3.57),('14598','2013-08-19','16:40:00',3.47),('14598','2013-08-19','16:45:00',3.43),('14598','2013-08-19','16:50:00',3.35),('14598','2013-08-19','16:55:00',3.29),('14598','2013-08-19','17:00:00',3.2),('14598','2013-08-19','17:05:00',3.11),('14598','2013-08-19','17:10:00',3.02),('14598','2013-08-19','17:15:00',2.94),('14598','2013-08-19','17:20:00',2.86),('14598','2013-08-19','17:25:00',2.77),('14598','2013-08-19','17:30:00',2.65),('14598','2013-08-19','17:35:00',2.56),('14598','2013-08-19','17:40:00',2.48),('14598','2013-08-19','17:45:00',2.36),('14598','2013-08-19','17:50:00',2.26),('14598','2013-08-19','17:55:00',2.18),('14598','2013-08-19','18:00:00',2.07),('14598','2013-08-19','18:05:00',1.98),('14598','2013-08-19','18:10:00',1.88),('14598','2013-08-19','18:15:00',1.78),('14598','2013-08-19','18:20:00',1.68),('14598','2013-08-19','18:25:00',1.54),('14598','2013-08-19','18:30:00',1.47),('14598','2013-08-19','18:35:00',1.36),('14598','2013-08-19','18:40:00',1.26),('14598','2013-08-19','18:45:00',1.16),('14598','2013-08-19','18:50:00',1.05),('14598','2013-08-18','08:25:00',1.02),('14598','2013-08-18','08:30:00',1.1),('14598','2013-08-18','08:35:00',1.18),('14598','2013-08-18','08:40:00',1.28),('14598','2013-08-18','08:45:00',1.38),('14598','2013-08-18','08:50:00',1.47),('14598','2013-08-18','08:55:00',1.55),('14598','2013-08-18','09:00:00',1.67),('14598','2013-08-18','09:05:00',1.79),('14598','2013-08-18','09:10:00',1.91),('14598','2013-08-18','09:15:00',2),('14598','2013-08-18','09:20:00',2.09),('14598','2013-08-18','09:25:00',2.18),('14598','2013-08-18','09:30:00',2.26),('14598','2013-08-18','09:35:00',2.35),('14598','2013-08-18','09:40:00',2.44),('14598','2013-08-18','09:45:00',2.52),('14598','2013-08-18','09:50:00',2.58),('14598','2013-08-18','09:55:00',2.67),('14598','2013-08-18','10:00:00',2.76),('14598','2013-08-18','10:05:00',2.83),('14598','2013-08-18','10:10:00',2.9),('14598','2013-08-18','10:15:00',2.98),('14598','2013-08-18','10:20:00',3.03),('14598','2013-08-18','10:25:00',3.1),('14598','2013-08-18','10:30:00',3.12),('14598','2013-08-18','10:35:00',3.17),('14598','2013-08-18','10:40:00',3.23),('14598','2013-08-18','10:45:00',3.35),('14598','2013-08-18','10:50:00',3.43),('14598','2013-08-18','10:55:00',3.52),('14598','2013-08-18','11:00:00',3.58),('14598','2013-08-18','11:05:00',3.61),('14598','2013-08-18','11:10:00',3.69),('14598','2013-08-18','11:15:00',3.77),('14598','2013-08-18','11:20:00',3.84),('14598','2013-08-18','11:25:00',3.91),('14598','2013-08-18','11:30:00',3.99),('14598','2013-08-18','11:35:00',4.02),('14598','2013-08-18','11:40:00',4.08),('14598','2013-08-18','11:45:00',4.12),('14598','2013-08-18','11:50:00',4.16),('14598','2013-08-18','11:55:00',4.21),('14598','2013-08-18','12:00:00',4.26),('14598','2013-08-18','12:05:00',4.25),('14598','2013-08-18','12:10:00',4.31),('14598','2013-08-18','12:15:00',4.32),('14598','2013-08-18','12:20:00',4.4),('14598','2013-08-18','12:25:00',4.44),('14598','2013-08-18','12:30:00',4.47),('14598','2013-08-18','12:35:00',4.5),('14598','2013-08-18','12:40:00',4.53),('14598','2013-08-18','12:45:00',4.56),('14598','2013-08-18','12:50:00',4.58),('14598','2013-08-18','12:55:00',4.6),('14598','2013-08-18','13:00:00',4.62),('14598','2013-08-18','13:05:00',4.64),('14598','2013-08-18','13:10:00',4.64),('14598','2013-08-18','13:15:00',4.67),('14598','2013-08-18','13:20:00',4.68),('14598','2013-08-18','13:25:00',4.69),('14598','2013-08-18','13:30:00',4.7),('14598','2013-08-18','13:35:00',4.71),('14598','2013-08-18','13:40:00',4.7),('14598','2013-08-18','13:45:00',4.69),('14598','2013-08-18','13:50:00',4.61),('14598','2013-08-18','13:55:00',4.72),('14598','2013-08-18','14:00:00',4.73),('14598','2013-08-18','14:05:00',4.71),('14598','2013-08-18','14:10:00',4.69),('14598','2013-08-18','14:15:00',4.68),('14598','2013-08-18','14:20:00',4.66),('14598','2013-08-18','14:25:00',4.66),('14598','2013-08-18','14:30:00',4.65),('14598','2013-08-18','14:35:00',4.62),('14598','2013-08-18','14:40:00',4.58),('14598','2013-08-18','14:45:00',4.55),('14598','2013-08-18','14:50:00',4.52),('14598','2013-08-18','14:55:00',4.51),('14598','2013-08-18','15:00:00',4.46),('14598','2013-08-18','15:05:00',4.43),('14598','2013-08-18','15:10:00',4.4),('14598','2013-08-18','15:15:00',4.36),('14598','2013-08-18','15:20:00',4.32),('14598','2013-08-18','15:25:00',4.29),('14598','2013-08-18','15:30:00',4.25),('14598','2013-08-18','15:35:00',4.22),('14598','2013-08-18','15:40:00',4.2),('14598','2013-08-18','15:45:00',4.14),('14598','2013-08-18','15:50:00',4.1),('14598','2013-08-18','15:55:00',4.05),('14598','2013-08-18','16:00:00',3.99),('14598','2013-08-18','16:05:00',3.94),('14598','2013-08-18','16:10:00',3.89),('14598','2013-08-18','16:15:00',3.86),('14598','2013-08-18','16:20:00',3.79),('14598','2013-08-18','16:25:00',3.71),('14598','2013-08-18','16:30:00',3.65),('14598','2013-08-18','16:35:00',3.57),('14598','2013-08-18','16:40:00',3.51),('14598','2013-08-18','16:45:00',3.44),('14598','2013-08-18','16:50:00',3.31),('14598','2013-08-18','16:55:00',3.29),('14598','2013-08-18','17:00:00',3.2),('14598','2013-08-18','17:05:00',3.12),('14598','2013-08-18','17:10:00',3.04),('14598','2013-08-18','17:15:00',2.96),('14598','2013-08-18','17:20:00',2.88),('14598','2013-08-18','17:25:00',2.79),('14598','2013-08-18','17:30:00',2.7),('14598','2013-08-18','17:35:00',2.61),('14598','2013-08-18','17:40:00',2.51),('14598','2013-08-18','17:45:00',2.41),('14598','2013-08-18','17:50:00',2.31),('14598','2013-08-18','17:55:00',2.22),('14598','2013-08-18','18:00:00',2.12),('14598','2013-08-18','18:05:00',2.01),('14598','2013-08-18','18:10:00',1.9),('14598','2013-08-18','18:15:00',1.81),('14598','2013-08-18','18:20:00',1.71),('14598','2013-08-18','18:25:00',1.6),('14598','2013-08-18','18:30:00',1.49),('14598','2013-08-18','18:35:00',1.38),('14598','2013-08-18','18:40:00',1.26),('14598','2013-08-18','18:45:00',1.17),('14598','2013-08-18','18:50:00',1.06),('14598','2013-08-17','08:25:00',1.01),('14598','2013-08-17','08:30:00',1.09),('14598','2013-08-17','08:35:00',1.18),('14598','2013-08-17','08:40:00',1.27),('14598','2013-08-17','08:45:00',1.37),('14598','2013-08-17','08:50:00',1.44),('14598','2013-08-17','08:55:00',1.53),('14598','2013-08-17','09:00:00',1.56),('14598','2013-08-17','09:05:00',1.81),('14598','2013-08-17','09:10:00',1.63),('14598','2013-08-17','09:15:00',1.97),('14598','2013-08-17','09:20:00',2.07),('14598','2013-08-17','09:25:00',2.15),('14598','2013-08-17','09:30:00',2.25),('14598','2013-08-17','09:35:00',2.33),('14598','2013-08-17','09:40:00',2.43),('14598','2013-08-17','09:45:00',2.5),('14598','2013-08-17','09:50:00',2.59),('14598','2013-08-17','09:55:00',2.65),('14598','2013-08-17','10:00:00',2.73),('14598','2013-08-17','10:05:00',2.81),('14598','2013-08-17','10:10:00',2.88),('14598','2013-08-17','10:15:00',2.94),('14598','2013-08-17','10:20:00',3.03),('14598','2013-08-17','10:25:00',3.08),('14598','2013-08-17','10:30:00',3.14),('14598','2013-08-17','10:35:00',3.19),('14598','2013-08-17','10:40:00',3.26),('14598','2013-08-17','10:45:00',3.35),('14598','2013-08-17','10:50:00',3.46),('14598','2013-08-17','10:55:00',3.53),('14598','2013-08-17','11:00:00',3.58),('14598','2013-08-17','11:05:00',3.66),('14598','2013-08-17','11:10:00',3.73),('14598','2013-08-17','11:15:00',3.8),('14598','2013-08-17','11:20:00',3.85),('14598','2013-08-17','11:25:00',3.9),('14598','2013-08-17','11:30:00',3.93),('14598','2013-08-17','11:35:00',4.01),('14598','2013-08-17','11:40:00',4.06),('14598','2013-08-17','11:45:00',4.1),('14598','2013-08-17','11:50:00',4.14),('14598','2013-08-17','11:55:00',4.18),('14598','2013-08-17','12:00:00',4.21),('14598','2013-08-17','12:05:00',4.25),('14598','2013-08-17','12:10:00',4.29),('14598','2013-08-17','12:15:00',4.32),('14598','2013-08-17','12:20:00',4.37),('14598','2013-08-17','12:25:00',4.38),('14598','2013-08-17','12:30:00',4.41),('14598','2013-08-17','12:35:00',4.43),('14598','2013-08-17','12:40:00',4.48),('14598','2013-08-17','12:45:00',4.51),('14598','2013-08-17','12:50:00',4.52),('14598','2013-08-17','12:55:00',4.08),('14598','2013-08-17','13:00:00',4.55),('14598','2013-08-17','13:05:00',4.58),('14598','2013-08-17','13:10:00',4.58),('14598','2013-08-17','13:15:00',4.62),('14598','2013-08-17','13:20:00',4.61),('14598','2013-08-17','13:25:00',4.62),('14598','2013-08-17','13:30:00',4.65),('14598','2013-08-17','13:35:00',4.67),('14598','2013-08-17','13:40:00',4.67),('14598','2013-08-17','13:45:00',4.66),('14598','2013-08-17','13:50:00',4.66),('14598','2013-08-17','13:55:00',4.67),('14598','2013-08-17','14:00:00',4.65),('14598','2013-08-17','14:05:00',4.64),('14598','2013-08-17','14:10:00',4.62),('14598','2013-08-17','14:15:00',4.61),('14598','2013-08-17','14:20:00',4.59),('14598','2013-08-17','14:25:00',4.62),('14598','2013-08-17','14:30:00',4.6),('14598','2013-08-17','14:35:00',4.58),('14598','2013-08-17','14:40:00',4.56),('14598','2013-08-17','14:45:00',4.55),('14598','2013-08-17','14:50:00',4.54),('14598','2013-08-17','14:55:00',4.5),('14598','2013-08-17','15:00:00',4.46),('14598','2013-08-17','15:05:00',4.44),('14598','2013-08-17','15:10:00',4.41),('14598','2013-08-17','15:15:00',4.38),('14598','2013-08-17','15:20:00',4.35),('14598','2013-08-17','15:25:00',4.32),('14598','2013-08-17','15:30:00',4.3),('14598','2013-08-17','15:35:00',4.22),('14598','2013-08-17','15:40:00',3.36),('14598','2013-08-17','15:45:00',4.17),('14598','2013-08-17','15:50:00',4.14),('14598','2013-08-17','15:55:00',4.07),('14598','2013-08-17','16:00:00',4.02),('14598','2013-08-17','16:05:00',3.97),('14598','2013-08-17','16:10:00',3.93),('14598','2013-08-17','16:15:00',3.87),('14598','2013-08-17','16:20:00',3.75),('14598','2013-08-17','16:25:00',3.57),('14598','2013-08-17','16:30:00',3.6),('14598','2013-08-17','16:35:00',3.43),('14598','2013-08-17','16:40:00',3.37),('14598','2013-08-17','16:45:00',3.5),('14598','2013-08-17','16:50:00',3.4),('14598','2013-08-17','16:55:00',3.34),('14598','2013-08-17','17:00:00',3.28),('14598','2013-08-17','17:05:00',3.17),('14598','2013-08-17','17:10:00',3.07),('14598','2013-08-17','17:15:00',2.96),('14598','2013-08-17','17:20:00',2.79),('14598','2013-08-17','17:25:00',2.71),('14598','2013-08-17','17:30:00',2.62),('14598','2013-08-17','17:35:00',2.5),('14598','2013-08-17','17:40:00',2.44),('14598','2013-08-17','17:45:00',2.47),('14598','2013-08-17','17:50:00',2.38),('14598','2013-08-17','17:55:00',2.27),('14598','2013-08-17','18:00:00',2.18),('14598','2013-08-17','18:05:00',2.08),('14598','2013-08-17','18:10:00',1.91),('14598','2013-08-17','18:15:00',1.85),('14598','2013-08-17','18:20:00',1.73),('14598','2013-08-17','18:25:00',1.66),('14598','2013-08-17','18:30:00',1.56),('14598','2013-08-17','18:35:00',1.46),('14598','2013-08-17','18:40:00',1.36),('14598','2013-08-17','18:45:00',1.26),('14598','2013-08-17','18:50:00',1.15),('14598','2013-08-17','18:55:00',1.04),('14598','2013-08-16','08:25:00',1.04),('14598','2013-08-16','08:30:00',1.13),('14598','2013-08-16','08:35:00',1.22),('14598','2013-08-16','08:40:00',1.31),('14598','2013-08-16','08:45:00',1.41),('14598','2013-08-16','08:50:00',1.49),('14598','2013-08-16','08:55:00',1.59),('14598','2013-08-16','09:00:00',1.71),('14598','2013-08-16','09:05:00',1.83),('14598','2013-08-16','09:10:00',1.95),('14598','2013-08-16','09:15:00',2.05),('14598','2013-08-16','09:20:00',2.15),('14598','2013-08-16','09:25:00',2.24),('14598','2013-08-16','09:30:00',2.32),('14598','2013-08-16','09:35:00',2.43),('14598','2013-08-16','09:40:00',2.52),('14598','2013-08-16','09:45:00',2.6),('14598','2013-08-16','09:50:00',2.69),('14598','2013-08-16','09:55:00',2.77),('14598','2013-08-16','10:00:00',2.84),('14598','2013-08-16','10:05:00',2.91),('14598','2013-08-16','10:10:00',2.99),('14598','2013-08-16','10:15:00',3.06),('14598','2013-08-16','10:20:00',3.12),('14598','2013-08-16','10:25:00',3.21),('14598','2013-08-16','10:30:00',3.27),('14598','2013-08-16','10:35:00',3.35),('14598','2013-08-16','10:40:00',3.41),('14598','2013-08-16','10:45:00',3.45),('14598','2013-08-16','10:50:00',3.53),('14598','2013-08-16','10:55:00',3.59),('14598','2013-08-16','11:00:00',3.62),('14598','2013-08-16','11:05:00',3.64),('14598','2013-08-16','11:10:00',3.73),('14598','2013-08-16','11:15:00',3.81),('14598','2013-08-16','11:20:00',3.86),('14598','2013-08-16','11:25:00',3.9),('14598','2013-08-16','11:30:00',3.95),('14598','2013-08-16','11:35:00',4),('14598','2013-08-16','11:40:00',4.03),('14598','2013-08-16','11:45:00',4.06),('14598','2013-08-16','11:50:00',4.1),('14598','2013-08-16','11:55:00',4.14),('14598','2013-08-16','12:00:00',4.15),('14598','2013-08-16','12:05:00',4.16),('14598','2013-08-16','12:10:00',4.19),('14598','2013-08-16','12:15:00',4.23),('14598','2013-08-16','12:20:00',4.28),('14598','2013-08-16','12:25:00',4.32),('14598','2013-08-16','12:30:00',4.28),('14598','2013-08-16','12:35:00',4.37),('14598','2013-08-16','12:40:00',4.4),('14598','2013-08-16','12:45:00',4.4),('14598','2013-08-16','12:50:00',4.44),('14598','2013-08-16','12:55:00',4.48),('14598','2013-08-16','13:00:00',4.48),('14598','2013-08-16','13:05:00',4.49),('14598','2013-08-16','13:10:00',4.5),('14598','2013-08-16','13:15:00',4.48),('14598','2013-08-16','13:20:00',4.47),('14598','2013-08-16','13:25:00',4.47),('14598','2013-08-16','13:30:00',4.52),('14598','2013-08-16','13:35:00',4.52),('14598','2013-08-16','13:40:00',4.51),('14598','2013-08-16','13:45:00',4.44),('14598','2013-08-16','13:50:00',4.46),('14598','2013-08-16','13:55:00',4.44),('14598','2013-08-16','14:00:00',4.53),('14598','2013-08-16','14:05:00',4.62),('14598','2013-08-16','14:10:00',4.63),('14598','2013-08-16','14:15:00',4.65),('14598','2013-08-16','14:20:00',4.65),('14598','2013-08-16','14:25:00',4.61),('14598','2013-08-16','14:30:00',4.62),('14598','2013-08-16','14:35:00',4.63),('14598','2013-08-16','14:40:00',4.61),('14598','2013-08-16','14:45:00',4.58),('14598','2013-08-16','14:50:00',4.55),('14598','2013-08-16','14:55:00',4.53),('14598','2013-08-16','15:00:00',4.49),('14598','2013-08-16','15:05:00',4.46),('14598','2013-08-16','15:10:00',4.42),('14598','2013-08-16','15:15:00',4.39),('14598','2013-08-16','15:20:00',4.36),('14598','2013-08-16','15:25:00',4.32),('14598','2013-08-16','15:30:00',4.29),('14598','2013-08-16','15:35:00',4.18),('14598','2013-08-16','15:40:00',4.21),('14598','2013-08-16','15:45:00',4.17),('14598','2013-08-16','15:50:00',4.14),('14598','2013-08-16','15:55:00',4.06),('14598','2013-08-16','16:00:00',3.99),('14598','2013-08-16','16:05:00',3.94),('14598','2013-08-16','16:10:00',3.87),('14598','2013-08-16','16:15:00',3.85),('14598','2013-08-16','16:20:00',3.78),('14598','2013-08-16','16:25:00',3.72),('14598','2013-08-16','16:30:00',3.66),('14598','2013-08-16','16:35:00',3.6),('14598','2013-08-16','16:40:00',3.52),('14598','2013-08-16','16:45:00',3.45),('14598','2013-08-16','16:50:00',3.37),('14598','2013-08-16','16:55:00',3.29),('14598','2013-08-16','17:00:00',3.22),('14598','2013-08-16','17:05:00',3.12),('14598','2013-08-16','17:10:00',3.04),('14598','2013-08-16','17:15:00',2.96),('14598','2013-08-16','17:20:00',2.85),('14598','2013-08-16','17:25:00',2.78),('14598','2013-08-16','17:30:00',2.69),('14598','2013-08-16','17:35:00',2.6),('14598','2013-08-16','17:40:00',2.5),('14598','2013-08-16','17:45:00',2.41),('14598','2013-08-16','17:50:00',2.33),('14598','2013-08-16','17:55:00',2.24),('14598','2013-08-16','18:00:00',2.12),('14598','2013-08-16','18:05:00',1.98),('14598','2013-08-16','18:10:00',1.96),('14598','2013-08-16','18:15:00',1.84),('14598','2013-08-16','18:20:00',1.04),('14598','2013-08-16','18:25:00',1.36),('14598','2013-08-16','18:30:00',1.63),('14598','2013-08-16','18:35:00',1.53),('14598','2013-08-16','18:40:00',1.42),('14598','2013-08-16','18:45:00',1.31),('14598','2013-08-16','18:50:00',1.16),('14598','2013-08-16','18:55:00',1.09),('14598','2013-08-15','08:40:00',1.11),('14598','2013-08-15','08:45:00',1.45),('14598','2013-08-15','08:50:00',1.52),('14598','2013-08-15','08:55:00',1.65),('14598','2013-08-15','09:00:00',1.74),('14598','2013-08-15','09:05:00',1.86),('14598','2013-08-15','09:10:00',1.96),('14598','2013-08-15','09:15:00',2.07),('14598','2013-08-15','09:20:00',2.15),('14598','2013-08-15','09:25:00',2.24),('14598','2013-08-15','09:30:00',2.34),('14598','2013-08-15','09:35:00',2.42),('14598','2013-08-15','09:40:00',2.5),('14598','2013-08-15','09:45:00',2.59),('14598','2013-08-15','09:50:00',2.67),('14598','2013-08-15','09:55:00',2.76),('14598','2013-08-15','10:00:00',2.85),('14598','2013-08-15','10:05:00',2.95),('14598','2013-08-15','10:10:00',3.01),('14598','2013-08-15','10:15:00',3.08),('14598','2013-08-15','10:20:00',3.16),('14598','2013-08-15','10:25:00',3.23),('14598','2013-08-15','10:30:00',3.29),('14598','2013-08-15','10:35:00',3.35),('14598','2013-08-15','10:40:00',3.42),('14598','2013-08-15','10:45:00',3.47),('14598','2013-08-15','10:50:00',3.55),('14598','2013-08-15','10:55:00',3.61),('14598','2013-08-15','11:00:00',3.67),('14598','2013-08-15','11:05:00',3.72),('14598','2013-08-15','11:10:00',3.79),('14598','2013-08-15','11:15:00',3.84),('14598','2013-08-15','11:20:00',3.89),('14598','2013-08-15','11:25:00',3.94),('14598','2013-08-15','11:30:00',3.99),('14598','2013-08-15','11:35:00',4.04),('14598','2013-08-15','11:40:00',4.08),('14598','2013-08-15','11:45:00',4.14),('14598','2013-08-15','11:50:00',4.19),('14598','2013-08-15','11:55:00',4.23),('14598','2013-08-15','12:00:00',4.22),('14598','2013-08-15','12:05:00',4.28),('14598','2013-08-15','12:10:00',4.33),('14598','2013-08-15','12:15:00',4.36),('14598','2013-08-15','12:20:00',4.41),('14598','2013-08-15','12:25:00',4.44),('14598','2013-08-15','12:30:00',4.45),('14598','2013-08-15','12:35:00',4.5),('14598','2013-08-15','12:40:00',4.5),('14598','2013-08-15','12:45:00',4.51),('14598','2013-08-15','12:50:00',4.5),('14598','2013-08-15','12:55:00',4.51),('14598','2013-08-15','13:00:00',4.48),('14598','2013-08-15','13:05:00',4.49),('14598','2013-08-15','13:10:00',4.51),('14598','2013-08-15','13:15:00',4.54),('14598','2013-08-15','13:20:00',4.53),('14598','2013-08-15','13:25:00',4.55),('14598','2013-08-15','13:30:00',4.53),('14598','2013-08-15','13:35:00',4.52),('14598','2013-08-15','13:40:00',4.55),('14598','2013-08-15','13:45:00',4.56),('14598','2013-08-15','13:50:00',4.52),('14598','2013-08-15','13:55:00',4.52),('14598','2013-08-15','14:00:00',4.5),('14598','2013-08-15','14:05:00',4.46),('14598','2013-08-15','14:10:00',4.44),('14598','2013-08-15','14:15:00',4.48),('14598','2013-08-15','14:20:00',4.45),('14598','2013-08-15','14:25:00',4.44),('14598','2013-08-15','14:30:00',4.38),('14598','2013-08-15','14:35:00',4.38),('14598','2013-08-15','14:40:00',4.36),('14598','2013-08-15','14:45:00',4.33),('14598','2013-08-15','14:50:00',4.3),('14598','2013-08-15','14:55:00',4.27),('14598','2013-08-15','15:00:00',4.28),('14598','2013-08-15','15:05:00',4.25),('14598','2013-08-15','15:10:00',4.3),('14598','2013-08-15','15:15:00',4.27),('14598','2013-08-15','15:20:00',4.26),('14598','2013-08-15','15:25:00',4.22),('14598','2013-08-15','15:30:00',4.18),('14598','2013-08-15','15:35:00',4.12),('14598','2013-08-15','15:40:00',4.08),('14598','2013-08-15','15:45:00',4.05),('14598','2013-08-15','15:50:00',4.03),('14598','2013-08-15','15:55:00',3.98),('14598','2013-08-15','16:00:00',3.9),('14598','2013-08-15','16:05:00',3.83),('14598','2013-08-15','16:10:00',3.8),('14598','2013-08-15','16:15:00',3.79),('14598','2013-08-15','16:20:00',3.74),('14598','2013-08-15','16:25:00',3.7),('14598','2013-08-15','16:30:00',3.65),('14598','2013-08-15','16:35:00',3.59),('14598','2013-08-15','16:40:00',3.28),('14598','2013-08-15','16:45:00',3.32),('14598','2013-08-15','16:50:00',3.36),('14598','2013-08-15','16:55:00',3.08),('14598','2013-08-15','17:00:00',2.74),('14598','2013-08-15','17:05:00',3.07),('14598','2013-08-15','17:10:00',2.95),('14598','2013-08-15','17:15:00',2.87),('14598','2013-08-15','17:20:00',2.78),('14598','2013-08-15','17:25:00',2.74),('14598','2013-08-15','17:30:00',2.54),('14598','2013-08-15','17:35:00',2.54),('14598','2013-08-15','17:40:00',2.46),('14598','2013-08-15','17:45:00',2.37),('14598','2013-08-15','17:50:00',2.23),('14598','2013-08-15','17:55:00',2.12),('14598','2013-08-15','18:00:00',2.01),('14598','2013-08-15','18:05:00',1.79),('14598','2013-08-15','18:10:00',1.65),('14598','2013-08-15','18:15:00',1.6),('14598','2013-08-15','18:20:00',1.56),('14598','2013-08-15','18:25:00',1.44),('14598','2013-08-15','18:30:00',1.35),('14598','2013-08-15','18:35:00',1.28),('14598','2013-08-15','18:40:00',1.14),('14598','2013-08-14','08:25:00',1.04),('14598','2013-08-14','08:30:00',1.12),('14598','2013-08-14','08:35:00',1.18),('14598','2013-08-14','08:40:00',1.27),('14598','2013-08-14','08:45:00',1.36),('14598','2013-08-14','08:50:00',1.48),('14598','2013-08-14','08:55:00',1.62),('14598','2013-08-14','09:00:00',1.73),('14598','2013-08-14','09:05:00',1.79),('14598','2013-08-14','09:10:00',1.94),('14598','2013-08-14','09:15:00',1.56),('14598','2013-08-14','09:20:00',2.08),('14598','2013-08-14','09:25:00',2.39),('14598','2013-08-14','09:30:00',2.24),('14598','2013-08-14','09:35:00',2.41),('14598','2013-08-14','09:40:00',1.74),('14598','2013-08-14','09:45:00',2.32),('14598','2013-08-14','09:50:00',2.48),('14598','2013-08-14','09:55:00',2.79),('14598','2013-08-14','10:00:00',2.61),('14598','2013-08-14','10:05:00',2.87),('14598','2013-08-14','10:10:00',3.02),('14598','2013-08-14','10:15:00',3.06),('14598','2013-08-14','10:20:00',3.15),('14598','2013-08-14','10:25:00',3.17),('14598','2013-08-14','10:30:00',3.25),('14598','2013-08-14','10:35:00',3.25),('14598','2013-08-14','10:40:00',3.23),('14598','2013-08-14','10:45:00',3.18),('14598','2013-08-14','10:50:00',3.22),('14598','2013-08-14','10:55:00',3.53),('14598','2013-08-14','11:00:00',3.68),('14598','2013-08-14','11:05:00',3.71),('14598','2013-08-14','11:10:00',3.84),('14598','2013-08-14','11:15:00',3.87),('14598','2013-08-14','11:20:00',3.92),('14598','2013-08-14','11:25:00',3.92),('14598','2013-08-14','11:30:00',3.96),('14598','2013-08-14','11:35:00',3.81),('14598','2013-08-14','11:40:00',3.91),('14598','2013-08-14','11:45:00',4.17),('14598','2013-08-14','11:50:00',4.21),('14598','2013-08-14','11:55:00',4.22),('14598','2013-08-14','12:00:00',4.38),('14598','2013-08-14','12:05:00',4.39),('14598','2013-08-14','12:10:00',4.48),('14598','2013-08-14','12:15:00',4.35),('14598','2013-08-14','12:20:00',4.38),('14598','2013-08-14','12:25:00',4.19),('14598','2013-08-14','12:30:00',4),('14598','2013-08-14','12:35:00',3.8),('14598','2013-08-14','12:40:00',4.02),('14598','2013-08-14','12:45:00',4.08),('14598','2013-08-14','12:50:00',3.55),('14598','2013-08-14','12:55:00',3.93),('14598','2013-08-14','13:00:00',4.41),('14598','2013-08-14','13:05:00',4.55),('14598','2013-08-14','13:10:00',4.49),('14598','2013-08-14','13:15:00',4.55),('14598','2013-08-14','13:20:00',4.6),('14598','2013-08-14','13:25:00',4.53),('14598','2013-08-14','13:30:00',4.76),('14598','2013-08-14','13:35:00',4.73),('14598','2013-08-14','13:40:00',4.68),('14598','2013-08-14','13:45:00',4.78),('14598','2013-08-14','13:50:00',4.76),('14598','2013-08-14','13:55:00',4.76),('14598','2013-08-14','14:00:00',4.66),('14598','2013-08-14','14:05:00',4.72),('14598','2013-08-14','14:10:00',4.72),('14598','2013-08-14','14:15:00',4.74),('14598','2013-08-14','14:20:00',4.73),('14598','2013-08-14','14:25:00',4.68),('14598','2013-08-14','14:30:00',4.68),('14598','2013-08-14','14:35:00',4.68),('14598','2013-08-14','14:40:00',4.63),('14598','2013-08-14','14:45:00',4.61),('14598','2013-08-14','14:50:00',4.58),('14598','2013-08-14','14:55:00',4.58),('14598','2013-08-14','15:00:00',4.54),('14598','2013-08-14','15:05:00',4.52),('14598','2013-08-14','15:10:00',4.48),('14598','2013-08-14','15:15:00',4.42),('14598','2013-08-14','15:20:00',4.42),('14598','2013-08-14','15:25:00',4.39),('14598','2013-08-14','15:30:00',4.35),('14598','2013-08-14','15:35:00',4.32),('14598','2013-08-14','15:40:00',4.3),('14598','2013-08-14','15:45:00',4.24),('14598','2013-08-14','15:50:00',4.19),('14598','2013-08-14','15:55:00',4.14),('14598','2013-08-14','16:00:00',4.08),('14598','2013-08-14','16:05:00',3.99),('14598','2013-08-14','16:10:00',3.9),('14598','2013-08-14','16:15:00',3.87),('14598','2013-08-14','16:20:00',3.82),('14598','2013-08-14','16:25:00',3.7),('14598','2013-08-14','16:30:00',3.67),('14598','2013-08-14','16:35:00',3.59),('14598','2013-08-14','16:40:00',3.55),('14598','2013-08-14','16:45:00',3.33),('14598','2013-08-14','16:50:00',3.43),('14598','2013-08-14','16:55:00',3.35),('14598','2013-08-14','17:00:00',3.27),('14598','2013-08-14','17:05:00',3.15),('14598','2013-08-14','17:10:00',3.09),('14598','2013-08-14','17:15:00',3.01),('14598','2013-08-14','17:20:00',2.93),('14598','2013-08-14','17:25:00',2.84),('14598','2013-08-14','17:30:00',2.75),('14598','2013-08-14','17:35:00',2.67),('14598','2013-08-14','17:40:00',2.58),('14598','2013-08-14','17:45:00',2.49),('14598','2013-08-14','17:50:00',2.4),('14598','2013-08-14','17:55:00',2.3),('14598','2013-08-14','18:00:00',2.22),('14598','2013-08-14','18:05:00',2.12),('14598','2013-08-14','18:10:00',2.01),('14598','2013-08-14','18:15:00',1.89),('14598','2013-08-14','18:20:00',1.79),('14598','2013-08-14','18:25:00',1.65),('14598','2013-08-14','18:30:00',1.52),('14598','2013-08-14','18:35:00',1.45),('14598','2013-08-14','18:40:00',1.36),('14598','2013-08-14','18:45:00',1.27),('14598','2013-08-14','18:50:00',1.17),('14598','2013-08-14','18:55:00',1.07),('14598','2013-08-13','08:25:00',1.08),('14598','2013-08-13','08:30:00',1.17),('14598','2013-08-13','08:35:00',1.24),('14598','2013-08-13','08:40:00',1.34),('14598','2013-08-13','08:45:00',1.43),('14598','2013-08-13','08:50:00',1.51),('14598','2013-08-13','08:55:00',1.63),('14598','2013-08-13','09:00:00',1.72),('14598','2013-08-13','09:05:00',1.84),('14598','2013-08-13','09:10:00',1.96),('14598','2013-08-13','09:15:00',1.99),('14598','2013-08-13','09:20:00',1.98),('14598','2013-08-13','09:30:00',1.3),('14598','2013-08-13','09:35:00',1.97),('14598','2013-08-13','09:40:00',2.57),('14598','2013-08-13','09:45:00',1.34),('14598','2013-08-13','09:55:00',1.22),('14598','2013-08-13','10:05:00',1.68),('14598','2013-08-13','10:10:00',1.01),('14598','2013-08-13','10:15:00',2.93),('14598','2013-08-13','10:20:00',3.23),('14598','2013-08-13','10:25:00',3.24),('14598','2013-08-13','10:30:00',3.27),('14598','2013-08-13','10:35:00',2.67),('14598','2013-08-13','10:40:00',3.44),('14598','2013-08-13','10:45:00',3.52),('14598','2013-08-13','10:50:00',3.57),('14598','2013-08-13','10:55:00',3.62),('14598','2013-08-13','11:00:00',3.65),('14598','2013-08-13','11:05:00',3.76),('14598','2013-08-13','11:10:00',3.8),('14598','2013-08-13','11:15:00',3.87),('14598','2013-08-13','11:20:00',3.93),('14598','2013-08-13','11:25:00',3.98),('14598','2013-08-13','11:30:00',4.03),('14598','2013-08-13','11:35:00',4.08),('14598','2013-08-13','11:40:00',4.13),('14598','2013-08-13','11:45:00',4.19),('14598','2013-08-13','11:50:00',4.22),('14598','2013-08-13','11:55:00',4.26),('14598','2013-08-13','12:00:00',4.31),('14598','2013-08-13','12:05:00',4.35),('14598','2013-08-13','12:10:00',4.38),('14598','2013-08-13','12:15:00',4.41),('14598','2013-08-13','12:20:00',4.45),('14598','2013-08-13','12:25:00',4.51),('14598','2013-08-13','12:30:00',4.55),('14598','2013-08-13','12:35:00',4.59),('14598','2013-08-13','12:40:00',4.61),('14598','2013-08-13','12:45:00',4.63),('14598','2013-08-13','12:50:00',4.66),('14598','2013-08-13','12:55:00',4.69),('14598','2013-08-13','13:00:00',4.7),('14598','2013-08-13','13:05:00',4.7),('14598','2013-08-13','13:10:00',4.72),('14598','2013-08-13','13:15:00',4.73),('14598','2013-08-13','13:20:00',4.74),('14598','2013-08-13','13:25:00',4.75),('14598','2013-08-13','13:30:00',4.77),('14598','2013-08-13','13:35:00',4.79),('14598','2013-08-13','13:40:00',4.79),('14598','2013-08-13','13:45:00',4.78),('14598','2013-08-13','13:50:00',4.79),('14598','2013-08-13','13:55:00',4.79),('14598','2013-08-13','14:00:00',4.7),('14598','2013-08-13','14:05:00',4.77),('14598','2013-08-13','14:10:00',4.75),('14598','2013-08-13','14:15:00',4.73),('14598','2013-08-13','14:20:00',4.74),('14598','2013-08-13','14:25:00',4.74),('14598','2013-08-13','14:30:00',4.72),('14598','2013-08-13','14:35:00',4.71),('14598','2013-08-13','14:40:00',4.67),('14598','2013-08-13','14:45:00',4.66),('14598','2013-08-13','14:50:00',4.65),('14598','2013-08-13','14:55:00',4.62),('14598','2013-08-13','15:00:00',4.58),('14598','2013-08-13','15:05:00',4.55),('14598','2013-08-13','15:10:00',4.51),('14598','2013-08-13','15:15:00',4.47),('14598','2013-08-13','15:20:00',4.46),('14598','2013-08-13','15:25:00',4.43),('14598','2013-08-13','15:30:00',4.39),('14598','2013-08-13','15:35:00',4.35),('14598','2013-08-13','15:40:00',4.3),('14598','2013-08-13','15:45:00',4.24),('14598','2013-08-13','15:50:00',4.18),('14598','2013-08-13','15:55:00',4.14),('14598','2013-08-13','16:00:00',4.09),('14598','2013-08-13','16:05:00',4.05),('14598','2013-08-13','16:10:00',3.98),('14598','2013-08-13','16:15:00',3.91),('14598','2013-08-13','16:20:00',3.86),('14598','2013-08-13','16:25:00',3.81),('14598','2013-08-13','16:30:00',3.74),('14598','2013-08-13','16:35:00',3.68),('14598','2013-08-13','16:40:00',3.6),('14598','2013-08-13','16:45:00',3.53),('14598','2013-08-13','16:50:00',3.45),('14598','2013-08-13','16:55:00',3.36),('14598','2013-08-13','17:00:00',3.3),('14598','2013-08-13','17:05:00',3.23),('14598','2013-08-13','17:10:00',3.15),('14598','2013-08-13','17:15:00',3.06),('14598','2013-08-13','17:20:00',2.98),('14598','2013-08-13','17:25:00',2.89),('14598','2013-08-13','17:30:00',2.8),('14598','2013-08-13','17:35:00',2.72),('14598','2013-08-13','17:40:00',2.62),('14598','2013-08-13','17:45:00',2.53),('14598','2013-08-13','17:50:00',2.45),('14598','2013-08-13','17:55:00',2.36),('14598','2013-08-13','18:00:00',2.28),('14598','2013-08-13','18:05:00',2.17),('14598','2013-08-13','18:10:00',2.06),('14598','2013-08-13','18:15:00',1.95),('14598','2013-08-13','18:20:00',1.86),('14598','2013-08-13','18:25:00',1.75),('14598','2013-08-13','18:30:00',1.63),('14598','2013-08-13','18:35:00',1.53),('14598','2013-08-13','18:40:00',1.4),('14598','2013-08-13','18:45:00',1.29),('14598','2013-08-13','18:50:00',1.17),('14598','2013-08-13','18:55:00',1.11),('14598','2013-08-12','08:25:00',1.08),('14598','2013-08-12','08:30:00',1.16),('14598','2013-08-12','08:35:00',1.24),('14598','2013-08-12','08:40:00',1.33),('14598','2013-08-12','08:45:00',1.44),('14598','2013-08-12','08:50:00',1.55),('14598','2013-08-12','08:55:00',1.64),('14598','2013-08-12','09:00:00',1.73),('14598','2013-08-12','09:05:00',1.84),('14598','2013-08-12','09:10:00',1.94),('14598','2013-08-12','09:15:00',2.04),('14598','2013-08-12','09:20:00',2.13),('14598','2013-08-12','09:25:00',2.21),('14598','2013-08-12','09:30:00',2.3),('14598','2013-08-12','09:35:00',2.38),('14598','2013-08-12','09:40:00',2.46),('14598','2013-08-12','09:45:00',2.53),('14598','2013-08-12','09:50:00',2.6),('14598','2013-08-12','09:55:00',2.67),('14598','2013-08-12','10:00:00',2.73),('14598','2013-08-12','10:05:00',2.8),('14598','2013-08-12','10:10:00',2.86),('14598','2013-08-12','10:15:00',2.9),('14598','2013-08-12','10:20:00',3),('14598','2013-08-12','10:25:00',3.11),('14598','2013-08-12','10:30:00',3.18),('14598','2013-08-12','10:35:00',3.27),('14598','2013-08-12','10:40:00',3.35),('14598','2013-08-12','10:45:00',3.38),('14598','2013-08-12','10:50:00',3.48),('14598','2013-08-12','10:55:00',3.55),('14598','2013-08-12','11:00:00',3.6),('14598','2013-08-12','11:05:00',3.65),('14598','2013-08-12','11:10:00',3.75),('14598','2013-08-12','11:15:00',3.78),('14598','2013-08-12','11:20:00',3.85),('14598','2013-08-12','11:25:00',3.89),('14598','2013-08-12','11:30:00',3.94),('14598','2013-08-12','11:35:00',3.96),('14598','2013-08-12','11:40:00',4.03),('14598','2013-08-12','11:45:00',4.06),('14598','2013-08-12','11:50:00',4.12),('14598','2013-08-12','11:55:00',4.14),('14598','2013-08-12','12:00:00',4.16),('14598','2013-08-12','12:05:00',4.24),('14598','2013-08-12','12:10:00',4.27),('14598','2013-08-12','12:15:00',4.33),('14598','2013-08-12','12:20:00',4.34),('14598','2013-08-12','12:25:00',4.36),('14598','2013-08-12','12:30:00',4.39),('14598','2013-08-12','12:35:00',4.44),('14598','2013-08-12','12:40:00',4.46),('14598','2013-08-12','12:45:00',4.47),('14598','2013-08-12','12:50:00',4.5),('14598','2013-08-12','12:55:00',4.52),('14598','2013-08-12','13:00:00',4.58),('14598','2013-08-12','13:05:00',4.59),('14598','2013-08-12','13:10:00',4.6),('14598','2013-08-12','13:15:00',4.61),('14598','2013-08-12','13:20:00',4.65),('14598','2013-08-12','13:25:00',4.68),('14598','2013-08-12','13:30:00',4.7),('14598','2013-08-12','13:35:00',4.7),('14598','2013-08-12','13:40:00',4.71),('14598','2013-08-12','13:45:00',4.7),('14598','2013-08-12','13:50:00',4.69),('14598','2013-08-12','13:55:00',4.68),('14598','2013-08-12','14:00:00',4.69),('14598','2013-08-12','14:05:00',4.69),('14598','2013-08-12','14:10:00',4.69),('14598','2013-08-12','14:15:00',4.69),('14598','2013-08-12','14:20:00',4.67),('14598','2013-08-12','14:25:00',4.66),('14598','2013-08-12','14:30:00',4.66),('14598','2013-08-12','14:35:00',4.63),('14598','2013-08-12','14:40:00',4.61),('14598','2013-08-12','14:45:00',4.59),('14598','2013-08-12','14:50:00',4.54),('14598','2013-08-12','14:55:00',4.51),('14598','2013-08-12','15:00:00',4.48),('14598','2013-08-12','15:05:00',4.46),('14598','2013-08-12','15:10:00',4.45),('14598','2013-08-12','15:15:00',4.4),('14598','2013-08-12','15:20:00',4.34),('14598','2013-08-12','15:25:00',4.3),('14598','2013-08-12','15:30:00',4.27),('14598','2013-08-12','15:35:00',4.26),('14598','2013-08-12','15:40:00',4.22),('14598','2013-08-12','15:45:00',4.17),('14598','2013-08-12','15:50:00',4.12),('14598','2013-08-12','15:55:00',4.09),('14598','2013-08-12','16:00:00',4.05),('14598','2013-08-12','16:05:00',3.97),('14598','2013-08-12','16:10:00',3.91),('14598','2013-08-12','16:15:00',3.85),('14598','2013-08-12','16:20:00',3.79),('14598','2013-08-12','16:25:00',3.73),('14598','2013-08-12','16:30:00',3.67),('14598','2013-08-12','16:35:00',3.6),('14598','2013-08-12','16:40:00',3.53),('14598','2013-08-12','16:45:00',3.41),('14598','2013-08-12','16:50:00',3.4),('14598','2013-08-12','16:55:00',3.32),('14598','2013-08-12','17:00:00',3.24),('14598','2013-08-12','17:05:00',3.17),('14598','2013-08-12','17:10:00',3.1),('14598','2013-08-12','17:15:00',3.03),('14598','2013-08-12','17:20:00',2.93),('14598','2013-08-12','17:25:00',2.85),('14598','2013-08-12','17:30:00',2.78),('14598','2013-08-12','17:35:00',2.69),('14598','2013-08-12','17:40:00',2.6),('14598','2013-08-12','17:45:00',2.5),('14598','2013-08-12','17:50:00',2.42),('14598','2013-08-12','17:55:00',2.32),('14598','2013-08-12','18:00:00',2.23),('14598','2013-08-12','18:05:00',2.14),('14598','2013-08-12','18:10:00',2.05),('14598','2013-08-12','18:15:00',1.95),('14598','2013-08-12','18:20:00',1.86),('14598','2013-08-12','18:25:00',1.77),('14598','2013-08-12','18:30:00',1.66),('14598','2013-08-12','18:35:00',1.56),('14598','2013-08-12','18:40:00',1.45),('14598','2013-08-12','18:45:00',1.35),('14598','2013-08-12','18:50:00',1.24),('14598','2013-08-12','18:55:00',1.13),('14598','2013-08-12','19:00:00',1.02),('14598','2013-08-11','08:20:00',1.02),('14598','2013-08-11','08:25:00',1.11),('14598','2013-08-11','08:30:00',1.19),('14598','2013-08-11','08:35:00',1.26),('14598','2013-08-11','08:40:00',1.37),('14598','2013-08-11','08:45:00',1.49),('14598','2013-08-11','08:50:00',1.6),('14598','2013-08-11','08:55:00',1.69),('14598','2013-08-11','09:00:00',1.79),('14598','2013-08-11','09:05:00',1.9),('14598','2013-08-11','09:10:00',2),('14598','2013-08-11','09:15:00',2.11),('14598','2013-08-11','09:20:00',2.2),('14598','2013-08-11','09:25:00',2.29),('14598','2013-08-11','09:30:00',2.38),('14598','2013-08-11','09:35:00',2.46),('14598','2013-08-11','09:40:00',2.54),('14598','2013-08-11','09:45:00',2.62),('14598','2013-08-11','09:50:00',2.7),('14598','2013-08-11','09:55:00',2.78),('14598','2013-08-11','10:00:00',2.86),('14598','2013-08-11','10:05:00',2.94),('14598','2013-08-11','10:10:00',3.01),('14598','2013-08-11','10:15:00',3.1),('14598','2013-08-11','10:20:00',3.16),('14598','2013-08-11','10:25:00',3.24),('14598','2013-08-11','10:30:00',3.3),('14598','2013-08-11','10:35:00',3.36),('14598','2013-08-11','10:40:00',3.39),('14598','2013-08-11','10:45:00',3.5),('14598','2013-08-11','10:50:00',3.55),('14598','2013-08-11','10:55:00',3.61),('14598','2013-08-11','11:00:00',3.69),('14598','2013-08-11','11:05:00',3.73),('14598','2013-08-11','11:10:00',3.79),('14598','2013-08-11','11:15:00',3.85),('14598','2013-08-11','11:20:00',3.9),('14598','2013-08-11','11:25:00',3.93),('14598','2013-08-11','11:30:00',3.99),('14598','2013-08-11','11:35:00',4.03),('14598','2013-08-11','11:40:00',4.06),('14598','2013-08-11','11:45:00',4.08),('14598','2013-08-11','11:50:00',4.11),('14598','2013-08-11','11:55:00',4.11),('14598','2013-08-11','12:00:00',4.18),('14598','2013-08-11','12:05:00',4.24),('14598','2013-08-11','12:10:00',4.29),('14598','2013-08-11','12:15:00',4.3),('14598','2013-08-11','12:20:00',4.32),('14598','2013-08-11','12:25:00',4.32),('14598','2013-08-11','12:30:00',4.32),('14598','2013-08-11','12:35:00',4.39),('14598','2013-08-11','12:40:00',4.5),('14598','2013-08-11','12:45:00',4.59),('14598','2013-08-11','12:50:00',4.63),('14598','2013-08-11','12:55:00',4.66),('14598','2013-08-11','13:00:00',4.66),('14598','2013-08-11','13:05:00',4.68),('14598','2013-08-11','13:10:00',4.7),('14598','2013-08-11','13:15:00',4.71),('14598','2013-08-11','13:20:00',4.74),('14598','2013-08-11','13:25:00',4.75),('14598','2013-08-11','13:30:00',4.74),('14598','2013-08-11','13:35:00',4.76),('14598','2013-08-11','13:40:00',4.77),('14598','2013-08-11','13:45:00',4.7),('14598','2013-08-11','13:50:00',4.77),('14598','2013-08-11','13:55:00',4.77),('14598','2013-08-11','14:00:00',4.76),('14598','2013-08-11','14:05:00',4.76),('14598','2013-08-11','14:10:00',4.75),('14598','2013-08-11','14:15:00',4.75),('14598','2013-08-11','14:20:00',4.76),('14598','2013-08-11','14:25:00',4.72),('14598','2013-08-11','14:30:00',4.73),('14598','2013-08-11','14:35:00',4.71),('14598','2013-08-11','14:40:00',4.69),('14598','2013-08-11','14:45:00',4.68),('14598','2013-08-11','14:50:00',4.64),('14598','2013-08-11','14:55:00',4.63),('14598','2013-08-11','15:00:00',4.57),('14598','2013-08-11','15:05:00',4.55),('14598','2013-08-11','15:10:00',4.53),('14598','2013-08-11','15:15:00',4.48),('14598','2013-08-11','15:20:00',4.46),('14598','2013-08-11','15:25:00',4.42),('14598','2013-08-11','15:30:00',4.29),('14598','2013-08-11','15:35:00',4.34),('14598','2013-08-11','15:40:00',4.28),('14598','2013-08-11','15:45:00',4.23),('14598','2013-08-11','15:50:00',4.18),('14598','2013-08-11','15:55:00',4.14),('14598','2013-08-11','16:00:00',4.1),('14598','2013-08-11','16:05:00',4.03),('14598','2013-08-11','16:10:00',3.97),('14598','2013-08-11','16:15:00',3.92),('14598','2013-08-11','16:20:00',3.87),('14598','2013-08-11','16:25:00',3.81),('14598','2013-08-11','16:30:00',3.74),('14598','2013-08-11','16:35:00',3.67),('14598','2013-08-11','16:40:00',3.6),('14598','2013-08-11','16:45:00',3.5),('14598','2013-08-11','16:50:00',3.47),('14598','2013-08-11','16:55:00',3.39),('14598','2013-08-11','17:00:00',3.31),('14598','2013-08-11','17:05:00',3.21),('14598','2013-08-11','17:10:00',3.14),('14598','2013-08-11','17:15:00',3.06),('14598','2013-08-11','17:20:00',2.98),('14598','2013-08-11','17:25:00',2.89),('14598','2013-08-11','17:30:00',2.8),('14598','2013-08-11','17:35:00',2.7),('14598','2013-08-11','17:40:00',2.61),('14598','2013-08-11','17:45:00',2.53),('14598','2013-08-11','17:50:00',2.43),('14598','2013-08-11','17:55:00',2.33),('14598','2013-08-11','18:00:00',2.23),('14598','2013-08-11','18:05:00',2.13),('14598','2013-08-11','18:10:00',2.02),('14598','2013-08-11','18:15:00',1.93),('14598','2013-08-11','18:20:00',1.83),('14598','2013-08-11','18:25:00',1.72),('14598','2013-08-11','18:30:00',1.58),('14598','2013-08-11','18:35:00',1.51),('14598','2013-08-11','18:40:00',1.4),('14598','2013-08-11','18:45:00',1.3),('14598','2013-08-11','18:50:00',1.19),('14598','2013-08-11','18:55:00',1.08),('14598','2013-08-10','08:20:00',1.04),('14598','2013-08-10','08:25:00',1.12),('14598','2013-08-10','08:30:00',1.22),('14598','2013-08-10','08:35:00',1.3),('14598','2013-08-10','08:40:00',1.39),('14598','2013-08-10','08:45:00',1.52),('14598','2013-08-10','08:50:00',1.62),('14598','2013-08-10','08:55:00',1.72),('14598','2013-08-10','09:00:00',1.81),('14598','2013-08-10','09:05:00',1.9),('14598','2013-08-10','09:10:00',1.99),('14598','2013-08-10','09:15:00',2.11),('14598','2013-08-10','09:20:00',2.22),('14598','2013-08-10','09:25:00',2.31),('14598','2013-08-10','09:30:00',2.39),('14598','2013-08-10','09:35:00',2.48),('14598','2013-08-10','09:40:00',2.57),('14598','2013-08-10','09:45:00',2.64),('14598','2013-08-10','09:50:00',2.75),('14598','2013-08-10','09:55:00',2.82),('14598','2013-08-10','10:00:00',2.91),('14598','2013-08-10','10:05:00',2.98),('14598','2013-08-10','10:10:00',3.04),('14598','2013-08-10','10:15:00',3.14),('14598','2013-08-10','10:20:00',3.18),('14598','2013-08-10','10:25:00',3.23),('14598','2013-08-10','10:30:00',3.3),('14598','2013-08-10','10:35:00',3.37),('14598','2013-08-10','10:40:00',3.45),('14598','2013-08-10','10:45:00',3.5),('14598','2013-08-10','10:50:00',3.55),('14598','2013-08-10','10:55:00',3.6),('14598','2013-08-10','11:00:00',3.68),('14598','2013-08-10','11:05:00',3.69),('14598','2013-08-10','11:10:00',3.77),('14598','2013-08-10','11:15:00',3.81),('14598','2013-08-10','11:20:00',3.88),('14598','2013-08-10','11:25:00',3.97),('14598','2013-08-10','11:30:00',4),('14598','2013-08-10','11:35:00',4.13),('14598','2013-08-10','11:40:00',4.37),('14598','2013-08-10','11:45:00',3.42),('14598','2013-08-10','11:50:00',2.15),('14598','2013-08-10','11:55:00',1.75),('14598','2013-08-10','12:00:00',1.96),('14598','2013-08-10','12:05:00',1.37),('14598','2013-08-10','12:10:00',3.53),('14598','2013-08-10','12:15:00',4.19),('14598','2013-08-10','12:20:00',4.41),('14598','2013-08-10','12:25:00',4.38),('14598','2013-08-10','12:30:00',4.33),('14598','2013-08-10','12:35:00',2.15),('14598','2013-08-10','12:40:00',4.09),('14598','2013-08-10','12:45:00',4.5),('14598','2013-08-10','12:50:00',4.47),('14598','2013-08-10','12:55:00',4.43),('14598','2013-08-10','13:00:00',4.42),('14598','2013-08-10','13:05:00',4.6),('14598','2013-08-10','13:10:00',4.71),('14598','2013-08-10','13:15:00',4.65),('14598','2013-08-10','13:20:00',4.77),('14598','2013-08-10','13:25:00',4.78),('14598','2013-08-10','13:30:00',4.79),('14598','2013-08-10','13:35:00',4.81),('14598','2013-08-10','13:40:00',4.89),('14598','2013-08-10','13:45:00',4.89),('14598','2013-08-10','13:50:00',4.79),('14598','2013-08-10','13:55:00',4.84),('14598','2013-08-10','14:00:00',4.86),('14598','2013-08-10','14:05:00',5),('14598','2013-08-10','14:10:00',4.39),('14598','2013-08-10','14:15:00',4.92),('14598','2013-08-10','14:20:00',4.4),('14598','2013-08-10','14:25:00',3.81),('14598','2013-08-10','14:30:00',4.94),('14598','2013-08-10','14:35:00',4.27),('14598','2013-08-10','14:40:00',4.84),('14598','2013-08-10','14:45:00',4.88),('14598','2013-08-10','14:50:00',5.11),('14598','2013-08-10','14:55:00',5.25),('14598','2013-08-10','15:00:00',2.41),('14598','2013-08-10','15:05:00',1.31),('14598','2013-08-10','15:10:00',1.27),('14598','2013-08-10','16:10:00',1.16),('14598','2013-08-10','16:15:00',1.41),('14598','2013-08-10','16:20:00',2.15),('14598','2013-08-10','16:25:00',2.84),('14598','2013-08-10','16:30:00',4.7),('14598','2013-08-10','16:35:00',2.63),('14598','2013-08-10','16:40:00',2.23),('14598','2013-08-10','16:45:00',4.35),('14598','2013-08-10','16:50:00',4.25),('14598','2013-08-10','16:55:00',2.97),('14598','2013-08-10','17:00:00',1.51),('14598','2013-08-10','17:05:00',1.09),('14598','2013-08-10','17:10:00',1.14),('14598','2013-08-10','17:15:00',1.4),('14598','2013-08-10','17:20:00',1.01),('14598','2013-08-10','17:35:00',1.45),('14598','2014-04-09','08:55:00',1.37),('14598','2014-04-09','09:00:00',2.1),('14598','2014-04-09','09:05:00',1.42),('14598','2014-04-09','09:25:00',2.2),('14598','2014-04-09','09:30:00',1.55),('14598','2014-04-09','09:35:00',1.63),('14598','2014-04-09','09:40:00',1.72),('14598','2014-04-09','09:45:00',2.62),('14598','2014-04-09','09:50:00',2.64),('14598','2014-04-09','09:55:00',2.74),('14598','2014-04-09','10:00:00',2.84),('14598','2014-04-09','10:05:00',2.92),('14598','2014-04-09','10:10:00',3.03),('14598','2014-04-09','10:15:00',3.1),('14598','2014-04-09','10:20:00',3.18),('14598','2014-04-09','10:25:00',3.27),('14598','2014-04-09','10:30:00',3.37),('14598','2014-04-09','10:35:00',3.47),('14598','2014-04-09','10:40:00',3.54),('14598','2014-04-09','10:45:00',3.6),('14598','2014-04-09','10:50:00',3.69),('14598','2014-04-09','10:55:00',3.78),('14598','2014-04-09','11:00:00',3.88),('14598','2014-04-09','11:05:00',3.96),('14598','2014-04-09','11:10:00',4.02),('14598','2014-04-09','11:15:00',4.06),('14598','2014-04-09','11:20:00',4.13),('14598','2014-04-09','11:25:00',4.15),('14598','2014-04-09','11:30:00',4.18),('14598','2014-04-09','11:35:00',4.28),('14598','2014-04-09','11:40:00',4.35),('14598','2014-04-09','11:45:00',4.41),('14598','2014-04-09','11:50:00',4.43),('14598','2014-04-09','11:55:00',4.46),('14598','2014-04-09','12:00:00',4.5),('14598','2014-04-09','12:05:00',4.52),('14598','2014-04-09','12:10:00',4.54),('14598','2014-04-09','12:15:00',4.58),('14598','2014-04-09','12:20:00',4.58),('14598','2014-04-09','12:25:00',4.63),('14598','2014-04-09','12:30:00',4.68),('14598','2014-04-09','12:35:00',4.7),('14598','2014-04-09','12:40:00',4.72),('14598','2014-04-09','12:45:00',4.74),('14598','2014-04-09','12:50:00',4.75),('14598','2014-04-09','12:55:00',4.78),('14598','2014-04-09','13:00:00',4.84),('14598','2014-04-09','13:05:00',4.87),('14598','2014-04-09','13:10:00',4.89),('14598','2014-04-09','13:15:00',4.85),('14598','2014-04-09','13:20:00',4.92),('14598','2014-04-09','13:25:00',4.92),('14598','2014-04-09','13:30:00',4.93),('14598','2014-04-09','13:35:00',4.91),('14598','2014-04-09','13:40:00',4.93),('14598','2014-04-09','13:45:00',4.94),('14598','2014-04-09','13:50:00',4.93),('14598','2014-04-09','13:55:00',4.91),('14598','2014-04-09','14:00:00',4.91),('14598','2014-04-09','14:05:00',4.91),('14598','2014-04-09','14:10:00',4.9),('14598','2014-04-09','14:15:00',4.88),('14598','2014-04-09','14:20:00',4.87),('14598','2014-04-09','14:25:00',4.84),('14598','2014-04-09','14:30:00',4.78),('14598','2014-04-09','14:35:00',4.81),('14598','2014-04-09','14:40:00',4.76),('14598','2014-04-09','14:45:00',4.74),('14598','2014-04-09','14:50:00',4.71),('14598','2014-04-09','14:55:00',4.66),('14598','2014-04-09','15:00:00',4.62),('14598','2014-04-09','15:05:00',4.58),('14598','2014-04-09','15:10:00',4.55),('14598','2014-04-09','15:15:00',4.51),('14598','2014-04-09','15:20:00',4.46),('14598','2014-04-09','15:25:00',4.43),('14598','2014-04-09','15:30:00',4.38),('14598','2014-04-09','15:35:00',4.32),('14598','2014-04-09','15:40:00',4.27),('14598','2014-04-09','15:45:00',4.21),('14598','2014-04-09','15:50:00',4.16),('14598','2014-04-09','15:55:00',4.06),('14598','2014-04-09','16:00:00',4.01),('14598','2014-04-09','16:05:00',3.95),('14598','2014-04-09','16:10:00',3.85),('14598','2014-04-09','16:15:00',3.77),('14598','2014-04-09','16:20:00',3.7),('14598','2014-04-09','16:25:00',3.67),('14598','2014-04-09','16:30:00',3.62),('14598','2014-04-09','16:35:00',3.3),('14598','2014-04-09','16:40:00',3.4),('14598','2014-04-09','16:45:00',3.34),('14598','2014-04-09','16:50:00',3.25),('14598','2014-04-09','16:55:00',3.19),('14598','2014-04-09','17:00:00',3.12),('14598','2014-04-09','17:05:00',2.94),('14598','2014-04-09','17:10:00',2.91),('14598','2014-04-09','17:15:00',2.38),('14598','2014-04-09','17:20:00',2.64),('14598','2014-04-09','17:25:00',2.57),('14598','2014-04-09','17:30:00',2.19),('14598','2014-04-09','17:35:00',2.3),('14598','2014-04-09','17:40:00',2.21),('14598','2014-04-09','17:45:00',2.28),('14598','2014-04-09','17:50:00',2.31),('14598','2014-04-09','17:55:00',2.31),('14598','2014-04-09','18:00:00',1.06),('14598','2013-08-09','08:20:00',1.09),('14598','2013-08-09','08:25:00',1.31),('14598','2013-08-09','08:30:00',1.42),('14598','2013-08-09','08:35:00',1.54),('14598','2013-08-09','08:40:00',1.6),('14598','2013-08-09','08:45:00',1.68),('14598','2013-08-09','08:50:00',1.92),('14598','2013-08-09','08:55:00',1.85),('14598','2013-08-09','09:00:00',1.43),('14598','2013-08-09','09:05:00',1.09),('14598','2013-08-09','09:20:00',1.16),('14598','2013-08-09','09:25:00',1.39),('14598','2013-08-09','09:30:00',1.56),('14598','2013-08-09','09:35:00',1.71),('14598','2013-08-09','09:40:00',1.5),('14598','2013-08-09','09:45:00',1.04),('14598','2013-08-09','09:50:00',2.13),('14598','2013-08-09','09:55:00',2.73),('14598','2013-08-09','10:00:00',2.74),('14598','2013-08-09','10:05:00',2.77),('14598','2013-08-09','10:10:00',2.89),('14598','2013-08-09','10:15:00',2.95),('14598','2013-08-09','10:20:00',3.04),('14598','2013-08-09','10:25:00',3.1),('14598','2013-08-09','10:30:00',3.22),('14598','2013-08-09','10:35:00',3.26),('14598','2013-08-09','10:40:00',3.28),('14598','2013-08-09','10:45:00',3.33),('14598','2013-08-09','10:50:00',3.42),('14598','2013-08-09','10:55:00',3.47),('14598','2013-08-09','11:00:00',3.53),('14598','2013-08-09','11:05:00',3.57),('14598','2013-08-09','11:10:00',3.69),('14598','2013-08-09','11:15:00',3.71),('14598','2013-08-09','11:20:00',3.79),('14598','2013-08-09','11:25:00',3.89),('14598','2013-08-09','11:30:00',3.96),('14598','2013-08-09','11:35:00',4.13),('14598','2013-08-09','11:40:00',4.56),('14598','2013-08-09','11:45:00',4.77),('14598','2013-08-09','11:50:00',3.7),('14598','2013-08-09','11:55:00',2.55),('14598','2013-08-09','12:00:00',1.91),('14598','2013-08-09','12:05:00',1.96),('14598','2013-08-09','12:10:00',1.88),('14598','2013-08-09','12:15:00',2.16),('14598','2013-08-09','12:20:00',2.36),('14598','2013-08-09','12:25:00',2.21),('14598','2013-08-09','12:30:00',1.35),('14598','2013-08-09','12:35:00',1.29),('14598','2013-08-09','12:40:00',1.2),('14598','2013-08-09','12:45:00',1.25),('14598','2013-08-09','12:50:00',1.95),('14598','2013-08-09','12:55:00',2.42),('14598','2013-08-09','13:00:00',2.59),('14598','2013-08-09','13:05:00',2.19),('14598','2013-08-09','13:10:00',2.28),('14598','2013-08-09','13:15:00',2.41),('14598','2013-08-09','13:20:00',1.92),('14598','2013-08-09','13:25:00',1.27),('14598','2013-08-09','13:30:00',1.14),('14598','2013-08-09','13:35:00',1.4),('14598','2013-08-09','13:40:00',1.54),('14598','2013-08-09','13:45:00',1.39),('14598','2013-08-09','13:50:00',1.38),('14598','2013-08-09','13:55:00',1.25),('14598','2013-08-09','14:00:00',1.21),('14598','2013-08-09','14:05:00',1.07),('14598','2013-08-09','14:10:00',1.18),('14598','2013-08-09','14:15:00',1.13),('14598','2013-08-09','14:20:00',1.04),('14598','2013-08-09','15:05:00',1.38),('14598','2013-08-09','15:45:00',1.15),('14598','2013-08-09','15:50:00',1.17),('14598','2013-08-09','15:55:00',1.85),('14598','2013-08-09','16:00:00',3.26),('14598','2013-08-09','16:05:00',2.43),('14598','2013-08-09','17:15:00',1.18),('14598','2013-08-09','17:20:00',1.2),('14598','2013-08-09','17:25:00',1.36),('14598','2013-08-09','17:30:00',2.11),('14598','2013-08-09','17:35:00',1.21),('14598','2013-08-09','18:10:00',1.02),('14598','2013-08-09','18:35:00',1.29),('14598','2013-08-09','18:40:00',1.21),('14598','2013-08-09','18:50:00',1.34),('14598','2013-08-09','18:55:00',1.12),('14598','2013-08-09','19:00:00',1.03),('14598','2013-08-08','08:20:00',1.01),('14598','2013-08-08','08:25:00',1.11),('14598','2013-08-08','08:30:00',1.19),('14598','2013-08-08','08:35:00',1.29),('14598','2013-08-08','08:40:00',1.4),('14598','2013-08-08','08:45:00',1.49),('14598','2013-08-08','08:50:00',1.58),('14598','2013-08-08','08:55:00',1.66),('14598','2013-08-08','09:00:00',1.76),('14598','2013-08-08','09:05:00',1.87),('14598','2013-08-08','09:10:00',1.97),('14598','2013-08-08','09:15:00',2.04),('14598','2013-08-08','09:20:00',2.1),('14598','2013-08-08','09:25:00',2.2),('14598','2013-08-08','09:30:00',2.29),('14598','2013-08-08','09:35:00',2.35),('14598','2013-08-08','09:40:00',2.43),('14598','2013-08-08','09:45:00',2.5),('14598','2013-08-08','09:50:00',2.58),('14598','2013-08-08','09:55:00',2.71),('14598','2013-08-08','10:00:00',2.81),('14598','2013-08-08','10:05:00',2.88),('14598','2013-08-08','10:10:00',2.97),('14598','2013-08-08','10:15:00',3.06),('14598','2013-08-08','10:20:00',3.15),('14598','2013-08-08','10:25:00',3.24),('14598','2013-08-08','10:30:00',3.31),('14598','2013-08-08','10:35:00',3.38),('14598','2013-08-08','10:40:00',3.44),('14598','2013-08-08','10:45:00',3.52),('14598','2013-08-08','10:50:00',3.57),('14598','2013-08-08','10:55:00',3.63),('14598','2013-08-08','11:00:00',3.68),('14598','2013-08-08','11:05:00',3.75),('14598','2013-08-08','11:10:00',3.82),('14598','2013-08-08','11:15:00',3.89),('14598','2013-08-08','11:20:00',3.94),('14598','2013-08-08','11:25:00',3.97),('14598','2013-08-08','11:30:00',4.04),('14598','2013-08-08','11:35:00',4.1),('14598','2013-08-08','11:40:00',4.15),('14598','2013-08-08','11:45:00',4.18),('14598','2013-08-08','11:50:00',4.21),('14598','2013-08-08','11:55:00',4.25),('14598','2013-08-08','12:00:00',4.3),('14598','2013-08-08','12:05:00',4.36),('14598','2013-08-08','12:10:00',4.38),('14598','2013-08-08','12:15:00',4.41),('14598','2013-08-08','12:20:00',4.44),('14598','2013-08-08','12:25:00',4.45),('14598','2013-08-08','12:30:00',4.46),('14598','2013-08-08','12:35:00',4.48),('14598','2013-08-08','12:40:00',4.51),('14598','2013-08-08','12:45:00',4.54),('14598','2013-08-08','12:50:00',4.54),('14598','2013-08-08','12:55:00',4.55),('14598','2013-08-08','13:00:00',4.56),('14598','2013-08-08','13:05:00',4.59),('14598','2013-08-08','13:10:00',4.59),('14598','2013-08-08','13:15:00',4.62),('14598','2013-08-08','13:20:00',4.63),('14598','2013-08-08','13:25:00',4.64),('14598','2013-08-08','13:30:00',4.66),('14598','2013-08-08','13:35:00',4.68),('14598','2013-08-08','13:40:00',4.66),('14598','2013-08-08','13:45:00',4.64),('14598','2013-08-08','13:50:00',4.66),('14598','2013-08-08','13:55:00',4.65),('14598','2013-08-08','14:00:00',4.64),('14598','2013-08-08','14:05:00',4.63),('14598','2013-08-08','14:10:00',4.63),('14598','2013-08-08','14:15:00',4.63),('14598','2013-08-08','14:20:00',4.61),('14598','2013-08-08','14:25:00',4.54),('14598','2013-08-08','14:30:00',4.57),('14598','2013-08-08','14:35:00',4.55),('14598','2013-08-08','14:40:00',4.53),('14598','2013-08-08','14:45:00',4.51),('14598','2013-08-08','14:50:00',4.48),('14598','2013-08-08','14:55:00',4.44),('14598','2013-08-08','15:00:00',4.42),('14598','2013-08-08','15:05:00',4.39),('14598','2013-08-08','15:10:00',4.36),('14598','2013-08-08','15:15:00',4.34),('14598','2013-08-08','15:20:00',4.31),('14598','2013-08-08','15:25:00',4.26),('14598','2013-08-08','15:30:00',4.22),('14598','2013-08-08','15:35:00',4.17),('14598','2013-08-08','15:40:00',4.13),('14598','2013-08-08','15:45:00',4.09),('14598','2013-08-08','15:50:00',4.05),('14598','2013-08-08','15:55:00',4.01),('14598','2013-08-08','16:00:00',3.95),('14598','2013-08-08','16:05:00',3.92),('14598','2013-08-08','16:10:00',3.82),('14598','2013-08-08','16:15:00',3.82),('14598','2013-08-08','16:20:00',3.77),('14598','2013-08-08','16:25:00',3.71),('14598','2013-08-08','16:30:00',3.64),('14598','2013-08-08','16:35:00',3.57),('14598','2013-08-08','16:40:00',3.5),('14598','2013-08-08','16:45:00',3.43),('14598','2013-08-08','16:50:00',3.38),('14598','2013-08-08','16:55:00',3.32),('14598','2013-08-08','17:00:00',3.24),('14598','2013-08-08','17:05:00',3.16),('14598','2013-08-08','17:10:00',3.07),('14598','2013-08-08','17:15:00',3),('14598','2013-08-08','17:20:00',2.93),('14598','2013-08-08','17:25:00',2.85),('14598','2013-08-08','17:30:00',2.77),('14598','2013-08-08','17:35:00',2.69),('14598','2013-08-08','17:40:00',2.59),('14598','2013-08-08','17:45:00',2.5),('14598','2013-08-08','17:50:00',2.41),('14598','2013-08-08','17:55:00',2.31),('14598','2013-08-08','18:00:00',2.21),('14598','2013-08-08','18:05:00',2.11),('14598','2013-08-08','18:10:00',2.03),('14598','2013-08-08','18:15:00',1.93),('14598','2013-08-08','18:20:00',1.82),('14598','2013-08-08','18:25:00',1.71),('14598','2013-08-08','18:30:00',1.6),('14598','2013-08-08','18:35:00',1.51),('14598','2013-08-08','18:40:00',1.4),('14598','2013-08-08','18:45:00',1.29),('14598','2013-08-08','18:50:00',1.19),('14598','2013-08-08','18:55:00',1.1),('14598','2013-08-07','08:20:00',1.06),('14598','2013-08-07','08:25:00',1.14),('14598','2013-08-07','08:30:00',1.23),('14598','2013-08-07','08:35:00',1.33),('14598','2013-08-07','08:40:00',1.43),('14598','2013-08-07','08:45:00',1.52),('14598','2013-08-07','08:50:00',1.61),('14598','2013-08-07','08:55:00',1.69),('14598','2013-08-07','09:00:00',1.79),('14598','2013-08-07','09:05:00',1.86),('14598','2013-08-07','09:10:00',1.98),('14598','2013-08-07','09:15:00',2.1),('14598','2013-08-07','09:20:00',2.11),('14598','2013-08-07','09:25:00',2.21),('14598','2013-08-07','09:30:00',2.34),('14598','2013-08-07','09:35:00',2.41),('14598','2013-08-07','09:40:00',2.47),('14598','2013-08-07','09:45:00',2.52),('14598','2013-08-07','09:50:00',2.61),('14598','2013-08-07','09:55:00',2.77),('14598','2013-08-07','10:00:00',2.84),('14598','2013-08-07','10:05:00',2.96),('14598','2013-08-07','10:10:00',3.02),('14598','2013-08-07','10:15:00',3.12),('14598','2013-08-07','10:20:00',3.2),('14598','2013-08-07','10:25:00',3.27),('14598','2013-08-07','10:30:00',3.34),('14598','2013-08-07','10:35:00',3.42),('14598','2013-08-07','10:40:00',3.47),('14598','2013-08-07','10:45:00',3.55),('14598','2013-08-07','10:50:00',3.62),('14598','2013-08-07','10:55:00',3.68),('14598','2013-08-07','11:00:00',3.73),('14598','2013-08-07','11:05:00',3.81),('14598','2013-08-07','11:10:00',3.86),('14598','2013-08-07','11:15:00',3.93),('14598','2013-08-07','11:20:00',3.97),('14598','2013-08-07','11:25:00',4.03),('14598','2013-08-07','11:30:00',4.05),('14598','2013-08-07','11:35:00',4.11),('14598','2013-08-07','11:40:00',4.16),('14598','2013-08-07','11:45:00',4.21),('14598','2013-08-07','11:50:00',4.26),('14598','2013-08-07','11:55:00',4.31),('14598','2013-08-07','12:00:00',4.35),('14598','2013-08-07','12:05:00',4.38),('14598','2013-08-07','12:10:00',4.39),('14598','2013-08-07','12:15:00',4.43),('14598','2013-08-07','12:20:00',4.46),('14598','2013-08-07','12:25:00',4.42),('14598','2013-08-07','12:30:00',4.54),('14598','2013-08-07','12:35:00',4.58),('14598','2013-08-07','12:40:00',4.59),('14598','2013-08-07','12:45:00',4.61),('14598','2013-08-07','12:50:00',4.64),('14598','2013-08-07','12:55:00',4.67),('14598','2013-08-07','13:00:00',4.71),('14598','2013-08-07','13:05:00',4.74),('14598','2013-08-07','13:10:00',4.74),('14598','2013-08-07','13:15:00',4.73),('14598','2013-08-07','13:20:00',4.74),('14598','2013-08-07','13:25:00',4.7),('14598','2013-08-07','13:30:00',4.72),('14598','2013-08-07','13:35:00',4.72),('14598','2013-08-07','13:40:00',4.73),('14598','2013-08-07','13:45:00',4.75),('14598','2013-08-07','13:50:00',4.75),('14598','2013-08-07','13:55:00',4.77),('14598','2013-08-07','14:00:00',4.77),('14598','2013-08-07','14:05:00',4.73),('14598','2013-08-07','14:10:00',4.74),('14598','2013-08-07','14:15:00',4.74),('14598','2013-08-07','14:20:00',4.69),('14598','2013-08-07','14:25:00',4.67),('14598','2013-08-07','14:30:00',4.65),('14598','2013-08-07','14:35:00',4.66),('14598','2013-08-07','14:40:00',4.64),('14598','2013-08-07','14:45:00',4.64),('14598','2013-08-07','14:50:00',4.62),('14598','2013-08-07','14:55:00',4.58),('14598','2013-08-07','15:00:00',4.55),('14598','2013-08-07','15:05:00',4.52),('14598','2013-08-07','15:10:00',4.49),('14598','2013-08-07','15:15:00',4.48),('14598','2013-08-07','15:20:00',4.45),('14598','2013-08-07','15:25:00',4.33),('14598','2013-08-07','15:30:00',4.38),('14598','2013-08-07','15:35:00',4.33),('14598','2013-08-07','15:40:00',4.27),('14598','2013-08-07','15:45:00',4.24),('14598','2013-08-07','15:50:00',4.2),('14598','2013-08-07','15:55:00',4.15),('14598','2013-08-07','16:00:00',4.1),('14598','2013-08-07','16:05:00',4.04),('14598','2013-08-07','16:10:00',3.98),('14598','2013-08-07','16:15:00',3.91),('14598','2013-08-07','16:20:00',3.85),('14598','2013-08-07','16:25:00',3.78),('14598','2013-08-07','16:30:00',3.71),('14598','2013-08-07','16:35:00',3.64),('14598','2013-08-07','16:40:00',3.57),('14598','2013-08-07','16:45:00',3.52),('14598','2013-08-07','16:50:00',3.44),('14598','2013-08-07','16:55:00',3.37),('14598','2013-08-07','17:00:00',3.31),('14598','2013-08-07','17:05:00',3.23),('14598','2013-08-07','17:10:00',3.14),('14598','2013-08-07','17:15:00',3.07),('14598','2013-08-07','17:20:00',2.99),('14598','2013-08-07','17:25:00',2.9),('14598','2013-08-07','17:30:00',2.81),('14598','2013-08-07','17:35:00',2.72),('14598','2013-08-07','17:40:00',2.63),('14598','2013-08-07','17:45:00',2.53),('14598','2013-08-07','17:50:00',2.41),('14598','2013-08-07','17:55:00',2.3),('14598','2013-08-07','18:00:00',2.23),('14598','2013-08-07','18:05:00',2.15),('14598','2013-08-07','18:10:00',2.04),('14598','2013-08-07','18:15:00',1.91),('14598','2013-08-07','18:20:00',1.81),('14598','2013-08-07','18:25:00',1.71),('14598','2013-08-07','18:30:00',1.51),('14598','2013-08-07','18:35:00',1.51),('14598','2013-08-07','18:40:00',1.29),('14598','2013-08-07','18:45:00',1.29),('14598','2013-08-07','18:50:00',1.2),('14598','2013-08-07','18:55:00',1.13),('14598','2013-08-07','19:00:00',1.02),('14598','2013-08-06','08:20:00',1.03),('14598','2013-08-06','08:25:00',1.13),('14598','2013-08-06','08:30:00',1.22),('14598','2013-08-06','08:35:00',1.3),('14598','2013-08-06','08:40:00',1.4),('14598','2013-08-06','08:45:00',1.48),('14598','2013-08-06','08:50:00',1.57),('14598','2013-08-06','08:55:00',1.67),('14598','2013-08-06','09:00:00',1.75),('14598','2013-08-06','09:05:00',1.84),('14598','2013-08-06','09:10:00',1.93),('14598','2013-08-06','09:15:00',2.02),('14598','2013-08-06','09:20:00',1.92),('14598','2013-08-06','09:25:00',2.3),('14598','2013-08-06','09:30:00',2.34),('14598','2013-08-06','09:35:00',2.23),('14598','2013-08-06','09:40:00',2.56),('14598','2013-08-06','09:45:00',2.64),('14598','2013-08-06','09:50:00',2.75),('14598','2013-08-06','09:55:00',2.74),('14598','2013-08-06','10:00:00',2.82),('14598','2013-08-06','10:05:00',2.91),('14598','2013-08-06','10:10:00',3.01),('14598','2013-08-06','10:15:00',3.09),('14598','2013-08-06','10:20:00',3.16),('14598','2013-08-06','10:25:00',3.24),('14598','2013-08-06','10:30:00',3.3),('14598','2013-08-06','10:35:00',3.37),('14598','2013-08-06','10:40:00',3.42),('14598','2013-08-06','10:45:00',3.49),('14598','2013-08-06','10:50:00',3.57),('14598','2013-08-06','10:55:00',3.64),('14598','2013-08-06','11:00:00',3.7),('14598','2013-08-06','11:05:00',3.76),('14598','2013-08-06','11:10:00',3.82),('14598','2013-08-06','11:15:00',3.89),('14598','2013-08-06','11:20:00',3.94),('14598','2013-08-06','11:25:00',3.99),('14598','2013-08-06','11:30:00',4.04),('14598','2013-08-06','11:35:00',4.1),('14598','2013-08-06','11:40:00',4.12),('14598','2013-08-06','11:45:00',4.18),('14598','2013-08-06','11:50:00',4.23),('14598','2013-08-06','11:55:00',4.28),('14598','2013-08-06','12:00:00',4.32),('14598','2013-08-06','12:05:00',4.36),('14598','2013-08-06','12:10:00',4.4),('14598','2013-08-06','12:15:00',4.44),('14598','2013-08-06','12:20:00',4.49),('14598','2013-08-06','12:25:00',4.53),('14598','2013-08-06','12:30:00',4.55),('14598','2013-08-06','12:35:00',4.58),('14598','2013-08-06','12:40:00',4.61),('14598','2013-08-06','12:45:00',4.62),('14598','2013-08-06','12:50:00',4.64),('14598','2013-08-06','12:55:00',4.61),('14598','2013-08-06','13:00:00',4.65),('14598','2013-08-06','13:05:00',4.66),('14598','2013-08-06','13:10:00',4.67),('14598','2013-08-06','13:15:00',4.71),('14598','2013-08-06','13:20:00',4.75),('14598','2013-08-06','13:25:00',4.76),('14598','2013-08-06','13:30:00',4.76),('14598','2013-08-06','13:35:00',4.79),('14598','2013-08-06','13:40:00',4.76),('14598','2013-08-06','13:45:00',4.77),('14598','2013-08-06','13:50:00',4.77),('14598','2013-08-06','13:55:00',4.78),('14598','2013-08-06','14:00:00',4.77),('14598','2013-08-06','14:05:00',4.75),('14598','2013-08-06','14:10:00',4.74),('14598','2013-08-06','14:15:00',4.75),('14598','2013-08-06','14:20:00',4.74),('14598','2013-08-06','14:25:00',4.73),('14598','2013-08-06','14:30:00',4.73),('14598','2013-08-06','14:35:00',4.71),('14598','2013-08-06','14:40:00',4.64),('14598','2013-08-06','14:45:00',4.7),('14598','2013-08-06','14:50:00',4.68),('14598','2013-08-06','14:55:00',4.65),('14598','2013-08-06','15:00:00',4.62),('14598','2013-08-06','15:05:00',4.59),('14598','2013-08-06','15:10:00',4.52),('14598','2013-08-06','15:15:00',4.48),('14598','2013-08-06','15:20:00',4.45),('14598','2013-08-06','15:25:00',4.42),('14598','2013-08-06','15:30:00',4.38),('14598','2013-08-06','15:35:00',4.34),('14598','2013-08-06','15:40:00',4.31),('14598','2013-08-06','15:45:00',4.28),('14598','2013-08-06','15:50:00',4.25),('14598','2013-08-06','15:55:00',4.19),('14598','2013-08-06','16:00:00',4.13),('14598','2013-08-06','16:05:00',4.06),('14598','2013-08-06','16:10:00',4.03),('14598','2013-08-06','16:15:00',3.96),('14598','2013-08-06','16:20:00',3.92),('14598','2013-08-06','16:25:00',3.85),('14598','2013-08-06','16:30:00',3.79),('14598','2013-08-06','16:35:00',3.73),('14598','2013-08-06','16:40:00',3.66),('14598','2013-08-06','16:45:00',3.59),('14598','2013-08-06','16:50:00',3.52),('14598','2013-08-06','16:55:00',3.44),('14598','2013-08-06','17:00:00',3.37),('14598','2013-08-06','17:05:00',3.29),('14598','2013-08-06','17:10:00',3.22),('14598','2013-08-06','17:15:00',3.13),('14598','2013-08-06','17:20:00',3.04),('14598','2013-08-06','17:25:00',2.97),('14598','2013-08-06','17:30:00',2.84),('14598','2013-08-06','17:35:00',2.86),('14598','2013-08-06','17:40:00',2.66),('14598','2013-08-06','17:45:00',2.63),('14598','2013-08-06','17:50:00',2.51),('14598','2013-08-06','17:55:00',2.4),('14598','2013-08-06','18:00:00',2.3),('14598','2013-08-06','18:05:00',2.2),('14598','2013-08-06','18:10:00',2.09),('14598','2013-08-06','18:15:00',1.97),('14598','2013-08-06','18:20:00',1.89),('14598','2013-08-06','18:25:00',1.79),('14598','2013-08-06','18:30:00',1.7),('14598','2013-08-06','18:35:00',1.6),('14598','2013-08-06','18:40:00',1.48),('14598','2013-08-06','18:45:00',1.37),('14598','2013-08-06','18:50:00',1.25),('14598','2013-08-06','18:55:00',1.12),('14598','2013-08-06','19:00:00',1.03),('14598','2013-08-05','08:20:00',1.04),('14598','2013-08-05','08:25:00',1.14),('14598','2013-08-05','08:30:00',1.23),('14598','2013-08-05','08:35:00',1.33),('14598','2013-08-05','08:40:00',1.45),('14598','2013-08-05','08:45:00',1.55),('14598','2013-08-05','08:50:00',1.64),('14598','2013-08-05','08:55:00',1.73),('14598','2013-08-05','09:00:00',1.83),('14598','2013-08-05','09:05:00',1.93),('14598','2013-08-05','09:10:00',2.04),('14598','2013-08-05','09:15:00',2.12),('14598','2013-08-05','09:20:00',2.2),('14598','2013-08-05','09:25:00',2.28),('14598','2013-08-05','09:30:00',2.37),('14598','2013-08-05','09:35:00',2.47),('14598','2013-08-05','09:40:00',2.56),('14598','2013-08-05','09:45:00',2.67),('14598','2013-08-05','09:50:00',2.75),('14598','2013-08-05','09:55:00',2.82),('14598','2013-08-05','10:00:00',2.91),('14598','2013-08-05','10:05:00',2.99),('14598','2013-08-05','10:10:00',3.08),('14598','2013-08-05','10:15:00',3.16),('14598','2013-08-05','10:20:00',3.25),('14598','2013-08-05','10:25:00',3.31),('14598','2013-08-05','10:30:00',3.35),('14598','2013-08-05','10:35:00',3.4),('14598','2013-08-05','10:40:00',3.49),('14598','2013-08-05','10:45:00',3.54),('14598','2013-08-05','10:50:00',3.62),('14598','2013-08-05','10:55:00',3.69),('14598','2013-08-05','11:00:00',3.77),('14598','2013-08-05','11:05:00',3.82),('14598','2013-08-05','11:10:00',3.89),('14598','2013-08-05','11:15:00',3.95),('14598','2013-08-05','11:20:00',3.97),('14598','2013-08-05','11:25:00',4.03),('14598','2013-08-05','11:30:00',4.09),('14598','2013-08-05','11:35:00',4.13),('14598','2013-08-05','11:40:00',4.21),('14598','2013-08-05','11:45:00',4.24),('14598','2013-08-05','11:50:00',4.28),('14598','2013-08-05','11:55:00',4.33),('14598','2013-08-05','12:00:00',4.36),('14598','2013-08-05','12:05:00',4.4),('14598','2013-08-05','12:10:00',4.43),('14598','2013-08-05','12:15:00',4.47),('14598','2013-08-05','12:20:00',4.5),('14598','2013-08-05','12:25:00',4.52),('14598','2013-08-05','12:30:00',4.55),('14598','2013-08-05','12:35:00',4.54),('14598','2013-08-05','12:40:00',4.6),('14598','2013-08-05','12:45:00',4.63),('14598','2013-08-05','12:50:00',4.66),('14598','2013-08-05','12:55:00',4.69),('14598','2013-08-05','13:00:00',4.69),('14598','2013-08-05','13:05:00',4.71),('14598','2013-08-05','13:10:00',4.73),('14598','2013-08-05','13:15:00',4.72),('14598','2013-08-05','13:20:00',4.73),('14598','2013-08-05','13:25:00',4.75),('14598','2013-08-05','13:30:00',4.77),('14598','2013-08-05','13:35:00',4.78),('14598','2013-08-05','13:40:00',4.78),('14598','2013-08-05','13:45:00',4.78),('14598','2013-08-05','13:50:00',4.77),('14598','2013-08-05','13:55:00',4.76),('14598','2013-08-05','14:00:00',4.76),('14598','2013-08-05','14:05:00',4.76),('14598','2013-08-05','14:10:00',4.74),('14598','2013-08-05','14:15:00',4.73),('14598','2013-08-05','14:20:00',4.71),('14598','2013-08-05','14:25:00',4.65),('14598','2013-08-05','14:30:00',4.7),('14598','2013-08-05','14:35:00',4.68),('14598','2013-08-05','14:40:00',4.66),('14598','2013-08-05','14:45:00',4.62),('14598','2013-08-05','14:50:00',4.62),('14598','2013-08-05','14:55:00',4.61),('14598','2013-08-05','15:00:00',4.6),('14598','2013-08-05','15:05:00',4.57),('14598','2013-08-05','15:10:00',4.53),('14598','2013-08-05','15:15:00',4.51),('14598','2013-08-05','15:20:00',4.46),('14598','2013-08-05','15:25:00',4.45),('14598','2013-08-05','15:30:00',4.4),('14598','2013-08-05','15:35:00',4.37),('14598','2013-08-05','15:40:00',4.33),('14598','2013-08-05','15:45:00',4.31),('14598','2013-08-05','15:50:00',4.25),('14598','2013-08-05','15:55:00',4.2),('14598','2013-08-05','16:00:00',4.13),('14598','2013-08-05','16:05:00',4.07),('14598','2013-08-05','16:10:00',4.02),('14598','2013-08-05','16:15:00',3.96),('14598','2013-08-05','16:20:00',3.9),('14598','2013-08-05','16:25:00',3.84),('14598','2013-08-05','16:30:00',3.78),('14598','2013-08-05','16:35:00',3.71),('14598','2013-08-05','16:40:00',3.64),('14598','2013-08-05','16:45:00',3.54),('14598','2013-08-05','16:50:00',3.47),('14598','2013-08-05','16:55:00',3.42),('14598','2013-08-05','17:00:00',3.33),('14598','2013-08-05','17:05:00',3.25),('14598','2013-08-05','17:10:00',3.17),('14598','2013-08-05','17:15:00',3.09),('14598','2013-08-05','17:20:00',3),('14598','2013-08-05','17:25:00',2.85),('14598','2013-08-05','17:30:00',2.82),('14598','2013-08-05','17:35:00',2.74),('14598','2013-08-05','17:40:00',2.65),('14598','2013-08-05','17:45:00',2.55),('14598','2013-08-05','17:50:00',2.46),('14598','2013-08-05','17:55:00',2.38),('14598','2013-08-05','18:00:00',2.28),('14598','2013-08-05','18:05:00',2.17),('14598','2013-08-05','18:10:00',2.07),('14598','2013-08-05','18:15:00',1.96),('14598','2013-08-05','18:20:00',1.86),('14598','2013-08-05','18:25:00',1.75),('14598','2013-08-05','18:30:00',1.65),('14598','2013-08-05','18:35:00',1.54),('14598','2013-08-05','18:40:00',1.44),('14598','2013-08-05','18:45:00',1.34),('14598','2013-08-05','18:50:00',1.23),('14598','2013-08-05','18:55:00',1.11),('14598','2013-08-04','08:15:00',1.02),('14598','2013-08-04','08:20:00',1.09),('14598','2013-08-04','08:25:00',1.2),('14598','2013-08-04','08:30:00',1.31),('14598','2013-08-04','08:35:00',1.4),('14598','2013-08-04','08:40:00',1.51),('14598','2013-08-04','08:45:00',1.62),('14598','2013-08-04','08:50:00',1.71),('14598','2013-08-04','08:55:00',1.81),('14598','2013-08-04','09:00:00',1.91),('14598','2013-08-04','09:05:00',2.01),('14598','2013-08-04','09:10:00',2.13),('14598','2013-08-04','09:15:00',2.22),('14598','2013-08-04','09:20:00',2.3),('14598','2013-08-04','09:25:00',2.39),('14598','2013-08-04','09:30:00',2.48),('14598','2013-08-04','09:35:00',2.57),('14598','2013-08-04','09:40:00',2.65),('14598','2013-08-04','09:45:00',2.73),('14598','2013-08-04','09:50:00',2.8),('14598','2013-08-04','09:55:00',2.88),('14598','2013-08-04','10:00:00',2.98),('14598','2013-08-04','10:05:00',2.99),('14598','2013-08-04','10:10:00',3.14),('14598','2013-08-04','10:15:00',3.22),('14598','2013-08-04','10:20:00',3.3),('14598','2013-08-04','10:25:00',3.39),('14598','2013-08-04','10:30:00',3.46),('14598','2013-08-04','10:35:00',3.53),('14598','2013-08-04','10:40:00',3.62),('14598','2013-08-04','10:45:00',3.68),('14598','2013-08-04','10:50:00',3.75),('14598','2013-08-04','10:55:00',3.81),('14598','2013-08-04','11:00:00',3.87),('14598','2013-08-04','11:05:00',3.93),('14598','2013-08-04','11:10:00',4),('14598','2013-08-04','11:15:00',4.06),('14598','2013-08-04','11:20:00',4.09),('14598','2013-08-04','11:25:00',4.18),('14598','2013-08-04','11:30:00',4.24),('14598','2013-08-04','11:35:00',4.3),('14598','2013-08-04','11:40:00',4.35),('14598','2013-08-04','11:45:00',4.37),('14598','2013-08-04','11:50:00',4.43),('14598','2013-08-04','11:55:00',4.47),('14598','2013-08-04','12:00:00',4.5),('14598','2013-08-04','12:05:00',4.54),('14598','2013-08-04','12:10:00',4.59),('14598','2013-08-04','12:15:00',4.61),('14598','2013-08-04','12:20:00',4.64),('14598','2013-08-04','12:25:00',4.69),('14598','2013-08-04','12:30:00',4.74),('14598','2013-08-04','12:35:00',4.75),('14598','2013-08-04','12:40:00',4.75),('14598','2013-08-04','12:45:00',4.74),('14598','2013-08-04','12:50:00',4.79),('14598','2013-08-04','12:55:00',4.8),('14598','2013-08-04','13:00:00',4.84),('14598','2013-08-04','13:05:00',4.76),('14598','2013-08-04','13:10:00',4.84),('14598','2013-08-04','13:15:00',4.86),('14598','2013-08-04','13:20:00',4.87),('14598','2013-08-04','13:25:00',4.87),('14598','2013-08-04','13:30:00',4.89),('14598','2013-08-04','13:35:00',4.89),('14598','2013-08-04','13:40:00',4.9),('14598','2013-08-04','13:45:00',4.89),('14598','2013-08-04','13:50:00',4.89),('14598','2013-08-04','13:55:00',4.89),('14598','2013-08-04','14:00:00',4.87),('14598','2013-08-04','14:05:00',4.86),('14598','2013-08-04','14:10:00',4.89),('14598','2013-08-04','14:15:00',4.88),('14598','2013-08-04','14:20:00',4.8),('14598','2013-08-04','14:25:00',4.85),('14598','2013-08-04','14:30:00',4.84),('14598','2013-08-04','14:35:00',4.79),('14598','2013-08-04','14:40:00',4.77),('14598','2013-08-04','14:45:00',4.72),('14598','2013-08-04','14:50:00',4.69),('14598','2013-08-04','14:55:00',4.67),('14598','2013-08-04','15:00:00',4.68),('14598','2013-08-04','15:05:00',4.69),('14598','2013-08-04','15:10:00',4.65),('14598','2013-08-04','15:15:00',4.6),('14598','2013-08-04','15:20:00',4.59),('14598','2013-08-04','15:25:00',4.54),('14598','2013-08-04','15:30:00',4.48),('14598','2013-08-04','15:35:00',4.45),('14598','2013-08-04','15:40:00',4.42),('14598','2013-08-04','15:45:00',4.41),('14598','2013-08-04','15:50:00',4.36),('14598','2013-08-04','15:55:00',4.3),('14598','2013-08-04','16:00:00',4.24),('14598','2013-08-04','16:05:00',4.13),('14598','2013-08-04','16:10:00',4.12),('14598','2013-08-04','16:15:00',4.05),('14598','2013-08-04','16:20:00',3.97),('14598','2013-08-04','16:25:00',3.91),('14598','2013-08-04','16:30:00',3.85),('14598','2013-08-04','16:35:00',3.76),('14598','2013-08-04','16:40:00',3.69),('14598','2013-08-04','16:45:00',3.59),('14598','2013-08-04','16:50:00',3.51),('14598','2013-08-04','16:55:00',3.44),('14598','2013-08-04','17:00:00',3.36),('14598','2013-08-04','17:05:00',3.28),('14598','2013-08-04','17:10:00',3.19),('14598','2013-08-04','17:15:00',3.1),('14598','2013-08-04','17:20:00',3.03),('14598','2013-08-04','17:25:00',2.95),('14598','2013-08-04','17:30:00',2.87),('14598','2013-08-04','17:35:00',2.8),('14598','2013-08-04','17:40:00',2.7),('14598','2013-08-04','17:45:00',2.59),('14598','2013-08-04','17:50:00',2.5),('14598','2013-08-04','17:55:00',2.43),('14598','2013-08-04','18:00:00',2.32),('14598','2013-08-04','18:05:00',2.23),('14598','2013-08-04','18:10:00',2.13),('14598','2013-08-04','18:15:00',2.03),('14598','2013-08-04','18:20:00',1.95),('14598','2013-08-04','18:25:00',1.84),('14598','2013-08-04','18:30:00',1.72),('14598','2013-08-04','18:35:00',1.59),('14598','2013-08-04','18:40:00',1.47),('14598','2013-08-04','18:45:00',1.35),('14598','2013-08-04','18:50:00',1.26),('14598','2013-08-04','18:55:00',1.15),('14598','2013-08-04','19:00:00',1.04),('14598','2013-08-03','08:15:00',1.02),('14598','2013-08-03','08:20:00',1.12),('14598','2013-08-03','08:25:00',1.23),('14598','2013-08-03','08:30:00',1.33),('14598','2013-08-03','08:35:00',1.42),('14598','2013-08-03','08:40:00',1.52),('14598','2013-08-03','08:45:00',1.64),('14598','2013-08-03','08:50:00',1.73),('14598','2013-08-03','08:55:00',1.83),('14598','2013-08-03','09:00:00',1.91),('14598','2013-08-03','09:05:00',2.04),('14598','2013-08-03','09:10:00',2.15),('14598','2013-08-03','09:15:00',2.25),('14598','2013-08-03','09:20:00',2.34),('14598','2013-08-03','09:25:00',2.44),('14598','2013-08-03','09:30:00',2.52),('14598','2013-08-03','09:35:00',2.6),('14598','2013-08-03','09:40:00',2.68),('14598','2013-08-03','09:45:00',2.77),('14598','2013-08-03','09:50:00',2.84),('14598','2013-08-03','09:55:00',2.92),('14598','2013-08-03','10:00:00',3),('14598','2013-08-03','10:05:00',3.06),('14598','2013-08-03','10:10:00',3.11),('14598','2013-08-03','10:15:00',3.19),('14598','2013-08-03','10:20:00',3.29),('14598','2013-08-03','10:25:00',3.36),('14598','2013-08-03','10:30:00',3.43),('14598','2013-08-03','10:35:00',3.47),('14598','2013-08-03','10:40:00',3.5),('14598','2013-08-03','10:45:00',3.59),('14598','2013-08-03','10:50:00',3.66),('14598','2013-08-03','10:55:00',3.7),('14598','2013-08-03','11:00:00',3.78),('14598','2013-08-03','11:05:00',3.87),('14598','2013-08-03','11:10:00',3.96),('14598','2013-08-03','11:15:00',4.03),('14598','2013-08-03','11:20:00',4.07),('14598','2013-08-03','11:25:00',4.14),('14598','2013-08-03','11:30:00',4.19),('14598','2013-08-03','11:35:00',4.24),('14598','2013-08-03','11:40:00',4.3),('14598','2013-08-03','11:45:00',4.35),('14598','2013-08-03','11:50:00',4.4),('14598','2013-08-03','11:55:00',4.43),('14598','2013-08-03','12:00:00',4.46),('14598','2013-08-03','12:05:00',4.51),('14598','2013-08-03','12:10:00',4.58),('14598','2013-08-03','12:15:00',4.63),('14598','2013-08-03','12:20:00',4.66),('14598','2013-08-03','12:25:00',4.67),('14598','2013-08-03','12:30:00',4.72),('14598','2013-08-03','12:35:00',4.75),('14598','2013-08-03','12:40:00',4.78),('14598','2013-08-03','12:45:00',4.78),('14598','2013-08-03','12:50:00',4.79),('14598','2013-08-03','12:55:00',4.82),('14598','2013-08-03','13:00:00',4.85),('14598','2013-08-03','13:05:00',4.86),('14598','2013-08-03','13:10:00',4.87),('14598','2013-08-03','13:15:00',4.86),('14598','2013-08-03','13:20:00',4.84),('14598','2013-08-03','13:25:00',4.9),('14598','2013-08-03','13:30:00',4.91),('14598','2013-08-03','13:35:00',4.91),('14598','2013-08-03','13:40:00',4.92),('14598','2013-08-03','13:45:00',4.94),('14598','2013-08-03','13:50:00',4.96),('14598','2013-08-03','13:55:00',4.92),('14598','2013-08-03','14:00:00',4.93),('14598','2013-08-03','14:05:00',4.94),('14598','2013-08-03','14:10:00',4.94),('14598','2013-08-03','14:15:00',4.93),('14598','2013-08-03','14:20:00',4.91),('14598','2013-08-03','14:25:00',4.9),('14598','2013-08-03','14:30:00',4.88),('14598','2013-08-03','14:35:00',4.85),('14598','2013-08-03','14:40:00',4.84),('14598','2013-08-03','14:45:00',4.82),('14598','2013-08-03','14:50:00',4.78),('14598','2013-08-03','14:55:00',4.75),('14598','2013-08-03','15:00:00',4.72),('14598','2013-08-03','15:05:00',4.62),('14598','2013-08-03','15:10:00',4.64),('14598','2013-08-03','15:15:00',4.62),('14598','2013-08-03','15:20:00',4.57),('14598','2013-08-03','15:25:00',4.54),('14598','2013-08-03','15:30:00',4.51),('14598','2013-08-03','15:35:00',4.48),('14598','2013-08-03','15:40:00',4.43),('14598','2013-08-03','15:45:00',4.37),('14598','2013-08-03','15:50:00',4.31),('14598','2013-08-03','15:55:00',4.26),('14598','2013-08-03','16:00:00',4.22),('14598','2013-08-03','16:05:00',4.16),('14598','2013-08-03','16:10:00',4.11),('14598','2013-08-03','16:15:00',4.06),('14598','2013-08-03','16:20:00',3.97),('14598','2013-08-03','16:25:00',3.97),('14598','2013-08-03','16:30:00',3.89),('14598','2013-08-03','16:35:00',3.82),('14598','2013-08-03','16:40:00',3.78),('14598','2013-08-03','16:45:00',3.71),('14598','2013-08-03','16:50:00',3.62),('14598','2013-08-03','16:55:00',3.57),('14598','2013-08-03','17:00:00',3.49),('14598','2013-08-03','17:05:00',3.4),('14598','2013-08-03','17:10:00',3.31),('14598','2013-08-03','17:15:00',3.22),('14598','2013-08-03','17:20:00',3.18),('14598','2013-08-03','17:25:00',3.13),('14598','2013-08-03','17:30:00',3.04),('14598','2013-08-03','17:35:00',2.96),('14598','2013-08-03','17:40:00',2.86),('14598','2013-08-03','17:45:00',2.77),('14598','2013-08-03','17:50:00',2.67),('14598','2013-08-03','17:55:00',2.57),('14598','2013-08-03','18:00:00',2.47),('14598','2013-08-03','18:05:00',2.34),('14598','2013-08-03','18:10:00',2.27),('14598','2013-08-03','18:15:00',2.17),('14598','2013-08-03','18:20:00',2.07),('14598','2013-08-03','18:25:00',1.97),('14598','2013-08-03','18:30:00',1.86),('14598','2013-08-03','18:35:00',1.75),('14598','2013-08-03','18:40:00',1.64),('14598','2013-08-03','18:45:00',1.55),('14598','2013-08-03','18:50:00',1.44),('14598','2013-08-03','18:55:00',1.33),('14598','2013-08-03','19:00:00',1.22),('14598','2013-08-03','19:05:00',1.11),('14598','2013-08-03','19:10:00',1),('14598','2013-08-02','08:15:00',1.09),('14598','2013-08-02','08:20:00',1.19),('14598','2013-08-02','08:25:00',1.3),('14598','2013-08-02','08:30:00',1.4),('14598','2013-08-02','08:35:00',1.49),('14598','2013-08-02','08:40:00',1.6),('14598','2013-08-02','08:45:00',1.73),('14598','2013-08-02','08:50:00',1.83),('14598','2013-08-02','08:55:00',1.93),('14598','2013-08-02','09:00:00',2.03),('14598','2013-08-02','09:05:00',2.14),('14598','2013-08-02','09:10:00',2.26),('14598','2013-08-02','09:15:00',2.35),('14598','2013-08-02','09:20:00',2.45),('14598','2013-08-02','09:25:00',2.53),('14598','2013-08-02','09:30:00',2.61),('14598','2013-08-02','09:35:00',2.7),('14598','2013-08-02','09:40:00',2.78),('14598','2013-08-02','09:45:00',2.86),('14598','2013-08-02','09:50:00',2.94),('14598','2013-08-02','09:55:00',3.01),('14598','2013-08-02','10:00:00',3.08),('14598','2013-08-02','10:05:00',3.15),('14598','2013-08-02','10:10:00',3.22),('14598','2013-08-02','10:15:00',3.29),('14598','2013-08-02','10:20:00',3.34),('14598','2013-08-02','10:25:00',3.42),('14598','2013-08-02','10:30:00',3.48),('14598','2013-08-02','10:35:00',3.56),('14598','2013-08-02','10:40:00',3.62),('14598','2013-08-02','10:45:00',3.67),('14598','2013-08-02','10:50:00',3.72),('14598','2013-08-02','10:55:00',3.77),('14598','2013-08-02','11:00:00',3.83),('14598','2013-08-02','11:05:00',3.88),('14598','2013-08-02','11:10:00',3.93),('14598','2013-08-02','11:15:00',3.98),('14598','2013-08-02','11:20:00',4.02),('14598','2013-08-02','11:25:00',4.05),('14598','2013-08-02','11:30:00',4.14),('14598','2013-08-02','11:35:00',4.23),('14598','2013-08-02','11:40:00',4.29),('14598','2013-08-02','11:45:00',4.32),('14598','2013-08-02','11:50:00',4.32),('14598','2013-08-02','11:55:00',4.4),('14598','2013-08-02','12:00:00',4.43),('14598','2013-08-02','12:05:00',4.46),('14598','2013-08-02','12:10:00',4.52),('14598','2013-08-02','12:15:00',4.54),('14598','2013-08-02','12:20:00',4.57),('14598','2013-08-02','12:25:00',4.62),('14598','2013-08-02','12:30:00',4.65),('14598','2013-08-02','12:35:00',4.67),('14598','2013-08-02','12:40:00',4.71),('14598','2013-08-02','12:45:00',4.73),('14598','2013-08-02','12:50:00',4.75),('14598','2013-08-02','12:55:00',4.79),('14598','2013-08-02','13:00:00',4.8),('14598','2013-08-02','13:05:00',4.81),('14598','2013-08-02','13:10:00',4.83),('14598','2013-08-02','13:15:00',4.86),('14598','2013-08-02','13:20:00',4.85),('14598','2013-08-02','13:25:00',4.84),('14598','2013-08-02','13:30:00',4.85),('14598','2013-08-02','13:35:00',4.84),('14598','2013-08-02','13:40:00',4.88),('14598','2013-08-02','13:45:00',4.87),('14598','2013-08-02','13:50:00',4.85),('14598','2013-08-02','13:55:00',4.86),('14598','2013-08-02','14:00:00',4.88),('14598','2013-08-02','14:05:00',4.88),('14598','2013-08-02','14:10:00',4.86),('14598','2013-08-02','14:15:00',4.86),('14598','2013-08-02','14:20:00',4.85),('14598','2013-08-02','14:25:00',4.85),('14598','2013-08-02','14:30:00',4.84),('14598','2013-08-02','14:35:00',4.84),('14598','2013-08-02','14:40:00',4.81),('14598','2013-08-02','14:45:00',4.81),('14598','2013-08-02','14:50:00',4.77),('14598','2013-08-02','14:55:00',4.76),('14598','2013-08-02','15:00:00',4.73),('14598','2013-08-02','15:05:00',4.71),('14598','2013-08-02','15:10:00',4.69),('14598','2013-08-02','15:15:00',4.67),('14598','2013-08-02','15:20:00',4.64),('14598','2013-08-02','15:25:00',4.6),('14598','2013-08-02','15:30:00',4.57),('14598','2013-08-02','15:35:00',4.53),('14598','2013-08-02','15:40:00',4.48),('14598','2013-08-02','15:45:00',4.45),('14598','2013-08-02','15:50:00',4.4),('14598','2013-08-02','15:55:00',4.35),('14598','2013-08-02','16:00:00',4.28),('14598','2013-08-02','16:05:00',4.21),('14598','2013-08-02','16:10:00',4.17),('14598','2013-08-02','16:15:00',4.15),('14598','2013-08-02','16:20:00',4.1),('14598','2013-08-02','16:25:00',4.03),('14598','2013-08-02','16:30:00',3.98),('14598','2013-08-02','16:35:00',3.89),('14598','2013-08-02','16:40:00',3.84),('14598','2013-08-02','16:45:00',3.77),('14598','2013-08-02','16:50:00',3.72),('14598','2013-08-02','16:55:00',3.62),('14598','2013-08-02','17:00:00',3.51),('14598','2013-08-02','17:05:00',3.42),('14598','2013-08-02','17:10:00',3.36),('14598','2013-08-02','17:15:00',3.3),('14598','2013-08-02','17:20:00',3.22),('14598','2013-08-02','17:25:00',3.13),('14598','2013-08-02','17:30:00',3.07),('14598','2013-08-02','17:35:00',2.98),('14598','2013-08-02','17:40:00',2.87),('14598','2013-08-02','17:45:00',2.76),('14598','2013-08-02','17:50:00',2.69),('14598','2013-08-02','17:55:00',2.59),('14598','2013-08-02','18:00:00',2.49),('14598','2013-08-02','18:05:00',2.4),('14598','2013-08-02','18:10:00',2.3),('14598','2013-08-02','18:15:00',2.22),('14598','2013-08-02','18:20:00',2.12),('14598','2013-08-02','18:25:00',2.02),('14598','2013-08-02','18:30:00',1.91),('14598','2013-08-02','18:35:00',1.81),('14598','2013-08-02','18:40:00',1.7),('14598','2013-08-02','18:45:00',1.59),('14598','2013-08-02','18:50:00',1.49),('14598','2013-08-02','18:55:00',1.38),('14598','2013-08-02','19:00:00',1.27),('14598','2013-08-02','19:05:00',1.16),('14598','2013-08-02','19:10:00',1.06),('14598','2013-08-01','08:10:00',1.01),('14598','2013-08-01','08:15:00',1.09),('14598','2013-08-01','08:20:00',1.22),('14598','2013-08-01','08:25:00',1.32),('14598','2013-08-01','08:30:00',1.42),('14598','2013-08-01','08:35:00',1.52),('14598','2013-08-01','08:40:00',1.62),('14598','2013-08-01','08:45:00',1.75),('14598','2013-08-01','08:50:00',1.86),('14598','2013-08-01','08:55:00',1.96),('14598','2013-08-01','09:00:00',2.07),('14598','2013-08-01','09:05:00',2.18),('14598','2013-08-01','09:10:00',2.3),('14598','2013-08-01','09:15:00',2.39),('14598','2013-08-01','09:20:00',2.49),('14598','2013-08-01','09:25:00',2.58),('14598','2013-08-01','09:30:00',2.66),('14598','2013-08-01','09:35:00',2.75),('14598','2013-08-01','09:40:00',2.84),('14598','2013-08-01','09:45:00',2.92),('14598','2013-08-01','09:50:00',3.01),('14598','2013-08-01','09:55:00',3.06),('14598','2013-08-01','10:00:00',3.12),('14598','2013-08-01','10:05:00',3.24),('14598','2013-08-01','10:10:00',3.3),('14598','2013-08-01','10:15:00',3.39),('14598','2013-08-01','10:20:00',3.45),('14598','2013-08-01','10:25:00',3.51),('14598','2013-08-01','10:30:00',3.6),('14598','2013-08-01','10:35:00',3.68),('14598','2013-08-01','10:40:00',3.75),('14598','2013-08-01','10:45:00',3.8),('14598','2013-08-01','10:50:00',3.87),('14598','2013-08-01','10:55:00',3.93),('14598','2013-08-01','11:00:00',3.95),('14598','2013-08-01','11:05:00',4.01),('14598','2013-08-01','11:10:00',4.08),('14598','2013-08-01','11:15:00',4.08),('14598','2013-08-01','11:20:00',4.16),('14598','2013-08-01','11:25:00',4.2),('14598','2013-08-01','11:30:00',4.27),('14598','2013-08-01','11:35:00',4.32),('14598','2013-08-01','11:40:00',4.39),('14598','2013-08-01','11:45:00',4.45),('14598','2013-08-01','11:50:00',4.43),('14598','2013-08-01','11:55:00',4.5),('14598','2013-08-01','12:00:00',4.52),('14598','2013-08-01','12:05:00',4.59),('14598','2013-08-01','12:10:00',4.61),('14598','2013-08-01','12:15:00',4.61),('14598','2013-08-01','12:20:00',4.67),('14598','2013-08-01','12:25:00',4.71),('14598','2013-08-01','12:30:00',4.68),('14598','2013-08-01','12:35:00',4.73),('14598','2013-08-01','12:40:00',4.76),('14598','2013-08-01','12:45:00',4.77),('14598','2013-08-01','12:50:00',4.82),('14598','2013-08-01','12:55:00',4.8),('14598','2013-08-01','13:00:00',4.8),('14598','2013-08-01','13:05:00',4.86),('14598','2013-08-01','13:10:00',4.85),('14598','2013-08-01','13:15:00',4.88),('14598','2013-08-01','13:20:00',4.9),('14598','2013-08-01','13:25:00',4.89),('14598','2013-08-01','13:30:00',4.93),('14598','2013-08-01','13:35:00',4.94),('14598','2013-08-01','13:40:00',4.91),('14598','2013-08-01','13:45:00',4.89),('14598','2013-08-01','13:50:00',4.9),('14598','2013-08-01','13:55:00',4.88),('14598','2013-08-01','14:00:00',4.9),('14598','2013-08-01','14:05:00',4.87),('14598','2013-08-01','14:10:00',4.8),('14598','2013-08-01','14:15:00',4.83),('14598','2013-08-01','14:20:00',4.74),('14598','2013-08-01','14:25:00',4.8),('14598','2013-08-01','14:30:00',4.81),('14598','2013-08-01','14:35:00',4.75),('14598','2013-08-01','14:40:00',4.77),('14598','2013-08-01','14:45:00',4.77),('14598','2013-08-01','14:50:00',4.73),('14598','2013-08-01','14:55:00',4.71),('14598','2013-08-01','15:00:00',4.64),('14598','2013-08-01','15:05:00',4.61),('14598','2013-08-01','15:10:00',4.57),('14598','2013-08-01','15:15:00',4.53),('14598','2013-08-01','15:20:00',4.53),('14598','2013-08-01','15:25:00',4.5),('14598','2013-08-01','15:30:00',4.41),('14598','2013-08-01','15:35:00',4.37),('14598','2013-08-01','15:40:00',4.37),('14598','2013-08-01','15:45:00',4.34),('14598','2013-08-01','15:50:00',4.3),('14598','2013-08-01','15:55:00',4.27),('14598','2013-08-01','16:00:00',4.18),('14598','2013-08-01','16:05:00',4.1),('14598','2013-08-01','16:10:00',4.09),('14598','2013-08-01','16:25:00',3.81),('14598','2013-08-01','16:30:00',3.96),('14598','2013-08-01','16:35:00',3.9),('14598','2013-08-01','16:40:00',3.84),('14598','2013-08-01','16:45:00',3.78),('14598','2013-08-01','16:50:00',3.68),('14598','2013-08-01','16:55:00',3.61),('14598','2013-08-01','17:00:00',3.29),('14598','2013-08-01','17:05:00',3.48),('14598','2013-08-01','17:10:00',3.39),('14598','2013-08-01','17:15:00',3.32),('14598','2013-08-01','17:20:00',3.27),('14598','2013-08-01','17:25:00',3.14),('14598','2013-08-01','17:30:00',3.08),('14598','2013-08-01','17:35:00',2.97),('14598','2013-08-01','17:40:00',2.88),('14598','2013-08-01','17:45:00',2.79),('14598','2013-08-01','17:50:00',2.7),('14598','2013-08-01','17:55:00',2.63),('14598','2013-08-01','18:00:00',2.55),('14598','2013-08-01','18:05:00',2.42),('14598','2013-08-01','18:10:00',2.36),('14598','2013-08-01','18:15:00',2.25),('14598','2013-08-01','18:20:00',2.15),('14598','2013-08-01','18:25:00',2.06),('14598','2013-08-01','18:30:00',1.95),('14598','2013-08-01','18:35:00',1.84),('14598','2013-08-01','18:40:00',1.74),('14598','2013-08-01','18:45:00',1.63),('14598','2013-08-01','18:50:00',1.52),('14598','2013-08-01','18:55:00',1.41),('14598','2013-08-01','19:00:00',1.3),('14598','2013-08-01','19:05:00',1.18),('14598','2013-08-01','19:10:00',1.08),('14598','2013-07-31','08:10:00',1.02),('14598','2013-07-31','08:15:00',1.11),('14598','2013-07-31','08:20:00',1.23),('14598','2013-07-31','08:25:00',1.33),('14598','2013-07-31','08:30:00',1.42),('14598','2013-07-31','08:35:00',1.52),('14598','2013-07-31','08:40:00',1.62),('14598','2013-07-31','08:45:00',1.75),('14598','2013-07-31','08:50:00',1.84),('14598','2013-07-31','08:55:00',1.95),('14598','2013-07-31','09:00:00',2.06),('14598','2013-07-31','09:05:00',2.19),('14598','2013-07-31','09:10:00',2.3),('14598','2013-07-31','09:15:00',2.39),('14598','2013-07-31','09:20:00',2.49),('14598','2013-07-31','09:25:00',2.57),('14598','2013-07-31','09:30:00',2.66),('14598','2013-07-31','09:35:00',2.75),('14598','2013-07-31','09:40:00',2.83),('14598','2013-07-31','09:45:00',2.91),('14598','2013-07-31','09:50:00',3),('14598','2013-07-31','09:55:00',3.07),('14598','2013-07-31','10:00:00',3.15),('14598','2013-07-31','10:05:00',3.24),('14598','2013-07-31','10:10:00',3.32),('14598','2013-07-31','10:15:00',3.39),('14598','2013-07-31','10:20:00',3.45),('14598','2013-07-31','10:25:00',3.52),('14598','2013-07-31','10:30:00',3.58),('14598','2013-07-31','10:35:00',3.64),('14598','2013-07-31','10:40:00',3.7),('14598','2013-07-31','10:45:00',3.75),('14598','2013-07-31','10:50:00',3.84),('14598','2013-07-31','10:55:00',3.9),('14598','2013-07-31','11:00:00',3.97),('14598','2013-07-31','11:05:00',4.03),('14598','2013-07-31','11:10:00',4.06),('14598','2013-07-31','11:15:00',4.13),('14598','2013-07-31','11:20:00',4.2),('14598','2013-07-31','11:25:00',4.22),('14598','2013-07-31','11:30:00',4.28),('14598','2013-07-31','11:35:00',4.31),('14598','2013-07-31','11:40:00',4.36),('14598','2013-07-31','11:45:00',4.41),('14598','2013-07-31','11:50:00',4.44),('14598','2013-07-31','11:55:00',4.48),('14598','2013-07-31','12:00:00',4.55),('14598','2013-07-31','12:05:00',4.57),('14598','2013-07-31','12:10:00',4.62),('14598','2013-07-31','12:15:00',4.63),('14598','2013-07-31','12:20:00',4.64),('14598','2013-07-31','12:25:00',4.63),('14598','2013-07-31','12:30:00',4.66),('14598','2013-07-31','12:35:00',4.69),('14598','2013-07-31','12:40:00',4.71),('14598','2013-07-31','12:45:00',4.7),('14598','2013-07-31','12:50:00',4.74),('14598','2013-07-31','12:55:00',4.76),('14598','2013-07-31','13:00:00',4.06),('14598','2013-07-31','13:05:00',4.87),('14598','2013-07-31','13:10:00',4.15),('14598','2013-07-31','13:15:00',4.81),('14598','2013-07-31','13:20:00',4.89),('14598','2013-07-31','13:25:00',4.83),('14598','2013-07-31','13:30:00',4.81),('14598','2013-07-31','13:35:00',4.83),('14598','2013-07-31','13:40:00',4.84),('14598','2013-07-31','13:45:00',4.86),('14598','2013-07-31','13:50:00',4.83),('14598','2013-07-31','13:55:00',4.87),('14598','2013-07-31','14:00:00',4.34),('14598','2013-07-31','14:05:00',4.27),('14598','2013-07-31','14:10:00',4.88),('14598','2013-07-31','14:15:00',4.83),('14598','2013-07-31','14:20:00',4.82),('14598','2013-07-31','14:25:00',4.73),('14598','2013-07-31','14:30:00',4.73),('14598','2013-07-31','14:35:00',4.85),('14598','2013-07-31','14:40:00',4.91),('14598','2013-07-31','14:45:00',4.85),('14598','2013-07-31','14:50:00',4.82),('14598','2013-07-31','14:55:00',4.73),('14598','2013-07-31','15:00:00',4.77),('14598','2013-07-31','15:05:00',4.79),('14598','2013-07-31','15:10:00',4.79),('14598','2013-07-31','15:15:00',4.61),('14598','2013-07-31','15:20:00',4.58),('14598','2013-07-31','15:25:00',4.64),('14598','2013-07-31','15:30:00',4.83),('14598','2013-07-31','15:35:00',4.91),('14598','2013-07-31','15:40:00',4.27),('14598','2013-07-31','15:45:00',4.71),('14598','2013-07-31','15:50:00',4.71),('14598','2013-07-31','15:55:00',4.68),('14598','2013-07-31','16:00:00',4.55),('14598','2013-07-31','16:05:00',3.53),('14598','2013-07-31','16:10:00',3.56),('14598','2013-07-31','16:15:00',4.19),('14598','2013-07-31','16:20:00',4.11),('14598','2013-07-31','16:25:00',4.05),('14598','2013-07-31','16:30:00',4.07),('14598','2013-07-31','16:35:00',4.08),('14598','2013-07-31','16:40:00',3.96),('14598','2013-07-31','16:45:00',3.81),('14598','2013-07-31','16:50:00',3.73),('14598','2013-07-31','16:55:00',3.69),('14598','2013-07-31','17:00:00',3.62),('14598','2013-07-31','17:05:00',3.5),('14598','2013-07-31','17:10:00',3.44),('14598','2013-07-31','17:15:00',3.22),('14598','2013-07-31','17:20:00',3.27),('14598','2013-07-31','17:25:00',3.18),('14598','2013-07-31','17:30:00',3.11),('14598','2013-07-31','17:35:00',2.98),('14598','2013-07-31','17:40:00',2.88),('14598','2013-07-31','17:45:00',2.79),('14598','2013-07-31','17:50:00',2.69),('14598','2013-07-31','17:55:00',2.59),('14598','2013-07-31','18:00:00',2.48),('14598','2013-07-31','18:05:00',2.34),('14598','2013-07-31','18:10:00',2.23),('14598','2013-07-31','18:15:00',2.15),('14598','2013-07-31','18:20:00',2.09),('14598','2013-07-31','18:25:00',1.97),('14598','2013-07-31','18:30:00',1.88),('14598','2013-07-31','18:35:00',1.71),('14598','2013-07-31','18:40:00',1.57),('14598','2013-07-31','18:45:00',1.52),('14598','2013-07-31','18:50:00',1.45),('14598','2013-07-31','18:55:00',1.34),('14598','2013-07-31','19:00:00',1.24),('14598','2013-07-31','19:05:00',1.15),('14598','2013-07-31','19:10:00',1.04),('14598','2014-04-08','08:35:00',1.02),('14598','2014-04-08','08:40:00',1.12),('14598','2014-04-08','08:45:00',1.23),('14598','2014-04-08','08:50:00',1.32),('14598','2014-04-08','08:55:00',1.44),('14598','2014-04-08','09:00:00',1.53),('14598','2014-04-08','09:05:00',1.55),('14598','2014-04-08','09:10:00',1.63),('14598','2014-04-08','09:20:00',1.93),('14598','2014-04-08','09:25:00',1.7),('14598','2014-04-08','09:30:00',1.79),('14598','2014-04-08','09:35:00',1.13),('14598','2014-04-08','09:40:00',1.98),('14598','2014-04-08','09:45:00',1.42),('14598','2014-04-08','09:50:00',2.7),('14598','2014-04-08','09:55:00',2.45),('14598','2014-04-08','10:00:00',2.43),('14598','2014-04-08','10:05:00',2.21),('14598','2014-04-08','10:10:00',2.95),('14598','2014-04-08','10:15:00',3.18),('14598','2014-04-08','10:20:00',3.18),('14598','2014-04-08','10:25:00',3.31),('14598','2014-04-08','10:30:00',3.4),('14598','2014-04-08','10:35:00',3.5),('14598','2014-04-08','10:40:00',3.38),('14598','2014-04-08','10:45:00',3.14),('14598','2014-04-08','10:50:00',3.45),('14598','2014-04-08','10:55:00',3.55),('14598','2014-04-08','11:00:00',3.54),('14598','2014-04-08','11:05:00',3.59),('14598','2014-04-08','11:10:00',3.74),('14598','2014-04-08','11:15:00',3.89),('14598','2014-04-08','11:20:00',3.96),('14598','2014-04-08','11:25:00',3.98),('14598','2014-04-08','11:30:00',4.01),('14598','2014-04-08','11:35:00',4.01),('14598','2014-04-08','11:40:00',4.23),('14598','2014-04-08','11:45:00',4.36),('14598','2014-04-08','11:50:00',4.51),('14598','2014-04-08','11:55:00',4.31),('14598','2014-04-08','12:00:00',3.96),('14598','2014-04-08','12:05:00',4.47),('14598','2014-04-08','12:10:00',4.67),('14598','2014-04-08','12:15:00',4.81),('14598','2014-04-08','12:20:00',4.87),('14598','2014-04-08','12:25:00',4.52),('14598','2014-04-08','12:30:00',4.28),('14598','2014-04-08','12:35:00',4.24),('14598','2014-04-08','12:40:00',4.18),('14598','2014-04-08','12:45:00',4.05),('14598','2014-04-08','12:50:00',4.25),('14598','2014-04-08','12:55:00',4.79),('14598','2014-04-08','13:00:00',4.87),('14598','2014-04-08','13:05:00',4.88),('14598','2014-04-08','13:10:00',4.82),('14598','2014-04-08','13:15:00',4.59),('14598','2014-04-08','13:20:00',4.64),('14598','2014-04-08','13:25:00',4.96),('14598','2014-04-08','13:30:00',4.96),('14598','2014-04-08','13:35:00',5),('14598','2014-04-08','13:40:00',4.86),('14598','2014-04-08','13:45:00',4.85),('14598','2014-04-08','13:50:00',4.94),('14598','2014-04-08','13:55:00',4.99),('14598','2014-04-08','14:00:00',4.94),('14598','2014-04-08','14:05:00',4.93),('14598','2014-04-08','14:10:00',4.9),('14598','2014-04-08','14:15:00',4.66),('14598','2014-04-08','14:20:00',4.16),('14598','2014-04-08','14:25:00',4.69),('14598','2014-04-08','14:30:00',4.82),('14598','2014-04-08','14:35:00',4.25),('14598','2014-04-08','14:40:00',4.82),('14598','2014-04-08','14:45:00',4.77),('14598','2014-04-08','14:50:00',4.72),('14598','2014-04-08','14:55:00',4.64),('14598','2014-04-08','15:00:00',4.63),('14598','2014-04-08','15:05:00',4.61),('14598','2014-04-08','15:10:00',4.57),('14598','2014-04-08','15:15:00',4.48),('14598','2014-04-08','15:20:00',4.42),('14598','2014-04-08','15:25:00',4.33),('14598','2014-04-08','15:30:00',4.27),('14598','2014-04-08','15:35:00',4.34),('14598','2014-04-08','15:40:00',4.22),('14598','2014-04-08','15:45:00',4.21),('14598','2014-04-08','15:50:00',4.14),('14598','2014-04-08','15:55:00',4.11),('14598','2014-04-08','16:00:00',3.99),('14598','2014-04-08','16:05:00',3.96),('14598','2014-04-08','16:10:00',3.93),('14598','2014-04-08','16:15:00',3.79),('14598','2014-04-08','16:20:00',3.66),('14598','2014-04-08','16:25:00',3.54),('14598','2014-04-08','16:30:00',3.53),('14598','2014-04-08','16:35:00',3.52),('14598','2014-04-08','16:40:00',3.38),('14598','2014-04-08','16:45:00',3.19),('14598','2014-04-08','16:50:00',3.26),('14598','2014-04-08','16:55:00',3.05),('14598','2014-04-08','17:00:00',2.92),('14598','2014-04-08','17:05:00',2.88),('14598','2014-04-08','17:10:00',2.95),('14598','2014-04-08','17:15:00',2.66),('14598','2014-04-08','17:20:00',2.69),('14598','2014-04-08','17:25:00',2.52),('14598','2014-04-08','17:30:00',2.29),('14598','2014-04-08','17:35:00',1.81),('14598','2014-04-08','17:40:00',1.9),('14598','2014-04-08','17:45:00',2.21),('14598','2014-04-08','17:50:00',2.03),('14598','2014-04-08','17:55:00',1.76),('14598','2014-04-08','18:00:00',1.62),('14598','2014-04-08','18:05:00',1.61),('14598','2014-04-08','18:10:00',1.51),('14598','2014-04-08','18:15:00',1.34),('14598','2014-04-08','18:20:00',1.17),('14598','2013-07-30','08:15:00',1.28),('14598','2013-07-30','08:20:00',1.24),('14598','2013-07-30','08:25:00',1.33),('14598','2013-07-30','08:30:00',1.37),('14598','2013-07-30','08:35:00',1.47),('14598','2013-07-30','08:40:00',1.61),('14598','2013-07-30','08:45:00',1.7),('14598','2013-07-30','08:50:00',1.87),('14598','2013-07-30','08:55:00',1.98),('14598','2013-07-30','09:00:00',2.2),('14598','2013-07-30','09:05:00',2.38),('14598','2013-07-30','09:10:00',2.51),('14598','2013-07-30','09:15:00',2.51),('14598','2013-07-30','09:20:00',2.59),('14598','2013-07-30','09:25:00',2.27),('14598','2013-07-30','09:30:00',2.08),('14598','2013-07-30','09:35:00',2.94),('14598','2013-07-30','09:40:00',3.02),('14598','2013-07-30','09:45:00',3.09),('14598','2013-07-30','09:50:00',3.15),('14598','2013-07-30','09:55:00',3.26),('14598','2013-07-30','10:00:00',3.04),('14598','2013-07-30','10:05:00',3.37),('14598','2013-07-30','10:10:00',3.54),('14598','2013-07-30','10:15:00',3.63),('14598','2013-07-30','10:20:00',3.32),('14598','2013-07-30','10:25:00',3.47),('14598','2013-07-30','10:30:00',3.03),('14598','2013-07-30','10:35:00',4.06),('14598','2013-07-30','10:40:00',4.01),('14598','2013-07-30','10:45:00',4.14),('14598','2013-07-30','10:50:00',4.1),('14598','2013-07-30','10:55:00',4.36),('14598','2013-07-30','11:00:00',3.63),('14598','2013-07-30','11:05:00',4.14),('14598','2013-07-30','11:10:00',4.22),('14598','2013-07-30','11:15:00',4.15),('14598','2013-07-30','11:20:00',4.15),('14598','2013-07-30','11:25:00',4.23),('14598','2013-07-30','11:30:00',4.33),('14598','2013-07-30','11:35:00',4.35),('14598','2013-07-30','11:40:00',4.37),('14598','2013-07-30','11:45:00',4.43),('14598','2013-07-30','11:50:00',4.51),('14598','2013-07-30','11:55:00',4.55),('14598','2013-07-30','12:00:00',4.48),('14598','2013-07-30','12:05:00',4.58),('14598','2013-07-30','12:10:00',4.59),('14598','2013-07-30','12:15:00',4.57),('14598','2013-07-30','12:20:00',4.7),('14598','2013-07-30','12:25:00',4.74),('14598','2013-07-30','12:30:00',4.8),('14598','2013-07-30','12:35:00',4.81),('14598','2013-07-30','12:40:00',4.85),('14598','2013-07-30','12:45:00',4.87),('14598','2013-07-30','12:50:00',4.86),('14598','2013-07-30','12:55:00',4.88),('14598','2013-07-30','13:00:00',4.94),('14598','2013-07-30','13:05:00',4.95),('14598','2013-07-30','13:10:00',4.96),('14598','2013-07-30','13:15:00',4.99),('14598','2013-07-30','13:20:00',5.02),('14598','2013-07-30','13:25:00',4.99),('14598','2013-07-30','13:30:00',4.99),('14598','2013-07-30','13:35:00',4.98),('14598','2013-07-30','13:40:00',4.98),('14598','2013-07-30','13:45:00',4.96),('14598','2013-07-30','13:50:00',4.98),('14598','2013-07-30','13:55:00',4.96),('14598','2013-07-30','14:00:00',4.97),('14598','2013-07-30','14:05:00',4.97),('14598','2013-07-30','14:10:00',4.98),('14598','2013-07-30','14:15:00',4.94),('14598','2013-07-30','14:20:00',4.93),('14598','2013-07-30','14:25:00',4.9),('14598','2013-07-30','14:30:00',4.89),('14598','2013-07-30','14:35:00',4.88),('14598','2013-07-30','14:40:00',4.87),('14598','2013-07-30','14:45:00',4.88),('14598','2013-07-30','14:50:00',4.84),('14598','2013-07-30','14:55:00',4.81),('14598','2013-07-30','15:00:00',4.78),('14598','2013-07-30','15:05:00',4.79),('14598','2013-07-30','15:10:00',4.77),('14598','2013-07-30','15:15:00',4.67),('14598','2013-07-30','15:20:00',4.68),('14598','2013-07-30','15:25:00',4.65),('14598','2013-07-30','15:30:00',4.61),('14598','2013-07-30','15:35:00',4.56),('14598','2013-07-30','15:40:00',4.51),('14598','2013-07-30','15:45:00',4.47),('14598','2013-07-30','15:50:00',4.41),('14598','2013-07-30','15:55:00',4.37),('14598','2013-07-30','16:00:00',4.32),('14598','2013-07-30','16:05:00',4.26),('14598','2013-07-30','16:10:00',4.2),('14598','2013-07-30','16:15:00',4.14),('14598','2013-07-30','16:20:00',4.08),('14598','2013-07-30','16:25:00',4.03),('14598','2013-07-30','16:30:00',3.96),('14598','2013-07-30','16:35:00',3.91),('14598','2013-07-30','16:40:00',3.87),('14598','2013-07-30','16:45:00',3.8),('14598','2013-07-30','16:50:00',3.7),('14598','2013-07-30','16:55:00',3.64),('14598','2013-07-30','17:00:00',3.59),('14598','2013-07-30','17:05:00',3.42),('14598','2013-07-30','17:10:00',3.41),('14598','2013-07-30','17:15:00',3.34),('14598','2013-07-30','17:20:00',3.25),('14598','2013-07-30','17:25:00',3.18),('14598','2013-07-30','17:30:00',3.09),('14598','2013-07-30','17:35:00',3.01),('14598','2013-07-30','17:40:00',2.93),('14598','2013-07-30','17:45:00',2.83),('14598','2013-07-30','17:50:00',2.74),('14598','2013-07-30','17:55:00',2.68),('14598','2013-07-30','18:00:00',2.59),('14598','2013-07-30','18:05:00',2.48),('14598','2013-07-30','18:10:00',2.36),('14598','2013-07-30','18:15:00',2.26),('14598','2013-07-30','18:20:00',2.16),('14598','2013-07-30','18:25:00',2.06),('14598','2013-07-30','18:30:00',1.96),('14598','2013-07-30','18:35:00',1.86),('14598','2013-07-30','18:40:00',1.75),('14598','2013-07-30','18:45:00',1.64),('14598','2013-07-30','18:50:00',1.53),('14598','2013-07-30','18:55:00',1.43),('14598','2013-07-30','19:00:00',1.33),('14598','2013-07-30','19:05:00',1.22),('14598','2013-07-30','19:10:00',1.1),('14598','2013-07-29','08:10:00',1.04),('14598','2013-07-29','08:15:00',1.1),('14598','2013-07-29','08:20:00',1.2),('14598','2013-07-29','08:25:00',1.29),('14598','2013-07-29','08:30:00',1.37),('14598','2013-07-29','08:35:00',1.45),('14598','2013-07-29','08:40:00',1.54),('14598','2013-07-29','08:45:00',1.64),('14598','2013-07-29','08:50:00',1.75),('14598','2013-07-29','08:55:00',1.82),('14598','2013-07-29','09:00:00',1.93),('14598','2013-07-29','09:05:00',2.01),('14598','2013-07-29','09:10:00',2.09),('14598','2013-07-29','09:15:00',2.21),('14598','2013-07-29','09:20:00',2.31),('14598','2013-07-29','09:25:00',2.43),('14598','2013-07-29','09:30:00',2.5),('14598','2013-07-29','09:35:00',2.59),('14598','2013-07-29','09:40:00',2.66),('14598','2013-07-29','09:45:00',2.75),('14598','2013-07-29','09:50:00',2.85),('14598','2013-07-29','09:55:00',2.92),('14598','2013-07-29','10:00:00',3),('14598','2013-07-29','10:05:00',3.09),('14598','2013-07-29','10:10:00',3.16),('14598','2013-07-29','10:15:00',3.24),('14598','2013-07-29','10:20:00',3.32),('14598','2013-07-29','10:25:00',3.39),('14598','2013-07-29','10:30:00',3.47),('14598','2013-07-29','10:35:00',3.53),('14598','2013-07-29','10:40:00',3.6),('14598','2013-07-29','10:45:00',3.66),('14598','2013-07-29','10:50:00',3.72),('14598','2013-07-29','10:55:00',3.77),('14598','2013-07-29','11:00:00',3.83),('14598','2013-07-29','11:05:00',3.9),('14598','2013-07-29','11:10:00',3.95),('14598','2013-07-29','11:15:00',3.96),('14598','2013-07-29','11:20:00',4.06),('14598','2013-07-29','11:25:00',4.11),('14598','2013-07-29','11:30:00',4.18),('14598','2013-07-29','11:35:00',4.24),('14598','2013-07-29','11:40:00',4.27),('14598','2013-07-29','11:45:00',4.31),('14598','2013-07-29','11:50:00',4.36),('14598','2013-07-29','11:55:00',4.4),('14598','2013-07-29','12:00:00',4.42),('14598','2013-07-29','12:05:00',4.48),('14598','2013-07-29','12:10:00',4.48),('14598','2013-07-29','12:15:00',4.54),('14598','2013-07-29','12:20:00',4.6),('14598','2013-07-29','12:25:00',4.61),('14598','2013-07-29','12:30:00',4.62),('14598','2013-07-29','12:35:00',4.67),('14598','2013-07-29','12:40:00',4.73),('14598','2013-07-29','12:45:00',4.77),('14598','2013-07-29','12:50:00',4.75),('14598','2013-07-29','12:55:00',4.74),('14598','2013-07-29','13:00:00',4.78),('14598','2013-07-29','13:05:00',4.81),('14598','2013-07-29','13:10:00',4.8),('14598','2013-07-29','13:15:00',4.81),('14598','2013-07-29','13:20:00',4.84),('14598','2013-07-29','13:25:00',4.84),('14598','2013-07-29','13:30:00',4.84),('14598','2013-07-29','13:35:00',4.86),('14598','2013-07-29','13:40:00',4.86),('14598','2013-07-29','13:45:00',4.85),('14598','2013-07-29','13:50:00',4.85),('14598','2013-07-29','13:55:00',4.85),('14598','2013-07-29','14:00:00',4.86),('14598','2013-07-29','14:05:00',4.86),('14598','2013-07-29','14:10:00',4.86),('14598','2013-07-29','14:15:00',4.79),('14598','2013-07-29','14:20:00',4.84),('14598','2013-07-29','14:25:00',4.84),('14598','2013-07-29','14:30:00',4.82),('14598','2013-07-29','14:35:00',4.83),('14598','2013-07-29','14:40:00',4.79),('14598','2013-07-29','14:45:00',4.76),('14598','2013-07-29','14:50:00',4.79),('14598','2013-07-29','14:55:00',4.75),('14598','2013-07-29','15:00:00',4.74),('14598','2013-07-29','15:05:00',4.7),('14598','2013-07-29','15:10:00',4.66),('14598','2013-07-29','15:15:00',4.77),('14598','2013-07-29','15:20:00',4.67),('14598','2013-07-29','15:25:00',3.58),('14598','2013-07-29','15:30:00',4.07),('14598','2013-07-29','15:35:00',3.55),('14598','2013-07-29','15:40:00',3.83),('14598','2013-07-29','15:45:00',3.71),('14598','2013-07-29','15:50:00',3.07),('14598','2013-07-29','15:55:00',2.78),('14598','2013-07-29','16:00:00',2.66),('14598','2013-07-29','16:05:00',3.04),('14598','2013-07-29','16:10:00',4.61),('14598','2013-07-29','16:15:00',4.08),('14598','2013-07-29','16:20:00',4.03),('14598','2013-07-29','16:25:00',2.31),('14598','2013-07-29','16:30:00',3.09),('14598','2013-07-29','16:35:00',2.02),('14598','2013-07-29','16:40:00',1.68),('14598','2013-07-29','16:45:00',3.86),('14598','2013-07-29','16:50:00',4.28),('14598','2013-07-29','16:55:00',3.46),('14598','2013-07-29','17:00:00',3.1),('14598','2013-07-29','17:05:00',3.52),('14598','2013-07-29','17:10:00',2.62),('14598','2013-07-29','17:15:00',2.34),('14598','2013-07-29','17:20:00',2.53),('14598','2013-07-29','17:25:00',3.71),('14598','2013-07-29','17:30:00',3.35),('14598','2013-07-29','17:35:00',2.2),('14598','2013-07-29','17:40:00',1.37),('14598','2013-07-29','17:45:00',2.82),('14598','2013-07-29','17:50:00',2.82),('14598','2013-07-29','17:55:00',2.56),('14598','2013-07-29','18:00:00',2.41),('14598','2013-07-29','18:05:00',2.21),('14598','2013-07-29','18:10:00',2.2),('14598','2013-07-29','18:15:00',2.11),('14598','2013-07-29','18:20:00',1.89),('14598','2013-07-29','18:25:00',1.35),('14598','2013-07-29','18:30:00',1.12),('14598','2013-07-29','18:35:00',1.52),('14598','2013-07-29','18:40:00',1.67),('14598','2013-07-29','18:45:00',1.75),('14598','2013-07-29','18:50:00',1.23),('14598','2013-07-28','08:10:00',1.03),('14598','2013-07-28','08:15:00',1.11),('14598','2013-07-28','08:20:00',1.2),('14598','2013-07-28','08:25:00',1.29),('14598','2013-07-28','08:30:00',1.37),('14598','2013-07-28','08:35:00',1.45),('14598','2013-07-28','08:40:00',1.54),('14598','2013-07-28','08:45:00',1.64),('14598','2013-07-28','08:50:00',1.74),('14598','2013-07-28','08:55:00',1.82),('14598','2013-07-28','09:00:00',1.99),('14598','2013-07-28','09:05:00',2.03),('14598','2013-07-28','09:10:00',2.1),('14598','2013-07-28','09:15:00',2.15),('14598','2013-07-28','09:20:00',2.28),('14598','2013-07-28','09:25:00',2.14),('14598','2013-07-28','09:30:00',2.36),('14598','2013-07-28','09:35:00',2.6),('14598','2013-07-28','09:40:00',2.67),('14598','2013-07-28','09:45:00',2.8),('14598','2013-07-28','09:50:00',2.89),('14598','2013-07-28','09:55:00',2.94),('14598','2013-07-28','10:00:00',3.04),('14598','2013-07-28','10:05:00',3.12),('14598','2013-07-28','10:10:00',3.21),('14598','2013-07-28','10:15:00',3.28),('14598','2013-07-28','10:20:00',3.35),('14598','2013-07-28','10:25:00',3.41),('14598','2013-07-28','10:30:00',3.48),('14598','2013-07-28','10:35:00',3.57),('14598','2013-07-28','10:40:00',3.64),('14598','2013-07-28','10:45:00',3.7),('14598','2013-07-28','10:50:00',3.76),('14598','2013-07-28','10:55:00',3.83),('14598','2013-07-28','11:00:00',3.89),('14598','2013-07-28','11:05:00',3.95),('14598','2013-07-28','11:10:00',4),('14598','2013-07-28','11:15:00',4.05),('14598','2013-07-28','11:20:00',4.09),('14598','2013-07-28','11:25:00',4.14),('14598','2013-07-28','11:30:00',4.19),('14598','2013-07-28','11:35:00',4.24),('14598','2013-07-28','11:40:00',4.3),('14598','2013-07-28','11:45:00',4.33),('14598','2013-07-28','11:50:00',4.38),('14598','2013-07-28','11:55:00',4.43),('14598','2013-07-28','12:00:00',4.46),('14598','2013-07-28','12:05:00',4.51),('14598','2013-07-28','12:10:00',4.54),('14598','2013-07-28','12:15:00',4.53),('14598','2013-07-28','12:20:00',4.6),('14598','2013-07-28','12:25:00',4.63),('14598','2013-07-28','12:30:00',4.66),('14598','2013-07-28','12:35:00',4.7),('14598','2013-07-28','12:40:00',4.74),('14598','2013-07-28','12:45:00',4.76),('14598','2013-07-28','12:50:00',4.8),('14598','2013-07-28','12:55:00',4.83),('14598','2013-07-28','13:00:00',4.85),('14598','2013-07-28','13:05:00',4.86),('14598','2013-07-28','13:10:00',4.89),('14598','2013-07-28','13:15:00',4.9),('14598','2013-07-28','13:20:00',4.91),('14598','2013-07-28','13:25:00',4.92),('14598','2013-07-28','13:30:00',4.92),('14598','2013-07-28','13:35:00',4.92),('14598','2013-07-28','13:40:00',4.94),('14598','2013-07-28','13:45:00',4.95),('14598','2013-07-28','13:50:00',4.93),('14598','2013-07-28','13:55:00',4.92),('14598','2013-07-28','14:00:00',4.9),('14598','2013-07-28','14:05:00',4.92),('14598','2013-07-28','14:10:00',4.91),('14598','2013-07-28','14:15:00',4.91),('14598','2013-07-28','14:20:00',4.88),('14598','2013-07-28','14:25:00',4.87),('14598','2013-07-28','14:30:00',4.85),('14598','2013-07-28','14:35:00',4.82),('14598','2013-07-28','14:40:00',4.82),('14598','2013-07-28','14:45:00',4.81),('14598','2013-07-28','14:50:00',4.78),('14598','2013-07-28','14:55:00',4.76),('14598','2013-07-28','15:00:00',4.74),('14598','2013-07-28','15:05:00',4.73),('14598','2013-07-28','15:10:00',4.71),('14598','2013-07-28','15:15:00',4.64),('14598','2013-07-28','15:20:00',4.6),('14598','2013-07-28','15:25:00',4.58),('14598','2013-07-28','15:30:00',4.53),('14598','2013-07-28','15:35:00',4.49),('14598','2013-07-28','15:40:00',4.47),('14598','2013-07-28','15:45:00',4.42),('14598','2013-07-28','15:50:00',4.38),('14598','2013-07-28','15:55:00',4.34),('14598','2013-07-28','16:00:00',4.29),('14598','2013-07-28','16:05:00',4.23),('14598','2013-07-28','16:10:00',4.17),('14598','2013-07-28','16:15:00',4.12),('14598','2013-07-28','16:20:00',4.07),('14598','2013-07-28','16:25:00',4),('14598','2013-07-28','16:30:00',3.94),('14598','2013-07-28','16:35:00',3.87),('14598','2013-07-28','16:40:00',3.81),('14598','2013-07-28','16:45:00',3.56),('14598','2013-07-28','16:50:00',2.82),('14598','2013-07-28','16:55:00',3.58),('14598','2013-07-28','17:00:00',3.51),('14598','2013-07-28','17:05:00',3.43),('14598','2013-07-28','17:10:00',3.39),('14598','2013-07-28','17:15:00',3.31),('14598','2013-07-28','17:20:00',3.24),('14598','2013-07-28','17:25:00',3.16),('14598','2013-07-28','17:30:00',3.08),('14598','2013-07-28','17:35:00',2.95),('14598','2013-07-28','17:40:00',2.88),('14598','2013-07-28','17:45:00',2.81),('14598','2013-07-28','17:50:00',2.69),('14598','2013-07-28','17:55:00',2.59),('14598','2013-07-28','18:00:00',2.48),('14598','2013-07-28','18:05:00',2.4),('14598','2013-07-28','18:10:00',2.31),('14598','2013-07-28','18:15:00',2.2),('14598','2013-07-28','18:20:00',2.09),('14598','2013-07-28','18:25:00',2),('14598','2013-07-28','18:30:00',1.89),('14598','2013-07-28','18:35:00',1.81),('14598','2013-07-28','18:40:00',1.7),('14598','2013-07-28','18:45:00',1.59),('14598','2013-07-28','18:50:00',1.47),('14598','2013-07-28','18:55:00',1.35),('14598','2013-07-28','19:00:00',1.25),('14598','2013-07-28','19:05:00',1.15),('14598','2013-07-28','19:10:00',1.05),('14598','2013-07-27','08:10:00',1.04),('14598','2013-07-27','08:15:00',1.14),('14598','2013-07-27','08:20:00',1.22),('14598','2013-07-27','08:25:00',1.32),('14598','2013-07-27','08:30:00',1.42),('14598','2013-07-27','08:35:00',1.49),('14598','2013-07-27','08:40:00',1.54),('14598','2013-07-27','08:45:00',1.68),('14598','2013-07-27','08:50:00',1.77),('14598','2013-07-27','08:55:00',1.86),('14598','2013-07-27','09:00:00',1.99),('14598','2013-07-27','09:05:00',2.08),('14598','2013-07-27','09:10:00',2.18),('14598','2013-07-27','09:15:00',2.26),('14598','2013-07-27','09:20:00',2.34),('14598','2013-07-27','09:25:00',2.42),('14598','2013-07-27','09:30:00',2.52),('14598','2013-07-27','09:35:00',2.57),('14598','2013-07-27','09:40:00',2.69),('14598','2013-07-27','09:45:00',2.77),('14598','2013-07-27','09:50:00',2.82),('14598','2013-07-27','09:55:00',2.9),('14598','2013-07-27','10:00:00',2.99),('14598','2013-07-27','10:05:00',3.05),('14598','2013-07-27','10:10:00',3.14),('14598','2013-07-27','10:15:00',3.23),('14598','2013-07-27','10:20:00',3.29),('14598','2013-07-27','10:25:00',3.31),('14598','2013-07-27','10:30:00',3.4),('14598','2013-07-27','10:35:00',3.49),('14598','2013-07-27','10:40:00',3.62),('14598','2013-07-27','10:45:00',3.68),('14598','2013-07-27','10:50:00',3.75),('14598','2013-07-27','10:55:00',3.82),('14598','2013-07-27','11:00:00',3.88),('14598','2013-07-27','11:05:00',3.94),('14598','2013-07-27','11:10:00',3.92),('14598','2013-07-27','11:15:00',4.02),('14598','2013-07-27','11:20:00',4.09),('14598','2013-07-27','11:25:00',3.68),('14598','2013-07-27','11:30:00',2.94),('14598','2013-07-27','11:35:00',4.24),('14598','2013-07-27','11:40:00',3.24),('14598','2013-07-27','11:45:00',4.36),('14598','2013-07-27','11:50:00',4.42),('14598','2013-07-27','11:55:00',4.48),('14598','2013-07-27','12:00:00',4.51),('14598','2013-07-27','12:05:00',4.55),('14598','2013-07-27','12:10:00',3.67),('14598','2013-07-27','12:15:00',4.61),('14598','2013-07-27','12:20:00',4.67),('14598','2013-07-27','12:25:00',4.69),('14598','2013-07-27','12:30:00',4.71),('14598','2013-07-27','12:35:00',4.74),('14598','2013-07-27','12:40:00',4.78),('14598','2013-07-27','12:45:00',4.79),('14598','2013-07-27','12:50:00',4.85),('14598','2013-07-27','12:55:00',4.86),('14598','2013-07-27','13:00:00',4.87),('14598','2013-07-27','13:05:00',4.87),('14598','2013-07-27','13:10:00',4.89),('14598','2013-07-27','13:15:00',4.9),('14598','2013-07-27','13:20:00',4.91),('14598','2013-07-27','13:25:00',4.92),('14598','2013-07-27','13:30:00',4.9),('14598','2013-07-27','13:35:00',4.91),('14598','2013-07-27','13:40:00',4.91),('14598','2013-07-27','13:45:00',4.91),('14598','2013-07-27','13:50:00',4.92),('14598','2013-07-27','13:55:00',4.92),('14598','2013-07-27','14:00:00',4.92),('14598','2013-07-27','14:05:00',4.92),('14598','2013-07-27','14:10:00',4.93),('14598','2013-07-27','14:15:00',4.86),('14598','2013-07-27','14:20:00',4.89),('14598','2013-07-27','14:25:00',4.89),('14598','2013-07-27','14:30:00',4.87),('14598','2013-07-27','14:35:00',4.85),('14598','2013-07-27','14:40:00',4.84),('14598','2013-07-27','14:45:00',4.79),('14598','2013-07-27','14:50:00',4.78),('14598','2013-07-27','14:55:00',4.78),('14598','2013-07-27','15:00:00',4.76),('14598','2013-07-27','15:05:00',4.72),('14598','2013-07-27','15:10:00',4.7),('14598','2013-07-27','15:15:00',4.66),('14598','2013-07-27','15:20:00',4.62),('14598','2013-07-27','15:25:00',4.57),('14598','2013-07-27','15:30:00',4.51),('14598','2013-07-27','15:35:00',4.48),('14598','2013-07-27','15:40:00',4.46),('14598','2013-07-27','15:45:00',4.41),('14598','2013-07-27','15:50:00',4.39),('14598','2013-07-27','15:55:00',4.35),('14598','2013-07-27','16:00:00',4.28),('14598','2013-07-27','16:05:00',4.24),('14598','2013-07-27','16:10:00',4.17),('14598','2013-07-27','16:15:00',4.14),('14598','2013-07-27','16:20:00',4.1),('14598','2013-07-27','16:25:00',4.02),('14598','2013-07-27','16:30:00',3.97),('14598','2013-07-27','16:35:00',3.94),('14598','2013-07-27','16:40:00',3.85),('14598','2013-07-27','16:45:00',3.8),('14598','2013-07-27','16:50:00',3.74),('14598','2013-07-27','16:55:00',3.64),('14598','2013-07-27','17:00:00',3.59),('14598','2013-07-27','17:05:00',3.52),('14598','2013-07-27','17:10:00',3.45),('14598','2013-07-27','17:15:00',3.36),('14598','2013-07-27','17:20:00',3.28),('14598','2013-07-27','17:25:00',3.23),('14598','2013-07-27','17:30:00',3.11),('14598','2013-07-27','17:35:00',3.05),('14598','2013-07-27','17:40:00',2.97),('14598','2013-07-27','17:45:00',2.89),('14598','2013-07-27','17:50:00',2.78),('14598','2013-07-27','17:55:00',2.68),('14598','2013-07-27','18:00:00',2.56),('14598','2013-07-27','18:05:00',2.44),('14598','2013-07-27','18:10:00',2.35),('14598','2013-07-27','18:15:00',2.27),('14598','2013-07-27','18:20:00',2.17),('14598','2013-07-27','18:25:00',2.06),('14598','2013-07-27','18:30:00',1.95),('14598','2013-07-27','18:35:00',1.84),('14598','2013-07-27','18:40:00',1.74),('14598','2013-07-27','18:45:00',1.64),('14598','2013-07-27','18:50:00',1.52),('14598','2013-07-27','18:55:00',1.42),('14598','2013-07-27','19:00:00',1.27),('14598','2013-07-27','19:05:00',1.2),('14598','2013-07-27','19:10:00',1.08),('14598','2013-07-27','19:15:00',1),('14598','2013-07-26','07:55:00',1.12),('14598','2013-07-26','08:00:00',1.06),('14598','2013-07-26','08:05:00',1.16),('14598','2013-07-26','08:10:00',1.28),('14598','2013-07-26','08:15:00',1.37),('14598','2013-07-26','08:20:00',1.4),('14598','2013-07-26','08:25:00',1.5),('14598','2013-07-26','08:30:00',1.6),('14598','2013-07-26','08:35:00',1.62),('14598','2013-07-26','08:40:00',1.84),('14598','2013-07-26','08:45:00',2.04),('14598','2013-07-26','08:50:00',1.78),('14598','2013-07-26','08:55:00',1.64),('14598','2013-07-26','09:00:00',1.55),('14598','2013-07-26','09:05:00',1.98),('14598','2013-07-26','09:10:00',2.1),('14598','2013-07-26','09:15:00',2.17),('14598','2013-07-26','09:20:00',2.27),('14598','2013-07-26','09:25:00',2.38),('14598','2013-07-26','09:30:00',2.43),('14598','2013-07-26','09:35:00',2.52),('14598','2013-07-26','09:40:00',2.32),('14598','2013-07-26','09:45:00',2.13),('14598','2013-07-26','09:50:00',2.84),('14598','2013-07-26','09:55:00',2.84),('14598','2013-07-26','10:00:00',2.11),('14598','2013-07-26','10:05:00',1.21),('14598','2013-07-26','10:10:00',1.17),('14598','2013-07-26','10:15:00',2.73),('14598','2013-07-26','10:20:00',2.88),('14598','2013-07-26','10:25:00',3.25),('14598','2013-07-26','10:30:00',3.41),('14598','2013-07-26','10:35:00',3.42),('14598','2013-07-26','10:40:00',3.51),('14598','2013-07-26','10:45:00',3.6),('14598','2013-07-26','10:50:00',3.62),('14598','2013-07-26','10:55:00',3.65),('14598','2013-07-26','11:00:00',3.74),('14598','2013-07-26','11:05:00',3.88),('14598','2013-07-26','11:10:00',3.86),('14598','2013-07-26','11:15:00',3.92),('14598','2013-07-26','11:20:00',3.99),('14598','2013-07-26','11:25:00',4.02),('14598','2013-07-26','11:30:00',4.12),('14598','2013-07-26','11:35:00',4.17),('14598','2013-07-26','11:40:00',4.22),('14598','2013-07-26','11:45:00',4.23),('14598','2013-07-26','11:50:00',4.27),('14598','2013-07-26','11:55:00',4.32),('14598','2013-07-26','12:00:00',4.38),('14598','2013-07-26','12:05:00',4.4),('14598','2013-07-26','12:10:00',4.45),('14598','2013-07-26','12:15:00',4.47),('14598','2013-07-26','12:20:00',4.51),('14598','2013-07-26','12:25:00',4.54),('14598','2013-07-26','12:30:00',4.54),('14598','2013-07-26','12:35:00',4.58),('14598','2013-07-26','12:40:00',4.61),('14598','2013-07-26','12:45:00',4.64),('14598','2013-07-26','12:50:00',4.66),('14598','2013-07-26','12:55:00',4.69),('14598','2013-07-26','13:00:00',4.73),('14598','2013-07-26','13:05:00',4.76),('14598','2013-07-26','13:10:00',4.75),('14598','2013-07-26','13:15:00',4.73),('14598','2013-07-26','13:20:00',4.79),('14598','2013-07-26','13:25:00',4.79),('14598','2013-07-26','13:30:00',4.81),('14598','2013-07-26','13:35:00',4.8),('14598','2013-07-26','13:40:00',4.81),('14598','2013-07-26','13:45:00',4.83),('14598','2013-07-26','13:50:00',4.83),('14598','2013-07-26','13:55:00',4.84),('14598','2013-07-26','14:00:00',4.85),('14598','2013-07-26','14:05:00',4.84),('14598','2013-07-26','14:10:00',4.84),('14598','2013-07-26','14:15:00',4.83),('14598','2013-07-26','14:20:00',4.83),('14598','2013-07-26','14:25:00',4.83),('14598','2013-07-26','14:30:00',4.81),('14598','2013-07-26','14:35:00',4.78),('14598','2013-07-26','14:40:00',4.75),('14598','2013-07-26','14:45:00',4.72),('14598','2013-07-26','14:50:00',4.7),('14598','2013-07-26','14:55:00',4.7),('14598','2013-07-26','15:00:00',4.64),('14598','2013-07-26','15:05:00',4.63),('14598','2013-07-26','15:10:00',4.62),('14598','2013-07-26','15:15:00',4.59),('14598','2013-07-26','15:20:00',4.56),('14598','2013-07-26','15:25:00',4.54),('14598','2013-07-26','15:30:00',4.51),('14598','2013-07-26','15:35:00',4.45),('14598','2013-07-26','15:40:00',4.42),('14598','2013-07-26','15:45:00',4.35),('14598','2013-07-26','15:50:00',4.28),('14598','2013-07-26','15:55:00',4.24),('14598','2013-07-26','16:00:00',4.2),('14598','2013-07-26','16:05:00',4.14),('14598','2013-07-26','16:10:00',4.09),('14598','2013-07-26','16:15:00',3.98),('14598','2013-07-26','16:20:00',3.98),('14598','2013-07-26','16:25:00',3.91),('14598','2013-07-26','16:30:00',3.85),('14598','2013-07-26','16:35:00',3.78),('14598','2013-07-26','16:40:00',3.72),('14598','2013-07-26','16:45:00',3.64),('14598','2013-07-26','16:50:00',3.59),('14598','2013-07-26','16:55:00',3.51),('14598','2013-07-26','17:00:00',3.41),('14598','2013-07-26','17:05:00',3.35),('14598','2013-07-26','17:10:00',3.28),('14598','2013-07-26','17:15:00',3.2),('14598','2013-07-26','17:20:00',3.1),('14598','2013-07-26','17:25:00',3.04),('14598','2013-07-26','17:30:00',2.95),('14598','2013-07-26','17:35:00',2.86),('14598','2013-07-26','17:40:00',2.79),('14598','2013-07-26','17:45:00',2.7),('14598','2013-07-26','17:50:00',2.6),('14598','2013-07-26','17:55:00',2.49),('14598','2013-07-26','18:00:00',2.37),('14598','2013-07-26','18:05:00',2.34),('14598','2013-07-26','18:10:00',2.23),('14598','2013-07-26','18:15:00',2.14),('14598','2013-07-26','18:20:00',2.03),('14598','2013-07-26','18:25:00',1.91),('14598','2013-07-26','18:30:00',1.81),('14598','2013-07-26','18:35:00',1.68),('14598','2013-07-26','18:40:00',1.5),('14598','2013-07-26','18:45:00',1.49),('14598','2013-07-26','18:50:00',1.4),('14598','2013-07-26','18:55:00',1.29),('14598','2013-07-26','19:00:00',1.19),('14598','2013-07-26','19:05:00',1.08),('14598','2013-07-25','08:10:00',1.01),('14598','2013-07-25','08:15:00',1.04),('14598','2013-07-25','08:20:00',1.07),('14598','2013-07-25','08:25:00',1.22),('14598','2013-07-25','08:30:00',1.17),('14598','2013-07-25','08:35:00',1.03),('14598','2013-07-25','08:40:00',1.12),('14598','2013-07-25','08:45:00',1.5),('14598','2013-07-25','08:50:00',1.44),('14598','2013-07-25','08:55:00',1.88),('14598','2013-07-25','09:00:00',1.7),('14598','2013-07-25','09:05:00',2.02),('14598','2013-07-25','09:10:00',2.3),('14598','2013-07-25','09:15:00',2.46),('14598','2013-07-25','09:20:00',2.39),('14598','2013-07-25','09:25:00',2.41),('14598','2013-07-25','09:30:00',1.87),('14598','2013-07-25','09:35:00',2.05),('14598','2013-07-25','09:40:00',2.39),('14598','2013-07-25','09:45:00',1.08),('14598','2013-07-25','09:50:00',2.22),('14598','2013-07-25','09:55:00',3.02),('14598','2013-07-25','10:00:00',2.25),('14598','2013-07-25','10:05:00',2.16),('14598','2013-07-25','10:10:00',3.13),('14598','2013-07-25','10:15:00',3.29),('14598','2013-07-25','10:20:00',3.46),('14598','2013-07-25','10:25:00',3.44),('14598','2013-07-25','10:30:00',3.42),('14598','2013-07-25','10:35:00',3.48),('14598','2013-07-25','10:40:00',3.49),('14598','2013-07-25','10:45:00',3.6),('14598','2013-07-25','10:50:00',3.67),('14598','2013-07-25','10:55:00',3.75),('14598','2013-07-25','11:00:00',3.79),('14598','2013-07-25','11:05:00',3.89),('14598','2013-07-25','11:10:00',3.97),('14598','2013-07-25','11:15:00',3.99),('14598','2013-07-25','11:20:00',4.09),('14598','2013-07-25','11:25:00',4.17),('14598','2013-07-25','11:30:00',4.24),('14598','2013-07-25','11:35:00',4.24),('14598','2013-07-25','11:40:00',4.33),('14598','2013-07-25','11:45:00',4.34),('14598','2013-07-25','11:50:00',4.4),('14598','2013-07-25','11:55:00',4.43),('14598','2013-07-25','12:00:00',4.48),('14598','2013-07-25','12:05:00',4.53),('14598','2013-07-25','12:10:00',4.55),('14598','2013-07-25','12:15:00',4.58),('14598','2013-07-25','12:20:00',4.63),('14598','2013-07-25','12:25:00',4.66),('14598','2013-07-25','12:30:00',4.74),('14598','2013-07-25','12:35:00',4.75),('14598','2013-07-25','12:40:00',4.8),('14598','2013-07-25','12:45:00',4.85),('14598','2013-07-25','12:50:00',4.88),('14598','2013-07-25','12:55:00',4.89),('14598','2013-07-25','13:00:00',4.93),('14598','2013-07-25','13:05:00',4.94),('14598','2013-07-25','13:10:00',4.96),('14598','2013-07-25','13:15:00',5),('14598','2013-07-25','13:20:00',4.98),('14598','2013-07-25','13:25:00',4.99),('14598','2013-07-25','13:30:00',4.99),('14598','2013-07-25','13:35:00',4.96),('14598','2013-07-25','13:40:00',4.94),('14598','2013-07-25','13:45:00',4.97),('14598','2013-07-25','13:50:00',4.96),('14598','2013-07-25','13:55:00',4.97),('14598','2013-07-25','14:00:00',4.98),('14598','2013-07-25','14:05:00',4.98),('14598','2013-07-25','14:10:00',4.97),('14598','2013-07-25','14:15:00',4.93),('14598','2013-07-25','14:20:00',4.93),('14598','2013-07-25','14:25:00',4.82),('14598','2013-07-25','14:30:00',4.89),('14598','2013-07-25','14:35:00',4.87),('14598','2013-07-25','14:40:00',4.85),('14598','2013-07-25','14:45:00',4.83),('14598','2013-07-25','14:50:00',4.81),('14598','2013-07-25','14:55:00',4.78),('14598','2013-07-25','15:00:00',4.76),('14598','2013-07-25','15:05:00',4.72),('14598','2013-07-25','15:10:00',4.67),('14598','2013-07-25','15:15:00',4.64),('14598','2013-07-25','15:20:00',4.61),('14598','2013-07-25','15:25:00',4.6),('14598','2013-07-25','15:30:00',4.51),('14598','2013-07-25','15:35:00',4.53),('14598','2013-07-25','15:40:00',4.49),('14598','2013-07-25','15:45:00',4.47),('14598','2013-07-25','15:50:00',4.41),('14598','2013-07-25','15:55:00',4.35),('14598','2013-07-25','16:00:00',4.28),('14598','2013-07-25','16:05:00',4.25),('14598','2013-07-25','16:10:00',4.24),('14598','2013-07-25','16:15:00',4.02),('14598','2013-07-25','16:20:00',3.96),('14598','2013-07-25','16:25:00',4.02),('14598','2013-07-25','16:30:00',3.91),('14598','2013-07-25','16:35:00',3.92),('14598','2013-07-25','16:40:00',3.85),('14598','2013-07-25','16:45:00',3.8),('14598','2013-07-25','16:50:00',3.75),('14598','2013-07-25','16:55:00',3.32),('14598','2013-07-25','17:00:00',3.44),('14598','2013-07-25','17:05:00',3.49),('14598','2013-07-25','17:10:00',2.98),('14598','2013-07-25','17:15:00',3.27),('14598','2013-07-25','17:20:00',3.08),('14598','2013-07-25','17:25:00',3.09),('14598','2013-07-25','17:30:00',3.06),('14598','2013-07-25','17:35:00',3),('14598','2013-07-25','17:40:00',2.89),('14598','2013-07-25','17:45:00',2.81),('14598','2013-07-25','17:50:00',2.69),('14598','2013-07-25','17:55:00',2.62),('14598','2013-07-25','18:00:00',2.52),('14598','2013-07-25','18:05:00',2.4),('14598','2013-07-25','18:10:00',2.31),('14598','2013-07-25','18:15:00',2.22),('14598','2013-07-25','18:20:00',2.12),('14598','2013-07-25','18:25:00',2.03),('14598','2013-07-25','18:30:00',1.91),('14598','2013-07-25','18:35:00',1.83),('14598','2013-07-25','18:40:00',1.72),('14598','2013-07-25','18:45:00',1.61),('14598','2013-07-25','18:50:00',1.5),('14598','2013-07-25','18:55:00',1.41),('14598','2013-07-25','19:00:00',1.32),('14598','2013-07-25','19:05:00',1.21),('14598','2013-07-25','19:10:00',1.09),('14598','2013-07-24','08:10:00',1.04),('14598','2013-07-24','08:15:00',1.17),('14598','2013-07-24','08:20:00',1.3),('14598','2013-07-24','08:25:00',1.18),('14598','2013-07-24','08:45:00',1.6),('14598','2013-07-24','08:50:00',2),('14598','2013-07-24','08:55:00',1.77),('14598','2013-07-24','09:00:00',1.31),('14598','2013-07-24','09:05:00',1.96),('14598','2013-07-24','09:10:00',2.22),('14598','2013-07-24','09:15:00',2.38),('14598','2013-07-24','09:20:00',2.1),('14598','2013-07-24','09:25:00',2.44),('14598','2013-07-24','09:30:00',2.54),('14598','2013-07-24','09:35:00',2.62),('14598','2013-07-24','09:40:00',2.73),('14598','2013-07-24','09:45:00',2.8),('14598','2013-07-24','09:50:00',2.86),('14598','2013-07-24','09:55:00',2.98),('14598','2013-07-24','10:00:00',2.09),('14598','2013-07-24','10:05:00',3.18),('14598','2013-07-24','10:10:00',3.11),('14598','2013-07-24','10:15:00',3.3),('14598','2013-07-24','10:20:00',3.39),('14598','2013-07-24','10:25:00',3.4),('14598','2013-07-24','10:30:00',2.71),('14598','2013-07-24','10:35:00',3.72),('14598','2013-07-24','10:40:00',3.83),('14598','2013-07-24','10:45:00',3.78),('14598','2013-07-24','10:50:00',3.82),('14598','2013-07-24','10:55:00',3.83),('14598','2013-07-24','11:00:00',3.9),('14598','2013-07-24','11:05:00',3.94),('14598','2013-07-24','11:10:00',4.03),('14598','2013-07-24','11:15:00',4.05),('14598','2013-07-24','11:20:00',4.12),('14598','2013-07-24','11:25:00',4.16),('14598','2013-07-24','11:30:00',4.2),('14598','2013-07-24','11:35:00',4.25),('14598','2013-07-24','11:40:00',4.26),('14598','2013-07-24','11:45:00',4.32),('14598','2013-07-24','11:50:00',4.39),('14598','2013-07-24','11:55:00',4.43),('14598','2013-07-24','12:00:00',4.48),('14598','2013-07-24','12:05:00',4.51),('14598','2013-07-24','12:10:00',4.52),('14598','2013-07-24','12:15:00',4.56),('14598','2013-07-24','12:20:00',4.58),('14598','2013-07-24','12:25:00',4.64),('14598','2013-07-24','12:30:00',4.66),('14598','2013-07-24','12:35:00',4.67),('14598','2013-07-24','12:40:00',4.7),('14598','2013-07-24','12:45:00',4.72),('14598','2013-07-24','12:50:00',4.72),('14598','2013-07-24','12:55:00',4.77),('14598','2013-07-24','13:00:00',4.8),('14598','2013-07-24','13:05:00',4.83),('14598','2013-07-24','13:10:00',4.86),('14598','2013-07-24','13:15:00',4.88),('14598','2013-07-24','13:20:00',4.79),('14598','2013-07-24','13:25:00',4.84),('14598','2013-07-24','13:30:00',4.9),('14598','2013-07-24','13:35:00',4.93),('14598','2013-07-24','13:40:00',4.92),('14598','2013-07-24','13:45:00',4.91),('14598','2013-07-24','13:50:00',4.91),('14598','2013-07-24','13:55:00',4.91),('14598','2013-07-24','14:00:00',4.89),('14598','2013-07-24','14:05:00',4.89),('14598','2013-07-24','14:10:00',4.87),('14598','2013-07-24','14:15:00',4.86),('14598','2013-07-24','14:20:00',4.86),('14598','2013-07-24','14:25:00',4.85),('14598','2013-07-24','14:30:00',4.85),('14598','2013-07-24','14:35:00',4.83),('14598','2013-07-24','14:40:00',4.81),('14598','2013-07-24','14:45:00',4.84),('14598','2013-07-24','14:50:00',4.83),('14598','2013-07-24','14:55:00',4.8),('14598','2013-07-24','15:00:00',4.78),('14598','2013-07-24','15:05:00',4.77),('14598','2013-07-24','15:10:00',4.73),('14598','2013-07-24','15:15:00',4.72),('14598','2013-07-24','15:20:00',4.67),('14598','2013-07-24','15:25:00',4.62),('14598','2013-07-24','15:30:00',4.59),('14598','2013-07-24','15:35:00',4.56),('14598','2013-07-24','15:40:00',4.6),('14598','2013-07-24','15:45:00',4.52),('14598','2013-07-24','15:50:00',4.33),('14598','2013-07-24','15:55:00',4.25),('14598','2013-07-24','16:00:00',4.32),('14598','2013-07-24','16:05:00',4.31),('14598','2013-07-24','16:10:00',4.29),('14598','2013-07-24','16:15:00',4.24),('14598','2013-07-24','16:20:00',4.2),('14598','2013-07-24','16:25:00',4.14),('14598','2013-07-24','16:30:00',4.04),('14598','2013-07-24','16:35:00',4.01),('14598','2013-07-24','16:40:00',3.93),('14598','2013-07-24','16:45:00',3.84),('14598','2013-07-24','16:50:00',3.74),('14598','2013-07-24','16:55:00',3.66),('14598','2013-07-24','17:00:00',3.58),('14598','2013-07-24','17:05:00',3.49),('14598','2013-07-24','17:10:00',3.39),('14598','2013-07-24','17:15:00',3.28),('14598','2013-07-24','17:20:00',3.17),('14598','2013-07-24','17:25:00',3.04),('14598','2013-07-24','17:30:00',2.99),('14598','2013-07-24','17:35:00',2.88),('14598','2013-07-24','17:40:00',2.8),('14598','2013-07-24','17:45:00',2.65),('14598','2013-07-24','17:50:00',2.66),('14598','2013-07-24','17:55:00',2.61),('14598','2013-07-24','18:00:00',2.41),('14598','2013-07-24','18:05:00',1.95),('14598','2013-07-24','18:10:00',2.17),('14598','2013-07-24','18:15:00',1.85),('14598','2013-07-24','18:20:00',1.96),('14598','2013-07-24','18:25:00',1.82),('14598','2013-07-24','18:30:00',1.71),('14598','2013-07-24','18:35:00',1.79),('14598','2013-07-24','18:40:00',1.67),('14598','2013-07-24','18:45:00',1.4),('14598','2013-07-24','18:50:00',1.45),('14598','2013-07-24','18:55:00',1.36),('14598','2013-07-24','19:00:00',1.23),('14598','2013-07-23','08:10:00',1.07),('14598','2013-07-23','08:15:00',1.16),('14598','2013-07-23','08:20:00',1.24),('14598','2013-07-23','08:25:00',1.33),('14598','2013-07-23','08:30:00',1.41),('14598','2013-07-23','08:35:00',1.49),('14598','2013-07-23','08:40:00',1.59),('14598','2013-07-23','08:45:00',1.7),('14598','2013-07-23','08:50:00',1.79),('14598','2013-07-23','08:55:00',1.9),('14598','2013-07-23','09:00:00',2),('14598','2013-07-23','09:05:00',2.11),('14598','2013-07-23','09:10:00',2.2),('14598','2013-07-23','09:15:00',2.3),('14598','2013-07-23','09:20:00',2.39),('14598','2013-07-23','09:25:00',2.48),('14598','2013-07-23','09:30:00',2.55),('14598','2013-07-23','09:35:00',2.63),('14598','2013-07-23','09:40:00',2.7),('14598','2013-07-23','09:45:00',2.77),('14598','2013-07-23','09:50:00',2.84),('14598','2013-07-23','09:55:00',2.92),('14598','2013-07-23','10:00:00',2.99),('14598','2013-07-23','10:05:00',3.06),('14598','2013-07-23','10:10:00',3.12),('14598','2013-07-23','10:15:00',3.19),('14598','2013-07-23','10:20:00',3.23),('14598','2013-07-23','10:25:00',3.32),('14598','2013-07-23','10:30:00',3.44),('14598','2013-07-23','10:35:00',3.44),('14598','2013-07-23','10:40:00',3.57),('14598','2013-07-23','10:45:00',3.66),('14598','2013-07-23','10:50:00',3.7),('14598','2013-07-23','10:55:00',3.75),('14598','2013-07-23','11:00:00',3.82),('14598','2013-07-23','11:05:00',3.9),('14598','2013-07-23','11:10:00',3.94),('14598','2013-07-23','11:15:00',4),('14598','2013-07-23','11:20:00',4.06),('14598','2013-07-23','11:25:00',4.1),('14598','2013-07-23','11:30:00',4.15),('14598','2013-07-23','11:35:00',4.19),('14598','2013-07-23','11:40:00',3.38),('14598','2013-07-23','11:45:00',4.26),('14598','2013-07-23','11:50:00',4.33),('14598','2013-07-23','11:55:00',4.36),('14598','2013-07-23','12:00:00',4.42),('14598','2013-07-23','12:05:00',4.44),('14598','2013-07-23','12:10:00',4.48),('14598','2013-07-23','12:15:00',4.53),('14598','2013-07-23','12:20:00',4.55),('14598','2013-07-23','12:25:00',4.57),('14598','2013-07-23','12:30:00',4.61),('14598','2013-07-23','12:35:00',4.65),('14598','2013-07-23','12:40:00',4.68),('14598','2013-07-23','12:45:00',4.71),('14598','2013-07-23','12:50:00',4.74),('14598','2013-07-23','12:55:00',4.75),('14598','2013-07-23','13:00:00',4.78),('14598','2013-07-23','13:05:00',4.81),('14598','2013-07-23','13:10:00',4.82),('14598','2013-07-23','13:15:00',4.84),('14598','2013-07-23','13:20:00',4.85),('14598','2013-07-23','13:25:00',4.87),('14598','2013-07-23','13:30:00',4.89),('14598','2013-07-23','13:35:00',4.91),('14598','2013-07-23','13:40:00',4.83),('14598','2013-07-23','13:45:00',4.92),('14598','2013-07-23','13:50:00',4.91),('14598','2013-07-23','13:55:00',4.91),('14598','2013-07-23','14:00:00',4.91),('14598','2013-07-23','14:05:00',4.88),('14598','2013-07-23','14:10:00',4.9),('14598','2013-07-23','14:15:00',4.92),('14598','2013-07-23','14:20:00',4.89),('14598','2013-07-23','14:25:00',4.86),('14598','2013-07-23','14:30:00',4.87),('14598','2013-07-23','14:35:00',4.87),('14598','2013-07-23','14:40:00',4.85),('14598','2013-07-23','14:45:00',4.83),('14598','2013-07-23','14:50:00',4.77),('14598','2013-07-23','14:55:00',4.76),('14598','2013-07-23','15:00:00',4.76),('14598','2013-07-23','15:05:00',4.73),('14598','2013-07-23','15:10:00',4.69),('14598','2013-07-23','15:15:00',4.63),('14598','2013-07-23','15:20:00',4.57),('14598','2013-07-23','15:25:00',4.53),('14598','2013-07-23','15:30:00',4.48),('14598','2013-07-23','15:35:00',4.41),('14598','2013-07-23','15:40:00',4.39),('14598','2013-07-23','15:45:00',4.38),('14598','2013-07-23','15:50:00',4.32),('14598','2013-07-23','15:55:00',4.27),('14598','2013-07-23','16:00:00',4.22),('14598','2013-07-23','16:05:00',4.18),('14598','2013-07-23','16:10:00',4.14),('14598','2013-07-23','16:15:00',4.08),('14598','2013-07-23','16:20:00',4.02),('14598','2013-07-23','16:25:00',3.99),('14598','2013-07-23','16:30:00',3.94),('14598','2013-07-23','16:35:00',3.88),('14598','2013-07-23','16:40:00',3.79),('14598','2013-07-23','16:45:00',3.79),('14598','2013-07-23','16:50:00',3.73),('14598','2013-07-23','16:55:00',3.65),('14598','2013-07-23','17:00:00',3.58),('14598','2013-07-23','17:05:00',3.51),('14598','2013-07-23','17:10:00',3.46),('14598','2013-07-23','17:15:00',3.38),('14598','2013-07-23','17:20:00',3.31),('14598','2013-07-23','17:25:00',3.22),('14598','2013-07-23','17:30:00',3.13),('14598','2013-07-23','17:35:00',3.03),('14598','2013-07-23','17:40:00',2.93),('14598','2013-07-23','17:45:00',2.84),('14598','2013-07-23','17:50:00',2.76),('14598','2013-07-23','17:55:00',2.68),('14598','2013-07-23','18:00:00',2.61),('14598','2013-07-23','18:05:00',2.53),('14598','2013-07-23','18:10:00',2.42),('14598','2013-07-23','18:15:00',2.3),('14598','2013-07-23','18:20:00',1.25),('14598','2013-07-23','18:40:00',1.93),('14598','2013-07-23','18:45:00',1.86),('14598','2013-07-23','18:50:00',1.71),('14598','2013-07-23','18:55:00',1.56),('14598','2013-07-23','19:00:00',1.43),('14598','2013-07-23','19:05:00',1.3),('14598','2013-07-23','19:10:00',1.16),('14598','2013-07-23','19:15:00',1.06),('14598','2013-07-22','08:05:00',1.01),('14598','2013-07-22','08:10:00',1.1),('14598','2013-07-22','08:15:00',1.19),('14598','2013-07-22','08:20:00',1.27),('14598','2013-07-22','08:25:00',1.37),('14598','2013-07-22','08:30:00',1.45),('14598','2013-07-22','08:35:00',1.52),('14598','2013-07-22','08:40:00',1.64),('14598','2013-07-22','08:45:00',1.74),('14598','2013-07-22','08:50:00',1.85),('14598','2013-07-22','08:55:00',1.95),('14598','2013-07-22','09:00:00',2.06),('14598','2013-07-22','09:05:00',2.16),('14598','2013-07-22','09:10:00',2.25),('14598','2013-07-22','09:15:00',2.34),('14598','2013-07-22','09:20:00',2.42),('14598','2013-07-22','09:25:00',2.49),('14598','2013-07-22','09:30:00',2.57),('14598','2013-07-22','09:35:00',2.66),('14598','2013-07-22','09:40:00',2.75),('14598','2013-07-22','09:45:00',2.84),('14598','2013-07-22','09:50:00',2.89),('14598','2013-07-22','09:55:00',2.99),('14598','2013-07-22','10:00:00',3.07),('14598','2013-07-22','10:05:00',3.15),('14598','2013-07-22','10:10:00',3.22),('14598','2013-07-22','10:15:00',3.29),('14598','2013-07-22','10:20:00',3.36),('14598','2013-07-22','10:25:00',3.42),('14598','2013-07-22','10:30:00',3.49),('14598','2013-07-22','10:35:00',3.56),('14598','2013-07-22','10:40:00',3.61),('14598','2013-07-22','10:45:00',3.65),('14598','2013-07-22','10:50:00',3.72),('14598','2013-07-22','10:55:00',3.78),('14598','2013-07-22','11:00:00',3.83),('14598','2013-07-22','11:05:00',3.89),('14598','2013-07-22','11:10:00',3.94),('14598','2013-07-22','11:15:00',3.99),('14598','2013-07-22','11:20:00',4.03),('14598','2013-07-22','11:25:00',4.09),('14598','2013-07-22','11:30:00',4.12),('14598','2013-07-22','11:35:00',4.17),('14598','2013-07-22','11:40:00',4.21),('14598','2013-07-22','11:45:00',4.23),('14598','2013-07-22','11:50:00',4.3),('14598','2013-07-22','11:55:00',4.35),('14598','2013-07-22','12:00:00',4.39),('14598','2013-07-22','12:05:00',4.42),('14598','2013-07-22','12:10:00',4.44),('14598','2013-07-22','12:15:00',4.44),('14598','2013-07-22','12:20:00',4.46),('14598','2013-07-22','12:25:00',4.49),('14598','2013-07-22','12:30:00',4.5),('14598','2013-07-22','12:35:00',4.5),('14598','2013-07-22','12:40:00',4.53),('14598','2013-07-22','12:45:00',4.53),('14598','2013-07-22','12:50:00',4.54),('14598','2013-07-22','12:55:00',4.54),('14598','2013-07-22','13:00:00',4.64),('14598','2013-07-22','13:05:00',4.68),('14598','2013-07-22','13:10:00',4.67),('14598','2013-07-22','13:15:00',4.7),('14598','2013-07-22','13:20:00',4.75),('14598','2013-07-22','13:25:00',4.83),('14598','2013-07-22','13:30:00',4.87),('14598','2013-07-22','13:35:00',4.86),('14598','2013-07-22','13:40:00',4.85),('14598','2013-07-22','13:45:00',4.86),('14598','2013-07-22','13:50:00',4.84),('14598','2013-07-22','13:55:00',4.87),('14598','2013-07-22','14:00:00',4.87),('14598','2013-07-22','14:05:00',4.87),('14598','2013-07-22','14:10:00',4.86),('14598','2013-07-22','14:15:00',4.87),('14598','2013-07-22','14:20:00',4.87),('14598','2013-07-22','14:25:00',4.87),('14598','2013-07-22','14:30:00',4.85),('14598','2013-07-22','14:35:00',4.8),('14598','2013-07-22','14:40:00',4.76),('14598','2013-07-22','14:45:00',4.76),('14598','2013-07-22','14:50:00',4.75),('14598','2013-07-22','14:55:00',4.72),('14598','2013-07-22','15:00:00',4.7),('14598','2013-07-22','15:05:00',4.68),('14598','2013-07-22','15:10:00',4.66),('14598','2013-07-22','15:15:00',4.63),('14598','2013-07-22','15:20:00',4.62),('14598','2013-07-22','15:25:00',4.6),('14598','2013-07-22','15:30:00',4.54),('14598','2013-07-22','15:35:00',4.51),('14598','2013-07-22','15:40:00',4.5),('14598','2013-07-22','15:45:00',4.46),('14598','2013-07-22','15:50:00',4.39),('14598','2013-07-22','15:55:00',4.32),('14598','2013-07-22','16:00:00',4.31),('14598','2013-07-22','16:05:00',4.23),('14598','2013-07-22','16:10:00',4.16),('14598','2013-07-22','16:15:00',3.93),('14598','2013-07-22','16:20:00',3.81),('14598','2013-07-22','16:25:00',3.94),('14598','2013-07-22','16:30:00',3.91),('14598','2013-07-22','16:35:00',3.88),('14598','2013-07-22','16:40:00',3.8),('14598','2013-07-22','16:45:00',3.67),('14598','2013-07-22','16:50:00',3.59),('14598','2013-07-22','16:55:00',3.54),('14598','2013-07-22','17:00:00',3.51),('14598','2013-07-22','17:05:00',3.43),('14598','2013-07-22','17:10:00',3.28),('14598','2013-07-22','17:15:00',3.2),('14598','2013-07-22','17:20:00',3.19),('14598','2013-07-22','17:25:00',3.06),('14598','2013-07-22','17:30:00',2.98),('14598','2013-07-22','17:35:00',2.9),('14598','2013-07-22','17:40:00',2.8),('14598','2013-07-22','17:45:00',2.72),('14598','2013-07-22','17:50:00',2.56),('14598','2013-07-22','17:55:00',2.52),('14598','2013-07-22','18:00:00',2.46),('14598','2013-07-22','18:05:00',2.37),('14598','2013-07-22','18:10:00',2.26),('14598','2013-07-22','18:15:00',2.14),('14598','2013-07-22','18:20:00',2.04),('14598','2013-07-22','18:25:00',1.95),('14598','2013-07-22','18:30:00',1.86),('14598','2013-07-22','18:35:00',1.75),('14598','2013-07-22','18:40:00',1.67),('14598','2013-07-22','18:45:00',1.56),('14598','2013-07-22','18:50:00',1.44),('14598','2013-07-22','18:55:00',1.33),('14598','2013-07-22','19:00:00',1.26),('14598','2013-07-22','19:05:00',1.15),('14598','2013-07-22','19:10:00',1.07),('14598','2013-07-21','08:10:00',1.05),('14598','2013-07-21','08:15:00',1.14),('14598','2013-07-21','08:20:00',1.22),('14598','2013-07-21','08:25:00',1.31),('14598','2013-07-21','08:30:00',1.41),('14598','2013-07-21','08:35:00',1.51),('14598','2013-07-21','08:40:00',1.6),('14598','2013-07-21','08:45:00',1.65),('14598','2013-07-21','08:50:00',1.77),('14598','2013-07-21','08:55:00',1.83),('14598','2013-07-21','09:00:00',1.97),('14598','2013-07-21','09:05:00',2.09),('14598','2013-07-21','09:10:00',2.16),('14598','2013-07-21','09:15:00',2.25),('14598','2013-07-21','09:20:00',2.32),('14598','2013-07-21','09:25:00',2.38),('14598','2013-07-21','09:30:00',2.46),('14598','2013-07-21','09:35:00',2.02),('14598','2013-07-21','09:40:00',2.61),('14598','2013-07-21','09:45:00',2.7),('14598','2013-07-21','09:50:00',2.8),('14598','2013-07-21','09:55:00',2.85),('14598','2013-07-21','10:00:00',2.93),('14598','2013-07-21','10:05:00',2.99),('14598','2013-07-21','10:10:00',3.12),('14598','2013-07-21','10:15:00',3.17),('14598','2013-07-21','10:20:00',3.25),('14598','2013-07-21','10:25:00',3.32),('14598','2013-07-21','10:30:00',3.39),('14598','2013-07-21','10:35:00',3.47),('14598','2013-07-21','10:40:00',3.5),('14598','2013-07-21','10:45:00',3.56),('14598','2013-07-21','10:50:00',3.6),('14598','2013-07-21','10:55:00',3.67),('14598','2013-07-21','11:00:00',3.72),('14598','2013-07-21','11:05:00',3.75),('14598','2013-07-21','11:10:00',3.79),('14598','2013-07-21','11:15:00',3.86),('14598','2013-07-21','11:20:00',3.95),('14598','2013-07-21','11:25:00',3.96),('14598','2013-07-21','11:30:00',4.06),('14598','2013-07-21','11:35:00',4.16),('14598','2013-07-21','11:40:00',4.26),('14598','2013-07-21','11:45:00',4.04),('14598','2013-07-21','11:50:00',4.46),('14598','2013-07-21','11:55:00',4.48),('14598','2013-07-21','12:00:00',4.62),('14598','2013-07-21','12:05:00',4.64),('14598','2013-07-21','12:10:00',4.72),('14598','2013-07-21','12:15:00',4.28),('14598','2013-07-21','12:20:00',2.78),('14598','2013-07-21','12:25:00',1.61),('14598','2013-07-21','12:30:00',1.61),('14598','2013-07-21','12:35:00',1.72),('14598','2013-07-21','12:40:00',3.38),('14598','2013-07-21','12:45:00',5.64),('14598','2013-07-21','12:50:00',5.46),('14598','2013-07-21','12:55:00',5.54),('14598','2013-07-21','13:00:00',5.14),('14598','2013-07-21','13:05:00',1.87),('14598','2013-07-21','13:10:00',2.03),('14598','2013-07-21','13:15:00',2.32),('14598','2013-07-21','13:20:00',2.32),('14598','2013-07-21','13:25:00',2.32),('14598','2013-07-21','13:30:00',2.81),('14598','2013-07-21','13:35:00',2.86),('14598','2013-07-21','13:40:00',4.74),('14598','2013-07-21','13:45:00',3.43),('14598','2013-07-21','13:50:00',2.55),('14598','2013-07-21','13:55:00',2.59),('14598','2013-07-21','14:00:00',4.77),('14598','2013-07-21','14:05:00',4.68),('14598','2013-07-21','14:10:00',5.97),('14598','2013-07-21','14:15:00',5.75),('14598','2013-07-21','14:20:00',5.74),('14598','2013-07-21','14:25:00',5.78),('14598','2013-07-21','14:30:00',4.78),('14598','2013-07-21','14:35:00',4.56),('14598','2013-07-21','14:40:00',4.38),('14598','2013-07-21','14:45:00',2.7),('14598','2013-07-21','14:50:00',2.99),('14598','2013-07-21','14:55:00',2.83),('14598','2013-07-21','15:00:00',2.89),('14598','2013-07-21','15:05:00',2.64),('14598','2013-07-21','15:10:00',2.38),('14598','2013-07-21','15:15:00',3.03),('14598','2013-07-21','15:20:00',4.25),('14598','2013-07-21','15:25:00',3.93),('14598','2013-07-21','15:30:00',3.71),('14598','2013-07-21','15:35:00',2.6),('14598','2013-07-21','15:40:00',2.05),('14598','2013-07-21','15:45:00',1.74),('14598','2013-07-21','15:50:00',1.71),('14598','2013-07-21','15:55:00',1.66),('14598','2013-07-21','16:00:00',1.53),('14598','2013-07-21','16:05:00',1.4),('14598','2013-07-21','16:10:00',1.32),('14598','2013-07-21','16:15:00',1.33),('14598','2013-07-21','16:20:00',1.52),('14598','2013-07-21','16:25:00',1.68),('14598','2013-07-21','16:30:00',2.01),('14598','2013-07-21','16:35:00',2.32),('14598','2013-07-21','16:40:00',1.85),('14598','2013-07-21','16:45:00',1.86),('14598','2013-07-21','16:50:00',1.89),('14598','2013-07-21','16:55:00',1.78),('14598','2013-07-21','17:00:00',1.85),('14598','2013-07-21','17:05:00',1.87),('14598','2013-07-21','17:10:00',1.86),('14598','2013-07-21','17:15:00',2.32),('14598','2013-07-21','17:20:00',2.34),('14598','2013-07-21','17:25:00',2.76),('14598','2013-07-21','17:30:00',2.81),('14598','2013-07-21','17:35:00',3.05),('14598','2013-07-21','17:40:00',3.15),('14598','2013-07-21','17:45:00',3.28),('14598','2013-07-21','17:50:00',3.07),('14598','2013-07-21','17:55:00',2.66),('14598','2013-07-21','18:00:00',2.23),('14598','2013-07-21','18:05:00',1.8),('14598','2013-07-21','18:10:00',1.59),('14598','2013-07-21','18:15:00',1.66),('14598','2013-07-21','18:20:00',1.63),('14598','2013-07-21','18:25:00',1.81),('14598','2013-07-21','18:30:00',1.75),('14598','2013-07-21','18:35:00',1.4),('14598','2013-07-21','18:40:00',1.33),('14598','2013-07-21','18:45:00',1.09),('14598','2013-07-21','18:50:00',1.05),('14598','2013-07-21','18:55:00',1.41),('14598','2013-07-21','19:00:00',1.63),('14598','2013-07-21','19:05:00',1.35),('14598','2014-04-07','09:00:00',1.02),('14598','2014-04-07','09:05:00',1.15),('14598','2014-04-07','09:10:00',1.24),('14598','2014-04-07','09:15:00',1.3),('14598','2014-04-07','09:20:00',1.27),('14598','2014-04-07','09:25:00',1.21),('14598','2014-04-07','09:30:00',1.17),('14598','2014-04-07','09:35:00',1.21),('14598','2014-04-07','09:40:00',1.16),('14598','2014-04-07','09:45:00',1.14),('14598','2014-04-07','09:50:00',1.16),('14598','2014-04-07','09:55:00',1.19),('14598','2014-04-07','10:00:00',1.23),('14598','2014-04-07','10:05:00',1.3),('14598','2014-04-07','10:10:00',1.45),('14598','2014-04-07','10:15:00',1.62),('14598','2014-04-07','10:20:00',1.54),('14598','2014-04-07','10:25:00',1.55),('14598','2014-04-07','10:30:00',1.67),('14598','2014-04-07','10:35:00',1.75),('14598','2014-04-07','10:40:00',1.72),('14598','2014-04-07','10:45:00',1.79),('14598','2014-04-07','10:50:00',1.89),('14598','2014-04-07','10:55:00',1.94),('14598','2014-04-07','11:00:00',2.06),('14598','2014-04-07','11:05:00',2.1),('14598','2014-04-07','11:10:00',2.18),('14598','2014-04-07','11:15:00',2.26),('14598','2014-04-07','11:20:00',1.79),('14598','2014-04-07','11:25:00',1.64),('14598','2014-04-07','11:30:00',1.69),('14598','2014-04-07','11:35:00',1.94),('14598','2014-04-07','11:40:00',2.35),('14598','2014-04-07','11:45:00',2.38),('14598','2014-04-07','11:50:00',3.25),('14598','2014-04-07','11:55:00',4.39),('14598','2014-04-07','12:00:00',3.54),('14598','2014-04-07','12:05:00',4.28),('14598','2014-04-07','12:10:00',4.18),('14598','2014-04-07','12:15:00',3.24),('14598','2014-04-07','12:20:00',2.07),('14598','2014-04-07','12:25:00',2.55),('14598','2014-04-07','12:30:00',4.71),('14598','2014-04-07','12:35:00',4.68),('14598','2014-04-07','12:40:00',4.59),('14598','2014-04-07','12:45:00',4.58),('14598','2014-04-07','12:50:00',4.59),('14598','2014-04-07','12:55:00',4.59),('14598','2014-04-07','13:00:00',4.6),('14598','2014-04-07','13:05:00',4.61),('14598','2014-04-07','13:10:00',4.59),('14598','2014-04-07','13:15:00',4.59),('14598','2014-04-07','13:20:00',4.62),('14598','2014-04-07','13:25:00',4.64),('14598','2014-04-07','13:30:00',4.67),('14598','2014-04-07','13:35:00',4.71),('14598','2014-04-07','13:40:00',4.69),('14598','2014-04-07','13:45:00',4.72),('14598','2014-04-07','13:50:00',4.73),('14598','2014-04-07','13:55:00',4.71),('14598','2014-04-07','14:00:00',4.73),('14598','2014-04-07','14:05:00',4.74),('14598','2014-04-07','14:10:00',4.73),('14598','2014-04-07','14:15:00',4.7),('14598','2014-04-07','14:20:00',4.69),('14598','2014-04-07','14:25:00',4.67),('14598','2014-04-07','14:30:00',4.68),('14598','2014-04-07','14:35:00',4.64),('14598','2014-04-07','14:40:00',4.6),('14598','2014-04-07','14:45:00',4.58),('14598','2014-04-07','14:50:00',4.55),('14598','2014-04-07','14:55:00',4.53),('14598','2014-04-07','15:00:00',4.45),('14598','2014-04-07','15:05:00',4.46),('14598','2014-04-07','15:10:00',4.41),('14598','2014-04-07','15:15:00',4.34),('14598','2014-04-07','15:20:00',4.31),('14598','2014-04-07','15:25:00',4.28),('14598','2014-04-07','15:30:00',4.25),('14598','2014-04-07','15:35:00',4.16),('14598','2014-04-07','15:40:00',4.1),('14598','2014-04-07','15:45:00',4.03),('14598','2014-04-07','15:50:00',4.01),('14598','2014-04-07','15:55:00',3.95),('14598','2014-04-07','16:00:00',3.8),('14598','2014-04-07','16:05:00',3.78),('14598','2014-04-07','16:10:00',3.75),('14598','2014-04-07','16:15:00',3.68),('14598','2014-04-07','16:20:00',3.7),('14598','2014-04-07','16:25:00',3.74),('14598','2014-04-07','16:30:00',3.59),('14598','2014-04-07','16:35:00',3.37),('14598','2014-04-07','16:40:00',2.33),('14598','2014-04-07','16:45:00',2.69),('14598','2014-04-07','16:50:00',3.25),('14598','2014-04-07','16:55:00',3.03),('14598','2014-04-07','17:00:00',2.96),('14598','2014-04-07','17:05:00',2.86),('14598','2014-04-07','17:10:00',2.76),('14598','2014-04-07','17:15:00',2.72),('14598','2014-04-07','17:20:00',2.58),('14598','2014-04-07','17:25:00',2.34),('14598','2014-04-07','17:30:00',2.35),('14598','2014-04-07','17:35:00',2.23),('14598','2014-04-07','17:40:00',2.14),('14598','2014-04-07','17:45:00',2.01),('14598','2014-04-07','17:50:00',1.95),('14598','2014-04-07','17:55:00',1.63),('14598','2014-04-07','18:00:00',1.56),('14598','2014-04-07','18:10:00',1.36),('14598','2014-04-07','18:15:00',1.06),('14598','2013-07-20','08:05:00',1.03),('14598','2013-07-20','08:10:00',1.11),('14598','2013-07-20','08:15:00',1.22),('14598','2013-07-20','08:20:00',1.33),('14598','2013-07-20','08:25:00',1.45),('14598','2013-07-20','08:30:00',1.52),('14598','2013-07-20','08:35:00',1.69),('14598','2013-07-20','08:40:00',1.73),('14598','2013-07-20','08:45:00',1.98),('14598','2013-07-20','08:50:00',2.11),('14598','2013-07-20','08:55:00',2.18),('14598','2013-07-20','09:00:00',2.12),('14598','2013-07-20','09:05:00',2.03),('14598','2013-07-20','09:10:00',1.94),('14598','2013-07-20','09:15:00',2.21),('14598','2013-07-20','09:20:00',2.56),('14598','2013-07-20','09:25:00',2.45),('14598','2013-07-20','09:30:00',1.9),('14598','2013-07-20','09:35:00',2.1),('14598','2013-07-20','09:40:00',2.78),('14598','2013-07-20','09:45:00',2.86),('14598','2013-07-20','09:50:00',2.9),('14598','2013-07-20','09:55:00',2.99),('14598','2013-07-20','10:00:00',3.06),('14598','2013-07-20','10:05:00',3.11),('14598','2013-07-20','10:10:00',3.17),('14598','2013-07-20','10:15:00',3.26),('14598','2013-07-20','10:20:00',3.34),('14598','2013-07-20','10:25:00',3.4),('14598','2013-07-20','10:30:00',3.44),('14598','2013-07-20','10:35:00',3.53),('14598','2013-07-20','10:40:00',3.59),('14598','2013-07-20','10:45:00',3.62),('14598','2013-07-20','10:50:00',3.68),('14598','2013-07-20','10:55:00',3.75),('14598','2013-07-20','11:00:00',3.81),('14598','2013-07-20','11:05:00',3.91),('14598','2013-07-20','11:10:00',3.99),('14598','2013-07-20','11:15:00',4.05),('14598','2013-07-20','11:20:00',4.12),('14598','2013-07-20','11:25:00',4.17),('14598','2013-07-20','11:30:00',4.24),('14598','2013-07-20','11:35:00',4.25),('14598','2013-07-20','11:40:00',4.3),('14598','2013-07-20','11:45:00',4.37),('14598','2013-07-20','11:50:00',4.43),('14598','2013-07-20','11:55:00',4.46),('14598','2013-07-20','12:00:00',4.51),('14598','2013-07-20','12:05:00',4.56),('14598','2013-07-20','12:10:00',4.57),('14598','2013-07-20','12:15:00',4.59),('14598','2013-07-20','12:20:00',4.63),('14598','2013-07-20','12:25:00',4.66),('14598','2013-07-20','12:30:00',4.69),('14598','2013-07-20','12:35:00',4.72),('14598','2013-07-20','12:40:00',4.74),('14598','2013-07-20','12:45:00',4.75),('14598','2013-07-20','12:50:00',4.74),('14598','2013-07-20','12:55:00',4.83),('14598','2013-07-20','13:00:00',4.85),('14598','2013-07-20','13:05:00',4.86),('14598','2013-07-20','13:10:00',4.88),('14598','2013-07-20','13:15:00',4.9),('14598','2013-07-20','13:20:00',4.91),('14598','2013-07-20','13:25:00',4.9),('14598','2013-07-20','13:30:00',4.91),('14598','2013-07-20','13:35:00',4.91),('14598','2013-07-20','13:40:00',4.92),('14598','2013-07-20','13:45:00',4.94),('14598','2013-07-20','13:50:00',4.94),('14598','2013-07-20','13:55:00',4.93),('14598','2013-07-20','14:00:00',4.95),('14598','2013-07-20','14:05:00',4.92),('14598','2013-07-20','14:10:00',4.92),('14598','2013-07-20','14:15:00',4.91),('14598','2013-07-20','14:20:00',4.9),('14598','2013-07-20','14:25:00',4.89),('14598','2013-07-20','14:30:00',4.86),('14598','2013-07-20','14:35:00',4.84),('14598','2013-07-20','14:40:00',4.86),('14598','2013-07-20','14:45:00',4.84),('14598','2013-07-20','14:50:00',4.81),('14598','2013-07-20','14:55:00',4.77),('14598','2013-07-20','15:00:00',4.75),('14598','2013-07-20','15:05:00',4.73),('14598','2013-07-20','15:10:00',4.7),('14598','2013-07-20','15:15:00',4.68),('14598','2013-07-20','15:20:00',4.64),('14598','2013-07-20','15:25:00',4.6),('14598','2013-07-20','15:30:00',4.54),('14598','2013-07-20','15:35:00',4.5),('14598','2013-07-20','15:40:00',4.49),('14598','2013-07-20','15:45:00',4.45),('14598','2013-07-20','15:50:00',4.36),('14598','2013-07-20','15:55:00',4.34),('14598','2013-07-20','16:00:00',4.3),('14598','2013-07-20','16:05:00',4.26),('14598','2013-07-20','16:10:00',4.21),('14598','2013-07-20','16:15:00',4.16),('14598','2013-07-20','16:20:00',4.09),('14598','2013-07-20','16:25:00',4.06),('14598','2013-07-20','16:30:00',3.99),('14598','2013-07-20','16:35:00',3.95),('14598','2013-07-20','16:40:00',3.85),('14598','2013-07-20','16:45:00',3.79),('14598','2013-07-20','16:50:00',3.72),('14598','2013-07-20','16:55:00',3.65),('14598','2013-07-20','17:00:00',3.58),('14598','2013-07-20','17:05:00',3.49),('14598','2013-07-20','17:10:00',3.43),('14598','2013-07-20','17:15:00',3.36),('14598','2013-07-20','17:20:00',3.28),('14598','2013-07-20','17:25:00',3.19),('14598','2013-07-20','17:30:00',3.11),('14598','2013-07-20','17:35:00',3.03),('14598','2013-07-20','17:40:00',2.94),('14598','2013-07-20','17:45:00',2.86),('14598','2013-07-20','17:50:00',2.76),('14598','2013-07-20','17:55:00',2.67),('14598','2013-07-20','18:00:00',2.57),('14598','2013-07-20','18:05:00',2.49),('14598','2013-07-20','18:10:00',2.4),('14598','2013-07-20','18:15:00',2.31),('14598','2013-07-20','18:20:00',2.2),('14598','2013-07-20','18:25:00',2.11),('14598','2013-07-20','18:30:00',2.01),('14598','2013-07-20','18:35:00',1.9),('14598','2013-07-20','18:40:00',1.79),('14598','2013-07-20','18:45:00',1.68),('14598','2013-07-20','18:50:00',1.59),('14598','2013-07-20','18:55:00',1.45),('14598','2013-07-20','19:00:00',1.37),('14598','2013-07-20','19:05:00',1.25),('14598','2013-07-20','19:10:00',1.14),('14598','2013-07-20','19:15:00',1.03),('14598','2013-07-19','08:05:00',1),('14598','2013-07-19','08:10:00',1.07),('14598','2013-07-19','08:15:00',1.16),('14598','2013-07-19','08:20:00',1.26),('14598','2013-07-19','08:25:00',1.36),('14598','2013-07-19','08:30:00',1.44),('14598','2013-07-19','08:35:00',1.51),('14598','2013-07-19','08:40:00',1.6),('14598','2013-07-19','08:45:00',1.7),('14598','2013-07-19','08:50:00',1.8),('14598','2013-07-19','08:55:00',1.91),('14598','2013-07-19','09:00:00',2.03),('14598','2013-07-19','09:05:00',2.12),('14598','2013-07-19','09:10:00',2.08),('14598','2013-07-19','09:15:00',1.98),('14598','2013-07-19','09:20:00',2.3),('14598','2013-07-19','09:25:00',2.37),('14598','2013-07-19','09:30:00',2.46),('14598','2013-07-19','09:35:00',2.5),('14598','2013-07-19','09:40:00',2.63),('14598','2013-07-19','09:45:00',2.77),('14598','2013-07-19','09:50:00',2.83),('14598','2013-07-19','09:55:00',2.92),('14598','2013-07-19','10:00:00',3.03),('14598','2013-07-19','10:05:00',3.07),('14598','2013-07-19','10:10:00',3.18),('14598','2013-07-19','10:15:00',3.23),('14598','2013-07-19','10:20:00',3.28),('14598','2013-07-19','10:25:00',3.37),('14598','2013-07-19','10:30:00',3.42),('14598','2013-07-19','10:35:00',3.49),('14598','2013-07-19','10:40:00',3.56),('14598','2013-07-19','10:45:00',3.64),('14598','2013-07-19','10:50:00',3.65),('14598','2013-07-19','10:55:00',3.75),('14598','2013-07-19','11:00:00',3.85),('14598','2013-07-19','11:05:00',3.91),('14598','2013-07-19','11:10:00',3.98),('14598','2013-07-19','11:15:00',4.04),('14598','2013-07-19','11:20:00',4.1),('14598','2013-07-19','11:25:00',4.13),('14598','2013-07-19','11:30:00',4.19),('14598','2013-07-19','11:35:00',4.25),('14598','2013-07-19','11:40:00',4.3),('14598','2013-07-19','11:45:00',4.36),('14598','2013-07-19','11:50:00',4.38),('14598','2013-07-19','11:55:00',4.43),('14598','2013-07-19','12:00:00',4.48),('14598','2013-07-19','12:05:00',4.39),('14598','2013-07-19','12:10:00',4.51),('14598','2013-07-19','12:15:00',4.58),('14598','2013-07-19','12:20:00',4.69),('14598','2013-07-19','12:25:00',4.78),('14598','2013-07-19','12:30:00',4.54),('14598','2013-07-19','12:35:00',4.66),('14598','2013-07-19','12:40:00',4.58),('14598','2013-07-19','12:45:00',4.25),('14598','2013-07-19','12:50:00',4.39),('14598','2013-07-19','12:55:00',3.49),('14598','2013-07-19','13:00:00',4.89),('14598','2013-07-19','13:05:00',4.31),('14598','2013-07-19','13:10:00',3.59),('14598','2013-07-19','13:15:00',4.4),('14598','2013-07-19','13:20:00',3.98),('14598','2013-07-19','13:25:00',4.66),('14598','2013-07-19','13:30:00',4.94),('14598','2013-07-19','13:35:00',5.06),('14598','2013-07-19','13:40:00',4.97),('14598','2013-07-19','13:45:00',4.92),('14598','2013-07-19','13:50:00',4.86),('14598','2013-07-19','13:55:00',4.91),('14598','2013-07-19','14:00:00',4.9),('14598','2013-07-19','14:05:00',4.9),('14598','2013-07-19','14:10:00',4.9),('14598','2013-07-19','14:15:00',4.91),('14598','2013-07-19','14:20:00',4.97),('14598','2013-07-19','14:25:00',5.12),('14598','2013-07-19','14:30:00',5.09),('14598','2013-07-19','14:35:00',5.06),('14598','2013-07-19','14:40:00',5.08),('14598','2013-07-19','14:45:00',3.96),('14598','2013-07-19','14:50:00',3.26),('14598','2013-07-19','14:55:00',3.45),('14598','2013-07-19','15:00:00',4.93),('14598','2013-07-19','15:05:00',4.87),('14598','2013-07-19','15:10:00',4.72),('14598','2013-07-19','15:15:00',4.67),('14598','2013-07-19','15:20:00',4.62),('14598','2013-07-19','15:25:00',4.57),('14598','2013-07-19','15:30:00',4.53),('14598','2013-07-19','15:35:00',4.46),('14598','2013-07-19','15:40:00',4.39),('14598','2013-07-19','15:45:00',4.39),('14598','2013-07-19','15:50:00',4.32),('14598','2013-07-19','15:55:00',4.29),('14598','2013-07-19','16:00:00',4),('14598','2013-07-19','16:05:00',4.24),('14598','2013-07-19','16:10:00',4.13),('14598','2013-07-19','16:15:00',4.13),('14598','2013-07-19','16:20:00',4.14),('14598','2013-07-19','16:25:00',3.95),('14598','2013-07-19','16:30:00',3.96),('14598','2013-07-19','16:35:00',3.85),('14598','2013-07-19','16:40:00',3.71),('14598','2013-07-19','16:45:00',3.6),('14598','2013-07-19','16:50:00',2.71),('14598','2013-07-19','16:55:00',1.46),('14598','2013-07-19','17:00:00',1.35),('14598','2013-07-19','17:05:00',1.25),('14598','2013-07-19','17:10:00',1.73),('14598','2013-07-19','17:15:00',2.34),('14598','2013-07-19','17:20:00',2.37),('14598','2013-07-19','17:25:00',2.31),('14598','2013-07-19','17:30:00',1.75),('14598','2013-07-19','17:35:00',1.27),('14598','2013-07-19','17:40:00',1.16),('14598','2013-07-19','17:45:00',1.28),('14598','2013-07-19','17:50:00',1.3),('14598','2013-07-18','08:05:00',1.04),('14598','2013-07-18','08:10:00',1.13),('14598','2013-07-18','08:15:00',1.22),('14598','2013-07-18','08:20:00',1.32),('14598','2013-07-18','08:25:00',1.42),('14598','2013-07-18','08:30:00',1.48),('14598','2013-07-18','08:35:00',1.59),('14598','2013-07-18','08:40:00',1.69),('14598','2013-07-18','08:45:00',1.79),('14598','2013-07-18','08:50:00',1.89),('14598','2013-07-18','08:55:00',2),('14598','2013-07-18','09:00:00',2.11),('14598','2013-07-18','09:05:00',2.21),('14598','2013-07-18','09:10:00',2.3),('14598','2013-07-18','09:15:00',2.38),('14598','2013-07-18','09:20:00',2.46),('14598','2013-07-18','09:25:00',2.54),('14598','2013-07-18','09:30:00',2.64),('14598','2013-07-18','09:35:00',2.73),('14598','2013-07-18','09:40:00',2.8),('14598','2013-07-18','09:45:00',2.87),('14598','2013-07-18','09:50:00',2.92),('14598','2013-07-18','09:55:00',3.03),('14598','2013-07-18','10:00:00',3.09),('14598','2013-07-18','10:05:00',3.16),('14598','2013-07-18','10:10:00',3.22),('14598','2013-07-18','10:15:00',3.19),('14598','2013-07-18','10:20:00',3.33),('14598','2013-07-18','10:25:00',3.39),('14598','2013-07-18','10:30:00',3.46),('14598','2013-07-18','10:35:00',3.53),('14598','2013-07-18','10:40:00',3.56),('14598','2013-07-18','10:45:00',3.63),('14598','2013-07-18','10:50:00',3.75),('14598','2013-07-18','10:55:00',3.83),('14598','2013-07-18','11:00:00',3.9),('14598','2013-07-18','11:05:00',3.94),('14598','2013-07-18','11:10:00',4.02),('14598','2013-07-18','11:15:00',4.07),('14598','2013-07-18','11:20:00',4.13),('14598','2013-07-18','11:25:00',4.19),('14598','2013-07-18','11:30:00',4.24),('14598','2013-07-18','11:35:00',4.29),('14598','2013-07-18','11:40:00',4.34),('14598','2013-07-18','11:45:00',4.41),('14598','2013-07-18','11:50:00',4.44),('14598','2013-07-18','11:55:00',4.46),('14598','2013-07-18','12:00:00',4.5),('14598','2013-07-18','12:05:00',4.55),('14598','2013-07-18','12:10:00',4.6),('14598','2013-07-18','12:15:00',4.64),('14598','2013-07-18','12:20:00',4.69),('14598','2013-07-18','12:25:00',4.71),('14598','2013-07-18','12:30:00',4.74),('14598','2013-07-18','12:35:00',4.75),('14598','2013-07-18','12:40:00',4.79),('14598','2013-07-18','12:45:00',4.82),('14598','2013-07-18','12:50:00',4.79),('14598','2013-07-18','12:55:00',4.84),('14598','2013-07-18','13:00:00',4.86),('14598','2013-07-18','13:05:00',4.87),('14598','2013-07-18','13:10:00',4.89),('14598','2013-07-18','13:15:00',4.91),('14598','2013-07-18','13:20:00',4.92),('14598','2013-07-18','13:25:00',4.94),('14598','2013-07-18','13:30:00',4.94),('14598','2013-07-18','13:35:00',4.95),('14598','2013-07-18','13:40:00',4.95),('14598','2013-07-18','13:45:00',4.95),('14598','2013-07-18','13:50:00',4.95),('14598','2013-07-18','13:55:00',4.95),('14598','2013-07-18','14:00:00',4.92),('14598','2013-07-18','14:05:00',4.88),('14598','2013-07-18','14:10:00',4.88),('14598','2013-07-18','14:15:00',4.87),('14598','2013-07-18','14:20:00',4.86),('14598','2013-07-18','14:25:00',4.84),('14598','2013-07-18','14:30:00',4.84),('14598','2013-07-18','14:35:00',4.75),('14598','2013-07-18','14:40:00',4.77),('14598','2013-07-18','14:45:00',4.75),('14598','2013-07-18','14:50:00',4.72),('14598','2013-07-18','14:55:00',4.67),('14598','2013-07-18','15:00:00',4.65),('14598','2013-07-18','15:05:00',4.64),('14598','2013-07-18','15:10:00',4.63),('14598','2013-07-18','15:15:00',4.6),('14598','2013-07-18','15:20:00',4.57),('14598','2013-07-18','15:25:00',4.55),('14598','2013-07-18','15:30:00',4.51),('14598','2013-07-18','15:35:00',4.44),('14598','2013-07-18','15:40:00',4.39),('14598','2013-07-18','15:45:00',4.34),('14598','2013-07-18','15:50:00',4.28),('14598','2013-07-18','15:55:00',4.26),('14598','2013-07-18','16:00:00',4.23),('14598','2013-07-18','16:05:00',4.15),('14598','2013-07-18','16:10:00',4.08),('14598','2013-07-18','16:15:00',4.05),('14598','2013-07-18','16:20:00',3.96),('14598','2013-07-18','16:25:00',3.89),('14598','2013-07-18','16:30:00',3.83),('14598','2013-07-18','16:35:00',3.75),('14598','2013-07-18','16:40:00',3.67),('14598','2013-07-18','16:45:00',3.62),('14598','2013-07-18','16:50:00',3.57),('14598','2013-07-18','16:55:00',3.48),('14598','2013-07-18','17:00:00',3.41),('14598','2013-07-18','17:05:00',3.48),('14598','2013-07-18','17:10:00',3.5),('14598','2013-07-18','17:15:00',3.35),('14598','2013-07-18','17:20:00',3.35),('14598','2013-07-18','17:25:00',3.1),('14598','2013-07-18','17:30:00',2.98),('14598','2013-07-18','17:35:00',2.85),('14598','2013-07-18','17:40:00',2.76),('14598','2013-07-18','17:45:00',2.66),('14598','2013-07-18','17:50:00',2.56),('14598','2013-07-18','17:55:00',2.49),('14598','2013-07-18','18:00:00',2.4),('14598','2013-07-18','18:05:00',2.32),('14598','2013-07-18','18:10:00',2.23),('14598','2013-07-18','18:15:00',2.15),('14598','2013-07-18','18:20:00',2.03),('14598','2013-07-18','18:25:00',1.94),('14598','2013-07-18','18:30:00',1.83),('14598','2013-07-18','18:35:00',1.77),('14598','2013-07-18','18:40:00',1.65),('14598','2013-07-18','18:45:00',1.58),('14598','2013-07-18','18:50:00',1.47),('14598','2013-07-18','18:55:00',1.36),('14598','2013-07-18','19:00:00',1.27),('14598','2013-07-18','19:05:00',1.17),('14598','2013-07-18','19:10:00',1.06),('14598','2013-07-17','08:05:00',1.06),('14598','2013-07-17','08:10:00',1.14),('14598','2013-07-17','08:15:00',1.23),('14598','2013-07-17','08:20:00',1.33),('14598','2013-07-17','08:25:00',1.43),('14598','2013-07-17','08:30:00',1.53),('14598','2013-07-17','08:35:00',1.6),('14598','2013-07-17','08:40:00',1.69),('14598','2013-07-17','08:45:00',1.79),('14598','2013-07-17','08:50:00',1.9),('14598','2013-07-17','08:55:00',2.01),('14598','2013-07-17','09:00:00',2.08),('14598','2013-07-17','09:05:00',2.22),('14598','2013-07-17','09:10:00',2.31),('14598','2013-07-17','09:15:00',2.39),('14598','2013-07-17','09:20:00',2.47),('14598','2013-07-17','09:25:00',2.56),('14598','2013-07-17','09:30:00',2.64),('14598','2013-07-17','09:35:00',2.72),('14598','2013-07-17','09:40:00',2.8),('14598','2013-07-17','09:45:00',2.89),('14598','2013-07-17','09:50:00',2.95),('14598','2013-07-17','09:55:00',3.02),('14598','2013-07-17','10:00:00',3.1),('14598','2013-07-17','10:05:00',3.16),('14598','2013-07-17','10:10:00',3.23),('14598','2013-07-17','10:15:00',3.32),('14598','2013-07-17','10:20:00',3.35),('14598','2013-07-17','10:25:00',3.44),('14598','2013-07-17','10:30:00',3.49),('14598','2013-07-17','10:35:00',3.57),('14598','2013-07-17','10:40:00',3.64),('14598','2013-07-17','10:45:00',3.72),('14598','2013-07-17','10:50:00',3.78),('14598','2013-07-17','10:55:00',3.83),('14598','2013-07-17','11:00:00',3.91),('14598','2013-07-17','11:05:00',3.94),('14598','2013-07-17','11:10:00',4.02),('14598','2013-07-17','11:15:00',4.05),('14598','2013-07-17','11:20:00',4.06),('14598','2013-07-17','11:25:00',4.11),('14598','2013-07-17','11:30:00',4.21),('14598','2013-07-17','11:35:00',4.24),('14598','2013-07-17','11:40:00',4.28),('14598','2013-07-17','11:45:00',4.33),('14598','2013-07-17','11:50:00',4.36),('14598','2013-07-17','11:55:00',4.42),('14598','2013-07-17','12:00:00',4.44),('14598','2013-07-17','12:05:00',4.38),('14598','2013-07-17','12:10:00',4.47),('14598','2013-07-17','12:15:00',4.5),('14598','2013-07-17','12:20:00',4.54),('14598','2013-07-17','12:25:00',4.56),('14598','2013-07-17','12:30:00',4.55),('14598','2013-07-17','12:35:00',4.57),('14598','2013-07-17','12:40:00',4.61),('14598','2013-07-17','12:45:00',4.63),('14598','2013-07-17','12:50:00',4.67),('14598','2013-07-17','12:55:00',4.7),('14598','2013-07-17','13:00:00',4.71),('14598','2013-07-17','13:05:00',4.75),('14598','2013-07-17','13:10:00',4.86),('14598','2013-07-17','13:15:00',4.92),('14598','2013-07-17','13:20:00',4.9),('14598','2013-07-17','13:25:00',4.93),('14598','2013-07-17','13:30:00',4.97),('14598','2013-07-17','13:35:00',4.98),('14598','2013-07-17','13:40:00',4.99),('14598','2013-07-17','13:45:00',4.97),('14598','2013-07-17','13:50:00',4.97),('14598','2013-07-17','13:55:00',5),('14598','2013-07-17','14:00:00',5.02),('14598','2013-07-17','14:05:00',5.03),('14598','2013-07-17','14:10:00',4.97),('14598','2013-07-17','14:15:00',4.96),('14598','2013-07-17','14:20:00',4.94),('14598','2013-07-17','14:25:00',4.95),('14598','2013-07-17','14:30:00',4.92),('14598','2013-07-17','14:35:00',4.91),('14598','2013-07-17','14:40:00',4.9),('14598','2013-07-17','14:45:00',4.87),('14598','2013-07-17','14:50:00',4.88),('14598','2013-07-17','14:55:00',4.86),('14598','2013-07-17','15:00:00',4.8),('14598','2013-07-17','15:05:00',4.67),('14598','2013-07-17','15:10:00',4.75),('14598','2013-07-17','15:15:00',4.74),('14598','2013-07-17','15:20:00',4.72),('14598','2013-07-17','15:25:00',4.69),('14598','2013-07-17','15:30:00',4.62),('14598','2013-07-17','15:35:00',4.57),('14598','2013-07-17','15:40:00',4.53),('14598','2013-07-17','15:45:00',4.49),('14598','2013-07-17','15:50:00',4.46),('14598','2013-07-17','15:55:00',4.4),('14598','2013-07-17','16:00:00',4.34),('14598','2013-07-17','16:05:00',4.28),('14598','2013-07-17','16:10:00',4.24),('14598','2013-07-17','16:15:00',4.14),('14598','2013-07-17','16:20:00',4.09),('14598','2013-07-17','16:25:00',4.07),('14598','2013-07-17','16:30:00',4.03),('14598','2013-07-17','16:35:00',3.97),('14598','2013-07-17','16:40:00',3.89),('14598','2013-07-17','16:45:00',3.82),('14598','2013-07-17','16:50:00',3.74),('14598','2013-07-17','16:55:00',3.68),('14598','2013-07-17','17:00:00',3.6),('14598','2013-07-17','17:05:00',3.52),('14598','2013-07-17','17:10:00',3.44),('14598','2013-07-17','17:15:00',3.38),('14598','2013-07-17','17:20:00',3.3),('14598','2013-07-17','17:25:00',3.2),('14598','2013-07-17','17:30:00',3.12),('14598','2013-07-17','17:35:00',3.04),('14598','2013-07-17','17:40:00',2.94),('14598','2013-07-17','17:45:00',2.84),('14598','2013-07-17','17:50:00',2.77),('14598','2013-07-17','17:55:00',2.68),('14598','2013-07-17','18:00:00',2.58),('14598','2013-07-17','18:05:00',2.46),('14598','2013-07-17','18:10:00',2.37),('14598','2013-07-17','18:15:00',2.26),('14598','2013-07-17','18:20:00',2.18),('14598','2013-07-17','18:25:00',2.07),('14598','2013-07-17','18:30:00',1.96),('14598','2013-07-17','18:35:00',1.87),('14598','2013-07-17','18:40:00',1.76),('14598','2013-07-17','18:45:00',1.66),('14598','2013-07-17','18:50:00',1.56),('14598','2013-07-17','18:55:00',1.45),('14598','2013-07-17','19:00:00',1.35),('14598','2013-07-17','19:05:00',1.24),('14598','2013-07-17','19:10:00',1.14),('14598','2013-07-17','19:15:00',1.04),('14598','2013-07-16','08:00:00',1.01),('14598','2013-07-16','08:05:00',1.09),('14598','2013-07-16','08:10:00',1.17),('14598','2013-07-16','08:15:00',1.24),('14598','2013-07-16','08:20:00',1.33),('14598','2013-07-16','08:25:00',1.43),('14598','2013-07-16','08:30:00',1.5),('14598','2013-07-16','08:35:00',1.6),('14598','2013-07-16','08:40:00',1.68),('14598','2013-07-16','08:45:00',1.78),('14598','2013-07-16','08:50:00',1.9),('14598','2013-07-16','08:55:00',2.02),('14598','2013-07-16','09:00:00',2.12),('14598','2013-07-16','09:05:00',2.21),('14598','2013-07-16','09:10:00',2.3),('14598','2013-07-16','09:15:00',2.38),('14598','2013-07-16','09:20:00',2.49),('14598','2013-07-16','09:25:00',2.58),('14598','2013-07-16','09:30:00',2.65),('14598','2013-07-16','09:35:00',2.74),('14598','2013-07-16','09:40:00',2.81),('14598','2013-07-16','09:45:00',2.9),('14598','2013-07-16','09:50:00',2.95),('14598','2013-07-16','09:55:00',3.05),('14598','2013-07-16','10:00:00',3.11),('14598','2013-07-16','10:05:00',3.17),('14598','2013-07-16','10:10:00',3.23),('14598','2013-07-16','10:15:00',3.29),('14598','2013-07-16','10:20:00',3.37),('14598','2013-07-16','10:25:00',3.44),('14598','2013-07-16','10:30:00',3.49),('14598','2013-07-16','10:35:00',3.56),('14598','2013-07-16','10:40:00',3.62),('14598','2013-07-16','10:45:00',3.7),('14598','2013-07-16','10:50:00',3.76),('14598','2013-07-16','10:55:00',3.79),('14598','2013-07-16','11:00:00',3.86),('14598','2013-07-16','11:05:00',3.91),('14598','2013-07-16','11:10:00',3.95),('14598','2013-07-16','11:15:00',4),('14598','2013-07-16','11:20:00',4.03),('14598','2013-07-16','11:25:00',4.1),('14598','2013-07-16','11:30:00',4.16),('14598','2013-07-16','11:35:00',4.17),('14598','2013-07-16','11:40:00',4.21),('14598','2013-07-16','11:45:00',4.25),('14598','2013-07-16','11:50:00',4.33),('14598','2013-07-16','11:55:00',4.36),('14598','2013-07-16','12:00:00',4.4),('14598','2013-07-16','12:05:00',4.41),('14598','2013-07-16','12:10:00',4.46),('14598','2013-07-16','12:15:00',4.5),('14598','2013-07-16','12:20:00',4.53),('14598','2013-07-16','12:25:00',4.57),('14598','2013-07-16','12:30:00',4.59),('14598','2013-07-16','12:35:00',4.62),('14598','2013-07-16','12:40:00',4.61),('14598','2013-07-16','12:45:00',4.69),('14598','2013-07-16','12:50:00',4.65),('14598','2013-07-16','12:55:00',4.71),('14598','2013-07-16','13:00:00',4.75),('14598','2013-07-16','13:05:00',4.77),('14598','2013-07-16','13:10:00',4.77),('14598','2013-07-16','13:15:00',4.82),('14598','2013-07-16','13:20:00',4.82),('14598','2013-07-16','13:25:00',4.79),('14598','2013-07-16','13:30:00',4.81),('14598','2013-07-16','13:35:00',4.8),('14598','2013-07-16','13:40:00',4.76),('14598','2013-07-16','13:45:00',4.74),('14598','2013-07-16','13:50:00',4.77),('14598','2013-07-16','13:55:00',4.77),('14598','2013-07-16','14:00:00',4.79),('14598','2013-07-16','14:05:00',4.81),('14598','2013-07-16','14:10:00',4.8),('14598','2013-07-16','14:15:00',4.8),('14598','2013-07-16','14:20:00',4.74),('14598','2013-07-16','14:25:00',4.75),('14598','2013-07-16','14:30:00',4.73),('14598','2013-07-16','14:35:00',4.65),('14598','2013-07-16','14:40:00',4.67),('14598','2013-07-16','14:45:00',4.7),('14598','2013-07-16','14:50:00',4.74),('14598','2013-07-16','14:55:00',4.72),('14598','2013-07-16','15:00:00',4.73),('14598','2013-07-16','15:05:00',4.74),('14598','2013-07-16','15:10:00',4.69),('14598','2013-07-16','15:15:00',4.68),('14598','2013-07-16','15:20:00',4.63),('14598','2013-07-16','15:25:00',4.55),('14598','2013-07-16','15:30:00',4.56),('14598','2013-07-16','15:35:00',4.47),('14598','2013-07-16','15:40:00',4.43),('14598','2013-07-16','15:45:00',4.44),('14598','2013-07-16','15:50:00',4.4),('14598','2013-07-16','15:55:00',4.35),('14598','2013-07-16','16:00:00',4.27),('14598','2013-07-16','16:05:00',4.24),('14598','2013-07-16','16:10:00',4.19),('14598','2013-07-16','16:15:00',4.16),('14598','2013-07-16','16:20:00',4.1),('14598','2013-07-16','16:25:00',4.03),('14598','2013-07-16','16:30:00',3.97),('14598','2013-07-16','16:35:00',3.93),('14598','2013-07-16','16:40:00',3.84),('14598','2013-07-16','16:45:00',3.77),('14598','2013-07-16','16:50:00',3.71),('14598','2013-07-16','16:55:00',3.65),('14598','2013-07-16','17:00:00',3.57),('14598','2013-07-16','17:05:00',3.45),('14598','2013-07-16','17:10:00',3.36),('14598','2013-07-16','17:15:00',3.27),('14598','2013-07-16','17:20:00',3.24),('14598','2013-07-16','17:25:00',3.14),('14598','2013-07-16','17:30:00',3.08),('14598','2013-07-16','17:35:00',2.91),('14598','2013-07-16','17:40:00',2.87),('14598','2013-07-16','17:45:00',2.71),('14598','2013-07-16','17:50:00',2.69),('14598','2013-07-16','17:55:00',2.63),('14598','2013-07-16','18:00:00',2.51),('14598','2013-07-16','18:05:00',2.43),('14598','2013-07-16','18:10:00',2.35),('14598','2013-07-16','18:15:00',2.26),('14598','2013-07-16','18:20:00',2.16),('14598','2013-07-16','18:25:00',2.06),('14598','2013-07-16','18:30:00',1.93),('14598','2013-07-16','18:35:00',1.82),('14598','2013-07-16','18:40:00',1.71),('14598','2013-07-16','18:45:00',1.61),('14598','2013-07-16','18:50:00',1.5),('14598','2013-07-16','18:55:00',1.41),('14598','2013-07-16','19:00:00',1.3),('14598','2013-07-16','19:05:00',1.18),('14598','2013-07-16','19:10:00',1.04),('14598','2013-07-15','08:00:00',1.02),('14598','2013-07-15','08:05:00',1.11),('14598','2013-07-15','08:10:00',1.2),('14598','2013-07-15','08:15:00',1.28),('14598','2013-07-15','08:20:00',1.38),('14598','2013-07-15','08:25:00',1.49),('14598','2013-07-15','08:30:00',1.58),('14598','2013-07-15','08:35:00',1.67),('14598','2013-07-15','08:40:00',1.76),('14598','2013-07-15','08:45:00',1.85),('14598','2013-07-15','08:50:00',1.96),('14598','2013-07-15','08:55:00',2.08),('14598','2013-07-15','09:00:00',2.19),('14598','2013-07-15','09:05:00',2.27),('14598','2013-07-15','09:10:00',2.36),('14598','2013-07-15','09:15:00',2.45),('14598','2013-07-15','09:20:00',2.55),('14598','2013-07-15','09:25:00',2.63),('14598','2013-07-15','09:30:00',2.72),('14598','2013-07-15','09:35:00',2.8),('14598','2013-07-15','09:40:00',2.89),('14598','2013-07-15','09:45:00',2.97),('14598','2013-07-15','09:50:00',3.04),('14598','2013-07-15','09:55:00',3.12),('14598','2013-07-15','10:00:00',3.2),('14598','2013-07-15','10:05:00',3.28),('14598','2013-07-15','10:10:00',3.35),('14598','2013-07-15','10:15:00',3.41),('14598','2013-07-15','10:20:00',3.47),('14598','2013-07-15','10:25:00',3.55),('14598','2013-07-15','10:30:00',3.59),('14598','2013-07-15','10:35:00',3.69),('14598','2013-07-15','10:40:00',3.75),('14598','2013-07-15','10:45:00',3.79),('14598','2013-07-15','10:50:00',3.79),('14598','2013-07-15','10:55:00',3.87),('14598','2013-07-15','11:00:00',3.93),('14598','2013-07-15','11:05:00',3.96),('14598','2013-07-15','11:10:00',4.01),('14598','2013-07-15','11:15:00',4.07),('14598','2013-07-15','11:20:00',4.15),('14598','2013-07-15','11:25:00',4.18),('14598','2013-07-15','11:30:00',4.22),('14598','2013-07-15','11:35:00',4.28),('14598','2013-07-15','11:40:00',4.29),('14598','2013-07-15','11:45:00',4.33),('14598','2013-07-15','11:50:00',4.34),('14598','2013-07-15','11:55:00',4.39),('14598','2013-07-15','12:00:00',4.46),('14598','2013-07-15','12:05:00',4.48),('14598','2013-07-15','12:10:00',4.52),('14598','2013-07-15','12:15:00',4.53),('14598','2013-07-15','12:20:00',4.54),('14598','2013-07-15','12:25:00',4.56),('14598','2013-07-15','12:30:00',4.59),('14598','2013-07-15','12:35:00',4.63),('14598','2013-07-15','12:40:00',4.61),('14598','2013-07-15','12:45:00',4.63),('14598','2013-07-15','12:50:00',4.63),('14598','2013-07-15','12:55:00',4.66),('14598','2013-07-15','13:00:00',4.63),('14598','2013-07-15','13:05:00',4.63),('14598','2013-07-15','13:10:00',4.73),('14598','2013-07-15','13:15:00',4.86),('14598','2013-07-15','13:20:00',4.97),('14598','2013-07-15','13:25:00',4.98),('14598','2013-07-15','13:30:00',5.02),('14598','2013-07-15','13:35:00',5),('14598','2013-07-15','13:40:00',4.99),('14598','2013-07-15','13:45:00',4.97),('14598','2013-07-15','13:50:00',5.01),('14598','2013-07-15','13:55:00',5.06),('14598','2013-07-15','14:00:00',5.05),('14598','2013-07-15','14:05:00',5.02),('14598','2013-07-15','14:10:00',4.99),('14598','2013-07-15','14:15:00',4.97),('14598','2013-07-15','14:20:00',4.98),('14598','2013-07-15','14:25:00',4.95),('14598','2013-07-15','14:30:00',4.95),('14598','2013-07-15','14:35:00',4.93),('14598','2013-07-15','14:40:00',4.87),('14598','2013-07-15','14:45:00',4.85),('14598','2013-07-15','14:50:00',4.85),('14598','2013-07-15','14:55:00',4.88),('14598','2013-07-15','15:00:00',4.86),('14598','2013-07-15','15:05:00',4.82),('14598','2013-07-15','15:10:00',4.77),('14598','2013-07-15','15:15:00',4.76),('14598','2013-07-15','15:20:00',4.75),('14598','2013-07-15','15:25:00',4.71),('14598','2013-07-15','15:30:00',4.68),('14598','2013-07-15','15:35:00',4.64),('14598','2013-07-15','15:40:00',4.58),('14598','2013-07-15','15:45:00',4.5),('14598','2013-07-15','15:50:00',4.47),('14598','2013-07-15','15:55:00',4.43),('14598','2013-07-15','16:00:00',4.36),('14598','2013-07-15','16:05:00',4.34),('14598','2013-07-15','16:10:00',4.27),('14598','2013-07-15','16:15:00',4.21),('14598','2013-07-15','16:20:00',4.13),('14598','2013-07-15','16:25:00',4.07),('14598','2013-07-15','16:30:00',3.99),('14598','2013-07-15','16:35:00',3.93),('14598','2013-07-15','16:40:00',3.91),('14598','2013-07-15','16:45:00',3.82),('14598','2013-07-15','16:50:00',3.75),('14598','2013-07-15','16:55:00',3.64),('14598','2013-07-15','17:00:00',3.53),('14598','2013-07-15','17:05:00',3.44),('14598','2013-07-15','17:10:00',3.39),('14598','2013-07-15','17:15:00',3.32),('14598','2013-07-15','17:20:00',3.23),('14598','2013-07-15','17:25:00',3.14),('14598','2013-07-15','17:30:00',3.06),('14598','2013-07-15','17:35:00',2.98),('14598','2013-07-15','17:40:00',2.9),('14598','2013-07-15','17:45:00',2.8),('14598','2013-07-15','17:50:00',2.71),('14598','2013-07-15','17:55:00',2.61),('14598','2013-07-15','18:00:00',2.48),('14598','2013-07-15','18:05:00',2.41),('14598','2013-07-15','18:10:00',2.31),('14598','2013-07-15','18:15:00',2.21),('14598','2013-07-15','18:20:00',2.09),('14598','2013-07-15','18:25:00',2.01),('14598','2013-07-15','18:30:00',1.89),('14598','2013-07-15','18:35:00',1.76),('14598','2013-07-15','18:40:00',1.66),('14598','2013-07-15','18:45:00',1.55),('14598','2013-07-15','18:50:00',1.48),('14598','2013-07-15','18:55:00',1.38),('14598','2013-07-15','19:00:00',1.29),('14598','2013-07-15','19:05:00',1.19),('14598','2013-07-15','19:10:00',1.09),('14598','2013-07-14','08:00:00',1.19),('14598','2013-07-14','08:05:00',1.27),('14598','2013-07-14','08:10:00',1.46),('14598','2013-07-14','08:15:00',1.26),('14598','2013-07-14','08:20:00',1.36),('14598','2013-07-14','08:25:00',1.19),('14598','2013-07-14','08:30:00',1.73),('14598','2013-07-14','08:35:00',1.71),('14598','2013-07-14','08:40:00',1.52),('14598','2013-07-14','08:45:00',1.38),('14598','2013-07-14','08:50:00',2.03),('14598','2013-07-14','08:55:00',2.7),('14598','2013-07-14','09:00:00',2.07),('14598','2013-07-14','09:05:00',2.19),('14598','2013-07-14','09:10:00',2.38),('14598','2013-07-14','09:15:00',2.52),('14598','2013-07-14','09:20:00',2),('14598','2013-07-14','09:25:00',2.1),('14598','2013-07-14','09:30:00',1.75),('14598','2013-07-14','09:35:00',1.63),('14598','2013-07-14','09:40:00',1.38),('14598','2013-07-14','09:45:00',1.34),('14598','2013-07-14','09:50:00',1.55),('14598','2013-07-14','09:55:00',1.6),('14598','2013-07-14','10:00:00',2.17),('14598','2013-07-14','10:05:00',3.12),('14598','2013-07-14','10:10:00',3),('14598','2013-07-14','10:15:00',3.78),('14598','2013-07-14','10:20:00',3.75),('14598','2013-07-14','10:25:00',3.85),('14598','2013-07-14','10:30:00',4.01),('14598','2013-07-14','10:35:00',4.39),('14598','2013-07-14','10:40:00',3.19),('14598','2013-07-14','10:45:00',2.83),('14598','2013-07-14','10:50:00',2.72),('14598','2013-07-14','10:55:00',2.6),('14598','2013-07-14','11:00:00',2.63),('14598','2013-07-14','11:05:00',3.45),('14598','2013-07-14','11:10:00',2.37),('14598','2013-07-14','11:15:00',4.24),('14598','2013-07-14','11:20:00',4.24),('14598','2013-07-14','11:25:00',4.26),('14598','2013-07-14','11:30:00',4.29),('14598','2013-07-14','11:35:00',4.3),('14598','2013-07-14','11:40:00',4.35),('14598','2013-07-14','11:45:00',4.36),('14598','2013-07-14','11:50:00',4.24),('14598','2013-07-14','11:55:00',4.46),('14598','2013-07-14','12:00:00',3.98),('14598','2013-07-14','12:05:00',4.65),('14598','2013-07-14','12:10:00',4.58),('14598','2013-07-14','12:15:00',4.58),('14598','2013-07-14','12:20:00',4.66),('14598','2013-07-14','12:25:00',4.69),('14598','2013-07-14','12:30:00',4.72),('14598','2013-07-14','12:35:00',4.77),('14598','2013-07-14','12:40:00',4.79),('14598','2013-07-14','12:45:00',4.83),('14598','2013-07-14','12:50:00',4.86),('14598','2013-07-14','12:55:00',4.85),('14598','2013-07-14','13:00:00',4.88),('14598','2013-07-14','13:05:00',4.93),('14598','2013-07-14','13:10:00',4.95),('14598','2013-07-14','13:15:00',4.99),('14598','2013-07-14','13:20:00',5.02),('14598','2013-07-14','13:25:00',5.03),('14598','2013-07-14','13:30:00',5.04),('14598','2013-07-14','13:35:00',5.03),('14598','2013-07-14','13:40:00',5.05),('14598','2013-07-14','13:45:00',5.07),('14598','2013-07-14','13:50:00',5.08),('14598','2013-07-14','13:55:00',5.08),('14598','2013-07-14','14:00:00',5.09),('14598','2013-07-14','14:05:00',5.04),('14598','2013-07-14','14:10:00',5.03),('14598','2013-07-14','14:15:00',5.03),('14598','2013-07-14','14:20:00',5.03),('14598','2013-07-14','14:25:00',5),('14598','2013-07-14','14:30:00',4.99),('14598','2013-07-14','14:35:00',4.99),('14598','2013-07-14','14:40:00',4.94),('14598','2013-07-14','14:45:00',4.92),('14598','2013-07-14','14:50:00',4.86),('14598','2013-07-14','14:55:00',4.81),('14598','2013-07-14','15:00:00',4.82),('14598','2013-07-14','15:05:00',4.8),('14598','2013-07-14','15:10:00',4.67),('14598','2013-07-14','15:15:00',4.69),('14598','2013-07-14','15:20:00',4.68),('14598','2013-07-14','15:25:00',4.62),('14598','2013-07-14','15:30:00',4.58),('14598','2013-07-14','15:35:00',4.59),('14598','2013-07-14','15:40:00',4.55),('14598','2013-07-14','15:45:00',4.53),('14598','2013-07-14','15:50:00',4.48),('14598','2013-07-14','15:55:00',4.42),('14598','2013-07-14','16:00:00',4.26),('14598','2013-07-14','16:05:00',4.38),('14598','2013-07-14','16:10:00',4.34),('14598','2013-07-14','16:15:00',3.95),('14598','2013-07-14','16:20:00',3.94),('14598','2013-07-14','16:25:00',4.14),('14598','2013-07-14','16:30:00',3.71),('14598','2013-07-14','16:35:00',3.54),('14598','2013-07-14','16:40:00',3.91),('14598','2013-07-14','16:45:00',3.56),('14598','2013-07-14','16:50:00',3.74),('14598','2013-07-14','16:55:00',3.62),('14598','2013-07-14','17:00:00',3.51),('14598','2013-07-14','17:05:00',3.56),('14598','2013-07-14','17:10:00',3.15),('14598','2013-07-14','17:15:00',3.17),('14598','2013-07-14','17:20:00',3.25),('14598','2013-07-14','17:25:00',2.08),('14598','2013-07-14','17:30:00',3.35),('14598','2013-07-14','17:35:00',1.73),('14598','2013-07-14','17:40:00',1.84),('14598','2013-07-14','17:45:00',1.37),('14598','2013-07-14','17:50:00',1.84),('14598','2013-07-14','17:55:00',2.76),('14598','2013-07-14','18:00:00',1.95),('14598','2013-07-14','18:45:00',1.55),('14598','2013-07-14','18:50:00',1.84),('14598','2013-07-14','18:55:00',1.6),('14598','2013-07-14','19:00:00',1.34),('14598','2013-07-14','19:05:00',1.15),('14598','2013-07-14','19:10:00',1.03),('14598','2013-07-13','08:05:00',1.08),('14598','2013-07-13','08:10:00',1.14),('14598','2013-07-13','08:15:00',1.23),('14598','2013-07-13','08:20:00',1.33),('14598','2013-07-13','08:25:00',1.44),('14598','2013-07-13','08:30:00',1.53),('14598','2013-07-13','08:35:00',1.61),('14598','2013-07-13','08:40:00',1.68),('14598','2013-07-13','08:45:00',1.79),('14598','2013-07-13','08:50:00',1.89),('14598','2013-07-13','08:55:00',1.99),('14598','2013-07-13','09:00:00',2.12),('14598','2013-07-13','09:05:00',2.2),('14598','2013-07-13','09:10:00',2.29),('14598','2013-07-13','09:15:00',2.34),('14598','2013-07-13','09:20:00',2.48),('14598','2013-07-13','09:25:00',2.51),('14598','2013-07-13','09:30:00',2.47),('14598','2013-07-13','09:35:00',2.68),('14598','2013-07-13','09:40:00',2.85),('14598','2013-07-13','09:45:00',2.89),('14598','2013-07-13','09:50:00',3.04),('14598','2013-07-13','09:55:00',3.14),('14598','2013-07-13','10:00:00',3.11),('14598','2013-07-13','10:05:00',3.2),('14598','2013-07-13','10:10:00',3.28),('14598','2013-07-13','10:15:00',3.33),('14598','2013-07-13','10:20:00',3.45),('14598','2013-07-13','10:25:00',3.47),('14598','2013-07-13','10:30:00',3.57),('14598','2013-07-13','10:35:00',3.67),('14598','2013-07-13','10:40:00',3.72),('14598','2013-07-13','10:45:00',3.77),('14598','2013-07-13','10:50:00',3.87),('14598','2013-07-13','10:55:00',3.92),('14598','2013-07-13','11:00:00',3.97),('14598','2013-07-13','11:05:00',4.03),('14598','2013-07-13','11:10:00',4.09),('14598','2013-07-13','11:15:00',4.15),('14598','2013-07-13','11:20:00',4.07),('14598','2013-07-13','11:25:00',4.23),('14598','2013-07-13','11:30:00',4.25),('14598','2013-07-13','11:35:00',4.36),('14598','2013-07-13','11:40:00',4.41),('14598','2013-07-13','11:45:00',4.43),('14598','2013-07-13','11:50:00',4.49),('14598','2013-07-13','11:55:00',4.53),('14598','2013-07-13','12:00:00',4.57),('14598','2013-07-13','12:05:00',4.65),('14598','2013-07-13','12:10:00',4.7),('14598','2013-07-13','12:15:00',4.73),('14598','2013-07-13','12:20:00',4.75),('14598','2013-07-13','12:25:00',4.78),('14598','2013-07-13','12:30:00',4.81),('14598','2013-07-13','12:35:00',4.83),('14598','2013-07-13','12:40:00',4.87),('14598','2013-07-13','12:45:00',4.92),('14598','2013-07-13','12:50:00',4.91),('14598','2013-07-13','12:55:00',4.96),('14598','2013-07-13','13:00:00',4.95),('14598','2013-07-13','13:05:00',5),('14598','2013-07-13','13:10:00',5),('14598','2013-07-13','13:15:00',5.02),('14598','2013-07-13','13:20:00',5.07),('14598','2013-07-13','13:25:00',5.07),('14598','2013-07-13','13:30:00',5.07),('14598','2013-07-13','13:35:00',5.06),('14598','2013-07-13','13:40:00',4.54),('14598','2013-07-13','13:45:00',5.04),('14598','2013-07-13','13:50:00',5.07),('14598','2013-07-13','13:55:00',5.06),('14598','2013-07-13','14:00:00',5.05),('14598','2013-07-13','14:05:00',5.07),('14598','2013-07-13','14:10:00',5.04),('14598','2013-07-13','14:15:00',4.99),('14598','2013-07-13','14:20:00',4.97),('14598','2013-07-13','14:25:00',5.03),('14598','2013-07-13','14:30:00',5.01),('14598','2013-07-13','14:35:00',5.03),('14598','2013-07-13','14:40:00',5.01),('14598','2013-07-13','14:45:00',5),('14598','2013-07-13','14:50:00',4.99),('14598','2013-07-13','14:55:00',4.78),('14598','2013-07-13','15:00:00',4.64),('14598','2013-07-13','15:05:00',4.88),('14598','2013-07-13','15:10:00',3.45),('14598','2013-07-13','15:15:00',4.28),('14598','2013-07-13','15:20:00',4.5),('14598','2013-07-13','15:25:00',4.06),('14598','2013-07-13','15:30:00',4.83),('14598','2013-07-13','15:35:00',4.71),('14598','2013-07-13','15:40:00',4.67),('14598','2013-07-13','15:45:00',4.48),('14598','2013-07-13','15:50:00',4.56),('14598','2013-07-13','15:55:00',4.52),('14598','2013-07-13','16:00:00',4.45),('14598','2013-07-13','16:05:00',4.38),('14598','2013-07-13','16:10:00',4.29),('14598','2013-07-13','16:15:00',4.29),('14598','2013-07-13','16:20:00',4.19),('14598','2013-07-13','16:25:00',4.13),('14598','2013-07-13','16:30:00',4.08),('14598','2013-07-13','16:35:00',4.03),('14598','2013-07-13','16:40:00',3.95),('14598','2013-07-13','16:45:00',3.9),('14598','2013-07-13','16:50:00',3.84),('14598','2013-07-13','16:55:00',3.64),('14598','2013-07-13','17:00:00',3.69),('14598','2013-07-13','17:05:00',3.59),('14598','2013-07-13','17:10:00',3.3),('14598','2013-07-13','17:15:00',3.43),('14598','2013-07-13','17:20:00',2.92),('14598','2013-07-13','17:25:00',3.28),('14598','2013-07-13','17:30:00',2.72),('14598','2013-07-13','17:35:00',1.72),('14598','2013-07-13','17:40:00',2.61),('14598','2013-07-13','17:45:00',3.13),('14598','2013-07-13','17:50:00',2.87),('14598','2013-07-13','17:55:00',2.8),('14598','2013-07-13','18:00:00',2.73),('14598','2013-07-13','18:05:00',2.63),('14598','2013-07-13','18:10:00',2.46),('14598','2013-07-13','18:15:00',2.45),('14598','2013-07-13','18:20:00',2.3),('14598','2013-07-13','18:25:00',2.19),('14598','2013-07-13','18:30:00',1.65),('14598','2013-07-13','18:35:00',1.16),('14598','2013-07-13','18:40:00',1.75),('14598','2013-07-13','18:45:00',1.99),('14598','2013-07-13','18:50:00',1.6),('14598','2013-07-13','18:55:00',1.67),('14598','2013-07-13','19:00:00',1.41),('14598','2013-07-13','19:05:00',1.34),('14598','2013-07-13','19:10:00',1.07),('14598','2013-07-13','19:15:00',1.08),('14598','2013-07-13','19:20:00',1.03),('14598','2013-07-12','08:00:00',1.17),('14598','2013-07-12','08:05:00',1.07),('14598','2013-07-12','08:15:00',1.07),('14598','2013-07-12','08:20:00',1.17),('14598','2013-07-12','08:25:00',1.24),('14598','2013-07-12','08:30:00',1.07),('14598','2013-07-12','08:40:00',1.43),('14598','2013-07-12','08:45:00',1.33),('14598','2013-07-12','08:50:00',1.96),('14598','2013-07-12','08:55:00',1.43),('14598','2013-07-12','09:00:00',1.2),('14598','2013-07-12','09:05:00',2.33),('14598','2013-07-12','09:10:00',2.51),('14598','2013-07-12','09:20:00',1.77),('14598','2013-07-12','09:25:00',2.49),('14598','2013-07-12','09:30:00',1.13),('14598','2013-07-12','09:40:00',1.12),('14598','2013-07-12','09:45:00',1.32),('14598','2013-07-12','09:50:00',1.48),('14598','2013-07-12','09:55:00',1.94),('14598','2013-07-12','10:00:00',2.61),('14598','2013-07-12','10:05:00',3.23),('14598','2013-07-12','10:10:00',2.9),('14598','2013-07-12','10:15:00',2.61),('14598','2013-07-12','10:20:00',2.31),('14598','2013-07-12','10:25:00',3.15),('14598','2013-07-12','10:30:00',3.42),('14598','2013-07-12','10:35:00',3.69),('14598','2013-07-12','10:40:00',3.7),('14598','2013-07-12','10:45:00',3.71),('14598','2013-07-12','10:50:00',2.98),('14598','2013-07-12','10:55:00',3.88),('14598','2013-07-12','11:00:00',3.88),('14598','2013-07-12','11:05:00',3.96),('14598','2013-07-12','11:10:00',4.02),('14598','2013-07-12','11:15:00',4.12),('14598','2013-07-12','11:20:00',4.16),('14598','2013-07-12','11:25:00',4.22),('14598','2013-07-12','11:30:00',4.25),('14598','2013-07-12','11:35:00',4.32),('14598','2013-07-12','11:40:00',4.34),('14598','2013-07-12','11:45:00',4.44),('14598','2013-07-12','11:50:00',4.51),('14598','2013-07-12','11:55:00',4.47),('14598','2013-07-12','12:00:00',4.5),('14598','2013-07-12','12:05:00',4.55),('14598','2013-07-12','12:10:00',4.61),('14598','2013-07-12','12:15:00',4.65),('14598','2013-07-12','12:20:00',4.68),('14598','2013-07-12','12:25:00',4.74),('14598','2013-07-12','12:30:00',4.76),('14598','2013-07-12','12:35:00',4.8),('14598','2013-07-12','12:40:00',4.79),('14598','2013-07-12','12:45:00',4.68),('14598','2013-07-12','12:50:00',4.83),('14598','2013-07-12','12:55:00',4.83),('14598','2013-07-12','13:00:00',4.84),('14598','2013-07-12','13:05:00',4.83),('14598','2013-07-12','13:10:00',4.91),('14598','2013-07-12','13:15:00',4.95),('14598','2013-07-12','13:20:00',4.95),('14598','2013-07-12','13:25:00',4.97),('14598','2013-07-12','13:30:00',4.98),('14598','2013-07-12','13:35:00',4.96),('14598','2013-07-12','13:40:00',4.97),('14598','2013-07-12','13:45:00',4.97),('14598','2013-07-12','13:50:00',4.98),('14598','2013-07-12','13:55:00',4.99),('14598','2013-07-12','14:00:00',4.97),('14598','2013-07-12','14:05:00',4.94),('14598','2013-07-12','14:10:00',4.95),('14598','2013-07-12','14:15:00',4.94),('14598','2013-07-12','14:20:00',4.94),('14598','2013-07-12','14:25:00',4.92),('14598','2013-07-12','14:30:00',4.88),('14598','2013-07-12','14:35:00',4.87),('14598','2013-07-12','14:40:00',4.88),('14598','2013-07-12','14:45:00',4.84),('14598','2013-07-12','14:50:00',4.86),('14598','2013-07-12','14:55:00',4.84),('14598','2013-07-12','15:00:00',4.81),('14598','2013-07-12','15:05:00',4.79),('14598','2013-07-12','15:10:00',4.74),('14598','2013-07-12','15:15:00',4.69),('14598','2013-07-12','15:20:00',4.7),('14598','2013-07-12','15:25:00',4.63),('14598','2013-07-12','15:30:00',4.56),('14598','2013-07-12','15:35:00',4.53),('14598','2013-07-12','15:40:00',4.49),('14598','2013-07-12','15:45:00',4.46),('14598','2013-07-12','15:50:00',4.38),('14598','2013-07-12','15:55:00',4.38),('14598','2013-07-12','16:00:00',4.32),('14598','2013-07-12','16:05:00',4.25),('14598','2013-07-12','16:10:00',4.23),('14598','2013-07-12','16:15:00',4.18),('14598','2013-07-12','16:20:00',4.1),('14598','2013-07-12','16:25:00',4.02),('14598','2013-07-12','16:30:00',3.99),('14598','2013-07-12','16:35:00',3.94),('14598','2013-07-12','16:40:00',3.87),('14598','2013-07-12','16:45:00',3.78),('14598','2013-07-12','16:50:00',3.73),('14598','2013-07-12','16:55:00',3.66),('14598','2013-07-12','17:00:00',3.56),('14598','2013-07-12','17:05:00',3.5),('14598','2013-07-12','17:10:00',3.45),('14598','2013-07-12','17:15:00',3.39),('14598','2013-07-12','17:20:00',3.3),('14598','2013-07-12','17:25:00',3.23),('14598','2013-07-12','17:30:00',3.2),('14598','2013-07-12','17:35:00',3.09),('14598','2013-07-12','17:40:00',3.09),('14598','2013-07-12','17:45:00',1.63),('14598','2013-07-12','17:50:00',1.27),('14598','2013-07-12','17:55:00',2.66),('14598','2013-07-12','18:00:00',2.73),('14598','2013-07-12','18:05:00',2.54),('14598','2013-07-12','18:10:00',2.36),('14598','2013-07-12','18:15:00',2.24),('14598','2013-07-12','18:20:00',2.15),('14598','2013-07-12','18:25:00',2.04),('14598','2013-07-12','18:30:00',1.93),('14598','2013-07-12','18:35:00',1.84),('14598','2013-07-12','18:40:00',1.75),('14598','2013-07-12','18:45:00',1.63),('14598','2013-07-12','18:50:00',1.52),('14598','2013-07-12','18:55:00',1.41),('14598','2013-07-12','19:00:00',1.31),('14598','2013-07-12','19:05:00',1.19),('14598','2013-07-12','19:10:00',1.11),('14598','2013-07-12','19:15:00',1),('14598','2013-07-11','08:00:00',1.02),('14598','2013-07-11','08:05:00',1.09),('14598','2013-07-11','08:10:00',1.16),('14598','2013-07-11','08:15:00',1.23),('14598','2013-07-11','08:20:00',1.32),('14598','2013-07-11','08:25:00',1.42),('14598','2013-07-11','08:30:00',1.5),('14598','2013-07-11','08:35:00',1.6),('14598','2013-07-11','08:40:00',1.68),('14598','2013-07-11','08:45:00',1.77),('14598','2013-07-11','08:50:00',1.98),('14598','2013-07-11','08:55:00',2.05),('14598','2013-07-11','09:00:00',2.17),('14598','2013-07-11','09:05:00',2.25),('14598','2013-07-11','09:10:00',2.39),('14598','2013-07-11','09:15:00',1.49),('14598','2013-07-11','09:20:00',1.2),('14598','2013-07-11','09:25:00',1.14),('14598','2013-07-11','09:30:00',1.02),('14598','2013-07-11','09:35:00',1.81),('14598','2013-07-11','09:40:00',1.03),('14598','2013-07-11','09:45:00',2.48),('14598','2013-07-11','09:50:00',3.13),('14598','2013-07-11','09:55:00',3.13),('14598','2013-07-11','10:00:00',3.14),('14598','2013-07-11','10:05:00',3.21),('14598','2013-07-11','10:10:00',3.27),('14598','2013-07-11','10:15:00',3.35),('14598','2013-07-11','10:20:00',3.47),('14598','2013-07-11','10:25:00',3.54),('14598','2013-07-11','10:30:00',3.62),('14598','2013-07-11','10:35:00',3.69),('14598','2013-07-11','10:40:00',3.74),('14598','2013-07-11','10:45:00',3.79),('14598','2013-07-11','10:50:00',3.88),('14598','2013-07-11','10:55:00',3.94),('14598','2013-07-11','11:00:00',4.01),('14598','2013-07-11','11:05:00',4.06),('14598','2013-07-11','11:10:00',4.11),('14598','2013-07-11','11:15:00',4.17),('14598','2013-07-11','11:20:00',4.25),('14598','2013-07-11','11:25:00',4.28),('14598','2013-07-11','11:30:00',4.35),('14598','2013-07-11','11:35:00',4.36),('14598','2013-07-11','11:40:00',4.42),('14598','2013-07-11','11:45:00',4.48),('14598','2013-07-11','11:50:00',4.53),('14598','2013-07-11','11:55:00',4.53),('14598','2013-07-11','12:00:00',4.59),('14598','2013-07-11','12:05:00',4.65),('14598','2013-07-11','12:10:00',4.69),('14598','2013-07-11','12:15:00',4.69),('14598','2013-07-11','12:20:00',4.78),('14598','2013-07-11','12:25:00',4.78),('14598','2013-07-11','12:30:00',4.58),('14598','2013-07-11','12:35:00',4.8),('14598','2013-07-11','12:40:00',4.87),('14598','2013-07-11','12:45:00',4.89),('14598','2013-07-11','12:50:00',4.89),('14598','2013-07-11','12:55:00',4.92),('14598','2013-07-11','13:00:00',4.96),('14598','2013-07-11','13:05:00',4.96),('14598','2013-07-11','13:10:00',4.99),('14598','2013-07-11','13:15:00',5.01),('14598','2013-07-11','13:20:00',4.99),('14598','2013-07-11','13:25:00',5),('14598','2013-07-11','13:30:00',5.03),('14598','2013-07-11','13:35:00',5.07),('14598','2013-07-11','13:40:00',4.97),('14598','2013-07-11','13:45:00',5.04),('14598','2013-07-11','13:50:00',5.04),('14598','2013-07-11','13:55:00',5.04),('14598','2013-07-11','14:00:00',5.04),('14598','2013-07-11','14:05:00',5.03),('14598','2013-07-11','14:10:00',5.15),('14598','2013-07-11','14:15:00',5.09),('14598','2013-07-11','14:20:00',5.04),('14598','2013-07-11','14:25:00',4.98),('14598','2013-07-11','14:30:00',4.98),('14598','2013-07-11','14:35:00',4.98),('14598','2013-07-11','14:40:00',4.96),('14598','2013-07-11','14:45:00',4.93),('14598','2013-07-11','14:50:00',4.89),('14598','2013-07-11','14:55:00',4.86),('14598','2013-07-11','15:00:00',4.79),('14598','2013-07-11','15:05:00',4.77),('14598','2013-07-11','15:10:00',4.71),('14598','2013-07-11','15:15:00',4.72),('14598','2013-07-11','15:20:00',4.71),('14598','2013-07-11','15:25:00',4.68),('14598','2013-07-11','15:30:00',4.64),('14598','2013-07-11','15:35:00',4.57),('14598','2013-07-11','15:40:00',4.51),('14598','2013-07-11','15:45:00',4.49),('14598','2013-07-11','15:50:00',4.35),('14598','2013-07-11','15:55:00',4.4),('14598','2013-07-11','16:00:00',4.37),('14598','2013-07-11','16:05:00',4.31),('14598','2013-07-11','16:10:00',4.26),('14598','2013-07-11','16:15:00',4.21),('14598','2013-07-11','16:20:00',4.09),('14598','2013-07-11','16:25:00',4.03),('14598','2013-07-11','16:30:00',3.94),('14598','2013-07-11','16:35:00',3.94),('14598','2013-07-11','16:40:00',3.89),('14598','2013-07-11','16:45:00',3.73),('14598','2013-07-11','16:50:00',3.7),('14598','2013-07-11','16:55:00',3.65),('14598','2013-07-11','17:00:00',3.57),('14598','2013-07-11','17:05:00',3.49),('14598','2013-07-11','17:10:00',3.44),('14598','2013-07-11','17:15:00',3.34),('14598','2013-07-11','17:20:00',3.24),('14598','2013-07-11','17:25:00',3.16),('14598','2013-07-11','17:30:00',3.08),('14598','2013-07-11','17:35:00',2.93),('14598','2013-07-11','17:40:00',2.95),('14598','2013-07-11','17:45:00',2.86),('14598','2013-07-11','17:50:00',2.73),('14598','2013-07-11','17:55:00',2.58),('14598','2013-07-11','18:00:00',2.56),('14598','2013-07-11','18:05:00',2.47),('14598','2013-07-11','18:10:00',2.35),('14598','2013-07-11','18:15:00',2.2),('14598','2013-07-11','18:20:00',2.09),('14598','2013-07-11','18:25:00',1.33),('14598','2013-07-11','18:30:00',1.08),('14598','2013-07-11','18:35:00',1.63),('14598','2013-07-11','18:50:00',1.58),('14598','2013-07-11','18:55:00',1.64),('14598','2013-07-11','19:00:00',1.48),('14598','2013-07-11','19:05:00',1.42),('14598','2013-07-11','19:10:00',1.3),('14598','2013-07-11','19:15:00',1.15),('14598','2013-07-11','19:20:00',1.06),('14598','2014-05-03','07:45:00',1.19),('14598','2014-05-03','08:05:00',1.06),('14598','2014-05-03','08:10:00',1.17),('14598','2014-05-03','08:15:00',1.3),('14598','2014-05-03','08:20:00',1.45),('14598','2014-05-03','08:25:00',1.49),('14598','2014-05-03','08:30:00',1.53),('14598','2014-05-03','08:35:00',1.7),('14598','2014-05-03','08:40:00',2.04),('14598','2014-05-03','08:45:00',1.21),('14598','2014-05-03','08:50:00',2.16),('14598','2014-05-03','08:55:00',2.02),('14598','2014-05-03','10:35:00',1.34),('14598','2014-05-03','10:40:00',1.37),('14598','2014-05-03','10:45:00',1.26),('14598','2014-05-03','10:50:00',1.48),('14598','2014-05-03','10:55:00',1.23),('14598','2014-05-03','11:00:00',1.32),('14598','2014-05-03','11:05:00',1.16),('14598','2014-05-03','12:25:00',1.14),('14598','2014-05-03','12:30:00',1.42),('14598','2014-05-03','12:35:00',1.52),('14598','2014-05-03','12:40:00',1.46),('14598','2014-05-03','12:45:00',1.24),('14598','2014-05-03','12:50:00',1.11),('14598','2014-05-03','12:55:00',1.11),('14598','2014-05-03','13:00:00',1.05),('14598','2014-05-03','13:20:00',1.02),('14598','2014-05-03','13:25:00',1.08),('14598','2014-05-03','13:30:00',1.15),('14598','2014-05-03','13:35:00',1.23),('14598','2014-05-03','13:40:00',1.36),('14598','2014-05-03','13:45:00',1.54),('14598','2014-05-03','13:50:00',1.67),('14598','2014-05-03','13:55:00',1.74),('14598','2014-05-03','14:00:00',1.62),('14598','2014-05-03','14:05:00',1.09),('14598','2014-05-03','14:30:00',1.15),('14598','2014-05-03','14:35:00',1.54),('14598','2014-05-03','14:40:00',1.92),('14598','2014-05-03','14:45:00',2.13),('14598','2014-05-03','14:50:00',2.29),('14598','2014-05-03','14:55:00',2.6),('14598','2014-05-03','15:00:00',2.68),('14598','2014-05-03','15:05:00',2.22),('14598','2014-05-03','15:10:00',3.79),('14598','2014-05-03','15:15:00',2.63),('14598','2014-05-03','15:20:00',2.11),('14598','2014-05-03','15:25:00',1.16),('14598','2014-05-03','15:30:00',1.7),('14598','2014-05-03','15:35:00',1.65),('14598','2014-05-03','15:40:00',1.43),('14598','2014-05-03','15:45:00',1.3),('14598','2014-05-03','15:50:00',1.22),('14598','2014-05-03','15:55:00',1.08),('14598','2014-05-03','17:35:00',1.03),('14598','2014-05-03','17:40:00',1.93),('14598','2014-05-03','17:45:00',2.08),('14598','2014-05-03','17:50:00',2.32),('14598','2014-05-03','17:55:00',3.34),('14598','2014-05-03','18:00:00',2.87),('14598','2014-05-03','18:05:00',2.04),('14598','2014-05-03','18:10:00',2.34),('14598','2014-05-03','18:15:00',1.14),('14598','2014-04-06','08:50:00',1.37),('14598','2014-04-06','08:55:00',1.46),('14598','2014-04-06','09:00:00',1.62),('14598','2014-04-06','09:05:00',1.72),('14598','2014-04-06','09:10:00',1.77),('14598','2014-04-06','09:15:00',1.96),('14598','2014-04-06','09:20:00',2.11),('14598','2014-04-06','09:25:00',2.26),('14598','2014-04-06','09:30:00',2.35),('14598','2014-04-06','09:35:00',2.43),('14598','2014-04-06','09:40:00',2.54),('14598','2014-04-06','09:45:00',2.53),('14598','2014-04-06','09:50:00',1.58),('14598','2014-04-06','09:55:00',1.18),('14598','2014-04-06','10:00:00',1.32),('14598','2014-04-06','10:05:00',1.76),('14598','2014-04-06','10:10:00',1.38),('14598','2014-04-06','10:15:00',1.47),('14598','2014-04-06','10:20:00',1.42),('14598','2014-04-06','10:25:00',2.99),('14598','2014-04-06','10:30:00',2.79),('14598','2014-04-06','10:35:00',1.89),('14598','2014-04-06','10:40:00',1.54),('14598','2014-04-06','10:45:00',1.42),('14598','2014-04-06','10:50:00',1.39),('14598','2014-04-06','10:55:00',1.56),('14598','2014-04-06','11:00:00',1.68),('14598','2014-04-06','11:05:00',2.73),('14598','2014-04-06','11:10:00',4.09),('14598','2014-04-06','11:15:00',4.92),('14598','2014-04-06','11:20:00',4.51),('14598','2014-04-06','11:25:00',4.09),('14598','2014-04-06','11:30:00',4.31),('14598','2014-04-06','11:35:00',4.22),('14598','2014-04-06','11:40:00',4.23),('14598','2014-04-06','11:45:00',4.35),('14598','2014-04-06','11:50:00',4.42),('14598','2014-04-06','11:55:00',4.43),('14598','2014-04-06','12:00:00',4.41),('14598','2014-04-06','12:05:00',4.45),('14598','2014-04-06','12:10:00',4.48),('14598','2014-04-06','12:15:00',4.57),('14598','2014-04-06','12:20:00',4.66),('14598','2014-04-06','12:25:00',4.72),('14598','2014-04-06','12:30:00',4.77),('14598','2014-04-06','12:35:00',4.85),('14598','2014-04-06','12:40:00',4.86),('14598','2014-04-06','12:45:00',4.94),('14598','2014-04-06','12:50:00',4.93),('14598','2014-04-06','12:55:00',4.96),('14598','2014-04-06','13:00:00',5.05),('14598','2014-04-06','13:05:00',5.01),('14598','2014-04-06','13:10:00',4.97),('14598','2014-04-06','13:15:00',4.63),('14598','2014-04-06','13:20:00',4.76),('14598','2014-04-06','13:25:00',4.98),('14598','2014-04-06','13:30:00',4.99),('14598','2014-04-06','13:35:00',4.92),('14598','2014-04-06','13:40:00',4.89),('14598','2014-04-06','13:45:00',4.88),('14598','2014-04-06','13:50:00',4.89),('14598','2014-04-06','13:55:00',4.88),('14598','2014-04-06','14:00:00',4.86),('14598','2014-04-06','14:05:00',4.84),('14598','2014-04-06','14:10:00',4.83),('14598','2014-04-06','14:15:00',4.89),('14598','2014-04-06','14:20:00',4.93),('14598','2014-04-06','14:25:00',4.99),('14598','2014-04-06','14:30:00',5.01),('14598','2014-04-06','14:35:00',4.93),('14598','2014-04-06','14:40:00',4.84),('14598','2014-04-06','14:45:00',4.77),('14598','2014-04-06','14:50:00',4.75),('14598','2014-04-06','14:55:00',4.76),('14598','2014-04-06','15:00:00',4.67),('14598','2014-04-06','15:05:00',4.67),('14598','2014-04-06','15:10:00',4.63),('14598','2014-04-06','15:15:00',4.61),('14598','2014-04-06','15:20:00',4.6),('14598','2014-04-06','15:25:00',4.65),('14598','2014-04-06','15:30:00',4.74),('14598','2014-04-06','15:35:00',4.84),('14598','2014-04-06','15:40:00',4.61),('14598','2014-04-06','15:45:00',4.43),('14598','2014-04-06','15:50:00',4.45),('14598','2014-04-06','15:55:00',4.49),('14598','2014-04-06','16:00:00',4.46),('14598','2014-04-06','16:05:00',4.51),('14598','2014-04-06','16:10:00',4.53),('14598','2014-04-06','16:15:00',3.87),('14598','2014-04-06','16:20:00',2.87),('14598','2014-04-06','16:25:00',2.17),('14598','2014-04-06','16:30:00',2.5),('14598','2014-04-06','16:35:00',3.91),('14598','2014-04-06','16:40:00',3.53),('14598','2014-04-06','16:45:00',1.47),('14598','2014-04-06','16:50:00',1.96),('14598','2014-04-06','16:55:00',3.46),('14598','2014-04-06','17:00:00',3.37),('14598','2014-04-06','17:05:00',3.3),('14598','2014-04-06','17:10:00',3.55),('14598','2014-04-06','17:15:00',3.48),('14598','2014-04-06','17:20:00',1.82),('14598','2014-04-06','17:25:00',2.27),('14598','2014-04-06','17:30:00',2.54),('14598','2014-04-06','17:35:00',2.54),('14598','2014-04-06','17:40:00',2.4),('14598','2014-04-06','17:45:00',2.26),('14598','2014-04-06','17:50:00',2.12),('14598','2014-04-06','17:55:00',2),('14598','2014-04-06','18:00:00',1.91),('14598','2014-04-06','18:05:00',1.62),('14598','2014-04-06','18:10:00',1.72),('14598','2014-04-06','18:15:00',1.56),('14598','2014-04-06','18:20:00',1.44),('14598','2014-04-06','18:25:00',1.32),('14598','2014-04-06','18:30:00',1.19),('14598','2014-04-06','18:35:00',1.03),('14598','2013-07-10','08:00:00',1.06),('14598','2013-07-10','08:05:00',1.19),('14598','2013-07-10','08:10:00',1.25),('14598','2013-07-10','08:15:00',1.34),('14598','2013-07-10','08:20:00',1.44),('14598','2013-07-10','08:25:00',1.57),('14598','2013-07-10','08:30:00',1.66),('14598','2013-07-10','08:35:00',1.8),('14598','2013-07-10','08:40:00',1.91),('14598','2013-07-10','08:45:00',1.87),('14598','2013-07-10','08:50:00',1.85),('14598','2013-07-10','08:55:00',2.34),('14598','2013-07-10','09:00:00',2.43),('14598','2013-07-10','09:05:00',2.4),('14598','2013-07-10','09:10:00',2.42),('14598','2013-07-10','09:15:00',2.49),('14598','2013-07-10','09:20:00',2.61),('14598','2013-07-10','09:25:00',2.7),('14598','2013-07-10','09:30:00',2.74),('14598','2013-07-10','09:35:00',2.81),('14598','2013-07-10','09:40:00',2.86),('14598','2013-07-10','09:45:00',2.96),('14598','2013-07-10','09:50:00',3.04),('14598','2013-07-10','09:55:00',3.12),('14598','2013-07-10','10:00:00',3.15),('14598','2013-07-10','10:05:00',3.21),('14598','2013-07-10','10:10:00',3.28),('14598','2013-07-10','10:15:00',3.37),('14598','2013-07-10','10:20:00',3.45),('14598','2013-07-10','10:25:00',3.47),('14598','2013-07-10','10:30:00',3.47),('14598','2013-07-10','10:35:00',3.64),('14598','2013-07-10','10:40:00',3.72),('14598','2013-07-10','10:45:00',3.82),('14598','2013-07-10','10:50:00',3.9),('14598','2013-07-10','10:55:00',3.95),('14598','2013-07-10','11:00:00',3.99),('14598','2013-07-10','11:05:00',4.06),('14598','2013-07-10','11:10:00',4.11),('14598','2013-07-10','11:15:00',4.2),('14598','2013-07-10','11:20:00',4.25),('14598','2013-07-10','11:25:00',4.31),('14598','2013-07-10','11:30:00',4.37),('14598','2013-07-10','11:35:00',4.42),('14598','2013-07-10','11:40:00',4.45),('14598','2013-07-10','11:45:00',4.46),('14598','2013-07-10','11:50:00',4.55),('14598','2013-07-10','11:55:00',4.59),('14598','2013-07-10','12:00:00',4.62),('14598','2013-07-10','12:05:00',4.7),('14598','2013-07-10','12:10:00',4.71),('14598','2013-07-10','12:15:00',4.74),('14598','2013-07-10','12:20:00',4.74),('14598','2013-07-10','12:25:00',4.77),('14598','2013-07-10','12:30:00',4.82),('14598','2013-07-10','12:35:00',4.87),('14598','2013-07-10','12:40:00',4.91),('14598','2013-07-10','12:45:00',4.94),('14598','2013-07-10','12:50:00',4.96),('14598','2013-07-10','12:55:00',4.98),('14598','2013-07-10','13:00:00',4.98),('14598','2013-07-10','13:05:00',5.01),('14598','2013-07-10','13:10:00',4.99),('14598','2013-07-10','13:15:00',5.02),('14598','2013-07-10','13:20:00',5.01),('14598','2013-07-10','13:25:00',5.02),('14598','2013-07-10','13:30:00',5.01),('14598','2013-07-10','13:35:00',5.06),('14598','2013-07-10','13:40:00',5.07),('14598','2013-07-10','13:45:00',5.07),('14598','2013-07-10','13:50:00',5.07),('14598','2013-07-10','13:55:00',5.05),('14598','2013-07-10','14:00:00',5.05),('14598','2013-07-10','14:05:00',5.06),('14598','2013-07-10','14:10:00',5.05),('14598','2013-07-10','14:15:00',5.04),('14598','2013-07-10','14:20:00',5.02),('14598','2013-07-10','14:25:00',5.01),('14598','2013-07-10','14:30:00',4.99),('14598','2013-07-10','14:35:00',4.99),('14598','2013-07-10','14:40:00',4.95),('14598','2013-07-10','14:45:00',4.89),('14598','2013-07-10','14:50:00',4.92),('14598','2013-07-10','14:55:00',4.92),('14598','2013-07-10','15:00:00',4.88),('14598','2013-07-10','15:05:00',4.87),('14598','2013-07-10','15:10:00',4.84),('14598','2013-07-10','15:15:00',4.81),('14598','2013-07-10','15:20:00',4.77),('14598','2013-07-10','15:25:00',4.73),('14598','2013-07-10','15:30:00',4.69),('14598','2013-07-10','15:35:00',4.65),('14598','2013-07-10','15:40:00',4.62),('14598','2013-07-10','15:45:00',4.57),('14598','2013-07-10','15:50:00',4.52),('14598','2013-07-10','15:55:00',4.47),('14598','2013-07-10','16:00:00',4.42),('14598','2013-07-10','16:05:00',4.38),('14598','2013-07-10','16:10:00',4.31),('14598','2013-07-10','16:15:00',4.25),('14598','2013-07-10','16:20:00',4.19),('14598','2013-07-10','16:25:00',4.14),('14598','2013-07-10','16:30:00',4.02),('14598','2013-07-10','16:35:00',4.02),('14598','2013-07-10','16:40:00',3.96),('14598','2013-07-10','16:45:00',3.9),('14598','2013-07-10','16:50:00',3.84),('14598','2013-07-10','16:55:00',3.77),('14598','2013-07-10','17:00:00',3.71),('14598','2013-07-10','17:05:00',3.67),('14598','2013-07-10','17:10:00',3.65),('14598','2013-07-10','17:15:00',3.56),('14598','2013-07-10','17:20:00',3.56),('14598','2013-07-10','17:25:00',2.83),('14598','2013-07-10','17:30:00',2.51),('14598','2013-07-10','17:35:00',1.68),('14598','2013-07-10','17:40:00',2.6),('14598','2013-07-10','17:45:00',3.24),('14598','2013-07-10','17:50:00',3.21),('14598','2013-07-10','17:55:00',2.97),('14598','2013-07-10','18:00:00',2.69),('14598','2013-07-10','18:05:00',2.6),('14598','2013-07-10','18:10:00',2.54),('14598','2013-07-10','18:15:00',2.45),('14598','2013-07-10','18:20:00',2.35),('14598','2013-07-10','18:25:00',2.29),('14598','2013-07-10','18:30:00',2.22),('14598','2013-07-10','18:35:00',2.12),('14598','2013-07-10','18:40:00',2),('14598','2013-07-10','18:45:00',1.9),('14598','2013-07-10','18:50:00',1.82),('14598','2013-07-10','18:55:00',1.72),('14598','2013-07-10','19:00:00',1.58),('14598','2013-07-10','19:05:00',1.41),('14598','2013-07-10','19:10:00',1.26),('14598','2013-07-10','19:15:00',1.12),('14598','2013-07-10','19:20:00',1.02),('14598','2013-07-09','08:20:00',1.36),('14598','2013-07-09','08:25:00',1.06),('14598','2013-07-09','08:30:00',1.44),('14598','2013-07-09','08:35:00',1.76),('14598','2013-07-09','08:40:00',1.63),('14598','2013-07-09','08:45:00',1.8),('14598','2013-07-09','08:50:00',2),('14598','2013-07-09','08:55:00',2.1),('14598','2013-07-09','09:00:00',2.21),('14598','2013-07-09','09:05:00',2.26),('14598','2013-07-09','09:10:00',2.35),('14598','2013-07-09','09:15:00',2.45),('14598','2013-07-09','09:20:00',2.57),('14598','2013-07-09','09:25:00',2.66),('14598','2013-07-09','09:30:00',2.73),('14598','2013-07-09','09:35:00',2.82),('14598','2013-07-09','09:40:00',2.89),('14598','2013-07-09','09:45:00',2.97),('14598','2013-07-09','09:50:00',3.04),('14598','2013-07-09','09:55:00',3.12),('14598','2013-07-09','10:00:00',3.16),('14598','2013-07-09','10:05:00',3.24),('14598','2013-07-09','10:10:00',3.32),('14598','2013-07-09','10:15:00',3.37),('14598','2013-07-09','10:20:00',3.45),('14598','2013-07-09','10:25:00',3.52),('14598','2013-07-09','10:30:00',3.57),('14598','2013-07-09','10:35:00',3.62),('14598','2013-07-09','10:40:00',3.68),('14598','2013-07-09','10:45:00',3.74),('14598','2013-07-09','10:50:00',3.8),('14598','2013-07-09','10:55:00',3.86),('14598','2013-07-09','11:00:00',3.88),('14598','2013-07-09','11:05:00',3.94),('14598','2013-07-09','11:10:00',3.98),('14598','2013-07-09','11:15:00',4.02),('14598','2013-07-09','11:20:00',4.07),('14598','2013-07-09','11:25:00',4.08),('14598','2013-07-09','11:30:00',4.11),('14598','2013-07-09','11:35:00',4.15),('14598','2013-07-09','11:40:00',4.19),('14598','2013-07-09','11:45:00',4.23),('14598','2013-07-09','11:50:00',4.39),('14598','2013-07-09','11:55:00',4.48),('14598','2013-07-09','12:00:00',4.53),('14598','2013-07-09','12:05:00',4.54),('14598','2013-07-09','12:10:00',4.58),('14598','2013-07-09','12:15:00',4.6),('14598','2013-07-09','12:20:00',4.64),('14598','2013-07-09','12:25:00',4.73),('14598','2013-07-09','12:30:00',4.78),('14598','2013-07-09','12:35:00',4.85),('14598','2013-07-09','12:40:00',4.89),('14598','2013-07-09','12:45:00',4.88),('14598','2013-07-09','12:50:00',4.89),('14598','2013-07-09','12:55:00',4.95),('14598','2013-07-09','13:00:00',4.96),('14598','2013-07-09','13:05:00',4.97),('14598','2013-07-09','13:10:00',4.98),('14598','2013-07-09','13:15:00',4.98),('14598','2013-07-09','13:20:00',5.02),('14598','2013-07-09','13:25:00',5.03),('14598','2013-07-09','13:30:00',5.06),('14598','2013-07-09','13:35:00',5.09),('14598','2013-07-09','13:40:00',5.07),('14598','2013-07-09','13:45:00',5.07),('14598','2013-07-09','13:50:00',5.09),('14598','2013-07-09','13:55:00',5.11),('14598','2013-07-09','14:00:00',5.18),('14598','2013-07-09','14:05:00',5.27),('14598','2013-07-09','14:10:00',4.04),('14598','2013-07-09','14:15:00',4.81),('14598','2013-07-09','14:20:00',5.07),('14598','2013-07-09','14:25:00',5.53),('14598','2013-07-09','14:30:00',5.68),('14598','2013-07-09','14:35:00',4.72),('14598','2013-07-09','14:40:00',3.1),('14598','2013-07-09','14:45:00',2.06),('14598','2013-07-09','14:50:00',1.23),('14598','2013-07-08','07:55:00',1.03),('14598','2013-07-08','08:00:00',1.04),('14598','2013-07-08','08:05:00',1.14),('14598','2013-07-08','08:10:00',1.18),('14598','2013-07-08','08:20:00',1.4),('14598','2013-07-08','08:25:00',1.5),('14598','2013-07-08','08:30:00',1.62),('14598','2013-07-08','08:35:00',1.73),('14598','2013-07-08','08:40:00',1.8),('14598','2013-07-08','08:45:00',1.88),('14598','2013-07-08','08:50:00',2),('14598','2013-07-08','08:55:00',2.11),('14598','2013-07-08','09:00:00',2.21),('14598','2013-07-08','09:05:00',2.27),('14598','2013-07-08','09:10:00',2.35),('14598','2013-07-08','09:15:00',2.42),('14598','2013-07-08','09:20:00',2.52),('14598','2013-07-08','09:25:00',2.62),('14598','2013-07-08','09:30:00',2.71),('14598','2013-07-08','09:35:00',2.79),('14598','2013-07-08','09:40:00',2.87),('14598','2013-07-08','09:45:00',2.95),('14598','2013-07-08','09:50:00',3.03),('14598','2013-07-08','09:55:00',3.12),('14598','2013-07-08','10:00:00',3.19),('14598','2013-07-08','10:05:00',3.25),('14598','2013-07-08','10:10:00',3.3),('14598','2013-07-08','10:15:00',3.37),('14598','2013-07-08','10:20:00',3.44),('14598','2013-07-08','10:25:00',3.49),('14598','2013-07-08','10:30:00',3.56),('14598','2013-07-08','10:35:00',3.63),('14598','2013-07-08','10:40:00',3.67),('14598','2013-07-08','10:45:00',3.74),('14598','2013-07-08','10:50:00',3.81),('14598','2013-07-08','10:55:00',3.88),('14598','2013-07-08','11:00:00',3.92),('14598','2013-07-08','11:05:00',3.94),('14598','2013-07-08','11:10:00',4.01),('14598','2013-07-08','11:15:00',4.03),('14598','2013-07-08','11:20:00',4.1),('14598','2013-07-08','11:25:00',4.21),('14598','2013-07-08','11:30:00',4.28),('14598','2013-07-08','11:35:00',4.22),('14598','2013-07-08','11:40:00',4.19),('14598','2013-07-08','11:45:00',4.02),('14598','2013-07-08','11:50:00',4.14),('14598','2013-07-08','11:55:00',3.55),('14598','2013-07-08','12:00:00',4.17),('14598','2013-07-08','12:05:00',4.54),('14598','2013-07-08','12:10:00',4.42),('14598','2013-07-08','12:15:00',4.55),('14598','2013-07-08','12:20:00',4.37),('14598','2013-07-08','12:25:00',4.53),('14598','2013-07-08','12:30:00',4.56),('14598','2013-07-08','12:35:00',4.49),('14598','2013-07-08','12:40:00',4.66),('14598','2013-07-08','12:45:00',4.66),('14598','2013-07-08','12:50:00',4.87),('14598','2013-07-08','12:55:00',4.89),('14598','2013-07-08','13:00:00',4.93),('14598','2013-07-08','13:05:00',4.98),('14598','2013-07-08','13:10:00',4.98),('14598','2013-07-08','13:15:00',5.01),('14598','2013-07-08','13:20:00',5.07),('14598','2013-07-08','13:25:00',5.17),('14598','2013-07-08','13:30:00',5.18),('14598','2013-07-08','13:35:00',4.42),('14598','2013-07-08','13:40:00',3.83),('14598','2013-07-08','13:45:00',1.37),('14598','2013-07-08','14:45:00',1.07),('14598','2013-07-08','14:50:00',1.22),('14598','2013-07-08','14:55:00',1.29),('14598','2013-07-08','15:00:00',1.58),('14598','2013-07-08','15:05:00',1.67),('14598','2013-07-08','15:10:00',1.55),('14598','2013-07-08','15:15:00',1.48),('14598','2013-07-08','15:20:00',1.37),('14598','2013-07-08','15:25:00',1.35),('14598','2013-07-08','15:30:00',1.39),('14598','2013-07-08','15:35:00',1.33),('14598','2013-07-08','15:40:00',1.06),('14598','2013-07-07','08:00:00',1.06),('14598','2013-07-07','08:05:00',1.14),('14598','2013-07-07','08:10:00',1.2),('14598','2013-07-07','08:15:00',1.31),('14598','2013-07-07','08:20:00',1.4),('14598','2013-07-07','08:25:00',1.49),('14598','2013-07-07','08:30:00',1.59),('14598','2013-07-07','08:35:00',1.69),('14598','2013-07-07','08:40:00',1.78),('14598','2013-07-07','08:45:00',1.88),('14598','2013-07-07','08:50:00',2.02),('14598','2013-07-07','08:55:00',2.13),('14598','2013-07-07','09:00:00',1.7),('14598','2013-07-07','09:05:00',1.91),('14598','2013-07-07','09:10:00',2.42),('14598','2013-07-07','09:15:00',2.54),('14598','2013-07-07','09:20:00',2.49),('14598','2013-07-07','09:25:00',2.76),('14598','2013-07-07','09:30:00',2.71),('14598','2013-07-07','09:35:00',2.63),('14598','2013-07-07','09:40:00',2.36),('14598','2013-07-07','09:45:00',2.39),('14598','2013-07-07','09:50:00',1.88),('14598','2013-07-07','09:55:00',2.47),('14598','2013-07-07','10:00:00',3.15),('14598','2013-07-07','10:05:00',3.58),('14598','2013-07-07','10:10:00',3.43),('14598','2013-07-07','10:15:00',3.44),('14598','2013-07-07','10:20:00',3.4),('14598','2013-07-07','10:25:00',3.26),('14598','2013-07-07','10:30:00',2.79),('14598','2013-07-07','10:35:00',3.02),('14598','2013-07-07','10:40:00',3.63),('14598','2013-07-07','10:45:00',3.97),('14598','2013-07-07','10:50:00',3.98),('14598','2013-07-07','10:55:00',3.96),('14598','2013-07-07','11:00:00',3.99),('14598','2013-07-07','11:05:00',4.05),('14598','2013-07-07','11:10:00',4.07),('14598','2013-07-07','11:15:00',4.08),('14598','2013-07-07','11:20:00',4.14),('14598','2013-07-07','11:25:00',4.15),('14598','2013-07-07','11:30:00',4.06),('14598','2013-07-07','11:35:00',4.22),('14598','2013-07-07','11:40:00',4.02),('14598','2013-07-07','11:45:00',4.1),('14598','2013-07-07','11:50:00',4.19),('14598','2013-07-07','11:55:00',4.05),('14598','2013-07-07','12:00:00',4.38),('14598','2013-07-07','12:05:00',4.26),('14598','2013-07-07','12:10:00',4.21),('14598','2013-07-07','12:15:00',4.21),('14598','2013-07-07','12:20:00',4.23),('14598','2013-07-07','12:25:00',3.83),('14598','2013-07-07','12:30:00',3.17),('14598','2013-07-07','12:35:00',4.12),('14598','2013-07-07','12:40:00',4.55),('14598','2013-07-07','12:45:00',4.49),('14598','2013-07-07','12:50:00',4.69),('14598','2013-07-07','12:55:00',3.88),('14598','2013-07-07','13:00:00',4.72),('14598','2013-07-07','13:05:00',4.81),('14598','2013-07-07','13:10:00',4.74),('14598','2013-07-07','13:15:00',4.51),('14598','2013-07-07','13:20:00',4.63),('14598','2013-07-07','13:25:00',4.85),('14598','2013-07-07','13:30:00',5.06),('14598','2013-07-07','13:35:00',5.09),('14598','2013-07-07','13:40:00',5.11),('14598','2013-07-07','13:45:00',5.11),('14598','2013-07-07','13:50:00',5.19),('14598','2013-07-07','13:55:00',5.22),('14598','2013-07-07','14:00:00',5.26),('14598','2013-07-07','14:05:00',5.45),('14598','2013-07-07','14:10:00',4.69),('14598','2013-07-07','14:15:00',2.23),('14598','2013-07-07','14:20:00',1.05),('14598','2013-07-07','14:25:00',1.02),('14598','2013-07-07','14:30:00',1.28),('14598','2013-07-07','14:35:00',1.26),('14598','2013-07-07','14:40:00',1.67),('14598','2013-07-07','14:45:00',2.89),('14598','2013-07-07','15:20:00',1.2),('14598','2013-07-07','15:25:00',1.32),('14598','2013-07-07','15:30:00',1.79),('14598','2013-07-07','15:35:00',2.19),('14598','2013-07-07','15:40:00',1.71),('14598','2013-07-07','17:25:00',1.03),('14598','2013-07-07','17:30:00',1.15),('14598','2013-07-07','17:35:00',1.22),('14598','2013-07-07','17:40:00',1.29),('14598','2013-07-07','17:45:00',1.36),('14598','2013-07-07','17:50:00',1.39),('14598','2013-07-07','17:55:00',1.3),('14598','2013-07-07','18:00:00',1.36),('14598','2013-07-07','18:05:00',1.68),('14598','2013-07-07','18:10:00',1.72),('14598','2013-07-07','18:15:00',1.38),('14598','2013-07-06','08:00:00',1.04),('14598','2013-07-06','08:05:00',1.12),('14598','2013-07-06','08:10:00',1.21),('14598','2013-07-06','08:15:00',1.3),('14598','2013-07-06','08:20:00',1.38),('14598','2013-07-06','08:25:00',1.47),('14598','2013-07-06','08:30:00',1.56),('14598','2013-07-06','08:35:00',1.66),('14598','2013-07-06','08:40:00',1.75),('14598','2013-07-06','08:45:00',1.84),('14598','2013-07-06','08:50:00',1.96),('14598','2013-07-06','08:55:00',2.06),('14598','2013-07-06','09:00:00',2.15),('14598','2013-07-06','09:05:00',2.24),('14598','2013-07-06','09:10:00',2.32),('14598','2013-07-06','09:15:00',2.43),('14598','2013-07-06','09:20:00',2.53),('14598','2013-07-06','09:25:00',2.62),('14598','2013-07-06','09:30:00',2.69),('14598','2013-07-06','09:35:00',2.77),('14598','2013-07-06','09:40:00',2.85),('14598','2013-07-06','09:45:00',2.93),('14598','2013-07-06','09:50:00',3),('14598','2013-07-06','09:55:00',3.08),('14598','2013-07-06','10:00:00',3.15),('14598','2013-07-06','10:05:00',3.23),('14598','2013-07-06','10:10:00',3.29),('14598','2013-07-06','10:15:00',3.36),('14598','2013-07-06','10:20:00',3.43),('14598','2013-07-06','10:25:00',3.46),('14598','2013-07-06','10:30:00',3.55),('14598','2013-07-06','10:35:00',3.6),('14598','2013-07-06','10:40:00',3.64),('14598','2013-07-06','10:45:00',3.7),('14598','2013-07-06','10:50:00',3.77),('14598','2013-07-06','10:55:00',3.83),('14598','2013-07-06','11:00:00',3.9),('14598','2013-07-06','11:05:00',3.95),('14598','2013-07-06','11:10:00',3.99),('14598','2013-07-06','11:15:00',4.05),('14598','2013-07-06','11:20:00',4.1),('14598','2013-07-06','11:25:00',4.14),('14598','2013-07-06','11:30:00',4.18),('14598','2013-07-06','11:35:00',4.25),('14598','2013-07-06','11:40:00',4.3),('14598','2013-07-06','11:45:00',4.3),('14598','2013-07-06','11:50:00',4.34),('14598','2013-07-06','11:55:00',4.37),('14598','2013-07-06','12:00:00',4.39),('14598','2013-07-06','12:05:00',4.44),('14598','2013-07-06','12:10:00',4.44),('14598','2013-07-06','12:15:00',4.49),('14598','2013-07-06','12:20:00',4.54),('14598','2013-07-06','12:25:00',4.57),('14598','2013-07-06','12:30:00',4.56),('14598','2013-07-06','12:35:00',4.57),('14598','2013-07-06','12:40:00',4.64),('14598','2013-07-06','12:45:00',4.66),('14598','2013-07-06','12:50:00',4.65),('14598','2013-07-06','12:55:00',4.65),('14598','2013-07-06','13:00:00',4.68),('14598','2013-07-06','13:05:00',4.69),('14598','2013-07-06','13:10:00',4.75),('14598','2013-07-06','13:15:00',4.76),('14598','2013-07-06','13:20:00',4.93),('14598','2013-07-06','13:25:00',5),('14598','2013-07-06','13:30:00',5.33),('14598','2013-07-06','13:35:00',5.42),('14598','2013-07-06','13:40:00',4.28),('14598','2013-07-06','13:45:00',2.81),('14598','2013-07-06','13:50:00',3.02),('14598','2013-07-06','13:55:00',3.16),('14598','2013-07-06','14:00:00',2.85),('14598','2013-07-06','14:05:00',1.48),('14598','2013-07-06','14:10:00',3.91),('14598','2013-07-06','14:15:00',5.33),('14598','2013-07-06','14:20:00',5.24),('14598','2013-07-06','14:25:00',5.01),('14598','2013-07-06','14:30:00',4.96),('14598','2013-07-06','14:35:00',4.95),('14598','2013-07-06','14:40:00',4.91),('14598','2013-07-06','14:45:00',4.9),('14598','2013-07-06','14:50:00',4.89),('14598','2013-07-06','14:55:00',4.86),('14598','2013-07-06','15:00:00',4.86),('14598','2013-07-06','15:05:00',4.88),('14598','2013-07-06','15:10:00',4.95),('14598','2013-07-06','15:15:00',4.72),('14598','2013-07-06','15:20:00',3.7),('14598','2013-07-06','15:25:00',2.14),('14598','2013-07-06','15:30:00',2.19),('14598','2013-07-06','15:35:00',2.4),('14598','2013-07-06','15:40:00',1.65),('14598','2013-07-06','15:45:00',1.43),('14598','2013-07-06','15:50:00',1.3),('14598','2013-07-06','15:55:00',1.29),('14598','2013-07-06','16:00:00',1.39),('14598','2013-07-06','16:05:00',1.52),('14598','2013-07-06','16:10:00',1.53),('14598','2013-07-06','16:15:00',1.48),('14598','2013-07-06','16:20:00',1.51),('14598','2013-07-06','16:25:00',1.58),('14598','2013-07-06','16:30:00',1.57),('14598','2013-07-06','16:35:00',1.58),('14598','2013-07-06','16:40:00',1.66),('14598','2013-07-06','16:45:00',2.85),('14598','2013-07-06','16:50:00',3.85),('14598','2013-07-06','16:55:00',3.61),('14598','2013-07-06','17:00:00',2.86),('14598','2013-07-06','17:05:00',2.28),('14598','2013-07-06','17:10:00',1.7),('14598','2013-07-06','17:15:00',1.55),('14598','2013-07-06','17:20:00',1.44),('14598','2013-07-06','17:25:00',1.42),('14598','2013-07-06','17:30:00',1.04),('14598','2013-07-05','07:55:00',1),('14598','2013-07-05','08:00:00',1.08),('14598','2013-07-05','08:05:00',1.15),('14598','2013-07-05','08:10:00',1.23),('14598','2013-07-05','08:15:00',1.32),('14598','2013-07-05','08:20:00',1.41),('14598','2013-07-05','08:25:00',1.49),('14598','2013-07-05','08:30:00',1.57),('14598','2013-07-05','08:35:00',1.68),('14598','2013-07-05','08:40:00',1.76),('14598','2013-07-05','08:45:00',1.86),('14598','2013-07-05','08:50:00',1.97),('14598','2013-07-05','08:55:00',2.1),('14598','2013-07-05','09:00:00',2.18),('14598','2013-07-05','09:05:00',2.24),('14598','2013-07-05','09:10:00',2.31),('14598','2013-07-05','09:15:00',2.44),('14598','2013-07-05','09:20:00',2.56),('14598','2013-07-05','09:25:00',2.64),('14598','2013-07-05','09:30:00',2.73),('14598','2013-07-05','09:35:00',2.81),('14598','2013-07-05','09:40:00',2.88),('14598','2013-07-05','09:45:00',2.92),('14598','2013-07-05','09:50:00',2.99),('14598','2013-07-05','09:55:00',3.08),('14598','2013-07-05','10:00:00',3.13),('14598','2013-07-05','10:05:00',3.2),('14598','2013-07-05','10:10:00',3.25),('14598','2013-07-05','10:15:00',3.32),('14598','2013-07-05','10:20:00',3.38),('14598','2013-07-05','10:25:00',3.42),('14598','2013-07-05','10:30:00',3.52),('14598','2013-07-05','10:35:00',3.57),('14598','2013-07-05','10:40:00',3.61),('14598','2013-07-05','10:45:00',3.68),('14598','2013-07-05','10:50:00',3.76),('14598','2013-07-05','10:55:00',3.78),('14598','2013-07-05','11:00:00',3.84),('14598','2013-07-05','11:05:00',3.9),('14598','2013-07-05','11:10:00',3.97),('14598','2013-07-05','11:15:00',4.03),('14598','2013-07-05','11:20:00',4.05),('14598','2013-07-05','11:25:00',4.1),('14598','2013-07-05','11:30:00',4.16),('14598','2013-07-05','11:35:00',4.19),('14598','2013-07-05','11:40:00',4.22),('14598','2013-07-05','11:45:00',4.29),('14598','2013-07-05','11:50:00',4.32),('14598','2013-07-05','11:55:00',4.37),('14598','2013-07-05','12:00:00',4.38),('14598','2013-07-05','12:05:00',4.44),('14598','2013-07-05','12:10:00',4.41),('14598','2013-07-05','12:15:00',4.46),('14598','2013-07-05','12:20:00',4.5),('14598','2013-07-05','12:25:00',4.54),('14598','2013-07-05','12:30:00',4.54),('14598','2013-07-05','12:35:00',4.66),('14598','2013-07-05','12:40:00',4.7),('14598','2013-07-05','12:45:00',4.7),('14598','2013-07-05','12:50:00',4.76),('14598','2013-07-05','12:55:00',4.72),('14598','2013-07-05','13:00:00',4.81),('14598','2013-07-05','13:05:00',4.52),('14598','2013-07-05','13:10:00',4.74),('14598','2013-07-05','13:15:00',4.92),('14598','2013-07-05','13:20:00',4.95),('14598','2013-07-05','13:25:00',4.95),('14598','2013-07-05','13:30:00',4.94),('14598','2013-07-05','13:35:00',4.88),('14598','2013-07-05','13:40:00',4.67),('14598','2013-07-05','13:45:00',5.01),('14598','2013-07-05','13:50:00',5),('14598','2013-07-05','13:55:00',5.1),('14598','2013-07-05','14:00:00',5.05),('14598','2013-07-05','14:05:00',5.02),('14598','2013-07-05','14:10:00',4.84),('14598','2013-07-05','14:15:00',4.98),('14598','2013-07-05','14:20:00',4.52),('14598','2013-07-05','14:25:00',4.99),('14598','2013-07-05','14:30:00',5.05),('14598','2013-07-05','14:35:00',4.46),('14598','2013-07-05','14:40:00',4.53),('14598','2013-07-05','14:45:00',2.27),('14598','2013-07-05','14:50:00',2.97),('14598','2013-07-05','14:55:00',5.17),('14598','2013-07-05','15:00:00',4.88),('14598','2013-07-05','15:05:00',4.72),('14598','2013-07-05','15:10:00',4.76),('14598','2013-07-05','15:15:00',4.81),('14598','2013-07-05','15:20:00',4.15),('14598','2013-07-05','15:25:00',4.66),('14598','2013-07-05','15:30:00',4.69),('14598','2013-07-05','15:35:00',4.66),('14598','2013-07-05','15:40:00',4.59),('14598','2013-07-05','15:45:00',4.49),('14598','2013-07-05','15:50:00',4.46),('14598','2013-07-05','15:55:00',4.54),('14598','2013-07-05','16:00:00',3.96),('14598','2013-07-05','16:05:00',4.23),('14598','2013-07-05','16:10:00',4.2),('14598','2013-07-05','16:15:00',4.13),('14598','2013-07-05','16:20:00',4.04),('14598','2013-07-05','16:25:00',4.03),('14598','2013-07-05','16:30:00',3.94),('14598','2013-07-05','16:35:00',3.94),('14598','2013-07-05','16:40:00',4.01),('14598','2013-07-05','16:45:00',3.92),('14598','2013-07-05','16:50:00',3.82),('14598','2013-07-05','16:55:00',3.79),('14598','2013-07-05','17:00:00',3.66),('14598','2013-07-05','17:05:00',3.55),('14598','2013-07-05','17:10:00',3.5),('14598','2013-07-05','17:15:00',3.37),('14598','2013-07-05','17:20:00',2.13),('14598','2013-07-05','17:25:00',3.13),('14598','2013-07-05','17:30:00',2.97),('14598','2013-07-05','17:35:00',2.91),('14598','2013-07-05','17:40:00',2.87),('14598','2013-07-05','17:45:00',2.81),('14598','2013-07-05','17:50:00',2.54),('14598','2013-07-05','17:55:00',2.49),('14598','2013-07-05','18:00:00',1.56),('14598','2013-07-05','18:05:00',2.29),('14598','2013-07-05','18:10:00',2.33),('14598','2013-07-05','18:15:00',2.32),('14598','2013-07-05','18:20:00',2.28),('14598','2013-07-05','18:25:00',2.14),('14598','2013-07-05','18:30:00',1.92),('14598','2013-07-05','18:35:00',1.86),('14598','2013-07-05','18:40:00',1.75),('14598','2013-07-05','18:45:00',1.64),('14598','2013-07-05','18:50:00',1.53),('14598','2013-07-05','18:55:00',1.47),('14598','2013-07-05','19:00:00',1.43),('14598','2013-07-05','19:05:00',1.31),('14598','2013-07-05','19:10:00',1.24),('14598','2013-07-05','19:15:00',1.15),('14598','2013-07-04','10:30:00',1.2),('14598','2013-07-04','10:35:00',1.31),('14598','2013-07-04','10:40:00',1.49),('14598','2013-07-04','10:45:00',1.66),('14598','2013-07-04','10:50:00',1.57),('14598','2013-07-04','10:55:00',1.49),('14598','2013-07-04','11:00:00',1.41),('14598','2013-07-04','11:05:00',1.41),('14598','2013-07-04','11:10:00',1.54),('14598','2013-07-04','11:15:00',1.78),('14598','2013-07-04','11:20:00',2.04),('14598','2013-07-04','11:25:00',2.3),('14598','2013-07-04','11:30:00',2.4),('14598','2013-07-04','11:35:00',2.03),('14598','2013-07-04','11:40:00',1.92),('14598','2013-07-04','11:45:00',2.1),('14598','2013-07-04','11:50:00',2.4),('14598','2013-07-04','11:55:00',2.42),('14598','2013-07-04','12:00:00',2.46),('14598','2013-07-04','12:05:00',2.55),('14598','2013-07-04','12:10:00',2.57),('14598','2013-07-04','12:15:00',2.54),('14598','2013-07-04','12:20:00',2.48),('14598','2013-07-04','12:25:00',2.33),('14598','2013-07-04','12:30:00',2.32),('14598','2013-07-04','12:35:00',2.39),('14598','2013-07-04','12:40:00',4.03),('14598','2013-07-04','12:45:00',4.77),('14598','2013-07-04','12:50:00',3.38),('14598','2013-07-04','12:55:00',4.79),('14598','2013-07-04','13:00:00',4.42),('14598','2013-07-04','13:05:00',4.06),('14598','2013-07-04','13:10:00',4.28),('14598','2013-07-04','13:15:00',4.26),('14598','2013-07-04','13:20:00',4.62),('14598','2013-07-04','13:25:00',3.25),('14598','2013-07-04','13:30:00',2.64),('14598','2013-07-04','13:35:00',4.05),('14598','2013-07-04','13:40:00',5.45),('14598','2013-07-04','13:45:00',4.18),('14598','2013-07-04','13:50:00',3.01),('14598','2013-07-04','13:55:00',4.24),('14598','2013-07-04','14:00:00',5.15),('14598','2013-07-04','14:05:00',5.18),('14598','2013-07-04','14:10:00',3.92),('14598','2013-07-04','14:15:00',5.18),('14598','2013-07-04','14:20:00',5.4),('14598','2013-07-04','14:25:00',5.26),('14598','2013-07-04','14:30:00',5.16),('14598','2013-07-04','14:35:00',5.14),('14598','2013-07-04','14:40:00',5.2),('14598','2013-07-04','14:45:00',5.23),('14598','2013-07-04','14:50:00',5.15),('14598','2013-07-04','14:55:00',5.3),('14598','2013-07-04','15:00:00',4.57),('14598','2013-07-04','15:05:00',5.28),('14598','2013-07-04','15:10:00',5.07),('14598','2013-07-04','15:15:00',4.09),('14598','2013-07-04','15:20:00',3.48),('14598','2013-07-04','15:25:00',3.45),('14598','2013-07-04','15:30:00',2.24),('14598','2013-07-04','15:35:00',3.79),('14598','2013-07-04','15:40:00',2.9),('14598','2013-07-04','15:45:00',2.96),('14598','2013-07-04','15:50:00',3.1),('14598','2013-07-04','15:55:00',2.65),('14598','2013-07-04','16:00:00',2.43),('14598','2013-07-04','16:05:00',2.22),('14598','2013-07-04','16:10:00',2.15),('14598','2013-07-04','16:15:00',2.25),('14598','2013-07-04','16:20:00',2.73),('14598','2013-07-04','16:25:00',3.71),('14598','2013-07-04','16:30:00',2.49),('14598','2013-07-04','16:35:00',2.4),('14598','2013-07-04','16:40:00',2.15),('14598','2013-07-04','16:45:00',1.89),('14598','2013-07-04','16:50:00',1.64),('14598','2013-07-04','16:55:00',2.04),('14598','2013-07-04','17:00:00',2.31),('14598','2013-07-04','17:05:00',2.2),('14598','2013-07-04','17:10:00',1.45),('14598','2013-07-04','17:15:00',1.28),('14598','2013-07-04','17:20:00',1.39),('14598','2013-07-04','17:25:00',1.59),('14598','2013-07-04','17:30:00',2.52),('14598','2013-07-04','17:35:00',2.54),('14598','2013-07-04','17:40:00',1.64),('14598','2013-07-04','17:45:00',1.75),('14598','2013-07-04','17:50:00',1.57),('14598','2013-07-04','17:55:00',1.79),('14598','2013-07-04','18:00:00',2.69),('14598','2013-07-04','18:05:00',2.27),('14598','2013-07-04','18:10:00',1.45),('14598','2013-07-04','18:15:00',1),('14598','2013-07-04','18:20:00',1.21),('14598','2013-07-04','18:25:00',1.42),('14598','2013-07-04','18:35:00',1.34),('14598','2013-07-04','18:40:00',1),('14598','2013-07-03','07:55:00',1.03),('14598','2013-07-03','08:00:00',1.11),('14598','2013-07-03','08:05:00',1.2),('14598','2013-07-03','08:10:00',1.28),('14598','2013-07-03','08:15:00',1.36),('14598','2013-07-03','08:20:00',1.45),('14598','2013-07-03','08:25:00',1.53),('14598','2013-07-03','08:30:00',1.63),('14598','2013-07-03','08:35:00',1.76),('14598','2013-07-03','08:40:00',1.84),('14598','2013-07-03','08:45:00',1.92),('14598','2013-07-03','08:50:00',2.04),('14598','2013-07-03','08:55:00',2.12),('14598','2013-07-03','09:00:00',2.15),('14598','2013-07-03','09:05:00',2.17),('14598','2013-07-03','09:10:00',2.33),('14598','2013-07-03','09:15:00',2.57),('14598','2013-07-03','09:20:00',2.6),('14598','2013-07-03','09:25:00',2.74),('14598','2013-07-03','09:30:00',2.84),('14598','2013-07-03','09:35:00',2.93),('14598','2013-07-03','09:40:00',2.95),('14598','2013-07-03','09:45:00',3.11),('14598','2013-07-03','09:50:00',3.19),('14598','2013-07-03','09:55:00',3.28),('14598','2013-07-03','10:00:00',3.36),('14598','2013-07-03','10:05:00',3.44),('14598','2013-07-03','10:10:00',3.51),('14598','2013-07-03','10:15:00',3.58),('14598','2013-07-03','10:20:00',3.67),('14598','2013-07-03','10:25:00',3.73),('14598','2013-07-03','10:30:00',3.8),('14598','2013-07-03','10:35:00',3.88),('14598','2013-07-03','10:40:00',3.95),('14598','2013-07-03','10:45:00',4.01),('14598','2013-07-03','10:50:00',4.07),('14598','2013-07-03','10:55:00',4.07),('14598','2013-07-03','11:00:00',4.19),('14598','2013-07-03','11:05:00',4.25),('14598','2013-07-03','11:10:00',4.3),('14598','2013-07-03','11:15:00',4.36),('14598','2013-07-03','11:20:00',4.41),('14598','2013-07-03','11:25:00',4.45),('14598','2013-07-03','11:30:00',4.5),('14598','2013-07-03','11:35:00',4.57),('14598','2013-07-03','11:40:00',4.63),('14598','2013-07-03','11:45:00',4.66),('14598','2013-07-03','11:50:00',4.69),('14598','2013-07-03','11:55:00',4.74),('14598','2013-07-03','12:00:00',4.76),('14598','2013-07-03','12:05:00',4.81),('14598','2013-07-03','12:10:00',4.86),('14598','2013-07-03','12:15:00',4.86),('14598','2013-07-03','12:20:00',4.89),('14598','2013-07-03','12:25:00',4.92),('14598','2013-07-03','12:30:00',4.95),('14598','2013-07-03','12:35:00',4.96),('14598','2013-07-03','12:40:00',4.99),('14598','2013-07-03','12:45:00',5.03),('14598','2013-07-03','12:50:00',5.05),('14598','2013-07-03','12:55:00',5.08),('14598','2013-07-03','13:00:00',5.09),('14598','2013-07-03','13:05:00',5.11),('14598','2013-07-03','13:10:00',5.11),('14598','2013-07-03','13:15:00',5.11),('14598','2013-07-03','13:20:00',5.13),('14598','2013-07-03','13:25:00',5.12),('14598','2013-07-03','13:30:00',5.14),('14598','2013-07-03','13:35:00',5.14),('14598','2013-07-03','13:40:00',5.13),('14598','2013-07-03','13:45:00',5.16),('14598','2013-07-03','13:50:00',5.15),('14598','2013-07-03','13:55:00',5.1),('14598','2013-07-03','14:00:00',5.15),('14598','2013-07-03','14:05:00',5.16),('14598','2013-07-03','14:10:00',5.14),('14598','2013-07-03','14:15:00',5.13),('14598','2013-07-03','14:20:00',5.13),('14598','2013-07-03','14:25:00',5.12),('14598','2013-07-03','14:30:00',5.1),('14598','2013-07-03','14:35:00',5.09),('14598','2013-07-03','14:40:00',5.08),('14598','2013-07-03','14:45:00',5.04),('14598','2013-07-03','14:50:00',5.02),('14598','2013-07-03','14:55:00',4.96),('14598','2013-07-03','15:00:00',4.96),('14598','2013-07-03','15:05:00',4.97),('14598','2013-07-03','15:10:00',4.92),('14598','2013-07-03','15:15:00',4.88),('14598','2013-07-03','15:20:00',4.85),('14598','2013-07-03','15:25:00',4.8),('14598','2013-07-03','15:30:00',4.79),('14598','2013-07-03','15:35:00',4.76),('14598','2013-07-03','15:40:00',4.69),('14598','2013-07-03','15:45:00',4.68),('14598','2013-07-03','15:50:00',4.64),('14598','2013-07-03','15:55:00',4.58),('14598','2013-07-03','16:00:00',4.54),('14598','2013-07-03','16:05:00',4.5),('14598','2013-07-03','16:10:00',4.44),('14598','2013-07-03','16:15:00',4.39),('14598','2013-07-03','16:20:00',4.34),('14598','2013-07-03','16:25:00',4.27),('14598','2013-07-03','16:30:00',4.2),('14598','2013-07-03','16:35:00',4.16),('14598','2013-07-03','16:40:00',4.09),('14598','2013-07-03','16:45:00',4.02),('14598','2013-07-03','16:50:00',3.96),('14598','2013-07-03','16:55:00',3.88),('14598','2013-07-03','17:00:00',3.84),('14598','2013-07-03','17:05:00',3.76),('14598','2013-07-03','17:10:00',3.68),('14598','2013-07-03','17:15:00',3.62),('14598','2013-07-03','17:20:00',3.55),('14598','2013-07-03','17:25:00',3.46),('14598','2013-07-03','17:30:00',3.39),('14598','2013-07-03','17:35:00',3.31),('14598','2013-07-03','17:40:00',3.22),('14598','2013-07-03','17:45:00',3.13),('14598','2013-07-03','17:50:00',3.05),('14598','2013-07-03','17:55:00',2.96),('14598','2013-07-03','18:00:00',2.86),('14598','2013-07-03','18:05:00',2.77),('14598','2013-07-03','18:10:00',2.67),('14598','2013-07-03','18:15:00',2.57),('14598','2013-07-03','18:20:00',2.47),('14598','2013-07-03','18:25:00',2.38),('14598','2013-07-03','18:30:00',2.27),('14598','2013-07-03','18:35:00',2.17),('14598','2013-07-03','18:40:00',2.05),('14598','2013-07-03','18:45:00',1.9),('14598','2013-07-03','18:50:00',1.83),('14598','2013-07-03','18:55:00',1.73),('14598','2013-07-03','19:00:00',1.63),('14598','2013-07-03','19:05:00',1.53),('14598','2013-07-03','19:10:00',1.42),('14598','2013-07-03','19:15:00',1.32),('14598','2013-07-03','19:20:00',1.24),('14598','2013-07-03','19:25:00',1.14),('14598','2013-07-03','19:30:00',1.03),('14598','2013-07-02','07:55:00',1.01),('14598','2013-07-02','08:00:00',1.09),('14598','2013-07-02','08:05:00',1.17),('14598','2013-07-02','08:10:00',1.26),('14598','2013-07-02','08:15:00',1.34),('14598','2013-07-02','08:20:00',1.43),('14598','2013-07-02','08:25:00',1.52),('14598','2013-07-02','08:30:00',1.61),('14598','2013-07-02','08:35:00',1.72),('14598','2013-07-02','08:40:00',1.8),('14598','2013-07-02','08:45:00',1.88),('14598','2013-07-02','08:50:00',2.01),('14598','2013-07-02','08:55:00',2.12),('14598','2013-07-02','09:00:00',2.22),('14598','2013-07-02','09:05:00',2.3),('14598','2013-07-02','09:10:00',2.39),('14598','2013-07-02','09:15:00',2.47),('14598','2013-07-02','09:20:00',2.58),('14598','2013-07-02','09:25:00',2.67),('14598','2013-07-02','09:30:00',2.76),('14598','2013-07-02','09:35:00',2.83),('14598','2013-07-02','09:40:00',2.89),('14598','2013-07-02','09:45:00',2.96),('14598','2013-07-02','09:50:00',3.01),('14598','2013-07-02','09:55:00',3.07),('14598','2013-07-02','10:00:00',3.14),('14598','2013-07-02','10:05:00',3.25),('14598','2013-07-02','10:10:00',3.35),('14598','2013-07-02','10:15:00',3.43),('14598','2013-07-02','10:20:00',3.52),('14598','2013-07-02','10:25:00',3.59),('14598','2013-07-02','10:30:00',3.67),('14598','2013-07-02','10:35:00',3.76),('14598','2013-07-02','10:40:00',3.81),('14598','2013-07-02','10:45:00',3.88),('14598','2013-07-02','10:50:00',3.94),('14598','2013-07-02','10:55:00',3.95),('14598','2013-07-02','11:00:00',4.05),('14598','2013-07-02','11:05:00',4.12),('14598','2013-07-02','11:10:00',4.18),('14598','2013-07-02','11:15:00',4.22),('14598','2013-07-02','11:20:00',4.29),('14598','2013-07-02','11:25:00',4.34),('14598','2013-07-02','11:30:00',4.41),('14598','2013-07-02','11:35:00',4.48),('14598','2013-07-02','11:40:00',4.54),('14598','2013-07-02','11:45:00',4.57),('14598','2013-07-02','11:50:00',4.62),('14598','2013-07-02','11:55:00',4.66),('14598','2013-07-02','12:00:00',4.71),('14598','2013-07-02','12:05:00',4.73),('14598','2013-07-02','12:10:00',4.73),('14598','2013-07-02','12:15:00',4.8),('14598','2013-07-02','12:20:00',4.83),('14598','2013-07-02','12:25:00',4.87),('14598','2013-07-02','12:30:00',4.91),('14598','2013-07-02','12:35:00',4.93),('14598','2013-07-02','12:40:00',4.95),('14598','2013-07-02','12:45:00',5),('14598','2013-07-02','12:50:00',5),('14598','2013-07-02','12:55:00',5.02),('14598','2013-07-02','13:00:00',5.05),('14598','2013-07-02','13:05:00',5.05),('14598','2013-07-02','13:10:00',5.09),('14598','2013-07-02','13:15:00',5.08),('14598','2013-07-02','13:20:00',5.08),('14598','2013-07-02','13:25:00',5.09),('14598','2013-07-02','13:30:00',5.1),('14598','2013-07-02','13:35:00',5.09),('14598','2013-07-02','13:40:00',5.1),('14598','2013-07-02','13:45:00',5.11),('14598','2013-07-02','13:50:00',5.1),('14598','2013-07-02','13:55:00',5.02),('14598','2013-07-02','14:00:00',5.1),('14598','2013-07-02','14:05:00',5.1),('14598','2013-07-02','14:10:00',5.1),('14598','2013-07-02','14:15:00',5.1),('14598','2013-07-02','14:20:00',5.09),('14598','2013-07-02','14:25:00',5.08),('14598','2013-07-02','14:30:00',5.06),('14598','2013-07-02','14:35:00',5.05),('14598','2013-07-02','14:40:00',5.03),('14598','2013-07-02','14:45:00',4.99),('14598','2013-07-02','14:50:00',4.97),('14598','2013-07-02','14:55:00',4.94),('14598','2013-07-02','15:00:00',4.92),('14598','2013-07-02','15:05:00',4.88),('14598','2013-07-02','15:10:00',4.86),('14598','2013-07-02','15:15:00',4.85),('14598','2013-07-02','15:20:00',4.81),('14598','2013-07-02','15:25:00',4.75),('14598','2013-07-02','15:30:00',4.71),('14598','2013-07-02','15:35:00',4.67),('14598','2013-07-02','15:40:00',4.62),('14598','2013-07-02','15:45:00',4.59),('14598','2013-07-02','15:50:00',4.55),('14598','2013-07-02','15:55:00',4.5),('14598','2013-07-02','16:00:00',4.44),('14598','2013-07-02','16:05:00',4.39),('14598','2013-07-02','16:10:00',4.34),('14598','2013-07-02','16:15:00',4.29),('14598','2013-07-02','16:20:00',4.22),('14598','2013-07-02','16:25:00',4.15),('14598','2013-07-02','16:30:00',4.09),('14598','2013-07-02','16:35:00',4.03),('14598','2013-07-02','16:40:00',3.97),('14598','2013-07-02','16:45:00',3.91),('14598','2013-07-02','16:50:00',3.84),('14598','2013-07-02','16:55:00',3.72),('14598','2013-07-02','17:00:00',3.72),('14598','2013-07-02','17:05:00',3.65),('14598','2013-07-02','17:10:00',3.57),('14598','2013-07-02','17:15:00',3.5),('14598','2013-07-02','17:20:00',3.42),('14598','2013-07-02','17:25:00',3.35),('14598','2013-07-02','17:30:00',3.26),('14598','2013-07-02','17:35:00',3.17),('14598','2013-07-02','17:40:00',3.09),('14598','2013-07-02','17:45:00',3),('14598','2013-07-02','17:50:00',2.9),('14598','2013-07-02','17:55:00',2.81),('14598','2013-07-02','18:00:00',2.73),('14598','2013-07-02','18:05:00',2.63),('14598','2013-07-02','18:10:00',2.54),('14598','2013-07-02','18:15:00',2.46),('14598','2013-07-02','18:20:00',2.37),('14598','2013-07-02','18:25:00',2.26),('14598','2013-07-02','18:30:00',2.16),('14598','2013-07-02','18:35:00',2.05),('14598','2013-07-02','18:40:00',1.96),('14598','2013-07-02','18:45:00',1.87),('14598','2013-07-02','18:50:00',1.77),('14598','2013-07-02','18:55:00',1.67),('14598','2013-07-02','19:00:00',1.57),('14598','2013-07-02','19:05:00',1.47),('14598','2013-07-02','19:10:00',1.37),('14598','2013-07-02','19:15:00',1.27),('14598','2013-07-02','19:20:00',1.16),('14598','2013-07-02','19:25:00',1.04),('14598','2013-07-01','07:55:00',1.05),('14598','2013-07-01','08:00:00',1.13),('14598','2013-07-01','08:05:00',1.21),('14598','2013-07-01','08:10:00',1.29),('14598','2013-07-01','08:15:00',1.37),('14598','2013-07-01','08:20:00',1.47),('14598','2013-07-01','08:25:00',1.56),('14598','2013-07-01','08:30:00',1.65),('14598','2013-07-01','08:35:00',1.76),('14598','2013-07-01','08:40:00',1.84),('14598','2013-07-01','08:45:00',1.96),('14598','2013-07-01','08:50:00',2.09),('14598','2013-07-01','08:55:00',2.19),('14598','2013-07-01','09:00:00',2.25),('14598','2013-07-01','09:05:00',2.32),('14598','2013-07-01','09:10:00',2.44),('14598','2013-07-01','09:15:00',2.54),('14598','2013-07-01','09:20:00',2.65),('14598','2013-07-01','09:25:00',2.74),('14598','2013-07-01','09:30:00',2.81),('14598','2013-07-01','09:35:00',2.89),('14598','2013-07-01','09:40:00',2.97),('14598','2013-07-01','09:45:00',3.03),('14598','2013-07-01','09:50:00',3.11),('14598','2013-07-01','09:55:00',3.14),('14598','2013-07-01','10:00:00',3.25),('14598','2013-07-01','10:05:00',3.32),('14598','2013-07-01','10:10:00',3.39),('14598','2013-07-01','10:15:00',3.46),('14598','2013-07-01','10:20:00',3.52),('14598','2013-07-01','10:25:00',3.59),('14598','2013-07-01','10:30:00',3.64),('14598','2013-07-01','10:35:00',3.73),('14598','2013-07-01','10:40:00',3.84),('14598','2013-07-01','10:45:00',3.92),('14598','2013-07-01','10:50:00',4),('14598','2013-07-01','10:55:00',4.08),('14598','2013-07-01','11:00:00',4.14),('14598','2013-07-01','11:05:00',4.21),('14598','2013-07-01','11:10:00',4.23),('14598','2013-07-01','11:15:00',4.28),('14598','2013-07-01','11:20:00',4.35),('14598','2013-07-01','11:25:00',4.41),('14598','2013-07-01','11:30:00',4.47),('14598','2013-07-01','11:35:00',4.52),('14598','2013-07-01','11:40:00',4.52),('14598','2013-07-01','11:45:00',4.58),('14598','2013-07-01','11:50:00',4.63),('14598','2013-07-01','11:55:00',4.65),('14598','2013-07-01','12:00:00',4.69),('14598','2013-07-01','12:05:00',4.72),('14598','2013-07-01','12:10:00',4.77),('14598','2013-07-01','12:15:00',4.81),('14598','2013-07-01','12:20:00',4.85),('14598','2013-07-01','12:25:00',4.89),('14598','2013-07-01','12:30:00',4.91),('14598','2013-07-01','12:35:00',4.94),('14598','2013-07-01','12:40:00',4.98),('14598','2013-07-01','12:45:00',4.97),('14598','2013-07-01','12:50:00',5.01),('14598','2013-07-01','12:55:00',4.95),('14598','2013-07-01','13:00:00',5.05),('14598','2013-07-01','13:05:00',5.08),('14598','2013-07-01','13:10:00',5.1),('14598','2013-07-01','13:15:00',5.11),('14598','2013-07-01','13:20:00',5.12),('14598','2013-07-01','13:25:00',5.12),('14598','2013-07-01','13:30:00',5.12),('14598','2013-07-01','13:35:00',5.11),('14598','2013-07-01','13:40:00',5.14),('14598','2013-07-01','13:45:00',5.18),('14598','2013-07-01','13:50:00',5.16),('14598','2013-07-01','13:55:00',5.13),('14598','2013-07-01','14:00:00',5.01),('14598','2013-07-01','14:05:00',5.13),('14598','2013-07-01','14:10:00',5.11),('14598','2013-07-01','14:15:00',5.09),('14598','2013-07-01','14:20:00',5.11),('14598','2013-07-01','14:25:00',5.06),('14598','2013-07-01','14:30:00',5.07),('14598','2013-07-01','14:35:00',5.05),('14598','2013-07-01','14:40:00',4.97),('14598','2013-07-01','14:45:00',4.96),('14598','2013-07-01','14:50:00',4.95),('14598','2013-07-01','14:55:00',4.95),('14598','2013-07-01','15:00:00',4.88),('14598','2013-07-01','15:05:00',4.87),('14598','2013-07-01','15:10:00',4.83),('14598','2013-07-01','15:15:00',4.77),('14598','2013-07-01','15:20:00',4.76),('14598','2013-07-01','15:25:00',4.72),('14598','2013-07-01','15:30:00',4.7),('14598','2013-07-01','15:35:00',4.65),('14598','2013-07-01','15:40:00',4.58),('14598','2013-07-01','15:45:00',4.58),('14598','2013-07-01','15:50:00',4.48),('14598','2013-07-01','15:55:00',4.39),('14598','2013-07-01','16:00:00',4.45),('14598','2013-07-01','16:05:00',4.36),('14598','2013-07-01','16:10:00',4.32),('14598','2013-07-01','16:15:00',4.26),('14598','2013-07-01','16:20:00',4.19),('14598','2013-07-01','16:25:00',4.13),('14598','2013-07-01','16:30:00',4.07),('14598','2013-07-01','16:35:00',4.01),('14598','2013-07-01','16:40:00',3.95),('14598','2013-07-01','16:45:00',3.88),('14598','2013-07-01','16:50:00',3.81),('14598','2013-07-01','16:55:00',3.74),('14598','2013-07-01','17:00:00',3.66),('14598','2013-07-01','17:05:00',3.6),('14598','2013-07-01','17:10:00',3.52),('14598','2013-07-01','17:15:00',3.43),('14598','2013-07-01','17:20:00',3.35),('14598','2013-07-01','17:25:00',3.27),('14598','2013-07-01','17:30:00',3.18),('14598','2013-07-01','17:35:00',3.09),('14598','2013-07-01','17:40:00',3.01),('14598','2013-07-01','17:45:00',2.91),('14598','2013-07-01','17:50:00',2.86),('14598','2013-07-01','17:55:00',2.72),('14598','2013-07-01','18:00:00',2.53),('14598','2013-07-01','18:05:00',2.53),('14598','2013-07-01','18:10:00',2.54),('14598','2013-07-01','18:15:00',2.43),('14598','2013-07-01','18:20:00',2.19),('14598','2013-07-01','18:25:00',1.96),('14598','2013-07-01','18:30:00',2.06),('14598','2013-07-01','18:35:00',1.84),('14598','2013-07-01','18:40:00',1.82),('14598','2013-07-01','18:45:00',1.71),('14598','2013-07-01','18:50:00',1.67),('14598','2013-07-01','18:55:00',1.43),('14598','2013-07-01','19:00:00',1.38),('14598','2013-07-01','19:05:00',1.34),('14598','2013-07-01','19:10:00',1.03),('14598','2013-07-01','19:20:00',1.02),('14598','2014-04-05','08:55:00',1.07),('14598','2014-04-05','09:00:00',1.12),('14598','2014-04-05','09:05:00',1.44),('14598','2014-04-05','09:10:00',1.78),('14598','2014-04-05','09:15:00',1.95),('14598','2014-04-05','09:20:00',2.21),('14598','2014-04-05','09:25:00',2.22),('14598','2014-04-05','09:30:00',2.05),('14598','2014-04-05','09:35:00',1.93),('14598','2014-04-05','09:40:00',2.07),('14598','2014-04-05','09:45:00',2.23),('14598','2014-04-05','09:50:00',3.16),('14598','2014-04-05','09:55:00',3.05),('14598','2014-04-05','10:00:00',3.06),('14598','2014-04-05','10:05:00',3.32),('14598','2014-04-05','10:10:00',4.18),('14598','2014-04-05','10:15:00',3.33),('14598','2014-04-05','10:20:00',4.07),('14598','2014-04-05','10:25:00',2.92),('14598','2014-04-05','10:30:00',2.33),('14598','2014-04-05','10:35:00',2.37),('14598','2014-04-05','10:40:00',2.51),('14598','2014-04-05','10:45:00',2.65),('14598','2014-04-05','10:50:00',2.84),('14598','2014-04-05','10:55:00',2.78),('14598','2014-04-05','11:00:00',4.57),('14598','2014-04-05','11:05:00',4.46),('14598','2014-04-05','11:10:00',4.44),('14598','2014-04-05','11:15:00',4.35),('14598','2014-04-05','11:20:00',4.42),('14598','2014-04-05','11:25:00',4.52),('14598','2014-04-05','11:30:00',3.54),('14598','2014-04-05','11:35:00',3.93),('14598','2014-04-05','11:40:00',4.11),('14598','2014-04-05','11:45:00',3.75),('14598','2014-04-05','11:50:00',4),('14598','2014-04-05','11:55:00',3.36),('14598','2014-04-05','12:00:00',3.58),('14598','2014-04-05','12:05:00',4.02),('14598','2014-04-05','12:10:00',4.13),('14598','2014-04-05','12:15:00',3.7),('14598','2014-04-05','12:20:00',3.21),('14598','2014-04-05','12:25:00',3.21),('14598','2014-04-05','12:30:00',3),('14598','2014-04-05','12:35:00',2.87),('14598','2014-04-05','12:40:00',3.57),('14598','2014-04-05','12:45:00',3.52),('14598','2014-04-05','12:50:00',3.28),('14598','2014-04-05','12:55:00',3.21),('14598','2014-04-05','13:00:00',2.99),('14598','2014-04-05','13:05:00',3),('14598','2014-04-05','13:10:00',2.57),('14598','2014-04-05','13:15:00',2.55),('14598','2014-04-05','13:20:00',2.95),('14598','2014-04-05','13:25:00',3.66),('14598','2014-04-05','13:30:00',4.24),('14598','2014-04-05','13:35:00',4.58),('14598','2014-04-05','13:40:00',4.7),('14598','2014-04-05','13:45:00',4.65),('14598','2014-04-05','13:50:00',5.14),('14598','2014-04-05','13:55:00',5.18),('14598','2014-04-05','14:00:00',5.34),('14598','2014-04-05','14:05:00',5.35),('14598','2014-04-05','14:10:00',5.38),('14598','2014-04-05','14:15:00',4.92),('14598','2014-04-05','14:20:00',3.99),('14598','2014-04-05','14:25:00',2.99),('14598','2014-04-05','14:30:00',1.59),('14598','2014-04-05','14:35:00',1.66),('14598','2014-04-05','14:40:00',1.32),('14598','2014-04-05','14:45:00',3.37),('14598','2014-04-05','14:50:00',3.8),('14598','2014-04-05','14:55:00',4.17),('14598','2014-04-05','15:00:00',4.51),('14598','2014-04-05','15:05:00',1.99),('14598','2014-04-05','15:10:00',1.58),('14598','2014-04-05','15:15:00',1.97),('14598','2014-04-05','15:20:00',3.02),('14598','2014-04-05','15:25:00',3.01),('14598','2014-04-05','15:30:00',3.62),('14598','2014-04-05','15:35:00',1.89),('14598','2014-04-05','15:40:00',1.29),('14598','2014-04-05','15:45:00',1.41),('14598','2014-04-05','15:50:00',3.49),('14598','2014-04-05','15:55:00',3.77),('14598','2014-04-05','16:00:00',4.24),('14598','2014-04-05','16:05:00',4.67),('14598','2014-04-05','16:10:00',4.73),('14598','2014-04-05','16:15:00',2.45),('14598','2014-04-05','16:20:00',2.17),('14598','2014-04-05','16:25:00',2.38),('14598','2014-04-05','16:30:00',1.58),('14598','2014-04-05','17:00:00',1.04),('14598','2014-04-05','17:05:00',1.39),('14598','2014-04-05','17:10:00',1.07),('14598','2014-04-05','17:15:00',2.77),('14598','2014-04-05','17:20:00',2),('14598','2013-06-30','07:55:00',1.06),('14598','2013-06-30','08:00:00',1.14),('14598','2013-06-30','08:05:00',1.23),('14598','2013-06-30','08:10:00',1.33),('14598','2013-06-30','08:15:00',1.42),('14598','2013-06-30','08:20:00',1.52),('14598','2013-06-30','08:25:00',1.61),('14598','2013-06-30','08:30:00',1.69),('14598','2013-06-30','08:35:00',1.81),('14598','2013-06-30','08:40:00',1.89),('14598','2013-06-30','08:45:00',1.99),('14598','2013-06-30','08:50:00',2.12),('14598','2013-06-30','08:55:00',2.23),('14598','2013-06-30','09:00:00',2.33),('14598','2013-06-30','09:05:00',2.42),('14598','2013-06-30','09:10:00',2.51),('14598','2013-06-30','09:15:00',2.6),('14598','2013-06-30','09:20:00',2.66),('14598','2013-06-30','09:25:00',2.82),('14598','2013-06-30','09:30:00',2.91),('14598','2013-06-30','09:35:00',3),('14598','2013-06-30','09:40:00',3.07),('14598','2013-06-30','09:45:00',3.16),('14598','2013-06-30','09:50:00',3.23),('14598','2013-06-30','09:55:00',3.31),('14598','2013-06-30','10:00:00',3.38),('14598','2013-06-30','10:05:00',3.45),('14598','2013-06-30','10:10:00',3.52),('14598','2013-06-30','10:15:00',3.57),('14598','2013-06-30','10:20:00',3.64),('14598','2013-06-30','10:25:00',3.69),('14598','2013-06-30','10:30:00',3.77),('14598','2013-06-30','10:35:00',3.83),('14598','2013-06-30','10:40:00',3.85),('14598','2013-06-30','10:45:00',3.95),('14598','2013-06-30','10:50:00',4.05),('14598','2013-06-30','10:55:00',4.12),('14598','2013-06-30','11:00:00',4.21),('14598','2013-06-30','11:05:00',4.27),('14598','2013-06-30','11:10:00',4.29),('14598','2013-06-30','11:15:00',4.35),('14598','2013-06-30','11:20:00',4.44),('14598','2013-06-30','11:25:00',4.46),('14598','2013-06-30','11:30:00',4.51),('14598','2013-06-30','11:35:00',4.57),('14598','2013-06-30','11:40:00',4.59),('14598','2013-06-30','11:45:00',4.66),('14598','2013-06-30','11:50:00',4.71),('14598','2013-06-30','11:55:00',4.8),('14598','2013-06-30','12:00:00',4.82),('14598','2013-06-30','12:05:00',4.86),('14598','2013-06-30','12:10:00',4.88),('14598','2013-06-30','12:15:00',4.9),('14598','2013-06-30','12:20:00',4.91),('14598','2013-06-30','12:25:00',4.86),('14598','2013-06-30','12:30:00',4.91),('14598','2013-06-30','12:35:00',4.97),('14598','2013-06-30','12:40:00',4.99),('14598','2013-06-30','12:45:00',5.03),('14598','2013-06-30','12:50:00',5.08),('14598','2013-06-30','12:55:00',5.13),('14598','2013-06-30','13:00:00',5.13),('14598','2013-06-30','13:05:00',5.14),('14598','2013-06-30','13:10:00',5.12),('14598','2013-06-30','13:15:00',5.12),('14598','2013-06-30','13:20:00',5.17),('14598','2013-06-30','13:25:00',5.17),('14598','2013-06-30','13:30:00',5.16),('14598','2013-06-30','13:35:00',5.16),('14598','2013-06-30','13:40:00',5.15),('14598','2013-06-30','13:45:00',5.16),('14598','2013-06-30','13:50:00',5.15),('14598','2013-06-30','13:55:00',5.18),('14598','2013-06-30','14:00:00',5.18),('14598','2013-06-30','14:05:00',5.17),('14598','2013-06-30','14:10:00',5.16),('14598','2013-06-30','14:15:00',5.09),('14598','2013-06-30','14:20:00',5.06),('14598','2013-06-30','14:25:00',5.07),('14598','2013-06-30','14:30:00',5.08),('14598','2013-06-30','14:35:00',5.09),('14598','2013-06-30','14:40:00',5.07),('14598','2013-06-30','14:45:00',5.05),('14598','2013-06-30','14:50:00',5),('14598','2013-06-30','14:55:00',4.99),('14598','2013-06-30','15:00:00',4.96),('14598','2013-06-30','15:05:00',4.93),('14598','2013-06-30','15:10:00',4.89),('14598','2013-06-30','15:15:00',4.86),('14598','2013-06-30','15:20:00',4.82),('14598','2013-06-30','15:25:00',4.77),('14598','2013-06-30','15:30:00',4.73),('14598','2013-06-30','15:35:00',4.7),('14598','2013-06-30','15:40:00',4.66),('14598','2013-06-30','15:45:00',4.63),('14598','2013-06-30','15:50:00',4.59),('14598','2013-06-30','15:55:00',4.56),('14598','2013-06-30','16:00:00',4.5),('14598','2013-06-30','16:05:00',4.44),('14598','2013-06-30','16:10:00',4.41),('14598','2013-06-30','16:15:00',4.32),('14598','2013-06-30','16:20:00',4.34),('14598','2013-06-30','16:25:00',4.31),('14598','2013-06-30','16:30:00',4.2),('14598','2013-06-30','16:35:00',4.12),('14598','2013-06-30','16:40:00',4.05),('14598','2013-06-30','16:45:00',3.96),('14598','2013-06-30','16:50:00',3.91),('14598','2013-06-30','16:55:00',3.81),('14598','2013-06-30','17:00:00',3.7),('14598','2013-06-30','17:05:00',3.62),('14598','2013-06-30','17:10:00',3.52),('14598','2013-06-30','17:15:00',3.43),('14598','2013-06-30','17:20:00',3.35),('14598','2013-06-30','17:25:00',3.25),('14598','2013-06-30','17:30:00',3.19),('14598','2013-06-30','17:35:00',3.04),('14598','2013-06-30','17:40:00',3),('14598','2013-06-30','17:45:00',2.91),('14598','2013-06-30','17:50:00',2.8),('14598','2013-06-30','17:55:00',2.72),('14598','2013-06-30','18:00:00',2.65),('14598','2013-06-30','18:05:00',2.52),('14598','2013-06-30','18:10:00',2.42),('14598','2013-06-30','18:15:00',2.34),('14598','2013-06-30','18:20:00',2.28),('14598','2013-06-30','18:25:00',2.17),('14598','2013-06-30','18:30:00',2.09),('14598','2013-06-30','18:35:00',1.96),('14598','2013-06-30','18:40:00',1.85),('14598','2013-06-30','18:45:00',1.76),('14598','2013-06-30','18:50:00',1.69),('14598','2013-06-30','18:55:00',1.57),('14598','2013-06-30','19:00:00',1.45),('14598','2013-06-30','19:05:00',1.35),('14598','2013-06-30','19:10:00',1.27),('14598','2013-06-30','19:15:00',1.16),('14598','2013-06-30','19:20:00',1.07),('14598','2013-06-29','08:00:00',1.12),('14598','2013-06-29','08:05:00',1.21),('14598','2013-06-29','08:10:00',1.3),('14598','2013-06-29','08:15:00',1.39),('14598','2013-06-29','08:20:00',1.49),('14598','2013-06-29','08:25:00',1.58),('14598','2013-06-29','08:30:00',1.67),('14598','2013-06-29','08:35:00',1.76),('14598','2013-06-29','08:40:00',1.86),('14598','2013-06-29','08:45:00',1.92),('14598','2013-06-29','08:50:00',2.09),('14598','2013-06-29','08:55:00',2.2),('14598','2013-06-29','09:00:00',2.29),('14598','2013-06-29','09:05:00',2.38),('14598','2013-06-29','09:10:00',2.46),('14598','2013-06-29','09:15:00',2.56),('14598','2013-06-29','09:20:00',2.67),('14598','2013-06-29','09:25:00',2.77),('14598','2013-06-29','09:30:00',2.86),('14598','2013-06-29','09:35:00',2.93),('14598','2013-06-29','09:40:00',3.02),('14598','2013-06-29','09:45:00',3.09),('14598','2013-06-29','09:50:00',3.17),('14598','2013-06-29','09:55:00',3.25),('14598','2013-06-29','10:00:00',3.31),('14598','2013-06-29','10:05:00',3.41),('14598','2013-06-29','10:10:00',3.46),('14598','2013-06-29','10:15:00',3.53),('14598','2013-06-29','10:20:00',3.6),('14598','2013-06-29','10:25:00',3.66),('14598','2013-06-29','10:30:00',3.71),('14598','2013-06-29','10:35:00',3.78),('14598','2013-06-29','10:40:00',3.85),('14598','2013-06-29','10:45:00',3.9),('14598','2013-06-29','10:50:00',3.96),('14598','2013-06-29','10:55:00',4.02),('14598','2013-06-29','11:00:00',4.11),('14598','2013-06-29','11:05:00',4.26),('14598','2013-06-29','11:10:00',4.36),('14598','2013-06-29','11:15:00',4.5),('14598','2013-06-29','11:20:00',2.72),('14598','2013-06-29','11:25:00',3.19),('14598','2013-06-29','11:30:00',4.16),('14598','2013-06-29','11:35:00',4.8),('14598','2013-06-29','11:40:00',4.85),('14598','2013-06-29','11:45:00',4.8),('14598','2013-06-29','11:50:00',4.86),('14598','2013-06-29','11:55:00',4.82),('14598','2013-06-29','12:00:00',4.83),('14598','2013-06-29','12:05:00',4.85),('14598','2013-06-29','12:10:00',4.9),('14598','2013-06-29','12:15:00',4.97),('14598','2013-06-29','12:20:00',5.07),('14598','2013-06-29','12:25:00',5.03),('14598','2013-06-29','12:30:00',5.09),('14598','2013-06-29','12:35:00',5.14),('14598','2013-06-29','12:40:00',4.85),('14598','2013-06-29','12:45:00',4.29),('14598','2013-06-29','12:50:00',2.5),('14598','2013-06-29','12:55:00',2.29),('14598','2013-06-29','13:00:00',4.22),('14598','2013-06-29','13:05:00',5.71),('14598','2013-06-29','13:10:00',4.84),('14598','2013-06-29','13:15:00',5.37),('14598','2013-06-29','13:20:00',5.25),('14598','2013-06-29','13:25:00',5.28),('14598','2013-06-29','13:30:00',5.3),('14598','2013-06-29','13:35:00',5.27),('14598','2013-06-29','13:40:00',5.27),('14598','2013-06-29','13:45:00',5.29),('14598','2013-06-29','13:50:00',5.28),('14598','2013-06-29','13:55:00',5.3),('14598','2013-06-29','14:00:00',5.07),('14598','2013-06-29','14:05:00',5.34),('14598','2013-06-29','14:10:00',5.28),('14598','2013-06-29','14:15:00',5.27),('14598','2013-06-29','14:20:00',5.24),('14598','2013-06-29','14:25:00',5.21),('14598','2013-06-29','14:30:00',5.2),('14598','2013-06-29','14:35:00',5.24),('14598','2013-06-29','14:40:00',5.28),('14598','2013-06-29','14:45:00',5.17),('14598','2013-06-29','14:50:00',5.31),('14598','2013-06-29','14:55:00',5.13),('14598','2013-06-29','15:00:00',3.1),('14598','2013-06-29','15:05:00',3.02),('14598','2013-06-29','15:10:00',3.05),('14598','2013-06-29','15:15:00',4.25),('14598','2013-06-29','15:20:00',4.8),('14598','2013-06-29','15:25:00',4.96),('14598','2013-06-29','15:30:00',4.87),('14598','2013-06-29','15:35:00',4.81),('14598','2013-06-29','15:40:00',4.77),('14598','2013-06-29','15:45:00',4.1),('14598','2013-06-29','15:50:00',4.55),('14598','2013-06-29','15:55:00',4.89),('14598','2013-06-29','16:00:00',5.02),('14598','2013-06-29','16:05:00',5.18),('14598','2013-06-29','16:10:00',4.25),('14598','2013-06-29','16:15:00',5.3),('14598','2013-06-29','16:20:00',5.09),('14598','2013-06-29','16:25:00',4.83),('14598','2013-06-29','16:30:00',4.26),('14598','2013-06-29','16:35:00',3.74),('14598','2013-06-29','16:40:00',3.6),('14598','2013-06-29','16:45:00',2.59),('14598','2013-06-29','16:50:00',4.03),('14598','2013-06-29','16:55:00',4.06),('14598','2013-06-29','17:00:00',3.7),('14598','2013-06-29','17:05:00',3.94),('14598','2013-06-29','17:10:00',3.93),('14598','2013-06-29','17:15:00',3.81),('14598','2013-06-29','17:20:00',2.97),('14598','2013-06-29','17:25:00',3.38),('14598','2013-06-29','17:30:00',2.24),('14598','2013-06-29','17:35:00',2.77),('14598','2013-06-29','17:40:00',1.93),('14598','2013-06-29','17:45:00',2.69),('14598','2013-06-29','17:50:00',1.57),('14598','2013-06-29','17:55:00',1.4),('14598','2013-06-29','18:00:00',2.64),('14598','2013-06-29','18:05:00',2.41),('14598','2013-06-29','18:10:00',2.34),('14598','2013-06-29','18:15:00',2.04),('14598','2013-06-29','18:20:00',2.25),('14598','2013-06-29','18:25:00',2.1),('14598','2013-06-29','18:30:00',2.06),('14598','2013-06-29','18:35:00',2.08),('14598','2013-06-29','18:40:00',2),('14598','2013-06-29','18:45:00',1.88),('14598','2013-06-29','18:50:00',1.3),('14598','2013-06-28','07:55:00',1.03),('14598','2013-06-28','08:00:00',1.11),('14598','2013-06-28','08:05:00',1.2),('14598','2013-06-28','08:10:00',1.31),('14598','2013-06-28','08:15:00',1.4),('14598','2013-06-28','08:20:00',1.48),('14598','2013-06-28','08:25:00',1.59),('14598','2013-06-28','08:30:00',1.67),('14598','2013-06-28','08:35:00',1.77),('14598','2013-06-28','08:40:00',1.55),('14598','2013-06-28','08:45:00',2.01),('14598','2013-06-28','08:50:00',2.33),('14598','2013-06-28','08:55:00',2.44),('14598','2013-06-28','09:10:00',1.2),('14598','2013-06-28','09:20:00',1.23),('14598','2013-06-28','09:25:00',2.47),('14598','2013-06-28','09:30:00',3.03),('14598','2013-06-28','09:35:00',3.05),('14598','2013-06-28','09:40:00',3.13),('14598','2013-06-28','09:45:00',3.22),('14598','2013-06-28','09:50:00',3.3),('14598','2013-06-28','09:55:00',3.37),('14598','2013-06-28','10:00:00',3.43),('14598','2013-06-28','10:05:00',3.5),('14598','2013-06-28','10:10:00',3.52),('14598','2013-06-28','10:15:00',3.67),('14598','2013-06-28','10:20:00',3.76),('14598','2013-06-28','10:25:00',3.83),('14598','2013-06-28','10:30:00',3.98),('14598','2013-06-28','10:35:00',4.07),('14598','2013-06-28','10:40:00',4.13),('14598','2013-06-28','10:45:00',4.25),('14598','2013-06-28','10:50:00',3.67),('14598','2013-06-28','10:55:00',3.8),('14598','2013-06-28','11:00:00',4.43),('14598','2013-06-28','11:05:00',4.56),('14598','2013-06-28','11:10:00',4.81),('14598','2013-06-28','11:15:00',4.24),('14598','2013-06-28','11:20:00',3.62),('14598','2013-06-28','11:25:00',3.95),('14598','2013-06-28','11:30:00',3.08),('14598','2013-06-28','11:35:00',2.46),('14598','2013-06-28','11:40:00',3.87),('14598','2013-06-28','11:45:00',4.04),('14598','2013-06-28','11:50:00',2.94),('14598','2013-06-28','11:55:00',2.3),('14598','2013-06-28','12:00:00',4.26),('14598','2013-06-28','12:05:00',5.04),('14598','2013-06-28','12:10:00',4.89),('14598','2013-06-28','12:15:00',4.91),('14598','2013-06-28','12:20:00',4.93),('14598','2013-06-28','12:25:00',4.97),('14598','2013-06-28','12:30:00',4.98),('14598','2013-06-28','12:35:00',5),('14598','2013-06-28','12:40:00',5.03),('14598','2013-06-28','12:45:00',5.05),('14598','2013-06-28','12:50:00',5.09),('14598','2013-06-28','12:55:00',5.12),('14598','2013-06-28','13:00:00',5.14),('14598','2013-06-28','13:05:00',5.16),('14598','2013-06-28','13:10:00',4.77),('14598','2013-06-28','13:15:00',5.35),('14598','2013-06-28','13:20:00',3.95),('14598','2013-06-28','13:25:00',3.01),('14598','2013-06-28','13:30:00',4.78),('14598','2013-06-28','13:35:00',4.66),('14598','2013-06-28','13:40:00',4.7),('14598','2013-06-28','13:45:00',4.91),('14598','2013-06-28','13:50:00',5.64),('14598','2013-06-28','13:55:00',5.09),('14598','2013-06-28','14:00:00',5.3),('14598','2013-06-28','14:05:00',5.26),('14598','2013-06-28','14:10:00',5.28),('14598','2013-06-28','14:15:00',4.85),('14598','2013-06-28','14:20:00',4.07),('14598','2013-06-28','14:25:00',3.32),('14598','2013-06-28','14:30:00',5.13),('14598','2013-06-28','14:35:00',4.89),('14598','2013-06-28','14:40:00',4.86),('14598','2013-06-28','14:45:00',4.71),('14598','2013-06-28','14:50:00',4.97),('14598','2013-06-28','14:55:00',4.96),('14598','2013-06-28','15:00:00',5.06),('14598','2013-06-28','15:05:00',5.15),('14598','2013-06-28','15:10:00',5.16),('14598','2013-06-28','15:15:00',2.72),('14598','2013-06-28','15:20:00',3.36),('14598','2013-06-28','15:25:00',5.77),('14598','2013-06-28','15:30:00',5),('14598','2013-06-28','15:35:00',4.77),('14598','2013-06-28','15:40:00',4.74),('14598','2013-06-28','15:45:00',4.68),('14598','2013-06-28','15:50:00',4.66),('14598','2013-06-28','15:55:00',4.66),('14598','2013-06-28','16:00:00',4.56),('14598','2013-06-28','16:05:00',4.44),('14598','2013-06-28','16:10:00',4.34),('14598','2013-06-28','16:15:00',4.35),('14598','2013-06-28','16:20:00',4.27),('14598','2013-06-28','16:25:00',4.22),('14598','2013-06-28','16:30:00',4.16),('14598','2013-06-28','16:35:00',4.08),('14598','2013-06-28','16:40:00',4.02),('14598','2013-06-28','16:45:00',3.97),('14598','2013-06-28','16:50:00',3.9),('14598','2013-06-28','16:55:00',3.82),('14598','2013-06-28','17:00:00',3.74),('14598','2013-06-28','17:05:00',3.68),('14598','2013-06-28','17:10:00',3.61),('14598','2013-06-28','17:15:00',3.53),('14598','2013-06-28','17:20:00',3.46),('14598','2013-06-28','17:25:00',3.37),('14598','2013-06-28','17:30:00',3.28),('14598','2013-06-28','17:35:00',3.2),('14598','2013-06-28','17:40:00',3.11),('14598','2013-06-28','17:45:00',2.95),('14598','2013-06-28','17:50:00',2.95),('14598','2013-06-28','17:55:00',2.86),('14598','2013-06-28','18:00:00',2.78),('14598','2013-06-28','18:05:00',2.68),('14598','2013-06-28','18:10:00',2.57),('14598','2013-06-28','18:15:00',2.47),('14598','2013-06-28','18:20:00',2.36),('14598','2013-06-28','18:25:00',2.24),('14598','2013-06-28','18:30:00',2.09),('14598','2013-06-28','18:35:00',2.05),('14598','2013-06-28','18:40:00',1.96),('14598','2013-06-28','18:45:00',1.88),('14598','2013-06-28','18:50:00',1.78),('14598','2013-06-28','18:55:00',1.66),('14598','2013-06-28','19:00:00',1.54),('14598','2013-06-28','19:05:00',1.45),('14598','2013-06-28','19:10:00',1.33),('14598','2013-06-28','19:20:00',1.11),('14598','2013-06-27','07:50:00',1.01),('14598','2013-06-27','07:55:00',1.09),('14598','2013-06-27','08:00:00',1.17),('14598','2013-06-27','08:05:00',1.26),('14598','2013-06-27','08:10:00',1.35),('14598','2013-06-27','08:15:00',1.43),('14598','2013-06-27','08:20:00',1.51),('14598','2013-06-27','08:25:00',1.56),('14598','2013-06-27','08:30:00',1.69),('14598','2013-06-27','08:35:00',1.8),('14598','2013-06-27','08:40:00',1.89),('14598','2013-06-27','08:45:00',2.02),('14598','2013-06-27','08:50:00',2.13),('14598','2013-06-27','08:55:00',2.23),('14598','2013-06-27','09:00:00',2.32),('14598','2013-06-27','09:05:00',2.41),('14598','2013-06-27','09:10:00',2.63),('14598','2013-06-27','09:15:00',2.97),('14598','2013-06-27','09:20:00',3.3),('14598','2013-06-27','09:25:00',3.29),('14598','2013-06-27','09:30:00',3.25),('14598','2013-06-27','09:35:00',3.14),('14598','2013-06-27','09:40:00',3.03),('14598','2013-06-27','09:45:00',3.12),('14598','2013-06-27','09:50:00',3.19),('14598','2013-06-27','09:55:00',3.25),('14598','2013-06-27','10:00:00',3.34),('14598','2013-06-27','10:05:00',3.43),('14598','2013-06-27','10:10:00',3.49),('14598','2013-06-27','10:15:00',3.54),('14598','2013-06-27','10:20:00',3.61),('14598','2013-06-27','10:25:00',3.64),('14598','2013-06-27','10:30:00',3.76),('14598','2013-06-27','10:35:00',2.94),('14598','2013-06-27','10:40:00',3.88),('14598','2013-06-27','10:45:00',2.57),('14598','2013-06-27','10:50:00',2.3),('14598','2013-06-27','10:55:00',4.28),('14598','2013-06-27','11:00:00',4.26),('14598','2013-06-27','11:05:00',4.31),('14598','2013-06-27','11:10:00',4.39),('14598','2013-06-27','11:15:00',4.31),('14598','2013-06-27','11:20:00',4.35),('14598','2013-06-27','11:25:00',4.38),('14598','2013-06-27','11:30:00',4.47),('14598','2013-06-27','11:35:00',4.55),('14598','2013-06-27','11:40:00',4.6),('14598','2013-06-27','11:45:00',4.59),('14598','2013-06-27','11:50:00',4.68),('14598','2013-06-27','11:55:00',4.77),('14598','2013-06-27','12:00:00',4.75),('14598','2013-06-27','12:05:00',4.74),('14598','2013-06-27','12:10:00',4.79),('14598','2013-06-27','12:15:00',4.81),('14598','2013-06-27','12:20:00',4.87),('14598','2013-06-27','12:25:00',4.89),('14598','2013-06-27','12:30:00',4.93),('14598','2013-06-27','12:35:00',4.96),('14598','2013-06-27','12:40:00',4.96),('14598','2013-06-27','12:45:00',4.95),('14598','2013-06-27','12:50:00',4.97),('14598','2013-06-27','12:55:00',4.96),('14598','2013-06-27','13:00:00',4.96),('14598','2013-06-27','13:05:00',4.94),('14598','2013-06-27','13:10:00',5),('14598','2013-06-27','13:15:00',4.99),('14598','2013-06-27','13:20:00',4.97),('14598','2013-06-27','13:25:00',5),('14598','2013-06-27','13:30:00',4.99),('14598','2013-06-27','13:35:00',5.01),('14598','2013-06-27','13:40:00',5.02),('14598','2013-06-27','13:45:00',5.02),('14598','2013-06-27','13:50:00',5.01),('14598','2013-06-27','13:55:00',5.01),('14598','2013-06-27','14:00:00',5.03),('14598','2013-06-27','14:05:00',5.01),('14598','2013-06-27','14:10:00',4.97),('14598','2013-06-27','14:15:00',4.99),('14598','2013-06-27','14:20:00',4.96),('14598','2013-06-27','14:25:00',4.98),('14598','2013-06-27','14:30:00',4.84),('14598','2013-06-27','14:35:00',4.91),('14598','2013-06-27','14:40:00',4.94),('14598','2013-06-27','14:45:00',4.94),('14598','2013-06-27','14:50:00',4.92),('14598','2013-06-27','14:55:00',4.9),('14598','2013-06-27','15:00:00',4.9),('14598','2013-06-27','15:05:00',4.91),('14598','2013-06-27','15:10:00',4.89),('14598','2013-06-27','15:15:00',4.84),('14598','2013-06-27','15:20:00',4.77),('14598','2013-06-27','15:25:00',4.77),('14598','2013-06-27','15:30:00',4.71),('14598','2013-06-27','15:35:00',4.64),('14598','2013-06-27','15:40:00',4.58),('14598','2013-06-27','15:45:00',4.52),('14598','2013-06-27','15:50:00',4.48),('14598','2013-06-27','15:55:00',4.47),('14598','2013-06-27','16:00:00',4.46),('14598','2013-06-27','16:05:00',4.4),('14598','2013-06-27','16:10:00',4.29),('14598','2013-06-27','16:15:00',4.22),('14598','2013-06-27','16:20:00',4.12),('14598','2013-06-27','16:25:00',4.14),('14598','2013-06-27','16:30:00',4.1),('14598','2013-06-27','16:35:00',4.01),('14598','2013-06-27','16:40:00',3.96),('14598','2013-06-27','16:45:00',3.92),('14598','2013-06-27','16:50:00',3.79),('14598','2013-06-27','16:55:00',3.66),('14598','2013-06-27','17:00:00',3.81),('14598','2013-06-27','17:05:00',3.72),('14598','2013-06-27','17:10:00',3.65),('14598','2013-06-27','17:15:00',3.54),('14598','2013-06-27','17:20:00',3.32),('14598','2013-06-27','17:25:00',3.22),('14598','2013-06-27','17:30:00',2.97),('14598','2013-06-27','17:35:00',2.92),('14598','2013-06-27','17:40:00',2.86),('14598','2013-06-27','17:45:00',2.81),('14598','2013-06-27','17:50:00',2.75),('14598','2013-06-27','17:55:00',2.61),('14598','2013-06-27','18:00:00',2.47),('14598','2013-06-27','18:05:00',2.42),('14598','2013-06-27','18:10:00',2.41),('14598','2013-06-27','18:15:00',2.32),('14598','2013-06-27','18:20:00',2.19),('14598','2013-06-27','18:25:00',1.9),('14598','2013-06-27','18:30:00',1.93),('14598','2013-06-27','18:35:00',1.89),('14598','2013-06-27','18:40:00',1.85),('14598','2013-06-27','18:45:00',1.76),('14598','2013-06-27','18:50:00',1.64),('14598','2013-06-27','18:55:00',1.56),('14598','2013-06-27','19:00:00',1.47),('14598','2013-06-27','19:05:00',1.33),('14598','2013-06-26','07:55:00',1.07),('14598','2013-06-26','08:00:00',1.15),('14598','2013-06-26','08:05:00',1.24),('14598','2013-06-26','08:10:00',1.32),('14598','2013-06-26','08:15:00',1.41),('14598','2013-06-26','08:20:00',1.51),('14598','2013-06-26','08:25:00',1.6),('14598','2013-06-26','08:30:00',1.69),('14598','2013-06-26','08:35:00',1.79),('14598','2013-06-26','08:40:00',1.85),('14598','2013-06-26','08:45:00',1.4),('14598','2013-06-26','08:50:00',1.84),('14598','2013-06-26','08:55:00',2.12),('14598','2013-06-26','09:00:00',2.3),('14598','2013-06-26','09:05:00',2.42),('14598','2013-06-26','09:10:00',2.5),('14598','2013-06-26','09:15:00',2.58),('14598','2013-06-26','09:20:00',2.7),('14598','2013-06-26','09:25:00',2.77),('14598','2013-06-26','09:30:00',2.85),('14598','2013-06-26','09:35:00',2.92),('14598','2013-06-26','09:40:00',3),('14598','2013-06-26','09:45:00',3.08),('14598','2013-06-26','09:50:00',3.18),('14598','2013-06-26','09:55:00',3.26),('14598','2013-06-26','10:00:00',3.31),('14598','2013-06-26','10:05:00',3.37),('14598','2013-06-26','10:10:00',3.43),('14598','2013-06-26','10:15:00',3.47),('14598','2013-06-26','10:20:00',3.56),('14598','2013-06-26','10:25:00',3.66),('14598','2013-06-26','10:30:00',3.72),('14598','2013-06-26','10:35:00',3.79),('14598','2013-06-26','10:40:00',3.85),('14598','2013-06-26','10:45:00',3.91),('14598','2013-06-26','10:50:00',3.89),('14598','2013-06-26','10:55:00',3.98),('14598','2013-06-26','11:00:00',4.06),('14598','2013-06-26','11:05:00',4.14),('14598','2013-06-26','11:10:00',4.22),('14598','2013-06-26','11:15:00',4.27),('14598','2013-06-26','11:20:00',4.32),('14598','2013-06-26','11:25:00',4.38),('14598','2013-06-26','11:30:00',4.47),('14598','2013-06-26','11:35:00',4.55),('14598','2013-06-26','11:40:00',4.6),('14598','2013-06-26','11:45:00',4.63),('14598','2013-06-26','11:50:00',4.66),('14598','2013-06-26','11:55:00',4.69),('14598','2013-06-26','12:00:00',4.7),('14598','2013-06-26','12:05:00',4.72),('14598','2013-06-26','12:10:00',4.8),('14598','2013-06-26','12:15:00',4.87),('14598','2013-06-26','12:20:00',4.91),('14598','2013-06-26','12:25:00',4.96),('14598','2013-06-26','12:30:00',5.02),('14598','2013-06-26','12:35:00',5.03),('14598','2013-06-26','12:40:00',5.01),('14598','2013-06-26','12:45:00',5.01),('14598','2013-06-26','12:50:00',5.01),('14598','2013-06-26','12:55:00',5.02),('14598','2013-06-26','13:00:00',5.06),('14598','2013-06-26','13:05:00',5.1),('14598','2013-06-26','13:10:00',5.14),('14598','2013-06-26','13:15:00',5.16),('14598','2013-06-26','13:20:00',5.16),('14598','2013-06-26','13:25:00',5.15),('14598','2013-06-26','13:30:00',5.12),('14598','2013-06-26','13:35:00',5.16),('14598','2013-06-26','13:40:00',5.26),('14598','2013-06-26','13:45:00',5.22),('14598','2013-06-26','13:50:00',5.18),('14598','2013-06-26','13:55:00',5.13),('14598','2013-06-26','14:00:00',5.16),('14598','2013-06-26','14:05:00',5.15),('14598','2013-06-26','14:10:00',5.12),('14598','2013-06-26','14:15:00',5.12),('14598','2013-06-26','14:20:00',5.12),('14598','2013-06-26','14:25:00',5.09),('14598','2013-06-26','14:30:00',5.06),('14598','2013-06-26','14:35:00',5.07),('14598','2013-06-26','14:40:00',5.04),('14598','2013-06-26','14:45:00',5.04),('14598','2013-06-26','14:50:00',5.01),('14598','2013-06-26','14:55:00',4.98),('14598','2013-06-26','15:00:00',4.94),('14598','2013-06-26','15:05:00',4.93),('14598','2013-06-26','15:10:00',4.9),('14598','2013-06-26','15:15:00',4.85),('14598','2013-06-26','15:20:00',4.81),('14598','2013-06-26','15:25:00',4.77),('14598','2013-06-26','15:30:00',4.77),('14598','2013-06-26','15:35:00',4.73),('14598','2013-06-26','15:40:00',4.62),('14598','2013-06-26','15:45:00',4.6),('14598','2013-06-26','15:50:00',4.55),('14598','2013-06-26','15:55:00',4.51),('14598','2013-06-26','16:00:00',4.48),('14598','2013-06-26','16:05:00',4.42),('14598','2013-06-26','16:10:00',4.36),('14598','2013-06-26','16:15:00',4.31),('14598','2013-06-26','16:20:00',4.24),('14598','2013-06-26','16:25:00',4.21),('14598','2013-06-26','16:30:00',4.15),('14598','2013-06-26','16:35:00',4.07),('14598','2013-06-26','16:40:00',4),('14598','2013-06-26','16:45:00',3.92),('14598','2013-06-26','16:50:00',3.84),('14598','2013-06-26','16:55:00',3.74),('14598','2013-06-26','17:00:00',3.68),('14598','2013-06-26','17:05:00',3.59),('14598','2013-06-26','17:10:00',3.53),('14598','2013-06-26','17:15:00',3.46),('14598','2013-06-26','17:20:00',3.38),('14598','2013-06-26','17:25:00',3.3),('14598','2013-06-26','17:30:00',3.24),('14598','2013-06-26','17:35:00',3.14),('14598','2013-06-26','17:40:00',3.06),('14598','2013-06-26','17:45:00',2.95),('14598','2013-06-26','17:50:00',2.84),('14598','2013-06-26','17:55:00',2.73),('14598','2013-06-26','18:00:00',2.35),('14598','2013-06-26','18:05:00',1.94),('14598','2013-06-26','18:10:00',2.59),('14598','2013-06-26','18:15:00',2.37),('14598','2013-06-26','18:20:00',2.29),('14598','2013-06-26','18:25:00',2.19),('14598','2013-06-26','18:30:00',2.15),('14598','2013-06-26','18:35:00',2.14),('14598','2013-06-26','18:40:00',2.17),('14598','2013-06-26','18:45:00',2.08),('14598','2013-06-26','18:50:00',1.47),('14598','2013-06-26','19:00:00',1.3),('14598','2013-06-26','19:05:00',1.27),('14598','2013-06-26','19:10:00',1.13),('14598','2013-06-25','07:55:00',1.07),('14598','2013-06-25','08:00:00',1.13),('14598','2013-06-25','08:05:00',1.24),('14598','2013-06-25','08:10:00',1.34),('14598','2013-06-25','08:15:00',1.43),('14598','2013-06-25','08:20:00',1.53),('14598','2013-06-25','08:25:00',1.62),('14598','2013-06-25','08:30:00',1.69),('14598','2013-06-25','08:35:00',1.8),('14598','2013-06-25','08:40:00',1.86),('14598','2013-06-25','08:45:00',1.97),('14598','2013-06-25','08:50:00',2.2),('14598','2013-06-25','08:55:00',1.9),('14598','2013-06-25','09:00:00',2.35),('14598','2013-06-25','09:05:00',2.46),('14598','2013-06-25','09:10:00',2.57),('14598','2013-06-25','09:15:00',2.69),('14598','2013-06-25','09:20:00',2.75),('14598','2013-06-25','09:25:00',2.82),('14598','2013-06-25','09:30:00',2.98),('14598','2013-06-25','09:35:00',3.07),('14598','2013-06-25','09:40:00',3.32),('14598','2013-06-25','09:45:00',3.42),('14598','2013-06-25','09:50:00',3.56),('14598','2013-06-25','09:55:00',3.68),('14598','2013-06-25','10:00:00',3.62),('14598','2013-06-25','10:05:00',3.59),('14598','2013-06-25','10:10:00',3.83),('14598','2013-06-25','10:15:00',3.96),('14598','2013-06-25','10:20:00',3.83),('14598','2013-06-25','10:25:00',3.85),('14598','2013-06-25','10:30:00',3.89),('14598','2013-06-25','10:35:00',3.96),('14598','2013-06-25','10:40:00',4.04),('14598','2013-06-25','10:45:00',4.07),('14598','2013-06-25','10:50:00',4.11),('14598','2013-06-25','10:55:00',4.17),('14598','2013-06-25','11:00:00',4.2),('14598','2013-06-25','11:05:00',4.27),('14598','2013-06-25','11:10:00',4.35),('14598','2013-06-25','11:15:00',4.41),('14598','2013-06-25','11:20:00',4.45),('14598','2013-06-25','11:25:00',4.49),('14598','2013-06-25','11:30:00',4.55),('14598','2013-06-25','11:35:00',4.59),('14598','2013-06-25','11:40:00',4.64),('14598','2013-06-25','11:45:00',4.66),('14598','2013-06-25','11:50:00',4.73),('14598','2013-06-25','11:55:00',4.77),('14598','2013-06-25','12:00:00',4.81),('14598','2013-06-25','12:05:00',4.83),('14598','2013-06-25','12:10:00',4.86),('14598','2013-06-25','12:15:00',4.89),('14598','2013-06-25','12:20:00',4.94),('14598','2013-06-25','12:25:00',4.96),('14598','2013-06-25','12:30:00',5.01),('14598','2013-06-25','12:35:00',5.06),('14598','2013-06-25','12:40:00',5.05),('14598','2013-06-25','12:45:00',5.06),('14598','2013-06-25','12:50:00',5.04),('14598','2013-06-25','12:55:00',5.1),('14598','2013-06-25','13:00:00',5.12),('14598','2013-06-25','13:05:00',5.16),('14598','2013-06-25','13:10:00',5.17),('14598','2013-06-25','13:15:00',5.16),('14598','2013-06-25','13:20:00',5.16),('14598','2013-06-25','13:25:00',5.14),('14598','2013-06-25','13:30:00',5.17),('14598','2013-06-25','13:35:00',5.15),('14598','2013-06-25','13:40:00',5.16),('14598','2013-06-25','13:45:00',5.18),('14598','2013-06-25','13:50:00',5.17),('14598','2013-06-25','13:55:00',5.15),('14598','2013-06-25','14:00:00',5.19),('14598','2013-06-25','14:05:00',5.2),('14598','2013-06-25','14:10:00',5.17),('14598','2013-06-25','14:15:00',5.18),('14598','2013-06-25','14:20:00',5.16),('14598','2013-06-25','14:25:00',5.14),('14598','2013-06-25','14:30:00',5.13),('14598','2013-06-25','14:35:00',5.12),('14598','2013-06-25','14:40:00',5.07),('14598','2013-06-25','14:45:00',5.05),('14598','2013-06-25','14:50:00',5.04),('14598','2013-06-25','14:55:00',5.03),('14598','2013-06-25','15:00:00',5.01),('14598','2013-06-25','15:05:00',4.99),('14598','2013-06-25','15:10:00',4.94),('14598','2013-06-25','15:15:00',4.87),('14598','2013-06-25','15:20:00',4.85),('14598','2013-06-25','15:25:00',4.81),('14598','2013-06-25','15:30:00',4.78),('14598','2013-06-25','15:35:00',4.72),('14598','2013-06-25','15:40:00',4.68),('14598','2013-06-25','15:45:00',4.64),('14598','2013-06-25','15:50:00',4.6),('14598','2013-06-25','15:55:00',4.49),('14598','2013-06-25','16:00:00',4.48),('14598','2013-06-25','16:05:00',4.46),('14598','2013-06-25','16:10:00',4.41),('14598','2013-06-25','16:15:00',4.35),('14598','2013-06-25','16:20:00',4.3),('14598','2013-06-25','16:25:00',4.22),('14598','2013-06-25','16:30:00',4.14),('14598','2013-06-25','16:35:00',4.08),('14598','2013-06-25','16:40:00',4.03),('14598','2013-06-25','16:45:00',3.95),('14598','2013-06-25','16:50:00',3.89),('14598','2013-06-25','16:55:00',3.81),('14598','2013-06-25','17:00:00',3.74),('14598','2013-06-25','17:05:00',3.69),('14598','2013-06-25','17:10:00',3.6),('14598','2013-06-25','17:15:00',3.51),('14598','2013-06-25','17:20:00',3.44),('14598','2013-06-25','17:25:00',3.36),('14598','2013-06-25','17:30:00',3.26),('14598','2013-06-25','17:35:00',3.17),('14598','2013-06-25','17:40:00',3.07),('14598','2013-06-25','17:45:00',2.99),('14598','2013-06-25','17:50:00',2.91),('14598','2013-06-25','17:55:00',2.83),('14598','2013-06-25','18:00:00',2.73),('14598','2013-06-25','18:05:00',2.63),('14598','2013-06-25','18:10:00',2.52),('14598','2013-06-25','18:15:00',2.44),('14598','2013-06-25','18:20:00',2.35),('14598','2013-06-25','18:25:00',2.24),('14598','2013-06-25','18:30:00',2.14),('14598','2013-06-25','18:35:00',2.02),('14598','2013-06-25','18:40:00',1.9),('14598','2013-06-25','18:45:00',1.82),('14598','2013-06-25','18:50:00',1.71),('14598','2013-06-25','18:55:00',1.61),('14598','2013-06-25','19:00:00',1.53),('14598','2013-06-25','19:05:00',1.44),('14598','2013-06-25','19:10:00',1.33),('14598','2013-06-25','19:15:00',1.23),('14598','2013-06-25','19:20:00',1.12),('14598','2013-06-24','07:55:00',1.08),('14598','2013-06-24','08:00:00',1.18),('14598','2013-06-24','08:05:00',1.27),('14598','2013-06-24','08:10:00',1.37),('14598','2013-06-24','08:15:00',1.48),('14598','2013-06-24','08:20:00',1.59),('14598','2013-06-24','08:25:00',1.61),('14598','2013-06-24','08:30:00',1.51),('14598','2013-06-24','08:35:00',1.72),('14598','2013-06-24','08:40:00',1.98),('14598','2013-06-24','08:45:00',1.81),('14598','2013-06-24','08:50:00',1.72),('14598','2013-06-24','08:55:00',2.79),('14598','2013-06-24','09:00:00',1.59),('14598','2013-06-24','09:05:00',1.07),('14598','2013-06-24','09:10:00',2.66),('14598','2013-06-24','09:15:00',2.71),('14598','2013-06-24','09:20:00',2.81),('14598','2013-06-24','09:25:00',2.91),('14598','2013-06-24','09:30:00',3),('14598','2013-06-24','09:35:00',3.08),('14598','2013-06-24','09:40:00',3.15),('14598','2013-06-24','09:45:00',3.24),('14598','2013-06-24','09:50:00',3.28),('14598','2013-06-24','09:55:00',3.38),('14598','2013-06-24','10:00:00',3.51),('14598','2013-06-24','10:05:00',3.73),('14598','2013-06-24','10:10:00',3.76),('14598','2013-06-24','10:15:00',3.52),('14598','2013-06-24','10:20:00',4.33),('14598','2013-06-24','10:25:00',2.97),('14598','2013-06-24','10:30:00',2),('14598','2013-06-24','10:35:00',3.96),('14598','2013-06-24','10:40:00',4.09),('14598','2013-06-24','10:45:00',3.06),('14598','2013-06-24','10:50:00',2.76),('14598','2013-06-24','10:55:00',1.22),('14598','2013-06-24','11:00:00',1.34),('14598','2013-06-24','11:05:00',2.11),('14598','2013-06-24','11:10:00',2.57),('14598','2013-06-24','11:15:00',2.68),('14598','2013-06-24','11:20:00',2.02),('14598','2013-06-24','11:25:00',3.34),('14598','2013-06-24','11:30:00',3.49),('14598','2013-06-24','11:35:00',2.12),('14598','2013-06-24','11:40:00',2.35),('14598','2013-06-24','11:45:00',2.69),('14598','2013-06-24','11:50:00',4.62),('14598','2013-06-24','11:55:00',4.63),('14598','2013-06-24','12:00:00',4.08),('14598','2013-06-24','12:05:00',4.67),('14598','2013-06-24','12:10:00',5.11),('14598','2013-06-24','12:15:00',4.42),('14598','2013-06-24','12:20:00',3.99),('14598','2013-06-24','12:25:00',5.18),('14598','2013-06-24','12:30:00',4.54),('14598','2013-06-24','12:35:00',5.17),('14598','2013-06-24','12:40:00',5.45),('14598','2013-06-24','12:45:00',4.61),('14598','2013-06-24','12:50:00',5.73),('14598','2013-06-24','12:55:00',5.42),('14598','2013-06-24','13:00:00',5.17),('14598','2013-06-24','13:05:00',5.48),('14598','2013-06-24','13:10:00',5.39),('14598','2013-06-24','13:15:00',5.57),('14598','2013-06-24','13:20:00',5.14),('14598','2013-06-24','13:25:00',5.32),('14598','2013-06-24','13:30:00',5.34),('14598','2013-06-24','13:35:00',5.35),('14598','2013-06-24','13:40:00',5.34),('14598','2013-06-24','13:45:00',4.96),('14598','2013-06-24','13:50:00',5.19),('14598','2013-06-24','13:55:00',5.39),('14598','2013-06-24','14:00:00',5.43),('14598','2013-06-24','14:05:00',5.09),('14598','2013-06-24','14:10:00',3.23),('14598','2013-06-24','14:15:00',4.25),('14598','2013-06-24','14:20:00',4.37),('14598','2013-06-24','14:25:00',4.89),('14598','2013-06-24','14:30:00',4.09),('14598','2013-06-24','14:35:00',4.36),('14598','2013-06-24','14:40:00',4.45),('14598','2013-06-24','14:45:00',4.36),('14598','2013-06-24','14:50:00',5.39),('14598','2013-06-24','14:55:00',4.42),('14598','2013-06-24','15:00:00',3.61),('14598','2013-06-24','15:05:00',4.59),('14598','2013-06-24','15:10:00',3.36),('14598','2013-06-24','15:15:00',4.7),('14598','2013-06-24','15:20:00',3.5),('14598','2013-06-24','15:25:00',4.42),('14598','2013-06-24','15:30:00',5.04),('14598','2013-06-24','15:35:00',4.94),('14598','2013-06-24','15:40:00',4.9),('14598','2013-06-24','15:45:00',3.94),('14598','2013-06-24','15:50:00',4.58),('14598','2013-06-24','15:55:00',4.91),('14598','2013-06-24','16:00:00',3.65),('14598','2013-06-24','16:05:00',4.99),('14598','2013-06-24','16:10:00',4.23),('14598','2013-06-24','16:15:00',3.09),('14598','2013-06-24','16:20:00',3.57),('14598','2013-06-24','16:25:00',3.03),('14598','2013-06-24','16:30:00',2.63),('14598','2013-06-24','16:35:00',2.73),('14598','2013-06-24','16:40:00',1.38),('14598','2013-06-24','16:45:00',3.89),('14598','2013-06-24','16:50:00',4.41),('14598','2013-06-24','16:55:00',4.31),('14598','2013-06-24','17:00:00',3.38),('14598','2013-06-24','17:05:00',4.27),('14598','2013-06-24','17:11:00',2.29),('14598','2013-06-24','17:15:00',1.5),('14598','2013-06-24','17:20:00',3.33),('14598','2013-06-24','17:25:00',3.3),('14598','2013-06-24','17:30:00',1.33),('14598','2013-06-24','17:35:00',1.41),('14598','2013-06-24','17:40:00',2.92),('14598','2013-06-24','17:45:00',2.76),('14598','2013-06-24','17:50:00',3.23),('14598','2013-06-24','17:56:00',2.78),('14598','2013-06-24','18:00:00',1.13),('14598','2013-06-24','18:05:00',1.98),('14598','2013-06-24','18:10:00',1.32),('14598','2013-06-24','18:26:00',2.49),('14598','2013-06-24','18:30:00',1.42),('14598','2013-06-24','18:35:00',2),('14598','2013-06-24','18:40:00',1.6),('14598','2013-06-24','18:45:00',1.5),('14598','2013-06-24','18:50:00',2.07),('14598','2013-06-24','18:56:00',1.27),('14598','2013-06-24','19:00:00',1.82),('14598','2013-06-24','19:05:00',1.7),('14598','2013-06-24','19:10:00',1.49),('14598','2013-06-24','19:15:00',1.24),('14598','2013-06-24','19:20:00',1.23),('14598','2013-06-23','08:45:00',1.48),('14598','2013-06-23','08:50:00',1.99),('14598','2013-06-23','08:55:00',2.28),('14598','2013-06-23','09:00:00',2.39),('14598','2013-06-23','09:05:00',2.42),('14598','2013-06-23','09:10:00',2.46),('14598','2013-06-23','09:15:00',2.56),('14598','2013-06-23','09:20:00',2.66),('14598','2013-06-23','09:25:00',2.79),('14598','2013-06-23','09:30:00',2.83),('14598','2013-06-23','09:35:00',2.89),('14598','2013-06-23','09:40:00',2.97),('14598','2013-06-23','09:45:00',3.09),('14598','2013-06-23','09:50:00',3.15),('14598','2013-06-23','09:55:00',3.24),('14598','2013-06-23','10:00:00',3.32),('14598','2013-06-23','10:05:00',3.38),('14598','2013-06-23','10:10:00',3.42),('14598','2013-06-23','10:15:00',3.44),('14598','2013-06-23','10:20:00',3.56),('14598','2013-06-23','10:25:00',3.69),('14598','2013-06-23','10:30:00',3.76),('14598','2013-06-23','10:35:00',3.82),('14598','2013-06-23','10:40:00',3.94),('14598','2013-06-23','10:45:00',3.96),('14598','2013-06-23','10:50:00',4.04),('14598','2013-06-23','10:55:00',4.11),('14598','2013-06-23','11:00:00',4.19),('14598','2013-06-23','11:05:00',4.25),('14598','2013-06-23','11:10:00',4.31),('14598','2013-06-23','11:15:00',4.37),('14598','2013-06-23','11:20:00',4.42),('14598','2013-06-23','11:25:00',4.49),('14598','2013-06-23','11:30:00',4.56),('14598','2013-06-23','11:35:00',4.59),('14598','2013-06-23','11:40:00',4.63),('14598','2013-06-23','11:45:00',4.69),('14598','2013-06-23','11:50:00',4.75),('14598','2013-06-23','11:55:00',4.78),('14598','2013-06-23','12:00:00',4.83),('14598','2013-06-23','12:05:00',4.86),('14598','2013-06-23','12:10:00',4.89),('14598','2013-06-23','12:15:00',4.93),('14598','2013-06-23','12:20:00',4.91),('14598','2013-06-23','12:25:00',5),('14598','2013-06-23','12:30:00',5.04),('14598','2013-06-23','12:35:00',5.06),('14598','2013-06-23','12:40:00',5.09),('14598','2013-06-23','12:45:00',5.1),('14598','2013-06-23','12:50:00',5.1),('14598','2013-06-23','12:55:00',5.13),('14598','2013-06-23','13:00:00',5.17),('14598','2013-06-23','13:05:00',5.19),('14598','2013-06-23','13:10:00',5.22),('14598','2013-06-23','13:15:00',5.23),('14598','2013-06-23','13:20:00',5.25),('14598','2013-06-23','13:25:00',5.26),('14598','2013-06-23','13:30:00',5.26),('14598','2013-06-23','13:35:00',5.24),('14598','2013-06-23','13:40:00',5.25),('14598','2013-06-23','13:45:00',5.25),('14598','2013-06-23','13:50:00',5.23),('14598','2013-06-23','13:55:00',5.24),('14598','2013-06-23','14:00:00',5.24),('14598','2013-06-23','14:05:00',5.22),('14598','2013-06-23','14:10:00',5.19),('14598','2013-06-23','14:15:00',5.2),('14598','2013-06-23','14:20:00',5.2),('14598','2013-06-23','14:25:00',5.24),('14598','2013-06-23','14:30:00',4.86),('14598','2013-06-23','14:35:00',5.23),('14598','2013-06-23','14:40:00',5.23),('14598','2013-06-23','14:45:00',5.1),('14598','2013-06-23','14:50:00',4.02),('14598','2013-06-23','14:55:00',4.83),('14598','2013-06-23','15:00:00',4.91),('14598','2013-06-23','15:05:00',4.89),('14598','2013-06-23','15:10:00',5.31),('14598','2013-06-23','15:15:00',4.98),('14598','2013-06-23','15:20:00',4.33),('14598','2013-06-23','15:25:00',4.68),('14598','2013-06-23','15:30:00',4.78),('14598','2013-06-23','15:35:00',4.69),('14598','2013-06-23','15:40:00',4.46),('14598','2013-06-23','15:45:00',4.75),('14598','2013-06-23','15:50:00',4.29),('14598','2013-06-23','15:55:00',4.6),('14598','2013-06-23','16:00:00',4.57),('14598','2013-06-23','16:05:00',4.35),('14598','2013-06-23','16:10:00',3.88),('14598','2013-06-23','16:15:00',4.7),('14598','2013-06-23','16:20:00',3.52),('14598','2013-06-23','16:25:00',3.65),('14598','2013-06-23','16:30:00',4.79),('14598','2013-06-23','16:35:00',2.85),('14598','2013-06-23','16:40:00',2.81),('14598','2013-06-23','16:45:00',3.5),('14598','2013-06-23','16:50:00',1.93),('14598','2013-06-23','16:55:00',3.93),('14598','2013-06-23','17:00:00',2.84),('14598','2013-06-23','17:05:00',3.32),('14598','2013-06-23','17:10:00',3.67),('14598','2013-06-23','17:15:00',3.65),('14598','2013-06-23','17:20:00',2.17),('14598','2013-06-23','17:25:00',3.44),('14598','2013-06-23','17:30:00',3.15),('14598','2013-06-23','17:35:00',2.16),('14598','2013-06-23','17:40:00',2.39),('14598','2013-06-23','17:45:00',3.13),('14598','2013-06-23','17:50:00',2.96),('14598','2013-06-23','17:55:00',2.18),('14598','2013-06-23','18:00:00',2.99),('14598','2013-06-23','18:05:00',2.95),('14598','2013-06-23','18:10:00',2.56),('14598','2013-06-23','18:15:00',2.1),('14598','2013-06-23','18:20:00',2.07),('14598','2013-06-23','18:25:00',2.33),('14598','2013-06-23','18:30:00',2.25),('14598','2013-06-23','18:35:00',2.16),('14598','2013-06-23','18:40:00',2.08),('14598','2013-06-23','18:45:00',1.82),('14598','2013-06-23','18:50:00',1.89),('14598','2013-06-23','19:00:00',1.72),('14598','2013-06-23','19:05:00',1.45),('14598','2013-06-23','19:10:00',1.1),('14598','2013-06-22','07:55:00',1.08),('14598','2013-06-22','08:00:00',1.16),('14598','2013-06-22','08:05:00',1.23),('14598','2013-06-22','08:10:00',1.31),('14598','2013-06-22','08:15:00',1.4),('14598','2013-06-22','08:20:00',1.49),('14598','2013-06-22','08:25:00',1.56),('14598','2013-06-22','08:30:00',1.63),('14598','2013-06-22','08:35:00',1.72),('14598','2013-06-22','08:40:00',1.78),('14598','2013-06-22','08:45:00',1.95),('14598','2013-06-22','08:50:00',2.03),('14598','2013-06-22','08:55:00',2.14),('14598','2013-06-22','09:00:00',2.19),('14598','2013-06-22','09:05:00',2.33),('14598','2013-06-22','09:10:00',2.44),('14598','2013-06-22','09:15:00',2.58),('14598','2013-06-22','09:20:00',2.67),('14598','2013-06-22','09:25:00',2.74),('14598','2013-06-22','09:30:00',2.81),('14598','2013-06-22','09:35:00',2.91),('14598','2013-06-22','09:40:00',3),('14598','2013-06-22','09:45:00',3.08),('14598','2013-06-22','09:50:00',3.09),('14598','2013-06-22','09:55:00',3.23),('14598','2013-06-22','10:00:00',3.31),('14598','2013-06-22','10:05:00',3.37),('14598','2013-06-22','10:10:00',3.45),('14598','2013-06-22','10:15:00',3.51),('14598','2013-06-22','10:20:00',3.54),('14598','2013-06-22','10:25:00',3.64),('14598','2013-06-22','10:30:00',3.77),('14598','2013-06-22','10:35:00',3.81),('14598','2013-06-22','10:40:00',3.86),('14598','2013-06-22','10:45:00',3.78),('14598','2013-06-22','10:50:00',4),('14598','2013-06-22','10:55:00',4.06),('14598','2013-06-22','11:00:00',4.12),('14598','2013-06-22','11:05:00',4.16),('14598','2013-06-22','11:10:00',4.22),('14598','2013-06-22','11:15:00',4.29),('14598','2013-06-22','11:20:00',4.34),('14598','2013-06-22','11:25:00',4.36),('14598','2013-06-22','11:30:00',4.44),('14598','2013-06-22','11:35:00',4.49),('14598','2013-06-22','11:40:00',4.51),('14598','2013-06-22','11:45:00',4.57),('14598','2013-06-22','11:50:00',4.63),('14598','2013-06-22','11:55:00',4.57),('14598','2013-06-22','12:00:00',4.58),('14598','2013-06-22','12:05:00',4.49),('14598','2013-06-22','12:10:00',4.05),('14598','2013-06-22','12:15:00',4.79),('14598','2013-06-22','12:20:00',4.82),('14598','2013-06-22','12:25:00',4.86),('14598','2013-06-22','12:30:00',4.89),('14598','2013-06-22','12:35:00',4.9),('14598','2013-06-22','12:40:00',4.9),('14598','2013-06-22','12:45:00',5.04),('14598','2013-06-22','12:50:00',5.09),('14598','2013-06-22','12:55:00',5.12),('14598','2013-06-22','13:00:00',4.68),('14598','2013-06-22','13:05:00',4.68),('14598','2013-06-22','13:10:00',5.42),('14598','2013-06-22','13:15:00',5.52),('14598','2013-06-22','13:20:00',5.6),('14598','2013-06-22','13:25:00',4.84),('14598','2013-06-22','13:30:00',5.46),('14598','2013-06-22','13:35:00',4.72),('14598','2013-06-22','13:40:00',4.26),('14598','2013-06-22','13:45:00',5.3),('14598','2013-06-22','13:50:00',5.61),('14598','2013-06-22','13:55:00',4.43),('14598','2013-06-22','14:00:00',5.26),('14598','2013-06-22','14:05:00',4.23),('14598','2013-06-22','14:10:00',4.49),('14598','2013-06-22','14:15:00',2.2),('14598','2013-06-22','14:20:00',2.58),('14598','2013-06-22','14:25:00',4.19),('14598','2013-06-22','14:30:00',5.93),('14598','2013-06-22','14:35:00',5.36),('14598','2013-06-22','14:40:00',4.21),('14598','2013-06-22','14:45:00',4.51),('14598','2013-06-22','14:50:00',3.84),('14598','2013-06-22','14:55:00',4.28),('14598','2013-06-22','15:00:00',5.43),('14598','2013-06-22','15:05:00',4.45),('14598','2013-06-22','15:10:00',4.64),('14598','2013-06-22','15:15:00',2.56),('14598','2013-06-22','15:20:00',1.2),('14598','2013-06-22','15:25:00',1.63),('14598','2013-06-22','15:30:00',2.03),('14598','2013-06-22','15:35:00',1.97),('14598','2013-06-22','15:40:00',1.94),('14598','2013-06-22','15:45:00',2.07),('14598','2013-06-22','15:50:00',2.03),('14598','2013-06-22','15:55:00',1.87),('14598','2013-06-22','16:00:00',1.7),('14598','2013-06-22','16:05:00',1.51),('14598','2013-06-22','16:10:00',1.5),('14598','2013-06-22','16:15:00',1.56),('14598','2013-06-22','16:20:00',1.64),('14598','2013-06-22','16:25:00',1.73),('14598','2013-06-22','16:30:00',1.66),('14598','2013-06-22','16:35:00',1.91),('14598','2013-06-22','16:40:00',2.24),('14598','2013-06-22','16:45:00',2.24),('14598','2013-06-22','16:50:00',3.97),('14598','2013-06-22','16:55:00',3.58),('14598','2013-06-22','17:00:00',2.5),('14598','2013-06-22','17:05:00',3.56),('14598','2013-06-22','17:10:00',2.43),('14598','2013-06-22','17:15:00',3.56),('14598','2013-06-22','17:20:00',3.38),('14598','2013-06-22','17:25:00',2.76),('14598','2013-06-22','17:30:00',2.51),('14598','2013-06-22','17:35:00',2.85),('14598','2013-06-22','17:40:00',2.83),('14598','2013-06-22','17:45:00',1.93),('14598','2013-06-22','17:50:00',1.76),('14598','2013-06-22','17:55:00',1.65),('14598','2013-06-22','18:00:00',1.84),('14598','2013-06-22','18:05:00',1.84),('14598','2013-06-22','18:10:00',1.61),('14598','2013-06-22','18:15:00',1.02),('14598','2013-06-22','18:25:00',1.06),('14598','2013-06-22','18:40:00',1.69),('14598','2013-06-22','18:45:00',1.59),('14598','2013-06-22','18:50:00',1.76),('14598','2013-06-22','18:55:00',1.79),('14598','2013-06-22','19:00:00',1.91),('14598','2013-06-22','19:05:00',1.75),('14598','2013-06-22','19:10:00',1.58),('14598','2013-06-22','19:15:00',1.31),('14598','2013-06-21','07:50:00',1.01),('14598','2013-06-21','07:55:00',1.09),('14598','2013-06-21','08:00:00',1.16),('14598','2013-06-21','08:05:00',1.23),('14598','2013-06-21','08:10:00',1.31),('14598','2013-06-21','08:15:00',1.39),('14598','2013-06-21','08:20:00',1.49),('14598','2013-06-21','08:25:00',1.57),('14598','2013-06-21','08:30:00',1.65),('14598','2013-06-21','08:35:00',1.75),('14598','2013-06-21','08:40:00',1.83),('14598','2013-06-21','08:45:00',1.94),('14598','2013-06-21','08:50:00',2.05),('14598','2013-06-21','08:55:00',2.15),('14598','2013-06-21','09:00:00',2.25),('14598','2013-06-21','09:05:00',2.35),('14598','2013-06-21','09:10:00',2.43),('14598','2013-06-21','09:15:00',2.5),('14598','2013-06-21','09:20:00',2.61),('14598','2013-06-21','09:25:00',2.67),('14598','2013-06-21','09:30:00',2.74),('14598','2013-06-21','09:35:00',2.83),('14598','2013-06-21','09:40:00',2.96),('14598','2013-06-21','09:45:00',3.02),('14598','2013-06-21','09:50:00',3.08),('14598','2013-06-21','09:55:00',3.18),('14598','2013-06-21','10:00:00',3.25),('14598','2013-06-21','10:05:00',3.3),('14598','2013-06-21','10:10:00',3.38),('14598','2013-06-21','10:15:00',3.46),('14598','2013-06-21','10:20:00',3.55),('14598','2013-06-21','10:25:00',3.64),('14598','2013-06-21','10:30:00',3.71),('14598','2013-06-21','10:35:00',3.77),('14598','2013-06-21','10:40:00',3.84),('14598','2013-06-21','10:45:00',3.91),('14598','2013-06-21','10:50:00',3.98),('14598','2013-06-21','10:55:00',4.04),('14598','2013-06-21','11:00:00',4.1),('14598','2013-06-21','11:05:00',4.14),('14598','2013-06-21','11:10:00',4.21),('14598','2013-06-21','11:15:00',4.27),('14598','2013-06-21','11:20:00',4.32),('14598','2013-06-21','11:25:00',4.37),('14598','2013-06-21','11:30:00',4.44),('14598','2013-06-21','11:35:00',4.5),('14598','2013-06-21','11:40:00',4.55),('14598','2013-06-21','11:45:00',4.59),('14598','2013-06-21','11:50:00',4.63),('14598','2013-06-21','11:55:00',4.66),('14598','2013-06-21','12:00:00',4.69),('14598','2013-06-21','12:05:00',4.72),('14598','2013-06-21','12:10:00',4.75),('14598','2013-06-21','12:15:00',4.76),('14598','2013-06-21','12:20:00',4.81),('14598','2013-06-21','12:25:00',4.84),('14598','2013-06-21','12:30:00',4.88),('14598','2013-06-21','12:35:00',4.91),('14598','2013-06-21','12:40:00',4.95),('14598','2013-06-21','12:45:00',4.94),('14598','2013-06-21','12:50:00',4.88),('14598','2013-06-21','12:55:00',4.95),('14598','2013-06-21','13:00:00',4.96),('14598','2013-06-21','13:05:00',4.97),('14598','2013-06-21','13:10:00',4.99),('14598','2013-06-21','13:15:00',5.01),('14598','2013-06-21','13:20:00',5.03),('14598','2013-06-21','13:25:00',5.05),('14598','2013-06-21','13:30:00',5.04),('14598','2013-06-21','13:35:00',5.07),('14598','2013-06-21','13:40:00',5.05),('14598','2013-06-21','13:45:00',5.05),('14598','2013-06-21','13:50:00',5.07),('14598','2013-06-21','13:55:00',5.06),('14598','2013-06-21','14:00:00',5.06),('14598','2013-06-21','14:05:00',5.04),('14598','2013-06-21','14:10:00',5.03),('14598','2013-06-21','14:15:00',5.02),('14598','2013-06-21','14:20:00',4.97),('14598','2013-06-21','14:25:00',4.95),('14598','2013-06-21','14:30:00',4.96),('14598','2013-06-21','14:35:00',4.91),('14598','2013-06-21','14:40:00',4.92),('14598','2013-06-21','14:45:00',4.9),('14598','2013-06-21','14:50:00',4.87),('14598','2013-06-21','14:55:00',4.86),('14598','2013-06-21','15:00:00',4.83),('14598','2013-06-21','15:05:00',4.83),('14598','2013-06-21','15:10:00',4.78),('14598','2013-06-21','15:15:00',4.73),('14598','2013-06-21','15:20:00',4.7),('14598','2013-06-21','15:25:00',4.68),('14598','2013-06-21','15:30:00',4.65),('14598','2013-06-21','15:35:00',4.61),('14598','2013-06-21','15:40:00',4.58),('14598','2013-06-21','15:45:00',4.55),('14598','2013-06-21','15:50:00',4.5),('14598','2013-06-21','15:55:00',4.42),('14598','2013-06-21','16:00:00',4.41),('14598','2013-06-21','16:05:00',4.36),('14598','2013-06-21','16:10:00',4.31),('14598','2013-06-21','16:15:00',4.26),('14598','2013-06-21','16:20:00',4.22),('14598','2013-06-21','16:25:00',4.14),('14598','2013-06-21','16:30:00',4.06),('14598','2013-06-21','16:35:00',4.01),('14598','2013-06-21','16:40:00',3.95),('14598','2013-06-21','16:45:00',3.92),('14598','2013-06-21','16:50:00',3.82),('14598','2013-06-21','16:55:00',3.77),('14598','2013-06-21','17:00:00',3.68),('14598','2013-06-21','17:05:00',3.6),('14598','2013-06-21','17:10:00',3.5),('14598','2013-06-21','17:15:00',3.43),('14598','2013-06-21','17:20:00',3.34),('14598','2013-06-21','17:25:00',3.26),('14598','2013-06-21','17:30:00',3.17),('14598','2013-06-21','17:35:00',3.1),('14598','2013-06-21','17:40:00',2.95),('14598','2013-06-21','17:45:00',2.94),('14598','2013-06-21','17:50:00',2.87),('14598','2013-06-21','17:55:00',2.79),('14598','2013-06-21','18:00:00',2.68),('14598','2013-06-21','18:05:00',2.59),('14598','2013-06-21','18:10:00',2.48),('14598','2013-06-21','18:15:00',2.39),('14598','2013-06-21','18:20:00',2.26),('14598','2013-06-21','18:25:00',2.13),('14598','2013-06-21','18:30:00',2.03),('14598','2013-06-21','18:35:00',1.95),('14598','2013-06-21','18:40:00',1.85),('14598','2013-06-21','18:45:00',1.75),('14598','2013-06-21','18:50:00',1.66),('14598','2013-06-21','18:55:00',1.54),('14598','2013-06-21','19:00:00',1.44),('14598','2013-06-21','19:05:00',1.31),('14598','2013-06-21','19:10:00',1.18),('14598','2013-06-21','19:15:00',1.07),('14598','2014-04-04','08:45:00',1.36),('14598','2014-04-04','08:50:00',1.59),('14598','2014-04-04','08:55:00',1.48),('14598','2014-04-04','09:00:00',1.1),('14598','2014-04-04','09:55:00',1.11),('14598','2014-04-04','10:00:00',1.26),('14598','2014-04-04','12:15:00',1.01),('14598','2014-04-04','12:20:00',1.08),('14598','2014-04-04','12:35:00',1.37),('14598','2014-04-04','12:40:00',2.06),('14598','2014-04-04','12:45:00',2.17),('14598','2014-04-04','12:50:00',2.59),('14598','2014-04-04','12:55:00',3.17),('14598','2014-04-04','13:00:00',3.51),('14598','2014-04-04','13:05:00',3.91),('14598','2014-04-04','13:10:00',3.3),('14598','2014-04-04','13:15:00',3.14),('14598','2014-04-04','13:20:00',4.98),('14598','2014-04-04','13:25:00',4.91),('14598','2014-04-04','13:30:00',5.22),('14598','2014-04-04','13:35:00',5.56),('14598','2014-04-04','13:40:00',3.56),('14598','2014-04-04','13:45:00',3.51),('14598','2014-04-04','13:50:00',5.26),('14598','2014-04-04','13:55:00',4.71),('14598','2014-04-04','14:00:00',3.97),('14598','2014-04-04','14:05:00',4.97),('14598','2014-04-04','14:10:00',4.81),('14598','2014-04-04','14:15:00',4.81),('14598','2014-04-04','14:20:00',4.81),('14598','2014-04-04','14:25:00',4.83),('14598','2014-04-04','14:30:00',4.24),('14598','2014-04-04','14:35:00',2.51),('14598','2014-04-04','14:40:00',3.95),('14598','2014-04-04','14:45:00',4.59),('14598','2014-04-04','14:50:00',2.96),('14598','2014-04-04','14:55:00',2.53),('14598','2014-04-04','15:00:00',3.41),('14598','2014-04-04','15:05:00',2.94),('14598','2014-04-04','15:10:00',4.77),('14598','2014-04-04','15:15:00',2.87),('14598','2014-04-04','15:20:00',4.4),('14598','2014-04-04','15:25:00',3.97),('14598','2014-04-04','15:30:00',2.25),('14598','2014-04-04','15:35:00',4.13),('14598','2014-04-04','15:40:00',4.6),('14598','2014-04-04','15:45:00',4.28),('14598','2014-04-04','15:50:00',4.26),('14598','2014-04-04','15:55:00',4.2),('14598','2014-04-04','16:00:00',4.19),('14598','2014-04-04','16:05:00',3.97),('14598','2014-04-04','16:10:00',4.02),('14598','2014-04-04','16:15:00',3.94),('14598','2014-04-04','16:20:00',3.9),('14598','2014-04-04','16:25:00',3.72),('14598','2014-04-04','16:30:00',3.86),('14598','2014-04-04','16:35:00',3.73),('14598','2014-04-04','16:40:00',3.63),('14598','2014-04-04','16:45:00',3.54),('14598','2014-04-04','16:50:00',2.33),('14598','2014-04-04','16:55:00',2.49),('14598','2014-04-04','17:00:00',2.1),('14598','2014-04-04','17:05:00',3.24),('14598','2014-04-04','17:10:00',2.96),('14598','2014-04-04','17:15:00',3),('14598','2014-04-04','17:20:00',2.98),('14598','2014-04-04','17:25:00',2.81),('14598','2014-04-04','17:30:00',2.63),('14598','2014-04-04','17:35:00',2.57),('14598','2014-04-04','17:40:00',2.42),('14598','2014-04-04','17:45:00',2.25),('14598','2014-04-04','17:50:00',2.14),('14598','2014-04-04','17:55:00',1.99),('14598','2014-04-04','18:00:00',1.61),('14598','2014-04-04','18:05:00',1.72),('14598','2014-04-04','18:10:00',1.65),('14598','2014-04-04','18:15:00',1.64),('14598','2014-04-04','18:20:00',1.46),('14598','2014-04-04','18:25:00',1.3),('14598','2014-04-04','18:30:00',1.13),('14598','2013-06-20','07:55:00',1.07),('14598','2013-06-20','08:00:00',1.14),('14598','2013-06-20','08:05:00',1.23),('14598','2013-06-20','08:10:00',1.32),('14598','2013-06-20','08:15:00',1.42),('14598','2013-06-20','08:20:00',1.51),('14598','2013-06-20','08:25:00',1.6),('14598','2013-06-20','08:30:00',1.67),('14598','2013-06-20','08:35:00',1.78),('14598','2013-06-20','08:40:00',1.85),('14598','2013-06-20','08:45:00',1.98),('14598','2013-06-20','08:50:00',2.09),('14598','2013-06-20','08:55:00',2.17),('14598','2013-06-20','09:00:00',2.28),('14598','2013-06-20','09:05:00',2.35),('14598','2013-06-20','09:10:00',2.44),('14598','2013-06-20','09:15:00',2.55),('14598','2013-06-20','09:20:00',2.64),('14598','2013-06-20','09:25:00',2.71),('14598','2013-06-20','09:30:00',2.79),('14598','2013-06-20','09:35:00',2.89),('14598','2013-06-20','09:40:00',2.97),('14598','2013-06-20','09:45:00',3.03),('14598','2013-06-20','09:50:00',3.11),('14598','2013-06-20','09:55:00',3.2),('14598','2013-06-20','10:00:00',3.25),('14598','2013-06-20','10:05:00',3.36),('14598','2013-06-20','10:10:00',3.4),('14598','2013-06-20','10:15:00',3.45),('14598','2013-06-20','10:20:00',3.5),('14598','2013-06-20','10:25:00',3.55),('14598','2013-06-20','10:30:00',3.65),('14598','2013-06-20','10:35:00',3.78),('14598','2013-06-20','10:40:00',3.84),('14598','2013-06-20','10:45:00',3.93),('14598','2013-06-20','10:50:00',4),('14598','2013-06-20','10:55:00',4.06),('14598','2013-06-20','11:00:00',4.11),('14598','2013-06-20','11:05:00',4.14),('14598','2013-06-20','11:10:00',4.23),('14598','2013-06-20','11:15:00',4.28),('14598','2013-06-20','11:20:00',4.33),('14598','2013-06-20','11:25:00',4.38),('14598','2013-06-20','11:30:00',4.42),('14598','2013-06-20','11:35:00',4.47),('14598','2013-06-20','11:40:00',4.51),('14598','2013-06-20','11:45:00',4.54),('14598','2013-06-20','11:50:00',4.59),('14598','2013-06-20','11:55:00',4.62),('14598','2013-06-20','12:00:00',4.63),('14598','2013-06-20','12:05:00',4.65),('14598','2013-06-20','12:10:00',4.68),('14598','2013-06-20','12:15:00',4.75),('14598','2013-06-20','12:20:00',4.76),('14598','2013-06-20','12:25:00',4.82),('14598','2013-06-20','12:30:00',4.86),('14598','2013-06-20','12:35:00',4.88),('14598','2013-06-20','12:40:00',4.88),('14598','2013-06-20','12:45:00',4.91),('14598','2013-06-20','12:50:00',4.95),('14598','2013-06-20','12:55:00',4.98),('14598','2013-06-20','13:00:00',5),('14598','2013-06-20','13:05:00',5.02),('14598','2013-06-20','13:10:00',5.04),('14598','2013-06-20','13:15:00',5.06),('14598','2013-06-20','13:20:00',5.07),('14598','2013-06-20','13:25:00',5.08),('14598','2013-06-20','13:30:00',5.09),('14598','2013-06-20','13:35:00',5.11),('14598','2013-06-20','13:40:00',5.12),('14598','2013-06-20','13:45:00',5.12),('14598','2013-06-20','13:50:00',5.14),('14598','2013-06-20','13:55:00',5.17),('14598','2013-06-20','14:00:00',5.17),('14598','2013-06-20','14:05:00',5.1),('14598','2013-06-20','14:10:00',5.17),('14598','2013-06-20','14:15:00',5.14),('14598','2013-06-20','14:20:00',5.14),('14598','2013-06-20','14:25:00',5.11),('14598','2013-06-20','14:30:00',5.09),('14598','2013-06-20','14:35:00',5.09),('14598','2013-06-20','14:40:00',5.06),('14598','2013-06-20','14:45:00',5.05),('14598','2013-06-20','14:50:00',5.01),('14598','2013-06-20','14:55:00',4.97),('14598','2013-06-20','15:00:00',4.93),('14598','2013-06-20','15:05:00',4.88),('14598','2013-06-20','15:10:00',4.8),('14598','2013-06-20','15:15:00',4.75),('14598','2013-06-20','15:20:00',4.68),('14598','2013-06-20','15:25:00',4.66),('14598','2013-06-20','15:30:00',4.66),('14598','2013-06-20','15:35:00',4.65),('14598','2013-06-20','15:40:00',4.6),('14598','2013-06-20','15:45:00',4.56),('14598','2013-06-20','15:50:00',4.47),('14598','2013-06-20','15:55:00',4.43),('14598','2013-06-20','16:00:00',4.38),('14598','2013-06-20','16:05:00',4.39),('14598','2013-06-20','16:10:00',4.34),('14598','2013-06-20','16:15:00',4.29),('14598','2013-06-20','16:20:00',4.23),('14598','2013-06-20','16:25:00',4.16),('14598','2013-06-20','16:30:00',4.11),('14598','2013-06-20','16:35:00',4.05),('14598','2013-06-20','16:40:00',3.99),('14598','2013-06-20','16:45:00',3.95),('14598','2013-06-20','16:50:00',3.88),('14598','2013-06-20','16:55:00',3.81),('14598','2013-06-20','17:00:00',3.74),('14598','2013-06-20','17:05:00',3.65),('14598','2013-06-20','17:10:00',3.6),('14598','2013-06-20','17:15:00',3.52),('14598','2013-06-20','17:20:00',3.45),('14598','2013-06-20','17:25:00',3.37),('14598','2013-06-20','17:30:00',3.29),('14598','2013-06-20','17:35:00',3.2),('14598','2013-06-20','17:40:00',3.11),('14598','2013-06-20','17:45:00',3.03),('14598','2013-06-20','17:50:00',2.94),('14598','2013-06-20','17:55:00',2.84),('14598','2013-06-20','18:00:00',2.73),('14598','2013-06-20','18:05:00',2.64),('14598','2013-06-20','18:10:00',2.55),('14598','2013-06-20','18:15:00',2.44),('14598','2013-06-20','18:20:00',2.33),('14598','2013-06-20','18:25:00',2.24),('14598','2013-06-20','18:30:00',2.13),('14598','2013-06-20','18:35:00',2.03),('14598','2013-06-20','18:40:00',1.93),('14598','2013-06-20','18:45:00',1.84),('14598','2013-06-20','18:50:00',1.74),('14598','2013-06-20','18:55:00',1.59),('14598','2013-06-20','19:00:00',1.52),('14598','2013-06-20','19:05:00',1.42),('14598','2013-06-20','19:10:00',1.32),('14598','2013-06-20','19:15:00',1.23),('14598','2013-06-20','19:20:00',1.15),('14598','2013-06-20','19:25:00',1.05),('14598','2013-06-19','07:55:00',1.06),('14598','2013-06-19','08:00:00',1.14),('14598','2013-06-19','08:05:00',1.22),('14598','2013-06-19','08:10:00',1.3),('14598','2013-06-19','08:15:00',1.39),('14598','2013-06-19','08:20:00',1.47),('14598','2013-06-19','08:25:00',1.55),('14598','2013-06-19','08:30:00',1.64),('14598','2013-06-19','08:35:00',1.74),('14598','2013-06-19','08:40:00',1.84),('14598','2013-06-19','08:45:00',1.95),('14598','2013-06-19','08:50:00',2.05),('14598','2013-06-19','08:55:00',2.15),('14598','2013-06-19','09:00:00',2.22),('14598','2013-06-19','09:05:00',2.32),('14598','2013-06-19','09:10:00',2.39),('14598','2013-06-19','09:15:00',2.49),('14598','2013-06-19','09:20:00',2.59),('14598','2013-06-19','09:25:00',2.66),('14598','2013-06-19','09:30:00',2.74),('14598','2013-06-19','09:35:00',2.82),('14598','2013-06-19','09:40:00',2.89),('14598','2013-06-19','09:45:00',2.96),('14598','2013-06-19','09:50:00',3.04),('14598','2013-06-19','09:55:00',3.11),('14598','2013-06-19','10:00:00',3.17),('14598','2013-06-19','10:05:00',3.25),('14598','2013-06-19','10:10:00',3.33),('14598','2013-06-19','10:15:00',3.44),('14598','2013-06-19','10:20:00',3.48),('14598','2013-06-19','10:25:00',3.57),('14598','2013-06-19','10:30:00',3.65),('14598','2013-06-19','10:35:00',3.7),('14598','2013-06-19','10:40:00',3.75),('14598','2013-06-19','10:45:00',3.81),('14598','2013-06-19','10:50:00',3.88),('14598','2013-06-19','10:55:00',3.95),('14598','2013-06-19','11:00:00',4.01),('14598','2013-06-19','11:05:00',4.07),('14598','2013-06-19','11:10:00',4.13),('14598','2013-06-19','11:15:00',4.18),('14598','2013-06-19','11:20:00',4.23),('14598','2013-06-19','11:25:00',4.29),('14598','2013-06-19','11:30:00',4.34),('14598','2013-06-19','11:35:00',4.37),('14598','2013-06-19','11:40:00',4.42),('14598','2013-06-19','11:45:00',4.47),('14598','2013-06-19','11:50:00',4.5),('14598','2013-06-19','11:55:00',4.51),('14598','2013-06-19','12:00:00',4.55),('14598','2013-06-19','12:05:00',4.51),('14598','2013-06-19','12:10:00',4.63),('14598','2013-06-19','12:15:00',4.65),('14598','2013-06-19','12:20:00',4.69),('14598','2013-06-19','12:25:00',4.72),('14598','2013-06-19','12:30:00',4.75),('14598','2013-06-19','12:35:00',4.79),('14598','2013-06-19','12:40:00',4.81),('14598','2013-06-19','12:45:00',4.82),('14598','2013-06-19','12:50:00',4.84),('14598','2013-06-19','12:55:00',4.88),('14598','2013-06-19','13:00:00',4.89),('14598','2013-06-19','13:05:00',4.93),('14598','2013-06-19','13:10:00',4.96),('14598','2013-06-19','13:15:00',4.97),('14598','2013-06-19','13:20:00',4.96),('14598','2013-06-19','13:25:00',4.98),('14598','2013-06-19','13:30:00',4.99),('14598','2013-06-19','13:35:00',4.99),('14598','2013-06-19','13:40:00',4.97),('14598','2013-06-19','13:45:00',4.98),('14598','2013-06-19','13:50:00',4.94),('14598','2013-06-19','13:55:00',4.92),('14598','2013-06-19','14:00:00',4.92),('14598','2013-06-19','14:05:00',4.92),('14598','2013-06-19','14:10:00',4.9),('14598','2013-06-19','14:15:00',4.88),('14598','2013-06-19','14:20:00',4.87),('14598','2013-06-19','14:25:00',4.87),('14598','2013-06-19','14:30:00',4.84),('14598','2013-06-19','14:35:00',4.83),('14598','2013-06-19','14:40:00',4.8),('14598','2013-06-19','14:45:00',4.8),('14598','2013-06-19','14:50:00',4.78),('14598','2013-06-19','14:55:00',4.75),('14598','2013-06-19','15:00:00',4.71),('14598','2013-06-19','15:05:00',4.63),('14598','2013-06-19','15:10:00',4.64),('14598','2013-06-19','15:15:00',4.62),('14598','2013-06-19','15:20:00',4.58),('14598','2013-06-19','15:25:00',4.55),('14598','2013-06-19','15:30:00',4.53),('14598','2013-06-19','15:35:00',4.48),('14598','2013-06-19','15:40:00',4.45),('14598','2013-06-19','15:45:00',4.4),('14598','2013-06-19','15:50:00',4.36),('14598','2013-06-19','15:55:00',4.32),('14598','2013-06-19','16:00:00',4.27),('14598','2013-06-19','16:05:00',4.23),('14598','2013-06-19','16:10:00',4.2),('14598','2013-06-19','16:15:00',4.14),('14598','2013-06-19','16:20:00',4.07),('14598','2013-06-19','16:25:00',4.02),('14598','2013-06-19','16:30:00',3.98),('14598','2013-06-19','16:35:00',3.93),('14598','2013-06-19','16:40:00',3.89),('14598','2013-06-19','16:45:00',3.84),('14598','2013-06-19','16:50:00',3.78),('14598','2013-06-19','16:55:00',3.72),('14598','2013-06-19','17:00:00',3.64),('14598','2013-06-19','17:05:00',3.54),('14598','2013-06-19','17:10:00',3.47),('14598','2013-06-19','17:15:00',3.38),('14598','2013-06-19','17:20:00',3.31),('14598','2013-06-19','17:25:00',3.24),('14598','2013-06-19','17:30:00',3.16),('14598','2013-06-19','17:35:00',3.07),('14598','2013-06-19','17:40:00',2.99),('14598','2013-06-19','17:45:00',2.91),('14598','2013-06-19','17:50:00',2.81),('14598','2013-06-19','17:55:00',2.74),('14598','2013-06-19','18:00:00',2.64),('14598','2013-06-19','18:05:00',2.55),('14598','2013-06-19','18:10:00',2.42),('14598','2013-06-19','18:15:00',2.34),('14598','2013-06-19','18:20:00',2.24),('14598','2013-06-19','18:25:00',2.15),('14598','2013-06-19','18:30:00',2.06),('14598','2013-06-19','18:35:00',1.98),('14598','2013-06-19','18:40:00',1.88),('14598','2013-06-19','18:45:00',1.79),('14598','2013-06-19','18:50:00',1.68),('14598','2013-06-19','18:55:00',1.57),('14598','2013-06-19','19:00:00',1.47),('14598','2013-06-19','19:05:00',1.37),('14598','2013-06-19','19:10:00',1.26),('14598','2013-06-19','19:15:00',1.17),('14598','2013-06-19','19:20:00',1.07),('14598','2013-06-18','07:55:00',1.04),('14598','2013-06-18','08:00:00',1.13),('14598','2013-06-18','08:05:00',1.21),('14598','2013-06-18','08:10:00',1.29),('14598','2013-06-18','08:15:00',1.37),('14598','2013-06-18','08:20:00',1.46),('14598','2013-06-18','08:25:00',1.55),('14598','2013-06-18','08:30:00',1.64),('14598','2013-06-18','08:35:00',1.74),('14598','2013-06-18','08:40:00',1.84),('14598','2013-06-18','08:45:00',1.96),('14598','2013-06-18','08:50:00',2.06),('14598','2013-06-18','08:55:00',2.17),('14598','2013-06-18','09:00:00',2.22),('14598','2013-06-18','09:05:00',2.34),('14598','2013-06-18','09:10:00',2.42),('14598','2013-06-18','09:15:00',2.52),('14598','2013-06-18','09:20:00',2.61),('14598','2013-06-18','09:25:00',2.68),('14598','2013-06-18','09:30:00',2.75),('14598','2013-06-18','09:35:00',2.82),('14598','2013-06-18','09:40:00',2.89),('14598','2013-06-18','09:45:00',2.97),('14598','2013-06-18','09:50:00',3.06),('14598','2013-06-18','09:55:00',3.11),('14598','2013-06-18','10:00:00',3.16),('14598','2013-06-18','10:05:00',3.23),('14598','2013-06-18','10:10:00',3.3),('14598','2013-06-18','10:15:00',3.37),('14598','2013-06-18','10:20:00',3.41),('14598','2013-06-18','10:25:00',3.52),('14598','2013-06-18','10:30:00',3.59),('14598','2013-06-18','10:35:00',3.65),('14598','2013-06-18','10:40:00',3.72),('14598','2013-06-18','10:45:00',3.78),('14598','2013-06-18','10:50:00',3.82),('14598','2013-06-18','10:55:00',3.89),('14598','2013-06-18','11:00:00',3.98),('14598','2013-06-18','11:05:00',4.05),('14598','2013-06-18','11:10:00',4.08),('14598','2013-06-18','11:15:00',4.12),('14598','2013-06-18','11:20:00',4.17),('14598','2013-06-18','11:25:00',4.2),('14598','2013-06-18','11:30:00',4.24),('14598','2013-06-18','11:35:00',4.3),('14598','2013-06-18','11:40:00',4.35),('14598','2013-06-18','11:45:00',4.41),('14598','2013-06-18','11:50:00',4.47),('14598','2013-06-18','11:55:00',4.54),('14598','2013-06-18','12:00:00',4.57),('14598','2013-06-18','12:05:00',4.58),('14598','2013-06-18','12:10:00',4.64),('14598','2013-06-18','12:15:00',4.69),('14598','2013-06-18','12:20:00',4.72),('14598','2013-06-18','12:25:00',4.73),('14598','2013-06-18','12:30:00',4.79),('14598','2013-06-18','12:35:00',4.82),('14598','2013-06-18','12:40:00',4.84),('14598','2013-06-18','12:45:00',4.87),('14598','2013-06-18','12:50:00',4.91),('14598','2013-06-18','12:55:00',4.91),('14598','2013-06-18','13:00:00',4.92),('14598','2013-06-18','13:05:00',4.93),('14598','2013-06-18','13:10:00',4.93),('14598','2013-06-18','13:15:00',4.95),('14598','2013-06-18','13:20:00',4.94),('14598','2013-06-18','13:25:00',4.97),('14598','2013-06-18','13:30:00',4.99),('14598','2013-06-18','13:35:00',5.02),('14598','2013-06-18','13:40:00',5.05),('14598','2013-06-18','13:45:00',5.06),('14598','2013-06-18','13:50:00',5.06),('14598','2013-06-18','13:55:00',5.06),('14598','2013-06-18','14:00:00',5.07),('14598','2013-06-18','14:05:00',5.07),('14598','2013-06-18','14:10:00',5.07),('14598','2013-06-18','14:15:00',5.06),('14598','2013-06-18','14:20:00',5.06),('14598','2013-06-18','14:25:00',5.06),('14598','2013-06-18','14:30:00',5.05),('14598','2013-06-18','14:35:00',5.05),('14598','2013-06-18','14:40:00',5.05),('14598','2013-06-18','14:45:00',5.03),('14598','2013-06-18','14:50:00',5.03),('14598','2013-06-18','14:55:00',4.99),('14598','2013-06-18','15:00:00',4.95),('14598','2013-06-18','15:05:00',4.84),('14598','2013-06-18','15:10:00',4.82),('14598','2013-06-18','15:15:00',4.76),('14598','2013-06-18','15:20:00',4.73),('14598','2013-06-18','15:25:00',4.69),('14598','2013-06-18','15:30:00',4.64),('14598','2013-06-18','15:35:00',4.62),('14598','2013-06-18','15:40:00',4.57),('14598','2013-06-18','15:45:00',4.51),('14598','2013-06-18','15:50:00',4.47),('14598','2013-06-18','15:55:00',4.43),('14598','2013-06-18','16:00:00',4.41),('14598','2013-06-18','16:05:00',4.34),('14598','2013-06-18','16:10:00',4.31),('14598','2013-06-18','16:15:00',4.24),('14598','2013-06-18','16:20:00',4.18),('14598','2013-06-18','16:25:00',4.13),('14598','2013-06-18','16:30:00',4.07),('14598','2013-06-18','16:35:00',4.03),('14598','2013-06-18','16:40:00',3.96),('14598','2013-06-18','16:45:00',3.89),('14598','2013-06-18','16:50:00',3.8),('14598','2013-06-18','16:55:00',3.78),('14598','2013-06-18','17:00:00',3.71),('14598','2013-06-18','17:05:00',3.62),('14598','2013-06-18','17:10:00',3.53),('14598','2013-06-18','17:15:00',3.45),('14598','2013-06-18','17:20:00',3.38),('14598','2013-06-18','17:25:00',3.3),('14598','2013-06-18','17:30:00',3.2),('14598','2013-06-18','17:35:00',3.11),('14598','2013-06-18','17:40:00',3.01),('14598','2013-06-18','17:45:00',2.93),('14598','2013-06-18','17:50:00',2.83),('14598','2013-06-18','17:55:00',2.75),('14598','2013-06-18','18:00:00',2.67),('14598','2013-06-18','18:05:00',2.54),('14598','2013-06-18','18:10:00',2.46),('14598','2013-06-18','18:15:00',2.35),('14598','2013-06-18','18:20:00',2.27),('14598','2013-06-18','18:25:00',2.19),('14598','2013-06-18','18:30:00',2.1),('14598','2013-06-18','18:35:00',1.98),('14598','2013-06-18','18:40:00',1.88),('14598','2013-06-18','18:45:00',1.79),('14598','2013-06-18','18:50:00',1.69),('14598','2013-06-18','18:55:00',1.59),('14598','2013-06-18','19:00:00',1.5),('14598','2013-06-18','19:05:00',1.38),('14598','2013-06-18','19:10:00',1.28),('14598','2013-06-18','19:15:00',1.18),('14598','2013-06-18','19:20:00',1.09),('14598','2013-06-17','07:50:00',1.01),('14598','2013-06-17','07:55:00',1.09),('14598','2013-06-17','08:00:00',1.16),('14598','2013-06-17','08:05:00',1.25),('14598','2013-06-17','08:10:00',1.33),('14598','2013-06-17','08:15:00',1.41),('14598','2013-06-17','08:20:00',1.5),('14598','2013-06-17','08:25:00',1.59),('14598','2013-06-17','08:30:00',1.69),('14598','2013-06-17','08:35:00',1.8),('14598','2013-06-17','08:40:00',1.88),('14598','2013-06-17','08:45:00',2.02),('14598','2013-06-17','08:50:00',2.11),('14598','2013-06-17','08:55:00',2.21),('14598','2013-06-17','09:00:00',2.29),('14598','2013-06-17','09:05:00',2.39),('14598','2013-06-17','09:10:00',2.48),('14598','2013-06-17','09:15:00',2.56),('14598','2013-06-17','09:20:00',2.66),('14598','2013-06-17','09:25:00',2.73),('14598','2013-06-17','09:30:00',2.83),('14598','2013-06-17','09:35:00',2.9),('14598','2013-06-17','09:40:00',3.02),('14598','2013-06-17','09:45:00',3.1),('14598','2013-06-17','09:50:00',3.17),('14598','2013-06-17','09:55:00',3.25),('14598','2013-06-17','10:00:00',3.31),('14598','2013-06-17','10:05:00',3.39),('14598','2013-06-17','10:10:00',3.48),('14598','2013-06-17','10:15:00',3.56),('14598','2013-06-17','10:20:00',3.63),('14598','2013-06-17','10:25:00',3.7),('14598','2013-06-17','10:30:00',3.77),('14598','2013-06-17','10:35:00',3.85),('14598','2013-06-17','10:40:00',3.9),('14598','2013-06-17','10:45:00',3.97),('14598','2013-06-17','10:50:00',4.03),('14598','2013-06-17','10:55:00',4.1),('14598','2013-06-17','11:00:00',4.17),('14598','2013-06-17','11:05:00',4.21),('14598','2013-06-17','11:10:00',4.27),('14598','2013-06-17','11:15:00',4.32),('14598','2013-06-17','11:20:00',4.34),('14598','2013-06-17','11:25:00',4.39),('14598','2013-06-17','11:30:00',4.45),('14598','2013-06-17','11:35:00',4.5),('14598','2013-06-17','11:40:00',4.56),('14598','2013-06-17','11:45:00',4.62),('14598','2013-06-17','11:50:00',4.66),('14598','2013-06-17','11:55:00',4.7),('14598','2013-06-17','12:00:00',4.73),('14598','2013-06-17','12:05:00',4.76),('14598','2013-06-17','12:10:00',4.82),('14598','2013-06-17','12:15:00',4.86),('14598','2013-06-17','12:20:00',4.88),('14598','2013-06-17','12:25:00',4.9),('14598','2013-06-17','12:30:00',4.91),('14598','2013-06-17','12:35:00',4.87),('14598','2013-06-17','12:40:00',4.96),('14598','2013-06-17','12:45:00',5),('14598','2013-06-17','12:50:00',5.01),('14598','2013-06-17','12:55:00',5.02),('14598','2013-06-17','13:00:00',5.04),('14598','2013-06-17','13:05:00',5.02),('14598','2013-06-17','13:10:00',5.05),('14598','2013-06-17','13:15:00',5.03),('14598','2013-06-17','13:20:00',5.05),('14598','2013-06-17','13:25:00',5.05),('14598','2013-06-17','13:30:00',5.07),('14598','2013-06-17','13:35:00',5.06),('14598','2013-06-17','13:40:00',5.07),('14598','2013-06-17','13:45:00',5.05),('14598','2013-06-17','13:50:00',5.03),('14598','2013-06-17','13:55:00',5.04),('14598','2013-06-17','14:00:00',5.05),('14598','2013-06-17','14:05:00',5.05),('14598','2013-06-17','14:10:00',5.03),('14598','2013-06-17','14:15:00',5.02),('14598','2013-06-17','14:20:00',5.01),('14598','2013-06-17','14:25:00',5.01),('14598','2013-06-17','14:30:00',4.97),('14598','2013-06-17','14:35:00',4.95),('14598','2013-06-17','14:40:00',4.92),('14598','2013-06-17','14:45:00',4.93),('14598','2013-06-17','14:50:00',4.91),('14598','2013-06-17','14:55:00',4.89),('14598','2013-06-17','15:00:00',4.85),('14598','2013-06-17','15:05:00',4.82),('14598','2013-06-17','15:10:00',4.78),('14598','2013-06-17','15:15:00',4.74),('14598','2013-06-17','15:20:00',4.72),('14598','2013-06-17','15:25:00',4.67),('14598','2013-06-17','15:30:00',4.65),('14598','2013-06-17','15:35:00',4.59),('14598','2013-06-17','15:40:00',4.6),('14598','2013-06-17','15:45:00',4.57),('14598','2013-06-17','15:50:00',4.52),('14598','2013-06-17','15:55:00',4.49),('14598','2013-06-17','16:00:00',4.43),('14598','2013-06-17','16:05:00',4.37),('14598','2013-06-17','16:10:00',4.31),('14598','2013-06-17','16:15:00',4.25),('14598','2013-06-17','16:20:00',4.18),('14598','2013-06-17','16:25:00',4.1),('14598','2013-06-17','16:30:00',4.05),('14598','2013-06-17','16:35:00',3.98),('14598','2013-06-17','16:40:00',3.92),('14598','2013-06-17','16:45:00',3.86),('14598','2013-06-17','16:50:00',3.8),('14598','2013-06-17','16:55:00',3.76),('14598','2013-06-17','17:00:00',3.7),('14598','2013-06-17','17:05:00',3.64),('14598','2013-06-17','17:10:00',3.56),('14598','2013-06-17','17:15:00',3.47),('14598','2013-06-17','17:20:00',3.38),('14598','2013-06-17','17:25:00',3.3),('14598','2013-06-17','17:30:00',3.23),('14598','2013-06-17','17:35:00',3.14),('14598','2013-06-17','17:40:00',3.05),('14598','2013-06-17','17:45:00',2.98),('14598','2013-06-17','17:50:00',2.89),('14598','2013-06-17','17:55:00',2.83),('14598','2013-06-17','18:00:00',2.73),('14598','2013-06-17','18:05:00',2.64),('14598','2013-06-17','18:10:00',2.54),('14598','2013-06-17','18:15:00',2.46),('14598','2013-06-17','18:20:00',2.36),('14598','2013-06-17','18:25:00',2.26),('14598','2013-06-17','18:30:00',2.15),('14598','2013-06-17','18:35:00',2.06),('14598','2013-06-17','18:40:00',1.93),('14598','2013-06-17','18:45:00',1.84),('14598','2013-06-17','18:50:00',1.74),('14598','2013-06-17','18:55:00',1.66),('14598','2013-06-17','19:00:00',1.56),('14598','2013-06-17','19:05:00',1.46),('14598','2013-06-17','19:10:00',1.36),('14598','2013-06-17','19:15:00',1.26),('14598','2013-06-17','19:20:00',1.16),('14598','2013-06-17','19:25:00',1.05),('14598','2013-06-16','07:50:00',1.05),('14598','2013-06-16','07:55:00',1.14),('14598','2013-06-16','08:00:00',1.21),('14598','2013-06-16','08:05:00',1.28),('14598','2013-06-16','08:10:00',1.36),('14598','2013-06-16','08:15:00',1.44),('14598','2013-06-16','08:20:00',1.59),('14598','2013-06-16','08:25:00',1.66),('14598','2013-06-16','08:30:00',1.74),('14598','2013-06-16','08:35:00',1.88),('14598','2013-06-16','08:40:00',1.97),('14598','2013-06-16','08:45:00',2.1),('14598','2013-06-16','08:50:00',2.17),('14598','2013-06-16','08:55:00',2.29),('14598','2013-06-16','09:00:00',2.32),('14598','2013-06-16','09:05:00',2.43),('14598','2013-06-16','09:10:00',1.71),('14598','2013-06-16','09:15:00',2.58),('14598','2013-06-16','09:20:00',2.69),('14598','2013-06-16','09:25:00',2.76),('14598','2013-06-16','09:30:00',2.93),('14598','2013-06-16','09:35:00',3.04),('14598','2013-06-16','09:40:00',3.13),('14598','2013-06-16','09:45:00',3.21),('14598','2013-06-16','09:50:00',3.3),('14598','2013-06-16','09:55:00',3.38),('14598','2013-06-16','10:00:00',3.44),('14598','2013-06-16','10:05:00',3.52),('14598','2013-06-16','10:10:00',3.59),('14598','2013-06-16','10:15:00',3.66),('14598','2013-06-16','10:20:00',3.71),('14598','2013-06-16','10:25:00',3.8),('14598','2013-06-16','10:30:00',3.86),('14598','2013-06-16','10:35:00',3.93),('14598','2013-06-16','10:40:00',3.98),('14598','2013-06-16','10:45:00',4.06),('14598','2013-06-16','10:50:00',4.09),('14598','2013-06-16','10:55:00',4.17),('14598','2013-06-16','11:00:00',4.24),('14598','2013-06-16','11:05:00',4.28),('14598','2013-06-16','11:10:00',4.37),('14598','2013-06-16','11:15:00',4.4),('14598','2013-06-16','11:20:00',4.46),('14598','2013-06-16','11:25:00',4.51),('14598','2013-06-16','11:30:00',4.55),('14598','2013-06-16','11:35:00',4.6),('14598','2013-06-16','11:40:00',4.65),('14598','2013-06-16','11:45:00',4.69),('14598','2013-06-16','11:50:00',4.72),('14598','2013-06-16','11:55:00',4.76),('14598','2013-06-16','12:00:00',4.81),('14598','2013-06-16','12:05:00',4.84),('14598','2013-06-16','12:10:00',4.86),('14598','2013-06-16','12:15:00',4.89),('14598','2013-06-16','12:20:00',4.89),('14598','2013-06-16','12:25:00',4.96),('14598','2013-06-16','12:30:00',4.98),('14598','2013-06-16','12:35:00',5.01),('14598','2013-06-16','12:40:00',5.04),('14598','2013-06-16','12:45:00',5.05),('14598','2013-06-16','12:50:00',5.06),('14598','2013-06-16','12:55:00',5.09),('14598','2013-06-16','13:00:00',5.1),('14598','2013-06-16','13:05:00',5.12),('14598','2013-06-16','13:10:00',5.13),('14598','2013-06-16','13:15:00',5.13),('14598','2013-06-16','13:20:00',5.16),('14598','2013-06-16','13:25:00',5.15),('14598','2013-06-16','13:30:00',5.13),('14598','2013-06-16','13:35:00',5.15),('14598','2013-06-16','13:40:00',5.15),('14598','2013-06-16','13:45:00',5.17),('14598','2013-06-16','13:50:00',5.18),('14598','2013-06-16','13:55:00',5.16),('14598','2013-06-16','14:00:00',5.15),('14598','2013-06-16','14:05:00',5.09),('14598','2013-06-16','14:10:00',5.14),('14598','2013-06-16','14:15:00',5.11),('14598','2013-06-16','14:20:00',5.11),('14598','2013-06-16','14:25:00',5.11),('14598','2013-06-16','14:30:00',5.06),('14598','2013-06-16','14:35:00',5.04),('14598','2013-06-16','14:40:00',5.03),('14598','2013-06-16','14:45:00',5.01),('14598','2013-06-16','14:50:00',4.96),('14598','2013-06-16','14:55:00',4.93),('14598','2013-06-16','15:00:00',4.9),('14598','2013-06-16','15:05:00',4.88),('14598','2013-06-16','15:10:00',4.85),('14598','2013-06-16','15:15:00',4.81),('14598','2013-06-16','15:20:00',4.78),('14598','2013-06-16','15:25:00',4.73),('14598','2013-06-16','15:30:00',4.7),('14598','2013-06-16','15:35:00',4.66),('14598','2013-06-16','15:40:00',4.63),('14598','2013-06-16','15:45:00',4.58),('14598','2013-06-16','15:50:00',4.45),('14598','2013-06-16','15:55:00',4.48),('14598','2013-06-16','16:00:00',4.42),('14598','2013-06-16','16:05:00',4.38),('14598','2013-06-16','16:10:00',4.32),('14598','2013-06-16','16:15:00',4.28),('14598','2013-06-16','16:20:00',4.21),('14598','2013-06-16','16:25:00',4.16),('14598','2013-06-16','16:30:00',4.09),('14598','2013-06-16','16:35:00',4.04),('14598','2013-06-16','16:40:00',3.98),('14598','2013-06-16','16:45:00',3.91),('14598','2013-06-16','16:50:00',3.82),('14598','2013-06-16','16:55:00',3.74),('14598','2013-06-16','17:00:00',3.67),('14598','2013-06-16','17:05:00',3.57),('14598','2013-06-16','17:10:00',3.53),('14598','2013-06-16','17:15:00',3.45),('14598','2013-06-16','17:20:00',3.38),('14598','2013-06-16','17:25:00',3.31),('14598','2013-06-16','17:30:00',3.22),('14598','2013-06-16','17:35:00',3.12),('14598','2013-06-16','17:40:00',3.04),('14598','2013-06-16','17:45:00',2.95),('14598','2013-06-16','17:50:00',2.85),('14598','2013-06-16','17:55:00',2.76),('14598','2013-06-16','18:00:00',2.67),('14598','2013-06-16','18:05:00',2.57),('14598','2013-06-16','18:10:00',2.49),('14598','2013-06-16','18:15:00',2.39),('14598','2013-06-16','18:20:00',2.29),('14598','2013-06-16','18:25:00',2.2),('14598','2013-06-16','18:30:00',2.1),('14598','2013-06-16','18:35:00',2),('14598','2013-06-16','18:40:00',1.9),('14598','2013-06-16','18:45:00',1.79),('14598','2013-06-16','18:50:00',1.7),('14598','2013-06-16','18:55:00',1.59),('14598','2013-06-16','19:00:00',1.48),('14598','2013-06-16','19:05:00',1.38),('14598','2013-06-16','19:10:00',1.27),('14598','2013-06-16','19:15:00',1.16),('14598','2013-06-16','19:20:00',1.07),('14598','2013-06-15','07:40:00',1.14),('14598','2013-06-15','07:45:00',1.28),('14598','2013-06-15','07:50:00',1.52),('14598','2013-06-15','07:55:00',1.04),('14598','2013-06-15','08:05:00',1.07),('14598','2013-06-15','08:10:00',1.09),('14598','2013-06-15','08:15:00',1.08),('14598','2013-06-15','08:20:00',1.43),('14598','2013-06-15','08:25:00',1.07),('14598','2013-06-15','08:30:00',1.16),('14598','2013-06-15','08:40:00',1.03),('14598','2013-06-15','08:45:00',1.25),('14598','2013-06-15','08:50:00',1.17),('14598','2013-06-15','08:55:00',2.31),('14598','2013-06-15','09:00:00',2.3),('14598','2013-06-15','09:05:00',2.2),('14598','2013-06-15','09:10:00',2.22),('14598','2013-06-15','09:15:00',2.07),('14598','2013-06-15','09:20:00',2.63),('14598','2013-06-15','09:25:00',2.43),('14598','2013-06-15','09:30:00',2.81),('14598','2013-06-15','09:35:00',3.09),('14598','2013-06-15','09:40:00',3.02),('14598','2013-06-15','09:45:00',3.25),('14598','2013-06-15','09:50:00',3.31),('14598','2013-06-15','09:55:00',3.38),('14598','2013-06-15','10:00:00',3.45),('14598','2013-06-15','10:05:00',3.5),('14598','2013-06-15','10:10:00',3.56),('14598','2013-06-15','10:15:00',3.65),('14598','2013-06-15','10:20:00',3.69),('14598','2013-06-15','10:25:00',3.81),('14598','2013-06-15','10:30:00',3.9),('14598','2013-06-15','10:35:00',3.94),('14598','2013-06-15','10:40:00',4.01),('14598','2013-06-15','10:45:00',4.08),('14598','2013-06-15','10:50:00',4.18),('14598','2013-06-15','10:55:00',4.22),('14598','2013-06-15','11:00:00',4.29),('14598','2013-06-15','11:05:00',4.37),('14598','2013-06-15','11:10:00',4.4),('14598','2013-06-15','11:15:00',4.18),('14598','2013-06-15','11:20:00',4.48),('14598','2013-06-15','11:25:00',4.56),('14598','2013-06-15','11:30:00',4.65),('14598','2013-06-15','11:35:00',4.62),('14598','2013-06-15','11:40:00',4.72),('14598','2013-06-15','11:45:00',4.74),('14598','2013-06-15','11:50:00',4.69),('14598','2013-06-15','11:55:00',4.77),('14598','2013-06-15','12:00:00',4.82),('14598','2013-06-15','12:05:00',4.79),('14598','2013-06-15','12:10:00',4.91),('14598','2013-06-15','12:15:00',4.88),('14598','2013-06-15','12:20:00',4.5),('14598','2013-06-15','12:25:00',4.92),('14598','2013-06-15','12:30:00',4.98),('14598','2013-06-15','12:35:00',5),('14598','2013-06-15','12:40:00',5),('14598','2013-06-15','12:45:00',5.02),('14598','2013-06-15','12:50:00',5.06),('14598','2013-06-15','12:55:00',5.07),('14598','2013-06-15','13:00:00',5.1),('14598','2013-06-15','13:05:00',5.12),('14598','2013-06-15','13:10:00',5.12),('14598','2013-06-15','13:15:00',5.16),('14598','2013-06-15','13:20:00',5.15),('14598','2013-06-15','13:25:00',5.19),('14598','2013-06-15','13:30:00',5.23),('14598','2013-06-15','13:35:00',5.18),('14598','2013-06-15','13:40:00',5.18),('14598','2013-06-15','13:45:00',5.13),('14598','2013-06-15','13:50:00',5.18),('14598','2013-06-15','13:55:00',5.17),('14598','2013-06-15','14:00:00',5.1),('14598','2013-06-15','14:05:00',5.11),('14598','2013-06-15','14:10:00',5.2),('14598','2013-06-15','14:15:00',5.15),('14598','2013-06-15','14:20:00',5.08),('14598','2013-06-15','14:25:00',5.1),('14598','2013-06-15','14:30:00',5.08),('14598','2013-06-15','14:35:00',5.06),('14598','2013-06-15','14:40:00',5.04),('14598','2013-06-15','14:45:00',5.03),('14598','2013-06-15','14:50:00',4.99),('14598','2013-06-15','14:55:00',4.96),('14598','2013-06-15','15:00:00',4.94),('14598','2013-06-15','15:05:00',4.91),('14598','2013-06-15','15:10:00',4.87),('14598','2013-06-15','15:15:00',4.83),('14598','2013-06-15','15:20:00',4.8),('14598','2013-06-15','15:25:00',4.74),('14598','2013-06-15','15:30:00',4.69),('14598','2013-06-15','15:35:00',4.66),('14598','2013-06-15','15:40:00',4.6),('14598','2013-06-15','15:45:00',4.56),('14598','2013-06-15','15:50:00',4.51),('14598','2013-06-15','15:55:00',4.47),('14598','2013-06-15','16:00:00',4.4),('14598','2013-06-15','16:05:00',4.34),('14598','2013-06-15','16:10:00',4.3),('14598','2013-06-15','16:15:00',4.24),('14598','2013-06-15','16:20:00',4.17),('14598','2013-06-15','16:25:00',4.11),('14598','2013-06-15','16:30:00',4.05),('14598','2013-06-15','16:35:00',3.99),('14598','2013-06-15','16:40:00',3.92),('14598','2013-06-15','16:45:00',3.86),('14598','2013-06-15','16:50:00',3.8),('14598','2013-06-15','16:55:00',3.74),('14598','2013-06-15','17:00:00',3.65),('14598','2013-06-15','17:05:00',3.57),('14598','2013-06-15','17:10:00',3.5),('14598','2013-06-15','17:15:00',3.42),('14598','2013-06-15','17:20:00',3.34),('14598','2013-06-15','17:25:00',3.26),('14598','2013-06-15','17:30:00',3.19),('14598','2013-06-15','17:35:00',3.07),('14598','2013-06-15','17:40:00',3),('14598','2013-06-15','17:45:00',2.93),('14598','2013-06-15','17:50:00',2.84),('14598','2013-06-15','17:55:00',2.72),('14598','2013-06-15','18:00:00',2.64),('14598','2013-06-15','18:05:00',2.53),('14598','2013-06-15','18:10:00',2.39),('14598','2013-06-15','18:15:00',2.35),('14598','2013-06-15','18:20:00',2.26),('14598','2013-06-15','18:25:00',2.16),('14598','2013-06-15','18:30:00',2.07),('14598','2013-06-15','18:35:00',1.98),('14598','2013-06-15','18:40:00',1.88),('14598','2013-06-15','18:45:00',1.79),('14598','2013-06-15','18:50:00',1.68),('14598','2013-06-15','18:55:00',1.57),('14598','2013-06-15','19:00:00',1.47),('14598','2013-06-15','19:05:00',1.36),('14598','2013-06-15','19:10:00',1.25),('14598','2013-06-15','19:15:00',1.16),('14598','2013-06-15','19:20:00',1.06),('14598','2013-06-14','07:50:00',1.09),('14598','2013-06-14','07:55:00',1.17),('14598','2013-06-14','08:00:00',1.26),('14598','2013-06-14','08:05:00',1.35),('14598','2013-06-14','08:10:00',1.43),('14598','2013-06-14','08:15:00',1.53),('14598','2013-06-14','08:20:00',1.63),('14598','2013-06-14','08:25:00',1.72),('14598','2013-06-14','08:30:00',1.8),('14598','2013-06-14','08:35:00',1.93),('14598','2013-06-14','08:40:00',2.02),('14598','2013-06-14','08:45:00',2.15),('14598','2013-06-14','08:50:00',2.25),('14598','2013-06-14','08:55:00',2.35),('14598','2013-06-14','09:00:00',2.44),('14598','2013-06-14','09:05:00',2.52),('14598','2013-06-14','09:10:00',2.59),('14598','2013-06-14','09:15:00',2.69),('14598','2013-06-14','09:20:00',2.79),('14598','2013-06-14','09:25:00',2.93),('14598','2013-06-14','09:30:00',3.02),('14598','2013-06-14','09:35:00',3.08),('14598','2013-06-14','09:40:00',3.16),('14598','2013-06-14','09:45:00',3.22),('14598','2013-06-14','09:50:00',3.33),('14598','2013-06-14','09:55:00',3.4),('14598','2013-06-14','10:00:00',3.47),('14598','2013-06-14','10:05:00',3.62),('14598','2013-06-14','10:10:00',3.72),('14598','2013-06-14','10:15:00',3.8),('14598','2013-06-14','10:20:00',3.88),('14598','2013-06-14','10:25:00',3.94),('14598','2013-06-14','10:30:00',4.03),('14598','2013-06-14','10:35:00',4.15),('14598','2013-06-14','10:40:00',4.27),('14598','2013-06-14','10:45:00',4.27),('14598','2013-06-14','10:50:00',4.13),('14598','2013-06-14','10:55:00',4.42),('14598','2013-06-14','11:00:00',4.28),('14598','2013-06-14','11:05:00',4.1),('14598','2013-06-14','11:10:00',4.33),('14598','2013-06-14','11:15:00',4.55),('14598','2013-06-14','11:20:00',4.58),('14598','2013-06-14','11:25:00',4.69),('14598','2013-06-14','11:30:00',4.69),('14598','2013-06-14','11:35:00',4.58),('14598','2013-06-14','11:40:00',4.71),('14598','2013-06-14','11:45:00',4.86),('14598','2013-06-14','11:50:00',4.92),('14598','2013-06-14','11:55:00',4.95),('14598','2013-06-14','12:00:00',4.99),('14598','2013-06-14','12:05:00',5.01),('14598','2013-06-14','12:10:00',5.02),('14598','2013-06-14','12:15:00',5.07),('14598','2013-06-14','12:20:00',5.08),('14598','2013-06-14','12:25:00',5.1),('14598','2013-06-14','12:30:00',5.1),('14598','2013-06-14','12:35:00',5.12),('14598','2013-06-14','12:40:00',5.12),('14598','2013-06-14','12:45:00',5.16),('14598','2013-06-14','12:50:00',5.13),('14598','2013-06-14','12:55:00',5.2),('14598','2013-06-14','13:00:00',5.25),('14598','2013-06-14','13:05:00',5.28),('14598','2013-06-14','13:10:00',5.31),('14598','2013-06-14','13:15:00',5.33),('14598','2013-06-14','13:20:00',5.35),('14598','2013-06-14','13:25:00',5.39),('14598','2013-06-14','13:30:00',5.39),('14598','2013-06-14','13:35:00',5.37),('14598','2013-06-14','13:40:00',5.35),('14598','2013-06-14','13:45:00',5.39),('14598','2013-06-14','13:50:00',5.38),('14598','2013-06-14','13:55:00',5.32),('14598','2013-06-14','14:00:00',5.31),('14598','2013-06-14','14:05:00',5.28),('14598','2013-06-14','14:10:00',5.27),('14598','2013-06-14','14:15:00',5.27),('14598','2013-06-14','14:20:00',5.27),('14598','2013-06-14','14:25:00',5.29),('14598','2013-06-14','14:30:00',5.27),('14598','2013-06-14','14:35:00',5.15),('14598','2013-06-14','14:40:00',5.24),('14598','2013-06-14','14:45:00',5.2),('14598','2013-06-14','14:50:00',5.19),('14598','2013-06-14','14:55:00',5.18),('14598','2013-06-14','15:00:00',5.14),('14598','2013-06-14','15:05:00',5.12),('14598','2013-06-14','15:10:00',5.05),('14598','2013-06-14','15:15:00',5),('14598','2013-06-14','15:20:00',4.97),('14598','2013-06-14','15:25:00',4.9),('14598','2013-06-14','15:30:00',4.86),('14598','2013-06-14','15:35:00',4.81),('14598','2013-06-14','15:40:00',4.79),('14598','2013-06-14','15:45:00',4.75),('14598','2013-06-14','15:50:00',4.66),('14598','2013-06-14','15:55:00',4.64),('14598','2013-06-14','16:00:00',4.57),('14598','2013-06-14','16:05:00',4.52),('14598','2013-06-14','16:10:00',4.5),('14598','2013-06-14','16:15:00',4.45),('14598','2013-06-14','16:20:00',4.4),('14598','2013-06-14','16:25:00',4.36),('14598','2013-06-14','16:30:00',4.28),('14598','2013-06-14','16:35:00',4.19),('14598','2013-06-14','16:40:00',4.1),('14598','2013-06-14','16:45:00',4.04),('14598','2013-06-14','16:50:00',3.92),('14598','2013-06-14','16:55:00',3.89),('14598','2013-06-14','17:00:00',3.81),('14598','2013-06-14','17:05:00',3.78),('14598','2013-06-14','17:10:00',3.69),('14598','2013-06-14','17:15:00',3.63),('14598','2013-06-14','17:20:00',3.49),('14598','2013-06-14','17:25:00',3.43),('14598','2013-06-14','17:30:00',3.35),('14598','2013-06-14','17:35:00',3.22),('14598','2013-06-14','17:40:00',3.17),('14598','2013-06-14','17:45:00',3.08),('14598','2013-06-14','17:50:00',2.98),('14598','2013-06-14','17:55:00',2.88),('14598','2013-06-14','18:00:00',2.79),('14598','2013-06-14','18:05:00',2.69),('14598','2013-06-14','18:10:00',2.59),('14598','2013-06-14','18:15:00',2.51),('14598','2013-06-14','18:20:00',2.43),('14598','2013-06-14','18:25:00',2.32),('14598','2013-06-14','18:30:00',2.21),('14598','2013-06-14','18:35:00',2.11),('14598','2013-06-14','18:40:00',2.01),('14598','2013-06-14','18:45:00',1.89),('14598','2013-06-14','18:50:00',1.79),('14598','2013-06-14','18:55:00',1.68),('14598','2013-06-14','19:00:00',1.57),('14598','2013-06-14','19:05:00',1.46),('14598','2013-06-14','19:10:00',1.35),('14598','2013-06-14','19:15:00',1.26),('14598','2013-06-14','19:20:00',1.14),('14598','2013-06-14','19:25:00',1.04),('14598','2013-06-13','07:45:00',1.01),('14598','2013-06-13','07:50:00',1.09),('14598','2013-06-13','07:55:00',1.18),('14598','2013-06-13','08:00:00',1.27),('14598','2013-06-13','08:05:00',1.36),('14598','2013-06-13','08:10:00',1.46),('14598','2013-06-13','08:15:00',1.56),('14598','2013-06-13','08:20:00',1.66),('14598','2013-06-13','08:25:00',1.75),('14598','2013-06-13','08:30:00',1.85),('14598','2013-06-13','08:35:00',1.96),('14598','2013-06-13','08:40:00',2.06),('14598','2013-06-13','08:45:00',2.19),('14598','2013-06-13','08:50:00',2.3),('14598','2013-06-13','08:55:00',2.41),('14598','2013-06-13','09:00:00',2.5),('14598','2013-06-13','09:05:00',2.59),('14598','2013-06-13','09:10:00',2.68),('14598','2013-06-13','09:15:00',2.78),('14598','2013-06-13','09:20:00',2.86),('14598','2013-06-13','09:25:00',2.96),('14598','2013-06-13','09:30:00',3.04),('14598','2013-06-13','09:35:00',3.13),('14598','2013-06-13','09:40:00',3.21),('14598','2013-06-13','09:45:00',3.28),('14598','2013-06-13','09:50:00',3.37),('14598','2013-06-13','09:55:00',3.43),('14598','2013-06-13','10:00:00',3.49),('14598','2013-06-13','10:05:00',3.56),('14598','2013-06-13','10:10:00',3.63),('14598','2013-06-13','10:15:00',3.7),('14598','2013-06-13','10:20:00',3.78),('14598','2013-06-13','10:25:00',3.84),('14598','2013-06-13','10:30:00',3.9),('14598','2013-06-13','10:35:00',3.94),('14598','2013-06-13','10:40:00',3.99),('14598','2013-06-13','10:45:00',4.06),('14598','2013-06-13','10:50:00',4.12),('14598','2013-06-13','10:55:00',4.16),('14598','2013-06-13','11:00:00',4.19),('14598','2013-06-13','11:05:00',4.23),('14598','2013-06-13','11:10:00',4.26),('14598','2013-06-13','11:15:00',4.31),('14598','2013-06-13','11:20:00',4.37),('14598','2013-06-13','11:25:00',4.47),('14598','2013-06-13','11:30:00',4.54),('14598','2013-06-13','11:35:00',4.57),('14598','2013-06-13','11:40:00',4.63),('14598','2013-06-13','11:45:00',4.73),('14598','2013-06-13','11:50:00',4.8),('14598','2013-06-13','11:55:00',4.84),('14598','2013-06-13','12:00:00',4.86),('14598','2013-06-13','12:05:00',4.91),('14598','2013-06-13','12:10:00',4.97),('14598','2013-06-13','12:15:00',5.01),('14598','2013-06-13','12:20:00',5),('14598','2013-06-13','12:25:00',5.05),('14598','2013-06-13','12:30:00',5.06),('14598','2013-06-13','12:35:00',5.11),('14598','2013-06-13','12:40:00',5.15),('14598','2013-06-13','12:45:00',5.17),('14598','2013-06-13','12:50:00',5.23),('14598','2013-06-13','12:55:00',5.25),('14598','2013-06-13','13:00:00',5.26),('14598','2013-06-13','13:05:00',5.29),('14598','2013-06-13','13:10:00',5.33),('14598','2013-06-13','13:15:00',5.32),('14598','2013-06-13','13:20:00',5.33),('14598','2013-06-13','13:25:00',5.37),('14598','2013-06-13','13:30:00',5.37),('14598','2013-06-13','13:35:00',5.36),('14598','2013-06-13','13:40:00',5.34),('14598','2013-06-13','13:45:00',5.35),('14598','2013-06-13','13:50:00',5.33),('14598','2013-06-13','13:55:00',5.32),('14598','2013-06-13','14:00:00',5.32),('14598','2013-06-13','14:05:00',5.3),('14598','2013-06-13','14:10:00',5.3),('14598','2013-06-13','14:15:00',5.28),('14598','2013-06-13','14:20:00',5.28),('14598','2013-06-13','14:25:00',5.3),('14598','2013-06-13','14:30:00',5.26),('14598','2013-06-13','14:35:00',5.23),('14598','2013-06-13','14:40:00',5.22),('14598','2013-06-13','14:45:00',5.18),('14598','2013-06-13','14:50:00',5.16),('14598','2013-06-13','14:55:00',5.13),('14598','2013-06-13','15:00:00',5.08),('14598','2013-06-13','15:05:00',5.06),('14598','2013-06-13','15:10:00',5.03),('14598','2013-06-13','15:15:00',4.99),('14598','2013-06-13','15:20:00',4.89),('14598','2013-06-13','15:25:00',4.92),('14598','2013-06-13','15:30:00',4.85),('14598','2013-06-13','15:35:00',4.83),('14598','2013-06-13','15:40:00',4.76),('14598','2013-06-13','15:45:00',4.73),('14598','2013-06-13','15:50:00',4.7),('14598','2013-06-13','15:55:00',4.64),('14598','2013-06-13','16:00:00',4.57),('14598','2013-06-13','16:05:00',4.5),('14598','2013-06-13','16:10:00',4.49),('14598','2013-06-13','16:15:00',4.45),('14598','2013-06-13','16:20:00',4.35),('14598','2013-06-13','16:25:00',4.29),('14598','2013-06-13','16:30:00',4.24),('14598','2013-06-13','16:35:00',4.18),('14598','2013-06-13','16:40:00',4.09),('14598','2013-06-13','16:45:00',4.03),('14598','2013-06-13','16:50:00',4),('14598','2013-06-13','16:55:00',3.91),('14598','2013-06-13','17:00:00',3.81),('14598','2013-06-13','17:05:00',3.71),('14598','2013-06-13','17:10:00',3.54),('14598','2013-06-13','17:15:00',3.56),('14598','2013-06-13','17:20:00',3.49),('14598','2013-06-13','17:25:00',3.41),('14598','2013-06-13','17:30:00',3.32),('14598','2013-06-13','17:35:00',3.24),('14598','2013-06-13','17:40:00',3.17),('14598','2013-06-13','17:45:00',3.07),('14598','2013-06-13','17:50:00',2.97),('14598','2013-06-13','17:55:00',2.88),('14598','2013-06-13','18:00:00',2.8),('14598','2013-06-13','18:05:00',2.69),('14598','2013-06-13','18:10:00',2.59),('14598','2013-06-13','18:15:00',2.51),('14598','2013-06-13','18:20:00',2.4),('14598','2013-06-13','18:25:00',2.28),('14598','2013-06-13','18:30:00',2.2),('14598','2013-06-13','18:35:00',2.1),('14598','2013-06-13','18:40:00',1.99),('14598','2013-06-13','18:45:00',1.89),('14598','2013-06-13','18:50:00',1.78),('14598','2013-06-13','18:55:00',1.67),('14598','2013-06-13','19:00:00',1.56),('14598','2013-06-13','19:05:00',1.46),('14598','2013-06-13','19:10:00',1.35),('14598','2013-06-13','19:15:00',1.24),('14598','2013-06-13','19:20:00',1.13),('14598','2013-06-13','19:25:00',1.01),('14598','2013-06-12','07:50:00',1.09),('14598','2013-06-12','07:55:00',1.2),('14598','2013-06-12','08:00:00',1.29),('14598','2013-06-12','08:05:00',1.38),('14598','2013-06-12','08:10:00',1.47),('14598','2013-06-12','08:15:00',1.57),('14598','2013-06-12','08:20:00',1.66),('14598','2013-06-12','08:25:00',1.77),('14598','2013-06-12','08:30:00',1.87),('14598','2013-06-12','08:35:00',1.98),('14598','2013-06-12','08:40:00',2.08),('14598','2013-06-12','08:45:00',2.21),('14598','2013-06-12','08:50:00',2.31),('14598','2013-06-12','08:55:00',2.43),('14598','2013-06-12','09:00:00',2.52),('14598','2013-06-12','09:05:00',2.6),('14598','2013-06-12','09:10:00',2.69),('14598','2013-06-12','09:15:00',2.81),('14598','2013-06-12','09:20:00',2.9),('14598','2013-06-12','09:25:00',2.99),('14598','2013-06-12','09:30:00',3.05),('14598','2013-06-12','09:35:00',3.1),('14598','2013-06-12','09:40:00',3.22),('14598','2013-06-12','09:45:00',3.28),('14598','2013-06-12','09:50:00',3.36),('14598','2013-06-12','09:55:00',3.44),('14598','2013-06-12','10:00:00',3.52),('14598','2013-06-12','10:05:00',3.6),('14598','2013-06-12','10:10:00',3.67),('14598','2013-06-12','10:15:00',3.76),('14598','2013-06-12','10:20:00',3.82),('14598','2013-06-12','10:25:00',3.88),('14598','2013-06-12','10:30:00',3.95),('14598','2013-06-12','10:35:00',4.01),('14598','2013-06-12','10:40:00',4.06),('14598','2013-06-12','10:45:00',4.11),('14598','2013-06-12','10:50:00',4.11),('14598','2013-06-12','10:55:00',4.19),('14598','2013-06-12','11:00:00',4.26),('14598','2013-06-12','11:05:00',4.32),('14598','2013-06-12','11:10:00',4.35),('14598','2013-06-12','11:15:00',4.41),('14598','2013-06-12','11:20:00',4.49),('14598','2013-06-12','11:25:00',4.54),('14598','2013-06-12','11:30:00',4.57),('14598','2013-06-12','11:35:00',4.61),('14598','2013-06-12','11:40:00',4.69),('14598','2013-06-12','11:45:00',4.71),('14598','2013-06-12','11:50:00',4.71),('14598','2013-06-12','11:55:00',4.85),('14598','2013-06-12','12:00:00',4.91),('14598','2013-06-12','12:05:00',4.92),('14598','2013-06-12','12:10:00',4.99),('14598','2013-06-12','12:15:00',5),('14598','2013-06-12','12:20:00',5.02),('14598','2013-06-12','12:25:00',5.07),('14598','2013-06-12','12:30:00',5.15),('14598','2013-06-12','12:35:00',5.15),('14598','2013-06-12','12:40:00',5.21),('14598','2013-06-12','12:45:00',5.23),('14598','2013-06-12','12:50:00',5.28),('14598','2013-06-12','12:55:00',5.29),('14598','2013-06-12','13:00:00',5.28),('14598','2013-06-12','13:05:00',5.29),('14598','2013-06-12','13:10:00',5.31),('14598','2013-06-12','13:15:00',5.31),('14598','2013-06-12','13:20:00',5.33),('14598','2013-06-12','13:25:00',5.37),('14598','2013-06-12','13:30:00',5.39),('14598','2013-06-12','13:35:00',5.4),('14598','2013-06-12','13:40:00',5.4),('14598','2013-06-12','13:45:00',5.39),('14598','2013-06-12','13:50:00',5.32),('14598','2013-06-12','13:55:00',5.36),('14598','2013-06-12','14:00:00',5.37),('14598','2013-06-12','14:05:00',5.36),('14598','2013-06-12','14:10:00',5.32),('14598','2013-06-12','14:15:00',5.28),('14598','2013-06-12','14:20:00',5.29),('14598','2013-06-12','14:25:00',5.26),('14598','2013-06-12','14:30:00',5.28),('14598','2013-06-12','14:35:00',5.26),('14598','2013-06-12','14:40:00',5.21),('14598','2013-06-12','14:45:00',5.19),('14598','2013-06-12','14:50:00',5.19),('14598','2013-06-12','14:55:00',5.2),('14598','2013-06-12','15:00:00',5.14),('14598','2013-06-12','15:05:00',5.11),('14598','2013-06-12','15:10:00',5.08),('14598','2013-06-12','15:15:00',5.05),('14598','2013-06-12','15:20:00',5),('14598','2013-06-12','15:25:00',4.96),('14598','2013-06-12','15:30:00',4.92),('14598','2013-06-12','15:35:00',4.87),('14598','2013-06-12','15:40:00',4.77),('14598','2013-06-12','15:45:00',4.78),('14598','2013-06-12','15:50:00',4.71),('14598','2013-06-12','15:55:00',4.66),('14598','2013-06-12','16:00:00',4.61),('14598','2013-06-12','16:05:00',4.55),('14598','2013-06-12','16:10:00',4.51),('14598','2013-06-12','16:15:00',4.39),('14598','2013-06-12','16:20:00',4.36),('14598','2013-06-12','16:25:00',4.2),('14598','2013-06-12','16:30:00',4.24),('14598','2013-06-12','16:35:00',4.19),('14598','2013-06-12','16:40:00',4.11),('14598','2013-06-12','16:45:00',4.08),('14598','2013-06-12','16:50:00',3.96),('14598','2013-06-12','16:55:00',3.66),('14598','2013-06-12','17:00:00',2.02),('14598','2013-06-12','17:05:00',4.34),('14598','2013-06-12','17:10:00',4.06),('14598','2013-06-12','17:15:00',3.89),('14598','2013-06-12','17:20:00',3.92),('14598','2013-06-12','17:25:00',4.05),('14598','2013-06-12','17:30:00',4.01),('14598','2013-06-12','17:35:00',3.78),('14598','2013-06-12','17:40:00',3.78),('14598','2013-06-12','17:45:00',3.56),('14598','2013-06-12','17:50:00',3.5),('14598','2013-06-12','17:55:00',3.32),('14598','2013-06-12','18:00:00',3.32),('14598','2013-06-12','18:05:00',3.3),('14598','2013-06-12','18:10:00',3.04),('14598','2013-06-12','18:15:00',2.78),('14598','2013-06-12','18:20:00',2.68),('14598','2013-06-12','18:25:00',2.43),('14598','2013-06-12','18:30:00',2.24),('14598','2013-06-12','18:35:00',2.14),('14598','2013-06-12','18:40:00',1.99),('14598','2013-06-12','18:45:00',1.91),('14598','2013-06-12','18:50:00',1.79),('14598','2013-06-12','18:55:00',1.68),('14598','2013-06-12','19:00:00',1.57),('14598','2013-06-12','19:05:00',1.45),('14598','2013-06-12','19:10:00',1.35),('14598','2013-06-12','19:15:00',1.25),('14598','2013-06-12','19:20:00',1.13),('14598','2013-06-12','19:25:00',1),('14598','2013-06-11','07:50:00',1.07),('14598','2013-06-11','07:55:00',1.16),('14598','2013-06-11','08:00:00',1.25),('14598','2013-06-11','08:05:00',1.34),('14598','2013-06-11','08:10:00',1.43),('14598','2013-06-11','08:15:00',1.53),('14598','2013-06-11','08:20:00',1.63),('14598','2013-06-11','08:25:00',1.72),('14598','2013-06-11','08:30:00',1.83),('14598','2013-06-11','08:35:00',1.92),('14598','2013-06-11','08:40:00',2.02),('14598','2013-06-11','08:45:00',2.15),('14598','2013-06-11','08:50:00',2.25),('14598','2013-06-11','08:55:00',2.32),('14598','2013-06-11','09:00:00',2.43),('14598','2013-06-11','09:05:00',2.54),('14598','2013-06-11','09:10:00',2.63),('14598','2013-06-11','09:15:00',2.72),('14598','2013-06-11','09:20:00',2.84),('14598','2013-06-11','09:25:00',2.91),('14598','2013-06-11','09:30:00',3.01),('14598','2013-06-11','09:35:00',3.15),('14598','2013-06-11','09:40:00',3.26),('14598','2013-06-11','09:45:00',3.33),('14598','2013-06-11','09:50:00',3.41),('14598','2013-06-11','09:55:00',3.49),('14598','2013-06-11','10:00:00',3.56),('14598','2013-06-11','10:05:00',3.63),('14598','2013-06-11','10:10:00',3.71),('14598','2013-06-11','10:15:00',3.78),('14598','2013-06-11','10:20:00',3.86),('14598','2013-06-11','10:25:00',3.94),('14598','2013-06-11','10:30:00',3.99),('14598','2013-06-11','10:35:00',4.06),('14598','2013-06-11','10:40:00',4.12),('14598','2013-06-11','10:45:00',4.18),('14598','2013-06-11','10:50:00',4.2),('14598','2013-06-11','10:55:00',4.3),('14598','2013-06-11','11:00:00',4.38),('14598','2013-06-11','11:05:00',4.44),('14598','2013-06-11','11:10:00',4.52),('14598','2013-06-11','11:15:00',4.59),('14598','2013-06-11','11:20:00',4.65),('14598','2013-06-11','11:25:00',4.69),('14598','2013-06-11','11:30:00',4.76),('14598','2013-06-11','11:35:00',4.81),('14598','2013-06-11','11:40:00',4.83),('14598','2013-06-11','11:45:00',4.86),('14598','2013-06-11','11:50:00',4.9),('14598','2013-06-11','11:55:00',4.95),('14598','2013-06-11','12:00:00',4.99),('14598','2013-06-11','12:05:00',5.02),('14598','2013-06-11','12:10:00',5.08),('14598','2013-06-11','12:15:00',5.11),('14598','2013-06-11','12:20:00',5.16),('14598','2013-06-11','12:25:00',5.18),('14598','2013-06-11','12:30:00',5.2),('14598','2013-06-11','12:35:00',5.22),('14598','2013-06-11','12:40:00',5.24),('14598','2013-06-11','12:45:00',5.27),('14598','2013-06-11','12:50:00',5.3),('14598','2013-06-11','12:55:00',5.28),('14598','2013-06-11','13:00:00',5.29),('14598','2013-06-11','13:05:00',5.33),('14598','2013-06-11','13:10:00',5.35),('14598','2013-06-11','13:15:00',5.39),('14598','2013-06-11','13:20:00',5.38),('14598','2013-06-11','13:25:00',5.39),('14598','2013-06-11','13:30:00',5.38),('14598','2013-06-11','13:35:00',5.38),('14598','2013-06-11','13:40:00',5.4),('14598','2013-06-11','13:45:00',5.39),('14598','2013-06-11','13:50:00',5.32),('14598','2013-06-11','13:55:00',5.38),('14598','2013-06-11','14:00:00',5.37),('14598','2013-06-11','14:05:00',5.37),('14598','2013-06-11','14:10:00',5.37),('14598','2013-06-11','14:15:00',5.35),('14598','2013-06-11','14:20:00',5.34),('14598','2013-06-11','14:25:00',5.31),('14598','2013-06-11','14:30:00',5.29),('14598','2013-06-11','14:35:00',5.25),('14598','2013-06-11','14:40:00',5.23),('14598','2013-06-11','14:45:00',5.24),('14598','2013-06-11','14:50:00',5.21),('14598','2013-06-11','14:55:00',5.16),('14598','2013-06-11','15:00:00',5.16),('14598','2013-06-11','15:05:00',5.13),('14598','2013-06-11','15:10:00',5.03),('14598','2013-06-11','15:15:00',5.04),('14598','2013-06-11','15:20:00',4.99),('14598','2013-06-11','15:25:00',4.96),('14598','2013-06-11','15:30:00',4.92),('14598','2013-06-11','15:35:00',4.87),('14598','2013-06-11','15:40:00',4.82),('14598','2013-06-11','15:45:00',4.79),('14598','2013-06-11','15:50:00',4.74),('14598','2013-06-11','15:55:00',4.73),('14598','2013-06-11','16:00:00',4.68),('14598','2013-06-11','16:05:00',4.6),('14598','2013-06-11','16:10:00',4.53),('14598','2013-06-11','16:15:00',4.44),('14598','2013-06-11','16:20:00',4.4),('14598','2013-06-11','16:25:00',4.34),('14598','2013-06-11','16:30:00',4.27),('14598','2013-06-11','16:35:00',4.21),('14598','2013-06-11','16:40:00',4.17),('14598','2013-06-11','16:45:00',4.1),('14598','2013-06-11','16:50:00',4.08),('14598','2013-06-11','16:55:00',4.06),('14598','2013-06-11','17:00:00',4.12),('14598','2013-06-11','17:05:00',4.25),('14598','2013-06-11','17:10:00',4.34),('14598','2013-06-11','17:15:00',4.27),('14598','2013-06-11','17:20:00',4.09),('14598','2013-06-11','17:25:00',3.37),('14598','2013-06-11','17:30:00',2.71),('14598','2013-06-11','17:35:00',3.45),('14598','2013-06-11','17:40:00',1.57),('14598','2013-06-11','17:45:00',1.15),('14598','2013-06-11','19:15:00',1.19),('14598','2013-06-11','19:20:00',1.41),('14598','2013-06-11','19:25:00',1.09),('14598','2014-04-03','08:45:00',1.03),('14598','2014-04-03','08:50:00',1.22),('14598','2014-04-03','08:55:00',1.3),('14598','2014-04-03','09:00:00',1.24),('14598','2014-04-03','09:05:00',1.22),('14598','2014-04-03','09:10:00',1.36),('14598','2014-04-03','09:15:00',1.46),('14598','2014-04-03','09:20:00',1.56),('14598','2014-04-03','09:25:00',1.62),('14598','2014-04-03','09:30:00',1.62),('14598','2014-04-03','09:35:00',1.62),('14598','2014-04-03','09:40:00',1.66),('14598','2014-04-03','09:45:00',1.78),('14598','2014-04-03','09:50:00',1.78),('14598','2014-04-03','09:55:00',2.05),('14598','2014-04-03','10:00:00',2.53),('14598','2014-04-03','10:05:00',3.02),('14598','2014-04-03','10:10:00',2.8),('14598','2014-04-03','10:15:00',2.71),('14598','2014-04-03','10:20:00',2.7),('14598','2014-04-03','10:25:00',2.69),('14598','2014-04-03','10:30:00',2.26),('14598','2014-04-03','10:35:00',2.1),('14598','2014-04-03','10:40:00',1.91),('14598','2014-04-03','10:45:00',1.76),('14598','2014-04-03','10:50:00',1.6),('14598','2014-04-03','10:55:00',1.71),('14598','2014-04-03','11:00:00',1.84),('14598','2014-04-03','11:05:00',1.67),('14598','2014-04-03','11:10:00',1.47),('14598','2014-04-03','11:15:00',1.44),('14598','2014-04-03','11:20:00',1.61),('14598','2014-04-03','11:25:00',1.77),('14598','2014-04-03','11:30:00',1.87),('14598','2014-04-03','11:35:00',1.81),('14598','2014-04-03','11:40:00',2),('14598','2014-04-03','11:45:00',2.24),('14598','2014-04-03','11:50:00',2.57),('14598','2014-04-03','11:55:00',2.59),('14598','2014-04-03','12:00:00',2.37),('14598','2014-04-03','12:05:00',2.59),('14598','2014-04-03','12:10:00',2.52),('14598','2014-04-03','12:15:00',3.45),('14598','2014-04-03','12:20:00',4.49),('14598','2014-04-03','12:25:00',3.78),('14598','2014-04-03','12:30:00',2.97),('14598','2014-04-03','12:35:00',2.7),('14598','2014-04-03','12:40:00',2.15),('14598','2014-04-03','12:45:00',2.34),('14598','2014-04-03','12:50:00',2.25),('14598','2014-04-03','12:55:00',2.18),('14598','2014-04-03','13:00:00',3.4),('14598','2014-04-03','13:05:00',3.96),('14598','2014-04-03','13:10:00',3.93),('14598','2014-04-03','13:15:00',3.35),('14598','2014-04-03','13:20:00',4.23),('14598','2014-04-03','13:25:00',5.05),('14598','2014-04-03','13:30:00',3.44),('14598','2014-04-03','13:35:00',2.3),('14598','2014-04-03','13:40:00',2.66),('14598','2014-04-03','13:45:00',4.27),('14598','2014-04-03','13:50:00',2.62),('14598','2014-04-03','13:55:00',3.55),('14598','2014-04-03','14:00:00',3.45),('14598','2014-04-03','14:05:00',4.18),('14598','2014-04-03','14:10:00',4.46),('14598','2014-04-03','14:15:00',3.53),('14598','2014-04-03','14:20:00',3.99),('14598','2014-04-03','14:25:00',5.26),('14598','2014-04-03','14:30:00',4.74),('14598','2014-04-03','14:35:00',4.85),('14598','2014-04-03','14:40:00',4.69),('14598','2014-04-03','14:45:00',4.63),('14598','2014-04-03','14:50:00',4.62),('14598','2014-04-03','14:55:00',4.63),('14598','2014-04-03','15:00:00',4.63),('14598','2014-04-03','15:05:00',4.55),('14598','2014-04-03','15:10:00',4.55),('14598','2014-04-03','15:15:00',4.53),('14598','2014-04-03','15:20:00',4.47),('14598','2014-04-03','15:25:00',4.45),('14598','2014-04-03','15:30:00',4.41),('14598','2014-04-03','15:35:00',4.38),('14598','2014-04-03','15:40:00',4.28),('14598','2014-04-03','15:45:00',4.05),('14598','2014-04-03','15:50:00',4.39),('14598','2014-04-03','15:55:00',4.22),('14598','2014-04-03','16:00:00',4.18),('14598','2014-04-03','16:05:00',4.14),('14598','2014-04-03','16:10:00',4.06),('14598','2014-04-03','16:15:00',3.96),('14598','2014-04-03','16:20:00',3.87),('14598','2014-04-03','16:25:00',3.79),('14598','2014-04-03','16:30:00',3.76),('14598','2014-04-03','16:35:00',3.67),('14598','2014-04-03','16:40:00',3.58),('14598','2014-04-03','16:45:00',3.46),('14598','2014-04-03','16:50:00',3.12),('14598','2014-04-03','16:55:00',3.32),('14598','2014-04-03','17:00:00',3.48),('14598','2014-04-03','17:05:00',3.28),('14598','2014-04-03','17:10:00',3.07),('14598','2014-04-03','17:15:00',2.97),('14598','2014-04-03','17:20:00',2.78),('14598','2014-04-03','17:25:00',2.33),('14598','2014-04-03','17:30:00',2.43),('14598','2014-04-03','17:35:00',2.76),('14598','2014-04-03','17:40:00',2.58),('14598','2014-04-03','17:45:00',2.38),('14598','2014-04-03','17:50:00',2.19),('14598','2014-04-03','17:55:00',2.05),('14598','2014-04-03','18:00:00',1.94),('14598','2014-04-03','18:05:00',1.82),('14598','2014-04-03','18:10:00',1.69),('14598','2014-04-03','18:15:00',1.57),('14598','2014-04-03','18:20:00',1.2),('14598','2014-04-03','18:30:00',1.05),('14598','2014-04-03','18:35:00',1.11),('14598','2014-04-03','18:40:00',1.01),('14598','2013-06-10','08:25:00',1.19),('14598','2013-06-10','08:30:00',1.47),('14598','2013-06-10','08:35:00',1.8),('14598','2013-06-10','08:40:00',2.35),('14598','2013-06-10','08:45:00',1.1),('14598','2013-06-10','08:50:00',2.05),('14598','2013-06-10','08:55:00',2.31),('14598','2013-06-10','09:00:00',2.93),('14598','2013-06-10','09:05:00',2.6),('14598','2013-06-10','09:10:00',3.39),('14598','2013-06-10','09:15:00',3.53),('14598','2013-06-10','09:20:00',2.83),('14598','2013-06-10','09:25:00',3.64),('14598','2013-06-10','09:30:00',3.24),('14598','2013-06-10','09:35:00',2.59),('14598','2013-06-10','09:40:00',1.86),('14598','2013-06-10','09:45:00',2.3),('14598','2013-06-10','09:50:00',3.66),('14598','2013-06-10','09:55:00',2.32),('14598','2013-06-10','10:00:00',2.28),('14598','2013-06-10','10:05:00',2.15),('14598','2013-06-10','10:10:00',3.6),('14598','2013-06-10','10:15:00',4.15),('14598','2013-06-10','10:20:00',2.42),('14598','2013-06-10','10:25:00',2.04),('14598','2013-06-10','10:30:00',2.08),('14598','2013-06-10','10:35:00',2.61),('14598','2013-06-10','10:40:00',3.24),('14598','2013-06-10','10:45:00',3.68),('14598','2013-06-10','10:50:00',3.88),('14598','2013-06-10','10:55:00',4.29),('14598','2013-06-10','11:00:00',4.4),('14598','2013-06-10','11:05:00',4.86),('14598','2013-06-10','11:10:00',3.39),('14598','2013-06-10','11:15:00',3.11),('14598','2013-06-10','11:20:00',2.58),('14598','2013-06-10','11:25:00',3.06),('14598','2013-06-10','11:30:00',4.43),('14598','2013-06-10','11:35:00',5),('14598','2013-06-10','11:40:00',4.84),('14598','2013-06-10','11:45:00',4.67),('14598','2013-06-10','11:50:00',4.6),('14598','2013-06-10','11:55:00',4.91),('14598','2013-06-10','12:00:00',4.91),('14598','2013-06-10','12:05:00',4.91),('14598','2013-06-10','12:10:00',4.97),('14598','2013-06-10','12:15:00',5.01),('14598','2013-06-10','12:20:00',5.03),('14598','2013-06-10','12:25:00',5.1),('14598','2013-06-10','12:30:00',4.44),('14598','2013-06-10','12:35:00',4.99),('14598','2013-06-10','12:40:00',2.94),('14598','2013-06-10','12:45:00',4.78),('14598','2013-06-10','12:50:00',3.45),('14598','2013-06-10','12:55:00',4.97),('14598','2013-06-10','13:00:00',4.57),('14598','2013-06-10','13:05:00',5.11),('14598','2013-06-10','13:10:00',5.29),('14598','2013-06-10','13:15:00',5.3),('14598','2013-06-10','13:20:00',5.14),('14598','2013-06-10','13:25:00',5.46),('14598','2013-06-10','13:30:00',5.31),('14598','2013-06-10','13:35:00',5.33),('14598','2013-06-10','13:40:00',5.35),('14598','2013-06-10','13:45:00',5.32),('14598','2013-06-10','13:50:00',5.28),('14598','2013-06-10','13:55:00',5.32),('14598','2013-06-10','14:00:00',5.33),('14598','2013-06-10','14:05:00',5.31),('14598','2013-06-10','14:10:00',5.31),('14598','2013-06-10','14:15:00',5.34),('14598','2013-06-10','14:20:00',5.32),('14598','2013-06-10','14:25:00',5.31),('14598','2013-06-10','14:30:00',5.3),('14598','2013-06-10','14:35:00',5.28),('14598','2013-06-10','14:40:00',5.26),('14598','2013-06-10','14:45:00',5.25),('14598','2013-06-10','14:50:00',5.21),('14598','2013-06-10','14:55:00',5.18),('14598','2013-06-10','15:00:00',5.12),('14598','2013-06-10','15:05:00',5.12),('14598','2013-06-10','15:10:00',5.08),('14598','2013-06-10','15:15:00',5.04),('14598','2013-06-10','15:20:00',5),('14598','2013-06-10','15:25:00',4.99),('14598','2013-06-10','15:30:00',4.96),('14598','2013-06-10','15:35:00',4.87),('14598','2013-06-10','15:40:00',4.88),('14598','2013-06-10','15:45:00',4.84),('14598','2013-06-10','15:50:00',4.78),('14598','2013-06-10','15:55:00',4.72),('14598','2013-06-10','16:00:00',4.66),('14598','2013-06-10','16:05:00',4.62),('14598','2013-06-10','16:10:00',4.58),('14598','2013-06-10','16:15:00',4.52),('14598','2013-06-10','16:20:00',4.47),('14598','2013-06-10','16:25:00',4.41),('14598','2013-06-10','16:30:00',4.32),('14598','2013-06-10','16:35:00',4.27),('14598','2013-06-10','16:40:00',4.21),('14598','2013-06-10','16:45:00',4.13),('14598','2013-06-10','16:50:00',4.04),('14598','2013-06-10','16:55:00',4),('14598','2013-06-10','17:00:00',3.91),('14598','2013-06-10','17:05:00',3.84),('14598','2013-06-10','17:10:00',3.77),('14598','2013-06-10','17:15:00',3.69),('14598','2013-06-10','17:20:00',3.61),('14598','2013-06-10','17:25:00',3.54),('14598','2013-06-10','17:30:00',3.45),('14598','2013-06-10','17:35:00',3.34),('14598','2013-06-10','17:40:00',3.27),('14598','2013-06-10','17:45:00',3.18),('14598','2013-06-10','17:50:00',3.08),('14598','2013-06-10','17:55:00',3),('14598','2013-06-10','18:00:00',2.89),('14598','2013-06-10','18:05:00',2.79),('14598','2013-06-10','18:10:00',2.69),('14598','2013-06-10','18:15:00',2.59),('14598','2013-06-10','18:20:00',2.5),('14598','2013-06-10','18:25:00',2.4),('14598','2013-06-10','18:30:00',2.29),('14598','2013-06-10','18:35:00',2.16),('14598','2013-06-10','18:40:00',2.07),('14598','2013-06-10','18:45:00',1.96),('14598','2013-06-10','18:50:00',1.85),('14598','2013-06-10','18:55:00',1.75),('14598','2013-06-10','19:00:00',1.64),('14598','2013-06-10','19:05:00',1.53),('14598','2013-06-10','19:10:00',1.42),('14598','2013-06-10','19:15:00',1.32),('14598','2013-06-10','19:20:00',1.21),('14598','2013-06-10','19:25:00',1.11),('14598','2013-06-09','08:05:00',1.2),('14598','2013-06-09','08:10:00',1.36),('14598','2013-06-09','08:15:00',1.37),('14598','2013-06-09','08:20:00',1.72),('14598','2013-06-09','08:25:00',2),('14598','2013-06-09','08:30:00',1.98),('14598','2013-06-09','08:35:00',1.81),('14598','2013-06-09','08:40:00',1.65),('14598','2013-06-09','08:45:00',2.12),('14598','2013-06-09','08:50:00',1.71),('14598','2013-06-09','08:55:00',2.47),('14598','2013-06-09','09:00:00',1.91),('14598','2013-06-09','09:05:00',2.12),('14598','2013-06-09','09:15:00',2.73),('14598','2013-06-09','09:20:00',3.06),('14598','2013-06-09','09:25:00',1.79),('14598','2013-06-09','09:30:00',2.81),('14598','2013-06-09','09:35:00',2.01),('14598','2013-06-09','09:40:00',2.36),('14598','2013-06-09','09:45:00',3.03),('14598','2013-06-09','09:50:00',3.33),('14598','2013-06-09','09:55:00',3.45),('14598','2013-06-09','10:00:00',3.28),('14598','2013-06-09','10:05:00',3.44),('14598','2013-06-09','10:10:00',3.52),('14598','2013-06-09','10:15:00',3.63),('14598','2013-06-09','10:20:00',3.7),('14598','2013-06-09','10:25:00',3.79),('14598','2013-06-09','10:30:00',3.86),('14598','2013-06-09','10:35:00',3.93),('14598','2013-06-09','10:40:00',3.98),('14598','2013-06-09','10:45:00',4.05),('14598','2013-06-09','10:50:00',4.12),('14598','2013-06-09','10:55:00',4.18),('14598','2013-06-09','11:00:00',4.24),('14598','2013-06-09','11:05:00',4.28),('14598','2013-06-09','11:10:00',4.34),('14598','2013-06-09','11:15:00',4.38),('14598','2013-06-09','11:20:00',4.42),('14598','2013-06-09','11:25:00',4.47),('14598','2013-06-09','11:30:00',4.53),('14598','2013-06-09','11:35:00',4.58),('14598','2013-06-09','11:40:00',4.59),('14598','2013-06-09','11:45:00',4.71),('14598','2013-06-09','11:50:00',4.69),('14598','2013-06-09','11:55:00',4.35),('14598','2013-06-09','12:00:00',5),('14598','2013-06-09','12:05:00',4.85),('14598','2013-06-09','12:10:00',4.88),('14598','2013-06-09','12:15:00',4.98),('14598','2013-06-09','12:20:00',4.69),('14598','2013-06-09','12:25:00',5.25),('14598','2013-06-09','12:30:00',4.09),('14598','2013-06-09','12:35:00',4.61),('14598','2013-06-09','12:40:00',4.56),('14598','2013-06-09','12:45:00',4.77),('14598','2013-06-09','12:50:00',5.02),('14598','2013-06-09','12:55:00',5.27),('14598','2013-06-09','13:00:00',4.39),('14598','2013-06-09','13:05:00',4.96),('14598','2013-06-09','13:10:00',5.48),('14598','2013-06-09','13:15:00',4.65),('14598','2013-06-09','13:20:00',4.78),('14598','2013-06-09','13:25:00',3.9),('14598','2013-06-09','13:30:00',4.72),('14598','2013-06-09','13:35:00',2.62),('14598','2013-06-09','13:40:00',5.47),('14598','2013-06-09','13:45:00',5.53),('14598','2013-06-09','13:50:00',5.58),('14598','2013-06-09','13:55:00',5.87),('14598','2013-06-09','14:00:00',4.31),('14598','2013-06-09','14:05:00',1.77),('14598','2013-06-09','14:10:00',1.83),('14598','2013-06-09','14:15:00',1.94),('14598','2013-06-09','14:20:00',2.14),('14598','2013-06-09','14:25:00',5.16),('14598','2013-06-09','14:30:00',3.18),('14598','2013-06-09','14:35:00',4.26),('14598','2013-06-09','14:40:00',4.33),('14598','2013-06-09','14:45:00',3.74),('14598','2013-06-09','14:50:00',4.75),('14598','2013-06-09','14:55:00',2.63),('14598','2013-06-09','15:00:00',3.93),('14598','2013-06-09','15:05:00',4.3),('14598','2013-06-09','15:10:00',4.39),('14598','2013-06-09','15:15:00',5.47),('14598','2013-06-09','15:20:00',5.14),('14598','2013-06-09','15:25:00',4.54),('14598','2013-06-09','15:30:00',3.22),('14598','2013-06-09','15:35:00',1.98),('14598','2013-06-09','15:40:00',2.4),('14598','2013-06-09','15:45:00',2.86),('14598','2013-06-09','15:50:00',2.48),('14598','2013-06-09','15:55:00',3.07),('14598','2013-06-09','16:00:00',3.19),('14598','2013-06-09','16:05:00',4.67),('14598','2013-06-09','16:10:00',2.6),('14598','2013-06-09','16:15:00',1.98),('14598','2013-06-09','16:20:00',1.5),('14598','2013-06-09','16:25:00',1.39),('14598','2013-06-09','16:30:00',1.69),('14598','2013-06-09','16:35:00',2.2),('14598','2013-06-09','16:40:00',2.62),('14598','2013-06-09','16:45:00',3.34),('14598','2013-06-09','16:50:00',3.15),('14598','2013-06-09','16:55:00',1.55),('14598','2013-06-09','17:00:00',1.09),('14598','2013-06-09','17:55:00',1.7),('14598','2013-06-09','18:00:00',1.47),('14598','2013-06-09','18:05:00',1.03),('14598','2013-06-09','18:20:00',1.01),('14598','2013-06-08','07:45:00',1.02),('14598','2013-06-08','07:50:00',1.15),('14598','2013-06-08','07:55:00',1.13),('14598','2013-06-08','08:00:00',1.22),('14598','2013-06-08','08:05:00',1.31),('14598','2013-06-08','08:10:00',1.38),('14598','2013-06-08','08:15:00',1.48),('14598','2013-06-08','08:20:00',1.56),('14598','2013-06-08','08:25:00',1.68),('14598','2013-06-08','08:30:00',1.8),('14598','2013-06-08','08:35:00',1.64),('14598','2013-06-08','08:40:00',1.96),('14598','2013-06-08','08:45:00',2.11),('14598','2013-06-08','08:50:00',2.22),('14598','2013-06-08','08:55:00',2.28),('14598','2013-06-08','09:00:00',2.33),('14598','2013-06-08','09:05:00',2.47),('14598','2013-06-08','09:10:00',2.62),('14598','2013-06-08','09:15:00',2.39),('14598','2013-06-08','09:20:00',2.67),('14598','2013-06-08','09:25:00',3.68),('14598','2013-06-08','09:30:00',2.56),('14598','2013-06-08','09:35:00',3.07),('14598','2013-06-08','09:40:00',3.19),('14598','2013-06-08','09:45:00',3.29),('14598','2013-06-08','09:50:00',3.37),('14598','2013-06-08','09:55:00',3.4),('14598','2013-06-08','10:00:00',3.49),('14598','2013-06-08','10:05:00',3.59),('14598','2013-06-08','10:10:00',3.66),('14598','2013-06-08','10:15:00',3.74),('14598','2013-06-08','10:20:00',3.81),('14598','2013-06-08','10:25:00',3.9),('14598','2013-06-08','10:30:00',3.98),('14598','2013-06-08','10:35:00',4.02),('14598','2013-06-08','10:40:00',4.03),('14598','2013-06-08','10:45:00',4.16),('14598','2013-06-08','10:50:00',4.22),('14598','2013-06-08','10:55:00',4.29),('14598','2013-06-08','11:00:00',4.34),('14598','2013-06-08','11:05:00',4.4),('14598','2013-06-08','11:10:00',4.46),('14598','2013-06-08','11:15:00',4.51),('14598','2013-06-08','11:20:00',4.56),('14598','2013-06-08','11:25:00',4.61),('14598','2013-06-08','11:30:00',4.65),('14598','2013-06-08','11:35:00',4.68),('14598','2013-06-08','11:40:00',4.72),('14598','2013-06-08','11:45:00',4.77),('14598','2013-06-08','11:50:00',4.82),('14598','2013-06-08','11:55:00',4.9),('14598','2013-06-08','12:00:00',4.95),('14598','2013-06-08','12:05:00',4.9),('14598','2013-06-08','12:10:00',4.99),('14598','2013-06-08','12:15:00',4.83),('14598','2013-06-08','12:20:00',4.76),('14598','2013-06-08','12:25:00',5.01),('14598','2013-06-08','12:30:00',5.1),('14598','2013-06-08','12:35:00',5.13),('14598','2013-06-08','12:40:00',5.11),('14598','2013-06-08','12:45:00',5),('14598','2013-06-08','12:50:00',4.93),('14598','2013-06-08','12:55:00',4.94),('14598','2013-06-08','13:00:00',5.15),('14598','2013-06-08','13:05:00',5.19),('14598','2013-06-08','13:10:00',5.21),('14598','2013-06-08','13:15:00',5.26),('14598','2013-06-08','13:20:00',5.27),('14598','2013-06-08','13:25:00',5.3),('14598','2013-06-08','13:30:00',5.3),('14598','2013-06-08','13:35:00',5.31),('14598','2013-06-08','13:40:00',5.33),('14598','2013-06-08','13:45:00',5.33),('14598','2013-06-08','13:50:00',5.32),('14598','2013-06-08','13:55:00',5.31),('14598','2013-06-08','14:00:00',5.33),('14598','2013-06-08','14:05:00',5.3),('14598','2013-06-08','14:10:00',5.32),('14598','2013-06-08','14:15:00',5.29),('14598','2013-06-08','14:20:00',5.28),('14598','2013-06-08','14:25:00',5.27),('14598','2013-06-08','14:30:00',5.24),('14598','2013-06-08','14:35:00',5.25),('14598','2013-06-08','14:40:00',5.22),('14598','2013-06-08','14:45:00',5.16),('14598','2013-06-08','14:50:00',5.12),('14598','2013-06-08','14:55:00',5.17),('14598','2013-06-08','15:00:00',5.09),('14598','2013-06-08','15:05:00',4.65),('14598','2013-06-08','15:10:00',4.49),('14598','2013-06-08','15:15:00',4.76),('14598','2013-06-08','15:20:00',3.34),('14598','2013-06-08','15:25:00',3.3),('14598','2013-06-08','15:30:00',2.23),('14598','2013-06-08','15:35:00',3.88),('14598','2013-06-08','15:40:00',4.16),('14598','2013-06-08','15:45:00',4.9),('14598','2013-06-08','15:50:00',4.89),('14598','2013-06-08','15:55:00',4.8),('14598','2013-06-08','16:00:00',4.75),('14598','2013-06-08','16:05:00',4.66),('14598','2013-06-08','16:10:00',4.56),('14598','2013-06-08','16:15:00',4.35),('14598','2013-06-08','16:20:00',3.97),('14598','2013-06-08','16:25:00',4.11),('14598','2013-06-08','16:30:00',4.2),('14598','2013-06-08','16:35:00',4.27),('14598','2013-06-08','16:40:00',4.2),('14598','2013-06-08','16:45:00',4.19),('14598','2013-06-08','16:50:00',4.17),('14598','2013-06-08','16:55:00',4.12),('14598','2013-06-08','17:00:00',3.99),('14598','2013-06-08','17:05:00',3.89),('14598','2013-06-08','17:10:00',3.8),('14598','2013-06-08','17:15:00',3.5),('14598','2013-06-08','17:20:00',3.64),('14598','2013-06-08','17:25:00',3.77),('14598','2013-06-08','17:30:00',3.47),('14598','2013-06-08','17:35:00',3.23),('14598','2013-06-08','17:40:00',3.02),('14598','2013-06-08','17:45:00',2.33),('14598','2013-06-08','17:50:00',1.79),('14598','2013-06-08','17:55:00',1.84),('14598','2013-06-08','18:00:00',2.43),('14598','2013-06-08','18:05:00',2.28),('14598','2013-06-08','18:10:00',1.92),('14598','2013-06-08','18:15:00',1.23),('14598','2013-06-08','18:20:00',1.1),('14598','2013-06-07','07:45:00',1.01),('14598','2013-06-07','07:50:00',1.1),('14598','2013-06-07','07:55:00',1.19),('14598','2013-06-07','08:00:00',1.28),('14598','2013-06-07','08:05:00',1.37),('14598','2013-06-07','08:10:00',1.46),('14598','2013-06-07','08:15:00',1.57),('14598','2013-06-07','08:20:00',1.67),('14598','2013-06-07','08:25:00',1.77),('14598','2013-06-07','08:30:00',1.89),('14598','2013-06-07','08:35:00',1.98),('14598','2013-06-07','08:40:00',2.07),('14598','2013-06-07','08:45:00',2.21),('14598','2013-06-07','08:50:00',2.34),('14598','2013-06-07','08:55:00',2.47),('14598','2013-06-07','09:00:00',2.56),('14598','2013-06-07','09:05:00',2.64),('14598','2013-06-07','09:10:00',2.74),('14598','2013-06-07','09:15:00',2.86),('14598','2013-06-07','09:20:00',2.96),('14598','2013-06-07','09:25:00',3.05),('14598','2013-06-07','09:30:00',3.13),('14598','2013-06-07','09:35:00',3.22),('14598','2013-06-07','09:40:00',3.3),('14598','2013-06-07','09:45:00',3.39),('14598','2013-06-07','09:50:00',3.46),('14598','2013-06-07','09:55:00',3.54),('14598','2013-06-07','10:00:00',3.61),('14598','2013-06-07','10:05:00',3.67),('14598','2013-06-07','10:10:00',3.74),('14598','2013-06-07','10:15:00',3.82),('14598','2013-06-07','10:20:00',3.87),('14598','2013-06-07','10:25:00',3.97),('14598','2013-06-07','10:30:00',4.04),('14598','2013-06-07','10:35:00',4.08),('14598','2013-06-07','10:40:00',4.14),('14598','2013-06-07','10:45:00',4.2),('14598','2013-06-07','10:50:00',4.25),('14598','2013-06-07','10:55:00',4.29),('14598','2013-06-07','11:00:00',4.34),('14598','2013-06-07','11:05:00',4.41),('14598','2013-06-07','11:10:00',4.47),('14598','2013-06-07','11:15:00',4.5),('14598','2013-06-07','11:20:00',4.57),('14598','2013-06-07','11:25:00',4.59),('14598','2013-06-07','11:30:00',4.64),('14598','2013-06-07','11:35:00',4.65),('14598','2013-06-07','11:40:00',4.75),('14598','2013-06-07','11:45:00',4.8),('14598','2013-06-07','11:50:00',4.84),('14598','2013-06-07','11:55:00',4.87),('14598','2013-06-07','12:00:00',4.87),('14598','2013-06-07','12:05:00',4.9),('14598','2013-06-07','12:10:00',4.95),('14598','2013-06-07','12:15:00',4.96),('14598','2013-06-07','12:20:00',4.99),('14598','2013-06-07','12:25:00',4.99),('14598','2013-06-07','12:30:00',4.99),('14598','2013-06-07','12:35:00',4.99),('14598','2013-06-07','12:40:00',5.05),('14598','2013-06-07','12:45:00',5.07),('14598','2013-06-07','12:50:00',5.08),('14598','2013-06-07','12:55:00',5.09),('14598','2013-06-07','13:00:00',5.1),('14598','2013-06-07','13:05:00',5.19),('14598','2013-06-07','13:10:00',5.24),('14598','2013-06-07','13:15:00',5.33),('14598','2013-06-07','13:20:00',5.3),('14598','2013-06-07','13:25:00',5.41),('14598','2013-06-07','13:30:00',5.43),('14598','2013-06-07','13:35:00',5.41),('14598','2013-06-07','13:40:00',5.41),('14598','2013-06-07','13:45:00',5.42),('14598','2013-06-07','13:50:00',5.4),('14598','2013-06-07','13:55:00',5.4),('14598','2013-06-07','14:00:00',5.41),('14598','2013-06-07','14:05:00',5.42),('14598','2013-06-07','14:10:00',5.38),('14598','2013-06-07','14:15:00',5.36),('14598','2013-06-07','14:20:00',5.36),('14598','2013-06-07','14:25:00',5.37),('14598','2013-06-07','14:30:00',5.34),('14598','2013-06-07','14:35:00',5.27),('14598','2013-06-07','14:40:00',5.27),('14598','2013-06-07','14:45:00',5.24),('14598','2013-06-07','14:50:00',5.23),('14598','2013-06-07','14:55:00',5.21),('14598','2013-06-07','15:00:00',5.18),('14598','2013-06-07','15:05:00',5.14),('14598','2013-06-07','15:10:00',5.13),('14598','2013-06-07','15:15:00',5.07),('14598','2013-06-07','15:20:00',5.03),('14598','2013-06-07','15:25:00',5),('14598','2013-06-07','15:30:00',4.95),('14598','2013-06-07','15:35:00',4.91),('14598','2013-06-07','15:40:00',4.88),('14598','2013-06-07','15:45:00',4.86),('14598','2013-06-07','15:50:00',4.8),('14598','2013-06-07','15:55:00',4.74),('14598','2013-06-07','16:00:00',4.7),('14598','2013-06-07','16:05:00',4.62),('14598','2013-06-07','16:10:00',4.58),('14598','2013-06-07','16:15:00',4.52),('14598','2013-06-07','16:20:00',4.4),('14598','2013-06-07','16:25:00',4.4),('14598','2013-06-07','16:30:00',4.34),('14598','2013-06-07','16:35:00',4.25),('14598','2013-06-07','16:40:00',4.19),('14598','2013-06-07','16:45:00',4.14),('14598','2013-06-07','16:50:00',4.06),('14598','2013-06-07','16:55:00',3.98),('14598','2013-06-07','17:00:00',3.9),('14598','2013-06-07','17:05:00',3.82),('14598','2013-06-07','17:10:00',3.73),('14598','2013-06-07','17:15:00',3.64),('14598','2013-06-07','17:20:00',3.56),('14598','2013-06-07','17:25:00',3.49),('14598','2013-06-07','17:30:00',3.41),('14598','2013-06-07','17:35:00',3.32),('14598','2013-06-07','17:40:00',3.22),('14598','2013-06-07','17:45:00',3.12),('14598','2013-06-07','17:50:00',3.04),('14598','2013-06-07','17:55:00',2.94),('14598','2013-06-07','18:00:00',2.84),('14598','2013-06-07','18:05:00',2.74),('14598','2013-06-07','18:10:00',2.62),('14598','2013-06-07','18:15:00',2.55),('14598','2013-06-07','18:20:00',2.49),('14598','2013-06-07','18:25:00',2.31),('14598','2013-06-07','18:30:00',2.21),('14598','2013-06-07','18:35:00',2.12),('14598','2013-06-07','18:40:00',1.98),('14598','2013-06-07','18:45:00',1.88),('14598','2013-06-07','18:50:00',1.76),('14598','2013-06-07','18:55:00',1.66),('14598','2013-06-07','19:00:00',1.58),('14598','2013-06-07','19:05:00',1.5),('14598','2013-06-07','19:10:00',1.36),('14598','2013-06-07','19:15:00',1.21),('14598','2013-06-07','19:20:00',1.1),('14598','2013-06-06','07:40:00',1.02),('14598','2013-06-06','07:50:00',1.09),('14598','2013-06-06','07:55:00',1),('14598','2013-06-06','08:05:00',1.44),('14598','2013-06-06','08:10:00',1.51),('14598','2013-06-06','08:15:00',1.54),('14598','2013-06-06','08:20:00',1.62),('14598','2013-06-06','08:25:00',1.7),('14598','2013-06-06','08:30:00',1.85),('14598','2013-06-06','08:35:00',1.93),('14598','2013-06-06','08:40:00',2.07),('14598','2013-06-06','08:45:00',2.17),('14598','2013-06-06','08:50:00',2.02),('14598','2013-06-06','08:55:00',2.34),('14598','2013-06-06','09:00:00',2.42),('14598','2013-06-06','09:05:00',2.58),('14598','2013-06-06','09:10:00',2.73),('14598','2013-06-06','09:15:00',2.83),('14598','2013-06-06','09:20:00',2.88),('14598','2013-06-06','09:25:00',2.6),('14598','2013-06-06','09:30:00',3.05),('14598','2013-06-06','09:35:00',3.22),('14598','2013-06-06','09:40:00',2.78),('14598','2013-06-06','09:45:00',3.4),('14598','2013-06-06','09:50:00',3.43),('14598','2013-06-06','09:55:00',3.55),('14598','2013-06-06','10:00:00',3.71),('14598','2013-06-06','10:05:00',3.73),('14598','2013-06-06','10:10:00',3.59),('14598','2013-06-06','10:15:00',3.63),('14598','2013-06-06','10:20:00',3.73),('14598','2013-06-06','10:25:00',3.9),('14598','2013-06-06','10:30:00',3.79),('14598','2013-06-06','10:35:00',3.78),('14598','2013-06-06','10:40:00',4.09),('14598','2013-06-06','10:45:00',4.2),('14598','2013-06-06','10:50:00',4.16),('14598','2013-06-06','10:55:00',4.3),('14598','2013-06-06','11:00:00',4.3),('14598','2013-06-06','11:05:00',4.41),('14598','2013-06-06','11:10:00',4.44),('14598','2013-06-06','11:15:00',4.47),('14598','2013-06-06','11:20:00',4.55),('14598','2013-06-06','11:25:00',4.62),('14598','2013-06-06','11:30:00',4.66),('14598','2013-06-06','11:35:00',4.68),('14598','2013-06-06','11:40:00',4.74),('14598','2013-06-06','11:45:00',4.8),('14598','2013-06-06','11:50:00',4.8),('14598','2013-06-06','11:55:00',4.86),('14598','2013-06-06','12:00:00',4.91),('14598','2013-06-06','12:05:00',4.92),('14598','2013-06-06','12:10:00',4.95),('14598','2013-06-06','12:15:00',4.98),('14598','2013-06-06','12:20:00',5),('14598','2013-06-06','12:25:00',5.05),('14598','2013-06-06','12:30:00',5.15),('14598','2013-06-06','12:35:00',5.1),('14598','2013-06-06','12:40:00',5.13),('14598','2013-06-06','12:45:00',5.15),('14598','2013-06-06','12:50:00',5.21),('14598','2013-06-06','12:55:00',5.2),('14598','2013-06-06','13:00:00',5.22),('14598','2013-06-06','13:05:00',5.23),('14598','2013-06-06','13:10:00',5.24),('14598','2013-06-06','13:15:00',5.28),('14598','2013-06-06','13:20:00',5.28),('14598','2013-06-06','13:25:00',5.27),('14598','2013-06-06','13:30:00',5.25),('14598','2013-06-06','13:35:00',5.28),('14598','2013-06-06','13:40:00',5.28),('14598','2013-06-06','13:45:00',5.28),('14598','2013-06-06','13:50:00',5.3),('14598','2013-06-06','13:55:00',5.28),('14598','2013-06-06','14:00:00',5.27),('14598','2013-06-06','14:05:00',5.27),('14598','2013-06-06','14:10:00',5.27),('14598','2013-06-06','14:15:00',5.23),('14598','2013-06-06','14:20:00',5.19),('14598','2013-06-06','14:25:00',5.1),('14598','2013-06-06','14:30:00',5.18),('14598','2013-06-06','14:35:00',5.16),('14598','2013-06-06','14:40:00',5.15),('14598','2013-06-06','14:45:00',5.13),('14598','2013-06-06','14:50:00',5.08),('14598','2013-06-06','14:55:00',5.07),('14598','2013-06-06','15:00:00',5.04),('14598','2013-06-06','15:05:00',4.99),('14598','2013-06-06','15:10:00',4.99),('14598','2013-06-06','15:15:00',4.94),('14598','2013-06-06','15:20:00',4.89),('14598','2013-06-06','15:25:00',4.9),('14598','2013-06-06','15:30:00',4.82),('14598','2013-06-06','15:35:00',4.76),('14598','2013-06-06','15:40:00',4.73),('14598','2013-06-06','15:45:00',4.69),('14598','2013-06-06','15:50:00',4.6),('14598','2013-06-06','15:55:00',4.58),('14598','2013-06-06','16:00:00',4.54),('14598','2013-06-06','16:05:00',4.5),('14598','2013-06-06','16:10:00',4.46),('14598','2013-06-06','16:15:00',4.4),('14598','2013-06-06','16:20:00',4.36),('14598','2013-06-06','16:25:00',4.28),('14598','2013-06-06','16:30:00',4.23),('14598','2013-06-06','16:35:00',4.12),('14598','2013-06-06','16:40:00',4.1),('14598','2013-06-06','16:45:00',4.05),('14598','2013-06-06','16:50:00',3.99),('14598','2013-06-06','16:55:00',3.91),('14598','2013-06-06','17:00:00',3.84),('14598','2013-06-06','17:05:00',3.78),('14598','2013-06-06','17:10:00',3.69),('14598','2013-06-06','17:15:00',3.62),('14598','2013-06-06','17:20:00',3.53),('14598','2013-06-06','17:25:00',3.47),('14598','2013-06-06','17:30:00',3.38),('14598','2013-06-06','17:35:00',3.28),('14598','2013-06-06','17:40:00',3.18),('14598','2013-06-06','17:45:00',3.09),('14598','2013-06-06','17:50:00',3),('14598','2013-06-06','17:55:00',2.93),('14598','2013-06-06','18:00:00',2.84),('14598','2013-06-06','18:05:00',2.76),('14598','2013-06-06','18:10:00',2.63),('14598','2013-06-06','18:15:00',2.52),('14598','2013-06-06','18:20:00',2.42),('14598','2013-06-06','18:25:00',2.3),('14598','2013-06-06','18:30:00',2.19),('14598','2013-06-06','18:35:00',2.08),('14598','2013-06-06','18:40:00',1.97),('14598','2013-06-06','18:45:00',1.87),('14598','2013-06-06','18:50:00',1.76),('14598','2013-06-06','18:55:00',1.66),('14598','2013-06-06','19:00:00',1.54),('14598','2013-06-06','19:05:00',1.43),('14598','2013-06-06','19:10:00',1.32),('14598','2013-06-06','19:15:00',1.21),('14598','2013-06-06','19:20:00',1.1),('14598','2013-06-05','07:50:00',1.09),('14598','2013-06-05','07:55:00',1.19),('14598','2013-06-05','08:00:00',1.17),('14598','2013-06-05','08:05:00',1.19),('14598','2013-06-05','08:10:00',1.37),('14598','2013-06-05','08:15:00',1.49),('14598','2013-06-05','08:20:00',1.57),('14598','2013-06-05','08:25:00',1.5),('14598','2013-06-05','08:30:00',1.8),('14598','2013-06-05','08:35:00',1.89),('14598','2013-06-05','08:40:00',1.96),('14598','2013-06-05','08:45:00',2),('14598','2013-06-05','08:50:00',2.23),('14598','2013-06-05','08:55:00',2.33),('14598','2013-06-05','09:00:00',2.55),('14598','2013-06-05','09:05:00',2.92),('14598','2013-06-05','09:10:00',1.86),('14598','2013-06-05','09:20:00',1.15),('14598','2013-06-05','09:25:00',1.41),('14598','2013-06-05','09:30:00',1.37),('14598','2013-06-05','09:35:00',1.36),('14598','2013-06-05','09:40:00',2.23),('14598','2013-06-05','09:45:00',3.73),('14598','2013-06-05','09:50:00',3.54),('14598','2013-06-05','09:55:00',3.42),('14598','2013-06-05','10:00:00',2.04),('14598','2013-06-05','10:10:00',3.37),('14598','2013-06-05','10:15:00',3.96),('14598','2013-06-05','10:20:00',4.02),('14598','2013-06-05','10:25:00',4.03),('14598','2013-06-05','10:30:00',4.07),('14598','2013-06-05','10:35:00',4.16),('14598','2013-06-05','10:40:00',4.27),('14598','2013-06-05','10:45:00',4.32),('14598','2013-06-05','10:50:00',4.34),('14598','2013-06-05','10:55:00',4.22),('14598','2013-06-05','11:00:00',4.46),('14598','2013-06-05','11:05:00',4.47),('14598','2013-06-05','11:10:00',4.53),('14598','2013-06-05','11:15:00',4.54),('14598','2013-06-05','11:20:00',4.59),('14598','2013-06-05','11:25:00',4.67),('14598','2013-06-05','11:30:00',4.74),('14598','2013-06-05','11:35:00',4.77),('14598','2013-06-05','11:40:00',4.82),('14598','2013-06-05','11:45:00',4.87),('14598','2013-06-05','11:50:00',4.83),('14598','2013-06-05','11:55:00',4.94),('14598','2013-06-05','12:00:00',4.97),('14598','2013-06-05','12:05:00',5),('14598','2013-06-05','12:10:00',5.04),('14598','2013-06-05','12:15:00',5.07),('14598','2013-06-05','12:20:00',5.11),('14598','2013-06-05','12:25:00',5.13),('14598','2013-06-05','12:30:00',5.17),('14598','2013-06-05','12:35:00',5.2),('14598','2013-06-05','12:40:00',5.24),('14598','2013-06-05','12:45:00',5.26),('14598','2013-06-05','12:50:00',5.26),('14598','2013-06-05','12:55:00',5.29),('14598','2013-06-05','13:00:00',5.32),('14598','2013-06-05','13:05:00',5.34),('14598','2013-06-05','13:10:00',5.35),('14598','2013-06-05','13:15:00',5.36),('14598','2013-06-05','13:20:00',5.4),('14598','2013-06-05','13:25:00',5.43),('14598','2013-06-05','13:30:00',5.44),('14598','2013-06-05','13:35:00',5.37),('14598','2013-06-05','13:40:00',5.42),('14598','2013-06-05','13:45:00',5.38),('14598','2013-06-05','13:50:00',5.38),('14598','2013-06-05','13:55:00',5.35),('14598','2013-06-05','14:00:00',5.38),('14598','2013-06-05','14:05:00',5.36),('14598','2013-06-05','14:10:00',5.36),('14598','2013-06-05','14:15:00',5.32),('14598','2013-06-05','14:20:00',5.34),('14598','2013-06-05','14:25:00',5.33),('14598','2013-06-05','14:30:00',5.28),('14598','2013-06-05','14:35:00',5.24),('14598','2013-06-05','14:40:00',5.22),('14598','2013-06-05','14:45:00',5.17),('14598','2013-06-05','14:50:00',5.17),('14598','2013-06-05','14:55:00',5.11),('14598','2013-06-05','15:00:00',5.13),('14598','2013-06-05','15:05:00',5.13),('14598','2013-06-05','15:10:00',5.17),('14598','2013-06-05','15:15:00',5.07),('14598','2013-06-05','15:20:00',4.83),('14598','2013-06-05','15:25:00',5),('14598','2013-06-05','15:30:00',4.68),('14598','2013-06-05','15:35:00',4.88),('14598','2013-06-05','15:40:00',4.86),('14598','2013-06-05','15:45:00',4.86),('14598','2013-06-05','15:50:00',4.3),('14598','2013-06-05','15:55:00',3.76),('14598','2013-06-05','16:00:00',4.39),('14598','2013-06-05','16:05:00',4.52),('14598','2013-06-05','16:10:00',4.24),('14598','2013-06-05','16:15:00',4.4),('14598','2013-06-05','16:20:00',4.38),('14598','2013-06-05','16:25:00',4.27),('14598','2013-06-05','16:30:00',4.18),('14598','2013-06-05','16:35:00',4.15),('14598','2013-06-05','16:40:00',4.08),('14598','2013-06-05','16:45:00',4.02),('14598','2013-06-05','16:50:00',3.92),('14598','2013-06-05','16:55:00',3.84),('14598','2013-06-05','17:00:00',3.76),('14598','2013-06-05','17:05:00',3.7),('14598','2013-06-05','17:10:00',3.62),('14598','2013-06-05','17:15:00',3.54),('14598','2013-06-05','17:20:00',3.45),('14598','2013-06-05','17:25:00',3.36),('14598','2013-06-05','17:30:00',3.22),('14598','2013-06-05','17:35:00',3.18),('14598','2013-06-05','17:40:00',3.11),('14598','2013-06-05','17:45:00',3.01),('14598','2013-06-05','17:50:00',2.92),('14598','2013-06-05','17:55:00',2.77),('14598','2013-06-05','18:00:00',2.32),('14598','2013-06-05','18:05:00',2.61),('14598','2013-06-05','18:10:00',2.5),('14598','2013-06-05','18:15:00',2.4),('14598','2013-06-05','18:20:00',2.29),('14598','2013-06-05','18:25:00',2.2),('14598','2013-06-05','18:30:00',2.1),('14598','2013-06-05','18:35:00',2),('14598','2013-06-05','18:40:00',1.91),('14598','2013-06-05','18:45:00',1.76),('14598','2013-06-05','18:50:00',1.69),('14598','2013-06-05','18:55:00',1.47),('14598','2013-06-05','19:00:00',1.45),('14598','2013-06-05','19:05:00',1.36),('14598','2013-06-05','19:10:00',1.25),('14598','2013-06-05','19:15:00',1.17),('14598','2013-06-05','19:20:00',1.03),('14598','2013-06-04','07:30:00',1.03),('14598','2013-06-04','07:35:00',1.1),('14598','2013-06-04','07:40:00',1.04),('14598','2013-06-04','08:15:00',1.07),('14598','2013-06-04','08:20:00',1.26),('14598','2013-06-04','08:25:00',1.27),('14598','2013-06-04','08:30:00',1.09),('14598','2013-06-04','08:35:00',1.02),('14598','2013-06-04','08:40:00',1.24),('14598','2013-06-04','08:45:00',1.5),('14598','2013-06-04','08:50:00',2.01),('14598','2013-06-04','08:55:00',2.1),('14598','2013-06-04','09:00:00',1.89),('14598','2013-06-04','09:05:00',1.76),('14598','2013-06-04','09:10:00',1.78),('14598','2013-06-04','09:15:00',1.53),('14598','2013-06-04','09:20:00',1.28),('14598','2013-06-04','09:25:00',1.32),('14598','2013-06-04','09:30:00',1.4),('14598','2013-06-04','09:35:00',1.54),('14598','2013-06-04','09:40:00',1.62),('14598','2013-06-04','09:45:00',1.85),('14598','2013-06-04','09:50:00',1.88),('14598','2013-06-04','09:55:00',2.46),('14598','2013-06-04','10:00:00',2.54),('14598','2013-06-04','10:05:00',2.85),('14598','2013-06-04','10:10:00',3.11),('14598','2013-06-04','10:15:00',2.85),('14598','2013-06-04','10:20:00',2.54),('14598','2013-06-04','10:25:00',2.7),('14598','2013-06-04','10:30:00',3.35),('14598','2013-06-04','10:35:00',4.22),('14598','2013-06-04','10:40:00',3.05),('14598','2013-06-04','10:45:00',2.2),('14598','2013-06-04','10:50:00',2.11),('14598','2013-06-04','10:55:00',1.9),('14598','2013-06-04','11:00:00',1.68),('14598','2013-06-04','11:05:00',2.2),('14598','2013-06-04','11:10:00',2.68),('14598','2013-06-04','11:15:00',4.31),('14598','2013-06-04','11:20:00',3.79),('14598','2013-06-04','11:25:00',3.6),('14598','2013-06-04','11:30:00',4.42),('14598','2013-06-04','11:35:00',3.66),('14598','2013-06-04','11:40:00',4.73),('14598','2013-06-04','11:45:00',5.18),('14598','2013-06-04','11:50:00',5.06),('14598','2013-06-04','11:55:00',5.5),('14598','2013-06-04','12:00:00',5.53),('14598','2013-06-04','12:05:00',3.38),('14598','2013-06-04','12:10:00',3.63),('14598','2013-06-04','12:15:00',2.9),('14598','2013-06-04','12:20:00',3.33),('14598','2013-06-04','12:25:00',3.82),('14598','2013-06-04','12:30:00',2.42),('14598','2013-06-04','12:35:00',2.63),('14598','2013-06-04','12:40:00',3.22),('14598','2013-06-04','12:45:00',2.21),('14598','2013-06-04','12:50:00',1.92),('14598','2013-06-04','12:55:00',2),('14598','2013-06-04','13:00:00',2.69),('14598','2013-06-04','13:05:00',2.94),('14598','2013-06-04','13:10:00',3.46),('14598','2013-06-04','13:15:00',3.4),('14598','2013-06-04','13:20:00',4.03),('14598','2013-06-04','13:25:00',3.65),('14598','2013-06-04','13:30:00',3.22),('14598','2013-06-04','13:35:00',3.06),('14598','2013-06-04','13:40:00',2.92),('14598','2013-06-04','13:45:00',2.76),('14598','2013-06-04','13:50:00',2.79),('14598','2013-06-04','13:55:00',3.3),('14598','2013-06-04','14:00:00',4.96),('14598','2013-06-04','14:05:00',5.41),('14598','2013-06-04','14:10:00',5.38),('14598','2013-06-04','14:15:00',5.26),('14598','2013-06-04','14:20:00',5.61),('14598','2013-06-04','14:25:00',5.17),('14598','2013-06-04','14:30:00',5.53),('14598','2013-06-04','14:35:00',5.45),('14598','2013-06-04','14:40:00',5.2),('14598','2013-06-04','14:45:00',5.18),('14598','2013-06-04','14:50:00',5.36),('14598','2013-06-04','14:55:00',5.41),('14598','2013-06-04','15:00:00',4.92),('14598','2013-06-04','15:05:00',5.04),('14598','2013-06-04','15:10:00',5.17),('14598','2013-06-04','15:15:00',4.9),('14598','2013-06-04','15:20:00',5.01),('14598','2013-06-04','15:25:00',4.9),('14598','2013-06-04','15:30:00',4.41),('14598','2013-06-04','15:35:00',4.31),('14598','2013-06-04','15:40:00',2.58),('14598','2013-06-04','15:45:00',3.22),('14598','2013-06-04','15:50:00',3.89),('14598','2013-06-04','15:55:00',4.22),('14598','2013-06-04','16:00:00',4.35),('14598','2013-06-04','16:05:00',4.42),('14598','2013-06-04','16:10:00',3.69),('14598','2013-06-04','16:15:00',3.9),('14598','2013-06-04','16:20:00',4.11),('14598','2013-06-04','16:25:00',3.05),('14598','2013-06-04','16:30:00',2.97),('14598','2013-06-04','16:35:00',2.66),('14598','2013-06-04','16:40:00',2.57),('14598','2013-06-04','16:45:00',2.19),('14598','2013-06-04','16:50:00',1.64),('14598','2013-06-04','16:55:00',1.54),('14598','2013-06-04','17:00:00',1.45),('14598','2013-06-04','17:05:00',1.34),('14598','2013-06-04','17:10:00',1.24),('14598','2013-06-04','17:15:00',1.18),('14598','2013-06-04','17:20:00',1.17),('14598','2013-06-04','17:25:00',1.15),('14598','2013-06-04','17:30:00',1.12),('14598','2013-06-04','17:35:00',1.1),('14598','2013-06-04','17:40:00',1.11),('14598','2013-06-04','17:45:00',1.21),('14598','2013-06-04','17:50:00',1.37),('14598','2013-06-04','17:55:00',1.49),('14598','2013-06-04','18:00:00',1.31),('14598','2013-06-04','18:05:00',1.17),('14598','2013-06-04','18:25:00',1.14),('14598','2013-06-04','18:30:00',1.41),('14598','2013-06-04','18:35:00',1.35),('14598','2013-06-04','18:50:00',1.19),('14598','2013-06-03','07:35:00',1.04),('14598','2013-06-03','07:40:00',1.12),('14598','2013-06-03','07:45:00',1.18),('14598','2013-06-03','07:55:00',1.11),('14598','2013-06-03','08:00:00',1.28),('14598','2013-06-03','08:05:00',1.35),('14598','2013-06-03','08:10:00',1.43),('14598','2013-06-03','08:15:00',1.54),('14598','2013-06-03','08:20:00',1.69),('14598','2013-06-03','08:25:00',1.82),('14598','2013-06-03','08:30:00',2.21),('14598','2013-06-03','08:35:00',2.45),('14598','2013-06-03','08:40:00',2.48),('14598','2013-06-03','08:45:00',2.44),('14598','2013-06-03','08:50:00',1.45),('14598','2013-06-03','08:55:00',1.22),('14598','2013-06-03','09:00:00',2.84),('14598','2013-06-03','09:05:00',2.27),('14598','2013-06-03','09:10:00',1.76),('14598','2013-06-03','09:15:00',1.62),('14598','2013-06-03','09:20:00',1.29),('14598','2013-06-03','09:25:00',1.52),('14598','2013-06-03','10:00:00',1.28),('14598','2013-06-03','10:05:00',2.76),('14598','2013-06-03','10:10:00',3.41),('14598','2013-06-03','10:15:00',3.53),('14598','2013-06-03','10:20:00',4.86),('14598','2013-06-03','10:25:00',2.27),('14598','2013-06-03','10:30:00',2.19),('14598','2013-06-03','10:35:00',2.68),('14598','2013-06-03','10:40:00',3.07),('14598','2013-06-03','10:45:00',3.15),('14598','2013-06-03','10:50:00',2.71),('14598','2013-06-03','10:55:00',1.74),('14598','2013-06-03','11:00:00',2.24),('14598','2013-06-03','11:05:00',2.91),('14598','2013-06-03','11:10:00',1.73),('14598','2013-06-03','11:15:00',1.85),('14598','2013-06-03','11:20:00',2.14),('14598','2013-06-03','11:25:00',2.84),('14598','2013-06-03','11:30:00',3.27),('14598','2013-06-03','11:35:00',4.19),('14598','2013-06-03','11:40:00',5.93),('14598','2013-06-03','11:45:00',4.76),('14598','2013-06-03','11:50:00',5.58),('14598','2013-06-03','11:55:00',5.48),('14598','2013-06-03','12:00:00',4.09),('14598','2013-06-03','12:05:00',1.6),('14598','2013-06-03','12:10:00',2.09),('14598','2013-06-03','12:15:00',3),('14598','2013-06-03','12:20:00',2.38),('14598','2013-06-03','12:25:00',1.93),('14598','2013-06-03','12:30:00',2.03),('14598','2013-06-03','12:35:00',2.75),('14598','2013-06-03','12:40:00',3.52),('14598','2013-06-03','12:45:00',3.93),('14598','2013-06-03','12:50:00',5.62),('14598','2013-06-03','12:55:00',6.02),('14598','2013-06-03','13:00:00',5.26),('14598','2013-06-03','13:05:00',3.95),('14598','2013-06-03','13:10:00',4.04),('14598','2013-06-03','13:15:00',2.7),('14598','2013-06-03','13:20:00',4.76),('14598','2013-06-03','13:25:00',5.22),('14598','2013-06-03','13:30:00',2.89),('14598','2013-06-03','13:35:00',2.42),('14598','2013-06-03','13:40:00',5.62),('14598','2013-06-03','13:45:00',4.93),('14598','2013-06-03','13:50:00',5.08),('14598','2013-06-03','13:55:00',2.27),('14598','2013-06-03','14:00:00',4.55),('14598','2013-06-03','14:05:00',2.89),('14598','2013-06-03','14:10:00',5.44),('14598','2013-06-03','14:15:00',5.47),('14598','2013-06-03','14:20:00',5.37),('14598','2013-06-03','14:25:00',5.35),('14598','2013-06-03','14:30:00',5.27),('14598','2013-06-03','14:35:00',5.2),('14598','2013-06-03','14:40:00',5.19),('14598','2013-06-03','14:45:00',5.09),('14598','2013-06-03','14:50:00',5.16),('14598','2013-06-03','14:55:00',5.17),('14598','2013-06-03','15:00:00',5.14),('14598','2013-06-03','15:05:00',5.14),('14598','2013-06-03','15:10:00',5.19),('14598','2013-06-03','15:15:00',5.16),('14598','2013-06-03','15:20:00',5.07),('14598','2013-06-03','15:25:00',5.05),('14598','2013-06-03','15:30:00',5.06),('14598','2013-06-03','15:35:00',5.04),('14598','2013-06-03','15:40:00',4.94),('14598','2013-06-03','15:45:00',4.49),('14598','2013-06-03','15:50:00',4.73),('14598','2013-06-03','15:55:00',4.69),('14598','2013-06-03','16:00:00',4.63),('14598','2013-06-03','16:05:00',4.58),('14598','2013-06-03','16:10:00',4.53),('14598','2013-06-03','16:15:00',4.5),('14598','2013-06-03','16:20:00',4.48),('14598','2013-06-03','16:25:00',4.47),('14598','2013-06-03','16:30:00',4.39),('14598','2013-06-03','16:35:00',4.05),('14598','2013-06-03','16:40:00',3.48),('14598','2013-06-03','16:45:00',2.98),('14598','2013-06-03','16:50:00',3.18),('14598','2013-06-03','16:55:00',4.24),('14598','2013-06-03','17:00:00',2.92),('14598','2013-06-03','17:05:00',4.22),('14598','2013-06-03','17:10:00',4.1),('14598','2013-06-03','17:15:00',3.64),('14598','2013-06-03','17:20:00',3.93),('14598','2013-06-03','17:25:00',4.11),('14598','2013-06-03','17:30:00',3.8),('14598','2013-06-03','17:35:00',3.42),('14598','2013-06-03','17:40:00',3.67),('14598','2013-06-03','17:45:00',3.58),('14598','2013-06-03','17:50:00',2.58),('14598','2013-06-03','17:55:00',1.68),('14598','2013-06-03','18:00:00',1.37),('14598','2013-06-03','18:05:00',1.31),('14598','2013-06-02','08:25:00',1.39),('14598','2013-06-02','08:30:00',2.41),('14598','2013-06-02','08:35:00',1.62),('14598','2013-06-02','08:40:00',1.61),('14598','2013-06-02','08:45:00',2.11),('14598','2013-06-02','08:50:00',2.57),('14598','2013-06-02','08:55:00',2.59),('14598','2013-06-02','09:00:00',2.61),('14598','2013-06-02','09:05:00',2.71),('14598','2013-06-02','09:10:00',2.86),('14598','2013-06-02','09:15:00',2.94),('14598','2013-06-02','09:20:00',2.92),('14598','2013-06-02','09:25:00',2.99),('14598','2013-06-02','09:30:00',3.09),('14598','2013-06-02','09:35:00',3.16),('14598','2013-06-02','09:40:00',3.27),('14598','2013-06-02','09:45:00',3.45),('14598','2013-06-02','09:50:00',2.77),('14598','2013-06-02','09:55:00',2.41),('14598','2013-06-02','10:00:00',3.87),('14598','2013-06-02','10:05:00',3.85),('14598','2013-06-02','10:10:00',3.92),('14598','2013-06-02','10:15:00',4.13),('14598','2013-06-02','10:20:00',3.26),('14598','2013-06-02','10:25:00',4.01),('14598','2013-06-02','10:30:00',4.12),('14598','2013-06-02','10:35:00',4.15),('14598','2013-06-02','10:40:00',4.22),('14598','2013-06-02','10:45:00',4.25),('14598','2013-06-02','10:50:00',4.31),('14598','2013-06-02','10:55:00',4.38),('14598','2013-06-02','11:00:00',4.46),('14598','2013-06-02','11:05:00',4.53),('14598','2013-06-02','11:10:00',4.55),('14598','2013-06-02','11:15:00',4.6),('14598','2013-06-02','11:20:00',4.7),('14598','2013-06-02','11:25:00',4.76),('14598','2013-06-02','11:30:00',4.8),('14598','2013-06-02','11:35:00',4.83),('14598','2013-06-02','11:40:00',4.88),('14598','2013-06-02','11:45:00',4.91),('14598','2013-06-02','11:50:00',4.95),('14598','2013-06-02','11:55:00',4.97),('14598','2013-06-02','12:00:00',4.92),('14598','2013-06-02','12:05:00',5.04),('14598','2013-06-02','12:10:00',5.07),('14598','2013-06-02','12:15:00',5.12),('14598','2013-06-02','12:20:00',5.15),('14598','2013-06-02','12:25:00',5.14),('14598','2013-06-02','12:30:00',5.2),('14598','2013-06-02','12:35:00',5.22),('14598','2013-06-02','12:40:00',5.24),('14598','2013-06-02','12:45:00',5.27),('14598','2013-06-02','12:50:00',5.29),('14598','2013-06-02','12:55:00',5.28),('14598','2013-06-02','13:00:00',5.28),('14598','2013-06-02','13:05:00',5.31),('14598','2013-06-02','13:10:00',5.32),('14598','2013-06-02','13:15:00',5.32),('14598','2013-06-02','13:20:00',5.32),('14598','2013-06-02','13:25:00',5.33),('14598','2013-06-02','13:30:00',5.31),('14598','2013-06-02','13:35:00',5.32),('14598','2013-06-02','13:40:00',5.04),('14598','2013-06-02','13:45:00',5.38),('14598','2013-06-02','13:50:00',5.42),('14598','2013-06-02','13:55:00',5.44),('14598','2013-06-02','14:00:00',4.27),('14598','2013-06-02','14:05:00',5.23),('14598','2013-06-02','14:10:00',5.54),('14598','2013-06-02','14:15:00',5.5),('14598','2013-06-02','14:20:00',5.12),('14598','2013-06-02','14:25:00',4.24),('14598','2013-06-02','14:30:00',5.41),('14598','2013-06-02','14:35:00',5.27),('14598','2013-06-02','14:40:00',5.22),('14598','2013-06-02','14:45:00',5.25),('14598','2013-06-02','14:50:00',5.09),('14598','2013-06-02','14:55:00',4.65),('14598','2013-06-02','15:00:00',5.27),('14598','2013-06-02','15:05:00',4.82),('14598','2013-06-02','15:10:00',3.83),('14598','2013-06-02','15:15:00',2.93),('14598','2013-06-02','15:20:00',3.11),('14598','2013-06-02','15:25:00',3.87),('14598','2013-06-02','15:30:00',5.15),('14598','2013-06-02','15:35:00',4.62),('14598','2013-06-02','15:40:00',4.77),('14598','2013-06-02','15:45:00',4.4),('14598','2013-06-02','15:50:00',4.18),('14598','2013-06-02','15:55:00',4.55),('14598','2013-06-02','16:00:00',3.89),('14598','2013-06-02','16:05:00',4.58),('14598','2013-06-02','16:10:00',4.69),('14598','2013-06-02','16:15:00',3.83),('14598','2013-06-02','16:20:00',4.22),('14598','2013-06-02','16:25:00',4.27),('14598','2013-06-02','16:30:00',4.19),('14598','2013-06-02','16:35:00',3.91),('14598','2013-06-02','16:40:00',4.08),('14598','2013-06-02','16:45:00',3.66),('14598','2013-06-02','16:50:00',3.65),('14598','2013-06-02','16:55:00',3.94),('14598','2013-06-02','17:00:00',2.73),('14598','2013-06-02','17:05:00',2.73),('14598','2013-06-02','17:10:00',2.97),('14598','2013-06-02','17:15:00',3.55),('14598','2013-06-02','17:20:00',2.62),('14598','2013-06-02','17:25:00',2.46),('14598','2013-06-02','17:30:00',3.06),('14598','2013-06-02','17:35:00',3.18),('14598','2013-06-02','17:40:00',1.76),('14598','2013-06-02','17:45:00',2.88),('14598','2013-06-02','17:50:00',3.13),('14598','2013-06-02','17:55:00',3.03),('14598','2013-06-02','18:00:00',2.69),('14598','2013-06-02','18:05:00',2.68),('14598','2013-06-02','18:10:00',2.53),('14598','2013-06-02','18:15:00',2.42),('14598','2013-06-02','18:20:00',2.32),('14598','2013-06-02','18:25:00',2.2),('14598','2013-06-02','18:30:00',2.08),('14598','2013-06-02','18:35:00',1.97),('14598','2013-06-02','18:40:00',1.84),('14598','2013-06-02','18:45:00',1.69),('14598','2013-06-02','18:50:00',1.62),('14598','2013-06-02','18:55:00',1.5),('14598','2013-06-02','19:00:00',1.41),('14598','2013-06-02','19:05:00',1.31),('14598','2013-06-02','19:10:00',1.22),('14598','2013-06-02','19:15:00',1.09),('14598','2013-06-02','19:20:00',1.01),('14598','2013-06-01','07:45:00',1.02),('14598','2013-06-01','08:00:00',1),('14598','2013-06-01','08:05:00',1.19),('14598','2013-06-01','08:10:00',1.34),('14598','2013-06-01','08:15:00',1.07),('14598','2013-06-01','08:20:00',1.34),('14598','2013-06-01','08:25:00',1.18),('14598','2013-06-01','08:30:00',1.27),('14598','2013-06-01','08:35:00',1.11),('14598','2013-06-01','08:55:00',1.03),('14598','2013-06-01','09:05:00',1.52),('14598','2013-06-01','09:10:00',3.52),('14598','2013-06-01','09:15:00',2.78),('14598','2013-06-01','09:20:00',3.76),('14598','2013-06-01','09:25:00',3.48),('14598','2013-06-01','09:30:00',1.19),('14598','2013-06-01','10:20:00',1.34),('14598','2013-06-01','10:25:00',1.64),('14598','2013-06-01','10:30:00',2.42),('14598','2013-06-01','10:35:00',2.83),('14598','2013-06-01','10:40:00',1.13),('14598','2013-06-01','10:50:00',1.06),('14598','2013-06-01','10:55:00',1.35),('14598','2013-06-01','11:00:00',1.62),('14598','2013-06-01','11:05:00',1.97),('14598','2013-06-01','11:10:00',2.25),('14598','2013-06-01','11:15:00',1.83),('14598','2013-06-01','11:20:00',1.75),('14598','2013-06-01','11:25:00',1.37),('14598','2013-06-01','11:30:00',1.11),('14598','2013-06-01','11:35:00',1.18),('14598','2013-06-01','11:40:00',2.06),('14598','2013-06-01','11:45:00',3.58),('14598','2013-06-01','11:50:00',3.81),('14598','2013-06-01','11:55:00',5.36),('14598','2013-06-01','12:00:00',5.16),('14598','2013-06-01','12:05:00',3.15),('14598','2013-06-01','12:10:00',3.04),('14598','2013-06-01','12:15:00',2.91),('14598','2013-06-01','12:20:00',2.97),('14598','2013-06-01','12:25:00',2.96),('14598','2013-06-01','12:30:00',2.97),('14598','2013-06-01','12:35:00',3.1),('14598','2013-06-01','12:40:00',3.35),('14598','2013-06-01','12:45:00',3.41),('14598','2013-06-01','12:50:00',3.26),('14598','2013-06-01','12:55:00',3.38),('14598','2013-06-01','13:00:00',3.59),('14598','2013-06-01','13:05:00',3.8),('14598','2013-06-01','13:10:00',4.11),('14598','2013-06-01','13:15:00',4.23),('14598','2013-06-01','13:20:00',3.56),('14598','2013-06-01','13:25:00',4.12),('14598','2013-06-01','13:30:00',5.35),('14598','2013-06-01','13:35:00',4.58),('14598','2013-06-01','13:40:00',5.36),('14598','2013-06-01','13:45:00',3.58),('14598','2013-06-01','13:50:00',2.32),('14598','2013-06-01','13:55:00',2.27),('14598','2013-06-01','14:00:00',2.82),('14598','2013-06-01','14:05:00',3.44),('14598','2013-06-01','14:10:00',3.18),('14598','2013-06-01','14:15:00',3.19),('14598','2013-06-01','14:20:00',3.72),('14598','2013-06-01','14:25:00',3.19),('14598','2013-06-01','14:30:00',2.97),('14598','2013-06-01','14:35:00',2.51),('14598','2013-06-01','14:40:00',1.57),('14598','2013-06-01','14:45:00',1.63),('14598','2013-06-01','14:50:00',1.89),('14598','2013-06-01','14:55:00',1.48),('14598','2013-06-01','15:00:00',1.4),('14598','2013-06-01','15:05:00',1.37),('14598','2013-06-01','15:10:00',1.08),('14598','2013-06-01','15:15:00',1.27),('14598','2013-06-01','15:20:00',1.17),('14598','2013-06-01','15:30:00',1.23),('14598','2013-06-01','15:35:00',1.55),('14598','2013-06-01','15:40:00',1.41),('14598','2013-06-01','15:45:00',1.21),('14598','2013-06-01','15:50:00',1.08),('14598','2013-06-01','15:55:00',1.13),('14598','2013-06-01','16:00:00',1.16),('14598','2013-06-01','16:05:00',1.49),('14598','2013-06-01','16:10:00',1.72),('14598','2013-06-01','16:15:00',1.57),('14598','2013-06-01','16:20:00',1.26),('14598','2013-06-01','16:25:00',1.23),('14598','2013-06-01','16:30:00',1.24),('14598','2013-06-01','16:35:00',1.24),('14598','2013-06-01','16:40:00',1.16),('14598','2013-06-01','17:45:00',2.42),('14598','2013-06-01','17:50:00',3.85),('14598','2013-06-01','17:55:00',4.07),('14598','2013-06-01','18:00:00',3.54),('14598','2013-06-01','18:05:00',3.12),('14598','2013-06-01','18:10:00',2.85),('14598','2013-06-01','18:15:00',2.81),('14598','2013-06-01','18:20:00',2.94),('14598','2013-06-01','18:25:00',2.81),('14598','2013-06-01','18:30:00',2.55),('14598','2013-06-01','18:35:00',2.27),('14598','2013-06-01','18:40:00',1.94),('14598','2013-06-01','18:45:00',1.2),('14598','2013-06-01','18:50:00',1.74),('14598','2013-06-01','18:55:00',1.62),('14598','2013-06-01','19:20:00',1.2),('14598','2013-06-01','19:25:00',1.14),('14598','2013-06-01','19:30:00',1.1),('14598','2013-06-01','19:35:00',1.04),('14598','2014-04-02','09:00:00',1.34),('14598','2014-04-02','09:05:00',1.33),('14598','2014-04-02','09:10:00',1.09),('14598','2014-04-02','09:15:00',1.03),('14598','2014-04-02','09:20:00',1.08),('14598','2014-04-02','09:25:00',1.08),('14598','2014-04-02','09:30:00',1.11),('14598','2014-04-02','09:35:00',1.09),('14598','2014-04-02','09:40:00',2.1),('14598','2014-04-02','09:45:00',2.55),('14598','2014-04-02','09:50:00',2.51),('14598','2014-04-02','09:55:00',2.59),('14598','2014-04-02','10:00:00',2.81),('14598','2014-04-02','10:05:00',3.15),('14598','2014-04-02','10:10:00',2.13),('14598','2014-04-02','10:25:00',2.64),('14598','2014-04-02','10:30:00',3.85),('14598','2014-04-02','10:35:00',3.8),('14598','2014-04-02','10:40:00',2.57),('14598','2014-04-02','10:45:00',3.42),('14598','2014-04-02','10:50:00',1.91),('14598','2014-04-02','10:55:00',3.19),('14598','2014-04-02','11:00:00',3.49),('14598','2014-04-02','11:05:00',3.84),('14598','2014-04-02','11:10:00',3.8),('14598','2014-04-02','11:15:00',3.92),('14598','2014-04-02','11:20:00',3.93),('14598','2014-04-02','11:25:00',3.96),('14598','2014-04-02','11:30:00',4.14),('14598','2014-04-02','11:35:00',4.2),('14598','2014-04-02','11:40:00',4.22),('14598','2014-04-02','11:45:00',4.21),('14598','2014-04-02','11:50:00',4.26),('14598','2014-04-02','11:55:00',4.32),('14598','2014-04-02','12:00:00',4.37),('14598','2014-04-02','12:05:00',4.41),('14598','2014-04-02','12:10:00',4.43),('14598','2014-04-02','12:15:00',4.46),('14598','2014-04-02','12:20:00',4.54),('14598','2014-04-02','12:25:00',4.6),('14598','2014-04-02','12:30:00',4.64),('14598','2014-04-02','12:35:00',4.66),('14598','2014-04-02','12:40:00',4.75),('14598','2014-04-02','12:45:00',4.76),('14598','2014-04-02','12:50:00',4.77),('14598','2014-04-02','12:55:00',4.8),('14598','2014-04-02','13:00:00',4.8),('14598','2014-04-02','13:05:00',4.83),('14598','2014-04-02','13:10:00',4.95),('14598','2014-04-02','13:15:00',3.9),('14598','2014-04-02','13:20:00',4.74),('14598','2014-04-02','13:25:00',5.09),('14598','2014-04-02','13:30:00',5.08),('14598','2014-04-02','13:35:00',4.84),('14598','2014-04-02','13:40:00',4.62),('14598','2014-04-02','13:45:00',3.83),('14598','2014-04-02','13:50:00',4.84),('14598','2014-04-02','13:55:00',4.99),('14598','2014-04-02','14:00:00',3.79),('14598','2014-04-02','14:05:00',4.61),('14598','2014-04-02','14:10:00',4.86),('14598','2014-04-02','14:15:00',4.73),('14598','2014-04-02','14:20:00',4.78),('14598','2014-04-02','14:25:00',4.66),('14598','2014-04-02','14:30:00',4.76),('14598','2014-04-02','14:35:00',4.72),('14598','2014-04-02','14:40:00',4.64),('14598','2014-04-02','14:45:00',4.49),('14598','2014-04-02','14:50:00',4.47),('14598','2014-04-02','14:55:00',4.51),('14598','2014-04-02','15:00:00',3.7),('14598','2014-04-02','15:05:00',4.57),('14598','2014-04-02','15:10:00',4.47),('14598','2014-04-02','15:15:00',4.36),('14598','2014-04-02','15:20:00',4.35),('14598','2014-04-02','15:25:00',4.38),('14598','2014-04-02','15:30:00',4.29),('14598','2014-04-02','15:35:00',4.13),('14598','2014-04-02','15:40:00',4.24),('14598','2014-04-02','15:45:00',4.1),('14598','2014-04-02','15:50:00',4.05),('14598','2014-04-02','15:55:00',4.05),('14598','2014-04-02','16:00:00',3.9),('14598','2014-04-02','16:05:00',3.88),('14598','2014-04-02','16:10:00',3.88),('14598','2014-04-02','16:15:00',3.78),('14598','2014-04-02','16:20:00',3.72),('14598','2014-04-02','16:25:00',3.52),('14598','2014-04-02','16:30:00',3.39),('14598','2014-04-02','16:35:00',3.27),('14598','2014-04-02','16:40:00',3.1),('14598','2014-04-02','16:45:00',3.12),('14598','2014-04-02','16:50:00',3.23),('14598','2014-04-02','16:55:00',3.04),('14598','2014-04-02','17:00:00',2.9),('14598','2014-04-02','17:05:00',2.54),('14598','2014-04-02','17:10:00',2.2),('14598','2014-04-02','17:15:00',2.35),('14598','2014-04-02','17:20:00',2.22),('14598','2014-04-02','17:25:00',2.1),('14598','2014-04-02','17:30:00',2.11),('14598','2014-04-02','17:35:00',1.77),('14598','2014-04-02','17:40:00',1.88),('14598','2014-04-02','17:45:00',2.3),('14598','2014-04-02','17:50:00',1.94),('14598','2014-04-02','17:55:00',1.51),('14598','2014-04-02','18:00:00',1.24),('14598','2014-04-02','18:05:00',1.02),('14598','2014-04-02','18:10:00',1.03),('14598','2014-04-02','18:15:00',1.04),('14598','2013-05-31','07:45:00',1.08),('14598','2013-05-31','07:50:00',1.13),('14598','2013-05-31','07:55:00',1.25),('14598','2013-05-31','08:00:00',1.35),('14598','2013-05-31','08:05:00',1.41),('14598','2013-05-31','08:10:00',1.53),('14598','2013-05-31','08:15:00',1.65),('14598','2013-05-31','08:20:00',1.79),('14598','2013-05-31','08:25:00',1.94),('14598','2013-05-31','08:30:00',2.04),('14598','2013-05-31','08:35:00',2.14),('14598','2013-05-31','08:40:00',2.09),('14598','2013-05-31','08:45:00',2.08),('14598','2013-05-31','08:50:00',2.14),('14598','2013-05-31','08:55:00',2.49),('14598','2013-05-31','09:00:00',2.6),('14598','2013-05-31','09:05:00',2.81),('14598','2013-05-31','09:10:00',2.7),('14598','2013-05-31','09:15:00',2.83),('14598','2013-05-31','09:20:00',3.19),('14598','2013-05-31','09:25:00',3.43),('14598','2013-05-31','09:30:00',3.81),('14598','2013-05-31','09:35:00',2.61),('14598','2013-05-31','09:40:00',4.16),('14598','2013-05-31','09:45:00',3.97),('14598','2013-05-31','09:50:00',3.56),('14598','2013-05-31','09:55:00',1.46),('14598','2013-05-31','10:00:00',1.22),('14598','2013-05-31','10:05:00',1.52),('14598','2013-05-31','10:10:00',4.46),('14598','2013-05-31','10:15:00',3.15),('14598','2013-05-31','10:20:00',2.85),('14598','2013-05-31','10:25:00',3.41),('14598','2013-05-31','10:30:00',4.73),('14598','2013-05-31','10:35:00',4.98),('14598','2013-05-31','10:40:00',2.97),('14598','2013-05-31','10:45:00',1.51),('14598','2013-05-31','10:50:00',4.46),('14598','2013-05-31','10:55:00',4.74),('14598','2013-05-31','11:00:00',5.12),('14598','2013-05-31','11:05:00',1.61),('14598','2013-05-31','11:10:00',4.6),('14598','2013-05-31','11:15:00',3.49),('14598','2013-05-31','11:20:00',3.85),('14598','2013-05-31','11:25:00',4.88),('14598','2013-05-31','11:30:00',4.98),('14598','2013-05-31','11:35:00',5.04),('14598','2013-05-31','11:40:00',5.36),('14598','2013-05-31','11:45:00',5.94),('14598','2013-05-31','11:50:00',2.7),('14598','2013-05-31','11:55:00',1.49),('14598','2013-05-31','12:00:00',2.85),('14598','2013-05-31','12:05:00',3.3),('14598','2013-05-31','12:10:00',3.07),('14598','2013-05-31','12:15:00',1.98),('14598','2013-05-31','12:20:00',2.06),('14598','2013-05-31','12:25:00',2.19),('14598','2013-05-31','12:30:00',2.93),('14598','2013-05-31','12:35:00',3.51),('14598','2013-05-31','12:40:00',1.8),('14598','2013-05-31','12:45:00',1.06),('14598','2013-05-31','12:50:00',1.97),('14598','2013-05-31','12:55:00',2.86),('14598','2013-05-31','13:00:00',2.81),('14598','2013-05-31','13:05:00',2.27),('14598','2013-05-31','13:10:00',2.48),('14598','2013-05-31','13:15:00',1.87),('14598','2013-05-31','13:20:00',1.96),('14598','2013-05-31','13:25:00',2.22),('14598','2013-05-31','13:30:00',2.36),('14598','2013-05-31','13:35:00',2.5),('14598','2013-05-31','13:40:00',1.26),('14598','2013-05-31','14:05:00',1.02),('14598','2013-05-31','14:10:00',3.41),('14598','2013-05-31','14:15:00',3.03),('14598','2013-05-31','14:20:00',4.48),('14598','2013-05-31','14:25:00',2.64),('14598','2013-05-31','14:30:00',1.42),('14598','2013-05-31','14:35:00',1.51),('14598','2013-05-31','14:45:00',1.01),('14598','2013-05-31','14:50:00',1.58),('14598','2013-05-31','14:55:00',2.23),('14598','2013-05-31','15:00:00',2.46),('14598','2013-05-31','15:05:00',1.79),('14598','2013-05-31','15:10:00',1.86),('14598','2013-05-31','15:15:00',1.77),('14598','2013-05-31','15:20:00',1.6),('14598','2013-05-31','15:25:00',2.13),('14598','2013-05-31','15:30:00',2.98),('14598','2013-05-31','15:35:00',3.19),('14598','2013-05-31','15:40:00',2.16),('14598','2013-05-31','15:45:00',1.12),('14598','2013-05-31','15:55:00',1.07),('14598','2013-05-31','16:00:00',1.35),('14598','2013-05-31','16:05:00',1.43),('14598','2013-05-31','16:10:00',1.1),('14598','2013-05-31','16:20:00',1.4),('14598','2013-05-31','16:25:00',1.31),('14598','2013-05-31','17:00:00',1.15),('14598','2013-05-31','17:05:00',1.24),('14598','2013-05-31','17:10:00',1.25),('14598','2013-05-31','17:15:00',1.2),('14598','2013-05-31','17:20:00',1.03),('14598','2013-05-31','17:25:00',1.05),('14598','2013-05-31','17:30:00',1.19),('14598','2013-05-31','17:35:00',1.19),('14598','2013-05-31','19:20:00',1.12),('14598','2013-05-31','19:25:00',1.12),('14598','2013-05-30','07:30:00',1.08),('14598','2013-05-30','08:15:00',1.73),('14598','2013-05-30','08:20:00',1.86),('14598','2013-05-30','08:25:00',2.12),('14598','2013-05-30','08:30:00',2.31),('14598','2013-05-30','08:35:00',2.26),('14598','2013-05-30','08:40:00',2.36),('14598','2013-05-30','08:45:00',2.65),('14598','2013-05-30','08:50:00',1.95),('14598','2013-05-30','08:55:00',2.34),('14598','2013-05-30','09:00:00',2.65),('14598','2013-05-30','09:05:00',2.73),('14598','2013-05-30','09:10:00',2.84),('14598','2013-05-30','09:15:00',2.96),('14598','2013-05-30','09:20:00',3.06),('14598','2013-05-30','09:25:00',3.21),('14598','2013-05-30','09:30:00',3.28),('14598','2013-05-30','09:35:00',3.47),('14598','2013-05-30','09:40:00',3.68),('14598','2013-05-30','09:45:00',3.46),('14598','2013-05-30','09:50:00',3.2),('14598','2013-05-30','09:55:00',1.85),('14598','2013-05-30','10:00:00',2.12),('14598','2013-05-30','10:05:00',3.38),('14598','2013-05-30','10:10:00',3.71),('14598','2013-05-30','10:15:00',4.06),('14598','2013-05-30','10:20:00',4.09),('14598','2013-05-30','10:25:00',4.16),('14598','2013-05-30','10:30:00',4.21),('14598','2013-05-30','10:35:00',4.31),('14598','2013-05-30','10:40:00',4.42),('14598','2013-05-30','10:45:00',4.43),('14598','2013-05-30','10:50:00',4.53),('14598','2013-05-30','10:55:00',4.64),('14598','2013-05-30','11:00:00',3.93),('14598','2013-05-30','11:05:00',3.45),('14598','2013-05-30','11:10:00',4.24),('14598','2013-05-30','11:15:00',2.19),('14598','2013-05-30','11:20:00',4.05),('14598','2013-05-30','11:25:00',5.46),('14598','2013-05-30','11:30:00',5.52),('14598','2013-05-30','11:35:00',3.78),('14598','2013-05-30','11:40:00',3.78),('14598','2013-05-30','11:45:00',3.58),('14598','2013-05-30','11:50:00',4.54),('14598','2013-05-30','11:55:00',4.01),('14598','2013-05-30','12:00:00',4.14),('14598','2013-05-30','12:05:00',3.95),('14598','2013-05-30','12:10:00',5.5),('14598','2013-05-30','12:15:00',5.62),('14598','2013-05-30','12:20:00',4.4),('14598','2013-05-30','12:25:00',4.33),('14598','2013-05-30','12:30:00',3.43),('14598','2013-05-30','12:35:00',3.96),('14598','2013-05-30','12:40:00',4.83),('14598','2013-05-30','12:45:00',4.47),('14598','2013-05-30','12:50:00',5.98),('14598','2013-05-30','12:55:00',4.4),('14598','2013-05-30','13:00:00',4.42),('14598','2013-05-30','13:05:00',4.51),('14598','2013-05-30','13:10:00',4.01),('14598','2013-05-30','13:15:00',4.93),('14598','2013-05-30','13:20:00',4.88),('14598','2013-05-30','13:25:00',3.79),('14598','2013-05-30','13:30:00',5.78),('14598','2013-05-30','13:35:00',5.73),('14598','2013-05-30','13:40:00',5.64),('14598','2013-05-30','13:45:00',4.61),('14598','2013-05-30','13:50:00',5.36),('14598','2013-05-30','13:55:00',5.24),('14598','2013-05-30','14:00:00',4.4),('14598','2013-05-30','14:05:00',2.87),('14598','2013-05-30','14:10:00',5.47),('14598','2013-05-30','14:15:00',2.38),('14598','2013-05-30','14:20:00',4.19),('14598','2013-05-30','14:25:00',6.03),('14598','2013-05-30','14:30:00',2.92),('14598','2013-05-30','14:35:00',4.3),('14598','2013-05-30','14:40:00',3.14),('14598','2013-05-30','14:45:00',4.23),('14598','2013-05-30','14:50:00',5.66),('14598','2013-05-30','14:55:00',5.55),('14598','2013-05-30','15:00:00',5.18),('14598','2013-05-30','15:05:00',5.14),('14598','2013-05-30','15:10:00',5.68),('14598','2013-05-30','15:15:00',5.26),('14598','2013-05-30','15:20:00',4.98),('14598','2013-05-30','15:25:00',5.51),('14598','2013-05-30','15:30:00',5.61),('14598','2013-05-30','15:35:00',3.69),('14598','2013-05-30','15:40:00',3.63),('14598','2013-05-30','15:45:00',5.51),('14598','2013-05-30','15:50:00',4.66),('14598','2013-05-30','15:55:00',4.99),('14598','2013-05-30','16:00:00',3.26),('14598','2013-05-30','16:05:00',4.3),('14598','2013-05-30','16:10:00',3.45),('14598','2013-05-30','16:15:00',3.39),('14598','2013-05-30','16:20:00',3.23),('14598','2013-05-30','16:25:00',2.61),('14598','2013-05-30','16:30:00',2.52),('14598','2013-05-30','16:35:00',3),('14598','2013-05-30','16:40:00',3.49),('14598','2013-05-30','16:45:00',2.02),('14598','2013-05-30','16:50:00',1.38),('14598','2013-05-30','16:55:00',1.09),('14598','2013-05-30','17:20:00',1.12),('14598','2013-05-30','17:25:00',1.64),('14598','2013-05-30','17:30:00',1.25),('14598','2013-05-30','17:35:00',2.19),('14598','2013-05-30','17:40:00',3.83),('14598','2013-05-30','17:45:00',3.36),('14598','2013-05-30','17:50:00',2.3),('14598','2013-05-30','17:55:00',1.97),('14598','2013-05-30','18:00:00',2.41),('14598','2013-05-30','18:05:00',1.29),('14598','2013-05-30','18:10:00',1.87),('14598','2013-05-30','18:15:00',3.08),('14598','2013-05-30','18:20:00',3.16),('14598','2013-05-30','18:25:00',1.45),('14598','2013-05-30','19:20:00',1.54),('14598','2013-05-30','19:25:00',1.39),('14598','2013-05-29','07:50:00',1.06),('14598','2013-05-29','07:55:00',1.15),('14598','2013-05-29','08:00:00',1.25),('14598','2013-05-29','08:05:00',1.34),('14598','2013-05-29','08:10:00',1.44),('14598','2013-05-29','08:15:00',1.55),('14598','2013-05-29','08:20:00',1.67),('14598','2013-05-29','08:25:00',1.78),('14598','2013-05-29','08:30:00',1.88),('14598','2013-05-29','08:35:00',1.98),('14598','2013-05-29','08:40:00',2.09),('14598','2013-05-29','08:45:00',2.23),('14598','2013-05-29','08:50:00',2.34),('14598','2013-05-29','08:55:00',2.45),('14598','2013-05-29','09:00:00',2.53),('14598','2013-05-29','09:05:00',2.63),('14598','2013-05-29','09:10:00',2.72),('14598','2013-05-29','09:15:00',2.85),('14598','2013-05-29','09:20:00',2.95),('14598','2013-05-29','09:25:00',3.04),('14598','2013-05-29','09:30:00',3.12),('14598','2013-05-29','09:35:00',3.22),('14598','2013-05-29','09:40:00',3.32),('14598','2013-05-29','09:45:00',3.4),('14598','2013-05-29','09:50:00',3.48),('14598','2013-05-29','09:55:00',3.56),('14598','2013-05-29','10:00:00',3.64),('14598','2013-05-29','10:05:00',3.72),('14598','2013-05-29','10:10:00',3.8),('14598','2013-05-29','10:15:00',3.87),('14598','2013-05-29','10:20:00',3.94),('14598','2013-05-29','10:25:00',4.02),('14598','2013-05-29','10:30:00',4.09),('14598','2013-05-29','10:35:00',4.2),('14598','2013-05-29','10:40:00',4.07),('14598','2013-05-29','10:45:00',4.31),('14598','2013-05-29','10:50:00',4.38),('14598','2013-05-29','10:55:00',4.43),('14598','2013-05-29','11:00:00',4.5),('14598','2013-05-29','11:05:00',4.58),('14598','2013-05-29','11:10:00',4.65),('14598','2013-05-29','11:15:00',4.72),('14598','2013-05-29','11:20:00',4.49),('14598','2013-05-29','11:25:00',4.31),('14598','2013-05-29','11:30:00',4.28),('14598','2013-05-29','11:35:00',4.33),('14598','2013-05-29','11:40:00',3.54),('14598','2013-05-29','11:45:00',4.35),('14598','2013-05-29','11:50:00',4.06),('14598','2013-05-29','11:55:00',4.71),('14598','2013-05-29','12:00:00',5.22),('14598','2013-05-29','12:05:00',5.18),('14598','2013-05-29','12:10:00',5.19),('14598','2013-05-29','12:15:00',5.23),('14598','2013-05-29','12:20:00',5.23),('14598','2013-05-29','12:25:00',5.21),('14598','2013-05-29','12:30:00',5.28),('14598','2013-05-29','12:35:00',5.33),('14598','2013-05-29','12:40:00',5.32),('14598','2013-05-29','12:45:00',5.37),('14598','2013-05-29','12:50:00',5.41),('14598','2013-05-29','12:55:00',5.44),('14598','2013-05-29','13:00:00',5.53),('14598','2013-05-29','13:05:00',5.22),('14598','2013-05-29','13:10:00',3.49),('14598','2013-05-29','13:15:00',3.93),('14598','2013-05-29','13:20:00',5.34),('14598','2013-05-29','13:25:00',5.87),('14598','2013-05-29','13:30:00',5.57),('14598','2013-05-29','13:35:00',5.47),('14598','2013-05-29','13:40:00',5.46),('14598','2013-05-29','13:45:00',5.17),('14598','2013-05-29','13:50:00',5.34),('14598','2013-05-29','13:55:00',5.47),('14598','2013-05-29','14:00:00',5.39),('14598','2013-05-29','14:05:00',5.43),('14598','2013-05-29','14:10:00',5.4),('14598','2013-05-29','14:15:00',5.42),('14598','2013-05-29','14:20:00',5.43),('14598','2013-05-29','14:25:00',5.34),('14598','2013-05-29','14:30:00',5.34),('14598','2013-05-29','14:35:00',5.32),('14598','2013-05-29','14:40:00',5.17),('14598','2013-05-29','14:45:00',5.28),('14598','2013-05-29','14:50:00',5.39),('14598','2013-05-29','14:55:00',5.56),('14598','2013-05-29','15:00:00',4.95),('14598','2013-05-29','15:05:00',4.03),('14598','2013-05-29','15:10:00',3.74),('14598','2013-05-29','15:15:00',3.81),('14598','2013-05-29','15:20:00',4.26),('14598','2013-05-29','15:25:00',3.91),('14598','2013-05-29','15:30:00',3.69),('14598','2013-05-29','15:35:00',3.48),('14598','2013-05-29','15:40:00',4.09),('14598','2013-05-29','15:45:00',4.48),('14598','2013-05-29','15:50:00',3.62),('14598','2013-05-29','15:55:00',4.2),('14598','2013-05-29','16:00:00',4.13),('14598','2013-05-29','16:05:00',2.95),('14598','2013-05-29','16:10:00',2.77),('14598','2013-05-29','16:15:00',2.55),('14598','2013-05-29','16:20:00',2.27),('14598','2013-05-29','16:25:00',1.76),('14598','2013-05-29','16:30:00',1.15),('14598','2013-05-29','16:55:00',1.07),('14598','2013-05-29','17:00:00',1.5),('14598','2013-05-29','17:05:00',2.14),('14598','2013-05-29','17:10:00',1.93),('14598','2013-05-29','17:15:00',1.91),('14598','2013-05-29','17:20:00',2.06),('14598','2013-05-29','17:25:00',1.77),('14598','2013-05-29','17:30:00',1.97),('14598','2013-05-29','17:35:00',1.76),('14598','2013-05-29','17:40:00',1.54),('14598','2013-05-29','17:45:00',1.29),('14598','2013-05-29','17:50:00',1.27),('14598','2013-05-29','18:30:00',1.95),('14598','2013-05-29','18:35:00',1.48),('14598','2013-05-29','18:40:00',1.68),('14598','2013-05-29','18:45:00',1.18),('14598','2013-05-29','19:00:00',1.6),('14598','2013-05-29','19:05:00',1.53),('14598','2013-05-28','07:40:00',1.02),('14598','2013-05-28','07:50:00',1.07),('14598','2013-05-28','07:55:00',1.08),('14598','2013-05-28','08:05:00',1.03),('14598','2013-05-28','08:10:00',1.27),('14598','2013-05-28','08:15:00',1.31),('14598','2013-05-28','08:20:00',1.56),('14598','2013-05-28','08:25:00',1.48),('14598','2013-05-28','08:30:00',1.4),('14598','2013-05-28','08:35:00',1.65),('14598','2013-05-28','08:40:00',1.83),('14598','2013-05-28','08:45:00',1.89),('14598','2013-05-28','08:50:00',1.6),('14598','2013-05-28','08:55:00',1.54),('14598','2013-05-28','09:00:00',1.77),('14598','2013-05-28','09:05:00',2),('14598','2013-05-28','09:10:00',1.97),('14598','2013-05-28','09:15:00',1.97),('14598','2013-05-28','09:20:00',2.58),('14598','2013-05-28','09:25:00',2.66),('14598','2013-05-28','09:30:00',2.79),('14598','2013-05-28','09:35:00',2.81),('14598','2013-05-28','09:40:00',3.11),('14598','2013-05-28','09:45:00',2.31),('14598','2013-05-28','09:50:00',2.45),('14598','2013-05-28','09:55:00',2.23),('14598','2013-05-28','10:00:00',2.44),('14598','2013-05-28','10:05:00',2.78),('14598','2013-05-28','10:10:00',2.71),('14598','2013-05-28','10:15:00',2.42),('14598','2013-05-28','10:20:00',2.64),('14598','2013-05-28','10:25:00',2.7),('14598','2013-05-28','10:30:00',2.89),('14598','2013-05-28','10:35:00',3.2),('14598','2013-05-28','10:40:00',3.22),('14598','2013-05-28','10:45:00',2.4),('14598','2013-05-28','10:50:00',2.71),('14598','2013-05-28','10:55:00',2.47),('14598','2013-05-28','11:00:00',2.56),('14598','2013-05-28','11:05:00',2.3),('14598','2013-05-28','11:10:00',2.67),('14598','2013-05-28','11:15:00',4.63),('14598','2013-05-28','11:20:00',4.6),('14598','2013-05-28','11:25:00',4.09),('14598','2013-05-28','11:30:00',3.58),('14598','2013-05-28','11:35:00',2.38),('14598','2013-05-28','11:40:00',2.78),('14598','2013-05-28','11:45:00',2.53),('14598','2013-05-28','11:50:00',2.77),('14598','2013-05-28','11:55:00',3.18),('14598','2013-05-28','12:00:00',4.8),('14598','2013-05-28','12:05:00',5.28),('14598','2013-05-28','12:10:00',3.92),('14598','2013-05-28','12:15:00',3.1),('14598','2013-05-28','12:20:00',3.16),('14598','2013-05-28','12:25:00',2.94),('14598','2013-05-28','12:30:00',2.97),('14598','2013-05-28','12:35:00',2.7),('14598','2013-05-28','12:40:00',2.55),('14598','2013-05-28','12:45:00',2.69),('14598','2013-05-28','12:50:00',4.37),('14598','2013-05-28','12:55:00',4.05),('14598','2013-05-28','13:00:00',3.87),('14598','2013-05-28','13:05:00',4.48),('14598','2013-05-28','13:10:00',3.72),('14598','2013-05-28','13:15:00',4.21),('14598','2013-05-28','13:20:00',4.24),('14598','2013-05-28','13:25:00',4.07),('14598','2013-05-28','13:30:00',2.46),('14598','2013-05-28','13:35:00',2.77),('14598','2013-05-28','13:40:00',2.62),('14598','2013-05-28','13:45:00',2.04),('14598','2013-05-28','13:50:00',1.75),('14598','2013-05-28','13:55:00',1.99),('14598','2013-05-28','14:00:00',2.29),('14598','2013-05-28','14:05:00',2.27),('14598','2013-05-28','14:10:00',2.74),('14598','2013-05-28','14:15:00',3.84),('14598','2013-05-28','14:20:00',3.09),('14598','2013-05-28','14:25:00',4.02),('14598','2013-05-28','14:30:00',3.56),('14598','2013-05-28','14:35:00',3.68),('14598','2013-05-28','14:40:00',3.25),('14598','2013-05-28','14:45:00',4.14),('14598','2013-05-28','14:50:00',3.53),('14598','2013-05-28','14:55:00',2.96),('14598','2013-05-28','15:00:00',3.54),('14598','2013-05-28','15:05:00',4.13),('14598','2013-05-28','15:10:00',3.82),('14598','2013-05-28','15:15:00',3.56),('14598','2013-05-28','15:20:00',2.65),('14598','2013-05-28','15:25:00',2.26),('14598','2013-05-28','15:30:00',2.49),('14598','2013-05-28','15:35:00',2.91),('14598','2013-05-28','15:40:00',2.49),('14598','2013-05-28','15:45:00',3.13),('14598','2013-05-28','15:50:00',2.97),('14598','2013-05-28','15:55:00',2.2),('14598','2013-05-28','16:00:00',2.33),('14598','2013-05-28','16:05:00',2.15),('14598','2013-05-28','16:10:00',2.09),('14598','2013-05-28','16:15:00',2.34),('14598','2013-05-28','16:20:00',2.4),('14598','2013-05-28','16:25:00',4.15),('14598','2013-05-28','16:30:00',2.38),('14598','2013-05-28','16:35:00',1.54),('14598','2013-05-28','16:40:00',1.56),('14598','2013-05-28','16:45:00',2.07),('14598','2013-05-28','16:50:00',1.67),('14598','2013-05-28','16:55:00',1.44),('14598','2013-05-28','17:00:00',1.49),('14598','2013-05-28','17:05:00',1.51),('14598','2013-05-28','17:10:00',1.35),('14598','2013-05-28','17:15:00',1.59),('14598','2013-05-28','17:20:00',2.52),('14598','2013-05-28','17:25:00',2.18),('14598','2013-05-28','17:30:00',2.37),('14598','2013-05-28','17:35:00',1.67),('14598','2013-05-28','17:40:00',1.42),('14598','2013-05-28','17:45:00',1.29),('14598','2013-05-28','17:50:00',1.11),('14598','2013-05-28','17:55:00',1.14),('14598','2013-05-28','18:00:00',1.13),('14598','2013-05-28','18:05:00',1.76),('14598','2013-05-28','18:10:00',2.64),('14598','2013-05-28','18:15:00',2.36),('14598','2013-05-28','18:20:00',2.25),('14598','2013-05-28','18:25:00',2.14),('14598','2013-05-28','18:30:00',2.05),('14598','2013-05-28','18:35:00',1.93),('14598','2013-05-28','18:40:00',1.8),('14598','2013-05-28','18:45:00',1.63),('14598','2013-05-28','18:50:00',1.57),('14598','2013-05-28','18:55:00',1.39),('14598','2013-05-27','07:50:00',1.1),('14598','2013-05-27','07:55:00',1.18),('14598','2013-05-27','08:00:00',1.14),('14598','2013-05-27','08:05:00',1.08),('14598','2013-05-27','08:10:00',1.22),('14598','2013-05-27','08:15:00',1.56),('14598','2013-05-27','08:20:00',1.65),('14598','2013-05-27','08:25:00',1.77),('14598','2013-05-27','08:30:00',1.88),('14598','2013-05-27','08:35:00',1.98),('14598','2013-05-27','08:40:00',2.1),('14598','2013-05-27','08:45:00',2.21),('14598','2013-05-27','08:50:00',2.34),('14598','2013-05-27','08:55:00',2.45),('14598','2013-05-27','09:00:00',2.52),('14598','2013-05-27','09:05:00',2.62),('14598','2013-05-27','09:10:00',2.74),('14598','2013-05-27','09:15:00',2.87),('14598','2013-05-27','09:20:00',2.94),('14598','2013-05-27','09:25:00',3.06),('14598','2013-05-27','09:30:00',3.16),('14598','2013-05-27','09:35:00',3.25),('14598','2013-05-27','09:40:00',3.34),('14598','2013-05-27','09:45:00',3.43),('14598','2013-05-27','09:50:00',3.52),('14598','2013-05-27','09:55:00',3.59),('14598','2013-05-27','10:00:00',3.68),('14598','2013-05-27','10:05:00',3.76),('14598','2013-05-27','10:10:00',3.84),('14598','2013-05-27','10:15:00',3.91),('14598','2013-05-27','10:20:00',3.98),('14598','2013-05-27','10:25:00',4.06),('14598','2013-05-27','10:30:00',4.12),('14598','2013-05-27','10:35:00',4.19),('14598','2013-05-27','10:40:00',4.25),('14598','2013-05-27','10:45:00',4.36),('14598','2013-05-27','10:50:00',4.42),('14598','2013-05-27','10:55:00',4.47),('14598','2013-05-27','11:00:00',4.56),('14598','2013-05-27','11:05:00',4.77),('14598','2013-05-27','11:10:00',4.78),('14598','2013-05-27','11:15:00',4.76),('14598','2013-05-27','11:20:00',4.78),('14598','2013-05-27','11:25:00',4.85),('14598','2013-05-27','11:30:00',4.88),('14598','2013-05-27','11:35:00',4.94),('14598','2013-05-27','11:40:00',5.04),('14598','2013-05-27','11:45:00',4.9),('14598','2013-05-27','11:50:00',5.07),('14598','2013-05-27','11:55:00',5.01),('14598','2013-05-27','12:00:00',5.1),('14598','2013-05-27','12:05:00',4.86),('14598','2013-05-27','12:10:00',5.27),('14598','2013-05-27','12:15:00',5.31),('14598','2013-05-27','12:20:00',5.31),('14598','2013-05-27','12:25:00',5.3),('14598','2013-05-27','12:30:00',5.23),('14598','2013-05-27','12:35:00',5.33),('14598','2013-05-27','12:40:00',5.41),('14598','2013-05-27','12:45:00',5.41),('14598','2013-05-27','12:50:00',5.31),('14598','2013-05-27','12:55:00',5.42),('14598','2013-05-27','13:00:00',5.5),('14598','2013-05-27','13:05:00',5.2),('14598','2013-05-27','13:10:00',5.1),('14598','2013-05-27','13:15:00',5.43),('14598','2013-05-27','13:20:00',5.26),('14598','2013-05-27','13:25:00',5.09),('14598','2013-05-27','13:30:00',4.82),('14598','2013-05-27','13:35:00',5.58),('14598','2013-05-27','13:40:00',5.52),('14598','2013-05-27','13:45:00',5.48),('14598','2013-05-27','13:50:00',5.38),('14598','2013-05-27','13:55:00',5.28),('14598','2013-05-27','14:00:00',5.38),('14598','2013-05-27','14:05:00',5.34),('14598','2013-05-27','14:10:00',5.37),('14598','2013-05-27','14:15:00',5.42),('14598','2013-05-27','14:20:00',5.45),('14598','2013-05-27','14:25:00',5.37),('14598','2013-05-27','14:30:00',5.44),('14598','2013-05-27','14:35:00',5.47),('14598','2013-05-27','14:40:00',5.49),('14598','2013-05-27','14:45:00',5.43),('14598','2013-05-27','14:50:00',4.24),('14598','2013-05-27','14:55:00',3.14),('14598','2013-05-27','15:00:00',4.65),('14598','2013-05-27','15:05:00',4.37),('14598','2013-05-27','15:10:00',4.69),('14598','2013-05-27','15:15:00',5.52),('14598','2013-05-27','15:20:00',4.1),('14598','2013-05-27','15:25:00',5.41),('14598','2013-05-27','15:30:00',4.49),('14598','2013-05-27','15:35:00',4.91),('14598','2013-05-27','15:40:00',4.78),('14598','2013-05-27','15:45:00',4.07),('14598','2013-05-27','15:50:00',3.02),('14598','2013-05-27','15:55:00',3.2),('14598','2013-05-27','16:00:00',3.56),('14598','2013-05-27','16:05:00',3.12),('14598','2013-05-27','16:10:00',4.37),('14598','2013-05-27','16:15:00',5.09),('14598','2013-05-27','16:20:00',4.67),('14598','2013-05-27','16:25:00',3.83),('14598','2013-05-27','16:30:00',2.42),('14598','2013-05-27','16:35:00',1.76),('14598','2013-05-27','16:40:00',1.74),('14598','2013-05-27','16:45:00',1.78),('14598','2013-05-27','16:50:00',1.85),('14598','2013-05-27','16:55:00',1.94),('14598','2013-05-27','17:00:00',2.17),('14598','2013-05-27','17:05:00',1.91),('14598','2013-05-27','17:10:00',1.66),('14598','2013-05-27','17:15:00',1.51),('14598','2013-05-27','17:20:00',1.44),('14598','2013-05-27','17:25:00',1.3),('14598','2013-05-27','17:30:00',1.23),('14598','2013-05-27','17:35:00',1.19),('14598','2013-05-27','17:40:00',1.16),('14598','2013-05-27','17:45:00',1.2),('14598','2013-05-27','17:50:00',1.13),('14598','2013-05-27','17:55:00',1.07),('14598','2013-05-27','18:00:00',1.12),('14598','2013-05-27','18:05:00',1.35),('14598','2013-05-27','18:10:00',1.85),('14598','2013-05-27','18:15:00',2.94),('14598','2013-05-27','18:20:00',2.66),('14598','2013-05-27','18:25:00',1.37),('14598','2013-05-27','18:30:00',1.31),('14598','2013-05-27','18:35:00',1.89),('14598','2013-05-27','18:40:00',1.46),('14598','2013-05-27','18:45:00',1.75),('14598','2013-05-27','18:50:00',1.89),('14598','2013-05-27','18:55:00',2.07),('14598','2013-05-27','19:00:00',1.88),('14598','2013-05-27','19:05:00',1.59),('14598','2013-05-27','19:10:00',1.3),('14598','2013-05-27','19:15:00',1.02),('14598','2013-05-27','19:20:00',1.32),('14598','2013-05-27','19:25:00',1.18),('14598','2013-05-26','07:40:00',1.01),('14598','2013-05-26','07:45:00',1.25),('14598','2013-05-26','07:55:00',1.11),('14598','2013-05-26','08:10:00',1.05),('14598','2013-05-26','08:15:00',1.6),('14598','2013-05-26','08:20:00',1.38),('14598','2013-05-26','08:25:00',1.67),('14598','2013-05-26','08:30:00',2.01),('14598','2013-05-26','08:35:00',2.8),('14598','2013-05-26','08:40:00',2.03),('14598','2013-05-26','08:50:00',1.76),('14598','2013-05-26','08:55:00',2.99),('14598','2013-05-26','09:00:00',2.18),('14598','2013-05-26','09:05:00',3.17),('14598','2013-05-26','09:10:00',1.96),('14598','2013-05-26','09:15:00',1.44),('14598','2013-05-26','09:20:00',2.34),('14598','2013-05-26','09:35:00',2.63),('14598','2013-05-26','09:40:00',3.45),('14598','2013-05-26','09:45:00',3.07),('14598','2013-05-26','09:50:00',3.63),('14598','2013-05-26','09:55:00',3.71),('14598','2013-05-26','10:00:00',3.79),('14598','2013-05-26','10:05:00',3.89),('14598','2013-05-26','10:10:00',3.97),('14598','2013-05-26','10:15:00',4.04),('14598','2013-05-26','10:20:00',4.08),('14598','2013-05-26','10:25:00',4.17),('14598','2013-05-26','10:30:00',4.28),('14598','2013-05-26','10:35:00',4.35),('14598','2013-05-26','10:40:00',4.43),('14598','2013-05-26','10:45:00',4.49),('14598','2013-05-26','10:50:00',4.56),('14598','2013-05-26','10:55:00',4.62),('14598','2013-05-26','11:00:00',4.69),('14598','2013-05-26','11:05:00',4.71),('14598','2013-05-26','11:10:00',4.79),('14598','2013-05-26','11:15:00',4.85),('14598','2013-05-26','11:20:00',4.9),('14598','2013-05-26','11:25:00',4.96),('14598','2013-05-26','11:30:00',5),('14598','2013-05-26','11:35:00',5.05),('14598','2013-05-26','11:40:00',5.11),('14598','2013-05-26','11:45:00',5.16),('14598','2013-05-26','11:50:00',5.2),('14598','2013-05-26','11:55:00',5.21),('14598','2013-05-26','12:00:00',5.23),('14598','2013-05-26','12:05:00',5.28),('14598','2013-05-26','12:10:00',5.3),('14598','2013-05-26','12:15:00',5.39),('14598','2013-05-26','12:20:00',5.43),('14598','2013-05-26','12:25:00',5.47),('14598','2013-05-26','12:30:00',5.49),('14598','2013-05-26','12:35:00',5.5),('14598','2013-05-26','12:40:00',5.54),('14598','2013-05-26','12:45:00',5.44),('14598','2013-05-26','12:50:00',5.57),('14598','2013-05-26','12:55:00',5.59),('14598','2013-05-26','13:00:00',5.59),('14598','2013-05-26','13:05:00',5.57),('14598','2013-05-26','13:10:00',5.61),('14598','2013-05-26','13:15:00',5.59),('14598','2013-05-26','13:20:00',5.6),('14598','2013-05-26','13:25:00',5.65),('14598','2013-05-26','13:30:00',5.62),('14598','2013-05-26','13:35:00',5.64),('14598','2013-05-26','13:40:00',5.66),('14598','2013-05-26','13:45:00',5.67),('14598','2013-05-26','13:50:00',5.66),('14598','2013-05-26','13:55:00',5.68),('14598','2013-05-26','14:00:00',5.59),('14598','2013-05-26','14:05:00',5.61),('14598','2013-05-26','14:10:00',5.61),('14598','2013-05-26','14:15:00',5.56),('14598','2013-05-26','14:20:00',5.57),('14598','2013-05-26','14:25:00',5.55),('14598','2013-05-26','14:30:00',5.54),('14598','2013-05-26','14:35:00',5.52),('14598','2013-05-26','14:40:00',5.48),('14598','2013-05-26','14:45:00',5.46),('14598','2013-05-26','14:50:00',5.44),('14598','2013-05-26','14:55:00',5.39),('14598','2013-05-26','15:00:00',5.35),('14598','2013-05-26','15:05:00',5.32),('14598','2013-05-26','15:10:00',5.29),('14598','2013-05-26','15:15:00',5.26),('14598','2013-05-26','15:20:00',5.2),('14598','2013-05-26','15:25:00',5.18),('14598','2013-05-26','15:30:00',5.14),('14598','2013-05-26','15:35:00',5.09),('14598','2013-05-26','15:40:00',5.01),('14598','2013-05-26','15:45:00',4.84),('14598','2013-05-26','15:50:00',4.89),('14598','2013-05-26','15:55:00',4.85),('14598','2013-05-26','16:00:00',4.8),('14598','2013-05-26','16:05:00',4.72),('14598','2013-05-26','16:10:00',4.66),('14598','2013-05-26','16:15:00',4.6),('14598','2013-05-26','16:20:00',4.52),('14598','2013-05-26','16:25:00',4.46),('14598','2013-05-26','16:30:00',4.39),('14598','2013-05-26','16:35:00',4.33),('14598','2013-05-26','16:40:00',4.26),('14598','2013-05-26','16:45:00',4.2),('14598','2013-05-26','16:50:00',4.12),('14598','2013-05-26','16:55:00',4.04),('14598','2013-05-26','17:00:00',3.96),('14598','2013-05-26','17:05:00',3.9),('14598','2013-05-26','17:10:00',3.82),('14598','2013-05-26','17:15:00',3.74),('14598','2013-05-26','17:20:00',3.65),('14598','2013-05-26','17:25:00',3.55),('14598','2013-05-26','17:30:00',3.46),('14598','2013-05-26','17:35:00',3.38),('14598','2013-05-26','17:40:00',3.28),('14598','2013-05-26','17:45:00',3.19),('14598','2013-05-26','17:50:00',3.08),('14598','2013-05-26','17:55:00',2.96),('14598','2013-05-26','18:00:00',2.87),('14598','2013-05-26','18:05:00',2.77),('14598','2013-05-26','18:10:00',2.66),('14598','2013-05-26','18:15:00',2.56),('14598','2013-05-26','18:20:00',2.45),('14598','2013-05-26','18:25:00',2.34),('14598','2013-05-26','18:30:00',2.22),('14598','2013-05-26','18:35:00',2.11),('14598','2013-05-26','18:40:00',1.99),('14598','2013-05-26','18:45:00',1.87),('14598','2013-05-26','18:50:00',1.77),('14598','2013-05-26','18:55:00',1.65),('14598','2013-05-26','19:00:00',1.54),('14598','2013-05-26','19:05:00',1.43),('14598','2013-05-26','19:10:00',1.31),('14598','2013-05-26','19:15:00',1.2),('14598','2013-05-26','19:20:00',1.09),('14598','2013-05-25','07:50:00',1.14),('14598','2013-05-25','07:55:00',1.23),('14598','2013-05-25','08:00:00',1.34),('14598','2013-05-25','08:05:00',1.06),('14598','2013-05-25','08:10:00',1.81),('14598','2013-05-25','08:15:00',1.31),('14598','2013-05-25','08:20:00',1.03),('14598','2013-05-25','08:35:00',1.72),('14598','2013-05-25','08:40:00',2.69),('14598','2013-05-25','08:45:00',1.22),('14598','2013-05-25','08:50:00',1.05),('14598','2013-05-25','08:55:00',1.44),('14598','2013-05-25','09:00:00',1.72),('14598','2013-05-25','09:05:00',3.1),('14598','2013-05-25','09:10:00',1.8),('14598','2013-05-25','09:15:00',3.46),('14598','2013-05-25','09:20:00',1.76),('14598','2013-05-25','09:25:00',2.14),('14598','2013-05-25','09:30:00',2.97),('14598','2013-05-25','09:35:00',1.3),('14598','2013-05-25','09:40:00',1.88),('14598','2013-05-25','09:45:00',1.76),('14598','2013-05-25','09:50:00',1.94),('14598','2013-05-25','09:55:00',1.9),('14598','2013-05-25','10:00:00',2.03),('14598','2013-05-25','10:05:00',1.8),('14598','2013-05-25','10:10:00',1.17),('14598','2013-05-25','10:15:00',1.3),('14598','2013-05-25','10:20:00',1.08),('14598','2013-05-25','10:25:00',1.01),('14598','2013-05-25','10:30:00',1.34),('14598','2013-05-25','10:35:00',1.75),('14598','2013-05-25','10:40:00',1.27),('14598','2013-05-25','11:00:00',1.21),('14598','2013-05-25','11:05:00',1.45),('14598','2013-05-25','11:10:00',1.74),('14598','2013-05-25','11:15:00',1.59),('14598','2013-05-25','11:20:00',1.93),('14598','2013-05-25','11:25:00',1.65),('14598','2013-05-25','11:30:00',2.27),('14598','2013-05-25','11:35:00',2.68),('14598','2013-05-25','11:40:00',2.74),('14598','2013-05-25','11:45:00',4.21),('14598','2013-05-25','11:50:00',2.84),('14598','2013-05-25','11:55:00',1.59),('14598','2013-05-25','12:00:00',1.05),('14598','2013-05-25','12:10:00',1.33),('14598','2013-05-25','12:15:00',2.28),('14598','2013-05-25','12:20:00',3.52),('14598','2013-05-25','12:25:00',5.83),('14598','2013-05-25','12:30:00',3.9),('14598','2013-05-25','12:35:00',3.95),('14598','2013-05-25','12:40:00',2.51),('14598','2013-05-25','12:45:00',2.84),('14598','2013-05-25','12:50:00',2.52),('14598','2013-05-25','12:55:00',2.39),('14598','2013-05-25','13:00:00',2.12),('14598','2013-05-25','13:05:00',2.37),('14598','2013-05-25','13:10:00',1.81),('14598','2013-05-25','13:15:00',3.09),('14598','2013-05-25','13:20:00',2.76),('14598','2013-05-25','13:25:00',2.81),('14598','2013-05-25','13:30:00',3.25),('14598','2013-05-25','13:35:00',4.34),('14598','2013-05-25','13:40:00',2.84),('14598','2013-05-25','13:45:00',4.2),('14598','2013-05-25','13:50:00',5.03),('14598','2013-05-25','13:55:00',5.76),('14598','2013-05-25','14:00:00',5.6),('14598','2013-05-25','14:05:00',5.6),('14598','2013-05-25','14:10:00',5.57),('14598','2013-05-25','14:15:00',5.73),('14598','2013-05-25','14:20:00',4.8),('14598','2013-05-25','14:25:00',4.72),('14598','2013-05-25','14:30:00',5.69),('14598','2013-05-25','14:35:00',5.15),('14598','2013-05-25','14:40:00',2.95),('14598','2013-05-25','14:45:00',5.64),('14598','2013-05-25','14:50:00',5.05),('14598','2013-05-25','14:55:00',4.59),('14598','2013-05-25','15:00:00',4.58),('14598','2013-05-25','15:05:00',5.61),('14598','2013-05-25','15:10:00',5.3),('14598','2013-05-25','15:15:00',4.18),('14598','2013-05-25','15:20:00',4.16),('14598','2013-05-25','15:25:00',2.58),('14598','2013-05-25','15:30:00',5.47),('14598','2013-05-25','15:35:00',4.52),('14598','2013-05-25','15:40:00',5.02),('14598','2013-05-25','15:45:00',3.99),('14598','2013-05-25','15:50:00',4.12),('14598','2013-05-25','15:55:00',2.83),('14598','2013-05-25','16:00:00',5.58),('14598','2013-05-25','16:05:00',3.96),('14598','2013-05-25','16:10:00',2.41),('14598','2013-05-25','16:15:00',4.89),('14598','2013-05-25','16:20:00',3.75),('14598','2013-05-25','16:25:00',3.8),('14598','2013-05-25','16:30:00',4.84),('14598','2013-05-25','16:35:00',2.23),('14598','2013-05-25','16:40:00',3.64),('14598','2013-05-25','16:45:00',2.61),('14598','2013-05-25','16:50:00',4.36),('14598','2013-05-25','16:55:00',4.11),('14598','2013-05-25','17:00:00',3.87),('14598','2013-05-25','17:05:00',4.03),('14598','2013-05-25','17:10:00',3.34),('14598','2013-05-25','17:15:00',3.11),('14598','2013-05-25','17:20:00',1.48),('14598','2013-05-25','17:25:00',3.81),('14598','2013-05-25','17:30:00',3.7),('14598','2013-05-25','17:35:00',3.67),('14598','2013-05-25','17:40:00',3.64),('14598','2013-05-25','17:45:00',2.91),('14598','2013-05-24','08:00:00',1.19),('14598','2013-05-24','08:05:00',1.31),('14598','2013-05-24','08:10:00',1.41),('14598','2013-05-24','08:15:00',1.54),('14598','2013-05-24','08:20:00',1.69),('14598','2013-05-24','08:25:00',1.95),('14598','2013-05-24','08:30:00',1.62),('14598','2013-05-24','08:35:00',2.22),('14598','2013-05-24','08:40:00',1.44),('14598','2013-05-24','08:50:00',1.89),('14598','2013-05-24','08:55:00',2.72),('14598','2013-05-24','09:00:00',3.02),('14598','2013-05-24','09:05:00',1.6),('14598','2013-05-24','09:10:00',3.08),('14598','2013-05-24','09:15:00',2.92),('14598','2013-05-24','09:20:00',2),('14598','2013-05-24','09:35:00',2.6),('14598','2013-05-24','09:40:00',3.32),('14598','2013-05-24','09:45:00',3.56),('14598','2013-05-24','09:50:00',1.9),('14598','2013-05-24','10:00:00',1.67),('14598','2013-05-24','10:05:00',2.08),('14598','2013-05-24','10:10:00',1.88),('14598','2013-05-24','10:15:00',1.59),('14598','2013-05-24','10:20:00',4.14),('14598','2013-05-24','10:25:00',3.26),('14598','2013-05-24','10:30:00',4.64),('14598','2013-05-24','10:35:00',3.4),('14598','2013-05-24','10:40:00',4.44),('14598','2013-05-24','10:45:00',3.79),('14598','2013-05-24','10:50:00',4.26),('14598','2013-05-24','10:55:00',4.53),('14598','2013-05-24','11:00:00',3.64),('14598','2013-05-24','11:05:00',3.96),('14598','2013-05-24','11:10:00',4.78),('14598','2013-05-24','11:15:00',4.91),('14598','2013-05-24','11:20:00',3.86),('14598','2013-05-24','11:25:00',2.86),('14598','2013-05-24','11:30:00',3.86),('14598','2013-05-24','11:35:00',5.36),('14598','2013-05-24','11:40:00',5.89),('14598','2013-05-24','11:45:00',5.76),('14598','2013-05-24','11:50:00',2.9),('14598','2013-05-24','11:55:00',3.18),('14598','2013-05-24','12:00:00',4.58),('14598','2013-05-24','12:05:00',3.49),('14598','2013-05-24','12:10:00',3.78),('14598','2013-05-24','12:15:00',3.2),('14598','2013-05-24','12:20:00',2.12),('14598','2013-05-24','12:25:00',2.15),('14598','2013-05-24','12:30:00',3.84),('14598','2013-05-24','12:35:00',2.35),('14598','2013-05-24','12:40:00',2.28),('14598','2013-05-24','12:45:00',3.6),('14598','2013-05-24','12:50:00',4.65),('14598','2013-05-24','12:55:00',5.8),('14598','2013-05-24','13:00:00',5.72),('14598','2013-05-24','13:05:00',5.94),('14598','2013-05-24','13:10:00',6.02),('14598','2013-05-24','13:15:00',5.8),('14598','2013-05-24','13:20:00',2.67),('14598','2013-05-24','13:25:00',5.01),('14598','2013-05-24','13:30:00',3),('14598','2013-05-24','13:35:00',6.01),('14598','2013-05-24','13:40:00',5.9),('14598','2013-05-24','13:45:00',5.82),('14598','2013-05-24','13:50:00',4.92),('14598','2013-05-24','13:55:00',3.08),('14598','2013-05-24','14:00:00',5.67),('14598','2013-05-24','14:05:00',6.03),('14598','2013-05-24','14:10:00',6.01),('14598','2013-05-24','14:15:00',4.49),('14598','2013-05-24','14:20:00',2.64),('14598','2013-05-24','14:25:00',5.22),('14598','2013-05-24','14:30:00',3.73),('14598','2013-05-24','14:35:00',3.42),('14598','2013-05-24','14:40:00',1.49),('14598','2013-05-24','14:45:00',4.36),('14598','2013-05-24','14:50:00',4.07),('14598','2013-05-24','14:55:00',5.69),('14598','2013-05-24','15:00:00',5.54),('14598','2013-05-24','15:05:00',5.51),('14598','2013-05-24','15:10:00',5.59),('14598','2013-05-24','15:15:00',4.72),('14598','2013-05-24','15:20:00',3.34),('14598','2013-05-24','15:25:00',3.09),('14598','2013-05-24','15:30:00',4.06),('14598','2013-05-24','15:35:00',4.2),('14598','2013-05-24','15:40:00',2.8),('14598','2013-05-24','15:45:00',2.56),('14598','2013-05-24','15:50:00',2.26),('14598','2013-05-24','15:55:00',2.24),('14598','2013-05-24','16:00:00',2.13),('14598','2013-05-24','16:05:00',1.91),('14598','2013-05-24','16:10:00',1.79),('14598','2013-05-24','16:15:00',1.51),('14598','2013-05-24','16:20:00',1.45),('14598','2013-05-24','16:25:00',1.37),('14598','2013-05-24','16:30:00',1.54),('14598','2013-05-24','16:35:00',2.06),('14598','2013-05-24','16:40:00',1.61),('14598','2013-05-24','16:45:00',1.15),('14598','2013-05-24','16:50:00',1.15),('14598','2013-05-24','16:55:00',1.26),('14598','2013-05-24','17:00:00',1.43),('14598','2013-05-24','17:05:00',1.42),('14598','2013-05-24','17:10:00',1.91),('14598','2013-05-24','17:15:00',2.45),('14598','2013-05-24','17:20:00',2.37),('14598','2013-05-24','17:25:00',1.7),('14598','2013-05-24','17:30:00',1.27),('14598','2013-05-24','17:35:00',1.05),('14598','2013-05-23','07:25:00',1.15),('14598','2013-05-23','07:30:00',1.04),('14598','2013-05-23','07:50:00',1.14),('14598','2013-05-23','07:55:00',1.16),('14598','2013-05-23','08:05:00',1.15),('14598','2013-05-23','08:10:00',1.34),('14598','2013-05-23','08:15:00',2.15),('14598','2013-05-23','08:50:00',2.49),('14598','2013-05-23','08:55:00',2.74),('14598','2013-05-23','09:00:00',1.45),('14598','2013-05-23','09:05:00',2.35),('14598','2013-05-23','09:15:00',2.64),('14598','2013-05-23','09:20:00',1.45),('14598','2013-05-23','09:25:00',1.24),('14598','2013-05-23','09:30:00',2.26),('14598','2013-05-23','09:35:00',2.35),('14598','2013-05-23','09:40:00',2.77),('14598','2013-05-23','09:45:00',3.44),('14598','2013-05-23','09:50:00',3.08),('14598','2013-05-23','09:55:00',3.65),('14598','2013-05-23','10:00:00',3.8),('14598','2013-05-23','10:05:00',3.86),('14598','2013-05-23','10:10:00',3.63),('14598','2013-05-23','10:15:00',3.85),('14598','2013-05-23','10:20:00',4.02),('14598','2013-05-23','10:25:00',4.17),('14598','2013-05-23','10:30:00',4.33),('14598','2013-05-23','10:35:00',4.46),('14598','2013-05-23','10:40:00',2.39),('14598','2013-05-23','10:45:00',1.31),('14598','2013-05-23','10:50:00',2.97),('14598','2013-05-23','10:55:00',3.1),('14598','2013-05-23','11:00:00',2.66),('14598','2013-05-23','11:05:00',4.52),('14598','2013-05-23','11:10:00',2.98),('14598','2013-05-23','11:15:00',1.79),('14598','2013-05-23','11:20:00',2.54),('14598','2013-05-23','11:25:00',2),('14598','2013-05-23','11:35:00',2.26),('14598','2013-05-23','11:40:00',5.41),('14598','2013-05-23','11:45:00',4.53),('14598','2013-05-23','11:50:00',4.3),('14598','2013-05-23','11:55:00',3.27),('14598','2013-05-23','12:00:00',3.87),('14598','2013-05-23','12:05:00',2.09),('14598','2013-05-23','12:10:00',1.34),('14598','2013-05-23','12:15:00',1.66),('14598','2013-05-23','12:20:00',4.5),('14598','2013-05-23','12:25:00',5.7),('14598','2013-05-23','12:30:00',3.01),('14598','2013-05-23','12:35:00',5.25),('14598','2013-05-23','12:40:00',5.24),('14598','2013-05-23','12:45:00',5.41),('14598','2013-05-23','12:50:00',5.39),('14598','2013-05-23','12:55:00',5.47),('14598','2013-05-23','13:00:00',5.45),('14598','2013-05-23','13:05:00',5.49),('14598','2013-05-23','13:10:00',5.48),('14598','2013-05-23','13:15:00',5.51),('14598','2013-05-23','13:20:00',5.65),('14598','2013-05-23','13:25:00',4.19),('14598','2013-05-23','13:30:00',5.83),('14598','2013-05-23','13:35:00',5.72),('14598','2013-05-23','13:40:00',5.62),('14598','2013-05-23','13:45:00',5.65),('14598','2013-05-23','13:50:00',5.26),('14598','2013-05-23','13:55:00',3.82),('14598','2013-05-23','14:00:00',3.55),('14598','2013-05-23','14:05:00',5.8),('14598','2013-05-23','14:10:00',4.2),('14598','2013-05-23','14:15:00',3.77),('14598','2013-05-23','14:20:00',3.81),('14598','2013-05-23','14:25:00',4.14),('14598','2013-05-23','14:30:00',5.96),('14598','2013-05-23','14:35:00',5.53),('14598','2013-05-23','14:40:00',5.66),('14598','2013-05-23','14:45:00',4.47),('14598','2013-05-23','14:50:00',5.22),('14598','2013-05-23','14:55:00',4.1),('14598','2013-05-23','15:00:00',4.76),('14598','2013-05-23','15:05:00',1.22),('14598','2013-05-23','15:10:00',1.24),('14598','2013-05-23','15:15:00',2.3),('14598','2013-05-23','15:20:00',3.05),('14598','2013-05-23','15:25:00',5.42),('14598','2013-05-23','15:30:00',3.65),('14598','2013-05-23','15:35:00',3.38),('14598','2013-05-23','15:40:00',4.95),('14598','2013-05-23','15:45:00',5.36),('14598','2013-05-23','15:50:00',5.37),('14598','2013-05-23','15:55:00',5),('14598','2013-05-23','16:00:00',3.49),('14598','2013-05-23','16:05:00',4.8),('14598','2013-05-23','16:10:00',3.5),('14598','2013-05-23','16:15:00',2.64),('14598','2013-05-23','16:20:00',3.97),('14598','2013-05-23','16:25:00',4.1),('14598','2013-05-23','16:30:00',2.7),('14598','2013-05-23','16:35:00',3.4),('14598','2013-05-23','16:40:00',3.62),('14598','2013-05-23','16:45:00',1.83),('14598','2013-05-23','16:50:00',1.85),('14598','2013-05-23','16:55:00',1.89),('14598','2013-05-23','17:00:00',2.45),('14598','2013-05-23','17:05:00',3.64),('14598','2013-05-23','17:10:00',3.06),('14598','2013-05-23','17:15:00',2.78),('14598','2013-05-23','17:20:00',2.55),('14598','2013-05-23','17:25:00',1.47),('14598','2013-05-23','17:30:00',2.86),('14598','2013-05-23','17:35:00',4.23),('14598','2013-05-23','17:40:00',3.93),('14598','2013-05-23','17:45:00',2.66),('14598','2013-05-23','18:30:00',1.22),('14598','2013-05-23','18:35:00',1.6),('14598','2013-05-22','07:50:00',1.03),('14598','2013-05-22','07:55:00',1.24),('14598','2013-05-22','08:00:00',1.41),('14598','2013-05-22','08:05:00',1.63),('14598','2013-05-22','08:10:00',1.63),('14598','2013-05-22','08:15:00',1.77),('14598','2013-05-22','08:20:00',1.09),('14598','2013-05-22','09:00:00',1.11),('14598','2013-05-22','09:15:00',1.94),('14598','2013-05-22','09:20:00',3.02),('14598','2013-05-22','09:25:00',1.27),('14598','2013-05-22','09:30:00',2.26),('14598','2013-05-22','09:35:00',3.04),('14598','2013-05-22','09:40:00',3.07),('14598','2013-05-22','09:45:00',3.15),('14598','2013-05-22','09:50:00',3.24),('14598','2013-05-22','09:55:00',3.36),('14598','2013-05-22','10:00:00',3.4),('14598','2013-05-22','10:05:00',3.74),('14598','2013-05-22','10:10:00',2.91),('14598','2013-05-22','10:15:00',3.88),('14598','2013-05-22','10:20:00',3.85),('14598','2013-05-22','10:25:00',4.15),('14598','2013-05-22','10:30:00',3.55),('14598','2013-05-22','10:35:00',2.75),('14598','2013-05-22','10:40:00',2.08),('14598','2013-05-22','10:45:00',2.79),('14598','2013-05-22','10:50:00',3.01),('14598','2013-05-22','10:55:00',2.89),('14598','2013-05-22','11:00:00',3.55),('14598','2013-05-22','11:05:00',4.57),('14598','2013-05-22','11:10:00',4.46),('14598','2013-05-22','11:15:00',4.45),('14598','2013-05-22','11:20:00',4.51),('14598','2013-05-22','11:25:00',4.55),('14598','2013-05-22','11:30:00',4.45),('14598','2013-05-22','11:35:00',3.85),('14598','2013-05-22','11:40:00',4.04),('14598','2013-05-22','11:45:00',4.22),('14598','2013-05-22','11:50:00',3.4),('14598','2013-05-22','11:55:00',3.06),('14598','2013-05-22','12:00:00',2.61),('14598','2013-05-22','12:05:00',2.56),('14598','2013-05-22','12:10:00',2.12),('14598','2013-05-22','12:15:00',2.07),('14598','2013-05-22','12:20:00',3.94),('14598','2013-05-22','12:25:00',5.52),('14598','2013-05-22','12:30:00',4.27),('14598','2013-05-22','12:35:00',2.32),('14598','2013-05-22','12:40:00',1.46),('14598','2013-05-22','13:15:00',1.7),('14598','2013-05-22','13:20:00',3.56),('14598','2013-05-22','13:25:00',2.87),('14598','2013-05-22','13:30:00',4.18),('14598','2013-05-22','13:35:00',2.77),('14598','2013-05-22','13:40:00',3.84),('14598','2013-05-22','13:45:00',4.12),('14598','2013-05-22','13:50:00',4.07),('14598','2013-05-22','13:55:00',5.42),('14598','2013-05-22','14:00:00',4.58),('14598','2013-05-22','14:05:00',5.05),('14598','2013-05-22','14:10:00',5.03),('14598','2013-05-22','14:15:00',5),('14598','2013-05-22','14:20:00',5.01),('14598','2013-05-22','14:25:00',4.98),('14598','2013-05-22','14:30:00',4.93),('14598','2013-05-22','14:35:00',4.93),('14598','2013-05-22','14:40:00',4.87),('14598','2013-05-22','14:45:00',4.85),('14598','2013-05-22','14:50:00',4.8),('14598','2013-05-22','14:55:00',4.78),('14598','2013-05-22','15:00:00',4.79),('14598','2013-05-22','15:05:00',4.72),('14598','2013-05-22','15:10:00',4.67),('14598','2013-05-22','15:15:00',4.64),('14598','2013-05-22','15:20:00',4.62),('14598','2013-05-22','15:25:00',4.58),('14598','2013-05-22','15:30:00',4.53),('14598','2013-05-22','15:35:00',4.42),('14598','2013-05-22','15:40:00',4.45),('14598','2013-05-22','15:45:00',4.39),('14598','2013-05-22','15:50:00',4.32),('14598','2013-05-22','15:55:00',4.25),('14598','2013-05-22','16:00:00',4.19),('14598','2013-05-22','16:05:00',4.11),('14598','2013-05-22','16:10:00',4.03),('14598','2013-05-22','16:15:00',3.98),('14598','2013-05-22','16:20:00',3.9),('14598','2013-05-22','16:25:00',3.82),('14598','2013-05-22','16:30:00',3.74),('14598','2013-05-22','16:35:00',3.57),('14598','2013-05-22','16:40:00',3.3),('14598','2013-05-22','16:45:00',3.18),('14598','2013-05-22','16:50:00',2.9),('14598','2013-05-22','16:55:00',2.89),('14598','2013-05-22','17:00:00',2.97),('14598','2013-05-22','17:05:00',3.34),('14598','2013-05-22','17:10:00',3.19),('14598','2013-05-22','17:15:00',3.13),('14598','2013-05-22','17:20:00',3.04),('14598','2013-05-22','17:25:00',2.79),('14598','2013-05-22','17:30:00',3.07),('14598','2013-05-22','17:35:00',2.84),('14598','2013-05-22','17:40:00',2.71),('14598','2013-05-22','17:45:00',2.57),('14598','2013-05-22','17:50:00',2.52),('14598','2013-05-22','17:55:00',2.41),('14598','2013-05-22','18:00:00',2.43),('14598','2013-05-22','18:05:00',2.28),('14598','2013-05-22','18:10:00',2.31),('14598','2013-05-22','18:15:00',2.14),('14598','2013-05-22','18:20:00',2.03),('14598','2013-05-22','18:25:00',1.22),('14598','2013-05-22','18:30:00',1.04),('14598','2013-05-22','18:40:00',1.02),('14598','2013-05-22','18:45:00',1.18),('14598','2013-05-22','18:50:00',1.25),('14598','2013-05-22','18:55:00',1.33),('14598','2013-05-22','19:00:00',1.15),('14598','2014-04-01','08:40:00',1.04),('14598','2014-04-01','08:45:00',1),('14598','2014-04-01','08:50:00',1.18),('14598','2014-04-01','08:55:00',1.23),('14598','2014-04-01','09:00:00',1.38),('14598','2014-04-01','09:05:00',1.52),('14598','2014-04-01','09:10:00',1.62),('14598','2014-04-01','09:15:00',1.73),('14598','2014-04-01','09:20:00',1.87),('14598','2014-04-01','09:25:00',2),('14598','2014-04-01','09:30:00',2.11),('14598','2014-04-01','09:35:00',2.2),('14598','2014-04-01','09:40:00',2.31),('14598','2014-04-01','09:45:00',2.39),('14598','2014-04-01','09:50:00',2.49),('14598','2014-04-01','09:55:00',2.6),('14598','2014-04-01','10:00:00',2.69),('14598','2014-04-01','10:05:00',2.8),('14598','2014-04-01','10:10:00',2.88),('14598','2014-04-01','10:15:00',2.99),('14598','2014-04-01','10:20:00',3.09),('14598','2014-04-01','10:25:00',3.18),('14598','2014-04-01','10:30:00',3.26),('14598','2014-04-01','10:35:00',3.36),('14598','2014-04-01','10:40:00',3.43),('14598','2014-04-01','10:45:00',3.5),('14598','2014-04-01','10:50:00',3.59),('14598','2014-04-01','10:55:00',3.64),('14598','2014-04-01','11:00:00',3.72),('14598','2014-04-01','11:05:00',3.8),('14598','2014-04-01','11:10:00',3.88),('14598','2014-04-01','11:15:00',3.93),('14598','2014-04-01','11:20:00',3.97),('14598','2014-04-01','11:25:00',4.06),('14598','2014-04-01','11:30:00',4.15),('14598','2014-04-01','11:35:00',4.24),('14598','2014-04-01','11:40:00',4.27),('14598','2014-04-01','11:45:00',4.32),('14598','2014-04-01','11:50:00',4.35),('14598','2014-04-01','11:55:00',4.41),('14598','2014-04-01','12:00:00',4.45),('14598','2014-04-01','12:05:00',4.43),('14598','2014-04-01','12:10:00',4.55),('14598','2014-04-01','12:15:00',4.47),('14598','2014-04-01','12:20:00',4.58),('14598','2014-04-01','12:25:00',4.63),('14598','2014-04-01','12:30:00',4.58),('14598','2014-04-01','12:35:00',3.99),('14598','2014-04-01','12:40:00',4.45),('14598','2014-04-01','12:45:00',4.23),('14598','2014-04-01','12:50:00',3.52),('14598','2014-04-01','12:55:00',3.8),('14598','2014-04-01','13:00:00',5.18),('14598','2014-04-01','13:05:00',4.89),('14598','2014-04-01','13:10:00',4.56),('14598','2014-04-01','13:15:00',5.17),('14598','2014-04-01','13:20:00',4.96),('14598','2014-04-01','13:25:00',4.35),('14598','2014-04-01','13:30:00',4.79),('14598','2014-04-01','13:35:00',4.99),('14598','2014-04-01','13:40:00',4.98),('14598','2014-04-01','13:45:00',5.08),('14598','2014-04-01','13:50:00',4.57),('14598','2014-04-01','13:55:00',5.07),('14598','2014-04-01','14:00:00',4.19),('14598','2014-04-01','14:05:00',4.34),('14598','2014-04-01','14:10:00',4.91),('14598','2014-04-01','14:15:00',4.83),('14598','2014-04-01','14:20:00',2.79),('14598','2014-04-01','14:25:00',3.63),('14598','2014-04-01','14:30:00',3.58),('14598','2014-04-01','14:35:00',4.91),('14598','2014-04-01','14:40:00',4.85),('14598','2014-04-01','14:45:00',4.42),('14598','2014-04-01','14:50:00',4.5),('14598','2014-04-01','14:55:00',4.87),('14598','2014-04-01','15:00:00',4.74),('14598','2014-04-01','15:05:00',4.66),('14598','2014-04-01','15:10:00',4.78),('14598','2014-04-01','15:15:00',3.67),('14598','2014-04-01','15:20:00',2.87),('14598','2014-04-01','15:25:00',4.13),('14598','2014-04-01','15:30:00',4.44),('14598','2014-04-01','15:35:00',4.57),('14598','2014-04-01','15:40:00',4.51),('14598','2014-04-01','15:45:00',3.36),('14598','2014-04-01','15:50:00',3.87),('14598','2014-04-01','15:55:00',3.85),('14598','2014-04-01','16:00:00',4.02),('14598','2014-04-01','16:05:00',3.9),('14598','2014-04-01','16:10:00',3.96),('14598','2014-04-01','16:15:00',3.92),('14598','2014-04-01','16:20:00',3.81),('14598','2014-04-01','16:25:00',3.56),('14598','2014-04-01','16:30:00',3.57),('14598','2014-04-01','16:35:00',3.63),('14598','2014-04-01','16:40:00',3.55),('14598','2014-04-01','16:45:00',3.44),('14598','2014-04-01','16:50:00',3.34),('14598','2014-04-01','16:55:00',3.24),('14598','2014-04-01','17:00:00',3.13),('14598','2014-04-01','17:05:00',3.04),('14598','2014-04-01','17:10:00',2.95),('14598','2014-04-01','17:15:00',2.86),('14598','2014-04-01','17:20:00',2.66),('14598','2014-04-01','17:25:00',2.55),('14598','2014-04-01','17:30:00',2.38),('14598','2014-04-01','17:35:00',2.36),('14598','2014-04-01','17:40:00',2.34),('14598','2014-04-01','17:45:00',2.22),('14598','2014-04-01','17:50:00',2.06),('14598','2014-04-01','17:55:00',1.89),('14598','2014-04-01','18:00:00',1.28),('14598','2014-04-01','18:05:00',1.58),('14598','2014-04-01','18:10:00',1.16),('14598','2014-04-01','18:15:00',1.08),('14598','2013-05-21','07:25:00',1),('14598','2013-05-21','07:55:00',1.3),('14598','2013-05-21','08:00:00',1.64),('14598','2013-05-21','08:05:00',1.77),('14598','2013-05-21','08:10:00',1.37),('14598','2013-05-21','08:15:00',1.25),('14598','2013-05-21','08:20:00',1.17),('14598','2013-05-21','08:25:00',1.24),('14598','2013-05-21','08:30:00',1.24),('14598','2013-05-21','08:35:00',1.19),('14598','2013-05-21','08:40:00',1.3),('14598','2013-05-21','08:45:00',1.43),('14598','2013-05-21','08:50:00',1.32),('14598','2013-05-21','08:55:00',1.45),('14598','2013-05-21','09:00:00',1.83),('14598','2013-05-21','09:05:00',1.84),('14598','2013-05-21','09:10:00',2.09),('14598','2013-05-21','09:15:00',2.27),('14598','2013-05-21','09:20:00',2.3),('14598','2013-05-21','09:25:00',2.4),('14598','2013-05-21','09:30:00',1.95),('14598','2013-05-21','09:35:00',1.76),('14598','2013-05-21','09:40:00',1.7),('14598','2013-05-21','09:45:00',1.82),('14598','2013-05-21','09:50:00',2.07),('14598','2013-05-21','09:55:00',2.7),('14598','2013-05-21','10:00:00',2.13),('14598','2013-05-21','10:05:00',2.13),('14598','2013-05-21','10:10:00',2.22),('14598','2013-05-21','10:15:00',2.64),('14598','2013-05-21','10:20:00',2.83),('14598','2013-05-21','10:25:00',2.12),('14598','2013-05-21','10:30:00',2.57),('14598','2013-05-21','10:35:00',2.34),('14598','2013-05-21','10:40:00',2.19),('14598','2013-05-21','10:45:00',1.57),('14598','2013-05-21','10:50:00',1.74),('14598','2013-05-21','10:55:00',2.23),('14598','2013-05-21','11:00:00',2.7),('14598','2013-05-21','11:05:00',2.62),('14598','2013-05-21','11:10:00',3.64),('14598','2013-05-21','11:15:00',4.14),('14598','2013-05-21','11:20:00',3.42),('14598','2013-05-21','11:25:00',3.94),('14598','2013-05-21','11:30:00',2.82),('14598','2013-05-21','11:35:00',2.44),('14598','2013-05-21','11:40:00',2.92),('14598','2013-05-21','11:45:00',3.44),('14598','2013-05-21','11:50:00',3.28),('14598','2013-05-21','11:55:00',2.45),('14598','2013-05-21','12:00:00',2.81),('14598','2013-05-21','12:05:00',2.44),('14598','2013-05-21','12:10:00',2.37),('14598','2013-05-21','12:15:00',3.29),('14598','2013-05-21','12:20:00',3.18),('14598','2013-05-21','12:25:00',5.36),('14598','2013-05-21','12:30:00',3.12),('14598','2013-05-21','12:35:00',4.47),('14598','2013-05-21','12:40:00',3.99),('14598','2013-05-21','12:45:00',3.47),('14598','2013-05-21','12:50:00',2.48),('14598','2013-05-21','12:55:00',2.91),('14598','2013-05-21','13:00:00',4.28),('14598','2013-05-21','13:05:00',3.52),('14598','2013-05-21','13:10:00',3.95),('14598','2013-05-21','13:15:00',3.65),('14598','2013-05-21','13:20:00',2.81),('14598','2013-05-21','13:25:00',2.49),('14598','2013-05-21','13:30:00',2.85),('14598','2013-05-21','13:35:00',2.63),('14598','2013-05-21','13:40:00',1.25),('14598','2013-05-21','14:00:00',1.39),('14598','2013-05-21','14:05:00',2.24),('14598','2013-05-21','14:10:00',2.68),('14598','2013-05-21','14:15:00',3.13),('14598','2013-05-21','14:20:00',5.49),('14598','2013-05-21','14:25:00',4.29),('14598','2013-05-21','14:30:00',2.48),('14598','2013-05-21','14:35:00',1.21),('14598','2013-05-21','15:00:00',1.01),('14598','2013-05-21','15:05:00',1.37),('14598','2013-05-21','15:10:00',1.75),('14598','2013-05-21','15:15:00',1.65),('14598','2013-05-21','15:20:00',2.54),('14598','2013-05-21','15:25:00',2.94),('14598','2013-05-21','15:30:00',2),('14598','2013-05-21','15:35:00',1.78),('14598','2013-05-21','15:40:00',1.69),('14598','2013-05-21','15:45:00',1.24),('14598','2013-05-20','07:25:00',1.16),('14598','2013-05-20','07:30:00',1.06),('14598','2013-05-20','07:55:00',1.11),('14598','2013-05-20','08:20:00',1.41),('14598','2013-05-20','08:30:00',1.75),('14598','2013-05-20','08:35:00',1.28),('14598','2013-05-20','08:40:00',2.53),('14598','2013-05-20','08:45:00',1.92),('14598','2013-05-20','08:50:00',1.67),('14598','2013-05-20','08:55:00',2.27),('14598','2013-05-20','09:00:00',1.9),('14598','2013-05-20','09:05:00',2.64),('14598','2013-05-20','09:10:00',2.8),('14598','2013-05-20','09:15:00',2.9),('14598','2013-05-20','09:20:00',2.98),('14598','2013-05-20','09:25:00',2.93),('14598','2013-05-20','09:30:00',2.97),('14598','2013-05-20','09:35:00',3.14),('14598','2013-05-20','09:40:00',3.25),('14598','2013-05-20','09:45:00',3.36),('14598','2013-05-20','09:50:00',3.46),('14598','2013-05-20','09:55:00',3.54),('14598','2013-05-20','10:00:00',3.63),('14598','2013-05-20','10:05:00',3.77),('14598','2013-05-20','10:10:00',3.77),('14598','2013-05-20','10:15:00',3.88),('14598','2013-05-20','10:20:00',3.94),('14598','2013-05-20','10:25:00',4.01),('14598','2013-05-20','10:30:00',3.84),('14598','2013-05-20','10:35:00',4.19),('14598','2013-05-20','10:40:00',4.1),('14598','2013-05-20','10:45:00',4.3),('14598','2013-05-20','10:50:00',4.33),('14598','2013-05-20','10:55:00',4.37),('14598','2013-05-20','11:00:00',4.4),('14598','2013-05-20','11:05:00',4.46),('14598','2013-05-20','11:10:00',4.54),('14598','2013-05-20','11:15:00',4.61),('14598','2013-05-20','11:20:00',4.61),('14598','2013-05-20','11:25:00',4.69),('14598','2013-05-20','11:30:00',4.76),('14598','2013-05-20','11:35:00',4.8),('14598','2013-05-20','11:40:00',4.86),('14598','2013-05-20','11:45:00',4.91),('14598','2013-05-20','11:50:00',4.96),('14598','2013-05-20','11:55:00',4.98),('14598','2013-05-20','12:00:00',5.03),('14598','2013-05-20','12:05:00',5.06),('14598','2013-05-20','12:10:00',5.09),('14598','2013-05-20','12:15:00',5.12),('14598','2013-05-20','12:20:00',5.17),('14598','2013-05-20','12:25:00',5.2),('14598','2013-05-20','12:30:00',5.21),('14598','2013-05-20','12:35:00',5.23),('14598','2013-05-20','12:40:00',5.22),('14598','2013-05-20','12:45:00',5.27),('14598','2013-05-20','12:50:00',5.31),('14598','2013-05-20','12:55:00',5.32),('14598','2013-05-20','13:00:00',5.32),('14598','2013-05-20','13:05:00',5.35),('14598','2013-05-20','13:10:00',5.36),('14598','2013-05-20','13:15:00',5.38),('14598','2013-05-20','13:20:00',5.39),('14598','2013-05-20','13:25:00',5.41),('14598','2013-05-20','13:30:00',5.3),('14598','2013-05-20','13:35:00',5.4),('14598','2013-05-20','13:40:00',5.39),('14598','2013-05-20','13:45:00',5.39),('14598','2013-05-20','13:50:00',5.38),('14598','2013-05-20','13:55:00',5.38),('14598','2013-05-20','14:00:00',5.33),('14598','2013-05-20','14:05:00',5.35),('14598','2013-05-20','14:10:00',5.3),('14598','2013-05-20','14:15:00',5.29),('14598','2013-05-20','14:20:00',5.26),('14598','2013-05-20','14:25:00',5.25),('14598','2013-05-20','14:30:00',5.22),('14598','2013-05-20','14:35:00',5.19),('14598','2013-05-20','14:40:00',5.19),('14598','2013-05-20','14:45:00',5.17),('14598','2013-05-20','14:50:00',5.11),('14598','2013-05-20','14:55:00',5.13),('14598','2013-05-20','15:00:00',5.09),('14598','2013-05-20','15:05:00',5.04),('14598','2013-05-20','15:10:00',4.99),('14598','2013-05-20','15:15:00',4.95),('14598','2013-05-20','15:20:00',4.9),('14598','2013-05-20','15:25:00',4.91),('14598','2013-05-20','15:30:00',4.87),('14598','2013-05-20','15:35:00',4.82),('14598','2013-05-20','15:40:00',4.72),('14598','2013-05-20','15:45:00',4.71),('14598','2013-05-20','15:50:00',4.66),('14598','2013-05-20','15:55:00',4.59),('14598','2013-05-20','16:00:00',4.57),('14598','2013-05-20','16:05:00',4.54),('14598','2013-05-20','16:10:00',4.51),('14598','2013-05-20','16:15:00',4.34),('14598','2013-05-20','16:20:00',3.4),('14598','2013-05-20','16:25:00',3.44),('14598','2013-05-20','16:30:00',4.08),('14598','2013-05-20','16:35:00',3.19),('14598','2013-05-20','16:40:00',2.54),('14598','2013-05-20','16:45:00',2.32),('14598','2013-05-20','16:50:00',3.78),('14598','2013-05-20','16:55:00',3.89),('14598','2013-05-20','17:00:00',2.86),('14598','2013-05-20','17:05:00',2.62),('14598','2013-05-20','17:10:00',4.35),('14598','2013-05-20','17:15:00',3.68),('14598','2013-05-20','17:20:00',3.52),('14598','2013-05-20','17:25:00',3.42),('14598','2013-05-20','17:30:00',3.21),('14598','2013-05-20','17:35:00',3.1),('14598','2013-05-20','17:40:00',3.02),('14598','2013-05-20','17:45:00',2.96),('14598','2013-05-20','17:50:00',2.48),('14598','2013-05-20','17:55:00',2.84),('14598','2013-05-20','18:00:00',2.58),('14598','2013-05-20','18:05:00',2.63),('14598','2013-05-20','18:10:00',2.4),('14598','2013-05-20','18:15:00',2.28),('14598','2013-05-20','18:20:00',2.16),('14598','2013-05-20','18:25:00',2.09),('14598','2013-05-20','18:30:00',1.95),('14598','2013-05-20','18:35:00',1.88),('14598','2013-05-20','18:40:00',1.78),('14598','2013-05-20','18:45:00',1.65),('14598','2013-05-20','18:50:00',1.53),('14598','2013-05-20','18:55:00',1.43),('14598','2013-05-20','19:00:00',1.33),('14598','2013-05-20','19:05:00',1.21),('14598','2013-05-20','19:10:00',1.09),('14598','2013-05-19','08:20:00',1.12),('14598','2013-05-19','08:25:00',1.22),('14598','2013-05-19','08:30:00',1.23),('14598','2013-05-19','08:35:00',1.08),('14598','2013-05-19','08:40:00',1.58),('14598','2013-05-19','08:45:00',2.15),('14598','2013-05-19','08:50:00',1.81),('14598','2013-05-19','08:55:00',1.55),('14598','2013-05-19','09:00:00',1.76),('14598','2013-05-19','09:05:00',1.71),('14598','2013-05-19','09:10:00',2.51),('14598','2013-05-19','09:15:00',2.49),('14598','2013-05-19','09:20:00',2.27),('14598','2013-05-19','09:25:00',2.16),('14598','2013-05-19','09:30:00',1.91),('14598','2013-05-19','09:35:00',2.79),('14598','2013-05-19','09:40:00',3.11),('14598','2013-05-19','09:45:00',3.22),('14598','2013-05-19','09:50:00',3.31),('14598','2013-05-19','09:55:00',3.29),('14598','2013-05-19','10:00:00',3.37),('14598','2013-05-19','10:05:00',2.81),('14598','2013-05-19','10:10:00',3.61),('14598','2013-05-19','10:15:00',3.79),('14598','2013-05-19','10:20:00',3.88),('14598','2013-05-19','10:25:00',4),('14598','2013-05-19','10:30:00',3.79),('14598','2013-05-19','10:35:00',4.13),('14598','2013-05-19','10:40:00',4.18),('14598','2013-05-19','10:45:00',4.26),('14598','2013-05-19','10:50:00',4.35),('14598','2013-05-19','10:55:00',4.43),('14598','2013-05-19','11:00:00',4.6),('14598','2013-05-19','11:05:00',4.64),('14598','2013-05-19','11:10:00',4.37),('14598','2013-05-19','11:15:00',4.6),('14598','2013-05-19','11:20:00',4.93),('14598','2013-05-19','11:25:00',4.8),('14598','2013-05-19','11:30:00',5.06),('14598','2013-05-19','11:35:00',5.22),('14598','2013-05-19','11:40:00',4.09),('14598','2013-05-19','11:45:00',4.55),('14598','2013-05-19','11:50:00',5.2),('14598','2013-05-19','11:55:00',5.22),('14598','2013-05-19','12:00:00',5.21),('14598','2013-05-19','12:05:00',5.35),('14598','2013-05-19','12:10:00',5.34),('14598','2013-05-19','12:15:00',5.36),('14598','2013-05-19','12:20:00',5.35),('14598','2013-05-19','12:25:00',5.33),('14598','2013-05-19','12:30:00',5.33),('14598','2013-05-19','12:35:00',5.34),('14598','2013-05-19','12:40:00',5.38),('14598','2013-05-19','12:45:00',5.4),('14598','2013-05-19','12:50:00',5.44),('14598','2013-05-19','12:55:00',5.43),('14598','2013-05-19','13:00:00',5.45),('14598','2013-05-19','13:05:00',5.44),('14598','2013-05-19','13:10:00',5.49),('14598','2013-05-19','13:15:00',5.5),('14598','2013-05-19','13:20:00',5.52),('14598','2013-05-19','13:25:00',5.49),('14598','2013-05-19','13:30:00',5.49),('14598','2013-05-19','13:35:00',5.49),('14598','2013-05-19','13:40:00',5.5),('14598','2013-05-19','13:45:00',5.52),('14598','2013-05-19','13:50:00',5.53),('14598','2013-05-19','13:55:00',5.55),('14598','2013-05-19','14:00:00',5.55),('14598','2013-05-19','14:05:00',5.54),('14598','2013-05-19','14:10:00',5.52),('14598','2013-05-19','14:15:00',5.48),('14598','2013-05-19','14:20:00',5.44),('14598','2013-05-19','14:25:00',5.45),('14598','2013-05-19','14:30:00',5.44),('14598','2013-05-19','14:35:00',5.4),('14598','2013-05-19','14:40:00',5.37),('14598','2013-05-19','14:45:00',5.35),('14598','2013-05-19','14:50:00',5.32),('14598','2013-05-19','14:55:00',5.34),('14598','2013-05-19','15:00:00',5.29),('14598','2013-05-19','15:05:00',5.21),('14598','2013-05-19','15:10:00',5.17),('14598','2013-05-19','15:15:00',5.12),('14598','2013-05-19','15:20:00',5.09),('14598','2013-05-19','15:25:00',5.04),('14598','2013-05-19','15:30:00',5.03),('14598','2013-05-19','15:35:00',4.97),('14598','2013-05-19','15:40:00',4.94),('14598','2013-05-19','15:45:00',4.87),('14598','2013-05-19','15:50:00',4.82),('14598','2013-05-19','15:55:00',4.78),('14598','2013-05-19','16:00:00',4.73),('14598','2013-05-19','16:05:00',4.6),('14598','2013-05-19','16:10:00',4.59),('14598','2013-05-19','16:15:00',4.53),('14598','2013-05-19','16:20:00',4.44),('14598','2013-05-19','16:25:00',4.4),('14598','2013-05-19','16:30:00',4.34),('14598','2013-05-19','16:35:00',4.27),('14598','2013-05-19','16:40:00',4.21),('14598','2013-05-19','16:45:00',4.14),('14598','2013-05-19','16:50:00',4.05),('14598','2013-05-19','16:55:00',3.99),('14598','2013-05-19','17:00:00',3.91),('14598','2013-05-19','17:05:00',3.84),('14598','2013-05-19','17:10:00',3.76),('14598','2013-05-19','17:15:00',3.66),('14598','2013-05-19','17:20:00',3.54),('14598','2013-05-19','17:25:00',3.48),('14598','2013-05-19','17:30:00',3.4),('14598','2013-05-19','17:35:00',3.31),('14598','2013-05-19','17:40:00',3.18),('14598','2013-05-19','17:45:00',3.07),('14598','2013-05-19','17:50:00',2.97),('14598','2013-05-19','17:55:00',2.87),('14598','2013-05-19','18:00:00',2.75),('14598','2013-05-19','18:05:00',2.65),('14598','2013-05-19','18:10:00',2.55),('14598','2013-05-19','18:15:00',2.43),('14598','2013-05-19','18:20:00',2.32),('14598','2013-05-19','18:25:00',2.23),('14598','2013-05-19','18:30:00',2.12),('14598','2013-05-19','18:35:00',2.01),('14598','2013-05-19','18:40:00',1.9),('14598','2013-05-19','18:45:00',1.79),('14598','2013-05-19','18:50:00',1.66),('14598','2013-05-19','18:55:00',1.54),('14598','2013-05-19','19:00:00',1.43),('14598','2013-05-19','19:05:00',1.31),('14598','2013-05-19','19:10:00',1.22),('14598','2013-05-19','19:15:00',1.1),('14598','2013-05-18','08:10:00',1.05),('14598','2013-05-18','08:25:00',1.7),('14598','2013-05-18','08:30:00',1.88),('14598','2013-05-18','08:35:00',2),('14598','2013-05-18','08:40:00',1.97),('14598','2013-05-18','08:45:00',2.11),('14598','2013-05-18','08:50:00',2.24),('14598','2013-05-18','08:55:00',2.41),('14598','2013-05-18','09:00:00',2.69),('14598','2013-05-18','09:05:00',2.75),('14598','2013-05-18','09:10:00',2.67),('14598','2013-05-18','09:15:00',2.72),('14598','2013-05-18','09:20:00',2.8),('14598','2013-05-18','09:25:00',2.92),('14598','2013-05-18','09:30:00',3.01),('14598','2013-05-18','09:35:00',3.08),('14598','2013-05-18','09:40:00',3.15),('14598','2013-05-18','09:45:00',3.24),('14598','2013-05-18','09:50:00',3.32),('14598','2013-05-18','09:55:00',3.39),('14598','2013-05-18','10:00:00',3.45),('14598','2013-05-18','10:05:00',3.53),('14598','2013-05-18','10:10:00',3.62),('14598','2013-05-18','10:15:00',3.67),('14598','2013-05-18','10:20:00',3.75),('14598','2013-05-18','10:25:00',3.79),('14598','2013-05-18','10:30:00',3.86),('14598','2013-05-18','10:35:00',3.96),('14598','2013-05-18','10:40:00',4.05),('14598','2013-05-18','10:45:00',3.89),('14598','2013-05-18','10:50:00',3.38),('14598','2013-05-18','10:55:00',3.61),('14598','2013-05-18','11:00:00',4.02),('14598','2013-05-18','11:05:00',3.26),('14598','2013-05-18','11:10:00',2.56),('14598','2013-05-18','11:15:00',2.56),('14598','2013-05-18','11:20:00',4.51),('14598','2013-05-18','11:25:00',4),('14598','2013-05-18','11:30:00',4.03),('14598','2013-05-18','11:35:00',4.26),('14598','2013-05-18','11:40:00',4.57),('14598','2013-05-18','11:45:00',4.19),('14598','2013-05-18','11:50:00',4.58),('14598','2013-05-18','11:55:00',4.59),('14598','2013-05-18','12:00:00',4.61),('14598','2013-05-18','12:05:00',4.67),('14598','2013-05-18','12:10:00',4.64),('14598','2013-05-18','12:15:00',4.85),('14598','2013-05-18','12:20:00',4.82),('14598','2013-05-18','12:25:00',4.78),('14598','2013-05-18','12:30:00',4.82),('14598','2013-05-18','12:35:00',4.85),('14598','2013-05-18','12:40:00',4.81),('14598','2013-05-18','12:45:00',4.81),('14598','2013-05-18','12:50:00',4.81),('14598','2013-05-18','12:55:00',4.87),('14598','2013-05-18','13:00:00',4.88),('14598','2013-05-18','13:05:00',4.88),('14598','2013-05-18','13:10:00',4.6),('14598','2013-05-18','13:15:00',4.89),('14598','2013-05-18','13:20:00',4.89),('14598','2013-05-18','13:25:00',4.89),('14598','2013-05-18','13:30:00',4.92),('14598','2013-05-18','13:35:00',4.89),('14598','2013-05-18','13:40:00',4.85),('14598','2013-05-18','13:45:00',4.83),('14598','2013-05-18','13:50:00',4.85),('14598','2013-05-18','13:55:00',4.96),('14598','2013-05-18','14:00:00',4.54),('14598','2013-05-18','14:05:00',3.74),('14598','2013-05-18','14:10:00',3.59),('14598','2013-05-18','14:15:00',3.5),('14598','2013-05-18','14:20:00',3.21),('14598','2013-05-18','14:25:00',3.45),('14598','2013-05-18','14:30:00',4.39),('14598','2013-05-18','14:35:00',5.09),('14598','2013-05-18','14:40:00',4.77),('14598','2013-05-18','14:45:00',4.76),('14598','2013-05-18','14:50:00',4.72),('14598','2013-05-18','14:55:00',4.53),('14598','2013-05-18','15:00:00',4.53),('14598','2013-05-18','15:05:00',4.54),('14598','2013-05-18','15:10:00',4.54),('14598','2013-05-18','15:15:00',4.2),('14598','2013-05-18','15:20:00',4.38),('14598','2013-05-18','15:25:00',4.44),('14598','2013-05-18','15:30:00',4.35),('14598','2013-05-18','15:35:00',4.29),('14598','2013-05-18','15:40:00',4.21),('14598','2013-05-18','15:45:00',4.12),('14598','2013-05-18','15:50:00',4.05),('14598','2013-05-18','15:55:00',4.01),('14598','2013-05-18','16:00:00',3.96),('14598','2013-05-18','16:05:00',3.89),('14598','2013-05-18','16:10:00',3.81),('14598','2013-05-18','16:15:00',3.71),('14598','2013-05-18','16:20:00',3.68),('14598','2013-05-18','16:25:00',3.62),('14598','2013-05-18','16:30:00',3.55),('14598','2013-05-18','16:35:00',3.48),('14598','2013-05-18','16:40:00',3.42),('14598','2013-05-18','16:45:00',3.35),('14598','2013-05-18','16:50:00',3.27),('14598','2013-05-18','16:55:00',3.22),('14598','2013-05-18','17:00:00',3.15),('14598','2013-05-18','17:05:00',3.06),('14598','2013-05-18','17:10:00',2.99),('14598','2013-05-18','17:15:00',2.92),('14598','2013-05-18','17:20:00',2.85),('14598','2013-05-18','17:25:00',2.75),('14598','2013-05-18','17:30:00',2.66),('14598','2013-05-18','17:35:00',2.57),('14598','2013-05-18','17:40:00',2.48),('14598','2013-05-18','17:45:00',2.38),('14598','2013-05-18','17:50:00',2.3),('14598','2013-05-18','17:55:00',2.21),('14598','2013-05-18','18:00:00',2.12),('14598','2013-05-18','18:05:00',1.95),('14598','2013-05-18','18:10:00',1.89),('14598','2013-05-18','18:15:00',1.79),('14598','2013-05-18','18:20:00',1.69),('14598','2013-05-18','18:25:00',1.58),('14598','2013-05-18','18:30:00',1.48),('14598','2013-05-18','18:35:00',1.37),('14598','2013-05-18','18:40:00',1.28),('14598','2013-05-18','18:45:00',1.18),('14598','2013-05-18','18:50:00',1.07),('14598','2013-05-17','07:40:00',1.1),('14598','2013-05-17','07:45:00',1.07),('14598','2013-05-17','07:50:00',1.55),('14598','2013-05-17','07:55:00',1.55),('14598','2013-05-17','08:00:00',1.53),('14598','2013-05-17','08:05:00',1.32),('14598','2013-05-17','08:10:00',1.25),('14598','2013-05-17','08:55:00',1.22),('14598','2013-05-17','09:00:00',1.69),('14598','2013-05-17','09:05:00',2.26),('14598','2013-05-17','09:10:00',1.05),('14598','2013-05-17','10:00:00',1.21),('14598','2013-05-17','10:05:00',1.62),('14598','2013-05-17','10:10:00',1.7),('14598','2013-05-17','10:15:00',2.05),('14598','2013-05-17','10:20:00',3.05),('14598','2013-05-17','10:25:00',2.14),('14598','2013-05-17','10:30:00',3.56),('14598','2013-05-17','10:35:00',5.06),('14598','2013-05-17','10:40:00',3.58),('14598','2013-05-17','10:45:00',3.82),('14598','2013-05-17','10:50:00',3.54),('14598','2013-05-17','10:55:00',2.21),('14598','2013-05-17','11:00:00',3.93),('14598','2013-05-17','11:05:00',3.66),('14598','2013-05-17','11:10:00',3.81),('14598','2013-05-17','11:15:00',3.91),('14598','2013-05-17','11:20:00',2.95),('14598','2013-05-17','11:25:00',2.96),('14598','2013-05-17','11:30:00',2.75),('14598','2013-05-17','11:35:00',4.14),('14598','2013-05-17','11:40:00',4.37),('14598','2013-05-17','11:45:00',3.79),('14598','2013-05-17','11:50:00',4.48),('14598','2013-05-17','11:55:00',5.54),('14598','2013-05-17','12:00:00',3.94),('14598','2013-05-17','12:05:00',5.13),('14598','2013-05-17','12:10:00',4.43),('14598','2013-05-17','12:15:00',4.63),('14598','2013-05-17','12:20:00',4.8),('14598','2013-05-17','12:25:00',4.07),('14598','2013-05-17','12:30:00',5.23),('14598','2013-05-17','12:35:00',4.89),('14598','2013-05-17','12:40:00',3.26),('14598','2013-05-17','12:45:00',5.7),('14598','2013-05-17','12:50:00',5.44),('14598','2013-05-17','12:55:00',5.37),('14598','2013-05-17','13:00:00',5.4),('14598','2013-05-17','13:05:00',5.44),('14598','2013-05-17','13:10:00',5.4),('14598','2013-05-17','13:15:00',5.49),('14598','2013-05-17','13:20:00',5.43),('14598','2013-05-17','13:25:00',5.17),('14598','2013-05-17','13:30:00',5.53),('14598','2013-05-17','13:35:00',4.04),('14598','2013-05-17','13:40:00',4.84),('14598','2013-05-17','13:45:00',4.63),('14598','2013-05-17','13:50:00',3.29),('14598','2013-05-17','13:55:00',5.09),('14598','2013-05-17','14:00:00',5.14),('14598','2013-05-17','14:05:00',5.71),('14598','2013-05-17','14:10:00',4.88),('14598','2013-05-17','14:15:00',4.64),('14598','2013-05-17','14:20:00',5.41),('14598','2013-05-17','14:25:00',5.15),('14598','2013-05-17','14:30:00',5.02),('14598','2013-05-17','14:35:00',5.36),('14598','2013-05-17','14:40:00',4.94),('14598','2013-05-17','14:45:00',5.38),('14598','2013-05-17','14:50:00',5.21),('14598','2013-05-17','14:55:00',5.15),('14598','2013-05-17','15:00:00',5.13),('14598','2013-05-17','15:05:00',5.1),('14598','2013-05-17','15:10:00',5.08),('14598','2013-05-17','15:15:00',5.04),('14598','2013-05-17','15:20:00',4.97),('14598','2013-05-17','15:25:00',4.93),('14598','2013-05-17','15:30:00',4.89),('14598','2013-05-17','15:35:00',4.86),('14598','2013-05-17','15:40:00',4.8),('14598','2013-05-17','15:45:00',4.74),('14598','2013-05-17','15:50:00',4.69),('14598','2013-05-17','15:55:00',4.63),('14598','2013-05-17','16:00:00',4.57),('14598','2013-05-17','16:05:00',4.53),('14598','2013-05-17','16:10:00',4.45),('14598','2013-05-17','16:15:00',4.42),('14598','2013-05-17','16:20:00',4.37),('14598','2013-05-17','16:25:00',4.31),('14598','2013-05-17','16:30:00',4.23),('14598','2013-05-17','16:35:00',4.15),('14598','2013-05-17','16:40:00',4.09),('14598','2013-05-17','16:45:00',4.01),('14598','2013-05-17','16:50:00',3.92),('14598','2013-05-17','16:55:00',3.84),('14598','2013-05-17','17:00:00',3.78),('14598','2013-05-17','17:05:00',3.7),('14598','2013-05-17','17:10:00',3.62),('14598','2013-05-17','17:15:00',3.53),('14598','2013-05-17','17:20:00',3.44),('14598','2013-05-17','17:25:00',3.36),('14598','2013-05-17','17:30:00',3.28),('14598','2013-05-17','17:35:00',3.17),('14598','2013-05-17','17:40:00',3.08),('14598','2013-05-17','17:45:00',3),('14598','2013-05-17','17:50:00',2.92),('14598','2013-05-17','17:55:00',2.8),('14598','2013-05-17','18:00:00',2.71),('14598','2013-05-17','18:05:00',2.58),('14598','2013-05-17','18:10:00',2.48),('14598','2013-05-17','18:15:00',2.37),('14598','2013-05-17','18:20:00',2.27),('14598','2013-05-17','18:25:00',2.16),('14598','2013-05-17','18:30:00',2.06),('14598','2013-05-17','18:35:00',1.95),('14598','2013-05-17','18:40:00',1.85),('14598','2013-05-17','18:45:00',1.72),('14598','2013-05-17','18:50:00',1.61),('14598','2013-05-17','18:55:00',1.51),('14598','2013-05-17','19:00:00',1.39),('14598','2013-05-17','19:05:00',1.27),('14598','2013-05-17','19:10:00',1.14),('14598','2013-05-17','19:15:00',1.03),('14598','2013-05-16','09:15:00',1.43),('14598','2013-05-16','09:20:00',1.73),('14598','2013-05-16','09:25:00',1.84),('14598','2013-05-16','09:30:00',2.57),('14598','2013-05-16','09:35:00',3.23),('14598','2013-05-16','09:40:00',3.42),('14598','2013-05-16','09:45:00',2.9),('14598','2013-05-16','09:50:00',1.64),('14598','2013-05-16','09:55:00',3.18),('14598','2013-05-16','10:00:00',3.42),('14598','2013-05-16','10:05:00',2.24),('14598','2013-05-16','10:10:00',1.93),('14598','2013-05-16','10:15:00',1.84),('14598','2013-05-16','10:45:00',1.06),('14598','2013-05-16','10:50:00',1.95),('14598','2013-05-16','10:55:00',1.57),('14598','2013-05-16','11:00:00',1.6),('14598','2013-05-16','11:05:00',2.03),('14598','2013-05-16','11:10:00',1.8),('14598','2013-05-16','11:15:00',1.23),('14598','2013-05-16','11:20:00',1.02),('14598','2013-05-16','11:25:00',1.09),('14598','2013-05-16','11:30:00',1.69),('14598','2013-05-16','11:35:00',1.52),('14598','2013-05-16','11:40:00',1.94),('14598','2013-05-16','11:45:00',1.81),('14598','2013-05-16','11:50:00',1.27),('14598','2013-05-16','11:55:00',1.3),('14598','2013-05-16','12:00:00',1.62),('14598','2013-05-16','12:05:00',1.81),('14598','2013-05-16','12:10:00',2.03),('14598','2013-05-16','12:15:00',2.91),('14598','2013-05-16','12:20:00',4.46),('14598','2013-05-16','12:25:00',2.02),('14598','2013-05-16','12:30:00',1.58),('14598','2013-05-16','12:35:00',1.88),('14598','2013-05-16','12:40:00',3.88),('14598','2013-05-16','12:45:00',3.74),('14598','2013-05-16','12:50:00',3.63),('14598','2013-05-16','12:55:00',4.85),('14598','2013-05-16','13:00:00',4.92),('14598','2013-05-16','13:05:00',4.57),('14598','2013-05-16','13:10:00',3.85),('14598','2013-05-16','13:15:00',4.98),('14598','2013-05-16','13:20:00',4.68),('14598','2013-05-16','13:25:00',4.79),('14598','2013-05-16','13:30:00',4.88),('14598','2013-05-16','13:35:00',4.84),('14598','2013-05-16','13:40:00',4.87),('14598','2013-05-16','13:45:00',4.87),('14598','2013-05-16','13:50:00',4.83),('14598','2013-05-16','13:55:00',4.8),('14598','2013-05-16','14:00:00',4.8),('14598','2013-05-16','14:05:00',4.86),('14598','2013-05-16','14:10:00',4.8),('14598','2013-05-16','14:15:00',4.8),('14598','2013-05-16','14:20:00',4.72),('14598','2013-05-16','14:25:00',4.7),('14598','2013-05-16','14:30:00',4.63),('14598','2013-05-16','14:35:00',4.61),('14598','2013-05-16','14:40:00',4.65),('14598','2013-05-16','14:45:00',4.58),('14598','2013-05-16','14:50:00',4.5),('14598','2013-05-16','14:55:00',4.41),('14598','2013-05-16','15:00:00',4.42),('14598','2013-05-16','15:05:00',2.61),('14598','2013-05-16','15:10:00',3.44),('14598','2013-05-16','15:15:00',3.5),('14598','2013-05-16','15:20:00',4.27),('14598','2013-05-16','15:25:00',4.13),('14598','2013-05-16','15:30:00',4.09),('14598','2013-05-16','15:35:00',3.91),('14598','2013-05-16','15:40:00',4.03),('14598','2013-05-16','15:45:00',3.95),('14598','2013-05-16','15:50:00',3.92),('14598','2013-05-16','15:55:00',3.79),('14598','2013-05-16','16:00:00',3.71),('14598','2013-05-16','16:05:00',3.75),('14598','2013-05-16','16:10:00',3.82),('14598','2013-05-16','16:15:00',3.82),('14598','2013-05-16','16:20:00',3.71),('14598','2013-05-16','16:25:00',3.56),('14598','2013-05-16','16:30:00',3.2),('14598','2013-05-16','16:35:00',3.31),('14598','2013-05-16','16:40:00',3.34),('14598','2013-05-16','16:45:00',3.02),('14598','2013-05-16','16:50:00',2.69),('14598','2013-05-16','16:55:00',3.1),('14598','2013-05-16','17:00:00',3.2),('14598','2013-05-16','17:05:00',2.4),('14598','2013-05-16','17:10:00',2.66),('14598','2013-05-16','17:15:00',2.25),('14598','2013-05-16','17:20:00',1.98),('14598','2013-05-16','17:25:00',2.58),('14598','2013-05-16','17:30:00',2.65),('14598','2013-05-16','17:35:00',2.79),('14598','2013-05-16','17:40:00',2.31),('14598','2013-05-16','17:45:00',1.59),('14598','2013-05-16','17:50:00',1.81),('14598','2013-05-16','17:55:00',2.45),('14598','2013-05-16','18:00:00',2.47),('14598','2013-05-16','18:05:00',2.49),('14598','2013-05-16','18:10:00',2.22),('14598','2013-05-16','18:15:00',2),('14598','2013-05-16','18:20:00',1.79),('14598','2013-05-16','18:25:00',1.59),('14598','2013-05-16','18:30:00',1.52),('14598','2013-05-16','18:35:00',1.51),('14598','2013-05-16','18:40:00',1.36),('14598','2013-05-16','18:45:00',1.17),('14598','2013-05-15','08:00:00',1.1),('14598','2013-05-15','08:05:00',1.25),('14598','2013-05-15','08:10:00',1.33),('14598','2013-05-15','08:15:00',1.45),('14598','2013-05-15','08:20:00',1.43),('14598','2013-05-15','08:25:00',1.64),('14598','2013-05-15','08:30:00',1.78),('14598','2013-05-15','08:35:00',1.9),('14598','2013-05-15','08:40:00',2),('14598','2013-05-15','08:45:00',2.14),('14598','2013-05-15','08:50:00',2.07),('14598','2013-05-15','08:55:00',2.33),('14598','2013-05-15','09:00:00',2.34),('14598','2013-05-15','09:05:00',2.42),('14598','2013-05-15','09:10:00',2.42),('14598','2013-05-15','09:15:00',2.53),('14598','2013-05-15','09:20:00',2.76),('14598','2013-05-15','09:25:00',2.88),('14598','2013-05-15','09:30:00',2.88),('14598','2013-05-15','09:35:00',2.98),('14598','2013-05-15','09:40:00',3.08),('14598','2013-05-15','09:45:00',3.05),('14598','2013-05-15','09:50:00',3.14),('14598','2013-05-15','09:55:00',3.27),('14598','2013-05-15','10:00:00',3.36),('14598','2013-05-15','10:05:00',3.41),('14598','2013-05-15','10:10:00',3.65),('14598','2013-05-15','10:15:00',3.8),('14598','2013-05-15','10:20:00',3.88),('14598','2013-05-15','10:25:00',3.74),('14598','2013-05-15','10:30:00',3.52),('14598','2013-05-15','10:35:00',3.86),('14598','2013-05-15','10:40:00',4.04),('14598','2013-05-15','10:45:00',4.1),('14598','2013-05-15','10:50:00',4.22),('14598','2013-05-15','10:55:00',4.23),('14598','2013-05-15','11:00:00',4.29),('14598','2013-05-15','11:05:00',4.44),('14598','2013-05-15','11:10:00',4.27),('14598','2013-05-15','11:15:00',4.52),('14598','2013-05-15','11:20:00',4.76),('14598','2013-05-15','11:25:00',4.72),('14598','2013-05-15','11:30:00',4.95),('14598','2013-05-15','11:35:00',4.83),('14598','2013-05-15','11:40:00',3.55),('14598','2013-05-15','11:45:00',2.66),('14598','2013-05-15','11:50:00',3.55),('14598','2013-05-15','11:55:00',5.38),('14598','2013-05-15','12:00:00',5.03),('14598','2013-05-15','12:05:00',3.95),('14598','2013-05-15','12:10:00',3.79),('14598','2013-05-15','12:15:00',5.53),('14598','2013-05-15','12:20:00',4.69),('14598','2013-05-15','12:25:00',4.29),('14598','2013-05-15','12:30:00',3.87),('14598','2013-05-15','12:35:00',3.88),('14598','2013-05-15','12:40:00',3.69),('14598','2013-05-15','12:45:00',3.96),('14598','2013-05-15','12:50:00',3.76),('14598','2013-05-15','12:55:00',3.28),('14598','2013-05-15','13:00:00',2.99),('14598','2013-05-15','13:05:00',3.63),('14598','2013-05-15','13:10:00',3.46),('14598','2013-05-15','13:15:00',3.79),('14598','2013-05-15','13:20:00',3.36),('14598','2013-05-15','13:25:00',3.92),('14598','2013-05-15','13:30:00',4.14),('14598','2013-05-15','13:35:00',3.34),('14598','2013-05-15','13:40:00',2.89),('14598','2013-05-15','13:45:00',2.89),('14598','2013-05-15','13:50:00',3.33),('14598','2013-05-15','13:55:00',3.31),('14598','2013-05-15','14:00:00',2.65),('14598','2013-05-15','14:05:00',2.47),('14598','2013-05-15','14:10:00',2.3),('14598','2013-05-15','14:15:00',2.14),('14598','2013-05-15','14:20:00',2.08),('14598','2013-05-15','14:25:00',1.89),('14598','2013-05-15','14:30:00',1.54),('14598','2013-05-15','14:35:00',1.32),('14598','2013-05-15','14:40:00',1.26),('14598','2013-05-15','14:45:00',1.31),('14598','2013-05-15','14:50:00',1.34),('14598','2013-05-15','14:55:00',1.33),('14598','2013-05-15','15:00:00',1.21),('14598','2013-05-15','15:05:00',1.12),('14598','2013-05-15','15:10:00',1.09),('14598','2013-05-15','15:15:00',1.4),('14598','2013-05-15','15:20:00',1.51),('14598','2013-05-15','15:25:00',1.59),('14598','2013-05-15','15:30:00',1.56),('14598','2013-05-15','15:35:00',1.33),('14598','2013-05-15','15:40:00',1.33),('14598','2013-05-15','15:45:00',1.41),('14598','2013-05-15','15:50:00',1.62),('14598','2013-05-15','15:55:00',1.97),('14598','2013-05-15','16:00:00',2.05),('14598','2013-05-15','16:05:00',2.14),('14598','2013-05-15','16:10:00',2.44),('14598','2013-05-15','16:15:00',2.36),('14598','2013-05-15','16:20:00',2.24),('14598','2013-05-15','16:25:00',2.35),('14598','2013-05-15','16:30:00',2.04),('14598','2013-05-15','16:35:00',1.74),('14598','2013-05-15','16:40:00',1.92),('14598','2013-05-15','16:45:00',1.88),('14598','2013-05-15','16:50:00',1.98),('14598','2013-05-15','16:55:00',2.28),('14598','2013-05-15','17:00:00',2.35),('14598','2013-05-15','17:05:00',2.8),('14598','2013-05-15','17:10:00',2.41),('14598','2013-05-15','17:15:00',1.21),('14598','2013-05-15','17:20:00',1.32),('14598','2013-05-15','17:25:00',1.34),('14598','2013-05-15','17:30:00',1.07),('14598','2013-05-15','18:15:00',1.24),('14598','2013-05-14','07:55:00',1.04),('14598','2013-05-14','08:00:00',1.15),('14598','2013-05-14','08:05:00',1.24),('14598','2013-05-14','08:10:00',1.36),('14598','2013-05-14','08:15:00',1.48),('14598','2013-05-14','08:20:00',1.58),('14598','2013-05-14','08:25:00',1.69),('14598','2013-05-14','08:30:00',1.79),('14598','2013-05-14','08:35:00',1.91),('14598','2013-05-14','08:40:00',2.03),('14598','2013-05-14','08:45:00',2.14),('14598','2013-05-14','08:50:00',2.26),('14598','2013-05-14','08:55:00',2.39),('14598','2013-05-14','09:00:00',2.49),('14598','2013-05-14','09:05:00',2.59),('14598','2013-05-14','09:10:00',2.69),('14598','2013-05-14','09:15:00',2.79),('14598','2013-05-14','09:20:00',2.89),('14598','2013-05-14','09:25:00',2.98),('14598','2013-05-14','09:30:00',3.07),('14598','2013-05-14','09:35:00',3.14),('14598','2013-05-14','09:40:00',3.24),('14598','2013-05-14','09:45:00',3.33),('14598','2013-05-14','09:50:00',3.42),('14598','2013-05-14','09:55:00',3.49),('14598','2013-05-14','10:00:00',3.57),('14598','2013-05-14','10:05:00',3.63),('14598','2013-05-14','10:10:00',3.71),('14598','2013-05-14','10:15:00',3.78),('14598','2013-05-14','10:20:00',3.84),('14598','2013-05-14','10:25:00',3.91),('14598','2013-05-14','10:30:00',3.99),('14598','2013-05-14','10:35:00',4.04),('14598','2013-05-14','10:40:00',4.1),('14598','2013-05-14','10:45:00',4.19),('14598','2013-05-14','10:50:00',4.18),('14598','2013-05-14','10:55:00',4.26),('14598','2013-05-14','11:00:00',4.3),('14598','2013-05-14','11:05:00',4.35),('14598','2013-05-14','11:10:00',4.4),('14598','2013-05-14','11:15:00',4.45),('14598','2013-05-14','11:20:00',4.55),('14598','2013-05-14','11:25:00',4.64),('14598','2013-05-14','11:30:00',4.72),('14598','2013-05-14','11:35:00',4.79),('14598','2013-05-14','11:40:00',4.84),('14598','2013-05-14','11:45:00',4.89),('14598','2013-05-14','11:50:00',4.93),('14598','2013-05-14','11:55:00',4.99),('14598','2013-05-14','12:00:00',5.01),('14598','2013-05-14','12:05:00',5.04),('14598','2013-05-14','12:10:00',5.11),('14598','2013-05-14','12:15:00',5.14),('14598','2013-05-14','12:20:00',5.14),('14598','2013-05-14','12:25:00',5.17),('14598','2013-05-14','12:30:00',5.2),('14598','2013-05-14','12:35:00',5.2),('14598','2013-05-14','12:40:00',5.24),('14598','2013-05-14','12:45:00',5.28),('14598','2013-05-14','12:50:00',5.3),('14598','2013-05-14','12:55:00',5.33),('14598','2013-05-14','13:00:00',5.33),('14598','2013-05-14','13:05:00',5.35),('14598','2013-05-14','13:10:00',5.38),('14598','2013-05-14','13:15:00',5.39),('14598','2013-05-14','13:20:00',5.4),('14598','2013-05-14','13:25:00',5.41),('14598','2013-05-14','13:30:00',5.42),('14598','2013-05-14','13:35:00',5.44),('14598','2013-05-14','13:40:00',5.42),('14598','2013-05-14','13:45:00',5.41),('14598','2013-05-14','13:50:00',5.33),('14598','2013-05-14','13:55:00',5.4),('14598','2013-05-14','14:00:00',5.39),('14598','2013-05-14','14:05:00',5.37),('14598','2013-05-14','14:10:00',5.34),('14598','2013-05-14','14:15:00',5.31),('14598','2013-05-14','14:20:00',5.29),('14598','2013-05-14','14:25:00',5.3),('14598','2013-05-14','14:30:00',5.28),('14598','2013-05-14','14:35:00',5.25),('14598','2013-05-14','14:40:00',5.22),('14598','2013-05-14','14:45:00',5.18),('14598','2013-05-14','14:50:00',5.14),('14598','2013-05-14','14:55:00',5.14),('14598','2013-05-14','15:00:00',5.1),('14598','2013-05-14','15:05:00',5.07),('14598','2013-05-14','15:10:00',5.02),('14598','2013-05-14','15:15:00',5),('14598','2013-05-14','15:20:00',4.99),('14598','2013-05-14','15:25:00',4.94),('14598','2013-05-14','15:30:00',4.87),('14598','2013-05-14','15:35:00',4.79),('14598','2013-05-14','15:40:00',4.79),('14598','2013-05-14','15:45:00',4.73),('14598','2013-05-14','15:50:00',4.67),('14598','2013-05-14','15:55:00',4.63),('14598','2013-05-14','16:00:00',4.57),('14598','2013-05-14','16:05:00',4.51),('14598','2013-05-14','16:10:00',4.46),('14598','2013-05-14','16:15:00',4.4),('14598','2013-05-14','16:20:00',4.33),('14598','2013-05-14','16:25:00',4.25),('14598','2013-05-14','16:30:00',4.18),('14598','2013-05-14','16:35:00',4.12),('14598','2013-05-14','16:40:00',4.05),('14598','2013-05-14','16:45:00',3.98),('14598','2013-05-14','16:50:00',3.87),('14598','2013-05-14','16:55:00',3.82),('14598','2013-05-14','17:00:00',3.72),('14598','2013-05-14','17:05:00',3.65),('14598','2013-05-14','17:10:00',3.56),('14598','2013-05-14','17:15:00',3.47),('14598','2013-05-14','17:20:00',3.38),('14598','2013-05-14','17:25:00',3.29),('14598','2013-05-14','17:30:00',3.21),('14598','2013-05-14','17:35:00',3.11),('14598','2013-05-14','17:40:00',3.02),('14598','2013-05-14','17:45:00',2.93),('14598','2013-05-14','17:50:00',2.83),('14598','2013-05-14','17:55:00',2.72),('14598','2013-05-14','18:00:00',2.61),('14598','2013-05-14','18:05:00',2.52),('14598','2013-05-14','18:10:00',2.41),('14598','2013-05-14','18:15:00',2.31),('14598','2013-05-14','18:20:00',2.21),('14598','2013-05-14','18:25:00',2.11),('14598','2013-05-14','18:30:00',1.92),('14598','2013-05-14','18:35:00',1.82),('14598','2013-05-14','18:40:00',1.7),('14598','2013-05-14','18:45:00',1.63),('14598','2013-05-14','18:50:00',1.5),('14598','2013-05-14','18:55:00',1.39),('14598','2013-05-14','19:00:00',1.31),('14598','2013-05-14','19:05:00',1.18),('14598','2013-05-14','19:10:00',1.05),('14598','2013-05-13','07:55:00',1.06),('14598','2013-05-13','08:00:00',1.35),('14598','2013-05-13','08:05:00',1.24),('14598','2013-05-13','08:10:00',1.32),('14598','2013-05-13','08:15:00',1.38),('14598','2013-05-13','08:20:00',1.45),('14598','2013-05-13','08:25:00',1.56),('14598','2013-05-13','08:30:00',1.66),('14598','2013-05-13','08:35:00',1.77),('14598','2013-05-13','08:40:00',1.81),('14598','2013-05-13','08:45:00',2),('14598','2013-05-13','08:50:00',2.15),('14598','2013-05-13','08:55:00',2.28),('14598','2013-05-13','09:00:00',2.36),('14598','2013-05-13','09:05:00',2.46),('14598','2013-05-13','09:10:00',2.63),('14598','2013-05-13','09:15:00',1.03),('14598','2013-05-13','09:20:00',2.22),('14598','2013-05-13','09:25:00',1.2),('14598','2013-05-13','09:30:00',3.18),('14598','2013-05-13','09:35:00',3.27),('14598','2013-05-13','09:40:00',3.25),('14598','2013-05-13','09:45:00',1.87),('14598','2013-05-13','09:50:00',2.12),('14598','2013-05-13','09:55:00',2.42),('14598','2013-05-13','10:00:00',2.59),('14598','2013-05-13','10:05:00',2.86),('14598','2013-05-13','10:10:00',3.66),('14598','2013-05-13','10:15:00',3.93),('14598','2013-05-13','10:20:00',3.92),('14598','2013-05-13','10:25:00',4.05),('14598','2013-05-13','10:30:00',3.42),('14598','2013-05-13','10:35:00',4.23),('14598','2013-05-13','10:40:00',4.36),('14598','2013-05-13','10:45:00',4.57),('14598','2013-05-13','10:50:00',3.41),('14598','2013-05-13','10:55:00',2.2),('14598','2013-05-13','11:00:00',1.36),('14598','2013-05-13','11:05:00',1.68),('14598','2013-05-13','11:10:00',4.72),('14598','2013-05-13','11:15:00',4.8),('14598','2013-05-13','11:20:00',4.79),('14598','2013-05-13','11:25:00',4.82),('14598','2013-05-13','11:30:00',4.96),('14598','2013-05-13','11:35:00',5.04),('14598','2013-05-13','11:40:00',4.34),('14598','2013-05-13','11:45:00',4.7),('14598','2013-05-13','11:50:00',5.17),('14598','2013-05-13','11:55:00',5.19),('14598','2013-05-13','12:00:00',5.25),('14598','2013-05-13','12:05:00',2.72),('14598','2013-05-13','12:10:00',5.19),('14598','2013-05-13','12:15:00',5.11),('14598','2013-05-13','12:20:00',5.12),('14598','2013-05-13','12:25:00',5.1),('14598','2013-05-13','12:30:00',5.15),('14598','2013-05-13','12:35:00',5.18),('14598','2013-05-13','12:40:00',5.19),('14598','2013-05-13','12:45:00',5.21),('14598','2013-05-13','12:50:00',5.23),('14598','2013-05-13','12:55:00',5.3),('14598','2013-05-13','13:00:00',5.33),('14598','2013-05-13','13:05:00',5.33),('14598','2013-05-13','13:10:00',5.35),('14598','2013-05-13','13:15:00',5.38),('14598','2013-05-13','13:20:00',5.37),('14598','2013-05-13','13:25:00',5.35),('14598','2013-05-13','13:30:00',5.33),('14598','2013-05-13','13:35:00',5.35),('14598','2013-05-13','13:40:00',5.31),('14598','2013-05-13','13:45:00',5.35),('14598','2013-05-13','13:50:00',5.36),('14598','2013-05-13','13:55:00',5.33),('14598','2013-05-13','14:00:00',5.31),('14598','2013-05-13','14:05:00',5.3),('14598','2013-05-13','14:10:00',5.21),('14598','2013-05-13','14:15:00',5.32),('14598','2013-05-13','14:20:00',5.33),('14598','2013-05-13','14:25:00',5.31),('14598','2013-05-13','14:30:00',5.26),('14598','2013-05-13','14:35:00',5.23),('14598','2013-05-13','14:40:00',5.2),('14598','2013-05-13','14:45:00',5.2),('14598','2013-05-13','14:50:00',5.2),('14598','2013-05-13','14:55:00',5.23),('14598','2013-05-13','15:00:00',5.21),('14598','2013-05-13','15:05:00',5.11),('14598','2013-05-13','15:10:00',5.04),('14598','2013-05-13','15:15:00',4.99),('14598','2013-05-13','15:20:00',4.96),('14598','2013-05-13','15:25:00',4.94),('14598','2013-05-13','15:30:00',4.95),('14598','2013-05-13','15:35:00',4.94),('14598','2013-05-13','15:40:00',4.82),('14598','2013-05-13','15:45:00',4.72),('14598','2013-05-13','15:50:00',4.66),('14598','2013-05-13','15:55:00',4.61),('14598','2013-05-13','16:00:00',4.58),('14598','2013-05-13','16:05:00',4.54),('14598','2013-05-13','16:10:00',4.44),('14598','2013-05-13','16:15:00',4.38),('14598','2013-05-13','16:20:00',4.33),('14598','2013-05-13','16:25:00',4.27),('14598','2013-05-13','16:30:00',4.21),('14598','2013-05-13','16:35:00',4.13),('14598','2013-05-13','16:40:00',4.05),('14598','2013-05-13','16:45:00',3.98),('14598','2013-05-13','16:50:00',3.89),('14598','2013-05-13','16:55:00',3.79),('14598','2013-05-13','17:00:00',3.71),('14598','2013-05-13','17:05:00',3.63),('14598','2013-05-13','17:10:00',3.47),('14598','2013-05-13','17:15:00',3.43),('14598','2013-05-13','17:20:00',3.34),('14598','2013-05-13','17:25:00',3.25),('14598','2013-05-13','17:30:00',3.16),('14598','2013-05-13','17:35:00',3.07),('14598','2013-05-13','17:40:00',2.96),('14598','2013-05-13','17:45:00',2.86),('14598','2013-05-13','17:50:00',2.75),('14598','2013-05-13','17:55:00',2.66),('14598','2013-05-13','18:00:00',2.55),('14598','2013-05-13','18:05:00',2.44),('14598','2013-05-13','18:10:00',2.33),('14598','2013-05-13','18:15:00',2.23),('14598','2013-05-13','18:20:00',2.13),('14598','2013-05-13','18:25:00',2),('14598','2013-05-13','18:30:00',1.89),('14598','2013-05-13','18:35:00',1.76),('14598','2013-05-13','18:40:00',1.64),('14598','2013-05-13','18:45:00',1.53),('14598','2013-05-13','18:50:00',1.4),('14598','2013-05-13','18:55:00',1.27),('14598','2013-05-13','19:00:00',1.19),('14598','2013-05-13','19:05:00',1.14),('14598','2013-05-13','19:10:00',1.07),('14598','2013-05-13','19:15:00',1.06),('14598','2013-05-12','07:30:00',1.04),('14598','2013-05-12','07:40:00',1.09),('14598','2013-05-12','07:55:00',1.11),('14598','2013-05-12','08:00:00',1.02),('14598','2013-05-12','08:05:00',1),('14598','2013-05-12','08:10:00',1.02),('14598','2013-05-12','08:25:00',1.3),('14598','2013-05-12','08:30:00',1.08),('14598','2013-05-12','08:35:00',1.77),('14598','2013-05-12','08:40:00',1.65),('14598','2013-05-12','08:45:00',2.11),('14598','2013-05-12','08:50:00',2.31),('14598','2013-05-12','08:55:00',2.84),('14598','2013-05-12','09:00:00',2.57),('14598','2013-05-12','09:05:00',1.28),('14598','2013-05-12','09:25:00',1.11),('14598','2013-05-12','09:30:00',3.28),('14598','2013-05-12','09:35:00',3.19),('14598','2013-05-12','09:40:00',3.26),('14598','2013-05-12','09:45:00',3.25),('14598','2013-05-12','09:50:00',3.29),('14598','2013-05-12','09:55:00',3.37),('14598','2013-05-12','10:00:00',3.48),('14598','2013-05-12','10:05:00',3.55),('14598','2013-05-12','10:10:00',3.61),('14598','2013-05-12','10:15:00',3.69),('14598','2013-05-12','10:20:00',3.73),('14598','2013-05-12','10:25:00',3.81),('14598','2013-05-12','10:30:00',3.93),('14598','2013-05-12','10:35:00',3.99),('14598','2013-05-12','10:40:00',4.06),('14598','2013-05-12','10:45:00',4.13),('14598','2013-05-12','10:50:00',4.21),('14598','2013-05-12','10:55:00',4.27),('14598','2013-05-12','11:00:00',4.29),('14598','2013-05-12','11:05:00',4.36),('14598','2013-05-12','11:10:00',4.42),('14598','2013-05-12','11:15:00',4.5),('14598','2013-05-12','11:20:00',4.56),('14598','2013-05-12','11:25:00',4.6),('14598','2013-05-12','11:30:00',4.67),('14598','2013-05-12','11:35:00',4.71),('14598','2013-05-12','11:40:00',4.71),('14598','2013-05-12','11:45:00',4.81),('14598','2013-05-12','11:50:00',4.85),('14598','2013-05-12','11:55:00',4.89),('14598','2013-05-12','12:00:00',4.95),('14598','2013-05-12','12:05:00',4.99),('14598','2013-05-12','12:10:00',5.03),('14598','2013-05-12','12:15:00',5.07),('14598','2013-05-12','12:20:00',5.1),('14598','2013-05-12','12:25:00',5.12),('14598','2013-05-12','12:30:00',5.15),('14598','2013-05-12','12:35:00',5.18),('14598','2013-05-12','12:40:00',5.19),('14598','2013-05-12','12:45:00',5.23),('14598','2013-05-12','12:50:00',5.25),('14598','2013-05-12','12:55:00',5.25),('14598','2013-05-12','13:00:00',5.28),('14598','2013-05-12','13:05:00',5.29),('14598','2013-05-12','13:10:00',5.29),('14598','2013-05-12','13:15:00',5.31),('14598','2013-05-12','13:20:00',5.31),('14598','2013-05-12','13:25:00',5.32),('14598','2013-05-12','13:30:00',5.33),('14598','2013-05-12','13:35:00',5.34),('14598','2013-05-12','13:40:00',5.32),('14598','2013-05-12','13:45:00',5.32),('14598','2013-05-12','13:50:00',5.32),('14598','2013-05-12','13:55:00',5.3),('14598','2013-05-12','14:00:00',5.29),('14598','2013-05-12','14:05:00',5.32),('14598','2013-05-12','14:10:00',5.34),('14598','2013-05-12','14:15:00',4.64),('14598','2013-05-12','14:20:00',5.34),('14598','2013-05-12','14:25:00',5.23),('14598','2013-05-12','14:30:00',5.19),('14598','2013-05-12','14:35:00',5.15),('14598','2013-05-12','14:40:00',5.16),('14598','2013-05-12','14:45:00',5.06),('14598','2013-05-12','14:50:00',5.08),('14598','2013-05-12','14:55:00',5.05),('14598','2013-05-12','15:00:00',5.01),('14598','2013-05-12','15:05:00',5),('14598','2013-05-12','15:10:00',4.97),('14598','2013-05-12','15:15:00',4.91),('14598','2013-05-12','15:20:00',4.86),('14598','2013-05-12','15:25:00',4.82),('14598','2013-05-12','15:30:00',4.75),('14598','2013-05-12','15:35:00',4.68),('14598','2013-05-12','15:40:00',4.64),('14598','2013-05-12','15:45:00',4.63),('14598','2013-05-12','15:50:00',3.83),('14598','2013-05-12','15:55:00',4.83),('14598','2013-05-12','16:00:00',3.46),('14598','2013-05-12','16:05:00',2.6),('14598','2013-05-12','16:10:00',3.78),('14598','2013-05-12','16:15:00',3.37),('14598','2013-05-12','16:20:00',3.99),('14598','2013-05-12','16:25:00',3.75),('14598','2013-05-12','16:30:00',4.19),('14598','2013-05-12','16:35:00',4.27),('14598','2013-05-12','16:40:00',4.02),('14598','2013-05-12','16:45:00',3.13),('14598','2013-05-12','16:50:00',3.55),('14598','2013-05-12','16:55:00',3.91),('14598','2013-05-12','17:00:00',3.86),('14598','2013-05-12','17:05:00',3.26),('14598','2013-05-12','17:10:00',2.43),('14598','2013-05-12','17:15:00',1.74),('14598','2013-05-12','17:20:00',2.82),('14598','2013-05-12','17:25:00',3.26),('14598','2013-05-12','17:30:00',1.34),('14598','2013-05-12','17:35:00',1.42),('14598','2013-05-12','17:40:00',3.26),('14598','2013-05-12','17:45:00',2.57),('14598','2013-05-12','17:50:00',2.27),('14598','2013-05-12','17:55:00',1.58),('14598','2013-05-12','18:00:00',1.47),('14598','2013-05-12','18:05:00',1.35),('14598','2013-05-12','18:10:00',1.06),('14598','2013-05-12','18:15:00',1.51),('14598','2013-05-12','18:20:00',1.09),('14598','2013-05-12','18:25:00',1.14),('14598','2013-05-12','18:30:00',1.22),('14598','2013-05-12','18:35:00',1.76),('14598','2014-03-31','08:45:00',1.06),('14598','2014-03-31','08:50:00',1.15),('14598','2014-03-31','08:55:00',1.27),('14598','2014-03-31','09:00:00',1.37),('14598','2014-03-31','09:05:00',1.49),('14598','2014-03-31','09:10:00',1.61),('14598','2014-03-31','09:15:00',1.72),('14598','2014-03-31','09:20:00',1.83),('14598','2014-03-31','09:25:00',1.98),('14598','2014-03-31','09:30:00',2.09),('14598','2014-03-31','09:35:00',2.18),('14598','2014-03-31','09:40:00',2.28),('14598','2014-03-31','09:45:00',2.37),('14598','2014-03-31','09:50:00',2.46),('14598','2014-03-31','09:55:00',2.55),('14598','2014-03-31','10:00:00',2.64),('14598','2014-03-31','10:05:00',2.73),('14598','2014-03-31','10:10:00',2.82),('14598','2014-03-31','10:15:00',2.88),('14598','2014-03-31','10:20:00',2.98),('14598','2014-03-31','10:25:00',3.06),('14598','2014-03-31','10:30:00',3.13),('14598','2014-03-31','10:35:00',3.16),('14598','2014-03-31','10:40:00',3.28),('14598','2014-03-31','10:45:00',3.34),('14598','2014-03-31','10:50:00',3.4),('14598','2014-03-31','10:55:00',3.47),('14598','2014-03-31','11:00:00',3.53),('14598','2014-03-31','11:05:00',3.58),('14598','2014-03-31','11:10:00',3.66),('14598','2014-03-31','11:15:00',3.72),('14598','2014-03-31','11:20:00',3.81),('14598','2014-03-31','11:25:00',3.87),('14598','2014-03-31','11:30:00',3.95),('14598','2014-03-31','11:35:00',4),('14598','2014-03-31','11:40:00',4.04),('14598','2014-03-31','11:45:00',4.11),('14598','2014-03-31','11:50:00',4.17),('14598','2014-03-31','11:55:00',4.24),('14598','2014-03-31','12:00:00',4.28),('14598','2014-03-31','12:05:00',4.34),('14598','2014-03-31','12:10:00',4.37),('14598','2014-03-31','12:15:00',4.42),('14598','2014-03-31','12:20:00',4.45),('14598','2014-03-31','12:25:00',4.48),('14598','2014-03-31','12:30:00',4.53),('14598','2014-03-31','12:35:00',4.57),('14598','2014-03-31','12:40:00',4.59),('14598','2014-03-31','12:45:00',4.63),('14598','2014-03-31','12:50:00',4.65),('14598','2014-03-31','12:55:00',4.66),('14598','2014-03-31','13:00:00',4.7),('14598','2014-03-31','13:05:00',4.72),('14598','2014-03-31','13:10:00',4.75),('14598','2014-03-31','13:15:00',4.76),('14598','2014-03-31','13:20:00',4.77),('14598','2014-03-31','13:25:00',4.77),('14598','2014-03-31','13:30:00',4.77),('14598','2014-03-31','13:35:00',4.69),('14598','2014-03-31','13:40:00',4.76),('14598','2014-03-31','13:45:00',4.75),('14598','2014-03-31','13:50:00',4.77),('14598','2014-03-31','13:55:00',4.76),('14598','2014-03-31','14:00:00',4.78),('14598','2014-03-31','14:05:00',4.82),('14598','2014-03-31','14:10:00',4.82),('14598','2014-03-31','14:15:00',4.8),('14598','2014-03-31','14:20:00',4.78),('14598','2014-03-31','14:25:00',4.74),('14598','2014-03-31','14:30:00',4.71),('14598','2014-03-31','14:35:00',4.7),('14598','2014-03-31','14:40:00',4.67),('14598','2014-03-31','14:45:00',4.65),('14598','2014-03-31','14:50:00',4.6),('14598','2014-03-31','14:55:00',4.59),('14598','2014-03-31','15:00:00',4.56),('14598','2014-03-31','15:05:00',4.52),('14598','2014-03-31','15:10:00',4.5),('14598','2014-03-31','15:15:00',4.46),('14598','2014-03-31','15:20:00',4.42),('14598','2014-03-31','15:25:00',4.37),('14598','2014-03-31','15:30:00',4.33),('14598','2014-03-31','15:35:00',4.28),('14598','2014-03-31','15:40:00',4.25),('14598','2014-03-31','15:45:00',4.19),('14598','2014-03-31','15:50:00',4.13),('14598','2014-03-31','15:55:00',4.06),('14598','2014-03-31','16:00:00',3.98),('14598','2014-03-31','16:05:00',3.9),('14598','2014-03-31','16:10:00',3.85),('14598','2014-03-31','16:15:00',3.79),('14598','2014-03-31','16:20:00',3.71),('14598','2014-03-31','16:25:00',3.63),('14598','2014-03-31','16:30:00',3.55),('14598','2014-03-31','16:35:00',3.45),('14598','2014-03-31','16:40:00',3.37),('14598','2014-03-31','16:45:00',3.3),('14598','2014-03-31','16:50:00',3.21),('14598','2014-03-31','16:55:00',3.11),('14598','2014-03-31','17:00:00',3.01),('14598','2014-03-31','17:05:00',2.91),('14598','2014-03-31','17:10:00',2.82),('14598','2014-03-31','17:15:00',2.72),('14598','2014-03-31','17:20:00',2.6),('14598','2014-03-31','17:25:00',2.52),('14598','2014-03-31','17:30:00',2.41),('14598','2014-03-31','17:35:00',2.3),('14598','2014-03-31','17:40:00',2.19),('14598','2014-03-31','17:45:00',2.08),('14598','2014-03-31','17:50:00',1.98),('14598','2014-03-31','17:55:00',1.85),('14598','2014-03-31','18:00:00',1.72),('14598','2014-03-31','18:05:00',1.61),('14598','2014-03-31','18:10:00',1.5),('14598','2014-03-31','18:15:00',1.38),('14598','2014-03-31','18:20:00',1.26),('14598','2014-03-31','18:25:00',1.13),('14598','2014-03-31','18:30:00',1.01),('14598','2013-05-11','07:55:00',1.18),('14598','2013-05-11','08:00:00',1.13),('14598','2013-05-11','08:05:00',1.21),('14598','2013-05-11','08:10:00',1.28),('14598','2013-05-11','08:15:00',1.72),('14598','2013-05-11','08:20:00',1.53),('14598','2013-05-11','08:25:00',1.73),('14598','2013-05-11','08:35:00',1.13),('14598','2013-05-11','08:40:00',1.42),('14598','2013-05-11','08:45:00',2.24),('14598','2013-05-11','08:50:00',2.52),('14598','2013-05-11','08:55:00',1.99),('14598','2013-05-11','09:00:00',1.02),('14598','2013-05-11','09:10:00',2.19),('14598','2013-05-11','09:15:00',3.09),('14598','2013-05-11','09:20:00',1.67),('14598','2013-05-11','09:25:00',1.29),('14598','2013-05-11','09:30:00',2.64),('14598','2013-05-11','09:35:00',3.27),('14598','2013-05-11','09:40:00',2.86),('14598','2013-05-11','09:45:00',2.48),('14598','2013-05-11','09:50:00',3.49),('14598','2013-05-11','09:55:00',2.46),('14598','2013-05-11','10:00:00',3.61),('14598','2013-05-11','10:05:00',3.64),('14598','2013-05-11','10:10:00',3.6),('14598','2013-05-11','10:15:00',3.64),('14598','2013-05-11','10:20:00',3.28),('14598','2013-05-11','10:25:00',3.35),('14598','2013-05-11','10:30:00',4),('14598','2013-05-11','10:35:00',4.21),('14598','2013-05-11','10:40:00',4.09),('14598','2013-05-11','10:45:00',4.35),('14598','2013-05-11','10:50:00',3.87),('14598','2013-05-11','10:55:00',4.23),('14598','2013-05-11','11:00:00',4.65),('14598','2013-05-11','11:05:00',5.13),('14598','2013-05-11','11:10:00',3.65),('14598','2013-05-11','11:15:00',3.98),('14598','2013-05-11','11:20:00',4.57),('14598','2013-05-11','11:25:00',4.53),('14598','2013-05-11','11:30:00',4.61),('14598','2013-05-11','11:35:00',4.7),('14598','2013-05-11','11:40:00',4.78),('14598','2013-05-11','11:45:00',5.09),('14598','2013-05-11','11:50:00',5.2),('14598','2013-05-11','11:55:00',4.09),('14598','2013-05-11','12:00:00',3.82),('14598','2013-05-11','12:05:00',5.76),('14598','2013-05-11','12:10:00',4.65),('14598','2013-05-11','12:15:00',5.14),('14598','2013-05-11','12:20:00',5.61),('14598','2013-05-11','12:25:00',3.33),('14598','2013-05-11','12:30:00',4.42),('14598','2013-05-11','12:35:00',4.74),('14598','2013-05-11','12:40:00',4.46),('14598','2013-05-11','12:45:00',5.07),('14598','2013-05-11','12:50:00',5.64),('14598','2013-05-11','12:55:00',5.72),('14598','2013-05-11','13:00:00',4.19),('14598','2013-05-11','13:05:00',5.42),('14598','2013-05-11','13:10:00',5.32),('14598','2013-05-11','13:15:00',5.37),('14598','2013-05-11','13:20:00',5.31),('14598','2013-05-11','13:25:00',5.3),('14598','2013-05-11','13:30:00',5.3),('14598','2013-05-11','13:35:00',5.34),('14598','2013-05-11','13:40:00',5.33),('14598','2013-05-11','13:45:00',5.3),('14598','2013-05-11','13:50:00',5.33),('14598','2013-05-11','13:55:00',5.33),('14598','2013-05-11','14:00:00',5.32),('14598','2013-05-11','14:05:00',4.88),('14598','2013-05-11','14:10:00',5.14),('14598','2013-05-11','14:15:00',3.58),('14598','2013-05-11','14:20:00',4.7),('14598','2013-05-11','14:25:00',3.81),('14598','2013-05-11','14:30:00',4.23),('14598','2013-05-11','14:35:00',3.89),('14598','2013-05-11','14:40:00',3.42),('14598','2013-05-11','14:45:00',4.41),('14598','2013-05-11','14:50:00',4.14),('14598','2013-05-11','14:55:00',4.54),('14598','2013-05-11','15:00:00',4.09),('14598','2013-05-11','15:05:00',3.9),('14598','2013-05-11','15:10:00',4.33),('14598','2013-05-11','15:15:00',3.98),('14598','2013-05-11','15:20:00',4.82),('14598','2013-05-11','15:25:00',3.47),('14598','2013-05-11','15:30:00',4.55),('14598','2013-05-11','15:35:00',4.25),('14598','2013-05-11','15:40:00',4.83),('14598','2013-05-11','15:45:00',4.46),('14598','2013-05-11','15:50:00',5.01),('14598','2013-05-11','15:55:00',3.63),('14598','2013-05-11','16:00:00',4),('14598','2013-05-11','16:05:00',4.24),('14598','2013-05-11','16:10:00',4.09),('14598','2013-05-11','16:15:00',3.77),('14598','2013-05-11','16:20:00',3.86),('14598','2013-05-11','16:25:00',4.31),('14598','2013-05-11','16:30:00',4.22),('14598','2013-05-11','16:35:00',4.15),('14598','2013-05-11','16:40:00',3.8),('14598','2013-05-11','16:45:00',3.51),('14598','2013-05-11','16:50:00',3.83),('14598','2013-05-11','16:55:00',3.1),('14598','2013-05-11','17:00:00',3.71),('14598','2013-05-11','17:05:00',3.41),('14598','2013-05-11','17:10:00',3.71),('14598','2013-05-11','17:15:00',3.52),('14598','2013-05-11','17:20:00',2.81),('14598','2013-05-11','17:25:00',3.2),('14598','2013-05-11','17:30:00',2.54),('14598','2013-05-11','17:35:00',2.41),('14598','2013-05-11','17:40:00',1.45),('14598','2013-05-11','17:45:00',1.67),('14598','2013-05-11','17:50:00',2),('14598','2013-05-11','17:55:00',2.26),('14598','2013-05-11','18:00:00',2.21),('14598','2013-05-11','18:05:00',1.36),('14598','2013-05-11','18:10:00',2.09),('14598','2013-05-11','18:15:00',1.37),('14598','2013-05-11','18:20:00',1.02),('14598','2013-05-11','18:25:00',2.47),('14598','2013-05-11','18:30:00',2.07),('14598','2013-05-11','18:35:00',1.3),('14598','2013-05-11','18:40:00',1.75),('14598','2013-05-11','18:45:00',1.62),('14598','2013-05-11','18:50:00',1.51),('14598','2013-05-11','18:55:00',1.34),('14598','2013-05-11','19:00:00',1.07),('14598','2013-05-10','07:25:00',1.05),('14598','2013-05-10','07:30:00',1.07),('14598','2013-05-10','07:35:00',1.07),('14598','2013-05-10','07:40:00',1.15),('14598','2013-05-10','07:45:00',1.18),('14598','2013-05-10','07:50:00',1.22),('14598','2013-05-10','07:55:00',1.27),('14598','2013-05-10','08:00:00',1.29),('14598','2013-05-10','08:25:00',1.24),('14598','2013-05-10','08:30:00',1.71),('14598','2013-05-10','08:35:00',1.78),('14598','2013-05-10','08:40:00',2.11),('14598','2013-05-10','08:45:00',2.32),('14598','2013-05-10','08:50:00',2.35),('14598','2013-05-10','08:55:00',1.15),('14598','2013-05-10','09:00:00',1.29),('14598','2013-05-10','09:05:00',3.09),('14598','2013-05-10','09:10:00',2.63),('14598','2013-05-10','09:15:00',2.76),('14598','2013-05-10','09:20:00',3.04),('14598','2013-05-10','09:25:00',2.69),('14598','2013-05-10','09:30:00',2.95),('14598','2013-05-10','09:35:00',2.97),('14598','2013-05-10','09:40:00',3.11),('14598','2013-05-10','09:45:00',3.21),('14598','2013-05-10','09:50:00',3.3),('14598','2013-05-10','09:55:00',3.39),('14598','2013-05-10','10:00:00',3.44),('14598','2013-05-10','10:05:00',3.53),('14598','2013-05-10','10:10:00',3.26),('14598','2013-05-10','10:15:00',3.76),('14598','2013-05-10','10:20:00',3.79),('14598','2013-05-10','10:25:00',3.86),('14598','2013-05-10','10:30:00',3.95),('14598','2013-05-10','10:35:00',4.04),('14598','2013-05-10','10:40:00',4.13),('14598','2013-05-10','10:45:00',4.29),('14598','2013-05-10','10:50:00',4.42),('14598','2013-05-10','10:55:00',4.58),('14598','2013-05-10','11:00:00',4.75),('14598','2013-05-10','11:05:00',4.74),('14598','2013-05-10','11:10:00',4.09),('14598','2013-05-10','11:15:00',3.42),('14598','2013-05-10','11:20:00',4.93),('14598','2013-05-10','11:25:00',4.83),('14598','2013-05-10','11:30:00',4.59),('14598','2013-05-10','11:35:00',4.24),('14598','2013-05-10','11:40:00',3.59),('14598','2013-05-10','11:45:00',3.25),('14598','2013-05-10','11:50:00',3),('14598','2013-05-10','11:55:00',3.15),('14598','2013-05-10','12:00:00',4.53),('14598','2013-05-10','12:05:00',4.17),('14598','2013-05-10','12:10:00',5.06),('14598','2013-05-10','12:15:00',5.63),('14598','2013-05-10','12:20:00',5.9),('14598','2013-05-10','12:25:00',5.99),('14598','2013-05-10','12:30:00',5.46),('14598','2013-05-10','12:35:00',4.55),('14598','2013-05-10','12:40:00',3.36),('14598','2013-05-10','12:45:00',3.3),('14598','2013-05-10','12:50:00',3.08),('14598','2013-05-10','12:55:00',2.59),('14598','2013-05-10','13:00:00',2.81),('14598','2013-05-10','13:05:00',3.24),('14598','2013-05-10','13:10:00',4.45),('14598','2013-05-10','13:15:00',5.13),('14598','2013-05-10','13:20:00',5.05),('14598','2013-05-10','13:25:00',4.64),('14598','2013-05-10','13:30:00',3.74),('14598','2013-05-10','13:35:00',4.08),('14598','2013-05-10','13:40:00',3.7),('14598','2013-05-10','13:45:00',3.26),('14598','2013-05-10','13:50:00',2.9),('14598','2013-05-10','13:55:00',2.8),('14598','2013-05-10','14:00:00',2.86),('14598','2013-05-10','14:05:00',2.38),('14598','2013-05-10','14:10:00',1.98),('14598','2013-05-10','14:15:00',2.18),('14598','2013-05-10','14:20:00',3.11),('14598','2013-05-10','14:25:00',3.16),('14598','2013-05-10','14:30:00',3.97),('14598','2013-05-10','14:35:00',4.89),('14598','2013-05-10','14:40:00',3.7),('14598','2013-05-10','14:45:00',3.67),('14598','2013-05-10','14:50:00',2.93),('14598','2013-05-10','14:55:00',2.76),('14598','2013-05-10','15:00:00',3.13),('14598','2013-05-10','15:05:00',3.16),('14598','2013-05-10','15:10:00',3.21),('14598','2013-05-10','15:15:00',3.53),('14598','2013-05-10','15:20:00',4.2),('14598','2013-05-10','15:25:00',3.16),('14598','2013-05-10','15:30:00',2.83),('14598','2013-05-10','15:35:00',3.21),('14598','2013-05-10','15:40:00',5.32),('14598','2013-05-10','15:45:00',3.59),('14598','2013-05-10','15:50:00',2.41),('14598','2013-05-10','15:55:00',1.95),('14598','2013-05-10','16:00:00',1.74),('14598','2013-05-10','16:05:00',1.74),('14598','2013-05-10','16:10:00',1.57),('14598','2013-05-10','16:15:00',1.37),('14598','2013-05-10','16:20:00',1.41),('14598','2013-05-10','16:25:00',1.7),('14598','2013-05-10','16:30:00',2.02),('14598','2013-05-10','16:35:00',2.08),('14598','2013-05-10','16:40:00',2.62),('14598','2013-05-10','16:45:00',2.94),('14598','2013-05-10','16:50:00',3.66),('14598','2013-05-10','16:55:00',3.38),('14598','2013-05-10','17:00:00',2.93),('14598','2013-05-10','17:05:00',2.94),('14598','2013-05-10','17:10:00',2.59),('14598','2013-05-10','17:15:00',2.08),('14598','2013-05-10','17:20:00',1.72),('14598','2013-05-10','17:25:00',1.47),('14598','2013-05-10','17:30:00',1.38),('14598','2013-05-10','17:35:00',1.35),('14598','2013-05-10','17:40:00',1.23),('14598','2013-05-10','17:45:00',1.05),('14598','2013-05-10','17:50:00',1),('14598','2013-05-09','08:00:00',1.02),('14598','2013-05-09','08:05:00',1.12),('14598','2013-05-09','08:10:00',1.22),('14598','2013-05-09','08:15:00',1.34),('14598','2013-05-09','08:20:00',1.45),('14598','2013-05-09','08:25:00',1.55),('14598','2013-05-09','08:30:00',1.66),('14598','2013-05-09','08:35:00',1.8),('14598','2013-05-09','08:40:00',1.9),('14598','2013-05-09','08:45:00',1.99),('14598','2013-05-09','08:50:00',2.1),('14598','2013-05-09','08:55:00',2.21),('14598','2013-05-09','09:00:00',2.33),('14598','2013-05-09','09:05:00',2.43),('14598','2013-05-09','09:10:00',2.53),('14598','2013-05-09','09:15:00',2.64),('14598','2013-05-09','09:20:00',2.73),('14598','2013-05-09','09:25:00',2.82),('14598','2013-05-09','09:30:00',2.91),('14598','2013-05-09','09:35:00',2.99),('14598','2013-05-09','09:40:00',3.07),('14598','2013-05-09','09:45:00',3.17),('14598','2013-05-09','09:50:00',3.24),('14598','2013-05-09','09:55:00',3.3),('14598','2013-05-09','10:00:00',3.34),('14598','2013-05-09','10:05:00',3.41),('14598','2013-05-09','10:10:00',3.5),('14598','2013-05-09','10:15:00',3.57),('14598','2013-05-09','10:20:00',3.66),('14598','2013-05-09','10:25:00',3.71),('14598','2013-05-09','10:30:00',3.75),('14598','2013-05-09','10:35:00',3.83),('14598','2013-05-09','10:40:00',3.9),('14598','2013-05-09','10:45:00',3.95),('14598','2013-05-09','10:50:00',3.99),('14598','2013-05-09','10:55:00',3.96),('14598','2013-05-09','11:00:00',4.11),('14598','2013-05-09','11:05:00',4.16),('14598','2013-05-09','11:10:00',4.23),('14598','2013-05-09','11:15:00',4.29),('14598','2013-05-09','11:20:00',4.31),('14598','2013-05-09','11:25:00',4.34),('14598','2013-05-09','11:30:00',4.4),('14598','2013-05-09','11:35:00',4.47),('14598','2013-05-09','11:40:00',4.64),('14598','2013-05-09','11:45:00',4.71),('14598','2013-05-09','11:50:00',4.79),('14598','2013-05-09','11:55:00',4.82),('14598','2013-05-09','12:00:00',4.87),('14598','2013-05-09','12:05:00',4.9),('14598','2013-05-09','12:10:00',4.94),('14598','2013-05-09','12:15:00',4.99),('14598','2013-05-09','12:20:00',5.02),('14598','2013-05-09','12:25:00',5.06),('14598','2013-05-09','12:30:00',5.09),('14598','2013-05-09','12:35:00',5.07),('14598','2013-05-09','12:40:00',5.06),('14598','2013-05-09','12:45:00',5.16),('14598','2013-05-09','12:50:00',5.18),('14598','2013-05-09','12:55:00',5.19),('14598','2013-05-09','13:00:00',5.23),('14598','2013-05-09','13:05:00',5.25),('14598','2013-05-09','13:10:00',5.28),('14598','2013-05-09','13:15:00',5.3),('14598','2013-05-09','13:20:00',5.31),('14598','2013-05-09','13:25:00',5.33),('14598','2013-05-09','13:30:00',5.35),('14598','2013-05-09','13:35:00',5.32),('14598','2013-05-09','13:40:00',5.28),('14598','2013-05-09','13:45:00',5.31),('14598','2013-05-09','13:50:00',5.31),('14598','2013-05-09','13:55:00',5.25),('14598','2013-05-09','14:00:00',5.29),('14598','2013-05-09','14:05:00',5.28),('14598','2013-05-09','14:10:00',5.26),('14598','2013-05-09','14:15:00',5.25),('14598','2013-05-09','14:20:00',5.25),('14598','2013-05-09','14:25:00',5.19),('14598','2013-05-09','14:30:00',5.2),('14598','2013-05-09','14:35:00',5.16),('14598','2013-05-09','14:40:00',5.14),('14598','2013-05-09','14:45:00',5.11),('14598','2013-05-09','14:50:00',5.11),('14598','2013-05-09','14:55:00',5.1),('14598','2013-05-09','15:00:00',5.05),('14598','2013-05-09','15:05:00',5.01),('14598','2013-05-09','15:10:00',4.96),('14598','2013-05-09','15:15:00',4.93),('14598','2013-05-09','15:20:00',4.87),('14598','2013-05-09','15:25:00',4.83),('14598','2013-05-09','15:30:00',4.79),('14598','2013-05-09','15:35:00',4.76),('14598','2013-05-09','15:40:00',4.69),('14598','2013-05-09','15:45:00',4.65),('14598','2013-05-09','15:50:00',4.6),('14598','2013-05-09','15:55:00',4.55),('14598','2013-05-09','16:00:00',4.5),('14598','2013-05-09','16:05:00',4.41),('14598','2013-05-09','16:10:00',4.35),('14598','2013-05-09','16:15:00',4.28),('14598','2013-05-09','16:20:00',4.23),('14598','2013-05-09','16:25:00',4.18),('14598','2013-05-09','16:30:00',4.11),('14598','2013-05-09','16:35:00',4.02),('14598','2013-05-09','16:40:00',3.95),('14598','2013-05-09','16:45:00',3.86),('14598','2013-05-09','16:50:00',3.79),('14598','2013-05-09','16:55:00',3.72),('14598','2013-05-09','17:00:00',3.62),('14598','2013-05-09','17:05:00',3.53),('14598','2013-05-09','17:10:00',3.46),('14598','2013-05-09','17:15:00',3.37),('14598','2013-05-09','17:20:00',3.3),('14598','2013-05-09','17:25:00',3.19),('14598','2013-05-09','17:30:00',3.08),('14598','2013-05-09','17:35:00',2.99),('14598','2013-05-09','17:40:00',2.91),('14598','2013-05-09','17:45:00',2.81),('14598','2013-05-09','17:50:00',2.71),('14598','2013-05-09','17:55:00',2.6),('14598','2013-05-09','18:00:00',2.51),('14598','2013-05-09','18:05:00',2.4),('14598','2013-05-09','18:10:00',2.28),('14598','2013-05-09','18:15:00',2.17),('14598','2013-05-09','18:20:00',2.05),('14598','2013-05-09','18:25:00',1.93),('14598','2013-05-09','18:30:00',1.83),('14598','2013-05-09','18:35:00',1.72),('14598','2013-05-09','18:40:00',1.62),('14598','2013-05-09','18:45:00',1.49),('14598','2013-05-09','18:50:00',1.37),('14598','2013-05-09','18:55:00',1.21),('14598','2013-05-09','19:00:00',1.15),('14598','2013-05-08','08:00:00',1.01),('14598','2013-05-08','08:05:00',1.09),('14598','2013-05-08','08:10:00',1.18),('14598','2013-05-08','08:15:00',1.29),('14598','2013-05-08','08:20:00',1.4),('14598','2013-05-08','08:25:00',1.49),('14598','2013-05-08','08:30:00',1.62),('14598','2013-05-08','08:35:00',1.74),('14598','2013-05-08','08:40:00',1.87),('14598','2013-05-08','08:45:00',2.05),('14598','2013-05-08','08:50:00',2.33),('14598','2013-05-08','08:55:00',1.92),('14598','2013-05-08','09:00:00',2.05),('14598','2013-05-08','09:05:00',2.96),('14598','2013-05-08','09:10:00',2.76),('14598','2013-05-08','09:15:00',2.71),('14598','2013-05-08','09:20:00',2.81),('14598','2013-05-08','09:25:00',2.94),('14598','2013-05-08','09:30:00',2.96),('14598','2013-05-08','09:35:00',2.77),('14598','2013-05-08','09:40:00',2.81),('14598','2013-05-08','09:45:00',3.24),('14598','2013-05-08','09:50:00',3.3),('14598','2013-05-08','09:55:00',3.37),('14598','2013-05-08','10:00:00',3.44),('14598','2013-05-08','10:05:00',3.53),('14598','2013-05-08','10:10:00',3.61),('14598','2013-05-08','10:15:00',3.68),('14598','2013-05-08','10:20:00',3.76),('14598','2013-05-08','10:25:00',3.85),('14598','2013-05-08','10:30:00',3.91),('14598','2013-05-08','10:35:00',3.97),('14598','2013-05-08','10:40:00',4.04),('14598','2013-05-08','10:45:00',4.13),('14598','2013-05-08','10:50:00',4.18),('14598','2013-05-08','10:55:00',4.23),('14598','2013-05-08','11:00:00',4.3),('14598','2013-05-08','11:05:00',4.34),('14598','2013-05-08','11:10:00',4.42),('14598','2013-05-08','11:15:00',4.44),('14598','2013-05-08','11:20:00',4.56),('14598','2013-05-08','11:25:00',4.62),('14598','2013-05-08','11:30:00',4.68),('14598','2013-05-08','11:35:00',4.71),('14598','2013-05-08','11:40:00',4.76),('14598','2013-05-08','11:45:00',4.79),('14598','2013-05-08','11:50:00',4.83),('14598','2013-05-08','11:55:00',4.86),('14598','2013-05-08','12:00:00',4.91),('14598','2013-05-08','12:05:00',4.96),('14598','2013-05-08','12:10:00',4.99),('14598','2013-05-08','12:15:00',5.02),('14598','2013-05-08','12:20:00',5.04),('14598','2013-05-08','12:25:00',5.08),('14598','2013-05-08','12:30:00',5.13),('14598','2013-05-08','12:35:00',5.16),('14598','2013-05-08','12:40:00',5.16),('14598','2013-05-08','12:45:00',5.17),('14598','2013-05-08','12:50:00',5.22),('14598','2013-05-08','12:55:00',5.24),('14598','2013-05-08','13:00:00',5.23),('14598','2013-05-08','13:05:00',5.24),('14598','2013-05-08','13:10:00',5.25),('14598','2013-05-08','13:15:00',5.28),('14598','2013-05-08','13:20:00',5.29),('14598','2013-05-08','13:25:00',5.3),('14598','2013-05-08','13:30:00',5.29),('14598','2013-05-08','13:35:00',5.29),('14598','2013-05-08','13:40:00',5.28),('14598','2013-05-08','13:45:00',5.3),('14598','2013-05-08','13:50:00',5.31),('14598','2013-05-08','13:55:00',5.31),('14598','2013-05-08','14:00:00',5.29),('14598','2013-05-08','14:05:00',5.27),('14598','2013-05-08','14:10:00',5.27),('14598','2013-05-08','14:15:00',5.22),('14598','2013-05-08','14:20:00',5.23),('14598','2013-05-08','14:25:00',5.22),('14598','2013-05-08','14:30:00',5.18),('14598','2013-05-08','14:35:00',5.13),('14598','2013-05-08','14:40:00',5.11),('14598','2013-05-08','14:45:00',5.08),('14598','2013-05-08','14:50:00',5.04),('14598','2013-05-08','14:55:00',5.02),('14598','2013-05-08','15:00:00',4.98),('14598','2013-05-08','15:05:00',4.96),('14598','2013-05-08','15:10:00',4.93),('14598','2013-05-08','15:15:00',4.88),('14598','2013-05-08','15:20:00',4.81),('14598','2013-05-08','15:25:00',4.75),('14598','2013-05-08','15:30:00',4.7),('14598','2013-05-08','15:35:00',4.68),('14598','2013-05-08','15:40:00',4.63),('14598','2013-05-08','15:45:00',4.57),('14598','2013-05-08','15:50:00',4.52),('14598','2013-05-08','15:55:00',4.47),('14598','2013-05-08','16:00:00',4.41),('14598','2013-05-08','16:05:00',4.36),('14598','2013-05-08','16:10:00',4.31),('14598','2013-05-08','16:15:00',4.24),('14598','2013-05-08','16:20:00',3.97),('14598','2013-05-08','16:25:00',4.09),('14598','2013-05-08','16:30:00',3.04),('14598','2013-05-08','16:35:00',2.2),('14598','2013-05-08','16:40:00',3.07),('14598','2013-05-08','16:45:00',2.74),('14598','2013-05-08','16:50:00',2.15),('14598','2013-05-08','16:55:00',1.86),('14598','2013-05-08','17:00:00',2.14),('14598','2013-05-08','17:05:00',2.65),('14598','2013-05-08','17:10:00',3.14),('14598','2013-05-08','17:15:00',3.3),('14598','2013-05-08','17:20:00',3.2),('14598','2013-05-08','17:25:00',3.28),('14598','2013-05-08','17:30:00',3.05),('14598','2013-05-08','17:35:00',2.87),('14598','2013-05-08','17:40:00',2.68),('14598','2013-05-08','17:45:00',2.52),('14598','2013-05-08','17:50:00',2.14),('14598','2013-05-08','17:55:00',2.75),('14598','2013-05-08','18:00:00',1.01),('14598','2013-05-08','18:25:00',1.09),('14598','2013-05-08','18:30:00',1.53),('14598','2013-05-08','18:35:00',1.08),('14598','2013-05-08','18:45:00',1.37),('14598','2013-05-08','18:50:00',1.54),('14598','2013-05-08','18:55:00',1.39),('14598','2013-05-08','19:00:00',1.23),('14598','2013-05-07','08:00:00',1.03),('14598','2013-05-07','08:06:00',1.12),('14598','2013-05-07','08:10:00',1.23),('14598','2013-05-07','08:15:00',1.32),('14598','2013-05-07','08:20:00',1.45),('14598','2013-05-07','08:25:00',1.58),('14598','2013-05-07','08:30:00',1.68),('14598','2013-05-07','08:36:00',1.81),('14598','2013-05-07','08:40:00',1.94),('14598','2013-05-07','08:45:00',2.02),('14598','2013-05-07','08:50:00',2.25),('14598','2013-05-07','08:55:00',2.29),('14598','2013-05-07','09:00:00',2.43),('14598','2013-05-07','09:07:00',1.33),('14598','2013-05-07','09:30:00',2.16),('14598','2013-05-07','09:37:00',3.18),('14598','2013-05-07','09:40:00',1.85),('14598','2013-05-07','09:55:00',2.01),('14598','2013-05-07','10:00:00',3.73),('14598','2013-05-07','10:05:00',3.69),('14598','2013-05-07','10:10:00',3.74),('14598','2013-05-07','10:15:00',3.79),('14598','2013-05-07','10:20:00',3.78),('14598','2013-05-07','10:25:00',3.86),('14598','2013-05-07','10:30:00',3.94),('14598','2013-05-07','10:35:00',3.98),('14598','2013-05-07','10:40:00',4.08),('14598','2013-05-07','10:45:00',4.17),('14598','2013-05-07','10:50:00',4.27),('14598','2013-05-07','10:55:00',4.35),('14598','2013-05-07','11:00:00',4.37),('14598','2013-05-07','11:05:00',4.46),('14598','2013-05-07','11:10:00',4.51),('14598','2013-05-07','11:15:00',4.57),('14598','2013-05-07','11:20:00',4.61),('14598','2013-05-07','11:25:00',4.65),('14598','2013-05-07','11:30:00',4.74),('14598','2013-05-07','11:35:00',4.81),('14598','2013-05-07','11:40:00',4.87),('14598','2013-05-07','11:45:00',4.92),('14598','2013-05-07','11:50:00',4.98),('14598','2013-05-07','11:55:00',5),('14598','2013-05-07','12:00:00',5.2),('14598','2013-05-07','12:05:00',4.46),('14598','2013-05-07','12:10:00',4.08),('14598','2013-05-07','12:15:00',4.19),('14598','2013-05-07','12:20:00',4.63),('14598','2013-05-07','12:25:00',4.63),('14598','2013-05-07','12:30:00',4.71),('14598','2013-05-07','12:35:00',4.64),('14598','2013-05-07','12:40:00',4.46),('14598','2013-05-07','12:45:00',4.05),('14598','2013-05-07','12:50:00',3.73),('14598','2013-05-07','12:55:00',4.53),('14598','2013-05-07','13:00:00',5.16),('14598','2013-05-07','13:05:00',4.79),('14598','2013-05-07','13:10:00',4.64),('14598','2013-05-07','13:15:00',5.44),('14598','2013-05-07','13:20:00',5.46),('14598','2013-05-07','13:25:00',5.41),('14598','2013-05-07','13:30:00',5.45),('14598','2013-05-07','13:35:00',5.07),('14598','2013-05-07','13:40:00',5.44),('14598','2013-05-07','13:45:00',5.7),('14598','2013-05-07','13:50:00',5.28),('14598','2013-05-07','13:55:00',5.23),('14598','2013-05-07','14:00:00',5.6),('14598','2013-05-07','14:05:00',5.21),('14598','2013-05-07','14:10:00',5.41),('14598','2013-05-07','14:15:00',4.59),('14598','2013-05-07','14:20:00',5.48),('14598','2013-05-07','14:25:00',4.76),('14598','2013-05-07','14:30:00',5.1),('14598','2013-05-07','14:35:00',5.29),('14598','2013-05-07','14:40:00',5.28),('14598','2013-05-07','14:45:00',5.13),('14598','2013-05-07','14:50:00',5.11),('14598','2013-05-07','14:55:00',4.86),('14598','2013-05-07','15:00:00',4.61),('14598','2013-05-07','15:05:00',4.08),('14598','2013-05-07','15:10:00',5.08),('14598','2013-05-07','15:15:00',4.59),('14598','2013-05-07','15:20:00',5.09),('14598','2013-05-07','15:25:00',5.06),('14598','2013-05-07','15:30:00',4.19),('14598','2013-05-07','15:35:00',4.2),('14598','2013-05-07','15:40:00',4.05),('14598','2013-05-07','15:45:00',2.81),('14598','2013-05-07','15:50:00',2.42),('14598','2013-05-07','15:55:00',4.01),('14598','2013-05-07','16:00:00',3.45),('14598','2013-05-07','16:05:00',1.68),('14598','2013-05-07','16:10:00',1.9),('14598','2013-05-07','16:15:00',2.78),('14598','2013-05-07','16:20:00',4.36),('14598','2013-05-07','16:25:00',4.47),('14598','2013-05-07','16:30:00',2.88),('14598','2013-05-07','16:35:00',2.1),('14598','2013-05-07','16:40:00',1.69),('14598','2013-05-07','16:45:00',1.61),('14598','2013-05-07','16:50:00',1.82),('14598','2013-05-07','16:55:00',2.68),('14598','2013-05-07','17:00:00',2.07),('14598','2013-05-07','17:05:00',1.68),('14598','2013-05-07','17:10:00',1.34),('14598','2013-05-07','17:15:00',1.35),('14598','2013-05-07','17:20:00',1.35),('14598','2013-05-07','17:25:00',1.28),('14598','2013-05-07','17:30:00',1.01),('14598','2013-05-07','18:10:00',1.4),('14598','2013-05-07','18:15:00',2.41),('14598','2013-05-07','18:20:00',2.14),('14598','2013-05-07','18:25:00',1.44),('14598','2013-05-07','18:30:00',1.75),('14598','2013-05-07','18:35:00',1.22),('14598','2013-05-06','09:00:00',1.17),('14598','2013-05-06','09:05:00',1.49),('14598','2013-05-06','09:40:00',1.89),('14598','2013-05-06','09:45:00',3.23),('14598','2013-05-06','09:50:00',2.13),('14598','2013-05-06','09:55:00',2.18),('14598','2013-05-06','10:00:00',2.28),('14598','2013-05-06','10:05:00',2),('14598','2013-05-06','10:10:00',1.16),('14598','2013-05-06','10:15:00',1.24),('14598','2013-05-06','10:20:00',1.38),('14598','2013-05-06','10:25:00',1.44),('14598','2013-05-06','10:30:00',1.77),('14598','2013-05-06','10:35:00',2.61),('14598','2013-05-06','10:40:00',2.82),('14598','2013-05-06','10:45:00',2.6),('14598','2013-05-06','10:50:00',2.48),('14598','2013-05-06','10:55:00',3.6),('14598','2013-05-06','11:00:00',4.51),('14598','2013-05-06','11:05:00',4.35),('14598','2013-05-06','11:10:00',4),('14598','2013-05-06','11:15:00',4.64),('14598','2013-05-06','11:20:00',3.66),('14598','2013-05-06','11:25:00',4.66),('14598','2013-05-06','11:30:00',4.74),('14598','2013-05-06','11:35:00',4.75),('14598','2013-05-06','11:40:00',4.81),('14598','2013-05-06','11:45:00',4.83),('14598','2013-05-06','11:50:00',4.82),('14598','2013-05-06','11:55:00',4.94),('14598','2013-05-06','12:00:00',4.92),('14598','2013-05-06','12:05:00',4.94),('14598','2013-05-06','12:10:00',4.96),('14598','2013-05-06','12:15:00',5),('14598','2013-05-06','12:20:00',5.03),('14598','2013-05-06','12:25:00',5.06),('14598','2013-05-06','12:30:00',5.09),('14598','2013-05-06','12:35:00',5.13),('14598','2013-05-06','12:40:00',5.17),('14598','2013-05-06','12:45:00',5.19),('14598','2013-05-06','12:50:00',5.24),('14598','2013-05-06','12:55:00',5.24),('14598','2013-05-06','13:00:00',5.26),('14598','2013-05-06','13:05:00',5.24),('14598','2013-05-06','13:10:00',5.01),('14598','2013-05-06','13:15:00',5.28),('14598','2013-05-06','13:20:00',5.42),('14598','2013-05-06','13:25:00',5.2),('14598','2013-05-06','13:30:00',4.89),('14598','2013-05-06','13:35:00',4.29),('14598','2013-05-06','13:40:00',3.32),('14598','2013-05-06','13:45:00',2.81),('14598','2013-05-06','13:50:00',4.9),('14598','2013-05-06','13:55:00',3.96),('14598','2013-05-06','14:00:00',3.83),('14598','2013-05-06','14:05:00',5.73),('14598','2013-05-06','14:10:00',5.49),('14598','2013-05-06','14:15:00',4.53),('14598','2013-05-06','14:20:00',4.97),('14598','2013-05-06','14:25:00',5.31),('14598','2013-05-06','14:30:00',5.12),('14598','2013-05-06','14:35:00',5.4),('14598','2013-05-06','14:40:00',4.56),('14598','2013-05-06','14:45:00',4.7),('14598','2013-05-06','14:50:00',4.08),('14598','2013-05-06','14:55:00',3.56),('14598','2013-05-06','15:00:00',5.26),('14598','2013-05-06','15:05:00',5.06),('14598','2013-05-06','15:10:00',5.02),('14598','2013-05-06','15:15:00',4.8),('14598','2013-05-06','15:20:00',4.28),('14598','2013-05-06','15:25:00',3.57),('14598','2013-05-06','15:30:00',5.37),('14598','2013-05-06','15:35:00',3.38),('14598','2013-05-06','15:40:00',4.25),('14598','2013-05-06','15:45:00',4.67),('14598','2013-05-06','15:50:00',4.16),('14598','2013-05-06','15:55:00',4.38),('14598','2013-05-06','16:00:00',4.71),('14598','2013-05-06','16:05:00',4.36),('14598','2013-05-06','16:10:00',2.59),('14598','2013-05-06','16:15:00',3.08),('14598','2013-05-06','16:20:00',1.9),('14598','2013-05-06','16:25:00',2.55),('14598','2013-05-06','16:30:00',1.96),('14598','2013-05-06','16:35:00',2.57),('14598','2013-05-06','16:40:00',2.26),('14598','2013-05-06','16:45:00',1.78),('14598','2013-05-06','16:50:00',2.1),('14598','2013-05-06','16:55:00',3.33),('14598','2013-05-06','17:00:00',3.31),('14598','2013-05-06','17:05:00',3.4),('14598','2013-05-06','17:10:00',3.62),('14598','2013-05-06','17:15:00',2.75),('14598','2013-05-06','17:20:00',2.08),('14598','2013-05-06','17:25:00',4.02),('14598','2013-05-06','17:30:00',3.49),('14598','2013-05-06','17:35:00',3.52),('14598','2013-05-06','17:40:00',1.74),('14598','2013-05-06','17:45:00',1.76),('14598','2013-05-06','17:50:00',2.93),('14598','2013-05-06','17:55:00',2.48),('14598','2013-05-06','18:00:00',2.83),('14598','2013-05-06','18:05:00',2.76),('14598','2013-05-06','18:10:00',2.63),('14598','2013-05-06','18:15:00',1.08),('14598','2013-05-06','18:20:00',1.04),('14598','2013-05-06','18:25:00',1.65),('14598','2013-05-06','18:30:00',1.26),('14598','2013-05-05','07:55:00',1.19),('14598','2013-05-05','08:00:00',1.07),('14598','2013-05-05','08:07:00',1.52),('14598','2013-05-05','08:10:00',1.77),('14598','2013-05-05','08:15:00',1.7),('14598','2013-05-05','08:20:00',1.38),('14598','2013-05-05','08:25:00',1.26),('14598','2013-05-05','08:30:00',1.13),('14598','2013-05-05','08:50:00',1.15),('14598','2013-05-05','08:55:00',1.39),('14598','2013-05-05','09:00:00',1.57),('14598','2013-05-05','09:05:00',1.78),('14598','2013-05-05','09:10:00',1.42),('14598','2013-05-05','09:15:00',1.89),('14598','2013-05-05','09:20:00',1.46),('14598','2013-05-05','09:25:00',2.56),('14598','2013-05-05','09:30:00',2.95),('14598','2013-05-05','09:35:00',2.98),('14598','2013-05-05','09:40:00',3.36),('14598','2013-05-05','09:45:00',2.75),('14598','2013-05-05','09:50:00',3.58),('14598','2013-05-05','09:55:00',2.5),('14598','2013-05-05','10:00:00',2.1),('14598','2013-05-05','10:05:00',1.94),('14598','2013-05-05','10:10:00',1.32),('14598','2013-05-05','10:15:00',1.4),('14598','2013-05-05','10:20:00',1.75),('14598','2013-05-05','10:25:00',2.29),('14598','2013-05-05','10:30:00',3.12),('14598','2013-05-05','10:35:00',4.14),('14598','2013-05-05','10:40:00',4.01),('14598','2013-05-05','10:45:00',2.93),('14598','2013-05-05','10:50:00',3.95),('14598','2013-05-05','10:55:00',4.15),('14598','2013-05-05','11:00:00',3.6),('14598','2013-05-05','11:05:00',4.29),('14598','2013-05-05','11:10:00',4.77),('14598','2013-05-05','11:15:00',4.71),('14598','2013-05-05','11:20:00',4.65),('14598','2013-05-05','11:25:00',4.45),('14598','2013-05-05','11:30:00',4.74),('14598','2013-05-05','11:35:00',3.97),('14598','2013-05-05','11:40:00',3.97),('14598','2013-05-05','11:45:00',2.76),('14598','2013-05-05','11:50:00',3.19),('14598','2013-05-05','11:55:00',3.8),('14598','2013-05-05','12:00:00',2.17),('14598','2013-05-05','12:05:00',1.46),('14598','2013-05-05','12:10:00',1.18),('14598','2013-05-05','12:15:00',1.77),('14598','2013-05-05','12:20:00',2.07),('14598','2013-05-05','12:25:00',1.92),('14598','2013-05-05','12:30:00',1.64),('14598','2013-05-05','12:35:00',2.58),('14598','2013-05-05','12:40:00',4.85),('14598','2013-05-05','12:45:00',4.74),('14598','2013-05-05','12:50:00',3.69),('14598','2013-05-05','12:55:00',3.97),('14598','2013-05-05','13:00:00',4.8),('14598','2013-05-05','13:05:00',5.1),('14598','2013-05-05','13:10:00',4.89),('14598','2013-05-05','13:15:00',3.4),('14598','2013-05-05','13:20:00',2.8),('14598','2013-05-05','13:25:00',2.8),('14598','2013-05-05','13:30:00',5.24),('14598','2013-05-05','13:35:00',4.67),('14598','2013-05-05','13:40:00',4.76),('14598','2013-05-05','13:45:00',5.3),('14598','2013-05-05','13:50:00',5.21),('14598','2013-05-05','13:55:00',5.16),('14598','2013-05-05','14:00:00',5.13),('14598','2013-05-05','14:05:00',5.01),('14598','2013-05-05','14:10:00',5.08),('14598','2013-05-05','14:15:00',5.03),('14598','2013-05-05','14:20:00',5.03),('14598','2013-05-05','14:25:00',4.99),('14598','2013-05-05','14:30:00',4.96),('14598','2013-05-05','14:35:00',4.94),('14598','2013-05-05','14:40:00',4.92),('14598','2013-05-05','14:45:00',4.79),('14598','2013-05-05','14:50:00',4.88),('14598','2013-05-05','14:55:00',4.84),('14598','2013-05-05','15:00:00',4.76),('14598','2013-05-05','15:05:00',4.71),('14598','2013-05-05','15:10:00',4.69),('14598','2013-05-05','15:15:00',4.66),('14598','2013-05-05','15:20:00',4.61),('14598','2013-05-05','15:25:00',4.54),('14598','2013-05-05','15:30:00',4.51),('14598','2013-05-05','15:35:00',4.45),('14598','2013-05-05','15:40:00',4.41),('14598','2013-05-05','15:45:00',4.35),('14598','2013-05-05','15:50:00',4.28),('14598','2013-05-05','15:55:00',4.2),('14598','2013-05-05','16:00:00',4.16),('14598','2013-05-05','16:05:00',4.1),('14598','2013-05-05','16:10:00',4.05),('14598','2013-05-05','16:15:00',3.99),('14598','2013-05-05','16:20:00',3.92),('14598','2013-05-05','16:25:00',3.86),('14598','2013-05-05','16:30:00',3.78),('14598','2013-05-05','16:35:00',3.7),('14598','2013-05-05','16:40:00',3.65),('14598','2013-05-05','16:45:00',3.56),('14598','2013-05-05','16:50:00',3.5),('14598','2013-05-05','16:55:00',3.45),('14598','2013-05-05','17:00:00',3.37),('14598','2013-05-05','17:05:00',3.28),('14598','2013-05-05','17:10:00',3.16),('14598','2013-05-05','17:15:00',3.09),('14598','2013-05-05','17:20:00',2.99),('14598','2013-05-05','17:25:00',2.89),('14598','2013-05-05','17:30:00',2.8),('14598','2013-05-05','17:35:00',2.71),('14598','2013-05-05','17:40:00',2.49),('14598','2013-05-05','17:45:00',2.48),('14598','2013-05-05','17:50:00',2.39),('14598','2013-05-05','17:55:00',2.29),('14598','2013-05-05','18:00:00',2.2),('14598','2013-05-05','18:05:00',2.09),('14598','2013-05-05','18:11:00',2),('14598','2013-05-05','18:15:00',1.89),('14598','2013-05-05','18:20:00',1.77),('14598','2013-05-05','18:25:00',1.63),('14598','2013-05-05','18:30:00',1.54),('14598','2013-05-05','18:35:00',1.44),('14598','2013-05-05','18:41:00',1.34),('14598','2013-05-05','18:45:00',1.21),('14598','2013-05-05','18:50:00',1.12),('14598','2013-05-05','18:55:00',1.02),('14598','2013-05-04','08:05:00',1.07),('14598','2013-05-04','08:10:00',1.25),('14598','2013-05-04','08:15:00',1.33),('14598','2013-05-04','08:20:00',1.39),('14598','2013-05-04','08:25:00',1.43),('14598','2013-05-04','08:30:00',1.56),('14598','2013-05-04','08:35:00',1.79),('14598','2013-05-04','08:40:00',1.98),('14598','2013-05-04','08:45:00',2.15),('14598','2013-05-04','08:50:00',2.34),('14598','2013-05-04','08:55:00',2.43),('14598','2013-05-04','09:00:00',2.4),('14598','2013-05-04','09:05:00',2.48),('14598','2013-05-04','09:10:00',2.38),('14598','2013-05-04','09:15:00',2.38),('14598','2013-05-04','09:20:00',2.4),('14598','2013-05-04','09:25:00',2.48),('14598','2013-05-04','09:30:00',2.67),('14598','2013-05-04','09:35:00',2.81),('14598','2013-05-04','09:40:00',2.58),('14598','2013-05-04','09:45:00',2.54),('14598','2013-05-04','09:50:00',2.89),('14598','2013-05-04','09:55:00',2.38),('14598','2013-05-04','10:00:00',3.13),('14598','2013-05-04','10:05:00',3.18),('14598','2013-05-04','10:10:00',3.22),('14598','2013-05-04','10:15:00',3.12),('14598','2013-05-04','10:20:00',3.27),('14598','2013-05-04','10:25:00',3.43),('14598','2013-05-04','10:30:00',3.43),('14598','2013-05-04','10:35:00',3.55),('14598','2013-05-04','10:40:00',3.61),('14598','2013-05-04','10:45:00',3.67),('14598','2013-05-04','10:50:00',3.75),('14598','2013-05-04','10:55:00',3.85),('14598','2013-05-04','11:00:00',3.9),('14598','2013-05-04','11:05:00',3.75),('14598','2013-05-04','11:10:00',3.6),('14598','2013-05-04','11:15:00',3.97),('14598','2013-05-04','11:20:00',4.01),('14598','2013-05-04','11:25:00',3.82),('14598','2013-05-04','11:30:00',3.88),('14598','2013-05-04','11:35:00',4.08),('14598','2013-05-04','11:40:00',4.18),('14598','2013-05-04','11:45:00',4.13),('14598','2013-05-04','11:50:00',4.12),('14598','2013-05-04','11:55:00',4.15),('14598','2013-05-04','12:00:00',4.12),('14598','2013-05-04','12:05:00',4.12),('14598','2013-05-04','12:10:00',4.19),('14598','2013-05-04','12:15:00',4.35),('14598','2013-05-04','12:20:00',4.42),('14598','2013-05-04','12:25:00',4.58),('14598','2013-05-04','12:30:00',4.56),('14598','2013-05-04','12:35:00',4.67),('14598','2013-05-04','12:40:00',4.59),('14598','2013-05-04','12:45:00',4.49),('14598','2013-05-04','12:50:00',4.58),('14598','2013-05-04','12:55:00',4.57),('14598','2013-05-04','13:00:00',4.63),('14598','2013-05-04','13:05:00',4.79),('14598','2013-05-04','13:10:00',4.71),('14598','2013-05-04','13:15:00',4.68),('14598','2013-05-04','13:20:00',4.66),('14598','2013-05-04','13:25:00',4.76),('14598','2013-05-04','13:30:00',4.47),('14598','2013-05-04','13:35:00',4.3),('14598','2013-05-04','13:40:00',4.23),('14598','2013-05-04','13:45:00',4.22),('14598','2013-05-04','13:50:00',4.53),('14598','2013-05-04','13:55:00',4.66),('14598','2013-05-04','14:00:00',4.58),('14598','2013-05-04','14:05:00',4.11),('14598','2013-05-04','14:10:00',4.39),('14598','2013-05-04','14:15:00',4.35),('14598','2013-05-04','14:20:00',4.29),('14598','2013-05-04','14:25:00',4.3),('14598','2013-05-04','14:30:00',3.8),('14598','2013-05-04','14:35:00',3.97),('14598','2013-05-04','14:40:00',3.91),('14598','2013-05-04','14:45:00',4.07),('14598','2013-05-04','14:50:00',4.15),('14598','2013-05-04','14:55:00',3.94),('14598','2013-05-04','15:00:00',4.14),('14598','2013-05-04','15:05:00',4.24),('14598','2013-05-04','15:10:00',4.04),('14598','2013-05-04','15:15:00',4.31),('14598','2013-05-04','15:20:00',4.3),('14598','2013-05-04','15:25:00',4.14),('14598','2013-05-04','15:30:00',4.37),('14598','2013-05-04','15:35:00',4.28),('14598','2013-05-04','15:40:00',4.21),('14598','2013-05-04','15:45:00',4.12),('14598','2013-05-04','15:50:00',4.09),('14598','2013-05-04','15:55:00',4.04),('14598','2013-05-04','16:00:00',3.97),('14598','2013-05-04','16:05:00',3.92),('14598','2013-05-04','16:10:00',3.88),('14598','2013-05-04','16:15:00',3.79),('14598','2013-05-04','16:20:00',3.75),('14598','2013-05-04','16:25:00',3.68),('14598','2013-05-04','16:30:00',3.59),('14598','2013-05-04','16:35:00',3.5),('14598','2013-05-04','16:40:00',3.45),('14598','2013-05-04','16:45:00',3.37),('14598','2013-05-04','16:50:00',3.31),('14598','2013-05-04','16:55:00',3.24),('14598','2013-05-04','17:00:00',3.17),('14598','2013-05-04','17:05:00',3.11),('14598','2013-05-04','17:11:00',2.45),('14598','2013-05-04','17:15:00',2.51),('14598','2013-05-04','17:20:00',2.89),('14598','2013-05-04','17:25:00',2.75),('14598','2013-05-04','17:30:00',2.61),('14598','2013-05-04','17:35:00',2.51),('14598','2013-05-04','17:41:00',2.46),('14598','2013-05-04','17:45:00',2.34),('14598','2013-05-04','17:50:00',2.24),('14598','2013-05-04','17:55:00',2.11),('14598','2013-05-04','18:00:00',1.87),('14598','2013-05-04','18:05:00',1.92),('14598','2013-05-04','18:11:00',1.62),('14598','2013-05-04','18:15:00',1.7),('14598','2013-05-04','18:20:00',1.42),('14598','2013-05-03','08:05:00',1.01),('14598','2013-05-03','08:10:00',1.04),('14598','2013-05-03','08:20:00',1.06),('14598','2013-05-03','08:25:00',1.19),('14598','2013-05-03','08:30:00',1.37),('14598','2013-05-03','08:35:00',1.55),('14598','2013-05-03','08:40:00',1.65),('14598','2013-05-03','08:45:00',1.7),('14598','2013-05-03','08:50:00',1.7),('14598','2013-05-03','08:55:00',1.81),('14598','2013-05-03','09:00:00',2.06),('14598','2013-05-03','09:05:00',2.2),('14598','2013-05-03','09:10:00',2.28),('14598','2013-05-03','09:15:00',2.38),('14598','2013-05-03','09:20:00',2.5),('14598','2013-05-03','09:25:00',2.59),('14598','2013-05-03','09:30:00',2.65),('14598','2013-05-03','09:35:00',2.76),('14598','2013-05-03','09:40:00',2.85),('14598','2013-05-03','09:45:00',2.9),('14598','2013-05-03','09:50:00',2.99),('14598','2013-05-03','09:55:00',3.09),('14598','2013-05-03','10:00:00',3.16),('14598','2013-05-03','10:05:00',3.23),('14598','2013-05-03','10:10:00',3.3),('14598','2013-05-03','10:15:00',3.38),('14598','2013-05-03','10:20:00',3.44),('14598','2013-05-03','10:25:00',3.55),('14598','2013-05-03','10:30:00',2.71),('14598','2013-05-03','10:35:00',3.67),('14598','2013-05-03','10:40:00',3.74),('14598','2013-05-03','10:45:00',3.8),('14598','2013-05-03','10:50:00',3.86),('14598','2013-05-03','10:55:00',3.93),('14598','2013-05-03','11:00:00',3.96),('14598','2013-05-03','11:05:00',4),('14598','2013-05-03','11:10:00',4.06),('14598','2013-05-03','11:15:00',4.16),('14598','2013-05-03','11:20:00',4.21),('14598','2013-05-03','11:25:00',4.29),('14598','2013-05-03','11:30:00',4.34),('14598','2013-05-03','11:35:00',4.37),('14598','2013-05-03','11:40:00',4.39),('14598','2013-05-03','11:45:00',4.45),('14598','2013-05-03','11:50:00',4.48),('14598','2013-05-03','11:55:00',4.56),('14598','2013-05-03','12:00:00',4.62),('14598','2013-05-03','12:05:00',4.7),('14598','2013-05-03','12:10:00',4.74),('14598','2013-05-03','12:15:00',4.75),('14598','2013-05-03','12:20:00',4.75),('14598','2013-05-03','12:25:00',4.8),('14598','2013-05-03','12:30:00',4.82),('14598','2013-05-03','12:35:00',4.79),('14598','2013-05-03','12:40:00',4.87),('14598','2013-05-03','12:45:00',4.9),('14598','2013-05-03','12:50:00',4.92),('14598','2013-05-03','12:55:00',4.95),('14598','2013-05-03','13:00:00',4.95),('14598','2013-05-03','13:05:00',4.92),('14598','2013-05-03','13:10:00',4.89),('14598','2013-05-03','13:15:00',4.96),('14598','2013-05-03','13:20:00',5.01),('14598','2013-05-03','13:25:00',4.98),('14598','2013-05-03','13:30:00',4.88),('14598','2013-05-03','13:35:00',4.76),('14598','2013-05-03','13:40:00',4.83),('14598','2013-05-03','13:45:00',4.92),('14598','2013-05-03','13:50:00',4.95),('14598','2013-05-03','13:55:00',5),('14598','2013-05-03','14:00:00',4.99),('14598','2013-05-03','14:05:00',4.99),('14598','2013-05-03','14:10:00',4.93),('14598','2013-05-03','14:15:00',4.92),('14598','2013-05-03','14:20:00',4.88),('14598','2013-05-03','14:25:00',4.86),('14598','2013-05-03','14:30:00',4.82),('14598','2013-05-03','14:35:00',4.8),('14598','2013-05-03','14:40:00',4.77),('14598','2013-05-03','14:45:00',4.76),('14598','2013-05-03','14:50:00',4.7),('14598','2013-05-03','14:55:00',4.7),('14598','2013-05-03','15:00:00',4.65),('14598','2013-05-03','15:05:00',4.6),('14598','2013-05-03','15:10:00',4.59),('14598','2013-05-03','15:15:00',4.52),('14598','2013-05-03','15:20:00',4.47),('14598','2013-05-03','15:25:00',4.39),('14598','2013-05-03','15:30:00',4.35),('14598','2013-05-03','15:35:00',4.26),('14598','2013-05-03','15:40:00',4.26),('14598','2013-05-03','15:45:00',4.21),('14598','2013-05-03','15:50:00',4.18),('14598','2013-05-03','15:55:00',4.12),('14598','2013-05-03','16:00:00',4.11),('14598','2013-05-03','16:05:00',3.97),('14598','2013-05-03','16:10:00',3.76),('14598','2013-05-03','16:15:00',3.93),('14598','2013-05-03','16:20:00',3.86),('14598','2013-05-03','16:25:00',3.79),('14598','2013-05-03','16:30:00',3.72),('14598','2013-05-03','16:35:00',3.67),('14598','2013-05-03','16:40:00',3.59),('14598','2013-05-03','16:45:00',3.51),('14598','2013-05-03','16:50:00',3.43),('14598','2013-05-03','16:55:00',3.35),('14598','2013-05-03','17:00:00',3.23),('14598','2013-05-03','17:05:00',3.16),('14598','2013-05-03','17:10:00',3.08),('14598','2013-05-03','17:15:00',2.98),('14598','2013-05-03','17:20:00',2.87),('14598','2013-05-03','17:25:00',2.78),('14598','2013-05-03','17:30:00',2.65),('14598','2013-05-03','17:35:00',2.57),('14598','2013-05-03','17:40:00',2.49),('14598','2013-05-03','17:45:00',2.39),('14598','2013-05-03','17:50:00',2.29),('14598','2013-05-03','17:55:00',2.19),('14598','2013-05-03','18:00:00',2.07),('14598','2013-05-03','18:05:00',1.98),('14598','2013-05-03','18:10:00',1.88),('14598','2013-05-03','18:15:00',1.76),('14598','2013-05-03','18:20:00',1.66),('14598','2013-05-03','18:25:00',1.53),('14598','2013-05-03','18:30:00',1.38),('14598','2013-05-03','18:35:00',1.32),('14598','2013-05-03','18:40:00',1.22),('14598','2013-05-03','18:45:00',1.13),('14598','2013-05-03','18:50:00',1.03),('14598','2013-05-02','08:45:00',1.1),('14598','2013-05-02','08:50:00',1.06),('14598','2013-05-02','09:00:00',1.07),('14598','2013-05-02','09:05:00',1.92),('14598','2013-05-02','09:10:00',1.46),('14598','2013-05-02','09:15:00',1.13),('14598','2013-05-02','10:00:00',1.58),('14598','2013-05-02','10:05:00',1.95),('14598','2013-05-02','10:10:00',1.76),('14598','2013-05-02','10:15:00',2.22),('14598','2013-05-02','10:20:00',2.32),('14598','2013-05-02','10:25:00',3.01),('14598','2013-05-02','10:30:00',3.19),('14598','2013-05-02','10:35:00',4.1),('14598','2013-05-02','10:40:00',2.62),('14598','2013-05-02','10:45:00',1.87),('14598','2013-05-02','10:50:00',1.82),('14598','2013-05-02','10:55:00',1.98),('14598','2013-05-02','11:00:00',2.19),('14598','2013-05-02','11:05:00',2.92),('14598','2013-05-02','11:10:00',4.59),('14598','2013-05-02','11:15:00',3.07),('14598','2013-05-02','11:20:00',3.51),('14598','2013-05-02','11:25:00',4.7),('14598','2013-05-02','11:30:00',4.63),('14598','2013-05-02','11:35:00',4.39),('14598','2013-05-02','11:40:00',4.35),('14598','2013-05-02','11:45:00',4.38),('14598','2013-05-02','11:50:00',4.38),('14598','2013-05-02','11:55:00',4.37),('14598','2013-05-02','12:00:00',4.39),('14598','2013-05-02','12:05:00',4.42),('14598','2013-05-02','12:10:00',4.4),('14598','2013-05-02','12:15:00',4.43),('14598','2013-05-02','12:20:00',4.51),('14598','2013-05-02','12:25:00',4.66),('14598','2013-05-02','12:30:00',4.7),('14598','2013-05-02','12:35:00',4.76),('14598','2013-05-02','12:40:00',4.79),('14598','2013-05-02','12:45:00',4.84),('14598','2013-05-02','12:50:00',4.86),('14598','2013-05-02','12:55:00',4.87),('14598','2013-05-02','13:00:00',4.91),('14598','2013-05-02','13:05:00',4.96),('14598','2013-05-02','13:10:00',4.95),('14598','2013-05-02','13:15:00',4.94),('14598','2013-05-02','13:20:00',4.94),('14598','2013-05-02','13:25:00',4.91),('14598','2013-05-02','13:30:00',4.93),('14598','2013-05-02','13:35:00',4.92),('14598','2013-05-02','13:40:00',4.89),('14598','2013-05-02','13:45:00',4.87),('14598','2013-05-02','13:50:00',4.91),('14598','2013-05-02','13:55:00',4.92),('14598','2013-05-02','14:00:00',4.95),('14598','2013-05-02','14:05:00',4.94),('14598','2013-05-02','14:10:00',4.92),('14598','2013-05-02','14:15:00',4.89),('14598','2013-05-02','14:20:00',4.87),('14598','2013-05-02','14:25:00',4.82),('14598','2013-05-02','14:30:00',4.83),('14598','2013-05-02','14:35:00',4.83),('14598','2013-05-02','14:40:00',4.82),('14598','2013-05-02','14:45:00',4.79),('14598','2013-05-02','14:50:00',4.75),('14598','2013-05-02','14:55:00',4.7),('14598','2013-05-02','15:00:00',4.67),('14598','2013-05-02','15:05:00',4.64),('14598','2013-05-02','15:10:00',4.6),('14598','2013-05-02','15:15:00',4.55),('14598','2013-05-02','15:20:00',4.5),('14598','2013-05-02','15:25:00',4.41),('14598','2013-05-02','15:30:00',4.44),('14598','2013-05-02','15:35:00',4.39),('14598','2013-05-02','15:40:00',4.32),('14598','2013-05-02','15:45:00',4.27),('14598','2013-05-02','15:50:00',4.21),('14598','2013-05-02','15:55:00',4.18),('14598','2013-05-02','16:00:00',4.12),('14598','2013-05-02','16:05:00',4.06),('14598','2013-05-02','16:10:00',3.98),('14598','2013-05-02','16:15:00',3.91),('14598','2013-05-02','16:20:00',3.84),('14598','2013-05-02','16:25:00',3.79),('14598','2013-05-02','16:30:00',3.73),('14598','2013-05-02','16:35:00',3.66),('14598','2013-05-02','16:40:00',3.58),('14598','2013-05-02','16:45:00',3.49),('14598','2013-05-02','16:50:00',3.42),('14598','2013-05-02','16:55:00',3.35),('14598','2013-05-02','17:00:00',3.27),('14598','2013-05-02','17:05:00',3.18),('14598','2013-05-02','17:10:00',3.08),('14598','2013-05-02','17:15:00',3.01),('14598','2013-05-02','17:20:00',2.93),('14598','2013-05-02','17:25:00',2.83),('14598','2013-05-02','17:30:00',2.74),('14598','2013-05-02','17:35:00',2.64),('14598','2013-05-02','17:40:00',2.55),('14598','2013-05-02','17:45:00',2.45),('14598','2013-05-02','17:50:00',2.35),('14598','2013-05-02','17:55:00',2.26),('14598','2013-05-02','18:00:00',2.15),('14598','2013-05-02','18:05:00',2.04),('14598','2013-05-02','18:10:00',1.95),('14598','2013-05-02','18:15:00',1.85),('14598','2013-05-02','18:20:00',1.74),('14598','2013-05-02','18:25:00',1.62),('14598','2013-05-02','18:30:00',1.53),('14598','2013-05-02','18:35:00',1.43),('14598','2013-05-02','18:40:00',1.32),('14598','2013-05-02','18:45:00',1.21),('14598','2013-05-02','18:50:00',1.09),('14598','2014-03-30','08:40:00',1.07),('14598','2014-03-30','08:45:00',1.12),('14598','2014-03-30','08:50:00',1.23),('14598','2014-03-30','08:55:00',1.3),('14598','2014-03-30','09:00:00',1.43),('14598','2014-03-30','09:05:00',1.56),('14598','2014-03-30','09:10:00',1.67),('14598','2014-03-30','09:15:00',1.73),('14598','2014-03-30','09:20:00',1.76),('14598','2014-03-30','09:25:00',1.95),('14598','2014-03-30','09:30:00',2.2),('14598','2014-03-30','09:35:00',2.24),('14598','2014-03-30','09:40:00',2.28),('14598','2014-03-30','09:45:00',2.39),('14598','2014-03-30','09:50:00',2.4),('14598','2014-03-30','09:55:00',2.52),('14598','2014-03-30','10:00:00',2.52),('14598','2014-03-30','10:05:00',2.57),('14598','2014-03-30','10:10:00',2.69),('14598','2014-03-30','10:15:00',2.77),('14598','2014-03-30','10:20:00',2.76),('14598','2014-03-30','10:25:00',2.85),('14598','2014-03-30','10:30:00',3.03),('14598','2014-03-30','10:35:00',3.22),('14598','2014-03-30','10:40:00',3.34),('14598','2014-03-30','10:45:00',3.26),('14598','2014-03-30','10:50:00',3.36),('14598','2014-03-30','10:55:00',3.59),('14598','2014-03-30','11:00:00',3.83),('14598','2014-03-30','11:05:00',4.01),('14598','2014-03-30','11:10:00',4.04),('14598','2014-03-30','11:15:00',3.93),('14598','2014-03-30','11:20:00',3.81),('14598','2014-03-30','11:25:00',3.91),('14598','2014-03-30','11:30:00',3.84),('14598','2014-03-30','11:35:00',3.98),('14598','2014-03-30','11:40:00',4.07),('14598','2014-03-30','11:45:00',4.12),('14598','2014-03-30','11:50:00',4.17),('14598','2014-03-30','11:55:00',3.83),('14598','2014-03-30','12:00:00',3.88),('14598','2014-03-30','12:05:00',3.89),('14598','2014-03-30','12:10:00',3.95),('14598','2014-03-30','12:15:00',4.06),('14598','2014-03-30','12:20:00',4.35),('14598','2014-03-30','12:25:00',4.25),('14598','2014-03-30','12:30:00',4.24),('14598','2014-03-30','12:35:00',4.07),('14598','2014-03-30','12:40:00',4.35),('14598','2014-03-30','12:45:00',4.42),('14598','2014-03-30','12:50:00',4.42),('14598','2014-03-30','12:55:00',4.4),('14598','2014-03-30','13:00:00',4.37),('14598','2014-03-30','13:05:00',4.31),('14598','2014-03-30','13:10:00',4.54),('14598','2014-03-30','13:15:00',4.89),('14598','2014-03-30','13:20:00',5.08),('14598','2014-03-30','13:25:00',5.11),('14598','2014-03-30','13:30:00',5.13),('14598','2014-03-30','13:35:00',5.14),('14598','2014-03-30','13:40:00',5.13),('14598','2014-03-30','13:45:00',4.84),('14598','2014-03-30','13:50:00',4.5),('14598','2014-03-30','13:55:00',4.03),('14598','2014-03-30','14:00:00',4.33),('14598','2014-03-30','14:05:00',4.61),('14598','2014-03-30','14:10:00',3.9),('14598','2014-03-30','14:15:00',3.7),('14598','2014-03-30','14:20:00',4.18),('14598','2014-03-30','14:25:00',4.83),('14598','2014-03-30','14:30:00',4.91),('14598','2014-03-30','14:35:00',4.88),('14598','2014-03-30','14:40:00',4.73),('14598','2014-03-30','14:45:00',4.89),('14598','2014-03-30','14:50:00',4.75),('14598','2014-03-30','14:55:00',4.6),('14598','2014-03-30','15:00:00',4.85),('14598','2014-03-30','15:05:00',4.85),('14598','2014-03-30','15:10:00',4.98),('14598','2014-03-30','15:15:00',4.79),('14598','2014-03-30','15:20:00',4.7),('14598','2014-03-30','15:25:00',4.73),('14598','2014-03-30','15:30:00',4.57),('14598','2014-03-30','15:35:00',4.4),('14598','2014-03-30','15:40:00',4.4),('14598','2014-03-30','15:45:00',4.18),('14598','2014-03-30','15:50:00',4.04),('14598','2014-03-30','15:55:00',3.98),('14598','2014-03-30','16:00:00',4.14),('14598','2014-03-30','16:05:00',4.15),('14598','2014-03-30','16:10:00',3.91),('14598','2014-03-30','16:15:00',3.91),('14598','2014-03-30','16:20:00',3.74),('14598','2014-03-30','16:25:00',3.94),('14598','2014-03-30','16:30:00',3.79),('14598','2014-03-30','16:35:00',3.81),('14598','2014-03-30','16:40:00',3.74),('14598','2014-03-30','16:45:00',3.64),('14598','2014-03-30','16:50:00',3.56),('14598','2014-03-30','16:55:00',3.42),('14598','2014-03-30','17:00:00',3.31),('14598','2014-03-30','17:05:00',3.26),('14598','2014-03-30','17:10:00',3.14),('14598','2014-03-30','17:15:00',3.06),('14598','2014-03-30','17:20:00',2.66),('14598','2014-03-30','17:25:00',2.79),('14598','2014-03-30','17:30:00',2.7),('14598','2014-03-30','17:35:00',2.32),('14598','2014-03-30','17:40:00',2.45),('14598','2014-03-30','17:45:00',2.34),('14598','2014-03-30','17:50:00',2.21),('14598','2014-03-30','17:55:00',2.13),('14598','2014-03-30','18:00:00',1.9),('14598','2014-03-30','18:05:00',1.93),('14598','2014-03-30','18:10:00',1.71),('14598','2014-03-30','18:15:00',1.23),('14598','2013-05-01','08:10:00',1.04),('14598','2013-05-01','08:15:00',1.13),('14598','2013-05-01','08:20:00',1.2),('14598','2013-05-01','08:25:00',1.27),('14598','2013-05-01','08:30:00',1.38),('14598','2013-05-01','08:35:00',1.5),('14598','2013-05-01','08:40:00',1.6),('14598','2013-05-01','08:45:00',1.69),('14598','2013-05-01','08:50:00',1.75),('14598','2013-05-01','08:55:00',1.86),('14598','2013-05-01','09:00:00',1.95),('14598','2013-05-01','09:05:00',2.04),('14598','2013-05-01','09:10:00',2.15),('14598','2013-05-01','09:15:00',2.24),('14598','2013-05-01','09:20:00',2.29),('14598','2013-05-01','09:25:00',2.37),('14598','2013-05-01','09:30:00',2.45),('14598','2013-05-01','09:35:00',2.55),('14598','2013-05-01','09:40:00',2.64),('14598','2013-05-01','09:45:00',2.75),('14598','2013-05-01','09:50:00',2.82),('14598','2013-05-01','09:55:00',2.88),('14598','2013-05-01','10:00:00',2.95),('14598','2013-05-01','10:05:00',3.1),('14598','2013-05-01','10:10:00',3.21),('14598','2013-05-01','10:15:00',3.26),('14598','2013-05-01','10:20:00',3.31),('14598','2013-05-01','10:25:00',3.4),('14598','2013-05-01','10:30:00',3.47),('14598','2013-05-01','10:35:00',3.53),('14598','2013-05-01','10:40:00',3.59),('14598','2013-05-01','10:45:00',3.66),('14598','2013-05-01','10:50:00',3.72),('14598','2013-05-01','10:55:00',3.83),('14598','2013-05-01','11:00:00',3.88),('14598','2013-05-01','11:05:00',3.91),('14598','2013-05-01','11:10:00',3.69),('14598','2013-05-01','11:15:00',3.15),('14598','2013-05-01','11:20:00',3.25),('14598','2013-05-01','11:25:00',4.21),('14598','2013-05-01','11:30:00',4.31),('14598','2013-05-01','11:35:00',4.29),('14598','2013-05-01','11:40:00',4.31),('14598','2013-05-01','11:45:00',4.29),('14598','2013-05-01','11:50:00',4.24),('14598','2013-05-01','11:55:00',4.29),('14598','2013-05-01','12:00:00',4.33),('14598','2013-05-01','12:05:00',4.41),('14598','2013-05-01','12:10:00',4.53),('14598','2013-05-01','12:15:00',3.83),('14598','2013-05-01','12:20:00',3.57),('14598','2013-05-01','12:25:00',3.41),('14598','2013-05-01','12:30:00',3.39),('14598','2013-05-01','12:35:00',2.51),('14598','2013-05-01','12:40:00',2.72),('14598','2013-05-01','12:45:00',2.29),('14598','2013-05-01','12:50:00',4.34),('14598','2013-05-01','12:55:00',4.81),('14598','2013-05-01','13:00:00',4.75),('14598','2013-05-01','13:05:00',4.35),('14598','2013-05-01','13:10:00',4.6),('14598','2013-05-01','13:15:00',4.72),('14598','2013-05-01','13:20:00',4.77),('14598','2013-05-01','13:25:00',4.8),('14598','2013-05-01','13:30:00',4.85),('14598','2013-05-01','13:35:00',4.48),('14598','2013-05-01','13:40:00',4.64),('14598','2013-05-01','13:45:00',4.65),('14598','2013-05-01','13:50:00',4.17),('14598','2013-05-01','13:55:00',4.71),('14598','2013-05-01','14:00:00',4.71),('14598','2013-05-01','14:05:00',4.44),('14598','2013-05-01','14:10:00',3.71),('14598','2013-05-01','14:15:00',4.62),('14598','2013-05-01','14:20:00',4.09),('14598','2013-05-01','14:25:00',3.97),('14598','2013-05-01','14:30:00',4.43),('14598','2013-05-01','14:35:00',3.91),('14598','2013-05-01','14:40:00',3.92),('14598','2013-05-01','14:45:00',2.28),('14598','2013-05-01','14:50:00',2.37),('14598','2013-05-01','14:55:00',2.41),('14598','2013-05-01','15:00:00',3.51),('14598','2013-05-01','15:05:00',3.21),('14598','2013-05-01','15:10:00',3.87),('14598','2013-05-01','15:15:00',3.33),('14598','2013-05-01','15:20:00',3.07),('14598','2013-05-01','15:25:00',3.1),('14598','2013-05-01','15:30:00',2.95),('14598','2013-05-01','15:35:00',2.62),('14598','2013-05-01','15:40:00',2.33),('14598','2013-05-01','15:45:00',2.32),('14598','2013-05-01','15:50:00',2.55),('14598','2013-05-01','15:55:00',3.1),('14598','2013-05-01','16:00:00',2.48),('14598','2013-05-01','16:05:00',2.54),('14598','2013-05-01','16:10:00',2.49),('14598','2013-05-01','16:15:00',1.95),('14598','2013-05-01','16:20:00',1.42),('14598','2013-05-01','16:25:00',1.25),('14598','2013-05-01','16:30:00',1.24),('14598','2013-05-01','16:35:00',1.21),('14598','2013-05-01','16:40:00',1.16),('14598','2013-05-01','16:45:00',1.08),('14598','2013-05-01','16:50:00',1.02),('14598','2013-05-01','16:55:00',1),('14598','2013-04-30','08:25:00',1.24),('14598','2013-04-30','08:30:00',1.7),('14598','2013-04-30','08:35:00',1.45),('14598','2013-04-30','08:40:00',1.26),('14598','2013-04-30','08:45:00',1.23),('14598','2013-04-30','08:50:00',1.47),('14598','2013-04-30','08:55:00',1.37),('14598','2013-04-30','09:00:00',1.61),('14598','2013-04-30','09:05:00',1.63),('14598','2013-04-30','09:10:00',1.72),('14598','2013-04-30','09:15:00',2.53),('14598','2013-04-30','09:20:00',2.44),('14598','2013-04-30','09:25:00',2.41),('14598','2013-04-30','09:30:00',2.95),('14598','2013-04-30','09:35:00',3.18),('14598','2013-04-30','09:40:00',2.8),('14598','2013-04-30','09:45:00',3.37),('14598','2013-04-30','09:50:00',2.47),('14598','2013-04-30','09:55:00',2.17),('14598','2013-04-30','10:00:00',1.93),('14598','2013-04-30','10:05:00',3.2),('14598','2013-04-30','10:10:00',2.11),('14598','2013-04-30','10:15:00',2.58),('14598','2013-04-30','10:20:00',2.71),('14598','2013-04-30','10:25:00',2.96),('14598','2013-04-30','10:30:00',4.16),('14598','2013-04-30','10:35:00',3.76),('14598','2013-04-30','10:40:00',2.38),('14598','2013-04-30','10:45:00',1.98),('14598','2013-04-30','10:50:00',1.64),('14598','2013-04-30','10:55:00',1.54),('14598','2013-04-30','11:00:00',1.69),('14598','2013-04-30','11:05:00',2.05),('14598','2013-04-30','11:10:00',1.73),('14598','2013-04-30','11:15:00',1.55),('14598','2013-04-30','11:20:00',1.48),('14598','2013-04-30','11:25:00',1.5),('14598','2013-04-30','11:30:00',1.63),('14598','2013-04-30','11:35:00',1.69),('14598','2013-04-30','11:40:00',1.9),('14598','2013-04-30','11:45:00',2.43),('14598','2013-04-30','11:50:00',3.95),('14598','2013-04-30','11:55:00',4.58),('14598','2013-04-30','12:00:00',2.95),('14598','2013-04-30','12:05:00',3.08),('14598','2013-04-30','12:10:00',1.91),('14598','2013-04-30','12:15:00',2.2),('14598','2013-04-30','12:20:00',2.89),('14598','2013-04-30','12:25:00',4.11),('14598','2013-04-30','12:30:00',4.09),('14598','2013-04-30','12:35:00',3.93),('14598','2013-04-30','12:40:00',3.99),('14598','2013-04-30','12:45:00',4.28),('14598','2013-04-30','12:50:00',4.06),('14598','2013-04-30','12:55:00',4.78),('14598','2013-04-30','13:00:00',4.64),('14598','2013-04-30','13:05:00',4.63),('14598','2013-04-30','13:10:00',4.61),('14598','2013-04-30','13:15:00',4.59),('14598','2013-04-30','13:20:00',4.59),('14598','2013-04-30','13:25:00',4.59),('14598','2013-04-30','13:30:00',4.57),('14598','2013-04-30','13:35:00',4.56),('14598','2013-04-30','13:40:00',4.57),('14598','2013-04-30','13:45:00',4.53),('14598','2013-04-30','13:50:00',4.49),('14598','2013-04-30','13:55:00',4.46),('14598','2013-04-30','14:00:00',4.42),('14598','2013-04-30','14:05:00',4.42),('14598','2013-04-30','14:10:00',4.53),('14598','2013-04-30','14:15:00',4.58),('14598','2013-04-30','14:20:00',4.57),('14598','2013-04-30','14:25:00',4.56),('14598','2013-04-30','14:30:00',4.54),('14598','2013-04-30','14:35:00',4.48),('14598','2013-04-30','14:40:00',4.47),('14598','2013-04-30','14:45:00',4.46),('14598','2013-04-30','14:50:00',4.41),('14598','2013-04-30','14:55:00',4.37),('14598','2013-04-30','15:00:00',4.37),('14598','2013-04-30','15:05:00',4.32),('14598','2013-04-30','15:10:00',4.29),('14598','2013-04-30','15:15:00',4.24),('14598','2013-04-30','15:20:00',4.17),('14598','2013-04-30','15:25:00',4.17),('14598','2013-04-30','15:30:00',4.12),('14598','2013-04-30','15:35:00',4.08),('14598','2013-04-30','15:40:00',4.02),('14598','2013-04-30','15:45:00',3.95),('14598','2013-04-30','15:50:00',3.92),('14598','2013-04-30','15:55:00',3.73),('14598','2013-04-30','16:00:00',3.02),('14598','2013-04-30','16:05:00',3.54),('14598','2013-04-30','16:10:00',3.24),('14598','2013-04-30','16:15:00',3.24),('14598','2013-04-30','16:20:00',2.68),('14598','2013-04-30','16:25:00',2.03),('14598','2013-04-30','16:30:00',2.31),('14598','2013-04-30','16:35:00',2.39),('14598','2013-04-30','16:40:00',2.15),('14598','2013-04-30','16:45:00',1.97),('14598','2013-04-30','16:50:00',2.02),('14598','2013-04-30','16:55:00',2.19),('14598','2013-04-30','17:00:00',1.65),('14598','2013-04-30','17:05:00',1.4),('14598','2013-04-30','17:10:00',2.2),('14598','2013-04-30','17:15:00',2.57),('14598','2013-04-30','17:20:00',2.56),('14598','2013-04-30','17:25:00',2.4),('14598','2013-04-30','17:30:00',2.28),('14598','2013-04-30','17:35:00',2.16),('14598','2013-04-30','17:40:00',2.02),('14598','2013-04-30','17:45:00',1.94),('14598','2013-04-30','17:50:00',1.84),('14598','2013-04-30','17:55:00',1.74),('14598','2013-04-30','18:00:00',1.59),('14598','2013-04-30','18:05:00',1.43),('14598','2013-04-30','18:10:00',1.4),('14598','2013-04-30','18:15:00',1.41),('14598','2013-04-30','18:20:00',1.3),('14598','2013-04-30','18:25:00',1.2),('14598','2013-04-30','18:30:00',1.09),('14598','2013-04-29','07:55:00',1.01),('14598','2013-04-29','08:00:00',1.06),('14598','2013-04-29','08:05:00',1.2),('14598','2013-04-29','08:10:00',1.31),('14598','2013-04-29','08:15:00',1.28),('14598','2013-04-29','08:20:00',1.36),('14598','2013-04-29','08:25:00',1.28),('14598','2013-04-29','08:30:00',1.21),('14598','2013-04-29','08:35:00',1.15),('14598','2013-04-29','08:40:00',1.17),('14598','2013-04-29','08:45:00',1.58),('14598','2013-04-29','08:50:00',1.64),('14598','2013-04-29','08:55:00',1.37),('14598','2013-04-29','09:00:00',1.56),('14598','2013-04-29','09:05:00',1.79),('14598','2013-04-29','09:10:00',2.1),('14598','2013-04-29','09:15:00',2.22),('14598','2013-04-29','09:20:00',2.43),('14598','2013-04-29','09:25:00',2.56),('14598','2013-04-29','09:30:00',2.55),('14598','2013-04-29','09:35:00',2.5),('14598','2013-04-29','09:40:00',2.6),('14598','2013-04-29','09:45:00',2.51),('14598','2013-04-29','09:50:00',2.47),('14598','2013-04-29','09:55:00',2.52),('14598','2013-04-29','10:00:00',2.56),('14598','2013-04-29','10:05:00',3.12),('14598','2013-04-29','10:10:00',2.88),('14598','2013-04-29','10:15:00',2.66),('14598','2013-04-29','10:20:00',3.25),('14598','2013-04-29','10:25:00',3.12),('14598','2013-04-29','10:30:00',3.49),('14598','2013-04-29','10:35:00',3.37),('14598','2013-04-29','10:40:00',3.4),('14598','2013-04-29','10:45:00',3.15),('14598','2013-04-29','10:50:00',3.11),('14598','2013-04-29','10:55:00',3.06),('14598','2013-04-29','11:00:00',3.13),('14598','2013-04-29','11:05:00',3.37),('14598','2013-04-29','11:10:00',3.65),('14598','2013-04-29','11:15:00',3.89),('14598','2013-04-29','11:20:00',3.75),('14598','2013-04-29','11:25:00',3.69),('14598','2013-04-29','11:30:00',3.76),('14598','2013-04-29','11:35:00',4),('14598','2013-04-29','11:40:00',4.05),('14598','2013-04-29','11:45:00',4.14),('14598','2013-04-29','11:50:00',3.9),('14598','2013-04-29','11:55:00',3.89),('14598','2013-04-29','12:00:00',4.23),('14598','2013-04-29','12:05:00',4.33),('14598','2013-04-29','12:10:00',4.31),('14598','2013-04-29','12:15:00',4.43),('14598','2013-04-29','12:20:00',4.51),('14598','2013-04-29','12:25:00',4.48),('14598','2013-04-29','12:30:00',4.41),('14598','2013-04-29','12:35:00',4.42),('14598','2013-04-29','12:40:00',4.41),('14598','2013-04-29','12:45:00',4.22),('14598','2013-04-29','12:50:00',4.37),('14598','2013-04-29','12:55:00',4.22),('14598','2013-04-29','13:00:00',4.52),('14598','2013-04-29','13:05:00',4.65),('14598','2013-04-29','13:10:00',4.59),('14598','2013-04-29','13:15:00',4.4),('14598','2013-04-29','13:20:00',4.27),('14598','2013-04-29','13:25:00',4.31),('14598','2013-04-29','13:30:00',4.43),('14598','2013-04-29','13:35:00',4.4),('14598','2013-04-29','13:40:00',4.45),('14598','2013-04-29','13:45:00',4.58),('14598','2013-04-29','13:50:00',4.46),('14598','2013-04-29','13:55:00',4.47),('14598','2013-04-29','14:00:00',4.58),('14598','2013-04-29','14:05:00',4.71),('14598','2013-04-29','14:10:00',4.78),('14598','2013-04-29','14:15:00',4.7),('14598','2013-04-29','14:20:00',4.05),('14598','2013-04-29','14:25:00',4.57),('14598','2013-04-29','14:30:00',4.26),('14598','2013-04-29','14:35:00',4.2),('14598','2013-04-29','14:40:00',4.17),('14598','2013-04-29','14:45:00',4.29),('14598','2013-04-29','14:50:00',4.43),('14598','2013-04-29','14:55:00',4.24),('14598','2013-04-29','15:00:00',4.35),('14598','2013-04-29','15:05:00',4.14),('14598','2013-04-29','15:10:00',3.96),('14598','2013-04-29','15:15:00',3.7),('14598','2013-04-29','15:20:00',3.31),('14598','2013-04-29','15:25:00',3.1),('14598','2013-04-29','15:30:00',3.38),('14598','2013-04-29','15:35:00',3.2),('14598','2013-04-29','15:40:00',3.51),('14598','2013-04-29','15:45:00',3.88),('14598','2013-04-29','15:50:00',4.17),('14598','2013-04-29','15:55:00',3.88),('14598','2013-04-29','16:00:00',3.58),('14598','2013-04-29','16:05:00',3.48),('14598','2013-04-29','16:10:00',3.62),('14598','2013-04-29','16:15:00',3.72),('14598','2013-04-29','16:20:00',3.96),('14598','2013-04-29','16:25:00',3.95),('14598','2013-04-29','16:30:00',3.81),('14598','2013-04-29','16:35:00',3.74),('14598','2013-04-29','16:40:00',3.83),('14598','2013-04-29','16:45:00',3.44),('14598','2013-04-29','16:50:00',3.3),('14598','2013-04-29','16:55:00',3.28),('14598','2013-04-29','17:00:00',3.04),('14598','2013-04-29','17:05:00',2.58),('14598','2013-04-29','17:10:00',3),('14598','2013-04-29','17:15:00',3.28),('14598','2013-04-29','17:20:00',3.34),('14598','2013-04-29','17:25:00',3.16),('14598','2013-04-29','17:30:00',2.82),('14598','2013-04-29','17:35:00',2.66),('14598','2013-04-29','17:40:00',2.74),('14598','2013-04-29','17:45:00',3.06),('14598','2013-04-29','17:50:00',2.79),('14598','2013-04-29','17:55:00',2.66),('14598','2013-04-29','18:00:00',2.56),('14598','2013-04-29','18:05:00',2.44),('14598','2013-04-29','18:10:00',2.23),('14598','2013-04-29','18:15:00',1.97),('14598','2013-04-29','18:20:00',1.78),('14598','2013-04-29','18:25:00',1.53),('14598','2013-04-29','18:30:00',1.44),('14598','2013-04-29','18:35:00',1),('14598','2013-04-29','18:40:00',1),('14598','2013-04-28','08:10:00',1.09),('14598','2013-04-28','08:15:00',1.19),('14598','2013-04-28','08:20:00',1.26),('14598','2013-04-28','08:25:00',1.35),('14598','2013-04-28','08:30:00',1.39),('14598','2013-04-28','08:35:00',1.53),('14598','2013-04-28','08:40:00',1.63),('14598','2013-04-28','08:45:00',1.76),('14598','2013-04-28','08:50:00',1.88),('14598','2013-04-28','08:55:00',1.99),('14598','2013-04-28','09:00:00',2.11),('14598','2013-04-28','09:05:00',2.23),('14598','2013-04-28','09:10:00',2.34),('14598','2013-04-28','09:15:00',2.44),('14598','2013-04-28','09:20:00',2.53),('14598','2013-04-28','09:25:00',2.63),('14598','2013-04-28','09:30:00',2.71),('14598','2013-04-28','09:35:00',2.79),('14598','2013-04-28','09:40:00',2.88),('14598','2013-04-28','09:45:00',2.98),('14598','2013-04-28','09:50:00',3.06),('14598','2013-04-28','09:55:00',3.13),('14598','2013-04-28','10:00:00',3.2),('14598','2013-04-28','10:05:00',3.23),('14598','2013-04-28','10:10:00',3.33),('14598','2013-04-28','10:15:00',3.43),('14598','2013-04-28','10:20:00',3.51),('14598','2013-04-28','10:25:00',3.57),('14598','2013-04-28','10:30:00',3.66),('14598','2013-04-28','10:35:00',3.69),('14598','2013-04-28','10:40:00',3.69),('14598','2013-04-28','10:45:00',3.78),('14598','2013-04-28','10:50:00',3.88),('14598','2013-04-28','10:55:00',3.96),('14598','2013-04-28','11:00:00',3.91),('14598','2013-04-28','11:05:00',3.93),('14598','2013-04-28','11:10:00',3.95),('14598','2013-04-28','11:15:00',3.98),('14598','2013-04-28','11:20:00',4.02),('14598','2013-04-28','11:25:00',4.27),('14598','2013-04-28','11:30:00',4.18),('14598','2013-04-28','11:35:00',4.06),('14598','2013-04-28','11:40:00',4.07),('14598','2013-04-28','11:45:00',3.81),('14598','2013-04-28','11:50:00',3.82),('14598','2013-04-28','11:55:00',4.08),('14598','2013-04-28','12:00:00',3.85),('14598','2013-04-28','12:05:00',4.06),('14598','2013-04-28','12:10:00',4.31),('14598','2013-04-28','12:15:00',4.2),('14598','2013-04-28','12:20:00',4.34),('14598','2013-04-28','12:25:00',3.81),('14598','2013-04-28','12:30:00',3.82),('14598','2013-04-28','12:35:00',4.12),('14598','2013-04-28','12:40:00',4.63),('14598','2013-04-28','12:45:00',4.63),('14598','2013-04-28','12:50:00',4.63),('14598','2013-04-28','12:55:00',4.89),('14598','2013-04-28','13:00:00',4.73),('14598','2013-04-28','13:05:00',4.69),('14598','2013-04-28','13:10:00',4.66),('14598','2013-04-28','13:15:00',4.78),('14598','2013-04-28','13:20:00',4.51),('14598','2013-04-28','13:25:00',4.55),('14598','2013-04-28','13:30:00',5.12),('14598','2013-04-28','13:35:00',5),('14598','2013-04-28','13:40:00',4.87),('14598','2013-04-28','13:45:00',4.88),('14598','2013-04-28','13:50:00',4.92),('14598','2013-04-28','13:55:00',4.92),('14598','2013-04-28','14:00:00',4.61),('14598','2013-04-28','14:05:00',4.82),('14598','2013-04-28','14:10:00',4.91),('14598','2013-04-28','14:15:00',4.86),('14598','2013-04-28','14:20:00',4.82),('14598','2013-04-28','14:25:00',4.78),('14598','2013-04-28','14:30:00',4.74),('14598','2013-04-28','14:35:00',4.71),('14598','2013-04-28','14:40:00',4.68),('14598','2013-04-28','14:45:00',4.65),('14598','2013-04-28','14:50:00',4.6),('14598','2013-04-28','14:55:00',4.57),('14598','2013-04-28','15:00:00',4.57),('14598','2013-04-28','15:05:00',4.57),('14598','2013-04-28','15:10:00',4.54),('14598','2013-04-28','15:15:00',4.49),('14598','2013-04-28','15:20:00',4.45),('14598','2013-04-28','15:25:00',4.4),('14598','2013-04-28','15:30:00',4.34),('14598','2013-04-28','15:35:00',4.3),('14598','2013-04-28','15:40:00',4.24),('14598','2013-04-28','15:45:00',4.19),('14598','2013-04-28','15:50:00',4.13),('14598','2013-04-28','15:55:00',4.07),('14598','2013-04-28','16:00:00',4.04),('14598','2013-04-28','16:05:00',3.98),('14598','2013-04-28','16:10:00',3.88),('14598','2013-04-28','16:15:00',3.82),('14598','2013-04-28','16:20:00',3.75),('14598','2013-04-28','16:25:00',3.67),('14598','2013-04-28','16:30:00',3.6),('14598','2013-04-28','16:35:00',3.55),('14598','2013-04-28','16:40:00',3.51),('14598','2013-04-28','16:45:00',3.46),('14598','2013-04-28','16:50:00',3.38),('14598','2013-04-28','16:55:00',3.15),('14598','2013-04-28','17:00:00',3.01),('14598','2013-04-28','17:05:00',3.02),('14598','2013-04-28','17:10:00',3.06),('14598','2013-04-28','17:15:00',2.99),('14598','2013-04-28','17:20:00',2.82),('14598','2013-04-28','17:25:00',2.41),('14598','2013-04-28','17:30:00',2.55),('14598','2013-04-28','17:35:00',2.54),('14598','2013-04-28','17:40:00',2.48),('14598','2013-04-28','17:45:00',2.29),('14598','2013-04-28','17:50:00',2.08),('14598','2013-04-28','17:55:00',2.12),('14598','2013-04-28','18:00:00',1.8),('14598','2013-04-28','18:05:00',1.5),('14598','2013-04-28','18:10:00',1.93),('14598','2013-04-28','18:15:00',1.81),('14598','2013-04-28','18:20:00',1.35),('14598','2013-04-28','18:25:00',1.24),('14598','2013-04-28','18:30:00',1.35),('14598','2013-04-28','18:35:00',1.14),('14598','2013-04-28','18:45:00',1.01),('14598','2013-04-27','12:15:00',1.07),('14598','2013-04-27','12:20:00',1.23),('14598','2013-04-27','12:25:00',1.48),('14598','2013-04-27','12:30:00',1.71),('14598','2013-04-27','12:35:00',2.03),('14598','2013-04-27','12:40:00',2.05),('14598','2013-04-27','12:45:00',2.02),('14598','2013-04-27','12:50:00',2.97),('14598','2013-04-27','13:25:00',1.16),('14598','2013-04-27','13:30:00',1.74),('14598','2013-04-27','13:35:00',1.88),('14598','2013-04-27','14:10:00',1.74),('14598','2013-04-27','14:15:00',1.59),('14598','2013-04-27','14:20:00',1.37),('14598','2013-04-27','16:15:00',1.7),('14598','2013-04-27','16:20:00',2.12),('14598','2013-04-27','16:25:00',2.77),('14598','2013-04-27','16:30:00',2.47),('14598','2013-04-27','16:40:00',1.39),('14598','2013-04-27','16:45:00',2.1),('14598','2013-04-27','16:50:00',2.32),('14598','2013-04-27','16:55:00',1.97),('14598','2013-04-27','17:00:00',1.67),('14598','2013-04-27','17:05:00',1.5),('14598','2013-04-27','17:10:00',1.43),('14598','2013-04-27','17:20:00',1.29),('14598','2013-04-27','17:25:00',2.29),('14598','2013-04-27','17:30:00',2.1),('14598','2013-04-27','17:35:00',1.26),('14598','2013-04-26','08:10:00',1.07),('14598','2013-04-26','08:15:00',1.17),('14598','2013-04-26','08:20:00',1.26),('14598','2013-04-26','08:25:00',1.37),('14598','2013-04-26','08:30:00',1.46),('14598','2013-04-26','08:35:00',1.46),('14598','2013-04-26','08:40:00',1.53),('14598','2013-04-26','08:45:00',1.45),('14598','2013-04-26','08:50:00',1.06),('14598','2013-04-26','08:55:00',1.15),('14598','2013-04-26','09:05:00',1.67),('14598','2013-04-26','09:10:00',1.83),('14598','2013-04-26','09:15:00',2.11),('14598','2013-04-26','09:20:00',2.34),('14598','2013-04-26','09:25:00',2.44),('14598','2013-04-26','09:30:00',2.54),('14598','2013-04-26','09:35:00',2.72),('14598','2013-04-26','09:40:00',3.13),('14598','2013-04-26','09:45:00',3.6),('14598','2013-04-26','09:50:00',3.69),('14598','2013-04-26','09:55:00',3.56),('14598','2013-04-26','10:00:00',2.67),('14598','2013-04-26','10:05:00',2.29),('14598','2013-04-26','10:10:00',2.68),('14598','2013-04-26','10:15:00',3.57),('14598','2013-04-26','10:20:00',3.04),('14598','2013-04-26','10:25:00',2.48),('14598','2013-04-26','10:30:00',2.4),('14598','2013-04-26','10:35:00',2.43),('14598','2013-04-26','10:40:00',2.42),('14598','2013-04-26','10:45:00',2.5),('14598','2013-04-26','10:50:00',2.48),('14598','2013-04-26','10:55:00',2.63),('14598','2013-04-26','11:00:00',2.59),('14598','2013-04-26','11:05:00',2.44),('14598','2013-04-26','11:10:00',2.49),('14598','2013-04-26','11:15:00',2.53),('14598','2013-04-26','11:20:00',2.46),('14598','2013-04-26','11:25:00',2.53),('14598','2013-04-26','11:30:00',2.95),('14598','2013-04-26','11:35:00',2.87),('14598','2013-04-26','11:40:00',2.88),('14598','2013-04-26','11:45:00',2.72),('14598','2013-04-26','11:50:00',1.91),('14598','2013-04-26','11:55:00',1.92),('14598','2013-04-26','12:00:00',2.37),('14598','2013-04-26','12:05:00',3.23),('14598','2013-04-26','12:10:00',3.63),('14598','2013-04-26','12:15:00',3.36),('14598','2013-04-26','12:20:00',2.9),('14598','2013-04-26','12:25:00',3.24),('14598','2013-04-26','12:30:00',3.13),('14598','2013-04-26','12:35:00',2.6),('14598','2013-04-26','12:40:00',2.4),('14598','2013-04-26','12:45:00',2.61),('14598','2013-04-26','12:50:00',2.58),('14598','2013-04-26','12:55:00',2.93),('14598','2013-04-26','13:00:00',2.78),('14598','2013-04-26','13:05:00',2.4),('14598','2013-04-26','13:10:00',2.64),('14598','2013-04-26','13:15:00',2.94),('14598','2013-04-26','13:20:00',2.23),('14598','2013-04-26','13:25:00',2.89),('14598','2013-04-26','13:30:00',3.72),('14598','2013-04-26','13:35:00',4.98),('14598','2013-04-26','13:40:00',4.68),('14598','2013-04-26','13:45:00',3.91),('14598','2013-04-26','13:50:00',3.68),('14598','2013-04-26','13:55:00',4.42),('14598','2013-04-26','14:00:00',4.24),('14598','2013-04-26','14:05:00',3.43),('14598','2013-04-26','14:10:00',4.63),('14598','2013-04-26','14:15:00',5.78),('14598','2013-04-26','14:20:00',5.64),('14598','2013-04-26','14:25:00',5.31),('14598','2013-04-26','14:30:00',4.41),('14598','2013-04-26','14:35:00',2.81),('14598','2013-04-26','14:40:00',1.78),('14598','2013-04-26','14:45:00',1.8),('14598','2013-04-26','14:50:00',1.29),('14598','2013-04-26','14:55:00',1.1),('14598','2013-04-26','15:00:00',1.12),('14598','2013-04-26','15:05:00',1.92),('14598','2013-04-26','15:10:00',2.41),('14598','2013-04-26','15:15:00',1.83),('14598','2013-04-26','15:20:00',1.53),('14598','2013-04-26','15:25:00',1.83),('14598','2013-04-26','15:30:00',1.14),('14598','2013-04-26','15:35:00',1.14),('14598','2013-04-26','15:40:00',1.13),('14598','2013-04-25','08:20:00',1.14),('14598','2013-04-25','08:25:00',1.41),('14598','2013-04-25','08:30:00',1.38),('14598','2013-04-25','08:35:00',1.33),('14598','2013-04-25','08:40:00',1.56),('14598','2013-04-25','08:45:00',1.22),('14598','2013-04-25','08:50:00',1.3),('14598','2013-04-25','08:55:00',1.17),('14598','2013-04-25','09:00:00',1.09),('14598','2013-04-25','09:05:00',1.21),('14598','2013-04-25','09:10:00',1.63),('14598','2013-04-25','09:15:00',2.14),('14598','2013-04-25','09:20:00',2.42),('14598','2013-04-25','09:25:00',2.72),('14598','2013-04-25','09:30:00',2.79),('14598','2013-04-25','09:35:00',2.42),('14598','2013-04-25','09:40:00',2.61),('14598','2013-04-25','09:45:00',2.64),('14598','2013-04-25','09:50:00',2.8),('14598','2013-04-25','09:55:00',2.91),('14598','2013-04-25','10:00:00',2.91),('14598','2013-04-25','10:05:00',2.89),('14598','2013-04-25','10:10:00',2.74),('14598','2013-04-25','10:15:00',3.03),('14598','2013-04-25','10:20:00',3.37),('14598','2013-04-25','10:25:00',3.48),('14598','2013-04-25','10:30:00',3.57),('14598','2013-04-25','10:35:00',3.63),('14598','2013-04-25','10:40:00',3.67),('14598','2013-04-25','10:45:00',3.72),('14598','2013-04-25','10:50:00',3.79),('14598','2013-04-25','10:55:00',3.86),('14598','2013-04-25','11:00:00',3.91),('14598','2013-04-25','11:05:00',4.01),('14598','2013-04-25','11:10:00',3.97),('14598','2013-04-25','11:15:00',4.1),('14598','2013-04-25','11:20:00',4.26),('14598','2013-04-25','11:25:00',4.18),('14598','2013-04-25','11:30:00',3.72),('14598','2013-04-25','11:35:00',3.96),('14598','2013-04-25','11:40:00',3.7),('14598','2013-04-25','11:45:00',3.18),('14598','2013-04-25','11:50:00',3.41),('14598','2013-04-25','11:55:00',3.92),('14598','2013-04-25','12:00:00',4.5),('14598','2013-04-25','12:05:00',4.79),('14598','2013-04-25','12:10:00',4.81),('14598','2013-04-25','12:15:00',4.62),('14598','2013-04-25','12:20:00',4.66),('14598','2013-04-25','12:25:00',4.58),('14598','2013-04-25','12:30:00',4.85),('14598','2013-04-25','12:35:00',4.46),('14598','2013-04-25','12:40:00',4.96),('14598','2013-04-25','12:45:00',4.68),('14598','2013-04-25','12:50:00',4.27),('14598','2013-04-25','12:55:00',3.61),('14598','2013-04-25','13:00:00',3.91),('14598','2013-04-25','13:05:00',3.74),('14598','2013-04-25','13:10:00',3.55),('14598','2013-04-25','13:15:00',2.87),('14598','2013-04-25','13:20:00',2.66),('14598','2013-04-25','13:25:00',2.46),('14598','2013-04-25','13:30:00',2.24),('14598','2013-04-25','13:35:00',2.32),('14598','2013-04-25','13:40:00',2.35),('14598','2013-04-25','13:45:00',2.44),('14598','2013-04-25','13:50:00',2.51),('14598','2013-04-25','13:55:00',2.41),('14598','2013-04-25','14:00:00',2.58),('14598','2013-04-25','14:05:00',2.8),('14598','2013-04-25','14:10:00',3.18),('14598','2013-04-25','14:15:00',4),('14598','2013-04-25','14:20:00',3.73),('14598','2013-04-25','14:25:00',3.81),('14598','2013-04-25','14:30:00',4.15),('14598','2013-04-25','14:35:00',4.13),('14598','2013-04-25','14:40:00',4.09),('14598','2013-04-25','14:45:00',3.87),('14598','2013-04-25','14:50:00',3.74),('14598','2013-04-25','14:55:00',4.15),('14598','2013-04-25','15:00:00',2.81),('14598','2013-04-25','15:05:00',3.45),('14598','2013-04-25','15:10:00',3.86),('14598','2013-04-25','15:15:00',4.07),('14598','2013-04-25','15:20:00',4.52),('14598','2013-04-25','15:25:00',4.04),('14598','2013-04-25','15:30:00',2.86),('14598','2013-04-25','15:35:00',3.15),('14598','2013-04-25','15:40:00',3.53),('14598','2013-04-25','15:45:00',3.44),('14598','2013-04-25','15:50:00',3.18),('14598','2013-04-25','15:55:00',3.06),('14598','2013-04-25','16:00:00',2.58),('14598','2013-04-25','16:05:00',2.48),('14598','2013-04-25','16:10:00',2.27),('14598','2013-04-25','16:15:00',1.91),('14598','2013-04-25','16:20:00',2.07),('14598','2013-04-25','16:25:00',2.12),('14598','2013-04-25','16:30:00',1.97),('14598','2013-04-25','16:35:00',1.98),('14598','2013-04-25','16:40:00',2.11),('14598','2013-04-25','16:45:00',2.23),('14598','2013-04-25','16:50:00',2.54),('14598','2013-04-25','16:55:00',3.01),('14598','2013-04-25','17:00:00',2.74),('14598','2013-04-25','17:05:00',2.83),('14598','2013-04-25','17:10:00',2.69),('14598','2013-04-25','17:15:00',1.72),('14598','2013-04-25','17:20:00',1.39),('14598','2013-04-25','17:25:00',1.31),('14598','2013-04-25','17:30:00',1.98),('14598','2013-04-25','17:35:00',1.88),('14598','2013-04-25','17:40:00',1.58),('14598','2013-04-25','17:45:00',1.26),('14598','2013-04-25','17:50:00',1.13),('14598','2013-04-25','17:55:00',1.02),('14598','2013-04-24','08:10:00',1.03),('14598','2013-04-24','08:15:00',1.08),('14598','2013-04-24','08:20:00',1.12),('14598','2013-04-24','08:25:00',1.12),('14598','2013-04-24','08:30:00',1.24),('14598','2013-04-24','08:35:00',1.38),('14598','2013-04-24','08:40:00',1.41),('14598','2013-04-24','08:45:00',1.74),('14598','2013-04-24','08:50:00',2.04),('14598','2013-04-24','08:55:00',2.34),('14598','2013-04-24','09:00:00',2.08),('14598','2013-04-24','09:05:00',1.77),('14598','2013-04-24','09:10:00',1.74),('14598','2013-04-24','09:15:00',1.9),('14598','2013-04-24','09:20:00',2.19),('14598','2013-04-24','09:25:00',2.26),('14598','2013-04-24','09:30:00',2.96),('14598','2013-04-24','09:35:00',3.03),('14598','2013-04-24','09:40:00',3.06),('14598','2013-04-24','09:45:00',2.62),('14598','2013-04-24','09:50:00',2.52),('14598','2013-04-24','09:55:00',2.77),('14598','2013-04-24','10:00:00',2.87),('14598','2013-04-24','10:05:00',3.32),('14598','2013-04-24','10:10:00',3.63),('14598','2013-04-24','10:15:00',3.37),('14598','2013-04-24','10:20:00',3.01),('14598','2013-04-24','10:25:00',3.4),('14598','2013-04-24','10:30:00',3.48),('14598','2013-04-24','10:35:00',3.91),('14598','2013-04-24','10:40:00',3.86),('14598','2013-04-24','10:45:00',3.78),('14598','2013-04-24','10:50:00',4),('14598','2013-04-24','10:55:00',4.1),('14598','2013-04-24','11:00:00',4.19),('14598','2013-04-24','11:05:00',4.31),('14598','2013-04-24','11:10:00',4.13),('14598','2013-04-24','11:15:00',3.84),('14598','2013-04-24','11:20:00',3.58),('14598','2013-04-24','11:25:00',3.9),('14598','2013-04-24','11:30:00',4.59),('14598','2013-04-24','11:35:00',4.24),('14598','2013-04-24','11:40:00',3.97),('14598','2013-04-24','11:45:00',2.95),('14598','2013-04-24','11:50:00',3.54),('14598','2013-04-24','11:55:00',3.74),('14598','2013-04-24','12:00:00',3.07),('14598','2013-04-24','12:05:00',4.27),('14598','2013-04-24','12:10:00',2.92),('14598','2013-04-24','12:15:00',3.78),('14598','2013-04-24','12:20:00',3.64),('14598','2013-04-24','12:25:00',4.52),('14598','2013-04-24','12:30:00',4.07),('14598','2013-04-24','12:35:00',4.74),('14598','2013-04-24','12:40:00',4.59),('14598','2013-04-24','12:45:00',4.44),('14598','2013-04-24','12:50:00',3.98),('14598','2013-04-24','12:55:00',4.96),('14598','2013-04-24','13:00:00',4.45),('14598','2013-04-24','13:05:00',4.68),('14598','2013-04-24','13:10:00',4.67),('14598','2013-04-24','13:15:00',4.1),('14598','2013-04-24','13:20:00',4.47),('14598','2013-04-24','13:25:00',5.19),('14598','2013-04-24','13:30:00',4.53),('14598','2013-04-24','13:35:00',3.51),('14598','2013-04-24','13:40:00',4.67),('14598','2013-04-24','13:45:00',4.68),('14598','2013-04-24','13:50:00',3.51),('14598','2013-04-24','13:55:00',4.12),('14598','2013-04-24','14:00:00',5.06),('14598','2013-04-24','14:05:00',4.8),('14598','2013-04-24','14:10:00',4.97),('14598','2013-04-24','14:15:00',4.48),('14598','2013-04-24','14:20:00',4.3),('14598','2013-04-24','14:25:00',3.91),('14598','2013-04-24','14:30:00',4.04),('14598','2013-04-24','14:35:00',3.06),('14598','2013-04-24','14:40:00',2.87),('14598','2013-04-24','14:45:00',2.96),('14598','2013-04-24','14:50:00',3.03),('14598','2013-04-24','14:55:00',2.49),('14598','2013-04-24','15:00:00',2.75),('14598','2013-04-24','15:05:00',2.68),('14598','2013-04-24','15:10:00',2.24),('14598','2013-04-24','15:15:00',2.21),('14598','2013-04-24','15:20:00',2.08),('14598','2013-04-24','15:25:00',2.1),('14598','2013-04-24','15:30:00',2.23),('14598','2013-04-24','15:35:00',2.7),('14598','2013-04-24','15:40:00',2.89),('14598','2013-04-24','15:45:00',3.32),('14598','2013-04-24','15:50:00',3.39),('14598','2013-04-24','15:55:00',3.72),('14598','2013-04-24','16:00:00',4.44),('14598','2013-04-24','16:05:00',3.97),('14598','2013-04-24','16:10:00',3.54),('14598','2013-04-24','16:15:00',2.2),('14598','2013-04-24','16:20:00',3.16),('14598','2013-04-24','16:25:00',3.2),('14598','2013-04-24','16:30:00',3.21),('14598','2013-04-24','16:35:00',3.39),('14598','2013-04-24','16:40:00',3.97),('14598','2013-04-24','16:45:00',3.73),('14598','2013-04-24','16:50:00',3.44),('14598','2013-04-24','16:55:00',3.27),('14598','2013-04-24','17:00:00',2.91),('14598','2013-04-24','17:05:00',3.16),('14598','2013-04-24','17:10:00',2.37),('14598','2013-04-24','17:15:00',1.33),('14598','2013-04-24','17:20:00',1.02),('14598','2013-04-24','17:25:00',1.41),('14598','2013-04-24','17:30:00',1.43),('14598','2013-04-24','17:35:00',2.39),('14598','2013-04-24','17:40:00',2.13),('14598','2013-04-24','17:45:00',2),('14598','2013-04-24','17:50:00',2.19),('14598','2013-04-24','17:55:00',1.46),('14598','2013-04-24','18:00:00',1.08),('14598','2013-04-24','18:10:00',1.37),('14598','2013-04-24','18:15:00',1.85),('14598','2013-04-24','18:20:00',1.45),('14598','2013-04-24','18:25:00',1.25),('14598','2013-04-23','08:15:00',1.08),('14598','2013-04-23','08:20:00',1.19),('14598','2013-04-23','08:25:00',1.3),('14598','2013-04-23','08:30:00',1.41),('14598','2013-04-23','08:35:00',1.53),('14598','2013-04-23','08:40:00',1.64),('14598','2013-04-23','08:45:00',1.73),('14598','2013-04-23','08:50:00',1.85),('14598','2013-04-23','08:55:00',1.97),('14598','2013-04-23','09:00:00',2.11),('14598','2013-04-23','09:05:00',2.27),('14598','2013-04-23','09:10:00',2.39),('14598','2013-04-23','09:15:00',2.49),('14598','2013-04-23','09:20:00',2.6),('14598','2013-04-23','09:25:00',2.69),('14598','2013-04-23','09:30:00',2.79),('14598','2013-04-23','09:35:00',2.89),('14598','2013-04-23','09:40:00',2.99),('14598','2013-04-23','09:45:00',3.03),('14598','2013-04-23','09:50:00',2.82),('14598','2013-04-23','09:55:00',3.19),('14598','2013-04-23','10:00:00',3.33),('14598','2013-04-23','10:05:00',3.4),('14598','2013-04-23','10:10:00',3.48),('14598','2013-04-23','10:15:00',3.61),('14598','2013-04-23','10:20:00',3.7),('14598','2013-04-23','10:25:00',3.78),('14598','2013-04-23','10:30:00',3.85),('14598','2013-04-23','10:35:00',3.89),('14598','2013-04-23','10:40:00',3.96),('14598','2013-04-23','10:45:00',4.05),('14598','2013-04-23','10:50:00',4.09),('14598','2013-04-23','10:55:00',4.13),('14598','2013-04-23','11:00:00',4.17),('14598','2013-04-23','11:05:00',4.23),('14598','2013-04-23','11:10:00',4.31),('14598','2013-04-23','11:15:00',4.37),('14598','2013-04-23','11:20:00',4.39),('14598','2013-04-23','11:25:00',4.43),('14598','2013-04-23','11:30:00',4.47),('14598','2013-04-23','11:35:00',4.53),('14598','2013-04-23','11:40:00',4.54),('14598','2013-04-23','11:45:00',4.5),('14598','2013-04-23','11:50:00',4.58),('14598','2013-04-23','11:55:00',4.62),('14598','2013-04-23','12:00:00',4.64),('14598','2013-04-23','12:05:00',4.69),('14598','2013-04-23','12:10:00',4.72),('14598','2013-04-23','12:15:00',4.85),('14598','2013-04-23','12:20:00',4.61),('14598','2013-04-23','12:25:00',4.68),('14598','2013-04-23','12:30:00',4.79),('14598','2013-04-23','12:35:00',5.07),('14598','2013-04-23','12:40:00',4.96),('14598','2013-04-23','12:45:00',4.91),('14598','2013-04-23','12:50:00',5.11),('14598','2013-04-23','12:55:00',5.13),('14598','2013-04-23','13:00:00',5.1),('14598','2013-04-23','13:05:00',5.11),('14598','2013-04-23','13:10:00',5.09),('14598','2013-04-23','13:15:00',5.09),('14598','2013-04-23','13:20:00',5.37),('14598','2013-04-23','13:25:00',5.32),('14598','2013-04-23','13:30:00',4.78),('14598','2013-04-23','13:35:00',4.56),('14598','2013-04-23','13:40:00',4.89),('14598','2013-04-23','13:45:00',4.83),('14598','2013-04-23','13:50:00',4.47),('14598','2013-04-23','13:55:00',4.73),('14598','2013-04-23','14:00:00',5.46),('14598','2013-04-23','14:05:00',5.33),('14598','2013-04-23','14:10:00',4.95),('14598','2013-04-23','14:15:00',4.85),('14598','2013-04-23','14:20:00',4.84),('14598','2013-04-23','14:25:00',4.72),('14598','2013-04-23','14:30:00',4.83),('14598','2013-04-23','14:35:00',5.1),('14598','2013-04-23','14:40:00',5.13),('14598','2013-04-23','14:45:00',4.6),('14598','2013-04-23','14:50:00',3.45),('14598','2013-04-23','14:55:00',2.64),('14598','2013-04-23','15:00:00',3.03),('14598','2013-04-23','15:05:00',3.4),('14598','2013-04-23','15:10:00',3.69),('14598','2013-04-23','15:15:00',3.77),('14598','2013-04-23','15:20:00',3.49),('14598','2013-04-23','15:25:00',3.24),('14598','2013-04-23','15:30:00',3.51),('14598','2013-04-23','15:35:00',3.66),('14598','2013-04-23','15:40:00',3.79),('14598','2013-04-23','15:45:00',3.41),('14598','2013-04-23','15:50:00',2.77),('14598','2013-04-23','15:55:00',2.8),('14598','2013-04-23','16:00:00',3.08),('14598','2013-04-23','16:05:00',3.21),('14598','2013-04-23','16:10:00',2.61),('14598','2013-04-23','16:15:00',2.35),('14598','2013-04-23','16:20:00',2.84),('14598','2013-04-23','16:25:00',2.88),('14598','2013-04-23','16:30:00',3.71),('14598','2013-04-23','16:35:00',2.73),('14598','2013-04-23','16:40:00',2.78),('14598','2013-04-23','16:45:00',3.55),('14598','2013-04-23','16:50:00',2.21),('14598','2013-04-23','16:55:00',1.78),('14598','2013-04-23','17:00:00',1.58),('14598','2013-04-23','17:05:00',1.44),('14598','2013-04-23','17:10:00',1.45),('14598','2013-04-23','17:15:00',1.76),('14598','2013-04-23','17:20:00',1.41),('14598','2013-04-23','17:25:00',2.1),('14598','2013-04-23','17:30:00',2.5),('14598','2013-04-23','17:35:00',2.25),('14598','2013-04-23','17:40:00',1.06),('14598','2013-04-23','17:45:00',1.78),('14598','2013-04-23','17:50:00',2.23),('14598','2013-04-23','17:55:00',1.93),('14598','2013-04-23','18:00:00',1.31),('14598','2013-04-23','18:05:00',1.8),('14598','2013-04-23','18:10:00',1.71),('14598','2013-04-23','18:15:00',1.35),('14598','2013-04-23','18:25:00',1.24),('14598','2013-04-23','18:30:00',1.39),('14598','2013-04-22','08:35:00',1.15),('14598','2013-04-22','08:40:00',1.06),('14598','2013-04-22','10:20:00',1.04),('14598','2013-04-22','10:40:00',1.98),('14598','2013-04-22','10:45:00',3.55),('14598','2013-04-22','10:50:00',5.26),('14598','2013-04-22','10:55:00',1.69),('14598','2013-04-22','11:00:00',2.4),('14598','2013-04-22','11:05:00',2.38),('14598','2013-04-22','11:10:00',2.05),('14598','2013-04-22','11:15:00',3.51),('14598','2013-04-22','11:20:00',3.74),('14598','2013-04-22','11:25:00',5.09),('14598','2013-04-22','11:30:00',5),('14598','2013-04-22','11:35:00',4.78),('14598','2013-04-22','11:40:00',4.8),('14598','2013-04-22','11:45:00',4.85),('14598','2013-04-22','11:50:00',4.67),('14598','2013-04-22','11:55:00',4.39),('14598','2013-04-22','12:00:00',4.97),('14598','2013-04-22','12:05:00',4.96),('14598','2013-04-22','12:10:00',5.01),('14598','2013-04-22','12:15:00',5.07),('14598','2013-04-22','12:20:00',5.08),('14598','2013-04-22','12:25:00',5.1),('14598','2013-04-22','12:30:00',5.13),('14598','2013-04-22','12:35:00',4.8),('14598','2013-04-22','12:40:00',2.99),('14598','2013-04-22','12:45:00',2.67),('14598','2013-04-22','12:50:00',2.83),('14598','2013-04-22','12:55:00',1.9),('14598','2013-04-22','13:00:00',3.09),('14598','2013-04-22','13:05:00',2.46),('14598','2013-04-22','13:10:00',1.58),('14598','2013-04-22','13:15:00',4.17),('14598','2013-04-22','13:20:00',3.62),('14598','2013-04-22','13:25:00',2.07),('14598','2013-04-22','13:30:00',3.95),('14598','2013-04-22','13:35:00',4.05),('14598','2013-04-22','13:40:00',5.72),('14598','2013-04-22','13:45:00',5.5),('14598','2013-04-22','13:50:00',5.5),('14598','2013-04-22','13:55:00',5.46),('14598','2013-04-22','14:00:00',5.45),('14598','2013-04-22','14:05:00',5.53),('14598','2013-04-22','14:10:00',5.56),('14598','2013-04-22','14:15:00',5.51),('14598','2013-04-22','14:20:00',5.51),('14598','2013-04-22','14:25:00',4.49),('14598','2013-04-22','14:30:00',5.05),('14598','2013-04-22','14:35:00',2.83),('14598','2013-04-22','14:40:00',2.65),('14598','2013-04-22','14:45:00',3.48),('14598','2013-04-22','14:50:00',5.55),('14598','2013-04-22','14:55:00',4.37),('14598','2013-04-22','15:00:00',4.96),('14598','2013-04-22','15:05:00',5.71),('14598','2013-04-22','15:10:00',2.59),('14598','2013-04-22','15:15:00',1.95),('14598','2013-04-22','15:20:00',1.56),('14598','2013-04-22','15:25:00',1.34),('14598','2013-04-22','15:30:00',1.15),('14598','2013-04-22','15:35:00',3.73),('14598','2013-04-22','15:40:00',4.52),('14598','2013-04-22','15:45:00',4.45),('14598','2013-04-22','15:50:00',1.59),('14598','2013-04-22','15:55:00',3.25),('14598','2013-04-22','16:00:00',3.85),('14598','2013-04-22','16:05:00',4.91),('14598','2013-04-22','16:10:00',4.99),('14598','2013-04-22','16:15:00',4.92),('14598','2013-04-22','16:20:00',4.38),('14598','2013-04-22','16:25:00',4.28),('14598','2013-04-22','16:30:00',3.26),('14598','2013-04-22','16:35:00',1.77),('14598','2013-04-22','16:40:00',2.32),('14598','2013-04-22','16:45:00',3.59),('14598','2013-04-22','16:50:00',3.42),('14598','2013-04-22','16:55:00',3.23),('14598','2013-04-22','17:00:00',3.58),('14598','2013-04-22','17:05:00',3.65),('14598','2013-04-22','17:10:00',2.49),('14598','2013-04-22','17:15:00',1.92),('14598','2013-04-22','17:20:00',1.51),('14598','2013-04-22','17:25:00',1.11),('14598','2013-04-22','18:10:00',1.75),('14598','2013-04-22','18:20:00',1.49),('14598','2013-04-22','18:35:00',1.22),('14598','2013-04-22','18:55:00',1.07),('14598','2014-03-29','07:50:00',1.08),('14598','2014-03-29','07:55:00',1.16),('14598','2014-03-29','08:00:00',1.28),('14598','2014-03-29','08:05:00',1.38),('14598','2014-03-29','08:10:00',1.49),('14598','2014-03-29','08:15:00',1.62),('14598','2014-03-29','08:20:00',1.73),('14598','2014-03-29','08:25:00',1.88),('14598','2014-03-29','08:30:00',2),('14598','2014-03-29','08:35:00',2.1),('14598','2014-03-29','08:40:00',2.21),('14598','2014-03-29','08:45:00',2.29),('14598','2014-03-29','08:50:00',2.37),('14598','2014-03-29','08:55:00',2.46),('14598','2014-03-29','09:00:00',2.54),('14598','2014-03-29','09:05:00',2.63),('14598','2014-03-29','09:10:00',2.7),('14598','2014-03-29','09:15:00',2.8),('14598','2014-03-29','09:20:00',2.87),('14598','2014-03-29','09:25:00',2.96),('14598','2014-03-29','09:30:00',3.04),('14598','2014-03-29','09:35:00',3.13),('14598','2014-03-29','09:40:00',3.21),('14598','2014-03-29','09:45:00',3.27),('14598','2014-03-29','09:50:00',3.34),('14598','2014-03-29','09:55:00',3.41),('14598','2014-03-29','10:00:00',3.48),('14598','2014-03-29','10:05:00',3.57),('14598','2014-03-29','10:10:00',3.63),('14598','2014-03-29','10:15:00',3.7),('14598','2014-03-29','10:20:00',3.75),('14598','2014-03-29','10:25:00',3.81),('14598','2014-03-29','10:30:00',3.9),('14598','2014-03-29','10:35:00',3.94),('14598','2014-03-29','10:40:00',3.96),('14598','2014-03-29','10:45:00',3.99),('14598','2014-03-29','10:50:00',4.05),('14598','2014-03-29','10:55:00',4.13),('14598','2014-03-29','11:00:00',4.16),('14598','2014-03-29','11:05:00',4.19),('14598','2014-03-29','11:10:00',4.23),('14598','2014-03-29','11:15:00',4.27),('14598','2014-03-29','11:20:00',4.3),('14598','2014-03-29','11:25:00',4.35),('14598','2014-03-29','11:30:00',4.39),('14598','2014-03-29','11:35:00',4.4),('14598','2014-03-29','11:40:00',4.4),('14598','2014-03-29','11:45:00',4.43),('14598','2014-03-29','11:50:00',4.46),('14598','2014-03-29','11:55:00',4.48),('14598','2014-03-29','12:00:00',4.61),('14598','2014-03-29','12:05:00',4.69),('14598','2014-03-29','12:10:00',4.57),('14598','2014-03-29','12:15:00',4.69),('14598','2014-03-29','12:20:00',4.7),('14598','2014-03-29','12:25:00',4.7),('14598','2014-03-29','12:30:00',4.68),('14598','2014-03-29','12:35:00',4.69),('14598','2014-03-29','12:40:00',4.71),('14598','2014-03-29','12:45:00',4.72),('14598','2014-03-29','12:50:00',4.74),('14598','2014-03-29','12:55:00',4.75),('14598','2014-03-29','13:00:00',4.71),('14598','2014-03-29','13:05:00',4.69),('14598','2014-03-29','13:10:00',4.71),('14598','2014-03-29','13:15:00',4.69),('14598','2014-03-29','13:20:00',4.64),('14598','2014-03-29','13:25:00',4.58),('14598','2014-03-29','13:30:00',4.61),('14598','2014-03-29','13:35:00',4.57),('14598','2014-03-29','13:40:00',4.5),('14598','2014-03-29','13:45:00',4.52),('14598','2014-03-29','13:50:00',4.45),('14598','2014-03-29','13:55:00',4.42),('14598','2014-03-29','14:00:00',4.43),('14598','2014-03-29','14:05:00',4.36),('14598','2014-03-29','14:10:00',4.33),('14598','2014-03-29','14:15:00',4.27),('14598','2014-03-29','14:20:00',4.21),('14598','2014-03-29','14:25:00',4.19),('14598','2014-03-29','14:30:00',4.14),('14598','2014-03-29','14:35:00',4.13),('14598','2014-03-29','14:40:00',4.02),('14598','2014-03-29','14:45:00',3.92),('14598','2014-03-29','14:50:00',3.93),('14598','2014-03-29','14:55:00',3.86),('14598','2014-03-29','15:00:00',3.78),('14598','2014-03-29','15:05:00',3.69),('14598','2014-03-29','15:10:00',3.54),('14598','2014-03-29','15:15:00',3.55),('14598','2014-03-29','15:20:00',3.49),('14598','2014-03-29','15:25:00',3.42),('14598','2014-03-29','15:30:00',3.33),('14598','2014-03-29','15:35:00',3.28),('14598','2014-03-29','15:40:00',3.21),('14598','2014-03-29','15:45:00',3.11),('14598','2014-03-29','15:50:00',3.02),('14598','2014-03-29','15:55:00',2.96),('14598','2014-03-29','16:00:00',2.86),('14598','2014-03-29','16:05:00',2.76),('14598','2014-03-29','16:10:00',2.48),('14598','2014-03-29','16:15:00',2.5),('14598','2014-03-29','16:20:00',2.49),('14598','2014-03-29','16:25:00',2.12),('14598','2014-03-29','16:30:00',1.82),('14598','2014-03-29','16:35:00',1.65),('14598','2014-03-29','16:40:00',1.72),('14598','2014-03-29','16:45:00',1.91),('14598','2014-03-29','16:50:00',1.87),('14598','2014-03-29','16:55:00',1.65),('14598','2014-03-29','17:00:00',1.52),('14598','2014-03-29','17:05:00',1.53),('14598','2014-03-29','17:10:00',1.38),('14598','2014-03-29','17:15:00',1.26),('14598','2014-03-29','17:20:00',1.13),('14598','2013-04-21','08:20:00',1.03),('14598','2013-04-21','08:25:00',1.23),('14598','2013-04-21','08:30:00',1.27),('14598','2013-04-21','08:35:00',1.42),('14598','2013-04-21','08:40:00',1.79),('14598','2013-04-21','08:45:00',1.86),('14598','2013-04-21','08:50:00',1.8),('14598','2013-04-21','08:55:00',1.99),('14598','2013-04-21','09:00:00',1.14),('14598','2013-04-21','09:05:00',1.99),('14598','2013-04-21','09:10:00',1.97),('14598','2013-04-21','09:15:00',1.94),('14598','2013-04-21','09:20:00',1.77),('14598','2013-04-21','09:25:00',1.54),('14598','2013-04-21','09:30:00',1.56),('14598','2013-04-21','09:35:00',2.98),('14598','2013-04-21','09:40:00',3.75),('14598','2013-04-21','09:45:00',2.96),('14598','2013-04-21','09:50:00',2.74),('14598','2013-04-21','09:55:00',1.88),('14598','2013-04-21','10:00:00',3.3),('14598','2013-04-21','10:05:00',3.36),('14598','2013-04-21','10:10:00',3.46),('14598','2013-04-21','10:15:00',3.57),('14598','2013-04-21','10:20:00',3.66),('14598','2013-04-21','10:25:00',3.74),('14598','2013-04-21','10:30:00',3.81),('14598','2013-04-21','10:35:00',3.87),('14598','2013-04-21','10:40:00',3.94),('14598','2013-04-21','10:45:00',4.02),('14598','2013-04-21','10:50:00',4.08),('14598','2013-04-21','10:55:00',4.14),('14598','2013-04-21','11:00:00',4.22),('14598','2013-04-21','11:05:00',4.3),('14598','2013-04-21','11:10:00',4.34),('14598','2013-04-21','11:15:00',4.02),('14598','2013-04-21','11:20:00',3.21),('14598','2013-04-21','11:25:00',3.12),('14598','2013-04-21','11:30:00',3.1),('14598','2013-04-21','11:35:00',3.24),('14598','2013-04-21','11:40:00',2.93),('14598','2013-04-21','11:45:00',2.64),('14598','2013-04-21','11:50:00',2.47),('14598','2013-04-21','11:55:00',2.61),('14598','2013-04-21','12:00:00',3),('14598','2013-04-21','12:05:00',2.99),('14598','2013-04-21','12:10:00',2.74),('14598','2013-04-21','12:15:00',2.92),('14598','2013-04-21','12:20:00',3.23),('14598','2013-04-21','12:25:00',3.7),('14598','2013-04-21','12:30:00',3.39),('14598','2013-04-21','12:35:00',2.92),('14598','2013-04-21','12:40:00',3.16),('14598','2013-04-21','12:45:00',3.32),('14598','2013-04-21','12:50:00',3.7),('14598','2013-04-21','12:55:00',3.48),('14598','2013-04-21','13:00:00',5),('14598','2013-04-21','13:05:00',4.32),('14598','2013-04-21','13:10:00',4.33),('14598','2013-04-21','13:15:00',4.5),('14598','2013-04-21','13:20:00',4.68),('14598','2013-04-21','13:25:00',5.67),('14598','2013-04-21','13:30:00',5.68),('14598','2013-04-21','13:35:00',5.38),('14598','2013-04-21','13:40:00',4.34),('14598','2013-04-21','13:45:00',4.57),('14598','2013-04-21','13:50:00',5.22),('14598','2013-04-21','13:55:00',5.26),('14598','2013-04-21','14:00:00',5.23),('14598','2013-04-21','14:05:00',5.21),('14598','2013-04-21','14:10:00',5.22),('14598','2013-04-21','14:15:00',5.17),('14598','2013-04-21','14:20:00',5.21),('14598','2013-04-21','14:25:00',5.14),('14598','2013-04-21','14:30:00',5.2),('14598','2013-04-21','14:35:00',4.47),('14598','2013-04-21','14:40:00',4.41),('14598','2013-04-21','14:45:00',4.79),('14598','2013-04-21','14:50:00',4.29),('14598','2013-04-21','14:55:00',5.48),('14598','2013-04-21','15:00:00',5.09),('14598','2013-04-21','15:05:00',5.02),('14598','2013-04-21','15:10:00',5.04),('14598','2013-04-21','15:15:00',5.21),('14598','2013-04-21','15:20:00',3.43),('14598','2013-04-21','15:25:00',3.16),('14598','2013-04-21','15:30:00',2.75),('14598','2013-04-21','15:35:00',2.57),('14598','2013-04-21','15:40:00',2.48),('14598','2013-04-21','15:45:00',2.58),('14598','2013-04-21','15:50:00',1.88),('14598','2013-04-21','15:55:00',1.49),('14598','2013-04-21','16:00:00',1.43),('14598','2013-04-21','16:05:00',1.49),('14598','2013-04-21','16:10:00',1.44),('14598','2013-04-21','16:15:00',1.33),('14598','2013-04-21','16:20:00',1.35),('14598','2013-04-21','16:25:00',2.03),('14598','2013-04-21','16:30:00',2.17),('14598','2013-04-21','16:35:00',2.09),('14598','2013-04-21','16:40:00',1.4),('14598','2013-04-21','16:45:00',1.21),('14598','2013-04-21','16:50:00',1.32),('14598','2013-04-21','16:55:00',1.27),('14598','2013-04-20','08:40:00',1.14),('14598','2013-04-20','08:45:00',1.4),('14598','2013-04-20','08:50:00',1.02),('14598','2013-04-20','10:05:00',1.21),('14598','2013-04-20','10:10:00',1.17),('14598','2013-04-20','10:15:00',1.32),('14598','2013-04-20','10:20:00',1.63),('14598','2013-04-20','10:25:00',2.32),('14598','2013-04-20','10:30:00',2.73),('14598','2013-04-20','10:35:00',2.25),('14598','2013-04-20','10:40:00',2.16),('14598','2013-04-20','10:45:00',1.93),('14598','2013-04-20','10:50:00',1.86),('14598','2013-04-20','10:55:00',1.84),('14598','2013-04-20','11:00:00',2.28),('14598','2013-04-20','11:05:00',2.2),('14598','2013-04-20','11:10:00',2.54),('14598','2013-04-20','11:15:00',2.32),('14598','2013-04-20','11:20:00',3.51),('14598','2013-04-20','11:25:00',2.44),('14598','2013-04-20','11:30:00',4.96),('14598','2013-04-20','11:35:00',5.02),('14598','2013-04-20','11:40:00',4.83),('14598','2013-04-20','11:45:00',4.81),('14598','2013-04-20','11:50:00',4.83),('14598','2013-04-20','11:55:00',4.89),('14598','2013-04-20','12:00:00',4.8),('14598','2013-04-20','12:05:00',4.86),('14598','2013-04-20','12:10:00',4.94),('14598','2013-04-20','12:15:00',5.01),('14598','2013-04-20','12:20:00',5.01),('14598','2013-04-20','12:25:00',5.03),('14598','2013-04-20','12:30:00',5.13),('14598','2013-04-20','12:35:00',5.27),('14598','2013-04-20','12:40:00',5.18),('14598','2013-04-20','12:45:00',4.92),('14598','2013-04-20','12:50:00',5.45),('14598','2013-04-20','12:55:00',4.22),('14598','2013-04-20','13:00:00',4.48),('14598','2013-04-20','13:05:00',4.94),('14598','2013-04-20','13:10:00',5.5),('14598','2013-04-20','13:15:00',4.23),('14598','2013-04-20','13:20:00',2.18),('14598','2013-04-20','13:25:00',2.07),('14598','2013-04-20','13:30:00',2.01),('14598','2013-04-20','13:35:00',2.32),('14598','2013-04-20','13:40:00',5.12),('14598','2013-04-20','13:45:00',5.7),('14598','2013-04-20','13:50:00',4.95),('14598','2013-04-20','13:55:00',4.46),('14598','2013-04-20','14:00:00',5.31),('14598','2013-04-20','14:05:00',5.8),('14598','2013-04-20','14:10:00',5.38),('14598','2013-04-20','14:15:00',5.63),('14598','2013-04-20','14:20:00',3.9),('14598','2013-04-20','14:25:00',4.78),('14598','2013-04-20','14:30:00',5.86),('14598','2013-04-20','14:35:00',5.6),('14598','2013-04-20','14:40:00',5.44),('14598','2013-04-20','14:45:00',5.1),('14598','2013-04-20','14:50:00',2.97),('14598','2013-04-20','14:55:00',1.81),('14598','2013-04-20','15:00:00',1.5),('14598','2013-04-20','15:05:00',1.17),('14598','2013-04-20','15:20:00',1.11),('14598','2013-04-20','15:25:00',1.7),('14598','2013-04-20','15:30:00',2.61),('14598','2013-04-20','15:35:00',3.64),('14598','2013-04-20','15:40:00',4.48),('14598','2013-04-20','15:45:00',3.81),('14598','2013-04-20','15:50:00',3.82),('14598','2013-04-20','15:55:00',4.07),('14598','2013-04-20','16:00:00',3.64),('14598','2013-04-20','16:05:00',4.15),('14598','2013-04-20','16:10:00',4.06),('14598','2013-04-20','16:15:00',4.14),('14598','2013-04-20','16:20:00',4.08),('14598','2013-04-20','16:25:00',3.97),('14598','2013-04-20','16:30:00',3.84),('14598','2013-04-20','16:35:00',3.77),('14598','2013-04-20','16:40:00',3.68),('14598','2013-04-20','16:45:00',3.59),('14598','2013-04-20','16:50:00',3.52),('14598','2013-04-20','16:55:00',3.42),('14598','2013-04-20','17:00:00',3.32),('14598','2013-04-20','17:05:00',3.23),('14598','2013-04-20','17:10:00',2.92),('14598','2013-04-20','17:15:00',1.72),('14598','2013-04-20','17:30:00',1.3),('14598','2013-04-20','17:35:00',2.12),('14598','2013-04-20','17:40:00',2.77),('14598','2013-04-20','17:45:00',3.05),('14598','2013-04-20','17:50:00',2.41),('14598','2013-04-20','18:00:00',1.24),('14598','2013-04-20','18:10:00',1.35),('14598','2013-04-20','18:15:00',1.25),('14598','2013-04-19','08:35:00',1.12),('14598','2013-04-19','08:40:00',1.24),('14598','2013-04-19','08:45:00',1.21),('14598','2013-04-19','08:50:00',1.56),('14598','2013-04-19','08:55:00',1.41),('14598','2013-04-19','09:00:00',1.3),('14598','2013-04-19','09:05:00',1.56),('14598','2013-04-19','09:10:00',2.04),('14598','2013-04-19','09:15:00',2.01),('14598','2013-04-19','09:20:00',2.49),('14598','2013-04-19','09:25:00',1.85),('14598','2013-04-19','09:30:00',2.57),('14598','2013-04-19','09:35:00',2.82),('14598','2013-04-19','09:40:00',2.61),('14598','2013-04-19','09:45:00',2.13),('14598','2013-04-19','09:50:00',2.02),('14598','2013-04-19','09:55:00',2.21),('14598','2013-04-19','10:00:00',2.62),('14598','2013-04-19','10:05:00',3.12),('14598','2013-04-19','10:10:00',2.38),('14598','2013-04-19','10:15:00',1.92),('14598','2013-04-19','10:20:00',3.07),('14598','2013-04-19','10:25:00',3.17),('14598','2013-04-19','10:30:00',3.64),('14598','2013-04-19','10:35:00',3.7),('14598','2013-04-19','10:40:00',3.67),('14598','2013-04-19','10:45:00',3.81),('14598','2013-04-19','10:50:00',3.89),('14598','2013-04-19','10:55:00',3.96),('14598','2013-04-19','11:00:00',4.01),('14598','2013-04-19','11:05:00',4.1),('14598','2013-04-19','11:10:00',4.16),('14598','2013-04-19','11:15:00',4.18),('14598','2013-04-19','11:20:00',4.27),('14598','2013-04-19','11:25:00',4.3),('14598','2013-04-19','11:30:00',4.36),('14598','2013-04-19','11:35:00',4.42),('14598','2013-04-19','11:40:00',4.44),('14598','2013-04-19','11:45:00',4.51),('14598','2013-04-19','11:50:00',4.55),('14598','2013-04-19','11:55:00',4.58),('14598','2013-04-19','12:00:00',4.64),('14598','2013-04-19','12:05:00',4.66),('14598','2013-04-19','12:10:00',4.71),('14598','2013-04-19','12:15:00',4.75),('14598','2013-04-19','12:20:00',4.77),('14598','2013-04-19','12:25:00',4.81),('14598','2013-04-19','12:30:00',4.81),('14598','2013-04-19','12:35:00',4.88),('14598','2013-04-19','12:40:00',4.88),('14598','2013-04-19','12:45:00',4.92),('14598','2013-04-19','12:50:00',4.95),('14598','2013-04-19','12:55:00',5),('14598','2013-04-19','13:00:00',5.03),('14598','2013-04-19','13:05:00',5.03),('14598','2013-04-19','13:10:00',5.01),('14598','2013-04-19','13:15:00',4.98),('14598','2013-04-19','13:20:00',5.01),('14598','2013-04-19','13:25:00',5.02),('14598','2013-04-19','13:30:00',4.98),('14598','2013-04-19','13:35:00',4.98),('14598','2013-04-19','13:40:00',5.01),('14598','2013-04-19','13:45:00',5.04),('14598','2013-04-19','13:50:00',5.05),('14598','2013-04-19','13:55:00',5.02),('14598','2013-04-19','14:00:00',5.06),('14598','2013-04-19','14:05:00',5.05),('14598','2013-04-19','14:10:00',5.06),('14598','2013-04-19','14:15:00',5.02),('14598','2013-04-19','14:20:00',5.04),('14598','2013-04-19','14:25:00',5.03),('14598','2013-04-19','14:30:00',5.03),('14598','2013-04-19','14:35:00',4.99),('14598','2013-04-19','14:40:00',4.97),('14598','2013-04-19','14:45:00',4.94),('14598','2013-04-19','14:50:00',4.93),('14598','2013-04-19','14:55:00',4.88),('14598','2013-04-19','15:00:00',4.81),('14598','2013-04-19','15:05:00',4.76),('14598','2013-04-19','15:10:00',4.74),('14598','2013-04-19','15:15:00',4.71),('14598','2013-04-19','15:20:00',4.64),('14598','2013-04-19','15:25:00',4.58),('14598','2013-04-19','15:30:00',4.47),('14598','2013-04-19','15:35:00',4.47),('14598','2013-04-19','15:40:00',4.42),('14598','2013-04-19','15:45:00',4.35),('14598','2013-04-19','15:50:00',4.37),('14598','2013-04-19','15:55:00',4.32),('14598','2013-04-19','16:00:00',4.19),('14598','2013-04-19','16:05:00',4.07),('14598','2013-04-19','16:10:00',4.02),('14598','2013-04-19','16:15:00',3.94),('14598','2013-04-19','16:20:00',3.88),('14598','2013-04-19','16:25:00',3.29),('14598','2013-04-19','16:30:00',3.14),('14598','2013-04-19','16:35:00',3.71),('14598','2013-04-19','16:40:00',3.57),('14598','2013-04-19','16:45:00',3.51),('14598','2013-04-19','16:50:00',3.41),('14598','2013-04-19','16:55:00',3.33),('14598','2013-04-19','17:00:00',3.23),('14598','2013-04-19','17:05:00',3.14),('14598','2013-04-19','17:10:00',3.05),('14598','2013-04-19','17:15:00',2.95),('14598','2013-04-19','17:20:00',2.85),('14598','2013-04-19','17:25:00',2.74),('14598','2013-04-19','17:30:00',2.59),('14598','2013-04-19','17:35:00',2.43),('14598','2013-04-19','17:40:00',2.36),('14598','2013-04-19','17:45:00',2.27),('14598','2013-04-19','17:50:00',2.17),('14598','2013-04-19','17:55:00',2.07),('14598','2013-04-19','18:00:00',1.83),('14598','2013-04-19','18:05:00',1.67),('14598','2013-04-19','18:10:00',1.54),('14598','2013-04-19','18:15:00',1.4),('14598','2013-04-19','18:20:00',1.39),('14598','2013-04-19','18:30:00',1.14),('14598','2013-04-19','18:35:00',1.06),('14598','2013-04-18','08:25:00',1.01),('14598','2013-04-18','08:30:00',1.22),('14598','2013-04-18','08:35:00',1.41),('14598','2013-04-18','08:40:00',1.52),('14598','2013-04-18','08:45:00',1.66),('14598','2013-04-18','08:50:00',1.56),('14598','2013-04-18','08:55:00',1.5),('14598','2013-04-18','09:00:00',1.87),('14598','2013-04-18','09:05:00',2.16),('14598','2013-04-18','09:10:00',2.31),('14598','2013-04-18','09:15:00',2.3),('14598','2013-04-18','09:20:00',2.5),('14598','2013-04-18','09:25:00',2.6),('14598','2013-04-18','09:30:00',2.69),('14598','2013-04-18','09:35:00',2.78),('14598','2013-04-18','09:40:00',2.88),('14598','2013-04-18','09:45:00',2.96),('14598','2013-04-18','09:50:00',3.05),('14598','2013-04-18','09:55:00',3.13),('14598','2013-04-18','10:00:00',3.21),('14598','2013-04-18','10:05:00',3.23),('14598','2013-04-18','10:10:00',3.36),('14598','2013-04-18','10:15:00',3.43),('14598','2013-04-18','10:20:00',3.51),('14598','2013-04-18','10:25:00',3.59),('14598','2013-04-18','10:30:00',3.63),('14598','2013-04-18','10:35:00',3.72),('14598','2013-04-18','10:40:00',3.8),('14598','2013-04-18','10:45:00',3.86),('14598','2013-04-18','10:50:00',3.93),('14598','2013-04-18','10:55:00',4),('14598','2013-04-18','11:00:00',4.07),('14598','2013-04-18','11:05:00',4.14),('14598','2013-04-18','11:10:00',4.22),('14598','2013-04-18','11:15:00',4.28),('14598','2013-04-18','11:20:00',4.31),('14598','2013-04-18','11:25:00',4.41),('14598','2013-04-18','11:30:00',4.47),('14598','2013-04-18','11:35:00',4.5),('14598','2013-04-18','11:40:00',4.52),('14598','2013-04-18','11:45:00',4.52),('14598','2013-04-18','11:50:00',4.54),('14598','2013-04-18','11:55:00',4.59),('14598','2013-04-18','12:00:00',4.65),('14598','2013-04-18','12:05:00',4.63),('14598','2013-04-18','12:10:00',4.76),('14598','2013-04-18','12:15:00',4.79),('14598','2013-04-18','12:20:00',4.79),('14598','2013-04-18','12:25:00',4.79),('14598','2013-04-18','12:30:00',4.83),('14598','2013-04-18','12:35:00',4.9),('14598','2013-04-18','12:40:00',4.97),('14598','2013-04-18','12:45:00',5),('14598','2013-04-18','12:50:00',5.05),('14598','2013-04-18','12:55:00',5.06),('14598','2013-04-18','13:00:00',5.06),('14598','2013-04-18','13:05:00',5.06),('14598','2013-04-18','13:10:00',5.11),('14598','2013-04-18','13:15:00',5.12),('14598','2013-04-18','13:20:00',5.15),('14598','2013-04-18','13:25:00',5.16),('14598','2013-04-18','13:30:00',5.18),('14598','2013-04-18','13:35:00',5.2),('14598','2013-04-18','13:40:00',5.2),('14598','2013-04-18','13:45:00',5.21),('14598','2013-04-18','13:50:00',5.21),('14598','2013-04-18','13:55:00',5.19),('14598','2013-04-18','14:00:00',5.09),('14598','2013-04-18','14:05:00',5.16),('14598','2013-04-18','14:10:00',5.1),('14598','2013-04-18','14:15:00',5.11),('14598','2013-04-18','14:20:00',5.02),('14598','2013-04-18','14:25:00',5.07),('14598','2013-04-18','14:30:00',5.04),('14598','2013-04-18','14:35:00',5.02),('14598','2013-04-18','14:40:00',5),('14598','2013-04-18','14:45:00',4.96),('14598','2013-04-18','14:50:00',4.92),('14598','2013-04-18','14:55:00',4.86),('14598','2013-04-18','15:00:00',4.83),('14598','2013-04-18','15:05:00',4.81),('14598','2013-04-18','15:10:00',4.8),('14598','2013-04-18','15:15:00',4.76),('14598','2013-04-18','15:20:00',4.66),('14598','2013-04-18','15:25:00',4.64),('14598','2013-04-18','15:30:00',4.59),('14598','2013-04-18','15:35:00',4.55),('14598','2013-04-18','15:40:00',4.5),('14598','2013-04-18','15:45:00',4.46),('14598','2013-04-18','15:50:00',4.42),('14598','2013-04-18','15:55:00',4.36),('14598','2013-04-18','16:00:00',4.29),('14598','2013-04-18','16:05:00',4.22),('14598','2013-04-18','16:10:00',4.17),('14598','2013-04-18','16:15:00',4.1),('14598','2013-04-18','16:20:00',4.04),('14598','2013-04-18','16:25:00',3.96),('14598','2013-04-18','16:30:00',3.9),('14598','2013-04-18','16:35:00',3.8),('14598','2013-04-18','16:40:00',3.72),('14598','2013-04-18','16:45:00',3.65),('14598','2013-04-18','16:50:00',3.56),('14598','2013-04-18','16:55:00',3.48),('14598','2013-04-18','17:00:00',3.38),('14598','2013-04-18','17:05:00',3.28),('14598','2013-04-18','17:10:00',3.18),('14598','2013-04-18','17:15:00',3.09),('14598','2013-04-18','17:20:00',2.98),('14598','2013-04-18','17:25:00',2.89),('14598','2013-04-18','17:30:00',2.78),('14598','2013-04-18','17:35:00',2.66),('14598','2013-04-18','17:40:00',2.56),('14598','2013-04-18','17:45:00',2.45),('14598','2013-04-18','17:50:00',2.34),('14598','2013-04-18','17:55:00',2.21),('14598','2013-04-18','18:00:00',2.06),('14598','2013-04-18','18:05:00',1.92),('14598','2013-04-18','18:10:00',1.82),('14598','2013-04-18','18:15:00',1.72),('14598','2013-04-18','18:20:00',1.61),('14598','2013-04-18','18:25:00',1.49),('14598','2013-04-18','18:30:00',1.37),('14598','2013-04-18','18:35:00',1.26),('14598','2013-04-18','18:40:00',1.15),('14598','2013-04-18','18:45:00',1.04),('14598','2013-04-17','08:20:00',1.04),('14598','2013-04-17','08:25:00',1.14),('14598','2013-04-17','08:30:00',1.24),('14598','2013-04-17','08:35:00',1.34),('14598','2013-04-17','08:40:00',1.46),('14598','2013-04-17','08:45:00',1.57),('14598','2013-04-17','08:50:00',1.68),('14598','2013-04-17','08:55:00',1.78),('14598','2013-04-17','09:00:00',1.91),('14598','2013-04-17','09:05:00',2.05),('14598','2013-04-17','09:10:00',2.17),('14598','2013-04-17','09:15:00',2.29),('14598','2013-04-17','09:20:00',2.4),('14598','2013-04-17','09:25:00',2.5),('14598','2013-04-17','09:30:00',2.59),('14598','2013-04-17','09:35:00',2.7),('14598','2013-04-17','09:40:00',2.8),('14598','2013-04-17','09:45:00',2.89),('14598','2013-04-17','09:50:00',2.97),('14598','2013-04-17','09:55:00',3.05),('14598','2013-04-17','10:00:00',3.14),('14598','2013-04-17','10:05:00',3.22),('14598','2013-04-17','10:10:00',3.3),('14598','2013-04-17','10:15:00',3.39),('14598','2013-04-17','10:20:00',3.47),('14598','2013-04-17','10:25:00',3.54),('14598','2013-04-17','10:30:00',3.61),('14598','2013-04-17','10:35:00',3.68),('14598','2013-04-17','10:40:00',3.73),('14598','2013-04-17','10:45:00',3.78),('14598','2013-04-17','10:50:00',3.83),('14598','2013-04-17','10:55:00',3.84),('14598','2013-04-17','11:00:00',3.95),('14598','2013-04-17','11:05:00',4.02),('14598','2013-04-17','11:10:00',4.06),('14598','2013-04-17','11:15:00',4.13),('14598','2013-04-17','11:20:00',4.19),('14598','2013-04-17','11:25:00',4.24),('14598','2013-04-17','11:30:00',4.27),('14598','2013-04-17','11:35:00',4.39),('14598','2013-04-17','11:40:00',4.52),('14598','2013-04-17','11:45:00',4.59),('14598','2013-04-17','11:50:00',4.64),('14598','2013-04-17','11:55:00',4.7),('14598','2013-04-17','12:00:00',4.74),('14598','2013-04-17','12:05:00',4.77),('14598','2013-04-17','12:10:00',4.69),('14598','2013-04-17','12:15:00',4.82),('14598','2013-04-17','12:20:00',4.87),('14598','2013-04-17','12:25:00',4.85),('14598','2013-04-17','12:30:00',4.85),('14598','2013-04-17','12:35:00',4.99),('14598','2013-04-17','12:40:00',4.98),('14598','2013-04-17','12:45:00',5.01),('14598','2013-04-17','12:50:00',4.96),('14598','2013-04-17','12:55:00',5.12),('14598','2013-04-17','13:00:00',5.17),('14598','2013-04-17','13:05:00',5.03),('14598','2013-04-17','13:10:00',5.05),('14598','2013-04-17','13:15:00',5.31),('14598','2013-04-17','13:20:00',4.89),('14598','2013-04-17','13:25:00',4.74),('14598','2013-04-17','13:30:00',5.33),('14598','2013-04-17','13:35:00',5.25),('14598','2013-04-17','13:40:00',4.96),('14598','2013-04-17','13:45:00',5.01),('14598','2013-04-17','13:50:00',5.32),('14598','2013-04-17','13:55:00',5.27),('14598','2013-04-17','14:00:00',5.36),('14598','2013-04-17','14:05:00',5),('14598','2013-04-17','14:10:00',5.08),('14598','2013-04-17','14:15:00',5.32),('14598','2013-04-17','14:20:00',5.39),('14598','2013-04-17','14:25:00',5.31),('14598','2013-04-17','14:30:00',5.26),('14598','2013-04-17','14:35:00',5.23),('14598','2013-04-17','14:40:00',5.27),('14598','2013-04-17','14:45:00',5.37),('14598','2013-04-17','14:50:00',5.11),('14598','2013-04-17','14:55:00',4.4),('14598','2013-04-17','15:00:00',3.7),('14598','2013-04-17','15:05:00',3.35),('14598','2013-04-17','15:10:00',2.9),('14598','2013-04-17','15:15:00',2.4),('14598','2013-04-17','15:20:00',2.94),('14598','2013-04-17','15:25:00',3.21),('14598','2013-04-17','15:30:00',3.68),('14598','2013-04-17','15:35:00',4.39),('14598','2013-04-17','15:40:00',4.73),('14598','2013-04-17','15:45:00',4.83),('14598','2013-04-17','15:50:00',4.99),('14598','2013-04-17','15:55:00',4.92),('14598','2013-04-17','16:00:00',4.68),('14598','2013-04-17','16:05:00',4.41),('14598','2013-04-17','16:10:00',4.2),('14598','2013-04-17','16:15:00',4.26),('14598','2013-04-17','16:20:00',3.61),('14598','2013-04-17','16:25:00',3.71),('14598','2013-04-17','16:30:00',3.94),('14598','2013-04-17','16:35:00',3.84),('14598','2013-04-17','16:40:00',3.75),('14598','2013-04-17','16:45:00',3.65),('14598','2013-04-17','16:50:00',3.57),('14598','2013-04-17','16:55:00',3.42),('14598','2013-04-17','17:00:00',3.37),('14598','2013-04-17','17:05:00',3.27),('14598','2013-04-17','17:10:00',3.17),('14598','2013-04-17','17:15:00',3.07),('14598','2013-04-17','17:20:00',2.97),('14598','2013-04-17','17:25:00',2.89),('14598','2013-04-17','17:30:00',2.79),('14598','2013-04-17','17:35:00',2.67),('14598','2013-04-17','17:40:00',2.57),('14598','2013-04-17','17:45:00',2.45),('14598','2013-04-17','17:50:00',2.33),('14598','2013-04-17','17:55:00',2.22),('14598','2013-04-17','18:00:00',2.1),('14598','2013-04-17','18:05:00',1.99),('14598','2013-04-17','18:10:00',1.86),('14598','2013-04-17','18:15:00',1.78),('14598','2013-04-17','18:20:00',1.66),('14598','2013-04-17','18:25:00',1.55),('14598','2013-04-17','18:30:00',1.42),('14598','2013-04-17','18:35:00',1.29),('14598','2013-04-17','18:40:00',1.17),('14598','2013-04-17','18:45:00',1.06),('14598','2013-04-16','08:25:00',1.05),('14598','2013-04-16','08:30:00',1.18),('14598','2013-04-16','08:35:00',1.27),('14598','2013-04-16','08:40:00',1.37),('14598','2013-04-16','08:45:00',1.48),('14598','2013-04-16','08:50:00',1.57),('14598','2013-04-16','08:55:00',1.67),('14598','2013-04-16','09:00:00',1.8),('14598','2013-04-16','09:05:00',1.98),('14598','2013-04-16','09:10:00',1.54),('14598','2013-04-16','09:15:00',1.08),('14598','2013-04-16','09:25:00',1.27),('14598','2013-04-16','09:30:00',2.15),('14598','2013-04-16','09:35:00',1.96),('14598','2013-04-16','09:40:00',1.88),('14598','2013-04-16','09:45:00',1.97),('14598','2013-04-16','09:50:00',1.81),('14598','2013-04-16','09:55:00',2.13),('14598','2013-04-16','10:00:00',1.91),('14598','2013-04-16','10:05:00',1.94),('14598','2013-04-16','10:10:00',1.68),('14598','2013-04-16','10:15:00',1.7),('14598','2013-04-16','10:20:00',1.79),('14598','2013-04-16','10:25:00',1.7),('14598','2013-04-16','10:30:00',1.78),('14598','2013-04-16','10:35:00',1.75),('14598','2013-04-16','10:40:00',1.63),('14598','2013-04-16','10:45:00',1.55),('14598','2013-04-16','10:50:00',1.6),('14598','2013-04-16','10:55:00',1.69),('14598','2013-04-16','11:00:00',1.75),('14598','2013-04-16','11:05:00',1.76),('14598','2013-04-16','11:10:00',1.82),('14598','2013-04-16','11:15:00',2.11),('14598','2013-04-16','11:20:00',2.26),('14598','2013-04-16','11:25:00',2.41),('14598','2013-04-16','11:30:00',2.53),('14598','2013-04-16','11:35:00',2.49),('14598','2013-04-16','11:40:00',2.45),('14598','2013-04-16','11:45:00',2.62),('14598','2013-04-16','11:50:00',2.86),('14598','2013-04-16','11:55:00',2.97),('14598','2013-04-16','12:00:00',3),('14598','2013-04-16','12:05:00',3.37),('14598','2013-04-16','12:10:00',3.97),('14598','2013-04-16','12:15:00',3.92),('14598','2013-04-16','12:20:00',3.29),('14598','2013-04-16','12:25:00',4.23),('14598','2013-04-16','12:30:00',4.16),('14598','2013-04-16','12:35:00',5.11),('14598','2013-04-16','12:40:00',4.26),('14598','2013-04-16','12:45:00',4.2),('14598','2013-04-16','12:50:00',4.79),('14598','2013-04-16','12:55:00',4.43),('14598','2013-04-16','13:00:00',4.84),('14598','2013-04-16','13:05:00',5),('14598','2013-04-16','13:10:00',5.04),('14598','2013-04-16','13:15:00',5.05),('14598','2013-04-16','13:20:00',5.05),('14598','2013-04-16','13:25:00',5.05),('14598','2013-04-16','13:30:00',5.06),('14598','2013-04-16','13:35:00',5.1),('14598','2013-04-16','13:40:00',5.14),('14598','2013-04-16','13:45:00',5.16),('14598','2013-04-16','13:50:00',5),('14598','2013-04-16','13:55:00',4.79),('14598','2013-04-16','14:00:00',4.76),('14598','2013-04-16','14:05:00',4.98),('14598','2013-04-16','14:10:00',5.06),('14598','2013-04-16','14:15:00',5.23),('14598','2013-04-16','14:20:00',5.24),('14598','2013-04-16','14:25:00',5.08),('14598','2013-04-16','14:30:00',5.15),('14598','2013-04-16','14:35:00',3.69),('14598','2013-04-16','14:40:00',4.59),('14598','2013-04-16','14:45:00',5.1),('14598','2013-04-16','14:50:00',5.01),('14598','2013-04-16','14:55:00',5.28),('14598','2013-04-16','15:00:00',3.68),('14598','2013-04-16','15:05:00',2.36),('14598','2013-04-16','15:10:00',3.23),('14598','2013-04-16','15:15:00',5.07),('14598','2013-04-16','15:20:00',4.76),('14598','2013-04-16','15:25:00',4.67),('14598','2013-04-16','15:30:00',4.6),('14598','2013-04-16','15:35:00',4.36),('14598','2013-04-16','15:40:00',4.42),('14598','2013-04-16','15:45:00',4.23),('14598','2013-04-16','15:50:00',4.25),('14598','2013-04-16','15:55:00',4.29),('14598','2013-04-16','16:00:00',4.24),('14598','2013-04-16','16:05:00',4.17),('14598','2013-04-16','16:10:00',4.13),('14598','2013-04-16','16:15:00',4.11),('14598','2013-04-16','16:20:00',4.06),('14598','2013-04-16','16:25:00',3.69),('14598','2013-04-16','16:30:00',3.25),('14598','2013-04-16','16:35:00',2.02),('14598','2013-04-16','16:40:00',2.05),('14598','2013-04-16','16:45:00',3.62),('14598','2013-04-16','16:50:00',3.59),('14598','2013-04-16','16:55:00',3.39),('14598','2013-04-16','17:00:00',3.29),('14598','2013-04-16','17:05:00',3.2),('14598','2013-04-16','17:10:00',3.09),('14598','2013-04-16','17:15:00',2.99),('14598','2013-04-16','17:20:00',2.89),('14598','2013-04-16','17:25:00',2.79),('14598','2013-04-16','17:30:00',2.68),('14598','2013-04-16','17:35:00',2.57),('14598','2013-04-16','17:40:00',2.45),('14598','2013-04-16','17:45:00',2.3),('14598','2013-04-16','17:50:00',2.23),('14598','2013-04-16','17:55:00',2.14),('14598','2013-04-16','18:00:00',2.04),('14598','2013-04-16','18:05:00',1.9),('14598','2013-04-16','18:10:00',1.38),('14598','2013-04-16','18:15:00',1.6),('14598','2013-04-16','18:20:00',1.54),('14598','2013-04-16','18:25:00',1.41),('14598','2013-04-16','18:30:00',1.26),('14598','2013-04-16','18:35:00',1.16),('14598','2013-04-16','18:40:00',1.05),('14598','2013-04-15','08:25:00',1.09),('14598','2013-04-15','08:30:00',1.2),('14598','2013-04-15','08:35:00',1.32),('14598','2013-04-15','08:40:00',1.42),('14598','2013-04-15','08:45:00',1.52),('14598','2013-04-15','08:50:00',1.63),('14598','2013-04-15','08:55:00',1.74),('14598','2013-04-15','09:00:00',1.86),('14598','2013-04-15','09:05:00',2),('14598','2013-04-15','09:10:00',2.13),('14598','2013-04-15','09:15:00',2.27),('14598','2013-04-15','09:20:00',2.39),('14598','2013-04-15','09:25:00',2.48),('14598','2013-04-15','09:30:00',2.58),('14598','2013-04-15','09:35:00',2.67),('14598','2013-04-15','09:40:00',2.76),('14598','2013-04-15','09:45:00',2.86),('14598','2013-04-15','09:50:00',2.96),('14598','2013-04-15','09:55:00',3.05),('14598','2013-04-15','10:00:00',3.14),('14598','2013-04-15','10:05:00',3.22),('14598','2013-04-15','10:10:00',3.3),('14598','2013-04-15','10:15:00',3.37),('14598','2013-04-15','10:20:00',3.46),('14598','2013-04-15','10:25:00',3.53),('14598','2013-04-15','10:30:00',3.62),('14598','2013-04-15','10:35:00',3.67),('14598','2013-04-15','10:40:00',3.67),('14598','2013-04-15','10:45:00',3.82),('14598','2013-04-15','10:50:00',3.88),('14598','2013-04-15','10:55:00',3.93),('14598','2013-04-15','11:00:00',3.98),('14598','2013-04-15','11:05:00',4.03),('14598','2013-04-15','11:10:00',4.09),('14598','2013-04-15','11:15:00',4.12),('14598','2013-04-15','11:20:00',4.17),('14598','2013-04-15','11:25:00',4.23),('14598','2013-04-15','11:30:00',4.29),('14598','2013-04-15','11:35:00',4.34),('14598','2013-04-15','11:40:00',4.38),('14598','2013-04-15','11:45:00',4.41),('14598','2013-04-15','11:50:00',4.46),('14598','2013-04-15','11:55:00',4.47),('14598','2013-04-15','12:00:00',4.54),('14598','2013-04-15','12:05:00',4.57),('14598','2013-04-15','12:10:00',4.7),('14598','2013-04-15','12:15:00',4.79),('14598','2013-04-15','12:20:00',4.83),('14598','2013-04-15','12:25:00',4.88),('14598','2013-04-15','12:30:00',4.95),('14598','2013-04-15','12:35:00',4.97),('14598','2013-04-15','12:40:00',5),('14598','2013-04-15','12:45:00',5.02),('14598','2013-04-15','12:50:00',5.05),('14598','2013-04-15','12:55:00',5.09),('14598','2013-04-15','13:00:00',5.12),('14598','2013-04-15','13:05:00',5.14),('14598','2013-04-15','13:10:00',5.14),('14598','2013-04-15','13:15:00',5.13),('14598','2013-04-15','13:20:00',5.13),('14598','2013-04-15','13:25:00',5.14),('14598','2013-04-15','13:30:00',5.17),('14598','2013-04-15','13:35:00',5.2),('14598','2013-04-15','13:40:00',5.24),('14598','2013-04-15','13:45:00',5.2),('14598','2013-04-15','13:50:00',5.19),('14598','2013-04-15','13:55:00',5.19),('14598','2013-04-15','14:00:00',5.18),('14598','2013-04-15','14:05:00',5.17),('14598','2013-04-15','14:10:00',5.17),('14598','2013-04-15','14:15:00',5.15),('14598','2013-04-15','14:20:00',5.12),('14598','2013-04-15','14:25:00',5.09),('14598','2013-04-15','14:30:00',5.07),('14598','2013-04-15','14:35:00',5.05),('14598','2013-04-15','14:40:00',5.01),('14598','2013-04-15','14:45:00',5.01),('14598','2013-04-15','14:50:00',5.01),('14598','2013-04-15','14:55:00',4.97),('14598','2013-04-15','15:00:00',4.91),('14598','2013-04-15','15:05:00',4.91),('14598','2013-04-15','15:10:00',4.86),('14598','2013-04-15','15:15:00',4.81),('14598','2013-04-15','15:20:00',4.76),('14598','2013-04-15','15:25:00',4.72),('14598','2013-04-15','15:30:00',4.67),('14598','2013-04-15','15:35:00',4.64),('14598','2013-04-15','15:40:00',4.59),('14598','2013-04-15','15:45:00',4.51),('14598','2013-04-15','15:50:00',4.46),('14598','2013-04-15','15:55:00',4.41),('14598','2013-04-15','16:00:00',4.33),('14598','2013-04-15','16:05:00',4.27),('14598','2013-04-15','16:10:00',4.19),('14598','2013-04-15','16:15:00',4.11),('14598','2013-04-15','16:20:00',4.06),('14598','2013-04-15','16:25:00',4),('14598','2013-04-15','16:30:00',3.93),('14598','2013-04-15','16:35:00',3.85),('14598','2013-04-15','16:40:00',3.75),('14598','2013-04-15','16:45:00',3.6),('14598','2013-04-15','16:50:00',3.59),('14598','2013-04-15','16:55:00',3.5),('14598','2013-04-15','17:00:00',3.41),('14598','2013-04-15','17:05:00',3.32),('14598','2013-04-15','17:10:00',3.22),('14598','2013-04-15','17:15:00',3.13),('14598','2013-04-15','17:20:00',3.02),('14598','2013-04-15','17:25:00',2.92),('14598','2013-04-15','17:30:00',2.82),('14598','2013-04-15','17:35:00',2.72),('14598','2013-04-15','17:40:00',2.62),('14598','2013-04-15','17:45:00',2.51),('14598','2013-04-15','17:50:00',2.4),('14598','2013-04-15','17:55:00',2.28),('14598','2013-04-15','18:00:00',2.16),('14598','2013-04-15','18:05:00',2.05),('14598','2013-04-15','18:10:00',1.93),('14598','2013-04-15','18:15:00',1.82),('14598','2013-04-15','18:20:00',1.69),('14598','2013-04-15','18:25:00',1.57),('14598','2013-04-15','18:30:00',1.45),('14598','2013-04-15','18:35:00',1.33),('14598','2013-04-15','18:40:00',1.22),('14598','2013-04-15','18:45:00',1.1),('14598','2013-04-14','08:25:00',1.02),('14598','2013-04-14','08:30:00',1.09),('14598','2013-04-14','08:35:00',1.24),('14598','2013-04-14','08:40:00',1.35),('14598','2013-04-14','08:45:00',1.45),('14598','2013-04-14','08:50:00',1.55),('14598','2013-04-14','08:55:00',1.67),('14598','2013-04-14','09:00:00',1.78),('14598','2013-04-14','09:05:00',1.91),('14598','2013-04-14','09:10:00',2.02),('14598','2013-04-14','09:15:00',2.17),('14598','2013-04-14','09:20:00',2.27),('14598','2013-04-14','09:25:00',2.38),('14598','2013-04-14','09:30:00',2.47),('14598','2013-04-14','09:35:00',2.55),('14598','2013-04-14','09:40:00',2.65),('14598','2013-04-14','09:45:00',2.75),('14598','2013-04-14','09:50:00',2.83),('14598','2013-04-14','09:55:00',2.92),('14598','2013-04-14','10:00:00',3.01),('14598','2013-04-14','10:05:00',3.11),('14598','2013-04-14','10:10:00',3.18),('14598','2013-04-14','10:15:00',3.25),('14598','2013-04-14','10:20:00',3.33),('14598','2013-04-14','10:25:00',3.42),('14598','2013-04-14','10:30:00',3.46),('14598','2013-04-14','10:35:00',3.56),('14598','2013-04-14','10:40:00',3.63),('14598','2013-04-14','10:45:00',3.69),('14598','2013-04-14','10:50:00',3.75),('14598','2013-04-14','10:55:00',3.8),('14598','2013-04-14','11:00:00',3.86),('14598','2013-04-14','11:05:00',3.92),('14598','2013-04-14','11:10:00',3.97),('14598','2013-04-14','11:15:00',4.05),('14598','2013-04-14','11:20:00',4.16),('14598','2013-04-14','11:25:00',4.24),('14598','2013-04-14','11:30:00',4.29),('14598','2013-04-14','11:35:00',4.36),('14598','2013-04-14','11:40:00',4.41),('14598','2013-04-14','11:45:00',4.46),('14598','2013-04-14','11:50:00',4.52),('14598','2013-04-14','11:55:00',4.57),('14598','2013-04-14','12:00:00',4.59),('14598','2013-04-14','12:05:00',4.63),('14598','2013-04-14','12:10:00',4.67),('14598','2013-04-14','12:15:00',4.69),('14598','2013-04-14','12:20:00',4.73),('14598','2013-04-14','12:25:00',4.74),('14598','2013-04-14','12:30:00',4.78),('14598','2013-04-14','12:35:00',4.83),('14598','2013-04-14','12:40:00',4.86),('14598','2013-04-14','12:45:00',4.89),('14598','2013-04-14','12:50:00',4.91),('14598','2013-04-14','12:55:00',4.95),('14598','2013-04-14','13:00:00',4.95),('14598','2013-04-14','13:05:00',4.98),('14598','2013-04-14','13:10:00',5),('14598','2013-04-14','13:15:00',5),('14598','2013-04-14','13:20:00',5.04),('14598','2013-04-14','13:25:00',5.04),('14598','2013-04-14','13:30:00',4.98),('14598','2013-04-14','13:35:00',5.06),('14598','2013-04-14','13:40:00',5.06),('14598','2013-04-14','13:45:00',5.06),('14598','2013-04-14','13:50:00',5.03),('14598','2013-04-14','13:55:00',5.03),('14598','2013-04-14','14:00:00',5.06),('14598','2013-04-14','14:05:00',5.05),('14598','2013-04-14','14:10:00',5.04),('14598','2013-04-14','14:15:00',5.03),('14598','2013-04-14','14:20:00',5.01),('14598','2013-04-14','14:25:00',4.98),('14598','2013-04-14','14:30:00',4.96),('14598','2013-04-14','14:35:00',4.95),('14598','2013-04-14','14:40:00',4.93),('14598','2013-04-14','14:45:00',4.87),('14598','2013-04-14','14:50:00',4.88),('14598','2013-04-14','14:55:00',4.86),('14598','2013-04-14','15:00:00',4.82),('14598','2013-04-14','15:05:00',4.8),('14598','2013-04-14','15:10:00',4.75),('14598','2013-04-14','15:15:00',4.68),('14598','2013-04-14','15:20:00',4.65),('14598','2013-04-14','15:25:00',4.59),('14598','2013-04-14','15:30:00',4.58),('14598','2013-04-14','15:35:00',4.51),('14598','2013-04-14','15:40:00',4.45),('14598','2013-04-14','15:45:00',4.39),('14598','2013-04-14','15:50:00',4.33),('14598','2013-04-14','15:55:00',4.27),('14598','2013-04-14','16:00:00',4.2),('14598','2013-04-14','16:05:00',4.12),('14598','2013-04-14','16:10:00',4.05),('14598','2013-04-14','16:15:00',3.98),('14598','2013-04-14','16:20:00',3.9),('14598','2013-04-14','16:25:00',3.83),('14598','2013-04-14','16:30:00',3.73),('14598','2013-04-14','16:35:00',3.68),('14598','2013-04-14','16:40:00',3.59),('14598','2013-04-14','16:45:00',3.51),('14598','2013-04-14','16:50:00',3.44),('14598','2013-04-14','16:55:00',3.35),('14598','2013-04-14','17:00:00',3.25),('14598','2013-04-14','17:05:00',3.13),('14598','2013-04-14','17:10:00',3.04),('14598','2013-04-14','17:15:00',2.97),('14598','2013-04-14','17:20:00',2.88),('14598','2013-04-14','17:25:00',2.78),('14598','2013-04-14','17:30:00',2.68),('14598','2013-04-14','17:35:00',2.57),('14598','2013-04-14','17:40:00',2.48),('14598','2013-04-14','17:45:00',2.38),('14598','2013-04-14','17:50:00',2.26),('14598','2013-04-14','17:55:00',2.13),('14598','2013-04-14','18:00:00',2.04),('14598','2013-04-14','18:05:00',1.93),('14598','2013-04-14','18:10:00',1.8),('14598','2013-04-14','18:15:00',1.67),('14598','2013-04-14','18:20:00',1.55),('14598','2013-04-14','18:25:00',1.45),('14598','2013-04-14','18:30:00',1.32),('14598','2013-04-14','18:35:00',1.2),('14598','2013-04-14','18:40:00',1.08),('14598','2013-04-13','08:40:00',1.01),('14598','2013-04-13','08:45:00',1.1),('14598','2013-04-13','08:50:00',1.69),('14598','2013-04-13','08:55:00',2.12),('14598','2013-04-13','09:00:00',2.26),('14598','2013-04-13','09:05:00',2.4),('14598','2013-04-13','09:10:00',2.47),('14598','2013-04-13','09:15:00',1.77),('14598','2013-04-13','09:25:00',1.09),('14598','2013-04-13','09:35:00',2.47),('14598','2013-04-13','09:40:00',2.75),('14598','2013-04-13','09:45:00',2.84),('14598','2013-04-13','09:50:00',2.91),('14598','2013-04-13','09:55:00',2.54),('14598','2013-04-13','10:00:00',3.12),('14598','2013-04-13','10:05:00',3.1),('14598','2013-04-13','10:10:00',3.24),('14598','2013-04-13','10:15:00',3.38),('14598','2013-04-13','10:20:00',3.46),('14598','2013-04-13','10:25:00',3.58),('14598','2013-04-13','10:30:00',3.49),('14598','2013-04-13','10:35:00',3.3),('14598','2013-04-13','10:40:00',3.83),('14598','2013-04-13','10:45:00',3.97),('14598','2013-04-13','10:50:00',3.5),('14598','2013-04-13','10:55:00',3.98),('14598','2013-04-13','11:00:00',3.87),('14598','2013-04-13','11:05:00',3.82),('14598','2013-04-13','11:10:00',4.15),('14598','2013-04-13','11:15:00',4.16),('14598','2013-04-13','11:20:00',4.19),('14598','2013-04-13','11:25:00',4.36),('14598','2013-04-13','11:30:00',4.38),('14598','2013-04-13','11:35:00',4.36),('14598','2013-04-13','11:40:00',4.54),('14598','2013-04-13','11:45:00',4.55),('14598','2013-04-13','11:50:00',4.64),('14598','2013-04-13','11:55:00',4.7),('14598','2013-04-13','12:00:00',4.58),('14598','2013-04-13','12:05:00',4.75),('14598','2013-04-13','12:10:00',4.79),('14598','2013-04-13','12:15:00',4.82),('14598','2013-04-13','12:20:00',4.92),('14598','2013-04-13','12:25:00',4.92),('14598','2013-04-13','12:30:00',4.94),('14598','2013-04-13','12:35:00',5.05),('14598','2013-04-13','12:40:00',5.02),('14598','2013-04-13','12:45:00',4.87),('14598','2013-04-13','12:50:00',4.96),('14598','2013-04-13','12:55:00',5.06),('14598','2013-04-13','13:00:00',5.25),('14598','2013-04-13','13:05:00',5.12),('14598','2013-04-13','13:10:00',4.89),('14598','2013-04-13','13:15:00',4.97),('14598','2013-04-13','13:20:00',5.03),('14598','2013-04-13','13:25:00',4.77),('14598','2013-04-13','13:30:00',4.46),('14598','2013-04-13','13:35:00',4.54),('14598','2013-04-13','13:40:00',4.37),('14598','2013-04-13','13:45:00',4.42),('14598','2013-04-13','13:50:00',4.43),('14598','2013-04-13','13:55:00',4.33),('14598','2013-04-13','14:00:00',4.37),('14598','2013-04-13','14:05:00',4.27),('14598','2013-04-13','14:10:00',4.36),('14598','2013-04-13','14:15:00',4.43),('14598','2013-04-13','14:20:00',4.7),('14598','2013-04-13','14:25:00',4.84),('14598','2013-04-13','14:30:00',4.78),('14598','2013-04-13','14:35:00',4.73),('14598','2013-04-13','14:40:00',4.68),('14598','2013-04-13','14:45:00',4.54),('14598','2013-04-13','14:50:00',4.29),('14598','2013-04-13','14:55:00',4.2),('14598','2013-04-13','15:00:00',4.33),('14598','2013-04-13','15:05:00',4.07),('14598','2013-04-13','15:10:00',3.85),('14598','2013-04-13','15:15:00',3.71),('14598','2013-04-13','15:20:00',3.7),('14598','2013-04-13','15:25:00',3.65),('14598','2013-04-13','15:30:00',3.72),('14598','2013-04-13','15:35:00',3.81),('14598','2013-04-13','15:40:00',3.85),('14598','2013-04-13','15:45:00',3.81),('14598','2013-04-13','15:50:00',3.56),('14598','2013-04-13','15:55:00',3.67),('14598','2013-04-13','16:00:00',3.33),('14598','2013-04-13','16:05:00',3.28),('14598','2013-04-13','16:10:00',3.23),('14598','2013-04-13','16:15:00',3.21),('14598','2013-04-13','16:20:00',2.74),('14598','2013-04-13','16:25:00',2.7),('14598','2013-04-13','16:30:00',2.45),('14598','2013-04-13','16:35:00',1.96),('14598','2013-04-13','16:40:00',2),('14598','2013-04-13','16:45:00',2),('14598','2013-04-13','16:50:00',1.67),('14598','2013-04-13','16:55:00',2.31),('14598','2013-04-13','17:00:00',2.89),('14598','2013-04-13','17:05:00',2.39),('14598','2013-04-13','17:10:00',2.24),('14598','2013-04-13','17:15:00',2.18),('14598','2013-04-13','17:20:00',2.85),('14598','2013-04-13','17:25:00',2.06),('14598','2013-04-13','17:30:00',2.15),('14598','2013-04-13','17:35:00',1.75),('14598','2013-04-13','17:40:00',2.22),('14598','2013-04-13','17:45:00',1.76),('14598','2013-04-13','17:50:00',1.77),('14598','2013-04-13','17:55:00',1.81),('14598','2013-04-13','18:00:00',1.7),('14598','2013-04-13','18:05:00',1.19),('14598','2013-04-13','18:10:00',1.87),('14598','2013-04-13','18:15:00',1.57),('14598','2013-04-13','18:20:00',1.09),('14598','2013-04-13','18:30:00',1.47),('14598','2013-04-13','18:35:00',1.46),('14598','2013-04-13','18:40:00',1.31),('14598','2013-04-13','18:45:00',1.13),('14598','2013-04-13','18:50:00',1.09),('14598','2013-04-13','18:55:00',1.07),('14598','2013-04-12','08:50:00',1.07),('14598','2013-04-12','09:05:00',1.11),('14598','2013-04-12','09:45:00',1.01),('14598','2013-04-12','10:00:00',1.63),('14598','2013-04-12','10:05:00',1.34),('14598','2013-04-12','10:10:00',1.1),('14598','2013-04-12','10:15:00',1.85),('14598','2013-04-12','10:20:00',1.71),('14598','2013-04-12','10:25:00',1.65),('14598','2013-04-12','10:30:00',1.95),('14598','2013-04-12','10:35:00',1.88),('14598','2013-04-12','10:40:00',2.38),('14598','2013-04-12','10:45:00',3.99),('14598','2013-04-12','10:50:00',3.58),('14598','2013-04-12','10:55:00',2.83),('14598','2013-04-12','11:00:00',3.14),('14598','2013-04-12','11:05:00',3.39),('14598','2013-04-12','11:10:00',3.3),('14598','2013-04-12','11:15:00',4.42),('14598','2013-04-12','11:20:00',4.37),('14598','2013-04-12','11:25:00',4.42),('14598','2013-04-12','11:30:00',4.49),('14598','2013-04-12','11:35:00',4.53),('14598','2013-04-12','11:40:00',4.49),('14598','2013-04-12','11:45:00',4.48),('14598','2013-04-12','11:50:00',4.56),('14598','2013-04-12','11:55:00',4.41),('14598','2013-04-12','12:00:00',4.58),('14598','2013-04-12','12:05:00',4.83),('14598','2013-04-12','12:10:00',4.88),('14598','2013-04-12','12:15:00',4.96),('14598','2013-04-12','12:20:00',4.94),('14598','2013-04-12','12:25:00',4.84),('14598','2013-04-12','12:30:00',4.95),('14598','2013-04-12','12:35:00',4.7),('14598','2013-04-12','12:40:00',4.85),('14598','2013-04-12','12:45:00',4.94),('14598','2013-04-12','12:50:00',5.01),('14598','2013-04-12','12:55:00',5.05),('14598','2013-04-12','13:00:00',5.1),('14598','2013-04-12','13:05:00',5.11),('14598','2013-04-12','13:10:00',5.12),('14598','2013-04-12','13:15:00',5.11),('14598','2013-04-12','13:20:00',5.14),('14598','2013-04-12','13:25:00',5.17),('14598','2013-04-12','13:30:00',5.14),('14598','2013-04-12','13:35:00',5.19),('14598','2013-04-12','13:40:00',5.21),('14598','2013-04-12','13:45:00',5.19),('14598','2013-04-12','13:50:00',5.19),('14598','2013-04-12','13:55:00',5.17),('14598','2013-04-12','14:00:00',5.15),('14598','2013-04-12','14:05:00',5.13),('14598','2013-04-12','14:10:00',5.13),('14598','2013-04-12','14:15:00',5.11),('14598','2013-04-12','14:20:00',5.08),('14598','2013-04-12','14:25:00',5.06),('14598','2013-04-12','14:30:00',4.96),('14598','2013-04-12','14:35:00',5.03),('14598','2013-04-12','14:40:00',5),('14598','2013-04-12','14:45:00',4.97),('14598','2013-04-12','14:50:00',4.93),('14598','2013-04-12','14:55:00',4.89),('14598','2013-04-12','15:00:00',4.84),('14598','2013-04-12','15:05:00',4.81),('14598','2013-04-12','15:10:00',4.75),('14598','2013-04-12','15:15:00',4.72),('14598','2013-04-12','15:20:00',4.68),('14598','2013-04-12','15:25:00',4.61),('14598','2013-04-12','15:30:00',4.56),('14598','2013-04-12','15:35:00',4.5),('14598','2013-04-12','15:40:00',4.43),('14598','2013-04-12','15:45:00',4.37),('14598','2013-04-12','15:50:00',4.32),('14598','2013-04-12','15:55:00',4.27),('14598','2013-04-12','16:00:00',4.19),('14598','2013-04-12','16:05:00',4.15),('14598','2013-04-12','16:10:00',4.08),('14598','2013-04-12','16:15:00',3.98),('14598','2013-04-12','16:20:00',3.94),('14598','2013-04-12','16:25:00',3.86),('14598','2013-04-12','16:30:00',3.77),('14598','2013-04-12','16:35:00',3.71),('14598','2013-04-12','16:40:00',3.61),('14598','2013-04-12','16:45:00',3.53),('14598','2013-04-12','16:50:00',3.43),('14598','2013-04-12','16:55:00',3.35),('14598','2013-04-12','17:00:00',3.27),('14598','2013-04-12','17:05:00',3.19),('14598','2013-04-12','17:10:00',3.1),('14598','2013-04-12','17:15:00',3),('14598','2013-04-12','17:20:00',2.9),('14598','2013-04-12','17:25:00',2.81),('14598','2013-04-12','17:30:00',2.7),('14598','2013-04-12','17:35:00',2.59),('14598','2013-04-12','17:40:00',2.48),('14598','2013-04-12','17:45:00',2.36),('14598','2013-04-12','17:50:00',2.25),('14598','2013-04-12','17:55:00',2.12),('14598','2013-04-12','18:00:00',2.02),('14598','2013-04-12','18:05:00',1.9),('14598','2013-04-12','18:10:00',1.28),('14598','2013-04-12','18:15:00',1.08),('14598','2013-04-12','18:20:00',1.18),('14598','2014-03-28','07:50:00',1.09),('14598','2014-03-28','07:55:00',1.16),('14598','2014-03-28','08:00:00',1.29),('14598','2014-03-28','08:05:00',1.38),('14598','2014-03-28','08:10:00',1.5),('14598','2014-03-28','08:15:00',1.63),('14598','2014-03-28','08:20:00',1.78),('14598','2014-03-28','08:25:00',1.94),('14598','2014-03-28','08:30:00',2.08),('14598','2014-03-28','08:35:00',2.22),('14598','2014-03-28','08:40:00',2.4),('14598','2014-03-28','08:45:00',2.6),('14598','2014-03-28','08:50:00',2.85),('14598','2014-03-28','08:55:00',3.14),('14598','2014-03-28','09:00:00',2.74),('14598','2014-03-28','09:05:00',2.78),('14598','2014-03-28','09:10:00',3.19),('14598','2014-03-28','09:15:00',2.12),('14598','2014-03-28','09:20:00',1.88),('14598','2014-03-28','09:25:00',1.69),('14598','2014-03-28','09:30:00',1.83),('14598','2014-03-28','09:35:00',1.63),('14598','2014-03-28','09:40:00',2.36),('14598','2014-03-28','09:45:00',3.12),('14598','2014-03-28','09:50:00',3.66),('14598','2014-03-28','09:55:00',3.68),('14598','2014-03-28','10:00:00',3.71),('14598','2014-03-28','10:05:00',3.75),('14598','2014-03-28','10:10:00',3.8),('14598','2014-03-28','10:15:00',3.86),('14598','2014-03-28','10:20:00',3.9),('14598','2014-03-28','10:25:00',3.95),('14598','2014-03-28','10:30:00',4.01),('14598','2014-03-28','10:35:00',4.03),('14598','2014-03-28','10:40:00',4.13),('14598','2014-03-28','10:45:00',4.21),('14598','2014-03-28','10:50:00',4.36),('14598','2014-03-28','10:55:00',4.46),('14598','2014-03-28','11:00:00',4.24),('14598','2014-03-28','11:05:00',4.07),('14598','2014-03-28','11:10:00',4.49),('14598','2014-03-28','11:15:00',4.55),('14598','2014-03-28','11:20:00',4.61),('14598','2014-03-28','11:25:00',4.64),('14598','2014-03-28','11:30:00',4.65),('14598','2014-03-28','11:35:00',4.68),('14598','2014-03-28','11:40:00',4.71),('14598','2014-03-28','11:45:00',4.74),('14598','2014-03-28','11:50:00',4.76),('14598','2014-03-28','11:55:00',4.78),('14598','2014-03-28','12:00:00',4.8),('14598','2014-03-28','12:05:00',4.84),('14598','2014-03-28','12:10:00',4.8),('14598','2014-03-28','12:15:00',4.87),('14598','2014-03-28','12:20:00',4.88),('14598','2014-03-28','12:25:00',4.84),('14598','2014-03-28','12:30:00',4.92),('14598','2014-03-28','12:35:00',4.91),('14598','2014-03-28','12:40:00',4.92),('14598','2014-03-28','12:45:00',4.93),('14598','2014-03-28','12:50:00',4.96),('14598','2014-03-28','12:55:00',4.94),('14598','2014-03-28','13:00:00',4.91),('14598','2014-03-28','13:05:00',4.94),('14598','2014-03-28','13:10:00',4.92),('14598','2014-03-28','13:15:00',4.9),('14598','2014-03-28','13:20:00',4.36),('14598','2014-03-28','13:25:00',4.73),('14598','2014-03-28','13:30:00',4.77),('14598','2014-03-28','13:35:00',4.81),('14598','2014-03-28','13:40:00',4.8),('14598','2014-03-28','13:45:00',4.78),('14598','2014-03-28','13:50:00',4.73),('14598','2014-03-28','13:55:00',4.69),('14598','2014-03-28','14:00:00',4.65),('14598','2014-03-28','14:05:00',4.61),('14598','2014-03-28','14:10:00',4.59),('14598','2014-03-28','14:15:00',4.55),('14598','2014-03-28','14:20:00',4.51),('14598','2014-03-28','14:25:00',4.47),('14598','2014-03-28','14:30:00',4.42),('14598','2014-03-28','14:35:00',4.38),('14598','2014-03-28','14:40:00',4.34),('14598','2014-03-28','14:45:00',4.29),('14598','2014-03-28','14:50:00',4.21),('14598','2014-03-28','14:55:00',4.15),('14598','2014-03-28','15:00:00',4.07),('14598','2014-03-28','15:05:00',4.02),('14598','2014-03-28','15:10:00',3.93),('14598','2014-03-28','15:15:00',3.87),('14598','2014-03-28','15:20:00',3.82),('14598','2014-03-28','15:25:00',3.74),('14598','2014-03-28','15:30:00',3.68),('14598','2014-03-28','15:35:00',3.6),('14598','2014-03-28','15:40:00',3.51),('14598','2014-03-28','15:45:00',3.41),('14598','2014-03-28','15:50:00',3.34),('14598','2014-03-28','15:55:00',3.26),('14598','2014-03-28','16:00:00',3.16),('14598','2014-03-28','16:05:00',3.07),('14598','2014-03-28','16:10:00',2.96),('14598','2014-03-28','16:15:00',2.87),('14598','2014-03-28','16:20:00',2.77),('14598','2014-03-28','16:25:00',2.67),('14598','2014-03-28','16:30:00',2.56),('14598','2014-03-28','16:35:00',2.5),('14598','2014-03-28','16:40:00',2.47),('14598','2014-03-28','16:45:00',2.56),('14598','2014-03-28','16:50:00',2.59),('14598','2014-03-28','16:55:00',2.33),('14598','2014-03-28','17:00:00',1.89),('14598','2014-03-28','17:05:00',1.71),('14598','2014-03-28','17:10:00',1.58),('14598','2014-03-28','17:15:00',1.49),('14598','2014-03-28','17:20:00',1.23),('14598','2014-03-28','17:25:00',1.24),('14598','2014-03-28','17:30:00',1.1),('14598','2014-03-28','17:35:00',1.01),('14598','2013-04-11','08:30:00',1.03),('14598','2013-04-11','08:35:00',1.12),('14598','2013-04-11','08:40:00',1.24),('14598','2013-04-11','08:45:00',1.36),('14598','2013-04-11','08:50:00',1.48),('14598','2013-04-11','08:55:00',1.59),('14598','2013-04-11','09:00:00',1.7),('14598','2013-04-11','09:05:00',1.82),('14598','2013-04-11','09:10:00',1.96),('14598','2013-04-11','09:15:00',1.97),('14598','2013-04-11','09:20:00',1.92),('14598','2013-04-11','09:25:00',2.49),('14598','2013-04-11','09:30:00',2.74),('14598','2013-04-11','09:35:00',1.14),('14598','2013-04-11','09:40:00',1.65),('14598','2013-04-11','09:45:00',2.56),('14598','2013-04-11','09:50:00',3.36),('14598','2013-04-11','09:55:00',2.87),('14598','2013-04-11','10:00:00',2.7),('14598','2013-04-11','10:05:00',3.27),('14598','2013-04-11','10:10:00',2.57),('14598','2013-04-11','10:15:00',3.09),('14598','2013-04-11','10:20:00',2.96),('14598','2013-04-11','10:25:00',3.02),('14598','2013-04-11','10:30:00',3.57),('14598','2013-04-11','10:35:00',3.68),('14598','2013-04-11','10:40:00',3.79),('14598','2013-04-11','10:45:00',3.84),('14598','2013-04-11','10:50:00',3.87),('14598','2013-04-11','10:55:00',3.94),('14598','2013-04-11','11:00:00',4.01),('14598','2013-04-11','11:05:00',4.08),('14598','2013-04-11','11:10:00',4.15),('14598','2013-04-11','11:15:00',4.21),('14598','2013-04-11','11:20:00',4.27),('14598','2013-04-11','11:25:00',4.35),('14598','2013-04-11','11:30:00',4.4),('14598','2013-04-11','11:35:00',4.46),('14598','2013-04-11','11:40:00',4.52),('14598','2013-04-11','11:45:00',4.57),('14598','2013-04-11','11:50:00',4.62),('14598','2013-04-11','11:55:00',4.65),('14598','2013-04-11','12:00:00',4.69),('14598','2013-04-11','12:05:00',4.75),('14598','2013-04-11','12:10:00',4.8),('14598','2013-04-11','12:15:00',4.84),('14598','2013-04-11','12:20:00',4.82),('14598','2013-04-11','12:25:00',4.88),('14598','2013-04-11','12:30:00',4.93),('14598','2013-04-11','12:35:00',4.98),('14598','2013-04-11','12:40:00',4.99),('14598','2013-04-11','12:45:00',5.02),('14598','2013-04-11','12:50:00',5.02),('14598','2013-04-11','12:55:00',5.06),('14598','2013-04-11','13:00:00',5.07),('14598','2013-04-11','13:05:00',5.09),('14598','2013-04-11','13:10:00',5.1),('14598','2013-04-11','13:15:00',5.11),('14598','2013-04-11','13:20:00',5.11),('14598','2013-04-11','13:25:00',5.15),('14598','2013-04-11','13:30:00',5.17),('14598','2013-04-11','13:35:00',5.13),('14598','2013-04-11','13:40:00',4.84),('14598','2013-04-11','13:45:00',5.17),('14598','2013-04-11','13:50:00',5.17),('14598','2013-04-11','13:55:00',5.16),('14598','2013-04-11','14:00:00',5.15),('14598','2013-04-11','14:05:00',5.14),('14598','2013-04-11','14:10:00',5.13),('14598','2013-04-11','14:15:00',5.14),('14598','2013-04-11','14:20:00',5.11),('14598','2013-04-11','14:25:00',5.08),('14598','2013-04-11','14:30:00',5.05),('14598','2013-04-11','14:35:00',5.01),('14598','2013-04-11','14:40:00',4.99),('14598','2013-04-11','14:45:00',4.97),('14598','2013-04-11','14:50:00',4.94),('14598','2013-04-11','14:55:00',4.9),('14598','2013-04-11','15:00:00',4.85),('14598','2013-04-11','15:05:00',4.81),('14598','2013-04-11','15:10:00',4.8),('14598','2013-04-11','15:15:00',4.76),('14598','2013-04-11','15:20:00',4.7),('14598','2013-04-11','15:25:00',4.64),('14598','2013-04-11','15:30:00',4.61),('14598','2013-04-11','15:35:00',4.57),('14598','2013-04-11','15:40:00',4.52),('14598','2013-04-11','15:45:00',4.47),('14598','2013-04-11','15:50:00',4.42),('14598','2013-04-11','15:55:00',4.35),('14598','2013-04-11','16:00:00',4.28),('14598','2013-04-11','16:05:00',4.22),('14598','2013-04-11','16:10:00',4.12),('14598','2013-04-11','16:15:00',4.1),('14598','2013-04-11','16:20:00',3.95),('14598','2013-04-11','16:25:00',3.97),('14598','2013-04-11','16:30:00',3.9),('14598','2013-04-11','16:35:00',3.83),('14598','2013-04-11','16:40:00',3.75),('14598','2013-04-11','16:45:00',3.66),('14598','2013-04-11','16:50:00',3.58),('14598','2013-04-11','16:55:00',3.5),('14598','2013-04-11','17:00:00',3.4),('14598','2013-04-11','17:05:00',3.32),('14598','2013-04-11','17:10:00',3.22),('14598','2013-04-11','17:15:00',3.13),('14598','2013-04-11','17:20:00',3.03),('14598','2013-04-11','17:25:00',2.93),('14598','2013-04-11','17:30:00',2.83),('14598','2013-04-11','17:35:00',2.74),('14598','2013-04-11','17:40:00',2.61),('14598','2013-04-11','17:45:00',2.42),('14598','2013-04-11','17:50:00',2.31),('14598','2013-04-11','17:55:00',2.27),('14598','2013-04-11','18:00:00',2.07),('14598','2013-04-11','18:05:00',1.95),('14598','2013-04-11','18:10:00',1.87),('14598','2013-04-11','18:15:00',1.87),('14598','2013-04-11','18:20:00',1.73),('14598','2013-04-11','18:25:00',1.59),('14598','2013-04-11','18:30:00',1.46),('14598','2013-04-11','18:35:00',1.3),('14598','2013-04-10','08:55:00',1.57),('14598','2013-04-10','09:00:00',1.7),('14598','2013-04-10','09:05:00',1.8),('14598','2013-04-10','09:10:00',1.92),('14598','2013-04-10','09:15:00',2.02),('14598','2013-04-10','09:20:00',2.14),('14598','2013-04-10','09:25:00',2.34),('14598','2013-04-10','09:30:00',2.41),('14598','2013-04-10','09:35:00',2.53),('14598','2013-04-10','09:40:00',2.65),('14598','2013-04-10','09:45:00',2.76),('14598','2013-04-10','09:50:00',2.85),('14598','2013-04-10','09:55:00',2.91),('14598','2013-04-10','10:00:00',3.03),('14598','2013-04-10','10:05:00',3.13),('14598','2013-04-10','10:10:00',3.24),('14598','2013-04-10','10:15:00',3.33),('14598','2013-04-10','10:20:00',3.42),('14598','2013-04-10','10:25:00',3.51),('14598','2013-04-10','10:30:00',3.62),('14598','2013-04-10','10:35:00',3.73),('14598','2013-04-10','10:40:00',3.7),('14598','2013-04-10','10:45:00',3.76),('14598','2013-04-10','10:50:00',3.73),('14598','2013-04-10','10:55:00',3.61),('14598','2013-04-10','11:00:00',3.75),('14598','2013-04-10','11:05:00',3.83),('14598','2013-04-10','11:10:00',4.04),('14598','2013-04-10','11:15:00',4.22),('14598','2013-04-10','11:20:00',4.27),('14598','2013-04-10','11:25:00',4.31),('14598','2013-04-10','11:30:00',4.35),('14598','2013-04-10','11:35:00',4.43),('14598','2013-04-10','11:40:00',4.48),('14598','2013-04-10','11:45:00',4.57),('14598','2013-04-10','11:50:00',4.6),('14598','2013-04-10','11:55:00',4.66),('14598','2013-04-10','12:00:00',4.78),('14598','2013-04-10','12:05:00',4.95),('14598','2013-04-10','12:10:00',4.33),('14598','2013-04-10','12:15:00',4.99),('14598','2013-04-10','12:20:00',5.23),('14598','2013-04-10','12:25:00',5.08),('14598','2013-04-10','12:30:00',5.32),('14598','2013-04-10','12:35:00',4.98),('14598','2013-04-10','12:40:00',5.02),('14598','2013-04-10','12:45:00',5.09),('14598','2013-04-10','12:50:00',5.11),('14598','2013-04-10','12:55:00',5.21),('14598','2013-04-10','13:00:00',4.48),('14598','2013-04-10','13:05:00',5.12),('14598','2013-04-10','13:10:00',5.13),('14598','2013-04-10','13:15:00',4.82),('14598','2013-04-10','13:20:00',4.69),('14598','2013-04-10','13:25:00',5.19),('14598','2013-04-10','13:30:00',4.62),('14598','2013-04-10','13:35:00',5.13),('14598','2013-04-10','13:40:00',5.09),('14598','2013-04-10','13:45:00',5.11),('14598','2013-04-10','13:50:00',5.11),('14598','2013-04-10','13:55:00',5.1),('14598','2013-04-10','14:00:00',5.11),('14598','2013-04-10','14:05:00',4.82),('14598','2013-04-10','14:10:00',5.13),('14598','2013-04-10','14:15:00',4.96),('14598','2013-04-10','14:20:00',5.12),('14598','2013-04-10','14:25:00',5.03),('14598','2013-04-10','14:30:00',5.04),('14598','2013-04-10','14:35:00',5.08),('14598','2013-04-10','14:40:00',4.57),('14598','2013-04-10','14:45:00',5.18),('14598','2013-04-10','14:50:00',4.09),('14598','2013-04-10','14:55:00',3.49),('14598','2013-04-10','15:00:00',4.97),('14598','2013-04-10','15:05:00',5.05),('14598','2013-04-10','15:10:00',4.8),('14598','2013-04-10','15:15:00',4.75),('14598','2013-04-10','15:20:00',4.72),('14598','2013-04-10','15:25:00',4),('14598','2013-04-10','15:30:00',4.66),('14598','2013-04-10','15:35:00',4.57),('14598','2013-04-10','15:40:00',4.55),('14598','2013-04-10','15:45:00',4.54),('14598','2013-04-10','15:50:00',4.54),('14598','2013-04-10','15:55:00',3.66),('14598','2013-04-10','16:00:00',4.27),('14598','2013-04-10','16:05:00',4.22),('14598','2013-04-10','16:10:00',4.2),('14598','2013-04-10','16:15:00',4.04),('14598','2013-04-10','16:20:00',3.96),('14598','2013-04-10','16:25:00',3.9),('14598','2013-04-10','16:30:00',3.78),('14598','2013-04-10','16:35:00',3.79),('14598','2013-04-10','16:40:00',3.77),('14598','2013-04-10','16:45:00',3.6),('14598','2013-04-10','16:50:00',3.48),('14598','2013-04-10','16:55:00',3.33),('14598','2013-04-10','17:00:00',3.33),('14598','2013-04-10','17:05:00',3.23),('14598','2013-04-10','17:10:00',3.11),('14598','2013-04-10','17:15:00',3.05),('14598','2013-04-10','17:20:00',3.04),('14598','2013-04-10','17:25:00',2.86),('14598','2013-04-10','17:30:00',2.64),('14598','2013-04-10','17:35:00',2.46),('14598','2013-04-10','17:40:00',2.57),('14598','2013-04-10','17:45:00',2.41),('14598','2013-04-10','17:50:00',2.34),('14598','2013-04-10','17:55:00',2.24),('14598','2013-04-10','18:00:00',2.06),('14598','2013-04-10','18:05:00',2.01),('14598','2013-04-10','18:10:00',1.89),('14598','2013-04-10','18:15:00',1.73),('14598','2013-04-10','18:20:00',1.42),('14598','2013-04-10','18:25:00',1.49),('14598','2013-04-10','18:30:00',1.29),('14598','2013-04-09','08:35:00',1.07),('14598','2013-04-09','08:40:00',1.29),('14598','2013-04-09','08:45:00',1.23),('14598','2013-04-09','09:00:00',1.02),('14598','2013-04-09','09:05:00',1.03),('14598','2013-04-09','09:10:00',1.12),('14598','2013-04-09','09:15:00',1.59),('14598','2013-04-09','09:20:00',1.89),('14598','2013-04-09','09:25:00',1.29),('14598','2013-04-09','09:30:00',1.66),('14598','2013-04-09','09:35:00',1.91),('14598','2013-04-09','09:40:00',2.27),('14598','2013-04-09','09:45:00',2.45),('14598','2013-04-09','09:50:00',2.9),('14598','2013-04-09','09:55:00',2.99),('14598','2013-04-09','10:00:00',3.15),('14598','2013-04-09','10:05:00',3),('14598','2013-04-09','10:10:00',3.24),('14598','2013-04-09','10:15:00',3.35),('14598','2013-04-09','10:20:00',3.45),('14598','2013-04-09','10:25:00',3.54),('14598','2013-04-09','10:30:00',3.38),('14598','2013-04-09','10:35:00',3.06),('14598','2013-04-09','10:40:00',3.62),('14598','2013-04-09','10:45:00',3.87),('14598','2013-04-09','10:50:00',3.87),('14598','2013-04-09','10:55:00',4.09),('14598','2013-04-09','11:00:00',3.65),('14598','2013-04-09','11:05:00',1.89),('14598','2013-04-09','11:10:00',1.39),('14598','2013-04-09','11:15:00',4),('14598','2013-04-09','11:20:00',5.14),('14598','2013-04-09','11:25:00',3.44),('14598','2013-04-09','11:30:00',1.33),('14598','2013-04-09','11:35:00',1.48),('14598','2013-04-09','11:40:00',1.5),('14598','2013-04-09','11:45:00',1.15),('14598','2013-04-09','11:50:00',2.75),('14598','2013-04-09','11:55:00',3.24),('14598','2013-04-09','12:00:00',4),('14598','2013-04-09','12:05:00',4.89),('14598','2013-04-09','12:10:00',4.69),('14598','2013-04-09','12:15:00',3.84),('14598','2013-04-09','12:20:00',4.66),('14598','2013-04-09','12:25:00',4.95),('14598','2013-04-09','12:30:00',5.1),('14598','2013-04-09','12:35:00',5.27),('14598','2013-04-09','12:40:00',5.37),('14598','2013-04-09','12:45:00',5.19),('14598','2013-04-09','12:50:00',4.7),('14598','2013-04-09','12:55:00',5.17),('14598','2013-04-09','13:00:00',5.03),('14598','2013-04-09','13:05:00',4.49),('14598','2013-04-09','13:10:00',4.96),('14598','2013-04-09','13:15:00',5.26),('14598','2013-04-09','13:20:00',5.34),('14598','2013-04-09','13:25:00',5.14),('14598','2013-04-09','13:30:00',4.84),('14598','2013-04-09','13:35:00',4.81),('14598','2013-04-09','13:40:00',5.04),('14598','2013-04-09','13:45:00',5.19),('14598','2013-04-09','13:50:00',4.66),('14598','2013-04-09','13:55:00',4.76),('14598','2013-04-09','14:00:00',4.54),('14598','2013-04-09','14:05:00',4.23),('14598','2013-04-09','14:10:00',4.24),('14598','2013-04-09','14:15:00',4.07),('14598','2013-04-09','14:20:00',4.53),('14598','2013-04-09','14:25:00',4.47),('14598','2013-04-09','14:30:00',4.57),('14598','2013-04-09','14:35:00',4.66),('14598','2013-04-09','14:40:00',4.02),('14598','2013-04-09','14:45:00',4.67),('14598','2013-04-09','14:50:00',4.87),('14598','2013-04-09','14:55:00',4.99),('14598','2013-04-09','15:00:00',4.8),('14598','2013-04-09','15:05:00',4.87),('14598','2013-04-09','15:10:00',4.78),('14598','2013-04-09','15:15:00',4.91),('14598','2013-04-09','15:20:00',4.77),('14598','2013-04-09','15:25:00',4.78),('14598','2013-04-09','15:30:00',4.55),('14598','2013-04-09','15:35:00',4.46),('14598','2013-04-09','15:40:00',4.66),('14598','2013-04-09','15:45:00',4.32),('14598','2013-04-09','15:50:00',3.55),('14598','2013-04-09','15:55:00',3.89),('14598','2013-04-09','16:00:00',4.4),('14598','2013-04-09','16:05:00',4.15),('14598','2013-04-09','16:10:00',2.92),('14598','2013-04-09','16:15:00',3.83),('14598','2013-04-09','16:20:00',3.88),('14598','2013-04-09','16:25:00',3.43),('14598','2013-04-09','16:30:00',3.53),('14598','2013-04-09','16:35:00',3.31),('14598','2013-04-09','16:40:00',3.9),('14598','2013-04-09','16:45:00',3.14),('14598','2013-04-09','16:50:00',2.66),('14598','2013-04-09','16:55:00',3.69),('14598','2013-04-09','17:00:00',3.48),('14598','2013-04-09','17:05:00',3.34),('14598','2013-04-09','17:10:00',3.12),('14598','2013-04-09','17:15:00',3.16),('14598','2013-04-09','17:20:00',3.07),('14598','2013-04-09','17:25:00',2.76),('14598','2013-04-09','17:30:00',3.02),('14598','2013-04-09','17:35:00',2.25),('14598','2013-04-09','17:40:00',1.8),('14598','2013-04-09','17:45:00',2),('14598','2013-04-09','17:50:00',1.63),('14598','2013-04-09','17:55:00',1.85),('14598','2013-04-09','18:00:00',1.13),('14598','2013-04-09','18:05:00',1.01),('14598','2013-04-09','18:10:00',1.99),('14598','2013-04-09','18:15:00',1.64),('14598','2013-04-08','08:30:00',1.03),('14598','2013-04-08','08:35:00',1.15),('14598','2013-04-08','08:40:00',1.26),('14598','2013-04-08','08:45:00',1.41),('14598','2013-04-08','08:50:00',1.49),('14598','2013-04-08','08:55:00',1.61),('14598','2013-04-08','09:00:00',1.74),('14598','2013-04-08','09:05:00',1.86),('14598','2013-04-08','09:10:00',2.02),('14598','2013-04-08','09:15:00',2.23),('14598','2013-04-08','09:20:00',2.39),('14598','2013-04-08','09:25:00',2.74),('14598','2013-04-08','09:30:00',2.44),('14598','2013-04-08','09:35:00',1.52),('14598','2013-04-08','09:40:00',2.37),('14598','2013-04-08','09:45:00',2.68),('14598','2013-04-08','09:50:00',2.81),('14598','2013-04-08','09:55:00',2.31),('14598','2013-04-08','10:00:00',2.88),('14598','2013-04-08','10:05:00',3.11),('14598','2013-04-08','10:10:00',3.09),('14598','2013-04-08','10:15:00',3.01),('14598','2013-04-08','10:20:00',3.12),('14598','2013-04-08','10:25:00',3.27),('14598','2013-04-08','10:30:00',3.72),('14598','2013-04-08','10:35:00',3.79),('14598','2013-04-08','10:40:00',3.79),('14598','2013-04-08','10:45:00',3.81),('14598','2013-04-08','10:50:00',3.33),('14598','2013-04-08','10:55:00',2.79),('14598','2013-04-08','11:00:00',2.29),('14598','2013-04-08','11:05:00',2.17),('14598','2013-04-08','11:10:00',2.58),('14598','2013-04-08','11:15:00',3.28),('14598','2013-04-08','11:20:00',3.22),('14598','2013-04-08','11:25:00',2.99),('14598','2013-04-08','11:30:00',2.82),('14598','2013-04-08','11:35:00',3.58),('14598','2013-04-08','11:40:00',2.98),('14598','2013-04-08','11:45:00',3.08),('14598','2013-04-08','11:50:00',3.04),('14598','2013-04-08','11:55:00',3.86),('14598','2013-04-08','12:00:00',3.98),('14598','2013-04-08','12:05:00',3.45),('14598','2013-04-08','12:10:00',3.28),('14598','2013-04-08','12:15:00',3.15),('14598','2013-04-08','12:20:00',3.72),('14598','2013-04-08','12:25:00',4.18),('14598','2013-04-08','12:30:00',4.06),('14598','2013-04-08','12:35:00',3.87),('14598','2013-04-08','12:40:00',4.28),('14598','2013-04-08','12:45:00',4.04),('14598','2013-04-08','12:50:00',3.5),('14598','2013-04-08','12:55:00',3.98),('14598','2013-04-08','13:00:00',3.71),('14598','2013-04-08','13:05:00',4.19),('14598','2013-04-08','13:10:00',4.16),('14598','2013-04-08','13:15:00',4.6),('14598','2013-04-08','13:20:00',4.13),('14598','2013-04-08','13:25:00',3.7),('14598','2013-04-08','13:30:00',4.05),('14598','2013-04-08','13:35:00',4.04),('14598','2013-04-08','13:40:00',3.53),('14598','2013-04-08','13:45:00',4.35),('14598','2013-04-08','13:50:00',4.75),('14598','2013-04-08','13:55:00',4.04),('14598','2013-04-08','14:00:00',3.85),('14598','2013-04-08','14:05:00',4.07),('14598','2013-04-08','14:10:00',4.07),('14598','2013-04-08','14:15:00',4.37),('14598','2013-04-08','14:20:00',4.18),('14598','2013-04-08','14:25:00',4.97),('14598','2013-04-08','14:30:00',4.78),('14598','2013-04-08','14:35:00',5.3),('14598','2013-04-08','14:40:00',3.96),('14598','2013-04-08','14:45:00',4.71),('14598','2013-04-08','14:50:00',4.33),('14598','2013-04-08','14:55:00',4.12),('14598','2013-04-08','15:00:00',4.62),('14598','2013-04-08','15:05:00',4.63),('14598','2013-04-08','15:10:00',4.18),('14598','2013-04-08','15:15:00',4.42),('14598','2013-04-08','15:20:00',4.27),('14598','2013-04-08','15:25:00',4.5),('14598','2013-04-08','15:30:00',4.61),('14598','2013-04-08','15:35:00',4.59),('14598','2013-04-08','15:40:00',4.54),('14598','2013-04-08','15:45:00',4.5),('14598','2013-04-08','15:50:00',4.09),('14598','2013-04-08','15:55:00',3.83),('14598','2013-04-08','16:00:00',4.16),('14598','2013-04-08','16:05:00',4.31),('14598','2013-04-08','16:10:00',4.16),('14598','2013-04-08','16:15:00',4.09),('14598','2013-04-08','16:20:00',3.97),('14598','2013-04-08','16:25:00',3.93),('14598','2013-04-08','16:30:00',3.93),('14598','2013-04-08','16:35:00',3.87),('14598','2013-04-08','16:40:00',3.81),('14598','2013-04-08','16:45:00',3.74),('14598','2013-04-08','16:50:00',3.66),('14598','2013-04-08','16:55:00',3.54),('14598','2013-04-08','17:00:00',3.28),('14598','2013-04-08','17:05:00',3.14),('14598','2013-04-08','17:10:00',2.98),('14598','2013-04-08','17:15:00',2.58),('14598','2013-04-08','17:20:00',2.58),('14598','2013-04-08','17:25:00',2.15),('14598','2013-04-08','17:30:00',2.17),('14598','2013-04-08','17:35:00',2),('14598','2013-04-08','17:40:00',1.96),('14598','2013-04-08','17:45:00',1.96),('14598','2013-04-08','17:50:00',2.06),('14598','2013-04-08','18:05:00',1.55),('14598','2013-04-08','18:10:00',2.22),('14598','2013-04-08','18:15:00',1.89),('14598','2013-04-08','18:20:00',1.17),('14598','2013-04-08','18:25:00',1.17),('14598','2013-04-08','18:30:00',1.06),('14598','2013-04-07','08:40:00',1.01),('14598','2013-04-07','08:45:00',1.08),('14598','2013-04-07','08:50:00',1.22),('14598','2013-04-07','08:55:00',1.32),('14598','2013-04-07','09:00:00',1.44),('14598','2013-04-07','09:05:00',1.52),('14598','2013-04-07','09:10:00',1.58),('14598','2013-04-07','09:15:00',1.68),('14598','2013-04-07','09:20:00',1.8),('14598','2013-04-07','09:25:00',1.96),('14598','2013-04-07','09:30:00',2.08),('14598','2013-04-07','09:35:00',2.11),('14598','2013-04-07','09:40:00',2.14),('14598','2013-04-07','09:45:00',2.3),('14598','2013-04-07','09:50:00',2.47),('14598','2013-04-07','09:55:00',2.64),('14598','2013-04-07','10:00:00',2.73),('14598','2013-04-07','10:05:00',2.79),('14598','2013-04-07','10:10:00',2.89),('14598','2013-04-07','10:15:00',2.79),('14598','2013-04-07','10:20:00',2.86),('14598','2013-04-07','10:25:00',3.03),('14598','2013-04-07','10:30:00',3.28),('14598','2013-04-07','10:35:00',3.45),('14598','2013-04-07','10:40:00',3.47),('14598','2013-04-07','10:45:00',3.3),('14598','2013-04-07','10:50:00',3.37),('14598','2013-04-07','10:55:00',3.49),('14598','2013-04-07','11:00:00',3.45),('14598','2013-04-07','11:05:00',3.51),('14598','2013-04-07','11:10:00',3.37),('14598','2013-04-07','11:15:00',3.3),('14598','2013-04-07','11:20:00',3.83),('14598','2013-04-07','11:25:00',3.93),('14598','2013-04-07','11:30:00',3.9),('14598','2013-04-07','11:35:00',3.81),('14598','2013-04-07','11:40:00',3.96),('14598','2013-04-07','11:45:00',3.78),('14598','2013-04-07','11:50:00',3.68),('14598','2013-04-07','11:55:00',2.84),('14598','2013-04-07','12:00:00',2.65),('14598','2013-04-07','12:05:00',2.84),('14598','2013-04-07','12:10:00',2.8),('14598','2013-04-07','12:15:00',2.86),('14598','2013-04-07','12:20:00',2.68),('14598','2013-04-07','12:25:00',2.74),('14598','2013-04-07','12:30:00',2.73),('14598','2013-04-07','12:35:00',2.8),('14598','2013-04-07','12:40:00',3.07),('14598','2013-04-07','12:45:00',3.04),('14598','2013-04-07','12:50:00',3.22),('14598','2013-04-07','12:55:00',3.64),('14598','2013-04-07','13:00:00',4),('14598','2013-04-07','13:05:00',3.47),('14598','2013-04-07','13:10:00',3.44),('14598','2013-04-07','13:15:00',3.52),('14598','2013-04-07','13:20:00',3.91),('14598','2013-04-07','13:25:00',3.78),('14598','2013-04-07','13:30:00',3.5),('14598','2013-04-07','13:35:00',3.26),('14598','2013-04-07','13:40:00',3.17),('14598','2013-04-07','13:45:00',3.21),('14598','2013-04-07','13:50:00',3.26),('14598','2013-04-07','13:55:00',3.2),('14598','2013-04-07','14:00:00',3.23),('14598','2013-04-07','14:05:00',3.17),('14598','2013-04-07','14:10:00',3.32),('14598','2013-04-07','14:15:00',3.51),('14598','2013-04-07','14:20:00',3.65),('14598','2013-04-07','14:25:00',3.83),('14598','2013-04-07','14:30:00',3.8),('14598','2013-04-07','14:35:00',3.61),('14598','2013-04-07','14:40:00',3.61),('14598','2013-04-07','14:45:00',3.77),('14598','2013-04-07','14:50:00',3.84),('14598','2013-04-07','14:55:00',3.82),('14598','2013-04-07','15:00:00',3.73),('14598','2013-04-07','15:05:00',3.56),('14598','2013-04-07','15:10:00',3.24),('14598','2013-04-07','15:15:00',3.05),('14598','2013-04-07','15:20:00',3.18),('14598','2013-04-07','15:25:00',3.56),('14598','2013-04-07','15:30:00',4.13),('14598','2013-04-07','15:35:00',4.5),('14598','2013-04-07','15:40:00',4.32),('14598','2013-04-07','15:45:00',4.32),('14598','2013-04-07','15:50:00',4.45),('14598','2013-04-07','15:55:00',4.49),('14598','2013-04-07','16:00:00',4.49),('14598','2013-04-07','16:05:00',4.41),('14598','2013-04-07','16:10:00',4.16),('14598','2013-04-07','16:15:00',3.9),('14598','2013-04-07','16:20:00',3.74),('14598','2013-04-07','16:25:00',3.65),('14598','2013-04-07','16:30:00',3.6),('14598','2013-04-07','16:35:00',3.56),('14598','2013-04-07','16:40:00',3.54),('14598','2013-04-07','16:45:00',3.48),('14598','2013-04-07','16:50:00',3.44),('14598','2013-04-07','16:55:00',3.35),('14598','2013-04-07','17:00:00',3.31),('14598','2013-04-07','17:05:00',3.27),('14598','2013-04-07','17:10:00',3.22),('14598','2013-04-07','17:15:00',3.11),('14598','2013-04-07','17:20:00',3.01),('14598','2013-04-07','17:25:00',2.86),('14598','2013-04-07','17:30:00',2.72),('14598','2013-04-07','17:35:00',2.23),('14598','2013-04-07','17:40:00',1.44),('14598','2013-04-06','08:35:00',1.01),('14598','2013-04-06','08:40:00',1.08),('14598','2013-04-06','08:45:00',1.21),('14598','2013-04-06','08:50:00',1.33),('14598','2013-04-06','08:55:00',1.44),('14598','2013-04-06','09:00:00',1.56),('14598','2013-04-06','09:05:00',1.66),('14598','2013-04-06','09:10:00',1.75),('14598','2013-04-06','09:15:00',1.89),('14598','2013-04-06','09:20:00',2),('14598','2013-04-06','09:25:00',2.11),('14598','2013-04-06','09:30:00',2.2),('14598','2013-04-06','09:35:00',2.32),('14598','2013-04-06','09:40:00',2.49),('14598','2013-04-06','09:45:00',2.55),('14598','2013-04-06','09:50:00',2.67),('14598','2013-04-06','09:55:00',1.94),('14598','2013-04-06','10:00:00',2.81),('14598','2013-04-06','10:05:00',2.21),('14598','2013-04-06','10:10:00',2.89),('14598','2013-04-06','10:15:00',3.27),('14598','2013-04-06','10:20:00',3.34),('14598','2013-04-06','10:25:00',3.43),('14598','2013-04-06','10:30:00',3.41),('14598','2013-04-06','10:35:00',3.5),('14598','2013-04-06','10:40:00',3.53),('14598','2013-04-06','10:45:00',3.54),('14598','2013-04-06','10:50:00',3.57),('14598','2013-04-06','10:55:00',3.63),('14598','2013-04-06','11:00:00',3.71),('14598','2013-04-06','11:05:00',3.76),('14598','2013-04-06','11:10:00',3.8),('14598','2013-04-06','11:15:00',3.86),('14598','2013-04-06','11:20:00',3.97),('14598','2013-04-06','11:25:00',4.09),('14598','2013-04-06','11:30:00',4.12),('14598','2013-04-06','11:35:00',4.19),('14598','2013-04-06','11:40:00',4.25),('14598','2013-04-06','11:45:00',4.3),('14598','2013-04-06','11:50:00',4.35),('14598','2013-04-06','11:55:00',4.39),('14598','2013-04-06','12:00:00',4.44),('14598','2013-04-06','12:05:00',4.48),('14598','2013-04-06','12:10:00',4.51),('14598','2013-04-06','12:15:00',4.58),('14598','2013-04-06','12:20:00',4.62),('14598','2013-04-06','12:25:00',4.64),('14598','2013-04-06','12:30:00',4.66),('14598','2013-04-06','12:35:00',4.71),('14598','2013-04-06','12:40:00',4.74),('14598','2013-04-06','12:45:00',4.78),('14598','2013-04-06','12:50:00',4.8),('14598','2013-04-06','12:55:00',4.8),('14598','2013-04-06','13:00:00',4.86),('14598','2013-04-06','13:05:00',4.87),('14598','2013-04-06','13:10:00',4.88),('14598','2013-04-06','13:15:00',4.9),('14598','2013-04-06','13:20:00',4.9),('14598','2013-04-06','13:25:00',4.91),('14598','2013-04-06','13:30:00',4.91),('14598','2013-04-06','13:35:00',4.93),('14598','2013-04-06','13:40:00',4.95),('14598','2013-04-06','13:45:00',4.94),('14598','2013-04-06','13:50:00',4.92),('14598','2013-04-06','13:55:00',4.89),('14598','2013-04-06','14:00:00',4.91),('14598','2013-04-06','14:05:00',4.91),('14598','2013-04-06','14:10:00',4.92),('14598','2013-04-06','14:15:00',4.89),('14598','2013-04-06','14:20:00',4.88),('14598','2013-04-06','14:25:00',4.86),('14598','2013-04-06','14:30:00',4.82),('14598','2013-04-06','14:35:00',4.83),('14598','2013-04-06','14:40:00',4.79),('14598','2013-04-06','14:45:00',4.75),('14598','2013-04-06','14:50:00',4.67),('14598','2013-04-06','14:55:00',4.7),('14598','2013-04-06','15:00:00',4.61),('14598','2013-04-06','15:05:00',4.56),('14598','2013-04-06','15:10:00',4.55),('14598','2013-04-06','15:15:00',4.5),('14598','2013-04-06','15:20:00',4.38),('14598','2013-04-06','15:25:00',4.42),('14598','2013-04-06','15:30:00',4.06),('14598','2013-04-06','15:35:00',3.84),('14598','2013-04-06','15:40:00',4.1),('14598','2013-04-06','15:45:00',3.71),('14598','2013-04-06','15:50:00',3.71),('14598','2013-04-06','15:55:00',3.39),('14598','2013-04-06','16:00:00',2.87),('14598','2013-04-06','16:05:00',3.26),('14598','2013-04-06','16:10:00',3.24),('14598','2013-04-06','16:15:00',3.16),('14598','2013-04-06','16:20:00',2.5),('14598','2013-04-06','16:25:00',2.85),('14598','2013-04-06','16:30:00',2.85),('14598','2013-04-06','16:35:00',1.94),('14598','2013-04-06','16:40:00',2.29),('14598','2013-04-06','16:45:00',2.91),('14598','2013-04-06','16:50:00',3.12),('14598','2013-04-06','16:55:00',2.67),('14598','2013-04-06','17:00:00',2.33),('14598','2013-04-06','17:05:00',2.14),('14598','2013-04-06','17:10:00',1.83),('14598','2013-04-06','17:15:00',1.49),('14598','2013-04-06','17:20:00',1.52),('14598','2013-04-06','17:25:00',1.29),('14598','2013-04-06','17:30:00',1.17),('14598','2013-04-06','17:35:00',1.12),('14598','2013-04-06','17:40:00',1.08),('14598','2013-04-06','17:45:00',1.11),('14598','2013-04-06','17:50:00',1.27),('14598','2013-04-06','17:55:00',1.06),('14598','2013-04-05','08:20:00',1.18),('14598','2013-04-05','08:25:00',1.15),('14598','2013-04-05','08:45:00',1.15),('14598','2013-04-05','08:50:00',1.26),('14598','2013-04-05','08:55:00',1.38),('14598','2013-04-05','09:00:00',1.49),('14598','2013-04-05','09:05:00',1.56),('14598','2013-04-05','09:10:00',1.66),('14598','2013-04-05','09:15:00',1.81),('14598','2013-04-05','09:20:00',1.95),('14598','2013-04-05','09:25:00',2.06),('14598','2013-04-05','09:30:00',2.15),('14598','2013-04-05','09:35:00',2.26),('14598','2013-04-05','09:40:00',2.36),('14598','2013-04-05','09:45:00',2.53),('14598','2013-04-05','09:50:00',2.87),('14598','2013-04-05','09:55:00',2.08),('14598','2013-04-05','10:00:00',2.72),('14598','2013-04-05','10:05:00',2.89),('14598','2013-04-05','10:10:00',2.96),('14598','2013-04-05','10:15:00',2.83),('14598','2013-04-05','10:20:00',3.12),('14598','2013-04-05','10:25:00',3.21),('14598','2013-04-05','10:30:00',3.3),('14598','2013-04-05','10:35:00',3.39),('14598','2013-04-05','10:40:00',3.45),('14598','2013-04-05','10:45:00',3.48),('14598','2013-04-05','10:50:00',3.63),('14598','2013-04-05','10:55:00',3.71),('14598','2013-04-05','11:00:00',3.76),('14598','2013-04-05','11:05:00',3.82),('14598','2013-04-05','11:10:00',3.89),('14598','2013-04-05','11:15:00',3.97),('14598','2013-04-05','11:20:00',4.04),('14598','2013-04-05','11:25:00',4.11),('14598','2013-04-05','11:30:00',4.16),('14598','2013-04-05','11:35:00',4.21),('14598','2013-04-05','11:40:00',4.26),('14598','2013-04-05','11:45:00',4.31),('14598','2013-04-05','11:50:00',4.39),('14598','2013-04-05','11:55:00',4.12),('14598','2013-04-05','12:00:00',3.69),('14598','2013-04-05','12:05:00',4.48),('14598','2013-04-05','12:10:00',2.67),('14598','2013-04-05','12:15:00',1.16),('14598','2013-04-05','12:20:00',2.6),('14598','2013-04-05','12:25:00',5.05),('14598','2013-04-05','12:30:00',4.88),('14598','2013-04-05','12:35:00',4.04),('14598','2013-04-05','12:40:00',4.82),('14598','2013-04-05','12:45:00',4.83),('14598','2013-04-05','12:50:00',4.85),('14598','2013-04-05','12:55:00',4.87),('14598','2013-04-05','13:00:00',4.88),('14598','2013-04-05','13:05:00',4.91),('14598','2013-04-05','13:10:00',4.91),('14598','2013-04-05','13:15:00',4.89),('14598','2013-04-05','13:20:00',4.93),('14598','2013-04-05','13:25:00',4.96),('14598','2013-04-05','13:30:00',4.95),('14598','2013-04-05','13:35:00',4.95),('14598','2013-04-05','13:40:00',4.94),('14598','2013-04-05','13:45:00',4.93),('14598','2013-04-05','13:50:00',4.94),('14598','2013-04-05','13:55:00',4.48),('14598','2013-04-05','14:00:00',4.06),('14598','2013-04-05','14:05:00',4.88),('14598','2013-04-05','14:10:00',2.92),('14598','2013-04-05','14:15:00',2.42),('14598','2013-04-05','14:20:00',2.57),('14598','2013-04-05','14:25:00',1.91),('14598','2013-04-05','14:30:00',1.43),('14598','2013-04-05','14:35:00',2.02),('14598','2013-04-05','14:40:00',2.41),('14598','2013-04-05','14:45:00',2.49),('14598','2013-04-05','14:50:00',2.05),('14598','2013-04-05','14:55:00',1.85),('14598','2013-04-05','15:00:00',1.71),('14598','2013-04-05','15:05:00',1.55),('14598','2013-04-05','15:10:00',1.85),('14598','2013-04-05','15:15:00',1.98),('14598','2013-04-05','15:20:00',1.98),('14598','2013-04-05','15:25:00',1.42),('14598','2013-04-05','15:30:00',1.22),('14598','2013-04-05','15:35:00',1.72),('14598','2013-04-05','15:40:00',4.02),('14598','2013-04-05','15:45:00',2.63),('14598','2013-04-05','15:50:00',2.84),('14598','2013-04-05','15:55:00',3.03),('14598','2013-04-05','16:00:00',1.82),('14598','2013-04-05','16:05:00',2.55),('14598','2013-04-05','16:10:00',3.14),('14598','2013-04-05','16:15:00',4.37),('14598','2013-04-05','16:20:00',3.92),('14598','2013-04-05','16:25:00',3.7),('14598','2013-04-05','16:30:00',3.85),('14598','2013-04-05','16:35:00',3.52),('14598','2013-04-05','16:40:00',3.46),('14598','2013-04-05','16:45:00',3.39),('14598','2013-04-05','16:50:00',3.31),('14598','2013-04-05','16:55:00',3.24),('14598','2013-04-05','17:00:00',2.71),('14598','2013-04-05','17:05:00',2.27),('14598','2013-04-05','17:10:00',3.18),('14598','2013-04-05','17:15:00',2.95),('14598','2013-04-05','17:20:00',2.73),('14598','2013-04-05','17:25:00',2.64),('14598','2013-04-05','17:30:00',2.57),('14598','2013-04-05','17:35:00',2.67),('14598','2013-04-05','17:40:00',1.61),('14598','2013-04-05','17:45:00',2.1),('14598','2013-04-05','17:50:00',2.14),('14598','2013-04-05','17:55:00',2.03),('14598','2013-04-05','18:00:00',1.88),('14598','2013-04-05','18:05:00',1.75),('14598','2013-04-05','18:10:00',1.68),('14598','2013-04-05','18:15:00',1.69),('14598','2013-04-05','18:25:00',1.55),('14598','2013-04-05','18:30:00',1.28),('14598','2013-04-05','18:35:00',1.13),('14598','2013-04-04','08:40:00',1.02),('14598','2013-04-04','08:45:00',1.3),('14598','2013-04-04','08:50:00',1.38),('14598','2013-04-04','08:55:00',1.18),('14598','2013-04-04','09:00:00',1.1),('14598','2013-04-04','09:15:00',1.31),('14598','2013-04-04','09:20:00',2.03),('14598','2013-04-04','09:25:00',2.21),('14598','2013-04-04','09:30:00',1.63),('14598','2013-04-04','09:35:00',1.01),('14598','2013-04-04','09:45:00',1.22),('14598','2013-04-04','09:50:00',1.36),('14598','2013-04-04','09:55:00',1.07),('14598','2013-04-04','10:00:00',1.01),('14598','2013-04-04','10:05:00',1.62),('14598','2013-04-04','10:10:00',3.76),('14598','2013-04-04','10:15:00',3.02),('14598','2013-04-04','10:20:00',1.64),('14598','2013-04-04','10:25:00',3.92),('14598','2013-04-04','10:30:00',1.88),('14598','2013-04-04','10:35:00',1.95),('14598','2013-04-04','10:40:00',3.47),('14598','2013-04-04','10:45:00',3.62),('14598','2013-04-04','10:50:00',1.31),('14598','2013-04-04','10:55:00',1.11),('14598','2013-04-04','11:00:00',1.61),('14598','2013-04-04','11:05:00',1.79),('14598','2013-04-04','11:10:00',1.27),('14598','2013-04-04','11:15:00',1.26),('14598','2013-04-04','11:20:00',1.59),('14598','2013-04-04','11:25:00',2.12),('14598','2013-04-04','11:30:00',2.55),('14598','2013-04-04','11:35:00',3.36),('14598','2013-04-04','11:40:00',4.36),('14598','2013-04-04','11:45:00',3.09),('14598','2013-04-04','11:50:00',3.46),('14598','2013-04-04','11:55:00',4.3),('14598','2013-04-04','12:00:00',3.61),('14598','2013-04-04','12:05:00',3.23),('14598','2013-04-04','12:10:00',2.68),('14598','2013-04-04','12:15:00',2.46),('14598','2013-04-04','12:20:00',2.27),('14598','2013-04-04','12:25:00',3.55),('14598','2013-04-04','12:30:00',4.78),('14598','2013-04-04','12:35:00',4.33),('14598','2013-04-04','12:40:00',3.77),('14598','2013-04-04','12:45:00',4.17),('14598','2013-04-04','12:50:00',3.96),('14598','2013-04-04','12:55:00',4.64),('14598','2013-04-04','13:00:00',4.85),('14598','2013-04-04','13:05:00',4.7),('14598','2013-04-04','13:10:00',4.4),('14598','2013-04-04','13:15:00',4.89),('14598','2013-04-04','13:20:00',4.66),('14598','2013-04-04','13:25:00',4.64),('14598','2013-04-04','13:30:00',4.75),('14598','2013-04-04','13:35:00',4.17),('14598','2013-04-04','13:40:00',3.21),('14598','2013-04-04','13:45:00',3.24),('14598','2013-04-04','13:50:00',3.88),('14598','2013-04-04','13:55:00',4.11),('14598','2013-04-04','14:00:00',4.92),('14598','2013-04-04','14:05:00',4.69),('14598','2013-04-04','14:10:00',4.64),('14598','2013-04-04','14:15:00',4.6),('14598','2013-04-04','14:20:00',4.61),('14598','2013-04-04','14:25:00',4.57),('14598','2013-04-04','14:30:00',4.5),('14598','2013-04-04','14:35:00',4.48),('14598','2013-04-04','14:40:00',4.47),('14598','2013-04-04','14:45:00',4.47),('14598','2013-04-04','14:50:00',4.46),('14598','2013-04-04','14:55:00',4.43),('14598','2013-04-04','15:00:00',4.42),('14598','2013-04-04','15:05:00',4.38),('14598','2013-04-04','15:10:00',4.35),('14598','2013-04-04','15:15:00',4.26),('14598','2013-04-04','15:20:00',4.21),('14598','2013-04-04','15:25:00',4.18),('14598','2013-04-04','15:30:00',4.02),('14598','2013-04-04','15:35:00',3.95),('14598','2013-04-04','15:40:00',3.92),('14598','2013-04-04','15:45:00',3.94),('14598','2013-04-04','15:50:00',3.88),('14598','2013-04-04','15:55:00',3.78),('14598','2013-04-04','16:00:00',3.46),('14598','2013-04-04','16:05:00',2.8),('14598','2013-04-04','16:10:00',1.94),('14598','2013-04-04','16:15:00',2.18),('14598','2013-04-04','16:20:00',2.84),('14598','2013-04-04','16:25:00',2.09),('14598','2013-04-04','16:30:00',1.72),('14598','2013-04-04','16:35:00',2.03),('14598','2013-04-04','16:40:00',2.14),('14598','2013-04-04','16:45:00',2.19),('14598','2013-04-04','16:50:00',1.86),('14598','2013-04-04','16:55:00',1.83),('14598','2013-04-04','17:00:00',1.49),('14598','2013-04-04','17:05:00',1.47),('14598','2013-04-04','17:10:00',1.36),('14598','2013-04-04','17:15:00',1.36),('14598','2013-04-04','17:20:00',1.4),('14598','2013-04-04','17:35:00',1.15),('14598','2013-04-04','17:40:00',1.16),('14598','2013-04-04','17:45:00',1.53),('14598','2013-04-04','17:50:00',1.47),('14598','2013-04-04','17:55:00',1.51),('14598','2013-04-04','18:00:00',1.31),('14598','2013-04-03','08:45:00',1.12),('14598','2013-04-03','08:50:00',1.53),('14598','2013-04-03','08:55:00',1.83),('14598','2013-04-03','09:00:00',1.98),('14598','2013-04-03','09:05:00',2.26),('14598','2013-04-03','09:10:00',1.96),('14598','2013-04-03','09:15:00',1.57),('14598','2013-04-03','09:20:00',2.65),('14598','2013-04-03','09:25:00',1.21),('14598','2013-04-03','09:30:00',1.88),('14598','2013-04-03','09:35:00',1.2),('14598','2013-04-03','09:40:00',2.18),('14598','2013-04-03','09:45:00',1.91),('14598','2013-04-03','09:50:00',2.03),('14598','2013-04-03','09:55:00',2.73),('14598','2013-04-03','10:00:00',2.5),('14598','2013-04-03','10:05:00',3.42),('14598','2013-04-03','10:10:00',2.03),('14598','2013-04-03','10:15:00',2.17),('14598','2013-04-03','10:20:00',2.09),('14598','2013-04-03','10:25:00',1.74),('14598','2013-04-03','10:30:00',1.94),('14598','2013-04-03','10:35:00',2),('14598','2013-04-03','10:40:00',2.25),('14598','2013-04-03','10:45:00',2.75),('14598','2013-04-03','10:50:00',4.15),('14598','2013-04-03','10:55:00',4.52),('14598','2013-04-03','11:00:00',4.74),('14598','2013-04-03','11:05:00',4.68),('14598','2013-04-03','11:10:00',2.7),('14598','2013-04-03','11:15:00',2.25),('14598','2013-04-03','11:20:00',2.2),('14598','2013-04-03','11:25:00',2.15),('14598','2013-04-03','11:30:00',2.54),('14598','2013-04-03','11:35:00',3.65),('14598','2013-04-03','11:40:00',3.47),('14598','2013-04-03','11:45:00',3.6),('14598','2013-04-03','11:50:00',4.57),('14598','2013-04-03','11:55:00',4.64),('14598','2013-04-03','12:00:00',4.75),('14598','2013-04-03','12:05:00',3.66),('14598','2013-04-03','12:10:00',2.37),('14598','2013-04-03','12:15:00',4.86),('14598','2013-04-03','12:20:00',3.78),('14598','2013-04-03','12:25:00',5.05),('14598','2013-04-03','12:30:00',4.94),('14598','2013-04-03','12:35:00',4.99),('14598','2013-04-03','12:40:00',5.01),('14598','2013-04-03','12:45:00',5.06),('14598','2013-04-03','12:50:00',5.07),('14598','2013-04-03','12:55:00',5.15),('14598','2013-04-03','13:05:00',4.93),('14598','2013-04-03','13:10:00',4.56),('14598','2013-04-03','13:15:00',5.86),('14598','2013-04-03','13:20:00',5.58),('14598','2013-04-03','13:25:00',5.56),('14598','2013-04-03','13:30:00',5.39),('14598','2013-04-03','13:35:00',5.35),('14598','2013-04-03','13:40:00',5.39),('14598','2013-04-03','13:45:00',5.37),('14598','2013-04-03','13:50:00',5.27),('14598','2013-04-03','13:55:00',5.24),('14598','2013-04-03','14:00:00',5.2),('14598','2013-04-03','14:05:00',5.22),('14598','2013-04-03','14:10:00',5.15),('14598','2013-04-03','14:15:00',4.04),('14598','2013-04-03','14:20:00',5.27),('14598','2013-04-03','14:25:00',5.19),('14598','2013-04-03','14:30:00',5.11),('14598','2013-04-03','14:35:00',5.08),('14598','2013-04-03','14:40:00',4.94),('14598','2013-04-03','14:45:00',5.02),('14598','2013-04-03','14:50:00',4.97),('14598','2013-04-03','14:55:00',4.92),('14598','2013-04-03','15:00:00',4.9),('14598','2013-04-03','15:05:00',4.86),('14598','2013-04-03','15:10:00',4.83),('14598','2013-04-03','15:15:00',4.78),('14598','2013-04-03','15:20:00',4.75),('14598','2013-04-03','15:25:00',4.72),('14598','2013-04-03','15:30:00',4.65),('14598','2013-04-03','15:35:00',4.6),('14598','2013-04-03','15:40:00',4.54),('14598','2013-04-03','15:45:00',4.5),('14598','2013-04-03','15:50:00',4.42),('14598','2013-04-03','15:55:00',4.32),('14598','2013-04-03','16:00:00',4.32),('14598','2013-04-03','16:05:00',4.24),('14598','2013-04-03','16:10:00',4.17),('14598','2013-04-03','16:15:00',4.1),('14598','2013-04-03','16:20:00',4.01),('14598','2013-04-03','16:25:00',3.94),('14598','2013-04-03','16:30:00',3.87),('14598','2013-04-03','16:35:00',3.77),('14598','2013-04-03','16:40:00',3.69),('14598','2013-04-03','16:45:00',3.61),('14598','2013-04-03','16:50:00',3.53),('14598','2013-04-03','16:55:00',3.43),('14598','2013-04-03','17:00:00',3.35),('14598','2013-04-03','17:05:00',3.24),('14598','2013-04-03','17:10:00',3.14),('14598','2013-04-03','17:15:00',3.04),('14598','2013-04-03','17:20:00',2.95),('14598','2013-04-03','17:25:00',2.84),('14598','2013-04-03','17:30:00',2.7),('14598','2013-04-03','17:35:00',2.62),('14598','2013-04-03','17:40:00',2.51),('14598','2013-04-03','17:45:00',2.42),('14598','2013-04-03','17:50:00',2.3),('14598','2013-04-03','17:55:00',2.18),('14598','2013-04-03','18:00:00',2.05),('14598','2013-04-03','18:05:00',1.93),('14598','2013-04-03','18:10:00',1.81),('14598','2013-04-03','18:15:00',1.69),('14598','2013-04-03','18:20:00',1.56),('14598','2013-04-03','18:25:00',1.42),('14598','2013-04-03','18:30:00',1.3),('14598','2013-04-03','18:35:00',1.17),('14598','2013-04-03','18:40:00',1.04),('14598','2013-04-02','08:10:00',1.15),('14598','2013-04-02','08:15:00',1.15),('14598','2013-04-02','08:40:00',1.03),('14598','2013-04-02','08:45:00',1.11),('14598','2013-04-02','08:50:00',1.32),('14598','2013-04-02','09:00:00',1.28),('14598','2013-04-02','09:05:00',1.27),('14598','2013-04-02','09:10:00',1.66),('14598','2013-04-02','09:15:00',1.75),('14598','2013-04-02','09:20:00',1.96),('14598','2013-04-02','09:25:00',2.46),('14598','2013-04-02','09:30:00',1.87),('14598','2013-04-02','09:35:00',2.29),('14598','2013-04-02','09:40:00',2.39),('14598','2013-04-02','09:45:00',2.51),('14598','2013-04-02','09:50:00',2.62),('14598','2013-04-02','09:55:00',2.38),('14598','2013-04-02','10:00:00',2.55),('14598','2013-04-02','10:05:00',3),('14598','2013-04-02','10:10:00',2.15),('14598','2013-04-02','10:15:00',3.3),('14598','2013-04-02','10:20:00',3.51),('14598','2013-04-02','10:25:00',3.49),('14598','2013-04-02','10:30:00',3.44),('14598','2013-04-02','10:35:00',3.58),('14598','2013-04-02','10:40:00',3.89),('14598','2013-04-02','10:45:00',2.45),('14598','2013-04-02','10:50:00',2.21),('14598','2013-04-02','10:55:00',2.41),('14598','2013-04-02','11:00:00',1.24),('14598','2013-04-02','11:05:00',2.47),('14598','2013-04-02','11:10:00',4.4),('14598','2013-04-02','11:15:00',4.46),('14598','2013-04-02','11:20:00',4.22),('14598','2013-04-02','11:25:00',3.37),('14598','2013-04-02','11:30:00',4.2),('14598','2013-04-02','11:35:00',1.97),('14598','2013-04-02','11:40:00',3.68),('14598','2013-04-02','11:45:00',4.97),('14598','2013-04-02','11:50:00',3.96),('14598','2013-04-02','11:55:00',2.05),('14598','2013-04-02','12:00:00',3.43),('14598','2013-04-02','12:05:00',3.27),('14598','2013-04-02','12:10:00',3.03),('14598','2013-04-02','12:15:00',4.17),('14598','2013-04-02','12:20:00',5.19),('14598','2013-04-02','12:25:00',3.84),('14598','2013-04-02','12:30:00',3),('14598','2013-04-02','12:35:00',3.15),('14598','2013-04-02','12:40:00',1.96),('14598','2013-04-02','12:45:00',2.12),('14598','2013-04-02','12:50:00',2.1),('14598','2013-04-02','12:55:00',2.59),('14598','2013-04-02','13:00:00',2.64),('14598','2013-04-02','13:05:00',1.29),('14598','2013-04-02','13:10:00',1.28),('14598','2013-04-02','13:15:00',1.27),('14598','2013-04-02','13:20:00',1.06),('14598','2013-04-02','13:25:00',1.15),('14598','2013-04-02','13:30:00',2.11),('14598','2013-04-02','13:35:00',4.74),('14598','2013-04-02','13:40:00',5.42),('14598','2013-04-02','13:45:00',5.22),('14598','2013-04-02','13:50:00',4.49),('14598','2013-04-02','13:55:00',3.25),('14598','2013-04-02','14:00:00',1.45),('14598','2013-04-02','14:05:00',1.8),('14598','2013-04-02','14:10:00',2),('14598','2013-04-02','14:15:00',4.51),('14598','2013-04-02','14:20:00',3.09),('14598','2013-04-02','14:25:00',4.62),('14598','2013-04-02','14:30:00',3.7),('14598','2013-04-02','14:35:00',2.57),('14598','2013-04-02','14:40:00',1.95),('14598','2013-04-02','14:45:00',1.94),('14598','2013-04-02','14:50:00',2.6),('14598','2013-04-02','14:55:00',2.37),('14598','2013-04-02','15:00:00',1.84),('14598','2013-04-02','15:05:00',1.4),('14598','2013-04-02','15:15:00',1.34),('14598','2013-04-02','15:30:00',1.05),('14598','2013-04-02','15:45:00',1.03),('14598','2013-04-02','15:50:00',1.09),('14598','2013-04-02','16:00:00',1.11),('14598','2013-04-02','16:05:00',1.58),('14598','2013-04-02','16:10:00',1.45),('14598','2013-04-02','16:15:00',1.2),('14598','2013-04-02','17:15:00',1.3),('14598','2013-04-02','17:20:00',1.14),('14598','2013-04-02','17:30:00',1.74),('14598','2013-04-02','17:35:00',2.43),('14598','2013-04-02','17:40:00',2.24),('14598','2013-04-02','17:45:00',1.01),('14598','2014-05-02','07:45:00',1.08),('14598','2014-05-02','08:25:00',1.09),('14598','2014-05-02','08:30:00',1.38),('14598','2014-05-02','08:35:00',1.41),('14598','2014-05-02','08:40:00',1.18),('14598','2014-05-02','08:45:00',1.19),('14598','2014-05-02','08:50:00',1.28),('14598','2014-05-02','08:55:00',1.3),('14598','2014-05-02','09:00:00',1.33),('14598','2014-05-02','09:05:00',1.86),('14598','2014-05-02','09:10:00',1.85),('14598','2014-05-02','09:15:00',1.54),('14598','2014-05-02','09:20:00',1.51),('14598','2014-05-02','09:25:00',1.75),('14598','2014-05-02','09:30:00',1.57),('14598','2014-05-02','09:35:00',1.21),('14598','2014-05-02','10:10:00',1.02),('14598','2014-05-02','10:15:00',1.09),('14598','2014-05-02','10:20:00',1.23),('14598','2014-05-02','10:25:00',1.4),('14598','2014-05-02','10:30:00',1.4),('14598','2014-05-02','10:35:00',1.33),('14598','2014-05-02','10:40:00',1.25),('14598','2014-05-02','10:45:00',1.31),('14598','2014-05-02','10:50:00',1.09),('14598','2014-05-02','11:10:00',1.16),('14598','2014-05-02','11:15:00',1.36),('14598','2014-05-02','11:20:00',1.5),('14598','2014-05-02','11:25:00',1.5),('14598','2014-05-02','11:30:00',1.51),('14598','2014-05-02','11:35:00',1.87),('14598','2014-05-02','11:40:00',2.24),('14598','2014-05-02','11:45:00',2.26),('14598','2014-05-02','11:50:00',2.29),('14598','2014-05-02','11:55:00',2.54),('14598','2014-05-02','12:00:00',2.45),('14598','2014-05-02','12:05:00',2.24),('14598','2014-05-02','12:10:00',1.74),('14598','2014-05-02','12:15:00',1.77),('14598','2014-05-02','12:20:00',2.1),('14598','2014-05-02','12:25:00',2.07),('14598','2014-05-02','12:30:00',2.26),('14598','2014-05-02','12:35:00',2.16),('14598','2014-05-02','12:40:00',1.8),('14598','2014-05-02','12:45:00',2.1),('14598','2014-05-02','12:50:00',3),('14598','2014-05-02','12:55:00',3.34),('14598','2014-05-02','13:00:00',3.78),('14598','2014-05-02','13:05:00',3.27),('14598','2014-05-02','13:10:00',3.98),('14598','2014-05-02','13:15:00',4.69),('14598','2014-05-02','13:20:00',5.3),('14598','2014-05-02','13:25:00',3.79),('14598','2014-05-02','13:30:00',4.46),('14598','2014-05-02','13:35:00',3.01),('14598','2014-05-02','13:40:00',3.62),('14598','2014-05-02','13:45:00',2.7),('14598','2014-05-02','13:50:00',2.98),('14598','2014-05-02','13:55:00',3.55),('14598','2014-05-02','14:00:00',4.89),('14598','2014-05-02','14:05:00',4.37),('14598','2014-05-02','14:10:00',4.18),('14598','2014-05-02','14:15:00',1.32),('14598','2014-05-02','14:20:00',1.15),('14598','2014-05-02','14:30:00',1.21),('14598','2014-05-02','14:35:00',1.88),('14598','2014-05-02','14:40:00',3.14),('14598','2014-05-02','14:45:00',3),('14598','2014-05-02','14:50:00',2.13),('14598','2014-05-02','14:55:00',1.9),('14598','2014-05-02','15:00:00',1.25),('14598','2014-05-02','15:05:00',1.32),('14598','2014-05-02','15:10:00',1.02),('14598','2014-05-02','15:15:00',1.17),('14598','2014-05-02','15:20:00',1.46),('14598','2014-05-02','15:25:00',1.75),('14598','2014-05-02','15:30:00',1.74),('14598','2014-05-02','15:45:00',1.76),('14598','2014-05-02','15:50:00',2.2),('14598','2014-05-02','15:55:00',2.47),('14598','2014-05-02','16:00:00',1.99),('14598','2014-05-02','16:05:00',1.91),('14598','2014-05-02','16:10:00',2.14),('14598','2014-05-02','16:15:00',1.85),('14598','2014-05-02','16:20:00',1.76),('14598','2014-05-02','16:25:00',1.35),('14598','2014-05-02','16:30:00',1.04),('14598','2014-05-02','16:35:00',1.3),('14598','2014-05-02','16:40:00',1.6),('14598','2014-05-02','16:45:00',1.92),('14598','2014-05-02','16:50:00',2.17),('14598','2014-05-02','16:55:00',1.52),('14598','2014-03-27','09:55:00',1.21),('14598','2014-03-27','10:00:00',1.59),('14598','2014-03-27','10:05:00',1.66),('14598','2014-03-27','10:10:00',1.71),('14598','2014-03-27','10:15:00',1.71),('14598','2014-03-27','10:20:00',1.98),('14598','2014-03-27','10:25:00',2.47),('14598','2014-03-27','10:30:00',3.32),('14598','2014-03-27','10:35:00',3.85),('14598','2014-03-27','10:40:00',3.84),('14598','2014-03-27','10:45:00',4.52),('14598','2014-03-27','10:50:00',4.63),('14598','2014-03-27','10:55:00',4.55),('14598','2014-03-27','11:00:00',3.02),('14598','2014-03-27','11:05:00',4.04),('14598','2014-03-27','11:10:00',4.47),('14598','2014-03-27','11:15:00',3.92),('14598','2014-03-27','11:20:00',4.74),('14598','2014-03-27','11:25:00',4.88),('14598','2014-03-27','11:30:00',4.56),('14598','2014-03-27','11:35:00',3.46),('14598','2014-03-27','11:40:00',3.08),('14598','2014-03-27','11:45:00',1.56),('14598','2014-03-27','12:20:00',1.09),('14598','2014-03-27','12:25:00',1.64),('14598','2014-03-27','12:30:00',1.87),('14598','2014-03-27','12:35:00',1.88),('14598','2014-03-27','12:40:00',2.42),('14598','2014-03-27','12:45:00',3.14),('14598','2014-03-27','12:50:00',3.75),('14598','2014-03-27','12:55:00',4.76),('14598','2014-03-27','13:00:00',5),('14598','2014-03-27','13:05:00',4.75),('14598','2014-03-27','13:10:00',3.53),('14598','2014-03-27','13:15:00',5.37),('14598','2014-03-27','13:20:00',4.15),('14598','2014-03-27','13:25:00',3),('14598','2014-03-27','13:30:00',5.37),('14598','2014-03-27','13:35:00',4.74),('14598','2014-03-27','13:40:00',5.09),('14598','2014-03-27','13:45:00',5.1),('14598','2014-03-27','13:50:00',4.88),('14598','2014-03-27','13:55:00',5.18),('14598','2014-03-27','14:00:00',4.87),('14598','2014-03-27','14:05:00',5.06),('14598','2014-03-27','14:10:00',2.87),('14598','2014-03-27','14:15:00',1.74),('14598','2014-03-27','14:20:00',1.72),('14598','2014-03-27','14:25:00',1.29),('14598','2014-03-27','14:30:00',1.14),('14598','2014-03-27','14:35:00',2.09),('14598','2014-03-27','14:40:00',2.14),('14598','2014-03-27','14:45:00',1.23),('14598','2014-03-27','15:40:00',1.04),('14598','2014-03-27','15:45:00',1.17),('14598','2014-03-27','15:50:00',1.4),('14598','2014-03-27','15:55:00',1.45),('14598','2014-03-27','16:00:00',1.19),('14598','2013-04-01','08:40:00',1.38),('14598','2013-04-01','08:45:00',1.42),('14598','2013-04-01','08:50:00',1.39),('14598','2013-04-01','08:55:00',1.15),('14598','2013-04-01','09:00:00',1.51),('14598','2013-04-01','09:05:00',1.78),('14598','2013-04-01','09:10:00',1.89),('14598','2013-04-01','09:15:00',1.25),('14598','2013-04-01','09:20:00',1.67),('14598','2013-04-01','09:30:00',1.6),('14598','2013-04-01','09:35:00',1.49),('14598','2013-04-01','09:40:00',1.84),('14598','2013-04-01','09:45:00',2.57),('14598','2013-04-01','09:50:00',2.5),('14598','2013-04-01','09:55:00',2.16),('14598','2013-04-01','10:00:00',2.69),('14598','2013-04-01','10:05:00',2.98),('14598','2013-04-01','10:10:00',3.23),('14598','2013-04-01','10:15:00',3.81),('14598','2013-04-01','10:20:00',3.46),('14598','2013-04-01','10:25:00',2.71),('14598','2013-04-01','10:30:00',3.28),('14598','2013-04-01','10:35:00',3.51),('14598','2013-04-01','10:40:00',3.3),('14598','2013-04-01','10:45:00',3.79),('14598','2013-04-01','10:50:00',4.08),('14598','2013-04-01','10:55:00',4.24),('14598','2013-04-01','11:00:00',3.4),('14598','2013-04-01','11:05:00',3.49),('14598','2013-04-01','11:10:00',4.29),('14598','2013-04-01','11:15:00',4.07),('14598','2013-04-01','11:20:00',3.57),('14598','2013-04-01','11:25:00',3.25),('14598','2013-04-01','11:30:00',3.92),('14598','2013-04-01','11:35:00',3.07),('14598','2013-04-01','11:40:00',2.48),('14598','2013-04-01','11:45:00',2.7),('14598','2013-04-01','11:50:00',2.91),('14598','2013-04-01','11:55:00',2.37),('14598','2013-04-01','12:00:00',2.88),('14598','2013-04-01','12:05:00',2.57),('14598','2013-04-01','12:10:00',2.22),('14598','2013-04-01','12:15:00',2.44),('14598','2013-04-01','12:20:00',2.82),('14598','2013-04-01','12:25:00',2.49),('14598','2013-04-01','12:30:00',2.74),('14598','2013-04-01','12:35:00',2.98),('14598','2013-04-01','12:40:00',3.23),('14598','2013-04-01','12:45:00',3.07),('14598','2013-04-01','12:50:00',3.19),('14598','2013-04-01','12:55:00',3.76),('14598','2013-04-01','13:00:00',3.51),('14598','2013-04-01','13:05:00',3.44),('14598','2013-04-01','13:10:00',3.33),('14598','2013-04-01','13:15:00',3.09),('14598','2013-04-01','13:20:00',2.72),('14598','2013-04-01','13:25:00',2.56),('14598','2013-04-01','13:30:00',3.65),('14598','2013-04-01','13:35:00',3.84),('14598','2013-04-01','13:40:00',3.88),('14598','2013-04-01','13:45:00',3.13),('14598','2013-04-01','13:50:00',2.23),('14598','2013-04-01','13:55:00',2.16),('14598','2013-04-01','14:00:00',2.27),('14598','2013-04-01','14:05:00',2.52),('14598','2013-04-01','14:10:00',3.48),('14598','2013-04-01','14:15:00',4),('14598','2013-04-01','14:20:00',3.65),('14598','2013-04-01','14:25:00',3.14),('14598','2013-04-01','14:30:00',2.48),('14598','2013-04-01','14:35:00',2.4),('14598','2013-04-01','14:40:00',2.43),('14598','2013-04-01','14:45:00',2.03),('14598','2013-04-01','14:50:00',1.76),('14598','2013-04-01','14:55:00',1.97),('14598','2013-04-01','15:00:00',2.28),('14598','2013-04-01','15:05:00',2.26),('14598','2013-04-01','15:10:00',2.58),('14598','2013-04-01','15:15:00',2.26),('14598','2013-04-01','15:20:00',2.3),('14598','2013-04-01','15:25:00',2.17),('14598','2013-04-01','15:30:00',1.94),('14598','2013-04-01','15:35:00',2.67),('14598','2013-04-01','15:40:00',3.24),('14598','2013-04-01','15:45:00',2.9),('14598','2013-04-01','15:50:00',2.16),('14598','2013-04-01','15:55:00',1.73),('14598','2013-04-01','16:00:00',1.41),('14598','2013-04-01','16:05:00',1.05),('14598','2013-03-31','09:30:00',2.69),('14598','2013-03-31','09:35:00',2.06),('14598','2013-03-31','09:40:00',1.75),('14598','2013-03-31','09:45:00',1.33),('14598','2013-03-31','09:50:00',1.23),('14598','2013-03-31','09:55:00',1.31),('14598','2013-03-31','10:00:00',1.41),('14598','2013-03-31','10:05:00',1.44),('14598','2013-03-31','10:10:00',2.07),('14598','2013-03-31','10:15:00',1.43),('14598','2013-03-31','10:20:00',1.7),('14598','2013-03-31','10:25:00',2.91),('14598','2013-03-31','10:30:00',2.62),('14598','2013-03-31','10:35:00',3.27),('14598','2013-03-31','10:40:00',3.24),('14598','2013-03-31','10:45:00',2.31),('14598','2013-03-31','10:50:00',2.12),('14598','2013-03-31','10:55:00',2.99),('14598','2013-03-31','11:00:00',2.33),('14598','2013-03-31','11:05:00',2.59),('14598','2013-03-31','11:10:00',2.42),('14598','2013-03-31','11:15:00',1.97),('14598','2013-03-31','11:20:00',1.63),('14598','2013-03-31','11:25:00',1.56),('14598','2013-03-31','11:30:00',1.84),('14598','2013-03-31','11:35:00',1.79),('14598','2013-03-31','11:40:00',1.48),('14598','2013-03-31','11:45:00',1.37),('14598','2013-03-31','11:50:00',1.28),('14598','2013-03-31','11:55:00',1.5),('14598','2013-03-31','12:00:00',1.29),('14598','2013-03-31','12:05:00',1.43),('14598','2013-03-31','12:10:00',1.43),('14598','2013-03-31','12:15:00',1.18),('14598','2013-03-31','12:20:00',1.32),('14598','2013-03-31','12:25:00',1.62),('14598','2013-03-31','12:30:00',2.38),('14598','2013-03-31','12:35:00',1.64),('14598','2013-03-31','12:40:00',2.15),('14598','2013-03-31','12:45:00',2.14),('14598','2013-03-31','12:50:00',3.45),('14598','2013-03-31','12:55:00',4.13),('14598','2013-03-31','13:00:00',2.04),('14598','2013-03-31','13:05:00',3.57),('14598','2013-03-31','13:10:00',2.82),('14598','2013-03-31','13:15:00',2.52),('14598','2013-03-31','13:20:00',2.57),('14598','2013-03-31','13:25:00',2.38),('14598','2013-03-31','13:30:00',2.63),('14598','2013-03-31','13:35:00',3.88),('14598','2013-03-31','13:40:00',4.82),('14598','2013-03-31','13:45:00',3.81),('14598','2013-03-31','13:50:00',5.58),('14598','2013-03-31','13:55:00',5.05),('14598','2013-03-31','14:00:00',4.28),('14598','2013-03-31','14:05:00',3.72),('14598','2013-03-31','14:10:00',5.47),('14598','2013-03-31','14:15:00',5.23),('14598','2013-03-31','14:20:00',5.18),('14598','2013-03-31','14:25:00',5.56),('14598','2013-03-31','14:30:00',5.37),('14598','2013-03-31','14:35:00',4.29),('14598','2013-03-31','14:40:00',5.28),('14598','2013-03-31','14:45:00',5.36),('14598','2013-03-31','14:50:00',5.05),('14598','2013-03-31','14:55:00',4.87),('14598','2013-03-31','15:00:00',4.85),('14598','2013-03-31','15:05:00',4.81),('14598','2013-03-31','15:10:00',4.88),('14598','2013-03-31','15:15:00',2.96),('14598','2013-03-31','15:20:00',3.68),('14598','2013-03-31','15:25:00',4.6),('14598','2013-03-31','15:30:00',3.4),('14598','2013-03-31','15:35:00',1.83),('14598','2013-03-31','15:40:00',1.24),('14598','2013-03-31','16:00:00',1.8),('14598','2013-03-31','16:05:00',1.2),('14598','2013-03-31','16:50:00',1.16),('14598','2013-03-31','16:55:00',1.16),('14598','2013-03-31','17:10:00',1.13),('14598','2013-03-31','17:15:00',1.85),('14598','2013-03-31','17:20:00',1.37),('14598','2013-03-31','17:25:00',1.69),('14598','2013-03-31','17:30:00',2.71),('14598','2013-03-31','17:35:00',1.34),('14598','2013-03-31','17:40:00',1.89),('14598','2013-03-31','17:55:00',2.15),('14598','2013-03-31','18:00:00',2.15),('14598','2013-03-31','18:05:00',1.77),('14598','2013-03-31','18:10:00',1.53),('14598','2013-03-31','18:30:00',1.12),('14598','2013-03-30','08:55:00',1.17),('14598','2013-03-30','09:00:00',1.39),('14598','2013-03-30','09:05:00',1.03),('14598','2013-03-30','09:10:00',1),('14598','2013-03-30','09:15:00',1.11),('14598','2013-03-30','09:20:00',1.67),('14598','2013-03-30','09:25:00',1.42),('14598','2013-03-30','09:30:00',1.32),('14598','2013-03-30','09:35:00',1.69),('14598','2013-03-30','09:40:00',1.25),('14598','2013-03-30','09:45:00',1.84),('14598','2013-03-30','09:50:00',1.89),('14598','2013-03-30','09:55:00',1.57),('14598','2013-03-30','10:00:00',1.21),('14598','2013-03-30','10:05:00',1.3),('14598','2013-03-30','10:10:00',1.73),('14598','2013-03-30','10:15:00',1.57),('14598','2013-03-30','10:20:00',1.36),('14598','2013-03-30','10:25:00',1.6),('14598','2013-03-30','10:30:00',2.01),('14598','2013-03-30','10:35:00',1.87),('14598','2013-03-30','10:40:00',1.27),('14598','2013-03-30','10:45:00',1.15),('14598','2013-03-30','10:50:00',1.24),('14598','2013-03-30','11:00:00',1.02),('14598','2013-03-30','11:10:00',1.39),('14598','2013-03-30','11:15:00',1.33),('14598','2013-03-30','11:20:00',1.75),('14598','2013-03-30','11:25:00',1.69),('14598','2013-03-30','11:30:00',1.58),('14598','2013-03-30','11:35:00',1.95),('14598','2013-03-30','11:40:00',2.22),('14598','2013-03-30','11:45:00',1.81),('14598','2013-03-30','11:50:00',1.04),('14598','2013-03-30','11:55:00',1.02),('14598','2013-03-30','12:30:00',1.35),('14598','2013-03-30','12:35:00',1.05),('14598','2013-03-30','12:40:00',2.35),('14598','2013-03-30','12:45:00',2.4),('14598','2013-03-30','12:50:00',2.48),('14598','2013-03-30','12:55:00',2.8),('14598','2013-03-30','13:00:00',2.13),('14598','2013-03-30','13:05:00',1.47),('14598','2013-03-30','13:25:00',1.21),('14598','2013-03-30','13:35:00',1.47),('14598','2013-03-30','13:40:00',1.75),('14598','2013-03-30','13:45:00',1.91),('14598','2013-03-30','13:50:00',1.84),('14598','2013-03-30','13:55:00',2.1),('14598','2013-03-30','14:00:00',2.2),('14598','2013-03-30','14:05:00',2.42),('14598','2013-03-30','14:10:00',2.99),('14598','2013-03-30','14:15:00',2.13),('14598','2013-03-30','14:20:00',1.98),('14598','2013-03-30','14:25:00',2.05),('14598','2013-03-30','14:30:00',1.65),('14598','2013-03-30','14:35:00',1.54),('14598','2013-03-30','14:40:00',1.09),('14598','2013-03-30','14:45:00',1.17),('14598','2013-03-30','14:50:00',1.04),('14598','2013-03-30','15:10:00',1.06),('14598','2013-03-30','15:15:00',1.04),('14598','2013-03-29','07:45:00',1.36),('14598','2013-03-29','07:50:00',1.75),('14598','2013-03-29','07:55:00',1.27),('14598','2013-03-29','08:00:00',1.04),('14598','2013-03-29','08:10:00',1.06),('14598','2013-03-29','08:16:00',1.71),('14598','2013-03-29','08:20:00',1.71),('14598','2013-03-29','08:25:00',1.66),('14598','2013-03-29','08:30:00',1.81),('14598','2013-03-29','08:35:00',1.78),('14598','2013-03-29','08:40:00',2.12),('14598','2013-03-29','08:45:00',2.19),('14598','2013-03-29','08:50:00',2.45),('14598','2013-03-29','08:55:00',2.57),('14598','2013-03-29','09:00:00',2.72),('14598','2013-03-29','09:05:00',2.64),('14598','2013-03-29','09:10:00',3.04),('14598','2013-03-29','09:15:00',3.13),('14598','2013-03-29','09:20:00',2.99),('14598','2013-03-29','09:25:00',2.71),('14598','2013-03-29','09:30:00',2.61),('14598','2013-03-29','09:35:00',3.26),('14598','2013-03-29','09:40:00',3.33),('14598','2013-03-29','09:45:00',3.45),('14598','2013-03-29','09:50:00',3.4),('14598','2013-03-29','09:55:00',2.78),('14598','2013-03-29','10:00:00',3.04),('14598','2013-03-29','10:05:00',3.05),('14598','2013-03-29','10:10:00',3),('14598','2013-03-29','10:15:00',3.47),('14598','2013-03-29','10:20:00',3.78),('14598','2013-03-29','10:25:00',3.66),('14598','2013-03-29','10:30:00',3.7),('14598','2013-03-29','10:35:00',3.58),('14598','2013-03-29','10:40:00',3.42),('14598','2013-03-29','10:45:00',3.93),('14598','2013-03-29','10:50:00',3.96),('14598','2013-03-29','10:55:00',4.41),('14598','2013-03-29','11:00:00',4.49),('14598','2013-03-29','11:05:00',4.51),('14598','2013-03-29','11:10:00',4.56),('14598','2013-03-29','11:15:00',4.6),('14598','2013-03-29','11:20:00',4.65),('14598','2013-03-29','11:25:00',4.68),('14598','2013-03-29','11:30:00',4.71),('14598','2013-03-29','11:35:00',4.75),('14598','2013-03-29','11:40:00',4.77),('14598','2013-03-29','11:45:00',4.79),('14598','2013-03-29','11:50:00',4.83),('14598','2013-03-29','11:55:00',4.85),('14598','2013-03-29','12:00:00',4.88),('14598','2013-03-29','12:05:00',4.88),('14598','2013-03-29','12:10:00',4.87),('14598','2013-03-29','12:15:00',4.83),('14598','2013-03-29','12:20:00',4.92),('14598','2013-03-29','12:25:00',4.93),('14598','2013-03-29','12:30:00',4.93),('14598','2013-03-29','12:35:00',4.95),('14598','2013-03-29','12:40:00',4.81),('14598','2013-03-29','12:45:00',4.77),('14598','2013-03-29','12:50:00',4.99),('14598','2013-03-29','12:55:00',4.99),('14598','2013-03-29','13:00:00',5.05),('14598','2013-03-29','13:05:00',4.96),('14598','2013-03-29','13:10:00',5.05),('14598','2013-03-29','13:15:00',4.79),('14598','2013-03-29','13:20:00',4.59),('14598','2013-03-29','13:25:00',4.03),('14598','2013-03-29','13:30:00',4.07),('14598','2013-03-29','13:35:00',4.45),('14598','2013-03-29','13:40:00',4.57),('14598','2013-03-29','13:45:00',4.38),('14598','2013-03-29','13:50:00',3.64),('14598','2013-03-29','13:55:00',3.22),('14598','2013-03-29','14:00:00',3.3),('14598','2013-03-29','14:05:00',3.68),('14598','2013-03-29','14:10:00',2.89),('14598','2013-03-29','14:15:00',2.61),('14598','2013-03-29','14:20:00',2.37),('14598','2013-03-29','14:25:00',2.27),('14598','2013-03-29','14:30:00',2.14),('14598','2013-03-29','14:35:00',2.08),('14598','2013-03-29','14:40:00',2.02),('14598','2013-03-29','14:45:00',1.95),('14598','2013-03-29','14:50:00',1.86),('14598','2013-03-29','14:55:00',1.86),('14598','2013-03-29','15:00:00',1.83),('14598','2013-03-29','15:05:00',1.65),('14598','2013-03-29','15:10:00',1.49),('14598','2013-03-29','15:15:00',1.41),('14598','2013-03-29','15:20:00',1.41),('14598','2013-03-29','15:25:00',1.45),('14598','2013-03-29','15:30:00',1.75),('14598','2013-03-29','15:35:00',2.88),('14598','2013-03-29','15:40:00',3.62),('14598','2013-03-29','15:45:00',4.01),('14598','2013-03-29','15:50:00',2.99),('14598','2013-03-29','15:55:00',1.62),('14598','2013-03-29','16:00:00',1.62),('14598','2013-03-29','16:05:00',1.47),('14598','2013-03-29','16:10:00',2.22),('14598','2013-03-29','16:15:00',1.95),('14598','2013-03-29','16:20:00',2.43),('14598','2013-03-29','16:25:00',3.48),('14598','2013-03-29','16:30:00',2.67),('14598','2013-03-29','16:35:00',1.69),('14598','2013-03-29','16:40:00',1.97),('14598','2013-03-29','16:45:00',1.54),('14598','2013-03-29','16:50:00',1.6),('14598','2013-03-29','16:55:00',1),('14598','2013-03-29','17:00:00',1.37),('14598','2013-03-29','17:05:00',1.17),('14598','2013-03-29','17:10:00',1.87),('14598','2013-03-29','17:15:00',1.97),('14598','2013-03-29','17:20:00',1.78),('14598','2013-03-29','17:25:00',1.4),('14598','2013-03-28','08:55:00',1.07),('14598','2013-03-28','09:00:00',1.87),('14598','2013-03-28','09:05:00',2.32),('14598','2013-03-28','09:10:00',1.33),('14598','2013-03-28','09:15:00',1.21),('14598','2013-03-28','09:20:00',1.31),('14598','2013-03-28','09:25:00',1.32),('14598','2013-03-28','09:30:00',1.01),('14598','2013-03-28','11:40:00',1.24),('14598','2013-03-28','11:45:00',1.47),('14598','2013-03-28','11:50:00',1.27),('14598','2013-03-28','12:55:00',1.37),('14598','2013-03-28','13:00:00',1),('14598','2013-03-28','13:05:00',1.5),('14598','2013-03-28','13:10:00',2.94),('14598','2013-03-28','13:15:00',5.8),('14598','2013-03-28','13:20:00',5.25),('14598','2013-03-28','13:25:00',4.37),('14598','2013-03-28','13:30:00',5.35),('14598','2013-03-28','13:35:00',3.7),('14598','2013-03-28','13:40:00',2.59),('14598','2013-03-28','13:45:00',1.56),('14598','2013-03-28','13:50:00',1.2),('14598','2013-03-28','13:55:00',2.12),('14598','2013-03-28','14:00:00',3.44),('14598','2013-03-28','14:05:00',2.7),('14598','2013-03-28','14:10:00',2.06),('14598','2013-03-28','14:15:00',2.31),('14598','2013-03-28','14:20:00',2.5),('14598','2013-03-28','14:25:00',2.18),('14598','2013-03-28','14:30:00',2.47),('14598','2013-03-28','14:35:00',2.29),('14598','2013-03-28','14:40:00',2.05),('14598','2013-03-28','14:45:00',2.1),('14598','2013-03-28','14:50:00',2.45),('14598','2013-03-28','14:55:00',3.61),('14598','2013-03-28','15:00:00',4.57),('14598','2013-03-28','15:05:00',3.81),('14598','2013-03-28','15:10:00',2.33),('14598','2013-03-28','15:15:00',1.96),('14598','2013-03-28','15:20:00',1.27),('14598','2013-03-28','15:25:00',1.36),('14598','2013-03-28','15:30:00',2.05),('14598','2013-03-28','15:35:00',3.08),('14598','2013-03-28','15:40:00',2.03),('14598','2013-03-28','15:45:00',1.93),('14598','2013-03-28','15:55:00',1.69),('14598','2013-03-28','16:00:00',3.76),('14598','2013-03-28','16:05:00',2.15),('14598','2013-03-28','16:10:00',1.66),('14598','2013-03-28','16:15:00',1.85),('14598','2013-03-28','16:20:00',2.51),('14598','2013-03-28','16:25:00',1.93),('14598','2013-03-28','16:30:00',1.68),('14598','2013-03-28','16:35:00',1.09),('14598','2013-03-28','16:40:00',1.21),('14598','2013-03-28','16:45:00',1.07),('14598','2013-03-28','16:50:00',2.12),('14598','2013-03-28','16:55:00',2.43),('14598','2013-03-28','17:00:00',1.77),('14598','2013-03-28','17:05:00',1.41),('14598','2013-03-28','17:10:00',1.18),('14598','2013-03-27','07:40:00',1.1),('14598','2013-03-27','07:45:00',1.39),('14598','2013-03-27','08:00:00',1.28),('14598','2013-03-27','08:05:00',1.35),('14598','2013-03-27','08:10:00',1.19),('14598','2013-03-27','08:15:00',1.54),('14598','2013-03-27','08:20:00',1.89),('14598','2013-03-27','08:25:00',2.31),('14598','2013-03-27','08:30:00',1.67),('14598','2013-03-27','08:35:00',2.09),('14598','2013-03-27','08:40:00',2.03),('14598','2013-03-27','08:45:00',2.45),('14598','2013-03-27','08:50:00',2.31),('14598','2013-03-27','08:55:00',2.33),('14598','2013-03-27','09:00:00',3.06),('14598','2013-03-27','09:05:00',2.47),('14598','2013-03-27','09:10:00',2.6),('14598','2013-03-27','09:15:00',1.53),('14598','2013-03-27','09:20:00',1.91),('14598','2013-03-27','09:25:00',1.66),('14598','2013-03-27','09:30:00',2.44),('14598','2013-03-27','09:35:00',1.49),('14598','2013-03-27','09:40:00',2.7),('14598','2013-03-27','09:45:00',2.11),('14598','2013-03-27','09:50:00',1.17),('14598','2013-03-27','09:55:00',1.84),('14598','2013-03-27','10:00:00',2.78),('14598','2013-03-27','10:05:00',2.33),('14598','2013-03-27','10:10:00',2.69),('14598','2013-03-27','10:15:00',2.73),('14598','2013-03-27','10:20:00',2.37),('14598','2013-03-27','10:25:00',3.15),('14598','2013-03-27','10:30:00',2.98),('14598','2013-03-27','10:35:00',2.64),('14598','2013-03-27','10:40:00',2.34),('14598','2013-03-27','10:45:00',2.07),('14598','2013-03-27','10:50:00',2.05),('14598','2013-03-27','10:55:00',2.07),('14598','2013-03-27','11:00:00',2.14),('14598','2013-03-27','11:05:00',2.11),('14598','2013-03-27','11:10:00',2.33),('14598','2013-03-27','11:15:00',2.29),('14598','2013-03-27','11:20:00',2.18),('14598','2013-03-27','11:25:00',2.13),('14598','2013-03-27','11:30:00',2.1),('14598','2013-03-27','11:35:00',2.72),('14598','2013-03-27','11:40:00',3.84),('14598','2013-03-27','11:45:00',3.78),('14598','2013-03-27','11:50:00',3.39),('14598','2013-03-27','11:55:00',3.87),('14598','2013-03-27','12:00:00',3.67),('14598','2013-03-27','12:05:00',3.22),('14598','2013-03-27','12:10:00',3.28),('14598','2013-03-27','12:15:00',3.67),('14598','2013-03-27','12:20:00',3.76),('14598','2013-03-27','12:25:00',4.06),('14598','2013-03-27','12:30:00',3.16),('14598','2013-03-27','12:35:00',2.95),('14598','2013-03-27','12:40:00',4.14),('14598','2013-03-27','12:45:00',3.85),('14598','2013-03-27','12:50:00',3.71),('14598','2013-03-27','12:55:00',2.77),('14598','2013-03-27','13:00:00',2.4),('14598','2013-03-27','13:05:00',2.36),('14598','2013-03-27','13:10:00',2.32),('14598','2013-03-27','13:15:00',2.31),('14598','2013-03-27','13:20:00',2.53),('14598','2013-03-27','13:25:00',2.52),('14598','2013-03-27','13:30:00',2.56),('14598','2013-03-27','13:35:00',2.71),('14598','2013-03-27','13:40:00',2.26),('14598','2013-03-27','13:45:00',2),('14598','2013-03-27','13:50:00',1.87),('14598','2013-03-27','13:55:00',2.16),('14598','2013-03-27','14:00:00',2.34),('14598','2013-03-27','14:05:00',2.1),('14598','2013-03-27','14:10:00',1.99),('14598','2013-03-27','14:15:00',1.69),('14598','2013-03-27','14:20:00',1.97),('14598','2013-03-27','14:25:00',2.14),('14598','2013-03-27','14:30:00',1.98),('14598','2013-03-27','14:35:00',1.94),('14598','2013-03-27','14:40:00',1.86),('14598','2013-03-27','14:45:00',2.07),('14598','2013-03-27','14:50:00',1.86),('14598','2013-03-27','14:55:00',1.76),('14598','2013-03-27','15:00:00',1.43),('14598','2013-03-27','15:05:00',1.42),('14598','2013-03-27','15:10:00',1.84),('14598','2013-03-27','15:15:00',2.01),('14598','2013-03-27','15:20:00',1.59),('14598','2013-03-27','15:25:00',1.94),('14598','2013-03-27','15:30:00',1.76),('14598','2013-03-27','15:35:00',1.32),('14598','2013-03-27','15:40:00',1.66),('14598','2013-03-27','15:45:00',1.61),('14598','2013-03-27','15:50:00',1.89),('14598','2013-03-27','15:55:00',1.67),('14598','2013-03-27','16:00:00',1.28),('14598','2013-03-27','16:05:00',1.25),('14598','2013-03-27','16:10:00',1.08),('14598','2013-03-27','16:20:00',1),('14598','2013-03-27','16:25:00',1.06),('14598','2013-03-27','16:30:00',1.17),('14598','2013-03-27','16:35:00',1.4),('14598','2013-03-27','16:40:00',1.51),('14598','2013-03-27','16:45:00',1.56),('14598','2013-03-27','16:50:00',2.05),('14598','2013-03-27','16:55:00',1.79),('14598','2013-03-26','08:40:00',1.23),('14598','2013-03-26','08:45:00',1.35),('14598','2013-03-26','09:20:00',1.13),('14598','2013-03-26','09:25:00',2.21),('14598','2013-03-26','09:30:00',1.63),('14598','2013-03-26','09:35:00',1.21),('14598','2013-03-26','09:45:00',1.16),('14598','2013-03-26','10:05:00',1.63),('14598','2013-03-26','10:10:00',1.16),('14598','2013-03-26','10:15:00',1.1),('14598','2013-03-26','10:20:00',1.15),('14598','2013-03-26','10:25:00',1.62),('14598','2013-03-26','10:30:00',2.49),('14598','2013-03-26','10:35:00',2.52),('14598','2013-03-26','10:40:00',1.34),('14598','2013-03-26','10:45:00',1.75),('14598','2013-03-26','10:50:00',3.25),('14598','2013-03-26','10:55:00',2.89),('14598','2013-03-26','11:00:00',1.81),('14598','2013-03-26','11:05:00',2.8),('14598','2013-03-26','11:10:00',3.99),('14598','2013-03-26','11:15:00',4.1),('14598','2013-03-26','11:20:00',2.72),('14598','2013-03-26','11:25:00',2.08),('14598','2013-03-26','11:30:00',3.71),('14598','2013-03-26','11:35:00',5.18),('14598','2013-03-26','11:40:00',3.69),('14598','2013-03-26','11:45:00',3.05),('14598','2013-03-26','11:50:00',2.6),('14598','2013-03-26','11:55:00',1.77),('14598','2013-03-26','12:00:00',1.74),('14598','2013-03-26','12:05:00',2.29),('14598','2013-03-26','12:10:00',2.99),('14598','2013-03-26','12:15:00',3.18),('14598','2013-03-26','12:20:00',1.86),('14598','2013-03-26','12:25:00',2.35),('14598','2013-03-26','12:30:00',2.53),('14598','2013-03-26','12:35:00',3.73),('14598','2013-03-26','12:40:00',3.49),('14598','2013-03-26','12:45:00',2.75),('14598','2013-03-26','12:50:00',3.16),('14598','2013-03-26','12:55:00',3.03),('14598','2013-03-26','13:00:00',2.61),('14598','2013-03-26','13:05:00',2.5),('14598','2013-03-26','13:10:00',2.74),('14598','2013-03-26','13:15:00',2.05),('14598','2013-03-26','13:20:00',2.05),('14598','2013-03-26','13:25:00',2.15),('14598','2013-03-26','13:30:00',1.98),('14598','2013-03-26','13:35:00',1.84),('14598','2013-03-26','13:40:00',2.76),('14598','2013-03-26','13:45:00',3.12),('14598','2013-03-26','13:50:00',3.49),('14598','2013-03-26','13:55:00',2.89),('14598','2013-03-26','14:00:00',2.02),('14598','2013-03-26','14:05:00',1.62),('14598','2013-03-26','14:10:00',1.33),('14598','2013-03-26','14:15:00',1.36),('14598','2013-03-26','14:20:00',1.35),('14598','2013-03-26','14:25:00',1.24),('14598','2013-03-26','14:30:00',1.19),('14598','2013-03-26','14:35:00',1.24),('14598','2013-03-26','14:40:00',1.24),('14598','2013-03-26','14:45:00',1.19),('14598','2013-03-26','14:50:00',1.11),('14598','2013-03-26','14:55:00',1.08),('14598','2013-03-26','15:00:00',1.09),('14598','2013-03-26','15:05:00',1.21),('14598','2013-03-26','15:10:00',1.33),('14598','2013-03-26','15:15:00',1.25),('14598','2013-03-26','15:20:00',1.04),('14598','2013-03-25','07:40:00',1.15),('14598','2013-03-25','07:50:00',1.17),('14598','2013-03-25','07:55:00',1.28),('14598','2013-03-25','08:00:00',1.36),('14598','2013-03-25','08:05:00',1.49),('14598','2013-03-25','08:10:00',1.66),('14598','2013-03-25','08:15:00',1.88),('14598','2013-03-25','08:20:00',1.42),('14598','2013-03-25','08:25:00',2.32),('14598','2013-03-25','08:30:00',3.25),('14598','2013-03-25','08:35:00',2.57),('14598','2013-03-25','08:40:00',1.5),('14598','2013-03-25','08:45:00',1.45),('14598','2013-03-25','08:50:00',1.29),('14598','2013-03-25','08:55:00',1.5),('14598','2013-03-25','09:00:00',3.64),('14598','2013-03-25','09:05:00',1.83),('14598','2013-03-25','09:25:00',1.41),('14598','2013-03-25','09:30:00',3.34),('14598','2013-03-25','09:35:00',3.59),('14598','2013-03-25','09:40:00',2.06),('14598','2013-03-25','09:45:00',1.24),('14598','2013-03-25','09:55:00',1.01),('14598','2013-03-25','10:00:00',2.42),('14598','2013-03-25','10:05:00',2.28),('14598','2013-03-25','10:20:00',1.89),('14598','2013-03-25','10:25:00',2.56),('14598','2013-03-25','10:30:00',2.95),('14598','2013-03-25','10:35:00',4.62),('14598','2013-03-25','10:40:00',3.04),('14598','2013-03-25','10:45:00',2.12),('14598','2013-03-25','10:50:00',3.25),('14598','2013-03-25','10:55:00',4.21),('14598','2013-03-25','11:00:00',4.72),('14598','2013-03-25','11:05:00',4.56),('14598','2013-03-25','11:10:00',3.24),('14598','2013-03-25','11:15:00',3.02),('14598','2013-03-25','11:20:00',3.32),('14598','2013-03-25','11:25:00',4.43),('14598','2013-03-25','11:30:00',5.51),('14598','2013-03-25','11:35:00',3.86),('14598','2013-03-25','11:40:00',4.39),('14598','2013-03-25','11:45:00',2.93),('14598','2013-03-25','11:50:00',3.33),('14598','2013-03-25','11:55:00',4.36),('14598','2013-03-25','12:00:00',4.7),('14598','2013-03-25','12:05:00',5.16),('14598','2013-03-25','12:10:00',5.12),('14598','2013-03-25','12:15:00',5.25),('14598','2013-03-25','12:20:00',4.37),('14598','2013-03-25','12:25:00',4.05),('14598','2013-03-25','12:30:00',2.23),('14598','2013-03-25','12:35:00',5.46),('14598','2013-03-25','12:40:00',5.24),('14598','2013-03-25','12:45:00',3.97),('14598','2013-03-25','12:50:00',2.87),('14598','2013-03-25','12:55:00',3.7),('14598','2013-03-25','13:00:00',4.13),('14598','2013-03-25','13:05:00',4.77),('14598','2013-03-25','13:10:00',5.41),('14598','2013-03-25','13:15:00',4.27),('14598','2013-03-25','13:20:00',5.5),('14598','2013-03-25','13:25:00',5.28),('14598','2013-03-25','13:30:00',4.8),('14598','2013-03-25','13:35:00',4.18),('14598','2013-03-25','13:40:00',4.66),('14598','2013-03-25','13:45:00',4.64),('14598','2013-03-25','13:50:00',4.87),('14598','2013-03-25','13:55:00',5.04),('14598','2013-03-25','14:00:00',4.98),('14598','2013-03-25','14:05:00',4.86),('14598','2013-03-25','14:10:00',4.83),('14598','2013-03-25','14:15:00',4.03),('14598','2013-03-25','14:20:00',4.36),('14598','2013-03-25','14:25:00',4.44),('14598','2013-03-25','14:30:00',3.76),('14598','2013-03-25','14:35:00',3.89),('14598','2013-03-25','14:40:00',4.38),('14598','2013-03-25','14:45:00',4.75),('14598','2013-03-25','14:50:00',4.89),('14598','2013-03-25','14:55:00',4.08),('14598','2013-03-25','15:00:00',4.28),('14598','2013-03-25','15:05:00',3.4),('14598','2013-03-25','15:10:00',3.28),('14598','2013-03-25','15:15:00',2.56),('14598','2013-03-25','15:20:00',3.04),('14598','2013-03-25','15:25:00',2.55),('14598','2013-03-25','15:30:00',3.21),('14598','2013-03-25','15:35:00',3.51),('14598','2013-03-25','15:40:00',1.83),('14598','2013-03-25','15:45:00',1.5),('14598','2013-03-25','15:50:00',2.93),('14598','2013-03-25','15:55:00',2.61),('14598','2013-03-25','16:00:00',3.17),('14598','2013-03-25','16:05:00',2.76),('14598','2013-03-25','16:10:00',2.83),('14598','2013-03-25','16:15:00',3.08),('14598','2013-03-25','16:20:00',1.92),('14598','2013-03-25','16:25:00',3),('14598','2013-03-25','16:30:00',2.2),('14598','2013-03-25','16:35:00',1.97),('14598','2013-03-25','16:40:00',1.52),('14598','2013-03-24','07:55:00',1.08),('14598','2013-03-24','08:00:00',1.2),('14598','2013-03-24','08:05:00',1.3),('14598','2013-03-24','08:10:00',1.37),('14598','2013-03-24','08:15:00',1.45),('14598','2013-03-24','08:20:00',1.56),('14598','2013-03-24','08:25:00',1.76),('14598','2013-03-24','08:30:00',1.88),('14598','2013-03-24','08:35:00',1.96),('14598','2013-03-24','08:40:00',2.05),('14598','2013-03-24','08:45:00',2.18),('14598','2013-03-24','08:50:00',2.26),('14598','2013-03-24','08:55:00',2.38),('14598','2013-03-24','09:00:00',2.47),('14598','2013-03-24','09:05:00',2.55),('14598','2013-03-24','09:10:00',2.64),('14598','2013-03-24','09:15:00',2.74),('14598','2013-03-24','09:20:00',2.83),('14598','2013-03-24','09:25:00',2.92),('14598','2013-03-24','09:30:00',3),('14598','2013-03-24','09:35:00',3.09),('14598','2013-03-24','09:40:00',3.15),('14598','2013-03-24','09:45:00',3.23),('14598','2013-03-24','09:50:00',3.31),('14598','2013-03-24','09:55:00',3.39),('14598','2013-03-24','10:00:00',3.46),('14598','2013-03-24','10:05:00',3.48),('14598','2013-03-24','10:10:00',3.59),('14598','2013-03-24','10:15:00',3.65),('14598','2013-03-24','10:20:00',3.71),('14598','2013-03-24','10:25:00',3.77),('14598','2013-03-24','10:30:00',3.82),('14598','2013-03-24','10:35:00',3.86),('14598','2013-03-24','10:40:00',3.91),('14598','2013-03-24','10:45:00',3.97),('14598','2013-03-24','10:50:00',4.02),('14598','2013-03-24','10:55:00',4.06),('14598','2013-03-24','11:00:00',4.1),('14598','2013-03-24','11:05:00',4.15),('14598','2013-03-24','11:10:00',4.17),('14598','2013-03-24','11:15:00',4.21),('14598','2013-03-24','11:20:00',4.28),('14598','2013-03-24','11:25:00',4.39),('14598','2013-03-24','11:30:00',4.45),('14598','2013-03-24','11:35:00',4.49),('14598','2013-03-24','11:40:00',4.52),('14598','2013-03-24','11:45:00',4.56),('14598','2013-03-24','11:50:00',4.56),('14598','2013-03-24','11:55:00',4.6),('14598','2013-03-24','12:00:00',4.6),('14598','2013-03-24','12:05:00',4.63),('14598','2013-03-24','12:10:00',4.66),('14598','2013-03-24','12:15:00',4.67),('14598','2013-03-24','12:20:00',4.69),('14598','2013-03-24','12:25:00',4.69),('14598','2013-03-24','12:30:00',4.69),('14598','2013-03-24','12:35:00',4.69),('14598','2013-03-24','12:40:00',4.69),('14598','2013-03-24','12:45:00',4.69),('14598','2013-03-24','12:50:00',4.7),('14598','2013-03-24','12:55:00',4.69),('14598','2013-03-24','13:00:00',4.64),('14598','2013-03-24','13:05:00',4.55),('14598','2013-03-24','13:10:00',4.64),('14598','2013-03-24','13:15:00',4.64),('14598','2013-03-24','13:20:00',4.66),('14598','2013-03-24','13:25:00',4.62),('14598','2013-03-24','13:30:00',4.59),('14598','2013-03-24','13:35:00',4.55),('14598','2013-03-24','13:40:00',4.54),('14598','2013-03-24','13:45:00',4.49),('14598','2013-03-24','13:50:00',4.4),('14598','2013-03-24','13:55:00',4.36),('14598','2013-03-24','14:00:00',4.38),('14598','2013-03-24','14:05:00',4.33),('14598','2013-03-24','14:10:00',4.26),('14598','2013-03-24','14:15:00',4.22),('14598','2013-03-24','14:20:00',4.28),('14598','2013-03-24','14:25:00',3.35),('14598','2013-03-24','14:30:00',4.06),('14598','2013-03-24','14:35:00',4.04),('14598','2013-03-24','14:40:00',4.05),('14598','2013-03-24','14:45:00',3.92),('14598','2013-03-24','14:50:00',3.52),('14598','2013-03-24','14:55:00',1.61),('14598','2013-03-24','15:00:00',2.26),('14598','2013-03-24','15:05:00',2.67),('14598','2013-03-24','15:10:00',3.33),('14598','2013-03-24','15:15:00',2.82),('14598','2013-03-24','15:20:00',3.18),('14598','2013-03-24','15:25:00',3.28),('14598','2013-03-24','15:30:00',1.96),('14598','2013-03-24','15:35:00',1.78),('14598','2013-03-24','15:40:00',1.1),('14598','2013-03-24','15:45:00',1.3),('14598','2013-03-24','15:50:00',1.75),('14598','2013-03-24','16:00:00',1.11),('14598','2013-03-24','16:05:00',1.56),('14598','2013-03-24','16:10:00',1.92),('14598','2013-03-24','16:20:00',1.22),('14598','2013-03-24','16:25:00',1.21),('14598','2013-03-23','07:55:00',1.06),('14598','2013-03-23','08:00:00',1.15),('14598','2013-03-23','08:05:00',1.28),('14598','2013-03-23','08:10:00',1.36),('14598','2013-03-23','08:15:00',1.45),('14598','2013-03-23','08:20:00',1.57),('14598','2013-03-23','08:25:00',1.72),('14598','2013-03-23','08:30:00',1.88),('14598','2013-03-23','08:35:00',1.98),('14598','2013-03-23','08:40:00',2.1),('14598','2013-03-23','08:45:00',2.23),('14598','2013-03-23','08:50:00',2.33),('14598','2013-03-23','08:55:00',2.46),('14598','2013-03-23','09:00:00',2.51),('14598','2013-03-23','09:05:00',2.64),('14598','2013-03-23','09:10:00',2.74),('14598','2013-03-23','09:15:00',2.85),('14598','2013-03-23','09:20:00',2.95),('14598','2013-03-23','09:25:00',2.99),('14598','2013-03-23','09:30:00',3.02),('14598','2013-03-23','09:35:00',3.17),('14598','2013-03-23','09:40:00',3.18),('14598','2013-03-23','09:45:00',3.24),('14598','2013-03-23','09:50:00',3.41),('14598','2013-03-23','09:55:00',3.38),('14598','2013-03-23','10:00:00',2.42),('14598','2013-03-23','10:05:00',2.56),('14598','2013-03-23','10:10:00',2.41),('14598','2013-03-23','10:15:00',4.02),('14598','2013-03-23','10:20:00',3.83),('14598','2013-03-23','10:25:00',3.95),('14598','2013-03-23','10:30:00',2.81),('14598','2013-03-23','10:35:00',2.89),('14598','2013-03-23','10:40:00',2.13),('14598','2013-03-23','10:45:00',2.93),('14598','2013-03-23','10:50:00',3.91),('14598','2013-03-23','10:55:00',2.84),('14598','2013-03-23','11:00:00',3.49),('14598','2013-03-23','11:05:00',3.08),('14598','2013-03-23','11:10:00',3.18),('14598','2013-03-23','11:15:00',3.41),('14598','2013-03-23','11:20:00',3.18),('14598','2013-03-23','11:25:00',4.42),('14598','2013-03-23','11:30:00',4.39),('14598','2013-03-23','11:35:00',4.24),('14598','2013-03-23','11:40:00',4.28),('14598','2013-03-23','11:45:00',4.53),('14598','2013-03-23','11:50:00',4.55),('14598','2013-03-23','11:55:00',4.51),('14598','2013-03-23','12:00:00',4.64),('14598','2013-03-23','12:05:00',4.62),('14598','2013-03-23','12:10:00',4.76),('14598','2013-03-23','12:15:00',4.66),('14598','2013-03-23','12:20:00',4.69),('14598','2013-03-23','12:25:00',4.63),('14598','2013-03-23','12:30:00',4.65),('14598','2013-03-23','12:35:00',4.56),('14598','2013-03-23','12:40:00',4.74),('14598','2013-03-23','12:45:00',4.66),('14598','2013-03-23','12:50:00',4.26),('14598','2013-03-23','12:55:00',4.6),('14598','2013-03-23','13:00:00',4.61),('14598','2013-03-23','13:05:00',4.67),('14598','2013-03-23','13:10:00',4.77),('14598','2013-03-23','13:15:00',4.69),('14598','2013-03-23','13:20:00',4.66),('14598','2013-03-23','13:25:00',4.7),('14598','2013-03-23','13:30:00',4.62),('14598','2013-03-23','13:35:00',4.6),('14598','2013-03-23','13:40:00',4.54),('14598','2013-03-23','13:45:00',4.56),('14598','2013-03-23','13:50:00',4.54),('14598','2013-03-23','13:55:00',4.59),('14598','2013-03-23','14:00:00',4.35),('14598','2013-03-23','14:05:00',4.39),('14598','2013-03-23','14:10:00',4.51),('14598','2013-03-23','14:15:00',4.35),('14598','2013-03-23','14:20:00',4.33),('14598','2013-03-23','14:25:00',4.27),('14598','2013-03-23','14:30:00',4.09),('14598','2013-03-23','14:35:00',3.95),('14598','2013-03-23','14:40:00',3.98),('14598','2013-03-23','14:45:00',3.88),('14598','2013-03-23','14:50:00',3.89),('14598','2013-03-23','14:55:00',4),('14598','2013-03-23','15:00:00',3.83),('14598','2013-03-23','15:05:00',3.31),('14598','2013-03-23','15:10:00',3.59),('14598','2013-03-23','15:15:00',3.67),('14598','2013-03-23','15:20:00',3.49),('14598','2013-03-23','15:25:00',3.4),('14598','2013-03-23','15:30:00',3.29),('14598','2013-03-23','15:35:00',3.05),('14598','2013-03-23','15:40:00',2.46),('14598','2013-03-23','15:45:00',2.93),('14598','2013-03-23','15:50:00',2.56),('14598','2013-03-23','15:55:00',2.96),('14598','2013-03-23','16:00:00',2.69),('14598','2013-03-23','16:05:00',2.97),('14598','2013-03-23','16:10:00',2.55),('14598','2013-03-23','16:15:00',2.77),('14598','2013-03-23','16:20:00',2.22),('14598','2013-03-23','16:25:00',2.13),('14598','2013-03-23','16:30:00',1.88),('14598','2013-03-23','16:35:00',1.68),('14598','2013-03-23','16:40:00',1.7),('14598','2013-03-23','16:45:00',1.82),('14598','2013-03-23','16:50:00',1.83),('14598','2013-03-23','16:55:00',2.12),('14598','2013-03-23','17:00:00',1.98),('14598','2013-03-23','17:05:00',1.68),('14598','2013-03-23','17:10:00',1.49),('14598','2013-03-23','17:15:00',1.43),('14598','2013-03-23','17:20:00',1.33),('14598','2013-03-23','17:25:00',1.11),('14598','2014-03-26','07:50:00',1.05),('14598','2014-03-26','07:55:00',1.23),('14598','2014-03-26','08:05:00',1.13),('14598','2014-03-26','08:30:00',1.08),('14598','2014-03-26','08:35:00',1.38),('14598','2014-03-26','08:40:00',1.44),('14598','2014-03-26','08:45:00',1.22),('14598','2014-03-26','08:50:00',1.26),('14598','2014-03-26','08:55:00',1.25),('14598','2014-03-26','09:00:00',1.65),('14598','2014-03-26','09:05:00',2.69),('14598','2014-03-26','09:10:00',2.89),('14598','2014-03-26','09:15:00',2.88),('14598','2014-03-26','09:20:00',2.96),('14598','2014-03-26','09:25:00',3.05),('14598','2014-03-26','09:30:00',3.15),('14598','2014-03-26','09:35:00',3.21),('14598','2014-03-26','09:40:00',3.32),('14598','2014-03-26','09:45:00',3.39),('14598','2014-03-26','09:50:00',3.28),('14598','2014-03-26','09:55:00',3.42),('14598','2014-03-26','10:00:00',3.42),('14598','2014-03-26','10:05:00',2.13),('14598','2014-03-26','10:10:00',3.38),('14598','2014-03-26','10:15:00',3.08),('14598','2014-03-26','10:20:00',2.15),('14598','2014-03-26','10:25:00',4.45),('14598','2014-03-26','10:30:00',1.34),('14598','2014-03-26','10:35:00',3.49),('14598','2014-03-26','10:40:00',3.06),('14598','2014-03-26','10:45:00',2.94),('14598','2014-03-26','10:50:00',3.62),('14598','2014-03-26','10:55:00',1.89),('14598','2014-03-26','11:00:00',2.33),('14598','2014-03-26','11:05:00',2.85),('14598','2014-03-26','11:10:00',2.42),('14598','2014-03-26','11:15:00',2.28),('14598','2014-03-26','11:20:00',2.78),('14598','2014-03-26','11:25:00',1.83),('14598','2014-03-26','11:30:00',1.59),('14598','2014-03-26','11:35:00',1.67),('14598','2014-03-26','11:40:00',1.54),('14598','2014-03-26','11:45:00',2.14),('14598','2014-03-26','11:50:00',3.15),('14598','2014-03-26','11:55:00',4.69),('14598','2014-03-26','12:00:00',5.47),('14598','2014-03-26','12:05:00',4.87),('14598','2014-03-26','12:10:00',4.14),('14598','2014-03-26','12:15:00',3.76),('14598','2014-03-26','12:20:00',3.72),('14598','2014-03-26','12:25:00',5.08),('14598','2014-03-26','12:30:00',5.04),('14598','2014-03-26','12:35:00',4.79),('14598','2014-03-26','12:40:00',4.89),('14598','2014-03-26','12:45:00',4.88),('14598','2014-03-26','12:50:00',4.94),('14598','2014-03-26','12:55:00',4.97),('14598','2014-03-26','13:00:00',4.99),('14598','2014-03-26','13:05:00',5.06),('14598','2014-03-26','13:10:00',4.81),('14598','2014-03-26','13:15:00',4.79),('14598','2014-03-26','13:20:00',4.35),('14598','2014-03-26','13:25:00',4.39),('14598','2014-03-26','13:30:00',4.3),('14598','2014-03-26','13:35:00',3.52),('14598','2014-03-26','13:40:00',3.44),('14598','2014-03-26','13:45:00',3.75),('14598','2014-03-26','13:50:00',4.16),('14598','2014-03-26','13:55:00',4.18),('14598','2014-03-26','14:00:00',4.56),('14598','2014-03-26','14:05:00',4.78),('14598','2014-03-26','14:10:00',4.57),('14598','2014-03-26','14:15:00',4.57),('14598','2014-03-26','14:20:00',3.68),('14598','2014-03-26','14:25:00',3.99),('14598','2014-03-26','14:30:00',3.57),('14598','2014-03-26','14:35:00',3.87),('14598','2014-03-26','14:40:00',3.77),('14598','2014-03-26','14:45:00',2.99),('14598','2014-03-26','14:50:00',3.14),('14598','2014-03-26','14:55:00',3.49),('14598','2014-03-26','15:00:00',3.95),('14598','2014-03-26','15:05:00',4.04),('14598','2014-03-26','15:10:00',3.81),('14598','2014-03-26','15:15:00',3.46),('14598','2014-03-26','15:20:00',3.69),('14598','2014-03-26','15:25:00',3.79),('14598','2014-03-26','15:30:00',3.56),('14598','2014-03-26','15:35:00',3.04),('14598','2014-03-26','15:40:00',3.14),('14598','2014-03-26','15:45:00',2.34),('14598','2014-03-26','15:50:00',2.36),('14598','2014-03-26','15:55:00',1.96),('14598','2014-03-26','16:00:00',1.99),('14598','2014-03-26','16:05:00',2.3),('14598','2014-03-26','16:10:00',2.41),('14598','2014-03-26','16:15:00',2.43),('14598','2014-03-26','16:20:00',1.53),('14598','2014-03-26','16:25:00',1.34),('14598','2014-03-26','16:30:00',1.3),('14598','2014-03-26','16:35:00',1.53),('14598','2014-03-26','16:40:00',1.05),('14598','2013-03-22','07:55:00',1.01),('14598','2013-03-22','08:00:00',1.12),('14598','2013-03-22','08:05:00',1.25),('14598','2013-03-22','08:10:00',1.36),('14598','2013-03-22','08:15:00',1.46),('14598','2013-03-22','08:20:00',1.56),('14598','2013-03-22','08:25:00',1.71),('14598','2013-03-22','08:30:00',1.87),('14598','2013-03-22','08:35:00',1.98),('14598','2013-03-22','08:40:00',2.09),('14598','2013-03-22','08:45:00',2.2),('14598','2013-03-22','08:50:00',2.26),('14598','2013-03-22','08:55:00',2.38),('14598','2013-03-22','09:00:00',2.49),('14598','2013-03-22','09:05:00',2.58),('14598','2013-03-22','09:10:00',2.68),('14598','2013-03-22','09:15:00',2.77),('14598','2013-03-22','09:20:00',2.84),('14598','2013-03-22','09:25:00',2.94),('14598','2013-03-22','09:30:00',3.03),('14598','2013-03-22','09:35:00',3.12),('14598','2013-03-22','09:40:00',3.19),('14598','2013-03-22','09:45:00',3.26),('14598','2013-03-22','09:50:00',3.33),('14598','2013-03-22','09:55:00',3.4),('14598','2013-03-22','10:00:00',3.46),('14598','2013-03-22','10:05:00',3.53),('14598','2013-03-22','10:10:00',3.59),('14598','2013-03-22','10:15:00',3.65),('14598','2013-03-22','10:20:00',3.71),('14598','2013-03-22','10:25:00',3.75),('14598','2013-03-22','10:30:00',3.85),('14598','2013-03-22','10:35:00',3.94),('14598','2013-03-22','10:40:00',4.03),('14598','2013-03-22','10:45:00',4.1),('14598','2013-03-22','10:50:00',4.15),('14598','2013-03-22','10:55:00',4.2),('14598','2013-03-22','11:00:00',4.23),('14598','2013-03-22','11:05:00',4.29),('14598','2013-03-22','11:10:00',4.36),('14598','2013-03-22','11:15:00',4.39),('14598','2013-03-22','11:20:00',4.42),('14598','2013-03-22','11:25:00',4.47),('14598','2013-03-22','11:30:00',4.53),('14598','2013-03-22','11:35:00',4.56),('14598','2013-03-22','11:40:00',4.59),('14598','2013-03-22','11:45:00',4.6),('14598','2013-03-22','11:50:00',4.57),('14598','2013-03-22','11:55:00',4.64),('14598','2013-03-22','12:00:00',4.69),('14598','2013-03-22','12:05:00',4.7),('14598','2013-03-22','12:10:00',4.73),('14598','2013-03-22','12:15:00',4.73),('14598','2013-03-22','12:20:00',4.76),('14598','2013-03-22','12:25:00',4.73),('14598','2013-03-22','12:30:00',4.8),('14598','2013-03-22','12:35:00',4.86),('14598','2013-03-22','12:40:00',4.87),('14598','2013-03-22','12:45:00',4.9),('14598','2013-03-22','12:50:00',4.86),('14598','2013-03-22','12:55:00',4.85),('14598','2013-03-22','13:00:00',4.87),('14598','2013-03-22','13:05:00',4.83),('14598','2013-03-22','13:10:00',4.82),('14598','2013-03-22','13:15:00',4.74),('14598','2013-03-22','13:20:00',4.87),('14598','2013-03-22','13:25:00',4.84),('14598','2013-03-22','13:30:00',4.84),('14598','2013-03-22','13:35:00',4.81),('14598','2013-03-22','13:40:00',4.73),('14598','2013-03-22','13:45:00',4.7),('14598','2013-03-22','13:50:00',4.65),('14598','2013-03-22','13:55:00',4.63),('14598','2013-03-22','14:00:00',4.61),('14598','2013-03-22','14:05:00',4.56),('14598','2013-03-22','14:10:00',4.53),('14598','2013-03-22','14:15:00',4.4),('14598','2013-03-22','14:20:00',4.5),('14598','2013-03-22','14:25:00',3.7),('14598','2013-03-22','14:30:00',3.9),('14598','2013-03-22','14:35:00',3.13),('14598','2013-03-22','14:40:00',2.95),('14598','2013-03-22','14:45:00',4.1),('14598','2013-03-22','14:50:00',3.33),('14598','2013-03-22','14:55:00',3.43),('14598','2013-03-22','15:00:00',3.53),('14598','2013-03-22','15:05:00',2.95),('14598','2013-03-22','15:10:00',2.97),('14598','2013-03-22','15:15:00',3.02),('14598','2013-03-22','15:20:00',2.55),('14598','2013-03-22','15:25:00',1.82),('14598','2013-03-22','15:30:00',1.72),('14598','2013-03-22','15:35:00',1.61),('14598','2013-03-22','15:40:00',1.77),('14598','2013-03-22','15:45:00',2.15),('14598','2013-03-22','15:50:00',3.2),('14598','2013-03-22','15:55:00',3.05),('14598','2013-03-22','16:00:00',2.85),('14598','2013-03-22','16:05:00',3.12),('14598','2013-03-22','16:10:00',3.14),('14598','2013-03-22','16:15:00',3.08),('14598','2013-03-22','16:20:00',3.12),('14598','2013-03-22','16:25:00',2.97),('14598','2013-03-22','16:30:00',2.71),('14598','2013-03-22','16:35:00',2.51),('14598','2013-03-22','16:40:00',2.48),('14598','2013-03-22','16:45:00',1.5),('14598','2013-03-22','16:55:00',2.05),('14598','2013-03-22','17:00:00',1.44),('14598','2013-03-22','17:05:00',1.61),('14598','2013-03-22','17:10:00',1.4),('14598','2013-03-22','17:15:00',1.36),('14598','2013-03-22','17:20:00',1.25),('14598','2013-03-22','17:25:00',1.12),('14598','2013-03-21','08:00:00',1.19),('14598','2013-03-21','08:05:00',1.26),('14598','2013-03-21','08:10:00',1.42),('14598','2013-03-21','08:15:00',1.39),('14598','2013-03-21','08:20:00',1.57),('14598','2013-03-21','08:25:00',1.7),('14598','2013-03-21','08:30:00',1.87),('14598','2013-03-21','08:35:00',2.01),('14598','2013-03-21','08:40:00',2.11),('14598','2013-03-21','08:45:00',2.19),('14598','2013-03-21','08:50:00',2.33),('14598','2013-03-21','08:55:00',2.44),('14598','2013-03-21','09:00:00',2.55),('14598','2013-03-21','09:05:00',2.65),('14598','2013-03-21','09:10:00',2.77),('14598','2013-03-21','09:15:00',2.86),('14598','2013-03-21','09:20:00',2.97),('14598','2013-03-21','09:25:00',3.07),('14598','2013-03-21','09:30:00',3.18),('14598','2013-03-21','09:35:00',3.27),('14598','2013-03-21','09:40:00',3.37),('14598','2013-03-21','09:45:00',3.46),('14598','2013-03-21','09:50:00',3.53),('14598','2013-03-21','09:55:00',3.6),('14598','2013-03-21','10:00:00',3.66),('14598','2013-03-21','10:05:00',3.74),('14598','2013-03-21','10:10:00',3.84),('14598','2013-03-21','10:15:00',3.91),('14598','2013-03-21','10:20:00',3.98),('14598','2013-03-21','10:25:00',4.06),('14598','2013-03-21','10:30:00',4.12),('14598','2013-03-21','10:35:00',4.17),('14598','2013-03-21','10:40:00',4.27),('14598','2013-03-21','10:45:00',4.33),('14598','2013-03-21','10:50:00',4.4),('14598','2013-03-21','10:55:00',4.46),('14598','2013-03-21','11:00:00',4.51),('14598','2013-03-21','11:05:00',4.57),('14598','2013-03-21','11:10:00',4.63),('14598','2013-03-21','11:15:00',4.67),('14598','2013-03-21','11:20:00',4.72),('14598','2013-03-21','11:25:00',4.78),('14598','2013-03-21','11:30:00',4.81),('14598','2013-03-21','11:35:00',4.83),('14598','2013-03-21','11:40:00',4.88),('14598','2013-03-21','11:45:00',4.87),('14598','2013-03-21','11:50:00',4.93),('14598','2013-03-21','11:55:00',4.96),('14598','2013-03-21','12:00:00',5),('14598','2013-03-21','12:05:00',5.01),('14598','2013-03-21','12:10:00',5.01),('14598','2013-03-21','12:15:00',5.04),('14598','2013-03-21','12:20:00',5.04),('14598','2013-03-21','12:25:00',5.02),('14598','2013-03-21','12:30:00',5.05),('14598','2013-03-21','12:35:00',5.06),('14598','2013-03-21','12:40:00',5.07),('14598','2013-03-21','12:45:00',5.08),('14598','2013-03-21','12:50:00',5.07),('14598','2013-03-21','12:55:00',5.05),('14598','2013-03-21','13:00:00',4.95),('14598','2013-03-21','13:05:00',5.01),('14598','2013-03-21','13:10:00',5.01),('14598','2013-03-21','13:15:00',5),('14598','2013-03-21','13:20:00',5),('14598','2013-03-21','13:25:00',4.98),('14598','2013-03-21','13:30:00',4.94),('14598','2013-03-21','13:35:00',4.9),('14598','2013-03-21','13:40:00',4.87),('14598','2013-03-21','13:45:00',4.84),('14598','2013-03-21','13:50:00',4.8),('14598','2013-03-21','13:55:00',4.78),('14598','2013-03-21','14:00:00',4.74),('14598','2013-03-21','14:05:00',4.69),('14598','2013-03-21','14:10:00',4.66),('14598','2013-03-21','14:15:00',4.61),('14598','2013-03-21','14:20:00',4.56),('14598','2013-03-21','14:25:00',4.52),('14598','2013-03-21','14:30:00',4.47),('14598','2013-03-21','14:35:00',4.41),('14598','2013-03-21','14:41:00',4.34),('14598','2013-03-21','14:45:00',4.28),('14598','2013-03-21','14:50:00',4.23),('14598','2013-03-21','14:55:00',4.19),('14598','2013-03-21','15:00:00',4.12),('14598','2013-03-21','15:05:00',4.05),('14598','2013-03-21','15:11:00',3.98),('14598','2013-03-21','15:15:00',3.88),('14598','2013-03-21','15:20:00',3.82),('14598','2013-03-21','15:25:00',3.75),('14598','2013-03-21','15:30:00',3.66),('14598','2013-03-21','15:35:00',3.59),('14598','2013-03-21','15:40:00',3.5),('14598','2013-03-21','15:45:00',3.4),('14598','2013-03-21','15:50:00',3.32),('14598','2013-03-21','15:55:00',3.22),('14598','2013-03-21','16:00:00',3.1),('14598','2013-03-21','16:05:00',2.98),('14598','2013-03-21','16:10:00',2.93),('14598','2013-03-21','16:15:00',2.82),('14598','2013-03-21','16:20:00',2.45),('14598','2013-03-21','16:25:00',2.5),('14598','2013-03-21','16:30:00',2.49),('14598','2013-03-21','16:35:00',2.36),('14598','2013-03-21','16:40:00',2.25),('14598','2013-03-21','16:45:00',2.11),('14598','2013-03-21','16:50:00',2.01),('14598','2013-03-21','16:55:00',1.89),('14598','2013-03-21','17:00:00',1.76),('14598','2013-03-21','17:05:00',1.64),('14598','2013-03-21','17:10:00',1.51),('14598','2013-03-21','17:15:00',1.38),('14598','2013-03-21','17:20:00',1.24),('14598','2013-03-21','17:25:00',1.12),('14598','2013-03-20','08:00:00',1.06),('14598','2013-03-20','08:06:00',1.17),('14598','2013-03-20','08:10:00',1.33),('14598','2013-03-20','08:15:00',1.42),('14598','2013-03-20','08:20:00',1.53),('14598','2013-03-20','08:25:00',1.67),('14598','2013-03-20','08:30:00',1.77),('14598','2013-03-20','08:36:00',1.86),('14598','2013-03-20','08:40:00',2.1),('14598','2013-03-20','08:45:00',1.79),('14598','2013-03-20','08:50:00',1.55),('14598','2013-03-20','08:55:00',1.45),('14598','2013-03-20','09:00:00',1.37),('14598','2013-03-20','09:07:00',1.55),('14598','2013-03-20','09:10:00',1.82),('14598','2013-03-20','09:15:00',2.69),('14598','2013-03-20','09:20:00',2.31),('14598','2013-03-20','09:25:00',2.94),('14598','2013-03-20','09:30:00',2.94),('14598','2013-03-20','09:35:00',2.47),('14598','2013-03-20','09:40:00',1.96),('14598','2013-03-20','09:45:00',2.34),('14598','2013-03-20','09:50:00',2.51),('14598','2013-03-20','09:55:00',2.7),('14598','2013-03-20','10:00:00',3.17),('14598','2013-03-20','10:05:00',3.36),('14598','2013-03-20','10:10:00',3.25),('14598','2013-03-20','10:15:00',3.39),('14598','2013-03-20','10:20:00',3.51),('14598','2013-03-20','10:25:00',3.83),('14598','2013-03-20','10:30:00',3.71),('14598','2013-03-20','10:35:00',3.46),('14598','2013-03-20','10:40:00',2.85),('14598','2013-03-20','10:45:00',3.2),('14598','2013-03-20','10:50:00',2.86),('14598','2013-03-20','10:55:00',2.81),('14598','2013-03-20','11:00:00',2.46),('14598','2013-03-20','11:05:00',2.62),('14598','2013-03-20','11:10:00',3.18),('14598','2013-03-20','11:15:00',2.64),('14598','2013-03-20','11:20:00',2.56),('14598','2013-03-20','11:25:00',2.85),('14598','2013-03-20','11:30:00',3.31),('14598','2013-03-20','11:35:00',2.62),('14598','2013-03-20','11:40:00',2.15),('14598','2013-03-20','11:45:00',2.22),('14598','2013-03-20','11:50:00',2.29),('14598','2013-03-20','11:55:00',2.44),('14598','2013-03-20','12:00:00',2.17),('14598','2013-03-20','12:05:00',1.79),('14598','2013-03-20','12:10:00',1.42),('14598','2013-03-20','12:15:00',1.72),('14598','2013-03-20','12:20:00',1.74),('14598','2013-03-20','12:25:00',1.44),('14598','2013-03-20','12:30:00',2.34),('14598','2013-03-20','12:35:00',2.09),('14598','2013-03-20','12:40:00',1.96),('14598','2013-03-20','12:45:00',1.7),('14598','2013-03-20','12:50:00',1.49),('14598','2013-03-20','12:55:00',1.6),('14598','2013-03-20','13:00:00',2.14),('14598','2013-03-20','13:05:00',1.95),('14598','2013-03-20','13:10:00',1.57),('14598','2013-03-20','13:15:00',1.51),('14598','2013-03-20','13:20:00',1.85),('14598','2013-03-20','13:25:00',1.83),('14598','2013-03-20','13:30:00',1.77),('14598','2013-03-20','13:35:00',2.27),('14598','2013-03-20','13:40:00',2.05),('14598','2013-03-20','13:45:00',1.85),('14598','2013-03-20','13:50:00',1.73),('14598','2013-03-20','13:55:00',1.47),('14598','2013-03-20','14:00:00',1.2),('14598','2013-03-20','14:05:00',1.24),('14598','2013-03-20','14:10:00',1.35),('14598','2013-03-20','14:15:00',1.54),('14598','2013-03-20','14:20:00',1.68),('14598','2013-03-20','14:25:00',1.59),('14598','2013-03-20','14:30:00',1.3),('14598','2013-03-20','14:35:00',1.04),('14598','2013-03-19','08:10:00',1.21),('14598','2013-03-19','08:15:00',1.25),('14598','2013-03-19','08:20:00',1.45),('14598','2013-03-19','08:25:00',1.57),('14598','2013-03-19','08:30:00',1.71),('14598','2013-03-19','08:35:00',1.85),('14598','2013-03-19','08:40:00',1.99),('14598','2013-03-19','08:45:00',2.07),('14598','2013-03-19','08:50:00',2.18),('14598','2013-03-19','08:55:00',2.28),('14598','2013-03-19','09:00:00',2.39),('14598','2013-03-19','09:05:00',2.5),('14598','2013-03-19','09:10:00',2.61),('14598','2013-03-19','09:15:00',2.69),('14598','2013-03-19','09:20:00',2.79),('14598','2013-03-19','09:25:00',2.88),('14598','2013-03-19','09:30:00',2.97),('14598','2013-03-19','09:35:00',3.05),('14598','2013-03-19','09:40:00',3.15),('14598','2013-03-19','09:45:00',3.23),('14598','2013-03-19','09:50:00',3.33),('14598','2013-03-19','09:55:00',3.41),('14598','2013-03-19','10:00:00',3.5),('14598','2013-03-19','10:05:00',3.6),('14598','2013-03-19','10:10:00',3.68),('14598','2013-03-19','10:15:00',3.74),('14598','2013-03-19','10:20:00',3.83),('14598','2013-03-19','10:25:00',3.89),('14598','2013-03-19','10:30:00',3.97),('14598','2013-03-19','10:35:00',4.04),('14598','2013-03-19','10:40:00',4.14),('14598','2013-03-19','10:45:00',4.18),('14598','2013-03-19','10:50:00',4.25),('14598','2013-03-19','10:55:00',4.34),('14598','2013-03-19','11:00:00',4.35),('14598','2013-03-19','11:05:00',4.39),('14598','2013-03-19','11:10:00',4.44),('14598','2013-03-19','11:15:00',4.51),('14598','2013-03-19','11:20:00',4.54),('14598','2013-03-19','11:25:00',3.32),('14598','2013-03-19','11:30:00',3.69),('14598','2013-03-19','11:35:00',3.9),('14598','2013-03-19','11:40:00',4.27),('14598','2013-03-19','11:45:00',4.82),('14598','2013-03-19','11:50:00',4.8),('14598','2013-03-19','11:55:00',4.69),('14598','2013-03-19','12:00:00',4.8),('14598','2013-03-19','12:05:00',4.6),('14598','2013-03-19','12:10:00',4.83),('14598','2013-03-19','12:15:00',4.68),('14598','2013-03-19','12:20:00',4.91),('14598','2013-03-19','12:25:00',4.87),('14598','2013-03-19','12:30:00',4.91),('14598','2013-03-19','12:35:00',4.96),('14598','2013-03-19','12:40:00',4.42),('14598','2013-03-19','12:45:00',4.58),('14598','2013-03-19','12:50:00',4.82),('14598','2013-03-19','12:55:00',4.71),('14598','2013-03-19','13:00:00',4.84),('14598','2013-03-19','13:05:00',4.86),('14598','2013-03-19','13:10:00',4.8),('14598','2013-03-19','13:15:00',4.84),('14598','2013-03-19','13:20:00',4.84),('14598','2013-03-19','13:25:00',4.71),('14598','2013-03-19','13:30:00',4.58),('14598','2013-03-19','13:35:00',4.81),('14598','2013-03-19','13:40:00',4.75),('14598','2013-03-19','13:45:00',4.67),('14598','2013-03-19','13:50:00',4.63),('14598','2013-03-19','13:55:00',4.58),('14598','2013-03-19','14:00:00',4.54),('14598','2013-03-19','14:05:00',4.51),('14598','2013-03-19','14:10:00',4.46),('14598','2013-03-19','14:15:00',4.41),('14598','2013-03-19','14:20:00',4.36),('14598','2013-03-19','14:25:00',4.33),('14598','2013-03-19','14:30:00',4.29),('14598','2013-03-19','14:35:00',4.26),('14598','2013-03-19','14:40:00',4.2),('14598','2013-03-19','14:45:00',4.13),('14598','2013-03-19','14:50:00',4.06),('14598','2013-03-19','14:55:00',4.01),('14598','2013-03-19','15:00:00',3.95),('14598','2013-03-19','15:05:00',3.88),('14598','2013-03-19','15:10:00',3.82),('14598','2013-03-19','15:15:00',3.75),('14598','2013-03-19','15:20:00',3.67),('14598','2013-03-19','15:25:00',3.62),('14598','2013-03-19','15:30:00',3.56),('14598','2013-03-19','15:35:00',3.49),('14598','2013-03-19','15:40:00',3.4),('14598','2013-03-19','15:45:00',3.27),('14598','2013-03-19','15:50:00',3.2),('14598','2013-03-19','15:55:00',3.08),('14598','2013-03-19','16:00:00',3.02),('14598','2013-03-19','16:05:00',2.92),('14598','2013-03-19','16:10:00',2.84),('14598','2013-03-19','16:15:00',2.72),('14598','2013-03-19','16:20:00',2.63),('14598','2013-03-19','16:25:00',2.53),('14598','2013-03-19','16:30:00',2.41),('14598','2013-03-19','16:35:00',2.27),('14598','2013-03-19','16:40:00',1.78),('14598','2013-03-19','16:45:00',1.48),('14598','2013-03-19','16:50:00',1.6),('14598','2013-03-19','16:55:00',1.33),('14598','2013-03-19','17:00:00',1.33),('14598','2013-03-19','17:05:00',1.46),('14598','2013-03-19','17:10:00',1.54),('14598','2013-03-19','17:15:00',1.39),('14598','2013-03-19','17:20:00',1.09),('14598','2013-03-18','09:15:00',1.12),('14598','2013-03-18','09:20:00',1.43),('14598','2013-03-18','09:25:00',2.33),('14598','2013-03-18','09:30:00',1.26),('14598','2013-03-18','09:35:00',1.28),('14598','2013-03-18','09:40:00',1.23),('14598','2013-03-18','09:45:00',2.06),('14598','2013-03-18','09:50:00',2.87),('14598','2013-03-18','09:55:00',2.47),('14598','2013-03-18','10:00:00',2.8),('14598','2013-03-18','10:05:00',3.72),('14598','2013-03-18','10:10:00',3.06),('14598','2013-03-18','10:15:00',2.52),('14598','2013-03-18','10:20:00',2.26),('14598','2013-03-18','10:25:00',2.23),('14598','2013-03-18','10:30:00',2.82),('14598','2013-03-18','10:35:00',2.27),('14598','2013-03-18','10:40:00',2),('14598','2013-03-18','10:45:00',2.39),('14598','2013-03-18','10:50:00',2.65),('14598','2013-03-18','10:55:00',2.72),('14598','2013-03-18','11:00:00',2.87),('14598','2013-03-18','11:05:00',3.63),('14598','2013-03-18','11:10:00',4.09),('14598','2013-03-18','11:15:00',4.41),('14598','2013-03-18','11:20:00',3.48),('14598','2013-03-18','11:25:00',2.5),('14598','2013-03-18','11:30:00',2.01),('14598','2013-03-18','11:35:00',2.09),('14598','2013-03-18','11:40:00',1.92),('14598','2013-03-18','11:45:00',2.11),('14598','2013-03-18','11:50:00',2.22),('14598','2013-03-18','11:55:00',2.21),('14598','2013-03-18','12:00:00',1.84),('14598','2013-03-18','12:05:00',1.5),('14598','2013-03-18','12:10:00',1.86),('14598','2013-03-18','12:15:00',2.63),('14598','2013-03-18','12:20:00',1.97),('14598','2013-03-18','12:25:00',1.5),('14598','2013-03-18','12:30:00',1.54),('14598','2013-03-18','12:35:00',1.96),('14598','2013-03-18','12:40:00',2.24),('14598','2013-03-18','12:45:00',2.1),('14598','2013-03-18','12:50:00',1.17),('14598','2013-03-18','12:55:00',1.5),('14598','2013-03-18','13:00:00',1.95),('14598','2013-03-18','13:05:00',1.99),('14598','2013-03-18','13:10:00',2.25),('14598','2013-03-18','13:15:00',2.84),('14598','2013-03-18','13:20:00',1.58),('14598','2013-03-18','13:25:00',1.06),('14598','2013-03-18','13:30:00',1.6),('14598','2013-03-18','13:35:00',1.73),('14598','2013-03-18','13:40:00',1.29),('14598','2013-03-18','13:45:00',1.49),('14598','2013-03-18','13:50:00',2.6),('14598','2013-03-18','13:55:00',1.89),('14598','2013-03-18','14:00:00',2.95),('14598','2013-03-18','14:05:00',2.9),('14598','2013-03-18','14:10:00',1.45),('14598','2013-03-18','14:15:00',1.29),('14598','2013-03-18','14:30:00',1.19),('14598','2013-03-17','08:10:00',1.12),('14598','2013-03-17','08:15:00',1.13),('14598','2013-03-17','08:20:00',1.04),('14598','2013-03-17','08:25:00',1.08),('14598','2013-03-17','08:30:00',1.16),('14598','2013-03-17','08:35:00',1.07),('14598','2013-03-17','08:40:00',1.11),('14598','2013-03-17','08:45:00',1.06),('14598','2013-03-17','08:50:00',1.19),('14598','2013-03-17','08:55:00',1.49),('14598','2013-03-17','09:00:00',1.53),('14598','2013-03-17','09:05:00',1.38),('14598','2013-03-17','09:10:00',1.46),('14598','2013-03-17','09:15:00',1.49),('14598','2013-03-17','09:20:00',1.59),('14598','2013-03-17','09:25:00',1.58),('14598','2013-03-17','09:30:00',1.53),('14598','2013-03-17','09:35:00',1.59),('14598','2013-03-17','09:40:00',1.71),('14598','2013-03-17','09:45:00',1.71),('14598','2013-03-17','09:50:00',1.68),('14598','2013-03-17','09:55:00',1.74),('14598','2013-03-17','10:00:00',1.78),('14598','2013-03-17','10:05:00',2.02),('14598','2013-03-17','10:10:00',2.08),('14598','2013-03-17','10:15:00',1.88),('14598','2013-03-17','10:20:00',1.94),('14598','2013-03-17','10:25:00',1.94),('14598','2013-03-17','10:30:00',1.99),('14598','2013-03-17','10:35:00',1.72),('14598','2013-03-17','10:40:00',1.56),('14598','2013-03-17','10:45:00',1.61),('14598','2013-03-17','10:50:00',1.88),('14598','2013-03-17','10:55:00',2.33),('14598','2013-03-17','11:00:00',2.35),('14598','2013-03-17','11:05:00',2.4),('14598','2013-03-17','11:10:00',2.2),('14598','2013-03-17','11:15:00',2.23),('14598','2013-03-17','11:20:00',2.16),('14598','2013-03-17','11:25:00',1.97),('14598','2013-03-17','11:30:00',1.74),('14598','2013-03-17','11:35:00',1.56),('14598','2013-03-17','11:40:00',1.46),('14598','2013-03-17','11:45:00',1.31),('14598','2013-03-17','11:50:00',1.52),('14598','2013-03-17','11:55:00',1.84),('14598','2013-03-17','12:00:00',2.48),('14598','2013-03-17','12:05:00',3.6),('14598','2013-03-17','12:10:00',4.56),('14598','2013-03-17','12:15:00',4.21),('14598','2013-03-17','12:20:00',3.46),('14598','2013-03-17','12:25:00',3.18),('14598','2013-03-17','12:30:00',2.54),('14598','2013-03-17','12:35:00',2.48),('14598','2013-03-17','12:40:00',3.09),('14598','2013-03-17','12:45:00',3.15),('14598','2013-03-17','12:50:00',2.79),('14598','2013-03-17','12:55:00',2.45),('14598','2013-03-17','13:00:00',2.66),('14598','2013-03-17','13:05:00',2.41),('14598','2013-03-17','13:10:00',1.96),('14598','2013-03-17','13:15:00',2.36),('14598','2013-03-17','13:20:00',2.52),('14598','2013-03-17','13:25:00',2.57),('14598','2013-03-17','13:30:00',1.83),('14598','2013-03-17','13:35:00',1.67),('14598','2013-03-17','13:40:00',2.32),('14598','2013-03-17','13:45:00',2.05),('14598','2013-03-17','13:50:00',2.07),('14598','2013-03-17','13:55:00',2.36),('14598','2013-03-17','14:00:00',2.56),('14598','2013-03-17','14:05:00',2.45),('14598','2013-03-17','14:10:00',2.59),('14598','2013-03-17','14:15:00',2.19),('14598','2013-03-17','14:20:00',2.25),('14598','2013-03-17','14:25:00',2.29),('14598','2013-03-17','14:30:00',1.97),('14598','2013-03-17','14:35:00',1.91),('14598','2013-03-17','14:40:00',1.66),('14598','2013-03-17','14:45:00',1.72),('14598','2013-03-17','14:50:00',1.76),('14598','2013-03-17','14:55:00',1.93),('14598','2013-03-17','15:00:00',2.38),('14598','2013-03-17','15:05:00',1.99),('14598','2013-03-17','15:10:00',2.25),('14598','2013-03-17','15:15:00',1.89),('14598','2013-03-17','15:20:00',1.39),('14598','2013-03-17','15:25:00',1.1),('14598','2013-03-17','15:30:00',1.04),('14598','2013-03-17','16:05:00',1.23),('14598','2013-03-17','16:30:00',1.01),('14598','2013-03-17','16:35:00',1.76),('14598','2013-03-16','08:05:00',1.02),('14598','2013-03-16','08:20:00',1.26),('14598','2013-03-16','08:25:00',1.83),('14598','2013-03-16','08:30:00',1.88),('14598','2013-03-16','08:35:00',1.66),('14598','2013-03-16','08:40:00',1.61),('14598','2013-03-16','08:45:00',1.62),('14598','2013-03-16','08:50:00',1.48),('14598','2013-03-16','08:55:00',1.61),('14598','2013-03-16','09:00:00',1.96),('14598','2013-03-16','09:05:00',1.91),('14598','2013-03-16','09:10:00',2.37),('14598','2013-03-16','09:15:00',2.69),('14598','2013-03-16','09:20:00',2.77),('14598','2013-03-16','09:25:00',2.89),('14598','2013-03-16','09:30:00',2.63),('14598','2013-03-16','09:35:00',3.24),('14598','2013-03-16','09:40:00',3.58),('14598','2013-03-16','09:45:00',2.8),('14598','2013-03-16','09:50:00',3.53),('14598','2013-03-16','09:55:00',3.97),('14598','2013-03-16','10:00:00',3.71),('14598','2013-03-16','10:05:00',3.85),('14598','2013-03-16','10:10:00',3.93),('14598','2013-03-16','10:15:00',3.82),('14598','2013-03-16','10:20:00',3.79),('14598','2013-03-16','10:25:00',3.86),('14598','2013-03-16','10:30:00',3.96),('14598','2013-03-16','10:35:00',4),('14598','2013-03-16','10:40:00',4.03),('14598','2013-03-16','10:45:00',4.09),('14598','2013-03-16','10:50:00',4.15),('14598','2013-03-16','10:55:00',4.09),('14598','2013-03-16','11:00:00',4.23),('14598','2013-03-16','11:05:00',4.26),('14598','2013-03-16','11:10:00',4.31),('14598','2013-03-16','11:15:00',4.35),('14598','2013-03-16','11:20:00',4.4),('14598','2013-03-16','11:25:00',4.45),('14598','2013-03-16','11:30:00',4.49),('14598','2013-03-16','11:35:00',4.52),('14598','2013-03-16','11:40:00',4.53),('14598','2013-03-16','11:45:00',4.55),('14598','2013-03-16','11:50:00',4.57),('14598','2013-03-16','11:55:00',4.62),('14598','2013-03-16','12:00:00',4.64),('14598','2013-03-16','12:05:00',4.64),('14598','2013-03-16','12:10:00',4.58),('14598','2013-03-16','12:15:00',4.65),('14598','2013-03-16','12:20:00',4.61),('14598','2013-03-16','12:25:00',4.55),('14598','2013-03-16','12:30:00',4.27),('14598','2013-03-16','12:35:00',3.7),('14598','2013-03-16','12:40:00',1.78),('14598','2013-03-16','12:55:00',3.91),('14598','2013-03-16','13:00:00',5.36),('14598','2013-03-16','13:05:00',5.21),('14598','2013-03-16','13:10:00',5.24),('14598','2013-03-16','13:15:00',5),('14598','2013-03-16','13:20:00',4.1),('14598','2013-03-16','13:25:00',4.36),('14598','2013-03-16','13:30:00',3.63),('14598','2013-03-16','13:35:00',3),('14598','2013-03-16','13:40:00',1.68),('14598','2013-03-16','13:45:00',4.44),('14598','2013-03-16','13:50:00',4.35),('14598','2013-03-16','13:55:00',4.68),('14598','2013-03-16','14:00:00',4.4),('14598','2013-03-16','14:05:00',4.35),('14598','2013-03-16','14:10:00',4.32),('14598','2013-03-16','14:15:00',4.25),('14598','2013-03-16','14:20:00',4.28),('14598','2013-03-16','14:25:00',4.29),('14598','2013-03-16','14:30:00',4.28),('14598','2013-03-16','14:35:00',4.22),('14598','2013-03-16','14:40:00',4.15),('14598','2013-03-16','14:45:00',4.08),('14598','2013-03-16','14:50:00',4.04),('14598','2013-03-16','14:55:00',4),('14598','2013-03-16','15:00:00',3.97),('14598','2013-03-16','15:05:00',3.9),('14598','2013-03-16','15:10:00',3.84),('14598','2013-03-16','15:15:00',3.73),('14598','2013-03-16','15:20:00',3.68),('14598','2013-03-16','15:25:00',3.6),('14598','2013-03-16','15:30:00',3.51),('14598','2013-03-16','15:35:00',3.42),('14598','2013-03-16','15:40:00',3.35),('14598','2013-03-16','15:45:00',3.27),('14598','2013-03-16','15:50:00',3.17),('14598','2013-03-16','15:55:00',3.06),('14598','2013-03-16','16:00:00',2.99),('14598','2013-03-16','16:05:00',2.89),('14598','2013-03-16','16:10:00',2.79),('14598','2013-03-16','16:15:00',2.67),('14598','2013-03-16','16:20:00',2.59),('14598','2013-03-16','16:25:00',2.51),('14598','2013-03-16','16:30:00',2.36),('14598','2013-03-16','16:35:00',2.26),('14598','2013-03-16','16:40:00',2.13),('14598','2013-03-16','16:45:00',2.01),('14598','2013-03-16','16:50:00',1.89),('14598','2013-03-16','16:55:00',1.73),('14598','2013-03-16','17:00:00',1.59),('14598','2013-03-16','17:05:00',1.48),('14598','2013-03-16','17:10:00',1.35),('14598','2013-03-16','17:15:00',1.2),('14598','2013-03-16','17:20:00',1.07),('14598','2013-03-15','10:10:00',1.17),('14598','2013-03-15','10:15:00',1.51),('14598','2013-03-15','10:20:00',1.68),('14598','2013-03-15','10:25:00',1.63),('14598','2013-03-15','10:30:00',1.61),('14598','2013-03-15','10:35:00',1.75),('14598','2013-03-15','10:40:00',1.84),('14598','2013-03-15','10:45:00',1.62),('14598','2013-03-15','10:50:00',1.54),('14598','2013-03-15','10:55:00',1.74),('14598','2013-03-15','11:00:00',1.58),('14598','2013-03-15','11:05:00',1.46),('14598','2013-03-15','11:10:00',1.77),('14598','2013-03-15','11:15:00',1.87),('14598','2013-03-15','11:20:00',1.94),('14598','2013-03-15','11:25:00',2.05),('14598','2013-03-15','11:30:00',1.9),('14598','2013-03-15','11:35:00',1.76),('14598','2013-03-15','11:40:00',1.76),('14598','2013-03-15','11:45:00',1.88),('14598','2013-03-15','11:50:00',1.94),('14598','2013-03-15','11:55:00',1.82),('14598','2013-03-15','12:00:00',1.8),('14598','2013-03-15','12:05:00',1.94),('14598','2013-03-15','12:10:00',2.35),('14598','2013-03-15','12:15:00',2.33),('14598','2013-03-15','12:20:00',2.27),('14598','2013-03-15','12:25:00',2.38),('14598','2013-03-15','12:30:00',2.58),('14598','2013-03-15','12:35:00',2.84),('14598','2013-03-15','12:40:00',2.7),('14598','2013-03-15','12:45:00',2.4),('14598','2013-03-15','12:50:00',2.71),('14598','2013-03-15','12:55:00',2.76),('14598','2013-03-15','13:00:00',2.94),('14598','2013-03-15','13:05:00',2.54),('14598','2013-03-15','13:10:00',2.17),('14598','2013-03-15','13:15:00',2.01),('14598','2013-03-15','13:20:00',1.76),('14598','2013-03-15','13:25:00',1.46),('14598','2013-03-15','13:30:00',1.41),('14598','2013-03-15','13:35:00',1.52),('14598','2013-03-15','13:40:00',1.39),('14598','2013-03-15','13:45:00',1.31),('14598','2013-03-15','13:50:00',1.09),('14598','2013-03-15','14:15:00',1.13),('14598','2013-03-15','14:20:00',1.56),('14598','2013-03-15','14:25:00',2.03),('14598','2013-03-15','14:30:00',2.82),('14598','2013-03-15','14:35:00',3.17),('14598','2013-03-15','14:40:00',3.48),('14598','2013-03-15','14:45:00',2.71),('14598','2013-03-15','14:50:00',3.04),('14598','2013-03-15','14:55:00',2.87),('14598','2013-03-15','15:00:00',2.91),('14598','2013-03-15','15:05:00',2.26),('14598','2013-03-15','15:10:00',2.13),('14598','2013-03-15','15:15:00',2.16),('14598','2013-03-15','15:20:00',1.48),('14598','2013-03-15','15:25:00',1.35),('14598','2013-03-15','15:30:00',1.31),('14598','2013-03-15','15:35:00',1.48),('14598','2013-03-15','15:40:00',1.35),('14598','2013-03-15','15:45:00',1.23),('14598','2013-03-15','16:45:00',1.13),('14598','2013-03-15','17:00:00',1.46),('14598','2013-03-15','17:05:00',1.24),('14598','2013-03-15','17:10:00',1.32),('14598','2013-03-15','17:15:00',1.15),('14598','2013-03-15','17:20:00',1.06),('14598','2013-03-15','17:25:00',1.09),('14598','2013-03-14','11:45:00',1.04),('14598','2013-03-14','12:20:00',1.1),('14598','2013-03-14','12:25:00',1.29),('14598','2013-03-14','12:30:00',1.57),('14598','2013-03-14','12:35:00',1.88),('14598','2013-03-14','12:40:00',2.02),('14598','2013-03-14','12:45:00',1.83),('14598','2013-03-14','12:50:00',1.83),('14598','2013-03-14','12:55:00',1.98),('14598','2013-03-14','13:00:00',1.9),('14598','2013-03-14','13:05:00',1.84),('14598','2013-03-14','13:10:00',1.54),('14598','2013-03-14','13:15:00',1.5),('14598','2013-03-14','13:20:00',1.68),('14598','2013-03-14','13:25:00',1.76),('14598','2013-03-14','13:30:00',1.73),('14598','2013-03-14','13:35:00',1.65),('14598','2013-03-14','13:40:00',1.54),('14598','2013-03-14','13:45:00',1.51),('14598','2013-03-14','13:50:00',1.31),('14598','2013-03-14','14:00:00',1.01),('14598','2013-03-14','14:05:00',1.31),('14598','2013-03-14','14:10:00',1.16),('14598','2013-03-14','14:25:00',1.17),('14598','2013-03-14','14:30:00',1.15),('14598','2013-03-14','14:35:00',1.35),('14598','2013-03-14','14:40:00',1.72),('14598','2013-03-14','14:45:00',1.51),('14598','2013-03-14','14:50:00',1.44),('14598','2013-03-14','14:55:00',1.25),('14598','2013-03-14','15:00:00',1.01),('14598','2013-03-14','15:05:00',1.01),('14598','2013-03-13','08:40:00',1.13),('14598','2013-03-13','08:45:00',1.09),('14598','2013-03-13','08:50:00',1.11),('14598','2013-03-13','08:55:00',1.08),('14598','2013-03-13','09:10:00',1.05),('14598','2013-03-13','09:35:00',1.12),('14598','2013-03-13','09:40:00',1.61),('14598','2013-03-13','09:45:00',1.64),('14598','2013-03-13','09:50:00',1.09),('14598','2013-03-13','10:25:00',1.33),('14598','2013-03-13','10:30:00',2.58),('14598','2013-03-13','10:35:00',3.4),('14598','2013-03-13','10:40:00',3.12),('14598','2013-03-13','10:45:00',3.28),('14598','2013-03-13','10:50:00',3.05),('14598','2013-03-13','10:55:00',3.19),('14598','2013-03-13','11:00:00',2.97),('14598','2013-03-13','11:05:00',1.95),('14598','2013-03-13','11:10:00',1.54),('14598','2013-03-13','11:15:00',1.77),('14598','2013-03-13','11:20:00',1.97),('14598','2013-03-13','11:25:00',1.83),('14598','2013-03-13','11:30:00',1.88),('14598','2013-03-13','11:35:00',1.65),('14598','2013-03-13','11:40:00',1.03),('14598','2013-03-13','12:20:00',1.09),('14598','2013-03-13','12:25:00',1.29),('14598','2013-03-13','12:30:00',1.35),('14598','2013-03-13','12:35:00',1.51),('14598','2013-03-13','12:40:00',1.5),('14598','2013-03-13','12:45:00',1.66),('14598','2013-03-13','12:50:00',1.28),('14598','2013-03-13','13:00:00',1.15),('14598','2013-03-13','13:05:00',1.22),('14598','2013-03-13','13:10:00',1.29),('14598','2013-03-13','13:15:00',1.47),('14598','2013-03-13','13:20:00',1.68),('14598','2013-03-13','13:25:00',1.76),('14598','2013-03-13','13:30:00',1.67),('14598','2013-03-13','13:35:00',1.57),('14598','2013-03-13','13:40:00',1.39),('14598','2013-03-13','13:45:00',1.21),('14598','2014-03-25','07:40:00',1.01),('14598','2014-03-25','07:45:00',1.04),('14598','2014-03-25','07:50:00',1.03),('14598','2014-03-25','07:55:00',1.11),('14598','2014-03-25','08:00:00',1.25),('14598','2014-03-25','08:05:00',1.29),('14598','2014-03-25','08:10:00',1.24),('14598','2014-03-25','08:15:00',1.13),('14598','2014-03-25','08:20:00',1.05),('14598','2014-03-25','08:25:00',1.15),('14598','2014-03-25','08:30:00',1.36),('14598','2014-03-25','08:35:00',1.62),('14598','2014-03-25','08:40:00',1.72),('14598','2014-03-25','08:45:00',1.84),('14598','2014-03-25','08:50:00',1.67),('14598','2014-03-25','08:55:00',1.65),('14598','2014-03-25','09:00:00',1.77),('14598','2014-03-25','09:05:00',2.28),('14598','2014-03-25','09:10:00',2.32),('14598','2014-03-25','09:15:00',2.11),('14598','2014-03-25','09:20:00',1.9),('14598','2014-03-25','09:25:00',1.82),('14598','2014-03-25','09:30:00',1.84),('14598','2014-03-25','09:35:00',1.85),('14598','2014-03-25','09:40:00',1.95),('14598','2014-03-25','09:45:00',2.07),('14598','2014-03-25','09:50:00',2.35),('14598','2014-03-25','09:55:00',2.45),('14598','2014-03-25','10:00:00',2.57),('14598','2014-03-25','10:05:00',2.56),('14598','2014-03-25','10:10:00',2.81),('14598','2014-03-25','10:15:00',2.58),('14598','2014-03-25','10:20:00',2.41),('14598','2014-03-25','10:25:00',2.33),('14598','2014-03-25','10:30:00',2.13),('14598','2014-03-25','10:35:00',2.06),('14598','2014-03-25','10:40:00',2.15),('14598','2014-03-25','10:45:00',2.16),('14598','2014-03-25','10:50:00',2.13),('14598','2014-03-25','10:55:00',2.19),('14598','2014-03-25','11:00:00',2.3),('14598','2014-03-25','11:05:00',2.42),('14598','2014-03-25','11:10:00',2.52),('14598','2014-03-25','11:15:00',2.56),('14598','2014-03-25','11:20:00',2.62),('14598','2014-03-25','11:25:00',2.62),('14598','2014-03-25','11:30:00',2.43),('14598','2014-03-25','11:35:00',2.32),('14598','2014-03-25','11:40:00',2.17),('14598','2014-03-25','11:45:00',2.03),('14598','2014-03-25','11:50:00',1.97),('14598','2014-03-25','11:55:00',1.94),('14598','2014-03-25','12:00:00',1.96),('14598','2014-03-25','12:05:00',1.99),('14598','2014-03-25','12:10:00',1.91),('14598','2014-03-25','12:15:00',1.81),('14598','2014-03-25','12:20:00',1.71),('14598','2014-03-25','12:25:00',1.71),('14598','2014-03-25','12:30:00',1.68),('14598','2014-03-25','12:35:00',1.66),('14598','2014-03-25','12:40:00',1.62),('14598','2014-03-25','12:45:00',1.19),('14598','2014-03-25','12:50:00',1.15),('14598','2014-03-25','14:30:00',1.07),('14598','2014-03-25','14:35:00',1.01),('14598','2013-03-12','08:25:00',1.3),('14598','2013-03-12','08:30:00',1.51),('14598','2013-03-12','08:35:00',1.42),('14598','2013-03-12','08:40:00',1.62),('14598','2013-03-12','08:45:00',1.77),('14598','2013-03-12','08:50:00',1.94),('14598','2013-03-12','08:55:00',2.04),('14598','2013-03-12','09:00:00',2.13),('14598','2013-03-12','09:05:00',2.22),('14598','2013-03-12','09:10:00',2.33),('14598','2013-03-12','09:15:00',2.44),('14598','2013-03-12','09:20:00',2.53),('14598','2013-03-12','09:25:00',2.61),('14598','2013-03-12','09:30:00',2.71),('14598','2013-03-12','09:35:00',2.81),('14598','2013-03-12','09:40:00',2.91),('14598','2013-03-12','09:45:00',2.99),('14598','2013-03-12','09:50:00',3.08),('14598','2013-03-12','09:55:00',3.18),('14598','2013-03-12','10:00:00',3.24),('14598','2013-03-12','10:05:00',3.35),('14598','2013-03-12','10:10:00',3.42),('14598','2013-03-12','10:15:00',3.5),('14598','2013-03-12','10:20:00',3.55),('14598','2013-03-12','10:25:00',3.62),('14598','2013-03-12','10:30:00',3.7),('14598','2013-03-12','10:35:00',3.79),('14598','2013-03-12','10:40:00',3.86),('14598','2013-03-12','10:45:00',3.94),('14598','2013-03-12','10:50:00',4.03),('14598','2013-03-12','10:55:00',3.77),('14598','2013-03-12','11:00:00',3.55),('14598','2013-03-12','11:05:00',3.08),('14598','2013-03-12','11:10:00',2.69),('14598','2013-03-12','11:15:00',4.42),('14598','2013-03-12','11:20:00',2.24),('14598','2013-03-12','11:25:00',3.76),('14598','2013-03-12','11:30:00',5.26),('14598','2013-03-12','11:35:00',2.78),('14598','2013-03-12','11:40:00',4.77),('14598','2013-03-12','11:45:00',2.33),('14598','2013-03-12','11:50:00',1.45),('14598','2013-03-12','11:55:00',2.01),('14598','2013-03-12','12:00:00',3.8),('14598','2013-03-12','12:05:00',4.43),('14598','2013-03-12','12:10:00',5.25),('14598','2013-03-12','12:15:00',3.52),('14598','2013-03-12','12:20:00',3.38),('14598','2013-03-12','12:25:00',4.84),('14598','2013-03-12','12:30:00',4.8),('14598','2013-03-12','12:35:00',4.2),('14598','2013-03-12','12:40:00',4.77),('14598','2013-03-12','12:45:00',4.55),('14598','2013-03-12','12:50:00',4.19),('14598','2013-03-12','12:55:00',4.69),('14598','2013-03-12','13:00:00',4.4),('14598','2013-03-12','13:05:00',2.56),('14598','2013-03-12','13:10:00',2.54),('14598','2013-03-12','13:15:00',2.76),('14598','2013-03-12','13:20:00',4.13),('14598','2013-03-12','13:25:00',3.73),('14598','2013-03-12','13:30:00',3.25),('14598','2013-03-12','13:35:00',3.48),('14598','2013-03-12','13:40:00',3.33),('14598','2013-03-12','13:45:00',2.17),('14598','2013-03-12','13:50:00',2.11),('14598','2013-03-12','13:55:00',3.56),('14598','2013-03-12','14:00:00',1.98),('14598','2013-03-12','14:05:00',2.82),('14598','2013-03-12','14:10:00',4.02),('14598','2013-03-12','14:15:00',1.46),('14598','2013-03-12','14:30:00',1.8),('14598','2013-03-12','14:35:00',2.6),('14598','2013-03-12','14:40:00',2.69),('14598','2013-03-12','14:45:00',2.9),('14598','2013-03-12','14:50:00',1.74),('14598','2013-03-12','14:55:00',1.79),('14598','2013-03-12','15:00:00',2.77),('14598','2013-03-12','15:05:00',2.44),('14598','2013-03-12','15:10:00',2.29),('14598','2013-03-12','15:15:00',1.67),('14598','2013-03-12','15:20:00',1.56),('14598','2013-03-12','15:25:00',1.25),('14598','2013-03-12','15:30:00',1.13),('14598','2013-03-12','16:00:00',2.69),('14598','2013-03-12','16:05:00',1.57),('14598','2013-03-12','16:15:00',1.26),('14598','2013-03-12','16:20:00',1.4),('14598','2013-03-12','16:25:00',1.12),('14598','2013-03-11','08:15:00',1.04),('14598','2013-03-11','08:20:00',1.15),('14598','2013-03-11','08:25:00',1.24),('14598','2013-03-11','08:30:00',1.38),('14598','2013-03-11','08:35:00',1.5),('14598','2013-03-11','08:40:00',1.63),('14598','2013-03-11','08:45:00',1.74),('14598','2013-03-11','08:50:00',1.84),('14598','2013-03-11','08:55:00',1.97),('14598','2013-03-11','09:00:00',2.08),('14598','2013-03-11','09:05:00',2.23),('14598','2013-03-11','09:10:00',1.8),('14598','2013-03-11','09:15:00',1.99),('14598','2013-03-11','09:20:00',1.83),('14598','2013-03-11','09:25:00',2.44),('14598','2013-03-11','09:30:00',1.83),('14598','2013-03-11','09:35:00',2.31),('14598','2013-03-11','09:40:00',1.69),('14598','2013-03-11','09:45:00',1.67),('14598','2013-03-11','09:50:00',1.53),('14598','2013-03-11','09:55:00',1.46),('14598','2013-03-11','10:00:00',1.5),('14598','2013-03-11','10:05:00',1.49),('14598','2013-03-11','10:10:00',1.57),('14598','2013-03-11','10:15:00',1.74),('14598','2013-03-11','10:20:00',1.86),('14598','2013-03-11','10:25:00',1.96),('14598','2013-03-11','10:30:00',2.39),('14598','2013-03-11','10:35:00',2.71),('14598','2013-03-11','10:40:00',2.93),('14598','2013-03-11','10:45:00',2.62),('14598','2013-03-11','10:50:00',2.46),('14598','2013-03-11','10:55:00',2.66),('14598','2013-03-11','11:00:00',3.06),('14598','2013-03-11','11:05:00',4.77),('14598','2013-03-11','11:10:00',3.02),('14598','2013-03-11','11:15:00',2.66),('14598','2013-03-11','11:20:00',3.07),('14598','2013-03-11','11:25:00',4.72),('14598','2013-03-11','11:30:00',5),('14598','2013-03-11','11:35:00',5.12),('14598','2013-03-11','11:40:00',4.92),('14598','2013-03-11','11:45:00',5.67),('14598','2013-03-11','11:50:00',4.17),('14598','2013-03-11','11:55:00',3.97),('14598','2013-03-11','12:00:00',4.16),('14598','2013-03-11','12:05:00',3.9),('14598','2013-03-11','12:10:00',3.35),('14598','2013-03-11','12:15:00',3.4),('14598','2013-03-11','12:20:00',3.95),('14598','2013-03-11','12:25:00',3.55),('14598','2013-03-11','12:30:00',3.02),('14598','2013-03-11','12:35:00',2.89),('14598','2013-03-11','12:40:00',3.16),('14598','2013-03-11','12:45:00',3.44),('14598','2013-03-11','12:50:00',4.21),('14598','2013-03-11','12:55:00',3.38),('14598','2013-03-11','13:00:00',3.3),('14598','2013-03-11','13:05:00',4.53),('14598','2013-03-11','13:10:00',4.58),('14598','2013-03-11','13:15:00',4.53),('14598','2013-03-11','13:20:00',4.51),('14598','2013-03-11','13:25:00',4.47),('14598','2013-03-11','13:30:00',4.48),('14598','2013-03-11','13:35:00',4.37),('14598','2013-03-11','13:40:00',4),('14598','2013-03-11','13:45:00',4.45),('14598','2013-03-11','13:50:00',4.35),('14598','2013-03-11','13:55:00',4.25),('14598','2013-03-11','14:00:00',4.28),('14598','2013-03-11','14:05:00',4.26),('14598','2013-03-11','14:10:00',4.23),('14598','2013-03-11','14:15:00',4.2),('14598','2013-03-11','14:20:00',4.16),('14598','2013-03-11','14:25:00',4.06),('14598','2013-03-11','14:30:00',3.79),('14598','2013-03-11','14:35:00',3.91),('14598','2013-03-11','14:40:00',3.43),('14598','2013-03-11','14:45:00',3.87),('14598','2013-03-11','14:50:00',3.73),('14598','2013-03-11','14:55:00',4.03),('14598','2013-03-11','15:00:00',2.87),('14598','2013-03-11','15:05:00',3.52),('14598','2013-03-11','15:10:00',2.95),('14598','2013-03-11','15:15:00',1.96),('14598','2013-03-11','15:20:00',1.63),('14598','2013-03-11','15:25:00',3.24),('14598','2013-03-11','15:30:00',3.54),('14598','2013-03-11','15:35:00',3.38),('14598','2013-03-11','15:40:00',1.46),('14598','2013-03-11','15:45:00',2.1),('14598','2013-03-11','15:50:00',2.89),('14598','2013-03-11','15:55:00',2.61),('14598','2013-03-11','16:00:00',2.41),('14598','2013-03-11','16:05:00',2.64),('14598','2013-03-11','16:10:00',1.76),('14598','2013-03-11','16:15:00',1.19),('14598','2013-03-11','16:20:00',1.34),('14598','2013-03-11','16:30:00',1.56),('14598','2013-03-11','16:35:00',1.56),('14598','2013-03-11','16:50:00',1.42),('14598','2013-03-11','16:55:00',1.2),('14598','2013-03-11','17:00:00',1.63),('14598','2013-03-11','17:05:00',1.33),('14598','2013-03-11','17:10:00',1.02),('14598','2013-03-10','08:15:00',1.03),('14598','2013-03-10','08:20:00',1.14),('14598','2013-03-10','08:25:00',1.24),('14598','2013-03-10','08:30:00',1.41),('14598','2013-03-10','08:35:00',1.53),('14598','2013-03-10','08:40:00',1.66),('14598','2013-03-10','08:45:00',1.78),('14598','2013-03-10','08:50:00',1.89),('14598','2013-03-10','08:55:00',2),('14598','2013-03-10','09:00:00',2.1),('14598','2013-03-10','09:05:00',2.19),('14598','2013-03-10','09:10:00',2.3),('14598','2013-03-10','09:15:00',2.37),('14598','2013-03-10','09:20:00',2.47),('14598','2013-03-10','09:25:00',2.56),('14598','2013-03-10','09:30:00',2.66),('14598','2013-03-10','09:35:00',2.73),('14598','2013-03-10','09:40:00',2.83),('14598','2013-03-10','09:45:00',2.93),('14598','2013-03-10','09:50:00',3),('14598','2013-03-10','09:55:00',3.1),('14598','2013-03-10','10:00:00',3.18),('14598','2013-03-10','10:05:00',3.26),('14598','2013-03-10','10:10:00',3.33),('14598','2013-03-10','10:15:00',3.42),('14598','2013-03-10','10:20:00',3.47),('14598','2013-03-10','10:25:00',3.54),('14598','2013-03-10','10:30:00',3.6),('14598','2013-03-10','10:35:00',3.67),('14598','2013-03-10','10:40:00',3.73),('14598','2013-03-10','10:45:00',3.8),('14598','2013-03-10','10:50:00',3.86),('14598','2013-03-10','10:55:00',3.9),('14598','2013-03-10','11:00:00',3.94),('14598','2013-03-10','11:05:00',4),('14598','2013-03-10','11:10:00',4.04),('14598','2013-03-10','11:15:00',4.09),('14598','2013-03-10','11:20:00',4.16),('14598','2013-03-10','11:25:00',4.11),('14598','2013-03-10','11:30:00',4.24),('14598','2013-03-10','11:35:00',4.24),('14598','2013-03-10','11:40:00',4.28),('14598','2013-03-10','11:45:00',4.32),('14598','2013-03-10','11:50:00',4.35),('14598','2013-03-10','11:55:00',4.39),('14598','2013-03-10','12:00:00',4.42),('14598','2013-03-10','12:05:00',4.45),('14598','2013-03-10','12:10:00',4.47),('14598','2013-03-10','12:15:00',4.45),('14598','2013-03-10','12:20:00',4.45),('14598','2013-03-10','12:25:00',4.51),('14598','2013-03-10','12:30:00',4.38),('14598','2013-03-10','12:35:00',2.26),('14598','2013-03-10','12:40:00',3.09),('14598','2013-03-10','12:45:00',4.91),('14598','2013-03-10','12:50:00',4.94),('14598','2013-03-10','12:55:00',4.66),('14598','2013-03-10','13:00:00',4.77),('14598','2013-03-10','13:05:00',4.71),('14598','2013-03-10','13:10:00',4.22),('14598','2013-03-10','13:15:00',3.64),('14598','2013-03-10','13:20:00',3.86),('14598','2013-03-10','13:25:00',3.03),('14598','2013-03-10','13:30:00',2.83),('14598','2013-03-10','13:35:00',2.29),('14598','2013-03-10','13:40:00',1.93),('14598','2013-03-10','13:45:00',1.81),('14598','2013-03-10','13:50:00',1.74),('14598','2013-03-10','13:55:00',1.82),('14598','2013-03-10','14:00:00',2.35),('14598','2013-03-10','14:05:00',2.73),('14598','2013-03-10','14:10:00',2.02),('14598','2013-03-10','14:15:00',2.42),('14598','2013-03-10','14:20:00',2.22),('14598','2013-03-10','14:25:00',2.17),('14598','2013-03-10','14:30:00',2.21),('14598','2013-03-10','14:35:00',1.8),('14598','2013-03-10','14:40:00',2),('14598','2013-03-10','14:45:00',1.14),('14598','2013-03-10','15:05:00',1.14),('14598','2013-03-09','08:15:00',1.01),('14598','2013-03-09','08:20:00',1.11),('14598','2013-03-09','08:25:00',1.22),('14598','2013-03-09','08:30:00',1.33),('14598','2013-03-09','08:35:00',1.38),('14598','2013-03-09','08:40:00',1.19),('14598','2013-03-09','08:45:00',1.09),('14598','2013-03-09','08:50:00',1.23),('14598','2013-03-09','08:55:00',1.91),('14598','2013-03-09','09:00:00',2.03),('14598','2013-03-09','09:05:00',2.15),('14598','2013-03-09','09:10:00',2.23),('14598','2013-03-09','09:15:00',2.33),('14598','2013-03-09','09:20:00',2.43),('14598','2013-03-09','09:25:00',2.52),('14598','2013-03-09','09:30:00',2.6),('14598','2013-03-09','09:35:00',2.7),('14598','2013-03-09','09:40:00',2.79),('14598','2013-03-09','09:45:00',2.87),('14598','2013-03-09','09:50:00',2.97),('14598','2013-03-09','09:55:00',3.04),('14598','2013-03-09','10:00:00',3.13),('14598','2013-03-09','10:05:00',3.21),('14598','2013-03-09','10:10:00',3.3),('14598','2013-03-09','10:15:00',3.37),('14598','2013-03-09','10:20:00',3.44),('14598','2013-03-09','10:25:00',3.52),('14598','2013-03-09','10:30:00',3.6),('14598','2013-03-09','10:35:00',3.67),('14598','2013-03-09','10:40:00',3.72),('14598','2013-03-09','10:45:00',3.78),('14598','2013-03-09','10:50:00',3.86),('14598','2013-03-09','10:55:00',3.92),('14598','2013-03-09','11:00:00',3.97),('14598','2013-03-09','11:05:00',4.03),('14598','2013-03-09','11:10:00',4.08),('14598','2013-03-09','11:15:00',4.12),('14598','2013-03-09','11:20:00',4.14),('14598','2013-03-09','11:25:00',4.15),('14598','2013-03-09','11:30:00',4.24),('14598','2013-03-09','11:35:00',4.23),('14598','2013-03-09','11:40:00',4.31),('14598','2013-03-09','11:45:00',4.51),('14598','2013-03-09','11:50:00',3.22),('14598','2013-03-09','11:55:00',3.14),('14598','2013-03-09','12:00:00',4.43),('14598','2013-03-09','12:05:00',3.8),('14598','2013-03-09','12:10:00',3.64),('14598','2013-03-09','12:15:00',3.84),('14598','2013-03-09','12:20:00',4.61),('14598','2013-03-09','12:25:00',4.64),('14598','2013-03-09','12:30:00',4.48),('14598','2013-03-09','12:35:00',4.48),('14598','2013-03-09','12:40:00',4.49),('14598','2013-03-09','12:45:00',4.51),('14598','2013-03-09','12:50:00',4.5),('14598','2013-03-09','12:55:00',4.48),('14598','2013-03-09','13:00:00',4.49),('14598','2013-03-09','13:05:00',4.48),('14598','2013-03-09','13:10:00',4.46),('14598','2013-03-09','13:15:00',4.46),('14598','2013-03-09','13:20:00',4.45),('14598','2013-03-09','13:25:00',4.41),('14598','2013-03-09','13:30:00',4.4),('14598','2013-03-09','13:35:00',4.39),('14598','2013-03-09','13:40:00',4.34),('14598','2013-03-09','13:45:00',4.31),('14598','2013-03-09','13:50:00',4.29),('14598','2013-03-09','13:55:00',4.26),('14598','2013-03-09','14:00:00',4.22),('14598','2013-03-09','14:05:00',4.2),('14598','2013-03-09','14:10:00',4.15),('14598','2013-03-09','14:15:00',4.13),('14598','2013-03-09','14:20:00',4.07),('14598','2013-03-09','14:25:00',4),('14598','2013-03-09','14:30:00',3.96),('14598','2013-03-09','14:35:00',3.92),('14598','2013-03-09','14:40:00',3.79),('14598','2013-03-09','14:45:00',3.77),('14598','2013-03-09','14:50:00',3.72),('14598','2013-03-09','14:55:00',3.67),('14598','2013-03-09','15:00:00',3.63),('14598','2013-03-09','15:05:00',3.56),('14598','2013-03-09','15:10:00',3.5),('14598','2013-03-09','15:15:00',3.43),('14598','2013-03-09','15:20:00',3.37),('14598','2013-03-09','15:25:00',3.29),('14598','2013-03-09','15:30:00',3.21),('14598','2013-03-09','15:35:00',3.14),('14598','2013-03-09','15:40:00',3.06),('14598','2013-03-09','15:45:00',2.92),('14598','2013-03-09','15:50:00',2.65),('14598','2013-03-09','15:55:00',2.29),('14598','2013-03-09','16:00:00',2.14),('14598','2013-03-09','16:05:00',2.22),('14598','2013-03-09','16:10:00',1.65),('14598','2013-03-09','16:15:00',1.23),('14598','2013-03-09','16:20:00',1.31),('14598','2013-03-09','16:25:00',1.83),('14598','2013-03-09','16:30:00',1.96),('14598','2013-03-09','16:35:00',1.02),('14598','2013-03-08','08:15:00',1.05),('14598','2013-03-08','08:20:00',1.04),('14598','2013-03-08','08:50:00',1.68),('14598','2013-03-08','08:55:00',2.01),('14598','2013-03-08','09:00:00',2.04),('14598','2013-03-08','09:05:00',2.11),('14598','2013-03-08','09:10:00',1.51),('14598','2013-03-08','09:15:00',1.06),('14598','2013-03-08','09:20:00',1.44),('14598','2013-03-08','09:25:00',1.01),('14598','2013-03-08','09:30:00',1.18),('14598','2013-03-08','09:35:00',1.32),('14598','2013-03-08','09:40:00',1.38),('14598','2013-03-08','09:45:00',1.24),('14598','2013-03-08','09:50:00',1.42),('14598','2013-03-08','09:55:00',1.61),('14598','2013-03-08','10:00:00',1.63),('14598','2013-03-08','10:05:00',1.6),('14598','2013-03-08','10:10:00',1.79),('14598','2013-03-08','10:15:00',1.75),('14598','2013-03-08','10:20:00',2.28),('14598','2013-03-08','10:25:00',2.33),('14598','2013-03-08','10:30:00',2.19),('14598','2013-03-08','10:35:00',2),('14598','2013-03-08','10:40:00',1.27),('14598','2013-03-08','10:55:00',1.1),('14598','2013-03-08','11:15:00',1.01),('14598','2013-03-08','11:20:00',1.19),('14598','2013-03-08','11:25:00',1.52),('14598','2013-03-08','11:30:00',1.38),('14598','2013-03-08','11:35:00',1.17),('14598','2013-03-08','11:40:00',1.02),('14598','2013-03-08','11:45:00',1.04),('14598','2013-03-08','12:05:00',1.08),('14598','2013-03-08','12:10:00',1.28),('14598','2013-03-08','12:15:00',1.86),('14598','2013-03-08','12:20:00',2.03),('14598','2013-03-08','12:25:00',1.68),('14598','2013-03-08','12:30:00',1.43),('14598','2013-03-08','12:35:00',1.18),('14598','2013-03-08','12:40:00',1.63),('14598','2013-03-08','12:45:00',1.03),('14598','2013-03-08','12:50:00',1.26),('14598','2013-03-08','12:55:00',1.66),('14598','2013-03-08','13:00:00',1.88),('14598','2013-03-08','13:05:00',1.19),('14598','2013-03-08','13:10:00',1.41),('14598','2013-03-08','13:15:00',2.37),('14598','2013-03-08','13:20:00',2.76),('14598','2013-03-08','13:25:00',2.52),('14598','2013-03-08','13:30:00',2.44),('14598','2013-03-08','13:35:00',1.7),('14598','2013-03-08','13:40:00',1.63),('14598','2013-03-07','09:10:00',1.03),('14598','2013-03-07','09:15:00',1.43),('14598','2013-03-07','09:20:00',1.23),('14598','2013-03-07','09:45:00',1.42),('14598','2013-03-07','09:50:00',1.65),('14598','2013-03-07','09:55:00',1.23),('14598','2013-03-07','10:00:00',1.2),('14598','2013-03-07','10:25:00',1),('14598','2013-03-07','10:30:00',1.45),('14598','2013-03-07','10:35:00',1.6),('14598','2013-03-07','10:40:00',1.62),('14598','2013-03-07','10:45:00',1.58),('14598','2013-03-07','10:50:00',2.14),('14598','2013-03-07','10:55:00',2.07),('14598','2013-03-07','11:00:00',1.82),('14598','2013-03-07','11:05:00',1.67),('14598','2013-03-07','11:10:00',1.59),('14598','2013-03-07','11:15:00',2.15),('14598','2013-03-07','11:20:00',2.83),('14598','2013-03-07','11:25:00',1.96),('14598','2013-03-07','11:30:00',2.47),('14598','2013-03-07','11:35:00',3.13),('14598','2013-03-07','11:40:00',3.31),('14598','2013-03-07','11:45:00',2.43),('14598','2013-03-07','11:50:00',2.91),('14598','2013-03-07','11:55:00',3),('14598','2013-03-07','12:00:00',2.87),('14598','2013-03-07','12:05:00',1.94),('14598','2013-03-07','12:15:00',2.42),('14598','2013-03-07','12:20:00',1.97),('14598','2013-03-07','12:25:00',1.69),('14598','2013-03-07','12:30:00',1.29),('14598','2013-03-07','12:35:00',1.04),('14598','2013-03-07','12:40:00',1.68),('14598','2013-03-07','12:45:00',2.41),('14598','2013-03-07','12:50:00',2.41),('14598','2013-03-07','12:55:00',2.37),('14598','2013-03-07','13:00:00',1.36),('14598','2013-03-07','13:45:00',1.12),('14598','2013-03-07','13:50:00',1.61),('14598','2013-03-07','13:55:00',1.46),('14598','2013-03-07','14:00:00',1.21),('14598','2013-03-07','14:15:00',1.7),('14598','2013-03-07','14:20:00',1.99),('14598','2013-03-07','14:25:00',1.51),('14598','2013-03-07','14:30:00',1.18),('14598','2013-03-07','14:55:00',1.06),('14598','2013-03-07','15:00:00',1.28),('14598','2013-03-07','15:05:00',2.27),('14598','2013-03-07','15:10:00',1.19),('14598','2013-03-07','15:20:00',1.04),('14598','2013-03-07','16:15:00',1.13),('14598','2013-03-05','08:20:00',1.1),('14598','2013-03-05','08:25:00',1.05),('14598','2013-03-05','08:30:00',1.17),('14598','2013-03-05','08:35:00',1.33),('14598','2013-03-05','08:40:00',1.36),('14598','2013-03-05','08:45:00',1.33),('14598','2013-03-05','08:50:00',1.31),('14598','2013-03-05','08:55:00',1.33),('14598','2013-03-05','09:00:00',1.35),('14598','2013-03-05','09:05:00',1.39),('14598','2013-03-05','09:10:00',1.47),('14598','2013-03-05','09:15:00',1.5),('14598','2013-03-05','09:20:00',1.52),('14598','2013-03-05','09:25:00',1.56),('14598','2013-03-05','09:30:00',1.62),('14598','2013-03-05','09:35:00',1.75),('14598','2013-03-05','09:40:00',2),('14598','2013-03-05','09:45:00',2.14),('14598','2013-03-05','09:50:00',1.81),('14598','2013-03-05','09:55:00',1.66),('14598','2013-03-05','10:00:00',1.79),('14598','2013-03-05','10:05:00',1.81),('14598','2013-03-05','10:10:00',1.73),('14598','2013-03-05','10:15:00',2.05),('14598','2013-03-05','10:20:00',2.25),('14598','2013-03-05','10:25:00',2.29),('14598','2013-03-05','10:30:00',2.42),('14598','2013-03-05','10:35:00',2.49),('14598','2013-03-05','10:40:00',2.62),('14598','2013-03-05','10:45:00',2.79),('14598','2013-03-05','10:50:00',2.76),('14598','2013-03-05','10:55:00',2.67),('14598','2013-03-05','11:00:00',2.86),('14598','2013-03-05','11:05:00',2.91),('14598','2013-03-05','11:10:00',2.69),('14598','2013-03-05','11:15:00',2.89),('14598','2013-03-05','11:20:00',2.97),('14598','2013-03-05','11:25:00',2.94),('14598','2013-03-05','11:30:00',3.09),('14598','2013-03-05','11:35:00',3.26),('14598','2013-03-05','11:40:00',3.39),('14598','2013-03-05','11:45:00',3.43),('14598','2013-03-05','11:50:00',3.53),('14598','2013-03-05','11:55:00',3.62),('14598','2013-03-05','12:00:00',3.43),('14598','2013-03-05','12:05:00',2.89),('14598','2013-03-05','12:10:00',2.35),('14598','2013-03-05','12:15:00',2.67),('14598','2013-03-05','12:20:00',2.43),('14598','2013-03-05','12:25:00',2.59),('14598','2013-03-05','12:30:00',3.06),('14598','2013-03-05','12:35:00',3.33),('14598','2013-03-05','12:40:00',2.75),('14598','2013-03-05','12:45:00',2.13),('14598','2013-03-05','12:50:00',1.97),('14598','2013-03-05','12:55:00',1.94),('14598','2013-03-05','13:00:00',2),('14598','2013-03-05','13:05:00',1.99),('14598','2013-03-05','13:10:00',1.91),('14598','2013-03-05','13:15:00',1.71),('14598','2013-03-05','13:20:00',1.46),('14598','2013-03-05','13:25:00',1.29),('14598','2013-03-05','13:30:00',1.26),('14598','2013-03-05','13:35:00',1.22),('14598','2013-03-05','13:40:00',1.24),('14598','2013-03-05','13:45:00',1.3),('14598','2013-03-05','13:50:00',1.32),('14598','2013-03-05','13:55:00',1.29),('14598','2013-03-05','14:00:00',1.29),('14598','2013-03-05','14:05:00',1.28),('14598','2013-03-05','14:10:00',1.3),('14598','2013-03-05','14:15:00',1.32),('14598','2013-03-05','14:20:00',1.35),('14598','2013-03-05','14:25:00',1.31),('14598','2013-03-05','14:30:00',1.22),('14598','2013-03-05','14:35:00',1.09),('14598','2013-03-05','15:20:00',1),('14598','2013-03-05','15:25:00',1.18),('14598','2013-03-05','15:30:00',1.21),('14598','2013-03-05','15:35:00',1.11),('14598','2013-03-05','15:40:00',1.09),('14598','2013-03-05','15:45:00',1),('14598','2013-03-04','08:20:00',1.02),('14598','2013-03-04','08:25:00',1.16),('14598','2013-03-04','08:30:00',1.3),('14598','2013-03-04','08:35:00',1.34),('14598','2013-03-04','08:40:00',1.43),('14598','2013-03-04','08:45:00',1.55),('14598','2013-03-04','08:50:00',1.65),('14598','2013-03-04','08:55:00',1.76),('14598','2013-03-04','09:00:00',1.87),('14598','2013-03-04','09:05:00',1.98),('14598','2013-03-04','09:10:00',2.06),('14598','2013-03-04','09:15:00',2.14),('14598','2013-03-04','09:20:00',2.23),('14598','2013-03-04','09:25:00',2.34),('14598','2013-03-04','09:30:00',2.45),('14598','2013-03-04','09:35:00',2.54),('14598','2013-03-04','09:40:00',2.63),('14598','2013-03-04','09:45:00',2.7),('14598','2013-03-04','09:50:00',2.8),('14598','2013-03-04','09:55:00',2.9),('14598','2013-03-04','10:00:00',2.97),('14598','2013-03-04','10:05:00',3.05),('14598','2013-03-04','10:10:00',3.11),('14598','2013-03-04','10:15:00',3.19),('14598','2013-03-04','10:20:00',3.23),('14598','2013-03-04','10:25:00',3.32),('14598','2013-03-04','10:30:00',3.36),('14598','2013-03-04','10:35:00',3.42),('14598','2013-03-04','10:40:00',3.5),('14598','2013-03-04','10:45:00',3.58),('14598','2013-03-04','10:50:00',3.63),('14598','2013-03-04','10:55:00',3.65),('14598','2013-03-04','11:00:00',3.67),('14598','2013-03-04','11:05:00',3.72),('14598','2013-03-04','11:10:00',3.76),('14598','2013-03-04','11:15:00',3.8),('14598','2013-03-04','11:20:00',3.7),('14598','2013-03-04','11:25:00',3.98),('14598','2013-03-04','11:30:00',4.04),('14598','2013-03-04','11:35:00',3.98),('14598','2013-03-04','11:40:00',4.05),('14598','2013-03-04','11:45:00',4.08),('14598','2013-03-04','11:51:00',4.13),('14598','2013-03-04','11:55:00',4.14),('14598','2013-03-04','12:00:00',4.19),('14598','2013-03-04','12:05:00',4.2),('14598','2013-03-04','12:10:00',4.24),('14598','2013-03-04','12:15:00',4.26),('14598','2013-03-04','12:20:00',4.27),('14598','2013-03-04','12:25:00',4.27),('14598','2013-03-04','12:30:00',4.28),('14598','2013-03-04','12:35:00',4.29),('14598','2013-03-04','12:40:00',4.3),('14598','2013-03-04','12:45:00',4.29),('14598','2013-03-04','12:50:00',4.28),('14598','2013-03-04','12:55:00',4.27),('14598','2013-03-04','13:00:00',4.28),('14598','2013-03-04','13:05:00',4.32),('14598','2013-03-04','13:10:00',4.3),('14598','2013-03-04','13:15:00',4.32),('14598','2013-03-04','13:20:00',4.32),('14598','2013-03-04','13:25:00',4.26),('14598','2013-03-04','13:30:00',4.23),('14598','2013-03-04','13:35:00',4.18),('14598','2013-03-04','13:40:00',4.12),('14598','2013-03-04','13:45:00',4.09),('14598','2013-03-04','13:50:00',4.07),('14598','2013-03-04','13:55:00',4.04),('14598','2013-03-04','14:00:00',3.99),('14598','2013-03-04','14:05:00',3.98),('14598','2013-03-04','14:10:00',3.95),('14598','2013-03-04','14:15:00',3.93),('14598','2013-03-04','14:20:00',3.88),('14598','2013-03-04','14:25:00',3.83),('14598','2013-03-04','14:30:00',3.8),('14598','2013-03-04','14:35:00',3.69),('14598','2013-03-04','14:40:00',3.72),('14598','2013-03-04','14:45:00',3.67),('14598','2013-03-04','14:50:00',3.6),('14598','2013-03-04','14:55:00',3.55),('14598','2013-03-04','15:00:00',3.5),('14598','2013-03-04','15:05:00',3.42),('14598','2013-03-04','15:10:00',3.36),('14598','2013-03-04','15:15:00',3.3),('14598','2013-03-04','15:20:00',3.22),('14598','2013-03-04','15:25:00',3.12),('14598','2013-03-04','15:30:00',3.04),('14598','2013-03-04','15:35:00',2.98),('14598','2013-03-04','15:40:00',2.88),('14598','2013-03-04','15:45:00',2.8),('14598','2013-03-04','15:50:00',2.71),('14598','2013-03-04','15:55:00',2.6),('14598','2013-03-04','16:00:00',2.54),('14598','2013-03-04','16:05:00',2.47),('14598','2013-03-04','16:10:00',2.36),('14598','2013-03-04','16:15:00',2.25),('14598','2013-03-04','16:20:00',2.16),('14598','2013-03-04','16:25:00',2.06),('14598','2013-03-04','16:30:00',1.96),('14598','2013-03-04','16:35:00',1.86),('14598','2013-03-04','16:40:00',1.67),('14598','2013-03-04','16:45:00',1.6),('14598','2013-03-04','16:50:00',1.49),('14598','2013-03-04','16:55:00',1.36),('14598','2013-03-04','17:00:00',1.24),('14598','2013-03-04','17:05:00',1.14),('14598','2013-03-04','17:10:00',1.01),('14598','2013-03-03','08:25:00',1.1),('14598','2013-03-03','08:30:00',1.2),('14598','2013-03-03','08:35:00',1.31),('14598','2013-03-03','08:40:00',1.41),('14598','2013-03-03','08:45:00',1.57),('14598','2013-03-03','08:50:00',1.71),('14598','2013-03-03','08:55:00',1.81),('14598','2013-03-03','09:00:00',1.92),('14598','2013-03-03','09:05:00',2.03),('14598','2013-03-03','09:10:00',2.14),('14598','2013-03-03','09:15:00',2.24),('14598','2013-03-03','09:20:00',2.34),('14598','2013-03-03','09:25:00',2.43),('14598','2013-03-03','09:30:00',2.54),('14598','2013-03-03','09:35:00',2.64),('14598','2013-03-03','09:40:00',2.73),('14598','2013-03-03','09:45:00',2.82),('14598','2013-03-03','09:50:00',2.85),('14598','2013-03-03','09:55:00',3.01),('14598','2013-03-03','10:00:00',3.1),('14598','2013-03-03','10:05:00',3.18),('14598','2013-03-03','10:10:00',3.25),('14598','2013-03-03','10:15:00',3.32),('14598','2013-03-03','10:20:00',3.4),('14598','2013-03-03','10:25:00',3.46),('14598','2013-03-03','10:30:00',3.53),('14598','2013-03-03','10:35:00',3.62),('14598','2013-03-03','10:40:00',3.67),('14598','2013-03-03','10:45:00',3.71),('14598','2013-03-03','10:50:00',3.76),('14598','2013-03-03','10:55:00',3.82),('14598','2013-03-03','11:00:00',3.87),('14598','2013-03-03','11:05:00',3.87),('14598','2013-03-03','11:10:00',3.96),('14598','2013-03-03','11:15:00',4),('14598','2013-03-03','11:20:00',4.04),('14598','2013-03-03','11:25:00',4.07),('14598','2013-03-03','11:30:00',4.12),('14598','2013-03-03','11:35:00',4.17),('14598','2013-03-03','11:40:00',4.19),('14598','2013-03-03','11:45:00',4.21),('14598','2013-03-03','11:50:00',4.23),('14598','2013-03-03','11:55:00',4.25),('14598','2013-03-03','12:00:00',4.26),('14598','2013-03-03','12:05:00',4.26),('14598','2013-03-03','12:10:00',4.27),('14598','2013-03-03','12:15:00',4.26),('14598','2013-03-03','12:20:00',4.27),('14598','2013-03-03','12:25:00',4.3),('14598','2013-03-03','12:30:00',4.3),('14598','2013-03-03','12:35:00',4.31),('14598','2013-03-03','12:40:00',4.32),('14598','2013-03-03','12:45:00',4.29),('14598','2013-03-03','12:50:00',4.27),('14598','2013-03-03','12:55:00',4.26),('14598','2013-03-03','13:00:00',4.26),('14598','2013-03-03','13:05:00',4.25),('14598','2013-03-03','13:10:00',4.29),('14598','2013-03-03','13:15:00',4.34),('14598','2013-03-03','13:20:00',4.38),('14598','2013-03-03','13:25:00',4.38),('14598','2013-03-03','13:30:00',4.35),('14598','2013-03-03','13:35:00',4.33),('14598','2013-03-03','13:40:00',4.31),('14598','2013-03-03','13:45:00',4.29),('14598','2013-03-03','13:50:00',4.28),('14598','2013-03-03','13:55:00',4.25),('14598','2013-03-03','14:00:00',4.22),('14598','2013-03-03','14:05:00',4.2),('14598','2013-03-03','14:10:00',4.11),('14598','2013-03-03','14:15:00',4.12),('14598','2013-03-03','14:20:00',4.07),('14598','2013-03-03','14:25:00',4.01),('14598','2013-03-03','14:30:00',3.98),('14598','2013-03-03','14:35:00',3.92),('14598','2013-03-03','14:40:00',3.85),('14598','2013-03-03','14:45:00',3.79),('14598','2013-03-03','14:50:00',3.73),('14598','2013-03-03','14:55:00',3.68),('14598','2013-03-03','15:00:00',3.59),('14598','2013-03-03','15:05:00',3.53),('14598','2013-03-03','15:10:00',3.45),('14598','2013-03-03','15:15:00',3.37),('14598','2013-03-03','15:20:00',3.29),('14598','2013-03-03','15:25:00',3.22),('14598','2013-03-03','15:30:00',3.16),('14598','2013-03-03','15:35:00',3.07),('14598','2013-03-03','15:40:00',2.98),('14598','2013-03-03','15:45:00',2.89),('14598','2013-03-03','15:50:00',2.79),('14598','2013-03-03','15:55:00',2.69),('14598','2013-03-03','16:00:00',2.6),('14598','2013-03-03','16:05:00',2.51),('14598','2013-03-03','16:10:00',2.4),('14598','2013-03-03','16:15:00',2.3),('14598','2013-03-03','16:20:00',2.19),('14598','2013-03-03','16:25:00',2.08),('14598','2013-03-03','16:30:00',1.97),('14598','2013-03-03','16:35:00',1.86),('14598','2013-03-03','16:40:00',1.73),('14598','2013-03-03','16:45:00',1.61),('14598','2013-03-03','16:50:00',1.49),('14598','2013-03-03','16:55:00',1.36),('14598','2013-03-03','17:00:00',1.23),('14598','2013-03-03','17:05:00',1.1),('14598','2014-03-24','08:10:00',1.62),('14598','2014-03-24','08:15:00',1.54),('14598','2014-03-24','08:25:00',1.61),('14598','2014-03-24','08:30:00',1.43),('14598','2014-03-24','08:35:00',1.67),('14598','2014-03-24','08:40:00',1.38),('14598','2014-03-24','08:45:00',1.92),('14598','2014-03-24','08:50:00',1.85),('14598','2014-03-24','08:55:00',2.45),('14598','2014-03-24','09:00:00',2.07),('14598','2014-03-24','09:05:00',2.33),('14598','2014-03-24','09:10:00',2.36),('14598','2014-03-24','09:20:00',2.3),('14598','2014-03-24','09:25:00',2.15),('14598','2014-03-24','09:30:00',3.29),('14598','2014-03-24','09:35:00',1.53),('14598','2014-03-24','09:40:00',3.77),('14598','2014-03-24','09:45:00',2.16),('14598','2014-03-24','09:50:00',2.39),('14598','2014-03-24','09:55:00',1.82),('14598','2014-03-24','10:00:00',4.37),('14598','2014-03-24','10:05:00',2.76),('14598','2014-03-24','10:10:00',1.13),('14598','2014-03-24','10:15:00',1.2),('14598','2014-03-24','10:20:00',2.35),('14598','2014-03-24','10:25:00',4.11),('14598','2014-03-24','10:30:00',2.62),('14598','2014-03-24','10:35:00',5.08),('14598','2014-03-24','10:40:00',3.74),('14598','2014-03-24','10:45:00',1.76),('14598','2014-03-24','10:50:00',3.56),('14598','2014-03-24','10:55:00',5.24),('14598','2014-03-24','11:00:00',4.02),('14598','2014-03-24','11:05:00',3.65),('14598','2014-03-24','11:10:00',1.32),('14598','2014-03-24','12:00:00',1.07),('14598','2014-03-24','12:05:00',1.87),('14598','2014-03-24','12:10:00',2.05),('14598','2014-03-24','12:15:00',2.12),('14598','2014-03-24','12:20:00',1.8),('14598','2014-03-24','12:25:00',1.52),('14598','2014-03-24','12:30:00',1.57),('14598','2014-03-24','12:35:00',1.67),('14598','2014-03-24','12:40:00',1.75),('14598','2014-03-24','12:45:00',1.69),('14598','2014-03-24','12:50:00',1.6),('14598','2014-03-24','12:55:00',1.66),('14598','2014-03-24','13:00:00',1.73),('14598','2014-03-24','13:05:00',1.72),('14598','2014-03-24','13:10:00',1.6),('14598','2014-03-24','13:15:00',1.05),('14598','2014-03-24','13:25:00',1.11),('14598','2014-03-24','13:50:00',1.14),('14598','2014-03-24','13:55:00',1.6),('14598','2014-03-24','14:00:00',2.71),('14598','2014-03-24','14:05:00',3.02),('14598','2014-03-24','14:10:00',2.15),('14598','2014-03-24','14:15:00',2),('14598','2014-03-24','14:20:00',2.04),('14598','2014-03-24','14:25:00',2.82),('14598','2014-03-24','14:30:00',3.49),('14598','2014-03-24','14:35:00',3.52),('14598','2014-03-24','14:40:00',3.45),('14598','2014-03-24','14:45:00',3),('14598','2014-03-24','14:50:00',2.64),('14598','2014-03-24','14:55:00',2.32),('14598','2014-03-24','15:00:00',2.68),('14598','2014-03-24','15:05:00',2.39),('14598','2014-03-24','15:10:00',1.75),('14598','2014-03-24','15:15:00',1.61),('14598','2014-03-24','15:20:00',2.28),('14598','2014-03-24','15:25:00',3.97),('14598','2014-03-24','15:30:00',4.04),('14598','2014-03-24','15:35:00',3.29),('14598','2014-03-24','15:40:00',1.32),('14598','2014-03-24','15:45:00',1.15),('14598','2014-03-24','15:50:00',1.65),('14598','2014-03-24','15:55:00',1.25),('14598','2014-03-24','17:30:00',1.13),('14598','2014-03-24','17:35:00',1.18),('14598','2014-03-24','17:40:00',1.05),('14598','2013-03-02','11:05:00',1.03),('14598','2013-03-02','11:10:00',1.13),('14598','2013-03-02','11:15:00',1.35),('14598','2013-03-02','11:20:00',1.44),('14598','2013-03-02','11:25:00',1.37),('14598','2013-03-02','11:30:00',1.43),('14598','2013-03-02','11:35:00',1.59),('14598','2013-03-02','11:40:00',1.39),('14598','2013-03-02','11:45:00',1.34),('14598','2013-03-02','11:50:00',1.34),('14598','2013-03-02','11:55:00',1.34),('14598','2013-03-02','12:00:00',1.34),('14598','2013-03-02','12:05:00',1.43),('14598','2013-03-02','12:10:00',1.45),('14598','2013-03-02','12:15:00',1.44),('14598','2013-03-02','12:20:00',1.41),('14598','2013-03-02','12:25:00',1.4),('14598','2013-03-02','12:30:00',1.42),('14598','2013-03-02','12:35:00',1.47),('14598','2013-03-02','12:40:00',1.42),('14598','2013-03-02','12:45:00',1.35),('14598','2013-03-02','12:50:00',1.34),('14598','2013-03-02','12:55:00',1.21),('14598','2013-03-02','13:00:00',1.11),('14598','2013-03-02','13:05:00',1.03),('14598','2013-03-02','13:10:00',1.12),('14598','2013-03-02','13:15:00',1.16),('14598','2013-03-02','13:20:00',1.27),('14598','2013-03-02','13:25:00',1.29),('14598','2013-03-02','13:30:00',1.32),('14598','2013-03-02','13:35:00',1.26),('14598','2013-03-02','13:40:00',1.09),('14598','2013-03-02','13:45:00',1.06),('14598','2013-03-02','13:50:00',1.04),('14598','2013-03-02','13:55:00',1),('14598','2013-03-02','14:00:00',1.01),('14598','2013-03-02','14:05:00',1.02),('14598','2013-03-02','14:30:00',1.16),('14598','2013-03-02','14:35:00',1.07),('14598','2013-03-02','14:50:00',1.23),('14598','2013-03-02','14:55:00',1.28),('14598','2013-03-02','15:00:00',1.31),('14598','2013-03-02','15:05:00',1.4),('14598','2013-03-02','15:10:00',1.37),('14598','2013-03-02','15:15:00',1.13),('14598','2013-03-02','15:25:00',1.01),('14598','2013-03-02','15:30:00',1.03),('14598','2013-03-02','15:55:00',1.01),('14598','2013-03-02','16:00:00',1.03),('14598','2013-03-01','08:25:00',1.09),('14598','2013-03-01','08:30:00',1.2),('14598','2013-03-01','08:35:00',1.3),('14598','2013-03-01','08:40:00',1.33),('14598','2013-03-01','08:45:00',1.37),('14598','2013-03-01','08:50:00',1.42),('14598','2013-03-01','08:55:00',1.51),('14598','2013-03-01','09:00:00',1.5),('14598','2013-03-01','09:05:00',1.52),('14598','2013-03-01','09:10:00',1.71),('14598','2013-03-01','09:15:00',1.81),('14598','2013-03-01','09:20:00',1.9),('14598','2013-03-01','09:25:00',1.96),('14598','2013-03-01','09:30:00',1.98),('14598','2013-03-01','09:35:00',2),('14598','2013-03-01','09:40:00',1.85),('14598','2013-03-01','09:45:00',1.57),('14598','2013-03-01','09:50:00',1.46),('14598','2013-03-01','09:55:00',1.48),('14598','2013-03-01','10:00:00',1.61),('14598','2013-03-01','10:05:00',1.77),('14598','2013-03-01','10:10:00',1.93),('14598','2013-03-01','10:15:00',2.14),('14598','2013-03-01','10:20:00',2.03),('14598','2013-03-01','10:25:00',1.88),('14598','2013-03-01','10:30:00',1.81),('14598','2013-03-01','10:35:00',1.87),('14598','2013-03-01','10:40:00',1.95),('14598','2013-03-01','10:45:00',2.07),('14598','2013-03-01','10:50:00',2.02),('14598','2013-03-01','10:55:00',2.11),('14598','2013-03-01','11:00:00',2.19),('14598','2013-03-01','11:05:00',2.23),('14598','2013-03-01','11:10:00',2.17),('14598','2013-03-01','11:15:00',2.1),('14598','2013-03-01','11:20:00',2.03),('14598','2013-03-01','11:25:00',1.91),('14598','2013-03-01','11:30:00',1.85),('14598','2013-03-01','11:35:00',1.76),('14598','2013-03-01','11:40:00',1.67),('14598','2013-03-01','11:45:00',1.55),('14598','2013-03-01','11:50:00',1.45),('14598','2013-03-01','11:55:00',1.36),('14598','2013-03-01','12:00:00',1.29),('14598','2013-03-01','12:05:00',1.25),('14598','2013-03-01','12:10:00',1.22),('14598','2013-03-01','12:15:00',1.23),('14598','2013-03-01','12:20:00',1.36),('14598','2013-03-01','12:25:00',1.64),('14598','2013-03-01','12:30:00',1.81),('14598','2013-03-01','12:35:00',1.89),('14598','2013-03-01','12:40:00',1.86),('14598','2013-03-01','12:45:00',1.85),('14598','2013-03-01','12:50:00',1.88),('14598','2013-03-01','12:55:00',1.95),('14598','2013-03-01','13:00:00',2.04),('14598','2013-03-01','13:05:00',2.15),('14598','2013-03-01','13:10:00',2.16),('14598','2013-03-01','13:15:00',1.9),('14598','2013-03-01','13:20:00',1.67),('14598','2013-03-01','13:25:00',1.53),('14598','2013-03-01','13:30:00',1.53),('14598','2013-03-01','13:35:00',1.57),('14598','2013-03-01','13:40:00',1.53),('14598','2013-03-01','13:45:00',1.41),('14598','2013-03-01','13:50:00',1.32),('14598','2013-03-01','13:55:00',1.32),('14598','2013-03-01','14:00:00',1.34),('14598','2013-03-01','14:05:00',1.34),('14598','2013-03-01','14:10:00',1.32),('14598','2013-03-01','14:15:00',1.3),('14598','2013-03-01','14:20:00',1.3),('14598','2013-03-01','14:25:00',1.31),('14598','2013-03-01','14:30:00',1.29),('14598','2013-03-01','14:35:00',1.23),('14598','2013-03-01','14:40:00',1.16),('14598','2013-03-01','14:45:00',1.09),('14598','2013-03-01','14:50:00',1.03),('14598','2013-03-01','14:55:00',1.03),('14598','2013-03-01','15:00:00',1.12),('14598','2013-03-01','15:05:00',1.18),('14598','2013-03-01','15:10:00',1.12),('14598','2013-03-01','15:15:00',1.01),('14598','2013-02-28','08:30:00',1.04),('14598','2013-02-28','08:35:00',1.15),('14598','2013-02-28','08:40:00',1.24),('14598','2013-02-28','08:45:00',1.38),('14598','2013-02-28','08:50:00',1.51),('14598','2013-02-28','08:55:00',1.59),('14598','2013-02-28','09:00:00',1.67),('14598','2013-02-28','09:05:00',1.81),('14598','2013-02-28','09:10:00',1.91),('14598','2013-02-28','09:15:00',1.99),('14598','2013-02-28','09:20:00',2.1),('14598','2013-02-28','09:25:00',2.2),('14598','2013-02-28','09:30:00',2.3),('14598','2013-02-28','09:35:00',2.4),('14598','2013-02-28','09:40:00',2.38),('14598','2013-02-28','09:45:00',2.46),('14598','2013-02-28','09:50:00',2.57),('14598','2013-02-28','09:55:00',2.71),('14598','2013-02-28','10:00:00',2.78),('14598','2013-02-28','10:05:00',2.88),('14598','2013-02-28','10:10:00',2.88),('14598','2013-02-28','10:15:00',2.98),('14598','2013-02-28','10:20:00',2.9),('14598','2013-02-28','10:25:00',3.14),('14598','2013-02-28','10:30:00',3.02),('14598','2013-02-28','10:35:00',3.3),('14598','2013-02-28','10:40:00',3.36),('14598','2013-02-28','10:45:00',3.42),('14598','2013-02-28','10:50:00',3.44),('14598','2013-02-28','10:55:00',3.52),('14598','2013-02-28','11:00:00',3.55),('14598','2013-02-28','11:05:00',3.6),('14598','2013-02-28','11:10:00',3.65),('14598','2013-02-28','11:15:00',3.72),('14598','2013-02-28','11:20:00',3.72),('14598','2013-02-28','11:25:00',3.76),('14598','2013-02-28','11:30:00',3.79),('14598','2013-02-28','11:35:00',3.81),('14598','2013-02-28','11:40:00',3.79),('14598','2013-02-28','11:45:00',3.82),('14598','2013-02-28','11:50:00',3.88),('14598','2013-02-28','11:55:00',3.9),('14598','2013-02-28','12:00:00',3.9),('14598','2013-02-28','12:05:00',3.88),('14598','2013-02-28','12:10:00',3.86),('14598','2013-02-28','12:15:00',3.83),('14598','2013-02-28','12:20:00',3.88),('14598','2013-02-28','12:25:00',3.63),('14598','2013-02-28','12:30:00',4.15),('14598','2013-02-28','12:35:00',4.04),('14598','2013-02-28','12:40:00',4.1),('14598','2013-02-28','12:45:00',4.09),('14598','2013-02-28','12:50:00',3.79),('14598','2013-02-28','12:55:00',4.01),('14598','2013-02-28','13:00:00',4.03),('14598','2013-02-28','13:05:00',4.1),('14598','2013-02-28','13:10:00',4.12),('14598','2013-02-28','13:15:00',4.14),('14598','2013-02-28','13:20:00',4.07),('14598','2013-02-28','13:25:00',4.03),('14598','2013-02-28','13:30:00',3.98),('14598','2013-02-28','13:35:00',3.98),('14598','2013-02-28','13:40:00',4),('14598','2013-02-28','13:45:00',3.98),('14598','2013-02-28','13:50:00',4),('14598','2013-02-28','13:55:00',4),('14598','2013-02-28','14:00:00',3.94),('14598','2013-02-28','14:05:00',3.9),('14598','2013-02-28','14:10:00',3.86),('14598','2013-02-28','14:15:00',3.83),('14598','2013-02-28','14:20:00',3.82),('14598','2013-02-28','14:25:00',3.65),('14598','2013-02-28','14:30:00',3.76),('14598','2013-02-28','14:35:00',3.69),('14598','2013-02-28','14:40:00',3.64),('14598','2013-02-28','14:45:00',3.56),('14598','2013-02-28','14:50:00',3.47),('14598','2013-02-28','14:55:00',3.38),('14598','2013-02-28','15:00:00',3.31),('14598','2013-02-28','15:05:00',3.25),('14598','2013-02-28','15:10:00',3.17),('14598','2013-02-28','15:15:00',3.09),('14598','2013-02-28','15:20:00',3),('14598','2013-02-28','15:25:00',2.94),('14598','2013-02-28','15:30:00',2.84),('14598','2013-02-28','15:35:00',2.75),('14598','2013-02-28','15:40:00',2.66),('14598','2013-02-28','15:45:00',2.62),('14598','2013-02-28','15:50:00',2.55),('14598','2013-02-28','15:55:00',2.44),('14598','2013-02-28','16:00:00',2.3),('14598','2013-02-28','16:05:00',2.23),('14598','2013-02-28','16:10:00',2.12),('14598','2013-02-28','16:15:00',1.95),('14598','2013-02-28','16:20:00',1.91),('14598','2013-02-28','16:25:00',1.8),('14598','2013-02-28','16:30:00',1.69),('14598','2013-02-28','16:35:00',1.58),('14598','2013-02-28','16:40:00',1.46),('14598','2013-02-28','16:45:00',1.35),('14598','2013-02-28','16:50:00',1.24),('14598','2013-02-28','16:55:00',1.13),('14598','2013-02-28','17:00:00',1.01),('14598','2013-02-27','08:35:00',1.09),('14598','2013-02-27','08:40:00',1.19),('14598','2013-02-27','08:45:00',1.32),('14598','2013-02-27','08:50:00',1.44),('14598','2013-02-27','08:55:00',1.56),('14598','2013-02-27','09:00:00',1.67),('14598','2013-02-27','09:05:00',1.78),('14598','2013-02-27','09:10:00',1.88),('14598','2013-02-27','09:15:00',1.98),('14598','2013-02-27','09:20:00',2.06),('14598','2013-02-27','09:25:00',2.17),('14598','2013-02-27','09:30:00',2.26),('14598','2013-02-27','09:35:00',2.35),('14598','2013-02-27','09:40:00',2.43),('14598','2013-02-27','09:45:00',2.52),('14598','2013-02-27','09:50:00',2.61),('14598','2013-02-27','09:55:00',2.69),('14598','2013-02-27','10:00:00',2.78),('14598','2013-02-27','10:05:00',2.86),('14598','2013-02-27','10:10:00',2.93),('14598','2013-02-27','10:15:00',3.01),('14598','2013-02-27','10:20:00',3.09),('14598','2013-02-27','10:25:00',3.12),('14598','2013-02-27','10:30:00',3.2),('14598','2013-02-27','10:35:00',3.26),('14598','2013-02-27','10:40:00',3.31),('14598','2013-02-27','10:45:00',3.36),('14598','2013-02-27','10:50:00',3.4),('14598','2013-02-27','10:55:00',3.47),('14598','2013-02-27','11:00:00',3.47),('14598','2013-02-27','11:05:00',3.59),('14598','2013-02-27','11:10:00',3.53),('14598','2013-02-27','11:15:00',3.62),('14598','2013-02-27','11:20:00',3.66),('14598','2013-02-27','11:25:00',3.77),('14598','2013-02-27','11:30:00',3.86),('14598','2013-02-27','11:35:00',3.95),('14598','2013-02-27','11:40:00',4.02),('14598','2013-02-27','11:45:00',4.11),('14598','2013-02-27','11:50:00',4.17),('14598','2013-02-27','11:55:00',4.07),('14598','2013-02-27','12:00:00',3.98),('14598','2013-02-27','12:05:00',4.1),('14598','2013-02-27','12:10:00',4.28),('14598','2013-02-27','12:15:00',4.19),('14598','2013-02-27','12:20:00',4.17),('14598','2013-02-27','12:25:00',4.17),('14598','2013-02-27','12:30:00',4.11),('14598','2013-02-27','12:35:00',4.16),('14598','2013-02-27','12:40:00',4.19),('14598','2013-02-27','12:45:00',4.21),('14598','2013-02-27','12:50:00',4.19),('14598','2013-02-27','12:55:00',4.18),('14598','2013-02-27','13:00:00',4.2),('14598','2013-02-27','13:05:00',4.2),('14598','2013-02-27','13:10:00',4.19),('14598','2013-02-27','13:15:00',4.21),('14598','2013-02-27','13:20:00',4.19),('14598','2013-02-27','13:25:00',4.16),('14598','2013-02-27','13:30:00',4.16),('14598','2013-02-27','13:35:00',4.14),('14598','2013-02-27','13:40:00',4.1),('14598','2013-02-27','13:45:00',4.07),('14598','2013-02-27','13:50:00',4.02),('14598','2013-02-27','13:55:00',3.99),('14598','2013-02-27','14:00:00',3.95),('14598','2013-02-27','14:05:00',3.94),('14598','2013-02-27','14:10:00',3.89),('14598','2013-02-27','14:15:00',3.83),('14598','2013-02-27','14:20:00',3.79),('14598','2013-02-27','14:25:00',3.73),('14598','2013-02-27','14:30:00',3.7),('14598','2013-02-27','14:35:00',3.68),('14598','2013-02-27','14:40:00',3.62),('14598','2013-02-27','14:45:00',3.58),('14598','2013-02-27','14:50:00',3.56),('14598','2013-02-27','14:55:00',3.49),('14598','2013-02-27','15:00:00',3.41),('14598','2013-02-27','15:05:00',3.35),('14598','2013-02-27','15:10:00',3.26),('14598','2013-02-27','15:15:00',3.18),('14598','2013-02-27','15:20:00',3.09),('14598','2013-02-27','15:25:00',3.03),('14598','2013-02-27','15:30:00',2.92),('14598','2013-02-27','15:35:00',2.82),('14598','2013-02-27','15:40:00',2.71),('14598','2013-02-27','15:45:00',2.64),('14598','2013-02-27','15:50:00',2.55),('14598','2013-02-27','15:55:00',2.44),('14598','2013-02-27','16:00:00',2.34),('14598','2013-02-27','16:05:00',2.24),('14598','2013-02-27','16:10:00',2.13),('14598','2013-02-27','16:15:00',2.03),('14598','2013-02-27','16:20:00',1.92),('14598','2013-02-27','16:25:00',1.82),('14598','2013-02-27','16:30:00',1.72),('14598','2013-02-27','16:35:00',1.61),('14598','2013-02-27','16:40:00',1.52),('14598','2013-02-27','16:45:00',1.43),('14598','2013-02-27','16:50:00',1.32),('14598','2013-02-27','16:55:00',1.2),('14598','2013-02-27','17:00:00',1.07),('14598','2013-02-26','09:10:00',1.18),('14598','2013-02-26','09:15:00',1.42),('14598','2013-02-26','09:20:00',1.72),('14598','2013-02-26','09:25:00',1.76),('14598','2013-02-26','09:30:00',1.61),('14598','2013-02-26','09:35:00',1.77),('14598','2013-02-26','09:40:00',1.83),('14598','2013-02-26','09:45:00',1.62),('14598','2013-02-26','09:50:00',1.35),('14598','2013-02-26','09:55:00',1.26),('14598','2013-02-26','10:00:00',2.11),('14598','2013-02-26','10:05:00',1.7),('14598','2013-02-26','10:10:00',1.4),('14598','2013-02-26','10:15:00',1.46),('14598','2013-02-26','10:20:00',1.39),('14598','2013-02-26','10:25:00',1.41),('14598','2013-02-26','10:30:00',1.46),('14598','2013-02-26','10:35:00',1.43),('14598','2013-02-26','10:40:00',1.44),('14598','2013-02-26','10:45:00',1.37),('14598','2013-02-26','10:50:00',1.37),('14598','2013-02-26','10:55:00',1.48),('14598','2013-02-26','11:00:00',1.46),('14598','2013-02-26','11:05:00',1.46),('14598','2013-02-26','11:10:00',1.54),('14598','2013-02-26','11:15:00',1.62),('14598','2013-02-26','11:20:00',1.95),('14598','2013-02-26','11:25:00',1.76),('14598','2013-02-26','11:30:00',1.86),('14598','2013-02-26','11:35:00',2.07),('14598','2013-02-26','11:40:00',2.82),('14598','2013-02-26','11:45:00',3.84),('14598','2013-02-26','11:50:00',3.94),('14598','2013-02-26','11:55:00',4.15),('14598','2013-02-26','12:00:00',4.11),('14598','2013-02-26','12:05:00',4.13),('14598','2013-02-26','12:10:00',4.19),('14598','2013-02-26','12:15:00',4.38),('14598','2013-02-26','12:20:00',2.42),('14598','2013-02-26','12:25:00',2.41),('14598','2013-02-26','12:30:00',2.44),('14598','2013-02-26','12:35:00',2.21),('14598','2013-02-26','12:40:00',2.21),('14598','2013-02-26','12:45:00',2.1),('14598','2013-02-26','12:50:00',2.1),('14598','2013-02-26','12:55:00',1.97),('14598','2013-02-26','13:00:00',1.85),('14598','2013-02-26','13:05:00',1.69),('14598','2013-02-26','13:10:00',1.71),('14598','2013-02-26','13:15:00',1.69),('14598','2013-02-26','13:20:00',1.59),('14598','2013-02-26','13:25:00',1.51),('14598','2013-02-26','13:30:00',1.38),('14598','2013-02-26','13:35:00',1.35),('14598','2013-02-26','13:40:00',1.4),('14598','2013-02-26','13:45:00',1.42),('14598','2013-02-26','13:50:00',1.39),('14598','2013-02-26','13:55:00',1.5),('14598','2013-02-26','14:00:00',1.45),('14598','2013-02-26','14:05:00',1.29),('14598','2013-02-26','14:10:00',1.25),('14598','2013-02-26','14:15:00',1.26),('14598','2013-02-26','14:20:00',1.25),('14598','2013-02-26','14:25:00',1.16),('14598','2013-02-26','14:30:00',1),('14598','2013-02-26','14:50:00',1.07),('14598','2013-02-26','14:55:00',1.09),('14598','2013-02-26','15:00:00',1.07),('14598','2013-02-25','09:40:00',1.13),('14598','2013-02-25','09:45:00',1.25),('14598','2013-02-25','09:50:00',1.14),('14598','2013-02-25','09:55:00',1.14),('14598','2013-02-25','10:00:00',1.54),('14598','2013-02-25','10:05:00',1.59),('14598','2013-02-25','10:10:00',1.12),('14598','2013-02-25','10:15:00',1.23),('14598','2013-02-25','10:20:00',1.71),('14598','2013-02-25','10:25:00',2.37),('14598','2013-02-25','10:30:00',2.76),('14598','2013-02-25','10:35:00',3.52),('14598','2013-02-25','10:40:00',3.47),('14598','2013-02-25','10:45:00',2.96),('14598','2013-02-25','10:50:00',3.58),('14598','2013-02-25','10:55:00',2.13),('14598','2013-02-25','11:00:00',3.51),('14598','2013-02-25','11:05:00',2.59),('14598','2013-02-25','11:10:00',2.44),('14598','2013-02-25','11:15:00',2.41),('14598','2013-02-25','11:20:00',1.84),('14598','2013-02-25','11:25:00',1.4),('14598','2013-02-25','11:30:00',1.36),('14598','2013-02-25','11:35:00',1.72),('14598','2013-02-25','11:40:00',1.86),('14598','2013-02-25','11:45:00',1.61),('14598','2013-02-25','11:50:00',1.42),('14598','2013-02-25','11:55:00',1.6),('14598','2013-02-25','12:00:00',1.56),('14598','2013-02-25','12:05:00',1.31),('14598','2013-02-25','12:10:00',1.3),('14598','2013-02-25','12:15:00',1.36),('14598','2013-02-25','12:20:00',1.61),('14598','2013-02-25','12:25:00',1.81),('14598','2013-02-25','12:30:00',1.89),('14598','2013-02-25','12:35:00',2.07),('14598','2013-02-25','12:40:00',1.9),('14598','2013-02-25','12:45:00',1.7),('14598','2013-02-25','12:50:00',1.47),('14598','2013-02-25','12:55:00',1.31),('14598','2013-02-25','13:00:00',1.23),('14598','2013-02-25','13:05:00',1.21),('14598','2013-02-25','13:10:00',1.29),('14598','2013-02-25','13:15:00',1.48),('14598','2013-02-25','13:20:00',2.59),('14598','2013-02-25','13:25:00',2.77),('14598','2013-02-25','13:30:00',2.85),('14598','2013-02-25','13:35:00',3.61),('14598','2013-02-25','13:40:00',5.09),('14598','2013-02-25','13:45:00',4.06),('14598','2013-02-25','13:50:00',2.9),('14598','2013-02-25','13:55:00',3.22),('14598','2013-02-25','14:00:00',2.34),('14598','2013-02-25','14:05:00',1.99),('14598','2013-02-25','14:10:00',1.75),('14598','2013-02-25','14:15:00',1.47),('14598','2013-02-25','14:20:00',1.46),('14598','2013-02-25','14:25:00',1.35),('14598','2013-02-25','14:30:00',1.37),('14598','2013-02-25','14:35:00',1.07),('14598','2013-02-25','14:50:00',1.04),('14598','2013-02-25','14:55:00',1.07),('14598','2013-02-25','15:00:00',1.12),('14598','2013-02-25','15:05:00',1.13),('14598','2013-02-25','15:10:00',1.03),('14598','2013-02-25','15:35:00',1.68),('14598','2013-02-25','15:40:00',2.28),('14598','2013-02-25','15:45:00',2.73),('14598','2013-02-25','15:50:00',3.11),('14598','2013-02-25','15:55:00',3.6),('14598','2013-02-25','16:00:00',3.56),('14598','2013-02-25','16:05:00',3.56),('14598','2013-02-25','16:10:00',3.44),('14598','2013-02-25','16:15:00',2.13),('14598','2013-02-25','16:20:00',1.36),('14598','2013-02-25','16:25:00',1.12),('14598','2013-02-25','16:40:00',1.67),('14598','2013-02-25','16:50:00',1.54),('14598','2013-02-25','16:55:00',1.28),('14598','2013-02-25','17:00:00',1.02),('14598','2013-02-24','09:20:00',1.08),('14598','2013-02-24','09:45:00',1.02),('14598','2013-02-24','10:15:00',1.14),('14598','2013-02-24','10:20:00',1.35),('14598','2013-02-24','10:25:00',1.61),('14598','2013-02-24','10:30:00',1.82),('14598','2013-02-24','10:35:00',1.97),('14598','2013-02-24','10:40:00',1.77),('14598','2013-02-24','10:45:00',1),('14598','2013-02-24','11:20:00',1.09),('14598','2013-02-24','11:25:00',1.01),('14598','2013-02-24','11:30:00',1.06),('14598','2013-02-24','11:55:00',1.72),('14598','2013-02-24','12:00:00',2.01),('14598','2013-02-24','12:05:00',1.97),('14598','2013-02-24','12:10:00',2.14),('14598','2013-02-24','12:15:00',2.33),('14598','2013-02-24','12:20:00',1.95),('14598','2013-02-24','12:25:00',2.06),('14598','2013-02-24','12:30:00',2.88),('14598','2013-02-24','12:35:00',3.17),('14598','2013-02-24','12:40:00',2.57),('14598','2013-02-24','12:45:00',2.85),('14598','2013-02-24','12:50:00',1.78),('14598','2013-02-24','12:55:00',2.86),('14598','2013-02-24','13:00:00',4.74),('14598','2013-02-24','13:05:00',2.07),('14598','2013-02-24','13:10:00',2.04),('14598','2013-02-24','13:15:00',4.2),('14598','2013-02-24','13:20:00',4.55),('14598','2013-02-24','13:25:00',4.67),('14598','2013-02-24','13:30:00',3.69),('14598','2013-02-24','13:35:00',2.19),('14598','2013-02-24','13:40:00',4.01),('14598','2013-02-24','13:45:00',3.39),('14598','2013-02-24','13:50:00',2.37),('14598','2013-02-24','13:55:00',1.29),('14598','2013-02-24','14:00:00',1.33),('14598','2013-02-24','14:05:00',1.17),('14598','2013-02-24','14:20:00',1.42),('14598','2013-02-24','14:25:00',2.73),('14598','2013-02-24','14:30:00',3.64),('14598','2013-02-24','14:35:00',2.88),('14598','2013-02-24','14:40:00',3.86),('14598','2013-02-24','14:45:00',3.06),('14598','2013-02-24','14:50:00',4.31),('14598','2013-02-24','14:55:00',3.98),('14598','2013-02-24','15:00:00',3.34),('14598','2013-02-24','15:05:00',1.92),('14598','2013-02-24','15:10:00',3.19),('14598','2013-02-24','15:15:00',2.34),('14598','2013-02-24','15:20:00',3.26),('14598','2013-02-24','15:25:00',3.08),('14598','2013-02-24','15:30:00',2.94),('14598','2013-02-24','15:35:00',2.14),('14598','2013-02-24','15:40:00',2.8),('14598','2013-02-24','15:45:00',2.75),('14598','2013-02-24','15:50:00',2.54),('14598','2013-02-24','15:55:00',1.76),('14598','2013-02-23','11:20:00',1.14),('14598','2013-02-23','11:25:00',1.07),('14598','2013-02-23','11:35:00',1.07),('14598','2013-02-23','11:40:00',1.27),('14598','2013-02-23','13:50:00',1.01),('14598','2013-02-22','11:55:00',1.01),('14598','2013-02-22','12:00:00',1.11),('14598','2013-02-22','13:45:00',1.11),('14598','2013-02-22','14:10:00',1.48),('14598','2013-02-22','14:15:00',1.78),('14598','2013-02-22','14:35:00',1.01),('14598','2013-02-22','14:40:00',1.29),('14598','2013-02-22','14:45:00',1.25),('14598','2013-02-22','14:50:00',2.79),('14598','2013-02-22','14:55:00',1.74),('14598','2013-02-22','15:35:00',1.13),('14598','2013-02-22','15:40:00',1.53),('14598','2013-02-22','15:50:00',1.58),('14598','2013-02-22','15:55:00',1.26),('14598','2013-02-22','16:05:00',1.05),('14598','2013-02-22','16:15:00',1.33);
INSERT INTO `solarlog` VALUES ('14598','2013-02-21','11:10:00',1.03),('14598','2013-02-21','11:30:00',1.02),('14598','2013-02-21','11:35:00',1.01),('14598','2013-02-21','11:40:00',1.03),('14598','2013-02-21','11:45:00',1.15),('14598','2013-02-21','11:50:00',1.32),('14598','2013-02-21','11:55:00',1.25),('14598','2013-02-21','12:00:00',1.05),('14598','2013-02-21','12:15:00',1.02),('14598','2013-02-21','12:20:00',1.18),('14598','2013-02-21','12:25:00',1.22),('14598','2013-02-21','12:30:00',1.31),('14598','2013-02-21','12:35:00',1.47),('14598','2013-02-21','12:40:00',1.58),('14598','2013-02-21','12:45:00',1.55),('14598','2013-02-21','12:50:00',1.53),('14598','2013-02-21','12:55:00',1.52),('14598','2013-02-21','13:00:00',1.38),('14598','2013-02-21','13:05:00',1.29),('14598','2013-02-21','13:10:00',1.26),('14598','2013-02-21','13:15:00',1.18),('14598','2013-02-21','13:20:00',1.08),('14598','2013-02-21','13:25:00',1.05),('14598','2013-02-21','13:30:00',1.07),('14598','2013-02-21','13:35:00',1.06),('14598','2013-02-21','13:40:00',1.07),('14598','2013-02-21','13:45:00',1.05),('14598','2013-02-21','13:50:00',1.05),('14598','2013-02-21','13:55:00',1.09),('14598','2013-02-21','14:00:00',1.17),('14598','2013-02-21','14:05:00',1.06),('14598','2013-02-21','14:20:00',1.04),('14598','2013-02-21','14:25:00',1.22),('14598','2013-02-21','14:30:00',1.35),('14598','2013-02-21','14:35:00',1.41),('14598','2013-02-21','14:40:00',1.37),('14598','2013-02-21','14:45:00',1.37),('14598','2013-02-21','14:50:00',1.38),('14598','2013-02-21','14:55:00',1.51),('14598','2013-02-21','15:00:00',1.79),('14598','2013-02-21','15:05:00',1.63),('14598','2013-02-21','15:10:00',1.51),('14598','2013-02-21','15:15:00',1.36),('14598','2013-02-21','15:20:00',1.38),('14598','2013-02-21','15:25:00',2.27),('14598','2013-02-21','15:30:00',2.61),('14598','2013-02-21','15:35:00',2.01),('14598','2013-02-21','15:40:00',1.47),('14598','2013-02-21','15:45:00',2.21),('14598','2013-02-21','15:50:00',2.97),('14598','2013-02-21','15:55:00',2.8),('14598','2013-02-21','16:00:00',2.62),('14598','2013-02-21','16:05:00',2.42),('14598','2013-02-21','16:10:00',2.25),('14598','2013-02-21','16:15:00',2.08),('14598','2013-02-21','16:20:00',1.9),('14598','2013-02-21','16:25:00',1.74),('14598','2013-02-21','16:30:00',1.61),('14598','2013-02-21','16:35:00',1.46),('14598','2013-02-21','16:40:00',1.37),('14598','2013-02-21','16:45:00',1.23),('14598','2013-02-21','16:50:00',1.12),('14598','2014-03-23','08:00:00',1.01),('14598','2014-03-23','08:15:00',1.5),('14598','2014-03-23','08:20:00',1.66),('14598','2014-03-23','08:25:00',1),('14598','2014-03-23','08:30:00',1.16),('14598','2014-03-23','08:35:00',1.59),('14598','2014-03-23','08:40:00',1.76),('14598','2014-03-23','08:45:00',2.09),('14598','2014-03-23','08:50:00',1.96),('14598','2014-03-23','08:55:00',2.35),('14598','2014-03-23','09:00:00',1.32),('14598','2014-03-23','09:40:00',1.1),('14598','2014-03-23','12:40:00',1.28),('14598','2014-03-23','13:15:00',1.5),('14598','2014-03-23','13:20:00',1.58),('14598','2014-03-23','13:25:00',1.1),('14598','2014-03-23','13:45:00',1.2),('14598','2014-03-23','14:35:00',1.54),('14598','2014-03-23','14:40:00',1.13),('14598','2014-03-23','15:00:00',1.06),('14598','2014-03-23','15:25:00',1.99),('14598','2014-03-23','15:30:00',1.21),('14598','2014-03-23','17:05:00',1.75),('14598','2014-03-23','17:10:00',1.19),('14598','2013-02-20','08:40:00',1.05),('14598','2013-02-20','08:45:00',1.17),('14598','2013-02-20','08:50:00',1.33),('14598','2013-02-20','08:55:00',1.53),('14598','2013-02-20','09:00:00',1.63),('14598','2013-02-20','09:05:00',1.71),('14598','2013-02-20','09:10:00',1.78),('14598','2013-02-20','09:15:00',1.11),('14598','2013-02-20','09:25:00',1.67),('14598','2013-02-20','09:30:00',2.14),('14598','2013-02-20','09:35:00',2.1),('14598','2013-02-20','09:40:00',1.02),('14598','2013-02-20','09:50:00',1.41),('14598','2013-02-20','09:55:00',1.38),('14598','2013-02-20','10:00:00',1.94),('14598','2013-02-20','10:05:00',1.59),('14598','2013-02-20','10:10:00',1.59),('14598','2013-02-20','10:15:00',2.95),('14598','2013-02-20','10:20:00',1.62),('14598','2013-02-20','10:25:00',3.46),('14598','2013-02-20','10:30:00',3.28),('14598','2013-02-20','10:35:00',3.24),('14598','2013-02-20','10:40:00',2.07),('14598','2013-02-20','10:45:00',1.96),('14598','2013-02-20','10:55:00',2.51),('14598','2013-02-20','11:00:00',2.15),('14598','2013-02-20','11:05:00',4),('14598','2013-02-20','11:10:00',3.69),('14598','2013-02-20','11:15:00',3.82),('14598','2013-02-20','11:20:00',3.82),('14598','2013-02-20','11:25:00',3.97),('14598','2013-02-20','11:30:00',3.4),('14598','2013-02-20','11:35:00',2.01),('14598','2013-02-20','11:40:00',1.73),('14598','2013-02-20','11:45:00',2.29),('14598','2013-02-20','11:50:00',3.1),('14598','2013-02-20','11:55:00',1.15),('14598','2013-02-20','12:00:00',1.23),('14598','2013-02-20','12:05:00',1.74),('14598','2013-02-20','12:10:00',1.5),('14598','2013-02-20','12:15:00',1.41),('14598','2013-02-20','12:20:00',1.7),('14598','2013-02-20','12:25:00',1.89),('14598','2013-02-20','12:30:00',2.83),('14598','2013-02-20','12:35:00',2.57),('14598','2013-02-20','12:40:00',3.39),('14598','2013-02-20','12:45:00',2.81),('14598','2013-02-20','12:50:00',2.47),('14598','2013-02-20','12:55:00',1.72),('14598','2013-02-20','13:00:00',3.21),('14598','2013-02-20','13:05:00',3.96),('14598','2013-02-20','13:10:00',2.32),('14598','2013-02-20','13:15:00',1.35),('14598','2013-02-20','13:20:00',2.04),('14598','2013-02-20','13:25:00',3.65),('14598','2013-02-20','13:30:00',4.85),('14598','2013-02-20','13:35:00',4.72),('14598','2013-02-20','13:40:00',4.09),('14598','2013-02-20','13:45:00',4.11),('14598','2013-02-20','13:50:00',3.77),('14598','2013-02-20','13:55:00',3.69),('14598','2013-02-20','14:00:00',3.85),('14598','2013-02-20','14:05:00',3.35),('14598','2013-02-20','14:10:00',2.09),('14598','2013-02-20','14:15:00',2.38),('14598','2013-02-20','14:20:00',1.32),('14598','2013-02-20','14:25:00',1.33),('14598','2013-02-20','14:30:00',2.5),('14598','2013-02-20','14:35:00',1.98),('14598','2013-02-20','14:40:00',1.6),('14598','2013-02-20','14:45:00',1.87),('14598','2013-02-20','14:50:00',2.67),('14598','2013-02-20','14:55:00',2.67),('14598','2013-02-20','15:00:00',2.56),('14598','2013-02-20','15:05:00',2.77),('14598','2013-02-20','15:10:00',2.41),('14598','2013-02-20','15:15:00',2.5),('14598','2013-02-20','15:20:00',2.93),('14598','2013-02-20','15:25:00',2.4),('14598','2013-02-20','15:30:00',1.68),('14598','2013-02-20','15:35:00',1.45),('14598','2013-02-20','15:40:00',1.36),('14598','2013-02-20','15:45:00',1.48),('14598','2013-02-20','15:50:00',1.36),('14598','2013-02-20','15:55:00',1.66),('14598','2013-02-20','16:00:00',1.29),('14598','2013-02-20','16:05:00',1.59),('14598','2013-02-20','16:10:00',1.3),('14598','2013-02-20','16:15:00',2.14),('14598','2013-02-20','16:20:00',2.26),('14598','2013-02-20','16:25:00',2.07),('14598','2013-02-20','16:30:00',1.71),('14598','2013-02-20','16:40:00',1.12),('14598','2013-02-20','16:55:00',1.21),('14598','2013-02-20','17:00:00',1.11),('14598','2013-02-19','08:45:00',1.1),('14598','2013-02-19','08:50:00',1.22),('14598','2013-02-19','08:55:00',1.35),('14598','2013-02-19','09:00:00',1.46),('14598','2013-02-19','09:05:00',1.57),('14598','2013-02-19','09:10:00',1.69),('14598','2013-02-19','09:15:00',1.8),('14598','2013-02-19','09:20:00',1.9),('14598','2013-02-19','09:25:00',2),('14598','2013-02-19','09:30:00',2.1),('14598','2013-02-19','09:35:00',2.19),('14598','2013-02-19','09:40:00',2.3),('14598','2013-02-19','09:45:00',2.39),('14598','2013-02-19','09:50:00',2.46),('14598','2013-02-19','09:55:00',2.55),('14598','2013-02-19','10:00:00',2.64),('14598','2013-02-19','10:05:00',2.72),('14598','2013-02-19','10:10:00',2.8),('14598','2013-02-19','10:15:00',2.88),('14598','2013-02-19','10:20:00',2.95),('14598','2013-02-19','10:25:00',3.02),('14598','2013-02-19','10:30:00',3.1),('14598','2013-02-19','10:35:00',3.16),('14598','2013-02-19','10:40:00',3.22),('14598','2013-02-19','10:45:00',3.29),('14598','2013-02-19','10:50:00',3.34),('14598','2013-02-19','10:55:00',3.38),('14598','2013-02-19','11:00:00',3.4),('14598','2013-02-19','11:05:00',3.47),('14598','2013-02-19','11:10:00',3.51),('14598','2013-02-19','11:15:00',3.58),('14598','2013-02-19','11:20:00',3.59),('14598','2013-02-19','11:25:00',3.63),('14598','2013-02-19','11:30:00',3.68),('14598','2013-02-19','11:35:00',3.74),('14598','2013-02-19','11:40:00',3.74),('14598','2013-02-19','11:45:00',3.78),('14598','2013-02-19','11:50:00',3.83),('14598','2013-02-19','11:55:00',3.85),('14598','2013-02-19','12:00:00',3.84),('14598','2013-02-19','12:05:00',3.87),('14598','2013-02-19','12:10:00',3.86),('14598','2013-02-19','12:15:00',3.89),('14598','2013-02-19','12:20:00',3.91),('14598','2013-02-19','12:25:00',3.89),('14598','2013-02-19','12:30:00',3.89),('14598','2013-02-19','12:35:00',3.95),('14598','2013-02-19','12:40:00',3.94),('14598','2013-02-19','12:45:00',4),('14598','2013-02-19','12:50:00',4.04),('14598','2013-02-19','12:55:00',4.07),('14598','2013-02-19','13:00:00',4.07),('14598','2013-02-19','13:05:00',4.06),('14598','2013-02-19','13:10:00',4.06),('14598','2013-02-19','13:15:00',4.05),('14598','2013-02-19','13:20:00',4.02),('14598','2013-02-19','13:25:00',3.99),('14598','2013-02-19','13:30:00',4.02),('14598','2013-02-19','13:35:00',3.99),('14598','2013-02-19','13:40:00',3.97),('14598','2013-02-19','13:45:00',3.95),('14598','2013-02-19','13:50:00',3.87),('14598','2013-02-19','13:55:00',3.85),('14598','2013-02-19','14:00:00',3.83),('14598','2013-02-19','14:05:00',3.78),('14598','2013-02-19','14:10:00',3.74),('14598','2013-02-19','14:15:00',3.71),('14598','2013-02-19','14:20:00',3.65),('14598','2013-02-19','14:25:00',3.62),('14598','2013-02-19','14:30:00',3.55),('14598','2013-02-19','14:35:00',3.52),('14598','2013-02-19','14:40:00',3.46),('14598','2013-02-19','14:45:00',3.4),('14598','2013-02-19','14:50:00',3.34),('14598','2013-02-19','14:55:00',3.28),('14598','2013-02-19','15:00:00',3.2),('14598','2013-02-19','15:05:00',3.14),('14598','2013-02-19','15:10:00',3.06),('14598','2013-02-19','15:15:00',3),('14598','2013-02-19','15:20:00',2.91),('14598','2013-02-19','15:25:00',2.83),('14598','2013-02-19','15:30:00',2.77),('14598','2013-02-19','15:35:00',2.68),('14598','2013-02-19','15:40:00',2.6),('14598','2013-02-19','15:45:00',2.53),('14598','2013-02-19','15:50:00',2.46),('14598','2013-02-19','15:55:00',2.35),('14598','2013-02-19','16:00:00',2.27),('14598','2013-02-19','16:05:00',2.16),('14598','2013-02-19','16:10:00',2.06),('14598','2013-02-19','16:15:00',1.96),('14598','2013-02-19','16:20:00',1.85),('14598','2013-02-19','16:25:00',1.72),('14598','2013-02-19','16:30:00',1.61),('14598','2013-02-19','16:35:00',1.49),('14598','2013-02-19','16:40:00',1.37),('14598','2013-02-19','16:45:00',1.25),('14598','2013-02-19','16:50:00',1.13),('14598','2013-02-19','16:55:00',1),('14598','2013-02-18','08:45:00',1.15),('14598','2013-02-18','08:50:00',1.21),('14598','2013-02-18','08:55:00',1.12),('14598','2013-02-18','09:00:00',1.38),('14598','2013-02-18','09:05:00',1.57),('14598','2013-02-18','09:10:00',1.54),('14598','2013-02-18','09:15:00',1.42),('14598','2013-02-18','09:20:00',1.57),('14598','2013-02-18','09:25:00',1.45),('14598','2013-02-18','09:30:00',2.03),('14598','2013-02-18','09:35:00',1.31),('14598','2013-02-18','09:40:00',1.82),('14598','2013-02-18','09:45:00',1.21),('14598','2013-02-18','09:50:00',1.82),('14598','2013-02-18','09:55:00',1.25),('14598','2013-02-18','10:00:00',1.23),('14598','2013-02-18','10:05:00',1.29),('14598','2013-02-18','10:10:00',1.19),('14598','2013-02-18','10:15:00',1.16),('14598','2013-02-18','10:20:00',1.53),('14598','2013-02-18','10:25:00',1.52),('14598','2013-02-18','10:30:00',1.88),('14598','2013-02-18','10:35:00',3.49),('14598','2013-02-18','10:40:00',2.08),('14598','2013-02-18','10:45:00',1.82),('14598','2013-02-18','10:50:00',2.48),('14598','2013-02-18','10:55:00',2.3),('14598','2013-02-18','11:00:00',2.07),('14598','2013-02-18','11:05:00',2.1),('14598','2013-02-18','11:10:00',1.68),('14598','2013-02-18','11:15:00',1.73),('14598','2013-02-18','11:20:00',1.79),('14598','2013-02-18','11:25:00',1.76),('14598','2013-02-18','11:30:00',1.95),('14598','2013-02-18','11:35:00',1.99),('14598','2013-02-18','11:40:00',1.85),('14598','2013-02-18','11:45:00',1.76),('14598','2013-02-18','11:50:00',1.77),('14598','2013-02-18','11:55:00',1.79),('14598','2013-02-18','12:00:00',1.73),('14598','2013-02-18','12:05:00',1.77),('14598','2013-02-18','12:10:00',2.48),('14598','2013-02-18','12:15:00',1.8),('14598','2013-02-18','12:20:00',1.73),('14598','2013-02-18','12:25:00',1.72),('14598','2013-02-18','12:30:00',1.42),('14598','2013-02-18','12:35:00',1.65),('14598','2013-02-18','12:40:00',1.69),('14598','2013-02-18','12:45:00',1.89),('14598','2013-02-18','12:50:00',2),('14598','2013-02-18','12:55:00',1.94),('14598','2013-02-18','13:00:00',2.5),('14598','2013-02-18','13:05:00',2.29),('14598','2013-02-18','13:10:00',1.68),('14598','2013-02-18','13:15:00',1.32),('14598','2013-02-18','13:20:00',1.2),('14598','2013-02-18','13:25:00',1.19),('14598','2013-02-18','13:30:00',1.19),('14598','2013-02-18','13:35:00',1.39),('14598','2013-02-18','13:40:00',1.77),('14598','2013-02-18','13:45:00',1.93),('14598','2013-02-18','13:50:00',2.17),('14598','2013-02-18','13:55:00',2.56),('14598','2013-02-18','14:00:00',2.81),('14598','2013-02-18','14:05:00',2.23),('14598','2013-02-18','14:10:00',1.46),('14598','2013-02-18','14:15:00',1.24),('14598','2013-02-18','14:20:00',1.24),('14598','2013-02-18','14:25:00',1.64),('14598','2013-02-18','14:30:00',2.63),('14598','2013-02-18','14:35:00',1.94),('14598','2013-02-18','14:40:00',1.29),('14598','2013-02-18','14:45:00',1.4),('14598','2013-02-18','14:50:00',1.44),('14598','2013-02-18','14:55:00',1.19),('14598','2013-02-18','15:00:00',1.07),('14598','2013-02-17','08:45:00',1.05),('14598','2013-02-17','08:50:00',1.15),('14598','2013-02-17','08:55:00',1.26),('14598','2013-02-17','09:00:00',1.37),('14598','2013-02-17','09:05:00',1.47),('14598','2013-02-17','09:10:00',1.55),('14598','2013-02-17','09:15:00',1.65),('14598','2013-02-17','09:20:00',1.75),('14598','2013-02-17','09:25:00',1.84),('14598','2013-02-17','09:30:00',1.94),('14598','2013-02-17','09:35:00',2.03),('14598','2013-02-17','09:40:00',2.11),('14598','2013-02-17','09:45:00',2.2),('14598','2013-02-17','09:50:00',2.28),('14598','2013-02-17','09:55:00',2.37),('14598','2013-02-17','10:00:00',2.46),('14598','2013-02-17','10:05:00',2.55),('14598','2013-02-17','10:10:00',2.62),('14598','2013-02-17','10:15:00',2.69),('14598','2013-02-17','10:20:00',2.75),('14598','2013-02-17','10:25:00',2.82),('14598','2013-02-17','10:30:00',2.89),('14598','2013-02-17','10:35:00',2.97),('14598','2013-02-17','10:40:00',3.03),('14598','2013-02-17','10:45:00',3.08),('14598','2013-02-17','10:50:00',3.15),('14598','2013-02-17','10:55:00',3.18),('14598','2013-02-17','11:00:00',3.23),('14598','2013-02-17','11:05:00',3.28),('14598','2013-02-17','11:10:00',3.34),('14598','2013-02-17','11:15:00',3.39),('14598','2013-02-17','11:20:00',3.45),('14598','2013-02-17','11:25:00',3.47),('14598','2013-02-17','11:30:00',3.5),('14598','2013-02-17','11:35:00',3.56),('14598','2013-02-17','11:40:00',3.62),('14598','2013-02-17','11:45:00',3.54),('14598','2013-02-17','11:50:00',3.63),('14598','2013-02-17','11:55:00',3.61),('14598','2013-02-17','12:00:00',3.64),('14598','2013-02-17','12:05:00',3.63),('14598','2013-02-17','12:10:00',3.62),('14598','2013-02-17','12:15:00',3.57),('14598','2013-02-17','12:20:00',3.63),('14598','2013-02-17','12:25:00',3.71),('14598','2013-02-17','12:30:00',3.7),('14598','2013-02-17','12:35:00',3.69),('14598','2013-02-17','12:40:00',3.72),('14598','2013-02-17','12:45:00',3.75),('14598','2013-02-17','12:50:00',3.79),('14598','2013-02-17','12:55:00',3.79),('14598','2013-02-17','13:00:00',3.79),('14598','2013-02-17','13:05:00',3.82),('14598','2013-02-17','13:10:00',3.82),('14598','2013-02-17','13:15:00',3.79),('14598','2013-02-17','13:20:00',3.78),('14598','2013-02-17','13:25:00',3.76),('14598','2013-02-17','13:30:00',3.77),('14598','2013-02-17','13:35:00',3.76),('14598','2013-02-17','13:40:00',3.72),('14598','2013-02-17','13:45:00',3.68),('14598','2013-02-17','13:50:00',3.66),('14598','2013-02-17','13:55:00',3.66),('14598','2013-02-17','14:00:00',3.63),('14598','2013-02-17','14:05:00',3.62),('14598','2013-02-17','14:10:00',3.58),('14598','2013-02-17','14:15:00',3.56),('14598','2013-02-17','14:20:00',3.53),('14598','2013-02-17','14:25:00',3.49),('14598','2013-02-17','14:30:00',3.46),('14598','2013-02-17','14:35:00',3.45),('14598','2013-02-17','14:40:00',3.46),('14598','2013-02-17','14:45:00',2.14),('14598','2013-02-17','14:50:00',2.35),('14598','2013-02-17','14:55:00',3.33),('14598','2013-02-17','15:00:00',3.21),('14598','2013-02-17','15:05:00',3.18),('14598','2013-02-17','15:10:00',3.17),('14598','2013-02-17','15:15:00',1.56),('14598','2013-02-17','15:20:00',1.77),('14598','2013-02-17','15:25:00',1.75),('14598','2013-02-17','15:30:00',1.77),('14598','2013-02-17','15:35:00',2.71),('14598','2013-02-17','15:40:00',1.2),('14598','2013-02-17','16:00:00',1.01),('14598','2013-02-17','16:05:00',1.13),('14598','2013-02-17','16:10:00',1.04),('14598','2013-02-16','08:45:00',1.01),('14598','2013-02-16','08:50:00',1.12),('14598','2013-02-16','08:55:00',1.24),('14598','2013-02-16','09:00:00',1.35),('14598','2013-02-16','09:05:00',1.43),('14598','2013-02-16','09:10:00',1.52),('14598','2013-02-16','09:15:00',1.61),('14598','2013-02-16','09:20:00',1.7),('14598','2013-02-16','09:25:00',1.8),('14598','2013-02-16','09:30:00',1.89),('14598','2013-02-16','09:35:00',1.99),('14598','2013-02-16','09:40:00',2.07),('14598','2013-02-16','09:45:00',2.15),('14598','2013-02-16','09:50:00',2.23),('14598','2013-02-16','09:55:00',2.33),('14598','2013-02-16','10:00:00',2.42),('14598','2013-02-16','10:05:00',2.51),('14598','2013-02-16','10:10:00',2.59),('14598','2013-02-16','10:15:00',2.66),('14598','2013-02-16','10:20:00',2.73),('14598','2013-02-16','10:25:00',2.81),('14598','2013-02-16','10:30:00',2.86),('14598','2013-02-16','10:35:00',2.91),('14598','2013-02-16','10:40:00',2.95),('14598','2013-02-16','10:45:00',3),('14598','2013-02-16','10:50:00',3.11),('14598','2013-02-16','10:55:00',3.12),('14598','2013-02-16','11:00:00',3.19),('14598','2013-02-16','11:05:00',3.24),('14598','2013-02-16','11:10:00',3.29),('14598','2013-02-16','11:15:00',3.35),('14598','2013-02-16','11:20:00',3.4),('14598','2013-02-16','11:25:00',3.47),('14598','2013-02-16','11:30:00',3.53),('14598','2013-02-16','11:35:00',3.81),('14598','2013-02-16','11:40:00',3.64),('14598','2013-02-16','11:45:00',3.55),('14598','2013-02-16','11:50:00',3.65),('14598','2013-02-16','11:55:00',3.7),('14598','2013-02-16','12:00:00',3.72),('14598','2013-02-16','12:05:00',3.54),('14598','2013-02-16','12:10:00',3.74),('14598','2013-02-16','12:15:00',3.58),('14598','2013-02-16','12:20:00',3.73),('14598','2013-02-16','12:25:00',3.74),('14598','2013-02-16','12:30:00',3.88),('14598','2013-02-16','12:35:00',3.9),('14598','2013-02-16','12:40:00',2.94),('14598','2013-02-16','12:45:00',3.51),('14598','2013-02-16','12:50:00',3.94),('14598','2013-02-16','12:55:00',3.95),('14598','2013-02-16','13:00:00',4.01),('14598','2013-02-16','13:05:00',2.36),('14598','2013-02-16','13:10:00',4.05),('14598','2013-02-16','13:15:00',3.71),('14598','2013-02-16','13:20:00',4.28),('14598','2013-02-16','13:25:00',2.79),('14598','2013-02-16','13:30:00',2),('14598','2013-02-16','13:35:00',1.15),('14598','2013-02-16','13:40:00',1.16),('14598','2013-02-16','13:45:00',1.22),('14598','2013-02-16','13:50:00',1.17),('14598','2013-02-16','14:25:00',1.22),('14598','2013-02-16','14:30:00',1.38),('14598','2013-02-16','14:35:00',1.51),('14598','2013-02-16','14:40:00',1.92),('14598','2013-02-16','14:45:00',2.97),('14598','2013-02-16','14:50:00',2.38),('14598','2013-02-16','14:55:00',2.01),('14598','2013-02-16','15:00:00',1.27),('14598','2013-02-15','08:55:00',1.17),('14598','2013-02-15','09:00:00',1.34),('14598','2013-02-15','09:05:00',1.52),('14598','2013-02-15','09:10:00',1.68),('14598','2013-02-15','09:15:00',1.79),('14598','2013-02-15','09:20:00',1.7),('14598','2013-02-15','09:25:00',1.99),('14598','2013-02-15','09:30:00',2.33),('14598','2013-02-15','09:35:00',2.65),('14598','2013-02-15','09:40:00',2.75),('14598','2013-02-15','09:45:00',2.26),('14598','2013-02-15','09:50:00',1.51),('14598','2013-02-15','09:55:00',1.97),('14598','2013-02-15','10:00:00',1.66),('14598','2013-02-15','10:05:00',1.52),('14598','2013-02-15','10:10:00',2.48),('14598','2013-02-15','10:15:00',3.27),('14598','2013-02-15','10:20:00',2.42),('14598','2013-02-15','10:25:00',2.02),('14598','2013-02-15','10:30:00',1.97),('14598','2013-02-15','10:35:00',1.59),('14598','2013-02-15','10:40:00',1.65),('14598','2013-02-15','10:45:00',2.56),('14598','2013-02-15','10:50:00',3.54),('14598','2013-02-15','10:55:00',3.51),('14598','2013-02-15','11:00:00',2.95),('14598','2013-02-15','11:05:00',3.61),('14598','2013-02-15','11:10:00',3.39),('14598','2013-02-15','11:15:00',3.73),('14598','2013-02-15','11:20:00',3.93),('14598','2013-02-15','11:25:00',3.24),('14598','2013-02-15','11:30:00',3.3),('14598','2013-02-15','11:35:00',2.58),('14598','2013-02-15','11:40:00',3.53),('14598','2013-02-15','11:45:00',3.9),('14598','2013-02-15','11:50:00',3.71),('14598','2013-02-15','11:55:00',3.76),('14598','2013-02-15','12:00:00',3.88),('14598','2013-02-15','12:05:00',3.8),('14598','2013-02-15','12:10:00',3.87),('14598','2013-02-15','12:15:00',3.86),('14598','2013-02-15','12:20:00',3.86),('14598','2013-02-15','12:25:00',3.96),('14598','2013-02-15','12:30:00',3.95),('14598','2013-02-15','12:35:00',4.02),('14598','2013-02-15','12:40:00',4.09),('14598','2013-02-15','12:45:00',3.69),('14598','2013-02-15','12:50:00',3.01),('14598','2013-02-15','12:55:00',3.11),('14598','2013-02-15','13:00:00',3.95),('14598','2013-02-15','13:05:00',3.43),('14598','2013-02-15','13:10:00',4.05),('14598','2013-02-15','13:15:00',3.64),('14598','2013-02-15','13:20:00',2.71),('14598','2013-02-15','13:25:00',4.07),('14598','2013-02-15','13:30:00',4.21),('14598','2013-02-15','13:35:00',4.02),('14598','2013-02-15','13:40:00',3.75),('14598','2013-02-15','13:45:00',3.9),('14598','2013-02-15','13:50:00',4.08),('14598','2013-02-15','13:55:00',3.74),('14598','2013-02-15','14:00:00',3.64),('14598','2013-02-15','14:05:00',3.32),('14598','2013-02-15','14:10:00',3.6),('14598','2013-02-15','14:15:00',2.82),('14598','2013-02-15','14:20:00',2.82),('14598','2013-02-15','14:25:00',2.89),('14598','2013-02-15','14:30:00',2.83),('14598','2013-02-15','14:35:00',2.16),('14598','2013-02-15','14:40:00',2.14),('14598','2013-02-15','14:45:00',1.4),('14598','2013-02-15','14:50:00',2.25),('14598','2013-02-15','14:55:00',2.2),('14598','2013-02-15','15:00:00',2.34),('14598','2013-02-15','15:05:00',2.56),('14598','2013-02-15','15:10:00',2.26),('14598','2013-02-15','15:15:00',2),('14598','2013-02-15','15:20:00',2.08),('14598','2013-02-15','15:25:00',1.36),('14598','2013-02-15','15:30:00',1.15),('14598','2013-02-15','15:35:00',1.17),('14598','2013-02-15','15:40:00',1.08),('14598','2013-02-14','08:45:00',1.05),('14598','2013-02-14','08:50:00',1.14),('14598','2013-02-14','08:55:00',1.22),('14598','2013-02-14','09:00:00',1.27),('14598','2013-02-14','09:05:00',1.42),('14598','2013-02-14','09:10:00',1.57),('14598','2013-02-14','09:15:00',1.68),('14598','2013-02-14','09:20:00',1.76),('14598','2013-02-14','09:25:00',1.87),('14598','2013-02-14','09:30:00',1.96),('14598','2013-02-14','09:35:00',2.06),('14598','2013-02-14','09:40:00',2.15),('14598','2013-02-14','09:45:00',2.24),('14598','2013-02-14','09:50:00',2.33),('14598','2013-02-14','09:55:00',2.42),('14598','2013-02-14','10:00:00',2.5),('14598','2013-02-14','10:05:00',2.59),('14598','2013-02-14','10:10:00',2.68),('14598','2013-02-14','10:15:00',2.76),('14598','2013-02-14','10:20:00',2.84),('14598','2013-02-14','10:25:00',2.91),('14598','2013-02-14','10:30:00',2.98),('14598','2013-02-14','10:35:00',3.05),('14598','2013-02-14','10:40:00',3.13),('14598','2013-02-14','10:45:00',3.19),('14598','2013-02-14','10:50:00',3.25),('14598','2013-02-14','10:55:00',3.31),('14598','2013-02-14','11:00:00',3.37),('14598','2013-02-14','11:05:00',3.37),('14598','2013-02-14','11:10:00',3.45),('14598','2013-02-14','11:15:00',3.51),('14598','2013-02-14','11:20:00',3.56),('14598','2013-02-14','11:25:00',3.61),('14598','2013-02-14','11:30:00',3.66),('14598','2013-02-14','11:35:00',3.69),('14598','2013-02-14','11:40:00',3.71),('14598','2013-02-14','11:45:00',3.76),('14598','2013-02-14','11:50:00',3.79),('14598','2013-02-14','11:55:00',3.81),('14598','2013-02-14','12:00:00',3.85),('14598','2013-02-14','12:05:00',3.77),('14598','2013-02-14','12:10:00',3.89),('14598','2013-02-14','12:15:00',3.91),('14598','2013-02-14','12:20:00',3.91),('14598','2013-02-14','12:25:00',3.93),('14598','2013-02-14','12:30:00',3.93),('14598','2013-02-14','12:35:00',3.94),('14598','2013-02-14','12:40:00',3.94),('14598','2013-02-14','12:45:00',3.93),('14598','2013-02-14','12:50:00',3.94),('14598','2013-02-14','12:55:00',3.94),('14598','2013-02-14','13:00:00',3.94),('14598','2013-02-14','13:05:00',3.94),('14598','2013-02-14','13:10:00',3.93),('14598','2013-02-14','13:15:00',3.92),('14598','2013-02-14','13:20:00',3.9),('14598','2013-02-14','13:25:00',3.88),('14598','2013-02-14','13:30:00',3.86),('14598','2013-02-14','13:35:00',3.83),('14598','2013-02-14','13:40:00',3.8),('14598','2013-02-14','13:45:00',3.78),('14598','2013-02-14','13:50:00',3.76),('14598','2013-02-14','13:55:00',3.73),('14598','2013-02-14','14:00:00',3.68),('14598','2013-02-14','14:05:00',3.61),('14598','2013-02-14','14:10:00',3.61),('14598','2013-02-14','14:15:00',3.56),('14598','2013-02-14','14:20:00',3.52),('14598','2013-02-14','14:25:00',3.46),('14598','2013-02-14','14:30:00',3.42),('14598','2013-02-14','14:35:00',3.36),('14598','2013-02-14','14:40:00',3.32),('14598','2013-02-14','14:45:00',3.24),('14598','2013-02-14','14:50:00',3.2),('14598','2013-02-14','14:55:00',3.14),('14598','2013-02-14','15:00:00',3.08),('14598','2013-02-14','15:05:00',3.01),('14598','2013-02-14','15:10:00',2.94),('14598','2013-02-14','15:15:00',2.85),('14598','2013-02-14','15:20:00',2.73),('14598','2013-02-14','15:25:00',2.66),('14598','2013-02-14','15:30:00',2.58),('14598','2013-02-14','15:35:00',2.49),('14598','2013-02-14','15:40:00',2.44),('14598','2013-02-14','15:45:00',2.35),('14598','2013-02-14','15:50:00',2.26),('14598','2013-02-14','15:55:00',2.16),('14598','2013-02-14','16:00:00',2.05),('14598','2013-02-14','16:05:00',1.95),('14598','2013-02-14','16:10:00',1.85),('14598','2013-02-14','16:15:00',1.74),('14598','2013-02-14','16:20:00',1.64),('14598','2013-02-14','16:25:00',1.54),('14598','2013-02-14','16:30:00',1.43),('14598','2013-02-14','16:35:00',1.31),('14598','2013-02-14','16:40:00',1.19),('14598','2013-02-14','16:45:00',1.03),('14598','2013-02-13','09:00:00',1.02),('14598','2013-02-13','09:05:00',1.09),('14598','2013-02-13','09:10:00',1.13),('14598','2013-02-13','09:15:00',1.26),('14598','2013-02-13','09:20:00',1.33),('14598','2013-02-13','09:25:00',1.4),('14598','2013-02-13','09:30:00',1.52),('14598','2013-02-13','09:35:00',1.67),('14598','2013-02-13','09:40:00',1.71),('14598','2013-02-13','09:45:00',1.97),('14598','2013-02-13','09:50:00',2.22),('14598','2013-02-13','09:55:00',2.41),('14598','2013-02-13','10:00:00',2.5),('14598','2013-02-13','10:05:00',2.34),('14598','2013-02-13','10:10:00',2.29),('14598','2013-02-13','10:15:00',2.26),('14598','2013-02-13','10:20:00',2.16),('14598','2013-02-13','10:25:00',2.2),('14598','2013-02-13','10:30:00',2.62),('14598','2013-02-13','10:35:00',2.94),('14598','2013-02-13','10:40:00',2.95),('14598','2013-02-13','10:45:00',2.7),('14598','2013-02-13','10:50:00',2.92),('14598','2013-02-13','10:55:00',3.26),('14598','2013-02-13','11:00:00',3.26),('14598','2013-02-13','11:05:00',3.2),('14598','2013-02-13','11:10:00',3.27),('14598','2013-02-13','11:15:00',3.3),('14598','2013-02-13','11:20:00',3.1),('14598','2013-02-13','11:25:00',3.42),('14598','2013-02-13','11:30:00',3.69),('14598','2013-02-13','11:35:00',3.82),('14598','2013-02-13','11:40:00',3.81),('14598','2013-02-13','11:45:00',3.68),('14598','2013-02-13','11:50:00',3.46),('14598','2013-02-13','11:55:00',3.2),('14598','2013-02-13','12:00:00',3.43),('14598','2013-02-13','12:05:00',3.89),('14598','2013-02-13','12:10:00',3.55),('14598','2013-02-13','12:15:00',3.57),('14598','2013-02-13','12:20:00',3.89),('14598','2013-02-13','12:25:00',3.83),('14598','2013-02-13','12:30:00',3.86),('14598','2013-02-13','12:35:00',3.77),('14598','2013-02-13','12:40:00',3.79),('14598','2013-02-13','12:45:00',3.69),('14598','2013-02-13','12:50:00',3.95),('14598','2013-02-13','12:55:00',3.86),('14598','2013-02-13','13:00:00',4.31),('14598','2013-02-13','13:05:00',4.42),('14598','2013-02-13','13:10:00',3.89),('14598','2013-02-13','13:15:00',4.1),('14598','2013-02-13','13:20:00',4.19),('14598','2013-02-13','13:25:00',4.17),('14598','2013-02-13','13:30:00',4),('14598','2013-02-13','13:35:00',3.87),('14598','2013-02-13','13:40:00',3.7),('14598','2013-02-13','13:45:00',3.71),('14598','2013-02-13','13:50:00',3.27),('14598','2013-02-13','13:55:00',3.14),('14598','2013-02-13','14:00:00',3.34),('14598','2013-02-13','14:05:00',3.51),('14598','2013-02-13','14:10:00',3.26),('14598','2013-02-13','14:15:00',3.46),('14598','2013-02-13','14:20:00',3.63),('14598','2013-02-13','14:25:00',3.59),('14598','2013-02-13','14:30:00',3.57),('14598','2013-02-13','14:35:00',3.45),('14598','2013-02-13','14:40:00',3.43),('14598','2013-02-13','14:45:00',3.13),('14598','2013-02-13','14:50:00',2.84),('14598','2013-02-13','14:55:00',2.71),('14598','2013-02-13','15:00:00',3.06),('14598','2013-02-13','15:05:00',3.05),('14598','2013-02-13','15:10:00',2.9),('14598','2013-02-13','15:15:00',2.83),('14598','2013-02-13','15:20:00',2.76),('14598','2013-02-13','15:25:00',2.67),('14598','2013-02-13','15:30:00',2.62),('14598','2013-02-13','15:35:00',2.48),('14598','2013-02-13','15:40:00',2.37),('14598','2013-02-13','15:45:00',2.3),('14598','2013-02-13','15:50:00',2.21),('14598','2013-02-13','15:55:00',2.12),('14598','2013-02-13','16:00:00',2.02),('14598','2013-02-13','16:05:00',1.91),('14598','2013-02-13','16:10:00',1.58),('14598','2014-03-22','08:00:00',1.01),('14598','2014-03-22','08:05:00',1.05),('14598','2014-03-22','08:10:00',1.17),('14598','2014-03-22','08:15:00',1.18),('14598','2014-03-22','08:20:00',1.34),('14598','2014-03-22','08:25:00',1.5),('14598','2014-03-22','08:30:00',1.65),('14598','2014-03-22','08:35:00',1.84),('14598','2014-03-22','08:40:00',1.21),('14598','2014-03-22','08:45:00',1.25),('14598','2014-03-22','08:55:00',1.02),('14598','2014-03-22','09:00:00',1.06),('14598','2014-03-22','09:05:00',1.57),('14598','2014-03-22','09:10:00',1.68),('14598','2014-03-22','09:15:00',1.77),('14598','2014-03-22','09:20:00',2.03),('14598','2014-03-22','09:25:00',2.85),('14598','2014-03-22','09:30:00',2.56),('14598','2014-03-22','09:35:00',2.56),('14598','2014-03-22','09:40:00',2.86),('14598','2014-03-22','09:45:00',3.05),('14598','2014-03-22','09:50:00',3.17),('14598','2014-03-22','09:55:00',2.21),('14598','2014-03-22','10:00:00',2.91),('14598','2014-03-22','10:05:00',3.4),('14598','2014-03-22','10:10:00',2.8),('14598','2014-03-22','10:15:00',3.07),('14598','2014-03-22','10:20:00',3.63),('14598','2014-03-22','10:25:00',3.04),('14598','2014-03-22','10:30:00',2.06),('14598','2014-03-22','10:35:00',2.22),('14598','2014-03-22','10:40:00',2.22),('14598','2014-03-22','10:45:00',2.92),('14598','2014-03-22','10:50:00',2.57),('14598','2014-03-22','10:55:00',3.79),('14598','2014-03-22','11:00:00',3.89),('14598','2014-03-22','11:05:00',4.16),('14598','2014-03-22','11:10:00',4.32),('14598','2014-03-22','11:15:00',4.22),('14598','2014-03-22','11:20:00',4.16),('14598','2014-03-22','11:25:00',4.23),('14598','2014-03-22','11:30:00',4.23),('14598','2014-03-22','11:35:00',4.28),('14598','2014-03-22','11:40:00',4.31),('14598','2014-03-22','11:45:00',4.36),('14598','2014-03-22','11:50:00',4.34),('14598','2014-03-22','11:55:00',4.36),('14598','2014-03-22','12:00:00',4.4),('14598','2014-03-22','12:05:00',4.42),('14598','2014-03-22','12:10:00',4.4),('14598','2014-03-22','12:15:00',4.42),('14598','2014-03-22','12:20:00',4.44),('14598','2014-03-22','12:25:00',4.5),('14598','2014-03-22','12:30:00',4.5),('14598','2014-03-22','12:35:00',4.47),('14598','2014-03-22','12:40:00',4.49),('14598','2014-03-22','12:45:00',4.49),('14598','2014-03-22','12:50:00',4.54),('14598','2014-03-22','12:55:00',4.53),('14598','2014-03-22','13:00:00',4.52),('14598','2014-03-22','13:05:00',4.5),('14598','2014-03-22','13:10:00',4.48),('14598','2014-03-22','13:15:00',4.48),('14598','2014-03-22','13:20:00',4.46),('14598','2014-03-22','13:25:00',4.45),('14598','2014-03-22','13:30:00',4.43),('14598','2014-03-22','13:35:00',4.4),('14598','2014-03-22','13:40:00',4.38),('14598','2014-03-22','13:45:00',4.36),('14598','2014-03-22','13:50:00',4.32),('14598','2014-03-22','13:55:00',4.29),('14598','2014-03-22','14:00:00',4.27),('14598','2014-03-22','14:05:00',4.24),('14598','2014-03-22','14:10:00',4.2),('14598','2014-03-22','14:15:00',4.14),('14598','2014-03-22','14:20:00',4.04),('14598','2014-03-22','14:25:00',4.06),('14598','2014-03-22','14:30:00',4.01),('14598','2014-03-22','14:35:00',3.96),('14598','2014-03-22','14:40:00',3.89),('14598','2014-03-22','14:45:00',3.84),('14598','2014-03-22','14:50:00',3.79),('14598','2014-03-22','14:55:00',3.73),('14598','2014-03-22','15:00:00',3.68),('14598','2014-03-22','15:05:00',3.61),('14598','2014-03-22','15:10:00',3.52),('14598','2014-03-22','15:15:00',3.45),('14598','2014-03-22','15:20:00',3.37),('14598','2014-03-22','15:25:00',3.31),('14598','2014-03-22','15:30:00',3.22),('14598','2014-03-22','15:35:00',3.13),('14598','2014-03-22','15:40:00',3.06),('14598','2014-03-22','15:45:00',2.96),('14598','2014-03-22','15:50:00',2.87),('14598','2014-03-22','15:55:00',2.2),('14598','2014-03-22','16:00:00',1.01),('14598','2014-03-22','16:35:00',1.03),('14598','2014-03-22','16:40:00',1.26),('14598','2013-02-10','09:10:00',1.02),('14598','2013-02-10','09:15:00',1.57),('14598','2013-02-10','09:20:00',1.7),('14598','2013-02-10','09:25:00',1.82),('14598','2013-02-10','09:30:00',1.87),('14598','2013-02-10','09:35:00',1.85),('14598','2013-02-10','09:40:00',1.88),('14598','2013-02-10','09:45:00',2.12),('14598','2013-02-10','09:50:00',2.22),('14598','2013-02-10','09:55:00',2.32),('14598','2013-02-10','10:00:00',2.41),('14598','2013-02-10','10:05:00',2.51),('14598','2013-02-10','10:10:00',2.52),('14598','2013-02-10','10:15:00',2.3),('14598','2013-02-10','10:20:00',2.68),('14598','2013-02-10','10:25:00',2.8),('14598','2013-02-10','10:30:00',2.89),('14598','2013-02-10','10:35:00',2.97),('14598','2013-02-10','10:40:00',3.03),('14598','2013-02-10','10:45:00',3.1),('14598','2013-02-10','10:50:00',3.17),('14598','2013-02-10','10:55:00',3.16),('14598','2013-02-10','11:00:00',3.17),('14598','2013-02-10','11:05:00',3.31),('14598','2013-02-10','11:10:00',3.35),('14598','2013-02-10','11:15:00',3.38),('14598','2013-02-10','11:20:00',3.48),('14598','2013-02-10','11:25:00',3.52),('14598','2013-02-10','11:30:00',3.54),('14598','2013-02-10','11:35:00',3.26),('14598','2013-02-10','11:40:00',3.61),('14598','2013-02-10','11:45:00',3.64),('14598','2013-02-10','11:50:00',3.69),('14598','2013-02-10','11:55:00',3.71),('14598','2013-02-10','12:00:00',3.71),('14598','2013-02-10','12:05:00',3.75),('14598','2013-02-10','12:10:00',3.78),('14598','2013-02-10','12:15:00',3.8),('14598','2013-02-10','12:20:00',3.75),('14598','2013-02-10','12:25:00',3.79),('14598','2013-02-10','12:30:00',3.77),('14598','2013-02-10','12:35:00',3.79),('14598','2013-02-10','12:40:00',3.78),('14598','2013-02-10','12:45:00',3.79),('14598','2013-02-10','12:50:00',3.7),('14598','2013-02-10','12:55:00',3.6),('14598','2013-02-10','13:00:00',3.72),('14598','2013-02-10','13:05:00',3.71),('14598','2013-02-10','13:10:00',3.76),('14598','2013-02-10','13:15:00',3.79),('14598','2013-02-10','13:20:00',3.77),('14598','2013-02-10','13:25:00',3.61),('14598','2013-02-10','13:30:00',2.93),('14598','2013-02-10','13:35:00',3.69),('14598','2013-02-10','13:40:00',3.55),('14598','2013-02-10','13:45:00',3.65),('14598','2013-02-10','13:50:00',3.61),('14598','2013-02-10','13:55:00',3.71),('14598','2013-02-10','14:00:00',3.68),('14598','2013-02-10','14:05:00',3.64),('14598','2013-02-10','14:10:00',3.73),('14598','2013-02-10','14:15:00',3.78),('14598','2013-02-10','14:20:00',3.51),('14598','2013-02-10','14:25:00',3.48),('14598','2013-02-10','14:30:00',3.5),('14598','2013-02-10','14:35:00',3.52),('14598','2013-02-10','14:40:00',3.36),('14598','2013-02-10','14:45:00',3.3),('14598','2013-02-10','14:50:00',3.28),('14598','2013-02-10','14:55:00',3.16),('14598','2013-02-10','15:00:00',3.04),('14598','2013-02-10','15:05:00',2.95),('14598','2013-02-10','15:10:00',2.88),('14598','2013-02-10','15:15:00',2.83),('14598','2013-02-10','15:20:00',2.77),('14598','2013-02-10','15:25:00',2.69),('14598','2013-02-10','15:30:00',2.6),('14598','2013-02-10','15:35:00',2.53),('14598','2013-02-10','15:40:00',2.49),('14598','2013-02-10','15:45:00',2.45),('14598','2013-02-10','15:50:00',2.35),('14598','2013-02-10','15:55:00',2.21),('14598','2013-02-10','16:00:00',2.1),('14598','2013-02-10','16:05:00',1.98),('14598','2013-02-10','16:10:00',1.63),('14598','2013-02-09','10:05:00',1.02),('14598','2013-02-09','10:10:00',1.11),('14598','2013-02-09','10:15:00',1.22),('14598','2013-02-09','10:20:00',1.32),('14598','2013-02-09','10:25:00',1.35),('14598','2013-02-09','10:30:00',1.33),('14598','2013-02-09','10:35:00',1.34),('14598','2013-02-09','10:40:00',1.46),('14598','2013-02-09','10:45:00',1.45),('14598','2013-02-09','10:50:00',1.32),('14598','2013-02-09','10:55:00',1.23),('14598','2013-02-09','11:00:00',1.26),('14598','2013-02-09','11:05:00',1.25),('14598','2013-02-09','11:10:00',1.21),('14598','2013-02-09','11:15:00',1.23),('14598','2013-02-09','11:20:00',1.29),('14598','2013-02-09','11:25:00',1.38),('14598','2013-02-09','11:30:00',1.45),('14598','2013-02-09','11:35:00',1.48),('14598','2013-02-09','11:40:00',1.51),('14598','2013-02-09','11:45:00',1.5),('14598','2013-02-09','11:50:00',1.48),('14598','2013-02-09','11:55:00',1.53),('14598','2013-02-09','12:00:00',1.55),('14598','2013-02-09','12:05:00',1.58),('14598','2013-02-09','12:10:00',1.63),('14598','2013-02-09','12:15:00',1.65),('14598','2013-02-09','12:20:00',1.75),('14598','2013-02-09','12:25:00',1.84),('14598','2013-02-09','12:30:00',1.81),('14598','2013-02-09','12:35:00',1.87),('14598','2013-02-09','12:40:00',2.21),('14598','2013-02-09','12:45:00',2.36),('14598','2013-02-09','12:50:00',2.61),('14598','2013-02-09','12:55:00',2.71),('14598','2013-02-09','13:00:00',3.15),('14598','2013-02-09','13:05:00',3.45),('14598','2013-02-09','13:10:00',3.73),('14598','2013-02-09','13:15:00',4.11),('14598','2013-02-09','13:20:00',3.91),('14598','2013-02-09','13:25:00',3.31),('14598','2013-02-09','13:30:00',3.96),('14598','2013-02-09','13:35:00',3.87),('14598','2013-02-09','13:40:00',3.88),('14598','2013-02-09','13:45:00',3.82),('14598','2013-02-09','13:50:00',3.56),('14598','2013-02-09','13:55:00',3.8),('14598','2013-02-09','14:00:00',3.57),('14598','2013-02-09','14:05:00',3.07),('14598','2013-02-09','14:10:00',2.02),('14598','2013-02-09','14:15:00',1.45),('14598','2013-02-09','14:20:00',2.3),('14598','2013-02-09','14:25:00',2.63),('14598','2013-02-09','14:30:00',2.95),('14598','2013-02-09','14:35:00',3.39),('14598','2013-02-09','14:40:00',2.27),('14598','2013-02-09','14:45:00',1.02),('14598','2013-02-09','14:50:00',2.08),('14598','2013-02-09','14:55:00',3.21),('14598','2013-02-09','15:00:00',3.04),('14598','2013-02-09','15:05:00',2.97),('14598','2013-02-09','15:10:00',2.88),('14598','2013-02-09','15:15:00',2.81),('14598','2013-02-09','15:20:00',2.7),('14598','2013-02-09','15:25:00',2.61),('14598','2013-02-09','15:30:00',2.53),('14598','2013-02-09','15:35:00',2.45),('14598','2013-02-09','15:40:00',2.38),('14598','2013-02-09','15:45:00',2.29),('14598','2013-02-09','15:50:00',2.19),('14598','2013-02-09','15:55:00',2.09),('14598','2013-02-09','16:00:00',1.99),('14598','2013-02-09','16:05:00',1.89),('14598','2013-02-09','16:10:00',1.77),('14598','2013-02-09','16:15:00',1.68),('14598','2013-02-09','16:20:00',1.57),('14598','2013-02-09','16:25:00',1.46),('14598','2013-02-09','16:30:00',1.34),('14598','2013-02-09','16:35:00',1.21),('14598','2013-02-09','16:40:00',1.11),('14598','2013-02-08','08:50:00',1.01),('14598','2013-02-08','09:00:00',1.36),('14598','2013-02-08','09:05:00',1.53),('14598','2013-02-08','09:10:00',1.56),('14598','2013-02-08','09:15:00',1.72),('14598','2013-02-08','09:20:00',1.8),('14598','2013-02-08','09:25:00',1.88),('14598','2013-02-08','09:30:00',1.85),('14598','2013-02-08','09:35:00',1.9),('14598','2013-02-08','09:40:00',1.98),('14598','2013-02-08','09:45:00',2.06),('14598','2013-02-08','09:50:00',2.15),('14598','2013-02-08','09:55:00',2.24),('14598','2013-02-08','10:00:00',2.32),('14598','2013-02-08','10:05:00',2.42),('14598','2013-02-08','10:10:00',2.49),('14598','2013-02-08','10:15:00',2.58),('14598','2013-02-08','10:20:00',2.67),('14598','2013-02-08','10:25:00',2.74),('14598','2013-02-08','10:30:00',2.79),('14598','2013-02-08','10:35:00',2.88),('14598','2013-02-08','10:40:00',3.03),('14598','2013-02-08','10:45:00',2.83),('14598','2013-02-08','10:50:00',3.09),('14598','2013-02-08','10:55:00',3.17),('14598','2013-02-08','11:00:00',3.25),('14598','2013-02-08','11:05:00',3.27),('14598','2013-02-08','11:10:00',3.31),('14598','2013-02-08','11:15:00',3.36),('14598','2013-02-08','11:20:00',3.45),('14598','2013-02-08','11:25:00',3.57),('14598','2013-02-08','11:30:00',3.66),('14598','2013-02-08','11:35:00',3.77),('14598','2013-02-08','11:40:00',3.87),('14598','2013-02-08','11:45:00',3.4),('14598','2013-02-08','11:50:00',3.83),('14598','2013-02-08','11:55:00',3.82),('14598','2013-02-08','12:00:00',3.83),('14598','2013-02-08','12:05:00',3.68),('14598','2013-02-08','12:10:00',3.11),('14598','2013-02-08','12:15:00',2.64),('14598','2013-02-08','12:20:00',2.48),('14598','2013-02-08','12:25:00',2.35),('14598','2013-02-08','12:30:00',2.79),('14598','2013-02-08','12:35:00',3.46),('14598','2013-02-08','12:40:00',3.66),('14598','2013-02-08','12:45:00',3.42),('14598','2013-02-08','12:50:00',3.97),('14598','2013-02-08','12:55:00',2.32),('14598','2013-02-08','13:00:00',2.62),('14598','2013-02-08','13:05:00',1.79),('14598','2013-02-08','13:10:00',1.92),('14598','2013-02-08','13:15:00',2.08),('14598','2013-02-08','13:20:00',2.1),('14598','2013-02-08','13:25:00',1.97),('14598','2013-02-08','13:30:00',1.99),('14598','2013-02-08','13:35:00',1.93),('14598','2013-02-08','13:40:00',1.47),('14598','2013-02-08','13:45:00',1.82),('14598','2013-02-08','13:50:00',2.22),('14598','2013-02-08','13:55:00',3.76),('14598','2013-02-08','14:00:00',3.72),('14598','2013-02-08','14:05:00',2.98),('14598','2013-02-08','14:10:00',2.53),('14598','2013-02-08','14:15:00',4.18),('14598','2013-02-08','14:20:00',4.33),('14598','2013-02-08','14:25:00',4.14),('14598','2013-02-08','14:30:00',2.14),('14598','2013-02-08','14:35:00',2.34),('14598','2013-02-08','14:40:00',3.93),('14598','2013-02-08','14:45:00',3.9),('14598','2013-02-08','14:50:00',3.35),('14598','2013-02-08','14:55:00',1.99),('14598','2013-02-08','15:00:00',2.76),('14598','2013-02-08','15:05:00',3.1),('14598','2013-02-08','15:10:00',1.85),('14598','2013-02-08','15:15:00',2.84),('14598','2013-02-08','15:20:00',2.02),('14598','2013-02-08','15:35:00',1.34),('14598','2013-02-08','15:40:00',2.38),('14598','2013-02-08','15:45:00',2.7),('14598','2013-02-08','15:50:00',2.57),('14598','2013-02-08','15:55:00',2.4),('14598','2013-02-08','16:00:00',2.22),('14598','2013-02-08','16:05:00',2.01),('14598','2013-02-08','16:10:00',1.54),('14598','2013-02-08','16:20:00',1.05),('14598','2013-02-07','09:55:00',2.38),('14598','2013-02-07','10:00:00',1.58),('14598','2013-02-07','10:05:00',2.17),('14598','2013-02-07','10:10:00',2.43),('14598','2013-02-07','10:15:00',2.52),('14598','2013-02-07','10:20:00',2.62),('14598','2013-02-07','10:25:00',2.7),('14598','2013-02-07','10:30:00',2.59),('14598','2013-02-07','10:35:00',2.9),('14598','2013-02-07','10:40:00',3.32),('14598','2013-02-07','10:45:00',3.72),('14598','2013-02-07','10:50:00',4.52),('14598','2013-02-07','10:55:00',4.52),('14598','2013-02-07','11:00:00',2.27),('14598','2013-02-07','11:25:00',1.21),('14598','2013-02-07','11:30:00',2.92),('14598','2013-02-07','11:35:00',1.44),('14598','2013-02-07','12:05:00',1.09),('14598','2013-02-07','12:10:00',1.6),('14598','2013-02-07','12:15:00',1.47),('14598','2013-02-07','12:20:00',2.05),('14598','2013-02-07','12:25:00',1.54),('14598','2013-02-07','12:30:00',1.61),('14598','2013-02-07','12:35:00',1.82),('14598','2013-02-07','12:40:00',1.4),('14598','2013-02-07','12:45:00',2.12),('14598','2013-02-07','12:50:00',2.33),('14598','2013-02-07','12:55:00',4.28),('14598','2013-02-07','13:00:00',4.59),('14598','2013-02-07','13:05:00',4.18),('14598','2013-02-07','13:10:00',1.83),('14598','2013-02-07','13:15:00',1.13),('14598','2013-02-07','13:30:00',1.37),('14598','2013-02-07','13:35:00',1.23),('14598','2013-02-07','13:45:00',1.12),('14598','2013-02-07','13:50:00',1.11),('14598','2013-02-07','13:55:00',1.04),('14598','2013-02-07','14:00:00',2.58),('14598','2013-02-07','14:05:00',4.19),('14598','2013-02-07','14:10:00',3.66),('14598','2013-02-07','14:15:00',3.49),('14598','2013-02-07','14:20:00',3.44),('14598','2013-02-07','14:25:00',2.99),('14598','2013-02-07','14:30:00',1.77),('14598','2013-02-07','14:35:00',1.46),('14598','2013-02-07','14:40:00',1.25),('14598','2013-02-07','14:45:00',1.44),('14598','2013-02-07','14:50:00',1.14),('14598','2013-02-07','14:55:00',1.13),('14598','2013-02-07','16:45:00',1.1),('14598','2013-02-07','16:50:00',1.28),('14598','2013-02-07','16:55:00',1),('14598','2013-02-06','09:15:00',1.06),('14598','2013-02-06','09:20:00',1.07),('14598','2013-02-06','09:25:00',1.18),('14598','2013-02-06','09:30:00',1.22),('14598','2013-02-06','09:35:00',1.17),('14598','2013-02-06','09:40:00',1.17),('14598','2013-02-06','09:45:00',1.19),('14598','2013-02-06','09:50:00',1.16),('14598','2013-02-06','09:55:00',1.47),('14598','2013-02-06','10:00:00',1.48),('14598','2013-02-06','10:05:00',1.46),('14598','2013-02-06','10:10:00',2.3),('14598','2013-02-06','10:15:00',1.89),('14598','2013-02-06','10:20:00',1.16),('14598','2013-02-06','10:25:00',1.24),('14598','2013-02-06','10:30:00',1.2),('14598','2013-02-06','10:35:00',1.21),('14598','2013-02-06','10:40:00',1.49),('14598','2013-02-06','10:45:00',1.61),('14598','2013-02-06','10:50:00',1.55),('14598','2013-02-06','10:55:00',1.71),('14598','2013-02-06','11:00:00',1.83),('14598','2013-02-06','11:05:00',1.95),('14598','2013-02-06','11:10:00',1.59),('14598','2013-02-06','11:15:00',1.13),('14598','2013-02-06','11:20:00',1.07),('14598','2013-02-06','11:25:00',1.32),('14598','2013-02-06','11:30:00',1.54),('14598','2013-02-06','11:35:00',1.67),('14598','2013-02-06','11:40:00',1.36),('14598','2013-02-06','11:45:00',1.34),('14598','2013-02-06','11:50:00',1.4),('14598','2013-02-06','11:55:00',1.29),('14598','2013-02-06','12:00:00',1.24),('14598','2013-02-06','12:05:00',1.02),('14598','2013-02-06','12:10:00',1.15),('14598','2013-02-06','12:15:00',1.18),('14598','2013-02-06','12:20:00',1.1),('14598','2013-02-06','12:25:00',1.22),('14598','2013-02-06','12:30:00',1.54),('14598','2013-02-06','12:35:00',1.33),('14598','2013-02-06','12:40:00',1.08),('14598','2013-02-06','12:45:00',1.27),('14598','2013-02-06','12:50:00',1.02),('14598','2013-02-06','13:00:00',1.21),('14598','2013-02-06','13:05:00',1.28),('14598','2013-02-06','13:10:00',1.32),('14598','2013-02-06','13:15:00',1.41),('14598','2013-02-06','13:20:00',1.82),('14598','2013-02-06','13:25:00',1.52),('14598','2013-02-06','13:30:00',2.1),('14598','2013-02-06','13:35:00',2.91),('14598','2013-02-06','13:40:00',2.3),('14598','2013-02-06','13:45:00',1.7),('14598','2013-02-06','13:50:00',1.42),('14598','2013-02-06','14:05:00',1.3),('14598','2013-02-06','14:10:00',1.14),('14598','2013-02-06','14:50:00',1.99),('14598','2013-02-06','14:55:00',3.75),('14598','2013-02-06','15:00:00',2.52),('14598','2013-02-06','15:05:00',1.7),('14598','2013-02-06','15:10:00',2.23),('14598','2013-02-06','15:15:00',1.89),('14598','2013-02-06','15:25:00',1.1),('14598','2013-02-06','15:30:00',1),('14598','2013-02-06','16:40:00',1.12),('14598','2013-02-06','16:45:00',1.24),('14598','2013-02-06','16:50:00',1),('14598','2013-02-05','09:00:00',1.07),('14598','2013-02-05','09:05:00',1.19),('14598','2013-02-05','09:10:00',1.28),('14598','2013-02-05','09:15:00',1.39),('14598','2013-02-05','09:20:00',1.43),('14598','2013-02-05','09:25:00',1.55),('14598','2013-02-05','09:30:00',1.69),('14598','2013-02-05','09:35:00',1.79),('14598','2013-02-05','09:40:00',1.88),('14598','2013-02-05','09:45:00',1.96),('14598','2013-02-05','09:50:00',2.04),('14598','2013-02-05','09:55:00',2.05),('14598','2013-02-05','10:00:00',2.22),('14598','2013-02-05','10:05:00',2.31),('14598','2013-02-05','10:10:00',2.38),('14598','2013-02-05','10:15:00',2.45),('14598','2013-02-05','10:20:00',2.51),('14598','2013-02-05','10:25:00',2.58),('14598','2013-02-05','10:30:00',2.65),('14598','2013-02-05','10:35:00',2.71),('14598','2013-02-05','10:40:00',2.79),('14598','2013-02-05','10:45:00',2.85),('14598','2013-02-05','10:50:00',2.98),('14598','2013-02-05','10:55:00',3),('14598','2013-02-05','11:00:00',2.9),('14598','2013-02-05','11:05:00',2.47),('14598','2013-02-05','11:10:00',2.63),('14598','2013-02-05','11:15:00',2.56),('14598','2013-02-05','11:20:00',2.72),('14598','2013-02-05','11:25:00',3.27),('14598','2013-02-05','11:30:00',3.23),('14598','2013-02-05','11:35:00',3.32),('14598','2013-02-05','11:40:00',3.31),('14598','2013-02-05','11:45:00',3.49),('14598','2013-02-05','11:50:00',2.9),('14598','2013-02-05','11:55:00',3.29),('14598','2013-02-05','12:00:00',3.1),('14598','2013-02-05','12:05:00',3.8),('14598','2013-02-05','12:10:00',3.1),('14598','2013-02-05','12:15:00',2.96),('14598','2013-02-05','12:20:00',3.26),('14598','2013-02-05','12:25:00',2.99),('14598','2013-02-05','12:30:00',2.76),('14598','2013-02-05','12:35:00',2.52),('14598','2013-02-05','12:40:00',2.1),('14598','2013-02-05','12:45:00',2.32),('14598','2013-02-05','12:50:00',2.25),('14598','2013-02-05','12:55:00',2.05),('14598','2013-02-05','13:00:00',1.8),('14598','2013-02-05','13:05:00',1.58),('14598','2013-02-05','13:10:00',1.62),('14598','2013-02-05','13:15:00',2),('14598','2013-02-05','13:20:00',2.05),('14598','2013-02-05','13:25:00',1.88),('14598','2013-02-05','13:30:00',1.58),('14598','2013-02-05','13:35:00',1.64),('14598','2013-02-05','13:40:00',1.76),('14598','2013-02-05','13:45:00',1.72),('14598','2013-02-05','13:50:00',1.71),('14598','2013-02-05','13:55:00',1.75),('14598','2013-02-05','14:00:00',1.82),('14598','2013-02-05','14:05:00',1.98),('14598','2013-02-05','14:10:00',2.07),('14598','2013-02-05','14:15:00',2.17),('14598','2013-02-05','14:20:00',2.46),('14598','2013-02-05','14:25:00',2.88),('14598','2013-02-05','14:30:00',3.43),('14598','2013-02-05','14:35:00',2.79),('14598','2013-02-05','14:40:00',1.48),('14598','2013-02-05','14:45:00',1.24),('14598','2013-02-05','14:50:00',1.19),('14598','2013-02-05','14:55:00',1.96),('14598','2013-02-05','15:00:00',1.21),('14598','2013-02-04','09:00:00',1.07),('14598','2013-02-04','09:05:00',1.18),('14598','2013-02-04','09:10:00',1.29),('14598','2013-02-04','09:15:00',1.44),('14598','2013-02-04','09:20:00',1.48),('14598','2013-02-04','09:25:00',1.55),('14598','2013-02-04','09:30:00',1.63),('14598','2013-02-04','09:35:00',1.6),('14598','2013-02-04','09:40:00',1.75),('14598','2013-02-04','09:45:00',1.27),('14598','2013-02-04','09:50:00',1.06),('14598','2013-02-04','09:55:00',1.91),('14598','2013-02-04','10:00:00',2.3),('14598','2013-02-04','10:05:00',2.35),('14598','2013-02-04','10:10:00',2.26),('14598','2013-02-04','10:15:00',2.42),('14598','2013-02-04','10:20:00',2.57),('14598','2013-02-04','10:25:00',2.65),('14598','2013-02-04','10:30:00',2.68),('14598','2013-02-04','10:35:00',2.83),('14598','2013-02-04','10:40:00',2.89),('14598','2013-02-04','10:45:00',2.9),('14598','2013-02-04','10:50:00',2.99),('14598','2013-02-04','10:55:00',3.05),('14598','2013-02-04','11:00:00',3.11),('14598','2013-02-04','11:05:00',3.17),('14598','2013-02-04','11:10:00',3.21),('14598','2013-02-04','11:15:00',3.26),('14598','2013-02-04','11:20:00',3.31),('14598','2013-02-04','11:25:00',3.34),('14598','2013-02-04','11:30:00',3.38),('14598','2013-02-04','11:35:00',3.43),('14598','2013-02-04','11:40:00',3.46),('14598','2013-02-04','11:45:00',3.49),('14598','2013-02-04','11:50:00',3.52),('14598','2013-02-04','11:55:00',3.55),('14598','2013-02-04','12:00:00',3.58),('14598','2013-02-04','12:05:00',3.61),('14598','2013-02-04','12:10:00',3.63),('14598','2013-02-04','12:15:00',3.64),('14598','2013-02-04','12:20:00',3.66),('14598','2013-02-04','12:25:00',3.67),('14598','2013-02-04','12:30:00',3.64),('14598','2013-02-04','12:35:00',3.67),('14598','2013-02-04','12:40:00',3.67),('14598','2013-02-04','12:45:00',3.66),('14598','2013-02-04','12:50:00',3.65),('14598','2013-02-04','12:55:00',3.65),('14598','2013-02-04','13:00:00',3.65),('14598','2013-02-04','13:05:00',3.64),('14598','2013-02-04','13:10:00',3.62),('14598','2013-02-04','13:15:00',3.62),('14598','2013-02-04','13:20:00',3.59),('14598','2013-02-04','13:25:00',3.6),('14598','2013-02-04','13:30:00',3.57),('14598','2013-02-04','13:35:00',3.55),('14598','2013-02-04','13:40:00',3.52),('14598','2013-02-04','13:45:00',3.44),('14598','2013-02-04','13:50:00',3.45),('14598','2013-02-04','13:55:00',3.4),('14598','2013-02-04','14:00:00',3.37),('14598','2013-02-04','14:05:00',3.35),('14598','2013-02-04','14:10:00',3.32),('14598','2013-02-04','14:15:00',3.28),('14598','2013-02-04','14:20:00',3.24),('14598','2013-02-04','14:25:00',3.21),('14598','2013-02-04','14:30:00',3.17),('14598','2013-02-04','14:35:00',3.12),('14598','2013-02-04','14:40:00',3.08),('14598','2013-02-04','14:45:00',3.03),('14598','2013-02-04','14:50:00',2.97),('14598','2013-02-04','14:55:00',2.9),('14598','2013-02-04','15:00:00',2.83),('14598','2013-02-04','15:05:00',2.78),('14598','2013-02-04','15:10:00',2.7),('14598','2013-02-04','15:15:00',2.63),('14598','2013-02-04','15:20:00',2.56),('14598','2013-02-04','15:25:00',2.48),('14598','2013-02-04','15:30:00',2.4),('14598','2013-02-04','15:35:00',2.33),('14598','2013-02-04','15:40:00',2.22),('14598','2013-02-04','15:45:00',2.13),('14598','2013-02-04','15:50:00',2.04),('14598','2013-02-04','15:55:00',1.94),('14598','2013-02-04','16:00:00',1.84),('14598','2013-02-04','16:05:00',1.74),('14598','2013-02-04','16:10:00',1.63),('14598','2013-02-04','16:15:00',1.53),('14598','2013-02-04','16:20:00',1.42),('14598','2013-02-04','16:25:00',1.31),('14598','2013-02-04','16:30:00',1.2),('14598','2013-02-04','16:35:00',1.08),('14598','2013-02-03','08:45:00',1.04),('14598','2013-02-03','08:50:00',1.52),('14598','2013-02-03','08:55:00',1.55),('14598','2013-02-03','09:00:00',1.33),('14598','2013-02-03','09:05:00',1.23),('14598','2013-02-03','09:55:00',1.1),('14598','2013-02-03','10:00:00',1.04),('14598','2013-02-03','10:10:00',2.62),('14598','2013-02-03','10:15:00',1.77),('14598','2013-02-03','10:20:00',1.42),('14598','2013-02-03','10:25:00',1.86),('14598','2013-02-03','10:30:00',2.22),('14598','2013-02-03','10:35:00',1.68),('14598','2013-02-03','10:45:00',1.04),('14598','2013-02-03','10:50:00',1.51),('14598','2013-02-03','11:15:00',1.06),('14598','2013-02-03','11:20:00',1.96),('14598','2013-02-03','11:25:00',2.4),('14598','2013-02-03','11:30:00',1.41),('14598','2013-02-03','11:35:00',1.05),('14598','2013-02-03','11:40:00',1.7),('14598','2013-02-03','11:45:00',1.85),('14598','2013-02-03','13:10:00',1.11),('14598','2013-02-03','13:15:00',1.1),('14598','2013-02-03','14:05:00',1.13),('14598','2013-02-03','14:15:00',1.04),('14598','2013-02-03','14:20:00',1.19),('14598','2013-02-03','14:25:00',1.29),('14598','2013-02-03','14:30:00',1.06),('14598','2013-02-03','14:40:00',1.02),('14598','2013-02-02','09:35:00',1.02),('14598','2013-02-02','10:00:00',1.67),('14598','2013-02-02','10:05:00',1.83),('14598','2013-02-02','10:10:00',2.1),('14598','2013-02-02','10:15:00',1.94),('14598','2013-02-02','10:20:00',1.56),('14598','2013-02-02','10:25:00',1.43),('14598','2013-02-02','10:30:00',1.73),('14598','2013-02-02','10:35:00',2.12),('14598','2013-02-02','10:40:00',2.06),('14598','2013-02-02','10:45:00',1.89),('14598','2013-02-02','10:50:00',1.94),('14598','2013-02-02','10:55:00',1.99),('14598','2013-02-02','11:00:00',2.2),('14598','2013-02-02','11:05:00',2.1),('14598','2013-02-02','11:10:00',2.1),('14598','2013-02-02','11:15:00',1.9),('14598','2013-02-02','11:20:00',1.69),('14598','2013-02-02','11:25:00',1.57),('14598','2013-02-02','11:30:00',1.13),('14598','2013-02-02','12:25:00',1.62),('14598','2013-02-02','12:30:00',2.38),('14598','2013-02-02','12:35:00',2.03),('14598','2013-02-02','12:40:00',1.28),('14598','2013-02-02','12:55:00',1.23),('14598','2013-02-02','13:00:00',1.19),('14598','2013-02-02','14:50:00',1.06),('14598','2013-02-02','14:55:00',1.18),('14598','2013-02-01','09:10:00',1.08),('14598','2013-02-01','09:15:00',1.8),('14598','2013-02-01','09:20:00',1.68),('14598','2013-02-01','09:25:00',1.49),('14598','2013-02-01','09:30:00',1.3),('14598','2013-02-01','09:35:00',1.52),('14598','2013-02-01','09:40:00',1.16),('14598','2013-02-01','09:45:00',1.4),('14598','2013-02-01','09:50:00',1.46),('14598','2013-02-01','09:55:00',2.26),('14598','2013-02-01','10:00:00',1.26),('14598','2013-02-01','10:05:00',1.77),('14598','2013-02-01','10:10:00',2.37),('14598','2013-02-01','10:15:00',2.03),('14598','2013-02-01','10:45:00',1.14),('14598','2013-02-01','10:50:00',3.6),('14598','2013-02-01','10:55:00',3.28),('14598','2013-02-01','11:00:00',2.92),('14598','2013-02-01','11:05:00',2.92),('14598','2013-02-01','11:10:00',2.93),('14598','2013-02-01','11:15:00',2.95),('14598','2013-02-01','11:20:00',3.01),('14598','2013-02-01','11:25:00',3.01),('14598','2013-02-01','11:30:00',3.09),('14598','2013-02-01','11:35:00',3.13),('14598','2013-02-01','11:40:00',3.19),('14598','2013-02-01','11:45:00',3.22),('14598','2013-02-01','11:50:00',3.25),('14598','2013-02-01','11:55:00',3.21),('14598','2013-02-01','12:00:00',3.36),('14598','2013-02-01','12:05:00',3.39),('14598','2013-02-01','12:10:00',3.4),('14598','2013-02-01','12:15:00',3.53),('14598','2013-02-01','12:20:00',3.49),('14598','2013-02-01','12:25:00',3.33),('14598','2013-02-01','12:30:00',3.38),('14598','2013-02-01','12:35:00',3.42),('14598','2013-02-01','12:40:00',3.36),('14598','2013-02-01','12:45:00',3.34),('14598','2013-02-01','12:50:00',3.35),('14598','2013-02-01','12:55:00',3.36),('14598','2013-02-01','13:00:00',3.39),('14598','2013-02-01','13:05:00',3.34),('14598','2013-02-01','13:10:00',3.14),('14598','2013-02-01','13:15:00',3.11),('14598','2013-02-01','13:20:00',3.37),('14598','2013-02-01','13:25:00',3.35),('14598','2013-02-01','13:30:00',3.21),('14598','2013-02-01','13:35:00',3.34),('14598','2013-02-01','13:40:00',3.16),('14598','2013-02-01','13:45:00',2.76),('14598','2013-02-01','13:50:00',3.03),('14598','2013-02-01','13:55:00',3.21),('14598','2013-02-01','14:00:00',3.1),('14598','2013-02-01','14:05:00',3.17),('14598','2013-02-01','14:10:00',3.11),('14598','2013-02-01','14:15:00',3.03),('14598','2013-02-01','14:20:00',3.02),('14598','2013-02-01','14:25:00',2.97),('14598','2013-02-01','14:30:00',2.93),('14598','2013-02-01','14:35:00',2.9),('14598','2013-02-01','14:40:00',2.71),('14598','2013-02-01','14:45:00',2.67),('14598','2013-02-01','14:50:00',2.61),('14598','2013-02-01','14:55:00',2.58),('14598','2013-02-01','15:00:00',2.54),('14598','2013-02-01','15:05:00',2.48),('14598','2013-02-01','15:10:00',2.39),('14598','2013-02-01','15:15:00',2.24),('14598','2013-02-01','15:20:00',2.39),('14598','2013-02-01','15:25:00',1.69),('14598','2013-02-01','15:40:00',1.3),('14598','2013-02-01','15:45:00',2.18),('14598','2013-02-01','15:50:00',1.48),('14598','2014-03-21','08:00:00',1.07),('14598','2014-03-21','08:05:00',1.17),('14598','2014-03-21','08:10:00',1.28),('14598','2014-03-21','08:15:00',1.36),('14598','2014-03-21','08:20:00',1.47),('14598','2014-03-21','08:25:00',1.58),('14598','2014-03-21','08:30:00',1.73),('14598','2014-03-21','08:35:00',1.83),('14598','2014-03-21','08:40:00',1.93),('14598','2014-03-21','08:45:00',2.01),('14598','2014-03-21','08:50:00',2.07),('14598','2014-03-21','08:55:00',2.16),('14598','2014-03-21','09:00:00',2.24),('14598','2014-03-21','09:05:00',2.33),('14598','2014-03-21','09:10:00',2.43),('14598','2014-03-21','09:15:00',2.55),('14598','2014-03-21','09:20:00',2.61),('14598','2014-03-21','09:25:00',2.58),('14598','2014-03-21','09:30:00',2.74),('14598','2014-03-21','09:35:00',2.76),('14598','2014-03-21','09:40:00',2.81),('14598','2014-03-21','09:45:00',2.94),('14598','2014-03-21','09:50:00',3),('14598','2014-03-21','09:55:00',3.05),('14598','2014-03-21','10:00:00',3.14),('14598','2014-03-21','10:05:00',3.19),('14598','2014-03-21','10:10:00',3.32),('14598','2014-03-21','10:15:00',3.42),('14598','2014-03-21','10:20:00',3.51),('14598','2014-03-21','10:25:00',3.58),('14598','2014-03-21','10:30:00',3.5),('14598','2014-03-21','10:35:00',3.51),('14598','2014-03-21','10:40:00',3.88),('14598','2014-03-21','10:45:00',3.93),('14598','2014-03-21','10:50:00',4),('14598','2014-03-21','10:55:00',4.03),('14598','2014-03-21','11:00:00',4.07),('14598','2014-03-21','11:05:00',4.11),('14598','2014-03-21','11:10:00',4.15),('14598','2014-03-21','11:15:00',4.19),('14598','2014-03-21','11:20:00',4.21),('14598','2014-03-21','11:25:00',4.26),('14598','2014-03-21','11:30:00',4.27),('14598','2014-03-21','11:35:00',4.3),('14598','2014-03-21','11:40:00',4.35),('14598','2014-03-21','11:45:00',4.38),('14598','2014-03-21','11:50:00',4.42),('14598','2014-03-21','11:55:00',4.44),('14598','2014-03-21','12:00:00',4.47),('14598','2014-03-21','12:05:00',4.5),('14598','2014-03-21','12:10:00',4.52),('14598','2014-03-21','12:15:00',4.5),('14598','2014-03-21','12:20:00',4.52),('14598','2014-03-21','12:25:00',4.51),('14598','2014-03-21','12:30:00',4.55),('14598','2014-03-21','12:35:00',4.55),('14598','2014-03-21','12:40:00',4.56),('14598','2014-03-21','12:45:00',4.54),('14598','2014-03-21','12:50:00',4.54),('14598','2014-03-21','12:55:00',4.53),('14598','2014-03-21','13:00:00',4.55),('14598','2014-03-21','13:05:00',4.52),('14598','2014-03-21','13:10:00',4.54),('14598','2014-03-21','13:15:00',4.54),('14598','2014-03-21','13:20:00',4.51),('14598','2014-03-21','13:25:00',4.51),('14598','2014-03-21','13:30:00',4.52),('14598','2014-03-21','13:35:00',4.52),('14598','2014-03-21','13:40:00',4.5),('14598','2014-03-21','13:45:00',4.47),('14598','2014-03-21','13:50:00',4.43),('14598','2014-03-21','13:55:00',4.37),('14598','2014-03-21','14:00:00',3.83),('14598','2014-03-21','14:05:00',3.68),('14598','2014-03-21','14:10:00',1.88),('14598','2014-03-21','14:15:00',1.09),('14598','2014-03-21','14:20:00',1.38),('14598','2014-03-21','14:25:00',2.11),('14598','2014-03-21','14:30:00',1.54),('14598','2014-03-21','14:35:00',3.08),('14598','2014-03-21','14:40:00',3.05),('14598','2014-03-21','14:45:00',4.31),('14598','2014-03-21','14:50:00',4.34),('14598','2014-03-21','14:55:00',4.15),('14598','2014-03-21','15:00:00',3.72),('14598','2014-03-21','15:05:00',2.2),('14598','2014-03-21','15:10:00',2.94),('14598','2014-03-21','15:15:00',3.87),('14598','2014-03-21','15:20:00',3.71),('14598','2014-03-21','15:25:00',3.59),('14598','2014-03-21','15:30:00',3.45),('14598','2014-03-21','15:35:00',3.31),('14598','2014-03-21','15:40:00',2.57),('14598','2014-03-21','15:45:00',2.72),('14598','2014-03-21','15:50:00',3.02),('14598','2014-03-21','15:55:00',3),('14598','2014-03-21','16:00:00',2.84),('14598','2014-03-21','16:05:00',2.7),('14598','2014-03-21','16:10:00',2.62),('14598','2014-03-21','16:15:00',2.52),('14598','2014-03-21','16:20:00',2.41),('14598','2014-03-21','16:25:00',2.28),('14598','2014-03-21','16:30:00',2.16),('14598','2014-03-21','16:35:00',1.99),('14598','2014-03-21','16:40:00',1.84),('14598','2014-03-21','16:45:00',1.64),('14598','2014-03-21','16:50:00',1.58),('14598','2014-03-21','16:55:00',1.45),('14598','2014-03-21','17:00:00',1.39),('14598','2014-03-21','17:05:00',1.28),('14598','2014-03-21','17:10:00',1.15),('14598','2014-03-21','17:15:00',1.06),('14598','2013-01-31','09:30:00',1.07),('14598','2013-01-31','09:35:00',1.57),('14598','2013-01-31','09:40:00',1.62),('14598','2013-01-31','09:45:00',1.72),('14598','2013-01-31','09:50:00',1.8),('14598','2013-01-31','09:55:00',1.88),('14598','2013-01-31','10:00:00',1.97),('14598','2013-01-31','10:05:00',2.04),('14598','2013-01-31','10:10:00',2.11),('14598','2013-01-31','10:15:00',2.2),('14598','2013-01-31','10:20:00',2.25),('14598','2013-01-31','10:25:00',2.36),('14598','2013-01-31','10:30:00',2.43),('14598','2013-01-31','10:35:00',2.49),('14598','2013-01-31','10:40:00',2.6),('14598','2013-01-31','10:45:00',2.53),('14598','2013-01-31','10:50:00',1.58),('14598','2013-01-31','10:55:00',2.78),('14598','2013-01-31','11:00:00',2.89),('14598','2013-01-31','11:05:00',2.42),('14598','2013-01-31','11:10:00',2.96),('14598','2013-01-31','11:15:00',3.3),('14598','2013-01-31','11:20:00',3.3),('14598','2013-01-31','11:25:00',3.28),('14598','2013-01-31','11:30:00',2.89),('14598','2013-01-31','11:35:00',3.11),('14598','2013-01-31','11:40:00',3.2),('14598','2013-01-31','11:45:00',3.3),('14598','2013-01-31','11:50:00',3.46),('14598','2013-01-31','11:55:00',2.05),('14598','2013-01-31','12:00:00',3.53),('14598','2013-01-31','12:05:00',1.53),('14598','2013-01-31','12:10:00',1.52),('14598','2013-01-31','12:15:00',1.66),('14598','2013-01-31','12:20:00',1.14),('14598','2013-01-31','12:25:00',1.44),('14598','2013-01-31','12:35:00',2.13),('14598','2013-01-31','12:40:00',2.29),('14598','2013-01-31','12:45:00',2.26),('14598','2013-01-31','12:50:00',3.25),('14598','2013-01-31','12:55:00',3.38),('14598','2013-01-31','13:00:00',3.38),('14598','2013-01-31','13:05:00',3.38),('14598','2013-01-31','13:10:00',3.34),('14598','2013-01-31','13:15:00',3.3),('14598','2013-01-31','13:20:00',3.27),('14598','2013-01-31','13:25:00',3.28),('14598','2013-01-31','13:30:00',3.3),('14598','2013-01-31','13:35:00',3.31),('14598','2013-01-31','13:40:00',3.31),('14598','2013-01-31','13:45:00',3.28),('14598','2013-01-31','13:50:00',3.23),('14598','2013-01-31','13:55:00',3.2),('14598','2013-01-31','14:00:00',3.16),('14598','2013-01-31','14:05:00',3.07),('14598','2013-01-31','14:10:00',3.01),('14598','2013-01-31','14:15:00',3.01),('14598','2013-01-31','14:20:00',2.98),('14598','2013-01-31','14:25:00',2.94),('14598','2013-01-31','14:30:00',2.88),('14598','2013-01-31','14:35:00',2.8),('14598','2013-01-31','14:40:00',2.77),('14598','2013-01-31','14:45:00',2.71),('14598','2013-01-31','14:50:00',2.51),('14598','2013-01-31','14:55:00',2.61),('14598','2013-01-31','15:00:00',2.46),('14598','2013-01-31','15:05:00',2.47),('14598','2013-01-31','15:10:00',2.41),('14598','2013-01-31','15:15:00',2.32),('14598','2013-01-31','15:20:00',2.19),('14598','2013-01-31','15:25:00',2.2),('14598','2013-01-31','15:30:00',2.11),('14598','2013-01-31','15:35:00',1.89),('14598','2013-01-31','15:40:00',1.55),('14598','2013-01-31','15:45:00',1.31),('14598','2013-01-31','15:50:00',1.52),('14598','2013-01-31','15:55:00',1.68),('14598','2013-01-31','16:00:00',1.31),('14598','2013-01-31','16:05:00',1.07),('14598','2013-01-31','16:10:00',1.29),('14598','2013-01-31','16:15:00',1.33),('14598','2013-01-31','16:20:00',1.18),('14598','2013-01-31','16:25:00',1.07),('14598','2013-01-30','09:05:00',1.03),('14598','2013-01-30','09:10:00',1.21),('14598','2013-01-30','09:15:00',1.79),('14598','2013-01-30','09:20:00',1.82),('14598','2013-01-30','09:25:00',1.18),('14598','2013-01-30','09:30:00',1.09),('14598','2013-01-30','09:35:00',1.21),('14598','2013-01-30','09:40:00',1.13),('14598','2013-01-30','09:45:00',1.13),('14598','2013-01-30','09:50:00',1.17),('14598','2013-01-30','09:55:00',1.11),('14598','2013-01-30','10:00:00',1.17),('14598','2013-01-30','10:05:00',1.28),('14598','2013-01-30','10:10:00',1.23),('14598','2013-01-30','10:15:00',2.17),('14598','2013-01-30','10:20:00',2.35),('14598','2013-01-30','10:25:00',2.35),('14598','2013-01-30','10:30:00',2.29),('14598','2013-01-30','10:35:00',1.99),('14598','2013-01-30','10:40:00',2.52),('14598','2013-01-30','10:45:00',2.59),('14598','2013-01-30','10:50:00',2.61),('14598','2013-01-30','10:55:00',2.68),('14598','2013-01-30','11:00:00',2.72),('14598','2013-01-30','11:05:00',2.74),('14598','2013-01-30','11:10:00',2.84),('14598','2013-01-30','11:15:00',2.92),('14598','2013-01-30','11:20:00',2.9),('14598','2013-01-30','11:25:00',2.89),('14598','2013-01-30','11:30:00',3.01),('14598','2013-01-30','11:35:00',3.03),('14598','2013-01-30','11:40:00',3.01),('14598','2013-01-30','11:45:00',3.01),('14598','2013-01-30','11:50:00',3.15),('14598','2013-01-30','11:55:00',3.07),('14598','2013-01-30','12:00:00',2.67),('14598','2013-01-30','12:05:00',2.07),('14598','2013-01-30','12:10:00',1.89),('14598','2013-01-30','12:15:00',1.82),('14598','2013-01-30','12:20:00',1.89),('14598','2013-01-30','12:25:00',2.06),('14598','2013-01-30','12:30:00',2.04),('14598','2013-01-30','12:35:00',1.84),('14598','2013-01-30','12:40:00',1.61),('14598','2013-01-30','12:45:00',1.49),('14598','2013-01-30','12:50:00',1.66),('14598','2013-01-30','12:55:00',2.55),('14598','2013-01-30','13:00:00',2.14),('14598','2013-01-30','13:05:00',2.8),('14598','2013-01-30','13:10:00',3.31),('14598','2013-01-30','13:15:00',1.76),('14598','2013-01-30','13:20:00',2.85),('14598','2013-01-30','13:25:00',1.85),('14598','2013-01-30','13:30:00',2.5),('14598','2013-01-30','13:35:00',3.7),('14598','2013-01-30','13:40:00',3.35),('14598','2013-01-30','13:45:00',3.1),('14598','2013-01-30','13:50:00',3.06),('14598','2013-01-30','13:55:00',2.81),('14598','2013-01-30','14:00:00',2.45),('14598','2013-01-30','14:05:00',2.53),('14598','2013-01-30','14:10:00',2.8),('14598','2013-01-30','14:15:00',2.62),('14598','2013-01-30','14:20:00',2.44),('14598','2013-01-30','14:25:00',1.78),('14598','2013-01-30','14:30:00',1.4),('14598','2013-01-30','14:35:00',1.87),('14598','2013-01-30','14:40:00',1.6),('14598','2013-01-30','14:45:00',1.57),('14598','2013-01-30','14:50:00',1.48),('14598','2013-01-30','14:55:00',1.52),('14598','2013-01-30','15:00:00',1.47),('14598','2013-01-30','15:05:00',1.38),('14598','2013-01-30','15:10:00',1.24),('14598','2013-01-30','15:15:00',1.09),('14598','2013-01-30','15:20:00',1.01),('14598','2013-01-30','16:10:00',1.38),('14598','2013-01-29','09:05:00',1.01),('14598','2013-01-29','09:10:00',1.11),('14598','2013-01-29','09:15:00',1.21),('14598','2013-01-29','09:20:00',1.3),('14598','2013-01-29','09:25:00',1.39),('14598','2013-01-29','09:30:00',1.49),('14598','2013-01-29','09:35:00',1.58),('14598','2013-01-29','09:40:00',1.68),('14598','2013-01-29','09:45:00',1.76),('14598','2013-01-29','09:50:00',1.85),('14598','2013-01-29','09:55:00',1.92),('14598','2013-01-29','10:00:00',2.01),('14598','2013-01-29','10:05:00',2.07),('14598','2013-01-29','10:10:00',2.15),('14598','2013-01-29','10:15:00',2.25),('14598','2013-01-29','10:20:00',2.33),('14598','2013-01-29','10:25:00',2.42),('14598','2013-01-29','10:30:00',2.48),('14598','2013-01-29','10:35:00',2.56),('14598','2013-01-29','10:40:00',2.61),('14598','2013-01-29','10:45:00',2.69),('14598','2013-01-29','10:50:00',2.76),('14598','2013-01-29','10:55:00',2.76),('14598','2013-01-29','11:00:00',2.84),('14598','2013-01-29','11:05:00',2.94),('14598','2013-01-29','11:10:00',2.96),('14598','2013-01-29','11:15:00',3.04),('14598','2013-01-29','11:20:00',3.16),('14598','2013-01-29','11:25:00',3.15),('14598','2013-01-29','11:30:00',3.21),('14598','2013-01-29','11:35:00',3.06),('14598','2013-01-29','11:40:00',3.05),('14598','2013-01-29','11:45:00',3.15),('14598','2013-01-29','11:50:00',3.01),('14598','2013-01-29','11:55:00',3.38),('14598','2013-01-29','12:00:00',3.23),('14598','2013-01-29','12:05:00',3.34),('14598','2013-01-29','12:10:00',3.45),('14598','2013-01-29','12:15:00',3.4),('14598','2013-01-29','12:20:00',3.43),('14598','2013-01-29','12:25:00',3.46),('14598','2013-01-29','12:30:00',3.48),('14598','2013-01-29','12:35:00',3.5),('14598','2013-01-29','12:40:00',3.42),('14598','2013-01-29','12:45:00',3.3),('14598','2013-01-29','12:50:00',3.33),('14598','2013-01-29','12:55:00',3.41),('14598','2013-01-29','13:00:00',3.43),('14598','2013-01-29','13:05:00',3.39),('14598','2013-01-29','13:10:00',3.39),('14598','2013-01-29','13:15:00',3.37),('14598','2013-01-29','13:20:00',3.36),('14598','2013-01-29','13:25:00',3.34),('14598','2013-01-29','13:30:00',3.32),('14598','2013-01-29','13:35:00',3.34),('14598','2013-01-29','13:40:00',3.36),('14598','2013-01-29','13:45:00',3.62),('14598','2013-01-29','13:50:00',3.5),('14598','2013-01-29','13:55:00',3.33),('14598','2013-01-29','14:00:00',3.26),('14598','2013-01-29','14:05:00',3.22),('14598','2013-01-29','14:10:00',3.19),('14598','2013-01-29','14:15:00',3.14),('14598','2013-01-29','14:20:00',3.08),('14598','2013-01-29','14:25:00',2.97),('14598','2013-01-29','14:30:00',2.98),('14598','2013-01-29','14:35:00',2.92),('14598','2013-01-29','14:40:00',2.87),('14598','2013-01-29','14:45:00',2.82),('14598','2013-01-29','14:50:00',2.74),('14598','2013-01-29','14:55:00',2.69),('14598','2013-01-29','15:00:00',2.62),('14598','2013-01-29','15:05:00',2.56),('14598','2013-01-29','15:10:00',2.48),('14598','2013-01-29','15:15:00',2.41),('14598','2013-01-29','15:20:00',2.34),('14598','2013-01-29','15:25:00',2.26),('14598','2013-01-29','15:30:00',2.17),('14598','2013-01-29','15:35:00',2.08),('14598','2013-01-29','15:40:00',1.99),('14598','2013-01-29','15:45:00',1.9),('14598','2013-01-29','15:50:00',1.79),('14598','2013-01-29','15:55:00',1.71),('14598','2013-01-29','16:00:00',1.24),('14598','2013-01-29','16:05:00',1.51),('14598','2013-01-29','16:10:00',1.4),('14598','2013-01-29','16:15:00',1.3),('14598','2013-01-29','16:20:00',1.2),('14598','2013-01-29','16:25:00',1.1),('14598','2013-01-28','10:45:00',1),('14598','2013-01-28','12:10:00',1.19),('14598','2013-01-28','12:15:00',1.18),('14598','2013-01-28','12:20:00',1.18),('14598','2013-01-28','12:25:00',1.18),('14598','2013-01-28','12:30:00',1.18),('14598','2013-01-28','12:35:00',1.12),('14598','2013-01-28','12:40:00',1.16),('14598','2013-01-28','12:45:00',1.47),('14598','2013-01-28','12:50:00',1.38),('14598','2013-01-28','12:55:00',1.16),('14598','2013-01-28','13:00:00',1.09),('14598','2013-01-28','13:05:00',1.07),('14598','2013-01-28','13:10:00',1.18),('14598','2013-01-28','13:15:00',1.35),('14598','2013-01-28','13:20:00',1.35),('14598','2013-01-28','13:25:00',1.12),('14598','2013-01-28','13:35:00',1),('14598','2013-01-27','09:05:00',1.05),('14598','2013-01-27','09:10:00',1.17),('14598','2013-01-27','09:15:00',1.36),('14598','2013-01-27','09:30:00',1.31),('14598','2013-01-27','09:35:00',1.55),('14598','2013-01-27','09:40:00',1.63),('14598','2013-01-27','09:45:00',1.72),('14598','2013-01-27','09:50:00',1.81),('14598','2013-01-27','09:55:00',1.9),('14598','2013-01-27','10:00:00',1.98),('14598','2013-01-27','10:05:00',2.05),('14598','2013-01-27','10:10:00',2.12),('14598','2013-01-27','10:15:00',2.21),('14598','2013-01-27','10:20:00',2.29),('14598','2013-01-27','10:25:00',2.35),('14598','2013-01-27','10:30:00',2.4),('14598','2013-01-27','10:35:00',2.43),('14598','2013-01-27','10:40:00',2.56),('14598','2013-01-27','10:45:00',2.61),('14598','2013-01-27','10:50:00',2.68),('14598','2013-01-27','10:55:00',2.75),('14598','2013-01-27','11:00:00',2.81),('14598','2013-01-27','11:05:00',2.86),('14598','2013-01-27','11:10:00',2.88),('14598','2013-01-27','11:15:00',2.93),('14598','2013-01-27','11:20:00',2.97),('14598','2013-01-27','11:25:00',3.01),('14598','2013-01-27','11:30:00',3.06),('14598','2013-01-27','11:35:00',3.09),('14598','2013-01-27','11:40:00',3.12),('14598','2013-01-27','11:45:00',3.18),('14598','2013-01-27','11:50:00',3.13),('14598','2013-01-27','11:55:00',3.21),('14598','2013-01-27','12:00:00',3.27),('14598','2013-01-27','12:05:00',3.27),('14598','2013-01-27','12:10:00',3.28),('14598','2013-01-27','12:15:00',3.32),('14598','2013-01-27','12:20:00',3.34),('14598','2013-01-27','12:25:00',3.33),('14598','2013-01-27','12:30:00',3.33),('14598','2013-01-27','12:35:00',3.34),('14598','2013-01-27','12:40:00',3.36),('14598','2013-01-27','12:45:00',3.36),('14598','2013-01-27','12:50:00',3.37),('14598','2013-01-27','12:55:00',3.35),('14598','2013-01-27','13:00:00',3.31),('14598','2013-01-27','13:05:00',3.3),('14598','2013-01-27','13:10:00',3.32),('14598','2013-01-27','13:15:00',3.33),('14598','2013-01-27','13:20:00',3.3),('14598','2013-01-27','13:25:00',3.28),('14598','2013-01-27','13:30:00',3.26),('14598','2013-01-27','13:35:00',3.13),('14598','2013-01-27','13:40:00',3.19),('14598','2013-01-27','13:45:00',3.13),('14598','2013-01-27','13:50:00',3.08),('14598','2013-01-27','13:55:00',3.07),('14598','2013-01-27','14:00:00',3.03),('14598','2013-01-27','14:05:00',2.99),('14598','2013-01-27','14:10:00',2.95),('14598','2013-01-27','14:15:00',2.93),('14598','2013-01-27','14:20:00',2.9),('14598','2013-01-27','14:25:00',2.84),('14598','2013-01-27','14:30:00',2.8),('14598','2013-01-27','14:35:00',2.74),('14598','2013-01-27','14:40:00',2.71),('14598','2013-01-27','14:45:00',2.65),('14598','2013-01-27','14:50:00',2.36),('14598','2013-01-27','14:55:00',2.49),('14598','2013-01-27','15:00:00',2.34),('14598','2013-01-27','15:05:00',2.4),('14598','2013-01-27','15:10:00',2.3),('14598','2013-01-27','15:15:00',2.22),('14598','2013-01-27','15:20:00',2.14),('14598','2013-01-27','15:25:00',2.06),('14598','2013-01-27','15:30:00',1.99),('14598','2013-01-27','15:35:00',1.9),('14598','2013-01-27','15:40:00',1.82),('14598','2013-01-27','15:45:00',1.71),('14598','2013-01-27','15:50:00',1.6),('14598','2013-01-27','15:55:00',1.5),('14598','2013-01-27','16:00:00',1.4),('14598','2013-01-27','16:05:00',1.3),('14598','2013-01-27','16:10:00',1.21),('14598','2013-01-27','16:15:00',1.1),('14598','2013-01-26','10:30:00',1.01),('14598','2013-01-26','10:35:00',1.21),('14598','2013-01-26','10:40:00',1.28),('14598','2013-01-26','10:45:00',1.2),('14598','2013-01-26','10:50:00',1.26),('14598','2013-01-26','10:55:00',1.37),('14598','2013-01-26','11:00:00',1.36),('14598','2013-01-26','11:05:00',1.35),('14598','2013-01-26','11:10:00',1.12),('14598','2013-01-26','11:15:00',1.11),('14598','2013-01-26','11:20:00',1.11),('14598','2013-01-26','11:55:00',1.03),('14598','2013-01-26','12:00:00',1.14),('14598','2013-01-26','12:05:00',1.07),('14598','2013-01-26','12:10:00',1.08),('14598','2013-01-26','12:15:00',1.13),('14598','2013-01-26','12:20:00',1.02),('14598','2013-01-26','12:45:00',1.04),('14598','2013-01-26','13:15:00',1.08),('14598','2013-01-26','13:20:00',1.12),('14598','2013-01-26','13:25:00',1.23),('14598','2013-01-26','13:30:00',1.35),('14598','2013-01-26','13:35:00',1.15),('14598','2013-01-26','13:40:00',1.15),('14598','2013-01-26','13:45:00',1.13),('14598','2013-01-26','13:50:00',1.2),('14598','2013-01-26','13:55:00',1.3),('14598','2013-01-26','14:00:00',1.39),('14598','2013-01-26','14:05:00',1.26),('14598','2013-01-26','14:10:00',1.08),('14598','2013-01-25','09:00:00',1.02),('14598','2013-01-25','09:05:00',1.07),('14598','2013-01-25','09:10:00',1.05),('14598','2013-01-25','09:20:00',1.04),('14598','2013-01-25','09:25:00',1.29),('14598','2013-01-25','09:30:00',1.67),('14598','2013-01-25','09:35:00',1.76),('14598','2013-01-25','09:40:00',1.53),('14598','2013-01-25','09:45:00',1.48),('14598','2013-01-25','09:50:00',2.07),('14598','2013-01-25','09:55:00',2.29),('14598','2013-01-25','10:00:00',2.31),('14598','2013-01-25','10:05:00',1.74),('14598','2013-01-25','10:10:00',1.49),('14598','2013-01-25','10:15:00',2.42),('14598','2013-01-25','10:20:00',2.45),('14598','2013-01-25','10:25:00',2.51),('14598','2013-01-25','10:30:00',2.27),('14598','2013-01-25','10:35:00',2.26),('14598','2013-01-25','10:40:00',2.42),('14598','2013-01-25','10:45:00',2.74),('14598','2013-01-25','10:50:00',2.92),('14598','2013-01-25','10:55:00',2.97),('14598','2013-01-25','11:00:00',3.03),('14598','2013-01-25','11:05:00',3.11),('14598','2013-01-25','11:10:00',3.16),('14598','2013-01-25','11:15:00',3.17),('14598','2013-01-25','11:20:00',3.18),('14598','2013-01-25','11:25:00',3.19),('14598','2013-01-25','11:30:00',3.17),('14598','2013-01-25','11:35:00',3.13),('14598','2013-01-25','11:40:00',3.22),('14598','2013-01-25','11:45:00',3.24),('14598','2013-01-25','11:50:00',3.21),('14598','2013-01-25','11:55:00',3.22),('14598','2013-01-25','12:00:00',3.26),('14598','2013-01-25','12:05:00',3.37),('14598','2013-01-25','12:10:00',3.38),('14598','2013-01-25','12:15:00',3.41),('14598','2013-01-25','12:20:00',3.42),('14598','2013-01-25','12:25:00',3.41),('14598','2013-01-25','12:30:00',3.4),('14598','2013-01-25','12:35:00',3.35),('14598','2013-01-25','12:40:00',3.28),('14598','2013-01-25','12:45:00',3.28),('14598','2013-01-25','12:50:00',3.29),('14598','2013-01-25','12:55:00',3.33),('14598','2013-01-25','13:00:00',3.34),('14598','2013-01-25','13:05:00',3.05),('14598','2013-01-25','13:10:00',2.86),('14598','2013-01-25','13:15:00',3.22),('14598','2013-01-25','13:20:00',3.36),('14598','2013-01-25','13:25:00',3.32),('14598','2013-01-25','13:30:00',3.28),('14598','2013-01-25','13:35:00',3.29),('14598','2013-01-25','13:40:00',3.32),('14598','2013-01-25','13:45:00',3.28),('14598','2013-01-25','13:50:00',3.25),('14598','2013-01-25','13:55:00',3.13),('14598','2013-01-25','14:00:00',2.97),('14598','2013-01-25','14:05:00',2.94),('14598','2013-01-25','14:10:00',2.85),('14598','2013-01-25','14:15:00',2.75),('14598','2013-01-25','14:20:00',2.63),('14598','2013-01-25','14:25:00',2.64),('14598','2013-01-25','14:30:00',2.58),('14598','2013-01-25','14:35:00',2.61),('14598','2013-01-25','14:40:00',2.57),('14598','2013-01-25','14:45:00',2.5),('14598','2013-01-25','14:50:00',2.49),('14598','2013-01-25','14:55:00',2.4),('14598','2013-01-25','15:00:00',2.38),('14598','2013-01-25','15:05:00',2.34),('14598','2013-01-25','15:10:00',1.92),('14598','2013-01-25','15:15:00',2.06),('14598','2013-01-24','09:15:00',1.04),('14598','2013-01-24','09:20:00',1.27),('14598','2013-01-24','09:25:00',1.4),('14598','2013-01-24','09:30:00',1.25),('14598','2013-01-24','09:50:00',1.51),('14598','2013-01-24','09:55:00',1.72),('14598','2013-01-24','10:00:00',1.99),('14598','2013-01-24','10:05:00',2.26),('14598','2013-01-24','10:10:00',2.3),('14598','2013-01-24','10:15:00',2.32),('14598','2013-01-24','10:20:00',2.34),('14598','2013-01-24','10:25:00',2.41),('14598','2013-01-24','10:30:00',1.34),('14598','2013-01-24','10:35:00',1.56),('14598','2013-01-24','10:40:00',1.48),('14598','2013-01-24','11:40:00',1.01),('14598','2013-01-24','11:45:00',1.02),('14598','2013-01-24','11:50:00',1.67),('14598','2013-01-24','11:55:00',2.76),('14598','2013-01-24','12:00:00',2.19),('14598','2013-01-24','12:05:00',1.41),('14598','2013-01-24','12:10:00',1.42),('14598','2013-01-24','12:15:00',1.71),('14598','2013-01-24','12:20:00',1.5),('14598','2013-01-24','12:25:00',1.42),('14598','2013-01-24','12:30:00',1.18),('14598','2013-01-24','13:20:00',1.03),('14598','2013-01-24','13:25:00',1.13),('14598','2013-01-24','13:30:00',1.26),('14598','2013-01-24','13:35:00',1.4),('14598','2013-01-24','13:40:00',1.71),('14598','2013-01-24','13:45:00',2.88),('14598','2013-01-24','13:50:00',2.9),('14598','2013-01-24','13:55:00',3.72),('14598','2013-01-24','14:00:00',3.39),('14598','2013-01-24','14:05:00',2.17),('14598','2013-01-24','14:10:00',1.38),('14598','2013-01-24','14:15:00',3.06),('14598','2013-01-24','14:20:00',3.37),('14598','2013-01-24','14:25:00',3.05),('14598','2013-01-24','14:30:00',3.07),('14598','2013-01-24','14:35:00',3.32),('14598','2013-01-24','14:40:00',2.59),('14598','2013-01-24','14:45:00',1.88),('14598','2013-01-24','14:50:00',1.77),('14598','2013-01-24','15:10:00',1.55),('14598','2013-01-24','15:15:00',2.57),('14598','2013-01-24','15:20:00',2.67),('14598','2013-01-24','15:25:00',2.52),('14598','2013-01-24','15:30:00',2.31),('14598','2013-01-24','15:35:00',2.12),('14598','2013-01-24','15:40:00',1.59),('14598','2013-01-24','15:45:00',1.48),('14598','2013-01-24','15:55:00',1.05),('14598','2013-01-24','16:00:00',1.43),('14598','2013-01-24','16:05:00',1.33),('14598','2013-01-24','16:10:00',1.24),('14598','2013-01-23','09:20:00',1.08),('14598','2013-01-23','09:25:00',1.37),('14598','2013-01-23','09:30:00',1.76),('14598','2013-01-23','09:35:00',1.78),('14598','2013-01-23','09:40:00',1.7),('14598','2013-01-23','09:45:00',2.13),('14598','2013-01-23','09:50:00',1.26),('14598','2013-01-23','09:55:00',1.01),('14598','2013-01-23','11:50:00',1.08),('14598','2013-01-23','11:55:00',1.84),('14598','2013-01-23','12:00:00',2.68),('14598','2013-01-23','12:05:00',3.06),('14598','2013-01-23','12:10:00',1.94),('14598','2013-01-23','12:15:00',1.54),('14598','2013-01-23','12:20:00',1.41),('14598','2013-01-22','09:15:00',1.05),('14598','2013-01-22','09:35:00',1.15),('14598','2013-01-22','09:40:00',1.47),('14598','2013-01-22','09:45:00',1.55),('14598','2013-01-22','09:50:00',1.47),('14598','2013-01-22','09:55:00',1.3),('14598','2013-01-22','10:00:00',1.65),('14598','2013-01-22','10:05:00',2.04),('14598','2013-01-22','10:10:00',1.71),('14598','2013-01-22','10:15:00',2),('14598','2013-01-22','10:20:00',2.41),('14598','2013-01-22','10:25:00',2.45),('14598','2013-01-22','10:30:00',2.41),('14598','2013-01-22','10:35:00',1.48),('14598','2013-01-22','10:40:00',1.65),('14598','2013-01-22','10:45:00',1.96),('14598','2013-01-22','10:55:00',2.52),('14598','2013-01-22','11:00:00',3.08),('14598','2013-01-22','11:05:00',1.55),('14598','2013-01-22','11:15:00',2.79),('14598','2013-01-22','11:20:00',1.51),('14598','2013-01-22','11:25:00',2.34),('14598','2013-01-22','11:30:00',2.16),('14598','2013-01-22','11:35:00',2.42),('14598','2013-01-22','11:40:00',2.61),('14598','2013-01-22','11:45:00',2.09),('14598','2013-01-22','11:50:00',1.93),('14598','2013-01-22','11:55:00',2.86),('14598','2013-01-22','12:00:00',3.27),('14598','2013-01-22','12:05:00',1.15),('14598','2013-01-22','12:10:00',2.45),('14598','2013-01-22','12:15:00',3.87),('14598','2013-01-22','12:20:00',2.65),('14598','2013-01-22','12:25:00',1.32),('14598','2013-01-22','12:30:00',1.2),('14598','2013-01-22','12:35:00',2.84),('14598','2013-01-22','12:40:00',3.01),('14598','2013-01-22','12:45:00',2.48),('14598','2013-01-22','12:50:00',2.6),('14598','2013-01-22','12:55:00',3.15),('14598','2013-01-22','13:00:00',2.94),('14598','2013-01-22','13:05:00',1.95),('14598','2013-01-22','13:10:00',1.53),('14598','2013-01-22','13:15:00',1.95),('14598','2013-01-22','13:20:00',2.49),('14598','2013-01-22','13:25:00',2.32),('14598','2013-01-22','13:30:00',1.04),('14598','2013-01-22','13:35:00',2.38),('14598','2013-01-22','13:40:00',2.64),('14598','2013-01-22','13:45:00',3.06),('14598','2013-01-22','13:50:00',3.28),('14598','2013-01-22','13:55:00',3.16),('14598','2013-01-22','14:00:00',2.22),('14598','2013-01-22','14:05:00',2.25),('14598','2013-01-22','14:10:00',2.95),('14598','2013-01-22','14:15:00',3.02),('14598','2013-01-22','14:20:00',2.66),('14598','2013-01-22','14:25:00',1.82),('14598','2013-01-22','14:30:00',1.18),('14598','2013-01-22','14:40:00',1.64),('14598','2013-01-22','14:45:00',1.59),('14598','2013-01-22','14:50:00',1.31),('14598','2014-03-20','08:05:00',1.01),('14598','2014-03-20','08:10:00',1.17),('14598','2014-03-20','08:15:00',1.27),('14598','2014-03-20','08:20:00',1.39),('14598','2014-03-20','08:25:00',1.51),('14598','2014-03-20','08:30:00',1.66),('14598','2014-03-20','08:35:00',1.8),('14598','2014-03-20','08:40:00',1.88),('14598','2014-03-20','08:45:00',1.93),('14598','2014-03-20','08:50:00',1.98),('14598','2014-03-20','08:55:00',2.11),('14598','2014-03-20','09:00:00',2.21),('14598','2014-03-20','09:05:00',2.25),('14598','2014-03-20','09:10:00',2.35),('14598','2014-03-20','09:15:00',2.4),('14598','2014-03-20','09:20:00',2.47),('14598','2014-03-20','09:25:00',2.61),('14598','2014-03-20','09:30:00',2.64),('14598','2014-03-20','09:35:00',2.77),('14598','2014-03-20','09:40:00',2.83),('14598','2014-03-20','09:45:00',2.98),('14598','2014-03-20','09:50:00',3.06),('14598','2014-03-20','09:55:00',3.07),('14598','2014-03-20','10:00:00',3.12),('14598','2014-03-20','10:05:00',3.25),('14598','2014-03-20','10:10:00',3.33),('14598','2014-03-20','10:15:00',3.37),('14598','2014-03-20','10:20:00',3.42),('14598','2014-03-20','10:25:00',3.38),('14598','2014-03-20','10:30:00',3.27),('14598','2014-03-20','10:35:00',3.26),('14598','2014-03-20','10:40:00',3.36),('14598','2014-03-20','10:45:00',3.6),('14598','2014-03-20','10:50:00',3.81),('14598','2014-03-20','10:55:00',3.64),('14598','2014-03-20','11:00:00',3.27),('14598','2014-03-20','11:05:00',3.53),('14598','2014-03-20','11:10:00',3.63),('14598','2014-03-20','11:15:00',3.78),('14598','2014-03-20','11:20:00',3.81),('14598','2014-03-20','11:25:00',3.72),('14598','2014-03-20','11:30:00',3.74),('14598','2014-03-20','11:35:00',3.82),('14598','2014-03-20','11:40:00',3.87),('14598','2014-03-20','11:45:00',3.77),('14598','2014-03-20','11:50:00',3.75),('14598','2014-03-20','11:55:00',3.99),('14598','2014-03-20','12:00:00',4.1),('14598','2014-03-20','12:05:00',4.11),('14598','2014-03-20','12:10:00',4.02),('14598','2014-03-20','12:15:00',4.23),('14598','2014-03-20','12:20:00',4.35),('14598','2014-03-20','12:25:00',4.5),('14598','2014-03-20','12:30:00',4.48),('14598','2014-03-20','12:35:00',4.43),('14598','2014-03-20','12:40:00',4.44),('14598','2014-03-20','12:45:00',4.3),('14598','2014-03-20','12:50:00',4.23),('14598','2014-03-20','12:55:00',4.08),('14598','2014-03-20','13:00:00',4.15),('14598','2014-03-20','13:05:00',4.12),('14598','2014-03-20','13:10:00',4.18),('14598','2014-03-20','13:15:00',4.14),('14598','2014-03-20','13:20:00',3.89),('14598','2014-03-20','13:25:00',3.71),('14598','2014-03-20','13:30:00',3.9),('14598','2014-03-20','13:35:00',3.86),('14598','2014-03-20','13:40:00',4.11),('14598','2014-03-20','13:45:00',3.89),('14598','2014-03-20','13:50:00',3.81),('14598','2014-03-20','13:55:00',3.69),('14598','2014-03-20','14:00:00',3.66),('14598','2014-03-20','14:05:00',3.72),('14598','2014-03-20','14:10:00',3.59),('14598','2014-03-20','14:15:00',3.62),('14598','2014-03-20','14:20:00',3.72),('14598','2014-03-20','14:25:00',3.55),('14598','2014-03-20','14:30:00',3.48),('14598','2014-03-20','14:35:00',3.24),('14598','2014-03-20','14:40:00',3.3),('14598','2014-03-20','14:45:00',3.07),('14598','2014-03-20','14:50:00',2.85),('14598','2014-03-20','14:55:00',2.81),('14598','2014-03-20','15:00:00',2.84),('14598','2014-03-20','15:05:00',2.69),('14598','2014-03-20','15:10:00',2.75),('14598','2014-03-20','15:15:00',2.34),('14598','2014-03-20','15:20:00',2.2),('14598','2014-03-20','15:25:00',2.18),('14598','2014-03-20','15:30:00',2.23),('14598','2014-03-20','15:35:00',2.08),('14598','2014-03-20','15:40:00',2.12),('14598','2014-03-20','15:45:00',1.97),('14598','2014-03-20','15:50:00',1.67),('14598','2014-03-20','15:55:00',1.77),('14598','2014-03-20','16:00:00',1.48),('14598','2014-03-20','16:05:00',1.48),('14598','2014-03-20','16:10:00',1.4),('14598','2014-03-20','16:15:00',1.34),('14598','2014-03-20','16:20:00',1.62),('14598','2014-03-20','16:25:00',1.49),('14598','2014-03-20','16:30:00',1.28),('14598','2014-03-20','16:35:00',1.16),('14598','2014-03-20','16:40:00',1.1),('14598','2013-01-21','10:50:00',1.1),('14598','2013-01-21','10:55:00',1.4),('14598','2013-01-21','11:00:00',1.21),('14598','2013-01-21','11:10:00',1.11),('14598','2013-01-21','11:20:00',1),('14598','2013-01-21','11:30:00',2.48),('14598','2013-01-21','11:35:00',2.97),('14598','2013-01-21','11:40:00',2.97),('14598','2013-01-21','11:45:00',2.79),('14598','2013-01-21','11:50:00',3.15),('14598','2013-01-21','11:55:00',2.28),('14598','2013-01-21','12:00:00',1.88),('14598','2013-01-21','12:05:00',2.44),('14598','2013-01-21','12:10:00',1.72),('14598','2013-01-21','12:15:00',2.09),('14598','2013-01-21','12:25:00',1.12),('14598','2013-01-21','12:35:00',1.64),('14598','2013-01-21','12:40:00',1.87),('14598','2013-01-21','12:45:00',1.34),('14598','2013-01-21','12:50:00',1.18),('14598','2013-01-21','12:55:00',1.14),('14598','2013-01-21','13:00:00',2.97),('14598','2013-01-21','13:05:00',3.81),('14598','2013-01-21','13:10:00',3.25),('14598','2013-01-21','13:15:00',3.32),('14598','2013-01-21','13:20:00',3.34),('14598','2013-01-21','13:25:00',3.47),('14598','2013-01-21','13:30:00',2.8),('14598','2013-01-21','13:35:00',2.62),('14598','2013-01-21','13:40:00',3.37),('14598','2013-01-21','13:45:00',2.81),('14598','2013-01-21','13:50:00',2.56),('14598','2013-01-21','13:55:00',2.72),('14598','2013-01-21','14:00:00',2.2),('14598','2013-01-21','14:05:00',3.24),('14598','2013-01-21','14:10:00',2.16),('14598','2013-01-21','15:15:00',2.27),('14598','2013-01-21','15:20:00',2.11),('14598','2013-01-20','10:50:00',1.02),('14598','2013-01-20','11:05:00',1.07),('14598','2013-01-20','11:10:00',1.08),('14598','2013-01-20','11:15:00',1.22),('14598','2013-01-20','11:30:00',1.01),('14598','2013-01-20','11:35:00',1.12),('14598','2013-01-19','10:30:00',1.38),('14598','2013-01-19','10:35:00',1.16),('14598','2013-01-19','10:50:00',1.12),('14598','2013-01-19','14:15:00',1.15),('14598','2013-01-18','10:15:00',1.02),('14598','2013-01-18','11:00:00',1.02),('14598','2013-01-18','11:05:00',1.2),('14598','2013-01-18','11:10:00',1.44),('14598','2013-01-18','11:15:00',1.48),('14598','2013-01-18','11:20:00',2.12),('14598','2013-01-18','11:25:00',2.71),('14598','2013-01-18','11:30:00',2.08),('14598','2013-01-18','11:35:00',1.38),('14598','2013-01-18','11:40:00',1.51),('14598','2013-01-18','11:45:00',2.12),('14598','2013-01-18','11:50:00',2.13),('14598','2013-01-18','11:55:00',1.55),('14598','2013-01-18','12:00:00',1.54),('14598','2013-01-18','12:05:00',1.51),('14598','2013-01-18','12:10:00',1.61),('14598','2013-01-18','12:15:00',1.64),('14598','2013-01-18','12:20:00',1.48),('14598','2013-01-18','12:25:00',1.46),('14598','2013-01-18','12:30:00',1.61),('14598','2013-01-18','12:35:00',2.05),('14598','2013-01-18','12:40:00',2.19),('14598','2013-01-18','12:45:00',1.71),('14598','2013-01-18','12:50:00',1.79),('14598','2013-01-18','12:55:00',1.48),('14598','2013-01-18','13:00:00',1.45),('14598','2013-01-18','13:05:00',1.34),('14598','2013-01-18','13:10:00',1.32),('14598','2013-01-18','13:15:00',2.01),('14598','2013-01-18','13:20:00',2.01),('14598','2013-01-18','13:25:00',1.91),('14598','2013-01-18','13:30:00',1.72),('14598','2013-01-18','13:35:00',1.83),('14598','2013-01-18','13:40:00',3.26),('14598','2013-01-18','13:45:00',3.63),('14598','2013-01-18','13:50:00',3.37),('14598','2013-01-18','13:55:00',2.35),('14598','2013-01-18','14:00:00',2.98),('14598','2013-01-18','14:05:00',2.75),('14598','2013-01-18','14:10:00',2.91),('14598','2013-01-18','14:15:00',2.84),('14598','2013-01-18','14:20:00',2.87),('14598','2013-01-18','14:25:00',2.86),('14598','2013-01-18','14:30:00',2.77),('14598','2013-01-18','14:35:00',2.7),('14598','2013-01-18','14:40:00',2.79),('14598','2013-01-18','14:45:00',2.7),('14598','2013-01-18','14:50:00',2.84),('14598','2013-01-18','14:55:00',2.93),('14598','2013-01-18','15:00:00',2.8),('14598','2013-01-18','15:05:00',2.17),('14598','2013-01-18','15:10:00',2.62),('14598','2013-01-18','15:15:00',2.53),('14598','2013-01-18','15:20:00',2.43),('14598','2013-01-18','15:25:00',2.33),('14598','2013-01-18','15:30:00',1.81),('14598','2013-01-18','15:35:00',1.74),('14598','2013-01-18','15:40:00',1.59),('14598','2013-01-18','15:45:00',1.48),('14598','2013-01-18','15:50:00',1.31),('14598','2013-01-18','15:55:00',1.17),('14598','2013-01-18','16:00:00',1.1),('14598','2013-01-17','09:35:00',1.09),('14598','2013-01-17','09:40:00',1.34),('14598','2013-01-17','09:45:00',1.35),('14598','2013-01-17','09:50:00',1.25),('14598','2013-01-17','09:55:00',1.26),('14598','2013-01-17','10:00:00',1.31),('14598','2013-01-17','10:05:00',1.34),('14598','2013-01-17','10:10:00',1.72),('14598','2013-01-17','10:15:00',2.03),('14598','2013-01-17','10:20:00',1.78),('14598','2013-01-17','10:25:00',1.98),('14598','2013-01-17','10:30:00',1.66),('14598','2013-01-17','10:35:00',1.56),('14598','2013-01-17','10:40:00',1.58),('14598','2013-01-17','10:45:00',1.46),('14598','2013-01-17','10:50:00',1.33),('14598','2013-01-17','10:55:00',1.42),('14598','2013-01-17','11:00:00',1.86),('14598','2013-01-17','11:05:00',1.76),('14598','2013-01-17','11:10:00',1.55),('14598','2013-01-17','11:15:00',1.96),('14598','2013-01-17','11:20:00',2.15),('14598','2013-01-17','11:25:00',2.3),('14598','2013-01-17','11:30:00',2.17),('14598','2013-01-17','11:35:00',1.82),('14598','2013-01-17','11:40:00',1.71),('14598','2013-01-17','11:45:00',1.8),('14598','2013-01-17','11:50:00',1.65),('14598','2013-01-17','11:55:00',1.99),('14598','2013-01-17','12:00:00',1.96),('14598','2013-01-17','12:05:00',1.69),('14598','2013-01-17','12:10:00',2.18),('14598','2013-01-17','12:15:00',2.1),('14598','2013-01-17','12:20:00',1.83),('14598','2013-01-17','12:25:00',2.15),('14598','2013-01-17','12:30:00',2.05),('14598','2013-01-17','12:35:00',1.36),('14598','2013-01-17','12:40:00',1.79),('14598','2013-01-17','12:45:00',1.94),('14598','2013-01-17','12:50:00',1.93),('14598','2013-01-17','12:55:00',1.4),('14598','2013-01-17','13:00:00',1.93),('14598','2013-01-17','13:05:00',1.55),('14598','2013-01-17','13:10:00',1),('14598','2013-01-17','13:15:00',1.41),('14598','2013-01-17','13:20:00',1.78),('14598','2013-01-17','13:25:00',2.06),('14598','2013-01-17','13:30:00',2.35),('14598','2013-01-17','13:35:00',1.96),('14598','2013-01-17','13:40:00',1.5),('14598','2013-01-17','13:45:00',1.22),('14598','2013-01-17','13:50:00',1.06),('14598','2013-01-17','14:15:00',1.24),('14598','2013-01-17','14:20:00',1.14),('14598','2013-01-17','14:30:00',1.05),('14598','2013-01-17','14:35:00',1.07),('14598','2013-01-17','14:50:00',1.12),('14598','2013-01-17','14:55:00',1.19),('14598','2013-01-16','09:05:00',1.38),('14598','2013-01-16','09:15:00',1.26),('14598','2013-01-16','09:20:00',1.38),('14598','2013-01-16','09:25:00',1.66),('14598','2013-01-16','09:30:00',1.55),('14598','2013-01-16','09:35:00',1.51),('14598','2013-01-16','10:10:00',1.42),('14598','2013-01-16','10:15:00',2.29),('14598','2013-01-16','10:20:00',2.49),('14598','2013-01-16','10:25:00',2.11),('14598','2013-01-16','10:30:00',1.69),('14598','2013-01-16','10:35:00',2.18),('14598','2013-01-16','10:40:00',3.09),('14598','2013-01-16','10:45:00',2.17),('14598','2013-01-16','11:45:00',1.03),('14598','2013-01-16','11:50:00',1.24),('14598','2013-01-16','11:55:00',1.72),('14598','2013-01-16','12:00:00',1.49),('14598','2013-01-16','12:05:00',1.37),('14598','2013-01-16','12:20:00',3.16),('14598','2013-01-16','12:25:00',3.05),('14598','2013-01-16','12:50:00',1.12),('14598','2013-01-16','12:55:00',3.68),('14598','2013-01-16','13:00:00',1.27),('14598','2013-01-16','15:40:00',1.06),('14598','2013-01-16','15:45:00',1.72),('14598','2013-01-16','15:50:00',1.52),('14598','2013-01-16','15:55:00',1.29),('14598','2013-01-16','16:00:00',1.13),('14598','2013-01-15','09:35:00',1.18),('14598','2013-01-15','10:15:00',1.23),('14598','2013-01-15','10:20:00',1.03),('14598','2013-01-15','10:25:00',1.06),('14598','2013-01-15','10:30:00',2.41),('14598','2013-01-15','10:35:00',2.25),('14598','2013-01-15','11:00:00',1.16),('14598','2013-01-15','11:05:00',1.28),('14598','2013-01-15','11:10:00',1.33),('14598','2013-01-15','11:15:00',1.17),('14598','2013-01-15','11:20:00',1.15),('14598','2013-01-15','11:25:00',1.17),('14598','2013-01-15','11:30:00',1.19),('14598','2013-01-15','11:35:00',1.24),('14598','2013-01-15','11:40:00',1.32),('14598','2013-01-15','11:45:00',1.09),('14598','2013-01-15','11:50:00',1.17),('14598','2013-01-15','11:55:00',1.26),('14598','2013-01-15','12:00:00',1.31),('14598','2013-01-15','12:05:00',1.44),('14598','2013-01-15','12:10:00',1.45),('14598','2013-01-15','12:15:00',1.47),('14598','2013-01-15','12:20:00',1.52),('14598','2013-01-15','12:25:00',1.51),('14598','2013-01-15','12:30:00',1.52),('14598','2013-01-15','12:35:00',1.67),('14598','2013-01-15','12:40:00',1.81),('14598','2013-01-15','12:45:00',1.65),('14598','2013-01-15','12:50:00',1.51),('14598','2013-01-15','12:55:00',1.83),('14598','2013-01-15','13:00:00',1.94),('14598','2013-01-15','13:05:00',1.87),('14598','2013-01-15','13:10:00',2.09),('14598','2013-01-15','13:15:00',2.02),('14598','2013-01-15','13:20:00',1.9),('14598','2013-01-15','13:25:00',1.99),('14598','2013-01-15','13:30:00',2.12),('14598','2013-01-15','13:35:00',2.79),('14598','2013-01-15','13:40:00',2.84),('14598','2013-01-15','13:45:00',2.49),('14598','2013-01-15','13:50:00',2.98),('14598','2013-01-15','13:55:00',1.59),('14598','2013-01-15','14:00:00',1.87),('14598','2013-01-15','14:05:00',1.75),('14598','2013-01-15','14:10:00',1.76),('14598','2013-01-15','14:15:00',3.12),('14598','2013-01-15','14:20:00',2.97),('14598','2013-01-15','14:25:00',2.75),('14598','2013-01-15','14:30:00',2.6),('14598','2013-01-15','14:35:00',2.45),('14598','2013-01-15','14:40:00',2.19),('14598','2013-01-15','14:45:00',2.42),('14598','2013-01-15','14:50:00',2.36),('14598','2013-01-15','14:55:00',2.28),('14598','2013-01-15','15:00:00',2.18),('14598','2013-01-15','15:05:00',2.12),('14598','2013-01-15','15:10:00',2.05),('14598','2013-01-15','15:15:00',1.99),('14598','2013-01-15','15:20:00',1.92),('14598','2013-01-15','15:25:00',1.87),('14598','2013-01-15','15:30:00',1.81),('14598','2013-01-15','15:35:00',1.74),('14598','2013-01-15','15:40:00',1.68),('14598','2013-01-15','15:45:00',1.66),('14598','2013-01-15','15:50:00',1.63),('14598','2013-01-15','15:55:00',1.58),('14598','2013-01-15','16:00:00',1.49),('14598','2013-01-15','16:05:00',1.39),('14598','2013-01-15','16:10:00',1.26),('14598','2013-01-15','16:15:00',1.11),('14598','2013-01-14','10:20:00',1.13),('14598','2013-01-14','10:25:00',1.19),('14598','2013-01-14','10:55:00',1.03),('14598','2013-01-14','11:00:00',1.05),('14598','2013-01-14','11:05:00',1.25),('14598','2013-01-14','11:10:00',1.23),('14598','2013-01-14','11:15:00',1.35),('14598','2013-01-14','11:20:00',1.53),('14598','2013-01-14','11:25:00',1.39),('14598','2013-01-14','11:30:00',1.02),('14598','2013-01-14','15:00:00',1.34),('14598','2013-01-14','15:05:00',1.2),('14598','2013-01-13','10:10:00',1.19),('14598','2013-01-13','10:55:00',1.23),('14598','2013-01-13','11:00:00',1.02),('14598','2013-01-13','11:35:00',1.02),('14598','2013-01-13','11:40:00',1.15),('14598','2013-01-13','11:45:00',1.22),('14598','2013-01-13','11:50:00',1.24),('14598','2013-01-13','11:55:00',1.43),('14598','2013-01-13','12:00:00',1.24),('14598','2013-01-12','09:25:00',1.01),('14598','2013-01-12','09:30:00',1.12),('14598','2013-01-12','09:35:00',1.22),('14598','2013-01-12','09:40:00',1.32),('14598','2013-01-12','09:45:00',1.44),('14598','2013-01-12','09:50:00',1.56),('14598','2013-01-12','09:55:00',1.64),('14598','2013-01-12','10:00:00',1.72),('14598','2013-01-12','10:05:00',1.81),('14598','2013-01-12','10:10:00',1.86),('14598','2013-01-12','10:15:00',1.96),('14598','2013-01-12','10:20:00',2.03),('14598','2013-01-12','10:25:00',2.09),('14598','2013-01-12','10:30:00',2.14),('14598','2013-01-12','10:35:00',2.22),('14598','2013-01-12','10:40:00',2.28),('14598','2013-01-12','10:45:00',2.33),('14598','2013-01-12','10:50:00',2.39),('14598','2013-01-12','10:55:00',2.45),('14598','2013-01-12','11:00:00',2.51),('14598','2013-01-12','11:05:00',2.56),('14598','2013-01-12','11:10:00',2.61),('14598','2013-01-12','11:15:00',2.65),('14598','2013-01-12','11:20:00',2.69),('14598','2013-01-12','11:25:00',2.7),('14598','2013-01-12','11:30:00',2.73),('14598','2013-01-12','11:35:00',2.78),('14598','2013-01-12','11:40:00',2.82),('14598','2013-01-12','11:45:00',2.87),('14598','2013-01-12','11:50:00',2.9),('14598','2013-01-12','11:55:00',2.93),('14598','2013-01-12','12:00:00',2.94),('14598','2013-01-12','12:05:00',2.96),('14598','2013-01-12','12:10:00',2.97),('14598','2013-01-12','12:15:00',2.97),('14598','2013-01-12','12:20:00',2.98),('14598','2013-01-12','12:25:00',2.99),('14598','2013-01-12','12:30:00',3.01),('14598','2013-01-12','12:35:00',2.99),('14598','2013-01-12','12:40:00',2.4),('14598','2013-01-12','12:45:00',1.74),('14598','2013-01-12','12:50:00',1.6),('14598','2013-01-12','12:55:00',2.39),('14598','2013-01-12','13:00:00',1.72),('14598','2013-01-12','13:05:00',3.16),('14598','2013-01-12','13:10:00',1.39),('14598','2013-01-12','13:15:00',2.71),('14598','2013-01-12','13:20:00',3.46),('14598','2013-01-12','13:25:00',3.07),('14598','2013-01-12','13:30:00',2.93),('14598','2013-01-12','13:35:00',2.92),('14598','2013-01-12','13:40:00',2.9),('14598','2013-01-12','13:45:00',2.84),('14598','2013-01-12','13:50:00',2.81),('14598','2013-01-12','13:55:00',2.77),('14598','2013-01-12','14:00:00',2.71),('14598','2013-01-12','14:05:00',2.68),('14598','2013-01-12','14:10:00',2.65),('14598','2013-01-12','14:15:00',2.62),('14598','2013-01-12','14:20:00',2.56),('14598','2013-01-12','14:25:00',2.46),('14598','2013-01-12','14:30:00',2.41),('14598','2013-01-12','14:35:00',2.39),('14598','2013-01-12','14:40:00',2.33),('14598','2013-01-12','14:45:00',2.25),('14598','2013-01-12','14:50:00',2.18),('14598','2013-01-12','14:55:00',2.09),('14598','2013-01-12','15:00:00',1.99),('14598','2013-01-12','15:05:00',1.89),('14598','2013-01-12','15:10:00',1.87),('14598','2013-01-12','15:15:00',1.79),('14598','2013-01-12','15:20:00',1.69),('14598','2013-01-12','15:25:00',1.6),('14598','2013-01-12','15:30:00',1.53),('14598','2013-01-12','15:35:00',1.41),('14598','2013-01-12','15:40:00',1.3),('14598','2013-01-12','15:45:00',1.2),('14598','2013-01-12','15:50:00',1.11),('14598','2013-01-12','15:55:00',1.01),('14598','2014-03-19','08:35:00',1.08),('14598','2014-03-19','08:40:00',1.19),('14598','2014-03-19','08:45:00',1.25),('14598','2014-03-19','08:50:00',1.4),('14598','2014-03-19','08:55:00',1.43),('14598','2014-03-19','09:00:00',1.45),('14598','2014-03-19','09:05:00',1.46),('14598','2014-03-19','09:10:00',1.54),('14598','2014-03-19','09:15:00',2.13),('14598','2014-03-19','09:20:00',1.96),('14598','2014-03-19','09:25:00',2.1),('14598','2014-03-19','09:30:00',2.32),('14598','2014-03-19','09:35:00',2.36),('14598','2014-03-19','09:40:00',2.52),('14598','2014-03-19','09:45:00',1.93),('14598','2014-03-19','09:50:00',1.86),('14598','2014-03-19','09:55:00',1.67),('14598','2014-03-19','10:00:00',2.19),('14598','2014-03-19','10:05:00',4.01),('14598','2014-03-19','10:10:00',4.59),('14598','2014-03-19','10:15:00',4.66),('14598','2014-03-19','10:20:00',3.54),('14598','2014-03-19','10:25:00',2.14),('14598','2014-03-19','10:30:00',2.62),('14598','2014-03-19','10:35:00',4.73),('14598','2014-03-19','10:40:00',4.39),('14598','2014-03-19','10:45:00',4.41),('14598','2014-03-19','10:50:00',4.38),('14598','2014-03-19','10:55:00',4.64),('14598','2014-03-19','11:00:00',4.77),('14598','2014-03-19','11:05:00',4.76),('14598','2014-03-19','11:10:00',4.75),('14598','2014-03-19','11:15:00',4.17),('14598','2014-03-19','11:20:00',4.33),('14598','2014-03-19','11:25:00',5.06),('14598','2014-03-19','11:30:00',4.96),('14598','2014-03-19','11:35:00',4.68),('14598','2014-03-19','11:40:00',4.68),('14598','2014-03-19','11:45:00',4.63),('14598','2014-03-19','11:50:00',4.67),('14598','2014-03-19','11:55:00',4.59),('14598','2014-03-19','12:00:00',4.69),('14598','2014-03-19','12:05:00',4.57),('14598','2014-03-19','12:10:00',4.45),('14598','2014-03-19','12:15:00',4.66),('14598','2014-03-19','12:20:00',4.63),('14598','2014-03-19','12:25:00',4.63),('14598','2014-03-19','12:30:00',4.54),('14598','2014-03-19','12:35:00',4.61),('14598','2014-03-19','12:40:00',4.52),('14598','2014-03-19','12:45:00',4.49),('14598','2014-03-19','12:50:00',4.34),('14598','2014-03-19','12:55:00',4),('14598','2014-03-19','13:00:00',4.19),('14598','2014-03-19','13:05:00',3.91),('14598','2014-03-19','13:10:00',4.61),('14598','2014-03-19','13:15:00',4.34),('14598','2014-03-19','13:20:00',4.46),('14598','2014-03-19','13:25:00',4.31),('14598','2014-03-19','13:30:00',4.41),('14598','2014-03-19','13:35:00',4.44),('14598','2014-03-19','13:40:00',4.42),('14598','2014-03-19','13:45:00',4.39),('14598','2014-03-19','13:50:00',4.32),('14598','2014-03-19','13:55:00',4.29),('14598','2014-03-19','14:00:00',4.27),('14598','2014-03-19','14:05:00',4.22),('14598','2014-03-19','14:10:00',4.16),('14598','2014-03-19','14:15:00',4.17),('14598','2014-03-19','14:20:00',4.02),('14598','2014-03-19','14:25:00',4.09),('14598','2014-03-19','14:30:00',4.04),('14598','2014-03-19','14:35:00',3.97),('14598','2014-03-19','14:40:00',3.93),('14598','2014-03-19','14:45:00',3.92),('14598','2014-03-19','14:50:00',3.86),('14598','2014-03-19','14:55:00',3.79),('14598','2014-03-19','15:00:00',3.75),('14598','2014-03-19','15:05:00',3.66),('14598','2014-03-19','15:10:00',3.62),('14598','2014-03-19','15:15:00',3.54),('14598','2014-03-19','15:20:00',3.42),('14598','2014-03-19','15:25:00',3.31),('14598','2014-03-19','15:30:00',3.2),('14598','2014-03-19','15:35:00',3.16),('14598','2014-03-19','15:40:00',3.1),('14598','2014-03-19','15:45:00',3.04),('14598','2014-03-19','15:50:00',2.96),('14598','2014-03-19','15:55:00',2.86),('14598','2014-03-19','16:00:00',2.77),('14598','2014-03-19','16:05:00',2.64),('14598','2014-03-19','16:10:00',2.53),('14598','2014-03-19','16:15:00',2.44),('14598','2014-03-19','16:20:00',2.28),('14598','2014-03-19','16:25:00',2.07),('14598','2014-03-19','16:30:00',1.99),('14598','2014-03-19','16:35:00',1.99),('14598','2014-03-19','16:40:00',1.77),('14598','2014-03-19','16:45:00',1.65),('14598','2014-03-19','16:50:00',1.45),('14598','2014-03-19','16:55:00',1.33),('14598','2014-03-19','17:05:00',1.04),('14598','2014-03-19','17:10:00',1.03),('14598','2014-03-19','17:15:00',1.06),('14598','2013-01-11','09:45:00',1.12),('14598','2013-01-11','09:50:00',1.38),('14598','2013-01-11','09:55:00',1.53),('14598','2013-01-11','10:00:00',1.56),('14598','2013-01-11','10:05:00',1.67),('14598','2013-01-11','10:10:00',1.74),('14598','2013-01-11','10:15:00',1.82),('14598','2013-01-11','10:20:00',1.9),('14598','2013-01-11','10:25:00',1.98),('14598','2013-01-11','10:30:00',2.05),('14598','2013-01-11','10:35:00',2.08),('14598','2013-01-11','10:40:00',2.13),('14598','2013-01-11','10:45:00',2.18),('14598','2013-01-11','10:50:00',2.2),('14598','2013-01-11','10:55:00',2.29),('14598','2013-01-11','11:00:00',1.48),('14598','2013-01-11','11:05:00',1.28),('14598','2013-01-11','11:10:00',1.12),('14598','2013-01-11','11:15:00',1.34),('14598','2013-01-11','11:20:00',1.66),('14598','2013-01-11','11:25:00',1.21),('14598','2013-01-11','11:30:00',1.99),('14598','2013-01-11','11:35:00',1.37),('14598','2013-01-11','11:40:00',1.09),('14598','2013-01-11','12:00:00',1.07),('14598','2013-01-11','12:25:00',1.31),('14598','2013-01-11','12:30:00',2.08),('14598','2013-01-11','12:35:00',2.41),('14598','2013-01-11','12:40:00',1.45),('14598','2013-01-11','12:45:00',1.63),('14598','2013-01-11','13:15:00',3.09),('14598','2013-01-11','13:20:00',2.55),('14598','2013-01-11','13:25:00',2.22),('14598','2013-01-11','13:30:00',1.06),('14598','2013-01-11','13:50:00',2.12),('14598','2013-01-11','14:10:00',1.54),('14598','2013-01-11','14:15:00',1.28),('14598','2013-01-11','14:20:00',2.07),('14598','2013-01-11','14:25:00',2.88),('14598','2013-01-11','14:30:00',1.56),('14598','2013-01-11','14:35:00',1.41),('14598','2013-01-11','14:40:00',2.36),('14598','2013-01-11','14:45:00',1.76),('14598','2013-01-11','14:50:00',2.03),('14598','2013-01-10','11:55:00',1.07),('14598','2013-01-10','12:00:00',1.34),('14598','2013-01-10','12:05:00',1.64),('14598','2013-01-10','12:10:00',1.42),('14598','2013-01-10','12:15:00',1.17),('14598','2013-01-10','13:00:00',1.11),('14598','2013-01-10','13:05:00',1.14),('14598','2013-01-10','13:25:00',1.03),('14598','2013-01-10','13:30:00',1.06),('14598','2013-01-09','10:05:00',1.03),('14598','2013-01-09','10:10:00',1.37),('14598','2013-01-09','10:15:00',2.54),('14598','2013-01-09','10:20:00',1.73),('14598','2013-01-09','10:25:00',1.94),('14598','2013-01-09','10:30:00',1.35),('14598','2013-01-09','10:35:00',1.15),('14598','2013-01-09','10:40:00',1.1),('14598','2013-01-09','10:45:00',1.29),('14598','2013-01-09','10:50:00',2.53),('14598','2013-01-09','10:55:00',1.67),('14598','2013-01-09','11:00:00',1.67),('14598','2013-01-09','11:05:00',1.57),('14598','2013-01-09','11:10:00',1.44),('14598','2013-01-09','11:15:00',1.56),('14598','2013-01-09','11:20:00',1.8),('14598','2013-01-09','11:25:00',1.85),('14598','2013-01-09','11:30:00',3.05),('14598','2013-01-09','11:35:00',2.5),('14598','2013-01-09','11:40:00',3.06),('14598','2013-01-09','11:45:00',2.32),('14598','2013-01-09','11:50:00',2.94),('14598','2013-01-09','11:55:00',2.57),('14598','2013-01-09','12:00:00',2.85),('14598','2013-01-09','12:05:00',2.81),('14598','2013-01-09','12:10:00',2.89),('14598','2013-01-09','12:15:00',2.93),('14598','2013-01-09','12:20:00',2.78),('14598','2013-01-09','12:25:00',2.3),('14598','2013-01-09','12:30:00',2.97),('14598','2013-01-09','12:35:00',2.93),('14598','2013-01-09','12:40:00',2.9),('14598','2013-01-09','12:45:00',2.89),('14598','2013-01-09','12:50:00',2.87),('14598','2013-01-09','12:55:00',2.89),('14598','2013-01-09','13:00:00',2.84),('14598','2013-01-09','13:05:00',2.81),('14598','2013-01-09','13:10:00',2.73),('14598','2013-01-09','13:15:00',2.79),('14598','2013-01-09','13:20:00',2.68),('14598','2013-01-09','13:25:00',2.78),('14598','2013-01-09','13:30:00',2.72),('14598','2013-01-09','13:35:00',2.72),('14598','2013-01-09','13:40:00',2.2),('14598','2013-01-09','13:45:00',1.59),('14598','2013-01-09','13:50:00',1.46),('14598','2013-01-09','13:55:00',1.9),('14598','2013-01-09','14:00:00',1.93),('14598','2013-01-09','14:05:00',2.49),('14598','2013-01-09','14:10:00',2.81),('14598','2013-01-09','14:15:00',2.71),('14598','2013-01-09','14:20:00',2.22),('14598','2013-01-09','14:25:00',1.46),('14598','2013-01-09','14:30:00',1.38),('14598','2013-01-09','14:35:00',2.03),('14598','2013-01-09','14:40:00',2.17),('14598','2013-01-09','14:45:00',1.98),('14598','2013-01-09','14:50:00',1.97),('14598','2013-01-09','14:55:00',1.8),('14598','2013-01-09','15:00:00',1.5),('14598','2013-01-09','15:05:00',1.32),('14598','2013-01-09','15:10:00',1.5),('14598','2013-01-09','15:15:00',1.68),('14598','2013-01-09','15:20:00',1.57),('14598','2013-01-09','15:25:00',1.45),('14598','2013-01-09','15:30:00',1.39),('14598','2013-01-09','15:35:00',1.3),('14598','2013-01-09','15:40:00',1.14),('14598','2013-01-09','15:50:00',1.09),('14598','2013-01-09','15:55:00',1.04),('14598','2013-01-08','10:20:00',1.42),('14598','2013-01-08','10:25:00',1.89),('14598','2013-01-08','10:30:00',2.07),('14598','2013-01-08','10:35:00',2.12),('14598','2013-01-08','10:40:00',2.14),('14598','2013-01-08','10:45:00',2.15),('14598','2013-01-08','10:50:00',2.32),('14598','2013-01-08','10:55:00',2.38),('14598','2013-01-08','11:00:00',2.44),('14598','2013-01-08','11:05:00',2.5),('14598','2013-01-08','11:10:00',2.51),('14598','2013-01-08','11:15:00',2.53),('14598','2013-01-08','11:20:00',2.65),('14598','2013-01-08','11:25:00',2.65),('14598','2013-01-08','11:30:00',2.71),('14598','2013-01-08','11:35:00',2.74),('14598','2013-01-08','11:40:00',2.79),('14598','2013-01-08','11:45:00',2.87),('14598','2013-01-08','11:50:00',1.89),('14598','2013-01-08','11:55:00',1.41),('14598','2013-01-08','12:00:00',1.36),('14598','2013-01-08','12:05:00',1.97),('14598','2013-01-08','12:10:00',2.04),('14598','2013-01-08','12:15:00',2.41),('14598','2013-01-08','12:20:00',2.17),('14598','2013-01-08','12:25:00',1.63),('14598','2013-01-08','12:30:00',1.48),('14598','2013-01-08','12:35:00',1.26),('14598','2013-01-08','12:40:00',1.14),('14598','2013-01-08','12:45:00',1.01),('14598','2013-01-07','09:30:00',1.06),('14598','2013-01-07','09:35:00',1.15),('14598','2013-01-07','09:40:00',1.25),('14598','2013-01-07','09:45:00',1.38),('14598','2013-01-07','09:50:00',1.48),('14598','2013-01-07','09:55:00',1.55),('14598','2013-01-07','10:00:00',1.63),('14598','2013-01-07','10:05:00',1.72),('14598','2013-01-07','10:10:00',1.8),('14598','2013-01-07','10:15:00',1.87),('14598','2013-01-07','10:20:00',1.94),('14598','2013-01-07','10:25:00',2.01),('14598','2013-01-07','10:30:00',2.08),('14598','2013-01-07','10:35:00',2.14),('14598','2013-01-07','10:40:00',2.2),('14598','2013-01-07','10:45:00',2.25),('14598','2013-01-07','10:50:00',2.3),('14598','2013-01-07','10:55:00',2.37),('14598','2013-01-07','11:00:00',2.42),('14598','2013-01-07','11:05:00',2.47),('14598','2013-01-07','11:10:00',2.52),('14598','2013-01-07','11:15:00',2.57),('14598','2013-01-07','11:20:00',2.6),('14598','2013-01-07','11:25:00',2.63),('14598','2013-01-07','11:30:00',2.68),('14598','2013-01-07','11:35:00',2.71),('14598','2013-01-07','11:40:00',2.75),('14598','2013-01-07','11:45:00',2.77),('14598','2013-01-07','11:50:00',2.8),('14598','2013-01-07','11:55:00',2.81),('14598','2013-01-07','12:00:00',2.8),('14598','2013-01-07','12:05:00',2.87),('14598','2013-01-07','12:10:00',2.87),('14598','2013-01-07','12:15:00',2.86),('14598','2013-01-07','12:20:00',2.84),('14598','2013-01-07','12:25:00',2.86),('14598','2013-01-07','12:30:00',2.89),('14598','2013-01-07','12:35:00',2.9),('14598','2013-01-07','12:40:00',2.9),('14598','2013-01-07','12:45:00',2.9),('14598','2013-01-07','12:50:00',2.9),('14598','2013-01-07','12:55:00',2.88),('14598','2013-01-07','13:00:00',2.87),('14598','2013-01-07','13:05:00',2.87),('14598','2013-01-07','13:10:00',2.86),('14598','2013-01-07','13:15:00',2.83),('14598','2013-01-07','13:20:00',2.81),('14598','2013-01-07','13:25:00',2.79),('14598','2013-01-07','13:30:00',2.76),('14598','2013-01-07','13:35:00',2.71),('14598','2013-01-07','13:40:00',2.68),('14598','2013-01-07','13:45:00',2.65),('14598','2013-01-07','13:50:00',2.63),('14598','2013-01-07','13:55:00',2.6),('14598','2013-01-07','14:00:00',2.56),('14598','2013-01-07','14:05:00',2.52),('14598','2013-01-07','14:10:00',2.48),('14598','2013-01-07','14:15:00',2.43),('14598','2013-01-07','14:20:00',2.38),('14598','2013-01-07','14:25:00',2.33),('14598','2013-01-07','14:30:00',2.26),('14598','2013-01-07','14:35:00',2.19),('14598','2013-01-07','14:40:00',2.13),('14598','2013-01-07','14:45:00',2.07),('14598','2013-01-07','14:50:00',2.01),('14598','2013-01-07','14:55:00',1.97),('14598','2013-01-07','15:00:00',1.87),('14598','2013-01-07','15:05:00',1.83),('14598','2013-01-07','15:10:00',1.75),('14598','2013-01-07','15:15:00',1.68),('14598','2013-01-07','15:20:00',1.61),('14598','2013-01-07','15:25:00',1.51),('14598','2013-01-07','15:30:00',1.42),('14598','2013-01-07','15:35:00',1.33),('14598','2013-01-07','15:40:00',1.25),('14598','2013-01-07','15:45:00',1.16),('14598','2013-01-07','15:50:00',1.07),('14598','2013-01-06','09:30:00',1.11),('14598','2013-01-06','09:35:00',1.2),('14598','2013-01-06','09:40:00',1.29),('14598','2013-01-06','09:45:00',1.41),('14598','2013-01-06','09:50:00',1.5),('14598','2013-01-06','09:55:00',1.58),('14598','2013-01-06','10:00:00',1.67),('14598','2013-01-06','10:05:00',1.74),('14598','2013-01-06','10:10:00',1.81),('14598','2013-01-06','10:15:00',1.89),('14598','2013-01-06','10:20:00',1.96),('14598','2013-01-06','10:25:00',2.02),('14598','2013-01-06','10:30:00',2.08),('14598','2013-01-06','10:35:00',2.14),('14598','2013-01-06','10:40:00',2.19),('14598','2013-01-06','10:45:00',2.25),('14598','2013-01-06','10:50:00',2.3),('14598','2013-01-06','10:55:00',2.32),('14598','2013-01-06','11:00:00',2.35),('14598','2013-01-06','11:05:00',2.43),('14598','2013-01-06','11:10:00',2.49),('14598','2013-01-06','11:15:00',2.51),('14598','2013-01-06','11:20:00',2.54),('14598','2013-01-06','11:25:00',2.57),('14598','2013-01-06','11:30:00',2.61),('14598','2013-01-06','11:35:00',2.66),('14598','2013-01-06','11:40:00',2.72),('14598','2013-01-06','11:45:00',2.78),('14598','2013-01-06','11:50:00',2.8),('14598','2013-01-06','11:55:00',2.82),('14598','2013-01-06','12:00:00',2.84),('14598','2013-01-06','12:05:00',2.87),('14598','2013-01-06','12:10:00',2.89),('14598','2013-01-06','12:15:00',2.88),('14598','2013-01-06','12:20:00',2.9),('14598','2013-01-06','12:25:00',2.87),('14598','2013-01-06','12:30:00',2.89),('14598','2013-01-06','12:35:00',2.9),('14598','2013-01-06','12:40:00',2.92),('14598','2013-01-06','12:45:00',2.88),('14598','2013-01-06','12:50:00',2.87),('14598','2013-01-06','12:55:00',2.88),('14598','2013-01-06','13:00:00',2.87),('14598','2013-01-06','13:05:00',2.85),('14598','2013-01-06','13:10:00',2.82),('14598','2013-01-06','13:15:00',2.8),('14598','2013-01-06','13:20:00',2.76),('14598','2013-01-06','13:25:00',2.73),('14598','2013-01-06','13:30:00',2.68),('14598','2013-01-06','13:35:00',2.67),('14598','2013-01-06','13:40:00',2.64),('14598','2013-01-06','13:45:00',2.61),('14598','2013-01-06','13:50:00',2.55),('14598','2013-01-06','13:55:00',2.52),('14598','2013-01-06','14:00:00',2.5),('14598','2013-01-06','14:05:00',2.52),('14598','2013-01-06','14:10:00',2.49),('14598','2013-01-06','14:15:00',2.46),('14598','2013-01-06','14:20:00',2.42),('14598','2013-01-06','14:25:00',2.37),('14598','2013-01-06','14:30:00',2.3),('14598','2013-01-06','14:35:00',2.25),('14598','2013-01-06','14:40:00',2.17),('14598','2013-01-06','14:45:00',2.1),('14598','2013-01-06','14:50:00',2.03),('14598','2013-01-06','14:55:00',1.93),('14598','2013-01-06','15:00:00',1.86),('14598','2013-01-06','15:05:00',1.79),('14598','2013-01-06','15:10:00',1.71),('14598','2013-01-06','15:15:00',1.63),('14598','2013-01-06','15:20:00',1.58),('14598','2013-01-06','15:25:00',1.5),('14598','2013-01-06','15:30:00',1.4),('14598','2013-01-06','15:35:00',1.27),('14598','2013-01-06','15:40:00',1.17),('14598','2013-01-06','15:45:00',1.09),('14598','2013-01-05','10:20:00',1.18),('14598','2013-01-05','10:25:00',1.55),('14598','2013-01-05','10:30:00',1.94),('14598','2013-01-05','10:35:00',1.78),('14598','2013-01-05','10:40:00',1.84),('14598','2013-01-05','10:45:00',1.94),('14598','2013-01-05','10:50:00',1.93),('14598','2013-01-05','10:55:00',1.84),('14598','2013-01-05','11:00:00',1.74),('14598','2013-01-05','11:05:00',1.96),('14598','2013-01-05','11:10:00',2.17),('14598','2013-01-05','11:15:00',2.4),('14598','2013-01-05','11:20:00',2.39),('14598','2013-01-05','11:25:00',2.54),('14598','2013-01-05','11:30:00',2.52),('14598','2013-01-05','11:35:00',2.65),('14598','2013-01-05','11:40:00',2.62),('14598','2013-01-05','11:45:00',2.5),('14598','2013-01-05','11:50:00',2.46),('14598','2013-01-05','11:55:00',2.38),('14598','2013-01-05','12:00:00',2.43),('14598','2013-01-05','12:05:00',2.18),('14598','2013-01-05','12:10:00',2.34),('14598','2013-01-05','12:15:00',2.58),('14598','2013-01-05','12:20:00',2.39),('14598','2013-01-05','12:25:00',2.35),('14598','2013-01-05','12:30:00',2.09),('14598','2013-01-05','12:35:00',1.93),('14598','2013-01-05','12:40:00',1.96),('14598','2013-01-05','12:45:00',2.58),('14598','2013-01-05','12:50:00',2.37),('14598','2013-01-05','12:55:00',2.5),('14598','2013-01-05','13:00:00',3.09),('14598','2013-01-05','13:05:00',3),('14598','2013-01-05','13:10:00',2.86),('14598','2013-01-05','13:15:00',1.62),('14598','2013-01-05','13:20:00',2.07),('14598','2013-01-05','13:25:00',2.65),('14598','2013-01-05','13:30:00',2.73),('14598','2013-01-05','13:35:00',2.9),('14598','2013-01-05','13:40:00',2.86),('14598','2013-01-05','13:45:00',2.45),('14598','2013-01-05','13:50:00',2.6),('14598','2013-01-05','13:55:00',2.23),('14598','2013-01-05','14:00:00',2.56),('14598','2013-01-05','14:05:00',2.6),('14598','2013-01-05','14:10:00',2.54),('14598','2013-01-05','14:15:00',2.62),('14598','2013-01-05','14:20:00',2.46),('14598','2013-01-05','14:25:00',2.44),('14598','2013-01-05','14:30:00',2.34),('14598','2013-01-05','14:35:00',1.77),('14598','2013-01-05','14:40:00',2.08),('14598','2013-01-05','14:45:00',2.08),('14598','2013-01-05','14:50:00',1.55),('14598','2013-01-05','14:55:00',1.6),('14598','2013-01-05','15:00:00',1.84),('14598','2013-01-05','15:05:00',1.79),('14598','2013-01-05','15:10:00',1.9),('14598','2013-01-05','15:15:00',1.8),('14598','2013-01-05','15:20:00',1.76),('14598','2013-01-05','15:25:00',1.46),('14598','2013-01-05','15:30:00',1.26),('14598','2013-01-05','15:35:00',1.09),('14598','2013-01-05','15:40:00',1.2),('14598','2013-01-05','15:45:00',1.11),('14598','2013-01-04','09:30:00',1.11),('14598','2013-01-04','09:35:00',1.12),('14598','2013-01-04','09:40:00',1.23),('14598','2013-01-04','09:45:00',1.42),('14598','2013-01-04','09:50:00',1.34),('14598','2013-01-04','09:55:00',1.68),('14598','2013-01-04','10:00:00',1.92),('14598','2013-01-04','10:05:00',2.15),('14598','2013-01-04','10:10:00',2.08),('14598','2013-01-04','10:15:00',2.01),('14598','2013-01-04','10:20:00',1.71),('14598','2013-01-04','10:25:00',1.29),('14598','2013-01-04','10:30:00',1.13),('14598','2013-01-04','10:35:00',1.43),('14598','2013-01-04','10:40:00',2.2),('14598','2013-01-04','10:45:00',1.49),('14598','2013-01-04','10:50:00',1.75),('14598','2013-01-04','10:55:00',2.52),('14598','2013-01-04','11:00:00',2.71),('14598','2013-01-04','11:05:00',2.92),('14598','2013-01-04','11:10:00',3.05),('14598','2013-01-04','11:15:00',3.12),('14598','2013-01-04','11:20:00',2.56),('14598','2013-01-04','11:25:00',1.41),('14598','2013-01-04','11:30:00',1.1),('14598','2013-01-04','11:40:00',1.22),('14598','2013-01-04','11:45:00',1.61),('14598','2013-01-04','11:50:00',2.39),('14598','2013-01-04','11:55:00',1.31),('14598','2013-01-04','12:00:00',1.55),('14598','2013-01-04','12:05:00',2.99),('14598','2013-01-04','12:10:00',2.56),('14598','2013-01-04','12:15:00',2.29),('14598','2013-01-04','12:20:00',1.84),('14598','2013-01-04','12:25:00',1.36),('14598','2013-01-04','12:30:00',1.62),('14598','2013-01-04','12:35:00',1.45),('14598','2013-01-04','12:40:00',2.25),('14598','2013-01-04','12:45:00',2.88),('14598','2013-01-04','12:50:00',3.06),('14598','2013-01-04','12:55:00',3.17),('14598','2013-01-04','13:00:00',3.14),('14598','2013-01-04','13:05:00',3.02),('14598','2013-01-04','13:10:00',2.82),('14598','2013-01-04','13:15:00',1.96),('14598','2013-01-04','13:20:00',1.86),('14598','2013-01-04','13:25:00',2.7),('14598','2013-01-04','13:30:00',2.68),('14598','2013-01-04','13:35:00',2.65),('14598','2013-01-04','13:40:00',2.6),('14598','2013-01-04','13:45:00',2.58),('14598','2013-01-04','13:50:00',2.56),('14598','2013-01-04','13:55:00',2.53),('14598','2013-01-04','14:00:00',2.48),('14598','2013-01-04','14:05:00',2.44),('14598','2013-01-04','14:10:00',2.41),('14598','2013-01-04','14:15:00',2.4),('14598','2013-01-04','14:20:00',2.34),('14598','2013-01-04','14:25:00',2.28),('14598','2013-01-04','14:30:00',2.22),('14598','2013-01-04','14:35:00',2.19),('14598','2013-01-04','14:40:00',2.13),('14598','2013-01-04','14:45:00',2.06),('14598','2013-01-04','14:50:00',2.01),('14598','2013-01-04','14:55:00',1.94),('14598','2013-01-04','15:00:00',1.86),('14598','2013-01-04','15:05:00',1.8),('14598','2013-01-04','15:10:00',1.74),('14598','2013-01-04','15:15:00',1.67),('14598','2013-01-04','15:20:00',1.6),('14598','2013-01-04','15:25:00',1.5),('14598','2013-01-04','15:30:00',1.41),('14598','2013-01-04','15:35:00',1.33),('14598','2013-01-04','15:50:00',1.13),('14598','2013-01-04','15:55:00',1.13),('14598','2013-01-04','16:00:00',1.02),('14598','2013-01-03','09:25:00',1.01),('14598','2013-01-03','09:30:00',1.11),('14598','2013-01-03','09:35:00',1.22),('14598','2013-01-03','09:40:00',1.36),('14598','2013-01-03','09:45:00',1.52),('14598','2013-01-03','09:50:00',1.67),('14598','2013-01-03','09:55:00',1.77),('14598','2013-01-03','10:00:00',1.93),('14598','2013-01-03','10:05:00',2.02),('14598','2013-01-03','10:10:00',2.3),('14598','2013-01-03','10:15:00',1.72),('14598','2013-01-03','10:20:00',2.24),('14598','2013-01-03','10:25:00',2.01),('14598','2013-01-03','10:30:00',1.98),('14598','2013-01-03','10:35:00',1.72),('14598','2013-01-03','10:40:00',1.71),('14598','2013-01-03','10:45:00',1.56),('14598','2013-01-03','10:50:00',1.6),('14598','2013-01-03','10:55:00',1.75),('14598','2013-01-03','11:00:00',1.72),('14598','2013-01-03','11:05:00',1.89),('14598','2013-01-03','11:10:00',2.27),('14598','2013-01-03','11:15:00',2.43),('14598','2013-01-03','11:20:00',2.14),('14598','2013-01-03','11:25:00',2.26),('14598','2013-01-03','11:30:00',2.79),('14598','2013-01-03','11:35:00',2.64),('14598','2013-01-03','11:40:00',2.69),('14598','2013-01-03','11:45:00',2.72),('14598','2013-01-03','11:50:00',2.73),('14598','2013-01-03','11:55:00',2.75),('14598','2013-01-03','12:00:00',2.76),('14598','2013-01-03','12:05:00',2.78),('14598','2013-01-03','12:10:00',2.8),('14598','2013-01-03','12:15:00',2.8),('14598','2013-01-03','12:20:00',2.8),('14598','2013-01-03','12:25:00',2.82),('14598','2013-01-03','12:30:00',2.84),('14598','2013-01-03','12:35:00',2.84),('14598','2013-01-03','12:40:00',2.83),('14598','2013-01-03','12:45:00',2.83),('14598','2013-01-03','12:50:00',2.83),('14598','2013-01-03','12:55:00',2.81),('14598','2013-01-03','13:00:00',2.8),('14598','2013-01-03','13:05:00',2.79),('14598','2013-01-03','13:10:00',2.76),('14598','2013-01-03','13:15:00',2.77),('14598','2013-01-03','13:20:00',2.72),('14598','2013-01-03','13:25:00',2.71),('14598','2013-01-03','13:30:00',2.7),('14598','2013-01-03','13:35:00',2.66),('14598','2013-01-03','13:40:00',2.64),('14598','2013-01-03','13:45:00',2.61),('14598','2013-01-03','13:50:00',2.57),('14598','2013-01-03','13:55:00',2.53),('14598','2013-01-03','14:00:00',2.48),('14598','2013-01-03','14:05:00',2.45),('14598','2013-01-03','14:10:00',2.39),('14598','2013-01-03','14:15:00',2.35),('14598','2013-01-03','14:20:00',2.31),('14598','2013-01-03','14:25:00',2.24),('14598','2013-01-03','14:30:00',2.18),('14598','2013-01-03','14:35:00',2.11),('14598','2013-01-03','14:40:00',2.07),('14598','2013-01-03','14:45:00',2.01),('14598','2013-01-03','14:50:00',1.95),('14598','2013-01-03','14:55:00',1.9),('14598','2013-01-03','15:00:00',1.83),('14598','2013-01-03','15:05:00',1.74),('14598','2013-01-03','15:10:00',1.63),('14598','2013-01-03','15:15:00',1.57),('14598','2013-01-03','15:20:00',1.52),('14598','2013-01-03','15:25:00',1.43),('14598','2013-01-03','15:30:00',1.36),('14598','2013-01-03','15:35:00',1.2),('14598','2013-01-03','15:40:00',1.05),('14598','2013-01-02','10:35:00',1.08),('14598','2013-01-02','10:40:00',1.02),('14598','2013-01-02','10:55:00',1.07),('14598','2013-01-02','11:00:00',1.46),('14598','2013-01-02','11:05:00',1.87),('14598','2013-01-02','11:10:00',1.82),('14598','2013-01-02','11:15:00',1.89),('14598','2013-01-02','11:20:00',2),('14598','2013-01-02','11:25:00',2.06),('14598','2013-01-02','11:30:00',2.01),('14598','2013-01-02','11:35:00',1.63),('14598','2013-01-02','11:40:00',1.32),('14598','2013-01-02','11:45:00',1.02),('14598','2013-01-02','11:50:00',1.17),('14598','2013-01-02','11:55:00',1.4),('14598','2013-01-02','12:00:00',1.48),('14598','2013-01-02','12:05:00',1.57),('14598','2013-01-02','12:10:00',1.56),('14598','2013-01-02','12:15:00',1.68),('14598','2013-01-02','12:20:00',1.63),('14598','2013-01-02','12:25:00',1.46),('14598','2013-01-02','12:30:00',1.42),('14598','2013-01-02','12:35:00',1.4),('14598','2013-01-02','12:40:00',1.61),('14598','2013-01-02','12:45:00',1.8),('14598','2013-01-02','12:50:00',1.83),('14598','2013-01-02','12:55:00',2.03),('14598','2013-01-02','13:00:00',2.6),('14598','2013-01-02','13:05:00',2.54),('14598','2013-01-02','13:10:00',2.19),('14598','2013-01-02','13:15:00',1.63),('14598','2013-01-02','13:20:00',1.38),('14598','2013-01-02','13:25:00',1.55),('14598','2013-01-02','13:30:00',1.66),('14598','2013-01-02','13:35:00',1.68),('14598','2013-01-02','13:40:00',1.64),('14598','2013-01-02','13:45:00',1.39),('14598','2013-01-02','13:50:00',1.15),('14598','2013-01-02','13:55:00',1.06),('14598','2014-03-18','08:05:00',1.05),('14598','2014-03-18','08:10:00',1.26),('14598','2014-03-18','08:15:00',1.35),('14598','2014-03-18','08:20:00',1.4),('14598','2014-03-18','08:25:00',1.35),('14598','2014-03-18','08:30:00',1.65),('14598','2014-03-18','08:35:00',1.7),('14598','2014-03-18','08:40:00',1.76),('14598','2014-03-18','08:45:00',1.86),('14598','2014-03-18','08:50:00',2),('14598','2014-03-18','08:55:00',2.08),('14598','2014-03-18','09:00:00',2),('14598','2014-03-18','09:05:00',2.22),('14598','2014-03-18','09:10:00',2.39),('14598','2014-03-18','09:15:00',2.52),('14598','2014-03-18','09:20:00',2.6),('14598','2014-03-18','09:25:00',2.64),('14598','2014-03-18','09:30:00',2.8),('14598','2014-03-18','09:35:00',2.55),('14598','2014-03-18','09:40:00',3.12),('14598','2014-03-18','09:45:00',2.98),('14598','2014-03-18','09:50:00',3.02),('14598','2014-03-18','09:55:00',3.13),('14598','2014-03-18','10:00:00',3.21),('14598','2014-03-18','10:05:00',3.17),('14598','2014-03-18','10:10:00',3.18),('14598','2014-03-18','10:15:00',3.43),('14598','2014-03-18','10:20:00',3.53),('14598','2014-03-18','10:25:00',3.6),('14598','2014-03-18','10:30:00',3.68),('14598','2014-03-18','10:35:00',3.72),('14598','2014-03-18','10:40:00',3.77),('14598','2014-03-18','10:45:00',3.85),('14598','2014-03-18','10:50:00',3.9),('14598','2014-03-18','10:55:00',3.94),('14598','2014-03-18','11:00:00',4),('14598','2014-03-18','11:05:00',4.02),('14598','2014-03-18','11:10:00',4.1),('14598','2014-03-18','11:15:00',4.11),('14598','2014-03-18','11:20:00',4.16),('14598','2014-03-18','11:25:00',4.19),('14598','2014-03-18','11:30:00',4.25),('14598','2014-03-18','11:35:00',4.27),('14598','2014-03-18','11:40:00',4.3),('14598','2014-03-18','11:45:00',4.32),('14598','2014-03-18','11:50:00',4.34),('14598','2014-03-18','11:55:00',4.39),('14598','2014-03-18','12:00:00',4.41),('14598','2014-03-18','12:05:00',4.39),('14598','2014-03-18','12:10:00',4.46),('14598','2014-03-18','12:15:00',4.5),('14598','2014-03-18','12:20:00',4.46),('14598','2014-03-18','12:25:00',4.52),('14598','2014-03-18','12:30:00',4.52),('14598','2014-03-18','12:35:00',4.53),('14598','2014-03-18','12:40:00',4.55),('14598','2014-03-18','12:45:00',4.53),('14598','2014-03-18','12:50:00',4.53),('14598','2014-03-18','12:55:00',4.51),('14598','2014-03-18','13:00:00',4.54),('14598','2014-03-18','13:05:00',4.52),('14598','2014-03-18','13:10:00',4.5),('14598','2014-03-18','13:15:00',4.5),('14598','2014-03-18','13:20:00',4.45),('14598','2014-03-18','13:25:00',4.45),('14598','2014-03-18','13:30:00',4.41),('14598','2014-03-18','13:35:00',4.4),('14598','2014-03-18','13:40:00',4.36),('14598','2014-03-18','13:45:00',4.34),('14598','2014-03-18','13:50:00',4.31),('14598','2014-03-18','13:55:00',4.29),('14598','2014-03-18','14:00:00',4.24),('14598','2014-03-18','14:05:00',4.24),('14598','2014-03-18','14:10:00',4.13),('14598','2014-03-18','14:15:00',4.11),('14598','2014-03-18','14:20:00',4.05),('14598','2014-03-18','14:25:00',4.07),('14598','2014-03-18','14:30:00',4),('14598','2014-03-18','14:35:00',3.94),('14598','2014-03-18','14:40:00',3.91),('14598','2014-03-18','14:45:00',3.83),('14598','2014-03-18','14:50:00',3.67),('14598','2014-03-18','14:55:00',3.71),('14598','2014-03-18','15:00:00',3.63),('14598','2014-03-18','15:05:00',3.56),('14598','2014-03-18','15:10:00',3.44),('14598','2014-03-18','15:15:00',3.44),('14598','2014-03-18','15:20:00',3.47),('14598','2014-03-18','15:25:00',2.94),('14598','2014-03-18','15:30:00',3.25),('14598','2014-03-18','15:35:00',3.25),('14598','2014-03-18','15:40:00',3.05),('14598','2014-03-18','15:45:00',2.98),('14598','2014-03-18','15:50:00',2.92),('14598','2014-03-18','15:55:00',2.83),('14598','2014-03-18','16:00:00',2.71),('14598','2014-03-18','16:05:00',2.64),('14598','2014-03-18','16:10:00',2.5),('14598','2014-03-18','16:15:00',2.44),('14598','2014-03-18','16:20:00',2.3),('14598','2014-03-18','16:25:00',2.21),('14598','2014-03-18','16:30:00',2.04),('14598','2014-03-18','16:35:00',2.01),('14598','2014-03-18','16:40:00',1.72),('14598','2014-03-18','16:45:00',1.77),('14598','2014-03-18','16:50:00',1.69),('14598','2014-03-18','16:55:00',1.56),('14598','2014-03-18','17:00:00',1.46),('14598','2014-03-18','17:05:00',1.34),('14598','2014-03-18','17:10:00',1.16),('14598','2014-03-18','17:15:00',1.08),('14598','2013-01-01','09:10:00',1.01),('14598','2013-01-01','09:15:00',1),('14598','2013-01-01','09:20:00',1.02),('14598','2013-01-01','09:25:00',1.15),('14598','2013-01-01','09:30:00',1.08),('14598','2013-01-01','09:35:00',1.2),('14598','2013-01-01','09:40:00',1.29),('14598','2013-01-01','09:45:00',1.42),('14598','2013-01-01','09:50:00',1.55),('14598','2013-01-01','09:55:00',1.65),('14598','2013-01-01','10:00:00',2.16),('14598','2013-01-01','10:05:00',1.69),('14598','2013-01-01','10:10:00',1.38),('14598','2013-01-01','10:15:00',1.12),('14598','2013-01-01','10:40:00',1.16),('14598','2013-01-01','10:45:00',1.33),('14598','2013-01-01','10:50:00',1.54),('14598','2013-01-01','10:55:00',1.28),('14598','2013-01-01','11:00:00',1.52),('14598','2013-01-01','11:05:00',2.04),('14598','2013-01-01','11:10:00',2.55),('14598','2013-01-01','11:15:00',2.83),('14598','2013-01-01','11:20:00',2.51),('14598','2013-01-01','11:25:00',2),('14598','2013-01-01','11:30:00',2.03),('14598','2013-01-01','11:35:00',2.88),('14598','2013-01-01','11:40:00',1.4),('14598','2013-01-01','11:45:00',1.19),('14598','2013-01-01','11:50:00',1.1),('14598','2013-01-01','11:55:00',1.1),('14598','2013-01-01','12:00:00',1.05),('14598','2013-01-01','13:55:00',1.16),('14598','2013-01-01','14:00:00',1.28),('14598','2013-01-01','14:05:00',1.76),('14598','2013-01-01','14:10:00',1.03),('14598','2013-01-01','14:15:00',1.42),('14598','2013-01-01','14:20:00',1.62),('14598','2013-01-01','14:25:00',1.4),('14598','2013-01-01','14:30:00',1.43),('14598','2012-12-31','09:25:00',1.1),('14598','2012-12-31','09:30:00',1.19),('14598','2012-12-31','09:35:00',1.29),('14598','2012-12-31','09:40:00',1.41),('14598','2012-12-31','09:45:00',1.33),('14598','2012-12-31','09:50:00',1.49),('14598','2012-12-31','09:55:00',1.67),('14598','2012-12-31','10:00:00',1.75),('14598','2012-12-31','10:05:00',1.8),('14598','2012-12-31','10:10:00',1.85),('14598','2012-12-31','10:15:00',1.91),('14598','2012-12-31','10:20:00',1.94),('14598','2012-12-31','10:25:00',2),('14598','2012-12-31','10:30:00',2.1),('14598','2012-12-31','10:35:00',2.19),('14598','2012-12-31','10:40:00',2.23),('14598','2012-12-31','10:45:00',2.31),('14598','2012-12-31','10:50:00',2.37),('14598','2012-12-31','10:55:00',2.38),('14598','2012-12-31','11:00:00',2.44),('14598','2012-12-31','11:05:00',2.52),('14598','2012-12-31','11:10:00',2.57),('14598','2012-12-31','11:15:00',2.6),('14598','2012-12-31','11:20:00',2.65),('14598','2012-12-31','11:25:00',2.69),('14598','2012-12-31','11:30:00',2.73),('14598','2012-12-31','11:35:00',2.77),('14598','2012-12-31','11:40:00',2.79),('14598','2012-12-31','11:45:00',2.82),('14598','2012-12-31','11:50:00',2.84),('14598','2012-12-31','11:55:00',2.86),('14598','2012-12-31','12:00:00',2.89),('14598','2012-12-31','12:05:00',2.92),('14598','2012-12-31','12:10:00',2.92),('14598','2012-12-31','12:15:00',2.93),('14598','2012-12-31','12:20:00',2.94),('14598','2012-12-31','12:25:00',2.94),('14598','2012-12-31','12:30:00',2.93),('14598','2012-12-31','12:35:00',2.92),('14598','2012-12-31','12:40:00',2.93),('14598','2012-12-31','12:45:00',2.92),('14598','2012-12-31','12:50:00',2.9),('14598','2012-12-31','12:55:00',2.89),('14598','2012-12-31','13:00:00',2.88),('14598','2012-12-31','13:05:00',2.88),('14598','2012-12-31','13:10:00',2.87),('14598','2012-12-31','13:15:00',2.86),('14598','2012-12-31','13:20:00',2.83),('14598','2012-12-31','13:25:00',2.8),('14598','2012-12-31','13:30:00',2.78),('14598','2012-12-31','13:35:00',2.75),('14598','2012-12-31','13:40:00',2.72),('14598','2012-12-31','13:45:00',2.68),('14598','2012-12-31','13:50:00',2.64),('14598','2012-12-31','13:55:00',2.59),('14598','2012-12-31','14:00:00',2.55),('14598','2012-12-31','14:05:00',2.5),('14598','2012-12-31','14:10:00',2.47),('14598','2012-12-31','14:15:00',2.41),('14598','2012-12-31','14:20:00',2.37),('14598','2012-12-31','14:25:00',2.33),('14598','2012-12-31','14:30:00',2.27),('14598','2012-12-31','14:35:00',2.22),('14598','2012-12-31','14:40:00',2.15),('14598','2012-12-31','14:45:00',2.06),('14598','2012-12-31','14:50:00',1.97),('14598','2012-12-31','14:55:00',1.91),('14598','2012-12-31','15:00:00',1.83),('14598','2012-12-31','15:05:00',1.73),('14598','2012-12-31','15:10:00',1.64),('14598','2012-12-31','15:15:00',1.54),('14598','2012-12-31','15:20:00',1.48),('14598','2012-12-31','15:25:00',1.41),('14598','2012-12-31','15:30:00',1.31),('14598','2012-12-31','15:35:00',1.22),('14598','2012-12-31','15:40:00',1.14),('14598','2012-12-31','15:45:00',1.05),('14598','2012-12-30','09:25:00',1.02),('14598','2012-12-30','09:30:00',1.11),('14598','2012-12-30','09:35:00',1.21),('14598','2012-12-30','09:40:00',1.32),('14598','2012-12-30','09:45:00',1.42),('14598','2012-12-30','09:50:00',1.51),('14598','2012-12-30','09:55:00',1.59),('14598','2012-12-30','10:00:00',1.67),('14598','2012-12-30','10:05:00',1.75),('14598','2012-12-30','10:10:00',1.83),('14598','2012-12-30','10:15:00',1.9),('14598','2012-12-30','10:20:00',1.97),('14598','2012-12-30','10:25:00',2.04),('14598','2012-12-30','10:30:00',2.1),('14598','2012-12-30','10:35:00',2.17),('14598','2012-12-30','10:40:00',2.23),('14598','2012-12-30','10:45:00',2.28),('14598','2012-12-30','10:50:00',2.34),('14598','2012-12-30','10:55:00',2.39),('14598','2012-12-30','11:00:00',2.44),('14598','2012-12-30','11:05:00',2.49),('14598','2012-12-30','11:10:00',2.54),('14598','2012-12-30','11:15:00',2.58),('14598','2012-12-30','11:20:00',2.63),('14598','2012-12-30','11:25:00',2.67),('14598','2012-12-30','11:30:00',2.69),('14598','2012-12-30','11:35:00',2.74),('14598','2012-12-30','11:40:00',2.77),('14598','2012-12-30','11:45:00',2.81),('14598','2012-12-30','11:50:00',2.84),('14598','2012-12-30','11:55:00',2.85),('14598','2012-12-30','12:00:00',2.89),('14598','2012-12-30','12:05:00',2.91),('14598','2012-12-30','12:10:00',2.93),('14598','2012-12-30','12:15:00',2.93),('14598','2012-12-30','12:20:00',2.94),('14598','2012-12-30','12:25:00',2.95),('14598','2012-12-30','12:30:00',2.95),('14598','2012-12-30','12:35:00',2.93),('14598','2012-12-30','12:40:00',2.92),('14598','2012-12-30','12:45:00',2.9),('14598','2012-12-30','12:50:00',2.9),('14598','2012-12-30','12:55:00',2.9),('14598','2012-12-30','13:00:00',2.88),('14598','2012-12-30','13:05:00',2.88),('14598','2012-12-30','13:10:00',2.86),('14598','2012-12-30','13:15:00',2.83),('14598','2012-12-30','13:20:00',2.83),('14598','2012-12-30','13:25:00',2.81),('14598','2012-12-30','13:30:00',2.81),('14598','2012-12-30','13:35:00',2.79),('14598','2012-12-30','13:40:00',2.75),('14598','2012-12-30','13:45:00',2.72),('14598','2012-12-30','13:50:00',2.68),('14598','2012-12-30','13:55:00',2.64),('14598','2012-12-30','14:00:00',2.59),('14598','2012-12-30','14:05:00',2.54),('14598','2012-12-30','14:10:00',2.5),('14598','2012-12-30','14:15:00',2.45),('14598','2012-12-30','14:20:00',2.4),('14598','2012-12-30','14:25:00',2.34),('14598','2012-12-30','14:30:00',2.25),('14598','2012-12-30','14:35:00',2.22),('14598','2012-12-30','14:40:00',2.15),('14598','2012-12-30','14:45:00',2.09),('14598','2012-12-30','14:50:00',2.02),('14598','2012-12-30','14:55:00',1.95),('14598','2012-12-30','15:00:00',1.88),('14598','2012-12-30','15:05:00',1.8),('14598','2012-12-30','15:10:00',1.73),('14598','2012-12-30','15:15:00',1.65),('14598','2012-12-30','15:20:00',1.57),('14598','2012-12-30','15:25:00',1.48),('14598','2012-12-30','15:30:00',1.39),('14598','2012-12-30','15:35:00',1.3),('14598','2012-12-30','15:40:00',1.2),('14598','2012-12-30','15:45:00',1.1),('14598','2012-12-30','15:50:00',1),('14598','2012-12-29','09:25:00',1.04),('14598','2012-12-29','09:30:00',1.13),('14598','2012-12-29','09:35:00',1.22),('14598','2012-12-29','09:40:00',1.33),('14598','2012-12-29','09:45:00',1.43),('14598','2012-12-29','09:50:00',1.52),('14598','2012-12-29','09:55:00',1.59),('14598','2012-12-29','10:00:00',1.67),('14598','2012-12-29','10:05:00',1.75),('14598','2012-12-29','10:10:00',1.82),('14598','2012-12-29','10:15:00',1.89),('14598','2012-12-29','10:20:00',1.97),('14598','2012-12-29','10:25:00',2.04),('14598','2012-12-29','10:30:00',2.1),('14598','2012-12-29','10:35:00',2.16),('14598','2012-12-29','10:40:00',2.22),('14598','2012-12-29','10:45:00',2.28),('14598','2012-12-29','10:50:00',2.33),('14598','2012-12-29','10:55:00',2.38),('14598','2012-12-29','11:00:00',2.44),('14598','2012-12-29','11:05:00',2.48),('14598','2012-12-29','11:10:00',2.53),('14598','2012-12-29','11:15:00',2.58),('14598','2012-12-29','11:20:00',2.62),('14598','2012-12-29','11:25:00',2.67),('14598','2012-12-29','11:30:00',2.7),('14598','2012-12-29','11:35:00',2.75),('14598','2012-12-29','11:40:00',2.78),('14598','2012-12-29','11:45:00',2.8),('14598','2012-12-29','11:50:00',2.82),('14598','2012-12-29','11:55:00',2.84),('14598','2012-12-29','12:00:00',2.85),('14598','2012-12-29','12:05:00',2.89),('14598','2012-12-29','12:10:00',2.91),('14598','2012-12-29','12:15:00',2.93),('14598','2012-12-29','12:20:00',2.92),('14598','2012-12-29','12:25:00',2.92),('14598','2012-12-29','12:30:00',2.92),('14598','2012-12-29','12:35:00',2.92),('14598','2012-12-29','12:40:00',2.92),('14598','2012-12-29','12:45:00',2.87),('14598','2012-12-29','12:50:00',2.88),('14598','2012-12-29','12:55:00',2.86),('14598','2012-12-29','13:00:00',2.85),('14598','2012-12-29','13:05:00',2.86),('14598','2012-12-29','13:10:00',2.85),('14598','2012-12-29','13:15:00',2.83),('14598','2012-12-29','13:20:00',2.81),('14598','2012-12-29','13:25:00',2.8),('14598','2012-12-29','13:30:00',2.8),('14598','2012-12-29','13:35:00',2.77),('14598','2012-12-29','13:40:00',2.75),('14598','2012-12-29','13:45:00',2.72),('14598','2012-12-29','13:50:00',2.68),('14598','2012-12-29','13:55:00',2.65),('14598','2012-12-29','14:00:00',2.62),('14598','2012-12-29','14:05:00',2.57),('14598','2012-12-29','14:10:00',2.53),('14598','2012-12-29','14:15:00',2.47),('14598','2012-12-29','14:20:00',2.42),('14598','2012-12-29','14:25:00',2.37),('14598','2012-12-29','14:30:00',2.3),('14598','2012-12-29','14:35:00',2.23),('14598','2012-12-29','14:40:00',2.15),('14598','2012-12-29','14:45:00',2.08),('14598','2012-12-29','14:50:00',2.02),('14598','2012-12-29','14:55:00',1.95),('14598','2012-12-29','15:00:00',1.87),('14598','2012-12-29','15:05:00',1.8),('14598','2012-12-29','15:10:00',1.73),('14598','2012-12-29','15:15:00',1.65),('14598','2012-12-29','15:20:00',1.56),('14598','2012-12-29','15:25:00',1.47),('14598','2012-12-29','15:30:00',1.39),('14598','2012-12-29','15:35:00',1.31),('14598','2012-12-29','15:40:00',1.19),('14598','2012-12-29','15:45:00',1.09),('14598','2012-12-29','15:50:00',1.01),('14598','2012-12-28','09:30:00',1.04),('14598','2012-12-28','09:35:00',1.13),('14598','2012-12-28','09:40:00',1.25),('14598','2012-12-28','09:45:00',1.35),('14598','2012-12-28','09:50:00',1.44),('14598','2012-12-28','09:55:00',1.52),('14598','2012-12-28','10:00:00',1.61),('14598','2012-12-28','10:05:00',1.69),('14598','2012-12-28','10:10:00',1.74),('14598','2012-12-28','10:15:00',1.8),('14598','2012-12-28','10:20:00',1.87),('14598','2012-12-28','10:25:00',1.94),('14598','2012-12-28','10:30:00',2),('14598','2012-12-28','10:35:00',2.06),('14598','2012-12-28','10:40:00',2.11),('14598','2012-12-28','10:45:00',2.13),('14598','2012-12-28','10:50:00',2.21),('14598','2012-12-28','10:55:00',2.28),('14598','2012-12-28','11:00:00',2.33),('14598','2012-12-28','11:05:00',2.37),('14598','2012-12-28','11:10:00',2.43),('14598','2012-12-28','11:15:00',2.47),('14598','2012-12-28','11:20:00',2.53),('14598','2012-12-28','11:25:00',2.58),('14598','2012-12-28','11:30:00',2.63),('14598','2012-12-28','11:35:00',2.65),('14598','2012-12-28','11:40:00',2.69),('14598','2012-12-28','11:45:00',2.73),('14598','2012-12-28','11:50:00',2.76),('14598','2012-12-28','11:55:00',2.79),('14598','2012-12-28','12:00:00',2.8),('14598','2012-12-28','12:05:00',2.86),('14598','2012-12-28','12:10:00',2.86),('14598','2012-12-28','12:15:00',2.86),('14598','2012-12-28','12:20:00',2.87),('14598','2012-12-28','12:25:00',2.87),('14598','2012-12-28','12:30:00',2.85),('14598','2012-12-28','12:35:00',2.87),('14598','2012-12-28','12:40:00',2.87),('14598','2012-12-28','12:45:00',2.87),('14598','2012-12-28','12:50:00',2.86),('14598','2012-12-28','12:55:00',2.85),('14598','2012-12-28','13:00:00',2.84),('14598','2012-12-28','13:05:00',2.82),('14598','2012-12-28','13:10:00',2.79),('14598','2012-12-28','13:15:00',2.78),('14598','2012-12-28','13:20:00',2.77),('14598','2012-12-28','13:25:00',2.76),('14598','2012-12-28','13:30:00',2.74),('14598','2012-12-28','13:35:00',2.71),('14598','2012-12-28','13:40:00',2.68),('14598','2012-12-28','13:45:00',2.65),('14598','2012-12-28','13:50:00',2.62),('14598','2012-12-28','13:55:00',2.58),('14598','2012-12-28','14:00:00',2.54),('14598','2012-12-28','14:05:00',2.5),('14598','2012-12-28','14:10:00',2.45),('14598','2012-12-28','14:15:00',2.38),('14598','2012-12-28','14:20:00',2.32),('14598','2012-12-28','14:25:00',2.27),('14598','2012-12-28','14:30:00',2.2),('14598','2012-12-28','14:35:00',2.15),('14598','2012-12-28','14:40:00',2.08),('14598','2012-12-28','14:45:00',2.01),('14598','2012-12-28','14:50:00',1.93),('14598','2012-12-28','14:55:00',1.85),('14598','2012-12-28','15:00:00',1.77),('14598','2012-12-28','15:05:00',1.69),('14598','2012-12-28','15:10:00',1.63),('14598','2012-12-28','15:15:00',1.55),('14598','2012-12-28','15:20:00',1.46),('14598','2012-12-28','15:25:00',1.38),('14598','2012-12-28','15:30:00',1.3),('14598','2012-12-28','15:35:00',1.21),('14598','2012-12-28','15:40:00',1.12),('14598','2012-12-28','15:45:00',1.03),('14598','2012-12-27','09:30:00',1.26),('14598','2012-12-27','09:35:00',1),('14598','2012-12-27','09:40:00',1.15),('14598','2012-12-27','09:45:00',1.41),('14598','2012-12-27','09:50:00',1.32),('14598','2012-12-27','10:05:00',1.12),('14598','2012-12-27','10:10:00',1.35),('14598','2012-12-27','10:15:00',1.82),('14598','2012-12-27','10:20:00',1.82),('14598','2012-12-27','10:25:00',1.8),('14598','2012-12-27','10:30:00',1.9),('14598','2012-12-27','10:35:00',1.99),('14598','2012-12-27','10:40:00',2.03),('14598','2012-12-27','10:45:00',2.02),('14598','2012-12-27','10:50:00',2.14),('14598','2012-12-27','10:55:00',2.2),('14598','2012-12-27','11:00:00',2.23),('14598','2012-12-27','11:05:00',2.26),('14598','2012-12-27','11:10:00',2.28),('14598','2012-12-27','11:15:00',2.31),('14598','2012-12-27','11:20:00',2.39),('14598','2012-12-27','11:25:00',2.46),('14598','2012-12-27','11:30:00',2.49),('14598','2012-12-27','11:35:00',2.51),('14598','2012-12-27','11:40:00',2.45),('14598','2012-12-27','11:45:00',2.48),('14598','2012-12-27','11:50:00',2.95),('14598','2012-12-27','11:55:00',1.06),('14598','2012-12-27','12:00:00',1.95),('14598','2012-12-27','12:05:00',3.15),('14598','2012-12-27','12:10:00',2.95),('14598','2012-12-27','12:15:00',2.86),('14598','2012-12-27','12:20:00',2.86),('14598','2012-12-27','12:25:00',2.83),('14598','2012-12-27','12:30:00',2.8),('14598','2012-12-27','12:35:00',2.77),('14598','2012-12-27','12:40:00',2.78),('14598','2012-12-27','12:45:00',2.81),('14598','2012-12-27','12:50:00',2.77),('14598','2012-12-27','12:55:00',2.73),('14598','2012-12-27','13:00:00',2.83),('14598','2012-12-27','13:05:00',2.19),('14598','2012-12-27','13:10:00',2.84),('14598','2012-12-27','13:15:00',2.73),('14598','2012-12-27','13:20:00',2.68),('14598','2012-12-27','13:25:00',2.68),('14598','2012-12-27','13:30:00',2.68),('14598','2012-12-27','13:35:00',2.6),('14598','2012-12-27','13:40:00',2.59),('14598','2012-12-27','13:45:00',2.56),('14598','2012-12-27','13:50:00',2.54),('14598','2012-12-27','13:55:00',1.25),('14598','2012-12-27','14:00:00',1.06),('14598','2012-12-27','14:05:00',1.51),('14598','2012-12-27','14:10:00',2.4),('14598','2012-12-27','14:15:00',2.28),('14598','2012-12-27','14:20:00',2.1),('14598','2012-12-27','14:25:00',2.25),('14598','2012-12-27','14:30:00',1.96),('14598','2012-12-27','14:35:00',2.1),('14598','2012-12-27','14:40:00',2.06),('14598','2012-12-27','14:45:00',2.01),('14598','2012-12-27','14:50:00',1.93),('14598','2012-12-27','14:55:00',1.85),('14598','2012-12-27','15:00:00',1.79),('14598','2012-12-27','15:05:00',1.73),('14598','2012-12-27','15:10:00',1.67),('14598','2012-12-27','15:15:00',1.58),('14598','2012-12-27','15:20:00',1.51),('14598','2012-12-27','15:25:00',1.45),('14598','2012-12-27','15:30:00',1.33),('14598','2012-12-27','15:35:00',1.28),('14598','2012-12-27','15:40:00',1.1),('14598','2012-12-26','09:30:00',1.05),('14598','2012-12-26','09:35:00',1.13),('14598','2012-12-26','09:40:00',1.25),('14598','2012-12-26','09:45:00',1.36),('14598','2012-12-26','09:50:00',1.43),('14598','2012-12-26','09:55:00',1.05),('14598','2012-12-26','10:05:00',1.8),('14598','2012-12-26','10:10:00',1.99),('14598','2012-12-26','10:15:00',1.65),('14598','2012-12-26','10:20:00',1.96),('14598','2012-12-26','10:25:00',1.95),('14598','2012-12-26','10:30:00',1.64),('14598','2012-12-26','10:35:00',1.6),('14598','2012-12-26','10:40:00',2.34),('14598','2012-12-26','10:45:00',2.25),('14598','2012-12-26','10:50:00',2.13),('14598','2012-12-26','10:55:00',2.33),('14598','2012-12-26','11:00:00',2.3),('14598','2012-12-26','11:05:00',2.31),('14598','2012-12-26','11:10:00',2.26),('14598','2012-12-26','11:15:00',1.7),('14598','2012-12-26','11:20:00',3.09),('14598','2012-12-26','11:25:00',2.91),('14598','2012-12-26','11:30:00',3.13),('14598','2012-12-26','11:35:00',2.11),('14598','2012-12-26','11:40:00',1.49),('14598','2012-12-26','11:45:00',1.4),('14598','2012-12-26','11:50:00',1.09),('14598','2012-12-26','12:00:00',1.03),('14598','2012-12-26','12:05:00',1.6),('14598','2012-12-26','12:10:00',1.39),('14598','2012-12-26','12:15:00',1.31),('14598','2012-12-26','12:40:00',1.22),('14598','2012-12-26','12:45:00',1.29),('14598','2012-12-26','13:00:00',2.01),('14598','2012-12-26','13:05:00',1.93),('14598','2012-12-26','13:15:00',1.08),('14598','2012-12-26','13:30:00',1.36),('14598','2012-12-25','12:10:00',1.01),('14598','2012-12-25','12:45:00',1.15),('14598','2012-12-25','12:50:00',1.16),('14598','2012-12-25','12:55:00',1.14),('14598','2012-12-25','13:00:00',1.46),('14598','2012-12-25','13:05:00',1.33),('14598','2012-12-25','13:10:00',1.15),('14598','2012-12-25','13:15:00',1.05),('14598','2012-12-25','13:20:00',1.03),('14598','2012-12-25','13:40:00',1.03),('14598','2012-12-25','13:45:00',1.07),('14598','2012-12-25','13:55:00',1.2),('14598','2012-12-25','14:15:00',1.38),('14598','2012-12-25','14:20:00',1.75),('14598','2012-12-25','14:25:00',1.99),('14598','2012-12-25','14:30:00',1.89),('14598','2012-12-25','14:35:00',1.67),('14598','2012-12-25','14:40:00',1.53),('14598','2012-12-25','14:45:00',1.51),('14598','2012-12-25','14:50:00',1.24),('14598','2012-12-25','14:55:00',1.07),('14598','2012-12-23','09:30:00',1.06),('14598','2012-12-23','09:35:00',1.14),('14598','2012-12-23','09:40:00',1.25),('14598','2012-12-23','09:45:00',1.37),('14598','2012-12-23','09:50:00',1.48),('14598','2012-12-23','09:55:00',1.55),('14598','2012-12-23','10:00:00',1.62),('14598','2012-12-23','10:05:00',1.7),('14598','2012-12-23','10:10:00',1.78),('14598','2012-12-23','10:15:00',1.88),('14598','2012-12-23','10:20:00',1.96),('14598','2012-12-23','10:25:00',2.02),('14598','2012-12-23','10:30:00',2.06),('14598','2012-12-23','10:35:00',2.14),('14598','2012-12-23','10:40:00',2.19),('14598','2012-12-23','10:45:00',2.21),('14598','2012-12-23','10:50:00',2.3),('14598','2012-12-23','10:55:00',2.33),('14598','2012-12-23','11:00:00',2.36),('14598','2012-12-23','11:05:00',2.42),('14598','2012-12-23','11:10:00',2.49),('14598','2012-12-23','11:15:00',2.55),('14598','2012-12-23','11:20:00',2.48),('14598','2012-12-23','11:25:00',2.42),('14598','2012-12-23','11:30:00',2.53),('14598','2012-12-23','11:35:00',2.66),('14598','2012-12-23','11:40:00',2.62),('14598','2012-12-23','11:45:00',2.4),('14598','2012-12-23','11:50:00',2.64),('14598','2012-12-23','11:55:00',2.64),('14598','2012-12-23','12:00:00',2.51),('14598','2012-12-23','12:05:00',1.93),('14598','2012-12-23','12:10:00',2.67),('14598','2012-12-23','12:15:00',2.69),('14598','2012-12-23','12:20:00',2.67),('14598','2012-12-23','12:25:00',2.6),('14598','2012-12-23','12:30:00',2.43),('14598','2012-12-23','12:35:00',2.17),('14598','2012-12-23','12:40:00',2.1),('14598','2012-12-23','12:45:00',2.63),('14598','2012-12-23','12:50:00',2.88),('14598','2012-12-23','12:55:00',2.73),('14598','2012-12-23','13:00:00',2.41),('14598','2012-12-23','13:05:00',2.32),('14598','2012-12-23','13:10:00',2.54),('14598','2012-12-23','13:15:00',2.62),('14598','2012-12-23','13:20:00',2.96),('14598','2012-12-23','13:25:00',2.21),('14598','2012-12-23','13:30:00',2.16),('14598','2012-12-23','13:35:00',2.36),('14598','2012-12-23','13:40:00',1.68),('14598','2012-12-23','13:45:00',1.3),('14598','2012-12-23','13:50:00',2.15),('14598','2012-12-23','13:55:00',2.7),('14598','2012-12-23','14:00:00',2.56),('14598','2012-12-23','14:05:00',2.28),('14598','2012-12-23','14:10:00',1.8),('14598','2012-12-23','14:15:00',1.47),('14598','2012-12-23','14:20:00',1.11),('14598','2012-12-23','14:25:00',1.18),('14598','2012-12-23','14:30:00',1.18),('14598','2012-12-23','14:35:00',1.21),('14598','2012-12-23','14:40:00',1.58),('14598','2012-12-23','14:45:00',1.79),('14598','2012-12-23','14:50:00',1.86),('14598','2012-12-23','14:55:00',2.05),('14598','2012-12-23','15:00:00',1.85),('14598','2012-12-23','15:05:00',1.79),('14598','2012-12-23','15:10:00',1.63),('14598','2012-12-23','15:15:00',1.53),('14598','2012-12-23','15:20:00',1.48),('14598','2012-12-23','15:25:00',1.09),('14598','2012-12-23','15:40:00',1.01),('14598','2012-12-23','15:45:00',1.04),('14598','2014-05-01','08:05:00',1),('14598','2014-05-01','08:10:00',1.08),('14598','2014-05-01','08:15:00',1.21),('14598','2014-05-01','08:20:00',1.3),('14598','2014-05-01','08:25:00',1.4),('14598','2014-05-01','08:30:00',1.38),('14598','2014-05-01','08:35:00',1.67),('14598','2014-05-01','08:40:00',1.75),('14598','2014-05-01','08:45:00',1.72),('14598','2014-05-01','08:50:00',2.11),('14598','2014-05-01','08:55:00',2.15),('14598','2014-05-01','09:00:00',2.24),('14598','2014-05-01','09:05:00',2.34),('14598','2014-05-01','09:10:00',1.85),('14598','2014-05-01','09:15:00',2.9),('14598','2014-05-01','09:20:00',3.12),('14598','2014-05-01','09:25:00',2.89),('14598','2014-05-01','09:30:00',2.55),('14598','2014-05-01','09:35:00',2.83),('14598','2014-05-01','09:40:00',2.29),('14598','2014-05-01','09:45:00',1.21),('14598','2014-05-01','09:50:00',1.45),('14598','2014-05-01','09:55:00',2.18),('14598','2014-05-01','10:00:00',2.61),('14598','2014-05-01','10:05:00',2.85),('14598','2014-05-01','10:10:00',4.58),('14598','2014-05-01','10:15:00',3.72),('14598','2014-05-01','10:20:00',4.26),('14598','2014-05-01','10:25:00',4.64),('14598','2014-05-01','10:30:00',2.77),('14598','2014-05-01','10:35:00',4.02),('14598','2014-05-01','10:40:00',3.67),('14598','2014-05-01','10:45:00',3.44),('14598','2014-05-01','10:50:00',3.58),('14598','2014-05-01','10:55:00',1.7),('14598','2014-05-01','11:00:00',2.6),('14598','2014-05-01','11:05:00',3.23),('14598','2014-05-01','11:10:00',3.51),('14598','2014-05-01','11:15:00',3.21),('14598','2014-05-01','11:20:00',2.46),('14598','2014-05-01','11:25:00',1.09),('14598','2014-05-01','11:30:00',2.12),('14598','2014-05-01','11:35:00',4.51),('14598','2014-05-01','11:40:00',3.17),('14598','2014-05-01','11:45:00',1.69),('14598','2014-05-01','11:50:00',4.36),('14598','2014-05-01','11:55:00',4.9),('14598','2014-05-01','12:00:00',4.96),('14598','2014-05-01','12:05:00',4.94),('14598','2014-05-01','12:10:00',4.93),('14598','2014-05-01','12:15:00',5.01),('14598','2014-05-01','12:20:00',5.03),('14598','2014-05-01','12:25:00',5.06),('14598','2014-05-01','12:30:00',5.09),('14598','2014-05-01','12:35:00',5.13),('14598','2014-05-01','12:40:00',5.16),('14598','2014-05-01','12:45:00',5.16),('14598','2014-05-01','12:50:00',5.15),('14598','2014-05-01','12:55:00',5.17),('14598','2014-05-01','13:00:00',5.21),('14598','2014-05-01','13:05:00',5.24),('14598','2014-05-01','13:10:00',5.23),('14598','2014-05-01','13:15:00',5.22),('14598','2014-05-01','13:20:00',5.25),('14598','2014-05-01','13:25:00',5.25),('14598','2014-05-01','13:30:00',5.26),('14598','2014-05-01','13:35:00',5.23),('14598','2014-05-01','13:40:00',5.24),('14598','2014-05-01','13:45:00',5.23),('14598','2014-05-01','13:50:00',5.22),('14598','2014-05-01','13:55:00',5.1),('14598','2014-05-01','14:00:00',5.17),('14598','2014-05-01','14:05:00',5.17),('14598','2014-05-01','14:10:00',5.13),('14598','2014-05-01','14:15:00',5.13),('14598','2014-05-01','14:20:00',5.11),('14598','2014-05-01','14:25:00',5.13),('14598','2014-05-01','14:30:00',5.06),('14598','2014-05-01','14:35:00',5.12),('14598','2014-05-01','14:40:00',5.08),('14598','2014-05-01','14:45:00',5),('14598','2014-05-01','14:50:00',4.97),('14598','2014-05-01','14:55:00',4.93),('14598','2014-05-01','15:00:00',5.01),('14598','2014-05-01','15:05:00',4.95),('14598','2014-05-01','15:10:00',4.82),('14598','2014-05-01','15:15:00',4.9),('14598','2014-05-01','15:20:00',4.82),('14598','2014-05-01','15:25:00',4.75),('14598','2014-05-01','15:30:00',4.36),('14598','2014-05-01','15:35:00',4.78),('14598','2014-05-01','15:40:00',4.66),('14598','2014-05-01','15:45:00',4.44),('14598','2014-05-01','15:50:00',4.49),('14598','2014-05-01','15:55:00',4.52),('14598','2014-05-01','16:00:00',4.46),('14598','2014-05-01','16:05:00',4.27),('14598','2014-05-01','16:10:00',4.23),('14598','2014-05-01','16:15:00',4.06),('14598','2014-05-01','16:20:00',4.12),('14598','2014-05-01','16:25:00',4.17),('14598','2014-05-01','16:30:00',4.04),('14598','2014-05-01','16:35:00',3.51),('14598','2014-05-01','16:40:00',3.43),('14598','2014-05-01','16:45:00',3.85),('14598','2014-05-01','16:50:00',3.73),('14598','2014-05-01','16:55:00',3.14),('14598','2014-05-01','17:00:00',3.24),('14598','2014-05-01','17:05:00',2.86),('14598','2014-05-01','17:10:00',3.55),('14598','2014-05-01','17:15:00',3.28),('14598','2014-05-01','17:20:00',3.35),('14598','2014-05-01','17:25:00',2.73),('14598','2014-05-01','17:30:00',2.37),('14598','2014-05-01','17:35:00',3.16),('14598','2014-05-01','17:40:00',2.89),('14598','2014-05-01','17:45:00',2.43),('14598','2014-05-01','17:50:00',2.39),('14598','2014-05-01','17:55:00',2.61),('14598','2014-05-01','18:00:00',2.41),('14598','2014-05-01','18:05:00',2.22),('14598','2014-05-01','18:10:00',2.2),('14598','2014-05-01','18:15:00',2.07),('14598','2014-05-01','18:20:00',1.98),('14598','2014-05-01','18:25:00',1.86),('14598','2014-05-01','18:30:00',1.75),('14598','2014-05-01','18:35:00',1.64),('14598','2014-05-01','18:40:00',1.52),('14598','2014-05-01','18:45:00',1.41),('14598','2014-05-01','18:50:00',1.3),('14598','2014-05-01','18:55:00',1.19),('14598','2014-05-01','19:00:00',1.08),('14598','2014-03-17','08:30:00',1.08),('14598','2014-03-17','08:40:00',1.04),('14598','2014-03-17','08:45:00',1.35),('14598','2014-03-17','08:50:00',1.34),('14598','2014-03-17','08:55:00',1.18),('14598','2014-03-17','09:00:00',1.08),('14598','2014-03-17','09:05:00',1.39),('14598','2014-03-17','09:10:00',1.62),('14598','2014-03-17','09:15:00',1.51),('14598','2014-03-17','09:20:00',1.57),('14598','2014-03-17','09:25:00',1.77),('14598','2014-03-17','09:30:00',1.88),('14598','2014-03-17','09:35:00',1.78),('14598','2014-03-17','09:40:00',1.61),('14598','2014-03-17','09:45:00',1.65),('14598','2014-03-17','09:50:00',1.41),('14598','2014-03-17','09:55:00',1.03),('14598','2014-03-17','10:00:00',1.3),('14598','2014-03-17','10:05:00',1.2),('14598','2014-03-17','10:10:00',1.49),('14598','2014-03-17','10:15:00',2.08),('14598','2014-03-17','10:20:00',4.12),('14598','2014-03-17','10:25:00',4.26),('14598','2014-03-17','10:30:00',2.93),('14598','2014-03-17','10:35:00',2.05),('14598','2014-03-17','10:40:00',2.11),('14598','2014-03-17','10:45:00',2.93),('14598','2014-03-17','10:50:00',3.82),('14598','2014-03-17','10:55:00',2.64),('14598','2014-03-17','11:00:00',2.46),('14598','2014-03-17','11:05:00',2.54),('14598','2014-03-17','11:10:00',2.68),('14598','2014-03-17','11:15:00',3.34),('14598','2014-03-17','11:20:00',2.57),('14598','2014-03-17','11:25:00',2.54),('14598','2014-03-17','11:30:00',2.17),('14598','2014-03-17','11:35:00',2.31),('14598','2014-03-17','11:40:00',2.23),('14598','2014-03-17','11:45:00',2.29),('14598','2014-03-17','11:50:00',2.44),('14598','2014-03-17','11:55:00',2.78),('14598','2014-03-17','12:00:00',2.72),('14598','2014-03-17','12:05:00',2.71),('14598','2014-03-17','12:10:00',2.99),('14598','2014-03-17','12:15:00',4.59),('14598','2014-03-17','12:20:00',4.56),('14598','2014-03-17','12:25:00',2.72),('14598','2014-03-17','12:30:00',3.18),('14598','2014-03-17','12:35:00',3.25),('14598','2014-03-17','12:40:00',4.58),('14598','2014-03-17','12:45:00',3.24),('14598','2014-03-17','12:50:00',3.93),('14598','2014-03-17','12:55:00',3.49),('14598','2014-03-17','13:00:00',2.96),('14598','2014-03-17','13:05:00',3.87),('14598','2014-03-17','13:10:00',4.41),('14598','2014-03-17','13:15:00',2.53),('14598','2014-03-17','13:20:00',3.7),('14598','2014-03-17','13:25:00',2.35),('14598','2014-03-17','13:30:00',2.09),('14598','2014-03-17','13:35:00',2.18),('14598','2014-03-17','13:40:00',2.12),('14598','2014-03-17','13:45:00',2.2),('14598','2014-03-17','13:50:00',2.58),('14598','2014-03-17','13:55:00',2.39),('14598','2014-03-17','14:00:00',2.24),('14598','2014-03-17','14:05:00',1.78),('14598','2014-03-17','14:10:00',1.6),('14598','2014-03-17','14:15:00',1.97),('14598','2014-03-17','14:20:00',2.16),('14598','2014-03-17','14:25:00',2.45),('14598','2014-03-17','14:30:00',2.57),('14598','2014-03-17','14:35:00',1.8),('14598','2014-03-17','14:40:00',2.33),('14598','2014-03-17','14:45:00',3.64),('14598','2014-03-17','14:50:00',2.18),('14598','2014-03-17','14:55:00',3.61),('14598','2014-03-17','15:00:00',2.88),('14598','2014-03-17','15:05:00',1.3),('14598','2014-03-17','15:10:00',1.48),('14598','2014-03-17','15:15:00',1.51),('14598','2014-03-17','15:20:00',1.24),('14598','2014-03-17','15:25:00',1.21),('14598','2014-03-17','15:30:00',1.31),('14598','2014-03-17','15:35:00',1.12),('14598','2014-03-17','15:40:00',1.12),('14598','2014-03-17','15:45:00',1.11),('14598','2014-03-17','15:50:00',1.17),('14598','2014-03-17','15:55:00',1.14),('14598','2014-03-17','16:00:00',1.41),('14598','2014-03-17','16:05:00',1.66),('14598','2014-03-17','16:10:00',1.61),('14598','2012-12-22','10:35:00',1.02),('14598','2012-12-22','10:40:00',1.13),('14598','2012-12-22','10:45:00',1.11),('14598','2012-12-22','10:50:00',1.25),('14598','2012-12-22','10:55:00',1.46),('14598','2012-12-22','11:00:00',1.37),('14598','2012-12-22','11:05:00',1.37),('14598','2012-12-22','11:10:00',1.47),('14598','2012-12-22','11:15:00',1.38),('14598','2012-12-22','11:20:00',1.51),('14598','2012-12-22','11:25:00',1.73),('14598','2012-12-22','11:30:00',1.84),('14598','2012-12-22','11:35:00',1.51),('14598','2012-12-22','11:40:00',3.03),('14598','2012-12-22','11:45:00',3.5),('14598','2012-12-22','11:50:00',2.74),('14598','2012-12-22','11:55:00',1.69),('14598','2012-12-22','12:00:00',1.17),('14598','2012-12-22','12:05:00',1.29),('14598','2012-12-22','12:10:00',2.81),('14598','2012-12-22','12:15:00',3.08),('14598','2012-12-22','12:20:00',3.04),('14598','2012-12-22','12:25:00',3.08),('14598','2012-12-22','12:30:00',2.82),('14598','2012-12-22','12:35:00',1.15),('14598','2012-12-22','12:45:00',3.06),('14598','2012-12-22','12:50:00',2.41),('14598','2012-12-22','12:55:00',3.03),('14598','2012-12-22','13:00:00',1.16),('14598','2012-12-22','13:20:00',1.61),('14598','2012-12-22','13:25:00',3.18),('14598','2012-12-22','13:30:00',3.49),('14598','2012-12-22','13:35:00',2.22),('14598','2012-12-22','13:40:00',1.32),('14598','2012-12-22','13:45:00',1.35),('14598','2012-12-22','14:00:00',1.49),('14598','2012-12-22','14:05:00',2.06),('14598','2012-12-22','14:10:00',2.36),('14598','2012-12-22','14:15:00',1.72),('14598','2012-12-22','14:20:00',2.28),('14598','2012-12-22','14:30:00',2.29),('14598','2012-12-22','14:35:00',2.34),('14598','2012-12-22','14:40:00',2.1),('14598','2012-12-22','14:45:00',1.14),('14598','2012-12-22','14:50:00',2.07),('14598','2012-12-22','14:55:00',2.09),('14598','2012-12-22','15:00:00',1.78),('14598','2012-12-22','15:05:00',1.65),('14598','2012-12-22','15:10:00',1.12),('14598','2012-12-22','15:25:00',1.28),('14598','2012-12-22','15:30:00',1.24),('14598','2012-12-22','15:35:00',1.14),('14598','2012-12-22','15:40:00',1.05),('14598','2014-03-16','08:15:00',1.05),('14598','2014-03-16','08:20:00',1.19),('14598','2014-03-16','08:25:00',1.21),('14598','2014-03-16','08:30:00',1.37),('14598','2014-03-16','08:35:00',1.5),('14598','2014-03-16','08:40:00',1.62),('14598','2014-03-16','08:45:00',1.75),('14598','2014-03-16','08:50:00',1.8),('14598','2014-03-16','08:55:00',1.88),('14598','2014-03-16','09:00:00',1.87),('14598','2014-03-16','09:05:00',2.04),('14598','2014-03-16','09:10:00',2.27),('14598','2014-03-16','09:15:00',2.26),('14598','2014-03-16','09:20:00',2.27),('14598','2014-03-16','09:25:00',2.32),('14598','2014-03-16','09:30:00',2.38),('14598','2014-03-16','09:35:00',2.56),('14598','2014-03-16','09:40:00',2.46),('14598','2014-03-16','09:45:00',2.63),('14598','2014-03-16','09:50:00',2.85),('14598','2014-03-16','09:55:00',2.86),('14598','2014-03-16','10:00:00',2.94),('14598','2014-03-16','10:05:00',3.05),('14598','2014-03-16','10:10:00',3.11),('14598','2014-03-16','10:15:00',3.18),('14598','2014-03-16','10:20:00',3.24),('14598','2014-03-16','10:25:00',3.29),('14598','2014-03-16','10:30:00',3.32),('14598','2014-03-16','10:35:00',3.36),('14598','2014-03-16','10:40:00',3.46),('14598','2014-03-16','10:45:00',3.54),('14598','2014-03-16','10:50:00',3.61),('14598','2014-03-16','10:55:00',3.66),('14598','2014-03-16','11:00:00',3.7),('14598','2014-03-16','11:05:00',3.69),('14598','2014-03-16','11:10:00',3.74),('14598','2014-03-16','11:15:00',3.81),('14598','2014-03-16','11:20:00',3.86),('14598','2014-03-16','11:25:00',3.96),('14598','2014-03-16','11:30:00',3.96),('14598','2014-03-16','11:35:00',4),('14598','2014-03-16','11:40:00',4.07),('14598','2014-03-16','11:45:00',4.11),('14598','2014-03-16','11:50:00',4.13),('14598','2014-03-16','11:55:00',4.19),('14598','2014-03-16','12:00:00',4.19),('14598','2014-03-16','12:05:00',4.23),('14598','2014-03-16','12:10:00',4.26),('14598','2014-03-16','12:15:00',4.28),('14598','2014-03-16','12:20:00',4.28),('14598','2014-03-16','12:25:00',4.3),('14598','2014-03-16','12:30:00',4.33),('14598','2014-03-16','12:35:00',4.34),('14598','2014-03-16','12:40:00',4.36),('14598','2014-03-16','12:45:00',4.36),('14598','2014-03-16','12:50:00',4.36),('14598','2014-03-16','12:55:00',4.36),('14598','2014-03-16','13:00:00',4.36),('14598','2014-03-16','13:05:00',4.38),('14598','2014-03-16','13:10:00',4.31),('14598','2014-03-16','13:15:00',4.27),('14598','2014-03-16','13:20:00',4.36),('14598','2014-03-16','13:25:00',4.33),('14598','2014-03-16','13:30:00',4.3),('14598','2014-03-16','13:35:00',3.88),('14598','2014-03-16','13:40:00',3.96),('14598','2014-03-16','13:45:00',4.31),('14598','2014-03-16','13:50:00',4.26),('14598','2014-03-16','13:55:00',4.2),('14598','2014-03-16','14:00:00',4.16),('14598','2014-03-16','14:05:00',4.1),('14598','2014-03-16','14:10:00',4.08),('14598','2014-03-16','14:15:00',4.02),('14598','2014-03-16','14:20:00',4.04),('14598','2014-03-16','14:25:00',3.88),('14598','2014-03-16','14:30:00',4),('14598','2014-03-16','14:35:00',3.47),('14598','2014-03-16','14:40:00',3.52),('14598','2014-03-16','14:45:00',3.61),('14598','2014-03-16','14:50:00',3),('14598','2014-03-16','14:55:00',2.98),('14598','2014-03-16','15:00:00',2.87),('14598','2014-03-16','15:05:00',2.77),('14598','2014-03-16','15:10:00',2.2),('14598','2014-03-16','15:15:00',2.51),('14598','2014-03-16','15:20:00',2.61),('14598','2014-03-16','15:25:00',2.26),('14598','2014-03-16','15:30:00',2.13),('14598','2014-03-16','15:35:00',2.05),('14598','2014-03-16','15:40:00',2.23),('14598','2014-03-16','15:45:00',1.95),('14598','2014-03-16','15:50:00',1.91),('14598','2014-03-16','15:55:00',2.16),('14598','2014-03-16','16:00:00',2.19),('14598','2014-03-16','16:05:00',2.23),('14598','2014-03-16','16:10:00',2.23),('14598','2014-03-16','16:15:00',2.19),('14598','2014-03-16','16:20:00',2.04),('14598','2014-03-16','16:25:00',2.01),('14598','2014-03-16','16:30:00',1.84),('14598','2014-03-16','16:35:00',1.7),('14598','2014-03-16','16:40:00',1.52),('14598','2014-03-16','16:45:00',1.31),('14598','2014-03-16','16:50:00',1.39),('14598','2014-03-16','16:55:00',1.1),('14598','2014-03-15','08:15:00',1.04),('14598','2014-03-15','08:20:00',1.14),('14598','2014-03-15','08:25:00',1.23),('14598','2014-03-15','08:30:00',1.33),('14598','2014-03-15','08:35:00',1.45),('14598','2014-03-15','08:40:00',1.54),('14598','2014-03-15','08:45:00',1.64),('14598','2014-03-15','08:50:00',1.72),('14598','2014-03-15','08:55:00',1.82),('14598','2014-03-15','09:00:00',1.91),('14598','2014-03-15','09:05:00',1.99),('14598','2014-03-15','09:10:00',2.08),('14598','2014-03-15','09:15:00',2.16),('14598','2014-03-15','09:20:00',2.24),('14598','2014-03-15','09:25:00',2.32),('14598','2014-03-15','09:30:00',2.39),('14598','2014-03-15','09:35:00',2.47),('14598','2014-03-15','09:40:00',2.53),('14598','2014-03-15','09:45:00',2.6),('14598','2014-03-15','09:50:00',2.66),('14598','2014-03-15','09:55:00',2.73),('14598','2014-03-15','10:00:00',2.81),('14598','2014-03-15','10:05:00',2.91),('14598','2014-03-15','10:10:00',2.97),('14598','2014-03-15','10:15:00',3.06),('14598','2014-03-15','10:20:00',3.12),('14598','2014-03-15','10:25:00',3.17),('14598','2014-03-15','10:30:00',3.26),('14598','2014-03-15','10:35:00',3.28),('14598','2014-03-15','10:40:00',3.39),('14598','2014-03-15','10:45:00',3.43),('14598','2014-03-15','10:50:00',3.5),('14598','2014-03-15','10:55:00',3.55),('14598','2014-03-15','11:00:00',3.61),('14598','2014-03-15','11:05:00',3.68),('14598','2014-03-15','11:10:00',3.74),('14598','2014-03-15','11:15:00',3.78),('14598','2014-03-15','11:20:00',3.83),('14598','2014-03-15','11:25:00',3.87),('14598','2014-03-15','11:30:00',3.89),('14598','2014-03-15','11:35:00',3.95),('14598','2014-03-15','11:40:00',4),('14598','2014-03-15','11:45:00',4.02),('14598','2014-03-15','11:50:00',4.01),('14598','2014-03-15','11:55:00',4.06),('14598','2014-03-15','12:00:00',4.08),('14598','2014-03-15','12:05:00',4.12),('14598','2014-03-15','12:10:00',4.14),('14598','2014-03-15','12:15:00',4.14),('14598','2014-03-15','12:20:00',4.17),('14598','2014-03-15','12:25:00',4.19),('14598','2014-03-15','12:30:00',4.18),('14598','2014-03-15','12:35:00',4.21),('14598','2014-03-15','12:40:00',4.22),('14598','2014-03-15','12:45:00',4.24),('14598','2014-03-15','12:50:00',4.28),('14598','2014-03-15','12:55:00',4.3),('14598','2014-03-15','13:00:00',4.34),('14598','2014-03-15','13:05:00',4.34),('14598','2014-03-15','13:10:00',4.29),('14598','2014-03-15','13:15:00',4.24),('14598','2014-03-15','13:20:00',4.2),('14598','2014-03-15','13:25:00',4.19),('14598','2014-03-15','13:30:00',4.2),('14598','2014-03-15','13:35:00',4.16),('14598','2014-03-15','13:40:00',4.04),('14598','2014-03-15','13:45:00',4.12),('14598','2014-03-15','13:50:00',4.1),('14598','2014-03-15','13:55:00',4.04),('14598','2014-03-15','14:00:00',4.04),('14598','2014-03-15','14:05:00',3.96),('14598','2014-03-15','14:10:00',3.93),('14598','2014-03-15','14:15:00',3.9),('14598','2014-03-15','14:20:00',3.86),('14598','2014-03-15','14:25:00',3.82),('14598','2014-03-15','14:30:00',3.76),('14598','2014-03-15','14:35:00',3.71),('14598','2014-03-15','14:40:00',3.65),('14598','2014-03-15','14:45:00',3.59),('14598','2014-03-15','14:50:00',3.54),('14598','2014-03-15','14:55:00',3.43),('14598','2014-03-15','15:00:00',3.36),('14598','2014-03-15','15:05:00',3.25),('14598','2014-03-15','15:10:00',3.19),('14598','2014-03-15','15:15:00',3.11),('14598','2014-03-15','15:20:00',3),('14598','2014-03-15','15:25:00',2.93),('14598','2014-03-15','15:30:00',2.89),('14598','2014-03-15','15:35:00',2.82),('14598','2014-03-15','15:40:00',2.72),('14598','2014-03-15','15:45:00',2.61),('14598','2014-03-15','15:50:00',2.51),('14598','2014-03-15','15:55:00',2.39),('14598','2014-03-15','16:00:00',2.32),('14598','2014-03-15','16:05:00',2.24),('14598','2014-03-15','16:10:00',2.13),('14598','2014-03-15','16:15:00',2.05),('14598','2014-03-15','16:20:00',1.94),('14598','2014-03-15','16:25:00',1.85),('14598','2014-03-15','16:30:00',1.74),('14598','2014-03-15','16:35:00',1.65),('14598','2014-03-15','16:40:00',1.54),('14598','2014-03-15','16:45:00',1.44),('14598','2014-03-15','16:50:00',1.32),('14598','2014-03-15','16:55:00',1.21),('14598','2014-03-15','17:00:00',1.11),('14598','2014-03-14','08:35:00',1),('14598','2014-03-14','08:40:00',1.01),('14598','2014-03-14','08:45:00',1.03),('14598','2014-03-14','08:50:00',1.03),('14598','2014-03-14','08:55:00',1.18),('14598','2014-03-14','09:00:00',1.47),('14598','2014-03-14','09:05:00',1.65),('14598','2014-03-14','09:10:00',1.84),('14598','2014-03-14','09:15:00',1.9),('14598','2014-03-14','09:20:00',2.16),('14598','2014-03-14','09:25:00',2.47),('14598','2014-03-14','09:30:00',2.57),('14598','2014-03-14','09:35:00',2.3),('14598','2014-03-14','09:40:00',1.86),('14598','2014-03-14','09:45:00',1.7),('14598','2014-03-14','09:50:00',2.2),('14598','2014-03-14','09:55:00',2.97),('14598','2014-03-14','10:00:00',3.31),('14598','2014-03-14','10:05:00',3.2),('14598','2014-03-14','10:10:00',3.45),('14598','2014-03-14','10:15:00',3.54),('14598','2014-03-14','10:20:00',3.68),('14598','2014-03-14','10:25:00',3.72),('14598','2014-03-14','10:30:00',3.67),('14598','2014-03-14','10:35:00',3.7),('14598','2014-03-14','10:40:00',3.73),('14598','2014-03-14','10:45:00',3.68),('14598','2014-03-14','10:50:00',3.82),('14598','2014-03-14','10:55:00',3.57),('14598','2014-03-14','11:00:00',3.3),('14598','2014-03-14','11:05:00',3.69),('14598','2014-03-14','11:10:00',3.92),('14598','2014-03-14','11:15:00',4.04),('14598','2014-03-14','11:20:00',4.12),('14598','2014-03-14','11:25:00',3.99),('14598','2014-03-14','11:30:00',4.11),('14598','2014-03-14','11:35:00',4.19),('14598','2014-03-14','11:40:00',4.19),('14598','2014-03-14','11:45:00',4.29),('14598','2014-03-14','11:50:00',4.3),('14598','2014-03-14','11:55:00',4.19),('14598','2014-03-14','12:00:00',4.14),('14598','2014-03-14','12:05:00',4.16),('14598','2014-03-14','12:10:00',4.09),('14598','2014-03-14','12:15:00',4.33),('14598','2014-03-14','12:20:00',4.42),('14598','2014-03-14','12:25:00',4.55),('14598','2014-03-14','12:30:00',4.41),('14598','2014-03-14','12:35:00',4.31),('14598','2014-03-14','12:40:00',3.88),('14598','2014-03-14','12:45:00',2.72),('14598','2014-03-14','12:50:00',2.38),('14598','2014-03-14','12:55:00',2.72),('14598','2014-03-14','13:00:00',3.21),('14598','2014-03-14','13:05:00',3.68),('14598','2014-03-14','13:10:00',3.05),('14598','2014-03-14','13:15:00',3.1),('14598','2014-03-14','13:20:00',3.51),('14598','2014-03-14','13:25:00',3.66),('14598','2014-03-14','13:30:00',2.9),('14598','2014-03-14','13:35:00',2.37),('14598','2014-03-14','13:40:00',2.55),('14598','2014-03-14','13:45:00',3.3),('14598','2014-03-14','13:50:00',3.13),('14598','2014-03-14','13:55:00',3.48),('14598','2014-03-14','14:00:00',3.41),('14598','2014-03-14','14:05:00',3.73),('14598','2014-03-14','14:10:00',4.18),('14598','2014-03-14','14:15:00',4.24),('14598','2014-03-14','14:20:00',4.04),('14598','2014-03-14','14:25:00',4.08),('14598','2014-03-14','14:30:00',4.22),('14598','2014-03-14','14:35:00',4.2),('14598','2014-03-14','14:40:00',3.99),('14598','2014-03-14','14:45:00',3.35),('14598','2014-03-14','14:50:00',3.76),('14598','2014-03-14','14:55:00',3.54),('14598','2014-03-14','15:00:00',3.34),('14598','2014-03-14','15:05:00',2.83),('14598','2014-03-14','15:10:00',2.16),('14598','2014-03-14','15:15:00',1.61),('14598','2014-03-14','15:20:00',1.48),('14598','2014-03-14','15:25:00',1.4),('14598','2014-03-14','15:30:00',1.39),('14598','2014-03-14','15:35:00',1.34),('14598','2014-03-14','15:40:00',1.26),('14598','2014-03-14','15:45:00',1.06),('14598','2014-03-14','16:30:00',1.02),('14598','2014-03-13','08:10:00',1),('14598','2014-03-13','08:15:00',1.1),('14598','2014-03-13','08:20:00',1.21),('14598','2014-03-13','08:25:00',1.33),('14598','2014-03-13','08:30:00',1.46),('14598','2014-03-13','08:35:00',1.57),('14598','2014-03-13','08:40:00',1.7),('14598','2014-03-13','08:45:00',1.81),('14598','2014-03-13','08:50:00',1.91),('14598','2014-03-13','08:55:00',2),('14598','2014-03-13','09:00:00',2.1),('14598','2014-03-13','09:05:00',2.2),('14598','2014-03-13','09:10:00',2.3),('14598','2014-03-13','09:15:00',2.39),('14598','2014-03-13','09:20:00',2.48),('14598','2014-03-13','09:25:00',2.57),('14598','2014-03-13','09:30:00',2.67),('14598','2014-03-13','09:35:00',2.76),('14598','2014-03-13','09:40:00',2.84),('14598','2014-03-13','09:45:00',2.91),('14598','2014-03-13','09:50:00',3),('14598','2014-03-13','09:55:00',3.09),('14598','2014-03-13','10:00:00',3.17),('14598','2014-03-13','10:05:00',3.24),('14598','2014-03-13','10:10:00',3.32),('14598','2014-03-13','10:15:00',3.38),('14598','2014-03-13','10:20:00',3.44),('14598','2014-03-13','10:25:00',3.48),('14598','2014-03-13','10:30:00',3.54),('14598','2014-03-13','10:35:00',3.6),('14598','2014-03-13','10:40:00',3.66),('14598','2014-03-13','10:45:00',3.7),('14598','2014-03-13','10:50:00',3.74),('14598','2014-03-13','10:55:00',3.77),('14598','2014-03-13','11:00:00',3.79),('14598','2014-03-13','11:05:00',3.78),('14598','2014-03-13','11:10:00',3.84),('14598','2014-03-13','11:15:00',3.91),('14598','2014-03-13','11:20:00',4),('14598','2014-03-13','11:25:00',4.07),('14598','2014-03-13','11:30:00',4.13),('14598','2014-03-13','11:35:00',4.15),('14598','2014-03-13','11:40:00',4.19),('14598','2014-03-13','11:45:00',4.21),('14598','2014-03-13','11:50:00',4.24),('14598','2014-03-13','11:55:00',4.25),('14598','2014-03-13','12:00:00',4.27),('14598','2014-03-13','12:05:00',4.28),('14598','2014-03-13','12:10:00',4.3),('14598','2014-03-13','12:15:00',4.33),('14598','2014-03-13','12:20:00',4.34),('14598','2014-03-13','12:25:00',4.35),('14598','2014-03-13','12:30:00',4.37),('14598','2014-03-13','12:35:00',4.41),('14598','2014-03-13','12:40:00',4.42),('14598','2014-03-13','12:45:00',4.43),('14598','2014-03-13','12:50:00',4.42),('14598','2014-03-13','12:55:00',4.41),('14598','2014-03-13','13:00:00',4.43),('14598','2014-03-13','13:05:00',4.42),('14598','2014-03-13','13:10:00',4.39),('14598','2014-03-13','13:15:00',4.38),('14598','2014-03-13','13:20:00',4.38),('14598','2014-03-13','13:25:00',4.34),('14598','2014-03-13','13:30:00',4.31),('14598','2014-03-13','13:35:00',4.29),('14598','2014-03-13','13:40:00',4.26),('14598','2014-03-13','13:45:00',4.23),('14598','2014-03-13','13:50:00',4.2),('14598','2014-03-13','13:55:00',4.17),('14598','2014-03-13','14:00:00',4.13),('14598','2014-03-13','14:05:00',4.09),('14598','2014-03-13','14:10:00',4.03),('14598','2014-03-13','14:15:00',4),('14598','2014-03-13','14:20:00',3.95),('14598','2014-03-13','14:25:00',3.91),('14598','2014-03-13','14:30:00',3.86),('14598','2014-03-13','14:35:00',3.82),('14598','2014-03-13','14:40:00',3.74),('14598','2014-03-13','14:45:00',3.71),('14598','2014-03-13','14:50:00',3.66),('14598','2014-03-13','14:55:00',3.57),('14598','2014-03-13','15:00:00',3.51),('14598','2014-03-13','15:05:00',3.45),('14598','2014-03-13','15:10:00',3.39),('14598','2014-03-13','15:15:00',3.3),('14598','2014-03-13','15:20:00',3.21),('14598','2014-03-13','15:25:00',3.12),('14598','2014-03-13','15:30:00',3.05),('14598','2014-03-13','15:35:00',2.96),('14598','2014-03-13','15:40:00',2.89),('14598','2014-03-13','15:45:00',2.78),('14598','2014-03-13','15:50:00',2.69),('14598','2014-03-13','15:55:00',2.61),('14598','2014-03-13','16:00:00',2.52),('14598','2014-03-13','16:05:00',2.41),('14598','2014-03-13','16:10:00',2.32),('14598','2014-03-13','16:15:00',2.21),('14598','2014-03-13','16:20:00',2.12),('14598','2014-03-13','16:25:00',2.03),('14598','2014-03-13','16:30:00',1.94),('14598','2014-03-13','16:35:00',1.83),('14598','2014-03-13','16:40:00',1.71),('14598','2014-03-13','16:45:00',1.6),('14598','2014-03-13','16:50:00',1.49),('14598','2014-03-13','16:55:00',1.37),('14598','2014-03-13','17:00:00',1.26),('14598','2014-03-13','17:05:00',1.15),('14598','2014-03-13','17:10:00',1.04),('14598','2014-03-12','08:15:00',1.07),('14598','2014-03-12','08:20:00',1.17),('14598','2014-03-12','08:25:00',1.28),('14598','2014-03-12','08:30:00',1.41),('14598','2014-03-12','08:35:00',1.51),('14598','2014-03-12','08:40:00',1.65),('14598','2014-03-12','08:45:00',1.76),('14598','2014-03-12','08:50:00',1.86),('14598','2014-03-12','08:55:00',1.96),('14598','2014-03-12','09:00:00',2.06),('14598','2014-03-12','09:05:00',2.16),('14598','2014-03-12','09:10:00',2.26),('14598','2014-03-12','09:15:00',2.36),('14598','2014-03-12','09:20:00',2.46),('14598','2014-03-12','09:25:00',2.54),('14598','2014-03-12','09:30:00',2.63),('14598','2014-03-12','09:35:00',2.73),('14598','2014-03-12','09:40:00',2.8),('14598','2014-03-12','09:45:00',2.88),('14598','2014-03-12','09:50:00',2.93),('14598','2014-03-12','09:55:00',3.03),('14598','2014-03-12','10:00:00',3.09),('14598','2014-03-12','10:05:00',3.18),('14598','2014-03-12','10:10:00',3.24),('14598','2014-03-12','10:15:00',3.31),('14598','2014-03-12','10:20:00',3.38),('14598','2014-03-12','10:25:00',3.45),('14598','2014-03-12','10:30:00',3.5),('14598','2014-03-12','10:35:00',3.57),('14598','2014-03-12','10:40:00',3.6),('14598','2014-03-12','10:45:00',3.64),('14598','2014-03-12','10:50:00',3.68),('14598','2014-03-12','10:55:00',3.73),('14598','2014-03-12','11:00:00',3.78),('14598','2014-03-12','11:05:00',3.81),('14598','2014-03-12','11:10:00',3.8),('14598','2014-03-12','11:15:00',3.86),('14598','2014-03-12','11:20:00',3.91),('14598','2014-03-12','11:25:00',3.94),('14598','2014-03-12','11:30:00',3.94),('14598','2014-03-12','11:35:00',4.01),('14598','2014-03-12','11:40:00',4.03),('14598','2014-03-12','11:45:00',4.07),('14598','2014-03-12','11:50:00',4.08),('14598','2014-03-12','11:55:00',4.07),('14598','2014-03-12','12:00:00',4.06),('14598','2014-03-12','12:05:00',4.11),('14598','2014-03-12','12:10:00',4.14),('14598','2014-03-12','12:15:00',4.14),('14598','2014-03-12','12:20:00',4.16),('14598','2014-03-12','12:25:00',4.17),('14598','2014-03-12','12:30:00',4.2),('14598','2014-03-12','12:35:00',4.25),('14598','2014-03-12','12:40:00',4.25),('14598','2014-03-12','12:45:00',4.21),('14598','2014-03-12','12:50:00',4.18),('14598','2014-03-12','12:55:00',4.11),('14598','2014-03-12','13:00:00',4.17),('14598','2014-03-12','13:05:00',4.21),('14598','2014-03-12','13:10:00',4.2),('14598','2014-03-12','13:15:00',4.16),('14598','2014-03-12','13:20:00',4.15),('14598','2014-03-12','13:25:00',4.15),('14598','2014-03-12','13:30:00',4.16),('14598','2014-03-12','13:35:00',4.18),('14598','2014-03-12','13:40:00',4.15),('14598','2014-03-12','13:45:00',4.18),('14598','2014-03-12','13:50:00',4.15),('14598','2014-03-12','13:55:00',4.04),('14598','2014-03-12','14:00:00',4.05),('14598','2014-03-12','14:05:00',4.02),('14598','2014-03-12','14:10:00',3.95),('14598','2014-03-12','14:15:00',3.94),('14598','2014-03-12','14:20:00',3.9),('14598','2014-03-12','14:25:00',3.89),('14598','2014-03-12','14:30:00',3.85),('14598','2014-03-12','14:35:00',3.75),('14598','2014-03-12','14:40:00',3.69),('14598','2014-03-12','14:45:00',3.66),('14598','2014-03-12','14:50:00',3.61),('14598','2014-03-12','14:55:00',3.55),('14598','2014-03-12','15:00:00',3.5),('14598','2014-03-12','15:05:00',3.44),('14598','2014-03-12','15:10:00',3.35),('14598','2014-03-12','15:15:00',3.29),('14598','2014-03-12','15:20:00',3.2),('14598','2014-03-12','15:25:00',3.12),('14598','2014-03-12','15:30:00',3.05),('14598','2014-03-12','15:35:00',2.96),('14598','2014-03-12','15:40:00',2.86),('14598','2014-03-12','15:45:00',2.76),('14598','2014-03-12','15:50:00',2.66),('14598','2014-03-12','15:55:00',2.57),('14598','2014-03-12','16:00:00',2.5),('14598','2014-03-12','16:05:00',2.4),('14598','2014-03-12','16:10:00',2.3),('14598','2014-03-12','16:15:00',2.2),('14598','2014-03-12','16:20:00',2.1),('14598','2014-03-12','16:25:00',2),('14598','2014-03-12','16:30:00',1.9),('14598','2014-03-12','16:35:00',1.8),('14598','2014-03-12','16:40:00',1.69),('14598','2014-03-12','16:45:00',1.57),('14598','2014-03-12','16:50:00',1.45),('14598','2014-03-12','16:55:00',1.34),('14598','2014-03-12','17:00:00',1.22),('14598','2014-03-12','17:05:00',1.11),('14598','2014-03-11','08:00:00',1.01),('14598','2014-03-11','08:05:00',1.16),('14598','2014-03-11','08:10:00',1.13),('14598','2014-03-11','08:15:00',1.08),('14598','2014-03-11','08:20:00',1.4),('14598','2014-03-11','08:25:00',1.78),('14598','2014-03-11','08:30:00',1.7),('14598','2014-03-11','08:35:00',1.04),('14598','2014-03-11','09:00:00',1.09),('14598','2014-03-11','09:05:00',1.44),('14598','2014-03-11','09:10:00',1.55),('14598','2014-03-11','09:15:00',1.55),('14598','2014-03-11','09:20:00',1.73),('14598','2014-03-11','09:25:00',1.57),('14598','2014-03-11','09:30:00',1.47),('14598','2014-03-11','09:35:00',1.53),('14598','2014-03-11','09:40:00',1.5),('14598','2014-03-11','09:45:00',1.54),('14598','2014-03-11','09:50:00',1.46),('14598','2014-03-11','09:55:00',1.11),('14598','2014-03-11','10:25:00',1.02),('14598','2014-03-11','10:30:00',1.09),('14598','2014-03-11','10:35:00',1.19),('14598','2014-03-11','10:40:00',1.18),('14598','2014-03-11','10:45:00',1.08),('14598','2014-03-11','10:50:00',1.09),('14598','2014-03-11','10:55:00',1.04),('14598','2014-03-11','11:10:00',1.01),('14598','2014-03-11','12:00:00',1.14),('14598','2014-03-11','12:05:00',1.33),('14598','2014-03-11','12:10:00',1.34),('14598','2014-03-11','12:15:00',1.46),('14598','2014-03-11','12:20:00',1.63),('14598','2014-03-11','12:25:00',1.78),('14598','2014-03-11','12:30:00',1.91),('14598','2014-03-11','12:35:00',2),('14598','2014-03-11','12:40:00',2.28),('14598','2014-03-11','12:45:00',2.57),('14598','2014-03-11','12:50:00',2.85),('14598','2014-03-11','12:55:00',3.27),('14598','2014-03-11','13:00:00',3.39),('14598','2014-03-11','13:05:00',2.61),('14598','2014-03-11','13:10:00',2.96),('14598','2014-03-11','13:15:00',2.81),('14598','2014-03-11','13:20:00',2.86),('14598','2014-03-11','13:25:00',3.1),('14598','2014-03-11','13:30:00',3.27),('14598','2014-03-11','13:35:00',3.05),('14598','2014-03-11','13:40:00',2.93),('14598','2014-03-11','13:45:00',2.6),('14598','2014-03-11','13:50:00',2.48),('14598','2014-03-11','13:55:00',2.93),('14598','2014-03-11','14:00:00',3.28),('14598','2014-03-11','14:05:00',3.44),('14598','2014-03-11','14:10:00',3.55),('14598','2014-03-11','14:15:00',3.56),('14598','2014-03-11','14:20:00',3.34),('14598','2014-03-11','14:25:00',3.24),('14598','2014-03-11','14:30:00',3.28),('14598','2014-03-11','14:35:00',3.14),('14598','2014-03-11','14:40:00',2.63),('14598','2014-03-11','14:45:00',2.66),('14598','2014-03-11','14:50:00',2.54),('14598','2014-03-11','14:55:00',2.53),('14598','2014-03-11','15:00:00',2.15),('14598','2014-03-11','15:05:00',2.12),('14598','2014-03-11','15:10:00',2.04),('14598','2014-03-11','15:15:00',1.55),('14598','2014-03-11','15:20:00',1.26),('14598','2014-03-11','15:25:00',1.01),('14598','2014-03-10','08:25:00',1.03),('14598','2014-03-10','08:30:00',1.1),('14598','2014-03-10','08:35:00',1.25),('14598','2014-03-10','08:40:00',1.38),('14598','2014-03-10','08:45:00',1.35),('14598','2014-03-10','08:50:00',1.36),('14598','2014-03-10','08:55:00',1.44),('14598','2014-03-10','09:00:00',1.53),('14598','2014-03-10','09:05:00',1.72),('14598','2014-03-10','09:10:00',1.81),('14598','2014-03-10','09:15:00',1.69),('14598','2014-03-10','09:20:00',1.71),('14598','2014-03-10','09:25:00',1.66),('14598','2014-03-10','09:30:00',1.61),('14598','2014-03-10','09:35:00',1.74),('14598','2014-03-10','09:40:00',1.83),('14598','2014-03-10','09:45:00',1.94),('14598','2014-03-10','09:50:00',2.06),('14598','2014-03-10','09:55:00',2.1),('14598','2014-03-10','10:00:00',2.18),('14598','2014-03-10','10:05:00',2.15),('14598','2014-03-10','10:10:00',2.14),('14598','2014-03-10','10:15:00',2.24),('14598','2014-03-10','10:20:00',2.35),('14598','2014-03-10','10:25:00',2.26),('14598','2014-03-10','10:30:00',1.73),('14598','2014-03-10','10:35:00',1.31),('14598','2014-03-10','10:40:00',1.36),('14598','2014-03-10','10:45:00',1.45),('14598','2014-03-10','10:50:00',1.48),('14598','2014-03-10','10:55:00',1.49),('14598','2014-03-10','11:00:00',1.6),('14598','2014-03-10','11:05:00',1.47),('14598','2014-03-10','11:10:00',1.42),('14598','2014-03-10','11:15:00',1.68),('14598','2014-03-10','11:20:00',1.56),('14598','2014-03-10','11:25:00',1.19),('14598','2014-03-10','11:30:00',1.08),('14598','2014-03-10','11:35:00',1.14),('14598','2014-03-10','11:40:00',1.21),('14598','2014-03-10','11:45:00',1.11),('14598','2014-03-10','12:30:00',1),('14598','2014-03-10','12:35:00',1.01),('14598','2014-03-10','12:40:00',1.2),('14598','2014-03-10','12:45:00',1.11),('14598','2014-03-10','13:25:00',1.05),('14598','2014-03-10','13:30:00',1.18),('14598','2014-03-10','13:35:00',1.3),('14598','2014-03-10','13:40:00',1.19),('14598','2014-03-10','15:25:00',1.11),('14598','2014-03-10','15:30:00',1.11),('14598','2014-03-10','15:35:00',2.01),('14598','2014-03-10','15:40:00',1.51),('14598','2014-03-10','15:45:00',1.62),('14598','2014-03-10','15:50:00',1.54),('14598','2014-03-10','15:55:00',2.47),('14598','2014-03-10','16:00:00',2.63),('14598','2014-03-10','16:05:00',2.35),('14598','2014-03-10','16:10:00',2.24),('14598','2014-03-10','16:15:00',1.77),('14598','2014-03-10','16:20:00',1.94),('14598','2014-03-10','16:25:00',1.93),('14598','2014-03-10','16:30:00',1.89),('14598','2014-03-10','16:35:00',1.82),('14598','2014-03-10','16:40:00',1.73),('14598','2014-03-10','16:45:00',1.48),('14598','2014-03-10','16:50:00',1.24),('14598','2014-03-09','08:20:00',1.05),('14598','2014-03-09','08:25:00',1.15),('14598','2014-03-09','08:30:00',1.26),('14598','2014-03-09','08:35:00',1.4),('14598','2014-03-09','08:40:00',1.52),('14598','2014-03-09','08:45:00',1.64),('14598','2014-03-09','08:50:00',1.74),('14598','2014-03-09','08:55:00',1.85),('14598','2014-03-09','09:00:00',1.96),('14598','2014-03-09','09:05:00',2.06),('14598','2014-03-09','09:10:00',2.16),('14598','2014-03-09','09:15:00',2.25),('14598','2014-03-09','09:20:00',2.34),('14598','2014-03-09','09:25:00',2.42),('14598','2014-03-09','09:30:00',2.5),('14598','2014-03-09','09:35:00',2.58),('14598','2014-03-09','09:40:00',2.66),('14598','2014-03-09','09:45:00',2.75),('14598','2014-03-09','09:50:00',2.84),('14598','2014-03-09','09:55:00',2.92),('14598','2014-03-09','10:00:00',3.03),('14598','2014-03-09','10:05:00',3.15),('14598','2014-03-09','10:10:00',3.25),('14598','2014-03-09','10:15:00',3.38),('14598','2014-03-09','10:20:00',3.53),('14598','2014-03-09','10:25:00',3.71),('14598','2014-03-09','10:30:00',3.78),('14598','2014-03-09','10:35:00',3.88),('14598','2014-03-09','10:40:00',3.85),('14598','2014-03-09','10:45:00',3.84),('14598','2014-03-09','10:50:00',3.59),('14598','2014-03-09','10:55:00',2.82),('14598','2014-03-09','11:00:00',1.67),('14598','2014-03-09','11:05:00',4.73),('14598','2014-03-09','11:10:00',4.59),('14598','2014-03-09','11:15:00',4.59),('14598','2014-03-09','11:20:00',2.98),('14598','2014-03-09','11:25:00',1.19),('14598','2014-03-09','11:30:00',1.14),('14598','2014-03-09','11:35:00',1.09),('14598','2014-03-09','11:40:00',1.08),('14598','2014-03-09','11:45:00',1.46),('14598','2014-03-09','11:50:00',4.33),('14598','2014-03-09','11:55:00',2.82),('14598','2014-03-09','12:00:00',2.31),('14598','2014-03-09','12:05:00',1.92),('14598','2014-03-09','12:10:00',2.34),('14598','2014-03-09','12:15:00',3.58),('14598','2014-03-09','12:20:00',1.25),('14598','2014-03-09','12:25:00',1.6),('14598','2014-03-09','12:30:00',1.53),('14598','2014-03-09','12:35:00',2.44),('14598','2014-03-09','12:40:00',4.9),('14598','2014-03-09','12:45:00',4.81),('14598','2014-03-09','12:50:00',4.8),('14598','2014-03-09','12:55:00',4.8),('14598','2014-03-09','13:00:00',4.78),('14598','2014-03-09','13:05:00',4.12),('14598','2014-03-09','13:10:00',4.63),('14598','2014-03-09','13:15:00',4.53),('14598','2014-03-09','13:20:00',3.9),('14598','2014-03-09','13:25:00',4.55),('14598','2014-03-09','13:30:00',4.53),('14598','2014-03-09','13:35:00',4.47),('14598','2014-03-09','13:40:00',4.57),('14598','2014-03-09','13:45:00',4.54),('14598','2014-03-09','13:50:00',4.4),('14598','2014-03-09','13:55:00',4.37),('14598','2014-03-09','14:00:00',4.42),('14598','2014-03-09','14:05:00',4.47),('14598','2014-03-09','14:10:00',4.51),('14598','2014-03-09','14:15:00',4.3),('14598','2014-03-09','14:20:00',2.54),('14598','2014-03-09','14:25:00',1.25),('14598','2014-03-09','14:30:00',1.45),('14598','2014-03-09','14:35:00',3.89),('14598','2014-03-09','14:40:00',3.66),('14598','2014-03-09','14:45:00',3.75),('14598','2014-03-09','14:50:00',3.67),('14598','2014-03-09','14:55:00',3.14),('14598','2014-03-09','15:00:00',2.17),('14598','2014-03-09','15:05:00',1.89),('14598','2014-03-09','15:10:00',1.55),('14598','2014-03-09','15:35:00',1.42),('14598','2014-03-09','15:40:00',1.71),('14598','2014-03-09','15:45:00',2.76),('14598','2014-03-09','15:50:00',2.98),('14598','2014-03-09','15:55:00',2.88),('14598','2014-03-09','16:00:00',2.89),('14598','2014-03-09','16:05:00',2.89),('14598','2014-03-09','16:10:00',2.61),('14598','2014-03-09','16:15:00',2.42),('14598','2014-03-09','16:20:00',2.31),('14598','2014-03-09','16:25:00',2.12),('14598','2014-03-09','16:30:00',1.76),('14598','2014-03-09','16:35:00',1.76),('14598','2014-03-09','16:40:00',1.54),('14598','2014-03-09','16:45:00',1.52),('14598','2014-03-09','16:50:00',1.39),('14598','2014-03-09','16:55:00',1.28),('14598','2014-03-09','17:00:00',1.19),('14598','2014-03-09','17:05:00',1.07),('14598','2014-03-08','08:20:00',1.04),('14598','2014-03-08','08:25:00',1.16),('14598','2014-03-08','08:30:00',1.27),('14598','2014-03-08','08:35:00',1.39),('14598','2014-03-08','08:40:00',1.49),('14598','2014-03-08','08:45:00',1.63),('14598','2014-03-08','08:50:00',1.73),('14598','2014-03-08','08:55:00',1.84),('14598','2014-03-08','09:00:00',1.94),('14598','2014-03-08','09:05:00',2.05),('14598','2014-03-08','09:10:00',2.15),('14598','2014-03-08','09:15:00',2.25),('14598','2014-03-08','09:20:00',2.34),('14598','2014-03-08','09:25:00',2.43),('14598','2014-03-08','09:30:00',2.51),('14598','2014-03-08','09:35:00',2.6),('14598','2014-03-08','09:40:00',2.68),('14598','2014-03-08','09:45:00',2.77),('14598','2014-03-08','09:50:00',2.84),('14598','2014-03-08','09:55:00',2.9),('14598','2014-03-08','10:00:00',2.98),('14598','2014-03-08','10:05:00',3.06),('14598','2014-03-08','10:10:00',3.17),('14598','2014-03-08','10:15:00',3.22),('14598','2014-03-08','10:20:00',3.31),('14598','2014-03-08','10:25:00',3.39),('14598','2014-03-08','10:30:00',3.54),('14598','2014-03-08','10:35:00',2.54),('14598','2014-03-08','10:40:00',3.79),('14598','2014-03-08','10:45:00',2.96),('14598','2014-03-08','10:50:00',3.29),('14598','2014-03-08','10:55:00',4.11),('14598','2014-03-08','11:00:00',4.34),('14598','2014-03-08','11:05:00',3.54),('14598','2014-03-08','11:10:00',3.13),('14598','2014-03-08','11:15:00',4.23),('14598','2014-03-08','11:20:00',2.2),('14598','2014-03-08','11:25:00',1.55),('14598','2014-03-08','11:30:00',2.63),('14598','2014-03-08','11:35:00',3.36),('14598','2014-03-08','11:40:00',2.85),('14598','2014-03-08','11:45:00',3.35),('14598','2014-03-08','11:50:00',4.03),('14598','2014-03-08','11:55:00',2.57),('14598','2014-03-08','12:00:00',2.96),('14598','2014-03-08','12:05:00',1.8),('14598','2014-03-08','12:10:00',1.77),('14598','2014-03-08','12:15:00',1.82),('14598','2014-03-08','12:20:00',2.08),('14598','2014-03-08','12:25:00',2.35),('14598','2014-03-08','12:30:00',2.48),('14598','2014-03-08','12:35:00',2.53),('14598','2014-03-08','12:40:00',2.08),('14598','2014-03-08','12:45:00',1.83),('14598','2014-03-08','12:50:00',1.7),('14598','2014-03-08','12:55:00',1.55),('14598','2014-03-08','13:00:00',1.45),('14598','2014-03-08','13:05:00',1.51),('14598','2014-03-08','13:10:00',1.61),('14598','2014-03-08','13:15:00',1.73),('14598','2014-03-08','13:20:00',1.61),('14598','2014-03-08','13:25:00',1.39),('14598','2014-03-08','13:30:00',1.44),('14598','2014-03-08','13:35:00',1.62),('14598','2014-03-08','13:40:00',1.62),('14598','2014-03-08','13:45:00',1.48),('14598','2014-03-08','13:50:00',1.43),('14598','2014-03-08','13:55:00',1.54),('14598','2014-03-08','14:00:00',1.76),('14598','2014-03-08','14:05:00',2.4),('14598','2014-03-08','14:10:00',2.52),('14598','2014-03-08','14:15:00',1.95),('14598','2014-03-08','14:20:00',1.75),('14598','2014-03-08','14:25:00',1.27),('14598','2014-03-08','14:30:00',1.07),('14598','2014-03-08','15:00:00',1.03),('14598','2014-03-08','15:05:00',1.27),('14598','2014-03-08','15:10:00',1.48),('14598','2014-03-08','15:15:00',1.91),('14598','2014-03-08','15:20:00',1.92),('14598','2014-03-08','15:25:00',1.54),('14598','2014-03-08','15:30:00',1.1),('14598','2014-03-08','15:35:00',1.01),('14598','2014-03-08','15:40:00',1.3),('14598','2014-03-08','15:45:00',1.13),('14598','2014-03-08','15:50:00',1.22),('14598','2014-03-08','15:55:00',1.95),('14598','2014-03-08','17:05:00',1.17),('14598','2014-03-08','17:10:00',1.04),('14598','2014-04-30','08:10:00',1.06),('14598','2014-04-30','08:15:00',1.17),('14598','2014-04-30','08:20:00',1.27),('14598','2014-04-30','08:25:00',1.37),('14598','2014-04-30','08:30:00',1.48),('14598','2014-04-30','08:35:00',1.6),('14598','2014-04-30','08:40:00',1.7),('14598','2014-04-30','08:45:00',1.84),('14598','2014-04-30','08:50:00',1.94),('14598','2014-04-30','08:55:00',2.06),('14598','2014-04-30','09:00:00',2.17),('14598','2014-04-30','09:05:00',2.29),('14598','2014-04-30','09:10:00',2.39),('14598','2014-04-30','09:15:00',2.5),('14598','2014-04-30','09:20:00',2.57),('14598','2014-04-30','09:25:00',2.65),('14598','2014-04-30','09:30:00',2.78),('14598','2014-04-30','09:35:00',2.98),('14598','2014-04-30','09:40:00',2.42),('14598','2014-04-30','09:45:00',1.3),('14598','2014-04-30','09:50:00',2.36),('14598','2014-04-30','09:55:00',3.48),('14598','2014-04-30','10:00:00',3.62),('14598','2014-04-30','10:05:00',3.69),('14598','2014-04-30','10:10:00',3.63),('14598','2014-04-30','10:15:00',3.66),('14598','2014-04-30','10:20:00',3.71),('14598','2014-04-30','10:25:00',3.92),('14598','2014-04-30','10:30:00',4.15),('14598','2014-04-30','10:35:00',2.79),('14598','2014-04-30','10:40:00',2.31),('14598','2014-04-30','10:45:00',2.5),('14598','2014-04-30','10:50:00',3.49),('14598','2014-04-30','10:55:00',2.58),('14598','2014-04-30','11:00:00',2.19),('14598','2014-04-30','11:05:00',4.41),('14598','2014-04-30','11:10:00',4.54),('14598','2014-04-30','11:15:00',4.62),('14598','2014-04-30','11:20:00',4.29),('14598','2014-04-30','11:25:00',4.52),('14598','2014-04-30','11:30:00',3.69),('14598','2014-04-30','11:35:00',3.15),('14598','2014-04-30','11:40:00',3.44),('14598','2014-04-30','11:45:00',4.37),('14598','2014-04-30','11:50:00',3.92),('14598','2014-04-30','11:55:00',5.05),('14598','2014-04-30','12:00:00',5.13),('14598','2014-04-30','12:05:00',5.06),('14598','2014-04-30','12:10:00',4.83),('14598','2014-04-30','12:15:00',4.75),('14598','2014-04-30','12:20:00',5.01),('14598','2014-04-30','12:25:00',4.89),('14598','2014-04-30','12:30:00',5.12),('14598','2014-04-30','12:35:00',4.94),('14598','2014-04-30','12:40:00',4.4),('14598','2014-04-30','12:45:00',4.47),('14598','2014-04-30','12:50:00',5.39),('14598','2014-04-30','12:55:00',5.14),('14598','2014-04-30','13:00:00',2.74),('14598','2014-04-30','13:05:00',1.91),('14598','2014-04-30','13:10:00',1.77),('14598','2014-04-30','13:15:00',3.23),('14598','2014-04-30','13:20:00',3.11),('14598','2014-04-30','13:25:00',3.02),('14598','2014-04-30','13:30:00',2.7),('14598','2014-04-30','13:35:00',2.83),('14598','2014-04-30','13:40:00',3.45),('14598','2014-04-30','13:45:00',5.12),('14598','2014-04-30','13:50:00',5.11),('14598','2014-04-30','13:55:00',5.39),('14598','2014-04-30','14:00:00',3.54),('14598','2014-04-30','14:05:00',3.47),('14598','2014-04-30','14:10:00',3.24),('14598','2014-04-30','14:15:00',3.23),('14598','2014-04-30','14:20:00',3.47),('14598','2014-04-30','14:25:00',2.15),('14598','2014-04-30','14:30:00',2.21),('14598','2014-04-30','14:35:00',2.44),('14598','2014-04-30','14:40:00',1.68),('14598','2014-04-30','14:45:00',2.55),('14598','2014-04-30','14:50:00',3.92),('14598','2014-04-30','14:55:00',3.52),('14598','2014-04-30','15:00:00',3.51),('14598','2014-04-30','15:05:00',2.54),('14598','2014-04-30','15:10:00',2.92),('14598','2014-04-30','15:15:00',2.91),('14598','2014-04-30','15:20:00',4.43),('14598','2014-04-30','15:25:00',3.88),('14598','2014-04-30','15:30:00',4.47),('14598','2014-04-30','15:35:00',4.17),('14598','2014-04-30','15:40:00',2.62),('14598','2014-04-30','15:45:00',3.88),('14598','2014-04-30','15:50:00',4.13),('14598','2014-04-30','15:55:00',4.48),('14598','2014-04-30','16:00:00',3.55),('14598','2014-04-30','16:05:00',2.84),('14598','2014-04-30','16:10:00',3.48),('14598','2014-04-30','16:15:00',3.25),('14598','2014-04-30','16:20:00',2.72),('14598','2014-04-30','16:25:00',3.3),('14598','2014-04-30','16:30:00',3.73),('14598','2014-04-30','16:35:00',3.14),('14598','2014-04-30','16:40:00',2.57),('14598','2014-04-30','16:45:00',3.57),('14598','2014-04-30','16:50:00',3.48),('14598','2014-04-30','16:55:00',3.48),('14598','2014-04-30','17:00:00',3.43),('14598','2014-04-30','17:05:00',3.32),('14598','2014-04-30','17:10:00',2.17),('14598','2014-04-30','17:15:00',1.56),('14598','2014-04-30','17:20:00',1.94),('14598','2014-04-30','17:25:00',2.58),('14598','2014-04-30','17:30:00',1.76),('14598','2014-04-30','17:35:00',1.31),('14598','2014-04-30','17:40:00',1.9),('14598','2014-04-30','17:45:00',1.4),('14598','2014-04-30','17:50:00',1.18),('14598','2014-03-07','08:55:00',1.35),('14598','2014-03-07','09:00:00',1.3),('14598','2014-03-07','09:45:00',1.21),('14598','2014-03-07','09:50:00',1.5),('14598','2014-03-07','09:55:00',1.29),('14598','2014-03-07','10:00:00',1.1),('14598','2014-03-07','10:05:00',1.18),('14598','2014-03-07','10:10:00',1.61),('14598','2014-03-07','10:15:00',2.84),('14598','2014-03-07','10:20:00',4.1),('14598','2014-03-07','10:25:00',2.95),('14598','2014-03-07','10:30:00',3.87),('14598','2014-03-07','10:35:00',3.67),('14598','2014-03-07','10:40:00',3.7),('14598','2014-03-07','10:45:00',3.7),('14598','2014-03-07','10:50:00',3.18),('14598','2014-03-07','10:55:00',1.69),('14598','2014-03-07','11:00:00',1.76),('14598','2014-03-07','11:05:00',2.25),('14598','2014-03-07','11:10:00',1.62),('14598','2014-03-07','11:15:00',1.35),('14598','2014-03-07','11:20:00',1.32),('14598','2014-03-07','11:25:00',1.82),('14598','2014-03-07','11:30:00',1.5),('14598','2014-03-07','11:35:00',2.66),('14598','2014-03-07','11:40:00',4.45),('14598','2014-03-07','11:45:00',4.38),('14598','2014-03-07','11:50:00',4.37),('14598','2014-03-07','11:55:00',4.31),('14598','2014-03-07','12:00:00',4.26),('14598','2014-03-07','12:05:00',4.02),('14598','2014-03-07','12:10:00',1.84),('14598','2014-03-07','12:15:00',3.43),('14598','2014-03-07','12:20:00',3.76),('14598','2014-03-07','12:25:00',4.25),('14598','2014-03-07','12:30:00',4.06),('14598','2014-03-07','12:35:00',3.41),('14598','2014-03-07','12:40:00',2.97),('14598','2014-03-07','12:45:00',2.86),('14598','2014-03-07','12:50:00',3.13),('14598','2014-03-07','12:55:00',3.45),('14598','2014-03-07','13:00:00',3.77),('14598','2014-03-07','13:05:00',4.22),('14598','2014-03-07','13:10:00',3.1),('14598','2014-03-07','13:15:00',1.39),('14598','2014-03-07','13:20:00',1.3),('14598','2014-03-07','13:25:00',1.12),('14598','2014-03-07','13:30:00',1.05),('14598','2014-03-07','13:35:00',1.13),('14598','2014-03-07','13:40:00',1.81),('14598','2014-03-07','13:45:00',2.24),('14598','2014-03-07','13:50:00',2.79),('14598','2014-03-07','13:55:00',2.54),('14598','2014-03-07','14:00:00',2.91),('14598','2014-03-07','14:05:00',2.68),('14598','2014-03-07','14:10:00',2.54),('14598','2014-03-07','14:15:00',2.05),('14598','2014-03-07','14:20:00',1.43),('14598','2014-03-07','14:25:00',2.58),('14598','2014-03-07','14:30:00',3.84),('14598','2014-03-07','14:35:00',3.74),('14598','2014-03-07','14:40:00',4.09),('14598','2014-03-07','14:45:00',3.32),('14598','2014-03-07','14:50:00',3.83),('14598','2014-03-07','14:55:00',2.76),('14598','2014-03-07','15:15:00',1.05),('14598','2014-03-07','15:20:00',1.42),('14598','2014-03-07','15:25:00',2.16),('14598','2014-03-07','15:40:00',1.43),('14598','2014-03-07','15:45:00',1.87),('14598','2014-03-07','15:50:00',1.18),('14598','2014-03-07','15:55:00',1.67),('14598','2014-03-07','16:00:00',1.27),('14598','2014-03-07','16:15:00',1.64),('14598','2014-03-07','16:20:00',2.15),('14598','2014-03-07','16:25:00',1.69),('14598','2014-03-07','16:30:00',1.86),('14598','2014-03-07','16:35:00',1.75),('14598','2014-03-07','16:40:00',1.05),('14598','2014-03-06','08:15:00',1.13),('14598','2014-03-06','08:20:00',1.65),('14598','2014-03-06','08:25:00',1.48),('14598','2014-03-06','08:30:00',1.31),('14598','2014-03-06','08:35:00',1.78),('14598','2014-03-06','08:40:00',1.67),('14598','2014-03-06','08:45:00',1.77),('14598','2014-03-06','08:50:00',2.03),('14598','2014-03-06','08:55:00',2.09),('14598','2014-03-06','09:00:00',2.23),('14598','2014-03-06','09:05:00',1.99),('14598','2014-03-06','09:10:00',2.29),('14598','2014-03-06','09:15:00',2.37),('14598','2014-03-06','09:20:00',2.51),('14598','2014-03-06','09:25:00',2.79),('14598','2014-03-06','09:30:00',2.64),('14598','2014-03-06','09:35:00',2.06),('14598','2014-03-06','09:40:00',2.14),('14598','2014-03-06','09:45:00',2.76),('14598','2014-03-06','09:50:00',2.91),('14598','2014-03-06','09:55:00',3.4),('14598','2014-03-06','10:00:00',3.21),('14598','2014-03-06','10:05:00',2.48),('14598','2014-03-06','10:10:00',2.83),('14598','2014-03-06','10:15:00',2.64),('14598','2014-03-06','10:20:00',3),('14598','2014-03-06','10:25:00',3.2),('14598','2014-03-06','10:30:00',3.05),('14598','2014-03-06','10:35:00',3.17),('14598','2014-03-06','10:40:00',3.47),('14598','2014-03-06','10:45:00',3.49),('14598','2014-03-06','10:50:00',3.71),('14598','2014-03-06','10:55:00',4.03),('14598','2014-03-06','11:00:00',4.1),('14598','2014-03-06','11:05:00',4.08),('14598','2014-03-06','11:10:00',1.56),('14598','2014-03-06','11:15:00',1.76),('14598','2014-03-06','11:20:00',1.69),('14598','2014-03-06','11:25:00',1.39),('14598','2014-03-06','11:30:00',1.37),('14598','2014-03-06','11:35:00',1.06),('14598','2014-03-06','11:40:00',1.02),('14598','2014-03-06','11:45:00',3.39),('14598','2014-03-06','11:50:00',4.45),('14598','2014-03-06','11:55:00',1.84),('14598','2014-03-06','12:00:00',2),('14598','2014-03-06','12:05:00',2.01),('14598','2014-03-06','12:10:00',1.88),('14598','2014-03-06','12:15:00',3.3),('14598','2014-03-06','12:20:00',3.09),('14598','2014-03-06','12:25:00',5.49),('14598','2014-03-06','12:30:00',2.48),('14598','2014-03-06','12:35:00',4.3),('14598','2014-03-06','12:40:00',2.01),('14598','2014-03-06','12:45:00',1.67),('14598','2014-03-06','12:50:00',2.94),('14598','2014-03-06','12:55:00',3.15),('14598','2014-03-06','13:00:00',5.01),('14598','2014-03-06','13:05:00',4.71),('14598','2014-03-06','13:10:00',4.83),('14598','2014-03-06','13:15:00',4.86),('14598','2014-03-06','13:20:00',2.77),('14598','2014-03-06','13:25:00',2.17),('14598','2014-03-06','13:30:00',2.63),('14598','2014-03-06','13:35:00',4.47),('14598','2014-03-06','13:40:00',4.11),('14598','2014-03-06','13:45:00',2.57),('14598','2014-03-06','13:50:00',2),('14598','2014-03-06','13:55:00',1.88),('14598','2014-03-06','14:00:00',1.61),('14598','2014-03-06','14:05:00',1.04),('14598','2014-03-06','14:25:00',1.06),('14598','2014-03-06','14:30:00',1.1),('14598','2014-03-06','14:35:00',1.46),('14598','2014-03-06','14:40:00',3.42),('14598','2014-03-06','14:45:00',3.45),('14598','2014-03-06','14:50:00',1.88),('14598','2014-03-06','14:55:00',1.26),('14598','2014-03-06','15:00:00',1.26),('14598','2014-03-06','15:05:00',1.18),('14598','2014-03-06','16:20:00',2.2),('14598','2014-03-06','16:25:00',1.85),('14598','2014-03-06','16:55:00',1.08),('14598','2014-03-05','08:15:00',1.06),('14598','2014-03-05','08:20:00',1.1),('14598','2014-03-05','08:25:00',1.15),('14598','2014-03-05','08:30:00',1.24),('14598','2014-03-05','08:35:00',1.28),('14598','2014-03-05','08:40:00',1.48),('14598','2014-03-05','08:45:00',1.04),('14598','2014-03-05','08:55:00',1.81),('14598','2014-03-05','09:00:00',1.88),('14598','2014-03-05','09:05:00',1.78),('14598','2014-03-05','09:10:00',1.96),('14598','2014-03-05','09:15:00',2.03),('14598','2014-03-05','09:20:00',1.68),('14598','2014-03-05','09:25:00',2.42),('14598','2014-03-05','09:30:00',2.54),('14598','2014-03-05','09:35:00',1.85),('14598','2014-03-05','09:40:00',2.3),('14598','2014-03-05','09:45:00',2.77),('14598','2014-03-05','09:50:00',2.82),('14598','2014-03-05','09:55:00',2.91),('14598','2014-03-05','10:00:00',3),('14598','2014-03-05','10:05:00',3.09),('14598','2014-03-05','10:10:00',3.14),('14598','2014-03-05','10:15:00',3.22),('14598','2014-03-05','10:20:00',3.28),('14598','2014-03-05','10:25:00',3.33),('14598','2014-03-05','10:30:00',3.38),('14598','2014-03-05','10:35:00',3.45),('14598','2014-03-05','10:40:00',3.5),('14598','2014-03-05','10:45:00',3.54),('14598','2014-03-05','10:50:00',3.61),('14598','2014-03-05','10:55:00',3.66),('14598','2014-03-05','11:00:00',3.71),('14598','2014-03-05','11:05:00',3.75),('14598','2014-03-05','11:10:00',3.8),('14598','2014-03-05','11:15:00',3.84),('14598','2014-03-05','11:20:00',3.65),('14598','2014-03-05','11:25:00',4),('14598','2014-03-05','11:30:00',3.91),('14598','2014-03-05','11:35:00',4.6),('14598','2014-03-05','11:40:00',3.29),('14598','2014-03-05','11:45:00',3.78),('14598','2014-03-05','11:50:00',3.42),('14598','2014-03-05','11:55:00',2.14),('14598','2014-03-05','12:00:00',1.28),('14598','2014-03-05','12:05:00',4.39),('14598','2014-03-05','12:10:00',4.44),('14598','2014-03-05','12:15:00',4.06),('14598','2014-03-05','12:20:00',3.04),('14598','2014-03-05','12:25:00',3.94),('14598','2014-03-05','12:30:00',3.52),('14598','2014-03-05','12:35:00',3.53),('14598','2014-03-05','12:40:00',3.67),('14598','2014-03-05','12:45:00',3.57),('14598','2014-03-05','12:50:00',2.57),('14598','2014-03-05','12:55:00',2.99),('14598','2014-03-05','13:00:00',1.99),('14598','2014-03-05','13:05:00',2.35),('14598','2014-03-05','13:10:00',2.9),('14598','2014-03-05','13:15:00',2.32),('14598','2014-03-05','13:20:00',1.64),('14598','2014-03-05','13:25:00',1.4),('14598','2014-03-05','13:30:00',1.1),('14598','2014-03-05','13:35:00',2.23),('14598','2014-03-05','13:40:00',4.1),('14598','2014-03-05','13:45:00',4.49),('14598','2014-03-05','13:50:00',4.2),('14598','2014-03-05','13:55:00',4.32),('14598','2014-03-05','14:00:00',4.52),('14598','2014-03-05','14:05:00',4.08),('14598','2014-03-05','14:10:00',4.8),('14598','2014-03-05','14:15:00',3.91),('14598','2014-03-05','14:20:00',4.62),('14598','2014-03-05','14:25:00',4.87),('14598','2014-03-05','14:30:00',4.91),('14598','2014-03-05','14:35:00',3.22),('14598','2014-03-05','14:40:00',1.79),('14598','2014-03-05','14:45:00',1.82),('14598','2014-03-05','14:50:00',3.78),('14598','2014-03-05','14:55:00',3.14),('14598','2014-03-05','15:00:00',1.92),('14598','2014-03-05','15:05:00',1.59),('14598','2014-03-05','15:10:00',3.07),('14598','2014-03-05','15:15:00',3.18),('14598','2014-03-05','15:20:00',3.9),('14598','2014-03-05','15:25:00',2.78),('14598','2014-03-05','15:30:00',3.22),('14598','2014-03-05','15:35:00',3.51),('14598','2014-03-05','15:40:00',1.8),('14598','2014-03-05','15:50:00',1.2),('14598','2014-03-05','15:55:00',1.27),('14598','2014-03-05','16:00:00',1.49),('14598','2014-03-05','16:05:00',1.11),('14598','2014-03-05','16:15:00',1.25),('14598','2014-03-05','16:20:00',1.26),('14598','2014-03-04','08:35:00',1.03),('14598','2014-03-04','08:40:00',1.05),('14598','2014-03-04','08:45:00',1.55),('14598','2014-03-04','08:50:00',1.34),('14598','2014-03-04','09:50:00',1.64),('14598','2014-03-04','09:55:00',2.87),('14598','2014-03-04','10:00:00',4.18),('14598','2014-03-04','10:05:00',1.68),('14598','2014-03-04','10:10:00',1.4),('14598','2014-03-04','10:15:00',1.74),('14598','2014-03-04','10:20:00',2.21),('14598','2014-03-04','10:25:00',3.1),('14598','2014-03-04','10:30:00',2.42),('14598','2014-03-04','11:05:00',1.15),('14598','2014-03-04','11:10:00',1.26),('14598','2014-03-04','11:15:00',3.84),('14598','2014-03-04','11:20:00',4.66),('14598','2014-03-04','11:25:00',4.51),('14598','2014-03-04','11:30:00',4.88),('14598','2014-03-04','11:35:00',4.74),('14598','2014-03-04','11:40:00',2.56),('14598','2014-03-04','11:45:00',2.63),('14598','2014-03-04','11:50:00',4.08),('14598','2014-03-04','11:55:00',4.44),('14598','2014-03-04','12:00:00',4.28),('14598','2014-03-04','12:05:00',4.13),('14598','2014-03-04','12:10:00',4.26),('14598','2014-03-04','12:15:00',4.15),('14598','2014-03-04','12:20:00',4.3),('14598','2014-03-04','12:25:00',4.31),('14598','2014-03-04','12:30:00',4.33),('14598','2014-03-04','12:35:00',4.37),('14598','2014-03-04','12:40:00',4.31),('14598','2014-03-04','12:45:00',3.88),('14598','2014-03-04','12:50:00',4.37),('14598','2014-03-04','12:55:00',4.62),('14598','2014-03-04','13:00:00',2.04),('14598','2014-03-04','13:10:00',1.59),('14598','2014-03-04','13:15:00',3.11),('14598','2014-03-04','13:20:00',1.79),('14598','2014-03-04','13:25:00',2.55),('14598','2014-03-04','13:30:00',2.13),('14598','2014-03-04','13:35:00',1.53),('14598','2014-03-04','13:40:00',1.46),('14598','2014-03-04','13:45:00',2.23),('14598','2014-03-04','13:50:00',5.14),('14598','2014-03-04','13:55:00',4.54),('14598','2014-03-04','14:00:00',4.23),('14598','2014-03-04','14:05:00',4.37),('14598','2014-03-04','14:10:00',3.7),('14598','2014-03-04','14:15:00',2.06),('14598','2014-03-04','14:20:00',1.98),('14598','2014-03-04','14:25:00',1.56),('14598','2014-03-04','14:30:00',2.13),('14598','2014-03-04','14:35:00',4.23),('14598','2014-03-04','14:40:00',4.05),('14598','2014-03-04','14:45:00',3.83),('14598','2014-03-04','14:50:00',3.73),('14598','2014-03-04','14:55:00',3.64),('14598','2014-03-04','15:00:00',3.63),('14598','2014-03-04','15:05:00',3.6),('14598','2014-03-04','15:10:00',3.47),('14598','2014-03-04','15:15:00',3.37),('14598','2014-03-04','15:20:00',3.3),('14598','2014-03-04','15:25:00',2.16),('14598','2014-03-04','15:30:00',1.49),('14598','2014-03-04','15:35:00',2.47),('14598','2014-03-04','15:40:00',1.56),('14598','2014-03-04','15:45:00',1.6),('14598','2014-03-04','15:50:00',1.74),('14598','2014-03-04','15:55:00',2.76),('14598','2014-03-04','16:00:00',3.09),('14598','2014-03-04','16:05:00',2.56),('14598','2014-03-04','16:10:00',2.44),('14598','2014-03-04','16:15:00',2.24),('14598','2014-03-04','16:20:00',2.06),('14598','2014-03-04','16:25:00',2.04),('14598','2014-03-04','16:30:00',1.97),('14598','2014-03-04','16:35:00',1.7),('14598','2014-03-03','08:30:00',1.13),('14598','2014-03-03','08:35:00',1.22),('14598','2014-03-03','08:40:00',1.33),('14598','2014-03-03','08:45:00',1.51),('14598','2014-03-03','08:50:00',1.67),('14598','2014-03-03','08:55:00',1.82),('14598','2014-03-03','09:00:00',1.87),('14598','2014-03-03','09:05:00',1.21),('14598','2014-03-03','09:10:00',1.57),('14598','2014-03-03','09:15:00',2.05),('14598','2014-03-03','09:20:00',2.28),('14598','2014-03-03','09:25:00',2.38),('14598','2014-03-03','09:30:00',2.46),('14598','2014-03-03','09:35:00',2.56),('14598','2014-03-03','09:40:00',2.65),('14598','2014-03-03','09:45:00',2.73),('14598','2014-03-03','09:50:00',2.81),('14598','2014-03-03','09:55:00',2.88),('14598','2014-03-03','10:00:00',2.97),('14598','2014-03-03','10:05:00',3.03),('14598','2014-03-03','10:10:00',3.09),('14598','2014-03-03','10:15:00',3.16),('14598','2014-03-03','10:20:00',3.21),('14598','2014-03-03','10:25:00',3.26),('14598','2014-03-03','10:30:00',3.33),('14598','2014-03-03','10:35:00',3.39),('14598','2014-03-03','10:40:00',3.45),('14598','2014-03-03','10:45:00',3.51),('14598','2014-03-03','10:50:00',3.56),('14598','2014-03-03','10:55:00',3.62),('14598','2014-03-03','11:00:00',3.71),('14598','2014-03-03','11:05:00',3.77),('14598','2014-03-03','11:10:00',3.82),('14598','2014-03-03','11:15:00',3.86),('14598','2014-03-03','11:20:00',3.91),('14598','2014-03-03','11:25:00',3.96),('14598','2014-03-03','11:30:00',3.99),('14598','2014-03-03','11:35:00',4.03),('14598','2014-03-03','11:40:00',4.04),('14598','2014-03-03','11:45:00',4.12),('14598','2014-03-03','11:50:00',4.15),('14598','2014-03-03','11:55:00',4.18),('14598','2014-03-03','12:00:00',4.21),('14598','2014-03-03','12:05:00',4.23),('14598','2014-03-03','12:10:00',4.25),('14598','2014-03-03','12:15:00',4.27),('14598','2014-03-03','12:20:00',4.28),('14598','2014-03-03','12:25:00',4.29),('14598','2014-03-03','12:30:00',4.3),('14598','2014-03-03','12:35:00',4.31),('14598','2014-03-03','12:40:00',4.32),('14598','2014-03-03','12:45:00',4.32),('14598','2014-03-03','12:50:00',4.31),('14598','2014-03-03','12:55:00',4.3),('14598','2014-03-03','13:00:00',4.32),('14598','2014-03-03','13:05:00',4.31),('14598','2014-03-03','13:10:00',4.3),('14598','2014-03-03','13:15:00',4.28),('14598','2014-03-03','13:20:00',4.26),('14598','2014-03-03','13:25:00',4.24),('14598','2014-03-03','13:30:00',4.22),('14598','2014-03-03','13:35:00',4.18),('14598','2014-03-03','13:40:00',4.16),('14598','2014-03-03','13:45:00',4.13),('14598','2014-03-03','13:50:00',4.1),('14598','2014-03-03','13:55:00',4.09),('14598','2014-03-03','14:00:00',4.06),('14598','2014-03-03','14:05:00',4.03),('14598','2014-03-03','14:10:00',4.01),('14598','2014-03-03','14:15:00',3.97),('14598','2014-03-03','14:20:00',3.93),('14598','2014-03-03','14:25:00',3.89),('14598','2014-03-03','14:30:00',3.85),('14598','2014-03-03','14:35:00',3.8),('14598','2014-03-03','14:40:00',3.7),('14598','2014-03-03','14:45:00',3.7),('14598','2014-03-03','14:50:00',3.64),('14598','2014-03-03','14:55:00',3.58),('14598','2014-03-03','15:00:00',3.53),('14598','2014-03-03','15:05:00',3.46),('14598','2014-03-03','15:10:00',3.4),('14598','2014-03-03','15:15:00',3.34),('14598','2014-03-03','15:20:00',3.25),('14598','2014-03-03','15:25:00',3.17),('14598','2014-03-03','15:30:00',3.1),('14598','2014-03-03','15:35:00',3.01),('14598','2014-03-03','15:40:00',2.93),('14598','2014-03-03','15:45:00',2.85),('14598','2014-03-03','15:50:00',2.76),('14598','2014-03-03','15:55:00',2.66),('14598','2014-03-03','16:00:00',2.58),('14598','2014-03-03','16:05:00',2.48),('14598','2014-03-03','16:10:00',2.38),('14598','2014-03-03','16:15:00',2.29),('14598','2014-03-03','16:20:00',2.18),('14598','2014-03-03','16:25:00',2.07),('14598','2014-03-03','16:30:00',1.96),('14598','2014-03-03','16:35:00',1.8),('14598','2014-03-03','16:40:00',1.75),('14598','2014-03-03','16:45:00',1.65),('14598','2014-03-03','16:50:00',1.55),('14598','2014-03-03','16:55:00',1.44),('14598','2014-03-02','08:10:00',1.24),('14598','2014-03-02','08:15:00',1.16),('14598','2014-03-02','08:20:00',1.21),('14598','2014-03-02','08:25:00',1.65),('14598','2014-03-02','08:30:00',1.68),('14598','2014-03-02','08:35:00',1.92),('14598','2014-03-02','08:40:00',1.04),('14598','2014-03-02','10:10:00',1.28),('14598','2014-03-02','10:15:00',3.01),('14598','2014-03-02','10:20:00',3.62),('14598','2014-03-02','10:25:00',3.68),('14598','2014-03-02','10:30:00',3.66),('14598','2014-03-02','10:35:00',3.64),('14598','2014-03-02','10:40:00',3.36),('14598','2014-03-02','10:45:00',3.07),('14598','2014-03-02','10:50:00',4.2),('14598','2014-03-02','10:55:00',2.07),('14598','2014-03-02','11:00:00',1.69),('14598','2014-03-02','11:05:00',1.37),('14598','2014-03-02','11:10:00',1.16),('14598','2014-03-02','11:15:00',1.3),('14598','2014-03-02','11:20:00',1.5),('14598','2014-03-02','11:25:00',1.77),('14598','2014-03-02','11:30:00',1.73),('14598','2014-03-02','11:35:00',1.41),('14598','2014-03-02','13:15:00',1.06),('14598','2014-03-02','13:20:00',1.09),('14598','2014-03-02','13:25:00',1.04),('14598','2014-03-02','14:20:00',1.03),('14598','2014-03-02','14:25:00',1.09),('14598','2014-03-02','14:30:00',1.15),('14598','2014-03-02','14:35:00',1.21),('14598','2014-03-02','14:40:00',1.25),('14598','2014-03-02','14:45:00',1.27),('14598','2014-03-02','14:50:00',1.27),('14598','2014-03-02','14:55:00',1.3),('14598','2014-03-02','15:00:00',1.33),('14598','2014-03-02','15:05:00',1.39),('14598','2014-03-02','15:10:00',1.43),('14598','2014-03-02','15:15:00',1.47),('14598','2014-03-02','15:20:00',1.53),('14598','2014-03-02','15:25:00',1.57),('14598','2014-03-02','15:30:00',1.5),('14598','2014-03-02','15:35:00',1.39),('14598','2014-03-02','15:40:00',1.3),('14598','2014-03-02','15:45:00',1.22),('14598','2014-03-02','15:50:00',1.14),('14598','2014-03-02','15:55:00',1),('14598','2014-03-01','10:15:00',1.17),('14598','2014-03-01','10:20:00',1.45),('14598','2014-03-01','14:30:00',1.13),('14598','2014-03-01','14:35:00',1),('14598','2014-02-28','08:50:00',1.12),('14598','2014-02-28','08:55:00',1.54),('14598','2014-02-28','09:05:00',1.2),('14598','2014-02-28','09:10:00',1.69),('14598','2014-02-28','09:15:00',1.17),('14598','2014-02-28','09:25:00',1.1),('14598','2014-02-28','09:35:00',1.36),('14598','2014-02-28','09:40:00',2.72),('14598','2014-02-28','09:45:00',1.19),('14598','2014-02-28','09:50:00',1.99),('14598','2014-02-28','09:55:00',2.67),('14598','2014-02-28','10:00:00',1.56),('14598','2014-02-28','10:10:00',1.02),('14598','2014-02-28','10:15:00',1.01),('14598','2014-02-28','11:20:00',1.09),('14598','2014-02-28','11:25:00',1.06),('14598','2014-02-28','12:00:00',1.18),('14598','2014-02-28','12:05:00',1.36),('14598','2014-02-28','12:10:00',1.84),('14598','2014-02-28','12:15:00',2.49),('14598','2014-02-28','12:20:00',2.61),('14598','2014-02-28','12:25:00',2.78),('14598','2014-02-28','12:30:00',2.3),('14598','2014-02-28','12:35:00',1.71),('14598','2014-02-28','12:40:00',3.53),('14598','2014-02-28','12:45:00',4.07),('14598','2014-02-28','12:50:00',3.15),('14598','2014-02-28','12:55:00',4.13),('14598','2014-02-28','13:00:00',2.21),('14598','2014-02-28','13:05:00',3.89),('14598','2014-02-28','13:10:00',2.06),('14598','2014-02-28','13:15:00',1.77),('14598','2014-02-28','13:20:00',1.86),('14598','2014-02-28','13:25:00',2.05),('14598','2014-02-28','13:30:00',2.26),('14598','2014-02-28','13:35:00',2.46),('14598','2014-02-28','13:40:00',1.93),('14598','2014-02-28','13:45:00',1.65),('14598','2014-02-28','13:50:00',1.66),('14598','2014-02-28','13:55:00',1.41),('14598','2014-02-28','14:00:00',1.17),('14598','2014-02-28','14:05:00',1),('14598','2014-02-28','14:10:00',1.01),('14598','2014-02-28','14:15:00',1.04),('14598','2014-02-28','14:25:00',1.38),('14598','2014-02-28','14:30:00',1.77),('14598','2014-02-28','14:35:00',1.01),('14598','2014-02-28','14:45:00',1.14),('14598','2014-02-28','14:50:00',3.5),('14598','2014-02-28','14:55:00',4.15),('14598','2014-02-28','15:00:00',2.72),('14598','2014-02-28','15:05:00',2.97),('14598','2014-02-28','15:10:00',4.33),('14598','2014-02-28','15:15:00',2.14),('14598','2014-02-28','15:20:00',3.17),('14598','2014-02-28','15:25:00',3.05),('14598','2014-02-28','15:30:00',1.71),('14598','2014-02-28','16:30:00',1.07),('14598','2014-02-27','10:40:00',1.17),('14598','2014-02-27','10:45:00',1.3),('14598','2014-02-27','10:50:00',1.4),('14598','2014-02-27','10:55:00',1.45),('14598','2014-02-27','11:00:00',1.55),('14598','2014-02-27','11:05:00',1.63),('14598','2014-02-27','11:10:00',1.7),('14598','2014-02-27','11:15:00',1.66),('14598','2014-02-27','11:20:00',1.59),('14598','2014-02-27','11:25:00',1.59),('14598','2014-02-27','11:30:00',1.57),('14598','2014-02-27','11:35:00',1.57),('14598','2014-02-27','11:40:00',1.59),('14598','2014-02-27','11:45:00',1.6),('14598','2014-02-27','11:50:00',1.62),('14598','2014-02-27','11:55:00',1.65),('14598','2014-02-27','12:00:00',1.7),('14598','2014-02-27','12:05:00',1.76),('14598','2014-02-27','12:10:00',1.8),('14598','2014-02-27','12:15:00',1.87),('14598','2014-02-27','12:20:00',1.91),('14598','2014-02-27','12:25:00',1.95),('14598','2014-02-27','12:30:00',2.01),('14598','2014-02-27','12:35:00',2.06),('14598','2014-02-27','12:40:00',2.02),('14598','2014-02-27','12:45:00',2),('14598','2014-02-27','12:50:00',2.04),('14598','2014-02-27','12:55:00',2.03),('14598','2014-02-27','13:00:00',2.08),('14598','2014-02-27','13:05:00',2.07),('14598','2014-02-27','13:10:00',2.01),('14598','2014-02-27','13:15:00',2.19),('14598','2014-02-27','13:20:00',2.36),('14598','2014-02-27','13:25:00',2.31),('14598','2014-02-27','13:30:00',1.76),('14598','2014-02-27','13:35:00',1.82),('14598','2014-02-27','13:40:00',1.79),('14598','2014-02-27','13:45:00',1.99),('14598','2014-02-27','13:50:00',1.91),('14598','2014-02-27','13:55:00',2.01),('14598','2014-02-27','14:00:00',2.54),('14598','2014-02-27','14:05:00',2.16),('14598','2014-02-27','14:10:00',2.36),('14598','2014-02-27','14:15:00',2.56),('14598','2014-02-27','14:20:00',2.43),('14598','2014-02-27','14:25:00',2.44),('14598','2014-02-27','14:30:00',2.36),('14598','2014-02-27','14:35:00',2.27),('14598','2014-02-27','14:40:00',2.25),('14598','2014-02-27','14:45:00',2.11),('14598','2014-02-27','14:50:00',2.44),('14598','2014-02-27','14:55:00',2.57),('14598','2014-02-27','15:00:00',2.52),('14598','2014-02-27','15:05:00',1.92),('14598','2014-02-27','15:10:00',1.4),('14598','2014-02-27','15:15:00',1.33),('14598','2014-02-27','15:20:00',1.24),('14598','2014-02-27','15:25:00',1.23),('14598','2014-02-27','15:30:00',1.22),('14598','2014-02-27','15:35:00',1.27),('14598','2014-02-27','15:40:00',1.46),('14598','2014-02-27','15:45:00',1.08),('14598','2014-02-27','15:50:00',1.05),('14598','2014-02-27','15:55:00',1.15),('14598','2014-02-27','16:00:00',1.08),('14598','2014-02-27','16:05:00',1.02),('14598','2014-02-27','16:10:00',1.27),('14598','2014-02-27','16:15:00',1.66),('14598','2014-02-27','16:20:00',1.94),('14598','2014-02-27','16:25:00',1.91),('14598','2014-02-27','16:30:00',1.98),('14598','2014-02-27','16:35:00',1.6),('14598','2014-02-27','17:05:00',1.06),('14598','2014-02-26','08:05:00',1.05),('14598','2014-02-26','08:40:00',1.16),('14598','2014-02-26','08:45:00',1.46),('14598','2014-02-26','08:50:00',1.58),('14598','2014-02-26','08:55:00',1.36),('14598','2014-02-26','09:00:00',1.12),('14598','2014-02-26','09:05:00',1.39),('14598','2014-02-26','09:10:00',1.11),('14598','2014-02-26','09:15:00',1),('14598','2014-02-26','09:25:00',1.24),('14598','2014-02-26','10:15:00',1.09),('14598','2014-02-26','10:20:00',1.22),('14598','2014-02-26','10:25:00',1.2),('14598','2014-02-26','10:30:00',1.3),('14598','2014-02-26','10:35:00',1.38),('14598','2014-02-26','10:40:00',1.27),('14598','2014-02-26','10:45:00',1.28),('14598','2014-02-26','10:50:00',1.4),('14598','2014-02-26','10:55:00',1.42),('14598','2014-02-26','11:00:00',1.17),('14598','2014-02-26','11:05:00',1.08),('14598','2014-02-26','11:10:00',1.08),('14598','2014-02-26','11:15:00',1.27),('14598','2014-02-26','11:20:00',1.55),('14598','2014-02-26','11:25:00',1.65),('14598','2014-02-26','11:30:00',1.45),('14598','2014-02-26','11:35:00',1.37),('14598','2014-02-26','11:40:00',1.22),('14598','2014-02-26','11:45:00',1.48),('14598','2014-02-26','11:50:00',1.83),('14598','2014-02-26','11:55:00',2.01),('14598','2014-02-26','12:00:00',2.83),('14598','2014-02-26','12:05:00',3.45),('14598','2014-02-26','12:10:00',3.5),('14598','2014-02-26','12:15:00',3.63),('14598','2014-02-26','12:20:00',3.91),('14598','2014-02-26','12:25:00',3.95),('14598','2014-02-26','12:30:00',3.57),('14598','2014-02-26','12:35:00',3.5),('14598','2014-02-26','12:40:00',3.34),('14598','2014-02-26','12:45:00',3.28),('14598','2014-02-26','12:50:00',3.37),('14598','2014-02-26','12:55:00',3.71),('14598','2014-02-26','13:00:00',3.85),('14598','2014-02-26','13:05:00',3.64),('14598','2014-02-26','13:10:00',3.09),('14598','2014-02-26','13:15:00',3.83),('14598','2014-02-26','13:20:00',4.28),('14598','2014-02-26','13:25:00',4.39),('14598','2014-02-26','13:30:00',4.19),('14598','2014-02-26','13:35:00',3.68),('14598','2014-02-26','13:40:00',2.79),('14598','2014-02-26','13:45:00',3.58),('14598','2014-02-26','13:50:00',3.77),('14598','2014-02-26','13:55:00',3.77),('14598','2014-02-26','14:00:00',3.78),('14598','2014-02-26','14:05:00',3.85),('14598','2014-02-26','14:10:00',3.6),('14598','2014-02-26','14:15:00',3.66),('14598','2014-02-26','14:20:00',3.45),('14598','2014-02-26','14:25:00',3.72),('14598','2014-02-26','14:30:00',3.68),('14598','2014-02-26','14:35:00',3.67),('14598','2014-02-26','14:40:00',3.61),('14598','2014-02-26','14:45:00',3.59),('14598','2014-02-26','14:50:00',3.46),('14598','2014-02-26','14:55:00',2.82),('14598','2014-02-26','15:00:00',2.17),('14598','2014-02-26','15:05:00',1.97),('14598','2014-02-26','15:10:00',2.75),('14598','2014-02-26','15:15:00',3.04),('14598','2014-02-26','15:20:00',2.6),('14598','2014-02-26','15:25:00',2.94),('14598','2014-02-26','15:30:00',2.93),('14598','2014-02-26','15:35:00',3.24),('14598','2014-02-26','15:40:00',2.86),('14598','2014-02-26','15:45:00',2.69),('14598','2014-02-26','15:50:00',2.01),('14598','2014-02-26','15:55:00',1.9),('14598','2014-02-26','16:00:00',2.18),('14598','2014-02-26','16:05:00',1.54),('14598','2014-04-29','09:25:00',1),('14598','2014-04-29','09:30:00',1.11),('14598','2014-04-29','09:35:00',1.38),('14598','2014-04-29','09:40:00',1.25),('14598','2014-04-29','09:45:00',2.99),('14598','2014-04-29','09:50:00',3.25),('14598','2014-04-29','09:55:00',3.26),('14598','2014-04-29','10:00:00',3.63),('14598','2014-04-29','10:05:00',3.68),('14598','2014-04-29','10:10:00',3.71),('14598','2014-04-29','10:15:00',3.85),('14598','2014-04-29','10:20:00',3.32),('14598','2014-04-29','10:25:00',2.87),('14598','2014-04-29','10:30:00',2.37),('14598','2014-04-29','10:35:00',3.98),('14598','2014-04-29','10:40:00',2.34),('14598','2014-04-29','10:45:00',4.22),('14598','2014-04-29','10:50:00',4.41),('14598','2014-04-29','10:55:00',4.3),('14598','2014-04-29','11:00:00',4.39),('14598','2014-04-29','11:05:00',4.46),('14598','2014-04-29','11:10:00',4.67),('14598','2014-04-29','11:15:00',3.13),('14598','2014-04-29','11:20:00',4.79),('14598','2014-04-29','11:25:00',4.91),('14598','2014-04-29','11:30:00',4.93),('14598','2014-04-29','11:35:00',4.89),('14598','2014-04-29','11:40:00',4.67),('14598','2014-04-29','11:45:00',2.81),('14598','2014-04-29','11:50:00',3.09),('14598','2014-04-29','11:55:00',2.84),('14598','2014-04-29','12:00:00',2.43),('14598','2014-04-29','12:05:00',3.27),('14598','2014-04-29','12:10:00',4.78),('14598','2014-04-29','12:15:00',5.11),('14598','2014-04-29','12:20:00',5.13),('14598','2014-04-29','12:25:00',5.19),('14598','2014-04-29','12:30:00',5.18),('14598','2014-04-29','12:35:00',5.16),('14598','2014-04-29','12:40:00',5.2),('14598','2014-04-29','12:45:00',5.15),('14598','2014-04-29','12:50:00',5.2),('14598','2014-04-29','12:55:00',5.23),('14598','2014-04-29','13:00:00',5.24),('14598','2014-04-29','13:05:00',5.26),('14598','2014-04-29','13:10:00',5.26),('14598','2014-04-29','13:15:00',5.25),('14598','2014-04-29','13:20:00',5.26),('14598','2014-04-29','13:25:00',5.25),('14598','2014-04-29','13:30:00',5.27),('14598','2014-04-29','13:35:00',5.28),('14598','2014-04-29','13:40:00',5.26),('14598','2014-04-29','13:45:00',5.26),('14598','2014-04-29','13:50:00',5.25),('14598','2014-04-29','13:55:00',5.29),('14598','2014-04-29','14:00:00',4.85),('14598','2014-04-29','14:05:00',4.65),('14598','2014-04-29','14:10:00',5.14),('14598','2014-04-29','14:15:00',5.24),('14598','2014-04-29','14:20:00',5.21),('14598','2014-04-29','14:25:00',5.18),('14598','2014-04-29','14:30:00',5.15),('14598','2014-04-29','14:35:00',5.12),('14598','2014-04-29','14:40:00',5.11),('14598','2014-04-29','14:45:00',5.14),('14598','2014-04-29','14:50:00',5.03),('14598','2014-04-29','14:55:00',5.54),('14598','2014-04-29','15:00:00',3.65),('14598','2014-04-29','15:05:00',3.61),('14598','2014-04-29','15:10:00',5.22),('14598','2014-04-29','15:15:00',4.94),('14598','2014-04-29','15:20:00',4.89),('14598','2014-04-29','15:25:00',4.8),('14598','2014-04-29','15:30:00',3.98),('14598','2014-04-29','15:35:00',4.73),('14598','2014-04-29','15:40:00',4.68),('14598','2014-04-29','15:45:00',4.64),('14598','2014-04-29','15:50:00',4.57),('14598','2014-04-29','15:55:00',4.55),('14598','2014-04-29','16:00:00',4.54),('14598','2014-04-29','16:05:00',4.44),('14598','2014-04-29','16:10:00',4.37),('14598','2014-04-29','16:15:00',4.36),('14598','2014-04-29','16:20:00',4.29),('14598','2014-04-29','16:25:00',3.38),('14598','2014-04-29','16:30:00',4.37),('14598','2014-04-29','16:35:00',4.6),('14598','2014-04-29','16:40:00',2.87),('14598','2014-04-29','16:45:00',4.36),('14598','2014-04-29','16:50:00',4.12),('14598','2014-04-29','16:55:00',3.72),('14598','2014-04-29','17:00:00',3.59),('14598','2014-04-29','17:05:00',3.48),('14598','2014-04-29','17:10:00',3.39),('14598','2014-04-29','17:15:00',3.33),('14598','2014-04-29','17:20:00',3.24),('14598','2014-04-29','17:25:00',3.15),('14598','2014-04-29','17:30:00',3.05),('14598','2014-04-29','17:35:00',2.97),('14598','2014-04-29','17:40:00',2.89),('14598','2014-04-29','17:45:00',2.82),('14598','2014-04-29','17:50:00',1.94),('14598','2014-04-29','18:25:00',1.39),('14598','2014-04-29','18:35:00',1.83),('14598','2014-04-29','18:40:00',1.68),('14598','2014-04-29','18:45:00',1.43),('14598','2014-04-29','18:50:00',1.31),('14598','2014-02-25','08:35:00',1.02),('14598','2014-02-25','08:40:00',1.12),('14598','2014-02-25','08:45:00',1.25),('14598','2014-02-25','08:50:00',1.37),('14598','2014-02-25','08:55:00',1.49),('14598','2014-02-25','09:00:00',1.59),('14598','2014-02-25','09:05:00',1.7),('14598','2014-02-25','09:10:00',1.8),('14598','2014-02-25','09:15:00',1.9),('14598','2014-02-25','09:20:00',1.99),('14598','2014-02-25','09:25:00',2.08),('14598','2014-02-25','09:30:00',2.17),('14598','2014-02-25','09:35:00',2.26),('14598','2014-02-25','09:40:00',2.35),('14598','2014-02-25','09:45:00',2.43),('14598','2014-02-25','09:50:00',2.51),('14598','2014-02-25','09:55:00',2.59),('14598','2014-02-25','10:00:00',2.67),('14598','2014-02-25','10:05:00',2.74),('14598','2014-02-25','10:10:00',2.82),('14598','2014-02-25','10:15:00',2.89),('14598','2014-02-25','10:20:00',2.96),('14598','2014-02-25','10:25:00',3.02),('14598','2014-02-25','10:30:00',3.1),('14598','2014-02-25','10:35:00',3.15),('14598','2014-02-25','10:40:00',3.19),('14598','2014-02-25','10:45:00',3.26),('14598','2014-02-25','10:50:00',3.3),('14598','2014-02-25','10:55:00',3.36),('14598','2014-02-25','11:00:00',3.4),('14598','2014-02-25','11:05:00',3.45),('14598','2014-02-25','11:10:00',3.49),('14598','2014-02-25','11:15:00',3.53),('14598','2014-02-25','11:20:00',3.56),('14598','2014-02-25','11:25:00',3.58),('14598','2014-02-25','11:30:00',3.59),('14598','2014-02-25','11:35:00',3.65),('14598','2014-02-25','11:40:00',3.69),('14598','2014-02-25','11:45:00',3.76),('14598','2014-02-25','11:50:00',3.84),('14598','2014-02-25','11:55:00',3.88),('14598','2014-02-25','12:00:00',3.9),('14598','2014-02-25','12:05:00',3.92),('14598','2014-02-25','12:10:00',3.96),('14598','2014-02-25','12:15:00',3.97),('14598','2014-02-25','12:20:00',3.99),('14598','2014-02-25','12:25:00',4.01),('14598','2014-02-25','12:30:00',4.02),('14598','2014-02-25','12:35:00',4.05),('14598','2014-02-25','12:40:00',4.05),('14598','2014-02-25','12:45:00',4.02),('14598','2014-02-25','12:50:00',4.05),('14598','2014-02-25','12:55:00',4.06),('14598','2014-02-25','13:00:00',4.06),('14598','2014-02-25','13:05:00',4.05),('14598','2014-02-25','13:10:00',4.04),('14598','2014-02-25','13:15:00',4.05),('14598','2014-02-25','13:20:00',4.02),('14598','2014-02-25','13:25:00',3.96),('14598','2014-02-25','13:30:00',4.02),('14598','2014-02-25','13:35:00',3.95),('14598','2014-02-25','13:40:00',3.76),('14598','2014-02-25','13:45:00',3.89),('14598','2014-02-25','13:50:00',3.54),('14598','2014-02-25','13:55:00',3.69),('14598','2014-02-25','14:00:00',3.34),('14598','2014-02-25','14:05:00',3.11),('14598','2014-02-25','14:10:00',3.24),('14598','2014-02-25','14:15:00',3.31),('14598','2014-02-25','14:20:00',3.84),('14598','2014-02-25','14:25:00',3.86),('14598','2014-02-25','14:30:00',3.73),('14598','2014-02-25','14:35:00',3.62),('14598','2014-02-25','14:40:00',3.8),('14598','2014-02-25','14:45:00',3.55),('14598','2014-02-25','14:50:00',3.49),('14598','2014-02-25','14:55:00',3.42),('14598','2014-02-25','15:00:00',3.41),('14598','2014-02-25','15:05:00',3.11),('14598','2014-02-25','15:10:00',3.09),('14598','2014-02-25','15:15:00',3.13),('14598','2014-02-25','15:20:00',2.51),('14598','2014-02-25','15:25:00',1.39),('14598','2014-02-25','15:30:00',1.66),('14598','2014-02-25','15:35:00',2.1),('14598','2014-02-25','15:40:00',2.17),('14598','2014-02-25','15:45:00',2.12),('14598','2014-02-25','15:50:00',2.04),('14598','2014-02-25','15:55:00',1.35),('14598','2014-02-25','16:00:00',1.43),('14598','2014-02-25','16:05:00',1.68),('14598','2014-02-25','16:10:00',1.45),('14598','2014-02-25','16:15:00',1.05),('14598','2014-02-24','08:25:00',1.09),('14598','2014-02-24','08:30:00',1.04),('14598','2014-02-24','08:40:00',1.28),('14598','2014-02-24','08:45:00',1.31),('14598','2014-02-24','08:50:00',1.19),('14598','2014-02-24','08:55:00',1.33),('14598','2014-02-24','09:00:00',1),('14598','2014-02-24','09:10:00',1.05),('14598','2014-02-24','09:15:00',1.13),('14598','2014-02-24','09:25:00',2.31),('14598','2014-02-24','09:30:00',1.84),('14598','2014-02-24','09:35:00',1.95),('14598','2014-02-24','09:40:00',2.45),('14598','2014-02-24','09:45:00',2.48),('14598','2014-02-24','09:50:00',2.55),('14598','2014-02-24','09:55:00',2.62),('14598','2014-02-24','10:00:00',2.7),('14598','2014-02-24','10:05:00',2.77),('14598','2014-02-24','10:10:00',2.85),('14598','2014-02-24','10:15:00',2.9),('14598','2014-02-24','10:20:00',3),('14598','2014-02-24','10:25:00',3.05),('14598','2014-02-24','10:30:00',3.11),('14598','2014-02-24','10:35:00',3.17),('14598','2014-02-24','10:40:00',3.23),('14598','2014-02-24','10:45:00',3.29),('14598','2014-02-24','10:50:00',3.36),('14598','2014-02-24','10:55:00',3.43),('14598','2014-02-24','11:00:00',3.48),('14598','2014-02-24','11:05:00',3.53),('14598','2014-02-24','11:10:00',3.57),('14598','2014-02-24','11:15:00',3.62),('14598','2014-02-24','11:20:00',3.67),('14598','2014-02-24','11:25:00',3.7),('14598','2014-02-24','11:30:00',3.72),('14598','2014-02-24','11:35:00',3.81),('14598','2014-02-24','11:40:00',3.82),('14598','2014-02-24','11:45:00',3.88),('14598','2014-02-24','11:50:00',3.9),('14598','2014-02-24','11:55:00',3.92),('14598','2014-02-24','12:00:00',3.91),('14598','2014-02-24','12:05:00',3.94),('14598','2014-02-24','12:10:00',3.95),('14598','2014-02-24','12:15:00',3.96),('14598','2014-02-24','12:20:00',4),('14598','2014-02-24','12:25:00',4),('14598','2014-02-24','12:30:00',4),('14598','2014-02-24','12:35:00',4.01),('14598','2014-02-24','12:40:00',4.01),('14598','2014-02-24','12:45:00',4.01),('14598','2014-02-24','12:50:00',4.02),('14598','2014-02-24','12:55:00',4.01),('14598','2014-02-24','13:00:00',4),('14598','2014-02-24','13:05:00',3.99),('14598','2014-02-24','13:10:00',3.99),('14598','2014-02-24','13:15:00',3.97),('14598','2014-02-24','13:20:00',3.92),('14598','2014-02-24','13:25:00',3.96),('14598','2014-02-24','13:30:00',3.98),('14598','2014-02-24','13:35:00',4.02),('14598','2014-02-24','13:40:00',4.17),('14598','2014-02-24','13:45:00',4.15),('14598','2014-02-24','13:50:00',4.41),('14598','2014-02-24','13:55:00',4.11),('14598','2014-02-24','14:00:00',4.65),('14598','2014-02-24','14:05:00',4.79),('14598','2014-02-24','14:10:00',3.62),('14598','2014-02-24','14:15:00',3.73),('14598','2014-02-24','14:20:00',2.99),('14598','2014-02-24','14:25:00',3.88),('14598','2014-02-24','14:30:00',4.48),('14598','2014-02-24','14:35:00',2.05),('14598','2014-02-24','14:45:00',2.37),('14598','2014-02-24','14:50:00',1.68),('14598','2014-02-24','14:55:00',2.12),('14598','2014-02-24','15:00:00',3.23),('14598','2014-02-24','15:05:00',3.09),('14598','2014-02-24','15:10:00',3.08),('14598','2014-02-24','15:15:00',2.98),('14598','2014-02-24','15:20:00',2.91),('14598','2014-02-24','15:25:00',2.89),('14598','2014-02-24','15:30:00',2.84),('14598','2014-02-24','15:35:00',2.75),('14598','2014-02-24','15:40:00',2.68),('14598','2014-02-24','15:45:00',2.65),('14598','2014-02-24','15:50:00',2.54),('14598','2014-02-24','15:55:00',2.45),('14598','2014-02-24','16:00:00',2.31),('14598','2014-02-24','16:05:00',2.16),('14598','2014-02-24','16:10:00',2.06),('14598','2014-02-24','16:15:00',1.96),('14598','2014-02-24','16:20:00',1.85),('14598','2014-02-24','16:25:00',1.77),('14598','2014-02-24','16:30:00',1.67),('14598','2014-02-24','16:35:00',1.56),('14598','2014-02-24','16:40:00',1.44),('14598','2014-02-24','16:45:00',1.31),('14598','2014-02-24','16:50:00',1.19),('14598','2014-02-24','16:55:00',1.09),('14598','2014-02-23','08:40:00',1.08),('14598','2014-02-23','08:45:00',1.24),('14598','2014-02-23','08:50:00',1.43),('14598','2014-02-23','08:55:00',1.62),('14598','2014-02-23','09:00:00',1.76),('14598','2014-02-23','09:05:00',1.7),('14598','2014-02-23','09:10:00',1.38),('14598','2014-02-23','09:15:00',1.56),('14598','2014-02-23','09:20:00',1.52),('14598','2014-02-23','09:25:00',2.08),('14598','2014-02-23','09:30:00',2.09),('14598','2014-02-23','09:35:00',2.25),('14598','2014-02-23','09:40:00',2.34),('14598','2014-02-23','09:45:00',2.43),('14598','2014-02-23','09:50:00',2.52),('14598','2014-02-23','09:55:00',2.61),('14598','2014-02-23','10:00:00',2.69),('14598','2014-02-23','10:05:00',2.75),('14598','2014-02-23','10:10:00',2.85),('14598','2014-02-23','10:15:00',2.6),('14598','2014-02-23','10:20:00',2.88),('14598','2014-02-23','10:25:00',2.97),('14598','2014-02-23','10:30:00',3.04),('14598','2014-02-23','10:35:00',3.19),('14598','2014-02-23','10:40:00',3.25),('14598','2014-02-23','10:45:00',3.32),('14598','2014-02-23','10:50:00',3.4),('14598','2014-02-23','10:55:00',3.53),('14598','2014-02-23','11:00:00',3.38),('14598','2014-02-23','11:05:00',3.14),('14598','2014-02-23','11:10:00',2.98),('14598','2014-02-23','11:15:00',3.16),('14598','2014-02-23','11:20:00',2.95),('14598','2014-02-23','11:25:00',3.16),('14598','2014-02-23','11:30:00',3.88),('14598','2014-02-23','11:35:00',3.97),('14598','2014-02-23','11:40:00',3.87),('14598','2014-02-23','11:45:00',3.15),('14598','2014-02-23','11:50:00',2.22),('14598','2014-02-23','11:55:00',3.37),('14598','2014-02-23','12:00:00',3.99),('14598','2014-02-23','12:05:00',3.23),('14598','2014-02-23','12:10:00',2.89),('14598','2014-02-23','12:15:00',2.78),('14598','2014-02-23','12:20:00',3.43),('14598','2014-02-23','12:25:00',3.27),('14598','2014-02-23','12:30:00',4.22),('14598','2014-02-23','12:35:00',4.18),('14598','2014-02-23','12:40:00',4.16),('14598','2014-02-23','12:45:00',4.19),('14598','2014-02-23','12:50:00',4.22),('14598','2014-02-23','12:55:00',4.39),('14598','2014-02-23','13:00:00',4.41),('14598','2014-02-23','13:05:00',4.54),('14598','2014-02-23','13:10:00',3.43),('14598','2014-02-23','13:15:00',3.89),('14598','2014-02-23','13:20:00',3.74),('14598','2014-02-23','13:25:00',1.74),('14598','2014-02-23','13:30:00',2.73),('14598','2014-02-23','13:35:00',2.75),('14598','2014-02-23','13:40:00',3.62),('14598','2014-02-23','13:45:00',3.59),('14598','2014-02-23','13:50:00',2.81),('14598','2014-02-23','13:55:00',2.08),('14598','2014-02-23','14:00:00',2.14),('14598','2014-02-23','14:05:00',1.67),('14598','2014-02-23','14:10:00',1.56),('14598','2014-02-23','14:15:00',1.97),('14598','2014-02-23','14:20:00',2.98),('14598','2014-02-23','14:25:00',3.41),('14598','2014-02-23','14:30:00',3.56),('14598','2014-02-23','14:35:00',2.92),('14598','2014-02-23','14:40:00',3.64),('14598','2014-02-23','14:45:00',3.58),('14598','2014-02-23','14:50:00',3.1),('14598','2014-02-23','14:55:00',2),('14598','2014-02-23','15:00:00',3.02),('14598','2014-02-23','15:05:00',3.24),('14598','2014-02-23','15:10:00',3.1),('14598','2014-02-23','15:15:00',3),('14598','2014-02-23','15:20:00',2.78),('14598','2014-02-23','15:25:00',2.54),('14598','2014-02-23','15:30:00',2.7),('14598','2014-02-23','15:35:00',1.78),('14598','2014-02-23','15:40:00',2.13),('14598','2014-02-23','15:45:00',2.7),('14598','2014-02-23','15:50:00',2.68),('14598','2014-02-23','15:55:00',2.53),('14598','2014-02-23','16:00:00',2.54),('14598','2014-02-23','16:05:00',2.4),('14598','2014-02-23','16:10:00',2.13),('14598','2014-02-23','16:15:00',1.66),('14598','2014-02-23','16:20:00',1.36),('14598','2014-02-23','16:25:00',1.16),('14598','2014-02-23','16:30:00',1.29),('14598','2014-02-23','16:35:00',1.41),('14598','2014-02-23','16:40:00',1.5),('14598','2014-02-23','16:45:00',1.32),('14598','2014-02-23','16:50:00',1.39),('14598','2014-02-23','16:55:00',1.37),('14598','2014-02-23','17:00:00',1.36),('14598','2014-02-23','17:05:00',1.35),('14598','2014-02-23','17:10:00',1.42),('14598','2014-02-23','17:15:00',1.36),('14598','2014-02-23','17:20:00',1.06),('14598','2014-02-22','09:00:00',1.55),('14598','2014-02-22','09:05:00',1.23),('14598','2014-02-22','09:10:00',1.12),('14598','2014-02-22','09:25:00',1.25),('14598','2014-02-22','09:30:00',1.47),('14598','2014-02-22','09:35:00',1.74),('14598','2014-02-22','09:40:00',1.65),('14598','2014-02-22','09:45:00',1.8),('14598','2014-02-22','09:50:00',1.22),('14598','2014-02-22','09:55:00',1.17),('14598','2014-02-22','10:00:00',1.9),('14598','2014-02-22','10:05:00',1.03),('14598','2014-02-22','10:10:00',1.42),('14598','2014-02-22','10:15:00',1.48),('14598','2014-02-22','10:20:00',1.47),('14598','2014-02-22','10:25:00',1.21),('14598','2014-02-22','11:05:00',1.02),('14598','2014-02-22','11:10:00',1.01),('14598','2014-02-22','11:15:00',1.21),('14598','2014-02-22','11:20:00',1.2),('14598','2014-02-22','11:25:00',1.2),('14598','2014-02-22','11:30:00',1.45),('14598','2014-02-22','11:35:00',1.49),('14598','2014-02-22','11:40:00',2.25),('14598','2014-02-22','11:45:00',1.6),('14598','2014-02-22','11:50:00',1.46),('14598','2014-02-22','11:55:00',1.46),('14598','2014-02-22','12:00:00',3.71),('14598','2014-02-22','12:05:00',3.6),('14598','2014-02-22','12:10:00',3.49),('14598','2014-02-22','12:15:00',4.15),('14598','2014-02-22','12:20:00',4.31),('14598','2014-02-22','12:25:00',3.36),('14598','2014-02-22','12:30:00',1.9),('14598','2014-02-22','12:35:00',4.36),('14598','2014-02-22','12:40:00',4.19),('14598','2014-02-22','12:45:00',4.4),('14598','2014-02-22','12:50:00',3.14),('14598','2014-02-22','12:55:00',2.12),('14598','2014-02-22','13:00:00',4.25),('14598','2014-02-22','13:05:00',3.59),('14598','2014-02-22','13:10:00',2.09),('14598','2014-02-22','13:15:00',4.06),('14598','2014-02-22','13:20:00',4.4),('14598','2014-02-22','13:25:00',3.83),('14598','2014-02-22','13:30:00',4.12),('14598','2014-02-22','13:35:00',4.23),('14598','2014-02-22','13:40:00',3.11),('14598','2014-02-22','13:45:00',3.54),('14598','2014-02-22','13:50:00',2.41),('14598','2014-02-22','13:55:00',3.08),('14598','2014-02-22','14:00:00',3.1),('14598','2014-02-22','14:05:00',1.87),('14598','2014-02-22','14:10:00',4.24),('14598','2014-02-22','14:15:00',3.52),('14598','2014-02-22','14:20:00',4.08),('14598','2014-02-22','14:25:00',3.72),('14598','2014-02-22','14:30:00',3.74),('14598','2014-02-22','14:35:00',3.11),('14598','2014-02-22','14:40:00',2.94),('14598','2014-02-22','14:45:00',3.06),('14598','2014-02-22','14:50:00',3.66),('14598','2014-02-22','14:55:00',3.48),('14598','2014-02-22','15:00:00',3.17),('14598','2014-02-22','15:05:00',3.57),('14598','2014-02-22','15:10:00',2.82),('14598','2014-02-22','15:15:00',3.1),('14598','2014-02-22','15:20:00',2.89),('14598','2014-02-22','15:25:00',2.92),('14598','2014-02-22','15:30:00',2.99),('14598','2014-02-22','15:35:00',2.76),('14598','2014-02-22','15:40:00',2.51),('14598','2014-02-22','15:45:00',2.78),('14598','2014-02-22','15:50:00',2.58),('14598','2014-02-22','15:55:00',2.28),('14598','2014-02-22','16:00:00',2.29),('14598','2014-02-22','16:05:00',1.57),('14598','2014-02-22','16:10:00',1.66),('14598','2014-02-22','16:40:00',1.5),('14598','2014-02-22','16:45:00',1.44),('14598','2014-02-22','16:50:00',1.23),('14598','2014-02-21','09:25:00',1.3),('14598','2014-02-21','09:30:00',1.98),('14598','2014-02-21','09:35:00',2.09),('14598','2014-02-21','09:40:00',1.39),('14598','2014-02-21','09:45:00',1.68),('14598','2014-02-21','09:50:00',2.13),('14598','2014-02-21','09:55:00',2.47),('14598','2014-02-21','10:00:00',2.84),('14598','2014-02-21','10:05:00',2.04),('14598','2014-02-21','10:10:00',2.69),('14598','2014-02-21','10:15:00',2.38),('14598','2014-02-21','10:20:00',2.46),('14598','2014-02-21','10:25:00',2.98),('14598','2014-02-21','10:30:00',3.48),('14598','2014-02-21','10:35:00',3.31),('14598','2014-02-21','10:40:00',3.69),('14598','2014-02-21','10:45:00',3.07),('14598','2014-02-21','10:50:00',1.39),('14598','2014-02-21','10:55:00',1.33),('14598','2014-02-21','11:00:00',1.08),('14598','2014-02-21','11:15:00',1.13),('14598','2014-02-21','11:20:00',1.58),('14598','2014-02-21','11:25:00',2.29),('14598','2014-02-21','11:30:00',3.72),('14598','2014-02-21','11:35:00',3.86),('14598','2014-02-21','11:40:00',4.69),('14598','2014-02-21','11:45:00',3.21),('14598','2014-02-21','11:50:00',2.22),('14598','2014-02-21','11:55:00',2.1),('14598','2014-02-21','12:00:00',2.14),('14598','2014-02-21','12:05:00',2.73),('14598','2014-02-21','12:10:00',2.28),('14598','2014-02-21','12:15:00',2.28),('14598','2014-02-21','12:20:00',1.81),('14598','2014-02-21','12:25:00',1.37),('14598','2014-02-21','12:30:00',1.25),('14598','2014-02-21','12:35:00',1.17),('14598','2014-02-21','12:40:00',1.25),('14598','2014-02-21','12:45:00',1.34),('14598','2014-02-21','12:50:00',1.27),('14598','2014-02-21','12:55:00',1.44),('14598','2014-02-21','13:00:00',1.8),('14598','2014-02-21','13:05:00',3.01),('14598','2014-02-21','13:10:00',3.39),('14598','2014-02-21','13:15:00',2.14),('14598','2014-02-21','13:20:00',1.8),('14598','2014-02-21','13:25:00',1.51),('14598','2014-02-21','13:30:00',1.5),('14598','2014-02-21','13:35:00',1.89),('14598','2014-02-21','13:40:00',1.96),('14598','2014-02-21','13:45:00',1.95),('14598','2014-02-21','13:50:00',2.19),('14598','2014-02-21','13:55:00',2.24),('14598','2014-02-21','14:00:00',1.96),('14598','2014-02-21','14:05:00',3.02),('14598','2014-02-21','14:10:00',3.32),('14598','2014-02-21','14:15:00',4.03),('14598','2014-02-21','14:20:00',3.42),('14598','2014-02-21','14:25:00',3.15),('14598','2014-02-21','14:30:00',3.42),('14598','2014-02-21','14:35:00',3.35),('14598','2014-02-21','14:40:00',3.28),('14598','2014-02-21','14:45:00',3.26),('14598','2014-02-21','14:50:00',3.2),('14598','2014-02-21','14:55:00',3.13),('14598','2014-02-21','15:00:00',3.06),('14598','2014-02-21','15:05:00',3),('14598','2014-02-21','15:10:00',2.93),('14598','2014-02-21','15:15:00',2.85),('14598','2014-02-21','15:20:00',2.78),('14598','2014-02-21','15:25:00',2.71),('14598','2014-02-21','15:30:00',2.63),('14598','2014-02-21','15:35:00',2.54),('14598','2014-02-21','15:40:00',2.46),('14598','2014-02-21','15:45:00',2.38),('14598','2014-02-21','15:50:00',2.27),('14598','2014-02-21','15:55:00',2.2),('14598','2014-02-21','16:00:00',2.08),('14598','2014-02-21','16:05:00',1.97),('14598','2014-02-21','16:10:00',1.86),('14598','2014-02-21','16:15:00',1.76),('14598','2014-02-21','16:20:00',1.65),('14598','2014-02-21','16:25:00',1.54),('14598','2014-02-21','16:30:00',1.43),('14598','2014-02-21','16:35:00',1.33),('14598','2014-02-21','16:40:00',1.24),('14598','2014-02-21','16:45:00',1.15),('14598','2014-02-21','16:50:00',1.05),('14598','2014-02-20','09:35:00',1.03),('14598','2014-02-20','09:40:00',1.2),('14598','2014-02-20','09:45:00',1.18),('14598','2014-02-20','09:50:00',1.12),('14598','2014-02-20','09:55:00',1.07),('14598','2014-02-20','10:00:00',1.13),('14598','2014-02-20','10:05:00',1.04),('14598','2014-02-20','10:10:00',1.07),('14598','2014-02-20','10:15:00',1.15),('14598','2014-02-20','10:20:00',1.19),('14598','2014-02-20','10:25:00',1.37),('14598','2014-02-20','10:30:00',1.41),('14598','2014-02-20','10:35:00',1.47),('14598','2014-02-20','10:40:00',1.49),('14598','2014-02-20','10:45:00',1.55),('14598','2014-02-20','10:50:00',1.73),('14598','2014-02-20','10:55:00',1.93),('14598','2014-02-20','11:00:00',1.99),('14598','2014-02-20','11:05:00',1.67),('14598','2014-02-20','11:10:00',1.69),('14598','2014-02-20','11:15:00',1.85),('14598','2014-02-20','11:20:00',1.65),('14598','2014-02-20','11:25:00',1.74),('14598','2014-02-20','11:30:00',1.58),('14598','2014-02-20','11:35:00',1.72),('14598','2014-02-20','11:40:00',1.57),('14598','2014-02-20','11:45:00',1.37),('14598','2014-02-20','11:50:00',1.39),('14598','2014-02-20','11:55:00',1.61),('14598','2014-02-20','12:00:00',1.75),('14598','2014-02-20','12:05:00',1.74),('14598','2014-02-20','12:10:00',2),('14598','2014-02-20','12:15:00',1.94),('14598','2014-02-20','12:20:00',1.56),('14598','2014-02-20','12:25:00',1.69),('14598','2014-02-20','12:30:00',1.64),('14598','2014-02-20','12:35:00',1.58),('14598','2014-02-20','12:40:00',1.86),('14598','2014-02-20','12:45:00',1.87),('14598','2014-02-20','12:50:00',1.69),('14598','2014-02-20','12:55:00',1.97),('14598','2014-02-20','13:00:00',1.62),('14598','2014-02-20','13:05:00',1.82),('14598','2014-02-20','13:10:00',1.58),('14598','2014-02-20','13:15:00',1.83),('14598','2014-02-20','13:20:00',1.73),('14598','2014-02-20','13:25:00',1.49),('14598','2014-02-20','13:30:00',1.51),('14598','2014-02-20','13:35:00',1.48),('14598','2014-02-20','13:40:00',1.43),('14598','2014-02-20','13:45:00',1.44),('14598','2014-02-20','13:50:00',1.27),('14598','2014-02-20','13:55:00',1.36),('14598','2014-02-20','14:00:00',1.61),('14598','2014-02-20','14:05:00',1.41),('14598','2014-02-20','14:10:00',1.05),('14598','2014-02-20','14:15:00',1.03),('14598','2014-02-20','14:20:00',1.08),('14598','2014-02-20','14:25:00',1.01),('14598','2014-02-19','09:35:00',1.06),('14598','2014-02-19','09:40:00',1.16),('14598','2014-02-19','09:45:00',1.22),('14598','2014-02-19','09:50:00',1.28),('14598','2014-02-19','09:55:00',1.42),('14598','2014-02-19','10:00:00',1.41),('14598','2014-02-19','10:05:00',1.37),('14598','2014-02-19','10:10:00',1.34),('14598','2014-02-19','10:15:00',1.27),('14598','2014-02-19','10:20:00',1.19),('14598','2014-02-19','10:25:00',1.14),('14598','2014-02-19','10:30:00',1.22),('14598','2014-02-19','10:35:00',1.34),('14598','2014-02-19','10:40:00',1.35),('14598','2014-02-19','10:45:00',1.37),('14598','2014-02-19','10:50:00',1.51),('14598','2014-02-19','10:55:00',1.33),('14598','2014-02-19','11:00:00',1.44),('14598','2014-02-19','11:05:00',1.28),('14598','2014-02-19','11:10:00',1.05),('14598','2014-02-19','11:15:00',1.29),('14598','2014-02-19','11:20:00',1.3),('14598','2014-02-19','11:25:00',1.3),('14598','2014-02-19','11:40:00',1.73),('14598','2014-02-19','11:45:00',2.04),('14598','2014-02-19','11:50:00',2.14),('14598','2014-02-19','11:55:00',2.5),('14598','2014-02-19','12:00:00',2.32),('14598','2014-02-19','12:05:00',2.79),('14598','2014-02-19','12:10:00',2.65),('14598','2014-02-19','12:15:00',2.67),('14598','2014-02-19','12:20:00',2.4),('14598','2014-02-19','12:25:00',2.81),('14598','2014-02-19','12:30:00',2.73),('14598','2014-02-19','12:35:00',2.51),('14598','2014-02-19','12:40:00',1.94),('14598','2014-02-19','12:45:00',1.84),('14598','2014-02-19','12:50:00',2.5),('14598','2014-02-19','12:55:00',2.18),('14598','2014-02-19','13:00:00',2.12),('14598','2014-02-19','13:05:00',2.5),('14598','2014-02-19','13:10:00',2.41),('14598','2014-02-19','13:15:00',2.04),('14598','2014-02-19','13:20:00',1.78),('14598','2014-02-19','13:25:00',1.72),('14598','2014-02-19','13:30:00',1.81),('14598','2014-02-19','13:35:00',1.66),('14598','2014-02-19','13:40:00',1.65),('14598','2014-02-19','13:45:00',1.74),('14598','2014-02-19','13:50:00',1.46),('14598','2014-02-19','13:55:00',1.35),('14598','2014-02-19','14:00:00',1.44),('14598','2014-02-19','14:05:00',1.48),('14598','2014-02-19','14:10:00',1.6),('14598','2014-02-19','14:15:00',1.26),('14598','2014-02-19','14:20:00',1.41),('14598','2014-02-19','14:25:00',1.63),('14598','2014-02-19','14:30:00',1.75),('14598','2014-02-19','14:35:00',1.49),('14598','2014-02-19','14:40:00',1.42),('14598','2014-02-19','14:45:00',1.15),('14598','2014-02-19','14:50:00',1.57),('14598','2014-02-19','14:55:00',2.07),('14598','2014-02-19','15:00:00',1.23),('14598','2014-02-19','15:05:00',1.32),('14598','2014-02-19','15:15:00',1.31),('14598','2014-02-19','15:20:00',1.17),('14598','2014-02-19','15:25:00',1.18),('14598','2014-02-19','15:35:00',1.04),('14598','2014-02-19','15:40:00',1.02),('14598','2014-02-19','15:55:00',1.06),('14598','2014-02-18','08:45:00',1.03),('14598','2014-02-18','08:50:00',1.14),('14598','2014-02-18','08:55:00',1.26),('14598','2014-02-18','09:00:00',1.36),('14598','2014-02-18','09:05:00',1.45),('14598','2014-02-18','09:10:00',1.55),('14598','2014-02-18','09:15:00',1.64),('14598','2014-02-18','09:20:00',1.74),('14598','2014-02-18','09:25:00',1.83),('14598','2014-02-18','09:30:00',1.89),('14598','2014-02-18','09:35:00',2.01),('14598','2014-02-18','09:40:00',2.09),('14598','2014-02-18','09:45:00',2.19),('14598','2014-02-18','09:50:00',2.24),('14598','2014-02-18','09:55:00',2.42),('14598','2014-02-18','10:00:00',2.49),('14598','2014-02-18','10:05:00',2.57),('14598','2014-02-18','10:10:00',2.57),('14598','2014-02-18','10:15:00',2.68),('14598','2014-02-18','10:20:00',2.76),('14598','2014-02-18','10:25:00',2.82),('14598','2014-02-18','10:30:00',2.88),('14598','2014-02-18','10:35:00',2.95),('14598','2014-02-18','10:40:00',2.93),('14598','2014-02-18','10:45:00',3.05),('14598','2014-02-18','10:50:00',3.13),('14598','2014-02-18','10:55:00',3.16),('14598','2014-02-18','11:00:00',3.2),('14598','2014-02-18','11:05:00',3.3),('14598','2014-02-18','11:10:00',3.15),('14598','2014-02-18','11:15:00',3.36),('14598','2014-02-18','11:20:00',2.96),('14598','2014-02-18','11:25:00',2.23),('14598','2014-02-18','11:30:00',1.7),('14598','2014-02-18','11:35:00',1.42),('14598','2014-02-18','11:40:00',1.31),('14598','2014-02-18','11:45:00',1.31),('14598','2014-02-18','11:50:00',1.43),('14598','2014-02-18','11:55:00',1.52),('14598','2014-02-18','12:00:00',1.54),('14598','2014-02-18','12:05:00',1.61),('14598','2014-02-18','12:10:00',1.75),('14598','2014-02-18','12:15:00',2.14),('14598','2014-02-18','12:20:00',2.78),('14598','2014-02-18','12:25:00',2.23),('14598','2014-02-18','12:30:00',1.84),('14598','2014-02-18','12:35:00',1.79),('14598','2014-02-18','12:40:00',1.69),('14598','2014-02-18','12:45:00',1.57),('14598','2014-02-18','12:50:00',1.67),('14598','2014-02-18','12:55:00',1.64),('14598','2014-02-18','13:00:00',1.58),('14598','2014-02-18','13:05:00',1.63),('14598','2014-02-18','13:10:00',1.8),('14598','2014-02-18','13:15:00',2.5),('14598','2014-02-18','13:20:00',3.22),('14598','2014-02-18','13:25:00',2.73),('14598','2014-02-18','13:30:00',2.4),('14598','2014-02-18','13:35:00',2.92),('14598','2014-02-18','13:40:00',2.7),('14598','2014-02-18','13:45:00',2.33),('14598','2014-02-18','13:50:00',1.91),('14598','2014-02-18','13:55:00',1.64),('14598','2014-02-18','14:00:00',2.26),('14598','2014-02-18','14:05:00',2.27),('14598','2014-02-18','14:10:00',1.59),('14598','2014-02-18','14:15:00',1.41),('14598','2014-02-18','14:20:00',1.37),('14598','2014-02-18','14:25:00',1.4),('14598','2014-02-18','14:30:00',1.35),('14598','2014-02-18','14:35:00',1.3),('14598','2014-02-18','14:40:00',1.25),('14598','2014-02-18','14:45:00',1.22),('14598','2014-02-18','14:50:00',1.13),('14598','2014-02-18','14:55:00',1.02),('14598','2014-02-18','15:15:00',1.04),('14598','2014-02-18','15:20:00',1.15),('14598','2014-02-18','15:25:00',1.54),('14598','2014-02-18','15:30:00',1.46),('14598','2014-02-18','15:35:00',1.32),('14598','2014-02-18','15:40:00',1.14),('14598','2014-02-18','15:45:00',1.07),('14598','2014-02-18','15:50:00',1.3),('14598','2014-02-18','15:55:00',1.42),('14598','2014-02-18','16:00:00',1.55),('14598','2014-02-18','16:05:00',1.5),('14598','2014-02-18','16:10:00',1.07),('14598','2014-02-17','08:50:00',1.05),('14598','2014-02-17','08:55:00',1.16),('14598','2014-02-17','09:00:00',1.27),('14598','2014-02-17','09:05:00',1.37),('14598','2014-02-17','09:10:00',1.46),('14598','2014-02-17','09:15:00',1.54),('14598','2014-02-17','09:20:00',1.64),('14598','2014-02-17','09:25:00',1.75),('14598','2014-02-17','09:30:00',1.84),('14598','2014-02-17','09:35:00',1.91),('14598','2014-02-17','09:40:00',1.99),('14598','2014-02-17','09:45:00',2.05),('14598','2014-02-17','09:50:00',2.12),('14598','2014-02-17','09:55:00',2.18),('14598','2014-02-17','10:00:00',2.25),('14598','2014-02-17','10:05:00',2.31),('14598','2014-02-17','10:10:00',2.39),('14598','2014-02-17','10:15:00',2.44),('14598','2014-02-17','10:20:00',2.5),('14598','2014-02-17','10:25:00',2.55),('14598','2014-02-17','10:30:00',2.6),('14598','2014-02-17','10:35:00',2.68),('14598','2014-02-17','10:40:00',2.71),('14598','2014-02-17','10:45:00',2.76),('14598','2014-02-17','10:50:00',2.81),('14598','2014-02-17','10:55:00',2.86),('14598','2014-02-17','11:00:00',2.91),('14598','2014-02-17','11:05:00',2.95),('14598','2014-02-17','11:10:00',3),('14598','2014-02-17','11:15:00',3.04),('14598','2014-02-17','11:20:00',3.09),('14598','2014-02-17','11:25:00',3.14),('14598','2014-02-17','11:30:00',3.22),('14598','2014-02-17','11:35:00',3.26),('14598','2014-02-17','11:40:00',3.29),('14598','2014-02-17','11:45:00',3.3),('14598','2014-02-17','11:50:00',3.38),('14598','2014-02-17','11:55:00',3.44),('14598','2014-02-17','12:00:00',3.46),('14598','2014-02-17','12:05:00',3.48),('14598','2014-02-17','12:10:00',3.48),('14598','2014-02-17','12:15:00',3.48),('14598','2014-02-17','12:20:00',3.5),('14598','2014-02-17','12:25:00',3.52),('14598','2014-02-17','12:30:00',3.53),('14598','2014-02-17','12:35:00',3.54),('14598','2014-02-17','12:40:00',3.55),('14598','2014-02-17','12:45:00',3.55),('14598','2014-02-17','12:50:00',3.54),('14598','2014-02-17','12:55:00',3.53),('14598','2014-02-17','13:00:00',3.53),('14598','2014-02-17','13:05:00',3.53),('14598','2014-02-17','13:10:00',3.53),('14598','2014-02-17','13:15:00',3.54),('14598','2014-02-17','13:20:00',3.51),('14598','2014-02-17','13:25:00',3.49),('14598','2014-02-17','13:30:00',3.39),('14598','2014-02-17','13:35:00',3.48),('14598','2014-02-17','13:40:00',3.43),('14598','2014-02-17','13:45:00',3.38),('14598','2014-02-17','13:50:00',3.32),('14598','2014-02-17','13:55:00',3.32),('14598','2014-02-17','14:00:00',3.31),('14598','2014-02-17','14:05:00',3.17),('14598','2014-02-17','14:10:00',3.28),('14598','2014-02-17','14:15:00',3.21),('14598','2014-02-17','14:20:00',3.15),('14598','2014-02-17','14:25:00',2.98),('14598','2014-02-17','14:30:00',2.96),('14598','2014-02-17','14:35:00',2.85),('14598','2014-02-17','14:40:00',2.85),('14598','2014-02-17','14:45:00',2.76),('14598','2014-02-17','14:50:00',2.78),('14598','2014-02-17','14:55:00',2.72),('14598','2014-02-17','15:00:00',2.58),('14598','2014-02-17','15:05:00',2.64),('14598','2014-02-17','15:10:00',2.62),('14598','2014-02-17','15:15:00',2.44),('14598','2014-02-17','15:20:00',2.46),('14598','2014-02-17','15:25:00',2.37),('14598','2014-02-17','15:30:00',2.3),('14598','2014-02-17','15:35:00',2.21),('14598','2014-02-17','15:40:00',2.14),('14598','2014-02-17','15:45:00',2.05),('14598','2014-02-17','15:50:00',1.96),('14598','2014-02-17','15:55:00',1.83),('14598','2014-02-17','16:00:00',1.77),('14598','2014-02-17','16:05:00',1.67),('14598','2014-02-17','16:10:00',1.54),('14598','2014-02-17','16:15:00',1.46),('14598','2014-02-17','16:20:00',1.35),('14598','2014-02-17','16:25:00',1.19),('14598','2014-02-17','16:30:00',1.1),('14598','2014-02-17','16:35:00',1.01),('14598','2014-02-16','08:45:00',1.04),('14598','2014-02-16','08:50:00',1.15),('14598','2014-02-16','08:55:00',1.28),('14598','2014-02-16','09:00:00',1.17),('14598','2014-02-16','09:05:00',1.34),('14598','2014-02-16','09:10:00',1.47),('14598','2014-02-16','09:15:00',1.51),('14598','2014-02-16','09:20:00',1.4),('14598','2014-02-16','09:25:00',1.69),('14598','2014-02-16','09:30:00',1.88),('14598','2014-02-16','09:35:00',1.96),('14598','2014-02-16','09:40:00',1.98),('14598','2014-02-16','09:45:00',1.97),('14598','2014-02-16','09:50:00',2.23),('14598','2014-02-16','09:55:00',2.41),('14598','2014-02-16','10:00:00',2.43),('14598','2014-02-16','10:05:00',2.42),('14598','2014-02-16','10:10:00',2.63),('14598','2014-02-16','10:15:00',2.82),('14598','2014-02-16','10:20:00',2.86),('14598','2014-02-16','10:25:00',2.85),('14598','2014-02-16','10:30:00',2.97),('14598','2014-02-16','10:35:00',2.66),('14598','2014-02-16','10:40:00',2.77),('14598','2014-02-16','10:45:00',3.04),('14598','2014-02-16','10:50:00',3),('14598','2014-02-16','10:55:00',3.03),('14598','2014-02-16','11:00:00',3.08),('14598','2014-02-16','11:05:00',2.76),('14598','2014-02-16','11:10:00',2.76),('14598','2014-02-16','11:15:00',3.03),('14598','2014-02-16','11:20:00',3.38),('14598','2014-02-16','11:25:00',3.11),('14598','2014-02-16','11:30:00',2.95),('14598','2014-02-16','11:35:00',3.11),('14598','2014-02-16','11:40:00',3.41),('14598','2014-02-16','11:45:00',3.53),('14598','2014-02-16','11:50:00',3.48),('14598','2014-02-16','11:55:00',3.57),('14598','2014-02-16','12:00:00',3.6),('14598','2014-02-16','12:05:00',3.61),('14598','2014-02-16','12:10:00',3.6),('14598','2014-02-16','12:15:00',3.59),('14598','2014-02-16','12:20:00',3.6),('14598','2014-02-16','12:25:00',3.62),('14598','2014-02-16','12:30:00',3.62),('14598','2014-02-16','12:35:00',3.62),('14598','2014-02-16','12:40:00',3.63),('14598','2014-02-16','12:45:00',3.62),('14598','2014-02-16','12:50:00',3.69),('14598','2014-02-16','12:55:00',3.59),('14598','2014-02-16','13:00:00',3.69),('14598','2014-02-16','13:05:00',3.74),('14598','2014-02-16','13:10:00',3.71),('14598','2014-02-16','13:15:00',3.68),('14598','2014-02-16','13:20:00',3.69),('14598','2014-02-16','13:25:00',3.66),('14598','2014-02-16','13:30:00',3.74),('14598','2014-02-16','13:35:00',3.53),('14598','2014-02-16','13:40:00',3.63),('14598','2014-02-16','13:45:00',3.64),('14598','2014-02-16','13:50:00',3.63),('14598','2014-02-16','13:55:00',3.6),('14598','2014-02-16','14:00:00',3.52),('14598','2014-02-16','14:05:00',3.5),('14598','2014-02-16','14:10:00',3.48),('14598','2014-02-16','14:15:00',3.48),('14598','2014-02-16','14:20:00',3.38),('14598','2014-02-16','14:25:00',3.2),('14598','2014-02-16','14:30:00',3.34),('14598','2014-02-16','14:35:00',3.32),('14598','2014-02-16','14:40:00',2.7),('14598','2014-02-16','14:45:00',3.03),('14598','2014-02-16','14:50:00',3.15),('14598','2014-02-16','14:55:00',3.04),('14598','2014-02-16','15:00:00',2.97),('14598','2014-02-16','15:05:00',2.9),('14598','2014-02-16','15:10:00',2.82),('14598','2014-02-16','15:15:00',2.77),('14598','2014-02-16','15:20:00',2.69),('14598','2014-02-16','15:25:00',2.24),('14598','2014-02-16','15:30:00',1.96),('14598','2014-02-16','15:35:00',1.88),('14598','2014-02-16','15:40:00',2.04),('14598','2014-02-16','15:50:00',1.6),('14598','2014-02-16','15:55:00',1.02),('14598','2014-02-16','16:00:00',1.28),('14598','2014-02-16','16:05:00',2.33),('14598','2014-02-16','16:10:00',1.94),('14598','2014-02-16','16:15:00',2.04),('14598','2014-02-16','16:20:00',1.91),('14598','2014-02-16','16:25:00',1.34),('14598','2014-02-16','16:30:00',1.32),('14598','2014-04-28','07:40:00',1.1),('14598','2014-04-28','08:20:00',1.88),('14598','2014-04-28','08:25:00',1.54),('14598','2014-04-28','08:30:00',1.71),('14598','2014-04-28','08:35:00',1.43),('14598','2014-04-28','08:40:00',1.79),('14598','2014-04-28','08:45:00',1.71),('14598','2014-04-28','08:50:00',1.55),('14598','2014-04-28','08:55:00',1.72),('14598','2014-04-28','09:00:00',1.67),('14598','2014-04-28','09:05:00',1.75),('14598','2014-04-28','09:10:00',1.54),('14598','2014-04-28','09:15:00',1.27),('14598','2014-04-28','09:20:00',1.32),('14598','2014-04-28','09:25:00',1.4),('14598','2014-04-28','09:30:00',1.49),('14598','2014-04-28','09:35:00',1.55),('14598','2014-04-28','09:40:00',1.18),('14598','2014-04-28','09:45:00',1.63),('14598','2014-04-28','09:50:00',1.48),('14598','2014-04-28','09:55:00',1.46),('14598','2014-04-28','10:00:00',1.97),('14598','2014-04-28','10:05:00',2.85),('14598','2014-04-28','10:10:00',3.58),('14598','2014-04-28','10:15:00',4.2),('14598','2014-04-28','10:20:00',2.1),('14598','2014-04-28','10:25:00',2.25),('14598','2014-04-28','10:30:00',2.92),('14598','2014-04-28','10:35:00',2.79),('14598','2014-04-28','10:40:00',2.35),('14598','2014-04-28','10:45:00',2.28),('14598','2014-04-28','10:50:00',1.65),('14598','2014-04-28','10:55:00',1.32),('14598','2014-04-28','11:00:00',1.32),('14598','2014-04-28','11:05:00',1.4),('14598','2014-04-28','11:10:00',1.42),('14598','2014-04-28','11:15:00',1.68),('14598','2014-04-28','11:20:00',2.33),('14598','2014-04-28','11:25:00',2.89),('14598','2014-04-28','11:30:00',2.53),('14598','2014-04-28','11:35:00',2.58),('14598','2014-04-28','11:40:00',2.62),('14598','2014-04-28','11:45:00',2.53),('14598','2014-04-28','11:50:00',2.44),('14598','2014-04-28','11:55:00',2.36),('14598','2014-04-28','12:00:00',3.11),('14598','2014-04-28','12:05:00',3.64),('14598','2014-04-28','12:10:00',2.53),('14598','2014-04-28','12:15:00',2.85),('14598','2014-04-28','12:20:00',3.59),('14598','2014-04-28','12:25:00',4.11),('14598','2014-04-28','12:30:00',4.34),('14598','2014-04-28','12:35:00',4.32),('14598','2014-04-28','12:40:00',4.98),('14598','2014-04-28','12:45:00',5.61),('14598','2014-04-28','12:50:00',5.45),('14598','2014-04-28','12:55:00',5.69),('14598','2014-04-28','13:00:00',5.39),('14598','2014-04-28','13:05:00',3.94),('14598','2014-04-28','13:10:00',3.56),('14598','2014-04-28','13:15:00',3.24),('14598','2014-04-28','13:20:00',3.97),('14598','2014-04-28','13:25:00',5.73),('14598','2014-04-28','13:30:00',5.71),('14598','2014-04-28','13:35:00',5.35),('14598','2014-04-28','13:40:00',5.1),('14598','2014-04-28','13:45:00',5.24),('14598','2014-04-28','13:50:00',5.25),('14598','2014-04-28','13:55:00',5.28),('14598','2014-04-28','14:00:00',4.98),('14598','2014-04-28','14:05:00',4.22),('14598','2014-04-28','14:10:00',4.94),('14598','2014-04-28','14:15:00',5.29),('14598','2014-04-28','14:20:00',5.04),('14598','2014-04-28','14:25:00',5.17),('14598','2014-04-28','14:30:00',5.15),('14598','2014-04-28','14:35:00',5.14),('14598','2014-04-28','14:40:00',5.21),('14598','2014-04-28','14:45:00',5.08),('14598','2014-04-28','14:50:00',4.99),('14598','2014-04-28','14:55:00',4.68),('14598','2014-04-28','15:00:00',3.74),('14598','2014-04-28','15:05:00',4.93),('14598','2014-04-28','15:10:00',4.79),('14598','2014-04-28','15:15:00',5.07),('14598','2014-04-28','15:20:00',4.76),('14598','2014-04-28','15:25:00',4.94),('14598','2014-04-28','15:30:00',4.68),('14598','2014-04-28','15:35:00',5),('14598','2014-04-28','15:40:00',3),('14598','2014-04-28','15:45:00',2.83),('14598','2014-04-28','15:50:00',2.32),('14598','2014-04-28','15:55:00',1.51),('14598','2014-04-28','16:15:00',1.54),('14598','2014-04-28','16:20:00',1.69),('14598','2014-04-28','16:25:00',3.85),('14598','2014-04-28','16:30:00',3.92),('14598','2014-04-28','16:35:00',2.03),('14598','2014-04-28','16:40:00',3.77),('14598','2014-04-28','16:45:00',3.36),('14598','2014-04-28','16:50:00',1.52),('14598','2014-04-28','16:55:00',1.73),('14598','2014-04-28','17:00:00',3.25),('14598','2014-04-28','17:05:00',1.98),('14598','2014-04-28','17:10:00',1.92),('14598','2014-04-28','17:15:00',2.23),('14598','2014-04-28','17:20:00',2.73),('14598','2014-04-28','17:25:00',1.92),('14598','2014-04-28','17:30:00',1.82),('14598','2014-04-28','17:35:00',1.6),('14598','2014-04-28','17:40:00',1.66),('14598','2014-04-28','17:45:00',1.68),('14598','2014-04-28','17:50:00',1.34),('14598','2014-04-28','17:55:00',1.13),('14598','2014-04-28','18:00:00',1.17),('14598','2014-04-28','18:05:00',1.14),('14598','2014-04-28','18:10:00',1.11),('14598','2014-04-28','18:15:00',1.16),('14598','2014-04-28','18:20:00',1.3),('14598','2014-04-28','18:25:00',1.23),('14598','2014-04-28','18:30:00',1.25),('14598','2014-04-28','18:35:00',1.12),('14598','2014-02-15','08:50:00',1.01),('14598','2014-02-15','08:55:00',1.14),('14598','2014-02-15','09:00:00',1.25),('14598','2014-02-15','09:05:00',1.34),('14598','2014-02-15','09:10:00',1.43),('14598','2014-02-15','09:15:00',1.47),('14598','2014-02-15','09:20:00',1.62),('14598','2014-02-15','09:25:00',1.71),('14598','2014-02-15','09:30:00',1.79),('14598','2014-02-15','09:35:00',1.88),('14598','2014-02-15','09:40:00',1.95),('14598','2014-02-15','09:45:00',2),('14598','2014-02-15','09:50:00',2.11),('14598','2014-02-15','09:55:00',2.19),('14598','2014-02-15','10:00:00',2.25),('14598','2014-02-15','10:05:00',2.32),('14598','2014-02-15','10:10:00',2.34),('14598','2014-02-15','10:15:00',2.47),('14598','2014-02-15','10:20:00',2.53),('14598','2014-02-15','10:25:00',2.61),('14598','2014-02-15','10:30:00',2.69),('14598','2014-02-15','10:35:00',2.73),('14598','2014-02-15','10:40:00',2.8),('14598','2014-02-15','10:45:00',2.86),('14598','2014-02-15','10:50:00',2.94),('14598','2014-02-15','10:55:00',2.94),('14598','2014-02-15','11:00:00',2.92),('14598','2014-02-15','11:05:00',2.63),('14598','2014-02-15','11:10:00',2.52),('14598','2014-02-15','11:15:00',2.46),('14598','2014-02-15','11:20:00',3.06),('14598','2014-02-15','11:25:00',3.22),('14598','2014-02-15','11:30:00',3.43),('14598','2014-02-15','11:35:00',3.44),('14598','2014-02-15','11:40:00',3.45),('14598','2014-02-15','11:45:00',3.47),('14598','2014-02-15','11:50:00',3.53),('14598','2014-02-15','11:55:00',3.56),('14598','2014-02-15','12:00:00',3.56),('14598','2014-02-15','12:05:00',3.6),('14598','2014-02-15','12:10:00',3.64),('14598','2014-02-15','12:15:00',3.66),('14598','2014-02-15','12:20:00',3.67),('14598','2014-02-15','12:25:00',3.7),('14598','2014-02-15','12:30:00',3.71),('14598','2014-02-15','12:35:00',3.72),('14598','2014-02-15','12:40:00',3.72),('14598','2014-02-15','12:45:00',3.72),('14598','2014-02-15','12:50:00',3.73),('14598','2014-02-15','12:55:00',3.73),('14598','2014-02-15','13:00:00',3.73),('14598','2014-02-15','13:05:00',3.73),('14598','2014-02-15','13:10:00',3.73),('14598','2014-02-15','13:15:00',3.72),('14598','2014-02-15','13:20:00',3.7),('14598','2014-02-15','13:25:00',3.68),('14598','2014-02-15','13:30:00',3.67),('14598','2014-02-15','13:35:00',3.65),('14598','2014-02-15','13:40:00',3.62),('14598','2014-02-15','13:45:00',3.6),('14598','2014-02-15','13:50:00',3.58),('14598','2014-02-15','13:55:00',3.55),('14598','2014-02-15','14:00:00',3.48),('14598','2014-02-15','14:05:00',3.47),('14598','2014-02-15','14:10:00',3.43),('14598','2014-02-15','14:15:00',3.41),('14598','2014-02-15','14:20:00',3.37),('14598','2014-02-15','14:25:00',3.33),('14598','2014-02-15','14:30:00',3.27),('14598','2014-02-15','14:35:00',3.21),('14598','2014-02-15','14:40:00',3.17),('14598','2014-02-15','14:45:00',3.11),('14598','2014-02-15','14:50:00',3.07),('14598','2014-02-15','14:55:00',2.99),('14598','2014-02-15','15:00:00',2.94),('14598','2014-02-15','15:05:00',2.87),('14598','2014-02-15','15:10:00',2.81),('14598','2014-02-15','15:15:00',2.74),('14598','2014-02-15','15:20:00',2.67),('14598','2014-02-15','15:25:00',2.59),('14598','2014-02-15','15:30:00',2.51),('14598','2014-02-15','15:35:00',2.44),('14598','2014-02-15','15:40:00',2.36),('14598','2014-02-15','15:45:00',2.27),('14598','2014-02-15','15:50:00',2.18),('14598','2014-02-15','15:55:00',2.09),('14598','2014-02-15','16:00:00',1.99),('14598','2014-02-15','16:05:00',1.9),('14598','2014-02-15','16:10:00',1.81),('14598','2014-02-15','16:15:00',1.7),('14598','2014-02-15','16:20:00',1.6),('14598','2014-02-15','16:25:00',1.5),('14598','2014-02-15','16:30:00',1.4),('14598','2014-02-15','16:35:00',1.29),('14598','2014-02-15','16:40:00',1.17),('14598','2014-02-15','16:45:00',1.06),('14598','2014-02-14','08:55:00',1.09),('14598','2014-02-14','09:00:00',1.16),('14598','2014-02-14','09:05:00',1.31),('14598','2014-02-14','09:10:00',1.42),('14598','2014-02-14','09:15:00',1.49),('14598','2014-02-14','09:20:00',1.58),('14598','2014-02-14','09:25:00',1.67),('14598','2014-02-14','09:30:00',1.76),('14598','2014-02-14','09:35:00',1.86),('14598','2014-02-14','09:40:00',1.95),('14598','2014-02-14','09:45:00',2.02),('14598','2014-02-14','09:50:00',2.11),('14598','2014-02-14','09:55:00',2.19),('14598','2014-02-14','10:00:00',2.29),('14598','2014-02-14','10:05:00',2.36),('14598','2014-02-14','10:10:00',2.47),('14598','2014-02-14','10:15:00',2.51),('14598','2014-02-14','10:20:00',2.63),('14598','2014-02-14','10:25:00',2.68),('14598','2014-02-14','10:30:00',2.78),('14598','2014-02-14','10:35:00',2.83),('14598','2014-02-14','10:40:00',2.87),('14598','2014-02-14','10:45:00',2.91),('14598','2014-02-14','10:50:00',3.05),('14598','2014-02-14','10:55:00',3.11),('14598','2014-02-14','11:00:00',3.17),('14598','2014-02-14','11:05:00',3.24),('14598','2014-02-14','11:10:00',3.3),('14598','2014-02-14','11:15:00',3.36),('14598','2014-02-14','11:20:00',3.41),('14598','2014-02-14','11:25:00',3.45),('14598','2014-02-14','11:30:00',3.48),('14598','2014-02-14','11:35:00',3.51),('14598','2014-02-14','11:40:00',3.55),('14598','2014-02-14','11:45:00',3.58),('14598','2014-02-14','11:50:00',3.61),('14598','2014-02-14','11:55:00',3.63),('14598','2014-02-14','12:00:00',3.61),('14598','2014-02-14','12:05:00',3.7),('14598','2014-02-14','12:10:00',3.71),('14598','2014-02-14','12:15:00',3.73),('14598','2014-02-14','12:20:00',3.78),('14598','2014-02-14','12:25:00',3.8),('14598','2014-02-14','12:30:00',3.82),('14598','2014-02-14','12:35:00',3.83),('14598','2014-02-14','12:40:00',3.83),('14598','2014-02-14','12:45:00',3.83),('14598','2014-02-14','12:50:00',3.83),('14598','2014-02-14','12:55:00',3.83),('14598','2014-02-14','13:00:00',3.79),('14598','2014-02-14','13:05:00',3.77),('14598','2014-02-14','13:10:00',3.79),('14598','2014-02-14','13:15:00',3.79),('14598','2014-02-14','13:20:00',3.79),('14598','2014-02-14','13:25:00',3.76),('14598','2014-02-14','13:30:00',3.74),('14598','2014-02-14','13:35:00',3.7),('14598','2014-02-14','13:40:00',3.67),('14598','2014-02-14','13:45:00',3.65),('14598','2014-02-14','13:50:00',3.64),('14598','2014-02-14','13:55:00',3.61),('14598','2014-02-14','14:00:00',3.56),('14598','2014-02-14','14:05:00',3.5),('14598','2014-02-14','14:10:00',3.47),('14598','2014-02-14','14:15:00',3.41),('14598','2014-02-14','14:20:00',3.36),('14598','2014-02-14','14:25:00',3.33),('14598','2014-02-14','14:30:00',3.28),('14598','2014-02-14','14:35:00',3.25),('14598','2014-02-14','14:40:00',3.2),('14598','2014-02-14','14:45:00',3.15),('14598','2014-02-14','14:50:00',3.09),('14598','2014-02-14','14:55:00',3.03),('14598','2014-02-14','15:00:00',2.9),('14598','2014-02-14','15:05:00',2.88),('14598','2014-02-14','15:10:00',2.81),('14598','2014-02-14','15:15:00',2.72),('14598','2014-02-14','15:20:00',2.65),('14598','2014-02-14','15:25:00',2.59),('14598','2014-02-14','15:30:00',2.51),('14598','2014-02-14','15:35:00',2.41),('14598','2014-02-14','15:40:00',2.29),('14598','2014-02-14','15:45:00',2.2),('14598','2014-02-14','15:50:00',2.14),('14598','2014-02-14','15:55:00',2.05),('14598','2014-02-14','16:00:00',1.95),('14598','2014-02-14','16:05:00',1.83),('14598','2014-02-14','16:10:00',1.74),('14598','2014-02-14','16:15:00',1.64),('14598','2014-02-14','16:20:00',1.55),('14598','2014-02-14','16:25:00',1.43),('14598','2014-02-14','16:30:00',1.32),('14598','2014-02-14','16:35:00',1.23),('14598','2014-02-14','16:40:00',1.13),('14598','2014-02-14','16:45:00',1.02),('14598','2014-02-13','08:55:00',1.1),('14598','2014-02-13','09:00:00',1.2),('14598','2014-02-13','09:05:00',1.29),('14598','2014-02-13','09:10:00',1.39),('14598','2014-02-13','09:15:00',1.5),('14598','2014-02-13','09:20:00',1.61),('14598','2014-02-13','09:25:00',1.7),('14598','2014-02-13','09:30:00',1.79),('14598','2014-02-13','09:35:00',1.89),('14598','2014-02-13','09:40:00',1.98),('14598','2014-02-13','09:45:00',2.06),('14598','2014-02-13','09:50:00',2.15),('14598','2014-02-13','09:55:00',2.25),('14598','2014-02-13','10:00:00',2.33),('14598','2014-02-13','10:05:00',2.41),('14598','2014-02-13','10:10:00',2.48),('14598','2014-02-13','10:15:00',2.56),('14598','2014-02-13','10:20:00',2.64),('14598','2014-02-13','10:25:00',2.68),('14598','2014-02-13','10:30:00',2.75),('14598','2014-02-13','10:35:00',2.79),('14598','2014-02-13','10:40:00',2.84),('14598','2014-02-13','10:45:00',2.9),('14598','2014-02-13','10:50:00',2.96),('14598','2014-02-13','10:55:00',3),('14598','2014-02-13','11:00:00',3.08),('14598','2014-02-13','11:05:00',3.17),('14598','2014-02-13','11:10:00',3.22),('14598','2014-02-13','11:15:00',3.29),('14598','2014-02-13','11:20:00',2.66),('14598','2014-02-13','11:25:00',3.31),('14598','2014-02-13','11:30:00',3.41),('14598','2014-02-13','11:35:00',3.42),('14598','2014-02-13','11:40:00',3.45),('14598','2014-02-13','11:45:00',3.49),('14598','2014-02-13','11:50:00',3.54),('14598','2014-02-13','11:55:00',3.57),('14598','2014-02-13','12:00:00',3.62),('14598','2014-02-13','12:05:00',3.56),('14598','2014-02-13','12:10:00',3.69),('14598','2014-02-13','12:15:00',3.71),('14598','2014-02-13','12:20:00',3.72),('14598','2014-02-13','12:25:00',3.72),('14598','2014-02-13','12:30:00',3.74),('14598','2014-02-13','12:35:00',3.75),('14598','2014-02-13','12:40:00',3.76),('14598','2014-02-13','12:45:00',3.77),('14598','2014-02-13','12:50:00',3.78),('14598','2014-02-13','12:55:00',3.78),('14598','2014-02-13','13:00:00',3.79),('14598','2014-02-13','13:05:00',3.77),('14598','2014-02-13','13:10:00',3.76),('14598','2014-02-13','13:15:00',3.75),('14598','2014-02-13','13:20:00',3.7),('14598','2014-02-13','13:25:00',3.69),('14598','2014-02-13','13:30:00',3.69),('14598','2014-02-13','13:35:00',3.67),('14598','2014-02-13','13:40:00',3.66),('14598','2014-02-13','13:45:00',3.62),('14598','2014-02-13','13:50:00',3.58),('14598','2014-02-13','13:55:00',3.57),('14598','2014-02-13','14:00:00',3.54),('14598','2014-02-13','14:05:00',3.5),('14598','2014-02-13','14:10:00',3.46),('14598','2014-02-13','14:15:00',3.41),('14598','2014-02-13','14:20:00',3.36),('14598','2014-02-13','14:25:00',3.32),('14598','2014-02-13','14:30:00',3.27),('14598','2014-02-13','14:35:00',3.22),('14598','2014-02-13','14:40:00',3.17),('14598','2014-02-13','14:45:00',3.12),('14598','2014-02-13','14:50:00',3.07),('14598','2014-02-13','14:55:00',3.02),('14598','2014-02-13','15:00:00',2.95),('14598','2014-02-13','15:05:00',2.88),('14598','2014-02-13','15:10:00',2.82),('14598','2014-02-13','15:15:00',2.76),('14598','2014-02-13','15:20:00',2.68),('14598','2014-02-13','15:25:00',2.6),('14598','2014-02-13','15:30:00',2.52),('14598','2014-02-13','15:35:00',2.42),('14598','2014-02-13','15:40:00',2.34),('14598','2014-02-13','15:45:00',2.26),('14598','2014-02-13','15:50:00',2.07),('14598','2014-02-13','15:55:00',1.69),('14598','2014-02-13','16:00:00',1.93),('14598','2014-02-13','16:05:00',1.35),('14598','2014-02-13','16:10:00',1.76),('14598','2014-02-13','16:15:00',1.51),('14598','2014-02-13','16:45:00',1.13),('14598','2014-02-12','09:25:00',1.09),('14598','2014-02-12','09:30:00',1.26),('14598','2014-02-12','09:35:00',1.26),('14598','2014-02-12','09:40:00',1.75),('14598','2014-02-12','09:45:00',1.69),('14598','2014-02-12','09:50:00',1.9),('14598','2014-02-12','09:55:00',1.43),('14598','2014-02-12','10:05:00',1.15),('14598','2014-02-12','10:10:00',1.38),('14598','2014-02-12','10:15:00',1.72),('14598','2014-02-12','10:20:00',1.76),('14598','2014-02-12','10:25:00',1.34),('14598','2014-02-12','10:30:00',1.18),('14598','2014-02-12','10:35:00',1.09),('14598','2014-02-12','10:40:00',1.11),('14598','2014-02-12','10:45:00',1.13),('14598','2014-02-12','10:50:00',1.01),('14598','2014-02-12','11:00:00',1.27),('14598','2014-02-12','11:05:00',1.73),('14598','2014-02-12','11:10:00',1.42),('14598','2014-02-12','11:15:00',1.72),('14598','2014-02-12','11:20:00',2.18),('14598','2014-02-12','11:25:00',1.72),('14598','2014-02-12','11:30:00',1.26),('14598','2014-02-12','11:35:00',1.38),('14598','2014-02-12','11:40:00',1.63),('14598','2014-02-12','11:45:00',1.63),('14598','2014-02-12','11:50:00',1.43),('14598','2014-02-12','11:55:00',1.56),('14598','2014-02-12','12:00:00',1.74),('14598','2014-02-12','12:05:00',2.12),('14598','2014-02-12','12:10:00',2.12),('14598','2014-02-12','12:15:00',2.17),('14598','2014-02-12','12:20:00',1.98),('14598','2014-02-12','12:25:00',1.7),('14598','2014-02-12','12:30:00',1.76),('14598','2014-02-12','12:35:00',1.93),('14598','2014-02-12','12:40:00',2.33),('14598','2014-02-12','12:45:00',2.82),('14598','2014-02-12','12:50:00',3.08),('14598','2014-02-12','12:55:00',2.43),('14598','2014-02-12','13:00:00',2.77),('14598','2014-02-12','13:05:00',2.85),('14598','2014-02-12','13:10:00',2.3),('14598','2014-02-12','13:15:00',2.63),('14598','2014-02-12','13:20:00',1.78),('14598','2014-02-12','13:25:00',1.6),('14598','2014-02-12','13:30:00',1.79),('14598','2014-02-12','13:35:00',1.74),('14598','2014-02-12','13:40:00',1.76),('14598','2014-02-12','13:45:00',1.6),('14598','2014-02-12','13:50:00',1.52),('14598','2014-02-12','13:55:00',1.66),('14598','2014-02-12','14:00:00',1.94),('14598','2014-02-12','14:05:00',2.58),('14598','2014-02-12','14:10:00',4.65),('14598','2014-02-12','14:15:00',4.47),('14598','2014-02-12','14:20:00',4.04),('14598','2014-02-12','14:25:00',3.78),('14598','2014-02-12','14:30:00',3.56),('14598','2014-02-12','14:35:00',3.35),('14598','2014-02-12','14:40:00',3.03),('14598','2014-02-12','14:45:00',3.17),('14598','2014-02-12','14:50:00',2.93),('14598','2014-02-12','14:55:00',2.75),('14598','2014-02-12','15:00:00',2.8),('14598','2014-02-12','15:05:00',3),('14598','2014-02-12','15:10:00',2.82),('14598','2014-02-12','15:15:00',2.33),('14598','2014-02-12','15:20:00',2.84),('14598','2014-02-12','15:25:00',2.66),('14598','2014-02-12','15:30:00',2.56),('14598','2014-02-12','15:35:00',2.48),('14598','2014-02-12','15:40:00',2.33),('14598','2014-02-12','15:45:00',1.79),('14598','2014-02-12','15:50:00',2.1),('14598','2014-02-12','15:55:00',1.69),('14598','2014-02-12','16:00:00',1.09),('14598','2014-02-12','16:05:00',1.69),('14598','2014-02-12','16:10:00',1.18),('14598','2014-02-11','09:55:00',1.03),('14598','2014-02-11','10:00:00',1.24),('14598','2014-02-11','10:05:00',1.97),('14598','2014-02-11','10:10:00',1.78),('14598','2014-02-11','10:15:00',1.67),('14598','2014-02-11','10:20:00',1.79),('14598','2014-02-11','10:25:00',1.68),('14598','2014-02-11','10:30:00',1.69),('14598','2014-02-11','10:35:00',1.77),('14598','2014-02-11','10:40:00',1.56),('14598','2014-02-11','10:45:00',1.66),('14598','2014-02-11','10:50:00',1.88),('14598','2014-02-11','10:55:00',1.89),('14598','2014-02-11','11:00:00',1.57),('14598','2014-02-11','11:05:00',1.48),('14598','2014-02-11','11:10:00',1.48),('14598','2014-02-11','11:15:00',1.54),('14598','2014-02-11','11:20:00',1.75),('14598','2014-02-11','11:25:00',2.13),('14598','2014-02-11','11:30:00',2.03),('14598','2014-02-11','11:35:00',2.45),('14598','2014-02-11','11:40:00',2.32),('14598','2014-02-11','11:45:00',2.47),('14598','2014-02-11','11:50:00',2.52),('14598','2014-02-11','11:55:00',2.51),('14598','2014-02-11','12:00:00',2.47),('14598','2014-02-11','12:05:00',2.43),('14598','2014-02-11','12:10:00',2.29),('14598','2014-02-11','12:15:00',1.53),('14598','2014-02-11','12:20:00',1.72),('14598','2014-02-11','12:25:00',1.57),('14598','2014-02-11','12:30:00',1.7),('14598','2014-02-11','12:35:00',2.59),('14598','2014-02-11','12:40:00',2.63),('14598','2014-02-11','12:45:00',1.7),('14598','2014-02-11','12:50:00',2.37),('14598','2014-02-11','12:55:00',2.71),('14598','2014-02-11','13:00:00',3),('14598','2014-02-11','13:05:00',2.41),('14598','2014-02-11','13:10:00',2.62),('14598','2014-02-11','13:15:00',3.03),('14598','2014-02-11','13:20:00',2.96),('14598','2014-02-11','13:25:00',3.28),('14598','2014-02-11','13:30:00',3.08),('14598','2014-02-11','13:35:00',2.85),('14598','2014-02-11','13:40:00',2.54),('14598','2014-02-11','13:45:00',2.25),('14598','2014-02-11','13:50:00',2.49),('14598','2014-02-11','13:55:00',1.62),('14598','2014-02-11','14:00:00',2.07),('14598','2014-02-11','14:05:00',2.35),('14598','2014-02-11','14:10:00',1.38),('14598','2014-02-11','14:15:00',1.82),('14598','2014-02-11','14:20:00',1.38),('14598','2014-02-11','14:25:00',3.24),('14598','2014-02-11','14:30:00',2.46),('14598','2014-02-11','14:35:00',2.28),('14598','2014-02-11','14:40:00',1.66),('14598','2014-02-11','14:45:00',1.74),('14598','2014-02-11','14:50:00',1.7),('14598','2014-02-11','14:55:00',1.36),('14598','2014-02-11','15:00:00',1.4),('14598','2014-02-11','15:05:00',1.46),('14598','2014-02-11','15:10:00',1.41),('14598','2014-02-11','15:15:00',1.44),('14598','2014-02-11','15:20:00',2.14),('14598','2014-02-11','15:25:00',1.86),('14598','2014-02-11','15:30:00',2.36),('14598','2014-02-11','15:35:00',1.54),('14598','2014-02-11','15:40:00',1.36),('14598','2014-02-11','15:45:00',1.3),('14598','2014-02-11','15:50:00',1.13),('14598','2014-02-11','16:10:00',1.07),('14598','2014-02-10','12:45:00',1.01),('14598','2014-02-10','12:55:00',1.04),('14598','2014-02-10','13:30:00',1.1),('14598','2014-02-10','13:35:00',1.1),('14598','2014-02-10','13:40:00',1.03),('14598','2014-02-10','13:50:00',1.02),('14598','2014-02-10','13:55:00',1.1),('14598','2014-02-10','14:10:00',1.01),('14598','2014-02-10','15:05:00',1.06),('14598','2014-02-10','15:20:00',1.01),('14598','2014-02-10','15:25:00',1.03),('14598','2014-02-09','11:20:00',1.46),('14598','2014-02-09','11:45:00',1.44),('14598','2014-02-09','11:50:00',3.38),('14598','2014-02-09','11:55:00',1.92),('14598','2014-02-09','12:00:00',3.54),('14598','2014-02-09','12:05:00',1.47),('14598','2014-02-09','12:10:00',1.37),('14598','2014-02-09','12:15:00',1.33),('14598','2014-02-09','12:20:00',1.78),('14598','2014-02-09','12:25:00',1.8),('14598','2014-02-09','12:30:00',1.89),('14598','2014-02-09','12:35:00',1.44),('14598','2014-02-09','12:40:00',2.04),('14598','2014-02-09','12:45:00',3.17),('14598','2014-02-09','12:50:00',2.81),('14598','2014-02-09','12:55:00',4.42),('14598','2014-02-09','13:00:00',2.03),('14598','2014-02-09','13:05:00',3.33),('14598','2014-02-09','13:10:00',2.19),('14598','2014-02-09','13:15:00',1.01),('14598','2014-02-09','13:20:00',2.67),('14598','2014-02-09','13:25:00',4),('14598','2014-02-09','13:30:00',1.99),('14598','2014-02-09','13:35:00',2.4),('14598','2014-02-09','13:40:00',3.88),('14598','2014-02-09','13:45:00',3.76),('14598','2014-02-09','13:50:00',2.86),('14598','2014-02-09','13:55:00',1.15),('14598','2014-02-09','14:05:00',1.78),('14598','2014-02-09','14:10:00',2.07),('14598','2014-02-09','14:15:00',3.61),('14598','2014-02-09','14:20:00',3.11),('14598','2014-02-09','14:25:00',3.08),('14598','2014-02-09','14:30:00',3.23),('14598','2014-02-09','14:35:00',3.08),('14598','2014-02-09','14:40:00',2.86),('14598','2014-02-09','14:45:00',2.99),('14598','2014-02-09','14:50:00',2.65),('14598','2014-02-09','14:55:00',2.52),('14598','2014-02-09','15:00:00',2.81),('14598','2014-02-09','15:05:00',2.74),('14598','2014-02-09','15:10:00',2.61),('14598','2014-02-09','15:15:00',2.53),('14598','2014-02-09','15:20:00',2.46),('14598','2014-02-09','15:25:00',2.38),('14598','2014-02-09','15:30:00',2.28),('14598','2014-02-09','15:35:00',2.05),('14598','2014-02-09','15:40:00',2.09),('14598','2014-02-09','15:45:00',1.86),('14598','2014-02-09','15:50:00',1.6),('14598','2014-02-09','15:55:00',1.51),('14598','2014-02-09','16:00:00',1.54),('14598','2014-02-09','16:05:00',1.52),('14598','2014-02-09','16:10:00',1.44),('14598','2014-02-09','16:15:00',1.38),('14598','2014-02-09','16:20:00',1.27),('14598','2014-02-09','16:25:00',1.15),('14598','2014-02-08','09:25:00',1.19),('14598','2014-02-08','09:30:00',1.14),('14598','2014-02-08','09:35:00',1.72),('14598','2014-02-08','09:40:00',1.84),('14598','2014-02-08','09:45:00',1.92),('14598','2014-02-08','09:50:00',2.01),('14598','2014-02-08','09:55:00',1.98),('14598','2014-02-08','10:00:00',2.05),('14598','2014-02-08','10:05:00',2.18),('14598','2014-02-08','10:10:00',2.4),('14598','2014-02-08','10:15:00',2.4),('14598','2014-02-08','10:20:00',2.42),('14598','2014-02-08','10:25:00',2.74),('14598','2014-02-08','10:30:00',2.36),('14598','2014-02-08','10:35:00',2.76),('14598','2014-02-08','10:40:00',2.77),('14598','2014-02-08','10:45:00',2.75),('14598','2014-02-08','10:50:00',2.61),('14598','2014-02-08','10:55:00',2.75),('14598','2014-02-08','11:00:00',3.24),('14598','2014-02-08','11:05:00',3.19),('14598','2014-02-08','11:15:00',2.24),('14598','2014-02-08','11:20:00',2.75),('14598','2014-02-08','11:25:00',3.55),('14598','2014-02-08','11:30:00',2.07),('14598','2014-02-08','11:35:00',2.45),('14598','2014-02-08','11:40:00',1.77),('14598','2014-02-08','11:45:00',3.81),('14598','2014-02-08','11:50:00',3.49),('14598','2014-02-08','11:55:00',3.54),('14598','2014-02-08','12:00:00',3.59),('14598','2014-02-08','12:05:00',3.59),('14598','2014-02-08','12:10:00',3.59),('14598','2014-02-08','12:15:00',3.61),('14598','2014-02-08','12:20:00',3.63),('14598','2014-02-08','12:25:00',3.89),('14598','2014-02-08','12:30:00',3.64),('14598','2014-02-08','12:35:00',3.8),('14598','2014-02-08','12:40:00',3.42),('14598','2014-02-08','12:45:00',3.74),('14598','2014-02-08','12:50:00',2.73),('14598','2014-02-08','13:00:00',3.34),('14598','2014-02-08','13:05:00',3.84),('14598','2014-02-08','13:10:00',3.7),('14598','2014-02-08','13:15:00',2.54),('14598','2014-02-08','13:20:00',3.75),('14598','2014-02-08','13:25:00',3.86),('14598','2014-02-08','13:30:00',3.66),('14598','2014-02-08','13:35:00',3.59),('14598','2014-02-08','13:40:00',3.63),('14598','2014-02-08','13:45:00',3.61),('14598','2014-02-08','13:50:00',3.57),('14598','2014-02-08','13:55:00',3.6),('14598','2014-02-08','14:00:00',3.19),('14598','2014-02-08','14:05:00',2.66),('14598','2014-02-08','14:10:00',2.93),('14598','2014-02-08','14:15:00',3.31),('14598','2014-02-08','14:20:00',3.39),('14598','2014-02-08','14:25:00',2.07),('14598','2014-02-08','14:30:00',1.51),('14598','2014-02-08','14:35:00',2.27),('14598','2014-02-08','14:40:00',3.46),('14598','2014-02-08','14:45:00',3.34),('14598','2014-02-08','14:50:00',3.22),('14598','2014-02-08','14:55:00',2.51),('14598','2014-02-08','15:00:00',2.77),('14598','2014-02-08','15:05:00',2.41),('14598','2014-02-08','15:10:00',2.81),('14598','2014-02-08','15:15:00',2.66),('14598','2014-02-08','15:20:00',2.56),('14598','2014-02-08','15:25:00',2.49),('14598','2014-02-08','15:30:00',2.55),('14598','2014-02-08','15:35:00',2.46),('14598','2014-02-08','15:40:00',2.29),('14598','2014-02-08','15:45:00',2.01),('14598','2014-02-08','15:50:00',2.06),('14598','2014-02-08','15:55:00',2.12),('14598','2014-02-08','16:00:00',1.93),('14598','2014-02-08','16:05:00',1.05),('14598','2014-02-08','16:10:00',1.65),('14598','2014-02-08','16:15:00',1.93),('14598','2014-02-08','16:20:00',1.7),('14598','2014-02-08','16:25:00',1.46),('14598','2014-02-08','16:30:00',1.56),('14598','2014-02-07','08:50:00',1.13),('14598','2014-02-07','08:55:00',1.08),('14598','2014-02-07','09:10:00',1.07),('14598','2014-02-07','09:15:00',1.37),('14598','2014-02-07','09:20:00',1.45),('14598','2014-02-07','09:25:00',1.61),('14598','2014-02-07','09:30:00',1.82),('14598','2014-02-07','09:35:00',1.97),('14598','2014-02-07','09:40:00',2.21),('14598','2014-02-07','09:45:00',2.26),('14598','2014-02-07','09:50:00',2.28),('14598','2014-02-07','09:55:00',2.04),('14598','2014-02-07','10:00:00',2.13),('14598','2014-02-07','10:05:00',2.18),('14598','2014-02-07','10:10:00',2.26),('14598','2014-02-07','10:15:00',2.33),('14598','2014-02-07','10:20:00',2.39),('14598','2014-02-07','10:25:00',2.48),('14598','2014-02-07','10:30:00',2.55),('14598','2014-02-07','10:35:00',2.59),('14598','2014-02-07','10:40:00',2.54),('14598','2014-02-07','10:45:00',2.71),('14598','2014-02-07','10:50:00',2.83),('14598','2014-02-07','10:55:00',2.64),('14598','2014-02-07','11:00:00',3.13),('14598','2014-02-07','11:05:00',3.29),('14598','2014-02-07','11:10:00',3.39),('14598','2014-02-07','11:15:00',3.49),('14598','2014-02-07','11:20:00',3.42),('14598','2014-02-07','11:25:00',2.45),('14598','2014-02-07','11:30:00',3.36),('14598','2014-02-07','11:35:00',3.38),('14598','2014-02-07','11:40:00',3.42),('14598','2014-02-07','11:45:00',3.41),('14598','2014-02-07','11:50:00',3.43),('14598','2014-02-07','11:55:00',3.45),('14598','2014-02-07','12:00:00',3.48),('14598','2014-02-07','12:05:00',3.5),('14598','2014-02-07','12:10:00',3.54),('14598','2014-02-07','12:15:00',3.32),('14598','2014-02-07','12:20:00',3.61),('14598','2014-02-07','12:25:00',3.59),('14598','2014-02-07','12:30:00',3.59),('14598','2014-02-07','12:35:00',3.6),('14598','2014-02-07','12:40:00',3.6),('14598','2014-02-07','12:45:00',3.61),('14598','2014-02-07','12:50:00',3.62),('14598','2014-02-07','12:55:00',3.56),('14598','2014-02-07','13:00:00',3.61),('14598','2014-02-07','13:05:00',3.7),('14598','2014-02-07','13:10:00',3.89),('14598','2014-02-07','13:15:00',3.8),('14598','2014-02-07','13:20:00',3.79),('14598','2014-02-07','13:25:00',3.73),('14598','2014-02-07','13:30:00',2.91),('14598','2014-02-07','13:35:00',3.93),('14598','2014-02-07','13:40:00',3.2),('14598','2014-02-07','13:45:00',4.12),('14598','2014-02-07','13:55:00',3.75),('14598','2014-02-07','14:00:00',3.64),('14598','2014-02-07','14:05:00',3.43),('14598','2014-02-07','14:10:00',3.3),('14598','2014-02-07','14:15:00',3.27),('14598','2014-02-07','14:20:00',3.21),('14598','2014-02-07','14:25:00',3.17),('14598','2014-02-07','14:30:00',3.13),('14598','2014-02-07','14:35:00',3.08),('14598','2014-02-07','14:40:00',3.04),('14598','2014-02-07','14:45:00',2.99),('14598','2014-02-07','14:50:00',2.92),('14598','2014-02-07','14:55:00',2.85),('14598','2014-02-07','15:00:00',2.79),('14598','2014-02-07','15:05:00',2.73),('14598','2014-02-07','15:10:00',2.66),('14598','2014-02-07','15:15:00',2.59),('14598','2014-02-07','15:20:00',2.52),('14598','2014-02-07','15:25:00',2.44),('14598','2014-02-07','15:30:00',2.36),('14598','2014-02-07','15:35:00',2.27),('14598','2014-02-07','15:40:00',2.19),('14598','2014-02-07','15:45:00',2.1),('14598','2014-02-07','15:50:00',2.01),('14598','2014-02-07','15:55:00',1.91),('14598','2014-02-07','16:00:00',1.83),('14598','2014-02-07','16:05:00',1.73),('14598','2014-02-07','16:10:00',1.62),('14598','2014-02-07','16:15:00',1.52),('14598','2014-02-07','16:20:00',1.42),('14598','2014-02-07','16:25:00',1.3),('14598','2014-02-07','16:30:00',1.2),('14598','2014-02-07','16:35:00',1.08),('14598','2014-02-06','09:00:00',1.01),('14598','2014-02-06','09:05:00',1.13),('14598','2014-02-06','09:10:00',1.22),('14598','2014-02-06','09:15:00',1.33),('14598','2014-02-06','09:20:00',1.42),('14598','2014-02-06','09:25:00',1.51),('14598','2014-02-06','09:30:00',1.62),('14598','2014-02-06','09:35:00',1.68),('14598','2014-02-06','09:40:00',1.78),('14598','2014-02-06','09:45:00',1.88),('14598','2014-02-06','09:50:00',1.95),('14598','2014-02-06','09:55:00',2.05),('14598','2014-02-06','10:00:00',2.13),('14598','2014-02-06','10:05:00',2.21),('14598','2014-02-06','10:10:00',2.32),('14598','2014-02-06','10:15:00',2.4),('14598','2014-02-06','10:20:00',2.46),('14598','2014-02-06','10:25:00',2.51),('14598','2014-02-06','10:30:00',2.58),('14598','2014-02-06','10:35:00',2.71),('14598','2014-02-06','10:40:00',2.99),('14598','2014-02-06','10:45:00',2.85),('14598','2014-02-06','10:50:00',2.88),('14598','2014-02-06','10:55:00',2.94),('14598','2014-02-06','11:00:00',3.01),('14598','2014-02-06','11:05:00',3.08),('14598','2014-02-06','11:10:00',3.13),('14598','2014-02-06','11:15:00',3.18),('14598','2014-02-06','11:20:00',3.2),('14598','2014-02-06','11:25:00',3.24),('14598','2014-02-06','11:30:00',3.27),('14598','2014-02-06','11:35:00',3.35),('14598','2014-02-06','11:40:00',3.38),('14598','2014-02-06','11:45:00',3.43),('14598','2014-02-06','11:50:00',3.44),('14598','2014-02-06','11:55:00',3.48),('14598','2014-02-06','12:00:00',3.47),('14598','2014-02-06','12:05:00',3.54),('14598','2014-02-06','12:10:00',3.59),('14598','2014-02-06','12:15:00',3.63),('14598','2014-02-06','12:20:00',3.65),('14598','2014-02-06','12:25:00',3.66),('14598','2014-02-06','12:30:00',3.65),('14598','2014-02-06','12:35:00',3.66),('14598','2014-02-06','12:40:00',3.64),('14598','2014-02-06','12:45:00',3.65),('14598','2014-02-06','12:50:00',3.67),('14598','2014-02-06','12:55:00',3.66),('14598','2014-02-06','13:00:00',3.66),('14598','2014-02-06','13:05:00',3.64),('14598','2014-02-06','13:10:00',3.66),('14598','2014-02-06','13:15:00',3.62),('14598','2014-02-06','13:20:00',3.63),('14598','2014-02-06','13:25:00',3.61),('14598','2014-02-06','13:30:00',3.6),('14598','2014-02-06','13:35:00',3.59),('14598','2014-02-06','13:40:00',3.55),('14598','2014-02-06','13:45:00',3.5),('14598','2014-02-06','13:50:00',3.49),('14598','2014-02-06','13:55:00',3.48),('14598','2014-02-06','14:00:00',3.43),('14598','2014-02-06','14:05:00',3.39),('14598','2014-02-06','14:10:00',3.34),('14598','2014-02-06','14:15:00',3.29),('14598','2014-02-06','14:20:00',3.25),('14598','2014-02-06','14:25:00',3.21),('14598','2014-02-06','14:30:00',3.14),('14598','2014-02-06','14:35:00',3.1),('14598','2014-02-06','14:40:00',3.04),('14598','2014-02-06','14:45:00',2.98),('14598','2014-02-06','14:50:00',2.91),('14598','2014-02-06','14:55:00',2.86),('14598','2014-02-06','15:00:00',2.78),('14598','2014-02-06','15:05:00',2.73),('14598','2014-02-06','15:10:00',2.65),('14598','2014-02-06','15:15:00',2.58),('14598','2014-02-06','15:20:00',2.5),('14598','2014-02-06','15:25:00',2.42),('14598','2014-02-06','15:30:00',2.34),('14598','2014-02-06','15:35:00',2.26),('14598','2014-02-06','15:40:00',2.16),('14598','2014-02-06','15:45:00',2.08),('14598','2014-02-06','15:50:00',1.99),('14598','2014-02-06','15:55:00',1.9),('14598','2014-02-06','16:00:00',1.8),('14598','2014-02-06','16:05:00',1.69),('14598','2014-02-06','16:10:00',1.59),('14598','2014-02-06','16:15:00',1.49),('14598','2014-02-06','16:20:00',1.37),('14598','2014-02-06','16:25:00',1.27),('14598','2014-02-06','16:30:00',1.16),('14598','2014-02-06','16:35:00',1.05),('14598','2014-04-27','08:20:00',1.04),('14598','2014-04-27','10:00:00',1.39),('14598','2014-04-27','10:05:00',1.28),('14598','2014-04-27','10:10:00',1.24),('14598','2014-04-27','10:15:00',1.77),('14598','2014-04-27','10:20:00',1.66),('14598','2014-04-27','10:25:00',1.22),('14598','2014-04-27','10:30:00',2.01),('14598','2014-04-27','10:35:00',1.41),('14598','2014-04-27','10:40:00',1.21),('14598','2014-04-27','10:45:00',1.95),('14598','2014-04-27','10:50:00',2.11),('14598','2014-04-27','10:55:00',2.28),('14598','2014-04-27','11:00:00',1.93),('14598','2014-04-27','11:05:00',2.35),('14598','2014-04-27','11:10:00',4.88),('14598','2014-04-27','11:15:00',3.42),('14598','2014-04-27','11:20:00',3.69),('14598','2014-04-27','11:25:00',3.66),('14598','2014-04-27','11:30:00',4.21),('14598','2014-04-27','11:35:00',2.79),('14598','2014-04-27','11:40:00',2.55),('14598','2014-04-27','11:45:00',3.63),('14598','2014-04-27','11:50:00',4.37),('14598','2014-04-27','11:55:00',4.61),('14598','2014-04-27','12:00:00',4.67),('14598','2014-04-27','12:05:00',5.3),('14598','2014-04-27','12:10:00',5.03),('14598','2014-04-27','12:15:00',4.34),('14598','2014-04-27','12:20:00',4.49),('14598','2014-04-27','12:25:00',4.22),('14598','2014-04-27','12:30:00',3.11),('14598','2014-04-27','12:35:00',2.98),('14598','2014-04-27','12:40:00',2.43),('14598','2014-04-27','12:45:00',1.97),('14598','2014-04-27','12:50:00',2.47),('14598','2014-04-27','12:55:00',2.49),('14598','2014-04-27','13:00:00',2.93),('14598','2014-04-27','13:05:00',3.24),('14598','2014-04-27','13:10:00',2.49),('14598','2014-04-27','13:15:00',1.63),('14598','2014-04-27','13:20:00',1.61),('14598','2014-04-27','13:25:00',2.03),('14598','2014-04-27','13:30:00',2.65),('14598','2014-04-27','13:35:00',3.8),('14598','2014-04-27','13:40:00',2.89),('14598','2014-04-27','13:45:00',1.99),('14598','2014-04-27','13:50:00',2.16),('14598','2014-04-27','13:55:00',2.48),('14598','2014-04-27','14:00:00',2.43),('14598','2014-04-27','14:05:00',2.43),('14598','2014-04-27','14:10:00',2.49),('14598','2014-04-27','14:15:00',3.04),('14598','2014-04-27','14:20:00',3.1),('14598','2014-04-27','14:25:00',3.21),('14598','2014-04-27','14:30:00',2.97),('14598','2014-04-27','14:35:00',3.38),('14598','2014-04-27','14:40:00',3.15),('14598','2014-04-27','14:45:00',3.42),('14598','2014-04-27','14:50:00',3.98),('14598','2014-04-27','14:55:00',4.05),('14598','2014-04-27','15:00:00',3.12),('14598','2014-04-27','15:05:00',2.27),('14598','2014-04-27','15:10:00',1.85),('14598','2014-04-27','15:15:00',1.42),('14598','2014-04-27','15:20:00',1.1),('14598','2014-04-27','15:35:00',1.02),('14598','2014-02-05','08:55:00',1.11),('14598','2014-02-05','09:00:00',1.26),('14598','2014-02-05','09:05:00',1.4),('14598','2014-02-05','09:10:00',1.77),('14598','2014-02-05','09:15:00',1.27),('14598','2014-02-05','09:20:00',1.05),('14598','2014-02-05','09:50:00',1.96),('14598','2014-02-05','09:55:00',2.67),('14598','2014-02-05','10:00:00',2.56),('14598','2014-02-05','10:05:00',1.71),('14598','2014-02-05','10:10:00',2.28),('14598','2014-02-05','10:15:00',2.38),('14598','2014-02-05','10:20:00',2.49),('14598','2014-02-05','10:25:00',2.52),('14598','2014-02-05','10:30:00',2.58),('14598','2014-02-05','10:35:00',2.78),('14598','2014-02-05','10:40:00',2.98),('14598','2014-02-05','10:45:00',3.03),('14598','2014-02-05','10:50:00',2.66),('14598','2014-02-05','10:55:00',1.97),('14598','2014-02-05','11:00:00',1.52),('14598','2014-02-05','11:05:00',1.18),('14598','2014-02-05','11:30:00',1.67),('14598','2014-02-05','11:35:00',3.03),('14598','2014-02-05','11:40:00',3.11),('14598','2014-02-05','11:45:00',3.6),('14598','2014-02-05','11:50:00',2.41),('14598','2014-02-05','11:55:00',1.82),('14598','2014-02-05','12:00:00',2.25),('14598','2014-02-05','12:05:00',3.68),('14598','2014-02-05','12:10:00',2.32),('14598','2014-02-05','12:15:00',1.79),('14598','2014-02-05','12:20:00',1.39),('14598','2014-02-05','12:25:00',1.43),('14598','2014-02-05','12:30:00',1.83),('14598','2014-02-05','12:35:00',2.22),('14598','2014-02-05','12:40:00',2.76),('14598','2014-02-05','12:45:00',3.21),('14598','2014-02-05','12:50:00',2.75),('14598','2014-02-05','12:55:00',1.68),('14598','2014-02-05','13:00:00',1.12),('14598','2014-02-05','13:20:00',1.32),('14598','2014-02-05','13:25:00',1.56),('14598','2014-02-05','13:30:00',1.6),('14598','2014-02-05','13:35:00',1.45),('14598','2014-02-05','13:40:00',1.45),('14598','2014-02-05','13:45:00',1.46),('14598','2014-02-05','13:50:00',1.78),('14598','2014-02-05','13:55:00',1.68),('14598','2014-02-05','14:00:00',1.38),('14598','2014-02-05','14:05:00',1.35),('14598','2014-02-05','14:10:00',1.33),('14598','2014-02-05','14:15:00',1.37),('14598','2014-02-05','14:20:00',1.15),('14598','2014-02-05','14:25:00',1.2),('14598','2014-02-05','15:10:00',1.19),('14598','2014-02-05','15:15:00',1.12),('14598','2014-02-05','15:20:00',1.03),('14598','2014-02-05','15:50:00',1.48),('14598','2014-02-05','15:55:00',1.71),('14598','2014-02-05','16:00:00',1.09),('14598','2014-02-04','09:35:00',1.24),('14598','2014-02-04','09:40:00',1.34),('14598','2014-02-04','09:45:00',1.14),('14598','2014-02-04','09:55:00',2.38),('14598','2014-02-04','10:00:00',2.45),('14598','2014-02-04','10:05:00',2.65),('14598','2014-02-04','10:10:00',2.96),('14598','2014-02-04','10:15:00',2.92),('14598','2014-02-04','10:20:00',2.84),('14598','2014-02-04','10:25:00',2.97),('14598','2014-02-04','10:30:00',3),('14598','2014-02-04','10:35:00',3.1),('14598','2014-02-04','10:40:00',3.39),('14598','2014-02-04','10:45:00',3.57),('14598','2014-02-04','10:50:00',3.07),('14598','2014-02-04','10:55:00',2.06),('14598','2014-02-04','11:00:00',2.89),('14598','2014-02-04','11:05:00',1.59),('14598','2014-02-04','11:10:00',1.09),('14598','2014-02-04','11:25:00',1.1),('14598','2014-02-04','11:30:00',1.36),('14598','2014-02-04','11:35:00',2.11),('14598','2014-02-04','11:40:00',2.28),('14598','2014-02-04','11:45:00',2.39),('14598','2014-02-04','11:50:00',1.59),('14598','2014-02-04','11:55:00',1.46),('14598','2014-02-04','12:00:00',1.53),('14598','2014-02-04','12:05:00',1.76),('14598','2014-02-04','12:10:00',2.17),('14598','2014-02-04','12:15:00',1.93),('14598','2014-02-04','12:20:00',1.57),('14598','2014-02-04','12:25:00',1.15),('14598','2014-02-04','13:05:00',1.2),('14598','2014-02-04','13:10:00',1.22),('14598','2014-02-04','13:15:00',1.14),('14598','2014-02-04','13:20:00',1.3),('14598','2014-02-04','13:25:00',1.36),('14598','2014-02-04','13:30:00',1.1),('14598','2014-02-04','13:35:00',1.01),('14598','2014-02-04','13:40:00',1.14),('14598','2014-02-03','09:50:00',1.05),('14598','2014-02-03','09:55:00',1.38),('14598','2014-02-03','10:00:00',1.72),('14598','2014-02-03','10:05:00',2.33),('14598','2014-02-03','10:10:00',2.69),('14598','2014-02-03','10:15:00',1.62),('14598','2014-02-03','10:20:00',1.03),('14598','2014-02-02','12:20:00',1.01),('14598','2014-02-02','12:40:00',1.08),('14598','2014-02-02','12:45:00',1.06),('14598','2014-02-01','10:25:00',1.17),('14598','2014-02-01','10:40:00',1.03),('14598','2014-02-01','10:45:00',1.05),('14598','2014-02-01','10:50:00',1.02),('14598','2014-02-01','10:55:00',1.06),('14598','2014-02-01','11:00:00',1.37),('14598','2014-02-01','11:05:00',1.38),('14598','2014-02-01','11:10:00',1.25),('14598','2014-02-01','11:15:00',1.59),('14598','2014-02-01','11:20:00',2.03),('14598','2014-02-01','11:25:00',1.52),('14598','2014-02-01','11:30:00',1.68),('14598','2014-02-01','11:35:00',1.65),('14598','2014-02-01','11:40:00',1.05),('14598','2014-02-01','11:45:00',1.85),('14598','2014-02-01','11:50:00',2.36),('14598','2014-02-01','11:55:00',1.8),('14598','2014-02-01','12:00:00',1.1),('14598','2014-02-01','12:05:00',1.6),('14598','2014-02-01','12:10:00',2.31),('14598','2014-02-01','12:15:00',2.03),('14598','2014-02-01','12:20:00',2.3),('14598','2014-02-01','12:25:00',2.32),('14598','2014-02-01','12:30:00',2.13),('14598','2014-02-01','12:35:00',1.99),('14598','2014-02-01','12:40:00',2.32),('14598','2014-02-01','12:45:00',2.33),('14598','2014-02-01','12:50:00',2.16),('14598','2014-02-01','12:55:00',2.05),('14598','2014-02-01','13:00:00',1.86),('14598','2014-02-01','13:05:00',1.5),('14598','2014-02-01','13:10:00',1.55),('14598','2014-02-01','13:15:00',1.41),('14598','2014-02-01','13:20:00',1.71),('14598','2014-02-01','13:25:00',1.87),('14598','2014-02-01','13:30:00',1.69),('14598','2014-02-01','13:35:00',1.42),('14598','2014-02-01','13:40:00',1.22),('14598','2014-02-01','13:45:00',1.16),('14598','2014-02-01','13:50:00',1.12),('14598','2014-02-01','13:55:00',1.19),('14598','2014-02-01','14:00:00',1.2),('14598','2014-02-01','14:05:00',1.14),('14598','2014-02-01','14:10:00',1.06),('14598','2014-01-30','09:35:00',1.01),('14598','2014-01-30','09:40:00',1.05),('14598','2014-01-30','09:45:00',1.81),('14598','2014-01-30','09:50:00',2.14),('14598','2014-01-30','09:55:00',2.52),('14598','2014-01-30','10:00:00',2.75),('14598','2014-01-30','10:05:00',2.69),('14598','2014-01-30','10:10:00',2.49),('14598','2014-01-30','10:15:00',2.41),('14598','2014-01-30','10:20:00',2.03),('14598','2014-01-30','10:25:00',2.65),('14598','2014-01-30','10:30:00',2.79),('14598','2014-01-30','10:35:00',2.96),('14598','2014-01-30','10:40:00',3.31),('14598','2014-01-30','10:45:00',3.05),('14598','2014-01-30','10:50:00',2.65),('14598','2014-01-30','10:55:00',2.74),('14598','2014-01-30','11:00:00',2.63),('14598','2014-01-30','11:05:00',3.16),('14598','2014-01-30','11:10:00',2.54),('14598','2014-01-30','11:15:00',3.21),('14598','2014-01-30','11:20:00',2.72),('14598','2014-01-30','11:25:00',1.96),('14598','2014-01-30','11:30:00',2.23),('14598','2014-01-30','11:35:00',1.8),('14598','2014-01-30','11:40:00',2.22),('14598','2014-01-30','11:45:00',1.97),('14598','2014-01-30','11:50:00',1.69),('14598','2014-01-30','11:55:00',1.71),('14598','2014-01-30','12:00:00',1.32),('14598','2014-01-30','12:05:00',1.62),('14598','2014-01-30','12:10:00',1.93),('14598','2014-01-30','12:15:00',1.98),('14598','2014-01-30','12:20:00',2.18),('14598','2014-01-30','12:25:00',2.65),('14598','2014-01-30','12:30:00',2.61),('14598','2014-01-30','12:35:00',2.63),('14598','2014-01-30','12:40:00',2.12),('14598','2014-01-30','12:45:00',2.47),('14598','2014-01-30','12:50:00',2.65),('14598','2014-01-30','12:55:00',2.35),('14598','2014-01-30','13:00:00',2.99),('14598','2014-01-30','13:05:00',2.88),('14598','2014-01-30','13:10:00',2.26),('14598','2014-01-30','13:15:00',1.4),('14598','2014-01-30','13:20:00',1.47),('14598','2014-01-30','13:25:00',1.15),('14598','2014-01-30','13:30:00',1.93),('14598','2014-01-30','13:35:00',2.6),('14598','2014-01-30','13:40:00',2.14),('14598','2014-01-30','13:45:00',2),('14598','2014-01-30','13:50:00',1.67),('14598','2014-01-30','13:55:00',1.43),('14598','2014-01-30','14:00:00',1.46),('14598','2014-01-30','14:05:00',1.42),('14598','2014-01-30','14:10:00',1.89),('14598','2014-01-30','14:15:00',2.29),('14598','2014-01-30','14:20:00',1.75),('14598','2014-01-30','14:25:00',1.88),('14598','2014-01-30','14:30:00',2.55),('14598','2014-01-30','14:35:00',2.24),('14598','2014-01-30','14:40:00',2.52),('14598','2014-01-30','14:45:00',2.58),('14598','2014-01-30','14:50:00',2.39),('14598','2014-01-30','14:55:00',2.24),('14598','2014-01-30','15:00:00',2.1),('14598','2014-01-30','15:05:00',2.14),('14598','2014-01-30','15:10:00',2),('14598','2014-01-30','15:15:00',2.37),('14598','2014-01-30','15:20:00',2.23),('14598','2014-01-30','15:25:00',2.06),('14598','2014-01-30','15:30:00',1.55),('14598','2014-01-30','15:35:00',1.1),('14598','2014-01-29','09:05:00',1.13),('14598','2014-01-29','09:10:00',1),('14598','2014-01-29','09:15:00',1),('14598','2014-01-29','09:25:00',1.01),('14598','2014-01-29','09:30:00',1.02),('14598','2014-01-29','09:35:00',1.02),('14598','2014-01-29','09:40:00',1.09),('14598','2014-01-29','09:45:00',1.14),('14598','2014-01-29','10:05:00',1.99),('14598','2014-01-29','10:10:00',2.61),('14598','2014-01-29','10:15:00',1.76),('14598','2014-01-29','10:20:00',2.2),('14598','2014-01-29','10:25:00',1.85),('14598','2014-01-29','10:30:00',1.82),('14598','2014-01-29','10:35:00',1.91),('14598','2014-01-29','10:40:00',1.94),('14598','2014-01-29','10:45:00',2.42),('14598','2014-01-29','10:50:00',2.21),('14598','2014-01-29','10:55:00',2.37),('14598','2014-01-29','11:00:00',2.71),('14598','2014-01-29','11:05:00',2.74),('14598','2014-01-29','11:10:00',2.12),('14598','2014-01-29','11:15:00',1.85),('14598','2014-01-29','11:20:00',1.53),('14598','2014-01-29','11:25:00',1.84),('14598','2014-01-29','11:30:00',2.4),('14598','2014-01-29','11:35:00',2.86),('14598','2014-01-29','11:40:00',3),('14598','2014-01-29','11:45:00',2.4),('14598','2014-01-29','11:50:00',1.76),('14598','2014-01-29','11:55:00',1.06),('14598','2014-01-29','12:10:00',2.01),('14598','2014-01-29','12:15:00',3.73),('14598','2014-01-29','12:20:00',3.44),('14598','2014-01-29','12:25:00',3.03),('14598','2014-01-29','12:30:00',2.93),('14598','2014-01-29','12:35:00',2.2),('14598','2014-01-29','12:40:00',1.27),('14598','2014-01-29','12:45:00',1.14),('14598','2014-01-29','12:50:00',1.4),('14598','2014-01-29','12:55:00',1.34),('14598','2014-01-29','13:00:00',1.44),('14598','2014-01-29','13:05:00',1.3),('14598','2014-01-29','13:10:00',1.55),('14598','2014-01-29','13:15:00',1.61),('14598','2014-01-29','13:30:00',2.25),('14598','2014-01-29','13:35:00',3.36),('14598','2014-01-29','13:40:00',3.45),('14598','2014-01-29','13:45:00',2.75),('14598','2014-01-29','13:50:00',1.17),('14598','2014-01-29','13:55:00',1.08),('14598','2014-01-29','14:00:00',1.26),('14598','2014-01-29','14:05:00',1.2),('14598','2014-01-29','14:45:00',1.19),('14598','2014-01-29','14:50:00',1.33),('14598','2014-01-29','14:55:00',1.66),('14598','2014-01-29','15:00:00',1.45),('14598','2014-01-29','15:05:00',1.29),('14598','2014-01-29','15:10:00',1.29),('14598','2014-01-28','09:25:00',1.15),('14598','2014-01-28','09:30:00',1.06),('14598','2014-01-28','09:35:00',1.06),('14598','2014-01-28','09:40:00',1.32),('14598','2014-01-28','09:45:00',1.39),('14598','2014-01-28','09:50:00',1.67),('14598','2014-01-28','09:55:00',1.83),('14598','2014-01-28','10:00:00',2.13),('14598','2014-01-28','10:05:00',2.32),('14598','2014-01-28','10:10:00',2.46),('14598','2014-01-28','10:15:00',2.52),('14598','2014-01-28','10:20:00',2.22),('14598','2014-01-28','10:25:00',2.08),('14598','2014-01-28','10:30:00',1.98),('14598','2014-01-28','10:35:00',1.91),('14598','2014-01-28','10:40:00',2.28),('14598','2014-01-28','10:45:00',2.2),('14598','2014-01-28','10:50:00',2.13),('14598','2014-01-28','10:55:00',2.17),('14598','2014-01-28','11:00:00',2.16),('14598','2014-01-28','11:05:00',2.47),('14598','2014-01-28','11:10:00',2.94),('14598','2014-01-28','11:15:00',2.72),('14598','2014-01-28','11:20:00',2.71),('14598','2014-01-28','11:25:00',3.2),('14598','2014-01-28','11:30:00',3.16),('14598','2014-01-28','11:35:00',2.65),('14598','2014-01-28','11:40:00',2.02),('14598','2014-01-28','11:45:00',2.87),('14598','2014-01-28','11:50:00',1.62),('14598','2014-01-28','11:55:00',1.48),('14598','2014-01-28','12:00:00',1.65),('14598','2014-01-28','12:05:00',1.66),('14598','2014-01-28','12:10:00',1.79),('14598','2014-01-28','12:15:00',1.6),('14598','2014-01-28','12:20:00',2.6),('14598','2014-01-28','12:25:00',2.69),('14598','2014-01-28','12:30:00',3.18),('14598','2014-01-28','12:35:00',2.84),('14598','2014-01-28','12:40:00',3.88),('14598','2014-01-28','12:45:00',3.61),('14598','2014-01-28','12:50:00',3.56),('14598','2014-01-28','12:55:00',3.22),('14598','2014-01-28','13:00:00',3.35),('14598','2014-01-28','13:05:00',3.64),('14598','2014-01-28','13:10:00',3.61),('14598','2014-01-28','13:15:00',3.55),('14598','2014-01-28','13:20:00',3.51),('14598','2014-01-28','13:25:00',3.47),('14598','2014-01-28','13:30:00',3.45),('14598','2014-01-28','13:35:00',3.43),('14598','2014-01-28','13:40:00',3.38),('14598','2014-01-28','13:45:00',3.36),('14598','2014-01-28','13:50:00',3.33),('14598','2014-01-28','13:55:00',3.28),('14598','2014-01-28','14:00:00',3.25),('14598','2014-01-28','14:05:00',3.21),('14598','2014-01-28','14:10:00',3.16),('14598','2014-01-28','14:15:00',3.12),('14598','2014-01-28','14:20:00',3.07),('14598','2014-01-28','14:25:00',3.02),('14598','2014-01-28','14:30:00',2.96),('14598','2014-01-28','14:35:00',2.91),('14598','2014-01-28','14:40:00',2.83),('14598','2014-01-28','14:45:00',2.77),('14598','2014-01-28','14:50:00',2.7),('14598','2014-01-28','14:55:00',2.63),('14598','2014-01-28','15:00:00',2.56),('14598','2014-01-28','15:05:00',2.51),('14598','2014-01-28','15:10:00',2.42),('14598','2014-01-28','15:15:00',2.33),('14598','2014-01-28','15:20:00',2.24),('14598','2014-01-28','15:25:00',2.17),('14598','2014-01-28','15:30:00',2.09),('14598','2014-01-28','15:35:00',2),('14598','2014-01-28','15:40:00',1.91),('14598','2014-01-28','15:45:00',1.82),('14598','2014-01-28','15:50:00',1.72),('14598','2014-01-28','15:55:00',1.62),('14598','2014-01-28','16:00:00',1.5),('14598','2014-01-28','16:05:00',1.34),('14598','2014-01-28','16:10:00',1.09),('14598','2014-01-27','09:35:00',1.09),('14598','2014-01-27','09:40:00',1.05),('14598','2014-01-27','10:55:00',1.17),('14598','2014-01-27','11:00:00',1.21),('14598','2014-01-27','12:50:00',1.15),('14598','2014-01-27','12:55:00',1.16),('15087','2014-05-05','07:45:00',1.18),('15087','2014-05-05','07:50:00',1.29),('15087','2014-05-05','07:55:00',1.43),('15087','2014-05-05','08:00:00',1.53),('15087','2014-05-05','08:05:00',1.64),('15087','2014-05-05','08:10:00',1.75),('15087','2014-05-05','08:15:00',1.86),('15087','2014-05-05','08:20:00',1.98),('15087','2014-05-05','08:25:00',2.08),('15087','2014-05-05','08:30:00',2.17),('15087','2014-05-05','08:35:00',2.29),('15087','2014-05-05','08:40:00',2.39),('15087','2014-05-05','08:45:00',2.48),('15087','2014-05-05','08:50:00',2.56),('15087','2014-05-05','08:55:00',2.65),('15087','2014-05-05','09:00:00',2.74),('15087','2014-05-05','09:05:00',2.8),('15087','2014-05-05','09:10:00',2.89),('15087','2014-05-05','09:15:00',2.98),('15087','2014-05-05','09:20:00',3.06),('15087','2014-05-05','09:25:00',3.12),('15087','2014-05-05','09:30:00',3.26),('15087','2014-05-05','09:35:00',3.33),('15087','2014-05-05','09:40:00',3.4),('15087','2014-05-05','09:45:00',3.49),('15087','2014-05-05','09:50:00',3.56),('15087','2014-05-05','09:55:00',3.65),('15087','2014-05-05','10:00:00',3.72),('15087','2014-05-05','10:05:00',3.81),('15087','2014-05-05','10:10:00',3.87),('15087','2014-05-05','10:15:00',3.92),('15087','2014-05-05','10:20:00',3.95),('15087','2014-05-05','10:25:00',4.01),('15087','2014-05-05','10:30:00',4.07),('15087','2014-05-05','10:35:00',4.13),('15087','2014-05-05','10:40:00',4.17),('15087','2014-05-05','10:45:00',4.22),('15087','2014-05-05','10:50:00',4.27),('15087','2014-05-05','10:55:00',4.3),('15087','2014-05-05','11:00:00',4.36),('15087','2014-05-05','11:05:00',4.39),('15087','2014-05-05','11:10:00',4.42),('15087','2014-05-05','11:15:00',4.52),('15087','2014-05-05','11:20:00',4.53),('15087','2014-05-05','11:25:00',4.53),('15087','2014-05-05','11:30:00',4.46),('15087','2014-05-05','11:35:00',4.57),('15087','2014-05-05','11:40:00',4.6),('15087','2014-05-05','11:45:00',4.66),('15087','2014-05-05','11:50:00',4.7),('15087','2014-05-05','11:55:00',4.33),('15087','2014-05-05','12:00:00',4.83),('15087','2014-05-05','12:05:00',3.83),('15087','2014-05-05','12:10:00',2.05),('15087','2014-05-05','12:15:00',2.52),('15087','2014-05-05','12:20:00',2.07),('15087','2014-05-05','12:25:00',2.11),('15087','2014-05-05','12:30:00',4.41),('15087','2014-05-05','12:35:00',3.72),('15087','2014-05-05','12:40:00',1.6),('15087','2014-05-05','12:45:00',2.46),('15087','2014-05-05','12:50:00',4.98),('15087','2014-05-05','12:55:00',2.26),('15087','2014-05-05','13:00:00',1.37),('15087','2014-05-05','13:05:00',2.93),('15087','2014-05-05','13:10:00',5.3),('15087','2014-05-05','13:15:00',5.12),('15087','2014-05-05','13:20:00',4.99),('15087','2014-05-05','13:25:00',4.89),('15087','2014-05-05','13:30:00',4.91),('15087','2014-05-05','13:35:00',4.93),('15087','2014-05-05','13:40:00',4.93),('15087','2014-05-05','13:45:00',4.99),('15087','2014-05-05','13:50:00',4.95),('15087','2014-05-05','13:55:00',4.94),('15087','2014-05-05','14:00:00',4.78),('15087','2014-05-05','14:05:00',3.31),('15087','2014-05-05','14:10:00',2.99),('15087','2014-05-05','14:15:00',4.61),('15087','2014-05-05','14:20:00',5.08),('15087','2014-05-05','14:25:00',5.28),('15087','2014-05-05','14:30:00',4.25),('15087','2014-05-05','14:35:00',2.92),('15087','2014-05-05','14:40:00',2.75),('15087','2014-05-05','14:45:00',1.58),('15087','2014-05-05','14:50:00',1.5),('15087','2014-05-05','14:55:00',1.74),('15087','2014-05-05','15:00:00',2.69),('15087','2014-05-05','15:05:00',3.96),('15087','2014-05-05','15:10:00',2.76),('15087','2014-05-05','15:15:00',1.4),('15087','2014-05-05','15:20:00',1.42),('15087','2014-05-05','15:25:00',1.85),('15087','2014-05-05','15:30:00',3.85),('15087','2014-05-05','15:35:00',1.85),('15087','2014-05-05','15:40:00',2.35),('15087','2014-05-05','15:45:00',3.71),('15087','2014-05-05','15:50:00',1.31),('15087','2014-05-05','15:55:00',1.25),('15087','2014-05-05','16:00:00',2.01),('15087','2014-05-05','16:05:00',2.06),('15087','2014-05-05','16:10:00',2.37),('15087','2014-05-05','16:15:00',1.36),('15087','2014-05-05','16:20:00',1.49),('15087','2014-05-05','16:25:00',1.32),('15087','2014-05-05','16:30:00',1.39),('15087','2014-05-05','16:35:00',3.38),('15087','2014-05-05','16:40:00',3.04),('15087','2014-05-05','16:45:00',2.91),('15087','2014-05-05','16:50:00',2.95),('15087','2014-05-05','16:55:00',2.69),('15087','2014-05-05','17:00:00',2.5),('15087','2014-05-05','17:05:00',2.47),('15087','2014-05-05','17:10:00',2.46),('15087','2014-05-05','17:15:00',2.38),('15087','2014-05-05','17:20:00',2.25),('15087','2014-05-05','17:25:00',2.07),('15087','2014-05-05','17:30:00',1.79),('15087','2014-05-05','17:35:00',1.79),('15087','2014-05-05','17:40:00',1.62),('15087','2014-05-05','17:45:00',1.58),('15087','2014-05-05','17:50:00',1.61),('15087','2014-05-05','17:55:00',1.45),('15087','2014-05-05','18:00:00',1.3),('15087','2014-05-05','18:05:00',1.35),('15087','2014-05-05','18:10:00',1.22),('15087','2014-05-05','18:15:00',1.12),('15087','2014-05-05','18:20:00',1.02),('15087','2014-04-26','09:05:00',1.01),('15087','2014-04-26','09:55:00',1.42),('15087','2014-04-26','10:00:00',1.54),('15087','2014-04-26','10:05:00',1.38),('15087','2014-04-26','10:10:00',1.31),('15087','2014-04-26','10:15:00',1.37),('15087','2014-04-26','10:20:00',1.56),('15087','2014-04-26','10:25:00',1.77),('15087','2014-04-26','10:30:00',2.05),('15087','2014-04-26','10:35:00',2.32),('15087','2014-04-26','10:40:00',2.32),('15087','2014-04-26','10:45:00',2.3),('15087','2014-04-26','10:50:00',2.57),('15087','2014-04-26','10:55:00',4.09),('15087','2014-04-26','11:00:00',4),('15087','2014-04-26','11:05:00',3.88),('15087','2014-04-26','11:10:00',3.64),('15087','2014-04-26','11:15:00',3.45),('15087','2014-04-26','11:20:00',3.48),('15087','2014-04-26','11:25:00',3.36),('15087','2014-04-26','11:30:00',3.49),('15087','2014-04-26','11:35:00',3.38),('15087','2014-04-26','11:40:00',3.18),('15087','2014-04-26','11:45:00',3.43),('15087','2014-04-26','11:50:00',3.42),('15087','2014-04-26','11:55:00',3.21),('15087','2014-04-26','12:00:00',3.3),('15087','2014-04-26','12:05:00',3.55),('15087','2014-04-26','12:10:00',3.55),('15087','2014-04-26','12:15:00',2.64),('15087','2014-04-26','12:20:00',3.18),('15087','2014-04-26','12:25:00',2.97),('15087','2014-04-26','12:30:00',2.44),('15087','2014-04-26','12:35:00',3.97),('15087','2014-04-26','12:40:00',3.86),('15087','2014-04-26','12:45:00',4.12),('15087','2014-04-26','12:50:00',4.14),('15087','2014-04-26','12:55:00',4.75),('15087','2014-04-26','13:00:00',4.67),('15087','2014-04-26','13:05:00',3.19),('15087','2014-04-26','13:10:00',3.6),('15087','2014-04-26','13:15:00',4.73),('15087','2014-04-26','13:20:00',5.09),('15087','2014-04-26','13:25:00',4.11),('15087','2014-04-26','13:30:00',1.56),('15087','2014-04-26','13:35:00',2.19),('15087','2014-04-26','13:40:00',5.07),('15087','2014-04-26','13:45:00',4.8),('15087','2014-04-26','13:50:00',4.65),('15087','2014-04-26','13:55:00',4.66),('15087','2014-04-26','14:00:00',3.43),('15087','2014-04-26','14:10:00',1.69),('15087','2014-04-26','14:15:00',1.52),('15087','2014-04-26','14:35:00',1.46),('15087','2014-04-26','14:40:00',2.46),('15087','2014-01-26','09:05:00',1.3),('15087','2014-01-26','09:30:00',1.61),('15087','2014-01-26','09:35:00',1.66),('15087','2014-01-26','09:45:00',1.28),('15087','2014-01-26','09:50:00',1.56),('15087','2014-01-26','09:55:00',1.12),('15087','2014-01-26','10:10:00',1.95),('15087','2014-01-26','10:15:00',2.33),('15087','2014-01-26','10:20:00',1.18),('15087','2014-01-26','10:25:00',1.05),('15087','2014-01-26','11:25:00',1.15),('15087','2014-01-26','12:15:00',1.25),('15087','2014-01-26','12:20:00',1.34),('15087','2014-01-26','12:25:00',1.47),('15087','2014-01-26','12:30:00',2.82),('15087','2014-01-26','12:35:00',2.07),('15087','2014-01-26','12:40:00',1.36),('15087','2014-01-26','12:45:00',1.15),('15087','2014-01-26','13:00:00',1.06),('15087','2014-01-26','13:05:00',1.23),('15087','2014-01-26','13:10:00',1.37),('15087','2014-01-26','13:15:00',1.54),('15087','2014-01-26','13:20:00',1.6),('15087','2014-01-26','13:25:00',1.29),('15087','2014-01-26','13:50:00',1),('15087','2014-01-26','15:45:00',1.02),('15087','2014-01-25','09:05:00',1.37),('15087','2014-01-25','09:10:00',1.27),('15087','2014-01-25','09:20:00',1.29),('15087','2014-01-25','09:50:00',1.69),('15087','2014-01-25','09:55:00',2.08),('15087','2014-01-25','10:00:00',1.21),('15087','2014-01-25','10:05:00',2.56),('15087','2014-01-25','10:10:00',2.8),('15087','2014-01-25','10:15:00',2.99),('15087','2014-01-25','10:20:00',2.91),('15087','2014-01-25','10:25:00',1.95),('15087','2014-01-25','10:30:00',1.83),('15087','2014-01-25','10:45:00',1.45),('15087','2014-01-25','10:50:00',2.19),('15087','2014-01-25','10:55:00',1.86),('15087','2014-01-25','11:00:00',1.35),('15087','2014-01-25','11:15:00',1.16),('15087','2014-01-25','11:20:00',1.2),('15087','2014-01-25','11:25:00',1.54),('15087','2014-01-25','11:30:00',3.98),('15087','2014-01-25','11:35:00',2.27),('15087','2014-01-25','11:40:00',2.01),('15087','2014-01-25','11:45:00',1.49),('15087','2014-01-25','11:50:00',1.68),('15087','2014-01-25','11:55:00',1.49),('15087','2014-01-25','12:00:00',1.7),('15087','2014-01-25','12:05:00',1.85),('15087','2014-01-25','12:10:00',1.98),('15087','2014-01-25','12:15:00',1.52),('15087','2014-01-25','12:20:00',1.98),('15087','2014-01-25','12:25:00',2.14),('15087','2014-01-25','12:30:00',2.02),('15087','2014-01-25','12:35:00',1.5),('15087','2014-01-25','12:40:00',1.88),('15087','2014-01-25','12:45:00',2.29),('15087','2014-01-25','12:50:00',2.32),('15087','2014-01-25','12:55:00',2.7),('15087','2014-01-25','13:00:00',2.73),('15087','2014-01-25','13:05:00',2.45),('15087','2014-01-25','13:10:00',2.86),('15087','2014-01-25','13:15:00',2.32),('15087','2014-01-25','13:20:00',1.15),('15087','2014-01-25','13:25:00',1.65),('15087','2014-01-25','13:30:00',1.61),('15087','2014-01-25','13:35:00',1.46),('15087','2014-01-25','13:40:00',1.02),('15087','2014-01-25','13:45:00',1.43),('15087','2014-01-25','13:50:00',1.31),('15087','2014-01-25','14:00:00',1.36),('15087','2014-01-25','14:05:00',1.44),('15087','2014-01-25','14:10:00',2.09),('15087','2014-01-25','14:15:00',1.58),('15087','2014-01-25','14:20:00',2.2),('15087','2014-01-25','14:25:00',2.25),('15087','2014-01-25','14:30:00',2.49),('15087','2014-01-25','14:35:00',2.6),('15087','2014-01-25','14:40:00',2.28),('15087','2014-01-25','14:45:00',2.37),('15087','2014-01-25','14:50:00',2.17),('15087','2014-01-25','14:55:00',1.97),('15087','2014-01-25','15:00:00',1.66),('15087','2014-01-25','15:05:00',1.64),('15087','2014-01-25','15:10:00',1.48),('15087','2014-01-25','15:15:00',1.36),('15087','2014-01-25','15:20:00',1.25),('15087','2014-01-25','15:25:00',1.12),('15087','2014-01-25','15:30:00',1.01),('15087','2014-01-24','10:05:00',1.04),('15087','2014-01-24','10:10:00',1.19),('15087','2014-01-24','10:15:00',1.83),('15087','2014-01-24','10:25:00',1.07),('15087','2014-01-24','10:30:00',1.79),('15087','2014-01-24','10:35:00',1.67),('15087','2014-01-24','10:40:00',2.29),('15087','2014-01-24','10:45:00',2.02),('15087','2014-01-24','10:50:00',1.21),('15087','2014-01-24','10:55:00',1.06),('15087','2014-01-24','11:00:00',1.12),('15087','2014-01-24','11:25:00',1.19),('15087','2014-01-24','11:30:00',1.63),('15087','2014-01-24','11:35:00',1.4),('15087','2014-01-24','11:45:00',1.96),('15087','2014-01-24','11:50:00',3.42),('15087','2014-01-24','11:55:00',3.22),('15087','2014-01-24','12:00:00',1.87),('15087','2014-01-24','12:05:00',1.49),('15087','2014-01-24','12:10:00',1.11),('15087','2014-01-24','12:25:00',1.95),('15087','2014-01-24','12:30:00',1.36),('15087','2014-01-24','12:35:00',3.02),('15087','2014-01-24','12:40:00',2.91),('15087','2014-01-24','12:45:00',1.7),('15087','2014-01-24','12:50:00',1.24),('15087','2014-01-24','12:55:00',1.69),('15087','2014-01-24','13:00:00',1.85),('15087','2014-01-24','13:05:00',2.12),('15087','2014-01-24','13:10:00',1.28),('15087','2014-01-24','13:30:00',1.22),('15087','2014-01-24','13:35:00',1.73),('15087','2014-01-24','13:40:00',1.53),('15087','2014-01-24','13:45:00',1.15),('15087','2014-01-24','13:50:00',1.03),('15087','2014-01-24','13:55:00',1.63),('15087','2014-01-24','14:00:00',1.39),('15087','2014-01-24','14:10:00',2.88),('15087','2014-01-24','14:15:00',2.45),('15087','2014-01-24','14:20:00',2.23),('15087','2014-01-24','14:25:00',1.99),('15087','2014-01-23','11:00:00',1.09),('15087','2014-01-23','11:05:00',1.08),('15087','2014-01-23','11:10:00',1.07),('15087','2014-01-23','11:15:00',1.06),('15087','2014-01-23','11:20:00',1.03),('15087','2014-01-23','12:30:00',1.07),('15087','2014-01-22','11:10:00',1.02),('15087','2014-01-22','11:20:00',1),('15087','2014-01-22','13:10:00',1.03),('15087','2014-01-22','13:15:00',1.75),('15087','2014-01-22','13:20:00',1.01),('15087','2014-01-21','10:00:00',1.25),('15087','2014-01-21','10:05:00',1.25),('15087','2014-01-21','10:55:00',1.7),('15087','2014-01-21','11:00:00',2.45),('15087','2014-01-21','11:50:00',1.05),('15087','2014-01-21','12:00:00',1),('15087','2014-01-21','12:05:00',1.8),('15087','2014-01-21','12:10:00',1.92),('15087','2014-01-21','12:15:00',1.36),('15087','2014-01-21','12:20:00',1.13),('15087','2014-01-21','12:25:00',1.55),('15087','2014-01-21','12:30:00',1.95),('15087','2014-01-21','12:35:00',1.62),('15087','2014-01-21','12:40:00',1.43),('15087','2014-01-21','12:45:00',1.3),('15087','2014-01-21','12:50:00',2),('15087','2014-01-21','13:20:00',1.03),('15087','2014-01-21','14:00:00',1.08),('15087','2014-01-21','14:05:00',1.41),('15087','2014-01-21','14:10:00',1.26),('15087','2014-01-21','14:15:00',1.02),('15087','2014-01-20','11:15:00',1),('15087','2014-01-20','11:20:00',1.75),('15087','2014-01-20','11:25:00',2.06),('15087','2014-01-20','11:30:00',2.14),('15087','2014-01-20','11:35:00',2.08),('15087','2014-01-20','11:40:00',3.1),('15087','2014-01-20','11:45:00',3.28),('15087','2014-01-20','11:50:00',1.81),('15087','2014-01-20','12:05:00',1.09),('15087','2014-01-20','12:25:00',1.03),('15087','2014-01-20','12:30:00',1.16),('15087','2014-01-20','13:15:00',1.03),('15087','2014-01-20','13:20:00',3.82),('15087','2014-01-20','13:25:00',3.32),('15087','2014-01-20','13:30:00',2.98),('15087','2014-01-20','13:35:00',2.77),('15087','2014-01-20','13:40:00',2.14),('15087','2014-01-20','13:45:00',2.35),('15087','2014-01-20','13:50:00',1.15),('15087','2014-01-20','13:55:00',1.4),('15087','2014-01-20','14:00:00',2.76),('15087','2014-01-20','14:05:00',1.63),('15087','2014-01-20','14:10:00',1.15),('15087','2014-01-19','12:00:00',1.05),('15087','2014-01-19','12:05:00',1.08),('15087','2014-01-19','12:10:00',1.03),('15087','2014-01-19','13:05:00',1.03),('15087','2014-01-19','13:10:00',1.15),('15087','2014-01-19','14:20:00',1.43),('15087','2014-01-19','14:25:00',1.65),('15087','2014-01-19','14:30:00',1.95),('15087','2014-01-19','14:35:00',1.2),('15087','2014-01-18','10:00:00',1.26),('15087','2014-01-18','10:05:00',1.83),('15087','2014-01-18','10:10:00',2.37),('15087','2014-01-18','10:15:00',2.55),('15087','2014-01-18','10:20:00',2.17),('15087','2014-01-18','10:25:00',1.64),('15087','2014-01-18','10:30:00',1.75),('15087','2014-01-18','10:35:00',1.13),('15087','2014-01-18','10:40:00',1.12),('15087','2014-01-18','10:45:00',1.26),('15087','2014-01-18','10:50:00',1.28),('15087','2014-01-18','10:55:00',1.13),('15087','2014-01-18','11:05:00',1.39),('15087','2014-01-18','11:10:00',2.34),('15087','2014-01-18','11:15:00',2.93),('15087','2014-01-18','11:20:00',2.79),('15087','2014-01-18','11:25:00',2.67),('15087','2014-01-18','11:30:00',2.74),('15087','2014-01-18','11:35:00',2.79),('15087','2014-01-18','11:40:00',2.9),('15087','2014-01-18','11:45:00',3.18),('15087','2014-01-18','11:50:00',2.91),('15087','2014-01-18','11:55:00',3.33),('15087','2014-01-18','12:00:00',3.19),('15087','2014-01-18','12:05:00',2.42),('15087','2014-01-18','12:10:00',3.02),('15087','2014-01-18','12:15:00',2.85),('15087','2014-01-18','12:20:00',2.85),('15087','2014-01-18','12:25:00',2.85),('15087','2014-01-18','12:30:00',2.86),('15087','2014-01-18','12:35:00',2.83),('15087','2014-01-18','12:40:00',2.86),('15087','2014-01-18','12:45:00',2.72),('15087','2014-01-18','12:50:00',2.33),('15087','2014-01-18','12:55:00',2.84),('15087','2014-01-18','13:00:00',1.97),('15087','2014-01-18','13:05:00',1.68),('15087','2014-01-18','13:10:00',2.26),('15087','2014-01-18','13:15:00',2.76),('15087','2014-01-18','13:20:00',1.78),('15087','2014-01-18','13:25:00',1.31),('15087','2014-01-18','13:30:00',2.35),('15087','2014-01-18','13:35:00',1.5),('15087','2014-01-18','13:40:00',2.06),('15087','2014-01-18','13:45:00',2.33),('15087','2014-01-18','13:50:00',1.71),('15087','2014-01-18','13:55:00',2.2),('15087','2014-01-18','14:00:00',2.23),('15087','2014-01-18','14:05:00',2.07),('15087','2014-01-18','14:10:00',1.93),('15087','2014-01-18','14:15:00',1.89),('15087','2014-01-18','14:20:00',1.94),('15087','2014-01-18','14:25:00',1.77),('15087','2014-01-18','14:30:00',1.7),('15087','2014-01-18','14:35:00',1.62),('15087','2014-01-18','14:40:00',1.56),('15087','2014-01-18','14:45:00',1.5),('15087','2014-01-18','14:50:00',1.39),('15087','2014-01-17','09:25:00',1.09),('15087','2014-01-17','09:30:00',1.19),('15087','2014-01-17','09:35:00',1.33),('15087','2014-01-17','09:40:00',1.6),('15087','2014-01-17','09:45:00',1.79),('15087','2014-01-17','09:50:00',1.02),('15087','2014-01-17','11:25:00',1.16),('15087','2014-01-17','11:30:00',1.76),('15087','2014-01-17','11:35:00',2.03),('15087','2014-01-17','11:40:00',1.81),('15087','2014-01-17','11:55:00',1.2),('15087','2014-01-17','12:00:00',1.48),('15087','2014-01-17','12:05:00',1.64),('15087','2014-01-17','12:10:00',1.25),('15087','2014-01-17','12:40:00',1.01),('15087','2014-01-17','12:45:00',1.16),('15087','2014-04-25','08:00:00',1.21),('15087','2014-04-25','08:05:00',1.35),('15087','2014-04-25','08:10:00',1.42),('15087','2014-04-25','08:15:00',1.43),('15087','2014-04-25','08:20:00',1.53),('15087','2014-04-25','08:25:00',1.67),('15087','2014-04-25','08:30:00',1.77),('15087','2014-04-25','08:35:00',1.84),('15087','2014-04-25','08:40:00',1.93),('15087','2014-04-25','08:45:00',2.01),('15087','2014-04-25','08:50:00',2.13),('15087','2014-04-25','08:55:00',1.33),('15087','2014-04-25','09:00:00',1.16),('15087','2014-04-25','09:05:00',1.07),('15087','2014-04-25','09:25:00',1.34),('15087','2014-04-25','09:30:00',1.12),('15087','2014-04-25','09:35:00',1.04),('15087','2014-04-25','09:45:00',1),('15087','2014-04-25','09:50:00',1.01),('15087','2014-04-25','09:55:00',1.11),('15087','2014-04-25','10:00:00',1.32),('15087','2014-04-25','10:05:00',1.25),('15087','2014-04-25','10:10:00',1.35),('15087','2014-04-25','10:15:00',1.26),('15087','2014-04-25','10:20:00',1.4),('15087','2014-04-25','10:25:00',1.45),('15087','2014-04-25','10:30:00',2.94),('15087','2014-04-25','10:35:00',3.37),('15087','2014-04-25','10:40:00',3.47),('15087','2014-04-25','10:45:00',4.25),('15087','2014-04-25','10:50:00',2.2),('15087','2014-04-25','10:55:00',3.64),('15087','2014-04-25','11:00:00',3.72),('15087','2014-04-25','11:05:00',2.47),('15087','2014-04-25','11:10:00',4.4),('15087','2014-04-25','11:15:00',4.43),('15087','2014-04-25','11:20:00',4.27),('15087','2014-04-25','11:25:00',4.41),('15087','2014-04-25','11:30:00',2.36),('15087','2014-04-25','11:35:00',3.45),('15087','2014-04-25','11:40:00',3.12),('15087','2014-04-25','11:45:00',1.41),('15087','2014-04-25','11:50:00',1.49),('15087','2014-04-25','11:55:00',4.79),('15087','2014-04-25','12:00:00',2.98),('15087','2014-04-25','12:05:00',5.09),('15087','2014-04-25','12:10:00',4.04),('15087','2014-04-25','12:15:00',1.59),('15087','2014-04-25','12:20:00',3.64),('15087','2014-04-25','12:25:00',4.28),('15087','2014-04-25','12:30:00',4.83),('15087','2014-04-25','12:35:00',4.9),('15087','2014-04-25','12:40:00',5.07),('15087','2014-04-25','12:45:00',5.15),('15087','2014-04-25','12:50:00',2.36),('15087','2014-04-25','12:55:00',2.89),('15087','2014-04-25','13:00:00',2.97),('15087','2014-04-25','13:05:00',2.39),('15087','2014-04-25','13:10:00',4.32),('15087','2014-04-25','13:15:00',2.03),('15087','2014-04-25','13:20:00',1.92),('15087','2014-04-25','13:25:00',3.32),('15087','2014-04-25','13:30:00',1.34),('15087','2014-04-25','13:35:00',1.09),('15087','2014-04-25','13:40:00',1.48),('15087','2014-04-25','13:45:00',1.32),('15087','2014-04-25','13:50:00',2.01),('15087','2014-04-25','13:55:00',2.59),('15087','2014-04-25','14:00:00',1.43),('15087','2014-04-25','14:05:00',1.52),('15087','2014-04-25','14:10:00',1.22),('15087','2014-04-25','14:15:00',1.4),('15087','2014-04-25','14:20:00',4.06),('15087','2014-04-25','14:25:00',2.22),('15087','2014-04-25','14:30:00',2.38),('15087','2014-04-25','14:35:00',4.11),('15087','2014-04-25','14:40:00',3.85),('15087','2014-04-25','14:45:00',3.81),('15087','2014-04-25','14:50:00',3.97),('15087','2014-04-25','14:55:00',3.92),('15087','2014-04-25','15:00:00',3.77),('15087','2014-04-25','15:05:00',3.79),('15087','2014-04-25','15:10:00',3.76),('15087','2014-04-25','15:15:00',3.64),('15087','2014-04-25','15:20:00',3.21),('15087','2014-04-25','15:25:00',3.17),('15087','2014-04-25','15:30:00',3.18),('15087','2014-04-25','15:35:00',3.41),('15087','2014-04-25','15:40:00',3.29),('15087','2014-04-25','15:45:00',3.17),('15087','2014-04-25','15:50:00',3.18),('15087','2014-04-25','15:55:00',3.12),('15087','2014-04-25','16:00:00',3.09),('15087','2014-04-25','16:05:00',2.88),('15087','2014-04-25','16:10:00',2.75),('15087','2014-04-25','16:15:00',2.72),('15087','2014-04-25','16:20:00',2.51),('15087','2014-04-25','16:25:00',2.55),('15087','2014-04-25','16:30:00',2.53),('15087','2014-04-25','16:35:00',2.68),('15087','2014-04-25','16:40:00',2.69),('15087','2014-04-25','16:45:00',2.56),('15087','2014-04-25','16:50:00',2.25),('15087','2014-04-25','16:55:00',1.85),('15087','2014-04-25','17:00:00',1.79),('15087','2014-04-25','17:05:00',2.13),('15087','2014-04-25','17:10:00',1.72),('15087','2014-04-25','17:15:00',1.76),('15087','2014-04-25','17:20:00',1.18),('15087','2014-04-25','17:35:00',1),('15087','2014-01-16','09:20:00',1.05),('15087','2014-01-16','09:25:00',1.21),('15087','2014-01-16','09:30:00',1.32),('15087','2014-01-16','09:35:00',1.52),('15087','2014-01-16','09:40:00',1.78),('15087','2014-01-16','09:45:00',1.65),('15087','2014-01-16','09:50:00',1.3),('15087','2014-01-16','09:55:00',1.01),('15087','2014-01-16','10:10:00',1.08),('15087','2014-01-16','10:15:00',1.37),('15087','2014-01-16','10:20:00',1.3),('15087','2014-01-16','10:25:00',1.55),('15087','2014-01-16','10:30:00',2.22),('15087','2014-01-16','10:35:00',2.8),('15087','2014-01-16','10:40:00',2.44),('15087','2014-01-16','10:45:00',1.84),('15087','2014-01-16','10:50:00',1.99),('15087','2014-01-16','10:55:00',2.17),('15087','2014-01-16','11:00:00',2.18),('15087','2014-01-16','11:05:00',2.16),('15087','2014-01-16','11:10:00',2.27),('15087','2014-01-16','11:15:00',2.18),('15087','2014-01-16','11:20:00',1.99),('15087','2014-01-16','11:25:00',2.05),('15087','2014-01-16','11:30:00',1.88),('15087','2014-01-16','11:35:00',1.8),('15087','2014-01-16','11:40:00',1.66),('15087','2014-01-16','11:45:00',1.83),('15087','2014-01-16','11:50:00',1.46),('15087','2014-01-16','11:55:00',1.54),('15087','2014-01-16','12:00:00',1.53),('15087','2014-01-16','12:05:00',1.65),('15087','2014-01-16','12:10:00',1.89),('15087','2014-01-16','12:15:00',1.76),('15087','2014-01-16','12:20:00',1.58),('15087','2014-01-16','12:25:00',1.49),('15087','2014-01-16','12:30:00',1.62),('15087','2014-01-16','12:35:00',1.98),('15087','2014-01-16','12:40:00',2.01),('15087','2014-01-16','12:45:00',2.02),('15087','2014-01-16','12:50:00',2.19),('15087','2014-01-16','12:55:00',2.19),('15087','2014-01-16','13:00:00',2.26),('15087','2014-01-16','13:05:00',1.98),('15087','2014-01-16','13:10:00',2.25),('15087','2014-01-16','13:15:00',1.85),('15087','2014-01-16','13:20:00',1.64),('15087','2014-01-16','13:25:00',1.93),('15087','2014-01-16','13:30:00',1.15),('15087','2014-01-16','13:35:00',1.05),('15087','2014-01-16','13:40:00',1.57),('15087','2014-01-16','13:45:00',2.06),('15087','2014-01-16','13:50:00',1.9),('15087','2014-01-16','13:55:00',2.05),('15087','2014-01-16','14:00:00',1.08),('15087','2014-01-16','14:05:00',1.09),('15087','2014-01-16','14:10:00',1.03),('15087','2014-01-15','10:15:00',1.56),('15087','2014-01-15','10:20:00',2.04),('15087','2014-01-15','10:25:00',2.25),('15087','2014-01-15','10:30:00',1.86),('15087','2014-01-15','10:35:00',1.56),('15087','2014-01-15','10:40:00',2.02),('15087','2014-01-15','10:45:00',1.67),('15087','2014-01-15','10:50:00',1.04),('15087','2014-01-15','10:55:00',1.09),('15087','2014-01-15','11:00:00',1.47),('15087','2014-01-15','11:05:00',2),('15087','2014-01-15','11:10:00',2.57),('15087','2014-01-15','11:15:00',2.71),('15087','2014-01-15','11:20:00',2.6),('15087','2014-01-15','11:25:00',2.42),('15087','2014-01-15','11:30:00',2.1),('15087','2014-01-15','11:35:00',1.25),('15087','2014-01-15','11:40:00',2.1),('15087','2014-01-15','11:45:00',2.41),('15087','2014-01-15','11:50:00',2.42),('15087','2014-01-15','11:55:00',2.1),('15087','2014-01-15','12:00:00',2.04),('15087','2014-01-15','12:05:00',1.77),('15087','2014-01-15','12:10:00',1.71),('15087','2014-01-15','12:15:00',1.99),('15087','2014-01-15','12:20:00',2.6),('15087','2014-01-15','12:25:00',2.05),('15087','2014-01-15','12:30:00',1.46),('15087','2014-01-15','12:35:00',1.72),('15087','2014-01-15','12:40:00',1.43),('15087','2014-01-15','12:45:00',1.54),('15087','2014-01-15','12:50:00',1.61),('15087','2014-01-15','12:55:00',1.4),('15087','2014-01-15','13:00:00',1.3),('15087','2014-01-15','13:05:00',1.4),('15087','2014-01-15','13:10:00',1.88),('15087','2014-01-15','13:15:00',2.66),('15087','2014-01-15','13:20:00',2.71),('15087','2014-01-15','13:25:00',2.69),('15087','2014-01-15','13:30:00',2.48),('15087','2014-01-15','13:35:00',2.09),('15087','2014-01-15','13:40:00',2.24),('15087','2014-01-15','13:45:00',2.21),('15087','2014-01-15','13:50:00',1.9),('15087','2014-01-15','13:55:00',1.03),('15087','2014-01-15','14:00:00',1.87),('15087','2014-01-15','14:05:00',1.85),('15087','2014-01-15','14:10:00',1.97),('15087','2014-01-15','14:15:00',1.7),('15087','2014-01-15','14:20:00',1.76),('15087','2014-01-15','14:25:00',1.77),('15087','2014-01-15','14:30:00',1.73),('15087','2014-01-15','14:35:00',1.67),('15087','2014-01-15','14:40:00',1.68),('15087','2014-01-15','14:45:00',1.65),('15087','2014-01-15','14:50:00',1.43),('15087','2014-01-15','14:55:00',1.33),('15087','2014-01-15','15:00:00',1.23),('15087','2014-01-15','15:05:00',1.12),('15087','2014-01-15','15:10:00',1.03),('15087','2014-01-14','10:25:00',1.71),('15087','2014-01-14','10:30:00',2.92),('15087','2014-01-14','10:35:00',2.95),('15087','2014-01-14','10:40:00',2.52),('15087','2014-01-14','10:45:00',2.36),('15087','2014-01-14','10:50:00',1.42),('15087','2014-01-14','10:55:00',1.24),('15087','2014-01-14','11:00:00',1.59),('15087','2014-01-14','11:05:00',1.15),('15087','2014-01-14','11:30:00',1.02),('15087','2014-01-14','11:35:00',1.14),('15087','2014-01-14','11:40:00',1.35),('15087','2014-01-13','09:30:00',1.01),('15087','2014-01-13','09:35:00',1.14),('15087','2014-01-13','09:40:00',1.23),('15087','2014-01-13','09:45:00',1.33),('15087','2014-01-13','09:50:00',1.43),('15087','2014-01-13','09:55:00',1.51),('15087','2014-01-13','10:00:00',1.62),('15087','2014-01-13','10:05:00',1.71),('15087','2014-01-13','10:10:00',1.77),('15087','2014-01-13','10:15:00',1.84),('15087','2014-01-13','10:20:00',1.93),('15087','2014-01-13','10:25:00',1.99),('15087','2014-01-13','10:30:00',2.05),('15087','2014-01-13','10:35:00',2.1),('15087','2014-01-13','10:40:00',2.18),('15087','2014-01-13','10:45:00',2.21),('15087','2014-01-13','10:50:00',2.23),('15087','2014-01-13','10:55:00',2.3),('15087','2014-01-13','11:00:00',2.36),('15087','2014-01-13','11:05:00',2.39),('15087','2014-01-13','11:10:00',2.44),('15087','2014-01-13','11:15:00',2.49),('15087','2014-01-13','11:20:00',2.49),('15087','2014-01-13','11:25:00',2.51),('15087','2014-01-13','11:30:00',2.53),('15087','2014-01-13','11:35:00',2.55),('15087','2014-01-13','11:40:00',2.57),('15087','2014-01-13','11:45:00',2.55),('15087','2014-01-13','11:50:00',2.52),('15087','2014-01-13','11:55:00',2.53),('15087','2014-01-13','12:00:00',2.55),('15087','2014-01-13','12:05:00',2.52),('15087','2014-01-13','12:10:00',2.53),('15087','2014-01-13','12:15:00',2.54),('15087','2014-01-13','12:20:00',2.55),('15087','2014-01-13','12:25:00',2.55),('15087','2014-01-13','12:30:00',2.54),('15087','2014-01-13','12:35:00',2.49),('15087','2014-01-13','12:40:00',2.39),('15087','2014-01-13','12:45:00',2.24),('15087','2014-01-13','12:50:00',2.23),('15087','2014-01-13','12:55:00',2.06),('15087','2014-01-13','13:00:00',2.04),('15087','2014-01-13','13:05:00',2.15),('15087','2014-01-13','13:10:00',2.18),('15087','2014-01-13','13:15:00',2.12),('15087','2014-01-13','13:20:00',2.1),('15087','2014-01-13','13:25:00',2.12),('15087','2014-01-13','13:30:00',2.01),('15087','2014-01-13','13:35:00',1.93),('15087','2014-01-13','13:40:00',1.86),('15087','2014-01-13','13:45:00',1.8),('15087','2014-01-13','13:50:00',1.82),('15087','2014-01-13','13:55:00',1.8),('15087','2014-01-13','14:00:00',1.73),('15087','2014-01-13','14:05:00',1.68),('15087','2014-01-13','14:10:00',1.71),('15087','2014-01-13','14:15:00',1.63),('15087','2014-01-13','14:20:00',1.6),('15087','2014-01-13','14:25:00',1.53),('15087','2014-01-13','14:30:00',1.47),('15087','2014-01-13','14:35:00',1.36),('15087','2014-01-13','14:40:00',1.31),('15087','2014-01-13','14:45:00',1.24),('15087','2014-01-13','14:50:00',1.07),('15087','2014-01-13','14:55:00',1),('15087','2014-01-12','10:20:00',1.12),('15087','2014-01-12','10:25:00',1.06),('15087','2014-01-12','10:30:00',1.07),('15087','2014-01-12','10:35:00',1.26),('15087','2014-01-12','10:40:00',1.44),('15087','2014-01-12','10:45:00',1.42),('15087','2014-01-12','10:50:00',1.55),('15087','2014-01-12','10:55:00',1.69),('15087','2014-01-12','11:00:00',1.61),('15087','2014-01-12','11:05:00',1.69),('15087','2014-01-12','11:10:00',2.02),('15087','2014-01-12','11:15:00',1.77),('15087','2014-01-12','11:20:00',1.59),('15087','2014-01-12','11:25:00',1.58),('15087','2014-01-12','11:30:00',1.66),('15087','2014-01-12','11:35:00',1.46),('15087','2014-01-12','11:40:00',1.91),('15087','2014-01-12','11:45:00',2.15),('15087','2014-01-12','11:50:00',2.11),('15087','2014-01-12','11:55:00',1.93),('15087','2014-01-12','12:00:00',1.54),('15087','2014-01-12','12:05:00',1.54),('15087','2014-01-12','12:10:00',1.31),('15087','2014-01-12','12:15:00',1.24),('15087','2014-01-12','12:20:00',1.23),('15087','2014-01-12','12:25:00',1.18),('15087','2014-01-12','12:30:00',1.23),('15087','2014-01-12','12:35:00',1.27),('15087','2014-01-12','12:40:00',1.39),('15087','2014-01-12','12:45:00',1.3),('15087','2014-01-12','12:50:00',1.39),('15087','2014-01-12','12:55:00',1.31),('15087','2014-01-12','13:00:00',1.33),('15087','2014-01-12','13:05:00',1.2),('15087','2014-01-12','13:10:00',1.13),('15087','2014-01-12','13:15:00',1.1),('15087','2014-01-12','13:20:00',1.16),('15087','2014-01-12','13:25:00',1.22),('15087','2014-01-12','13:30:00',1.43),('15087','2014-01-12','13:35:00',1.27),('15087','2014-01-12','13:40:00',1.13),('15087','2014-01-11','09:55:00',1.33),('15087','2014-01-11','10:00:00',1.44),('15087','2014-01-11','10:05:00',1.15),('15087','2014-01-11','10:10:00',1.14),('15087','2014-01-11','10:15:00',1.3),('15087','2014-01-11','10:20:00',1.36),('15087','2014-01-11','10:25:00',1.64),('15087','2014-01-11','10:30:00',1.64),('15087','2014-01-11','10:35:00',1.72),('15087','2014-01-11','10:40:00',2.19),('15087','2014-01-11','10:45:00',2.31),('15087','2014-01-11','10:50:00',2.34),('15087','2014-01-11','10:55:00',2.35),('15087','2014-01-11','11:00:00',2.29),('15087','2014-01-11','11:05:00',2.25),('15087','2014-01-11','11:10:00',2.38),('15087','2014-01-11','11:15:00',2.15),('15087','2014-01-11','11:20:00',1.99),('15087','2014-01-11','11:25:00',2.05),('15087','2014-01-11','11:30:00',2.05),('15087','2014-01-11','11:35:00',1.82),('15087','2014-01-11','11:40:00',1.65),('15087','2014-01-11','11:45:00',1.71),('15087','2014-01-11','11:50:00',1.89),('15087','2014-01-11','11:55:00',1.91),('15087','2014-01-11','12:00:00',1.98),('15087','2014-01-11','12:05:00',2.2),('15087','2014-01-11','12:10:00',2.02),('15087','2014-01-11','12:15:00',1.99),('15087','2014-01-11','12:20:00',2),('15087','2014-01-11','12:25:00',1.86),('15087','2014-01-11','12:30:00',1.71),('15087','2014-01-11','12:35:00',1.53),('15087','2014-01-11','12:40:00',1.37),('15087','2014-01-11','12:45:00',1.69),('15087','2014-01-11','12:50:00',2),('15087','2014-01-11','12:55:00',2.04),('15087','2014-01-11','13:00:00',2.02),('15087','2014-01-11','13:05:00',1.86),('15087','2014-01-11','13:10:00',1.62),('15087','2014-01-11','13:15:00',2.02),('15087','2014-01-11','13:20:00',1.75),('15087','2014-01-11','13:25:00',1.48),('15087','2014-01-11','13:30:00',1.13),('15087','2014-01-11','13:35:00',1.13),('15087','2014-01-11','13:40:00',1.09),('15087','2014-01-11','13:45:00',1.24),('15087','2014-01-11','13:55:00',1.06),('15087','2014-01-11','14:00:00',1.46),('15087','2014-01-11','14:05:00',1.53),('15087','2014-01-11','14:10:00',1.22),('15087','2014-01-10','13:05:00',1),('15087','2014-01-09','09:30:00',1.1),('15087','2014-01-09','09:35:00',1.08),('15087','2014-01-09','09:40:00',1.29),('15087','2014-01-09','09:45:00',1.67),('15087','2014-01-09','09:50:00',1.76),('15087','2014-01-09','09:55:00',1.74),('15087','2014-01-09','10:00:00',1.81),('15087','2014-01-09','10:05:00',1.76),('15087','2014-01-09','10:10:00',1.63),('15087','2014-01-09','10:15:00',1.66),('15087','2014-01-09','10:20:00',1.71),('15087','2014-01-09','10:25:00',1.86),('15087','2014-01-09','10:30:00',1.9),('15087','2014-01-09','10:35:00',1.98),('15087','2014-01-09','10:40:00',2.24),('15087','2014-01-09','10:45:00',1.92),('15087','2014-01-09','10:50:00',1.19),('15087','2014-01-09','10:55:00',1.24),('15087','2014-01-09','11:00:00',1.39),('15087','2014-01-09','11:05:00',1.33),('15087','2014-01-09','11:10:00',1.15),('15087','2014-01-09','11:15:00',1.23),('15087','2014-01-09','11:20:00',1.52),('15087','2014-01-09','11:25:00',1.41),('15087','2014-01-09','11:30:00',1.31),('15087','2014-01-09','11:35:00',1.76),('15087','2014-01-09','11:40:00',1.75),('15087','2014-01-09','11:45:00',1.13),('15087','2014-01-09','13:15:00',1.05),('15087','2014-01-08','09:40:00',1.09),('15087','2014-01-08','09:45:00',1.21),('15087','2014-01-08','09:50:00',1.28),('15087','2014-01-08','09:55:00',1.43),('15087','2014-01-08','10:00:00',1.53),('15087','2014-01-08','10:05:00',1.5),('15087','2014-01-08','10:10:00',1.6),('15087','2014-01-08','10:15:00',1.66),('15087','2014-01-08','10:20:00',1.79),('15087','2014-01-08','10:25:00',1.95),('15087','2014-01-08','10:30:00',2.02),('15087','2014-01-08','10:35:00',1.97),('15087','2014-01-08','10:40:00',1.96),('15087','2014-01-08','10:45:00',2.13),('15087','2014-01-08','10:50:00',2.21),('15087','2014-01-08','10:55:00',2.24),('15087','2014-01-08','11:00:00',2.3),('15087','2014-01-08','11:05:00',2.35),('15087','2014-01-08','11:10:00',2.39),('15087','2014-01-08','11:15:00',2.43),('15087','2014-01-08','11:20:00',2.45),('15087','2014-01-08','11:25:00',2.45),('15087','2014-01-08','11:30:00',2.49),('15087','2014-01-08','11:35:00',2.58),('15087','2014-01-08','11:40:00',2.61),('15087','2014-01-08','11:45:00',2.61),('15087','2014-01-08','11:50:00',2.6),('15087','2014-01-08','11:55:00',2.56),('15087','2014-01-08','12:00:00',2.57),('15087','2014-01-08','12:05:00',2.5),('15087','2014-01-08','12:10:00',2.52),('15087','2014-01-08','12:15:00',2.54),('15087','2014-01-08','12:20:00',2.53),('15087','2014-01-08','12:25:00',2.51),('15087','2014-01-08','12:30:00',2.53),('15087','2014-01-08','12:35:00',2.53),('15087','2014-01-08','12:40:00',2.29),('15087','2014-01-08','12:45:00',2.29),('15087','2014-01-08','12:50:00',2.22),('15087','2014-01-08','12:55:00',2.11),('15087','2014-01-08','13:00:00',2.29),('15087','2014-01-08','13:05:00',2.1),('15087','2014-01-08','13:10:00',1.99),('15087','2014-01-08','13:15:00',2.07),('15087','2014-01-08','13:20:00',1.96),('15087','2014-01-08','13:25:00',1.84),('15087','2014-01-08','13:30:00',1.91),('15087','2014-01-08','13:35:00',1.8),('15087','2014-01-08','13:40:00',1.74),('15087','2014-01-08','13:45:00',1.81),('15087','2014-01-08','13:50:00',1.78),('15087','2014-01-08','13:55:00',1.66),('15087','2014-01-08','14:00:00',1.71),('15087','2014-01-08','14:05:00',1.66),('15087','2014-01-08','14:10:00',1.63),('15087','2014-01-08','14:15:00',1.6),('15087','2014-01-08','14:20:00',1.58),('15087','2014-01-08','14:25:00',1.52),('15087','2014-01-08','14:30:00',1.44),('15087','2014-01-08','14:35:00',1.35),('15087','2014-01-08','14:40:00',1.21),('15087','2014-01-08','14:45:00',1.07),('15087','2014-01-07','09:35:00',1.05),('15087','2014-01-07','09:40:00',1.13),('15087','2014-01-07','09:45:00',1.2),('15087','2014-01-07','09:50:00',1.26),('15087','2014-01-07','09:55:00',1.41),('15087','2014-01-07','10:00:00',1.57),('15087','2014-01-07','10:05:00',1.67),('15087','2014-01-07','10:10:00',1.76),('15087','2014-01-07','10:15:00',1.85),('15087','2014-01-07','10:20:00',1.93),('15087','2014-01-07','10:25:00',2),('15087','2014-01-07','10:30:00',2.05),('15087','2014-01-07','10:35:00',2.09),('15087','2014-01-07','10:40:00',2.14),('15087','2014-01-07','10:45:00',2.2),('15087','2014-01-07','10:50:00',2.27),('15087','2014-01-07','10:55:00',2.32),('15087','2014-01-07','11:00:00',2.38),('15087','2014-01-07','11:05:00',2.42),('15087','2014-01-07','11:10:00',2.48),('15087','2014-01-07','11:15:00',2.51),('15087','2014-01-07','11:20:00',2.55),('15087','2014-01-07','11:25:00',2.57),('15087','2014-01-07','11:30:00',2.58),('15087','2014-01-07','11:35:00',2.61),('15087','2014-01-07','11:40:00',2.64),('15087','2014-01-07','11:45:00',2.65),('15087','2014-01-07','11:50:00',2.66),('15087','2014-01-07','11:55:00',2.66),('15087','2014-01-07','12:00:00',2.68),('15087','2014-01-07','12:05:00',2.66),('15087','2014-01-07','12:10:00',2.64),('15087','2014-01-07','12:15:00',2.65),('15087','2014-01-07','12:20:00',2.64),('15087','2014-01-07','12:25:00',2.62),('15087','2014-01-07','12:30:00',2.6),('15087','2014-01-07','12:35:00',2.53),('15087','2014-01-07','12:40:00',2.34),('15087','2014-01-07','12:45:00',2.51),('15087','2014-01-07','12:50:00',2.38),('15087','2014-01-07','12:55:00',2.19),('15087','2014-01-07','13:00:00',2.27),('15087','2014-01-07','13:05:00',2.06),('15087','2014-01-07','13:10:00',1.99),('15087','2014-01-07','13:15:00',2.13),('15087','2014-01-07','13:20:00',1.98),('15087','2014-01-07','13:25:00',1.86),('15087','2014-01-07','13:30:00',1.9),('15087','2014-01-07','13:35:00',1.81),('15087','2014-01-07','13:40:00',1.8),('15087','2014-01-07','13:45:00',1.94),('15087','2014-01-07','13:50:00',1.95),('15087','2014-01-07','13:55:00',1.87),('15087','2014-01-07','14:00:00',1.74),('15087','2014-01-07','14:05:00',1.66),('15087','2014-01-07','14:10:00',1.61),('15087','2014-01-07','14:15:00',1.58),('15087','2014-01-07','14:20:00',1.52),('15087','2014-01-07','14:25:00',1.42),('15087','2014-01-07','14:30:00',1.3),('15087','2014-01-07','14:35:00',1.25),('15087','2014-01-07','14:40:00',1.15),('15087','2014-01-07','14:45:00',1.01),('15087','2014-04-24','07:50:00',1.04),('15087','2014-04-24','07:55:00',1.13),('15087','2014-04-24','08:10:00',1.36),('15087','2014-04-24','08:15:00',1.47),('15087','2014-04-24','08:20:00',1.57),('15087','2014-04-24','08:25:00',1.71),('15087','2014-04-24','08:30:00',1.55),('15087','2014-04-24','08:35:00',1.93),('15087','2014-04-24','08:40:00',2.01),('15087','2014-04-24','08:45:00',2.1),('15087','2014-04-24','08:50:00',1.72),('15087','2014-04-24','08:55:00',2.29),('15087','2014-04-24','09:00:00',2.36),('15087','2014-04-24','09:05:00',2.44),('15087','2014-04-24','09:10:00',1.95),('15087','2014-04-24','09:15:00',2.61),('15087','2014-04-24','09:20:00',2.7),('15087','2014-04-24','09:25:00',2.78),('15087','2014-04-24','09:30:00',2.4),('15087','2014-04-24','09:35:00',2.69),('15087','2014-04-24','09:40:00',3.01),('15087','2014-04-24','09:45:00',3.08),('15087','2014-04-24','09:50:00',3.14),('15087','2014-04-24','09:55:00',3.22),('15087','2014-04-24','10:00:00',3.3),('15087','2014-04-24','10:05:00',3.36),('15087','2014-04-24','10:10:00',3.4),('15087','2014-04-24','10:15:00',3.46),('15087','2014-04-24','10:20:00',3.54),('15087','2014-04-24','10:25:00',3.6),('15087','2014-04-24','10:30:00',3.62),('15087','2014-04-24','10:35:00',3.71),('15087','2014-04-24','10:40:00',3.77),('15087','2014-04-24','10:45:00',3.82),('15087','2014-04-24','10:50:00',3.88),('15087','2014-04-24','10:55:00',3.91),('15087','2014-04-24','11:00:00',3.86),('15087','2014-04-24','11:05:00',3.94),('15087','2014-04-24','11:10:00',4),('15087','2014-04-24','11:15:00',4.07),('15087','2014-04-24','11:20:00',4.1),('15087','2014-04-24','11:25:00',4.15),('15087','2014-04-24','11:30:00',4.15),('15087','2014-04-24','11:35:00',4.19),('15087','2014-04-24','11:40:00',4.23),('15087','2014-04-24','11:45:00',4.26),('15087','2014-04-24','11:50:00',4.23),('15087','2014-04-24','11:55:00',4.26),('15087','2014-04-24','12:00:00',4.34),('15087','2014-04-24','12:05:00',4.42),('15087','2014-04-24','12:10:00',3.93),('15087','2014-04-24','12:15:00',4.56),('15087','2014-04-24','12:20:00',4.52),('15087','2014-04-24','12:25:00',4.52),('15087','2014-04-24','12:30:00',4.6),('15087','2014-04-24','12:35:00',4.55),('15087','2014-04-24','12:40:00',4.58),('15087','2014-04-24','12:45:00',4.45),('15087','2014-04-24','12:50:00',4.47),('15087','2014-04-24','12:55:00',4.61),('15087','2014-04-24','13:00:00',4.59),('15087','2014-04-24','13:05:00',4.53),('15087','2014-04-24','13:10:00',4.61),('15087','2014-04-24','13:15:00',4.72),('15087','2014-04-24','13:20:00',4.67),('15087','2014-04-24','13:25:00',4.68),('15087','2014-04-24','13:30:00',3.04),('15087','2014-04-24','13:35:00',1.89),('15087','2014-04-24','13:40:00',1.16),('15087','2014-04-24','13:45:00',1.48),('15087','2014-04-24','13:50:00',5.11),('15087','2014-04-24','13:55:00',5.13),('15087','2014-04-24','14:00:00',4.91),('15087','2014-04-24','14:05:00',5.03),('15087','2014-04-24','14:10:00',4.73),('15087','2014-04-24','14:15:00',3.76),('15087','2014-04-24','14:20:00',4.76),('15087','2014-04-24','14:25:00',4.44),('15087','2014-04-24','14:30:00',4),('15087','2014-04-24','14:35:00',3.72),('15087','2014-04-24','14:40:00',2.9),('15087','2014-04-24','14:45:00',2.46),('15087','2014-04-24','14:50:00',2.39),('15087','2014-04-24','14:55:00',4.78),('15087','2014-04-24','15:00:00',4.28),('15087','2014-04-24','15:05:00',4.39),('15087','2014-04-24','15:10:00',4.62),('15087','2014-04-24','15:15:00',4.57),('15087','2014-04-24','15:20:00',3.3),('15087','2014-04-24','15:25:00',2.38),('15087','2014-04-24','15:30:00',2.86),('15087','2014-04-24','15:35:00',2.82),('15087','2014-04-24','15:40:00',2.61),('15087','2014-04-24','15:45:00',2.29),('15087','2014-04-24','15:50:00',2.57),('15087','2014-04-24','15:55:00',2.68),('15087','2014-04-24','16:00:00',3.84),('15087','2014-04-24','16:05:00',3.54),('15087','2014-04-24','16:10:00',2.88),('15087','2014-04-24','16:15:00',3.66),('15087','2014-04-24','16:20:00',3.08),('15087','2014-04-24','16:25:00',2.81),('15087','2014-04-24','16:30:00',3.08),('15087','2014-04-24','16:35:00',1.99),('15087','2014-04-24','16:40:00',2.09),('15087','2014-04-24','16:45:00',1.61),('15087','2014-04-24','16:50:00',1.37),('15087','2014-04-24','16:55:00',1.37),('15087','2014-04-24','17:00:00',1.41),('15087','2014-04-24','17:05:00',1.3),('15087','2014-04-24','17:10:00',1.23),('15087','2014-04-24','17:15:00',1.09),('15087','2014-04-24','17:20:00',1.07),('15087','2014-04-24','17:25:00',1.07),('15087','2014-04-24','17:30:00',1.08),('15087','2014-01-06','11:15:00',1.06),('15087','2014-01-06','11:20:00',1.02),('15087','2014-01-06','11:35:00',1.26),('15087','2014-01-06','11:40:00',2.61),('15087','2014-01-06','11:45:00',2.74),('15087','2014-01-06','11:50:00',2.62),('15087','2014-01-06','11:55:00',2.72),('15087','2014-01-06','12:00:00',2.78),('15087','2014-01-06','12:05:00',2.72),('15087','2014-01-06','12:10:00',2.66),('15087','2014-01-06','12:15:00',2.64),('15087','2014-01-06','12:20:00',2.63),('15087','2014-01-06','12:25:00',2.62),('15087','2014-01-06','12:30:00',2.62),('15087','2014-01-06','12:35:00',2.58),('15087','2014-01-06','12:40:00',2.52),('15087','2014-01-06','12:45:00',2.53),('15087','2014-01-06','12:50:00',2.44),('15087','2014-01-06','12:55:00',2.44),('15087','2014-01-06','13:00:00',2.32),('15087','2014-01-06','13:05:00',2.14),('15087','2014-01-06','13:10:00',2.31),('15087','2014-01-06','13:15:00',2.32),('15087','2014-01-06','13:20:00',2.11),('15087','2014-01-06','13:25:00',2.16),('15087','2014-01-06','13:30:00',1.92),('15087','2014-01-06','13:35:00',1.87),('15087','2014-01-06','13:40:00',1.92),('15087','2014-01-06','13:45:00',1.74),('15087','2014-01-06','13:50:00',1.75),('15087','2014-01-06','13:55:00',1.8),('15087','2014-01-06','14:00:00',1.5),('15087','2014-01-06','14:15:00',1.73),('15087','2014-01-06','14:20:00',1.43),('15087','2014-01-06','14:35:00',1.24),('15087','2014-01-06','14:40:00',1.37),('15087','2014-01-06','14:45:00',1.51),('15087','2014-01-06','14:50:00',1.14),('15087','2014-01-03','09:35:00',1.13),('15087','2014-01-03','09:40:00',1.43),('15087','2014-01-03','09:45:00',1.38),('15087','2014-01-03','09:50:00',1.04),('15087','2014-01-03','09:55:00',1),('15087','2014-01-03','10:00:00',1.58),('15087','2014-01-03','10:05:00',1.26),('15087','2014-01-03','10:10:00',1.6),('15087','2014-01-03','10:15:00',1.22),('15087','2014-01-03','10:20:00',1.58),('15087','2014-01-03','10:40:00',1.01),('15087','2014-01-03','10:45:00',1.22),('15087','2014-01-03','10:50:00',1.14),('15087','2014-01-03','11:35:00',1.15),('15087','2014-01-03','11:40:00',1.32),('15087','2014-01-03','11:45:00',1.39),('15087','2014-01-03','11:50:00',1.29),('15087','2014-01-03','11:55:00',1.3),('15087','2014-01-03','12:00:00',1.78),('15087','2014-01-03','12:05:00',1.92),('15087','2014-01-03','12:10:00',2.14),('15087','2014-01-03','12:15:00',2.94),('15087','2014-01-03','12:20:00',2.8),('15087','2014-01-03','12:25:00',2.37),('15087','2014-01-03','12:30:00',2.16),('15087','2014-01-03','12:35:00',1.79),('15087','2014-01-03','12:40:00',1.85),('15087','2014-01-03','12:45:00',1.8),('15087','2014-01-03','12:50:00',1.65),('15087','2014-01-03','12:55:00',1.46),('15087','2014-01-03','13:00:00',1.08),('15087','2014-01-03','13:05:00',1.73),('15087','2014-01-03','13:10:00',1.38),('15087','2014-01-03','13:15:00',1.17),('15087','2014-01-03','13:30:00',1.32),('15087','2014-01-03','13:35:00',1.63),('15087','2014-01-03','13:40:00',1.27),('15087','2014-01-03','13:45:00',1.1),('15087','2014-01-02','09:40:00',1.05),('15087','2014-01-02','09:45:00',1.11),('15087','2014-01-02','09:50:00',1.18),('15087','2014-01-02','09:55:00',1.21),('15087','2014-01-02','10:00:00',1.43),('15087','2014-01-02','10:05:00',1.51),('15087','2014-01-02','10:10:00',1.61),('15087','2014-01-02','10:15:00',1.73),('15087','2014-01-02','10:20:00',1.81),('15087','2014-01-02','10:25:00',1.89),('15087','2014-01-02','10:30:00',1.95),('15087','2014-01-02','10:35:00',1.98),('15087','2014-01-02','10:40:00',2.02),('15087','2014-01-02','10:45:00',2.08),('15087','2014-01-02','10:50:00',2.17),('15087','2014-01-02','10:55:00',2.3),('15087','2014-01-02','11:00:00',2.22),('15087','2014-01-02','11:05:00',2.28),('15087','2014-01-02','11:10:00',1.68),('15087','2014-01-02','11:15:00',1.38),('15087','2014-01-02','11:20:00',1.53),('15087','2014-01-02','11:25:00',1.66),('15087','2014-01-02','11:30:00',1.79),('15087','2014-01-02','11:35:00',2.31),('15087','2014-01-02','11:40:00',1.93),('15087','2014-01-02','11:45:00',1.71),('15087','2014-01-02','11:50:00',1.32),('15087','2014-01-02','11:55:00',1.23),('15087','2014-01-02','12:00:00',1.09),('15087','2014-01-02','12:05:00',1.16),('15087','2014-01-02','12:10:00',1.09),('15087','2014-01-02','12:50:00',1.53),('15087','2014-01-02','12:55:00',1.48),('15087','2014-01-02','13:30:00',1.27),('15087','2014-01-02','13:35:00',1.96),('15087','2014-01-02','13:40:00',1.85),('15087','2014-01-02','13:45:00',1.07),('15087','2014-01-01','09:35:00',1.21),('15087','2014-01-01','09:40:00',1.07),('15087','2014-01-01','09:45:00',1.25),('15087','2014-01-01','09:50:00',1.83),('15087','2014-01-01','09:55:00',1.42),('15087','2014-01-01','10:00:00',1.3),('15087','2014-01-01','10:05:00',1.08),('15087','2014-01-01','12:00:00',1.07),('15087','2014-01-01','12:05:00',1.12),('15087','2014-01-01','12:10:00',1.19),('15087','2014-01-01','12:15:00',1.22),('15087','2014-01-01','12:20:00',1.26),('15087','2014-01-01','12:25:00',1.27),('15087','2014-01-01','12:30:00',1.26),('15087','2014-01-01','12:35:00',1.28),('15087','2014-01-01','12:40:00',1.17),('15087','2014-01-01','12:45:00',1.2),('15087','2014-01-01','12:50:00',1.22),('15087','2014-01-01','12:55:00',1.21),('15087','2014-01-01','13:00:00',1.19),('15087','2014-01-01','13:05:00',1.09),('15087','2014-01-01','13:10:00',1.05),('15087','2014-01-01','13:15:00',1.04),('15087','2014-01-01','13:20:00',1.13),('15087','2014-01-01','13:25:00',1.31),('15087','2014-01-01','13:30:00',1.25),('15087','2014-01-01','13:35:00',1.29),('15087','2014-01-01','13:40:00',1.26),('15087','2014-01-01','13:45:00',1.13),('15087','2014-01-01','13:50:00',1.54),('15087','2014-01-01','13:55:00',1.48),('15087','2014-01-01','14:00:00',1.42),('15087','2014-01-01','14:05:00',1.06),('15087','2014-01-01','14:10:00',1.05),('15087','2014-01-01','14:15:00',1.17),('15087','2014-01-01','15:05:00',1.03),('15087','2013-12-31','09:30:00',1.08),('15087','2013-12-31','09:35:00',1.18),('15087','2013-12-31','09:40:00',1.08),('15087','2013-12-31','09:50:00',1.45),('15087','2013-12-31','09:55:00',1.08),('15087','2013-12-31','10:00:00',1.04),('15087','2013-12-31','10:05:00',1.02),('15087','2013-12-31','10:50:00',1.28),('15087','2013-12-31','10:55:00',1.36),('15087','2013-12-31','11:00:00',1.25),('15087','2013-12-31','11:05:00',1.29),('15087','2013-12-31','11:10:00',1.25),('15087','2013-12-31','11:15:00',1.71),('15087','2013-12-31','11:20:00',1.91),('15087','2013-12-31','11:25:00',2.6),('15087','2013-12-31','11:30:00',2.92),('15087','2013-12-31','11:35:00',1.86),('15087','2013-12-31','11:40:00',2.52),('15087','2013-12-31','11:50:00',1.47),('15087','2013-12-31','11:55:00',2),('15087','2013-12-31','12:00:00',2.73),('15087','2013-12-31','12:05:00',2.66),('15087','2013-12-31','12:10:00',2.65),('15087','2013-12-31','12:15:00',2.63),('15087','2013-12-31','12:20:00',2.59),('15087','2013-12-31','12:25:00',2.6),('15087','2013-12-31','12:30:00',2.58),('15087','2013-12-31','12:35:00',2.52),('15087','2013-12-31','12:40:00',2.48),('15087','2013-12-31','12:45:00',2.45),('15087','2013-12-31','12:50:00',2.39),('15087','2013-12-31','12:55:00',2.36),('15087','2013-12-31','13:00:00',2.31),('15087','2013-12-31','13:05:00',2.27),('15087','2013-12-31','13:10:00',2.21),('15087','2013-12-31','13:15:00',2.16),('15087','2013-12-31','13:20:00',2.11),('15087','2013-12-31','13:25:00',2.05),('15087','2013-12-31','13:30:00',1.93),('15087','2013-12-31','13:35:00',1.86),('15087','2013-12-31','13:40:00',1.79),('15087','2013-12-31','13:45:00',1.77),('15087','2013-12-31','13:50:00',1.78),('15087','2013-12-31','13:55:00',1.71),('15087','2013-12-31','14:00:00',1.63),('15087','2013-12-31','14:05:00',1.58),('15087','2013-12-31','14:10:00',1.42),('15087','2013-12-31','14:15:00',1.4),('15087','2013-12-31','14:20:00',1.32),('15087','2013-12-31','14:25:00',1.23),('15087','2013-12-31','14:30:00',1.11),('15087','2013-12-31','14:35:00',1.07),('15087','2013-12-31','14:40:00',1.03),('15087','2013-12-30','11:25:00',1.06),('15087','2013-12-30','11:30:00',1.06),('15087','2013-12-29','09:35:00',1.05),('15087','2013-12-29','09:40:00',1.12),('15087','2013-12-29','09:45:00',1.2),('15087','2013-12-29','09:50:00',1.16),('15087','2013-12-29','09:55:00',1.07),('15087','2013-12-29','10:00:00',1.16),('15087','2013-12-29','10:05:00',1.32),('15087','2013-12-29','10:10:00',1.68),('15087','2013-12-29','10:15:00',1.76),('15087','2013-12-29','10:20:00',1.98),('15087','2013-12-29','10:25:00',1.85),('15087','2013-12-29','10:30:00',2.5),('15087','2013-12-29','10:35:00',2.74),('15087','2013-12-29','10:40:00',1.7),('15087','2013-12-29','10:45:00',1.45),('15087','2013-12-29','10:55:00',1.1),('15087','2013-12-29','11:05:00',1),('15087','2013-12-28','09:35:00',1.04),('15087','2013-12-28','09:40:00',1.1),('15087','2013-12-28','09:45:00',1.15),('15087','2013-12-28','09:50:00',1.22),('15087','2013-12-28','09:55:00',1.31),('15087','2013-12-28','10:00:00',1.45),('15087','2013-12-28','10:05:00',1.54),('15087','2013-12-28','10:10:00',1.63),('15087','2013-12-28','10:15:00',1.71),('15087','2013-12-28','10:20:00',1.79),('15087','2013-12-28','10:25:00',1.87),('15087','2013-12-28','10:30:00',1.91),('15087','2013-12-28','10:35:00',1.97),('15087','2013-12-28','10:40:00',2.03),('15087','2013-12-28','10:45:00',2.11),('15087','2013-12-28','10:50:00',2.18),('15087','2013-12-28','10:55:00',2.22),('15087','2013-12-28','11:00:00',2.28),('15087','2013-12-28','11:05:00',2.32),('15087','2013-12-28','11:10:00',2.35),('15087','2013-12-28','11:15:00',2.39),('15087','2013-12-28','11:20:00',2.43),('15087','2013-12-28','11:25:00',2.45),('15087','2013-12-28','11:30:00',2.47),('15087','2013-12-28','11:35:00',2.48),('15087','2013-12-28','11:40:00',2.49),('15087','2013-12-28','11:45:00',2.51),('15087','2013-12-28','11:50:00',2.52),('15087','2013-12-28','11:55:00',2.53),('15087','2013-12-28','12:00:00',2.51),('15087','2013-12-28','12:05:00',2.53),('15087','2013-12-28','12:10:00',2.52),('15087','2013-12-28','12:15:00',2.5),('15087','2013-12-28','12:20:00',2.47),('15087','2013-12-28','12:25:00',2.46),('15087','2013-12-28','12:30:00',2.46),('15087','2013-12-28','12:35:00',2.33),('15087','2013-12-28','12:40:00',2.37),('15087','2013-12-28','12:45:00',2.27),('15087','2013-12-28','12:50:00',2.12),('15087','2013-12-28','12:55:00',2.08),('15087','2013-12-28','13:00:00',2.16),('15087','2013-12-28','13:05:00',2.11),('15087','2013-12-28','13:10:00',2.05),('15087','2013-12-28','13:15:00',1.9),('15087','2013-12-28','13:20:00',1.74),('15087','2013-12-28','13:25:00',1.86),('15087','2013-12-28','13:30:00',1.7),('15087','2013-12-28','13:35:00',1.61),('15087','2013-12-28','13:40:00',1.58),('15087','2013-12-28','13:45:00',1.67),('15087','2013-12-28','13:50:00',1.59),('15087','2013-12-28','13:55:00',1.54),('15087','2013-12-28','14:00:00',1.47),('15087','2013-12-28','14:05:00',1.37),('15087','2013-12-28','14:10:00',1.25),('15087','2013-12-28','14:15:00',1.18),('15087','2013-12-28','14:20:00',1.12),('15087','2013-12-28','14:25:00',1.08),('15087','2013-12-28','14:30:00',1.04),('15087','2014-04-23','13:10:00',1.03),('15087','2014-04-23','13:15:00',1.21),('15087','2014-04-23','13:20:00',1.37),('15087','2014-04-23','13:25:00',1.42),('15087','2014-04-23','13:30:00',1.57),('15087','2014-04-23','13:35:00',1.64),('15087','2014-04-23','13:40:00',1.73),('15087','2014-04-23','13:45:00',1.78),('15087','2014-04-23','13:50:00',1.76),('15087','2014-04-23','13:55:00',1.77),('15087','2014-04-23','14:00:00',1.67),('15087','2014-04-23','14:05:00',1.67),('15087','2014-04-23','14:10:00',1.6),('15087','2014-04-23','14:15:00',1.29),('15087','2014-04-23','14:20:00',1.1),('15087','2014-04-23','14:45:00',1.07),('15087','2014-04-23','14:50:00',1.33),('15087','2014-04-23','14:55:00',1.59),('15087','2014-04-23','15:00:00',1.81),('15087','2014-04-23','15:05:00',1.91),('15087','2014-04-23','15:10:00',1.86),('15087','2014-04-23','15:15:00',1.94),('15087','2014-04-23','15:20:00',1.64),('15087','2014-04-23','15:25:00',1.46),('15087','2014-04-23','15:30:00',1.36),('15087','2014-04-23','15:35:00',1.29),('15087','2014-04-23','15:40:00',1.27),('15087','2014-04-23','15:45:00',1.5),('15087','2014-04-23','15:50:00',1.13),('15087','2014-04-23','15:55:00',1.03),('15087','2013-12-27','12:05:00',1.05),('15087','2013-12-27','12:10:00',2),('15087','2013-12-27','12:15:00',1.6),('15087','2013-12-27','12:20:00',1.88),('15087','2013-12-27','12:25:00',1.3),('15087','2013-12-27','12:30:00',1.04),('15087','2013-12-27','12:35:00',1.23),('15087','2013-12-27','12:40:00',1.51),('15087','2013-12-27','12:45:00',1.87),('15087','2013-12-27','12:50:00',2.1),('15087','2013-12-27','12:55:00',2.16),('15087','2013-12-27','13:00:00',2.17),('15087','2013-12-27','13:05:00',1.95),('15087','2013-12-27','13:10:00',1.26),('15087','2013-12-27','13:15:00',1.33),('15087','2013-12-27','13:20:00',1.71),('15087','2013-12-27','13:25:00',1.64),('15087','2013-12-27','13:30:00',2.31),('15087','2013-12-27','13:35:00',2.11),('15087','2013-12-27','13:40:00',1.38),('15087','2013-12-27','13:45:00',1.19),('15087','2013-12-27','13:50:00',1.02),('15087','2013-12-27','14:10:00',1.08),('15087','2013-12-27','14:15:00',1.13),('15087','2013-12-27','14:20:00',1.06),('15087','2013-12-27','14:25:00',1.03),('15087','2013-12-27','14:30:00',1.08),('15087','2013-12-27','14:35:00',1.15),('15087','2013-12-27','14:40:00',1.18),('15087','2013-12-25','10:30:00',1.52),('15087','2013-12-25','10:35:00',1.51),('15087','2013-12-25','10:40:00',1.36),('15087','2013-12-25','10:45:00',1.5),('15087','2013-12-25','10:50:00',1.34),('15087','2013-12-25','11:15:00',1.45),('15087','2013-12-25','11:20:00',2.06),('15087','2013-12-25','11:25:00',1.45),('15087','2013-12-25','11:30:00',1.73),('15087','2013-12-25','11:40:00',1.58),('15087','2013-12-25','11:45:00',2.25),('15087','2013-12-25','11:50:00',1.51),('15087','2013-12-25','11:55:00',2.31),('15087','2013-12-25','12:00:00',1.55),('15087','2013-12-25','12:05:00',1.34),('15087','2013-12-25','12:10:00',1.53),('15087','2013-12-25','12:15:00',1.06),('15087','2013-12-25','12:20:00',1.27),('15087','2013-12-25','12:25:00',1.56),('15087','2013-12-25','12:30:00',1.41),('15087','2013-12-25','12:45:00',1.06),('15087','2013-12-25','12:50:00',1.42),('15087','2013-12-25','13:25:00',1.15),('15087','2013-12-25','13:40:00',1.14),('15087','2013-12-25','13:45:00',1.11),('15087','2013-12-25','13:50:00',1.25),('15087','2013-12-25','13:55:00',1.08),('15087','2013-12-24','09:40:00',1.03),('15087','2013-12-24','09:45:00',1.07),('15087','2013-12-24','09:50:00',1.1),('15087','2013-12-24','09:55:00',1.13),('15087','2013-12-24','10:00:00',1.29),('15087','2013-12-24','10:05:00',1.43),('15087','2013-12-24','10:10:00',1.5),('15087','2013-12-24','10:15:00',1.56),('15087','2013-12-24','10:20:00',1.66),('15087','2013-12-24','10:25:00',1.73),('15087','2013-12-24','10:30:00',1.75),('15087','2013-12-24','10:35:00',1.82),('15087','2013-12-24','10:40:00',1.87),('15087','2013-12-24','10:45:00',1.9),('15087','2013-12-24','10:50:00',1.96),('15087','2013-12-24','10:55:00',1.98),('15087','2013-12-24','11:00:00',2.02),('15087','2013-12-24','11:05:00',2.11),('15087','2013-12-24','11:10:00',2.1),('15087','2013-12-24','11:15:00',2.09),('15087','2013-12-24','11:20:00',2.13),('15087','2013-12-24','11:25:00',2.16),('15087','2013-12-24','11:30:00',2.22),('15087','2013-12-24','11:35:00',2.24),('15087','2013-12-24','11:40:00',2.26),('15087','2013-12-24','11:45:00',2.26),('15087','2013-12-24','11:50:00',2.3),('15087','2013-12-24','11:55:00',2.28),('15087','2013-12-24','12:00:00',2.24),('15087','2013-12-24','12:05:00',2.24),('15087','2013-12-24','12:10:00',2.24),('15087','2013-12-24','12:15:00',2.25),('15087','2013-12-24','12:20:00',2.26),('15087','2013-12-24','12:25:00',2.22),('15087','2013-12-24','12:30:00',2.16),('15087','2013-12-24','12:35:00',2),('15087','2013-12-24','12:40:00',1.95),('15087','2013-12-24','12:45:00',1.93),('15087','2013-12-24','12:50:00',1.99),('15087','2013-12-24','12:55:00',1.96),('15087','2013-12-24','13:00:00',1.87),('15087','2013-12-24','13:05:00',1.85),('15087','2013-12-24','13:10:00',1.83),('15087','2013-12-24','13:15:00',1.76),('15087','2013-12-24','13:20:00',1.75),('15087','2013-12-24','13:25:00',1.64),('15087','2013-12-24','13:30:00',1.61),('15087','2013-12-24','13:35:00',1.64),('15087','2013-12-24','13:40:00',1.51),('15087','2013-12-24','13:45:00',1.48),('15087','2013-12-24','13:50:00',1.39),('15087','2013-12-24','13:55:00',1.33),('15087','2013-12-24','14:00:00',1.26),('15087','2013-12-24','14:05:00',1.13),('15087','2013-12-24','14:10:00',1.12),('15087','2013-12-24','14:15:00',1.04),('15087','2013-12-23','09:50:00',1.14),('15087','2013-12-23','09:55:00',1.35),('15087','2013-12-23','10:00:00',1.61),('15087','2013-12-23','10:05:00',1.76),('15087','2013-12-23','10:10:00',1.75),('15087','2013-12-23','10:15:00',1.81),('15087','2013-12-23','10:20:00',1.86),('15087','2013-12-23','10:25:00',1.81),('15087','2013-12-23','10:30:00',1.75),('15087','2013-12-23','10:35:00',1.79),('15087','2013-12-23','10:40:00',1.83),('15087','2013-12-23','10:45:00',1.88),('15087','2013-12-23','10:50:00',1.94),('15087','2013-12-23','10:55:00',2.12),('15087','2013-12-23','11:00:00',2.32),('15087','2013-12-23','11:05:00',2.41),('15087','2013-12-23','11:10:00',2.42),('15087','2013-12-23','11:15:00',2.38),('15087','2013-12-23','11:20:00',2.35),('15087','2013-12-23','11:25:00',2.33),('15087','2013-12-23','11:30:00',2.41),('15087','2013-12-23','11:35:00',2.46),('15087','2013-12-23','11:40:00',2.31),('15087','2013-12-23','11:45:00',2.05),('15087','2013-12-23','11:50:00',2.24),('15087','2013-12-23','11:55:00',2.28),('15087','2013-12-23','12:00:00',2.39),('15087','2013-12-23','12:05:00',2.37),('15087','2013-12-23','12:10:00',2.43),('15087','2013-12-23','12:15:00',2.32),('15087','2013-12-23','12:20:00',2.27),('15087','2013-12-23','12:25:00',2.26),('15087','2013-12-23','12:30:00',2.22),('15087','2013-12-23','12:35:00',2.23),('15087','2013-12-23','12:40:00',2.29),('15087','2013-12-23','12:45:00',2.18),('15087','2013-12-23','12:50:00',2.14),('15087','2013-12-23','12:55:00',2.14),('15087','2013-12-23','13:00:00',2.09),('15087','2013-12-23','13:05:00',2.07),('15087','2013-12-23','13:10:00',2),('15087','2013-12-23','13:15:00',1.97),('15087','2013-12-23','13:20:00',1.6),('15087','2013-12-23','13:25:00',1.71),('15087','2013-12-23','13:30:00',1.57),('15087','2013-12-23','13:40:00',1.47),('15087','2013-12-23','13:50:00',1.3),('15087','2013-12-23','13:55:00',1.4),('15087','2013-12-23','14:00:00',1.46),('15087','2013-12-23','14:05:00',1.38),('15087','2013-12-23','14:10:00',1.28),('15087','2013-12-23','14:15:00',1.19),('15087','2013-12-23','14:20:00',1.1),('15087','2013-12-23','14:25:00',1.01),('15087','2013-12-22','09:30:00',1),('15087','2013-12-22','09:35:00',1.34),('15087','2013-12-22','09:40:00',1.61),('15087','2013-12-22','09:45:00',1.71),('15087','2013-12-22','09:50:00',1.83),('15087','2013-12-22','09:55:00',1.82),('15087','2013-12-22','10:00:00',1.87),('15087','2013-12-22','10:05:00',1.91),('15087','2013-12-22','10:10:00',1.97),('15087','2013-12-22','10:15:00',1.96),('15087','2013-12-22','10:20:00',1.94),('15087','2013-12-22','10:25:00',1.96),('15087','2013-12-22','10:30:00',2.05),('15087','2013-12-22','10:35:00',1.92),('15087','2013-12-22','10:40:00',1.84),('15087','2013-12-22','10:45:00',2.04),('15087','2013-12-22','10:50:00',2.05),('15087','2013-12-22','10:55:00',1.93),('15087','2013-12-22','11:00:00',1.78),('15087','2013-12-22','11:05:00',1.86),('15087','2013-12-22','11:10:00',2.4),('15087','2013-12-22','11:15:00',2.32),('15087','2013-12-22','11:20:00',2.13),('15087','2013-12-22','11:25:00',2.17),('15087','2013-12-22','11:30:00',2.04),('15087','2013-12-22','11:35:00',2.08),('15087','2013-12-22','11:40:00',2.19),('15087','2013-12-22','11:45:00',2.01),('15087','2013-12-22','11:50:00',1.51),('15087','2013-12-22','11:55:00',1.08),('15087','2013-12-22','12:20:00',1.12),('15087','2013-12-22','12:25:00',1.23),('15087','2013-12-22','12:30:00',1.57),('15087','2013-12-22','12:35:00',1.77),('15087','2013-12-22','12:40:00',1.71),('15087','2013-12-22','12:45:00',1.67),('15087','2013-12-22','12:50:00',1.99),('15087','2013-12-22','12:55:00',2.35),('15087','2013-12-22','13:00:00',2.25),('15087','2013-12-22','13:05:00',2.55),('15087','2013-12-22','13:10:00',2.6),('15087','2013-12-22','13:15:00',2),('15087','2013-12-22','13:20:00',1.89),('15087','2013-12-22','13:25:00',1.86),('15087','2013-12-22','13:30:00',1.69),('15087','2013-12-22','13:35:00',1.61),('15087','2013-12-22','13:40:00',1.29),('15087','2013-12-22','13:45:00',1.46),('15087','2013-12-22','13:50:00',1.26),('15087','2013-12-22','13:55:00',1.15),('15087','2013-12-22','14:00:00',1),('15087','2013-12-22','14:05:00',1.16),('15087','2013-12-22','14:10:00',1.24),('15087','2013-12-21','09:40:00',1.04),('15087','2013-12-21','09:45:00',1.11),('15087','2013-12-21','09:50:00',1.15),('15087','2013-12-21','09:55:00',1.25),('15087','2013-12-21','10:00:00',1.36),('15087','2013-12-21','10:05:00',1.46),('15087','2013-12-21','10:10:00',1.57),('15087','2013-12-21','10:15:00',1.66),('15087','2013-12-21','10:20:00',1.74),('15087','2013-12-21','10:25:00',1.79),('15087','2013-12-21','10:30:00',1.86),('15087','2013-12-21','10:35:00',1.91),('15087','2013-12-21','10:40:00',1.98),('15087','2013-12-21','10:45:00',2.04),('15087','2013-12-21','10:50:00',2.08),('15087','2013-12-21','10:55:00',2.12),('15087','2013-12-21','11:00:00',2.18),('15087','2013-12-21','11:05:00',2.23),('15087','2013-12-21','11:10:00',2.25),('15087','2013-12-21','11:15:00',2.27),('15087','2013-12-21','11:20:00',2.32),('15087','2013-12-21','11:25:00',2.34),('15087','2013-12-21','11:30:00',2.39),('15087','2013-12-21','11:35:00',2.41),('15087','2013-12-21','11:40:00',2.43),('15087','2013-12-21','11:45:00',2.43),('15087','2013-12-21','11:50:00',2.44),('15087','2013-12-21','11:55:00',2.46),('15087','2013-12-21','12:00:00',2.47),('15087','2013-12-21','12:05:00',2.47),('15087','2013-12-21','12:10:00',2.46),('15087','2013-12-21','12:15:00',2.45),('15087','2013-12-21','12:20:00',2.44),('15087','2013-12-21','12:25:00',2.43),('15087','2013-12-21','12:30:00',2.4),('15087','2013-12-21','12:35:00',2.36),('15087','2013-12-21','12:40:00',2.34),('15087','2013-12-21','12:45:00',2.28),('15087','2013-12-21','12:50:00',2.25),('15087','2013-12-21','12:55:00',2.2),('15087','2013-12-21','13:00:00',2.15),('15087','2013-12-21','13:05:00',2.08),('15087','2013-12-21','13:10:00',2.03),('15087','2013-12-21','13:15:00',1.97),('15087','2013-12-21','13:20:00',1.92),('15087','2013-12-21','13:25:00',1.83),('15087','2013-12-21','13:30:00',1.84),('15087','2013-12-21','13:35:00',1.72),('15087','2013-12-21','13:40:00',1.68),('15087','2013-12-21','13:45:00',1.61),('15087','2013-12-21','13:50:00',1.54),('15087','2013-12-21','13:55:00',1.52),('15087','2013-12-21','14:00:00',1.41),('15087','2013-12-21','14:05:00',1.28),('15087','2013-12-21','14:10:00',1.25),('15087','2013-12-21','14:15:00',1.13),('15087','2013-12-21','14:20:00',1.07),('15087','2013-12-21','14:25:00',1.06),('15087','2013-12-21','14:30:00',1.02),('15087','2013-12-20','09:40:00',1.01),('15087','2013-12-20','09:45:00',1.07),('15087','2013-12-20','09:50:00',1.13),('15087','2013-12-20','09:55:00',1.18),('15087','2013-12-20','10:00:00',1.28),('15087','2013-12-20','10:05:00',1.42),('15087','2013-12-20','10:10:00',1.51),('15087','2013-12-20','10:15:00',1.6),('15087','2013-12-20','10:20:00',1.67),('15087','2013-12-20','10:25:00',1.7),('15087','2013-12-20','10:30:00',1.78),('15087','2013-12-20','10:35:00',1.83),('15087','2013-12-20','10:40:00',1.88),('15087','2013-12-20','10:45:00',1.94),('15087','2013-12-20','10:50:00',2),('15087','2013-12-20','10:55:00',2.04),('15087','2013-12-20','11:00:00',2.06),('15087','2013-12-20','11:05:00',2.11),('15087','2013-12-20','11:10:00',2.17),('15087','2013-12-20','11:15:00',2.18),('15087','2013-12-20','11:20:00',2.22),('15087','2013-12-20','11:25:00',2.24),('15087','2013-12-20','11:30:00',2.23),('15087','2013-12-20','11:35:00',2.29),('15087','2013-12-20','11:40:00',2.28),('15087','2013-12-20','11:45:00',2.31),('15087','2013-12-20','11:50:00',2.32),('15087','2013-12-20','11:55:00',2.31),('15087','2013-12-20','12:00:00',2.35),('15087','2013-12-20','12:05:00',2.32),('15087','2013-12-20','12:10:00',2.3),('15087','2013-12-20','12:15:00',2.29),('15087','2013-12-20','12:20:00',2.31),('15087','2013-12-20','12:25:00',2.27),('15087','2013-12-20','12:30:00',2.21),('15087','2013-12-20','12:35:00',2.21),('15087','2013-12-20','12:40:00',2.15),('15087','2013-12-20','12:45:00',2.07),('15087','2013-12-20','12:50:00',2.07),('15087','2013-12-20','12:55:00',1.99),('15087','2013-12-20','13:00:00',1.96),('15087','2013-12-20','13:05:00',1.89),('15087','2013-12-20','13:10:00',1.83),('15087','2013-12-20','13:15:00',1.78),('15087','2013-12-20','13:20:00',1.77),('15087','2013-12-20','13:25:00',1.6),('15087','2013-12-20','13:30:00',1.56),('15087','2013-12-20','13:35:00',1.57),('15087','2013-12-20','13:40:00',1.52),('15087','2013-12-20','13:45:00',1.45),('15087','2013-12-20','13:50:00',1.44),('15087','2013-12-20','13:55:00',1.39),('15087','2013-12-20','14:00:00',1.05),('15087','2013-12-19','09:20:00',1.16),('15087','2013-12-19','09:30:00',1.19),('15087','2013-12-19','09:35:00',1),('15087','2013-12-19','09:50:00',1.27),('15087','2013-12-19','09:55:00',1.44),('15087','2013-12-19','10:00:00',1.43),('15087','2013-12-19','10:05:00',1.73),('15087','2013-12-19','10:10:00',2.04),('15087','2013-12-19','10:15:00',1.88),('15087','2013-12-19','10:20:00',1.29),('15087','2013-12-19','10:25:00',1.26),('15087','2013-12-19','10:30:00',1.02),('15087','2013-12-19','10:40:00',1.57),('15087','2013-12-19','10:45:00',2.33),('15087','2013-12-19','10:50:00',1.65),('15087','2013-12-19','11:15:00',1.26),('15087','2013-12-19','11:20:00',1.14),('15087','2013-12-19','14:30:00',1.29),('15087','2013-12-19','14:35:00',1.07),('15087','2013-12-18','09:35:00',1.03),('15087','2013-12-18','09:40:00',1.09),('15087','2013-12-18','09:45:00',1.15),('15087','2013-12-18','09:50:00',1.24),('15087','2013-12-18','09:55:00',1.35),('15087','2013-12-18','10:00:00',1.42),('15087','2013-12-18','10:05:00',1.53),('15087','2013-12-18','10:10:00',1.62),('15087','2013-12-18','10:15:00',1.71),('15087','2013-12-18','10:20:00',1.79),('15087','2013-12-18','10:25:00',1.85),('15087','2013-12-18','10:30:00',1.92),('15087','2013-12-18','10:35:00',1.97),('15087','2013-12-18','10:40:00',2.02),('15087','2013-12-18','10:45:00',2.07),('15087','2013-12-18','10:50:00',2.12),('15087','2013-12-18','10:55:00',2.16),('15087','2013-12-18','11:00:00',2.21),('15087','2013-12-18','11:05:00',2.25),('15087','2013-12-18','11:10:00',2.29),('15087','2013-12-18','11:15:00',2.32),('15087','2013-12-18','11:20:00',2.33),('15087','2013-12-18','11:25:00',2.33),('15087','2013-12-18','11:30:00',2.35),('15087','2013-12-18','11:35:00',2.35),('15087','2013-12-18','11:40:00',2.39),('15087','2013-12-18','11:45:00',2.37),('15087','2013-12-18','11:50:00',2.38),('15087','2013-12-18','11:55:00',2.4),('15087','2013-12-18','12:00:00',2.41),('15087','2013-12-18','12:05:00',2.4),('15087','2013-12-18','12:10:00',2.39),('15087','2013-12-18','12:15:00',2.4),('15087','2013-12-18','12:20:00',2.39),('15087','2013-12-18','12:25:00',2.37),('15087','2013-12-18','12:30:00',2.25),('15087','2013-12-18','12:35:00',2.27),('15087','2013-12-18','12:40:00',2.22),('15087','2013-12-18','12:45:00',2.13),('15087','2013-12-18','12:50:00',2.07),('15087','2013-12-18','12:55:00',2.09),('15087','2013-12-18','13:00:00',1.99),('15087','2013-12-18','13:05:00',1.97),('15087','2013-12-18','13:10:00',1.98),('15087','2013-12-18','13:15:00',1.89),('15087','2013-12-18','13:20:00',1.82),('15087','2013-12-18','13:25:00',1.81),('15087','2013-12-18','13:30:00',1.76),('15087','2013-12-18','13:35:00',1.64),('15087','2013-12-18','13:40:00',1.58),('15087','2013-12-18','13:45:00',1.5),('15087','2013-12-18','13:50:00',1.45),('15087','2013-12-18','13:55:00',1.43),('15087','2013-12-18','14:00:00',1.29),('15087','2013-12-18','14:05:00',1.2),('15087','2013-12-18','14:10:00',1.15),('15087','2013-12-18','14:15:00',1.11),('15087','2013-12-18','14:20:00',1.02),('15087','2013-12-18','14:25:00',1.03),('15087','2014-04-22','07:55:00',1.05),('15087','2014-04-22','08:00:00',1.14),('15087','2014-04-22','08:05:00',1.22),('15087','2014-04-22','08:10:00',1.32),('15087','2014-04-22','08:15:00',1.42),('15087','2014-04-22','08:20:00',1.5),('15087','2014-04-22','08:25:00',1.6),('15087','2014-04-22','08:30:00',1.75),('15087','2014-04-22','08:35:00',1.85),('15087','2014-04-22','08:40:00',1.99),('15087','2014-04-22','08:45:00',2.01),('15087','2014-04-22','08:50:00',2.14),('15087','2014-04-22','08:55:00',2.19),('15087','2014-04-22','09:00:00',2.21),('15087','2014-04-22','09:05:00',2.51),('15087','2014-04-22','09:10:00',2.3),('15087','2014-04-22','09:15:00',2.32),('15087','2014-04-22','09:20:00',2.59),('15087','2014-04-22','09:25:00',2.88),('15087','2014-04-22','09:30:00',2.8),('15087','2014-04-22','09:35:00',3.02),('15087','2014-04-22','09:40:00',3),('15087','2014-04-22','09:45:00',3.23),('15087','2014-04-22','09:50:00',2.42),('15087','2014-04-22','09:55:00',1.49),('15087','2014-04-22','10:00:00',1.38),('15087','2014-04-22','10:05:00',1.5),('15087','2014-04-22','10:10:00',2.13),('15087','2014-04-22','10:15:00',2.22),('15087','2014-04-22','10:20:00',3.39),('15087','2014-04-22','10:25:00',2.37),('15087','2014-04-22','10:30:00',3.85),('15087','2014-04-22','10:35:00',3.92),('15087','2014-04-22','10:40:00',3.77),('15087','2014-04-22','10:45:00',4.1),('15087','2014-04-22','10:50:00',4.33),('15087','2014-04-22','10:55:00',3.18),('15087','2014-04-22','11:00:00',2.17),('15087','2014-04-22','11:05:00',2.51),('15087','2014-04-22','11:10:00',1.79),('15087','2014-04-22','11:15:00',1.48),('15087','2014-04-22','11:20:00',1.28),('15087','2014-04-22','11:25:00',1.27),('15087','2014-04-22','11:30:00',1.15),('15087','2014-04-22','11:35:00',1.2),('15087','2014-04-22','11:40:00',1.07),('15087','2014-04-22','12:00:00',1),('15087','2014-04-22','12:05:00',1.22),('15087','2014-04-22','12:10:00',1.23),('15087','2014-04-22','12:15:00',1.23),('15087','2014-04-22','12:20:00',1.3),('15087','2014-04-22','12:25:00',1.43),('15087','2014-04-22','12:30:00',1.7),('15087','2014-04-22','12:35:00',1.41),('15087','2014-04-22','12:40:00',1.05),('15087','2014-04-22','13:15:00',1.57),('15087','2014-04-22','13:20:00',2.42),('15087','2014-04-22','13:25:00',2.83),('15087','2014-04-22','13:30:00',3.01),('15087','2014-04-22','13:35:00',2.88),('15087','2014-04-22','13:40:00',3.43),('15087','2014-04-22','13:45:00',3.46),('15087','2014-04-22','13:50:00',2.89),('15087','2014-04-22','13:55:00',1.67),('15087','2014-04-22','14:00:00',1.43),('15087','2014-04-22','14:05:00',2.06),('15087','2014-04-22','14:10:00',3.83),('15087','2014-04-22','14:15:00',3.55),('15087','2014-04-22','14:20:00',4.32),('15087','2014-04-22','14:25:00',2.65),('15087','2014-04-22','14:30:00',2.28),('15087','2014-04-22','14:35:00',2.73),('15087','2014-04-22','14:40:00',3.56),('15087','2014-04-22','14:45:00',4.4),('15087','2014-04-22','14:50:00',4.04),('15087','2014-04-22','14:55:00',3.05),('15087','2014-04-22','15:00:00',1.39),('15087','2014-04-22','15:05:00',1.31),('15087','2014-04-22','15:10:00',1.22),('15087','2014-04-22','15:15:00',1.21),('15087','2014-04-22','15:20:00',1.35),('15087','2014-04-22','15:25:00',1.5),('15087','2014-04-22','15:30:00',1.95),('15087','2014-04-22','15:35:00',2.74),('15087','2014-04-22','15:40:00',2.32),('15087','2014-04-22','15:45:00',2.07),('15087','2014-04-22','15:50:00',2.39),('15087','2014-04-22','15:55:00',1.96),('15087','2014-04-22','16:00:00',2.32),('15087','2014-04-22','16:05:00',1.57),('15087','2014-04-22','16:10:00',1.51),('15087','2014-04-22','16:15:00',1.42),('15087','2014-04-22','16:20:00',1.66),('15087','2014-04-22','16:25:00',1.59),('15087','2014-04-22','16:30:00',1.32),('15087','2014-04-22','16:35:00',1.48),('15087','2014-04-22','16:40:00',1.92),('15087','2014-04-22','16:45:00',1.7),('15087','2014-04-22','16:50:00',1.33),('15087','2014-04-22','16:55:00',1.16),('15087','2014-04-22','17:00:00',1.34),('15087','2014-04-22','17:05:00',1.52),('15087','2014-04-22','17:10:00',1.13),('15087','2014-04-22','17:15:00',1.01),('15087','2013-12-17','09:30:00',1.01),('15087','2013-12-17','09:35:00',1.08),('15087','2013-12-17','09:40:00',1.15),('15087','2013-12-17','09:45:00',1.22),('15087','2013-12-17','09:50:00',1.31),('15087','2013-12-17','09:55:00',1.44),('15087','2013-12-17','10:00:00',1.52),('15087','2013-12-17','10:05:00',1.61),('15087','2013-12-17','10:10:00',1.69),('15087','2013-12-17','10:15:00',1.79),('15087','2013-12-17','10:20:00',1.86),('15087','2013-12-17','10:25:00',1.89),('15087','2013-12-17','10:30:00',1.95),('15087','2013-12-17','10:35:00',2),('15087','2013-12-17','10:40:00',2.11),('15087','2013-12-17','10:45:00',2.15),('15087','2013-12-17','10:50:00',2.19),('15087','2013-12-17','10:55:00',2.23),('15087','2013-12-17','11:00:00',2.27),('15087','2013-12-17','11:05:00',2.31),('15087','2013-12-17','11:10:00',2.34),('15087','2013-12-17','11:15:00',2.39),('15087','2013-12-17','11:20:00',2.4),('15087','2013-12-17','11:25:00',2.42),('15087','2013-12-17','11:30:00',2.43),('15087','2013-12-17','11:35:00',2.46),('15087','2013-12-17','11:40:00',2.46),('15087','2013-12-17','11:45:00',2.48),('15087','2013-12-17','11:50:00',2.52),('15087','2013-12-17','11:55:00',2.53),('15087','2013-12-17','12:00:00',2.54),('15087','2013-12-17','12:05:00',2.52),('15087','2013-12-17','12:10:00',2.51),('15087','2013-12-17','12:15:00',2.51),('15087','2013-12-17','12:20:00',2.51),('15087','2013-12-17','12:25:00',2.52),('15087','2013-12-17','12:30:00',2.45),('15087','2013-12-17','12:35:00',2.44),('15087','2013-12-17','12:40:00',2.32),('15087','2013-12-17','12:45:00',2.23),('15087','2013-12-17','12:50:00',2.19),('15087','2013-12-17','12:55:00',2.23),('15087','2013-12-17','13:00:00',2.18),('15087','2013-12-17','13:05:00',2.1),('15087','2013-12-17','13:10:00',2.06),('15087','2013-12-17','13:15:00',2),('15087','2013-12-17','13:20:00',1.93),('15087','2013-12-17','13:25:00',1.91),('15087','2013-12-17','13:30:00',1.87),('15087','2013-12-17','13:35:00',1.68),('15087','2013-12-17','13:40:00',1.71),('15087','2013-12-17','13:45:00',1.59),('15087','2013-12-17','13:50:00',1.59),('15087','2013-12-17','13:55:00',1.53),('15087','2013-12-17','14:00:00',1.42),('15087','2013-12-17','14:05:00',1.35),('15087','2013-12-17','14:10:00',1.26),('15087','2013-12-17','14:15:00',1.14),('15087','2013-12-17','14:20:00',1.06),('15087','2013-12-17','14:25:00',1.08),('15087','2013-12-17','14:30:00',1),('15087','2013-12-16','09:30:00',1.02),('15087','2013-12-16','09:35:00',1.08),('15087','2013-12-16','09:40:00',1.15),('15087','2013-12-16','09:45:00',1.19),('15087','2013-12-16','09:50:00',1.29),('15087','2013-12-16','09:55:00',1.41),('15087','2013-12-16','10:00:00',1.48),('15087','2013-12-16','10:05:00',1.59),('15087','2013-12-16','10:10:00',1.66),('15087','2013-12-16','10:15:00',1.77),('15087','2013-12-16','10:20:00',1.81),('15087','2013-12-16','10:25:00',1.83),('15087','2013-12-16','10:30:00',1.87),('15087','2013-12-16','10:35:00',1.95),('15087','2013-12-16','10:40:00',2.05),('15087','2013-12-16','10:45:00',2.09),('15087','2013-12-16','10:50:00',2.13),('15087','2013-12-16','10:55:00',2.18),('15087','2013-12-16','11:00:00',2.23),('15087','2013-12-16','11:05:00',2.27),('15087','2013-12-16','11:10:00',2.27),('15087','2013-12-16','11:15:00',2.3),('15087','2013-12-16','11:20:00',2.3),('15087','2013-12-16','11:25:00',2.38),('15087','2013-12-16','11:30:00',2.39),('15087','2013-12-16','11:35:00',2.42),('15087','2013-12-16','11:40:00',2.45),('15087','2013-12-16','11:45:00',2.47),('15087','2013-12-16','11:50:00',2.48),('15087','2013-12-16','11:55:00',2.5),('15087','2013-12-16','12:00:00',2.51),('15087','2013-12-16','12:05:00',2.52),('15087','2013-12-16','12:10:00',2.51),('15087','2013-12-16','12:15:00',2.5),('15087','2013-12-16','12:20:00',2.51),('15087','2013-12-16','12:25:00',2.51),('15087','2013-12-16','12:30:00',2.33),('15087','2013-12-16','12:35:00',2.39),('15087','2013-12-16','12:40:00',2.28),('15087','2013-12-16','12:45:00',2.18),('15087','2013-12-16','12:50:00',2.18),('15087','2013-12-16','12:55:00',2.21),('15087','2013-12-16','13:00:00',2.17),('15087','2013-12-16','13:05:00',2.12),('15087','2013-12-16','13:10:00',2.07),('15087','2013-12-16','13:15:00',1.99),('15087','2013-12-16','13:20:00',1.93),('15087','2013-12-16','13:25:00',1.9),('15087','2013-12-16','13:30:00',1.86),('15087','2013-12-16','13:35:00',1.67),('15087','2013-12-16','13:40:00',1.7),('15087','2013-12-16','13:45:00',1.56),('15087','2013-12-16','13:50:00',1.58),('15087','2013-12-16','13:55:00',1.51),('15087','2013-12-16','14:00:00',1.35),('15087','2013-12-16','14:05:00',1.34),('15087','2013-12-16','14:10:00',1.25),('15087','2013-12-16','14:15:00',1.16),('15087','2013-12-16','14:20:00',1.06),('15087','2013-12-16','14:25:00',1.08),('15087','2013-12-15','10:20:00',1.29),('15087','2013-12-15','10:25:00',1.24),('15087','2013-12-15','10:30:00',1.13),('15087','2013-12-15','10:35:00',1.25),('15087','2013-12-15','10:40:00',1.26),('15087','2013-12-15','10:45:00',1.26),('15087','2013-12-14','09:30:00',1.02),('15087','2013-12-14','09:35:00',1.09),('15087','2013-12-14','09:40:00',1.15),('15087','2013-12-14','09:45:00',1.23),('15087','2013-12-14','09:50:00',1.33),('15087','2013-12-14','09:55:00',1.43),('15087','2013-12-14','10:00:00',1.53),('15087','2013-12-14','10:05:00',1.6),('15087','2013-12-14','10:10:00',1.69),('15087','2013-12-14','10:15:00',1.77),('15087','2013-12-14','10:20:00',1.83),('15087','2013-12-14','10:25:00',1.86),('15087','2013-12-14','10:30:00',1.91),('15087','2013-12-14','10:35:00',1.97),('15087','2013-12-14','10:40:00',2.03),('15087','2013-12-14','10:45:00',2.09),('15087','2013-12-14','10:50:00',2.11),('15087','2013-12-14','10:55:00',2.14),('15087','2013-12-14','11:00:00',2.19),('15087','2013-12-14','11:05:00',2.2),('15087','2013-12-14','11:10:00',2.26),('15087','2013-12-14','11:15:00',2.3),('15087','2013-12-14','11:20:00',2.33),('15087','2013-12-14','11:25:00',2.32),('15087','2013-12-14','11:30:00',2.35),('15087','2013-12-14','11:35:00',2.37),('15087','2013-12-14','11:40:00',2.35),('15087','2013-12-14','11:45:00',2.37),('15087','2013-12-14','11:50:00',2.33),('15087','2013-12-14','11:55:00',2.33),('15087','2013-12-14','12:00:00',2.34),('15087','2013-12-14','12:05:00',2.35),('15087','2013-12-14','12:10:00',2.38),('15087','2013-12-14','12:15:00',2.34),('15087','2013-12-14','12:20:00',2.31),('15087','2013-12-14','12:25:00',2.26),('15087','2013-12-14','12:30:00',2.21),('15087','2013-12-14','12:35:00',2.3),('15087','2013-12-14','12:40:00',2.15),('15087','2013-12-14','12:45:00',2.13),('15087','2013-12-14','12:50:00',2.12),('15087','2013-12-14','12:55:00',2.03),('15087','2013-12-14','13:00:00',1.99),('15087','2013-12-14','13:05:00',2.01),('15087','2013-12-14','13:10:00',1.96),('15087','2013-12-14','13:15:00',1.92),('15087','2013-12-14','13:20:00',1.9),('15087','2013-12-14','13:25:00',1.88),('15087','2013-12-14','13:30:00',1.82),('15087','2013-12-14','13:35:00',1.69),('15087','2013-12-14','13:40:00',1.69),('15087','2013-12-14','13:45:00',1.57),('15087','2013-12-14','13:50:00',1.55),('15087','2013-12-14','13:55:00',1.51),('15087','2013-12-14','14:00:00',1.34),('15087','2013-12-14','14:05:00',1.36),('15087','2013-12-14','14:10:00',1.24),('15087','2013-12-14','14:15:00',1.16),('15087','2013-12-14','14:20:00',1.08),('15087','2013-12-14','14:25:00',1.03),('15087','2013-12-13','09:40:00',1.05),('15087','2013-12-13','09:45:00',1.1),('15087','2013-12-13','09:50:00',1.24),('15087','2013-12-13','09:55:00',1.33),('15087','2013-12-13','10:00:00',1.43),('15087','2013-12-13','10:05:00',1.53),('15087','2013-12-13','10:10:00',1.62),('15087','2013-12-13','10:15:00',1.67),('15087','2013-12-13','10:20:00',1.72),('15087','2013-12-13','10:25:00',1.75),('15087','2013-12-13','10:30:00',1.8),('15087','2013-12-13','10:35:00',1.87),('15087','2013-12-13','10:40:00',1.92),('15087','2013-12-13','10:45:00',1.95),('15087','2013-12-13','10:50:00',2.01),('15087','2013-12-13','10:55:00',2.06),('15087','2013-12-13','11:00:00',2.13),('15087','2013-12-13','11:05:00',2.17),('15087','2013-12-13','11:10:00',2.17),('15087','2013-12-13','11:15:00',2.21),('15087','2013-12-13','11:20:00',2.19),('15087','2013-12-13','11:25:00',2.23),('15087','2013-12-13','11:30:00',2.23),('15087','2013-12-13','11:35:00',2.26),('15087','2013-12-13','11:40:00',2.29),('15087','2013-12-13','11:45:00',2.35),('15087','2013-12-13','11:50:00',2.34),('15087','2013-12-13','11:55:00',2.37),('15087','2013-12-13','12:00:00',2.35),('15087','2013-12-13','12:05:00',2.34),('15087','2013-12-13','12:10:00',2.36),('15087','2013-12-13','12:15:00',2.31),('15087','2013-12-13','12:20:00',2.31),('15087','2013-12-13','12:25:00',2.29),('15087','2013-12-13','12:30:00',2.13),('15087','2013-12-13','12:35:00',2.13),('15087','2013-12-13','12:40:00',2.16),('15087','2013-12-13','12:45:00',2.03),('15087','2013-12-13','12:50:00',2.04),('15087','2013-12-13','12:55:00',2.01),('15087','2013-12-13','13:00:00',2.01),('15087','2013-12-13','13:05:00',1.93),('15087','2013-12-13','13:10:00',1.86),('15087','2013-12-13','13:15:00',1.7),('15087','2013-12-13','13:20:00',1.78),('15087','2013-12-13','13:25:00',1.77),('15087','2013-12-13','13:30:00',1.71),('15087','2013-12-13','13:35:00',1.73),('15087','2013-12-13','13:40:00',1.71),('15087','2013-12-13','13:45:00',1.61),('15087','2013-12-13','13:50:00',1.58),('15087','2013-12-13','13:55:00',1.52),('15087','2013-12-13','14:00:00',1.39),('15087','2013-12-13','14:05:00',1.38),('15087','2013-12-13','14:10:00',1.27),('15087','2013-12-13','14:15:00',1.19),('15087','2013-12-13','14:20:00',1.11),('15087','2013-12-13','14:25:00',1.05),('15087','2013-12-12','09:30:00',1.01),('15087','2013-12-12','09:35:00',1.1),('15087','2013-12-12','09:40:00',1.17),('15087','2013-12-12','09:45:00',1.22),('15087','2013-12-12','09:50:00',1.31),('15087','2013-12-12','09:55:00',1.48),('15087','2013-12-12','10:00:00',1.53),('15087','2013-12-12','10:05:00',1.65),('15087','2013-12-12','10:10:00',1.72),('15087','2013-12-12','10:15:00',1.8),('15087','2013-12-12','10:20:00',1.84),('15087','2013-12-12','10:25:00',1.91),('15087','2013-12-12','10:30:00',1.96),('15087','2013-12-12','10:35:00',2.01),('15087','2013-12-12','10:40:00',2.08),('15087','2013-12-12','10:45:00',2.11),('15087','2013-12-12','10:50:00',2.14),('15087','2013-12-12','10:55:00',2.18),('15087','2013-12-12','11:00:00',2.22),('15087','2013-12-12','11:05:00',2.23),('15087','2013-12-12','11:10:00',2.25),('15087','2013-12-12','11:15:00',2.28),('15087','2013-12-12','11:20:00',2.28),('15087','2013-12-12','11:25:00',2.32),('15087','2013-12-12','11:30:00',2.37),('15087','2013-12-12','11:35:00',2.37),('15087','2013-12-12','11:40:00',2.38),('15087','2013-12-12','11:45:00',2.39),('15087','2013-12-12','11:50:00',2.38),('15087','2013-12-12','11:55:00',2.4),('15087','2013-12-12','12:00:00',2.4),('15087','2013-12-12','12:05:00',2.41),('15087','2013-12-12','12:10:00',2.41),('15087','2013-12-12','12:15:00',2.39),('15087','2013-12-12','12:20:00',2.37),('15087','2013-12-12','12:25:00',2.33),('15087','2013-12-12','12:30:00',2.19),('15087','2013-12-12','12:35:00',2.15),('15087','2013-12-12','12:40:00',2.13),('15087','2013-12-12','12:45:00',2.04),('15087','2013-12-12','12:50:00',2.03),('15087','2013-12-12','12:55:00',2.08),('15087','2013-12-12','13:00:00',2.05),('15087','2013-12-12','13:05:00',1.96),('15087','2013-12-12','13:10:00',1.97),('15087','2013-12-12','13:15:00',1.89),('15087','2013-12-12','13:20:00',1.82),('15087','2013-12-12','13:25:00',1.85),('15087','2013-12-12','13:30:00',1.65),('15087','2013-12-12','13:35:00',1.6),('15087','2013-12-12','13:40:00',1.66),('15087','2013-12-12','13:45:00',1.6),('15087','2013-12-12','13:50:00',1.59),('15087','2013-12-12','13:55:00',1.53),('15087','2013-12-12','14:00:00',1.37),('15087','2013-12-12','14:05:00',1.33),('15087','2013-12-12','14:10:00',1.24),('15087','2013-12-12','14:15:00',1.15),('15087','2013-12-12','14:20:00',1.07),('15087','2013-12-12','14:25:00',1),('15087','2013-12-11','09:30:00',1.03),('15087','2013-12-11','09:35:00',1.1),('15087','2013-12-11','09:40:00',1.17),('15087','2013-12-11','09:45:00',1.27),('15087','2013-12-11','09:50:00',1.44),('15087','2013-12-11','09:55:00',1.52),('15087','2013-12-11','10:00:00',1.59),('15087','2013-12-11','10:05:00',1.69),('15087','2013-12-11','10:10:00',1.79),('15087','2013-12-11','10:15:00',1.87),('15087','2013-12-11','10:20:00',1.89),('15087','2013-12-11','10:25:00',1.97),('15087','2013-12-11','10:30:00',2.01),('15087','2013-12-11','10:35:00',2.13),('15087','2013-12-11','10:40:00',2.17),('15087','2013-12-11','10:45:00',2.2),('15087','2013-12-11','10:50:00',2.21),('15087','2013-12-11','10:55:00',2.28),('15087','2013-12-11','11:00:00',2.31),('15087','2013-12-11','11:05:00',2.38),('15087','2013-12-11','11:10:00',2.42),('15087','2013-12-11','11:15:00',2.43),('15087','2013-12-11','11:20:00',2.46),('15087','2013-12-11','11:25:00',2.48),('15087','2013-12-11','11:30:00',2.42),('15087','2013-12-11','11:35:00',2.47),('15087','2013-12-11','11:40:00',2.49),('15087','2013-12-11','11:45:00',2.5),('15087','2013-12-11','11:50:00',2.53),('15087','2013-12-11','11:55:00',2.55),('15087','2013-12-11','12:00:00',2.57),('15087','2013-12-11','12:05:00',2.56),('15087','2013-12-11','12:10:00',2.56),('15087','2013-12-11','12:15:00',2.52),('15087','2013-12-11','12:20:00',2.51),('15087','2013-12-11','12:25:00',2.42),('15087','2013-12-11','12:30:00',2.37),('15087','2013-12-11','12:35:00',2.37),('15087','2013-12-11','12:40:00',2.32),('15087','2013-12-11','12:45:00',2.32),('15087','2013-12-11','12:50:00',2.27),('15087','2013-12-11','12:55:00',2.22),('15087','2013-12-11','13:00:00',2.19),('15087','2013-12-11','13:05:00',2.13),('15087','2013-12-11','13:10:00',2.06),('15087','2013-12-11','13:15:00',1.99),('15087','2013-12-11','13:20:00',1.86),('15087','2013-12-11','13:25:00',1.84),('15087','2013-12-11','13:30:00',1.72),('15087','2013-12-11','13:35:00',1.77),('15087','2013-12-11','13:40:00',1.71),('15087','2013-12-11','13:45:00',1.61),('15087','2013-12-11','13:50:00',1.61),('15087','2013-12-11','13:55:00',1.53),('15087','2013-12-11','14:00:00',1.4),('15087','2013-12-11','14:05:00',1.39),('15087','2013-12-11','14:10:00',1.29),('15087','2013-12-11','14:15:00',1.18),('15087','2013-12-11','14:20:00',1.11),('15087','2013-12-11','14:25:00',1.08),('15087','2013-12-11','14:30:00',1.02),('15087','2013-12-10','09:25:00',1.03),('15087','2013-12-10','09:30:00',1.06),('15087','2013-12-10','09:35:00',1.13),('15087','2013-12-10','09:40:00',1.19),('15087','2013-12-10','09:45:00',1.3),('15087','2013-12-10','09:50:00',1.47),('15087','2013-12-10','09:55:00',1.58),('15087','2013-12-10','10:00:00',1.65),('15087','2013-12-10','10:05:00',1.74),('15087','2013-12-10','10:10:00',1.85),('15087','2013-12-10','10:15:00',1.92),('15087','2013-12-10','10:20:00',1.95),('15087','2013-12-10','10:25:00',2.01),('15087','2013-12-10','10:30:00',2.08),('15087','2013-12-10','10:35:00',2.16),('15087','2013-12-10','10:40:00',2.21),('15087','2013-12-10','10:45:00',2.23),('15087','2013-12-10','10:50:00',2.26),('15087','2013-12-10','10:55:00',2.3),('15087','2013-12-10','11:00:00',2.35),('15087','2013-12-10','11:05:00',2.39),('15087','2013-12-10','11:10:00',2.44),('15087','2013-12-10','11:15:00',2.47),('15087','2013-12-10','11:20:00',2.5),('15087','2013-12-10','11:25:00',2.53),('15087','2013-12-10','11:30:00',2.56),('15087','2013-12-10','11:35:00',2.58),('15087','2013-12-10','11:40:00',2.58),('15087','2013-12-10','11:45:00',2.59),('15087','2013-12-10','11:50:00',2.6),('15087','2013-12-10','11:55:00',2.6),('15087','2013-12-10','12:00:00',2.58),('15087','2013-12-10','12:05:00',2.58),('15087','2013-12-10','12:10:00',2.56),('15087','2013-12-10','12:15:00',2.55),('15087','2013-12-10','12:20:00',2.54),('15087','2013-12-10','12:25:00',2.41),('15087','2013-12-10','12:30:00',2.3),('15087','2013-12-10','12:35:00',2.37),('15087','2013-12-10','12:40:00',2.25),('15087','2013-12-10','12:45:00',2.29),('15087','2013-12-10','12:50:00',2.21),('15087','2013-12-10','12:55:00',2.18),('15087','2013-12-10','13:00:00',2.09),('15087','2013-12-10','13:05:00',2.04),('15087','2013-12-10','13:10:00',2.03),('15087','2013-12-10','13:15:00',1.9),('15087','2013-12-10','13:20:00',1.88),('15087','2013-12-10','13:25:00',1.83),('15087','2013-12-10','13:30:00',1.67),('15087','2013-12-10','13:35:00',1.8),('15087','2013-12-10','13:40:00',1.69),('15087','2013-12-10','13:45:00',1.67),('15087','2013-12-10','13:50:00',1.63),('15087','2013-12-10','13:55:00',1.59),('15087','2013-12-10','14:00:00',1.45),('15087','2013-12-10','14:05:00',1.4),('15087','2013-12-10','14:10:00',1.29),('15087','2013-12-10','14:15:00',1.23),('15087','2013-12-10','14:20:00',1.15),('15087','2013-12-10','14:25:00',1.11),('15087','2013-12-10','14:30:00',1.04),('15087','2013-12-09','09:35:00',1.13),('15087','2013-12-09','09:40:00',1.23),('15087','2013-12-09','09:45:00',1.37),('15087','2013-12-09','09:50:00',1.48),('15087','2013-12-09','09:55:00',1.59),('15087','2013-12-09','10:00:00',1.71),('15087','2013-12-09','10:05:00',1.96),('15087','2013-12-09','10:10:00',2.26),('15087','2013-12-09','10:15:00',2.54),('15087','2013-12-09','10:20:00',2.72),('15087','2013-12-09','10:25:00',1.45),('15087','2013-12-09','12:25:00',1.02),('15087','2013-12-09','12:30:00',2.26),('15087','2013-12-09','12:35:00',1.2),('15087','2013-12-09','12:40:00',1.24),('15087','2013-12-09','12:45:00',1.63),('15087','2013-12-09','12:50:00',1.54),('15087','2013-12-09','12:55:00',1.95),('15087','2013-12-09','13:00:00',2.26),('15087','2013-12-09','13:05:00',1.34),('15087','2013-12-09','13:10:00',1.93),('15087','2013-12-09','13:15:00',1.55),('15087','2013-12-09','13:20:00',1.71),('15087','2013-12-09','13:25:00',1.15),('15087','2013-12-09','13:50:00',1.1),('15087','2013-12-09','13:55:00',1.15),('15087','2013-12-08','10:40:00',1.06),('15087','2013-12-08','10:45:00',1.1),('15087','2013-12-08','10:50:00',1.14),('15087','2013-12-08','10:55:00',1.21),('15087','2013-12-08','11:00:00',1.49),('15087','2013-12-08','11:05:00',1.22),('15087','2013-12-08','11:10:00',1.28),('15087','2013-12-08','11:15:00',2.21),('15087','2013-12-08','11:20:00',1.17),('15087','2013-12-08','12:55:00',1.31),('15087','2013-12-08','13:00:00',1.19),('15087','2013-12-08','13:05:00',1.35),('15087','2013-12-08','13:10:00',2.08),('15087','2013-12-08','13:15:00',1.63),('15087','2013-12-08','13:25:00',1.57),('15087','2013-12-08','13:30:00',1.43),('15087','2014-04-21','09:00:00',1.01),('15087','2014-04-21','09:10:00',1),('15087','2014-04-21','09:15:00',1.06),('15087','2014-04-21','09:20:00',1.64),('15087','2014-04-21','09:25:00',1.39),('15087','2014-04-21','09:50:00',1.01),('15087','2014-04-21','09:55:00',1.08),('15087','2014-04-21','10:00:00',1.49),('15087','2014-04-21','10:05:00',3.31),('15087','2014-04-21','10:10:00',3.36),('15087','2014-04-21','10:15:00',3.58),('15087','2014-04-21','10:20:00',3.58),('15087','2014-04-21','10:25:00',3.6),('15087','2014-04-21','10:30:00',3.61),('15087','2014-04-21','10:35:00',3.66),('15087','2014-04-21','10:40:00',3.7),('15087','2014-04-21','10:45:00',3.75),('15087','2014-04-21','10:50:00',3.8),('15087','2014-04-21','10:55:00',3.84),('15087','2014-04-21','11:00:00',3.88),('15087','2014-04-21','11:05:00',3.92),('15087','2014-04-21','11:10:00',3.94),('15087','2014-04-21','11:15:00',3.98),('15087','2014-04-21','11:20:00',4.04),('15087','2014-04-21','11:25:00',4.11),('15087','2014-04-21','11:30:00',4.14),('15087','2014-04-21','11:35:00',4.17),('15087','2014-04-21','11:40:00',4.15),('15087','2014-04-21','11:45:00',4.25),('15087','2014-04-21','11:50:00',4.29),('15087','2014-04-21','11:55:00',4.33),('15087','2014-04-21','12:00:00',4.35),('15087','2014-04-21','12:05:00',4.38),('15087','2014-04-21','12:10:00',4.42),('15087','2014-04-21','12:15:00',4.48),('15087','2014-04-21','12:20:00',4.49),('15087','2014-04-21','12:25:00',4.5),('15087','2014-04-21','12:30:00',4.51),('15087','2014-04-21','12:35:00',4.51),('15087','2014-04-21','12:40:00',4.54),('15087','2014-04-21','12:45:00',4.56),('15087','2014-04-21','12:50:00',4.59),('15087','2014-04-21','12:55:00',4.58),('15087','2014-04-21','13:00:00',4.58),('15087','2014-04-21','13:05:00',4.59),('15087','2014-04-21','13:10:00',4.56),('15087','2014-04-21','13:15:00',4.57),('15087','2014-04-21','13:20:00',4.57),('15087','2014-04-21','13:25:00',4.58),('15087','2014-04-21','13:30:00',4.56),('15087','2014-04-21','13:35:00',4.53),('15087','2014-04-21','13:40:00',4.54),('15087','2014-04-21','13:45:00',4.56),('15087','2014-04-21','13:50:00',4.53),('15087','2014-04-21','13:55:00',4.3),('15087','2014-04-21','14:00:00',4.45),('15087','2014-04-21','14:05:00',4.45),('15087','2014-04-21','14:10:00',4.44),('15087','2014-04-21','14:15:00',4.33),('15087','2014-04-21','14:20:00',4.16),('15087','2014-04-21','14:25:00',4.2),('15087','2014-04-21','14:30:00',4.26),('15087','2014-04-21','14:35:00',4.16),('15087','2014-04-21','14:40:00',4.06),('15087','2014-04-21','14:45:00',4.07),('15087','2014-04-21','14:50:00',4.04),('15087','2014-04-21','14:55:00',3.97),('15087','2014-04-21','15:00:00',3.88),('15087','2014-04-21','15:05:00',3.8),('15087','2014-04-21','15:10:00',3.74),('15087','2014-04-21','15:15:00',3.68),('15087','2014-04-21','15:20:00',3.64),('15087','2014-04-21','15:25:00',3.6),('15087','2014-04-21','15:30:00',3.52),('15087','2014-04-21','15:35:00',3.29),('15087','2014-04-21','15:40:00',3.2),('15087','2014-04-21','15:45:00',3.3),('15087','2014-04-21','15:50:00',3.26),('15087','2014-04-21','15:55:00',3.2),('15087','2014-04-21','16:00:00',3.17),('15087','2014-04-21','16:05:00',2.97),('15087','2014-04-21','16:10:00',2.79),('15087','2014-04-21','16:15:00',3.07),('15087','2014-04-21','16:20:00',2.93),('15087','2014-04-21','16:25:00',2.58),('15087','2014-04-21','16:30:00',2.75),('15087','2014-04-21','16:35:00',2.72),('15087','2014-04-21','16:40:00',2.65),('15087','2014-04-21','16:45:00',2.57),('15087','2014-04-21','16:50:00',2.5),('15087','2014-04-21','16:55:00',2.41),('15087','2014-04-21','17:00:00',2.33),('15087','2014-04-21','17:05:00',2.26),('15087','2014-04-21','17:10:00',2.17),('15087','2014-04-21','17:15:00',2.07),('15087','2014-04-21','17:20:00',1.98),('15087','2014-04-21','17:25:00',1.87),('15087','2014-04-21','17:30:00',1.75),('15087','2014-04-21','17:35:00',1.67),('15087','2014-04-21','17:40:00',1.43),('15087','2014-04-21','17:45:00',1.44),('15087','2014-04-21','17:50:00',1.45),('15087','2014-04-21','17:55:00',1.36),('15087','2014-04-21','18:00:00',1.27),('15087','2014-04-21','18:05:00',1.15),('15087','2014-04-21','18:10:00',1.09),('15087','2013-12-07','09:25:00',1.07),('15087','2013-12-07','09:30:00',1.15),('15087','2013-12-07','09:35:00',1.2),('15087','2013-12-07','09:40:00',1.27),('15087','2013-12-07','09:45:00',1.46),('15087','2013-12-07','09:50:00',1.58),('15087','2013-12-07','09:55:00',1.67),('15087','2013-12-07','10:00:00',1.75),('15087','2013-12-07','10:05:00',1.84),('15087','2013-12-07','10:10:00',1.9),('15087','2013-12-07','10:15:00',1.94),('15087','2013-12-07','10:20:00',1.98),('15087','2013-12-07','10:25:00',2.04),('15087','2013-12-07','10:30:00',2.08),('15087','2013-12-07','10:35:00',2.14),('15087','2013-12-07','10:40:00',2.23),('15087','2013-12-07','10:45:00',2.27),('15087','2013-12-07','10:50:00',2.28),('15087','2013-12-07','10:55:00',2.28),('15087','2013-12-07','11:00:00',2.34),('15087','2013-12-07','11:05:00',2.38),('15087','2013-12-07','11:10:00',2.41),('15087','2013-12-07','11:15:00',2.44),('15087','2013-12-07','11:20:00',2.46),('15087','2013-12-07','11:25:00',2.48),('15087','2013-12-07','11:30:00',2.47),('15087','2013-12-07','11:35:00',2.46),('15087','2013-12-07','11:40:00',2.46),('15087','2013-12-07','11:45:00',2.48),('15087','2013-12-07','11:50:00',2.46),('15087','2013-12-07','11:55:00',2.46),('15087','2013-12-07','12:00:00',2.47),('15087','2013-12-07','12:05:00',2.46),('15087','2013-12-07','12:10:00',2.46),('15087','2013-12-07','12:15:00',2.46),('15087','2013-12-07','12:20:00',2.46),('15087','2013-12-07','12:25:00',2.28),('15087','2013-12-07','12:30:00',2.29),('15087','2013-12-07','12:35:00',2.28),('15087','2013-12-07','12:40:00',2.1),('15087','2013-12-07','12:45:00',2.15),('15087','2013-12-07','12:50:00',2.1),('15087','2013-12-07','12:55:00',2.11),('15087','2013-12-07','13:00:00',2.05),('15087','2013-12-07','13:05:00',2.09),('15087','2013-12-07','13:10:00',2.04),('15087','2013-12-07','13:15:00',1.98),('15087','2013-12-07','13:20:00',1.87),('15087','2013-12-07','13:25:00',1.84),('15087','2013-12-07','13:30:00',1.79),('15087','2013-12-07','13:35:00',1.76),('15087','2013-12-07','13:40:00',1.69),('15087','2013-12-07','13:45:00',1.7),('15087','2013-12-07','13:50:00',1.66),('15087','2013-12-07','13:55:00',1.61),('15087','2013-12-07','14:00:00',1.51),('15087','2013-12-07','14:05:00',1.45),('15087','2013-12-07','14:10:00',1.35),('15087','2013-12-07','14:15:00',1.24),('15087','2013-12-07','14:20:00',1.11),('15087','2013-12-07','14:25:00',1.02),('15087','2013-12-06','10:10:00',1.16),('15087','2013-12-06','10:15:00',1.02),('15087','2013-12-06','11:25:00',1.01),('15087','2013-12-06','11:30:00',1.09),('15087','2013-12-06','11:35:00',1.5),('15087','2013-12-06','11:40:00',2.18),('15087','2013-12-06','11:45:00',1.83),('15087','2013-12-06','11:50:00',1.93),('15087','2013-12-06','11:55:00',2),('15087','2013-12-06','12:00:00',1.87),('15087','2013-12-06','12:05:00',1.58),('15087','2013-12-06','12:10:00',1.93),('15087','2013-12-06','12:15:00',1.38),('15087','2013-12-06','12:20:00',1.95),('15087','2013-12-06','12:25:00',1.11),('15087','2013-12-06','12:30:00',1.23),('15087','2013-12-06','12:35:00',1.41),('15087','2013-12-06','12:40:00',2.26),('15087','2013-12-06','12:45:00',1.13),('15087','2013-12-06','12:50:00',1.04),('15087','2013-12-05','09:20:00',1.07),('15087','2013-12-05','09:25:00',1.15),('15087','2013-12-05','09:30:00',1.27),('15087','2013-12-05','09:35:00',1.37),('15087','2013-12-05','09:40:00',1.48),('15087','2013-12-05','09:45:00',1.55),('15087','2013-12-05','09:50:00',1.65),('15087','2013-12-05','09:55:00',1.73),('15087','2013-12-05','10:00:00',1.82),('15087','2013-12-05','10:05:00',1.91),('15087','2013-12-05','10:10:00',1.98),('15087','2013-12-05','10:15:00',2.02),('15087','2013-12-05','10:20:00',2.08),('15087','2013-12-05','10:25:00',2.15),('15087','2013-12-05','10:30:00',2.18),('15087','2013-12-05','10:35:00',2.23),('15087','2013-12-05','10:40:00',2.26),('15087','2013-12-05','10:45:00',2.32),('15087','2013-12-05','10:50:00',2.37),('15087','2013-12-05','10:55:00',2.41),('15087','2013-12-05','11:00:00',2.47),('15087','2013-12-05','11:05:00',2.48),('15087','2013-12-05','11:10:00',2.51),('15087','2013-12-05','11:15:00',2.52),('15087','2013-12-05','11:20:00',2.56),('15087','2013-12-05','11:25:00',2.61),('15087','2013-12-05','11:30:00',2.62),('15087','2013-12-05','11:35:00',2.58),('15087','2013-12-05','11:40:00',2.57),('15087','2013-12-05','11:45:00',2.56),('15087','2013-12-05','11:50:00',2.59),('15087','2013-12-05','11:55:00',2.57),('15087','2013-12-05','12:00:00',2.6),('15087','2013-12-05','12:05:00',2.6),('15087','2013-12-05','12:10:00',2.53),('15087','2013-12-05','12:15:00',2.55),('15087','2013-12-05','12:20:00',2.53),('15087','2013-12-05','12:25:00',2.3),('15087','2013-12-05','12:30:00',2.39),('15087','2013-12-05','12:35:00',2.34),('15087','2013-12-05','12:40:00',2.16),('15087','2013-12-05','12:45:00',2.21),('15087','2013-12-05','12:50:00',2.11),('15087','2013-12-05','12:55:00',1.76),('15087','2013-12-05','13:00:00',2.25),('15087','2013-12-05','13:05:00',2.12),('15087','2013-12-05','13:10:00',2.06),('15087','2013-12-05','13:15:00',1.99),('15087','2013-12-05','13:20:00',1.92),('15087','2013-12-05','13:25:00',1.84),('15087','2013-12-05','13:30:00',1.86),('15087','2013-12-05','13:35:00',1.77),('15087','2013-12-05','13:40:00',1.71),('15087','2013-12-05','13:45:00',1.66),('15087','2013-12-05','13:50:00',1.67),('15087','2013-12-05','13:55:00',1.62),('15087','2013-12-05','14:00:00',1.57),('15087','2013-12-05','14:05:00',1.5),('15087','2013-12-05','14:10:00',1.4),('15087','2013-12-05','14:15:00',1.29),('15087','2013-12-05','14:20:00',1.23),('15087','2013-12-05','14:25:00',1.09),('15087','2013-12-03','09:40:00',1.18),('15087','2013-12-03','09:45:00',1.37),('15087','2013-12-03','09:50:00',1.53),('15087','2013-12-03','09:55:00',1.42),('15087','2013-12-03','10:00:00',1.92),('15087','2013-12-03','10:05:00',2.03),('15087','2013-12-03','10:10:00',2.1),('15087','2013-12-03','10:15:00',2.14),('15087','2013-12-03','10:20:00',2.19),('15087','2013-12-03','10:25:00',2.26),('15087','2013-12-03','10:30:00',2.32),('15087','2013-12-03','10:35:00',2.35),('15087','2013-12-03','10:40:00',2.43),('15087','2013-12-03','10:45:00',2.48),('15087','2013-12-03','10:50:00',2.54),('15087','2013-12-03','10:55:00',2.61),('15087','2013-12-03','11:00:00',2.66),('15087','2013-12-03','11:05:00',2.7),('15087','2013-12-03','11:10:00',2.74),('15087','2013-12-03','11:15:00',2.77),('15087','2013-12-03','11:20:00',2.77),('15087','2013-12-03','11:25:00',2.78),('15087','2013-12-03','11:30:00',2.77),('15087','2013-12-03','11:35:00',2.79),('15087','2013-12-03','11:40:00',2.8),('15087','2013-12-03','11:45:00',2.82),('15087','2013-12-03','11:50:00',2.82),('15087','2013-12-03','11:55:00',2.84),('15087','2013-12-03','12:00:00',2.84),('15087','2013-12-03','12:05:00',2.86),('15087','2013-12-03','12:10:00',2.88),('15087','2013-12-03','12:15:00',2.9),('15087','2013-12-03','12:20:00',2.88),('15087','2013-12-03','12:25:00',2.85),('15087','2013-12-03','12:30:00',2.88),('15087','2013-12-03','12:35:00',2.87),('15087','2013-12-03','12:40:00',2.9),('15087','2013-12-03','12:45:00',2.91),('15087','2013-12-03','12:50:00',2.98),('15087','2013-12-03','12:55:00',3.04),('15087','2013-12-03','13:00:00',2.92),('15087','2013-12-03','13:05:00',2.99),('15087','2013-12-03','13:10:00',2.99),('15087','2013-12-03','13:15:00',2.88),('15087','2013-12-03','13:20:00',2.78),('15087','2013-12-03','13:25:00',2.7),('15087','2013-12-03','13:30:00',2.53),('15087','2013-12-03','13:35:00',2.51),('15087','2013-12-03','13:40:00',2.31),('15087','2013-12-03','13:45:00',2.16),('15087','2013-12-03','13:50:00',2.09),('15087','2013-12-03','13:55:00',1.94),('15087','2013-12-03','14:00:00',1.86),('15087','2013-12-03','14:05:00',1.64),('15087','2013-12-03','14:10:00',1.52),('15087','2013-12-03','14:15:00',1.37),('15087','2013-12-03','14:20:00',1.15),('15087','2013-12-03','14:25:00',1.01),('15087','2013-12-03','14:35:00',1.01),('15087','2013-12-01','11:35:00',1.17),('15087','2013-12-01','11:40:00',1.19),('15087','2013-12-01','11:55:00',1.35),('15087','2013-12-01','12:00:00',1.18),('15087','2013-12-01','12:05:00',1.35),('15087','2013-12-01','12:10:00',1.71),('15087','2013-12-01','12:15:00',1.21),('15087','2013-11-30','09:10:00',1.22),('15087','2013-11-30','09:15:00',1.37),('15087','2013-11-30','09:20:00',1.56),('15087','2013-11-30','09:25:00',1.57),('15087','2013-11-30','09:30:00',1.78),('15087','2013-11-30','09:35:00',2.01),('15087','2013-11-30','09:40:00',2.02),('15087','2013-11-30','09:45:00',1.57),('15087','2013-11-30','09:50:00',1.34),('15087','2013-11-30','09:55:00',1.24),('15087','2013-11-30','10:00:00',1.18),('15087','2013-11-30','10:05:00',1.05),('15087','2013-11-30','10:15:00',1.11),('15087','2013-11-30','10:20:00',1.25),('15087','2013-11-30','10:25:00',1.18),('15087','2013-11-30','10:30:00',1.29),('15087','2013-11-30','10:35:00',1.44),('15087','2013-11-30','10:40:00',1.59),('15087','2013-11-30','10:45:00',1.5),('15087','2013-11-30','10:50:00',1.32),('15087','2013-11-30','10:55:00',1.18),('15087','2013-11-30','11:00:00',1.1),('15087','2013-11-30','11:05:00',1.46),('15087','2013-11-30','11:10:00',1.47),('15087','2013-11-30','11:15:00',1.41),('15087','2013-11-30','11:20:00',1.32),('15087','2013-11-30','11:25:00',1.38),('15087','2013-11-30','11:30:00',1.17),('15087','2013-11-30','11:35:00',1.09),('15087','2013-11-30','11:40:00',1.01),('15087','2013-11-29','09:10:00',1.09),('15087','2013-11-29','09:15:00',1.15),('15087','2013-11-29','09:20:00',1.24),('15087','2013-11-29','09:25:00',1.41),('15087','2013-11-29','09:30:00',1.55),('15087','2013-11-29','09:35:00',1.65),('15087','2013-11-29','09:40:00',1.77),('15087','2013-11-29','09:45:00',1.87),('15087','2013-11-29','09:50:00',1.96),('15087','2013-11-29','09:55:00',2.05),('15087','2013-11-29','10:00:00',2.13),('15087','2013-11-29','10:05:00',2.19),('15087','2013-11-29','10:10:00',2.25),('15087','2013-11-29','10:15:00',2.31),('15087','2013-11-29','10:20:00',2.37),('15087','2013-11-29','10:25:00',2.43),('15087','2013-11-29','10:30:00',2.48),('15087','2013-11-29','10:35:00',2.5),('15087','2013-11-29','10:40:00',2.59),('15087','2013-11-29','10:45:00',2.64),('15087','2013-11-29','10:50:00',2.67),('15087','2013-11-29','10:55:00',2.7),('15087','2013-11-29','11:00:00',2.73),('15087','2013-11-29','11:05:00',2.76),('15087','2013-11-29','11:10:00',2.79),('15087','2013-11-29','11:15:00',2.8),('15087','2013-11-29','11:20:00',2.82),('15087','2013-11-29','11:25:00',2.84),('15087','2013-11-29','11:30:00',2.86),('15087','2013-11-29','11:35:00',2.86),('15087','2013-11-29','11:40:00',2.87),('15087','2013-11-29','11:45:00',2.87),('15087','2013-11-29','11:50:00',2.88),('15087','2013-11-29','11:55:00',2.87),('15087','2013-11-29','12:00:00',2.88),('15087','2013-11-29','12:05:00',2.87),('15087','2013-11-29','12:10:00',2.86),('15087','2013-11-29','12:15:00',2.84),('15087','2013-11-29','12:20:00',2.7),('15087','2013-11-29','12:25:00',2.77),('15087','2013-11-29','12:30:00',2.7),('15087','2013-11-29','12:35:00',2.64),('15087','2013-11-29','12:40:00',2.64),('15087','2013-11-29','12:45:00',2.55),('15087','2013-11-29','12:50:00',2.56),('15087','2013-11-29','12:55:00',2.41),('15087','2013-11-29','13:00:00',2.3),('15087','2013-11-29','13:05:00',2.32),('15087','2013-11-29','13:10:00',2.31),('15087','2013-11-29','13:15:00',2.24),('15087','2013-11-29','13:20:00',2.12),('15087','2013-11-29','13:25:00',2.12),('15087','2013-11-29','13:30:00',2.05),('15087','2013-11-29','13:35:00',2.03),('15087','2013-11-29','13:40:00',1.99),('15087','2013-11-29','13:45:00',1.85),('15087','2013-11-29','13:50:00',1.78),('15087','2013-11-29','13:55:00',1.84),('15087','2013-11-29','14:00:00',1.67),('15087','2013-11-29','14:05:00',1.62),('15087','2013-11-29','14:10:00',1.57),('15087','2013-11-29','14:15:00',1.51),('15087','2013-11-29','14:20:00',1.4),('15087','2013-11-29','14:25:00',1.31),('15087','2013-11-29','14:30:00',1.18),('15087','2013-11-29','14:35:00',1.07),('15087','2013-11-28','12:55:00',1.14),('15087','2014-04-20','07:50:00',1.03),('15087','2014-04-20','07:55:00',1.14),('15087','2014-04-20','08:00:00',1.1),('15087','2014-04-20','08:05:00',1.18),('15087','2014-04-20','08:10:00',1.31),('15087','2014-04-20','08:15:00',1.46),('15087','2014-04-20','08:20:00',1.96),('15087','2014-04-20','08:25:00',2.27),('15087','2014-04-20','08:30:00',2.41),('15087','2014-04-20','08:35:00',2.01),('15087','2014-04-20','08:45:00',1.89),('15087','2014-04-20','08:50:00',1.34),('15087','2014-04-20','08:55:00',1.39),('15087','2014-04-20','09:00:00',2.32),('15087','2014-04-20','09:05:00',1.41),('15087','2014-04-20','09:10:00',2.39),('15087','2014-04-20','09:15:00',2.83),('15087','2014-04-20','09:20:00',2.9),('15087','2014-04-20','09:25:00',3.38),('15087','2014-04-20','09:30:00',3.88),('15087','2014-04-20','09:35:00',3.48),('15087','2014-04-20','09:40:00',2.17),('15087','2014-04-20','09:45:00',1.46),('15087','2014-04-20','09:50:00',1.78),('15087','2014-04-20','09:55:00',2.03),('15087','2014-04-20','10:00:00',2.43),('15087','2014-04-20','10:05:00',3.17),('15087','2014-04-20','10:10:00',3.04),('15087','2014-04-20','10:15:00',3.17),('15087','2014-04-20','10:20:00',3.25),('15087','2014-04-20','10:25:00',3.13),('15087','2014-04-20','10:30:00',2.87),('15087','2014-04-20','10:35:00',3.09),('15087','2014-04-20','10:40:00',2.89),('15087','2014-04-20','10:45:00',2.98),('15087','2014-04-20','10:50:00',3.26),('15087','2014-04-20','10:55:00',3.24),('15087','2014-04-20','11:00:00',3.79),('15087','2014-04-20','11:05:00',3.77),('15087','2014-04-20','11:10:00',3.91),('15087','2014-04-20','11:15:00',3),('15087','2014-04-20','11:20:00',3.14),('15087','2014-04-20','11:25:00',4.58),('15087','2014-04-20','11:30:00',4.67),('15087','2014-04-20','11:35:00',4.69),('15087','2014-04-20','11:40:00',2.46),('15087','2014-04-20','11:45:00',2.98),('15087','2014-04-20','11:50:00',3.18),('15087','2014-04-20','11:55:00',4.59),('15087','2014-04-20','12:00:00',4.82),('15087','2014-04-20','12:05:00',4.74),('15087','2014-04-20','12:10:00',3.49),('15087','2014-04-20','12:15:00',1.75),('15087','2014-04-20','12:20:00',3.68),('15087','2014-04-20','12:25:00',2.31),('15087','2014-04-20','12:30:00',5.09),('15087','2014-04-20','12:35:00',4.78),('15087','2014-04-20','12:40:00',4.78),('15087','2014-04-20','12:45:00',4.76),('15087','2014-04-20','12:50:00',4.79),('15087','2014-04-20','12:55:00',4.79),('15087','2014-04-20','13:00:00',4.78),('15087','2014-04-20','13:05:00',4.78),('15087','2014-04-20','13:10:00',4.83),('15087','2014-04-20','13:15:00',4.86),('15087','2014-04-20','13:20:00',4.73),('15087','2014-04-20','13:25:00',4.72),('15087','2014-04-20','13:30:00',4.74),('15087','2014-04-20','13:35:00',4.74),('15087','2014-04-20','13:40:00',4.73),('15087','2014-04-20','13:45:00',4.7),('15087','2014-04-20','13:50:00',4.68),('15087','2014-04-20','13:55:00',4.5),('15087','2014-04-20','14:00:00',4.49),('15087','2014-04-20','14:05:00',4.44),('15087','2014-04-20','14:10:00',4.53),('15087','2014-04-20','14:15:00',4.64),('15087','2014-04-20','14:20:00',3.51),('15087','2014-04-20','14:25:00',3.47),('15087','2014-04-20','14:30:00',3.24),('15087','2014-04-20','14:35:00',2.74),('15087','2014-04-20','14:40:00',2.72),('15087','2014-04-20','14:45:00',2.96),('15087','2014-04-20','14:50:00',2.89),('15087','2014-04-20','14:55:00',3.22),('15087','2014-04-20','15:00:00',4.25),('15087','2014-04-20','15:05:00',3.61),('15087','2014-04-20','15:10:00',3.93),('15087','2014-04-20','15:15:00',3.88),('15087','2014-04-20','15:20:00',3.66),('15087','2014-04-20','15:25:00',3.69),('15087','2014-04-20','15:30:00',3.57),('15087','2014-04-20','15:35:00',3.44),('15087','2014-04-20','15:40:00',3.6),('15087','2014-04-20','15:45:00',2.61),('15087','2014-04-20','15:50:00',2.66),('15087','2014-04-20','15:55:00',3.35),('15087','2014-04-20','16:00:00',3.07),('15087','2014-04-20','16:05:00',2.91),('15087','2014-04-20','16:10:00',3.15),('15087','2014-04-20','16:15:00',3.13),('15087','2014-04-20','16:20:00',3.09),('15087','2014-04-20','16:25:00',2.82),('15087','2014-04-20','16:30:00',3.03),('15087','2014-04-20','16:35:00',2.79),('15087','2014-04-20','16:40:00',2.36),('15087','2014-04-20','16:45:00',2.05),('15087','2014-04-20','16:50:00',2.45),('15087','2014-04-20','16:55:00',2.6),('15087','2014-04-20','17:00:00',2.46),('15087','2014-04-20','17:05:00',2.34),('15087','2014-04-20','17:10:00',2.2),('15087','2014-04-20','17:15:00',2.12),('15087','2014-04-20','17:20:00',2.03),('15087','2014-04-20','17:25:00',1.89),('15087','2014-04-20','17:30:00',1.67),('15087','2014-04-20','17:35:00',1.52),('15087','2014-04-20','17:40:00',1.53),('15087','2014-04-20','17:45:00',1.35),('15087','2014-04-20','17:50:00',1.28),('15087','2014-04-20','17:55:00',1.33),('15087','2014-04-20','18:00:00',1.24),('15087','2014-04-20','18:05:00',1.11),('15087','2014-04-20','18:10:00',1.05),('15087','2013-11-27','09:35:00',1.01),('15087','2013-11-27','09:40:00',1.1),('15087','2013-11-27','09:50:00',1.19),('15087','2013-11-27','09:55:00',1.56),('15087','2013-11-27','10:00:00',1.3),('15087','2013-11-27','10:05:00',1.31),('15087','2013-11-27','10:10:00',1.3),('15087','2013-11-27','10:15:00',1.33),('15087','2013-11-27','10:20:00',1.2),('15087','2013-11-27','10:25:00',1.11),('15087','2013-11-27','10:30:00',1.14),('15087','2013-11-27','10:35:00',1.21),('15087','2013-11-27','10:40:00',1.35),('15087','2013-11-27','10:45:00',1.51),('15087','2013-11-27','10:50:00',1.38),('15087','2013-11-27','10:55:00',1.41),('15087','2013-11-27','11:00:00',1.49),('15087','2013-11-27','11:05:00',1.51),('15087','2013-11-27','11:10:00',1.96),('15087','2013-11-27','11:15:00',1.49),('15087','2013-11-27','11:20:00',1.48),('15087','2013-11-27','11:25:00',1.54),('15087','2013-11-27','11:30:00',2.47),('15087','2013-11-27','11:35:00',2.3),('15087','2013-11-27','11:40:00',1.67),('15087','2013-11-27','11:45:00',1.72),('15087','2013-11-27','11:50:00',2.8),('15087','2013-11-27','11:55:00',3.08),('15087','2013-11-27','12:00:00',3.28),('15087','2013-11-27','12:05:00',2.31),('15087','2013-11-27','12:10:00',1.62),('15087','2013-11-27','12:15:00',2.08),('15087','2013-11-27','12:20:00',3.2),('15087','2013-11-27','12:25:00',1.82),('15087','2013-11-27','12:30:00',1.36),('15087','2013-11-27','12:35:00',2.89),('15087','2013-11-27','12:40:00',1.42),('15087','2013-11-27','12:50:00',1.01),('15087','2013-11-27','12:55:00',1.02),('15087','2013-11-27','13:00:00',1.09),('15087','2013-11-27','13:05:00',1.07),('15087','2013-11-27','13:10:00',1.06),('15087','2013-11-27','13:15:00',1.07),('15087','2013-11-27','13:20:00',1.03),('15087','2013-11-27','13:25:00',1.01),('15087','2013-11-27','13:30:00',1.04),('15087','2013-11-27','13:40:00',1.02),('15087','2013-11-26','09:05:00',1),('15087','2013-11-26','09:10:00',1.27),('15087','2013-11-26','09:15:00',1.22),('15087','2013-11-26','09:20:00',1.15),('15087','2013-11-26','09:25:00',1.13),('15087','2013-11-26','09:30:00',1.22),('15087','2013-11-26','09:35:00',1.37),('15087','2013-11-26','09:40:00',1.6),('15087','2013-11-26','09:45:00',1.22),('15087','2013-11-26','09:50:00',1.25),('15087','2013-11-26','09:55:00',1.98),('15087','2013-11-26','10:00:00',1.43),('15087','2013-11-26','10:05:00',1.59),('15087','2013-11-26','10:10:00',1.33),('15087','2013-11-26','10:20:00',1.47),('15087','2013-11-26','10:25:00',2.06),('15087','2013-11-26','10:30:00',2.33),('15087','2013-11-26','10:35:00',2.8),('15087','2013-11-26','10:40:00',2.82),('15087','2013-11-26','10:45:00',2.89),('15087','2013-11-26','10:50:00',2.88),('15087','2013-11-26','10:55:00',2.91),('15087','2013-11-26','11:00:00',3.07),('15087','2013-11-26','11:05:00',2.81),('15087','2013-11-26','11:10:00',3.43),('15087','2013-11-26','11:15:00',3.63),('15087','2013-11-26','11:20:00',2.45),('15087','2013-11-26','11:25:00',3.4),('15087','2013-11-26','11:30:00',3.44),('15087','2013-11-26','11:35:00',2.47),('15087','2013-11-26','11:40:00',2.97),('15087','2013-11-26','11:45:00',3.5),('15087','2013-11-26','11:50:00',2.85),('15087','2013-11-26','11:55:00',2.03),('15087','2013-11-26','12:00:00',1.18),('15087','2013-11-26','12:05:00',1.7),('15087','2013-11-26','12:15:00',1.38),('15087','2013-11-26','12:20:00',3.05),('15087','2013-11-26','12:25:00',2.97),('15087','2013-11-26','12:30:00',2.85),('15087','2013-11-26','12:35:00',2.88),('15087','2013-11-26','12:40:00',2.88),('15087','2013-11-26','12:45:00',2.76),('15087','2013-11-26','12:50:00',2.72),('15087','2013-11-26','12:55:00',2.67),('15087','2013-11-26','13:00:00',2.51),('15087','2013-11-26','13:05:00',2.54),('15087','2013-11-26','13:10:00',2.43),('15087','2013-11-26','13:15:00',2.23),('15087','2013-11-26','13:20:00',2.26),('15087','2013-11-26','13:25:00',2.38),('15087','2013-11-26','13:30:00',2.27),('15087','2013-11-26','13:35:00',2.23),('15087','2013-11-26','13:40:00',2.19),('15087','2013-11-26','13:45:00',2.13),('15087','2013-11-26','13:50:00',2.19),('15087','2013-11-26','13:55:00',2.18),('15087','2013-11-26','14:00:00',2.34),('15087','2013-11-26','14:05:00',2.23),('15087','2013-11-26','14:10:00',2.4),('15087','2013-11-26','14:15:00',2.71),('15087','2013-11-26','14:20:00',2.44),('15087','2013-11-26','14:25:00',1.61),('15087','2013-11-26','14:30:00',1.15),('15087','2013-11-26','14:35:00',1.37),('15087','2013-11-26','14:40:00',1.32),('15087','2013-11-26','14:45:00',1.4),('15087','2013-11-26','14:50:00',1.34),('15087','2013-11-26','14:55:00',1.45),('15087','2013-11-26','15:00:00',1.24),('15087','2013-11-25','08:45:00',1.05),('15087','2013-11-25','08:50:00',1.22),('15087','2013-11-25','08:55:00',1.44),('15087','2013-11-25','09:00:00',1.6),('15087','2013-11-25','09:05:00',1.84),('15087','2013-11-25','09:10:00',1.92),('15087','2013-11-25','09:15:00',2.09),('15087','2013-11-25','09:20:00',2.35),('15087','2013-11-25','09:25:00',1.72),('15087','2013-11-25','09:30:00',1.8),('15087','2013-11-25','09:35:00',2.09),('15087','2013-11-25','09:40:00',2.22),('15087','2013-11-25','09:45:00',1.07),('15087','2013-11-25','09:50:00',1.9),('15087','2013-11-25','09:55:00',1.48),('15087','2013-11-25','10:00:00',1.43),('15087','2013-11-25','10:05:00',2.07),('15087','2013-11-25','10:10:00',1.45),('15087','2013-11-25','10:15:00',2.24),('15087','2013-11-25','10:20:00',1.2),('15087','2013-11-25','10:25:00',1.53),('15087','2013-11-25','10:30:00',1.91),('15087','2013-11-25','10:35:00',2.38),('15087','2013-11-25','10:40:00',3.37),('15087','2013-11-25','10:45:00',3.04),('15087','2013-11-25','10:50:00',2.41),('15087','2013-11-25','10:55:00',2.26),('15087','2013-11-25','11:00:00',2.91),('15087','2013-11-25','11:05:00',3.1),('15087','2013-11-25','11:10:00',3.53),('15087','2013-11-25','11:15:00',3.08),('15087','2013-11-25','11:20:00',1.16),('15087','2013-11-25','11:25:00',1.29),('15087','2013-11-25','11:30:00',1.58),('15087','2013-11-25','11:35:00',1.33),('15087','2013-11-25','11:40:00',1.08),('15087','2013-11-25','11:45:00',1.22),('15087','2013-11-25','11:50:00',1.47),('15087','2013-11-25','11:55:00',1.36),('15087','2013-11-25','12:00:00',1.69),('15087','2013-11-25','12:05:00',1.66),('15087','2013-11-25','12:10:00',2.42),('15087','2013-11-25','12:15:00',1.82),('15087','2013-11-25','12:20:00',1.51),('15087','2013-11-25','12:25:00',1.54),('15087','2013-11-25','12:30:00',1.36),('15087','2013-11-25','12:35:00',1.26),('15087','2013-11-25','12:40:00',2.68),('15087','2013-11-25','12:45:00',2.85),('15087','2013-11-25','12:50:00',2.37),('15087','2013-11-25','12:55:00',2.55),('15087','2013-11-25','13:00:00',2.98),('15087','2013-11-25','13:05:00',2.82),('15087','2013-11-25','13:10:00',2.26),('15087','2013-11-25','13:15:00',1.95),('15087','2013-11-25','13:20:00',3.15),('15087','2013-11-25','13:25:00',3.01),('15087','2013-11-25','13:30:00',1.56),('15087','2013-11-25','13:35:00',1.05),('15087','2013-11-24','09:55:00',1.28),('15087','2013-11-24','10:00:00',1.51),('15087','2013-11-24','10:05:00',1.6),('15087','2013-11-24','10:10:00',1.64),('15087','2013-11-24','10:15:00',1.52),('15087','2013-11-24','10:20:00',1.33),('15087','2013-11-24','10:25:00',1.87),('15087','2013-11-24','10:30:00',1.62),('15087','2013-11-24','10:35:00',1.39),('15087','2013-11-24','10:40:00',1.13),('15087','2013-11-24','10:45:00',1.05),('15087','2013-11-24','10:50:00',1.1),('15087','2013-11-24','10:55:00',1.21),('15087','2013-11-24','11:00:00',1.25),('15087','2013-11-24','11:05:00',1.3),('15087','2013-11-24','11:10:00',1.37),('15087','2013-11-24','11:15:00',1.42),('15087','2013-11-24','11:20:00',1.58),('15087','2013-11-24','11:25:00',1.59),('15087','2013-11-24','11:30:00',1.53),('15087','2013-11-24','11:35:00',1.3),('15087','2013-11-24','11:40:00',1.19),('15087','2013-11-24','11:45:00',1.18),('15087','2013-11-24','11:50:00',1.32),('15087','2013-11-24','11:55:00',1.18),('15087','2013-11-24','12:25:00',1.05),('15087','2013-11-24','12:30:00',1.02),('15087','2013-11-24','12:35:00',1.02),('15087','2013-11-24','12:40:00',1.06),('15087','2013-11-24','12:45:00',1.03),('15087','2013-11-24','12:50:00',1.02),('15087','2013-11-24','13:00:00',1.14),('15087','2013-11-24','13:05:00',1.52),('15087','2013-11-24','13:10:00',1.59),('15087','2013-11-24','13:15:00',1.53),('15087','2013-11-24','13:20:00',1.24),('15087','2013-11-24','13:25:00',1),('15087','2013-11-23','10:15:00',1.23),('15087','2013-11-23','10:20:00',1.28),('15087','2013-11-23','10:25:00',1.69),('15087','2013-11-23','10:30:00',1.93),('15087','2013-11-23','10:35:00',1.1),('15087','2013-11-23','10:40:00',2.63),('15087','2013-11-23','13:20:00',1.17),('15087','2013-11-23','13:25:00',1.33),('15087','2013-11-23','13:30:00',1.2),('15087','2013-11-23','13:35:00',1.6),('15087','2013-11-23','13:40:00',1.3),('15087','2013-11-23','13:55:00',1.1),('15087','2013-11-23','14:00:00',1.14),('15087','2013-11-23','14:05:00',1.05),('15087','2013-11-21','09:10:00',1.05),('15087','2013-11-21','09:15:00',1.09),('15087','2013-11-21','09:20:00',1.16),('15087','2013-11-21','09:25:00',1.12),('15087','2013-11-21','09:40:00',1.59),('15087','2013-11-21','09:45:00',1.94),('15087','2013-11-21','09:50:00',1.42),('15087','2013-11-21','09:55:00',1.95),('15087','2013-11-21','10:00:00',1.82),('15087','2013-11-21','10:05:00',2.33),('15087','2013-11-21','10:10:00',2.33),('15087','2013-11-21','10:15:00',2.64),('15087','2013-11-21','10:20:00',2.26),('15087','2013-11-21','10:25:00',1.65),('15087','2013-11-21','10:30:00',2.56),('15087','2013-11-21','10:35:00',2.7),('15087','2013-11-21','10:40:00',2.96),('15087','2013-11-21','10:45:00',1.85),('15087','2013-11-21','11:15:00',1.39),('15087','2013-11-21','11:20:00',1.48),('15087','2013-11-21','11:25:00',1.71),('15087','2013-11-21','11:30:00',2.27),('15087','2013-11-21','11:35:00',1.96),('15087','2013-11-21','11:40:00',2.27),('15087','2013-11-21','11:45:00',2.6),('15087','2013-11-21','11:50:00',2.71),('15087','2013-11-21','11:55:00',2.98),('15087','2013-11-21','12:00:00',1.41),('15087','2013-11-21','12:05:00',2.99),('15087','2013-11-21','12:10:00',2.99),('15087','2013-11-21','12:15:00',2.97),('15087','2013-11-21','12:20:00',2.97),('15087','2013-11-21','12:25:00',2.85),('15087','2013-11-21','12:30:00',3.02),('15087','2013-11-21','12:35:00',3.11),('15087','2013-11-21','12:40:00',3.24),('15087','2013-11-21','12:45:00',3.15),('15087','2013-11-21','12:50:00',3.1),('15087','2013-11-21','12:55:00',3.02),('15087','2013-11-21','13:00:00',3.06),('15087','2013-11-21','13:05:00',2.81),('15087','2013-11-21','13:10:00',2.56),('15087','2013-11-21','13:15:00',2.88),('15087','2013-11-21','13:20:00',2.58),('15087','2013-11-21','13:25:00',2.04),('15087','2013-11-21','13:40:00',1.74),('15087','2013-11-21','13:45:00',2.32),('15087','2013-11-21','13:50:00',1.25),('15087','2013-11-21','13:55:00',2.31),('15087','2013-11-21','14:00:00',2.17),('15087','2013-11-21','14:05:00',1.12),('15087','2013-11-21','14:10:00',1.08),('15087','2013-11-21','14:25:00',1.11),('15087','2013-11-21','14:40:00',1.28),('15087','2013-11-21','14:45:00',1.13),('15087','2013-11-20','09:10:00',1.16),('15087','2013-11-20','09:15:00',1.55),('15087','2013-11-20','09:20:00',1.64),('15087','2013-11-20','09:25:00',1.77),('15087','2013-11-20','09:30:00',1.9),('15087','2013-11-20','10:00:00',1.84),('15087','2013-11-20','10:10:00',1.03),('15087','2013-11-20','10:15:00',2.07),('15087','2013-11-20','11:20:00',1.03),('15087','2013-11-20','11:25:00',1.25),('15087','2013-11-20','11:30:00',1.12),('15087','2013-11-20','11:35:00',1.11),('15087','2013-11-20','11:40:00',1.25),('15087','2013-11-20','11:45:00',4.25),('15087','2013-11-20','11:50:00',3.9),('15087','2013-11-20','11:55:00',1.77),('15087','2013-11-20','12:15:00',1.06),('15087','2013-11-20','12:20:00',1.86),('15087','2013-11-20','12:25:00',1.33),('15087','2013-11-20','12:45:00',1.2),('15087','2013-11-20','12:50:00',2.03),('15087','2013-11-20','12:55:00',2.56),('15087','2013-11-20','13:00:00',1.77),('15087','2013-11-20','13:05:00',1.75),('15087','2013-11-20','13:20:00',1.4),('15087','2013-11-20','13:25:00',1.21),('15087','2013-11-20','13:35:00',1.25),('15087','2013-11-20','13:45:00',1.3),('15087','2013-11-20','13:50:00',1.75),('15087','2013-11-20','14:25:00',1.5),('15087','2013-11-20','14:40:00',1.05),('15087','2013-11-20','14:45:00',1.18),('15087','2013-11-20','15:05:00',1.03),('15087','2013-11-19','09:35:00',1.26),('15087','2013-11-19','09:40:00',2.17),('15087','2013-11-19','09:45:00',2.12),('15087','2013-11-19','10:00:00',1.43),('15087','2013-11-19','10:05:00',1.19),('15087','2013-11-19','10:50:00',1.44),('15087','2013-11-19','11:20:00',2.2),('15087','2013-11-19','11:25:00',2.43),('15087','2013-11-19','11:30:00',2.51),('15087','2013-11-19','11:35:00',3.09),('15087','2013-11-19','11:40:00',2.61),('15087','2013-11-19','11:45:00',2.79),('15087','2013-11-19','11:50:00',2.65),('15087','2013-11-19','11:55:00',2.48),('15087','2013-11-19','12:00:00',2.07),('15087','2013-11-19','12:05:00',2.82),('15087','2013-11-19','12:10:00',2.69),('15087','2013-11-19','12:15:00',2.72),('15087','2013-11-19','12:20:00',1.2),('15087','2013-11-19','12:30:00',1.71),('15087','2013-11-19','12:40:00',1.38),('15087','2013-11-19','12:45:00',2.24),('15087','2013-11-19','12:50:00',2.2),('15087','2013-11-19','12:55:00',2.97),('15087','2013-11-19','13:00:00',1.04),('15087','2013-11-19','13:10:00',1.09),('15087','2013-11-19','13:15:00',1.93),('15087','2013-11-19','13:20:00',1.91),('15087','2013-11-19','15:25:00',1.06),('15087','2013-11-19','15:30:00',1.24),('15087','2013-11-18','09:15:00',1.25),('15087','2013-11-18','09:20:00',1.6),('15087','2013-11-18','09:25:00',1.7),('15087','2013-11-18','09:30:00',1.56),('15087','2013-11-18','09:35:00',2.13),('15087','2013-11-18','09:40:00',1.56),('15087','2013-11-18','09:45:00',1.37),('15087','2013-11-18','09:50:00',1.04),('15087','2013-11-18','09:55:00',1.08),('15087','2013-11-18','10:00:00',1.24),('15087','2013-11-18','10:05:00',1.45),('15087','2013-11-18','10:10:00',1.8),('15087','2013-11-18','10:15:00',1.87),('15087','2013-11-18','10:20:00',1.52),('15087','2013-11-18','10:25:00',1.42),('15087','2013-11-18','10:30:00',1.25),('15087','2013-11-18','10:35:00',1.24),('15087','2013-11-18','10:40:00',1.29),('15087','2013-11-18','10:45:00',1.35),('15087','2013-11-18','10:50:00',1.25),('15087','2013-11-18','10:55:00',1.1),('15087','2013-11-18','11:30:00',1.1),('15087','2013-11-18','11:35:00',1.16),('15087','2013-11-18','11:40:00',1.2),('15087','2013-11-18','11:45:00',1.24),('15087','2013-11-18','11:50:00',1.32),('15087','2013-11-18','11:55:00',1.43),('15087','2013-11-18','12:00:00',1.53),('15087','2013-11-18','12:05:00',1.61),('15087','2013-11-18','12:10:00',1.58),('15087','2013-11-18','12:15:00',1.67),('15087','2013-11-18','12:20:00',1.77),('15087','2013-11-18','12:25:00',1.81),('15087','2013-11-18','12:30:00',1.61),('15087','2013-11-18','12:35:00',1.39),('15087','2013-11-18','12:40:00',1.15),('15087','2013-11-18','12:45:00',1.02),('15087','2013-11-18','13:10:00',1.08),('15087','2013-11-18','13:15:00',1.01),('15087','2013-11-18','13:35:00',1.17),('15087','2013-11-18','13:40:00',1.22),('15087','2013-11-18','13:45:00',1.11),('15087','2013-11-18','13:50:00',1.03),('15087','2014-04-19','07:40:00',1.06),('15087','2014-04-19','07:55:00',2.02),('15087','2014-04-19','08:00:00',1.49),('15087','2014-04-19','08:05:00',1.17),('15087','2014-04-19','08:10:00',1.56),('15087','2014-04-19','08:15:00',1.16),('15087','2014-04-19','08:20:00',1.27),('15087','2014-04-19','08:25:00',1.75),('15087','2014-04-19','08:30:00',2.35),('15087','2014-04-19','08:35:00',2.44),('15087','2014-04-19','08:40:00',2.27),('15087','2014-04-19','08:45:00',1.96),('15087','2014-04-19','08:50:00',1.52),('15087','2014-04-19','09:20:00',1.13),('15087','2014-04-19','09:25:00',1.67),('15087','2014-04-19','09:30:00',2.38),('15087','2014-04-19','09:35:00',2.1),('15087','2014-04-19','09:40:00',1.22),('15087','2014-04-19','10:40:00',1.35),('15087','2014-04-19','10:45:00',1.22),('15087','2014-04-19','10:50:00',1.35),('15087','2014-04-19','10:55:00',1.77),('15087','2014-04-19','11:00:00',1.77),('15087','2014-04-19','11:05:00',1.39),('15087','2014-04-19','11:10:00',1.38),('15087','2014-04-19','11:15:00',2.17),('15087','2014-04-19','11:20:00',3.36),('15087','2014-04-19','11:25:00',2.8),('15087','2014-04-19','11:30:00',2.76),('15087','2014-04-19','11:35:00',2.83),('15087','2014-04-19','11:40:00',2.67),('15087','2014-04-19','11:45:00',2.27),('15087','2014-04-19','11:50:00',1.79),('15087','2014-04-19','11:55:00',1.08),('15087','2014-04-19','13:15:00',1.69),('15087','2014-04-19','13:20:00',1.41),('15087','2014-04-19','14:30:00',1.57),('15087','2014-04-19','14:35:00',1.68),('15087','2014-04-19','14:40:00',2.08),('15087','2014-04-19','14:45:00',2.15),('15087','2014-04-19','14:50:00',1.29),('15087','2014-04-19','14:55:00',1.19),('15087','2014-04-19','15:00:00',1.63),('15087','2014-04-19','15:05:00',1.27),('15087','2014-04-19','15:25:00',1.21),('15087','2014-04-19','15:30:00',1.14),('15087','2014-04-19','15:45:00',1.14),('15087','2014-04-19','15:50:00',3.59),('15087','2014-04-19','15:55:00',2.89),('15087','2014-04-19','16:00:00',2.64),('15087','2014-04-19','16:05:00',2.4),('15087','2014-04-19','16:10:00',2.07),('15087','2014-04-19','16:15:00',1.94),('15087','2014-04-19','16:20:00',2.23),('15087','2014-04-19','16:25:00',2.14),('15087','2014-04-19','16:30:00',3.19),('15087','2014-04-19','16:35:00',1.68),('15087','2014-04-19','16:40:00',1.14),('15087','2014-04-19','16:45:00',1.04),('15087','2014-04-19','17:10:00',1.01),('15087','2014-04-19','17:15:00',1.17),('15087','2014-04-19','17:20:00',1.93),('15087','2014-04-19','17:25:00',1.4),('15087','2014-04-19','17:30:00',1.24),('15087','2013-11-16','13:05:00',1.06),('15087','2013-11-15','09:10:00',1.1),('15087','2013-11-15','09:15:00',1.28),('15087','2013-11-15','09:20:00',1.04),('15087','2013-11-15','09:30:00',1.27),('15087','2013-11-15','09:35:00',1.39),('15087','2013-11-15','09:40:00',1.14),('15087','2013-11-15','10:10:00',1.14),('15087','2013-11-15','10:15:00',1.45),('15087','2013-11-15','10:20:00',1.32),('15087','2013-11-15','10:25:00',1.02),('15087','2013-11-15','10:50:00',1.15),('15087','2013-11-15','10:55:00',1.44),('15087','2013-11-15','11:00:00',1.38),('15087','2013-11-15','11:05:00',1.3),('15087','2013-11-15','11:10:00',1.24),('15087','2013-11-15','11:15:00',1.38),('15087','2013-11-15','11:20:00',1.8),('15087','2013-11-15','11:25:00',1.89),('15087','2013-11-15','11:30:00',2),('15087','2013-11-15','11:35:00',1.85),('15087','2013-11-15','11:40:00',2.09),('15087','2013-11-15','11:45:00',1.62),('15087','2013-11-15','11:50:00',1.36),('15087','2013-11-15','11:55:00',1.22),('15087','2013-11-15','12:00:00',1.23),('15087','2013-11-15','12:05:00',1.46),('15087','2013-11-15','12:10:00',1.13),('15087','2013-11-15','12:15:00',1.26),('15087','2013-11-15','12:20:00',1.59),('15087','2013-11-15','12:25:00',1.79),('15087','2013-11-15','12:30:00',1.38),('15087','2013-11-15','12:35:00',1.21),('15087','2013-11-15','12:40:00',1.13),('15087','2013-11-15','12:45:00',1.11),('15087','2013-11-15','12:50:00',1.18),('15087','2013-11-15','12:55:00',1.41),('15087','2013-11-15','13:00:00',1.5),('15087','2013-11-15','13:05:00',1.26),('15087','2013-11-15','13:10:00',1.11),('15087','2013-11-15','13:30:00',1.1),('15087','2013-11-15','13:35:00',1.26),('15087','2013-11-15','13:40:00',1.42),('15087','2013-11-15','13:45:00',1.87),('15087','2013-11-15','13:50:00',1.94),('15087','2013-11-15','13:55:00',1.27),('15087','2013-11-15','14:00:00',1.07),('15087','2013-11-14','09:00:00',1.79),('15087','2013-11-14','09:05:00',1.81),('15087','2013-11-14','09:10:00',1.61),('15087','2013-11-14','09:15:00',1.52),('15087','2013-11-14','09:20:00',2),('15087','2013-11-14','09:25:00',2.03),('15087','2013-11-14','09:30:00',2.08),('15087','2013-11-14','09:35:00',2.14),('15087','2013-11-14','09:40:00',2.17),('15087','2013-11-14','09:45:00',2.23),('15087','2013-11-14','09:50:00',1.71),('15087','2013-11-14','09:55:00',1.31),('15087','2013-11-14','10:05:00',1.72),('15087','2013-11-14','10:10:00',1.73),('15087','2013-11-14','10:15:00',2.54),('15087','2013-11-14','10:20:00',2.6),('15087','2013-11-14','10:25:00',2.59),('15087','2013-11-14','10:30:00',2.62),('15087','2013-11-14','10:35:00',2.63),('15087','2013-11-14','10:40:00',2.62),('15087','2013-11-14','10:45:00',2.6),('15087','2013-11-14','10:50:00',2.69),('15087','2013-11-14','10:55:00',2.72),('15087','2013-11-14','11:00:00',2.71),('15087','2013-11-14','11:05:00',2.85),('15087','2013-11-14','11:10:00',2.91),('15087','2013-11-14','11:15:00',2.97),('15087','2013-11-14','11:20:00',3.03),('15087','2013-11-14','11:25:00',3.05),('15087','2013-11-14','11:30:00',3.05),('15087','2013-11-14','11:35:00',2.73),('15087','2013-11-14','11:40:00',2.62),('15087','2013-11-14','11:45:00',1.91),('15087','2013-11-14','11:50:00',2.11),('15087','2013-11-14','11:55:00',2.4),('15087','2013-11-14','12:00:00',3.25),('15087','2013-11-14','12:05:00',2.07),('15087','2013-11-14','12:10:00',1.43),('15087','2013-11-14','12:15:00',1.46),('15087','2013-11-14','12:20:00',1.34),('15087','2013-11-14','12:25:00',1.12),('15087','2013-11-14','12:30:00',1.11),('15087','2013-11-14','12:35:00',1.15),('15087','2013-11-14','12:40:00',1.13),('15087','2013-11-14','12:45:00',1.16),('15087','2013-11-14','12:50:00',1.19),('15087','2013-11-14','12:55:00',1.16),('15087','2013-11-14','13:00:00',1.14),('15087','2013-11-14','13:05:00',1.01),('15087','2013-11-14','13:55:00',1.3),('15087','2013-11-13','10:05:00',1.11),('15087','2013-11-13','10:10:00',1.12),('15087','2013-11-13','10:15:00',1.17),('15087','2013-11-13','10:20:00',2.51),('15087','2013-11-13','10:25:00',3.59),('15087','2013-11-13','10:30:00',3.16),('15087','2013-11-13','10:35:00',3.56),('15087','2013-11-13','10:40:00',3.39),('15087','2013-11-13','10:45:00',3.16),('15087','2013-11-13','10:50:00',3.71),('15087','2013-11-13','10:55:00',3.28),('15087','2013-11-13','11:00:00',1.58),('15087','2013-11-13','11:30:00',1.04),('15087','2013-11-13','11:45:00',1.05),('15087','2013-11-13','11:50:00',1.21),('15087','2013-11-13','11:55:00',1.11),('15087','2013-11-13','12:55:00',1.01),('15087','2013-11-13','13:00:00',1.15),('15087','2013-11-13','13:05:00',1.36),('15087','2013-11-13','13:10:00',1.24),('15087','2013-11-13','13:15:00',1.21),('15087','2013-11-13','13:40:00',1.01),('15087','2013-11-13','13:55:00',1.59),('15087','2013-11-13','14:00:00',1.82),('15087','2013-11-13','14:05:00',1.71),('15087','2013-11-13','14:10:00',1.64),('15087','2013-11-13','14:15:00',1.66),('15087','2013-11-13','14:20:00',1.53),('15087','2013-11-13','14:25:00',1.63),('15087','2013-11-13','14:30:00',1.51),('15087','2013-11-13','14:35:00',1.13),('15087','2013-11-12','11:25:00',1.5),('15087','2013-11-12','11:35:00',1.13),('15087','2013-11-12','11:40:00',2.15),('15087','2013-11-12','11:45:00',1.13),('15087','2013-11-12','11:50:00',2.03),('15087','2013-11-12','11:55:00',1.06),('15087','2013-11-12','12:00:00',2.72),('15087','2013-11-12','12:05:00',1.66),('15087','2013-11-12','12:30:00',3.94),('15087','2013-11-12','12:35:00',3.55),('15087','2013-11-12','12:40:00',2.22),('15087','2013-11-12','12:45:00',2.1),('15087','2013-11-12','12:50:00',2.1),('15087','2013-11-12','12:55:00',2.44),('15087','2013-11-12','13:00:00',2.08),('15087','2013-11-12','13:05:00',2.11),('15087','2013-11-12','13:10:00',2.48),('15087','2013-11-12','13:15:00',2.36),('15087','2013-11-12','13:20:00',2.06),('15087','2013-11-12','13:25:00',2.23),('15087','2013-11-12','13:30:00',2),('15087','2013-11-12','13:35:00',2.08),('15087','2013-11-12','13:40:00',2.19),('15087','2013-11-12','13:45:00',1.82),('15087','2013-11-12','13:50:00',1.38),('15087','2013-11-12','13:55:00',1.52),('15087','2013-11-12','14:00:00',1.42),('15087','2013-11-12','14:05:00',1.32),('15087','2013-11-12','14:10:00',2.52),('15087','2013-11-12','14:15:00',2.55),('15087','2013-11-12','14:20:00',2.07),('15087','2013-11-12','14:25:00',1.22),('15087','2013-11-12','14:30:00',1.58),('15087','2013-11-12','14:35:00',1.51),('15087','2013-11-12','14:40:00',1.59),('15087','2013-11-12','14:45:00',1.35),('15087','2013-11-12','14:50:00',1.02),('15087','2013-11-11','09:50:00',1.28),('15087','2013-11-11','09:55:00',1.32),('15087','2013-11-11','10:00:00',1.03),('15087','2013-11-11','10:05:00',1.08),('15087','2013-11-11','10:10:00',1.32),('15087','2013-11-11','10:15:00',2.14),('15087','2013-11-11','10:20:00',2.6),('15087','2013-11-11','10:25:00',1.44),('15087','2013-11-11','11:05:00',1.61),('15087','2013-11-11','11:10:00',3.75),('15087','2013-11-11','11:15:00',2.9),('15087','2013-11-11','11:20:00',2.36),('15087','2013-11-11','11:25:00',2.75),('15087','2013-11-11','11:30:00',3.89),('15087','2013-11-11','11:35:00',2.72),('15087','2013-11-11','11:40:00',4.04),('15087','2013-11-11','11:45:00',2.95),('15087','2013-11-11','11:50:00',3.98),('15087','2013-11-11','11:55:00',3.72),('15087','2013-11-11','12:00:00',3.48),('15087','2013-11-11','12:05:00',3.33),('15087','2013-11-11','12:10:00',3.25),('15087','2013-11-11','12:15:00',2.83),('15087','2013-11-11','12:20:00',3.2),('15087','2013-11-11','12:25:00',3.29),('15087','2013-11-11','12:30:00',1.37),('15087','2013-11-11','12:40:00',1.81),('15087','2013-11-11','12:45:00',2.36),('15087','2013-11-11','12:50:00',1),('15087','2013-11-11','13:00:00',1.24),('15087','2013-11-11','13:05:00',1.04),('15087','2013-11-11','13:10:00',1.79),('15087','2013-11-11','13:15:00',1.99),('15087','2013-11-11','13:35:00',1.19),('15087','2013-11-11','13:40:00',1.7),('15087','2013-11-11','14:00:00',2.27),('15087','2013-11-11','14:05:00',1.56),('15087','2013-11-11','14:20:00',1.38),('15087','2013-11-11','14:25:00',1.95),('15087','2013-11-11','14:30:00',1.78),('15087','2013-11-11','14:35:00',1.7),('15087','2013-11-11','14:40:00',1.53),('15087','2013-11-10','08:35:00',1.33),('15087','2013-11-10','08:40:00',1.65),('15087','2013-11-10','08:45:00',1.25),('15087','2013-11-10','08:50:00',1.65),('15087','2013-11-10','08:55:00',1.61),('15087','2013-11-10','09:00:00',1.53),('15087','2013-11-10','09:05:00',1.2),('15087','2013-11-10','09:10:00',1.12),('15087','2013-11-10','09:15:00',1.58),('15087','2013-11-10','09:20:00',2.01),('15087','2013-11-10','09:25:00',2.18),('15087','2013-11-10','09:30:00',1.87),('15087','2013-11-10','09:35:00',1.87),('15087','2013-11-10','09:40:00',2.06),('15087','2013-11-10','09:45:00',2.29),('15087','2013-11-10','09:50:00',2.41),('15087','2013-11-10','09:55:00',2.4),('15087','2013-11-10','10:00:00',2.39),('15087','2013-11-10','10:05:00',2.66),('15087','2013-11-10','10:10:00',2.81),('15087','2013-11-10','10:15:00',2.76),('15087','2013-11-10','10:20:00',2.49),('15087','2013-11-10','10:25:00',3.06),('15087','2013-11-10','10:30:00',3.01),('15087','2013-11-10','10:35:00',1.96),('15087','2013-11-10','10:40:00',3.01),('15087','2013-11-10','10:45:00',2.37),('15087','2013-11-10','10:50:00',3.45),('15087','2013-11-10','10:55:00',3.26),('15087','2013-11-10','11:00:00',2.13),('15087','2013-11-10','11:05:00',1.61),('15087','2013-11-10','11:10:00',1.04),('15087','2013-11-10','11:20:00',1.02),('15087','2013-11-10','11:25:00',1.27),('15087','2013-11-10','11:35:00',1.25),('15087','2013-11-10','11:40:00',2.25),('15087','2013-11-10','11:45:00',2.4),('15087','2013-11-10','11:55:00',1.62),('15087','2013-11-10','12:05:00',1.61),('15087','2013-11-10','12:10:00',1.94),('15087','2013-11-10','12:15:00',3.09),('15087','2013-11-10','12:20:00',2.78),('15087','2013-11-10','12:25:00',2.67),('15087','2013-11-10','12:30:00',1.61),('15087','2013-11-10','12:35:00',2.52),('15087','2013-11-10','12:40:00',3.08),('15087','2013-11-10','12:45:00',3.17),('15087','2013-11-10','12:50:00',3.08),('15087','2013-11-10','12:55:00',1.65),('15087','2013-11-10','13:00:00',1.29),('15087','2013-11-10','13:45:00',1.1),('15087','2013-11-10','13:50:00',2.37),('15087','2013-11-10','13:55:00',1.77),('15087','2013-11-10','14:30:00',1.01),('15087','2013-11-09','09:30:00',1.02),('15087','2013-11-09','09:40:00',1.96),('15087','2013-11-09','09:45:00',1.5),('15087','2013-11-09','09:50:00',3.05),('15087','2013-11-09','09:55:00',2.89),('15087','2013-11-09','10:00:00',2.81),('15087','2013-11-09','10:05:00',2.49),('15087','2013-11-09','10:10:00',2.21),('15087','2013-11-09','10:15:00',2.43),('15087','2013-11-09','10:20:00',2.43),('15087','2013-11-09','10:25:00',1.49),('15087','2013-11-09','10:30:00',1.18),('15087','2013-11-09','10:35:00',1.39),('15087','2013-11-09','10:40:00',1.42),('15087','2013-11-09','10:45:00',1.58),('15087','2013-11-09','10:50:00',1.73),('15087','2013-11-09','10:55:00',2.1),('15087','2013-11-09','11:00:00',1.96),('15087','2013-11-09','11:05:00',2.71),('15087','2013-11-09','11:10:00',3.12),('15087','2013-11-09','11:15:00',2.9),('15087','2013-11-09','11:20:00',1.8),('15087','2013-11-09','11:25:00',2.55),('15087','2013-11-09','11:30:00',2.16),('15087','2013-11-09','11:35:00',1.66),('15087','2013-11-09','11:40:00',3.05),('15087','2013-11-09','11:45:00',3.46),('15087','2013-11-09','11:50:00',2.79),('15087','2013-11-09','11:55:00',3.37),('15087','2013-11-09','12:00:00',3.89),('15087','2013-11-09','12:05:00',3.67),('15087','2013-11-09','12:10:00',1.83),('15087','2013-11-09','12:15:00',2.14),('15087','2013-11-09','12:20:00',1.14),('15087','2013-11-09','12:25:00',1.76),('15087','2013-11-09','12:30:00',2.31),('15087','2013-11-09','12:35:00',3.6),('15087','2013-11-09','12:40:00',3.53),('15087','2013-11-09','12:45:00',2),('15087','2013-11-09','12:50:00',1.86),('15087','2013-11-09','12:55:00',1.68),('15087','2013-11-09','13:00:00',2.99),('15087','2013-11-09','13:05:00',2.21),('15087','2013-11-09','13:10:00',2.84),('15087','2013-11-09','13:15:00',2.73),('15087','2013-11-09','13:25:00',2.44),('15087','2013-11-09','13:30:00',2.36),('15087','2013-11-09','13:35:00',2.32),('15087','2013-11-09','13:40:00',2.25),('15087','2013-11-09','13:45:00',2.26),('15087','2013-11-09','13:50:00',2.24),('15087','2013-11-09','13:55:00',2.21),('15087','2013-11-09','14:00:00',2.02),('15087','2013-11-09','14:05:00',1.73),('15087','2013-11-09','14:10:00',1),('15087','2013-11-09','14:15:00',1.28),('15087','2013-11-09','14:20:00',1.89),('15087','2013-11-09','14:25:00',1.4),('15087','2013-11-09','14:35:00',1.1),('15087','2013-11-09','14:40:00',1.2),('15087','2013-11-09','14:50:00',1.29),('15087','2013-11-08','09:10:00',1.26),('15087','2013-11-08','09:15:00',1.12),('15087','2013-11-08','09:25:00',1.23),('15087','2013-11-08','09:30:00',2.13),('15087','2013-11-08','09:35:00',1.62),('15087','2013-11-08','09:40:00',1.37),('15087','2013-11-08','09:50:00',2.52),('15087','2013-11-08','09:55:00',1.65),('15087','2013-11-08','10:00:00',2.56),('15087','2013-11-08','10:05:00',1.77),('15087','2013-11-08','10:10:00',1.23),('15087','2013-11-08','10:40:00',1.14),('15087','2013-11-08','10:45:00',2.03),('15087','2013-11-08','10:50:00',3.2),('15087','2013-11-08','11:20:00',2.04),('15087','2013-11-08','11:35:00',2.45),('15087','2013-11-08','11:40:00',3.18),('15087','2013-11-08','11:45:00',3.23),('15087','2013-11-08','11:50:00',3.36),('15087','2013-11-08','11:55:00',3.33),('15087','2013-11-08','12:00:00',2.86),('15087','2013-11-08','12:05:00',3.02),('15087','2013-11-08','12:10:00',3.01),('15087','2013-11-08','12:20:00',1.24),('15087','2013-11-08','12:35:00',2.46),('15087','2013-11-08','12:40:00',2.75),('15087','2013-11-08','12:45:00',3.07),('15087','2013-11-08','12:50:00',2.99),('15087','2013-11-08','12:55:00',2.89),('15087','2013-11-08','13:00:00',2.71),('15087','2013-11-08','13:05:00',2.58),('15087','2013-11-08','13:10:00',2.82),('15087','2013-11-08','13:15:00',1.4),('15087','2013-11-08','13:20:00',2.31),('15087','2013-11-08','13:30:00',1.29),('15087','2013-11-08','13:35:00',2.39),('15087','2013-11-08','13:40:00',2.29),('15087','2013-11-08','13:45:00',2.19),('15087','2013-11-08','13:50:00',2.06),('15087','2013-11-08','13:55:00',2.16),('15087','2013-11-08','14:00:00',2.08),('15087','2013-11-08','14:05:00',1.79),('15087','2013-11-08','14:10:00',1.84),('15087','2013-11-08','14:15:00',1.05),('15087','2013-11-08','14:20:00',1.6),('15087','2013-11-08','14:25:00',1.54),('15087','2013-11-08','14:30:00',1.54),('15087','2013-11-08','14:35:00',1.6),('15087','2013-11-08','14:40:00',1.44),('15087','2013-11-08','14:45:00',1.41),('15087','2013-11-08','14:50:00',1.1),('15087','2013-11-08','15:00:00',1.06),('15087','2013-11-08','15:05:00',1.12),('15087','2013-11-08','15:10:00',1.02),('15087','2014-04-18','08:05:00',1.72),('15087','2014-04-18','08:10:00',1.73),('15087','2014-04-18','08:35:00',1),('15087','2014-04-18','08:40:00',1.54),('15087','2014-04-18','08:45:00',1.64),('15087','2014-04-18','08:50:00',1.17),('15087','2014-04-18','08:55:00',1.05),('15087','2014-04-18','09:00:00',1.21),('15087','2014-04-18','09:05:00',2.53),('15087','2014-04-18','09:10:00',3.45),('15087','2014-04-18','09:15:00',3.23),('15087','2014-04-18','09:20:00',3),('15087','2014-04-18','09:25:00',1.76),('15087','2014-04-18','09:30:00',3.34),('15087','2014-04-18','09:35:00',1.96),('15087','2014-04-18','09:40:00',1.09),('15087','2014-04-18','09:45:00',2.07),('15087','2014-04-18','09:50:00',3.1),('15087','2014-04-18','09:55:00',3.47),('15087','2014-04-18','10:00:00',2.84),('15087','2014-04-18','10:05:00',1.84),('15087','2014-04-18','10:10:00',1.6),('15087','2014-04-18','10:15:00',1.76),('15087','2014-04-18','10:20:00',1.61),('15087','2014-04-18','10:25:00',1.67),('15087','2014-04-18','10:30:00',1.37),('15087','2014-04-18','10:35:00',1.22),('15087','2014-04-18','10:40:00',1.47),('15087','2014-04-18','10:45:00',2.58),('15087','2014-04-18','10:50:00',3.19),('15087','2014-04-18','10:55:00',3.36),('15087','2014-04-18','11:00:00',2.1),('15087','2014-04-18','11:05:00',1.86),('15087','2014-04-18','11:10:00',2.07),('15087','2014-04-18','11:15:00',3.42),('15087','2014-04-18','11:20:00',2.14),('15087','2014-04-18','11:25:00',1.5),('15087','2014-04-18','11:30:00',1.82),('15087','2014-04-18','11:35:00',1.82),('15087','2014-04-18','11:40:00',1.91),('15087','2014-04-18','11:45:00',1.82),('15087','2014-04-18','11:50:00',2.21),('15087','2014-04-18','11:55:00',1.97),('15087','2014-04-18','12:00:00',2.07),('15087','2014-04-18','12:05:00',3.88),('15087','2014-04-18','12:10:00',3.75),('15087','2014-04-18','12:15:00',4.09),('15087','2014-04-18','12:20:00',4.38),('15087','2014-04-18','12:25:00',3.16),('15087','2014-04-18','12:30:00',4.92),('15087','2014-04-18','12:35:00',4.75),('15087','2014-04-18','12:40:00',4.9),('15087','2014-04-18','12:45:00',4.03),('15087','2014-04-18','12:50:00',4.07),('15087','2014-04-18','12:55:00',3.12),('15087','2014-04-18','13:00:00',4.74),('15087','2014-04-18','13:05:00',2.79),('15087','2014-04-18','13:10:00',2.8),('15087','2014-04-18','13:15:00',2.67),('15087','2014-04-18','13:20:00',2.52),('15087','2014-04-18','13:25:00',1.84),('15087','2014-04-18','13:30:00',1.43),('15087','2014-04-18','13:35:00',1.44),('15087','2014-04-18','13:40:00',1.41),('15087','2014-04-18','13:45:00',1.2),('15087','2014-04-18','13:50:00',1.45),('15087','2014-04-18','13:55:00',2.58),('15087','2014-04-18','14:00:00',2.25),('15087','2014-04-18','14:05:00',1.95),('15087','2014-04-18','14:10:00',1.63),('15087','2014-04-18','14:15:00',1.42),('15087','2014-04-18','14:20:00',1.69),('15087','2014-04-18','14:25:00',2.24),('15087','2014-04-18','14:30:00',2.53),('15087','2014-04-18','14:35:00',2.89),('15087','2014-04-18','14:40:00',2.53),('15087','2014-04-18','14:45:00',2.9),('15087','2014-04-18','14:50:00',3.29),('15087','2014-04-18','14:55:00',2.72),('15087','2014-04-18','15:00:00',4.44),('15087','2014-04-18','15:05:00',2.84),('15087','2014-04-18','15:10:00',2.03),('15087','2014-04-18','15:15:00',2.47),('15087','2014-04-18','15:20:00',2.09),('15087','2014-04-18','15:25:00',2.54),('15087','2014-04-18','15:30:00',3.33),('15087','2014-04-18','15:35:00',3.47),('15087','2014-04-18','15:40:00',3.67),('15087','2014-04-18','15:45:00',2.5),('15087','2014-04-18','15:50:00',2.87),('15087','2014-04-18','15:55:00',3.15),('15087','2014-04-18','16:00:00',2.64),('15087','2014-04-18','16:05:00',2.05),('15087','2014-04-18','16:10:00',1.57),('15087','2014-04-18','16:15:00',1.35),('15087','2014-04-18','16:20:00',1.42),('15087','2014-04-18','16:25:00',2.43),('15087','2014-04-18','16:30:00',2.64),('15087','2014-04-18','16:35:00',2.94),('15087','2014-04-18','16:40:00',2.98),('15087','2014-04-18','16:45:00',2.73),('15087','2014-04-18','16:50:00',2.72),('15087','2014-04-18','16:55:00',2.68),('15087','2014-04-18','17:00:00',2.84),('15087','2014-04-18','17:05:00',2.71),('15087','2014-04-18','17:10:00',2.32),('15087','2014-04-18','17:15:00',1.97),('15087','2014-04-18','17:20:00',2.03),('15087','2014-04-18','17:25:00',1.96),('15087','2014-04-18','17:30:00',1.77),('15087','2014-04-18','17:35:00',1.64),('15087','2014-04-18','17:40:00',1.49),('15087','2014-04-18','17:45:00',1.43),('15087','2014-04-18','17:50:00',1.34),('15087','2014-04-18','17:55:00',1.3),('15087','2014-04-18','18:00:00',1.27),('15087','2014-04-18','18:05:00',1.07),('15087','2013-11-07','08:25:00',1.08),('15087','2013-11-07','08:30:00',1.22),('15087','2013-11-07','08:35:00',1.35),('15087','2013-11-07','08:40:00',1.45),('15087','2013-11-07','08:45:00',1.57),('15087','2013-11-07','08:50:00',1.66),('15087','2013-11-07','08:55:00',1.7),('15087','2013-11-07','09:00:00',1.8),('15087','2013-11-07','09:05:00',1.85),('15087','2013-11-07','09:10:00',1.95),('15087','2013-11-07','09:15:00',2.01),('15087','2013-11-07','09:20:00',2.06),('15087','2013-11-07','09:25:00',2.15),('15087','2013-11-07','09:30:00',2.18),('15087','2013-11-07','09:35:00',2.26),('15087','2013-11-07','09:40:00',2.31),('15087','2013-11-07','09:45:00',2.36),('15087','2013-11-07','09:50:00',2.39),('15087','2013-11-07','09:55:00',2.44),('15087','2013-11-07','10:00:00',2.49),('15087','2013-11-07','10:05:00',2.51),('15087','2013-11-07','10:10:00',2.53),('15087','2013-11-07','10:15:00',2.56),('15087','2013-11-07','10:20:00',2.59),('15087','2013-11-07','10:25:00',2.63),('15087','2013-11-07','10:30:00',2.66),('15087','2013-11-07','10:35:00',2.69),('15087','2013-11-07','10:40:00',2.73),('15087','2013-11-07','10:45:00',2.74),('15087','2013-11-07','10:50:00',2.74),('15087','2013-11-07','10:55:00',2.75),('15087','2013-11-07','11:00:00',2.77),('15087','2013-11-07','11:05:00',2.78),('15087','2013-11-07','11:10:00',2.76),('15087','2013-11-07','11:15:00',2.78),('15087','2013-11-07','11:20:00',2.79),('15087','2013-11-07','11:25:00',2.78),('15087','2013-11-07','11:30:00',2.84),('15087','2013-11-07','11:35:00',2.87),('15087','2013-11-07','11:40:00',2.83),('15087','2013-11-07','11:45:00',2.83),('15087','2013-11-07','11:50:00',2.86),('15087','2013-11-07','11:55:00',2.85),('15087','2013-11-07','12:00:00',2.82),('15087','2013-11-07','12:05:00',2.79),('15087','2013-11-07','12:10:00',2.81),('15087','2013-11-07','12:15:00',2.76),('15087','2013-11-07','12:20:00',2.71),('15087','2013-11-07','12:25:00',2.54),('15087','2013-11-07','12:30:00',2.76),('15087','2013-11-07','12:35:00',2.62),('15087','2013-11-07','12:40:00',2.49),('15087','2013-11-07','12:45:00',2.62),('15087','2013-11-07','12:50:00',2.47),('15087','2013-11-07','12:55:00',2.4),('15087','2013-11-07','13:00:00',2.64),('15087','2013-11-07','13:05:00',2.69),('15087','2013-11-07','13:10:00',1.38),('15087','2013-11-07','13:15:00',1.07),('15087','2013-11-07','13:20:00',1.03),('15087','2013-11-07','13:25:00',1.89),('15087','2013-11-07','13:30:00',1.52),('15087','2013-11-07','13:35:00',2.4),('15087','2013-11-07','13:40:00',1.81),('15087','2013-11-07','13:45:00',1.45),('15087','2013-11-07','13:50:00',2.09),('15087','2013-11-07','13:55:00',1.95),('15087','2013-11-07','14:00:00',1.09),('15087','2013-11-07','14:05:00',1.26),('15087','2013-11-07','14:10:00',1.65),('15087','2013-11-07','14:20:00',1.25),('15087','2013-11-07','14:25:00',1.54),('15087','2013-11-07','14:30:00',1.51),('15087','2013-11-07','14:35:00',1.37),('15087','2013-11-07','14:40:00',1.41),('15087','2013-11-07','14:45:00',1.35),('15087','2013-11-07','14:50:00',1.31),('15087','2013-11-07','14:55:00',1.14),('15087','2013-11-07','15:00:00',1.12),('15087','2013-11-07','15:05:00',1.04),('15087','2013-11-06','08:15:00',1.06),('15087','2013-11-06','08:20:00',1.05),('15087','2013-11-06','08:35:00',1.5),('15087','2013-11-06','08:40:00',1.6),('15087','2013-11-06','08:45:00',1.74),('15087','2013-11-06','08:50:00',1.88),('15087','2013-11-06','08:55:00',1.76),('15087','2013-11-06','09:00:00',1.17),('15087','2013-11-06','09:05:00',1.2),('15087','2013-11-06','09:10:00',1.28),('15087','2013-11-06','09:15:00',1.76),('15087','2013-11-06','09:20:00',1.81),('15087','2013-11-06','09:25:00',2.19),('15087','2013-11-06','09:30:00',2.32),('15087','2013-11-06','09:35:00',2.37),('15087','2013-11-06','09:40:00',2.42),('15087','2013-11-06','09:45:00',2.48),('15087','2013-11-06','09:50:00',2.53),('15087','2013-11-06','09:55:00',2.57),('15087','2013-11-06','10:00:00',2.61),('15087','2013-11-06','10:05:00',2.65),('15087','2013-11-06','10:10:00',2.65),('15087','2013-11-06','10:15:00',2.72),('15087','2013-11-06','10:20:00',2.76),('15087','2013-11-06','10:25:00',2.8),('15087','2013-11-06','10:30:00',2.83),('15087','2013-11-06','10:35:00',2.85),('15087','2013-11-06','10:40:00',2.87),('15087','2013-11-06','10:45:00',2.91),('15087','2013-11-06','10:50:00',2.95),('15087','2013-11-06','10:55:00',2.98),('15087','2013-11-06','11:00:00',3),('15087','2013-11-06','11:05:00',3.01),('15087','2013-11-06','11:10:00',3.03),('15087','2013-11-06','11:15:00',3.05),('15087','2013-11-06','11:20:00',3.07),('15087','2013-11-06','11:25:00',3.07),('15087','2013-11-06','11:30:00',3.09),('15087','2013-11-06','11:35:00',3.08),('15087','2013-11-06','11:40:00',3.07),('15087','2013-11-06','11:45:00',3.1),('15087','2013-11-06','11:50:00',3.07),('15087','2013-11-06','11:55:00',3.07),('15087','2013-11-06','12:00:00',3.09),('15087','2013-11-06','12:05:00',3.07),('15087','2013-11-06','12:10:00',3.06),('15087','2013-11-06','12:15:00',3.04),('15087','2013-11-06','12:20:00',2.94),('15087','2013-11-06','12:25:00',2.88),('15087','2013-11-06','12:30:00',2.96),('15087','2013-11-06','12:35:00',2.81),('15087','2013-11-06','12:40:00',2.78),('15087','2013-11-06','12:45:00',2.82),('15087','2013-11-06','12:50:00',2.57),('15087','2013-11-06','12:55:00',2.64),('15087','2013-11-06','13:00:00',2.67),('15087','2013-11-06','13:05:00',2.54),('15087','2013-11-06','13:10:00',2.5),('15087','2013-11-06','13:15:00',2.47),('15087','2013-11-06','13:20:00',2.33),('15087','2013-11-06','13:25:00',2.34),('15087','2013-11-06','13:30:00',2.26),('15087','2013-11-06','13:35:00',2.05),('15087','2013-11-06','13:40:00',2.08),('15087','2013-11-06','13:45:00',1.96),('15087','2013-11-06','13:50:00',1.92),('15087','2013-11-06','13:55:00',2.07),('15087','2013-11-06','14:00:00',1.86),('15087','2013-11-06','14:05:00',1.84),('15087','2013-11-06','14:10:00',1.82),('15087','2013-11-06','14:15:00',1.72),('15087','2013-11-06','14:20:00',1.6),('15087','2013-11-06','14:25:00',1.58),('15087','2013-11-06','14:30:00',1.49),('15087','2013-11-06','14:35:00',1.45),('15087','2013-11-06','14:40:00',1.38),('15087','2013-11-06','14:45:00',1.34),('15087','2013-11-06','14:50:00',1.26),('15087','2013-11-06','14:55:00',1.2),('15087','2013-11-06','15:00:00',1.08),('15087','2013-11-06','15:05:00',1.05),('15087','2013-11-06','15:10:00',1.03),('15087','2013-11-04','08:20:00',1.12),('15087','2013-11-04','08:25:00',1.13),('15087','2013-11-04','08:30:00',1.18),('15087','2013-11-04','08:35:00',1.13),('15087','2013-11-04','09:10:00',2.16),('15087','2013-11-04','09:15:00',2.38),('15087','2013-11-04','09:20:00',2.61),('15087','2013-11-04','09:25:00',2.9),('15087','2013-11-04','09:30:00',1.19),('15087','2013-11-04','10:00:00',2.1),('15087','2013-11-04','10:05:00',2.74),('15087','2013-11-04','10:10:00',2.77),('15087','2013-11-04','10:15:00',2.84),('15087','2013-11-04','10:20:00',2.83),('15087','2013-11-04','10:25:00',3.21),('15087','2013-11-04','10:30:00',3.31),('15087','2013-11-04','10:35:00',2.64),('15087','2013-11-04','10:40:00',3.68),('15087','2013-11-04','10:45:00',2.09),('15087','2013-11-04','10:50:00',2.35),('15087','2013-11-04','10:55:00',3.15),('15087','2013-11-04','11:00:00',2.76),('15087','2013-11-04','11:05:00',3.41),('15087','2013-11-04','11:10:00',1.37),('15087','2013-11-04','11:15:00',1.95),('15087','2013-11-04','11:20:00',1.6),('15087','2013-11-04','11:25:00',1.43),('15087','2013-11-04','11:30:00',2.78),('15087','2013-11-04','11:35:00',2.72),('15087','2013-11-04','11:40:00',2.26),('15087','2013-11-04','11:45:00',2.66),('15087','2013-11-04','11:50:00',4.08),('15087','2013-11-04','11:55:00',3.56),('15087','2013-11-04','12:00:00',3.5),('15087','2013-11-04','12:05:00',3.25),('15087','2013-11-04','12:10:00',3.24),('15087','2013-11-04','12:15:00',3.2),('15087','2013-11-04','12:20:00',3.13),('15087','2013-11-04','12:25:00',3.1),('15087','2013-11-04','12:30:00',3.08),('15087','2013-11-04','12:35:00',3),('15087','2013-11-04','12:40:00',2.99),('15087','2013-11-04','12:45:00',2.98),('15087','2013-11-04','12:50:00',2.84),('15087','2013-11-04','12:55:00',2.81),('15087','2013-11-04','13:00:00',2.79),('15087','2013-11-04','13:05:00',2.7),('15087','2013-11-04','13:10:00',2.64),('15087','2013-11-04','13:15:00',2.67),('15087','2013-11-04','13:20:00',2.24),('15087','2013-11-04','13:25:00',2.51),('15087','2013-11-04','13:30:00',2.38),('15087','2013-11-04','13:35:00',2.32),('15087','2013-11-04','13:40:00',1.94),('15087','2013-11-04','13:45:00',2.49),('15087','2013-11-04','13:50:00',2.3),('15087','2013-11-04','13:55:00',1.58),('15087','2013-11-04','14:00:00',1.27),('15087','2013-11-04','14:05:00',1.75),('15087','2013-11-04','14:10:00',2.25),('15087','2013-11-04','14:15:00',1.91),('15087','2013-11-04','14:20:00',2.15),('15087','2013-11-04','14:25:00',1.12),('15087','2013-11-04','14:30:00',1.12),('15087','2013-11-04','14:35:00',1.91),('15087','2013-11-04','14:40:00',1.64),('15087','2013-11-04','14:45:00',1.57),('15087','2013-11-04','14:50:00',1.49),('15087','2013-11-04','14:55:00',1.37),('15087','2013-11-04','15:00:00',1.31),('15087','2013-11-04','15:15:00',1.03),('15087','2013-11-04','15:20:00',1),('15087','2013-11-04','15:25:00',1.01),('15087','2013-11-03','08:35:00',1.29),('15087','2013-11-03','08:50:00',1.72),('15087','2013-11-03','08:55:00',1.01),('15087','2013-11-03','09:35:00',1.13),('15087','2013-11-03','09:40:00',2.81),('15087','2013-11-03','09:45:00',1.35),('15087','2013-11-03','10:05:00',1.06),('15087','2013-11-03','10:10:00',1.41),('15087','2013-11-03','10:20:00',2.7),('15087','2013-11-03','10:25:00',1.82),('15087','2013-11-03','10:30:00',2.96),('15087','2013-11-03','10:35:00',1.9),('15087','2013-11-03','11:15:00',1.04),('15087','2013-11-03','11:20:00',1.98),('15087','2013-11-03','11:25:00',1.29),('15087','2013-11-03','11:30:00',2.6),('15087','2013-11-03','11:35:00',2.91),('15087','2013-11-03','11:40:00',3.37),('15087','2013-11-03','11:45:00',3.46),('15087','2013-11-03','11:50:00',3.45),('15087','2013-11-03','11:55:00',2.62),('15087','2013-11-03','12:00:00',2.72),('15087','2013-11-03','12:05:00',3.7),('15087','2013-11-03','12:10:00',2.75),('15087','2013-11-03','12:15:00',1.82),('15087','2013-11-03','12:25:00',1.32),('15087','2013-11-03','12:35:00',1.21),('15087','2013-11-03','12:40:00',1.35),('15087','2013-11-03','12:45:00',1.07),('15087','2013-11-03','12:50:00',1.07),('15087','2013-11-03','13:25:00',1),('15087','2013-11-03','13:35:00',1.17),('15087','2013-11-03','13:40:00',1.49),('15087','2013-11-03','13:45:00',2.19),('15087','2013-11-03','13:55:00',1.4),('15087','2013-11-03','14:00:00',1.33),('15087','2013-11-03','14:05:00',2.01),('15087','2013-11-03','14:10:00',2.23),('15087','2013-11-03','14:15:00',2.03),('15087','2013-11-03','14:20:00',1.79),('15087','2013-11-03','14:25:00',1.85),('15087','2013-11-03','14:30:00',1.22),('15087','2013-11-03','14:35:00',1.19),('15087','2013-11-03','14:40:00',1.67),('15087','2013-11-03','14:45:00',1.45),('15087','2013-11-03','14:50:00',1.12),('15087','2013-11-02','08:15:00',1.05),('15087','2013-11-02','08:20:00',1.13),('15087','2013-11-02','08:25:00',1.21),('15087','2013-11-02','08:30:00',1.3),('15087','2013-11-02','08:35:00',1.38),('15087','2013-11-02','08:40:00',1.45),('15087','2013-11-02','08:45:00',1.51),('15087','2013-11-02','08:50:00',1.61),('15087','2013-11-02','08:55:00',1.69),('15087','2013-11-02','09:00:00',1.79),('15087','2013-11-02','09:05:00',2.03),('15087','2013-11-02','09:10:00',1.89),('15087','2013-11-02','09:15:00',2),('15087','2013-11-02','09:20:00',1.95),('15087','2013-11-02','09:25:00',2.16),('15087','2013-11-02','09:30:00',2.25),('15087','2013-11-02','09:35:00',2.23),('15087','2013-11-02','09:40:00',2.3),('15087','2013-11-02','09:45:00',2.29),('15087','2013-11-02','09:50:00',2.57),('15087','2013-11-02','09:55:00',2.6),('15087','2013-11-02','10:00:00',2.63),('15087','2013-11-02','10:05:00',2.53),('15087','2013-11-02','10:10:00',1.31),('15087','2013-11-02','10:15:00',1.25),('15087','2013-11-02','11:00:00',1.26),('15087','2013-11-02','11:05:00',1.42),('15087','2013-11-02','11:10:00',1.2),('15087','2013-11-02','11:50:00',1.44),('15087','2013-11-02','11:55:00',2.3),('15087','2013-11-02','12:00:00',3.46),('15087','2013-11-02','12:05:00',3.64),('15087','2013-11-02','12:10:00',3.34),('15087','2013-11-02','12:15:00',2.84),('15087','2013-11-02','12:20:00',3.51),('15087','2013-11-02','12:25:00',3.51),('15087','2013-11-02','12:30:00',3.8),('15087','2013-11-02','12:35:00',3.16),('15087','2013-11-02','12:40:00',3.05),('15087','2013-11-02','12:45:00',2.07),('15087','2013-11-02','12:50:00',3.05),('15087','2013-11-02','12:55:00',3.04),('15087','2013-11-02','13:00:00',2.32),('15087','2013-11-02','13:05:00',3.11),('15087','2013-11-02','13:10:00',3.37),('15087','2013-11-02','13:15:00',1.53),('15087','2013-11-02','13:20:00',1.01),('15087','2013-11-02','13:30:00',1.29),('15087','2013-11-02','13:35:00',2.39),('15087','2013-11-02','13:40:00',2.56),('15087','2013-11-02','13:45:00',3.01),('15087','2013-11-02','13:50:00',3),('15087','2013-11-02','13:55:00',2.8),('15087','2013-11-02','14:00:00',2.47),('15087','2013-11-02','14:05:00',2.16),('15087','2013-11-02','14:10:00',2.01),('15087','2013-11-02','14:15:00',1.89),('15087','2013-11-02','14:20:00',1.73),('15087','2013-11-02','14:25:00',1.61),('15087','2013-11-02','14:30:00',1.57),('15087','2013-11-02','14:35:00',1.45),('15087','2013-11-02','14:40:00',1.45),('15087','2013-11-02','14:45:00',1.37),('15087','2013-11-02','14:50:00',1.33),('15087','2013-11-02','15:00:00',1.13),('15087','2013-11-02','15:10:00',1.05),('15087','2013-11-01','08:25:00',1.05),('15087','2013-11-01','08:30:00',1.22),('15087','2013-11-01','08:35:00',1.35),('15087','2013-11-01','08:40:00',1.48),('15087','2013-11-01','08:45:00',1.47),('15087','2013-11-01','08:50:00',1.46),('15087','2013-11-01','08:55:00',1.54),('15087','2013-11-01','09:00:00',1.64),('15087','2013-11-01','09:05:00',1.86),('15087','2013-11-01','09:10:00',1.96),('15087','2013-11-01','09:15:00',2.02),('15087','2013-11-01','09:20:00',2.09),('15087','2013-11-01','09:25:00',2.15),('15087','2013-11-01','09:30:00',2.22),('15087','2013-11-01','09:35:00',2.26),('15087','2013-11-01','09:40:00',2.34),('15087','2013-11-01','09:45:00',2.4),('15087','2013-11-01','09:50:00',2.46),('15087','2013-11-01','09:55:00',2.51),('15087','2013-11-01','10:00:00',2.56),('15087','2013-11-01','10:05:00',2.6),('15087','2013-11-01','10:10:00',2.66),('15087','2013-11-01','10:15:00',2.69),('15087','2013-11-01','10:20:00',2.73),('15087','2013-11-01','10:25:00',2.77),('15087','2013-11-01','10:30:00',2.7),('15087','2013-11-01','10:35:00',2.76),('15087','2013-11-01','10:40:00',2.8),('15087','2013-11-01','10:45:00',2.78),('15087','2013-11-01','10:50:00',2.76),('15087','2013-11-01','10:55:00',2.8),('15087','2013-11-01','11:00:00',2.84),('15087','2013-11-01','11:05:00',2.56),('15087','2013-11-01','11:10:00',2.27),('15087','2013-11-01','11:15:00',2.56),('15087','2013-11-01','11:20:00',3.02),('15087','2013-11-01','11:25:00',3.16),('15087','2013-11-01','11:30:00',3.16),('15087','2013-11-01','11:35:00',3.01),('15087','2013-11-01','11:40:00',2.64),('15087','2013-11-01','11:45:00',2.9),('15087','2013-11-01','11:50:00',3.14),('15087','2013-11-01','11:55:00',3.17),('15087','2013-11-01','12:00:00',3.07),('15087','2013-11-01','12:05:00',2.98),('15087','2013-11-01','12:10:00',2.8),('15087','2013-11-01','12:15:00',2.47),('15087','2013-11-01','12:20:00',2.57),('15087','2013-11-01','12:25:00',2.65),('15087','2013-11-01','12:30:00',1.77),('15087','2013-11-01','13:10:00',1.05),('15087','2013-11-01','13:15:00',1.22),('15087','2013-11-01','13:20:00',1.22),('15087','2013-11-01','13:25:00',1.05),('15087','2013-11-01','13:30:00',1.18),('15087','2013-11-01','13:35:00',1.24),('15087','2013-11-01','13:40:00',1.11),('15087','2013-10-31','08:25:00',1.08),('15087','2013-10-31','08:30:00',1.29),('15087','2013-10-31','08:35:00',1.38),('15087','2013-10-31','08:40:00',1.65),('15087','2013-10-31','08:45:00',1.6),('15087','2013-10-31','08:50:00',1.71),('15087','2013-10-31','08:55:00',1.62),('15087','2013-10-31','09:00:00',1.6),('15087','2013-10-31','09:05:00',1.39),('15087','2013-10-31','09:20:00',1.57),('15087','2013-10-31','09:25:00',1.63),('15087','2013-10-31','09:30:00',1.79),('15087','2013-10-31','09:35:00',1.84),('15087','2013-10-31','09:40:00',1.77),('15087','2013-10-31','09:45:00',1.77),('15087','2013-10-31','09:50:00',1.77),('15087','2013-10-31','09:55:00',1.87),('15087','2013-10-31','10:00:00',1.96),('15087','2013-10-31','10:05:00',1.93),('15087','2013-10-31','10:10:00',1.73),('15087','2013-10-31','10:15:00',1.59),('15087','2013-10-31','10:20:00',1.41),('15087','2013-10-31','10:25:00',1.65),('15087','2013-10-31','10:30:00',1.72),('15087','2013-10-31','10:35:00',1.95),('15087','2013-10-31','10:40:00',2.01),('15087','2013-10-31','10:45:00',1.8),('15087','2013-10-31','10:50:00',1.84),('15087','2013-10-31','10:55:00',2.09),('15087','2013-10-31','11:00:00',2.47),('15087','2013-10-31','11:05:00',2.85),('15087','2013-10-31','11:10:00',2.82),('15087','2013-10-31','11:15:00',2.89),('15087','2013-10-31','11:20:00',2.76),('15087','2013-10-31','11:25:00',2.49),('15087','2013-10-31','11:30:00',2.76),('15087','2013-10-31','11:35:00',2.62),('15087','2013-10-31','11:40:00',2.9),('15087','2013-10-31','11:45:00',3.03),('15087','2013-10-31','11:50:00',2.99),('15087','2013-10-31','11:55:00',2.98),('15087','2013-10-31','12:00:00',2.91),('15087','2013-10-31','12:05:00',2.85),('15087','2013-10-31','12:10:00',2.95),('15087','2013-10-31','12:15:00',2.92),('15087','2013-10-31','12:20:00',2.85),('15087','2013-10-31','12:25:00',2.69),('15087','2013-10-31','12:30:00',2.64),('15087','2013-10-31','12:35:00',2.55),('15087','2013-10-31','12:40:00',2.57),('15087','2013-10-31','12:45:00',2.59),('15087','2013-10-31','12:50:00',2.73),('15087','2013-10-31','12:55:00',2.69),('15087','2013-10-31','13:00:00',2.57),('15087','2013-10-31','13:05:00',2.6),('15087','2013-10-31','13:10:00',2.48),('15087','2013-10-31','13:15:00',2.37),('15087','2013-10-31','13:20:00',2.42),('15087','2013-10-31','13:25:00',2.41),('15087','2013-10-31','13:30:00',2.32),('15087','2013-10-31','13:35:00',2.25),('15087','2013-10-31','13:40:00',2.1),('15087','2013-10-31','13:45:00',2),('15087','2013-10-31','13:50:00',1.49),('15087','2013-10-31','13:55:00',1.35),('15087','2013-10-31','14:00:00',1.85),('15087','2013-10-31','14:05:00',1.83),('15087','2013-10-31','14:10:00',1.63),('15087','2013-10-31','14:15:00',1.21),('15087','2013-10-31','14:25:00',1.2),('15087','2013-10-30','08:15:00',1.02),('15087','2013-10-30','08:20:00',1.08),('15087','2013-10-30','08:25:00',1.14),('15087','2013-10-30','08:30:00',1.19),('15087','2013-10-30','08:35:00',1.28),('15087','2013-10-30','08:40:00',1.4),('15087','2013-10-30','08:45:00',1.5),('15087','2013-10-30','08:50:00',1.56),('15087','2013-10-30','08:55:00',1.56),('15087','2013-10-30','09:00:00',1.6),('15087','2013-10-30','09:05:00',1.77),('15087','2013-10-30','09:10:00',1.92),('15087','2013-10-30','09:15:00',1.98),('15087','2013-10-30','09:20:00',2.06),('15087','2013-10-30','09:25:00',2.15),('15087','2013-10-30','09:30:00',2.2),('15087','2013-10-30','09:35:00',2.24),('15087','2013-10-30','09:40:00',2.23),('15087','2013-10-30','09:45:00',2.34),('15087','2013-10-30','09:50:00',2.38),('15087','2013-10-30','09:55:00',2.2),('15087','2013-10-30','10:00:00',1.86),('15087','2013-10-30','10:05:00',1.98),('15087','2013-10-30','10:10:00',2.49),('15087','2013-10-30','10:15:00',2.65),('15087','2013-10-30','10:20:00',2.55),('15087','2013-10-30','10:25:00',2.51),('15087','2013-10-30','10:30:00',2.6),('15087','2013-10-30','10:35:00',2.53),('15087','2013-10-30','10:40:00',2.68),('15087','2013-10-30','10:45:00',2.75),('15087','2013-10-30','10:50:00',1.82),('15087','2013-10-30','10:55:00',1.74),('15087','2013-10-30','11:00:00',2.58),('15087','2013-10-30','11:05:00',2.66),('15087','2013-10-30','11:10:00',2.93),('15087','2013-10-30','11:15:00',2.94),('15087','2013-10-30','11:20:00',2.32),('15087','2013-10-30','11:25:00',1.35),('15087','2013-10-30','11:30:00',1.08),('15087','2013-10-30','11:40:00',1.13),('15087','2013-10-30','11:45:00',1.32),('15087','2013-10-30','11:50:00',1.39),('15087','2013-10-30','12:00:00',1.04),('15087','2013-10-30','12:05:00',1.13),('15087','2013-10-30','12:10:00',1.16),('15087','2013-10-30','12:15:00',2.24),('15087','2013-10-30','12:20:00',3.05),('15087','2013-10-30','12:25:00',2.17),('15087','2013-10-30','12:30:00',1.97),('15087','2013-10-30','12:35:00',1.19),('15087','2013-10-30','12:40:00',1.18),('15087','2013-10-30','12:45:00',1.18),('15087','2013-10-30','12:50:00',1.36),('15087','2013-10-30','12:55:00',2.64),('15087','2013-10-30','13:00:00',1.73),('15087','2013-10-30','13:05:00',2.75),('15087','2013-10-30','13:10:00',2.79),('15087','2013-10-30','13:15:00',2.93),('15087','2013-10-30','13:20:00',2.82),('15087','2013-10-30','13:25:00',2.68),('15087','2013-10-30','13:30:00',1.47),('15087','2013-10-30','13:35:00',1.78),('15087','2013-10-30','13:40:00',2.51),('15087','2013-10-30','13:45:00',2.02),('15087','2013-10-30','13:50:00',1.36),('15087','2013-10-30','13:55:00',2.25),('15087','2013-10-30','14:00:00',2.31),('15087','2013-10-30','14:05:00',2.31),('15087','2013-10-30','14:10:00',1.16),('15087','2013-10-30','14:35:00',1.14),('15087','2013-10-30','14:40:00',1.52),('15087','2013-10-30','14:45:00',1.3),('15087','2013-10-29','08:35:00',1.11),('15087','2013-10-29','08:45:00',1.51),('15087','2013-10-29','08:50:00',1.68),('15087','2013-10-29','08:55:00',1.78),('15087','2013-10-29','09:00:00',1.88),('15087','2013-10-29','09:05:00',1.95),('15087','2013-10-29','09:10:00',2),('15087','2013-10-29','09:15:00',2.08),('15087','2013-10-29','09:20:00',2.13),('15087','2013-10-29','09:25:00',2.17),('15087','2013-10-29','09:30:00',2.23),('15087','2013-10-29','09:35:00',2.38),('15087','2013-10-29','09:40:00',2.08),('15087','2013-10-29','09:45:00',2.47),('15087','2013-10-29','09:50:00',2.46),('15087','2013-10-29','09:55:00',2.07),('15087','2013-10-29','10:00:00',2.26),('15087','2013-10-29','10:05:00',1.73),('15087','2013-10-29','10:10:00',1.81),('15087','2013-10-29','10:15:00',2.17),('15087','2013-10-29','10:25:00',1.14),('15087','2013-10-29','10:30:00',1.34),('15087','2013-10-29','10:35:00',2.02),('15087','2013-10-29','10:40:00',2.82),('15087','2013-10-29','10:45:00',3.19),('15087','2013-10-29','10:50:00',3.23),('15087','2013-10-29','10:55:00',3.39),('15087','2013-10-29','11:00:00',3.28),('15087','2013-10-29','11:05:00',3.37),('15087','2013-10-29','11:10:00',3.28),('15087','2013-10-29','11:15:00',3.13),('15087','2013-10-29','11:20:00',3.14),('15087','2013-10-29','11:25:00',3.13),('15087','2013-10-29','11:30:00',3.16),('15087','2013-10-29','11:35:00',3.18),('15087','2013-10-29','11:40:00',3.15),('15087','2013-10-29','11:45:00',3.17),('15087','2013-10-29','11:50:00',3.19),('15087','2013-10-29','11:55:00',3.08),('15087','2013-10-29','12:00:00',2.98),('15087','2013-10-29','12:05:00',3.01),('15087','2013-10-29','12:10:00',2.99),('15087','2013-10-29','12:15:00',2.99),('15087','2013-10-29','12:20:00',2.91),('15087','2013-10-29','12:25:00',2.61),('15087','2013-10-29','12:30:00',2.47),('15087','2013-10-29','12:35:00',2.69),('15087','2013-10-29','12:40:00',2.75),('15087','2013-10-29','12:45:00',2.25),('15087','2013-10-29','12:50:00',2.43),('15087','2013-10-29','12:55:00',2.57),('15087','2013-10-29','13:00:00',2.57),('15087','2013-10-29','13:05:00',2.59),('15087','2013-10-29','13:10:00',2.57),('15087','2013-10-29','13:15:00',2.5),('15087','2013-10-29','13:20:00',2.41),('15087','2013-10-29','13:25:00',2.43),('15087','2013-10-29','13:30:00',2.39),('15087','2013-10-29','13:35:00',2.25),('15087','2013-10-29','13:40:00',2.06),('15087','2013-10-29','13:45:00',2.01),('15087','2013-10-29','13:50:00',2.11),('15087','2013-10-29','13:55:00',1.88),('15087','2013-10-29','14:00:00',1.63),('15087','2013-10-29','14:05:00',1.84),('15087','2013-10-29','14:10:00',1.75),('15087','2013-10-29','14:15:00',1.69),('15087','2013-10-29','14:20:00',1.67),('15087','2013-10-29','14:25:00',1.58),('15087','2013-10-29','14:30:00',1.5),('15087','2013-10-29','14:35:00',1.44),('15087','2013-10-29','14:40:00',1.41),('15087','2013-10-29','14:45:00',1.36),('15087','2013-10-29','14:50:00',1.28),('15087','2013-10-29','14:55:00',1.24),('15087','2013-10-29','15:00:00',1.18),('15087','2013-10-29','15:05:00',1.12),('15087','2013-10-29','15:10:00',1.1),('15087','2013-10-29','15:15:00',1.03),('15087','2014-04-17','08:00:00',1.2),('15087','2014-04-17','08:05:00',1.36),('15087','2014-04-17','08:10:00',1.46),('15087','2014-04-17','08:15:00',1.58),('15087','2014-04-17','08:20:00',1.62),('15087','2014-04-17','08:25:00',1.75),('15087','2014-04-17','08:30:00',1.86),('15087','2014-04-17','08:35:00',1.96),('15087','2014-04-17','08:40:00',2.06),('15087','2014-04-17','08:45:00',2.17),('15087','2014-04-17','08:50:00',2.29),('15087','2014-04-17','08:55:00',2.17),('15087','2014-04-17','09:00:00',2.01),('15087','2014-04-17','09:05:00',2.44),('15087','2014-04-17','09:10:00',2.64),('15087','2014-04-17','09:15:00',2.74),('15087','2014-04-17','09:20:00',2.86),('15087','2014-04-17','09:25:00',2.94),('15087','2014-04-17','09:30:00',3.03),('15087','2014-04-17','09:35:00',3.13),('15087','2014-04-17','09:40:00',3.22),('15087','2014-04-17','09:45:00',3.29),('15087','2014-04-17','09:50:00',3.38),('15087','2014-04-17','09:55:00',3.48),('15087','2014-04-17','10:00:00',3.63),('15087','2014-04-17','10:05:00',3.94),('15087','2014-04-17','10:10:00',3.82),('15087','2014-04-17','10:15:00',2.82),('15087','2014-04-17','10:20:00',4.01),('15087','2014-04-17','10:25:00',4.15),('15087','2014-04-17','10:30:00',4.46),('15087','2014-04-17','10:35:00',4.71),('15087','2014-04-17','10:40:00',4.31),('15087','2014-04-17','10:45:00',3.97),('15087','2014-04-17','10:50:00',2.91),('15087','2014-04-17','10:55:00',2.68),('15087','2014-04-17','11:00:00',3.04),('15087','2014-04-17','11:05:00',3.25),('15087','2014-04-17','11:10:00',3.38),('15087','2014-04-17','11:15:00',2.5),('15087','2014-04-17','11:20:00',3.28),('15087','2014-04-17','11:25:00',4.39),('15087','2014-04-17','11:30:00',2.82),('15087','2014-04-17','11:35:00',2.51),('15087','2014-04-17','11:40:00',2.7),('15087','2014-04-17','11:45:00',4.45),('15087','2014-04-17','11:50:00',3.51),('15087','2014-04-17','11:55:00',2.52),('15087','2014-04-17','12:00:00',3.23),('15087','2014-04-17','12:05:00',3.34),('15087','2014-04-17','12:10:00',2.89),('15087','2014-04-17','12:15:00',2.57),('15087','2014-04-17','12:20:00',2.7),('15087','2014-04-17','12:25:00',3.03),('15087','2014-04-17','12:30:00',3.73),('15087','2014-04-17','12:35:00',4.11),('15087','2014-04-17','12:40:00',4.75),('15087','2014-04-17','12:45:00',4.59),('15087','2014-04-17','12:50:00',2.38),('15087','2014-04-17','12:55:00',3.41),('15087','2014-04-17','13:25:00',4.02),('15087','2014-04-17','13:30:00',5.16),('15087','2014-04-17','13:35:00',1.9),('15087','2014-04-17','13:50:00',2.51),('15087','2014-04-17','13:55:00',1.94),('15087','2014-04-17','14:00:00',1.03),('15087','2014-04-17','14:05:00',1.14),('15087','2014-04-17','14:10:00',2.85),('15087','2014-04-17','14:15:00',4.37),('15087','2014-04-17','14:20:00',1.58),('15087','2014-04-17','14:25:00',1.86),('15087','2014-04-17','14:30:00',2.12),('15087','2014-04-17','14:35:00',2.56),('15087','2014-04-17','14:40:00',4.71),('15087','2014-04-17','14:45:00',1.37),('15087','2014-04-17','15:25:00',1.25),('15087','2014-04-17','15:30:00',2.13),('15087','2014-04-17','15:35:00',2.82),('15087','2014-04-17','15:40:00',2.04),('15087','2014-04-17','15:45:00',1.49),('15087','2014-04-17','15:50:00',1.29),('15087','2014-04-17','15:55:00',1.49),('15087','2014-04-17','16:00:00',1.2),('15087','2014-04-17','16:10:00',1.1),('15087','2014-04-17','16:15:00',1.1),('15087','2014-04-17','16:20:00',1.07),('15087','2014-04-17','16:25:00',1.24),('15087','2014-04-17','16:30:00',1.26),('15087','2014-04-17','16:35:00',1.11),('15087','2014-04-17','16:40:00',1.36),('15087','2014-04-17','16:45:00',1.93),('15087','2014-04-17','16:50:00',1.81),('15087','2014-04-17','16:55:00',1.32),('15087','2014-04-17','17:00:00',1.05),('15087','2014-04-17','17:15:00',1.01),('15087','2014-04-17','17:20:00',1.13),('15087','2014-04-17','17:30:00',1),('15087','2014-04-17','17:35:00',1.05),('15087','2013-10-28','08:50:00',1.29),('15087','2013-10-28','08:55:00',1.84),('15087','2013-10-28','09:00:00',1.96),('15087','2013-10-28','09:05:00',2.2),('15087','2013-10-28','09:10:00',2.27),('15087','2013-10-28','09:15:00',2.12),('15087','2013-10-28','09:20:00',1.86),('15087','2013-10-28','09:25:00',2.33),('15087','2013-10-28','09:30:00',2.36),('15087','2013-10-28','09:35:00',1.85),('15087','2013-10-28','09:40:00',2.6),('15087','2013-10-28','09:45:00',2.45),('15087','2013-10-28','09:50:00',2.15),('15087','2013-10-28','09:55:00',1.45),('15087','2013-10-28','10:45:00',1.18),('15087','2013-10-28','10:50:00',3.06),('15087','2013-10-28','10:55:00',2.95),('15087','2013-10-28','11:00:00',3.04),('15087','2013-10-28','11:05:00',3.05),('15087','2013-10-28','11:10:00',3.08),('15087','2013-10-28','11:15:00',3.09),('15087','2013-10-28','11:20:00',3.08),('15087','2013-10-28','11:25:00',3.1),('15087','2013-10-28','11:30:00',3.12),('15087','2013-10-28','11:35:00',3.08),('15087','2013-10-28','11:40:00',3.11),('15087','2013-10-28','11:45:00',3.08),('15087','2013-10-28','11:50:00',3.14),('15087','2013-10-28','11:55:00',2.4),('15087','2013-10-28','12:00:00',2.62),('15087','2013-10-28','12:05:00',2.71),('15087','2013-10-28','12:10:00',3.24),('15087','2013-10-28','12:15:00',3.22),('15087','2013-10-28','12:20:00',2.69),('15087','2013-10-28','12:25:00',2.24),('15087','2013-10-28','12:30:00',3.24),('15087','2013-10-28','12:35:00',3.48),('15087','2013-10-28','12:40:00',2.9),('15087','2013-10-28','12:45:00',3.03),('15087','2013-10-28','12:50:00',3.1),('15087','2013-10-28','12:55:00',2.77),('15087','2013-10-28','13:00:00',2.58),('15087','2013-10-28','13:05:00',2.78),('15087','2013-10-28','13:10:00',2.53),('15087','2013-10-28','13:15:00',2.49),('15087','2013-10-28','13:20:00',2.48),('15087','2013-10-28','13:25:00',2.25),('15087','2013-10-28','13:30:00',2.25),('15087','2013-10-28','13:35:00',2.42),('15087','2013-10-28','13:40:00',2.43),('15087','2013-10-28','13:45:00',2.36),('15087','2013-10-28','13:50:00',2.33),('15087','2013-10-28','13:55:00',2.33),('15087','2013-10-28','14:00:00',2.28),('15087','2013-10-28','14:05:00',2.25),('15087','2013-10-28','14:10:00',2.17),('15087','2013-10-28','14:15:00',1.87),('15087','2013-10-28','14:20:00',1.97),('15087','2013-10-28','14:25:00',1.88),('15087','2013-10-28','14:30:00',1.02),('15087','2013-10-28','14:35:00',1.63),('15087','2013-10-28','14:45:00',1.56),('15087','2013-10-28','14:50:00',1.44),('15087','2013-10-28','14:55:00',1.37),('15087','2013-10-28','15:00:00',1.27),('15087','2013-10-28','15:05:00',1.22),('15087','2013-10-28','15:10:00',1.13),('15087','2013-10-27','09:55:00',1.03),('15087','2013-10-27','10:00:00',1.07),('15087','2013-10-27','10:05:00',1.09),('15087','2013-10-27','10:10:00',1.17),('15087','2013-10-27','10:15:00',1.26),('15087','2013-10-27','10:20:00',1.37),('15087','2013-10-27','10:25:00',1.32),('15087','2013-10-27','10:30:00',1.3),('15087','2013-10-27','10:35:00',1.33),('15087','2013-10-27','10:40:00',1.37),('15087','2013-10-27','10:45:00',1.56),('15087','2013-10-27','10:50:00',1.5),('15087','2013-10-27','10:55:00',1.33),('15087','2013-10-27','11:00:00',1.17),('15087','2013-10-27','11:30:00',1.12),('15087','2013-10-27','11:35:00',1.7),('15087','2013-10-27','11:40:00',2.35),('15087','2013-10-27','11:45:00',2.68),('15087','2013-10-27','11:50:00',1.31),('15087','2013-10-27','11:55:00',1.11),('15087','2013-10-27','12:00:00',1.23),('15087','2013-10-27','12:05:00',1.29),('15087','2013-10-27','12:10:00',1.16),('15087','2013-10-27','12:15:00',1.63),('15087','2013-10-27','12:20:00',2.71),('15087','2013-10-27','12:25:00',2.8),('15087','2013-10-27','12:30:00',2.68),('15087','2013-10-27','12:35:00',3.56),('15087','2013-10-27','12:40:00',2.04),('15087','2013-10-27','12:45:00',2.99),('15087','2013-10-27','12:50:00',2.94),('15087','2013-10-27','12:55:00',2.35),('15087','2013-10-27','13:00:00',1.22),('15087','2013-10-27','13:05:00',1.42),('15087','2013-10-27','13:10:00',1.78),('15087','2013-10-27','13:15:00',1),('15087','2013-10-27','13:25:00',2.28),('15087','2013-10-27','13:30:00',2.55),('15087','2013-10-27','13:35:00',2.1),('15087','2013-10-27','13:40:00',1.1),('15087','2013-10-27','14:00:00',1.1),('15087','2013-10-27','14:10:00',1.16),('15087','2013-10-27','14:15:00',1.39),('15087','2013-10-27','14:20:00',1.07),('15087','2013-10-27','14:25:00',1.21),('15087','2013-10-27','14:30:00',1.74),('15087','2013-10-27','14:35:00',1.46),('15087','2013-10-27','14:40:00',1.54),('15087','2013-10-27','14:45:00',1.01),('15087','2013-10-27','14:55:00',1.12),('15087','2013-10-27','15:00:00',1.29),('15087','2013-10-27','15:05:00',1.13),('15087','2013-10-27','15:10:00',1.19),('15087','2013-10-27','15:15:00',1.11),('15087','2013-10-27','15:20:00',1.05),('15087','2013-10-26','09:05:00',1.03),('15087','2013-10-26','09:10:00',1.1),('15087','2013-10-26','09:15:00',1.19),('15087','2013-10-26','09:20:00',1.25),('15087','2013-10-26','09:25:00',1.33),('15087','2013-10-26','09:30:00',1.4),('15087','2013-10-26','09:35:00',1.48),('15087','2013-10-26','09:40:00',1.55),('15087','2013-10-26','09:45:00',1.64),('15087','2013-10-26','09:50:00',1.71),('15087','2013-10-26','09:55:00',1.76),('15087','2013-10-26','10:00:00',1.84),('15087','2013-10-26','10:05:00',1.92),('15087','2013-10-26','10:10:00',2.01),('15087','2013-10-26','10:15:00',2.1),('15087','2013-10-26','10:20:00',2.15),('15087','2013-10-26','10:25:00',2.23),('15087','2013-10-26','10:30:00',2.29),('15087','2013-10-26','10:35:00',2.34),('15087','2013-10-26','10:40:00',2.41),('15087','2013-10-26','10:45:00',2.49),('15087','2013-10-26','10:50:00',2.55),('15087','2013-10-26','10:55:00',2.58),('15087','2013-10-26','11:00:00',2.62),('15087','2013-10-26','11:05:00',2.66),('15087','2013-10-26','11:10:00',2.69),('15087','2013-10-26','11:15:00',2.73),('15087','2013-10-26','11:20:00',2.77),('15087','2013-10-26','11:25:00',2.82),('15087','2013-10-26','11:30:00',2.82),('15087','2013-10-26','11:35:00',2.86),('15087','2013-10-26','11:40:00',2.88),('15087','2013-10-26','11:45:00',2.9),('15087','2013-10-26','11:50:00',2.94),('15087','2013-10-26','11:55:00',2.94),('15087','2013-10-26','12:00:00',2.94),('15087','2013-10-26','12:05:00',2.98),('15087','2013-10-26','12:10:00',2.97),('15087','2013-10-26','12:15:00',2.97),('15087','2013-10-26','12:20:00',3.03),('15087','2013-10-26','12:25:00',2.99),('15087','2013-10-26','12:30:00',2.9),('15087','2013-10-26','12:35:00',3.04),('15087','2013-10-26','12:40:00',2.97),('15087','2013-10-26','12:45:00',2.81),('15087','2013-10-26','12:50:00',2.96),('15087','2013-10-26','12:55:00',2.84),('15087','2013-10-26','13:00:00',3.01),('15087','2013-10-26','13:05:00',2.81),('15087','2013-10-26','13:10:00',2.72),('15087','2013-10-26','13:15:00',3.02),('15087','2013-10-26','13:20:00',2.82),('15087','2013-10-26','13:25:00',2.77),('15087','2013-10-26','13:30:00',2.94),('15087','2013-10-26','13:35:00',2.98),('15087','2013-10-26','13:40:00',2.88),('15087','2013-10-26','13:45:00',2.71),('15087','2013-10-26','13:50:00',2.71),('15087','2013-10-26','13:55:00',2.45),('15087','2013-10-26','14:00:00',2.45),('15087','2013-10-26','14:05:00',2.14),('15087','2013-10-26','14:10:00',2.14),('15087','2013-10-26','14:15:00',1.52),('15087','2013-10-26','14:20:00',1.7),('15087','2013-10-26','14:25:00',1.68),('15087','2013-10-26','14:30:00',2.05),('15087','2013-10-26','14:35:00',2.01),('15087','2013-10-26','14:40:00',1.96),('15087','2013-10-26','14:45:00',1.46),('15087','2013-10-26','14:50:00',1.1),('15087','2013-10-26','14:55:00',2.01),('15087','2013-10-26','15:00:00',1.99),('15087','2013-10-26','15:05:00',1.83),('15087','2013-10-26','15:10:00',1.82),('15087','2013-10-26','15:15:00',1.62),('15087','2013-10-26','15:20:00',1.59),('15087','2013-10-26','15:25:00',1.67),('15087','2013-10-26','15:30:00',1.65),('15087','2013-10-26','15:35:00',1.68),('15087','2013-10-26','15:40:00',1.52),('15087','2013-10-26','15:45:00',1.46),('15087','2013-10-26','15:50:00',1.37),('15087','2013-10-26','15:55:00',1.26),('15087','2013-10-26','16:00:00',1.22),('15087','2013-10-26','16:05:00',1.18),('15087','2013-10-26','16:10:00',1.12),('15087','2013-10-26','16:15:00',1.05),('15087','2013-10-25','09:05:00',1.07),('15087','2013-10-25','09:10:00',1.14),('15087','2013-10-25','09:15:00',1.22),('15087','2013-10-25','09:20:00',1.31),('15087','2013-10-25','09:25:00',1.37),('15087','2013-10-25','09:30:00',1.46),('15087','2013-10-25','09:35:00',1.54),('15087','2013-10-25','09:40:00',1.6),('15087','2013-10-25','09:45:00',1.68),('15087','2013-10-25','09:50:00',1.77),('15087','2013-10-25','09:55:00',1.8),('15087','2013-10-25','10:00:00',1.94),('15087','2013-10-25','10:05:00',1.98),('15087','2013-10-25','10:10:00',2.04),('15087','2013-10-25','10:15:00',2.09),('15087','2013-10-25','10:20:00',2.22),('15087','2013-10-25','10:25:00',2.3),('15087','2013-10-25','10:30:00',2.37),('15087','2013-10-25','10:35:00',2.4),('15087','2013-10-25','10:40:00',2.47),('15087','2013-10-25','10:45:00',2.53),('15087','2013-10-25','10:50:00',2.56),('15087','2013-10-25','10:55:00',2.61),('15087','2013-10-25','11:00:00',2.63),('15087','2013-10-25','11:05:00',2.67),('15087','2013-10-25','11:10:00',2.75),('15087','2013-10-25','11:15:00',2.73),('15087','2013-10-25','11:20:00',2.74),('15087','2013-10-25','11:25:00',2.79),('15087','2013-10-25','11:30:00',2.84),('15087','2013-10-25','11:35:00',2.91),('15087','2013-10-25','11:40:00',2.98),('15087','2013-10-25','11:45:00',3),('15087','2013-10-25','11:50:00',3.04),('15087','2013-10-25','11:55:00',3.05),('15087','2013-10-25','12:00:00',3.09),('15087','2013-10-25','12:05:00',3.11),('15087','2013-10-25','12:10:00',3.14),('15087','2013-10-25','12:15:00',3.11),('15087','2013-10-25','12:20:00',3.14),('15087','2013-10-25','12:25:00',3.14),('15087','2013-10-25','12:30:00',3.15),('15087','2013-10-25','12:35:00',3.15),('15087','2013-10-25','12:40:00',3.18),('15087','2013-10-25','12:45:00',3.18),('15087','2013-10-25','12:50:00',3.18),('15087','2013-10-25','12:55:00',3.17),('15087','2013-10-25','13:00:00',3.15),('15087','2013-10-25','13:05:00',3.13),('15087','2013-10-25','13:10:00',3.12),('15087','2013-10-25','13:15:00',3.09),('15087','2013-10-25','13:20:00',3.06),('15087','2013-10-25','13:25:00',2.83),('15087','2013-10-25','13:30:00',2.95),('15087','2013-10-25','13:35:00',2.95),('15087','2013-10-25','13:40:00',2.76),('15087','2013-10-25','13:45:00',2.82),('15087','2013-10-25','13:50:00',2.83),('15087','2013-10-25','13:55:00',2.62),('15087','2013-10-25','14:00:00',2.64),('15087','2013-10-25','14:05:00',2.68),('15087','2013-10-25','14:10:00',2.47),('15087','2013-10-25','14:15:00',2.51),('15087','2013-10-25','14:20:00',2.53),('15087','2013-10-25','14:25:00',2.38),('15087','2013-10-25','14:30:00',2.45),('15087','2013-10-25','14:35:00',2.33),('15087','2013-10-25','14:40:00',2.23),('15087','2013-10-25','14:45:00',2.27),('15087','2013-10-25','14:50:00',2.3),('15087','2013-10-25','14:55:00',2.25),('15087','2013-10-25','15:00:00',2.14),('15087','2013-10-25','15:05:00',1.93),('15087','2013-10-25','15:10:00',1.77),('15087','2013-10-25','15:15:00',1.79),('15087','2013-10-25','15:20:00',1.73),('15087','2013-10-25','15:25:00',1.63),('15087','2013-10-25','15:30:00',1.55),('15087','2013-10-25','15:35:00',1.53),('15087','2013-10-25','15:40:00',1.5),('15087','2013-10-25','15:45:00',1.48),('15087','2013-10-25','15:50:00',1.38),('15087','2013-10-25','15:55:00',1.35),('15087','2013-10-25','16:00:00',1.31),('15087','2013-10-25','16:05:00',1.2),('15087','2013-10-25','16:10:00',1.12),('15087','2013-10-25','16:15:00',1.1),('15087','2013-10-25','16:20:00',1.03),('15087','2013-10-24','09:05:00',1.21),('15087','2013-10-24','09:10:00',1.21),('15087','2013-10-24','09:15:00',1.58),('15087','2013-10-24','09:20:00',1.19),('15087','2013-10-24','09:35:00',1.03),('15087','2013-10-24','09:40:00',1.1),('15087','2013-10-24','09:45:00',1.14),('15087','2013-10-24','09:50:00',1.16),('15087','2013-10-24','09:55:00',1.12),('15087','2013-10-24','10:00:00',1.08),('15087','2013-10-24','10:05:00',1.04),('15087','2013-10-24','10:20:00',1.62),('15087','2013-10-24','10:35:00',1.88),('15087','2013-10-24','10:40:00',1.1),('15087','2013-10-24','10:45:00',2.2),('15087','2013-10-24','10:50:00',1.69),('15087','2013-10-24','10:55:00',2.14),('15087','2013-10-24','11:00:00',3.15),('15087','2013-10-24','11:05:00',3.52),('15087','2013-10-24','11:10:00',2.27),('15087','2013-10-24','11:15:00',1.96),('15087','2013-10-24','11:20:00',1.81),('15087','2013-10-24','11:25:00',1.62),('15087','2013-10-24','11:30:00',1.21),('15087','2013-10-24','11:35:00',1.19),('15087','2013-10-24','11:40:00',1.12),('15087','2013-10-24','11:45:00',1.23),('15087','2013-10-24','11:50:00',2.02),('15087','2013-10-24','11:55:00',2.89),('15087','2013-10-24','12:00:00',1.75),('15087','2013-10-24','12:05:00',1.41),('15087','2013-10-24','12:10:00',1.34),('15087','2013-10-24','12:15:00',1.34),('15087','2013-10-24','12:20:00',1.41),('15087','2013-10-24','12:25:00',1.54),('15087','2013-10-24','12:30:00',1.62),('15087','2013-10-24','12:35:00',1.8),('15087','2013-10-24','12:40:00',2.19),('15087','2013-10-24','12:45:00',2.46),('15087','2013-10-24','12:50:00',2.02),('15087','2013-10-24','12:55:00',3.09),('15087','2013-10-24','13:00:00',3.41),('15087','2013-10-24','13:05:00',3.34),('15087','2013-10-24','13:10:00',2.74),('15087','2013-10-24','13:15:00',2.39),('15087','2013-10-24','13:20:00',2.53),('15087','2013-10-24','13:25:00',1.92),('15087','2013-10-24','13:30:00',1.36),('15087','2013-10-24','13:35:00',1.31),('15087','2013-10-24','13:40:00',1.34),('15087','2013-10-24','13:45:00',1.46),('15087','2013-10-24','13:50:00',1.91),('15087','2013-10-24','13:55:00',2.38),('15087','2013-10-24','14:00:00',2.28),('15087','2013-10-24','14:05:00',1.54),('15087','2013-10-24','14:10:00',1.4),('15087','2013-10-24','14:15:00',1.34),('15087','2013-10-24','14:20:00',1.48),('15087','2013-10-24','14:25:00',1.49),('15087','2013-10-24','14:30:00',1.56),('15087','2013-10-24','14:35:00',1.84),('15087','2013-10-24','14:40:00',2.06),('15087','2013-10-24','14:45:00',2.14),('15087','2013-10-24','14:50:00',1.55),('15087','2013-10-24','15:05:00',1.33),('15087','2013-10-24','15:10:00',1.81),('15087','2013-10-24','15:15:00',1.11),('15087','2013-10-24','15:20:00',1.26),('15087','2013-10-24','15:30:00',1.32),('15087','2013-10-24','15:35:00',2),('15087','2013-10-24','15:40:00',1.83),('15087','2013-10-24','15:45:00',1.74),('15087','2013-10-24','15:50:00',1.08),('15087','2013-10-23','10:20:00',1.13),('15087','2013-10-23','10:25:00',1.21),('15087','2013-10-23','10:30:00',1.16),('15087','2013-10-23','10:35:00',1.12),('15087','2013-10-23','10:40:00',1.24),('15087','2013-10-23','10:45:00',1.17),('15087','2013-10-23','10:50:00',1.34),('15087','2013-10-23','10:55:00',1.36),('15087','2013-10-23','11:00:00',1.45),('15087','2013-10-23','11:05:00',1.78),('15087','2013-10-23','11:10:00',1.72),('15087','2013-10-23','11:15:00',1.56),('15087','2013-10-23','11:20:00',2.87),('15087','2013-10-23','11:25:00',2.89),('15087','2013-10-23','11:30:00',3.01),('15087','2013-10-23','11:35:00',2.81),('15087','2013-10-23','11:40:00',2.97),('15087','2013-10-23','11:45:00',2.93),('15087','2013-10-23','11:50:00',3.03),('15087','2013-10-23','11:55:00',2.96),('15087','2013-10-23','12:00:00',2.9),('15087','2013-10-23','12:05:00',2.82),('15087','2013-10-23','12:10:00',2.73),('15087','2013-10-23','12:15:00',2.63),('15087','2013-10-23','12:20:00',2.89),('15087','2013-10-23','12:25:00',2.93),('15087','2013-10-23','12:30:00',2.97),('15087','2013-10-23','12:35:00',3.03),('15087','2013-10-23','12:40:00',2.9),('15087','2013-10-23','12:45:00',2.91),('15087','2013-10-23','12:50:00',1.91),('15087','2013-10-23','12:55:00',2.09),('15087','2013-10-23','13:00:00',2.76),('15087','2013-10-23','13:05:00',2.94),('15087','2013-10-23','13:10:00',2.85),('15087','2013-10-23','13:15:00',2.82),('15087','2013-10-23','13:20:00',2.92),('15087','2013-10-23','13:25:00',2.87),('15087','2013-10-23','13:30:00',2.68),('15087','2013-10-23','13:35:00',2.65),('15087','2013-10-23','13:40:00',2.65),('15087','2013-10-23','13:45:00',2.55),('15087','2013-10-23','13:50:00',2.3),('15087','2013-10-23','13:55:00',2.25),('15087','2013-10-23','14:00:00',2.39),('15087','2013-10-23','14:05:00',2.54),('15087','2013-10-23','14:10:00',2.41),('15087','2013-10-23','14:15:00',2.27),('15087','2013-10-23','14:20:00',2.27),('15087','2013-10-23','14:25:00',2.21),('15087','2013-10-23','14:30:00',2.12),('15087','2013-10-23','14:35:00',2.08),('15087','2013-10-23','14:40:00',2.23),('15087','2013-10-23','14:45:00',2.16),('15087','2013-10-23','14:50:00',2.08),('15087','2013-10-23','14:55:00',2.09),('15087','2013-10-23','15:00:00',2.09),('15087','2013-10-23','15:05:00',2.01),('15087','2013-10-23','15:10:00',1.8),('15087','2013-10-23','15:15:00',1.8),('15087','2013-10-23','15:20:00',1.82),('15087','2013-10-23','15:25:00',1.81),('15087','2013-10-23','15:30:00',1.61),('15087','2013-10-23','15:35:00',1.49),('15087','2013-10-23','15:40:00',1.63),('15087','2013-10-23','15:45:00',1.52),('15087','2013-10-23','15:50:00',1.43),('15087','2013-10-23','15:55:00',1.21),('15087','2013-10-22','09:00:00',1.01),('15087','2013-10-22','09:05:00',1.08),('15087','2013-10-22','09:10:00',1.14),('15087','2013-10-22','09:15:00',1.21),('15087','2013-10-22','09:20:00',1.29),('15087','2013-10-22','09:25:00',1.37),('15087','2013-10-22','09:30:00',1.45),('15087','2013-10-22','09:35:00',1.54),('15087','2013-10-22','09:40:00',1.61),('15087','2013-10-22','09:45:00',1.71),('15087','2013-10-22','09:50:00',1.78),('15087','2013-10-22','09:55:00',1.88),('15087','2013-10-22','10:00:00',1.94),('15087','2013-10-22','10:05:00',2.04),('15087','2013-10-22','10:10:00',2.09),('15087','2013-10-22','10:15:00',2.17),('15087','2013-10-22','10:20:00',2.24),('15087','2013-10-22','10:25:00',2.3),('15087','2013-10-22','10:30:00',2.35),('15087','2013-10-22','10:35:00',2.4),('15087','2013-10-22','10:40:00',2.42),('15087','2013-10-22','10:45:00',2.5),('15087','2013-10-22','10:50:00',2.55),('15087','2013-10-22','10:55:00',2.6),('15087','2013-10-22','11:00:00',2.65),('15087','2013-10-22','11:05:00',2.67),('15087','2013-10-22','11:10:00',2.7),('15087','2013-10-22','11:15:00',2.69),('15087','2013-10-22','11:20:00',2.72),('15087','2013-10-22','11:25:00',2.74),('15087','2013-10-22','11:30:00',2.81),('15087','2013-10-22','11:35:00',2.79),('15087','2013-10-22','11:40:00',2.8),('15087','2013-10-22','11:45:00',2.82),('15087','2013-10-22','11:50:00',2.86),('15087','2013-10-22','11:55:00',2.9),('15087','2013-10-22','12:00:00',2.93),('15087','2013-10-22','12:05:00',2.91),('15087','2013-10-22','12:10:00',2.96),('15087','2013-10-22','12:15:00',2.94),('15087','2013-10-22','12:20:00',2.88),('15087','2013-10-22','12:25:00',2.95),('15087','2013-10-22','12:30:00',3.01),('15087','2013-10-22','12:35:00',3.04),('15087','2013-10-22','12:40:00',2.96),('15087','2013-10-22','12:45:00',2.96),('15087','2013-10-22','12:50:00',2.99),('15087','2013-10-22','12:55:00',2.92),('15087','2013-10-22','13:00:00',2.91),('15087','2013-10-22','13:05:00',2.93),('15087','2013-10-22','13:10:00',2.92),('15087','2013-10-22','13:15:00',2.98),('15087','2013-10-22','13:20:00',2.94),('15087','2013-10-22','13:25:00',2.94),('15087','2013-10-22','13:30:00',2.79),('15087','2013-10-22','13:35:00',2.82),('15087','2013-10-22','13:40:00',2.59),('15087','2013-10-22','13:45:00',2.59),('15087','2013-10-22','13:50:00',2.74),('15087','2013-10-22','13:55:00',2.5),('15087','2013-10-22','14:00:00',2.51),('15087','2013-10-22','14:05:00',2.73),('15087','2013-10-22','14:10:00',2.74),('15087','2013-10-22','14:15:00',2.76),('15087','2013-10-22','14:20:00',2.79),('15087','2013-10-22','14:25:00',2.84),('15087','2013-10-22','14:30:00',2.63),('15087','2013-10-22','14:35:00',2.47),('15087','2013-10-22','14:40:00',2.33),('15087','2013-10-22','14:45:00',2.28),('15087','2013-10-22','14:50:00',2.19),('15087','2013-10-22','14:55:00',2.11),('15087','2013-10-22','15:00:00',2.09),('15087','2013-10-22','15:05:00',1.99),('15087','2013-10-22','15:10:00',1.89),('15087','2013-10-22','15:15:00',1.85),('15087','2013-10-22','15:20:00',1.78),('15087','2013-10-22','15:25:00',1.68),('15087','2013-10-22','15:30:00',1.68),('15087','2013-10-22','15:35:00',1.67),('15087','2013-10-22','15:40:00',1.65),('15087','2013-10-22','15:45:00',1.37),('15087','2013-10-22','15:50:00',1.45),('15087','2013-10-22','15:55:00',1.4),('15087','2013-10-22','16:00:00',1.3),('15087','2013-10-22','16:05:00',1.26),('15087','2013-10-22','16:10:00',1.17),('15087','2013-10-22','16:15:00',1.1),('15087','2013-10-22','16:20:00',1.03),('15087','2013-10-22','16:25:00',1.01),('15087','2013-10-21','09:10:00',1.09),('15087','2013-10-21','09:15:00',1.21),('15087','2013-10-21','09:20:00',1.48),('15087','2013-10-21','09:25:00',1.51),('15087','2013-10-21','09:30:00',1.39),('15087','2013-10-21','09:35:00',1.35),('15087','2013-10-21','09:40:00',1.58),('15087','2013-10-21','09:45:00',1.42),('15087','2013-10-21','09:50:00',1.58),('15087','2013-10-21','09:55:00',1.83),('15087','2013-10-21','10:00:00',1.74),('15087','2013-10-21','10:05:00',2.15),('15087','2013-10-21','10:10:00',2.18),('15087','2013-10-21','10:15:00',2.27),('15087','2013-10-21','10:20:00',2.28),('15087','2013-10-21','10:25:00',2.41),('15087','2013-10-21','10:30:00',2.34),('15087','2013-10-21','10:35:00',2.4),('15087','2013-10-21','10:40:00',2.36),('15087','2013-10-21','10:45:00',2.4),('15087','2013-10-21','10:50:00',2.57),('15087','2013-10-21','10:55:00',2.53),('15087','2013-10-21','11:00:00',2.78),('15087','2013-10-21','11:05:00',2.36),('15087','2013-10-21','11:10:00',2.52),('15087','2013-10-21','11:15:00',2.87),('15087','2013-10-21','11:20:00',2.83),('15087','2013-10-21','11:25:00',2.83),('15087','2013-10-21','11:30:00',2.96),('15087','2013-10-21','11:35:00',2.91),('15087','2013-10-21','11:40:00',2.9),('15087','2013-10-21','11:45:00',3),('15087','2013-10-21','11:50:00',3.06),('15087','2013-10-21','11:55:00',3.08),('15087','2013-10-21','12:00:00',3.16),('15087','2013-10-21','12:05:00',3.2),('15087','2013-10-21','12:10:00',3.22),('15087','2013-10-21','12:15:00',3.17),('15087','2013-10-21','12:20:00',3.16),('15087','2013-10-21','12:25:00',3.14),('15087','2013-10-21','12:30:00',3.04),('15087','2013-10-21','12:35:00',3.2),('15087','2013-10-21','12:40:00',3.24),('15087','2013-10-21','12:45:00',3.22),('15087','2013-10-21','12:50:00',3.21),('15087','2013-10-21','12:55:00',3.2),('15087','2013-10-21','13:00:00',3.15),('15087','2013-10-21','13:05:00',3.1),('15087','2013-10-21','13:10:00',3.04),('15087','2013-10-21','13:15:00',3.09),('15087','2013-10-21','13:20:00',3.02),('15087','2013-10-21','13:25:00',2.94),('15087','2013-10-21','13:30:00',3),('15087','2013-10-21','13:35:00',3.07),('15087','2013-10-21','13:40:00',2.85),('15087','2013-10-21','13:45:00',2.82),('15087','2013-10-21','13:50:00',2.82),('15087','2013-10-21','13:55:00',2.69),('15087','2013-10-21','14:00:00',2.67),('15087','2013-10-21','14:05:00',2.77),('15087','2013-10-21','14:10:00',2.64),('15087','2013-10-21','14:15:00',2.55),('15087','2013-10-21','14:20:00',2.58),('15087','2013-10-21','14:25:00',2.45),('15087','2013-10-21','14:30:00',2.41),('15087','2013-10-21','14:35:00',2.39),('15087','2013-10-21','14:40:00',2.24),('15087','2013-10-21','14:45:00',2.18),('15087','2013-10-21','14:50:00',2.14),('15087','2013-10-21','14:55:00',2.11),('15087','2013-10-21','15:00:00',2.07),('15087','2013-10-21','15:05:00',2.11),('15087','2013-10-21','15:10:00',1.95),('15087','2013-10-21','15:15:00',1.81),('15087','2013-10-21','15:20:00',1.84),('15087','2013-10-21','15:25:00',1.72),('15087','2013-10-21','15:30:00',1.64),('15087','2013-10-21','15:35:00',1.62),('15087','2013-10-21','15:40:00',1.58),('15087','2013-10-21','15:45:00',1.55),('15087','2013-10-21','15:50:00',1.51),('15087','2013-10-21','15:55:00',1.41),('15087','2013-10-21','16:00:00',1.4),('15087','2013-10-21','16:05:00',1.36),('15087','2013-10-21','16:10:00',1.29),('15087','2013-10-21','16:15:00',1.2),('15087','2013-10-21','16:20:00',1.12),('15087','2013-10-21','16:25:00',1.04),('15087','2013-10-20','08:55:00',1.04),('15087','2013-10-20','09:00:00',1.08),('15087','2013-10-20','09:05:00',1.17),('15087','2013-10-20','09:10:00',1.3),('15087','2013-10-20','09:15:00',1.37),('15087','2013-10-20','09:20:00',1.48),('15087','2013-10-20','09:25:00',1.54),('15087','2013-10-20','09:30:00',1.61),('15087','2013-10-20','09:35:00',1.68),('15087','2013-10-20','09:40:00',1.77),('15087','2013-10-20','09:45:00',1.82),('15087','2013-10-20','09:50:00',1.89),('15087','2013-10-20','09:55:00',1.97),('15087','2013-10-20','10:00:00',2.09),('15087','2013-10-20','10:05:00',2.19),('15087','2013-10-20','10:10:00',2.26),('15087','2013-10-20','10:15:00',2.32),('15087','2013-10-20','10:20:00',2.36),('15087','2013-10-20','10:25:00',2.44),('15087','2013-10-20','10:30:00',2.49),('15087','2013-10-20','10:35:00',2.55),('15087','2013-10-20','10:40:00',2.59),('15087','2013-10-20','10:45:00',2.65),('15087','2013-10-20','10:50:00',2.69),('15087','2013-10-20','10:55:00',2.77),('15087','2013-10-20','11:00:00',2.81),('15087','2013-10-20','11:05:00',2.85),('15087','2013-10-20','11:10:00',2.87),('15087','2013-10-20','11:15:00',2.91),('15087','2013-10-20','11:20:00',2.97),('15087','2013-10-20','11:25:00',3),('15087','2013-10-20','11:30:00',3.07),('15087','2013-10-20','11:35:00',3.11),('15087','2013-10-20','11:40:00',3.12),('15087','2013-10-20','11:45:00',3.13),('15087','2013-10-20','11:50:00',3.16),('15087','2013-10-20','11:55:00',3.13),('15087','2013-10-20','12:00:00',3.1),('15087','2013-10-20','12:05:00',3.22),('15087','2013-10-20','12:10:00',3.24),('15087','2013-10-20','12:15:00',2.6),('15087','2013-10-20','12:20:00',2.4),('15087','2013-10-20','12:25:00',2.66),('15087','2013-10-20','12:30:00',3.64),('15087','2013-10-20','12:35:00',2.1),('15087','2013-10-20','12:40:00',1.21),('15087','2013-10-20','12:45:00',2.6),('15087','2013-10-20','12:50:00',2.28),('15087','2013-10-20','12:55:00',1.78),('15087','2013-10-20','13:00:00',3.2),('15087','2013-10-20','13:05:00',1.95),('15087','2013-10-20','13:10:00',1.97),('15087','2013-10-20','13:15:00',1.11),('15087','2013-10-20','13:20:00',1.99),('15087','2013-10-20','13:25:00',1.88),('15087','2013-10-20','13:30:00',1.12),('15087','2013-10-20','13:35:00',1.09),('15087','2013-10-20','13:40:00',2.07),('15087','2013-10-20','13:45:00',1.65),('15087','2013-10-20','13:50:00',1.11),('15087','2013-10-20','13:55:00',1.29),('15087','2013-10-20','14:10:00',1.01),('15087','2013-10-20','16:35:00',1.03),('15087','2013-10-20','16:50:00',1.18),('15087','2013-10-20','16:55:00',1.16),('15087','2013-10-20','17:00:00',1.05),('15087','2013-10-19','08:50:00',1.15),('15087','2013-10-19','09:00:00',1.03),('15087','2013-10-19','09:05:00',1.09),('15087','2013-10-19','09:10:00',1.38),('15087','2013-10-19','09:15:00',1.74),('15087','2013-10-19','09:20:00',1.82),('15087','2013-10-19','09:25:00',1.86),('15087','2013-10-19','09:30:00',1.89),('15087','2013-10-19','09:35:00',1.97),('15087','2013-10-19','09:40:00',2.11),('15087','2013-10-19','09:45:00',2.19),('15087','2013-10-19','09:50:00',2.3),('15087','2013-10-19','09:55:00',2.41),('15087','2013-10-19','10:00:00',2.37),('15087','2013-10-19','10:05:00',2.36),('15087','2013-10-19','10:10:00',2.52),('15087','2013-10-19','10:15:00',2.44),('15087','2013-10-19','10:20:00',2.58),('15087','2013-10-19','10:25:00',2.81),('15087','2013-10-19','10:30:00',2.87),('15087','2013-10-19','10:35:00',2.88),('15087','2013-10-19','10:40:00',2.92),('15087','2013-10-19','10:45:00',2.9),('15087','2013-10-19','10:50:00',2.95),('15087','2013-10-19','10:55:00',3.09),('15087','2013-10-19','11:00:00',2.86),('15087','2013-10-19','11:05:00',2.87),('15087','2013-10-19','11:10:00',1.14),('15087','2013-10-19','11:15:00',1.28),('15087','2013-10-19','11:20:00',2.83),('15087','2013-10-19','11:25:00',3.4),('15087','2013-10-19','11:30:00',3.44),('15087','2013-10-19','11:35:00',3.4),('15087','2013-10-19','11:40:00',3.26),('15087','2013-10-19','11:45:00',3.44),('15087','2013-10-19','11:50:00',3.07),('15087','2013-10-19','11:55:00',3.45),('15087','2013-10-19','12:00:00',3.51),('15087','2013-10-19','12:05:00',3.52),('15087','2013-10-19','12:10:00',3.47),('15087','2013-10-19','12:15:00',3.49),('15087','2013-10-19','12:20:00',3.43),('15087','2013-10-19','12:25:00',3.21),('15087','2013-10-19','12:30:00',3.48),('15087','2013-10-19','12:35:00',3.56),('15087','2013-10-19','12:40:00',3.68),('15087','2013-10-19','12:45:00',3.76),('15087','2013-10-19','12:50:00',3.75),('15087','2013-10-19','12:55:00',3.89),('15087','2013-10-19','13:00:00',4.02),('15087','2013-10-19','13:05:00',3.26),('15087','2013-10-19','13:10:00',3.56),('15087','2013-10-19','13:15:00',3.35),('15087','2013-10-19','13:20:00',3.38),('15087','2013-10-19','13:25:00',3.45),('15087','2013-10-19','13:30:00',3.61),('15087','2013-10-19','13:35:00',2.62),('15087','2013-10-19','13:40:00',2.3),('15087','2013-10-19','13:45:00',2.23),('15087','2013-10-19','13:50:00',2.79),('15087','2013-10-19','13:55:00',3.41),('15087','2013-10-19','14:00:00',2.8),('15087','2013-10-19','14:05:00',2.35),('15087','2013-10-19','14:10:00',1.84),('15087','2013-10-19','14:15:00',2.48),('15087','2013-10-19','14:20:00',1.88),('15087','2013-10-19','14:25:00',1.72),('15087','2013-10-19','14:30:00',2.38),('15087','2013-10-19','14:35:00',2.73),('15087','2013-10-19','14:40:00',2.43),('15087','2013-10-19','14:45:00',2.05),('15087','2013-10-19','14:50:00',2.67),('15087','2013-10-19','14:55:00',2.6),('15087','2013-10-19','15:00:00',2.52),('15087','2013-10-19','15:05:00',2.24),('15087','2013-10-19','15:10:00',2.35),('15087','2013-10-19','15:15:00',2.11),('15087','2013-10-19','15:20:00',1.87),('15087','2013-10-19','15:25:00',1.99),('15087','2013-10-19','15:30:00',1.82),('15087','2013-10-19','15:35:00',1.79),('15087','2013-10-19','15:40:00',1.71),('15087','2013-10-19','15:45:00',1.41),('15087','2013-10-19','15:50:00',1.57),('15087','2013-10-19','15:55:00',1.77),('15087','2013-10-19','16:00:00',1.43),('15087','2013-10-19','16:05:00',1.55),('15087','2013-10-19','16:10:00',1.41),('15087','2013-10-19','16:15:00',1.5),('15087','2013-10-19','16:20:00',1.25),('15087','2013-10-19','16:25:00',1.02),('15087','2013-10-19','16:30:00',1.23),('15087','2013-10-19','16:35:00',1.15),('15087','2013-10-19','16:40:00',1.18),('15087','2013-10-19','16:45:00',1.07),('15087','2014-05-04','07:45:00',1.37),('15087','2014-05-04','07:50:00',1.45),('15087','2014-05-04','07:55:00',1.53),('15087','2014-05-04','08:00:00',1.61),('15087','2014-05-04','08:05:00',1.76),('15087','2014-05-04','08:10:00',1.83),('15087','2014-05-04','08:15:00',1.96),('15087','2014-05-04','08:20:00',2.08),('15087','2014-05-04','08:25:00',2.17),('15087','2014-05-04','08:30:00',2.19),('15087','2014-05-04','08:35:00',2.6),('15087','2014-05-04','08:40:00',1.65),('15087','2014-05-04','08:45:00',1.38),('15087','2014-05-04','08:50:00',1.66),('15087','2014-05-04','08:55:00',1.21),('15087','2014-05-04','09:00:00',1.41),('15087','2014-05-04','09:05:00',2.24),('15087','2014-05-04','09:10:00',2.27),('15087','2014-05-04','09:15:00',2.22),('15087','2014-05-04','09:20:00',3.74),('15087','2014-05-04','09:25:00',3.9),('15087','2014-05-04','09:30:00',2.31),('15087','2014-05-04','09:35:00',1.31),('15087','2014-05-04','09:40:00',1.56),('15087','2014-05-04','09:45:00',2.42),('15087','2014-05-04','09:50:00',2.27),('15087','2014-05-04','09:55:00',2.25),('15087','2014-05-04','10:00:00',3.97),('15087','2014-05-04','10:05:00',4.16),('15087','2014-05-04','10:10:00',3.37),('15087','2014-05-04','10:15:00',2.89),('15087','2014-05-04','10:20:00',2.15),('15087','2014-05-04','10:25:00',2.15),('15087','2014-05-04','10:30:00',2.35),('15087','2014-05-04','10:35:00',2.41),('15087','2014-05-04','10:40:00',2.49),('15087','2014-05-04','10:45:00',2.88),('15087','2014-05-04','10:50:00',3.14),('15087','2014-05-04','10:55:00',2.87),('15087','2014-05-04','11:00:00',2.66),('15087','2014-05-04','11:05:00',2.74),('15087','2014-05-04','11:10:00',4.68),('15087','2014-05-04','11:15:00',4.2),('15087','2014-05-04','11:20:00',5.03),('15087','2014-05-04','11:25:00',5.02),('15087','2014-05-04','11:30:00',4.58),('15087','2014-05-04','11:35:00',4.02),('15087','2014-05-04','11:40:00',3.43),('15087','2014-05-04','11:45:00',4.32),('15087','2014-05-04','11:50:00',3.83),('15087','2014-05-04','11:55:00',4.28),('15087','2014-05-04','12:00:00',3.03),('15087','2014-05-04','12:05:00',2.44),('15087','2014-05-04','12:10:00',2.03),('15087','2014-05-04','12:15:00',1.85),('15087','2014-05-04','12:20:00',1.75),('15087','2014-05-04','12:25:00',1.98),('15087','2014-05-04','12:30:00',3.73),('15087','2014-05-04','12:35:00',5.75),('15087','2014-05-04','12:40:00',3.75),('15087','2014-05-04','12:45:00',3.37),('15087','2014-05-04','12:50:00',1.89),('15087','2014-05-04','12:55:00',2.16),('15087','2014-05-04','13:00:00',2.82),('15087','2014-05-04','13:05:00',1.86),('15087','2014-05-04','13:10:00',1.97),('15087','2014-05-04','13:15:00',1.93),('15087','2014-05-04','13:20:00',1.78),('15087','2014-05-04','13:25:00',1.72),('15087','2014-05-04','13:30:00',1.65),('15087','2014-05-04','13:35:00',1.8),('15087','2014-05-04','13:40:00',1.76),('15087','2014-05-04','13:45:00',1.54),('15087','2014-05-04','13:50:00',1.44),('15087','2014-05-04','13:55:00',1.51),('15087','2014-05-04','14:00:00',1.54),('15087','2014-05-04','14:05:00',1.58),('15087','2014-05-04','14:10:00',1.51),('15087','2014-05-04','14:15:00',1.39),('15087','2014-05-04','14:20:00',1.02),('15087','2014-05-04','14:50:00',1.24),('15087','2014-05-04','14:55:00',1.92),('15087','2014-05-04','15:00:00',2.2),('15087','2014-05-04','15:05:00',2.43),('15087','2014-05-04','15:10:00',3.68),('15087','2014-05-04','15:15:00',2.54),('15087','2014-05-04','15:20:00',2.21),('15087','2014-05-04','15:25:00',1.74),('15087','2014-05-04','15:30:00',1.4),('15087','2014-05-04','15:50:00',1.18),('15087','2014-05-04','15:55:00',1.23),('15087','2014-05-04','16:00:00',1.08),('15087','2014-05-04','16:05:00',1.13),('15087','2014-05-04','16:10:00',1.38),('15087','2014-05-04','16:15:00',1.31),('15087','2014-05-04','16:20:00',1.08),('15087','2014-05-04','17:35:00',1.05),('15087','2014-05-04','17:40:00',1.11),('15087','2014-04-16','07:55:00',1.03),('15087','2014-04-16','08:00:00',1.13),('15087','2014-04-16','08:05:00',1.26),('15087','2014-04-16','08:10:00',1.41),('15087','2014-04-16','08:15:00',1.54),('15087','2013-10-17','08:45:00',1.04),('15087','2013-10-17','08:50:00',1.11),('15087','2013-10-17','08:55:00',1.19),('15087','2013-10-17','09:00:00',1.28),('15087','2013-10-17','09:05:00',1.38),('15087','2013-10-17','09:10:00',1.48),('15087','2013-10-17','09:15:00',1.57),('15087','2013-10-17','09:20:00',1.66),('15087','2013-10-17','09:25:00',1.77),('15087','2013-10-17','09:30:00',1.85),('15087','2013-10-17','09:35:00',1.96),('15087','2013-10-17','09:40:00',2.04),('15087','2013-10-17','09:45:00',2.14),('15087','2013-10-17','09:50:00',2.22),('15087','2013-10-17','09:55:00',2.3),('15087','2013-10-17','10:00:00',2.36),('15087','2013-10-17','10:05:00',2.41),('15087','2013-10-17','10:10:00',2.49),('15087','2013-10-17','10:15:00',2.58),('15087','2013-10-17','10:20:00',2.65),('15087','2013-10-17','10:25:00',2.71),('15087','2013-10-17','10:30:00',2.76),('15087','2013-10-17','10:35:00',2.82),('15087','2013-10-17','10:40:00',2.89),('15087','2013-10-17','10:45:00',2.97),('15087','2013-10-17','10:50:00',3.03),('15087','2013-10-17','10:55:00',3.07),('15087','2013-10-17','11:00:00',3.1),('15087','2013-10-17','11:05:00',3.14),('15087','2013-10-17','11:10:00',3.18),('15087','2013-10-17','11:15:00',3.24),('15087','2013-10-17','11:20:00',3.28),('15087','2013-10-17','11:25:00',3.3),('15087','2013-10-17','11:30:00',3.34),('15087','2013-10-17','11:35:00',3.38),('15087','2013-10-17','11:40:00',3.41),('15087','2013-10-17','11:45:00',3.4),('15087','2013-10-17','11:50:00',3.41),('15087','2013-10-17','11:55:00',3.45),('15087','2013-10-17','12:00:00',3.49),('15087','2013-10-17','12:05:00',3.5),('15087','2013-10-17','12:10:00',3.5),('15087','2013-10-17','12:15:00',3.51),('15087','2013-10-17','12:20:00',3.52),('15087','2013-10-17','12:25:00',3.53),('15087','2013-10-17','12:30:00',3.51),('15087','2013-10-17','12:35:00',3.55),('15087','2013-10-17','12:40:00',3.59),('15087','2013-10-17','12:45:00',3.6),('15087','2013-10-17','12:50:00',3.6),('15087','2013-10-17','12:55:00',3.59),('15087','2013-10-17','13:00:00',3.58),('15087','2013-10-17','13:05:00',3.56),('15087','2013-10-17','13:10:00',3.55),('15087','2013-10-17','13:15:00',3.54),('15087','2013-10-17','13:20:00',3.5),('15087','2013-10-17','13:25:00',3.29),('15087','2013-10-17','13:30:00',3.13),('15087','2013-10-17','13:35:00',3.41),('15087','2013-10-17','13:40:00',3.19),('15087','2013-10-17','13:45:00',2.96),('15087','2013-10-17','13:50:00',3.29),('15087','2013-10-17','13:55:00',3.11),('15087','2013-10-17','14:00:00',2.94),('15087','2013-10-17','14:05:00',3.11),('15087','2013-10-17','14:10:00',3.12),('15087','2013-10-17','14:15:00',2.9),('15087','2013-10-17','14:20:00',2.98),('15087','2013-10-17','14:25:00',2.87),('15087','2013-10-17','14:30:00',2.71),('15087','2013-10-17','14:35:00',2.77),('15087','2013-10-17','14:40:00',2.69),('15087','2013-10-17','14:45:00',2.64),('15087','2013-10-17','14:50:00',2.59),('15087','2013-10-17','14:55:00',2.53),('15087','2013-10-17','15:00:00',2.44),('15087','2013-10-17','15:05:00',2.45),('15087','2013-10-17','15:10:00',2.4),('15087','2013-10-17','15:15:00',2.04),('15087','2013-10-17','15:20:00',2.1),('15087','2013-10-17','15:25:00',2),('15087','2013-10-17','15:30:00',1.72),('15087','2013-10-17','15:35:00',1.93),('15087','2013-10-17','15:40:00',1.79),('15087','2013-10-17','15:45:00',1.65),('15087','2013-10-17','15:50:00',1.7),('15087','2013-10-17','15:55:00',1.56),('15087','2013-10-17','16:00:00',1.55),('15087','2013-10-17','16:05:00',1.58),('15087','2013-10-17','16:10:00',1.49),('15087','2013-10-17','16:15:00',1.42),('15087','2013-10-17','16:20:00',1.33),('15087','2013-10-17','16:25:00',1.22),('15087','2013-10-17','16:30:00',1.13),('15087','2013-10-17','16:35:00',1.07),('15087','2013-10-17','16:40:00',1.01),('15087','2013-10-16','09:45:00',1.7),('15087','2013-10-16','09:50:00',1.48),('15087','2013-10-16','11:15:00',1.35),('15087','2013-10-16','11:55:00',1.21),('15087','2013-10-16','12:10:00',1.62),('15087','2013-10-16','12:15:00',3.49),('15087','2013-10-16','12:20:00',1.84),('15087','2013-10-16','12:30:00',1.38),('15087','2013-10-16','12:35:00',1.41),('15087','2013-10-16','12:40:00',4.05),('15087','2013-10-16','12:45:00',2.9),('15087','2013-10-16','12:50:00',3.55),('15087','2013-10-16','12:55:00',2.15),('15087','2013-10-16','13:00:00',2.55),('15087','2013-10-16','13:05:00',3.82),('15087','2013-10-16','13:10:00',3.1),('15087','2013-10-16','13:20:00',2.75),('15087','2013-10-16','13:25:00',3.65),('15087','2013-10-16','13:30:00',3.5),('15087','2013-10-16','13:35:00',3.44),('15087','2013-10-16','13:40:00',2.42),('15087','2013-10-16','13:45:00',3.36),('15087','2013-10-16','13:50:00',3.1),('15087','2013-10-16','13:55:00',3.39),('15087','2013-10-16','14:00:00',2.03),('15087','2013-10-16','14:05:00',2.15),('15087','2013-10-16','14:10:00',3.45),('15087','2013-10-16','14:15:00',2.66),('15087','2013-10-16','14:20:00',1.86),('15087','2013-10-16','14:25:00',3.26),('15087','2013-10-16','14:30:00',2.99),('15087','2013-10-16','14:35:00',2.78),('15087','2013-10-16','14:40:00',2.52),('15087','2013-10-16','14:45:00',1.84),('15087','2013-10-16','14:50:00',2.49),('15087','2013-10-16','14:55:00',2.38),('15087','2013-10-16','15:00:00',2.58),('15087','2013-10-16','15:05:00',1.83),('15087','2013-10-16','15:10:00',2.15),('15087','2013-10-16','15:15:00',2.15),('15087','2013-10-16','15:20:00',1.98),('15087','2013-10-16','15:25:00',1.49),('15087','2013-10-16','15:35:00',1.52),('15087','2013-10-16','15:40:00',2.05),('15087','2013-10-16','15:45:00',1.83),('15087','2013-10-16','15:50:00',1.74),('15087','2013-10-16','15:55:00',1.73),('15087','2013-10-16','16:00:00',1.71),('15087','2013-10-16','16:05:00',1.65),('15087','2013-10-16','16:10:00',1.52),('15087','2013-10-16','16:15:00',1.42),('15087','2013-10-16','16:20:00',1.32),('15087','2013-10-16','16:25:00',1.26),('15087','2013-10-16','16:30:00',1.17),('15087','2013-10-16','16:40:00',1.04),('15087','2013-10-15','09:10:00',1.01),('15087','2013-10-15','09:20:00',1.06),('15087','2013-10-15','09:25:00',1.11),('15087','2013-10-15','09:30:00',1.59),('15087','2013-10-15','09:35:00',1.06),('15087','2013-10-15','09:40:00',1.45),('15087','2013-10-15','09:45:00',2.03),('15087','2013-10-15','09:50:00',2.22),('15087','2013-10-15','09:55:00',2.33),('15087','2013-10-15','10:00:00',2.3),('15087','2013-10-15','10:05:00',2.56),('15087','2013-10-15','10:10:00',1.93),('15087','2013-10-15','10:15:00',1.17),('15087','2013-10-15','10:20:00',1.18),('15087','2013-10-15','10:25:00',1.58),('15087','2013-10-15','10:30:00',2.01),('15087','2013-10-15','10:35:00',1.7),('15087','2013-10-15','10:40:00',2.07),('15087','2013-10-15','10:45:00',2.42),('15087','2013-10-15','10:50:00',2.29),('15087','2013-10-15','10:55:00',2),('15087','2013-10-15','11:00:00',1.97),('15087','2013-10-15','11:05:00',2.16),('15087','2013-10-15','11:10:00',2.79),('15087','2013-10-15','11:15:00',3.02),('15087','2013-10-15','11:20:00',3.07),('15087','2013-10-15','11:25:00',2.85),('15087','2013-10-15','11:30:00',2.97),('15087','2013-10-15','11:35:00',2.48),('15087','2013-10-15','11:40:00',1.96),('15087','2013-10-15','11:45:00',1.55),('15087','2013-10-15','11:50:00',1.48),('15087','2013-10-15','11:55:00',1.48),('15087','2013-10-15','12:00:00',1.53),('15087','2013-10-15','12:05:00',1.54),('15087','2013-10-15','12:10:00',1.57),('15087','2013-10-15','12:15:00',1.54),('15087','2013-10-15','12:20:00',1.62),('15087','2013-10-15','12:25:00',1.45),('15087','2013-10-15','12:30:00',1.33),('15087','2013-10-15','12:35:00',1.3),('15087','2013-10-15','12:40:00',1.3),('15087','2013-10-15','12:45:00',1.44),('15087','2013-10-15','12:50:00',1.38),('15087','2013-10-15','12:55:00',1.24),('15087','2013-10-15','13:00:00',1.23),('15087','2013-10-15','13:05:00',1.67),('15087','2013-10-15','13:10:00',1.91),('15087','2013-10-15','13:15:00',1.96),('15087','2013-10-15','13:20:00',2.88),('15087','2013-10-15','13:25:00',3.21),('15087','2013-10-15','13:30:00',2),('15087','2013-10-15','13:35:00',1.66),('15087','2013-10-15','13:40:00',1.55),('15087','2013-10-15','13:45:00',1.65),('15087','2013-10-15','13:50:00',1.5),('15087','2013-10-15','13:55:00',1.32),('15087','2013-10-15','14:00:00',1.2),('15087','2013-10-15','14:05:00',1.19),('15087','2013-10-15','14:10:00',1.33),('15087','2013-10-15','14:15:00',1.88),('15087','2013-10-15','14:20:00',2.08),('15087','2013-10-15','14:25:00',2.31),('15087','2013-10-15','14:30:00',2.09),('15087','2013-10-15','14:35:00',1.42),('15087','2013-10-15','14:40:00',2.07),('15087','2013-10-15','14:45:00',2.06),('15087','2013-10-15','14:50:00',2.51),('15087','2013-10-15','14:55:00',1.95),('15087','2013-10-15','15:00:00',1.3),('15087','2013-10-15','15:05:00',1.34),('15087','2013-10-15','15:10:00',1.37),('15087','2013-10-15','15:15:00',1.25),('15087','2013-10-15','15:20:00',1.13),('15087','2013-10-15','15:25:00',1.02),('15087','2013-10-15','15:35:00',1.03),('15087','2013-10-15','15:40:00',1.08),('15087','2013-10-15','15:45:00',1.04),('15087','2013-10-15','16:30:00',1.15),('15087','2013-10-15','16:35:00',1.16),('15087','2013-10-14','08:45:00',1.06),('15087','2013-10-14','08:50:00',1.03),('15087','2013-10-14','08:55:00',1.22),('15087','2013-10-14','09:00:00',1.05),('15087','2013-10-14','09:05:00',1.16),('15087','2013-10-14','09:20:00',1.06),('15087','2013-10-14','09:25:00',1.67),('15087','2013-10-14','09:30:00',1.9),('15087','2013-10-14','09:35:00',1.74),('15087','2013-10-14','09:40:00',1.58),('15087','2013-10-14','09:45:00',1.31),('15087','2013-10-14','09:50:00',1.73),('15087','2013-10-14','09:55:00',2.04),('15087','2013-10-14','10:00:00',2.02),('15087','2013-10-14','10:05:00',2.21),('15087','2013-10-14','10:10:00',2.35),('15087','2013-10-14','10:15:00',2.49),('15087','2013-10-14','10:20:00',2.54),('15087','2013-10-14','10:25:00',2.58),('15087','2013-10-14','10:30:00',2.63),('15087','2013-10-14','10:35:00',2.66),('15087','2013-10-14','10:40:00',2.62),('15087','2013-10-14','10:45:00',2.71),('15087','2013-10-14','10:50:00',2.81),('15087','2013-10-14','10:55:00',2.87),('15087','2013-10-14','11:00:00',2.92),('15087','2013-10-14','11:05:00',2.94),('15087','2013-10-14','11:10:00',3.1),('15087','2013-10-14','11:15:00',3.05),('15087','2013-10-14','11:20:00',3.09),('15087','2013-10-14','11:25:00',3.16),('15087','2013-10-14','11:30:00',3.24),('15087','2013-10-14','11:35:00',3.17),('15087','2013-10-14','11:40:00',3.2),('15087','2013-10-14','11:45:00',3.16),('15087','2013-10-14','11:50:00',3.23),('15087','2013-10-14','11:55:00',3.25),('15087','2013-10-14','12:00:00',3.26),('15087','2013-10-14','12:05:00',3.28),('15087','2013-10-14','12:10:00',3.34),('15087','2013-10-14','12:15:00',3.26),('15087','2013-10-14','12:20:00',3.01),('15087','2013-10-14','12:25:00',3.27),('15087','2013-10-14','12:30:00',3.4),('15087','2013-10-14','12:35:00',3.36),('15087','2013-10-14','12:40:00',3.38),('15087','2013-10-14','12:45:00',3.4),('15087','2013-10-14','12:50:00',3.34),('15087','2013-10-14','12:55:00',3.37),('15087','2013-10-14','13:00:00',3.34),('15087','2013-10-14','13:05:00',3.34),('15087','2013-10-14','13:10:00',3.32),('15087','2013-10-14','13:15:00',3.3),('15087','2013-10-14','13:20:00',3.32),('15087','2013-10-14','13:25:00',3.29),('15087','2013-10-14','13:30:00',3.14),('15087','2013-10-14','13:35:00',3.17),('15087','2013-10-14','13:40:00',3.18),('15087','2013-10-14','13:45:00',3),('15087','2013-10-14','13:50:00',3.07),('15087','2013-10-14','13:55:00',3.03),('15087','2013-10-14','14:00:00',2.83),('15087','2013-10-14','14:05:00',2.92),('15087','2013-10-14','14:10:00',2.95),('15087','2013-10-14','14:15:00',2.75),('15087','2013-10-14','14:20:00',2.77),('15087','2013-10-14','14:25:00',2.75),('15087','2013-10-14','14:30:00',2.63),('15087','2013-10-14','14:35:00',2.61),('15087','2013-10-14','14:40:00',2.58),('15087','2013-10-14','14:45:00',2.55),('15087','2013-10-14','14:50:00',2.52),('15087','2013-10-14','14:55:00',2.33),('15087','2013-10-14','15:00:00',2.21),('15087','2013-10-14','15:05:00',2.25),('15087','2013-10-14','15:10:00',2.11),('15087','2013-10-14','15:15:00',2.07),('15087','2013-10-14','15:20:00',2.12),('15087','2013-10-14','15:25:00',1.99),('15087','2013-10-14','15:30:00',2),('15087','2013-10-14','15:35:00',1.88),('15087','2013-10-14','15:40:00',1.61),('15087','2013-10-14','15:45:00',1.34),('15087','2013-10-14','15:50:00',1.38),('15087','2013-10-14','16:00:00',1.3),('15087','2013-10-14','16:05:00',1.03),('15087','2013-10-13','09:00:00',1.06),('15087','2013-10-13','09:05:00',1.09),('15087','2013-10-13','09:10:00',1.12),('15087','2013-10-13','09:15:00',1.76),('15087','2013-10-13','09:20:00',1.89),('15087','2013-10-13','09:25:00',1.63),('15087','2013-10-13','09:30:00',1.14),('15087','2013-10-13','09:35:00',1.52),('15087','2013-10-13','09:40:00',2.2),('15087','2013-10-13','09:45:00',2.82),('15087','2013-10-13','09:50:00',2.77),('15087','2013-10-13','09:55:00',2.84),('15087','2013-10-13','10:00:00',1.96),('15087','2013-10-13','10:05:00',1.51),('15087','2013-10-13','10:10:00',2.27),('15087','2013-10-13','10:15:00',2.36),('15087','2013-10-13','10:20:00',1.9),('15087','2013-10-13','10:25:00',2.16),('15087','2013-10-13','10:30:00',2.88),('15087','2013-10-13','10:35:00',3.3),('15087','2013-10-13','10:40:00',3.39),('15087','2013-10-13','10:45:00',3.48),('15087','2013-10-13','10:50:00',2.93),('15087','2013-10-13','10:55:00',2.43),('15087','2013-10-13','11:00:00',3.02),('15087','2013-10-13','11:05:00',3.03),('15087','2013-10-13','11:10:00',2.96),('15087','2013-10-13','11:15:00',3.35),('15087','2013-10-13','11:20:00',3.24),('15087','2013-10-13','11:25:00',3.18),('15087','2013-10-13','11:30:00',3.26),('15087','2013-10-13','11:35:00',3.24),('15087','2013-10-13','11:40:00',3.27),('15087','2013-10-13','11:45:00',3.26),('15087','2013-10-13','11:50:00',3.32),('15087','2013-10-13','11:55:00',3.32),('15087','2013-10-13','12:00:00',3.34),('15087','2013-10-13','12:05:00',3.34),('15087','2013-10-13','12:10:00',3.34),('15087','2013-10-13','12:15:00',3.39),('15087','2013-10-13','12:20:00',3.31),('15087','2013-10-13','12:25:00',3.3),('15087','2013-10-13','12:30:00',3.42),('15087','2013-10-13','12:35:00',3.45),('15087','2013-10-13','12:40:00',3.46),('15087','2013-10-13','12:45:00',3.41),('15087','2013-10-13','12:50:00',3.37),('15087','2013-10-13','12:55:00',3.34),('15087','2013-10-13','13:00:00',3.36),('15087','2013-10-13','13:05:00',3.36),('15087','2013-10-13','13:10:00',3.4),('15087','2013-10-13','13:15:00',3.44),('15087','2013-10-13','13:20:00',3.47),('15087','2013-10-13','13:25:00',3.02),('15087','2013-10-13','13:30:00',2.48),('15087','2013-10-13','13:35:00',2.72),('15087','2013-10-13','13:40:00',1.85),('15087','2013-10-13','13:45:00',2.18),('15087','2013-10-13','13:50:00',2.38),('15087','2013-10-13','13:55:00',2.39),('15087','2013-10-13','14:00:00',3.1),('15087','2013-10-13','14:05:00',3.09),('15087','2013-10-13','14:10:00',3.1),('15087','2013-10-13','14:15:00',2.8),('15087','2013-10-13','14:20:00',2.97),('15087','2013-10-13','14:25:00',2.94),('15087','2013-10-13','14:30:00',2.43),('15087','2013-10-13','14:35:00',2.3),('15087','2013-10-13','14:40:00',2.62),('15087','2013-10-13','14:45:00',2.05),('15087','2013-10-13','14:50:00',1.7),('15087','2013-10-13','14:55:00',2.09),('15087','2013-10-13','15:00:00',2.61),('15087','2013-10-13','15:05:00',2.22),('15087','2013-10-13','15:10:00',1.55),('15087','2013-10-13','15:15:00',1.88),('15087','2013-10-13','15:20:00',2.15),('15087','2013-10-13','15:25:00',2.15),('15087','2013-10-13','15:30:00',1.64),('15087','2013-10-13','15:35:00',1.48),('15087','2013-10-13','15:40:00',1.46),('15087','2013-10-13','15:45:00',1.4),('15087','2013-10-13','15:50:00',1.32),('15087','2013-10-13','15:55:00',1.26),('15087','2013-10-13','16:00:00',1.4),('15087','2013-10-13','16:05:00',1.66),('15087','2013-10-13','16:10:00',1.41),('15087','2013-10-13','16:15:00',1.24),('15087','2013-10-13','16:20:00',1.3),('15087','2013-10-13','16:25:00',1.62),('15087','2013-10-13','16:30:00',1.55),('15087','2013-10-13','16:35:00',1.3),('15087','2013-10-13','16:40:00',1.04),('15087','2013-10-12','11:20:00',1.11),('15087','2013-10-12','11:25:00',1.08),('15087','2013-10-12','11:30:00',1.47),('15087','2013-10-12','11:35:00',2.06),('15087','2013-10-12','11:40:00',3.15),('15087','2013-10-12','11:45:00',1.49),('15087','2013-10-12','11:50:00',1.4),('15087','2013-10-12','11:55:00',1.24),('15087','2013-10-12','12:15:00',1.14),('15087','2013-10-12','12:20:00',2.23),('15087','2013-10-12','12:25:00',3.75),('15087','2013-10-12','12:30:00',2.78),('15087','2013-10-12','12:35:00',3.38),('15087','2013-10-12','12:40:00',3.44),('15087','2013-10-12','12:45:00',3),('15087','2013-10-12','12:50:00',3.04),('15087','2013-10-12','12:55:00',2.63),('15087','2013-10-12','13:00:00',1.94),('15087','2013-10-12','13:05:00',1.05),('15087','2013-10-12','13:15:00',1.33),('15087','2013-10-12','13:20:00',1.41),('15087','2013-10-12','13:25:00',1.69),('15087','2013-10-12','13:30:00',4),('15087','2013-10-12','13:35:00',1.57),('15087','2013-10-12','16:00:00',1.14),('15087','2013-10-12','16:05:00',1.08),('15087','2013-10-12','16:10:00',1.14),('15087','2013-10-12','16:15:00',1.77),('15087','2013-10-12','16:20:00',1.97),('15087','2013-10-12','16:25:00',1.09),('15087','2013-10-11','09:15:00',1.14),('15087','2013-10-11','09:20:00',1.27),('15087','2013-10-11','09:25:00',1.09),('15087','2013-10-11','09:30:00',1.13),('15087','2013-10-11','09:35:00',1.15),('15087','2013-10-11','09:40:00',1.41),('15087','2013-10-11','09:45:00',2.27),('15087','2013-10-11','09:50:00',2.34),('15087','2013-10-11','09:55:00',2.41),('15087','2013-10-11','10:00:00',2.47),('15087','2013-10-11','10:05:00',2.57),('15087','2013-10-11','10:10:00',2.64),('15087','2013-10-11','10:15:00',2.44),('15087','2013-10-11','10:20:00',2.51),('15087','2013-10-11','10:25:00',2.78),('15087','2013-10-11','10:30:00',2.98),('15087','2013-10-11','10:35:00',3.11),('15087','2013-10-11','10:40:00',1.6),('15087','2013-10-11','11:05:00',2.73),('15087','2013-10-11','11:10:00',2.26),('15087','2013-10-11','11:15:00',1.03),('15087','2013-10-11','11:20:00',1.09),('15087','2013-10-11','11:25:00',1.07),('15087','2013-10-11','11:35:00',1.3),('15087','2013-10-11','11:40:00',2.09),('15087','2013-10-11','11:45:00',1.88),('15087','2013-10-11','11:50:00',2.16),('15087','2013-10-11','11:55:00',1.96),('15087','2013-10-11','12:00:00',2.59),('15087','2013-10-11','12:05:00',3.2),('15087','2013-10-11','12:10:00',1.55),('15087','2013-10-11','12:15:00',1.16),('15087','2013-10-11','12:25:00',1.63),('15087','2013-10-11','12:30:00',1.35),('15087','2013-10-11','13:05:00',2.23),('15087','2013-10-11','13:10:00',2.02),('15087','2013-10-11','13:15:00',1.66),('15087','2013-10-11','13:20:00',2.13),('15087','2013-10-11','13:25:00',4.19),('15087','2013-10-11','13:30:00',1.63),('15087','2013-10-11','13:40:00',2.01),('15087','2013-10-11','13:45:00',3.02),('15087','2013-10-11','13:50:00',1.18),('15087','2013-10-11','15:35:00',1.17),('15087','2013-10-11','15:40:00',1.64),('15087','2013-10-11','15:45:00',1.12),('15087','2013-10-11','16:00:00',2.02),('15087','2013-10-11','17:00:00',1.02),('15087','2013-10-10','08:50:00',1.15),('15087','2013-10-10','08:55:00',1.51),('15087','2013-10-10','09:05:00',1.04),('15087','2013-10-10','09:10:00',1.67),('15087','2013-10-10','09:15:00',1.79),('15087','2013-10-10','09:20:00',1.84),('15087','2013-10-10','09:25:00',1.84),('15087','2013-10-10','09:30:00',1.83),('15087','2013-10-10','09:40:00',1.72),('15087','2013-10-10','09:45:00',1.94),('15087','2013-10-10','09:50:00',2.25),('15087','2013-10-10','09:55:00',2.06),('15087','2013-10-10','10:10:00',1.91),('15087','2013-10-10','10:15:00',2.69),('15087','2013-10-10','10:20:00',2.72),('15087','2013-10-10','10:25:00',1.75),('15087','2013-10-10','10:30:00',1.54),('15087','2013-10-10','10:35:00',1.23),('15087','2013-10-10','10:40:00',2.58),('15087','2013-10-10','10:45:00',3.04),('15087','2013-10-10','10:50:00',2.39),('15087','2013-10-10','10:55:00',2.05),('15087','2013-10-10','11:20:00',2.58),('15087','2013-10-10','11:25:00',3.75),('15087','2013-10-10','11:35:00',2.46),('15087','2013-10-10','11:40:00',2.2),('15087','2013-10-10','11:50:00',3.03),('15087','2013-10-10','11:55:00',3.65),('15087','2013-10-10','12:00:00',3.85),('15087','2013-10-10','12:05:00',3.94),('15087','2013-10-10','12:10:00',1.12),('15087','2013-10-10','12:20:00',2.84),('15087','2013-10-10','12:25:00',3.62),('15087','2013-10-10','12:35:00',3.96),('15087','2013-10-10','12:40:00',4.13),('15087','2013-10-10','12:45:00',3.1),('15087','2013-10-10','12:50:00',1.73),('15087','2013-10-10','12:55:00',3.96),('15087','2013-10-10','13:00:00',4.14),('15087','2013-10-10','13:05:00',4.21),('15087','2013-10-10','13:10:00',3.84),('15087','2013-10-10','13:15:00',2.46),('15087','2013-10-10','13:20:00',1.21),('15087','2013-10-10','13:25:00',4.07),('15087','2013-10-10','13:30:00',4.07),('15087','2013-10-10','13:35:00',3.8),('15087','2013-10-10','13:40:00',2.71),('15087','2013-10-10','13:45:00',2.86),('15087','2013-10-10','13:50:00',3.96),('15087','2013-10-10','13:55:00',3.64),('15087','2013-10-10','14:00:00',3.6),('15087','2013-10-10','14:05:00',3.34),('15087','2013-10-10','14:10:00',3.36),('15087','2013-10-10','14:15:00',2.08),('15087','2013-10-10','14:20:00',3.24),('15087','2013-10-10','14:25:00',3.54),('15087','2013-10-10','14:30:00',3.57),('15087','2013-10-10','14:35:00',3.55),('15087','2013-10-10','14:40:00',3.19),('15087','2013-10-10','14:45:00',3.04),('15087','2013-10-10','14:50:00',2.89),('15087','2013-10-10','14:55:00',2.77),('15087','2013-10-10','15:00:00',2.6),('15087','2013-10-10','15:05:00',2.63),('15087','2013-10-10','15:10:00',2.88),('15087','2013-10-10','15:15:00',1.94),('15087','2013-10-10','15:20:00',2.31),('15087','2013-10-10','15:25:00',1.74),('15087','2013-10-10','15:30:00',1.97),('15087','2013-10-10','15:40:00',2.45),('15087','2013-10-10','15:45:00',1.45),('15087','2013-10-10','15:50:00',1.54),('15087','2013-10-10','15:55:00',2.2),('15087','2013-10-10','16:00:00',1.61),('15087','2013-10-10','16:15:00',1.22),('15087','2013-10-10','16:25:00',1.6),('15087','2013-10-10','16:55:00',1.01),('15087','2013-10-09','08:40:00',1.12),('15087','2013-10-09','08:45:00',1.2),('15087','2013-10-09','08:50:00',1.27),('15087','2013-10-09','08:55:00',1.36),('15087','2013-10-09','09:00:00',1.43),('15087','2013-10-09','09:05:00',1.55),('15087','2013-10-09','09:10:00',1.72),('15087','2013-10-09','09:15:00',1.58),('15087','2013-10-09','09:20:00',1.68),('15087','2013-10-09','09:25:00',1.99),('15087','2013-10-09','09:30:00',2.08),('15087','2013-10-09','09:35:00',2.16),('15087','2013-10-09','09:40:00',2.27),('15087','2013-10-09','09:45:00',2.36),('15087','2013-10-09','09:50:00',2.44),('15087','2013-10-09','09:55:00',2.57),('15087','2013-10-09','10:00:00',2.73),('15087','2013-10-09','10:05:00',2.85),('15087','2013-10-09','10:10:00',2.17),('15087','2013-10-09','10:15:00',1.44),('15087','2013-10-09','10:25:00',1.02),('15087','2013-10-09','10:30:00',1.21),('15087','2013-10-09','10:35:00',1.27),('15087','2013-10-09','10:40:00',1.35),('15087','2013-10-09','10:45:00',2.39),('15087','2013-10-09','10:50:00',4.09),('15087','2013-10-09','10:55:00',3.1),('15087','2013-10-09','11:00:00',3.33),('15087','2013-10-09','11:05:00',4.19),('15087','2013-10-09','11:10:00',4.24),('15087','2013-10-09','11:15:00',3.91),('15087','2013-10-09','11:20:00',2.94),('15087','2013-10-09','11:25:00',3.68),('15087','2013-10-09','11:30:00',4.24),('15087','2013-10-09','11:35:00',4.44),('15087','2013-10-09','11:40:00',4.26),('15087','2013-10-09','11:45:00',3.87),('15087','2013-10-09','11:50:00',3.52),('15087','2013-10-09','11:55:00',3.3),('15087','2013-10-09','12:00:00',1.36),('15087','2013-10-09','12:05:00',2.43),('15087','2013-10-09','12:10:00',2.38),('15087','2013-10-09','12:15:00',5.18),('15087','2013-10-09','12:20:00',4.09),('15087','2013-10-09','12:25:00',2.65),('15087','2013-10-09','12:30:00',2.09),('15087','2013-10-09','12:35:00',2.68),('15087','2013-10-09','12:40:00',1.4),('15087','2013-10-09','12:55:00',1.15),('15087','2013-10-09','13:10:00',1.26),('15087','2013-10-09','13:15:00',1.4),('15087','2013-10-09','13:20:00',2.2),('15087','2013-10-09','13:25:00',3.38),('15087','2013-10-09','13:30:00',3.55),('15087','2013-10-09','13:35:00',3.57),('15087','2013-10-09','13:40:00',2.57),('15087','2013-10-09','13:45:00',2.18),('15087','2013-10-09','13:50:00',1.78),('15087','2013-10-09','13:55:00',4.03),('15087','2013-10-09','14:00:00',2.39),('15087','2013-10-09','14:05:00',2.49),('15087','2013-10-09','14:50:00',1.09),('15087','2013-10-09','14:55:00',2.57),('15087','2013-10-09','15:00:00',1.41),('15087','2013-10-09','15:05:00',3.15),('15087','2013-10-09','15:10:00',2.83),('15087','2013-10-09','15:15:00',2.86),('15087','2013-10-09','15:20:00',2.6),('15087','2013-10-09','15:25:00',2.59),('15087','2013-10-09','15:30:00',2.16),('15087','2013-10-09','15:35:00',2.15),('15087','2013-10-09','15:40:00',1.82),('15087','2013-10-09','15:45:00',1.26),('15087','2013-10-09','16:15:00',1.13),('15087','2013-10-09','16:20:00',1.56),('15087','2013-10-09','16:25:00',1.72),('15087','2013-10-09','16:30:00',1.97),('15087','2013-10-09','16:35:00',1.42),('15087','2013-10-09','16:40:00',1.29),('15087','2013-10-09','17:35:00',1.05),('15087','2014-04-15','09:00:00',1.79),('15087','2014-04-15','09:05:00',1.81),('15087','2014-04-15','09:10:00',2.11),('15087','2014-04-15','09:15:00',2.34),('15087','2014-04-15','09:20:00',2.78),('15087','2014-04-15','09:25:00',3.22),('15087','2014-04-15','09:30:00',1.96),('15087','2014-04-15','09:45:00',1.24),('15087','2014-04-15','09:50:00',2.52),('15087','2014-04-15','10:05:00',2.05),('15087','2014-04-15','10:10:00',2.61),('15087','2014-04-15','10:15:00',2.12),('15087','2014-04-15','10:20:00',1.97),('15087','2014-04-15','10:25:00',2.68),('15087','2014-04-15','10:30:00',3.89),('15087','2014-04-15','10:35:00',1.99),('15087','2014-04-15','10:40:00',2.88),('15087','2014-04-15','10:45:00',2.38),('15087','2014-04-15','10:50:00',2.72),('15087','2014-04-15','10:55:00',1.97),('15087','2014-04-15','11:00:00',2.59),('15087','2014-04-15','11:05:00',2.12),('15087','2014-04-15','11:10:00',1.91),('15087','2014-04-15','11:15:00',1.57),('15087','2014-04-15','11:20:00',1.15),('15087','2014-04-15','11:25:00',1.53),('15087','2014-04-15','11:30:00',1.25),('15087','2014-04-15','11:45:00',1.22),('15087','2014-04-15','11:50:00',1.47),('15087','2014-04-15','11:55:00',1.04),('15087','2014-04-15','12:10:00',1.01),('15087','2014-04-15','12:15:00',1.79),('15087','2014-04-15','12:20:00',1.86),('15087','2014-04-15','13:05:00',1.11),('15087','2014-04-15','13:10:00',1.49),('15087','2014-04-15','13:15:00',2.68),('15087','2014-04-15','13:20:00',2.85),('15087','2014-04-15','13:25:00',2.29),('15087','2014-04-15','13:30:00',2.81),('15087','2014-04-15','13:35:00',3.05),('15087','2014-04-15','13:40:00',1.78),('15087','2014-04-15','14:00:00',3.55),('15087','2014-04-15','14:05:00',1.59),('15087','2014-04-15','14:10:00',2.95),('15087','2014-04-15','14:15:00',3.44),('15087','2014-04-15','14:20:00',3.41),('15087','2014-04-15','14:25:00',3.35),('15087','2014-04-15','14:30:00',1.96),('15087','2014-04-15','14:35:00',1.62),('15087','2014-04-15','14:40:00',2.93),('15087','2014-04-15','14:45:00',2.71),('15087','2014-04-15','14:50:00',2.76),('15087','2014-04-15','14:55:00',1.7),('15087','2014-04-15','15:05:00',1.05),('15087','2014-04-15','15:10:00',1.17),('15087','2014-04-15','15:15:00',1.88),('15087','2014-04-15','15:20:00',2.12),('15087','2014-04-15','15:25:00',2.18),('15087','2014-04-15','15:30:00',1.72),('15087','2014-04-15','15:35:00',1.54),('15087','2014-04-15','15:40:00',1.57),('15087','2014-04-15','15:45:00',1.45),('15087','2014-04-15','15:50:00',1.45),('15087','2014-04-15','15:55:00',1.49),('15087','2014-04-15','16:00:00',1.68),('15087','2014-04-15','16:05:00',1.67),('15087','2013-10-08','08:15:00',1.11),('15087','2013-10-08','08:20:00',1.05),('15087','2013-10-08','10:05:00',1),('15087','2013-10-08','10:55:00',1.07),('15087','2013-10-08','11:00:00',1.8),('15087','2013-10-08','11:05:00',1.22),('15087','2013-10-08','11:10:00',1.64),('15087','2013-10-08','11:15:00',2.96),('15087','2013-10-08','11:20:00',4.2),('15087','2013-10-08','11:25:00',2.12),('15087','2013-10-08','11:30:00',2.43),('15087','2013-10-08','11:35:00',2.32),('15087','2013-10-08','11:40:00',1.59),('15087','2013-10-08','11:45:00',1.42),('15087','2013-10-08','12:20:00',1.13),('15087','2013-10-08','12:25:00',1.6),('15087','2013-10-08','12:30:00',2.27),('15087','2013-10-08','12:35:00',2.37),('15087','2013-10-08','12:40:00',4.53),('15087','2013-10-08','12:45:00',4.2),('15087','2013-10-08','12:50:00',3.5),('15087','2013-10-08','12:55:00',4.32),('15087','2013-10-08','13:00:00',4.06),('15087','2013-10-08','13:05:00',2.78),('15087','2013-10-08','13:10:00',1.65),('15087','2013-10-08','13:15:00',3.18),('15087','2013-10-08','13:20:00',1.54),('15087','2013-10-08','13:25:00',2.98),('15087','2013-10-08','13:30:00',2.33),('15087','2013-10-08','13:35:00',1.59),('15087','2013-10-08','13:40:00',1.13),('15087','2013-10-08','14:05:00',1.37),('15087','2013-10-08','14:10:00',1.9),('15087','2013-10-08','14:15:00',2.35),('15087','2013-10-08','14:20:00',2.59),('15087','2013-10-08','14:25:00',2.83),('15087','2013-10-08','14:30:00',2.39),('15087','2013-10-08','14:35:00',1.31),('15087','2013-10-08','14:40:00',1.56),('15087','2013-10-08','14:45:00',2.87),('15087','2013-10-08','14:50:00',3.13),('15087','2013-10-08','14:55:00',2.95),('15087','2013-10-08','15:00:00',2.82),('15087','2013-10-08','15:05:00',2.78),('15087','2013-10-08','15:10:00',2.67),('15087','2013-10-08','15:15:00',2.54),('15087','2013-10-08','15:20:00',2.5),('15087','2013-10-08','15:25:00',3.21),('15087','2013-10-08','15:30:00',3.1),('15087','2013-10-08','15:35:00',2.74),('15087','2013-10-08','15:40:00',1.47),('15087','2013-10-08','15:45:00',1.17),('15087','2013-10-08','15:50:00',2.07),('15087','2013-10-08','15:55:00',1.3),('15087','2013-10-08','16:00:00',1.1),('15087','2013-10-07','08:40:00',1.12),('15087','2013-10-07','09:00:00',1.72),('15087','2013-10-07','09:05:00',1.78),('15087','2013-10-07','09:10:00',1.76),('15087','2013-10-07','09:15:00',1.84),('15087','2013-10-07','09:20:00',1.88),('15087','2013-10-07','09:25:00',1.99),('15087','2013-10-07','09:30:00',2.06),('15087','2013-10-07','09:35:00',2.15),('15087','2013-10-07','09:40:00',2.21),('15087','2013-10-07','09:45:00',2.3),('15087','2013-10-07','09:50:00',2.38),('15087','2013-10-07','09:55:00',2.45),('15087','2013-10-07','10:00:00',2.51),('15087','2013-10-07','10:05:00',2.58),('15087','2013-10-07','10:10:00',2.64),('15087','2013-10-07','10:15:00',2.69),('15087','2013-10-07','10:20:00',2.76),('15087','2013-10-07','10:25:00',2.61),('15087','2013-10-07','10:30:00',2.94),('15087','2013-10-07','10:35:00',3.18),('15087','2013-10-07','10:40:00',3.06),('15087','2013-10-07','10:45:00',3.11),('15087','2013-10-07','10:50:00',3.18),('15087','2013-10-07','10:55:00',2.82),('15087','2013-10-07','11:00:00',2.76),('15087','2013-10-07','11:05:00',3.43),('15087','2013-10-07','11:10:00',3.14),('15087','2013-10-07','11:15:00',3.19),('15087','2013-10-07','11:20:00',3.43),('15087','2013-10-07','11:25:00',3.42),('15087','2013-10-07','11:30:00',3.44),('15087','2013-10-07','11:35:00',3.48),('15087','2013-10-07','11:40:00',3.52),('15087','2013-10-07','11:45:00',3.55),('15087','2013-10-07','11:50:00',3.59),('15087','2013-10-07','11:55:00',3.6),('15087','2013-10-07','12:00:00',3.62),('15087','2013-10-07','12:05:00',3.74),('15087','2013-10-07','12:10:00',3.92),('15087','2013-10-07','12:15:00',1.61),('15087','2013-10-07','12:20:00',2.12),('15087','2013-10-07','12:25:00',3.42),('15087','2013-10-07','12:30:00',4.25),('15087','2013-10-07','12:35:00',4),('15087','2013-10-07','12:40:00',2.46),('15087','2013-10-07','12:45:00',4.07),('15087','2013-10-07','12:50:00',2.6),('15087','2013-10-07','12:55:00',4.16),('15087','2013-10-07','13:00:00',4.07),('15087','2013-10-07','13:05:00',3.69),('15087','2013-10-07','13:10:00',3.64),('15087','2013-10-07','13:15:00',4.09),('15087','2013-10-07','13:20:00',3.84),('15087','2013-10-07','13:25:00',2.98),('15087','2013-10-07','13:30:00',1.85),('15087','2013-10-07','13:35:00',2.42),('15087','2013-10-07','13:40:00',1.8),('15087','2013-10-07','13:45:00',1.32),('15087','2013-10-07','13:50:00',2.92),('15087','2013-10-07','13:55:00',4.36),('15087','2013-10-07','14:00:00',2.96),('15087','2013-10-07','14:05:00',2.3),('15087','2013-10-07','14:10:00',1.29),('15087','2013-10-07','14:15:00',1.07),('15087','2013-10-07','14:20:00',1.24),('15087','2013-10-07','14:30:00',2.79),('15087','2013-10-07','14:35:00',3.73),('15087','2013-10-07','14:40:00',2.02),('15087','2013-10-07','14:45:00',2.67),('15087','2013-10-07','14:50:00',3.22),('15087','2013-10-07','14:55:00',3.12),('15087','2013-10-07','15:00:00',2.74),('15087','2013-10-07','15:05:00',2.69),('15087','2013-10-07','15:10:00',1.88),('15087','2013-10-07','15:15:00',2.61),('15087','2013-10-07','15:20:00',1.39),('15087','2013-10-07','15:25:00',2.59),('15087','2013-10-07','15:30:00',1.39),('15087','2013-10-07','15:35:00',1.23),('15087','2013-10-07','15:40:00',2.13),('15087','2013-10-07','15:45:00',2.9),('15087','2013-10-07','15:50:00',2.36),('15087','2013-10-07','16:00:00',1.43),('15087','2013-10-07','16:05:00',1.77),('15087','2013-10-07','16:10:00',2.03),('15087','2013-10-07','16:15:00',1.97),('15087','2013-10-07','16:20:00',1.86),('15087','2013-10-07','16:25:00',1.74),('15087','2013-10-07','16:35:00',1.43),('15087','2013-10-07','16:40:00',1.45),('15087','2013-10-07','16:45:00',1.36),('15087','2013-10-07','16:50:00',1.24),('15087','2013-10-07','16:55:00',1.12),('15087','2013-10-07','17:00:00',1),('15087','2013-10-06','09:05:00',1.14),('15087','2013-10-06','09:30:00',1.34),('15087','2013-10-06','09:35:00',1.68),('15087','2013-10-06','09:40:00',1.44),('15087','2013-10-06','09:45:00',1.27),('15087','2013-10-06','09:50:00',2.27),('15087','2013-10-06','09:55:00',2.64),('15087','2013-10-06','10:00:00',3.06),('15087','2013-10-06','10:05:00',3.08),('15087','2013-10-06','10:10:00',2.99),('15087','2013-10-06','10:15:00',2.76),('15087','2013-10-06','10:20:00',2.83),('15087','2013-10-06','10:25:00',3.14),('15087','2013-10-06','10:30:00',3.1),('15087','2013-10-06','10:35:00',3.04),('15087','2013-10-06','10:40:00',2.59),('15087','2013-10-06','10:45:00',2.05),('15087','2013-10-06','10:50:00',2.37),('15087','2013-10-06','10:55:00',2.43),('15087','2013-10-06','11:00:00',2.64),('15087','2013-10-06','11:05:00',2.94),('15087','2013-10-06','11:10:00',3.05),('15087','2013-10-06','11:15:00',2.96),('15087','2013-10-06','11:20:00',3.09),('15087','2013-10-06','11:25:00',3.12),('15087','2013-10-06','11:30:00',3.04),('15087','2013-10-06','11:35:00',2.98),('15087','2013-10-06','11:40:00',2.16),('15087','2013-10-06','11:45:00',2.26),('15087','2013-10-06','11:50:00',2.08),('15087','2013-10-06','11:55:00',2.53),('15087','2013-10-06','12:00:00',2.79),('15087','2013-10-06','12:05:00',2.72),('15087','2013-10-06','12:10:00',3.44),('15087','2013-10-06','12:15:00',3.39),('15087','2013-10-06','12:20:00',3.18),('15087','2013-10-06','12:25:00',2.5),('15087','2013-10-06','12:30:00',2.66),('15087','2013-10-06','12:35:00',2.88),('15087','2013-10-06','12:40:00',2.76),('15087','2013-10-06','12:45:00',2.84),('15087','2013-10-06','12:50:00',3.03),('15087','2013-10-06','12:55:00',3.43),('15087','2013-10-06','13:00:00',3.5),('15087','2013-10-06','13:05:00',3.39),('15087','2013-10-06','13:10:00',3.28),('15087','2013-10-06','13:15:00',4.11),('15087','2013-10-06','13:20:00',1.97),('15087','2013-10-06','13:25:00',1.05),('15087','2013-10-06','13:45:00',1.74),('15087','2013-10-06','13:50:00',3.88),('15087','2013-10-06','13:55:00',3.52),('15087','2013-10-06','14:00:00',2.62),('15087','2013-10-06','14:05:00',1.99),('15087','2013-10-06','14:10:00',1.69),('15087','2013-10-06','14:15:00',1.46),('15087','2013-10-06','14:20:00',1.61),('15087','2013-10-06','14:25:00',1.64),('15087','2013-10-06','14:30:00',2.54),('15087','2013-10-06','14:35:00',2.35),('15087','2013-10-06','14:40:00',2.28),('15087','2013-10-06','14:45:00',1.74),('15087','2013-10-06','14:50:00',2.03),('15087','2013-10-06','14:55:00',2.69),('15087','2013-10-06','15:00:00',2.11),('15087','2013-10-06','15:05:00',1.46),('15087','2013-10-06','15:10:00',1.18),('15087','2013-10-06','15:15:00',1.16),('15087','2013-10-06','15:55:00',1.04),('15087','2013-10-06','16:00:00',1.1),('15087','2013-10-05','16:00:00',1.02),('15087','2013-10-05','16:05:00',1.26),('15087','2013-10-05','16:10:00',1.2),('15087','2013-10-05','16:15:00',1.1),('15087','2013-10-05','16:20:00',1.13),('15087','2013-10-05','16:25:00',1.08),('15087','2013-10-04','09:25:00',1.02),('15087','2013-10-04','09:30:00',1.1),('15087','2013-10-04','09:35:00',1.18),('15087','2013-10-04','09:40:00',1.21),('15087','2013-10-04','09:45:00',1.18),('15087','2013-10-04','09:50:00',1.47),('15087','2013-10-04','09:55:00',2.85),('15087','2013-10-04','10:00:00',2.27),('15087','2013-10-04','10:05:00',1.54),('15087','2013-10-04','10:10:00',1.6),('15087','2013-10-04','10:15:00',1.84),('15087','2013-10-04','10:20:00',1.68),('15087','2013-10-04','10:25:00',1.96),('15087','2013-10-04','10:30:00',2.66),('15087','2013-10-04','10:35:00',2.53),('15087','2013-10-04','10:40:00',2.68),('15087','2013-10-04','10:45:00',2.49),('15087','2013-10-04','10:50:00',2.08),('15087','2013-10-04','10:55:00',2.84),('15087','2013-10-04','11:00:00',2.21),('15087','2013-10-04','11:05:00',1.78),('15087','2013-10-04','11:10:00',2.03),('15087','2013-10-04','11:15:00',3.34),('15087','2013-10-04','11:20:00',3.13),('15087','2013-10-04','11:25:00',2.83),('15087','2013-10-04','11:30:00',3.91),('15087','2013-10-04','11:35:00',3.69),('15087','2013-10-04','11:40:00',3.8),('15087','2013-10-04','11:45:00',3.79),('15087','2013-10-04','11:50:00',3.73),('15087','2013-10-04','11:55:00',3.74),('15087','2013-10-04','12:00:00',3.76),('15087','2013-10-04','12:05:00',3.8),('15087','2013-10-04','12:10:00',3.83),('15087','2013-10-04','12:15:00',3.59),('15087','2013-10-04','12:20:00',3.79),('15087','2013-10-04','12:25:00',3.93),('15087','2013-10-04','12:30:00',4.05),('15087','2013-10-04','12:35:00',3.65),('15087','2013-10-04','12:40:00',3.79),('15087','2013-10-04','12:45:00',3.84),('15087','2013-10-04','12:50:00',3.73),('15087','2013-10-04','12:55:00',3.71),('15087','2013-10-04','13:00:00',3.72),('15087','2013-10-04','13:05:00',3.81),('15087','2013-10-04','13:10:00',3.83),('15087','2013-10-04','13:15:00',4),('15087','2013-10-04','13:20:00',3.88),('15087','2013-10-04','13:25:00',3.62),('15087','2013-10-04','13:30:00',3.9),('15087','2013-10-04','13:35:00',3.85),('15087','2013-10-04','13:40:00',3.63),('15087','2013-10-04','13:45:00',3.6),('15087','2013-10-04','13:50:00',3.57),('15087','2013-10-04','13:55:00',3.36),('15087','2013-10-04','14:00:00',3.2),('15087','2013-10-04','14:05:00',3.38),('15087','2013-10-04','14:10:00',2.97),('15087','2013-10-04','14:15:00',2.56),('15087','2013-10-04','14:20:00',3.14),('15087','2013-10-04','14:25:00',3.12),('15087','2013-10-04','14:30:00',2.66),('15087','2013-10-04','14:35:00',1.94),('15087','2013-10-04','14:40:00',1.6),('15087','2013-10-04','14:45:00',1.98),('15087','2013-10-04','14:50:00',2.53),('15087','2013-10-04','14:55:00',2.45),('15087','2013-10-04','15:00:00',2.11),('15087','2013-10-04','15:05:00',2.35),('15087','2013-10-04','15:10:00',1.94),('15087','2013-10-04','15:15:00',1.58),('15087','2013-10-04','15:20:00',1.39),('15087','2013-10-04','15:25:00',2.55),('15087','2013-10-04','15:30:00',2.08),('15087','2013-10-04','15:35:00',1.21),('15087','2013-10-04','16:00:00',1.05),('15087','2013-10-04','16:05:00',1.13),('15087','2013-10-04','16:10:00',1.03),('15087','2013-10-03','08:30:00',1.02),('15087','2013-10-03','08:35:00',1.12),('15087','2013-10-03','08:40:00',1.11),('15087','2013-10-03','08:45:00',1.31),('15087','2013-10-03','08:50:00',1.43),('15087','2013-10-03','08:55:00',1.54),('15087','2013-10-03','09:00:00',1.39),('15087','2013-10-03','09:05:00',1.77),('15087','2013-10-03','09:10:00',1.89),('15087','2013-10-03','09:15:00',1.97),('15087','2013-10-03','09:20:00',1.7),('15087','2013-10-03','09:25:00',2.17),('15087','2013-10-03','09:30:00',2.26),('15087','2013-10-03','09:35:00',2.35),('15087','2013-10-03','09:40:00',1.87),('15087','2013-10-03','09:45:00',2.48),('15087','2013-10-03','09:50:00',2.6),('15087','2013-10-03','09:55:00',2.68),('15087','2013-10-03','10:00:00',2.76),('15087','2013-10-03','10:05:00',2.84),('15087','2013-10-03','10:10:00',2.92),('15087','2013-10-03','10:15:00',2.99),('15087','2013-10-03','10:20:00',3.06),('15087','2013-10-03','10:25:00',3.13),('15087','2013-10-03','10:30:00',3.19),('15087','2013-10-03','10:35:00',3.26),('15087','2013-10-03','10:40:00',3.32),('15087','2013-10-03','10:45:00',3.38),('15087','2013-10-03','10:50:00',3.43),('15087','2013-10-03','10:55:00',3.48),('15087','2013-10-03','11:00:00',3.46),('15087','2013-10-03','11:05:00',3.57),('15087','2013-10-03','11:10:00',3.62),('15087','2013-10-03','11:15:00',3.64),('15087','2013-10-03','11:20:00',3.71),('15087','2013-10-03','11:25:00',3.75),('15087','2013-10-03','11:30:00',3.78),('15087','2013-10-03','11:35:00',3.82),('15087','2013-10-03','11:40:00',3.87),('15087','2013-10-03','11:45:00',3.9),('15087','2013-10-03','11:50:00',3.92),('15087','2013-10-03','11:55:00',3.94),('15087','2013-10-03','12:00:00',3.97),('15087','2013-10-03','12:05:00',4),('15087','2013-10-03','12:10:00',4.02),('15087','2013-10-03','12:15:00',4.01),('15087','2013-10-03','12:20:00',4),('15087','2013-10-03','12:25:00',4.03),('15087','2013-10-03','12:30:00',4.05),('15087','2013-10-03','12:35:00',4.06),('15087','2013-10-03','12:40:00',4.03),('15087','2013-10-03','12:45:00',4.03),('15087','2013-10-03','12:50:00',4.03),('15087','2013-10-03','12:55:00',4.05),('15087','2013-10-03','13:00:00',4.03),('15087','2013-10-03','13:05:00',3.96),('15087','2013-10-03','13:10:00',4.03),('15087','2013-10-03','13:15:00',4.01),('15087','2013-10-03','13:20:00',3.97),('15087','2013-10-03','13:25:00',3.97),('15087','2013-10-03','13:30:00',3.99),('15087','2013-10-03','13:35:00',3.91),('15087','2013-10-03','13:40:00',3.9),('15087','2013-10-03','13:45:00',3.86),('15087','2013-10-03','13:50:00',3.8),('15087','2013-10-03','13:55:00',3.7),('15087','2013-10-03','14:00:00',3.7),('15087','2013-10-03','14:05:00',3.72),('15087','2013-10-03','14:10:00',3.59),('15087','2013-10-03','14:15:00',3.46),('15087','2013-10-03','14:20:00',3.53),('15087','2013-10-03','14:25:00',3.38),('15087','2013-10-03','14:30:00',3.31),('15087','2013-10-03','14:35:00',3.32),('15087','2013-10-03','14:40:00',3.31),('15087','2013-10-03','14:45:00',3.05),('15087','2013-10-03','14:50:00',3.07),('15087','2013-10-03','14:55:00',3.04),('15087','2013-10-03','15:00:00',3),('15087','2013-10-03','15:05:00',2.92),('15087','2013-10-03','15:10:00',2.8),('15087','2013-10-03','15:15:00',2.83),('15087','2013-10-03','15:20:00',2.79),('15087','2013-10-03','15:25:00',2.75),('15087','2013-10-03','15:30:00',2.56),('15087','2013-10-03','15:35:00',2.61),('15087','2013-10-03','15:40:00',2.51),('15087','2013-10-03','15:45:00',2.41),('15087','2013-10-03','15:50:00',2.29),('15087','2013-10-03','15:55:00',2.25),('15087','2013-10-03','16:00:00',2.11),('15087','2013-10-03','16:05:00',2.04),('15087','2013-10-03','16:10:00',1.93),('15087','2013-10-03','16:15:00',1.77),('15087','2013-10-03','16:20:00',1.78),('15087','2013-10-03','16:25:00',1.77),('15087','2013-10-03','16:30:00',1.66),('15087','2013-10-03','16:35:00',1.54),('15087','2013-10-03','16:40:00',1.44),('15087','2013-10-03','16:45:00',1.35),('15087','2013-10-03','16:50:00',1.26),('15087','2013-10-03','16:55:00',1.19),('15087','2013-10-03','17:00:00',1.14),('15087','2013-10-03','17:05:00',1.07),('15087','2013-10-02','08:30:00',1.06),('15087','2013-10-02','08:35:00',1.06),('15087','2013-10-02','08:40:00',1.14),('15087','2013-10-02','08:45:00',1.24),('15087','2013-10-02','08:50:00',1.32),('15087','2013-10-02','08:55:00',1.43),('15087','2013-10-02','09:00:00',1.55),('15087','2013-10-02','09:05:00',1.69),('15087','2013-10-02','09:10:00',1.77),('15087','2013-10-02','09:15:00',1.88),('15087','2013-10-02','09:20:00',1.99),('15087','2013-10-02','09:25:00',2.08),('15087','2013-10-02','09:30:00',2.16),('15087','2013-10-02','09:35:00',2.25),('15087','2013-10-02','09:40:00',2.33),('15087','2013-10-02','09:45:00',2.38),('15087','2013-10-02','09:50:00',2.47),('15087','2013-10-02','09:55:00',2.55),('15087','2013-10-02','10:00:00',2.61),('15087','2013-10-02','10:05:00',2.68),('15087','2013-10-02','10:10:00',2.73),('15087','2013-10-02','10:15:00',2.8),('15087','2013-10-02','10:20:00',2.88),('15087','2013-10-02','10:25:00',2.95),('15087','2013-10-02','10:30:00',3.01),('15087','2013-10-02','10:35:00',3.09),('15087','2013-10-02','10:40:00',3.17),('15087','2013-10-02','10:45:00',3.25),('15087','2013-10-02','10:50:00',3.32),('15087','2013-10-02','10:55:00',3.37),('15087','2013-10-02','11:00:00',3.41),('15087','2013-10-02','11:05:00',3.46),('15087','2013-10-02','11:10:00',3.5),('15087','2013-10-02','11:15:00',3.55),('15087','2013-10-02','11:20:00',3.59),('15087','2013-10-02','11:25:00',3.62),('15087','2013-10-02','11:30:00',3.65),('15087','2013-10-02','11:35:00',3.68),('15087','2013-10-02','11:40:00',3.7),('15087','2013-10-02','11:45:00',3.74),('15087','2013-10-02','11:50:00',3.77),('15087','2013-10-02','11:55:00',3.8),('15087','2013-10-02','12:00:00',3.77),('15087','2013-10-02','12:05:00',3.83),('15087','2013-10-02','12:10:00',3.86),('15087','2013-10-02','12:15:00',3.88),('15087','2013-10-02','12:20:00',3.9),('15087','2013-10-02','12:25:00',3.89),('15087','2013-10-02','12:30:00',3.87),('15087','2013-10-02','12:35:00',3.9),('15087','2013-10-02','12:40:00',3.9),('15087','2013-10-02','12:45:00',3.91),('15087','2013-10-02','12:50:00',3.91),('15087','2013-10-02','12:55:00',3.91),('15087','2013-10-02','13:00:00',3.89),('15087','2013-10-02','13:05:00',3.92),('15087','2013-10-02','13:10:00',3.92),('15087','2013-10-02','13:15:00',3.92),('15087','2013-10-02','13:20:00',3.91),('15087','2013-10-02','13:25:00',3.89),('15087','2013-10-02','13:30:00',3.87),('15087','2013-10-02','13:35:00',3.8),('15087','2013-10-02','13:40:00',3.79),('15087','2013-10-02','13:45:00',3.77),('15087','2013-10-02','13:50:00',3.72),('15087','2013-10-02','13:55:00',3.62),('15087','2013-10-02','14:00:00',3.44),('15087','2013-10-02','14:05:00',3.59),('15087','2013-10-02','14:10:00',3.56),('15087','2013-10-02','14:15:00',3.31),('15087','2013-10-02','14:20:00',3.37),('15087','2013-10-02','14:25:00',3.37),('15087','2013-10-02','14:30:00',3.15),('15087','2013-10-02','14:35:00',3.17),('15087','2013-10-02','14:40:00',3.18),('15087','2013-10-02','14:45:00',3.14),('15087','2013-10-02','14:50:00',3.04),('15087','2013-10-02','14:55:00',2.95),('15087','2013-10-02','15:00:00',2.9),('15087','2013-10-02','15:05:00',2.88),('15087','2013-10-02','15:10:00',2.79),('15087','2013-10-02','15:15:00',2.77),('15087','2013-10-02','15:20:00',2.75),('15087','2013-10-02','15:25:00',2.69),('15087','2013-10-02','15:30:00',2.53),('15087','2013-10-02','15:35:00',2.53),('15087','2013-10-02','15:40:00',2.46),('15087','2013-10-02','15:45:00',2.36),('15087','2013-10-02','15:50:00',2.27),('15087','2013-10-02','15:55:00',2.24),('15087','2013-10-02','16:00:00',2.11),('15087','2013-10-02','16:05:00',2),('15087','2013-10-02','16:10:00',1.89),('15087','2013-10-02','16:15:00',1.81),('15087','2013-10-02','16:20:00',1.76),('15087','2013-10-02','16:25:00',1.72),('15087','2013-10-02','16:30:00',1.62),('15087','2013-10-02','16:35:00',1.56),('15087','2013-10-02','16:40:00',1.46),('15087','2013-10-02','16:45:00',1.35),('15087','2013-10-02','16:50:00',1.28),('15087','2013-10-02','16:55:00',1.19),('15087','2013-10-02','17:00:00',1.14),('15087','2013-10-02','17:05:00',1.07),('15087','2013-10-01','08:35:00',1.1),('15087','2013-10-01','08:40:00',1.19),('15087','2013-10-01','08:45:00',1.3),('15087','2013-10-01','08:50:00',1.41),('15087','2013-10-01','08:55:00',1.49),('15087','2013-10-01','09:00:00',1.59),('15087','2013-10-01','09:05:00',1.71),('15087','2013-10-01','09:10:00',1.78),('15087','2013-10-01','09:15:00',1.88),('15087','2013-10-01','09:20:00',1.93),('15087','2013-10-01','09:25:00',2.02),('15087','2013-10-01','09:30:00',2.11),('15087','2013-10-01','09:35:00',2.2),('15087','2013-10-01','09:40:00',2.29),('15087','2013-10-01','09:45:00',2.34),('15087','2013-10-01','09:50:00',2.42),('15087','2013-10-01','09:55:00',2.48),('15087','2013-10-01','10:00:00',2.56),('15087','2013-10-01','10:05:00',2.64),('15087','2013-10-01','10:10:00',2.67),('15087','2013-10-01','10:15:00',2.78),('15087','2013-10-01','10:20:00',2.88),('15087','2013-10-01','10:25:00',2.94),('15087','2013-10-01','10:30:00',3.01),('15087','2013-10-01','10:35:00',3.03),('15087','2013-10-01','10:40:00',3.09),('15087','2013-10-01','10:45:00',3.17),('15087','2013-10-01','10:50:00',3.26),('15087','2013-10-01','10:55:00',3.33),('15087','2013-10-01','11:00:00',3.38),('15087','2013-10-01','11:05:00',3.61),('15087','2013-10-01','11:10:00',3.83),('15087','2013-10-01','11:15:00',3.88),('15087','2013-10-01','11:20:00',1.69),('15087','2013-10-01','11:30:00',2.08),('15087','2013-10-01','11:35:00',3.89),('15087','2013-10-01','11:40:00',3.84),('15087','2013-10-01','11:45:00',3.85),('15087','2013-10-01','11:50:00',2.68),('15087','2013-10-01','11:55:00',1.59),('15087','2013-10-01','12:00:00',3.97),('15087','2013-10-01','12:05:00',3.98),('15087','2013-10-01','12:10:00',3.92),('15087','2013-10-01','12:15:00',4.01),('15087','2013-10-01','12:20:00',4.08),('15087','2013-10-01','12:25:00',3.12),('15087','2013-10-01','12:30:00',3.93),('15087','2013-10-01','12:40:00',1.02),('15087','2013-10-01','12:45:00',3.81),('15087','2013-10-01','12:50:00',1.24),('15087','2013-10-01','12:55:00',2.05),('15087','2013-10-01','13:00:00',4.21),('15087','2013-10-01','13:05:00',3.63),('15087','2013-10-01','13:10:00',1.09),('15087','2013-10-01','13:15:00',2.37),('15087','2013-10-01','13:20:00',4.26),('15087','2013-10-01','13:25:00',2.74),('15087','2013-10-01','13:30:00',1.63),('15087','2013-10-01','13:35:00',4.34),('15087','2013-10-01','13:40:00',3.85),('15087','2013-10-01','13:45:00',3.93),('15087','2013-10-01','13:50:00',3.94),('15087','2013-10-01','13:55:00',3.64),('15087','2013-10-01','14:00:00',3.37),('15087','2013-10-01','14:05:00',3.37),('15087','2013-10-01','14:10:00',3.43),('15087','2013-10-01','14:15:00',3.21),('15087','2013-10-01','14:20:00',3.2),('15087','2013-10-01','14:25:00',3.22),('15087','2013-10-01','14:30:00',3.16),('15087','2013-10-01','14:35:00',3),('15087','2013-10-01','14:40:00',2.47),('15087','2013-10-01','14:45:00',3.24),('15087','2013-10-01','14:50:00',3.14),('15087','2013-10-01','14:55:00',2.95),('15087','2013-10-01','15:00:00',2.7),('15087','2013-10-01','15:05:00',2.74),('15087','2013-10-01','15:10:00',2.84),('15087','2013-10-01','15:15:00',2.75),('15087','2013-10-01','15:20:00',2.74),('15087','2013-10-01','15:25:00',2.62),('15087','2013-10-01','15:30:00',2.55),('15087','2013-10-01','15:35:00',2.52),('15087','2013-10-01','15:40:00',2.51),('15087','2013-10-01','15:45:00',2.33),('15087','2013-10-01','15:50:00',2.27),('15087','2013-10-01','15:55:00',2.2),('15087','2013-10-01','16:00:00',2.01),('15087','2013-10-01','16:05:00',1.95),('15087','2013-10-01','16:10:00',1.9),('15087','2013-10-01','16:15:00',1.8),('15087','2013-10-01','16:20:00',1.72),('15087','2013-10-01','16:25:00',1.67),('15087','2013-10-01','16:30:00',1.59),('15087','2013-10-01','16:35:00',1.5),('15087','2013-10-01','16:40:00',1.42),('15087','2013-10-01','16:45:00',1.29),('15087','2013-10-01','16:50:00',1.25),('15087','2013-10-01','16:55:00',1.23),('15087','2013-10-01','17:00:00',1.09),('15087','2013-10-01','17:05:00',1.06),('15087','2013-09-30','09:45:00',1),('15087','2013-09-30','09:50:00',1.3),('15087','2013-09-30','09:55:00',1.07),('15087','2013-09-30','10:00:00',1.01),('15087','2013-09-30','10:10:00',1.09),('15087','2013-09-30','10:15:00',1.1),('15087','2013-09-30','10:20:00',1.12),('15087','2013-09-30','10:25:00',1.31),('15087','2013-09-30','10:30:00',1.54),('15087','2013-09-30','10:35:00',1.75),('15087','2013-09-30','10:40:00',2.31),('15087','2013-09-30','10:45:00',3.38),('15087','2013-09-30','10:50:00',3.47),('15087','2013-09-30','10:55:00',3.13),('15087','2013-09-30','11:00:00',2.39),('15087','2013-09-30','11:05:00',2.15),('15087','2013-09-30','11:10:00',3.5),('15087','2013-09-30','11:15:00',2.62),('15087','2013-09-30','11:20:00',3.29),('15087','2013-09-30','11:25:00',2.11),('15087','2013-09-30','11:30:00',2.29),('15087','2013-09-30','11:35:00',2.07),('15087','2013-09-30','11:40:00',4.28),('15087','2013-09-30','11:45:00',1.89),('15087','2013-09-30','11:50:00',1.49),('15087','2013-09-30','11:55:00',1.35),('15087','2013-09-30','12:00:00',1.49),('15087','2013-09-30','12:05:00',1.05),('15087','2013-09-30','12:10:00',2.28),('15087','2013-09-30','12:15:00',4.14),('15087','2013-09-30','12:20:00',4.19),('15087','2013-09-30','12:25:00',4.13),('15087','2013-09-30','12:30:00',4),('15087','2013-09-30','12:35:00',4.03),('15087','2013-09-30','12:40:00',3.85),('15087','2013-09-30','12:45:00',3.43),('15087','2013-09-30','12:50:00',4.19),('15087','2013-09-30','12:55:00',4.12),('15087','2013-09-30','13:00:00',3.97),('15087','2013-09-30','13:05:00',4.28),('15087','2013-09-30','13:10:00',4.1),('15087','2013-09-30','13:15:00',4.23),('15087','2013-09-30','13:20:00',4.52),('15087','2013-09-30','13:25:00',4.68),('15087','2013-09-30','13:30:00',4.4),('15087','2013-09-30','13:35:00',3.8),('15087','2013-09-30','13:40:00',3.31),('15087','2013-09-30','13:45:00',1.65),('15087','2013-09-30','13:50:00',3.74),('15087','2013-09-30','13:55:00',3.01),('15087','2013-09-30','14:00:00',1.97),('15087','2013-09-30','14:05:00',1.33),('15087','2013-09-30','14:10:00',1.32),('15087','2013-09-30','14:15:00',1.25),('15087','2013-09-30','14:20:00',1.06),('15087','2013-09-30','14:25:00',1.22),('15087','2013-09-30','14:30:00',2.84),('15087','2013-09-30','14:35:00',2.57),('15087','2013-09-30','14:40:00',3.83),('15087','2013-09-30','14:45:00',3.45),('15087','2013-09-30','14:50:00',2.64),('15087','2013-09-30','14:55:00',2.1),('15087','2013-09-30','15:00:00',1.99),('15087','2013-09-30','15:05:00',2.85),('15087','2013-09-30','15:10:00',3.6),('15087','2013-09-30','15:15:00',2.07),('15087','2013-09-30','15:20:00',1.68),('15087','2013-09-30','15:25:00',2.72),('15087','2013-09-30','15:30:00',1.6),('15087','2013-09-30','15:35:00',3.12),('15087','2013-09-30','15:40:00',3.12),('15087','2013-09-30','15:45:00',1.7),('15087','2013-09-30','16:10:00',1.25),('15087','2013-09-30','16:15:00',1.62),('15087','2013-09-30','16:20:00',1.47),('15087','2013-09-30','16:45:00',1.17),('15087','2013-09-29','08:50:00',1.25),('15087','2013-09-29','08:55:00',1.07),('15087','2013-09-29','09:00:00',1.04),('15087','2013-09-29','09:10:00',1.04),('15087','2013-09-29','09:15:00',1.25),('15087','2013-09-29','09:55:00',1.05),('15087','2013-09-29','10:00:00',1.25),('15087','2013-09-29','10:05:00',1.8),('15087','2013-09-29','10:10:00',2.1),('15087','2013-09-29','10:15:00',2.66),('15087','2013-09-29','10:20:00',2.14),('15087','2013-09-29','10:25:00',2.15),('15087','2013-09-29','10:30:00',2.45),('15087','2013-09-29','10:35:00',2.66),('15087','2013-09-29','10:40:00',2.67),('15087','2013-09-29','10:45:00',2.78),('15087','2013-09-29','10:50:00',2.91),('15087','2013-09-29','10:55:00',2.92),('15087','2013-09-29','11:00:00',2.97),('15087','2013-09-29','11:05:00',2.84),('15087','2013-09-29','11:10:00',2.88),('15087','2013-09-29','11:15:00',3.1),('15087','2013-09-29','11:20:00',3.08),('15087','2013-09-29','11:25:00',2.9),('15087','2013-09-29','11:30:00',3.12),('15087','2013-09-29','11:35:00',3.06),('15087','2013-09-29','11:40:00',3.06),('15087','2013-09-29','11:45:00',3.33),('15087','2013-09-29','11:50:00',3.42),('15087','2013-09-29','11:55:00',3.52),('15087','2013-09-29','12:00:00',3.1),('15087','2013-09-29','12:05:00',2.53),('15087','2013-09-29','12:10:00',3.67),('15087','2013-09-29','12:15:00',3.92),('15087','2013-09-29','12:20:00',2.14),('15087','2013-09-29','12:25:00',1.79),('15087','2013-09-29','12:30:00',1.96),('15087','2013-09-29','12:35:00',1.88),('15087','2013-09-29','12:40:00',1.6),('15087','2013-09-29','12:45:00',1.39),('15087','2013-09-29','12:50:00',1.37),('15087','2013-09-29','12:55:00',1.22),('15087','2013-09-29','13:00:00',1.18),('15087','2013-09-29','13:05:00',1.04),('15087','2013-09-29','13:10:00',1.05),('15087','2013-09-29','13:25:00',1.42),('15087','2013-09-29','13:30:00',1.81),('15087','2013-09-29','13:35:00',2.02),('15087','2013-09-29','13:40:00',1.8),('15087','2013-09-29','13:45:00',1.58),('15087','2013-09-29','13:50:00',1.73),('15087','2013-09-29','13:55:00',2.06),('15087','2013-09-29','14:00:00',1.94),('15087','2013-09-29','14:05:00',2.31),('15087','2013-09-29','14:10:00',1.32),('15087','2013-09-29','14:15:00',1.77),('15087','2013-09-29','14:20:00',2.62),('15087','2013-09-29','14:25:00',1.47),('15087','2013-09-29','14:30:00',1.51),('15087','2013-09-29','14:35:00',1.27),('15087','2013-09-29','14:55:00',1.02),('15087','2013-09-29','15:00:00',1.16),('15087','2013-09-29','16:00:00',1.16),('15087','2013-09-29','16:30:00',1.15),('15087','2013-09-29','16:35:00',1.04),('15087','2014-04-14','08:00:00',1.04),('15087','2014-04-14','08:05:00',1.13),('15087','2014-04-14','08:10:00',1.23),('15087','2014-04-14','08:15:00',1.34),('15087','2014-04-14','08:20:00',1.43),('15087','2014-04-14','08:25:00',1.52),('15087','2014-04-14','08:30:00',1.67),('15087','2014-04-14','08:35:00',1.8),('15087','2014-04-14','08:40:00',1.9),('15087','2014-04-14','08:45:00',1.99),('15087','2014-04-14','08:50:00',2.1),('15087','2014-04-14','08:55:00',2.2),('15087','2014-04-14','09:00:00',2.3),('15087','2014-04-14','09:05:00',2.4),('15087','2014-04-14','09:10:00',2.48),('15087','2014-04-14','09:15:00',2.57),('15087','2014-04-14','09:20:00',2.64),('15087','2014-04-14','09:25:00',2.72),('15087','2014-04-14','09:30:00',2.81),('15087','2014-04-14','09:35:00',2.89),('15087','2014-04-14','09:40:00',2.96),('15087','2014-04-14','09:45:00',3.05),('15087','2014-04-14','09:50:00',3.15),('15087','2014-04-14','09:55:00',3.2),('15087','2014-04-14','10:00:00',3.29),('15087','2014-04-14','10:05:00',3.37),('15087','2014-04-14','10:10:00',3.43),('15087','2014-04-14','10:15:00',3.51),('15087','2014-04-14','10:20:00',3.57),('15087','2014-04-14','10:25:00',3.63),('15087','2014-04-14','10:30:00',3.7),('15087','2014-04-14','10:35:00',3.76),('15087','2014-04-14','10:40:00',3.77),('15087','2014-04-14','10:45:00',3.88),('15087','2014-04-14','10:50:00',3.92),('15087','2014-04-14','10:55:00',3.96),('15087','2014-04-14','11:00:00',4),('15087','2014-04-14','11:05:00',4.07),('15087','2014-04-14','11:10:00',4.04),('15087','2014-04-14','11:15:00',4.15),('15087','2014-04-14','11:20:00',4.19),('15087','2014-04-14','11:25:00',4.25),('15087','2014-04-14','11:30:00',4.3),('15087','2014-04-14','11:35:00',4.35),('15087','2014-04-14','11:40:00',4.37),('15087','2014-04-14','11:45:00',4.4),('15087','2014-04-14','11:50:00',4.42),('15087','2014-04-14','11:55:00',4.46),('15087','2014-04-14','12:00:00',4.49),('15087','2014-04-14','12:05:00',4.53),('15087','2014-04-14','12:10:00',4.55),('15087','2014-04-14','12:15:00',4.56),('15087','2014-04-14','12:20:00',4.57),('15087','2014-04-14','12:25:00',4.6),('15087','2014-04-14','12:30:00',4.59),('15087','2014-04-14','12:35:00',4.62),('15087','2014-04-14','12:40:00',4.62),('15087','2014-04-14','12:45:00',4.63),('15087','2014-04-14','12:50:00',4.64),('15087','2014-04-14','12:55:00',4.65),('15087','2014-04-14','13:00:00',4.66),('15087','2014-04-14','13:05:00',4.63),('15087','2014-04-14','13:10:00',4.61),('15087','2014-04-14','13:15:00',4.69),('15087','2014-04-14','13:20:00',4.66),('15087','2014-04-14','13:25:00',4.65),('15087','2014-04-14','13:30:00',4.64),('15087','2014-04-14','13:35:00',4.68),('15087','2014-04-14','13:40:00',4.68),('15087','2014-04-14','13:45:00',4.64),('15087','2014-04-14','13:50:00',4.62),('15087','2014-04-14','13:55:00',4.38),('15087','2014-04-14','14:00:00',4.5),('15087','2014-04-14','14:05:00',4.55),('15087','2014-04-14','14:10:00',4.51),('15087','2014-04-14','14:15:00',4.45),('15087','2014-04-14','14:20:00',4.42),('15087','2014-04-14','14:25:00',4.39),('15087','2014-04-14','14:30:00',4.35),('15087','2014-04-14','14:35:00',4.17),('15087','2014-04-14','14:40:00',4),('15087','2014-04-14','14:45:00',4.13),('15087','2014-04-14','14:50:00',4.13),('15087','2014-04-14','14:55:00',4.06),('15087','2014-04-14','15:00:00',3.97),('15087','2014-04-14','15:05:00',3.94),('15087','2014-04-14','15:10:00',3.9),('15087','2014-04-14','15:15:00',3.69),('15087','2014-04-14','15:20:00',3.57),('15087','2014-04-14','15:25:00',3.35),('15087','2014-04-14','15:30:00',3.51),('15087','2014-04-14','15:35:00',3.49),('15087','2014-04-14','15:40:00',3.34),('15087','2014-04-14','15:45:00',3.39),('15087','2014-04-14','15:50:00',3.36),('15087','2014-04-14','15:55:00',3.3),('15087','2014-04-14','16:00:00',3.23),('15087','2014-04-14','16:05:00',3.16),('15087','2014-04-14','16:10:00',3.09),('15087','2014-04-14','16:15:00',3.02),('15087','2014-04-14','16:20:00',2.96),('15087','2014-04-14','16:25:00',2.89),('15087','2014-04-14','16:30:00',2.8),('15087','2014-04-14','16:35:00',2.73),('15087','2014-04-14','16:40:00',2.65),('15087','2014-04-14','16:45:00',2.58),('15087','2014-04-14','16:50:00',2.49),('15087','2014-04-14','16:55:00',2.4),('15087','2014-04-14','17:00:00',2.32),('15087','2014-04-14','17:05:00',2.24),('15087','2014-04-14','17:10:00',2.14),('15087','2014-04-14','17:15:00',2),('15087','2014-04-14','17:20:00',1.87),('15087','2014-04-14','17:25:00',1.68),('15087','2014-04-14','17:30:00',1.58),('15087','2014-04-14','17:35:00',1.43),('15087','2014-04-14','17:40:00',1.32),('15087','2014-04-14','17:45:00',1.29),('15087','2014-04-14','17:50:00',1.18),('15087','2014-04-14','17:55:00',1.16),('15087','2014-04-14','18:00:00',1.05),('15087','2014-04-14','18:05:00',1.02),('15087','2013-09-28','08:35:00',1.03),('15087','2013-09-28','08:40:00',1.15),('15087','2013-09-28','08:45:00',1.23),('15087','2013-09-28','08:50:00',1.31),('15087','2013-09-28','08:55:00',1.38),('15087','2013-09-28','09:00:00',1.43),('15087','2013-09-28','09:05:00',1.53),('15087','2013-09-28','09:10:00',1.66),('15087','2013-09-28','09:15:00',1.74),('15087','2013-09-28','09:20:00',1.81),('15087','2013-09-28','09:25:00',2),('15087','2013-09-28','09:30:00',1.95),('15087','2013-09-28','09:35:00',2.08),('15087','2013-09-28','09:40:00',2.2),('15087','2013-09-28','09:45:00',2.32),('15087','2013-09-28','09:50:00',2.5),('15087','2013-09-28','09:55:00',2.57),('15087','2013-09-28','10:00:00',2.12),('15087','2013-09-28','10:05:00',1.8),('15087','2013-09-28','10:10:00',1.14),('15087','2013-09-28','10:15:00',2.53),('15087','2013-09-28','10:20:00',2.61),('15087','2013-09-28','10:25:00',1.29),('15087','2013-09-28','10:30:00',2.25),('15087','2013-09-28','10:35:00',2.1),('15087','2013-09-28','10:40:00',2.57),('15087','2013-09-28','10:45:00',3.66),('15087','2013-09-28','10:50:00',3.76),('15087','2013-09-28','10:55:00',2.96),('15087','2013-09-28','11:05:00',1.01),('15087','2013-09-28','11:10:00',2.51),('15087','2013-09-28','11:15:00',3.9),('15087','2013-09-28','11:20:00',3.99),('15087','2013-09-28','11:25:00',4.03),('15087','2013-09-28','11:30:00',4.04),('15087','2013-09-28','11:35:00',2.55),('15087','2013-09-28','11:50:00',1.8),('15087','2013-09-28','11:55:00',2.08),('15087','2013-09-28','12:00:00',4.18),('15087','2013-09-28','12:05:00',2.77),('15087','2013-09-28','12:10:00',3.24),('15087','2013-09-28','12:15:00',2.69),('15087','2013-09-28','12:20:00',4),('15087','2013-09-28','12:25:00',3.25),('15087','2013-09-28','12:30:00',3.34),('15087','2013-09-28','12:35:00',3.86),('15087','2013-09-28','12:40:00',4.03),('15087','2013-09-28','12:45:00',3.45),('15087','2013-09-28','12:50:00',3.21),('15087','2013-09-28','12:55:00',4.19),('15087','2013-09-28','13:00:00',3.82),('15087','2013-09-28','13:05:00',1.35),('15087','2013-09-28','13:10:00',2.94),('15087','2013-09-28','13:15:00',4.04),('15087','2013-09-28','13:20:00',4.08),('15087','2013-09-28','13:25:00',3.36),('15087','2013-09-28','13:30:00',1.55),('15087','2013-09-28','13:35:00',1.71),('15087','2013-09-28','13:40:00',1.74),('15087','2013-09-28','13:45:00',3.3),('15087','2013-09-28','13:50:00',1.84),('15087','2013-09-28','13:55:00',1.93),('15087','2013-09-28','14:00:00',2.05),('15087','2013-09-28','14:05:00',1.79),('15087','2013-09-28','14:10:00',3.05),('15087','2013-09-28','14:15:00',4.06),('15087','2013-09-28','14:20:00',3.9),('15087','2013-09-28','14:25:00',3.56),('15087','2013-09-28','14:30:00',3.59),('15087','2013-09-28','14:35:00',3.65),('15087','2013-09-28','14:40:00',3.44),('15087','2013-09-28','14:45:00',3.1),('15087','2013-09-28','14:50:00',3.27),('15087','2013-09-28','14:55:00',3.22),('15087','2013-09-28','15:00:00',3.18),('15087','2013-09-28','15:05:00',3.15),('15087','2013-09-28','15:10:00',2.78),('15087','2013-09-28','15:15:00',2.81),('15087','2013-09-28','15:20:00',2.9),('15087','2013-09-28','15:25:00',2.68),('15087','2013-09-28','15:30:00',2.69),('15087','2013-09-28','15:35:00',2.59),('15087','2013-09-28','15:40:00',2.52),('15087','2013-09-28','15:45:00',2.46),('15087','2013-09-28','15:50:00',2.18),('15087','2013-09-28','15:55:00',2.16),('15087','2013-09-28','16:00:00',2.24),('15087','2013-09-28','16:05:00',2.24),('15087','2013-09-28','16:10:00',2.09),('15087','2013-09-28','16:15:00',1.34),('15087','2013-09-28','16:20:00',1.22),('15087','2013-09-28','16:25:00',1.61),('15087','2013-09-28','16:30:00',1.57),('15087','2013-09-28','16:35:00',1.54),('15087','2013-09-28','16:40:00',1.44),('15087','2013-09-28','16:45:00',1.35),('15087','2013-09-28','16:50:00',1.28),('15087','2013-09-28','16:55:00',1.24),('15087','2013-09-28','17:00:00',1.19),('15087','2013-09-28','17:05:00',1.03),('15087','2013-09-27','08:35:00',1.16),('15087','2013-09-27','08:40:00',1.11),('15087','2013-09-27','08:45:00',1.09),('15087','2013-09-27','08:50:00',1.29),('15087','2013-09-27','08:55:00',1.59),('15087','2013-09-27','09:00:00',1.48),('15087','2013-09-27','09:05:00',1.05),('15087','2013-09-27','09:15:00',1.1),('15087','2013-09-27','09:50:00',2.28),('15087','2013-09-27','09:55:00',2.13),('15087','2013-09-27','10:00:00',2.37),('15087','2013-09-27','10:05:00',1.78),('15087','2013-09-27','10:10:00',2.43),('15087','2013-09-27','10:15:00',1.84),('15087','2013-09-27','10:20:00',2.7),('15087','2013-09-27','10:25:00',1.64),('15087','2013-09-27','10:30:00',1.39),('15087','2013-09-27','10:35:00',1.34),('15087','2013-09-27','10:40:00',1.42),('15087','2013-09-27','10:45:00',1.16),('15087','2013-09-27','10:50:00',1.41),('15087','2013-09-27','10:55:00',2.9),('15087','2013-09-27','11:00:00',2.77),('15087','2013-09-27','11:05:00',2.49),('15087','2013-09-27','11:10:00',2.41),('15087','2013-09-27','11:15:00',2.3),('15087','2013-09-27','11:20:00',3.5),('15087','2013-09-27','11:25:00',2.81),('15087','2013-09-27','11:30:00',1.72),('15087','2013-09-27','11:35:00',1.09),('15087','2013-09-27','11:40:00',1.02),('15087','2013-09-27','11:45:00',1.23),('15087','2013-09-27','11:50:00',1.32),('15087','2013-09-27','11:55:00',1.81),('15087','2013-09-27','12:00:00',3.17),('15087','2013-09-27','12:05:00',2.2),('15087','2013-09-27','12:10:00',3.89),('15087','2013-09-27','12:15:00',1.06),('15087','2013-09-27','12:40:00',1.48),('15087','2013-09-27','12:45:00',1.88),('15087','2013-09-27','12:50:00',3.46),('15087','2013-09-27','12:55:00',3.84),('15087','2013-09-27','13:00:00',3.71),('15087','2013-09-27','13:05:00',3.35),('15087','2013-09-27','13:10:00',3.35),('15087','2013-09-27','13:15:00',1.58),('15087','2013-09-27','13:20:00',1.92),('15087','2013-09-27','13:25:00',1.14),('15087','2013-09-27','13:40:00',2.49),('15087','2013-09-27','13:45:00',1.04),('15087','2013-09-27','13:50:00',1.02),('15087','2013-09-27','13:55:00',1.96),('15087','2013-09-27','14:00:00',3.68),('15087','2013-09-27','14:05:00',3.49),('15087','2013-09-27','14:10:00',3.49),('15087','2013-09-27','14:15:00',3.52),('15087','2013-09-27','14:20:00',3.54),('15087','2013-09-27','14:25:00',2.48),('15087','2013-09-27','14:30:00',3.2),('15087','2013-09-27','14:35:00',3.24),('15087','2013-09-27','14:40:00',3.3),('15087','2013-09-27','14:45:00',3.13),('15087','2013-09-27','14:50:00',2.81),('15087','2013-09-27','14:55:00',2.94),('15087','2013-09-27','15:00:00',3.03),('15087','2013-09-27','15:05:00',1.37),('15087','2013-09-27','15:10:00',2.67),('15087','2013-09-27','15:15:00',2.69),('15087','2013-09-27','15:20:00',2.48),('15087','2013-09-27','15:25:00',2.52),('15087','2013-09-27','15:30:00',2.78),('15087','2013-09-27','15:35:00',2.65),('15087','2013-09-27','15:40:00',1.34),('15087','2013-09-27','15:45:00',2.08),('15087','2013-09-27','15:50:00',2.59),('15087','2013-09-27','15:55:00',2.28),('15087','2013-09-27','16:00:00',1.72),('15087','2013-09-27','16:05:00',1.23),('15087','2013-09-27','16:10:00',1.15),('15087','2013-09-27','16:15:00',1.71),('15087','2013-09-27','16:20:00',1.88),('15087','2013-09-27','16:25:00',1.53),('15087','2013-09-27','16:30:00',1.68),('15087','2013-09-27','16:35:00',1.6),('15087','2013-09-27','16:40:00',1.49),('15087','2013-09-27','16:45:00',1.43),('15087','2013-09-27','16:50:00',1.33),('15087','2013-09-27','17:10:00',1.15),('15087','2013-09-27','17:15:00',1.07),('15087','2013-09-26','08:35:00',1.02),('15087','2013-09-26','08:40:00',1.22),('15087','2013-09-26','08:45:00',1.34),('15087','2013-09-26','08:50:00',1.42),('15087','2013-09-26','08:55:00',1.52),('15087','2013-09-26','09:00:00',1.64),('15087','2013-09-26','09:05:00',1.71),('15087','2013-09-26','09:10:00',1.82),('15087','2013-09-26','09:15:00',1.92),('15087','2013-09-26','09:20:00',1.98),('15087','2013-09-26','09:25:00',2.07),('15087','2013-09-26','09:30:00',2.19),('15087','2013-09-26','09:35:00',2.28),('15087','2013-09-26','09:40:00',2.36),('15087','2013-09-26','09:45:00',2.43),('15087','2013-09-26','09:50:00',2.5),('15087','2013-09-26','09:55:00',2.55),('15087','2013-09-26','10:00:00',2.63),('15087','2013-09-26','10:05:00',2.71),('15087','2013-09-26','10:10:00',2.75),('15087','2013-09-26','10:15:00',2.79),('15087','2013-09-26','10:20:00',2.87),('15087','2013-09-26','10:25:00',2.86),('15087','2013-09-26','10:30:00',2.98),('15087','2013-09-26','10:35:00',3.05),('15087','2013-09-26','10:40:00',3.08),('15087','2013-09-26','10:45:00',3.11),('15087','2013-09-26','10:50:00',3.16),('15087','2013-09-26','10:55:00',3.15),('15087','2013-09-26','11:00:00',3.2),('15087','2013-09-26','11:05:00',3.29),('15087','2013-09-26','11:10:00',3.36),('15087','2013-09-26','11:15:00',3.34),('15087','2013-09-26','11:20:00',3.31),('15087','2013-09-26','11:25:00',3.33),('15087','2013-09-26','11:30:00',2.58),('15087','2013-09-26','11:35:00',2.19),('15087','2013-09-26','11:40:00',3.56),('15087','2013-09-26','11:45:00',3.34),('15087','2013-09-26','11:50:00',3.71),('15087','2013-09-26','11:55:00',3.93),('15087','2013-09-26','12:00:00',3.21),('15087','2013-09-26','12:05:00',4.1),('15087','2013-09-26','12:10:00',1.29),('15087','2013-09-26','12:15:00',1.39),('15087','2013-09-26','12:20:00',1.85),('15087','2013-09-26','12:25:00',1.23),('15087','2013-09-26','12:30:00',1.43),('15087','2013-09-26','12:35:00',1.73),('15087','2013-09-26','12:40:00',1.57),('15087','2013-09-26','12:45:00',1.59),('15087','2013-09-26','12:50:00',1.69),('15087','2013-09-26','12:55:00',3.8),('15087','2013-09-26','13:00:00',2.71),('15087','2013-09-26','13:05:00',2.33),('15087','2013-09-26','13:10:00',2.42),('15087','2013-09-26','13:15:00',4.4),('15087','2013-09-26','13:20:00',4.3),('15087','2013-09-26','13:25:00',2.71),('15087','2013-09-26','13:30:00',2.42),('15087','2013-09-26','13:35:00',1.97),('15087','2013-09-26','13:40:00',1.62),('15087','2013-09-26','13:45:00',1.48),('15087','2013-09-26','13:50:00',2.2),('15087','2013-09-26','13:55:00',2.2),('15087','2013-09-26','14:00:00',2.5),('15087','2013-09-26','14:05:00',4.06),('15087','2013-09-26','14:10:00',3.41),('15087','2013-09-26','14:15:00',2.69),('15087','2013-09-26','14:20:00',1.48),('15087','2013-09-26','14:30:00',1.94),('15087','2013-09-26','14:35:00',1.03),('15087','2013-09-26','14:40:00',2.12),('15087','2013-09-26','14:45:00',3.82),('15087','2013-09-26','14:50:00',3.25),('15087','2013-09-26','14:55:00',1.61),('15087','2013-09-26','15:00:00',1.24),('15087','2013-09-26','15:05:00',1.79),('15087','2013-09-26','15:10:00',1.04),('15087','2013-09-26','15:15:00',1.08),('15087','2013-09-26','15:20:00',2.61),('15087','2013-09-26','15:25:00',1.12),('15087','2013-09-26','15:35:00',2.19),('15087','2013-09-26','15:45:00',1.06),('15087','2013-09-26','15:50:00',2.07),('15087','2013-09-26','15:55:00',2.39),('15087','2013-09-26','16:00:00',2.15),('15087','2013-09-26','16:10:00',1.92),('15087','2013-09-26','16:15:00',1.88),('15087','2013-09-26','16:20:00',1.76),('15087','2013-09-26','16:25:00',1.77),('15087','2013-09-26','16:30:00',1.7),('15087','2013-09-26','16:35:00',1.65),('15087','2013-09-26','16:40:00',1.57),('15087','2013-09-26','16:45:00',1.46),('15087','2013-09-26','16:50:00',1.36),('15087','2013-09-26','16:55:00',1.24),('15087','2013-09-26','17:00:00',1.2),('15087','2013-09-26','17:05:00',1.1),('15087','2013-09-26','17:10:00',1.06),('15087','2013-09-25','08:30:00',1.02),('15087','2013-09-25','08:45:00',1.42),('15087','2013-09-25','09:05:00',1.6),('15087','2013-09-25','09:10:00',1.74),('15087','2013-09-25','09:15:00',1.29),('15087','2013-09-25','09:20:00',1.12),('15087','2013-09-25','09:25:00',1.87),('15087','2013-09-25','09:30:00',1.57),('15087','2013-09-25','09:35:00',2.41),('15087','2013-09-25','09:40:00',2.15),('15087','2013-09-25','09:55:00',2.22),('15087','2013-09-25','10:00:00',2.44),('15087','2013-09-25','10:05:00',1.3),('15087','2013-09-25','10:20:00',1.62),('15087','2013-09-25','10:25:00',1.51),('15087','2013-09-25','10:30:00',1.57),('15087','2013-09-25','10:35:00',1.24),('15087','2013-09-25','10:40:00',2.09),('15087','2013-09-25','10:45:00',3.43),('15087','2013-09-25','10:50:00',3.43),('15087','2013-09-25','10:55:00',2.45),('15087','2013-09-25','11:00:00',2.29),('15087','2013-09-25','11:05:00',1.56),('15087','2013-09-25','11:10:00',1.24),('15087','2013-09-25','11:15:00',2.91),('15087','2013-09-25','11:20:00',2.99),('15087','2013-09-25','11:25:00',3.53),('15087','2013-09-25','11:30:00',3.59),('15087','2013-09-25','11:35:00',3.3),('15087','2013-09-25','11:40:00',3.82),('15087','2013-09-25','11:45:00',2.95),('15087','2013-09-25','11:50:00',1.57),('15087','2013-09-25','11:55:00',1.48),('15087','2013-09-25','12:10:00',2.66),('15087','2013-09-25','12:15:00',3.89),('15087','2013-09-25','12:20:00',1.17),('15087','2013-09-25','12:25:00',1.14),('15087','2013-09-25','12:30:00',4.2),('15087','2013-09-25','12:35:00',3.67),('15087','2013-09-25','12:40:00',1.05),('15087','2013-09-25','12:45:00',1.96),('15087','2013-09-25','12:50:00',1.41),('15087','2013-09-25','12:55:00',1.02),('15087','2013-09-25','13:00:00',1.83),('15087','2013-09-25','13:10:00',1.4),('15087','2013-09-25','13:15:00',2),('15087','2013-09-25','13:20:00',1.34),('15087','2013-09-25','13:25:00',3.86),('15087','2013-09-25','13:30:00',2.17),('15087','2013-09-25','13:35:00',4.58),('15087','2013-09-25','13:40:00',4.48),('15087','2013-09-25','13:45:00',4.43),('15087','2013-09-25','13:50:00',4.26),('15087','2013-09-25','13:55:00',1.16),('15087','2013-09-25','14:05:00',1.06),('15087','2013-09-25','14:10:00',1.11),('15087','2013-09-25','14:20:00',1.11),('15087','2013-09-25','14:25:00',1.4),('15087','2013-09-25','14:30:00',3.05),('15087','2013-09-25','14:35:00',3.95),('15087','2013-09-25','14:40:00',3.86),('15087','2013-09-25','14:45:00',1.9),('15087','2013-09-25','14:50:00',3.34),('15087','2013-09-25','14:55:00',2.8),('15087','2013-09-25','15:00:00',3.44),('15087','2013-09-25','15:05:00',3.18),('15087','2013-09-25','15:10:00',3.06),('15087','2013-09-25','15:15:00',2.6),('15087','2013-09-25','15:20:00',2.64),('15087','2013-09-25','15:25:00',2.92),('15087','2013-09-25','15:30:00',2.14),('15087','2013-09-25','15:35:00',2.96),('15087','2013-09-25','15:40:00',2.81),('15087','2013-09-25','15:45:00',2.65),('15087','2013-09-25','15:50:00',2.47),('15087','2013-09-25','15:55:00',2.48),('15087','2013-09-25','16:00:00',2.32),('15087','2013-09-25','16:05:00',2.23),('15087','2013-09-25','16:10:00',2.18),('15087','2013-09-25','16:15:00',2.08),('15087','2013-09-25','16:20:00',1.57),('15087','2013-09-25','16:25:00',1.41),('15087','2013-09-25','16:30:00',1.85),('15087','2013-09-25','16:35:00',1.77),('15087','2013-09-25','16:40:00',1.4),('15087','2013-09-25','16:45:00',1.52),('15087','2013-09-25','16:50:00',1.4),('15087','2013-09-25','16:55:00',1.36),('15087','2013-09-25','17:00:00',1.32),('15087','2013-09-25','17:05:00',1.22),('15087','2013-09-25','17:10:00',1.1),('15087','2013-09-25','17:15:00',1.08),('15087','2013-09-24','08:25:00',1.03),('15087','2013-09-24','08:30:00',1.13),('15087','2013-09-24','08:35:00',1.22),('15087','2013-09-24','08:40:00',1.34),('15087','2013-09-24','08:45:00',1.42),('15087','2013-09-24','08:50:00',1.51),('15087','2013-09-24','08:55:00',1.63),('15087','2013-09-24','09:00:00',1.75),('15087','2013-09-24','09:05:00',1.84),('15087','2013-09-24','09:10:00',1.93),('15087','2013-09-24','09:15:00',2.04),('15087','2013-09-24','09:20:00',2.14),('15087','2013-09-24','09:25:00',2.23),('15087','2013-09-24','09:30:00',2.32),('15087','2013-09-24','09:35:00',2.4),('15087','2013-09-24','09:40:00',2.47),('15087','2013-09-24','09:45:00',2.54),('15087','2013-09-24','09:50:00',2.61),('15087','2013-09-24','09:55:00',2.69),('15087','2013-09-24','10:00:00',2.78),('15087','2013-09-24','10:05:00',2.83),('15087','2013-09-24','10:10:00',2.89),('15087','2013-09-24','10:15:00',2.97),('15087','2013-09-24','10:20:00',3.03),('15087','2013-09-24','10:25:00',3.1),('15087','2013-09-24','10:30:00',3.15),('15087','2013-09-24','10:35:00',3.21),('15087','2013-09-24','10:40:00',3.24),('15087','2013-09-24','10:45:00',3.3),('15087','2013-09-24','10:50:00',3.35),('15087','2013-09-24','10:55:00',3.35),('15087','2013-09-24','11:00:00',3.43),('15087','2013-09-24','11:05:00',3.48),('15087','2013-09-24','11:10:00',3.51),('15087','2013-09-24','11:15:00',3.52),('15087','2013-09-24','11:20:00',3.56),('15087','2013-09-24','11:25:00',3.61),('15087','2013-09-24','11:30:00',3.68),('15087','2013-09-24','11:35:00',3.67),('15087','2013-09-24','11:40:00',3.69),('15087','2013-09-24','11:45:00',3.7),('15087','2013-09-24','11:50:00',3.73),('15087','2013-09-24','11:55:00',3.77),('15087','2013-09-24','12:00:00',3.76),('15087','2013-09-24','12:05:00',3.78),('15087','2013-09-24','12:10:00',3.82),('15087','2013-09-24','12:15:00',3.82),('15087','2013-09-24','12:20:00',3.85),('15087','2013-09-24','12:25:00',3.86),('15087','2013-09-24','12:30:00',3.92),('15087','2013-09-24','12:35:00',3.88),('15087','2013-09-24','12:40:00',3.92),('15087','2013-09-24','12:45:00',3.94),('15087','2013-09-24','12:50:00',3.92),('15087','2013-09-24','12:55:00',3.95),('15087','2013-09-24','13:00:00',3.97),('15087','2013-09-24','13:05:00',3.98),('15087','2013-09-24','13:10:00',3.94),('15087','2013-09-24','13:15:00',3.96),('15087','2013-09-24','13:20:00',3.95),('15087','2013-09-24','13:25:00',3.88),('15087','2013-09-24','13:30:00',3.92),('15087','2013-09-24','13:35:00',3.92),('15087','2013-09-24','13:40:00',3.83),('15087','2013-09-24','13:45:00',3.54),('15087','2013-09-24','13:50:00',3.47),('15087','2013-09-24','13:55:00',3.7),('15087','2013-09-24','14:00:00',3.68),('15087','2013-09-24','14:05:00',3.47),('15087','2013-09-24','14:10:00',3.56),('15087','2013-09-24','14:15:00',3.58),('15087','2013-09-24','14:20:00',3.44),('15087','2013-09-24','14:25:00',3.43),('15087','2013-09-24','14:30:00',3.39),('15087','2013-09-24','14:35:00',3.31),('15087','2013-09-24','14:40:00',3.28),('15087','2013-09-24','14:45:00',3.18),('15087','2013-09-24','14:50:00',3.14),('15087','2013-09-24','14:55:00',3.06),('15087','2013-09-24','15:00:00',2.99),('15087','2013-09-24','15:05:00',2.75),('15087','2013-09-24','15:10:00',2.89),('15087','2013-09-24','15:15:00',2.81),('15087','2013-09-24','15:20:00',2.79),('15087','2013-09-24','15:25:00',2.67),('15087','2013-09-24','15:30:00',2.74),('15087','2013-09-24','15:35:00',2.63),('15087','2013-09-24','15:40:00',2.59),('15087','2013-09-24','15:45:00',2.59),('15087','2013-09-24','15:50:00',2.51),('15087','2013-09-24','15:55:00',2.42),('15087','2013-09-24','16:00:00',2.34),('15087','2013-09-24','16:05:00',2.22),('15087','2013-09-24','16:10:00',2.15),('15087','2013-09-24','16:15:00',2.11),('15087','2013-09-24','16:20:00',1.9),('15087','2013-09-24','16:25:00',1.85),('15087','2013-09-24','16:30:00',1.81),('15087','2013-09-24','16:35:00',1.69),('15087','2013-09-24','16:40:00',1.65),('15087','2013-09-24','16:45:00',1.58),('15087','2013-09-24','16:50:00',1.46),('15087','2013-09-24','16:55:00',1.4),('15087','2013-09-24','17:00:00',1.33),('15087','2013-09-24','17:05:00',1.25),('15087','2013-09-24','17:10:00',1.15),('15087','2013-09-24','17:15:00',1.06),('15087','2013-09-23','08:25:00',1.09),('15087','2013-09-23','08:30:00',1.18),('15087','2013-09-23','08:35:00',1.28),('15087','2013-09-23','08:40:00',1.38),('15087','2013-09-23','08:45:00',1.48),('15087','2013-09-23','08:50:00',1.58),('15087','2013-09-23','08:55:00',1.68),('15087','2013-09-23','09:00:00',1.79),('15087','2013-09-23','09:05:00',1.92),('15087','2013-09-23','09:10:00',2.02),('15087','2013-09-23','09:15:00',2.12),('15087','2013-09-23','09:20:00',2.2),('15087','2013-09-23','09:25:00',2.29),('15087','2013-09-23','09:30:00',2.38),('15087','2013-09-23','09:35:00',2.46),('15087','2013-09-23','09:40:00',2.53),('15087','2013-09-23','09:45:00',2.61),('15087','2013-09-23','09:50:00',2.68),('15087','2013-09-23','09:55:00',2.75),('15087','2013-09-23','10:00:00',2.82),('15087','2013-09-23','10:05:00',2.9),('15087','2013-09-23','10:10:00',2.95),('15087','2013-09-23','10:15:00',3.01),('15087','2013-09-23','10:20:00',3.07),('15087','2013-09-23','10:25:00',3.14),('15087','2013-09-23','10:30:00',3.2),('15087','2013-09-23','10:35:00',3.26),('15087','2013-09-23','10:40:00',3.33),('15087','2013-09-23','10:45:00',3.38),('15087','2013-09-23','10:50:00',3.44),('15087','2013-09-23','10:55:00',3.5),('15087','2013-09-23','11:00:00',3.52),('15087','2013-09-23','11:05:00',3.54),('15087','2013-09-23','11:10:00',3.63),('15087','2013-09-23','11:15:00',3.69),('15087','2013-09-23','11:20:00',3.74),('15087','2013-09-23','11:25:00',3.77),('15087','2013-09-23','11:30:00',3.83),('15087','2013-09-23','11:35:00',3.87),('15087','2013-09-23','11:40:00',3.88),('15087','2013-09-23','11:45:00',3.92),('15087','2013-09-23','11:50:00',3.96),('15087','2013-09-23','11:55:00',4),('15087','2013-09-23','12:00:00',4.02),('15087','2013-09-23','12:05:00',4.03),('15087','2013-09-23','12:10:00',4.06),('15087','2013-09-23','12:15:00',4.08),('15087','2013-09-23','12:20:00',4.06),('15087','2013-09-23','12:25:00',4.08),('15087','2013-09-23','12:30:00',4.08),('15087','2013-09-23','12:35:00',4.08),('15087','2013-09-23','12:40:00',4.1),('15087','2013-09-23','12:45:00',4.08),('15087','2013-09-23','12:50:00',4.06),('15087','2013-09-23','12:55:00',4.04),('15087','2013-09-23','13:00:00',4.08),('15087','2013-09-23','13:05:00',4.06),('15087','2013-09-23','13:10:00',4.02),('15087','2013-09-23','13:15:00',4.01),('15087','2013-09-23','13:20:00',3.99),('15087','2013-09-23','13:25:00',3.87),('15087','2013-09-23','13:30:00',3.95),('15087','2013-09-23','13:35:00',3.95),('15087','2013-09-23','13:40:00',3.88),('15087','2013-09-23','13:45:00',3.72),('15087','2013-09-23','13:50:00',3.51),('15087','2013-09-23','13:55:00',3.75),('15087','2013-09-23','14:00:00',3.68),('15087','2013-09-23','14:05:00',3.54),('15087','2013-09-23','14:10:00',3.54),('15087','2013-09-23','14:15:00',3.67),('15087','2013-09-23','14:20:00',3.53),('15087','2013-09-23','14:25:00',3.52),('15087','2013-09-23','14:30:00',3.54),('15087','2013-09-23','14:35:00',3.35),('15087','2013-09-23','14:40:00',3.32),('15087','2013-09-23','14:45:00',3.18),('15087','2013-09-23','14:50:00',2.99),('15087','2013-09-23','14:55:00',3.01),('15087','2013-09-23','15:00:00',3.22),('15087','2013-09-23','15:05:00',3.22),('15087','2013-09-23','15:10:00',1.79),('15087','2013-09-23','15:15:00',2.79),('15087','2013-09-23','15:20:00',2.27),('15087','2013-09-23','15:25:00',2.51),('15087','2013-09-23','15:30:00',2.8),('15087','2013-09-23','15:35:00',2.73),('15087','2013-09-23','15:40:00',2.62),('15087','2013-09-23','15:45:00',2.56),('15087','2013-09-23','15:50:00',2.18),('15087','2013-09-23','15:55:00',2.23),('15087','2013-09-23','16:00:00',2.27),('15087','2013-09-23','16:05:00',2.16),('15087','2013-09-23','16:10:00',1.93),('15087','2013-09-23','16:15:00',2),('15087','2013-09-23','16:20:00',1.99),('15087','2013-09-23','16:25:00',1.93),('15087','2013-09-23','16:30:00',1.74),('15087','2013-09-23','16:35:00',1.57),('15087','2013-09-23','16:40:00',1.72),('15087','2013-09-23','16:45:00',1.6),('15087','2013-09-23','16:50:00',1.45),('15087','2013-09-23','16:55:00',1.36),('15087','2013-09-23','17:00:00',1.28),('15087','2013-09-23','17:05:00',1.22),('15087','2013-09-23','17:10:00',1.12),('15087','2013-09-23','17:15:00',1.01),('15087','2013-09-22','08:25:00',1.09),('15087','2013-09-22','08:30:00',1.16),('15087','2013-09-22','08:35:00',1.25),('15087','2013-09-22','08:40:00',1.33),('15087','2013-09-22','08:45:00',1.43),('15087','2013-09-22','08:50:00',1.52),('15087','2013-09-22','08:55:00',1.62),('15087','2013-09-22','09:00:00',1.75),('15087','2013-09-22','09:05:00',1.89),('15087','2013-09-22','09:10:00',1.99),('15087','2013-09-22','09:15:00',2.1),('15087','2013-09-22','09:20:00',2.2),('15087','2013-09-22','09:25:00',2.29),('15087','2013-09-22','09:30:00',2.38),('15087','2013-09-22','09:35:00',2.47),('15087','2013-09-22','09:40:00',2.52),('15087','2013-09-22','09:45:00',2.6),('15087','2013-09-22','09:50:00',2.69),('15087','2013-09-22','09:55:00',2.76),('15087','2013-09-22','10:00:00',2.85),('15087','2013-09-22','10:05:00',2.94),('15087','2013-09-22','10:10:00',3),('15087','2013-09-22','10:15:00',3.08),('15087','2013-09-22','10:20:00',3.14),('15087','2013-09-22','10:25:00',3.19),('15087','2013-09-22','10:30:00',3.27),('15087','2013-09-22','10:35:00',3.35),('15087','2013-09-22','10:40:00',3.37),('15087','2013-09-22','10:45:00',3.43),('15087','2013-09-22','10:50:00',3.5),('15087','2013-09-22','10:55:00',3.55),('15087','2013-09-22','11:00:00',3.59),('15087','2013-09-22','11:05:00',3.62),('15087','2013-09-22','11:10:00',3.65),('15087','2013-09-22','11:15:00',3.69),('15087','2013-09-22','11:20:00',3.75),('15087','2013-09-22','11:25:00',3.79),('15087','2013-09-22','11:30:00',3.85),('15087','2013-09-22','11:35:00',3.89),('15087','2013-09-22','11:40:00',3.93),('15087','2013-09-22','11:45:00',3.96),('15087','2013-09-22','11:50:00',4),('15087','2013-09-22','11:55:00',4.02),('15087','2013-09-22','12:00:00',4.04),('15087','2013-09-22','12:05:00',4.07),('15087','2013-09-22','12:10:00',4.09),('15087','2013-09-22','12:15:00',4.1),('15087','2013-09-22','12:20:00',4.11),('15087','2013-09-22','12:25:00',4.07),('15087','2013-09-22','12:30:00',4.16),('15087','2013-09-22','12:35:00',4.15),('15087','2013-09-22','12:40:00',4.18),('15087','2013-09-22','12:45:00',4.18),('15087','2013-09-22','12:50:00',4.2),('15087','2013-09-22','12:55:00',4.22),('15087','2013-09-22','13:00:00',4.2),('15087','2013-09-22','13:05:00',4.16),('15087','2013-09-22','13:10:00',4.17),('15087','2013-09-22','13:15:00',4.15),('15087','2013-09-22','13:20:00',4.13),('15087','2013-09-22','13:25:00',4.06),('15087','2013-09-22','13:30:00',4.07),('15087','2013-09-22','13:35:00',4.08),('15087','2013-09-22','13:40:00',3.98),('15087','2013-09-22','13:45:00',3.99),('15087','2013-09-22','13:50:00',4.01),('15087','2013-09-22','13:55:00',4),('15087','2013-09-22','14:00:00',3.81),('15087','2013-09-22','14:05:00',3.77),('15087','2013-09-22','14:10:00',3.8),('15087','2013-09-22','14:15:00',3.69),('15087','2013-09-22','14:20:00',3),('15087','2013-09-22','14:25:00',3.39),('15087','2013-09-22','14:30:00',1.07),('15087','2013-09-22','14:35:00',3.46),('15087','2013-09-22','14:40:00',3.56),('15087','2013-09-22','14:45:00',3.53),('15087','2013-09-22','14:50:00',3.44),('15087','2013-09-22','14:55:00',3.37),('15087','2013-09-22','15:00:00',3.23),('15087','2013-09-22','15:05:00',3.28),('15087','2013-09-22','15:10:00',3.27),('15087','2013-09-22','15:15:00',3.53),('15087','2013-09-22','15:20:00',3.73),('15087','2013-09-22','15:25:00',1.98),('15087','2013-09-22','15:30:00',1.29),('15087','2013-09-22','15:35:00',1.1),('15087','2013-09-22','15:40:00',3.08),('15087','2013-09-22','15:45:00',2.86),('15087','2013-09-22','15:50:00',2.61),('15087','2013-09-22','15:55:00',2.64),('15087','2013-09-22','16:00:00',2.77),('15087','2013-09-22','16:05:00',2.81),('15087','2013-09-22','16:10:00',3.02),('15087','2013-09-22','16:15:00',2.83),('15087','2013-09-22','16:20:00',2.13),('15087','2013-09-22','16:25:00',1.51),('15087','2013-09-22','16:30:00',1.4),('15087','2013-09-22','16:35:00',1.14),('15087','2013-09-22','16:40:00',1.02),('15087','2013-09-22','16:45:00',1.55),('15087','2013-09-22','16:50:00',1.92),('15087','2013-09-22','16:55:00',1.46),('15087','2013-09-22','17:00:00',1.36),('15087','2013-09-22','17:05:00',1.73),('15087','2013-09-22','17:10:00',1.44),('15087','2013-09-21','08:25:00',1.07),('15087','2013-09-21','08:30:00',1.15),('15087','2013-09-21','08:35:00',1.25),('15087','2013-09-21','08:40:00',1.34),('15087','2013-09-21','08:45:00',1.43),('15087','2013-09-21','08:50:00',1.52),('15087','2013-09-21','08:55:00',1.63),('15087','2013-09-21','09:00:00',1.73),('15087','2013-09-21','09:05:00',1.86),('15087','2013-09-21','09:10:00',1.91),('15087','2013-09-21','09:15:00',2.02),('15087','2013-09-21','09:20:00',2.14),('15087','2013-09-21','09:25:00',2.22),('15087','2013-09-21','09:30:00',2.31),('15087','2013-09-21','09:35:00',2.4),('15087','2013-09-21','09:40:00',2.45),('15087','2013-09-21','09:45:00',2.55),('15087','2013-09-21','09:50:00',2.63),('15087','2013-09-21','09:55:00',2.69),('15087','2013-09-21','10:00:00',2.77),('15087','2013-09-21','10:05:00',2.85),('15087','2013-09-21','10:10:00',2.91),('15087','2013-09-21','10:15:00',2.98),('15087','2013-09-21','10:20:00',3.03),('15087','2013-09-21','10:25:00',3.1),('15087','2013-09-21','10:30:00',3.17),('15087','2013-09-21','10:35:00',3.21),('15087','2013-09-21','10:40:00',3.27),('15087','2013-09-21','10:45:00',3.34),('15087','2013-09-21','10:50:00',3.39),('15087','2013-09-21','10:55:00',3.45),('15087','2013-09-21','11:00:00',3.48),('15087','2013-09-21','11:05:00',3.51),('15087','2013-09-21','11:10:00',3.55),('15087','2013-09-21','11:15:00',3.6),('15087','2013-09-21','11:20:00',3.65),('15087','2013-09-21','11:25:00',3.7),('15087','2013-09-21','11:30:00',3.73),('15087','2013-09-21','11:35:00',3.76),('15087','2013-09-21','11:40:00',3.83),('15087','2013-09-21','11:45:00',3.86),('15087','2013-09-21','11:50:00',3.91),('15087','2013-09-21','11:55:00',3.84),('15087','2013-09-21','12:00:00',3.9),('15087','2013-09-21','12:05:00',3.95),('15087','2013-09-21','12:10:00',3.96),('15087','2013-09-21','12:15:00',4.02),('15087','2013-09-21','12:20:00',3.85),('15087','2013-09-21','12:25:00',3.69),('15087','2013-09-21','12:30:00',4.09),('15087','2013-09-21','12:35:00',3.95),('15087','2013-09-21','12:40:00',3.86),('15087','2013-09-21','12:45:00',3.95),('15087','2013-09-21','12:50:00',4.02),('15087','2013-09-21','12:55:00',4.1),('15087','2013-09-21','13:00:00',4.07),('15087','2013-09-21','13:05:00',3.96),('15087','2013-09-21','13:10:00',4.05),('15087','2013-09-21','13:15:00',4.15),('15087','2013-09-21','13:20:00',3.42),('15087','2013-09-21','13:25:00',3.9),('15087','2013-09-21','13:30:00',3.89),('15087','2013-09-21','13:35:00',3.88),('15087','2013-09-21','13:40:00',3.4),('15087','2013-09-21','13:45:00',3.2),('15087','2013-09-21','13:50:00',3.31),('15087','2013-09-21','13:55:00',3.39),('15087','2013-09-21','14:00:00',3.57),('15087','2013-09-21','14:05:00',3.53),('15087','2013-09-21','14:10:00',3.59),('15087','2013-09-21','14:15:00',3.72),('15087','2013-09-21','14:20:00',3.57),('15087','2013-09-21','14:25:00',3.63),('15087','2013-09-21','14:30:00',3.56),('15087','2013-09-21','14:35:00',3.51),('15087','2013-09-21','14:40:00',3.34),('15087','2013-09-21','14:45:00',3.32),('15087','2013-09-21','14:50:00',3.23),('15087','2013-09-21','14:55:00',3.21),('15087','2013-09-21','15:00:00',3.03),('15087','2013-09-21','15:05:00',2.89),('15087','2013-09-21','15:10:00',3.01),('15087','2013-09-21','15:15:00',2.85),('15087','2013-09-21','15:20:00',2.9),('15087','2013-09-21','15:25:00',2.86),('15087','2013-09-21','15:30:00',2.81),('15087','2013-09-21','15:35:00',2.75),('15087','2013-09-21','15:40:00',2.43),('15087','2013-09-21','15:45:00',1.66),('15087','2013-09-21','15:50:00',2.52),('15087','2013-09-21','15:55:00',2.34),('15087','2013-09-21','16:00:00',1.68),('15087','2013-09-21','16:05:00',1.16),('15087','2013-09-21','16:10:00',1.4),('15087','2013-09-21','16:15:00',1.23),('15087','2013-09-21','16:20:00',1.48),('15087','2013-09-21','16:30:00',1.11),('15087','2013-09-21','16:35:00',1.34),('15087','2013-09-21','16:55:00',1.07),('15087','2013-09-20','08:30:00',1.22),('15087','2013-09-20','08:35:00',1.29),('15087','2013-09-20','08:40:00',1.51),('15087','2013-09-20','08:45:00',1.34),('15087','2013-09-20','09:00:00',1.08),('15087','2013-09-20','09:05:00',1.23),('15087','2013-09-20','09:10:00',1.06),('15087','2013-09-20','09:15:00',1.25),('15087','2013-09-20','09:20:00',1.35),('15087','2013-09-20','09:25:00',1.41),('15087','2013-09-20','09:30:00',1.2),('15087','2013-09-20','09:35:00',1.22),('15087','2013-09-20','09:40:00',1.26),('15087','2013-09-20','09:45:00',1.35),('15087','2013-09-20','09:50:00',1.34),('15087','2013-09-20','09:55:00',1.54),('15087','2013-09-20','10:00:00',2),('15087','2013-09-20','10:05:00',2.36),('15087','2013-09-20','10:10:00',2.37),('15087','2013-09-20','10:15:00',3.68),('15087','2013-09-20','10:20:00',3.07),('15087','2013-09-20','10:25:00',2.56),('15087','2013-09-20','10:30:00',2.61),('15087','2013-09-20','10:35:00',2.92),('15087','2013-09-20','10:40:00',3.58),('15087','2013-09-20','10:45:00',3.02),('15087','2013-09-20','10:50:00',2.8),('15087','2013-09-20','10:55:00',2.31),('15087','2013-09-20','11:00:00',2.06),('15087','2013-09-20','11:05:00',2.1),('15087','2013-09-20','11:10:00',2.33),('15087','2013-09-20','11:15:00',2.47),('15087','2013-09-20','11:20:00',2.81),('15087','2013-09-20','11:25:00',2.47),('15087','2013-09-20','11:30:00',2.7),('15087','2013-09-20','11:35:00',2.86),('15087','2013-09-20','11:40:00',3.94),('15087','2013-09-20','11:45:00',4.16),('15087','2013-09-20','11:50:00',4.13),('15087','2013-09-20','11:55:00',4.05),('15087','2013-09-20','12:00:00',3.99),('15087','2013-09-20','12:05:00',4.02),('15087','2013-09-20','12:10:00',4.05),('15087','2013-09-20','12:15:00',4.14),('15087','2013-09-20','12:20:00',4.23),('15087','2013-09-20','12:25:00',3.39),('15087','2013-09-20','12:30:00',3.83),('15087','2013-09-20','12:35:00',2.82),('15087','2013-09-20','12:40:00',3.72),('15087','2013-09-20','12:45:00',2.82),('15087','2013-09-20','12:50:00',4.35),('15087','2013-09-20','12:55:00',4.17),('15087','2013-09-20','13:00:00',3.21),('15087','2013-09-20','13:10:00',1.22),('15087','2013-09-20','13:15:00',2.55),('15087','2013-09-20','13:20:00',2.58),('15087','2013-09-20','13:25:00',2.21),('15087','2013-09-20','13:30:00',2.84),('15087','2013-09-20','13:35:00',3.52),('15087','2013-09-20','13:40:00',3.7),('15087','2013-09-20','13:45:00',3.81),('15087','2013-09-20','13:50:00',2.88),('15087','2013-09-20','13:55:00',3.14),('15087','2013-09-20','14:00:00',2.98),('15087','2013-09-20','14:10:00',3.59),('15087','2013-09-20','14:15:00',2.56),('15087','2013-09-20','14:20:00',2.34),('15087','2013-09-20','14:25:00',3.8),('15087','2013-09-20','14:30:00',3.81),('15087','2013-09-20','14:35:00',2.47),('15087','2013-09-20','14:40:00',3.59),('15087','2013-09-20','14:45:00',3.53),('15087','2013-09-20','14:50:00',3.52),('15087','2013-09-20','14:55:00',3.45),('15087','2013-09-20','15:00:00',2.43),('15087','2013-09-20','15:05:00',3.43),('15087','2013-09-20','15:10:00',2.27),('15087','2013-09-20','15:15:00',2.5),('15087','2013-09-20','15:20:00',1.61),('15087','2013-09-20','15:25:00',1.26),('15087','2013-09-20','15:30:00',1.03),('15087','2013-09-20','15:35:00',3.14),('15087','2013-09-20','15:40:00',3),('15087','2013-09-20','15:45:00',2.81),('15087','2013-09-20','15:50:00',2.8),('15087','2013-09-20','15:55:00',2.8),('15087','2013-09-20','16:00:00',3.01),('15087','2013-09-20','16:05:00',1.97),('15087','2013-09-20','16:10:00',1.52),('15087','2013-09-20','16:15:00',1.99),('15087','2013-09-20','16:20:00',1.72),('15087','2013-09-20','16:25:00',1.21),('15087','2013-09-20','16:45:00',1.61),('15087','2013-09-20','16:50:00',1.74),('15087','2013-09-20','16:55:00',2.07),('15087','2013-09-20','17:00:00',1.94),('15087','2013-09-20','17:05:00',2.04),('15087','2013-09-20','17:10:00',2.12),('15087','2013-09-20','17:15:00',1.92),('15087','2013-09-20','17:20:00',1.86),('15087','2013-09-20','17:25:00',1.57),('15087','2013-09-20','17:30:00',1.25),('15087','2013-09-20','17:35:00',1.07),('15087','2013-09-20','17:40:00',1.05),('15087','2013-09-20','17:45:00',1),('15087','2013-09-19','08:25:00',1.03),('15087','2013-09-19','08:30:00',1.24),('15087','2013-09-19','08:35:00',1.2),('15087','2013-09-19','08:40:00',1.18),('15087','2013-09-19','08:45:00',1.18),('15087','2013-09-19','08:50:00',1.28),('15087','2013-09-19','08:55:00',1.33),('15087','2013-09-19','09:00:00',1.2),('15087','2013-09-19','09:10:00',1.99),('15087','2013-09-19','09:15:00',1.87),('15087','2013-09-19','09:20:00',1.43),('15087','2013-09-19','10:05:00',2.77),('15087','2013-09-19','10:10:00',1.65),('15087','2013-09-19','10:15:00',1.18),('15087','2013-09-19','10:25:00',1.12),('15087','2013-09-19','10:30:00',1.21),('15087','2013-09-19','10:35:00',3.54),('15087','2013-09-19','10:40:00',3.07),('15087','2013-09-19','10:45:00',1.69),('15087','2013-09-19','10:50:00',1.69),('15087','2013-09-19','10:55:00',3.82),('15087','2013-09-19','11:00:00',4.11),('15087','2013-09-19','11:05:00',1.9),('15087','2013-09-19','11:10:00',2.47),('15087','2013-09-19','11:15:00',1.7),('15087','2013-09-19','11:20:00',2.52),('15087','2013-09-19','11:25:00',3),('15087','2013-09-19','11:30:00',3.5),('15087','2013-09-19','11:35:00',4.14),('15087','2013-09-19','11:40:00',2.45),('15087','2013-09-19','11:45:00',4.08),('15087','2013-09-19','11:50:00',3.65),('15087','2013-09-19','11:55:00',3.85),('15087','2013-09-19','12:00:00',2.93),('15087','2013-09-19','12:05:00',1.75),('15087','2013-09-19','12:10:00',3.64),('15087','2013-09-19','12:15:00',2.15),('15087','2013-09-19','12:20:00',4.43),('15087','2013-09-19','12:25:00',4.35),('15087','2013-09-19','12:30:00',4.41),('15087','2013-09-19','12:35:00',4.3),('15087','2013-09-19','12:40:00',3.96),('15087','2013-09-19','12:45:00',2.81),('15087','2013-09-19','12:50:00',4.53),('15087','2013-09-19','12:55:00',4.44),('15087','2013-09-19','13:00:00',4.45),('15087','2013-09-19','13:05:00',4.54),('15087','2013-09-19','13:10:00',4.69),('15087','2013-09-19','13:15:00',4.69),('15087','2013-09-19','13:20:00',4.13),('15087','2013-09-19','13:25:00',3.81),('15087','2013-09-19','13:30:00',4.36),('15087','2013-09-19','13:35:00',4.41),('15087','2013-09-19','13:40:00',4.69),('15087','2013-09-19','13:45:00',4.74),('15087','2013-09-19','13:50:00',3.21),('15087','2013-09-19','13:55:00',1.6),('15087','2013-09-19','14:00:00',1.42),('15087','2013-09-19','14:05:00',4.22),('15087','2013-09-19','14:10:00',4.09),('15087','2013-09-19','14:15:00',3.96),('15087','2013-09-19','14:20:00',3.83),('15087','2013-09-19','14:25:00',3.65),('15087','2013-09-19','14:30:00',3.71),('15087','2013-09-19','14:35:00',3.67),('15087','2013-09-19','14:40:00',3.33),('15087','2013-09-19','14:45:00',3.44),('15087','2013-09-19','14:50:00',3.28),('15087','2013-09-19','14:55:00',3.46),('15087','2013-09-19','15:00:00',3.17),('15087','2013-09-19','15:05:00',2.88),('15087','2013-09-19','15:10:00',2.74),('15087','2013-09-19','15:15:00',2.63),('15087','2013-09-19','15:20:00',3.23),('15087','2013-09-19','15:25:00',2.7),('15087','2013-09-19','15:30:00',1.94),('15087','2013-09-19','15:35:00',2.11),('15087','2013-09-19','15:40:00',3.09),('15087','2013-09-19','15:45:00',2.96),('15087','2013-09-19','15:50:00',2.72),('15087','2013-09-19','15:55:00',2.45),('15087','2013-09-19','16:00:00',2.55),('15087','2013-09-19','16:05:00',2.5),('15087','2013-09-19','16:10:00',2.14),('15087','2013-09-19','16:15:00',2.34),('15087','2013-09-19','16:20:00',2.25),('15087','2013-09-19','16:25:00',1.89),('15087','2013-09-19','16:30:00',1.78),('15087','2013-09-19','16:35:00',1.75),('15087','2013-09-19','16:40:00',1.21),('15087','2013-09-19','16:45:00',1.55),('15087','2013-09-19','16:50:00',1.49),('15087','2013-09-19','16:55:00',1.85),('15087','2013-09-19','17:00:00',1.41),('15087','2013-09-19','17:05:00',1.43),('15087','2013-09-19','17:10:00',1.32),('15087','2013-09-19','17:15:00',1.24),('15087','2013-09-19','17:20:00',1.04),('15087','2013-09-19','17:25:00',1.02),('15087','2014-04-13','09:05:00',1.39),('15087','2014-04-13','09:10:00',1.63),('15087','2014-04-13','09:15:00',1.34),('15087','2014-04-13','09:20:00',1.52),('15087','2014-04-13','09:25:00',1.71),('15087','2014-04-13','09:30:00',2.48),('15087','2014-04-13','09:35:00',1.79),('15087','2014-04-13','09:40:00',2.26),('15087','2014-04-13','09:45:00',2.04),('15087','2014-04-13','09:50:00',1.53),('15087','2014-04-13','09:55:00',1.6),('15087','2014-04-13','10:00:00',3),('15087','2014-04-13','10:05:00',4.08),('15087','2014-04-13','10:10:00',2.91),('15087','2014-04-13','10:15:00',2.63),('15087','2014-04-13','10:20:00',2.95),('15087','2014-04-13','10:25:00',2.08),('15087','2014-04-13','10:30:00',3.69),('15087','2014-04-13','10:35:00',3.75),('15087','2014-04-13','10:40:00',3.79),('15087','2014-04-13','10:45:00',3.89),('15087','2014-04-13','10:50:00',3.95),('15087','2014-04-13','10:55:00',3.98),('15087','2014-04-13','11:00:00',3.77),('15087','2014-04-13','11:05:00',4.11),('15087','2014-04-13','11:10:00',4),('15087','2014-04-13','11:15:00',4.27),('15087','2014-04-13','11:20:00',4.16),('15087','2014-04-13','11:25:00',2.69),('15087','2014-04-13','11:30:00',2.42),('15087','2014-04-13','11:35:00',3.01),('15087','2014-04-13','11:40:00',4.58),('15087','2014-04-13','11:45:00',4.22),('15087','2014-04-13','11:50:00',4.32),('15087','2014-04-13','11:55:00',2.9),('15087','2014-04-13','12:00:00',2.47),('15087','2014-04-13','12:05:00',1.79),('15087','2014-04-13','12:10:00',1.56),('15087','2014-04-13','12:15:00',1.47),('15087','2014-04-13','12:20:00',1.33),('15087','2014-04-13','13:05:00',1.44),('15087','2014-04-13','13:10:00',2.19),('15087','2014-04-13','13:15:00',2.23),('15087','2014-04-13','13:20:00',3.15),('15087','2014-04-13','13:25:00',3.77),('15087','2014-04-13','13:30:00',4.89),('15087','2014-04-13','13:35:00',4.43),('15087','2014-04-13','13:40:00',3.91),('15087','2014-04-13','13:45:00',2.18),('15087','2014-04-13','13:50:00',3.28),('15087','2014-04-13','13:55:00',3),('15087','2014-04-13','14:00:00',4.68),('15087','2014-04-13','14:05:00',4.23),('15087','2014-04-13','14:10:00',4.22),('15087','2014-04-13','14:15:00',4.78),('15087','2014-04-13','14:20:00',2.13),('15087','2014-04-13','14:25:00',1.78),('15087','2014-04-13','14:30:00',1.82),('15087','2014-04-13','14:35:00',1.69),('15087','2014-04-13','14:40:00',1.46),('15087','2014-04-13','14:45:00',2.44),('15087','2014-04-13','14:50:00',4.52),('15087','2014-04-13','14:55:00',3.44),('15087','2014-04-13','15:00:00',3.26),('15087','2014-04-13','15:05:00',3.88),('15087','2014-04-13','15:10:00',3.91),('15087','2014-04-13','15:15:00',3.41),('15087','2014-04-13','15:20:00',3.33),('15087','2014-04-13','15:25:00',3.59),('15087','2014-04-13','15:30:00',3.3),('15087','2014-04-13','15:35:00',2.36),('15087','2014-04-13','15:40:00',1.51),('15087','2014-04-13','15:45:00',1.7),('15087','2014-04-13','15:50:00',1.96),('15087','2014-04-13','15:55:00',1.83),('15087','2014-04-13','16:00:00',3.36),('15087','2014-04-13','16:05:00',2.82),('15087','2014-04-13','16:10:00',1.28),('15087','2014-04-13','16:15:00',1.53),('15087','2014-04-13','16:20:00',1.4),('15087','2014-04-13','16:25:00',1.77),('15087','2014-04-13','16:30:00',1.38),('15087','2014-04-13','16:35:00',1.51),('15087','2014-04-13','16:40:00',2.74),('15087','2014-04-13','16:45:00',2.64),('15087','2014-04-13','16:50:00',2.32),('15087','2014-04-13','16:55:00',2.27),('15087','2014-04-13','17:00:00',1.85),('15087','2014-04-13','17:05:00',1.56),('15087','2014-04-13','17:10:00',1.02),('15087','2014-04-13','17:15:00',1.08),('15087','2014-04-13','17:20:00',1.62),('15087','2014-04-13','17:25:00',1.35),('15087','2014-04-13','17:55:00',1.11),('15087','2013-09-18','08:45:00',1.22),('15087','2013-09-18','08:50:00',1.05),('15087','2013-09-18','08:55:00',1.61),('15087','2013-09-18','09:00:00',1.58),('15087','2013-09-18','09:05:00',1.36),('15087','2013-09-18','09:15:00',1.71),('15087','2013-09-18','09:20:00',2.52),('15087','2013-09-18','09:25:00',2.03),('15087','2013-09-18','09:35:00',2.38),('15087','2013-09-18','09:40:00',2.18),('15087','2013-09-18','09:55:00',2.11),('15087','2013-09-18','10:00:00',2.99),('15087','2013-09-18','10:05:00',2.77),('15087','2013-09-18','10:10:00',2.98),('15087','2013-09-18','10:15:00',2.96),('15087','2013-09-18','10:20:00',3.04),('15087','2013-09-18','10:25:00',3.09),('15087','2013-09-18','10:30:00',3.14),('15087','2013-09-18','10:35:00',3.19),('15087','2013-09-18','10:40:00',3.24),('15087','2013-09-18','10:45:00',3.28),('15087','2013-09-18','10:50:00',2.73),('15087','2013-09-18','10:55:00',2.87),('15087','2013-09-18','11:00:00',3.67),('15087','2013-09-18','11:05:00',3.76),('15087','2013-09-18','11:10:00',3.8),('15087','2013-09-18','11:15:00',3.18),('15087','2013-09-18','11:20:00',3.43),('15087','2013-09-18','11:25:00',3.85),('15087','2013-09-18','11:30:00',3.85),('15087','2013-09-18','11:35:00',4.22),('15087','2013-09-18','11:40:00',2.98),('15087','2013-09-18','11:45:00',4.03),('15087','2013-09-18','11:50:00',4.04),('15087','2013-09-18','11:55:00',3.85),('15087','2013-09-18','12:00:00',4.1),('15087','2013-09-18','12:05:00',4.25),('15087','2013-09-18','12:10:00',4.27),('15087','2013-09-18','12:15:00',4.35),('15087','2013-09-18','12:20:00',3.81),('15087','2013-09-18','12:25:00',1.88),('15087','2013-09-18','12:30:00',2.69),('15087','2013-09-18','12:35:00',4.71),('15087','2013-09-18','12:40:00',2.83),('15087','2013-09-18','12:45:00',3.78),('15087','2013-09-18','12:50:00',4),('15087','2013-09-18','12:55:00',3.53),('15087','2013-09-18','13:00:00',1.65),('15087','2013-09-18','13:05:00',4.11),('15087','2013-09-18','13:10:00',4.45),('15087','2013-09-18','13:15:00',4.38),('15087','2013-09-18','13:20:00',4.3),('15087','2013-09-18','13:25:00',4.36),('15087','2013-09-18','13:30:00',4.29),('15087','2013-09-18','13:35:00',4.29),('15087','2013-09-18','13:40:00',4.29),('15087','2013-09-18','13:45:00',3.94),('15087','2013-09-18','13:50:00',4.32),('15087','2013-09-18','13:55:00',4.3),('15087','2013-09-18','14:00:00',3.98),('15087','2013-09-18','14:05:00',2.03),('15087','2013-09-18','14:10:00',3.3),('15087','2013-09-18','14:15:00',2.98),('15087','2013-09-18','14:20:00',3.9),('15087','2013-09-18','14:25:00',3.78),('15087','2013-09-18','14:30:00',3.64),('15087','2013-09-18','14:35:00',3.68),('15087','2013-09-18','14:40:00',3.65),('15087','2013-09-18','14:45:00',3.49),('15087','2013-09-18','14:50:00',3.37),('15087','2013-09-18','14:55:00',2.56),('15087','2013-09-18','15:00:00',3.34),('15087','2013-09-18','15:05:00',2.41),('15087','2013-09-18','15:10:00',1.43),('15087','2013-09-18','15:15:00',2.26),('15087','2013-09-18','15:20:00',2.1),('15087','2013-09-18','15:25:00',3.27),('15087','2013-09-18','15:30:00',2.93),('15087','2013-09-18','15:35:00',3.18),('15087','2013-09-18','15:40:00',2.94),('15087','2013-09-18','15:45:00',2.6),('15087','2013-09-18','15:50:00',1.79),('15087','2013-09-18','15:55:00',2.51),('15087','2013-09-18','16:00:00',2.84),('15087','2013-09-18','16:05:00',2.86),('15087','2013-09-18','16:10:00',2.62),('15087','2013-09-18','16:15:00',2.32),('15087','2013-09-18','16:20:00',2.26),('15087','2013-09-18','16:25:00',1.99),('15087','2013-09-18','16:30:00',1.91),('15087','2013-09-18','16:35:00',1.73),('15087','2013-09-18','16:40:00',1.85),('15087','2013-09-18','16:45:00',1.82),('15087','2013-09-18','16:50:00',1.58),('15087','2013-09-18','16:55:00',1.51),('15087','2013-09-18','17:00:00',1.59),('15087','2013-09-18','17:05:00',1.35),('15087','2013-09-18','17:10:00',1.35),('15087','2013-09-18','17:15:00',1.21),('15087','2013-09-18','17:20:00',1.09),('15087','2013-09-18','17:30:00',1.05),('15087','2013-09-17','09:20:00',1.46),('15087','2013-09-17','09:30:00',1.13),('15087','2013-09-17','09:40:00',1.45),('15087','2013-09-17','09:45:00',2.31),('15087','2013-09-17','09:50:00',1.25),('15087','2013-09-17','09:55:00',1.9),('15087','2013-09-17','10:00:00',2.15),('15087','2013-09-17','10:05:00',1.65),('15087','2013-09-17','10:10:00',1.86),('15087','2013-09-17','10:20:00',1.37),('15087','2013-09-17','10:25:00',2.25),('15087','2013-09-17','10:30:00',3.22),('15087','2013-09-17','10:35:00',1.79),('15087','2013-09-17','10:40:00',1.87),('15087','2013-09-17','10:45:00',2.7),('15087','2013-09-17','10:50:00',3.91),('15087','2013-09-17','10:55:00',3.18),('15087','2013-09-17','11:00:00',2.48),('15087','2013-09-17','11:05:00',1.88),('15087','2013-09-17','11:10:00',3.9),('15087','2013-09-17','11:15:00',3.02),('15087','2013-09-17','11:20:00',2.6),('15087','2013-09-17','11:25:00',1.78),('15087','2013-09-17','11:30:00',2.01),('15087','2013-09-17','11:35:00',3.37),('15087','2013-09-17','11:40:00',3.39),('15087','2013-09-17','11:45:00',3.02),('15087','2013-09-17','11:50:00',3.7),('15087','2013-09-17','11:55:00',3.47),('15087','2013-09-17','12:00:00',3.71),('15087','2013-09-17','12:05:00',3.62),('15087','2013-09-17','12:10:00',1.89),('15087','2013-09-17','12:15:00',2.26),('15087','2013-09-17','12:20:00',2.48),('15087','2013-09-17','12:25:00',4.31),('15087','2013-09-17','12:30:00',2.9),('15087','2013-09-17','12:35:00',2.38),('15087','2013-09-17','12:40:00',3.44),('15087','2013-09-17','12:45:00',4.06),('15087','2013-09-17','12:50:00',3.04),('15087','2013-09-17','12:55:00',3.29),('15087','2013-09-17','13:00:00',2.19),('15087','2013-09-17','13:05:00',1.47),('15087','2013-09-17','13:10:00',3.21),('15087','2013-09-17','13:15:00',3),('15087','2013-09-17','13:20:00',2.79),('15087','2013-09-17','13:25:00',2.44),('15087','2013-09-17','13:30:00',1.97),('15087','2013-09-17','13:35:00',2.36),('15087','2013-09-17','13:40:00',2.46),('15087','2013-09-17','13:45:00',1.5),('15087','2013-09-17','13:55:00',1.39),('15087','2013-09-17','14:00:00',2.01),('15087','2013-09-17','14:05:00',1.37),('15087','2013-09-17','14:15:00',1.23),('15087','2013-09-17','14:25:00',1.75),('15087','2013-09-17','14:30:00',1.01),('15087','2013-09-17','14:35:00',1.19),('15087','2013-09-17','14:50:00',1.44),('15087','2013-09-17','14:55:00',3.51),('15087','2013-09-17','15:00:00',3.32),('15087','2013-09-17','15:05:00',2.84),('15087','2013-09-17','15:10:00',2.48),('15087','2013-09-17','15:15:00',3.03),('15087','2013-09-17','15:20:00',3.07),('15087','2013-09-17','15:25:00',2.8),('15087','2013-09-17','15:30:00',2.29),('15087','2013-09-17','15:35:00',1.16),('15087','2013-09-17','15:45:00',1.41),('15087','2013-09-17','15:50:00',1.86),('15087','2013-09-17','15:55:00',2.01),('15087','2013-09-17','16:00:00',1.42),('15087','2013-09-17','16:05:00',1.96),('15087','2013-09-17','16:10:00',1.8),('15087','2013-09-17','16:15:00',1.62),('15087','2013-09-17','16:20:00',1.03),('15087','2013-09-17','16:40:00',1.28),('15087','2013-09-17','16:45:00',1.58),('15087','2013-09-17','16:50:00',1.23),('15087','2013-09-17','16:55:00',1.02),('15087','2013-09-17','17:00:00',1.58),('15087','2013-09-17','17:05:00',1.74),('15087','2013-09-17','17:10:00',1.61),('15087','2013-09-17','17:15:00',1.59),('15087','2013-09-17','17:20:00',1.19),('15087','2013-09-17','17:25:00',1.28),('15087','2013-09-17','17:30:00',1.21),('15087','2013-09-16','08:10:00',1.02),('15087','2013-09-16','08:20:00',1.07),('15087','2013-09-16','08:25:00',1.16),('15087','2013-09-16','08:30:00',1.25),('15087','2013-09-16','08:35:00',1.34),('15087','2013-09-16','08:40:00',1.58),('15087','2013-09-16','08:45:00',1.32),('15087','2013-09-16','08:50:00',1.18),('15087','2013-09-16','09:05:00',1.98),('15087','2013-09-16','09:10:00',1.85),('15087','2013-09-16','09:15:00',2.12),('15087','2013-09-16','09:20:00',2.24),('15087','2013-09-16','09:25:00',2.09),('15087','2013-09-16','09:30:00',1.91),('15087','2013-09-16','09:35:00',2.45),('15087','2013-09-16','09:40:00',2.55),('15087','2013-09-16','09:45:00',2.66),('15087','2013-09-16','09:50:00',2.72),('15087','2013-09-16','09:55:00',2.24),('15087','2013-09-16','10:00:00',2.68),('15087','2013-09-16','10:05:00',3.11),('15087','2013-09-16','10:10:00',1.82),('15087','2013-09-16','10:15:00',1.34),('15087','2013-09-16','10:20:00',2.77),('15087','2013-09-16','10:25:00',2.32),('15087','2013-09-16','10:30:00',3.54),('15087','2013-09-16','10:35:00',3.73),('15087','2013-09-16','10:40:00',3.98),('15087','2013-09-16','10:45:00',4.21),('15087','2013-09-16','10:50:00',3.26),('15087','2013-09-16','10:55:00',1.19),('15087','2013-09-16','11:00:00',1.41),('15087','2013-09-16','11:05:00',1.37),('15087','2013-09-16','11:25:00',4.05),('15087','2013-09-16','11:30:00',4.18),('15087','2013-09-16','11:35:00',4.14),('15087','2013-09-16','11:40:00',4.17),('15087','2013-09-16','11:45:00',3.05),('15087','2013-09-16','11:50:00',4.35),('15087','2013-09-16','11:55:00',4.24),('15087','2013-09-16','12:00:00',4.4),('15087','2013-09-16','12:05:00',4.12),('15087','2013-09-16','12:10:00',4.64),('15087','2013-09-16','12:15:00',4.08),('15087','2013-09-16','12:20:00',4.29),('15087','2013-09-16','12:25:00',4.28),('15087','2013-09-16','12:30:00',4.27),('15087','2013-09-16','12:35:00',4.33),('15087','2013-09-16','12:40:00',4.54),('15087','2013-09-16','12:45:00',3.32),('15087','2013-09-16','12:50:00',4.99),('15087','2013-09-16','12:55:00',3.83),('15087','2013-09-16','13:00:00',3.26),('15087','2013-09-16','13:05:00',3.29),('15087','2013-09-16','13:10:00',4.72),('15087','2013-09-16','13:15:00',4.15),('15087','2013-09-16','13:20:00',4.28),('15087','2013-09-16','13:25:00',4.27),('15087','2013-09-16','13:30:00',4.22),('15087','2013-09-16','13:35:00',4.24),('15087','2013-09-16','13:40:00',4.24),('15087','2013-09-16','13:45:00',4.04),('15087','2013-09-16','13:50:00',4.06),('15087','2013-09-16','13:55:00',4.26),('15087','2013-09-16','14:00:00',3.68),('15087','2013-09-16','14:05:00',3.98),('15087','2013-09-16','14:10:00',3.93),('15087','2013-09-16','14:15:00',3.91),('15087','2013-09-16','14:20:00',3.82),('15087','2013-09-16','14:25:00',3.58),('15087','2013-09-16','14:30:00',3.56),('15087','2013-09-16','14:35:00',3.55),('15087','2013-09-16','14:40:00',3.61),('15087','2013-09-16','14:45:00',3.56),('15087','2013-09-16','14:50:00',3.53),('15087','2013-09-16','14:55:00',3.47),('15087','2013-09-16','15:00:00',3.34),('15087','2013-09-16','15:05:00',3.19),('15087','2013-09-16','15:10:00',3.3),('15087','2013-09-16','15:15:00',3.18),('15087','2013-09-16','15:20:00',2.97),('15087','2013-09-16','15:25:00',2.99),('15087','2013-09-16','15:30:00',2.89),('15087','2013-09-16','15:35:00',2.88),('15087','2013-09-16','15:40:00',2.95),('15087','2013-09-16','15:45:00',2.76),('15087','2013-09-16','15:50:00',2.68),('15087','2013-09-16','15:55:00',2.65),('15087','2013-09-16','16:00:00',2.44),('15087','2013-09-16','16:05:00',1.97),('15087','2013-09-16','16:10:00',2.53),('15087','2013-09-16','16:15:00',2.29),('15087','2013-09-16','16:20:00',2.22),('15087','2013-09-16','16:25:00',2.18),('15087','2013-09-16','16:30:00',2.1),('15087','2013-09-16','16:35:00',2.02),('15087','2013-09-16','16:40:00',2.03),('15087','2013-09-16','16:45:00',1.96),('15087','2013-09-16','16:50:00',1.87),('15087','2013-09-16','16:55:00',1.74),('15087','2013-09-16','17:00:00',1.57),('15087','2013-09-16','17:05:00',1.49),('15087','2013-09-16','17:10:00',1.38),('15087','2013-09-16','17:15:00',1.29),('15087','2013-09-16','17:20:00',1.2),('15087','2013-09-16','17:25:00',1.12),('15087','2013-09-16','17:30:00',1.08),('15087','2013-09-15','08:15:00',1.03),('15087','2013-09-15','08:20:00',1.12),('15087','2013-09-15','08:25:00',1.23),('15087','2013-09-15','08:30:00',1.32),('15087','2013-09-15','08:35:00',1.43),('15087','2013-09-15','08:40:00',1.55),('15087','2013-09-15','08:45:00',1.64),('15087','2013-09-15','08:50:00',1.66),('15087','2013-09-15','08:55:00',1.61),('15087','2013-09-15','09:00:00',1.76),('15087','2013-09-15','09:05:00',1.85),('15087','2013-09-15','09:10:00',2.03),('15087','2013-09-15','09:15:00',2.26),('15087','2013-09-15','09:20:00',2.18),('15087','2013-09-15','09:25:00',2.32),('15087','2013-09-15','09:30:00',2.33),('15087','2013-09-15','09:35:00',2.52),('15087','2013-09-15','09:40:00',2.58),('15087','2013-09-15','09:45:00',2.62),('15087','2013-09-15','09:50:00',2.74),('15087','2013-09-15','09:55:00',2.81),('15087','2013-09-15','10:00:00',2.9),('15087','2013-09-15','10:05:00',2.99),('15087','2013-09-15','10:10:00',3.03),('15087','2013-09-15','10:15:00',3),('15087','2013-09-15','10:20:00',3.05),('15087','2013-09-15','10:25:00',3.09),('15087','2013-09-15','10:30:00',2.94),('15087','2013-09-15','10:35:00',1.82),('15087','2013-09-15','10:40:00',1.8),('15087','2013-09-15','10:50:00',2.02),('15087','2013-09-15','10:55:00',3.53),('15087','2013-09-15','11:00:00',3.94),('15087','2013-09-15','11:05:00',4.07),('15087','2013-09-15','11:10:00',2.67),('15087','2013-09-15','11:15:00',1.72),('15087','2013-09-15','11:20:00',1.47),('15087','2013-09-15','11:30:00',2.99),('15087','2013-09-15','11:35:00',2.11),('15087','2013-09-15','11:40:00',1.47),('15087','2013-09-15','11:45:00',2.79),('15087','2013-09-15','11:50:00',2.85),('15087','2013-09-15','11:55:00',1.6),('15087','2013-09-15','12:00:00',1.28),('15087','2013-09-15','12:05:00',1.19),('15087','2013-09-15','12:10:00',1.17),('15087','2013-09-15','12:15:00',1.28),('15087','2013-09-15','12:20:00',1.59),('15087','2013-09-15','12:25:00',1.83),('15087','2013-09-15','12:30:00',1.68),('15087','2013-09-15','12:35:00',1.5),('15087','2013-09-15','12:40:00',1.46),('15087','2013-09-15','12:45:00',1.2),('15087','2013-09-15','12:50:00',1.38),('15087','2013-09-15','12:55:00',1.41),('15087','2013-09-15','13:00:00',1.28),('15087','2013-09-15','13:05:00',1.03),('15087','2013-09-15','13:25:00',1.13),('15087','2013-09-15','13:30:00',1.12),('15087','2013-09-15','13:35:00',1.21),('15087','2013-09-15','13:40:00',1.41),('15087','2013-09-15','13:45:00',2.57),('15087','2013-09-15','13:50:00',1.79),('15087','2013-09-15','13:55:00',1.22),('15087','2013-09-15','14:00:00',1.98),('15087','2013-09-15','14:05:00',1.84),('15087','2013-09-15','14:10:00',1.62),('15087','2013-09-15','14:15:00',1.55),('15087','2013-09-15','14:20:00',1.47),('15087','2013-09-15','14:25:00',1.42),('15087','2013-09-15','14:30:00',1.33),('15087','2013-09-15','14:35:00',1.11),('15087','2013-09-15','14:40:00',1.15),('15087','2013-09-15','14:45:00',1.05),('15087','2013-09-15','14:50:00',1.1),('15087','2013-09-15','14:55:00',1.11),('15087','2013-09-15','15:00:00',1.13),('15087','2013-09-15','15:05:00',1.2),('15087','2013-09-15','15:10:00',1.4),('15087','2013-09-15','15:15:00',2.95),('15087','2013-09-15','15:20:00',2.16),('15087','2013-09-15','15:25:00',1.53),('15087','2013-09-15','15:30:00',1.12),('15087','2013-09-15','15:35:00',1.12),('15087','2013-09-15','15:40:00',1.04),('15087','2013-09-14','08:20:00',1.06),('15087','2013-09-14','08:25:00',1.14),('15087','2013-09-14','08:30:00',1.24),('15087','2013-09-14','08:35:00',1.34),('15087','2013-09-14','08:40:00',1.44),('15087','2013-09-14','08:45:00',1.54),('15087','2013-09-14','08:50:00',1.62),('15087','2013-09-14','08:55:00',1.73),('15087','2013-09-14','09:00:00',1.87),('15087','2013-09-14','09:05:00',1.93),('15087','2013-09-14','09:10:00',2.06),('15087','2013-09-14','09:15:00',2.17),('15087','2013-09-14','09:20:00',2.25),('15087','2013-09-14','09:25:00',2.33),('15087','2013-09-14','09:30:00',2.43),('15087','2013-09-14','09:35:00',2.51),('15087','2013-09-14','09:40:00',2.57),('15087','2013-09-14','09:45:00',2.64),('15087','2013-09-14','09:50:00',2.69),('15087','2013-09-14','09:55:00',2.85),('15087','2013-09-14','10:00:00',2.8),('15087','2013-09-14','10:05:00',2.86),('15087','2013-09-14','10:10:00',2.71),('15087','2013-09-14','10:15:00',2.8),('15087','2013-09-14','10:20:00',3),('15087','2013-09-14','10:25:00',3.13),('15087','2013-09-14','10:30:00',3.2),('15087','2013-09-14','10:35:00',3.45),('15087','2013-09-14','10:40:00',3.53),('15087','2013-09-14','10:45:00',2.54),('15087','2013-09-14','10:50:00',4.15),('15087','2013-09-14','10:55:00',2.57),('15087','2013-09-14','11:00:00',2.37),('15087','2013-09-14','11:10:00',2.93),('15087','2013-09-14','11:15:00',1.24),('15087','2013-09-14','11:25:00',3.71),('15087','2013-09-14','11:30:00',4.01),('15087','2013-09-14','11:35:00',4.11),('15087','2013-09-14','11:40:00',4.13),('15087','2013-09-14','11:45:00',4.16),('15087','2013-09-14','11:50:00',2.56),('15087','2013-09-14','12:10:00',1.58),('15087','2013-09-14','12:30:00',1.42),('15087','2013-09-14','12:35:00',2.63),('15087','2013-09-14','12:40:00',1.12),('15087','2013-09-14','12:55:00',1.14),('15087','2013-09-14','13:05:00',1.23),('15087','2013-09-14','13:10:00',3.39),('15087','2013-09-14','13:15:00',4.71),('15087','2013-09-14','13:20:00',3.09),('15087','2013-09-14','13:25:00',4.6),('15087','2013-09-14','13:30:00',3.46),('15087','2013-09-14','13:35:00',2.61),('15087','2013-09-14','13:40:00',4.08),('15087','2013-09-14','13:45:00',3.06),('15087','2013-09-14','13:50:00',3.08),('15087','2013-09-14','13:55:00',4.62),('15087','2013-09-14','14:00:00',4.37),('15087','2013-09-14','14:05:00',4.07),('15087','2013-09-14','14:10:00',3.85),('15087','2013-09-14','14:15:00',3.97),('15087','2013-09-14','14:20:00',3.91),('15087','2013-09-14','14:25:00',3.82),('15087','2013-09-14','14:30:00',3.8),('15087','2013-09-14','14:35:00',3.75),('15087','2013-09-14','14:40:00',3.72),('15087','2013-09-14','14:45:00',3.56),('15087','2013-09-14','14:50:00',3.46),('15087','2013-09-14','14:55:00',3.46),('15087','2013-09-14','15:00:00',3.4),('15087','2013-09-14','15:05:00',3.24),('15087','2013-09-14','15:10:00',3.16),('15087','2013-09-14','15:15:00',3.2),('15087','2013-09-14','15:20:00',3.12),('15087','2013-09-14','15:25:00',2.67),('15087','2013-09-14','15:30:00',3.1),('15087','2013-09-14','15:35:00',3.02),('15087','2013-09-14','15:40:00',2.92),('15087','2013-09-14','15:45:00',2.85),('15087','2013-09-14','15:50:00',2.74),('15087','2013-09-14','15:55:00',2.67),('15087','2013-09-14','16:00:00',2.55),('15087','2013-09-14','16:05:00',2.46),('15087','2013-09-14','16:10:00',2.36),('15087','2013-09-14','16:15:00',2.35),('15087','2013-09-14','16:20:00',2.26),('15087','2013-09-14','16:25:00',2.2),('15087','2013-09-14','16:30:00',2.14),('15087','2013-09-14','16:35:00',2.01),('15087','2013-09-14','16:40:00',1.98),('15087','2013-09-14','16:45:00',1.95),('15087','2013-09-14','16:50:00',1.85),('15087','2013-09-14','16:55:00',1.73),('15087','2013-09-14','17:00:00',1.65),('15087','2013-09-14','17:05:00',1.55),('15087','2013-09-14','17:10:00',1.45),('15087','2013-09-14','17:15:00',1.32),('15087','2013-09-14','17:20:00',1.23),('15087','2013-09-14','17:25:00',1.13),('15087','2013-09-14','17:30:00',1.09),('15087','2013-09-13','08:55:00',1.04),('15087','2013-09-13','09:00:00',1.02),('15087','2013-09-13','09:20:00',1.03),('15087','2013-09-13','09:25:00',1.15),('15087','2013-09-13','09:30:00',1.23),('15087','2013-09-13','09:35:00',1.33),('15087','2013-09-13','09:40:00',1.44),('15087','2013-09-13','09:45:00',1.38),('15087','2013-09-13','09:50:00',1.7),('15087','2013-09-13','09:55:00',2.97),('15087','2013-09-13','10:00:00',2.46),('15087','2013-09-13','10:05:00',1.5),('15087','2013-09-13','10:10:00',2.55),('15087','2013-09-13','10:15:00',3.95),('15087','2013-09-13','10:20:00',3.55),('15087','2013-09-13','10:25:00',1.6),('15087','2013-09-13','10:30:00',2.83),('15087','2013-09-13','10:35:00',3.42),('15087','2013-09-13','10:40:00',3.45),('15087','2013-09-13','10:45:00',3.47),('15087','2013-09-13','10:50:00',3.53),('15087','2013-09-13','10:55:00',3.58),('15087','2013-09-13','11:00:00',3.62),('15087','2013-09-13','11:05:00',3.65),('15087','2013-09-13','11:10:00',3.73),('15087','2013-09-13','11:15:00',3.69),('15087','2013-09-13','11:20:00',3.81),('15087','2013-09-13','11:25:00',3.84),('15087','2013-09-13','11:30:00',3.9),('15087','2013-09-13','11:35:00',3.96),('15087','2013-09-13','11:40:00',3.97),('15087','2013-09-13','11:45:00',4),('15087','2013-09-13','11:50:00',3.99),('15087','2013-09-13','11:55:00',4.04),('15087','2013-09-13','12:00:00',4.06),('15087','2013-09-13','12:05:00',4.08),('15087','2013-09-13','12:10:00',4.08),('15087','2013-09-13','12:15:00',4.16),('15087','2013-09-13','12:20:00',4.2),('15087','2013-09-13','12:25:00',4.24),('15087','2013-09-13','12:30:00',4.12),('15087','2013-09-13','12:35:00',4.26),('15087','2013-09-13','12:40:00',4.34),('15087','2013-09-13','12:45:00',4.33),('15087','2013-09-13','12:50:00',4.35),('15087','2013-09-13','12:55:00',4.34),('15087','2013-09-13','13:00:00',4.25),('15087','2013-09-13','13:05:00',4.21),('15087','2013-09-13','13:10:00',4.18),('15087','2013-09-13','13:15:00',4.15),('15087','2013-09-13','13:20:00',4.16),('15087','2013-09-13','13:25:00',4.12),('15087','2013-09-13','13:30:00',4.09),('15087','2013-09-13','13:35:00',4.02),('15087','2013-09-13','13:40:00',4.07),('15087','2013-09-13','13:45:00',4.05),('15087','2013-09-13','13:50:00',4.01),('15087','2013-09-13','13:55:00',3.98),('15087','2013-09-13','14:00:00',3.93),('15087','2013-09-13','14:05:00',3.87),('15087','2013-09-13','14:10:00',3.81),('15087','2013-09-13','14:15:00',3.58),('15087','2013-09-13','14:20:00',3.79),('15087','2013-09-13','14:25:00',1.45),('15087','2013-09-13','14:35:00',3.85),('15087','2013-09-13','14:40:00',3.72),('15087','2013-09-13','14:45:00',3.01),('15087','2013-09-13','14:50:00',3.55),('15087','2013-09-13','14:55:00',3.51),('15087','2013-09-13','15:00:00',3.47),('15087','2013-09-13','15:05:00',3.4),('15087','2013-09-13','15:10:00',3.37),('15087','2013-09-13','15:15:00',3.27),('15087','2013-09-13','15:20:00',3.2),('15087','2013-09-13','15:25:00',3.13),('15087','2013-09-13','15:30:00',3.1),('15087','2013-09-13','15:35:00',3.05),('15087','2013-09-13','15:40:00',2.95),('15087','2013-09-13','15:45:00',2.8),('15087','2013-09-13','15:50:00',2.65),('15087','2013-09-13','15:55:00',2.72),('15087','2013-09-13','16:00:00',2.6),('15087','2013-09-13','16:05:00',2.51),('15087','2013-09-13','16:10:00',2.44),('15087','2013-09-13','16:15:00',2.38),('15087','2013-09-13','16:20:00',2.35),('15087','2013-09-13','16:25:00',2.2),('15087','2013-09-13','16:30:00',2.08),('15087','2013-09-13','16:35:00',2.15),('15087','2013-09-13','16:40:00',2.04),('15087','2013-09-13','16:45:00',1.94),('15087','2013-09-13','16:50:00',1.86),('15087','2013-09-13','16:55:00',1.71),('15087','2013-09-13','17:00:00',1.66),('15087','2013-09-13','17:05:00',1.55),('15087','2013-09-13','17:10:00',1.44),('15087','2013-09-13','17:15:00',1.33),('15087','2013-09-13','17:20:00',1.27),('15087','2013-09-13','17:25:00',1.23),('15087','2013-09-13','17:30:00',1.04),('15087','2013-09-13','17:35:00',1.02),('15087','2013-09-12','08:15:00',1.19),('15087','2013-09-12','08:20:00',1.23),('15087','2013-09-12','08:25:00',1.46),('15087','2013-09-12','08:30:00',1.62),('15087','2013-09-12','08:35:00',1.59),('15087','2013-09-12','08:40:00',1),('15087','2013-09-12','08:55:00',1.54),('15087','2013-09-12','09:00:00',1.88),('15087','2013-09-12','09:05:00',1.75),('15087','2013-09-12','09:10:00',1.3),('15087','2013-09-12','09:15:00',2.05),('15087','2013-09-12','09:20:00',2.12),('15087','2013-09-12','09:25:00',2.29),('15087','2013-09-12','09:30:00',2.49),('15087','2013-09-12','09:35:00',2.39),('15087','2013-09-12','09:40:00',1.76),('15087','2013-09-12','09:45:00',2.45),('15087','2013-09-12','09:50:00',2.01),('15087','2013-09-12','09:55:00',1.15),('15087','2013-09-12','10:00:00',1.08),('15087','2013-09-12','10:05:00',1.51),('15087','2013-09-12','10:10:00',1.9),('15087','2013-09-12','10:15:00',1.95),('15087','2013-09-12','10:20:00',1.21),('15087','2013-09-12','10:25:00',1.44),('15087','2013-09-12','10:30:00',2.81),('15087','2013-09-12','10:35:00',1.91),('15087','2013-09-12','10:55:00',2.22),('15087','2013-09-12','11:00:00',2.52),('15087','2013-09-12','11:05:00',3.88),('15087','2013-09-12','11:10:00',2.89),('15087','2013-09-12','11:15:00',2.68),('15087','2013-09-12','11:20:00',1.35),('15087','2013-09-12','11:40:00',1.45),('15087','2013-09-12','11:45:00',2.25),('15087','2013-09-12','11:50:00',1.67),('15087','2013-09-12','11:55:00',2.99),('15087','2013-09-12','12:00:00',3.04),('15087','2013-09-12','12:05:00',4.11),('15087','2013-09-12','12:10:00',2.88),('15087','2013-09-12','12:15:00',2.85),('15087','2013-09-12','12:20:00',1.4),('15087','2013-09-12','12:25:00',2.08),('15087','2013-09-12','12:30:00',1.48),('15087','2013-09-12','12:35:00',3.48),('15087','2013-09-12','12:40:00',3.2),('15087','2013-09-12','12:45:00',1.04),('15087','2013-09-12','12:50:00',2.19),('15087','2013-09-12','12:55:00',2.52),('15087','2013-09-12','13:00:00',4.05),('15087','2013-09-12','13:05:00',2.45),('15087','2013-09-12','13:10:00',2.74),('15087','2013-09-12','13:15:00',4.6),('15087','2013-09-12','13:20:00',4.87),('15087','2013-09-12','13:25:00',4.52),('15087','2013-09-12','13:30:00',3.71),('15087','2013-09-12','13:35:00',2.38),('15087','2013-09-12','13:40:00',3.68),('15087','2013-09-12','13:45:00',2.5),('15087','2013-09-12','13:50:00',4.11),('15087','2013-09-12','13:55:00',4.23),('15087','2013-09-12','14:00:00',3.94),('15087','2013-09-12','14:05:00',3.88),('15087','2013-09-12','14:10:00',3.75),('15087','2013-09-12','14:15:00',3.77),('15087','2013-09-12','14:20:00',4.13),('15087','2013-09-12','14:25:00',3.89),('15087','2013-09-12','14:30:00',4.05),('15087','2013-09-12','14:35:00',1.99),('15087','2013-09-12','14:40:00',3.25),('15087','2013-09-12','14:45:00',3.61),('15087','2013-09-12','14:50:00',3.71),('15087','2013-09-12','14:55:00',3.61),('15087','2013-09-12','15:00:00',3.15),('15087','2013-09-12','15:05:00',2.21),('15087','2013-09-12','15:10:00',2.62),('15087','2013-09-12','15:15:00',3.42),('15087','2013-09-12','15:20:00',3.13),('15087','2013-09-12','15:25:00',2.77),('15087','2013-09-12','15:30:00',3.18),('15087','2013-09-12','15:35:00',3.09),('15087','2013-09-12','15:40:00',3.04),('15087','2013-09-12','15:45:00',2.94),('15087','2013-09-12','15:50:00',2.89),('15087','2013-09-12','15:55:00',2.79),('15087','2013-09-12','16:00:00',2.83),('15087','2013-09-12','16:05:00',1.4),('15087','2013-09-12','16:10:00',2.81),('15087','2013-09-12','16:15:00',1.87),('15087','2013-09-12','16:20:00',1.89),('15087','2013-09-12','16:25:00',1.37),('15087','2013-09-12','16:30:00',2.31),('15087','2013-09-12','16:40:00',2.32),('15087','2013-09-12','16:45:00',2.16),('15087','2013-09-12','16:55:00',1.13),('15087','2013-09-12','17:00:00',1.85),('15087','2013-09-12','17:05:00',1.79),('15087','2013-09-12','17:10:00',1.52),('15087','2013-09-12','17:15:00',1.15),('15087','2013-09-12','17:30:00',1.32),('15087','2013-09-12','17:35:00',1.15),('15087','2013-09-12','17:40:00',1.07),('15087','2013-09-11','08:10:00',1.09),('15087','2013-09-11','08:15:00',1.01),('15087','2013-09-11','08:30:00',1.15),('15087','2013-09-11','08:55:00',1.23),('15087','2013-09-11','09:00:00',1.99),('15087','2013-09-11','09:05:00',2.15),('15087','2013-09-11','09:10:00',1.99),('15087','2013-09-11','09:15:00',2.38),('15087','2013-09-11','09:20:00',2.59),('15087','2013-09-11','09:25:00',1.63),('15087','2013-09-11','09:30:00',1.24),('15087','2013-09-11','09:35:00',2.05),('15087','2013-09-11','09:40:00',1.54),('15087','2013-09-11','10:00:00',1.1),('15087','2013-09-11','10:05:00',2.14),('15087','2013-09-11','10:15:00',3.11),('15087','2013-09-11','10:20:00',2.72),('15087','2013-09-11','10:25:00',2.32),('15087','2013-09-11','10:30:00',3.08),('15087','2013-09-11','10:35:00',2.65),('15087','2013-09-11','10:40:00',2.29),('15087','2013-09-11','10:45:00',2.5),('15087','2013-09-11','10:50:00',2.94),('15087','2013-09-11','10:55:00',1.79),('15087','2013-09-11','11:00:00',1.98),('15087','2013-09-11','11:05:00',2.63),('15087','2013-09-11','11:10:00',3.31),('15087','2013-09-11','11:15:00',3.74),('15087','2013-09-11','11:20:00',3.36),('15087','2013-09-11','11:25:00',1.84),('15087','2013-09-11','11:30:00',2.46),('15087','2013-09-11','11:35:00',2.35),('15087','2013-09-11','11:40:00',4.25),('15087','2013-09-11','11:45:00',4.18),('15087','2013-09-11','11:50:00',4),('15087','2013-09-11','11:55:00',3.23),('15087','2013-09-11','12:00:00',4.2),('15087','2013-09-11','12:05:00',3.54),('15087','2013-09-11','12:10:00',2.58),('15087','2013-09-11','12:15:00',1.99),('15087','2013-09-11','12:20:00',2.17),('15087','2013-09-11','12:25:00',3.64),('15087','2013-09-11','12:30:00',1.94),('15087','2013-09-11','12:35:00',2.93),('15087','2013-09-11','12:40:00',2.08),('15087','2013-09-11','12:45:00',3.35),('15087','2013-09-11','12:50:00',5),('15087','2013-09-11','12:55:00',2.06),('15087','2013-09-11','13:00:00',4.11),('15087','2013-09-11','13:05:00',4.51),('15087','2013-09-11','13:10:00',4.56),('15087','2013-09-11','13:15:00',4.69),('15087','2013-09-11','13:20:00',4.57),('15087','2013-09-11','13:25:00',2.93),('15087','2013-09-11','13:30:00',2.32),('15087','2013-09-11','13:35:00',4.6),('15087','2013-09-11','13:40:00',2.65),('15087','2013-09-11','13:45:00',4.33),('15087','2013-09-11','13:50:00',3.41),('15087','2013-09-11','13:55:00',2.5),('15087','2013-09-11','14:00:00',4.19),('15087','2013-09-11','14:05:00',3.69),('15087','2013-09-11','14:10:00',3.06),('15087','2013-09-11','14:15:00',3.96),('15087','2013-09-11','14:20:00',3.26),('15087','2013-09-11','14:25:00',3.51),('15087','2013-09-11','14:30:00',2.32),('15087','2013-09-11','14:35:00',2.91),('15087','2013-09-11','14:40:00',2.83),('15087','2013-09-11','14:45:00',3.3),('15087','2013-09-11','14:50:00',3.78),('15087','2013-09-11','14:55:00',1.61),('15087','2013-09-11','15:00:00',3.54),('15087','2013-09-11','15:05:00',3.23),('15087','2013-09-11','15:10:00',2.87),('15087','2013-09-11','15:15:00',3.35),('15087','2013-09-11','15:20:00',3.57),('15087','2013-09-11','15:25:00',1.41),('15087','2013-09-11','15:30:00',1.71),('15087','2013-09-11','15:40:00',1.46),('15087','2013-09-11','15:45:00',2.96),('15087','2013-09-11','15:50:00',3.05),('15087','2013-09-11','15:55:00',2.61),('15087','2013-09-11','16:00:00',2.24),('15087','2013-09-11','16:05:00',3.08),('15087','2013-09-11','16:10:00',2.58),('15087','2013-09-11','16:15:00',2.62),('15087','2013-09-11','16:20:00',2.11),('15087','2013-09-11','16:25:00',2.13),('15087','2013-09-11','16:30:00',1.32),('15087','2013-09-11','16:40:00',1.55),('15087','2013-09-11','16:45:00',2.12),('15087','2013-09-11','16:50:00',1.81),('15087','2013-09-11','16:55:00',1.08),('15087','2013-09-11','17:00:00',1.7),('15087','2013-09-11','17:05:00',1.59),('15087','2013-09-11','17:10:00',1.49),('15087','2013-09-11','17:15:00',1.4),('15087','2013-09-11','17:20:00',1.33),('15087','2013-09-11','17:25:00',1.2),('15087','2013-09-11','17:30:00',1.16),('15087','2013-09-11','17:35:00',1.1),('15087','2013-09-10','08:55:00',1.63),('15087','2013-09-10','09:00:00',1.76),('15087','2013-09-10','09:05:00',1.78),('15087','2013-09-10','09:10:00',2.33),('15087','2013-09-10','09:15:00',1.99),('15087','2013-09-10','09:20:00',1.58),('15087','2013-09-10','09:25:00',1.61),('15087','2013-09-10','09:30:00',2.77),('15087','2013-09-10','09:35:00',2.9),('15087','2013-09-10','09:40:00',1.61),('15087','2013-09-10','09:45:00',1.36),('15087','2013-09-10','09:50:00',1.23),('15087','2013-09-10','09:55:00',1.09),('15087','2013-09-10','10:25:00',1.02),('15087','2013-09-10','10:30:00',1),('15087','2013-09-10','10:35:00',1.16),('15087','2013-09-10','10:40:00',1.57),('15087','2013-09-10','10:45:00',2.28),('15087','2013-09-10','10:50:00',1.26),('15087','2013-09-10','10:55:00',1.36),('15087','2013-09-10','11:00:00',1.66),('15087','2013-09-10','11:05:00',1.43),('15087','2013-09-10','11:10:00',1.42),('15087','2013-09-10','11:15:00',1.21),('15087','2013-09-10','11:20:00',1.33),('15087','2013-09-10','11:25:00',1.42),('15087','2013-09-10','11:30:00',1.08),('15087','2013-09-10','11:45:00',1.34),('15087','2013-09-10','11:50:00',1.31),('15087','2013-09-10','11:55:00',1.63),('15087','2013-09-10','12:00:00',1.4),('15087','2013-09-10','12:05:00',1.04),('15087','2013-09-10','12:10:00',1.04),('15087','2013-09-10','12:15:00',1.07),('15087','2013-09-10','13:25:00',1.1),('15087','2013-09-10','13:30:00',1.01),('15087','2013-09-10','13:35:00',1.1),('15087','2013-09-10','13:40:00',1.9),('15087','2013-09-10','13:45:00',2.93),('15087','2013-09-10','13:50:00',1.87),('15087','2013-09-10','13:55:00',1.56),('15087','2013-09-10','14:00:00',1.14),('15087','2013-09-10','14:05:00',1.32),('15087','2013-09-10','14:10:00',1.37),('15087','2013-09-10','14:15:00',1.64),('15087','2013-09-10','14:20:00',1.63),('15087','2013-09-10','14:25:00',2.37),('15087','2013-09-10','14:30:00',2.02),('15087','2013-09-10','14:35:00',1.49),('15087','2013-09-10','14:40:00',1.82),('15087','2013-09-10','14:45:00',1.93),('15087','2013-09-10','14:50:00',2.26),('15087','2013-09-10','14:55:00',1.96),('15087','2013-09-10','15:00:00',2.58),('15087','2013-09-10','15:05:00',2.32),('15087','2013-09-10','15:10:00',1.75),('15087','2013-09-10','15:15:00',1.62),('15087','2013-09-10','15:20:00',2.04),('15087','2013-09-10','15:25:00',1.79),('15087','2013-09-10','15:30:00',2.18),('15087','2013-09-10','15:35:00',1.78),('15087','2013-09-10','15:40:00',1.18),('15087','2013-09-10','15:45:00',1.01),('15087','2013-09-10','15:50:00',1.07),('15087','2013-09-10','15:55:00',1.02),('15087','2013-09-10','16:00:00',1.02),('15087','2013-09-10','16:05:00',1.11),('15087','2013-09-10','16:10:00',1.33),('15087','2013-09-10','16:15:00',1.45),('15087','2013-09-10','16:20:00',1.02),('15087','2013-09-09','08:55:00',1.19),('15087','2013-09-09','09:00:00',1.23),('15087','2013-09-09','09:05:00',1.09),('15087','2013-09-09','09:35:00',1.15),('15087','2013-09-09','10:00:00',1.49),('15087','2013-09-09','10:05:00',1.85),('15087','2013-09-09','10:10:00',1.78),('15087','2013-09-09','10:15:00',1.73),('15087','2013-09-09','10:20:00',1.64),('15087','2013-09-09','10:25:00',1.65),('15087','2013-09-09','10:30:00',1.61),('15087','2013-09-09','10:35:00',1.64),('15087','2013-09-09','10:40:00',1.82),('15087','2013-09-09','10:45:00',2.14),('15087','2013-09-09','10:50:00',2.75),('15087','2013-09-09','10:55:00',2.62),('15087','2013-09-09','11:00:00',2.88),('15087','2013-09-09','11:05:00',2.12),('15087','2013-09-09','11:10:00',2.25),('15087','2013-09-09','11:15:00',2.33),('15087','2013-09-09','11:20:00',2.5),('15087','2013-09-09','11:25:00',2.47),('15087','2013-09-09','11:30:00',2.27),('15087','2013-09-09','11:35:00',2.34),('15087','2013-09-09','11:40:00',3.4),('15087','2013-09-09','11:45:00',3.48),('15087','2013-09-09','11:50:00',3.78),('15087','2013-09-09','11:55:00',2.5),('15087','2013-09-09','12:00:00',3.07),('15087','2013-09-09','12:05:00',3.06),('15087','2013-09-09','12:10:00',3.12),('15087','2013-09-09','12:15:00',2.59),('15087','2013-09-09','12:20:00',1.48),('15087','2013-09-09','12:25:00',1.13),('15087','2013-09-09','12:30:00',1.06),('15087','2013-09-09','12:35:00',1.06),('15087','2013-09-09','12:40:00',1.59),('15087','2013-09-09','12:45:00',1.47),('15087','2013-09-09','12:50:00',1.22),('15087','2013-09-09','12:55:00',1.63),('15087','2013-09-09','13:00:00',1.76),('15087','2013-09-09','13:05:00',2.56),('15087','2013-09-09','13:10:00',2.19),('15087','2013-09-09','13:15:00',3.73),('15087','2013-09-09','13:20:00',3.24),('15087','2013-09-09','13:25:00',2.95),('15087','2013-09-09','13:30:00',3.59),('15087','2013-09-09','13:35:00',4.09),('15087','2013-09-09','13:40:00',3.28),('15087','2013-09-09','13:45:00',4.12),('15087','2013-09-09','13:50:00',3.75),('15087','2013-09-09','13:55:00',4.1),('15087','2013-09-09','14:00:00',3.76),('15087','2013-09-09','14:05:00',3.67),('15087','2013-09-09','14:10:00',3.69),('15087','2013-09-09','14:15:00',2.3),('15087','2013-09-09','14:20:00',2.03),('15087','2013-09-09','14:25:00',1.54),('15087','2013-09-09','14:30:00',2.2),('15087','2013-09-09','14:35:00',3.59),('15087','2013-09-09','14:40:00',3.72),('15087','2013-09-09','14:45:00',2.81),('15087','2013-09-09','14:50:00',3.59),('15087','2013-09-09','14:55:00',2.55),('15087','2013-09-09','15:00:00',2.6),('15087','2013-09-09','15:05:00',2.79),('15087','2013-09-09','15:10:00',2.41),('15087','2013-09-09','15:15:00',1.31),('15087','2013-09-09','15:20:00',2.43),('15087','2013-09-09','15:25:00',1.33),('15087','2013-09-09','15:30:00',2.89),('15087','2013-09-09','15:35:00',2.37),('15087','2013-09-09','15:40:00',2.2),('15087','2013-09-09','15:45:00',1.37),('15087','2013-09-09','15:50:00',1.41),('15087','2013-09-09','15:55:00',1.55),('15087','2013-09-09','16:00:00',1.73),('15087','2013-09-09','16:05:00',1.32),('15087','2013-09-09','16:10:00',1.83),('15087','2013-09-09','16:15:00',2.13),('15087','2013-09-09','16:20:00',1.72),('15087','2013-09-09','16:25:00',1.12),('15087','2013-09-09','16:30:00',1.08),('15087','2013-09-09','16:35:00',1.24),('15087','2013-09-09','16:40:00',1.35),('15087','2013-09-09','16:45:00',1.91),('15087','2013-09-09','17:00:00',1.02),('15087','2014-04-12','09:05:00',1.15),('15087','2014-04-12','09:10:00',1.09),('15087','2014-04-12','09:15:00',1.7),('15087','2014-04-12','09:20:00',2.56),('15087','2014-04-12','09:25:00',2.73),('15087','2014-04-12','09:30:00',1.9),('15087','2014-04-12','09:35:00',1.56),('15087','2014-04-12','09:40:00',1.36),('15087','2014-04-12','09:45:00',1.34),('15087','2014-04-12','09:50:00',1.51),('15087','2014-04-12','09:55:00',1.49),('15087','2014-04-12','10:00:00',1.51),('15087','2014-04-12','10:05:00',1.53),('15087','2014-04-12','10:10:00',1.71),('15087','2014-04-12','10:15:00',1.87),('15087','2014-04-12','10:20:00',2.02),('15087','2014-04-12','10:25:00',2.1),('15087','2014-04-12','10:30:00',2.25),('15087','2014-04-12','10:35:00',2.47),('15087','2014-04-12','10:40:00',2.52),('15087','2014-04-12','10:45:00',2.76),('15087','2014-04-12','10:50:00',2.79),('15087','2014-04-12','10:55:00',3.25),('15087','2014-04-12','11:00:00',3.21),('15087','2014-04-12','11:05:00',2.5),('15087','2014-04-12','11:10:00',2.28),('15087','2014-04-12','11:15:00',3.62),('15087','2014-04-12','11:20:00',4.48),('15087','2014-04-12','11:25:00',3.24),('15087','2014-04-12','11:30:00',3.78),('15087','2014-04-12','11:35:00',4.28),('15087','2014-04-12','11:40:00',3.95),('15087','2014-04-12','11:45:00',3.96),('15087','2014-04-12','11:50:00',3.01),('15087','2014-04-12','11:55:00',3.33),('15087','2014-04-12','12:00:00',3.26),('15087','2014-04-12','12:05:00',1.95),('15087','2014-04-12','12:10:00',1.95),('15087','2014-04-12','12:15:00',1.98),('15087','2014-04-12','12:20:00',3.47),('15087','2014-04-12','12:25:00',3.19),('15087','2014-04-12','12:30:00',3.06),('15087','2014-04-12','12:35:00',2.89),('15087','2014-04-12','12:40:00',3.29),('15087','2014-04-12','12:45:00',2.4),('15087','2014-04-12','12:50:00',2.65),('15087','2014-04-12','12:55:00',2.35),('15087','2014-04-12','13:00:00',2.48),('15087','2014-04-12','13:05:00',3.54),('15087','2014-04-12','13:10:00',3.07),('15087','2014-04-12','13:15:00',4.1),('15087','2014-04-12','13:20:00',4.18),('15087','2014-04-12','13:25:00',4.68),('15087','2014-04-12','13:30:00',2.44),('15087','2014-04-12','13:35:00',1.5),('15087','2014-04-12','13:40:00',2.7),('15087','2014-04-12','13:45:00',4.13),('15087','2014-04-12','13:50:00',1.8),('15087','2014-04-12','13:55:00',3.42),('15087','2014-04-12','14:00:00',4.18),('15087','2014-04-12','14:05:00',4.52),('15087','2014-04-12','14:10:00',3.79),('15087','2014-04-12','14:15:00',2.33),('15087','2014-04-12','14:20:00',3.37),('15087','2014-04-12','14:25:00',1.87),('15087','2014-04-12','14:30:00',3.3),('15087','2014-04-12','14:35:00',1.85),('15087','2014-04-12','14:40:00',1.7),('15087','2014-04-12','14:45:00',3.63),('15087','2014-04-12','14:50:00',4.41),('15087','2014-04-12','14:55:00',3.57),('15087','2014-04-12','15:00:00',2.24),('15087','2014-04-12','15:05:00',3.64),('15087','2014-04-12','15:10:00',3.68),('15087','2014-04-12','15:15:00',3.6),('15087','2014-04-12','15:20:00',2.59),('15087','2014-04-12','15:25:00',2.19),('15087','2014-04-12','15:30:00',2.37),('15087','2014-04-12','15:35:00',2.12),('15087','2014-04-12','15:40:00',2.69),('15087','2014-04-12','15:45:00',3),('15087','2014-04-12','15:50:00',3.26),('15087','2014-04-12','15:55:00',3.18),('15087','2014-04-12','16:00:00',3.14),('15087','2014-04-12','16:05:00',2.94),('15087','2014-04-12','16:10:00',2.85),('15087','2014-04-12','16:15:00',3.17),('15087','2014-04-12','16:20:00',3.15),('15087','2014-04-12','16:25:00',2.77),('15087','2014-04-12','16:30:00',2.69),('15087','2014-04-12','16:35:00',2.29),('15087','2014-04-12','16:40:00',2.25),('15087','2014-04-12','16:45:00',2.32),('15087','2014-04-12','16:50:00',1.65),('15087','2014-04-12','16:55:00',2.27),('15087','2014-04-12','17:00:00',2.22),('15087','2014-04-12','17:05:00',2.08),('15087','2014-04-12','17:10:00',2.04),('15087','2014-04-12','17:15:00',1.92),('15087','2014-04-12','17:20:00',1.46),('15087','2014-04-12','17:25:00',1.72),('15087','2014-04-12','17:30:00',1.6),('15087','2014-04-12','17:35:00',1.26),('15087','2014-04-12','17:40:00',1.71),('15087','2014-04-12','17:45:00',1.68),('15087','2014-04-12','17:50:00',1.44),('15087','2014-04-12','17:55:00',1.28),('15087','2014-04-12','18:00:00',1.01),('15087','2013-09-08','09:05:00',1.09),('15087','2013-09-08','09:10:00',1.12),('15087','2013-09-08','09:15:00',1.2),('15087','2013-09-08','09:20:00',1.2),('15087','2013-09-08','09:25:00',1.53),('15087','2013-09-08','09:30:00',2.11),('15087','2013-09-08','09:35:00',2.33),('15087','2013-09-08','09:40:00',2.24),('15087','2013-09-08','09:45:00',2.5),('15087','2013-09-08','09:50:00',2.54),('15087','2013-09-08','09:55:00',2.56),('15087','2013-09-08','10:00:00',2.65),('15087','2013-09-08','10:05:00',2.75),('15087','2013-09-08','10:10:00',2.83),('15087','2013-09-08','10:15:00',2.87),('15087','2013-09-08','10:20:00',2.93),('15087','2013-09-08','10:25:00',3),('15087','2013-09-08','10:30:00',3.05),('15087','2013-09-08','10:35:00',3.13),('15087','2013-09-08','10:40:00',3.19),('15087','2013-09-08','10:45:00',3.21),('15087','2013-09-08','10:50:00',3.26),('15087','2013-09-08','10:55:00',3.3),('15087','2013-09-08','11:00:00',3.24),('15087','2013-09-08','11:05:00',3.3),('15087','2013-09-08','11:10:00',3.38),('15087','2013-09-08','11:15:00',3.47),('15087','2013-09-08','11:20:00',3.48),('15087','2013-09-08','11:25:00',3.44),('15087','2013-09-08','11:30:00',3.47),('15087','2013-09-08','11:35:00',3.47),('15087','2013-09-08','11:40:00',3.57),('15087','2013-09-08','11:45:00',3.59),('15087','2013-09-08','11:50:00',3.55),('15087','2013-09-08','11:55:00',3.53),('15087','2013-09-08','12:00:00',3.53),('15087','2013-09-08','12:05:00',3.44),('15087','2013-09-08','12:10:00',3.54),('15087','2013-09-08','12:15:00',3.8),('15087','2013-09-08','12:20:00',3.75),('15087','2013-09-08','12:25:00',3.73),('15087','2013-09-08','12:30:00',3.71),('15087','2013-09-08','12:35:00',3.62),('15087','2013-09-08','12:40:00',3.59),('15087','2013-09-08','12:45:00',3.79),('15087','2013-09-08','12:50:00',3.78),('15087','2013-09-08','12:55:00',3.79),('15087','2013-09-08','13:00:00',3.73),('15087','2013-09-08','13:05:00',3.84),('15087','2013-09-08','13:10:00',3.72),('15087','2013-09-08','13:15:00',3.72),('15087','2013-09-08','13:20:00',3.76),('15087','2013-09-08','13:25:00',3.39),('15087','2013-09-08','13:30:00',3.37),('15087','2013-09-08','13:35:00',3.29),('15087','2013-09-08','13:40:00',2.38),('15087','2013-09-08','13:45:00',2.18),('15087','2013-09-08','13:50:00',3.03),('15087','2013-09-08','13:55:00',3.06),('15087','2013-09-08','14:00:00',3.54),('15087','2013-09-08','14:05:00',3.41),('15087','2013-09-08','14:10:00',3.83),('15087','2013-09-08','14:15:00',3.37),('15087','2013-09-08','14:20:00',3.77),('15087','2013-09-08','14:25:00',4.01),('15087','2013-09-08','14:30:00',3.49),('15087','2013-09-08','14:35:00',3.62),('15087','2013-09-08','14:40:00',3.48),('15087','2013-09-08','14:45:00',3.45),('15087','2013-09-08','14:50:00',3.45),('15087','2013-09-08','14:55:00',3.4),('15087','2013-09-08','15:00:00',3.38),('15087','2013-09-08','15:05:00',2.61),('15087','2013-09-08','15:10:00',1.77),('15087','2013-09-08','15:15:00',2.41),('15087','2013-09-08','15:20:00',3.08),('15087','2013-09-08','15:25:00',3.04),('15087','2013-09-08','15:30:00',2.97),('15087','2013-09-08','15:35:00',2.79),('15087','2013-09-08','15:40:00',2.75),('15087','2013-09-08','15:45:00',2.84),('15087','2013-09-08','15:50:00',2.72),('15087','2013-09-08','15:55:00',2.17),('15087','2013-09-08','16:00:00',2.3),('15087','2013-09-08','16:05:00',2.32),('15087','2013-09-08','16:10:00',2.1),('15087','2013-09-08','16:15:00',2.31),('15087','2013-09-08','16:20:00',1.98),('15087','2013-09-08','16:25:00',1.96),('15087','2013-09-08','16:30:00',2.08),('15087','2013-09-08','16:35:00',1.88),('15087','2013-09-08','16:40:00',1.6),('15087','2013-09-08','16:45:00',1.18),('15087','2013-09-08','16:50:00',1.13),('15087','2013-09-08','16:55:00',1.04),('15087','2013-09-08','17:00:00',1.36),('15087','2013-09-08','17:05:00',1.79),('15087','2013-09-08','17:10:00',1.67),('15087','2013-09-08','17:15:00',1.47),('15087','2013-09-08','17:20:00',1.24),('15087','2013-09-08','17:25:00',1.24),('15087','2013-09-08','17:30:00',1.13),('15087','2013-09-07','08:20:00',1.07),('15087','2013-09-07','08:25:00',1.16),('15087','2013-09-07','08:30:00',1.25),('15087','2013-09-07','08:35:00',1.34),('15087','2013-09-07','08:40:00',1.41),('15087','2013-09-07','08:45:00',1.49),('15087','2013-09-07','08:50:00',1.57),('15087','2013-09-07','08:55:00',1.67),('15087','2013-09-07','09:00:00',1.75),('15087','2013-09-07','09:05:00',1.85),('15087','2013-09-07','09:10:00',1.93),('15087','2013-09-07','09:15:00',2.04),('15087','2013-09-07','09:20:00',2.14),('15087','2013-09-07','09:25:00',2.25),('15087','2013-09-07','09:30:00',2.36),('15087','2013-09-07','09:35:00',2.44),('15087','2013-09-07','09:40:00',2.51),('15087','2013-09-07','09:45:00',2.56),('15087','2013-09-07','09:50:00',2.63),('15087','2013-09-07','09:55:00',2.71),('15087','2013-09-07','10:00:00',2.78),('15087','2013-09-07','10:05:00',2.84),('15087','2013-09-07','10:10:00',2.87),('15087','2013-09-07','10:15:00',2.91),('15087','2013-09-07','10:20:00',3.01),('15087','2013-09-07','10:25:00',3.07),('15087','2013-09-07','10:30:00',3.1),('15087','2013-09-07','10:35:00',3.17),('15087','2013-09-07','10:40:00',3.23),('15087','2013-09-07','10:45:00',3.27),('15087','2013-09-07','10:50:00',3.32),('15087','2013-09-07','10:55:00',3.37),('15087','2013-09-07','11:00:00',3.41),('15087','2013-09-07','11:05:00',3.4),('15087','2013-09-07','11:10:00',3.49),('15087','2013-09-07','11:15:00',3.53),('15087','2013-09-07','11:20:00',3.57),('15087','2013-09-07','11:25:00',3.62),('15087','2013-09-07','11:30:00',3.67),('15087','2013-09-07','11:35:00',3.71),('15087','2013-09-07','11:40:00',3.76),('15087','2013-09-07','11:45:00',3.78),('15087','2013-09-07','11:50:00',3.8),('15087','2013-09-07','11:55:00',3.83),('15087','2013-09-07','12:00:00',3.85),('15087','2013-09-07','12:05:00',3.87),('15087','2013-09-07','12:10:00',3.89),('15087','2013-09-07','12:15:00',3.88),('15087','2013-09-07','12:20:00',3.91),('15087','2013-09-07','12:25:00',3.9),('15087','2013-09-07','12:30:00',3.9),('15087','2013-09-07','12:35:00',3.92),('15087','2013-09-07','12:40:00',3.92),('15087','2013-09-07','12:45:00',3.91),('15087','2013-09-07','12:50:00',3.95),('15087','2013-09-07','12:55:00',3.85),('15087','2013-09-07','13:00:00',3.89),('15087','2013-09-07','13:05:00',3.96),('15087','2013-09-07','13:10:00',3.95),('15087','2013-09-07','13:15:00',3.95),('15087','2013-09-07','13:20:00',4),('15087','2013-09-07','13:25:00',3.97),('15087','2013-09-07','13:30:00',4.05),('15087','2013-09-07','13:35:00',4),('15087','2013-09-07','13:40:00',3.84),('15087','2013-09-07','13:45:00',3.91),('15087','2013-09-07','13:50:00',3.81),('15087','2013-09-07','13:55:00',3.7),('15087','2013-09-07','14:00:00',3.95),('15087','2013-09-07','14:05:00',3.92),('15087','2013-09-07','14:10:00',3.83),('15087','2013-09-07','14:15:00',3.73),('15087','2013-09-07','14:20:00',3.49),('15087','2013-09-07','14:25:00',3.63),('15087','2013-09-07','14:30:00',3.58),('15087','2013-09-07','14:35:00',3.54),('15087','2013-09-07','14:40:00',3.55),('15087','2013-09-07','14:45:00',3.54),('15087','2013-09-07','14:50:00',3.4),('15087','2013-09-07','14:55:00',3.41),('15087','2013-09-07','15:00:00',3.38),('15087','2013-09-07','15:05:00',3.3),('15087','2013-09-07','15:10:00',3.22),('15087','2013-09-07','15:15:00',3.21),('15087','2013-09-07','15:20:00',3.15),('15087','2013-09-07','15:25:00',3.1),('15087','2013-09-07','15:30:00',3.05),('15087','2013-09-07','15:35:00',2.99),('15087','2013-09-07','15:40:00',2.88),('15087','2013-09-07','15:45:00',2.84),('15087','2013-09-07','15:50:00',2.78),('15087','2013-09-07','15:55:00',2.71),('15087','2013-09-07','16:00:00',2.67),('15087','2013-09-07','16:05:00',2.6),('15087','2013-09-07','16:10:00',2.53),('15087','2013-09-07','16:15:00',2.46),('15087','2013-09-07','16:20:00',2.36),('15087','2013-09-07','16:25:00',2.27),('15087','2013-09-07','16:30:00',2.15),('15087','2013-09-07','16:35:00',2),('15087','2013-09-07','16:40:00',1.98),('15087','2013-09-07','16:45:00',1.94),('15087','2013-09-07','16:50:00',1.83),('15087','2013-09-07','16:55:00',1.76),('15087','2013-09-07','17:00:00',1.64),('15087','2013-09-07','17:05:00',1.51),('15087','2013-09-07','17:10:00',1.46),('15087','2013-09-07','17:15:00',1.38),('15087','2013-09-07','17:20:00',1.28),('15087','2013-09-07','17:25:00',1.2),('15087','2013-09-07','17:30:00',1.09),('15087','2013-09-07','17:35:00',1.04),('15087','2013-09-06','08:15:00',1.03),('15087','2013-09-06','08:20:00',1.11),('15087','2013-09-06','08:25:00',1.2),('15087','2013-09-06','08:30:00',1.28),('15087','2013-09-06','08:35:00',1.37),('15087','2013-09-06','08:40:00',1.47),('15087','2013-09-06','08:45:00',1.56),('15087','2013-09-06','08:50:00',1.62),('15087','2013-09-06','08:55:00',1.74),('15087','2013-09-06','09:00:00',1.81),('15087','2013-09-06','09:05:00',1.93),('15087','2013-09-06','09:10:00',2),('15087','2013-09-06','09:15:00',2.12),('15087','2013-09-06','09:20:00',2.22),('15087','2013-09-06','09:25:00',2.3),('15087','2013-09-06','09:30:00',2.39),('15087','2013-09-06','09:35:00',2.46),('15087','2013-09-06','09:40:00',2.57),('15087','2013-09-06','09:45:00',2.64),('15087','2013-09-06','09:50:00',2.69),('15087','2013-09-06','09:55:00',2.75),('15087','2013-09-06','10:00:00',2.81),('15087','2013-09-06','10:05:00',2.88),('15087','2013-09-06','10:10:00',2.94),('15087','2013-09-06','10:15:00',3),('15087','2013-09-06','10:20:00',3.05),('15087','2013-09-06','10:25:00',3.12),('15087','2013-09-06','10:30:00',3.18),('15087','2013-09-06','10:35:00',3.25),('15087','2013-09-06','10:40:00',3.35),('15087','2013-09-06','10:45:00',3.38),('15087','2013-09-06','10:50:00',3.4),('15087','2013-09-06','10:55:00',3.44),('15087','2013-09-06','11:00:00',3.5),('15087','2013-09-06','11:05:00',3.47),('15087','2013-09-06','11:10:00',3.6),('15087','2013-09-06','11:15:00',3.63),('15087','2013-09-06','11:20:00',3.65),('15087','2013-09-06','11:25:00',3.68),('15087','2013-09-06','11:30:00',3.71),('15087','2013-09-06','11:35:00',3.75),('15087','2013-09-06','11:40:00',3.8),('15087','2013-09-06','11:45:00',3.81),('15087','2013-09-06','11:50:00',3.84),('15087','2013-09-06','11:55:00',3.87),('15087','2013-09-06','12:00:00',3.83),('15087','2013-09-06','12:05:00',3.83),('15087','2013-09-06','12:10:00',3.88),('15087','2013-09-06','12:15:00',3.97),('15087','2013-09-06','12:20:00',3.99),('15087','2013-09-06','12:25:00',4.02),('15087','2013-09-06','12:30:00',4.03),('15087','2013-09-06','12:35:00',4.04),('15087','2013-09-06','12:40:00',4.06),('15087','2013-09-06','12:45:00',4.07),('15087','2013-09-06','12:50:00',4.03),('15087','2013-09-06','12:55:00',4.03),('15087','2013-09-06','13:00:00',4.04),('15087','2013-09-06','13:05:00',4.04),('15087','2013-09-06','13:10:00',4.02),('15087','2013-09-06','13:15:00',4.02),('15087','2013-09-06','13:20:00',3.99),('15087','2013-09-06','13:25:00',3.99),('15087','2013-09-06','13:30:00',3.96),('15087','2013-09-06','13:35:00',3.99),('15087','2013-09-06','13:40:00',3.98),('15087','2013-09-06','13:45:00',3.94),('15087','2013-09-06','13:50:00',3.81),('15087','2013-09-06','13:55:00',3.79),('15087','2013-09-06','14:00:00',3.77),('15087','2013-09-06','14:05:00',3.76),('15087','2013-09-06','14:10:00',3.7),('15087','2013-09-06','14:15:00',3.69),('15087','2013-09-06','14:20:00',3.67),('15087','2013-09-06','14:25:00',3.66),('15087','2013-09-06','14:30:00',3.48),('15087','2013-09-06','14:35:00',3.37),('15087','2013-09-06','14:40:00',3.46),('15087','2013-09-06','14:45:00',3.4),('15087','2013-09-06','14:50:00',3.38),('15087','2013-09-06','14:55:00',3.43),('15087','2013-09-06','15:00:00',3.38),('15087','2013-09-06','15:05:00',3.3),('15087','2013-09-06','15:10:00',3.12),('15087','2013-09-06','15:15:00',3.02),('15087','2013-09-06','15:20:00',2.79),('15087','2013-09-06','15:25:00',2.97),('15087','2013-09-06','15:30:00',2.63),('15087','2013-09-06','15:35:00',2.64),('15087','2013-09-06','15:40:00',2.82),('15087','2013-09-06','15:45:00',2.83),('15087','2013-09-06','15:50:00',2.76),('15087','2013-09-06','15:55:00',2.71),('15087','2013-09-06','16:00:00',2.64),('15087','2013-09-06','16:05:00',2.59),('15087','2013-09-06','16:10:00',2.49),('15087','2013-09-06','16:15:00',2.46),('15087','2013-09-06','16:20:00',2.37),('15087','2013-09-06','16:25:00',2.32),('15087','2013-09-06','16:30:00',2.2),('15087','2013-09-06','16:35:00',2.08),('15087','2013-09-06','16:40:00',2.06),('15087','2013-09-06','16:45:00',1.94),('15087','2013-09-06','16:50:00',1.88),('15087','2013-09-06','16:55:00',1.8),('15087','2013-09-06','17:00:00',1.73),('15087','2013-09-06','17:05:00',1.56),('15087','2013-09-06','17:10:00',1.49),('15087','2013-09-06','17:15:00',1.42),('15087','2013-09-06','17:20:00',1.27),('15087','2013-09-06','17:25:00',1.19),('15087','2013-09-06','17:30:00',1.14),('15087','2013-09-06','17:35:00',1.07),('15087','2013-09-06','17:40:00',1.04),('15087','2013-09-05','08:10:00',1.04),('15087','2013-09-05','08:15:00',1.14),('15087','2013-09-05','08:20:00',1.23),('15087','2013-09-05','08:25:00',1.33),('15087','2013-09-05','08:30:00',1.42),('15087','2013-09-05','08:35:00',1.51),('15087','2013-09-05','08:40:00',1.6),('15087','2013-09-05','08:45:00',1.71),('15087','2013-09-05','08:50:00',1.79),('15087','2013-09-05','08:55:00',1.89),('15087','2013-09-05','09:00:00',1.98),('15087','2013-09-05','09:05:00',2.06),('15087','2013-09-05','09:10:00',2.18),('15087','2013-09-05','09:15:00',2.31),('15087','2013-09-05','09:20:00',2.4),('15087','2013-09-05','09:25:00',2.49),('15087','2013-09-05','09:30:00',2.55),('15087','2013-09-05','09:35:00',2.6),('15087','2013-09-05','09:40:00',2.69),('15087','2013-09-05','09:45:00',2.76),('15087','2013-09-05','09:50:00',2.85),('15087','2013-09-05','09:55:00',2.93),('15087','2013-09-05','10:00:00',2.98),('15087','2013-09-05','10:05:00',3.05),('15087','2013-09-05','10:10:00',3.11),('15087','2013-09-05','10:15:00',3.17),('15087','2013-09-05','10:20:00',3.22),('15087','2013-09-05','10:25:00',3.27),('15087','2013-09-05','10:30:00',3.32),('15087','2013-09-05','10:35:00',3.39),('15087','2013-09-05','10:40:00',3.43),('15087','2013-09-05','10:45:00',3.49),('15087','2013-09-05','10:50:00',3.51),('15087','2013-09-05','10:55:00',3.57),('15087','2013-09-05','11:00:00',3.62),('15087','2013-09-05','11:05:00',3.68),('15087','2013-09-05','11:10:00',3.72),('15087','2013-09-05','11:15:00',3.73),('15087','2013-09-05','11:20:00',3.74),('15087','2013-09-05','11:25:00',3.82),('15087','2013-09-05','11:30:00',3.83),('15087','2013-09-05','11:35:00',3.83),('15087','2013-09-05','11:40:00',3.82),('15087','2013-09-05','11:45:00',3.84),('15087','2013-09-05','11:50:00',3.86),('15087','2013-09-05','11:55:00',3.97),('15087','2013-09-05','12:00:00',3.96),('15087','2013-09-05','12:05:00',3.98),('15087','2013-09-05','12:10:00',4.04),('15087','2013-09-05','12:15:00',4.07),('15087','2013-09-05','12:20:00',4.04),('15087','2013-09-05','12:25:00',4.08),('15087','2013-09-05','12:30:00',4.09),('15087','2013-09-05','12:35:00',4.11),('15087','2013-09-05','12:40:00',4.11),('15087','2013-09-05','12:45:00',4.13),('15087','2013-09-05','12:50:00',4.15),('15087','2013-09-05','12:55:00',4.16),('15087','2013-09-05','13:00:00',4.13),('15087','2013-09-05','13:05:00',4.12),('15087','2013-09-05','13:10:00',4.14),('15087','2013-09-05','13:15:00',4.14),('15087','2013-09-05','13:20:00',4.15),('15087','2013-09-05','13:25:00',4.16),('15087','2013-09-05','13:30:00',4.17),('15087','2013-09-05','13:35:00',4.13),('15087','2013-09-05','13:40:00',4.12),('15087','2013-09-05','13:45:00',4.05),('15087','2013-09-05','13:50:00',3.94),('15087','2013-09-05','13:55:00',3.96),('15087','2013-09-05','14:00:00',3.94),('15087','2013-09-05','14:05:00',3.9),('15087','2013-09-05','14:10:00',3.87),('15087','2013-09-05','14:15:00',3.68),('15087','2013-09-05','14:20:00',3.75),('15087','2013-09-05','14:25:00',3.75),('15087','2013-09-05','14:30:00',3.65),('15087','2013-09-05','14:35:00',3.5),('15087','2013-09-05','14:40:00',3.61),('15087','2013-09-05','14:45:00',3.58),('15087','2013-09-05','14:50:00',3.5),('15087','2013-09-05','14:55:00',3.49),('15087','2013-09-05','15:00:00',3.47),('15087','2013-09-05','15:05:00',3.41),('15087','2013-09-05','15:10:00',3.26),('15087','2013-09-05','15:15:00',3.11),('15087','2013-09-05','15:20:00',2.97),('15087','2013-09-05','15:25:00',3.11),('15087','2013-09-05','15:30:00',2.99),('15087','2013-09-05','15:35:00',3.01),('15087','2013-09-05','15:40:00',2.98),('15087','2013-09-05','15:45:00',2.93),('15087','2013-09-05','15:50:00',2.88),('15087','2013-09-05','15:55:00',2.84),('15087','2013-09-05','16:00:00',2.76),('15087','2013-09-05','16:05:00',2.72),('15087','2013-09-05','16:10:00',2.66),('15087','2013-09-05','16:15:00',2.6),('15087','2013-09-05','16:20:00',2.5),('15087','2013-09-05','16:25:00',2.44),('15087','2013-09-05','16:30:00',2.28),('15087','2013-09-05','16:35:00',2.28),('15087','2013-09-05','16:40:00',2.23),('15087','2013-09-05','16:45:00',2.19),('15087','2013-09-05','16:50:00',1.8),('15087','2013-09-05','16:55:00',1.42),('15087','2013-09-05','17:00:00',1.13),('15087','2013-09-05','17:05:00',1.24),('15087','2013-09-05','17:10:00',1.24),('15087','2013-09-05','17:15:00',1.11),('15087','2013-09-05','17:20:00',1.23),('15087','2013-09-05','17:25:00',1.24),('15087','2013-09-05','17:30:00',1.24),('15087','2013-09-05','17:35:00',1.31),('15087','2013-09-05','17:40:00',1.36),('15087','2013-09-05','17:45:00',1.16),('15087','2013-09-05','17:50:00',1.06),('15087','2013-09-04','08:10:00',1.05),('15087','2013-09-04','08:15:00',1.14),('15087','2013-09-04','08:20:00',1.23),('15087','2013-09-04','08:25:00',1.32),('15087','2013-09-04','08:30:00',1.42),('15087','2013-09-04','08:35:00',1.5),('15087','2013-09-04','08:40:00',1.59),('15087','2013-09-04','08:45:00',1.68),('15087','2013-09-04','08:50:00',1.78),('15087','2013-09-04','08:55:00',1.87),('15087','2013-09-04','09:00:00',1.97),('15087','2013-09-04','09:05:00',2.07),('15087','2013-09-04','09:10:00',2.18),('15087','2013-09-04','09:15:00',2.32),('15087','2013-09-04','09:20:00',2.42),('15087','2013-09-04','09:25:00',2.53),('15087','2013-09-04','09:30:00',2.62),('15087','2013-09-04','09:35:00',2.72),('15087','2013-09-04','09:40:00',2.81),('15087','2013-09-04','09:45:00',2.86),('15087','2013-09-04','09:50:00',2.94),('15087','2013-09-04','09:55:00',3.02),('15087','2013-09-04','10:00:00',3.11),('15087','2013-09-04','10:05:00',3.15),('15087','2013-09-04','10:10:00',3.23),('15087','2013-09-04','10:15:00',3.27),('15087','2013-09-04','10:20:00',3.33),('15087','2013-09-04','10:25:00',3.4),('15087','2013-09-04','10:30:00',3.46),('15087','2013-09-04','10:35:00',3.52),('15087','2013-09-04','10:40:00',3.59),('15087','2013-09-04','10:45:00',3.63),('15087','2013-09-04','10:50:00',3.67),('15087','2013-09-04','10:55:00',3.73),('15087','2013-09-04','11:00:00',3.78),('15087','2013-09-04','11:05:00',3.84),('15087','2013-09-04','11:10:00',3.88),('15087','2013-09-04','11:15:00',3.88),('15087','2013-09-04','11:20:00',3.94),('15087','2013-09-04','11:25:00',3.97),('15087','2013-09-04','11:30:00',4),('15087','2013-09-04','11:35:00',4.05),('15087','2013-09-04','11:40:00',4.11),('15087','2013-09-04','11:45:00',4.13),('15087','2013-09-04','11:50:00',4.15),('15087','2013-09-04','11:55:00',4.17),('15087','2013-09-04','12:00:00',4.19),('15087','2013-09-04','12:05:00',4.19),('15087','2013-09-04','12:10:00',4.25),('15087','2013-09-04','12:15:00',4.23),('15087','2013-09-04','12:20:00',4.22),('15087','2013-09-04','12:25:00',4.28),('15087','2013-09-04','12:30:00',4.29),('15087','2013-09-04','12:35:00',4.3),('15087','2013-09-04','12:40:00',4.34),('15087','2013-09-04','12:45:00',4.35),('15087','2013-09-04','12:50:00',4.29),('15087','2013-09-04','12:55:00',4.33),('15087','2013-09-04','13:00:00',4.35),('15087','2013-09-04','13:05:00',4.32),('15087','2013-09-04','13:10:00',4.34),('15087','2013-09-04','13:15:00',4.36),('15087','2013-09-04','13:20:00',4.33),('15087','2013-09-04','13:25:00',4.31),('15087','2013-09-04','13:30:00',4.29),('15087','2013-09-04','13:35:00',4.31),('15087','2013-09-04','13:40:00',4.3),('15087','2013-09-04','13:45:00',4.29),('15087','2013-09-04','13:50:00',4.19),('15087','2013-09-04','13:55:00',3.93),('15087','2013-09-04','14:00:00',4.01),('15087','2013-09-04','14:05:00',4.08),('15087','2013-09-04','14:10:00',4.08),('15087','2013-09-04','14:15:00',4.02),('15087','2013-09-04','14:20:00',3.96),('15087','2013-09-04','14:25:00',3.95),('15087','2013-09-04','14:30:00',3.87),('15087','2013-09-04','14:35:00',3.72),('15087','2013-09-04','14:40:00',3.82),('15087','2013-09-04','14:45:00',3.78),('15087','2013-09-04','14:50:00',3.71),('15087','2013-09-04','14:55:00',3.49),('15087','2013-09-04','15:00:00',3.51),('15087','2013-09-04','15:05:00',3.48),('15087','2013-09-04','15:10:00',3.41),('15087','2013-09-04','15:15:00',3.29),('15087','2013-09-04','15:20:00',3.21),('15087','2013-09-04','15:25:00',3.29),('15087','2013-09-04','15:30:00',3.17),('15087','2013-09-04','15:35:00',3.05),('15087','2013-09-04','15:40:00',3.09),('15087','2013-09-04','15:45:00',3.04),('15087','2013-09-04','15:50:00',2.98),('15087','2013-09-04','15:55:00',2.92),('15087','2013-09-04','16:00:00',2.84),('15087','2013-09-04','16:05:00',2.77),('15087','2013-09-04','16:10:00',2.71),('15087','2013-09-04','16:15:00',2.65),('15087','2013-09-04','16:20:00',2.59),('15087','2013-09-04','16:25:00',2.51),('15087','2013-09-04','16:30:00',2.45),('15087','2013-09-04','16:35:00',2.38),('15087','2013-09-04','16:40:00',2.28),('15087','2013-09-04','16:45:00',2.2),('15087','2013-09-04','16:50:00',2.08),('15087','2013-09-04','16:55:00',2),('15087','2013-09-04','17:00:00',1.93),('15087','2013-09-04','17:05:00',1.76),('15087','2013-09-04','17:10:00',1.66),('15087','2013-09-04','17:15:00',1.5),('15087','2013-09-04','17:20:00',1.4),('15087','2013-09-04','17:25:00',1.36),('15087','2013-09-04','17:30:00',1.26),('15087','2013-09-04','17:35:00',1.19),('15087','2013-09-04','17:40:00',1.08),('15087','2013-09-03','08:15:00',1.03),('15087','2013-09-03','08:20:00',1.11),('15087','2013-09-03','08:25:00',1.19),('15087','2013-09-03','08:30:00',1.28),('15087','2013-09-03','08:35:00',1.37),('15087','2013-09-03','08:40:00',1.45),('15087','2013-09-03','08:45:00',1.54),('15087','2013-09-03','08:50:00',1.62),('15087','2013-09-03','08:55:00',1.74),('15087','2013-09-03','09:00:00',1.81),('15087','2013-09-03','09:05:00',1.88),('15087','2013-09-03','09:10:00',1.98),('15087','2013-09-03','09:15:00',2.08),('15087','2013-09-03','09:20:00',2.26),('15087','2013-09-03','09:25:00',2.35),('15087','2013-09-03','09:30:00',2.45),('15087','2013-09-03','09:35:00',2.53),('15087','2013-09-03','09:40:00',2.6),('15087','2013-09-03','09:45:00',2.68),('15087','2013-09-03','09:50:00',2.74),('15087','2013-09-03','09:55:00',2.79),('15087','2013-09-03','10:00:00',2.86),('15087','2013-09-03','10:05:00',2.92),('15087','2013-09-03','10:10:00',2.99),('15087','2013-09-03','10:15:00',3.06),('15087','2013-09-03','10:20:00',3.16),('15087','2013-09-03','10:25:00',3.23),('15087','2013-09-03','10:30:00',3.28),('15087','2013-09-03','10:35:00',3.36),('15087','2013-09-03','10:40:00',3.46),('15087','2013-09-03','10:45:00',3.52),('15087','2013-09-03','10:50:00',3.55),('15087','2013-09-03','10:55:00',3.6),('15087','2013-09-03','11:00:00',3.64),('15087','2013-09-03','11:05:00',3.68),('15087','2013-09-03','11:10:00',3.72),('15087','2013-09-03','11:15:00',3.76),('15087','2013-09-03','11:20:00',3.76),('15087','2013-09-03','11:25:00',3.82),('15087','2013-09-03','11:30:00',3.86),('15087','2013-09-03','11:35:00',3.9),('15087','2013-09-03','11:40:00',3.92),('15087','2013-09-03','11:45:00',3.95),('15087','2013-09-03','11:50:00',3.97),('15087','2013-09-03','11:55:00',4.02),('15087','2013-09-03','12:00:00',4.06),('15087','2013-09-03','12:05:00',4.08),('15087','2013-09-03','12:10:00',4.09),('15087','2013-09-03','12:15:00',4.15),('15087','2013-09-03','12:20:00',4.18),('15087','2013-09-03','12:25:00',4.18),('15087','2013-09-03','12:30:00',4.19),('15087','2013-09-03','12:35:00',4.19),('15087','2013-09-03','12:40:00',4.21),('15087','2013-09-03','12:45:00',4.22),('15087','2013-09-03','12:50:00',4.21),('15087','2013-09-03','12:55:00',4.23),('15087','2013-09-03','13:00:00',4.24),('15087','2013-09-03','13:05:00',4.23),('15087','2013-09-03','13:10:00',4.24),('15087','2013-09-03','13:15:00',4.25),('15087','2013-09-03','13:20:00',4.22),('15087','2013-09-03','13:25:00',4.17),('15087','2013-09-03','13:30:00',4.17),('15087','2013-09-03','13:35:00',4.14),('15087','2013-09-03','13:40:00',4.17),('15087','2013-09-03','13:45:00',4.13),('15087','2013-09-03','13:50:00',4.15),('15087','2013-09-03','13:55:00',3.92),('15087','2013-09-03','14:00:00',3.88),('15087','2013-09-03','14:05:00',3.87),('15087','2013-09-03','14:10:00',3.92),('15087','2013-09-03','14:15:00',3.73),('15087','2013-09-03','14:20:00',3.72),('15087','2013-09-03','14:25:00',3.84),('15087','2013-09-03','14:30:00',3.82),('15087','2013-09-03','14:35:00',3.73),('15087','2013-09-03','14:40:00',3.75),('15087','2013-09-03','14:45:00',3.7),('15087','2013-09-03','14:50:00',3.68),('15087','2013-09-03','14:55:00',3.53),('15087','2013-09-03','15:00:00',3.43),('15087','2013-09-03','15:05:00',3.42),('15087','2013-09-03','15:10:00',3.35),('15087','2013-09-03','15:15:00',3.3),('15087','2013-09-03','15:20:00',3.13),('15087','2013-09-03','15:25:00',3.2),('15087','2013-09-03','15:30:00',3.12),('15087','2013-09-03','15:35:00',2.98),('15087','2013-09-03','15:40:00',3),('15087','2013-09-03','15:45:00',2.92),('15087','2013-09-03','15:50:00',2.9),('15087','2013-09-03','15:55:00',2.85),('15087','2013-09-03','16:00:00',2.81),('15087','2013-09-03','16:05:00',2.77),('15087','2013-09-03','16:10:00',2.63),('15087','2013-09-03','16:15:00',2.43),('15087','2013-09-03','16:20:00',2.39),('15087','2013-09-03','16:25:00',2.47),('15087','2013-09-03','16:30:00',2.38),('15087','2013-09-03','16:35:00',2.35),('15087','2013-09-03','16:40:00',2.26),('15087','2013-09-03','16:45:00',2.19),('15087','2013-09-03','16:50:00',2.06),('15087','2013-09-03','16:55:00',1.97),('15087','2013-09-03','17:00:00',1.89),('15087','2013-09-03','17:05:00',1.75),('15087','2013-09-03','17:10:00',1.64),('15087','2013-09-03','17:15:00',1.5),('15087','2013-09-03','17:20:00',1.39),('15087','2013-09-03','17:25:00',1.39),('15087','2013-09-03','17:30:00',1.3),('15087','2013-09-03','17:35:00',1.17),('15087','2013-09-03','17:40:00',1.12),('15087','2013-09-02','08:15:00',1.08),('15087','2013-09-02','08:20:00',1.16),('15087','2013-09-02','08:25:00',1.24),('15087','2013-09-02','08:30:00',1.33),('15087','2013-09-02','08:35:00',1.43),('15087','2013-09-02','08:40:00',1.53),('15087','2013-09-02','08:45:00',1.61),('15087','2013-09-02','08:50:00',1.7),('15087','2013-09-02','08:55:00',1.79),('15087','2013-09-02','09:00:00',1.89),('15087','2013-09-02','09:05:00',2.06),('15087','2013-09-02','09:10:00',2.13),('15087','2013-09-02','09:15:00',2.24),('15087','2013-09-02','09:20:00',2.34),('15087','2013-09-02','09:25:00',2.42),('15087','2013-09-02','09:30:00',2.5),('15087','2013-09-02','09:35:00',2.59),('15087','2013-09-02','09:40:00',2.66),('15087','2013-09-02','09:45:00',2.74),('15087','2013-09-02','09:50:00',2.82),('15087','2013-09-02','09:55:00',2.88),('15087','2013-09-02','10:00:00',2.95),('15087','2013-09-02','10:05:00',3.02),('15087','2013-09-02','10:10:00',3.08),('15087','2013-09-02','10:15:00',3.14),('15087','2013-09-02','10:20:00',3.23),('15087','2013-09-02','10:25:00',3.29),('15087','2013-09-02','10:30:00',3.34),('15087','2013-09-02','10:35:00',3.39),('15087','2013-09-02','10:40:00',3.45),('15087','2013-09-02','10:45:00',3.51),('15087','2013-09-02','10:50:00',3.55),('15087','2013-09-02','10:55:00',3.58),('15087','2013-09-02','11:00:00',3.62),('15087','2013-09-02','11:05:00',3.69),('15087','2013-09-02','11:10:00',3.73),('15087','2013-09-02','11:15:00',3.76),('15087','2013-09-02','11:20:00',3.77),('15087','2013-09-02','11:25:00',3.79),('15087','2013-09-02','11:30:00',3.84),('15087','2013-09-02','11:35:00',3.87),('15087','2013-09-02','11:40:00',3.93),('15087','2013-09-02','11:45:00',3.93),('15087','2013-09-02','11:50:00',3.95),('15087','2013-09-02','11:55:00',3.99),('15087','2013-09-02','12:00:00',3.99),('15087','2013-09-02','12:05:00',4.01),('15087','2013-09-02','12:10:00',4.07),('15087','2013-09-02','12:15:00',4.1),('15087','2013-09-02','12:20:00',4.09),('15087','2013-09-02','12:25:00',4.12),('15087','2013-09-02','12:30:00',4.04),('15087','2013-09-02','12:35:00',4.1),('15087','2013-09-02','12:40:00',4.12),('15087','2013-09-02','12:45:00',4.1),('15087','2013-09-02','12:50:00',4.17),('15087','2013-09-02','12:55:00',4.19),('15087','2013-09-02','13:00:00',4.18),('15087','2013-09-02','13:05:00',4.15),('15087','2013-09-02','13:10:00',4.16),('15087','2013-09-02','13:15:00',4.13),('15087','2013-09-02','13:20:00',4.11),('15087','2013-09-02','13:25:00',4.11),('15087','2013-09-02','13:30:00',4.04),('15087','2013-09-02','13:35:00',4.06),('15087','2013-09-02','13:40:00',4.11),('15087','2013-09-02','13:45:00',4.07),('15087','2013-09-02','13:50:00',3.07),('15087','2013-09-02','14:00:00',4.16),('15087','2013-09-02','14:05:00',4.17),('15087','2013-09-02','14:10:00',4.07),('15087','2013-09-02','14:15:00',3.93),('15087','2013-09-02','14:20:00',3.83),('15087','2013-09-02','14:25:00',3.82),('15087','2013-09-02','14:30:00',3.85),('15087','2013-09-02','14:35:00',3.73),('15087','2013-09-02','14:40:00',3.6),('15087','2013-09-02','14:45:00',3.73),('15087','2013-09-02','14:50:00',3.52),('15087','2013-09-02','14:55:00',1.68),('15087','2013-09-02','15:00:00',1.48),('15087','2013-09-02','15:05:00',3.35),('15087','2013-09-02','15:10:00',2.33),('15087','2013-09-02','15:15:00',1.72),('15087','2013-09-02','15:25:00',2.36),('15087','2013-09-02','15:30:00',3.14),('15087','2013-09-02','15:35:00',3.1),('15087','2013-09-02','15:40:00',2.72),('15087','2013-09-02','15:45:00',2.88),('15087','2013-09-02','15:50:00',2.94),('15087','2013-09-02','15:55:00',2.83),('15087','2013-09-02','16:00:00',2.67),('15087','2013-09-02','16:05:00',2.7),('15087','2013-09-02','16:10:00',2.69),('15087','2013-09-02','16:15:00',2.58),('15087','2013-09-02','16:20:00',2.61),('15087','2013-09-02','16:25:00',2.54),('15087','2013-09-02','16:30:00',2.43),('15087','2013-09-02','16:35:00',2.32),('15087','2013-09-02','16:40:00',2.17),('15087','2013-09-02','16:45:00',2.06),('15087','2013-09-02','16:50:00',1.98),('15087','2013-09-02','16:55:00',1.86),('15087','2013-09-02','17:00:00',1.79),('15087','2013-09-02','17:05:00',1.67),('15087','2013-09-02','17:10:00',1.56),('15087','2013-09-02','17:15:00',1.5),('15087','2013-09-02','17:20:00',1.41),('15087','2013-09-02','17:25:00',1.31),('15087','2013-09-02','17:30:00',1.23),('15087','2013-09-02','17:35:00',1.2),('15087','2013-09-02','17:40:00',1.11),('15087','2013-09-02','17:45:00',1.05),('15087','2013-09-01','08:10:00',1.07),('15087','2013-09-01','08:15:00',1.15),('15087','2013-09-01','08:20:00',1.24),('15087','2013-09-01','08:25:00',1.31),('15087','2013-09-01','08:30:00',1.33),('15087','2013-09-01','08:35:00',1.5),('15087','2013-09-01','08:40:00',1.61),('15087','2013-09-01','08:45:00',1.68),('15087','2013-09-01','08:50:00',1.77),('15087','2013-09-01','08:55:00',1.88),('15087','2013-09-01','09:00:00',1.95),('15087','2013-09-01','09:05:00',2.08),('15087','2013-09-01','09:10:00',2.22),('15087','2013-09-01','09:15:00',2.31),('15087','2013-09-01','09:20:00',2.39),('15087','2013-09-01','09:25:00',2.48),('15087','2013-09-01','09:30:00',2.56),('15087','2013-09-01','09:35:00',2.64),('15087','2013-09-01','09:40:00',2.72),('15087','2013-09-01','09:45:00',2.78),('15087','2013-09-01','09:50:00',2.86),('15087','2013-09-01','09:55:00',2.92),('15087','2013-09-01','10:00:00',2.98),('15087','2013-09-01','10:05:00',3.04),('15087','2013-09-01','10:10:00',3.12),('15087','2013-09-01','10:15:00',3.17),('15087','2013-09-01','10:20:00',3.21),('15087','2013-09-01','10:25:00',3.29),('15087','2013-09-01','10:30:00',3.35),('15087','2013-09-01','10:35:00',3.41),('15087','2013-09-01','10:40:00',3.46),('15087','2013-09-01','10:45:00',3.48),('15087','2013-09-01','10:50:00',3.54),('15087','2013-09-01','10:55:00',3.61),('15087','2013-09-01','11:00:00',3.67),('15087','2013-09-01','11:05:00',3.72),('15087','2013-09-01','11:10:00',3.75),('15087','2013-09-01','11:15:00',3.77),('15087','2013-09-01','11:20:00',3.77),('15087','2013-09-01','11:25:00',3.83),('15087','2013-09-01','11:30:00',3.84),('15087','2013-09-01','11:35:00',3.87),('15087','2013-09-01','11:40:00',3.92),('15087','2013-09-01','11:45:00',3.96),('15087','2013-09-01','11:50:00',4.02),('15087','2013-09-01','11:55:00',4),('15087','2013-09-01','12:00:00',4.02),('15087','2013-09-01','12:05:00',3.98),('15087','2013-09-01','12:10:00',4.04),('15087','2013-09-01','12:15:00',4.07),('15087','2013-09-01','12:20:00',4.11),('15087','2013-09-01','12:25:00',3.99),('15087','2013-09-01','12:30:00',4.14),('15087','2013-09-01','12:35:00',4.16),('15087','2013-09-01','12:40:00',4.17),('15087','2013-09-01','12:45:00',4.12),('15087','2013-09-01','12:50:00',4.14),('15087','2013-09-01','12:55:00',4.14),('15087','2013-09-01','13:00:00',4.23),('15087','2013-09-01','13:05:00',4.2),('15087','2013-09-01','13:10:00',4.23),('15087','2013-09-01','13:15:00',3.94),('15087','2013-09-01','13:20:00',4.23),('15087','2013-09-01','13:25:00',4.2),('15087','2013-09-01','13:30:00',4.26),('15087','2013-09-01','13:35:00',4.18),('15087','2013-09-01','13:40:00',4.18),('15087','2013-09-01','13:45:00',3.93),('15087','2013-09-01','13:50:00',3.48),('15087','2013-09-01','13:55:00',3.5),('15087','2013-09-01','14:00:00',3.1),('15087','2013-09-01','14:05:00',3.22),('15087','2013-09-01','14:10:00',3.68),('15087','2013-09-01','14:15:00',3.61),('15087','2013-09-01','14:20:00',3.24),('15087','2013-09-01','14:25:00',3.25),('15087','2013-09-01','14:30:00',3.36),('15087','2013-09-01','14:35:00',3.34),('15087','2013-09-01','14:40:00',3.35),('15087','2013-09-01','14:45:00',3.37),('15087','2013-09-01','14:50:00',3.34),('15087','2013-09-01','14:55:00',3.1),('15087','2013-09-01','15:00:00',3.06),('15087','2013-09-01','15:05:00',3.17),('15087','2013-09-01','15:10:00',3.19),('15087','2013-09-01','15:15:00',3.03),('15087','2013-09-01','15:20:00',2.95),('15087','2013-09-01','15:25:00',2.5),('15087','2013-09-01','15:30:00',2.19),('15087','2013-09-01','15:35:00',2.36),('15087','2013-09-01','15:40:00',2.81),('15087','2013-09-01','15:45:00',2.58),('15087','2013-09-01','15:50:00',1.9),('15087','2013-09-01','15:55:00',2.11),('15087','2013-09-01','16:00:00',2.63),('15087','2013-09-01','16:05:00',2.75),('15087','2013-09-01','16:10:00',2.66),('15087','2013-09-01','16:15:00',2.57),('15087','2013-09-01','16:20:00',2.36),('15087','2013-09-01','16:25:00',2.39),('15087','2013-09-01','16:30:00',2.49),('15087','2013-09-01','16:35:00',2.47),('15087','2013-09-01','16:40:00',2.32),('15087','2013-09-01','16:45:00',2.11),('15087','2013-09-01','16:50:00',2.03),('15087','2013-09-01','16:55:00',1.77),('15087','2013-09-01','17:00:00',1.47),('15087','2013-09-01','17:05:00',1.55),('15087','2013-09-01','17:10:00',1.29),('15087','2013-09-01','17:15:00',1.35),('15087','2013-09-01','17:20:00',1.43),('15087','2013-09-01','17:25:00',1.36),('15087','2013-09-01','17:30:00',1.21),('15087','2013-09-01','17:35:00',1.21),('15087','2013-09-01','17:40:00',1.25),('15087','2013-09-01','17:45:00',1.06),('15087','2013-08-31','08:20:00',1),('15087','2013-08-31','08:25:00',1.21),('15087','2013-08-31','08:30:00',1.44),('15087','2013-08-31','08:35:00',1.5),('15087','2013-08-31','08:40:00',1.65),('15087','2013-08-31','08:45:00',1.83),('15087','2013-08-31','08:50:00',2.03),('15087','2013-08-31','08:55:00',2.22),('15087','2013-08-31','09:00:00',2.33),('15087','2013-08-31','09:05:00',2.07),('15087','2013-08-31','09:10:00',1.64),('15087','2013-08-31','09:15:00',2.17),('15087','2013-08-31','09:20:00',2.41),('15087','2013-08-31','09:25:00',2.64),('15087','2013-08-31','09:30:00',2.7),('15087','2013-08-31','09:35:00',2.82),('15087','2013-08-31','09:40:00',2.85),('15087','2013-08-31','09:45:00',2.72),('15087','2013-08-31','09:50:00',2.74),('15087','2013-08-31','09:55:00',2.96),('15087','2013-08-31','10:00:00',3.14),('15087','2013-08-31','10:05:00',3.08),('15087','2013-08-31','10:10:00',3.26),('15087','2013-08-31','10:15:00',3.29),('15087','2013-08-31','10:20:00',3.32),('15087','2013-08-31','10:25:00',3.37),('15087','2013-08-31','10:30:00',3.47),('15087','2013-08-31','10:35:00',3.57),('15087','2013-08-31','10:40:00',3.58),('15087','2013-08-31','10:45:00',3.63),('15087','2013-08-31','10:50:00',3.74),('15087','2013-08-31','10:55:00',3.75),('15087','2013-08-31','11:00:00',3.86),('15087','2013-08-31','11:05:00',3.9),('15087','2013-08-31','11:10:00',3.93),('15087','2013-08-31','11:15:00',3.99),('15087','2013-08-31','11:20:00',4.03),('15087','2013-08-31','11:25:00',4.06),('15087','2013-08-31','11:30:00',4.08),('15087','2013-08-31','11:35:00',4.14),('15087','2013-08-31','11:40:00',4.19),('15087','2013-08-31','11:45:00',4.22),('15087','2013-08-31','11:50:00',4.26),('15087','2013-08-31','11:55:00',4.29),('15087','2013-08-31','12:00:00',4.07),('15087','2013-08-31','12:05:00',3.62),('15087','2013-08-31','12:10:00',3.46),('15087','2013-08-31','12:15:00',4.03),('15087','2013-08-31','12:20:00',4.28),('15087','2013-08-31','12:25:00',4.22),('15087','2013-08-31','12:30:00',4.27),('15087','2013-08-31','12:35:00',4.32),('15087','2013-08-31','12:40:00',4.26),('15087','2013-08-31','12:45:00',4.29),('15087','2013-08-31','12:50:00',4.29),('15087','2013-08-31','12:55:00',4.31),('15087','2013-08-31','13:00:00',4.3),('15087','2013-08-31','13:05:00',4.32),('15087','2013-08-31','13:10:00',4.26),('15087','2013-08-31','13:15:00',4.31),('15087','2013-08-31','13:20:00',4.28),('15087','2013-08-31','13:25:00',4.26),('15087','2013-08-31','13:30:00',4.31),('15087','2013-08-31','13:35:00',4.24),('15087','2013-08-31','13:40:00',4.25),('15087','2013-08-31','13:45:00',4.2),('15087','2013-08-31','13:50:00',4.25),('15087','2013-08-31','13:55:00',4.1),('15087','2013-08-31','14:00:00',4.1),('15087','2013-08-31','14:05:00',4.1),('15087','2013-08-31','14:10:00',4.05),('15087','2013-08-31','14:15:00',3.97),('15087','2013-08-31','14:20:00',3.93),('15087','2013-08-31','14:25:00',3.89),('15087','2013-08-31','14:30:00',3.84),('15087','2013-08-31','14:35:00',3.58),('15087','2013-08-31','14:40:00',3.66),('15087','2013-08-31','14:45:00',3.67),('15087','2013-08-31','14:50:00',3.65),('15087','2013-08-31','14:55:00',3.4),('15087','2013-08-31','15:00:00',3.43),('15087','2013-08-31','15:05:00',3.42),('15087','2013-08-31','15:10:00',3.4),('15087','2013-08-31','15:15:00',3.26),('15087','2013-08-31','15:20:00',3.13),('15087','2013-08-31','15:25:00',2.99),('15087','2013-08-31','15:30:00',3.1),('15087','2013-08-31','15:35:00',2.98),('15087','2013-08-31','15:40:00',2.97),('15087','2013-08-31','15:45:00',2.93),('15087','2013-08-31','15:50:00',2.89),('15087','2013-08-31','15:55:00',2.82),('15087','2013-08-31','16:00:00',2.77),('15087','2013-08-31','16:05:00',2.72),('15087','2013-08-31','16:10:00',2.68),('15087','2013-08-31','16:15:00',2.59),('15087','2013-08-31','16:20:00',2.43),('15087','2013-08-31','16:25:00',2.32),('15087','2013-08-31','16:30:00',2.43),('15087','2013-08-31','16:35:00',2.36),('15087','2013-08-31','16:40:00',2.24),('15087','2013-08-31','16:45:00',2.14),('15087','2013-08-31','16:50:00',2.04),('15087','2013-08-31','16:55:00',1.95),('15087','2013-08-31','17:00:00',1.85),('15087','2013-08-31','17:05:00',1.82),('15087','2013-08-31','17:10:00',1.67),('15087','2013-08-31','17:15:00',1.59),('15087','2013-08-31','17:20:00',1.49),('15087','2013-08-31','17:25:00',1.41),('15087','2013-08-31','17:30:00',1.33),('15087','2013-08-31','17:35:00',1.2),('15087','2013-08-31','17:40:00',1.16),('15087','2013-08-31','17:45:00',1.06),('15087','2013-08-30','08:05:00',1.12),('15087','2013-08-30','08:10:00',1.27),('15087','2013-08-30','08:15:00',1.23),('15087','2013-08-30','08:20:00',1.32),('15087','2013-08-30','08:25:00',1.36),('15087','2013-08-30','08:30:00',1.42),('15087','2013-08-30','08:35:00',1.52),('15087','2013-08-30','08:40:00',1.54),('15087','2013-08-30','08:45:00',1.38),('15087','2013-08-30','08:50:00',1.26),('15087','2013-08-30','08:55:00',1.27),('15087','2013-08-30','09:00:00',1.48),('15087','2013-08-30','09:05:00',1.66),('15087','2013-08-30','09:10:00',1.45),('15087','2013-08-30','09:15:00',1.33),('15087','2013-08-30','09:20:00',1.19),('15087','2013-08-30','09:25:00',1.29),('15087','2013-08-30','09:30:00',1.68),('15087','2013-08-30','09:35:00',1.95),('15087','2013-08-30','09:40:00',1.86),('15087','2013-08-30','09:45:00',1.9),('15087','2013-08-30','09:50:00',1.91),('15087','2013-08-30','09:55:00',2.03),('15087','2013-08-30','10:00:00',2.08),('15087','2013-08-30','10:05:00',2.07),('15087','2013-08-30','10:10:00',2.06),('15087','2013-08-30','10:15:00',2.22),('15087','2013-08-30','10:20:00',2.28),('15087','2013-08-30','10:25:00',2.14),('15087','2013-08-30','10:30:00',2.36),('15087','2013-08-30','10:35:00',2.27),('15087','2013-08-30','10:40:00',2.13),('15087','2013-08-30','10:45:00',2.09),('15087','2013-08-30','10:50:00',2.25),('15087','2013-08-30','10:55:00',2.12),('15087','2013-08-30','11:00:00',2.24),('15087','2013-08-30','11:05:00',2.37),('15087','2013-08-30','11:10:00',2.5),('15087','2013-08-30','11:15:00',2.52),('15087','2013-08-30','11:20:00',2.54),('15087','2013-08-30','11:25:00',2.62),('15087','2013-08-30','11:30:00',2.78),('15087','2013-08-30','11:35:00',2.63),('15087','2013-08-30','11:40:00',2.87),('15087','2013-08-30','11:45:00',2.85),('15087','2013-08-30','11:50:00',3.25),('15087','2013-08-30','11:55:00',2.83),('15087','2013-08-30','12:00:00',2.55),('15087','2013-08-30','12:05:00',2.2),('15087','2013-08-30','12:10:00',2.41),('15087','2013-08-30','12:15:00',2.65),('15087','2013-08-30','12:20:00',2.83),('15087','2013-08-30','12:25:00',3.22),('15087','2013-08-30','12:30:00',3.55),('15087','2013-08-30','12:35:00',3.35),('15087','2013-08-30','12:40:00',3.27),('15087','2013-08-30','12:45:00',3.41),('15087','2013-08-30','12:50:00',3.31),('15087','2013-08-30','12:55:00',3.08),('15087','2013-08-30','13:00:00',3.05),('15087','2013-08-30','13:05:00',3),('15087','2013-08-30','13:10:00',3.06),('15087','2013-08-30','13:15:00',2.94),('15087','2013-08-30','13:20:00',3.54),('15087','2013-08-30','13:25:00',3.96),('15087','2013-08-30','13:30:00',4.27),('15087','2013-08-30','13:35:00',3.98),('15087','2013-08-30','13:40:00',4.21),('15087','2013-08-30','13:45:00',3.8),('15087','2013-08-30','13:50:00',3.79),('15087','2013-08-30','13:55:00',4.02),('15087','2013-08-30','14:00:00',4.18),('15087','2013-08-30','14:05:00',3.91),('15087','2013-08-30','14:10:00',4.06),('15087','2013-08-30','14:15:00',3.9),('15087','2013-08-30','14:20:00',3.99),('15087','2013-08-30','14:25:00',3.98),('15087','2013-08-30','14:30:00',3.98),('15087','2013-08-30','14:35:00',3.95),('15087','2013-08-30','14:40:00',3.79),('15087','2013-08-30','14:45:00',3),('15087','2013-08-30','14:50:00',2.64),('15087','2013-08-30','14:55:00',3.02),('15087','2013-08-30','15:00:00',2.56),('15087','2013-08-30','15:05:00',2.41),('15087','2013-08-30','15:10:00',2.42),('15087','2013-08-30','15:15:00',2.98),('15087','2013-08-30','15:20:00',2.53),('15087','2013-08-30','15:25:00',2.31),('15087','2013-08-30','15:30:00',2.19),('15087','2013-08-30','15:35:00',1.76),('15087','2013-08-30','15:40:00',1.93),('15087','2013-08-30','15:45:00',2.33),('15087','2013-08-30','15:50:00',2.47),('15087','2013-08-30','15:55:00',2.4),('15087','2013-08-30','16:00:00',2.29),('15087','2013-08-30','16:05:00',1.98),('15087','2013-08-30','16:10:00',1.6),('15087','2013-08-30','16:15:00',1.47),('15087','2013-08-30','16:20:00',1.69),('15087','2013-08-30','16:25:00',1.62),('15087','2013-08-30','16:30:00',1.83),('15087','2013-08-30','16:35:00',1.45),('15087','2013-08-30','16:40:00',1.98),('15087','2013-08-30','16:45:00',2.36),('15087','2013-08-30','16:50:00',2.12),('15087','2013-08-30','16:55:00',1.52),('15087','2013-08-30','17:00:00',1.83),('15087','2013-08-30','17:05:00',1.33),('15087','2013-08-30','17:10:00',1.5),('15087','2013-08-30','17:15:00',1.34),('15087','2013-08-30','17:20:00',1.17),('15087','2013-08-30','17:25:00',1.23),('15087','2013-08-30','17:30:00',1.27),('15087','2013-08-30','17:35:00',1.47),('15087','2013-08-30','17:40:00',1.07),('15087','2013-08-30','17:45:00',1.28),('15087','2013-08-30','17:50:00',1.1),('15087','2013-08-30','17:55:00',1.04),('15087','2014-04-11','08:35:00',1.86),('15087','2014-04-11','08:40:00',1.98),('15087','2014-04-11','08:45:00',2.08),('15087','2014-04-11','08:50:00',2.1),('15087','2014-04-11','08:55:00',2.14),('15087','2014-04-11','09:00:00',2.15),('15087','2014-04-11','09:05:00',2.24),('15087','2014-04-11','09:10:00',2.34),('15087','2014-04-11','09:15:00',2.44),('15087','2014-04-11','09:20:00',2.52),('15087','2014-04-11','09:25:00',2.61),('15087','2014-04-11','09:30:00',2.68),('15087','2014-04-11','09:35:00',2.77),('15087','2014-04-11','09:40:00',2.87),('15087','2014-04-11','09:45:00',2.93),('15087','2014-04-11','09:50:00',3.02),('15087','2014-04-11','09:55:00',3.12),('15087','2014-04-11','10:00:00',3.19),('15087','2014-04-11','10:05:00',3.25),('15087','2014-04-11','10:10:00',3.36),('15087','2014-04-11','10:15:00',3.43),('15087','2014-04-11','10:20:00',3.51),('15087','2014-04-11','10:25:00',3.58),('15087','2014-04-11','10:30:00',3.62),('15087','2014-04-11','10:35:00',3.67),('15087','2014-04-11','10:40:00',3.73),('15087','2014-04-11','10:45:00',3.83),('15087','2014-04-11','10:50:00',3.9),('15087','2014-04-11','10:55:00',3.94),('15087','2014-04-11','11:00:00',4),('15087','2014-04-11','11:05:00',4.04),('15087','2014-04-11','11:10:00',4.05),('15087','2014-04-11','11:15:00',4.13),('15087','2014-04-11','11:20:00',4.21),('15087','2014-04-11','11:25:00',4.26),('15087','2014-04-11','11:30:00',4.3),('15087','2014-04-11','11:35:00',4.36),('15087','2014-04-11','11:40:00',4.34),('15087','2014-04-11','11:45:00',4.43),('15087','2014-04-11','11:50:00',4.5),('15087','2014-04-11','11:55:00',4.68),('15087','2014-04-11','12:00:00',4.71),('15087','2014-04-11','12:05:00',4.63),('15087','2014-04-11','12:10:00',4.76),('15087','2014-04-11','12:15:00',4.06),('15087','2014-04-11','12:20:00',4.56),('15087','2014-04-11','12:25:00',4.73),('15087','2014-04-11','12:30:00',4.81),('15087','2014-04-11','12:35:00',4.85),('15087','2014-04-11','12:40:00',4.83),('15087','2014-04-11','12:45:00',4.44),('15087','2014-04-11','12:50:00',5.12),('15087','2014-04-11','12:55:00',4.9),('15087','2014-04-11','13:00:00',3.64),('15087','2014-04-11','13:05:00',4.54),('15087','2014-04-11','13:10:00',3.32),('15087','2014-04-11','13:15:00',3.93),('15087','2014-04-11','13:20:00',3.67),('15087','2014-04-11','13:25:00',3.8),('15087','2014-04-11','13:30:00',2.55),('15087','2014-04-11','13:35:00',3.82),('15087','2014-04-11','13:40:00',2.64),('15087','2014-04-11','13:45:00',4.77),('15087','2014-04-11','13:50:00',3.23),('15087','2014-04-11','13:55:00',4.57),('15087','2014-04-11','14:00:00',2.82),('15087','2014-04-11','14:05:00',4.81),('15087','2014-04-11','14:10:00',2.01),('15087','2014-04-11','14:15:00',2.82),('15087','2014-04-11','14:20:00',3.23),('15087','2014-04-11','14:25:00',3.18),('15087','2014-04-11','14:30:00',4.68),('15087','2014-04-11','14:35:00',4.5),('15087','2014-04-11','14:40:00',2.43),('15087','2014-04-11','14:45:00',3.46),('15087','2014-04-11','14:50:00',4.07),('15087','2014-04-11','14:55:00',3.53),('15087','2014-04-11','15:00:00',4.64),('15087','2014-04-11','15:05:00',3.84),('15087','2014-04-11','15:10:00',4.02),('15087','2014-04-11','15:15:00',3.53),('15087','2014-04-11','15:20:00',3.65),('15087','2014-04-11','15:25:00',3.6),('15087','2014-04-11','15:30:00',3.64),('15087','2014-04-11','15:35:00',1.83),('15087','2014-04-11','15:40:00',3.47),('15087','2014-04-11','15:45:00',3.33),('15087','2014-04-11','15:50:00',3.04),('15087','2014-04-11','15:55:00',3.18),('15087','2014-04-11','16:00:00',3),('15087','2014-04-11','16:05:00',2.97),('15087','2014-04-11','16:10:00',2.37),('15087','2014-04-11','16:15:00',2.81),('15087','2014-04-11','16:20:00',2.85),('15087','2014-04-11','16:25:00',2.78),('15087','2014-04-11','16:30:00',2.71),('15087','2014-04-11','16:35:00',2.19),('15087','2014-04-11','16:40:00',2.52),('15087','2014-04-11','16:45:00',2.29),('15087','2014-04-11','16:50:00',1.51),('15087','2014-04-11','16:55:00',1.88),('15087','2014-04-11','17:00:00',2.1),('15087','2014-04-11','17:05:00',2.03),('15087','2014-04-11','17:10:00',2.02),('15087','2014-04-11','17:15:00',1.84),('15087','2014-04-11','17:20:00',1.84),('15087','2014-04-11','17:25:00',1.67),('15087','2014-04-11','17:30:00',1.69),('15087','2014-04-11','17:35:00',1.64),('15087','2014-04-11','17:40:00',1.55),('15087','2014-04-11','17:45:00',1.32),('15087','2014-04-11','17:50:00',1.16),('15087','2014-04-11','17:55:00',1.04),('15087','2013-08-29','08:05:00',1.05),('15087','2013-08-29','08:10:00',1.15),('15087','2013-08-29','08:15:00',1.3),('15087','2013-08-29','08:20:00',1.46),('15087','2013-08-29','08:25:00',1.65),('15087','2013-08-29','08:30:00',1.93),('15087','2013-08-29','08:35:00',1.86),('15087','2013-08-29','08:40:00',1.38),('15087','2013-08-29','08:45:00',1.09),('15087','2013-08-29','08:50:00',1.3),('15087','2013-08-29','08:55:00',1.73),('15087','2013-08-29','09:00:00',1.65),('15087','2013-08-29','09:05:00',1.61),('15087','2013-08-29','09:10:00',1.58),('15087','2013-08-29','09:15:00',1.73),('15087','2013-08-29','09:20:00',1.67),('15087','2013-08-29','09:25:00',1.52),('15087','2013-08-29','09:30:00',1.58),('15087','2013-08-29','09:35:00',1.76),('15087','2013-08-29','09:40:00',1.77),('15087','2013-08-29','09:45:00',1.55),('15087','2013-08-29','09:50:00',1.5),('15087','2013-08-29','09:55:00',1.56),('15087','2013-08-29','10:00:00',1.66),('15087','2013-08-29','10:05:00',1.58),('15087','2013-08-29','10:10:00',1.57),('15087','2013-08-29','10:15:00',1.55),('15087','2013-08-29','10:20:00',1.57),('15087','2013-08-29','10:25:00',1.58),('15087','2013-08-29','10:30:00',1.61),('15087','2013-08-29','10:35:00',1.52),('15087','2013-08-29','10:40:00',1.39),('15087','2013-08-29','10:45:00',1.29),('15087','2013-08-29','10:50:00',1.29),('15087','2013-08-29','10:55:00',1.44),('15087','2013-08-29','11:00:00',1.54),('15087','2013-08-29','11:05:00',1.57),('15087','2013-08-29','11:10:00',2.42),('15087','2013-08-29','11:15:00',2.71),('15087','2013-08-29','11:20:00',2.54),('15087','2013-08-29','11:25:00',1.91),('15087','2013-08-29','11:30:00',1.59),('15087','2013-08-29','11:35:00',1.43),('15087','2013-08-29','11:40:00',1.64),('15087','2013-08-29','11:45:00',1.94),('15087','2013-08-29','11:50:00',2.05),('15087','2013-08-29','11:55:00',1.91),('15087','2013-08-29','12:00:00',1.93),('15087','2013-08-29','12:05:00',2.28),('15087','2013-08-29','12:10:00',2.76),('15087','2013-08-29','12:15:00',3.15),('15087','2013-08-29','12:20:00',2.83),('15087','2013-08-29','12:25:00',2.87),('15087','2013-08-29','12:30:00',2.9),('15087','2013-08-29','12:35:00',3.52),('15087','2013-08-29','12:40:00',4.89),('15087','2013-08-29','12:45:00',4.63),('15087','2013-08-29','12:50:00',2.69),('15087','2013-08-29','12:55:00',4.12),('15087','2013-08-29','13:00:00',2.93),('15087','2013-08-29','13:05:00',2.8),('15087','2013-08-29','13:10:00',2.7),('15087','2013-08-29','13:15:00',2.6),('15087','2013-08-29','13:20:00',2.51),('15087','2013-08-29','13:25:00',2.16),('15087','2013-08-29','13:30:00',1.94),('15087','2013-08-29','13:35:00',1.78),('15087','2013-08-29','13:40:00',1.71),('15087','2013-08-29','13:45:00',1.6),('15087','2013-08-29','13:50:00',1.58),('15087','2013-08-29','13:55:00',1.87),('15087','2013-08-29','14:00:00',2.48),('15087','2013-08-29','14:05:00',1.73),('15087','2013-08-29','14:10:00',1.56),('15087','2013-08-29','14:15:00',1.29),('15087','2013-08-29','14:20:00',1.04),('15087','2013-08-29','14:45:00',1.04),('15087','2013-08-29','14:50:00',1.22),('15087','2013-08-29','14:55:00',1.41),('15087','2013-08-29','15:00:00',1.57),('15087','2013-08-29','15:05:00',1.78),('15087','2013-08-29','15:10:00',1.38),('15087','2013-08-29','15:15:00',1.2),('15087','2013-08-29','15:20:00',1.33),('15087','2013-08-29','15:25:00',1.53),('15087','2013-08-29','15:30:00',2.6),('15087','2013-08-29','15:35:00',2.35),('15087','2013-08-29','15:40:00',2.28),('15087','2013-08-29','15:45:00',2.47),('15087','2013-08-29','15:50:00',3),('15087','2013-08-29','15:55:00',3.33),('15087','2013-08-29','16:00:00',3.03),('15087','2013-08-29','16:05:00',3.19),('15087','2013-08-29','16:10:00',2.9),('15087','2013-08-29','16:15:00',2.91),('15087','2013-08-29','16:20:00',2.65),('15087','2013-08-29','16:25:00',2.51),('15087','2013-08-29','16:30:00',2.56),('15087','2013-08-29','16:35:00',2.47),('15087','2013-08-29','16:40:00',2.22),('15087','2013-08-29','16:45:00',2.31),('15087','2013-08-29','16:50:00',2.27),('15087','2013-08-29','16:55:00',2.19),('15087','2013-08-29','17:00:00',2.14),('15087','2013-08-29','17:05:00',2.05),('15087','2013-08-29','17:10:00',1.9),('15087','2013-08-29','17:15:00',1.76),('15087','2013-08-29','17:20:00',1.64),('15087','2013-08-29','17:25:00',1.49),('15087','2013-08-29','17:30:00',1.44),('15087','2013-08-29','17:35:00',1.37),('15087','2013-08-29','17:40:00',1.24),('15087','2013-08-29','17:45:00',1.16),('15087','2013-08-29','17:50:00',1),('15087','2013-08-28','08:05:00',1.05),('15087','2013-08-28','08:10:00',1.13),('15087','2013-08-28','08:15:00',1.21),('15087','2013-08-28','08:20:00',1.3),('15087','2013-08-28','08:25:00',1.31),('15087','2013-08-28','08:30:00',1.47),('15087','2013-08-28','08:35:00',1.63),('15087','2013-08-28','08:40:00',1.61),('15087','2013-08-28','08:45:00',1.29),('15087','2013-08-28','08:50:00',1.28),('15087','2013-08-28','08:55:00',1.09),('15087','2013-08-28','09:00:00',1.81),('15087','2013-08-28','09:10:00',1.19),('15087','2013-08-28','09:15:00',1.95),('15087','2013-08-28','09:20:00',1.14),('15087','2013-08-28','09:30:00',1.26),('15087','2013-08-28','09:35:00',2.32),('15087','2013-08-28','09:40:00',2.72),('15087','2013-08-28','09:45:00',2.84),('15087','2013-08-28','09:50:00',2.95),('15087','2013-08-28','09:55:00',2.97),('15087','2013-08-28','10:00:00',2.99),('15087','2013-08-28','10:05:00',3.08),('15087','2013-08-28','10:10:00',3.2),('15087','2013-08-28','10:15:00',3.36),('15087','2013-08-28','10:20:00',2.48),('15087','2013-08-28','10:25:00',1.22),('15087','2013-08-28','10:30:00',3.03),('15087','2013-08-28','10:35:00',1.89),('15087','2013-08-28','10:40:00',2.52),('15087','2013-08-28','10:45:00',3.86),('15087','2013-08-28','10:50:00',3.28),('15087','2013-08-28','10:55:00',3.74),('15087','2013-08-28','11:00:00',1.78),('15087','2013-08-28','11:05:00',3.51),('15087','2013-08-28','11:10:00',2.35),('15087','2013-08-28','11:15:00',4.21),('15087','2013-08-28','11:20:00',4.23),('15087','2013-08-28','11:25:00',4.33),('15087','2013-08-28','11:30:00',4.4),('15087','2013-08-28','11:35:00',4.41),('15087','2013-08-28','11:40:00',4.51),('15087','2013-08-28','11:45:00',3.18),('15087','2013-08-28','11:50:00',3.41),('15087','2013-08-28','11:55:00',1.92),('15087','2013-08-28','12:00:00',3.38),('15087','2013-08-28','12:05:00',3.38),('15087','2013-08-28','12:10:00',4.63),('15087','2013-08-28','12:15:00',4.54),('15087','2013-08-28','12:20:00',4.31),('15087','2013-08-28','12:25:00',4.48),('15087','2013-08-28','12:30:00',4.43),('15087','2013-08-28','12:35:00',4.44),('15087','2013-08-28','12:40:00',4.49),('15087','2013-08-28','12:45:00',4.63),('15087','2013-08-28','12:50:00',4.55),('15087','2013-08-28','12:55:00',4.52),('15087','2013-08-28','13:00:00',4.63),('15087','2013-08-28','13:05:00',4.23),('15087','2013-08-28','13:10:00',4.67),('15087','2013-08-28','13:15:00',4.58),('15087','2013-08-28','13:20:00',4.54),('15087','2013-08-28','13:25:00',4.57),('15087','2013-08-28','13:30:00',4.46),('15087','2013-08-28','13:35:00',4.56),('15087','2013-08-28','13:40:00',3.59),('15087','2013-08-28','13:45:00',3.4),('15087','2013-08-28','13:50:00',4.63),('15087','2013-08-28','13:55:00',3.58),('15087','2013-08-28','14:00:00',4.4),('15087','2013-08-28','14:05:00',4.35),('15087','2013-08-28','14:10:00',4.37),('15087','2013-08-28','14:15:00',4.26),('15087','2013-08-28','14:20:00',4.22),('15087','2013-08-28','14:25:00',4.2),('15087','2013-08-28','14:30:00',3.27),('15087','2013-08-28','14:35:00',3.27),('15087','2013-08-28','14:40:00',4.05),('15087','2013-08-28','14:45:00',3.85),('15087','2013-08-28','14:50:00',3.96),('15087','2013-08-28','14:55:00',3.89),('15087','2013-08-28','15:00:00',3.68),('15087','2013-08-28','15:05:00',3.74),('15087','2013-08-28','15:10:00',3.8),('15087','2013-08-28','15:15:00',3.69),('15087','2013-08-28','15:20:00',3.48),('15087','2013-08-28','15:25:00',2.22),('15087','2013-08-28','15:30:00',2.9),('15087','2013-08-28','15:35:00',2.62),('15087','2013-08-28','15:45:00',1.96),('15087','2013-08-28','15:50:00',1.63),('15087','2013-08-28','15:55:00',3.09),('15087','2013-08-28','16:00:00',3.3),('15087','2013-08-28','16:05:00',2.96),('15087','2013-08-28','16:10:00',1.8),('15087','2013-08-28','16:15:00',2.1),('15087','2013-08-28','16:20:00',2.35),('15087','2013-08-28','16:25:00',2.87),('15087','2013-08-28','16:30:00',2.69),('15087','2013-08-28','16:35:00',2.64),('15087','2013-08-28','16:40:00',2.53),('15087','2013-08-28','16:45:00',2.33),('15087','2013-08-28','16:50:00',2.23),('15087','2013-08-28','16:55:00',2.26),('15087','2013-08-28','17:00:00',2.2),('15087','2013-08-28','17:05:00',2.08),('15087','2013-08-28','17:10:00',1.55),('15087','2013-08-28','17:15:00',1.66),('15087','2013-08-28','17:20:00',1.12),('15087','2013-08-28','17:25:00',1.44),('15087','2013-08-28','17:35:00',1.46),('15087','2013-08-28','17:40:00',1.37),('15087','2013-08-28','17:55:00',1.11),('15087','2013-08-27','08:20:00',1.17),('15087','2013-08-27','08:25:00',1.52),('15087','2013-08-27','08:30:00',1.51),('15087','2013-08-27','08:35:00',1.05),('15087','2013-08-27','08:40:00',1.02),('15087','2013-08-27','08:45:00',1.19),('15087','2013-08-27','09:05:00',1.05),('15087','2013-08-27','09:10:00',1.32),('15087','2013-08-27','09:15:00',1.36),('15087','2013-08-27','09:20:00',1.65),('15087','2013-08-27','09:25:00',2.18),('15087','2013-08-27','09:30:00',2.4),('15087','2013-08-27','09:35:00',1.3),('15087','2013-08-27','09:40:00',1.03),('15087','2013-08-27','09:45:00',1.08),('15087','2013-08-27','09:50:00',1.14),('15087','2013-08-27','09:55:00',1.51),('15087','2013-08-27','10:00:00',2.04),('15087','2013-08-27','10:05:00',2.47),('15087','2013-08-27','10:10:00',3.06),('15087','2013-08-27','10:15:00',3.1),('15087','2013-08-27','10:20:00',3.24),('15087','2013-08-27','10:25:00',3.3),('15087','2013-08-27','10:30:00',3.33),('15087','2013-08-27','10:35:00',3.36),('15087','2013-08-27','10:40:00',3.35),('15087','2013-08-27','10:45:00',3.46),('15087','2013-08-27','10:50:00',3.49),('15087','2013-08-27','10:55:00',3.53),('15087','2013-08-27','11:00:00',3.61),('15087','2013-08-27','11:05:00',3.71),('15087','2013-08-27','11:10:00',3.72),('15087','2013-08-27','11:15:00',3.75),('15087','2013-08-27','11:20:00',3.7),('15087','2013-08-27','11:25:00',3.62),('15087','2013-08-27','11:30:00',3.73),('15087','2013-08-27','11:35:00',3.72),('15087','2013-08-27','11:40:00',3.56),('15087','2013-08-27','11:45:00',4.47),('15087','2013-08-27','11:50:00',3.19),('15087','2013-08-27','11:55:00',4.29),('15087','2013-08-27','12:00:00',4.44),('15087','2013-08-27','12:05:00',3.94),('15087','2013-08-27','12:10:00',3.35),('15087','2013-08-27','12:15:00',4.17),('15087','2013-08-27','12:20:00',4.06),('15087','2013-08-27','12:25:00',4.08),('15087','2013-08-27','12:30:00',3.53),('15087','2013-08-27','12:35:00',4.72),('15087','2013-08-27','12:40:00',4.18),('15087','2013-08-27','12:45:00',3.13),('15087','2013-08-27','12:50:00',2.06),('15087','2013-08-27','12:55:00',1.72),('15087','2013-08-27','13:00:00',1.29),('15087','2013-08-27','13:05:00',1.71),('15087','2013-08-27','13:10:00',1.95),('15087','2013-08-27','13:15:00',1.84),('15087','2013-08-27','13:20:00',2.25),('15087','2013-08-27','13:25:00',2.39),('15087','2013-08-27','13:30:00',2.65),('15087','2013-08-27','13:35:00',1.97),('15087','2013-08-27','13:40:00',1.86),('15087','2013-08-27','13:45:00',2.75),('15087','2013-08-27','13:50:00',3.92),('15087','2013-08-27','13:55:00',3.07),('15087','2013-08-27','14:00:00',3.91),('15087','2013-08-27','14:05:00',2.03),('15087','2013-08-27','14:10:00',2.58),('15087','2013-08-27','14:15:00',3.43),('15087','2013-08-27','14:20:00',1.95),('15087','2013-08-27','14:25:00',1.27),('15087','2013-08-27','14:30:00',1.24),('15087','2013-08-27','14:35:00',1.1),('15087','2013-08-27','14:40:00',1.24),('15087','2013-08-27','14:45:00',1.27),('15087','2013-08-27','15:55:00',1.4),('15087','2013-08-27','16:00:00',1.48),('15087','2013-08-27','16:05:00',1.89),('15087','2013-08-27','16:10:00',3.58),('15087','2013-08-27','16:15:00',3.26),('15087','2013-08-27','16:20:00',2.26),('15087','2013-08-27','16:25:00',2.26),('15087','2013-08-27','16:35:00',1.17),('15087','2013-08-27','16:40:00',1.65),('15087','2013-08-27','16:45:00',1.89),('15087','2013-08-27','16:50:00',2.28),('15087','2013-08-27','16:55:00',1.91),('15087','2013-08-27','17:05:00',1.21),('15087','2013-08-27','17:10:00',2.55),('15087','2013-08-27','17:15:00',1.31),('15087','2013-08-27','17:45:00',1.17),('15087','2013-08-27','17:50:00',1.29),('15087','2013-08-27','17:55:00',1.34),('15087','2013-08-27','18:00:00',1.04),('15087','2013-08-26','08:05:00',1.41),('15087','2013-08-26','08:10:00',1.26),('15087','2013-08-26','08:20:00',1.54),('15087','2013-08-26','08:25:00',1.32),('15087','2013-08-26','08:30:00',1.59),('15087','2013-08-26','08:35:00',1.34),('15087','2013-08-26','08:40:00',1.61),('15087','2013-08-26','08:45:00',1.73),('15087','2013-08-26','08:50:00',1.81),('15087','2013-08-26','08:55:00',1.91),('15087','2013-08-26','09:00:00',1.98),('15087','2013-08-26','09:05:00',2.09),('15087','2013-08-26','09:10:00',2.15),('15087','2013-08-26','09:15:00',2.3),('15087','2013-08-26','09:20:00',2.41),('15087','2013-08-26','09:25:00',2.49),('15087','2013-08-26','09:30:00',2.56),('15087','2013-08-26','09:35:00',2.65),('15087','2013-08-26','09:40:00',2.74),('15087','2013-08-26','09:45:00',2.81),('15087','2013-08-26','09:50:00',2.85),('15087','2013-08-26','09:55:00',2.88),('15087','2013-08-26','10:00:00',2.95),('15087','2013-08-26','10:05:00',3.02),('15087','2013-08-26','10:10:00',3.09),('15087','2013-08-26','10:15:00',3.12),('15087','2013-08-26','10:20:00',3.26),('15087','2013-08-26','10:25:00',3.31),('15087','2013-08-26','10:30:00',3.35),('15087','2013-08-26','10:35:00',3.41),('15087','2013-08-26','10:40:00',3.49),('15087','2013-08-26','10:45:00',3.57),('15087','2013-08-26','10:50:00',3.59),('15087','2013-08-26','10:55:00',3.61),('15087','2013-08-26','11:00:00',3.68),('15087','2013-08-26','11:05:00',3.69),('15087','2013-08-26','11:10:00',3.76),('15087','2013-08-26','11:15:00',3.82),('15087','2013-08-26','11:20:00',3.83),('15087','2013-08-26','11:25:00',3.84),('15087','2013-08-26','11:30:00',3.92),('15087','2013-08-26','11:35:00',3.96),('15087','2013-08-26','11:40:00',3.97),('15087','2013-08-26','11:45:00',4.01),('15087','2013-08-26','11:50:00',4.06),('15087','2013-08-26','11:55:00',4.07),('15087','2013-08-26','12:00:00',4.07),('15087','2013-08-26','12:05:00',4.11),('15087','2013-08-26','12:10:00',4.12),('15087','2013-08-26','12:15:00',4.13),('15087','2013-08-26','12:20:00',4.1),('15087','2013-08-26','12:25:00',4.12),('15087','2013-08-26','12:30:00',4.13),('15087','2013-08-26','12:35:00',4.15),('15087','2013-08-26','12:40:00',4.21),('15087','2013-08-26','12:45:00',4.22),('15087','2013-08-26','12:50:00',4.22),('15087','2013-08-26','12:55:00',4.27),('15087','2013-08-26','13:00:00',4.39),('15087','2013-08-26','13:05:00',5.01),('15087','2013-08-26','13:10:00',4.1),('15087','2013-08-26','13:15:00',4.03),('15087','2013-08-26','13:20:00',2.9),('15087','2013-08-26','13:25:00',3.18),('15087','2013-08-26','13:30:00',3.07),('15087','2013-08-26','13:35:00',4.01),('15087','2013-08-26','13:40:00',4.18),('15087','2013-08-26','13:45:00',4.24),('15087','2013-08-26','13:50:00',4.12),('15087','2013-08-26','13:55:00',3.09),('15087','2013-08-26','14:00:00',2.85),('15087','2013-08-26','14:05:00',3.61),('15087','2013-08-26','14:10:00',2.79),('15087','2013-08-26','14:15:00',3.97),('15087','2013-08-26','14:20:00',3.98),('15087','2013-08-26','14:25:00',3.84),('15087','2013-08-26','14:30:00',3.84),('15087','2013-08-26','14:35:00',3.68),('15087','2013-08-26','14:40:00',3.31),('15087','2013-08-26','14:45:00',2.4),('15087','2013-08-26','14:50:00',2.12),('15087','2013-08-26','14:55:00',1.97),('15087','2013-08-26','15:00:00',1.87),('15087','2013-08-26','15:05:00',1.35),('15087','2013-08-26','15:10:00',1.06),('15087','2013-08-26','15:35:00',1.01),('15087','2013-08-26','15:40:00',1.6),('15087','2013-08-26','15:45:00',1.71),('15087','2013-08-26','15:50:00',1.72),('15087','2013-08-26','15:55:00',1.58),('15087','2013-08-26','16:00:00',2.5),('15087','2013-08-26','16:05:00',3.2),('15087','2013-08-26','16:10:00',2.76),('15087','2013-08-26','16:15:00',2.68),('15087','2013-08-26','16:20:00',2.55),('15087','2013-08-26','16:25:00',2.38),('15087','2013-08-26','16:30:00',2.46),('15087','2013-08-26','16:35:00',2.42),('15087','2013-08-26','16:40:00',2.35),('15087','2013-08-26','16:45:00',2.23),('15087','2013-08-26','16:50:00',1.97),('15087','2013-08-26','16:55:00',1.91),('15087','2013-08-26','17:00:00',1.93),('15087','2013-08-26','17:05:00',1.74),('15087','2013-08-26','17:10:00',1.77),('15087','2013-08-26','17:15:00',1.69),('15087','2013-08-26','17:20:00',1.22),('15087','2013-08-26','17:30:00',1.22),('15087','2013-08-26','17:40:00',1.01),('15087','2013-08-26','17:45:00',1.18),('15087','2013-08-26','17:50:00',1.33),('15087','2013-08-26','17:55:00',1.24),('15087','2013-08-26','18:00:00',1.08),('15087','2013-08-25','08:05:00',1.02),('15087','2013-08-25','08:10:00',1.23),('15087','2013-08-25','08:15:00',1.19),('15087','2013-08-25','08:20:00',1.14),('15087','2013-08-25','08:25:00',1.19),('15087','2013-08-25','08:35:00',1.01),('15087','2013-08-25','08:40:00',1.36),('15087','2013-08-25','08:45:00',1.35),('15087','2013-08-25','09:15:00',1.07),('15087','2013-08-25','09:20:00',2.37),('15087','2013-08-25','09:25:00',2.38),('15087','2013-08-25','09:30:00',2.15),('15087','2013-08-25','09:40:00',2.98),('15087','2013-08-25','09:45:00',3.6),('15087','2013-08-25','09:50:00',3.1),('15087','2013-08-25','09:55:00',2.93),('15087','2013-08-25','10:00:00',2.4),('15087','2013-08-25','10:05:00',1.47),('15087','2013-08-25','15:10:00',1.05),('15087','2013-08-25','15:15:00',1.23),('15087','2013-08-25','15:20:00',1.5),('15087','2013-08-25','15:25:00',1.63),('15087','2013-08-25','15:30:00',2.28),('15087','2013-08-25','15:35:00',3.44),('15087','2013-08-25','15:40:00',3.46),('15087','2013-08-25','15:45:00',3.62),('15087','2013-08-25','15:50:00',2.23),('15087','2013-08-25','15:55:00',2.72),('15087','2013-08-25','16:00:00',3.34),('15087','2013-08-25','16:05:00',2.97),('15087','2013-08-25','16:10:00',2.75),('15087','2013-08-25','16:15:00',2.74),('15087','2013-08-25','16:20:00',2.58),('15087','2013-08-25','16:25:00',2.66),('15087','2013-08-25','16:30:00',2.67),('15087','2013-08-25','16:35:00',2.56),('15087','2013-08-25','16:40:00',1.76),('15087','2013-08-25','16:45:00',1.15),('15087','2013-08-25','16:50:00',1.83),('15087','2013-08-25','16:55:00',2.51),('15087','2013-08-25','17:00:00',2.36),('15087','2013-08-25','17:05:00',2.22),('15087','2013-08-25','17:10:00',2.08),('15087','2013-08-25','17:15:00',1.9),('15087','2013-08-25','17:20:00',1.76),('15087','2013-08-25','17:25:00',1.6),('15087','2013-08-25','17:30:00',1.49),('15087','2013-08-25','17:35:00',1.24),('15087','2013-08-25','17:40:00',1.13),('15087','2013-08-25','17:45:00',1.31),('15087','2013-08-25','17:50:00',1.14),('15087','2013-08-25','17:55:00',1),('15087','2013-08-24','08:20:00',1.08),('15087','2013-08-24','08:25:00',1.24),('15087','2013-08-24','08:30:00',1.27),('15087','2013-08-24','08:35:00',1.49),('15087','2013-08-24','08:40:00',1.55),('15087','2013-08-24','08:45:00',1.72),('15087','2013-08-24','08:50:00',1.78),('15087','2013-08-24','08:55:00',1.88),('15087','2013-08-24','09:00:00',1.89),('15087','2013-08-24','09:05:00',2.08),('15087','2013-08-24','09:10:00',1.79),('15087','2013-08-24','09:15:00',2.22),('15087','2013-08-24','09:25:00',2.44),('15087','2013-08-24','09:30:00',2.61),('15087','2013-08-24','09:35:00',2.57),('15087','2013-08-24','09:40:00',1.89),('15087','2013-08-24','09:45:00',2.6),('15087','2013-08-24','09:50:00',2.57),('15087','2013-08-24','09:55:00',2.66),('15087','2013-08-24','10:00:00',3.02),('15087','2013-08-24','10:05:00',3.01),('15087','2013-08-24','10:10:00',3.09),('15087','2013-08-24','10:15:00',3.13),('15087','2013-08-24','10:20:00',3.22),('15087','2013-08-24','10:25:00',3.25),('15087','2013-08-24','10:30:00',3.3),('15087','2013-08-24','10:35:00',3.39),('15087','2013-08-24','10:40:00',3.39),('15087','2013-08-24','10:45:00',2.75),('15087','2013-08-24','10:50:00',2.43),('15087','2013-08-24','10:55:00',3.67),('15087','2013-08-24','11:00:00',3.66),('15087','2013-08-24','11:05:00',3.77),('15087','2013-08-24','11:10:00',3.77),('15087','2013-08-24','11:15:00',3.73),('15087','2013-08-24','11:20:00',3.79),('15087','2013-08-24','11:25:00',3.77),('15087','2013-08-24','11:30:00',3.87),('15087','2013-08-24','11:35:00',3.92),('15087','2013-08-24','11:40:00',3.96),('15087','2013-08-24','11:45:00',4.01),('15087','2013-08-24','11:50:00',3.99),('15087','2013-08-24','11:55:00',4.03),('15087','2013-08-24','12:00:00',4.01),('15087','2013-08-24','12:05:00',4.06),('15087','2013-08-24','12:10:00',4.12),('15087','2013-08-24','12:15:00',4.08),('15087','2013-08-24','12:20:00',4.14),('15087','2013-08-24','12:25:00',4.12),('15087','2013-08-24','12:30:00',4.14),('15087','2013-08-24','12:35:00',4.18),('15087','2013-08-24','12:40:00',4.19),('15087','2013-08-24','12:45:00',4.18),('15087','2013-08-24','12:50:00',4.22),('15087','2013-08-24','12:55:00',4.15),('15087','2013-08-24','13:00:00',4.19),('15087','2013-08-24','13:05:00',4.22),('15087','2013-08-24','13:10:00',4.18),('15087','2013-08-24','13:15:00',4.21),('15087','2013-08-24','13:20:00',4.25),('15087','2013-08-24','13:25:00',4.21),('15087','2013-08-24','13:30:00',4.22),('15087','2013-08-24','13:35:00',4.22),('15087','2013-08-24','13:40:00',4.15),('15087','2013-08-24','13:45:00',4.21),('15087','2013-08-24','13:50:00',4.16),('15087','2013-08-24','13:55:00',4.15),('15087','2013-08-24','14:00:00',4.06),('15087','2013-08-24','14:05:00',3.96),('15087','2013-08-24','14:10:00',3.94),('15087','2013-08-24','14:15:00',4.01),('15087','2013-08-24','14:20:00',3.89),('15087','2013-08-24','14:25:00',3.9),('15087','2013-08-24','14:30:00',3.9),('15087','2013-08-24','14:35:00',3.86),('15087','2013-08-24','14:40:00',3.72),('15087','2013-08-24','14:45:00',3.74),('15087','2013-08-24','14:50:00',3.7),('15087','2013-08-24','14:55:00',3.66),('15087','2013-08-24','15:00:00',3.5),('15087','2013-08-24','15:05:00',3.46),('15087','2013-08-24','15:10:00',3.44),('15087','2013-08-24','15:15:00',3.42),('15087','2013-08-24','15:20:00',3.33),('15087','2013-08-24','15:25:00',3.17),('15087','2013-08-24','15:30:00',3.19),('15087','2013-08-24','15:35:00',3.04),('15087','2013-08-24','15:40:00',2.96),('15087','2013-08-24','15:45:00',3.03),('15087','2013-08-24','15:50:00',3),('15087','2013-08-24','15:55:00',2.91),('15087','2013-08-24','16:00:00',2.9),('15087','2013-08-24','16:05:00',2.84),('15087','2013-08-24','16:10:00',2.78),('15087','2013-08-24','16:15:00',2.74),('15087','2013-08-24','16:20:00',2.67),('15087','2013-08-24','16:25:00',2.61),('15087','2013-08-24','16:30:00',2.49),('15087','2013-08-24','16:35:00',2.34),('15087','2013-08-24','16:40:00',2.16),('15087','2013-08-24','16:45:00',2.23),('15087','2013-08-24','16:50:00',2.16),('15087','2013-08-24','16:55:00',2.05),('15087','2013-08-24','17:00:00',1.98),('15087','2013-08-24','17:05:00',1.9),('15087','2013-08-24','17:10:00',1.84),('15087','2013-08-24','17:15:00',1.76),('15087','2013-08-24','17:20:00',1.68),('15087','2013-08-24','17:25:00',1.57),('15087','2013-08-24','17:30:00',1.5),('15087','2013-08-24','17:35:00',1.32),('15087','2013-08-24','17:40:00',1.24),('15087','2013-08-24','17:45:00',1.26),('15087','2013-08-24','17:50:00',1.14),('15087','2013-08-24','17:55:00',1.08),('15087','2013-08-24','18:00:00',1.04),('15087','2013-08-23','08:15:00',1.04),('15087','2013-08-23','08:20:00',1.14),('15087','2013-08-23','08:25:00',1.22),('15087','2013-08-23','08:30:00',1.26),('15087','2013-08-23','08:35:00',1.31),('15087','2013-08-23','08:40:00',1.43),('15087','2013-08-23','08:45:00',1.52),('15087','2013-08-23','08:50:00',1.58),('15087','2013-08-23','08:55:00',1.68),('15087','2013-08-23','09:00:00',1.75),('15087','2013-08-23','09:05:00',1.82),('15087','2013-08-23','09:10:00',1.91),('15087','2013-08-23','09:15:00',2.03),('15087','2013-08-23','09:20:00',2.07),('15087','2013-08-23','09:25:00',2.19),('15087','2013-08-23','09:30:00',2.27),('15087','2013-08-23','09:35:00',2.33),('15087','2013-08-23','09:40:00',2.4),('15087','2013-08-23','09:45:00',2.53),('15087','2013-08-23','09:50:00',2.54),('15087','2013-08-23','09:55:00',2.64),('15087','2013-08-23','10:00:00',2.72),('15087','2013-08-23','10:05:00',2.76),('15087','2013-08-23','10:10:00',2.84),('15087','2013-08-23','10:15:00',2.9),('15087','2013-08-23','10:20:00',2.92),('15087','2013-08-23','10:25:00',3.01),('15087','2013-08-23','10:30:00',3.07),('15087','2013-08-23','10:35:00',3.08),('15087','2013-08-23','10:40:00',3.1),('15087','2013-08-23','10:45:00',3.12),('15087','2013-08-23','10:50:00',3.28),('15087','2013-08-23','10:55:00',3.25),('15087','2013-08-23','11:00:00',3.1),('15087','2013-08-23','11:05:00',2.89),('15087','2013-08-23','11:10:00',1.37),('15087','2013-08-23','11:15:00',1.15),('15087','2013-08-23','11:20:00',1.54),('15087','2013-08-23','11:25:00',2.4),('15087','2013-08-23','11:30:00',2.5),('15087','2013-08-23','11:35:00',3.72),('15087','2013-08-23','11:40:00',3.9),('15087','2013-08-23','11:45:00',3.94),('15087','2013-08-23','11:50:00',3.42),('15087','2013-08-23','11:55:00',1.23),('15087','2013-08-23','12:00:00',1.71),('15087','2013-08-23','12:05:00',3.53),('15087','2013-08-23','12:10:00',3.58),('15087','2013-08-23','12:15:00',1.01),('15087','2013-08-23','12:25:00',1.02),('15087','2013-08-23','12:30:00',1.75),('15087','2013-08-23','12:35:00',2.22),('15087','2013-08-23','12:40:00',1.26),('15087','2013-08-23','12:45:00',2.02),('15087','2013-08-23','12:50:00',2.52),('15087','2013-08-23','13:00:00',1.57),('15087','2013-08-23','13:05:00',3.59),('15087','2013-08-23','13:10:00',1.62),('15087','2013-08-23','13:15:00',2.48),('15087','2013-08-23','13:20:00',3.73),('15087','2013-08-23','13:25:00',4.14),('15087','2013-08-23','13:30:00',4.41),('15087','2013-08-23','13:35:00',3.01),('15087','2013-08-23','13:40:00',3.76),('15087','2013-08-23','13:45:00',2.96),('15087','2013-08-23','13:50:00',2.38),('15087','2013-08-23','13:55:00',4.52),('15087','2013-08-23','14:00:00',4.26),('15087','2013-08-23','14:05:00',3.93),('15087','2013-08-23','14:10:00',4.14),('15087','2013-08-23','14:15:00',4.06),('15087','2013-08-23','14:20:00',3.94),('15087','2013-08-23','14:25:00',3.86),('15087','2013-08-23','14:30:00',3.88),('15087','2013-08-23','14:35:00',3.78),('15087','2013-08-23','14:40:00',3.73),('15087','2013-08-23','14:45:00',3.77),('15087','2013-08-23','14:50:00',3.72),('15087','2013-08-23','14:55:00',3.4),('15087','2013-08-23','15:00:00',3.4),('15087','2013-08-23','15:05:00',3.29),('15087','2013-08-23','15:10:00',3.41),('15087','2013-08-23','15:15:00',3.24),('15087','2013-08-23','15:20:00',3.26),('15087','2013-08-23','15:25:00',3.28),('15087','2013-08-23','15:30:00',3.38),('15087','2013-08-23','15:35:00',3.06),('15087','2013-08-23','15:40:00',3.08),('15087','2013-08-23','15:45:00',3.02),('15087','2013-08-23','15:50:00',2.72),('15087','2013-08-23','15:55:00',2.78),('15087','2013-08-23','16:00:00',2.73),('15087','2013-08-23','16:05:00',2.6),('15087','2013-08-23','16:10:00',2.33),('15087','2013-08-23','16:15:00',2.59),('15087','2013-08-23','16:20:00',2.78),('15087','2013-08-23','16:25:00',2.67),('15087','2013-08-23','16:30:00',2.61),('15087','2013-08-23','16:35:00',2.53),('15087','2013-08-23','16:40:00',2.4),('15087','2013-08-23','16:45:00',2.42),('15087','2013-08-23','16:50:00',2.19),('15087','2013-08-23','16:55:00',2),('15087','2013-08-23','17:00:00',1.99),('15087','2013-08-23','17:05:00',1.9),('15087','2013-08-23','17:10:00',1.81),('15087','2013-08-23','17:15:00',1.73),('15087','2013-08-23','17:20:00',1.66),('15087','2013-08-23','17:25:00',1.55),('15087','2013-08-23','17:30:00',1.41),('15087','2013-08-23','17:35:00',1.34),('15087','2013-08-23','17:40:00',1.23),('15087','2013-08-23','17:45:00',1.19),('15087','2013-08-23','17:50:00',1.12),('15087','2013-08-23','17:55:00',1.07),('15087','2013-08-23','18:00:00',1.03),('15087','2013-08-22','08:10:00',1.04),('15087','2013-08-22','08:15:00',1.1),('15087','2013-08-22','08:20:00',1.19),('15087','2013-08-22','08:25:00',1.25),('15087','2013-08-22','08:30:00',1.37),('15087','2013-08-22','08:35:00',1.46),('15087','2013-08-22','08:40:00',1.51),('15087','2013-08-22','08:45:00',1.63),('15087','2013-08-22','08:50:00',1.7),('15087','2013-08-22','08:55:00',1.84),('15087','2013-08-22','09:00:00',1.93),('15087','2013-08-22','09:05:00',2.12),('15087','2013-08-22','09:10:00',2.35),('15087','2013-08-22','09:15:00',2.43),('15087','2013-08-22','09:20:00',2.59),('15087','2013-08-22','09:25:00',2.64),('15087','2013-08-22','09:30:00',2.77),('15087','2013-08-22','09:35:00',1.68),('15087','2013-08-22','09:40:00',1.93),('15087','2013-08-22','09:45:00',2.73),('15087','2013-08-22','09:50:00',2.91),('15087','2013-08-22','09:55:00',2.53),('15087','2013-08-22','10:00:00',3.17),('15087','2013-08-22','10:05:00',3.17),('15087','2013-08-22','10:10:00',3.2),('15087','2013-08-22','10:15:00',3.19),('15087','2013-08-22','10:20:00',3.19),('15087','2013-08-22','10:25:00',3.22),('15087','2013-08-22','10:30:00',3.31),('15087','2013-08-22','10:35:00',3.37),('15087','2013-08-22','10:40:00',3.4),('15087','2013-08-22','10:45:00',3.43),('15087','2013-08-22','10:50:00',3.48),('15087','2013-08-22','10:55:00',3.53),('15087','2013-08-22','11:00:00',3.58),('15087','2013-08-22','11:05:00',3.62),('15087','2013-08-22','11:10:00',3.65),('15087','2013-08-22','11:15:00',3.66),('15087','2013-08-22','11:20:00',3.71),('15087','2013-08-22','11:25:00',3.74),('15087','2013-08-22','11:30:00',3.81),('15087','2013-08-22','11:35:00',3.83),('15087','2013-08-22','11:40:00',3.88),('15087','2013-08-22','11:45:00',3.9),('15087','2013-08-22','11:50:00',3.9),('15087','2013-08-22','11:55:00',3.95),('15087','2013-08-22','12:00:00',3.96),('15087','2013-08-22','12:05:00',3.98),('15087','2013-08-22','12:10:00',3.97),('15087','2013-08-22','12:15:00',3.97),('15087','2013-08-22','12:20:00',4.04),('15087','2013-08-22','12:25:00',4.05),('15087','2013-08-22','12:30:00',4.03),('15087','2013-08-22','12:35:00',4),('15087','2013-08-22','12:40:00',4.04),('15087','2013-08-22','12:45:00',4.07),('15087','2013-08-22','12:50:00',4.07),('15087','2013-08-22','12:55:00',4.07),('15087','2013-08-22','13:00:00',4.06),('15087','2013-08-22','13:05:00',4.04),('15087','2013-08-22','13:10:00',3.9),('15087','2013-08-22','13:15:00',3.99),('15087','2013-08-22','13:20:00',3.99),('15087','2013-08-22','13:25:00',4.02),('15087','2013-08-22','13:30:00',4.01),('15087','2013-08-22','13:35:00',3.99),('15087','2013-08-22','13:40:00',3.95),('15087','2013-08-22','13:45:00',4.01),('15087','2013-08-22','13:50:00',4.01),('15087','2013-08-22','13:55:00',3.96),('15087','2013-08-22','14:00:00',3.82),('15087','2013-08-22','14:05:00',3.9),('15087','2013-08-22','14:10:00',3.86),('15087','2013-08-22','14:15:00',3.86),('15087','2013-08-22','14:20:00',3.84),('15087','2013-08-22','14:25:00',3.81),('15087','2013-08-22','14:30:00',3.72),('15087','2013-08-22','14:35:00',3.8),('15087','2013-08-22','14:40:00',3.72),('15087','2013-08-22','14:45:00',3.52),('15087','2013-08-22','14:50:00',3.6),('15087','2013-08-22','14:55:00',3.55),('15087','2013-08-22','15:00:00',3.5),('15087','2013-08-22','15:05:00',3.42),('15087','2013-08-22','15:10:00',3.46),('15087','2013-08-22','15:15:00',3.26),('15087','2013-08-22','15:20:00',3.21),('15087','2013-08-22','15:25:00',3.19),('15087','2013-08-22','15:30:00',3.09),('15087','2013-08-22','15:35:00',3.06),('15087','2013-08-22','15:40:00',2.96),('15087','2013-08-22','15:45:00',2.99),('15087','2013-08-22','15:50:00',2.89),('15087','2013-08-22','15:55:00',2.8),('15087','2013-08-22','16:00:00',2.79),('15087','2013-08-22','16:05:00',2.63),('15087','2013-08-22','16:10:00',2.61),('15087','2013-08-22','16:15:00',2.66),('15087','2013-08-22','16:20:00',2.6),('15087','2013-08-22','16:25:00',2.5),('15087','2013-08-22','16:30:00',2.46),('15087','2013-08-22','16:35:00',2.32),('15087','2013-08-22','16:40:00',2.15),('15087','2013-08-22','16:45:00',2.14),('15087','2013-08-22','16:50:00',1.98),('15087','2013-08-22','16:55:00',1.92),('15087','2013-08-22','17:00:00',1.89),('15087','2013-08-22','17:05:00',1.79),('15087','2013-08-22','17:10:00',1.72),('15087','2013-08-22','17:15:00',1.64),('15087','2013-08-22','17:20:00',1.56),('15087','2013-08-22','17:25:00',1.51),('15087','2013-08-22','17:30:00',1.43),('15087','2013-08-22','17:35:00',1.33),('15087','2013-08-22','17:40:00',1.24),('15087','2013-08-22','17:45:00',1.2),('15087','2013-08-22','17:50:00',1.12),('15087','2013-08-22','17:55:00',1.06),('15087','2013-08-22','18:00:00',1.04),('15087','2013-08-21','09:05:00',1.38),('15087','2013-08-21','09:10:00',1.4),('15087','2013-08-21','09:15:00',2.55),('15087','2013-08-21','09:20:00',2.61),('15087','2013-08-21','09:25:00',1.25),('15087','2013-08-21','09:40:00',1.04),('15087','2013-08-21','09:45:00',1.26),('15087','2013-08-21','09:50:00',2.62),('15087','2013-08-21','09:55:00',3.86),('15087','2013-08-21','10:00:00',3.63),('15087','2013-08-21','10:05:00',3.06),('15087','2013-08-21','10:10:00',2.71),('15087','2013-08-21','10:15:00',2.37),('15087','2013-08-21','10:20:00',2.34),('15087','2013-08-21','10:25:00',1.84),('15087','2013-08-21','10:30:00',2.61),('15087','2013-08-21','10:35:00',3.22),('15087','2013-08-21','10:40:00',1.99),('15087','2013-08-21','10:45:00',2.26),('15087','2013-08-21','10:50:00',2.34),('15087','2013-08-21','10:55:00',1.91),('15087','2013-08-21','11:00:00',2.75),('15087','2013-08-21','11:05:00',2.07),('15087','2013-08-21','11:10:00',1.8),('15087','2013-08-21','11:15:00',2.22),('15087','2013-08-21','11:20:00',2.92),('15087','2013-08-21','11:25:00',2.71),('15087','2013-08-21','11:30:00',3.36),('15087','2013-08-21','11:35:00',4.62),('15087','2013-08-21','11:40:00',4.36),('15087','2013-08-21','11:45:00',4.32),('15087','2013-08-21','11:50:00',4.07),('15087','2013-08-21','11:55:00',4.02),('15087','2013-08-21','12:00:00',4.3),('15087','2013-08-21','12:05:00',4.29),('15087','2013-08-21','12:10:00',4.29),('15087','2013-08-21','12:15:00',4.33),('15087','2013-08-21','12:20:00',4.27),('15087','2013-08-21','12:25:00',2.94),('15087','2013-08-21','12:30:00',2.58),('15087','2013-08-21','12:35:00',2.04),('15087','2013-08-21','12:40:00',3.87),('15087','2013-08-21','12:45:00',4.18),('15087','2013-08-21','12:50:00',3.99),('15087','2013-08-21','12:55:00',3.97),('15087','2013-08-21','13:00:00',4.13),('15087','2013-08-21','13:05:00',4.14),('15087','2013-08-21','13:10:00',4.23),('15087','2013-08-21','13:15:00',4.31),('15087','2013-08-21','13:20:00',4.32),('15087','2013-08-21','13:25:00',4.3),('15087','2013-08-21','13:30:00',4.18),('15087','2013-08-21','13:35:00',4.14),('15087','2013-08-21','13:40:00',4.14),('15087','2013-08-21','13:45:00',4.24),('15087','2013-08-21','13:50:00',4.1),('15087','2013-08-21','13:55:00',3.96),('15087','2013-08-21','14:00:00',3.78),('15087','2013-08-21','14:05:00',3.91),('15087','2013-08-21','14:10:00',4.02),('15087','2013-08-21','14:15:00',2.83),('15087','2013-08-21','14:20:00',1.58),('15087','2013-08-21','14:25:00',1.89),('15087','2013-08-21','14:30:00',3.55),('15087','2013-08-21','14:35:00',3.62),('15087','2013-08-21','14:40:00',3.63),('15087','2013-08-21','14:45:00',3.49),('15087','2013-08-21','14:50:00',3.39),('15087','2013-08-21','14:55:00',3.42),('15087','2013-08-21','15:00:00',3.45),('15087','2013-08-21','15:05:00',3.42),('15087','2013-08-21','15:10:00',3.34),('15087','2013-08-21','15:15:00',3.29),('15087','2013-08-21','15:20:00',3.14),('15087','2013-08-21','15:25:00',2.97),('15087','2013-08-21','15:30:00',2.94),('15087','2013-08-21','15:35:00',2.84),('15087','2013-08-21','15:40:00',2.64),('15087','2013-08-21','15:45:00',2.69),('15087','2013-08-21','15:50:00',2.72),('15087','2013-08-21','15:55:00',2.68),('15087','2013-08-21','16:00:00',2.56),('15087','2013-08-21','16:05:00',2.41),('15087','2013-08-21','16:10:00',2.34),('15087','2013-08-21','16:15:00',2.38),('15087','2013-08-21','16:20:00',2.5),('15087','2013-08-21','16:25:00',2.48),('15087','2013-08-21','16:30:00',2.59),('15087','2013-08-21','16:35:00',2.52),('15087','2013-08-21','16:40:00',2.45),('15087','2013-08-21','16:45:00',2.39),('15087','2013-08-21','16:50:00',2.27),('15087','2013-08-21','16:55:00',2.17),('15087','2013-08-21','17:00:00',2.14),('15087','2013-08-21','17:05:00',2.11),('15087','2013-08-21','17:10:00',2.03),('15087','2013-08-21','17:15:00',1.94),('15087','2013-08-21','17:20:00',1.91),('15087','2013-08-21','17:25:00',1.85),('15087','2013-08-21','17:30:00',1.72),('15087','2013-08-21','17:35:00',1.68),('15087','2013-08-21','17:40:00',1.6),('15087','2013-08-21','17:45:00',1.52),('15087','2013-08-21','17:50:00',1.47),('15087','2013-08-21','17:55:00',1.45),('15087','2013-08-21','18:00:00',1.4),('15087','2013-08-21','18:05:00',1.32),('15087','2013-08-21','18:10:00',1.21),('15087','2013-08-21','18:15:00',1.12),('15087','2013-08-21','18:20:00',1.01),('15087','2013-08-20','07:55:00',1.07),('15087','2013-08-20','08:55:00',1.01),('15087','2013-08-20','09:20:00',1.29),('15087','2013-08-20','09:25:00',2.04),('15087','2013-08-20','09:30:00',2.66),('15087','2013-08-20','09:35:00',3.05),('15087','2013-08-20','09:40:00',3.33),('15087','2013-08-20','09:45:00',2.33),('15087','2013-08-20','09:50:00',2.1),('15087','2013-08-20','09:55:00',3.3),('15087','2013-08-20','10:00:00',2.51),('15087','2013-08-20','10:05:00',1.61),('15087','2013-08-20','10:10:00',1.38),('15087','2013-08-20','10:15:00',2.19),('15087','2013-08-20','10:20:00',1.32),('15087','2013-08-20','10:30:00',1.02),('15087','2013-08-20','10:35:00',1.04),('15087','2013-08-20','10:40:00',1.69),('15087','2013-08-20','10:45:00',3.49),('15087','2013-08-20','10:50:00',3.87),('15087','2013-08-20','10:55:00',1.56),('15087','2013-08-20','11:00:00',1),('15087','2013-08-20','11:10:00',3.13),('15087','2013-08-20','11:15:00',4.18),('15087','2013-08-20','11:20:00',4.15),('15087','2013-08-20','11:25:00',2.73),('15087','2013-08-20','11:30:00',2.92),('15087','2013-08-20','11:35:00',4.2),('15087','2013-08-20','11:40:00',4.39),('15087','2013-08-20','11:45:00',4.53),('15087','2013-08-20','11:50:00',4.86),('15087','2013-08-20','11:55:00',3.59),('15087','2013-08-20','12:00:00',2.43),('15087','2013-08-20','12:05:00',1.68),('15087','2013-08-20','12:10:00',1.6),('15087','2013-08-20','12:25:00',1.2),('15087','2013-08-20','12:30:00',1.56),('15087','2013-08-20','12:35:00',1.72),('15087','2013-08-20','12:40:00',1.83),('15087','2013-08-20','12:45:00',1.79),('15087','2013-08-20','12:50:00',1.8),('15087','2013-08-20','12:55:00',1.9),('15087','2013-08-20','13:00:00',1.84),('15087','2013-08-20','13:05:00',1.69),('15087','2013-08-20','13:10:00',1.67),('15087','2013-08-20','13:15:00',1.7),('15087','2013-08-20','13:20:00',1.77),('15087','2013-08-20','13:25:00',1.84),('15087','2013-08-20','13:30:00',2.02),('15087','2013-08-20','13:35:00',2.88),('15087','2013-08-20','13:40:00',4.53),('15087','2013-08-20','13:45:00',3.75),('15087','2013-08-20','13:50:00',4.59),('15087','2013-08-20','13:55:00',4.42),('15087','2013-08-20','14:00:00',4.24),('15087','2013-08-20','14:05:00',3.9),('15087','2013-08-20','14:10:00',3.58),('15087','2013-08-20','14:15:00',3.81),('15087','2013-08-20','14:20:00',4.12),('15087','2013-08-20','14:25:00',3.56),('15087','2013-08-20','14:30:00',3.72),('15087','2013-08-20','14:35:00',4.33),('15087','2013-08-20','14:40:00',3.94),('15087','2013-08-20','14:45:00',3.66),('15087','2013-08-20','14:50:00',4.05),('15087','2013-08-20','14:55:00',3.67),('15087','2013-08-20','15:00:00',3.41),('15087','2013-08-20','15:05:00',3.85),('15087','2013-08-20','15:10:00',3.79),('15087','2013-08-20','15:15:00',3.84),('15087','2013-08-20','15:20:00',3.61),('15087','2013-08-20','15:25:00',3.66),('15087','2013-08-20','15:30:00',3.64),('15087','2013-08-20','15:35:00',3.55),('15087','2013-08-20','15:40:00',3.56),('15087','2013-08-20','15:45:00',3.56),('15087','2013-08-20','15:50:00',3.86),('15087','2013-08-20','15:55:00',3.79),('15087','2013-08-20','16:00:00',3.67),('15087','2013-08-20','16:05:00',3.68),('15087','2013-08-20','16:10:00',3.6),('15087','2013-08-20','16:15:00',3.57),('15087','2013-08-20','16:20:00',3.49),('15087','2013-08-20','16:25:00',3.37),('15087','2013-08-20','16:30:00',3.07),('15087','2013-08-20','16:35:00',2.99),('15087','2013-08-20','16:40:00',2.95),('15087','2013-08-20','16:45:00',2.8),('15087','2013-08-20','16:50:00',2.67),('15087','2013-08-20','16:55:00',2.6),('15087','2013-08-20','17:00:00',2.38),('15087','2013-08-20','17:05:00',2.22),('15087','2013-08-20','17:10:00',2.11),('15087','2013-08-20','17:15:00',1.91),('15087','2013-08-20','17:20:00',1.84),('15087','2013-08-20','17:25:00',1.76),('15087','2013-08-20','17:30:00',1.7),('15087','2013-08-20','17:35:00',1.64),('15087','2013-08-20','17:40:00',1.52),('15087','2013-08-20','17:45:00',1.4),('15087','2013-08-20','17:50:00',1.3),('15087','2013-08-20','17:55:00',1.27),('15087','2013-08-20','18:00:00',1.15),('15087','2013-08-20','18:05:00',1.12),('15087','2013-08-20','18:10:00',1.17),('15087','2013-08-20','18:15:00',1.1),('15087','2013-08-20','18:20:00',1.08),('15087','2013-08-20','18:25:00',1.02),('15087','2013-08-20','18:30:00',1.01),('15087','2014-04-10','08:05:00',1.08),('15087','2014-04-10','08:10:00',1.18),('15087','2014-04-10','08:15:00',1.29),('15087','2014-04-10','08:20:00',1.45),('15087','2014-04-10','08:25:00',1.56),('15087','2014-04-10','08:30:00',1.64),('15087','2014-04-10','08:35:00',1.79),('15087','2014-04-10','08:40:00',1.9),('15087','2014-04-10','08:45:00',2.01),('15087','2014-04-10','08:50:00',2.11),('15087','2014-04-10','08:55:00',2.19),('15087','2014-04-10','09:00:00',2.27),('15087','2014-04-10','09:05:00',2.4),('15087','2014-04-10','09:10:00',2.48),('15087','2014-04-10','09:15:00',2.54),('15087','2014-04-10','09:20:00',2.55),('15087','2014-04-10','09:25:00',2.74),('15087','2014-04-10','09:30:00',2.85),('15087','2014-04-10','09:35:00',2.93),('15087','2014-04-10','09:40:00',2.99),('15087','2014-04-10','09:45:00',3.06),('15087','2014-04-10','09:50:00',3.16),('15087','2014-04-10','09:55:00',3.25),('15087','2014-04-10','10:00:00',3.31),('15087','2014-04-10','10:05:00',3.38),('15087','2014-04-10','10:10:00',3.48),('15087','2014-04-10','10:15:00',3.47),('15087','2014-04-10','10:20:00',3.54),('15087','2014-04-10','10:25:00',3.62),('15087','2014-04-10','10:30:00',3.67),('15087','2014-04-10','10:35:00',3.79),('15087','2014-04-10','10:40:00',3.86),('15087','2014-04-10','10:45:00',3.87),('15087','2014-04-10','10:50:00',3.82),('15087','2014-04-10','10:55:00',3.95),('15087','2014-04-10','11:00:00',3.98),('15087','2014-04-10','11:05:00',4.12),('15087','2014-04-10','11:10:00',4.03),('15087','2014-04-10','11:15:00',4.19),('15087','2014-04-10','11:20:00',4.31),('15087','2014-04-10','11:25:00',4.4),('15087','2014-04-10','11:30:00',4.41),('15087','2014-04-10','11:35:00',4.47),('15087','2014-04-10','11:40:00',4.3),('15087','2014-04-10','11:45:00',4.45),('15087','2014-04-10','11:50:00',4.31),('15087','2014-04-10','11:55:00',4.53),('15087','2014-04-10','12:00:00',4.45),('15087','2014-04-10','12:05:00',4.17),('15087','2014-04-10','12:10:00',4.34),('15087','2014-04-10','12:15:00',4.42),('15087','2014-04-10','12:20:00',4.49),('15087','2014-04-10','12:25:00',4.25),('15087','2014-04-10','12:30:00',4.35),('15087','2014-04-10','12:35:00',4.64),('15087','2014-04-10','12:40:00',4.41),('15087','2014-04-10','12:45:00',4.58),('15087','2014-04-10','12:50:00',4.57),('15087','2014-04-10','12:55:00',4.49),('15087','2014-04-10','13:00:00',4.42),('15087','2014-04-10','13:05:00',4.21),('15087','2014-04-10','13:10:00',4.43),('15087','2014-04-10','13:15:00',4.4),('15087','2014-04-10','13:20:00',4.27),('15087','2014-04-10','13:25:00',4.63),('15087','2014-04-10','13:30:00',4.54),('15087','2014-04-10','13:35:00',4.63),('15087','2014-04-10','13:40:00',4.38),('15087','2014-04-10','13:45:00',4.6),('15087','2014-04-10','13:50:00',4.58),('15087','2014-04-10','13:55:00',4.49),('15087','2014-04-10','14:00:00',4.29),('15087','2014-04-10','14:05:00',4.25),('15087','2014-04-10','14:10:00',4.34),('15087','2014-04-10','14:15:00',4.3),('15087','2014-04-10','14:20:00',4.29),('15087','2014-04-10','14:25:00',4.25),('15087','2014-04-10','14:30:00',4.18),('15087','2014-04-10','14:35:00',4.12),('15087','2014-04-10','14:40:00',4.09),('15087','2014-04-10','14:45:00',3.68),('15087','2014-04-10','14:50:00',4.07),('15087','2014-04-10','14:55:00',3.93),('15087','2014-04-10','15:00:00',3.84),('15087','2014-04-10','15:05:00',3.78),('15087','2014-04-10','15:10:00',3.71),('15087','2014-04-10','15:15:00',3.6),('15087','2014-04-10','15:20:00',3.54),('15087','2014-04-10','15:25:00',3.58),('15087','2014-04-10','15:30:00',3.24),('15087','2014-04-10','15:35:00',2.98),('15087','2014-04-10','15:40:00',3.06),('15087','2014-04-10','15:45:00',3.09),('15087','2014-04-10','15:50:00',3.05),('15087','2014-04-10','15:55:00',3.11),('15087','2014-04-10','16:00:00',3.03),('15087','2014-04-10','16:05:00',3.08),('15087','2014-04-10','16:10:00',3.08),('15087','2014-04-10','16:15:00',3.12),('15087','2014-04-10','16:20:00',2.99),('15087','2014-04-10','16:25:00',2.94),('15087','2014-04-10','16:30:00',2.9),('15087','2014-04-10','16:35:00',2.78),('15087','2014-04-10','16:40:00',2.73),('15087','2014-04-10','16:45:00',2.72),('15087','2014-04-10','16:50:00',2.51),('15087','2014-04-10','16:55:00',2.44),('15087','2014-04-10','17:00:00',2.33),('15087','2014-04-10','17:05:00',2.19),('15087','2014-04-10','17:10:00',2.04),('15087','2014-04-10','17:15:00',1.89),('15087','2014-04-10','17:20:00',1.8),('15087','2014-04-10','17:25:00',1.69),('15087','2014-04-10','17:30:00',1.53),('15087','2014-04-10','17:35:00',1.46),('15087','2014-04-10','17:40:00',1.33),('15087','2014-04-10','17:45:00',1.22),('15087','2014-04-10','17:50:00',1.17),('15087','2014-04-10','17:55:00',1.07),('15087','2014-04-10','18:00:00',1.01),('15087','2013-08-19','08:05:00',1.06),('15087','2013-08-19','08:10:00',1.13),('15087','2013-08-19','08:15:00',1.21),('15087','2013-08-19','08:20:00',1.3),('15087','2013-08-19','08:25:00',1.38),('15087','2013-08-19','08:30:00',1.45),('15087','2013-08-19','08:35:00',1.53),('15087','2013-08-19','08:40:00',1.61),('15087','2013-08-19','08:45:00',1.71),('15087','2013-08-19','08:50:00',1.82),('15087','2013-08-19','08:55:00',1.93),('15087','2013-08-19','09:00:00',2.04),('15087','2013-08-19','09:05:00',2.13),('15087','2013-08-19','09:10:00',2.19),('15087','2013-08-19','09:15:00',2.32),('15087','2013-08-19','09:20:00',2.43),('15087','2013-08-19','09:25:00',2.5),('15087','2013-08-19','09:30:00',2.6),('15087','2013-08-19','09:35:00',2.66),('15087','2013-08-19','09:40:00',2.75),('15087','2013-08-19','09:45:00',2.8),('15087','2013-08-19','09:50:00',2.87),('15087','2013-08-19','09:55:00',2.95),('15087','2013-08-19','10:00:00',3.01),('15087','2013-08-19','10:05:00',3.07),('15087','2013-08-19','10:10:00',3.13),('15087','2013-08-19','10:15:00',3.2),('15087','2013-08-19','10:20:00',3.19),('15087','2013-08-19','10:25:00',3.26),('15087','2013-08-19','10:30:00',3.35),('15087','2013-08-19','10:35:00',3.4),('15087','2013-08-19','10:40:00',3.43),('15087','2013-08-19','10:45:00',3.48),('15087','2013-08-19','10:50:00',3.53),('15087','2013-08-19','10:55:00',3.59),('15087','2013-08-19','11:00:00',3.66),('15087','2013-08-19','11:05:00',3.68),('15087','2013-08-19','11:10:00',3.75),('15087','2013-08-19','11:15:00',3.77),('15087','2013-08-19','11:20:00',3.8),('15087','2013-08-19','11:25:00',3.83),('15087','2013-08-19','11:30:00',3.86),('15087','2013-08-19','11:35:00',3.86),('15087','2013-08-19','11:40:00',3.87),('15087','2013-08-19','11:45:00',3.88),('15087','2013-08-19','11:50:00',3.89),('15087','2013-08-19','11:55:00',3.9),('15087','2013-08-19','12:00:00',4.03),('15087','2013-08-19','12:05:00',4.02),('15087','2013-08-19','12:10:00',4.05),('15087','2013-08-19','12:15:00',4.11),('15087','2013-08-19','12:20:00',4.11),('15087','2013-08-19','12:25:00',4.14),('15087','2013-08-19','12:30:00',4.17),('15087','2013-08-19','12:35:00',4.16),('15087','2013-08-19','12:40:00',4.2),('15087','2013-08-19','12:45:00',4.21),('15087','2013-08-19','12:50:00',4.22),('15087','2013-08-19','12:55:00',4.29),('15087','2013-08-19','13:00:00',4.28),('15087','2013-08-19','13:05:00',4.27),('15087','2013-08-19','13:10:00',4.25),('15087','2013-08-19','13:15:00',4.27),('15087','2013-08-19','13:20:00',4.29),('15087','2013-08-19','13:25:00',4.28),('15087','2013-08-19','13:30:00',4.29),('15087','2013-08-19','13:35:00',4.29),('15087','2013-08-19','13:40:00',4.28),('15087','2013-08-19','13:45:00',4.27),('15087','2013-08-19','13:50:00',4.26),('15087','2013-08-19','13:55:00',4.24),('15087','2013-08-19','14:00:00',4.12),('15087','2013-08-19','14:05:00',4.09),('15087','2013-08-19','14:10:00',4.16),('15087','2013-08-19','14:15:00',4.1),('15087','2013-08-19','14:20:00',4.03),('15087','2013-08-19','14:25:00',3.94),('15087','2013-08-19','14:30:00',3.84),('15087','2013-08-19','14:35:00',3.9),('15087','2013-08-19','14:40:00',3.79),('15087','2013-08-19','14:45:00',3.84),('15087','2013-08-19','14:50:00',3.72),('15087','2013-08-19','14:55:00',3.78),('15087','2013-08-19','15:00:00',3.71),('15087','2013-08-19','15:05:00',3.63),('15087','2013-08-19','15:10:00',3.64),('15087','2013-08-19','15:15:00',3.59),('15087','2013-08-19','15:20:00',3.51),('15087','2013-08-19','15:25:00',3.32),('15087','2013-08-19','15:30:00',3.19),('15087','2013-08-19','15:35:00',3.14),('15087','2013-08-19','15:40:00',3.26),('15087','2013-08-19','15:45:00',3.21),('15087','2013-08-19','15:50:00',3.15),('15087','2013-08-19','15:55:00',3.1),('15087','2013-08-19','16:00:00',3.03),('15087','2013-08-19','16:05:00',2.98),('15087','2013-08-19','16:10:00',2.93),('15087','2013-08-19','16:15:00',2.84),('15087','2013-08-19','16:20:00',2.8),('15087','2013-08-19','16:25:00',2.67),('15087','2013-08-19','16:30:00',2.54),('15087','2013-08-19','16:35:00',2.37),('15087','2013-08-19','16:40:00',2.4),('15087','2013-08-19','16:45:00',2.3),('15087','2013-08-19','16:50:00',2.15),('15087','2013-08-19','16:55:00',2.23),('15087','2013-08-19','17:00:00',2.13),('15087','2013-08-19','17:05:00',2.05),('15087','2013-08-19','17:10:00',1.98),('15087','2013-08-19','17:15:00',1.9),('15087','2013-08-19','17:20:00',1.83),('15087','2013-08-19','17:25:00',1.74),('15087','2013-08-19','17:30:00',1.67),('15087','2013-08-19','17:35:00',1.58),('15087','2013-08-19','17:40:00',1.5),('15087','2013-08-19','17:45:00',1.35),('15087','2013-08-19','17:50:00',1.34),('15087','2013-08-19','17:55:00',1.32),('15087','2013-08-19','18:00:00',1.26),('15087','2013-08-19','18:05:00',1.21),('15087','2013-08-19','18:10:00',1.1),('15087','2013-08-18','08:00:00',1.02),('15087','2013-08-18','08:05:00',1.11),('15087','2013-08-18','08:10:00',1.2),('15087','2013-08-18','08:15:00',1.3),('15087','2013-08-18','08:20:00',1.39),('15087','2013-08-18','08:25:00',1.47),('15087','2013-08-18','08:30:00',1.55),('15087','2013-08-18','08:35:00',1.64),('15087','2013-08-18','08:40:00',1.73),('15087','2013-08-18','08:45:00',1.81),('15087','2013-08-18','08:50:00',1.88),('15087','2013-08-18','08:55:00',1.97),('15087','2013-08-18','09:00:00',2.09),('15087','2013-08-18','09:05:00',2.19),('15087','2013-08-18','09:10:00',2.3),('15087','2013-08-18','09:15:00',2.43),('15087','2013-08-18','09:20:00',2.52),('15087','2013-08-18','09:25:00',2.62),('15087','2013-08-18','09:30:00',2.69),('15087','2013-08-18','09:35:00',2.75),('15087','2013-08-18','09:40:00',2.78),('15087','2013-08-18','09:45:00',2.66),('15087','2013-08-18','09:50:00',2.84),('15087','2013-08-18','09:55:00',2.27),('15087','2013-08-18','10:00:00',2.9),('15087','2013-08-18','10:05:00',2.49),('15087','2013-08-18','10:10:00',3.13),('15087','2013-08-18','10:15:00',3.2),('15087','2013-08-18','10:20:00',3.28),('15087','2013-08-18','10:25:00',3.32),('15087','2013-08-18','10:30:00',3.37),('15087','2013-08-18','10:35:00',3.4),('15087','2013-08-18','10:40:00',3.42),('15087','2013-08-18','10:45:00',3.46),('15087','2013-08-18','10:50:00',3.51),('15087','2013-08-18','10:55:00',3.47),('15087','2013-08-18','11:00:00',3.61),('15087','2013-08-18','11:05:00',3.67),('15087','2013-08-18','11:10:00',3.71),('15087','2013-08-18','11:15:00',3.76),('15087','2013-08-18','11:20:00',3.76),('15087','2013-08-18','11:25:00',3.8),('15087','2013-08-18','11:30:00',3.83),('15087','2013-08-18','11:35:00',3.88),('15087','2013-08-18','11:40:00',3.9),('15087','2013-08-18','11:45:00',3.93),('15087','2013-08-18','11:50:00',3.94),('15087','2013-08-18','11:55:00',3.96),('15087','2013-08-18','12:00:00',4.05),('15087','2013-08-18','12:05:00',4.08),('15087','2013-08-18','12:10:00',4.16),('15087','2013-08-18','12:15:00',4.25),('15087','2013-08-18','12:20:00',4.19),('15087','2013-08-18','12:25:00',3.58),('15087','2013-08-18','12:30:00',1.32),('15087','2013-08-18','12:45:00',1.18),('15087','2013-08-18','12:50:00',1.79),('15087','2013-08-18','12:55:00',1.65),('15087','2013-08-18','13:00:00',3.81),('15087','2013-08-18','13:05:00',4.09),('15087','2013-08-18','13:10:00',4.38),('15087','2013-08-18','13:15:00',4.36),('15087','2013-08-18','13:20:00',4.37),('15087','2013-08-18','13:25:00',4.28),('15087','2013-08-18','13:30:00',4.28),('15087','2013-08-18','13:35:00',4.3),('15087','2013-08-18','13:40:00',4.33),('15087','2013-08-18','13:45:00',4.29),('15087','2013-08-18','13:50:00',4.2),('15087','2013-08-18','13:55:00',4.18),('15087','2013-08-18','14:00:00',4.23),('15087','2013-08-18','14:05:00',4.13),('15087','2013-08-18','14:10:00',4.12),('15087','2013-08-18','14:15:00',4.13),('15087','2013-08-18','14:20:00',4.06),('15087','2013-08-18','14:25:00',4.01),('15087','2013-08-18','14:30:00',3.89),('15087','2013-08-18','14:35:00',3.94),('15087','2013-08-18','14:40:00',3.89),('15087','2013-08-18','14:45:00',3.83),('15087','2013-08-18','14:50:00',3.74),('15087','2013-08-18','14:55:00',3.64),('15087','2013-08-18','15:00:00',3.68),('15087','2013-08-18','15:05:00',3.61),('15087','2013-08-18','15:10:00',3.62),('15087','2013-08-18','15:15:00',3.57),('15087','2013-08-18','15:20:00',3.46),('15087','2013-08-18','15:25:00',3.09),('15087','2013-08-18','15:30:00',3.17),('15087','2013-08-18','15:35:00',3.22),('15087','2013-08-18','15:40:00',3.24),('15087','2013-08-18','15:45:00',3.12),('15087','2013-08-18','15:50:00',3.1),('15087','2013-08-18','15:55:00',3.07),('15087','2013-08-18','16:00:00',3.02),('15087','2013-08-18','16:05:00',2.94),('15087','2013-08-18','16:10:00',2.73),('15087','2013-08-18','16:15:00',2.5),('15087','2013-08-18','16:20:00',2.72),('15087','2013-08-18','16:25:00',2.68),('15087','2013-08-18','16:30:00',2.58),('15087','2013-08-18','16:35:00',2.5),('15087','2013-08-18','16:40:00',2.41),('15087','2013-08-18','16:45:00',2.34),('15087','2013-08-18','16:50:00',2.25),('15087','2013-08-18','16:55:00',2.21),('15087','2013-08-18','17:00:00',2.21),('15087','2013-08-18','17:05:00',2.09),('15087','2013-08-18','17:10:00',2.04),('15087','2013-08-18','17:15:00',1.92),('15087','2013-08-18','17:20:00',1.85),('15087','2013-08-18','17:25:00',1.78),('15087','2013-08-18','17:30:00',1.69),('15087','2013-08-18','17:35:00',1.59),('15087','2013-08-18','17:40:00',1.51),('15087','2013-08-18','17:45:00',1.35),('15087','2013-08-18','17:50:00',1.37),('15087','2013-08-18','17:55:00',1.31),('15087','2013-08-18','18:00:00',1.26),('15087','2013-08-18','18:05:00',1.22),('15087','2013-08-18','18:10:00',1.13),('15087','2013-08-18','18:15:00',1),('15087','2013-08-17','08:05:00',1.07),('15087','2013-08-17','08:10:00',1.15),('15087','2013-08-17','08:15:00',1.23),('15087','2013-08-17','08:20:00',1.32),('15087','2013-08-17','08:25:00',1.41),('15087','2013-08-17','08:30:00',1.5),('15087','2013-08-17','08:35:00',1.59),('15087','2013-08-17','08:40:00',1.69),('15087','2013-08-17','08:45:00',1.77),('15087','2013-08-17','08:50:00',1.87),('15087','2013-08-17','08:55:00',1.96),('15087','2013-08-17','09:00:00',2.07),('15087','2013-08-17','09:05:00',2.22),('15087','2013-08-17','09:10:00',2.28),('15087','2013-08-17','09:15:00',2.37),('15087','2013-08-17','09:20:00',2.49),('15087','2013-08-17','09:25:00',2.59),('15087','2013-08-17','09:30:00',2.66),('15087','2013-08-17','09:35:00',2.72),('15087','2013-08-17','09:40:00',2.79),('15087','2013-08-17','09:45:00',2.85),('15087','2013-08-17','09:50:00',2.91),('15087','2013-08-17','09:55:00',2.99),('15087','2013-08-17','10:00:00',3.05),('15087','2013-08-17','10:05:00',3.11),('15087','2013-08-17','10:10:00',3.16),('15087','2013-08-17','10:15:00',3.23),('15087','2013-08-17','10:20:00',3.29),('15087','2013-08-17','10:25:00',3.35),('15087','2013-08-17','10:30:00',3.4),('15087','2013-08-17','10:35:00',3.46),('15087','2013-08-17','10:40:00',3.5),('15087','2013-08-17','10:45:00',3.56),('15087','2013-08-17','10:50:00',3.6),('15087','2013-08-17','10:55:00',3.64),('15087','2013-08-17','11:00:00',3.61),('15087','2013-08-17','11:05:00',3.71),('15087','2013-08-17','11:10:00',3.74),('15087','2013-08-17','11:15:00',3.77),('15087','2013-08-17','11:20:00',3.84),('15087','2013-08-17','11:25:00',3.88),('15087','2013-08-17','11:30:00',3.87),('15087','2013-08-17','11:35:00',3.91),('15087','2013-08-17','11:40:00',3.97),('15087','2013-08-17','11:45:00',4.03),('15087','2013-08-17','11:50:00',3.95),('15087','2013-08-17','11:55:00',3.86),('15087','2013-08-17','12:00:00',4.02),('15087','2013-08-17','12:05:00',4.11),('15087','2013-08-17','12:10:00',4.09),('15087','2013-08-17','12:15:00',4.03),('15087','2013-08-17','12:20:00',4.01),('15087','2013-08-17','12:25:00',4.24),('15087','2013-08-17','12:30:00',4.28),('15087','2013-08-17','12:35:00',4.27),('15087','2013-08-17','12:40:00',3.89),('15087','2013-08-17','12:45:00',4.16),('15087','2013-08-17','12:50:00',4.27),('15087','2013-08-17','12:55:00',4.32),('15087','2013-08-17','13:00:00',4.35),('15087','2013-08-17','13:05:00',4.17),('15087','2013-08-17','13:10:00',2.22),('15087','2013-08-17','13:15:00',4.3),('15087','2013-08-17','13:20:00',4.44),('15087','2013-08-17','13:25:00',4.44),('15087','2013-08-17','13:30:00',4.44),('15087','2013-08-17','13:35:00',4.11),('15087','2013-08-17','13:40:00',1.27),('15087','2013-08-17','13:45:00',4.29),('15087','2013-08-17','13:50:00',1.79),('15087','2013-08-17','13:55:00',2.96),('15087','2013-08-17','14:00:00',4.19),('15087','2013-08-17','14:05:00',4.16),('15087','2013-08-17','14:10:00',3.66),('15087','2013-08-17','14:15:00',3.59),('15087','2013-08-17','14:20:00',4.16),('15087','2013-08-17','14:25:00',4.04),('15087','2013-08-17','14:30:00',3.99),('15087','2013-08-17','14:35:00',3.93),('15087','2013-08-17','14:40:00',3.81),('15087','2013-08-17','14:45:00',3.79),('15087','2013-08-17','14:50:00',3.82),('15087','2013-08-17','14:55:00',3.78),('15087','2013-08-17','15:00:00',3.72),('15087','2013-08-17','15:05:00',3.67),('15087','2013-08-17','15:10:00',3.6),('15087','2013-08-17','15:15:00',3.56),('15087','2013-08-17','15:20:00',3.55),('15087','2013-08-17','15:25:00',3.39),('15087','2013-08-17','15:30:00',3.23),('15087','2013-08-17','15:35:00',3.29),('15087','2013-08-17','15:40:00',3.29),('15087','2013-08-17','15:45:00',3.18),('15087','2013-08-17','15:50:00',3.13),('15087','2013-08-17','15:55:00',3.1),('15087','2013-08-17','16:00:00',3.05),('15087','2013-08-17','16:05:00',2.97),('15087','2013-08-17','16:10:00',2.92),('15087','2013-08-17','16:15:00',2.89),('15087','2013-08-17','16:20:00',2.83),('15087','2013-08-17','16:25:00',2.77),('15087','2013-08-17','16:30:00',2.73),('15087','2013-08-17','16:35:00',2.67),('15087','2013-08-17','16:40:00',2.52),('15087','2013-08-17','16:45:00',2.32),('15087','2013-08-17','16:50:00',2.34),('15087','2013-08-17','16:55:00',2.25),('15087','2013-08-17','17:00:00',2.08),('15087','2013-08-17','17:05:00',2.08),('15087','2013-08-17','17:10:00',1.96),('15087','2013-08-17','17:15:00',1.78),('15087','2013-08-17','17:20:00',1.81),('15087','2013-08-17','17:25:00',1.85),('15087','2013-08-17','17:30:00',1.8),('15087','2013-08-17','17:35:00',1.72),('15087','2013-08-17','17:40:00',1.52),('15087','2013-08-17','17:45:00',1.5),('15087','2013-08-17','17:50:00',1.46),('15087','2013-08-17','17:55:00',1.39),('15087','2013-08-17','18:00:00',1.36),('15087','2013-08-17','18:05:00',1.28),('15087','2013-08-17','18:10:00',1.21),('15087','2013-08-17','18:15:00',1.07),('15087','2013-08-16','08:00:00',1.02),('15087','2013-08-16','08:05:00',1.11),('15087','2013-08-16','08:10:00',1.2),('15087','2013-08-16','08:15:00',1.29),('15087','2013-08-16','08:20:00',1.39),('15087','2013-08-16','08:25:00',1.48),('15087','2013-08-16','08:30:00',1.57),('15087','2013-08-16','08:35:00',1.65),('15087','2013-08-16','08:40:00',1.76),('15087','2013-08-16','08:45:00',1.83),('15087','2013-08-16','08:50:00',1.92),('15087','2013-08-16','08:55:00',2.08),('15087','2013-08-16','09:00:00',2.19),('15087','2013-08-16','09:05:00',2.3),('15087','2013-08-16','09:10:00',2.4),('15087','2013-08-16','09:15:00',2.49),('15087','2013-08-16','09:20:00',2.58),('15087','2013-08-16','09:25:00',2.66),('15087','2013-08-16','09:30:00',2.71),('15087','2013-08-16','09:35:00',2.82),('15087','2013-08-16','09:40:00',2.89),('15087','2013-08-16','09:45:00',2.96),('15087','2013-08-16','09:50:00',3.04),('15087','2013-08-16','09:55:00',3.12),('15087','2013-08-16','10:00:00',3.18),('15087','2013-08-16','10:05:00',3.25),('15087','2013-08-16','10:10:00',3.3),('15087','2013-08-16','10:15:00',3.35),('15087','2013-08-16','10:20:00',3.42),('15087','2013-08-16','10:25:00',3.49),('15087','2013-08-16','10:30:00',3.54),('15087','2013-08-16','10:35:00',3.58),('15087','2013-08-16','10:40:00',3.63),('15087','2013-08-16','10:45:00',3.69),('15087','2013-08-16','10:50:00',3.75),('15087','2013-08-16','10:55:00',3.81),('15087','2013-08-16','11:00:00',3.84),('15087','2013-08-16','11:05:00',3.88),('15087','2013-08-16','11:10:00',3.94),('15087','2013-08-16','11:15:00',3.96),('15087','2013-08-16','11:20:00',3.97),('15087','2013-08-16','11:25:00',4.01),('15087','2013-08-16','11:30:00',4.02),('15087','2013-08-16','11:35:00',4.06),('15087','2013-08-16','11:40:00',4.1),('15087','2013-08-16','11:45:00',4.07),('15087','2013-08-16','11:50:00',4.11),('15087','2013-08-16','11:55:00',4.13),('15087','2013-08-16','12:00:00',4.13),('15087','2013-08-16','12:05:00',4.2),('15087','2013-08-16','12:10:00',4.22),('15087','2013-08-16','12:15:00',4.21),('15087','2013-08-16','12:20:00',4.23),('15087','2013-08-16','12:25:00',4.24),('15087','2013-08-16','12:30:00',4.27),('15087','2013-08-16','12:35:00',4.28),('15087','2013-08-16','12:40:00',4.28),('15087','2013-08-16','12:45:00',4.28),('15087','2013-08-16','12:50:00',4.29),('15087','2013-08-16','12:55:00',4.27),('15087','2013-08-16','13:00:00',4.26),('15087','2013-08-16','13:05:00',4.28),('15087','2013-08-16','13:10:00',4.26),('15087','2013-08-16','13:15:00',4.26),('15087','2013-08-16','13:20:00',4.26),('15087','2013-08-16','13:25:00',4.24),('15087','2013-08-16','13:30:00',4.25),('15087','2013-08-16','13:35:00',4.25),('15087','2013-08-16','13:40:00',4.23),('15087','2013-08-16','13:45:00',4.2),('15087','2013-08-16','13:50:00',4.22),('15087','2013-08-16','13:55:00',4.23),('15087','2013-08-16','14:00:00',4.11),('15087','2013-08-16','14:05:00',4.1),('15087','2013-08-16','14:10:00',4.07),('15087','2013-08-16','14:15:00',4.06),('15087','2013-08-16','14:20:00',3.99),('15087','2013-08-16','14:25:00',3.86),('15087','2013-08-16','14:30:00',3.85),('15087','2013-08-16','14:35:00',3.86),('15087','2013-08-16','14:40:00',3.86),('15087','2013-08-16','14:45:00',3.68),('15087','2013-08-16','14:50:00',3.73),('15087','2013-08-16','14:55:00',3.68),('15087','2013-08-16','15:00:00',3.62),('15087','2013-08-16','15:05:00',3.51),('15087','2013-08-16','15:10:00',3.42),('15087','2013-08-16','15:15:00',3.49),('15087','2013-08-16','15:20:00',3.52),('15087','2013-08-16','15:25:00',3.44),('15087','2013-08-16','15:30:00',3.31),('15087','2013-08-16','15:35:00',3.34),('15087','2013-08-16','15:40:00',3.28),('15087','2013-08-16','15:45:00',3.19),('15087','2013-08-16','15:50:00',3.06),('15087','2013-08-16','15:55:00',2.95),('15087','2013-08-16','16:00:00',2.84),('15087','2013-08-16','16:05:00',2.99),('15087','2013-08-16','16:10:00',2.95),('15087','2013-08-16','16:15:00',2.88),('15087','2013-08-16','16:20:00',2.81),('15087','2013-08-16','16:25:00',2.75),('15087','2013-08-16','16:30:00',2.71),('15087','2013-08-16','16:35:00',2.66),('15087','2013-08-16','16:40:00',2.52),('15087','2013-08-16','16:45:00',2.36),('15087','2013-08-16','16:50:00',2.38),('15087','2013-08-16','16:55:00',2.25),('15087','2013-08-16','17:00:00',2.2),('15087','2013-08-16','17:05:00',2.12),('15087','2013-08-16','17:10:00',2.05),('15087','2013-08-16','17:15:00',1.96),('15087','2013-08-16','17:20:00',1.85),('15087','2013-08-16','17:25:00',1.77),('15087','2013-08-16','17:30:00',1.69),('15087','2013-08-16','17:35:00',1.6),('15087','2013-08-16','17:40:00',1.51),('15087','2013-08-16','17:45:00',1.47),('15087','2013-08-16','17:50:00',1.38),('15087','2013-08-16','17:55:00',1.31),('15087','2013-08-16','18:00:00',1.26),('15087','2013-08-16','18:05:00',1.2),('15087','2013-08-16','18:10:00',1.12),('15087','2013-08-16','18:15:00',1.04),('15087','2013-08-15','08:05:00',1.1),('15087','2013-08-15','08:10:00',1.29),('15087','2013-08-15','08:15:00',1.3),('15087','2013-08-15','08:20:00',1.35),('15087','2013-08-15','08:25:00',1.54),('15087','2013-08-15','08:30:00',1.62),('15087','2013-08-15','08:35:00',1.71),('15087','2013-08-15','08:40:00',1.81),('15087','2013-08-15','08:45:00',1.93),('15087','2013-08-15','08:50:00',2.06),('15087','2013-08-15','08:55:00',2.12),('15087','2013-08-15','09:00:00',2.35),('15087','2013-08-15','09:05:00',2.25),('15087','2013-08-15','09:10:00',1.35),('15087','2013-08-15','09:15:00',2.09),('15087','2013-08-15','09:20:00',2.73),('15087','2013-08-15','09:25:00',2.66),('15087','2013-08-15','09:30:00',2.72),('15087','2013-08-15','09:35:00',2.8),('15087','2013-08-15','09:40:00',2.88),('15087','2013-08-15','09:45:00',2.96),('15087','2013-08-15','09:50:00',3.05),('15087','2013-08-15','09:55:00',3.12),('15087','2013-08-15','10:00:00',3.16),('15087','2013-08-15','10:05:00',3.25),('15087','2013-08-15','10:10:00',3.31),('15087','2013-08-15','10:15:00',3.38),('15087','2013-08-15','10:20:00',3.47),('15087','2013-08-15','10:25:00',3.53),('15087','2013-08-15','10:30:00',3.58),('15087','2013-08-15','10:35:00',3.63),('15087','2013-08-15','10:40:00',3.68),('15087','2013-08-15','10:45:00',3.73),('15087','2013-08-15','10:50:00',3.74),('15087','2013-08-15','10:55:00',3.45),('15087','2013-08-15','11:00:00',3.14),('15087','2013-08-15','11:05:00',3.32),('15087','2013-08-15','11:10:00',2.5),('15087','2013-08-15','11:15:00',2.39),('15087','2013-08-15','11:20:00',2.81),('15087','2013-08-15','11:25:00',3.28),('15087','2013-08-15','11:30:00',3.59),('15087','2013-08-15','11:35:00',4.02),('15087','2013-08-15','11:40:00',4.29),('15087','2013-08-15','11:45:00',4.4),('15087','2013-08-15','11:50:00',4.48),('15087','2013-08-15','11:55:00',4.49),('15087','2013-08-15','12:00:00',4.52),('15087','2013-08-15','12:05:00',4.48),('15087','2013-08-15','12:10:00',4.44),('15087','2013-08-15','12:15:00',4.42),('15087','2013-08-15','12:20:00',4.46),('15087','2013-08-15','12:25:00',4.47),('15087','2013-08-15','12:30:00',4.44),('15087','2013-08-15','12:35:00',4.47),('15087','2013-08-15','12:40:00',4.49),('15087','2013-08-15','12:45:00',4.46),('15087','2013-08-15','12:50:00',4.46),('15087','2013-08-15','12:55:00',4.36),('15087','2013-08-15','13:00:00',4.15),('15087','2013-08-15','13:05:00',4.25),('15087','2013-08-15','13:10:00',4.34),('15087','2013-08-15','13:15:00',4.23),('15087','2013-08-15','13:20:00',4.17),('15087','2013-08-15','13:25:00',4.26),('15087','2013-08-15','13:30:00',4.33),('15087','2013-08-15','13:35:00',4.4),('15087','2013-08-15','13:40:00',4.38),('15087','2013-08-15','13:45:00',4.35),('15087','2013-08-15','13:50:00',4.32),('15087','2013-08-15','13:55:00',4.25),('15087','2013-08-15','14:00:00',4.12),('15087','2013-08-15','14:05:00',4.17),('15087','2013-08-15','14:10:00',4.19),('15087','2013-08-15','14:15:00',4.19),('15087','2013-08-15','14:20:00',4.13),('15087','2013-08-15','14:25:00',3.94),('15087','2013-08-15','14:30:00',3.93),('15087','2013-08-15','14:35:00',3.87),('15087','2013-08-15','14:40:00',3.93),('15087','2013-08-15','14:45:00',3.79),('15087','2013-08-15','14:50:00',3.7),('15087','2013-08-15','14:55:00',3.75),('15087','2013-08-15','15:00:00',3.69),('15087','2013-08-15','15:05:00',3.61),('15087','2013-08-15','15:10:00',3.46),('15087','2013-08-15','15:15:00',3.52),('15087','2013-08-15','15:20:00',3.48),('15087','2013-08-15','15:25:00',3.44),('15087','2013-08-15','15:30:00',3.32),('15087','2013-08-15','15:35:00',3.27),('15087','2013-08-15','15:40:00',3.24),('15087','2013-08-15','15:45:00',3.16),('15087','2013-08-15','15:50:00',3.07),('15087','2013-08-15','15:55:00',3.01),('15087','2013-08-15','16:00:00',2.96),('15087','2013-08-15','16:05:00',2.96),('15087','2013-08-15','16:10:00',2.91),('15087','2013-08-15','16:15:00',2.76),('15087','2013-08-15','16:20:00',2.75),('15087','2013-08-15','16:25:00',2.47),('15087','2013-08-15','16:30:00',2.44),('15087','2013-08-15','16:35:00',2.41),('15087','2013-08-15','16:40:00',2.32),('15087','2013-08-15','16:45:00',2.22),('15087','2013-08-15','16:50:00',2.15),('15087','2013-08-15','16:55:00',2.24),('15087','2013-08-15','17:00:00',2.06),('15087','2013-08-15','17:05:00',1.99),('15087','2013-08-15','17:10:00',1.97),('15087','2013-08-15','17:15:00',1.86),('15087','2013-08-15','17:20:00',1.76),('15087','2013-08-15','17:25:00',1.7),('15087','2013-08-15','17:30:00',1.63),('15087','2013-08-15','17:35:00',1.57),('15087','2013-08-15','17:40:00',1.5),('15087','2013-08-15','17:45:00',1.43),('15087','2013-08-15','17:50:00',1.33),('15087','2013-08-15','17:55:00',1.31),('15087','2013-08-15','18:00:00',1.25),('15087','2013-08-15','18:05:00',1.16),('15087','2013-08-15','18:10:00',1.09),('15087','2013-08-14','08:00:00',1.02),('15087','2013-08-14','08:05:00',1.11),('15087','2013-08-14','08:10:00',1.19),('15087','2013-08-14','08:15:00',1.29),('15087','2013-08-14','08:20:00',1.35),('15087','2013-08-14','08:25:00',1.39),('15087','2013-08-14','08:30:00',1.52),('15087','2013-08-14','08:35:00',1.57),('15087','2013-08-14','08:40:00',1.56),('15087','2013-08-14','08:45:00',1.69),('15087','2013-08-14','08:50:00',1.84),('15087','2013-08-14','08:55:00',1.91),('15087','2013-08-14','09:00:00',2.09),('15087','2013-08-14','09:05:00',1.93),('15087','2013-08-14','09:10:00',2.3),('15087','2013-08-14','09:15:00',2.46),('15087','2013-08-14','09:20:00',2.59),('15087','2013-08-14','09:25:00',2.47),('15087','2013-08-14','09:30:00',2.74),('15087','2013-08-14','09:35:00',2.06),('15087','2013-08-14','09:40:00',1.24),('15087','2013-08-14','09:45:00',2.78),('15087','2013-08-14','09:50:00',2.32),('15087','2013-08-14','09:55:00',2.81),('15087','2013-08-14','10:00:00',3.12),('15087','2013-08-14','10:05:00',2.74),('15087','2013-08-14','10:10:00',1.56),('15087','2013-08-14','10:15:00',1.1),('15087','2013-08-14','10:20:00',2.66),('15087','2013-08-14','10:25:00',3.5),('15087','2013-08-14','10:30:00',3.86),('15087','2013-08-14','10:35:00',2.99),('15087','2013-08-14','10:40:00',1.51),('15087','2013-08-14','10:45:00',1.03),('15087','2013-08-14','10:50:00',1.05),('15087','2013-08-14','10:55:00',1.22),('15087','2013-08-14','11:00:00',3.57),('15087','2013-08-14','11:05:00',3.92),('15087','2013-08-14','11:10:00',3.73),('15087','2013-08-14','11:15:00',3.84),('15087','2013-08-14','11:20:00',3.61),('15087','2013-08-14','11:25:00',3.78),('15087','2013-08-14','11:30:00',4.38),('15087','2013-08-14','11:35:00',3.32),('15087','2013-08-14','11:40:00',1.65),('15087','2013-08-14','11:45:00',1.46),('15087','2013-08-14','11:50:00',1.82),('15087','2013-08-14','11:55:00',4.12),('15087','2013-08-14','12:00:00',4.09),('15087','2013-08-14','12:05:00',2.93),('15087','2013-08-14','12:10:00',1.62),('15087','2013-08-14','12:15:00',1.34),('15087','2013-08-14','12:20:00',1.17),('15087','2013-08-14','12:25:00',1.86),('15087','2013-08-14','12:30:00',1.2),('15087','2013-08-14','12:35:00',1.28),('15087','2013-08-14','12:40:00',1.47),('15087','2013-08-14','12:45:00',1.98),('15087','2013-08-14','12:50:00',2.38),('15087','2013-08-14','12:55:00',2.98),('15087','2013-08-14','13:00:00',2.72),('15087','2013-08-14','13:05:00',1.07),('15087','2013-08-14','13:10:00',1.14),('15087','2013-08-14','13:15:00',1.46),('15087','2013-08-14','13:20:00',1.28),('15087','2013-08-14','13:25:00',3.39),('15087','2013-08-14','13:30:00',3.72),('15087','2013-08-14','13:35:00',1.96),('15087','2013-08-14','13:40:00',3),('15087','2013-08-14','13:45:00',4.51),('15087','2013-08-14','13:50:00',3.71),('15087','2013-08-14','13:55:00',3),('15087','2013-08-14','14:00:00',4.78),('15087','2013-08-14','14:05:00',4.4),('15087','2013-08-14','14:10:00',3.24),('15087','2013-08-14','14:15:00',4.47),('15087','2013-08-14','14:20:00',3.78),('15087','2013-08-14','14:25:00',3.61),('15087','2013-08-14','14:30:00',4.35),('15087','2013-08-14','14:35:00',4.17),('15087','2013-08-14','14:40:00',3.94),('15087','2013-08-14','14:45:00',3.96),('15087','2013-08-14','14:50:00',4.03),('15087','2013-08-14','14:55:00',3.96),('15087','2013-08-14','15:00:00',3.82),('15087','2013-08-14','15:05:00',3.67),('15087','2013-08-14','15:10:00',3.62),('15087','2013-08-14','15:15:00',3.73),('15087','2013-08-14','15:20:00',3.69),('15087','2013-08-14','15:25:00',3.4),('15087','2013-08-14','15:30:00',3.31),('15087','2013-08-14','15:35:00',3.36),('15087','2013-08-14','15:40:00',3.35),('15087','2013-08-14','15:45:00',3.26),('15087','2013-08-14','15:50:00',3.15),('15087','2013-08-14','15:55:00',3.03),('15087','2013-08-14','16:00:00',2.87),('15087','2013-08-14','16:05:00',3.01),('15087','2013-08-14','16:10:00',3.01),('15087','2013-08-14','16:15:00',2.99),('15087','2013-08-14','16:20:00',2.92),('15087','2013-08-14','16:25:00',2.8),('15087','2013-08-14','16:30:00',2.75),('15087','2013-08-14','16:35:00',2.71),('15087','2013-08-14','16:40:00',2.67),('15087','2013-08-14','16:45:00',2.59),('15087','2013-08-14','16:50:00',2.51),('15087','2013-08-14','16:55:00',2.36),('15087','2013-08-14','17:00:00',2.12),('15087','2013-08-14','17:05:00',2.16),('15087','2013-08-14','17:10:00',2.08),('15087','2013-08-14','17:15:00',2),('15087','2013-08-14','17:20:00',1.91),('15087','2013-08-14','17:25:00',1.81),('15087','2013-08-14','17:30:00',1.71),('15087','2013-08-14','17:35:00',1.57),('15087','2013-08-14','17:40:00',1.56),('15087','2013-08-14','17:45:00',1.4),('15087','2013-08-14','17:50:00',1.45),('15087','2013-08-14','17:55:00',1.35),('15087','2013-08-14','18:00:00',1.28),('15087','2013-08-14','18:05:00',1.26),('15087','2013-08-14','18:10:00',1.15),('15087','2013-08-14','18:15:00',1.09),('15087','2013-08-14','18:20:00',1.02),('15087','2013-08-13','08:00:00',1.06),('15087','2013-08-13','08:05:00',1.07),('15087','2013-08-13','08:10:00',1.22),('15087','2013-08-13','08:15:00',1.3),('15087','2013-08-13','08:20:00',1.38),('15087','2013-08-13','08:25:00',1.48),('15087','2013-08-13','08:30:00',1.57),('15087','2013-08-13','08:35:00',1.65),('15087','2013-08-13','08:40:00',1.75),('15087','2013-08-13','08:45:00',1.82),('15087','2013-08-13','08:50:00',1.94),('15087','2013-08-13','08:55:00',2.05),('15087','2013-08-13','09:00:00',2.17),('15087','2013-08-13','09:05:00',2.29),('15087','2013-08-13','09:10:00',2.39),('15087','2013-08-13','09:15:00',2.47),('15087','2013-08-13','09:20:00',2.54),('15087','2013-08-13','09:25:00',2.61),('15087','2013-08-13','09:30:00',2.72),('15087','2013-08-13','09:35:00',2.8),('15087','2013-08-13','09:40:00',2.81),('15087','2013-08-13','09:45:00',2.89),('15087','2013-08-13','09:50:00',2.97),('15087','2013-08-13','09:55:00',3.07),('15087','2013-08-13','10:00:00',3.12),('15087','2013-08-13','10:05:00',3.18),('15087','2013-08-13','10:10:00',2.94),('15087','2013-08-13','10:15:00',3.26),('15087','2013-08-13','10:20:00',3.34),('15087','2013-08-13','10:25:00',3.46),('15087','2013-08-13','10:30:00',3.5),('15087','2013-08-13','10:35:00',3.49),('15087','2013-08-13','10:40:00',3.5),('15087','2013-08-13','10:45:00',3.51),('15087','2013-08-13','10:50:00',3.64),('15087','2013-08-13','10:55:00',3.66),('15087','2013-08-13','11:00:00',3.74),('15087','2013-08-13','11:05:00',3.77),('15087','2013-08-13','11:10:00',3.78),('15087','2013-08-13','11:15:00',3.83),('15087','2013-08-13','11:20:00',3.89),('15087','2013-08-13','11:25:00',3.91),('15087','2013-08-13','11:30:00',3.92),('15087','2013-08-13','11:35:00',3.92),('15087','2013-08-13','11:40:00',3.94),('15087','2013-08-13','11:45:00',3.95),('15087','2013-08-13','11:50:00',4.05),('15087','2013-08-13','11:55:00',4.12),('15087','2013-08-13','12:00:00',3.25),('15087','2013-08-13','12:05:00',4.15),('15087','2013-08-13','12:10:00',4.31),('15087','2013-08-13','12:15:00',4.43),('15087','2013-08-13','12:20:00',4.38),('15087','2013-08-13','12:25:00',4.48),('15087','2013-08-13','12:30:00',4.53),('15087','2013-08-13','12:35:00',3.46),('15087','2013-08-13','12:40:00',2.21),('15087','2013-08-13','12:45:00',1.33),('15087','2013-08-13','12:50:00',2.59),('15087','2013-08-13','12:55:00',1.87),('15087','2013-08-13','13:00:00',1.32),('15087','2013-08-13','13:05:00',1.75),('15087','2013-08-13','13:10:00',4.88),('15087','2013-08-13','13:15:00',3.75),('15087','2013-08-13','13:20:00',3.44),('15087','2013-08-13','13:25:00',1.3),('15087','2013-08-13','13:30:00',2.27),('15087','2013-08-13','13:35:00',4.85),('15087','2013-08-13','13:40:00',3.04),('15087','2013-08-13','13:45:00',1.43),('15087','2013-08-13','13:50:00',1.45),('15087','2013-08-13','13:55:00',3.63),('15087','2013-08-13','14:00:00',4.75),('15087','2013-08-13','14:05:00',4.18),('15087','2013-08-13','14:10:00',4.49),('15087','2013-08-13','14:15:00',4.25),('15087','2013-08-13','14:20:00',4.28),('15087','2013-08-13','14:25:00',4.05),('15087','2013-08-13','14:30:00',4.68),('15087','2013-08-13','14:35:00',3.66),('15087','2013-08-13','14:40:00',3.68),('15087','2013-08-13','14:45:00',2.3),('15087','2013-08-13','14:50:00',2.4),('15087','2013-08-13','14:55:00',3.92),('15087','2013-08-13','15:00:00',3.96),('15087','2013-08-13','15:05:00',2.94),('15087','2013-08-13','15:10:00',3.91),('15087','2013-08-13','15:15:00',3.73),('15087','2013-08-13','15:20:00',3.39),('15087','2013-08-13','15:25:00',3.61),('15087','2013-08-13','15:30:00',3.46),('15087','2013-08-13','15:35:00',3.26),('15087','2013-08-13','15:40:00',3.41),('15087','2013-08-13','15:45:00',3.33),('15087','2013-08-13','15:50:00',3.2),('15087','2013-08-13','15:55:00',3.05),('15087','2013-08-13','16:00:00',3.01),('15087','2013-08-13','16:05:00',3.04),('15087','2013-08-13','16:10:00',2.98),('15087','2013-08-13','16:15:00',2.92),('15087','2013-08-13','16:20:00',2.87),('15087','2013-08-13','16:25:00',2.79),('15087','2013-08-13','16:30:00',2.75),('15087','2013-08-13','16:35:00',2.53),('15087','2013-08-13','16:40:00',2.45),('15087','2013-08-13','16:45:00',2.42),('15087','2013-08-13','16:50:00',2.47),('15087','2013-08-13','16:55:00',2.35),('15087','2013-08-13','17:00:00',2.25),('15087','2013-08-13','17:05:00',2.19),('15087','2013-08-13','17:10:00',2.09),('15087','2013-08-13','17:15:00',1.99),('15087','2013-08-13','17:20:00',1.92),('15087','2013-08-13','17:25:00',1.83),('15087','2013-08-13','17:30:00',1.7),('15087','2013-08-13','17:35:00',1.61),('15087','2013-08-13','17:40:00',1.58),('15087','2013-08-13','17:45:00',1.52),('15087','2013-08-13','17:50:00',1.44),('15087','2013-08-13','17:55:00',1.31),('15087','2013-08-13','18:00:00',1.28),('15087','2013-08-13','18:05:00',1.23),('15087','2013-08-13','18:10:00',1.15),('15087','2013-08-13','18:15:00',1.07),('15087','2013-08-12','08:00:00',1.05),('15087','2013-08-12','08:05:00',1.13),('15087','2013-08-12','08:10:00',1.21),('15087','2013-08-12','08:15:00',1.3),('15087','2013-08-12','08:20:00',1.38),('15087','2013-08-12','08:25:00',1.46),('15087','2013-08-12','08:30:00',1.54),('15087','2013-08-12','08:35:00',1.64),('15087','2013-08-12','08:40:00',1.73),('15087','2013-08-12','08:45:00',1.81),('15087','2013-08-12','08:50:00',1.89),('15087','2013-08-12','08:55:00',1.97),('15087','2013-08-12','09:00:00',2.05),('15087','2013-08-12','09:05:00',2.16),('15087','2013-08-12','09:10:00',2.28),('15087','2013-08-12','09:15:00',2.42),('15087','2013-08-12','09:20:00',2.52),('15087','2013-08-12','09:25:00',2.58),('15087','2013-08-12','09:30:00',2.65),('15087','2013-08-12','09:35:00',2.74),('15087','2013-08-12','09:40:00',2.8),('15087','2013-08-12','09:45:00',2.87),('15087','2013-08-12','09:50:00',2.93),('15087','2013-08-12','09:55:00',2.98),('15087','2013-08-12','10:00:00',3.05),('15087','2013-08-12','10:05:00',3.12),('15087','2013-08-12','10:10:00',3.16),('15087','2013-08-12','10:15:00',3.21),('15087','2013-08-12','10:20:00',3.28),('15087','2013-08-12','10:25:00',3.35),('15087','2013-08-12','10:30:00',3.37),('15087','2013-08-12','10:35:00',3.41),('15087','2013-08-12','10:40:00',3.5),('15087','2013-08-12','10:45:00',3.56),('15087','2013-08-12','10:50:00',3.6),('15087','2013-08-12','10:55:00',3.63),('15087','2013-08-12','11:00:00',3.65),('15087','2013-08-12','11:05:00',3.71),('15087','2013-08-12','11:10:00',3.72),('15087','2013-08-12','11:15:00',3.76),('15087','2013-08-12','11:20:00',3.82),('15087','2013-08-12','11:25:00',3.86),('15087','2013-08-12','11:30:00',3.92),('15087','2013-08-12','11:35:00',3.98),('15087','2013-08-12','11:40:00',3.99),('15087','2013-08-12','11:45:00',4.04),('15087','2013-08-12','11:50:00',4.14),('15087','2013-08-12','11:55:00',3.53),('15087','2013-08-12','12:00:00',4.26),('15087','2013-08-12','12:05:00',4.24),('15087','2013-08-12','12:10:00',4.15),('15087','2013-08-12','12:15:00',1.39),('15087','2013-08-12','12:20:00',2.47),('15087','2013-08-12','12:25:00',1.58),('15087','2013-08-12','12:30:00',1.98),('15087','2013-08-12','12:35:00',4.09),('15087','2013-08-12','12:40:00',2.83),('15087','2013-08-12','12:45:00',1.31),('15087','2013-08-12','12:50:00',1.28),('15087','2013-08-12','12:55:00',1.93),('15087','2013-08-12','13:15:00',1.04),('15087','2013-08-12','13:20:00',1.33),('15087','2013-08-12','13:25:00',1.52),('15087','2013-08-12','13:30:00',1.31),('15087','2013-08-12','13:35:00',1.33),('15087','2013-08-12','13:40:00',1.17),('15087','2013-08-12','13:45:00',1.26),('15087','2013-08-12','13:50:00',4.67),('15087','2013-08-12','13:55:00',3.42),('15087','2013-08-12','14:00:00',4.46),('15087','2013-08-12','14:05:00',4.32),('15087','2013-08-12','14:10:00',1.27),('15087','2013-08-12','14:15:00',1.05),('15087','2013-08-12','14:35:00',1.16),('15087','2013-08-12','14:40:00',1.23),('15087','2013-08-12','14:45:00',1.8),('15087','2013-08-12','14:50:00',3.08),('15087','2013-08-12','14:55:00',4.2),('15087','2013-08-12','15:00:00',4.26),('15087','2013-08-12','15:05:00',3.74),('15087','2013-08-12','15:10:00',2.93),('15087','2013-08-12','15:15:00',2.39),('15087','2013-08-12','15:20:00',3.23),('15087','2013-08-12','15:25:00',3.7),('15087','2013-08-12','15:30:00',3.56),('15087','2013-08-12','15:35:00',3.38),('15087','2013-08-12','15:40:00',3.21),('15087','2013-08-12','15:45:00',3.29),('15087','2013-08-12','15:50:00',3.27),('15087','2013-08-12','15:55:00',3.1),('15087','2013-08-12','16:00:00',3.04),('15087','2013-08-12','16:05:00',3.01),('15087','2013-08-12','16:10:00',2.96),('15087','2013-08-12','16:15:00',2.88),('15087','2013-08-12','16:20:00',2.85),('15087','2013-08-12','16:25:00',2.6),('15087','2013-08-12','16:30:00',2.62),('15087','2013-08-12','16:35:00',2.57),('15087','2013-08-12','16:40:00',2.34),('15087','2013-08-12','16:45:00',2.4),('15087','2013-08-12','16:50:00',2.42),('15087','2013-08-12','16:55:00',2.43),('15087','2013-08-12','17:00:00',2.25),('15087','2013-08-12','17:05:00',2.2),('15087','2013-08-12','17:10:00',2.03),('15087','2013-08-12','17:15:00',1.96),('15087','2013-08-12','17:20:00',1.89),('15087','2013-08-12','17:25:00',1.81),('15087','2013-08-12','17:30:00',1.69),('15087','2013-08-12','17:35:00',1.59),('15087','2013-08-12','17:40:00',1.56),('15087','2013-08-12','17:45:00',1.48),('15087','2013-08-12','17:50:00',1.38),('15087','2013-08-12','17:55:00',1.31),('15087','2013-08-12','18:00:00',1.26),('15087','2013-08-12','18:05:00',1.19),('15087','2013-08-12','18:10:00',1.11),('15087','2013-08-12','18:15:00',1.07),('15087','2013-08-12','18:20:00',1.01),('15087','2013-08-11','07:55:00',1),('15087','2013-08-11','08:00:00',1.09),('15087','2013-08-11','08:05:00',1.18),('15087','2013-08-11','08:10:00',1.26),('15087','2013-08-11','08:15:00',1.36),('15087','2013-08-11','08:20:00',1.44),('15087','2013-08-11','08:25:00',1.51),('15087','2013-08-11','08:30:00',1.61),('15087','2013-08-11','08:35:00',1.68),('15087','2013-08-11','08:40:00',1.79),('15087','2013-08-11','08:45:00',1.88),('15087','2013-08-11','08:50:00',1.97),('15087','2013-08-11','08:55:00',2.1),('15087','2013-08-11','09:00:00',2.21),('15087','2013-08-11','09:05:00',2.29),('15087','2013-08-11','09:10:00',2.4),('15087','2013-08-11','09:15:00',2.5),('15087','2013-08-11','09:20:00',2.58),('15087','2013-08-11','09:25:00',2.65),('15087','2013-08-11','09:30:00',2.73),('15087','2013-08-11','09:35:00',2.81),('15087','2013-08-11','09:40:00',2.88),('15087','2013-08-11','09:45:00',2.94),('15087','2013-08-11','09:50:00',3.02),('15087','2013-08-11','09:55:00',3.09),('15087','2013-08-11','10:00:00',3.16),('15087','2013-08-11','10:05:00',3.23),('15087','2013-08-11','10:10:00',3.3),('15087','2013-08-11','10:15:00',3.36),('15087','2013-08-11','10:20:00',3.4),('15087','2013-08-11','10:25:00',3.47),('15087','2013-08-11','10:30:00',3.52),('15087','2013-08-11','10:35:00',3.58),('15087','2013-08-11','10:40:00',3.59),('15087','2013-08-11','10:45:00',3.64),('15087','2013-08-11','10:50:00',3.7),('15087','2013-08-11','10:55:00',3.76),('15087','2013-08-11','11:00:00',3.81),('15087','2013-08-11','11:05:00',3.88),('15087','2013-08-11','11:10:00',3.91),('15087','2013-08-11','11:15:00',3.97),('15087','2013-08-11','11:20:00',3.98),('15087','2013-08-11','11:25:00',4.02),('15087','2013-08-11','11:30:00',4.08),('15087','2013-08-11','11:35:00',4.09),('15087','2013-08-11','11:40:00',4.09),('15087','2013-08-11','11:45:00',4.11),('15087','2013-08-11','11:50:00',4.11),('15087','2013-08-11','11:55:00',4.17),('15087','2013-08-11','12:00:00',4.24),('15087','2013-08-11','12:05:00',4.24),('15087','2013-08-11','12:10:00',4.28),('15087','2013-08-11','12:15:00',4.28),('15087','2013-08-11','12:20:00',4.26),('15087','2013-08-11','12:25:00',4.27),('15087','2013-08-11','12:30:00',4.3),('15087','2013-08-11','12:35:00',4.31),('15087','2013-08-11','12:40:00',4.32),('15087','2013-08-11','12:45:00',4.35),('15087','2013-08-11','12:50:00',4.3),('15087','2013-08-11','12:55:00',4.29),('15087','2013-08-11','13:00:00',4.32),('15087','2013-08-11','13:05:00',4.33),('15087','2013-08-11','13:10:00',4.33),('15087','2013-08-11','13:15:00',4.3),('15087','2013-08-11','13:20:00',4.23),('15087','2013-08-11','13:25:00',4.26),('15087','2013-08-11','13:30:00',4.28),('15087','2013-08-11','13:35:00',4.33),('15087','2013-08-11','13:40:00',4.31),('15087','2013-08-11','13:45:00',4.32),('15087','2013-08-11','13:50:00',4.24),('15087','2013-08-11','13:55:00',4.23),('15087','2013-08-11','14:00:00',4.22),('15087','2013-08-11','14:05:00',4.13),('15087','2013-08-11','14:10:00',4.04),('15087','2013-08-11','14:15:00',4.12),('15087','2013-08-11','14:20:00',4.06),('15087','2013-08-11','14:25:00',4.05),('15087','2013-08-11','14:30:00',3.91),('15087','2013-08-11','14:35:00',3.76),('15087','2013-08-11','14:40:00',3.86),('15087','2013-08-11','14:45:00',3.91),('15087','2013-08-11','14:50:00',3.87),('15087','2013-08-11','14:55:00',3.65),('15087','2013-08-11','15:00:00',2.96),('15087','2013-08-11','15:05:00',3.52),('15087','2013-08-11','15:10:00',3.3),('15087','2013-08-11','15:15:00',3.43),('15087','2013-08-11','15:20:00',3.29),('15087','2013-08-11','15:25:00',3.2),('15087','2013-08-11','15:30:00',2.87),('15087','2013-08-11','15:35:00',3.26),('15087','2013-08-11','15:40:00',3.21),('15087','2013-08-11','15:45:00',3.19),('15087','2013-08-11','15:50:00',3.21),('15087','2013-08-11','15:55:00',3.16),('15087','2013-08-11','16:00:00',3.07),('15087','2013-08-11','16:05:00',3.03),('15087','2013-08-11','16:10:00',2.98),('15087','2013-08-11','16:15:00',2.93),('15087','2013-08-11','16:20:00',2.86),('15087','2013-08-11','16:25:00',2.8),('15087','2013-08-11','16:30:00',2.72),('15087','2013-08-11','16:35:00',2.55),('15087','2013-08-11','16:40:00',2.37),('15087','2013-08-11','16:45:00',2.42),('15087','2013-08-11','16:50:00',2.38),('15087','2013-08-11','16:55:00',2.3),('15087','2013-08-11','17:00:00',2.17),('15087','2013-08-11','17:05:00',2.05),('15087','2013-08-11','17:10:00',1.97),('15087','2013-08-11','17:15:00',1.98),('15087','2013-08-11','17:20:00',1.91),('15087','2013-08-11','17:25:00',1.81),('15087','2013-08-11','17:30:00',1.67),('15087','2013-08-11','17:35:00',1.6),('15087','2013-08-11','17:40:00',1.56),('15087','2013-08-11','17:45:00',1.49),('15087','2013-08-11','17:50:00',1.39),('15087','2013-08-11','17:55:00',1.32),('15087','2013-08-11','18:00:00',1.27),('15087','2013-08-11','18:05:00',1.21),('15087','2013-08-11','18:10:00',1.1),('15087','2013-08-11','18:15:00',1.05),('15087','2013-08-10','07:55:00',1.01),('15087','2013-08-10','08:00:00',1.1),('15087','2013-08-10','08:05:00',1.2),('15087','2013-08-10','08:10:00',1.29),('15087','2013-08-10','08:15:00',1.39),('15087','2013-08-10','08:20:00',1.51),('15087','2013-08-10','08:25:00',1.59),('15087','2013-08-10','08:30:00',1.7),('15087','2013-08-10','08:35:00',1.77),('15087','2013-08-10','08:40:00',1.84),('15087','2013-08-10','08:45:00',1.95),('15087','2013-08-10','08:50:00',2.08),('15087','2013-08-10','08:55:00',2.21),('15087','2013-08-10','09:00:00',2.26),('15087','2013-08-10','09:05:00',2.35),('15087','2013-08-10','09:10:00',2.44),('15087','2013-08-10','09:15:00',2.55),('15087','2013-08-10','09:20:00',2.63),('15087','2013-08-10','09:25:00',2.7),('15087','2013-08-10','09:30:00',2.78),('15087','2013-08-10','09:35:00',2.85),('15087','2013-08-10','09:40:00',2.91),('15087','2013-08-10','09:45:00',2.93),('15087','2013-08-10','09:50:00',3.05),('15087','2013-08-10','09:55:00',3.12),('15087','2013-08-10','10:00:00',3.17),('15087','2013-08-10','10:05:00',3.24),('15087','2013-08-10','10:10:00',3.3),('15087','2013-08-10','10:15:00',3.34),('15087','2013-08-10','10:20:00',3.41),('15087','2013-08-10','10:25:00',3.46),('15087','2013-08-10','10:30:00',3.52),('15087','2013-08-10','10:35:00',3.59),('15087','2013-08-10','10:40:00',3.61),('15087','2013-08-10','10:45:00',3.66),('15087','2013-08-10','10:50:00',3.73),('15087','2013-08-10','10:55:00',3.79),('15087','2013-08-10','11:00:00',3.9),('15087','2013-08-10','11:05:00',3.96),('15087','2013-08-10','11:10:00',4.02),('15087','2013-08-10','11:15:00',4.05),('15087','2013-08-10','11:20:00',3.8),('15087','2013-08-10','11:25:00',3.22),('15087','2013-08-10','11:30:00',4.12),('15087','2013-08-10','11:35:00',3.88),('15087','2013-08-10','11:40:00',4.16),('15087','2013-08-10','11:45:00',4.19),('15087','2013-08-10','11:50:00',4.21),('15087','2013-08-10','11:55:00',4.25),('15087','2013-08-10','12:00:00',4.28),('15087','2013-08-10','12:05:00',4.33),('15087','2013-08-10','12:10:00',4.35),('15087','2013-08-10','12:15:00',4.31),('15087','2013-08-10','12:20:00',4.3),('15087','2013-08-10','12:25:00',4.35),('15087','2013-08-10','12:30:00',4.37),('15087','2013-08-10','12:35:00',4.38),('15087','2013-08-10','12:40:00',4.44),('15087','2013-08-10','12:45:00',4.45),('15087','2013-08-10','12:50:00',4.59),('15087','2013-08-10','12:55:00',4.55),('15087','2013-08-10','13:00:00',4.52),('15087','2013-08-10','13:05:00',4.44),('15087','2013-08-10','13:10:00',4.49),('15087','2013-08-10','13:15:00',4.67),('15087','2013-08-10','13:20:00',4.62),('15087','2013-08-10','13:25:00',4.77),('15087','2013-08-10','13:30:00',4.88),('15087','2013-08-10','13:35:00',3.35),('15087','2013-08-10','13:40:00',1.47),('15087','2013-08-10','13:50:00',1.8),('15087','2013-08-10','13:55:00',4.35),('15087','2013-08-10','14:00:00',4.74),('15087','2013-08-10','14:05:00',4.96),('15087','2013-08-10','14:10:00',2.92),('15087','2013-08-10','14:15:00',4.71),('15087','2013-08-10','14:20:00',2.74),('15087','2013-08-10','14:25:00',1.35),('15087','2013-08-10','14:30:00',1.25),('15087','2013-08-10','14:35:00',1.1),('15087','2013-08-10','14:40:00',1.01),('15087','2013-08-10','15:00:00',1.02),('15087','2013-08-10','15:05:00',1.07),('15087','2013-08-10','15:10:00',1.13),('15087','2013-08-10','15:15:00',1.25),('15087','2013-08-10','15:20:00',1.24),('15087','2013-08-10','15:25:00',1.1),('15087','2013-08-10','15:30:00',1.07),('15087','2013-08-10','15:35:00',1.36),('15087','2013-08-10','15:40:00',1.31),('15087','2013-08-10','15:45:00',1.48),('15087','2013-08-10','15:50:00',1.98),('15087','2013-08-10','15:55:00',2.35),('15087','2013-08-10','16:00:00',2.41),('15087','2013-08-10','16:05:00',4.36),('15087','2013-08-10','16:10:00',2.67),('15087','2013-08-10','16:15:00',2.32),('15087','2013-08-10','16:20:00',2.97),('15087','2013-08-10','16:25:00',1.13),('15087','2013-08-10','16:30:00',2.1),('15087','2013-08-10','16:35:00',2.38),('15087','2013-08-10','16:40:00',2.5),('15087','2013-08-10','16:45:00',2.86),('15087','2013-08-10','16:50:00',2.73),('15087','2013-08-10','16:55:00',2.57),('15087','2013-08-10','17:00:00',1.71),('15087','2013-08-10','17:05:00',1.64),('15087','2013-08-10','17:10:00',1.08),('15087','2013-08-10','17:15:00',1.16),('15087','2013-08-10','17:20:00',1.22),('15087','2013-08-10','17:25:00',1.62),('15087','2013-08-10','17:30:00',1.08),('15087','2014-04-09','08:05:00',1.08),('15087','2014-04-09','08:20:00',1.15),('15087','2014-04-09','09:00:00',1.04),('15087','2014-04-09','09:30:00',1.01),('15087','2014-04-09','09:50:00',2.53),('15087','2014-04-09','09:55:00',3.1),('15087','2014-04-09','10:00:00',3.13),('15087','2014-04-09','10:05:00',3.14),('15087','2014-04-09','10:10:00',3.24),('15087','2014-04-09','10:15:00',3.05),('15087','2014-04-09','10:20:00',3.52),('15087','2014-04-09','10:25:00',3.75),('15087','2014-04-09','10:30:00',3.97),('15087','2014-04-09','10:35:00',2.84),('15087','2014-04-09','10:40:00',1.47),('15087','2014-04-09','10:45:00',2.34),('15087','2014-04-09','10:50:00',1.24),('15087','2014-04-09','10:55:00',3.95),('15087','2014-04-09','11:00:00',3.93),('15087','2014-04-09','11:05:00',4.53),('15087','2014-04-09','11:10:00',4.6),('15087','2014-04-09','11:15:00',4.72),('15087','2014-04-09','11:20:00',3.43),('15087','2014-04-09','11:25:00',1.63),('15087','2014-04-09','11:30:00',1.3),('15087','2014-04-09','11:35:00',4.8),('15087','2014-04-09','11:40:00',4.74),('15087','2014-04-09','11:45:00',2.71),('15087','2014-04-09','11:50:00',3.9),('15087','2014-04-09','11:55:00',4.98),('15087','2014-04-09','12:00:00',5.07),('15087','2014-04-09','12:05:00',5.1),('15087','2014-04-09','12:10:00',4.25),('15087','2014-04-09','12:15:00',2.14),('15087','2014-04-09','12:20:00',1.52),('15087','2014-04-09','12:25:00',1.11),('15087','2014-04-09','13:15:00',1.08),('15087','2014-04-09','13:20:00',1.5),('15087','2014-04-09','13:25:00',1.45),('15087','2014-04-09','13:30:00',1.16),('15087','2014-04-09','13:35:00',1.18),('15087','2014-04-09','14:00:00',1.08),('15087','2014-04-09','14:05:00',1.5),('15087','2014-04-09','14:10:00',1.64),('15087','2014-04-09','14:15:00',1.58),('15087','2014-04-09','14:20:00',1.41),('15087','2014-04-09','14:25:00',1.46),('15087','2014-04-09','14:30:00',1.74),('15087','2014-04-09','14:35:00',2.39),('15087','2014-04-09','14:40:00',2.18),('15087','2014-04-09','14:45:00',2.31),('15087','2014-04-09','14:50:00',2.31),('15087','2014-04-09','14:55:00',2.98),('15087','2014-04-09','15:00:00',2.05),('15087','2014-04-09','15:05:00',3.91),('15087','2014-04-09','15:10:00',4.35),('15087','2014-04-09','15:15:00',3.33),('15087','2014-04-09','15:20:00',4.26),('15087','2014-04-09','15:25:00',3.14),('15087','2014-04-09','15:30:00',2.23),('15087','2014-04-09','15:35:00',2.53),('15087','2014-04-09','15:40:00',2.46),('15087','2014-04-09','15:45:00',1.78),('15087','2014-04-09','15:50:00',1.35),('15087','2014-04-09','15:55:00',1.24),('15087','2014-04-09','16:00:00',1.48),('15087','2014-04-09','16:05:00',1.94),('15087','2014-04-09','16:10:00',2.79),('15087','2014-04-09','16:15:00',2.98),('15087','2014-04-09','16:20:00',2.85),('15087','2014-04-09','16:25:00',2.5),('15087','2014-04-09','16:30:00',3.11),('15087','2014-04-09','16:35:00',3.24),('15087','2014-04-09','16:40:00',2.47),('15087','2014-04-09','16:45:00',2.83),('15087','2014-04-09','16:50:00',2.55),('15087','2014-04-09','16:55:00',2.09),('15087','2014-04-09','17:00:00',2.13),('15087','2014-04-09','17:05:00',2.6),('15087','2014-04-09','17:10:00',2.11),('15087','2014-04-09','17:15:00',1.87),('15087','2014-04-09','17:20:00',1.76),('15087','2014-04-09','17:25:00',1.67),('15087','2014-04-09','17:30:00',1.41),('15087','2014-04-09','17:45:00',1.19),('15087','2014-04-09','17:50:00',1.21),('15087','2014-04-09','17:55:00',1.16),('15087','2013-08-09','08:05:00',1.03),('15087','2013-08-09','08:35:00',1.15),('15087','2013-08-09','08:40:00',1.67),('15087','2013-08-09','08:45:00',1.74),('15087','2013-08-09','08:50:00',1.78),('15087','2013-08-09','08:55:00',1.92),('15087','2013-08-09','09:00:00',1.98),('15087','2013-08-09','09:05:00',2.15),('15087','2013-08-09','09:10:00',1.98),('15087','2013-08-09','09:15:00',2.45),('15087','2013-08-09','09:20:00',1.74),('15087','2013-08-09','09:25:00',1.71),('15087','2013-08-09','09:30:00',1.61),('15087','2013-08-09','09:35:00',2.22),('15087','2013-08-09','09:40:00',2.22),('15087','2013-08-09','09:45:00',2.69),('15087','2013-08-09','09:50:00',2.07),('15087','2013-08-09','09:55:00',1.65),('15087','2013-08-09','10:00:00',1.89),('15087','2013-08-09','10:05:00',2.08),('15087','2013-08-09','10:10:00',2.62),('15087','2013-08-09','10:15:00',3.01),('15087','2013-08-09','10:20:00',2.99),('15087','2013-08-09','10:25:00',3),('15087','2013-08-09','10:30:00',2.86),('15087','2013-08-09','10:35:00',2.98),('15087','2013-08-09','10:40:00',2.95),('15087','2013-08-09','10:45:00',3.35),('15087','2013-08-09','10:50:00',3.32),('15087','2013-08-09','10:55:00',3.45),('15087','2013-08-09','11:00:00',3.53),('15087','2013-08-09','11:05:00',3.53),('15087','2013-08-09','11:10:00',3.53),('15087','2013-08-09','11:15:00',3.65),('15087','2013-08-09','11:20:00',3.69),('15087','2013-08-09','11:25:00',3.69),('15087','2013-08-09','11:30:00',3.73),('15087','2013-08-09','11:35:00',3.73),('15087','2013-08-09','11:40:00',3.82),('15087','2013-08-09','11:45:00',3.83),('15087','2013-08-09','11:50:00',3.84),('15087','2013-08-09','11:55:00',3.87),('15087','2013-08-09','12:00:00',3.89),('15087','2013-08-09','12:05:00',3.94),('15087','2013-08-09','12:10:00',3.9),('15087','2013-08-09','12:15:00',3.99),('15087','2013-08-09','12:20:00',4.15),('15087','2013-08-09','12:25:00',3.13),('15087','2013-08-09','12:30:00',2.88),('15087','2013-08-09','12:35:00',3.14),('15087','2013-08-09','12:40:00',4.2),('15087','2013-08-09','12:45:00',3.61),('15087','2013-08-09','12:50:00',2.53),('15087','2013-08-09','12:55:00',3.11),('15087','2013-08-09','13:00:00',1.31),('15087','2013-08-09','13:15:00',1.16),('15087','2013-08-09','13:20:00',1.58),('15087','2013-08-09','13:25:00',2.29),('15087','2013-08-09','13:30:00',1.92),('15087','2013-08-09','13:35:00',1.52),('15087','2013-08-09','13:40:00',1.49),('15087','2013-08-09','13:45:00',1.42),('15087','2013-08-09','13:50:00',1.52),('15087','2013-08-09','13:55:00',1.33),('15087','2013-08-09','14:00:00',1.28),('15087','2013-08-09','14:05:00',1.24),('15087','2013-08-09','14:10:00',1.5),('15087','2013-08-09','14:25:00',1.01),('15087','2013-08-09','14:30:00',1.01),('15087','2013-08-09','15:05:00',1.31),('15087','2013-08-09','15:10:00',2.93),('15087','2013-08-09','15:15:00',2.68),('15087','2013-08-09','15:20:00',1.62),('15087','2013-08-09','15:25:00',1.21),('15087','2013-08-09','15:30:00',1.25),('15087','2013-08-09','15:35:00',2.32),('15087','2013-08-09','15:40:00',1.71),('15087','2013-08-09','15:45:00',2.89),('15087','2013-08-09','15:50:00',2.17),('15087','2013-08-09','15:55:00',1.92),('15087','2013-08-09','16:00:00',1.21),('15087','2013-08-09','16:50:00',1.6),('15087','2013-08-09','16:55:00',2.33),('15087','2013-08-09','17:00:00',1.51),('15087','2013-08-09','17:05:00',1.71),('15087','2013-08-08','08:05:00',1.05),('15087','2013-08-08','08:10:00',1.14),('15087','2013-08-08','08:15:00',1.23),('15087','2013-08-08','08:20:00',1.31),('15087','2013-08-08','08:25:00',1.39),('15087','2013-08-08','08:30:00',1.46),('15087','2013-08-08','08:35:00',1.54),('15087','2013-08-08','08:40:00',1.62),('15087','2013-08-08','08:45:00',1.71),('15087','2013-08-08','08:50:00',1.79),('15087','2013-08-08','08:55:00',1.87),('15087','2013-08-08','09:00:00',1.95),('15087','2013-08-08','09:05:00',2.04),('15087','2013-08-08','09:10:00',2.17),('15087','2013-08-08','09:15:00',2.24),('15087','2013-08-08','09:20:00',2.35),('15087','2013-08-08','09:25:00',2.46),('15087','2013-08-08','09:30:00',2.52),('15087','2013-08-08','09:35:00',2.58),('15087','2013-08-08','09:40:00',2.66),('15087','2013-08-08','09:45:00',2.74),('15087','2013-08-08','09:50:00',2.8),('15087','2013-08-08','09:55:00',2.86),('15087','2013-08-08','10:00:00',2.93),('15087','2013-08-08','10:05:00',2.98),('15087','2013-08-08','10:10:00',3.07),('15087','2013-08-08','10:15:00',3.13),('15087','2013-08-08','10:20:00',3.17),('15087','2013-08-08','10:25:00',3.22),('15087','2013-08-08','10:30:00',3.28),('15087','2013-08-08','10:35:00',3.32),('15087','2013-08-08','10:40:00',3.35),('15087','2013-08-08','10:45:00',3.41),('15087','2013-08-08','10:50:00',3.44),('15087','2013-08-08','10:55:00',3.47),('15087','2013-08-08','11:00:00',3.52),('15087','2013-08-08','11:05:00',3.55),('15087','2013-08-08','11:10:00',3.59),('15087','2013-08-08','11:15:00',3.61),('15087','2013-08-08','11:20:00',3.59),('15087','2013-08-08','11:25:00',3.67),('15087','2013-08-08','11:30:00',3.73),('15087','2013-08-08','11:35:00',3.69),('15087','2013-08-08','11:40:00',3.76),('15087','2013-08-08','11:45:00',3.8),('15087','2013-08-08','11:50:00',3.85),('15087','2013-08-08','11:55:00',3.82),('15087','2013-08-08','12:00:00',3.85),('15087','2013-08-08','12:05:00',3.92),('15087','2013-08-08','12:10:00',3.93),('15087','2013-08-08','12:15:00',3.9),('15087','2013-08-08','12:20:00',3.95),('15087','2013-08-08','12:25:00',3.94),('15087','2013-08-08','12:30:00',3.88),('15087','2013-08-08','12:35:00',4.05),('15087','2013-08-08','12:40:00',4.06),('15087','2013-08-08','12:45:00',4.07),('15087','2013-08-08','12:50:00',4.09),('15087','2013-08-08','12:55:00',4.1),('15087','2013-08-08','13:00:00',4.11),('15087','2013-08-08','13:05:00',4.16),('15087','2013-08-08','13:10:00',4.13),('15087','2013-08-08','13:15:00',4.11),('15087','2013-08-08','13:20:00',4.14),('15087','2013-08-08','13:25:00',4.12),('15087','2013-08-08','13:30:00',4.11),('15087','2013-08-08','13:35:00',4.08),('15087','2013-08-08','13:40:00',3.97),('15087','2013-08-08','13:45:00',4.07),('15087','2013-08-08','13:50:00',4.08),('15087','2013-08-08','13:55:00',4.07),('15087','2013-08-08','14:00:00',4.07),('15087','2013-08-08','14:05:00',4.03),('15087','2013-08-08','14:10:00',3.9),('15087','2013-08-08','14:15:00',3.84),('15087','2013-08-08','14:20:00',3.87),('15087','2013-08-08','14:25:00',3.85),('15087','2013-08-08','14:30:00',3.84),('15087','2013-08-08','14:35:00',3.73),('15087','2013-08-08','14:40:00',3.68),('15087','2013-08-08','14:45:00',3.68),('15087','2013-08-08','14:50:00',3.66),('15087','2013-08-08','14:55:00',3.59),('15087','2013-08-08','15:00:00',3.46),('15087','2013-08-08','15:05:00',3.43),('15087','2013-08-08','15:10:00',3.44),('15087','2013-08-08','15:15:00',3.42),('15087','2013-08-08','15:20:00',3.32),('15087','2013-08-08','15:25:00',3.26),('15087','2013-08-08','15:30:00',3.23),('15087','2013-08-08','15:35:00',3.2),('15087','2013-08-08','15:40:00',3.14),('15087','2013-08-08','15:45:00',3.02),('15087','2013-08-08','15:50:00',2.74),('15087','2013-08-08','15:55:00',2.79),('15087','2013-08-08','16:00:00',2.9),('15087','2013-08-08','16:05:00',2.84),('15087','2013-08-08','16:10:00',2.8),('15087','2013-08-08','16:15:00',2.75),('15087','2013-08-08','16:20:00',2.72),('15087','2013-08-08','16:25:00',2.65),('15087','2013-08-08','16:30:00',2.63),('15087','2013-08-08','16:35:00',2.49),('15087','2013-08-08','16:40:00',2.44),('15087','2013-08-08','16:45:00',2.41),('15087','2013-08-08','16:50:00',2.16),('15087','2013-08-08','16:55:00',2.13),('15087','2013-08-08','17:00:00',2.11),('15087','2013-08-08','17:05:00',1.96),('15087','2013-08-08','17:10:00',1.96),('15087','2013-08-08','17:15:00',1.87),('15087','2013-08-08','17:20:00',1.8),('15087','2013-08-08','17:25:00',1.72),('15087','2013-08-08','17:30:00',1.6),('15087','2013-08-08','17:35:00',1.44),('15087','2013-08-08','17:40:00',1.42),('15087','2013-08-08','17:45:00',1.37),('15087','2013-08-08','17:50:00',1.29),('15087','2013-08-08','17:55:00',1.24),('15087','2013-08-08','18:00:00',1.23),('15087','2013-08-08','18:05:00',1.13),('15087','2013-08-08','18:10:00',1.06),('15087','2013-08-07','08:00:00',1.03),('15087','2013-08-07','08:05:00',1.11),('15087','2013-08-07','08:10:00',1.19),('15087','2013-08-07','08:15:00',1.28),('15087','2013-08-07','08:20:00',1.36),('15087','2013-08-07','08:25:00',1.45),('15087','2013-08-07','08:30:00',1.53),('15087','2013-08-07','08:35:00',1.6),('15087','2013-08-07','08:40:00',1.69),('15087','2013-08-07','08:45:00',1.78),('15087','2013-08-07','08:50:00',1.86),('15087','2013-08-07','08:55:00',1.92),('15087','2013-08-07','09:00:00',2.01),('15087','2013-08-07','09:05:00',2.14),('15087','2013-08-07','09:10:00',2.22),('15087','2013-08-07','09:15:00',2.28),('15087','2013-08-07','09:20:00',2.37),('15087','2013-08-07','09:25:00',2.5),('15087','2013-08-07','09:30:00',2.59),('15087','2013-08-07','09:35:00',2.64),('15087','2013-08-07','09:40:00',2.71),('15087','2013-08-07','09:45:00',2.77),('15087','2013-08-07','09:50:00',2.84),('15087','2013-08-07','09:55:00',2.92),('15087','2013-08-07','10:00:00',2.97),('15087','2013-08-07','10:05:00',3.03),('15087','2013-08-07','10:10:00',3.12),('15087','2013-08-07','10:15:00',3.17),('15087','2013-08-07','10:20:00',3.22),('15087','2013-08-07','10:25:00',3.25),('15087','2013-08-07','10:30:00',3.32),('15087','2013-08-07','10:35:00',3.35),('15087','2013-08-07','10:40:00',3.4),('15087','2013-08-07','10:45:00',3.42),('15087','2013-08-07','10:50:00',3.48),('15087','2013-08-07','10:55:00',3.53),('15087','2013-08-07','11:00:00',3.57),('15087','2013-08-07','11:05:00',3.61),('15087','2013-08-07','11:10:00',3.64),('15087','2013-08-07','11:15:00',3.69),('15087','2013-08-07','11:20:00',3.71),('15087','2013-08-07','11:25:00',3.73),('15087','2013-08-07','11:30:00',3.75),('15087','2013-08-07','11:35:00',3.79),('15087','2013-08-07','11:40:00',3.78),('15087','2013-08-07','11:45:00',3.81),('15087','2013-08-07','11:50:00',3.87),('15087','2013-08-07','11:55:00',3.91),('15087','2013-08-07','12:00:00',3.91),('15087','2013-08-07','12:05:00',3.93),('15087','2013-08-07','12:10:00',3.92),('15087','2013-08-07','12:15:00',3.91),('15087','2013-08-07','12:20:00',3.86),('15087','2013-08-07','12:25:00',3.93),('15087','2013-08-07','12:30:00',4),('15087','2013-08-07','12:35:00',3.95),('15087','2013-08-07','12:40:00',4.02),('15087','2013-08-07','12:45:00',4.01),('15087','2013-08-07','12:50:00',3.98),('15087','2013-08-07','12:55:00',4.02),('15087','2013-08-07','13:00:00',4.03),('15087','2013-08-07','13:05:00',4.2),('15087','2013-08-07','13:10:00',4.18),('15087','2013-08-07','13:15:00',4.17),('15087','2013-08-07','13:20:00',4.08),('15087','2013-08-07','13:25:00',4.12),('15087','2013-08-07','13:30:00',4.17),('15087','2013-08-07','13:35:00',4.14),('15087','2013-08-07','13:40:00',4.18),('15087','2013-08-07','13:45:00',4.13),('15087','2013-08-07','13:50:00',4.14),('15087','2013-08-07','13:55:00',4.15),('15087','2013-08-07','14:00:00',4.13),('15087','2013-08-07','14:05:00',4.08),('15087','2013-08-07','14:10:00',3.98),('15087','2013-08-07','14:15:00',3.84),('15087','2013-08-07','14:20:00',3.83),('15087','2013-08-07','14:25:00',3.82),('15087','2013-08-07','14:30:00',3.75),('15087','2013-08-07','14:35:00',3.69),('15087','2013-08-07','14:40:00',3.7),('15087','2013-08-07','14:45:00',3.7),('15087','2013-08-07','14:50:00',3.73),('15087','2013-08-07','14:55:00',3.66),('15087','2013-08-07','15:00:00',3.58),('15087','2013-08-07','15:05:00',3.43),('15087','2013-08-07','15:10:00',3.5),('15087','2013-08-07','15:15:00',3.49),('15087','2013-08-07','15:20:00',3.46),('15087','2013-08-07','15:25:00',3.32),('15087','2013-08-07','15:30:00',3.32),('15087','2013-08-07','15:35:00',3.28),('15087','2013-08-07','15:40:00',3.22),('15087','2013-08-07','15:45:00',3.12),('15087','2013-08-07','15:50:00',2.95),('15087','2013-08-07','15:55:00',3.01),('15087','2013-08-07','16:00:00',2.93),('15087','2013-08-07','16:05:00',2.84),('15087','2013-08-07','16:10:00',2.78),('15087','2013-08-07','16:15:00',2.72),('15087','2013-08-07','16:20:00',2.48),('15087','2013-08-07','16:25:00',2.6),('15087','2013-08-07','16:30:00',2.53),('15087','2013-08-07','16:35:00',2.55),('15087','2013-08-07','16:40:00',2.46),('15087','2013-08-07','16:45:00',2.44),('15087','2013-08-07','16:50:00',2.33),('15087','2013-08-07','16:55:00',2.3),('15087','2013-08-07','17:00:00',2.21),('15087','2013-08-07','17:05:00',2.09),('15087','2013-08-07','17:10:00',2.06),('15087','2013-08-07','17:15:00',1.87),('15087','2013-08-07','17:20:00',1.87),('15087','2013-08-07','17:25:00',1.76),('15087','2013-08-07','17:30:00',1.65),('15087','2013-08-07','17:35:00',1.35),('15087','2013-08-07','17:40:00',1.48),('15087','2013-08-07','17:45:00',1.4),('15087','2013-08-07','17:50:00',1.3),('15087','2013-08-07','17:55:00',1.26),('15087','2013-08-07','18:00:00',1.22),('15087','2013-08-07','18:05:00',1.1),('15087','2013-08-07','18:10:00',1.06),('15087','2013-08-07','18:15:00',1.04),('15087','2013-08-06','08:00:00',1.01),('15087','2013-08-06','08:05:00',1.09),('15087','2013-08-06','08:10:00',1.17),('15087','2013-08-06','08:15:00',1.26),('15087','2013-08-06','08:20:00',1.32),('15087','2013-08-06','08:25:00',1.41),('15087','2013-08-06','08:30:00',1.5),('15087','2013-08-06','08:35:00',1.58),('15087','2013-08-06','08:40:00',1.66),('15087','2013-08-06','08:45:00',1.75),('15087','2013-08-06','08:50:00',1.83),('15087','2013-08-06','08:55:00',1.9),('15087','2013-08-06','09:00:00',1.99),('15087','2013-08-06','09:05:00',2.11),('15087','2013-08-06','09:10:00',2.19),('15087','2013-08-06','09:15:00',2.31),('15087','2013-08-06','09:20:00',2.4),('15087','2013-08-06','09:25:00',2.47),('15087','2013-08-06','09:30:00',2.56),('15087','2013-08-06','09:35:00',2.65),('15087','2013-08-06','09:40:00',2.71),('15087','2013-08-06','09:45:00',2.77),('15087','2013-08-06','09:50:00',2.82),('15087','2013-08-06','09:55:00',2.9),('15087','2013-08-06','10:00:00',2.98),('15087','2013-08-06','10:05:00',3.03),('15087','2013-08-06','10:10:00',3.09),('15087','2013-08-06','10:15:00',3.15),('15087','2013-08-06','10:20:00',3.2),('15087','2013-08-06','10:25:00',3.24),('15087','2013-08-06','10:30:00',3.3),('15087','2013-08-06','10:35:00',3.31),('15087','2013-08-06','10:40:00',3.38),('15087','2013-08-06','10:45:00',3.4),('15087','2013-08-06','10:50:00',3.45),('15087','2013-08-06','10:55:00',3.5),('15087','2013-08-06','11:00:00',3.54),('15087','2013-08-06','11:05:00',3.57),('15087','2013-08-06','11:10:00',3.6),('15087','2013-08-06','11:15:00',3.63),('15087','2013-08-06','11:20:00',3.7),('15087','2013-08-06','11:25:00',3.74),('15087','2013-08-06','11:30:00',3.77),('15087','2013-08-06','11:35:00',3.8),('15087','2013-08-06','11:40:00',3.81),('15087','2013-08-06','11:45:00',3.82),('15087','2013-08-06','11:50:00',3.87),('15087','2013-08-06','11:55:00',3.88),('15087','2013-08-06','12:00:00',3.89),('15087','2013-08-06','12:05:00',3.89),('15087','2013-08-06','12:10:00',3.93),('15087','2013-08-06','12:15:00',3.93),('15087','2013-08-06','12:20:00',3.89),('15087','2013-08-06','12:25:00',3.94),('15087','2013-08-06','12:30:00',3.93),('15087','2013-08-06','12:35:00',3.95),('15087','2013-08-06','12:40:00',3.98),('15087','2013-08-06','12:45:00',4.06),('15087','2013-08-06','12:50:00',4.04),('15087','2013-08-06','12:55:00',3.96),('15087','2013-08-06','13:00:00',4.01),('15087','2013-08-06','13:05:00',4.01),('15087','2013-08-06','13:10:00',4.11),('15087','2013-08-06','13:15:00',4.11),('15087','2013-08-06','13:20:00',4.1),('15087','2013-08-06','13:25:00',4.07),('15087','2013-08-06','13:30:00',4.16),('15087','2013-08-06','13:35:00',4.16),('15087','2013-08-06','13:40:00',4.18),('15087','2013-08-06','13:45:00',4.19),('15087','2013-08-06','13:50:00',4.2),('15087','2013-08-06','13:55:00',4.19),('15087','2013-08-06','14:00:00',4.17),('15087','2013-08-06','14:05:00',4.16),('15087','2013-08-06','14:10:00',4.15),('15087','2013-08-06','14:15:00',4.06),('15087','2013-08-06','14:20:00',4.02),('15087','2013-08-06','14:25:00',4),('15087','2013-08-06','14:30:00',3.79),('15087','2013-08-06','14:35:00',3.86),('15087','2013-08-06','14:40:00',3.89),('15087','2013-08-06','14:45:00',3.88),('15087','2013-08-06','14:50:00',3.87),('15087','2013-08-06','14:55:00',3.83),('15087','2013-08-06','15:00:00',3.73),('15087','2013-08-06','15:05:00',3.57),('15087','2013-08-06','15:10:00',3.6),('15087','2013-08-06','15:15:00',3.63),('15087','2013-08-06','15:20:00',3.6),('15087','2013-08-06','15:25:00',3.52),('15087','2013-08-06','15:30:00',3.47),('15087','2013-08-06','15:35:00',3.42),('15087','2013-08-06','15:40:00',3.36),('15087','2013-08-06','15:45:00',3.27),('15087','2013-08-06','15:50:00',3.08),('15087','2013-08-06','15:55:00',3.12),('15087','2013-08-06','16:00:00',3.11),('15087','2013-08-06','16:05:00',3.02),('15087','2013-08-06','16:10:00',2.93),('15087','2013-08-06','16:15:00',2.85),('15087','2013-08-06','16:20:00',2.65),('15087','2013-08-06','16:25:00',2.63),('15087','2013-08-06','16:30:00',2.69),('15087','2013-08-06','16:35:00',2.61),('15087','2013-08-06','16:40:00',2.56),('15087','2013-08-06','16:45:00',2.54),('15087','2013-08-06','16:50:00',2.38),('15087','2013-08-06','16:55:00',2.28),('15087','2013-08-06','17:00:00',2.27),('15087','2013-08-06','17:05:00',2.19),('15087','2013-08-06','17:10:00',2.12),('15087','2013-08-06','17:15:00',2.01),('15087','2013-08-06','17:20:00',1.88),('15087','2013-08-06','17:25:00',1.83),('15087','2013-08-06','17:30:00',1.72),('15087','2013-08-06','17:35:00',1.49),('15087','2013-08-06','17:40:00',1.53),('15087','2013-08-06','17:45:00',1.48),('15087','2013-08-06','17:50:00',1.34),('15087','2013-08-06','17:55:00',1.32),('15087','2013-08-06','18:00:00',1.25),('15087','2013-08-06','18:05:00',1.12),('15087','2013-08-06','18:10:00',1.12),('15087','2013-08-06','18:15:00',1.1),('15087','2013-08-05','07:55:00',1.01),('15087','2013-08-05','08:00:00',1.09),('15087','2013-08-05','08:05:00',1.16),('15087','2013-08-05','08:10:00',1.25),('15087','2013-08-05','08:15:00',1.33),('15087','2013-08-05','08:20:00',1.41),('15087','2013-08-05','08:25:00',1.48),('15087','2013-08-05','08:30:00',1.56),('15087','2013-08-05','08:35:00',1.64),('15087','2013-08-05','08:40:00',1.72),('15087','2013-08-05','08:45:00',1.79),('15087','2013-08-05','08:50:00',1.87),('15087','2013-08-05','08:55:00',1.94),('15087','2013-08-05','09:00:00',2.03),('15087','2013-08-05','09:05:00',2.16),('15087','2013-08-05','09:10:00',2.2),('15087','2013-08-05','09:15:00',2.33),('15087','2013-08-05','09:20:00',2.45),('15087','2013-08-05','09:25:00',2.5),('15087','2013-08-05','09:30:00',2.57),('15087','2013-08-05','09:35:00',2.65),('15087','2013-08-05','09:40:00',2.72),('15087','2013-08-05','09:45:00',2.8),('15087','2013-08-05','09:50:00',2.86),('15087','2013-08-05','09:55:00',2.91),('15087','2013-08-05','10:00:00',3),('15087','2013-08-05','10:05:00',3.03),('15087','2013-08-05','10:10:00',3.1),('15087','2013-08-05','10:15:00',3.18),('15087','2013-08-05','10:20:00',3.23),('15087','2013-08-05','10:25:00',3.28),('15087','2013-08-05','10:30:00',3.32),('15087','2013-08-05','10:35:00',3.39),('15087','2013-08-05','10:40:00',3.45),('15087','2013-08-05','10:45:00',3.51),('15087','2013-08-05','10:50:00',3.55),('15087','2013-08-05','10:55:00',3.6),('15087','2013-08-05','11:00:00',3.65),('15087','2013-08-05','11:05:00',3.69),('15087','2013-08-05','11:10:00',3.72),('15087','2013-08-05','11:15:00',3.8),('15087','2013-08-05','11:20:00',3.75),('15087','2013-08-05','11:25:00',3.85),('15087','2013-08-05','11:30:00',3.86),('15087','2013-08-05','11:35:00',3.93),('15087','2013-08-05','11:40:00',3.95),('15087','2013-08-05','11:45:00',3.93),('15087','2013-08-05','11:50:00',3.96),('15087','2013-08-05','11:55:00',4.02),('15087','2013-08-05','12:00:00',4.02),('15087','2013-08-05','12:05:00',4.06),('15087','2013-08-05','12:10:00',4.05),('15087','2013-08-05','12:15:00',4.04),('15087','2013-08-05','12:20:00',4.03),('15087','2013-08-05','12:25:00',4.08),('15087','2013-08-05','12:30:00',4.1),('15087','2013-08-05','12:35:00',4.11),('15087','2013-08-05','12:40:00',4.13),('15087','2013-08-05','12:45:00',4.15),('15087','2013-08-05','12:50:00',4.12),('15087','2013-08-05','12:55:00',4.12),('15087','2013-08-05','13:00:00',4.14),('15087','2013-08-05','13:05:00',4.16),('15087','2013-08-05','13:10:00',4.16),('15087','2013-08-05','13:15:00',4.13),('15087','2013-08-05','13:20:00',4.14),('15087','2013-08-05','13:25:00',4.16),('15087','2013-08-05','13:30:00',4.16),('15087','2013-08-05','13:35:00',4.06),('15087','2013-08-05','13:40:00',4.12),('15087','2013-08-05','13:45:00',4.04),('15087','2013-08-05','13:50:00',4.13),('15087','2013-08-05','13:55:00',4.07),('15087','2013-08-05','14:00:00',4.12),('15087','2013-08-05','14:05:00',4.09),('15087','2013-08-05','14:10:00',4.04),('15087','2013-08-05','14:15:00',3.96),('15087','2013-08-05','14:20:00',3.88),('15087','2013-08-05','14:25:00',3.92),('15087','2013-08-05','14:30:00',3.9),('15087','2013-08-05','14:35:00',3.88),('15087','2013-08-05','14:40:00',3.78),('15087','2013-08-05','14:45:00',3.72),('15087','2013-08-05','14:50:00',3.7),('15087','2013-08-05','14:55:00',3.7),('15087','2013-08-05','15:00:00',3.66),('15087','2013-08-05','15:05:00',3.56),('15087','2013-08-05','15:10:00',3.61),('15087','2013-08-05','15:15:00',3.56),('15087','2013-08-05','15:20:00',3.54),('15087','2013-08-05','15:25:00',3.48),('15087','2013-08-05','15:30:00',3.35),('15087','2013-08-05','15:35:00',3.23),('15087','2013-08-05','15:40:00',3.33),('15087','2013-08-05','15:45:00',3.28),('15087','2013-08-05','15:50:00',3.06),('15087','2013-08-05','15:55:00',3.11),('15087','2013-08-05','16:00:00',3.09),('15087','2013-08-05','16:05:00',3.04),('15087','2013-08-05','16:10:00',2.9),('15087','2013-08-05','16:15:00',2.73),('15087','2013-08-05','16:20:00',2.67),('15087','2013-08-05','16:25:00',2.77),('15087','2013-08-05','16:30:00',2.66),('15087','2013-08-05','16:35:00',2.64),('15087','2013-08-05','16:40:00',2.59),('15087','2013-08-05','16:45:00',2.56),('15087','2013-08-05','16:50:00',2.4),('15087','2013-08-05','16:55:00',2.33),('15087','2013-08-05','17:00:00',2.26),('15087','2013-08-05','17:05:00',2.2),('15087','2013-08-05','17:10:00',2.07),('15087','2013-08-05','17:15:00',1.94),('15087','2013-08-05','17:20:00',1.85),('15087','2013-08-05','17:25:00',1.82),('15087','2013-08-05','17:30:00',1.71),('15087','2013-08-05','17:35:00',1.64),('15087','2013-08-05','17:40:00',1.54),('15087','2013-08-05','17:45:00',1.42),('15087','2013-08-05','17:50:00',1.34),('15087','2013-08-05','17:55:00',1.35),('15087','2013-08-05','18:00:00',1.26),('15087','2013-08-05','18:05:00',1.12),('15087','2013-08-05','18:10:00',1.12),('15087','2013-08-05','18:15:00',1.06),('15087','2013-08-04','07:55:00',1.07),('15087','2013-08-04','08:00:00',1.16),('15087','2013-08-04','08:05:00',1.24),('15087','2013-08-04','08:10:00',1.33),('15087','2013-08-04','08:15:00',1.42),('15087','2013-08-04','08:20:00',1.5),('15087','2013-08-04','08:25:00',1.6),('15087','2013-08-04','08:30:00',1.68),('15087','2013-08-04','08:35:00',1.76),('15087','2013-08-04','08:40:00',1.84),('15087','2013-08-04','08:45:00',1.94),('15087','2013-08-04','08:50:00',2.04),('15087','2013-08-04','08:55:00',2.11),('15087','2013-08-04','09:00:00',2.24),('15087','2013-08-04','09:05:00',2.35),('15087','2013-08-04','09:10:00',2.43),('15087','2013-08-04','09:15:00',2.5),('15087','2013-08-04','09:20:00',2.57),('15087','2013-08-04','09:25:00',2.68),('15087','2013-08-04','09:30:00',2.74),('15087','2013-08-04','09:35:00',2.81),('15087','2013-08-04','09:40:00',2.89),('15087','2013-08-04','09:45:00',2.96),('15087','2013-08-04','09:50:00',3.03),('15087','2013-08-04','09:55:00',3.08),('15087','2013-08-04','10:00:00',3.15),('15087','2013-08-04','10:05:00',3.15),('15087','2013-08-04','10:10:00',3.26),('15087','2013-08-04','10:15:00',3.32),('15087','2013-08-04','10:20:00',3.38),('15087','2013-08-04','10:25:00',3.44),('15087','2013-08-04','10:30:00',3.47),('15087','2013-08-04','10:35:00',3.48),('15087','2013-08-04','10:40:00',3.56),('15087','2013-08-04','10:45:00',3.6),('15087','2013-08-04','10:50:00',3.65),('15087','2013-08-04','10:55:00',3.7),('15087','2013-08-04','11:00:00',3.72),('15087','2013-08-04','11:05:00',3.73),('15087','2013-08-04','11:10:00',3.75),('15087','2013-08-04','11:15:00',3.82),('15087','2013-08-04','11:20:00',3.87),('15087','2013-08-04','11:25:00',3.92),('15087','2013-08-04','11:30:00',3.99),('15087','2013-08-04','11:35:00',4),('15087','2013-08-04','11:40:00',4.01),('15087','2013-08-04','11:45:00',4.08),('15087','2013-08-04','11:50:00',4.14),('15087','2013-08-04','11:55:00',4.18),('15087','2013-08-04','12:00:00',4.15),('15087','2013-08-04','12:05:00',4.14),('15087','2013-08-04','12:10:00',4.22),('15087','2013-08-04','12:15:00',4.22),('15087','2013-08-04','12:20:00',4.21),('15087','2013-08-04','12:25:00',4.22),('15087','2013-08-04','12:30:00',4.24),('15087','2013-08-04','12:35:00',4.22),('15087','2013-08-04','12:40:00',4.3),('15087','2013-08-04','12:45:00',4.28),('15087','2013-08-04','12:50:00',4.27),('15087','2013-08-04','12:55:00',4.26),('15087','2013-08-04','13:00:00',4.17),('15087','2013-08-04','13:05:00',4.21),('15087','2013-08-04','13:10:00',4.22),('15087','2013-08-04','13:15:00',4.18),('15087','2013-08-04','13:20:00',4.23),('15087','2013-08-04','13:25:00',4.28),('15087','2013-08-04','13:30:00',4.28),('15087','2013-08-04','13:35:00',4.34),('15087','2013-08-04','13:40:00',4.34),('15087','2013-08-04','13:45:00',4.35),('15087','2013-08-04','13:50:00',4.33),('15087','2013-08-04','13:55:00',4.33),('15087','2013-08-04','14:00:00',4.33),('15087','2013-08-04','14:05:00',4.31),('15087','2013-08-04','14:10:00',4.27),('15087','2013-08-04','14:15:00',4.17),('15087','2013-08-04','14:20:00',4.08),('15087','2013-08-04','14:25:00',4.13),('15087','2013-08-04','14:30:00',4.1),('15087','2013-08-04','14:35:00',4.08),('15087','2013-08-04','14:40:00',3.99),('15087','2013-08-04','14:45:00',3.87),('15087','2013-08-04','14:50:00',3.93),('15087','2013-08-04','14:55:00',3.91),('15087','2013-08-04','15:00:00',3.84),('15087','2013-08-04','15:05:00',3.73),('15087','2013-08-04','15:10:00',3.77),('15087','2013-08-04','15:15:00',3.71),('15087','2013-08-04','15:20:00',3.68),('15087','2013-08-04','15:25:00',3.61),('15087','2013-08-04','15:30:00',3.42),('15087','2013-08-04','15:35:00',3.36),('15087','2013-08-04','15:40:00',3.44),('15087','2013-08-04','15:45:00',3.33),('15087','2013-08-04','15:50:00',3.2),('15087','2013-08-04','15:55:00',3.22),('15087','2013-08-04','16:00:00',3.12),('15087','2013-08-04','16:05:00',3.11),('15087','2013-08-04','16:10:00',2.98),('15087','2013-08-04','16:15:00',2.63),('15087','2013-08-04','16:20:00',2.6),('15087','2013-08-04','16:25:00',2.88),('15087','2013-08-04','16:30:00',2.76),('15087','2013-08-04','16:35:00',2.72),('15087','2013-08-04','16:40:00',2.67),('15087','2013-08-04','16:45:00',2.59),('15087','2013-08-04','16:50:00',2.5),('15087','2013-08-04','16:55:00',2.42),('15087','2013-08-04','17:00:00',2.38),('15087','2013-08-04','17:05:00',2.3),('15087','2013-08-04','17:10:00',2.18),('15087','2013-08-04','17:15:00',2.11),('15087','2013-08-04','17:20:00',1.96),('15087','2013-08-04','17:25:00',1.92),('15087','2013-08-04','17:30:00',1.78),('15087','2013-08-04','17:35:00',1.73),('15087','2013-08-04','17:40:00',1.54),('15087','2013-08-04','17:45:00',1.44),('15087','2013-08-04','17:50:00',1.38),('15087','2013-08-04','17:55:00',1.42),('15087','2013-08-04','18:00:00',1.29),('15087','2013-08-04','18:05:00',1.09),('15087','2013-08-04','18:10:00',1.19),('15087','2013-08-04','18:15:00',1.1),('15087','2013-08-04','18:20:00',1),('15087','2013-08-03','07:55:00',1.07),('15087','2013-08-03','08:00:00',1.15),('15087','2013-08-03','08:05:00',1.23),('15087','2013-08-03','08:10:00',1.32),('15087','2013-08-03','08:15:00',1.41),('15087','2013-08-03','08:20:00',1.5),('15087','2013-08-03','08:25:00',1.58),('15087','2013-08-03','08:30:00',1.67),('15087','2013-08-03','08:35:00',1.74),('15087','2013-08-03','08:40:00',1.82),('15087','2013-08-03','08:45:00',1.92),('15087','2013-08-03','08:50:00',1.99),('15087','2013-08-03','08:55:00',2.08),('15087','2013-08-03','09:00:00',2.14),('15087','2013-08-03','09:05:00',2.31),('15087','2013-08-03','09:10:00',2.42),('15087','2013-08-03','09:15:00',2.5),('15087','2013-08-03','09:20:00',2.58),('15087','2013-08-03','09:25:00',2.65),('15087','2013-08-03','09:30:00',2.7),('15087','2013-08-03','09:35:00',2.79),('15087','2013-08-03','09:40:00',2.84),('15087','2013-08-03','09:45:00',2.93),('15087','2013-08-03','09:50:00',2.99),('15087','2013-08-03','09:55:00',3.05),('15087','2013-08-03','10:00:00',3.1),('15087','2013-08-03','10:05:00',3.18),('15087','2013-08-03','10:10:00',3.24),('15087','2013-08-03','10:15:00',3.32),('15087','2013-08-03','10:20:00',3.37),('15087','2013-08-03','10:25:00',3.43),('15087','2013-08-03','10:30:00',3.44),('15087','2013-08-03','10:35:00',3.49),('15087','2013-08-03','10:40:00',3.57),('15087','2013-08-03','10:45:00',3.63),('15087','2013-08-03','10:50:00',3.67),('15087','2013-08-03','10:55:00',3.72),('15087','2013-08-03','11:00:00',3.78),('15087','2013-08-03','11:05:00',3.82),('15087','2013-08-03','11:10:00',3.82),('15087','2013-08-03','11:15:00',3.81),('15087','2013-08-03','11:20:00',3.89),('15087','2013-08-03','11:25:00',3.95),('15087','2013-08-03','11:30:00',3.95),('15087','2013-08-03','11:35:00',3.97),('15087','2013-08-03','11:40:00',4.02),('15087','2013-08-03','11:45:00',4.08),('15087','2013-08-03','11:50:00',4.07),('15087','2013-08-03','11:55:00',4.09),('15087','2013-08-03','12:00:00',4.11),('15087','2013-08-03','12:05:00',4.13),('15087','2013-08-03','12:10:00',4.08),('15087','2013-08-03','12:15:00',4.11),('15087','2013-08-03','12:20:00',4.15),('15087','2013-08-03','12:25:00',4.12),('15087','2013-08-03','12:30:00',4.15),('15087','2013-08-03','12:35:00',4.16),('15087','2013-08-03','12:40:00',4.12),('15087','2013-08-03','12:45:00',4.13),('15087','2013-08-03','12:50:00',4.11),('15087','2013-08-03','12:55:00',4.09),('15087','2013-08-03','13:00:00',4.15),('15087','2013-08-03','13:05:00',4.19),('15087','2013-08-03','13:10:00',4.16),('15087','2013-08-03','13:15:00',4.12),('15087','2013-08-03','13:20:00',4.12),('15087','2013-08-03','13:25:00',4.11),('15087','2013-08-03','13:30:00',4.06),('15087','2013-08-03','13:35:00',4.13),('15087','2013-08-03','13:40:00',4.19),('15087','2013-08-03','13:45:00',4.14),('15087','2013-08-03','13:50:00',4.12),('15087','2013-08-03','13:55:00',4.08),('15087','2013-08-03','14:00:00',4.06),('15087','2013-08-03','14:05:00',3.99),('15087','2013-08-03','14:10:00',4),('15087','2013-08-03','14:15:00',3.94),('15087','2013-08-03','14:20:00',3.92),('15087','2013-08-03','14:25:00',3.95),('15087','2013-08-03','14:30:00',3.95),('15087','2013-08-03','14:35:00',3.99),('15087','2013-08-03','14:40:00',3.95),('15087','2013-08-03','14:45:00',3.82),('15087','2013-08-03','14:50:00',3.88),('15087','2013-08-03','14:55:00',3.88),('15087','2013-08-03','15:00:00',3.83),('15087','2013-08-03','15:05:00',3.74),('15087','2013-08-03','15:10:00',3.7),('15087','2013-08-03','15:15:00',3.65),('15087','2013-08-03','15:20:00',3.59),('15087','2013-08-03','15:25:00',3.59),('15087','2013-08-03','15:30:00',3.5),('15087','2013-08-03','15:35:00',3.41),('15087','2013-08-03','15:40:00',3.4),('15087','2013-08-03','15:45:00',3.38),('15087','2013-08-03','15:50:00',3.29),('15087','2013-08-03','15:55:00',3.08),('15087','2013-08-03','16:00:00',3.02),('15087','2013-08-03','16:05:00',2.98),('15087','2013-08-03','16:10:00',2.97),('15087','2013-08-03','16:15:00',2.71),('15087','2013-08-03','16:20:00',2.71),('15087','2013-08-03','16:25:00',2.8),('15087','2013-08-03','16:30:00',2.71),('15087','2013-08-03','16:35:00',2.66),('15087','2013-08-03','16:40:00',2.46),('15087','2013-08-03','16:45:00',2.43),('15087','2013-08-03','16:50:00',2.39),('15087','2013-08-03','16:55:00',2.35),('15087','2013-08-03','17:00:00',2.3),('15087','2013-08-03','17:05:00',2.2),('15087','2013-08-03','17:10:00',2.15),('15087','2013-08-03','17:15:00',2.1),('15087','2013-08-03','17:20:00',1.98),('15087','2013-08-03','17:25:00',1.88),('15087','2013-08-03','17:30:00',1.78),('15087','2013-08-03','17:35:00',1.71),('15087','2013-08-03','17:40:00',1.61),('15087','2013-08-03','17:45:00',1.44),('15087','2013-08-03','17:50:00',1.42),('15087','2013-08-03','17:55:00',1.43),('15087','2013-08-03','18:00:00',1.32),('15087','2013-08-03','18:05:00',1.24),('15087','2013-08-03','18:10:00',1.22),('15087','2013-08-03','18:15:00',1.13),('15087','2013-08-03','18:20:00',1.06),('15087','2013-08-02','07:50:00',1.05),('15087','2013-08-02','07:55:00',1.14),('15087','2013-08-02','08:00:00',1.23),('15087','2013-08-02','08:05:00',1.32),('15087','2013-08-02','08:10:00',1.41),('15087','2013-08-02','08:15:00',1.49),('15087','2013-08-02','08:20:00',1.58),('15087','2013-08-02','08:25:00',1.67),('15087','2013-08-02','08:30:00',1.74),('15087','2013-08-02','08:35:00',1.86),('15087','2013-08-02','08:40:00',1.92),('15087','2013-08-02','08:45:00',2.01),('15087','2013-08-02','08:50:00',2.09),('15087','2013-08-02','08:55:00',2.18),('15087','2013-08-02','09:00:00',2.32),('15087','2013-08-02','09:05:00',2.45),('15087','2013-08-02','09:10:00',2.53),('15087','2013-08-02','09:15:00',2.61),('15087','2013-08-02','09:20:00',2.68),('15087','2013-08-02','09:25:00',2.76),('15087','2013-08-02','09:30:00',2.81),('15087','2013-08-02','09:35:00',2.9),('15087','2013-08-02','09:40:00',2.96),('15087','2013-08-02','09:45:00',3.02),('15087','2013-08-02','09:50:00',3.08),('15087','2013-08-02','09:55:00',3.12),('15087','2013-08-02','10:00:00',3.19),('15087','2013-08-02','10:05:00',3.27),('15087','2013-08-02','10:10:00',3.31),('15087','2013-08-02','10:15:00',3.35),('15087','2013-08-02','10:20:00',3.42),('15087','2013-08-02','10:25:00',3.46),('15087','2013-08-02','10:30:00',3.52),('15087','2013-08-02','10:35:00',3.58),('15087','2013-08-02','10:40:00',3.65),('15087','2013-08-02','10:45:00',3.69),('15087','2013-08-02','10:50:00',3.73),('15087','2013-08-02','10:55:00',3.73),('15087','2013-08-02','11:00:00',3.8),('15087','2013-08-02','11:05:00',3.86),('15087','2013-08-02','11:10:00',3.9),('15087','2013-08-02','11:15:00',3.87),('15087','2013-08-02','11:20:00',3.96),('15087','2013-08-02','11:25:00',4.01),('15087','2013-08-02','11:30:00',4.04),('15087','2013-08-02','11:35:00',4.07),('15087','2013-08-02','11:40:00',4.1),('15087','2013-08-02','11:45:00',4.12),('15087','2013-08-02','11:50:00',4.14),('15087','2013-08-02','11:55:00',4.2),('15087','2013-08-02','12:00:00',4.22),('15087','2013-08-02','12:05:00',4.26),('15087','2013-08-02','12:10:00',4.25),('15087','2013-08-02','12:15:00',4.26),('15087','2013-08-02','12:20:00',4.26),('15087','2013-08-02','12:25:00',4.27),('15087','2013-08-02','12:30:00',4.27),('15087','2013-08-02','12:35:00',4.27),('15087','2013-08-02','12:40:00',4.27),('15087','2013-08-02','12:45:00',4.28),('15087','2013-08-02','12:50:00',4.27),('15087','2013-08-02','12:55:00',4.31),('15087','2013-08-02','13:00:00',4.3),('15087','2013-08-02','13:05:00',4.29),('15087','2013-08-02','13:10:00',4.3),('15087','2013-08-02','13:15:00',4.32),('15087','2013-08-02','13:20:00',4.3),('15087','2013-08-02','13:25:00',4.32),('15087','2013-08-02','13:30:00',4.26),('15087','2013-08-02','13:35:00',4.34),('15087','2013-08-02','13:40:00',4.35),('15087','2013-08-02','13:45:00',4.32),('15087','2013-08-02','13:50:00',4.31),('15087','2013-08-02','13:55:00',4.32),('15087','2013-08-02','14:00:00',4.28),('15087','2013-08-02','14:05:00',4.25),('15087','2013-08-02','14:10:00',4.2),('15087','2013-08-02','14:15:00',4.15),('15087','2013-08-02','14:20:00',4),('15087','2013-08-02','14:25:00',3.95),('15087','2013-08-02','14:30:00',3.99),('15087','2013-08-02','14:35:00',4.13),('15087','2013-08-02','14:40:00',4.11),('15087','2013-08-02','14:45:00',3.98),('15087','2013-08-02','14:50:00',3.97),('15087','2013-08-02','14:55:00',3.96),('15087','2013-08-02','15:00:00',3.92),('15087','2013-08-02','15:05:00',3.83),('15087','2013-08-02','15:10:00',3.62),('15087','2013-08-02','15:15:00',3.61),('15087','2013-08-02','15:20:00',3.67),('15087','2013-08-02','15:25:00',3.67),('15087','2013-08-02','15:30:00',3.58),('15087','2013-08-02','15:35:00',3.51),('15087','2013-08-02','15:40:00',3.46),('15087','2013-08-02','15:45:00',3.41),('15087','2013-08-02','15:50:00',3.32),('15087','2013-08-02','15:55:00',3.16),('15087','2013-08-02','16:00:00',3.07),('15087','2013-08-02','16:05:00',3.12),('15087','2013-08-02','16:10:00',3.05),('15087','2013-08-02','16:15:00',2.87),('15087','2013-08-02','16:20:00',2.87),('15087','2013-08-02','16:25:00',2.91),('15087','2013-08-02','16:30:00',2.84),('15087','2013-08-02','16:35:00',2.78),('15087','2013-08-02','16:40:00',2.58),('15087','2013-08-02','16:45:00',2.58),('15087','2013-08-02','16:50:00',2.55),('15087','2013-08-02','16:55:00',2.45),('15087','2013-08-02','17:00:00',2.36),('15087','2013-08-02','17:05:00',2.36),('15087','2013-08-02','17:10:00',2.25),('15087','2013-08-02','17:15:00',2.15),('15087','2013-08-02','17:20:00',2.09),('15087','2013-08-02','17:25:00',1.97),('15087','2013-08-02','17:30:00',1.86),('15087','2013-08-02','17:35:00',1.81),('15087','2013-08-02','17:40:00',1.72),('15087','2013-08-02','17:45:00',1.66),('15087','2013-08-02','17:50:00',1.54),('15087','2013-08-02','17:55:00',1.48),('15087','2013-08-02','18:00:00',1.39),('15087','2013-08-02','18:05:00',1.29),('15087','2013-08-02','18:10:00',1.18),('15087','2013-08-02','18:15:00',1.17),('15087','2013-08-02','18:20:00',1.1),('15087','2013-08-02','18:25:00',1.03),('15087','2013-08-01','07:50:00',1.07),('15087','2013-08-01','07:55:00',1.15),('15087','2013-08-01','08:00:00',1.23),('15087','2013-08-01','08:05:00',1.32),('15087','2013-08-01','08:10:00',1.4),('15087','2013-08-01','08:15:00',1.49),('15087','2013-08-01','08:20:00',1.58),('15087','2013-08-01','08:25:00',1.68),('15087','2013-08-01','08:30:00',1.78),('15087','2013-08-01','08:35:00',1.86),('15087','2013-08-01','08:40:00',1.96),('15087','2013-08-01','08:45:00',2.04),('15087','2013-08-01','08:50:00',2.14),('15087','2013-08-01','08:55:00',2.26),('15087','2013-08-01','09:00:00',2.37),('15087','2013-08-01','09:05:00',2.49),('15087','2013-08-01','09:10:00',2.58),('15087','2013-08-01','09:15:00',2.68),('15087','2013-08-01','09:20:00',2.77),('15087','2013-08-01','09:25:00',2.84),('15087','2013-08-01','09:30:00',2.91),('15087','2013-08-01','09:35:00',2.99),('15087','2013-08-01','09:40:00',3.07),('15087','2013-08-01','09:45:00',3.15),('15087','2013-08-01','09:50:00',3.22),('15087','2013-08-01','09:55:00',3.29),('15087','2013-08-01','10:00:00',3.37),('15087','2013-08-01','10:05:00',3.41),('15087','2013-08-01','10:10:00',3.47),('15087','2013-08-01','10:15:00',3.54),('15087','2013-08-01','10:20:00',3.57),('15087','2013-08-01','10:25:00',3.65),('15087','2013-08-01','10:30:00',3.69),('15087','2013-08-01','10:35:00',3.74),('15087','2013-08-01','10:40:00',3.79),('15087','2013-08-01','10:45:00',3.82),('15087','2013-08-01','10:50:00',3.92),('15087','2013-08-01','10:55:00',3.95),('15087','2013-08-01','11:00:00',3.98),('15087','2013-08-01','11:05:00',4.06),('15087','2013-08-01','11:10:00',4.1),('15087','2013-08-01','11:15:00',4.15),('15087','2013-08-01','11:20:00',4.17),('15087','2013-08-01','11:25:00',4.23),('15087','2013-08-01','11:30:00',4.25),('15087','2013-08-01','11:35:00',4.3),('15087','2013-08-01','11:40:00',4.37),('15087','2013-08-01','11:45:00',4.39),('15087','2013-08-01','11:50:00',4.39),('15087','2013-08-01','11:55:00',4.45),('15087','2013-08-01','12:00:00',4.44),('15087','2013-08-01','12:05:00',4.46),('15087','2013-08-01','12:10:00',4.45),('15087','2013-08-01','12:15:00',4.48),('15087','2013-08-01','12:20:00',4.52),('15087','2013-08-01','12:25:00',4.54),('15087','2013-08-01','12:30:00',4.54),('15087','2013-08-01','12:35:00',4.56),('15087','2013-08-01','12:40:00',4.59),('15087','2013-08-01','12:45:00',4.61),('15087','2013-08-01','12:50:00',4.59),('15087','2013-08-01','12:55:00',4.54),('15087','2013-08-01','13:00:00',4.52),('15087','2013-08-01','13:05:00',4.56),('15087','2013-08-01','13:10:00',4.59),('15087','2013-08-01','13:15:00',4.31),('15087','2013-08-01','13:20:00',4.45),('15087','2013-08-01','13:25:00',4.59),('15087','2013-08-01','13:30:00',4.57),('15087','2013-08-01','13:35:00',4.56),('15087','2013-08-01','13:40:00',4.6),('15087','2013-08-01','13:45:00',4.66),('15087','2013-08-01','13:50:00',4.66),('15087','2013-08-01','13:55:00',4.01),('15087','2013-08-01','14:00:00',4.57),('15087','2013-08-01','14:05:00',4.5),('15087','2013-08-01','14:10:00',4.45),('15087','2013-08-01','14:15:00',4.31),('15087','2013-08-01','14:20:00',4.25),('15087','2013-08-01','14:25:00',4.18),('15087','2013-08-01','14:30:00',4.19),('15087','2013-08-01','14:35:00',4.07),('15087','2013-08-01','14:40:00',4.18),('15087','2013-08-01','14:45:00',4.12),('15087','2013-08-01','14:50:00',2.81),('15087','2013-08-01','14:55:00',4.09),('15087','2013-08-01','15:00:00',3.98),('15087','2013-08-01','15:05:00',3.99),('15087','2013-08-01','15:10:00',3.88),('15087','2013-08-01','15:15:00',3.75),('15087','2013-08-01','15:20:00',3.86),('15087','2013-08-01','15:25:00',3.81),('15087','2013-08-01','15:30:00',3.72),('15087','2013-08-01','15:35:00',3.62),('15087','2013-08-01','15:40:00',3.07),('15087','2013-08-01','15:45:00',3.52),('15087','2013-08-01','15:50:00',3.48),('15087','2013-08-01','15:55:00',3.34),('15087','2013-08-01','16:00:00',3.17),('15087','2013-08-01','16:05:00',3.34),('15087','2013-08-01','16:10:00',3.21),('15087','2013-08-01','16:15:00',3.03),('15087','2013-08-01','16:20:00',3.04),('15087','2013-08-01','16:25:00',3.03),('15087','2013-08-01','16:30:00',2.94),('15087','2013-08-01','16:35:00',2.84),('15087','2013-08-01','16:40:00',2.63),('15087','2013-08-01','16:45:00',2.66),('15087','2013-08-01','16:50:00',2.65),('15087','2013-08-01','16:55:00',2.6),('15087','2013-08-01','17:00:00',2.51),('15087','2013-08-01','17:05:00',2.46),('15087','2013-08-01','17:10:00',2.39),('15087','2013-08-01','17:15:00',2.27),('15087','2013-08-01','17:20:00',2.2),('15087','2013-08-01','17:25:00',2.07),('15087','2013-08-01','17:30:00',1.97),('15087','2013-08-01','17:35:00',1.88),('15087','2013-08-01','17:40:00',1.82),('15087','2013-08-01','17:45:00',1.68),('15087','2013-08-01','17:50:00',1.63),('15087','2013-08-01','17:55:00',1.55),('15087','2013-08-01','18:00:00',1.49),('15087','2013-08-01','18:05:00',1.38),('15087','2013-08-01','18:10:00',1.3),('15087','2013-08-01','18:15:00',1.23),('15087','2013-08-01','18:20:00',1.12),('15087','2013-08-01','18:25:00',1.07),('15087','2013-07-31','07:45:00',1.01),('15087','2013-07-31','07:50:00',1.09),('15087','2013-07-31','07:55:00',1.18),('15087','2013-07-31','08:00:00',1.28),('15087','2013-07-31','08:05:00',1.37),('15087','2013-07-31','08:10:00',1.47),('15087','2013-07-31','08:15:00',1.54),('15087','2013-07-31','08:20:00',1.66),('15087','2013-07-31','08:25:00',1.76),('15087','2013-07-31','08:30:00',1.88),('15087','2013-07-31','08:35:00',1.97),('15087','2013-07-31','08:40:00',2.07),('15087','2013-07-31','08:45:00',2.18),('15087','2013-07-31','08:50:00',2.29),('15087','2013-07-31','08:55:00',2.39),('15087','2013-07-31','09:00:00',2.47),('15087','2013-07-31','09:05:00',2.56),('15087','2013-07-31','09:10:00',2.64),('15087','2013-07-31','09:15:00',2.71),('15087','2013-07-31','09:20:00',2.79),('15087','2013-07-31','09:25:00',2.87),('15087','2013-07-31','09:30:00',2.94),('15087','2013-07-31','09:35:00',3.02),('15087','2013-07-31','09:40:00',3.1),('15087','2013-07-31','09:45:00',3.16),('15087','2013-07-31','09:50:00',3.24),('15087','2013-07-31','09:55:00',3.3),('15087','2013-07-31','10:00:00',3.35),('15087','2013-07-31','10:05:00',3.42),('15087','2013-07-31','10:10:00',3.47),('15087','2013-07-31','10:15:00',3.53),('15087','2013-07-31','10:20:00',3.61),('15087','2013-07-31','10:25:00',3.65),('15087','2013-07-31','10:30:00',3.67),('15087','2013-07-31','10:35:00',3.74),('15087','2013-07-31','10:40:00',3.85),('15087','2013-07-31','10:45:00',3.9),('15087','2013-07-31','10:50:00',3.98),('15087','2013-07-31','10:55:00',4.03),('15087','2013-07-31','11:00:00',4.06),('15087','2013-07-31','11:05:00',4.1),('15087','2013-07-31','11:10:00',4.16),('15087','2013-07-31','11:15:00',4.2),('15087','2013-07-31','11:20:00',4.23),('15087','2013-07-31','11:25:00',4.28),('15087','2013-07-31','11:30:00',4.29),('15087','2013-07-31','11:35:00',4.34),('15087','2013-07-31','11:40:00',4.38),('15087','2013-07-31','11:45:00',4.43),('15087','2013-07-31','11:50:00',4.47),('15087','2013-07-31','11:55:00',4.52),('15087','2013-07-31','12:00:00',4.48),('15087','2013-07-31','12:05:00',4.48),('15087','2013-07-31','12:10:00',4.53),('15087','2013-07-31','12:15:00',4.61),('15087','2013-07-31','12:20:00',4.58),('15087','2013-07-31','12:25:00',4.65),('15087','2013-07-31','12:30:00',4.63),('15087','2013-07-31','12:35:00',4.59),('15087','2013-07-31','12:40:00',4.66),('15087','2013-07-31','12:45:00',3.83),('15087','2013-07-31','12:50:00',2.06),('15087','2013-07-31','12:55:00',4.87),('15087','2013-07-31','13:00:00',1.69),('15087','2013-07-31','13:05:00',4.1),('15087','2013-07-31','13:10:00',4.26),('15087','2013-07-31','13:15:00',4.71),('15087','2013-07-31','13:20:00',4.61),('15087','2013-07-31','13:25:00',4.24),('15087','2013-07-31','13:30:00',4.37),('15087','2013-07-31','13:35:00',4.59),('15087','2013-07-31','13:40:00',4.66),('15087','2013-07-31','13:45:00',4.73),('15087','2013-07-31','13:50:00',4.78),('15087','2013-07-31','13:55:00',2.77),('15087','2013-07-31','14:00:00',3.68),('15087','2013-07-31','14:05:00',4.68),('15087','2013-07-31','14:10:00',4.66),('15087','2013-07-31','14:15:00',3.66),('15087','2013-07-31','14:20:00',3.81),('15087','2013-07-31','14:25:00',3.39),('15087','2013-07-31','14:30:00',4.45),('15087','2013-07-31','14:35:00',4.31),('15087','2013-07-31','14:40:00',4.41),('15087','2013-07-31','14:45:00',4.25),('15087','2013-07-31','14:50:00',4.31),('15087','2013-07-31','14:55:00',3.04),('15087','2013-07-31','15:00:00',1.04),('15087','2013-07-31','15:05:00',3.98),('15087','2013-07-31','15:10:00',4.01),('15087','2013-07-31','15:15:00',3.46),('15087','2013-07-31','15:20:00',3.66),('15087','2013-07-31','15:25:00',3.96),('15087','2013-07-31','15:30:00',3.36),('15087','2013-07-31','15:35:00',3.75),('15087','2013-07-31','15:40:00',3.74),('15087','2013-07-31','15:45:00',3.6),('15087','2013-07-31','15:50:00',3.51),('15087','2013-07-31','15:55:00',3.37),('15087','2013-07-31','16:00:00',3.19),('15087','2013-07-31','16:05:00',3.32),('15087','2013-07-31','16:10:00',3.29),('15087','2013-07-31','16:15:00',3.18),('15087','2013-07-31','16:20:00',3.06),('15087','2013-07-31','16:25:00',3.01),('15087','2013-07-31','16:30:00',2.99),('15087','2013-07-31','16:35:00',2.86),('15087','2013-07-31','16:40:00',2.71),('15087','2013-07-31','16:45:00',2.67),('15087','2013-07-31','16:50:00',2.69),('15087','2013-07-31','16:55:00',2.65),('15087','2013-07-31','17:00:00',2.55),('15087','2013-07-31','17:05:00',2.38),('15087','2013-07-31','17:10:00',2.17),('15087','2013-07-31','17:15:00',2.35),('15087','2013-07-31','17:20:00',1.45),('15087','2013-07-31','17:25:00',2.11),('15087','2013-07-31','17:30:00',2),('15087','2013-07-31','17:35:00',1.77),('15087','2013-07-31','17:40:00',1.77),('15087','2013-07-31','17:45:00',1.67),('15087','2013-07-31','17:50:00',1.63),('15087','2013-07-31','17:55:00',1.55),('15087','2013-07-31','18:00:00',1.47),('15087','2013-07-31','18:05:00',1.38),('15087','2013-07-31','18:10:00',1.26),('15087','2013-07-31','18:15:00',1.19),('15087','2013-07-31','18:20:00',1.16),('15087','2013-07-31','18:25:00',1.11),('15087','2013-07-31','18:30:00',1.02),('15087','2014-04-08','08:15:00',1.06),('15087','2014-04-08','08:20:00',1.47),('15087','2014-04-08','08:25:00',1.03),('15087','2014-04-08','08:30:00',1.5),('15087','2014-04-08','08:35:00',1.42),('15087','2014-04-08','08:40:00',1.31),('15087','2014-04-08','08:45:00',1.7),('15087','2014-04-08','08:50:00',1.74),('15087','2014-04-08','08:55:00',1.9),('15087','2014-04-08','09:00:00',1.98),('15087','2014-04-08','09:05:00',2.07),('15087','2014-04-08','09:10:00',2.15),('15087','2014-04-08','09:15:00',2.25),('15087','2014-04-08','09:20:00',2.33),('15087','2014-04-08','09:25:00',2.44),('15087','2014-04-08','09:30:00',2.5),('15087','2014-04-08','09:35:00',2.57),('15087','2014-04-08','09:40:00',2.62),('15087','2014-04-08','09:45:00',2.7),('15087','2014-04-08','09:50:00',2.77),('15087','2014-04-08','09:55:00',2.82),('15087','2014-04-08','10:00:00',2.88),('15087','2014-04-08','10:05:00',2.86),('15087','2014-04-08','10:10:00',3.02),('15087','2014-04-08','10:15:00',3.17),('15087','2014-04-08','10:20:00',3.25),('15087','2014-04-08','10:25:00',3.3),('15087','2014-04-08','10:30:00',3.37),('15087','2014-04-08','10:35:00',3.4),('15087','2014-04-08','10:40:00',3.5),('15087','2014-04-08','10:45:00',3.53),('15087','2014-04-08','10:50:00',3.57),('15087','2014-04-08','10:55:00',3.68),('15087','2014-04-08','11:00:00',3.64),('15087','2014-04-08','11:05:00',3.59),('15087','2014-04-08','11:10:00',3.75),('15087','2014-04-08','11:15:00',3.73),('15087','2014-04-08','11:20:00',3.91),('15087','2014-04-08','11:25:00',3.83),('15087','2014-04-08','11:30:00',3.88),('15087','2014-04-08','11:35:00',3.82),('15087','2014-04-08','11:40:00',3.99),('15087','2014-04-08','11:45:00',4.02),('15087','2014-04-08','11:50:00',4.05),('15087','2014-04-08','11:55:00',4.07),('15087','2014-04-08','12:00:00',4.12),('15087','2014-04-08','12:05:00',4.07),('15087','2014-04-08','12:10:00',3.99),('15087','2014-04-08','12:15:00',3.74),('15087','2014-04-08','12:20:00',3.78),('15087','2014-04-08','12:25:00',3.74),('15087','2014-04-08','12:30:00',4.38),('15087','2014-04-08','12:35:00',4.41),('15087','2014-04-08','12:40:00',3.68),('15087','2014-04-08','12:45:00',2.79),('15087','2014-04-08','12:50:00',3.79),('15087','2014-04-08','12:55:00',4.25),('15087','2014-04-08','13:00:00',4.1),('15087','2014-04-08','13:05:00',4.27),('15087','2014-04-08','13:10:00',4.35),('15087','2014-04-08','13:15:00',4.49),('15087','2014-04-08','13:20:00',4.43),('15087','2014-04-08','13:25:00',4.47),('15087','2014-04-08','13:30:00',4.46),('15087','2014-04-08','13:35:00',4.5),('15087','2014-04-08','13:40:00',4.46),('15087','2014-04-08','13:45:00',4.38),('15087','2014-04-08','13:50:00',4.4),('15087','2014-04-08','13:55:00',4.37),('15087','2014-04-08','14:00:00',4.33),('15087','2014-04-08','14:05:00',4.33),('15087','2014-04-08','14:10:00',4.3),('15087','2014-04-08','14:15:00',4.13),('15087','2014-04-08','14:20:00',3.72),('15087','2014-04-08','14:25:00',3.89),('15087','2014-04-08','14:30:00',4.17),('15087','2014-04-08','14:35:00',3.91),('15087','2014-04-08','14:40:00',3.49),('15087','2014-04-08','14:45:00',3.56),('15087','2014-04-08','14:50:00',3.83),('15087','2014-04-08','14:55:00',3.89),('15087','2014-04-08','15:00:00',3.68),('15087','2014-04-08','15:05:00',3.7),('15087','2014-04-08','15:10:00',3.62),('15087','2014-04-08','15:15:00',3.57),('15087','2014-04-08','15:20:00',3.37),('15087','2014-04-08','15:25:00',3.14),('15087','2014-04-08','15:30:00',3.03),('15087','2014-04-08','15:35:00',3.07),('15087','2014-04-08','15:40:00',3.11),('15087','2014-04-08','15:45:00',3.05),('15087','2014-04-08','15:50:00',3.1),('15087','2014-04-08','15:55:00',3.06),('15087','2014-04-08','16:00:00',2.76),('15087','2014-04-08','16:05:00',2.64),('15087','2014-04-08','16:10:00',2.63),('15087','2014-04-08','16:15:00',2.52),('15087','2014-04-08','16:20:00',2.3),('15087','2014-04-08','16:25:00',2.46),('15087','2014-04-08','16:30:00',2.56),('15087','2014-04-08','16:35:00',2.45),('15087','2014-04-08','16:40:00',2.31),('15087','2014-04-08','16:45:00',2.27),('15087','2014-04-08','16:50:00',2.3),('15087','2014-04-08','16:55:00',2.07),('15087','2014-04-08','17:00:00',1.92),('15087','2014-04-08','17:05:00',2),('15087','2014-04-08','17:10:00',1.8),('15087','2014-04-08','17:15:00',1.72),('15087','2014-04-08','17:20:00',1.61),('15087','2014-04-08','17:25:00',1.39),('15087','2014-04-08','17:30:00',1.29),('15087','2014-04-08','17:35:00',1.18),('15087','2014-04-08','17:40:00',1.19),('15087','2014-04-08','17:45:00',1.08),('15087','2014-04-08','17:50:00',1.03),('15087','2013-07-30','07:45:00',1.01),('15087','2013-07-30','07:50:00',1.04),('15087','2013-07-30','07:55:00',1.12),('15087','2013-07-30','08:00:00',1.26),('15087','2013-07-30','08:05:00',1.39),('15087','2013-07-30','08:10:00',1.49),('15087','2013-07-30','08:15:00',1.61),('15087','2013-07-30','08:20:00',1.82),('15087','2013-07-30','08:25:00',1.74),('15087','2013-07-30','08:30:00',1.81),('15087','2013-07-30','08:35:00',1.86),('15087','2013-07-30','08:40:00',1.94),('15087','2013-07-30','08:45:00',2.05),('15087','2013-07-30','08:50:00',2.12),('15087','2013-07-30','08:55:00',2.35),('15087','2013-07-30','09:00:00',2.47),('15087','2013-07-30','09:05:00',2.54),('15087','2013-07-30','09:10:00',2.58),('15087','2013-07-30','09:15:00',2.73),('15087','2013-07-30','09:20:00',2.83),('15087','2013-07-30','09:25:00',2.71),('15087','2013-07-30','09:30:00',2.75),('15087','2013-07-30','09:35:00',2.95),('15087','2013-07-30','09:55:00',2.29),('15087','2013-07-30','10:00:00',2.36),('15087','2013-07-30','10:05:00',2.52),('15087','2013-07-30','10:10:00',3.69),('15087','2013-07-30','10:15:00',3.63),('15087','2013-07-30','10:20:00',3.76),('15087','2013-07-30','10:25:00',3.85),('15087','2013-07-30','10:30:00',3.87),('15087','2013-07-30','10:35:00',3.85),('15087','2013-07-30','10:40:00',3.82),('15087','2013-07-30','10:45:00',3.88),('15087','2013-07-30','10:50:00',3.85),('15087','2013-07-30','10:55:00',3.82),('15087','2013-07-30','11:00:00',3.63),('15087','2013-07-30','11:05:00',3.86),('15087','2013-07-30','11:10:00',3.94),('15087','2013-07-30','11:15:00',3.31),('15087','2013-07-30','11:20:00',4.31),('15087','2013-07-30','11:25:00',4.1),('15087','2013-07-30','11:30:00',4.1),('15087','2013-07-30','11:35:00',4.38),('15087','2013-07-30','11:40:00',4.32),('15087','2013-07-30','11:45:00',4.01),('15087','2013-07-30','11:50:00',1.32),('15087','2013-07-30','11:55:00',3.91),('15087','2013-07-30','12:00:00',4.34),('15087','2013-07-30','12:05:00',4.36),('15087','2013-07-30','12:10:00',4.18),('15087','2013-07-30','12:15:00',4.33),('15087','2013-07-30','12:20:00',4.45),('15087','2013-07-30','12:25:00',4.47),('15087','2013-07-30','12:30:00',4.43),('15087','2013-07-30','12:35:00',2.78),('15087','2013-07-30','12:45:00',3.89),('15087','2013-07-30','12:50:00',4.69),('15087','2013-07-30','12:55:00',4.2),('15087','2013-07-30','13:00:00',3.14),('15087','2013-07-30','13:05:00',2.96),('15087','2013-07-30','13:10:00',3.25),('15087','2013-07-30','13:15:00',2.57),('15087','2013-07-30','13:20:00',4.64),('15087','2013-07-30','13:25:00',4.77),('15087','2013-07-30','13:30:00',4.7),('15087','2013-07-30','13:35:00',4.6),('15087','2013-07-30','13:40:00',4.63),('15087','2013-07-30','13:45:00',4.53),('15087','2013-07-30','13:50:00',4.58),('15087','2013-07-30','13:55:00',4.64),('15087','2013-07-30','14:00:00',4.6),('15087','2013-07-30','14:05:00',2.29),('15087','2013-07-30','14:10:00',4.13),('15087','2013-07-30','14:15:00',4.51),('15087','2013-07-30','14:20:00',4.49),('15087','2013-07-30','14:25:00',3.87),('15087','2013-07-30','14:30:00',4.22),('15087','2013-07-30','14:35:00',4.32),('15087','2013-07-30','14:40:00',4.16),('15087','2013-07-30','14:45:00',4.1),('15087','2013-07-30','14:50:00',4.05),('15087','2013-07-30','14:55:00',3.97),('15087','2013-07-30','15:00:00',4),('15087','2013-07-30','15:05:00',3.9),('15087','2013-07-30','15:10:00',3.74),('15087','2013-07-30','15:15:00',3.54),('15087','2013-07-30','15:20:00',3.61),('15087','2013-07-30','15:25:00',3.7),('15087','2013-07-30','15:30:00',3.64),('15087','2013-07-30','15:35:00',3.52),('15087','2013-07-30','15:40:00',3.36),('15087','2013-07-30','15:45:00',3.27),('15087','2013-07-30','15:50:00',3.32),('15087','2013-07-30','15:55:00',3.31),('15087','2013-07-30','16:00:00',3.14),('15087','2013-07-30','16:05:00',3.03),('15087','2013-07-30','16:10:00',3.11),('15087','2013-07-30','16:15:00',3.06),('15087','2013-07-30','16:20:00',2.93),('15087','2013-07-30','16:25:00',2.92),('15087','2013-07-30','16:30:00',2.86),('15087','2013-07-30','16:35:00',2.77),('15087','2013-07-30','16:40:00',2.67),('15087','2013-07-30','16:45:00',2.69),('15087','2013-07-30','16:50:00',2.61),('15087','2013-07-30','16:55:00',2.55),('15087','2013-07-30','17:00:00',2.49),('15087','2013-07-30','17:05:00',2.35),('15087','2013-07-30','17:10:00',2.31),('15087','2013-07-30','17:15:00',2.17),('15087','2013-07-30','17:20:00',2.13),('15087','2013-07-30','17:25:00',2.01),('15087','2013-07-30','17:30:00',1.98),('15087','2013-07-30','17:35:00',1.87),('15087','2013-07-30','17:40:00',1.82),('15087','2013-07-30','17:45:00',1.6),('15087','2013-07-30','17:50:00',1.6),('15087','2013-07-30','17:55:00',1.52),('15087','2013-07-30','18:00:00',1.43),('15087','2013-07-30','18:05:00',1.33),('15087','2013-07-30','18:10:00',1.24),('15087','2013-07-30','18:15:00',1.13),('15087','2013-07-30','18:20:00',1.12),('15087','2013-07-30','18:25:00',1.07),('15087','2013-07-29','07:55:00',1.06),('15087','2013-07-29','08:00:00',1.15),('15087','2013-07-29','08:05:00',1.24),('15087','2013-07-29','08:10:00',1.32),('15087','2013-07-29','08:15:00',1.38),('15087','2013-07-29','08:20:00',1.47),('15087','2013-07-29','08:25:00',1.54),('15087','2013-07-29','08:30:00',1.62),('15087','2013-07-29','08:35:00',1.7),('15087','2013-07-29','08:40:00',1.71),('15087','2013-07-29','08:45:00',1.79),('15087','2013-07-29','08:50:00',1.92),('15087','2013-07-29','08:55:00',1.99),('15087','2013-07-29','09:00:00',2.09),('15087','2013-07-29','09:05:00',2.21),('15087','2013-07-29','09:10:00',2.31),('15087','2013-07-29','09:15:00',2.38),('15087','2013-07-29','09:20:00',2.46),('15087','2013-07-29','09:25:00',2.53),('15087','2013-07-29','09:30:00',2.57),('15087','2013-07-29','09:35:00',2.67),('15087','2013-07-29','09:40:00',2.79),('15087','2013-07-29','09:45:00',2.88),('15087','2013-07-29','09:50:00',2.96),('15087','2013-07-29','09:55:00',3.03),('15087','2013-07-29','10:00:00',3.09),('15087','2013-07-29','10:05:00',3.17),('15087','2013-07-29','10:10:00',3.22),('15087','2013-07-29','10:15:00',3.25),('15087','2013-07-29','10:20:00',3.34),('15087','2013-07-29','10:25:00',3.42),('15087','2013-07-29','10:30:00',3.49),('15087','2013-07-29','10:35:00',3.49),('15087','2013-07-29','10:40:00',3.55),('15087','2013-07-29','10:45:00',3.57),('15087','2013-07-29','10:50:00',3.63),('15087','2013-07-29','10:55:00',3.65),('15087','2013-07-29','11:00:00',3.68),('15087','2013-07-29','11:05:00',3.72),('15087','2013-07-29','11:10:00',3.75),('15087','2013-07-29','11:15:00',3.75),('15087','2013-07-29','11:20:00',3.84),('15087','2013-07-29','11:25:00',3.87),('15087','2013-07-29','11:30:00',3.87),('15087','2013-07-29','11:35:00',3.89),('15087','2013-07-29','11:40:00',3.93),('15087','2013-07-29','11:45:00',3.95),('15087','2013-07-29','11:50:00',3.95),('15087','2013-07-29','11:55:00',3.95),('15087','2013-07-29','12:00:00',4.06),('15087','2013-07-29','12:05:00',4.1),('15087','2013-07-29','12:10:00',4.11),('15087','2013-07-29','12:15:00',4.09),('15087','2013-07-29','12:20:00',4.1),('15087','2013-07-29','12:25:00',4.13),('15087','2013-07-29','12:30:00',4.13),('15087','2013-07-29','12:35:00',4.14),('15087','2013-07-29','12:40:00',4.15),('15087','2013-07-29','12:45:00',4.16),('15087','2013-07-29','12:50:00',4.12),('15087','2013-07-29','12:55:00',4.08),('15087','2013-07-29','13:00:00',4.19),('15087','2013-07-29','13:05:00',4.16),('15087','2013-07-29','13:10:00',4.26),('15087','2013-07-29','13:15:00',4.26),('15087','2013-07-29','13:20:00',4.31),('15087','2013-07-29','13:25:00',4.34),('15087','2013-07-29','13:30:00',4.33),('15087','2013-07-29','13:35:00',4.36),('15087','2013-07-29','13:40:00',4.36),('15087','2013-07-29','13:45:00',4.39),('15087','2013-07-29','13:50:00',4.37),('15087','2013-07-29','13:55:00',4.33),('15087','2013-07-29','14:00:00',4.32),('15087','2013-07-29','14:05:00',4.31),('15087','2013-07-29','14:10:00',4.27),('15087','2013-07-29','14:15:00',4.28),('15087','2013-07-29','14:20:00',4.24),('15087','2013-07-29','14:25:00',4.16),('15087','2013-07-29','14:30:00',4.1),('15087','2013-07-29','14:35:00',4.11),('15087','2013-07-29','14:40:00',4.07),('15087','2013-07-29','14:45:00',4.04),('15087','2013-07-29','14:50:00',3.95),('15087','2013-07-29','14:55:00',3.83),('15087','2013-07-29','15:00:00',3.88),('15087','2013-07-29','15:05:00',3.85),('15087','2013-07-29','15:10:00',3.79),('15087','2013-07-29','15:15:00',3.68),('15087','2013-07-29','15:20:00',3.68),('15087','2013-07-29','15:25:00',3.64),('15087','2013-07-29','15:30:00',3.6),('15087','2013-07-29','15:35:00',3.56),('15087','2013-07-29','15:40:00',3.51),('15087','2013-07-29','15:45:00',3.51),('15087','2013-07-29','15:50:00',2.72),('15087','2013-07-29','15:55:00',1.96),('15087','2013-07-29','16:00:00',1.87),('15087','2013-07-29','16:05:00',3.01),('15087','2013-07-29','16:10:00',3.14),('15087','2013-07-29','16:15:00',2.45),('15087','2013-07-29','16:20:00',2.51),('15087','2013-07-29','16:25:00',2.5),('15087','2013-07-29','16:30:00',2.84),('15087','2013-07-29','16:35:00',2.55),('15087','2013-07-29','16:40:00',2.47),('15087','2013-07-29','16:45:00',2.89),('15087','2013-07-29','16:50:00',2.59),('15087','2013-07-29','16:55:00',1.87),('15087','2013-07-29','17:00:00',1.35),('15087','2013-07-29','17:05:00',1.93),('15087','2013-07-29','17:10:00',1.31),('15087','2013-07-29','17:15:00',1.13),('15087','2013-07-29','17:20:00',2.08),('15087','2013-07-29','17:25:00',1.86),('15087','2013-07-29','17:30:00',1.32),('15087','2013-07-29','17:40:00',1.18),('15087','2013-07-29','17:45:00',1.8),('15087','2013-07-29','17:50:00',1.64),('15087','2013-07-29','17:55:00',1.36),('15087','2013-07-29','18:10:00',1.19),('15087','2013-07-29','18:15:00',1.03),('15087','2013-07-29','18:20:00',1.1),('15087','2013-07-29','18:25:00',1.04),('15087','2013-07-28','07:55:00',1.05),('15087','2013-07-28','08:00:00',1.13),('15087','2013-07-28','08:05:00',1.22),('15087','2013-07-28','08:10:00',1.28),('15087','2013-07-28','08:15:00',1.38),('15087','2013-07-28','08:20:00',1.46),('15087','2013-07-28','08:25:00',1.56),('15087','2013-07-28','08:30:00',1.65),('15087','2013-07-28','08:35:00',1.73),('15087','2013-07-28','08:40:00',1.81),('15087','2013-07-28','08:45:00',1.87),('15087','2013-07-28','08:50:00',1.97),('15087','2013-07-28','08:55:00',2.04),('15087','2013-07-28','09:00:00',2.14),('15087','2013-07-28','09:05:00',2.3),('15087','2013-07-28','09:10:00',2.38),('15087','2013-07-28','09:15:00',2.49),('15087','2013-07-28','09:20:00',2.53),('15087','2013-07-28','09:25:00',2.65),('15087','2013-07-28','09:30:00',2.71),('15087','2013-07-28','09:35:00',2.7),('15087','2013-07-28','09:40:00',2.78),('15087','2013-07-28','09:45:00',2.89),('15087','2013-07-28','09:50:00',2.96),('15087','2013-07-28','09:55:00',3.05),('15087','2013-07-28','10:00:00',3.07),('15087','2013-07-28','10:05:00',3.16),('15087','2013-07-28','10:10:00',3.23),('15087','2013-07-28','10:15:00',3.28),('15087','2013-07-28','10:20:00',3.31),('15087','2013-07-28','10:25:00',3.32),('15087','2013-07-28','10:30:00',3.44),('15087','2013-07-28','10:35:00',3.52),('15087','2013-07-28','10:40:00',3.56),('15087','2013-07-28','10:45:00',3.56),('15087','2013-07-28','10:50:00',3.62),('15087','2013-07-28','10:55:00',3.63),('15087','2013-07-28','11:00:00',3.7),('15087','2013-07-28','11:05:00',3.72),('15087','2013-07-28','11:10:00',3.71),('15087','2013-07-28','11:15:00',3.79),('15087','2013-07-28','11:20:00',3.8),('15087','2013-07-28','11:25:00',3.83),('15087','2013-07-28','11:30:00',3.91),('15087','2013-07-28','11:35:00',3.91),('15087','2013-07-28','11:40:00',3.96),('15087','2013-07-28','11:45:00',3.95),('15087','2013-07-28','11:50:00',3.98),('15087','2013-07-28','11:55:00',4.01),('15087','2013-07-28','12:00:00',4.05),('15087','2013-07-28','12:05:00',4.03),('15087','2013-07-28','12:10:00',3.95),('15087','2013-07-28','12:15:00',4.01),('15087','2013-07-28','12:20:00',4.1),('15087','2013-07-28','12:25:00',4.15),('15087','2013-07-28','12:30:00',4.24),('15087','2013-07-28','12:35:00',4.21),('15087','2013-07-28','12:40:00',4.2),('15087','2013-07-28','12:45:00',4.15),('15087','2013-07-28','12:50:00',4.2),('15087','2013-07-28','12:55:00',4.19),('15087','2013-07-28','13:00:00',4.13),('15087','2013-07-28','13:05:00',4.28),('15087','2013-07-28','13:10:00',4.25),('15087','2013-07-28','13:15:00',3.72),('15087','2013-07-28','13:20:00',4.07),('15087','2013-07-28','13:25:00',4.24),('15087','2013-07-28','13:30:00',4.3),('15087','2013-07-28','13:35:00',4.34),('15087','2013-07-28','13:40:00',4.33),('15087','2013-07-28','13:45:00',4.4),('15087','2013-07-28','13:50:00',4.32),('15087','2013-07-28','13:55:00',4.31),('15087','2013-07-28','14:00:00',4.27),('15087','2013-07-28','14:05:00',4.3),('15087','2013-07-28','14:10:00',4.31),('15087','2013-07-28','14:15:00',4.22),('15087','2013-07-28','14:20:00',4.2),('15087','2013-07-28','14:25:00',4.14),('15087','2013-07-28','14:30:00',4.06),('15087','2013-07-28','14:35:00',4.04),('15087','2013-07-28','14:40:00',4.07),('15087','2013-07-28','14:45:00',4),('15087','2013-07-28','14:50:00',3.95),('15087','2013-07-28','14:55:00',3.75),('15087','2013-07-28','15:00:00',3.84),('15087','2013-07-28','15:05:00',3.85),('15087','2013-07-28','15:10:00',3.77),('15087','2013-07-28','15:15:00',3.66),('15087','2013-07-28','15:20:00',3.62),('15087','2013-07-28','15:25:00',3.63),('15087','2013-07-28','15:30:00',3.53),('15087','2013-07-28','15:35:00',3.52),('15087','2013-07-28','15:40:00',3.4),('15087','2013-07-28','15:45:00',3.35),('15087','2013-07-28','15:50:00',3.35),('15087','2013-07-28','15:55:00',3.31),('15087','2013-07-28','16:00:00',3.14),('15087','2013-07-28','16:05:00',2.92),('15087','2013-07-28','16:10:00',2.78),('15087','2013-07-28','16:15:00',2.95),('15087','2013-07-28','16:20:00',2.89),('15087','2013-07-28','16:25:00',2.77),('15087','2013-07-28','16:30:00',2.77),('15087','2013-07-28','16:35:00',2.88),('15087','2013-07-28','16:40:00',2.65),('15087','2013-07-28','16:45:00',2.72),('15087','2013-07-28','16:50:00',2.69),('15087','2013-07-28','16:55:00',2.64),('15087','2013-07-28','17:00:00',2.54),('15087','2013-07-28','17:05:00',2.37),('15087','2013-07-28','17:10:00',2.24),('15087','2013-07-28','17:15:00',2.25),('15087','2013-07-28','17:20:00',2.18),('15087','2013-07-28','17:25:00',2.07),('15087','2013-07-28','17:30:00',2.02),('15087','2013-07-28','17:35:00',1.97),('15087','2013-07-28','17:40:00',1.83),('15087','2013-07-28','17:45:00',1.72),('15087','2013-07-28','17:50:00',1.67),('15087','2013-07-28','17:55:00',1.42),('15087','2013-07-28','18:00:00',1.36),('15087','2013-07-28','18:05:00',1.39),('15087','2013-07-28','18:10:00',1.23),('15087','2013-07-28','18:15:00',1.23),('15087','2013-07-28','18:20:00',1.17),('15087','2013-07-28','18:25:00',1.05),('15087','2013-07-27','07:55:00',1.09),('15087','2013-07-27','08:00:00',1.18),('15087','2013-07-27','08:05:00',1.26),('15087','2013-07-27','08:10:00',1.34),('15087','2013-07-27','08:15:00',1.43),('15087','2013-07-27','08:20:00',1.52),('15087','2013-07-27','08:25:00',1.6),('15087','2013-07-27','08:30:00',1.69),('15087','2013-07-27','08:35:00',1.77),('15087','2013-07-27','08:40:00',1.84),('15087','2013-07-27','08:45:00',1.93),('15087','2013-07-27','08:50:00',2.02),('15087','2013-07-27','08:55:00',2.13),('15087','2013-07-27','09:00:00',2.25),('15087','2013-07-27','09:05:00',2.38),('15087','2013-07-27','09:10:00',2.48),('15087','2013-07-27','09:15:00',2.54),('15087','2013-07-27','09:20:00',2.61),('15087','2013-07-27','09:25:00',2.69),('15087','2013-07-27','09:30:00',2.78),('15087','2013-07-27','09:35:00',2.87),('15087','2013-07-27','09:40:00',2.91),('15087','2013-07-27','09:45:00',2.96),('15087','2013-07-27','09:50:00',3.03),('15087','2013-07-27','09:55:00',3.11),('15087','2013-07-27','10:00:00',3.18),('15087','2013-07-27','10:05:00',3.23),('15087','2013-07-27','10:10:00',3.24),('15087','2013-07-27','10:15:00',3.35),('15087','2013-07-27','10:20:00',3.39),('15087','2013-07-27','10:25:00',3.48),('15087','2013-07-27','10:30:00',3.52),('15087','2013-07-27','10:35:00',3.57),('15087','2013-07-27','10:40:00',3.62),('15087','2013-07-27','10:45:00',3.68),('15087','2013-07-27','10:50:00',3.69),('15087','2013-07-27','10:55:00',3.73),('15087','2013-07-27','11:00:00',3.78),('15087','2013-07-27','11:05:00',3.86),('15087','2013-07-27','11:10:00',3.95),('15087','2013-07-27','11:15:00',3.98),('15087','2013-07-27','11:20:00',4),('15087','2013-07-27','11:25:00',3.99),('15087','2013-07-27','11:30:00',4.01),('15087','2013-07-27','11:35:00',4.04),('15087','2013-07-27','11:40:00',4.06),('15087','2013-07-27','11:45:00',4.09),('15087','2013-07-27','11:50:00',4.12),('15087','2013-07-27','11:55:00',4.12),('15087','2013-07-27','12:00:00',4.14),('15087','2013-07-27','12:05:00',4.15),('15087','2013-07-27','12:10:00',4.13),('15087','2013-07-27','12:15:00',4.14),('15087','2013-07-27','12:20:00',4.1),('15087','2013-07-27','12:25:00',4.13),('15087','2013-07-27','12:30:00',4.2),('15087','2013-07-27','12:35:00',4.22),('15087','2013-07-27','12:40:00',4.14),('15087','2013-07-27','12:45:00',4.28),('15087','2013-07-27','12:50:00',4.3),('15087','2013-07-27','12:55:00',4.34),('15087','2013-07-27','13:00:00',3.52),('15087','2013-07-27','13:05:00',1),('15087','2013-07-27','13:10:00',2.41),('15087','2013-07-27','13:15:00',4.08),('15087','2013-07-27','13:20:00',4.34),('15087','2013-07-27','13:25:00',4.36),('15087','2013-07-27','13:30:00',4.37),('15087','2013-07-27','13:35:00',4.28),('15087','2013-07-27','13:40:00',4.36),('15087','2013-07-27','13:45:00',4.37),('15087','2013-07-27','13:50:00',4.32),('15087','2013-07-27','13:55:00',4.35),('15087','2013-07-27','14:00:00',4.17),('15087','2013-07-27','14:05:00',4.38),('15087','2013-07-27','14:10:00',4.4),('15087','2013-07-27','14:15:00',4.25),('15087','2013-07-27','14:20:00',4.19),('15087','2013-07-27','14:25:00',4.2),('15087','2013-07-27','14:30:00',4.08),('15087','2013-07-27','14:35:00',4.08),('15087','2013-07-27','14:40:00',4),('15087','2013-07-27','14:45:00',4),('15087','2013-07-27','14:50:00',3.99),('15087','2013-07-27','14:55:00',3.81),('15087','2013-07-27','15:00:00',3.86),('15087','2013-07-27','15:05:00',3.88),('15087','2013-07-27','15:10:00',3.79),('15087','2013-07-27','15:15:00',3.74),('15087','2013-07-27','15:20:00',3.58),('15087','2013-07-27','15:25:00',3.56),('15087','2013-07-27','15:30:00',3.62),('15087','2013-07-27','15:35:00',3.58),('15087','2013-07-27','15:40:00',3.44),('15087','2013-07-27','15:45:00',3.43),('15087','2013-07-27','15:50:00',3.4),('15087','2013-07-27','15:55:00',3.35),('15087','2013-07-27','16:00:00',3.27),('15087','2013-07-27','16:05:00',3.03),('15087','2013-07-27','16:10:00',2.8),('15087','2013-07-27','16:15:00',3.02),('15087','2013-07-27','16:20:00',2.91),('15087','2013-07-27','16:25:00',2.83),('15087','2013-07-27','16:30:00',2.9),('15087','2013-07-27','16:35:00',2.88),('15087','2013-07-27','16:40:00',2.75),('15087','2013-07-27','16:45:00',2.76),('15087','2013-07-27','16:50:00',2.68),('15087','2013-07-27','16:55:00',2.62),('15087','2013-07-27','17:00:00',2.5),('15087','2013-07-27','17:05:00',2.41),('15087','2013-07-27','17:10:00',2.32),('15087','2013-07-27','17:15:00',2.27),('15087','2013-07-27','17:20:00',2.09),('15087','2013-07-27','17:25:00',2.1),('15087','2013-07-27','17:30:00',2.04),('15087','2013-07-27','17:35:00',1.96),('15087','2013-07-27','17:40:00',1.81),('15087','2013-07-27','17:45:00',1.75),('15087','2013-07-27','17:50:00',1.66),('15087','2013-07-27','17:55:00',1.46),('15087','2013-07-27','18:00:00',1.49),('15087','2013-07-27','18:05:00',1.4),('15087','2013-07-27','18:10:00',1.26),('15087','2013-07-27','18:15:00',1.26),('15087','2013-07-27','18:20:00',1.18),('15087','2013-07-27','18:25:00',1.09),('15087','2013-07-27','18:30:00',1.01),('15087','2013-07-26','07:55:00',1.04),('15087','2013-07-26','08:00:00',1.14),('15087','2013-07-26','08:05:00',1.24),('15087','2013-07-26','08:10:00',1.31),('15087','2013-07-26','08:15:00',1.37),('15087','2013-07-26','08:20:00',1.45),('15087','2013-07-26','08:25:00',1.56),('15087','2013-07-26','08:30:00',1.64),('15087','2013-07-26','08:35:00',1.72),('15087','2013-07-26','08:40:00',1.77),('15087','2013-07-26','08:45:00',1.88),('15087','2013-07-26','08:50:00',1.99),('15087','2013-07-26','08:55:00',2.06),('15087','2013-07-26','09:00:00',2.22),('15087','2013-07-26','09:05:00',2.32),('15087','2013-07-26','09:10:00',2.39),('15087','2013-07-26','09:15:00',2.46),('15087','2013-07-26','09:20:00',2.52),('15087','2013-07-26','09:25:00',2.59),('15087','2013-07-26','09:30:00',2.6),('15087','2013-07-26','09:35:00',2.7),('15087','2013-07-26','09:40:00',2.76),('15087','2013-07-26','09:45:00',2.84),('15087','2013-07-26','09:50:00',2.89),('15087','2013-07-26','09:55:00',3.04),('15087','2013-07-26','10:00:00',3.11),('15087','2013-07-26','10:05:00',3.21),('15087','2013-07-26','10:10:00',3.21),('15087','2013-07-26','10:15:00',3.23),('15087','2013-07-26','10:20:00',3.33),('15087','2013-07-26','10:25:00',3.39),('15087','2013-07-26','10:30:00',3.46),('15087','2013-07-26','10:35:00',3.47),('15087','2013-07-26','10:40:00',3.58),('15087','2013-07-26','10:45:00',3.61),('15087','2013-07-26','10:50:00',3.58),('15087','2013-07-26','10:55:00',3.65),('15087','2013-07-26','11:00:00',3.67),('15087','2013-07-26','11:05:00',3.74),('15087','2013-07-26','11:10:00',3.83),('15087','2013-07-26','11:15:00',3.89),('15087','2013-07-26','11:20:00',3.97),('15087','2013-07-26','11:25:00',3.98),('15087','2013-07-26','11:30:00',4.01),('15087','2013-07-26','11:35:00',4.04),('15087','2013-07-26','11:40:00',4.06),('15087','2013-07-26','11:45:00',4.05),('15087','2013-07-26','11:50:00',4.15),('15087','2013-07-26','11:55:00',4.1),('15087','2013-07-26','12:00:00',3.5),('15087','2013-07-26','12:05:00',3.84),('15087','2013-07-26','12:10:00',3.87),('15087','2013-07-26','12:15:00',4.26),('15087','2013-07-26','12:20:00',4.37),('15087','2013-07-26','12:25:00',4.41),('15087','2013-07-26','12:30:00',4.44),('15087','2013-07-26','12:35:00',4.44),('15087','2013-07-26','12:40:00',4.52),('15087','2013-07-26','12:45:00',4.49),('15087','2013-07-26','12:50:00',3.78),('15087','2013-07-26','12:55:00',1.88),('15087','2013-07-26','13:00:00',1.58),('15087','2013-07-26','13:05:00',1.25),('15087','2013-07-26','13:10:00',1.55),('15087','2013-07-26','13:15:00',1.7),('15087','2013-07-26','13:20:00',1.46),('15087','2013-07-26','13:25:00',1.57),('15087','2013-07-26','13:30:00',4.25),('15087','2013-07-26','13:35:00',4.61),('15087','2013-07-26','13:40:00',4.4),('15087','2013-07-26','13:45:00',4.65),('15087','2013-07-26','13:50:00',4.52),('15087','2013-07-26','13:55:00',4.39),('15087','2013-07-26','14:00:00',4.47),('15087','2013-07-26','14:05:00',2.37),('15087','2013-07-26','14:10:00',4.52),('15087','2013-07-26','14:15:00',4.46),('15087','2013-07-26','14:20:00',4.32),('15087','2013-07-26','14:25:00',4.27),('15087','2013-07-26','14:30:00',4.16),('15087','2013-07-26','14:35:00',4.08),('15087','2013-07-26','14:40:00',4.08),('15087','2013-07-26','14:45:00',4.13),('15087','2013-07-26','14:50:00',4.05),('15087','2013-07-26','14:55:00',3.93),('15087','2013-07-26','15:00:00',3.97),('15087','2013-07-26','15:05:00',3.91),('15087','2013-07-26','15:10:00',3.86),('15087','2013-07-26','15:15:00',3.81),('15087','2013-07-26','15:20:00',3.62),('15087','2013-07-26','15:25:00',3.53),('15087','2013-07-26','15:30:00',3.63),('15087','2013-07-26','15:35:00',3.59),('15087','2013-07-26','15:40:00',3.5),('15087','2013-07-26','15:45:00',3.47),('15087','2013-07-26','15:50:00',3.43),('15087','2013-07-26','15:55:00',3.37),('15087','2013-07-26','16:00:00',3.29),('15087','2013-07-26','16:05:00',3.14),('15087','2013-07-26','16:10:00',2.92),('15087','2013-07-26','16:15:00',3.1),('15087','2013-07-26','16:20:00',2.97),('15087','2013-07-26','16:25:00',2.94),('15087','2013-07-26','16:30:00',2.94),('15087','2013-07-26','16:35:00',2.91),('15087','2013-07-26','16:40:00',2.8),('15087','2013-07-26','16:45:00',2.77),('15087','2013-07-26','16:50:00',2.74),('15087','2013-07-26','16:55:00',2.63),('15087','2013-07-26','17:00:00',2.59),('15087','2013-07-26','17:05:00',2.47),('15087','2013-07-26','17:10:00',2.43),('15087','2013-07-26','17:15:00',2.3),('15087','2013-07-26','17:20:00',2.14),('15087','2013-07-26','17:25:00',2.15),('15087','2013-07-26','17:30:00',2.07),('15087','2013-07-26','17:35:00',1.95),('15087','2013-07-26','17:40:00',1.82),('15087','2013-07-26','17:45:00',1.75),('15087','2013-07-26','17:50:00',1.53),('15087','2013-07-26','17:55:00',1.45),('15087','2013-07-26','18:00:00',1.39),('15087','2013-07-26','18:05:00',1.29),('15087','2013-07-26','18:10:00',1.22),('15087','2013-07-26','18:15:00',1.19),('15087','2013-07-26','18:20:00',1.13),('15087','2013-07-26','18:25:00',1.08),('15087','2013-07-25','07:55:00',1.08),('15087','2013-07-25','08:00:00',1.15),('15087','2013-07-25','08:05:00',1.25),('15087','2013-07-25','08:10:00',1.31),('15087','2013-07-25','08:15:00',1.39),('15087','2013-07-25','08:20:00',1.48),('15087','2013-07-25','08:25:00',1.59),('15087','2013-07-25','08:30:00',1.67),('15087','2013-07-25','08:35:00',1.74),('15087','2013-07-25','08:40:00',1.79),('15087','2013-07-25','08:45:00',1.91),('15087','2013-07-25','08:50:00',1.99),('15087','2013-07-25','08:55:00',2.19),('15087','2013-07-25','09:00:00',2.17),('15087','2013-07-25','09:05:00',2.18),('15087','2013-07-25','09:10:00',2.41),('15087','2013-07-25','09:15:00',2.71),('15087','2013-07-25','09:20:00',2.4),('15087','2013-07-25','09:25:00',2.15),('15087','2013-07-25','09:30:00',2.01),('15087','2013-07-25','09:35:00',1.5),('15087','2013-07-25','09:40:00',1.64),('15087','2013-07-25','09:45:00',1.13),('15087','2013-07-25','09:50:00',1.06),('15087','2013-07-25','10:00:00',2.77),('15087','2013-07-25','10:05:00',3.22),('15087','2013-07-25','10:10:00',3.24),('15087','2013-07-25','10:15:00',3.25),('15087','2013-07-25','10:20:00',3.35),('15087','2013-07-25','10:25:00',1.78),('15087','2013-07-25','10:30:00',1.4),('15087','2013-07-25','10:35:00',2.15),('15087','2013-07-25','10:40:00',2.52),('15087','2013-07-25','10:45:00',3.92),('15087','2013-07-25','10:50:00',3.88),('15087','2013-07-25','10:55:00',3.84),('15087','2013-07-25','11:00:00',4.01),('15087','2013-07-25','11:05:00',4.01),('15087','2013-07-25','11:10:00',4.04),('15087','2013-07-25','11:15:00',4.1),('15087','2013-07-25','11:20:00',3.99),('15087','2013-07-25','11:25:00',4.19),('15087','2013-07-25','11:30:00',4.26),('15087','2013-07-25','11:35:00',2.68),('15087','2013-07-25','11:40:00',4.1),('15087','2013-07-25','11:45:00',2.91),('15087','2013-07-25','11:50:00',4.56),('15087','2013-07-25','11:55:00',3.99),('15087','2013-07-25','12:00:00',4.42),('15087','2013-07-25','12:05:00',1.18),('15087','2013-07-25','12:10:00',3.52),('15087','2013-07-25','12:15:00',1.93),('15087','2013-07-25','12:20:00',3.95),('15087','2013-07-25','12:25:00',4.12),('15087','2013-07-25','12:30:00',4.6),('15087','2013-07-25','12:35:00',3.29),('15087','2013-07-25','12:40:00',4.25),('15087','2013-07-25','12:45:00',3.92),('15087','2013-07-25','12:50:00',4.57),('15087','2013-07-25','12:55:00',4.75),('15087','2013-07-25','13:00:00',4.55),('15087','2013-07-25','13:05:00',4.64),('15087','2013-07-25','13:10:00',4.73),('15087','2013-07-25','13:15:00',4.62),('15087','2013-07-25','13:20:00',4.6),('15087','2013-07-25','13:25:00',4.53),('15087','2013-07-25','13:30:00',4.51),('15087','2013-07-25','13:35:00',4.52),('15087','2013-07-25','13:40:00',4.5),('15087','2013-07-25','13:45:00',4.55),('15087','2013-07-25','13:50:00',4.57),('15087','2013-07-25','13:55:00',4.55),('15087','2013-07-25','14:00:00',4.55),('15087','2013-07-25','14:05:00',4.59),('15087','2013-07-25','14:10:00',4.54),('15087','2013-07-25','14:15:00',4.52),('15087','2013-07-25','14:20:00',4.47),('15087','2013-07-25','14:25:00',4.41),('15087','2013-07-25','14:30:00',4.29),('15087','2013-07-25','14:35:00',4.05),('15087','2013-07-25','14:40:00',4.19),('15087','2013-07-25','14:45:00',4.28),('15087','2013-07-25','14:50:00',4.23),('15087','2013-07-25','14:55:00',4.06),('15087','2013-07-25','15:00:00',4.13),('15087','2013-07-25','15:05:00',4.07),('15087','2013-07-25','15:10:00',4.02),('15087','2013-07-25','15:15:00',3.97),('15087','2013-07-25','15:20:00',3.76),('15087','2013-07-25','15:25:00',3.65),('15087','2013-07-25','15:30:00',3.8),('15087','2013-07-25','15:35:00',3.79),('15087','2013-07-25','15:40:00',3.73),('15087','2013-07-25','15:45:00',3.52),('15087','2013-07-25','15:50:00',3.24),('15087','2013-07-25','15:55:00',3.14),('15087','2013-07-25','16:00:00',3.45),('15087','2013-07-25','16:05:00',3.33),('15087','2013-07-25','16:10:00',3.11),('15087','2013-07-25','16:15:00',3.23),('15087','2013-07-25','16:20:00',3.08),('15087','2013-07-25','16:25:00',3.05),('15087','2013-07-25','16:30:00',3),('15087','2013-07-25','16:35:00',2.96),('15087','2013-07-25','16:40:00',2.92),('15087','2013-07-25','16:45:00',2.88),('15087','2013-07-25','16:50:00',2.83),('15087','2013-07-25','16:55:00',2.78),('15087','2013-07-25','17:00:00',2.71),('15087','2013-07-25','17:05:00',2.6),('15087','2013-07-25','17:10:00',2.49),('15087','2013-07-25','17:15:00',2.42),('15087','2013-07-25','17:20:00',2.3),('15087','2013-07-25','17:25:00',2.31),('15087','2013-07-25','17:30:00',2.26),('15087','2013-07-25','17:35:00',2.08),('15087','2013-07-25','17:40:00',1.94),('15087','2013-07-25','17:45:00',1.87),('15087','2013-07-25','17:50:00',1.6),('15087','2013-07-25','17:55:00',1.53),('15087','2013-07-25','18:00:00',1.58),('15087','2013-07-25','18:05:00',1.4),('15087','2013-07-25','18:10:00',1.31),('15087','2013-07-25','18:15:00',1.3),('15087','2013-07-25','18:20:00',1.23),('15087','2013-07-25','18:25:00',1.05),('15087','2013-07-25','18:30:00',1.03),('15087','2013-07-24','08:15:00',1.43),('15087','2013-07-24','08:20:00',1.27),('15087','2013-07-24','08:25:00',1.14),('15087','2013-07-24','08:30:00',1.09),('15087','2013-07-24','08:35:00',1.14),('15087','2013-07-24','08:40:00',1.02),('15087','2013-07-24','08:45:00',1.83),('15087','2013-07-24','08:50:00',2.24),('15087','2013-07-24','08:55:00',2.25),('15087','2013-07-24','09:00:00',1.89),('15087','2013-07-24','09:05:00',1.86),('15087','2013-07-24','09:10:00',2.57),('15087','2013-07-24','09:15:00',1.94),('15087','2013-07-24','09:20:00',2.21),('15087','2013-07-24','09:25:00',1.67),('15087','2013-07-24','09:30:00',2.37),('15087','2013-07-24','09:35:00',2.08),('15087','2013-07-24','09:40:00',1.62),('15087','2013-07-24','09:45:00',1.54),('15087','2013-07-24','09:50:00',1.38),('15087','2013-07-24','09:55:00',1.3),('15087','2013-07-24','10:10:00',1.64),('15087','2013-07-24','10:15:00',2.43),('15087','2013-07-24','10:20:00',3.05),('15087','2013-07-24','10:25:00',3.78),('15087','2013-07-24','10:30:00',3.8),('15087','2013-07-24','10:35:00',3.88),('15087','2013-07-24','10:40:00',2.68),('15087','2013-07-24','10:45:00',1.99),('15087','2013-07-24','10:50:00',1.96),('15087','2013-07-24','10:55:00',1.8),('15087','2013-07-24','11:00:00',2.59),('15087','2013-07-24','11:05:00',2.89),('15087','2013-07-24','11:10:00',4.23),('15087','2013-07-24','11:15:00',4.2),('15087','2013-07-24','11:20:00',3.87),('15087','2013-07-24','11:25:00',3.94),('15087','2013-07-24','11:30:00',3.54),('15087','2013-07-24','11:35:00',4.15),('15087','2013-07-24','11:40:00',4.25),('15087','2013-07-24','11:45:00',4.32),('15087','2013-07-24','11:50:00',4.2),('15087','2013-07-24','11:55:00',4.26),('15087','2013-07-24','12:00:00',4.53),('15087','2013-07-24','12:05:00',3.85),('15087','2013-07-24','12:10:00',4.77),('15087','2013-07-24','12:15:00',4.49),('15087','2013-07-24','12:20:00',3.22),('15087','2013-07-24','12:25:00',1.95),('15087','2013-07-24','12:30:00',4.1),('15087','2013-07-24','12:35:00',1.32),('15087','2013-07-24','12:40:00',3.44),('15087','2013-07-24','12:45:00',3.95),('15087','2013-07-24','12:50:00',2.78),('15087','2013-07-24','12:55:00',4.41),('15087','2013-07-24','13:00:00',4.02),('15087','2013-07-24','13:05:00',4.4),('15087','2013-07-24','13:10:00',2.84),('15087','2013-07-24','13:15:00',3.64),('15087','2013-07-24','13:20:00',1.67),('15087','2013-07-24','13:25:00',4.78),('15087','2013-07-24','13:30:00',4.73),('15087','2013-07-24','13:35:00',2.53),('15087','2013-07-24','13:40:00',1.51),('15087','2013-07-24','13:45:00',4.61),('15087','2013-07-24','13:50:00',4.89),('15087','2013-07-24','13:55:00',3.98),('15087','2013-07-24','14:00:00',4.56),('15087','2013-07-24','14:05:00',4.71),('15087','2013-07-24','14:10:00',4.64),('15087','2013-07-24','14:15:00',4.66),('15087','2013-07-24','14:20:00',4.72),('15087','2013-07-24','14:25:00',4.67),('15087','2013-07-24','14:30:00',4.59),('15087','2013-07-24','14:35:00',4.6),('15087','2013-07-24','14:40:00',4.38),('15087','2013-07-24','14:45:00',4.4),('15087','2013-07-24','14:50:00',4.36),('15087','2013-07-24','14:55:00',4.24),('15087','2013-07-24','15:00:00',4.17),('15087','2013-07-24','15:05:00',4.11),('15087','2013-07-24','15:10:00',4.09),('15087','2013-07-24','15:15:00',4.07),('15087','2013-07-24','15:20:00',3.93),('15087','2013-07-24','15:25:00',3.84),('15087','2013-07-24','15:30:00',3.71),('15087','2013-07-24','15:35:00',3.65),('15087','2013-07-24','15:40:00',3.76),('15087','2013-07-24','15:45:00',3.57),('15087','2013-07-24','15:50:00',3.35),('15087','2013-07-24','15:55:00',3.35),('15087','2013-07-24','16:00:00',3.47),('15087','2013-07-24','16:05:00',3.35),('15087','2013-07-24','16:10:00',3.3),('15087','2013-07-24','16:15:00',3.3),('15087','2013-07-24','16:20:00',3.27),('15087','2013-07-24','16:25:00',3.27),('15087','2013-07-24','16:30:00',3.13),('15087','2013-07-24','16:35:00',3),('15087','2013-07-24','16:40:00',3.04),('15087','2013-07-24','16:45:00',3.01),('15087','2013-07-24','16:50:00',3.04),('15087','2013-07-24','16:55:00',3),('15087','2013-07-24','17:00:00',2.88),('15087','2013-07-24','17:05:00',2.81),('15087','2013-07-24','17:10:00',2.46),('15087','2013-07-24','17:15:00',2.57),('15087','2013-07-24','17:20:00',2.42),('15087','2013-07-24','17:25:00',2.36),('15087','2013-07-24','17:30:00',2.28),('15087','2013-07-24','17:35:00',2.01),('15087','2013-07-24','17:40:00',1.95),('15087','2013-07-24','17:45:00',1.86),('15087','2013-07-24','17:50:00',1.72),('15087','2013-07-24','17:55:00',1.63),('15087','2013-07-24','18:00:00',1.57),('15087','2013-07-24','18:05:00',1.43),('15087','2013-07-24','18:10:00',1.32),('15087','2013-07-24','18:15:00',1.25),('15087','2013-07-24','18:20:00',1.17),('15087','2013-07-24','18:25:00',1.09),('15087','2013-07-24','18:30:00',1.03),('15087','2013-07-23','07:45:00',1.05),('15087','2013-07-23','07:50:00',1.13),('15087','2013-07-23','07:55:00',1.21),('15087','2013-07-23','08:00:00',1.24),('15087','2013-07-23','08:05:00',1.33),('15087','2013-07-23','08:10:00',1.46),('15087','2013-07-23','08:15:00',1.58),('15087','2013-07-23','08:20:00',1.67),('15087','2013-07-23','08:25:00',1.76),('15087','2013-07-23','08:30:00',1.84),('15087','2013-07-23','08:35:00',1.92),('15087','2013-07-23','08:40:00',2.01),('15087','2013-07-23','08:45:00',2.12),('15087','2013-07-23','08:50:00',2.22),('15087','2013-07-23','08:55:00',2.38),('15087','2013-07-23','09:00:00',2.47),('15087','2013-07-23','09:05:00',2.52),('15087','2013-07-23','09:10:00',2.6),('15087','2013-07-23','09:15:00',2.65),('15087','2013-07-23','09:20:00',2.73),('15087','2013-07-23','09:25:00',2.78),('15087','2013-07-23','09:30:00',2.85),('15087','2013-07-23','09:35:00',2.9),('15087','2013-07-23','09:40:00',2.96),('15087','2013-07-23','09:45:00',3),('15087','2013-07-23','09:50:00',3.05),('15087','2013-07-23','09:55:00',3.15),('15087','2013-07-23','10:00:00',3.17),('15087','2013-07-23','10:05:00',3.23),('15087','2013-07-23','10:10:00',3.29),('15087','2013-07-23','10:15:00',3.32),('15087','2013-07-23','10:20:00',3.37),('15087','2013-07-23','10:25:00',3.52),('15087','2013-07-23','10:30:00',3.64),('15087','2013-07-23','10:35:00',3.69),('15087','2013-07-23','10:40:00',3.74),('15087','2013-07-23','10:45:00',3.76),('15087','2013-07-23','10:50:00',3.77),('15087','2013-07-23','10:55:00',3.87),('15087','2013-07-23','11:00:00',3.9),('15087','2013-07-23','11:05:00',3.95),('15087','2013-07-23','11:10:00',4),('15087','2013-07-23','11:15:00',4.09),('15087','2013-07-23','11:20:00',4.15),('15087','2013-07-23','11:25:00',4.12),('15087','2013-07-23','11:30:00',4.12),('15087','2013-07-23','11:35:00',4.16),('15087','2013-07-23','11:40:00',4.25),('15087','2013-07-23','11:45:00',4.27),('15087','2013-07-23','11:50:00',4.25),('15087','2013-07-23','11:55:00',4.37),('15087','2013-07-23','12:00:00',4.4),('15087','2013-07-23','12:05:00',4.43),('15087','2013-07-23','12:10:00',4.47),('15087','2013-07-23','12:15:00',4.51),('15087','2013-07-23','12:20:00',4.49),('15087','2013-07-23','12:25:00',4.38),('15087','2013-07-23','12:30:00',3.89),('15087','2013-07-23','12:35:00',1.22),('15087','2013-07-23','12:45:00',1.63),('15087','2013-07-23','12:50:00',2.26),('15087','2013-07-23','12:55:00',4.36),('15087','2013-07-23','13:00:00',1.19),('15087','2013-07-23','13:30:00',3.14),('15087','2013-07-23','13:35:00',4.21),('15087','2013-07-23','13:40:00',2.47),('15087','2013-07-23','13:55:00',1.64),('15087','2013-07-23','14:00:00',4.36),('15087','2013-07-23','14:05:00',4.63),('15087','2013-07-23','14:10:00',1.32),('15087','2013-07-23','14:25:00',1.64),('15087','2013-07-23','14:30:00',2.49),('15087','2013-07-23','14:35:00',2.96),('15087','2013-07-23','14:40:00',1.77),('15087','2013-07-23','14:45:00',3.3),('15087','2013-07-23','14:50:00',2.03),('15087','2013-07-23','14:55:00',3.58),('15087','2013-07-23','15:00:00',4.72),('15087','2013-07-23','15:05:00',4.15),('15087','2013-07-23','15:10:00',4.11),('15087','2013-07-23','15:15:00',4.11),('15087','2013-07-23','15:20:00',3.88),('15087','2013-07-23','15:25:00',3.78),('15087','2013-07-23','15:30:00',3.78),('15087','2013-07-23','15:35:00',3.8),('15087','2013-07-23','15:40:00',3.6),('15087','2013-07-23','15:45:00',3.5),('15087','2013-07-23','15:50:00',3.3),('15087','2013-07-23','15:55:00',3.4),('15087','2013-07-23','16:00:00',3.41),('15087','2013-07-23','16:05:00',3.32),('15087','2013-07-23','16:10:00',3.21),('15087','2013-07-23','16:15:00',3.17),('15087','2013-07-23','16:20:00',3.12),('15087','2013-07-23','16:25:00',3.08),('15087','2013-07-23','16:30:00',2.98),('15087','2013-07-23','16:35:00',2.76),('15087','2013-07-23','16:40:00',2.83),('15087','2013-07-23','16:45:00',2.86),('15087','2013-07-23','16:50:00',2.82),('15087','2013-07-23','16:55:00',2.74),('15087','2013-07-23','17:00:00',2.67),('15087','2013-07-23','17:05:00',2.57),('15087','2013-07-23','17:10:00',2.48),('15087','2013-07-23','17:15:00',2.46),('15087','2013-07-23','17:20:00',2.4),('15087','2013-07-23','17:25:00',2.33),('15087','2013-07-23','17:30:00',2.27),('15087','2013-07-23','17:35:00',2.05),('15087','2013-07-23','17:40:00',2.01),('15087','2013-07-23','17:45:00',1.91),('15087','2013-07-23','17:50:00',1.68),('15087','2013-07-23','17:55:00',1.62),('15087','2013-07-23','18:00:00',1.65),('15087','2013-07-23','18:05:00',1.46),('15087','2013-07-23','18:10:00',1.43),('15087','2013-07-23','18:15:00',1.36),('15087','2013-07-23','18:20:00',1.23),('15087','2013-07-23','18:25:00',1.19),('15087','2013-07-23','18:30:00',1.09),('15087','2013-07-22','07:45:00',1.03),('15087','2013-07-22','07:50:00',1.1),('15087','2013-07-22','07:55:00',1.19),('15087','2013-07-22','08:00:00',1.27),('15087','2013-07-22','08:05:00',1.36),('15087','2013-07-22','08:10:00',1.45),('15087','2013-07-22','08:15:00',1.55),('15087','2013-07-22','08:20:00',1.63),('15087','2013-07-22','08:25:00',1.72),('15087','2013-07-22','08:30:00',1.82),('15087','2013-07-22','08:35:00',1.88),('15087','2013-07-22','08:40:00',1.98),('15087','2013-07-22','08:45:00',2.09),('15087','2013-07-22','08:50:00',2.2),('15087','2013-07-22','08:55:00',2.31),('15087','2013-07-22','09:00:00',2.41),('15087','2013-07-22','09:05:00',2.52),('15087','2013-07-22','09:10:00',2.59),('15087','2013-07-22','09:15:00',2.66),('15087','2013-07-22','09:20:00',2.73),('15087','2013-07-22','09:25:00',2.8),('15087','2013-07-22','09:30:00',2.89),('15087','2013-07-22','09:35:00',2.95),('15087','2013-07-22','09:40:00',3.02),('15087','2013-07-22','09:45:00',3.1),('15087','2013-07-22','09:50:00',3.16),('15087','2013-07-22','09:55:00',3.22),('15087','2013-07-22','10:00:00',3.28),('15087','2013-07-22','10:05:00',3.36),('15087','2013-07-22','10:10:00',3.43),('15087','2013-07-22','10:15:00',3.49),('15087','2013-07-22','10:20:00',3.54),('15087','2013-07-22','10:25:00',3.6),('15087','2013-07-22','10:30:00',3.67),('15087','2013-07-22','10:35:00',3.73),('15087','2013-07-22','10:40:00',3.77),('15087','2013-07-22','10:45:00',3.8),('15087','2013-07-22','10:50:00',3.86),('15087','2013-07-22','10:55:00',3.9),('15087','2013-07-22','11:00:00',3.92),('15087','2013-07-22','11:05:00',3.95),('15087','2013-07-22','11:10:00',3.98),('15087','2013-07-22','11:15:00',4.04),('15087','2013-07-22','11:20:00',4.09),('15087','2013-07-22','11:25:00',4.09),('15087','2013-07-22','11:30:00',4.1),('15087','2013-07-22','11:35:00',4.14),('15087','2013-07-22','11:40:00',4.18),('15087','2013-07-22','11:45:00',4.18),('15087','2013-07-22','11:50:00',4.22),('15087','2013-07-22','11:55:00',4.24),('15087','2013-07-22','12:00:00',4.25),('15087','2013-07-22','12:05:00',4.32),('15087','2013-07-22','12:10:00',4.34),('15087','2013-07-22','12:15:00',4.37),('15087','2013-07-22','12:20:00',4.41),('15087','2013-07-22','12:25:00',4.39),('15087','2013-07-22','12:30:00',4.43),('15087','2013-07-22','12:35:00',4.49),('15087','2013-07-22','12:40:00',4.48),('15087','2013-07-22','12:45:00',4.45),('15087','2013-07-22','12:50:00',4.41),('15087','2013-07-22','12:55:00',4.42),('15087','2013-07-22','13:00:00',4.41),('15087','2013-07-22','13:05:00',4.46),('15087','2013-07-22','13:10:00',4.42),('15087','2013-07-22','13:15:00',4.43),('15087','2013-07-22','13:20:00',4.47),('15087','2013-07-22','13:25:00',4.52),('15087','2013-07-22','13:30:00',4.46),('15087','2013-07-22','13:35:00',4.45),('15087','2013-07-22','13:40:00',4.44),('15087','2013-07-22','13:45:00',4.47),('15087','2013-07-22','13:50:00',4.46),('15087','2013-07-22','13:55:00',4.41),('15087','2013-07-22','14:00:00',4.39),('15087','2013-07-22','14:05:00',4.38),('15087','2013-07-22','14:10:00',4.39),('15087','2013-07-22','14:15:00',4.33),('15087','2013-07-22','14:20:00',4.3),('15087','2013-07-22','14:25:00',4.25),('15087','2013-07-22','14:30:00',4.29),('15087','2013-07-22','14:35:00',4.06),('15087','2013-07-22','14:40:00',4.09),('15087','2013-07-22','14:45:00',4.15),('15087','2013-07-22','14:50:00',4.13),('15087','2013-07-22','14:55:00',4.03),('15087','2013-07-22','15:00:00',3.81),('15087','2013-07-22','15:05:00',3.76),('15087','2013-07-22','15:10:00',3.97),('15087','2013-07-22','15:15:00',3.89),('15087','2013-07-22','15:20:00',3.79),('15087','2013-07-22','15:25:00',3.75),('15087','2013-07-22','15:30:00',2.42),('15087','2013-07-22','15:40:00',1.02),('15087','2013-07-22','15:45:00',2.15),('15087','2013-07-22','15:50:00',3.82),('15087','2013-07-22','15:55:00',3.88),('15087','2013-07-22','16:00:00',3.87),('15087','2013-07-22','16:05:00',3.77),('15087','2013-07-22','16:10:00',3.59),('15087','2013-07-22','16:15:00',3.23),('15087','2013-07-22','16:20:00',3.49),('15087','2013-07-22','16:25:00',3.36),('15087','2013-07-22','16:30:00',3.17),('15087','2013-07-22','16:35:00',3.03),('15087','2013-07-22','16:40:00',2.83),('15087','2013-07-22','16:45:00',2.83),('15087','2013-07-22','16:50:00',2.74),('15087','2013-07-22','16:55:00',2.7),('15087','2013-07-22','17:00:00',2.63),('15087','2013-07-22','17:05:00',2.58),('15087','2013-07-22','17:10:00',2.47),('15087','2013-07-22','17:15:00',2.38),('15087','2013-07-22','17:20:00',2.34),('15087','2013-07-22','17:25:00',2.26),('15087','2013-07-22','17:30:00',2.09),('15087','2013-07-22','17:35:00',2.07),('15087','2013-07-22','17:40:00',1.99),('15087','2013-07-22','17:45:00',1.73),('15087','2013-07-22','17:50:00',1.61),('15087','2013-07-22','17:55:00',1.6),('15087','2013-07-22','18:00:00',1.63),('15087','2013-07-22','18:05:00',1.48),('15087','2013-07-22','18:10:00',1.36),('15087','2013-07-22','18:15:00',1.24),('15087','2013-07-22','18:20:00',1.18),('15087','2013-07-22','18:25:00',1.13),('15087','2013-07-22','18:30:00',1),('15087','2013-07-21','07:45:00',1.03),('15087','2013-07-21','07:50:00',1.08),('15087','2013-07-21','07:55:00',1.14),('15087','2013-07-21','08:00:00',1.19),('15087','2013-07-21','08:05:00',1.26),('15087','2013-07-21','08:10:00',1.37),('15087','2013-07-21','08:15:00',1.45),('15087','2013-07-21','08:20:00',1.52),('15087','2013-07-21','08:25:00',1.62),('15087','2013-07-21','08:30:00',1.73),('15087','2013-07-21','08:35:00',1.79),('15087','2013-07-21','08:40:00',1.89),('15087','2013-07-21','08:45:00',1.95),('15087','2013-07-21','08:50:00',2.03),('15087','2013-07-21','08:55:00',2.19),('15087','2013-07-21','09:00:00',2.31),('15087','2013-07-21','09:05:00',2.39),('15087','2013-07-21','09:10:00',2.49),('15087','2013-07-21','09:15:00',2.57),('15087','2013-07-21','09:20:00',2.65),('15087','2013-07-21','09:25:00',2.71),('15087','2013-07-21','09:30:00',2.78),('15087','2013-07-21','09:35:00',2.83),('15087','2013-07-21','09:40:00',2.93),('15087','2013-07-21','09:45:00',2.99),('15087','2013-07-21','09:50:00',3.04),('15087','2013-07-21','09:55:00',3.1),('15087','2013-07-21','10:00:00',3.19),('15087','2013-07-21','10:05:00',3.26),('15087','2013-07-21','10:10:00',3.31),('15087','2013-07-21','10:15:00',3.37),('15087','2013-07-21','10:20:00',3.42),('15087','2013-07-21','10:25:00',3.47),('15087','2013-07-21','10:30:00',3.53),('15087','2013-07-21','10:35:00',3.58),('15087','2013-07-21','10:40:00',3.62),('15087','2013-07-21','10:45:00',3.64),('15087','2013-07-21','10:50:00',3.77),('15087','2013-07-21','10:55:00',3.77),('15087','2013-07-21','11:00:00',3.84),('15087','2013-07-21','11:05:00',3.89),('15087','2013-07-21','11:10:00',3.91),('15087','2013-07-21','11:15:00',3.93),('15087','2013-07-21','11:20:00',3.94),('15087','2013-07-21','11:25:00',4.03),('15087','2013-07-21','11:30:00',4.09),('15087','2013-07-21','11:35:00',4.09),('15087','2013-07-21','11:40:00',4.23),('15087','2013-07-21','11:45:00',4.25),('15087','2013-07-21','11:50:00',4.2),('15087','2013-07-21','11:55:00',4.22),('15087','2013-07-21','12:00:00',4.28),('15087','2013-07-21','12:05:00',4.14),('15087','2013-07-21','12:10:00',4.2),('15087','2013-07-21','12:15:00',4.29),('15087','2013-07-21','12:20:00',4.59),('15087','2013-07-21','12:25:00',4.85),('15087','2013-07-21','12:30:00',4.95),('15087','2013-07-21','12:35:00',5.19),('15087','2013-07-21','12:40:00',5.2),('15087','2013-07-21','12:45:00',5.07),('15087','2013-07-21','12:50:00',4.48),('15087','2013-07-21','12:55:00',5.24),('15087','2013-07-21','13:00:00',5.05),('15087','2013-07-21','13:05:00',5.12),('15087','2013-07-21','13:10:00',3.94),('15087','2013-07-21','13:15:00',4.09),('15087','2013-07-21','13:20:00',3.71),('15087','2013-07-21','13:25:00',4.24),('15087','2013-07-21','13:30:00',4.65),('15087','2013-07-21','13:35:00',4.87),('15087','2013-07-21','13:40:00',4.34),('15087','2013-07-21','13:45:00',4.54),('15087','2013-07-21','13:50:00',2.72),('15087','2013-07-21','13:55:00',1.01),('15087','2013-07-21','14:00:00',1.04),('15087','2013-07-21','14:05:00',1.15),('15087','2013-07-21','14:10:00',1.08),('15087','2013-07-21','14:15:00',1.08),('15087','2013-07-21','14:20:00',1.34),('15087','2013-07-21','14:25:00',1.5),('15087','2013-07-21','14:30:00',1.24),('15087','2013-07-21','14:35:00',1.26),('15087','2013-07-21','14:40:00',1.26),('15087','2013-07-21','14:45:00',1.43),('15087','2013-07-21','14:50:00',1.68),('15087','2013-07-21','14:55:00',1.72),('15087','2013-07-21','15:00:00',1.9),('15087','2013-07-21','15:05:00',1.72),('15087','2013-07-21','15:10:00',1.76),('15087','2013-07-21','15:15:00',4.1),('15087','2013-07-21','15:20:00',4.38),('15087','2013-07-21','15:25:00',1.71),('15087','2013-07-21','15:30:00',1.52),('15087','2013-07-21','15:35:00',1.71),('15087','2013-07-21','15:40:00',2.75),('15087','2013-07-21','15:45:00',3.71),('15087','2013-07-21','15:50:00',3.16),('15087','2013-07-21','15:55:00',2.18),('15087','2013-07-21','16:00:00',1.45),('15087','2013-07-21','16:05:00',1.06),('15087','2013-07-21','16:55:00',1.07),('15087','2013-07-21','17:00:00',1.19),('15087','2013-07-21','17:05:00',1.32),('15087','2013-07-21','17:10:00',1.38),('15087','2013-07-21','17:15:00',1.13),('15087','2013-07-21','17:20:00',1),('15087','2014-04-07','08:20:00',1.03),('15087','2014-04-07','08:25:00',1.06),('15087','2014-04-07','08:30:00',1.28),('15087','2014-04-07','08:35:00',1.72),('15087','2014-04-07','08:40:00',1.78),('15087','2014-04-07','08:45:00',1.57),('15087','2014-04-07','08:50:00',1.45),('15087','2014-04-07','08:55:00',1.26),('15087','2014-04-07','09:00:00',1.18),('15087','2014-04-07','09:05:00',1.2),('15087','2014-04-07','09:10:00',1.44),('15087','2014-04-07','09:15:00',1.71),('15087','2014-04-07','09:20:00',1.3),('15087','2014-04-07','09:25:00',1.22),('15087','2014-04-07','09:30:00',1.21),('15087','2014-04-07','09:35:00',1.16),('15087','2014-04-07','09:40:00',1.2),('15087','2014-04-07','09:45:00',1.28),('15087','2014-04-07','09:50:00',1.35),('15087','2014-04-07','09:55:00',1.45),('15087','2014-04-07','10:00:00',1.46),('15087','2014-04-07','10:05:00',1.46),('15087','2014-04-07','10:10:00',1.5),('15087','2014-04-07','10:15:00',1.35),('15087','2014-04-07','10:20:00',1.34),('15087','2014-04-07','10:25:00',1.4),('15087','2014-04-07','10:30:00',1.41),('15087','2014-04-07','10:35:00',1.53),('15087','2014-04-07','10:40:00',1.58),('15087','2014-04-07','10:45:00',1.65),('15087','2014-04-07','10:50:00',1.75),('15087','2014-04-07','10:55:00',1.89),('15087','2014-04-07','11:00:00',2.03),('15087','2014-04-07','11:05:00',2.08),('15087','2014-04-07','11:10:00',2.29),('15087','2014-04-07','11:15:00',2.46),('15087','2014-04-07','11:20:00',2.49),('15087','2014-04-07','11:25:00',2.18),('15087','2014-04-07','11:30:00',2.17),('15087','2014-04-07','11:35:00',2.15),('15087','2014-04-07','11:40:00',2.11),('15087','2014-04-07','11:45:00',2.01),('15087','2014-04-07','11:50:00',1.9),('15087','2014-04-07','11:55:00',1.83),('15087','2014-04-07','12:00:00',2.05),('15087','2014-04-07','12:05:00',2.54),('15087','2014-04-07','12:10:00',2.69),('15087','2014-04-07','12:15:00',3.61),('15087','2014-04-07','12:20:00',4.28),('15087','2014-04-07','12:25:00',3.97),('15087','2014-04-07','12:30:00',2.58),('15087','2014-04-07','12:35:00',2.33),('15087','2014-04-07','12:40:00',2.82),('15087','2014-04-07','12:45:00',4.3),('15087','2014-04-07','12:50:00',4.36),('15087','2014-04-07','12:55:00',4.27),('15087','2014-04-07','13:00:00',4.31),('15087','2014-04-07','13:05:00',4.33),('15087','2014-04-07','13:10:00',4.28),('15087','2014-04-07','13:15:00',4.27),('15087','2014-04-07','13:20:00',4.25),('15087','2014-04-07','13:25:00',4.25),('15087','2014-04-07','13:30:00',4.28),('15087','2014-04-07','13:35:00',4.24),('15087','2014-04-07','13:40:00',4.22),('15087','2014-04-07','13:45:00',4.23),('15087','2014-04-07','13:50:00',4.26),('15087','2014-04-07','13:55:00',4.14),('15087','2014-04-07','14:00:00',4.16),('15087','2014-04-07','14:05:00',4.14),('15087','2014-04-07','14:10:00',4.07),('15087','2014-04-07','14:15:00',3.93),('15087','2014-04-07','14:20:00',3.84),('15087','2014-04-07','14:25:00',4.05),('15087','2014-04-07','14:30:00',4.04),('15087','2014-04-07','14:35:00',3.86),('15087','2014-04-07','14:40:00',3.74),('15087','2014-04-07','14:45:00',3.72),('15087','2014-04-07','14:50:00',3.77),('15087','2014-04-07','14:55:00',3.6),('15087','2014-04-07','15:00:00',3.32),('15087','2014-04-07','15:05:00',3.69),('15087','2014-04-07','15:10:00',3.59),('15087','2014-04-07','15:15:00',3.68),('15087','2014-04-07','15:20:00',3.77),('15087','2014-04-07','15:25:00',3.59),('15087','2014-04-07','15:30:00',3.49),('15087','2014-04-07','15:35:00',3.42),('15087','2014-04-07','15:40:00',3.37),('15087','2014-04-07','15:45:00',3.33),('15087','2014-04-07','15:50:00',3.49),('15087','2014-04-07','15:55:00',3.43),('15087','2014-04-07','16:00:00',2.63),('15087','2014-04-07','16:05:00',2.18),('15087','2014-04-07','16:10:00',3.04),('15087','2014-04-07','16:15:00',2.78),('15087','2014-04-07','16:20:00',2.59),('15087','2014-04-07','16:25:00',2.5),('15087','2014-04-07','16:30:00',2.39),('15087','2014-04-07','16:35:00',1.29),('15087','2014-04-07','16:40:00',1.38),('15087','2014-04-07','16:45:00',1.69),('15087','2014-04-07','16:50:00',2.33),('15087','2014-04-07','16:55:00',2.42),('15087','2014-04-07','17:00:00',2.46),('15087','2014-04-07','17:05:00',2.33),('15087','2014-04-07','17:10:00',1.64),('15087','2014-04-07','17:15:00',1.83),('15087','2014-04-07','17:20:00',1.49),('15087','2013-07-20','07:45:00',1.03),('15087','2013-07-20','07:50:00',1.12),('15087','2013-07-20','07:55:00',1.21),('15087','2013-07-20','08:00:00',1.28),('15087','2013-07-20','08:05:00',1.37),('15087','2013-07-20','08:10:00',1.46),('15087','2013-07-20','08:15:00',1.55),('15087','2013-07-20','08:20:00',1.65),('15087','2013-07-20','08:25:00',1.73),('15087','2013-07-20','08:30:00',1.81),('15087','2013-07-20','08:35:00',1.91),('15087','2013-07-20','08:40:00',1.99),('15087','2013-07-20','08:45:00',2.12),('15087','2013-07-20','08:50:00',2.2),('15087','2013-07-20','08:55:00',2.36),('15087','2013-07-20','09:00:00',2.46),('15087','2013-07-20','09:05:00',2.57),('15087','2013-07-20','09:10:00',2.7),('15087','2013-07-20','09:15:00',2.81),('15087','2013-07-20','09:20:00',2.79),('15087','2013-07-20','09:25:00',2.79),('15087','2013-07-20','09:30:00',2.79),('15087','2013-07-20','09:35:00',2.82),('15087','2013-07-20','09:40:00',2.86),('15087','2013-07-20','09:45:00',3.13),('15087','2013-07-20','09:50:00',3.09),('15087','2013-07-20','09:55:00',3.07),('15087','2013-07-20','10:00:00',3.27),('15087','2013-07-20','10:05:00',3.35),('15087','2013-07-20','10:10:00',3.44),('15087','2013-07-20','10:15:00',3.47),('15087','2013-07-20','10:20:00',3.52),('15087','2013-07-20','10:25:00',3.56),('15087','2013-07-20','10:30:00',3.61),('15087','2013-07-20','10:35:00',3.65),('15087','2013-07-20','10:40:00',3.71),('15087','2013-07-20','10:45:00',3.73),('15087','2013-07-20','10:50:00',3.79),('15087','2013-07-20','10:55:00',3.86),('15087','2013-07-20','11:00:00',3.92),('15087','2013-07-20','11:05:00',3.92),('15087','2013-07-20','11:10:00',3.93),('15087','2013-07-20','11:15:00',3.98),('15087','2013-07-20','11:20:00',3.97),('15087','2013-07-20','11:25:00',4.02),('15087','2013-07-20','11:30:00',4.1),('15087','2013-07-20','11:35:00',4.05),('15087','2013-07-20','11:40:00',4.18),('15087','2013-07-20','11:45:00',4.21),('15087','2013-07-20','11:50:00',4.22),('15087','2013-07-20','11:55:00',4.32),('15087','2013-07-20','12:00:00',4.35),('15087','2013-07-20','12:05:00',4.41),('15087','2013-07-20','12:10:00',4.46),('15087','2013-07-20','12:15:00',4.46),('15087','2013-07-20','12:20:00',4.46),('15087','2013-07-20','12:25:00',4.4),('15087','2013-07-20','12:30:00',4.39),('15087','2013-07-20','12:35:00',4.46),('15087','2013-07-20','12:40:00',4.49),('15087','2013-07-20','12:45:00',4.58),('15087','2013-07-20','12:50:00',4.59),('15087','2013-07-20','12:55:00',4.52),('15087','2013-07-20','13:00:00',4.66),('15087','2013-07-20','13:05:00',4.63),('15087','2013-07-20','13:10:00',1.83),('15087','2013-07-20','13:15:00',1.09),('15087','2013-07-20','13:20:00',2.92),('15087','2013-07-20','13:25:00',1.93),('15087','2013-07-20','13:30:00',4.9),('15087','2013-07-20','13:35:00',4.77),('15087','2013-07-20','13:40:00',4.77),('15087','2013-07-20','13:45:00',3.64),('15087','2013-07-20','13:50:00',1.84),('15087','2013-07-20','14:00:00',4.13),('15087','2013-07-20','14:05:00',4.61),('15087','2013-07-20','14:10:00',4.67),('15087','2013-07-20','14:15:00',4.72),('15087','2013-07-20','14:20:00',4.63),('15087','2013-07-20','14:25:00',4.41),('15087','2013-07-20','14:30:00',4.25),('15087','2013-07-20','14:35:00',4.06),('15087','2013-07-20','14:40:00',4.43),('15087','2013-07-20','14:45:00',4.38),('15087','2013-07-20','14:50:00',4.35),('15087','2013-07-20','14:55:00',3.44),('15087','2013-07-20','15:00:00',4.2),('15087','2013-07-20','15:05:00',3.96),('15087','2013-07-20','15:10:00',4.08),('15087','2013-07-20','15:15:00',3.99),('15087','2013-07-20','15:20:00',3.88),('15087','2013-07-20','15:25:00',3.7),('15087','2013-07-20','15:30:00',3.48),('15087','2013-07-20','15:35:00',3.46),('15087','2013-07-20','15:40:00',3.67),('15087','2013-07-20','15:45:00',3.63),('15087','2013-07-20','15:50:00',3.51),('15087','2013-07-20','15:55:00',3.45),('15087','2013-07-20','16:00:00',3.4),('15087','2013-07-20','16:05:00',3.36),('15087','2013-07-20','16:10:00',3.27),('15087','2013-07-20','16:15:00',3.1),('15087','2013-07-20','16:20:00',3.01),('15087','2013-07-20','16:25:00',3.14),('15087','2013-07-20','16:30:00',3.13),('15087','2013-07-20','16:35:00',2.95),('15087','2013-07-20','16:40:00',2.99),('15087','2013-07-20','16:45:00',2.9),('15087','2013-07-20','16:50:00',2.83),('15087','2013-07-20','16:55:00',2.72),('15087','2013-07-20','17:00:00',2.64),('15087','2013-07-20','17:05:00',2.57),('15087','2013-07-20','17:10:00',2.42),('15087','2013-07-20','17:15:00',2.42),('15087','2013-07-20','17:20:00',2.37),('15087','2013-07-20','17:25:00',2.3),('15087','2013-07-20','17:30:00',2.18),('15087','2013-07-20','17:35:00',2.11),('15087','2013-07-20','17:40:00',2.02),('15087','2013-07-20','17:45:00',1.73),('15087','2013-07-20','17:50:00',1.76),('15087','2013-07-20','17:55:00',1.7),('15087','2013-07-20','18:00:00',1.59),('15087','2013-07-20','18:05:00',1.48),('15087','2013-07-20','18:10:00',1.39),('15087','2013-07-20','18:15:00',1.26),('15087','2013-07-20','18:20:00',1.24),('15087','2013-07-20','18:25:00',1.15),('15087','2013-07-20','18:30:00',1.01),('15087','2013-07-19','07:45:00',1.01),('15087','2013-07-19','07:50:00',1.09),('15087','2013-07-19','07:55:00',1.17),('15087','2013-07-19','08:00:00',1.25),('15087','2013-07-19','08:05:00',1.32),('15087','2013-07-19','08:10:00',1.41),('15087','2013-07-19','08:15:00',1.5),('15087','2013-07-19','08:20:00',1.57),('15087','2013-07-19','08:25:00',1.64),('15087','2013-07-19','08:30:00',1.73),('15087','2013-07-19','08:35:00',1.82),('15087','2013-07-19','08:40:00',1.91),('15087','2013-07-19','08:45:00',2.04),('15087','2013-07-19','08:50:00',2.15),('15087','2013-07-19','08:55:00',2.27),('15087','2013-07-19','09:00:00',2.34),('15087','2013-07-19','09:05:00',2.42),('15087','2013-07-19','09:10:00',2.51),('15087','2013-07-19','09:15:00',2.58),('15087','2013-07-19','09:20:00',2.63),('15087','2013-07-19','09:25:00',2.7),('15087','2013-07-19','09:30:00',2.79),('15087','2013-07-19','09:35:00',2.84),('15087','2013-07-19','09:40:00',2.88),('15087','2013-07-19','09:45:00',2.95),('15087','2013-07-19','09:50:00',3.03),('15087','2013-07-19','09:55:00',3.09),('15087','2013-07-19','10:00:00',3.14),('15087','2013-07-19','10:05:00',3.18),('15087','2013-07-19','10:10:00',3.26),('15087','2013-07-19','10:15:00',3.31),('15087','2013-07-19','10:20:00',3.33),('15087','2013-07-19','10:25:00',3.43),('15087','2013-07-19','10:30:00',3.43),('15087','2013-07-19','10:35:00',3.52),('15087','2013-07-19','10:40:00',3.58),('15087','2013-07-19','10:45:00',3.63),('15087','2013-07-19','10:50:00',3.61),('15087','2013-07-19','10:55:00',3.66),('15087','2013-07-19','11:00:00',3.72),('15087','2013-07-19','11:05:00',3.78),('15087','2013-07-19','11:10:00',3.83),('15087','2013-07-19','11:15:00',3.88),('15087','2013-07-19','11:20:00',3.95),('15087','2013-07-19','11:25:00',3.95),('15087','2013-07-19','11:30:00',3.96),('15087','2013-07-19','11:35:00',4.02),('15087','2013-07-19','11:40:00',4.08),('15087','2013-07-19','11:45:00',4.04),('15087','2013-07-19','11:50:00',4),('15087','2013-07-19','11:55:00',4.11),('15087','2013-07-19','12:00:00',4.21),('15087','2013-07-19','12:05:00',4.3),('15087','2013-07-19','12:10:00',4.28),('15087','2013-07-19','12:15:00',4.44),('15087','2013-07-19','12:20:00',4.47),('15087','2013-07-19','12:25:00',4.36),('15087','2013-07-19','12:30:00',4.34),('15087','2013-07-19','12:35:00',4.3),('15087','2013-07-19','12:40:00',4.27),('15087','2013-07-19','12:45:00',4.29),('15087','2013-07-19','12:50:00',4.56),('15087','2013-07-19','12:55:00',4.45),('15087','2013-07-19','13:00:00',3.68),('15087','2013-07-19','13:05:00',4.55),('15087','2013-07-19','13:10:00',3.55),('15087','2013-07-19','13:15:00',1.72),('15087','2013-07-19','13:20:00',2.63),('15087','2013-07-19','13:25:00',4.91),('15087','2013-07-19','13:30:00',4.71),('15087','2013-07-19','13:35:00',4.63),('15087','2013-07-19','13:40:00',4.6),('15087','2013-07-19','13:45:00',4.6),('15087','2013-07-19','13:50:00',4.65),('15087','2013-07-19','13:55:00',4.63),('15087','2013-07-19','14:00:00',4.59),('15087','2013-07-19','14:05:00',4.56),('15087','2013-07-19','14:10:00',4.14),('15087','2013-07-19','14:15:00',4.44),('15087','2013-07-19','14:20:00',4.6),('15087','2013-07-19','14:25:00',4.04),('15087','2013-07-19','14:30:00',4.48),('15087','2013-07-19','14:35:00',3.82),('15087','2013-07-19','14:40:00',4.28),('15087','2013-07-19','14:45:00',4.31),('15087','2013-07-19','14:50:00',4.14),('15087','2013-07-19','14:55:00',4.32),('15087','2013-07-19','15:00:00',4.18),('15087','2013-07-19','15:05:00',4.08),('15087','2013-07-19','15:10:00',4.12),('15087','2013-07-19','15:15:00',2.22),('15087','2013-07-19','15:20:00',2.83),('15087','2013-07-19','15:25:00',3.46),('15087','2013-07-19','15:30:00',3.88),('15087','2013-07-19','15:35:00',3.8),('15087','2013-07-19','15:40:00',3.92),('15087','2013-07-19','15:45:00',3.82),('15087','2013-07-19','15:50:00',3.74),('15087','2013-07-19','15:55:00',3.5),('15087','2013-07-19','16:00:00',3.21),('15087','2013-07-19','16:05:00',3.3),('15087','2013-07-19','16:10:00',3.46),('15087','2013-07-19','16:15:00',3.33),('15087','2013-07-19','16:20:00',3.25),('15087','2013-07-19','16:25:00',3.31),('15087','2013-07-19','16:30:00',3.33),('15087','2013-07-19','16:35:00',3.21),('15087','2013-07-19','16:40:00',3.21),('15087','2013-07-19','16:45:00',3.16),('15087','2013-07-19','16:50:00',3.1),('15087','2013-07-19','16:55:00',3.06),('15087','2013-07-19','17:00:00',2.57),('15087','2013-07-19','17:05:00',2.99),('15087','2013-07-19','17:10:00',2.71),('15087','2013-07-19','17:15:00',2.74),('15087','2013-07-19','17:20:00',2.5),('15087','2013-07-19','17:25:00',1.93),('15087','2013-07-19','17:30:00',2.35),('15087','2013-07-19','17:35:00',2.59),('15087','2013-07-19','17:40:00',2),('15087','2013-07-19','17:45:00',1.41),('15087','2013-07-19','17:50:00',1.01),('15087','2014-05-03','07:35:00',1.02),('15087','2014-05-03','07:40:00',1.12),('15087','2014-05-03','07:45:00',1.21),('15087','2014-05-03','07:50:00',1.33),('15087','2014-05-03','07:55:00',1.49),('15087','2014-05-03','08:00:00',1.67),('15087','2014-05-03','08:05:00',1.82),('15087','2014-05-03','08:10:00',2.17),('15087','2014-05-03','08:15:00',2.07),('15087','2014-05-03','08:20:00',1.19),('15087','2014-05-03','08:25:00',1.19),('15087','2014-05-03','08:30:00',1.77),('15087','2014-05-03','08:45:00',1.63),('15087','2014-05-03','08:50:00',2.86),('15087','2014-05-03','08:55:00',3.03),('15087','2014-05-03','09:00:00',2.3),('15087','2014-05-03','09:05:00',2.12),('15087','2014-05-03','09:10:00',1.52),('15087','2014-05-03','09:15:00',2.8),('15087','2014-05-03','09:20:00',3.72),('15087','2014-05-03','09:25:00',2.23),('15087','2014-05-03','09:30:00',2.32),('15087','2014-05-03','09:35:00',3.25),('15087','2014-05-03','09:40:00',2.68),('15087','2014-05-03','09:45:00',3.71),('15087','2014-05-03','09:50:00',2.24),('15087','2014-05-03','09:55:00',3.77),('15087','2014-05-03','10:00:00',3.97),('15087','2014-05-03','10:05:00',3.97),('15087','2014-05-03','10:10:00',4.27),('15087','2014-05-03','10:15:00',4.1),('15087','2014-05-03','10:20:00',2.42),('15087','2014-05-03','10:25:00',1.55),('15087','2014-05-03','10:30:00',2.2),('15087','2014-05-03','10:35:00',1.25),('15087','2014-05-03','10:40:00',1.27),('15087','2014-05-03','10:45:00',1.23),('15087','2014-05-03','10:50:00',1.13),('15087','2014-05-03','10:55:00',1.51),('15087','2014-05-03','11:00:00',1.28),('15087','2014-05-03','11:05:00',4.54),('15087','2014-05-03','11:10:00',4.6),('15087','2014-05-03','11:15:00',5.41),('15087','2014-05-03','11:20:00',5.3),('15087','2014-05-03','11:25:00',4.15),('15087','2014-05-03','11:30:00',5.15),('15087','2014-05-03','11:35:00',3.09),('15087','2014-05-03','11:40:00',3.44),('15087','2014-05-03','11:45:00',2.98),('15087','2014-05-03','11:50:00',2.66),('15087','2014-05-03','11:55:00',2.69),('15087','2014-05-03','12:00:00',2.02),('15087','2014-05-03','12:05:00',1.56),('15087','2014-05-03','12:10:00',1.38),('15087','2014-05-03','12:15:00',1.29),('15087','2014-05-03','12:20:00',1.22),('15087','2014-05-03','12:25:00',1.32),('15087','2014-05-03','12:30:00',1.84),('15087','2014-05-03','12:35:00',2.38),('15087','2014-05-03','12:40:00',2.31),('15087','2014-05-03','12:45:00',2.26),('15087','2014-05-03','12:50:00',1.94),('15087','2014-05-03','12:55:00',1.9),('15087','2014-05-03','13:00:00',2.15),('15087','2014-05-03','13:05:00',2.71),('15087','2014-05-03','13:10:00',3.02),('15087','2014-05-03','13:15:00',3.13),('15087','2014-05-03','13:20:00',2.51),('15087','2014-05-03','13:25:00',2.97),('15087','2014-05-03','13:30:00',3.75),('15087','2014-05-03','13:35:00',3.52),('15087','2014-05-03','13:40:00',2.33),('15087','2014-05-03','13:45:00',2.08),('15087','2014-05-03','13:50:00',2.04),('15087','2014-05-03','13:55:00',2.05),('15087','2014-05-03','14:00:00',2.03),('15087','2014-05-03','14:05:00',2.07),('15087','2014-05-03','14:10:00',2.29),('15087','2014-05-03','14:15:00',2.72),('15087','2014-05-03','14:20:00',3.13),('15087','2014-05-03','14:25:00',3.7),('15087','2014-05-03','14:30:00',2.22),('15087','2014-05-03','14:35:00',1.7),('15087','2014-05-03','14:40:00',1.19),('15087','2014-05-03','14:55:00',3.35),('15087','2014-05-03','15:00:00',2.51),('15087','2014-05-03','15:05:00',1.3),('15087','2014-05-03','15:10:00',1.02),('15087','2014-05-03','17:05:00',1),('15087','2014-05-03','17:10:00',1.01),('15087','2014-05-03','17:50:00',1.14),('15087','2014-05-03','17:55:00',1.21),('15087','2014-04-06','08:15:00',1.13),('15087','2014-04-06','08:20:00',1.21),('15087','2014-04-06','08:25:00',1.33),('15087','2014-04-06','08:30:00',1.45),('15087','2014-04-06','08:35:00',1.57),('15087','2014-04-06','08:40:00',1.74),('15087','2014-04-06','08:45:00',1.8),('15087','2014-04-06','08:50:00',1.68),('15087','2014-04-06','09:10:00',1.95),('15087','2014-04-06','09:15:00',2.57),('15087','2014-04-06','09:20:00',2.36),('15087','2014-04-06','09:25:00',2.03),('15087','2014-04-06','09:30:00',1.89),('15087','2014-04-06','09:35:00',2.4),('15087','2014-04-06','09:40:00',2.65),('15087','2014-04-06','09:45:00',3.22),('15087','2014-04-06','09:50:00',3.86),('15087','2014-04-06','09:55:00',3.93),('15087','2014-04-06','10:00:00',3.7),('15087','2014-04-06','10:05:00',2.51),('15087','2014-04-06','10:10:00',2.09),('15087','2014-04-06','10:15:00',2.5),('15087','2014-04-06','10:20:00',1.98),('15087','2014-04-06','10:25:00',1.29),('15087','2014-04-06','10:30:00',1.4),('15087','2014-04-06','10:35:00',1.56),('15087','2014-04-06','10:40:00',1.75),('15087','2014-04-06','10:45:00',2.74),('15087','2014-04-06','10:50:00',3.04),('15087','2014-04-06','10:55:00',1.55),('15087','2014-04-06','11:00:00',2.94),('15087','2014-04-06','11:05:00',3.45),('15087','2014-04-06','11:10:00',4.65),('15087','2014-04-06','11:15:00',1.86),('15087','2014-04-06','11:20:00',3.97),('15087','2014-04-06','11:25:00',4.41),('15087','2014-04-06','11:30:00',4.64),('15087','2014-04-06','11:35:00',4.95),('15087','2014-04-06','11:40:00',4.44),('15087','2014-04-06','11:45:00',4.85),('15087','2014-04-06','11:50:00',3.66),('15087','2014-04-06','11:55:00',4.36),('15087','2014-04-06','12:00:00',4.81),('15087','2014-04-06','12:05:00',4.69),('15087','2014-04-06','12:10:00',4.66),('15087','2014-04-06','12:15:00',4.71),('15087','2014-04-06','12:20:00',3.82),('15087','2014-04-06','12:25:00',1.79),('15087','2014-04-06','12:30:00',2.15),('15087','2014-04-06','12:35:00',2.07),('15087','2014-04-06','12:40:00',1.4),('15087','2014-04-06','12:45:00',1.11),('15087','2014-04-06','12:50:00',1.07),('15087','2014-04-06','12:55:00',1.5),('15087','2014-04-06','13:00:00',4.71),('15087','2014-04-06','13:05:00',3.7),('15087','2014-04-06','13:10:00',4.87),('15087','2014-04-06','13:15:00',4.72),('15087','2014-04-06','13:20:00',2.74),('15087','2014-04-06','13:25:00',1.36),('15087','2014-04-06','13:30:00',3.83),('15087','2014-04-06','13:35:00',4.52),('15087','2014-04-06','13:40:00',1.44),('15087','2014-04-06','13:45:00',3.41),('15087','2014-04-06','13:50:00',4.89),('15087','2014-04-06','13:55:00',4.71),('15087','2014-04-06','14:00:00',4.54),('15087','2014-04-06','14:05:00',4.24),('15087','2014-04-06','14:10:00',4.64),('15087','2014-04-06','14:15:00',4.62),('15087','2014-04-06','14:20:00',2.06),('15087','2014-04-06','14:25:00',1.6),('15087','2014-04-06','14:30:00',1.12),('15087','2014-04-06','14:35:00',1.31),('15087','2014-04-06','14:40:00',1.46),('15087','2014-04-06','14:45:00',4.83),('15087','2014-04-06','14:50:00',3.83),('15087','2014-04-06','14:55:00',3.04),('15087','2014-04-06','15:00:00',2.28),('15087','2014-04-06','15:05:00',1.29),('15087','2014-04-06','15:10:00',3.16),('15087','2014-04-06','15:15:00',3.21),('15087','2014-04-06','15:20:00',3),('15087','2014-04-06','15:25:00',1.62),('15087','2014-04-06','15:30:00',1.23),('15087','2014-04-06','15:50:00',1.29),('15087','2014-04-06','15:55:00',3.55),('15087','2014-04-06','16:00:00',3.2),('15087','2014-04-06','16:05:00',1.8),('15087','2014-04-06','16:10:00',2.27),('15087','2014-04-06','16:15:00',1.36),('15087','2014-04-06','16:35:00',1.36),('15087','2014-04-06','16:40:00',2.16),('15087','2014-04-06','16:45:00',2.98),('15087','2014-04-06','16:50:00',2.98),('15087','2014-04-06','16:55:00',2.31),('15087','2014-04-06','17:25:00',1.7),('15087','2014-04-06','17:30:00',1.63),('15087','2014-04-06','17:35:00',1.17),('15087','2014-04-06','17:45:00',1),('15087','2014-04-06','17:50:00',1.28),('15087','2014-04-06','17:55:00',1.1),('15087','2014-04-06','18:00:00',1.03),('15087','2013-07-10','07:25:00',1.18),('15087','2013-07-10','07:30:00',1.32),('15087','2013-07-10','07:35:00',1.48),('15087','2013-07-10','07:40:00',1.63),('15087','2013-07-10','07:45:00',1.72),('15087','2013-07-10','07:50:00',1.93),('15087','2013-07-10','07:55:00',2.11),('15087','2013-07-10','08:00:00',1.72),('15087','2013-07-10','08:05:00',1.45),('15087','2013-07-10','08:10:00',1.86),('15087','2013-07-10','08:15:00',1.97),('15087','2013-07-10','08:20:00',2.18),('15087','2013-07-10','08:25:00',2.04),('15087','2013-07-10','08:30:00',1.83),('15087','2013-07-10','08:35:00',2.06),('15087','2013-07-10','08:40:00',2.64),('15087','2013-07-10','08:45:00',2.61),('15087','2013-07-10','08:50:00',2.62),('15087','2013-07-10','08:55:00',2.6),('15087','2013-07-10','09:00:00',2.62),('15087','2013-07-10','09:05:00',2.77),('15087','2013-07-10','09:10:00',2.86),('15087','2013-07-10','09:15:00',2.97),('15087','2013-07-10','09:20:00',2.37),('15087','2013-07-10','09:25:00',1.71),('15087','2013-07-10','09:30:00',2.78),('15087','2013-07-10','09:35:00',3.1),('15087','2013-07-10','09:40:00',3.11),('15087','2013-07-10','09:45:00',3.19),('15087','2013-07-10','09:50:00',3.24),('15087','2013-07-10','09:55:00',2.44),('15087','2013-07-10','10:00:00',3.35),('15087','2013-07-10','10:05:00',3.42),('15087','2013-07-10','10:10:00',3.48),('15087','2013-07-10','10:15:00',3.54),('15087','2013-07-10','10:20:00',3.63),('15087','2013-07-10','10:25:00',3.67),('15087','2013-07-10','10:30:00',3.75),('15087','2013-07-10','10:35:00',3.79),('15087','2013-07-10','10:40:00',3.83),('15087','2013-07-10','10:45:00',3.89),('15087','2013-07-10','10:50:00',3.93),('15087','2013-07-10','10:55:00',3.93),('15087','2013-07-10','11:00:00',3.95),('15087','2013-07-10','11:05:00',3.98),('15087','2013-07-10','11:10:00',4.02),('15087','2013-07-10','11:15:00',4.07),('15087','2013-07-10','11:20:00',4.11),('15087','2013-07-10','11:25:00',4.14),('15087','2013-07-10','11:30:00',4.12),('15087','2013-07-10','11:35:00',4.17),('15087','2013-07-10','11:40:00',4.23),('15087','2013-07-10','11:45:00',4.29),('15087','2013-07-10','11:50:00',4.3),('15087','2013-07-10','11:55:00',4.35),('15087','2013-07-10','12:00:00',4.4),('15087','2013-07-10','12:05:00',4.4),('15087','2013-07-10','12:10:00',4.46),('15087','2013-07-10','12:15:00',4.44),('15087','2013-07-10','12:20:00',4.47),('15087','2013-07-10','12:25:00',4.56),('15087','2013-07-10','12:30:00',4.51),('15087','2013-07-10','12:35:00',4.58),('15087','2013-07-10','12:40:00',4.58),('15087','2013-07-10','12:45:00',4.57),('15087','2013-07-10','12:50:00',4.57),('15087','2013-07-10','12:55:00',4.6),('15087','2013-07-10','13:00:00',4.61),('15087','2013-07-10','13:05:00',4.63),('15087','2013-07-10','13:10:00',4.66),('15087','2013-07-10','13:15:00',4.6),('15087','2013-07-10','13:20:00',4.58),('15087','2013-07-10','13:25:00',4.62),('15087','2013-07-10','13:30:00',4.59),('15087','2013-07-10','13:35:00',4.6),('15087','2013-07-10','13:40:00',4.62),('15087','2013-07-10','13:45:00',4.62),('15087','2013-07-10','13:50:00',4.61),('15087','2013-07-10','13:55:00',4.62),('15087','2013-07-10','14:00:00',4.63),('15087','2013-07-10','14:05:00',4.62),('15087','2013-07-10','14:10:00',4.62),('15087','2013-07-10','14:15:00',4.61),('15087','2013-07-10','14:20:00',4.59),('15087','2013-07-10','14:25:00',4.55),('15087','2013-07-10','14:30:00',4.52),('15087','2013-07-10','14:35:00',4.49),('15087','2013-07-10','14:40:00',4.44),('15087','2013-07-10','14:45:00',4.34),('15087','2013-07-10','14:50:00',4.32),('15087','2013-07-10','14:55:00',4.32),('15087','2013-07-10','15:00:00',4.26),('15087','2013-07-10','15:05:00',4.2),('15087','2013-07-10','15:10:00',4),('15087','2013-07-10','15:15:00',4.01),('15087','2013-07-10','15:20:00',4.05),('15087','2013-07-10','15:25:00',4.02),('15087','2013-07-10','15:30:00',3.92),('15087','2013-07-10','15:35:00',3.73),('15087','2013-07-10','15:45:00',1.59),('15087','2013-07-10','15:50:00',3.55),('15087','2013-07-10','15:55:00',3.58),('15087','2013-07-10','16:00:00',3.51),('15087','2013-07-10','16:05:00',2.37),('15087','2013-07-10','16:10:00',3.34),('15087','2013-07-10','16:15:00',3.38),('15087','2013-07-10','16:20:00',3.39),('15087','2013-07-10','16:25:00',2.54),('15087','2013-07-10','16:30:00',3.04),('15087','2013-07-10','16:35:00',3.11),('15087','2013-07-10','16:40:00',3.07),('15087','2013-07-10','16:45:00',2.83),('15087','2013-07-10','16:50:00',2.39),('15087','2013-07-10','16:55:00',2.9),('15087','2013-07-10','17:00:00',2.96),('15087','2013-07-10','17:05:00',2.46),('15087','2013-07-10','17:10:00',1.9),('15087','2013-07-10','17:15:00',1.57),('15087','2013-07-10','17:20:00',1.81),('15087','2013-07-10','17:35:00',1.92),('15087','2013-07-10','17:40:00',1.78),('15087','2013-07-10','17:45:00',1.98),('15087','2013-07-10','17:50:00',1.92),('15087','2013-07-10','17:55:00',1.72),('15087','2013-07-10','18:00:00',1.77),('15087','2013-07-10','18:05:00',1.4),('15087','2013-07-10','18:10:00',1.09),('15087','2013-07-09','07:40:00',1.12),('15087','2013-07-09','07:45:00',1.19),('15087','2013-07-09','07:50:00',1.27),('15087','2013-07-09','07:55:00',1.36),('15087','2013-07-09','08:00:00',1.41),('15087','2013-07-09','08:05:00',1.51),('15087','2013-07-09','08:10:00',1.58),('15087','2013-07-09','08:15:00',1.67),('15087','2013-07-09','08:20:00',1.74),('15087','2013-07-09','08:25:00',1.82),('15087','2013-07-09','08:30:00',1.94),('15087','2013-07-09','08:35:00',2.04),('15087','2013-07-09','08:40:00',2.15),('15087','2013-07-09','08:45:00',2.23),('15087','2013-07-09','08:50:00',2.35),('15087','2013-07-09','08:55:00',2.42),('15087','2013-07-09','09:00:00',2.49),('15087','2013-07-09','09:05:00',2.58),('15087','2013-07-09','09:10:00',2.67),('15087','2013-07-09','09:15:00',2.76),('15087','2013-07-09','09:20:00',2.82),('15087','2013-07-09','09:25:00',2.89),('15087','2013-07-09','09:30:00',2.96),('15087','2013-07-09','09:35:00',3.02),('15087','2013-07-09','09:40:00',3.08),('15087','2013-07-09','09:45:00',3.16),('15087','2013-07-09','09:50:00',3.23),('15087','2013-07-09','09:55:00',3.3),('15087','2013-07-09','10:00:00',3.08),('15087','2013-07-09','10:05:00',3.26),('15087','2013-07-09','10:10:00',3.46),('15087','2013-07-09','10:15:00',3.5),('15087','2013-07-09','10:20:00',3.58),('15087','2013-07-09','10:25:00',3.62),('15087','2013-07-09','10:30:00',3.68),('15087','2013-07-09','10:35:00',3.73),('15087','2013-07-09','10:40:00',3.79),('15087','2013-07-09','10:45:00',3.84),('15087','2013-07-09','10:50:00',3.91),('15087','2013-07-09','10:55:00',3.95),('15087','2013-07-09','11:00:00',4.01),('15087','2013-07-09','11:05:00',4.03),('15087','2013-07-09','11:10:00',4.04),('15087','2013-07-09','11:15:00',3.93),('15087','2013-07-09','11:20:00',3.99),('15087','2013-07-09','11:25:00',3.73),('15087','2013-07-09','11:30:00',2.46),('15087','2013-07-09','11:35:00',3.09),('15087','2013-07-09','11:40:00',3.64),('15087','2013-07-09','11:45:00',4.2),('15087','2013-07-09','11:50:00',4.86),('15087','2013-07-09','11:55:00',4.71),('15087','2013-07-09','12:00:00',4.7),('15087','2013-07-09','12:05:00',4.65),('15087','2013-07-09','12:10:00',4.58),('15087','2013-07-09','12:15:00',4.54),('15087','2013-07-09','12:20:00',4.49),('15087','2013-07-09','12:25:00',4.47),('15087','2013-07-09','12:30:00',4.47),('15087','2013-07-09','12:35:00',4.47),('15087','2013-07-09','12:40:00',4.51),('15087','2013-07-09','12:45:00',4.52),('15087','2013-07-09','12:50:00',4.48),('15087','2013-07-09','12:55:00',4.48),('15087','2013-07-09','13:00:00',4.53),('15087','2013-07-09','13:05:00',4.67),('15087','2013-07-09','13:10:00',4.7),('15087','2013-07-09','13:15:00',4.63),('15087','2013-07-09','13:20:00',4.56),('15087','2013-07-09','13:25:00',4.68),('15087','2013-07-09','13:30:00',4.76),('15087','2013-07-09','13:35:00',4.6),('15087','2013-07-09','13:40:00',4.6),('15087','2013-07-09','13:45:00',4.07),('15087','2013-07-09','13:50:00',3.43),('15087','2013-07-09','13:55:00',3.66),('15087','2013-07-09','14:00:00',3.69),('15087','2013-07-09','14:05:00',3.48),('15087','2013-07-09','14:10:00',3.83),('15087','2013-07-09','14:15:00',3.96),('15087','2013-07-09','14:20:00',2.87),('15087','2013-07-09','14:25:00',2.92),('15087','2013-07-09','14:30:00',1.83),('15087','2013-07-09','14:35:00',1.08),('15087','2013-07-08','07:40:00',1.39),('15087','2013-07-08','07:45:00',1.37),('15087','2013-07-08','07:50:00',1.07),('15087','2013-07-08','07:55:00',1.09),('15087','2013-07-08','08:00:00',1.25),('15087','2013-07-08','08:05:00',1.28),('15087','2013-07-08','08:10:00',1.47),('15087','2013-07-08','08:15:00',1.65),('15087','2013-07-08','08:20:00',1.76),('15087','2013-07-08','08:25:00',1.85),('15087','2013-07-08','08:30:00',1.99),('15087','2013-07-08','08:35:00',2.09),('15087','2013-07-08','08:40:00',2.15),('15087','2013-07-08','08:45:00',2.25),('15087','2013-07-08','08:50:00',2.35),('15087','2013-07-08','08:55:00',2.44),('15087','2013-07-08','09:00:00',2.51),('15087','2013-07-08','09:05:00',2.59),('15087','2013-07-08','09:10:00',2.65),('15087','2013-07-08','09:15:00',2.71),('15087','2013-07-08','09:20:00',2.78),('15087','2013-07-08','09:25:00',2.76),('15087','2013-07-08','09:30:00',2.85),('15087','2013-07-08','09:35:00',3.08),('15087','2013-07-08','09:40:00',3.14),('15087','2013-07-08','09:45:00',3.22),('15087','2013-07-08','09:50:00',3.24),('15087','2013-07-08','09:55:00',3.31),('15087','2013-07-08','10:00:00',3.41),('15087','2013-07-08','10:05:00',3.46),('15087','2013-07-08','10:10:00',3.5),('15087','2013-07-08','10:15:00',3.57),('15087','2013-07-08','10:20:00',3.63),('15087','2013-07-08','10:25:00',3.69),('15087','2013-07-08','10:30:00',3.73),('15087','2013-07-08','10:35:00',3.78),('15087','2013-07-08','10:40:00',3.79),('15087','2013-07-08','10:45:00',3.84),('15087','2013-07-08','10:50:00',3.88),('15087','2013-07-08','10:55:00',3.88),('15087','2013-07-08','11:00:00',3.9),('15087','2013-07-08','11:05:00',3.97),('15087','2013-07-08','11:10:00',4.04),('15087','2013-07-08','11:15:00',4.11),('15087','2013-07-08','11:20:00',4.19),('15087','2013-07-08','11:25:00',4.27),('15087','2013-07-08','11:30:00',4.3),('15087','2013-07-08','11:35:00',4.34),('15087','2013-07-08','11:40:00',4.16),('15087','2013-07-08','11:45:00',4.28),('15087','2013-07-08','11:50:00',4.42),('15087','2013-07-08','11:55:00',4.41),('15087','2013-07-08','12:00:00',4.42),('15087','2013-07-08','12:05:00',4.53),('15087','2013-07-08','12:10:00',4.59),('15087','2013-07-08','12:15:00',4.7),('15087','2013-07-08','12:20:00',4.8),('15087','2013-07-08','12:25:00',4.75),('15087','2013-07-08','12:30:00',4.08),('15087','2013-07-08','12:35:00',4.62),('15087','2013-07-08','12:40:00',4.59),('15087','2013-07-08','12:45:00',4.6),('15087','2013-07-08','12:50:00',4.57),('15087','2013-07-08','12:55:00',4.65),('15087','2013-07-08','13:00:00',4.84),('15087','2013-07-08','13:05:00',4.97),('15087','2013-07-08','13:10:00',4.64),('15087','2013-07-08','13:15:00',5.22),('15087','2013-07-08','13:20:00',3.23),('15087','2013-07-08','13:25:00',1.38),('15087','2013-07-08','14:30:00',1),('15087','2013-07-08','14:35:00',1.19),('15087','2013-07-08','14:40:00',1.25),('15087','2013-07-08','14:45:00',1.19),('15087','2013-07-08','14:50:00',1.16),('15087','2013-07-08','14:55:00',1.15),('15087','2013-07-08','15:00:00',1.06),('15087','2013-07-08','17:35:00',1.05),('15087','2013-07-08','17:45:00',1.07),('15087','2013-07-08','17:50:00',1.07),('15087','2013-07-08','17:55:00',1.03),('15087','2013-07-08','18:40:00',1.21),('15087','2013-07-08','18:45:00',1.16),('15087','2013-07-08','18:50:00',1.03),('15087','2013-07-07','07:35:00',1.07),('15087','2013-07-07','07:40:00',1.16),('15087','2013-07-07','07:45:00',1.24),('15087','2013-07-07','07:50:00',1.33),('15087','2013-07-07','07:55:00',1.41),('15087','2013-07-07','08:00:00',1.51),('15087','2013-07-07','08:05:00',1.61),('15087','2013-07-07','08:10:00',1.71),('15087','2013-07-07','08:15:00',1.79),('15087','2013-07-07','08:20:00',1.4),('15087','2013-07-07','08:25:00',1.52),('15087','2013-07-07','08:30:00',1.84),('15087','2013-07-07','08:35:00',2.31),('15087','2013-07-07','08:40:00',1.68),('15087','2013-07-07','08:50:00',1.82),('15087','2013-07-07','08:55:00',2.64),('15087','2013-07-07','09:00:00',2.71),('15087','2013-07-07','09:05:00',2.43),('15087','2013-07-07','09:10:00',2.58),('15087','2013-07-07','09:15:00',2.67),('15087','2013-07-07','09:20:00',1.75),('15087','2013-07-07','09:25:00',2.17),('15087','2013-07-07','09:30:00',3.08),('15087','2013-07-07','09:35:00',3.15),('15087','2013-07-07','09:40:00',3.07),('15087','2013-07-07','09:45:00',3.28),('15087','2013-07-07','09:50:00',3.42),('15087','2013-07-07','09:55:00',3.57),('15087','2013-07-07','10:00:00',3.65),('15087','2013-07-07','10:05:00',3.41),('15087','2013-07-07','10:10:00',3.45),('15087','2013-07-07','10:15:00',3.45),('15087','2013-07-07','10:20:00',3.4),('15087','2013-07-07','10:25:00',3.72),('15087','2013-07-07','10:30:00',3.24),('15087','2013-07-07','10:35:00',4),('15087','2013-07-07','10:40:00',3.8),('15087','2013-07-07','10:45:00',3.93),('15087','2013-07-07','10:50:00',4.13),('15087','2013-07-07','10:55:00',4.09),('15087','2013-07-07','11:00:00',4.13),('15087','2013-07-07','11:05:00',4.16),('15087','2013-07-07','11:10:00',4.24),('15087','2013-07-07','11:15:00',4.26),('15087','2013-07-07','11:20:00',3.95),('15087','2013-07-07','11:25:00',3.7),('15087','2013-07-07','11:30:00',3.75),('15087','2013-07-07','11:35:00',3.64),('15087','2013-07-07','11:40:00',3.87),('15087','2013-07-07','11:45:00',3.17),('15087','2013-07-07','11:50:00',3.35),('15087','2013-07-07','11:55:00',2.46),('15087','2013-07-07','12:00:00',2.41),('15087','2013-07-07','12:05:00',4.31),('15087','2013-07-07','12:10:00',4.39),('15087','2013-07-07','12:15:00',4.47),('15087','2013-07-07','12:20:00',4.58),('15087','2013-07-07','12:25:00',4.39),('15087','2013-07-07','12:30:00',4.31),('15087','2013-07-07','12:35:00',4.5),('15087','2013-07-07','12:40:00',4.7),('15087','2013-07-07','12:45:00',4.75),('15087','2013-07-07','12:50:00',4.55),('15087','2013-07-07','12:55:00',4.83),('15087','2013-07-07','13:00:00',4.69),('15087','2013-07-07','13:05:00',4.72),('15087','2013-07-07','13:10:00',4.71),('15087','2013-07-07','13:15:00',4.74),('15087','2013-07-07','13:20:00',4.67),('15087','2013-07-07','13:25:00',4.21),('15087','2013-07-07','13:30:00',3.82),('15087','2013-07-07','13:35:00',4.79),('15087','2013-07-07','13:40:00',4.89),('15087','2013-07-07','13:45:00',3.58),('15087','2013-07-07','13:50:00',5.2),('15087','2013-07-07','13:55:00',4.35),('15087','2013-07-07','14:00:00',3.06),('15087','2013-07-07','14:05:00',3.64),('15087','2013-07-07','14:10:00',2.77),('15087','2013-07-07','14:15:00',1.56),('15087','2013-07-07','14:20:00',1.29),('15087','2013-07-07','14:25:00',1.12),('15087','2013-07-07','14:30:00',1.06),('15087','2013-07-07','15:00:00',1.01),('15087','2013-07-07','15:05:00',1.16),('15087','2013-07-07','17:05:00',1.03),('15087','2013-07-07','17:10:00',1.07),('15087','2013-07-07','17:15:00',1.11),('15087','2013-07-07','17:20:00',1.12),('15087','2013-07-07','17:25:00',1.1),('15087','2013-07-07','17:30:00',1.06),('15087','2013-07-06','07:35:00',1.02),('15087','2013-07-06','07:40:00',1.1),('15087','2013-07-06','07:45:00',1.18),('15087','2013-07-06','07:50:00',1.27),('15087','2013-07-06','07:55:00',1.37),('15087','2013-07-06','08:00:00',1.46),('15087','2013-07-06','08:05:00',1.54),('15087','2013-07-06','08:10:00',1.63),('15087','2013-07-06','08:15:00',1.71),('15087','2013-07-06','08:20:00',1.78),('15087','2013-07-06','08:25:00',1.88),('15087','2013-07-06','08:30:00',1.99),('15087','2013-07-06','08:35:00',2.07),('15087','2013-07-06','08:40:00',2.22),('15087','2013-07-06','08:45:00',2.33),('15087','2013-07-06','08:50:00',2.41),('15087','2013-07-06','08:55:00',2.47),('15087','2013-07-06','09:00:00',2.58),('15087','2013-07-06','09:05:00',2.66),('15087','2013-07-06','09:10:00',2.75),('15087','2013-07-06','09:15:00',2.81),('15087','2013-07-06','09:20:00',2.9),('15087','2013-07-06','09:25:00',2.96),('15087','2013-07-06','09:30:00',3.01),('15087','2013-07-06','09:35:00',3.08),('15087','2013-07-06','09:40:00',3.14),('15087','2013-07-06','09:45:00',3.21),('15087','2013-07-06','09:50:00',3.28),('15087','2013-07-06','09:55:00',3.37),('15087','2013-07-06','10:00:00',3.44),('15087','2013-07-06','10:05:00',3.53),('15087','2013-07-06','10:10:00',3.61),('15087','2013-07-06','10:15:00',3.65),('15087','2013-07-06','10:20:00',3.69),('15087','2013-07-06','10:25:00',3.73),('15087','2013-07-06','10:30:00',3.77),('15087','2013-07-06','10:35:00',3.81),('15087','2013-07-06','10:40:00',3.83),('15087','2013-07-06','10:45:00',3.91),('15087','2013-07-06','10:50:00',3.95),('15087','2013-07-06','10:55:00',4.02),('15087','2013-07-06','11:00:00',4.08),('15087','2013-07-06','11:05:00',4.12),('15087','2013-07-06','11:10:00',4.15),('15087','2013-07-06','11:15:00',4.2),('15087','2013-07-06','11:20:00',4.17),('15087','2013-07-06','11:25:00',4.22),('15087','2013-07-06','11:30:00',4.26),('15087','2013-07-06','11:35:00',4.3),('15087','2013-07-06','11:40:00',4.32),('15087','2013-07-06','11:45:00',4.37),('15087','2013-07-06','11:50:00',4.42),('15087','2013-07-06','11:55:00',4.39),('15087','2013-07-06','12:00:00',4.42),('15087','2013-07-06','12:05:00',4.48),('15087','2013-07-06','12:10:00',4.57),('15087','2013-07-06','12:15:00',4.59),('15087','2013-07-06','12:20:00',4.61),('15087','2013-07-06','12:25:00',4.64),('15087','2013-07-06','12:30:00',4.65),('15087','2013-07-06','12:35:00',4.66),('15087','2013-07-06','12:40:00',4.63),('15087','2013-07-06','12:45:00',4.63),('15087','2013-07-06','12:50:00',4.65),('15087','2013-07-06','12:55:00',4.64),('15087','2013-07-06','13:00:00',4.7),('15087','2013-07-06','13:05:00',4.68),('15087','2013-07-06','13:10:00',4.68),('15087','2013-07-06','13:15:00',4.68),('15087','2013-07-06','13:20:00',4.69),('15087','2013-07-06','13:25:00',4.64),('15087','2013-07-06','13:30:00',4.71),('15087','2013-07-06','13:35:00',4.64),('15087','2013-07-06','13:40:00',4.72),('15087','2013-07-06','13:45:00',4.69),('15087','2013-07-06','13:50:00',4.61),('15087','2013-07-06','13:55:00',4.57),('15087','2013-07-06','14:00:00',4.62),('15087','2013-07-06','14:05:00',4.64),('15087','2013-07-06','14:10:00',4.59),('15087','2013-07-06','14:15:00',4.6),('15087','2013-07-06','14:20:00',4.57),('15087','2013-07-06','14:25:00',4.59),('15087','2013-07-06','14:30:00',4.51),('15087','2013-07-06','14:35:00',4.51),('15087','2013-07-06','14:40:00',4.49),('15087','2013-07-06','14:45:00',4.35),('15087','2013-07-06','14:50:00',4.16),('15087','2013-07-06','14:55:00',3.42),('15087','2013-07-06','15:00:00',4.03),('15087','2013-07-06','15:05:00',4.42),('15087','2013-07-06','15:10:00',4.25),('15087','2013-07-06','15:15:00',4.13),('15087','2013-07-06','15:20:00',4.06),('15087','2013-07-06','15:25:00',4.06),('15087','2013-07-06','15:30:00',3.29),('15087','2013-07-06','15:35:00',2.51),('15087','2013-07-06','15:40:00',1.02),('15087','2013-07-06','16:50:00',1.65),('15087','2013-07-06','16:55:00',2.03),('15087','2013-07-06','17:00:00',1.14),('15087','2013-07-06','17:05:00',1.07),('15087','2013-07-06','17:10:00',1.28),('15087','2013-07-06','17:15:00',2.32),('15087','2013-07-06','17:20:00',1.28),('15087','2013-07-06','17:25:00',1.05),('15087','2013-07-06','17:30:00',1.22),('15087','2013-07-06','17:35:00',1.16),('15087','2013-07-05','07:30:00',1),('15087','2013-07-05','07:35:00',1.1),('15087','2013-07-05','07:40:00',1.18),('15087','2013-07-05','07:45:00',1.25),('15087','2013-07-05','07:50:00',1.33),('15087','2013-07-05','07:55:00',1.41),('15087','2013-07-05','08:00:00',1.51),('15087','2013-07-05','08:05:00',1.59),('15087','2013-07-05','08:10:00',1.67),('15087','2013-07-05','08:15:00',1.76),('15087','2013-07-05','08:20:00',1.82),('15087','2013-07-05','08:25:00',1.89),('15087','2013-07-05','08:30:00',1.99),('15087','2013-07-05','08:35:00',2.07),('15087','2013-07-05','08:40:00',2.22),('15087','2013-07-05','08:45:00',2.3),('15087','2013-07-05','08:50:00',2.4),('15087','2013-07-05','08:55:00',2.44),('15087','2013-07-05','09:00:00',2.57),('15087','2013-07-05','09:05:00',2.65),('15087','2013-07-05','09:10:00',2.73),('15087','2013-07-05','09:15:00',2.8),('15087','2013-07-05','09:20:00',2.88),('15087','2013-07-05','09:25:00',2.96),('15087','2013-07-05','09:30:00',3.03),('15087','2013-07-05','09:35:00',3.08),('15087','2013-07-05','09:40:00',3.16),('15087','2013-07-05','09:45:00',3.23),('15087','2013-07-05','09:50:00',3.28),('15087','2013-07-05','09:55:00',3.34),('15087','2013-07-05','10:00:00',3.41),('15087','2013-07-05','10:05:00',3.47),('15087','2013-07-05','10:10:00',3.54),('15087','2013-07-05','10:15:00',3.59),('15087','2013-07-05','10:20:00',3.64),('15087','2013-07-05','10:25:00',3.69),('15087','2013-07-05','10:30:00',3.75),('15087','2013-07-05','10:35:00',3.8),('15087','2013-07-05','10:40:00',3.84),('15087','2013-07-05','10:45:00',3.88),('15087','2013-07-05','10:50:00',3.92),('15087','2013-07-05','10:55:00',3.95),('15087','2013-07-05','11:00:00',3.97),('15087','2013-07-05','11:05:00',4),('15087','2013-07-05','11:10:00',4.04),('15087','2013-07-05','11:15:00',4.08),('15087','2013-07-05','11:20:00',4.13),('15087','2013-07-05','11:25:00',4.16),('15087','2013-07-05','11:30:00',4.21),('15087','2013-07-05','11:35:00',4.27),('15087','2013-07-05','11:40:00',4.3),('15087','2013-07-05','11:45:00',4.31),('15087','2013-07-05','11:50:00',4.32),('15087','2013-07-05','11:55:00',4.41),('15087','2013-07-05','12:00:00',4.39),('15087','2013-07-05','12:05:00',4.41),('15087','2013-07-05','12:10:00',4.43),('15087','2013-07-05','12:15:00',4.45),('15087','2013-07-05','12:20:00',4.56),('15087','2013-07-05','12:25:00',3.56),('15087','2013-07-05','12:30:00',4.3),('15087','2013-07-05','12:35:00',3.4),('15087','2013-07-05','12:40:00',3.77),('15087','2013-07-05','12:45:00',4.59),('15087','2013-07-05','12:50:00',4.64),('15087','2013-07-05','12:55:00',4.69),('15087','2013-07-05','13:00:00',3.93),('15087','2013-07-05','13:05:00',2.85),('15087','2013-07-05','13:10:00',4.84),('15087','2013-07-05','13:15:00',4.78),('15087','2013-07-05','13:20:00',2.92),('15087','2013-07-05','13:25:00',4.77),('15087','2013-07-05','13:30:00',4.72),('15087','2013-07-05','13:35:00',4.44),('15087','2013-07-05','13:40:00',4.72),('15087','2013-07-05','13:45:00',4.67),('15087','2013-07-05','13:50:00',4.62),('15087','2013-07-05','13:55:00',4.65),('15087','2013-07-05','14:00:00',4.69),('15087','2013-07-05','14:05:00',4.44),('15087','2013-07-05','14:10:00',3.35),('15087','2013-07-05','14:15:00',4.57),('15087','2013-07-05','14:20:00',4.48),('15087','2013-07-05','14:25:00',4.46),('15087','2013-07-05','14:30:00',4.42),('15087','2013-07-05','14:35:00',4.3),('15087','2013-07-05','14:40:00',4.41),('15087','2013-07-05','14:45:00',2.82),('15087','2013-07-05','14:50:00',3.61),('15087','2013-07-05','14:55:00',4.23),('15087','2013-07-05','15:00:00',4.29),('15087','2013-07-05','15:05:00',2.74),('15087','2013-07-05','15:10:00',4.28),('15087','2013-07-05','15:15:00',4.16),('15087','2013-07-05','15:20:00',3.01),('15087','2013-07-05','15:25:00',4.02),('15087','2013-07-05','15:30:00',3.83),('15087','2013-07-05','15:35:00',3.88),('15087','2013-07-05','15:40:00',3.61),('15087','2013-07-05','15:45:00',3.81),('15087','2013-07-05','15:50:00',3.78),('15087','2013-07-05','15:55:00',3.67),('15087','2013-07-05','16:00:00',3.55),('15087','2013-07-05','16:05:00',3.55),('15087','2013-07-05','16:10:00',3.28),('15087','2013-07-05','16:15:00',3.44),('15087','2013-07-05','16:20:00',3.4),('15087','2013-07-05','16:25:00',3.36),('15087','2013-07-05','16:30:00',3.32),('15087','2013-07-05','16:35:00',3.19),('15087','2013-07-05','16:40:00',3.11),('15087','2013-07-05','16:45:00',3.04),('15087','2013-07-05','16:50:00',2.98),('15087','2013-07-05','16:55:00',2.91),('15087','2013-07-05','17:00:00',2.85),('15087','2013-07-05','17:05:00',2.78),('15087','2013-07-05','17:10:00',2.7),('15087','2013-07-05','17:15:00',2.7),('15087','2013-07-05','17:20:00',2.65),('15087','2013-07-05','17:25:00',2.51),('15087','2013-07-05','17:30:00',2.46),('15087','2013-07-05','17:35:00',2.3),('15087','2013-07-05','17:40:00',2.12),('15087','2013-07-05','17:45:00',1.96),('15087','2013-07-05','17:50:00',1.81),('15087','2013-07-05','17:55:00',1.74),('15087','2013-07-05','18:00:00',1.71),('15087','2013-07-05','18:05:00',1.55),('15087','2013-07-05','18:10:00',1.38),('15087','2013-07-05','18:15:00',1.08),('15087','2013-07-05','18:20:00',1.08),('15087','2013-07-04','11:10:00',1.09),('15087','2013-07-04','11:15:00',1.13),('15087','2013-07-04','11:20:00',1.09),('15087','2013-07-04','11:25:00',1.17),('15087','2013-07-04','11:30:00',1.28),('15087','2013-07-04','11:35:00',1.49),('15087','2013-07-04','11:40:00',1.72),('15087','2013-07-04','11:45:00',1.84),('15087','2013-07-04','11:50:00',1.87),('15087','2013-07-04','11:55:00',1.67),('15087','2013-07-04','12:00:00',1.53),('15087','2013-07-04','12:05:00',2.14),('15087','2013-07-04','12:10:00',2.76),('15087','2013-07-04','12:15:00',2.77),('15087','2013-07-04','12:20:00',2.68),('15087','2013-07-04','12:25:00',3.6),('15087','2013-07-04','12:30:00',2.97),('15087','2013-07-04','12:35:00',2.48),('15087','2013-07-04','12:40:00',1.76),('15087','2013-07-04','12:45:00',1.36),('15087','2013-07-04','12:50:00',1.07),('15087','2013-07-04','13:00:00',1.1),('15087','2013-07-04','13:05:00',1.35),('15087','2013-07-04','13:10:00',1.85),('15087','2013-07-04','13:15:00',2.25),('15087','2013-07-04','13:20:00',2.24),('15087','2013-07-04','13:25:00',3.19),('15087','2013-07-04','13:30:00',2.55),('15087','2013-07-04','13:35:00',2.68),('15087','2013-07-04','13:40:00',3.08),('15087','2013-07-04','13:45:00',5.33),('15087','2013-07-04','13:50:00',5.61),('15087','2013-07-04','13:55:00',4.18),('15087','2013-07-04','14:00:00',3.73),('15087','2013-07-04','14:05:00',2.56),('15087','2013-07-04','14:10:00',2.42),('15087','2013-07-04','14:15:00',2.47),('15087','2013-07-04','14:20:00',2.5),('15087','2013-07-04','14:25:00',2.2),('15087','2013-07-04','14:30:00',2.16),('15087','2013-07-04','14:35:00',2.28),('15087','2013-07-04','14:40:00',2.76),('15087','2013-07-04','14:45:00',3.66),('15087','2013-07-04','14:50:00',2.77),('15087','2013-07-04','14:55:00',2.35),('15087','2013-07-04','15:00:00',1.99),('15087','2013-07-04','15:05:00',2.33),('15087','2013-07-04','15:10:00',3.75),('15087','2013-07-04','15:15:00',3.27),('15087','2013-07-04','15:20:00',3.02),('15087','2013-07-04','15:25:00',2.94),('15087','2013-07-04','15:30:00',2.76),('15087','2013-07-04','15:35:00',2.66),('15087','2013-07-04','15:40:00',2.81),('15087','2013-07-04','15:45:00',3.75),('15087','2013-07-04','15:50:00',2.28),('15087','2013-07-04','15:55:00',2.48),('15087','2013-07-04','16:00:00',2.64),('15087','2013-07-04','16:05:00',2.59),('15087','2013-07-04','16:10:00',1.98),('15087','2013-07-04','16:15:00',1.89),('15087','2013-07-04','16:20:00',1.98),('15087','2013-07-04','16:25:00',2.32),('15087','2013-07-04','16:30:00',2.4),('15087','2013-07-04','16:35:00',2.43),('15087','2013-07-04','16:40:00',1.9),('15087','2013-07-04','16:45:00',1.66),('15087','2013-07-04','16:50:00',1.59),('15087','2013-07-04','16:55:00',1.52),('15087','2013-07-04','17:00:00',1.33),('15087','2013-07-04','17:05:00',1.31),('15087','2013-07-04','17:10:00',2.05),('15087','2013-07-04','17:15:00',2.66),('15087','2013-07-04','17:20:00',2.41),('15087','2013-07-04','17:25:00',2.97),('15087','2013-07-04','17:30:00',2.65),('15087','2013-07-04','17:35:00',1.93),('15087','2013-07-04','17:40:00',2.4),('15087','2013-07-04','17:45:00',2.38),('15087','2013-07-04','17:50:00',2.21),('15087','2013-07-04','17:55:00',1.9),('15087','2013-07-04','18:00:00',1.99),('15087','2013-07-04','18:05:00',1.83),('15087','2013-07-04','18:10:00',1.76),('15087','2013-07-04','18:15:00',1.74),('15087','2013-07-04','18:20:00',1.59),('15087','2013-07-04','18:25:00',1.3),('15087','2013-07-03','07:30:00',1.02),('15087','2013-07-03','07:35:00',1.1),('15087','2013-07-03','07:40:00',1.19),('15087','2013-07-03','07:45:00',1.28),('15087','2013-07-03','07:50:00',1.37),('15087','2013-07-03','07:55:00',1.45),('15087','2013-07-03','08:00:00',1.55),('15087','2013-07-03','08:05:00',1.65),('15087','2013-07-03','08:10:00',1.74),('15087','2013-07-03','08:15:00',1.83),('15087','2013-07-03','08:20:00',1.91),('15087','2013-07-03','08:25:00',2.03),('15087','2013-07-03','08:30:00',2.15),('15087','2013-07-03','08:35:00',2.23),('15087','2013-07-03','08:40:00',2.36),('15087','2013-07-03','08:45:00',2.46),('15087','2013-07-03','08:50:00',2.55),('15087','2013-07-03','08:55:00',2.62),('15087','2013-07-03','09:00:00',2.67),('15087','2013-07-03','09:05:00',2.74),('15087','2013-07-03','09:10:00',2.82),('15087','2013-07-03','09:15:00',2.92),('15087','2013-07-03','09:20:00',2.95),('15087','2013-07-03','09:25:00',3.02),('15087','2013-07-03','09:30:00',3.12),('15087','2013-07-03','09:35:00',3.12),('15087','2013-07-03','09:40:00',3.22),('15087','2013-07-03','09:45:00',3.25),('15087','2013-07-03','09:50:00',3.3),('15087','2013-07-03','09:55:00',3.37),('15087','2013-07-03','10:00:00',3.46),('15087','2013-07-03','10:05:00',3.52),('15087','2013-07-03','10:10:00',3.6),('15087','2013-07-03','10:15:00',3.61),('15087','2013-07-03','10:20:00',3.65),('15087','2013-07-03','10:25:00',3.63),('15087','2013-07-03','10:30:00',3.71),('15087','2013-07-03','10:35:00',3.85),('15087','2013-07-03','10:40:00',3.88),('15087','2013-07-03','10:45:00',3.94),('15087','2013-07-03','10:50:00',3.92),('15087','2013-07-03','10:55:00',3.97),('15087','2013-07-03','11:00:00',4.08),('15087','2013-07-03','11:05:00',4.16),('15087','2013-07-03','11:10:00',4.22),('15087','2013-07-03','11:15:00',4.28),('15087','2013-07-03','11:20:00',4.25),('15087','2013-07-03','11:25:00',4.24),('15087','2013-07-03','11:30:00',4.27),('15087','2013-07-03','11:35:00',4.28),('15087','2013-07-03','11:40:00',4.46),('15087','2013-07-03','11:45:00',4.44),('15087','2013-07-03','11:50:00',4.38),('15087','2013-07-03','11:55:00',4.48),('15087','2013-07-03','12:00:00',4.49),('15087','2013-07-03','12:05:00',4.5),('15087','2013-07-03','12:10:00',4.52),('15087','2013-07-03','12:15:00',4.55),('15087','2013-07-03','12:20:00',4.61),('15087','2013-07-03','12:25:00',4.58),('15087','2013-07-03','12:30:00',4.67),('15087','2013-07-03','12:35:00',4.66),('15087','2013-07-03','12:40:00',4.68),('15087','2013-07-03','12:45:00',4.72),('15087','2013-07-03','12:50:00',4.74),('15087','2013-07-03','12:55:00',4.75),('15087','2013-07-03','13:00:00',4.74),('15087','2013-07-03','13:05:00',4.76),('15087','2013-07-03','13:10:00',4.75),('15087','2013-07-03','13:15:00',4.78),('15087','2013-07-03','13:20:00',4.74),('15087','2013-07-03','13:25:00',4.73),('15087','2013-07-03','13:30:00',4.7),('15087','2013-07-03','13:35:00',4.72),('15087','2013-07-03','13:40:00',4.73),('15087','2013-07-03','13:45:00',4.7),('15087','2013-07-03','13:50:00',4.69),('15087','2013-07-03','13:55:00',4.66),('15087','2013-07-03','14:00:00',4.65),('15087','2013-07-03','14:05:00',4.68),('15087','2013-07-03','14:10:00',4.55),('15087','2013-07-03','14:15:00',4.62),('15087','2013-07-03','14:20:00',4.59),('15087','2013-07-03','14:25:00',4.58),('15087','2013-07-03','14:30:00',4.57),('15087','2013-07-03','14:35:00',4.55),('15087','2013-07-03','14:40:00',4.51),('15087','2013-07-03','14:45:00',4.47),('15087','2013-07-03','14:50:00',4.42),('15087','2013-07-03','14:55:00',4.38),('15087','2013-07-03','15:00:00',4.38),('15087','2013-07-03','15:05:00',4.31),('15087','2013-07-03','15:10:00',4.21),('15087','2013-07-03','15:15:00',3.94),('15087','2013-07-03','15:20:00',3.85),('15087','2013-07-03','15:25:00',4.09),('15087','2013-07-03','15:30:00',4.05),('15087','2013-07-03','15:35:00',3.86),('15087','2013-07-03','15:40:00',3.83),('15087','2013-07-03','15:45:00',3.83),('15087','2013-07-03','15:50:00',3.74),('15087','2013-07-03','15:55:00',3.68),('15087','2013-07-03','16:00:00',3.64),('15087','2013-07-03','16:05:00',3.63),('15087','2013-07-03','16:10:00',3.5),('15087','2013-07-03','16:15:00',3.55),('15087','2013-07-03','16:20:00',3.46),('15087','2013-07-03','16:25:00',3.39),('15087','2013-07-03','16:30:00',3.38),('15087','2013-07-03','16:35:00',3.23),('15087','2013-07-03','16:40:00',3.18),('15087','2013-07-03','16:45:00',3.07),('15087','2013-07-03','16:50:00',3.1),('15087','2013-07-03','16:55:00',3.08),('15087','2013-07-03','17:00:00',2.97),('15087','2013-07-03','17:05:00',2.91),('15087','2013-07-03','17:10:00',2.79),('15087','2013-07-03','17:15:00',2.73),('15087','2013-07-03','17:20:00',2.68),('15087','2013-07-03','17:25:00',2.61),('15087','2013-07-03','17:30:00',2.55),('15087','2013-07-03','17:35:00',2.38),('15087','2013-07-03','17:40:00',2.27),('15087','2013-07-03','17:45:00',2.11),('15087','2013-07-03','17:50:00',1.97),('15087','2013-07-03','17:55:00',1.86),('15087','2013-07-03','18:00:00',1.77),('15087','2013-07-03','18:05:00',1.62),('15087','2013-07-03','18:10:00',1.54),('15087','2013-07-03','18:15:00',1.42),('15087','2013-07-03','18:20:00',1.36),('15087','2013-07-03','18:25:00',1.26),('15087','2013-07-03','18:30:00',1.17),('15087','2013-07-03','18:35:00',1.08),('15087','2013-07-03','18:40:00',1.01),('15087','2013-07-02','07:35:00',1.08),('15087','2013-07-02','07:40:00',1.16),('15087','2013-07-02','07:45:00',1.25),('15087','2013-07-02','07:50:00',1.33),('15087','2013-07-02','07:55:00',1.42),('15087','2013-07-02','08:00:00',1.52),('15087','2013-07-02','08:05:00',1.61),('15087','2013-07-02','08:10:00',1.7),('15087','2013-07-02','08:15:00',1.79),('15087','2013-07-02','08:20:00',1.9),('15087','2013-07-02','08:25:00',2.02),('15087','2013-07-02','08:30:00',2.16),('15087','2013-07-02','08:35:00',2.24),('15087','2013-07-02','08:40:00',2.32),('15087','2013-07-02','08:45:00',2.4),('15087','2013-07-02','08:50:00',2.47),('15087','2013-07-02','08:55:00',2.57),('15087','2013-07-02','09:00:00',2.64),('15087','2013-07-02','09:05:00',2.72),('15087','2013-07-02','09:10:00',2.79),('15087','2013-07-02','09:15:00',2.83),('15087','2013-07-02','09:20:00',2.9),('15087','2013-07-02','09:25:00',2.99),('15087','2013-07-02','09:30:00',3.06),('15087','2013-07-02','09:35:00',3.12),('15087','2013-07-02','09:40:00',3.17),('15087','2013-07-02','09:45:00',3.25),('15087','2013-07-02','09:50:00',3.32),('15087','2013-07-02','09:55:00',3.37),('15087','2013-07-02','10:00:00',3.44),('15087','2013-07-02','10:05:00',3.46),('15087','2013-07-02','10:10:00',3.53),('15087','2013-07-02','10:15:00',3.57),('15087','2013-07-02','10:20:00',3.65),('15087','2013-07-02','10:25:00',3.69),('15087','2013-07-02','10:30:00',3.71),('15087','2013-07-02','10:35:00',3.71),('15087','2013-07-02','10:40:00',3.79),('15087','2013-07-02','10:45:00',3.85),('15087','2013-07-02','10:50:00',3.91),('15087','2013-07-02','10:55:00',3.96),('15087','2013-07-02','11:00:00',3.98),('15087','2013-07-02','11:05:00',3.96),('15087','2013-07-02','11:10:00',4),('15087','2013-07-02','11:15:00',4),('15087','2013-07-02','11:20:00',4.08),('15087','2013-07-02','11:25:00',4.13),('15087','2013-07-02','11:30:00',4.1),('15087','2013-07-02','11:35:00',4.14),('15087','2013-07-02','11:40:00',4.17),('15087','2013-07-02','11:45:00',4.19),('15087','2013-07-02','11:50:00',4.24),('15087','2013-07-02','11:55:00',4.23),('15087','2013-07-02','12:00:00',4.31),('15087','2013-07-02','12:05:00',4.36),('15087','2013-07-02','12:10:00',4.38),('15087','2013-07-02','12:15:00',4.37),('15087','2013-07-02','12:20:00',4.35),('15087','2013-07-02','12:25:00',4.37),('15087','2013-07-02','12:30:00',4.49),('15087','2013-07-02','12:35:00',4.63),('15087','2013-07-02','12:40:00',4.69),('15087','2013-07-02','12:45:00',4.73),('15087','2013-07-02','12:50:00',4.88),('15087','2013-07-02','12:55:00',4.29),('15087','2013-07-02','13:00:00',1.82),('15087','2013-07-02','13:05:00',5.07),('15087','2013-07-02','13:10:00',4.56),('15087','2013-07-02','13:15:00',3.4),('15087','2013-07-02','13:20:00',4.7),('15087','2013-07-02','13:25:00',4.58),('15087','2013-07-02','13:30:00',4.71),('15087','2013-07-02','13:35:00',4.7),('15087','2013-07-02','13:40:00',4.52),('15087','2013-07-02','13:45:00',4.51),('15087','2013-07-02','13:50:00',4.5),('15087','2013-07-02','13:55:00',4.52),('15087','2013-07-02','14:00:00',4.49),('15087','2013-07-02','14:05:00',4.49),('15087','2013-07-02','14:10:00',4.5),('15087','2013-07-02','14:15:00',4.54),('15087','2013-07-02','14:20:00',4.52),('15087','2013-07-02','14:25:00',4.48),('15087','2013-07-02','14:30:00',4.44),('15087','2013-07-02','14:35:00',4.43),('15087','2013-07-02','14:40:00',4.41),('15087','2013-07-02','14:45:00',4.31),('15087','2013-07-02','14:50:00',4.08),('15087','2013-07-02','14:55:00',4.18),('15087','2013-07-02','15:00:00',4.23),('15087','2013-07-02','15:05:00',4.19),('15087','2013-07-02','15:10:00',4.06),('15087','2013-07-02','15:15:00',3.83),('15087','2013-07-02','15:20:00',3.74),('15087','2013-07-02','15:25:00',3.98),('15087','2013-07-02','15:30:00',3.96),('15087','2013-07-02','15:35:00',3.8),('15087','2013-07-02','15:40:00',3.77),('15087','2013-07-02','15:45:00',3.76),('15087','2013-07-02','15:50:00',3.67),('15087','2013-07-02','15:55:00',3.64),('15087','2013-07-02','16:00:00',3.6),('15087','2013-07-02','16:05:00',3.57),('15087','2013-07-02','16:10:00',3.46),('15087','2013-07-02','16:15:00',3.47),('15087','2013-07-02','16:20:00',3.38),('15087','2013-07-02','16:25:00',3.33),('15087','2013-07-02','16:30:00',3.28),('15087','2013-07-02','16:35:00',3.16),('15087','2013-07-02','16:40:00',3.1),('15087','2013-07-02','16:45:00',2.92),('15087','2013-07-02','16:50:00',2.92),('15087','2013-07-02','16:55:00',3.02),('15087','2013-07-02','17:00:00',2.93),('15087','2013-07-02','17:05:00',2.83),('15087','2013-07-02','17:10:00',2.72),('15087','2013-07-02','17:15:00',2.66),('15087','2013-07-02','17:20:00',2.59),('15087','2013-07-02','17:25:00',2.5),('15087','2013-07-02','17:30:00',2.46),('15087','2013-07-02','17:35:00',2.23),('15087','2013-07-02','17:40:00',2.14),('15087','2013-07-02','17:45:00',2),('15087','2013-07-02','17:50:00',1.79),('15087','2013-07-02','17:55:00',1.74),('15087','2013-07-02','18:00:00',1.61),('15087','2013-07-02','18:05:00',1.44),('15087','2013-07-02','18:10:00',1.36),('15087','2013-07-02','18:15:00',1.39),('15087','2013-07-02','18:20:00',1.3),('15087','2013-07-02','18:25:00',1.19),('15087','2013-07-02','18:30:00',1.1),('15087','2013-07-02','18:35:00',1.03),('15087','2013-07-01','07:30:00',1.02),('15087','2013-07-01','07:35:00',1.11),('15087','2013-07-01','07:40:00',1.19),('15087','2013-07-01','07:45:00',1.27),('15087','2013-07-01','07:50:00',1.35),('15087','2013-07-01','07:55:00',1.45),('15087','2013-07-01','08:00:00',1.57),('15087','2013-07-01','08:05:00',1.66),('15087','2013-07-01','08:10:00',1.74),('15087','2013-07-01','08:15:00',1.86),('15087','2013-07-01','08:20:00',1.96),('15087','2013-07-01','08:25:00',2.06),('15087','2013-07-01','08:30:00',2.2),('15087','2013-07-01','08:35:00',2.29),('15087','2013-07-01','08:40:00',2.39),('15087','2013-07-01','08:45:00',2.48),('15087','2013-07-01','08:50:00',2.54),('15087','2013-07-01','08:55:00',2.63),('15087','2013-07-01','09:00:00',2.71),('15087','2013-07-01','09:05:00',2.79),('15087','2013-07-01','09:10:00',2.86),('15087','2013-07-01','09:15:00',2.94),('15087','2013-07-01','09:20:00',3.02),('15087','2013-07-01','09:25:00',3.1),('15087','2013-07-01','09:30:00',3.19),('15087','2013-07-01','09:35:00',3.25),('15087','2013-07-01','09:40:00',3.3),('15087','2013-07-01','09:45:00',3.36),('15087','2013-07-01','09:50:00',3.42),('15087','2013-07-01','09:55:00',3.46),('15087','2013-07-01','10:00:00',3.5),('15087','2013-07-01','10:05:00',3.55),('15087','2013-07-01','10:10:00',3.62),('15087','2013-07-01','10:15:00',3.69),('15087','2013-07-01','10:20:00',3.74),('15087','2013-07-01','10:25:00',3.78),('15087','2013-07-01','10:30:00',3.85),('15087','2013-07-01','10:35:00',3.93),('15087','2013-07-01','10:40:00',3.97),('15087','2013-07-01','10:45:00',4.03),('15087','2013-07-01','10:50:00',4.07),('15087','2013-07-01','10:55:00',4.14),('15087','2013-07-01','11:00:00',4.21),('15087','2013-07-01','11:05:00',4.2),('15087','2013-07-01','11:10:00',4.23),('15087','2013-07-01','11:15:00',4.3),('15087','2013-07-01','11:20:00',4.38),('15087','2013-07-01','11:25:00',4.43),('15087','2013-07-01','11:30:00',4.43),('15087','2013-07-01','11:35:00',4.4),('15087','2013-07-01','11:40:00',4.48),('15087','2013-07-01','11:45:00',4.54),('15087','2013-07-01','11:50:00',4.57),('15087','2013-07-01','11:55:00',4.53),('15087','2013-07-01','12:00:00',4.51),('15087','2013-07-01','12:05:00',4.51),('15087','2013-07-01','12:10:00',4.52),('15087','2013-07-01','12:15:00',4.56),('15087','2013-07-01','12:20:00',4.61),('15087','2013-07-01','12:25:00',4.57),('15087','2013-07-01','12:30:00',4.6),('15087','2013-07-01','12:35:00',4.66),('15087','2013-07-01','12:40:00',4.61),('15087','2013-07-01','12:45:00',4.6),('15087','2013-07-01','12:50:00',4.63),('15087','2013-07-01','12:55:00',4.66),('15087','2013-07-01','13:00:00',4.68),('15087','2013-07-01','13:05:00',4.68),('15087','2013-07-01','13:10:00',4.7),('15087','2013-07-01','13:15:00',4.67),('15087','2013-07-01','13:20:00',4.71),('15087','2013-07-01','13:25:00',4.71),('15087','2013-07-01','13:30:00',4.71),('15087','2013-07-01','13:35:00',4.7),('15087','2013-07-01','13:40:00',4.7),('15087','2013-07-01','13:45:00',4.64),('15087','2013-07-01','13:50:00',4.64),('15087','2013-07-01','13:55:00',4.64),('15087','2013-07-01','14:00:00',4.64),('15087','2013-07-01','14:05:00',4.66),('15087','2013-07-01','14:10:00',4.66),('15087','2013-07-01','14:15:00',4.61),('15087','2013-07-01','14:20:00',4.58),('15087','2013-07-01','14:25:00',4.53),('15087','2013-07-01','14:30:00',4.5),('15087','2013-07-01','14:35:00',4.5),('15087','2013-07-01','14:40:00',4.4),('15087','2013-07-01','14:45:00',4.35),('15087','2013-07-01','14:50:00',4.15),('15087','2013-07-01','14:55:00',4.1),('15087','2013-07-01','15:00:00',4.17),('15087','2013-07-01','15:05:00',4.12),('15087','2013-07-01','15:10:00',4.09),('15087','2013-07-01','15:15:00',4.04),('15087','2013-07-01','15:20:00',4),('15087','2013-07-01','15:25:00',3.94),('15087','2013-07-01','15:30:00',3.89),('15087','2013-07-01','15:35:00',3.74),('15087','2013-07-01','15:40:00',3.67),('15087','2013-07-01','15:45:00',3.71),('15087','2013-07-01','15:50:00',3.65),('15087','2013-07-01','15:55:00',3.59),('15087','2013-07-01','16:00:00',3.55),('15087','2013-07-01','16:05:00',3.55),('15087','2013-07-01','16:10:00',3.39),('15087','2013-07-01','16:15:00',3.43),('15087','2013-07-01','16:20:00',3.34),('15087','2013-07-01','16:25:00',3.27),('15087','2013-07-01','16:30:00',3.25),('15087','2013-07-01','16:35:00',3.11),('15087','2013-07-01','16:40:00',3.07),('15087','2013-07-01','16:45:00',2.93),('15087','2013-07-01','16:50:00',2.97),('15087','2013-07-01','16:55:00',2.95),('15087','2013-07-01','17:00:00',2.9),('15087','2013-07-01','17:05:00',2.81),('15087','2013-07-01','17:10:00',2.7),('15087','2013-07-01','17:15:00',2.64),('15087','2013-07-01','17:20:00',2.58),('15087','2013-07-01','17:25:00',2.48),('15087','2013-07-01','17:30:00',2.35),('15087','2013-07-01','17:35:00',2.19),('15087','2013-07-01','17:40:00',2.12),('15087','2013-07-01','17:45:00',1.99),('15087','2013-07-01','17:50:00',1.78),('15087','2013-07-01','17:55:00',1.79),('15087','2013-07-01','18:00:00',1.55),('15087','2013-07-01','18:05:00',1.55),('15087','2013-07-01','18:10:00',1.46),('15087','2013-07-01','18:15:00',1.16),('15087','2013-07-01','18:20:00',1.22),('15087','2013-07-01','18:25:00',1.25),('15087','2013-07-01','18:30:00',1.17),('15087','2013-07-01','18:35:00',1.05),('15087','2014-04-05','09:15:00',1.15),('15087','2014-04-05','09:20:00',1.72),('15087','2014-04-05','09:25:00',2.06),('15087','2014-04-05','09:30:00',3.93),('15087','2014-04-05','09:35:00',3.91),('15087','2014-04-05','09:40:00',3.91),('15087','2014-04-05','09:45:00',3.67),('15087','2014-04-05','09:50:00',2.18),('15087','2014-04-05','09:55:00',1.71),('15087','2014-04-05','10:00:00',2.34),('15087','2014-04-05','10:05:00',2.17),('15087','2014-04-05','10:10:00',2.55),('15087','2014-04-05','10:15:00',1.87),('15087','2014-04-05','10:20:00',2.4),('15087','2014-04-05','10:25:00',2.9),('15087','2014-04-05','10:30:00',2.76),('15087','2014-04-05','10:35:00',2.98),('15087','2014-04-05','10:40:00',3.2),('15087','2014-04-05','10:45:00',3.65),('15087','2014-04-05','10:50:00',2.9),('15087','2014-04-05','10:55:00',3.07),('15087','2014-04-05','11:00:00',3.56),('15087','2014-04-05','11:05:00',3.72),('15087','2014-04-05','11:10:00',4.14),('15087','2014-04-05','11:15:00',4.29),('15087','2014-04-05','11:20:00',4.62),('15087','2014-04-05','11:25:00',4.24),('15087','2014-04-05','11:30:00',2.92),('15087','2014-04-05','11:35:00',2.35),('15087','2014-04-05','11:40:00',3.02),('15087','2014-04-05','11:45:00',4.11),('15087','2014-04-05','11:50:00',4.38),('15087','2014-04-05','11:55:00',4.17),('15087','2014-04-05','12:00:00',4.45),('15087','2014-04-05','12:05:00',3.44),('15087','2014-04-05','12:10:00',3.26),('15087','2014-04-05','12:15:00',3.74),('15087','2014-04-05','12:20:00',3.24),('15087','2014-04-05','12:25:00',4.12),('15087','2014-04-05','12:30:00',3.17),('15087','2014-04-05','12:35:00',2.59),('15087','2014-04-05','12:40:00',3.17),('15087','2014-04-05','12:45:00',4.78),('15087','2014-04-05','12:50:00',4.56),('15087','2014-04-05','12:55:00',4.93),('15087','2014-04-05','13:00:00',3.93),('15087','2014-04-05','13:05:00',3.14),('15087','2014-04-05','13:10:00',2.67),('15087','2014-04-05','13:15:00',2.19),('15087','2014-04-05','13:20:00',2.91),('15087','2014-04-05','13:25:00',4.83),('15087','2014-04-05','13:30:00',4.41),('15087','2014-04-05','13:35:00',4.56),('15087','2014-04-05','13:40:00',3.35),('15087','2014-04-05','13:45:00',4.7),('15087','2014-04-05','13:50:00',5.12),('15087','2014-04-05','13:55:00',3.86),('15087','2014-04-05','14:00:00',4.18),('15087','2014-04-05','14:05:00',5.12),('15087','2014-04-05','14:10:00',3.51),('15087','2014-04-05','14:25:00',1.13),('15087','2014-04-05','14:30:00',1.82),('15087','2014-04-05','14:35:00',1.04),('15087','2014-04-05','14:55:00',4.19),('15087','2014-04-05','15:00:00',4.29),('15087','2014-04-05','15:05:00',4.18),('15087','2014-04-05','15:10:00',3.31),('15087','2014-04-05','15:15:00',1.86),('15087','2014-04-05','15:20:00',3.41),('15087','2014-04-05','15:25:00',2.58),('15087','2014-04-05','15:30:00',1.69),('15087','2014-04-05','15:35:00',1.57),('15087','2014-04-05','15:40:00',2.05),('15087','2014-04-05','15:45:00',2.22),('15087','2014-04-05','15:50:00',2.59),('15087','2014-04-05','15:55:00',1.35),('15087','2014-04-05','16:00:00',1.3),('15087','2014-04-05','16:05:00',1.33),('15087','2014-04-05','16:10:00',1.25),('15087','2014-04-05','16:15:00',1.66),('15087','2014-04-05','16:20:00',3.98),('15087','2014-04-05','16:25:00',2.85),('15087','2014-04-05','16:30:00',2.14),('15087','2014-04-05','16:35:00',2.9),('15087','2014-04-05','16:40:00',1.65),('15087','2014-04-05','16:45:00',2.31),('15087','2014-04-05','16:50:00',1.63),('15087','2014-04-05','16:55:00',2.51),('15087','2014-04-05','17:00:00',1.45),('15087','2014-04-05','17:05:00',1.97),('15087','2014-04-05','17:10:00',1.66),('15087','2014-04-05','17:20:00',1.19),('15087','2014-04-05','17:25:00',1.19),('15087','2014-04-05','17:30:00',1.3),('15087','2014-04-05','17:35:00',1.09),('15087','2014-04-05','17:50:00',1.05),('15087','2014-04-05','17:55:00',1.06),('15087','2014-04-05','18:00:00',1.02),('15087','2013-06-30','07:25:00',1.02),('15087','2013-06-30','07:30:00',1.1),('15087','2013-06-30','07:35:00',1.19),('15087','2013-06-30','07:40:00',1.27),('15087','2013-06-30','07:45:00',1.36),('15087','2013-06-30','07:50:00',1.45),('15087','2013-06-30','07:55:00',1.54),('15087','2013-06-30','08:00:00',1.66),('15087','2013-06-30','08:05:00',1.75),('15087','2013-06-30','08:10:00',1.85),('15087','2013-06-30','08:15:00',1.97),('15087','2013-06-30','08:20:00',2.07),('15087','2013-06-30','08:25:00',2.16),('15087','2013-06-30','08:30:00',2.28),('15087','2013-06-30','08:35:00',2.38),('15087','2013-06-30','08:40:00',2.47),('15087','2013-06-30','08:45:00',2.55),('15087','2013-06-30','08:50:00',2.63),('15087','2013-06-30','08:55:00',2.71),('15087','2013-06-30','09:00:00',2.79),('15087','2013-06-30','09:05:00',2.85),('15087','2013-06-30','09:10:00',2.95),('15087','2013-06-30','09:15:00',3.02),('15087','2013-06-30','09:20:00',3.1),('15087','2013-06-30','09:25:00',3.18),('15087','2013-06-30','09:30:00',3.26),('15087','2013-06-30','09:35:00',3.31),('15087','2013-06-30','09:40:00',3.4),('15087','2013-06-30','09:45:00',3.48),('15087','2013-06-30','09:50:00',3.54),('15087','2013-06-30','09:55:00',3.59),('15087','2013-06-30','10:00:00',3.66),('15087','2013-06-30','10:05:00',3.7),('15087','2013-06-30','10:10:00',3.79),('15087','2013-06-30','10:15:00',3.85),('15087','2013-06-30','10:20:00',3.89),('15087','2013-06-30','10:25:00',3.92),('15087','2013-06-30','10:30:00',3.95),('15087','2013-06-30','10:35:00',4.02),('15087','2013-06-30','10:40:00',4.09),('15087','2013-06-30','10:45:00',4.15),('15087','2013-06-30','10:50:00',4.16),('15087','2013-06-30','10:55:00',4.18),('15087','2013-06-30','11:00:00',4.2),('15087','2013-06-30','11:05:00',4.26),('15087','2013-06-30','11:10:00',4.32),('15087','2013-06-30','11:15:00',4.34),('15087','2013-06-30','11:20:00',4.34),('15087','2013-06-30','11:25:00',4.38),('15087','2013-06-30','11:30:00',4.41),('15087','2013-06-30','11:35:00',4.43),('15087','2013-06-30','11:40:00',4.46),('15087','2013-06-30','11:45:00',4.47),('15087','2013-06-30','11:50:00',4.45),('15087','2013-06-30','11:55:00',4.55),('15087','2013-06-30','12:00:00',4.54),('15087','2013-06-30','12:05:00',4.47),('15087','2013-06-30','12:10:00',4.66),('15087','2013-06-30','12:15:00',4.66),('15087','2013-06-30','12:20:00',4.67),('15087','2013-06-30','12:25:00',4.64),('15087','2013-06-30','12:30:00',4.65),('15087','2013-06-30','12:35:00',4.68),('15087','2013-06-30','12:40:00',4.7),('15087','2013-06-30','12:45:00',4.67),('15087','2013-06-30','12:50:00',4.76),('15087','2013-06-30','12:55:00',4.79),('15087','2013-06-30','13:00:00',4.76),('15087','2013-06-30','13:05:00',4.73),('15087','2013-06-30','13:10:00',4.72),('15087','2013-06-30','13:15:00',4.77),('15087','2013-06-30','13:20:00',4.76),('15087','2013-06-30','13:25:00',4.77),('15087','2013-06-30','13:30:00',4.76),('15087','2013-06-30','13:35:00',4.77),('15087','2013-06-30','13:40:00',4.38),('15087','2013-06-30','13:45:00',4.65),('15087','2013-06-30','13:50:00',4.87),('15087','2013-06-30','13:55:00',4.82),('15087','2013-06-30','14:00:00',4.62),('15087','2013-06-30','14:05:00',4.79),('15087','2013-06-30','14:10:00',4.74),('15087','2013-06-30','14:15:00',4.61),('15087','2013-06-30','14:20:00',4.62),('15087','2013-06-30','14:25:00',4.59),('15087','2013-06-30','14:30:00',4.5),('15087','2013-06-30','14:35:00',4.47),('15087','2013-06-30','14:40:00',4.52),('15087','2013-06-30','14:45:00',4.45),('15087','2013-06-30','14:50:00',4.35),('15087','2013-06-30','14:55:00',4.35),('15087','2013-06-30','15:00:00',4.29),('15087','2013-06-30','15:05:00',4.23),('15087','2013-06-30','15:10:00',4.19),('15087','2013-06-30','15:15:00',3.94),('15087','2013-06-30','15:20:00',3.68),('15087','2013-06-30','15:25:00',4.04),('15087','2013-06-30','15:30:00',4.05),('15087','2013-06-30','15:35:00',3.93),('15087','2013-06-30','15:40:00',3.93),('15087','2013-06-30','15:45:00',3.89),('15087','2013-06-30','15:50:00',3.85),('15087','2013-06-30','15:55:00',3.76),('15087','2013-06-30','16:00:00',3.72),('15087','2013-06-30','16:05:00',3.7),('15087','2013-06-30','16:10:00',3.67),('15087','2013-06-30','16:15:00',3.5),('15087','2013-06-30','16:20:00',3.65),('15087','2013-06-30','16:25:00',3.67),('15087','2013-06-30','16:30:00',3.58),('15087','2013-06-30','16:35:00',3.47),('15087','2013-06-30','16:40:00',3.23),('15087','2013-06-30','16:45:00',3.11),('15087','2013-06-30','16:50:00',3.15),('15087','2013-06-30','16:55:00',3.06),('15087','2013-06-30','17:00:00',2.95),('15087','2013-06-30','17:05:00',2.82),('15087','2013-06-30','17:10:00',2.78),('15087','2013-06-30','17:15:00',2.69),('15087','2013-06-30','17:20:00',2.63),('15087','2013-06-30','17:25:00',2.55),('15087','2013-06-30','17:30:00',2.43),('15087','2013-06-30','17:35:00',2.24),('15087','2013-06-30','17:40:00',2.18),('15087','2013-06-30','17:45:00',2.02),('15087','2013-06-30','17:50:00',1.83),('15087','2013-06-30','17:55:00',1.8),('15087','2013-06-30','18:00:00',1.6),('15087','2013-06-30','18:05:00',1.44),('15087','2013-06-30','18:10:00',1.42),('15087','2013-06-30','18:15:00',1.36),('15087','2013-06-30','18:20:00',1.34),('15087','2013-06-30','18:25:00',1.24),('15087','2013-06-30','18:30:00',1.13),('15087','2013-06-30','18:35:00',1.04),('15087','2013-06-29','07:30:00',1.35),('15087','2013-06-29','07:35:00',1.66),('15087','2013-06-29','07:40:00',1.74),('15087','2013-06-29','07:45:00',1.71),('15087','2013-06-29','07:50:00',1.86),('15087','2013-06-29','07:55:00',2.06),('15087','2013-06-29','08:00:00',2.25),('15087','2013-06-29','08:05:00',2.49),('15087','2013-06-29','08:10:00',2.54),('15087','2013-06-29','08:15:00',2.07),('15087','2013-06-29','08:20:00',1.4),('15087','2013-06-29','08:25:00',2.38),('15087','2013-06-29','08:30:00',2.4),('15087','2013-06-29','08:35:00',2.49),('15087','2013-06-29','08:40:00',1.34),('15087','2013-06-29','08:45:00',2.39),('15087','2013-06-29','08:50:00',2.65),('15087','2013-06-29','08:55:00',2.71),('15087','2013-06-29','09:00:00',2.77),('15087','2013-06-29','09:05:00',2.84),('15087','2013-06-29','09:10:00',2.9),('15087','2013-06-29','09:15:00',2.96),('15087','2013-06-29','09:20:00',3.05),('15087','2013-06-29','09:25:00',3.12),('15087','2013-06-29','09:30:00',3.17),('15087','2013-06-29','09:35:00',3.24),('15087','2013-06-29','09:40:00',3.35),('15087','2013-06-29','09:45:00',3.44),('15087','2013-06-29','09:50:00',3.49),('15087','2013-06-29','09:55:00',3.53),('15087','2013-06-29','10:00:00',3.58),('15087','2013-06-29','10:05:00',3.66),('15087','2013-06-29','10:10:00',3.74),('15087','2013-06-29','10:15:00',3.78),('15087','2013-06-29','10:20:00',3.82),('15087','2013-06-29','10:25:00',3.89),('15087','2013-06-29','10:30:00',3.9),('15087','2013-06-29','10:35:00',3.98),('15087','2013-06-29','10:40:00',4.07),('15087','2013-06-29','10:45:00',4.03),('15087','2013-06-29','10:50:00',1.07),('15087','2013-06-29','10:55:00',3.15),('15087','2013-06-29','11:00:00',4.33),('15087','2013-06-29','11:05:00',4.4),('15087','2013-06-29','11:10:00',4.45),('15087','2013-06-29','11:15:00',4.57),('15087','2013-06-29','11:20:00',4.29),('15087','2013-06-29','11:25:00',4.91),('15087','2013-06-29','11:30:00',4.02),('15087','2013-06-29','11:35:00',3.18),('15087','2013-06-29','11:40:00',3.01),('15087','2013-06-29','11:45:00',5.14),('15087','2013-06-29','11:50:00',5.24),('15087','2013-06-29','11:55:00',4.09),('15087','2013-06-29','12:00:00',4.23),('15087','2013-06-29','12:05:00',4.01),('15087','2013-06-29','12:10:00',4.95),('15087','2013-06-29','12:15:00',5.08),('15087','2013-06-29','12:20:00',3.09),('15087','2013-06-29','12:25:00',4.75),('15087','2013-06-29','12:30:00',5.14),('15087','2013-06-29','12:35:00',2.54),('15087','2013-06-29','12:40:00',3.05),('15087','2013-06-29','12:45:00',5.44),('15087','2013-06-29','12:50:00',3.77),('15087','2013-06-29','12:55:00',5.28),('15087','2013-06-29','13:00:00',3.76),('15087','2013-06-29','13:05:00',4.51),('15087','2013-06-29','13:10:00',3.95),('15087','2013-06-29','13:15:00',4.24),('15087','2013-06-29','13:20:00',2.44),('15087','2013-06-29','13:25:00',3.72),('15087','2013-06-29','13:30:00',1.13),('15087','2013-06-29','13:40:00',1.03),('15087','2013-06-29','13:45:00',1.95),('15087','2013-06-29','13:50:00',1.87),('15087','2013-06-29','13:55:00',3.63),('15087','2013-06-29','14:00:00',5.42),('15087','2013-06-29','14:05:00',5.37),('15087','2013-06-29','14:10:00',5.22),('15087','2013-06-29','14:15:00',5.22),('15087','2013-06-29','14:20:00',5.43),('15087','2013-06-29','14:25:00',5.31),('15087','2013-06-29','14:30:00',5.13),('15087','2013-06-29','14:35:00',5.07),('15087','2013-06-29','14:40:00',5.05),('15087','2013-06-29','14:45:00',5.06),('15087','2013-06-29','14:50:00',5.25),('15087','2013-06-29','14:55:00',3.41),('15087','2013-06-29','15:00:00',4.24),('15087','2013-06-29','15:05:00',5.35),('15087','2013-06-29','15:10:00',3.1),('15087','2013-06-29','15:15:00',2.89),('15087','2013-06-29','15:20:00',1.58),('15087','2013-06-29','15:25:00',1.15),('15087','2013-06-29','16:40:00',1.3),('15087','2013-06-29','16:45:00',1.71),('15087','2013-06-29','16:50:00',2.72),('15087','2013-06-29','16:55:00',1.32),('15087','2013-06-29','17:00:00',1.24),('15087','2013-06-29','17:05:00',1.61),('15087','2013-06-29','17:10:00',1.17),('15087','2013-06-29','17:15:00',1.11),('15087','2013-06-29','17:20:00',1.36),('15087','2013-06-29','17:25:00',1.62),('15087','2013-06-29','17:30:00',3.01),('15087','2013-06-29','17:35:00',1.91),('15087','2013-06-29','17:40:00',1.31),('15087','2013-06-29','17:45:00',2.25),('15087','2013-06-29','17:50:00',1.98),('15087','2013-06-29','17:55:00',1.92),('15087','2013-06-29','18:00:00',1.69),('15087','2013-06-29','18:05:00',1.63),('15087','2013-06-29','18:15:00',1.24),('15087','2013-06-29','18:20:00',1.36),('15087','2013-06-29','18:25:00',1.02),('15087','2013-06-29','18:35:00',1.07),('15087','2013-06-29','18:40:00',1.08),('15087','2013-06-28','07:25:00',1.01),('15087','2013-06-28','07:30:00',1.11),('15087','2013-06-28','07:35:00',1.16),('15087','2013-06-28','07:40:00',1.17),('15087','2013-06-28','07:45:00',1.38),('15087','2013-06-28','07:50:00',1.42),('15087','2013-06-28','07:55:00',1.5),('15087','2013-06-28','08:00:00',1.55),('15087','2013-06-28','08:05:00',1.53),('15087','2013-06-28','08:10:00',1.64),('15087','2013-06-28','08:15:00',1.83),('15087','2013-06-28','08:20:00',1.86),('15087','2013-06-28','08:25:00',1.86),('15087','2013-06-28','08:30:00',2.13),('15087','2013-06-28','08:35:00',2.25),('15087','2013-06-28','08:40:00',2.35),('15087','2013-06-28','08:45:00',2.45),('15087','2013-06-28','08:50:00',2.54),('15087','2013-06-28','08:55:00',2.63),('15087','2013-06-28','09:00:00',2.72),('15087','2013-06-28','09:05:00',2.79),('15087','2013-06-28','09:10:00',2.98),('15087','2013-06-28','09:15:00',2.36),('15087','2013-06-28','09:25:00',2.02),('15087','2013-06-28','09:30:00',3.36),('15087','2013-06-28','09:35:00',3.36),('15087','2013-06-28','09:40:00',3.52),('15087','2013-06-28','09:45:00',3.65),('15087','2013-06-28','09:50:00',3.43),('15087','2013-06-28','09:55:00',3.36),('15087','2013-06-28','10:05:00',2.71),('15087','2013-06-28','10:10:00',3.93),('15087','2013-06-28','10:15:00',3.78),('15087','2013-06-28','10:20:00',1.4),('15087','2013-06-28','10:25:00',1.4),('15087','2013-06-28','10:30:00',4.22),('15087','2013-06-28','10:35:00',4.96),('15087','2013-06-28','10:40:00',3.71),('15087','2013-06-28','10:45:00',4.28),('15087','2013-06-28','10:50:00',1.68),('15087','2013-06-28','10:55:00',2.35),('15087','2013-06-28','11:00:00',2.69),('15087','2013-06-28','11:05:00',1.96),('15087','2013-06-28','11:10:00',1.76),('15087','2013-06-28','11:15:00',2.21),('15087','2013-06-28','11:20:00',1.65),('15087','2013-06-28','11:25:00',4.69),('15087','2013-06-28','11:30:00',4.63),('15087','2013-06-28','11:35:00',3.93),('15087','2013-06-28','11:40:00',4.29),('15087','2013-06-28','11:45:00',4.17),('15087','2013-06-28','11:50:00',4.65),('15087','2013-06-28','11:55:00',2.78),('15087','2013-06-28','12:00:00',2.88),('15087','2013-06-28','12:05:00',3.21),('15087','2013-06-28','12:10:00',5.1),('15087','2013-06-28','12:15:00',5.06),('15087','2013-06-28','12:20:00',4.93),('15087','2013-06-28','12:25:00',4.52),('15087','2013-06-28','12:30:00',4.78),('15087','2013-06-28','12:35:00',3.38),('15087','2013-06-28','12:40:00',2.85),('15087','2013-06-28','12:45:00',5.04),('15087','2013-06-28','12:50:00',4.97),('15087','2013-06-28','12:55:00',4.85),('15087','2013-06-28','13:00:00',4.89),('15087','2013-06-28','13:05:00',4.71),('15087','2013-06-28','13:10:00',4.46),('15087','2013-06-28','13:15:00',4.87),('15087','2013-06-28','13:20:00',3.7),('15087','2013-06-28','13:25:00',4.89),('15087','2013-06-28','13:30:00',4.88),('15087','2013-06-28','13:35:00',4.95),('15087','2013-06-28','13:40:00',4.61),('15087','2013-06-28','13:45:00',4.97),('15087','2013-06-28','13:50:00',4.8),('15087','2013-06-28','13:55:00',4.74),('15087','2013-06-28','14:00:00',3.49),('15087','2013-06-28','14:05:00',5.14),('15087','2013-06-28','14:10:00',3.89),('15087','2013-06-28','14:15:00',4.51),('15087','2013-06-28','14:20:00',4.71),('15087','2013-06-28','14:25:00',2.18),('15087','2013-06-28','14:30:00',3.07),('15087','2013-06-28','14:35:00',4.41),('15087','2013-06-28','14:40:00',4.62),('15087','2013-06-28','14:45:00',4.9),('15087','2013-06-28','14:50:00',4.42),('15087','2013-06-28','14:55:00',4.24),('15087','2013-06-28','15:00:00',3.62),('15087','2013-06-28','15:05:00',4.41),('15087','2013-06-28','15:10:00',4.49),('15087','2013-06-28','15:15:00',4.44),('15087','2013-06-28','15:20:00',4.49),('15087','2013-06-28','15:25:00',4.18),('15087','2013-06-28','15:30:00',3.34),('15087','2013-06-28','15:35:00',3.98),('15087','2013-06-28','15:40:00',2.69),('15087','2013-06-28','15:45:00',3.4),('15087','2013-06-28','15:50:00',3.54),('15087','2013-06-28','15:55:00',3.42),('15087','2013-06-28','16:00:00',3.71),('15087','2013-06-28','16:05:00',2.97),('15087','2013-06-28','16:10:00',1.38),('15087','2013-06-28','16:15:00',3.05),('15087','2013-06-28','16:20:00',3.65),('15087','2013-06-28','16:25:00',2.05),('15087','2013-06-28','16:30:00',3.59),('15087','2013-06-28','16:40:00',2.18),('15087','2013-06-28','16:45:00',2.25),('15087','2013-06-28','16:50:00',3.58),('15087','2013-06-28','16:55:00',3.34),('15087','2013-06-28','17:00:00',3.09),('15087','2013-06-28','17:05:00',2.3),('15087','2013-06-28','17:10:00',2.54),('15087','2013-06-28','17:15:00',2.68),('15087','2013-06-28','17:20:00',2.6),('15087','2013-06-28','17:25:00',2.6),('15087','2013-06-28','17:30:00',2.51),('15087','2013-06-28','17:35:00',2.36),('15087','2013-06-28','17:40:00',2.2),('15087','2013-06-28','17:45:00',2.12),('15087','2013-06-28','17:50:00',1.96),('15087','2013-06-28','17:55:00',1.85),('15087','2013-06-28','18:00:00',1.78),('15087','2013-06-28','18:05:00',1.66),('15087','2013-06-28','18:10:00',1.5),('15087','2013-06-28','18:15:00',1.5),('15087','2013-06-28','18:20:00',1.38),('15087','2013-06-28','18:25:00',1.21),('15087','2013-06-27','07:30:00',1.04),('15087','2013-06-27','07:35:00',1.12),('15087','2013-06-27','07:40:00',1.21),('15087','2013-06-27','07:45:00',1.31),('15087','2013-06-27','07:50:00',1.43),('15087','2013-06-27','07:55:00',1.51),('15087','2013-06-27','08:00:00',1.6),('15087','2013-06-27','08:05:00',1.77),('15087','2013-06-27','08:10:00',1.83),('15087','2013-06-27','08:15:00',1.93),('15087','2013-06-27','08:20:00',2.02),('15087','2013-06-27','08:25:00',2.12),('15087','2013-06-27','08:30:00',2.2),('15087','2013-06-27','08:35:00',2.27),('15087','2013-06-27','08:40:00',2.35),('15087','2013-06-27','08:45:00',2.46),('15087','2013-06-27','08:50:00',2.55),('15087','2013-06-27','08:55:00',2.65),('15087','2013-06-27','09:00:00',2.76),('15087','2013-06-27','09:05:00',2.81),('15087','2013-06-27','09:10:00',2.9),('15087','2013-06-27','09:15:00',2.96),('15087','2013-06-27','09:20:00',3.08),('15087','2013-06-27','09:25:00',3.15),('15087','2013-06-27','09:30:00',3.2),('15087','2013-06-27','09:35:00',3.28),('15087','2013-06-27','09:40:00',3.34),('15087','2013-06-27','09:45:00',3.35),('15087','2013-06-27','09:50:00',3.5),('15087','2013-06-27','09:55:00',3.63),('15087','2013-06-27','10:00:00',3.59),('15087','2013-06-27','10:05:00',3.82),('15087','2013-06-27','10:10:00',3.49),('15087','2013-06-27','10:15:00',2.99),('15087','2013-06-27','10:20:00',3.15),('15087','2013-06-27','10:25:00',3.95),('15087','2013-06-27','10:30:00',4.03),('15087','2013-06-27','10:35:00',4.16),('15087','2013-06-27','10:40:00',4.4),('15087','2013-06-27','10:45:00',4.48),('15087','2013-06-27','10:50:00',4.29),('15087','2013-06-27','10:55:00',4.41),('15087','2013-06-27','11:00:00',4.41),('15087','2013-06-27','11:05:00',4.49),('15087','2013-06-27','11:10:00',4.57),('15087','2013-06-27','11:15:00',4.61),('15087','2013-06-27','11:20:00',4.62),('15087','2013-06-27','11:25:00',4.66),('15087','2013-06-27','11:30:00',4.59),('15087','2013-06-27','11:35:00',4.64),('15087','2013-06-27','11:40:00',4.87),('15087','2013-06-27','11:45:00',4.88),('15087','2013-06-27','11:50:00',3.86),('15087','2013-06-27','11:55:00',1.33),('15087','2013-06-27','12:00:00',1.43),('15087','2013-06-27','12:05:00',1.29),('15087','2013-06-27','12:10:00',1.25),('15087','2013-06-27','12:15:00',1.08),('15087','2013-06-27','12:20:00',1.16),('15087','2013-06-27','12:25:00',1.9),('15087','2013-06-27','12:30:00',1.77),('15087','2013-06-27','12:35:00',2.93),('15087','2013-06-27','12:40:00',1.84),('15087','2013-06-27','12:45:00',1.84),('15087','2013-06-27','12:50:00',1.39),('15087','2013-06-27','12:55:00',1.18),('15087','2013-06-27','13:00:00',1),('15087','2013-06-27','13:05:00',1.16),('15087','2013-06-27','13:10:00',1.42),('15087','2013-06-27','13:15:00',1.94),('15087','2013-06-27','13:20:00',1.54),('15087','2013-06-27','13:25:00',1.64),('15087','2013-06-27','13:30:00',1.47),('15087','2013-06-27','13:35:00',1.38),('15087','2013-06-27','13:40:00',1.29),('15087','2013-06-27','13:45:00',1.38),('15087','2013-06-27','13:50:00',1.69),('15087','2013-06-27','13:55:00',1.43),('15087','2013-06-27','14:00:00',1.44),('15087','2013-06-27','14:05:00',1.41),('15087','2013-06-27','14:10:00',2.28),('15087','2013-06-27','14:15:00',3.96),('15087','2013-06-27','14:20:00',3.36),('15087','2013-06-27','14:25:00',2.63),('15087','2013-06-27','14:30:00',3.25),('15087','2013-06-27','14:35:00',1.81),('15087','2013-06-27','14:40:00',4.43),('15087','2013-06-27','14:45:00',2.56),('15087','2013-06-27','14:50:00',2.57),('15087','2013-06-27','14:55:00',4.17),('15087','2013-06-27','15:00:00',4.25),('15087','2013-06-27','15:05:00',4.18),('15087','2013-06-27','15:10:00',4.11),('15087','2013-06-27','15:15:00',3.85),('15087','2013-06-27','15:20:00',3.6),('15087','2013-06-27','15:25:00',3.99),('15087','2013-06-27','15:30:00',3.92),('15087','2013-06-27','15:35:00',3.81),('15087','2013-06-27','15:40:00',3.69),('15087','2013-06-27','15:45:00',3.74),('15087','2013-06-27','15:50:00',3.71),('15087','2013-06-27','15:55:00',3.59),('15087','2013-06-27','16:00:00',3.56),('15087','2013-06-27','16:05:00',3.49),('15087','2013-06-27','16:10:00',3.36),('15087','2013-06-27','16:15:00',3.46),('15087','2013-06-27','16:20:00',3.39),('15087','2013-06-27','16:25:00',3.24),('15087','2013-06-27','16:30:00',3.3),('15087','2013-06-27','16:35:00',2.99),('15087','2013-06-27','16:40:00',3.07),('15087','2013-06-27','16:45:00',3.06),('15087','2013-06-27','16:50:00',3),('15087','2013-06-27','16:55:00',2.94),('15087','2013-06-27','17:00:00',2.87),('15087','2013-06-27','17:05:00',2.73),('15087','2013-06-27','17:10:00',2.58),('15087','2013-06-27','17:15:00',2.5),('15087','2013-06-27','17:20:00',2.62),('15087','2013-06-27','17:25:00',2.54),('15087','2013-06-27','17:30:00',2.46),('15087','2013-06-27','17:35:00',2.3),('15087','2013-06-27','17:40:00',1.66),('15087','2013-06-27','17:45:00',1.09),('15087','2013-06-27','17:50:00',1.83),('15087','2013-06-27','17:55:00',1.78),('15087','2013-06-27','18:00:00',1.68),('15087','2013-06-27','18:05:00',1.49),('15087','2013-06-27','18:10:00',1.35),('15087','2013-06-27','18:15:00',1.33),('15087','2013-06-27','18:20:00',1.28),('15087','2013-06-27','18:25:00',1.24),('15087','2013-06-27','18:30:00',1.18),('15087','2013-06-27','18:35:00',1.07),('15087','2013-06-26','07:30:00',1.07),('15087','2013-06-26','07:35:00',1.17),('15087','2013-06-26','07:40:00',1.26),('15087','2013-06-26','07:45:00',1.35),('15087','2013-06-26','07:50:00',1.45),('15087','2013-06-26','07:55:00',1.52),('15087','2013-06-26','08:00:00',1.59),('15087','2013-06-26','08:05:00',1.69),('15087','2013-06-26','08:10:00',1.8),('15087','2013-06-26','08:15:00',1.9),('15087','2013-06-26','08:20:00',1.92),('15087','2013-06-26','08:25:00',2.04),('15087','2013-06-26','08:30:00',2.17),('15087','2013-06-26','08:35:00',2.23),('15087','2013-06-26','08:40:00',2.32),('15087','2013-06-26','08:45:00',2.46),('15087','2013-06-26','08:50:00',2.5),('15087','2013-06-26','08:55:00',2.6),('15087','2013-06-26','09:00:00',2.68),('15087','2013-06-26','09:05:00',2.77),('15087','2013-06-26','09:10:00',2.83),('15087','2013-06-26','09:15:00',2.89),('15087','2013-06-26','09:20:00',2.95),('15087','2013-06-26','09:25:00',3.04),('15087','2013-06-26','09:30:00',3.11),('15087','2013-06-26','09:35:00',3.16),('15087','2013-06-26','09:40:00',3.22),('15087','2013-06-26','09:45:00',3.31),('15087','2013-06-26','09:50:00',3.36),('15087','2013-06-26','09:55:00',3.41),('15087','2013-06-26','10:00:00',3.48),('15087','2013-06-26','10:05:00',3.55),('15087','2013-06-26','10:10:00',3.64),('15087','2013-06-26','10:15:00',3.74),('15087','2013-06-26','10:20:00',3.77),('15087','2013-06-26','10:25:00',3.81),('15087','2013-06-26','10:30:00',3.83),('15087','2013-06-26','10:35:00',3.87),('15087','2013-06-26','10:40:00',3.95),('15087','2013-06-26','10:45:00',4.01),('15087','2013-06-26','10:50:00',4.08),('15087','2013-06-26','10:55:00',4.14),('15087','2013-06-26','11:00:00',4.15),('15087','2013-06-26','11:05:00',4.09),('15087','2013-06-26','11:10:00',4.2),('15087','2013-06-26','11:15:00',4.24),('15087','2013-06-26','11:20:00',4.31),('15087','2013-06-26','11:25:00',4.3),('15087','2013-06-26','11:30:00',4.31),('15087','2013-06-26','11:35:00',4.32),('15087','2013-06-26','11:40:00',4.35),('15087','2013-06-26','11:45:00',4.38),('15087','2013-06-26','11:50:00',4.44),('15087','2013-06-26','11:55:00',4.51),('15087','2013-06-26','12:00:00',4.56),('15087','2013-06-26','12:05:00',4.57),('15087','2013-06-26','12:10:00',4.54),('15087','2013-06-26','12:15:00',4.58),('15087','2013-06-26','12:20:00',4.53),('15087','2013-06-26','12:25:00',4.48),('15087','2013-06-26','12:30:00',4.22),('15087','2013-06-26','12:35:00',1.54),('15087','2013-06-26','12:40:00',2.84),('15087','2013-06-26','12:45:00',2.41),('15087','2013-06-26','12:55:00',1.02),('15087','2013-06-26','13:00:00',1.1),('15087','2013-06-26','13:05:00',1.13),('15087','2013-06-26','13:10:00',2.34),('15087','2013-06-26','13:15:00',5.04),('15087','2013-06-26','13:20:00',2.92),('15087','2013-06-26','13:25:00',3.2),('15087','2013-06-26','13:30:00',5.32),('15087','2013-06-26','13:35:00',1.52),('15087','2013-06-26','13:40:00',1.11),('15087','2013-06-26','13:45:00',1.33),('15087','2013-06-26','13:50:00',4.23),('15087','2013-06-26','13:55:00',1.49),('15087','2013-06-26','14:00:00',4.63),('15087','2013-06-26','14:05:00',5.06),('15087','2013-06-26','14:10:00',4.15),('15087','2013-06-26','14:15:00',4.48),('15087','2013-06-26','14:20:00',4.78),('15087','2013-06-26','14:25:00',4.63),('15087','2013-06-26','14:30:00',4.68),('15087','2013-06-26','14:35:00',4.2),('15087','2013-06-26','14:40:00',4.17),('15087','2013-06-26','14:45:00',3.05),('15087','2013-06-26','14:50:00',4.59),('15087','2013-06-26','14:55:00',4.54),('15087','2013-06-26','15:00:00',4.29),('15087','2013-06-26','15:05:00',4.23),('15087','2013-06-26','15:10:00',4.13),('15087','2013-06-26','15:15:00',3.85),('15087','2013-06-26','15:20:00',3.64),('15087','2013-06-26','15:25:00',3.96),('15087','2013-06-26','15:30:00',3.88),('15087','2013-06-26','15:35:00',3.77),('15087','2013-06-26','15:40:00',3.82),('15087','2013-06-26','15:45:00',3.76),('15087','2013-06-26','15:50:00',3.78),('15087','2013-06-26','15:55:00',3.67),('15087','2013-06-26','16:00:00',3.64),('15087','2013-06-26','16:05:00',3.6),('15087','2013-06-26','16:10:00',3.53),('15087','2013-06-26','16:15:00',3.5),('15087','2013-06-26','16:20:00',3.44),('15087','2013-06-26','16:25:00',3.4),('15087','2013-06-26','16:30:00',3.31),('15087','2013-06-26','16:35:00',3.14),('15087','2013-06-26','16:40:00',3.1),('15087','2013-06-26','16:45:00',3.01),('15087','2013-06-26','16:50:00',3.02),('15087','2013-06-26','16:55:00',2.99),('15087','2013-06-26','17:00:00',2.92),('15087','2013-06-26','17:05:00',2.8),('15087','2013-06-26','17:10:00',2.73),('15087','2013-06-26','17:15:00',2.64),('15087','2013-06-26','17:20:00',2.59),('15087','2013-06-26','17:25:00',2.51),('15087','2013-06-26','17:30:00',2.37),('15087','2013-06-26','17:35:00',2.25);
INSERT INTO `solarlog` VALUES ('15087','2013-06-26','17:40:00',2.16),('15087','2013-06-26','17:45:00',2.01),('15087','2013-06-26','17:50:00',1.83),('15087','2013-06-26','17:55:00',1.77),('15087','2013-06-26','18:00:00',1.68),('15087','2013-06-26','18:05:00',1.56),('15087','2013-06-26','18:10:00',1.85),('15087','2013-06-26','18:15:00',1.34),('15087','2013-06-25','07:30:00',1.05),('15087','2013-06-25','07:35:00',1.18),('15087','2013-06-25','07:40:00',1.29),('15087','2013-06-25','07:45:00',1.41),('15087','2013-06-25','07:50:00',1.06),('15087','2013-06-25','08:00:00',1.49),('15087','2013-06-25','08:05:00',1.67),('15087','2013-06-25','08:20:00',1.24),('15087','2013-06-25','08:25:00',2.08),('15087','2013-06-25','08:30:00',2.28),('15087','2013-06-25','08:35:00',2.33),('15087','2013-06-25','08:40:00',2.42),('15087','2013-06-25','08:45:00',2.51),('15087','2013-06-25','08:50:00',2.57),('15087','2013-06-25','08:55:00',2.67),('15087','2013-06-25','09:00:00',2.76),('15087','2013-06-25','09:05:00',2.81),('15087','2013-06-25','09:10:00',2.89),('15087','2013-06-25','09:15:00',2.99),('15087','2013-06-25','09:20:00',3.05),('15087','2013-06-25','09:25:00',3.12),('15087','2013-06-25','09:30:00',3.25),('15087','2013-06-25','09:35:00',3.44),('15087','2013-06-25','09:40:00',3.54),('15087','2013-06-25','09:45:00',2.62),('15087','2013-06-25','09:50:00',2.4),('15087','2013-06-25','09:55:00',1.8),('15087','2013-06-25','10:00:00',4.13),('15087','2013-06-25','10:05:00',4.16),('15087','2013-06-25','10:10:00',4.28),('15087','2013-06-25','10:15:00',4.29),('15087','2013-06-25','10:20:00',1.8),('15087','2013-06-25','10:25:00',1.01),('15087','2013-06-25','10:30:00',4.31),('15087','2013-06-25','10:35:00',4.42),('15087','2013-06-25','10:40:00',4.39),('15087','2013-06-25','10:45:00',3.47),('15087','2013-06-25','10:50:00',1.59),('15087','2013-06-25','10:55:00',3.43),('15087','2013-06-25','11:00:00',2.17),('15087','2013-06-25','11:05:00',3.18),('15087','2013-06-25','11:10:00',1.85),('15087','2013-06-25','11:15:00',2.09),('15087','2013-06-25','11:20:00',1.06),('15087','2013-06-25','11:25:00',1.1),('15087','2013-06-25','11:30:00',1.12),('15087','2013-06-25','11:35:00',3.77),('15087','2013-06-25','11:40:00',5.4),('15087','2013-06-25','11:45:00',5.06),('15087','2013-06-25','11:50:00',5),('15087','2013-06-25','11:55:00',2.04),('15087','2013-06-25','12:00:00',1.14),('15087','2013-06-25','12:05:00',1.05),('15087','2013-06-25','12:10:00',1.17),('15087','2013-06-25','12:15:00',1.16),('15087','2013-06-25','12:20:00',1.28),('15087','2013-06-25','12:25:00',1.28),('15087','2013-06-25','12:30:00',1.37),('15087','2013-06-25','12:35:00',3.26),('15087','2013-06-25','12:40:00',3.16),('15087','2013-06-25','12:45:00',5.44),('15087','2013-06-25','12:50:00',1.84),('15087','2013-06-25','12:55:00',2.01),('15087','2013-06-25','13:00:00',4.68),('15087','2013-06-25','13:05:00',4.63),('15087','2013-06-25','13:10:00',3.08),('15087','2013-06-25','13:15:00',4.43),('15087','2013-06-25','13:20:00',4.54),('15087','2013-06-25','13:25:00',4.57),('15087','2013-06-25','13:30:00',4.26),('15087','2013-06-25','13:35:00',4.3),('15087','2013-06-25','13:40:00',5.12),('15087','2013-06-25','13:45:00',4.49),('15087','2013-06-25','13:50:00',4.12),('15087','2013-06-25','13:55:00',4.42),('15087','2013-06-25','14:00:00',4.23),('15087','2013-06-25','14:05:00',4.85),('15087','2013-06-25','14:10:00',4.84),('15087','2013-06-25','14:15:00',4.86),('15087','2013-06-25','14:20:00',4.74),('15087','2013-06-25','14:25:00',4.63),('15087','2013-06-25','14:30:00',4.57),('15087','2013-06-25','14:35:00',4.55),('15087','2013-06-25','14:40:00',4.36),('15087','2013-06-25','14:45:00',4.52),('15087','2013-06-25','14:50:00',4.3),('15087','2013-06-25','14:55:00',4.35),('15087','2013-06-25','15:00:00',4.32),('15087','2013-06-25','15:05:00',4.29),('15087','2013-06-25','15:10:00',4.21),('15087','2013-06-25','15:15:00',4.06),('15087','2013-06-25','15:20:00',4.08),('15087','2013-06-25','15:25:00',4.01),('15087','2013-06-25','15:30:00',3.92),('15087','2013-06-25','15:35:00',3.79),('15087','2013-06-25','15:40:00',3.81),('15087','2013-06-25','15:45:00',3.72),('15087','2013-06-25','15:50:00',3.66),('15087','2013-06-25','15:55:00',3.58),('15087','2013-06-25','16:00:00',3.61),('15087','2013-06-25','16:05:00',3.56),('15087','2013-06-25','16:10:00',3.49),('15087','2013-06-25','16:15:00',3.48),('15087','2013-06-25','16:20:00',3.4),('15087','2013-06-25','16:25:00',3.35),('15087','2013-06-25','16:30:00',3.31),('15087','2013-06-25','16:35:00',3.16),('15087','2013-06-25','16:40:00',3.12),('15087','2013-06-25','16:45:00',3.04),('15087','2013-06-25','16:50:00',3.03),('15087','2013-06-25','16:55:00',2.97),('15087','2013-06-25','17:00:00',2.88),('15087','2013-06-25','17:05:00',2.76),('15087','2013-06-25','17:10:00',2.67),('15087','2013-06-25','17:15:00',2.62),('15087','2013-06-25','17:20:00',2.59),('15087','2013-06-25','17:25:00',2.5),('15087','2013-06-25','17:30:00',2.38),('15087','2013-06-25','17:35:00',2.22),('15087','2013-06-25','17:40:00',2.11),('15087','2013-06-25','17:45:00',1.99),('15087','2013-06-25','17:50:00',1.82),('15087','2013-06-25','17:55:00',1.73),('15087','2013-06-25','18:00:00',1.54),('15087','2013-06-25','18:05:00',1.44),('15087','2013-06-25','18:10:00',1.4),('15087','2013-06-25','18:15:00',1.35),('15087','2013-06-25','18:20:00',1.29),('15087','2013-06-25','18:25:00',1.19),('15087','2013-06-25','18:30:00',1.11),('15087','2013-06-25','18:35:00',1.04),('15087','2013-06-24','08:40:00',2.06),('15087','2013-06-24','08:45:00',2.7),('15087','2013-06-24','08:50:00',2.76),('15087','2013-06-24','08:55:00',2.62),('15087','2013-06-24','09:00:00',2.47),('15087','2013-06-24','09:05:00',2.2),('15087','2013-06-24','09:10:00',1.88),('15087','2013-06-24','09:15:00',2.59),('15087','2013-06-24','09:20:00',2.96),('15087','2013-06-24','09:25:00',3.89),('15087','2013-06-24','09:30:00',2.68),('15087','2013-06-24','09:35:00',3.01),('15087','2013-06-24','09:40:00',3.55),('15087','2013-06-24','09:45:00',3.55),('15087','2013-06-24','09:50:00',3.82),('15087','2013-06-24','09:55:00',3.75),('15087','2013-06-24','10:00:00',3.77),('15087','2013-06-24','10:05:00',3.88),('15087','2013-06-24','10:10:00',4.11),('15087','2013-06-24','10:15:00',3.63),('15087','2013-06-24','10:20:00',4.29),('15087','2013-06-24','10:25:00',4.62),('15087','2013-06-24','10:30:00',4.15),('15087','2013-06-24','10:35:00',4.18),('15087','2013-06-24','10:40:00',1.51),('15087','2013-06-24','10:45:00',2.11),('15087','2013-06-24','10:50:00',4.58),('15087','2013-06-24','10:55:00',3.17),('15087','2013-06-24','11:00:00',4.07),('15087','2013-06-24','11:05:00',4.34),('15087','2013-06-24','11:10:00',1.35),('15087','2013-06-24','11:15:00',4.45),('15087','2013-06-24','11:20:00',3.63),('15087','2013-06-24','11:25:00',1.75),('15087','2013-06-24','11:30:00',2.36),('15087','2013-06-24','11:35:00',1.44),('15087','2013-06-24','11:40:00',1.31),('15087','2013-06-24','11:45:00',2.74),('15087','2013-06-24','11:50:00',2),('15087','2013-06-24','11:55:00',4.84),('15087','2013-06-24','12:00:00',2.86),('15087','2013-06-24','12:05:00',3.66),('15087','2013-06-24','12:10:00',4.97),('15087','2013-06-24','12:15:00',2.45),('15087','2013-06-24','12:20:00',5.47),('15087','2013-06-24','12:25:00',4.13),('15087','2013-06-24','12:30:00',3.18),('15087','2013-06-24','12:35:00',5.58),('15087','2013-06-24','12:40:00',3.9),('15087','2013-06-24','12:45:00',4.09),('15087','2013-06-24','12:50:00',4.57),('15087','2013-06-24','12:55:00',5.17),('15087','2013-06-24','13:00:00',4.53),('15087','2013-06-24','13:05:00',5.59),('15087','2013-06-24','13:10:00',3.67),('15087','2013-06-24','13:15:00',3.08),('15087','2013-06-24','13:20:00',2.16),('15087','2013-06-24','13:25:00',4.03),('15087','2013-06-24','13:30:00',4.99),('15087','2013-06-24','13:35:00',3.62),('15087','2013-06-24','13:40:00',4.68),('15087','2013-06-24','13:45:00',5.08),('15087','2013-06-24','13:50:00',4.98),('15087','2013-06-24','13:55:00',4.95),('15087','2013-06-24','14:00:00',4.21),('15087','2013-06-24','14:05:00',4.88),('15087','2013-06-24','14:10:00',4.87),('15087','2013-06-24','14:15:00',4.82),('15087','2013-06-24','14:20:00',4.77),('15087','2013-06-24','14:25:00',4.83),('15087','2013-06-24','14:30:00',4.83),('15087','2013-06-24','14:35:00',4.82),('15087','2013-06-24','14:40:00',4.81),('15087','2013-06-24','14:45:00',4.82),('15087','2013-06-24','14:50:00',4.17),('15087','2013-06-24','14:55:00',3.05),('15087','2013-06-24','15:00:00',4.04),('15087','2013-06-24','15:05:00',2.41),('15087','2013-06-24','15:10:00',3.99),('15087','2013-06-24','15:15:00',4),('15087','2013-06-24','15:20:00',3.52),('15087','2013-06-24','15:25:00',3.21),('15087','2013-06-24','15:30:00',3.58),('15087','2013-06-24','15:35:00',1.9),('15087','2013-06-24','15:40:00',3.05),('15087','2013-06-24','15:45:00',2.98),('15087','2013-06-24','15:50:00',3.5),('15087','2013-06-24','15:55:00',3.81),('15087','2013-06-24','16:00:00',4.23),('15087','2013-06-24','16:05:00',3.93),('15087','2013-06-24','16:10:00',2.71),('15087','2013-06-24','16:15:00',4.02),('15087','2013-06-24','16:20:00',2.5),('15087','2013-06-24','16:25:00',3.04),('15087','2013-06-24','16:30:00',3.85),('15087','2013-06-24','16:35:00',3.11),('15087','2013-06-24','16:40:00',2.43),('15087','2013-06-24','16:45:00',2.15),('15087','2013-06-24','16:50:00',2.13),('15087','2013-06-24','16:55:00',1.32),('15087','2013-06-24','17:00:00',1.48),('15087','2013-06-24','17:05:00',2.69),('15087','2013-06-24','17:10:00',2.88),('15087','2013-06-24','17:15:00',3.07),('15087','2013-06-24','17:20:00',1.99),('15087','2013-06-24','17:25:00',2.66),('15087','2013-06-24','17:30:00',1.7),('15087','2013-06-24','17:50:00',1.6),('15087','2013-06-24','17:55:00',1.34),('15087','2013-06-24','18:00:00',2.09),('15087','2013-06-24','18:05:00',1.62),('15087','2013-06-24','18:10:00',1.47),('15087','2013-06-24','18:15:00',1.57),('15087','2013-06-24','18:20:00',1.42),('15087','2013-06-24','18:25:00',1.39),('15087','2013-06-24','18:30:00',1.04),('15087','2013-06-24','18:35:00',1.19),('15087','2013-06-24','18:45:00',1.07),('15087','2013-06-23','08:45:00',1.08),('15087','2013-06-23','08:50:00',1.58),('15087','2013-06-23','08:55:00',1.13),('15087','2013-06-23','09:00:00',2.03),('15087','2013-06-23','09:05:00',1.42),('15087','2013-06-23','09:20:00',1.9),('15087','2013-06-23','09:25:00',3.01),('15087','2013-06-23','09:30:00',3.21),('15087','2013-06-23','09:35:00',3.32),('15087','2013-06-23','09:40:00',3.88),('15087','2013-06-23','09:45:00',2.11),('15087','2013-06-23','09:50:00',1.13),('15087','2013-06-23','09:55:00',1.91),('15087','2013-06-23','10:00:00',3.68),('15087','2013-06-23','10:05:00',3.21),('15087','2013-06-23','10:10:00',1.62),('15087','2013-06-23','10:15:00',3.46),('15087','2013-06-23','10:20:00',1.35),('15087','2013-06-23','10:25:00',2.34),('15087','2013-06-23','10:30:00',2.92),('15087','2013-06-23','10:35:00',1.76),('15087','2013-06-23','10:40:00',3.88),('15087','2013-06-23','10:45:00',3.97),('15087','2013-06-23','10:50:00',3.99),('15087','2013-06-23','10:55:00',4.01),('15087','2013-06-23','11:00:00',4.07),('15087','2013-06-23','11:05:00',4.14),('15087','2013-06-23','11:10:00',4.17),('15087','2013-06-23','11:15:00',3.19),('15087','2013-06-23','11:20:00',4.25),('15087','2013-06-23','11:25:00',4.32),('15087','2013-06-23','11:30:00',4.18),('15087','2013-06-23','11:35:00',4.25),('15087','2013-06-23','11:40:00',4.27),('15087','2013-06-23','11:45:00',4.4),('15087','2013-06-23','11:50:00',4.28),('15087','2013-06-23','11:55:00',4.4),('15087','2013-06-23','12:00:00',4.55),('15087','2013-06-23','12:05:00',4.58),('15087','2013-06-23','12:10:00',4.61),('15087','2013-06-23','12:15:00',4.59),('15087','2013-06-23','12:20:00',4.59),('15087','2013-06-23','12:25:00',4.68),('15087','2013-06-23','12:30:00',4.65),('15087','2013-06-23','12:35:00',4.66),('15087','2013-06-23','12:40:00',4.68),('15087','2013-06-23','12:45:00',4.68),('15087','2013-06-23','12:50:00',4.69),('15087','2013-06-23','12:55:00',4.68),('15087','2013-06-23','13:00:00',4.68),('15087','2013-06-23','13:05:00',4.69),('15087','2013-06-23','13:10:00',4.7),('15087','2013-06-23','13:15:00',4.68),('15087','2013-06-23','13:20:00',4.67),('15087','2013-06-23','13:25:00',4.69),('15087','2013-06-23','13:30:00',4.71),('15087','2013-06-23','13:35:00',4.74),('15087','2013-06-23','13:40:00',4.7),('15087','2013-06-23','13:45:00',4.7),('15087','2013-06-23','13:50:00',4.7),('15087','2013-06-23','13:55:00',4.68),('15087','2013-06-23','14:00:00',4.65),('15087','2013-06-23','14:05:00',4.62),('15087','2013-06-23','14:10:00',4.56),('15087','2013-06-23','14:15:00',4.53),('15087','2013-06-23','14:20:00',4.59),('15087','2013-06-23','14:25:00',4.59),('15087','2013-06-23','14:30:00',4.54),('15087','2013-06-23','14:35:00',4.53),('15087','2013-06-23','14:40:00',4.52),('15087','2013-06-23','14:45:00',4.43),('15087','2013-06-23','14:50:00',4.19),('15087','2013-06-23','14:55:00',4.24),('15087','2013-06-23','15:00:00',4.34),('15087','2013-06-23','15:05:00',4.26),('15087','2013-06-23','15:10:00',4.17),('15087','2013-06-23','15:15:00',4.05),('15087','2013-06-23','15:20:00',4.11),('15087','2013-06-23','15:25:00',4.02),('15087','2013-06-23','15:30:00',3.91),('15087','2013-06-23','15:35:00',3.86),('15087','2013-06-23','15:40:00',3.79),('15087','2013-06-23','15:45:00',3.76),('15087','2013-06-23','15:50:00',3.74),('15087','2013-06-23','15:55:00',3.67),('15087','2013-06-23','16:00:00',3.63),('15087','2013-06-23','16:05:00',3.55),('15087','2013-06-23','16:10:00',3.42),('15087','2013-06-23','16:15:00',3.46),('15087','2013-06-23','16:20:00',3.36),('15087','2013-06-23','16:25:00',3.24),('15087','2013-06-23','16:30:00',3.24),('15087','2013-06-23','16:35:00',3.17),('15087','2013-06-23','16:40:00',3.13),('15087','2013-06-23','16:45:00',3.08),('15087','2013-06-23','16:50:00',3.06),('15087','2013-06-23','16:55:00',2.98),('15087','2013-06-23','17:00:00',2.87),('15087','2013-06-23','17:05:00',2.74),('15087','2013-06-23','17:10:00',2.72),('15087','2013-06-23','17:15:00',2.66),('15087','2013-06-23','17:20:00',2.41),('15087','2013-06-23','17:25:00',2.52),('15087','2013-06-23','17:30:00',2.39),('15087','2013-06-23','17:35:00',2.24),('15087','2013-06-23','17:40:00',2.16),('15087','2013-06-23','17:45:00',2.03),('15087','2013-06-23','17:50:00',1.92),('15087','2013-06-23','17:55:00',1.75),('15087','2013-06-23','18:00:00',1.7),('15087','2013-06-23','18:05:00',1.6),('15087','2013-06-23','18:10:00',1.4),('15087','2013-06-23','18:15:00',1.28),('15087','2013-06-23','18:20:00',1.31),('15087','2013-06-23','18:25:00',1.18),('15087','2013-06-23','18:30:00',1.13),('15087','2013-06-23','18:35:00',1.03),('15087','2013-06-22','07:35:00',1.07),('15087','2013-06-22','07:40:00',1.14),('15087','2013-06-22','07:45:00',1.23),('15087','2013-06-22','07:50:00',1.32),('15087','2013-06-22','07:55:00',1.39),('15087','2013-06-22','08:00:00',1.47),('15087','2013-06-22','08:05:00',1.55),('15087','2013-06-22','08:10:00',1.62),('15087','2013-06-22','08:15:00',1.71),('15087','2013-06-22','08:20:00',1.82),('15087','2013-06-22','08:25:00',1.91),('15087','2013-06-22','08:30:00',2),('15087','2013-06-22','08:35:00',2.1),('15087','2013-06-22','08:40:00',2.18),('15087','2013-06-22','08:45:00',2.26),('15087','2013-06-22','08:50:00',2.44),('15087','2013-06-22','08:55:00',2.53),('15087','2013-06-22','09:00:00',2.58),('15087','2013-06-22','09:05:00',2.65),('15087','2013-06-22','09:10:00',2.73),('15087','2013-06-22','09:15:00',2.8),('15087','2013-06-22','09:20:00',2.86),('15087','2013-06-22','09:25:00',2.92),('15087','2013-06-22','09:30:00',3),('15087','2013-06-22','09:35:00',3.07),('15087','2013-06-22','09:40:00',3.13),('15087','2013-06-22','09:45:00',3.17),('15087','2013-06-22','09:50:00',3.27),('15087','2013-06-22','09:55:00',3.36),('15087','2013-06-22','10:00:00',3.4),('15087','2013-06-22','10:05:00',3.49),('15087','2013-06-22','10:10:00',3.53),('15087','2013-06-22','10:15:00',3.61),('15087','2013-06-22','10:20:00',3.69),('15087','2013-06-22','10:25:00',3.71),('15087','2013-06-22','10:30:00',3.7),('15087','2013-06-22','10:35:00',3.78),('15087','2013-06-22','10:40:00',3.86),('15087','2013-06-22','10:45:00',3.92),('15087','2013-06-22','10:50:00',3.98),('15087','2013-06-22','10:55:00',4),('15087','2013-06-22','11:00:00',4.05),('15087','2013-06-22','11:05:00',4.1),('15087','2013-06-22','11:10:00',4.15),('15087','2013-06-22','11:15:00',4.16),('15087','2013-06-22','11:20:00',4.21),('15087','2013-06-22','11:25:00',4.24),('15087','2013-06-22','11:30:00',4.31),('15087','2013-06-22','11:35:00',4.35),('15087','2013-06-22','11:40:00',4.35),('15087','2013-06-22','11:45:00',4.37),('15087','2013-06-22','11:50:00',4.34),('15087','2013-06-22','11:55:00',4.37),('15087','2013-06-22','12:00:00',4.42),('15087','2013-06-22','12:05:00',4.35),('15087','2013-06-22','12:10:00',4.29),('15087','2013-06-22','12:15:00',4.47),('15087','2013-06-22','12:20:00',4.41),('15087','2013-06-22','12:25:00',4.47),('15087','2013-06-22','12:30:00',4.49),('15087','2013-06-22','12:35:00',4.51),('15087','2013-06-22','12:40:00',4.55),('15087','2013-06-22','12:45:00',4.49),('15087','2013-06-22','12:50:00',4.42),('15087','2013-06-22','12:55:00',4.4),('15087','2013-06-22','13:00:00',4.35),('15087','2013-06-22','13:05:00',4.39),('15087','2013-06-22','13:10:00',4.4),('15087','2013-06-22','13:15:00',4.31),('15087','2013-06-22','13:20:00',4.23),('15087','2013-06-22','13:25:00',4.55),('15087','2013-06-22','13:30:00',4.74),('15087','2013-06-22','13:35:00',4.77),('15087','2013-06-22','13:40:00',4.22),('15087','2013-06-22','13:45:00',4.58),('15087','2013-06-22','13:50:00',4.62),('15087','2013-06-22','13:55:00',3.22),('15087','2013-06-22','14:00:00',3.04),('15087','2013-06-22','14:05:00',5.03),('15087','2013-06-22','14:10:00',4.82),('15087','2013-06-22','14:15:00',4.75),('15087','2013-06-22','14:20:00',3.96),('15087','2013-06-22','14:25:00',4.62),('15087','2013-06-22','14:30:00',3.29),('15087','2013-06-22','14:35:00',2.5),('15087','2013-06-22','14:40:00',1.78),('15087','2013-06-22','14:45:00',2.46),('15087','2013-06-22','14:50:00',3.94),('15087','2013-06-22','14:55:00',4.33),('15087','2013-06-22','15:00:00',4.27),('15087','2013-06-22','15:05:00',3.3),('15087','2013-06-22','15:10:00',4.27),('15087','2013-06-22','15:15:00',4.16),('15087','2013-06-22','15:20:00',3.77),('15087','2013-06-22','15:25:00',3.54),('15087','2013-06-22','15:30:00',2.57),('15087','2013-06-22','15:35:00',1.93),('15087','2013-06-22','15:40:00',2.41),('15087','2013-06-22','15:45:00',3.05),('15087','2013-06-22','15:50:00',2.73),('15087','2013-06-22','15:55:00',2.74),('15087','2013-06-22','16:00:00',1.93),('15087','2013-06-22','16:05:00',1.28),('15087','2013-06-22','16:10:00',1.32),('15087','2013-06-22','16:15:00',1.68),('15087','2013-06-22','16:20:00',1.9),('15087','2013-06-22','16:25:00',1.33),('15087','2013-06-22','16:30:00',1.07),('15087','2013-06-22','16:55:00',1.3),('15087','2013-06-22','17:00:00',1.6),('15087','2013-06-22','17:05:00',1.53),('15087','2013-06-22','17:10:00',2.25),('15087','2013-06-22','17:15:00',3.21),('15087','2013-06-22','17:20:00',3.02),('15087','2013-06-22','17:25:00',3.03),('15087','2013-06-22','17:30:00',2.39),('15087','2013-06-22','17:35:00',1.96),('15087','2013-06-22','17:40:00',2.29),('15087','2013-06-22','17:45:00',2.19),('15087','2013-06-22','17:50:00',1.93),('15087','2013-06-22','17:55:00',1.89),('15087','2013-06-22','18:00:00',1.66),('15087','2013-06-22','18:05:00',1.34),('15087','2013-06-21','07:35:00',1.06),('15087','2013-06-21','07:40:00',1.14),('15087','2013-06-21','07:45:00',1.23),('15087','2013-06-21','07:50:00',1.31),('15087','2013-06-21','07:55:00',1.4),('15087','2013-06-21','08:00:00',1.48),('15087','2013-06-21','08:05:00',1.57),('15087','2013-06-21','08:10:00',1.65),('15087','2013-06-21','08:15:00',1.72),('15087','2013-06-21','08:20:00',1.79),('15087','2013-06-21','08:25:00',1.88),('15087','2013-06-21','08:30:00',1.98),('15087','2013-06-21','08:35:00',2.06),('15087','2013-06-21','08:40:00',2.14),('15087','2013-06-21','08:45:00',2.28),('15087','2013-06-21','08:50:00',2.36),('15087','2013-06-21','08:55:00',2.42),('15087','2013-06-21','09:00:00',2.52),('15087','2013-06-21','09:05:00',2.56),('15087','2013-06-21','09:10:00',2.6),('15087','2013-06-21','09:15:00',2.66),('15087','2013-06-21','09:20:00',2.68),('15087','2013-06-21','09:25:00',2.82),('15087','2013-06-21','09:30:00',2.89),('15087','2013-06-21','09:35:00',2.91),('15087','2013-06-21','09:40:00',2.97),('15087','2013-06-21','09:45:00',3.06),('15087','2013-06-21','09:50:00',3.11),('15087','2013-06-21','09:55:00',3.16),('15087','2013-06-21','10:00:00',3.21),('15087','2013-06-21','10:05:00',3.26),('15087','2013-06-21','10:10:00',3.32),('15087','2013-06-21','10:15:00',3.39),('15087','2013-06-21','10:20:00',3.4),('15087','2013-06-21','10:25:00',3.45),('15087','2013-06-21','10:30:00',3.49),('15087','2013-06-21','10:35:00',3.54),('15087','2013-06-21','10:40:00',3.59),('15087','2013-06-21','10:45:00',3.67),('15087','2013-06-21','10:50:00',3.67),('15087','2013-06-21','10:55:00',3.66),('15087','2013-06-21','11:00:00',3.72),('15087','2013-06-21','11:05:00',3.76),('15087','2013-06-21','11:10:00',3.8),('15087','2013-06-21','11:15:00',3.87),('15087','2013-06-21','11:20:00',3.93),('15087','2013-06-21','11:25:00',3.99),('15087','2013-06-21','11:30:00',4.03),('15087','2013-06-21','11:35:00',4.01),('15087','2013-06-21','11:40:00',4.03),('15087','2013-06-21','11:45:00',4.06),('15087','2013-06-21','11:50:00',4.1),('15087','2013-06-21','11:55:00',4.15),('15087','2013-06-21','12:00:00',4.14),('15087','2013-06-21','12:05:00',4.15),('15087','2013-06-21','12:10:00',4.2),('15087','2013-06-21','12:15:00',4.17),('15087','2013-06-21','12:20:00',4.19),('15087','2013-06-21','12:25:00',4.15),('15087','2013-06-21','12:30:00',4.16),('15087','2013-06-21','12:35:00',4.15),('15087','2013-06-21','12:40:00',4.21),('15087','2013-06-21','12:45:00',4.25),('15087','2013-06-21','12:50:00',4.21),('15087','2013-06-21','12:55:00',4.19),('15087','2013-06-21','13:00:00',4.19),('15087','2013-06-21','13:05:00',4.18),('15087','2013-06-21','13:10:00',4.17),('15087','2013-06-21','13:15:00',4.22),('15087','2013-06-21','13:20:00',4.28),('15087','2013-06-21','13:25:00',4.32),('15087','2013-06-21','13:30:00',4.37),('15087','2013-06-21','13:35:00',4.3),('15087','2013-06-21','13:40:00',4.3),('15087','2013-06-21','13:45:00',4.32),('15087','2013-06-21','13:50:00',4.27),('15087','2013-06-21','13:55:00',4.3),('15087','2013-06-21','14:00:00',4.35),('15087','2013-06-21','14:05:00',4.34),('15087','2013-06-21','14:10:00',4.33),('15087','2013-06-21','14:15:00',4.31),('15087','2013-06-21','14:20:00',4.3),('15087','2013-06-21','14:25:00',4.38),('15087','2013-06-21','14:30:00',4.34),('15087','2013-06-21','14:35:00',4.3),('15087','2013-06-21','14:40:00',4.29),('15087','2013-06-21','14:45:00',4.21),('15087','2013-06-21','14:50:00',4.09),('15087','2013-06-21','14:55:00',4.12),('15087','2013-06-21','15:00:00',4.1),('15087','2013-06-21','15:05:00',4.03),('15087','2013-06-21','15:10:00',3.96),('15087','2013-06-21','15:15:00',3.69),('15087','2013-06-21','15:20:00',3.6),('15087','2013-06-21','15:25:00',3.85),('15087','2013-06-21','15:30:00',3.77),('15087','2013-06-21','15:35:00',3.7),('15087','2013-06-21','15:40:00',3.69),('15087','2013-06-21','15:45:00',3.64),('15087','2013-06-21','15:50:00',3.56),('15087','2013-06-21','15:55:00',3.54),('15087','2013-06-21','16:00:00',3.52),('15087','2013-06-21','16:05:00',3.46),('15087','2013-06-21','16:10:00',3.4),('15087','2013-06-21','16:15:00',3.38),('15087','2013-06-21','16:20:00',3.32),('15087','2013-06-21','16:25:00',3.29),('15087','2013-06-21','16:30:00',3.22),('15087','2013-06-21','16:35:00',3.07),('15087','2013-06-21','16:40:00',3.02),('15087','2013-06-21','16:45:00',2.98),('15087','2013-06-21','16:50:00',2.98),('15087','2013-06-21','16:55:00',2.91),('15087','2013-06-21','17:00:00',2.81),('15087','2013-06-21','17:05:00',2.7),('15087','2013-06-21','17:10:00',2.61),('15087','2013-06-21','17:15:00',2.53),('15087','2013-06-21','17:20:00',2.43),('15087','2013-06-21','17:25:00',2.34),('15087','2013-06-21','17:30:00',2.2),('15087','2013-06-21','17:35:00',2.06),('15087','2013-06-21','17:40:00',2.01),('15087','2013-06-21','17:45:00',1.88),('15087','2013-06-21','17:50:00',1.74),('15087','2013-06-21','17:55:00',1.66),('15087','2013-06-21','18:00:00',1.58),('15087','2013-06-21','18:05:00',1.41),('15087','2013-06-21','18:10:00',1.38),('15087','2013-06-21','18:15:00',1.3),('15087','2013-06-21','18:20:00',1.22),('15087','2013-06-21','18:25:00',1.11),('15087','2013-06-21','18:30:00',1.06),('15087','2014-04-04','09:00:00',1.01),('15087','2014-04-04','09:05:00',1.69),('15087','2014-04-04','09:10:00',2.19),('15087','2014-04-04','09:15:00',2.12),('15087','2014-04-04','09:20:00',1.35),('15087','2014-04-04','13:10:00',1.27),('15087','2014-04-04','13:20:00',2.03),('15087','2014-04-04','13:25:00',2.4),('15087','2014-04-04','13:30:00',2.35),('15087','2014-04-04','13:35:00',2.86),('15087','2014-04-04','13:40:00',5.03),('15087','2014-04-04','13:45:00',3.57),('15087','2014-04-04','13:50:00',4.5),('15087','2014-04-04','13:55:00',2.16),('15087','2014-04-04','14:00:00',3.48),('15087','2014-04-04','14:05:00',4.92),('15087','2014-04-04','14:10:00',4.78),('15087','2014-04-04','14:15:00',3.36),('15087','2014-04-04','14:20:00',3.44),('15087','2014-04-04','14:25:00',3.46),('15087','2014-04-04','14:30:00',1.33),('15087','2014-04-04','14:35:00',2.37),('15087','2014-04-04','14:40:00',1.43),('15087','2014-04-04','14:45:00',1.52),('15087','2014-04-04','14:50:00',3.05),('15087','2014-04-04','14:55:00',3.97),('15087','2014-04-04','15:00:00',4.05),('15087','2014-04-04','15:05:00',3.72),('15087','2014-04-04','15:10:00',3.51),('15087','2014-04-04','15:15:00',3.24),('15087','2014-04-04','15:20:00',2.16),('15087','2014-04-04','15:25:00',2.05),('15087','2014-04-04','15:30:00',1.54),('15087','2014-04-04','15:35:00',1.46),('15087','2014-04-04','15:40:00',2.4),('15087','2014-04-04','15:45:00',1.88),('15087','2014-04-04','15:50:00',1.71),('15087','2014-04-04','15:55:00',3.25),('15087','2014-04-04','16:00:00',3.09),('15087','2014-04-04','16:05:00',2.73),('15087','2014-04-04','16:10:00',3.5),('15087','2014-04-04','16:15:00',1.74),('15087','2014-04-04','16:20:00',1.2),('15087','2014-04-04','16:25:00',1.1),('15087','2014-04-04','16:30:00',2.21),('15087','2014-04-04','16:35:00',1.7),('15087','2014-04-04','16:40:00',1.44),('15087','2014-04-04','16:45:00',2.56),('15087','2014-04-04','16:50:00',2.49),('15087','2014-04-04','16:55:00',2.44),('15087','2014-04-04','17:00:00',2.12),('15087','2014-04-04','17:05:00',1.89),('15087','2014-04-04','17:10:00',1.7),('15087','2014-04-04','17:15:00',1.64),('15087','2014-04-04','17:20:00',1.98),('15087','2014-04-04','17:25:00',1.62),('15087','2014-04-04','17:30:00',2.13),('15087','2014-04-04','17:35:00',1.62),('15087','2014-04-04','17:40:00',1.24),('15087','2014-04-04','17:45:00',1.4),('15087','2014-04-04','17:50:00',1.31),('15087','2014-04-04','17:55:00',1.09),('15087','2013-06-20','07:35:00',1.03),('15087','2013-06-20','07:40:00',1.08),('15087','2013-06-20','07:45:00',1.18),('15087','2013-06-20','07:50:00',1.26),('15087','2013-06-20','07:55:00',1.34),('15087','2013-06-20','08:00:00',1.44),('15087','2013-06-20','08:05:00',1.54),('15087','2013-06-20','08:10:00',1.63),('15087','2013-06-20','08:15:00',1.72),('15087','2013-06-20','08:20:00',1.8),('15087','2013-06-20','08:25:00',1.89),('15087','2013-06-20','08:30:00',2.01),('15087','2013-06-20','08:35:00',2.07),('15087','2013-06-20','08:40:00',2.17),('15087','2013-06-20','08:45:00',2.26),('15087','2013-06-20','08:50:00',2.41),('15087','2013-06-20','08:55:00',2.49),('15087','2013-06-20','09:00:00',2.55),('15087','2013-06-20','09:05:00',2.63),('15087','2013-06-20','09:10:00',2.7),('15087','2013-06-20','09:15:00',2.76),('15087','2013-06-20','09:20:00',2.82),('15087','2013-06-20','09:25:00',2.89),('15087','2013-06-20','09:30:00',2.94),('15087','2013-06-20','09:35:00',3.03),('15087','2013-06-20','09:40:00',3.08),('15087','2013-06-20','09:45:00',3.13),('15087','2013-06-20','09:50:00',3.2),('15087','2013-06-20','09:55:00',3.28),('15087','2013-06-20','10:00:00',3.35),('15087','2013-06-20','10:05:00',3.4),('15087','2013-06-20','10:10:00',3.48),('15087','2013-06-20','10:15:00',3.49),('15087','2013-06-20','10:20:00',3.55),('15087','2013-06-20','10:25:00',3.62),('15087','2013-06-20','10:30:00',3.66),('15087','2013-06-20','10:35:00',3.74),('15087','2013-06-20','10:40:00',3.75),('15087','2013-06-20','10:45:00',3.76),('15087','2013-06-20','10:50:00',3.76),('15087','2013-06-20','10:55:00',3.84),('15087','2013-06-20','11:00:00',3.89),('15087','2013-06-20','11:05:00',3.92),('15087','2013-06-20','11:10:00',3.95),('15087','2013-06-20','11:15:00',3.94),('15087','2013-06-20','11:20:00',3.91),('15087','2013-06-20','11:25:00',3.92),('15087','2013-06-20','11:30:00',3.97),('15087','2013-06-20','11:35:00',4.09),('15087','2013-06-20','11:40:00',4.16),('15087','2013-06-20','11:45:00',4.13),('15087','2013-06-20','11:50:00',3.93),('15087','2013-06-20','11:55:00',4.04),('15087','2013-06-20','12:00:00',3.94),('15087','2013-06-20','12:05:00',4.05),('15087','2013-06-20','12:10:00',3.6),('15087','2013-06-20','12:15:00',3.95),('15087','2013-06-20','12:20:00',3.26),('15087','2013-06-20','12:25:00',4.2),('15087','2013-06-20','12:30:00',4.34),('15087','2013-06-20','12:35:00',4.33),('15087','2013-06-20','12:40:00',4.21),('15087','2013-06-20','12:45:00',3.87),('15087','2013-06-20','12:50:00',4.15),('15087','2013-06-20','12:55:00',4.35),('15087','2013-06-20','13:00:00',4.48),('15087','2013-06-20','13:05:00',4.45),('15087','2013-06-20','13:10:00',4.26),('15087','2013-06-20','13:15:00',2.03),('15087','2013-06-20','13:20:00',4.34),('15087','2013-06-20','13:25:00',4.31),('15087','2013-06-20','13:30:00',4.15),('15087','2013-06-20','13:35:00',4.42),('15087','2013-06-20','13:40:00',4.41),('15087','2013-06-20','13:45:00',4.45),('15087','2013-06-20','13:50:00',4.46),('15087','2013-06-20','13:55:00',4.42),('15087','2013-06-20','14:00:00',4.48),('15087','2013-06-20','14:05:00',4.46),('15087','2013-06-20','14:10:00',4.45),('15087','2013-06-20','14:15:00',4.48),('15087','2013-06-20','14:20:00',4.51),('15087','2013-06-20','14:25:00',4.46),('15087','2013-06-20','14:30:00',4.48),('15087','2013-06-20','14:35:00',4.44),('15087','2013-06-20','14:40:00',4.43),('15087','2013-06-20','14:45:00',4.34),('15087','2013-06-20','14:50:00',4.25),('15087','2013-06-20','14:55:00',4.25),('15087','2013-06-20','15:00:00',4.21),('15087','2013-06-20','15:05:00',4.11),('15087','2013-06-20','15:10:00',4.04),('15087','2013-06-20','15:15:00',4.03),('15087','2013-06-20','15:20:00',3.99),('15087','2013-06-20','15:25:00',3.94),('15087','2013-06-20','15:30:00',3.83),('15087','2013-06-20','15:35:00',3.77),('15087','2013-06-20','15:40:00',3.77),('15087','2013-06-20','15:45:00',3.7),('15087','2013-06-20','15:50:00',3.65),('15087','2013-06-20','15:55:00',3.59),('15087','2013-06-20','16:00:00',3.58),('15087','2013-06-20','16:05:00',3.54),('15087','2013-06-20','16:10:00',3.47),('15087','2013-06-20','16:15:00',3.47),('15087','2013-06-20','16:20:00',3.34),('15087','2013-06-20','16:25:00',3.32),('15087','2013-06-20','16:30:00',3.25),('15087','2013-06-20','16:35:00',3.11),('15087','2013-06-20','16:40:00',3.04),('15087','2013-06-20','16:45:00',2.98),('15087','2013-06-20','16:50:00',2.99),('15087','2013-06-20','16:55:00',2.91),('15087','2013-06-20','17:00:00',2.79),('15087','2013-06-20','17:05:00',2.71),('15087','2013-06-20','17:10:00',2.63),('15087','2013-06-20','17:15:00',2.55),('15087','2013-06-20','17:20:00',2.46),('15087','2013-06-20','17:25:00',2.35),('15087','2013-06-20','17:30:00',2.21),('15087','2013-06-20','17:35:00',2.11),('15087','2013-06-20','17:40:00',2.03),('15087','2013-06-20','17:45:00',1.89),('15087','2013-06-20','17:50:00',1.75),('15087','2013-06-20','17:55:00',1.68),('15087','2013-06-20','18:00:00',1.54),('15087','2013-06-20','18:05:00',1.43),('15087','2013-06-20','18:10:00',1.37),('15087','2013-06-20','18:15:00',1.33),('15087','2013-06-20','18:20:00',1.25),('15087','2013-06-20','18:25:00',1.15),('15087','2013-06-20','18:30:00',1.1),('15087','2013-06-19','07:35:00',1.03),('15087','2013-06-19','07:40:00',1.11),('15087','2013-06-19','07:45:00',1.19),('15087','2013-06-19','07:50:00',1.28),('15087','2013-06-19','07:55:00',1.35),('15087','2013-06-19','08:00:00',1.42),('15087','2013-06-19','08:05:00',1.5),('15087','2013-06-19','08:10:00',1.59),('15087','2013-06-19','08:15:00',1.67),('15087','2013-06-19','08:20:00',1.75),('15087','2013-06-19','08:25:00',1.84),('15087','2013-06-19','08:30:00',1.89),('15087','2013-06-19','08:35:00',2.02),('15087','2013-06-19','08:40:00',2.1),('15087','2013-06-19','08:45:00',2.15),('15087','2013-06-19','08:50:00',2.28),('15087','2013-06-19','08:55:00',2.37),('15087','2013-06-19','09:00:00',2.49),('15087','2013-06-19','09:05:00',2.56),('15087','2013-06-19','09:10:00',2.65),('15087','2013-06-19','09:15:00',2.73),('15087','2013-06-19','09:20:00',2.78),('15087','2013-06-19','09:25:00',2.85),('15087','2013-06-19','09:30:00',2.9),('15087','2013-06-19','09:35:00',2.97),('15087','2013-06-19','09:40:00',3.03),('15087','2013-06-19','09:45:00',3.08),('15087','2013-06-19','09:50:00',3.15),('15087','2013-06-19','09:55:00',3.2),('15087','2013-06-19','10:00:00',3.26),('15087','2013-06-19','10:05:00',3.33),('15087','2013-06-19','10:10:00',3.38),('15087','2013-06-19','10:15:00',3.43),('15087','2013-06-19','10:20:00',3.47),('15087','2013-06-19','10:25:00',3.52),('15087','2013-06-19','10:30:00',3.57),('15087','2013-06-19','10:35:00',3.61),('15087','2013-06-19','10:40:00',3.64),('15087','2013-06-19','10:45:00',3.68),('15087','2013-06-19','10:50:00',3.7),('15087','2013-06-19','10:55:00',3.73),('15087','2013-06-19','11:00:00',3.75),('15087','2013-06-19','11:05:00',3.82),('15087','2013-06-19','11:10:00',3.82),('15087','2013-06-19','11:15:00',3.8),('15087','2013-06-19','11:20:00',3.93),('15087','2013-06-19','11:25:00',3.92),('15087','2013-06-19','11:30:00',3.99),('15087','2013-06-19','11:35:00',3.97),('15087','2013-06-19','11:40:00',3.99),('15087','2013-06-19','11:45:00',4.05),('15087','2013-06-19','11:50:00',4.05),('15087','2013-06-19','11:55:00',4.12),('15087','2013-06-19','12:00:00',4.12),('15087','2013-06-19','12:05:00',4.12),('15087','2013-06-19','12:10:00',4.1),('15087','2013-06-19','12:15:00',4.11),('15087','2013-06-19','12:20:00',4.07),('15087','2013-06-19','12:25:00',4.08),('15087','2013-06-19','12:30:00',4.22),('15087','2013-06-19','12:35:00',4.33),('15087','2013-06-19','12:40:00',4.33),('15087','2013-06-19','12:45:00',4.31),('15087','2013-06-19','12:50:00',4.37),('15087','2013-06-19','12:55:00',4.35),('15087','2013-06-19','13:00:00',4.34),('15087','2013-06-19','13:05:00',4.35),('15087','2013-06-19','13:10:00',4.33),('15087','2013-06-19','13:15:00',4.3),('15087','2013-06-19','13:20:00',4.36),('15087','2013-06-19','13:25:00',4.42),('15087','2013-06-19','13:30:00',4.39),('15087','2013-06-19','13:35:00',4.4),('15087','2013-06-19','13:40:00',4.38),('15087','2013-06-19','13:45:00',4.37),('15087','2013-06-19','13:50:00',4.37),('15087','2013-06-19','13:55:00',4.38),('15087','2013-06-19','14:00:00',4.39),('15087','2013-06-19','14:05:00',4.39),('15087','2013-06-19','14:10:00',4.34),('15087','2013-06-19','14:15:00',4.26),('15087','2013-06-19','14:20:00',4.28),('15087','2013-06-19','14:25:00',4.27),('15087','2013-06-19','14:30:00',4.23),('15087','2013-06-19','14:35:00',4.19),('15087','2013-06-19','14:40:00',4.13),('15087','2013-06-19','14:45:00',4.04),('15087','2013-06-19','14:50:00',3.97),('15087','2013-06-19','14:55:00',4.01),('15087','2013-06-19','15:00:00',3.98),('15087','2013-06-19','15:05:00',3.95),('15087','2013-06-19','15:10:00',3.86),('15087','2013-06-19','15:15:00',3.54),('15087','2013-06-19','15:20:00',3.55),('15087','2013-06-19','15:25:00',3.75),('15087','2013-06-19','15:30:00',3.64),('15087','2013-06-19','15:35:00',3.59),('15087','2013-06-19','15:40:00',3.56),('15087','2013-06-19','15:45:00',3.52),('15087','2013-06-19','15:50:00',3.41),('15087','2013-06-19','15:55:00',3.39),('15087','2013-06-19','16:00:00',3.38),('15087','2013-06-19','16:05:00',3.32),('15087','2013-06-19','16:10:00',3.25),('15087','2013-06-19','16:15:00',3.27),('15087','2013-06-19','16:20:00',3.18),('15087','2013-06-19','16:25:00',3.14),('15087','2013-06-19','16:30:00',3.07),('15087','2013-06-19','16:35:00',2.95),('15087','2013-06-19','16:40:00',2.9),('15087','2013-06-19','16:45:00',2.89),('15087','2013-06-19','16:50:00',2.87),('15087','2013-06-19','16:55:00',2.81),('15087','2013-06-19','17:00:00',2.71),('15087','2013-06-19','17:05:00',2.59),('15087','2013-06-19','17:10:00',2.49),('15087','2013-06-19','17:15:00',2.46),('15087','2013-06-19','17:20:00',2.38),('15087','2013-06-19','17:25:00',2.31),('15087','2013-06-19','17:30:00',2.19),('15087','2013-06-19','17:35:00',2.07),('15087','2013-06-19','17:40:00',1.98),('15087','2013-06-19','17:45:00',1.85),('15087','2013-06-19','17:50:00',1.71),('15087','2013-06-19','17:55:00',1.65),('15087','2013-06-19','18:00:00',1.58),('15087','2013-06-19','18:05:00',1.48),('15087','2013-06-19','18:10:00',1.32),('15087','2013-06-19','18:15:00',1.21),('15087','2013-06-19','18:20:00',1.18),('15087','2013-06-19','18:25:00',1.07),('15087','2013-06-19','18:30:00',1.02),('15087','2013-06-17','07:30:00',1.02),('15087','2013-06-17','07:35:00',1.09),('15087','2013-06-17','07:40:00',1.18),('15087','2013-06-17','07:45:00',1.25),('15087','2013-06-17','07:50:00',1.35),('15087','2013-06-17','07:55:00',1.44),('15087','2013-06-17','08:00:00',1.52),('15087','2013-06-17','08:05:00',1.62),('15087','2013-06-17','08:10:00',1.71),('15087','2013-06-17','08:15:00',1.79),('15087','2013-06-17','08:20:00',1.88),('15087','2013-06-17','08:25:00',1.97),('15087','2013-06-17','08:30:00',2.04),('15087','2013-06-17','08:35:00',2.16),('15087','2013-06-17','08:40:00',2.27),('15087','2013-06-17','08:45:00',2.35),('15087','2013-06-17','08:50:00',2.45),('15087','2013-06-17','08:55:00',2.53),('15087','2013-06-17','09:00:00',2.62),('15087','2013-06-17','09:05:00',2.69),('15087','2013-06-17','09:10:00',2.76),('15087','2013-06-17','09:15:00',2.83),('15087','2013-06-17','09:20:00',2.9),('15087','2013-06-17','09:25:00',2.95),('15087','2013-06-17','09:30:00',3.02),('15087','2013-06-17','09:35:00',3.09),('15087','2013-06-17','09:40:00',3.13),('15087','2013-06-17','09:45:00',3.19),('15087','2013-06-17','09:50:00',3.25),('15087','2013-06-17','09:55:00',3.32),('15087','2013-06-17','10:00:00',3.32),('15087','2013-06-17','10:05:00',3.41),('15087','2013-06-17','10:10:00',3.46),('15087','2013-06-17','10:15:00',3.5),('15087','2013-06-17','10:20:00',3.54),('15087','2013-06-17','10:25:00',3.6),('15087','2013-06-17','10:30:00',3.64),('15087','2013-06-17','10:35:00',3.72),('15087','2013-06-17','10:40:00',3.75),('15087','2013-06-17','10:45:00',3.79),('15087','2013-06-17','10:50:00',3.85),('15087','2013-06-17','10:55:00',3.85),('15087','2013-06-17','11:00:00',3.9),('15087','2013-06-17','11:05:00',3.95),('15087','2013-06-17','11:10:00',3.96),('15087','2013-06-17','11:15:00',3.99),('15087','2013-06-17','11:20:00',4.02),('15087','2013-06-17','11:25:00',4.07),('15087','2013-06-17','11:30:00',4.11),('15087','2013-06-17','11:35:00',4.14),('15087','2013-06-17','11:40:00',4.15),('15087','2013-06-17','11:45:00',4.15),('15087','2013-06-17','11:50:00',4.15),('15087','2013-06-17','11:55:00',4.16),('15087','2013-06-17','12:00:00',4.17),('15087','2013-06-17','12:05:00',4.23),('15087','2013-06-17','12:10:00',4.21),('15087','2013-06-17','12:15:00',4.19),('15087','2013-06-17','12:20:00',4.19),('15087','2013-06-17','12:25:00',4.23),('15087','2013-06-17','12:30:00',4.21),('15087','2013-06-17','12:35:00',4.27),('15087','2013-06-17','12:40:00',4.28),('15087','2013-06-17','12:45:00',4.4),('15087','2013-06-17','12:50:00',4.35),('15087','2013-06-17','12:55:00',4.48),('15087','2013-06-17','13:00:00',4.49),('15087','2013-06-17','13:05:00',4.47),('15087','2013-06-17','13:10:00',4.43),('15087','2013-06-17','13:15:00',4.47),('15087','2013-06-17','13:20:00',4.45),('15087','2013-06-17','13:25:00',4.43),('15087','2013-06-17','13:30:00',4.44),('15087','2013-06-17','13:35:00',4.42),('15087','2013-06-17','13:40:00',4.44),('15087','2013-06-17','13:45:00',4.41),('15087','2013-06-17','13:50:00',4.41),('15087','2013-06-17','13:55:00',4.37),('15087','2013-06-17','14:00:00',4.36),('15087','2013-06-17','14:05:00',4.36),('15087','2013-06-17','14:10:00',4.36),('15087','2013-06-17','14:15:00',4.33),('15087','2013-06-17','14:20:00',4.33),('15087','2013-06-17','14:25:00',4.3),('15087','2013-06-17','14:30:00',4.27),('15087','2013-06-17','14:35:00',4.24),('15087','2013-06-17','14:40:00',4.22),('15087','2013-06-17','14:45:00',4.13),('15087','2013-06-17','14:50:00',4.1),('15087','2013-06-17','14:55:00',4.08),('15087','2013-06-17','15:00:00',4.03),('15087','2013-06-17','15:05:00',3.96),('15087','2013-06-17','15:10:00',3.88),('15087','2013-06-17','15:15:00',3.54),('15087','2013-06-17','15:20:00',3.67),('15087','2013-06-17','15:25:00',3.81),('15087','2013-06-17','15:30:00',3.7),('15087','2013-06-17','15:35:00',3.66),('15087','2013-06-17','15:40:00',3.61),('15087','2013-06-17','15:45:00',3.57),('15087','2013-06-17','15:50:00',3.5),('15087','2013-06-17','15:55:00',3.48),('15087','2013-06-17','16:00:00',3.47),('15087','2013-06-17','16:05:00',3.38),('15087','2013-06-17','16:10:00',3.31),('15087','2013-06-17','16:15:00',3.33),('15087','2013-06-17','16:20:00',3.26),('15087','2013-06-17','16:25:00',3.23),('15087','2013-06-17','16:30:00',3.16),('15087','2013-06-17','16:35:00',3.08),('15087','2013-06-17','16:40:00',2.96),('15087','2013-06-17','16:45:00',2.92),('15087','2013-06-17','16:50:00',2.9),('15087','2013-06-17','16:55:00',2.89),('15087','2013-06-17','17:00:00',2.77),('15087','2013-06-17','17:05:00',2.68),('15087','2013-06-17','17:10:00',2.61),('15087','2013-06-17','17:15:00',2.55),('15087','2013-06-17','17:20:00',2.51),('15087','2013-06-17','17:25:00',2.37),('15087','2013-06-17','17:30:00',2.23),('15087','2013-06-17','17:35:00',2.13),('15087','2013-06-17','17:40:00',2.05),('15087','2013-06-17','17:45:00',1.91),('15087','2013-06-17','17:50:00',1.77),('15087','2013-06-17','17:55:00',1.68),('15087','2013-06-17','18:00:00',1.5),('15087','2013-06-17','18:05:00',1.46),('15087','2013-06-17','18:10:00',1.4),('15087','2013-06-17','18:15:00',1.32),('15087','2013-06-17','18:20:00',1.29),('15087','2013-06-17','18:25:00',1.1),('15087','2013-06-17','18:30:00',1.11),('15087','2013-06-16','07:30:00',1.03),('15087','2013-06-16','07:35:00',1.12),('15087','2013-06-16','07:40:00',1.21),('15087','2013-06-16','07:45:00',1.29),('15087','2013-06-16','07:50:00',1.38),('15087','2013-06-16','07:55:00',1.46),('15087','2013-06-16','08:00:00',1.54),('15087','2013-06-16','08:05:00',1.62),('15087','2013-06-16','08:10:00',1.71),('15087','2013-06-16','08:15:00',1.81),('15087','2013-06-16','08:20:00',1.89),('15087','2013-06-16','08:25:00',2.03),('15087','2013-06-16','08:30:00',2.1),('15087','2013-06-16','08:35:00',2.21),('15087','2013-06-16','08:40:00',2.3),('15087','2013-06-16','08:45:00',2.41),('15087','2013-06-16','08:50:00',2.51),('15087','2013-06-16','08:55:00',2.59),('15087','2013-06-16','09:00:00',2.62),('15087','2013-06-16','09:05:00',2.69),('15087','2013-06-16','09:10:00',2.78),('15087','2013-06-16','09:15:00',2.86),('15087','2013-06-16','09:20:00',2.93),('15087','2013-06-16','09:25:00',3.02),('15087','2013-06-16','09:30:00',3.06),('15087','2013-06-16','09:35:00',3.13),('15087','2013-06-16','09:40:00',3.2),('15087','2013-06-16','09:45:00',3.22),('15087','2013-06-16','09:50:00',3.3),('15087','2013-06-16','09:55:00',3.38),('15087','2013-06-16','10:00:00',3.46),('15087','2013-06-16','10:05:00',3.49),('15087','2013-06-16','10:10:00',3.56),('15087','2013-06-16','10:15:00',3.57),('15087','2013-06-16','10:20:00',3.59),('15087','2013-06-16','10:25:00',3.65),('15087','2013-06-16','10:30:00',3.71),('15087','2013-06-16','10:35:00',3.77),('15087','2013-06-16','10:40:00',3.83),('15087','2013-06-16','10:45:00',3.86),('15087','2013-06-16','10:50:00',3.96),('15087','2013-06-16','10:55:00',3.98),('15087','2013-06-16','11:00:00',3.97),('15087','2013-06-16','11:05:00',4.02),('15087','2013-06-16','11:10:00',4.06),('15087','2013-06-16','11:15:00',4.07),('15087','2013-06-16','11:20:00',4.14),('15087','2013-06-16','11:25:00',4.21),('15087','2013-06-16','11:30:00',4.22),('15087','2013-06-16','11:35:00',4.24),('15087','2013-06-16','11:40:00',4.27),('15087','2013-06-16','11:45:00',4.28),('15087','2013-06-16','11:50:00',4.33),('15087','2013-06-16','11:55:00',4.35),('15087','2013-06-16','12:00:00',4.39),('15087','2013-06-16','12:05:00',4.44),('15087','2013-06-16','12:10:00',4.42),('15087','2013-06-16','12:15:00',4.45),('15087','2013-06-16','12:20:00',4.46),('15087','2013-06-16','12:25:00',4.44),('15087','2013-06-16','12:30:00',4.46),('15087','2013-06-16','12:35:00',4.46),('15087','2013-06-16','12:40:00',4.46),('15087','2013-06-16','12:45:00',4.5),('15087','2013-06-16','12:50:00',4.47),('15087','2013-06-16','12:55:00',4.51),('15087','2013-06-16','13:00:00',4.59),('15087','2013-06-16','13:05:00',4.61),('15087','2013-06-16','13:10:00',4.65),('15087','2013-06-16','13:15:00',4.61),('15087','2013-06-16','13:20:00',4.63),('15087','2013-06-16','13:25:00',4.62),('15087','2013-06-16','13:30:00',4.57),('15087','2013-06-16','13:35:00',4.6),('15087','2013-06-16','13:40:00',4.6),('15087','2013-06-16','13:45:00',4.57),('15087','2013-06-16','13:50:00',4.59),('15087','2013-06-16','13:55:00',4.55),('15087','2013-06-16','14:00:00',4.55),('15087','2013-06-16','14:05:00',4.53),('15087','2013-06-16','14:10:00',4.53),('15087','2013-06-16','14:15:00',4.5),('15087','2013-06-16','14:20:00',4.48),('15087','2013-06-16','14:25:00',4.43),('15087','2013-06-16','14:30:00',4.41),('15087','2013-06-16','14:35:00',4.39),('15087','2013-06-16','14:40:00',4.35),('15087','2013-06-16','14:45:00',4.21),('15087','2013-06-16','14:50:00',4.17),('15087','2013-06-16','14:55:00',4.19),('15087','2013-06-16','15:00:00',4.16),('15087','2013-06-16','15:05:00',4.1),('15087','2013-06-16','15:10:00',3.97),('15087','2013-06-16','15:15:00',3.98),('15087','2013-06-16','15:20:00',3.97),('15087','2013-06-16','15:25:00',3.93),('15087','2013-06-16','15:30:00',3.79),('15087','2013-06-16','15:35:00',3.75),('15087','2013-06-16','15:40:00',3.72),('15087','2013-06-16','15:45:00',3.66),('15087','2013-06-16','15:50:00',3.54),('15087','2013-06-16','15:55:00',3.57),('15087','2013-06-16','16:00:00',3.54),('15087','2013-06-16','16:05:00',3.42),('15087','2013-06-16','16:10:00',3.37),('15087','2013-06-16','16:15:00',3.39),('15087','2013-06-16','16:20:00',3.3),('15087','2013-06-16','16:25:00',3.29),('15087','2013-06-16','16:30:00',3.2),('15087','2013-06-16','16:35:00',3.1),('15087','2013-06-16','16:40:00',3),('15087','2013-06-16','16:45:00',2.98),('15087','2013-06-16','16:50:00',2.96),('15087','2013-06-16','16:55:00',2.9),('15087','2013-06-16','17:00:00',2.76),('15087','2013-06-16','17:05:00',2.64),('15087','2013-06-16','17:10:00',2.6),('15087','2013-06-16','17:15:00',2.56),('15087','2013-06-16','17:20:00',2.51),('15087','2013-06-16','17:25:00',2.36),('15087','2013-06-16','17:30:00',2.2),('15087','2013-06-16','17:35:00',2.1),('15087','2013-06-16','17:40:00',1.98),('15087','2013-06-16','17:45:00',1.83),('15087','2013-06-16','17:50:00',1.7),('15087','2013-06-16','17:55:00',1.59),('15087','2013-06-16','18:00:00',1.42),('15087','2013-06-16','18:05:00',1.38),('15087','2013-06-16','18:10:00',1.31),('15087','2013-06-16','18:15:00',1.25),('15087','2013-06-16','18:20:00',1.2),('15087','2013-06-16','18:25:00',1.07),('15087','2013-06-16','18:30:00',1.04),('15087','2013-06-15','07:35:00',1.08),('15087','2013-06-15','07:40:00',1.16),('15087','2013-06-15','07:45:00',1.24),('15087','2013-06-15','07:50:00',1.33),('15087','2013-06-15','07:55:00',1.41),('15087','2013-06-15','08:00:00',1.5),('15087','2013-06-15','08:05:00',1.58),('15087','2013-06-15','08:10:00',1.64),('15087','2013-06-15','08:15:00',1.77),('15087','2013-06-15','08:20:00',1.82),('15087','2013-06-15','08:25:00',1.91),('15087','2013-06-15','08:30:00',2.01),('15087','2013-06-15','08:35:00',2.12),('15087','2013-06-15','08:40:00',2.2),('15087','2013-06-15','08:45:00',2.36),('15087','2013-06-15','08:50:00',2.41),('15087','2013-06-15','08:55:00',2.48),('15087','2013-06-15','09:00:00',2.4),('15087','2013-06-15','09:05:00',2.49),('15087','2013-06-15','09:10:00',2.68),('15087','2013-06-15','09:15:00',2.72),('15087','2013-06-15','09:20:00',2.97),('15087','2013-06-15','09:25:00',2.96),('15087','2013-06-15','09:30:00',3.14),('15087','2013-06-15','09:35:00',3.36),('15087','2013-06-15','09:40:00',3.29),('15087','2013-06-15','09:45:00',3.21),('15087','2013-06-15','09:50:00',3.25),('15087','2013-06-15','09:55:00',2.34),('15087','2013-06-15','10:00:00',3.2),('15087','2013-06-15','10:05:00',3.5),('15087','2013-06-15','10:10:00',3.42),('15087','2013-06-15','10:15:00',2.9),('15087','2013-06-15','10:20:00',3.71),('15087','2013-06-15','10:25:00',3.67),('15087','2013-06-15','10:30:00',2.97),('15087','2013-06-15','10:35:00',2.16),('15087','2013-06-15','10:40:00',2.36),('15087','2013-06-15','10:45:00',3.63),('15087','2013-06-15','10:50:00',2.56),('15087','2013-06-15','10:55:00',3.34),('15087','2013-06-15','11:00:00',4.27),('15087','2013-06-15','11:05:00',3.66),('15087','2013-06-15','11:10:00',4.08),('15087','2013-06-15','11:15:00',2.73),('15087','2013-06-15','11:20:00',3.09),('15087','2013-06-15','11:25:00',4.54),('15087','2013-06-15','11:30:00',4.29),('15087','2013-06-15','11:35:00',4.42),('15087','2013-06-15','11:40:00',4.4),('15087','2013-06-15','11:45:00',3.23),('15087','2013-06-15','11:50:00',4.64),('15087','2013-06-15','11:55:00',4.58),('15087','2013-06-15','12:00:00',4.36),('15087','2013-06-15','12:05:00',4.49),('15087','2013-06-15','12:10:00',4.56),('15087','2013-06-15','12:15:00',4.6),('15087','2013-06-15','12:20:00',4.6),('15087','2013-06-15','12:25:00',4.53),('15087','2013-06-15','12:30:00',4.57),('15087','2013-06-15','12:35:00',4.58),('15087','2013-06-15','12:40:00',4.59),('15087','2013-06-15','12:45:00',4.55),('15087','2013-06-15','12:50:00',4.62),('15087','2013-06-15','12:55:00',4.65),('15087','2013-06-15','13:00:00',4.63),('15087','2013-06-15','13:05:00',4.65),('15087','2013-06-15','13:10:00',4.65),('15087','2013-06-15','13:15:00',4.66),('15087','2013-06-15','13:20:00',4.63),('15087','2013-06-15','13:25:00',4.61),('15087','2013-06-15','13:30:00',4.57),('15087','2013-06-15','13:35:00',4.5),('15087','2013-06-15','13:40:00',4.59),('15087','2013-06-15','13:45:00',4.57),('15087','2013-06-15','13:50:00',4.52),('15087','2013-06-15','13:55:00',4.54),('15087','2013-06-15','14:00:00',4.51),('15087','2013-06-15','14:05:00',4.49),('15087','2013-06-15','14:10:00',4.49),('15087','2013-06-15','14:15:00',4.46),('15087','2013-06-15','14:20:00',4.46),('15087','2013-06-15','14:25:00',4.37),('15087','2013-06-15','14:30:00',4.34),('15087','2013-06-15','14:35:00',4.27),('15087','2013-06-15','14:40:00',4.31),('15087','2013-06-15','14:45:00',4.13),('15087','2013-06-15','14:50:00',4.07),('15087','2013-06-15','14:55:00',4.14),('15087','2013-06-15','15:00:00',4.08),('15087','2013-06-15','15:05:00',4.06),('15087','2013-06-15','15:10:00',3.93),('15087','2013-06-15','15:15:00',3.61),('15087','2013-06-15','15:20:00',3.79),('15087','2013-06-15','15:25:00',3.93),('15087','2013-06-15','15:30:00',3.82),('15087','2013-06-15','15:35:00',3.77),('15087','2013-06-15','15:40:00',3.73),('15087','2013-06-15','15:45:00',3.67),('15087','2013-06-15','15:50:00',3.61),('15087','2013-06-15','15:55:00',3.58),('15087','2013-06-15','16:00:00',3.54),('15087','2013-06-15','16:05:00',3.49),('15087','2013-06-15','16:10:00',3.43),('15087','2013-06-15','16:15:00',3.41),('15087','2013-06-15','16:20:00',3.31),('15087','2013-06-15','16:25:00',3.28),('15087','2013-06-15','16:30:00',3.2),('15087','2013-06-15','16:35:00',3.09),('15087','2013-06-15','16:40:00',2.98),('15087','2013-06-15','16:45:00',2.98),('15087','2013-06-15','16:50:00',2.98),('15087','2013-06-15','16:55:00',2.9),('15087','2013-06-15','17:00:00',2.78),('15087','2013-06-15','17:05:00',2.67),('15087','2013-06-15','17:10:00',2.61),('15087','2013-06-15','17:15:00',2.55),('15087','2013-06-15','17:20:00',2.48),('15087','2013-06-15','17:25:00',2.37),('15087','2013-06-15','17:30:00',2.16),('15087','2013-06-15','17:35:00',2.07),('15087','2013-06-15','17:40:00',1.95),('15087','2013-06-15','17:45:00',1.77),('15087','2013-06-15','17:50:00',1.65),('15087','2013-06-15','17:55:00',1.6),('15087','2013-06-15','18:00:00',1.47),('15087','2013-06-15','18:05:00',1.37),('15087','2013-06-15','18:10:00',1.29),('15087','2013-06-15','18:15:00',1.25),('15087','2013-06-15','18:20:00',1.18),('15087','2013-06-15','18:25:00',1.06),('15087','2013-06-15','18:30:00',1.02),('15087','2013-06-14','07:25:00',1.05),('15087','2013-06-14','07:30:00',1.13),('15087','2013-06-14','07:35:00',1.23),('15087','2013-06-14','07:40:00',1.32),('15087','2013-06-14','07:45:00',1.41),('15087','2013-06-14','07:50:00',1.49),('15087','2013-06-14','07:55:00',1.58),('15087','2013-06-14','08:00:00',1.7),('15087','2013-06-14','08:05:00',1.79),('15087','2013-06-14','08:10:00',1.88),('15087','2013-06-14','08:15:00',1.99),('15087','2013-06-14','08:20:00',2.1),('15087','2013-06-14','08:25:00',2.19),('15087','2013-06-14','08:30:00',2.28),('15087','2013-06-14','08:35:00',2.37),('15087','2013-06-14','08:40:00',2.47),('15087','2013-06-14','08:45:00',2.55),('15087','2013-06-14','08:50:00',2.63),('15087','2013-06-14','08:55:00',2.7),('15087','2013-06-14','09:00:00',2.77),('15087','2013-06-14','09:05:00',2.85),('15087','2013-06-14','09:10:00',2.93),('15087','2013-06-14','09:15:00',2.97),('15087','2013-06-14','09:20:00',3.06),('15087','2013-06-14','09:25:00',3.14),('15087','2013-06-14','09:30:00',3.2),('15087','2013-06-14','09:35:00',3.28),('15087','2013-06-14','09:40:00',3.36),('15087','2013-06-14','09:45:00',3.42),('15087','2013-06-14','09:50:00',3.49),('15087','2013-06-14','09:55:00',3.55),('15087','2013-06-14','10:00:00',3.6),('15087','2013-06-14','10:05:00',3.64),('15087','2013-06-14','10:10:00',3.71),('15087','2013-06-14','10:15:00',3.72),('15087','2013-06-14','10:20:00',3.78),('15087','2013-06-14','10:25:00',3.83),('15087','2013-06-14','10:30:00',3.81),('15087','2013-06-14','10:35:00',4),('15087','2013-06-14','10:40:00',4.03),('15087','2013-06-14','10:45:00',4.06),('15087','2013-06-14','10:50:00',4.08),('15087','2013-06-14','10:55:00',4.06),('15087','2013-06-14','11:00:00',4.06),('15087','2013-06-14','11:05:00',4.13),('15087','2013-06-14','11:10:00',4.19),('15087','2013-06-14','11:15:00',4.25),('15087','2013-06-14','11:20:00',4.23),('15087','2013-06-14','11:25:00',4.14),('15087','2013-06-14','11:30:00',4.37),('15087','2013-06-14','11:35:00',4.4),('15087','2013-06-14','11:40:00',4.43),('15087','2013-06-14','11:45:00',4.43),('15087','2013-06-14','11:50:00',4.42),('15087','2013-06-14','11:55:00',4.46),('15087','2013-06-14','12:00:00',4.43),('15087','2013-06-14','12:05:00',4.48),('15087','2013-06-14','12:10:00',4.45),('15087','2013-06-14','12:15:00',4.47),('15087','2013-06-14','12:20:00',4.5),('15087','2013-06-14','12:25:00',4.48),('15087','2013-06-14','12:30:00',4.55),('15087','2013-06-14','12:35:00',4.52),('15087','2013-06-14','12:40:00',4.52),('15087','2013-06-14','12:45:00',4.61),('15087','2013-06-14','12:50:00',4.57),('15087','2013-06-14','12:55:00',4.6),('15087','2013-06-14','13:00:00',4.61),('15087','2013-06-14','13:05:00',4.64),('15087','2013-06-14','13:10:00',4.68),('15087','2013-06-14','13:15:00',4.68),('15087','2013-06-14','13:20:00',4.66),('15087','2013-06-14','13:25:00',4.7),('15087','2013-06-14','13:30:00',4.6),('15087','2013-06-14','13:35:00',4.57),('15087','2013-06-14','13:40:00',4.55),('15087','2013-06-14','13:45:00',4.52),('15087','2013-06-14','13:50:00',4.56),('15087','2013-06-14','13:55:00',4.47),('15087','2013-06-14','14:00:00',4.46),('15087','2013-06-14','14:05:00',4.51),('15087','2013-06-14','14:10:00',4.54),('15087','2013-06-14','14:15:00',4.52),('15087','2013-06-14','14:20:00',4.41),('15087','2013-06-14','14:25:00',4.41),('15087','2013-06-14','14:30:00',4.38),('15087','2013-06-14','14:35:00',4.38),('15087','2013-06-14','14:40:00',4.36),('15087','2013-06-14','14:45:00',4.19),('15087','2013-06-14','14:50:00',4.24),('15087','2013-06-14','14:55:00',4.24),('15087','2013-06-14','15:00:00',4.2),('15087','2013-06-14','15:05:00',4.12),('15087','2013-06-14','15:10:00',3.97),('15087','2013-06-14','15:15:00',3.58),('15087','2013-06-14','15:20:00',3.88),('15087','2013-06-14','15:25:00',3.98),('15087','2013-06-14','15:30:00',3.85),('15087','2013-06-14','15:35:00',3.82),('15087','2013-06-14','15:40:00',3.79),('15087','2013-06-14','15:45:00',3.74),('15087','2013-06-14','15:50:00',3.7),('15087','2013-06-14','15:55:00',3.64),('15087','2013-06-14','16:00:00',3.6),('15087','2013-06-14','16:05:00',3.53),('15087','2013-06-14','16:10:00',3.48),('15087','2013-06-14','16:15:00',3.45),('15087','2013-06-14','16:20:00',3.4),('15087','2013-06-14','16:25:00',3.33),('15087','2013-06-14','16:30:00',3.25),('15087','2013-06-14','16:35:00',3.14),('15087','2013-06-14','16:40:00',2.98),('15087','2013-06-14','16:45:00',3),('15087','2013-06-14','16:50:00',3.03),('15087','2013-06-14','16:55:00',2.93),('15087','2013-06-14','17:00:00',2.85),('15087','2013-06-14','17:05:00',2.67),('15087','2013-06-14','17:10:00',2.64),('15087','2013-06-14','17:15:00',2.64),('15087','2013-06-14','17:20:00',2.58),('15087','2013-06-14','17:25:00',2.45),('15087','2013-06-14','17:30:00',2.17),('15087','2013-06-14','17:35:00',2.12),('15087','2013-06-14','17:40:00',2.07),('15087','2013-06-14','17:45:00',1.89),('15087','2013-06-14','17:50:00',1.81),('15087','2013-06-14','17:55:00',1.72),('15087','2013-06-14','18:00:00',1.6),('15087','2013-06-14','18:05:00',1.53),('15087','2013-06-14','18:10:00',1.34),('15087','2013-06-14','18:15:00',1.32),('15087','2013-06-14','18:20:00',1.23),('15087','2013-06-14','18:25:00',1.13),('15087','2013-06-14','18:30:00',1.05),('15087','2013-06-13','07:25:00',1.06),('15087','2013-06-13','07:30:00',1.15),('15087','2013-06-13','07:35:00',1.24),('15087','2013-06-13','07:40:00',1.34),('15087','2013-06-13','07:45:00',1.43),('15087','2013-06-13','07:50:00',1.51),('15087','2013-06-13','07:55:00',1.6),('15087','2013-06-13','08:00:00',1.7),('15087','2013-06-13','08:05:00',1.84),('15087','2013-06-13','08:10:00',1.89),('15087','2013-06-13','08:15:00',2.04),('15087','2013-06-13','08:20:00',2.11),('15087','2013-06-13','08:25:00',2.16),('15087','2013-06-13','08:30:00',2.25),('15087','2013-06-13','08:35:00',2.37),('15087','2013-06-13','08:40:00',2.47),('15087','2013-06-13','08:45:00',2.53),('15087','2013-06-13','08:50:00',2.6),('15087','2013-06-13','08:55:00',2.68),('15087','2013-06-13','09:00:00',2.79),('15087','2013-06-13','09:05:00',2.89),('15087','2013-06-13','09:10:00',2.96),('15087','2013-06-13','09:15:00',3.05),('15087','2013-06-13','09:20:00',3.09),('15087','2013-06-13','09:25:00',3.21),('15087','2013-06-13','09:30:00',3.3),('15087','2013-06-13','09:35:00',3.38),('15087','2013-06-13','09:40:00',3.46),('15087','2013-06-13','09:45:00',3.52),('15087','2013-06-13','09:50:00',3.54),('15087','2013-06-13','09:55:00',3.66),('15087','2013-06-13','10:00:00',3.69),('15087','2013-06-13','10:05:00',3.75),('15087','2013-06-13','10:10:00',3.79),('15087','2013-06-13','10:15:00',3.85),('15087','2013-06-13','10:20:00',3.93),('15087','2013-06-13','10:25:00',3.96),('15087','2013-06-13','10:30:00',4.02),('15087','2013-06-13','10:35:00',4.09),('15087','2013-06-13','10:40:00',4.11),('15087','2013-06-13','10:45:00',4.18),('15087','2013-06-13','10:50:00',4.24),('15087','2013-06-13','10:55:00',4.29),('15087','2013-06-13','11:00:00',4.32),('15087','2013-06-13','11:05:00',4.34),('15087','2013-06-13','11:10:00',4.36),('15087','2013-06-13','11:15:00',4.39),('15087','2013-06-13','11:20:00',4.42),('15087','2013-06-13','11:25:00',4.48),('15087','2013-06-13','11:30:00',4.53),('15087','2013-06-13','11:35:00',4.56),('15087','2013-06-13','11:40:00',4.59),('15087','2013-06-13','11:45:00',4.64),('15087','2013-06-13','11:50:00',4.68),('15087','2013-06-13','11:55:00',4.67),('15087','2013-06-13','12:00:00',4.68),('15087','2013-06-13','12:05:00',4.65),('15087','2013-06-13','12:10:00',4.8),('15087','2013-06-13','12:15:00',4.78),('15087','2013-06-13','12:20:00',4.78),('15087','2013-06-13','12:25:00',4.77),('15087','2013-06-13','12:30:00',4.81),('15087','2013-06-13','12:35:00',4.82),('15087','2013-06-13','12:40:00',4.81),('15087','2013-06-13','12:45:00',4.8),('15087','2013-06-13','12:50:00',4.81),('15087','2013-06-13','12:55:00',4.79),('15087','2013-06-13','13:00:00',4.84),('15087','2013-06-13','13:05:00',4.83),('15087','2013-06-13','13:10:00',4.78),('15087','2013-06-13','13:15:00',4.83),('15087','2013-06-13','13:20:00',4.78),('15087','2013-06-13','13:25:00',4.81),('15087','2013-06-13','13:30:00',4.78),('15087','2013-06-13','13:35:00',4.79),('15087','2013-06-13','13:40:00',4.77),('15087','2013-06-13','13:45:00',4.71),('15087','2013-06-13','13:50:00',4.71),('15087','2013-06-13','13:55:00',4.69),('15087','2013-06-13','14:00:00',4.74),('15087','2013-06-13','14:05:00',4.73),('15087','2013-06-13','14:10:00',4.68),('15087','2013-06-13','14:15:00',4.67),('15087','2013-06-13','14:20:00',4.62),('15087','2013-06-13','14:25:00',4.64),('15087','2013-06-13','14:30:00',4.17),('15087','2013-06-13','14:35:00',4.63),('15087','2013-06-13','14:40:00',4.63),('15087','2013-06-13','14:45:00',4.41),('15087','2013-06-13','14:50:00',4.18),('15087','2013-06-13','14:55:00',4.31),('15087','2013-06-13','15:00:00',4.33),('15087','2013-06-13','15:05:00',4.24),('15087','2013-06-13','15:10:00',3.99),('15087','2013-06-13','15:15:00',3.99),('15087','2013-06-13','15:20:00',4.07),('15087','2013-06-13','15:25:00',4.02),('15087','2013-06-13','15:30:00',3.87),('15087','2013-06-13','15:35:00',3.8),('15087','2013-06-13','15:40:00',3.82),('15087','2013-06-13','15:45:00',3.77),('15087','2013-06-13','15:50:00',3.73),('15087','2013-06-13','15:55:00',3.67),('15087','2013-06-13','16:00:00',3.64),('15087','2013-06-13','16:05:00',3.51),('15087','2013-06-13','16:10:00',3.5),('15087','2013-06-13','16:15:00',3.45),('15087','2013-06-13','16:20:00',3.33),('15087','2013-06-13','16:25:00',3.32),('15087','2013-06-13','16:30:00',3.2),('15087','2013-06-13','16:35:00',3.09),('15087','2013-06-13','16:40:00',3.07),('15087','2013-06-13','16:45:00',3.01),('15087','2013-06-13','16:50:00',2.94),('15087','2013-06-13','16:55:00',2.88),('15087','2013-06-13','17:00:00',2.77),('15087','2013-06-13','17:05:00',2.71),('15087','2013-06-13','17:10:00',2.64),('15087','2013-06-13','17:15:00',2.59),('15087','2013-06-13','17:20:00',2.56),('15087','2013-06-13','17:25:00',2.47),('15087','2013-06-13','17:30:00',2.29),('15087','2013-06-13','17:35:00',2.2),('15087','2013-06-13','17:40:00',2.06),('15087','2013-06-13','17:45:00',1.89),('15087','2013-06-13','17:50:00',1.8),('15087','2013-06-13','17:55:00',1.64),('15087','2013-06-13','18:00:00',1.47),('15087','2013-06-13','18:05:00',1.35),('15087','2013-06-13','18:10:00',1.41),('15087','2013-06-13','18:15:00',1.33),('15087','2013-06-13','18:20:00',1.22),('15087','2013-06-13','18:25:00',1.14),('15087','2013-06-13','18:30:00',1.06),('15087','2013-06-12','07:20:00',1.01),('15087','2013-06-12','07:25:00',1.09),('15087','2013-06-12','07:30:00',1.19),('15087','2013-06-12','07:35:00',1.27),('15087','2013-06-12','07:40:00',1.36),('15087','2013-06-12','07:45:00',1.44),('15087','2013-06-12','07:50:00',1.52),('15087','2013-06-12','07:55:00',1.63),('15087','2013-06-12','08:00:00',1.72),('15087','2013-06-12','08:05:00',1.83),('15087','2013-06-12','08:10:00',1.91),('15087','2013-06-12','08:15:00',2.01),('15087','2013-06-12','08:20:00',2.16),('15087','2013-06-12','08:25:00',2.28),('15087','2013-06-12','08:30:00',2.38),('15087','2013-06-12','08:35:00',2.45),('15087','2013-06-12','08:40:00',2.55),('15087','2013-06-12','08:45:00',2.64),('15087','2013-06-12','08:50:00',2.72),('15087','2013-06-12','08:55:00',2.8),('15087','2013-06-12','09:00:00',2.89),('15087','2013-06-12','09:05:00',2.96),('15087','2013-06-12','09:10:00',3.04),('15087','2013-06-12','09:15:00',3.14),('15087','2013-06-12','09:20:00',3.21),('15087','2013-06-12','09:25:00',3.3),('15087','2013-06-12','09:30:00',3.36),('15087','2013-06-12','09:35:00',3.4),('15087','2013-06-12','09:40:00',3.48),('15087','2013-06-12','09:45:00',3.54),('15087','2013-06-12','09:50:00',3.61),('15087','2013-06-12','09:55:00',3.69),('15087','2013-06-12','10:00:00',3.75),('15087','2013-06-12','10:05:00',3.76),('15087','2013-06-12','10:10:00',3.84),('15087','2013-06-12','10:15:00',3.88),('15087','2013-06-12','10:20:00',3.98),('15087','2013-06-12','10:25:00',4.03),('15087','2013-06-12','10:30:00',4.05),('15087','2013-06-12','10:35:00',4.1),('15087','2013-06-12','10:40:00',4.13),('15087','2013-06-12','10:45:00',4.19),('15087','2013-06-12','10:50:00',4.25),('15087','2013-06-12','10:55:00',4.32),('15087','2013-06-12','11:00:00',4.37),('15087','2013-06-12','11:05:00',4.44),('15087','2013-06-12','11:10:00',4.47),('15087','2013-06-12','11:15:00',4.49),('15087','2013-06-12','11:20:00',4.53),('15087','2013-06-12','11:25:00',4.53),('15087','2013-06-12','11:30:00',4.58),('15087','2013-06-12','11:35:00',4.57),('15087','2013-06-12','11:40:00',4.58),('15087','2013-06-12','11:45:00',4.65),('15087','2013-06-12','11:50:00',4.6),('15087','2013-06-12','11:55:00',4.66),('15087','2013-06-12','12:00:00',4.67),('15087','2013-06-12','12:05:00',4.63),('15087','2013-06-12','12:10:00',4.68),('15087','2013-06-12','12:15:00',4.75),('15087','2013-06-12','12:20:00',4.9),('15087','2013-06-12','12:25:00',3.37),('15087','2013-06-12','12:30:00',2.23),('15087','2013-06-12','12:35:00',5.11),('15087','2013-06-12','12:40:00',4.93),('15087','2013-06-12','12:45:00',1.36),('15087','2013-06-12','12:50:00',2.03),('15087','2013-06-12','12:55:00',2.66),('15087','2013-06-12','13:00:00',4.82),('15087','2013-06-12','13:05:00',1.83),('15087','2013-06-12','13:10:00',5.03),('15087','2013-06-12','13:15:00',4.89),('15087','2013-06-12','13:20:00',4.86),('15087','2013-06-12','13:25:00',4.8),('15087','2013-06-12','13:30:00',4.82),('15087','2013-06-12','13:35:00',4.85),('15087','2013-06-12','13:40:00',4.86),('15087','2013-06-12','13:45:00',4.51),('15087','2013-06-12','13:50:00',4.79),('15087','2013-06-12','13:55:00',4.9),('15087','2013-06-12','14:00:00',2.97),('15087','2013-06-12','14:05:00',3.1),('15087','2013-06-12','14:10:00',1.45),('15087','2013-06-12','14:15:00',4.78),('15087','2013-06-12','14:20:00',2.53),('15087','2013-06-12','14:25:00',2.93),('15087','2013-06-12','14:30:00',4.38),('15087','2013-06-12','14:35:00',3.84),('15087','2013-06-12','14:40:00',4.24),('15087','2013-06-12','14:45:00',4.53),('15087','2013-06-12','14:50:00',4.38),('15087','2013-06-12','14:55:00',4.58),('15087','2013-06-12','15:00:00',4.49),('15087','2013-06-12','15:05:00',4.32),('15087','2013-06-12','15:10:00',4.14),('15087','2013-06-12','15:15:00',3.67),('15087','2013-06-12','15:20:00',4.27),('15087','2013-06-12','15:25:00',4.05),('15087','2013-06-12','15:30:00',3.95),('15087','2013-06-12','15:35:00',3.97),('15087','2013-06-12','15:40:00',3.96),('15087','2013-06-12','15:45:00',3.88),('15087','2013-06-12','15:50:00',3.8),('15087','2013-06-12','15:55:00',3.82),('15087','2013-06-12','16:00:00',3.88),('15087','2013-06-12','16:05:00',3.54),('15087','2013-06-12','16:10:00',3.65),('15087','2013-06-12','16:15:00',3.6),('15087','2013-06-12','16:20:00',3.46),('15087','2013-06-12','16:25:00',3.51),('15087','2013-06-12','16:30:00',2.86),('15087','2013-06-12','16:35:00',3.06),('15087','2013-06-12','16:40:00',3.26),('15087','2013-06-12','16:45:00',2.43),('15087','2013-06-12','16:50:00',3.15),('15087','2013-06-12','16:55:00',2.51),('15087','2013-06-12','17:00:00',2.89),('15087','2013-06-12','17:05:00',2.81),('15087','2013-06-12','17:10:00',2.73),('15087','2013-06-12','17:15:00',2.7),('15087','2013-06-12','17:20:00',2.63),('15087','2013-06-12','17:25:00',2.51),('15087','2013-06-12','17:30:00',2.37),('15087','2013-06-12','17:35:00',2.32),('15087','2013-06-12','17:40:00',2.2),('15087','2013-06-12','18:05:00',1.38),('15087','2013-06-12','18:10:00',1.5),('15087','2013-06-12','18:15:00',1.42),('15087','2013-06-12','18:20:00',1.3),('15087','2013-06-12','18:25:00',1.15),('15087','2013-06-12','18:30:00',1.08),('15087','2013-06-11','07:25:00',1.07),('15087','2013-06-11','07:30:00',1.11),('15087','2013-06-11','07:35:00',1.18),('15087','2013-06-11','07:40:00',1.23),('15087','2013-06-11','07:45:00',1.02),('15087','2013-06-11','07:50:00',1.48),('15087','2013-06-11','07:55:00',1.68),('15087','2013-06-11','08:00:00',1.84),('15087','2013-06-11','08:05:00',2.07),('15087','2013-06-11','08:10:00',1.58),('15087','2013-06-11','08:15:00',1.64),('15087','2013-06-11','08:25:00',2.46),('15087','2013-06-11','08:30:00',2.58),('15087','2013-06-11','08:35:00',2.63),('15087','2013-06-11','08:40:00',2.3),('15087','2013-06-11','08:45:00',2.08),('15087','2013-06-11','08:50:00',1.23),('15087','2013-06-11','08:55:00',1.46),('15087','2013-06-11','09:00:00',3.03),('15087','2013-06-11','09:05:00',3.09),('15087','2013-06-11','09:10:00',3.22),('15087','2013-06-11','09:15:00',3.32),('15087','2013-06-11','09:20:00',3.39),('15087','2013-06-11','09:25:00',2.38),('15087','2013-06-11','09:30:00',2.8),('15087','2013-06-11','09:40:00',3.07),('15087','2013-06-11','09:45:00',3.71),('15087','2013-06-11','09:50:00',3.75),('15087','2013-06-11','09:55:00',3.64),('15087','2013-06-11','10:00:00',2.14),('15087','2013-06-11','10:05:00',2.29),('15087','2013-06-11','10:10:00',3.77),('15087','2013-06-11','10:15:00',4.12),('15087','2013-06-11','10:20:00',4.2),('15087','2013-06-11','10:25:00',4.15),('15087','2013-06-11','10:30:00',4.17),('15087','2013-06-11','10:35:00',4.24),('15087','2013-06-11','10:40:00',4.23),('15087','2013-06-11','10:45:00',4.36),('15087','2013-06-11','10:50:00',2.9),('15087','2013-06-11','10:55:00',1.65),('15087','2013-06-11','11:00:00',4.72),('15087','2013-06-11','11:05:00',2.64),('15087','2013-06-11','11:10:00',3.41),('15087','2013-06-11','11:15:00',4.76),('15087','2013-06-11','11:20:00',4.6),('15087','2013-06-11','11:25:00',4.59),('15087','2013-06-11','11:30:00',4.61),('15087','2013-06-11','11:35:00',4.66),('15087','2013-06-11','11:40:00',4.64),('15087','2013-06-11','11:45:00',4.72),('15087','2013-06-11','11:50:00',4.76),('15087','2013-06-11','11:55:00',4.79),('15087','2013-06-11','12:00:00',4.81),('15087','2013-06-11','12:05:00',4.9),('15087','2013-06-11','12:10:00',4.87),('15087','2013-06-11','12:15:00',4.88),('15087','2013-06-11','12:20:00',4.86),('15087','2013-06-11','12:25:00',4.87),('15087','2013-06-11','12:30:00',4.9),('15087','2013-06-11','12:35:00',4.91),('15087','2013-06-11','12:40:00',4.94),('15087','2013-06-11','12:45:00',4.97),('15087','2013-06-11','12:50:00',5),('15087','2013-06-11','12:55:00',4.99),('15087','2013-06-11','13:00:00',4.98),('15087','2013-06-11','13:05:00',4.99),('15087','2013-06-11','13:10:00',4.99),('15087','2013-06-11','13:15:00',5.01),('15087','2013-06-11','13:20:00',4.98),('15087','2013-06-11','13:25:00',4.97),('15087','2013-06-11','13:30:00',4.99),('15087','2013-06-11','13:35:00',4.78),('15087','2013-06-11','13:40:00',5.02),('15087','2013-06-11','13:45:00',4.2),('15087','2013-06-11','13:50:00',4.74),('15087','2013-06-11','13:55:00',4.98),('15087','2013-06-11','14:00:00',4.95),('15087','2013-06-11','14:05:00',4.84),('15087','2013-06-11','14:10:00',4.83),('15087','2013-06-11','14:15:00',4.79),('15087','2013-06-11','14:20:00',4.74),('15087','2013-06-11','14:25:00',4.73),('15087','2013-06-11','14:30:00',4.72),('15087','2013-06-11','14:35:00',4.67),('15087','2013-06-11','14:40:00',4.57),('15087','2013-06-11','14:45:00',4.47),('15087','2013-06-11','14:50:00',4.52),('15087','2013-06-11','14:55:00',4.45),('15087','2013-06-11','15:00:00',4.42),('15087','2013-06-11','15:05:00',4.29),('15087','2013-06-11','15:10:00',4.24),('15087','2013-06-11','15:15:00',4.2),('15087','2013-06-11','15:20:00',4.16),('15087','2013-06-11','15:25:00',4.1),('15087','2013-06-11','15:30:00',3.99),('15087','2013-06-11','15:35:00',3.83),('15087','2013-06-11','15:40:00',3.8),('15087','2013-06-11','15:45:00',4.02),('15087','2013-06-11','15:50:00',3.83),('15087','2013-06-11','15:55:00',3.86),('15087','2013-06-11','16:00:00',3.64),('15087','2013-06-11','16:05:00',3.56),('15087','2013-06-11','16:10:00',3.68),('15087','2013-06-11','16:15:00',3.62),('15087','2013-06-11','16:20:00',3.51),('15087','2013-06-11','16:25:00',3.51),('15087','2013-06-11','16:30:00',3.42),('15087','2013-06-11','16:35:00',3.34),('15087','2013-06-11','16:40:00',3.38),('15087','2013-06-11','16:45:00',3.58),('15087','2013-06-11','16:50:00',3.66),('15087','2013-06-11','16:55:00',3.43),('15087','2013-06-11','17:00:00',2.85),('15087','2013-06-11','17:05:00',1.86),('15087','2014-04-03','08:55:00',1.15),('15087','2014-04-03','09:00:00',1.29),('15087','2014-04-03','09:05:00',1.44),('15087','2014-04-03','09:10:00',1.39),('15087','2014-04-03','09:15:00',1.24),('15087','2014-04-03','09:20:00',1.25),('15087','2014-04-03','09:25:00',1.37),('15087','2014-04-03','09:30:00',1.64),('15087','2014-04-03','09:35:00',1.95),('15087','2014-04-03','09:40:00',2.06),('15087','2014-04-03','09:45:00',2.03),('15087','2014-04-03','09:50:00',1.93),('15087','2014-04-03','09:55:00',2.04),('15087','2014-04-03','10:00:00',2.43),('15087','2014-04-03','10:05:00',2.82),('15087','2014-04-03','10:10:00',2.99),('15087','2014-04-03','10:15:00',3.38),('15087','2014-04-03','10:20:00',3.47),('15087','2014-04-03','10:25:00',3.11),('15087','2014-04-03','10:30:00',2.94),('15087','2014-04-03','10:35:00',3.13),('15087','2014-04-03','10:40:00',2.46),('15087','2014-04-03','10:45:00',2.65),('15087','2014-04-03','10:50:00',2.29),('15087','2014-04-03','10:55:00',2.39),('15087','2014-04-03','11:00:00',2.22),('15087','2014-04-03','11:05:00',1.88),('15087','2014-04-03','11:10:00',1.77),('15087','2014-04-03','11:15:00',1.62),('15087','2014-04-03','11:20:00',1.51),('15087','2014-04-03','11:25:00',1.39),('15087','2014-04-03','11:30:00',1.38),('15087','2014-04-03','11:35:00',1.49),('15087','2014-04-03','11:40:00',1.7),('15087','2014-04-03','11:45:00',1.95),('15087','2014-04-03','11:50:00',2.4),('15087','2014-04-03','11:55:00',2.62),('15087','2014-04-03','12:00:00',2.5),('15087','2014-04-03','12:05:00',2.52),('15087','2014-04-03','12:10:00',2.44),('15087','2014-04-03','12:15:00',2.39),('15087','2014-04-03','12:20:00',2.68),('15087','2014-04-03','12:25:00',3.31),('15087','2014-04-03','12:30:00',4.19),('15087','2014-04-03','12:35:00',4.06),('15087','2014-04-03','12:40:00',4.48),('15087','2014-04-03','12:45:00',2.51),('15087','2014-04-03','12:50:00',3.05),('15087','2014-04-03','12:55:00',2.94),('15087','2014-04-03','13:00:00',2.82),('15087','2014-04-03','13:05:00',3.59),('15087','2014-04-03','13:10:00',2.76),('15087','2014-04-03','13:15:00',4.9),('15087','2014-04-03','13:20:00',2.91),('15087','2014-04-03','13:25:00',3.06),('15087','2014-04-03','13:30:00',3.15),('15087','2014-04-03','13:35:00',4.96),('15087','2014-04-03','13:40:00',4.25),('15087','2014-04-03','13:45:00',2.35),('15087','2014-04-03','13:50:00',2.37),('15087','2014-04-03','13:55:00',2.86),('15087','2014-04-03','14:00:00',3.99),('15087','2014-04-03','14:05:00',3.71),('15087','2014-04-03','14:10:00',2.92),('15087','2014-04-03','14:15:00',3.83),('15087','2014-04-03','14:20:00',3.89),('15087','2014-04-03','14:25:00',4.06),('15087','2014-04-03','14:30:00',4.1),('15087','2014-04-03','14:35:00',4.07),('15087','2014-04-03','14:40:00',3.8),('15087','2014-04-03','14:45:00',3.7),('15087','2014-04-03','14:50:00',3.75),('15087','2014-04-03','14:55:00',3.65),('15087','2014-04-03','15:00:00',3.51),('15087','2014-04-03','15:05:00',3.52),('15087','2014-04-03','15:10:00',3.5),('15087','2014-04-03','15:15:00',3.43),('15087','2014-04-03','15:20:00',3.4),('15087','2014-04-03','15:25:00',3.38),('15087','2014-04-03','15:30:00',3.3),('15087','2014-04-03','15:35:00',3.2),('15087','2014-04-03','15:40:00',3.12),('15087','2014-04-03','15:45:00',2.98),('15087','2014-04-03','15:50:00',3.05),('15087','2014-04-03','15:55:00',3.07),('15087','2014-04-03','16:00:00',2.9),('15087','2014-04-03','16:05:00',2.89),('15087','2014-04-03','16:10:00',2.9),('15087','2014-04-03','16:15:00',2.7),('15087','2014-04-03','16:20:00',2.76),('15087','2014-04-03','16:25:00',2.7),('15087','2014-04-03','16:30:00',2.6),('15087','2014-04-03','16:35:00',2.53),('15087','2014-04-03','16:40:00',2.47),('15087','2014-04-03','16:45:00',2.29),('15087','2014-04-03','16:50:00',1.65),('15087','2014-04-03','16:55:00',1.41),('15087','2014-04-03','17:00:00',1.08),('15087','2014-04-03','17:50:00',1.14),('15087','2013-06-10','07:30:00',1.27),('15087','2013-06-10','07:35:00',1.78),('15087','2013-06-10','08:00:00',1.23),('15087','2013-06-10','08:05:00',1.73),('15087','2013-06-10','08:10:00',2.37),('15087','2013-06-10','08:15:00',1.8),('15087','2013-06-10','08:20:00',1.85),('15087','2013-06-10','08:25:00',1.58),('15087','2013-06-10','08:30:00',1.23),('15087','2013-06-10','08:35:00',1.06),('15087','2013-06-10','08:40:00',1.74),('15087','2013-06-10','08:55:00',1.09),('15087','2013-06-10','09:00:00',1.15),('15087','2013-06-10','09:05:00',1.16),('15087','2013-06-10','09:10:00',1.36),('15087','2013-06-10','09:15:00',1.48),('15087','2013-06-10','09:20:00',2.86),('15087','2013-06-10','09:25:00',3.47),('15087','2013-06-10','09:30:00',2.36),('15087','2013-06-10','09:35:00',3.61),('15087','2013-06-10','09:40:00',2.81),('15087','2013-06-10','09:45:00',4.32),('15087','2013-06-10','09:50:00',1.96),('15087','2013-06-10','09:55:00',1.69),('15087','2013-06-10','10:00:00',2.38),('15087','2013-06-10','10:05:00',2.56),('15087','2013-06-10','10:10:00',2.16),('15087','2013-06-10','10:15:00',2.09),('15087','2013-06-10','10:20:00',2.14),('15087','2013-06-10','10:25:00',1.76),('15087','2013-06-10','10:30:00',1.53),('15087','2013-06-10','10:35:00',2.19),('15087','2013-06-10','10:40:00',1.65),('15087','2013-06-10','10:45:00',1.28),('15087','2013-06-10','10:50:00',2.26),('15087','2013-06-10','10:55:00',3.96),('15087','2013-06-10','11:00:00',2.65),('15087','2013-06-10','11:05:00',2.39),('15087','2013-06-10','11:10:00',2.43),('15087','2013-06-10','11:15:00',4.23),('15087','2013-06-10','11:20:00',4.83),('15087','2013-06-10','11:25:00',4.36),('15087','2013-06-10','11:30:00',4.75),('15087','2013-06-10','11:35:00',4.25),('15087','2013-06-10','11:40:00',2.91),('15087','2013-06-10','11:45:00',3.05),('15087','2013-06-10','11:50:00',2.17),('15087','2013-06-10','11:55:00',4.83),('15087','2013-06-10','12:00:00',4.11),('15087','2013-06-10','12:05:00',1.51),('15087','2013-06-10','12:10:00',4.52),('15087','2013-06-10','12:15:00',4.58),('15087','2013-06-10','12:20:00',5.1),('15087','2013-06-10','12:25:00',5.06),('15087','2013-06-10','12:30:00',5.44),('15087','2013-06-10','12:35:00',4.31),('15087','2013-06-10','12:40:00',4.91),('15087','2013-06-10','12:45:00',2.93),('15087','2013-06-10','12:50:00',2.69),('15087','2013-06-10','12:55:00',4.39),('15087','2013-06-10','13:00:00',5.69),('15087','2013-06-10','13:05:00',4.51),('15087','2013-06-10','13:10:00',2.13),('15087','2013-06-10','13:15:00',4.87),('15087','2013-06-10','13:20:00',3.55),('15087','2013-06-10','13:25:00',2.93),('15087','2013-06-10','13:30:00',2.9),('15087','2013-06-10','13:35:00',5.33),('15087','2013-06-10','13:40:00',4.85),('15087','2013-06-10','13:45:00',4.93),('15087','2013-06-10','13:50:00',4.74),('15087','2013-06-10','13:55:00',4.54),('15087','2013-06-10','14:00:00',4.3),('15087','2013-06-10','14:05:00',5.19),('15087','2013-06-10','14:10:00',4.13),('15087','2013-06-10','14:15:00',5.02),('15087','2013-06-10','14:20:00',4.9),('15087','2013-06-10','14:25:00',4.83),('15087','2013-06-10','14:30:00',4.71),('15087','2013-06-10','14:35:00',4.7),('15087','2013-06-10','14:40:00',4.21),('15087','2013-06-10','14:45:00',4.44),('15087','2013-06-10','14:50:00',4.29),('15087','2013-06-10','14:55:00',4.51),('15087','2013-06-10','15:00:00',4.47),('15087','2013-06-10','15:05:00',4.34),('15087','2013-06-10','15:10:00',4.32),('15087','2013-06-10','15:15:00',4.3),('15087','2013-06-10','15:20:00',4.26),('15087','2013-06-10','15:25:00',4.21),('15087','2013-06-10','15:30:00',4.04),('15087','2013-06-10','15:35:00',3.9),('15087','2013-06-10','15:40:00',4.02),('15087','2013-06-10','15:45:00',3.95),('15087','2013-06-10','15:50:00',3.88),('15087','2013-06-10','15:55:00',3.8),('15087','2013-06-10','16:00:00',3.78),('15087','2013-06-10','16:05:00',3.56),('15087','2013-06-10','16:10:00',3.68),('15087','2013-06-10','16:15:00',3.59),('15087','2013-06-10','16:20:00',3.5),('15087','2013-06-10','16:25:00',3.53),('15087','2013-06-10','16:30:00',3.36),('15087','2013-06-10','16:35:00',3.3),('15087','2013-06-10','16:40:00',3.23),('15087','2013-06-10','16:45:00',3.22),('15087','2013-06-10','16:50:00',3.22),('15087','2013-06-10','16:55:00',3.13),('15087','2013-06-10','17:00:00',3.05),('15087','2013-06-10','17:05:00',2.93),('15087','2013-06-10','17:10:00',2.84),('15087','2013-06-10','17:15:00',2.81),('15087','2013-06-10','17:20:00',2.74),('15087','2013-06-10','17:25:00',2.64),('15087','2013-06-10','17:30:00',2.48),('15087','2013-06-10','17:35:00',2.39),('15087','2013-06-10','17:40:00',2.23),('15087','2013-06-10','17:45:00',2.08),('15087','2013-06-10','17:50:00',1.96),('15087','2013-06-10','17:55:00',1.89),('15087','2013-06-10','18:00:00',1.78),('15087','2013-06-10','18:05:00',1.62),('15087','2013-06-10','18:10:00',1.54),('15087','2013-06-10','18:15:00',1.41),('15087','2013-06-10','18:20:00',1.31),('15087','2013-06-10','18:25:00',1.22),('15087','2013-06-10','18:30:00',1.11),('15087','2013-06-10','18:35:00',1.05),('15087','2013-06-09','07:35:00',1.37),('15087','2013-06-09','07:40:00',1.17),('15087','2013-06-09','07:50:00',1.13),('15087','2013-06-09','07:55:00',1.47),('15087','2013-06-09','08:00:00',1.65),('15087','2013-06-09','08:05:00',1.75),('15087','2013-06-09','08:10:00',1.76),('15087','2013-06-09','08:15:00',1.18),('15087','2013-06-09','08:20:00',1.3),('15087','2013-06-09','08:25:00',2.16),('15087','2013-06-09','08:30:00',2.28),('15087','2013-06-09','08:35:00',2.36),('15087','2013-06-09','08:40:00',2.41),('15087','2013-06-09','08:45:00',2.45),('15087','2013-06-09','08:50:00',2.58),('15087','2013-06-09','08:55:00',2.66),('15087','2013-06-09','09:00:00',2.74),('15087','2013-06-09','09:05:00',2.79),('15087','2013-06-09','09:10:00',2.87),('15087','2013-06-09','09:15:00',2.97),('15087','2013-06-09','09:20:00',3.02),('15087','2013-06-09','09:25:00',3.09),('15087','2013-06-09','09:30:00',3.19),('15087','2013-06-09','09:35:00',3.25),('15087','2013-06-09','09:40:00',3.23),('15087','2013-06-09','09:45:00',3.27),('15087','2013-06-09','09:50:00',3.45),('15087','2013-06-09','09:55:00',3.51),('15087','2013-06-09','10:00:00',3.57),('15087','2013-06-09','10:05:00',3.6),('15087','2013-06-09','10:10:00',3.66),('15087','2013-06-09','10:15:00',3.69),('15087','2013-06-09','10:20:00',3.7),('15087','2013-06-09','10:25:00',3.76),('15087','2013-06-09','10:30:00',3.85),('15087','2013-06-09','10:35:00',3.85),('15087','2013-06-09','10:40:00',3.96),('15087','2013-06-09','10:45:00',3.97),('15087','2013-06-09','10:50:00',4.02),('15087','2013-06-09','10:55:00',4.03),('15087','2013-06-09','11:00:00',4.02),('15087','2013-06-09','11:05:00',4.02),('15087','2013-06-09','11:10:00',4.1),('15087','2013-06-09','11:15:00',4.2),('15087','2013-06-09','11:20:00',4.2),('15087','2013-06-09','11:25:00',4.18),('15087','2013-06-09','11:30:00',4.25),('15087','2013-06-09','11:35:00',4.3),('15087','2013-06-09','11:40:00',4.34),('15087','2013-06-09','11:45:00',4.45),('15087','2013-06-09','11:50:00',4.41),('15087','2013-06-09','11:55:00',4.38),('15087','2013-06-09','12:00:00',4.38),('15087','2013-06-09','12:05:00',4.44),('15087','2013-06-09','12:10:00',3.74),('15087','2013-06-09','12:15:00',4.42),('15087','2013-06-09','12:20:00',4.49),('15087','2013-06-09','12:25:00',4.45),('15087','2013-06-09','12:30:00',4.52),('15087','2013-06-09','12:35:00',4.43),('15087','2013-06-09','12:40:00',4.51),('15087','2013-06-09','12:45:00',4.41),('15087','2013-06-09','12:50:00',4.68),('15087','2013-06-09','12:55:00',4),('15087','2013-06-09','13:00:00',4.56),('15087','2013-06-09','13:05:00',3.81),('15087','2013-06-09','13:10:00',2.02),('15087','2013-06-09','13:15:00',2.74),('15087','2013-06-09','13:20:00',3.35),('15087','2013-06-09','13:25:00',5.05),('15087','2013-06-09','13:30:00',4.78),('15087','2013-06-09','13:35:00',4.84),('15087','2013-06-09','13:40:00',4.98),('15087','2013-06-09','13:45:00',4.98),('15087','2013-06-09','13:50:00',5.17),('15087','2013-06-09','13:55:00',4.3),('15087','2013-06-09','14:00:00',5.18),('15087','2013-06-09','14:05:00',4.77),('15087','2013-06-09','14:10:00',4.76),('15087','2013-06-09','14:15:00',3.04),('15087','2013-06-09','14:20:00',1.95),('15087','2013-06-09','14:25:00',1.2),('15087','2013-06-09','14:30:00',1.67),('15087','2013-06-09','14:35:00',4.26),('15087','2013-06-09','14:40:00',4.4),('15087','2013-06-09','14:45:00',4.25),('15087','2013-06-09','14:50:00',4.38),('15087','2013-06-09','14:55:00',4.47),('15087','2013-06-09','15:00:00',4.34),('15087','2013-06-09','15:05:00',4.08),('15087','2013-06-09','15:10:00',3.97),('15087','2013-06-09','15:15:00',3.63),('15087','2013-06-09','15:20:00',3.82),('15087','2013-06-09','15:25:00',3.99),('15087','2013-06-09','15:30:00',3.75),('15087','2013-06-09','15:35:00',3.87),('15087','2013-06-09','15:40:00',3.08),('15087','2013-06-09','15:45:00',3.22),('15087','2013-06-09','15:50:00',3.62),('15087','2013-06-09','15:55:00',3.77),('15087','2013-06-09','16:00:00',2.54),('15087','2013-06-09','16:05:00',3.51),('15087','2013-06-09','16:10:00',3.51),('15087','2013-06-09','16:15:00',1.55),('15087','2013-06-09','16:20:00',1.67),('15087','2013-06-09','16:25:00',2.43),('15087','2013-06-09','16:30:00',1.42),('15087','2013-06-09','17:05:00',1.01),('15087','2013-06-09','18:00:00',1.04),('15087','2013-06-09','18:10:00',1.36),('15087','2013-06-08','07:25:00',1.03),('15087','2013-06-08','07:30:00',1.11),('15087','2013-06-08','07:35:00',1.19),('15087','2013-06-08','07:40:00',1.27),('15087','2013-06-08','07:45:00',1.36),('15087','2013-06-08','07:50:00',1.43),('15087','2013-06-08','07:55:00',1.5),('15087','2013-06-08','08:00:00',1.59),('15087','2013-06-08','08:05:00',1.69),('15087','2013-06-08','08:10:00',1.79),('15087','2013-06-08','08:15:00',1.88),('15087','2013-06-08','08:20:00',2),('15087','2013-06-08','08:25:00',2.11),('15087','2013-06-08','08:30:00',2.18),('15087','2013-06-08','08:35:00',2.29),('15087','2013-06-08','08:40:00',2.4),('15087','2013-06-08','08:45:00',2.5),('15087','2013-06-08','08:50:00',2.61),('15087','2013-06-08','08:55:00',2.68),('15087','2013-06-08','09:00:00',2.74),('15087','2013-06-08','09:05:00',2.81),('15087','2013-06-08','09:10:00',2.87),('15087','2013-06-08','09:15:00',2.91),('15087','2013-06-08','09:20:00',3.02),('15087','2013-06-08','09:25:00',3.08),('15087','2013-06-08','09:30:00',3.15),('15087','2013-06-08','09:35:00',3.23),('15087','2013-06-08','09:40:00',3.28),('15087','2013-06-08','09:45:00',3.36),('15087','2013-06-08','09:50:00',3.44),('15087','2013-06-08','09:55:00',3.56),('15087','2013-06-08','10:00:00',3.57),('15087','2013-06-08','10:05:00',3.07),('15087','2013-06-08','10:10:00',3.14),('15087','2013-06-08','10:15:00',3.12),('15087','2013-06-08','10:20:00',3.79),('15087','2013-06-08','10:25:00',3.76),('15087','2013-06-08','10:30:00',3.62),('15087','2013-06-08','10:35:00',3.93),('15087','2013-06-08','10:40:00',4.07),('15087','2013-06-08','10:45:00',4.12),('15087','2013-06-08','10:50:00',4.25),('15087','2013-06-08','10:55:00',1.92),('15087','2013-06-08','11:00:00',1.58),('15087','2013-06-08','11:05:00',3.91),('15087','2013-06-08','11:10:00',3.71),('15087','2013-06-08','11:15:00',4.94),('15087','2013-06-08','11:20:00',4.42),('15087','2013-06-08','11:25:00',2.04),('15087','2013-06-08','11:30:00',1.12),('15087','2013-06-08','11:35:00',3.98),('15087','2013-06-08','11:40:00',4.91),('15087','2013-06-08','11:45:00',1.89),('15087','2013-06-08','11:50:00',4.58),('15087','2013-06-08','11:55:00',5.05),('15087','2013-06-08','12:00:00',4.35),('15087','2013-06-08','12:05:00',1.19),('15087','2013-06-08','12:10:00',3.66),('15087','2013-06-08','12:15:00',4.05),('15087','2013-06-08','12:20:00',1.21),('15087','2013-06-08','12:25:00',3.65),('15087','2013-06-08','12:30:00',1.56),('15087','2013-06-08','12:35:00',4.91),('15087','2013-06-08','12:40:00',4.76),('15087','2013-06-08','12:45:00',4.94),('15087','2013-06-08','12:50:00',4.93),('15087','2013-06-08','12:55:00',4.85),('15087','2013-06-08','13:00:00',4.93),('15087','2013-06-08','13:05:00',4.87),('15087','2013-06-08','13:10:00',4.91),('15087','2013-06-08','13:15:00',4.38),('15087','2013-06-08','13:20:00',4.99),('15087','2013-06-08','13:25:00',4.94),('15087','2013-06-08','13:30:00',5.02),('15087','2013-06-08','13:35:00',4.93),('15087','2013-06-08','13:40:00',4.85),('15087','2013-06-08','13:45:00',4.81),('15087','2013-06-08','13:50:00',4.78),('15087','2013-06-08','13:55:00',4.8),('15087','2013-06-08','14:00:00',4.81),('15087','2013-06-08','14:05:00',4.79),('15087','2013-06-08','14:10:00',4.79),('15087','2013-06-08','14:15:00',4.78),('15087','2013-06-08','14:20:00',4.72),('15087','2013-06-08','14:25:00',4.68),('15087','2013-06-08','14:30:00',4.64),('15087','2013-06-08','14:35:00',4.62),('15087','2013-06-08','14:40:00',4.51),('15087','2013-06-08','14:45:00',4.26),('15087','2013-06-08','14:50:00',4.42),('15087','2013-06-08','14:55:00',4.48),('15087','2013-06-08','15:00:00',4.41),('15087','2013-06-08','15:05:00',4.17),('15087','2013-06-08','15:10:00',3.81),('15087','2013-06-08','15:15:00',4.03),('15087','2013-06-08','15:20:00',4.19),('15087','2013-06-08','15:25:00',3.9),('15087','2013-06-08','15:30:00',3.85),('15087','2013-06-08','15:35:00',3.81),('15087','2013-06-08','15:40:00',3.84),('15087','2013-06-08','15:45:00',4.05),('15087','2013-06-08','15:50:00',4.02),('15087','2013-06-08','15:55:00',3.68),('15087','2013-06-08','16:00:00',3.81),('15087','2013-06-08','16:05:00',3.7),('15087','2013-06-08','16:10:00',3.8),('15087','2013-06-08','16:15:00',3.75),('15087','2013-06-08','16:20:00',3.68),('15087','2013-06-08','16:25:00',3.53),('15087','2013-06-08','16:30:00',3.29),('15087','2013-06-08','16:35:00',3.23),('15087','2013-06-08','16:40:00',3.03),('15087','2013-06-08','16:45:00',3.09),('15087','2013-06-08','16:50:00',2.66),('15087','2013-06-08','16:55:00',2.73),('15087','2013-06-08','17:00:00',3.01),('15087','2013-06-08','17:05:00',2.83),('15087','2013-06-08','17:10:00',3.1),('15087','2013-06-08','17:15:00',3.06),('15087','2013-06-08','17:20:00',2.9),('15087','2013-06-08','17:25:00',2.71),('15087','2013-06-08','17:30:00',1.83),('15087','2013-06-08','17:35:00',1.36),('15087','2013-06-08','17:40:00',2.17),('15087','2013-06-08','17:45:00',2.18),('15087','2013-06-08','17:50:00',1.98),('15087','2013-06-08','17:55:00',1.9),('15087','2013-06-08','18:00:00',1.47),('15087','2013-06-08','18:05:00',1.27),('15087','2013-06-08','18:10:00',1.11),('15087','2013-06-08','18:15:00',1.14),('15087','2013-06-08','18:20:00',1.11),('15087','2013-06-08','18:25:00',1.02),('15087','2013-06-07','07:25:00',1.06),('15087','2013-06-07','07:30:00',1.15),('15087','2013-06-07','07:35:00',1.25),('15087','2013-06-07','07:40:00',1.34),('15087','2013-06-07','07:45:00',1.44),('15087','2013-06-07','07:50:00',1.53),('15087','2013-06-07','07:55:00',1.62),('15087','2013-06-07','08:00:00',1.72),('15087','2013-06-07','08:05:00',1.86),('15087','2013-06-07','08:10:00',1.94),('15087','2013-06-07','08:15:00',2.04),('15087','2013-06-07','08:20:00',2.16),('15087','2013-06-07','08:25:00',2.28),('15087','2013-06-07','08:30:00',2.38),('15087','2013-06-07','08:35:00',2.46),('15087','2013-06-07','08:40:00',2.57),('15087','2013-06-07','08:45:00',2.67),('15087','2013-06-07','08:50:00',2.75),('15087','2013-06-07','08:55:00',2.84),('15087','2013-06-07','09:00:00',2.92),('15087','2013-06-07','09:05:00',2.99),('15087','2013-06-07','09:10:00',3.07),('15087','2013-06-07','09:15:00',3.09),('15087','2013-06-07','09:20:00',3.22),('15087','2013-06-07','09:25:00',3.31),('15087','2013-06-07','09:30:00',3.37),('15087','2013-06-07','09:35:00',3.44),('15087','2013-06-07','09:40:00',3.54),('15087','2013-06-07','09:45:00',3.63),('15087','2013-06-07','09:50:00',3.69),('15087','2013-06-07','09:55:00',3.76),('15087','2013-06-07','10:00:00',3.83),('15087','2013-06-07','10:05:00',3.88),('15087','2013-06-07','10:10:00',3.94),('15087','2013-06-07','10:15:00',3.99),('15087','2013-06-07','10:20:00',4.05),('15087','2013-06-07','10:25:00',4.1),('15087','2013-06-07','10:30:00',4.15),('15087','2013-06-07','10:35:00',4.2),('15087','2013-06-07','10:40:00',4.25),('15087','2013-06-07','10:45:00',4.29),('15087','2013-06-07','10:50:00',4.34),('15087','2013-06-07','10:55:00',4.37),('15087','2013-06-07','11:00:00',4.42),('15087','2013-06-07','11:05:00',4.47),('15087','2013-06-07','11:10:00',4.52),('15087','2013-06-07','11:15:00',4.55),('15087','2013-06-07','11:20:00',4.55),('15087','2013-06-07','11:25:00',4.59),('15087','2013-06-07','11:30:00',4.64),('15087','2013-06-07','11:35:00',4.62),('15087','2013-06-07','11:40:00',4.69),('15087','2013-06-07','11:45:00',4.73),('15087','2013-06-07','11:50:00',4.75),('15087','2013-06-07','11:55:00',4.78),('15087','2013-06-07','12:00:00',4.8),('15087','2013-06-07','12:05:00',4.82),('15087','2013-06-07','12:10:00',4.85),('15087','2013-06-07','12:15:00',4.86),('15087','2013-06-07','12:20:00',4.86),('15087','2013-06-07','12:25:00',4.85),('15087','2013-06-07','12:30:00',4.86),('15087','2013-06-07','12:35:00',4.86),('15087','2013-06-07','12:40:00',4.86),('15087','2013-06-07','12:45:00',4.9),('15087','2013-06-07','12:50:00',4.89),('15087','2013-06-07','12:55:00',4.87),('15087','2013-06-07','13:00:00',4.87),('15087','2013-06-07','13:05:00',4.87),('15087','2013-06-07','13:10:00',4.87),('15087','2013-06-07','13:15:00',4.87),('15087','2013-06-07','13:20:00',4.83),('15087','2013-06-07','13:25:00',4.81),('15087','2013-06-07','13:30:00',4.82),('15087','2013-06-07','13:35:00',4.82),('15087','2013-06-07','13:40:00',4.73),('15087','2013-06-07','13:45:00',4.71),('15087','2013-06-07','13:50:00',4.64),('15087','2013-06-07','13:55:00',4.68),('15087','2013-06-07','14:00:00',4.64),('15087','2013-06-07','14:05:00',4.62),('15087','2013-06-07','14:10:00',4.64),('15087','2013-06-07','14:15:00',4.61),('15087','2013-06-07','14:20:00',4.49),('15087','2013-06-07','14:25:00',4.47),('15087','2013-06-07','14:30:00',4.41),('15087','2013-06-07','14:35:00',4.35),('15087','2013-06-07','14:40:00',4.29),('15087','2013-06-07','14:45:00',4.08),('15087','2013-06-07','14:50:00',4.16),('15087','2013-06-07','14:55:00',4.25),('15087','2013-06-07','15:00:00',4.22),('15087','2013-06-07','15:05:00',4.23),('15087','2013-06-07','15:10:00',4.16),('15087','2013-06-07','15:15:00',4.11),('15087','2013-06-07','15:20:00',4.09),('15087','2013-06-07','15:25:00',4.09),('15087','2013-06-07','15:30:00',3.89),('15087','2013-06-07','15:35:00',3.78),('15087','2013-06-07','15:40:00',3.87),('15087','2013-06-07','15:45:00',3.79),('15087','2013-06-07','15:50:00',3.75),('15087','2013-06-07','15:55:00',3.64),('15087','2013-06-07','16:00:00',3.61),('15087','2013-06-07','16:05:00',3.37),('15087','2013-06-07','16:10:00',3.48),('15087','2013-06-07','16:15:00',3.29),('15087','2013-06-07','16:20:00',3.32),('15087','2013-06-07','16:25:00',3.38),('15087','2013-06-07','16:30:00',3.25),('15087','2013-06-07','16:35:00',3.2),('15087','2013-06-07','16:40:00',3.11),('15087','2013-06-07','16:45:00',3.11),('15087','2013-06-07','16:50:00',3.1),('15087','2013-06-07','16:55:00',3.01),('15087','2013-06-07','17:00:00',2.94),('15087','2013-06-07','17:05:00',2.82),('15087','2013-06-07','17:10:00',2.78),('15087','2013-06-07','17:15:00',2.65),('15087','2013-06-07','17:20:00',2.59),('15087','2013-06-07','17:25:00',2.54),('15087','2013-06-07','17:30:00',2.4),('15087','2013-06-07','17:35:00',2.29),('15087','2013-06-07','17:40:00',2.17),('15087','2013-06-07','17:45:00',2.03),('15087','2013-06-07','17:50:00',1.95),('15087','2013-06-07','17:55:00',1.77),('15087','2013-06-07','18:00:00',1.59),('15087','2013-06-07','18:05:00',1.44),('15087','2013-06-07','18:10:00',1.5),('15087','2013-06-07','18:15:00',1.34),('15087','2013-06-07','18:20:00',1.24),('15087','2013-06-07','18:25:00',1.09),('15087','2013-06-07','18:30:00',1.04),('15087','2013-06-06','07:05:00',1.1),('15087','2013-06-06','07:15:00',1.15),('15087','2013-06-06','07:50:00',1.34),('15087','2013-06-06','07:55:00',1.78),('15087','2013-06-06','08:00:00',1.84),('15087','2013-06-06','08:05:00',1.4),('15087','2013-06-06','08:10:00',1.92),('15087','2013-06-06','08:15:00',1.52),('15087','2013-06-06','08:20:00',1.89),('15087','2013-06-06','08:25:00',2.27),('15087','2013-06-06','08:30:00',2.35),('15087','2013-06-06','08:35:00',2.43),('15087','2013-06-06','08:40:00',2.5),('15087','2013-06-06','08:45:00',2.57),('15087','2013-06-06','08:50:00',2.67),('15087','2013-06-06','08:55:00',2.74),('15087','2013-06-06','09:00:00',2.81),('15087','2013-06-06','09:05:00',2.92),('15087','2013-06-06','09:10:00',2.99),('15087','2013-06-06','09:15:00',3.1),('15087','2013-06-06','09:20:00',3.18),('15087','2013-06-06','09:25:00',3.25),('15087','2013-06-06','09:30:00',3.3),('15087','2013-06-06','09:35:00',3.27),('15087','2013-06-06','09:40:00',3.4),('15087','2013-06-06','09:45:00',3.5),('15087','2013-06-06','09:50:00',3.58),('15087','2013-06-06','09:55:00',3.64),('15087','2013-06-06','10:00:00',3.59),('15087','2013-06-06','10:05:00',3.64),('15087','2013-06-06','10:10:00',3.64),('15087','2013-06-06','10:15:00',3.84),('15087','2013-06-06','10:20:00',3.94),('15087','2013-06-06','10:25:00',3.98),('15087','2013-06-06','10:30:00',4),('15087','2013-06-06','10:35:00',4),('15087','2013-06-06','10:40:00',4.1),('15087','2013-06-06','10:45:00',4.08),('15087','2013-06-06','10:50:00',4.2),('15087','2013-06-06','10:55:00',4.27),('15087','2013-06-06','11:00:00',4.29),('15087','2013-06-06','11:05:00',4.31),('15087','2013-06-06','11:10:00',4.26),('15087','2013-06-06','11:15:00',4.34),('15087','2013-06-06','11:20:00',4.36),('15087','2013-06-06','11:25:00',4.44),('15087','2013-06-06','11:30:00',4.47),('15087','2013-06-06','11:35:00',4.49),('15087','2013-06-06','11:40:00',4.44),('15087','2013-06-06','11:45:00',4.54),('15087','2013-06-06','11:50:00',4.58),('15087','2013-06-06','11:55:00',4.66),('15087','2013-06-06','12:00:00',4.61),('15087','2013-06-06','12:05:00',4.59),('15087','2013-06-06','12:10:00',4.62),('15087','2013-06-06','12:15:00',4.58),('15087','2013-06-06','12:20:00',4.62),('15087','2013-06-06','12:25:00',4.65),('15087','2013-06-06','12:30:00',4.64),('15087','2013-06-06','12:35:00',4.63),('15087','2013-06-06','12:40:00',4.67),('15087','2013-06-06','12:45:00',4.72),('15087','2013-06-06','12:50:00',4.77),('15087','2013-06-06','12:55:00',4.76),('15087','2013-06-06','13:00:00',4.75),('15087','2013-06-06','13:05:00',4.84),('15087','2013-06-06','13:10:00',4.87),('15087','2013-06-06','13:15:00',4.86),('15087','2013-06-06','13:20:00',4.77),('15087','2013-06-06','13:25:00',4.71),('15087','2013-06-06','13:30:00',4.9),('15087','2013-06-06','13:35:00',4.68),('15087','2013-06-06','13:40:00',1),('15087','2013-06-06','13:50:00',1.99),('15087','2013-06-06','13:55:00',4.34),('15087','2013-06-06','14:00:00',4.51),('15087','2013-06-06','14:05:00',1.36),('15087','2013-06-06','14:10:00',2.4),('15087','2013-06-06','14:15:00',3.46),('15087','2013-06-06','14:20:00',3.49),('15087','2013-06-06','14:25:00',3.91),('15087','2013-06-06','14:30:00',4.4),('15087','2013-06-06','14:35:00',4.56),('15087','2013-06-06','14:40:00',4.58),('15087','2013-06-06','14:45:00',4.06),('15087','2013-06-06','14:50:00',4.74),('15087','2013-06-06','14:55:00',4.45),('15087','2013-06-06','15:00:00',4.32),('15087','2013-06-06','15:05:00',4.34),('15087','2013-06-06','15:10:00',4.1),('15087','2013-06-06','15:15:00',3.75),('15087','2013-06-06','15:20:00',4.05),('15087','2013-06-06','15:25:00',3.71),('15087','2013-06-06','15:30:00',3.79),('15087','2013-06-06','15:35:00',3.82),('15087','2013-06-06','15:40:00',3.86),('15087','2013-06-06','15:45:00',3.8),('15087','2013-06-06','15:50:00',3.75),('15087','2013-06-06','15:55:00',3.72),('15087','2013-06-06','16:00:00',3.75),('15087','2013-06-06','16:05:00',3.73),('15087','2013-06-06','16:10:00',3.58),('15087','2013-06-06','16:15:00',3.3),('15087','2013-06-06','16:20:00',3.36),('15087','2013-06-06','16:25:00',3.28),('15087','2013-06-06','16:30:00',3.16),('15087','2013-06-06','16:35:00',3.21),('15087','2013-06-06','16:40:00',3.09),('15087','2013-06-06','16:45:00',3.01),('15087','2013-06-06','16:50:00',2.99),('15087','2013-06-06','16:55:00',2.86),('15087','2013-06-06','17:00:00',2.81),('15087','2013-06-06','17:05:00',2.7),('15087','2013-06-06','17:10:00',2.66),('15087','2013-06-06','17:15:00',2.56),('15087','2013-06-06','17:20:00',2.5),('15087','2013-06-06','17:25:00',2.45),('15087','2013-06-06','17:30:00',2.29),('15087','2013-06-06','17:35:00',2.15),('15087','2013-06-06','17:40:00',2.03),('15087','2013-06-06','17:45:00',1.82),('15087','2013-06-06','17:50:00',1.73),('15087','2013-06-06','17:55:00',1.59),('15087','2013-06-06','18:00:00',1.46),('15087','2013-06-06','18:05:00',1.43),('15087','2013-06-06','18:10:00',1.38),('15087','2013-06-06','18:15:00',1.26),('15087','2013-06-06','18:20:00',1.18),('15087','2013-06-06','18:25:00',1.07),('15087','2013-06-06','18:30:00',1.02),('15087','2013-06-05','07:45:00',1.3),('15087','2013-06-05','07:50:00',1.76),('15087','2013-06-05','07:55:00',2),('15087','2013-06-05','08:00:00',1.92),('15087','2013-06-05','08:05:00',1.64),('15087','2013-06-05','08:10:00',1.88),('15087','2013-06-05','08:15:00',2.03),('15087','2013-06-05','08:20:00',2.12),('15087','2013-06-05','08:25:00',2.25),('15087','2013-06-05','08:30:00',2.33),('15087','2013-06-05','08:35:00',2.41),('15087','2013-06-05','08:40:00',2.5),('15087','2013-06-05','08:45:00',2.59),('15087','2013-06-05','08:50:00',2.64),('15087','2013-06-05','08:55:00',2.77),('15087','2013-06-05','09:00:00',2.81),('15087','2013-06-05','09:05:00',3.02),('15087','2013-06-05','09:10:00',3.13),('15087','2013-06-05','09:15:00',3.2),('15087','2013-06-05','09:20:00',3.29),('15087','2013-06-05','09:25:00',3.55),('15087','2013-06-05','09:30:00',2.69),('15087','2013-06-05','09:35:00',4.11),('15087','2013-06-05','09:40:00',4.07),('15087','2013-06-05','09:45:00',2.05),('15087','2013-06-05','09:50:00',1.4),('15087','2013-06-05','09:55:00',2.73),('15087','2013-06-05','10:00:00',3.79),('15087','2013-06-05','10:05:00',3.54),('15087','2013-06-05','10:10:00',3.69),('15087','2013-06-05','10:15:00',1.84),('15087','2013-06-05','10:20:00',1.97),('15087','2013-06-05','10:25:00',1.54),('15087','2013-06-05','10:30:00',1.6),('15087','2013-06-05','10:35:00',2.24),('15087','2013-06-05','10:40:00',4.7),('15087','2013-06-05','10:45:00',4.78),('15087','2013-06-05','10:50:00',4.69),('15087','2013-06-05','10:55:00',4.37),('15087','2013-06-05','11:00:00',1.87),('15087','2013-06-05','11:05:00',1.49),('15087','2013-06-05','11:10:00',1.19),('15087','2013-06-05','11:15:00',1.18),('15087','2013-06-05','11:20:00',1.12),('15087','2013-06-05','11:25:00',1.17),('15087','2013-06-05','11:30:00',1.42),('15087','2013-06-05','11:35:00',4.32),('15087','2013-06-05','11:40:00',3.87),('15087','2013-06-05','11:45:00',2.37),('15087','2013-06-05','11:50:00',2.9),('15087','2013-06-05','11:55:00',5.21),('15087','2013-06-05','12:00:00',5.24),('15087','2013-06-05','12:05:00',5.19),('15087','2013-06-05','12:10:00',5.23),('15087','2013-06-05','12:15:00',5.2),('15087','2013-06-05','12:20:00',5.47),('15087','2013-06-05','12:25:00',4.86),('15087','2013-06-05','12:30:00',5.07),('15087','2013-06-05','12:35:00',4.07),('15087','2013-06-05','12:40:00',5.38),('15087','2013-06-05','12:45:00',4.98),('15087','2013-06-05','12:50:00',2.13),('15087','2013-06-05','12:55:00',2.8),('15087','2013-06-05','13:00:00',5.15),('15087','2013-06-05','13:05:00',3.11),('15087','2013-06-05','13:10:00',4.73),('15087','2013-06-05','13:15:00',4.12),('15087','2013-06-05','13:20:00',2.55),('15087','2013-06-05','13:25:00',3.1),('15087','2013-06-05','13:30:00',4.79),('15087','2013-06-05','13:35:00',5.38),('15087','2013-06-05','13:40:00',5.01),('15087','2013-06-05','13:45:00',5.08),('15087','2013-06-05','13:50:00',4.99),('15087','2013-06-05','13:55:00',4.98),('15087','2013-06-05','14:00:00',4.89),('15087','2013-06-05','14:05:00',4.93),('15087','2013-06-05','14:10:00',4.89),('15087','2013-06-05','14:15:00',4.84),('15087','2013-06-05','14:20:00',4.77),('15087','2013-06-05','14:25:00',4.74),('15087','2013-06-05','14:30:00',4.06),('15087','2013-06-05','14:35:00',4.72),('15087','2013-06-05','14:40:00',4.52),('15087','2013-06-05','14:45:00',4.34),('15087','2013-06-05','14:50:00',4.34),('15087','2013-06-05','14:55:00',4.52),('15087','2013-06-05','15:00:00',4.39),('15087','2013-06-05','15:05:00',4.26),('15087','2013-06-05','15:10:00',4.3),('15087','2013-06-05','15:15:00',4.26),('15087','2013-06-05','15:20:00',4.21),('15087','2013-06-05','15:25:00',4.16),('15087','2013-06-05','15:30:00',3.99),('15087','2013-06-05','15:35:00',3.89),('15087','2013-06-05','15:40:00',4.02),('15087','2013-06-05','15:45:00',3.97),('15087','2013-06-05','15:50:00',3.89),('15087','2013-06-05','15:55:00',3.82),('15087','2013-06-05','16:00:00',3.74),('15087','2013-06-05','16:05:00',3.56),('15087','2013-06-05','16:10:00',3.6),('15087','2013-06-05','16:15:00',3.66),('15087','2013-06-05','16:20:00',3.57),('15087','2013-06-05','16:25:00',3.49),('15087','2013-06-05','16:30:00',3.32),('15087','2013-06-05','16:35:00',3.29),('15087','2013-06-05','16:40:00',3.18),('15087','2013-06-05','16:45:00',3.18),('15087','2013-06-05','16:50:00',3.14),('15087','2013-06-05','16:55:00',3.11),('15087','2013-06-05','17:00:00',1.35),('15087','2013-06-05','17:05:00',2.39),('15087','2013-06-05','17:10:00',1.81),('15087','2013-06-05','17:15:00',1.96),('15087','2013-06-05','17:20:00',2.17),('15087','2013-06-05','17:25:00',2.08),('15087','2013-06-05','17:30:00',2.03),('15087','2013-06-05','17:35:00',1.74),('15087','2013-06-05','17:40:00',2.26),('15087','2013-06-05','17:45:00',1.95),('15087','2013-06-05','17:50:00',1.82),('15087','2013-06-05','17:55:00',1.69),('15087','2013-06-05','18:00:00',1.5),('15087','2013-06-05','18:10:00',1.08),('15087','2013-06-05','18:25:00',1.2),('15087','2013-06-05','18:30:00',1.13),('15087','2013-06-05','18:35:00',1.13),('15087','2013-06-04','07:25:00',1.07),('15087','2013-06-04','07:30:00',1.17),('15087','2013-06-04','07:35:00',1.27),('15087','2013-06-04','07:40:00',1.47),('15087','2013-06-04','07:45:00',1.74),('15087','2013-06-04','07:50:00',1.95),('15087','2013-06-04','07:55:00',2.09),('15087','2013-06-04','08:00:00',2.33),('15087','2013-06-04','08:05:00',2.49),('15087','2013-06-04','08:10:00',2.52),('15087','2013-06-04','08:15:00',2.56),('15087','2013-06-04','08:20:00',2.55),('15087','2013-06-04','08:25:00',2.52),('15087','2013-06-04','08:30:00',2.79),('15087','2013-06-04','08:35:00',2.38),('15087','2013-06-04','08:40:00',2.19),('15087','2013-06-04','08:45:00',1.9),('15087','2013-06-04','08:50:00',1.52),('15087','2013-06-04','08:55:00',1.52),('15087','2013-06-04','09:00:00',1.83),('15087','2013-06-04','09:05:00',1.88),('15087','2013-06-04','09:10:00',2.72),('15087','2013-06-04','09:15:00',3.48),('15087','2013-06-04','09:20:00',3.73),('15087','2013-06-04','09:25:00',2.72),('15087','2013-06-04','09:30:00',3.6),('15087','2013-06-04','09:35:00',2.47),('15087','2013-06-04','09:40:00',2.29),('15087','2013-06-04','09:45:00',2.28),('15087','2013-06-04','09:50:00',2.12),('15087','2013-06-04','09:55:00',1.96),('15087','2013-06-04','10:00:00',2.24),('15087','2013-06-04','10:05:00',3.07),('15087','2013-06-04','10:10:00',2.61),('15087','2013-06-04','10:15:00',1.96),('15087','2013-06-04','10:20:00',2.13),('15087','2013-06-04','10:25:00',2.05),('15087','2013-06-04','10:30:00',1.82),('15087','2013-06-04','10:35:00',1.85),('15087','2013-06-04','10:40:00',2.12),('15087','2013-06-04','10:45:00',2.58),('15087','2013-06-04','10:50:00',3.31),('15087','2013-06-04','10:55:00',3.08),('15087','2013-06-04','11:00:00',2.51),('15087','2013-06-04','11:05:00',3.15),('15087','2013-06-04','11:10:00',4.13),('15087','2013-06-04','11:15:00',3.52),('15087','2013-06-04','11:20:00',2.56),('15087','2013-06-04','11:25:00',3.19),('15087','2013-06-04','11:30:00',3.67),('15087','2013-06-04','11:35:00',3.3),('15087','2013-06-04','11:40:00',3.64),('15087','2013-06-04','11:45:00',4.23),('15087','2013-06-04','11:50:00',4.88),('15087','2013-06-04','11:55:00',3.9),('15087','2013-06-04','12:00:00',2.72),('15087','2013-06-04','12:05:00',4.17),('15087','2013-06-04','12:10:00',2.95),('15087','2013-06-04','12:15:00',2.53),('15087','2013-06-04','12:20:00',2.16),('15087','2013-06-04','12:25:00',2.58),('15087','2013-06-04','12:30:00',3.51),('15087','2013-06-04','12:35:00',4.14),('15087','2013-06-04','12:40:00',2.65),('15087','2013-06-04','12:45:00',3.16),('15087','2013-06-04','12:50:00',2.19),('15087','2013-06-04','12:55:00',1.84),('15087','2013-06-04','13:00:00',1.81),('15087','2013-06-04','13:05:00',1.59),('15087','2013-06-04','13:10:00',1.54),('15087','2013-06-04','13:15:00',1.18),('15087','2013-06-04','13:20:00',1.23),('15087','2013-06-04','13:25:00',1.5),('15087','2013-06-04','13:30:00',2.45),('15087','2013-06-04','13:35:00',4.41),('15087','2013-06-04','13:40:00',3.59),('15087','2013-06-04','13:45:00',3.06),('15087','2013-06-04','13:50:00',4.53),('15087','2013-06-04','13:55:00',3.57),('15087','2013-06-04','14:00:00',2.5),('15087','2013-06-04','14:05:00',4.31),('15087','2013-06-04','14:10:00',5),('15087','2013-06-04','14:15:00',2.61),('15087','2013-06-04','14:20:00',5.35),('15087','2013-06-04','14:25:00',1.45),('15087','2013-06-04','14:30:00',1.24),('15087','2013-06-04','14:35:00',1.55),('15087','2013-06-04','14:40:00',2.74),('15087','2013-06-04','14:45:00',1.35),('15087','2013-06-04','14:50:00',1.41),('15087','2013-06-04','14:55:00',3.55),('15087','2013-06-04','15:00:00',5.41),('15087','2013-06-04','15:05:00',2.63),('15087','2013-06-04','15:10:00',1.75),('15087','2013-06-04','15:15:00',2.16),('15087','2013-06-04','15:20:00',1.19),('15087','2013-06-03','07:40:00',1.33),('15087','2013-06-03','07:45:00',1.4),('15087','2013-06-03','07:50:00',1.63),('15087','2013-06-03','07:55:00',1.71),('15087','2013-06-03','08:00:00',1.82),('15087','2013-06-03','08:05:00',1.88),('15087','2013-06-03','08:10:00',1.97),('15087','2013-06-03','08:15:00',2.07),('15087','2013-06-03','08:20:00',2.15),('15087','2013-06-03','08:25:00',2.26),('15087','2013-06-03','08:30:00',2.34),('15087','2013-06-03','08:35:00',2.41),('15087','2013-06-03','08:40:00',2.51),('15087','2013-06-03','08:45:00',2.58),('15087','2013-06-03','08:50:00',2.63),('15087','2013-06-03','08:55:00',2.74),('15087','2013-06-03','09:00:00',2.88),('15087','2013-06-03','09:05:00',2.97),('15087','2013-06-03','09:10:00',3.1),('15087','2013-06-03','09:15:00',3.42),('15087','2013-06-03','09:20:00',2.68),('15087','2013-06-03','09:25:00',2.48),('15087','2013-06-03','09:30:00',1.93),('15087','2013-06-03','09:35:00',1.99),('15087','2013-06-03','09:40:00',3),('15087','2013-06-03','09:45:00',3.86),('15087','2013-06-03','09:50:00',3.7),('15087','2013-06-03','09:55:00',3.98),('15087','2013-06-03','10:00:00',4.09),('15087','2013-06-03','10:05:00',4.03),('15087','2013-06-03','10:10:00',3.05),('15087','2013-06-03','10:15:00',1.25),('15087','2013-06-03','10:30:00',1.09),('15087','2013-06-03','10:35:00',1.25),('15087','2013-06-03','10:40:00',1.41),('15087','2013-06-03','10:45:00',2.44),('15087','2013-06-03','10:50:00',4.24),('15087','2013-06-03','10:55:00',3.46),('15087','2013-06-03','11:00:00',4.32),('15087','2013-06-03','11:05:00',3.3),('15087','2013-06-03','11:10:00',1.65),('15087','2013-06-03','11:15:00',1.46),('15087','2013-06-03','11:20:00',1.79),('15087','2013-06-03','11:25:00',1.77),('15087','2013-06-03','11:30:00',2.61),('15087','2013-06-03','11:35:00',1.49),('15087','2013-06-03','11:40:00',1.51),('15087','2013-06-03','11:45:00',1.56),('15087','2013-06-03','11:50:00',1.75),('15087','2013-06-03','11:55:00',1.79),('15087','2013-06-03','12:00:00',1.9),('15087','2013-06-03','12:05:00',1.37),('15087','2013-06-03','12:10:00',1.93),('15087','2013-06-03','12:15:00',1.37),('15087','2013-06-03','12:20:00',1.49),('15087','2013-06-03','12:25:00',1.28),('15087','2013-06-03','12:30:00',1.47),('15087','2013-06-03','12:35:00',2.64),('15087','2013-06-03','12:40:00',5.02),('15087','2013-06-03','12:45:00',3.59),('15087','2013-06-03','12:50:00',2.46),('15087','2013-06-03','12:55:00',4.03),('15087','2013-06-03','13:00:00',3.17),('15087','2013-06-03','13:05:00',2.42),('15087','2013-06-03','13:10:00',2.4),('15087','2013-06-03','13:15:00',4.9),('15087','2013-06-03','13:20:00',5.56),('15087','2013-06-03','13:25:00',5.57),('15087','2013-06-03','13:30:00',4.43),('15087','2013-06-03','13:35:00',5.4),('15087','2013-06-03','13:40:00',5.16),('15087','2013-06-03','13:45:00',4.87),('15087','2013-06-03','13:50:00',4.78),('15087','2013-06-03','13:55:00',2.18),('15087','2013-06-03','14:00:00',3.12),('15087','2013-06-03','14:05:00',3.74),('15087','2013-06-03','14:10:00',2.64),('15087','2013-06-03','14:15:00',3.02),('15087','2013-06-03','14:20:00',3.25),('15087','2013-06-03','14:25:00',2.88),('15087','2013-06-03','14:30:00',5.29),('15087','2013-06-03','14:35:00',5.23),('15087','2013-06-03','14:40:00',3.76),('15087','2013-06-03','14:45:00',3.26),('15087','2013-06-03','14:50:00',2.84),('15087','2013-06-03','14:55:00',3.92),('15087','2013-06-03','15:00:00',4.21),('15087','2013-06-03','15:05:00',4.52),('15087','2013-06-03','15:10:00',4.11),('15087','2013-06-03','15:15:00',4.79),('15087','2013-06-03','15:20:00',3.39),('15087','2013-06-03','15:25:00',4.22),('15087','2013-06-03','15:30:00',4.13),('15087','2013-06-03','15:35:00',4.1),('15087','2013-06-03','15:40:00',4),('15087','2013-06-03','15:45:00',3.91),('15087','2013-06-03','15:50:00',3.89),('15087','2013-06-03','15:55:00',3.82),('15087','2013-06-03','16:00:00',3.66),('15087','2013-06-03','16:05:00',3.58),('15087','2013-06-03','16:10:00',3.74),('15087','2013-06-03','16:15:00',3.63),('15087','2013-06-03','16:20:00',3.35),('15087','2013-06-03','16:25:00',3.59),('15087','2013-06-03','16:30:00',3.63),('15087','2013-06-03','16:35:00',3.52),('15087','2013-06-03','16:40:00',3.5),('15087','2013-06-03','16:45:00',3.02),('15087','2013-06-03','16:50:00',2.55),('15087','2013-06-03','16:55:00',2.13),('15087','2013-06-03','17:00:00',2.88),('15087','2013-06-03','17:05:00',3.41),('15087','2013-06-03','17:10:00',3.12),('15087','2013-06-03','17:15:00',2.72),('15087','2013-06-03','17:20:00',2.41),('15087','2013-06-03','17:25:00',1.68),('15087','2013-06-02','06:55:00',1.1),('15087','2013-06-02','08:45:00',1.06),('15087','2013-06-02','08:50:00',1.09),('15087','2013-06-02','09:05:00',1.04),('15087','2013-06-02','09:10:00',1.15),('15087','2013-06-02','09:15:00',1.42),('15087','2013-06-02','09:20:00',2.48),('15087','2013-06-02','09:25:00',3.75),('15087','2013-06-02','09:30:00',3.6),('15087','2013-06-02','09:35:00',3.58),('15087','2013-06-02','09:40:00',3.57),('15087','2013-06-02','09:45:00',3.57),('15087','2013-06-02','09:50:00',3.66),('15087','2013-06-02','09:55:00',3.71),('15087','2013-06-02','10:00:00',3.81),('15087','2013-06-02','10:05:00',3.85),('15087','2013-06-02','10:10:00',3.92),('15087','2013-06-02','10:15:00',3.99),('15087','2013-06-02','10:20:00',4.04),('15087','2013-06-02','10:25:00',3.5),('15087','2013-06-02','10:30:00',4.07),('15087','2013-06-02','10:35:00',1.36),('15087','2013-06-02','10:40:00',1.46),('15087','2013-06-02','10:45:00',4.31),('15087','2013-06-02','10:50:00',4.69),('15087','2013-06-02','10:55:00',4.92),('15087','2013-06-02','11:00:00',5.07),('15087','2013-06-02','11:05:00',4.47),('15087','2013-06-02','11:10:00',1.48),('15087','2013-06-02','11:15:00',4.35),('15087','2013-06-02','11:20:00',4.99),('15087','2013-06-02','11:25:00',4.09),('15087','2013-06-02','11:30:00',1.94),('15087','2013-06-02','11:35:00',2.54),('15087','2013-06-02','11:40:00',2.29),('15087','2013-06-02','11:45:00',1.87),('15087','2013-06-02','11:50:00',1.68),('15087','2013-06-02','11:55:00',3.47),('15087','2013-06-02','12:00:00',1.75),('15087','2013-06-02','12:05:00',1.49),('15087','2013-06-02','12:10:00',3.64),('15087','2013-06-02','12:15:00',2.55),('15087','2013-06-02','12:20:00',2.72),('15087','2013-06-02','12:25:00',3.96),('15087','2013-06-02','12:30:00',3.76),('15087','2013-06-02','12:35:00',3.46),('15087','2013-06-02','12:40:00',4.34),('15087','2013-06-02','12:45:00',3.48),('15087','2013-06-02','12:50:00',2.54),('15087','2013-06-02','12:55:00',4.17),('15087','2013-06-02','13:00:00',3.17),('15087','2013-06-02','13:05:00',3.27),('15087','2013-06-02','13:10:00',5.06),('15087','2013-06-02','13:15:00',5.21),('15087','2013-06-02','13:20:00',5.05),('15087','2013-06-02','13:25:00',5.01),('15087','2013-06-02','13:30:00',4.97),('15087','2013-06-02','13:35:00',4.94),('15087','2013-06-02','13:40:00',4.93),('15087','2013-06-02','13:45:00',4.91),('15087','2013-06-02','13:50:00',4.88),('15087','2013-06-02','13:55:00',4.89),('15087','2013-06-02','14:00:00',4.88),('15087','2013-06-02','14:05:00',4.84),('15087','2013-06-02','14:10:00',4.87),('15087','2013-06-02','14:15:00',4.78),('15087','2013-06-02','14:20:00',4.76),('15087','2013-06-02','14:25:00',4.77),('15087','2013-06-02','14:30:00',4.75),('15087','2013-06-02','14:35:00',4.63),('15087','2013-06-02','14:40:00',4.6),('15087','2013-06-02','14:45:00',4.56),('15087','2013-06-02','14:50:00',4.54),('15087','2013-06-02','14:55:00',4.46),('15087','2013-06-02','15:00:00',4.33),('15087','2013-06-02','15:05:00',4.11),('15087','2013-06-02','15:10:00',4.28),('15087','2013-06-02','15:15:00',4.28),('15087','2013-06-02','15:20:00',2.62),('15087','2013-06-02','15:25:00',4.03),('15087','2013-06-02','15:30:00',3.45),('15087','2013-06-02','15:35:00',3.18),('15087','2013-06-02','15:40:00',3.33),('15087','2013-06-02','15:45:00',3.2),('15087','2013-06-02','15:50:00',3.07),('15087','2013-06-02','15:55:00',4.03),('15087','2013-06-02','16:00:00',3.69),('15087','2013-06-02','16:05:00',3.62),('15087','2013-06-02','16:10:00',3.62),('15087','2013-06-02','16:15:00',3.69),('15087','2013-06-02','16:20:00',3.25),('15087','2013-06-02','16:25:00',3.57),('15087','2013-06-02','16:30:00',3.36),('15087','2013-06-02','16:35:00',3.35),('15087','2013-06-02','16:40:00',3.32),('15087','2013-06-02','16:45:00',2.54),('15087','2013-06-02','16:50:00',3.17),('15087','2013-06-02','16:55:00',3.05),('15087','2013-06-02','17:00:00',2.46),('15087','2013-06-02','17:05:00',2.93),('15087','2013-06-02','17:10:00',2.84),('15087','2013-06-02','17:15:00',2.79),('15087','2013-06-02','17:20:00',2.65),('15087','2013-06-02','17:25:00',2.59),('15087','2013-06-02','17:30:00',2.09),('15087','2013-06-02','17:35:00',1.54),('15087','2013-06-02','17:40:00',1.22),('15087','2013-06-02','17:45:00',1.54),('15087','2013-06-02','17:50:00',1.6),('15087','2013-06-01','07:20:00',1.02),('15087','2013-06-01','07:25:00',1.11),('15087','2013-06-01','07:30:00',1.2),('15087','2013-06-01','07:35:00',1.3),('15087','2013-06-01','07:40:00',1.42),('15087','2013-06-01','07:45:00',1.55),('15087','2013-06-01','07:50:00',1.12),('15087','2013-06-01','07:55:00',1.37),('15087','2013-06-01','08:10:00',1.04),('15087','2013-06-01','08:15:00',1.49),('15087','2013-06-01','08:20:00',1.1),('15087','2013-06-01','08:30:00',1.53),('15087','2013-06-01','08:35:00',1.25),('15087','2013-06-01','10:35:00',1.38),('15087','2013-06-01','10:40:00',1.12),('15087','2013-06-01','10:50:00',2.74),('15087','2013-06-01','10:55:00',2.89),('15087','2013-06-01','11:50:00',1.56),('15087','2013-06-01','11:55:00',1.97),('15087','2013-06-01','12:00:00',3.98),('15087','2013-06-01','12:05:00',2.87),('15087','2013-06-01','12:10:00',3.27),('15087','2013-06-01','12:15:00',1.37),('15087','2013-06-01','12:20:00',1.06),('15087','2013-06-01','12:25:00',1.3),('15087','2013-06-01','12:30:00',1.18),('15087','2013-06-01','12:40:00',1.22),('15087','2013-06-01','12:45:00',2.03),('15087','2013-06-01','12:50:00',2.18),('15087','2013-06-01','12:55:00',2.31),('15087','2013-06-01','13:00:00',2.46),('15087','2013-06-01','13:05:00',2.57),('15087','2013-06-01','13:10:00',2.72),('15087','2013-06-01','13:15:00',2.89),('15087','2013-06-01','13:20:00',2.41),('15087','2013-06-01','13:25:00',2.05),('15087','2013-06-01','13:30:00',1.7),('15087','2013-06-01','13:35:00',1.27),('15087','2013-06-01','13:40:00',1.11),('15087','2013-06-01','13:45:00',1.23),('15087','2013-06-01','13:50:00',1.41),('15087','2013-06-01','13:55:00',1.67),('15087','2013-06-01','14:00:00',2.39),('15087','2013-06-01','14:05:00',2.63),('15087','2013-06-01','14:10:00',2.58),('15087','2013-06-01','14:15:00',2.95),('15087','2013-06-01','14:20:00',2.68),('15087','2013-06-01','14:25:00',1.75),('15087','2013-06-01','14:30:00',1.43),('15087','2013-06-01','14:35:00',1.44),('15087','2013-06-01','14:40:00',1.33),('15087','2013-06-01','14:45:00',1.25),('15087','2013-06-01','14:50:00',1.16),('15087','2013-06-01','18:30:00',1.01),('15087','2013-06-01','18:35:00',1.04),('15087','2013-06-01','19:00:00',1.39),('15087','2014-04-02','08:50:00',1.29),('15087','2014-04-02','08:55:00',1.41),('15087','2014-04-02','09:15:00',1.07),('15087','2014-04-02','09:50:00',1.61),('15087','2014-04-02','09:55:00',3.06),('15087','2014-04-02','10:00:00',2.5),('15087','2014-04-02','10:05:00',3.29),('15087','2014-04-02','10:10:00',3.71),('15087','2014-04-02','10:15:00',3.29),('15087','2014-04-02','10:20:00',3.03),('15087','2014-04-02','10:25:00',2.53),('15087','2014-04-02','10:30:00',1.39),('15087','2014-04-02','10:35:00',1.27),('15087','2014-04-02','10:40:00',1.38),('15087','2014-04-02','10:45:00',1.48),('15087','2014-04-02','10:50:00',3.5),('15087','2014-04-02','10:55:00',4.23),('15087','2014-04-02','11:00:00',3.22),('15087','2014-04-02','11:05:00',1.73),('15087','2014-04-02','11:10:00',1.31),('15087','2014-04-02','11:15:00',4.09),('15087','2014-04-02','11:20:00',4.17),('15087','2014-04-02','11:25:00',4.71),('15087','2014-04-02','11:30:00',3.8),('15087','2014-04-02','11:35:00',1.3),('15087','2014-04-02','11:40:00',1.21),('15087','2014-04-02','11:45:00',3.19),('15087','2014-04-02','11:50:00',4.59),('15087','2014-04-02','11:55:00',4.71),('15087','2014-04-02','12:00:00',4.75),('15087','2014-04-02','12:05:00',1.83),('15087','2014-04-02','12:10:00',2.21),('15087','2014-04-02','12:15:00',4.64),('15087','2014-04-02','12:20:00',4.39),('15087','2014-04-02','12:25:00',1.77),('15087','2014-04-02','12:30:00',5.14),('15087','2014-04-02','12:35:00',4.24),('15087','2014-04-02','12:40:00',4.81),('15087','2014-04-02','12:45:00',4.37),('15087','2014-04-02','12:50:00',4.96),('15087','2014-04-02','12:55:00',2.09),('15087','2014-04-02','13:00:00',3.37),('15087','2014-04-02','13:05:00',5.14),('15087','2014-04-02','13:10:00',4.4),('15087','2014-04-02','13:15:00',4.8),('15087','2014-04-02','13:20:00',4.78),('15087','2014-04-02','13:25:00',4.74),('15087','2014-04-02','13:30:00',4.77),('15087','2014-04-02','13:35:00',4.42),('15087','2014-04-02','13:40:00',4.78),('15087','2014-04-02','13:45:00',4.57),('15087','2014-04-02','13:50:00',4.58),('15087','2014-04-02','13:55:00',4.45),('15087','2014-04-02','14:00:00',4.31),('15087','2014-04-02','14:05:00',4.4),('15087','2014-04-02','14:10:00',4.4),('15087','2014-04-02','14:15:00',4.24),('15087','2014-04-02','14:20:00',3.95),('15087','2014-04-02','14:25:00',4.3),('15087','2014-04-02','14:30:00',4.22),('15087','2014-04-02','14:35:00',4.06),('15087','2014-04-02','14:40:00',4),('15087','2014-04-02','14:45:00',4.05),('15087','2014-04-02','14:50:00',3.34),('15087','2014-04-02','14:55:00',3.55),('15087','2014-04-02','15:00:00',3.69),('15087','2014-04-02','15:05:00',3.72),('15087','2014-04-02','15:10:00',3.41),('15087','2014-04-02','15:15:00',3.5),('15087','2014-04-02','15:20:00',3.38),('15087','2014-04-02','15:25:00',3.38),('15087','2014-04-02','15:30:00',3.09),('15087','2014-04-02','15:35:00',2.98),('15087','2014-04-02','15:40:00',3.11),('15087','2014-04-02','15:45:00',3.08),('15087','2014-04-02','15:50:00',3.04),('15087','2014-04-02','15:55:00',2.75),('15087','2014-04-02','16:00:00',2.68),('15087','2014-04-02','16:05:00',2.68),('15087','2014-04-02','16:10:00',2.77),('15087','2014-04-02','16:15:00',2.69),('15087','2014-04-02','16:20:00',2.55),('15087','2014-04-02','16:25:00',2.5),('15087','2014-04-02','16:30:00',2.5),('15087','2014-04-02','16:35:00',2.37),('15087','2014-04-02','16:40:00',2.38),('15087','2014-04-02','16:45:00',2.31),('15087','2014-04-02','16:50:00',2.12),('15087','2014-04-02','16:55:00',2.06),('15087','2014-04-02','17:00:00',2.09),('15087','2014-04-02','17:05:00',1.89),('15087','2014-04-02','17:10:00',1.77),('15087','2014-04-02','17:15:00',1.53),('15087','2014-04-02','17:20:00',1.52),('15087','2014-04-02','17:25:00',1.4),('15087','2014-04-02','17:30:00',1.25),('15087','2014-04-02','17:35:00',1.23),('15087','2014-04-02','17:50:00',1.1),('15087','2013-05-31','07:20:00',1.02),('15087','2013-05-31','07:25:00',1.12),('15087','2013-05-31','07:30:00',1.22),('15087','2013-05-31','07:35:00',1.31),('15087','2013-05-31','07:40:00',1.45),('15087','2013-05-31','07:45:00',1.54),('15087','2013-05-31','07:50:00',1.66),('15087','2013-05-31','07:55:00',1.82),('15087','2013-05-31','08:00:00',1.92),('15087','2013-05-31','08:05:00',1.99),('15087','2013-05-31','08:10:00',2.07),('15087','2013-05-31','08:15:00',2.15),('15087','2013-05-31','08:20:00',2.23),('15087','2013-05-31','08:25:00',2.37),('15087','2013-05-31','08:30:00',2.04),('15087','2013-05-31','08:35:00',2.66),('15087','2013-05-31','08:40:00',1.33),('15087','2013-05-31','08:45:00',1.94),('15087','2013-05-31','08:50:00',2.76),('15087','2013-05-31','08:55:00',1.14),('15087','2013-05-31','09:10:00',1.08),('15087','2013-05-31','09:15:00',1.48),('15087','2013-05-31','09:25:00',1),('15087','2013-05-31','09:30:00',1.88),('15087','2013-05-31','09:35:00',2.33),('15087','2013-05-31','09:40:00',3.08),('15087','2013-05-31','09:45:00',3.77),('15087','2013-05-31','09:50:00',4.05),('15087','2013-05-31','09:55:00',3.71),('15087','2013-05-31','10:00:00',4.15),('15087','2013-05-31','10:05:00',2.88),('15087','2013-05-31','10:10:00',2.14),('15087','2013-05-31','10:15:00',3.54),('15087','2013-05-31','10:20:00',4.04),('15087','2013-05-31','10:25:00',1.69),('15087','2013-05-31','10:30:00',3),('15087','2013-05-31','10:35:00',2.19),('15087','2013-05-31','10:40:00',4.56),('15087','2013-05-31','10:45:00',4.68),('15087','2013-05-31','10:50:00',2.09),('15087','2013-05-31','10:55:00',4.08),('15087','2013-05-31','11:00:00',1.61),('15087','2013-05-31','11:05:00',2.61),('15087','2013-05-31','11:10:00',5.44),('15087','2013-05-31','11:15:00',4.43),('15087','2013-05-31','11:20:00',1.32),('15087','2013-05-31','11:25:00',3.18),('15087','2013-05-31','11:30:00',3.44),('15087','2013-05-31','11:35:00',2.65),('15087','2013-05-31','11:45:00',5),('15087','2013-05-31','11:50:00',3.41),('15087','2013-05-31','11:55:00',3.74),('15087','2013-05-31','12:00:00',1.75),('15087','2013-05-31','12:05:00',5.58),('15087','2013-05-31','12:10:00',3.7),('15087','2013-05-31','12:15:00',1.74),('15087','2013-05-31','12:20:00',1.98),('15087','2013-05-31','12:25:00',3.93),('15087','2013-05-31','12:30:00',1.83),('15087','2013-05-31','12:35:00',2.57),('15087','2013-05-31','12:40:00',4.76),('15087','2013-05-31','12:45:00',1.98),('15087','2013-05-31','12:55:00',1.66),('15087','2013-05-31','13:00:00',5.66),('15087','2013-05-31','13:05:00',1.74),('15087','2013-05-31','13:20:00',1.35),('15087','2013-05-31','13:25:00',2.08),('15087','2013-05-31','13:30:00',4.24),('15087','2013-05-31','13:35:00',5.08),('15087','2013-05-31','13:40:00',2.72),('15087','2013-05-31','13:45:00',1.39),('15087','2013-05-31','13:55:00',1.6),('15087','2013-05-31','14:00:00',2.05),('15087','2013-05-31','14:25:00',1.07),('15087','2013-05-31','15:00:00',1.08),('15087','2013-05-31','15:05:00',1.69),('15087','2013-05-31','15:10:00',2.04),('15087','2013-05-31','15:15:00',3.34),('15087','2013-05-31','15:20:00',5.28),('15087','2013-05-31','15:25:00',3.76),('15087','2013-05-31','15:30:00',2.68),('15087','2013-05-31','15:35:00',2.27),('15087','2013-05-31','15:40:00',1.91),('15087','2013-05-31','15:45:00',1.75),('15087','2013-05-31','15:50:00',2.64),('15087','2013-05-31','15:55:00',2.42),('15087','2013-05-31','16:00:00',1.59),('15087','2013-05-31','16:05:00',1.37),('15087','2013-05-31','16:10:00',1),('15087','2013-05-31','16:20:00',1.15),('15087','2013-05-31','16:25:00',1.42),('15087','2013-05-31','16:30:00',1.25),('15087','2013-05-31','16:35:00',1.08),('15087','2013-05-31','16:40:00',1.25),('15087','2013-05-31','16:45:00',1.27),('15087','2013-05-30','07:45:00',1.12),('15087','2013-05-30','07:50:00',1.28),('15087','2013-05-30','08:25:00',1.46),('15087','2013-05-30','08:35:00',1.18),('15087','2013-05-30','08:40:00',2.77),('15087','2013-05-30','08:45:00',2.8),('15087','2013-05-30','08:50:00',2.86),('15087','2013-05-30','08:55:00',2.94),('15087','2013-05-30','09:00:00',3.02),('15087','2013-05-30','09:05:00',3.02),('15087','2013-05-30','09:10:00',3.21),('15087','2013-05-30','09:15:00',3.32),('15087','2013-05-30','09:20:00',3.41),('15087','2013-05-30','09:25:00',3.52),('15087','2013-05-30','09:30:00',3.62),('15087','2013-05-30','09:35:00',3.64),('15087','2013-05-30','09:40:00',3.88),('15087','2013-05-30','09:45:00',3.07),('15087','2013-05-30','09:50:00',4.47),('15087','2013-05-30','09:55:00',1.67),('15087','2013-05-30','10:00:00',1.49),('15087','2013-05-30','10:05:00',1.69),('15087','2013-05-30','10:10:00',3.14),('15087','2013-05-30','10:15:00',2.65),('15087','2013-05-30','10:20:00',4.44),('15087','2013-05-30','10:25:00',1.16),('15087','2013-05-30','10:30:00',1.81),('15087','2013-05-30','10:35:00',1.91),('15087','2013-05-30','10:40:00',3.18),('15087','2013-05-30','10:45:00',4.79),('15087','2013-05-30','10:50:00',4.14),('15087','2013-05-30','10:55:00',3.99),('15087','2013-05-30','11:00:00',5.36),('15087','2013-05-30','11:05:00',4.86),('15087','2013-05-30','11:10:00',1.01),('15087','2013-05-30','11:15:00',2.71),('15087','2013-05-30','11:20:00',3.47),('15087','2013-05-30','11:25:00',1.8),('15087','2013-05-30','11:30:00',4.64),('15087','2013-05-30','11:35:00',5.48),('15087','2013-05-30','11:40:00',4.64),('15087','2013-05-30','11:45:00',4.44),('15087','2013-05-30','11:50:00',4.55),('15087','2013-05-30','11:55:00',1.81),('15087','2013-05-30','12:00:00',5.63),('15087','2013-05-30','12:05:00',5.62),('15087','2013-05-30','12:10:00',2.61),('15087','2013-05-30','12:15:00',4.22),('15087','2013-05-30','12:20:00',3.76),('15087','2013-05-30','12:25:00',5.19),('15087','2013-05-30','12:30:00',3.58),('15087','2013-05-30','12:35:00',3.37),('15087','2013-05-30','12:40:00',5.07),('15087','2013-05-30','12:45:00',3.26),('15087','2013-05-30','12:50:00',3.89),('15087','2013-05-30','12:55:00',5.72),('15087','2013-05-30','13:00:00',4.38),('15087','2013-05-30','13:05:00',4.11),('15087','2013-05-30','13:10:00',2.64),('15087','2013-05-30','13:15:00',2.17),('15087','2013-05-30','13:20:00',2.13),('15087','2013-05-30','13:25:00',1.86),('15087','2013-05-30','13:30:00',2.39),('15087','2013-05-30','13:35:00',2.36),('15087','2013-05-30','13:40:00',4.45),('15087','2013-05-30','13:45:00',4.83),('15087','2013-05-30','13:50:00',1.86),('15087','2013-05-30','13:55:00',2.13),('15087','2013-05-30','14:00:00',4.46),('15087','2013-05-30','14:05:00',5.69),('15087','2013-05-30','14:10:00',3.7),('15087','2013-05-30','14:15:00',5.18),('15087','2013-05-30','14:20:00',3.78),('15087','2013-05-30','14:25:00',4.71),('15087','2013-05-30','14:30:00',5.22),('15087','2013-05-30','14:35:00',4.2),('15087','2013-05-30','14:40:00',5.08),('15087','2013-05-30','14:45:00',5.1),('15087','2013-05-30','14:50:00',5.01),('15087','2013-05-30','14:55:00',4.48),('15087','2013-05-30','15:00:00',4.68),('15087','2013-05-30','15:05:00',2.89),('15087','2013-05-30','15:10:00',2.13),('15087','2013-05-30','15:15:00',4.47),('15087','2013-05-30','15:20:00',4.68),('15087','2013-05-30','15:25:00',4.26),('15087','2013-05-30','15:30:00',4.28),('15087','2013-05-30','15:35:00',4.43),('15087','2013-05-30','15:40:00',4.38),('15087','2013-05-30','15:45:00',4.6),('15087','2013-05-30','15:50:00',2.65),('15087','2013-05-30','15:55:00',4.11),('15087','2013-05-30','16:00:00',3.91),('15087','2013-05-30','16:05:00',4.37),('15087','2013-05-30','16:10:00',4.11),('15087','2013-05-30','16:15:00',3.87),('15087','2013-05-30','16:20:00',3.48),('15087','2013-05-30','16:25:00',1.99),('15087','2013-05-30','16:30:00',1.2),('15087','2013-05-30','16:35:00',2.54),('15087','2013-05-30','16:40:00',1.02),('15087','2013-05-30','16:45:00',3.08),('15087','2013-05-30','16:50:00',2.68),('15087','2013-05-30','16:55:00',2.19),('15087','2013-05-30','17:00:00',1.74),('15087','2013-05-30','17:05:00',2.15),('15087','2013-05-30','17:20:00',1.37),('15087','2013-05-30','17:30:00',1.07),('15087','2013-05-30','18:00:00',1),('15087','2013-05-30','18:05:00',1.08),('15087','2013-05-30','18:10:00',1.25),('15087','2013-05-30','18:35:00',1.38),('15087','2013-05-30','18:40:00',1.31),('15087','2013-05-30','18:45:00',1.48),('15087','2013-05-30','18:50:00',1.32),('15087','2013-05-29','07:25:00',1.05),('15087','2013-05-29','07:30:00',1.15),('15087','2013-05-29','07:35:00',1.25),('15087','2013-05-29','07:40:00',1.35),('15087','2013-05-29','07:45:00',1.43),('15087','2013-05-29','07:50:00',1.52),('15087','2013-05-29','07:55:00',1.63),('15087','2013-05-29','08:00:00',1.75),('15087','2013-05-29','08:05:00',1.86),('15087','2013-05-29','08:10:00',2),('15087','2013-05-29','08:15:00',2.1),('15087','2013-05-29','08:20:00',2.2),('15087','2013-05-29','08:25:00',2.29),('15087','2013-05-29','08:30:00',2.4),('15087','2013-05-29','08:35:00',2.51),('15087','2013-05-29','08:40:00',2.6),('15087','2013-05-29','08:45:00',2.68),('15087','2013-05-29','08:50:00',2.76),('15087','2013-05-29','08:55:00',2.87),('15087','2013-05-29','09:00:00',2.95),('15087','2013-05-29','09:05:00',3.03),('15087','2013-05-29','09:10:00',3.11),('15087','2013-05-29','09:15:00',3.19),('15087','2013-05-29','09:20:00',3.27),('15087','2013-05-29','09:25:00',3.35),('15087','2013-05-29','09:30:00',3.42),('15087','2013-05-29','09:35:00',3.52),('15087','2013-05-29','09:40:00',3.58),('15087','2013-05-29','09:45:00',3.65),('15087','2013-05-29','09:50:00',3.74),('15087','2013-05-29','09:55:00',3.81),('15087','2013-05-29','10:00:00',3.85),('15087','2013-05-29','10:05:00',3.85),('15087','2013-05-29','10:10:00',3.99),('15087','2013-05-29','10:15:00',4.07),('15087','2013-05-29','10:20:00',4.15),('15087','2013-05-29','10:25:00',4.19),('15087','2013-05-29','10:30:00',4.27),('15087','2013-05-29','10:35:00',4.32),('15087','2013-05-29','10:40:00',4.38),('15087','2013-05-29','10:45:00',4.44),('15087','2013-05-29','10:50:00',4.48),('15087','2013-05-29','10:55:00',4.54),('15087','2013-05-29','11:00:00',4.61),('15087','2013-05-29','11:05:00',4.6),('15087','2013-05-29','11:10:00',4.43),('15087','2013-05-29','11:15:00',3.6),('15087','2013-05-29','11:20:00',5.04),('15087','2013-05-29','11:25:00',4.88),('15087','2013-05-29','11:30:00',5.13),('15087','2013-05-29','11:35:00',5.13),('15087','2013-05-29','11:40:00',4.06),('15087','2013-05-29','11:45:00',3.49),('15087','2013-05-29','11:50:00',4.13),('15087','2013-05-29','11:55:00',4.86),('15087','2013-05-29','12:00:00',3.34),('15087','2013-05-29','12:05:00',3.22),('15087','2013-05-29','12:10:00',5.37),('15087','2013-05-29','12:15:00',4.24),('15087','2013-05-29','12:20:00',5.31),('15087','2013-05-29','12:25:00',5.21),('15087','2013-05-29','12:30:00',5.17),('15087','2013-05-29','12:35:00',5.14),('15087','2013-05-29','12:40:00',3.85),('15087','2013-05-29','12:45:00',5.19),('15087','2013-05-29','12:50:00',4.89),('15087','2013-05-29','12:55:00',5.12),('15087','2013-05-29','13:00:00',5.2),('15087','2013-05-29','13:05:00',4.83),('15087','2013-05-29','13:10:00',4.74),('15087','2013-05-29','13:15:00',4.28),('15087','2013-05-29','13:20:00',4.17),('15087','2013-05-29','13:25:00',5.76),('15087','2013-05-29','13:30:00',5.45),('15087','2013-05-29','13:35:00',4.13),('15087','2013-05-29','13:40:00',5.25),('15087','2013-05-29','13:45:00',4.85),('15087','2013-05-29','13:50:00',4.66),('15087','2013-05-29','13:55:00',4.43),('15087','2013-05-29','14:00:00',5.14),('15087','2013-05-29','14:05:00',4.87),('15087','2013-05-29','14:10:00',4.88),('15087','2013-05-29','14:15:00',4.98),('15087','2013-05-29','14:20:00',5.01),('15087','2013-05-29','14:25:00',4.51),('15087','2013-05-29','14:30:00',4.91),('15087','2013-05-29','14:35:00',3.64),('15087','2013-05-29','14:40:00',4.94),('15087','2013-05-29','14:45:00',4.9),('15087','2013-05-29','14:50:00',4.01),('15087','2013-05-29','14:55:00',4.37),('15087','2013-05-29','15:00:00',4.57),('15087','2013-05-29','15:05:00',1.95),('15087','2013-05-29','15:15:00',3.57),('15087','2013-05-29','15:20:00',3.87),('15087','2013-05-29','15:25:00',3.03),('15087','2013-05-29','15:30:00',3.1),('15087','2013-05-29','15:35:00',2.81),('15087','2013-05-29','15:40:00',2.89),('15087','2013-05-29','15:45:00',3.31),('15087','2013-05-29','15:50:00',3.34),('15087','2013-05-29','15:55:00',2.12),('15087','2013-05-29','16:00:00',2.96),('15087','2013-05-29','16:05:00',2.98),('15087','2013-05-29','16:10:00',2.57),('15087','2013-05-29','16:15:00',1.91),('15087','2013-05-29','16:20:00',2.4),('15087','2013-05-29','16:25:00',2.52),('15087','2013-05-29','16:30:00',2.01),('15087','2013-05-29','16:35:00',1.76),('15087','2013-05-29','16:40:00',2.58),('15087','2013-05-29','16:45:00',2.27),('15087','2013-05-29','16:50:00',1.68),('15087','2013-05-29','16:55:00',1.55),('15087','2013-05-29','17:00:00',1.4),('15087','2013-05-29','17:35:00',1.21),('15087','2013-05-29','17:40:00',1.75),('15087','2013-05-29','17:45:00',1.15),('15087','2013-05-29','18:00:00',1.02),('15087','2013-05-29','18:05:00',1.27),('15087','2013-05-29','18:10:00',1.38),('15087','2013-05-29','18:15:00',2.23),('15087','2013-05-29','18:20:00',1.54),('15087','2013-05-28','07:15:00',1.04),('15087','2013-05-28','07:20:00',1.2),('15087','2013-05-28','07:25:00',1.27),('15087','2013-05-28','07:40:00',1.16),('15087','2013-05-28','07:45:00',1.22),('15087','2013-05-28','07:50:00',1.26),('15087','2013-05-28','07:55:00',1.21),('15087','2013-05-28','08:00:00',1.31),('15087','2013-05-28','08:05:00',1.43),('15087','2013-05-28','08:10:00',1.66),('15087','2013-05-28','08:15:00',1.96),('15087','2013-05-28','08:20:00',2.05),('15087','2013-05-28','08:25:00',1.76),('15087','2013-05-28','08:30:00',2.07),('15087','2013-05-28','08:35:00',1.86),('15087','2013-05-28','08:40:00',1.63),('15087','2013-05-28','08:45:00',1.57),('15087','2013-05-28','08:50:00',1.87),('15087','2013-05-28','08:55:00',1.71),('15087','2013-05-28','09:00:00',1.79),('15087','2013-05-28','09:05:00',2.07),('15087','2013-05-28','09:10:00',1.87),('15087','2013-05-28','09:15:00',1.79),('15087','2013-05-28','09:20:00',2.1),('15087','2013-05-28','09:25:00',2.36),('15087','2013-05-28','09:30:00',2.53),('15087','2013-05-28','09:35:00',2.59),('15087','2013-05-28','09:40:00',2.48),('15087','2013-05-28','09:45:00',2.36),('15087','2013-05-28','09:50:00',2.42),('15087','2013-05-28','09:55:00',2.57),('15087','2013-05-28','10:00:00',2.38),('15087','2013-05-28','10:05:00',2.55),('15087','2013-05-28','10:10:00',2.84),('15087','2013-05-28','10:15:00',2.96),('15087','2013-05-28','10:20:00',3.1),('15087','2013-05-28','10:25:00',3.07),('15087','2013-05-28','10:30:00',3.29),('15087','2013-05-28','10:35:00',3.42),('15087','2013-05-28','10:40:00',3.11),('15087','2013-05-28','10:45:00',2.99),('15087','2013-05-28','10:50:00',3.1),('15087','2013-05-28','10:55:00',2.73),('15087','2013-05-28','11:00:00',2.77),('15087','2013-05-28','11:05:00',2.65),('15087','2013-05-28','11:10:00',2.72),('15087','2013-05-28','11:15:00',2.6),('15087','2013-05-28','11:20:00',2.41),('15087','2013-05-28','11:25:00',2.54),('15087','2013-05-28','11:30:00',4.67),('15087','2013-05-28','11:35:00',3.49),('15087','2013-05-28','11:40:00',4.5),('15087','2013-05-28','11:45:00',3.71),('15087','2013-05-28','11:50:00',1.2),('15087','2013-05-28','11:55:00',1.86),('15087','2013-05-28','12:00:00',1.64),('15087','2013-05-28','12:05:00',2.19),('15087','2013-05-28','12:10:00',3.05),('15087','2013-05-28','12:15:00',2.96),('15087','2013-05-28','12:20:00',2.64),('15087','2013-05-28','12:25:00',2.73),('15087','2013-05-28','12:30:00',3.01),('15087','2013-05-28','12:35:00',2.91),('15087','2013-05-28','12:40:00',3),('15087','2013-05-28','12:45:00',3.3),('15087','2013-05-28','12:50:00',2.97),('15087','2013-05-28','12:55:00',3.05),('15087','2013-05-28','13:00:00',3.1),('15087','2013-05-28','13:05:00',3.36),('15087','2013-05-28','13:10:00',3.48),('15087','2013-05-28','13:15:00',3.06),('15087','2013-05-28','13:20:00',3.36),('15087','2013-05-28','13:25:00',1.9),('15087','2013-05-28','13:30:00',2.42),('15087','2013-05-28','13:35:00',1.99),('15087','2013-05-28','13:40:00',2.28),('15087','2013-05-28','13:45:00',2.16),('15087','2013-05-28','13:50:00',2.93),('15087','2013-05-28','13:55:00',2.92),('15087','2013-05-28','14:00:00',2.88),('15087','2013-05-28','14:05:00',3.05),('15087','2013-05-28','14:10:00',4.18),('15087','2013-05-28','14:15:00',4.28),('15087','2013-05-28','14:20:00',2.78),('15087','2013-05-28','14:25:00',3.05),('15087','2013-05-28','14:30:00',3.79),('15087','2013-05-28','14:35:00',3.21),('15087','2013-05-28','14:40:00',3.54),('15087','2013-05-28','14:45:00',4.14),('15087','2013-05-28','14:50:00',3.26),('15087','2013-05-28','14:55:00',3.1),('15087','2013-05-28','15:00:00',2.87),('15087','2013-05-28','15:05:00',3.74),('15087','2013-05-28','15:10:00',1.81),('15087','2013-05-28','15:15:00',2.9),('15087','2013-05-28','15:20:00',3.33),('15087','2013-05-28','15:25:00',2.43),('15087','2013-05-28','15:30:00',1.6),('15087','2013-05-28','15:35:00',1.63),('15087','2013-05-28','15:40:00',2.82),('15087','2013-05-28','15:45:00',3.82),('15087','2013-05-28','15:50:00',3.3),('15087','2013-05-28','15:55:00',2.31),('15087','2013-05-28','16:00:00',1.75),('15087','2013-05-28','16:05:00',1.4),('15087','2013-05-28','16:10:00',1.49),('15087','2013-05-28','16:15:00',1.71),('15087','2013-05-28','16:20:00',2.79),('15087','2013-05-28','16:25:00',2.33),('15087','2013-05-28','16:30:00',3.01),('15087','2013-05-28','16:35:00',3.21),('15087','2013-05-28','16:40:00',2.79),('15087','2013-05-28','16:45:00',2.69),('15087','2013-05-28','16:50:00',2.84),('15087','2013-05-28','16:55:00',2.79),('15087','2013-05-28','17:00:00',2.74),('15087','2013-05-28','17:05:00',2.72),('15087','2013-05-28','17:10:00',2.62),('15087','2013-05-28','17:15:00',2.56),('15087','2013-05-28','17:20:00',2.49),('15087','2013-05-28','17:25:00',2.36),('15087','2013-05-28','17:30:00',2.26),('15087','2013-05-28','17:35:00',2.05),('15087','2013-05-28','17:40:00',1.84),('15087','2013-05-28','17:45:00',1.81),('15087','2013-05-28','17:50:00',1.72),('15087','2013-05-28','17:55:00',1.57),('15087','2013-05-28','18:00:00',1.54),('15087','2013-05-28','18:05:00',1.49),('15087','2013-05-27','07:25:00',1.08),('15087','2013-05-27','07:30:00',1.2),('15087','2013-05-27','07:35:00',1.34),('15087','2013-05-27','07:40:00',1.42),('15087','2013-05-27','07:45:00',1.59),('15087','2013-05-27','07:50:00',1.53),('15087','2013-05-27','08:00:00',1.59),('15087','2013-05-27','08:05:00',2.09),('15087','2013-05-27','08:10:00',2.24),('15087','2013-05-27','08:15:00',2.23),('15087','2013-05-27','08:20:00',1.44),('15087','2013-05-27','08:25:00',2.09),('15087','2013-05-27','08:30:00',2.46),('15087','2013-05-27','08:35:00',2.53),('15087','2013-05-27','08:40:00',2.63),('15087','2013-05-27','08:45:00',2.95),('15087','2013-05-27','08:50:00',2.58),('15087','2013-05-27','08:55:00',2.94),('15087','2013-05-27','09:00:00',3.38),('15087','2013-05-27','09:05:00',3.54),('15087','2013-05-27','09:10:00',2.07),('15087','2013-05-27','09:15:00',2.74),('15087','2013-05-27','09:20:00',1.91),('15087','2013-05-27','09:25:00',3.07),('15087','2013-05-27','09:30:00',3.66),('15087','2013-05-27','09:35:00',3.68),('15087','2013-05-27','09:40:00',3.74),('15087','2013-05-27','09:45:00',3.65),('15087','2013-05-27','09:50:00',3.08),('15087','2013-05-27','09:55:00',4.18),('15087','2013-05-27','10:00:00',4.11),('15087','2013-05-27','10:05:00',3.93),('15087','2013-05-27','10:10:00',4.24),('15087','2013-05-27','10:15:00',3.7),('15087','2013-05-27','10:20:00',2.5),('15087','2013-05-27','10:25:00',4.44),('15087','2013-05-27','10:30:00',1.86),('15087','2013-05-27','10:35:00',1.81),('15087','2013-05-27','10:40:00',4.05),('15087','2013-05-27','10:45:00',2.34),('15087','2013-05-27','10:50:00',2.83),('15087','2013-05-27','10:55:00',1.68),('15087','2013-05-27','11:00:00',4.54),('15087','2013-05-27','11:05:00',2.99),('15087','2013-05-27','11:10:00',3.88),('15087','2013-05-27','11:15:00',1.9),('15087','2013-05-27','11:20:00',4.01),('15087','2013-05-27','11:25:00',3.68),('15087','2013-05-27','11:30:00',3.26),('15087','2013-05-27','11:35:00',1.71),('15087','2013-05-27','11:40:00',5.49),('15087','2013-05-27','11:45:00',1.82),('15087','2013-05-27','11:50:00',1.82),('15087','2013-05-27','11:55:00',3),('15087','2013-05-27','12:00:00',5.18),('15087','2013-05-27','12:05:00',2.35),('15087','2013-05-27','12:10:00',5.19),('15087','2013-05-27','12:15:00',4.12),('15087','2013-05-27','12:20:00',5.49),('15087','2013-05-27','12:25:00',4.03),('15087','2013-05-27','12:30:00',5.25),('15087','2013-05-27','12:35:00',3.88),('15087','2013-05-27','12:40:00',5.67),('15087','2013-05-27','12:45:00',2.23),('15087','2013-05-27','12:50:00',5.6),('15087','2013-05-27','12:55:00',3.2),('15087','2013-05-27','13:00:00',1.85),('15087','2013-05-27','13:05:00',3.07),('15087','2013-05-27','13:10:00',4.77),('15087','2013-05-27','13:15:00',2.12),('15087','2013-05-27','13:20:00',5.44),('15087','2013-05-27','13:25:00',4.66),('15087','2013-05-27','13:30:00',5.12),('15087','2013-05-27','13:35:00',3.73),('15087','2013-05-27','13:40:00',5.44),('15087','2013-05-27','13:45:00',4.9),('15087','2013-05-27','13:50:00',5.04),('15087','2013-05-27','13:55:00',5.11),('15087','2013-05-27','14:00:00',4.95),('15087','2013-05-27','14:05:00',4.73),('15087','2013-05-27','14:10:00',4.27),('15087','2013-05-27','14:15:00',4.53),('15087','2013-05-27','14:20:00',2.87),('15087','2013-05-27','14:25:00',4.94),('15087','2013-05-27','14:30:00',4.8),('15087','2013-05-27','14:35:00',3.34),('15087','2013-05-27','14:40:00',3.38),('15087','2013-05-27','14:45:00',4.94),('15087','2013-05-27','14:50:00',4.86),('15087','2013-05-27','14:55:00',3.99),('15087','2013-05-27','15:00:00',3.04),('15087','2013-05-27','15:05:00',2.91),('15087','2013-05-27','15:10:00',4.57),('15087','2013-05-27','15:15:00',3.13),('15087','2013-05-27','15:20:00',3.78),('15087','2013-05-27','15:25:00',3.34),('15087','2013-05-27','15:30:00',3.62),('15087','2013-05-27','15:35:00',4.05),('15087','2013-05-27','15:40:00',3.59),('15087','2013-05-27','15:45:00',3.3),('15087','2013-05-27','15:50:00',3.96),('15087','2013-05-27','15:55:00',2.69),('15087','2013-05-27','16:00:00',3.25),('15087','2013-05-27','16:05:00',2.34),('15087','2013-05-27','16:10:00',2.69),('15087','2013-05-27','16:15:00',2.55),('15087','2013-05-27','16:20:00',3.99),('15087','2013-05-27','16:25:00',3.82),('15087','2013-05-27','16:30:00',3.58),('15087','2013-05-27','16:35:00',2.96),('15087','2013-05-27','16:40:00',1.47),('15087','2013-05-27','16:45:00',1.32),('15087','2013-05-27','16:50:00',1.34),('15087','2013-05-27','16:55:00',1.43),('15087','2013-05-27','17:00:00',1.51),('15087','2013-05-27','17:05:00',1.57),('15087','2013-05-27','17:10:00',2.04),('15087','2013-05-27','17:15:00',1.56),('15087','2013-05-27','17:20:00',1.33),('15087','2013-05-27','17:25:00',1.22),('15087','2013-05-27','17:30:00',1.18),('15087','2013-05-27','17:35:00',1.1),('15087','2013-05-27','17:40:00',1.02),('15087','2013-05-27','18:20:00',1.29),('15087','2013-05-27','18:25:00',1.75),('15087','2013-05-27','18:30:00',1.34),('15087','2013-05-26','07:20:00',1.16),('15087','2013-05-26','07:35:00',1.27),('15087','2013-05-26','07:40:00',1.51),('15087','2013-05-26','07:45:00',1.72),('15087','2013-05-26','07:50:00',2.41),('15087','2013-05-26','08:05:00',2.49),('15087','2013-05-26','08:10:00',1.78),('15087','2013-05-26','08:20:00',1.21),('15087','2013-05-26','08:25:00',1.59),('15087','2013-05-26','08:30:00',2.26),('15087','2013-05-26','08:35:00',1.91),('15087','2013-05-26','08:40:00',2.57),('15087','2013-05-26','08:45:00',2.96),('15087','2013-05-26','08:50:00',3.14),('15087','2013-05-26','08:55:00',1.15),('15087','2013-05-26','09:00:00',1.93),('15087','2013-05-26','09:10:00',2.78),('15087','2013-05-26','09:15:00',1.38),('15087','2013-05-26','09:25:00',1.68),('15087','2013-05-26','09:40:00',1.61),('15087','2013-05-26','09:45:00',2.1),('15087','2013-05-26','09:55:00',1.44),('15087','2013-05-26','10:00:00',1.26),('15087','2013-05-26','10:05:00',3.76),('15087','2013-05-26','10:10:00',4.18),('15087','2013-05-26','10:15:00',1.99),('15087','2013-05-26','10:20:00',3.15),('15087','2013-05-26','10:25:00',3.63),('15087','2013-05-26','10:30:00',4.25),('15087','2013-05-26','10:35:00',4.67),('15087','2013-05-26','10:40:00',4.51),('15087','2013-05-26','10:45:00',4.6),('15087','2013-05-26','10:50:00',4.78),('15087','2013-05-26','10:55:00',4.21),('15087','2013-05-26','11:00:00',4.7),('15087','2013-05-26','11:05:00',4.85),('15087','2013-05-26','11:10:00',4.86),('15087','2013-05-26','11:15:00',4.91),('15087','2013-05-26','11:20:00',4.87),('15087','2013-05-26','11:25:00',5.02),('15087','2013-05-26','11:35:00',2.38),('15087','2013-05-26','11:40:00',4.94),('15087','2013-05-26','11:45:00',4.83),('15087','2013-05-26','11:50:00',5.17),('15087','2013-05-26','11:55:00',2.87),('15087','2013-05-26','12:00:00',5.05),('15087','2013-05-26','12:05:00',5.27),('15087','2013-05-26','12:10:00',4.71),('15087','2013-05-26','12:15:00',2.76),('15087','2013-05-26','12:20:00',3.58),('15087','2013-05-26','12:25:00',4.67),('15087','2013-05-26','12:30:00',5.4),('15087','2013-05-26','12:35:00',4.22),('15087','2013-05-26','12:40:00',3.71),('15087','2013-05-26','12:45:00',5.18),('15087','2013-05-26','12:50:00',5.21),('15087','2013-05-26','12:55:00',5.38),('15087','2013-05-26','13:00:00',2.32),('15087','2013-05-26','13:05:00',5),('15087','2013-05-26','13:10:00',5.45),('15087','2013-05-26','13:15:00',5.43),('15087','2013-05-26','13:20:00',5.4),('15087','2013-05-26','13:25:00',5.34),('15087','2013-05-26','13:30:00',5.38),('15087','2013-05-26','13:35:00',5.33),('15087','2013-05-26','13:40:00',5.27),('15087','2013-05-26','13:45:00',5.29),('15087','2013-05-26','13:50:00',5.29),('15087','2013-05-26','13:55:00',5.18),('15087','2013-05-26','14:00:00',5.08),('15087','2013-05-26','14:05:00',5.15),('15087','2013-05-26','14:10:00',5.12),('15087','2013-05-26','14:15:00',5.09),('15087','2013-05-26','14:20:00',5.05),('15087','2013-05-26','14:25:00',4.95),('15087','2013-05-26','14:30:00',4.9),('15087','2013-05-26','14:35:00',4.87),('15087','2013-05-26','14:40:00',4.85),('15087','2013-05-26','14:45:00',4.77),('15087','2013-05-26','14:50:00',4.7),('15087','2013-05-26','14:55:00',4.57),('15087','2013-05-26','15:00:00',4.56),('15087','2013-05-26','15:05:00',4.58),('15087','2013-05-26','15:10:00',4.55),('15087','2013-05-26','15:15:00',4.4),('15087','2013-05-26','15:20:00',4.27),('15087','2013-05-26','15:25:00',4.16),('15087','2013-05-26','15:30:00',4.19),('15087','2013-05-26','15:35:00',4.21),('15087','2013-05-26','15:40:00',4.11),('15087','2013-05-26','15:45:00',4.03),('15087','2013-05-26','15:50:00',3.99),('15087','2013-05-26','15:55:00',3.93),('15087','2013-05-26','16:00:00',3.85),('15087','2013-05-26','16:05:00',3.74),('15087','2013-05-26','16:10:00',3.66),('15087','2013-05-26','16:15:00',3.65),('15087','2013-05-26','16:20:00',3.64),('15087','2013-05-26','16:25:00',3.6),('15087','2013-05-26','16:30:00',3.49),('15087','2013-05-26','16:35:00',3.41),('15087','2013-05-26','16:40:00',3.33),('15087','2013-05-26','16:45:00',3.23),('15087','2013-05-26','16:50:00',3.17),('15087','2013-05-26','16:55:00',3.06),('15087','2013-05-26','17:00:00',3),('15087','2013-05-26','17:05:00',2.98),('15087','2013-05-26','17:10:00',2.91),('15087','2013-05-26','17:15:00',2.81),('15087','2013-05-26','17:20:00',2.73),('15087','2013-05-26','17:25:00',2.64),('15087','2013-05-26','17:30:00',2.53),('15087','2013-05-26','17:35:00',2.28),('15087','2013-05-26','17:40:00',2.23),('15087','2013-05-26','17:45:00',2.16),('15087','2013-05-26','17:50:00',1.99),('15087','2013-05-26','17:55:00',1.89),('15087','2013-05-26','18:00:00',1.76),('15087','2013-05-26','18:05:00',1.61),('15087','2013-05-26','18:10:00',1.56),('15087','2013-05-26','18:15:00',1.43),('15087','2013-05-26','18:20:00',1.32),('15087','2013-05-26','18:25:00',1.22),('15087','2013-05-26','18:30:00',1.09),('15087','2013-05-25','07:15:00',1.13),('15087','2013-05-25','07:30:00',1.38),('15087','2013-05-25','07:35:00',1.87),('15087','2013-05-25','07:40:00',1.32),('15087','2013-05-25','07:55:00',1.97),('15087','2013-05-25','08:00:00',2.39),('15087','2013-05-25','08:05:00',2.09),('15087','2013-05-25','08:10:00',1.5),('15087','2013-05-25','08:20:00',1.75),('15087','2013-05-25','08:25:00',2.75),('15087','2013-05-25','08:30:00',2.86),('15087','2013-05-25','08:35:00',1.39),('15087','2013-05-25','08:40:00',1.48),('15087','2013-05-25','08:45:00',1.27),('15087','2013-05-25','08:50:00',1.97),('15087','2013-05-25','08:55:00',1.84),('15087','2013-05-25','09:00:00',2.53),('15087','2013-05-25','09:05:00',2.93),('15087','2013-05-25','09:10:00',3.2),('15087','2013-05-25','09:15:00',3.68),('15087','2013-05-25','09:20:00',1.55),('15087','2013-05-25','09:25:00',1.61),('15087','2013-05-25','09:30:00',1.14),('15087','2013-05-25','09:35:00',2.9),('15087','2013-05-25','09:40:00',3.85),('15087','2013-05-25','09:45:00',2.93),('15087','2013-05-25','09:50:00',3.96),('15087','2013-05-25','09:55:00',2.18),('15087','2013-05-25','10:10:00',1.27),('15087','2013-05-25','10:15:00',1.09),('15087','2013-05-25','10:40:00',1.76),('15087','2013-05-25','10:45:00',1.48),('15087','2013-05-25','10:50:00',1.46),('15087','2013-05-25','11:00:00',1.23),('15087','2013-05-25','11:05:00',2.25),('15087','2013-05-25','11:10:00',4.36),('15087','2013-05-25','11:15:00',4.57),('15087','2013-05-25','11:20:00',2.9),('15087','2013-05-25','11:35:00',1.93),('15087','2013-05-25','11:40:00',2.38),('15087','2013-05-25','11:45:00',2.79),('15087','2013-05-25','11:50:00',2.04),('15087','2013-05-25','11:55:00',2.14),('15087','2013-05-25','12:00:00',1.9),('15087','2013-05-25','12:05:00',1.51),('15087','2013-05-25','12:10:00',1.96),('15087','2013-05-25','12:15:00',1.29),('15087','2013-05-25','12:20:00',1.75),('15087','2013-05-25','12:25:00',2.25),('15087','2013-05-25','12:30:00',1.45),('15087','2013-05-25','12:35:00',1.75),('15087','2013-05-25','12:40:00',2.06),('15087','2013-05-25','12:45:00',2.01),('15087','2013-05-25','12:50:00',1.45),('15087','2013-05-25','12:55:00',2.06),('15087','2013-05-25','13:00:00',1.1),('15087','2013-05-25','13:05:00',1.87),('15087','2013-05-25','13:10:00',1.58),('15087','2013-05-25','13:15:00',2.12),('15087','2013-05-25','13:20:00',2.31),('15087','2013-05-25','13:25:00',4.13),('15087','2013-05-25','13:30:00',1.65),('15087','2013-05-25','13:35:00',1.58),('15087','2013-05-25','13:40:00',2.33),('15087','2013-05-25','13:45:00',2.14),('15087','2013-05-25','13:50:00',2.85),('15087','2013-05-25','13:55:00',3.77),('15087','2013-05-25','14:00:00',4.33),('15087','2013-05-25','14:05:00',4.45),('15087','2013-05-25','14:10:00',4.94),('15087','2013-05-25','14:15:00',4.28),('15087','2013-05-25','14:20:00',4.12),('15087','2013-05-25','14:25:00',3.07),('15087','2013-05-25','14:30:00',2.73),('15087','2013-05-25','14:35:00',2.97),('15087','2013-05-25','14:40:00',1.55),('15087','2013-05-25','14:45:00',3.3),('15087','2013-05-25','14:50:00',1.32),('15087','2013-05-25','14:55:00',1.97),('15087','2013-05-25','15:00:00',4.61),('15087','2013-05-25','15:05:00',2.81),('15087','2013-05-25','15:20:00',1.68),('15087','2013-05-25','15:25:00',2.78),('15087','2013-05-25','15:30:00',3.04),('15087','2013-05-25','15:35:00',4.18),('15087','2013-05-25','15:40:00',3.07),('15087','2013-05-25','15:45:00',3.96),('15087','2013-05-25','15:50:00',4.49),('15087','2013-05-25','15:55:00',3.89),('15087','2013-05-25','16:00:00',1.45),('15087','2013-05-25','16:05:00',2.32),('15087','2013-05-25','16:10:00',2.17),('15087','2013-05-25','16:15:00',1.86),('15087','2013-05-25','16:20:00',1.18),('15087','2013-05-25','16:25:00',1.93),('15087','2013-05-25','16:30:00',2.9),('15087','2013-05-25','16:35:00',3.63),('15087','2013-05-25','16:40:00',2.16),('15087','2013-05-25','16:45:00',2.57),('15087','2013-05-25','16:50:00',1.66),('15087','2013-05-25','17:05:00',2),('15087','2013-05-25','17:10:00',3.19),('15087','2013-05-25','17:15:00',2.43),('15087','2013-05-25','17:20:00',2.08),('15087','2013-05-25','17:35:00',1.8),('15087','2013-05-25','17:40:00',1.09),('15087','2013-05-25','17:45:00',1.18),('15087','2013-05-25','17:50:00',1.7),('15087','2013-05-25','18:00:00',1.06),('15087','2013-05-25','18:10:00',1.02),('15087','2013-05-24','08:00:00',1.11),('15087','2013-05-24','08:05:00',2.09),('15087','2013-05-24','08:10:00',2.44),('15087','2013-05-24','08:15:00',1.81),('15087','2013-05-24','08:25:00',1.7),('15087','2013-05-24','08:30:00',2.58),('15087','2013-05-24','08:35:00',1.61),('15087','2013-05-24','08:40:00',1.56),('15087','2013-05-24','08:45:00',2.81),('15087','2013-05-24','08:50:00',2.81),('15087','2013-05-24','08:55:00',2.93),('15087','2013-05-24','09:00:00',3.16),('15087','2013-05-24','09:05:00',3.15),('15087','2013-05-24','09:20:00',2.77),('15087','2013-05-24','09:25:00',1.57),('15087','2013-05-24','09:30:00',1.98),('15087','2013-05-24','09:40:00',1.84),('15087','2013-05-24','09:45:00',1.15),('15087','2013-05-24','09:50:00',1.58),('15087','2013-05-24','09:55:00',3.61),('15087','2013-05-24','10:00:00',1.77),('15087','2013-05-24','10:20:00',1.56),('15087','2013-05-24','10:25:00',3.06),('15087','2013-05-24','10:30:00',4.44),('15087','2013-05-24','10:35:00',4.3),('15087','2013-05-24','10:40:00',4.04),('15087','2013-05-24','10:45:00',3.77),('15087','2013-05-24','10:50:00',3.24),('15087','2013-05-24','10:55:00',5.16),('15087','2013-05-24','11:00:00',3.1),('15087','2013-05-24','11:05:00',3.87),('15087','2013-05-24','11:10:00',4.49),('15087','2013-05-24','11:15:00',3.45),('15087','2013-05-24','11:20:00',5),('15087','2013-05-24','11:25:00',5.22),('15087','2013-05-24','11:30:00',2.99),('15087','2013-05-24','11:35:00',1.45),('15087','2013-05-24','11:45:00',3.76),('15087','2013-05-24','11:50:00',5.56),('15087','2013-05-24','11:55:00',3.36),('15087','2013-05-24','12:00:00',3.03),('15087','2013-05-24','12:05:00',2.76),('15087','2013-05-24','12:10:00',4.37),('15087','2013-05-24','12:15:00',2.78),('15087','2013-05-24','12:20:00',2.51),('15087','2013-05-24','12:25:00',4.23),('15087','2013-05-24','12:30:00',4.81),('15087','2013-05-24','12:35:00',2.57),('15087','2013-05-24','12:40:00',3.04),('15087','2013-05-24','12:45:00',3.79),('15087','2013-05-24','12:50:00',3.56),('15087','2013-05-24','12:55:00',2.97),('15087','2013-05-24','13:00:00',2.86),('15087','2013-05-24','13:05:00',2.48),('15087','2013-05-24','13:10:00',2.88),('15087','2013-05-24','13:15:00',3.33),('15087','2013-05-24','13:20:00',3.38),('15087','2013-05-24','13:25:00',2.61),('15087','2013-05-24','13:30:00',2.27),('15087','2013-05-24','13:35:00',2.84),('15087','2013-05-24','13:40:00',2.41),('15087','2013-05-24','13:45:00',1.2),('15087','2013-05-24','13:50:00',1.37),('15087','2013-05-24','13:55:00',2.79),('15087','2013-05-24','14:00:00',2.41),('15087','2013-05-24','14:05:00',2.13),('15087','2013-05-24','14:10:00',1.57),('15087','2013-05-24','14:15:00',4.29),('15087','2013-05-24','14:20:00',3.76),('15087','2013-05-24','14:25:00',3.7),('15087','2013-05-24','14:30:00',2.7),('15087','2013-05-24','14:35:00',3.87),('15087','2013-05-24','14:40:00',2.93),('15087','2013-05-24','14:45:00',3.11),('15087','2013-05-24','14:50:00',1.51),('15087','2013-05-24','14:55:00',1.87),('15087','2013-05-24','15:00:00',3.02),('15087','2013-05-24','15:05:00',3.54),('15087','2013-05-24','15:10:00',2.59),('15087','2013-05-24','15:15:00',4.08),('15087','2013-05-24','15:20:00',4.24),('15087','2013-05-24','15:25:00',3.92),('15087','2013-05-24','15:30:00',4.99),('15087','2013-05-24','15:35:00',4.25),('15087','2013-05-24','15:40:00',3.53),('15087','2013-05-24','15:45:00',4.59),('15087','2013-05-24','15:50:00',4.7),('15087','2013-05-24','15:55:00',4.62),('15087','2013-05-24','16:00:00',2.45),('15087','2013-05-24','16:05:00',2.45),('15087','2013-05-24','16:10:00',2.6),('15087','2013-05-24','16:15:00',3.12),('15087','2013-05-24','16:20:00',2.48),('15087','2013-05-24','16:25:00',3.43),('15087','2013-05-24','16:30:00',3.08),('15087','2013-05-24','16:35:00',1.74),('15087','2013-05-24','16:50:00',1.61),('15087','2013-05-24','16:55:00',1.96),('15087','2013-05-24','17:00:00',1.44),('15087','2013-05-24','17:05:00',1.03),('15087','2013-05-24','17:20:00',1.07),('15087','2013-05-24','17:25:00',1.1),('15087','2013-05-24','17:30:00',1.15),('15087','2013-05-24','17:35:00',1.15),('15087','2013-05-23','07:55:00',1.01),('15087','2013-05-23','08:00:00',1.26),('15087','2013-05-23','08:05:00',1.76),('15087','2013-05-23','08:10:00',1.27),('15087','2013-05-23','08:30:00',2.31),('15087','2013-05-23','08:35:00',2.03),('15087','2013-05-23','08:40:00',2.63),('15087','2013-05-23','08:45:00',1.73),('15087','2013-05-23','08:55:00',1.24),('15087','2013-05-23','09:00:00',3.09),('15087','2013-05-23','09:05:00',1.1),('15087','2013-05-23','09:15:00',1.18),('15087','2013-05-23','09:20:00',2.58),('15087','2013-05-23','09:25:00',3.73),('15087','2013-05-23','09:30:00',3.35),('15087','2013-05-23','09:35:00',3.04),('15087','2013-05-23','09:40:00',3.39),('15087','2013-05-23','09:45:00',2.37),('15087','2013-05-23','09:50:00',3.11),('15087','2013-05-23','09:55:00',1.77),('15087','2013-05-23','10:00:00',1.35),('15087','2013-05-23','10:05:00',4.27),('15087','2013-05-23','10:10:00',3.9),('15087','2013-05-23','10:15:00',4.56),('15087','2013-05-23','10:20:00',2.29),('15087','2013-05-23','10:25:00',4.12),('15087','2013-05-23','10:30:00',3.9),('15087','2013-05-23','10:35:00',4.12),('15087','2013-05-23','10:40:00',4),('15087','2013-05-23','10:45:00',4.46),('15087','2013-05-23','10:50:00',2.78),('15087','2013-05-23','10:55:00',4.53),('15087','2013-05-23','11:00:00',2.53),('15087','2013-05-23','11:05:00',4.15),('15087','2013-05-23','11:10:00',2.48),('15087','2013-05-23','11:15:00',2.65),('15087','2013-05-23','11:20:00',1.62),('15087','2013-05-23','11:25:00',2.93),('15087','2013-05-23','11:30:00',3.4),('15087','2013-05-23','11:35:00',3.92),('15087','2013-05-23','11:40:00',5.31),('15087','2013-05-23','11:45:00',2.61),('15087','2013-05-23','11:50:00',3.12),('15087','2013-05-23','11:55:00',4.45),('15087','2013-05-23','12:00:00',5.45),('15087','2013-05-23','12:05:00',5.31),('15087','2013-05-23','12:10:00',5.41),('15087','2013-05-23','12:15:00',3.31),('15087','2013-05-23','12:20:00',3.82),('15087','2013-05-23','12:25:00',3.63),('15087','2013-05-23','12:30:00',5.04),('15087','2013-05-23','12:35:00',1.99),('15087','2013-05-23','12:40:00',5.69),('15087','2013-05-23','12:45:00',3.15),('15087','2013-05-23','12:50:00',4.4),('15087','2013-05-23','12:55:00',4.96),('15087','2013-05-23','13:00:00',5.2),('15087','2013-05-23','13:05:00',4.22),('15087','2013-05-23','13:10:00',5.18),('15087','2013-05-23','13:15:00',4.5),('15087','2013-05-23','13:20:00',3.74),('15087','2013-05-23','13:25:00',5.19),('15087','2013-05-23','13:30:00',3.74),('15087','2013-05-23','13:35:00',2.56),('15087','2013-05-23','13:40:00',2.49),('15087','2013-05-23','13:45:00',3.91),('15087','2013-05-23','13:50:00',4.05),('15087','2013-05-23','13:55:00',4.34),('15087','2013-05-23','14:00:00',4.37),('15087','2013-05-23','14:05:00',5.22),('15087','2013-05-23','14:10:00',4.88),('15087','2013-05-23','14:15:00',4.38),('15087','2013-05-23','14:20:00',4.03),('15087','2013-05-23','14:25:00',2.66),('15087','2013-05-23','14:30:00',2.33),('15087','2013-05-23','14:35:00',5.34),('15087','2013-05-23','14:40:00',3.57),('15087','2013-05-23','14:45:00',2.07),('15087','2013-05-23','14:50:00',2.06),('15087','2013-05-23','14:55:00',3.73),('15087','2013-05-23','15:00:00',3.95),('15087','2013-05-23','15:05:00',3.09),('15087','2013-05-23','15:10:00',1.41),('15087','2013-05-23','15:15:00',1.88),('15087','2013-05-23','15:20:00',3.5),('15087','2013-05-23','15:25:00',1.66),('15087','2013-05-23','15:30:00',4.13),('15087','2013-05-23','15:35:00',3.48),('15087','2013-05-23','15:40:00',1.48),('15087','2013-05-23','15:45:00',2.82),('15087','2013-05-23','15:50:00',1.25),('15087','2013-05-23','15:55:00',2.3),('15087','2013-05-23','16:00:00',2.9),('15087','2013-05-23','16:05:00',4.31),('15087','2013-05-23','16:10:00',1.98),('15087','2013-05-23','16:15:00',3.22),('15087','2013-05-23','16:20:00',2.77),('15087','2013-05-23','16:25:00',3.05),('15087','2013-05-23','16:30:00',3.21),('15087','2013-05-23','16:35:00',1.8),('15087','2013-05-23','16:40:00',1.26),('15087','2013-05-23','16:45:00',2.32),('15087','2013-05-23','16:50:00',1.07),('15087','2013-05-23','17:05:00',1.26),('15087','2013-05-23','17:10:00',2.62),('15087','2013-05-23','17:15:00',1.96),('15087','2013-05-23','17:20:00',1.67),('15087','2013-05-23','17:35:00',1.68),('15087','2013-05-23','17:40:00',1.06),('15087','2013-05-23','17:55:00',1.57),('15087','2013-05-23','18:00:00',1.97),('15087','2013-05-23','18:05:00',2.41),('15087','2013-05-23','18:50:00',1.16),('15087','2013-05-22','07:50:00',1),('15087','2013-05-22','07:55:00',1.08),('15087','2013-05-22','08:00:00',1.23),('15087','2013-05-22','08:05:00',1.55),('15087','2013-05-22','08:10:00',1.33),('15087','2013-05-22','08:15:00',2.36),('15087','2013-05-22','08:20:00',2.21),('15087','2013-05-22','08:25:00',1.88),('15087','2013-05-22','08:30:00',2.45),('15087','2013-05-22','08:35:00',2.9),('15087','2013-05-22','08:40:00',1.57),('15087','2013-05-22','08:45:00',1.77),('15087','2013-05-22','08:50:00',1.02),('15087','2013-05-22','09:25:00',1.27),('15087','2013-05-22','09:30:00',3.3),('15087','2013-05-22','09:35:00',3.28),('15087','2013-05-22','09:40:00',3.27),('15087','2013-05-22','09:45:00',3.28),('15087','2013-05-22','09:50:00',3.34),('15087','2013-05-22','09:55:00',3.4),('15087','2013-05-22','10:00:00',3.43),('15087','2013-05-22','10:05:00',3.55),('15087','2013-05-22','10:10:00',3.62),('15087','2013-05-22','10:15:00',3.68),('15087','2013-05-22','10:20:00',3.49),('15087','2013-05-22','10:25:00',3.8),('15087','2013-05-22','10:30:00',3.85),('15087','2013-05-22','10:35:00',3.87),('15087','2013-05-22','10:40:00',4.14),('15087','2013-05-22','10:45:00',4.12),('15087','2013-05-22','10:50:00',4.05),('15087','2013-05-22','10:55:00',4.08),('15087','2013-05-22','11:00:00',4.16),('15087','2013-05-22','11:05:00',4.29),('15087','2013-05-22','11:10:00',3.42),('15087','2013-05-22','11:15:00',4.25),('15087','2013-05-22','11:20:00',4.38),('15087','2013-05-22','11:25:00',4.25),('15087','2013-05-22','11:30:00',3.43),('15087','2013-05-22','11:35:00',3.63),('15087','2013-05-22','11:40:00',3.74),('15087','2013-05-22','11:45:00',4.44),('15087','2013-05-22','11:50:00',2.42),('15087','2013-05-22','11:55:00',2.23),('15087','2013-05-22','12:00:00',3.25),('15087','2013-05-22','12:05:00',2.57),('15087','2013-05-22','12:10:00',2.54),('15087','2013-05-22','12:15:00',3.49),('15087','2013-05-22','12:20:00',3.82),('15087','2013-05-22','12:25:00',3.49),('15087','2013-05-22','12:30:00',2.38),('15087','2013-05-22','12:35:00',2.57),('15087','2013-05-22','12:40:00',1.71),('15087','2013-05-22','13:05:00',4.49),('15087','2013-05-22','13:10:00',2.8),('15087','2013-05-22','13:15:00',3.21),('15087','2013-05-22','13:20:00',3.16),('15087','2013-05-22','13:25:00',1.15),('15087','2013-05-22','13:30:00',1.86),('15087','2013-05-22','13:35:00',3.94),('15087','2013-05-22','13:40:00',3.02),('15087','2013-05-22','13:45:00',2.73),('15087','2013-05-22','13:50:00',1.78),('15087','2013-05-22','13:55:00',2.23),('15087','2013-05-22','14:00:00',2.86),('15087','2013-05-22','14:05:00',3.47),('15087','2013-05-22','14:10:00',4.74),('15087','2013-05-22','14:15:00',4.69),('15087','2013-05-22','14:20:00',4.55),('15087','2013-05-22','14:25:00',4.44),('15087','2013-05-22','14:30:00',4.31),('15087','2013-05-22','14:35:00',4.33),('15087','2013-05-22','14:40:00',4.32),('15087','2013-05-22','14:45:00',4.3),('15087','2013-05-22','14:50:00',4.12),('15087','2013-05-22','14:55:00',4.11),('15087','2013-05-22','15:00:00',4.08),('15087','2013-05-22','15:05:00',4.03),('15087','2013-05-22','15:10:00',3.98),('15087','2013-05-22','15:15:00',3.71),('15087','2013-05-22','15:20:00',3.43),('15087','2013-05-22','15:25:00',2.41),('15087','2013-05-22','15:30:00',2.07),('15087','2013-05-22','15:35:00',2.02),('15087','2013-05-22','15:40:00',3.67),('15087','2013-05-22','15:45:00',2.97),('15087','2013-05-22','15:50:00',3.39),('15087','2013-05-22','15:55:00',3.39),('15087','2013-05-22','16:00:00',3.35),('15087','2013-05-22','16:05:00',3.23),('15087','2013-05-22','16:10:00',3.21),('15087','2013-05-22','16:15:00',3.11),('15087','2013-05-22','16:20:00',3.13),('15087','2013-05-22','16:25:00',3.06),('15087','2013-05-22','16:30:00',2.96),('15087','2013-05-22','16:35:00',2.77),('15087','2013-05-22','16:40:00',2.84),('15087','2013-05-22','16:45:00',2.59),('15087','2013-05-22','16:50:00',1.09),('15087','2013-05-22','17:15:00',1.15),('15087','2013-05-22','17:20:00',1.25),('15087','2013-05-22','17:25:00',1.64),('15087','2013-05-22','17:30:00',1.32),('15087','2013-05-22','17:35:00',1.76),('15087','2013-05-22','17:55:00',1.59),('15087','2013-05-22','18:00:00',1.67),('15087','2014-04-01','08:20:00',1.01),('15087','2014-04-01','08:25:00',1.16),('15087','2014-04-01','08:30:00',1.27),('15087','2014-04-01','08:35:00',1.41),('15087','2014-04-01','08:40:00',1.53),('15087','2014-04-01','08:45:00',1.64),('15087','2014-04-01','08:50:00',1.73),('15087','2014-04-01','08:55:00',1.84),('15087','2014-04-01','09:00:00',1.95),('15087','2014-04-01','09:05:00',2.03),('15087','2014-04-01','09:10:00',2.13),('15087','2014-04-01','09:15:00',2.22),('15087','2014-04-01','09:20:00',2.3),('15087','2014-04-01','09:25:00',2.4),('15087','2014-04-01','09:30:00',2.45),('15087','2014-04-01','09:35:00',2.58),('15087','2014-04-01','09:40:00',2.71),('15087','2014-04-01','09:45:00',2.75),('15087','2014-04-01','09:50:00',2.87),('15087','2014-04-01','09:55:00',2.95),('15087','2014-04-01','10:00:00',3.03),('15087','2014-04-01','10:05:00',3.06),('15087','2014-04-01','10:10:00',3.14),('15087','2014-04-01','10:15:00',3.3),('15087','2014-04-01','10:20:00',3.15),('15087','2014-04-01','10:25:00',3.18),('15087','2014-04-01','10:30:00',3.64),('15087','2014-04-01','10:35:00',3.22),('15087','2014-04-01','10:40:00',1.88),('15087','2014-04-01','10:45:00',2.69),('15087','2014-04-01','10:50:00',3.83),('15087','2014-04-01','10:55:00',3.81),('15087','2014-04-01','11:00:00',3.86),('15087','2014-04-01','11:05:00',3.88),('15087','2014-04-01','11:10:00',3.91),('15087','2014-04-01','11:15:00',3.91),('15087','2014-04-01','11:20:00',4.02),('15087','2014-04-01','11:25:00',4.1),('15087','2014-04-01','11:30:00',4.15),('15087','2014-04-01','11:35:00',4.17),('15087','2014-04-01','11:40:00',4.2),('15087','2014-04-01','11:45:00',4.3),('15087','2014-04-01','11:50:00',4.27),('15087','2014-04-01','11:55:00',4.33),('15087','2014-04-01','12:00:00',4.37),('15087','2014-04-01','12:05:00',4.4),('15087','2014-04-01','12:10:00',4.41),('15087','2014-04-01','12:15:00',4.44),('15087','2014-04-01','12:20:00',4.49),('15087','2014-04-01','12:25:00',4.54),('15087','2014-04-01','12:30:00',4.58),('15087','2014-04-01','12:35:00',4.61),('15087','2014-04-01','12:40:00',4.63),('15087','2014-04-01','12:45:00',4.66),('15087','2014-04-01','12:50:00',4.55),('15087','2014-04-01','12:55:00',4.65),('15087','2014-04-01','13:00:00',4.66),('15087','2014-04-01','13:05:00',4.55),('15087','2014-04-01','13:10:00',4.71),('15087','2014-04-01','13:15:00',4.23),('15087','2014-04-01','13:20:00',4.21),('15087','2014-04-01','13:25:00',4.62),('15087','2014-04-01','13:30:00',4.62),('15087','2014-04-01','13:35:00',4.66),('15087','2014-04-01','13:40:00',4.69),('15087','2014-04-01','13:45:00',4.62),('15087','2014-04-01','13:50:00',4.56),('15087','2014-04-01','13:55:00',4.54),('15087','2014-04-01','14:00:00',4.5),('15087','2014-04-01','14:05:00',4.51),('15087','2014-04-01','14:10:00',3.93),('15087','2014-04-01','14:15:00',4.01),('15087','2014-04-01','14:20:00',2.89),('15087','2014-04-01','14:25:00',3.96),('15087','2014-04-01','14:30:00',3.54),('15087','2014-04-01','14:35:00',4.39),('15087','2014-04-01','14:40:00',3.39),('15087','2014-04-01','14:45:00',4.41),('15087','2014-04-01','14:50:00',4.05),('15087','2014-04-01','14:55:00',3.19),('15087','2014-04-01','15:00:00',4.03),('15087','2014-04-01','15:05:00',3.16),('15087','2014-04-01','15:10:00',3.89),('15087','2014-04-01','15:15:00',2.92),('15087','2014-04-01','15:20:00',1.72),('15087','2014-04-01','15:25:00',3.54),('15087','2014-04-01','15:30:00',3.48),('15087','2014-04-01','15:35:00',2.54),('15087','2014-04-01','15:40:00',3.59),('15087','2014-04-01','15:45:00',2.82),('15087','2014-04-01','15:50:00',3.21),('15087','2014-04-01','15:55:00',2.96),('15087','2014-04-01','16:00:00',1.78),('15087','2014-04-01','16:05:00',2.91),('15087','2014-04-01','16:10:00',2.63),('15087','2014-04-01','16:15:00',1.95),('15087','2014-04-01','16:20:00',1.37),('15087','2014-04-01','16:25:00',2.23),('15087','2014-04-01','16:30:00',2.57),('15087','2014-04-01','16:35:00',2.63),('15087','2014-04-01','16:40:00',2.49),('15087','2014-04-01','16:45:00',1.37),('15087','2014-04-01','16:50:00',1.53),('15087','2014-04-01','16:55:00',1.87),('15087','2014-04-01','17:00:00',2.19),('15087','2014-04-01','17:05:00',1.97),('15087','2014-04-01','17:10:00',1.59),('15087','2014-04-01','17:15:00',1.85),('15087','2014-04-01','17:20:00',1.66),('15087','2014-04-01','17:25:00',1.32),('15087','2014-04-01','17:30:00',1.45),('15087','2014-04-01','17:35:00',1.35),('15087','2014-04-01','17:40:00',1.27),('15087','2014-04-01','17:45:00',1.11),('15087','2014-04-01','17:50:00',1.08),('15087','2013-05-21','07:30:00',1.09),('15087','2013-05-21','07:35:00',1.35),('15087','2013-05-21','07:40:00',1.6),('15087','2013-05-21','07:45:00',1.27),('15087','2013-05-21','07:50:00',1.05),('15087','2013-05-21','07:55:00',1.13),('15087','2013-05-21','08:00:00',1.2),('15087','2013-05-21','08:10:00',1.57),('15087','2013-05-21','08:15:00',2.02),('15087','2013-05-21','08:20:00',1.66),('15087','2013-05-21','08:25:00',2),('15087','2013-05-21','08:30:00',1.36),('15087','2013-05-21','08:35:00',1.3),('15087','2013-05-21','08:40:00',1.53),('15087','2013-05-21','08:45:00',1.28),('15087','2013-05-21','08:50:00',1.41),('15087','2013-05-21','08:55:00',1.88),('15087','2013-05-21','09:00:00',1.57),('15087','2013-05-21','09:05:00',1.36),('15087','2013-05-21','09:10:00',1.55),('15087','2013-05-21','09:15:00',1.71),('15087','2013-05-21','09:20:00',2.47),('15087','2013-05-21','09:25:00',2.49),('15087','2013-05-21','09:30:00',2.02),('15087','2013-05-21','09:35:00',2.12),('15087','2013-05-21','09:40:00',2.14),('15087','2013-05-21','09:45:00',1.78),('15087','2013-05-21','09:50:00',1.71),('15087','2013-05-21','09:55:00',1.98),('15087','2013-05-21','10:00:00',2.16),('15087','2013-05-21','10:05:00',2.39),('15087','2013-05-21','10:10:00',2.45),('15087','2013-05-21','10:15:00',2.62),('15087','2013-05-21','10:20:00',2.16),('15087','2013-05-21','10:25:00',2.1),('15087','2013-05-21','10:30:00',1.88),('15087','2013-05-21','10:35:00',1.96),('15087','2013-05-21','10:40:00',2.21),('15087','2013-05-21','10:45:00',3.19),('15087','2013-05-21','10:50:00',2.24),('15087','2013-05-21','10:55:00',1.67),('15087','2013-05-21','11:00:00',2.04),('15087','2013-05-21','11:05:00',1.89),('15087','2013-05-21','11:10:00',3.11),('15087','2013-05-21','11:15:00',3.93),('15087','2013-05-21','11:20:00',3.97),('15087','2013-05-21','11:25:00',4.32),('15087','2013-05-21','11:30:00',3.46),('15087','2013-05-21','11:35:00',2.78),('15087','2013-05-21','11:40:00',2.87),('15087','2013-05-21','11:45:00',3.42),('15087','2013-05-21','11:50:00',3.08),('15087','2013-05-21','11:55:00',3.99),('15087','2013-05-21','12:00:00',3.57),('15087','2013-05-21','12:05:00',4.23),('15087','2013-05-21','12:10:00',2.98),('15087','2013-05-21','12:15:00',3.34),('15087','2013-05-21','12:20:00',2.55),('15087','2013-05-21','12:25:00',3.46),('15087','2013-05-21','12:30:00',4.39),('15087','2013-05-21','12:35:00',2.83),('15087','2013-05-21','12:40:00',4.68),('15087','2013-05-21','12:45:00',4.21),('15087','2013-05-21','12:50:00',2.97),('15087','2013-05-21','12:55:00',4.97),('15087','2013-05-21','13:00:00',4.27),('15087','2013-05-21','13:05:00',4.39),('15087','2013-05-21','13:10:00',2.77),('15087','2013-05-21','13:15:00',3.85),('15087','2013-05-21','13:20:00',3.15),('15087','2013-05-21','13:25:00',3.19),('15087','2013-05-21','13:30:00',3.11),('15087','2013-05-21','13:35:00',1.47),('15087','2013-05-21','14:05:00',1.14),('15087','2013-05-21','14:10:00',1.79),('15087','2013-05-21','14:15:00',2.16),('15087','2013-05-21','14:20:00',1.73),('15087','2013-05-21','14:25:00',2.97),('15087','2013-05-21','14:30:00',2.81),('15087','2013-05-21','14:35:00',2.07),('15087','2013-05-21','14:40:00',1.93),('15087','2013-05-21','14:45:00',1.59),('15087','2013-05-21','15:15:00',1.14),('15087','2013-05-21','15:20:00',1.53),('15087','2013-05-21','15:25:00',1.56),('15087','2013-05-21','15:30:00',2.62),('15087','2013-05-21','15:35:00',1.68),('15087','2013-05-21','15:40:00',1.35),('15087','2013-05-21','15:45:00',1.41),('15087','2013-05-21','15:50:00',1.25),('15087','2013-05-21','15:55:00',1.2),('15087','2013-05-21','16:00:00',1.17),('15087','2013-05-21','16:05:00',1.19),('15087','2013-05-21','16:10:00',1.32),('15087','2013-05-21','16:15:00',1.1),('15087','2013-05-21','16:25:00',1.28),('15087','2013-05-21','16:30:00',1.8),('15087','2013-05-21','16:35:00',2.14),('15087','2013-05-21','16:40:00',1.93),('15087','2013-05-21','16:45:00',1.78),('15087','2013-05-21','16:50:00',1.1),('15087','2013-05-20','07:30:00',1.05),('15087','2013-05-20','07:35:00',1.17),('15087','2013-05-20','07:40:00',1.25),('15087','2013-05-20','07:45:00',1.31),('15087','2013-05-20','07:50:00',1.37),('15087','2013-05-20','07:55:00',1.48),('15087','2013-05-20','08:00:00',1.57),('15087','2013-05-20','08:05:00',1.23),('15087','2013-05-20','08:10:00',1.38),('15087','2013-05-20','08:15:00',1.26),('15087','2013-05-20','08:20:00',1.72),('15087','2013-05-20','08:45:00',2.47),('15087','2013-05-20','08:50:00',3.19),('15087','2013-05-20','08:55:00',2.77),('15087','2013-05-20','09:00:00',2.74),('15087','2013-05-20','09:05:00',2.25),('15087','2013-05-20','09:10:00',3.67),('15087','2013-05-20','09:15:00',1.47),('15087','2013-05-20','09:20:00',2.04),('15087','2013-05-20','09:25:00',1.17),('15087','2013-05-20','09:30:00',1.13),('15087','2013-05-20','09:35:00',2.54),('15087','2013-05-20','09:45:00',2.13),('15087','2013-05-20','09:50:00',2.6),('15087','2013-05-20','10:00:00',1.06),('15087','2013-05-20','10:05:00',1.57),('15087','2013-05-20','10:10:00',2.6),('15087','2013-05-20','10:25:00',2.2),('15087','2013-05-20','10:30:00',3.65),('15087','2013-05-20','10:35:00',1.98),('15087','2013-05-20','10:40:00',1.78),('15087','2013-05-20','10:45:00',1.66),('15087','2013-05-20','10:50:00',1.71),('15087','2013-05-20','10:55:00',1.12),('15087','2013-05-20','11:00:00',4.68),('15087','2013-05-20','11:05:00',3.33),('15087','2013-05-20','11:10:00',4.77),('15087','2013-05-20','11:15:00',3.74),('15087','2013-05-20','11:20:00',2.7),('15087','2013-05-20','11:25:00',3.86),('15087','2013-05-20','11:40:00',1.95),('15087','2013-05-20','11:45:00',2),('15087','2013-05-20','11:50:00',1.71),('15087','2013-05-20','11:55:00',3.52),('15087','2013-05-20','12:00:00',3.04),('15087','2013-05-20','12:05:00',3.43),('15087','2013-05-20','12:10:00',2.16),('15087','2013-05-20','12:15:00',2.15),('15087','2013-05-20','12:20:00',2.36),('15087','2013-05-20','12:25:00',2.37),('15087','2013-05-20','12:30:00',2.83),('15087','2013-05-20','12:35:00',2.46),('15087','2013-05-20','12:40:00',2.85),('15087','2013-05-20','12:45:00',3.93),('15087','2013-05-20','12:50:00',1.77),('15087','2013-05-20','12:55:00',3.5),('15087','2013-05-20','13:00:00',2.05),('15087','2013-05-20','13:05:00',3.04),('15087','2013-05-20','13:10:00',2.21),('15087','2013-05-20','13:15:00',2.31),('15087','2013-05-20','13:20:00',4.45),('15087','2013-05-20','13:25:00',5.53),('15087','2013-05-20','13:30:00',1.39),('15087','2013-05-20','13:35:00',5.04),('15087','2013-05-20','13:40:00',1.58),('15087','2013-05-20','13:45:00',5.1),('15087','2013-05-20','13:50:00',3.3),('15087','2013-05-20','13:55:00',4.75),('15087','2013-05-20','14:00:00',4.57),('15087','2013-05-20','14:10:00',3.55),('15087','2013-05-20','14:15:00',3.74),('15087','2013-05-20','14:20:00',2.16),('15087','2013-05-20','14:25:00',4.51),('15087','2013-05-20','14:30:00',4.84),('15087','2013-05-20','14:35:00',3.31),('15087','2013-05-20','14:40:00',2.32),('15087','2013-05-20','14:45:00',4.54),('15087','2013-05-20','14:50:00',3.56),('15087','2013-05-20','14:55:00',4.77),('15087','2013-05-20','15:00:00',2.39),('15087','2013-05-20','15:05:00',2.59),('15087','2013-05-20','15:10:00',4.56),('15087','2013-05-20','15:15:00',1.86),('15087','2013-05-20','15:20:00',4.54),('15087','2013-05-20','15:25:00',4),('15087','2013-05-20','15:30:00',4.38),('15087','2013-05-20','15:35:00',4.31),('15087','2013-05-20','15:40:00',1.88),('15087','2013-05-20','15:45:00',1.91),('15087','2013-05-20','15:50:00',2.7),('15087','2013-05-20','15:55:00',2.33),('15087','2013-05-20','16:00:00',2.28),('15087','2013-05-20','16:05:00',3.65),('15087','2013-05-20','16:10:00',3.69),('15087','2013-05-20','16:15:00',3.21),('15087','2013-05-20','16:20:00',3.37),('15087','2013-05-20','16:25:00',3.34),('15087','2013-05-20','16:30:00',3.15),('15087','2013-05-20','16:35:00',3),('15087','2013-05-20','16:40:00',3.04),('15087','2013-05-20','16:45:00',2.8),('15087','2013-05-20','16:50:00',2.71),('15087','2013-05-20','16:55:00',2.67),('15087','2013-05-20','17:00:00',2.48),('15087','2013-05-20','17:05:00',2.56),('15087','2013-05-20','17:10:00',1.94),('15087','2013-05-20','17:15:00',1.25),('15087','2013-05-20','17:20:00',2.24),('15087','2013-05-20','17:25:00',2.67),('15087','2013-05-20','17:30:00',2.63),('15087','2013-05-20','17:35:00',2.05),('15087','2013-05-20','17:40:00',1.88),('15087','2013-05-20','17:45:00',1.75),('15087','2013-05-20','17:50:00',1.61),('15087','2013-05-20','17:55:00',1.59),('15087','2013-05-20','18:00:00',1.5),('15087','2013-05-20','18:05:00',1.56),('15087','2013-05-20','18:10:00',1.27),('15087','2013-05-20','18:15:00',1.4),('15087','2013-05-20','18:20:00',1.19),('15087','2013-05-20','18:25:00',1.04),('15087','2013-05-19','08:35:00',1.28),('15087','2013-05-19','08:45:00',1.06),('15087','2013-05-19','08:50:00',1.29),('15087','2013-05-19','08:55:00',1.43),('15087','2013-05-19','09:00:00',1.28),('15087','2013-05-19','09:05:00',1.19),('15087','2013-05-19','09:10:00',1.37),('15087','2013-05-19','09:15:00',1.36),('15087','2013-05-19','09:40:00',1.13),('15087','2013-05-19','09:45:00',1.26),('15087','2013-05-19','09:55:00',1.1),('15087','2013-05-19','10:00:00',1.4),('15087','2013-05-19','10:05:00',1.73),('15087','2013-05-19','10:10:00',2.57),('15087','2013-05-19','10:15:00',3.12),('15087','2013-05-19','10:20:00',3.15),('15087','2013-05-19','10:25:00',2.66),('15087','2013-05-19','10:30:00',3.47),('15087','2013-05-19','10:35:00',4.03),('15087','2013-05-19','10:40:00',4.39),('15087','2013-05-19','10:45:00',4.39),('15087','2013-05-19','11:00:00',3.66),('15087','2013-05-19','11:05:00',2.16),('15087','2013-05-19','11:10:00',3.45),('15087','2013-05-19','11:15:00',4.31),('15087','2013-05-19','11:20:00',3.22),('15087','2013-05-19','11:25:00',4.72),('15087','2013-05-19','11:30:00',4.76),('15087','2013-05-19','11:35:00',4.75),('15087','2013-05-19','11:40:00',2.68),('15087','2013-05-19','11:45:00',4.82),('15087','2013-05-19','11:50:00',4.83),('15087','2013-05-19','11:55:00',4.96),('15087','2013-05-19','12:00:00',2.96),('15087','2013-05-19','12:05:00',4.79),('15087','2013-05-19','12:10:00',4.89),('15087','2013-05-19','12:15:00',5.05),('15087','2013-05-19','12:20:00',3.67),('15087','2013-05-19','12:25:00',3.47),('15087','2013-05-19','12:30:00',3.23),('15087','2013-05-19','12:35:00',3.22),('15087','2013-05-19','12:40:00',4.23),('15087','2013-05-19','12:45:00',4.48),('15087','2013-05-19','12:50:00',3.5),('15087','2013-05-19','12:55:00',2.88),('15087','2013-05-19','13:00:00',3.94),('15087','2013-05-19','13:05:00',4.06),('15087','2013-05-19','13:10:00',4.15),('15087','2013-05-19','13:15:00',4.04),('15087','2013-05-19','13:20:00',3.97),('15087','2013-05-19','13:25:00',4.9),('15087','2013-05-19','13:30:00',4.8),('15087','2013-05-19','13:35:00',4.89),('15087','2013-05-19','13:40:00',4.88),('15087','2013-05-19','13:45:00',4.86),('15087','2013-05-19','13:50:00',4.86),('15087','2013-05-19','13:55:00',4.82),('15087','2013-05-19','14:00:00',4.82),('15087','2013-05-19','14:05:00',4.79),('15087','2013-05-19','14:10:00',4.78),('15087','2013-05-19','14:15:00',4.71),('15087','2013-05-19','14:20:00',4.56),('15087','2013-05-19','14:25:00',4.29),('15087','2013-05-19','14:30:00',4.37),('15087','2013-05-19','14:35:00',4.59),('15087','2013-05-19','14:40:00',4.57),('15087','2013-05-19','14:45:00',4.39),('15087','2013-05-19','14:50:00',4.37),('15087','2013-05-19','14:55:00',4.4),('15087','2013-05-19','15:00:00',4.36),('15087','2013-05-19','15:05:00',4.31),('15087','2013-05-19','15:10:00',4.04),('15087','2013-05-19','15:15:00',3.75),('15087','2013-05-19','15:20:00',4.07),('15087','2013-05-19','15:25:00',4.08),('15087','2013-05-19','15:30:00',3.99),('15087','2013-05-19','15:35:00',3.87),('15087','2013-05-19','15:40:00',3.8),('15087','2013-05-19','15:45:00',3.77),('15087','2013-05-19','15:50:00',3.7),('15087','2013-05-19','15:55:00',3.58),('15087','2013-05-19','16:00:00',3.38),('15087','2013-05-19','16:05:00',3.44),('15087','2013-05-19','16:10:00',3.38),('15087','2013-05-19','16:15:00',3.29),('15087','2013-05-19','16:20:00',3.22),('15087','2013-05-19','16:25:00',3.18),('15087','2013-05-19','16:30:00',3.1),('15087','2013-05-19','16:35:00',3.05),('15087','2013-05-19','16:40:00',3.03),('15087','2013-05-19','16:45:00',2.93),('15087','2013-05-19','16:50:00',2.84),('15087','2013-05-19','16:55:00',2.78),('15087','2013-05-19','17:00:00',2.73),('15087','2013-05-19','17:05:00',2.65),('15087','2013-05-19','17:10:00',2.58),('15087','2013-05-19','17:15:00',2.55),('15087','2013-05-19','17:20:00',2.53),('15087','2013-05-19','17:25:00',2.37),('15087','2013-05-19','17:30:00',2.25),('15087','2013-05-19','17:35:00',2.11),('15087','2013-05-19','17:40:00',1.98),('15087','2013-05-19','17:45:00',1.91),('15087','2013-05-19','17:50:00',1.86),('15087','2013-05-19','17:55:00',1.68),('15087','2013-05-19','18:00:00',1.62),('15087','2013-05-19','18:05:00',1.53),('15087','2013-05-19','18:10:00',1.46),('15087','2013-05-19','18:15:00',1.34),('15087','2013-05-19','18:20:00',1.22),('15087','2013-05-19','18:25:00',1.12),('15087','2013-05-19','18:30:00',1),('15087','2013-05-18','07:30:00',1.02),('15087','2013-05-18','07:35:00',1.1),('15087','2013-05-18','07:40:00',1.23),('15087','2013-05-18','07:45:00',1.19),('15087','2013-05-18','07:50:00',1.19),('15087','2013-05-18','07:55:00',1.84),('15087','2013-05-18','08:00:00',2.04),('15087','2013-05-18','08:05:00',1.89),('15087','2013-05-18','08:20:00',1.47),('15087','2013-05-18','08:25:00',2.61),('15087','2013-05-18','08:30:00',2.19),('15087','2013-05-18','08:35:00',2.07),('15087','2013-05-18','08:40:00',2.47),('15087','2013-05-18','08:45:00',2.43),('15087','2013-05-18','08:50:00',2.51),('15087','2013-05-18','08:55:00',2.6),('15087','2013-05-18','09:00:00',2.68),('15087','2013-05-18','09:05:00',2.68),('15087','2013-05-18','09:10:00',2.88),('15087','2013-05-18','09:15:00',2.93),('15087','2013-05-18','09:20:00',2.99),('15087','2013-05-18','09:25:00',3.04),('15087','2013-05-18','09:30:00',3.13),('15087','2013-05-18','09:35:00',3.21),('15087','2013-05-18','09:40:00',3.28),('15087','2013-05-18','09:45:00',3.35),('15087','2013-05-18','09:50:00',3.4),('15087','2013-05-18','09:55:00',3.49),('15087','2013-05-18','10:00:00',3.53),('15087','2013-05-18','10:05:00',3.61),('15087','2013-05-18','10:10:00',3.68),('15087','2013-05-18','10:15:00',3.72),('15087','2013-05-18','10:20:00',3.78),('15087','2013-05-18','10:25:00',3.82),('15087','2013-05-18','10:30:00',3.84),('15087','2013-05-18','10:35:00',3.9),('15087','2013-05-18','10:40:00',3.93),('15087','2013-05-18','10:45:00',4.01),('15087','2013-05-18','10:50:00',4.08),('15087','2013-05-18','10:55:00',3.93),('15087','2013-05-18','11:00:00',4.35),('15087','2013-05-18','11:05:00',3.86),('15087','2013-05-18','11:10:00',3.51),('15087','2013-05-18','11:15:00',4.53),('15087','2013-05-18','11:20:00',4.45),('15087','2013-05-18','11:25:00',4.53),('15087','2013-05-18','11:30:00',4.11),('15087','2013-05-18','11:35:00',4.26),('15087','2013-05-18','11:40:00',4.44),('15087','2013-05-18','11:45:00',4.37),('15087','2013-05-18','11:50:00',4.16),('15087','2013-05-18','11:55:00',4.12),('15087','2013-05-18','12:00:00',4.17),('15087','2013-05-18','12:05:00',4.44),('15087','2013-05-18','12:10:00',4.4),('15087','2013-05-18','12:15:00',4.45),('15087','2013-05-18','12:20:00',4.5),('15087','2013-05-18','12:25:00',4.6),('15087','2013-05-18','12:30:00',3.42),('15087','2013-05-18','12:35:00',4.56),('15087','2013-05-18','12:40:00',4.52),('15087','2013-05-18','12:45:00',4.01),('15087','2013-05-18','12:50:00',4.54),('15087','2013-05-18','12:55:00',4.38),('15087','2013-05-18','13:00:00',4.51),('15087','2013-05-18','13:05:00',4.5),('15087','2013-05-18','13:10:00',4.54),('15087','2013-05-18','13:15:00',4.49),('15087','2013-05-18','13:20:00',4.54),('15087','2013-05-18','13:25:00',4.55),('15087','2013-05-18','13:30:00',4.49),('15087','2013-05-18','13:35:00',4.19),('15087','2013-05-18','13:40:00',4.36),('15087','2013-05-18','13:45:00',4.74),('15087','2013-05-18','13:50:00',4.32),('15087','2013-05-18','13:55:00',3.46),('15087','2013-05-18','14:00:00',3.3),('15087','2013-05-18','14:05:00',3.6),('15087','2013-05-18','14:10:00',4.78),('15087','2013-05-18','14:15:00',4.65),('15087','2013-05-18','14:20:00',4.56),('15087','2013-05-18','14:25:00',4.33),('15087','2013-05-18','14:30:00',4.32),('15087','2013-05-18','14:35:00',4.31),('15087','2013-05-18','14:40:00',4.52),('15087','2013-05-18','14:45:00',4.31),('15087','2013-05-18','14:50:00',4.14),('15087','2013-05-18','14:55:00',3.7),('15087','2013-05-18','15:00:00',3.84),('15087','2013-05-18','15:05:00',3.76),('15087','2013-05-18','15:10:00',3.61),('15087','2013-05-18','15:15:00',3.55),('15087','2013-05-18','15:20:00',3.55),('15087','2013-05-18','15:25:00',3.5),('15087','2013-05-18','15:30:00',3.42),('15087','2013-05-18','15:35:00',3.31),('15087','2013-05-18','15:40:00',3.13),('15087','2013-05-18','15:45:00',3.08),('15087','2013-05-18','15:50:00',3.15),('15087','2013-05-18','15:55:00',3.09),('15087','2013-05-18','16:00:00',3.01),('15087','2013-05-18','16:05:00',2.97),('15087','2013-05-18','16:10:00',2.89),('15087','2013-05-18','16:15:00',2.84),('15087','2013-05-18','16:20:00',2.78),('15087','2013-05-18','16:25:00',2.68),('15087','2013-05-18','16:30:00',2.68),('15087','2013-05-18','16:35:00',2.62),('15087','2013-05-18','16:40:00',2.6),('15087','2013-05-18','16:45:00',2.42),('15087','2013-05-18','16:50:00',2.35),('15087','2013-05-18','16:55:00',2.18),('15087','2013-05-18','17:00:00',2.12),('15087','2013-05-18','17:05:00',2.13),('15087','2013-05-18','17:10:00',2.06),('15087','2013-05-18','17:15:00',2.01),('15087','2013-05-18','17:20:00',1.96),('15087','2013-05-18','17:25:00',1.87),('15087','2013-05-18','17:30:00',1.77),('15087','2013-05-18','17:35:00',1.69),('15087','2013-05-18','17:40:00',1.6),('15087','2013-05-18','17:45:00',1.51),('15087','2013-05-18','17:50:00',1.44),('15087','2013-05-18','17:55:00',1.34),('15087','2013-05-18','18:00:00',1.28),('15087','2013-05-18','18:05:00',1.21),('15087','2013-05-18','18:10:00',1.17),('15087','2013-05-18','18:15:00',1.08),('15087','2013-05-18','18:20:00',1),('15087','2013-05-17','07:40:00',1.18),('15087','2013-05-17','07:45:00',1.19),('15087','2013-05-17','07:50:00',1.23),('15087','2013-05-17','07:55:00',1.25),('15087','2013-05-17','08:00:00',1.15),('15087','2013-05-17','08:10:00',1.31),('15087','2013-05-17','08:15:00',2.03),('15087','2013-05-17','08:20:00',2.26),('15087','2013-05-17','08:25:00',1.66),('15087','2013-05-17','09:25:00',1.11),('15087','2013-05-17','10:25:00',1.44),('15087','2013-05-17','10:30:00',1.77),('15087','2013-05-17','10:35:00',1.29),('15087','2013-05-17','10:40:00',1.51),('15087','2013-05-17','10:45:00',1.67),('15087','2013-05-17','10:50:00',3),('15087','2013-05-17','10:55:00',3.23),('15087','2013-05-17','11:00:00',2.55),('15087','2013-05-17','11:05:00',2.17),('15087','2013-05-17','11:10:00',1.54),('15087','2013-05-17','11:15:00',2.37),('15087','2013-05-17','11:20:00',2.11),('15087','2013-05-17','11:25:00',1.86),('15087','2013-05-17','11:30:00',1.75),('15087','2013-05-17','11:35:00',2.31),('15087','2013-05-17','11:40:00',1.86),('15087','2013-05-17','11:45:00',4.26),('15087','2013-05-17','11:50:00',4.81),('15087','2013-05-17','11:55:00',4.01),('15087','2013-05-17','12:00:00',4.89),('15087','2013-05-17','12:05:00',3.52),('15087','2013-05-17','12:10:00',3.79),('15087','2013-05-17','12:15:00',2.38),('15087','2013-05-17','12:20:00',4.06),('15087','2013-05-17','12:25:00',3.51),('15087','2013-05-17','12:30:00',2.49),('15087','2013-05-17','12:35:00',3.09),('15087','2013-05-17','12:40:00',5.15),('15087','2013-05-17','12:45:00',5.23),('15087','2013-05-17','12:50:00',5.19),('15087','2013-05-17','12:55:00',4.66),('15087','2013-05-17','13:00:00',3.96),('15087','2013-05-17','13:05:00',4.42),('15087','2013-05-17','13:10:00',4.26),('15087','2013-05-17','13:15:00',5.03),('15087','2013-05-17','13:20:00',5.21),('15087','2013-05-17','13:25:00',4.87),('15087','2013-05-17','13:30:00',3.8),('15087','2013-05-17','13:35:00',4.92),('15087','2013-05-17','13:40:00',4.31),('15087','2013-05-17','13:45:00',4.21),('15087','2013-05-17','13:50:00',4.46),('15087','2013-05-17','13:55:00',5.23),('15087','2013-05-17','14:00:00',3.32),('15087','2013-05-17','14:05:00',3.95),('15087','2013-05-17','14:10:00',4.18),('15087','2013-05-17','14:15:00',4.54),('15087','2013-05-17','14:20:00',4.81),('15087','2013-05-17','14:25:00',4.09),('15087','2013-05-17','14:30:00',4.29),('15087','2013-05-17','14:35:00',4.2),('15087','2013-05-17','14:40:00',2.76),('15087','2013-05-17','14:45:00',3.55),('15087','2013-05-17','14:50:00',4.53),('15087','2013-05-17','14:55:00',2.42),('15087','2013-05-17','15:00:00',4.75),('15087','2013-05-17','15:05:00',2.84),('15087','2013-05-17','15:10:00',1.36),('15087','2013-05-17','15:15:00',3.43),('15087','2013-05-17','15:20:00',2.15),('15087','2013-05-17','15:25:00',1.75),('15087','2013-05-17','15:30:00',2.18),('15087','2013-05-17','15:35:00',2.71),('15087','2013-05-17','15:40:00',2.99),('15087','2013-05-17','15:45:00',1.64),('15087','2013-05-17','15:50:00',3.7),('15087','2013-05-17','15:55:00',4.01),('15087','2013-05-17','16:00:00',3.88),('15087','2013-05-17','16:05:00',2.73),('15087','2013-05-17','16:10:00',3.8),('15087','2013-05-17','16:15:00',2.99),('15087','2013-05-17','16:20:00',2.77),('15087','2013-05-17','16:25:00',3.19),('15087','2013-05-17','16:30:00',3.37),('15087','2013-05-17','16:35:00',3.49),('15087','2013-05-17','16:40:00',3.4),('15087','2013-05-17','16:45:00',3.06),('15087','2013-05-17','16:50:00',2.77),('15087','2013-05-17','16:55:00',2.67),('15087','2013-05-17','17:00:00',2.61),('15087','2013-05-17','17:05:00',2.52),('15087','2013-05-17','17:10:00',2.43),('15087','2013-05-17','17:15:00',2.4),('15087','2013-05-17','17:20:00',2.37),('15087','2013-05-17','17:25:00',2.29),('15087','2013-05-17','17:30:00',2.18),('15087','2013-05-17','17:35:00',2.07),('15087','2013-05-17','17:40:00',1.92),('15087','2013-05-17','17:45:00',1.76),('15087','2013-05-17','17:50:00',1.61),('15087','2013-05-17','17:55:00',1.59),('15087','2013-05-17','18:00:00',1.55),('15087','2013-05-17','18:05:00',1.5),('15087','2013-05-17','18:10:00',1.38),('15087','2013-05-17','18:15:00',1.27),('15087','2013-05-17','18:20:00',1.15),('15087','2013-05-17','18:25:00',1.06),('15087','2013-05-16','09:20:00',1.19),('15087','2013-05-16','09:25:00',1.69),('15087','2013-05-16','09:30:00',1.72),('15087','2013-05-16','09:35:00',2.09),('15087','2013-05-16','09:40:00',2.33),('15087','2013-05-16','09:45:00',2.79),('15087','2013-05-16','09:50:00',1.36),('15087','2013-05-16','09:55:00',1.34),('15087','2013-05-16','10:00:00',1.7),('15087','2013-05-16','10:05:00',1.37),('15087','2013-05-16','10:10:00',1.24),('15087','2013-05-16','10:15:00',1.69),('15087','2013-05-16','10:20:00',2.24),('15087','2013-05-16','10:25:00',1.98),('15087','2013-05-16','10:30:00',2.1),('15087','2013-05-16','10:35:00',1.46),('15087','2013-05-16','10:40:00',1.42),('15087','2013-05-16','10:45:00',1.28),('15087','2013-05-16','10:50:00',1.51),('15087','2013-05-16','10:55:00',1.75),('15087','2013-05-16','11:00:00',4.34),('15087','2013-05-16','11:05:00',3.77),('15087','2013-05-16','11:10:00',3.43),('15087','2013-05-16','11:15:00',2.39),('15087','2013-05-16','11:20:00',1.2),('15087','2013-05-16','11:25:00',1.27),('15087','2013-05-16','11:30:00',1.6),('15087','2013-05-16','11:35:00',2.8),('15087','2013-05-16','11:40:00',3.88),('15087','2013-05-16','11:45:00',3.55),('15087','2013-05-16','11:50:00',3.75),('15087','2013-05-16','11:55:00',2.73),('15087','2013-05-16','12:00:00',1.97),('15087','2013-05-16','12:05:00',1.8),('15087','2013-05-16','12:10:00',1.8),('15087','2013-05-16','12:15:00',2.59),('15087','2013-05-16','12:20:00',2.07),('15087','2013-05-16','12:25:00',2.23),('15087','2013-05-16','12:30:00',3.61),('15087','2013-05-16','12:35:00',3.73),('15087','2013-05-16','12:40:00',5.11),('15087','2013-05-16','12:45:00',3.31),('15087','2013-05-16','12:50:00',2.96),('15087','2013-05-16','12:55:00',4.34),('15087','2013-05-16','13:00:00',4.44),('15087','2013-05-16','13:05:00',4.5),('15087','2013-05-16','13:10:00',4.43),('15087','2013-05-16','13:15:00',4.13),('15087','2013-05-16','13:20:00',3.32),('15087','2013-05-16','13:25:00',4.47),('15087','2013-05-16','13:30:00',4.38),('15087','2013-05-16','13:35:00',4.35),('15087','2013-05-16','13:40:00',4.29),('15087','2013-05-16','13:45:00',4.26),('15087','2013-05-16','13:50:00',4.31),('15087','2013-05-16','13:55:00',4.27),('15087','2013-05-16','14:00:00',4.22),('15087','2013-05-16','14:05:00',4.25),('15087','2013-05-16','14:10:00',4.21),('15087','2013-05-16','14:15:00',4.16),('15087','2013-05-16','14:20:00',4.06),('15087','2013-05-16','14:25:00',3.98),('15087','2013-05-16','14:30:00',4),('15087','2013-05-16','14:35:00',3.89),('15087','2013-05-16','14:40:00',3.86),('15087','2013-05-16','14:45:00',3.78),('15087','2013-05-16','14:50:00',3.46),('15087','2013-05-16','14:55:00',3.28),('15087','2013-05-16','15:00:00',3.73),('15087','2013-05-16','15:05:00',3.59),('15087','2013-05-16','15:10:00',3.46),('15087','2013-05-16','15:15:00',3.33),('15087','2013-05-16','15:20:00',3.51),('15087','2013-05-16','15:25:00',3.34),('15087','2013-05-16','15:30:00',3.22),('15087','2013-05-16','15:35:00',3.13),('15087','2013-05-16','15:40:00',3.27),('15087','2013-05-16','15:45:00',3.16),('15087','2013-05-16','15:50:00',3.12),('15087','2013-05-16','15:55:00',3.03),('15087','2013-05-16','16:00:00',2.96),('15087','2013-05-16','16:05:00',2.76),('15087','2013-05-16','16:10:00',2.93),('15087','2013-05-16','16:15:00',2.69),('15087','2013-05-16','16:20:00',2.89),('15087','2013-05-16','16:25:00',2.83),('15087','2013-05-16','16:30:00',2.83),('15087','2013-05-16','16:35:00',2.6),('15087','2013-05-16','16:40:00',1.56),('15087','2013-05-16','16:45:00',1.39),('15087','2013-05-16','16:50:00',1.88),('15087','2013-05-16','16:55:00',1.76),('15087','2013-05-16','17:00:00',1.55),('15087','2013-05-16','17:15:00',1.33),('15087','2013-05-16','17:20:00',1.45),('15087','2013-05-16','17:25:00',1.53),('15087','2013-05-16','17:30:00',1.87),('15087','2013-05-16','17:35:00',1.73),('15087','2013-05-16','17:40:00',1.44),('15087','2013-05-16','17:45:00',1.02),('15087','2013-05-15','07:30:00',1.05),('15087','2013-05-15','07:35:00',1.14),('15087','2013-05-15','07:40:00',1.23),('15087','2013-05-15','07:45:00',1.42),('15087','2013-05-15','07:50:00',1.46),('15087','2013-05-15','07:55:00',1.38),('15087','2013-05-15','08:00:00',1.46),('15087','2013-05-15','08:05:00',1.41),('15087','2013-05-15','08:10:00',1.68),('15087','2013-05-15','08:15:00',1.84),('15087','2013-05-15','08:20:00',1.91),('15087','2013-05-15','08:25:00',1.95),('15087','2013-05-15','08:30:00',2.02),('15087','2013-05-15','08:35:00',2.23),('15087','2013-05-15','08:40:00',2.35),('15087','2013-05-15','08:45:00',2.42),('15087','2013-05-15','08:50:00',2.54),('15087','2013-05-15','08:55:00',2.63),('15087','2013-05-15','09:00:00',2.53),('15087','2013-05-15','09:05:00',2.74),('15087','2013-05-15','09:10:00',2.75),('15087','2013-05-15','09:15:00',2.82),('15087','2013-05-15','09:20:00',2.83),('15087','2013-05-15','09:25:00',2.95),('15087','2013-05-15','09:30:00',3.1),('15087','2013-05-15','09:35:00',3.17),('15087','2013-05-15','09:40:00',3.19),('15087','2013-05-15','09:45:00',3.29),('15087','2013-05-15','09:50:00',3.36),('15087','2013-05-15','09:55:00',3.4),('15087','2013-05-15','10:00:00',3.49),('15087','2013-05-15','10:05:00',3.56),('15087','2013-05-15','10:10:00',3.62),('15087','2013-05-15','10:15:00',3.57),('15087','2013-05-15','10:20:00',3.67),('15087','2013-05-15','10:25:00',3.79),('15087','2013-05-15','10:30:00',3.74),('15087','2013-05-15','10:35:00',3.87),('15087','2013-05-15','10:40:00',3.97),('15087','2013-05-15','10:45:00',4.02),('15087','2013-05-15','10:50:00',4.05),('15087','2013-05-15','10:55:00',3.93),('15087','2013-05-15','11:00:00',3.94),('15087','2013-05-15','11:05:00',4.17),('15087','2013-05-15','11:10:00',4.2),('15087','2013-05-15','11:15:00',4.26),('15087','2013-05-15','11:20:00',4.05),('15087','2013-05-15','11:25:00',4.27),('15087','2013-05-15','11:30:00',4.16),('15087','2013-05-15','11:35:00',4.15),('15087','2013-05-15','11:40:00',3.4),('15087','2013-05-15','11:45:00',3.15),('15087','2013-05-15','11:50:00',2.84),('15087','2013-05-15','11:55:00',1.96),('15087','2013-05-15','12:00:00',2.28),('15087','2013-05-15','12:05:00',3.58),('15087','2013-05-15','12:10:00',5.13),('15087','2013-05-15','12:15:00',4.73),('15087','2013-05-15','12:20:00',3.37),('15087','2013-05-15','12:25:00',4.11),('15087','2013-05-15','12:30:00',3.03),('15087','2013-05-15','12:35:00',3.77),('15087','2013-05-15','12:40:00',4.98),('15087','2013-05-15','12:45:00',2.75),('15087','2013-05-15','12:50:00',2.74),('15087','2013-05-15','12:55:00',3.05),('15087','2013-05-15','13:00:00',2.98),('15087','2013-05-15','13:05:00',3.88),('15087','2013-05-15','13:10:00',3.01),('15087','2013-05-15','13:15:00',2.76),('15087','2013-05-15','13:20:00',2.98),('15087','2013-05-15','13:25:00',3.02),('15087','2013-05-15','13:30:00',2.99),('15087','2013-05-15','13:35:00',2.64),('15087','2013-05-15','13:40:00',2.95),('15087','2013-05-15','13:45:00',2.73),('15087','2013-05-15','13:50:00',2.34),('15087','2013-05-15','13:55:00',2.31),('15087','2013-05-15','14:00:00',1.96),('15087','2013-05-15','14:05:00',1.7),('15087','2013-05-15','14:10:00',1.79),('15087','2013-05-15','14:15:00',1.76),('15087','2013-05-15','14:20:00',1.89),('15087','2013-05-15','14:25:00',1.74),('15087','2013-05-15','14:30:00',1.52),('15087','2013-05-15','14:35:00',1.51),('15087','2013-05-15','14:40:00',1.68),('15087','2013-05-15','14:45:00',1.52),('15087','2013-05-15','14:50:00',1.51),('15087','2013-05-15','14:55:00',1.53),('15087','2013-05-15','15:00:00',1.5),('15087','2013-05-15','15:05:00',1.15),('15087','2013-05-15','15:45:00',1.14),('15087','2013-05-15','15:50:00',1.59),('15087','2013-05-15','15:55:00',2.18),('15087','2013-05-15','16:00:00',2.07),('15087','2013-05-15','16:05:00',1.92),('15087','2013-05-15','16:10:00',1.68),('15087','2013-05-15','16:15:00',1.48),('15087','2013-05-15','16:20:00',1.61),('15087','2013-05-15','16:25:00',1.63),('15087','2013-05-15','16:30:00',1.42),('15087','2013-05-15','16:35:00',1.32),('15087','2013-05-15','16:40:00',1.25),('15087','2013-05-15','16:45:00',1.2),('15087','2013-05-15','16:50:00',1.24),('15087','2013-05-15','16:55:00',1.43),('15087','2013-05-15','17:00:00',1.78),('15087','2013-05-15','17:05:00',2.09),('15087','2013-05-15','17:10:00',2.54),('15087','2013-05-15','17:15:00',2.71),('15087','2013-05-15','17:20:00',1.71),('15087','2013-05-15','17:30:00',1.02),('15087','2013-05-14','07:30:00',1.05),('15087','2013-05-14','07:35:00',1.15),('15087','2013-05-14','07:40:00',1.25),('15087','2013-05-14','07:45:00',1.35),('15087','2013-05-14','07:50:00',1.46),('15087','2013-05-14','07:55:00',1.54),('15087','2013-05-14','08:00:00',1.66),('15087','2013-05-14','08:05:00',1.79),('15087','2013-05-14','08:10:00',1.9),('15087','2013-05-14','08:15:00',2.01),('15087','2013-05-14','08:20:00',2.13),('15087','2013-05-14','08:25:00',2.23),('15087','2013-05-14','08:30:00',2.33),('15087','2013-05-14','08:35:00',2.43),('15087','2013-05-14','08:40:00',2.51),('15087','2013-05-14','08:45:00',2.6),('15087','2013-05-14','08:50:00',2.67),('15087','2013-05-14','08:55:00',2.77),('15087','2013-05-14','09:00:00',2.85),('15087','2013-05-14','09:05:00',2.94),('15087','2013-05-14','09:10:00',3.03),('15087','2013-05-14','09:15:00',3.1),('15087','2013-05-14','09:20:00',3.18),('15087','2013-05-14','09:25:00',3.25),('15087','2013-05-14','09:30:00',3.32),('15087','2013-05-14','09:35:00',3.39),('15087','2013-05-14','09:40:00',3.45),('15087','2013-05-14','09:45:00',3.52),('15087','2013-05-14','09:50:00',3.57),('15087','2013-05-14','09:55:00',3.62),('15087','2013-05-14','10:00:00',3.73),('15087','2013-05-14','10:05:00',3.81),('15087','2013-05-14','10:10:00',3.87),('15087','2013-05-14','10:15:00',3.93),('15087','2013-05-14','10:20:00',3.99),('15087','2013-05-14','10:25:00',3.99),('15087','2013-05-14','10:30:00',4.02),('15087','2013-05-14','10:35:00',4.12),('15087','2013-05-14','10:40:00',4.12),('15087','2013-05-14','10:45:00',4.22),('15087','2013-05-14','10:50:00',4.26),('15087','2013-05-14','10:55:00',4.26),('15087','2013-05-14','11:00:00',4.27),('15087','2013-05-14','11:05:00',4.37),('15087','2013-05-14','11:10:00',4.4),('15087','2013-05-14','11:15:00',4.41),('15087','2013-05-14','11:20:00',4.44),('15087','2013-05-14','11:25:00',4.47),('15087','2013-05-14','11:30:00',4.46),('15087','2013-05-14','11:35:00',4.47),('15087','2013-05-14','11:40:00',4.5),('15087','2013-05-14','11:45:00',4.53),('15087','2013-05-14','11:50:00',4.59),('15087','2013-05-14','11:55:00',4.63),('15087','2013-05-14','12:00:00',4.63),('15087','2013-05-14','12:05:00',4.65),('15087','2013-05-14','12:10:00',4.67),('15087','2013-05-14','12:15:00',4.72),('15087','2013-05-14','12:20:00',4.74),('15087','2013-05-14','12:25:00',4.77),('15087','2013-05-14','12:30:00',4.76),('15087','2013-05-14','12:35:00',4.78),('15087','2013-05-14','12:40:00',4.79),('15087','2013-05-14','12:45:00',4.78),('15087','2013-05-14','12:50:00',4.77),('15087','2013-05-14','12:55:00',4.81),('15087','2013-05-14','13:00:00',4.79),('15087','2013-05-14','13:05:00',1.91),('15087','2013-05-14','13:15:00',4.41),('15087','2013-05-14','13:20:00',4.71),('15087','2013-05-14','13:25:00',4.71),('15087','2013-05-14','13:30:00',3.69),('15087','2013-05-14','13:35:00',3.78),('15087','2013-05-14','13:40:00',4.69),('15087','2013-05-14','13:45:00',4.68),('15087','2013-05-14','13:50:00',4.63),('15087','2013-05-14','13:55:00',2.87),('15087','2013-05-14','14:00:00',4.62),('15087','2013-05-14','14:05:00',4.57),('15087','2013-05-14','14:10:00',4.54),('15087','2013-05-14','14:15:00',2.72),('15087','2013-05-14','14:20:00',4.38),('15087','2013-05-14','14:25:00',4.39),('15087','2013-05-14','14:30:00',4.39),('15087','2013-05-14','14:35:00',2.88),('15087','2013-05-14','14:40:00',4.21),('15087','2013-05-14','14:45:00',4.33),('15087','2013-05-14','14:50:00',4.33),('15087','2013-05-14','14:55:00',4.29),('15087','2013-05-14','15:00:00',4.21),('15087','2013-05-14','15:05:00',4.06),('15087','2013-05-14','15:10:00',4.13),('15087','2013-05-14','15:15:00',4.09),('15087','2013-05-14','15:20:00',4.04),('15087','2013-05-14','15:25:00',3.97),('15087','2013-05-14','15:30:00',3.73),('15087','2013-05-14','15:35:00',3.73),('15087','2013-05-14','15:40:00',3.78),('15087','2013-05-14','15:45:00',3.7),('15087','2013-05-14','15:50:00',3.6),('15087','2013-05-14','15:55:00',3.56),('15087','2013-05-14','16:00:00',3.49),('15087','2013-05-14','16:05:00',3.4),('15087','2013-05-14','16:10:00',3.12),('15087','2013-05-14','16:15:00',2.95),('15087','2013-05-14','16:20:00',3.07),('15087','2013-05-14','16:25:00',3.11),('15087','2013-05-14','16:30:00',2.94),('15087','2013-05-14','16:35:00',3.01),('15087','2013-05-14','16:40:00',2.9),('15087','2013-05-14','16:45:00',2.85),('15087','2013-05-14','16:50:00',2.8),('15087','2013-05-14','16:55:00',2.71),('15087','2013-05-14','17:00:00',2.66),('15087','2013-05-14','17:05:00',2.57),('15087','2013-05-14','17:10:00',2.45),('15087','2013-05-14','17:15:00',2.37),('15087','2013-05-14','17:20:00',2.32),('15087','2013-05-14','17:25:00',2.28),('15087','2013-05-14','17:30:00',2.13),('15087','2013-05-14','17:35:00',1.92),('15087','2013-05-14','17:40:00',1.9),('15087','2013-05-14','17:45:00',1.56),('15087','2013-05-14','17:50:00',1.67),('15087','2013-05-14','17:55:00',1.58),('15087','2013-05-14','18:00:00',1.37),('15087','2013-05-14','18:05:00',1.4),('15087','2013-05-14','18:10:00',1.22),('15087','2013-05-14','18:15:00',1.23),('15087','2013-05-14','18:20:00',1.11),('15087','2013-05-13','07:35:00',1.05),('15087','2013-05-13','07:40:00',1.14),('15087','2013-05-13','07:45:00',1.23),('15087','2013-05-13','07:50:00',1.28),('15087','2013-05-13','07:55:00',1.3),('15087','2013-05-13','08:00:00',1.35),('15087','2013-05-13','08:05:00',1.59),('15087','2013-05-13','08:10:00',1.7),('15087','2013-05-13','08:15:00',1.85),('15087','2013-05-13','08:20:00',1.95),('15087','2013-05-13','08:25:00',2),('15087','2013-05-13','08:30:00',2.11),('15087','2013-05-13','08:35:00',2.2),('15087','2013-05-13','08:40:00',2.3),('15087','2013-05-13','08:45:00',2.42),('15087','2013-05-13','08:50:00',2.48),('15087','2013-05-13','08:55:00',2.57),('15087','2013-05-13','09:00:00',2.67),('15087','2013-05-13','09:05:00',2.72),('15087','2013-05-13','09:10:00',2.83),('15087','2013-05-13','09:15:00',2.88),('15087','2013-05-13','09:20:00',2.99),('15087','2013-05-13','09:25:00',3.07),('15087','2013-05-13','09:30:00',3.13),('15087','2013-05-13','09:35:00',3.21),('15087','2013-05-13','09:40:00',3.29),('15087','2013-05-13','09:45:00',3.46),('15087','2013-05-13','09:50:00',3.21),('15087','2013-05-13','09:55:00',3.68),('15087','2013-05-13','10:00:00',3.05),('15087','2013-05-13','10:05:00',3.86),('15087','2013-05-13','10:10:00',3.8),('15087','2013-05-13','10:15:00',3.88),('15087','2013-05-13','10:20:00',4.04),('15087','2013-05-13','10:25:00',4.17),('15087','2013-05-13','10:30:00',4.21),('15087','2013-05-13','10:35:00',1.48),('15087','2013-05-13','10:40:00',1.46),('15087','2013-05-13','10:50:00',3.47),('15087','2013-05-13','10:55:00',2.21),('15087','2013-05-13','11:00:00',4.81),('15087','2013-05-13','11:05:00',2.93),('15087','2013-05-13','11:10:00',3.29),('15087','2013-05-13','11:15:00',2.03),('15087','2013-05-13','11:20:00',1.63),('15087','2013-05-13','11:25:00',1.74),('15087','2013-05-13','11:30:00',1.73),('15087','2013-05-13','11:35:00',2.58),('15087','2013-05-13','11:40:00',4.73),('15087','2013-05-13','11:45:00',2.6),('15087','2013-05-13','11:50:00',3.21),('15087','2013-05-13','11:55:00',1.9),('15087','2013-05-13','12:00:00',2.1),('15087','2013-05-13','12:05:00',2.03),('15087','2013-05-13','12:10:00',4.51),('15087','2013-05-13','12:15:00',2.26),('15087','2013-05-13','12:20:00',1.25),('15087','2013-05-13','12:25:00',1.12),('15087','2013-05-13','12:30:00',1.37),('15087','2013-05-13','12:35:00',5.51),('15087','2013-05-13','12:40:00',5.26),('15087','2013-05-13','12:45:00',5.11),('15087','2013-05-13','12:50:00',4.66),('15087','2013-05-13','12:55:00',3.98),('15087','2013-05-13','13:00:00',3.79),('15087','2013-05-13','13:05:00',5.48),('15087','2013-05-13','13:10:00',4.76),('15087','2013-05-13','13:15:00',3.75),('15087','2013-05-13','13:20:00',4.94),('15087','2013-05-13','13:25:00',5.01),('15087','2013-05-13','13:30:00',4.51),('15087','2013-05-13','13:35:00',4.7),('15087','2013-05-13','13:40:00',4.92),('15087','2013-05-13','13:45:00',4.43),('15087','2013-05-13','13:50:00',1.95),('15087','2013-05-13','13:55:00',3.87),('15087','2013-05-13','14:00:00',4.46),('15087','2013-05-13','14:05:00',5.02),('15087','2013-05-13','14:15:00',1.39),('15087','2013-05-13','14:20:00',4.7),('15087','2013-05-13','14:25:00',4.76),('15087','2013-05-13','14:30:00',3.91),('15087','2013-05-13','14:35:00',2.41),('15087','2013-05-13','14:40:00',2.17),('15087','2013-05-13','14:45:00',2.95),('15087','2013-05-13','14:50:00',4.87),('15087','2013-05-13','14:55:00',3.76),('15087','2013-05-13','15:00:00',3.41),('15087','2013-05-13','15:05:00',1.59),('15087','2013-05-13','15:10:00',1.26),('15087','2013-05-13','15:20:00',1.09),('15087','2013-05-13','16:00:00',1.92),('15087','2013-05-13','16:05:00',2.32),('15087','2013-05-13','16:10:00',2.05),('15087','2013-05-13','16:15:00',1.29),('15087','2013-05-13','16:20:00',1.35),('15087','2013-05-13','16:25:00',1.43),('15087','2013-05-13','16:30:00',2.04),('15087','2013-05-13','16:35:00',1.22),('15087','2013-05-13','16:40:00',1.56),('15087','2013-05-13','16:45:00',2.5),('15087','2013-05-13','16:50:00',3.21),('15087','2013-05-13','16:55:00',3),('15087','2013-05-13','17:00:00',2.94),('15087','2013-05-13','17:05:00',2.89),('15087','2013-05-13','17:10:00',1.17),('15087','2013-05-13','17:15:00',2.62),('15087','2013-05-13','17:20:00',3.26),('15087','2013-05-13','17:25:00',3.12),('15087','2013-05-13','17:30:00',2.95),('15087','2013-05-13','17:35:00',2.69),('15087','2013-05-13','17:40:00',2.4),('15087','2013-05-13','17:45:00',2.23),('15087','2013-05-13','17:50:00',2.03),('15087','2013-05-13','17:55:00',1.21),('15087','2013-05-13','18:00:00',1.76),('15087','2013-05-13','18:05:00',1.62),('15087','2013-05-13','18:10:00',1.06),('15087','2013-05-13','18:15:00',1.32),('15087','2013-05-13','18:20:00',1.01),('15087','2013-05-12','08:10:00',1.47),('15087','2013-05-12','08:15:00',1.45),('15087','2013-05-12','08:20:00',1.34),('15087','2013-05-12','08:25:00',2.02),('15087','2013-05-12','08:30:00',1.12),('15087','2013-05-12','08:40:00',1.03),('15087','2013-05-12','08:45:00',2.56),('15087','2013-05-12','08:50:00',1.35),('15087','2013-05-12','08:55:00',1.15),('15087','2013-05-12','09:00:00',2.07),('15087','2013-05-12','09:05:00',2.96),('15087','2013-05-12','09:10:00',1.73),('15087','2013-05-12','09:15:00',2.31),('15087','2013-05-12','09:20:00',2.2),('15087','2013-05-12','09:25:00',1.91),('15087','2013-05-12','09:30:00',1.23),('15087','2013-05-12','09:35:00',1.18),('15087','2013-05-12','09:40:00',1.17),('15087','2013-05-12','09:45:00',2.33),('15087','2013-05-12','09:50:00',4.14),('15087','2013-05-12','09:55:00',4.09),('15087','2013-05-12','10:00:00',3.74),('15087','2013-05-12','10:05:00',1.57),('15087','2013-05-12','10:10:00',4.02),('15087','2013-05-12','10:15:00',2.7),('15087','2013-05-12','10:20:00',1.81),('15087','2013-05-12','10:25:00',4.31),('15087','2013-05-12','10:30:00',1.97),('15087','2013-05-12','10:35:00',1.37),('15087','2013-05-12','10:40:00',1.03),('15087','2013-05-12','10:45:00',1.42),('15087','2013-05-12','10:50:00',2.16),('15087','2013-05-12','10:55:00',4.01),('15087','2013-05-12','11:00:00',3.43),('15087','2013-05-12','11:05:00',3.2),('15087','2013-05-12','11:10:00',4.87),('15087','2013-05-12','11:15:00',4.77),('15087','2013-05-12','11:20:00',4.84),('15087','2013-05-12','11:25:00',3.89),('15087','2013-05-12','11:30:00',2.97),('15087','2013-05-12','11:35:00',4.93),('15087','2013-05-12','11:40:00',3.66),('15087','2013-05-12','11:45:00',2.65),('15087','2013-05-12','11:50:00',1.88),('15087','2013-05-12','11:55:00',1.49),('15087','2013-05-12','12:00:00',2.87),('15087','2013-05-12','12:05:00',3.3),('15087','2013-05-12','12:10:00',1.71),('15087','2013-05-12','12:15:00',1.26),('15087','2013-05-12','12:20:00',1.16),('15087','2013-05-12','12:25:00',1.19),('15087','2013-05-12','12:30:00',2.4),('15087','2013-05-12','12:35:00',4.57),('15087','2013-05-12','12:40:00',3.09),('15087','2013-05-12','12:45:00',3.62),('15087','2013-05-12','12:50:00',4.48),('15087','2013-05-12','12:55:00',4.09),('15087','2013-05-12','13:00:00',1.45),('15087','2013-05-12','13:05:00',3.07),('15087','2013-05-12','13:10:00',4.42),('15087','2013-05-12','13:15:00',1.75),('15087','2013-05-12','13:20:00',3.64),('15087','2013-05-12','13:25:00',3.98),('15087','2013-05-12','13:30:00',5.17),('15087','2013-05-12','13:35:00',4.29),('15087','2013-05-12','13:40:00',4),('15087','2013-05-12','13:45:00',4.27),('15087','2013-05-12','13:50:00',5.55),('15087','2013-05-12','13:55:00',2.13),('15087','2013-05-12','14:00:00',4.25),('15087','2013-05-12','14:05:00',4.76),('15087','2013-05-12','14:10:00',5.2),('15087','2013-05-12','14:15:00',4.53),('15087','2013-05-12','14:20:00',4.98),('15087','2013-05-12','14:25:00',4.24),('15087','2013-05-12','14:30:00',4.77),('15087','2013-05-12','14:35:00',4.78),('15087','2013-05-12','14:40:00',4.44),('15087','2013-05-12','14:45:00',3.98),('15087','2013-05-12','14:50:00',4.51),('15087','2013-05-12','14:55:00',3.67),('15087','2013-05-12','15:00:00',4.46),('15087','2013-05-12','15:05:00',4.08),('15087','2013-05-12','15:10:00',2.54),('15087','2013-05-12','15:15:00',3.75),('15087','2013-05-12','15:20:00',2.18),('15087','2013-05-12','15:25:00',3.97),('15087','2013-05-12','15:30:00',3.76),('15087','2013-05-12','15:35:00',3.86),('15087','2013-05-12','15:40:00',3.81),('15087','2013-05-12','15:45:00',3.7),('15087','2013-05-12','15:50:00',3.59),('15087','2013-05-12','15:55:00',3.48),('15087','2013-05-12','16:00:00',3.26),('15087','2013-05-12','16:05:00',3.34),('15087','2013-05-12','16:10:00',3.13),('15087','2013-05-12','16:15:00',3.04),('15087','2013-05-12','16:20:00',3.18),('15087','2013-05-12','16:25:00',3.02),('15087','2013-05-12','16:30:00',2.96),('15087','2013-05-12','16:35:00',3.02),('15087','2013-05-12','16:40:00',2.98),('15087','2013-05-12','16:45:00',2.92),('15087','2013-05-12','16:50:00',2.78),('15087','2013-05-12','16:55:00',3.49),('15087','2013-05-12','17:00:00',3.4),('15087','2013-05-12','17:05:00',2.82),('15087','2013-05-12','17:10:00',3.28),('15087','2013-05-12','17:15:00',2.75),('15087','2013-05-12','17:20:00',2.96),('15087','2013-05-12','17:25:00',2.35),('15087','2013-05-12','17:30:00',1.96),('15087','2013-05-12','17:35:00',2.59),('15087','2013-05-12','17:40:00',1.7),('15087','2013-05-12','17:45:00',1.61),('15087','2013-05-12','17:50:00',1.33),('15087','2013-05-12','18:00:00',1.85),('15087','2013-05-12','18:05:00',1.85),('15087','2013-05-12','18:10:00',1.8),('15087','2013-05-12','18:15:00',1.55),('15087','2013-05-12','18:20:00',1.13),('15087','2013-05-12','18:25:00',1.35),('15087','2013-05-12','18:30:00',1.2),('15087','2013-05-12','18:35:00',1.24),('15087','2013-05-12','18:40:00',1.01),('15087','2014-03-31','08:20:00',1.09),('15087','2014-03-31','08:25:00',1.18),('15087','2014-03-31','08:30:00',1.3),('15087','2014-03-31','08:35:00',1.39),('15087','2014-03-31','08:40:00',1.48),('15087','2014-03-31','08:45:00',1.6),('15087','2014-03-31','08:50:00',1.69),('15087','2014-03-31','08:55:00',1.77),('15087','2014-03-31','09:00:00',1.9),('15087','2014-03-31','09:05:00',2.02),('15087','2014-03-31','09:10:00',2.12),('15087','2014-03-31','09:15:00',2.21),('15087','2014-03-31','09:20:00',2.29),('15087','2014-03-31','09:25:00',2.4),('15087','2014-03-31','09:30:00',2.49),('15087','2014-03-31','09:35:00',2.57),('15087','2014-03-31','09:40:00',2.65),('15087','2014-03-31','09:45:00',2.73),('15087','2014-03-31','09:50:00',2.81),('15087','2014-03-31','09:55:00',2.9),('15087','2014-03-31','10:00:00',2.95),('15087','2014-03-31','10:05:00',3),('15087','2014-03-31','10:10:00',3.06),('15087','2014-03-31','10:15:00',3.13),('15087','2014-03-31','10:20:00',3.23),('15087','2014-03-31','10:25:00',3.32),('15087','2014-03-31','10:30:00',3.35),('15087','2014-03-31','10:35:00',3.39),('15087','2014-03-31','10:40:00',3.47),('15087','2014-03-31','10:45:00',3.56),('15087','2014-03-31','10:50:00',3.62),('15087','2014-03-31','10:55:00',3.64),('15087','2014-03-31','11:00:00',3.68),('15087','2014-03-31','11:05:00',3.73),('15087','2014-03-31','11:10:00',3.78),('15087','2014-03-31','11:15:00',3.82),('15087','2014-03-31','11:20:00',3.88),('15087','2014-03-31','11:25:00',3.96),('15087','2014-03-31','11:30:00',3.98),('15087','2014-03-31','11:35:00',3.98),('15087','2014-03-31','11:40:00',4.02),('15087','2014-03-31','11:45:00',4.08),('15087','2014-03-31','11:50:00',4.12),('15087','2014-03-31','11:55:00',4.16),('15087','2014-03-31','12:00:00',4.14),('15087','2014-03-31','12:05:00',4.14),('15087','2014-03-31','12:10:00',4.19),('15087','2014-03-31','12:15:00',4.26),('15087','2014-03-31','12:20:00',4.25),('15087','2014-03-31','12:25:00',4.27),('15087','2014-03-31','12:30:00',4.31),('15087','2014-03-31','12:35:00',4.35),('15087','2014-03-31','12:40:00',4.36),('15087','2014-03-31','12:45:00',4.3),('15087','2014-03-31','12:50:00',4.29),('15087','2014-03-31','12:55:00',4.29),('15087','2014-03-31','13:00:00',4.34),('15087','2014-03-31','13:05:00',4.38),('15087','2014-03-31','13:10:00',4.39),('15087','2014-03-31','13:15:00',4.4),('15087','2014-03-31','13:20:00',4.35),('15087','2014-03-31','13:25:00',4.38),('15087','2014-03-31','13:30:00',4.4),('15087','2014-03-31','13:35:00',4.39),('15087','2014-03-31','13:40:00',4.41),('15087','2014-03-31','13:45:00',4.39),('15087','2014-03-31','13:50:00',4.35),('15087','2014-03-31','13:55:00',4.2),('15087','2014-03-31','14:00:00',4.13),('15087','2014-03-31','14:05:00',4.12),('15087','2014-03-31','14:10:00',4.25),('15087','2014-03-31','14:15:00',4.08),('15087','2014-03-31','14:20:00',4.07),('15087','2014-03-31','14:25:00',4.11),('15087','2014-03-31','14:30:00',4.04),('15087','2014-03-31','14:35:00',3.92),('15087','2014-03-31','14:40:00',3.98),('15087','2014-03-31','14:45:00',3.94),('15087','2014-03-31','14:50:00',3.88),('15087','2014-03-31','14:55:00',3.69),('15087','2014-03-31','15:00:00',3.67),('15087','2014-03-31','15:05:00',3.57),('15087','2014-03-31','15:10:00',3.6),('15087','2014-03-31','15:15:00',3.42),('15087','2014-03-31','15:20:00',3.4),('15087','2014-03-31','15:25:00',3.42),('15087','2014-03-31','15:30:00',3.16),('15087','2014-03-31','15:35:00',2.99),('15087','2014-03-31','15:40:00',3.21),('15087','2014-03-31','15:45:00',3.11),('15087','2014-03-31','15:50:00',3.1),('15087','2014-03-31','15:55:00',2.99),('15087','2014-03-31','16:00:00',2.77),('15087','2014-03-31','16:05:00',2.7),('15087','2014-03-31','16:10:00',2.74),('15087','2014-03-31','16:15:00',2.68),('15087','2014-03-31','16:20:00',2.65),('15087','2014-03-31','16:25:00',2.6),('15087','2014-03-31','16:30:00',2.45),('15087','2014-03-31','16:35:00',2.36),('15087','2014-03-31','16:40:00',2.3),('15087','2014-03-31','16:45:00',2.22),('15087','2014-03-31','16:50:00',2.14),('15087','2014-03-31','16:55:00',1.99),('15087','2014-03-31','17:00:00',1.97),('15087','2014-03-31','17:05:00',1.86),('15087','2014-03-31','17:10:00',1.73),('15087','2014-03-31','17:15:00',1.63),('15087','2014-03-31','17:20:00',1.48),('15087','2014-03-31','17:25:00',1.41),('15087','2014-03-31','17:30:00',1.32),('15087','2014-03-31','17:35:00',1.25),('15087','2014-03-31','17:40:00',1.18),('15087','2014-03-31','17:45:00',1.09),('15087','2013-05-11','07:45:00',1.22),('15087','2013-05-11','07:50:00',1.39),('15087','2013-05-11','07:55:00',1.57),('15087','2013-05-11','08:00:00',1.46),('15087','2013-05-11','08:05:00',1.27),('15087','2013-05-11','08:15:00',1.64),('15087','2013-05-11','08:20:00',1.48),('15087','2013-05-11','09:05:00',1.43),('15087','2013-05-11','09:10:00',1.5),('15087','2013-05-11','09:15:00',1.52),('15087','2013-05-11','09:20:00',1.79),('15087','2013-05-11','09:25:00',2.2),('15087','2013-05-11','09:30:00',2.53),('15087','2013-05-11','09:35:00',2.27),('15087','2013-05-11','09:40:00',1.49),('15087','2013-05-11','09:45:00',1.51),('15087','2013-05-11','09:51:00',2.71),('15087','2013-05-11','09:55:00',3.02),('15087','2013-05-11','10:00:00',2.44),('15087','2013-05-11','10:05:00',1.19),('15087','2013-05-11','10:20:00',1.19),('15087','2013-05-11','10:25:00',1.01),('15087','2013-05-11','10:30:00',1.43),('15087','2013-05-11','10:35:00',1.21),('15087','2013-05-11','10:45:00',1.04),('15087','2013-05-11','10:50:00',1.34),('15087','2013-05-11','10:55:00',4.35),('15087','2013-05-11','11:00:00',4.86),('15087','2013-05-11','11:05:00',2.13),('15087','2013-05-11','11:10:00',1.22),('15087','2013-05-11','11:25:00',1.13),('15087','2013-05-11','11:30:00',3.44),('15087','2013-05-11','11:35:00',2.61),('15087','2013-05-11','11:40:00',3.37),('15087','2013-05-11','11:45:00',5.13),('15087','2013-05-11','11:50:00',1.6),('15087','2013-05-11','11:55:00',1.09),('15087','2013-05-11','12:00:00',1.82),('15087','2013-05-11','12:05:00',2.38),('15087','2013-05-11','12:10:00',1.43),('15087','2013-05-11','12:15:00',1.39),('15087','2013-05-11','12:20:00',3.39),('15087','2013-05-11','12:25:00',5.41),('15087','2013-05-11','12:30:00',2.04),('15087','2013-05-11','12:35:00',2.07),('15087','2013-05-11','12:40:00',1.93),('15087','2013-05-11','12:45:00',1.75),('15087','2013-05-11','12:50:00',1.68),('15087','2013-05-11','12:55:00',1.59),('15087','2013-05-11','13:00:00',1.85),('15087','2013-05-11','13:05:00',1.47),('15087','2013-05-11','13:10:00',1.01),('15087','2013-05-11','13:25:00',1.01),('15087','2013-05-11','13:30:00',1.12),('15087','2013-05-11','13:35:00',1.17),('15087','2013-05-11','13:50:00',1.02),('15087','2013-05-11','13:55:00',1.16),('15087','2013-05-11','14:00:00',2.23),('15087','2013-05-11','14:05:00',4.05),('15087','2013-05-11','14:10:00',2.61),('15087','2013-05-11','14:15:00',3.4),('15087','2013-05-11','14:20:00',4.77),('15087','2013-05-11','14:25:00',3.85),('15087','2013-05-11','14:30:00',1.93),('15087','2013-05-11','14:35:00',3.39),('15087','2013-05-11','14:40:00',3.7),('15087','2013-05-11','14:45:00',4.56),('15087','2013-05-11','14:50:00',4.74),('15087','2013-05-11','14:55:00',4.43),('15087','2013-05-11','15:00:00',4.27),('15087','2013-05-11','15:05:00',4.28),('15087','2013-05-11','15:10:00',4.17),('15087','2013-05-11','15:15:00',4.17),('15087','2013-05-11','15:20:00',4.02),('15087','2013-05-11','15:25:00',4.05),('15087','2013-05-11','15:30:00',3.69),('15087','2013-05-11','15:35:00',3.62),('15087','2013-05-11','15:40:00',3.97),('15087','2013-05-11','15:45:00',2.9),('15087','2013-05-11','15:50:00',3.21),('15087','2013-05-11','15:55:00',3.61),('15087','2013-05-11','16:00:00',3.13),('15087','2013-05-11','16:05:00',3.56),('15087','2013-05-11','16:10:00',2.94),('15087','2013-05-11','16:15:00',3.38),('15087','2013-05-11','16:20:00',3.4),('15087','2013-05-11','16:25:00',3.24),('15087','2013-05-11','16:30:00',2.76),('15087','2013-05-11','16:35:00',2.02),('15087','2013-05-11','16:40:00',2.83),('15087','2013-05-11','16:45:00',2.93),('15087','2013-05-11','16:50:00',2.85),('15087','2013-05-11','16:55:00',2.85),('15087','2013-05-11','17:00:00',2.76),('15087','2013-05-11','17:05:00',1.74),('15087','2013-05-11','17:10:00',2.31),('15087','2013-05-11','17:15:00',1.44),('15087','2013-05-11','17:20:00',2.12),('15087','2013-05-11','17:25:00',1.65),('15087','2013-05-11','17:30:00',2.1),('15087','2013-05-11','17:35:00',1.73),('15087','2013-05-11','17:40:00',1.88),('15087','2013-05-11','17:45:00',1.87),('15087','2013-05-11','17:55:00',1.25),('15087','2013-05-11','18:05:00',1.55),('15087','2013-05-11','18:10:00',1.69),('15087','2013-05-11','18:15:00',1.03),('15087','2013-05-11','18:20:00',1.02),('15087','2013-05-11','18:25:00',1.02),('15087','2013-05-11','18:30:00',1.06),('15087','2013-05-10','07:40:00',1.16),('15087','2013-05-10','07:45:00',1.01),('15087','2013-05-10','07:55:00',1.3),('15087','2013-05-10','08:00:00',1.64),('15087','2013-05-10','08:05:00',2.21),('15087','2013-05-10','08:10:00',2.28),('15087','2013-05-10','08:15:00',2.35),('15087','2013-05-10','08:20:00',2.17),('15087','2013-05-10','08:25:00',2.12),('15087','2013-05-10','08:30:00',2.12),('15087','2013-05-10','08:35:00',2.12),('15087','2013-05-10','09:00:00',1.69),('15087','2013-05-10','09:05:00',2.55),('15087','2013-05-10','09:10:00',2.86),('15087','2013-05-10','09:15:00',2.99),('15087','2013-05-10','09:20:00',2.86),('15087','2013-05-10','09:25:00',2.74),('15087','2013-05-10','09:30:00',2.78),('15087','2013-05-10','09:35:00',3.31),('15087','2013-05-10','09:40:00',3.07),('15087','2013-05-10','09:45:00',2.62),('15087','2013-05-10','09:50:00',3.45),('15087','2013-05-10','09:55:00',1.45),('15087','2013-05-10','10:00:00',1.55),('15087','2013-05-10','10:05:00',1.39),('15087','2013-05-10','10:10:00',1.14),('15087','2013-05-10','10:15:00',1.47),('15087','2013-05-10','10:20:00',3.1),('15087','2013-05-10','10:25:00',2.32),('15087','2013-05-10','10:30:00',3.87),('15087','2013-05-10','10:35:00',4.29),('15087','2013-05-10','10:40:00',4.27),('15087','2013-05-10','10:45:00',4.4),('15087','2013-05-10','10:50:00',3.41),('15087','2013-05-10','10:55:00',4.36),('15087','2013-05-10','11:00:00',4.37),('15087','2013-05-10','11:05:00',4.33),('15087','2013-05-10','11:10:00',4.02),('15087','2013-05-10','11:15:00',4.51),('15087','2013-05-10','11:20:00',4.83),('15087','2013-05-10','11:25:00',3.83),('15087','2013-05-10','11:30:00',4.03),('15087','2013-05-10','11:35:00',2.33),('15087','2013-05-10','11:40:00',4.17),('15087','2013-05-10','11:45:00',3.3),('15087','2013-05-10','11:50:00',4.01),('15087','2013-05-10','11:55:00',4.28),('15087','2013-05-10','12:00:00',2.3),('15087','2013-05-10','12:05:00',2.09),('15087','2013-05-10','12:10:00',2.23),('15087','2013-05-10','12:15:00',3.03),('15087','2013-05-10','12:20:00',3.24),('15087','2013-05-10','12:25:00',2.45),('15087','2013-05-10','12:30:00',2.45),('15087','2013-05-10','12:35:00',2.21),('15087','2013-05-10','12:40:00',3.69),('15087','2013-05-10','12:45:00',4.88),('15087','2013-05-10','12:50:00',3.4),('15087','2013-05-10','12:55:00',3.15),('15087','2013-05-10','13:00:00',3.82),('15087','2013-05-10','13:05:00',4.59),('15087','2013-05-10','13:10:00',5.45),('15087','2013-05-10','13:15:00',4.74),('15087','2013-05-10','13:20:00',3.57),('15087','2013-05-10','13:25:00',3.12),('15087','2013-05-10','13:30:00',3.95),('15087','2013-05-10','13:35:00',4.24),('15087','2013-05-10','13:40:00',4.24),('15087','2013-05-10','13:45:00',4.24),('15087','2013-05-10','13:50:00',2.46),('15087','2013-05-10','13:55:00',2.31),('15087','2013-05-10','14:00:00',2.07),('15087','2013-05-10','14:05:00',2.29),('15087','2013-05-10','14:10:00',2.78),('15087','2013-05-10','14:15:00',3.03),('15087','2013-05-10','14:20:00',2.81),('15087','2013-05-10','14:25:00',2.9),('15087','2013-05-10','14:30:00',2.86),('15087','2013-05-10','14:35:00',3.36),('15087','2013-05-10','14:40:00',2.99),('15087','2013-05-10','14:45:00',2.02),('15087','2013-05-10','14:50:00',1.51),('15087','2013-05-10','14:55:00',1.32),('15087','2013-05-10','15:00:00',1.27),('15087','2013-05-10','15:05:00',1.46),('15087','2013-05-10','15:10:00',2.17),('15087','2013-05-10','15:15:00',3.63),('15087','2013-05-10','15:20:00',2.65),('15087','2013-05-10','15:25:00',2.13),('15087','2013-05-10','15:30:00',2.08),('15087','2013-05-10','15:35:00',2.2),('15087','2013-05-10','15:40:00',2.28),('15087','2013-05-10','15:45:00',2.11),('15087','2013-05-10','15:50:00',1.84),('15087','2013-05-10','15:55:00',1.76),('15087','2013-05-10','16:00:00',1.75),('15087','2013-05-10','16:05:00',1.67),('15087','2013-05-10','16:10:00',1.61),('15087','2013-05-10','16:15:00',1.47),('15087','2013-05-10','16:20:00',1.35),('15087','2013-05-10','16:25:00',1.39),('15087','2013-05-10','16:30:00',1.53),('15087','2013-05-10','16:35:00',1.58),('15087','2013-05-10','16:40:00',1.48),('15087','2013-05-10','16:45:00',1.5),('15087','2013-05-10','16:50:00',1.39),('15087','2013-05-10','16:55:00',1.12),('15087','2013-05-10','17:05:00',1),('15087','2013-05-10','17:10:00',1.39),('15087','2013-05-10','17:15:00',1.61),('15087','2013-05-10','17:20:00',2.53),('15087','2013-05-10','17:25:00',2.37),('15087','2013-05-10','17:30:00',2.13),('15087','2013-05-10','17:35:00',2.24),('15087','2013-05-10','17:40:00',1.41),('15087','2013-05-10','17:45:00',1.47),('15087','2013-05-10','17:50:00',1.12),('15087','2013-05-09','07:35:00',1.06),('15087','2013-05-09','07:40:00',1.14),('15087','2013-05-09','07:45:00',1.23),('15087','2013-05-09','07:50:00',1.31),('15087','2013-05-09','07:55:00',1.38),('15087','2013-05-09','08:00:00',1.49),('15087','2013-05-09','08:05:00',1.59),('15087','2013-05-09','08:10:00',1.7),('15087','2013-05-09','08:15:00',1.79),('15087','2013-05-09','08:20:00',1.89),('15087','2013-05-09','08:25:00',1.95),('15087','2013-05-09','08:30:00',2.12),('15087','2013-05-09','08:35:00',2.24),('15087','2013-05-09','08:40:00',2.34),('15087','2013-05-09','08:45:00',2.42),('15087','2013-05-09','08:50:00',2.51),('15087','2013-05-09','08:55:00',2.58),('15087','2013-05-09','09:00:00',2.67),('15087','2013-05-09','09:05:00',2.75),('15087','2013-05-09','09:10:00',2.84),('15087','2013-05-09','09:15:00',2.94),('15087','2013-05-09','09:20:00',3.03),('15087','2013-05-09','09:25:00',3.11),('15087','2013-05-09','09:30:00',3.2),('15087','2013-05-09','09:35:00',3.29),('15087','2013-05-09','09:40:00',3.36),('15087','2013-05-09','09:45:00',3.42),('15087','2013-05-09','09:50:00',3.49),('15087','2013-05-09','09:55:00',3.55),('15087','2013-05-09','10:00:00',3.62),('15087','2013-05-09','10:05:00',3.69),('15087','2013-05-09','10:10:00',3.74),('15087','2013-05-09','10:15:00',3.79),('15087','2013-05-09','10:20:00',3.86),('15087','2013-05-09','10:25:00',3.9),('15087','2013-05-09','10:30:00',3.95),('15087','2013-05-09','10:35:00',3.98),('15087','2013-05-09','10:40:00',4.02),('15087','2013-05-09','10:45:00',4.08),('15087','2013-05-09','10:50:00',4.14),('15087','2013-05-09','10:55:00',4.19),('15087','2013-05-09','11:00:00',4.22),('15087','2013-05-09','11:05:00',4.26),('15087','2013-05-09','11:10:00',4.29),('15087','2013-05-09','11:15:00',4.36),('15087','2013-05-09','11:20:00',4.37),('15087','2013-05-09','11:25:00',4.4),('15087','2013-05-09','11:30:00',4.42),('15087','2013-05-09','11:35:00',4.45),('15087','2013-05-09','11:40:00',4.47),('15087','2013-05-09','11:45:00',4.55),('15087','2013-05-09','11:50:00',4.57),('15087','2013-05-09','11:55:00',4.55),('15087','2013-05-09','12:00:00',4.59),('15087','2013-05-09','12:05:00',4.6),('15087','2013-05-09','12:10:00',4.61),('15087','2013-05-09','12:15:00',4.66),('15087','2013-05-09','12:20:00',4.71),('15087','2013-05-09','12:25:00',4.65),('15087','2013-05-09','12:30:00',4.71),('15087','2013-05-09','12:35:00',4.72),('15087','2013-05-09','12:40:00',4.72),('15087','2013-05-09','12:45:00',4.73),('15087','2013-05-09','12:50:00',4.79),('15087','2013-05-09','12:55:00',4.77),('15087','2013-05-09','13:00:00',4.72),('15087','2013-05-09','13:05:00',4.71),('15087','2013-05-09','13:10:00',4.69),('15087','2013-05-09','13:15:00',4.73),('15087','2013-05-09','13:20:00',4.73),('15087','2013-05-09','13:25:00',4.69),('15087','2013-05-09','13:30:00',4.7),('15087','2013-05-09','13:35:00',4.72),('15087','2013-05-09','13:40:00',4.73),('15087','2013-05-09','13:45:00',4.84),('15087','2013-05-09','13:50:00',4.79),('15087','2013-05-09','13:55:00',4.85),('15087','2013-05-09','14:00:00',4.52),('15087','2013-05-09','14:05:00',2.55),('15087','2013-05-09','14:10:00',4.84),('15087','2013-05-09','14:15:00',4.65),('15087','2013-05-09','14:20:00',3.7),('15087','2013-05-09','14:25:00',3.86),('15087','2013-05-09','14:30:00',4.43),('15087','2013-05-09','14:35:00',4.27),('15087','2013-05-09','14:40:00',4.17),('15087','2013-05-09','14:45:00',4.26),('15087','2013-05-09','14:50:00',4.2),('15087','2013-05-09','14:55:00',4.2),('15087','2013-05-09','15:00:00',4.13),('15087','2013-05-09','15:05:00',4.1),('15087','2013-05-09','15:10:00',4),('15087','2013-05-09','15:15:00',3.98),('15087','2013-05-09','15:20:00',3.85),('15087','2013-05-09','15:25:00',3.68),('15087','2013-05-09','15:30:00',3.74),('15087','2013-05-09','15:35:00',3.71),('15087','2013-05-09','15:40:00',3.64),('15087','2013-05-09','15:45:00',3.58),('15087','2013-05-09','15:50:00',3.52),('15087','2013-05-09','15:55:00',3.45),('15087','2013-05-09','16:00:00',3.33),('15087','2013-05-09','16:05:00',3.12),('15087','2013-05-09','16:10:00',3.06),('15087','2013-05-09','16:15:00',3.14),('15087','2013-05-09','16:20:00',3.08),('15087','2013-05-09','16:25:00',2.98),('15087','2013-05-09','16:30:00',2.97),('15087','2013-05-09','16:35:00',2.9),('15087','2013-05-09','16:40:00',2.79),('15087','2013-05-09','16:45:00',2.69),('15087','2013-05-09','16:50:00',2.58),('15087','2013-05-09','16:55:00',2.54),('15087','2013-05-09','17:00:00',2.49),('15087','2013-05-09','17:05:00',2.42),('15087','2013-05-09','17:10:00',2.33),('15087','2013-05-09','17:15:00',2.23),('15087','2013-05-09','17:20:00',2.14),('15087','2013-05-09','17:25:00',2),('15087','2013-05-09','17:30:00',1.89),('15087','2013-05-09','17:35:00',1.83),('15087','2013-05-09','17:40:00',1.72),('15087','2013-05-09','17:45:00',1.65),('15087','2013-05-09','17:50:00',1.55),('15087','2013-05-09','17:55:00',1.47),('15087','2013-05-09','18:00:00',1.41),('15087','2013-05-09','18:05:00',1.32),('15087','2013-05-09','18:10:00',1.24),('15087','2013-05-09','18:15:00',1.15),('15087','2013-05-09','18:20:00',1.07),('15087','2013-05-08','08:05:00',1.82),('15087','2013-05-08','08:10:00',1.8),('15087','2013-05-08','08:15:00',1.89),('15087','2013-05-08','08:20:00',2.02),('15087','2013-05-08','08:25:00',2.05),('15087','2013-05-08','08:30:00',2.07),('15087','2013-05-08','08:35:00',2.16),('15087','2013-05-08','08:40:00',2.34),('15087','2013-05-08','08:45:00',2.29),('15087','2013-05-08','08:50:00',1.07),('15087','2013-05-08','08:55:00',1.16),('15087','2013-05-08','09:35:00',3.14),('15087','2013-05-08','09:40:00',4.05),('15087','2013-05-08','09:45:00',3.24),('15087','2013-05-08','09:50:00',3.36),('15087','2013-05-08','09:55:00',1.7),('15087','2013-05-08','10:00:00',1.35),('15087','2013-05-08','10:05:00',4.16),('15087','2013-05-08','10:10:00',2.14),('15087','2013-05-08','10:20:00',1.07),('15087','2013-05-08','10:30:00',1),('15087','2013-05-08','10:50:00',1.08),('15087','2013-05-08','10:55:00',2.43),('15087','2013-05-08','11:00:00',3.2),('15087','2013-05-08','11:05:00',4.58),('15087','2013-05-08','11:10:00',3.14),('15087','2013-05-08','11:15:00',2.95),('15087','2013-05-08','11:20:00',3.7),('15087','2013-05-08','11:25:00',4.74),('15087','2013-05-08','11:30:00',4.88),('15087','2013-05-08','11:35:00',4.88),('15087','2013-05-08','11:40:00',2.33),('15087','2013-05-08','11:45:00',3.33),('15087','2013-05-08','11:50:00',2.03),('15087','2013-05-08','11:55:00',2.66),('15087','2013-05-08','12:00:00',2.57),('15087','2013-05-08','12:05:00',1.01),('15087','2013-05-08','12:15:00',1.17),('15087','2013-05-08','12:20:00',3.21),('15087','2013-05-08','12:25:00',2),('15087','2013-05-08','12:30:00',1.36),('15087','2013-05-08','12:35:00',1.41),('15087','2013-05-08','12:40:00',1.4),('15087','2013-05-08','12:45:00',1.28),('15087','2013-05-08','12:50:00',2.74),('15087','2013-05-08','12:55:00',2.97),('15087','2013-05-08','13:00:00',1.61),('15087','2013-05-08','13:05:00',1.78),('15087','2013-05-08','13:10:00',5.74),('15087','2013-05-08','13:15:00',3.03),('15087','2013-05-08','13:20:00',1.19),('15087','2013-05-08','13:25:00',2.56),('15087','2013-05-08','13:30:00',1.08),('15087','2013-05-08','13:35:00',1.03),('15087','2013-05-08','13:40:00',3.3),('15087','2013-05-08','13:45:00',5.55),('15087','2013-05-08','13:50:00',5.51),('15087','2013-05-08','13:55:00',5.12),('15087','2013-05-08','14:00:00',5),('15087','2013-05-08','14:05:00',3.99),('15087','2013-05-08','14:10:00',1.67),('15087','2013-05-08','14:15:00',2.67),('15087','2013-05-08','14:20:00',2.12),('15087','2013-05-08','14:25:00',2.21),('15087','2013-05-08','14:30:00',4.41),('15087','2013-05-08','14:35:00',3.27),('15087','2013-05-08','14:40:00',4.57),('15087','2013-05-08','14:45:00',3.76),('15087','2013-05-08','14:50:00',4.57),('15087','2013-05-08','14:55:00',3.73),('15087','2013-05-08','15:00:00',4.23),('15087','2013-05-08','15:05:00',4.14),('15087','2013-05-08','15:10:00',4.12),('15087','2013-05-08','15:15:00',4.05),('15087','2013-05-08','15:20:00',3.89),('15087','2013-05-08','15:25:00',3.69),('15087','2013-05-08','15:30:00',3.82),('15087','2013-05-08','15:35:00',3.76),('15087','2013-05-08','15:40:00',3.64),('15087','2013-05-08','15:45:00',3.58),('15087','2013-05-08','15:50:00',3.53),('15087','2013-05-08','15:55:00',3.49),('15087','2013-05-08','16:00:00',3.42),('15087','2013-05-08','16:05:00',3.14),('15087','2013-05-08','16:10:00',2.69),('15087','2013-05-08','16:15:00',3.2),('15087','2013-05-08','16:20:00',2.94),('15087','2013-05-08','16:25:00',2.83),('15087','2013-05-08','16:30:00',3.04),('15087','2013-05-08','16:35:00',2.9),('15087','2013-05-08','16:40:00',1.96),('15087','2013-05-08','16:45:00',2.84),('15087','2013-05-08','16:50:00',1.57),('15087','2013-05-08','16:55:00',2.61),('15087','2013-05-08','17:00:00',2.64),('15087','2013-05-08','17:05:00',2.64),('15087','2013-05-08','17:10:00',2.21),('15087','2013-05-08','17:15:00',2.46),('15087','2013-05-08','17:20:00',2.13),('15087','2013-05-08','17:25:00',2.05),('15087','2013-05-08','17:30:00',2.23),('15087','2013-05-08','17:35:00',2.13),('15087','2013-05-08','17:40:00',2.06),('15087','2013-05-08','17:45:00',2.24),('15087','2013-05-08','17:50:00',2.2),('15087','2013-05-08','17:55:00',2.06),('15087','2013-05-08','18:00:00',1.09),('15087','2013-05-08','18:15:00',1.47),('15087','2013-05-08','18:20:00',1.36),('15087','2013-05-08','18:25:00',1.15),('15087','2013-05-07','07:35:00',1.03),('15087','2013-05-07','07:40:00',1.12),('15087','2013-05-07','07:45:00',1.2),('15087','2013-05-07','07:50:00',1.28),('15087','2013-05-07','07:55:00',1.35),('15087','2013-05-07','08:00:00',1.49),('15087','2013-05-07','08:05:00',1.59),('15087','2013-05-07','08:10:00',1.69),('15087','2013-05-07','08:15:00',1.84),('15087','2013-05-07','08:20:00',1.96),('15087','2013-05-07','08:25:00',2.06),('15087','2013-05-07','08:30:00',2.14),('15087','2013-05-07','08:35:00',2.27),('15087','2013-05-07','08:40:00',2.37),('15087','2013-05-07','08:45:00',2.44),('15087','2013-05-07','08:50:00',2.58),('15087','2013-05-07','08:55:00',2.25),('15087','2013-05-07','09:00:00',2.53),('15087','2013-05-07','09:05:00',1.28),('15087','2013-05-07','09:15:00',2.55),('15087','2013-05-07','09:20:00',1.06),('15087','2013-05-07','09:30:00',1.62),('15087','2013-05-07','09:35:00',2.74),('15087','2013-05-07','09:40:00',2.16),('15087','2013-05-07','09:45:00',1.99),('15087','2013-05-07','09:50:00',1.5),('15087','2013-05-07','10:50:00',1),('15087','2013-05-07','10:55:00',1.25),('15087','2013-05-07','11:00:00',1.4),('15087','2013-05-07','11:05:00',1.44),('15087','2013-05-07','11:10:00',1.74),('15087','2013-05-07','11:15:00',1.49),('15087','2013-05-07','11:20:00',3.03),('15087','2013-05-07','11:25:00',1.31),('15087','2013-05-07','11:55:00',1.41),('15087','2013-05-07','12:00:00',1.59),('15087','2013-05-07','12:05:00',5.61),('15087','2013-05-07','12:10:00',4.46),('15087','2013-05-07','12:15:00',3.21),('15087','2013-05-07','12:20:00',5.54),('15087','2013-05-07','12:25:00',2.38),('15087','2013-05-07','12:30:00',1.09),('15087','2013-05-07','13:10:00',1.26),('15087','2013-05-07','13:15:00',1.42),('15087','2013-05-07','13:20:00',1.52),('15087','2013-05-07','13:25:00',3.07),('15087','2013-05-07','13:30:00',3.45),('15087','2013-05-07','13:35:00',5.74),('15087','2013-05-07','13:40:00',5.7),('15087','2013-05-07','13:45:00',5.35),('15087','2013-05-07','13:50:00',4.98),('15087','2013-05-07','13:55:00',2),('15087','2013-05-07','14:00:00',5.34),('15087','2013-05-07','14:05:00',5.24),('15087','2013-05-07','14:10:00',3.68),('15087','2013-05-07','14:15:00',5.19),('15087','2013-05-07','14:20:00',1.3),('15087','2013-05-07','14:25:00',4.87),('15087','2013-05-07','14:30:00',2.66),('15087','2013-05-07','14:35:00',3.93),('15087','2013-05-07','14:40:00',4.32),('15087','2013-05-07','14:45:00',3.26),('15087','2013-05-07','14:50:00',4.03),('15087','2013-05-07','14:55:00',3.32),('15087','2013-05-07','15:00:00',3.97),('15087','2013-05-07','15:05:00',3.92),('15087','2013-05-07','15:10:00',3.96),('15087','2013-05-07','15:15:00',4.29),('15087','2013-05-07','15:20:00',4.43),('15087','2013-05-07','15:25:00',3.02),('15087','2013-05-07','15:30:00',2.92),('15087','2013-05-07','15:35:00',3.11),('15087','2013-05-07','15:40:00',3.26),('15087','2013-05-07','15:45:00',3.34),('15087','2013-05-07','15:50:00',2.01),('15087','2013-05-07','15:55:00',2.55),('15087','2013-05-07','16:00:00',4.14),('15087','2013-05-07','16:05:00',1.48),('15087','2013-05-07','16:10:00',1.74),('15087','2013-05-07','16:15:00',3.5),('15087','2013-05-07','16:20:00',3.92),('15087','2013-05-07','16:25:00',3.77),('15087','2013-05-07','16:30:00',3.53),('15087','2013-05-07','16:35:00',3.57),('15087','2013-05-07','16:40:00',3.41),('15087','2013-05-07','16:45:00',3.27),('15087','2013-05-07','16:50:00',3.11),('15087','2013-05-07','16:55:00',2.56),('15087','2013-05-07','17:00:00',2.81),('15087','2013-05-07','17:05:00',2.79),('15087','2013-05-07','17:10:00',1.31),('15087','2013-05-07','17:15:00',1.22),('15087','2013-05-07','17:20:00',1.26),('15087','2013-05-07','17:25:00',1.23),('15087','2013-05-07','17:30:00',1.11),('15087','2013-05-07','17:35:00',1.03),('15087','2013-05-06','08:25:00',1.23),('15087','2013-05-06','08:30:00',1.31),('15087','2013-05-06','08:35:00',1.2),('15087','2013-05-06','08:40:00',1.1),('15087','2013-05-06','08:50:00',1.44),('15087','2013-05-06','08:55:00',2.69),('15087','2013-05-06','09:00:00',2.53),('15087','2013-05-06','09:05:00',1.72),('15087','2013-05-06','09:10:00',1.46),('15087','2013-05-06','09:15:00',1.38),('15087','2013-05-06','09:20:00',1.69),('15087','2013-05-06','09:25:00',1.3),('15087','2013-05-06','09:55:00',1.15),('15087','2013-05-06','10:00:00',2),('15087','2013-05-06','10:05:00',1.2),('15087','2013-05-06','10:10:00',1.07),('15087','2013-05-06','10:15:00',1.53),('15087','2013-05-06','10:20:00',2.64),('15087','2013-05-06','10:25:00',2.18),('15087','2013-05-06','10:30:00',2.16),('15087','2013-05-06','10:35:00',2.13),('15087','2013-05-06','10:40:00',2.03),('15087','2013-05-06','10:45:00',2.78),('15087','2013-05-06','10:50:00',2.34),('15087','2013-05-06','10:55:00',2.02),('15087','2013-05-06','11:00:00',1.9),('15087','2013-05-06','11:05:00',2.18),('15087','2013-05-06','11:10:00',2.19),('15087','2013-05-06','11:15:00',1.89),('15087','2013-05-06','11:20:00',2.32),('15087','2013-05-06','11:25:00',2.23),('15087','2013-05-06','11:30:00',1.29),('15087','2013-05-06','11:35:00',2.02),('15087','2013-05-06','11:40:00',2.38),('15087','2013-05-06','11:45:00',3.9),('15087','2013-05-06','11:50:00',2.22),('15087','2013-05-06','11:55:00',1.8),('15087','2013-05-06','12:00:00',2.16),('15087','2013-05-06','12:05:00',1.98),('15087','2013-05-06','12:10:00',2.79),('15087','2013-05-06','12:15:00',2.56),('15087','2013-05-06','12:20:00',2.62),('15087','2013-05-06','12:25:00',4.06),('15087','2013-05-06','12:30:00',4.36),('15087','2013-05-06','12:35:00',4.44),('15087','2013-05-06','12:40:00',2.1),('15087','2013-05-06','12:45:00',2.64),('15087','2013-05-06','12:50:00',4.09),('15087','2013-05-06','12:55:00',2.79),('15087','2013-05-06','13:00:00',2.07),('15087','2013-05-06','13:05:00',4.14),('15087','2013-05-06','13:10:00',3.74),('15087','2013-05-06','13:15:00',3.45),('15087','2013-05-06','13:20:00',4.09),('15087','2013-05-06','13:25:00',3.58),('15087','2013-05-06','13:30:00',2.93),('15087','2013-05-06','13:35:00',3.54),('15087','2013-05-06','13:40:00',3.78),('15087','2013-05-06','13:45:00',4.32),('15087','2013-05-06','13:50:00',5.2),('15087','2013-05-06','13:55:00',4.89),('15087','2013-05-06','14:00:00',4.07),('15087','2013-05-06','14:05:00',3.58),('15087','2013-05-06','14:10:00',3.42),('15087','2013-05-06','14:15:00',4.77),('15087','2013-05-06','14:20:00',4.66),('15087','2013-05-06','14:25:00',2.09),('15087','2013-05-06','14:30:00',4.67),('15087','2013-05-06','14:35:00',4.24),('15087','2013-05-06','14:40:00',3.13),('15087','2013-05-06','14:45:00',2.5),('15087','2013-05-06','14:50:00',3.13),('15087','2013-05-06','14:55:00',4.27),('15087','2013-05-06','15:00:00',2.68),('15087','2013-05-06','15:05:00',2.8),('15087','2013-05-06','15:10:00',3.01),('15087','2013-05-06','15:15:00',2.94),('15087','2013-05-06','15:20:00',2.2),('15087','2013-05-06','15:25:00',2.41),('15087','2013-05-06','15:30:00',2.44),('15087','2013-05-06','15:35:00',2.73),('15087','2013-05-06','15:40:00',1.31),('15087','2013-05-06','15:45:00',1.44),('15087','2013-05-06','15:50:00',2.4),('15087','2013-05-06','15:55:00',1.45),('15087','2013-05-06','16:00:00',1.81),('15087','2013-05-06','16:05:00',1.54),('15087','2013-05-06','16:10:00',1.45),('15087','2013-05-06','16:15:00',1.62),('15087','2013-05-06','16:20:00',2.59),('15087','2013-05-06','16:25:00',2.32),('15087','2013-05-06','16:30:00',2.53),('15087','2013-05-06','16:35:00',2.4),('15087','2013-05-06','16:40:00',2.24),('15087','2013-05-06','16:45:00',1.88),('15087','2013-05-06','16:50:00',3.03),('15087','2013-05-06','16:55:00',2.39),('15087','2013-05-06','17:15:00',1.42),('15087','2013-05-06','17:35:00',1.58),('15087','2013-05-06','17:40:00',1.4),('15087','2013-05-06','17:45:00',1.18),('15087','2013-05-06','17:55:00',1.25),('15087','2013-05-06','18:00:00',1.38),('15087','2013-05-06','18:05:00',1.5),('15087','2013-05-06','18:15:00',1.15),('15087','2013-05-06','18:20:00',1.41),('15087','2013-05-06','18:25:00',1.05),('15087','2013-05-05','07:45:00',1.05),('15087','2013-05-05','07:50:00',1.1),('15087','2013-05-05','07:55:00',1.05),('15087','2013-05-05','08:00:00',1.2),('15087','2013-05-05','08:05:00',1.39),('15087','2013-05-05','08:10:00',1.51),('15087','2013-05-05','08:15:00',1.62),('15087','2013-05-05','08:20:00',1.93),('15087','2013-05-05','08:25:00',2.41),('15087','2013-05-05','08:30:00',2.48),('15087','2013-05-05','08:35:00',2.32),('15087','2013-05-05','08:40:00',2.24),('15087','2013-05-05','08:45:00',1.68),('15087','2013-05-05','08:50:00',1.32),('15087','2013-05-05','08:55:00',1.43),('15087','2013-05-05','09:00:00',1.42),('15087','2013-05-05','09:05:00',1.39),('15087','2013-05-05','09:10:00',1.37),('15087','2013-05-05','09:15:00',1.27),('15087','2013-05-05','09:20:00',1.24),('15087','2013-05-05','09:25:00',1.49),('15087','2013-05-05','09:30:00',1.78),('15087','2013-05-05','09:35:00',1.55),('15087','2013-05-05','09:40:00',2.5),('15087','2013-05-05','09:45:00',3.37),('15087','2013-05-05','09:50:00',3.36),('15087','2013-05-05','09:55:00',3.31),('15087','2013-05-05','10:00:00',3.26),('15087','2013-05-05','10:05:00',2.93),('15087','2013-05-05','10:10:00',2.21),('15087','2013-05-05','10:15:00',3.36),('15087','2013-05-05','10:20:00',3.98),('15087','2013-05-05','10:25:00',2.28),('15087','2013-05-05','10:30:00',2.91),('15087','2013-05-05','10:35:00',3.13),('15087','2013-05-05','10:40:00',3.27),('15087','2013-05-05','10:45:00',2.93),('15087','2013-05-05','10:50:00',1.72),('15087','2013-05-05','10:55:00',1.47),('15087','2013-05-05','11:00:00',1.46),('15087','2013-05-05','11:05:00',1.7),('15087','2013-05-05','11:10:00',1.54),('15087','2013-05-05','11:15:00',1.7),('15087','2013-05-05','11:20:00',2.88),('15087','2013-05-05','11:25:00',3.36),('15087','2013-05-05','11:30:00',2.82),('15087','2013-05-05','11:35:00',3.99),('15087','2013-05-05','11:40:00',3.12),('15087','2013-05-05','11:45:00',2.84),('15087','2013-05-05','11:50:00',3.18),('15087','2013-05-05','11:55:00',4.41),('15087','2013-05-05','12:00:00',3.24),('15087','2013-05-05','12:05:00',3.31),('15087','2013-05-05','12:10:00',3.43),('15087','2013-05-05','12:15:00',3.54),('15087','2013-05-05','12:20:00',3.39),('15087','2013-05-05','12:25:00',4.42),('15087','2013-05-05','12:30:00',3.93),('15087','2013-05-05','12:35:00',4.32),('15087','2013-05-05','12:40:00',4.92),('15087','2013-05-05','12:45:00',4.93),('15087','2013-05-05','12:50:00',4.37),('15087','2013-05-05','12:55:00',4.77),('15087','2013-05-05','13:00:00',4.74),('15087','2013-05-05','13:05:00',4.61),('15087','2013-05-05','13:10:00',4.77),('15087','2013-05-05','13:15:00',3.46),('15087','2013-05-05','13:20:00',2.94),('15087','2013-05-05','13:25:00',1.89),('15087','2013-05-05','13:30:00',1.81),('15087','2013-05-05','13:35:00',4.49),('15087','2013-05-05','13:40:00',4.61),('15087','2013-05-05','13:45:00',4.58),('15087','2013-05-05','13:50:00',4.68),('15087','2013-05-05','13:55:00',4.71),('15087','2013-05-05','14:00:00',4.76),('15087','2013-05-05','14:05:00',4.36),('15087','2013-05-05','14:10:00',3.43),('15087','2013-05-05','14:15:00',3.87),('15087','2013-05-05','14:20:00',4.2),('15087','2013-05-05','14:25:00',4),('15087','2013-05-05','14:30:00',3.83),('15087','2013-05-05','14:35:00',3.77),('15087','2013-05-05','14:40:00',3.78),('15087','2013-05-05','14:45:00',3.79),('15087','2013-05-05','14:50:00',3.7),('15087','2013-05-05','14:55:00',3.57),('15087','2013-05-05','15:00:00',3.64),('15087','2013-05-05','15:05:00',3.6),('15087','2013-05-05','15:10:00',3.55),('15087','2013-05-05','15:15:00',3.4),('15087','2013-05-05','15:20:00',3.21),('15087','2013-05-05','15:25:00',3.14),('15087','2013-05-05','15:30:00',3.33),('15087','2013-05-05','15:35:00',3.25),('15087','2013-05-05','15:40:00',3.05),('15087','2013-05-05','15:45:00',3.13),('15087','2013-05-05','15:50:00',3.09),('15087','2013-05-05','15:55:00',3),('15087','2013-05-05','16:00:00',2.95),('15087','2013-05-05','16:05:00',2.85),('15087','2013-05-05','16:10:00',2.67),('15087','2013-05-05','16:15:00',2.79),('15087','2013-05-05','16:20:00',2.63),('15087','2013-05-05','16:25:00',2.63),('15087','2013-05-05','16:30:00',2.6),('15087','2013-05-05','16:35:00',2.58),('15087','2013-05-05','16:40:00',2.41),('15087','2013-05-05','16:45:00',2.38),('15087','2013-05-05','16:50:00',2.32),('15087','2013-05-05','16:55:00',2.16),('15087','2013-05-05','17:00:00',2.11),('15087','2013-05-05','17:05:00',2.03),('15087','2013-05-05','17:10:00',1.93),('15087','2013-05-05','17:15:00',1.88),('15087','2013-05-05','17:20:00',1.78),('15087','2013-05-05','17:25:00',1.64),('15087','2013-05-05','17:30:00',1.6),('15087','2013-05-05','17:35:00',1.55),('15087','2013-05-05','17:40:00',1.48),('15087','2013-05-05','17:45:00',1.42),('15087','2013-05-05','17:50:00',1.35),('15087','2013-05-05','17:55:00',1.22),('15087','2013-05-05','18:00:00',1.19),('15087','2013-05-05','18:05:00',1.08),('15087','2013-05-05','18:10:00',1),('15087','2013-05-04','07:50:00',1.02),('15087','2013-05-04','07:55:00',1.2),('15087','2013-05-04','08:00:00',1.34),('15087','2013-05-04','08:05:00',1.41),('15087','2013-05-04','08:10:00',1.48),('15087','2013-05-04','08:15:00',1.53),('15087','2013-05-04','08:20:00',1.57),('15087','2013-05-04','08:25:00',1.6),('15087','2013-05-04','08:30:00',1.67),('15087','2013-05-04','08:35:00',1.75),('15087','2013-05-04','08:40:00',1.83),('15087','2013-05-04','08:45:00',1.93),('15087','2013-05-04','08:50:00',1.99),('15087','2013-05-04','08:55:00',2.06),('15087','2013-05-04','09:00:00',2.17),('15087','2013-05-04','09:05:00',2.29),('15087','2013-05-04','09:10:00',2.39),('15087','2013-05-04','09:15:00',2.46),('15087','2013-05-04','09:20:00',2.57),('15087','2013-05-04','09:25:00',2.64),('15087','2013-05-04','09:30:00',2.66),('15087','2013-05-04','09:35:00',2.78),('15087','2013-05-04','09:40:00',2.85),('15087','2013-05-04','09:45:00',2.95),('15087','2013-05-04','09:50:00',3.02),('15087','2013-05-04','09:55:00',3.1),('15087','2013-05-04','10:00:00',3.14),('15087','2013-05-04','10:05:00',3.18),('15087','2013-05-04','10:10:00',3.29),('15087','2013-05-04','10:15:00',3.36),('15087','2013-05-04','10:20:00',3.42),('15087','2013-05-04','10:25:00',3.46),('15087','2013-05-04','10:30:00',3.5),('15087','2013-05-04','10:35:00',3.55),('15087','2013-05-04','10:40:00',3.54),('15087','2013-05-04','10:45:00',3.55),('15087','2013-05-04','10:50:00',3.47),('15087','2013-05-04','10:55:00',3.54),('15087','2013-05-04','11:00:00',3.51),('15087','2013-05-04','11:05:00',3.5),('15087','2013-05-04','11:10:00',3.32),('15087','2013-05-04','11:15:00',3.3),('15087','2013-05-04','11:20:00',3.59),('15087','2013-05-04','11:25:00',3.6),('15087','2013-05-04','11:30:00',3.54),('15087','2013-05-04','11:35:00',3.58),('15087','2013-05-04','11:40:00',3.48),('15087','2013-05-04','11:45:00',3.6),('15087','2013-05-04','11:50:00',3.58),('15087','2013-05-04','11:55:00',3.58),('15087','2013-05-04','12:00:00',3.57),('15087','2013-05-04','12:05:00',3.66),('15087','2013-05-04','12:10:00',3.71),('15087','2013-05-04','12:15:00',3.79),('15087','2013-05-04','12:20:00',3.84),('15087','2013-05-04','12:25:00',3.88),('15087','2013-05-04','12:30:00',3.97),('15087','2013-05-04','12:35:00',3.99),('15087','2013-05-04','12:40:00',3.99),('15087','2013-05-04','12:45:00',4.02),('15087','2013-05-04','12:50:00',3.87),('15087','2013-05-04','12:55:00',3.86),('15087','2013-05-04','13:00:00',3.8),('15087','2013-05-04','13:05:00',3.41),('15087','2013-05-04','13:10:00',3.77),('15087','2013-05-04','13:15:00',4.2),('15087','2013-05-04','13:20:00',4.2),('15087','2013-05-04','13:25:00',3.99),('15087','2013-05-04','13:30:00',4.1),('15087','2013-05-04','13:35:00',3.78),('15087','2013-05-04','13:40:00',3.91),('15087','2013-05-04','13:45:00',3.91),('15087','2013-05-04','13:50:00',3.48),('15087','2013-05-04','13:55:00',3.57),('15087','2013-05-04','14:00:00',3.91),('15087','2013-05-04','14:05:00',3.73),('15087','2013-05-04','14:10:00',3.62),('15087','2013-05-04','14:15:00',3.69),('15087','2013-05-04','14:20:00',3.6),('15087','2013-05-04','14:25:00',3.41),('15087','2013-05-04','14:30:00',3.53),('15087','2013-05-04','14:35:00',3.32),('15087','2013-05-04','14:40:00',3.37),('15087','2013-05-04','14:45:00',3.35),('15087','2013-05-04','14:50:00',3.26),('15087','2013-05-04','14:55:00',3.32),('15087','2013-05-04','15:00:00',3.36),('15087','2013-05-04','15:05:00',3.23),('15087','2013-05-04','15:10:00',3.1),('15087','2013-05-04','15:15:00',3.21),('15087','2013-05-04','15:20:00',3.12),('15087','2013-05-04','15:25:00',3.13),('15087','2013-05-04','15:30:00',3.17),('15087','2013-05-04','15:35:00',3.01),('15087','2013-05-04','15:40:00',2.99),('15087','2013-05-04','15:45:00',3.07),('15087','2013-05-04','15:50:00',2.99),('15087','2013-05-04','15:55:00',2.87),('15087','2013-05-04','16:00:00',2.86),('15087','2013-05-04','16:05:00',2.75),('15087','2013-05-04','16:10:00',2.52),('15087','2013-05-04','16:15:00',2.69),('15087','2013-05-04','16:20:00',2.44),('15087','2013-05-04','16:25:00',2.3),('15087','2013-05-04','16:30:00',2.45),('15087','2013-05-04','16:35:00',2.37),('15087','2013-05-04','16:40:00',2.17),('15087','2013-05-04','16:45:00',2.2),('15087','2013-05-04','16:50:00',2.06),('15087','2013-05-04','16:55:00',1.96),('15087','2013-05-04','17:00:00',1.97),('15087','2013-05-04','17:05:00',1.83),('15087','2013-05-04','17:10:00',1.38),('15087','2013-05-04','17:15:00',1.67),('15087','2013-05-04','17:20:00',1.72),('15087','2013-05-04','17:25:00',1.52),('15087','2013-05-04','17:30:00',1.51),('15087','2013-05-04','17:35:00',1.41),('15087','2013-05-04','17:40:00',1.33),('15087','2013-05-04','17:45:00',1.33),('15087','2013-05-04','17:50:00',1.27),('15087','2013-05-04','17:55:00',1.22),('15087','2013-05-04','18:00:00',1.18),('15087','2013-05-04','18:05:00',1.12),('15087','2013-05-03','08:05:00',1.36),('15087','2013-05-03','08:10:00',1.56),('15087','2013-05-03','08:15:00',1.77),('15087','2013-05-03','08:20:00',1.69),('15087','2013-05-03','08:25:00',1.84),('15087','2013-05-03','08:30:00',1.93),('15087','2013-05-03','08:35:00',1.98),('15087','2013-05-03','08:40:00',2.07),('15087','2013-05-03','08:45:00',2.11),('15087','2013-05-03','08:50:00',2.05),('15087','2013-05-03','08:55:00',2.13),('15087','2013-05-03','09:00:00',2.31),('15087','2013-05-03','09:05:00',2.44),('15087','2013-05-03','09:10:00',2.51),('15087','2013-05-03','09:15:00',2.58),('15087','2013-05-03','09:20:00',2.64),('15087','2013-05-03','09:25:00',2.71),('15087','2013-05-03','09:30:00',2.79),('15087','2013-05-03','09:35:00',2.86),('15087','2013-05-03','09:40:00',2.94),('15087','2013-05-03','09:45:00',3.01),('15087','2013-05-03','09:50:00',3.07),('15087','2013-05-03','09:55:00',3.16),('15087','2013-05-03','10:00:00',3.21),('15087','2013-05-03','10:05:00',3.31),('15087','2013-05-03','10:10:00',3.36),('15087','2013-05-03','10:15:00',3.41),('15087','2013-05-03','10:20:00',3.46),('15087','2013-05-03','10:25:00',3.52),('15087','2013-05-03','10:30:00',3.55),('15087','2013-05-03','10:35:00',3.6),('15087','2013-05-03','10:40:00',3.67),('15087','2013-05-03','10:45:00',3.66),('15087','2013-05-03','10:50:00',3.78),('15087','2013-05-03','10:55:00',3.83),('15087','2013-05-03','11:00:00',3.83),('15087','2013-05-03','11:05:00',3.85),('15087','2013-05-03','11:10:00',3.88),('15087','2013-05-03','11:15:00',3.93),('15087','2013-05-03','11:20:00',4),('15087','2013-05-03','11:25:00',4.05),('15087','2013-05-03','11:30:00',4.03),('15087','2013-05-03','11:35:00',4.08),('15087','2013-05-03','11:40:00',4.13),('15087','2013-05-03','11:45:00',4.13),('15087','2013-05-03','11:50:00',4.15),('15087','2013-05-03','11:55:00',4.18),('15087','2013-05-03','12:00:00',4.15),('15087','2013-05-03','12:05:00',4.13),('15087','2013-05-03','12:10:00',4.18),('15087','2013-05-03','12:15:00',4.24),('15087','2013-05-03','12:20:00',4.27),('15087','2013-05-03','12:25:00',4.29),('15087','2013-05-03','12:30:00',4.27),('15087','2013-05-03','12:35:00',4.28),('15087','2013-05-03','12:40:00',4.28),('15087','2013-05-03','12:45:00',4.2),('15087','2013-05-03','12:50:00',4.33),('15087','2013-05-03','12:55:00',4.34),('15087','2013-05-03','13:00:00',4.31),('15087','2013-05-03','13:05:00',4.3),('15087','2013-05-03','13:10:00',4.31),('15087','2013-05-03','13:15:00',4.3),('15087','2013-05-03','13:20:00',4.29),('15087','2013-05-03','13:25:00',4.29),('15087','2013-05-03','13:30:00',4.27),('15087','2013-05-03','13:35:00',4.14),('15087','2013-05-03','13:40:00',4.07),('15087','2013-05-03','13:45:00',4.05),('15087','2013-05-03','13:50:00',4.09),('15087','2013-05-03','13:55:00',4.1),('15087','2013-05-03','14:00:00',3.97),('15087','2013-05-03','14:05:00',3.82),('15087','2013-05-03','14:10:00',3.83),('15087','2013-05-03','14:15:00',3.82),('15087','2013-05-03','14:20:00',3.94),('15087','2013-05-03','14:25:00',3.84),('15087','2013-05-03','14:30:00',3.74),('15087','2013-05-03','14:35:00',3.8),('15087','2013-05-03','14:40:00',3.51),('15087','2013-05-03','14:45:00',3.3),('15087','2013-05-03','14:50:00',3.52),('15087','2013-05-03','14:55:00',3.59),('15087','2013-05-03','15:00:00',3.59),('15087','2013-05-03','15:05:00',3.52),('15087','2013-05-03','15:10:00',3.48),('15087','2013-05-03','15:15:00',3.36),('15087','2013-05-03','15:20:00',3.38),('15087','2013-05-03','15:25:00',3.39),('15087','2013-05-03','15:30:00',3.33),('15087','2013-05-03','15:35:00',3.24),('15087','2013-05-03','15:40:00',3.19),('15087','2013-05-03','15:45:00',3.15),('15087','2013-05-03','15:50:00',3),('15087','2013-05-03','15:55:00',2.85),('15087','2013-05-03','16:00:00',2.65),('15087','2013-05-03','16:05:00',2.84),('15087','2013-05-03','16:10:00',2.85),('15087','2013-05-03','16:15:00',2.78),('15087','2013-05-03','16:20:00',2.6),('15087','2013-05-03','16:25:00',2.51),('15087','2013-05-03','16:30:00',2.59),('15087','2013-05-03','16:35:00',2.5),('15087','2013-05-03','16:40:00',2.32),('15087','2013-05-03','16:45:00',2.11),('15087','2013-05-03','16:50:00',2.18),('15087','2013-05-03','16:55:00',2.07),('15087','2013-05-03','17:00:00',1.99),('15087','2013-05-03','17:05:00',1.95),('15087','2013-05-03','17:10:00',1.86),('15087','2013-05-03','17:15:00',1.77),('15087','2013-05-03','17:20:00',1.68),('15087','2013-05-03','17:25:00',1.56),('15087','2013-05-03','17:30:00',1.49),('15087','2013-05-03','17:35:00',1.43),('15087','2013-05-03','17:40:00',1.39),('15087','2013-05-03','17:45:00',1.28),('15087','2013-05-03','17:50:00',1.18),('15087','2013-05-03','17:55:00',1.16),('15087','2013-05-03','18:00:00',1.07),('15087','2013-05-03','18:05:00',1.06),('15087','2013-05-02','08:55:00',1.34),('15087','2013-05-02','09:00:00',1.77),('15087','2013-05-02','09:05:00',1.44),('15087','2013-05-02','09:20:00',1.02),('15087','2013-05-02','09:25:00',1.88),('15087','2013-05-02','09:30:00',2.33),('15087','2013-05-02','09:35:00',2.03),('15087','2013-05-02','09:40:00',1.54),('15087','2013-05-02','09:45:00',2.83),('15087','2013-05-02','09:50:00',1.36),('15087','2013-05-02','09:55:00',1.03),('15087','2013-05-02','10:00:00',1.03),('15087','2013-05-02','10:05:00',1.5),('15087','2013-05-02','10:10:00',1.38),('15087','2013-05-02','10:15:00',1.45),('15087','2013-05-02','10:20:00',1.48),('15087','2013-05-02','10:25:00',1.8),('15087','2013-05-02','10:30:00',2.91),('15087','2013-05-02','10:35:00',2.87),('15087','2013-05-02','10:40:00',3.66),('15087','2013-05-02','10:45:00',3.2),('15087','2013-05-02','10:50:00',3.89),('15087','2013-05-02','10:55:00',4.2),('15087','2013-05-02','11:00:00',4.13),('15087','2013-05-02','11:05:00',3.74),('15087','2013-05-02','11:10:00',3.28),('15087','2013-05-02','11:15:00',3.07),('15087','2013-05-02','11:20:00',3.41),('15087','2013-05-02','11:25:00',3.95),('15087','2013-05-02','11:30:00',4.16),('15087','2013-05-02','11:35:00',4.01),('15087','2013-05-02','11:40:00',4.06),('15087','2013-05-02','11:45:00',4.07),('15087','2013-05-02','11:50:00',4.06),('15087','2013-05-02','11:55:00',4.06),('15087','2013-05-02','12:00:00',4.06),('15087','2013-05-02','12:05:00',4.07),('15087','2013-05-02','12:10:00',4.06),('15087','2013-05-02','12:15:00',4.1),('15087','2013-05-02','12:20:00',4.11),('15087','2013-05-02','12:25:00',4.13),('15087','2013-05-02','12:30:00',4.18),('15087','2013-05-02','12:35:00',4.23),('15087','2013-05-02','12:40:00',4.26),('15087','2013-05-02','12:45:00',4.3),('15087','2013-05-02','12:50:00',4.3),('15087','2013-05-02','12:55:00',4.35),('15087','2013-05-02','13:00:00',4.39),('15087','2013-05-02','13:05:00',4.43),('15087','2013-05-02','13:10:00',4.44),('15087','2013-05-02','13:15:00',4.36),('15087','2013-05-02','13:20:00',4.41),('15087','2013-05-02','13:25:00',4.42),('15087','2013-05-02','13:30:00',4.41),('15087','2013-05-02','13:35:00',4.38),('15087','2013-05-02','13:40:00',4.38),('15087','2013-05-02','13:45:00',4.33),('15087','2013-05-02','13:50:00',4.33),('15087','2013-05-02','13:55:00',4.3),('15087','2013-05-02','14:00:00',4.21),('15087','2013-05-02','14:05:00',4.16),('15087','2013-05-02','14:10:00',4.13),('15087','2013-05-02','14:15:00',4.11),('15087','2013-05-02','14:20:00',4.07),('15087','2013-05-02','14:25:00',3.95),('15087','2013-05-02','14:30:00',3.91),('15087','2013-05-02','14:35:00',3.92),('15087','2013-05-02','14:40:00',3.86),('15087','2013-05-02','14:45:00',3.77),('15087','2013-05-02','14:50:00',3.65),('15087','2013-05-02','14:55:00',3.66),('15087','2013-05-02','15:00:00',3.61),('15087','2013-05-02','15:05:00',3.62),('15087','2013-05-02','15:10:00',3.48),('15087','2013-05-02','15:15:00',3.39),('15087','2013-05-02','15:20:00',3.41),('15087','2013-05-02','15:25:00',3.35),('15087','2013-05-02','15:30:00',3.26),('15087','2013-05-02','15:35:00',3.1),('15087','2013-05-02','15:40:00',2.9),('15087','2013-05-02','15:45:00',2.94),('15087','2013-05-02','15:50:00',2.99),('15087','2013-05-02','15:55:00',2.78),('15087','2013-05-02','16:00:00',2.76),('15087','2013-05-02','16:05:00',2.78),('15087','2013-05-02','16:10:00',2.67),('15087','2013-05-02','16:15:00',2.71),('15087','2013-05-02','16:20:00',2.7),('15087','2013-05-02','16:25:00',2.52),('15087','2013-05-02','16:30:00',2.42),('15087','2013-05-02','16:35:00',2.45),('15087','2013-05-02','16:40:00',2.31),('15087','2013-05-02','16:45:00',2.28),('15087','2013-05-02','16:50:00',2.18),('15087','2013-05-02','16:55:00',2.04),('15087','2013-05-02','17:00:00',1.98),('15087','2013-05-02','17:05:00',1.95),('15087','2013-05-02','17:10:00',1.87),('15087','2013-05-02','17:15:00',1.77),('15087','2013-05-02','17:20:00',1.74),('15087','2013-05-02','17:25:00',1.59),('15087','2013-05-02','17:30:00',1.57),('15087','2013-05-02','17:35:00',1.52),('15087','2013-05-02','17:40:00',1.47),('15087','2013-05-02','17:45:00',1.4),('15087','2013-05-02','17:50:00',1.31),('15087','2013-05-02','17:55:00',1.23),('15087','2013-05-02','18:00:00',1.17),('15087','2013-05-02','18:05:00',1.11),('15087','2013-05-02','18:10:00',1.04),('15087','2014-03-30','08:20:00',1.1),('15087','2014-03-30','08:25:00',1.2),('15087','2014-03-30','08:30:00',1.33),('15087','2014-03-30','08:35:00',1.37),('15087','2014-03-30','08:40:00',1.42),('15087','2014-03-30','08:45:00',1.36),('15087','2014-03-30','08:50:00',1.4),('15087','2014-03-30','08:55:00',1.47),('15087','2014-03-30','09:00:00',1.54),('15087','2014-03-30','09:05:00',1.53),('15087','2014-03-30','09:10:00',1.44),('15087','2014-03-30','09:15:00',1.56),('15087','2014-03-30','09:20:00',1.83),('15087','2014-03-30','09:25:00',2),('15087','2014-03-30','09:30:00',2.23),('15087','2014-03-30','09:35:00',2.35),('15087','2014-03-30','09:40:00',2.41),('15087','2014-03-30','09:45:00',2.53),('15087','2014-03-30','09:50:00',2.58),('15087','2014-03-30','09:55:00',2.51),('15087','2014-03-30','10:00:00',2.62),('15087','2014-03-30','10:05:00',2.89),('15087','2014-03-30','10:10:00',2.93),('15087','2014-03-30','10:15:00',2.89),('15087','2014-03-30','10:20:00',2.95),('15087','2014-03-30','10:25:00',3.16),('15087','2014-03-30','10:30:00',3.26),('15087','2014-03-30','10:35:00',3.33),('15087','2014-03-30','10:40:00',3.38),('15087','2014-03-30','10:45:00',3.4),('15087','2014-03-30','10:50:00',3.43),('15087','2014-03-30','10:55:00',3.43),('15087','2014-03-30','11:00:00',3.4),('15087','2014-03-30','11:05:00',3.38),('15087','2014-03-30','11:10:00',3.41),('15087','2014-03-30','11:15:00',3.25),('15087','2014-03-30','11:20:00',3.29),('15087','2014-03-30','11:25:00',3.41),('15087','2014-03-30','11:30:00',3.75),('15087','2014-03-30','11:35:00',3.73),('15087','2014-03-30','11:40:00',3.87),('15087','2014-03-30','11:45:00',4.01),('15087','2014-03-30','11:50:00',4.04),('15087','2014-03-30','11:55:00',4.14),('15087','2014-03-30','12:00:00',4.22),('15087','2014-03-30','12:05:00',4.35),('15087','2014-03-30','12:10:00',4.42),('15087','2014-03-30','12:15:00',4.51),('15087','2014-03-30','12:20:00',4.42),('15087','2014-03-30','12:25:00',4.44),('15087','2014-03-30','12:30:00',4.03),('15087','2014-03-30','12:35:00',4.1),('15087','2014-03-30','12:40:00',4.26),('15087','2014-03-30','12:45:00',4.21),('15087','2014-03-30','12:50:00',4.25),('15087','2014-03-30','12:55:00',4.34),('15087','2014-03-30','13:00:00',4.42),('15087','2014-03-30','13:05:00',4.53),('15087','2014-03-30','13:10:00',4.45),('15087','2014-03-30','13:15:00',4.45),('15087','2014-03-30','13:20:00',4.47),('15087','2014-03-30','13:25:00',4.47),('15087','2014-03-30','13:30:00',4.44),('15087','2014-03-30','13:35:00',4.51),('15087','2014-03-30','13:40:00',4.52),('15087','2014-03-30','13:45:00',4.52),('15087','2014-03-30','13:50:00',4.46),('15087','2014-03-30','13:55:00',4.26),('15087','2014-03-30','14:00:00',4.18),('15087','2014-03-30','14:05:00',4.21),('15087','2014-03-30','14:10:00',4.05),('15087','2014-03-30','14:15:00',4),('15087','2014-03-30','14:20:00',4.1),('15087','2014-03-30','14:25:00',4.21),('15087','2014-03-30','14:30:00',4.06),('15087','2014-03-30','14:35:00',3.4),('15087','2014-03-30','14:40:00',3.47),('15087','2014-03-30','14:45:00',3.16),('15087','2014-03-30','14:50:00',2.4),('15087','2014-03-30','14:55:00',1.82),('15087','2014-03-30','15:00:00',1.69),('15087','2014-03-30','15:05:00',2.01),('15087','2014-03-30','15:10:00',1.98),('15087','2014-03-30','15:15:00',2.81),('15087','2014-03-30','15:20:00',2.92),('15087','2014-03-30','15:25:00',3.17),('15087','2014-03-30','15:30:00',3.2),('15087','2014-03-30','15:35:00',3.11),('15087','2014-03-30','15:40:00',3.04),('15087','2014-03-30','15:45:00',2.95),('15087','2014-03-30','15:50:00',3.08),('15087','2014-03-30','15:55:00',2.97),('15087','2014-03-30','16:00:00',2.49),('15087','2014-03-30','16:05:00',2.59),('15087','2014-03-30','16:10:00',2.4),('15087','2014-03-30','16:15:00',2.71),('15087','2014-03-30','16:20:00',2.8),('15087','2014-03-30','16:25:00',2.74),('15087','2014-03-30','16:30:00',2.63),('15087','2014-03-30','16:35:00',2.62),('15087','2014-03-30','16:40:00',2.45),('15087','2014-03-30','16:45:00',2.18),('15087','2014-03-30','16:50:00',1.89),('15087','2014-03-30','16:55:00',1.77),('15087','2014-03-30','17:00:00',1.91),('15087','2014-03-30','17:05:00',1.94),('15087','2014-03-30','17:10:00',1.99),('15087','2014-03-30','17:15:00',1.81),('15087','2014-03-30','17:20:00',1.73),('15087','2014-03-30','17:25:00',1.5),('15087','2014-03-30','17:30:00',1.45),('15087','2014-03-30','17:35:00',1.37),('15087','2014-03-30','17:40:00',1.15),('15087','2014-03-30','17:45:00',1.11),('15087','2014-03-30','17:50:00',1),('15087','2013-05-01','07:55:00',1.03),('15087','2013-05-01','08:00:00',1.11),('15087','2013-05-01','08:05:00',1.18),('15087','2013-05-01','08:10:00',1.23),('15087','2013-05-01','08:15:00',1.35),('15087','2013-05-01','08:20:00',1.45),('15087','2013-05-01','08:25:00',1.55),('15087','2013-05-01','08:30:00',1.66),('15087','2013-05-01','08:35:00',1.78),('15087','2013-05-01','08:40:00',1.86),('15087','2013-05-01','08:45:00',1.94),('15087','2013-05-01','08:50:00',2.1),('15087','2013-05-01','08:55:00',2.17),('15087','2013-05-01','09:00:00',2.29),('15087','2013-05-01','09:05:00',2.38),('15087','2013-05-01','09:10:00',2.44),('15087','2013-05-01','09:15:00',2.5),('15087','2013-05-01','09:20:00',2.55),('15087','2013-05-01','09:25:00',2.62),('15087','2013-05-01','09:30:00',2.64),('15087','2013-05-01','09:35:00',2.73),('15087','2013-05-01','09:40:00',2.81),('15087','2013-05-01','09:45:00',2.87),('15087','2013-05-01','09:50:00',2.88),('15087','2013-05-01','09:55:00',3),('15087','2013-05-01','10:00:00',3.04),('15087','2013-05-01','10:05:00',3.07),('15087','2013-05-01','10:10:00',3.21),('15087','2013-05-01','10:15:00',3.29),('15087','2013-05-01','10:20:00',3.35),('15087','2013-05-01','10:25:00',3.41),('15087','2013-05-01','10:30:00',3.46),('15087','2013-05-01','10:35:00',3.53),('15087','2013-05-01','10:40:00',3.74),('15087','2013-05-01','10:45:00',3.8),('15087','2013-05-01','10:50:00',3.83),('15087','2013-05-01','10:55:00',3.84),('15087','2013-05-01','11:00:00',3.9),('15087','2013-05-01','11:05:00',3.9),('15087','2013-05-01','11:10:00',3.98),('15087','2013-05-01','11:15:00',3.65),('15087','2013-05-01','11:20:00',3.73),('15087','2013-05-01','11:25:00',3.73),('15087','2013-05-01','11:30:00',3.63),('15087','2013-05-01','11:35:00',3.71),('15087','2013-05-01','11:40:00',2.83),('15087','2013-05-01','11:45:00',2.81),('15087','2013-05-01','11:50:00',3.73),('15087','2013-05-01','11:55:00',4.23),('15087','2013-05-01','12:00:00',4.2),('15087','2013-05-01','12:05:00',4.08),('15087','2013-05-01','12:10:00',4.19),('15087','2013-05-01','12:15:00',4.13),('15087','2013-05-01','12:20:00',4.17),('15087','2013-05-01','12:25:00',4.24),('15087','2013-05-01','12:30:00',4.31),('15087','2013-05-01','12:35:00',4.36),('15087','2013-05-01','12:40:00',4.46),('15087','2013-05-01','12:45:00',3.97),('15087','2013-05-01','12:50:00',2.53),('15087','2013-05-01','12:55:00',1.54),('15087','2013-05-01','13:00:00',1.63),('15087','2013-05-01','13:05:00',1.95),('15087','2013-05-01','13:10:00',2.42),('15087','2013-05-01','13:15:00',4.47),('15087','2013-05-01','13:20:00',5.01),('15087','2013-05-01','13:25:00',4.4),('15087','2013-05-01','13:30:00',3.86),('15087','2013-05-01','13:35:00',4.55),('15087','2013-05-01','13:40:00',4.76),('15087','2013-05-01','13:45:00',4.67),('15087','2013-05-01','13:50:00',4.43),('15087','2013-05-01','13:55:00',4.27),('15087','2013-05-01','14:00:00',4.15),('15087','2013-05-01','14:05:00',4.15),('15087','2013-05-01','14:10:00',4.11),('15087','2013-05-01','14:15:00',3.6),('15087','2013-05-01','14:20:00',4.29),('15087','2013-05-01','14:25:00',4.18),('15087','2013-05-01','14:30:00',4.26),('15087','2013-05-01','14:35:00',4.01),('15087','2013-05-01','14:40:00',3.71),('15087','2013-05-01','14:45:00',3.7),('15087','2013-05-01','14:50:00',3.28),('15087','2013-05-01','14:55:00',2.95),('15087','2013-05-01','15:00:00',3.17),('15087','2013-05-01','15:05:00',3.54),('15087','2013-05-01','15:10:00',3.63),('15087','2013-05-01','15:15:00',3.46),('15087','2013-05-01','15:20:00',3.44),('15087','2013-05-01','15:25:00',3.39),('15087','2013-05-01','15:30:00',2.83),('15087','2013-05-01','15:35:00',2.5),('15087','2013-05-01','15:40:00',2.52),('15087','2013-05-01','15:45:00',2.44),('15087','2013-05-01','15:50:00',1.75),('15087','2013-05-01','15:55:00',1.75),('15087','2013-05-01','16:00:00',2.08),('15087','2013-05-01','16:05:00',1.98),('15087','2013-05-01','16:10:00',1.79),('15087','2013-05-01','16:15:00',1.65),('15087','2013-05-01','16:20:00',1.43),('15087','2013-05-01','16:25:00',1.14),('15087','2013-05-01','16:30:00',1.05),('15087','2013-05-01','16:35:00',1.1),('15087','2013-05-01','16:40:00',1.18),('15087','2013-05-01','16:45:00',1.1),('15087','2013-04-30','08:50:00',1.21),('15087','2013-04-30','08:55:00',1.99),('15087','2013-04-30','09:00:00',1.83),('15087','2013-04-30','09:05:00',1.5),('15087','2013-04-30','09:10:00',2.34),('15087','2013-04-30','09:15:00',2.8),('15087','2013-04-30','09:20:00',2.91),('15087','2013-04-30','09:25:00',3.09),('15087','2013-04-30','09:30:00',2.96),('15087','2013-04-30','09:35:00',2.41),('15087','2013-04-30','09:40:00',1.51),('15087','2013-04-30','09:45:00',2.32),('15087','2013-04-30','09:50:00',2.84),('15087','2013-04-30','09:55:00',3.17),('15087','2013-04-30','10:00:00',3.64),('15087','2013-04-30','10:05:00',3.16),('15087','2013-04-30','10:10:00',3.07),('15087','2013-04-30','10:15:00',2.33),('15087','2013-04-30','10:20:00',2.29),('15087','2013-04-30','10:25:00',3.78),('15087','2013-04-30','10:30:00',2.58),('15087','2013-04-30','10:35:00',1.95),('15087','2013-04-30','10:40:00',1.72),('15087','2013-04-30','10:45:00',1.36),('15087','2013-04-30','10:50:00',1.48),('15087','2013-04-30','10:55:00',1.59),('15087','2013-04-30','11:00:00',1.67),('15087','2013-04-30','11:05:00',1.94),('15087','2013-04-30','11:10:00',1.95),('15087','2013-04-30','11:15:00',2.11),('15087','2013-04-30','11:20:00',2.45),('15087','2013-04-30','11:25:00',2.18),('15087','2013-04-30','11:30:00',2.23),('15087','2013-04-30','11:35:00',2.44),('15087','2013-04-30','11:40:00',2.15),('15087','2013-04-30','11:45:00',1.73),('15087','2013-04-30','11:50:00',1.73),('15087','2013-04-30','11:55:00',1.79),('15087','2013-04-30','12:00:00',1.83),('15087','2013-04-30','12:05:00',1.94),('15087','2013-04-30','12:10:00',1.81),('15087','2013-04-30','12:15:00',1.63),('15087','2013-04-30','12:20:00',1.49),('15087','2013-04-30','12:25:00',1.39),('15087','2013-04-30','12:30:00',1.44),('15087','2013-04-30','12:35:00',2.98),('15087','2013-04-30','12:40:00',4.74),('15087','2013-04-30','12:45:00',4.85),('15087','2013-04-30','12:50:00',4.69),('15087','2013-04-30','12:55:00',4.23),('15087','2013-04-30','13:00:00',4.53),('15087','2013-04-30','13:05:00',4.51),('15087','2013-04-30','13:10:00',4.48),('15087','2013-04-30','13:15:00',4.42),('15087','2013-04-30','13:20:00',4.37),('15087','2013-04-30','13:25:00',4.34),('15087','2013-04-30','13:30:00',4.31),('15087','2013-04-30','13:35:00',4.28),('15087','2013-04-30','13:40:00',4.25),('15087','2013-04-30','13:45:00',4.21),('15087','2013-04-30','13:50:00',4.2),('15087','2013-04-30','13:55:00',4.13),('15087','2013-04-30','14:00:00',4.04),('15087','2013-04-30','14:05:00',4.07),('15087','2013-04-30','14:10:00',4.02),('15087','2013-04-30','14:15:00',3.99),('15087','2013-04-30','14:20:00',3.95),('15087','2013-04-30','14:25:00',3.89),('15087','2013-04-30','14:30:00',3.93),('15087','2013-04-30','14:35:00',3.82),('15087','2013-04-30','14:40:00',3.81),('15087','2013-04-30','14:45:00',3.71),('15087','2013-04-30','14:50:00',3.63),('15087','2013-04-30','14:55:00',3.58),('15087','2013-04-30','15:00:00',3.46),('15087','2013-04-30','15:05:00',3.43),('15087','2013-04-30','15:10:00',3.37),('15087','2013-04-30','15:15:00',3.35),('15087','2013-04-30','15:20:00',3.25),('15087','2013-04-30','15:25:00',3.16),('15087','2013-04-30','15:30:00',3.12),('15087','2013-04-30','15:35:00',3.14),('15087','2013-04-30','15:40:00',3.07),('15087','2013-04-30','15:45:00',3.02),('15087','2013-04-30','15:50:00',2.93),('15087','2013-04-30','15:55:00',2.82),('15087','2013-04-30','16:00:00',2.78),('15087','2013-04-30','16:05:00',2.76),('15087','2013-04-30','16:10:00',2.65),('15087','2013-04-30','16:15:00',2.6),('15087','2013-04-30','16:20:00',2.61),('15087','2013-04-30','16:25:00',2.54),('15087','2013-04-30','16:30:00',2.38),('15087','2013-04-30','16:35:00',2.19),('15087','2013-04-30','16:40:00',1.88),('15087','2013-04-30','16:45:00',1.97),('15087','2013-04-30','16:50:00',1.82),('15087','2013-04-30','16:55:00',1.94),('15087','2013-04-30','17:00:00',1.84),('15087','2013-04-30','17:05:00',1.78),('15087','2013-04-30','17:10:00',1.48),('15087','2013-04-30','17:20:00',1.39),('15087','2013-04-30','17:25:00',1.52),('15087','2013-04-30','17:30:00',1.44),('15087','2013-04-30','17:35:00',1.41),('15087','2013-04-30','17:40:00',1.34),('15087','2013-04-30','17:45:00',1.29),('15087','2013-04-30','17:50:00',1.2),('15087','2013-04-30','17:55:00',1.13),('15087','2013-04-30','18:00:00',1.06),('15087','2013-04-29','07:55:00',1.09),('15087','2013-04-29','08:00:00',1.24),('15087','2013-04-29','08:05:00',1.32),('15087','2013-04-29','08:10:00',1.27),('15087','2013-04-29','08:15:00',1.32),('15087','2013-04-29','08:20:00',1.45),('15087','2013-04-29','08:25:00',1.67),('15087','2013-04-29','08:30:00',1.97),('15087','2013-04-29','08:35:00',2.21),('15087','2013-04-29','08:40:00',2.2),('15087','2013-04-29','08:45:00',2.17),('15087','2013-04-29','08:50:00',2.31),('15087','2013-04-29','08:55:00',2.25),('15087','2013-04-29','09:00:00',1.79),('15087','2013-04-29','09:05:00',2.48),('15087','2013-04-29','09:10:00',2.72),('15087','2013-04-29','09:15:00',2.86),('15087','2013-04-29','09:20:00',2.69),('15087','2013-04-29','09:25:00',2.6),('15087','2013-04-29','09:30:00',2.69),('15087','2013-04-29','09:35:00',2.81),('15087','2013-04-29','09:40:00',2.84),('15087','2013-04-29','09:45:00',2.9),('15087','2013-04-29','09:50:00',3.05),('15087','2013-04-29','09:55:00',2.9),('15087','2013-04-29','10:00:00',3.03),('15087','2013-04-29','10:05:00',3.01),('15087','2013-04-29','10:10:00',2.96),('15087','2013-04-29','10:15:00',2.42),('15087','2013-04-29','10:20:00',2.57),('15087','2013-04-29','10:25:00',3),('15087','2013-04-29','10:30:00',3.2),('15087','2013-04-29','10:35:00',3.55),('15087','2013-04-29','10:40:00',3.56),('15087','2013-04-29','10:45:00',3.55),('15087','2013-04-29','10:50:00',3.45),('15087','2013-04-29','10:55:00',3.23),('15087','2013-04-29','11:00:00',3.66),('15087','2013-04-29','11:05:00',3.41),('15087','2013-04-29','11:10:00',3.31),('15087','2013-04-29','11:15:00',3.2),('15087','2013-04-29','11:20:00',3.74),('15087','2013-04-29','11:25:00',3.86),('15087','2013-04-29','11:30:00',4.01),('15087','2013-04-29','11:35:00',3.84),('15087','2013-04-29','11:40:00',3.96),('15087','2013-04-29','11:45:00',3.75),('15087','2013-04-29','11:50:00',4.24),('15087','2013-04-29','11:55:00',4.09),('15087','2013-04-29','12:00:00',4.25),('15087','2013-04-29','12:05:00',4.18),('15087','2013-04-29','12:10:00',4.12),('15087','2013-04-29','12:15:00',4.18),('15087','2013-04-29','12:20:00',4.17),('15087','2013-04-29','12:25:00',4.08),('15087','2013-04-29','12:30:00',4.23),('15087','2013-04-29','12:35:00',4.3),('15087','2013-04-29','12:40:00',4.34),('15087','2013-04-29','12:45:00',4.33),('15087','2013-04-29','12:50:00',4.25),('15087','2013-04-29','12:55:00',4.25),('15087','2013-04-29','13:00:00',4.35),('15087','2013-04-29','13:05:00',4.26),('15087','2013-04-29','13:10:00',4.14),('15087','2013-04-29','13:15:00',3.68),('15087','2013-04-29','13:20:00',4.22),('15087','2013-04-29','13:25:00',4.41),('15087','2013-04-29','13:30:00',4.25),('15087','2013-04-29','13:35:00',4.13),('15087','2013-04-29','13:40:00',4.22),('15087','2013-04-29','13:45:00',4.21),('15087','2013-04-29','13:50:00',4.09),('15087','2013-04-29','13:55:00',4.5),('15087','2013-04-29','14:00:00',4.09),('15087','2013-04-29','14:05:00',4.04),('15087','2013-04-29','14:10:00',4.1),('15087','2013-04-29','14:15:00',4.23),('15087','2013-04-29','14:20:00',4.22),('15087','2013-04-29','14:25:00',3.95),('15087','2013-04-29','14:30:00',3.83),('15087','2013-04-29','14:35:00',3.76),('15087','2013-04-29','14:40:00',3.53),('15087','2013-04-29','14:45:00',3.7),('15087','2013-04-29','14:50:00',3.76),('15087','2013-04-29','14:55:00',3.72),('15087','2013-04-29','15:00:00',3.56),('15087','2013-04-29','15:05:00',3.63),('15087','2013-04-29','15:10:00',3.21),('15087','2013-04-29','15:15:00',3.28),('15087','2013-04-29','15:20:00',3.4),('15087','2013-04-29','15:25:00',3.53),('15087','2013-04-29','15:30:00',3.36),('15087','2013-04-29','15:35:00',3),('15087','2013-04-29','15:40:00',2.76),('15087','2013-04-29','15:45:00',2.69),('15087','2013-04-29','15:50:00',2.76),('15087','2013-04-29','15:55:00',2.9),('15087','2013-04-29','16:00:00',2.86),('15087','2013-04-29','16:05:00',3.01),('15087','2013-04-29','16:10:00',2.89),('15087','2013-04-29','16:15:00',3.32),('15087','2013-04-29','16:20:00',3.04),('15087','2013-04-29','16:25:00',2.53),('15087','2013-04-29','16:30:00',2.52),('15087','2013-04-29','16:35:00',2.51),('15087','2013-04-29','16:40:00',2.69),('15087','2013-04-29','16:45:00',2.66),('15087','2013-04-29','16:50:00',2.71),('15087','2013-04-29','16:55:00',2.76),('15087','2013-04-29','17:00:00',2.55),('15087','2013-04-29','17:05:00',2.17),('15087','2013-04-29','17:10:00',2.24),('15087','2013-04-29','17:15:00',1.84),('15087','2013-04-29','17:20:00',1.51),('15087','2013-04-29','17:25:00',1.44),('15087','2013-04-29','17:30:00',1.44),('15087','2013-04-29','17:35:00',1.34),('15087','2013-04-29','17:40:00',1.15),('15087','2013-04-29','17:45:00',1.07),('15087','2013-04-29','17:50:00',1.34),('15087','2013-04-29','17:55:00',1.49),('15087','2013-04-29','18:00:00',1.42),('15087','2013-04-29','18:05:00',1.52),('15087','2013-04-29','18:10:00',1.35),('15087','2013-04-29','18:15:00',1.26),('15087','2013-04-29','18:20:00',1.05),('15087','2013-04-29','18:25:00',1.02),('15087','2013-04-28','07:45:00',1.03),('15087','2013-04-28','07:50:00',1.12),('15087','2013-04-28','07:55:00',1.2),('15087','2013-04-28','08:00:00',1.27),('15087','2013-04-28','08:05:00',1.39),('15087','2013-04-28','08:10:00',1.51),('15087','2013-04-28','08:15:00',1.6),('15087','2013-04-28','08:20:00',1.69),('15087','2013-04-28','08:25:00',1.84),('15087','2013-04-28','08:30:00',1.92),('15087','2013-04-28','08:35:00',1.99),('15087','2013-04-28','08:40:00',2.07),('15087','2013-04-28','08:45:00',2.18),('15087','2013-04-28','08:50:00',2.29),('15087','2013-04-28','08:55:00',2.37),('15087','2013-04-28','09:00:00',2.45),('15087','2013-04-28','09:05:00',2.53),('15087','2013-04-28','09:10:00',2.63),('15087','2013-04-28','09:15:00',2.71),('15087','2013-04-28','09:20:00',2.8),('15087','2013-04-28','09:25:00',2.86),('15087','2013-04-28','09:30:00',2.94),('15087','2013-04-28','09:35:00',3.01),('15087','2013-04-28','09:40:00',3.1),('15087','2013-04-28','09:45:00',3.18),('15087','2013-04-28','09:50:00',3.26),('15087','2013-04-28','09:55:00',3.32),('15087','2013-04-28','10:00:00',3.39),('15087','2013-04-28','10:05:00',3.43),('15087','2013-04-28','10:10:00',3.48),('15087','2013-04-28','10:15:00',3.55),('15087','2013-04-28','10:20:00',3.61),('15087','2013-04-28','10:25:00',3.74),('15087','2013-04-28','10:30:00',3.64),('15087','2013-04-28','10:35:00',3.8),('15087','2013-04-28','10:40:00',3.46),('15087','2013-04-28','10:45:00',3.93),('15087','2013-04-28','10:50:00',3.96),('15087','2013-04-28','10:55:00',4),('15087','2013-04-28','11:00:00',4.02),('15087','2013-04-28','11:05:00',4.02),('15087','2013-04-28','11:10:00',4.07),('15087','2013-04-28','11:15:00',4.16),('15087','2013-04-28','11:20:00',4.13),('15087','2013-04-28','11:25:00',4.2),('15087','2013-04-28','11:30:00',4.22),('15087','2013-04-28','11:35:00',4.16),('15087','2013-04-28','11:40:00',4.21),('15087','2013-04-28','11:45:00',4.05),('15087','2013-04-28','11:50:00',3.98),('15087','2013-04-28','11:55:00',4.24),('15087','2013-04-28','12:00:00',3.71),('15087','2013-04-28','12:05:00',3.69),('15087','2013-04-28','12:10:00',4.07),('15087','2013-04-28','12:15:00',4.15),('15087','2013-04-28','12:20:00',4.14),('15087','2013-04-28','12:25:00',3.71),('15087','2013-04-28','12:30:00',3.55),('15087','2013-04-28','12:35:00',3.37),('15087','2013-04-28','12:40:00',3.33),('15087','2013-04-28','12:45:00',4.31),('15087','2013-04-28','12:50:00',4.33),('15087','2013-04-28','12:55:00',4.14),('15087','2013-04-28','13:00:00',4.21),('15087','2013-04-28','13:05:00',4.55),('15087','2013-04-28','13:10:00',4.43),('15087','2013-04-28','13:15:00',4.09),('15087','2013-04-28','13:20:00',4.24),('15087','2013-04-28','13:25:00',4.04),('15087','2013-04-28','13:30:00',4.18),('15087','2013-04-28','13:35:00',3.37),('15087','2013-04-28','13:40:00',2.58),('15087','2013-04-28','13:45:00',1.75),('15087','2013-04-28','13:50:00',1.68),('15087','2013-04-28','13:55:00',1.74),('15087','2013-04-28','14:00:00',2.76),('15087','2013-04-28','14:05:00',3.95),('15087','2013-04-28','14:10:00',3.95),('15087','2013-04-28','14:15:00',4.11),('15087','2013-04-28','14:20:00',4.03),('15087','2013-04-28','14:25:00',3.66),('15087','2013-04-28','14:30:00',4),('15087','2013-04-28','14:35:00',4.06),('15087','2013-04-28','14:40:00',3.89),('15087','2013-04-28','14:45:00',3.77),('15087','2013-04-28','14:50:00',3.82),('15087','2013-04-28','14:55:00',3.78),('15087','2013-04-28','15:00:00',3.72),('15087','2013-04-28','15:05:00',3.61),('15087','2013-04-28','15:10:00',3.63),('15087','2013-04-28','15:15:00',3.58),('15087','2013-04-28','15:20:00',3.53),('15087','2013-04-28','15:25:00',3.41),('15087','2013-04-28','15:30:00',3.25),('15087','2013-04-28','15:35:00',3.23),('15087','2013-04-28','15:40:00',3.21),('15087','2013-04-28','15:45:00',3.19),('15087','2013-04-28','15:50:00',3),('15087','2013-04-28','15:55:00',2.99),('15087','2013-04-28','16:00:00',2.89),('15087','2013-04-28','16:05:00',2.77),('15087','2013-04-28','16:10:00',2.85),('15087','2013-04-28','16:15:00',2.82),('15087','2013-04-28','16:20:00',2.58),('15087','2013-04-28','16:25:00',2.66),('15087','2013-04-28','16:30:00',2.69),('15087','2013-04-28','16:35:00',2.59),('15087','2013-04-28','16:40:00',2.49),('15087','2013-04-28','16:45:00',2.46),('15087','2013-04-28','16:50:00',2.31),('15087','2013-04-28','16:55:00',2.21),('15087','2013-04-28','17:00:00',2.17),('15087','2013-04-28','17:05:00',1.97),('15087','2013-04-28','17:10:00',1.88),('15087','2013-04-28','17:15:00',1.93),('15087','2013-04-28','17:20:00',1.84),('15087','2013-04-28','17:25:00',1.73),('15087','2013-04-28','17:30:00',1.43),('15087','2013-04-28','17:35:00',1.39),('15087','2013-04-28','17:40:00',1.37),('15087','2013-04-28','17:45:00',1.42),('15087','2013-04-28','17:50:00',1.34),('15087','2013-04-28','17:55:00',1.17),('15087','2013-04-28','18:00:00',1.15),('15087','2013-04-28','18:05:00',1.07),('15087','2013-04-27','12:50:00',1.07),('15087','2013-04-27','12:55:00',1.45),('15087','2013-04-27','13:00:00',1.57),('15087','2013-04-27','13:05:00',1.11),('15087','2013-04-27','13:10:00',1.22),('15087','2013-04-27','13:15:00',1.66),('15087','2013-04-27','13:20:00',1.74),('15087','2013-04-27','13:25:00',1.2),('15087','2013-04-27','13:30:00',1.33),('15087','2013-04-27','13:35:00',1.7),('15087','2013-04-27','13:40:00',1.89),('15087','2013-04-27','13:45:00',1.23),('15087','2013-04-27','13:50:00',1.17),('15087','2013-04-27','14:25:00',1.37),('15087','2013-04-27','14:30:00',2.39),('15087','2013-04-27','14:35:00',2.01),('15087','2013-04-27','14:40:00',1.39),('15087','2013-04-27','14:45:00',1.2),('15087','2013-04-27','15:00:00',1.11),('15087','2013-04-27','15:05:00',1.92),('15087','2013-04-27','15:10:00',1.43),('15087','2013-04-27','15:15:00',1.03),('15087','2013-04-27','16:40:00',1.06),('15087','2013-04-27','16:45:00',1.45),('15087','2013-04-27','16:50:00',2.09),('15087','2013-04-27','16:55:00',2.19),('15087','2013-04-27','17:00:00',2.49),('15087','2013-04-27','17:05:00',1.6),('15087','2013-04-27','17:20:00',1.15),('15087','2013-04-27','17:40:00',1.23),('15087','2013-04-26','08:05:00',1.03),('15087','2013-04-26','08:10:00',1.24),('15087','2013-04-26','08:15:00',1.37),('15087','2013-04-26','08:20:00',1.45),('15087','2013-04-26','08:25:00',1.53),('15087','2013-04-26','08:30:00',1.62),('15087','2013-04-26','08:35:00',1.8),('15087','2013-04-26','08:40:00',1.86),('15087','2013-04-26','08:45:00',1.96),('15087','2013-04-26','08:50:00',1.6),('15087','2013-04-26','08:55:00',1.44),('15087','2013-04-26','09:00:00',1.5),('15087','2013-04-26','09:05:00',2.15),('15087','2013-04-26','09:10:00',1.81),('15087','2013-04-26','09:15:00',1.24),('15087','2013-04-26','09:20:00',1.25),('15087','2013-04-26','09:25:00',1.95),('15087','2013-04-26','09:30:00',2.1),('15087','2013-04-26','09:35:00',1.84),('15087','2013-04-26','09:40:00',2.01),('15087','2013-04-26','09:45:00',2.48),('15087','2013-04-26','09:50:00',2.99),('15087','2013-04-26','09:55:00',1.84),('15087','2013-04-26','10:00:00',2.94),('15087','2013-04-26','10:05:00',3.37),('15087','2013-04-26','10:10:00',3.4),('15087','2013-04-26','10:15:00',3.5),('15087','2013-04-26','10:20:00',3.32),('15087','2013-04-26','10:25:00',3.36),('15087','2013-04-26','10:30:00',3.53),('15087','2013-04-26','10:35:00',3.78),('15087','2013-04-26','10:40:00',3.61),('15087','2013-04-26','10:45:00',3.72),('15087','2013-04-26','10:50:00',2.69),('15087','2013-04-26','10:55:00',1.94),('15087','2013-04-26','11:00:00',3.64),('15087','2013-04-26','11:05:00',3.76),('15087','2013-04-26','11:10:00',3.66),('15087','2013-04-26','11:15:00',3.26),('15087','2013-04-26','11:20:00',2.69),('15087','2013-04-26','11:25:00',3.44),('15087','2013-04-26','11:30:00',3.46),('15087','2013-04-26','11:35:00',3.95),('15087','2013-04-26','11:40:00',3.22),('15087','2013-04-26','11:45:00',3.67),('15087','2013-04-26','11:50:00',2.8),('15087','2013-04-26','11:55:00',2.67),('15087','2013-04-26','12:00:00',3.37),('15087','2013-04-26','12:05:00',2.8),('15087','2013-04-26','12:10:00',2.75),('15087','2013-04-26','12:15:00',3.07),('15087','2013-04-26','12:20:00',3.13),('15087','2013-04-26','12:25:00',1.91),('15087','2013-04-26','12:30:00',1.87),('15087','2013-04-26','12:35:00',2.67),('15087','2013-04-26','12:40:00',3.42),('15087','2013-04-26','12:45:00',3.16),('15087','2013-04-26','12:50:00',2.28),('15087','2013-04-26','12:55:00',2.03),('15087','2013-04-26','13:00:00',1.39),('15087','2013-04-26','13:05:00',1.35),('15087','2013-04-26','13:10:00',1.73),('15087','2013-04-26','13:15:00',2.85),('15087','2013-04-26','13:20:00',1.89),('15087','2013-04-26','13:25:00',2.33),('15087','2013-04-26','13:30:00',3.47),('15087','2013-04-26','13:35:00',2.63),('15087','2013-04-26','13:40:00',3.13),('15087','2013-04-26','13:45:00',2.53),('15087','2013-04-26','13:50:00',3.44),('15087','2013-04-26','13:55:00',3.08),('15087','2013-04-26','14:00:00',3.34),('15087','2013-04-26','14:05:00',3.81),('15087','2013-04-26','14:10:00',3.41),('15087','2013-04-26','14:15:00',3.48),('15087','2013-04-26','14:20:00',3.8),('15087','2013-04-26','14:25:00',4.16),('15087','2013-04-26','14:30:00',4.12),('15087','2013-04-26','14:35:00',2.78),('15087','2013-04-26','14:40:00',1.82),('15087','2013-04-26','14:45:00',1.61),('15087','2013-04-26','14:50:00',3.99),('15087','2013-04-26','14:55:00',4.03),('15087','2013-04-26','15:00:00',3.78),('15087','2013-04-26','15:05:00',2.26),('15087','2013-04-26','15:10:00',1.63),('15087','2013-04-26','15:15:00',2.21),('15087','2013-04-26','15:20:00',1.51),('15087','2013-04-26','15:25:00',1.71),('15087','2013-04-26','15:30:00',2.56),('15087','2013-04-26','15:35:00',1.98),('15087','2013-04-26','15:40:00',2.19),('15087','2013-04-26','15:45:00',2.65),('15087','2013-04-26','15:50:00',2.01),('15087','2013-04-26','15:55:00',1.1),('15087','2013-04-25','08:05:00',1.09),('15087','2013-04-25','08:10:00',1.12),('15087','2013-04-25','08:15:00',1.52),('15087','2013-04-25','08:20:00',1.12),('15087','2013-04-25','08:30:00',1.02),('15087','2013-04-25','08:35:00',1.06),('15087','2013-04-25','08:40:00',1.13),('15087','2013-04-25','08:45:00',1.59),('15087','2013-04-25','08:50:00',2.43),('15087','2013-04-25','08:55:00',2.58),('15087','2013-04-25','09:00:00',2.03),('15087','2013-04-25','09:05:00',1.47),('15087','2013-04-25','09:10:00',1.46),('15087','2013-04-25','09:15:00',1.29),('15087','2013-04-25','09:20:00',1.45),('15087','2013-04-25','09:25:00',1.6),('15087','2013-04-25','09:30:00',1.49),('15087','2013-04-25','09:35:00',1.74),('15087','2013-04-25','09:40:00',2.44),('15087','2013-04-25','09:45:00',3.01),('15087','2013-04-25','09:50:00',3.35),('15087','2013-04-25','09:55:00',3.39),('15087','2013-04-25','10:00:00',3.4),('15087','2013-04-25','10:05:00',3.2),('15087','2013-04-25','10:10:00',2.94),('15087','2013-04-25','10:15:00',3.22),('15087','2013-04-25','10:20:00',3.47),('15087','2013-04-25','10:25:00',3.64),('15087','2013-04-25','10:30:00',3.78),('15087','2013-04-25','10:35:00',3.82),('15087','2013-04-25','10:40:00',3.81),('15087','2013-04-25','10:45:00',3.72),('15087','2013-04-25','10:50:00',3.93),('15087','2013-04-25','10:55:00',3.84),('15087','2013-04-25','11:00:00',4.05),('15087','2013-04-25','11:05:00',4.07),('15087','2013-04-25','11:10:00',4.12),('15087','2013-04-25','11:15:00',4.14),('15087','2013-04-25','11:20:00',4.22),('15087','2013-04-25','11:25:00',4.26),('15087','2013-04-25','11:30:00',4.28),('15087','2013-04-25','11:35:00',4.23),('15087','2013-04-25','11:40:00',4.36),('15087','2013-04-25','11:45:00',4.39),('15087','2013-04-25','11:50:00',4.45),('15087','2013-04-25','11:55:00',4.39),('15087','2013-04-25','12:00:00',4.32),('15087','2013-04-25','12:05:00',4.35),('15087','2013-04-25','12:10:00',4.44),('15087','2013-04-25','12:15:00',4.47),('15087','2013-04-25','12:20:00',4.44),('15087','2013-04-25','12:25:00',4.45),('15087','2013-04-25','12:30:00',4.48),('15087','2013-04-25','12:35:00',4.48),('15087','2013-04-25','12:40:00',4.48),('15087','2013-04-25','12:45:00',4.48),('15087','2013-04-25','12:50:00',4.47),('15087','2013-04-25','12:55:00',4.49),('15087','2013-04-25','13:00:00',4.55),('15087','2013-04-25','13:05:00',4.63),('15087','2013-04-25','13:10:00',4.51),('15087','2013-04-25','13:15:00',4.49),('15087','2013-04-25','13:20:00',4.11),('15087','2013-04-25','13:25:00',3.68),('15087','2013-04-25','13:30:00',2.89),('15087','2013-04-25','13:35:00',2.86),('15087','2013-04-25','13:40:00',2.6),('15087','2013-04-25','13:45:00',2.44),('15087','2013-04-25','13:50:00',2.33),('15087','2013-04-25','13:55:00',2.51),('15087','2013-04-25','14:00:00',2.58),('15087','2013-04-25','14:05:00',2.38),('15087','2013-04-25','14:10:00',2.57),('15087','2013-04-25','14:15:00',2.77),('15087','2013-04-25','14:20:00',2.81),('15087','2013-04-25','14:25:00',2.89),('15087','2013-04-25','14:30:00',3.43),('15087','2013-04-25','14:35:00',3.94),('15087','2013-04-25','14:40:00',3.68),('15087','2013-04-25','14:45:00',3.69),('15087','2013-04-25','14:50:00',3.36),('15087','2013-04-25','14:55:00',3.5),('15087','2013-04-25','15:00:00',3.29),('15087','2013-04-25','15:05:00',2.96),('15087','2013-04-25','15:10:00',3.02),('15087','2013-04-25','15:15:00',3.35),('15087','2013-04-25','15:20:00',3.56),('15087','2013-04-25','15:25:00',3.57),('15087','2013-04-25','15:30:00',3.48),('15087','2013-04-25','15:35:00',3.34),('15087','2013-04-25','15:40:00',3.06),('15087','2013-04-25','15:45:00',2.95),('15087','2013-04-25','15:50:00',2.76),('15087','2013-04-25','15:55:00',2.71),('15087','2013-04-25','16:00:00',2.73),('15087','2013-04-25','16:05:00',2.35),('15087','2013-04-25','16:10:00',2.34),('15087','2013-04-25','16:15:00',2.29),('15087','2013-04-25','16:20:00',2.44),('15087','2013-04-25','16:25:00',2.11),('15087','2013-04-25','16:30:00',2.03),('15087','2013-04-25','16:35:00',2.4),('15087','2013-04-25','16:40:00',2.15),('15087','2013-04-25','16:45:00',2.19),('15087','2013-04-25','16:50:00',1.85),('15087','2013-04-25','16:55:00',1.99),('15087','2013-04-25','17:00:00',1.88),('15087','2013-04-25','17:05:00',2.25),('15087','2013-04-25','17:10:00',2.32),('15087','2013-04-25','17:15:00',2.15),('15087','2013-04-25','17:20:00',2.15),('15087','2013-04-25','17:25:00',1.77),('15087','2013-04-25','17:30:00',1.44),('15087','2013-04-25','17:35:00',1.37),('15087','2013-04-25','17:40:00',1.38),('15087','2013-04-25','17:45:00',1.19),('15087','2013-04-24','07:55:00',1.08),('15087','2013-04-24','08:00:00',1.14),('15087','2013-04-24','08:05:00',1.22),('15087','2013-04-24','08:10:00',1.43),('15087','2013-04-24','08:15:00',1.65),('15087','2013-04-24','08:20:00',1.7),('15087','2013-04-24','08:25:00',1.86),('15087','2013-04-24','08:30:00',1.83),('15087','2013-04-24','08:35:00',1.77),('15087','2013-04-24','08:40:00',1.85),('15087','2013-04-24','08:45:00',1.9),('15087','2013-04-24','08:50:00',2.03),('15087','2013-04-24','08:55:00',2.13),('15087','2013-04-24','09:00:00',2.37),('15087','2013-04-24','09:05:00',2.63),('15087','2013-04-24','09:10:00',2.76),('15087','2013-04-24','09:15:00',2.31),('15087','2013-04-24','09:20:00',2.05),('15087','2013-04-24','09:25:00',2.79),('15087','2013-04-24','09:30:00',2.81),('15087','2013-04-24','09:35:00',3.1),('15087','2013-04-24','09:40:00',2.89),('15087','2013-04-24','09:45:00',2.9),('15087','2013-04-24','09:50:00',3.02),('15087','2013-04-24','09:55:00',3.38),('15087','2013-04-24','10:00:00',3.54),('15087','2013-04-24','10:05:00',3.63),('15087','2013-04-24','10:10:00',3.67),('15087','2013-04-24','10:15:00',3.63),('15087','2013-04-24','10:20:00',3.59),('15087','2013-04-24','10:25:00',3.56),('15087','2013-04-24','10:30:00',3.51),('15087','2013-04-24','10:35:00',3.53),('15087','2013-04-24','10:40:00',3.92),('15087','2013-04-24','10:45:00',3.95),('15087','2013-04-24','10:50:00',4.01),('15087','2013-04-24','10:55:00',4.14),('15087','2013-04-24','11:00:00',4.13),('15087','2013-04-24','11:05:00',4.01),('15087','2013-04-24','11:10:00',4.4),('15087','2013-04-24','11:15:00',4.43),('15087','2013-04-24','11:20:00',4.57),('15087','2013-04-24','11:25:00',4.56),('15087','2013-04-24','11:30:00',4.4),('15087','2013-04-24','11:35:00',4),('15087','2013-04-24','11:40:00',3.21),('15087','2013-04-24','11:45:00',2.98),('15087','2013-04-24','11:50:00',2.24),('15087','2013-04-24','11:55:00',3.37),('15087','2013-04-24','12:00:00',3.69),('15087','2013-04-24','12:05:00',2.63),('15087','2013-04-24','12:10:00',3.24),('15087','2013-04-24','12:15:00',4.37),('15087','2013-04-24','12:20:00',5),('15087','2013-04-24','12:25:00',4.25),('15087','2013-04-24','12:30:00',4.24),('15087','2013-04-24','12:35:00',4.38),('15087','2013-04-24','12:40:00',4.16),('15087','2013-04-24','12:45:00',4.29),('15087','2013-04-24','12:50:00',4.55),('15087','2013-04-24','12:55:00',4.42),('15087','2013-04-24','13:00:00',4.29),('15087','2013-04-24','13:05:00',3.81),('15087','2013-04-24','13:10:00',4.91),('15087','2013-04-24','13:15:00',4.51),('15087','2013-04-24','13:20:00',4.27),('15087','2013-04-24','13:25:00',4.48),('15087','2013-04-24','13:30:00',4.04),('15087','2013-04-24','13:35:00',4.41),('15087','2013-04-24','13:40:00',4.83),('15087','2013-04-24','13:45:00',3.97),('15087','2013-04-24','13:50:00',3.11),('15087','2013-04-24','13:55:00',4.64),('15087','2013-04-24','14:00:00',4.42),('15087','2013-04-24','14:05:00',3.18),('15087','2013-04-24','14:10:00',3.33),('15087','2013-04-24','14:15:00',4.4),('15087','2013-04-24','14:20:00',4.07),('15087','2013-04-24','14:25:00',4.17),('15087','2013-04-24','14:30:00',3.88),('15087','2013-04-24','14:35:00',3.53),('15087','2013-04-24','14:40:00',3.28),('15087','2013-04-24','14:45:00',3.19),('15087','2013-04-24','14:50:00',2.89),('15087','2013-04-24','14:55:00',2.57),('15087','2013-04-24','15:00:00',2.8),('15087','2013-04-24','15:05:00',2.58),('15087','2013-04-24','15:10:00',2.39),('15087','2013-04-24','15:15:00',2.55),('15087','2013-04-24','15:20:00',2.73),('15087','2013-04-24','15:25:00',2.25),('15087','2013-04-24','15:30:00',1.95),('15087','2013-04-24','15:35:00',1.85),('15087','2013-04-24','15:40:00',1.87),('15087','2013-04-24','15:45:00',1.87),('15087','2013-04-24','15:50:00',1.91),('15087','2013-04-24','15:55:00',2.43),('15087','2013-04-24','16:00:00',2.88),('15087','2013-04-24','16:05:00',2.96),('15087','2013-04-24','16:10:00',2.87),('15087','2013-04-24','16:15:00',2.75),('15087','2013-04-24','16:20:00',3.34),('15087','2013-04-24','16:25:00',2.6),('15087','2013-04-24','16:30:00',2.2),('15087','2013-04-24','16:35:00',1.98),('15087','2013-04-24','16:40:00',2.49),('15087','2013-04-24','16:45:00',2.51),('15087','2013-04-24','16:50:00',2.33),('15087','2013-04-24','16:55:00',2.75),('15087','2013-04-24','17:00:00',2.69),('15087','2013-04-24','17:05:00',2.55),('15087','2013-04-24','17:10:00',2.41),('15087','2013-04-24','17:15:00',1.72),('15087','2013-04-24','17:20:00',1.75),('15087','2013-04-24','17:25:00',1.49),('15087','2013-04-24','17:50:00',1.1),('15087','2013-04-24','17:55:00',1.44),('15087','2013-04-24','18:00:00',1.1),('15087','2013-04-24','18:05:00',1.16),('15087','2013-04-23','07:45:00',1.02),('15087','2013-04-23','07:50:00',1.12),('15087','2013-04-23','07:55:00',1.22),('15087','2013-04-23','08:00:00',1.34),('15087','2013-04-23','08:05:00',1.49),('15087','2013-04-23','08:10:00',1.61),('15087','2013-04-23','08:15:00',1.71),('15087','2013-04-23','08:20:00',1.82),('15087','2013-04-23','08:25:00',1.92),('15087','2013-04-23','08:30:00',2.01),('15087','2013-04-23','08:35:00',2.1),('15087','2013-04-23','08:40:00',2.2),('15087','2013-04-23','08:45:00',2.28),('15087','2013-04-23','08:50:00',2.39),('15087','2013-04-23','08:55:00',2.5),('15087','2013-04-23','09:00:00',2.57),('15087','2013-04-23','09:05:00',2.66),('15087','2013-04-23','09:10:00',2.75),('15087','2013-04-23','09:15:00',2.87),('15087','2013-04-23','09:20:00',2.96),('15087','2013-04-23','09:25:00',3.04),('15087','2013-04-23','09:30:00',3.12),('15087','2013-04-23','09:35:00',3.2),('15087','2013-04-23','09:40:00',2.93),('15087','2013-04-23','09:45:00',2.98),('15087','2013-04-23','09:50:00',3.49),('15087','2013-04-23','09:55:00',3.53),('15087','2013-04-23','10:00:00',3.56),('15087','2013-04-23','10:05:00',3.65),('15087','2013-04-23','10:10:00',3.71),('15087','2013-04-23','10:15:00',3.74),('15087','2013-04-23','10:20:00',3.78),('15087','2013-04-23','10:25:00',3.83),('15087','2013-04-23','10:30:00',3.9),('15087','2013-04-23','10:35:00',3.99),('15087','2013-04-23','10:40:00',4.04),('15087','2013-04-23','10:45:00',4),('15087','2013-04-23','10:50:00',4.15),('15087','2013-04-23','10:55:00',4.23),('15087','2013-04-23','11:00:00',4.26),('15087','2013-04-23','11:05:00',4.25),('15087','2013-04-23','11:10:00',4.3),('15087','2013-04-23','11:15:00',4.33),('15087','2013-04-23','11:20:00',4.39),('15087','2013-04-23','11:25:00',4.42),('15087','2013-04-23','11:30:00',4.42),('15087','2013-04-23','11:35:00',4.43),('15087','2013-04-23','11:40:00',4.49),('15087','2013-04-23','11:45:00',4.48),('15087','2013-04-23','11:50:00',4.46),('15087','2013-04-23','11:55:00',4.48),('15087','2013-04-23','12:00:00',4.53),('15087','2013-04-23','12:05:00',4.58),('15087','2013-04-23','12:10:00',4.58),('15087','2013-04-23','12:15:00',4.55),('15087','2013-04-23','12:20:00',4.58),('15087','2013-04-23','12:25:00',4.66),('15087','2013-04-23','12:30:00',4.83),('15087','2013-04-23','12:35:00',5.07),('15087','2013-04-23','12:40:00',5.09),('15087','2013-04-23','12:45:00',4.19),('15087','2013-04-23','12:50:00',2.14),('15087','2013-04-23','12:55:00',4.63),('15087','2013-04-23','13:00:00',5.19),('15087','2013-04-23','13:05:00',4.93),('15087','2013-04-23','13:10:00',2.65),('15087','2013-04-23','13:15:00',3.94),('15087','2013-04-23','13:20:00',4.87),('15087','2013-04-23','13:25:00',4.95),('15087','2013-04-23','13:30:00',4.84),('15087','2013-04-23','13:35:00',4.94),('15087','2013-04-23','13:40:00',4.87),('15087','2013-04-23','13:45:00',3.43),('15087','2013-04-23','13:50:00',4.42),('15087','2013-04-23','13:55:00',4.74),('15087','2013-04-23','14:00:00',4.55),('15087','2013-04-23','14:05:00',4.81),('15087','2013-04-23','14:10:00',4.32),('15087','2013-04-23','14:15:00',4.22),('15087','2013-04-23','14:20:00',4.12),('15087','2013-04-23','14:25:00',3.75),('15087','2013-04-23','14:30:00',4.43),('15087','2013-04-23','14:35:00',4.12),('15087','2013-04-23','14:40:00',4.25),('15087','2013-04-23','14:45:00',3.61),('15087','2013-04-23','14:50:00',2.34),('15087','2013-04-23','14:55:00',2.52),('15087','2013-04-23','15:00:00',2.62),('15087','2013-04-23','15:05:00',2.8),('15087','2013-04-23','15:10:00',3.33),('15087','2013-04-23','15:15:00',3.23),('15087','2013-04-23','15:20:00',2.98),('15087','2013-04-23','15:25:00',2.71),('15087','2013-04-23','15:30:00',2.71),('15087','2013-04-23','15:35:00',2.58),('15087','2013-04-23','15:40:00',2.35),('15087','2013-04-23','15:45:00',2.79),('15087','2013-04-23','15:50:00',2.12),('15087','2013-04-23','15:55:00',2.01),('15087','2013-04-23','16:00:00',2.37),('15087','2013-04-23','16:05:00',2.69),('15087','2013-04-23','16:10:00',2.66),('15087','2013-04-23','16:15:00',2.27),('15087','2013-04-23','16:20:00',1.45),('15087','2013-04-23','16:25:00',1.41),('15087','2013-04-23','16:30:00',1.21),('15087','2013-04-23','16:35:00',1.15),('15087','2013-04-23','16:40:00',1.13),('15087','2013-04-23','16:45:00',1.15),('15087','2013-04-23','16:50:00',1.03),('15087','2013-04-23','16:55:00',1.07),('15087','2013-04-23','17:00:00',1.13),('15087','2013-04-23','17:05:00',1.19),('15087','2013-04-23','17:10:00',1.69),('15087','2013-04-23','17:15:00',1.27),('15087','2013-04-23','17:25:00',1.72),('15087','2013-04-23','17:30:00',1.48),('15087','2013-04-23','17:35:00',1.06),('15087','2013-04-22','09:30:00',1.26),('15087','2013-04-22','09:35:00',1.07),('15087','2013-04-22','10:35:00',2.28),('15087','2013-04-22','10:40:00',3.85),('15087','2013-04-22','10:45:00',5.02),('15087','2013-04-22','10:50:00',2.66),('15087','2013-04-22','10:55:00',2.62),('15087','2013-04-22','11:00:00',2.21),('15087','2013-04-22','11:05:00',1.96),('15087','2013-04-22','11:10:00',2.43),('15087','2013-04-22','11:15:00',1.53),('15087','2013-04-22','11:20:00',1.64),('15087','2013-04-22','11:25:00',2),('15087','2013-04-22','11:30:00',3.39),('15087','2013-04-22','11:35:00',4.93),('15087','2013-04-22','11:40:00',4),('15087','2013-04-22','11:45:00',2.72),('15087','2013-04-22','11:50:00',1.9),('15087','2013-04-22','11:55:00',3.78),('15087','2013-04-22','12:00:00',3.74),('15087','2013-04-22','12:05:00',4.05),('15087','2013-04-22','12:10:00',3.19),('15087','2013-04-22','12:15:00',2.64),('15087','2013-04-22','12:20:00',2.49),('15087','2013-04-22','12:25:00',2.14),('15087','2013-04-22','12:30:00',2.45),('15087','2013-04-22','12:35:00',2.3),('15087','2013-04-22','12:40:00',4.15),('15087','2013-04-22','12:45:00',3.81),('15087','2013-04-22','12:50:00',5.16),('15087','2013-04-22','12:55:00',5.18),('15087','2013-04-22','13:00:00',4.56),('15087','2013-04-22','13:05:00',4.5),('15087','2013-04-22','13:10:00',3.29),('15087','2013-04-22','13:15:00',4.52),('15087','2013-04-22','13:20:00',5.26),('15087','2013-04-22','13:25:00',2.26),('15087','2013-04-22','13:30:00',1.79),('15087','2013-04-22','13:35:00',2.24),('15087','2013-04-22','13:40:00',2.18),('15087','2013-04-22','13:45:00',1.67),('15087','2013-04-22','13:50:00',1.18),('15087','2013-04-22','13:55:00',2.68),('15087','2013-04-22','14:00:00',1.5),('15087','2013-04-22','14:05:00',2.19),('15087','2013-04-22','14:10:00',2.71),('15087','2013-04-22','14:15:00',4.57),('15087','2013-04-22','14:20:00',4.95),('15087','2013-04-22','14:25:00',3.08),('15087','2013-04-22','14:30:00',2.65),('15087','2013-04-22','14:35:00',3.27),('15087','2013-04-22','14:40:00',4.76),('15087','2013-04-22','14:45:00',3.91),('15087','2013-04-22','14:50:00',4.61),('15087','2013-04-22','14:55:00',3.89),('15087','2013-04-22','15:00:00',1.04),('15087','2013-04-22','15:05:00',1.56),('15087','2013-04-22','15:10:00',1.26),('15087','2013-04-22','15:15:00',1.18),('15087','2013-04-22','15:20:00',2.79),('15087','2013-04-22','15:25:00',4.08),('15087','2013-04-22','15:30:00',1.79),('15087','2013-04-22','15:35:00',2.26),('15087','2013-04-22','15:40:00',3.25),('15087','2013-04-22','15:45:00',4.15),('15087','2013-04-22','15:50:00',2.38),('15087','2013-04-22','15:55:00',1.34),('15087','2013-04-22','16:45:00',1.14),('15087','2013-04-22','16:50:00',1.09),('15087','2014-03-29','07:25:00',1.05),('15087','2014-03-29','07:30:00',1.15),('15087','2014-03-29','07:35:00',1.25),('15087','2014-03-29','07:40:00',1.37),('15087','2014-03-29','07:45:00',1.53),('15087','2014-03-29','07:50:00',1.64),('15087','2014-03-29','07:55:00',1.73),('15087','2014-03-29','08:00:00',1.84),('15087','2014-03-29','08:05:00',1.95),('15087','2014-03-29','08:10:00',2.06),('15087','2014-03-29','08:15:00',2.15),('15087','2014-03-29','08:20:00',2.22),('15087','2014-03-29','08:25:00',2.34),('15087','2014-03-29','08:30:00',2.41),('15087','2014-03-29','08:35:00',2.5),('15087','2014-03-29','08:40:00',2.58),('15087','2014-03-29','08:45:00',2.65),('15087','2014-03-29','08:50:00',2.73),('15087','2014-03-29','08:55:00',2.8),('15087','2014-03-29','09:00:00',2.85),('15087','2014-03-29','09:05:00',2.93),('15087','2014-03-29','09:10:00',3.02),('15087','2014-03-29','09:15:00',3.12),('15087','2014-03-29','09:20:00',3.21),('15087','2014-03-29','09:25:00',3.28),('15087','2014-03-29','09:30:00',3.34),('15087','2014-03-29','09:35:00',3.37),('15087','2014-03-29','09:40:00',3.48),('15087','2014-03-29','09:45:00',3.52),('15087','2014-03-29','09:50:00',3.6),('15087','2014-03-29','09:55:00',3.68),('15087','2014-03-29','10:00:00',3.73),('15087','2014-03-29','10:05:00',3.77),('15087','2014-03-29','10:10:00',3.87),('15087','2014-03-29','10:15:00',3.97),('15087','2014-03-29','10:20:00',3.98),('15087','2014-03-29','10:25:00',4.03),('15087','2014-03-29','10:30:00',4.06),('15087','2014-03-29','10:35:00',4.05),('15087','2014-03-29','10:40:00',4.11),('15087','2014-03-29','10:45:00',4.13),('15087','2014-03-29','10:50:00',4.2),('15087','2014-03-29','10:55:00',4.25),('15087','2014-03-29','11:00:00',4.28),('15087','2014-03-29','11:05:00',4.28),('15087','2014-03-29','11:10:00',4.3),('15087','2014-03-29','11:15:00',4.34),('15087','2014-03-29','11:20:00',4.36),('15087','2014-03-29','11:25:00',4.37),('15087','2014-03-29','11:30:00',4.36),('15087','2014-03-29','11:35:00',4.37),('15087','2014-03-29','11:40:00',4.26),('15087','2014-03-29','11:45:00',4.47),('15087','2014-03-29','11:50:00',4.46),('15087','2014-03-29','11:55:00',4.44),('15087','2014-03-29','12:00:00',4.43),('15087','2014-03-29','12:05:00',4.45),('15087','2014-03-29','12:10:00',4.43),('15087','2014-03-29','12:15:00',4.44),('15087','2014-03-29','12:20:00',4.46),('15087','2014-03-29','12:25:00',4.48),('15087','2014-03-29','12:30:00',4.47),('15087','2014-03-29','12:35:00',4.45),('15087','2014-03-29','12:40:00',4.41),('15087','2014-03-29','12:45:00',4.43),('15087','2014-03-29','12:50:00',4.43),('15087','2014-03-29','12:55:00',4.34),('15087','2014-03-29','13:00:00',4.09),('15087','2014-03-29','13:05:00',4.08),('15087','2014-03-29','13:10:00',4.22),('15087','2014-03-29','13:15:00',4.17),('15087','2014-03-29','13:20:00',4),('15087','2014-03-29','13:25:00',3.98),('15087','2014-03-29','13:30:00',4.03),('15087','2014-03-29','13:35:00',3.89),('15087','2014-03-29','13:40:00',3.85),('15087','2014-03-29','13:45:00',3.8),('15087','2014-03-29','13:50:00',3.73),('15087','2014-03-29','13:55:00',3.67),('15087','2014-03-29','14:00:00',3.56),('15087','2014-03-29','14:05:00',3.57),('15087','2014-03-29','14:10:00',3.43),('15087','2014-03-29','14:15:00',3.43),('15087','2014-03-29','14:20:00',3.31),('15087','2014-03-29','14:25:00',3.25),('15087','2014-03-29','14:30:00',3.03),('15087','2014-03-29','14:35:00',2.72),('15087','2014-03-29','14:40:00',2.21),('15087','2014-03-29','14:45:00',3.06),('15087','2014-03-29','14:50:00',3),('15087','2014-03-29','14:55:00',2.95),('15087','2014-03-29','15:00:00',2.8),('15087','2014-03-29','15:05:00',2.59),('15087','2014-03-29','15:10:00',2.64),('15087','2014-03-29','15:15:00',2.64),('15087','2014-03-29','15:20:00',2.5),('15087','2014-03-29','15:25:00',2.39),('15087','2014-03-29','15:30:00',2.32),('15087','2014-03-29','15:35:00',2.19),('15087','2014-03-29','15:40:00',2.2),('15087','2014-03-29','15:45:00',2.17),('15087','2014-03-29','15:50:00',2.02),('15087','2014-03-29','15:55:00',1.98),('15087','2014-03-29','16:00:00',1.95),('15087','2014-03-29','16:05:00',1.82),('15087','2014-03-29','16:10:00',1.71),('15087','2014-03-29','16:15:00',1.58),('15087','2014-03-29','16:20:00',1.4),('15087','2014-03-29','16:25:00',1.39),('15087','2014-03-29','16:30:00',1.32),('15087','2014-03-29','16:35:00',1.19),('15087','2013-04-21','08:05:00',1.07),('15087','2013-04-21','08:10:00',1.02),('15087','2013-04-21','08:15:00',1.16),('15087','2013-04-21','08:20:00',1.09),('15087','2013-04-21','08:25:00',1.29),('15087','2013-04-21','08:30:00',1.58),('15087','2013-04-21','08:35:00',1.51),('15087','2013-04-21','08:40:00',1.44),('15087','2013-04-21','08:45:00',1.1),('15087','2013-04-21','08:50:00',1.24),('15087','2013-04-21','08:55:00',1.85),('15087','2013-04-21','09:00:00',2.13),('15087','2013-04-21','09:05:00',2.7),('15087','2013-04-21','09:10:00',2.03),('15087','2013-04-21','09:15:00',1.52),('15087','2013-04-21','09:20:00',1.52),('15087','2013-04-21','09:25:00',2.43),('15087','2013-04-21','09:30:00',3.13),('15087','2013-04-21','09:35:00',3.21),('15087','2013-04-21','09:40:00',3.19),('15087','2013-04-21','09:45:00',3.53),('15087','2013-04-21','09:50:00',3.52),('15087','2013-04-21','09:55:00',3.96),('15087','2013-04-21','10:00:00',2.83),('15087','2013-04-21','10:05:00',2.14),('15087','2013-04-21','10:10:00',1.88),('15087','2013-04-21','10:15:00',1.75),('15087','2013-04-21','10:20:00',4.18),('15087','2013-04-21','10:25:00',2.3),('15087','2013-04-21','10:30:00',2.12),('15087','2013-04-21','10:35:00',1.88),('15087','2013-04-21','10:40:00',2.53),('15087','2013-04-21','10:45:00',2.68),('15087','2013-04-21','10:50:00',2.54),('15087','2013-04-21','10:55:00',2.47),('15087','2013-04-21','11:00:00',4.08),('15087','2013-04-21','11:05:00',3.17),('15087','2013-04-21','11:10:00',3.9),('15087','2013-04-21','11:15:00',3.33),('15087','2013-04-21','11:20:00',3.3),('15087','2013-04-21','11:25:00',2.96),('15087','2013-04-21','11:30:00',2.84),('15087','2013-04-21','11:35:00',2.91),('15087','2013-04-21','11:40:00',3.14),('15087','2013-04-21','11:45:00',3.8),('15087','2013-04-21','11:50:00',3.28),('15087','2013-04-21','11:55:00',3.63),('15087','2013-04-21','12:00:00',2.61),('15087','2013-04-21','12:05:00',2.63),('15087','2013-04-21','12:10:00',2.44),('15087','2013-04-21','12:15:00',2.31),('15087','2013-04-21','12:20:00',2.06),('15087','2013-04-21','12:25:00',2.04),('15087','2013-04-21','12:30:00',2.21),('15087','2013-04-21','12:35:00',2.28),('15087','2013-04-21','12:40:00',2.28),('15087','2013-04-21','12:45:00',2.3),('15087','2013-04-21','12:50:00',2.19),('15087','2013-04-21','12:55:00',2.1),('15087','2013-04-21','13:00:00',2.46),('15087','2013-04-21','13:05:00',2.84),('15087','2013-04-21','13:10:00',2.76),('15087','2013-04-21','13:15:00',2.54),('15087','2013-04-21','13:20:00',2.4),('15087','2013-04-21','13:25:00',2.39),('15087','2013-04-21','13:30:00',3.44),('15087','2013-04-21','13:35:00',4.29),('15087','2013-04-21','13:40:00',3.31),('15087','2013-04-21','13:45:00',3.64),('15087','2013-04-21','13:50:00',3.33),('15087','2013-04-21','13:55:00',3.94),('15087','2013-04-21','14:00:00',4.17),('15087','2013-04-21','14:05:00',4.89),('15087','2013-04-21','14:10:00',4.3),('15087','2013-04-21','14:15:00',4.77),('15087','2013-04-21','14:20:00',4.85),('15087','2013-04-21','14:25:00',4.53),('15087','2013-04-21','14:30:00',3.9),('15087','2013-04-21','14:35:00',4.74),('15087','2013-04-21','14:40:00',4.55),('15087','2013-04-21','14:45:00',3.58),('15087','2013-04-21','14:50:00',2.31),('15087','2013-04-21','14:55:00',2.24),('15087','2013-04-21','15:00:00',2.05),('15087','2013-04-21','15:05:00',3.42),('15087','2013-04-21','15:10:00',3.94),('15087','2013-04-21','15:15:00',2.72),('15087','2013-04-21','15:20:00',1.76),('15087','2013-04-21','15:25:00',1.93),('15087','2013-04-21','15:30:00',1.69),('15087','2013-04-21','15:35:00',1.44),('15087','2013-04-21','15:40:00',1.51),('15087','2013-04-21','15:45:00',1.22),('15087','2013-04-20','07:55:00',1.02),('15087','2013-04-20','08:00:00',1.14),('15087','2013-04-20','08:05:00',1.25),('15087','2013-04-20','08:10:00',1.34),('15087','2013-04-20','08:15:00',1.16),('15087','2013-04-20','08:20:00',1.18),('15087','2013-04-20','08:25:00',1.25),('15087','2013-04-20','08:30:00',1.46),('15087','2013-04-20','08:35:00',1.62),('15087','2013-04-20','08:40:00',1.85),('15087','2013-04-20','08:45:00',1.91),('15087','2013-04-20','08:50:00',1.95),('15087','2013-04-20','08:55:00',1.96),('15087','2013-04-20','09:00:00',2.26),('15087','2013-04-20','09:05:00',2.32),('15087','2013-04-20','09:10:00',2.2),('15087','2013-04-20','09:15:00',2.37),('15087','2013-04-20','09:20:00',2.78),('15087','2013-04-20','09:25:00',2.39),('15087','2013-04-20','09:30:00',2.39),('15087','2013-04-20','09:35:00',1.6),('15087','2013-04-20','09:45:00',1.04),('15087','2013-04-20','10:40:00',1.52),('15087','2013-04-20','10:45:00',2.76),('15087','2013-04-20','10:50:00',3.41),('15087','2013-04-20','10:55:00',3.74),('15087','2013-04-20','11:00:00',3.56),('15087','2013-04-20','11:05:00',2.88),('15087','2013-04-20','11:10:00',4.39),('15087','2013-04-20','11:15:00',4.59),('15087','2013-04-20','11:20:00',3.22),('15087','2013-04-20','11:25:00',4.75),('15087','2013-04-20','11:30:00',3.11),('15087','2013-04-20','11:35:00',1.94),('15087','2013-04-20','11:40:00',2.34),('15087','2013-04-20','11:45:00',2.27),('15087','2013-04-20','11:50:00',4.35),('15087','2013-04-20','11:55:00',4.9),('15087','2013-04-20','12:00:00',4.57),('15087','2013-04-20','12:05:00',3.4),('15087','2013-04-20','12:10:00',4.8),('15087','2013-04-20','12:15:00',4.81),('15087','2013-04-20','12:20:00',4.59),('15087','2013-04-20','12:25:00',4.54),('15087','2013-04-20','12:30:00',3.78),('15087','2013-04-20','12:35:00',2.85),('15087','2013-04-20','12:40:00',4.5),('15087','2013-04-20','12:45:00',4.93),('15087','2013-04-20','12:50:00',1.81),('15087','2013-04-20','12:55:00',5.05),('15087','2013-04-20','13:00:00',2.01),('15087','2013-04-20','13:05:00',2.93),('15087','2013-04-20','13:10:00',3.25),('15087','2013-04-20','13:15:00',4.31),('15087','2013-04-20','13:20:00',2.52),('15087','2013-04-20','13:25:00',3.17),('15087','2013-04-20','13:30:00',1.53),('15087','2013-04-20','13:35:00',4.77),('15087','2013-04-20','13:40:00',3.08),('15087','2013-04-20','13:45:00',2.16),('15087','2013-04-20','13:50:00',1.63),('15087','2013-04-20','13:55:00',3.77),('15087','2013-04-20','14:00:00',2.96),('15087','2013-04-20','14:05:00',3.56),('15087','2013-04-20','14:10:00',4.47),('15087','2013-04-20','14:15:00',4.23),('15087','2013-04-20','14:20:00',3.93),('15087','2013-04-20','14:25:00',4.02),('15087','2013-04-20','14:30:00',3.91),('15087','2013-04-20','14:35:00',3.9),('15087','2013-04-20','14:40:00',3.76),('15087','2013-04-20','14:45:00',3.89),('15087','2013-04-20','14:50:00',3.76),('15087','2013-04-20','14:55:00',3.72),('15087','2013-04-20','15:00:00',3.74),('15087','2013-04-20','15:05:00',3.73),('15087','2013-04-20','15:10:00',2.28),('15087','2013-04-20','15:15:00',2.49),('15087','2013-04-20','15:20:00',3.07),('15087','2013-04-20','15:25:00',3.11),('15087','2013-04-20','15:30:00',1.4),('15087','2013-04-20','16:05:00',1.11),('15087','2013-04-20','16:10:00',2.04),('15087','2013-04-20','16:15:00',2.34),('15087','2013-04-20','16:20:00',2.23),('15087','2013-04-20','16:25:00',2.63),('15087','2013-04-20','16:30:00',2.9),('15087','2013-04-20','16:35:00',2.56),('15087','2013-04-20','16:40:00',2.78),('15087','2013-04-20','16:45:00',2.67),('15087','2013-04-20','16:50:00',2.44),('15087','2013-04-20','16:55:00',2.24),('15087','2013-04-20','17:00:00',2.07),('15087','2013-04-20','17:05:00',2.1),('15087','2013-04-20','17:10:00',2.03),('15087','2013-04-20','17:15:00',1.66),('15087','2013-04-20','17:20:00',1.8),('15087','2013-04-20','17:25:00',1.76),('15087','2013-04-20','17:30:00',1.83),('15087','2013-04-20','17:35:00',1.72),('15087','2013-04-20','17:40:00',1.56),('15087','2013-04-20','17:55:00',1.45),('15087','2013-04-20','18:00:00',1.09),('15087','2013-04-20','18:05:00',1.11),('15087','2013-04-20','18:10:00',1.29),('15087','2013-04-19','08:05:00',1.01),('15087','2013-04-19','08:15:00',1.03),('15087','2013-04-19','08:20:00',1.36),('15087','2013-04-19','08:25:00',1.29),('15087','2013-04-19','08:30:00',1.39),('15087','2013-04-19','08:35:00',1.64),('15087','2013-04-19','08:40:00',1.77),('15087','2013-04-19','08:45:00',1.88),('15087','2013-04-19','08:50:00',1.97),('15087','2013-04-19','08:55:00',2.08),('15087','2013-04-19','09:00:00',2.14),('15087','2013-04-19','09:05:00',2.2),('15087','2013-04-19','09:10:00',2.27),('15087','2013-04-19','09:15:00',2.34),('15087','2013-04-19','09:20:00',2.44),('15087','2013-04-19','09:25:00',2.52),('15087','2013-04-19','09:30:00',2.62),('15087','2013-04-19','09:35:00',2.69),('15087','2013-04-19','09:40:00',2.74),('15087','2013-04-19','09:45:00',2.79),('15087','2013-04-19','09:50:00',2.84),('15087','2013-04-19','09:55:00',2.91),('15087','2013-04-19','10:00:00',2.95),('15087','2013-04-19','10:05:00',3.02),('15087','2013-04-19','10:10:00',3.08),('15087','2013-04-19','10:15:00',3.18),('15087','2013-04-19','10:20:00',3.29),('15087','2013-04-19','10:25:00',3.36),('15087','2013-04-19','10:30:00',3.46),('15087','2013-04-19','10:35:00',2.55),('15087','2013-04-19','10:40:00',3.5),('15087','2013-04-19','10:45:00',3.52),('15087','2013-04-19','10:50:00',3.55),('15087','2013-04-19','10:55:00',3.52),('15087','2013-04-19','11:00:00',3.57),('15087','2013-04-19','11:05:00',3.66),('15087','2013-04-19','11:10:00',3.71),('15087','2013-04-19','11:15:00',3.75),('15087','2013-04-19','11:20:00',3.79),('15087','2013-04-19','11:25:00',3.82),('15087','2013-04-19','11:30:00',3.75),('15087','2013-04-19','11:35:00',3.88),('15087','2013-04-19','11:40:00',3.95),('15087','2013-04-19','11:45:00',3.99),('15087','2013-04-19','11:50:00',4.02),('15087','2013-04-19','11:55:00',4.03),('15087','2013-04-19','12:00:00',4.08),('15087','2013-04-19','12:05:00',4.07),('15087','2013-04-19','12:10:00',4.03),('15087','2013-04-19','12:15:00',4.04),('15087','2013-04-19','12:20:00',4.08),('15087','2013-04-19','12:25:00',4.15),('15087','2013-04-19','12:30:00',4.16),('15087','2013-04-19','12:35:00',4.14),('15087','2013-04-19','12:40:00',4.17),('15087','2013-04-19','12:45:00',4.04),('15087','2013-04-19','12:50:00',4.18),('15087','2013-04-19','12:55:00',4.17),('15087','2013-04-19','13:00:00',4.16),('15087','2013-04-19','13:05:00',4.25),('15087','2013-04-19','13:10:00',4.25),('15087','2013-04-19','13:15:00',4.2),('15087','2013-04-19','13:20:00',4.17),('15087','2013-04-19','13:25:00',4.3),('15087','2013-04-19','13:30:00',4.2),('15087','2013-04-19','13:35:00',4.15),('15087','2013-04-19','13:40:00',4.2),('15087','2013-04-19','13:45:00',4.08),('15087','2013-04-19','13:50:00',4.05),('15087','2013-04-19','13:55:00',3.99),('15087','2013-04-19','14:00:00',3.97),('15087','2013-04-19','14:05:00',4),('15087','2013-04-19','14:10:00',3.96),('15087','2013-04-19','14:15:00',3.89),('15087','2013-04-19','14:20:00',3.84),('15087','2013-04-19','14:25:00',3.85),('15087','2013-04-19','14:30:00',3.82),('15087','2013-04-19','14:35:00',3.73),('15087','2013-04-19','14:40:00',3.32),('15087','2013-04-19','14:45:00',3.26),('15087','2013-04-19','14:50:00',3.58),('15087','2013-04-19','14:55:00',3.62),('15087','2013-04-19','15:00:00',3.41),('15087','2013-04-19','15:05:00',3.41),('15087','2013-04-19','15:10:00',3.34),('15087','2013-04-19','15:15:00',3.24),('15087','2013-04-19','15:20:00',3.14),('15087','2013-04-19','15:25:00',3.1),('15087','2013-04-19','15:30:00',3.04),('15087','2013-04-19','15:35:00',3.03),('15087','2013-04-19','15:40:00',3.05),('15087','2013-04-19','15:45:00',2.92),('15087','2013-04-19','15:50:00',2.82),('15087','2013-04-19','15:55:00',2.84),('15087','2013-04-19','16:00:00',2.72),('15087','2013-04-19','16:05:00',2.68),('15087','2013-04-19','16:10:00',2.65),('15087','2013-04-19','16:15:00',2.63),('15087','2013-04-19','16:20:00',2.55),('15087','2013-04-19','16:25:00',2.53),('15087','2013-04-19','16:30:00',2.36),('15087','2013-04-19','16:35:00',2.24),('15087','2013-04-19','16:40:00',2.25),('15087','2013-04-19','16:45:00',2.15),('15087','2013-04-19','16:50:00',1.94),('15087','2013-04-19','16:55:00',1.91),('15087','2013-04-19','17:00:00',1.82),('15087','2013-04-19','17:05:00',1.74),('15087','2013-04-19','17:10:00',1.66),('15087','2013-04-19','17:15:00',1.54),('15087','2013-04-19','17:20:00',1.49),('15087','2013-04-19','17:25:00',1.4),('15087','2013-04-19','17:30:00',1.32),('15087','2013-04-19','17:35:00',1.23),('15087','2013-04-19','17:40:00',1.15),('15087','2013-04-19','17:45:00',1.09),('15087','2013-04-18','08:10:00',1.14),('15087','2013-04-18','08:15:00',1.11),('15087','2013-04-18','08:20:00',1.27),('15087','2013-04-18','08:25:00',1.19),('15087','2013-04-18','08:30:00',1.33),('15087','2013-04-18','08:35:00',1.43),('15087','2013-04-18','08:40:00',1.34),('15087','2013-04-18','08:45:00',1.39),('15087','2013-04-18','08:50:00',1.55),('15087','2013-04-18','08:55:00',1.76),('15087','2013-04-18','09:00:00',1.94),('15087','2013-04-18','09:05:00',2.03),('15087','2013-04-18','09:10:00',2.01),('15087','2013-04-18','09:15:00',2.11),('15087','2013-04-18','09:20:00',2.09),('15087','2013-04-18','09:25:00',2.14),('15087','2013-04-18','09:30:00',2.28),('15087','2013-04-18','09:35:00',2.63),('15087','2013-04-18','09:40:00',2.85),('15087','2013-04-18','09:45:00',2.84),('15087','2013-04-18','09:50:00',2.44),('15087','2013-04-18','09:55:00',2.36),('15087','2013-04-18','10:00:00',2.75),('15087','2013-04-18','10:05:00',3.01),('15087','2013-04-18','10:10:00',3.26),('15087','2013-04-18','10:15:00',3.46),('15087','2013-04-18','10:20:00',3.5),('15087','2013-04-18','10:25:00',3.48),('15087','2013-04-18','10:30:00',3.54),('15087','2013-04-18','10:35:00',3.56),('15087','2013-04-18','10:40:00',3.61),('15087','2013-04-18','10:45:00',3.67),('15087','2013-04-18','10:50:00',3.7),('15087','2013-04-18','10:55:00',3.73),('15087','2013-04-18','11:00:00',3.8),('15087','2013-04-18','11:05:00',3.84),('15087','2013-04-18','11:10:00',3.88),('15087','2013-04-18','11:15:00',3.99),('15087','2013-04-18','11:20:00',4.02),('15087','2013-04-18','11:25:00',4.04),('15087','2013-04-18','11:30:00',4.05),('15087','2013-04-18','11:35:00',4.08),('15087','2013-04-18','11:40:00',4.09),('15087','2013-04-18','11:45:00',4.06),('15087','2013-04-18','11:50:00',4.19),('15087','2013-04-18','11:55:00',4.23),('15087','2013-04-18','12:00:00',4.2),('15087','2013-04-18','12:05:00',4.26),('15087','2013-04-18','12:10:00',4.31),('15087','2013-04-18','12:15:00',4.29),('15087','2013-04-18','12:20:00',4.36),('15087','2013-04-18','12:25:00',4.38),('15087','2013-04-18','12:30:00',4.4),('15087','2013-04-18','12:35:00',4.39),('15087','2013-04-18','12:40:00',4.44),('15087','2013-04-18','12:45:00',4.44),('15087','2013-04-18','12:50:00',4.46),('15087','2013-04-18','12:55:00',4.48),('15087','2013-04-18','13:00:00',4.46),('15087','2013-04-18','13:05:00',4.41),('15087','2013-04-18','13:10:00',4.43),('15087','2013-04-18','13:15:00',4.38),('15087','2013-04-18','13:20:00',4.41),('15087','2013-04-18','13:25:00',4.44),('15087','2013-04-18','13:30:00',4.43),('15087','2013-04-18','13:35:00',4.44),('15087','2013-04-18','13:40:00',4.4),('15087','2013-04-18','13:45:00',4.39),('15087','2013-04-18','13:50:00',4.41),('15087','2013-04-18','13:55:00',4.26),('15087','2013-04-18','14:00:00',4.27),('15087','2013-04-18','14:05:00',4.3),('15087','2013-04-18','14:10:00',4.26),('15087','2013-04-18','14:15:00',4.16),('15087','2013-04-18','14:20:00',4.13),('15087','2013-04-18','14:25:00',4.09),('15087','2013-04-18','14:30:00',4.07),('15087','2013-04-18','14:35:00',3.93),('15087','2013-04-18','14:40:00',3.86),('15087','2013-04-18','14:45:00',3.87),('15087','2013-04-18','14:50:00',3.84),('15087','2013-04-18','14:55:00',3.75),('15087','2013-04-18','15:00:00',3.58),('15087','2013-04-18','15:05:00',3.64),('15087','2013-04-18','15:10:00',3.61),('15087','2013-04-18','15:15:00',3.53),('15087','2013-04-18','15:20:00',3.35),('15087','2013-04-18','15:25:00',3.12),('15087','2013-04-18','15:30:00',3.08),('15087','2013-04-18','15:35:00',3.23),('15087','2013-04-18','15:40:00',3.18),('15087','2013-04-18','15:45:00',3.12),('15087','2013-04-18','15:50:00',3.06),('15087','2013-04-18','15:55:00',2.98),('15087','2013-04-18','16:00:00',2.91),('15087','2013-04-18','16:05:00',2.81),('15087','2013-04-18','16:10:00',2.76),('15087','2013-04-18','16:15:00',2.72),('15087','2013-04-18','16:20:00',2.68),('15087','2013-04-18','16:25:00',2.61),('15087','2013-04-18','16:30:00',2.54),('15087','2013-04-18','16:35:00',2.41),('15087','2013-04-18','16:40:00',2.37),('15087','2013-04-18','16:45:00',2.26),('15087','2013-04-18','16:50:00',2.2),('15087','2013-04-18','16:55:00',2.07),('15087','2013-04-18','17:00:00',1.98),('15087','2013-04-18','17:05:00',1.86),('15087','2013-04-18','17:10:00',1.78),('15087','2013-04-18','17:15:00',1.71),('15087','2013-04-18','17:20:00',1.62),('15087','2013-04-18','17:25:00',1.49),('15087','2013-04-18','17:30:00',1.4),('15087','2013-04-18','17:35:00',1.32),('15087','2013-04-18','17:40:00',1.22),('15087','2013-04-18','17:45:00',1.14),('15087','2013-04-18','17:50:00',1.15),('15087','2013-04-18','17:55:00',1.07),('15087','2013-04-17','08:00:00',1.02),('15087','2013-04-17','08:05:00',1.11),('15087','2013-04-17','08:10:00',1.21),('15087','2013-04-17','08:15:00',1.3),('15087','2013-04-17','08:20:00',1.39),('15087','2013-04-17','08:25:00',1.48),('15087','2013-04-17','08:30:00',1.61),('15087','2013-04-17','08:35:00',1.68),('15087','2013-04-17','08:40:00',1.81),('15087','2013-04-17','08:45:00',1.92),('15087','2013-04-17','08:50:00',2.02),('15087','2013-04-17','08:55:00',2.11),('15087','2013-04-17','09:00:00',2.21),('15087','2013-04-17','09:05:00',2.29),('15087','2013-04-17','09:10:00',2.39),('15087','2013-04-17','09:15:00',2.46),('15087','2013-04-17','09:20:00',2.54),('15087','2013-04-17','09:25:00',2.63),('15087','2013-04-17','09:30:00',2.71),('15087','2013-04-17','09:35:00',2.8),('15087','2013-04-17','09:40:00',2.89),('15087','2013-04-17','09:45:00',2.96),('15087','2013-04-17','09:50:00',3.02),('15087','2013-04-17','09:55:00',3.11),('15087','2013-04-17','10:00:00',3.18),('15087','2013-04-17','10:05:00',3.26),('15087','2013-04-17','10:10:00',3.32),('15087','2013-04-17','10:15:00',3.38),('15087','2013-04-17','10:20:00',3.4),('15087','2013-04-17','10:25:00',3.5),('15087','2013-04-17','10:30:00',3.55),('15087','2013-04-17','10:35:00',3.61),('15087','2013-04-17','10:40:00',3.67),('15087','2013-04-17','10:45:00',3.72),('15087','2013-04-17','10:50:00',3.76),('15087','2013-04-17','10:55:00',3.81),('15087','2013-04-17','11:00:00',3.86),('15087','2013-04-17','11:05:00',3.93),('15087','2013-04-17','11:10:00',3.98),('15087','2013-04-17','11:15:00',4),('15087','2013-04-17','11:20:00',4.04),('15087','2013-04-17','11:25:00',4.06),('15087','2013-04-17','11:30:00',4.07),('15087','2013-04-17','11:35:00',4.1),('15087','2013-04-17','11:40:00',4.15),('15087','2013-04-17','11:45:00',4.17),('15087','2013-04-17','11:50:00',4.2),('15087','2013-04-17','11:55:00',4.26),('15087','2013-04-17','12:00:00',4.28),('15087','2013-04-17','12:05:00',4.28),('15087','2013-04-17','12:10:00',4.26),('15087','2013-04-17','12:15:00',4.27),('15087','2013-04-17','12:20:00',4.3),('15087','2013-04-17','12:25:00',4.34),('15087','2013-04-17','12:30:00',4.37),('15087','2013-04-17','12:35:00',4.39),('15087','2013-04-17','12:40:00',4.39),('15087','2013-04-17','12:45:00',4.41),('15087','2013-04-17','12:50:00',4.39),('15087','2013-04-17','12:55:00',4.36),('15087','2013-04-17','13:00:00',4.34),('15087','2013-04-17','13:05:00',4.34),('15087','2013-04-17','13:10:00',4.34),('15087','2013-04-17','13:15:00',4.47),('15087','2013-04-17','13:20:00',4.48),('15087','2013-04-17','13:25:00',4.47),('15087','2013-04-17','13:30:00',4.43),('15087','2013-04-17','13:35:00',4.44),('15087','2013-04-17','13:40:00',4.44),('15087','2013-04-17','13:45:00',4.4),('15087','2013-04-17','13:50:00',4.27),('15087','2013-04-17','13:55:00',4.46),('15087','2013-04-17','14:00:00',4.2),('15087','2013-04-17','14:05:00',4.48),('15087','2013-04-17','14:10:00',4.59),('15087','2013-04-17','14:15:00',4.18),('15087','2013-04-17','14:20:00',4.1),('15087','2013-04-17','14:25:00',3.83),('15087','2013-04-17','14:30:00',4.14),('15087','2013-04-17','14:35:00',4.22),('15087','2013-04-17','14:40:00',3.85),('15087','2013-04-17','14:45:00',3.76),('15087','2013-04-17','14:50:00',4.25),('15087','2013-04-17','14:55:00',4.05),('15087','2013-04-17','15:00:00',3.97),('15087','2013-04-17','15:05:00',4.06),('15087','2013-04-17','15:10:00',4.19),('15087','2013-04-17','15:15:00',3.81),('15087','2013-04-17','15:20:00',2.29),('15087','2013-04-17','15:25:00',1.72),('15087','2013-04-17','15:30:00',3.03),('15087','2013-04-17','15:35:00',3.35),('15087','2013-04-17','15:40:00',3.45),('15087','2013-04-17','15:45:00',3.32),('15087','2013-04-17','15:50:00',3.22),('15087','2013-04-17','15:55:00',3.29),('15087','2013-04-17','16:00:00',3.16),('15087','2013-04-17','16:05:00',2.34),('15087','2013-04-17','16:10:00',2.99),('15087','2013-04-17','16:15:00',2.93),('15087','2013-04-17','16:20:00',2.76),('15087','2013-04-17','16:25:00',2.73),('15087','2013-04-17','16:30:00',2.68),('15087','2013-04-17','16:35:00',2.65),('15087','2013-04-17','16:40:00',2.23),('15087','2013-04-17','16:45:00',2.43),('15087','2013-04-17','16:50:00',2.19),('15087','2013-04-17','16:55:00',2.14),('15087','2013-04-17','17:00:00',2.07),('15087','2013-04-17','17:05:00',1.94),('15087','2013-04-17','17:10:00',1.82),('15087','2013-04-17','17:15:00',1.76),('15087','2013-04-17','17:20:00',1.64),('15087','2013-04-17','17:25:00',1.51),('15087','2013-04-17','17:30:00',1.38),('15087','2013-04-17','17:35:00',1.33),('15087','2013-04-17','17:40:00',1.25),('15087','2013-04-17','17:45:00',1.2),('15087','2013-04-17','17:50:00',1.12),('15087','2013-04-17','17:55:00',1.03),('15087','2013-04-16','08:05:00',1.01),('15087','2013-04-16','08:10:00',1),('15087','2013-04-16','08:50:00',1.06),('15087','2013-04-16','08:55:00',1.02),('15087','2013-04-16','09:10:00',1.75),('15087','2013-04-16','09:15:00',2.46),('15087','2013-04-16','09:20:00',1.39),('15087','2013-04-16','09:25:00',1.36),('15087','2013-04-16','09:30:00',1.61),('15087','2013-04-16','09:35:00',1.64),('15087','2013-04-16','09:40:00',1.51),('15087','2013-04-16','09:45:00',1.64),('15087','2013-04-16','09:50:00',1.42),('15087','2013-04-16','09:55:00',1.36),('15087','2013-04-16','10:00:00',1.29),('15087','2013-04-16','10:05:00',1.27),('15087','2013-04-16','10:10:00',1.37),('15087','2013-04-16','10:15:00',1.47),('15087','2013-04-16','10:20:00',1.58),('15087','2013-04-16','10:25:00',1.63),('15087','2013-04-16','10:30:00',1.62),('15087','2013-04-16','10:35:00',1.67),('15087','2013-04-16','10:40:00',1.65),('15087','2013-04-16','10:45:00',1.56),('15087','2013-04-16','10:50:00',1.56),('15087','2013-04-16','10:55:00',1.7),('15087','2013-04-16','11:00:00',1.88),('15087','2013-04-16','11:05:00',1.94),('15087','2013-04-16','11:10:00',1.93),('15087','2013-04-16','11:15:00',1.97),('15087','2013-04-16','11:20:00',2.02),('15087','2013-04-16','11:25:00',1.98),('15087','2013-04-16','11:30:00',1.91),('15087','2013-04-16','11:35:00',1.81),('15087','2013-04-16','11:40:00',2),('15087','2013-04-16','11:45:00',2.34),('15087','2013-04-16','11:50:00',2.53),('15087','2013-04-16','11:55:00',2.62),('15087','2013-04-16','12:00:00',2.69),('15087','2013-04-16','12:05:00',2.91),('15087','2013-04-16','12:10:00',3.2),('15087','2013-04-16','12:15:00',3.16),('15087','2013-04-16','12:20:00',3.25),('15087','2013-04-16','12:25:00',3.25),('15087','2013-04-16','12:30:00',2.59),('15087','2013-04-16','12:35:00',2.86),('15087','2013-04-16','12:40:00',3.93),('15087','2013-04-16','12:45:00',3.72),('15087','2013-04-16','12:50:00',3.38),('15087','2013-04-16','12:55:00',3.89),('15087','2013-04-16','13:00:00',4.38),('15087','2013-04-16','13:05:00',4.31),('15087','2013-04-16','13:10:00',4.25),('15087','2013-04-16','13:15:00',4.29),('15087','2013-04-16','13:20:00',4.32),('15087','2013-04-16','13:25:00',4.34),('15087','2013-04-16','13:30:00',4.32),('15087','2013-04-16','13:35:00',4.27),('15087','2013-04-16','13:40:00',4.27),('15087','2013-04-16','13:45:00',4.07),('15087','2013-04-16','13:50:00',4.2),('15087','2013-04-16','13:55:00',3.99),('15087','2013-04-16','14:00:00',4.12),('15087','2013-04-16','14:05:00',4.16),('15087','2013-04-16','14:10:00',4.13),('15087','2013-04-16','14:15:00',4.15),('15087','2013-04-16','14:20:00',3.95),('15087','2013-04-16','14:25:00',3.61),('15087','2013-04-16','14:30:00',3.67),('15087','2013-04-16','14:35:00',2.83),('15087','2013-04-16','14:40:00',3.67),('15087','2013-04-16','14:45:00',3.74),('15087','2013-04-16','14:50:00',3.7),('15087','2013-04-16','14:55:00',3.43),('15087','2013-04-16','15:00:00',3.57),('15087','2013-04-16','15:05:00',3.6),('15087','2013-04-16','15:10:00',3.6),('15087','2013-04-16','15:15:00',3.47),('15087','2013-04-16','15:20:00',3.3),('15087','2013-04-16','15:25:00',2.87),('15087','2013-04-16','15:30:00',3.02),('15087','2013-04-16','15:35:00',3.03),('15087','2013-04-16','15:40:00',3.11),('15087','2013-04-16','15:45:00',3.04),('15087','2013-04-16','15:50:00',2.99),('15087','2013-04-16','15:55:00',2.95),('15087','2013-04-16','16:00:00',2.76),('15087','2013-04-16','16:05:00',2.75),('15087','2013-04-16','16:10:00',2.67),('15087','2013-04-16','16:15:00',2.63),('15087','2013-04-16','16:20:00',2.64),('15087','2013-04-16','16:25:00',2.55),('15087','2013-04-16','16:30:00',2.55),('15087','2013-04-16','16:35:00',2.5),('15087','2013-04-16','16:40:00',2.54),('15087','2013-04-16','16:45:00',2.57),('15087','2013-04-16','16:50:00',2.37),('15087','2013-04-16','16:55:00',1.91),('15087','2013-04-16','17:00:00',1.94),('15087','2013-04-16','17:05:00',2),('15087','2013-04-16','17:10:00',1.96),('15087','2013-04-16','17:15:00',1.92),('15087','2013-04-16','17:20:00',1.94),('15087','2013-04-16','17:25:00',1.9),('15087','2013-04-16','17:30:00',1.69),('15087','2013-04-16','17:35:00',1.66),('15087','2013-04-16','17:40:00',1.59),('15087','2013-04-16','17:45:00',1.45),('15087','2013-04-16','17:50:00',1.31),('15087','2013-04-16','17:55:00',1.07),('15087','2013-04-15','08:00:00',1.03),('15087','2013-04-15','08:05:00',1.11),('15087','2013-04-15','08:10:00',1.19),('15087','2013-04-15','08:15:00',1.28),('15087','2013-04-15','08:20:00',1.37),('15087','2013-04-15','08:25:00',1.47),('15087','2013-04-15','08:30:00',1.56),('15087','2013-04-15','08:35:00',1.66),('15087','2013-04-15','08:40:00',1.79),('15087','2013-04-15','08:45:00',1.83),('15087','2013-04-15','08:50:00',1.99),('15087','2013-04-15','08:55:00',2.09),('15087','2013-04-15','09:00:00',2.21),('15087','2013-04-15','09:05:00',2.3),('15087','2013-04-15','09:10:00',2.4),('15087','2013-04-15','09:15:00',2.5),('15087','2013-04-15','09:20:00',2.57),('15087','2013-04-15','09:25:00',2.65),('15087','2013-04-15','09:30:00',2.73),('15087','2013-04-15','09:35:00',2.8),('15087','2013-04-15','09:40:00',2.87),('15087','2013-04-15','09:45:00',2.93),('15087','2013-04-15','09:50:00',3.01),('15087','2013-04-15','09:55:00',3.06),('15087','2013-04-15','10:00:00',3.16),('15087','2013-04-15','10:05:00',3.24),('15087','2013-04-15','10:10:00',3.31),('15087','2013-04-15','10:15:00',3.36),('15087','2013-04-15','10:20:00',3.45),('15087','2013-04-15','10:25:00',3.5),('15087','2013-04-15','10:30:00',3.54),('15087','2013-04-15','10:35:00',3.59),('15087','2013-04-15','10:40:00',3.65),('15087','2013-04-15','10:45:00',3.7),('15087','2013-04-15','10:50:00',3.74),('15087','2013-04-15','10:55:00',3.8),('15087','2013-04-15','11:00:00',3.85),('15087','2013-04-15','11:05:00',3.89),('15087','2013-04-15','11:10:00',3.97),('15087','2013-04-15','11:15:00',4.02),('15087','2013-04-15','11:20:00',4.03),('15087','2013-04-15','11:25:00',4.05),('15087','2013-04-15','11:30:00',4.07),('15087','2013-04-15','11:35:00',4.12),('15087','2013-04-15','11:40:00',4.14),('15087','2013-04-15','11:45:00',4.2),('15087','2013-04-15','11:50:00',4.22),('15087','2013-04-15','11:55:00',4.24),('15087','2013-04-15','12:00:00',4.26),('15087','2013-04-15','12:05:00',4.31),('15087','2013-04-15','12:10:00',4.27),('15087','2013-04-15','12:15:00',4.31),('15087','2013-04-15','12:20:00',4.31),('15087','2013-04-15','12:25:00',4.33),('15087','2013-04-15','12:30:00',4.33),('15087','2013-04-15','12:35:00',4.37),('15087','2013-04-15','12:40:00',4.37),('15087','2013-04-15','12:45:00',4.37),('15087','2013-04-15','12:50:00',4.35),('15087','2013-04-15','12:55:00',4.36),('15087','2013-04-15','13:00:00',4.39),('15087','2013-04-15','13:05:00',4.4),('15087','2013-04-15','13:10:00',4.43),('15087','2013-04-15','13:15:00',4.4),('15087','2013-04-15','13:20:00',4.38),('15087','2013-04-15','13:25:00',4.42),('15087','2013-04-15','13:30:00',4.39),('15087','2013-04-15','13:35:00',4.37),('15087','2013-04-15','13:40:00',4.33),('15087','2013-04-15','13:45:00',4.33),('15087','2013-04-15','13:50:00',4.36),('15087','2013-04-15','13:55:00',4.26),('15087','2013-04-15','14:00:00',4.29),('15087','2013-04-15','14:05:00',4.29),('15087','2013-04-15','14:10:00',4.27),('15087','2013-04-15','14:15:00',4.17),('15087','2013-04-15','14:20:00',4.01),('15087','2013-04-15','14:25:00',3.91),('15087','2013-04-15','14:30:00',4.1),('15087','2013-04-15','14:35:00',4.03),('15087','2013-04-15','14:40:00',3.91),('15087','2013-04-15','14:45:00',3.92),('15087','2013-04-15','14:50:00',3.89),('15087','2013-04-15','14:55:00',3.78),('15087','2013-04-15','15:00:00',3.7),('15087','2013-04-15','15:05:00',3.61),('15087','2013-04-15','15:10:00',3.6),('15087','2013-04-15','15:15:00',3.48),('15087','2013-04-15','15:20:00',3.39),('15087','2013-04-15','15:25:00',3.09),('15087','2013-04-15','15:30:00',3.33),('15087','2013-04-15','15:35:00',2.95),('15087','2013-04-15','15:40:00',2.82),('15087','2013-04-15','15:45:00',3.14),('15087','2013-04-15','15:50:00',3.1),('15087','2013-04-15','15:55:00',3.04),('15087','2013-04-15','16:00:00',2.88),('15087','2013-04-15','16:05:00',2.8),('15087','2013-04-15','16:10:00',2.73),('15087','2013-04-15','16:15:00',2.77),('15087','2013-04-15','16:20:00',2.67),('15087','2013-04-15','16:25:00',2.43),('15087','2013-04-15','16:30:00',2.54),('15087','2013-04-15','16:35:00',2.46),('15087','2013-04-15','16:40:00',2.32),('15087','2013-04-15','16:45:00',2.3),('15087','2013-04-15','16:50:00',2.23),('15087','2013-04-15','16:55:00',2.11),('15087','2013-04-15','17:00:00',2.02),('15087','2013-04-15','17:05:00',1.93),('15087','2013-04-15','17:10:00',1.83),('15087','2013-04-15','17:15:00',1.73),('15087','2013-04-15','17:20:00',1.61),('15087','2013-04-15','17:25:00',1.51),('15087','2013-04-15','17:30:00',1.41),('15087','2013-04-15','17:35:00',1.24),('15087','2013-04-15','17:40:00',1.19),('15087','2013-04-15','17:45:00',1.17),('15087','2013-04-15','17:50:00',1.07),('15087','2013-04-15','17:55:00',1.05),('15087','2013-04-14','08:00:00',1.04),('15087','2013-04-14','08:05:00',1.05),('15087','2013-04-14','08:10:00',1.17),('15087','2013-04-14','08:15:00',1.29),('15087','2013-04-14','08:20:00',1.36),('15087','2013-04-14','08:25:00',1.46),('15087','2013-04-14','08:30:00',1.55),('15087','2013-04-14','08:35:00',1.63),('15087','2013-04-14','08:40:00',1.72),('15087','2013-04-14','08:45:00',1.83),('15087','2013-04-14','08:50:00',1.93),('15087','2013-04-14','08:55:00',2.02),('15087','2013-04-14','09:00:00',2.1),('15087','2013-04-14','09:05:00',2.21),('15087','2013-04-14','09:10:00',2.31),('15087','2013-04-14','09:15:00',2.39),('15087','2013-04-14','09:20:00',2.44),('15087','2013-04-14','09:25:00',2.52),('15087','2013-04-14','09:30:00',2.6),('15087','2013-04-14','09:35:00',2.69),('15087','2013-04-14','09:40:00',2.75),('15087','2013-04-14','09:45:00',2.82),('15087','2013-04-14','09:50:00',2.84),('15087','2013-04-14','09:55:00',2.94),('15087','2013-04-14','10:00:00',3.07),('15087','2013-04-14','10:05:00',3.14),('15087','2013-04-14','10:10:00',3.2),('15087','2013-04-14','10:15:00',3.29),('15087','2013-04-14','10:20:00',3.36),('15087','2013-04-14','10:25:00',3.42),('15087','2013-04-14','10:30:00',3.47),('15087','2013-04-14','10:35:00',3.5),('15087','2013-04-14','10:40:00',3.57),('15087','2013-04-14','10:45:00',3.63),('15087','2013-04-14','10:50:00',3.64),('15087','2013-04-14','10:55:00',3.71),('15087','2013-04-14','11:00:00',3.78),('15087','2013-04-14','11:05:00',3.81),('15087','2013-04-14','11:10:00',3.9),('15087','2013-04-14','11:15:00',3.92),('15087','2013-04-14','11:20:00',3.97),('15087','2013-04-14','11:25:00',4),('15087','2013-04-14','11:30:00',4.01),('15087','2013-04-14','11:35:00',4.04),('15087','2013-04-14','11:40:00',4.03),('15087','2013-04-14','11:45:00',4.11),('15087','2013-04-14','11:50:00',4.17),('15087','2013-04-14','11:55:00',4.11),('15087','2013-04-14','12:00:00',4.19),('15087','2013-04-14','12:05:00',4.17),('15087','2013-04-14','12:10:00',4.18),('15087','2013-04-14','12:15:00',4.24),('15087','2013-04-14','12:20:00',4.28),('15087','2013-04-14','12:25:00',4.3),('15087','2013-04-14','12:30:00',4.31),('15087','2013-04-14','12:35:00',4.3),('15087','2013-04-14','12:40:00',4.02),('15087','2013-04-14','12:45:00',2.05),('15087','2013-04-14','12:50:00',4.02),('15087','2013-04-14','12:55:00',4.5),('15087','2013-04-14','13:00:00',3.51),('15087','2013-04-14','13:05:00',2.82),('15087','2013-04-14','13:10:00',4.49),('15087','2013-04-14','13:15:00',4.15),('15087','2013-04-14','13:20:00',4.5),('15087','2013-04-14','13:25:00',4.46),('15087','2013-04-14','13:30:00',4.41),('15087','2013-04-14','13:35:00',4.36),('15087','2013-04-14','13:40:00',4.3),('15087','2013-04-14','13:45:00',4.24),('15087','2013-04-14','13:50:00',4.23),('15087','2013-04-14','13:55:00',4.08),('15087','2013-04-14','14:00:00',4.14),('15087','2013-04-14','14:05:00',4.16),('15087','2013-04-14','14:10:00',4.14),('15087','2013-04-14','14:15:00',3.97),('15087','2013-04-14','14:20:00',3.86),('15087','2013-04-14','14:25:00',3.91),('15087','2013-04-14','14:30:00',3.97),('15087','2013-04-14','14:35:00',4.01),('15087','2013-04-14','14:40:00',3.98),('15087','2013-04-14','14:45:00',4.05),('15087','2013-04-14','14:50:00',3.87),('15087','2013-04-14','14:55:00',3.88),('15087','2013-04-14','15:00:00',3.8),('15087','2013-04-14','15:05:00',3.73),('15087','2013-04-14','15:10:00',3.7),('15087','2013-04-14','15:15:00',3.17),('15087','2013-04-14','15:20:00',3.48),('15087','2013-04-14','15:25:00',3.23),('15087','2013-04-14','15:30:00',2.88),('15087','2013-04-14','15:35:00',3.35),('15087','2013-04-14','15:40:00',3.3),('15087','2013-04-14','15:45:00',3.26),('15087','2013-04-14','15:50:00',2.96),('15087','2013-04-14','15:55:00',2.85),('15087','2013-04-14','16:00:00',2.61),('15087','2013-04-14','16:05:00',2.77),('15087','2013-04-14','16:10:00',2.75),('15087','2013-04-14','16:15:00',2.7),('15087','2013-04-14','16:20:00',2.51),('15087','2013-04-14','16:25:00',2.39),('15087','2013-04-14','16:30:00',2.43),('15087','2013-04-14','16:35:00',2.35),('15087','2013-04-14','16:40:00',2.19),('15087','2013-04-14','16:45:00',2.19),('15087','2013-04-14','16:50:00',2.15),('15087','2013-04-14','16:55:00',2.08),('15087','2013-04-14','17:00:00',1.89),('15087','2013-04-14','17:05:00',1.81),('15087','2013-04-14','17:10:00',1.73),('15087','2013-04-14','17:15:00',1.62),('15087','2013-04-14','17:20:00',1.53),('15087','2013-04-14','17:25:00',1.4),('15087','2013-04-14','17:30:00',1.34),('15087','2013-04-14','17:35:00',1.24),('15087','2013-04-14','17:40:00',1.15),('15087','2013-04-14','17:45:00',1.13),('15087','2013-04-14','17:50:00',1.05),('15087','2013-04-14','17:55:00',1.01),('15087','2013-04-13','08:10:00',1.07),('15087','2013-04-13','08:15:00',1.15),('15087','2013-04-13','08:50:00',1.12),('15087','2013-04-13','08:55:00',1.62),('15087','2013-04-13','09:05:00',1.57),('15087','2013-04-13','09:10:00',1.67),('15087','2013-04-13','09:20:00',1.54),('15087','2013-04-13','09:25:00',1.92),('15087','2013-04-13','09:30:00',2.59),('15087','2013-04-13','09:35:00',2.59),('15087','2013-04-13','09:40:00',2.47),('15087','2013-04-13','09:45:00',2.86),('15087','2013-04-13','09:50:00',2.93),('15087','2013-04-13','09:55:00',3.01),('15087','2013-04-13','10:00:00',3.14),('15087','2013-04-13','10:05:00',3.18),('15087','2013-04-13','10:10:00',3.24),('15087','2013-04-13','10:15:00',3.2),('15087','2013-04-13','10:20:00',3.58),('15087','2013-04-13','10:25:00',3.64),('15087','2013-04-13','10:30:00',3.32),('15087','2013-04-13','10:35:00',3.58),('15087','2013-04-13','10:40:00',3.9),('15087','2013-04-13','10:45:00',3.34),('15087','2013-04-13','10:50:00',4.1),('15087','2013-04-13','10:55:00',2.89),('15087','2013-04-13','11:00:00',2.31),('15087','2013-04-13','11:05:00',3.84),('15087','2013-04-13','11:10:00',4.16),('15087','2013-04-13','11:15:00',4.43),('15087','2013-04-13','11:20:00',2.39),('15087','2013-04-13','11:25:00',1.66),('15087','2013-04-13','11:30:00',4.31),('15087','2013-04-13','11:35:00',4.48),('15087','2013-04-13','11:40:00',3.09),('15087','2013-04-13','11:45:00',3.34),('15087','2013-04-13','11:50:00',2.68),('15087','2013-04-13','11:55:00',4.58),('15087','2013-04-13','12:00:00',4.71),('15087','2013-04-13','12:05:00',4.58),('15087','2013-04-13','12:10:00',4.61),('15087','2013-04-13','12:15:00',4.04),('15087','2013-04-13','12:20:00',4.53),('15087','2013-04-13','12:25:00',4.66),('15087','2013-04-13','12:30:00',4.62),('15087','2013-04-13','12:35:00',4.56),('15087','2013-04-13','12:40:00',4.52),('15087','2013-04-13','12:45:00',4.5),('15087','2013-04-13','12:50:00',4.38),('15087','2013-04-13','12:55:00',3.99),('15087','2013-04-13','13:00:00',4.35),('15087','2013-04-13','13:05:00',4.49),('15087','2013-04-13','13:10:00',4.68),('15087','2013-04-13','13:15:00',4.54),('15087','2013-04-13','13:20:00',4.53),('15087','2013-04-13','13:25:00',4.47),('15087','2013-04-13','13:30:00',4.29),('15087','2013-04-13','13:35:00',3.53),('15087','2013-04-13','13:40:00',3.91),('15087','2013-04-13','13:45:00',3.52),('15087','2013-04-13','13:50:00',2.04),('15087','2013-04-13','13:55:00',2.2),('15087','2013-04-13','14:00:00',2.29),('15087','2013-04-13','14:05:00',2.01),('15087','2013-04-13','14:10:00',2.33),('15087','2013-04-13','14:15:00',3.84),('15087','2013-04-13','14:20:00',3.69),('15087','2013-04-13','14:25:00',3.81),('15087','2013-04-13','14:30:00',3.76),('15087','2013-04-13','14:35:00',3.81),('15087','2013-04-13','14:40:00',3.68),('15087','2013-04-13','14:45:00',3.73),('15087','2013-04-13','14:50:00',3.52),('15087','2013-04-13','14:55:00',3.63),('15087','2013-04-13','15:00:00',3.25),('15087','2013-04-13','15:05:00',2.87),('15087','2013-04-13','15:10:00',2.89),('15087','2013-04-13','15:15:00',2.75),('15087','2013-04-13','15:20:00',2.91),('15087','2013-04-13','15:25:00',2.71),('15087','2013-04-13','15:30:00',2.77),('15087','2013-04-13','15:35:00',2.67),('15087','2013-04-13','15:40:00',2.74),('15087','2013-04-13','15:45:00',2.73),('15087','2013-04-13','15:50:00',2.61),('15087','2013-04-13','15:55:00',2.67),('15087','2013-04-13','16:00:00',2.6),('15087','2013-04-13','16:05:00',2.49),('15087','2013-04-13','16:10:00',2.38),('15087','2013-04-13','16:15:00',2.42),('15087','2013-04-13','16:20:00',2.33),('15087','2013-04-13','16:25:00',2.15),('15087','2013-04-13','16:30:00',2.03),('15087','2013-04-13','16:35:00',1.92),('15087','2013-04-13','16:40:00',1.8),('15087','2013-04-13','16:45:00',1.72),('15087','2013-04-13','16:50:00',1.74),('15087','2013-04-13','16:55:00',1.42),('15087','2013-04-13','17:00:00',1.21),('15087','2013-04-13','17:05:00',1.16),('15087','2013-04-13','17:10:00',1.63),('15087','2013-04-13','17:15:00',1.84),('15087','2013-04-13','17:20:00',1.5),('15087','2013-04-13','17:25:00',1.67),('15087','2013-04-13','17:30:00',1.41),('15087','2013-04-13','17:35:00',1.36),('15087','2013-04-13','17:40:00',1.29),('15087','2013-04-13','17:45:00',1.15),('15087','2013-04-13','17:50:00',1.01),('15087','2013-04-13','17:55:00',1.03),('15087','2013-04-12','08:05:00',1.1),('15087','2013-04-12','08:10:00',1.09),('15087','2013-04-12','08:35:00',1.12),('15087','2013-04-12','08:45:00',1.13),('15087','2013-04-12','08:50:00',1.38),('15087','2013-04-12','08:55:00',1.97),('15087','2013-04-12','09:00:00',1.5),('15087','2013-04-12','09:05:00',1.3),('15087','2013-04-12','09:10:00',1.39),('15087','2013-04-12','09:15:00',2.15),('15087','2013-04-12','09:21:00',2.03),('15087','2013-04-12','09:25:00',2.4),('15087','2013-04-12','09:30:00',1.49),('15087','2013-04-12','09:35:00',1.19),('15087','2013-04-12','09:40:00',1.35),('15087','2013-04-12','09:45:00',1.17),('15087','2013-04-12','10:05:00',1.33),('15087','2013-04-12','10:15:00',1.31),('15087','2013-04-12','10:20:00',3.13),('15087','2013-04-12','10:25:00',2.47),('15087','2013-04-12','10:30:00',1.86),('15087','2013-04-12','10:35:00',2.84),('15087','2013-04-12','10:40:00',3.64),('15087','2013-04-12','10:45:00',4.39),('15087','2013-04-12','10:50:00',3.07),('15087','2013-04-12','10:55:00',1.3),('15087','2013-04-12','11:00:00',1.28),('15087','2013-04-12','11:05:00',1.78),('15087','2013-04-12','11:10:00',3.09),('15087','2013-04-12','11:15:00',4.93),('15087','2013-04-12','11:20:00',4.6),('15087','2013-04-12','11:25:00',4.73),('15087','2013-04-12','11:30:00',4.99),('15087','2013-04-12','11:35:00',3.28),('15087','2013-04-12','11:40:00',1.68),('15087','2013-04-12','11:45:00',1.84),('15087','2013-04-12','11:50:00',2.16),('15087','2013-04-12','11:55:00',4.2),('15087','2013-04-12','12:00:00',4.7),('15087','2013-04-12','12:05:00',4.57),('15087','2013-04-12','12:10:00',4.38),('15087','2013-04-12','12:15:00',4.65),('15087','2013-04-12','12:20:00',4.61),('15087','2013-04-12','12:25:00',4.63),('15087','2013-04-12','12:30:00',4.58),('15087','2013-04-12','12:35:00',4.47),('15087','2013-04-12','12:40:00',4.29),('15087','2013-04-12','12:45:00',4.47),('15087','2013-04-12','12:50:00',3.46),('15087','2013-04-12','12:55:00',4.36),('15087','2013-04-12','13:00:00',4.4),('15087','2013-04-12','13:05:00',4.32),('15087','2013-04-12','13:10:00',4.48),('15087','2013-04-12','13:15:00',4.5),('15087','2013-04-12','13:20:00',4.49),('15087','2013-04-12','13:25:00',4.49),('15087','2013-04-12','13:30:00',4.46),('15087','2013-04-12','13:35:00',4.48),('15087','2013-04-12','13:40:00',4.43),('15087','2013-04-12','13:45:00',4.43),('15087','2013-04-12','13:50:00',4.4),('15087','2013-04-12','13:55:00',4.25),('15087','2013-04-12','14:00:00',4.28),('15087','2013-04-12','14:05:00',4.32),('15087','2013-04-12','14:10:00',4.3),('15087','2013-04-12','14:15:00',4.13),('15087','2013-04-12','14:20:00',4.03),('15087','2013-04-12','14:25:00',4.11),('15087','2013-04-12','14:30:00',4.05),('15087','2013-04-12','14:35:00',3.97),('15087','2013-04-12','14:40:00',3.92),('15087','2013-04-12','14:45:00',3.87),('15087','2013-04-12','14:50:00',3.81),('15087','2013-04-12','14:55:00',3.64),('15087','2013-04-12','15:00:00',3.39),('15087','2013-04-12','15:05:00',3.56),('15087','2013-04-12','15:10:00',3.55),('15087','2013-04-12','15:15:00',3.47),('15087','2013-04-12','15:20:00',3.28),('15087','2013-04-12','15:25:00',3.35),('15087','2013-04-12','15:30:00',3.27),('15087','2013-04-12','15:35:00',3.17),('15087','2013-04-12','15:40:00',3.13),('15087','2013-04-12','15:45:00',3.09),('15087','2013-04-12','15:50:00',3.03),('15087','2013-04-12','15:55:00',2.96),('15087','2013-04-12','16:00:00',2.92),('15087','2013-04-12','16:05:00',2.84),('15087','2013-04-12','16:10:00',2.84),('15087','2013-04-12','16:15:00',2.55),('15087','2013-04-12','16:20:00',2.55),('15087','2013-04-12','16:25:00',2.64),('15087','2013-04-12','16:30:00',1.49),('15087','2013-04-12','16:35:00',1.21),('15087','2013-04-12','16:40:00',1.64),('15087','2013-04-12','16:45:00',2.23),('15087','2013-04-12','16:50:00',2.04),('15087','2013-04-12','16:55:00',2.08),('15087','2013-04-12','17:00:00',2.01),('15087','2013-04-12','17:05:00',1.92),('15087','2013-04-12','17:10:00',1.8),('15087','2013-04-12','17:15:00',1.67),('15087','2013-04-12','17:20:00',1.6),('15087','2013-04-12','17:25:00',1.5),('15087','2013-04-12','17:30:00',1.41),('15087','2013-04-12','17:35:00',1.29),('15087','2013-04-12','17:40:00',1.2),('15087','2013-04-12','17:45:00',1.1),('15087','2013-04-11','08:05:00',1.07),('15087','2013-04-11','08:10:00',1.15),('15087','2013-04-11','08:15:00',1.24),('15087','2013-04-11','08:20:00',1.34),('15087','2013-04-11','08:25:00',1.44),('15087','2013-04-11','08:30:00',1.53),('15087','2013-04-11','08:35:00',1.65),('15087','2013-04-11','08:40:00',1.73),('15087','2013-04-11','08:45:00',1.81),('15087','2013-04-11','08:50:00',1.91),('15087','2013-04-11','08:55:00',2),('15087','2013-04-11','09:00:00',2.08),('15087','2013-04-11','09:05:00',2.16),('15087','2013-04-11','09:10:00',2.25),('15087','2013-04-11','09:15:00',2.29),('15087','2013-04-11','09:20:00',2.41),('15087','2013-04-11','09:25:00',2.46),('15087','2013-04-11','09:30:00',2.58),('15087','2013-04-11','09:35:00',2.64),('15087','2013-04-11','09:40:00',2.7),('15087','2013-04-11','09:45:00',2.99),('15087','2013-04-11','09:50:00',1.72),('15087','2013-04-11','09:55:00',1.19),('15087','2013-04-11','10:00:00',2.51),('15087','2013-04-11','10:10:00',2.29),('15087','2013-04-11','10:15:00',3.41),('15087','2013-04-11','10:20:00',3.47),('15087','2013-04-11','10:25:00',3.79),('15087','2013-04-11','10:30:00',3.81),('15087','2013-04-11','10:35:00',3.79),('15087','2013-04-11','10:40:00',4.02),('15087','2013-04-11','10:45:00',2.88),('15087','2013-04-11','11:00:00',1.69),('15087','2013-04-11','11:05:00',3.92),('15087','2013-04-11','11:10:00',4.42),('15087','2013-04-11','11:15:00',3.64),('15087','2013-04-11','11:20:00',2.1),('15087','2013-04-11','11:25:00',3.74),('15087','2013-04-11','11:30:00',4.14),('15087','2013-04-11','11:35:00',2.58),('15087','2013-04-11','11:40:00',1.2),('15087','2013-04-11','11:45:00',1.13),('15087','2013-04-11','11:50:00',4.59),('15087','2013-04-11','11:55:00',5.16),('15087','2013-04-11','12:00:00',4.44),('15087','2013-04-11','12:05:00',4.79),('15087','2013-04-11','12:10:00',4.8),('15087','2013-04-11','12:15:00',4.6),('15087','2013-04-11','12:20:00',4.41),('15087','2013-04-11','12:25:00',4.62),('15087','2013-04-11','12:30:00',3.86),('15087','2013-04-11','12:35:00',4.04),('15087','2013-04-11','12:40:00',3.06),('15087','2013-04-11','12:45:00',2.55),('15087','2013-04-11','12:50:00',4.65),('15087','2013-04-11','12:55:00',4.81),('15087','2013-04-11','13:00:00',4.95),('15087','2013-04-11','13:05:00',4.51),('15087','2013-04-11','13:10:00',4.66),('15087','2013-04-11','13:15:00',3.61),('15087','2013-04-11','13:20:00',4.66),('15087','2013-04-11','13:25:00',4.61),('15087','2013-04-11','13:30:00',4.55),('15087','2013-04-11','13:35:00',4.61),('15087','2013-04-11','13:40:00',4.51),('15087','2013-04-11','13:45:00',4.42),('15087','2013-04-11','13:50:00',4.39),('15087','2013-04-11','13:55:00',4.34),('15087','2013-04-11','14:00:00',3.11),('15087','2013-04-11','14:05:00',4.42),('15087','2013-04-11','14:10:00',4.47),('15087','2013-04-11','14:15:00',4.3),('15087','2013-04-11','14:20:00',4.24),('15087','2013-04-11','14:25:00',4.18),('15087','2013-04-11','14:30:00',4.14),('15087','2013-04-11','14:35:00',4.06),('15087','2013-04-11','14:40:00',4.08),('15087','2013-04-11','14:45:00',3.87),('15087','2013-04-11','14:50:00',3.95),('15087','2013-04-11','14:55:00',3.82),('15087','2013-04-11','15:00:00',3.64),('15087','2013-04-11','15:05:00',3.69),('15087','2013-04-11','15:10:00',3.66),('15087','2013-04-11','15:15:00',3.5),('15087','2013-04-11','15:20:00',3.48),('15087','2013-04-11','15:25:00',3.45),('15087','2013-04-11','15:30:00',3.32),('15087','2013-04-11','15:35:00',3.26),('15087','2013-04-11','15:40:00',3.2),('15087','2013-04-11','15:45:00',3.15),('15087','2013-04-11','15:50:00',3.1),('15087','2013-04-11','15:55:00',3.03),('15087','2013-04-11','16:00:00',2.98),('15087','2013-04-11','16:05:00',2.85),('15087','2013-04-11','16:10:00',2.85),('15087','2013-04-11','16:15:00',2.76),('15087','2013-04-11','16:20:00',2.72),('15087','2013-04-11','16:25:00',2.64),('15087','2013-04-11','16:30:00',2.52),('15087','2013-04-11','16:35:00',2.43),('15087','2013-04-11','16:40:00',2.33),('15087','2013-04-11','16:45:00',2.23),('15087','2013-04-11','16:50:00',2.22),('15087','2013-04-11','16:55:00',2.18),('15087','2013-04-11','17:00:00',2.06),('15087','2013-04-11','17:05:00',1.97),('15087','2013-04-11','17:10:00',1.83),('15087','2013-04-11','17:15:00',1.65),('15087','2013-04-11','17:20:00',1.59),('15087','2013-04-11','17:25:00',1.5),('15087','2013-04-11','17:30:00',1.37),('15087','2013-04-11','17:35:00',1.33),('15087','2013-04-11','17:40:00',1.24),('15087','2013-04-11','17:45:00',1.13),('15087','2013-04-11','17:50:00',1.06),('15087','2013-04-10','08:50:00',1.1),('15087','2013-04-10','08:55:00',1.82),('15087','2013-04-10','09:00:00',2.11),('15087','2013-04-10','09:05:00',2.3),('15087','2013-04-10','09:10:00',2.42),('15087','2013-04-10','09:15:00',2.47),('15087','2013-04-10','09:20:00',2.48),('15087','2013-04-10','09:25:00',2.56),('15087','2013-04-10','09:30:00',2.67),('15087','2013-04-10','09:35:00',2.72),('15087','2013-04-10','09:40:00',2.81),('15087','2013-04-10','09:45:00',2.81),('15087','2013-04-10','09:50:00',2.89),('15087','2013-04-10','09:55:00',2.95),('15087','2013-04-10','10:00:00',3.22),('15087','2013-04-10','10:05:00',3.35),('15087','2013-04-10','10:10:00',3.53),('15087','2013-04-10','10:15:00',3.65),('15087','2013-04-10','10:20:00',3.68),('15087','2013-04-10','10:25:00',3.71),('15087','2013-04-10','10:30:00',3.72),('15087','2013-04-10','10:35:00',3.77),('15087','2013-04-10','10:40:00',3.77),('15087','2013-04-10','10:45:00',3.88),('15087','2013-04-10','10:50:00',3.66),('15087','2013-04-10','10:55:00',3.77),('15087','2013-04-10','11:00:00',3.76),('15087','2013-04-10','11:05:00',3.71),('15087','2013-04-10','11:10:00',3.84),('15087','2013-04-10','11:15:00',3.84),('15087','2013-04-10','11:20:00',4),('15087','2013-04-10','11:25:00',4.19),('15087','2013-04-10','11:30:00',4.2),('15087','2013-04-10','11:35:00',4.23),('15087','2013-04-10','11:40:00',4.31),('15087','2013-04-10','11:45:00',4.31),('15087','2013-04-10','11:50:00',4.39),('15087','2013-04-10','11:55:00',4.37),('15087','2013-04-10','12:00:00',4.49),('15087','2013-04-10','12:05:00',4.55),('15087','2013-04-10','12:10:00',4.6),('15087','2013-04-10','12:15:00',4.6),('15087','2013-04-10','12:20:00',4.6),('15087','2013-04-10','12:25:00',4.67),('15087','2013-04-10','12:30:00',4.72),('15087','2013-04-10','12:35:00',3.98),('15087','2013-04-10','12:40:00',4.69),('15087','2013-04-10','12:45:00',4.69),('15087','2013-04-10','12:50:00',4.37),('15087','2013-04-10','12:55:00',4.64),('15087','2013-04-10','13:00:00',3.07),('15087','2013-04-10','13:05:00',1.92),('15087','2013-04-10','13:10:00',1.46),('15087','2013-04-10','13:15:00',3.15),('15087','2013-04-10','13:20:00',5.2),('15087','2013-04-10','13:25:00',5),('15087','2013-04-10','13:30:00',4.34),('15087','2013-04-10','13:35:00',4.34),('15087','2013-04-10','13:40:00',3.94),('15087','2013-04-10','13:45:00',2.98),('15087','2013-04-10','13:50:00',4.96),('15087','2013-04-10','13:55:00',2.97),('15087','2013-04-10','14:00:00',4.65),('15087','2013-04-10','14:05:00',4.5),('15087','2013-04-10','14:10:00',4.44),('15087','2013-04-10','14:15:00',4.33),('15087','2013-04-10','14:20:00',4.3),('15087','2013-04-10','14:25:00',4.34),('15087','2013-04-10','14:30:00',4.36),('15087','2013-04-10','14:35:00',4.18),('15087','2013-04-10','14:40:00',4.12),('15087','2013-04-10','14:45:00',4.24),('15087','2013-04-10','14:50:00',4.17),('15087','2013-04-10','14:55:00',3.44),('15087','2013-04-10','15:00:00',3.83),('15087','2013-04-10','15:05:00',3.85),('15087','2013-04-10','15:10:00',2.87),('15087','2013-04-10','15:15:00',3.61),('15087','2013-04-10','15:20:00',3.71),('15087','2013-04-10','15:25:00',3.28),('15087','2013-04-10','15:30:00',3.32),('15087','2013-04-10','15:35:00',3),('15087','2013-04-10','15:40:00',2.77),('15087','2013-04-10','15:45:00',3.21),('15087','2013-04-10','15:50:00',3.21),('15087','2013-04-10','15:55:00',3.13),('15087','2013-04-10','16:00:00',2.63),('15087','2013-04-10','16:05:00',3.18),('15087','2013-04-10','16:10:00',2.93),('15087','2013-04-10','16:15:00',2.63),('15087','2013-04-10','16:20:00',2.57),('15087','2013-04-10','16:25:00',2.55),('15087','2013-04-10','16:30:00',2.31),('15087','2013-04-10','16:35:00',1.76),('15087','2013-04-10','16:40:00',2.23),('15087','2013-04-10','16:45:00',2.49),('15087','2013-04-10','16:50:00',2),('15087','2013-04-10','16:55:00',2.28),('15087','2013-04-10','17:00:00',2.01),('15087','2013-04-10','17:05:00',1.65),('15087','2013-04-10','17:10:00',1.74),('15087','2013-04-10','17:15:00',1.96),('15087','2013-04-10','17:20:00',1.79),('15087','2013-04-10','17:25:00',1.64),('15087','2013-04-10','17:30:00',1.48),('15087','2013-04-10','17:35:00',1.17),('15087','2013-04-10','17:45:00',1.2),('15087','2013-04-10','17:50:00',1.09),('15087','2013-04-10','17:55:00',1.01),('15087','2013-04-09','07:55:00',1.06),('15087','2013-04-09','08:00:00',1),('15087','2013-04-09','08:10:00',1.17),('15087','2013-04-09','08:20:00',1.5),('15087','2013-04-09','09:15:00',1.03),('15087','2013-04-09','09:25:00',1.05),('15087','2013-04-09','09:30:00',1.02),('15087','2013-04-09','09:45:00',1.75),('15087','2013-04-09','09:50:00',3.15),('15087','2013-04-09','09:55:00',3.25),('15087','2013-04-09','10:00:00',1.76),('15087','2013-04-09','10:05:00',1.18),('15087','2013-04-09','10:10:00',1.72),('15087','2013-04-09','10:15:00',2.03),('15087','2013-04-09','10:20:00',1.3),('15087','2013-04-09','10:30:00',1.19),('15087','2013-04-09','10:35:00',3.1),('15087','2013-04-09','10:40:00',2.97),('15087','2013-04-09','10:45:00',4.5),('15087','2013-04-09','10:50:00',3.61),('15087','2013-04-09','10:55:00',3.93),('15087','2013-04-09','11:00:00',3.73),('15087','2013-04-09','11:05:00',4.17),('15087','2013-04-09','11:10:00',3.54),('15087','2013-04-09','11:20:00',1.67),('15087','2013-04-09','11:25:00',3.91),('15087','2013-04-09','11:30:00',5.07),('15087','2013-04-09','11:35:00',1.94),('15087','2013-04-09','11:40:00',1.5),('15087','2013-04-09','11:45:00',3.5),('15087','2013-04-09','11:50:00',4.02),('15087','2013-04-09','11:55:00',3.39),('15087','2013-04-09','12:00:00',4.88),('15087','2013-04-09','12:05:00',4.87),('15087','2013-04-09','12:10:00',4.92),('15087','2013-04-09','12:15:00',4.88),('15087','2013-04-09','12:20:00',3.91),('15087','2013-04-09','12:25:00',4.66),('15087','2013-04-09','12:30:00',4.76),('15087','2013-04-09','12:35:00',4.54),('15087','2013-04-09','12:40:00',4.57),('15087','2013-04-09','12:45:00',4.66),('15087','2013-04-09','12:50:00',4.95),('15087','2013-04-09','12:55:00',4.93),('15087','2013-04-09','13:00:00',4.86),('15087','2013-04-09','13:05:00',4.43),('15087','2013-04-09','13:10:00',5.24),('15087','2013-04-09','13:15:00',3.72),('15087','2013-04-09','13:20:00',3.4),('15087','2013-04-09','13:25:00',4.25),('15087','2013-04-09','13:30:00',1.56),('15087','2013-04-09','13:35:00',2.32),('15087','2013-04-09','13:40:00',1.63),('15087','2013-04-09','13:45:00',2.17),('15087','2013-04-09','13:50:00',4.77),('15087','2013-04-09','13:55:00',4.5),('15087','2013-04-09','14:00:00',4.06),('15087','2013-04-09','14:05:00',3.07),('15087','2013-04-09','14:10:00',3.26),('15087','2013-04-09','14:15:00',3.66),('15087','2013-04-09','14:20:00',2.53),('15087','2013-04-09','14:25:00',3),('15087','2013-04-09','14:30:00',3.58),('15087','2013-04-09','14:35:00',3.71),('15087','2013-04-09','14:40:00',3.97),('15087','2013-04-09','14:45:00',3.6),('15087','2013-04-09','14:50:00',3.36),('15087','2013-04-09','14:55:00',2.73),('15087','2013-04-09','15:00:00',3.62),('15087','2013-04-09','15:05:00',4.07),('15087','2013-04-09','15:10:00',3.37),('15087','2013-04-09','15:15:00',2.76),('15087','2013-04-09','15:20:00',3.79),('15087','2013-04-09','15:25:00',3.73),('15087','2013-04-09','15:30:00',1.87),('15087','2013-04-09','15:35:00',3.72),('15087','2013-04-09','15:40:00',3.47),('15087','2013-04-09','15:45:00',2.84),('15087','2013-04-09','15:50:00',3.41),('15087','2013-04-09','15:55:00',2.76),('15087','2013-04-09','16:00:00',2.52),('15087','2013-04-09','16:05:00',2.63),('15087','2013-04-09','16:10:00',1.91),('15087','2013-04-09','16:15:00',1.84),('15087','2013-04-09','16:25:00',1.21),('15087','2013-04-09','16:30:00',1.09),('15087','2013-04-09','16:35:00',1.23),('15087','2013-04-09','16:40:00',1.06),('15087','2013-04-09','16:50:00',2.63),('15087','2013-04-09','16:55:00',1.95),('15087','2013-04-09','17:15:00',1.11),('15087','2013-04-08','08:40:00',1.33),('15087','2013-04-08','08:45:00',1.19),('15087','2013-04-08','08:50:00',1.89),('15087','2013-04-08','08:55:00',2.05),('15087','2013-04-08','09:00:00',1.37),('15087','2013-04-08','09:05:00',1.67),('15087','2013-04-08','09:10:00',1.3),('15087','2013-04-08','09:15:00',2.41),('15087','2013-04-08','09:20:00',2.6),('15087','2013-04-08','09:25:00',2.57),('15087','2013-04-08','09:30:00',2.75),('15087','2013-04-08','09:35:00',2.94),('15087','2013-04-08','09:40:00',2.92),('15087','2013-04-08','09:45:00',2.98),('15087','2013-04-08','09:50:00',1.65),('15087','2013-04-08','09:55:00',2.01),('15087','2013-04-08','10:00:00',3.16),('15087','2013-04-08','10:05:00',3.13),('15087','2013-04-08','10:10:00',3.31),('15087','2013-04-08','10:15:00',3.32),('15087','2013-04-08','10:20:00',3.35),('15087','2013-04-08','10:25:00',3.36),('15087','2013-04-08','10:30:00',3.47),('15087','2013-04-08','10:35:00',3.31),('15087','2013-04-08','10:40:00',3.71),('15087','2013-04-08','10:45:00',3.88),('15087','2013-04-08','10:50:00',3.89),('15087','2013-04-08','10:55:00',3.71),('15087','2013-04-08','11:00:00',3.87),('15087','2013-04-08','11:05:00',3.38),('15087','2013-04-08','11:10:00',3.3),('15087','2013-04-08','11:15:00',2.89),('15087','2013-04-08','11:20:00',2.45),('15087','2013-04-08','11:25:00',2.16),('15087','2013-04-08','11:30:00',2.53),('15087','2013-04-08','11:35:00',3.34),('15087','2013-04-08','11:40:00',3.42),('15087','2013-04-08','11:45:00',3.06),('15087','2013-04-08','11:50:00',2.79),('15087','2013-04-08','11:55:00',2.53),('15087','2013-04-08','12:00:00',2.35),('15087','2013-04-08','12:05:00',2.28),('15087','2013-04-08','12:10:00',2.5),('15087','2013-04-08','12:15:00',2.93),('15087','2013-04-08','12:20:00',2.97),('15087','2013-04-08','12:25:00',2.91),('15087','2013-04-08','12:30:00',3.23),('15087','2013-04-08','12:35:00',2.89),('15087','2013-04-08','12:40:00',2.86),('15087','2013-04-08','12:45:00',4.01),('15087','2013-04-08','12:50:00',2.52),('15087','2013-04-08','12:55:00',2.12),('15087','2013-04-08','13:00:00',2.13),('15087','2013-04-08','13:05:00',2.89),('15087','2013-04-08','13:10:00',2.94),('15087','2013-04-08','13:15:00',3.07),('15087','2013-04-08','13:20:00',3.9),('15087','2013-04-08','13:25:00',3.53),('15087','2013-04-08','13:30:00',3.02),('15087','2013-04-08','13:35:00',2.16),('15087','2013-04-08','13:40:00',3.07),('15087','2013-04-08','13:45:00',3.1),('15087','2013-04-08','13:50:00',3.34),('15087','2013-04-08','13:55:00',4.2),('15087','2013-04-08','14:00:00',3.94),('15087','2013-04-08','14:05:00',3.52),('15087','2013-04-08','14:10:00',3.54),('15087','2013-04-08','14:15:00',4),('15087','2013-04-08','14:20:00',3.5),('15087','2013-04-08','14:25:00',4.11),('15087','2013-04-08','14:30:00',3.98),('15087','2013-04-08','14:35:00',3.62),('15087','2013-04-08','14:40:00',3.73),('15087','2013-04-08','14:45:00',3.87),('15087','2013-04-08','14:50:00',3.68),('15087','2013-04-08','14:55:00',3.77),('15087','2013-04-08','15:00:00',2.85),('15087','2013-04-08','15:05:00',2.91),('15087','2013-04-08','15:10:00',3.03),('15087','2013-04-08','15:15:00',2.84),('15087','2013-04-08','15:20:00',3.05),('15087','2013-04-08','15:25:00',3.23),('15087','2013-04-08','15:30:00',3.39),('15087','2013-04-08','15:35:00',3.34),('15087','2013-04-08','15:40:00',3.23),('15087','2013-04-08','15:45:00',3.17),('15087','2013-04-08','15:50:00',3.11),('15087','2013-04-08','15:55:00',3.05),('15087','2013-04-08','16:00:00',2.95),('15087','2013-04-08','16:05:00',2.78),('15087','2013-04-08','16:10:00',2.65),('15087','2013-04-08','16:15:00',2.76),('15087','2013-04-08','16:20:00',2.76),('15087','2013-04-08','16:25:00',2.66),('15087','2013-04-08','16:30:00',2.58),('15087','2013-04-08','16:35:00',2.42),('15087','2013-04-08','16:40:00',2.32),('15087','2013-04-08','16:45:00',2.27),('15087','2013-04-08','16:50:00',2.25),('15087','2013-04-08','16:55:00',2.17),('15087','2013-04-08','17:00:00',2.08),('15087','2013-04-08','17:05:00',2),('15087','2013-04-08','17:10:00',1.83),('15087','2013-04-08','17:15:00',1.7),('15087','2013-04-08','17:20:00',1.56),('15087','2013-04-08','17:25:00',1.57),('15087','2013-04-08','17:30:00',1.42),('15087','2013-04-08','17:35:00',1.31),('15087','2013-04-08','17:40:00',1.17),('15087','2013-04-08','17:45:00',1.09),('15087','2013-04-07','08:30:00',1.01),('15087','2013-04-07','08:35:00',1.12),('15087','2013-04-07','08:40:00',1.16),('15087','2013-04-07','08:45:00',1.19),('15087','2013-04-07','08:50:00',1.18),('15087','2013-04-07','08:55:00',1.24),('15087','2013-04-07','09:00:00',1.32),('15087','2013-04-07','09:05:00',1.42),('15087','2013-04-07','09:10:00',1.54),('15087','2013-04-07','09:15:00',1.6),('15087','2013-04-07','09:20:00',1.71),('15087','2013-04-07','09:25:00',1.73),('15087','2013-04-07','09:30:00',1.62),('15087','2013-04-07','09:35:00',1.54),('15087','2013-04-07','09:40:00',1.49),('15087','2013-04-07','09:45:00',1.61),('15087','2013-04-07','09:50:00',2.07),('15087','2013-04-07','09:55:00',2.26),('15087','2013-04-07','10:00:00',2.61),('15087','2013-04-07','10:05:00',2.88),('15087','2013-04-07','10:10:00',2.88),('15087','2013-04-07','10:15:00',2.96),('15087','2013-04-07','10:20:00',2.99),('15087','2013-04-07','10:25:00',3.11),('15087','2013-04-07','10:30:00',2.72),('15087','2013-04-07','10:35:00',2.77),('15087','2013-04-07','10:40:00',2.96),('15087','2013-04-07','10:45:00',2.87),('15087','2013-04-07','10:50:00',2.81),('15087','2013-04-07','10:55:00',2.48),('15087','2013-04-07','11:00:00',2.3),('15087','2013-04-07','11:05:00',2.05),('15087','2013-04-07','11:10:00',2.13),('15087','2013-04-07','11:15:00',2.86),('15087','2013-04-07','11:20:00',3.75),('15087','2013-04-07','11:25:00',3.93),('15087','2013-04-07','11:30:00',4.08),('15087','2013-04-07','11:35:00',3.78),('15087','2013-04-07','11:40:00',3.5),('15087','2013-04-07','11:45:00',2.79),('15087','2013-04-07','11:50:00',2.48),('15087','2013-04-07','11:55:00',2.57),('15087','2013-04-07','12:00:00',2.63),('15087','2013-04-07','12:05:00',2.63),('15087','2013-04-07','12:10:00',2.81),('15087','2013-04-07','12:15:00',2.79),('15087','2013-04-07','12:20:00',2.98),('15087','2013-04-07','12:25:00',3.32),('15087','2013-04-07','12:30:00',3.03),('15087','2013-04-07','12:35:00',3.04),('15087','2013-04-07','12:40:00',3.11),('15087','2013-04-07','12:45:00',2.62),('15087','2013-04-07','12:50:00',2.82),('15087','2013-04-07','12:55:00',2.79),('15087','2013-04-07','13:00:00',3.31),('15087','2013-04-07','13:05:00',3.69),('15087','2013-04-07','13:10:00',3.57),('15087','2013-04-07','13:15:00',3.22),('15087','2013-04-07','13:20:00',3.1),('15087','2013-04-07','13:25:00',3.45),('15087','2013-04-07','13:30:00',3.1),('15087','2013-04-07','13:35:00',3.25),('15087','2013-04-07','13:40:00',3.58),('15087','2013-04-07','13:45:00',3.34),('15087','2013-04-07','13:50:00',2.87),('15087','2013-04-07','13:55:00',3.06),('15087','2013-04-07','14:00:00',3.82),('15087','2013-04-07','14:05:00',3.67),('15087','2013-04-07','14:10:00',1.94),('15087','2013-04-07','14:15:00',2.85),('15087','2013-04-07','14:20:00',2.67),('15087','2013-04-07','14:25:00',1.99),('15087','2013-04-07','14:30:00',1.6),('15087','2013-04-07','14:35:00',1.95),('15087','2013-04-07','14:40:00',2.15),('15087','2013-04-07','14:45:00',1.87),('15087','2013-04-07','14:50:00',2.3),('15087','2013-04-07','14:55:00',2.53),('15087','2013-04-07','15:00:00',1.68),('15087','2013-04-07','15:05:00',2.35),('15087','2013-04-07','15:10:00',2.39),('15087','2013-04-07','15:15:00',2.86),('15087','2013-04-07','15:20:00',2.29),('15087','2013-04-07','15:25:00',2.81),('15087','2013-04-07','15:30:00',2.95),('15087','2013-04-07','15:35:00',2.86),('15087','2013-04-07','15:40:00',2.6),('15087','2013-04-07','15:45:00',2.14),('15087','2013-04-07','15:50:00',2.62),('15087','2013-04-07','15:55:00',2.44),('15087','2013-04-07','16:00:00',2.27),('15087','2013-04-07','16:05:00',2.02),('15087','2013-04-07','16:10:00',1.83),('15087','2013-04-07','16:15:00',1.51),('15087','2013-04-07','16:20:00',1.51),('15087','2013-04-07','16:25:00',1.27),('15087','2013-04-07','16:30:00',1.4),('15087','2013-04-07','16:35:00',1.91),('15087','2013-04-07','16:40:00',1.68),('15087','2013-04-07','16:45:00',2.01),('15087','2013-04-07','16:50:00',2.27),('15087','2013-04-07','16:55:00',2.05),('15087','2013-04-07','17:00:00',2.1),('15087','2013-04-07','17:05:00',1.9),('15087','2013-04-07','17:10:00',1.74),('15087','2013-04-07','17:15:00',1.15),('15087','2013-04-07','17:20:00',1.57),('15087','2013-04-07','17:25:00',1.85),('15087','2013-04-07','17:30:00',1.65),('15087','2013-04-07','17:35:00',1.56),('15087','2013-04-07','17:40:00',1.57),('15087','2013-04-07','17:45:00',1.48),('15087','2013-04-07','17:50:00',1.28),('15087','2013-04-07','17:55:00',1.07),('15087','2013-04-06','08:10:00',1.06),('15087','2013-04-06','08:15:00',1.14),('15087','2013-04-06','08:20:00',1.23),('15087','2013-04-06','08:25:00',1.37),('15087','2013-04-06','08:30:00',1.47),('15087','2013-04-06','08:35:00',1.57),('15087','2013-04-06','08:40:00',1.63),('15087','2013-04-06','08:45:00',1.75),('15087','2013-04-06','08:50:00',1.86),('15087','2013-04-06','08:55:00',1.95),('15087','2013-04-06','09:00:00',2.04),('15087','2013-04-06','09:05:00',2.14),('15087','2013-04-06','09:10:00',2.21),('15087','2013-04-06','09:15:00',2.3),('15087','2013-04-06','09:20:00',2.43),('15087','2013-04-06','09:25:00',2.53),('15087','2013-04-06','09:30:00',2.61),('15087','2013-04-06','09:35:00',2.63),('15087','2013-04-06','09:40:00',2.76),('15087','2013-04-06','09:45:00',2.83),('15087','2013-04-06','09:50:00',2.91),('15087','2013-04-06','09:55:00',2.99),('15087','2013-04-06','10:00:00',3.05),('15087','2013-04-06','10:05:00',3.13),('15087','2013-04-06','10:10:00',3.2),('15087','2013-04-06','10:15:00',3.25),('15087','2013-04-06','10:20:00',3.33),('15087','2013-04-06','10:25:00',3.34),('15087','2013-04-06','10:30:00',3.41),('15087','2013-04-06','10:35:00',3.47),('15087','2013-04-06','10:40:00',3.56),('15087','2013-04-06','10:45:00',3.6),('15087','2013-04-06','10:50:00',3.63),('15087','2013-04-06','10:55:00',3.69),('15087','2013-04-06','11:00:00',3.78),('15087','2013-04-06','11:05:00',3.83),('15087','2013-04-06','11:10:00',3.87),('15087','2013-04-06','11:15:00',3.9),('15087','2013-04-06','11:20:00',3.98),('15087','2013-04-06','11:25:00',3.98),('15087','2013-04-06','11:30:00',4.03),('15087','2013-04-06','11:35:00',4.05),('15087','2013-04-06','11:40:00',3.99),('15087','2013-04-06','11:45:00',4.06),('15087','2013-04-06','11:50:00',4.13),('15087','2013-04-06','11:55:00',4.12),('15087','2013-04-06','12:00:00',4.13),('15087','2013-04-06','12:05:00',4.25),('15087','2013-04-06','12:10:00',4.26),('15087','2013-04-06','12:15:00',4.32),('15087','2013-04-06','12:20:00',4.36),('15087','2013-04-06','12:25:00',4.39),('15087','2013-04-06','12:30:00',4.41),('15087','2013-04-06','12:35:00',4.48),('15087','2013-04-06','12:40:00',4.46),('15087','2013-04-06','12:45:00',4.48),('15087','2013-04-06','12:50:00',4.49),('15087','2013-04-06','12:55:00',4.45),('15087','2013-04-06','13:00:00',2.93),('15087','2013-04-06','13:05:00',4.51),('15087','2013-04-06','13:10:00',4.65),('15087','2013-04-06','13:15:00',5),('15087','2013-04-06','13:20:00',2.69),('15087','2013-04-06','13:25:00',1.91),('15087','2013-04-06','13:30:00',4.44),('15087','2013-04-06','13:35:00',4.21),('15087','2013-04-06','13:40:00',1.2),('15087','2013-04-06','13:45:00',2.13),('15087','2013-04-06','13:50:00',5.02),('15087','2013-04-06','13:55:00',5.07),('15087','2013-04-06','14:00:00',4.98),('15087','2013-04-06','14:05:00',4.84),('15087','2013-04-06','14:10:00',4.7),('15087','2013-04-06','14:15:00',2.89),('15087','2013-04-06','14:20:00',2.37),('15087','2013-04-06','14:25:00',1.54),('15087','2013-04-06','14:30:00',3.3),('15087','2013-04-06','14:35:00',4.14),('15087','2013-04-06','14:40:00',4.09),('15087','2013-04-06','14:45:00',3.29),('15087','2013-04-06','14:50:00',3.91),('15087','2013-04-06','14:55:00',2.44),('15087','2013-04-06','15:00:00',3.74),('15087','2013-04-06','15:05:00',3.69),('15087','2013-04-06','15:10:00',3.59),('15087','2013-04-06','15:15:00',3.41),('15087','2013-04-06','15:20:00',3.26),('15087','2013-04-06','15:25:00',3.05),('15087','2013-04-06','15:30:00',3.16),('15087','2013-04-06','15:35:00',3.1),('15087','2013-04-06','15:40:00',3.06),('15087','2013-04-06','15:45:00',2.56),('15087','2013-04-06','15:50:00',2.64),('15087','2013-04-06','15:55:00',2.86),('15087','2013-04-06','16:00:00',2.64),('15087','2013-04-06','16:05:00',2.72),('15087','2013-04-06','16:10:00',2.61),('15087','2013-04-06','16:15:00',2.59),('15087','2013-04-06','16:20:00',2.03),('15087','2013-04-06','16:25:00',1.76),('15087','2013-04-06','16:30:00',2.23),('15087','2013-04-06','16:35:00',2.01),('15087','2013-04-06','16:40:00',1.68),('15087','2013-04-06','16:45:00',2.14),('15087','2013-04-06','16:50:00',1.97),('15087','2013-04-06','16:55:00',1.75),('15087','2013-04-06','17:00:00',1.83),('15087','2013-04-06','17:05:00',1.54),('15087','2013-04-06','17:10:00',1.35),('15087','2013-04-06','17:15:00',1.08),('15087','2013-04-05','08:20:00',1.36),('15087','2013-04-05','09:05:00',2.34),('15087','2013-04-05','09:10:00',1.35),('15087','2013-04-05','09:15:00',2.49),('15087','2013-04-05','09:20:00',2.63),('15087','2013-04-05','09:25:00',1.1),('15087','2013-04-05','09:35:00',1.04),('15087','2013-04-05','09:40:00',2.55),('15087','2013-04-05','09:45:00',1.85),('15087','2013-04-05','09:50:00',1.29),('15087','2013-04-05','10:00:00',1.74),('15087','2013-04-05','10:05:00',1.12),('15087','2013-04-05','10:10:00',3.04),('15087','2013-04-05','10:15:00',3.23),('15087','2013-04-05','10:20:00',1.2),('15087','2013-04-05','10:25:00',3.24),('15087','2013-04-05','10:30:00',1.97),('15087','2013-04-05','10:35:00',2.15),('15087','2013-04-05','10:40:00',4.25),('15087','2013-04-05','10:45:00',1.52),('15087','2013-04-05','10:50:00',2.19),('15087','2013-04-05','10:55:00',2.96),('15087','2013-04-05','11:00:00',2.97),('15087','2013-04-05','11:05:00',3.23),('15087','2013-04-05','11:10:00',4.28),('15087','2013-04-05','11:15:00',3.47),('15087','2013-04-05','11:20:00',3.67),('15087','2013-04-05','11:25:00',3.24),('15087','2013-04-05','11:30:00',4.31),('15087','2013-04-05','11:35:00',4.53),('15087','2013-04-05','11:40:00',4.15),('15087','2013-04-05','11:45:00',3.81),('15087','2013-04-05','11:50:00',4.5),('15087','2013-04-05','11:55:00',4.58),('15087','2013-04-05','12:00:00',4.67),('15087','2013-04-05','12:05:00',2.8),('15087','2013-04-05','12:10:00',1.95),('15087','2013-04-05','12:15:00',3.35),('15087','2013-04-05','12:20:00',1.68),('15087','2013-04-05','12:25:00',2.5),('15087','2013-04-05','12:30:00',1.39),('15087','2013-04-05','12:35:00',1.46),('15087','2013-04-05','12:40:00',1.86),('15087','2013-04-05','12:45:00',3.55),('15087','2013-04-05','12:50:00',4.22),('15087','2013-04-05','12:55:00',3.68),('15087','2013-04-05','13:00:00',3.81),('15087','2013-04-05','13:05:00',3.62),('15087','2013-04-05','13:10:00',3.15),('15087','2013-04-05','13:15:00',4.19),('15087','2013-04-05','13:20:00',4.21),('15087','2013-04-05','13:25:00',3.5),('15087','2013-04-05','13:30:00',4.08),('15087','2013-04-05','13:35:00',3.91),('15087','2013-04-05','13:40:00',3.68),('15087','2013-04-05','13:45:00',4.06),('15087','2013-04-05','13:50:00',4.38),('15087','2013-04-05','13:55:00',3.31),('15087','2013-04-05','14:00:00',3.32),('15087','2013-04-05','14:05:00',4.85),('15087','2013-04-05','14:10:00',4.26),('15087','2013-04-05','14:15:00',4.36),('15087','2013-04-05','14:20:00',3.58),('15087','2013-04-05','14:25:00',4.21),('15087','2013-04-05','14:30:00',4.04),('15087','2013-04-05','14:35:00',3.78),('15087','2013-04-05','14:40:00',4.01),('15087','2013-04-05','14:45:00',2.69),('15087','2013-04-05','14:50:00',2.85),('15087','2013-04-05','14:55:00',4.35),('15087','2013-04-05','15:00:00',3.83),('15087','2013-04-05','15:05:00',3.83),('15087','2013-04-05','15:10:00',2.38),('15087','2013-04-05','15:15:00',1.62),('15087','2013-04-05','15:20:00',1.72),('15087','2013-04-05','15:25:00',1.81),('15087','2013-04-05','15:30:00',1.58),('15087','2013-04-05','15:35:00',1.24),('15087','2013-04-05','15:40:00',1.12),('15087','2013-04-05','15:45:00',1.4),('15087','2013-04-05','15:50:00',1.78),('15087','2013-04-05','15:55:00',1.69),('15087','2013-04-05','16:00:00',1.73),('15087','2013-04-05','16:05:00',1.64),('15087','2013-04-05','16:10:00',1.71),('15087','2013-04-05','16:15:00',2.03),('15087','2013-04-05','16:20:00',1.69),('15087','2013-04-05','16:25:00',1.45),('15087','2013-04-05','16:30:00',1.59),('15087','2013-04-05','16:35:00',1.8),('15087','2013-04-05','16:40:00',1.57),('15087','2013-04-05','16:45:00',1.98),('15087','2013-04-05','16:50:00',2.46),('15087','2013-04-05','16:55:00',1.3),('15087','2013-04-05','17:00:00',1.24),('15087','2013-04-05','17:05:00',1.06),('15087','2013-04-05','17:10:00',2.63),('15087','2013-04-05','17:15:00',2.15),('15087','2013-04-05','17:20:00',1.74),('15087','2013-04-05','17:25:00',1.92),('15087','2013-04-05','17:30:00',1.35),('15087','2013-04-05','17:35:00',1.59),('15087','2013-04-05','17:40:00',1.07),('15087','2013-04-05','17:50:00',1.08),('15087','2013-04-05','17:55:00',1.41),('15087','2013-04-04','08:55:00',1.46),('15087','2013-04-04','09:00:00',2.16),('15087','2013-04-04','09:05:00',1.48),('15087','2013-04-04','09:10:00',1.44),('15087','2013-04-04','09:15:00',1.41),('15087','2013-04-04','09:20:00',1.29),('15087','2013-04-04','09:25:00',1.04),('15087','2013-04-04','09:30:00',1.68),('15087','2013-04-04','09:35:00',2.78),('15087','2013-04-04','09:40:00',2.48),('15087','2013-04-04','09:45:00',2.18),('15087','2013-04-04','09:50:00',1.13),('15087','2013-04-04','09:55:00',1.34),('15087','2013-04-04','10:00:00',2.05),('15087','2013-04-04','10:05:00',2.65),('15087','2013-04-04','10:10:00',2.17),('15087','2013-04-04','10:15:00',1.71),('15087','2013-04-04','10:20:00',2.05),('15087','2013-04-04','10:25:00',3.94),('15087','2013-04-04','10:30:00',3.18),('15087','2013-04-04','10:35:00',2.14),('15087','2013-04-04','10:40:00',4.07),('15087','2013-04-04','10:45:00',2.18),('15087','2013-04-04','10:50:00',2.52),('15087','2013-04-04','10:55:00',4.2),('15087','2013-04-04','11:00:00',2.44),('15087','2013-04-04','11:05:00',1.27),('15087','2013-04-04','11:10:00',1.13),('15087','2013-04-04','11:15:00',1.59),('15087','2013-04-04','11:20:00',1.44),('15087','2013-04-04','11:25:00',1.08),('15087','2013-04-04','11:30:00',1.2),('15087','2013-04-04','11:35:00',1.91),('15087','2013-04-04','11:40:00',3.21),('15087','2013-04-04','11:45:00',3.69),('15087','2013-04-04','11:50:00',3.98),('15087','2013-04-04','11:55:00',3.59),('15087','2013-04-04','12:00:00',2.7),('15087','2013-04-04','12:05:00',4.33),('15087','2013-04-04','12:10:00',4.37),('15087','2013-04-04','12:15:00',3.84),('15087','2013-04-04','12:20:00',3.41),('15087','2013-04-04','12:25:00',3.06),('15087','2013-04-04','12:30:00',3.64),('15087','2013-04-04','12:35:00',4.51),('15087','2013-04-04','12:40:00',4.62),('15087','2013-04-04','12:45:00',4.23),('15087','2013-04-04','12:50:00',3.5),('15087','2013-04-04','12:55:00',3.92),('15087','2013-04-04','13:00:00',4.14),('15087','2013-04-04','13:05:00',4.12),('15087','2013-04-04','13:10:00',4.29),('15087','2013-04-04','13:15:00',4.4),('15087','2013-04-04','13:20:00',4.24),('15087','2013-04-04','13:25:00',4.43),('15087','2013-04-04','13:30:00',4.24),('15087','2013-04-04','13:35:00',3.85),('15087','2013-04-04','13:40:00',3.28),('15087','2013-04-04','13:45:00',3.61),('15087','2013-04-04','13:50:00',3.48),('15087','2013-04-04','13:55:00',2.68),('15087','2013-04-04','14:00:00',2.92),('15087','2013-04-04','14:05:00',3.88),('15087','2013-04-04','14:10:00',4.18),('15087','2013-04-04','14:15:00',4.06),('15087','2013-04-04','14:20:00',4.05),('15087','2013-04-04','14:25:00',3.89),('15087','2013-04-04','14:30:00',3.87),('15087','2013-04-04','14:35:00',3.55),('15087','2013-04-04','14:40:00',3.86),('15087','2013-04-04','14:45:00',3.69),('15087','2013-04-04','14:50:00',3.71),('15087','2013-04-04','14:55:00',3.66),('15087','2013-04-04','15:00:00',3.62),('15087','2013-04-04','15:05:00',3.47),('15087','2013-04-04','15:10:00',3.32),('15087','2013-04-04','15:15:00',3.21),('15087','2013-04-04','15:20:00',3.23),('15087','2013-04-04','15:25:00',3.34),('15087','2013-04-04','15:30:00',3.28),('15087','2013-04-04','15:35:00',3.06),('15087','2013-04-04','15:40:00',3),('15087','2013-04-04','15:45:00',3.01),('15087','2013-04-04','15:50:00',2.88),('15087','2013-04-04','15:55:00',2.91),('15087','2013-04-04','16:00:00',2.81),('15087','2013-04-04','16:05:00',2.68),('15087','2013-04-04','16:10:00',2.6),('15087','2013-04-04','16:15:00',2.49),('15087','2013-04-04','16:20:00',2.36),('15087','2013-04-04','16:25:00',2.22),('15087','2013-04-04','16:30:00',1.85),('15087','2013-04-04','16:35:00',1.81),('15087','2013-04-04','16:40:00',1.95),('15087','2013-04-04','16:45:00',1.69),('15087','2013-04-04','16:50:00',1.64),('15087','2013-04-04','16:55:00',1.85),('15087','2013-04-04','17:00:00',1.7),('15087','2013-04-04','17:05:00',1.66),('15087','2013-04-04','17:10:00',1.56),('15087','2013-04-04','17:15:00',1.37),('15087','2013-04-04','17:25:00',1.03),('15087','2013-04-04','17:55:00',1.07),('15087','2013-04-03','08:15:00',1.17),('15087','2013-04-03','08:20:00',1.33),('15087','2013-04-03','08:25:00',1.19),('15087','2013-04-03','08:30:00',1.58),('15087','2013-04-03','08:40:00',1.02),('15087','2013-04-03','08:45:00',1.8),('15087','2013-04-03','08:50:00',1.97),('15087','2013-04-03','08:55:00',2.06),('15087','2013-04-03','09:00:00',2.16),('15087','2013-04-03','09:05:00',2.28),('15087','2013-04-03','09:10:00',2.45),('15087','2013-04-03','09:15:00',2.55),('15087','2013-04-03','09:20:00',2.56),('15087','2013-04-03','09:25:00',3.07),('15087','2013-04-03','09:30:00',2.67),('15087','2013-04-03','09:35:00',1.59),('15087','2013-04-03','09:40:00',3.05),('15087','2013-04-03','09:45:00',2.84),('15087','2013-04-03','09:50:00',2.88),('15087','2013-04-03','09:55:00',2.39),('15087','2013-04-03','10:00:00',1.98),('15087','2013-04-03','10:05:00',1.23),('15087','2013-04-03','10:10:00',1.36),('15087','2013-04-03','10:15:00',2.48),('15087','2013-04-03','10:20:00',4.19),('15087','2013-04-03','10:25:00',3.48),('15087','2013-04-03','10:30:00',4.33),('15087','2013-04-03','10:35:00',2.58),('15087','2013-04-03','10:40:00',1.79),('15087','2013-04-03','10:45:00',1.54),('15087','2013-04-03','10:50:00',1.65),('15087','2013-04-03','10:55:00',2.25),('15087','2013-04-03','11:00:00',4.52),('15087','2013-04-03','11:05:00',3.62),('15087','2013-04-03','11:10:00',2.45),('15087','2013-04-03','11:15:00',4.78),('15087','2013-04-03','11:20:00',4.07),('15087','2013-04-03','11:25:00',1.89),('15087','2013-04-03','11:30:00',2.1),('15087','2013-04-03','11:35:00',3.08),('15087','2013-04-03','11:40:00',1.65),('15087','2013-04-03','11:45:00',2.18),('15087','2013-04-03','11:50:00',4.34),('15087','2013-04-03','11:55:00',2.62),('15087','2013-04-03','12:00:00',3.15),('15087','2013-04-03','12:05:00',4.65),('15087','2013-04-03','12:10:00',2.89),('15087','2013-04-03','12:15:00',3.44),('15087','2013-04-03','12:20:00',4.17),('15087','2013-04-03','12:25:00',5.14),('15087','2013-04-03','12:30:00',4.73),('15087','2013-04-03','12:35:00',5.42),('15087','2013-04-03','12:40:00',5.02),('15087','2013-04-03','12:45:00',4.88),('15087','2013-04-03','12:50:00',5.23),('15087','2013-04-03','12:55:00',2.36),('15087','2013-04-03','13:05:00',4.39),('15087','2013-04-03','13:10:00',3.69),('15087','2013-04-03','13:15:00',4.93),('15087','2013-04-03','13:20:00',2.7),('15087','2013-04-03','13:25:00',2.76),('15087','2013-04-03','13:30:00',3.72),('15087','2013-04-03','13:35:00',4.33),('15087','2013-04-03','13:40:00',4.09),('15087','2013-04-03','13:45:00',2.63),('15087','2013-04-03','13:50:00',4),('15087','2013-04-03','13:55:00',3.12),('15087','2013-04-03','14:00:00',4.33),('15087','2013-04-03','14:05:00',2.99),('15087','2013-04-03','14:10:00',3.81),('15087','2013-04-03','14:15:00',1.96),('15087','2013-04-03','14:20:00',3.29),('15087','2013-04-03','14:25:00',2.41),('15087','2013-04-03','14:30:00',4.47),('15087','2013-04-03','14:35:00',4.22),('15087','2013-04-03','14:40:00',2.12),('15087','2013-04-03','14:45:00',3.24),('15087','2013-04-03','14:50:00',4.13),('15087','2013-04-03','14:55:00',3.99),('15087','2013-04-03','15:00:00',3.58),('15087','2013-04-03','15:05:00',3.74),('15087','2013-04-03','15:10:00',3.77),('15087','2013-04-03','15:15:00',3.96),('15087','2013-04-03','15:20:00',3.36),('15087','2013-04-03','15:25:00',3.88),('15087','2013-04-03','15:30:00',2.16),('15087','2013-04-03','15:35:00',2.72),('15087','2013-04-03','15:40:00',2.98),('15087','2013-04-03','15:45:00',2.79),('15087','2013-04-03','15:50:00',3.74),('15087','2013-04-03','15:55:00',3.56),('15087','2013-04-03','16:00:00',3.37),('15087','2013-04-03','16:05:00',3.34),('15087','2013-04-03','16:10:00',2.97),('15087','2013-04-03','16:15:00',3.03),('15087','2013-04-03','16:20:00',2.96),('15087','2013-04-03','16:25:00',2.91),('15087','2013-04-03','16:30:00',2.85),('15087','2013-04-03','16:35:00',2.39),('15087','2013-04-03','16:40:00',2.63),('15087','2013-04-03','16:45:00',2.43),('15087','2013-04-03','16:50:00',2.46),('15087','2013-04-03','16:55:00',2.37),('15087','2013-04-03','17:00:00',2.27),('15087','2013-04-03','17:05:00',2.14),('15087','2013-04-03','17:10:00',2.01),('15087','2013-04-03','17:15:00',1.93),('15087','2013-04-03','17:20:00',1.8),('15087','2013-04-03','17:25:00',1.63),('15087','2013-04-03','17:30:00',1.49),('15087','2013-04-03','17:35:00',1.41),('15087','2013-04-03','17:40:00',1.34),('15087','2013-04-03','17:45:00',1.24),('15087','2013-04-03','17:50:00',1.14),('15087','2013-04-03','17:55:00',1.02),('15087','2013-04-02','08:40:00',1.73),('15087','2013-04-02','08:45:00',1.82),('15087','2013-04-02','08:50:00',1.34),('15087','2013-04-02','08:55:00',1.36),('15087','2013-04-02','09:00:00',2.08),('15087','2013-04-02','09:05:00',2.16),('15087','2013-04-02','09:10:00',1.87),('15087','2013-04-02','09:15:00',1.66),('15087','2013-04-02','09:20:00',2.03),('15087','2013-04-02','09:25:00',1.54),('15087','2013-04-02','09:30:00',1.7),('15087','2013-04-02','09:35:00',2.66),('15087','2013-04-02','09:40:00',3.06),('15087','2013-04-02','09:45:00',2.46),('15087','2013-04-02','09:50:00',2.2),('15087','2013-04-02','09:55:00',2.28),('15087','2013-04-02','10:00:00',2.39),('15087','2013-04-02','10:05:00',1.44),('15087','2013-04-02','10:10:00',1.36),('15087','2013-04-02','10:15:00',1.37),('15087','2013-04-02','10:20:00',1.85),('15087','2013-04-02','10:25:00',2.14),('15087','2013-04-02','10:35:00',3.35),('15087','2013-04-02','10:40:00',2.29),('15087','2013-04-02','10:45:00',2.54),('15087','2013-04-02','10:50:00',4.25),('15087','2013-04-02','10:55:00',1.49),('15087','2013-04-02','11:00:00',1.15),('15087','2013-04-02','11:05:00',3.34),('15087','2013-04-02','11:10:00',1.73),('15087','2013-04-02','11:15:00',1.19),('15087','2013-04-02','11:25:00',1.21),('15087','2013-04-02','11:30:00',1.35),('15087','2013-04-02','11:35:00',1.3),('15087','2013-04-02','11:40:00',1.06),('15087','2013-04-02','11:45:00',2.74),('15087','2013-04-02','11:50:00',2.49),('15087','2013-04-02','11:55:00',1.11),('15087','2013-04-02','12:00:00',1.1),('15087','2013-04-02','12:05:00',3.31),('15087','2013-04-02','12:10:00',2),('15087','2013-04-02','12:15:00',2.17),('15087','2013-04-02','12:30:00',1.03),('15087','2013-04-02','12:35:00',1.92),('15087','2013-04-02','12:40:00',2.18),('15087','2013-04-02','12:45:00',2.56),('15087','2013-04-02','12:50:00',2.41),('15087','2013-04-02','12:55:00',2.35),('15087','2013-04-02','13:00:00',2.72),('15087','2013-04-02','13:05:00',2.75),('15087','2013-04-02','13:10:00',3.46),('15087','2013-04-02','13:15:00',2.68),('15087','2013-04-02','13:20:00',2.16),('15087','2013-04-02','13:25:00',3.59),('15087','2013-04-02','13:30:00',2.66),('15087','2013-04-02','13:35:00',2.11),('15087','2013-04-02','13:40:00',3.16),('15087','2013-04-02','13:45:00',2.9),('15087','2013-04-02','13:50:00',2.31),('15087','2013-04-02','13:55:00',2.19),('15087','2013-04-02','14:00:00',2.5),('15087','2013-04-02','14:05:00',2.14),('15087','2013-04-02','14:10:00',2.75),('15087','2013-04-02','14:15:00',2.42),('15087','2013-04-02','14:20:00',3.85),('15087','2013-04-02','14:25:00',4.31),('15087','2013-04-02','14:30:00',2.6),('15087','2013-04-02','14:35:00',2.11),('15087','2013-04-02','14:40:00',2.83),('15087','2013-04-02','14:45:00',2.96),('15087','2013-04-02','14:50:00',2.06),('15087','2013-04-02','14:55:00',1.82),('15087','2013-04-02','15:00:00',1.55),('15087','2013-04-02','15:45:00',1.21),('15087','2013-04-02','16:00:00',1.12),('15087','2013-04-02','16:05:00',1.18),('15087','2013-04-02','16:15:00',1.11),('15087','2013-04-02','16:20:00',1.04),('15087','2014-05-02','07:40:00',1.08),('15087','2014-05-02','07:45:00',1.17),('15087','2014-05-02','07:50:00',1.27),('15087','2014-05-02','07:55:00',1.49),('15087','2014-05-02','08:00:00',1.6),('15087','2014-05-02','08:05:00',1.46),('15087','2014-05-02','08:15:00',2.55),('15087','2014-05-02','08:20:00',1.96),('15087','2014-05-02','08:25:00',1.12),('15087','2014-05-02','08:45:00',1.35),('15087','2014-05-02','08:50:00',1.98),('15087','2014-05-02','09:15:00',1.31),('15087','2014-05-02','09:20:00',1.63),('15087','2014-05-02','09:25:00',1.91),('15087','2014-05-02','09:30:00',2.17),('15087','2014-05-02','09:35:00',2.04),('15087','2014-05-02','09:40:00',1.85),('15087','2014-05-02','09:45:00',1.92),('15087','2014-05-02','09:50:00',1.72),('15087','2014-05-02','09:55:00',1.67),('15087','2014-05-02','10:00:00',2.04),('15087','2014-05-02','10:05:00',2.31),('15087','2014-05-02','10:10:00',2),('15087','2014-05-02','10:15:00',1.76),('15087','2014-05-02','10:20:00',1.62),('15087','2014-05-02','10:25:00',1.32),('15087','2014-05-02','10:40:00',1.07),('15087','2014-05-02','10:45:00',1.38),('15087','2014-05-02','10:50:00',1.12),('15087','2014-05-02','12:30:00',1.13),('15087','2014-05-02','12:35:00',1.25),('15087','2014-05-02','12:40:00',1.27),('15087','2014-05-02','12:45:00',1.72),('15087','2014-05-02','12:50:00',2.09),('15087','2014-05-02','12:55:00',1.6),('15087','2014-05-02','13:00:00',1.81),('15087','2014-05-02','13:05:00',2.02),('15087','2014-05-02','13:10:00',2.04),('15087','2014-05-02','13:15:00',2.79),('15087','2014-05-02','13:20:00',3.42),('15087','2014-05-02','13:25:00',3.89),('15087','2014-05-02','13:30:00',2.81),('15087','2014-05-02','13:35:00',3.2),('15087','2014-05-02','13:40:00',2.66),('15087','2014-05-02','13:45:00',2.3),('15087','2014-05-02','13:50:00',1.92),('15087','2014-05-02','13:55:00',1.46),('15087','2014-05-02','14:00:00',1.58),('15087','2014-05-02','14:05:00',2.75),('15087','2014-05-02','14:10:00',1),('15087','2014-05-02','14:30:00',1.16),('15087','2014-05-02','14:35:00',1.83),('15087','2014-05-02','14:40:00',3.16),('15087','2014-05-02','14:45:00',1.74),('15087','2014-05-02','14:50:00',1.52),('15087','2014-05-02','14:55:00',2.2),('15087','2014-05-02','15:00:00',2.62),('15087','2014-05-02','15:05:00',2.24),('15087','2014-05-02','15:10:00',4.49),('15087','2014-05-02','15:15:00',3.39),('15087','2014-05-02','15:20:00',2.86),('15087','2014-05-02','15:25:00',1.69),('15087','2014-05-02','15:30:00',1.39),('15087','2014-05-02','15:35:00',2.93),('15087','2014-05-02','15:40:00',3.74),('15087','2014-05-02','15:45:00',1.4),('15087','2014-05-02','16:00:00',1.56),('15087','2014-05-02','16:05:00',1.92),('15087','2014-05-02','16:10:00',1.14),('15087','2014-05-02','16:15:00',1.33),('15087','2014-05-02','16:20:00',2.33),('15087','2014-05-02','17:20:00',1.06),('15087','2014-05-02','17:25:00',1.26),('15087','2013-04-01','08:25:00',1.35),('15087','2013-04-01','08:30:00',1.33),('15087','2013-04-01','08:35:00',1.56),('15087','2013-04-01','08:40:00',1.42),('15087','2013-04-01','08:55:00',1.54),('15087','2013-04-01','09:00:00',2.03),('15087','2013-04-01','09:05:00',2.16),('15087','2013-04-01','09:10:00',2.31),('15087','2013-04-01','09:15:00',1.46),('15087','2013-04-01','09:20:00',1.73),('15087','2013-04-01','09:25:00',1.84),('15087','2013-04-01','09:30:00',1.9),('15087','2013-04-01','09:35:00',2.4),('15087','2013-04-01','09:40:00',1.77),('15087','2013-04-01','09:45:00',2.98),('15087','2013-04-01','09:50:00',3.04),('15087','2013-04-01','09:55:00',2.91),('15087','2013-04-01','10:00:00',3.28),('15087','2013-04-01','10:05:00',3.32),('15087','2013-04-01','10:10:00',2.48),('15087','2013-04-01','10:15:00',2.99),('15087','2013-04-01','10:20:00',1.63),('15087','2013-04-01','10:25:00',3.31),('15087','2013-04-01','10:30:00',2.47),('15087','2013-04-01','10:35:00',1.36),('15087','2013-04-01','10:40:00',2.06),('15087','2013-04-01','10:45:00',3.98),('15087','2013-04-01','10:50:00',1.9),('15087','2013-04-01','10:55:00',2.07),('15087','2013-04-01','11:00:00',1.2),('15087','2013-04-01','11:05:00',1.58),('15087','2013-04-01','11:10:00',2.95),('15087','2013-04-01','11:15:00',2.7),('15087','2013-04-01','11:20:00',3.9),('15087','2013-04-01','11:25:00',1.87),('15087','2013-04-01','11:30:00',1.69),('15087','2013-04-01','11:35:00',2.03),('15087','2013-04-01','11:40:00',3.21),('15087','2013-04-01','11:45:00',3.22),('15087','2013-04-01','11:50:00',2.73),('15087','2013-04-01','11:55:00',2.4),('15087','2013-04-01','12:00:00',3.16),('15087','2013-04-01','12:05:00',1.94),('15087','2013-04-01','12:10:00',2.57),('15087','2013-04-01','12:15:00',2.07),('15087','2013-04-01','12:20:00',1.74),('15087','2013-04-01','12:25:00',1.99),('15087','2013-04-01','12:30:00',2.84),('15087','2013-04-01','12:35:00',2.6),('15087','2013-04-01','12:40:00',2.64),('15087','2013-04-01','12:45:00',2.96),('15087','2013-04-01','12:50:00',3.15),('15087','2013-04-01','12:55:00',3.32),('15087','2013-04-01','13:00:00',3.29),('15087','2013-04-01','13:05:00',3.5),('15087','2013-04-01','13:10:00',3.12),('15087','2013-04-01','13:15:00',3.33),('15087','2013-04-01','13:20:00',3.12),('15087','2013-04-01','13:25:00',3),('15087','2013-04-01','13:30:00',3.23),('15087','2013-04-01','13:35:00',2.91),('15087','2013-04-01','13:40:00',3.9),('15087','2013-04-01','13:45:00',4.14),('15087','2013-04-01','13:50:00',4.58),('15087','2013-04-01','13:55:00',4.37),('15087','2013-04-01','14:00:00',2.57),('15087','2013-04-01','14:05:00',2.04),('15087','2013-04-01','14:10:00',2.64),('15087','2013-04-01','14:15:00',2.88),('15087','2013-04-01','14:20:00',3.07),('15087','2013-04-01','14:25:00',4.47),('15087','2013-04-01','14:30:00',2.75),('15087','2013-04-01','14:35:00',2.37),('15087','2013-04-01','14:40:00',2.05),('15087','2013-04-01','14:45:00',2.1),('15087','2013-04-01','14:50:00',2.27),('15087','2013-04-01','14:55:00',2.39),('15087','2013-04-01','15:00:00',2.16),('15087','2013-04-01','15:05:00',2.16),('15087','2013-04-01','15:10:00',2.22),('15087','2013-04-01','15:15:00',2.38),('15087','2013-04-01','15:20:00',2.47),('15087','2013-04-01','15:25:00',2.5),('15087','2013-04-01','15:30:00',2.2),('15087','2013-04-01','15:35:00',2.73),('15087','2013-04-01','15:40:00',2.55),('15087','2013-04-01','15:45:00',2.65),('15087','2013-04-01','15:50:00',2.9),('15087','2013-04-01','15:55:00',2.21),('15087','2013-04-01','16:00:00',2.06),('15087','2013-04-01','16:05:00',1.65),('15087','2013-04-01','16:10:00',1.35),('15087','2013-04-01','16:15:00',1.08),('15087','2013-04-01','16:20:00',1.05),('15087','2013-03-31','08:30:00',1.03),('15087','2013-03-31','08:35:00',1.08),('15087','2013-03-31','08:40:00',1.13),('15087','2013-03-31','08:45:00',1.4),('15087','2013-03-31','08:50:00',1.11),('15087','2013-03-31','08:55:00',1.21),('15087','2013-03-31','09:00:00',1.12),('15087','2013-03-31','09:05:00',1.08),('15087','2013-03-31','09:10:00',1.19),('15087','2013-03-31','09:15:00',1.56),('15087','2013-03-31','09:20:00',2.69),('15087','2013-03-31','09:25:00',3.06),('15087','2013-03-31','09:30:00',2.22),('15087','2013-03-31','09:35:00',2.29),('15087','2013-03-31','09:40:00',1.52),('15087','2013-03-31','09:45:00',2.59),('15087','2013-03-31','09:50:00',1.59),('15087','2013-03-31','09:55:00',2.19),('15087','2013-03-31','10:00:00',1.94),('15087','2013-03-31','10:15:00',1.07),('15087','2013-03-31','10:20:00',2.48),('15087','2013-03-31','10:25:00',2.57),('15087','2013-03-31','10:30:00',3.08),('15087','2013-03-31','10:35:00',3.13),('15087','2013-03-31','10:45:00',1.33),('15087','2013-03-31','10:50:00',2.19),('15087','2013-03-31','11:10:00',1.54),('15087','2013-03-31','11:15:00',1.35),('15087','2013-03-31','11:20:00',1.21),('15087','2013-03-31','11:25:00',1.71),('15087','2013-03-31','11:30:00',1.29),('15087','2013-03-31','11:35:00',1.68),('15087','2013-03-31','11:40:00',1.74),('15087','2013-03-31','11:45:00',1.56),('15087','2013-03-31','11:50:00',1.73),('15087','2013-03-31','11:55:00',1.84),('15087','2013-03-31','12:00:00',1.71),('15087','2013-03-31','12:05:00',1.58),('15087','2013-03-31','12:10:00',1.39),('15087','2013-03-31','12:15:00',1.52),('15087','2013-03-31','12:20:00',1.38),('15087','2013-03-31','12:25:00',1.77),('15087','2013-03-31','12:30:00',2.06),('15087','2013-03-31','12:35:00',3.24),('15087','2013-03-31','12:40:00',3.47),('15087','2013-03-31','12:45:00',1.78),('15087','2013-03-31','12:50:00',1.93),('15087','2013-03-31','12:55:00',2.25),('15087','2013-03-31','13:00:00',2.71),('15087','2013-03-31','13:05:00',2.11),('15087','2013-03-31','13:10:00',3.32),('15087','2013-03-31','13:15:00',3.27),('15087','2013-03-31','13:20:00',4.06),('15087','2013-03-31','13:25:00',2.36),('15087','2013-03-31','13:40:00',1.95),('15087','2013-03-31','13:45:00',1.76),('15087','2013-03-31','13:50:00',2.47),('15087','2013-03-31','13:55:00',1.73),('15087','2013-03-31','14:00:00',2.12),('15087','2013-03-31','14:05:00',3.28),('15087','2013-03-31','14:10:00',2.79),('15087','2013-03-31','14:15:00',2.82),('15087','2013-03-31','14:20:00',1.82),('15087','2013-03-31','14:25:00',1.98),('15087','2013-03-31','14:30:00',2.88),('15087','2013-03-31','14:35:00',4.51),('15087','2013-03-31','14:40:00',4.65),('15087','2013-03-31','14:45:00',3.57),('15087','2013-03-31','14:50:00',3.34),('15087','2013-03-31','14:55:00',3.31),('15087','2013-03-31','15:00:00',3.51),('15087','2013-03-31','15:05:00',2.33),('15087','2013-03-31','15:10:00',3.37),('15087','2013-03-31','15:15:00',3.41),('15087','2013-03-31','15:20:00',4.11),('15087','2013-03-31','15:25:00',2.56),('15087','2013-03-31','15:30:00',2.67),('15087','2013-03-31','15:35:00',3.33),('15087','2013-03-31','15:40:00',4.05),('15087','2013-03-31','15:45:00',2.67),('15087','2013-03-31','16:00:00',3.18),('15087','2013-03-31','16:05:00',1.19),('15087','2013-03-31','16:10:00',1.74),('15087','2013-03-31','16:15:00',2.55),('15087','2013-03-31','16:20:00',1.9),('15087','2013-03-31','16:25:00',1.32),('15087','2013-03-31','16:30:00',1.1),('15087','2013-03-31','16:35:00',1.17),('15087','2013-03-31','16:40:00',1.38),('15087','2013-03-31','16:45:00',1.11),('15087','2013-03-31','17:00:00',1.2),('15087','2013-03-31','17:05:00',1.39),('15087','2013-03-31','17:10:00',1.13),('15087','2013-03-31','17:20:00',1.11),('15087','2013-03-31','17:25:00',1.16),('15087','2013-03-31','17:30:00',1.27),('15087','2013-03-31','17:35:00',1.17),('15087','2013-03-31','17:50:00',1.03),('15087','2013-03-31','17:55:00',1.52),('15087','2013-03-31','18:15:00',1.23),('15087','2013-03-30','08:35:00',1.18),('15087','2013-03-30','08:40:00',1.09),('15087','2013-03-30','09:05:00',1.75),('15087','2013-03-30','09:10:00',1.88),('15087','2013-03-30','09:15:00',2.13),('15087','2013-03-30','09:20:00',4.02),('15087','2013-03-30','09:25:00',1.72),('15087','2013-03-30','09:30:00',1.23),('15087','2013-03-30','09:35:00',1.39),('15087','2013-03-30','09:40:00',1.45),('15087','2013-03-30','09:45:00',1.19),('15087','2013-03-30','09:55:00',1.29),('15087','2013-03-30','10:00:00',2.05),('15087','2013-03-30','10:05:00',1.92),('15087','2013-03-30','10:10:00',2.09),('15087','2013-03-30','10:15:00',1.85),('15087','2013-03-30','10:20:00',1.58),('15087','2013-03-30','10:25:00',1.59),('15087','2013-03-30','10:30:00',1.83),('15087','2013-03-30','10:35:00',2.21),('15087','2013-03-30','10:40:00',2.65),('15087','2013-03-30','10:45:00',3.47),('15087','2013-03-30','10:50:00',3.21),('15087','2013-03-30','10:55:00',2.45),('15087','2013-03-30','11:00:00',3.73),('15087','2013-03-30','11:05:00',4.3),('15087','2013-03-30','11:10:00',4.74),('15087','2013-03-30','11:15:00',4.15),('15087','2013-03-30','11:20:00',5.5),('15087','2013-03-30','11:25:00',4.81),('15087','2013-03-30','11:30:00',2.87),('15087','2013-03-30','11:35:00',3.86),('15087','2013-03-30','11:40:00',3.4),('15087','2013-03-30','11:45:00',4.33),('15087','2013-03-30','11:50:00',4.86),('15087','2013-03-30','11:55:00',4.32),('15087','2013-03-30','12:00:00',4.02),('15087','2013-03-30','12:05:00',2.82),('15087','2013-03-30','12:10:00',2.26),('15087','2013-03-30','12:15:00',2.22),('15087','2013-03-30','12:20:00',1.96),('15087','2013-03-30','12:25:00',1.05),('15087','2013-03-30','13:10:00',3.22),('15087','2013-03-30','13:15:00',3.38),('15087','2013-03-30','13:20:00',2.23),('15087','2013-03-30','13:25:00',2.05),('15087','2013-03-30','13:30:00',1.13),('15087','2013-03-30','13:45:00',2.74),('15087','2013-03-30','13:50:00',4.02),('15087','2013-03-30','13:55:00',1.77),('15087','2013-03-30','14:00:00',2.22),('15087','2013-03-30','14:05:00',1.91),('15087','2013-03-30','14:10:00',1.12),('15087','2013-03-30','14:15:00',1.04),('15087','2013-03-30','14:20:00',1.72),('15087','2013-03-30','14:25:00',1.4),('15087','2013-03-30','14:30:00',2),('15087','2013-03-30','14:35:00',2.16),('15087','2013-03-30','14:40:00',1.38),('15087','2013-03-30','14:45:00',1.01),('15087','2013-03-30','14:50:00',1.52),('15087','2013-03-29','07:20:00',1.02),('15087','2013-03-29','07:25:00',1.05),('15087','2013-03-29','07:30:00',1.3),('15087','2013-03-29','07:35:00',1.27),('15087','2013-03-29','07:40:00',1.47),('15087','2013-03-29','07:45:00',1.63),('15087','2013-03-29','07:50:00',1.05),('15087','2013-03-29','08:00:00',1.14),('15087','2013-03-29','08:05:00',1.74),('15087','2013-03-29','08:10:00',2.18),('15087','2013-03-29','08:15:00',2.21),('15087','2013-03-29','08:20:00',2.32),('15087','2013-03-29','08:25:00',2.41),('15087','2013-03-29','08:30:00',2.54),('15087','2013-03-29','08:35:00',2.62),('15087','2013-03-29','08:40:00',2.71),('15087','2013-03-29','08:45:00',2.63),('15087','2013-03-29','08:50:00',2.73),('15087','2013-03-29','08:55:00',2.38),('15087','2013-03-29','09:00:00',2.59),('15087','2013-03-29','09:05:00',2.91),('15087','2013-03-29','09:10:00',2.94),('15087','2013-03-29','09:15:00',3.3),('15087','2013-03-29','09:20:00',3.45),('15087','2013-03-29','09:25:00',3.29),('15087','2013-03-29','09:30:00',3.9),('15087','2013-03-29','09:35:00',3.85),('15087','2013-03-29','09:40:00',3.83),('15087','2013-03-29','09:45:00',3.35),('15087','2013-03-29','09:50:00',3.65),('15087','2013-03-29','09:55:00',3.75),('15087','2013-03-29','10:00:00',3.7),('15087','2013-03-29','10:05:00',3.62),('15087','2013-03-29','10:10:00',3.11),('15087','2013-03-29','10:15:00',3.68),('15087','2013-03-29','10:20:00',3.45),('15087','2013-03-29','10:25:00',3.09),('15087','2013-03-29','10:30:00',3.07),('15087','2013-03-29','10:35:00',3.5),('15087','2013-03-29','10:40:00',4.12),('15087','2013-03-29','10:45:00',3.29),('15087','2013-03-29','10:50:00',3),('15087','2013-03-29','10:55:00',3.79),('15087','2013-03-29','11:00:00',4.28),('15087','2013-03-29','11:05:00',3.93),('15087','2013-03-29','11:10:00',2.1),('15087','2013-03-29','11:15:00',1.83),('15087','2013-03-29','11:20:00',4.89),('15087','2013-03-29','11:25:00',4.87),('15087','2013-03-29','11:30:00',4.65),('15087','2013-03-29','11:35:00',4.54),('15087','2013-03-29','11:40:00',4.59),('15087','2013-03-29','11:45:00',4.58),('15087','2013-03-29','11:50:00',4.66),('15087','2013-03-29','11:55:00',4.67),('15087','2013-03-29','12:00:00',4.66),('15087','2013-03-29','12:05:00',4.76),('15087','2013-03-29','12:10:00',4.71),('15087','2013-03-29','12:15:00',4.38),('15087','2013-03-29','12:30:00',1.34),('15087','2013-03-29','12:35:00',4.27),('15087','2013-03-29','12:40:00',4.41),('15087','2013-03-29','12:45:00',4.21),('15087','2013-03-29','12:50:00',3.22),('15087','2013-03-29','12:55:00',4.06),('15087','2013-03-29','13:00:00',4.27),('15087','2013-03-29','13:05:00',3.79),('15087','2013-03-29','13:10:00',3.33),('15087','2013-03-29','13:15:00',3.23),('15087','2013-03-29','13:20:00',3.73),('15087','2013-03-29','13:25:00',4.28),('15087','2013-03-29','13:30:00',3.83),('15087','2013-03-29','13:35:00',2.46),('15087','2013-03-29','13:40:00',3.45),('15087','2013-03-29','13:45:00',3.69),('15087','2013-03-29','13:50:00',3.45),('15087','2013-03-29','13:55:00',2.3),('15087','2013-03-29','14:00:00',3.7),('15087','2013-03-29','14:05:00',3.05),('15087','2013-03-29','14:10:00',2.58),('15087','2013-03-29','14:15:00',2.58),('15087','2013-03-29','14:20:00',2.58),('15087','2013-03-29','14:25:00',2.69),('15087','2013-03-29','14:30:00',2.25),('15087','2013-03-29','14:35:00',2.23),('15087','2013-03-29','14:40:00',2.17),('15087','2013-03-29','14:45:00',1.96),('15087','2013-03-29','14:50:00',1.9),('15087','2013-03-29','14:55:00',1.84),('15087','2013-03-29','15:00:00',1.62),('15087','2013-03-29','15:05:00',1.64),('15087','2013-03-29','15:10:00',1.53),('15087','2013-03-29','15:15:00',1.52),('15087','2013-03-29','15:20:00',1.4),('15087','2013-03-29','15:25:00',1.27),('15087','2013-03-29','15:30:00',1.17),('15087','2013-03-29','15:35:00',1.11),('15087','2013-03-29','15:40:00',1.06),('15087','2013-03-29','15:45:00',1.03),('15087','2013-03-29','15:50:00',1.14),('15087','2013-03-29','15:55:00',1.34),('15087','2013-03-29','16:00:00',1.71),('15087','2013-03-29','16:05:00',1.62),('15087','2013-03-29','16:10:00',1.11),('15087','2013-03-29','16:15:00',1),('15087','2013-03-29','16:25:00',1.05),('15087','2013-03-29','16:30:00',1.07),('15087','2013-03-29','16:35:00',1.2),('15087','2013-03-29','16:40:00',1.84),('15087','2013-03-29','16:45:00',1.51),('15087','2013-03-29','16:50:00',1.11),('15087','2013-03-29','17:00:00',1.05),('15087','2013-03-28','09:10:00',2.03),('15087','2013-03-28','09:15:00',3.11),('15087','2013-03-28','09:20:00',1.71),('15087','2013-03-28','09:25:00',1.65),('15087','2013-03-28','09:30:00',1.14),('15087','2013-03-28','09:45:00',1.11),('15087','2013-03-28','09:50:00',1.21),('15087','2013-03-28','09:55:00',1.05),('15087','2013-03-28','10:00:00',1.11),('15087','2013-03-28','11:35:00',1.23),('15087','2013-03-28','11:40:00',1.69),('15087','2013-03-28','11:45:00',1.24),('15087','2013-03-28','11:50:00',1.25),('15087','2013-03-28','11:55:00',2.43),('15087','2013-03-28','12:00:00',1.51),('15087','2013-03-28','12:10:00',1.06),('15087','2013-03-28','12:15:00',1.38),('15087','2013-03-28','12:20:00',1.02),('15087','2013-03-28','12:30:00',1.28),('15087','2013-03-28','12:40:00',1.5),('15087','2013-03-28','12:45:00',1.91),('15087','2013-03-28','12:50:00',3.81),('15087','2013-03-28','12:55:00',4.07),('15087','2013-03-28','13:00:00',3.23),('15087','2013-03-28','13:05:00',4.49),('15087','2013-03-28','13:10:00',4.54),('15087','2013-03-28','13:15:00',3.39),('15087','2013-03-28','13:20:00',3.22),('15087','2013-03-28','13:25:00',2.12),('15087','2013-03-28','13:30:00',3),('15087','2013-03-28','13:35:00',3.48),('15087','2013-03-28','13:40:00',2.45),('15087','2013-03-28','13:45:00',2.45),('15087','2013-03-28','13:50:00',2.62),('15087','2013-03-28','13:55:00',1.75),('15087','2013-03-28','14:00:00',2.04),('15087','2013-03-28','14:05:00',2.02),('15087','2013-03-28','14:10:00',1.32),('15087','2013-03-28','14:15:00',1.49),('15087','2013-03-28','14:20:00',1.98),('15087','2013-03-28','14:25:00',1.74),('15087','2013-03-28','14:30:00',2.8),('15087','2013-03-28','14:35:00',1.76),('15087','2013-03-28','14:40:00',1.1),('15087','2013-03-28','14:45:00',1.21),('15087','2013-03-28','14:50:00',1),('15087','2013-03-28','15:00:00',1.28),('15087','2013-03-28','15:05:00',1.48),('15087','2013-03-28','15:10:00',2.68),('15087','2013-03-28','15:15:00',1.93),('15087','2013-03-28','15:20:00',1.87),('15087','2013-03-28','15:25:00',1.01),('15087','2013-03-28','15:30:00',1.61),('15087','2013-03-28','15:35:00',2.26),('15087','2013-03-28','15:40:00',1.62),('15087','2013-03-28','15:45:00',2.11),('15087','2013-03-28','15:50:00',1.49),('15087','2013-03-28','15:55:00',2.73),('15087','2013-03-28','16:00:00',1.25),('15087','2013-03-28','16:05:00',1.08),('15087','2013-03-28','16:10:00',1.6),('15087','2013-03-28','16:35:00',1.54),('15087','2013-03-28','16:40:00',1.03),('15087','2013-03-28','17:00:00',1.39),('15087','2013-03-28','17:05:00',1.17),('15087','2013-03-27','07:25:00',1.07),('15087','2013-03-27','07:30:00',1.13),('15087','2013-03-27','07:40:00',1.19),('15087','2013-03-27','07:55:00',1.4),('15087','2013-03-27','08:00:00',1.52),('15087','2013-03-27','08:05:00',1.55),('15087','2013-03-27','08:10:00',1.4),('15087','2013-03-27','08:15:00',1.58),('15087','2013-03-27','08:20:00',1.36),('15087','2013-03-27','08:25:00',1.66),('15087','2013-03-27','08:30:00',2.16),('15087','2013-03-27','08:35:00',1.8),('15087','2013-03-27','08:40:00',1.31),('15087','2013-03-27','08:45:00',1.4),('15087','2013-03-27','08:50:00',2.03),('15087','2013-03-27','08:55:00',1.35),('15087','2013-03-27','09:00:00',1.54),('15087','2013-03-27','09:05:00',1.2),('15087','2013-03-27','09:15:00',1.75),('15087','2013-03-27','09:20:00',1.66),('15087','2013-03-27','09:25:00',1.09),('15087','2013-03-27','09:40:00',1.02),('15087','2013-03-27','09:45:00',1.83),('15087','2013-03-27','09:50:00',1.72),('15087','2013-03-27','09:55:00',1.57),('15087','2013-03-27','10:00:00',1.57),('15087','2013-03-27','10:10:00',1.53),('15087','2013-03-27','10:15:00',2.08),('15087','2013-03-27','10:20:00',1.54),('15087','2013-03-27','10:25:00',2.06),('15087','2013-03-27','10:30:00',2.64),('15087','2013-03-27','10:35:00',2.21),('15087','2013-03-27','10:40:00',2.54),('15087','2013-03-27','10:45:00',2.28),('15087','2013-03-27','10:50:00',2.56),('15087','2013-03-27','10:55:00',2.31),('15087','2013-03-27','11:00:00',1.98),('15087','2013-03-27','11:05:00',1.76),('15087','2013-03-27','11:10:00',1.84),('15087','2013-03-27','11:15:00',1.98),('15087','2013-03-27','11:20:00',2.03),('15087','2013-03-27','11:25:00',1.9),('15087','2013-03-27','11:30:00',2.1),('15087','2013-03-27','11:35:00',1.97),('15087','2013-03-27','11:40:00',1.75),('15087','2013-03-27','11:45:00',1.95),('15087','2013-03-27','11:50:00',1.89),('15087','2013-03-27','11:55:00',2.97),('15087','2013-03-27','12:00:00',2.88),('15087','2013-03-27','12:05:00',2.7),('15087','2013-03-27','12:10:00',2.33),('15087','2013-03-27','12:15:00',1.85),('15087','2013-03-27','12:20:00',2.06),('15087','2013-03-27','12:25:00',1.93),('15087','2013-03-27','12:30:00',4.35),('15087','2013-03-27','12:35:00',4.12),('15087','2013-03-27','12:40:00',4.29),('15087','2013-03-27','12:45:00',4.08),('15087','2013-03-27','12:50:00',3.05),('15087','2013-03-27','12:55:00',1.73),('15087','2013-03-27','13:00:00',1.66),('15087','2013-03-27','13:05:00',1.68),('15087','2013-03-27','13:10:00',2.32),('15087','2013-03-27','13:15:00',1.79),('15087','2013-03-27','13:20:00',1.4),('15087','2013-03-27','13:25:00',1.47),('15087','2013-03-27','13:30:00',1.69),('15087','2013-03-27','13:35:00',2.54),('15087','2013-03-27','13:40:00',1.79),('15087','2013-03-27','13:45:00',2.07),('15087','2013-03-27','13:50:00',2.34),('15087','2013-03-27','13:55:00',2.13),('15087','2013-03-27','14:00:00',1.9),('15087','2013-03-27','14:05:00',1.65),('15087','2013-03-27','14:10:00',1.71),('15087','2013-03-27','14:15:00',1.96),('15087','2013-03-27','14:20:00',2.44),('15087','2013-03-27','14:25:00',1.96),('15087','2013-03-27','14:30:00',1.6),('15087','2013-03-27','14:35:00',1.94),('15087','2013-03-27','14:40:00',2.72),('15087','2013-03-27','14:45:00',2.54),('15087','2013-03-27','14:50:00',1.88),('15087','2013-03-27','14:55:00',1.27),('15087','2013-03-27','15:00:00',1.01),('15087','2013-03-27','15:05:00',1.37),('15087','2013-03-27','15:10:00',1.43),('15087','2013-03-27','15:15:00',1.04),('15087','2013-03-27','15:20:00',1.01),('15087','2013-03-27','15:25:00',1.05),('15087','2013-03-27','16:40:00',1.02),('15087','2013-03-27','16:45:00',1.2),('15087','2013-03-27','16:50:00',1.06),('15087','2013-03-27','16:55:00',1.24),('15087','2013-03-27','17:00:00',1.24),('15087','2013-03-27','17:05:00',1.37),('15087','2013-03-27','17:10:00',1.16),('15087','2013-03-26','07:45:00',1.28),('15087','2013-03-26','07:50:00',1.8),('15087','2013-03-26','07:55:00',1.69),('15087','2013-03-26','08:30:00',1.01),('15087','2013-03-26','08:35:00',1.65),('15087','2013-03-26','08:40:00',1.63),('15087','2013-03-26','09:10:00',1.29),('15087','2013-03-26','09:15:00',2.04),('15087','2013-03-26','09:20:00',1.07),('15087','2013-03-26','09:50:00',1.57),('15087','2013-03-26','09:55:00',2.72),('15087','2013-03-26','10:00:00',1.14),('15087','2013-03-26','10:50:00',1.05),('15087','2013-03-26','10:55:00',1.06),('15087','2013-03-26','11:00:00',1.26),('15087','2013-03-26','11:05:00',1.17),('15087','2013-03-26','11:10:00',2.43),('15087','2013-03-26','11:15:00',1.82),('15087','2013-03-26','11:20:00',1.94),('15087','2013-03-26','11:45:00',1.3),('15087','2013-03-26','11:50:00',2.5),('15087','2013-03-26','11:55:00',1.05),('15087','2013-03-26','12:00:00',1.58),('15087','2013-03-26','12:05:00',1.36),('15087','2013-03-26','12:10:00',1.49),('15087','2013-03-26','12:15:00',1.57),('15087','2013-03-26','12:20:00',1.71),('15087','2013-03-26','12:25:00',2.49),('15087','2013-03-26','12:30:00',2.11),('15087','2013-03-26','12:35:00',3.49),('15087','2013-03-26','12:40:00',2.06),('15087','2013-03-26','12:45:00',2.69),('15087','2013-03-26','12:50:00',1.83),('15087','2013-03-26','12:55:00',1.16),('15087','2013-03-26','13:00:00',2.16),('15087','2013-03-26','13:05:00',2.61),('15087','2013-03-26','13:10:00',2.75),('15087','2013-03-26','13:15:00',1.79),('15087','2013-03-26','13:20:00',2.14),('15087','2013-03-26','13:25:00',2.3),('15087','2013-03-26','13:30:00',1.85),('15087','2013-03-26','13:35:00',2.38),('15087','2013-03-26','13:40:00',2.57),('15087','2013-03-26','13:45:00',2.22),('15087','2013-03-26','13:50:00',1.86),('15087','2013-03-26','13:55:00',1.7),('15087','2013-03-26','14:00:00',1.64),('15087','2013-03-26','14:05:00',1.63),('15087','2013-03-26','14:10:00',1.72),('15087','2013-03-26','14:15:00',1.57),('15087','2013-03-26','14:20:00',1.28),('15087','2013-03-26','14:25:00',1.18),('15087','2013-03-25','08:20:00',1.14),('15087','2013-03-25','08:25:00',2.6),('15087','2013-03-25','08:30:00',1.52),('15087','2013-03-25','08:55:00',1.27),('15087','2013-03-25','09:00:00',1.13),('15087','2013-03-25','09:05:00',1.12),('15087','2013-03-25','09:10:00',1.31),('15087','2013-03-25','09:15:00',1.23),('15087','2013-03-25','09:20:00',2.55),('15087','2013-03-25','09:25:00',2.5),('15087','2013-03-25','09:30:00',1.64),('15087','2013-03-25','09:35:00',1.06),('15087','2013-03-25','09:45:00',1.23),('15087','2013-03-25','09:50:00',5.15),('15087','2013-03-25','09:55:00',4.86),('15087','2013-03-25','10:00:00',1.2),('15087','2013-03-25','10:05:00',1.24),('15087','2013-03-25','10:10:00',1.26),('15087','2013-03-25','10:15:00',1.19),('15087','2013-03-25','10:20:00',1.71),('15087','2013-03-25','10:25:00',2.85),('15087','2013-03-25','10:30:00',2.49),('15087','2013-03-25','10:35:00',2.05),('15087','2013-03-25','10:40:00',1.99),('15087','2013-03-25','10:45:00',2.79),('15087','2013-03-25','10:50:00',3.13),('15087','2013-03-25','10:55:00',3.79),('15087','2013-03-25','11:00:00',2.59),('15087','2013-03-25','11:05:00',2.53),('15087','2013-03-25','11:10:00',2.43),('15087','2013-03-25','11:15:00',2.51),('15087','2013-03-25','11:20:00',4.3),('15087','2013-03-25','11:25:00',4.12),('15087','2013-03-25','11:30:00',5.49),('15087','2013-03-25','11:35:00',3.31),('15087','2013-03-25','11:40:00',1.38),('15087','2013-03-25','11:45:00',1.79),('15087','2013-03-25','11:50:00',2.04),('15087','2013-03-25','11:55:00',3.41),('15087','2013-03-25','12:00:00',4.81),('15087','2013-03-25','12:05:00',4.25),('15087','2013-03-25','12:10:00',4.38),('15087','2013-03-25','12:15:00',3.88),('15087','2013-03-25','12:20:00',3.1),('15087','2013-03-25','12:25:00',4.35),('15087','2013-03-25','12:30:00',3.67),('15087','2013-03-25','12:35:00',3.14),('15087','2013-03-25','12:40:00',2.88),('15087','2013-03-25','12:45:00',2.78),('15087','2013-03-25','12:50:00',3.06),('15087','2013-03-25','12:55:00',3.5),('15087','2013-03-25','13:00:00',3.92),('15087','2013-03-25','13:05:00',5.02),('15087','2013-03-25','13:10:00',4.68),('15087','2013-03-25','13:15:00',4.38),('15087','2013-03-25','13:20:00',3.88),('15087','2013-03-25','13:25:00',1.88),('15087','2013-03-25','13:30:00',1.92),('15087','2013-03-25','13:35:00',1.17),('15087','2013-03-25','13:40:00',1.25),('15087','2013-03-25','13:45:00',2.61),('15087','2013-03-25','13:50:00',2.19),('15087','2013-03-25','13:55:00',1.93),('15087','2013-03-25','14:05:00',1.3),('15087','2013-03-25','14:10:00',3.61),('15087','2013-03-25','14:15:00',2.06),('15087','2013-03-25','14:20:00',2.9),('15087','2013-03-25','14:25:00',3.41),('15087','2013-03-25','14:30:00',2.11),('15087','2013-03-25','14:35:00',1.74),('15087','2013-03-25','14:40:00',1.46),('15087','2013-03-25','14:45:00',2.34),('15087','2013-03-25','14:50:00',2.05),('15087','2013-03-25','14:55:00',2.98),('15087','2013-03-25','15:00:00',2.96),('15087','2013-03-25','15:05:00',2.87),('15087','2013-03-25','15:10:00',3.14),('15087','2013-03-25','15:15:00',2.69),('15087','2013-03-25','15:20:00',2.32),('15087','2013-03-25','15:25:00',2.53),('15087','2013-03-25','15:30:00',2.65),('15087','2013-03-25','15:35:00',2.04),('15087','2013-03-25','15:40:00',2.97),('15087','2013-03-25','15:45:00',2.2),('15087','2013-03-25','15:50:00',1.19),('15087','2013-03-25','15:55:00',2.03),('15087','2013-03-25','16:00:00',2.29),('15087','2013-03-25','16:05:00',1.01),('15087','2013-03-25','16:10:00',1.36),('15087','2013-03-25','16:30:00',1.43),('15087','2013-03-25','16:35:00',1.99),('15087','2013-03-25','16:40:00',1.7),('15087','2013-03-24','07:45:00',1.04),('15087','2013-03-24','07:50:00',1.26),('15087','2013-03-24','07:55:00',1.48),('15087','2013-03-24','08:00:00',1.77),('15087','2013-03-24','08:05:00',1.86),('15087','2013-03-24','08:10:00',1.91),('15087','2013-03-24','08:15:00',2.03),('15087','2013-03-24','08:20:00',2.12),('15087','2013-03-24','08:25:00',2.2),('15087','2013-03-24','08:30:00',2.29),('15087','2013-03-24','08:35:00',2.38),('15087','2013-03-24','08:40:00',2.46),('15087','2013-03-24','08:45:00',2.52),('15087','2013-03-24','08:50:00',2.56),('15087','2013-03-24','08:55:00',2.65),('15087','2013-03-24','09:00:00',2.71),('15087','2013-03-24','09:05:00',2.81),('15087','2013-03-24','09:10:00',2.9),('15087','2013-03-24','09:15:00',2.98),('15087','2013-03-24','09:20:00',3.04),('15087','2013-03-24','09:25:00',3.11),('15087','2013-03-24','09:30:00',3.18),('15087','2013-03-24','09:35:00',3.23),('15087','2013-03-24','09:40:00',3.29),('15087','2013-03-24','09:45:00',3.36),('15087','2013-03-24','09:50:00',3.39),('15087','2013-03-24','09:55:00',3.47),('15087','2013-03-24','10:00:00',3.54),('15087','2013-03-24','10:05:00',3.59),('15087','2013-03-24','10:10:00',3.66),('15087','2013-03-24','10:15:00',3.72),('15087','2013-03-24','10:20:00',3.77),('15087','2013-03-24','10:25:00',3.81),('15087','2013-03-24','10:30:00',3.85),('15087','2013-03-24','10:35:00',3.87),('15087','2013-03-24','10:40:00',3.9),('15087','2013-03-24','10:45:00',3.94),('15087','2013-03-24','10:50:00',3.95),('15087','2013-03-24','10:55:00',4.01),('15087','2013-03-24','11:00:00',4.03),('15087','2013-03-24','11:05:00',4.05),('15087','2013-03-24','11:10:00',4.07),('15087','2013-03-24','11:15:00',4.04),('15087','2013-03-24','11:20:00',4.09),('15087','2013-03-24','11:25:00',4.14),('15087','2013-03-24','11:30:00',4.17),('15087','2013-03-24','11:35:00',4.14),('15087','2013-03-24','11:40:00',4.18),('15087','2013-03-24','11:45:00',4.15),('15087','2013-03-24','11:50:00',4.17),('15087','2013-03-24','11:55:00',4.17),('15087','2013-03-24','12:00:00',4.17),('15087','2013-03-24','12:05:00',4.21),('15087','2013-03-24','12:10:00',4.27),('15087','2013-03-24','12:15:00',4.31),('15087','2013-03-24','12:20:00',4.34),('15087','2013-03-24','12:25:00',4.36),('15087','2013-03-24','12:30:00',4.36),('15087','2013-03-24','12:35:00',4.39),('15087','2013-03-24','12:40:00',4.35),('15087','2013-03-24','12:45:00',4.36),('15087','2013-03-24','12:50:00',4.31),('15087','2013-03-24','12:55:00',4.25),('15087','2013-03-24','13:00:00',4.19),('15087','2013-03-24','13:05:00',4.2),('15087','2013-03-24','13:10:00',4.19),('15087','2013-03-24','13:15:00',4.13),('15087','2013-03-24','13:20:00',4.06),('15087','2013-03-24','13:25:00',3.94),('15087','2013-03-24','13:30:00',3.97),('15087','2013-03-24','13:35:00',3.89),('15087','2013-03-24','13:40:00',3.86),('15087','2013-03-24','13:45:00',3.84),('15087','2013-03-24','13:50:00',3.74),('15087','2013-03-24','13:55:00',3.69),('15087','2013-03-24','14:00:00',3.63),('15087','2013-03-24','14:05:00',3.57),('15087','2013-03-24','14:10:00',3.46),('15087','2013-03-24','14:15:00',3.43),('15087','2013-03-24','14:20:00',3.26),('15087','2013-03-24','14:25:00',3.27),('15087','2013-03-24','14:30:00',3.04),('15087','2013-03-24','14:35:00',2.97),('15087','2013-03-24','14:40:00',2.99),('15087','2013-03-24','14:45:00',2.88),('15087','2013-03-24','14:50:00',2.8),('15087','2013-03-24','14:55:00',2.79),('15087','2013-03-24','15:00:00',2.65),('15087','2013-03-24','15:05:00',2.57),('15087','2013-03-24','15:10:00',2.41),('15087','2013-03-24','15:15:00',2.72),('15087','2013-03-24','15:20:00',2.52),('15087','2013-03-24','15:25:00',2.4),('15087','2013-03-24','15:30:00',2.16),('15087','2013-03-24','15:35:00',2.11),('15087','2013-03-24','15:40:00',2.13),('15087','2013-03-24','15:45:00',1.71),('15087','2013-03-24','15:50:00',1.24),('15087','2013-03-24','15:55:00',1.2),('15087','2013-03-24','16:00:00',1.19),('15087','2013-03-24','16:05:00',1.44),('15087','2013-03-24','16:10:00',1.03),('15087','2013-03-24','16:15:00',1.49),('15087','2013-03-24','16:20:00',1.18),('15087','2013-03-24','16:25:00',1.06),('15087','2013-03-24','16:30:00',1.18),('15087','2013-03-24','16:35:00',1),('15087','2013-03-23','07:35:00',1.02),('15087','2013-03-23','07:40:00',1.21),('15087','2013-03-23','07:45:00',1.2),('15087','2013-03-23','07:50:00',1.37),('15087','2013-03-23','07:55:00',1.58),('15087','2013-03-23','08:00:00',1.74),('15087','2013-03-23','08:05:00',1.9),('15087','2013-03-23','08:10:00',1.97),('15087','2013-03-23','08:15:00',2.06),('15087','2013-03-23','08:20:00',2.14),('15087','2013-03-23','08:25:00',2.23),('15087','2013-03-23','08:30:00',2.28),('15087','2013-03-23','08:35:00',2.38),('15087','2013-03-23','08:40:00',2.52),('15087','2013-03-23','08:45:00',2.57),('15087','2013-03-23','08:50:00',2.68),('15087','2013-03-23','08:55:00',2.82),('15087','2013-03-23','09:00:00',2.88),('15087','2013-03-23','09:05:00',2.99),('15087','2013-03-23','09:10:00',3),('15087','2013-03-23','09:15:00',3.05),('15087','2013-03-23','09:20:00',3.11),('15087','2013-03-23','09:25:00',3.23),('15087','2013-03-23','09:30:00',3.37),('15087','2013-03-23','09:35:00',3.38),('15087','2013-03-23','09:40:00',3.31),('15087','2013-03-23','09:45:00',3.5),('15087','2013-03-23','09:50:00',3.55),('15087','2013-03-23','09:55:00',3.66),('15087','2013-03-23','10:00:00',3.65),('15087','2013-03-23','10:05:00',3.42),('15087','2013-03-23','10:10:00',3.66),('15087','2013-03-23','10:15:00',3.83),('15087','2013-03-23','10:20:00',3.76),('15087','2013-03-23','10:25:00',3.78),('15087','2013-03-23','10:30:00',3.97),('15087','2013-03-23','10:35:00',3.99),('15087','2013-03-23','10:40:00',4.01),('15087','2013-03-23','10:45:00',3.96),('15087','2013-03-23','10:50:00',3.92),('15087','2013-03-23','10:55:00',3.88),('15087','2013-03-23','11:00:00',3.77),('15087','2013-03-23','11:05:00',3.52),('15087','2013-03-23','11:10:00',3.18),('15087','2013-03-23','11:15:00',3.45),('15087','2013-03-23','11:20:00',3.8),('15087','2013-03-23','11:25:00',3.99),('15087','2013-03-23','11:30:00',3.98),('15087','2013-03-23','11:35:00',4.2),('15087','2013-03-23','11:40:00',4.18),('15087','2013-03-23','11:45:00',4.16),('15087','2013-03-23','11:50:00',3.96),('15087','2013-03-23','11:55:00',4.15),('15087','2013-03-23','12:00:00',4.24),('15087','2013-03-23','12:05:00',4.18),('15087','2013-03-23','12:10:00',4.21),('15087','2013-03-23','12:15:00',4.35),('15087','2013-03-23','12:20:00',4.37),('15087','2013-03-23','12:25:00',4.26),('15087','2013-03-23','12:30:00',4.31),('15087','2013-03-23','12:35:00',4.29),('15087','2013-03-23','12:40:00',4.19),('15087','2013-03-23','12:45:00',4.27),('15087','2013-03-23','12:50:00',4.3),('15087','2013-03-23','12:55:00',4.08),('15087','2013-03-23','13:00:00',3.32),('15087','2013-03-23','13:05:00',4.19),('15087','2013-03-23','13:10:00',4.18),('15087','2013-03-23','13:15:00',3.97),('15087','2013-03-23','13:20:00',4.04),('15087','2013-03-23','13:25:00',3.9),('15087','2013-03-23','13:30:00',3.76),('15087','2013-03-23','13:35:00',3.85),('15087','2013-03-23','13:40:00',3.68),('15087','2013-03-23','13:45:00',3.64),('15087','2013-03-23','13:50:00',3.79),('15087','2013-03-23','13:55:00',3.59),('15087','2013-03-23','14:00:00',3.5),('15087','2013-03-23','14:05:00',3.57),('15087','2013-03-23','14:10:00',3.41),('15087','2013-03-23','14:15:00',3.26),('15087','2013-03-23','14:20:00',3.41),('15087','2013-03-23','14:25:00',3.3),('15087','2013-03-23','14:30:00',3.24),('15087','2013-03-23','14:35:00',3.15),('15087','2013-03-23','14:40:00',2.93),('15087','2013-03-23','14:45:00',2.76),('15087','2013-03-23','14:50:00',2.87),('15087','2013-03-23','14:55:00',2.78),('15087','2013-03-23','15:00:00',2.56),('15087','2013-03-23','15:05:00',2.59),('15087','2013-03-23','15:10:00',2.63),('15087','2013-03-23','15:15:00',2.44),('15087','2013-03-23','15:20:00',2.5),('15087','2013-03-23','15:25:00',2.36),('15087','2013-03-23','15:30:00',1.98),('15087','2013-03-23','15:35:00',2.19),('15087','2013-03-23','15:40:00',2.03),('15087','2013-03-23','15:45:00',1.87),('15087','2013-03-23','15:50:00',1.84),('15087','2013-03-23','15:55:00',1.81),('15087','2013-03-23','16:00:00',1.68),('15087','2013-03-23','16:05:00',1.5),('15087','2013-03-23','16:10:00',1.92),('15087','2013-03-23','16:15:00',1.64),('15087','2013-03-23','16:20:00',1.36),('15087','2013-03-23','16:25:00',1.38),('15087','2013-03-23','16:30:00',1.04),('15087','2013-03-23','16:35:00',1.11),('15087','2013-03-22','07:35:00',1.14),('15087','2013-03-22','07:40:00',1.28),('15087','2013-03-22','07:45:00',1.43),('15087','2013-03-22','07:50:00',1.52),('15087','2013-03-22','07:55:00',1.61),('15087','2013-03-22','08:00:00',1.71),('15087','2013-03-22','08:05:00',1.8),('15087','2013-03-22','08:10:00',1.91),('15087','2013-03-22','08:15:00',2.02),('15087','2013-03-22','08:20:00',2.11),('15087','2013-03-22','08:25:00',2.21),('15087','2013-03-22','08:30:00',2.3),('15087','2013-03-22','08:35:00',2.4),('15087','2013-03-22','08:40:00',2.49),('15087','2013-03-22','08:45:00',2.58),('15087','2013-03-22','08:50:00',2.65),('15087','2013-03-22','08:55:00',2.73),('15087','2013-03-22','09:00:00',2.79),('15087','2013-03-22','09:05:00',2.88),('15087','2013-03-22','09:10:00',2.95),('15087','2013-03-22','09:15:00',3),('15087','2013-03-22','09:20:00',3.07),('15087','2013-03-22','09:25:00',3.13),('15087','2013-03-22','09:30:00',3.21),('15087','2013-03-22','09:35:00',3.28),('15087','2013-03-22','09:40:00',3.37),('15087','2013-03-22','09:45:00',3.45),('15087','2013-03-22','09:50:00',3.5),('15087','2013-03-22','09:55:00',3.57),('15087','2013-03-22','10:00:00',3.65),('15087','2013-03-22','10:05:00',3.72),('15087','2013-03-22','10:10:00',3.74),('15087','2013-03-22','10:15:00',3.75),('15087','2013-03-22','10:20:00',3.89),('15087','2013-03-22','10:25:00',3.97),('15087','2013-03-22','10:30:00',4.03),('15087','2013-03-22','10:35:00',4.02),('15087','2013-03-22','10:40:00',4.09),('15087','2013-03-22','10:45:00',4.12),('15087','2013-03-22','10:50:00',4.17),('15087','2013-03-22','10:55:00',4.19),('15087','2013-03-22','11:00:00',4.25),('15087','2013-03-22','11:05:00',4.26),('15087','2013-03-22','11:10:00',4.28),('15087','2013-03-22','11:15:00',4.32),('15087','2013-03-22','11:20:00',4.32),('15087','2013-03-22','11:25:00',4.31),('15087','2013-03-22','11:30:00',4.37),('15087','2013-03-22','11:35:00',4.36),('15087','2013-03-22','11:40:00',4.44),('15087','2013-03-22','11:45:00',4.45),('15087','2013-03-22','11:50:00',4.46),('15087','2013-03-22','11:55:00',4.49),('15087','2013-03-22','12:00:00',4.48),('15087','2013-03-22','12:05:00',4.5),('15087','2013-03-22','12:10:00',4.48),('15087','2013-03-22','12:15:00',4.47),('15087','2013-03-22','12:20:00',4.48),('15087','2013-03-22','12:25:00',4.49),('15087','2013-03-22','12:30:00',4.5),('15087','2013-03-22','12:35:00',4.5),('15087','2013-03-22','12:40:00',4.5),('15087','2013-03-22','12:45:00',4.49),('15087','2013-03-22','12:50:00',4.34),('15087','2013-03-22','12:55:00',4.19),('15087','2013-03-22','13:00:00',4.03),('15087','2013-03-22','13:05:00',4.33),('15087','2013-03-22','13:10:00',4.37),('15087','2013-03-22','13:15:00',4.15),('15087','2013-03-22','13:20:00',4),('15087','2013-03-22','13:25:00',3.93),('15087','2013-03-22','13:30:00',3.88),('15087','2013-03-22','13:35:00',3.94),('15087','2013-03-22','13:40:00',3.49),('15087','2013-03-22','13:45:00',3.65),('15087','2013-03-22','13:50:00',3.97),('15087','2013-03-22','13:55:00',3.71),('15087','2013-03-22','14:00:00',3.67),('15087','2013-03-22','14:05:00',3.63),('15087','2013-03-22','14:10:00',3.58),('15087','2013-03-22','14:15:00',3.44),('15087','2013-03-22','14:20:00',3.29),('15087','2013-03-22','14:25:00',3.38),('15087','2013-03-22','14:30:00',3.23),('15087','2013-03-22','14:35:00',3.17),('15087','2013-03-22','14:40:00',3.21),('15087','2013-03-22','14:45:00',3.16),('15087','2013-03-22','14:50:00',3.08),('15087','2013-03-22','14:55:00',3.01),('15087','2013-03-22','15:00:00',2.84),('15087','2013-03-22','15:05:00',2.86),('15087','2013-03-22','15:10:00',2.45),('15087','2013-03-22','15:15:00',2.02),('15087','2013-03-22','15:20:00',1.85),('15087','2013-03-22','15:25:00',1.94),('15087','2013-03-22','15:30:00',1.86),('15087','2013-03-22','15:35:00',2.08),('15087','2013-03-22','15:40:00',2.01),('15087','2013-03-22','15:45:00',1.71),('15087','2013-03-22','15:50:00',1.95),('15087','2013-03-22','15:55:00',1.7),('15087','2013-03-22','16:00:00',1.28),('15087','2013-03-22','16:05:00',1.32),('15087','2013-03-22','16:10:00',1.48),('15087','2013-03-22','16:15:00',1.74),('15087','2013-03-22','16:20:00',1.35),('15087','2013-03-22','16:25:00',1.39),('15087','2013-03-22','16:30:00',1.45),('15087','2013-03-22','16:35:00',1.37),('15087','2013-03-22','16:40:00',1.34),('15087','2013-03-22','16:45:00',1.24),('15087','2013-03-22','16:50:00',1.2),('15087','2013-03-22','16:55:00',1.11),('15087','2013-03-21','07:40:00',1.24),('15087','2013-03-21','07:45:00',1.26),('15087','2013-03-21','07:50:00',1.65),('15087','2013-03-21','08:10:00',1.03),('15087','2013-03-21','08:15:00',1.57),('15087','2013-03-21','08:20:00',1.92),('15087','2013-03-21','08:25:00',1.81),('15087','2013-03-21','08:30:00',2.04),('15087','2013-03-21','08:35:00',2.6),('15087','2013-03-21','08:40:00',2.83),('15087','2013-03-21','08:45:00',2.72),('15087','2013-03-21','08:50:00',2.42),('15087','2013-03-21','08:55:00',2.91),('15087','2013-03-21','09:00:00',3.06),('15087','2013-03-21','09:05:00',3.44),('15087','2013-03-21','09:10:00',3.39),('15087','2013-03-21','09:15:00',2.3),('15087','2013-03-21','09:20:00',2.51),('15087','2013-03-21','09:25:00',1.89),('15087','2013-03-21','09:30:00',2.37),('15087','2013-03-21','09:35:00',3.37),('15087','2013-03-21','09:40:00',3.37),('15087','2013-03-21','09:45:00',3.74),('15087','2013-03-21','09:50:00',3.79),('15087','2013-03-21','09:55:00',3.89),('15087','2013-03-21','10:00:00',3.94),('15087','2013-03-21','10:05:00',3.98),('15087','2013-03-21','10:10:00',4.01),('15087','2013-03-21','10:15:00',4.07),('15087','2013-03-21','10:20:00',4.09),('15087','2013-03-21','10:25:00',4.12),('15087','2013-03-21','10:30:00',4.2),('15087','2013-03-21','10:35:00',4.26),('15087','2013-03-21','10:40:00',4.26),('15087','2013-03-21','10:45:00',4.25),('15087','2013-03-21','10:50:00',4.27),('15087','2013-03-21','10:55:00',4.17),('15087','2013-03-21','11:00:00',4.37),('15087','2013-03-21','11:05:00',4.44),('15087','2013-03-21','11:10:00',4.46),('15087','2013-03-21','11:15:00',4.5),('15087','2013-03-21','11:20:00',4.45),('15087','2013-03-21','11:25:00',4.58),('15087','2013-03-21','11:30:00',4.6),('15087','2013-03-21','11:35:00',4.62),('15087','2013-03-21','11:40:00',4.62),('15087','2013-03-21','11:45:00',4.65),('15087','2013-03-21','11:50:00',4.68),('15087','2013-03-21','11:55:00',4.7),('15087','2013-03-21','12:00:00',4.71),('15087','2013-03-21','12:05:00',4.72),('15087','2013-03-21','12:10:00',4.7),('15087','2013-03-21','12:15:00',4.7),('15087','2013-03-21','12:20:00',4.68),('15087','2013-03-21','12:25:00',4.7),('15087','2013-03-21','12:30:00',4.68),('15087','2013-03-21','12:35:00',4.66),('15087','2013-03-21','12:40:00',4.66),('15087','2013-03-21','12:45:00',4.62),('15087','2013-03-21','12:50:00',4.6),('15087','2013-03-21','12:55:00',4.54),('15087','2013-03-21','13:00:00',4.5),('15087','2013-03-21','13:05:00',4.46),('15087','2013-03-21','13:10:00',4.42),('15087','2013-03-21','13:15:00',4.35),('15087','2013-03-21','13:20:00',4.3),('15087','2013-03-21','13:25:00',4.27),('15087','2013-03-21','13:30:00',4.2),('15087','2013-03-21','13:35:00',4.14),('15087','2013-03-21','13:40:00',4.1),('15087','2013-03-21','13:45:00',4.06),('15087','2013-03-21','13:50:00',3.98),('15087','2013-03-21','13:55:00',3.9),('15087','2013-03-21','14:00:00',3.85),('15087','2013-03-21','14:05:00',3.73),('15087','2013-03-21','14:10:00',3.56),('15087','2013-03-21','14:15:00',3.38),('15087','2013-03-21','14:20:00',3.38),('15087','2013-03-21','14:25:00',3.38),('15087','2013-03-21','14:30:00',3.24),('15087','2013-03-21','14:35:00',3.18),('15087','2013-03-21','14:40:00',3.22),('15087','2013-03-21','14:45:00',3.19),('15087','2013-03-21','14:50:00',3.1),('15087','2013-03-21','14:55:00',3.01),('15087','2013-03-21','15:00:00',2.96),('15087','2013-03-21','15:05:00',2.88),('15087','2013-03-21','15:10:00',2.73),('15087','2013-03-21','15:15:00',2.67),('15087','2013-03-21','15:20:00',2.6),('15087','2013-03-21','15:25:00',2.46),('15087','2013-03-21','15:30:00',2.4),('15087','2013-03-21','15:35:00',2.29),('15087','2013-03-21','15:40:00',2.16),('15087','2013-03-21','15:45:00',2.1),('15087','2013-03-21','15:50:00',2.07),('15087','2013-03-21','15:55:00',2.03),('15087','2013-03-21','16:00:00',1.92),('15087','2013-03-21','16:05:00',1.82),('15087','2013-03-21','16:10:00',1.7),('15087','2013-03-21','16:15:00',1.58),('15087','2013-03-21','16:20:00',1.51),('15087','2013-03-21','16:25:00',1.41),('15087','2013-03-21','16:30:00',1.24),('15087','2013-03-21','16:35:00',1.16),('15087','2013-03-21','16:40:00',1.08),('15087','2013-03-21','16:45:00',1.01),('15087','2013-03-20','07:30:00',1.05),('15087','2013-03-20','07:35:00',1.09),('15087','2013-03-20','07:40:00',1.23),('15087','2013-03-20','07:45:00',1.33),('15087','2013-03-20','07:50:00',1.37),('15087','2013-03-20','07:55:00',1.69),('15087','2013-03-20','08:00:00',1.21),('15087','2013-03-20','08:05:00',1.59),('15087','2013-03-20','08:10:00',1.82),('15087','2013-03-20','08:15:00',1.92),('15087','2013-03-20','08:20:00',2.01),('15087','2013-03-20','08:25:00',2.13),('15087','2013-03-20','08:30:00',2.26),('15087','2013-03-20','08:35:00',2.38),('15087','2013-03-20','08:40:00',2.26),('15087','2013-03-20','08:45:00',2.42),('15087','2013-03-20','08:50:00',2.52),('15087','2013-03-20','08:55:00',2.49),('15087','2013-03-20','09:00:00',2.48),('15087','2013-03-20','09:05:00',3.24),('15087','2013-03-20','09:10:00',2.83),('15087','2013-03-20','09:15:00',2.95),('15087','2013-03-20','09:20:00',3.03),('15087','2013-03-20','09:25:00',3.05),('15087','2013-03-20','09:30:00',3.25),('15087','2013-03-20','09:35:00',3.15),('15087','2013-03-20','09:40:00',3.35),('15087','2013-03-20','09:45:00',3.42),('15087','2013-03-20','09:50:00',3.46),('15087','2013-03-20','09:55:00',3.45),('15087','2013-03-20','10:00:00',3.59),('15087','2013-03-20','10:05:00',3.44),('15087','2013-03-20','10:10:00',3.12),('15087','2013-03-20','10:15:00',2.93),('15087','2013-03-20','10:20:00',2.64),('15087','2013-03-20','10:25:00',2.68),('15087','2013-03-20','10:30:00',3.3),('15087','2013-03-20','10:35:00',4.19),('15087','2013-03-20','10:40:00',3.2),('15087','2013-03-20','10:45:00',2.84),('15087','2013-03-20','10:50:00',3.4),('15087','2013-03-20','10:55:00',3.08),('15087','2013-03-20','11:00:00',3.22),('15087','2013-03-20','11:05:00',3.7),('15087','2013-03-20','11:10:00',2.56),('15087','2013-03-20','11:15:00',2.58),('15087','2013-03-20','11:20:00',3.03),('15087','2013-03-20','11:25:00',2.79),('15087','2013-03-20','11:30:00',2.6),('15087','2013-03-20','11:35:00',2.9),('15087','2013-03-20','11:40:00',2.35),('15087','2013-03-20','11:45:00',2.25),('15087','2013-03-20','11:50:00',2.18),('15087','2013-03-20','11:55:00',2.39),('15087','2013-03-20','12:00:00',2.36),('15087','2013-03-20','12:05:00',2.56),('15087','2013-03-20','12:10:00',2.12),('15087','2013-03-20','12:15:00',1.81),('15087','2013-03-20','12:20:00',1.61),('15087','2013-03-20','12:25:00',1.33),('15087','2013-03-20','12:30:00',1.09),('15087','2013-03-20','12:35:00',1.45),('15087','2013-03-20','12:45:00',1.13),('15087','2013-03-20','12:50:00',1.6),('15087','2013-03-20','12:55:00',1.95),('15087','2013-03-20','13:00:00',2.04),('15087','2013-03-20','13:05:00',1.53),('15087','2013-03-20','13:10:00',1.5),('15087','2013-03-20','13:15:00',1.23),('15087','2013-03-20','13:20:00',1.32),('15087','2013-03-20','13:25:00',1.41),('15087','2013-03-20','13:30:00',1.52),('15087','2013-03-20','13:35:00',1.46),('15087','2013-03-20','13:40:00',1.91),('15087','2013-03-20','13:45:00',2.22),('15087','2013-03-20','13:50:00',1.86),('15087','2013-03-20','13:55:00',1.74),('15087','2013-03-20','14:00:00',1.72),('15087','2013-03-20','14:05:00',1.4),('15087','2013-03-20','14:10:00',1.32),('15087','2013-03-20','14:15:00',1.89),('15087','2013-03-20','14:20:00',2.31),('15087','2013-03-20','14:25:00',2.11),('15087','2013-03-20','14:30:00',1.81),('15087','2013-03-20','14:35:00',1.42),('15087','2013-03-20','14:40:00',1.13),('15087','2013-03-20','14:45:00',1.09),('15087','2013-03-19','07:35:00',1),('15087','2013-03-19','07:40:00',1.12),('15087','2013-03-19','07:45:00',1.23),('15087','2013-03-19','07:50:00',1.37),('15087','2013-03-19','07:55:00',1.38),('15087','2013-03-19','08:00:00',1.01),('15087','2013-03-19','08:05:00',1.38),('15087','2013-03-19','08:10:00',1.74),('15087','2013-03-19','08:15:00',1.91),('15087','2013-03-19','08:20:00',1.98),('15087','2013-03-19','08:25:00',2.05),('15087','2013-03-19','08:30:00',2.22),('15087','2013-03-19','08:35:00',1.67),('15087','2013-03-19','08:40:00',2.25),('15087','2013-03-19','08:45:00',2.53),('15087','2013-03-19','08:50:00',2.62),('15087','2013-03-19','08:55:00',2.68),('15087','2013-03-19','09:00:00',2.76),('15087','2013-03-19','09:05:00',2.85),('15087','2013-03-19','09:10:00',2.94),('15087','2013-03-19','09:15:00',3.04),('15087','2013-03-19','09:20:00',2.21),('15087','2013-03-19','09:25:00',3.12),('15087','2013-03-19','09:30:00',3.3),('15087','2013-03-19','09:35:00',3.27),('15087','2013-03-19','09:40:00',3.47),('15087','2013-03-19','09:45:00',3.4),('15087','2013-03-19','09:50:00',3.37),('15087','2013-03-19','09:55:00',3.33),('15087','2013-03-19','10:00:00',3.1),('15087','2013-03-19','10:05:00',3.31),('15087','2013-03-19','10:10:00',3.82),('15087','2013-03-19','10:15:00',3.88),('15087','2013-03-19','10:20:00',3.93),('15087','2013-03-19','10:25:00',3.62),('15087','2013-03-19','10:30:00',4.05),('15087','2013-03-19','10:35:00',4.1),('15087','2013-03-19','10:40:00',4.12),('15087','2013-03-19','10:45:00',4.19),('15087','2013-03-19','10:50:00',3.96),('15087','2013-03-19','10:55:00',4.35),('15087','2013-03-19','11:00:00',4.34),('15087','2013-03-19','11:05:00',4.36),('15087','2013-03-19','11:10:00',4.24),('15087','2013-03-19','11:15:00',4.45),('15087','2013-03-19','11:20:00',4.44),('15087','2013-03-19','11:25:00',4.43),('15087','2013-03-19','11:30:00',4.41),('15087','2013-03-19','11:35:00',2.69),('15087','2013-03-19','11:40:00',4.12),('15087','2013-03-19','11:45:00',4.08),('15087','2013-03-19','11:50:00',4.7),('15087','2013-03-19','11:55:00',4.61),('15087','2013-03-19','12:00:00',4.55),('15087','2013-03-19','12:05:00',4.51),('15087','2013-03-19','12:10:00',4.49),('15087','2013-03-19','12:15:00',4.31),('15087','2013-03-19','12:20:00',4.55),('15087','2013-03-19','12:25:00',4.46),('15087','2013-03-19','12:30:00',4.44),('15087','2013-03-19','12:35:00',4.51),('15087','2013-03-19','12:40:00',4.46),('15087','2013-03-19','12:45:00',4.47),('15087','2013-03-19','12:50:00',4.48),('15087','2013-03-19','12:55:00',4.39),('15087','2013-03-19','13:00:00',4.37),('15087','2013-03-19','13:05:00',4.32),('15087','2013-03-19','13:10:00',4.28),('15087','2013-03-19','13:15:00',4.17),('15087','2013-03-19','13:20:00',4.13),('15087','2013-03-19','13:25:00',4.08),('15087','2013-03-19','13:30:00',4.04),('15087','2013-03-19','13:35:00',3.95),('15087','2013-03-19','13:40:00',3.84),('15087','2013-03-19','13:45:00',3.85),('15087','2013-03-19','13:50:00',3.74),('15087','2013-03-19','13:55:00',3.72),('15087','2013-03-19','14:00:00',3.68),('15087','2013-03-19','14:05:00',3.64),('15087','2013-03-19','14:10:00',3.51),('15087','2013-03-19','14:15:00',3.4),('15087','2013-03-19','14:20:00',3.38),('15087','2013-03-19','14:25:00',3.3),('15087','2013-03-19','14:30:00',3.27),('15087','2013-03-19','14:35:00',3.14),('15087','2013-03-19','14:40:00',3.15),('15087','2013-03-19','14:45:00',3.05),('15087','2013-03-19','14:50:00',3),('15087','2013-03-19','14:55:00',2.91),('15087','2013-03-19','15:00:00',2.89),('15087','2013-03-19','15:05:00',2.79),('15087','2013-03-19','15:10:00',2.65),('15087','2013-03-19','15:15:00',2.63),('15087','2013-03-19','15:20:00',2.52),('15087','2013-03-19','15:25:00',2.42),('15087','2013-03-19','15:30:00',2.25),('15087','2013-03-19','15:35:00',2.21),('15087','2013-03-19','15:40:00',2.17),('15087','2013-03-19','15:45:00',2.11),('15087','2013-03-19','15:50:00',2.03),('15087','2013-03-19','15:55:00',1.99),('15087','2013-03-19','16:00:00',1.87),('15087','2013-03-19','16:05:00',1.74),('15087','2013-03-19','16:10:00',1.6),('15087','2013-03-19','16:15:00',1.53),('15087','2013-03-19','16:20:00',1.46),('15087','2013-03-19','16:25:00',1.31),('15087','2013-03-19','16:30:00',1.23),('15087','2013-03-19','16:35:00',1.16),('15087','2013-03-19','16:40:00',1.09),('15087','2013-03-18','09:55:00',1.07),('15087','2013-03-18','10:00:00',1.4),('15087','2013-03-18','10:05:00',1.69),('15087','2013-03-18','10:10:00',1.67),('15087','2013-03-18','10:15:00',1.43),('15087','2013-03-18','10:20:00',1.71),('15087','2013-03-18','10:25:00',2.05),('15087','2013-03-18','10:30:00',1.98),('15087','2013-03-18','10:35:00',1.68),('15087','2013-03-18','10:40:00',1.58),('15087','2013-03-18','10:45:00',1.66),('15087','2013-03-18','10:50:00',1.55),('15087','2013-03-18','10:55:00',1.26),('15087','2013-03-18','11:00:00',1.4),('15087','2013-03-18','11:05:00',1.56),('15087','2013-03-18','11:10:00',1.77),('15087','2013-03-18','11:15:00',1.94),('15087','2013-03-18','11:20:00',1.99),('15087','2013-03-18','11:25:00',2.1),('15087','2013-03-18','11:30:00',2.66),('15087','2013-03-18','11:35:00',2.18),('15087','2013-03-18','11:40:00',1.99),('15087','2013-03-18','11:45:00',1.69),('15087','2013-03-18','11:50:00',1.39),('15087','2013-03-18','11:55:00',1.69),('15087','2013-03-18','12:00:00',1.74),('15087','2013-03-18','12:05:00',3.03),('15087','2013-03-18','12:10:00',2.84),('15087','2013-03-18','12:15:00',3.35),('15087','2013-03-18','12:20:00',3.15),('15087','2013-03-18','12:25:00',2.34),('15087','2013-03-18','12:30:00',3.65),('15087','2013-03-18','12:35:00',4.34),('15087','2013-03-18','12:40:00',3.09),('15087','2013-03-18','12:45:00',2.98),('15087','2013-03-18','12:50:00',3.99),('15087','2013-03-18','12:55:00',4.28),('15087','2013-03-18','13:00:00',3.9),('15087','2013-03-18','13:05:00',1.83),('15087','2013-03-18','13:10:00',1.3),('15087','2013-03-18','13:20:00',1.2),('15087','2013-03-18','13:25:00',2.2),('15087','2013-03-18','13:30:00',1.4),('15087','2013-03-18','13:35:00',1.27),('15087','2013-03-18','13:40:00',2.34),('15087','2013-03-18','13:45:00',2.03),('15087','2013-03-18','13:50:00',1.85),('15087','2013-03-18','13:55:00',1.65),('15087','2013-03-18','14:00:00',1.88),('15087','2013-03-18','14:05:00',2.82),('15087','2013-03-18','14:10:00',2.48),('15087','2013-03-18','14:15:00',1.3),('15087','2013-03-18','14:20:00',1.34),('15087','2013-03-18','14:25:00',1.88),('15087','2013-03-18','14:35:00',1.21),('15087','2013-03-18','14:40:00',1.25),('15087','2013-03-18','14:45:00',1.11),('15087','2013-03-18','15:00:00',1.12),('15087','2013-03-17','08:15:00',1.09),('15087','2013-03-17','08:20:00',1.26),('15087','2013-03-17','08:25:00',1.65),('15087','2013-03-17','08:30:00',1.46),('15087','2013-03-17','08:35:00',1.27),('15087','2013-03-17','08:40:00',1.33),('15087','2013-03-17','08:45:00',1.59),('15087','2013-03-17','08:50:00',1.53),('15087','2013-03-17','08:55:00',1.44),('15087','2013-03-17','09:00:00',1.41),('15087','2013-03-17','09:05:00',1.64),('15087','2013-03-17','09:10:00',1.89),('15087','2013-03-17','09:15:00',2.06),('15087','2013-03-17','09:20:00',1.67),('15087','2013-03-17','09:25:00',1.4),('15087','2013-03-17','09:30:00',1.59),('15087','2013-03-17','09:35:00',1.72),('15087','2013-03-17','09:40:00',1.69),('15087','2013-03-17','09:45:00',1.75),('15087','2013-03-17','09:50:00',1.96),('15087','2013-03-17','09:55:00',2.11),('15087','2013-03-17','10:00:00',2.34),('15087','2013-03-17','10:05:00',1.92),('15087','2013-03-17','10:10:00',1.9),('15087','2013-03-17','10:15:00',2.07),('15087','2013-03-17','10:20:00',2.11),('15087','2013-03-17','10:25:00',2.2),('15087','2013-03-17','10:30:00',2.13),('15087','2013-03-17','10:35:00',2.04),('15087','2013-03-17','10:40:00',1.93),('15087','2013-03-17','10:45:00',2.03),('15087','2013-03-17','10:50:00',1.91),('15087','2013-03-17','10:55:00',1.78),('15087','2013-03-17','11:00:00',1.73),('15087','2013-03-17','11:05:00',1.47),('15087','2013-03-17','11:10:00',1.45),('15087','2013-03-17','11:15:00',1.64),('15087','2013-03-17','11:20:00',1.88),('15087','2013-03-17','11:25:00',1.86),('15087','2013-03-17','11:30:00',1.71),('15087','2013-03-17','11:35:00',1.69),('15087','2013-03-17','11:40:00',1.6),('15087','2013-03-17','11:45:00',1.48),('15087','2013-03-17','11:50:00',1.37),('15087','2013-03-17','11:55:00',1.16),('15087','2013-03-17','12:00:00',1.1),('15087','2013-03-17','12:05:00',1.13),('15087','2013-03-17','12:10:00',1.58),('15087','2013-03-17','12:15:00',2.16),('15087','2013-03-17','12:20:00',2.61),('15087','2013-03-17','12:25:00',3.63),('15087','2013-03-17','12:30:00',3.79),('15087','2013-03-17','12:35:00',2.7),('15087','2013-03-17','12:40:00',2.83),('15087','2013-03-17','12:45:00',2.63),('15087','2013-03-17','12:50:00',2.34),('15087','2013-03-17','12:55:00',1.94),('15087','2013-03-17','13:00:00',2.3),('15087','2013-03-17','13:05:00',2.48),('15087','2013-03-17','13:10:00',2.79),('15087','2013-03-17','13:15:00',2.73),('15087','2013-03-17','13:20:00',2.28),('15087','2013-03-17','13:25:00',2.02),('15087','2013-03-17','13:30:00',2.99),('15087','2013-03-17','13:35:00',2.97),('15087','2013-03-17','13:40:00',2.21),('15087','2013-03-17','13:45:00',1.97),('15087','2013-03-17','13:50:00',1.6),('15087','2013-03-17','13:55:00',2.53),('15087','2013-03-17','14:00:00',2.31),('15087','2013-03-17','14:05:00',2.41),('15087','2013-03-17','14:10:00',2.81),('15087','2013-03-17','14:15:00',2.78),('15087','2013-03-17','14:20:00',2.99),('15087','2013-03-17','14:25:00',2.5),('15087','2013-03-17','14:30:00',2.44),('15087','2013-03-17','14:35:00',2.09),('15087','2013-03-17','14:40:00',1.57),('15087','2013-03-17','14:45:00',1.42),('15087','2013-03-17','14:50:00',1.17),('15087','2013-03-17','14:55:00',1.28),('15087','2013-03-17','15:00:00',1.74),('15087','2013-03-17','15:05:00',1.95),('15087','2013-03-17','15:10:00',2.49),('15087','2013-03-17','15:15:00',2.21),('15087','2013-03-17','15:20:00',2.53),('15087','2013-03-17','15:25:00',2.57),('15087','2013-03-17','15:30:00',1.59),('15087','2013-03-17','15:35:00',2.19),('15087','2013-03-17','15:40:00',1.67),('15087','2013-03-17','15:45:00',1.49),('15087','2013-03-17','16:45:00',1.2),('15087','2013-03-16','08:05:00',1.08),('15087','2013-03-16','08:10:00',1.86),('15087','2013-03-16','08:15:00',2.09),('15087','2013-03-16','08:20:00',2.25),('15087','2013-03-16','08:25:00',2.26),('15087','2013-03-16','08:30:00',2.28),('15087','2013-03-16','08:35:00',2.43),('15087','2013-03-16','08:40:00',2.45),('15087','2013-03-16','08:45:00',2.51),('15087','2013-03-16','08:50:00',2.77),('15087','2013-03-16','08:55:00',2.95),('15087','2013-03-16','09:00:00',2.93),('15087','2013-03-16','09:05:00',3.01),('15087','2013-03-16','09:10:00',2.88),('15087','2013-03-16','09:15:00',3.21),('15087','2013-03-16','09:20:00',2.89),('15087','2013-03-16','09:25:00',1.83),('15087','2013-03-16','09:30:00',2.85),('15087','2013-03-16','09:35:00',3.69),('15087','2013-03-16','09:40:00',2.95),('15087','2013-03-16','09:45:00',3.5),('15087','2013-03-16','09:50:00',3.76),('15087','2013-03-16','09:55:00',3.88),('15087','2013-03-16','10:00:00',3.01),('15087','2013-03-16','10:05:00',2.83),('15087','2013-03-16','10:10:00',3.48),('15087','2013-03-16','10:15:00',2.73),('15087','2013-03-16','10:20:00',2.46),('15087','2013-03-16','10:25:00',2.85),('15087','2013-03-16','10:30:00',2.51),('15087','2013-03-16','10:35:00',3.81),('15087','2013-03-16','10:40:00',4.26),('15087','2013-03-16','10:45:00',4.23),('15087','2013-03-16','10:50:00',4.29),('15087','2013-03-16','10:55:00',4.31),('15087','2013-03-16','11:00:00',4.34),('15087','2013-03-16','11:05:00',4.37),('15087','2013-03-16','11:10:00',4.41),('15087','2013-03-16','11:15:00',4.43),('15087','2013-03-16','11:20:00',4.45),('15087','2013-03-16','11:25:00',4.46),('15087','2013-03-16','11:30:00',4.51),('15087','2013-03-16','11:35:00',4.5),('15087','2013-03-16','11:40:00',4.52),('15087','2013-03-16','11:45:00',4.53),('15087','2013-03-16','11:50:00',4.56),('15087','2013-03-16','11:55:00',4.54),('15087','2013-03-16','12:00:00',4.54),('15087','2013-03-16','12:05:00',4.53),('15087','2013-03-16','12:10:00',4.51),('15087','2013-03-16','12:15:00',4.53),('15087','2013-03-16','12:20:00',4.54),('15087','2013-03-16','12:25:00',4.51),('15087','2013-03-16','12:30:00',4.54),('15087','2013-03-16','12:35:00',4.51),('15087','2013-03-16','12:40:00',4.45),('15087','2013-03-16','12:45:00',4.48),('15087','2013-03-16','12:50:00',4.47),('15087','2013-03-16','12:55:00',4.33),('15087','2013-03-16','13:00:00',3.95),('15087','2013-03-16','13:05:00',4.06),('15087','2013-03-16','13:10:00',4.19),('15087','2013-03-16','13:15:00',4.08),('15087','2013-03-16','13:20:00',4),('15087','2013-03-16','13:25:00',2.05),('15087','2013-03-16','13:30:00',1.95),('15087','2013-03-16','13:35:00',1.11),('15087','2013-03-16','13:40:00',3.55),('15087','2013-03-16','13:45:00',3.2),('15087','2013-03-16','13:50:00',3.46),('15087','2013-03-16','13:55:00',2.86),('15087','2013-03-16','14:00:00',3.17),('15087','2013-03-16','14:05:00',3.12),('15087','2013-03-16','14:15:00',3.61),('15087','2013-03-16','14:20:00',1.26),('15087','2013-03-16','14:25:00',2.6),('15087','2013-03-16','14:30:00',3.59),('15087','2013-03-16','14:35:00',3.09),('15087','2013-03-16','14:40:00',2.45),('15087','2013-03-16','14:45:00',1.21),('15087','2013-03-16','14:55:00',1.11),('15087','2013-03-16','16:00:00',1.72),('15087','2013-03-16','16:05:00',1.8),('15087','2013-03-16','16:10:00',1.77),('15087','2013-03-16','16:15:00',1.75),('15087','2013-03-16','16:20:00',1.01),('15087','2013-03-16','16:55:00',1.04),('15087','2013-03-15','10:35:00',1.15),('15087','2013-03-15','10:40:00',1.3),('15087','2013-03-15','10:45:00',1.52),('15087','2013-03-15','10:50:00',1.54),('15087','2013-03-15','10:55:00',1.67),('15087','2013-03-15','11:00:00',1.65),('15087','2013-03-15','11:05:00',1.4),('15087','2013-03-15','11:10:00',1.41),('15087','2013-03-15','11:15:00',1.17),('15087','2013-03-15','11:20:00',1.38),('15087','2013-03-15','11:25:00',1.72),('15087','2013-03-15','11:30:00',1.9),('15087','2013-03-15','11:35:00',2.42),('15087','2013-03-15','11:40:00',2.54),('15087','2013-03-15','11:45:00',2.5),('15087','2013-03-15','11:50:00',2.22),('15087','2013-03-15','11:55:00',2.33),('15087','2013-03-15','12:00:00',2.11),('15087','2013-03-15','12:05:00',2.02),('15087','2013-03-15','12:10:00',2.19),('15087','2013-03-15','12:15:00',1.93),('15087','2013-03-15','12:20:00',1.87),('15087','2013-03-15','12:25:00',2.01),('15087','2013-03-15','12:30:00',2.09),('15087','2013-03-15','12:35:00',2.38),('15087','2013-03-15','12:40:00',2),('15087','2013-03-15','12:45:00',1.64),('15087','2013-03-15','12:50:00',1.55),('15087','2013-03-15','12:55:00',1.49),('15087','2013-03-15','13:00:00',1.39),('15087','2013-03-15','13:05:00',1.29),('15087','2013-03-15','13:10:00',1.35),('15087','2013-03-15','13:15:00',1.49),('15087','2013-03-15','13:20:00',1.6),('15087','2013-03-15','13:25:00',1.79),('15087','2013-03-15','13:30:00',1.71),('15087','2013-03-15','13:35:00',1.57),('15087','2013-03-15','13:40:00',1.64),('15087','2013-03-15','13:45:00',1.77),('15087','2013-03-15','13:50:00',1.44),('15087','2013-03-15','13:55:00',1.22),('15087','2013-03-15','14:00:00',1.09),('15087','2013-03-15','14:50:00',1.1),('15087','2013-03-15','14:55:00',1.27),('15087','2013-03-15','15:00:00',1.37),('15087','2013-03-15','15:05:00',1.28),('15087','2013-03-15','15:10:00',1.28),('15087','2013-03-15','15:15:00',1.38),('15087','2013-03-15','15:20:00',1.42),('15087','2013-03-15','15:25:00',1.56),('15087','2013-03-15','15:30:00',1.34),('15087','2013-03-15','15:35:00',1.13),('15087','2013-03-14','13:05:00',1.1),('15087','2013-03-14','13:10:00',1.2),('15087','2013-03-14','13:15:00',1.17),('15087','2013-03-14','13:20:00',1.2),('15087','2013-03-14','13:25:00',1.16),('15087','2013-03-14','13:30:00',1.23),('15087','2013-03-14','13:35:00',1.42),('15087','2013-03-14','13:40:00',1.26),('15087','2013-03-14','13:45:00',1.27),('15087','2013-03-14','13:50:00',1.62),('15087','2013-03-14','13:55:00',1.88),('15087','2013-03-14','14:00:00',1.79),('15087','2013-03-14','14:05:00',1.97),('15087','2013-03-14','14:10:00',1.64),('15087','2013-03-14','14:15:00',1.38),('15087','2013-03-14','14:20:00',1.28),('15087','2013-03-14','14:25:00',1.28),('15087','2013-03-14','14:30:00',1.04),('15087','2013-03-14','15:10:00',1.37),('15087','2013-03-14','15:15:00',1.37),('15087','2013-03-14','15:20:00',1.28),('15087','2013-03-14','15:25:00',1.38),('15087','2013-03-14','15:30:00',1.36),('15087','2013-03-14','15:35:00',1.03),('15087','2013-03-13','08:50:00',1.27),('15087','2013-03-13','08:55:00',1.16),('15087','2013-03-13','09:10:00',1.24),('15087','2013-03-13','09:45:00',1.05),('15087','2013-03-13','10:05:00',1.11),('15087','2013-03-13','10:10:00',1.44),('15087','2013-03-13','10:15:00',2.25),('15087','2013-03-13','10:20:00',1.73),('15087','2013-03-13','10:25:00',2.61),('15087','2013-03-13','10:30:00',3.53),('15087','2013-03-13','10:35:00',3.5),('15087','2013-03-13','10:40:00',2.46),('15087','2013-03-13','10:45:00',1.64),('15087','2013-03-13','10:50:00',1.24),('15087','2013-03-13','10:55:00',1.06),('15087','2013-03-13','11:00:00',1.1),('15087','2013-03-13','11:10:00',1.33),('15087','2013-03-13','11:15:00',1.14),('15087','2013-03-13','11:30:00',1.34),('15087','2013-03-13','11:35:00',1.38),('15087','2013-03-13','11:40:00',1.35),('15087','2013-03-13','11:45:00',1.56),('15087','2013-03-13','11:50:00',1.34),('15087','2013-03-13','12:45:00',1.2),('15087','2013-03-13','12:50:00',1.46),('15087','2013-03-13','12:55:00',1.31),('15087','2013-03-13','13:00:00',1.25),('15087','2013-03-13','13:05:00',1.17),('15087','2013-03-13','13:10:00',1.06),('15087','2013-03-13','13:35:00',1.09),('15087','2013-03-12','08:20:00',1.97),('15087','2013-03-12','08:25:00',1.96),('15087','2013-03-12','08:30:00',2.06),('15087','2013-03-12','08:35:00',1.76),('15087','2013-03-12','08:40:00',2.02),('15087','2013-03-12','08:45:00',2.47),('15087','2013-03-12','08:50:00',1.17),('15087','2013-03-12','09:00:00',1.87),('15087','2013-03-12','09:05:00',2.7),('15087','2013-03-12','09:10:00',2.74),('15087','2013-03-12','09:15:00',2.84),('15087','2013-03-12','09:20:00',2.92),('15087','2013-03-12','09:25:00',2.99),('15087','2013-03-12','09:30:00',3.07),('15087','2013-03-12','09:35:00',3.17),('15087','2013-03-12','09:40:00',3.12),('15087','2013-03-12','09:45:00',2.03),('15087','2013-03-12','09:50:00',2.76),('15087','2013-03-12','09:55:00',3.6),('15087','2013-03-12','10:00:00',3.6),('15087','2013-03-12','10:05:00',3.48),('15087','2013-03-12','10:10:00',3.51),('15087','2013-03-12','10:15:00',2.44),('15087','2013-03-12','10:20:00',2.02),('15087','2013-03-12','10:25:00',3.29),('15087','2013-03-12','10:30:00',2.07),('15087','2013-03-12','10:35:00',2.16),('15087','2013-03-12','10:40:00',3.28),('15087','2013-03-12','10:45:00',2.15),('15087','2013-03-12','10:50:00',4.32),('15087','2013-03-12','10:55:00',4.25),('15087','2013-03-12','11:00:00',4.44),('15087','2013-03-12','11:05:00',3.96),('15087','2013-03-12','11:10:00',4.06),('15087','2013-03-12','11:15:00',3.96),('15087','2013-03-12','11:20:00',4.18),('15087','2013-03-12','11:25:00',1.5),('15087','2013-03-12','11:30:00',1.73),('15087','2013-03-12','11:35:00',2.26),('15087','2013-03-12','11:40:00',2.28),('15087','2013-03-12','11:45:00',2.56),('15087','2013-03-12','11:50:00',3),('15087','2013-03-12','11:55:00',3.09),('15087','2013-03-12','12:05:00',1.43),('15087','2013-03-12','12:10:00',4.86),('15087','2013-03-12','12:15:00',2.26),('15087','2013-03-12','12:20:00',2.54),('15087','2013-03-12','12:25:00',3.88),('15087','2013-03-12','12:30:00',5.28),('15087','2013-03-12','12:35:00',3.08),('15087','2013-03-12','12:40:00',3.7),('15087','2013-03-12','12:45:00',1.29),('15087','2013-03-12','12:50:00',1.78),('15087','2013-03-12','12:55:00',2.91),('15087','2013-03-12','13:00:00',4.6),('15087','2013-03-12','13:05:00',2.12),('15087','2013-03-12','13:10:00',3.04),('15087','2013-03-12','13:15:00',2.28),('15087','2013-03-12','13:20:00',3.27),('15087','2013-03-12','13:25:00',2),('15087','2013-03-12','13:30:00',1.62),('15087','2013-03-12','13:35:00',1.96),('15087','2013-03-12','13:40:00',1.61),('15087','2013-03-12','13:45:00',1.36),('15087','2013-03-12','13:50:00',1.3),('15087','2013-03-12','13:55:00',2.21),('15087','2013-03-12','14:00:00',2.85),('15087','2013-03-12','14:05:00',2.4),('15087','2013-03-12','14:10:00',1.66),('15087','2013-03-12','14:15:00',1.22),('15087','2013-03-12','15:00:00',1.07),('15087','2013-03-12','15:20:00',1.06),('15087','2013-03-11','08:10:00',1.39),('15087','2013-03-11','08:15:00',1.64),('15087','2013-03-11','08:20:00',1.73),('15087','2013-03-11','08:25:00',1.84),('15087','2013-03-11','08:30:00',1.96),('15087','2013-03-11','08:35:00',2.05),('15087','2013-03-11','08:40:00',2.13),('15087','2013-03-11','08:45:00',2.24),('15087','2013-03-11','08:50:00',2.36),('15087','2013-03-11','08:55:00',2.43),('15087','2013-03-11','09:00:00',2.52),('15087','2013-03-11','09:05:00',2.56),('15087','2013-03-11','09:10:00',2.67),('15087','2013-03-11','09:15:00',2.77),('15087','2013-03-11','09:20:00',2.38),('15087','2013-03-11','09:25:00',1.62),('15087','2013-03-11','09:35:00',4.08),('15087','2013-03-11','09:40:00',2.51),('15087','2013-03-11','09:45:00',2.6),('15087','2013-03-11','10:10:00',1.2),('15087','2013-03-11','10:15:00',1.21),('15087','2013-03-11','10:20:00',1.35),('15087','2013-03-11','10:25:00',1.5),('15087','2013-03-11','10:30:00',1.4),('15087','2013-03-11','10:35:00',1.68),('15087','2013-03-11','10:40:00',2.28),('15087','2013-03-11','10:45:00',2.7),('15087','2013-03-11','10:50:00',3.68),('15087','2013-03-11','10:55:00',2.04),('15087','2013-03-11','11:00:00',1.71),('15087','2013-03-11','11:05:00',1.36),('15087','2013-03-11','11:10:00',1.48),('15087','2013-03-11','11:15:00',1.54),('15087','2013-03-11','11:20:00',1.32),('15087','2013-03-11','11:25:00',1.27),('15087','2013-03-11','11:30:00',2.1),('15087','2013-03-11','11:35:00',2.01),('15087','2013-03-11','11:40:00',2.08),('15087','2013-03-11','11:45:00',2.67),('15087','2013-03-11','11:50:00',2.54),('15087','2013-03-11','11:55:00',2.18),('15087','2013-03-11','12:00:00',1.98),('15087','2013-03-11','12:05:00',1.96),('15087','2013-03-11','12:10:00',2.43),('15087','2013-03-11','12:30:00',1.09),('15087','2013-03-11','12:35:00',1.65),('15087','2013-03-11','12:40:00',1.26),('15087','2013-03-11','12:45:00',1.45),('15087','2013-03-11','12:50:00',2.58),('15087','2013-03-11','12:55:00',3.14),('15087','2013-03-11','13:00:00',1.91),('15087','2013-03-11','13:05:00',2.07),('15087','2013-03-11','13:10:00',3.55),('15087','2013-03-11','13:15:00',3.59),('15087','2013-03-11','13:20:00',4.33),('15087','2013-03-11','13:25:00',4.14),('15087','2013-03-11','13:30:00',3.84),('15087','2013-03-11','13:35:00',4.01),('15087','2013-03-11','13:40:00',2.5),('15087','2013-03-11','13:45:00',3.69),('15087','2013-03-11','13:50:00',3.4),('15087','2013-03-11','13:55:00',1.69),('15087','2013-03-11','14:20:00',1.42),('15087','2013-03-11','14:25:00',1.68),('15087','2013-03-11','14:30:00',1.28),('15087','2013-03-11','14:35:00',1.01),('15087','2013-03-11','14:40:00',1.78),('15087','2013-03-11','15:25:00',1.56),('15087','2013-03-11','15:30:00',2.64),('15087','2013-03-11','15:35:00',1.52),('15087','2013-03-11','15:40:00',1.91),('15087','2013-03-11','15:45:00',2.66),('15087','2013-03-11','15:50:00',2.08),('15087','2013-03-11','15:55:00',1.73),('15087','2013-03-11','16:00:00',1.69),('15087','2013-03-11','16:05:00',1.51),('15087','2013-03-11','16:10:00',1.66),('15087','2013-03-11','16:15:00',1.19),('15087','2013-03-11','16:20:00',1.3),('15087','2013-03-11','16:25:00',1.23),('15087','2013-03-11','16:30:00',1.24),('15087','2013-03-11','16:35:00',1.04),('15087','2013-03-11','16:40:00',1.14),('15087','2013-03-11','16:45:00',1.2),('15087','2013-03-10','07:55:00',1.22),('15087','2013-03-10','08:00:00',1.34),('15087','2013-03-10','08:05:00',1.46),('15087','2013-03-10','08:10:00',1.37),('15087','2013-03-10','08:15:00',1.53),('15087','2013-03-10','08:20:00',1.75),('15087','2013-03-10','08:25:00',1.85),('15087','2013-03-10','08:30:00',1.93),('15087','2013-03-10','08:35:00',2.01),('15087','2013-03-10','08:40:00',2.1),('15087','2013-03-10','08:45:00',2.19),('15087','2013-03-10','08:50:00',2.26),('15087','2013-03-10','08:55:00',2.37),('15087','2013-03-10','09:00:00',2.47),('15087','2013-03-10','09:05:00',2.54),('15087','2013-03-10','09:10:00',2.62),('15087','2013-03-10','09:15:00',2.7),('15087','2013-03-10','09:20:00',2.77),('15087','2013-03-10','09:25:00',2.85),('15087','2013-03-10','09:30:00',2.95),('15087','2013-03-10','09:35:00',3.03),('15087','2013-03-10','09:40:00',3.17),('15087','2013-03-10','09:45:00',2.33),('15087','2013-03-10','09:50:00',3.46),('15087','2013-03-10','09:55:00',2.75),('15087','2013-03-10','10:00:00',3.63),('15087','2013-03-10','10:05:00',2.24),('15087','2013-03-10','10:10:00',2.96),('15087','2013-03-10','10:15:00',3.5),('15087','2013-03-10','10:20:00',2.65),('15087','2013-03-10','10:25:00',3.67),('15087','2013-03-10','10:30:00',2.89),('15087','2013-03-10','10:35:00',2.37),('15087','2013-03-10','10:40:00',3.57),('15087','2013-03-10','10:45:00',3.93),('15087','2013-03-10','10:50:00',2.19),('15087','2013-03-10','10:55:00',2.04),('15087','2013-03-10','11:00:00',1.72),('15087','2013-03-10','11:05:00',3.17),('15087','2013-03-10','11:10:00',1.91),('15087','2013-03-10','11:15:00',1.73),('15087','2013-03-10','11:20:00',2.34),('15087','2013-03-10','11:25:00',2.45),('15087','2013-03-10','11:30:00',2.13),('15087','2013-03-10','11:35:00',2.65),('15087','2013-03-10','11:40:00',1.3),('15087','2013-03-10','11:45:00',1.43),('15087','2013-03-10','11:50:00',4.02),('15087','2013-03-10','11:55:00',4.3),('15087','2013-03-10','12:00:00',4.26),('15087','2013-03-10','12:05:00',4.15),('15087','2013-03-10','12:10:00',4.21),('15087','2013-03-10','12:15:00',2.5),('15087','2013-03-10','12:20:00',4.37),('15087','2013-03-10','12:25:00',3.66),('15087','2013-03-10','12:30:00',4.1),('15087','2013-03-10','12:35:00',3.55),('15087','2013-03-10','12:40:00',4.31),('15087','2013-03-10','12:45:00',4.39),('15087','2013-03-10','12:50:00',4.25),('15087','2013-03-10','12:55:00',4.15),('15087','2013-03-10','13:00:00',4.01),('15087','2013-03-10','13:05:00',3.96),('15087','2013-03-10','13:10:00',3.73),('15087','2013-03-10','13:15:00',3.88),('15087','2013-03-10','13:20:00',3.85),('15087','2013-03-10','13:25:00',3.83),('15087','2013-03-10','13:30:00',3.56),('15087','2013-03-10','13:35:00',3.36),('15087','2013-03-10','13:40:00',2.16),('15087','2013-03-10','13:45:00',2.36),('15087','2013-03-10','13:50:00',2.05),('15087','2013-03-10','13:55:00',1.9),('15087','2013-03-10','14:00:00',1.54),('15087','2013-03-10','14:05:00',2.12),('15087','2013-03-10','14:10:00',2.2),('15087','2013-03-10','14:15:00',3.07),('15087','2013-03-10','14:20:00',2.91),('15087','2013-03-10','14:25:00',1.73),('15087','2013-03-10','14:30:00',2.61),('15087','2013-03-10','14:35:00',3.08),('15087','2013-03-10','14:40:00',2.57),('15087','2013-03-10','14:45:00',1.74),('15087','2013-03-10','14:50:00',1.75),('15087','2013-03-10','14:55:00',1.52),('15087','2013-03-10','15:00:00',1.19),('15087','2013-03-10','15:05:00',1.45),('15087','2013-03-10','15:10:00',1.37),('15087','2013-03-09','08:00:00',1.31),('15087','2013-03-09','08:05:00',1.41),('15087','2013-03-09','08:10:00',1.51),('15087','2013-03-09','08:15:00',1.58),('15087','2013-03-09','08:20:00',1.67),('15087','2013-03-09','08:25:00',1.78),('15087','2013-03-09','08:30:00',1.88),('15087','2013-03-09','08:35:00',1.92),('15087','2013-03-09','08:40:00',1.98),('15087','2013-03-09','08:45:00',1.99),('15087','2013-03-09','08:50:00',1.83),('15087','2013-03-09','08:55:00',2.03),('15087','2013-03-09','09:00:00',2.01),('15087','2013-03-09','09:05:00',2.09),('15087','2013-03-09','09:20:00',1.87),('15087','2013-03-09','09:25:00',2.08),('15087','2013-03-09','09:30:00',2.52),('15087','2013-03-09','09:35:00',2.6),('15087','2013-03-09','09:40:00',3.09),('15087','2013-03-09','09:45:00',3.91),('15087','2013-03-09','09:50:00',1.69),('15087','2013-03-09','09:55:00',2.94),('15087','2013-03-09','10:05:00',1.19),('15087','2013-03-09','10:10:00',1.04),('15087','2013-03-09','10:15:00',2.06),('15087','2013-03-09','10:20:00',1.05),('15087','2013-03-09','10:35:00',2.13),('15087','2013-03-09','10:40:00',2.87),('15087','2013-03-09','10:45:00',4.39),('15087','2013-03-09','10:50:00',3.97),('15087','2013-03-09','10:55:00',3),('15087','2013-03-09','11:00:00',4.12),('15087','2013-03-09','11:05:00',4.12),('15087','2013-03-09','11:10:00',4.17),('15087','2013-03-09','11:15:00',4.23),('15087','2013-03-09','11:20:00',4.34),('15087','2013-03-09','11:25:00',3.94),('15087','2013-03-09','11:30:00',4.23),('15087','2013-03-09','11:35:00',4.16),('15087','2013-03-09','11:40:00',4.2),('15087','2013-03-09','11:45:00',4.21),('15087','2013-03-09','11:50:00',4.15),('15087','2013-03-09','11:55:00',3.87),('15087','2013-03-09','12:00:00',2.98),('15087','2013-03-09','12:05:00',1.32),('15087','2013-03-09','12:10:00',2.06),('15087','2013-03-09','12:15:00',2.09),('15087','2013-03-09','12:20:00',2.61),('15087','2013-03-09','12:25:00',1.79),('15087','2013-03-09','12:30:00',1.6),('15087','2013-03-09','12:35:00',1.83),('15087','2013-03-09','12:40:00',1.69),('15087','2013-03-09','12:45:00',2.45),('15087','2013-03-09','12:50:00',2.27),('15087','2013-03-09','12:55:00',4.16),('15087','2013-03-09','13:00:00',4.08),('15087','2013-03-09','13:05:00',3.99),('15087','2013-03-09','13:10:00',4.01),('15087','2013-03-09','13:15:00',4.33),('15087','2013-03-09','13:20:00',3.5),('15087','2013-03-09','13:25:00',3.36),('15087','2013-03-09','13:30:00',4.01),('15087','2013-03-09','13:35:00',3.87),('15087','2013-03-09','13:40:00',3.41),('15087','2013-03-09','13:45:00',3.65),('15087','2013-03-09','13:50:00',2.74),('15087','2013-03-09','14:00:00',1.01),('15087','2013-03-09','14:05:00',1.26),('15087','2013-03-09','14:10:00',2.88),('15087','2013-03-09','14:15:00',3.17),('15087','2013-03-09','14:20:00',2.98),('15087','2013-03-09','14:25:00',2.85),('15087','2013-03-09','14:30:00',2.84),('15087','2013-03-09','14:35:00',2.74),('15087','2013-03-09','14:40:00',2.66),('15087','2013-03-09','14:45:00',2.83),('15087','2013-03-09','14:50:00',2.68),('15087','2013-03-09','14:55:00',2.71),('15087','2013-03-09','15:00:00',2.63),('15087','2013-03-09','15:05:00',2.49),('15087','2013-03-09','15:10:00',2.32),('15087','2013-03-09','15:15:00',2.28),('15087','2013-03-09','15:20:00',2.18),('15087','2013-03-09','15:25:00',2.08),('15087','2013-03-09','15:30:00',2.05),('15087','2013-03-09','15:35:00',1.92),('15087','2013-03-09','15:40:00',1.81),('15087','2013-03-09','15:45:00',1.85),('15087','2013-03-09','15:50:00',1.74),('15087','2013-03-09','15:55:00',1.48),('15087','2013-03-09','16:00:00',1.42),('15087','2013-03-09','16:05:00',1.4),('15087','2013-03-09','16:10:00',1.16),('15087','2013-03-09','16:15:00',1.4),('15087','2013-03-09','16:20:00',1.07),('15087','2013-03-09','16:25:00',1.28),('15087','2013-03-09','16:30:00',1.1),('15087','2013-03-08','08:25:00',1.05),('15087','2013-03-08','08:30:00',1.88),('15087','2013-03-08','08:35:00',1.6),('15087','2013-03-08','08:50:00',1),('15087','2013-03-08','09:30:00',2.17),('15087','2013-03-08','09:35:00',1.94),('15087','2013-03-08','09:40:00',1.78),('15087','2013-03-08','09:45:00',1.38),('15087','2013-03-08','09:50:00',1.87),('15087','2013-03-08','09:55:00',1.68),('15087','2013-03-08','10:05:00',1.15),('15087','2013-03-08','10:10:00',1.69),('15087','2013-03-08','10:15:00',1.82),('15087','2013-03-08','10:20:00',1.28),('15087','2013-03-08','10:25:00',1.53),('15087','2013-03-08','10:30:00',1.91),('15087','2013-03-08','10:35:00',2.45),('15087','2013-03-08','10:40:00',1.44),('15087','2013-03-08','10:45:00',1.07),('15087','2013-03-08','10:50:00',1.43),('15087','2013-03-08','10:55:00',1.25),('15087','2013-03-08','11:00:00',1.1),('15087','2013-03-08','11:35:00',1.85),('15087','2013-03-08','11:40:00',2.31),('15087','2013-03-08','11:45:00',1.8),('15087','2013-03-08','11:50:00',1.56),('15087','2013-03-08','11:55:00',2.04),('15087','2013-03-08','12:00:00',2.3),('15087','2013-03-08','12:05:00',1.43),('15087','2013-03-08','12:10:00',1.07),('15087','2013-03-08','12:20:00',1.4),('15087','2013-03-08','12:25:00',1.2),('15087','2013-03-08','12:30:00',1.06),('15087','2013-03-08','12:35:00',1.78),('15087','2013-03-08','12:40:00',2.26),('15087','2013-03-08','12:45:00',2.11),('15087','2013-03-08','12:50:00',2.63),('15087','2013-03-08','12:55:00',2.32),('15087','2013-03-08','13:00:00',2.28),('15087','2013-03-08','13:05:00',2.39),('15087','2013-03-08','13:10:00',1.5),('15087','2013-03-08','13:15:00',1.16),('15087','2013-03-08','13:20:00',1.13),('15087','2013-03-08','13:25:00',1.57),('15087','2013-03-08','13:30:00',2.25),('15087','2013-03-08','13:35:00',1.58),('15087','2013-03-08','13:40:00',1.32),('15087','2013-03-08','17:10:00',1.25),('15087','2013-03-07','08:40:00',1.03),('15087','2013-03-07','08:45:00',1.01),('15087','2013-03-07','08:50:00',1.15),('15087','2013-03-07','10:50:00',1.26),('15087','2013-03-07','10:55:00',1.24),('15087','2013-03-07','11:00:00',1.24),('15087','2013-03-07','11:05:00',1.51),('15087','2013-03-07','11:10:00',1.04),('15087','2013-03-07','11:30:00',2.04),('15087','2013-03-07','11:35:00',2.53),('15087','2013-03-07','11:40:00',2.32),('15087','2013-03-07','11:45:00',2.57),('15087','2013-03-07','11:50:00',2.55),('15087','2013-03-07','11:55:00',1.86),('15087','2013-03-07','12:00:00',1.28),('15087','2013-03-07','12:05:00',1.04),('15087','2013-03-07','12:25:00',1.25),('15087','2013-03-07','12:40:00',1.41),('15087','2013-03-07','12:45:00',2.08),('15087','2013-03-07','12:50:00',1.89),('15087','2013-03-07','12:55:00',1.66),('15087','2013-03-07','13:00:00',1.95),('15087','2013-03-07','13:05:00',1.97),('15087','2013-03-07','13:10:00',1.82),('15087','2013-03-07','13:15:00',2.03),('15087','2013-03-07','13:20:00',2.42),('15087','2013-03-07','13:25:00',2.07),('15087','2013-03-07','13:30:00',1.77),('15087','2013-03-07','13:35:00',1.62),('15087','2013-03-07','14:10:00',1.05),('15087','2013-03-05','08:15:00',1.33),('15087','2013-03-05','08:25:00',1.43),('15087','2013-03-05','08:30:00',2.02),('15087','2013-03-05','08:35:00',1.81),('15087','2013-03-05','08:40:00',1.87),('15087','2013-03-05','08:45:00',1.58),('15087','2013-03-05','08:50:00',1.78),('15087','2013-03-05','08:55:00',1.66),('15087','2013-03-05','09:00:00',1.71),('15087','2013-03-05','09:05:00',1.79),('15087','2013-03-05','09:10:00',1.64),('15087','2013-03-05','09:15:00',1.59),('15087','2013-03-05','09:20:00',1.62),('15087','2013-03-05','09:25:00',1.6),('15087','2013-03-05','09:30:00',1.68),('15087','2013-03-05','09:35:00',1.81),('15087','2013-03-05','09:40:00',1.92),('15087','2013-03-05','09:45:00',1.93),('15087','2013-03-05','09:50:00',1.9),('15087','2013-03-05','09:55:00',1.83),('15087','2013-03-05','10:00:00',1.75),('15087','2013-03-05','10:05:00',1.91),('15087','2013-03-05','10:10:00',1.96),('15087','2013-03-05','10:15:00',2.08),('15087','2013-03-05','10:20:00',2.26),('15087','2013-03-05','10:25:00',2.05),('15087','2013-03-05','10:30:00',2.02),('15087','2013-03-05','10:35:00',2.41),('15087','2013-03-05','10:40:00',2.46),('15087','2013-03-05','10:45:00',2.58),('15087','2013-03-05','10:50:00',2.78),('15087','2013-03-05','10:55:00',2.8),('15087','2013-03-05','11:00:00',2.62),('15087','2013-03-05','11:05:00',2.83),('15087','2013-03-05','11:10:00',2.92),('15087','2013-03-05','11:15:00',2.87),('15087','2013-03-05','11:20:00',2.8),('15087','2013-03-05','11:25:00',2.7),('15087','2013-03-05','11:30:00',2.77),('15087','2013-03-05','11:35:00',3.05),('15087','2013-03-05','11:40:00',3.33),('15087','2013-03-05','11:45:00',3.2),('15087','2013-03-05','11:50:00',3.23),('15087','2013-03-05','11:55:00',3.32),('15087','2013-03-05','12:00:00',3.41),('15087','2013-03-05','12:05:00',3.5),('15087','2013-03-05','12:10:00',3.65),('15087','2013-03-05','12:15:00',2.94),('15087','2013-03-05','12:20:00',3.37),('15087','2013-03-05','12:25:00',3.33),('15087','2013-03-05','12:30:00',2.78),('15087','2013-03-05','12:35:00',2.64),('15087','2013-03-05','12:40:00',2.68),('15087','2013-03-05','12:45:00',2.83),('15087','2013-03-05','12:50:00',2.46),('15087','2013-03-05','12:55:00',2.2),('15087','2013-03-05','13:00:00',1.86),('15087','2013-03-05','13:05:00',1.77),('15087','2013-03-05','13:10:00',1.92),('15087','2013-03-05','13:15:00',2.04),('15087','2013-03-05','13:20:00',1.94),('15087','2013-03-05','13:25:00',1.75),('15087','2013-03-05','13:30:00',1.57),('15087','2013-03-05','13:35:00',1.46),('15087','2013-03-05','13:40:00',1.36),('15087','2013-03-05','13:45:00',1.23),('15087','2013-03-05','13:50:00',1.11),('15087','2013-03-05','13:55:00',1.06),('15087','2013-03-05','14:00:00',1.05),('15087','2013-03-05','14:05:00',1.08),('15087','2013-03-05','14:10:00',1.12),('15087','2013-03-05','14:15:00',1.04),('15087','2013-03-05','14:40:00',1.01),('15087','2013-03-05','14:45:00',1.03),('15087','2013-03-05','14:50:00',1),('15087','2013-03-05','15:45:00',1.17),('15087','2013-03-05','15:50:00',1.13),('15087','2013-03-04','08:00:00',1.13),('15087','2013-03-04','08:05:00',1.24),('15087','2013-03-04','08:10:00',1.35),('15087','2013-03-04','08:15:00',1.45),('15087','2013-03-04','08:20:00',1.55),('15087','2013-03-04','08:25:00',1.65),('15087','2013-03-04','08:30:00',1.75),('15087','2013-03-04','08:35:00',1.85),('15087','2013-03-04','08:40:00',1.94),('15087','2013-03-04','08:45:00',2.02),('15087','2013-03-04','08:50:00',2.12),('15087','2013-03-04','08:55:00',2.2),('15087','2013-03-04','09:00:00',2.27),('15087','2013-03-04','09:05:00',2.36),('15087','2013-03-04','09:10:00',2.45),('15087','2013-03-04','09:15:00',2.52),('15087','2013-03-04','09:20:00',2.59),('15087','2013-03-04','09:25:00',2.66),('15087','2013-03-04','09:30:00',2.75),('15087','2013-03-04','09:35:00',2.83),('15087','2013-03-04','09:40:00',2.88),('15087','2013-03-04','09:45:00',2.96),('15087','2013-03-04','09:50:00',3.01),('15087','2013-03-04','09:55:00',3.11),('15087','2013-03-04','10:00:00',3.09),('15087','2013-03-04','10:05:00',3.23),('15087','2013-03-04','10:10:00',3.27),('15087','2013-03-04','10:15:00',3.31),('15087','2013-03-04','10:20:00',3.37),('15087','2013-03-04','10:25:00',3.43),('15087','2013-03-04','10:30:00',3.46),('15087','2013-03-04','10:35:00',3.49),('15087','2013-03-04','10:40:00',3.52),('15087','2013-03-04','10:45:00',3.56),('15087','2013-03-04','10:50:00',3.6),('15087','2013-03-04','10:55:00',3.64),('15087','2013-03-04','11:00:00',3.7),('15087','2013-03-04','11:05:00',3.76),('15087','2013-03-04','11:10:00',3.77),('15087','2013-03-04','11:15:00',3.78),('15087','2013-03-04','11:20:00',3.8),('15087','2013-03-04','11:25:00',3.83),('15087','2013-03-04','11:30:00',3.83),('15087','2013-03-04','11:35:00',3.85),('15087','2013-03-04','11:40:00',3.89),('15087','2013-03-04','11:45:00',3.88),('15087','2013-03-04','11:50:00',3.88),('15087','2013-03-04','11:55:00',3.89),('15087','2013-03-04','12:00:00',3.91),('15087','2013-03-04','12:05:00',3.94),('15087','2013-03-04','12:10:00',3.96),('15087','2013-03-04','12:15:00',3.97),('15087','2013-03-04','12:20:00',3.92),('15087','2013-03-04','12:25:00',3.95),('15087','2013-03-04','12:30:00',3.96),('15087','2013-03-04','12:35:00',3.96),('15087','2013-03-04','12:40:00',3.94),('15087','2013-03-04','12:45:00',3.89),('15087','2013-03-04','12:50:00',3.84),('15087','2013-03-04','12:55:00',3.79),('15087','2013-03-04','13:00:00',3.69),('15087','2013-03-04','13:05:00',3.68),('15087','2013-03-04','13:10:00',3.49),('15087','2013-03-04','13:15:00',3.28),('15087','2013-03-04','13:20:00',3.52),('15087','2013-03-04','13:25:00',3.09),('15087','2013-03-04','13:30:00',3.01),('15087','2013-03-04','13:35:00',3.57),('15087','2013-03-04','13:40:00',3.2),('15087','2013-03-04','13:45:00',2.83),('15087','2013-03-04','13:50:00',3.16),('15087','2013-03-04','13:55:00',3.06),('15087','2013-03-04','14:00:00',3.08),('15087','2013-03-04','14:05:00',3.05),('15087','2013-03-04','14:10:00',2.76),('15087','2013-03-04','14:15:00',2.65),('15087','2013-03-04','14:20:00',2.75),('15087','2013-03-04','14:25:00',2.7),('15087','2013-03-04','14:30:00',2.6),('15087','2013-03-04','14:35:00',2.68),('15087','2013-03-04','14:40:00',2.65),('15087','2013-03-04','14:45:00',2.49),('15087','2013-03-04','14:50:00',2.42),('15087','2013-03-04','14:55:00',2.33),('15087','2013-03-04','15:00:00',2.1),('15087','2013-03-04','15:05:00',2.2),('15087','2013-03-04','15:10:00',2.16),('15087','2013-03-04','15:15:00',1.94),('15087','2013-03-04','15:20:00',1.98),('15087','2013-03-04','15:25:00',1.87),('15087','2013-03-04','15:30:00',1.72),('15087','2013-03-04','15:35:00',1.79),('15087','2013-03-04','15:40:00',1.7),('15087','2013-03-04','15:45:00',1.61),('15087','2013-03-04','15:50:00',1.56),('15087','2013-03-04','15:55:00',1.42),('15087','2013-03-04','16:00:00',1.35),('15087','2013-03-04','16:05:00',1.3),('15087','2013-03-04','16:10:00',1.22),('15087','2013-03-04','16:15:00',1.11),('15087','2013-03-04','16:20:00',1.04),('15087','2013-03-04','16:25:00',1.01),('15087','2013-03-03','08:00:00',1.01),('15087','2013-03-03','08:05:00',1.24),('15087','2013-03-03','08:10:00',1.35),('15087','2013-03-03','08:15:00',1.47),('15087','2013-03-03','08:20:00',1.54),('15087','2013-03-03','08:25:00',1.68),('15087','2013-03-03','08:30:00',1.78),('15087','2013-03-03','08:35:00',1.88),('15087','2013-03-03','08:40:00',1.99),('15087','2013-03-03','08:45:00',2.08),('15087','2013-03-03','08:50:00',2.18),('15087','2013-03-03','08:55:00',2.26),('15087','2013-03-03','09:00:00',2.35),('15087','2013-03-03','09:05:00',2.44),('15087','2013-03-03','09:10:00',2.53),('15087','2013-03-03','09:15:00',2.61),('15087','2013-03-03','09:20:00',2.68),('15087','2013-03-03','09:25:00',2.78),('15087','2013-03-03','09:30:00',2.85),('15087','2013-03-03','09:35:00',2.9),('15087','2013-03-03','09:40:00',2.98),('15087','2013-03-03','09:45:00',3.06),('15087','2013-03-03','09:50:00',3.15),('15087','2013-03-03','09:55:00',3.25),('15087','2013-03-03','10:00:00',3.34),('15087','2013-03-03','10:05:00',3.39),('15087','2013-03-03','10:10:00',3.45),('15087','2013-03-03','10:15:00',3.52),('15087','2013-03-03','10:20:00',3.57),('15087','2013-03-03','10:25:00',3.63),('15087','2013-03-03','10:30:00',3.68),('15087','2013-03-03','10:35:00',3.7),('15087','2013-03-03','10:40:00',3.76),('15087','2013-03-03','10:45:00',3.8),('15087','2013-03-03','10:50:00',3.84),('15087','2013-03-03','10:55:00',3.88),('15087','2013-03-03','11:00:00',3.91),('15087','2013-03-03','11:05:00',3.9),('15087','2013-03-03','11:10:00',3.93),('15087','2013-03-03','11:15:00',3.94),('15087','2013-03-03','11:20:00',3.96),('15087','2013-03-03','11:25:00',3.97),('15087','2013-03-03','11:30:00',4.03),('15087','2013-03-03','11:35:00',4.05),('15087','2013-03-03','11:40:00',4.02),('15087','2013-03-03','11:45:00',4.03),('15087','2013-03-03','11:50:00',4.05),('15087','2013-03-03','11:55:00',4.05),('15087','2013-03-03','12:00:00',4.07),('15087','2013-03-03','12:05:00',4.07),('15087','2013-03-03','12:10:00',4.07),('15087','2013-03-03','12:15:00',4.05),('15087','2013-03-03','12:20:00',4.03),('15087','2013-03-03','12:25:00',4.03),('15087','2013-03-03','12:30:00',4.05),('15087','2013-03-03','12:35:00',4.06),('15087','2013-03-03','12:40:00',4.06),('15087','2013-03-03','12:45:00',4.06),('15087','2013-03-03','12:50:00',4),('15087','2013-03-03','12:55:00',4),('15087','2013-03-03','13:00:00',3.93),('15087','2013-03-03','13:05:00',3.87),('15087','2013-03-03','13:10:00',3.86),('15087','2013-03-03','13:15:00',3.83),('15087','2013-03-03','13:20:00',3.72),('15087','2013-03-03','13:25:00',3.76),('15087','2013-03-03','13:30:00',3.7),('15087','2013-03-03','13:35:00',3.5),('15087','2013-03-03','13:40:00',3.56),('15087','2013-03-03','13:45:00',3.48),('15087','2013-03-03','13:50:00',3.34),('15087','2013-03-03','13:55:00',3.33),('15087','2013-03-03','14:00:00',3.27),('15087','2013-03-03','14:05:00',3.13),('15087','2013-03-03','14:10:00',3.1),('15087','2013-03-03','14:15:00',2.99),('15087','2013-03-03','14:20:00',2.86),('15087','2013-03-03','14:25:00',2.99),('15087','2013-03-03','14:30:00',2.79),('15087','2013-03-03','14:35:00',2.79),('15087','2013-03-03','14:40:00',2.82),('15087','2013-03-03','14:45:00',2.68),('15087','2013-03-03','14:50:00',2.54),('15087','2013-03-03','14:55:00',2.58),('15087','2013-03-03','15:00:00',2.52),('15087','2013-03-03','15:05:00',2.4),('15087','2013-03-03','15:10:00',2.31),('15087','2013-03-03','15:15:00',2.27),('15087','2013-03-03','15:20:00',2.16),('15087','2013-03-03','15:25:00',2.13),('15087','2013-03-03','15:30:00',2.05),('15087','2013-03-03','15:35:00',1.96),('15087','2013-03-03','15:40:00',1.87),('15087','2013-03-03','15:45:00',1.75),('15087','2013-03-03','15:50:00',1.61),('15087','2013-03-03','15:55:00',1.53),('15087','2013-03-03','16:00:00',1.42),('15087','2013-03-03','16:05:00',1.35),('15087','2013-03-03','16:10:00',1.27),('15087','2013-03-03','16:15:00',1.15),('15087','2013-03-03','16:20:00',1.08),('15087','2013-03-03','16:25:00',1.04),('15087','2013-03-02','10:40:00',1.02),('15087','2013-03-02','10:45:00',1.02),('15087','2013-03-02','10:50:00',1.18),('15087','2013-03-02','10:55:00',1.23),('15087','2013-03-02','11:00:00',1.33),('15087','2013-03-02','11:05:00',1.41),('15087','2013-03-02','11:10:00',1.46),('15087','2013-03-02','11:15:00',1.68),('15087','2013-03-02','11:20:00',1.48),('15087','2013-03-02','11:25:00',1.29),('15087','2013-03-02','11:30:00',1.16),('15087','2013-03-02','11:35:00',1.19),('15087','2013-03-02','11:40:00',1.4),('15087','2013-03-02','11:45:00',1.26),('15087','2013-03-02','11:50:00',1.3),('15087','2013-03-02','11:55:00',1.18),('15087','2013-03-02','12:00:00',1.14),('15087','2013-03-02','12:05:00',1.36),('15087','2013-03-02','12:10:00',1.33),('15087','2013-03-02','12:15:00',1.41),('15087','2013-03-02','12:20:00',1.31),('15087','2013-03-02','12:25:00',1.38),('15087','2013-03-02','12:30:00',1.54),('15087','2013-03-02','12:35:00',1.63),('15087','2013-03-02','12:40:00',1.88),('15087','2013-03-02','12:45:00',1.83),('15087','2013-03-02','12:50:00',1.61),('15087','2013-03-02','12:55:00',1.95),('15087','2013-03-02','13:00:00',1.76),('15087','2013-03-02','13:05:00',1.6),('15087','2013-03-02','13:10:00',1.11),('15087','2013-03-02','13:30:00',1.02),('15087','2013-03-02','13:35:00',1.04),('15087','2013-03-02','13:40:00',1.13),('15087','2013-03-02','13:45:00',1.26),('15087','2013-03-02','13:50:00',1.21),('15087','2013-03-02','13:55:00',1.27),('15087','2013-03-02','14:00:00',1.43),('15087','2013-03-02','14:05:00',1.36),('15087','2013-03-02','14:10:00',1.19),('15087','2013-03-02','14:15:00',1.05),('15087','2013-03-02','14:20:00',1),('15087','2013-03-01','08:10:00',1.01),('15087','2013-03-01','08:15:00',1.12),('15087','2013-03-01','08:20:00',1.19),('15087','2013-03-01','08:25:00',1.18),('15087','2013-03-01','08:30:00',1.31),('15087','2013-03-01','08:35:00',1.41),('15087','2013-03-01','08:40:00',1.52),('15087','2013-03-01','08:45:00',1.6),('15087','2013-03-01','08:50:00',1.7),('15087','2013-03-01','08:55:00',1.82),('15087','2013-03-01','09:00:00',1.95),('15087','2013-03-01','09:05:00',2.11),('15087','2013-03-01','09:10:00',2.09),('15087','2013-03-01','09:15:00',2.14),('15087','2013-03-01','09:20:00',2.19),('15087','2013-03-01','09:25:00',2.21),('15087','2013-03-01','09:30:00',2.41),('15087','2013-03-01','09:35:00',2.35),('15087','2013-03-01','09:40:00',2.54),('15087','2013-03-01','09:45:00',2.67),('15087','2013-03-01','09:50:00',2.66),('15087','2013-03-01','09:55:00',2.64),('15087','2013-03-01','10:00:00',2.7),('15087','2013-03-01','10:05:00',2.68),('15087','2013-03-01','10:10:00',2.59),('15087','2013-03-01','10:15:00',2.27),('15087','2013-03-01','10:20:00',2.26),('15087','2013-03-01','10:25:00',2.4),('15087','2013-03-01','10:30:00',2.76),('15087','2013-03-01','10:35:00',2.84),('15087','2013-03-01','10:40:00',2.54),('15087','2013-03-01','10:45:00',2.43),('15087','2013-03-01','10:50:00',2.31),('15087','2013-03-01','10:55:00',2.17),('15087','2013-03-01','11:00:00',1.88),('15087','2013-03-01','11:05:00',1.69),('15087','2013-03-01','11:10:00',1.67),('15087','2013-03-01','11:15:00',1.88),('15087','2013-03-01','11:20:00',1.94),('15087','2013-03-01','11:25:00',1.93),('15087','2013-03-01','11:30:00',1.98),('15087','2013-03-01','11:35:00',1.98),('15087','2013-03-01','11:40:00',1.88),('15087','2013-03-01','11:45:00',1.8),('15087','2013-03-01','11:50:00',1.76),('15087','2013-03-01','11:55:00',1.69),('15087','2013-03-01','12:00:00',1.62),('15087','2013-03-01','12:05:00',1.53),('15087','2013-03-01','12:10:00',1.42),('15087','2013-03-01','12:15:00',1.28),('15087','2013-03-01','12:20:00',1.17),('15087','2013-03-01','12:25:00',1.18),('15087','2013-03-01','12:30:00',1.23),('15087','2013-03-01','12:35:00',1.22),('15087','2013-03-01','12:40:00',1.18),('15087','2013-03-01','12:45:00',1.17),('15087','2013-03-01','12:50:00',1.23),('15087','2013-03-01','12:55:00',1.32),('15087','2013-03-01','13:00:00',1.4),('15087','2013-03-01','13:05:00',1.41),('15087','2013-03-01','13:10:00',1.47),('15087','2013-03-01','13:15:00',1.57),('15087','2013-03-01','13:20:00',1.71),('15087','2013-03-01','13:25:00',1.86),('15087','2013-03-01','13:30:00',1.78),('15087','2013-03-01','13:35:00',1.66),('15087','2013-03-01','13:40:00',1.58),('15087','2013-03-01','13:45:00',1.58),('15087','2013-03-01','13:50:00',1.56),('15087','2013-03-01','13:55:00',1.49),('15087','2013-03-01','14:00:00',1.45),('15087','2013-03-01','14:05:00',1.38),('15087','2013-03-01','14:10:00',1.27),('15087','2013-03-01','14:15:00',1.16),('15087','2013-03-01','14:20:00',1.12),('15087','2013-03-01','14:25:00',1.14),('15087','2013-03-01','14:30:00',1.16),('15087','2013-03-01','14:35:00',1.17),('15087','2013-03-01','14:40:00',1.08),('15087','2013-03-01','14:45:00',1.03),('15087','2013-02-28','08:10:00',1.13),('15087','2013-02-28','08:15:00',1.23),('15087','2013-02-28','08:20:00',1.34),('15087','2013-02-28','08:25:00',1.42),('15087','2013-02-28','08:30:00',1.53),('15087','2013-02-28','08:35:00',1.63),('15087','2013-02-28','08:40:00',1.72),('15087','2013-02-28','08:45:00',1.82),('15087','2013-02-28','08:50:00',1.94),('15087','2013-02-28','08:55:00',2.06),('15087','2013-02-28','09:00:00',2.15),('15087','2013-02-28','09:05:00',2.23),('15087','2013-02-28','09:10:00',2.26),('15087','2013-02-28','09:15:00',2.34),('15087','2013-02-28','09:20:00',2.44),('15087','2013-02-28','09:25:00',2.48),('15087','2013-02-28','09:30:00',2.55),('15087','2013-02-28','09:35:00',2.63),('15087','2013-02-28','09:40:00',2.68),('15087','2013-02-28','09:45:00',2.79),('15087','2013-02-28','09:50:00',2.64),('15087','2013-02-28','09:55:00',2.84),('15087','2013-02-28','10:00:00',2.95),('15087','2013-02-28','10:05:00',3.02),('15087','2013-02-28','10:10:00',3.06),('15087','2013-02-28','10:15:00',3.09),('15087','2013-02-28','10:20:00',3.15),('15087','2013-02-28','10:25:00',3.21),('15087','2013-02-28','10:30:00',3.2),('15087','2013-02-28','10:35:00',3.24),('15087','2013-02-28','10:40:00',3.29),('15087','2013-02-28','10:45:00',3.36),('15087','2013-02-28','10:50:00',3.44),('15087','2013-02-28','10:55:00',3.41),('15087','2013-02-28','11:00:00',3.54),('15087','2013-02-28','11:05:00',3.61),('15087','2013-02-28','11:10:00',3.62),('15087','2013-02-28','11:15:00',3.63),('15087','2013-02-28','11:20:00',3.67),('15087','2013-02-28','11:25:00',3.73),('15087','2013-02-28','11:30:00',3.77),('15087','2013-02-28','11:35:00',3.7),('15087','2013-02-28','11:40:00',3.71),('15087','2013-02-28','11:45:00',3.63),('15087','2013-02-28','11:50:00',3.55),('15087','2013-02-28','11:55:00',3.63),('15087','2013-02-28','12:00:00',3.7),('15087','2013-02-28','12:05:00',3.71),('15087','2013-02-28','12:10:00',3.66),('15087','2013-02-28','12:15:00',3.72),('15087','2013-02-28','12:20:00',3.82),('15087','2013-02-28','12:25:00',3.8),('15087','2013-02-28','12:30:00',3.81),('15087','2013-02-28','12:35:00',3.84),('15087','2013-02-28','12:40:00',3.79),('15087','2013-02-28','12:45:00',3.68),('15087','2013-02-28','12:50:00',3.69),('15087','2013-02-28','12:55:00',3.73),('15087','2013-02-28','13:00:00',3.45),('15087','2013-02-28','13:05:00',3.67),('15087','2013-02-28','13:10:00',3.58),('15087','2013-02-28','13:15:00',3.37),('15087','2013-02-28','13:20:00',3.13),('15087','2013-02-28','13:25:00',3.08),('15087','2013-02-28','13:30:00',3.44),('15087','2013-02-28','13:35:00',3.4),('15087','2013-02-28','13:40:00',3.42),('15087','2013-02-28','13:45:00',3.29),('15087','2013-02-28','13:50:00',3.17),('15087','2013-02-28','13:55:00',3.25),('15087','2013-02-28','14:00:00',3.29),('15087','2013-02-28','14:05:00',3.24),('15087','2013-02-28','14:10:00',3.12),('15087','2013-02-28','14:15:00',3.02),('15087','2013-02-28','14:20:00',2.93),('15087','2013-02-28','14:25:00',2.77),('15087','2013-02-28','14:30:00',2.62),('15087','2013-02-28','14:35:00',2.39),('15087','2013-02-28','14:40:00',2.59),('15087','2013-02-28','14:45:00',2.34),('15087','2013-02-28','14:50:00',2.16),('15087','2013-02-28','14:55:00',2.05),('15087','2013-02-28','15:00:00',2.26),('15087','2013-02-28','15:05:00',2),('15087','2013-02-28','15:10:00',1.9),('15087','2013-02-28','15:15:00',2.06),('15087','2013-02-28','15:20:00',1.92),('15087','2013-02-28','15:25:00',1.73),('15087','2013-02-28','15:30:00',1.72),('15087','2013-02-28','15:35:00',1.6),('15087','2013-02-28','15:40:00',1.53),('15087','2013-02-28','15:45:00',1.55),('15087','2013-02-28','15:50:00',1.45),('15087','2013-02-28','15:55:00',1.37),('15087','2013-02-28','16:00:00',1.28),('15087','2013-02-28','16:05:00',1.18),('15087','2013-02-28','16:10:00',1.06),('15087','2013-02-28','16:15:00',1.01),('15087','2013-02-27','08:15:00',1.16),('15087','2013-02-27','08:20:00',1.28),('15087','2013-02-27','08:25:00',1.38),('15087','2013-02-27','08:30:00',1.48),('15087','2013-02-27','08:35:00',1.57),('15087','2013-02-27','08:40:00',1.66),('15087','2013-02-27','08:45:00',1.73),('15087','2013-02-27','08:50:00',1.82),('15087','2013-02-27','08:55:00',1.91),('15087','2013-02-27','09:00:00',2),('15087','2013-02-27','09:05:00',2.1),('15087','2013-02-27','09:10:00',2.18),('15087','2013-02-27','09:15:00',2.27),('15087','2013-02-27','09:20:00',2.34),('15087','2013-02-27','09:25:00',2.43),('15087','2013-02-27','09:30:00',2.49),('15087','2013-02-27','09:35:00',2.58),('15087','2013-02-27','09:40:00',2.63),('15087','2013-02-27','09:45:00',2.71),('15087','2013-02-27','09:50:00',2.78),('15087','2013-02-27','09:55:00',2.88),('15087','2013-02-27','10:00:00',2.93),('15087','2013-02-27','10:05:00',2.99),('15087','2013-02-27','10:10:00',3.05),('15087','2013-02-27','10:15:00',3.1),('15087','2013-02-27','10:20:00',3.17),('15087','2013-02-27','10:25:00',3.22),('15087','2013-02-27','10:30:00',3.25),('15087','2013-02-27','10:35:00',3.33),('15087','2013-02-27','10:40:00',3.29),('15087','2013-02-27','10:45:00',3.34),('15087','2013-02-27','10:50:00',3.43),('15087','2013-02-27','10:55:00',3.43),('15087','2013-02-27','11:00:00',3.51),('15087','2013-02-27','11:05:00',3.51),('15087','2013-02-27','11:10:00',3.59),('15087','2013-02-27','11:15:00',3.63),('15087','2013-02-27','11:20:00',3.52),('15087','2013-02-27','11:25:00',2.23),('15087','2013-02-27','11:30:00',1.97),('15087','2013-02-27','11:35:00',2.8),('15087','2013-02-27','11:45:00',2.23),('15087','2013-02-27','11:50:00',1.96),('15087','2013-02-27','11:55:00',4.14),('15087','2013-02-27','12:00:00',3.91),('15087','2013-02-27','12:05:00',3.15),('15087','2013-02-27','12:15:00',3.61),('15087','2013-02-27','12:20:00',4.09),('15087','2013-02-27','12:25:00',3.86),('15087','2013-02-27','12:30:00',3.91),('15087','2013-02-27','12:35:00',3.95),('15087','2013-02-27','12:40:00',3.94),('15087','2013-02-27','12:45:00',3.94),('15087','2013-02-27','12:50:00',3.8),('15087','2013-02-27','12:55:00',3.77),('15087','2013-02-27','13:00:00',3.65),('15087','2013-02-27','13:05:00',3.77),('15087','2013-02-27','13:10:00',3.54),('15087','2013-02-27','13:15:00',3.54),('15087','2013-02-27','13:20:00',3.68),('15087','2013-02-27','13:25:00',3.59),('15087','2013-02-27','13:30:00',3.46),('15087','2013-02-27','13:35:00',3.55),('15087','2013-02-27','13:40:00',3.45),('15087','2013-02-27','13:45:00',3.31),('15087','2013-02-27','13:50:00',3.35),('15087','2013-02-27','13:55:00',3.24),('15087','2013-02-27','14:00:00',3.02),('15087','2013-02-27','14:05:00',2.62),('15087','2013-02-27','14:10:00',1.74),('15087','2013-02-27','14:15:00',2.64),('15087','2013-02-27','14:20:00',2.47),('15087','2013-02-27','14:25:00',1.62),('15087','2013-02-27','14:30:00',2.04),('15087','2013-02-27','14:35:00',2.5),('15087','2013-02-27','14:40:00',2.49),('15087','2013-02-27','14:45:00',2.54),('15087','2013-02-27','14:50:00',2.21),('15087','2013-02-27','14:55:00',2.19),('15087','2013-02-27','15:00:00',2.34),('15087','2013-02-27','15:05:00',2.39),('15087','2013-02-27','15:10:00',2.1),('15087','2013-02-27','15:15:00',2.04),('15087','2013-02-27','15:20:00',1.85),('15087','2013-02-27','15:25:00',1.78),('15087','2013-02-27','15:30:00',1.8),('15087','2013-02-27','15:35:00',1.75),('15087','2013-02-27','15:40:00',1.69),('15087','2013-02-27','15:45:00',1.58),('15087','2013-02-27','15:50:00',1.55),('15087','2013-02-27','15:55:00',1.45),('15087','2013-02-27','16:00:00',1.34),('15087','2013-02-27','16:05:00',1.25),('15087','2013-02-27','16:10:00',1.15),('15087','2013-02-27','16:15:00',1.07),('15087','2013-02-26','09:15:00',1.02),('15087','2013-02-26','09:20:00',1.09),('15087','2013-02-26','09:25:00',1.18),('15087','2013-02-26','09:30:00',1.4),('15087','2013-02-26','09:35:00',1.79),('15087','2013-02-26','09:40:00',1.99),('15087','2013-02-26','09:45:00',2),('15087','2013-02-26','09:50:00',2.06),('15087','2013-02-26','09:55:00',2.29),('15087','2013-02-26','10:00:00',2.2),('15087','2013-02-26','10:05:00',2.17),('15087','2013-02-26','10:10:00',2.48),('15087','2013-02-26','10:15:00',2.7),('15087','2013-02-26','10:20:00',3.29),('15087','2013-02-26','10:25:00',3.36),('15087','2013-02-26','10:30:00',3.24),('15087','2013-02-26','10:35:00',2.81),('15087','2013-02-26','10:40:00',2.15),('15087','2013-02-26','10:45:00',1.68),('15087','2013-02-26','10:50:00',1.95),('15087','2013-02-26','10:55:00',1.92),('15087','2013-02-26','11:00:00',2.29),('15087','2013-02-26','11:05:00',2.7),('15087','2013-02-26','11:10:00',2.58),('15087','2013-02-26','11:15:00',1.98),('15087','2013-02-26','11:20:00',1.95),('15087','2013-02-26','11:25:00',1.89),('15087','2013-02-26','11:30:00',1.73),('15087','2013-02-26','11:35:00',1.62),('15087','2013-02-26','11:40:00',1.66),('15087','2013-02-26','11:45:00',1.72),('15087','2013-02-26','11:50:00',1.86),('15087','2013-02-26','11:55:00',2.12),('15087','2013-02-26','12:00:00',1.77),('15087','2013-02-26','12:05:00',1.72),('15087','2013-02-26','12:10:00',1.77),('15087','2013-02-26','12:15:00',1.6),('15087','2013-02-26','12:20:00',1.62),('15087','2013-02-26','12:25:00',1.5),('15087','2013-02-26','12:30:00',1.47),('15087','2013-02-26','12:35:00',1.35),('15087','2013-02-26','12:40:00',1.23),('15087','2013-02-26','12:45:00',1.08),('15087','2013-02-26','12:55:00',1.08),('15087','2013-02-26','13:00:00',1.15),('15087','2013-02-26','13:25:00',1.01),('15087','2013-02-26','13:30:00',1.03),('15087','2013-02-26','13:35:00',1.05),('15087','2013-02-26','13:40:00',1.08),('15087','2013-02-26','13:45:00',1.01),('15087','2013-02-25','08:40:00',1.18),('15087','2013-02-25','08:45:00',1.14),('15087','2013-02-25','08:50:00',1.04),('15087','2013-02-25','09:00:00',1.19),('15087','2013-02-25','09:20:00',1.12),('15087','2013-02-25','09:25:00',1.52),('15087','2013-02-25','09:30:00',1.66),('15087','2013-02-25','09:35:00',1.57),('15087','2013-02-25','09:40:00',1.16),('15087','2013-02-25','10:45:00',1.93),('15087','2013-02-25','10:50:00',3.57),('15087','2013-02-25','10:55:00',4.82),('15087','2013-02-25','11:00:00',4.13),('15087','2013-02-25','11:05:00',2.24),('15087','2013-02-25','11:10:00',2.47),('15087','2013-02-25','11:15:00',2.32),('15087','2013-02-25','11:20:00',1.37),('15087','2013-02-25','11:25:00',1.41),('15087','2013-02-25','11:30:00',1.71),('15087','2013-02-25','11:35:00',1.52),('15087','2013-02-25','11:40:00',1.95),('15087','2013-02-25','11:45:00',2.08),('15087','2013-02-25','11:50:00',3.12),('15087','2013-02-25','11:55:00',5.12),('15087','2013-02-25','12:00:00',3.35),('15087','2013-02-25','12:05:00',2.62),('15087','2013-02-25','12:10:00',2.19),('15087','2013-02-25','12:15:00',2.31),('15087','2013-02-25','12:20:00',4.38),('15087','2013-02-25','12:25:00',4.65),('15087','2013-02-25','12:30:00',3.45),('15087','2013-02-25','12:35:00',3.14),('15087','2013-02-25','12:40:00',4.37),('15087','2013-02-25','12:45:00',3.4),('15087','2013-02-25','12:50:00',4),('15087','2013-02-25','12:55:00',3.72),('15087','2013-02-25','13:00:00',2.09),('15087','2013-02-25','13:05:00',2.56),('15087','2013-02-25','13:10:00',1.65),('15087','2013-02-25','13:15:00',2.64),('15087','2013-02-25','13:20:00',2.01),('15087','2013-02-25','13:25:00',1.74),('15087','2013-02-25','13:30:00',1.82),('15087','2013-02-25','13:35:00',1.75),('15087','2013-02-25','13:40:00',1.39),('15087','2013-02-25','13:45:00',1.09),('15087','2013-02-24','10:45:00',1.07),('15087','2013-02-24','10:50:00',1.63),('15087','2013-02-24','10:55:00',1.47),('15087','2013-02-24','11:00:00',1.13),('15087','2013-02-24','11:05:00',1.03),('15087','2013-02-24','11:30:00',1.03),('15087','2013-02-24','12:35:00',1.03),('15087','2013-02-24','12:40:00',1.21),('15087','2013-02-24','12:45:00',1.33),('15087','2013-02-24','12:50:00',1.06),('15087','2013-02-24','12:55:00',1.02),('15087','2013-02-24','13:00:00',1.33),('15087','2013-02-24','13:05:00',1.62),('15087','2013-02-24','13:10:00',1.64),('15087','2013-02-24','13:15:00',1.45),('15087','2013-02-24','13:20:00',1.66),('15087','2013-02-24','13:30:00',1.25),('15087','2013-02-24','13:35:00',1.47),('15087','2013-02-24','13:40:00',1.26),('15087','2013-02-24','13:45:00',1.38),('15087','2013-02-24','13:50:00',1.09),('15087','2013-02-24','13:55:00',1.03),('15087','2013-02-24','14:00:00',1.11),('15087','2013-02-24','14:05:00',2.04),('15087','2013-02-24','14:10:00',1.54),('15087','2013-02-24','14:15:00',1.16),('15087','2013-02-24','14:20:00',1.01),('15087','2013-02-24','14:30:00',1.25),('15087','2013-02-24','14:35:00',1.25),('15087','2013-02-24','15:10:00',2.39),('15087','2013-02-24','15:20:00',1.5),('15087','2013-02-24','15:25:00',1.46),('15087','2013-02-24','15:30:00',1.53),('15087','2013-02-24','15:35:00',1.41),('15087','2013-02-24','15:40:00',1.1),('15087','2013-02-24','15:45:00',1.51),('15087','2013-02-24','15:55:00',1.61),('15087','2013-02-24','16:00:00',1.54),('15087','2013-02-23','08:00:00',1.05),('15087','2013-02-23','08:05:00',1.2),('15087','2013-02-23','08:10:00',1.31),('15087','2013-02-23','08:15:00',1.79),('15087','2013-02-23','08:20:00',1),('15087','2013-02-23','08:55:00',1.11),('15087','2013-02-23','09:00:00',1.52),('15087','2013-02-23','09:05:00',1.39),('15087','2013-02-23','09:10:00',1.03),('15087','2013-02-23','09:40:00',1.06),('15087','2013-02-23','09:45:00',1.49),('15087','2013-02-23','09:50:00',1.51),('15087','2013-02-23','09:55:00',1.47),('15087','2013-02-23','10:00:00',1.12),('15087','2013-02-23','10:05:00',1.04),('15087','2013-02-23','10:25:00',1.14),('15087','2013-02-23','10:30:00',1.08),('15087','2013-02-23','10:50:00',1.02),('15087','2013-02-23','13:55:00',1.03),('15087','2013-02-23','14:00:00',1.08),('15087','2013-02-23','14:05:00',1.96),('15087','2013-02-23','14:10:00',1.4),('15087','2013-02-22','12:55:00',1.04),('15087','2013-02-22','14:35:00',1.51),('15087','2013-02-22','14:40:00',1.51),('15087','2013-02-22','14:45:00',1.07),('15087','2013-02-22','14:50:00',1.24),('15087','2013-02-22','14:55:00',1.35),('15087','2013-02-22','16:20:00',1.35),('15087','2013-02-22','16:25:00',1.35),('15087','2013-02-22','16:30:00',1.04),('15087','2013-02-21','11:35:00',1.04),('15087','2013-02-21','11:40:00',1.02),('15087','2013-02-21','11:45:00',1.1),('15087','2013-02-21','11:50:00',1.24),('15087','2013-02-21','11:55:00',1.29),('15087','2013-02-21','12:00:00',1.23),('15087','2013-02-21','12:05:00',1.28),('15087','2013-02-21','12:10:00',1.31),('15087','2013-02-21','12:15:00',1.41),('15087','2013-02-21','12:20:00',1.51),('15087','2013-02-21','12:25:00',1.45),('15087','2013-02-21','12:30:00',1.35),('15087','2013-02-21','12:35:00',1.29),('15087','2013-02-21','12:40:00',1.25),('15087','2013-02-21','12:45:00',1.25),('15087','2013-02-21','12:50:00',1.28),('15087','2013-02-21','12:55:00',1.39),('15087','2013-02-21','13:00:00',1.38),('15087','2013-02-21','13:05:00',1.26),('15087','2013-02-21','13:10:00',1.18),('15087','2013-02-21','13:15:00',1.24),('15087','2013-02-21','13:20:00',1.34),('15087','2013-02-21','13:25:00',1.38),('15087','2013-02-21','13:30:00',1.38),('15087','2013-02-21','13:35:00',1.39),('15087','2013-02-21','13:40:00',1.31),('15087','2013-02-21','13:45:00',1.23),('15087','2013-02-21','13:50:00',1.27),('15087','2013-02-21','13:55:00',1.26),('15087','2013-02-21','14:00:00',1.26),('15087','2013-02-21','14:05:00',1.19),('15087','2013-02-21','14:10:00',1.07),('15087','2013-02-21','16:05:00',1),('15087','2013-02-21','16:20:00',1.3),('15087','2013-02-21','16:25:00',1.36),('15087','2013-02-21','16:30:00',1.24),('15087','2013-02-21','16:35:00',1.04),('15087','2014-03-23','08:35:00',1.05),('15087','2014-03-23','08:50:00',1.26),('15087','2014-03-23','08:55:00',1.63),('15087','2014-03-23','09:00:00',1),('15087','2014-03-23','09:05:00',1.92),('15087','2014-03-23','09:10:00',2.89),('15087','2014-03-23','09:15:00',2.68),('15087','2014-03-23','09:20:00',1.88),('15087','2014-03-23','09:25:00',1.08),('15087','2014-03-23','09:30:00',1.53),('15087','2014-03-23','09:35:00',1.59),('15087','2014-03-23','09:40:00',1.39),('15087','2014-03-23','10:25:00',1.25),('15087','2014-03-23','10:40:00',1.29),('15087','2014-03-23','10:45:00',1.17),('15087','2014-03-23','10:50:00',1.34),('15087','2014-03-23','10:55:00',1.83),('15087','2014-03-23','11:00:00',1.31),('15087','2014-03-23','11:05:00',1.07),('15087','2014-03-23','11:10:00',1.41),('15087','2014-03-23','11:25:00',1.05),('15087','2014-03-23','11:35:00',1.79),('15087','2014-03-23','11:40:00',3.7),('15087','2014-03-23','13:40:00',1.09),('15087','2014-03-23','13:45:00',2.39),('15087','2014-03-23','13:50:00',1.72),('15087','2014-03-23','13:55:00',1.34),('15087','2014-03-23','15:05:00',1.06),('15087','2014-03-23','15:10:00',1.37),('15087','2014-03-23','15:15:00',1.76),('15087','2014-03-23','15:20:00',1.73),('15087','2014-03-23','15:25:00',1.78),('15087','2014-03-23','15:30:00',1.26),('15087','2013-02-20','08:20:00',1.09),('15087','2013-02-20','08:25:00',1.33),('15087','2013-02-20','08:30:00',1.4),('15087','2013-02-20','08:35:00',1.51),('15087','2013-02-20','08:40:00',1.61),('15087','2013-02-20','08:45:00',1.71),('15087','2013-02-20','08:50:00',1.8),('15087','2013-02-20','08:55:00',1.82),('15087','2013-02-20','09:00:00',1.85),('15087','2013-02-20','09:05:00',1.15),('15087','2013-02-20','09:10:00',1.59),('15087','2013-02-20','09:15:00',1.87),('15087','2013-02-20','09:20:00',1.97),('15087','2013-02-20','09:25:00',2.47),('15087','2013-02-20','09:30:00',1.76),('15087','2013-02-20','09:35:00',2.01),('15087','2013-02-20','09:40:00',1.06),('15087','2013-02-20','09:45:00',1.31),('15087','2013-02-20','09:50:00',2.05),('15087','2013-02-20','09:55:00',1.92),('15087','2013-02-20','10:00:00',1.7),('15087','2013-02-20','10:05:00',2.49),('15087','2013-02-20','10:10:00',1.7),('15087','2013-02-20','10:45:00',2.76),('15087','2013-02-20','10:50:00',2.62),('15087','2013-02-20','10:55:00',1.27),('15087','2013-02-20','11:05:00',2.8),('15087','2013-02-20','11:10:00',4.2),('15087','2013-02-20','11:15:00',3.41),('15087','2013-02-20','11:20:00',3.28),('15087','2013-02-20','11:25:00',1.91),('15087','2013-02-20','11:30:00',1.32),('15087','2013-02-20','11:35:00',3.99),('15087','2013-02-20','11:40:00',3.99),('15087','2013-02-20','11:45:00',4.49),('15087','2013-02-20','11:50:00',3.95),('15087','2013-02-20','11:55:00',4.03),('15087','2013-02-20','12:00:00',1.43),('15087','2013-02-20','12:05:00',1.09),('15087','2013-02-20','12:10:00',2.63),('15087','2013-02-20','12:15:00',3.88),('15087','2013-02-20','12:20:00',2.06),('15087','2013-02-20','12:25:00',4.74),('15087','2013-02-20','12:30:00',4.68),('15087','2013-02-20','12:35:00',1.91),('15087','2013-02-20','12:45:00',1.08),('15087','2013-02-20','12:50:00',1.27),('15087','2013-02-20','12:55:00',2.34),('15087','2013-02-20','13:00:00',3.2),('15087','2013-02-20','13:05:00',2.91),('15087','2013-02-20','13:10:00',3.94),('15087','2013-02-20','13:15:00',3.78),('15087','2013-02-20','13:20:00',2.19),('15087','2013-02-20','13:25:00',1.45),('15087','2013-02-20','13:30:00',2.08),('15087','2013-02-20','13:35:00',1.54),('15087','2013-02-20','13:40:00',1.88),('15087','2013-02-20','13:45:00',1.44),('15087','2013-02-20','13:50:00',1.23),('15087','2013-02-20','13:55:00',1.98),('15087','2013-02-20','14:00:00',1.37),('15087','2013-02-20','14:35:00',1.04),('15087','2013-02-20','14:40:00',1.5),('15087','2013-02-20','14:45:00',1.25),('15087','2013-02-20','15:05:00',1.45),('15087','2013-02-20','15:10:00',2.24),('15087','2013-02-20','15:15:00',2.57),('15087','2013-02-20','15:20:00',2.23),('15087','2013-02-20','15:25:00',2.21),('15087','2013-02-20','15:30:00',1.75),('15087','2013-02-20','16:05:00',1.49),('15087','2013-02-20','16:10:00',1.58),('15087','2013-02-20','16:15:00',1.48),('15087','2013-02-20','16:20:00',1.24),('15087','2013-02-20','16:25:00',1.01),('15087','2013-02-19','08:15:00',1.08),('15087','2013-02-19','08:20:00',1.06),('15087','2013-02-19','08:25:00',1.29),('15087','2013-02-19','08:30:00',1.4),('15087','2013-02-19','08:35:00',1.48),('15087','2013-02-19','08:40:00',1.58),('15087','2013-02-19','08:45:00',1.67),('15087','2013-02-19','08:50:00',1.77),('15087','2013-02-19','08:55:00',1.84),('15087','2013-02-19','09:00:00',1.91),('15087','2013-02-19','09:05:00',2),('15087','2013-02-19','09:10:00',2.09),('15087','2013-02-19','09:15:00',2.18),('15087','2013-02-19','09:20:00',2.27),('15087','2013-02-19','09:25:00',2.36),('15087','2013-02-19','09:30:00',2.43),('15087','2013-02-19','09:35:00',2.49),('15087','2013-02-19','09:40:00',2.55),('15087','2013-02-19','09:45:00',2.64),('15087','2013-02-19','09:50:00',2.7),('15087','2013-02-19','09:55:00',2.77),('15087','2013-02-19','10:00:00',2.84),('15087','2013-02-19','10:05:00',2.89),('15087','2013-02-19','10:10:00',2.96),('15087','2013-02-19','10:15:00',3.03),('15087','2013-02-19','10:20:00',3.08),('15087','2013-02-19','10:25:00',3.12),('15087','2013-02-19','10:30:00',3.17),('15087','2013-02-19','10:35:00',3.24),('15087','2013-02-19','10:40:00',3.27),('15087','2013-02-19','10:45:00',3.29),('15087','2013-02-19','10:50:00',3.34),('15087','2013-02-19','10:55:00',3.38),('15087','2013-02-19','11:00:00',3.44),('15087','2013-02-19','11:05:00',3.46),('15087','2013-02-19','11:10:00',3.52),('15087','2013-02-19','11:15:00',3.57),('15087','2013-02-19','11:20:00',3.56),('15087','2013-02-19','11:25:00',3.58),('15087','2013-02-19','11:30:00',3.61),('15087','2013-02-19','11:35:00',3.65),('15087','2013-02-19','11:40:00',3.66),('15087','2013-02-19','11:45:00',3.66),('15087','2013-02-19','11:50:00',3.7),('15087','2013-02-19','11:55:00',3.66),('15087','2013-02-19','12:00:00',3.64),('15087','2013-02-19','12:05:00',3.68),('15087','2013-02-19','12:10:00',3.67),('15087','2013-02-19','12:15:00',3.67),('15087','2013-02-19','12:20:00',3.68),('15087','2013-02-19','12:25:00',3.64),('15087','2013-02-19','12:30:00',3.63),('15087','2013-02-19','12:35:00',3.7),('15087','2013-02-19','12:40:00',3.64),('15087','2013-02-19','12:45:00',3.69),('15087','2013-02-19','12:50:00',3.65),('15087','2013-02-19','12:55:00',3.58),('15087','2013-02-19','13:00:00',3.62),('15087','2013-02-19','13:05:00',3.56),('15087','2013-02-19','13:10:00',3.47),('15087','2013-02-19','13:15:00',3.51),('15087','2013-02-19','13:20:00',3.46),('15087','2013-02-19','13:25:00',3.33),('15087','2013-02-19','13:30:00',3.32),('15087','2013-02-19','13:35:00',3.28),('15087','2013-02-19','13:40:00',3.18),('15087','2013-02-19','13:45:00',3.13),('15087','2013-02-19','13:50:00',3.04),('15087','2013-02-19','13:55:00',2.93),('15087','2013-02-19','14:00:00',2.88),('15087','2013-02-19','14:05:00',2.84),('15087','2013-02-19','14:10:00',2.77),('15087','2013-02-19','14:15:00',2.7),('15087','2013-02-19','14:20:00',2.57),('15087','2013-02-19','14:25:00',2.53),('15087','2013-02-19','14:30:00',2.49),('15087','2013-02-19','14:35:00',2.4),('15087','2013-02-19','14:40:00',2.34),('15087','2013-02-19','14:45:00',2.29),('15087','2013-02-19','14:50:00',2.05),('15087','2013-02-19','14:55:00',2.1),('15087','2013-02-19','15:00:00',2.12),('15087','2013-02-19','15:05:00',2.01),('15087','2013-02-19','15:10:00',1.99),('15087','2013-02-19','15:15:00',1.92),('15087','2013-02-19','15:20:00',1.84),('15087','2013-02-19','15:25:00',1.86),('15087','2013-02-19','15:30:00',1.7),('15087','2013-02-19','15:35:00',1.62),('15087','2013-02-19','15:40:00',1.55),('15087','2013-02-19','15:45:00',1.43),('15087','2013-02-19','15:50:00',1.34),('15087','2013-02-19','15:55:00',1.25),('15087','2013-02-19','16:00:00',1.17),('15087','2013-02-19','16:05:00',1.09),('15087','2013-02-19','16:10:00',1),('15087','2013-02-18','08:15:00',1),('15087','2013-02-18','08:20:00',1.11),('15087','2013-02-18','08:25:00',1.06),('15087','2013-02-18','08:30:00',1.31),('15087','2013-02-18','08:35:00',1.41),('15087','2013-02-18','08:40:00',1.48),('15087','2013-02-18','08:45:00',1.56),('15087','2013-02-18','08:50:00',1.66),('15087','2013-02-18','08:55:00',1.74),('15087','2013-02-18','09:00:00',1.83),('15087','2013-02-18','09:05:00',1.92),('15087','2013-02-18','09:10:00',2),('15087','2013-02-18','09:15:00',2.12),('15087','2013-02-18','09:20:00',2.21),('15087','2013-02-18','09:25:00',2.58),('15087','2013-02-18','09:30:00',1.56),('15087','2013-02-18','09:35:00',1.28),('15087','2013-02-18','09:45:00',1.15),('15087','2013-02-18','09:50:00',1.44),('15087','2013-02-18','09:55:00',1.06),('15087','2013-02-18','10:05:00',1.09),('15087','2013-02-18','10:55:00',1.03),('15087','2013-02-18','11:00:00',1.29),('15087','2013-02-18','11:05:00',1.34),('15087','2013-02-18','11:10:00',1.46),('15087','2013-02-18','11:15:00',1.27),('15087','2013-02-18','11:20:00',1.62),('15087','2013-02-18','11:25:00',1.62),('15087','2013-02-18','11:30:00',1.53),('15087','2013-02-18','11:35:00',1.62),('15087','2013-02-18','11:40:00',1.57),('15087','2013-02-18','11:45:00',1.44),('15087','2013-02-18','11:50:00',1.57),('15087','2013-02-18','11:55:00',2),('15087','2013-02-18','12:00:00',2.05),('15087','2013-02-18','12:05:00',1.76),('15087','2013-02-18','12:10:00',1.61),('15087','2013-02-18','12:15:00',1.56),('15087','2013-02-18','12:20:00',1.53),('15087','2013-02-18','12:25:00',1.58),('15087','2013-02-18','12:30:00',1.44),('15087','2013-02-18','12:35:00',1.35),('15087','2013-02-18','12:40:00',1.42),('15087','2013-02-18','12:45:00',1.71),('15087','2013-02-18','12:50:00',1.69),('15087','2013-02-18','12:55:00',1.56),('15087','2013-02-18','13:00:00',1.57),('15087','2013-02-18','13:05:00',1.6),('15087','2013-02-18','13:10:00',1.55),('15087','2013-02-18','13:15:00',1.93),('15087','2013-02-18','13:20:00',1.56),('15087','2013-02-18','13:25:00',1.84),('15087','2013-02-18','13:30:00',1.62),('15087','2013-02-18','13:35:00',1.39),('15087','2013-02-18','13:40:00',1.37),('15087','2013-02-18','13:45:00',1.24),('15087','2013-02-18','13:50:00',1.27),('15087','2013-02-18','13:55:00',1.57),('15087','2013-02-18','14:00:00',1.59),('15087','2013-02-18','14:05:00',1.47),('15087','2013-02-18','14:10:00',1.23),('15087','2013-02-18','14:15:00',1.05),('15087','2013-02-18','14:20:00',1.12),('15087','2013-02-17','08:25:00',1.08),('15087','2013-02-17','08:30:00',1.27),('15087','2013-02-17','08:35:00',1.43),('15087','2013-02-17','08:40:00',1.55),('15087','2013-02-17','08:45:00',1.56),('15087','2013-02-17','08:50:00',1.32),('15087','2013-02-17','08:55:00',1.66),('15087','2013-02-17','09:00:00',1.76),('15087','2013-02-17','09:05:00',1.71),('15087','2013-02-17','09:10:00',1.88),('15087','2013-02-17','09:15:00',2.03),('15087','2013-02-17','09:20:00',2.11),('15087','2013-02-17','09:25:00',2.18),('15087','2013-02-17','09:30:00',2.23),('15087','2013-02-17','09:35:00',2.3),('15087','2013-02-17','09:40:00',2.39),('15087','2013-02-17','09:45:00',2.46),('15087','2013-02-17','09:50:00',2.54),('15087','2013-02-17','09:55:00',2.61),('15087','2013-02-17','10:00:00',2.66),('15087','2013-02-17','10:05:00',2.72),('15087','2013-02-17','10:10:00',2.81),('15087','2013-02-17','10:15:00',2.87),('15087','2013-02-17','10:20:00',2.89),('15087','2013-02-17','10:25:00',2.94),('15087','2013-02-17','10:30:00',3.02),('15087','2013-02-17','10:35:00',3.09),('15087','2013-02-17','10:40:00',3.1),('15087','2013-02-17','10:45:00',3.17),('15087','2013-02-17','10:50:00',3.19),('15087','2013-02-17','10:55:00',3.24),('15087','2013-02-17','11:00:00',3.27),('15087','2013-02-17','11:05:00',3.28),('15087','2013-02-17','11:10:00',3.34),('15087','2013-02-17','11:15:00',3.39),('15087','2013-02-17','11:20:00',3.44),('15087','2013-02-17','11:25:00',3.45),('15087','2013-02-17','11:30:00',3.46),('15087','2013-02-17','11:35:00',3.47),('15087','2013-02-17','11:40:00',3.48),('15087','2013-02-17','11:45:00',3.51),('15087','2013-02-17','11:50:00',3.56),('15087','2013-02-17','11:55:00',3.58),('15087','2013-02-17','12:00:00',3.58),('15087','2013-02-17','12:05:00',3.58),('15087','2013-02-17','12:10:00',3.6),('15087','2013-02-17','12:15:00',3.59),('15087','2013-02-17','12:20:00',3.58),('15087','2013-02-17','12:25:00',3.57),('15087','2013-02-17','12:30:00',3.57),('15087','2013-02-17','12:35:00',3.53),('15087','2013-02-17','12:40:00',3.48),('15087','2013-02-17','12:45:00',3.48),('15087','2013-02-17','12:50:00',3.49),('15087','2013-02-17','12:55:00',3.22),('15087','2013-02-17','13:00:00',3.43),('15087','2013-02-17','13:05:00',3.34),('15087','2013-02-17','13:10:00',3.05),('15087','2013-02-17','13:15:00',3.22),('15087','2013-02-17','13:20:00',1.1),('15087','2013-02-17','13:25:00',1.04),('15087','2013-02-17','13:30:00',2.35),('15087','2013-02-17','13:35:00',2.45),('15087','2013-02-17','13:40:00',2.57),('15087','2013-02-17','13:45:00',2.56),('15087','2013-02-17','13:50:00',1.8),('15087','2013-02-17','13:55:00',1.82),('15087','2013-02-17','14:05:00',1.67),('15087','2013-02-17','14:10:00',2.57),('15087','2013-02-17','14:15:00',1.26),('15087','2013-02-17','14:20:00',1.09),('15087','2013-02-17','14:25:00',1.95),('15087','2013-02-17','14:30:00',2.53),('15087','2013-02-17','14:35:00',2.4),('15087','2013-02-17','14:40:00',1.82),('15087','2013-02-17','15:00:00',1.82),('15087','2013-02-17','15:05:00',1.85),('15087','2013-02-17','15:10:00',2.19),('15087','2013-02-17','15:15:00',2.26),('15087','2013-02-17','15:20:00',2.2),('15087','2013-02-17','15:25:00',1.97),('15087','2013-02-17','15:30:00',1.88),('15087','2013-02-17','15:35:00',1.87),('15087','2013-02-17','15:40:00',1.75),('15087','2013-02-17','15:45:00',1.56),('15087','2013-02-17','15:50:00',1.5),('15087','2013-02-17','15:55:00',1.38),('15087','2013-02-17','16:00:00',1.29),('15087','2013-02-17','16:05:00',1.15),('15087','2013-02-17','16:25:00',1.15),('15087','2013-02-17','16:30:00',1.09),('15087','2013-02-16','08:30:00',1.07),('15087','2013-02-16','08:35:00',1.17),('15087','2013-02-16','08:40:00',1.26),('15087','2013-02-16','08:45:00',1.28),('15087','2013-02-16','09:05:00',1.44),('15087','2013-02-16','09:15:00',1.91),('15087','2013-02-16','09:20:00',2.14),('15087','2013-02-16','09:25:00',2.18),('15087','2013-02-16','09:30:00',2.23),('15087','2013-02-16','09:35:00',2.3),('15087','2013-02-16','09:40:00',2.34),('15087','2013-02-16','09:45:00',2.43),('15087','2013-02-16','09:50:00',2.54),('15087','2013-02-16','09:55:00',2.61),('15087','2013-02-16','10:00:00',2.68),('15087','2013-02-16','10:05:00',2.74),('15087','2013-02-16','10:10:00',2.85),('15087','2013-02-16','10:15:00',2.89),('15087','2013-02-16','10:20:00',2.96),('15087','2013-02-16','10:25:00',3),('15087','2013-02-16','10:30:00',3.05),('15087','2013-02-16','10:35:00',3.04),('15087','2013-02-16','10:41:00',2.87),('15087','2013-02-16','10:45:00',3.37),('15087','2013-02-16','10:50:00',3.27),('15087','2013-02-16','10:55:00',3.12),('15087','2013-02-16','11:00:00',3.42),('15087','2013-02-16','11:05:00',3.44),('15087','2013-02-16','11:10:00',3.38),('15087','2013-02-16','11:15:00',3.44),('15087','2013-02-16','11:20:00',3.37),('15087','2013-02-16','11:25:00',3.42),('15087','2013-02-16','11:30:00',3.56),('15087','2013-02-16','11:35:00',3.58),('15087','2013-02-16','11:40:00',3.6),('15087','2013-02-16','11:45:00',3.61),('15087','2013-02-16','11:50:00',3.66),('15087','2013-02-16','11:55:00',3.69),('15087','2013-02-16','12:00:00',3.67),('15087','2013-02-16','12:05:00',3.69),('15087','2013-02-16','12:10:00',3.66),('15087','2013-02-16','12:15:00',3.66),('15087','2013-02-16','12:20:00',3.64),('15087','2013-02-16','12:25:00',3.65),('15087','2013-02-16','12:30:00',3.66),('15087','2013-02-16','12:35:00',3.66),('15087','2013-02-16','12:40:00',3.64),('15087','2013-02-16','12:45:00',3.66),('15087','2013-02-16','12:50:00',3.65),('15087','2013-02-16','12:55:00',3.57),('15087','2013-02-16','13:00:00',3.56),('15087','2013-02-16','13:05:00',3.51),('15087','2013-02-16','13:10:00',3.42),('15087','2013-02-16','13:15:00',3.45),('15087','2013-02-16','13:20:00',3.33),('15087','2013-02-16','13:25:00',3.32),('15087','2013-02-16','13:30:00',3.26),('15087','2013-02-16','13:35:00',3.25),('15087','2013-02-16','13:40:00',3.1),('15087','2013-02-16','13:45:00',3.13),('15087','2013-02-16','13:50:00',3.11),('15087','2013-02-16','13:55:00',2.91),('15087','2013-02-16','14:00:00',2.89),('15087','2013-02-16','14:05:00',2.81),('15087','2013-02-16','14:10:00',2.57),('15087','2013-02-16','14:15:00',2.65),('15087','2013-02-16','14:20:00',2.2),('15087','2013-02-16','14:25:00',1.66),('15087','2013-02-16','14:45:00',1.06),('15087','2013-02-16','14:50:00',1.07),('15087','2013-02-16','14:55:00',1.14),('15087','2013-02-16','15:20:00',1.08),('15087','2013-02-16','15:25:00',1.25),('15087','2013-02-16','15:30:00',1.99),('15087','2013-02-16','15:35:00',2.03),('15087','2013-02-16','15:40:00',1.9),('15087','2013-02-16','15:45:00',1.3),('15087','2013-02-16','15:50:00',1.62),('15087','2013-02-16','15:55:00',1.44),('15087','2013-02-16','16:05:00',1.07),('15087','2013-02-15','09:20:00',1.5),('15087','2013-02-15','09:25:00',1.61),('15087','2013-02-15','09:30:00',1.09),('15087','2013-02-15','09:35:00',1.06),('15087','2013-02-15','09:40:00',1.01),('15087','2013-02-15','09:50:00',1.34),('15087','2013-02-15','09:55:00',1.53),('15087','2013-02-15','10:00:00',1.91),('15087','2013-02-15','10:05:00',1.77),('15087','2013-02-15','10:10:00',1.17),('15087','2013-02-15','10:15:00',1.3),('15087','2013-02-15','10:20:00',1.72),('15087','2013-02-15','10:25:00',2.21),('15087','2013-02-15','10:30:00',2.13),('15087','2013-02-15','10:35:00',2.97),('15087','2013-02-15','10:40:00',2.9),('15087','2013-02-15','10:45:00',2.91),('15087','2013-02-15','10:50:00',2.55),('15087','2013-02-15','10:55:00',1.84),('15087','2013-02-15','11:00:00',1.9),('15087','2013-02-15','11:05:00',2.18),('15087','2013-02-15','11:10:00',2.09),('15087','2013-02-15','11:15:00',3.05),('15087','2013-02-15','11:20:00',3.31),('15087','2013-02-15','11:25:00',3.5),('15087','2013-02-15','11:30:00',3.43),('15087','2013-02-15','11:35:00',2.35),('15087','2013-02-15','11:40:00',2.07),('15087','2013-02-15','11:45:00',2.77),('15087','2013-02-15','11:50:00',4.01),('15087','2013-02-15','11:55:00',3.29),('15087','2013-02-15','12:00:00',3.14),('15087','2013-02-15','12:05:00',3.07),('15087','2013-02-15','12:10:00',3.18),('15087','2013-02-15','12:15:00',3.64),('15087','2013-02-15','12:20:00',4.03),('15087','2013-02-15','12:25:00',3.66),('15087','2013-02-15','12:30:00',3.74),('15087','2013-02-15','12:35:00',3.68),('15087','2013-02-15','12:40:00',3.63),('15087','2013-02-15','12:45:00',3.66),('15087','2013-02-15','12:50:00',3.61),('15087','2013-02-15','12:55:00',3.58),('15087','2013-02-15','13:00:00',3.53),('15087','2013-02-15','13:05:00',3.47),('15087','2013-02-15','13:10:00',3.31),('15087','2013-02-15','13:15:00',3.42),('15087','2013-02-15','13:20:00',3.15),('15087','2013-02-15','13:25:00',2.85),('15087','2013-02-15','13:30:00',2.16),('15087','2013-02-15','13:35:00',2.33),('15087','2013-02-15','13:40:00',2.95),('15087','2013-02-15','13:45:00',2.46),('15087','2013-02-15','13:50:00',2.34),('15087','2013-02-15','13:55:00',2.43),('15087','2013-02-15','14:00:00',2.04),('15087','2013-02-15','14:05:00',3.11),('15087','2013-02-15','14:10:00',3.04),('15087','2013-02-15','14:15:00',2.13),('15087','2013-02-15','14:20:00',2.17),('15087','2013-02-15','14:25:00',1.6),('15087','2013-02-15','14:30:00',1.49),('15087','2013-02-15','14:35:00',2.32),('15087','2013-02-15','14:40:00',2.51),('15087','2013-02-15','14:45:00',1.87),('15087','2013-02-15','14:50:00',1.21),('15087','2013-02-15','14:55:00',1.13),('15087','2013-02-15','15:00:00',1.71),('15087','2013-02-15','15:05:00',1.15),('15087','2013-02-15','15:10:00',1.28),('15087','2013-02-15','15:15:00',1.46),('15087','2013-02-15','15:20:00',1.19),('15087','2013-02-15','15:25:00',1.4),('15087','2013-02-15','15:30:00',1.5),('15087','2013-02-15','15:35:00',1.26),('15087','2013-02-15','15:40:00',1.27),('15087','2013-02-15','15:45:00',1.13),('15087','2013-02-14','08:30:00',1.11),('15087','2013-02-14','08:35:00',1.22),('15087','2013-02-14','08:40:00',1.31),('15087','2013-02-14','08:45:00',1.41),('15087','2013-02-14','08:50:00',1.52),('15087','2013-02-14','08:55:00',1.62),('15087','2013-02-14','09:00:00',1.71),('15087','2013-02-14','09:05:00',1.79),('15087','2013-02-14','09:10:00',1.87),('15087','2013-02-14','09:15:00',1.97),('15087','2013-02-14','09:20:00',2.09),('15087','2013-02-14','09:25:00',2.19),('15087','2013-02-14','09:30:00',2.26),('15087','2013-02-14','09:35:00',2.35),('15087','2013-02-14','09:40:00',2.42),('15087','2013-02-14','09:45:00',2.49),('15087','2013-02-14','09:50:00',2.6),('15087','2013-02-14','09:55:00',2.67),('15087','2013-02-14','10:00:00',2.72),('15087','2013-02-14','10:05:00',2.81),('15087','2013-02-14','10:10:00',2.87),('15087','2013-02-14','10:15:00',2.96),('15087','2013-02-14','10:20:00',3.03),('15087','2013-02-14','10:25:00',3.08),('15087','2013-02-14','10:30:00',3.13),('15087','2013-02-14','10:35:00',3.22),('15087','2013-02-14','10:40:00',3.29),('15087','2013-02-14','10:45:00',3.33),('15087','2013-02-14','10:50:00',3.38),('15087','2013-02-14','10:55:00',3.42),('15087','2013-02-14','11:00:00',3.47),('15087','2013-02-14','11:05:00',3.49),('15087','2013-02-14','11:10:00',3.53),('15087','2013-02-14','11:15:00',3.55),('15087','2013-02-14','11:20:00',3.58),('15087','2013-02-14','11:25:00',3.6),('15087','2013-02-14','11:30:00',3.64),('15087','2013-02-14','11:35:00',3.66),('15087','2013-02-14','11:40:00',3.67),('15087','2013-02-14','11:45:00',3.68),('15087','2013-02-14','11:50:00',3.7),('15087','2013-02-14','11:55:00',3.71),('15087','2013-02-14','12:00:00',3.73),('15087','2013-02-14','12:05:00',3.75),('15087','2013-02-14','12:10:00',3.74),('15087','2013-02-14','12:15:00',3.74),('15087','2013-02-14','12:20:00',3.71),('15087','2013-02-14','12:25:00',3.74),('15087','2013-02-14','12:30:00',3.73),('15087','2013-02-14','12:35:00',3.73),('15087','2013-02-14','12:40:00',3.73),('15087','2013-02-14','12:45:00',3.7),('15087','2013-02-14','12:50:00',3.63),('15087','2013-02-14','12:55:00',3.31),('15087','2013-02-14','13:00:00',3.32),('15087','2013-02-14','13:05:00',3.51),('15087','2013-02-14','13:10:00',3.5),('15087','2013-02-14','13:15:00',3.49),('15087','2013-02-14','13:20:00',3.37),('15087','2013-02-14','13:25:00',3.36),('15087','2013-02-14','13:30:00',3.32),('15087','2013-02-14','13:35:00',3.25),('15087','2013-02-14','13:40:00',3.09),('15087','2013-02-14','13:45:00',3.07),('15087','2013-02-14','13:50:00',3.05),('15087','2013-02-14','13:55:00',2.97),('15087','2013-02-14','14:00:00',2.9),('15087','2013-02-14','14:05:00',2.84),('15087','2013-02-14','14:10:00',2.82),('15087','2013-02-14','14:15:00',2.77),('15087','2013-02-14','14:20:00',2.72),('15087','2013-02-14','14:25:00',2.64),('15087','2013-02-14','14:30:00',2.51),('15087','2013-02-14','14:35:00',2.43),('15087','2013-02-14','14:40:00',2.33),('15087','2013-02-14','14:45:00',2.08),('15087','2013-02-14','14:50:00',2.23),('15087','2013-02-14','14:55:00',2.01),('15087','2013-02-14','15:00:00',1.94),('15087','2013-02-14','15:05:00',1.93),('15087','2013-02-14','15:10:00',1.93),('15087','2013-02-14','15:15:00',1.85),('15087','2013-02-14','15:20:00',1.78),('15087','2013-02-14','15:25:00',1.7),('15087','2013-02-14','15:30:00',1.65),('15087','2013-02-14','15:35:00',1.49),('15087','2013-02-14','15:40:00',1.4),('15087','2013-02-14','15:45:00',1.38),('15087','2013-02-14','15:50:00',1.28),('15087','2013-02-14','15:55:00',1.15),('15087','2013-02-13','09:00:00',1.08),('15087','2013-02-13','09:05:00',1.17),('15087','2013-02-13','09:10:00',1.2),('15087','2013-02-13','09:15:00',1.22),('15087','2013-02-13','09:20:00',1.2),('15087','2013-02-13','09:25:00',1.51),('15087','2013-02-13','09:30:00',1.59),('15087','2013-02-13','09:35:00',2.05),('15087','2013-02-13','09:40:00',2.16),('15087','2013-02-13','09:45:00',2.38),('15087','2013-02-13','09:50:00',2.46),('15087','2013-02-13','09:55:00',2.36),('15087','2013-02-13','10:00:00',2.41),('15087','2013-02-13','10:05:00',2.56),('15087','2013-02-13','10:10:00',2.75),('15087','2013-02-13','10:15:00',2.89),('15087','2013-02-13','10:20:00',3.03),('15087','2013-02-13','10:25:00',3.09),('15087','2013-02-13','10:30:00',3.26),('15087','2013-02-13','10:35:00',3.35),('15087','2013-02-13','10:40:00',3.28),('15087','2013-02-13','10:45:00',3.44),('15087','2013-02-13','10:50:00',3.55),('15087','2013-02-13','10:55:00',3.53),('15087','2013-02-13','11:00:00',3.44),('15087','2013-02-13','11:05:00',3.59),('15087','2013-02-13','11:10:00',3.43),('15087','2013-02-13','11:15:00',3.34),('15087','2013-02-13','11:20:00',3.12),('15087','2013-02-13','11:25:00',3.05),('15087','2013-02-13','11:30:00',3.13),('15087','2013-02-13','11:35:00',1.77),('15087','2013-02-13','11:40:00',1.42),('15087','2013-02-13','11:45:00',1.61),('15087','2013-02-13','11:50:00',2.15),('15087','2013-02-13','11:55:00',1.36),('15087','2013-02-13','12:00:00',1.16),('15087','2013-02-13','12:05:00',1.6),('15087','2013-02-13','12:10:00',2.85),('15087','2013-02-13','12:15:00',2.51),('15087','2013-02-13','12:20:00',3.02),('15087','2013-02-13','12:25:00',1.97),('15087','2013-02-13','12:30:00',1.16),('15087','2013-02-13','12:35:00',1.64),('15087','2013-02-13','12:40:00',1.19),('15087','2013-02-13','12:45:00',2.58),('15087','2013-02-13','12:50:00',2.83),('15087','2013-02-13','12:55:00',2.43),('15087','2013-02-13','13:00:00',2.77),('15087','2013-02-13','13:05:00',1.8),('15087','2013-02-13','13:10:00',2.56),('15087','2013-02-13','13:15:00',2.61),('15087','2013-02-13','13:20:00',3.32),('15087','2013-02-13','13:25:00',3.27),('15087','2013-02-13','13:30:00',3.37),('15087','2013-02-13','13:35:00',3.48),('15087','2013-02-13','13:40:00',3.08),('15087','2013-02-13','13:45:00',2.71),('15087','2013-02-13','13:50:00',2.54),('15087','2013-02-13','13:55:00',2.48),('15087','2013-02-13','14:00:00',2.68),('15087','2013-02-13','14:05:00',2.9),('15087','2013-02-13','14:10:00',2.65),('15087','2013-02-13','14:15:00',2.53),('15087','2013-02-13','14:20:00',2.59),('15087','2013-02-13','14:25:00',2.29),('15087','2013-02-13','14:30:00',2.46),('15087','2013-02-13','14:35:00',2.47),('15087','2013-02-13','14:40:00',2.42),('15087','2013-02-13','14:45:00',2.15),('15087','2013-02-13','14:50:00',2.23),('15087','2013-02-13','14:55:00',2.03),('15087','2013-02-13','15:00:00',2.03),('15087','2013-02-13','15:05:00',1.96),('15087','2013-02-13','15:10:00',1.8),('15087','2013-02-13','15:15:00',1.84),('15087','2013-02-13','15:20:00',1.78),('15087','2013-02-13','15:25:00',1.67),('15087','2013-02-13','15:30:00',1.59),('15087','2013-02-13','15:35:00',1.45),('15087','2013-02-13','15:40:00',1.39),('15087','2013-02-13','15:45:00',1.31),('15087','2013-02-13','15:50:00',1.21),('15087','2013-02-13','15:55:00',1.14),('15087','2013-02-13','16:00:00',1.08),('15087','2013-02-13','16:05:00',1),('15087','2013-02-11','10:20:00',1.09),('15087','2013-02-11','10:25:00',1.14),('15087','2013-02-11','10:30:00',1.15),('15087','2013-02-11','10:35:00',1.38),('15087','2013-02-11','10:40:00',1.19),('15087','2013-02-11','11:00:00',1.05),('15087','2013-02-11','11:05:00',1.24),('15087','2013-02-11','11:10:00',1.53),('15087','2013-02-11','11:15:00',1.61),('15087','2013-02-11','11:20:00',1.21),('15087','2013-02-11','11:45:00',1.32),('15087','2013-02-11','12:45:00',1.4),('15087','2013-02-11','14:00:00',1.04),('15087','2013-02-11','14:05:00',1.13),('15087','2013-02-11','14:10:00',1.27),('15087','2013-02-11','14:15:00',1.04),('15087','2013-02-11','14:20:00',1.08),('15087','2013-02-11','14:25:00',1.7),('15087','2013-02-11','14:30:00',2.14),('15087','2013-02-11','14:35:00',1.26),('15087','2013-02-11','14:40:00',1.79),('15087','2013-02-11','14:45:00',1.44),('15087','2014-03-22','07:40:00',1.24),('15087','2014-03-22','07:45:00',1.32),('15087','2014-03-22','07:50:00',1.15),('15087','2014-03-22','08:10:00',1.26),('15087','2014-03-22','08:15:00',1.52),('15087','2014-03-22','08:20:00',1.81),('15087','2014-03-22','08:25:00',1.81),('15087','2014-03-22','08:30:00',1.68),('15087','2014-03-22','08:35:00',1.03),('15087','2014-03-22','08:40:00',2.33),('15087','2014-03-22','08:45:00',2.27),('15087','2014-03-22','08:50:00',1.81),('15087','2014-03-22','08:55:00',2.06),('15087','2014-03-22','09:00:00',2.09),('15087','2014-03-22','09:05:00',1.39),('15087','2014-03-22','09:10:00',1.52),('15087','2013-02-10','09:45:00',1.39),('15087','2013-02-10','09:50:00',1.44),('15087','2013-02-10','10:00:00',2.66),('15087','2013-02-10','10:05:00',2.71),('15087','2013-02-10','10:10:00',2.73),('15087','2013-02-10','10:15:00',2.86),('15087','2013-02-10','10:20:00',2.93),('15087','2013-02-10','10:25:00',3),('15087','2013-02-10','10:30:00',3.05),('15087','2013-02-10','10:35:00',3.11),('15087','2013-02-10','10:40:00',3.19),('15087','2013-02-10','10:45:00',3.22),('15087','2013-02-10','10:50:00',3.27),('15087','2013-02-10','10:55:00',3.31),('15087','2013-02-10','11:00:00',3.35),('15087','2013-02-10','11:05:00',3.38),('15087','2013-02-10','11:10:00',3.43),('15087','2013-02-10','11:15:00',3.42),('15087','2013-02-10','11:20:00',3.46),('15087','2013-02-10','11:25:00',3.48),('15087','2013-02-10','11:30:00',3.52),('15087','2013-02-10','11:35:00',3.55),('15087','2013-02-10','11:40:00',3.55),('15087','2013-02-10','11:45:00',3.51),('15087','2013-02-10','11:50:00',3.59),('15087','2013-02-10','11:55:00',3.61),('15087','2013-02-10','12:00:00',3.65),('15087','2013-02-10','12:05:00',3.67),('15087','2013-02-10','12:10:00',3.68),('15087','2013-02-10','12:15:00',3.67),('15087','2013-02-10','12:20:00',3.7),('15087','2013-02-10','12:25:00',3.69),('15087','2013-02-10','12:30:00',3.68),('15087','2013-02-10','12:35:00',3.68),('15087','2013-02-10','12:40:00',3.65),('15087','2013-02-10','12:45:00',3.63),('15087','2013-02-10','12:50:00',3.58),('15087','2013-02-10','12:55:00',3.42),('15087','2013-02-10','13:00:00',3.54),('15087','2013-02-10','13:05:00',3.4),('15087','2013-02-10','13:10:00',3.07),('15087','2013-02-10','13:15:00',3.07),('15087','2013-02-10','13:20:00',3.18),('15087','2013-02-10','13:25:00',2.92),('15087','2013-02-10','13:30:00',2.87),('15087','2013-02-10','13:35:00',3.08),('15087','2013-02-10','13:40:00',2.84),('15087','2013-02-10','13:45:00',2.66),('15087','2013-02-10','13:50:00',2.81),('15087','2013-02-10','13:55:00',2.64),('15087','2013-02-10','14:00:00',2.48),('15087','2013-02-10','14:05:00',2.72),('15087','2013-02-10','14:10:00',2.67),('15087','2013-02-10','14:15:00',2.63),('15087','2013-02-10','14:20:00',2.62),('15087','2013-02-10','14:25:00',2.41),('15087','2013-02-10','14:30:00',2.26),('15087','2013-02-10','14:35:00',2.34),('15087','2013-02-10','14:40:00',2.31),('15087','2013-02-10','14:45:00',2.12),('15087','2013-02-10','14:50:00',1.97),('15087','2013-02-10','14:55:00',1.7),('15087','2013-02-10','15:00:00',1.5),('15087','2013-02-10','15:05:00',1.76),('15087','2013-02-10','15:10:00',1.79),('15087','2013-02-10','15:15:00',1.5),('15087','2013-02-10','15:20:00',1.85),('15087','2013-02-10','15:25:00',1.97),('15087','2013-02-10','15:30:00',1.46),('15087','2013-02-10','15:35:00',1.54),('15087','2013-02-10','15:40:00',1.29),('15087','2013-02-09','10:55:00',1.06),('15087','2013-02-09','11:00:00',1.14),('15087','2013-02-09','11:05:00',1.18),('15087','2013-02-09','11:10:00',1.22),('15087','2013-02-09','11:15:00',1.27),('15087','2013-02-09','11:20:00',1.3),('15087','2013-02-09','11:25:00',1.32),('15087','2013-02-09','11:30:00',1.34),('15087','2013-02-09','11:35:00',1.3),('15087','2013-02-09','11:40:00',1.27),('15087','2013-02-09','11:45:00',1.29),('15087','2013-02-09','11:50:00',1.27),('15087','2013-02-09','11:55:00',1.24),('15087','2013-02-09','12:00:00',1.25),('15087','2013-02-09','12:05:00',1.25),('15087','2013-02-09','12:10:00',1.22),('15087','2013-02-09','12:15:00',1.22),('15087','2013-02-09','12:20:00',1.24),('15087','2013-02-09','12:25:00',1.25),('15087','2013-02-09','12:30:00',1.27),('15087','2013-02-09','12:35:00',1.35),('15087','2013-02-09','12:40:00',1.37),('15087','2013-02-09','12:45:00',1.38),('15087','2013-02-09','12:50:00',1.4),('15087','2013-02-09','12:55:00',1.38),('15087','2013-02-09','13:00:00',1.49),('15087','2013-02-09','13:05:00',1.7),('15087','2013-02-09','13:10:00',1.9),('15087','2013-02-09','13:15:00',2.06),('15087','2013-02-09','13:20:00',2.3),('15087','2013-02-09','13:25:00',2.4),('15087','2013-02-09','13:30:00',2.58),('15087','2013-02-09','13:35:00',2.77),('15087','2013-02-09','13:40:00',2.69),('15087','2013-02-09','13:45:00',2.92),('15087','2013-02-09','13:50:00',2.96),('15087','2013-02-09','13:55:00',3.09),('15087','2013-02-09','14:00:00',2.81),('15087','2013-02-09','14:05:00',2.71),('15087','2013-02-09','14:10:00',2.29),('15087','2013-02-09','14:15:00',2.8),('15087','2013-02-09','14:20:00',3.18),('15087','2013-02-09','14:25:00',3.01),('15087','2013-02-09','14:30:00',2.69),('15087','2013-02-09','14:35:00',2.52),('15087','2013-02-09','14:40:00',2.21),('15087','2013-02-09','14:45:00',2.15),('15087','2013-02-09','14:50:00',2.01),('15087','2013-02-09','14:55:00',1.94),('15087','2013-02-09','15:00:00',1.83),('15087','2013-02-09','15:05:00',1.76),('15087','2013-02-09','15:10:00',1.71),('15087','2013-02-09','15:15:00',1.53),('15087','2013-02-09','15:20:00',1.64),('15087','2013-02-09','15:25:00',1.31),('15087','2013-02-09','15:30:00',1.36),('15087','2013-02-09','15:35:00',1.38),('15087','2013-02-09','15:40:00',1.27),('15087','2013-02-09','15:45:00',1.2),('15087','2013-02-09','15:50:00',1.18),('15087','2013-02-08','09:35:00',2.04),('15087','2013-02-08','09:40:00',2.86),('15087','2013-02-08','09:45:00',2.79),('15087','2013-02-08','09:50:00',2.72),('15087','2013-02-08','09:55:00',2.91),('15087','2013-02-08','10:00:00',3),('15087','2013-02-08','10:05:00',3.23),('15087','2013-02-08','10:10:00',3.24),('15087','2013-02-08','10:15:00',3.42),('15087','2013-02-08','10:20:00',2.91),('15087','2013-02-08','10:25:00',3.37),('15087','2013-02-08','10:30:00',2.44),('15087','2013-02-08','10:35:00',2.24),('15087','2013-02-08','10:40:00',3.65),('15087','2013-02-08','10:45:00',3.54),('15087','2013-02-08','10:50:00',3.65),('15087','2013-02-08','10:55:00',3.59),('15087','2013-02-08','11:00:00',3.5),('15087','2013-02-08','11:05:00',3.45),('15087','2013-02-08','11:10:00',3.48),('15087','2013-02-08','11:15:00',3.51),('15087','2013-02-08','11:20:00',3.52),('15087','2013-02-08','11:25:00',3.53),('15087','2013-02-08','11:30:00',3.54),('15087','2013-02-08','11:35:00',3.51),('15087','2013-02-08','11:40:00',3.57),('15087','2013-02-08','11:45:00',3.58),('15087','2013-02-08','11:50:00',3.59),('15087','2013-02-08','11:55:00',3.59),('15087','2013-02-08','12:00:00',3.61),('15087','2013-02-08','12:05:00',3.61),('15087','2013-02-08','12:10:00',3.64),('15087','2013-02-08','12:15:00',3.63),('15087','2013-02-08','12:20:00',3.63),('15087','2013-02-08','12:25:00',3.65),('15087','2013-02-08','12:30:00',3.63),('15087','2013-02-08','12:35:00',3.64),('15087','2013-02-08','12:40:00',3.84),('15087','2013-02-08','12:45:00',3.87),('15087','2013-02-08','12:50:00',2.15),('15087','2013-02-08','12:55:00',2.31),('15087','2013-02-08','13:00:00',2.16),('15087','2013-02-08','13:05:00',1.85),('15087','2013-02-08','13:10:00',1.99),('15087','2013-02-08','13:15:00',1.95),('15087','2013-02-08','13:20:00',2.02),('15087','2013-02-08','13:25:00',1.89),('15087','2013-02-08','13:30:00',1.89),('15087','2013-02-08','13:35:00',2.46),('15087','2013-02-08','13:40:00',1.99),('15087','2013-02-08','13:45:00',1.54),('15087','2013-02-08','13:50:00',1.59),('15087','2013-02-08','13:55:00',1.69),('15087','2013-02-08','14:00:00',1.52),('15087','2013-02-08','14:05:00',1.51),('15087','2013-02-08','14:10:00',1.4),('15087','2013-02-08','14:15:00',1.33),('15087','2013-02-08','14:20:00',1.41),('15087','2013-02-08','14:25:00',1.84),('15087','2013-02-08','14:30:00',2.32),('15087','2013-02-08','14:35:00',2.4),('15087','2013-02-08','14:40:00',3.3),('15087','2013-02-08','14:45:00',2.4),('15087','2013-02-08','14:50:00',2.24),('15087','2013-02-08','14:55:00',2.57),('15087','2013-02-08','15:00:00',2.56),('15087','2013-02-08','15:05:00',2.67),('15087','2013-02-08','15:10:00',2.54),('15087','2013-02-08','15:15:00',2.23),('15087','2013-02-08','15:20:00',1.31),('15087','2013-02-08','15:25:00',1.55),('15087','2013-02-08','15:30:00',1.53),('15087','2013-02-08','15:35:00',1.47),('15087','2013-02-08','15:40:00',1.43),('15087','2013-02-08','15:45:00',1.37),('15087','2013-02-08','15:50:00',1.27),('15087','2013-02-08','15:55:00',1.2),('15087','2013-02-08','16:00:00',1.1),('15087','2013-02-08','16:05:00',1),('15087','2013-02-07','15:05:00',2.41),('15087','2013-02-07','15:10:00',2.41),('15087','2013-02-07','15:15:00',1.61),('15087','2013-02-07','15:25:00',1.15),('15087','2014-03-20','07:35:00',1.01),('15087','2014-03-20','07:40:00',1.13),('15087','2014-03-20','07:45:00',1.22),('15087','2014-03-20','07:50:00',1.33),('15087','2014-03-20','07:55:00',1.44),('15087','2014-03-20','08:00:00',1.56),('15087','2014-03-20','08:05:00',1.64),('15087','2014-03-20','08:10:00',1.7),('15087','2014-03-20','08:15:00',1.76),('15087','2014-03-20','08:20:00',1.8),('15087','2014-03-20','08:25:00',1.9),('15087','2014-03-20','08:30:00',2.01),('15087','2014-03-20','08:35:00',2.11),('15087','2014-03-20','08:40:00',2.24),('15087','2014-03-20','08:45:00',2.35),('15087','2014-03-20','08:50:00',2.42),('15087','2014-03-20','08:55:00',2.49),('15087','2014-03-20','09:00:00',2.53),('15087','2014-03-20','09:05:00',2.64),('15087','2014-03-20','09:10:00',2.73),('15087','2014-03-20','09:15:00',2.78),('15087','2014-03-20','09:20:00',2.86),('15087','2014-03-20','09:25:00',2.9),('15087','2014-03-20','09:30:00',2.97),('15087','2014-03-20','09:35:00',3.06),('15087','2014-03-20','09:40:00',3.08),('15087','2014-03-20','09:45:00',3.12),('15087','2014-03-20','09:50:00',3.11),('15087','2014-03-20','09:55:00',3.19),('15087','2014-03-20','10:00:00',3.37),('15087','2014-03-20','10:05:00',3.46),('15087','2014-03-20','10:10:00',3.49),('15087','2014-03-20','10:15:00',3.48),('15087','2014-03-20','10:20:00',3.48),('15087','2014-03-20','10:25:00',3.57),('15087','2014-03-20','10:30:00',3.58),('15087','2014-03-20','10:35:00',3.46),('15087','2014-03-20','10:40:00',3.4),('15087','2014-03-20','10:45:00',3.49),('15087','2014-03-20','10:50:00',3.64),('15087','2014-03-20','10:55:00',3.9),('15087','2014-03-20','11:00:00',3.95),('15087','2014-03-20','11:05:00',3.92),('15087','2014-03-20','11:10:00',3.89),('15087','2014-03-20','11:15:00',3.69),('15087','2014-03-20','11:20:00',3.89),('15087','2014-03-20','11:25:00',3.92),('15087','2014-03-20','11:30:00',3.99),('15087','2014-03-20','11:35:00',4.1),('15087','2014-03-20','11:40:00',4.03),('15087','2014-03-20','11:45:00',4.02),('15087','2014-03-20','11:50:00',4.12),('15087','2014-03-20','11:55:00',3.79),('15087','2014-03-20','12:00:00',3.59),('15087','2014-03-20','12:05:00',3.95),('15087','2014-03-20','12:10:00',4.08),('15087','2014-03-20','12:15:00',4.11),('15087','2014-03-20','12:20:00',3.99),('15087','2014-03-20','12:25:00',3.84),('15087','2014-03-20','12:30:00',3.98),('15087','2014-03-20','12:35:00',4.01),('15087','2014-03-20','12:40:00',4.03),('15087','2014-03-20','12:45:00',4.12),('15087','2014-03-20','12:50:00',4.05),('15087','2014-03-20','12:55:00',3.99),('15087','2014-03-20','13:00:00',3.83),('15087','2014-03-20','13:05:00',3.81),('15087','2014-03-20','13:10:00',3.8),('15087','2014-03-20','13:15:00',3.7),('15087','2014-03-20','13:20:00',3.7),('15087','2014-03-20','13:25:00',3.59),('15087','2014-03-20','13:30:00',3.65),('15087','2014-03-20','13:35:00',3.52),('15087','2014-03-20','13:40:00',3.37),('15087','2014-03-20','13:45:00',3.17),('15087','2014-03-20','13:50:00',3.09),('15087','2014-03-20','13:55:00',2.88),('15087','2014-03-20','14:00:00',3.05),('15087','2014-03-20','14:05:00',3.28),('15087','2014-03-20','14:10:00',3.11),('15087','2014-03-20','14:15:00',2.87),('15087','2014-03-20','14:20:00',2.85),('15087','2014-03-20','14:25:00',2.86),('15087','2014-03-20','14:30:00',2.45),('15087','2014-03-20','14:35:00',2.29),('15087','2014-03-20','14:40:00',2.52),('15087','2014-03-20','14:45:00',2.45),('15087','2014-03-20','14:50:00',2.27),('15087','2014-03-20','14:55:00',2.22),('15087','2014-03-20','15:00:00',1.96),('15087','2014-03-20','15:05:00',1.97),('15087','2014-03-20','15:10:00',2.03),('15087','2014-03-20','15:15:00',1.93),('15087','2014-03-20','15:20:00',2.05),('15087','2014-03-20','15:25:00',1.84),('15087','2014-03-20','15:30:00',1.76),('15087','2014-03-20','15:35:00',1.68),('15087','2014-03-20','15:40:00',1.51),('15087','2014-03-20','15:45:00',1.55),('15087','2014-03-20','15:50:00',1.35),('15087','2014-03-20','15:55:00',1.24),('15087','2014-03-20','16:00:00',1.08),('15087','2014-03-19','09:00:00',1.02),('15087','2014-03-19','09:05:00',1.26),('15087','2014-03-19','09:10:00',1.43),('15087','2014-03-19','09:15:00',1.79),('15087','2014-03-19','09:20:00',1.74),('15087','2014-03-19','09:25:00',2.88),('15087','2014-03-19','09:30:00',3.69),('15087','2014-03-19','09:35:00',2.99),('15087','2014-03-19','09:40:00',3.29),('15087','2014-03-19','09:45:00',2.74),('15087','2014-03-19','09:50:00',2.59),('15087','2014-03-19','09:55:00',2.01),('15087','2014-03-19','10:00:00',1.42),('15087','2014-03-19','10:25:00',1.06),('15087','2014-03-19','10:30:00',1.39),('15087','2014-03-19','10:35:00',2.64),('15087','2014-03-19','10:40:00',2.14),('15087','2014-03-19','10:45:00',1.88),('15087','2014-03-19','10:50:00',1.66),('15087','2014-03-19','10:55:00',1.96),('15087','2014-03-19','11:00:00',3.96),('15087','2014-03-19','11:05:00',3.63),('15087','2014-03-19','11:10:00',1.91),('15087','2014-03-19','11:15:00',1.89),('15087','2014-03-19','11:20:00',1.73),('15087','2014-03-19','11:25:00',1.88),('15087','2014-03-19','11:30:00',1.87),('15087','2014-03-19','11:35:00',2.33),('15087','2014-03-19','11:40:00',2.1),('15087','2014-03-19','11:45:00',2.04),('15087','2014-03-19','11:50:00',2.01),('15087','2014-03-19','11:55:00',2),('15087','2014-03-19','12:00:00',2.64),('15087','2014-03-19','12:05:00',4.33),('15087','2014-03-19','12:10:00',4.54),('15087','2014-03-19','12:15:00',4.49),('15087','2014-03-19','12:20:00',4.49),('15087','2014-03-19','12:25:00',3.88),('15087','2014-03-19','12:30:00',3.51),('15087','2014-03-19','12:35:00',2.48),('15087','2014-03-19','12:40:00',2.96),('15087','2014-03-19','12:45:00',4.18),('15087','2014-03-19','12:50:00',4.04),('15087','2014-03-19','12:55:00',3.54),('15087','2014-03-19','13:00:00',3.94),('15087','2014-03-19','13:05:00',3.83),('15087','2014-03-19','13:10:00',3.81),('15087','2014-03-19','13:15:00',3.57),('15087','2014-03-19','13:20:00',3.51),('15087','2014-03-19','13:25:00',3.23),('15087','2014-03-19','13:30:00',3.64),('15087','2014-03-19','13:35:00',3.73),('15087','2014-03-19','13:40:00',3.54),('15087','2014-03-19','13:45:00',3.43),('15087','2014-03-19','13:50:00',3.4),('15087','2014-03-19','13:55:00',3.44),('15087','2014-03-19','14:00:00',3.35),('15087','2014-03-19','14:05:00',3.38),('15087','2014-03-19','14:10:00',3.29),('15087','2014-03-19','14:15:00',3.18),('15087','2014-03-19','14:20:00',3.13),('15087','2014-03-19','14:25:00',2.99),('15087','2014-03-19','14:30:00',2.87),('15087','2014-03-19','14:35:00',2.99),('15087','2014-03-19','14:40:00',2.83),('15087','2014-03-19','14:45:00',2.76),('15087','2014-03-19','14:50:00',2.7),('15087','2014-03-19','14:55:00',2.52),('15087','2014-03-19','15:00:00',2.56),('15087','2014-03-19','15:05:00',2.58),('15087','2014-03-19','15:10:00',2.5),('15087','2014-03-19','15:15:00',2.33),('15087','2014-03-19','15:20:00',2.34),('15087','2014-03-19','15:25:00',2.28),('15087','2014-03-19','15:30:00',2.09),('15087','2014-03-19','15:35:00',2.08),('15087','2014-03-19','15:40:00',2.02),('15087','2014-03-19','15:45:00',1.9),('15087','2014-03-19','15:50:00',1.87),('15087','2014-03-19','15:55:00',1.81),('15087','2014-03-19','16:00:00',1.69),('15087','2014-03-19','16:05:00',1.59),('15087','2014-03-19','16:10:00',1.51),('15087','2014-03-19','16:15:00',1.41),('15087','2014-03-19','16:20:00',1.33),('15087','2014-03-19','16:25:00',1.18),('15087','2014-03-19','16:30:00',1.1),('15087','2014-03-18','07:55:00',1.06),('15087','2014-03-18','08:15:00',1),('15087','2014-03-18','08:20:00',1.93),('15087','2014-03-18','08:25:00',1.1),('15087','2014-03-18','08:30:00',1.28),('15087','2014-03-18','08:50:00',2.04),('15087','2014-03-18','08:55:00',2.83),('15087','2014-03-18','09:00:00',2.17),('15087','2014-03-18','09:05:00',1.63),('15087','2014-03-18','09:10:00',1.72),('15087','2014-03-18','09:15:00',1.89),('15087','2014-03-18','09:20:00',2.37),('15087','2014-03-18','09:25:00',1.95),('15087','2014-03-18','09:30:00',2.82),('15087','2014-03-18','09:35:00',1.81),('15087','2014-03-18','09:40:00',1.13),('15087','2014-03-18','09:45:00',1.61),('15087','2014-03-18','09:50:00',2.71),('15087','2014-03-18','09:55:00',1.62),('15087','2014-03-18','10:00:00',3.04),('15087','2014-03-18','10:05:00',3.6),('15087','2014-03-18','10:10:00',3.75),('15087','2014-03-18','10:15:00',3.82),('15087','2014-03-18','10:20:00',3.27),('15087','2014-03-18','10:25:00',2.17),('15087','2014-03-18','10:30:00',3.52),('15087','2014-03-18','10:35:00',3.78),('15087','2014-03-18','10:40:00',2.42),('15087','2014-03-18','10:45:00',3.37),('15087','2014-03-18','10:50:00',4.61),('15087','2014-03-18','10:55:00',3.21),('15087','2014-03-18','11:00:00',1.99),('15087','2014-03-18','11:05:00',2.28),('15087','2014-03-18','11:10:00',1.48),('15087','2014-03-18','11:15:00',2.74),('15087','2014-03-18','11:20:00',4.19),('15087','2014-03-18','11:25:00',3.42),('15087','2014-03-18','11:30:00',3.18),('15087','2014-03-18','11:35:00',4.88),('15087','2014-03-18','11:40:00',3),('15087','2014-03-18','11:45:00',3.78),('15087','2014-03-18','11:50:00',2.45),('15087','2014-03-18','11:55:00',1.87),('15087','2014-03-18','12:00:00',2.44),('15087','2014-03-18','12:05:00',4.07),('15087','2014-03-18','12:10:00',3.99),('15087','2014-03-18','12:15:00',2.23),('15087','2014-03-18','12:20:00',1.52),('15087','2014-03-18','12:25:00',1.23),('15087','2014-03-18','12:30:00',2.29),('15087','2014-03-18','12:35:00',1.85),('15087','2014-03-18','12:40:00',2.6),('15087','2014-03-18','12:45:00',4.52),('15087','2014-03-18','12:50:00',4.32),('15087','2014-03-18','12:55:00',4.18),('15087','2014-03-18','13:00:00',3.87),('15087','2014-03-18','13:05:00',4.1),('15087','2014-03-18','13:10:00',4.04),('15087','2014-03-18','13:15:00',3.87),('15087','2014-03-18','13:20:00',3.69),('15087','2014-03-18','13:25:00',2.92),('15087','2014-03-18','13:30:00',3.76),('15087','2014-03-18','13:35:00',3.63),('15087','2014-03-18','13:40:00',3.49),('15087','2014-03-18','13:45:00',3.43),('15087','2014-03-18','13:50:00',3.46),('15087','2014-03-18','13:55:00',3.35),('15087','2014-03-18','14:00:00',3.27),('15087','2014-03-18','14:05:00',3.35),('15087','2014-03-18','14:10:00',3.2),('15087','2014-03-18','14:15:00',3.13),('15087','2014-03-18','14:20:00',3.17),('15087','2014-03-18','14:25:00',2.95),('15087','2014-03-18','14:30:00',2.87),('15087','2014-03-18','14:35:00',2.93),('15087','2014-03-18','14:40:00',2.7),('15087','2014-03-18','14:45:00',2.68),('15087','2014-03-18','14:50:00',2.72),('15087','2014-03-18','14:55:00',2.52),('15087','2014-03-18','15:00:00',2.65),('15087','2014-03-18','15:05:00',2.58),('15087','2014-03-18','15:10:00',2.41),('15087','2014-03-18','15:15:00',2.23),('15087','2014-03-18','15:20:00',2.26),('15087','2014-03-18','15:25:00',2.21),('15087','2014-03-18','15:30:00',2.03),('15087','2014-03-18','15:35:00',1.98),('15087','2014-03-18','15:40:00',1.91),('15087','2014-03-18','15:45:00',1.86),('15087','2014-03-18','15:50:00',1.8),('15087','2014-03-18','15:55:00',1.73),('15087','2014-03-18','16:00:00',1.64),('15087','2014-03-18','16:05:00',1.57),('15087','2014-03-18','16:10:00',1.49),('15087','2014-03-18','16:15:00',1.4),('15087','2014-03-18','16:20:00',1.29),('15087','2014-03-18','16:25:00',1.18),('15087','2014-03-18','16:30:00',1.1),('15087','2014-03-18','16:35:00',1.01),('15087','2014-05-01','07:50:00',1.27),('15087','2014-05-01','07:55:00',1.44),('15087','2014-05-01','08:00:00',1.6),('15087','2014-05-01','08:05:00',1.63),('15087','2014-05-01','08:10:00',1.7),('15087','2014-05-01','08:15:00',1.81),('15087','2014-05-01','08:20:00',1.91),('15087','2014-05-01','08:25:00',2.01),('15087','2014-05-01','08:30:00',2.11),('15087','2014-05-01','08:35:00',2.21),('15087','2014-05-01','08:40:00',2.31),('15087','2014-05-01','08:45:00',2.41),('15087','2014-05-01','08:50:00',2.62),('15087','2014-05-01','08:55:00',2.83),('15087','2014-05-01','09:00:00',1.67),('15087','2014-05-01','09:05:00',1.17),('15087','2014-05-01','09:10:00',2.42),('15087','2014-05-01','09:15:00',2.62),('15087','2014-05-01','09:20:00',1.96),('15087','2014-05-01','09:25:00',3.21),('15087','2014-05-01','09:30:00',3.19),('15087','2014-05-01','09:35:00',3.43),('15087','2014-05-01','09:40:00',3.75),('15087','2014-05-01','09:45:00',2.42),('15087','2014-05-01','09:50:00',2.72),('15087','2014-05-01','09:55:00',2.37),('15087','2014-05-01','10:00:00',1.88),('15087','2014-05-01','10:05:00',1.78),('15087','2014-05-01','10:10:00',2.73),('15087','2014-05-01','10:15:00',3.13),('15087','2014-05-01','10:20:00',1.68),('15087','2014-05-01','10:25:00',1.35),('15087','2014-05-01','10:30:00',3.33),('15087','2014-05-01','10:35:00',3.7),('15087','2014-05-01','10:40:00',1.8),('15087','2014-05-01','10:45:00',3.76),('15087','2014-05-01','10:50:00',4.61),('15087','2014-05-01','10:55:00',3.98),('15087','2014-05-01','11:00:00',3.94),('15087','2014-05-01','11:05:00',4.73),('15087','2014-05-01','11:10:00',3.43),('15087','2014-05-01','11:20:00',1.69),('15087','2014-05-01','11:25:00',5.11),('15087','2014-05-01','11:30:00',4.99),('15087','2014-05-01','11:35:00',4.87),('15087','2014-05-01','11:40:00',3.42),('15087','2014-05-01','11:45:00',5.12),('15087','2014-05-01','11:50:00',5.17),('15087','2014-05-01','11:55:00',2.16),('15087','2014-05-01','12:00:00',1.02),('15087','2014-05-01','12:05:00',5.24),('15087','2014-05-01','12:10:00',3.94),('15087','2014-05-01','12:15:00',3.3),('15087','2014-05-01','12:20:00',4),('15087','2014-05-01','12:25:00',5.29),('15087','2014-05-01','12:30:00',4),('15087','2014-05-01','12:35:00',5.28),('15087','2014-05-01','12:40:00',5.06),('15087','2014-05-01','12:45:00',2.19),('15087','2014-05-01','12:50:00',5.22),('15087','2014-05-01','12:55:00',5.39),('15087','2014-05-01','13:00:00',5.28),('15087','2014-05-01','13:05:00',5.17),('15087','2014-05-01','13:10:00',4.31),('15087','2014-05-01','13:15:00',4.56),('15087','2014-05-01','13:20:00',5.2),('15087','2014-05-01','13:25:00',1.32),('15087','2014-05-01','13:30:00',1.82),('15087','2014-05-01','13:35:00',1.88),('15087','2014-05-01','13:40:00',5.43),('15087','2014-05-01','13:45:00',5.38),('15087','2014-05-01','13:50:00',5.61),('15087','2014-05-01','13:55:00',5.24),('15087','2014-05-01','14:00:00',4.41),('15087','2014-05-01','14:05:00',4.99),('15087','2014-05-01','14:10:00',4.83),('15087','2014-05-01','14:15:00',4.78),('15087','2014-05-01','14:20:00',4.6),('15087','2014-05-01','14:25:00',4.61),('15087','2014-05-01','14:30:00',4.41),('15087','2014-05-01','14:35:00',4.35),('15087','2014-05-01','14:40:00',4.66),('15087','2014-05-01','14:45:00',4.55),('15087','2014-05-01','14:50:00',4.47),('15087','2014-05-01','14:55:00',4.09),('15087','2014-05-01','15:00:00',4.3),('15087','2014-05-01','15:05:00',4.51),('15087','2014-05-01','15:10:00',3.95),('15087','2014-05-01','15:15:00',4.02),('15087','2014-05-01','15:20:00',4.06),('15087','2014-05-01','15:25:00',3.98),('15087','2014-05-01','15:30:00',3.75),('15087','2014-05-01','15:35:00',3.5),('15087','2014-05-01','15:40:00',3.59),('15087','2014-05-01','15:45:00',3.49),('15087','2014-05-01','15:50:00',3.49),('15087','2014-05-01','15:55:00',3.35),('15087','2014-05-01','16:00:00',3.43),('15087','2014-05-01','16:05:00',3.41),('15087','2014-05-01','16:10:00',3.23),('15087','2014-05-01','16:15:00',3.21),('15087','2014-05-01','16:20:00',3.06),('15087','2014-05-01','16:25:00',2.81),('15087','2014-05-01','16:30:00',2.98),('15087','2014-05-01','16:35:00',2.95),('15087','2014-05-01','16:40:00',2.75),('15087','2014-05-01','16:45:00',2.34),('15087','2014-05-01','16:50:00',2.12),('15087','2014-05-01','16:55:00',2.37),('15087','2014-05-01','17:00:00',2.37),('15087','2014-05-01','17:05:00',2.26),('15087','2014-05-01','17:10:00',2.45),('15087','2014-05-01','17:15:00',2.31),('15087','2014-05-01','17:20:00',2.1),('15087','2014-05-01','17:25:00',2.05),('15087','2014-05-01','17:30:00',1.94),('15087','2014-05-01','17:35:00',1.68),('15087','2014-05-01','17:40:00',1.74),('15087','2014-05-01','17:45:00',1.61),('15087','2014-05-01','17:50:00',1.58),('15087','2014-05-01','17:55:00',1.55),('15087','2014-05-01','18:00:00',1.54),('15087','2014-05-01','18:05:00',1.33),('15087','2014-05-01','18:10:00',1.2),('15087','2014-05-01','18:15:00',1.12),('15087','2014-05-01','18:20:00',1.04),('15087','2014-03-17','09:15:00',1.19),('15087','2014-03-17','09:20:00',1.26),('15087','2014-03-17','09:25:00',1.6),('15087','2014-03-17','09:30:00',1.81),('15087','2014-03-17','09:35:00',1.47),('15087','2014-03-17','09:40:00',1.28),('15087','2014-03-17','09:45:00',1.33),('15087','2014-03-17','09:50:00',2.26),('15087','2014-03-17','09:55:00',1.91),('15087','2014-03-17','10:00:00',2.01),('15087','2014-03-17','10:05:00',1.88),('15087','2014-03-17','10:10:00',1.74),('15087','2014-03-17','10:15:00',1.88),('15087','2014-03-17','10:20:00',2.09),('15087','2014-03-17','10:25:00',1.82),('15087','2014-03-17','10:30:00',1.56),('15087','2014-03-17','10:35:00',1.4),('15087','2014-03-17','10:40:00',1.55),('15087','2014-03-17','10:45:00',1.94),('15087','2014-03-17','10:50:00',1.58),('15087','2014-03-17','10:55:00',1.53),('15087','2014-03-17','11:00:00',1.65),('15087','2014-03-17','11:05:00',1.46),('15087','2014-03-17','11:10:00',1.95),('15087','2014-03-17','11:15:00',1.73),('15087','2014-03-17','11:20:00',1.44),('15087','2014-03-17','11:25:00',1.86),('15087','2014-03-17','11:30:00',1.54),('15087','2014-03-17','11:35:00',1.49),('15087','2014-03-17','11:40:00',1.31),('15087','2014-03-17','11:45:00',1.7),('15087','2014-03-17','11:50:00',1.78),('15087','2014-03-17','11:55:00',1.87),('15087','2014-03-17','12:00:00',2.02),('15087','2014-03-17','12:05:00',2.19),('15087','2014-03-17','12:10:00',1.55),('15087','2014-03-17','12:15:00',1.93),('15087','2014-03-17','12:20:00',3.7),('15087','2014-03-17','12:25:00',1.63),('15087','2014-03-17','12:30:00',1.82),('15087','2014-03-17','12:35:00',2.11),('15087','2014-03-17','12:40:00',3.53),('15087','2014-03-17','12:45:00',3.72),('15087','2014-03-17','12:50:00',4.35),('15087','2014-03-17','12:55:00',4.02),('15087','2014-03-17','13:00:00',1.64),('15087','2014-03-17','13:05:00',2.19),('15087','2014-03-17','13:10:00',4.03),('15087','2014-03-17','13:15:00',3.99),('15087','2014-03-17','13:20:00',3.79),('15087','2014-03-17','13:25:00',3.41),('15087','2014-03-17','13:30:00',3.56),('15087','2014-03-17','13:35:00',3.7),('15087','2014-03-17','13:40:00',3.51),('15087','2014-03-17','13:45:00',1.81),('15087','2014-03-17','13:50:00',3.68),('15087','2014-03-17','13:55:00',1.79),('15087','2014-03-17','14:00:00',3.19),('15087','2014-03-17','14:05:00',2.81),('15087','2014-03-17','14:10:00',1.17),('15087','2014-03-17','14:15:00',3.1),('15087','2014-03-17','14:20:00',2),('15087','2014-03-17','14:25:00',2.66),('15087','2014-03-17','14:30:00',1.75),('15087','2014-03-17','14:35:00',2.16),('15087','2014-03-17','14:40:00',2.81),('15087','2014-03-17','14:45:00',2),('15087','2014-03-17','14:50:00',2.86),('15087','2014-03-17','14:55:00',2.39),('15087','2014-03-17','15:00:00',2.73),('15087','2014-03-17','15:05:00',2.12),('15087','2014-03-17','15:10:00',2.11),('15087','2014-03-17','15:15:00',1.51),('15087','2014-03-17','15:20:00',2.03),('15087','2014-03-17','15:25:00',2.11),('15087','2014-03-17','15:30:00',2.1),('15087','2014-03-17','15:35:00',1.89),('15087','2014-03-17','15:40:00',1.81),('15087','2014-03-17','15:45:00',1.79),('15087','2014-03-17','15:50:00',1.69),('15087','2014-03-17','15:55:00',1.71),('15087','2014-03-17','16:00:00',1.65),('15087','2014-03-17','16:05:00',1.2),('15087','2014-03-17','16:15:00',1.08),('15087','2014-03-17','16:20:00',1.38),('15087','2014-03-17','16:25:00',1.29),('15087','2014-03-17','16:30:00',1.13),('15087','2014-03-17','16:35:00',1.23),('15087','2014-03-17','16:40:00',1.02),('15087','2014-03-16','07:55:00',1.07),('15087','2014-03-16','08:00:00',1.24),('15087','2014-03-16','08:05:00',1.37),('15087','2014-03-16','08:10:00',1.4),('15087','2014-03-16','08:15:00',1.45),('15087','2014-03-16','08:20:00',1.55),('15087','2014-03-16','08:25:00',1.65),('15087','2014-03-16','08:30:00',1.74),('15087','2014-03-16','08:35:00',1.81),('15087','2014-03-16','08:40:00',1.87),('15087','2014-03-16','08:45:00',1.94),('15087','2014-03-16','08:50:00',2.06),('15087','2014-03-16','08:55:00',2.11),('15087','2014-03-16','09:00:00',2.08),('15087','2014-03-16','09:05:00',2.17),('15087','2014-03-16','09:10:00',2.33),('15087','2014-03-16','09:15:00',2.5),('15087','2014-03-16','09:20:00',2.56),('15087','2014-03-16','09:25:00',2.54),('15087','2014-03-16','09:30:00',2.61),('15087','2014-03-16','09:35:00',2.59),('15087','2014-03-16','09:40:00',2.68),('15087','2014-03-16','09:45:00',2.85),('15087','2014-03-16','09:50:00',3.01),('15087','2014-03-16','09:55:00',2.99),('15087','2014-03-16','10:00:00',2.97),('15087','2014-03-16','10:05:00',3.11),('15087','2014-03-16','10:10:00',3.1),('15087','2014-03-16','10:15:00',3.27),('15087','2014-03-16','10:20:00',3.26),('15087','2014-03-16','10:25:00',3.27),('15087','2014-03-16','10:30:00',3.29),('15087','2014-03-16','10:35:00',3.35),('15087','2014-03-16','10:40:00',3.43),('15087','2014-03-16','10:45:00',3.51),('15087','2014-03-16','10:50:00',3.58),('15087','2014-03-16','10:55:00',3.58),('15087','2014-03-16','11:00:00',3.64),('15087','2014-03-16','11:05:00',3.63),('15087','2014-03-16','11:10:00',3.68),('15087','2014-03-16','11:15:00',3.65),('15087','2014-03-16','11:20:00',3.66),('15087','2014-03-16','11:25:00',3.71),('15087','2014-03-16','11:30:00',3.8),('15087','2014-03-16','11:35:00',3.8),('15087','2014-03-16','11:40:00',3.8),('15087','2014-03-16','11:45:00',3.72),('15087','2014-03-16','11:50:00',3.7),('15087','2014-03-16','11:55:00',3.58),('15087','2014-03-16','12:00:00',3.79),('15087','2014-03-16','12:05:00',3.82),('15087','2014-03-16','12:10:00',3.77),('15087','2014-03-16','12:15:00',3.63),('15087','2014-03-16','12:20:00',3.63),('15087','2014-03-16','12:25:00',3.82),('15087','2014-03-16','12:30:00',3.82),('15087','2014-03-16','12:35:00',3.84),('15087','2014-03-16','12:40:00',3.81),('15087','2014-03-16','12:45:00',3.78),('15087','2014-03-16','12:50:00',3.75),('15087','2014-03-16','12:55:00',3.73),('15087','2014-03-16','13:00:00',3.64),('15087','2014-03-16','13:05:00',3.63),('15087','2014-03-16','13:10:00',3.55),('15087','2014-03-16','13:15:00',3.52),('15087','2014-03-16','13:20:00',3.33),('15087','2014-03-16','13:25:00',3.44),('15087','2014-03-16','13:30:00',3.41),('15087','2014-03-16','13:35:00',3.31),('15087','2014-03-16','13:40:00',3.44),('15087','2014-03-16','13:45:00',3.35),('15087','2014-03-16','13:50:00',3.29),('15087','2014-03-16','13:55:00',3.31),('15087','2014-03-16','14:00:00',3.15),('15087','2014-03-16','14:05:00',3.1),('15087','2014-03-16','14:10:00',3.06),('15087','2014-03-16','14:15:00',2.91),('15087','2014-03-16','14:20:00',2.89),('15087','2014-03-16','14:25:00',2.89),('15087','2014-03-16','14:30:00',2.75),('15087','2014-03-16','14:35:00',2.76),('15087','2014-03-16','14:40:00',2.69),('15087','2014-03-16','14:45:00',2.57),('15087','2014-03-16','14:50:00',2.45),('15087','2014-03-16','14:55:00',2.5),('15087','2014-03-16','15:00:00',2.56),('15087','2014-03-16','15:05:00',2.37),('15087','2014-03-16','15:10:00',2.21),('15087','2014-03-16','15:15:00',2.07),('15087','2014-03-16','15:20:00',1.79),('15087','2014-03-16','15:25:00',2.01),('15087','2014-03-16','15:30:00',1.85),('15087','2014-03-16','15:35:00',1.75),('15087','2014-03-16','15:40:00',1.39),('15087','2014-03-16','15:45:00',1.29),('15087','2014-03-16','15:50:00',1.47),('15087','2014-03-16','15:55:00',1.32),('15087','2014-03-16','16:00:00',1.1),('15087','2014-03-16','16:05:00',1.31),('15087','2014-03-16','16:10:00',1.37),('15087','2014-03-16','16:15:00',1.37),('15087','2014-03-16','16:20:00',1.25),('15087','2014-03-16','16:25:00',1.19),('15087','2014-03-16','16:30:00',1.22),('15087','2014-03-16','16:35:00',1.12),('15087','2014-03-15','07:55:00',1.01),('15087','2014-03-15','08:00:00',1.11),('15087','2014-03-15','08:05:00',1.21),('15087','2014-03-15','08:10:00',1.33),('15087','2014-03-15','08:15:00',1.43),('15087','2014-03-15','08:20:00',1.52),('15087','2014-03-15','08:25:00',1.59),('15087','2014-03-15','08:30:00',1.68),('15087','2014-03-15','08:35:00',1.76),('15087','2014-03-15','08:40:00',1.84),('15087','2014-03-15','08:45:00',1.91),('15087','2014-03-15','08:50:00',2),('15087','2014-03-15','08:55:00',2.07),('15087','2014-03-15','09:00:00',2.16),('15087','2014-03-15','09:05:00',2.25),('15087','2014-03-15','09:10:00',2.32),('15087','2014-03-15','09:15:00',2.42),('15087','2014-03-15','09:20:00',2.47),('15087','2014-03-15','09:25:00',2.54),('15087','2014-03-15','09:30:00',2.6),('15087','2014-03-15','09:35:00',2.66),('15087','2014-03-15','09:40:00',2.72),('15087','2014-03-15','09:45:00',2.77),('15087','2014-03-15','09:50:00',2.81),('15087','2014-03-15','09:55:00',2.87),('15087','2014-03-15','10:00:00',2.91),('15087','2014-03-15','10:05:00',2.99),('15087','2014-03-15','10:10:00',3.11),('15087','2014-03-15','10:15:00',3.13),('15087','2014-03-15','10:20:00',3.15),('15087','2014-03-15','10:25:00',3.2),('15087','2014-03-15','10:30:00',3.23),('15087','2014-03-15','10:35:00',3.22),('15087','2014-03-15','10:40:00',3.3),('15087','2014-03-15','10:45:00',3.34),('15087','2014-03-15','10:50:00',3.34),('15087','2014-03-15','10:55:00',3.37),('15087','2014-03-15','11:00:00',3.43),('15087','2014-03-15','11:05:00',3.49),('15087','2014-03-15','11:10:00',3.5),('15087','2014-03-15','11:15:00',3.62),('15087','2014-03-15','11:20:00',3.66),('15087','2014-03-15','11:25:00',3.74),('15087','2014-03-15','11:30:00',3.64),('15087','2014-03-15','11:35:00',3.73),('15087','2014-03-15','11:40:00',3.72),('15087','2014-03-15','11:45:00',3.82),('15087','2014-03-15','11:50:00',3.7),('15087','2014-03-15','11:55:00',3.71),('15087','2014-03-15','12:00:00',3.71),('15087','2014-03-15','12:05:00',3.74),('15087','2014-03-15','12:10:00',3.79),('15087','2014-03-15','12:15:00',3.83),('15087','2014-03-15','12:20:00',3.75),('15087','2014-03-15','12:25:00',3.81),('15087','2014-03-15','12:30:00',3.88),('15087','2014-03-15','12:35:00',3.85),('15087','2014-03-15','12:40:00',3.84),('15087','2014-03-15','12:45:00',3.83),('15087','2014-03-15','12:50:00',3.85),('15087','2014-03-15','12:55:00',3.73),('15087','2014-03-15','13:00:00',3.69),('15087','2014-03-15','13:05:00',3.76),('15087','2014-03-15','13:10:00',3.73),('15087','2014-03-15','13:15:00',3.65),('15087','2014-03-15','13:20:00',3.55),('15087','2014-03-15','13:25:00',3.5),('15087','2014-03-15','13:30:00',3.44),('15087','2014-03-15','13:35:00',3.33),('15087','2014-03-15','13:40:00',3.42),('15087','2014-03-15','13:45:00',3.29),('15087','2014-03-15','13:50:00',3.19),('15087','2014-03-15','13:55:00',3.35),('15087','2014-03-15','14:00:00',3.15),('15087','2014-03-15','14:05:00',3.1),('15087','2014-03-15','14:10:00',3.21),('15087','2014-03-15','14:15:00',3.03),('15087','2014-03-15','14:20:00',2.88),('15087','2014-03-15','14:25:00',2.99),('15087','2014-03-15','14:30:00',2.81),('15087','2014-03-15','14:35:00',2.87),('15087','2014-03-15','14:40:00',2.72),('15087','2014-03-15','14:45:00',2.64),('15087','2014-03-15','14:50:00',2.58),('15087','2014-03-15','14:55:00',2.62),('15087','2014-03-15','15:00:00',2.52),('15087','2014-03-15','15:05:00',2.43),('15087','2014-03-15','15:10:00',2.33),('15087','2014-03-15','15:15:00',2.26),('15087','2014-03-15','15:20:00',2.15),('15087','2014-03-15','15:25:00',2.11),('15087','2014-03-15','15:30:00',1.99),('15087','2014-03-15','15:35:00',1.92),('15087','2014-03-15','15:40:00',1.86),('15087','2014-03-15','15:45:00',1.8),('15087','2014-03-15','15:50:00',1.77),('15087','2014-03-15','15:55:00',1.68),('15087','2014-03-15','16:00:00',1.52),('15087','2014-03-15','16:05:00',1.41),('15087','2014-03-15','16:10:00',1.35),('15087','2014-03-15','16:15:00',1.27),('15087','2014-03-15','16:20:00',1.19),('15087','2014-03-15','16:25:00',1.05),('15087','2014-03-14','08:15:00',1.05),('15087','2014-03-14','08:20:00',1.18),('15087','2014-03-14','08:25:00',1.24),('15087','2014-03-14','08:30:00',1.33),('15087','2014-03-14','08:35:00',1.32),('15087','2014-03-14','08:40:00',1.29),('15087','2014-03-14','08:45:00',1.08),('15087','2014-03-14','08:50:00',1.03),('15087','2014-03-14','08:55:00',1.06),('15087','2014-03-14','09:00:00',1.18),('15087','2014-03-14','09:05:00',1.41),('15087','2014-03-14','09:10:00',1.58),('15087','2014-03-14','09:15:00',1.65),('15087','2014-03-14','09:20:00',1.59),('15087','2014-03-14','09:25:00',1.67),('15087','2014-03-14','09:30:00',1.68),('15087','2014-03-14','09:35:00',1.96),('15087','2014-03-14','09:40:00',2.45),('15087','2014-03-14','09:45:00',2.82),('15087','2014-03-14','09:50:00',3.32),('15087','2014-03-14','09:55:00',3.52),('15087','2014-03-14','10:00:00',3.64),('15087','2014-03-14','10:05:00',3.66),('15087','2014-03-14','10:10:00',3.6),('15087','2014-03-14','10:15:00',3.55),('15087','2014-03-14','10:20:00',3.48),('15087','2014-03-14','10:25:00',3.3),('15087','2014-03-14','10:30:00',3.3),('15087','2014-03-14','10:35:00',3.47),('15087','2014-03-14','10:40:00',3.61),('15087','2014-03-14','10:45:00',3.14),('15087','2014-03-14','10:50:00',2.08),('15087','2014-03-14','10:55:00',2.81),('15087','2014-03-14','11:00:00',3.37),('15087','2014-03-14','11:05:00',3.58),('15087','2014-03-14','11:10:00',3.9),('15087','2014-03-14','11:15:00',4.01),('15087','2014-03-14','11:20:00',3.85),('15087','2014-03-14','11:25:00',3.75),('15087','2014-03-14','11:30:00',3.72),('15087','2014-03-14','11:35:00',3.78),('15087','2014-03-14','11:40:00',3.78),('15087','2014-03-14','11:45:00',3.91),('15087','2014-03-14','11:50:00',4.03),('15087','2014-03-14','11:55:00',4.01),('15087','2014-03-14','12:00:00',4.03),('15087','2014-03-14','12:05:00',3.94),('15087','2014-03-14','12:10:00',3.71),('15087','2014-03-14','12:15:00',3.65),('15087','2014-03-14','12:20:00',3.04),('15087','2014-03-14','12:25:00',2.56),('15087','2014-03-14','12:30:00',2.42),('15087','2014-03-14','12:35:00',1.96),('15087','2014-03-14','12:40:00',2.35),('15087','2014-03-14','12:45:00',2.58),('15087','2014-03-14','12:50:00',3.08),('15087','2014-03-14','12:55:00',3.36),('15087','2014-03-14','13:00:00',2.21),('15087','2014-03-14','13:05:00',2.01),('15087','2014-03-14','13:10:00',2.44),('15087','2014-03-14','13:15:00',2.62),('15087','2014-03-14','13:20:00',2.99),('15087','2014-03-14','13:25:00',2.73),('15087','2014-03-14','13:30:00',2.47),('15087','2014-03-14','13:35:00',2.18),('15087','2014-03-14','13:40:00',2.14),('15087','2014-03-14','13:45:00',2.21),('15087','2014-03-14','13:50:00',2.25),('15087','2014-03-14','13:55:00',2.12),('15087','2014-03-14','14:00:00',2.48),('15087','2014-03-14','14:05:00',2.82),('15087','2014-03-14','14:10:00',2.69),('15087','2014-03-14','14:15:00',2.87),('15087','2014-03-14','14:20:00',2.81),('15087','2014-03-14','14:25:00',2.56),('15087','2014-03-14','14:30:00',2.57),('15087','2014-03-14','14:35:00',2.47),('15087','2014-03-14','14:40:00',2.05),('15087','2014-03-14','14:45:00',1.67),('15087','2014-03-14','14:50:00',1.5),('15087','2014-03-14','14:55:00',1.37),('15087','2014-03-14','15:00:00',1.26),('15087','2014-03-14','15:05:00',1.26),('15087','2014-03-14','15:10:00',1.19),('15087','2014-03-14','15:15:00',1.15),('15087','2014-03-14','15:20:00',1.23),('15087','2014-03-14','15:25:00',1.33),('15087','2014-03-14','15:30:00',1.39),('15087','2014-03-14','15:35:00',1.7),('15087','2014-03-14','15:40:00',1.54),('15087','2014-03-14','15:45:00',1.26),('15087','2014-03-14','15:50:00',1.11),('15087','2014-03-14','15:55:00',1.13),('15087','2014-03-14','16:00:00',1.06),('15087','2014-03-14','16:05:00',1.06),('15087','2014-03-13','07:50:00',1.16),('15087','2014-03-13','07:55:00',1.31),('15087','2014-03-13','08:00:00',1.43),('15087','2014-03-13','08:05:00',1.52),('15087','2014-03-13','08:10:00',1.62),('15087','2014-03-13','08:15:00',1.7),('15087','2014-03-13','08:20:00',1.78),('15087','2014-03-13','08:25:00',1.87),('15087','2014-03-13','08:30:00',1.96),('15087','2014-03-13','08:35:00',2.04),('15087','2014-03-13','08:40:00',2.15),('15087','2014-03-13','08:45:00',2.23),('15087','2014-03-13','08:50:00',2.33),('15087','2014-03-13','08:55:00',2.42),('15087','2014-03-13','09:00:00',2.51),('15087','2014-03-13','09:05:00',2.56),('15087','2014-03-13','09:10:00',2.67),('15087','2014-03-13','09:15:00',2.74),('15087','2014-03-13','09:20:00',2.8),('15087','2014-03-13','09:25:00',2.86),('15087','2014-03-13','09:30:00',2.94),('15087','2014-03-13','09:35:00',3.02),('15087','2014-03-13','09:40:00',3.09),('15087','2014-03-13','09:45:00',3.16),('15087','2014-03-13','09:50:00',3.24),('15087','2014-03-13','09:55:00',3.31),('15087','2014-03-13','10:00:00',3.38),('15087','2014-03-13','10:05:00',3.44),('15087','2014-03-13','10:10:00',3.49),('15087','2014-03-13','10:15:00',3.55),('15087','2014-03-13','10:20:00',3.58),('15087','2014-03-13','10:25:00',3.61),('15087','2014-03-13','10:30:00',3.65),('15087','2014-03-13','10:35:00',3.68),('15087','2014-03-13','10:40:00',3.72),('15087','2014-03-13','10:45:00',3.75),('15087','2014-03-13','10:50:00',3.79),('15087','2014-03-13','10:55:00',3.84),('15087','2014-03-13','11:00:00',3.87),('15087','2014-03-13','11:05:00',3.89),('15087','2014-03-13','11:10:00',3.91),('15087','2014-03-13','11:15:00',3.93),('15087','2014-03-13','11:20:00',3.94),('15087','2014-03-13','11:25:00',4.01),('15087','2014-03-13','11:30:00',4.01),('15087','2014-03-13','11:35:00',4.02),('15087','2014-03-13','11:40:00',4.03),('15087','2014-03-13','11:45:00',4.05),('15087','2014-03-13','11:50:00',3.99),('15087','2014-03-13','11:55:00',4.08),('15087','2014-03-13','12:00:00',4.1),('15087','2014-03-13','12:05:00',4.1),('15087','2014-03-13','12:10:00',4.05),('15087','2014-03-13','12:15:00',4.06),('15087','2014-03-13','12:20:00',4.02),('15087','2014-03-13','12:25:00',4.01),('15087','2014-03-13','12:30:00',4),('15087','2014-03-13','12:35:00',4.02),('15087','2014-03-13','12:40:00',3.99),('15087','2014-03-13','12:45:00',3.96),('15087','2014-03-13','12:50:00',3.93),('15087','2014-03-13','12:55:00',3.83),('15087','2014-03-13','13:00:00',3.48),('15087','2014-03-13','13:05:00',3.56),('15087','2014-03-13','13:10:00',3.72),('15087','2014-03-13','13:15:00',3.63),('15087','2014-03-13','13:20:00',3.61),('15087','2014-03-13','13:25:00',3.61),('15087','2014-03-13','13:30:00',3.63),('15087','2014-03-13','13:35:00',3.48),('15087','2014-03-13','13:40:00',3.35),('15087','2014-03-13','13:45:00',2.98),('15087','2014-03-13','13:50:00',3.06),('15087','2014-03-13','13:55:00',3.15),('15087','2014-03-13','14:00:00',2.75),('15087','2014-03-13','14:05:00',2.94),('15087','2014-03-13','14:10:00',3.05),('15087','2014-03-13','14:15:00',2.85),('15087','2014-03-13','14:20:00',2.93),('15087','2014-03-13','14:25:00',2.85),('15087','2014-03-13','14:30:00',2.73),('15087','2014-03-13','14:35:00',2.76),('15087','2014-03-13','14:40:00',2.62),('15087','2014-03-13','14:45:00',2.62),('15087','2014-03-13','14:50:00',2.59),('15087','2014-03-13','14:55:00',2.59),('15087','2014-03-13','15:00:00',2.48),('15087','2014-03-13','15:05:00',2.4),('15087','2014-03-13','15:10:00',2.32),('15087','2014-03-13','15:15:00',2.06),('15087','2014-03-13','15:20:00',1.94),('15087','2014-03-13','15:25:00',1.99),('15087','2014-03-13','15:30:00',1.87),('15087','2014-03-13','15:35:00',1.83),('15087','2014-03-13','15:40:00',1.78),('15087','2014-03-13','15:45:00',1.71),('15087','2014-03-13','15:50:00',1.72),('15087','2014-03-13','15:55:00',1.62),('15087','2014-03-13','16:00:00',1.49),('15087','2014-03-13','16:05:00',1.38),('15087','2014-03-13','16:10:00',1.33),('15087','2014-03-13','16:15:00',1.24),('15087','2014-03-13','16:20:00',1.15),('15087','2014-03-13','16:25:00',1.03),('15087','2014-03-12','07:50:00',1.06),('15087','2014-03-12','07:55:00',1.16),('15087','2014-03-12','08:00:00',1.29),('15087','2014-03-12','08:05:00',1.42),('15087','2014-03-12','08:10:00',1.52),('15087','2014-03-12','08:15:00',1.63),('15087','2014-03-12','08:20:00',1.72),('15087','2014-03-12','08:25:00',1.82),('15087','2014-03-12','08:30:00',1.92),('15087','2014-03-12','08:35:00',2.02),('15087','2014-03-12','08:40:00',2.11),('15087','2014-03-12','08:45:00',2.21),('15087','2014-03-12','08:50:00',2.29),('15087','2014-03-12','08:55:00',2.39),('15087','2014-03-12','09:00:00',2.47),('15087','2014-03-12','09:05:00',2.52),('15087','2014-03-12','09:10:00',2.63),('15087','2014-03-12','09:15:00',2.7),('15087','2014-03-12','09:20:00',2.79),('15087','2014-03-12','09:25:00',2.87),('15087','2014-03-12','09:30:00',2.94),('15087','2014-03-12','09:35:00',2.99),('15087','2014-03-12','09:40:00',3.06),('15087','2014-03-12','09:45:00',3.12),('15087','2014-03-12','09:50:00',3.18),('15087','2014-03-12','09:55:00',3.25),('15087','2014-03-12','10:00:00',3.32),('15087','2014-03-12','10:05:00',3.38),('15087','2014-03-12','10:10:00',3.44),('15087','2014-03-12','10:15:00',3.51),('15087','2014-03-12','10:20:00',3.54),('15087','2014-03-12','10:25:00',3.58),('15087','2014-03-12','10:30:00',3.65),('15087','2014-03-12','10:35:00',3.7),('15087','2014-03-12','10:40:00',3.77),('15087','2014-03-12','10:45:00',3.82),('15087','2014-03-12','10:50:00',3.85),('15087','2014-03-12','10:55:00',3.88),('15087','2014-03-12','11:00:00',3.93),('15087','2014-03-12','11:05:00',3.98),('15087','2014-03-12','11:10:00',4.02),('15087','2014-03-12','11:15:00',4.07),('15087','2014-03-12','11:20:00',4),('15087','2014-03-12','11:25:00',4.09),('15087','2014-03-12','11:30:00',4.11),('15087','2014-03-12','11:35:00',4.12),('15087','2014-03-12','11:40:00',4.14),('15087','2014-03-12','11:45:00',4.14),('15087','2014-03-12','11:50:00',4.13),('15087','2014-03-12','11:55:00',4.18),('15087','2014-03-12','12:00:00',4.16),('15087','2014-03-12','12:05:00',4.14),('15087','2014-03-12','12:10:00',4.14),('15087','2014-03-12','12:15:00',4.14),('15087','2014-03-12','12:20:00',4.14),('15087','2014-03-12','12:25:00',4.15),('15087','2014-03-12','12:30:00',4.13),('15087','2014-03-12','12:35:00',4.11),('15087','2014-03-12','12:40:00',4.11),('15087','2014-03-12','12:45:00',4.07),('15087','2014-03-12','12:50:00',4.1),('15087','2014-03-12','12:55:00',3.99),('15087','2014-03-12','13:00:00',3.9),('15087','2014-03-12','13:05:00',3.95),('15087','2014-03-12','13:10:00',3.93),('15087','2014-03-12','13:15:00',3.76),('15087','2014-03-12','13:20:00',3.6),('15087','2014-03-12','13:25:00',3.72),('15087','2014-03-12','13:30:00',3.72),('15087','2014-03-12','13:35:00',3.46),('15087','2014-03-12','13:40:00',3.51),('15087','2014-03-12','13:45:00',3.51),('15087','2014-03-12','13:50:00',3.37),('15087','2014-03-12','13:55:00',3.32),('15087','2014-03-12','14:00:00',3.4),('15087','2014-03-12','14:05:00',3.35),('15087','2014-03-12','14:10:00',3.1),('15087','2014-03-12','14:15:00',2.74),('15087','2014-03-12','14:20:00',2.73),('15087','2014-03-12','14:25:00',3.01),('15087','2014-03-12','14:30:00',2.97),('15087','2014-03-12','14:35:00',2.76),('15087','2014-03-12','14:40:00',2.76),('15087','2014-03-12','14:45:00',2.75),('15087','2014-03-12','14:50:00',2.57),('15087','2014-03-12','14:55:00',2.57),('15087','2014-03-12','15:00:00',2.27),('15087','2014-03-12','15:05:00',2.39),('15087','2014-03-12','15:10:00',2.33),('15087','2014-03-12','15:15:00',2.21),('15087','2014-03-12','15:20:00',2.06),('15087','2014-03-12','15:25:00',1.96),('15087','2014-03-12','15:30:00',1.86),('15087','2014-03-12','15:35:00',1.8),('15087','2014-03-12','15:40:00',1.86),('15087','2014-03-12','15:45:00',1.84),('15087','2014-03-12','15:50:00',1.76),('15087','2014-03-12','15:55:00',1.65),('15087','2014-03-12','16:00:00',1.56),('15087','2014-03-12','16:05:00',1.42),('15087','2014-03-12','16:10:00',1.35),('15087','2014-03-12','16:15:00',1.28),('15087','2014-03-12','16:20:00',1.13),('15087','2014-03-12','16:25:00',1.08),('15087','2014-03-11','11:00:00',1.03),('15087','2014-03-11','11:05:00',1.08),('15087','2014-03-11','11:10:00',1.06),('15087','2014-03-11','11:15:00',1.09),('15087','2014-03-11','11:40:00',1.01),('15087','2014-03-11','11:45:00',1.07),('15087','2014-03-11','11:55:00',1.02),('15087','2014-03-11','12:00:00',1.08),('15087','2014-03-11','12:05:00',1.1),('15087','2014-03-11','12:10:00',1.13),('15087','2014-03-11','12:15:00',1.33),('15087','2014-03-11','12:20:00',1.43),('15087','2014-03-11','12:25:00',1.31),('15087','2014-03-11','12:30:00',1.28),('15087','2014-03-11','12:35:00',1.37),('15087','2014-03-11','12:40:00',1.52),('15087','2014-03-11','12:45:00',1.5),('15087','2014-03-11','12:50:00',1.41),('15087','2014-03-11','12:55:00',1.32),('15087','2014-03-11','13:00:00',1.26),('15087','2014-03-11','13:05:00',1.45),('15087','2014-03-11','13:10:00',1.45),('15087','2014-03-11','13:15:00',1.38),('15087','2014-03-11','13:20:00',1.43),('15087','2014-03-11','13:25:00',1.21),('15087','2014-03-11','13:30:00',1.19),('15087','2014-03-11','13:35:00',1.11),('15087','2014-03-11','13:40:00',1.15),('15087','2014-03-11','13:45:00',1.48),('15087','2014-03-11','13:50:00',1.74),('15087','2014-03-11','13:55:00',2.03),('15087','2014-03-11','14:00:00',2.13),('15087','2014-03-11','14:05:00',2.14),('15087','2014-03-11','14:10:00',2.6),('15087','2014-03-11','14:15:00',2.67),('15087','2014-03-11','14:20:00',2.57),('15087','2014-03-11','14:25:00',2.07),('15087','2014-03-11','14:30:00',1.54),('15087','2014-03-11','14:35:00',1.63),('15087','2014-03-11','14:40:00',1.54),('15087','2014-03-11','14:45:00',1.64),('15087','2014-03-11','14:50:00',1.48),('15087','2014-03-11','14:55:00',1.44),('15087','2014-03-11','15:00:00',1.67),('15087','2014-03-11','15:05:00',1.75),('15087','2014-03-11','15:10:00',1.98),('15087','2014-03-11','15:15:00',1.84),('15087','2014-03-11','15:20:00',1.95),('15087','2014-03-11','15:25:00',1.5),('15087','2014-03-11','15:30:00',1.39),('15087','2014-03-11','15:35:00',1.19),('15087','2014-03-11','15:40:00',1.13),('15087','2014-03-11','15:45:00',1.08),('15087','2014-03-11','15:50:00',1.08),('15087','2014-03-10','09:05:00',1.09),('15087','2014-03-10','09:10:00',1.11),('15087','2014-03-10','09:15:00',1.02),('15087','2014-03-10','09:25:00',1),('15087','2014-03-10','09:30:00',1.05),('15087','2014-03-10','09:35:00',1.08),('15087','2014-03-10','09:40:00',1.14),('15087','2014-03-10','09:45:00',1.02),('15087','2014-03-10','10:10:00',1.05),('15087','2014-03-10','10:15:00',1.26),('15087','2014-03-10','10:30:00',1.11),('15087','2014-03-10','10:35:00',1.35),('15087','2014-03-10','11:20:00',1.05),('15087','2014-03-10','12:45:00',1.05),('15087','2014-03-10','12:50:00',1.19),('15087','2014-03-10','12:55:00',1.29),('15087','2014-03-10','13:00:00',1.36),('15087','2014-03-10','13:05:00',1.39),('15087','2014-03-10','13:10:00',1.47),('15087','2014-03-10','13:15:00',1.61),('15087','2014-03-10','13:20:00',1.62),('15087','2014-03-10','13:25:00',1.46),('15087','2014-03-10','13:30:00',1.2),('15087','2014-03-10','13:50:00',1.24),('15087','2014-03-10','13:55:00',1.42),('15087','2014-03-10','14:00:00',1.24),('15087','2014-03-10','14:05:00',1.85),('15087','2014-03-10','14:10:00',2.26),('15087','2014-03-10','14:15:00',3.14),('15087','2014-03-10','14:20:00',2.29),('15087','2014-03-10','14:25:00',1.69),('15087','2014-03-10','14:30:00',1.45),('15087','2014-03-10','14:35:00',1.96),('15087','2014-03-10','14:40:00',2.59),('15087','2014-03-10','14:45:00',2.74),('15087','2014-03-10','14:50:00',2.64),('15087','2014-03-10','14:55:00',1.38),('15087','2014-03-10','15:00:00',1.72),('15087','2014-03-10','15:05:00',1.48),('15087','2014-03-10','15:15:00',1.47),('15087','2014-03-10','15:20:00',1.83),('15087','2014-03-10','15:25:00',2.32),('15087','2014-03-10','15:30:00',1.64),('15087','2014-03-10','15:35:00',1.23),('15087','2014-03-10','15:40:00',1.06),('15087','2014-03-09','07:55:00',1.03),('15087','2014-03-09','08:00:00',1.17),('15087','2014-03-09','08:05:00',1.29),('15087','2014-03-09','08:10:00',1.41),('15087','2014-03-09','08:15:00',1.53),('15087','2014-03-09','08:20:00',1.57),('15087','2014-03-09','08:25:00',1.56),('15087','2014-03-09','08:30:00',1.46),('15087','2014-03-09','08:35:00',1.27),('15087','2014-03-09','08:40:00',1.27),('15087','2014-03-09','08:45:00',1.19),('15087','2014-03-09','08:55:00',1.79),('15087','2014-03-09','09:00:00',2.3),('15087','2014-03-09','09:05:00',1.93),('15087','2014-03-09','09:15:00',2.69),('15087','2014-03-09','09:20:00',2.78),('15087','2014-03-09','09:25:00',2.86),('15087','2014-03-09','09:30:00',3.05),('15087','2014-03-09','09:35:00',3.23),('15087','2014-03-09','09:40:00',3.28),('15087','2014-03-09','09:45:00',3.35),('15087','2014-03-09','09:50:00',3.39),('15087','2014-03-09','09:55:00',3.39),('15087','2014-03-09','10:00:00',3.41),('15087','2014-03-09','10:05:00',3.47),('15087','2014-03-09','10:10:00',3.57),('15087','2014-03-09','10:15:00',3.61),('15087','2014-03-09','10:20:00',3.6),('15087','2014-03-09','10:25:00',3.51),('15087','2014-03-09','10:30:00',3.76),('15087','2014-03-09','10:35:00',3.79),('15087','2014-03-09','10:40:00',3.8),('15087','2014-03-09','10:45:00',3.85),('15087','2014-03-09','10:50:00',3.96),('15087','2014-03-09','10:55:00',4.06),('15087','2014-03-09','11:00:00',4.29),('15087','2014-03-09','11:05:00',4.17),('15087','2014-03-09','11:10:00',4.46),('15087','2014-03-09','11:15:00',4.55),('15087','2014-03-09','11:20:00',3.06),('15087','2014-03-09','11:25:00',2.07),('15087','2014-03-09','11:30:00',1.43),('15087','2014-03-09','11:35:00',2.05),('15087','2014-03-09','11:40:00',2.08),('15087','2014-03-09','11:45:00',1.84),('15087','2014-03-09','11:50:00',3.6),('15087','2014-03-09','11:55:00',3.54),('15087','2014-03-09','12:00:00',4.05),('15087','2014-03-09','12:05:00',4.67),('15087','2014-03-09','12:10:00',4.84),('15087','2014-03-09','12:15:00',4.75),('15087','2014-03-09','12:20:00',4.7),('15087','2014-03-09','12:25:00',4.62),('15087','2014-03-09','12:30:00',4.64),('15087','2014-03-09','12:35:00',4.78),('15087','2014-03-09','12:40:00',4.52),('15087','2014-03-09','12:45:00',4.41),('15087','2014-03-09','12:50:00',4.44),('15087','2014-03-09','12:55:00',4.45),('15087','2014-03-09','13:00:00',4.49),('15087','2014-03-09','13:05:00',4.54),('15087','2014-03-09','13:10:00',4.45),('15087','2014-03-09','13:15:00',4.15),('15087','2014-03-09','13:20:00',3.99),('15087','2014-03-09','13:25:00',3.8),('15087','2014-03-09','13:30:00',3.84),('15087','2014-03-09','13:35:00',3.68),('15087','2014-03-09','13:40:00',1.07),('15087','2014-03-09','13:45:00',1.16),('15087','2014-03-09','13:50:00',2.36),('15087','2014-03-09','13:55:00',1.06),('15087','2014-03-09','14:00:00',1.93),('15087','2014-03-09','14:05:00',3.35),('15087','2014-03-09','14:10:00',3.37),('15087','2014-03-09','14:15:00',3.19),('15087','2014-03-09','14:20:00',1.58),('15087','2014-03-09','14:25:00',3.15),('15087','2014-03-09','14:30:00',1.29),('15087','2014-03-09','14:45:00',2.28),('15087','2014-03-09','14:50:00',1.45),('15087','2014-03-09','14:55:00',2.84),('15087','2014-03-09','15:00:00',2.72),('15087','2014-03-09','15:05:00',2.39),('15087','2014-03-09','15:10:00',2.32),('15087','2014-03-09','15:15:00',2.38),('15087','2014-03-09','15:20:00',2.37),('15087','2014-03-09','15:25:00',2.25),('15087','2014-03-09','15:30:00',2.22),('15087','2014-03-09','15:35:00',2.09),('15087','2014-03-09','15:40:00',2.02),('15087','2014-03-09','15:45:00',1.71),('15087','2014-03-09','15:55:00',1.51),('15087','2014-03-09','16:00:00',1.7),('15087','2014-03-09','16:05:00',1.57),('15087','2014-03-09','16:10:00',1.17),('15087','2014-03-09','16:15:00',1.11),('15087','2014-03-09','16:25:00',1.12),('15087','2014-03-09','16:30:00',1.04),('15087','2014-03-09','16:40:00',1.01),('15087','2014-03-08','07:55:00',1.04),('15087','2014-03-08','08:00:00',1.17),('15087','2014-03-08','08:05:00',1.3),('15087','2014-03-08','08:10:00',1.39),('15087','2014-03-08','08:15:00',1.5),('15087','2014-03-08','08:20:00',1.61),('15087','2014-03-08','08:25:00',1.71),('15087','2014-03-08','08:30:00',1.81),('15087','2014-03-08','08:35:00',1.91),('15087','2014-03-08','08:40:00',2.01),('15087','2014-03-08','08:45:00',2.1),('15087','2014-03-08','08:50:00',2.2),('15087','2014-03-08','08:55:00',2.29),('15087','2014-03-08','09:00:00',2.38),('15087','2014-03-08','09:05:00',2.47),('15087','2014-03-08','09:10:00',2.55),('15087','2014-03-08','09:15:00',2.62),('15087','2014-03-08','09:20:00',2.71),('15087','2014-03-08','09:25:00',2.79),('15087','2014-03-08','09:30:00',2.88),('15087','2014-03-08','09:35:00',2.94),('15087','2014-03-08','09:40:00',3),('15087','2014-03-08','09:45:00',3.07),('15087','2014-03-08','09:50:00',3.15),('15087','2014-03-08','09:55:00',3.2),('15087','2014-03-08','10:00:00',3.28),('15087','2014-03-08','10:05:00',3.34),('15087','2014-03-08','10:10:00',3.4),('15087','2014-03-08','10:15:00',3.47),('15087','2014-03-08','10:20:00',3.53),('15087','2014-03-08','10:25:00',3.57),('15087','2014-03-08','10:30:00',3.65),('15087','2014-03-08','10:35:00',3.7),('15087','2014-03-08','10:40:00',3.75),('15087','2014-03-08','10:45:00',3.8),('15087','2014-03-08','10:50:00',3.83),('15087','2014-03-08','10:55:00',3.84),('15087','2014-03-08','11:00:00',3.87),('15087','2014-03-08','11:05:00',3.91),('15087','2014-03-08','11:10:00',3.93),('15087','2014-03-08','11:15:00',4),('15087','2014-03-08','11:20:00',4.07),('15087','2014-03-08','11:25:00',4.19),('15087','2014-03-08','11:30:00',4.4),('15087','2014-03-08','11:35:00',4.28),('15087','2014-03-08','11:40:00',2.55),('15087','2014-03-08','11:45:00',2.11),('15087','2014-03-08','11:50:00',1.6),('15087','2014-03-08','11:55:00',2.96),('15087','2014-03-08','12:00:00',2.35),('15087','2014-03-08','12:05:00',1.03),('15087','2014-03-08','12:10:00',1.07),('15087','2014-03-08','12:15:00',1.14),('15087','2014-03-08','12:20:00',1.37),('15087','2014-03-08','12:25:00',1.57),('15087','2014-03-08','12:30:00',1.69),('15087','2014-03-08','12:35:00',3.6),('15087','2014-03-08','12:40:00',2.15),('15087','2014-03-08','12:45:00',2.38),('15087','2014-03-08','12:50:00',2.31),('15087','2014-03-08','12:55:00',3.44),('15087','2014-03-08','13:00:00',2.29),('15087','2014-03-08','13:05:00',1.83),('15087','2014-03-08','13:10:00',1.61),('15087','2014-03-08','13:15:00',1.24),('15087','2014-03-08','13:20:00',1.02),('15087','2014-03-08','13:25:00',1.05),('15087','2014-03-08','13:30:00',1.68),('15087','2014-03-08','13:35:00',1.8),('15087','2014-03-08','13:40:00',2.36),('15087','2014-03-08','13:45:00',2.69),('15087','2014-03-08','13:50:00',2.48),('15087','2014-03-08','13:55:00',1.51),('15087','2014-03-08','14:00:00',1.14),('15087','2014-03-08','14:05:00',1.08),('15087','2014-03-08','14:10:00',1),('15087','2014-03-08','14:40:00',1.04),('15087','2014-03-08','14:50:00',1),('15087','2014-03-08','14:55:00',1.06),('15087','2014-03-08','15:15:00',1.26),('15087','2014-03-08','15:20:00',1.62),('15087','2014-03-08','15:25:00',1.49),('15087','2014-03-08','15:30:00',1.77),('15087','2014-03-08','16:35:00',1.1),('15087','2014-04-30','07:40:00',1.01),('15087','2014-04-30','07:45:00',1.1),('15087','2014-04-30','07:50:00',1.2),('15087','2014-04-30','07:55:00',1.31),('15087','2014-04-30','08:00:00',1.43),('15087','2014-04-30','08:05:00',1.52),('15087','2014-04-30','08:10:00',1.67),('15087','2014-04-30','08:15:00',1.77),('15087','2014-04-30','08:20:00',1.85),('15087','2014-04-30','08:25:00',1.94),('15087','2014-04-30','08:30:00',2.03),('15087','2014-04-30','08:35:00',2.13),('15087','2014-04-30','08:40:00',2.22),('15087','2014-04-30','08:45:00',2.3),('15087','2014-04-30','08:50:00',2.2),('15087','2014-04-30','08:55:00',2.46),('15087','2014-04-30','09:00:00',2.6),('15087','2014-04-30','09:05:00',2.92),('15087','2014-04-30','09:10:00',2.78),('15087','2014-04-30','09:15:00',1.39),('15087','2014-04-30','09:20:00',2.21),('15087','2014-04-30','09:25:00',2.25),('15087','2014-04-30','09:30:00',2.05),('15087','2014-04-30','09:35:00',3.32),('15087','2014-04-30','09:40:00',3.43),('15087','2014-04-30','09:45:00',2.73),('15087','2014-04-30','09:50:00',2.24),('15087','2014-04-30','09:55:00',3.42),('15087','2014-04-30','10:00:00',3.99),('15087','2014-04-30','10:05:00',2.74),('15087','2014-04-30','10:10:00',3.06),('15087','2014-04-30','10:15:00',2.62),('15087','2014-04-30','10:20:00',1.88),('15087','2014-04-30','10:25:00',1.84),('15087','2014-04-30','10:30:00',2.22),('15087','2014-04-30','10:35:00',2.36),('15087','2014-04-30','10:40:00',2.4),('15087','2014-04-30','10:45:00',1.76),('15087','2014-04-30','10:50:00',2.17),('15087','2014-04-30','10:55:00',4.53),('15087','2014-04-30','11:00:00',4.56),('15087','2014-04-30','11:05:00',3.55),('15087','2014-04-30','11:10:00',3.18),('15087','2014-04-30','11:15:00',2.29),('15087','2014-04-30','11:20:00',2.39),('15087','2014-04-30','11:25:00',2.55),('15087','2014-04-30','11:30:00',2.46),('15087','2014-04-30','11:35:00',3.94),('15087','2014-04-30','11:40:00',3.11),('15087','2014-04-30','11:45:00',3.56),('15087','2014-04-30','11:50:00',4.14),('15087','2014-04-30','11:55:00',3.67),('15087','2014-04-30','12:00:00',2.96),('15087','2014-04-30','12:05:00',1.48),('15087','2014-04-30','12:10:00',1.48),('15087','2014-04-30','12:15:00',2.01),('15087','2014-04-30','12:20:00',1.87),('15087','2014-04-30','12:25:00',1.66),('15087','2014-04-30','12:30:00',2.12),('15087','2014-04-30','12:35:00',2.12),('15087','2014-04-30','12:40:00',1.45),('15087','2014-04-30','12:45:00',1.43),('15087','2014-04-30','12:50:00',2.28),('15087','2014-04-30','12:55:00',4.78),('15087','2014-04-30','13:00:00',4.18),('15087','2014-04-30','13:05:00',3.02),('15087','2014-04-30','13:10:00',3.95),('15087','2014-04-30','13:15:00',2.48),('15087','2014-04-30','13:20:00',2.55),('15087','2014-04-30','13:25:00',3.97),('15087','2014-04-30','13:30:00',2.08),('15087','2014-04-30','13:35:00',2.51),('15087','2014-04-30','13:40:00',4.1),('15087','2014-04-30','13:45:00',3.83),('15087','2014-04-30','13:50:00',3.34),('15087','2014-04-30','13:55:00',3.79),('15087','2014-04-30','14:00:00',2.25),('15087','2014-04-30','14:05:00',2.01),('15087','2014-04-30','14:10:00',1.74),('15087','2014-04-30','14:15:00',2.12),('15087','2014-04-30','14:20:00',4.18),('15087','2014-04-30','14:25:00',4.48),('15087','2014-04-30','14:30:00',5.03),('15087','2014-04-30','14:35:00',3.89),('15087','2014-04-30','14:40:00',2.23),('15087','2014-04-30','14:45:00',1.52),('15087','2014-04-30','14:50:00',1.84),('15087','2014-04-30','14:55:00',2.04),('15087','2014-04-30','15:00:00',1.64),('15087','2014-04-30','15:05:00',1.61),('15087','2014-04-30','15:10:00',1.85),('15087','2014-04-30','15:15:00',1.42),('15087','2014-04-30','15:20:00',1.3),('15087','2014-04-30','15:25:00',1.47),('15087','2014-04-30','15:30:00',1.94),('15087','2014-04-30','15:35:00',3.57),('15087','2014-04-30','15:40:00',4.8),('15087','2014-04-30','15:45:00',3.86),('15087','2014-04-30','15:50:00',4.01),('15087','2014-04-30','15:55:00',2.68),('15087','2014-04-30','16:00:00',1.5),('15087','2014-04-30','16:05:00',1.86),('15087','2014-04-30','16:10:00',2.31),('15087','2014-04-30','16:15:00',3.03),('15087','2014-04-30','16:20:00',1.72),('15087','2014-04-30','16:25:00',2.11),('15087','2014-04-30','16:30:00',2.08),('15087','2014-04-30','16:35:00',1.46),('15087','2014-04-30','16:40:00',2.45),('15087','2014-04-30','16:45:00',1.71),('15087','2014-04-30','16:50:00',2.68),('15087','2014-04-30','16:55:00',2.56),('15087','2014-04-30','17:00:00',1.92),('15087','2014-04-30','17:05:00',1.61),('15087','2014-04-30','17:20:00',1.07),('15087','2014-04-30','17:35:00',1.07),('15087','2014-04-30','17:40:00',1.09),('15087','2014-03-07','11:20:00',1.02),('15087','2014-03-07','11:25:00',1.02),('15087','2014-03-07','11:30:00',1.14),('15087','2014-03-07','11:35:00',1.08),('15087','2014-03-07','11:45:00',1.89),('15087','2014-03-07','11:50:00',3.46),('15087','2014-03-07','11:55:00',4.06),('15087','2014-03-07','12:00:00',5.01),('15087','2014-03-07','12:05:00',4.28),('15087','2014-03-07','12:10:00',4.63),('15087','2014-03-07','12:15:00',4.48),('15087','2014-03-07','12:20:00',4.5),('15087','2014-03-07','12:25:00',4.5),('15087','2014-03-07','12:30:00',2.48),('15087','2014-03-07','12:35:00',3.7),('15087','2014-03-07','12:40:00',2.77),('15087','2014-03-07','12:50:00',1.44),('15087','2014-03-07','13:00:00',3.47),('15087','2014-03-07','13:05:00',3.56),('15087','2014-03-07','13:10:00',1.81),('15087','2014-03-07','13:15:00',1.26),('15087','2014-03-07','13:20:00',2.68),('15087','2014-03-07','13:25:00',3.58),('15087','2014-03-07','13:30:00',3.33),('15087','2014-03-07','13:35:00',2.75),('15087','2014-03-07','13:40:00',2.69),('15087','2014-03-07','13:45:00',2.42),('15087','2014-03-07','13:50:00',1.66),('15087','2014-03-07','13:55:00',1.28),('15087','2014-03-07','14:00:00',1.22),('15087','2014-03-07','14:05:00',1.14),('15087','2014-03-07','14:10:00',1.16),('15087','2014-03-07','14:15:00',1.15),('15087','2014-03-07','14:20:00',1.13),('15087','2014-03-07','14:25:00',1.09),('15087','2014-03-07','14:30:00',1.16),('15087','2014-03-07','14:35:00',1.23),('15087','2014-03-07','14:40:00',1.37),('15087','2014-03-07','14:45:00',1.39),('15087','2014-03-07','14:50:00',1.79),('15087','2014-03-07','14:55:00',2.42),('15087','2014-03-07','15:00:00',2.83),('15087','2014-03-07','15:05:00',3.04),('15087','2014-03-07','15:10:00',3.09),('15087','2014-03-07','15:15:00',3.15),('15087','2014-03-07','15:20:00',3.1),('15087','2014-03-07','15:25:00',2.83),('15087','2014-03-07','15:30:00',2.77),('15087','2014-03-07','15:35:00',2.49),('15087','2014-03-07','15:40:00',1.97),('15087','2014-03-07','15:45:00',2.21),('15087','2014-03-07','15:50:00',1.76),('15087','2014-03-07','15:55:00',1.39),('15087','2014-03-07','16:00:00',1.71),('15087','2014-03-07','16:05:00',1.6),('15087','2014-03-07','16:10:00',1.56),('15087','2014-03-07','16:15:00',1.6),('15087','2014-03-07','16:20:00',1.41),('15087','2014-03-07','16:25:00',1.33),('15087','2014-03-07','16:30:00',1.23),('15087','2014-03-07','16:35:00',1.14),('15087','2014-03-07','16:40:00',1.21),('15087','2014-03-07','16:45:00',1.18),('15087','2014-03-07','16:50:00',1.06),('15087','2014-03-07','16:55:00',1.01),('15087','2014-03-05','07:45:00',1.16),('15087','2014-03-05','07:50:00',1.28),('15087','2014-03-05','07:55:00',1.37),('15087','2014-03-05','08:00:00',1.21),('15087','2014-03-05','08:05:00',1.45),('15087','2014-03-05','08:10:00',1.59),('15087','2014-03-05','08:15:00',1.78),('15087','2014-03-05','08:20:00',1.02),('15087','2014-03-05','08:35:00',2.56),('15087','2014-03-05','08:40:00',2.19),('15087','2014-03-05','08:45:00',2.52),('15087','2014-03-05','08:50:00',1.81),('15087','2014-03-05','09:00:00',2.04),('15087','2014-03-05','09:05:00',2.41),('15087','2014-03-05','09:10:00',1.23),('15087','2014-03-05','09:15:00',2.79),('15087','2014-03-05','09:20:00',2.8),('15087','2014-03-05','09:25:00',2.83),('15087','2014-03-05','09:30:00',2.9),('15087','2014-03-05','09:35:00',2.66),('15087','2014-03-05','09:40:00',3.04),('15087','2014-03-05','09:45:00',3.1),('15087','2014-03-05','09:50:00',3.14),('15087','2014-03-05','09:55:00',3.23),('15087','2014-03-05','10:00:00',3.3),('15087','2014-03-05','10:05:00',3.37),('15087','2014-03-05','10:10:00',3.45),('15087','2014-03-05','10:15:00',3.48),('15087','2014-03-05','10:20:00',3.49),('15087','2014-03-05','10:25:00',3.56),('15087','2014-03-05','10:30:00',3.59),('15087','2014-03-05','10:35:00',3.66),('15087','2014-03-05','10:40:00',3.69),('15087','2014-03-05','10:45:00',3.7),('15087','2014-03-05','10:50:00',3.76),('15087','2014-03-05','10:55:00',3.82),('15087','2014-03-05','11:00:00',3.84),('15087','2014-03-05','11:05:00',3.92),('15087','2014-03-05','11:10:00',3.95),('15087','2014-03-05','11:15:00',4.04),('15087','2014-03-05','11:20:00',4.09),('15087','2014-03-05','11:25:00',4.14),('15087','2014-03-05','11:30:00',4.17),('15087','2014-03-05','11:35:00',4.32),('15087','2014-03-05','11:40:00',4.09),('15087','2014-03-05','11:45:00',4.28),('15087','2014-03-05','11:50:00',4.2),('15087','2014-03-05','11:55:00',3.57),('15087','2014-03-05','12:00:00',3.72),('15087','2014-03-05','12:05:00',3.37),('15087','2014-03-05','12:10:00',2.56),('15087','2014-03-05','12:15:00',1.08),('15087','2014-03-05','12:30:00',1.28),('15087','2014-03-05','12:35:00',2.16),('15087','2014-03-05','12:40:00',2.05),('15087','2014-03-05','12:45:00',1.14),('15087','2014-03-05','12:50:00',1.54),('15087','2014-03-05','12:55:00',1.55),('15087','2014-03-05','13:00:00',1.96),('15087','2014-03-05','13:05:00',2.97),('15087','2014-03-05','13:10:00',3.62),('15087','2014-03-05','13:15:00',2.47),('15087','2014-03-05','13:20:00',2.41),('15087','2014-03-05','13:25:00',1.81),('15087','2014-03-05','13:30:00',1.28),('15087','2014-03-05','13:35:00',1.33),('15087','2014-03-05','13:40:00',1.7),('15087','2014-03-05','13:45:00',1.62),('15087','2014-03-05','13:50:00',1.34),('15087','2014-03-05','13:55:00',1.17),('15087','2014-03-05','14:00:00',1.09),('15087','2014-03-05','14:05:00',1.14),('15087','2014-03-05','14:10:00',1.09),('15087','2014-03-05','14:15:00',1.22),('15087','2014-03-05','14:20:00',1.32),('15087','2014-03-05','14:25:00',1.55),('15087','2014-03-05','14:30:00',1.56),('15087','2014-03-05','14:35:00',1.27),('15087','2014-03-05','14:40:00',1.85),('15087','2014-03-05','14:45:00',2.86),('15087','2014-03-05','14:50:00',2.95),('15087','2014-03-05','14:55:00',2.1),('15087','2014-03-05','15:35:00',1.33),('15087','2014-03-05','15:40:00',1.8),('15087','2014-03-05','15:45:00',1.95),('15087','2014-03-05','15:50:00',1.4),('15087','2014-03-05','15:55:00',1.98),('15087','2014-03-05','16:00:00',2.63),('15087','2014-03-05','16:05:00',2.34),('15087','2014-03-05','16:10:00',1.99),('15087','2014-03-05','16:15:00',1.44),('15087','2014-03-04','09:05:00',1.15),('15087','2014-03-04','09:10:00',1.53),('15087','2014-03-04','09:15:00',2.47),('15087','2014-03-04','09:20:00',2.39),('15087','2014-03-04','09:30:00',1.03),('15087','2014-03-04','09:35:00',1.01),('15087','2014-03-04','09:40:00',1.22),('15087','2014-03-04','09:45:00',1.06),('15087','2014-03-04','09:55:00',2.02),('15087','2014-03-04','10:00:00',1.46),('15087','2014-03-04','10:20:00',1.04),('15087','2014-03-04','10:25:00',3.25),('15087','2014-03-04','10:30:00',1.99),('15087','2014-03-04','10:35:00',4.14),('15087','2014-03-04','10:40:00',4.53),('15087','2014-03-04','10:45:00',4.23),('15087','2014-03-04','10:50:00',1.14),('15087','2014-03-04','10:55:00',3.71),('15087','2014-03-04','11:00:00',2.37),('15087','2014-03-04','11:05:00',2.54),('15087','2014-03-04','11:10:00',4.62),('15087','2014-03-04','11:15:00',5.04),('15087','2014-03-04','11:20:00',2.79),('15087','2014-03-04','11:25:00',1.03),('15087','2014-03-04','11:30:00',1.06),('15087','2014-03-04','11:45:00',2.06),('15087','2014-03-04','11:50:00',5.12),('15087','2014-03-04','11:55:00',4.44),('15087','2014-03-04','12:00:00',4.33),('15087','2014-03-04','12:05:00',4.23),('15087','2014-03-04','12:10:00',4.23),('15087','2014-03-04','12:15:00',4.21),('15087','2014-03-04','12:20:00',4.23),('15087','2014-03-04','12:25:00',4.22),('15087','2014-03-04','12:30:00',4.12),('15087','2014-03-04','12:35:00',4.11),('15087','2014-03-04','12:40:00',4.16),('15087','2014-03-04','12:45:00',2.27),('15087','2014-03-04','12:50:00',3.52),('15087','2014-03-04','12:55:00',2.81),('15087','2014-03-04','13:00:00',4.03),('15087','2014-03-04','13:05:00',2.89),('15087','2014-03-04','13:10:00',4.34),('15087','2014-03-04','13:15:00',2.2),('15087','2014-03-04','13:20:00',1.92),('15087','2014-03-04','13:25:00',1.01),('15087','2014-03-04','13:30:00',1.07),('15087','2014-03-04','13:45:00',1.25),('15087','2014-03-04','13:50:00',1.44),('15087','2014-03-04','13:55:00',1.13),('15087','2014-03-04','14:05:00',2.02),('15087','2014-03-04','14:10:00',2.69),('15087','2014-03-04','14:15:00',3.46),('15087','2014-03-04','14:20:00',2.04),('15087','2014-03-04','14:25:00',3.47),('15087','2014-03-04','14:30:00',3.05),('15087','2014-03-04','14:35:00',2.89),('15087','2014-03-04','14:40:00',2.89),('15087','2014-03-04','14:45:00',2.66),('15087','2014-03-04','14:50:00',3),('15087','2014-03-04','14:55:00',1.99),('15087','2014-03-04','15:00:00',2.8),('15087','2014-03-04','15:05:00',2.58),('15087','2014-03-04','15:10:00',2.28),('15087','2014-03-04','15:15:00',2.11),('15087','2014-03-04','15:20:00',1.31),('15087','2014-03-04','15:25:00',1.89),('15087','2014-03-04','15:35:00',2.55),('15087','2014-03-04','15:40:00',2.1),('15087','2014-03-04','15:45:00',1.9),('15087','2014-03-04','15:50:00',1.6),('15087','2014-03-04','16:20:00',1.03),('15087','2014-03-04','16:25:00',1.25),('15087','2014-03-03','08:10:00',1.39),('15087','2014-03-03','08:15:00',1.52),('15087','2014-03-03','08:20:00',1.61),('15087','2014-03-03','08:25:00',1.69),('15087','2014-03-03','08:30:00',1.8),('15087','2014-03-03','08:35:00',1.88),('15087','2014-03-03','08:40:00',2),('15087','2014-03-03','08:45:00',2.09),('15087','2014-03-03','08:50:00',2.04),('15087','2014-03-03','08:55:00',2.31),('15087','2014-03-03','09:00:00',2.33),('15087','2014-03-03','09:05:00',2.33),('15087','2014-03-03','09:10:00',2.14),('15087','2014-03-03','09:15:00',2.32),('15087','2014-03-03','09:20:00',2.59),('15087','2014-03-03','09:25:00',2.72),('15087','2014-03-03','09:30:00',2.79),('15087','2014-03-03','09:35:00',2.51),('15087','2014-03-03','09:40:00',2.15),('15087','2014-03-03','09:45:00',2.43),('15087','2014-03-03','09:50:00',2.56),('15087','2014-03-03','09:55:00',2.81),('15087','2014-03-03','10:00:00',3.07),('15087','2014-03-03','10:05:00',3.26),('15087','2014-03-03','10:10:00',3.28),('15087','2014-03-03','10:15:00',3.34),('15087','2014-03-03','10:20:00',3.4),('15087','2014-03-03','10:25:00',3.45),('15087','2014-03-03','10:30:00',3.48),('15087','2014-03-03','10:35:00',3.54),('15087','2014-03-03','10:40:00',3.56),('15087','2014-03-03','10:45:00',3.61),('15087','2014-03-03','10:50:00',3.61),('15087','2014-03-03','10:55:00',3.63),('15087','2014-03-03','11:00:00',3.72),('15087','2014-03-03','11:05:00',3.74),('15087','2014-03-03','11:10:00',3.75),('15087','2014-03-03','11:15:00',3.8),('15087','2014-03-03','11:20:00',3.86),('15087','2014-03-03','11:25:00',3.9),('15087','2014-03-03','11:30:00',3.71),('15087','2014-03-03','11:35:00',2.21),('15087','2014-03-03','11:40:00',4.03),('15087','2014-03-03','11:45:00',4.04),('15087','2014-03-03','11:50:00',4.13),('15087','2014-03-03','11:55:00',4.09),('15087','2014-03-03','12:00:00',4.08),('15087','2014-03-03','12:05:00',4.11),('15087','2014-03-03','12:10:00',4.1),('15087','2014-03-03','12:15:00',4.12),('15087','2014-03-03','12:20:00',4.13),('15087','2014-03-03','12:25:00',4.11),('15087','2014-03-03','12:30:00',4.12),('15087','2014-03-03','12:35:00',4.11),('15087','2014-03-03','12:40:00',4.09),('15087','2014-03-03','12:45:00',4.09),('15087','2014-03-03','12:50:00',4.07),('15087','2014-03-03','12:55:00',4.05),('15087','2014-03-03','13:00:00',3.99),('15087','2014-03-03','13:05:00',3.82),('15087','2014-03-03','13:10:00',3.75),('15087','2014-03-03','13:15:00',3.86),('15087','2014-03-03','13:20:00',3.7),('15087','2014-03-03','13:25:00',3.61),('15087','2014-03-03','13:30:00',3.74),('15087','2014-03-03','13:35:00',3.45),('15087','2014-03-03','13:40:00',3.45),('15087','2014-03-03','13:45:00',3.53),('15087','2014-03-03','13:50:00',3.42),('15087','2014-03-03','13:55:00',3.37),('15087','2014-03-03','14:00:00',3.33),('15087','2014-03-03','14:05:00',3.31),('15087','2014-03-03','14:10:00',3.27),('15087','2014-03-03','14:15:00',3.17),('15087','2014-03-03','14:20:00',2.78),('15087','2014-03-03','14:25:00',2.66),('15087','2014-03-03','14:30:00',2.84),('15087','2014-03-03','14:35:00',2.72),('15087','2014-03-03','14:40:00',2.8),('15087','2014-03-03','14:45:00',2.76),('15087','2014-03-03','14:50:00',2.62),('15087','2014-03-03','14:55:00',2.67),('15087','2014-03-03','15:00:00',2.31),('15087','2014-03-03','15:05:00',2.45),('15087','2014-03-03','15:10:00',2.38),('15087','2014-03-03','15:15:00',2.26),('15087','2014-03-03','15:20:00',2.24),('15087','2014-03-03','15:25:00',2.18),('15087','2014-03-03','15:30:00',2.09),('15087','2014-03-03','15:35:00',1.97),('15087','2014-03-03','15:40:00',1.84),('15087','2014-03-03','15:45:00',1.78),('15087','2014-03-03','15:50:00',1.61),('15087','2014-03-03','15:55:00',1.5),('15087','2014-03-03','16:00:00',1.41),('15087','2014-03-03','16:05:00',1.34),('15087','2014-03-03','16:10:00',1.24),('15087','2014-03-03','16:15:00',1.2),('15087','2014-03-03','16:20:00',1.12),('15087','2014-03-03','16:25:00',1.06),('15087','2014-03-02','08:00:00',1.09),('15087','2014-03-02','08:05:00',1.08),('15087','2014-03-02','08:10:00',1.94),('15087','2014-03-02','08:15:00',1.79),('15087','2014-03-02','08:20:00',1.86),('15087','2014-03-02','08:25:00',1.75),('15087','2014-03-02','08:30:00',1.75),('15087','2014-03-02','08:35:00',1.83),('15087','2014-03-02','08:40:00',1.95),('15087','2014-03-02','08:45:00',2.05),('15087','2014-03-02','08:50:00',2.16),('15087','2014-03-02','08:55:00',2.26),('15087','2014-03-02','09:00:00',2.36),('15087','2014-03-02','09:05:00',2.46),('15087','2014-03-02','09:10:00',2.6),('15087','2014-03-02','09:15:00',2.68),('15087','2014-03-02','09:20:00',2.04),('15087','2014-03-02','09:25:00',2.97),('15087','2014-03-02','09:30:00',3.09),('15087','2014-03-02','09:35:00',3.04),('15087','2014-03-02','09:40:00',2.49),('15087','2014-03-02','09:55:00',1.28),('15087','2014-03-02','10:00:00',1.66),('15087','2014-03-02','10:05:00',1.74),('15087','2014-03-02','10:10:00',1.48),('15087','2014-03-02','10:15:00',1.37),('15087','2014-03-02','10:20:00',1.41),('15087','2014-03-02','10:25:00',1.7),('15087','2014-03-02','10:30:00',1.8),('15087','2014-03-02','10:35:00',3.18),('15087','2014-03-02','10:40:00',2.79),('15087','2014-03-02','10:45:00',1.04),('15087','2014-03-02','10:50:00',1.82),('15087','2014-03-02','10:55:00',1.79),('15087','2014-03-02','11:00:00',3.58),('15087','2014-03-02','11:05:00',3.29),('15087','2014-03-02','11:10:00',1.76),('15087','2014-03-02','11:15:00',1.37),('15087','2014-03-02','11:20:00',1.96),('15087','2014-03-02','11:25:00',2.09),('15087','2014-03-02','11:30:00',2.52),('15087','2014-03-02','11:35:00',3.32),('15087','2014-03-02','11:40:00',2.86),('15087','2014-03-02','11:45:00',5.12),('15087','2014-03-02','11:50:00',4.88),('15087','2014-03-02','11:55:00',4.62),('15087','2014-03-02','12:00:00',2.99),('15087','2014-03-02','12:05:00',2.36),('15087','2014-03-02','12:10:00',1.93),('15087','2014-03-02','12:15:00',2.94),('15087','2014-03-02','12:20:00',2.49),('15087','2014-03-02','12:25:00',2.45),('15087','2014-03-02','12:30:00',1.54),('15087','2014-03-02','12:35:00',1.19),('15087','2014-03-02','12:50:00',1.1),('15087','2014-03-02','12:55:00',1.38),('15087','2014-03-02','13:00:00',1.58),('15087','2014-03-02','13:05:00',1.66),('15087','2014-03-02','13:10:00',1.62),('15087','2014-03-02','13:15:00',1.44),('15087','2014-03-02','13:20:00',1.34),('15087','2014-03-02','13:25:00',1.26),('15087','2014-03-02','13:30:00',1.17),('15087','2014-03-02','13:35:00',1.01),('15087','2014-03-02','13:50:00',1.03),('15087','2014-03-02','13:55:00',1.1),('15087','2014-03-02','14:00:00',1.38),('15087','2014-03-02','14:05:00',1.51),('15087','2014-03-02','14:10:00',1.44),('15087','2014-03-02','14:15:00',1.36),('15087','2014-03-02','14:20:00',1.24),('15087','2014-03-02','14:25:00',1.22),('15087','2014-03-02','14:30:00',1.3),('15087','2014-03-02','14:35:00',1.32),('15087','2014-03-02','14:40:00',1.31),('15087','2014-03-02','14:45:00',1.36),('15087','2014-03-02','14:50:00',1.37),('15087','2014-03-02','14:55:00',1.34),('15087','2014-03-02','15:00:00',1.39),('15087','2014-03-02','15:05:00',1.48),('15087','2014-03-02','15:10:00',1.52),('15087','2014-03-02','15:15:00',1.49),('15087','2014-03-02','15:20:00',1.42),('15087','2014-03-02','15:25:00',1.47),('15087','2014-03-02','15:30:00',1.49),('15087','2014-03-02','15:35:00',1.45),('15087','2014-03-02','15:40:00',1.47),('15087','2014-03-02','15:45:00',1.21),('15087','2014-03-02','15:50:00',1.06),('15087','2014-02-28','07:55:00',1.02),('15087','2014-02-28','08:00:00',1.34),('15087','2014-02-28','08:05:00',1.07),('15087','2014-02-28','08:15:00',1.23),('15087','2014-02-28','08:20:00',1.76),('15087','2014-02-28','08:25:00',1.27),('15087','2014-02-28','08:35:00',2.22),('15087','2014-02-28','09:15:00',1.27),('15087','2014-02-28','09:20:00',1.37),('15087','2014-02-28','09:25:00',1.76),('15087','2014-02-28','09:30:00',2.04),('15087','2014-02-28','09:40:00',2.74),('15087','2014-02-28','09:45:00',3.21),('15087','2014-02-28','09:50:00',3.67),('15087','2014-02-28','09:55:00',2.41),('15087','2014-02-28','10:00:00',1.2),('15087','2014-02-28','10:05:00',1.25),('15087','2014-02-28','10:10:00',1.79),('15087','2014-02-28','10:15:00',1.23),('15087','2014-02-28','10:20:00',2.23),('15087','2014-02-28','10:25:00',3.3),('15087','2014-02-28','10:30:00',4.05),('15087','2014-02-28','10:35:00',2.75),('15087','2014-02-28','10:40:00',1.29),('15087','2014-02-28','11:15:00',1.1),('15087','2014-02-28','11:20:00',1.51),('15087','2014-02-28','11:25:00',1.48),('15087','2014-02-28','11:30:00',1.17),('15087','2014-02-28','11:50:00',1.12),('15087','2014-02-28','11:55:00',1.24),('15087','2014-02-28','12:00:00',1.64),('15087','2014-02-28','12:05:00',2.39),('15087','2014-02-28','12:10:00',2.08),('15087','2014-02-28','12:15:00',1.11),('15087','2014-02-28','12:20:00',1.02),('15087','2014-02-28','12:25:00',2.2),('15087','2014-02-28','12:30:00',2.21),('15087','2014-02-28','12:35:00',4.27),('15087','2014-02-28','12:40:00',2.77),('15087','2014-02-28','12:45:00',1.41),('15087','2014-02-28','12:50:00',3.57),('15087','2014-02-28','12:55:00',1.93),('15087','2014-02-28','13:00:00',2.75),('15087','2014-02-28','13:05:00',1.92),('15087','2014-02-28','13:10:00',1.72),('15087','2014-02-28','13:15:00',1.07),('15087','2014-02-28','13:45:00',1.17),('15087','2014-02-28','13:50:00',4.54),('15087','2014-02-28','13:55:00',2.24),('15087','2014-02-28','14:00:00',1.5),('15087','2014-02-28','14:15:00',1.2),('15087','2014-02-28','14:20:00',1.6),('15087','2014-02-28','14:25:00',2.29),('15087','2014-02-28','14:30:00',2.06),('15087','2014-02-28','14:35:00',1.6),('15087','2014-02-28','14:40:00',1.47),('15087','2014-02-28','14:45:00',1.41),('15087','2014-02-28','14:50:00',1.52),('15087','2014-02-28','14:55:00',1.65),('15087','2014-02-28','15:00:00',2.27),('15087','2014-02-28','15:05:00',1.58),('15087','2014-02-28','15:25:00',2.48),('15087','2014-02-28','15:30:00',1.95),('15087','2014-02-28','15:35:00',1.89),('15087','2014-02-28','15:40:00',1.84),('15087','2014-02-28','16:10:00',1.09),('15087','2014-02-28','16:15:00',1.84),('15087','2014-02-28','16:20:00',1.45),('15087','2014-02-28','16:40:00',1.24),('15087','2014-02-28','16:45:00',1.38),('15087','2014-02-28','16:50:00',1.18),('15087','2014-02-27','10:35:00',1.02),('15087','2014-02-27','10:40:00',1.25),('15087','2014-02-27','10:45:00',1.38),('15087','2014-02-27','10:50:00',1.44),('15087','2014-02-27','10:55:00',1.53),('15087','2014-02-27','11:00:00',1.74),('15087','2014-02-27','11:05:00',1.91),('15087','2014-02-27','11:10:00',1.78),('15087','2014-02-27','11:15:00',1.73),('15087','2014-02-27','11:20:00',1.58),('15087','2014-02-27','11:25:00',1.82),('15087','2014-02-27','11:30:00',2.16),('15087','2014-02-27','11:35:00',1.95),('15087','2014-02-27','11:40:00',1.65),('15087','2014-02-27','11:45:00',1.38),('15087','2014-02-27','11:50:00',1.35),('15087','2014-02-27','11:55:00',1.42),('15087','2014-02-27','12:00:00',1.38),('15087','2014-02-27','12:05:00',1.33),('15087','2014-02-27','12:10:00',1.19),('15087','2014-02-27','12:15:00',1.32),('15087','2014-02-27','12:20:00',1.41),('15087','2014-02-27','12:25:00',1.42),('15087','2014-02-27','12:30:00',1.31),('15087','2014-02-27','12:35:00',1.25),('15087','2014-02-27','12:40:00',1.22),('15087','2014-02-27','12:45:00',1.21),('15087','2014-02-27','12:50:00',1.19),('15087','2014-02-27','12:55:00',1.22),('15087','2014-02-27','13:00:00',1.31),('15087','2014-02-27','13:05:00',1.16),('15087','2014-02-27','13:10:00',1.24),('15087','2014-02-27','13:15:00',1.36),('15087','2014-02-27','13:20:00',1.37),('15087','2014-02-27','13:25:00',1.48),('15087','2014-02-27','13:30:00',1.71),('15087','2014-02-27','13:35:00',1.84),('15087','2014-02-27','13:40:00',1.89),('15087','2014-02-27','13:45:00',1.89),('15087','2014-02-27','13:50:00',1.9),('15087','2014-02-27','13:55:00',2.18),('15087','2014-02-27','14:00:00',2.2),('15087','2014-02-27','14:05:00',1.89),('15087','2014-02-27','14:10:00',1.69),('15087','2014-02-27','14:15:00',1.59),('15087','2014-02-27','14:20:00',1.58),('15087','2014-02-27','14:25:00',1.55),('15087','2014-02-27','14:30:00',1.65),('15087','2014-02-27','14:35:00',1.52),('15087','2014-02-27','14:40:00',1.29),('15087','2014-02-27','14:45:00',1.38),('15087','2014-02-27','14:50:00',1.29),('15087','2014-02-27','14:55:00',1.18),('15087','2014-02-27','15:00:00',1.27),('15087','2014-02-27','15:05:00',1.24),('15087','2014-02-27','15:10:00',1.29),('15087','2014-02-27','15:15:00',1.53),('15087','2014-02-27','15:20:00',1.65),('15087','2014-02-27','15:25:00',1.4),('15087','2014-02-27','15:30:00',1.38),('15087','2014-02-27','15:35:00',1.36),('15087','2014-02-27','15:40:00',1.03),('15087','2014-02-27','16:45:00',1.15),('15087','2014-02-27','16:50:00',1.2),('15087','2014-02-27','16:55:00',1.06),('15087','2014-02-26','08:10:00',1.14),('15087','2014-02-26','08:15:00',1.33),('15087','2014-02-26','08:20:00',1.42),('15087','2014-02-26','08:25:00',1.51),('15087','2014-02-26','08:30:00',1.6),('15087','2014-02-26','08:35:00',1.74),('15087','2014-02-26','08:40:00',1.87),('15087','2014-02-26','08:45:00',2.13),('15087','2014-02-26','08:50:00',1.97),('15087','2014-02-26','08:55:00',2.09),('15087','2014-02-26','09:00:00',2.11),('15087','2014-02-26','09:05:00',2.12),('15087','2014-02-26','09:10:00',2.18),('15087','2014-02-26','09:15:00',2.33),('15087','2014-02-26','09:20:00',2.46),('15087','2014-02-26','09:25:00',2.53),('15087','2014-02-26','09:30:00',2.49),('15087','2014-02-26','09:35:00',2.25),('15087','2014-02-26','09:40:00',2.05),('15087','2014-02-26','09:45:00',1.83),('15087','2014-02-26','09:50:00',2.08),('15087','2014-02-26','09:55:00',1.34),('15087','2014-02-26','10:00:00',1.35),('15087','2014-02-26','11:00:00',1.04),('15087','2014-02-26','11:05:00',1.08),('15087','2014-02-26','11:10:00',1.05),('15087','2014-02-26','11:15:00',1.01),('15087','2014-02-26','11:50:00',1.11),('15087','2014-02-26','11:55:00',1.24),('15087','2014-02-26','12:00:00',1.52),('15087','2014-02-26','12:05:00',1.51),('15087','2014-02-26','12:10:00',1.46),('15087','2014-02-26','12:15:00',1.26),('15087','2014-02-26','12:20:00',1.58),('15087','2014-02-26','12:25:00',2.42),('15087','2014-02-26','12:30:00',2.6),('15087','2014-02-26','12:35:00',2.65),('15087','2014-02-26','12:40:00',4.13),('15087','2014-02-26','12:45:00',4.03),('15087','2014-02-26','12:50:00',3.52),('15087','2014-02-26','12:55:00',3.74),('15087','2014-02-26','13:00:00',2.86),('15087','2014-02-26','13:05:00',2.92),('15087','2014-02-26','13:10:00',3.08),('15087','2014-02-26','13:15:00',2.9),('15087','2014-02-26','13:20:00',2.68),('15087','2014-02-26','13:25:00',2.7),('15087','2014-02-26','13:30:00',3.26),('15087','2014-02-26','13:35:00',2.93),('15087','2014-02-26','13:40:00',3.09),('15087','2014-02-26','13:45:00',1.67),('15087','2014-02-26','13:50:00',1.46),('15087','2014-02-26','13:55:00',2.84),('15087','2014-02-26','14:00:00',3.54),('15087','2014-02-26','14:05:00',1.9),('15087','2014-02-26','14:10:00',1.57),('15087','2014-02-26','14:15:00',2.47),('15087','2014-02-26','14:20:00',2.7),('15087','2014-02-26','14:25:00',2.91),('15087','2014-02-26','14:35:00',2.56),('15087','2014-02-26','14:40:00',2.85),('15087','2014-02-26','14:45:00',2.76),('15087','2014-02-26','14:50:00',2.86),('15087','2014-02-26','14:55:00',2.69),('15087','2014-02-26','15:00:00',2.11),('15087','2014-02-26','15:05:00',2.2),('15087','2014-02-26','15:10:00',1.78),('15087','2014-02-26','15:15:00',1.85),('15087','2014-02-26','15:20:00',1.36),('15087','2014-02-26','15:25:00',1.04),('15087','2014-02-26','15:30:00',1.17),('15087','2014-02-26','15:35:00',1.57),('15087','2014-02-26','15:40:00',1.61),('15087','2014-02-26','15:45:00',1.24),('15087','2014-02-26','15:50:00',1.28),('15087','2014-02-26','15:55:00',1.48),('15087','2014-02-26','16:00:00',1.67),('15087','2014-02-26','16:05:00',1.49),('15087','2014-04-29','09:50:00',1.11),('15087','2014-04-29','09:55:00',1.26),('15087','2014-04-29','10:00:00',1.33),('15087','2014-04-29','10:05:00',2.47),('15087','2014-04-29','10:10:00',4.39),('15087','2014-04-29','10:15:00',3.41),('15087','2014-04-29','10:20:00',3.35),('15087','2014-04-29','10:25:00',4.43),('15087','2014-04-29','10:30:00',4.16),('15087','2014-04-29','10:35:00',4.26),('15087','2014-04-29','10:40:00',4.32),('15087','2014-04-29','10:45:00',4.32),('15087','2014-04-29','10:50:00',4.44),('15087','2014-04-29','10:55:00',4.19),('15087','2014-04-29','11:00:00',4.42),('15087','2014-04-29','11:05:00',4.42),('15087','2014-04-29','11:10:00',4.4),('15087','2014-04-29','11:15:00',5.29),('15087','2014-04-29','11:20:00',3.16),('15087','2014-04-29','11:25:00',4.06),('15087','2014-04-29','11:30:00',1.69),('15087','2014-04-29','11:35:00',2.93),('15087','2014-04-29','11:40:00',3.74),('15087','2014-04-29','11:45:00',1.67),('15087','2014-04-29','11:50:00',1.15),('15087','2014-04-29','11:55:00',1.18),('15087','2014-04-29','12:00:00',1.7),('15087','2014-04-29','12:05:00',1.86),('15087','2014-04-29','12:10:00',1.91),('15087','2014-04-29','12:15:00',1.79),('15087','2014-04-29','12:20:00',2.4),('15087','2014-04-29','12:25:00',1.94),('15087','2014-04-29','12:30:00',1.65),('15087','2014-04-29','12:35:00',1.91),('15087','2014-04-29','12:40:00',2.03),('15087','2014-04-29','12:45:00',4.65),('15087','2014-04-29','12:50:00',2.54),('15087','2014-04-29','12:55:00',1.93),('15087','2014-04-29','13:00:00',2.6),('15087','2014-04-29','13:05:00',3.14),('15087','2014-04-29','13:10:00',2.65),('15087','2014-04-29','13:15:00',3.32),('15087','2014-04-29','13:20:00',4.56),('15087','2014-04-29','13:25:00',3),('15087','2014-04-29','13:30:00',3.48),('15087','2014-04-29','13:35:00',1.78),('15087','2014-04-29','13:40:00',1.86),('15087','2014-04-29','13:45:00',3.37),('15087','2014-04-29','13:50:00',3.2),('15087','2014-04-29','13:55:00',1.01),('15087','2014-04-29','16:25:00',1.01),('15087','2014-04-29','17:05:00',1.26),('15087','2014-04-29','17:10:00',1.15),('15087','2014-04-29','17:20:00',1.25),('15087','2014-04-29','17:25:00',1.36),('15087','2014-04-29','17:30:00',1.82),('15087','2014-04-29','17:35:00',1.3),('15087','2014-04-29','17:40:00',1.8),('15087','2014-04-29','17:45:00',1.85),('15087','2014-02-23','08:10:00',1.03),('15087','2014-02-23','08:20:00',1.26),('15087','2014-02-23','08:25:00',1.36),('15087','2014-02-23','08:30:00',1.46),('15087','2014-02-23','08:35:00',1.55),('15087','2014-02-23','08:40:00',1.65),('15087','2014-02-23','08:45:00',1.74),('15087','2014-02-23','08:50:00',1.79),('15087','2014-02-23','08:55:00',1.92),('15087','2014-02-23','09:00:00',2.02),('15087','2014-02-23','09:05:00',2.12),('15087','2014-02-23','09:10:00',2.22),('15087','2014-02-23','09:15:00',2.32),('15087','2014-02-23','09:20:00',2.4),('15087','2014-02-23','09:25:00',2.19),('15087','2014-02-23','09:30:00',2.21),('15087','2014-02-23','09:35:00',2.55),('15087','2014-02-23','09:40:00',2.63),('15087','2014-02-23','09:45:00',2.69),('15087','2014-02-23','09:50:00',2.72),('15087','2014-02-23','09:55:00',2.78),('15087','2014-02-23','10:00:00',2.83),('15087','2014-02-23','10:05:00',2.87),('15087','2014-02-23','10:10:00',2.93),('15087','2014-02-23','10:15:00',2.99),('15087','2014-02-23','10:20:00',3.07),('15087','2014-02-23','10:25:00',3.13),('15087','2014-02-23','10:30:00',3.18),('15087','2014-02-23','10:35:00',3.24),('15087','2014-02-23','10:40:00',3.28),('15087','2014-02-23','10:45:00',3.38),('15087','2014-02-23','10:50:00',3.37),('15087','2014-02-23','10:55:00',3.41),('15087','2014-02-23','11:00:00',3.48),('15087','2014-02-23','11:05:00',3.51),('15087','2014-02-23','11:10:00',3.56),('15087','2014-02-23','11:15:00',3.65),('15087','2014-02-23','11:20:00',3.69),('15087','2014-02-23','11:25:00',3.68),('15087','2014-02-23','11:30:00',3.74),('15087','2014-02-23','11:35:00',3.74),('15087','2014-02-23','11:40:00',3.61),('15087','2014-02-23','11:45:00',2.95),('15087','2014-02-23','11:50:00',3.48),('15087','2014-02-23','11:55:00',3.46),('15087','2014-02-23','12:00:00',3.97),('15087','2014-02-23','12:05:00',3.83),('15087','2014-02-23','12:10:00',1.77),('15087','2014-02-23','12:15:00',4.31),('15087','2014-02-23','12:20:00',3.55),('15087','2014-02-23','12:25:00',2.45),('15087','2014-02-23','12:30:00',3.12),('15087','2014-02-23','12:35:00',4.08),('15087','2014-02-23','12:40:00',2.25),('15087','2014-02-23','12:45:00',2.6),('15087','2014-02-23','12:50:00',2.09),('15087','2014-02-23','12:55:00',2.08),('15087','2014-02-23','13:00:00',2.6),('15087','2014-02-23','13:05:00',3.6),('15087','2014-02-23','13:10:00',3.68),('15087','2014-02-23','13:15:00',3.61),('15087','2014-02-23','13:20:00',3.56),('15087','2014-02-23','13:25:00',3.52),('15087','2014-02-23','13:30:00',3.46),('15087','2014-02-23','13:35:00',3.32),('15087','2014-02-23','13:40:00',2.87),('15087','2014-02-23','13:45:00',2.54),('15087','2014-02-23','13:50:00',1.83),('15087','2014-02-23','14:00:00',1.27),('15087','2014-02-23','14:05:00',2.84),('15087','2014-02-23','14:10:00',3.04),('15087','2014-02-23','14:15:00',2.24),('15087','2014-02-23','14:20:00',1.95),('15087','2014-02-23','14:25:00',2.89),('15087','2014-02-23','14:30:00',3.44),('15087','2014-02-23','14:35:00',2.7),('15087','2014-02-23','14:40:00',1.95),('15087','2014-02-23','14:45:00',1.59),('15087','2014-02-23','14:50:00',1.65),('15087','2014-02-23','14:55:00',1.02),('15087','2014-02-23','15:00:00',1.05),('15087','2014-02-22','09:10:00',1.12),('15087','2014-02-22','10:00:00',1.86),('15087','2014-02-22','10:05:00',1.77),('15087','2014-02-22','10:10:00',3.02),('15087','2014-02-22','10:15:00',2),('15087','2014-02-22','10:20:00',1.46),('15087','2014-02-22','10:25:00',2.4),('15087','2014-02-22','10:30:00',2.43),('15087','2014-02-22','10:35:00',1.98),('15087','2014-02-22','10:40:00',1.66),('15087','2014-02-22','10:45:00',4.04),('15087','2014-02-22','10:50:00',3.57),('15087','2014-02-22','10:55:00',1.09),('15087','2014-02-22','12:05:00',1.52),('15087','2014-02-22','12:10:00',1.75),('15087','2014-02-22','12:15:00',1.98),('15087','2014-02-22','12:20:00',1.95),('15087','2014-02-22','12:25:00',1.73),('15087','2014-02-22','12:30:00',1.12),('15087','2014-02-22','12:35:00',1.29),('15087','2014-02-22','12:40:00',1.54),('15087','2014-02-22','12:45:00',3.78),('15087','2014-02-22','12:50:00',3.82),('15087','2014-02-22','12:55:00',1.65),('15087','2014-02-22','13:00:00',1.56),('15087','2014-02-22','13:05:00',2.9),('15087','2014-02-22','13:10:00',4.96),('15087','2014-02-22','13:15:00',3.04),('15087','2014-02-22','13:20:00',1.63),('15087','2014-02-22','13:30:00',1.29),('15087','2014-02-22','13:35:00',2.22),('15087','2014-02-22','13:40:00',2.09),('15087','2014-02-22','13:45:00',1.74),('15087','2014-02-22','13:50:00',1.89),('15087','2014-02-22','13:55:00',3.54),('15087','2014-02-22','14:00:00',3.31),('15087','2014-02-22','14:05:00',2.88),('15087','2014-02-22','14:10:00',3.14),('15087','2014-02-22','14:15:00',3.09),('15087','2014-02-22','14:20:00',2.77),('15087','2014-02-22','14:25:00',2.33),('15087','2014-02-22','14:30:00',1.77),('15087','2014-02-22','14:35:00',2.26),('15087','2014-02-22','14:40:00',2.33),('15087','2014-02-22','14:45:00',2.71),('15087','2014-02-22','14:50:00',2.13),('15087','2014-02-22','15:00:00',1.5),('15087','2014-02-22','15:05:00',2.29),('15087','2014-02-22','15:10:00',1.11),('15087','2014-02-22','15:15:00',1.14),('15087','2014-02-22','15:25:00',1.27),('15087','2014-02-22','15:30:00',1.88),('15087','2014-02-22','15:45:00',1.72),('15087','2014-02-22','15:50:00',1.52),('15087','2014-02-22','16:00:00',1.22),('15087','2014-02-22','16:10:00',1.07),('15087','2014-02-22','16:15:00',1.03),('15087','2014-02-21','09:40:00',1.06),('15087','2014-02-21','09:45:00',1.22),('15087','2014-02-21','09:50:00',1.28),('15087','2014-02-21','09:55:00',1.2),('15087','2014-02-21','10:00:00',1.28),('15087','2014-02-21','10:05:00',1.6),('15087','2014-02-21','10:10:00',1.37),('15087','2014-02-21','10:15:00',1.69),('15087','2014-02-21','10:20:00',2.3),('15087','2014-02-21','10:25:00',2.58),('15087','2014-02-21','10:30:00',2.84),('15087','2014-02-21','10:35:00',1.99),('15087','2014-02-21','10:40:00',1.92),('15087','2014-02-21','10:45:00',1.75),('15087','2014-02-21','10:50:00',1.85),('15087','2014-02-21','10:55:00',2.54),('15087','2014-02-21','11:00:00',1.9),('15087','2014-02-21','11:05:00',1.71),('15087','2014-02-21','11:10:00',1.66),('15087','2014-02-21','11:15:00',1.82),('15087','2014-02-21','11:20:00',1.67),('15087','2014-02-21','11:25:00',1.74),('15087','2014-02-21','11:30:00',1.85),('15087','2014-02-21','11:35:00',1.85),('15087','2014-02-21','11:40:00',1.96),('15087','2014-02-21','11:45:00',1.89),('15087','2014-02-21','11:50:00',1.65),('15087','2014-02-21','11:55:00',1.6),('15087','2014-02-21','12:00:00',2.41),('15087','2014-02-21','12:05:00',3.88),('15087','2014-02-21','12:10:00',4.33),('15087','2014-02-21','12:15:00',4.37),('15087','2014-02-21','12:20:00',3.76),('15087','2014-02-21','12:25:00',2.56),('15087','2014-02-21','12:30:00',1.64),('15087','2014-02-21','12:35:00',1.29),('15087','2014-02-21','12:40:00',1.04),('15087','2014-02-21','15:00:00',1.15),('15087','2014-02-21','15:05:00',1.23),('15087','2014-02-21','15:30:00',1.46),('15087','2014-02-21','15:35:00',1.75),('15087','2014-02-21','15:40:00',1.56),('15087','2014-02-21','15:45:00',1.51),('15087','2014-02-21','15:50:00',1.41),('15087','2014-02-21','15:55:00',1.26),('15087','2014-02-21','16:00:00',1.18),('15087','2014-02-21','16:05:00',1.1),('15087','2014-02-21','16:10:00',1.02),('15087','2014-02-20','11:20:00',1.11),('15087','2014-02-20','11:25:00',1.23),('15087','2014-02-20','11:30:00',1.23),('15087','2014-02-20','12:25:00',1.1),('15087','2014-02-20','12:30:00',1.04),('15087','2014-02-20','12:35:00',1.09),('15087','2014-02-20','12:40:00',1.21),('15087','2014-02-20','12:45:00',1.06),('15087','2014-02-20','12:50:00',1.07),('15087','2014-02-20','12:55:00',1.27),('15087','2014-02-20','13:00:00',1.56),('15087','2014-02-20','13:15:00',1.24),('15087','2014-02-20','13:30:00',1.25),('15087','2014-02-20','13:35:00',1.07),('15087','2014-02-19','09:30:00',1.03),('15087','2014-02-19','09:35:00',1.18),('15087','2014-02-19','09:40:00',1.29),('15087','2014-02-19','09:45:00',1.62),('15087','2014-02-19','09:50:00',1.48),('15087','2014-02-19','09:55:00',1.31),('15087','2014-02-19','10:00:00',1.3),('15087','2014-02-19','10:05:00',1.28),('15087','2014-02-19','10:10:00',1.44),('15087','2014-02-19','10:15:00',1.51),('15087','2014-02-19','10:20:00',1.34),('15087','2014-02-19','10:25:00',1.4),('15087','2014-02-19','10:30:00',1.5),('15087','2014-02-19','10:35:00',1.61),('15087','2014-02-19','10:40:00',1.85),('15087','2014-02-19','10:45:00',2),('15087','2014-02-19','10:50:00',1.89),('15087','2014-02-19','10:55:00',1.67),('15087','2014-02-19','11:00:00',1.51),('15087','2014-02-19','11:05:00',1.55),('15087','2014-02-19','11:10:00',1.75),('15087','2014-02-19','11:15:00',1.74),('15087','2014-02-19','11:20:00',1.89),('15087','2014-02-19','11:25:00',1.75),('15087','2014-02-19','11:30:00',1.59),('15087','2014-02-19','11:35:00',1.63),('15087','2014-02-19','11:40:00',1.53),('15087','2014-02-19','11:45:00',1.47),('15087','2014-02-19','11:50:00',1.5),('15087','2014-02-19','11:55:00',1.28),('15087','2014-02-19','12:00:00',1.33),('15087','2014-02-19','12:05:00',1.46),('15087','2014-02-19','12:10:00',1.41),('15087','2014-02-19','12:15:00',1.38),('15087','2014-02-19','12:20:00',1.17),('15087','2014-02-19','12:25:00',1.45),('15087','2014-02-19','12:30:00',1.64),('15087','2014-02-19','12:35:00',1.26),('15087','2014-02-19','12:40:00',1.17),('15087','2014-02-19','12:45:00',1.19),('15087','2014-02-19','13:05:00',1.04),('15087','2014-02-19','13:10:00',1.02),('15087','2014-02-19','13:15:00',1.19),('15087','2014-02-19','13:20:00',1.15),('15087','2014-02-19','13:25:00',1.57),('15087','2014-02-19','13:30:00',1.6),('15087','2014-02-19','13:35:00',1.78),('15087','2014-02-19','13:40:00',1.65),('15087','2014-02-19','13:45:00',2.14),('15087','2014-02-19','13:50:00',2.22),('15087','2014-02-19','13:55:00',1.95),('15087','2014-02-19','14:00:00',1.83),('15087','2014-02-19','14:05:00',1.9),('15087','2014-02-19','14:10:00',1.47),('15087','2014-02-19','14:15:00',1.3),('15087','2014-02-19','14:20:00',2.16),('15087','2014-02-19','14:25:00',1.66),('15087','2014-02-19','14:30:00',1.58),('15087','2014-02-19','14:35:00',1.71),('15087','2014-02-19','14:40:00',1.37),('15087','2014-02-19','14:45:00',1.26),('15087','2014-02-19','14:50:00',1.7),('15087','2014-02-19','14:55:00',1.39),('15087','2014-02-19','15:00:00',1.03),('15087','2014-02-19','15:05:00',1.07),('15087','2014-02-19','15:10:00',1.13),('15087','2014-02-19','15:15:00',1.29),('15087','2014-02-19','15:25:00',1.11),('15087','2014-02-19','15:50:00',1.14),('15087','2014-02-18','08:25:00',1.12),('15087','2014-02-18','08:30:00',1.22),('15087','2014-02-18','08:35:00',1.31),('15087','2014-02-18','08:40:00',1.41),('15087','2014-02-18','08:45:00',1.49),('15087','2014-02-18','08:50:00',1.52),('15087','2014-02-18','08:55:00',1.66),('15087','2014-02-18','09:00:00',1.73),('15087','2014-02-18','09:05:00',1.82),('15087','2014-02-18','09:10:00',1.92),('15087','2014-02-18','09:15:00',1.98),('15087','2014-02-18','09:20:00',2.08),('15087','2014-02-18','09:25:00',2.14),('15087','2014-02-18','09:30:00',2.23),('15087','2014-02-18','09:35:00',2.3),('15087','2014-02-18','09:40:00',2.37),('15087','2014-02-18','09:45:00',2.43),('15087','2014-02-18','09:50:00',2.5),('15087','2014-02-18','09:55:00',2.57),('15087','2014-02-18','10:00:00',2.63),('15087','2014-02-18','10:05:00',2.69),('15087','2014-02-18','10:10:00',2.74),('15087','2014-02-18','10:15:00',2.78),('15087','2014-02-18','10:20:00',2.82),('15087','2014-02-18','10:25:00',2.89),('15087','2014-02-18','10:30:00',2.93),('15087','2014-02-18','10:35:00',2.96),('15087','2014-02-18','10:40:00',3.01),('15087','2014-02-18','10:45:00',3.05),('15087','2014-02-18','10:50:00',3.09),('15087','2014-02-18','10:55:00',3.12),('15087','2014-02-18','11:00:00',3.17),('15087','2014-02-18','11:05:00',2.73),('15087','2014-02-18','11:10:00',2.63),('15087','2014-02-18','11:15:00',2.57),('15087','2014-02-18','11:20:00',2.87),('15087','2014-02-18','11:25:00',3.23),('15087','2014-02-18','11:30:00',2.86),('15087','2014-02-18','11:35:00',2.78),('15087','2014-02-18','11:40:00',2.25),('15087','2014-02-18','11:45:00',2.2),('15087','2014-02-18','11:50:00',1.81),('15087','2014-02-18','11:55:00',1.54),('15087','2014-02-18','12:00:00',1.51),('15087','2014-02-18','12:05:00',1.52),('15087','2014-02-18','12:10:00',1.78),('15087','2014-02-18','12:15:00',1.94),('15087','2014-02-18','12:20:00',1.92),('15087','2014-02-18','12:25:00',2.26),('15087','2014-02-18','12:30:00',2.46),('15087','2014-02-18','12:35:00',1.82),('15087','2014-02-18','12:40:00',1.62),('15087','2014-02-18','12:45:00',1.56),('15087','2014-02-18','12:50:00',1.74),('15087','2014-02-18','12:55:00',1.89),('15087','2014-02-18','13:00:00',1.42),('15087','2014-02-18','13:05:00',1.34),('15087','2014-02-18','13:10:00',1.42),('15087','2014-02-18','13:15:00',1.94),('15087','2014-02-18','13:20:00',2.17),('15087','2014-02-18','13:25:00',2.6),('15087','2014-02-18','13:30:00',1.82),('15087','2014-02-18','13:35:00',1.48),('15087','2014-02-18','13:40:00',1.96),('15087','2014-02-18','13:45:00',2.26),('15087','2014-02-18','13:50:00',1.71),('15087','2014-02-18','13:55:00',1.7),('15087','2014-02-18','14:00:00',1.91),('15087','2014-02-18','14:05:00',2.64),('15087','2014-02-18','14:10:00',1.6),('15087','2014-02-18','14:15:00',1.26),('15087','2014-02-18','14:20:00',1.12),('15087','2014-02-18','14:25:00',1.15),('15087','2014-02-18','14:30:00',1.45),('15087','2014-02-18','14:35:00',1.37),('15087','2014-02-18','14:40:00',1.16),('15087','2014-02-18','14:45:00',1.06),('15087','2014-02-18','15:35:00',1.03),('15087','2014-02-18','15:40:00',1.25),('15087','2014-02-18','15:45:00',1.31),('15087','2014-02-18','15:50:00',1.04),('15087','2014-02-18','16:05:00',1.03),('15087','2014-02-17','08:25:00',1.02),('15087','2014-02-17','08:30:00',1.09),('15087','2014-02-17','08:35:00',1.17),('15087','2014-02-17','08:40:00',1.26),('15087','2014-02-17','08:45:00',1.34),('15087','2014-02-17','08:50:00',1.39),('15087','2014-02-17','08:55:00',1.51),('15087','2014-02-17','09:00:00',1.56),('15087','2014-02-17','09:05:00',1.65),('15087','2014-02-17','09:10:00',1.76),('15087','2014-02-17','09:15:00',1.85),('15087','2014-02-17','09:20:00',1.93),('15087','2014-02-17','09:25:00',1.98),('15087','2014-02-17','09:30:00',2.09),('15087','2014-02-17','09:35:00',2.16),('15087','2014-02-17','09:40:00',2.22),('15087','2014-02-17','09:45:00',2.28),('15087','2014-02-17','09:50:00',2.32),('15087','2014-02-17','09:55:00',2.37),('15087','2014-02-17','10:00:00',2.43),('15087','2014-02-17','10:05:00',2.49),('15087','2014-02-17','10:10:00',2.53),('15087','2014-02-17','10:15:00',2.56),('15087','2014-02-17','10:20:00',2.58),('15087','2014-02-17','10:25:00',2.62),('15087','2014-02-17','10:30:00',2.68),('15087','2014-02-17','10:35:00',2.68),('15087','2014-02-17','10:40:00',2.69),('15087','2014-02-17','10:45:00',2.71),('15087','2014-02-17','10:50:00',2.75),('15087','2014-02-17','10:55:00',2.8),('15087','2014-02-17','11:00:00',2.81),('15087','2014-02-17','11:05:00',2.87),('15087','2014-02-17','11:10:00',2.88),('15087','2014-02-17','11:15:00',2.95),('15087','2014-02-17','11:20:00',3),('15087','2014-02-17','11:25:00',3.07),('15087','2014-02-17','11:30:00',3.12),('15087','2014-02-17','11:35:00',3.18),('15087','2014-02-17','11:40:00',3.19),('15087','2014-02-17','11:45:00',3.24),('15087','2014-02-17','11:50:00',3.25),('15087','2014-02-17','11:55:00',3.25),('15087','2014-02-17','12:00:00',3.26),('15087','2014-02-17','12:05:00',3.27),('15087','2014-02-17','12:10:00',3.25),('15087','2014-02-17','12:15:00',3.24),('15087','2014-02-17','12:20:00',3.24),('15087','2014-02-17','12:25:00',3.25),('15087','2014-02-17','12:30:00',3.24),('15087','2014-02-17','12:35:00',3.24),('15087','2014-02-17','12:40:00',3.2),('15087','2014-02-17','12:45:00',3.19),('15087','2014-02-17','12:50:00',3.16),('15087','2014-02-17','12:55:00',2.99),('15087','2014-02-17','13:00:00',3.1),('15087','2014-02-17','13:05:00',3.06),('15087','2014-02-17','13:10:00',2.93),('15087','2014-02-17','13:15:00',2.99),('15087','2014-02-17','13:20:00',2.95),('15087','2014-02-17','13:25:00',2.8),('15087','2014-02-17','13:30:00',2.9),('15087','2014-02-17','13:35:00',2.86),('15087','2014-02-17','13:40:00',2.76),('15087','2014-02-17','13:45:00',2.63),('15087','2014-02-17','13:50:00',2.55),('15087','2014-02-17','13:55:00',2.44),('15087','2014-02-17','14:00:00',2.54),('15087','2014-02-17','14:05:00',2.46),('15087','2014-02-17','14:10:00',2.33),('15087','2014-02-17','14:15:00',2.32),('15087','2014-02-17','14:20:00',2.34),('15087','2014-02-17','14:25:00',2.22),('15087','2014-02-17','14:30:00',2.25),('15087','2014-02-17','14:35:00',2.12),('15087','2014-02-17','14:40:00',1.97),('15087','2014-02-17','14:45:00',2.13),('15087','2014-02-17','14:50:00',1.96),('15087','2014-02-17','14:55:00',1.82),('15087','2014-02-17','15:00:00',1.79),('15087','2014-02-17','15:05:00',1.73),('15087','2014-02-17','15:10:00',1.62),('15087','2014-02-17','15:15:00',1.74),('15087','2014-02-17','15:20:00',1.69),('15087','2014-02-17','15:25:00',1.51),('15087','2014-02-17','15:30:00',1.52),('15087','2014-02-17','15:35:00',1.42),('15087','2014-02-17','15:40:00',1.26),('15087','2014-02-17','15:45:00',1.24),('15087','2014-02-17','15:50:00',1.17),('15087','2014-02-17','15:55:00',1.07),('15087','2014-02-16','08:25:00',1.12),('15087','2014-02-16','08:30:00',1.26),('15087','2014-02-16','08:35:00',1.4),('15087','2014-02-16','08:40:00',1.38),('15087','2014-02-16','08:45:00',1.58),('15087','2014-02-16','08:50:00',1.49),('15087','2014-02-16','08:55:00',1.72),('15087','2014-02-16','09:00:00',1.86),('15087','2014-02-16','09:05:00',1.94),('15087','2014-02-16','09:10:00',1.87),('15087','2014-02-16','09:15:00',1.5),('15087','2014-02-16','09:20:00',2.08),('15087','2014-02-16','09:25:00',2.05),('15087','2014-02-16','09:30:00',2.11),('15087','2014-02-16','09:35:00',1.75),('15087','2014-02-16','09:40:00',2.29),('15087','2014-02-16','09:45:00',2.47),('15087','2014-02-16','09:50:00',2.55),('15087','2014-02-16','09:55:00',2.49),('15087','2014-02-16','10:00:00',2.45),('15087','2014-02-16','10:05:00',2.7),('15087','2014-02-16','10:10:00',2.75),('15087','2014-02-16','10:15:00',2.79),('15087','2014-02-16','10:20:00',2.88),('15087','2014-02-16','10:25:00',2.98),('15087','2014-02-16','10:30:00',3),('15087','2014-02-16','10:35:00',3.09),('15087','2014-02-16','10:40:00',3.19),('15087','2014-02-16','10:45:00',3.17),('15087','2014-02-16','10:50:00',2.72),('15087','2014-02-16','10:55:00',2.8),('15087','2014-02-16','11:00:00',3.22),('15087','2014-02-16','11:05:00',3.29),('15087','2014-02-16','11:10:00',3.13),('15087','2014-02-16','11:15:00',3.25),('15087','2014-02-16','11:20:00',3.13),('15087','2014-02-16','11:25:00',3.11),('15087','2014-02-16','11:30:00',3.18),('15087','2014-02-16','11:35:00',3.34),('15087','2014-02-16','11:40:00',3.31),('15087','2014-02-16','11:45:00',3.01),('15087','2014-02-16','11:50:00',3.31),('15087','2014-02-16','11:55:00',2.89),('15087','2014-02-16','12:00:00',3.42),('15087','2014-02-16','12:05:00',3.38),('15087','2014-02-16','12:10:00',3.39),('15087','2014-02-16','12:15:00',3.38),('15087','2014-02-16','12:20:00',3.4),('15087','2014-02-16','12:25:00',3.28),('15087','2014-02-16','12:30:00',3.34),('15087','2014-02-16','12:35:00',3.33),('15087','2014-02-16','12:40:00',3.31),('15087','2014-02-16','12:45:00',3.3),('15087','2014-02-16','12:50:00',3.28),('15087','2014-02-16','12:55:00',3.02),('15087','2014-02-16','13:00:00',3.25),('15087','2014-02-16','13:05:00',3.19),('15087','2014-02-16','13:10:00',2.86),('15087','2014-02-16','13:15:00',3.15),('15087','2014-02-16','13:20:00',3.06),('15087','2014-02-16','13:25:00',2.83),('15087','2014-02-16','13:30:00',2.98),('15087','2014-02-16','13:35:00',2.91),('15087','2014-02-16','13:40:00',2.72),('15087','2014-02-16','13:45:00',2.89),('15087','2014-02-16','13:50:00',2.78),('15087','2014-02-16','13:55:00',2.62),('15087','2014-02-16','14:00:00',2.75),('15087','2014-02-16','14:05:00',2.59),('15087','2014-02-16','14:10:00',2.37),('15087','2014-02-16','14:15:00',2.58),('15087','2014-02-16','14:20:00',2.58),('15087','2014-02-16','14:25:00',2.56),('15087','2014-02-16','14:30:00',2.45),('15087','2014-02-16','14:35:00',2.36),('15087','2014-02-16','14:40:00',2.11),('15087','2014-02-16','14:45:00',2.21),('15087','2014-02-16','14:50:00',2.13),('15087','2014-02-16','14:55:00',1.99),('15087','2014-02-16','15:00:00',1.96),('15087','2014-02-16','15:05:00',1.83),('15087','2014-02-16','15:10:00',1.74),('15087','2014-02-16','15:15:00',1.8),('15087','2014-02-16','15:20:00',1.59),('15087','2014-02-16','15:25:00',1.62),('15087','2014-02-16','15:30:00',1.55),('15087','2014-02-16','15:35:00',1.22),('15087','2014-02-16','15:40:00',1.08),('15087','2014-02-16','15:45:00',1.28),('15087','2014-02-16','16:25:00',1.05),('15087','2014-04-28','08:15:00',1.88),('15087','2014-04-28','08:20:00',1.99),('15087','2014-04-28','08:25:00',2.09),('15087','2014-04-28','08:30:00',1.27),('15087','2014-04-28','08:35:00',1.3),('15087','2014-04-28','08:40:00',1.31),('15087','2014-04-28','08:45:00',1.2),('15087','2014-04-28','08:50:00',1.26),('15087','2014-04-28','08:55:00',1.43),('15087','2014-04-28','09:00:00',1.02),('15087','2014-04-28','09:05:00',1.89),('15087','2014-04-28','09:10:00',3.01),('15087','2014-04-28','09:15:00',2.96),('15087','2014-04-28','09:20:00',2.28),('15087','2014-04-28','09:25:00',1.48),('15087','2014-04-28','09:30:00',3.38),('15087','2014-04-28','09:35:00',2.86),('15087','2014-04-28','09:40:00',2.12),('15087','2014-04-28','09:45:00',1.93),('15087','2014-04-28','09:50:00',1.64),('15087','2014-04-28','09:55:00',1.4),('15087','2014-04-28','10:00:00',2.47),('15087','2014-04-28','10:05:00',2.68),('15087','2014-04-28','10:10:00',2.58),('15087','2014-04-28','10:15:00',2.15),('15087','2014-04-28','10:20:00',1.67),('15087','2014-04-28','10:40:00',1.19),('15087','2014-04-28','10:45:00',1.85),('15087','2014-04-28','10:50:00',2.17),('15087','2014-04-28','10:55:00',1.98),('15087','2014-04-28','11:00:00',2.21),('15087','2014-04-28','11:05:00',2.74),('15087','2014-04-28','11:10:00',3.07),('15087','2014-04-28','11:15:00',2.85),('15087','2014-04-28','11:20:00',2.49),('15087','2014-04-28','11:25:00',2.08),('15087','2014-04-28','11:30:00',2.09),('15087','2014-04-28','11:35:00',1.79),('15087','2014-04-28','11:40:00',1.6),('15087','2014-04-28','11:45:00',1.86),('15087','2014-04-28','11:50:00',2.21),('15087','2014-04-28','11:55:00',2.27),('15087','2014-04-28','12:00:00',1.96),('15087','2014-04-28','12:05:00',1.59),('15087','2014-04-28','12:10:00',2.38),('15087','2014-04-28','12:15:00',3.18),('15087','2014-04-28','12:20:00',3.16),('15087','2014-04-28','12:25:00',3.1),('15087','2014-04-28','12:30:00',3.12),('15087','2014-04-28','12:35:00',2.75),('15087','2014-04-28','12:40:00',2.34),('15087','2014-04-28','12:45:00',2.19),('15087','2014-04-28','12:50:00',2.53),('15087','2014-04-28','12:55:00',2.52),('15087','2014-04-28','13:00:00',2.61),('15087','2014-04-28','13:05:00',3.96),('15087','2014-04-28','13:10:00',3.36),('15087','2014-04-28','13:15:00',2.48),('15087','2014-04-28','13:20:00',2.93),('15087','2014-04-28','13:25:00',3.85),('15087','2014-04-28','13:30:00',5.56),('15087','2014-04-28','13:35:00',4.7),('15087','2014-04-28','13:40:00',2.89),('15087','2014-04-28','13:45:00',4.5),('15087','2014-04-28','13:50:00',4.78),('15087','2014-04-28','13:55:00',2.91),('15087','2014-04-28','14:00:00',2.42),('15087','2014-04-28','14:05:00',4.23),('15087','2014-04-28','14:10:00',4.65),('15087','2014-04-28','14:15:00',2.84),('15087','2014-04-28','14:20:00',4.59),('15087','2014-04-28','14:25:00',3.26),('15087','2014-04-28','14:30:00',3.69),('15087','2014-04-28','14:35:00',2.48),('15087','2014-04-28','14:40:00',4.65),('15087','2014-04-28','14:45:00',3.89),('15087','2014-04-28','14:50:00',3.84),('15087','2014-04-28','14:55:00',4.22),('15087','2014-04-28','15:00:00',3.27),('15087','2014-04-28','15:05:00',3.28),('15087','2014-04-28','15:10:00',2.22),('15087','2014-04-28','15:15:00',2.96),('15087','2014-04-28','15:20:00',2.19),('15087','2014-04-28','15:25:00',1.61),('15087','2014-04-28','15:30:00',2.14),('15087','2014-04-28','15:35:00',3.64),('15087','2014-04-28','15:40:00',2.27),('15087','2014-04-28','15:45:00',3.26),('15087','2014-04-28','15:50:00',2.45),('15087','2014-04-28','15:55:00',1.46),('15087','2014-04-28','16:00:00',2.58),('15087','2014-04-28','16:05:00',2.82),('15087','2014-04-28','16:10:00',3.86),('15087','2014-04-28','16:15:00',2.11),('15087','2014-04-28','16:20:00',2.1),('15087','2014-04-28','16:25:00',2.09),('15087','2014-04-28','16:30:00',2.81),('15087','2014-04-28','16:35:00',2.85),('15087','2014-04-28','16:50:00',1.2),('15087','2014-04-28','16:55:00',1.8),('15087','2014-04-28','17:35:00',1.31),('15087','2014-04-28','17:40:00',1.4),('15087','2014-02-15','08:30:00',1.13),('15087','2014-02-15','08:35:00',1.22),('15087','2014-02-15','08:40:00',1.32),('15087','2014-02-15','08:45:00',1.42),('15087','2014-02-15','08:50:00',1.47),('15087','2014-02-15','08:55:00',1.5),('15087','2014-02-15','09:00:00',1.68),('15087','2014-02-15','09:05:00',1.76),('15087','2014-02-15','09:10:00',1.84),('15087','2014-02-15','09:15:00',1.91),('15087','2014-02-15','09:20:00',2.02),('15087','2014-02-15','09:25:00',2.07),('15087','2014-02-15','09:30:00',2.14),('15087','2014-02-15','09:35:00',2.21),('15087','2014-02-15','09:40:00',2.27),('15087','2014-02-15','09:45:00',2.35),('15087','2014-02-15','09:50:00',2.42),('15087','2014-02-15','09:55:00',2.48),('15087','2014-02-15','10:00:00',2.52),('15087','2014-02-15','10:05:00',2.59),('15087','2014-02-15','10:10:00',2.64),('15087','2014-02-15','10:15:00',2.68),('15087','2014-02-15','10:20:00',2.72),('15087','2014-02-15','10:25:00',2.74),('15087','2014-02-15','10:30:00',2.77),('15087','2014-02-15','10:35:00',2.79),('15087','2014-02-15','10:40:00',2.82),('15087','2014-02-15','10:45:00',2.9),('15087','2014-02-15','10:50:00',2.93),('15087','2014-02-15','10:55:00',2.97),('15087','2014-02-15','11:00:00',2.4),('15087','2014-02-15','11:05:00',3.09),('15087','2014-02-15','11:10:00',3.15),('15087','2014-02-15','11:15:00',2.36),('15087','2014-02-15','11:20:00',1.88),('15087','2014-02-15','11:25:00',3.48),('15087','2014-02-15','11:30:00',2.82),('15087','2014-02-15','11:35:00',2.46),('15087','2014-02-15','11:40:00',3.64),('15087','2014-02-15','11:45:00',3.66),('15087','2014-02-15','11:50:00',2.73),('15087','2014-02-15','11:55:00',2.2),('15087','2014-02-15','12:00:00',1.12),('15087','2014-02-15','12:05:00',1.41),('15087','2014-02-15','12:10:00',3.76),('15087','2014-02-15','12:15:00',3.58),('15087','2014-02-15','12:20:00',3.19),('15087','2014-02-15','12:25:00',1.22),('15087','2014-02-15','12:30:00',2.83),('15087','2014-02-15','12:35:00',3.69),('15087','2014-02-15','12:40:00',3.11),('15087','2014-02-15','12:45:00',3.92),('15087','2014-02-15','12:50:00',3.82),('15087','2014-02-15','12:55:00',2.57),('15087','2014-02-15','13:00:00',3.42),('15087','2014-02-15','13:05:00',3.71),('15087','2014-02-15','13:10:00',3.46),('15087','2014-02-15','13:15:00',3.16),('15087','2014-02-15','13:20:00',3.19),('15087','2014-02-15','13:25:00',2.9),('15087','2014-02-15','13:30:00',3.01),('15087','2014-02-15','13:35:00',3.01),('15087','2014-02-15','13:40:00',2.81),('15087','2014-02-15','13:45:00',2.84),('15087','2014-02-15','13:50:00',2.85),('15087','2014-02-15','13:55:00',2.68),('15087','2014-02-15','14:00:00',2.65),('15087','2014-02-15','14:05:00',2.63),('15087','2014-02-15','14:10:00',2.57),('15087','2014-02-15','14:15:00',2.5),('15087','2014-02-15','14:20:00',2.51),('15087','2014-02-15','14:25:00',2.45),('15087','2014-02-15','14:30:00',2.2),('15087','2014-02-15','14:35:00',2.25),('15087','2014-02-15','14:40:00',2.12),('15087','2014-02-15','14:45:00',2.08),('15087','2014-02-15','14:50:00',1.88),('15087','2014-02-15','14:55:00',1.85),('15087','2014-02-15','15:00:00',1.89),('15087','2014-02-15','15:05:00',1.74),('15087','2014-02-15','15:10:00',1.71),('15087','2014-02-15','15:15:00',1.69),('15087','2014-02-15','15:20:00',1.63),('15087','2014-02-15','15:25:00',1.56),('15087','2014-02-15','15:30:00',1.48),('15087','2014-02-15','15:35:00',1.32),('15087','2014-02-15','15:40:00',1.24),('15087','2014-02-15','15:45:00',1.2),('15087','2014-02-15','15:50:00',1.12),('15087','2014-02-15','15:55:00',1.02),('15087','2014-02-14','08:45:00',1.2),('15087','2014-02-14','08:50:00',1.49),('15087','2014-02-14','08:55:00',1.57),('15087','2014-02-14','09:00:00',1.64),('15087','2014-02-14','09:05:00',1.73),('15087','2014-02-14','09:10:00',1.46),('15087','2014-02-14','09:15:00',1.55),('15087','2014-02-14','09:20:00',1.97),('15087','2014-02-14','09:25:00',2.21),('15087','2014-02-14','09:30:00',1.84),('15087','2014-02-14','09:35:00',1.47),('15087','2014-02-14','09:45:00',1.39),('15087','2014-02-14','09:50:00',2.8),('15087','2014-02-14','09:55:00',2.48),('15087','2014-02-14','10:00:00',2.71),('15087','2014-02-14','10:05:00',2.8),('15087','2014-02-14','10:10:00',2.85),('15087','2014-02-14','10:15:00',1.71),('15087','2014-02-14','10:20:00',3.08),('15087','2014-02-14','10:25:00',3.01),('15087','2014-02-14','10:30:00',3.03),('15087','2014-02-14','10:35:00',2.84),('15087','2014-02-14','10:40:00',3.07),('15087','2014-02-14','10:45:00',3.19),('15087','2014-02-14','10:50:00',3.21),('15087','2014-02-14','10:55:00',3.22),('15087','2014-02-14','11:00:00',3.28),('15087','2014-02-14','11:05:00',3.29),('15087','2014-02-14','11:10:00',3.3),('15087','2014-02-14','11:15:00',3.34),('15087','2014-02-14','11:20:00',3.39),('15087','2014-02-14','11:25:00',3.41),('15087','2014-02-14','11:30:00',3.46),('15087','2014-02-14','11:35:00',3.47),('15087','2014-02-14','11:40:00',3.48),('15087','2014-02-14','11:45:00',3.51),('15087','2014-02-14','11:50:00',3.5),('15087','2014-02-14','11:55:00',3.54),('15087','2014-02-14','12:00:00',3.1),('15087','2014-02-14','12:05:00',3.53),('15087','2014-02-14','12:10:00',3.59),('15087','2014-02-14','12:15:00',3.52),('15087','2014-02-14','12:20:00',3.53),('15087','2014-02-14','12:25:00',3.53),('15087','2014-02-14','12:30:00',3.5),('15087','2014-02-14','12:35:00',3.52),('15087','2014-02-14','12:40:00',3.49),('15087','2014-02-14','12:45:00',3.47),('15087','2014-02-14','12:50:00',3.41),('15087','2014-02-14','12:55:00',3.31),('15087','2014-02-14','13:00:00',3.37),('15087','2014-02-14','13:05:00',3.3),('15087','2014-02-14','13:10:00',2.97),('15087','2014-02-14','13:15:00',2.9),('15087','2014-02-14','13:20:00',3.01),('15087','2014-02-14','13:25:00',2.85),('15087','2014-02-14','13:30:00',2.8),('15087','2014-02-14','13:35:00',2.92),('15087','2014-02-14','13:40:00',2.97),('15087','2014-02-14','13:45:00',2.91),('15087','2014-02-14','13:50:00',2.86),('15087','2014-02-14','13:55:00',2.84),('15087','2014-02-14','14:00:00',2.77),('15087','2014-02-14','14:05:00',2.67),('15087','2014-02-14','14:10:00',2.66),('15087','2014-02-14','14:15:00',2.6),('15087','2014-02-14','14:20:00',2.55),('15087','2014-02-14','14:25:00',2.51),('15087','2014-02-14','14:30:00',2.4),('15087','2014-02-14','14:35:00',2.29),('15087','2014-02-14','14:40:00',2.22),('15087','2014-02-14','14:45:00',1.95),('15087','2014-02-14','14:50:00',2.02),('15087','2014-02-14','14:55:00',1.88),('15087','2014-02-14','15:00:00',1.82),('15087','2014-02-14','15:05:00',1.81),('15087','2014-02-14','15:10:00',1.78),('15087','2014-02-14','15:15:00',1.77),('15087','2014-02-14','15:20:00',1.73),('15087','2014-02-14','15:25:00',1.51),('15087','2014-02-14','15:30:00',1.41),('15087','2014-02-14','15:35:00',1.36),('15087','2014-02-14','15:40:00',1.24),('15087','2014-02-14','15:45:00',1.17),('15087','2014-02-14','15:50:00',1.11),('15087','2014-02-14','15:55:00',1.01),('15087','2014-02-12','08:45:00',1.4),('15087','2014-02-12','08:50:00',1.45),('15087','2014-02-12','08:55:00',1.19),('15087','2014-02-12','09:10:00',1.53),('15087','2014-02-12','09:15:00',1.91),('15087','2014-02-12','09:20:00',1.74),('15087','2014-02-12','09:25:00',1.77),('15087','2014-02-12','09:40:00',1.9),('15087','2014-02-12','09:45:00',2.33),('15087','2014-02-12','09:50:00',2.47),('15087','2014-02-12','09:55:00',1.04),('15087','2014-02-12','10:00:00',1.12),('15087','2014-02-12','10:05:00',1.65),('15087','2014-02-12','10:10:00',1.46),('15087','2014-02-12','10:15:00',1.13),('15087','2014-02-12','10:20:00',1.06),('15087','2014-02-12','10:25:00',1.14),('15087','2014-02-12','10:30:00',1.49),('15087','2014-02-12','10:35:00',1.58),('15087','2014-02-12','10:40:00',1.39),('15087','2014-02-12','10:45:00',1.92),('15087','2014-02-12','10:50:00',1.47),('15087','2014-02-12','10:55:00',1.5),('15087','2014-02-12','11:00:00',1.59),('15087','2014-02-12','11:05:00',2.28),('15087','2014-02-12','11:10:00',1.66),('15087','2014-02-12','11:15:00',1.54),('15087','2014-02-12','11:20:00',1.55),('15087','2014-02-12','11:25:00',1.71),('15087','2014-02-12','11:30:00',1.7),('15087','2014-02-12','11:35:00',2.29),('15087','2014-02-12','11:40:00',1.14),('15087','2014-02-12','12:10:00',1.24),('15087','2014-02-12','12:15:00',1.38),('15087','2014-02-12','12:20:00',1.4),('15087','2014-02-12','12:25:00',1.47),('15087','2014-02-12','12:30:00',1.54),('15087','2014-02-12','12:35:00',1.48),('15087','2014-02-12','12:40:00',1.46),('15087','2014-02-12','12:45:00',1.63),('15087','2014-02-12','12:50:00',1.79),('15087','2014-02-12','12:55:00',1.89),('15087','2014-02-12','13:00:00',2.2),('15087','2014-02-12','13:05:00',1.99),('15087','2014-02-12','13:10:00',2.02),('15087','2014-02-12','13:15:00',1.36),('15087','2014-02-12','13:20:00',1.31),('15087','2014-02-12','13:25:00',1.71),('15087','2014-02-12','13:30:00',2.69),('15087','2014-02-12','13:35:00',2.85),('15087','2014-02-11','09:20:00',1.17),('15087','2014-02-11','09:25:00',1.33),('15087','2014-02-11','09:30:00',1.31),('15087','2014-02-11','09:35:00',1.32),('15087','2014-02-11','09:40:00',1.25),('15087','2014-02-11','09:45:00',1.24),('15087','2014-02-11','09:50:00',1.36),('15087','2014-02-11','09:55:00',1.34),('15087','2014-02-11','10:00:00',1.12),('15087','2014-02-11','10:15:00',1.66),('15087','2014-02-11','10:20:00',2.07),('15087','2014-02-11','10:25:00',2.13),('15087','2014-02-11','10:30:00',2.29),('15087','2014-02-11','10:35:00',2),('15087','2014-02-11','10:40:00',2.41),('15087','2014-02-11','10:45:00',2.34),('15087','2014-02-11','10:50:00',2.53),('15087','2014-02-11','10:55:00',1.68),('15087','2014-02-11','11:00:00',2.13),('15087','2014-02-11','11:05:00',2.23),('15087','2014-02-11','11:10:00',2.26),('15087','2014-02-11','11:15:00',1.77),('15087','2014-02-11','11:20:00',1.59),('15087','2014-02-11','11:25:00',1.77),('15087','2014-02-11','11:30:00',1.95),('15087','2014-02-11','11:35:00',1.55),('15087','2014-02-11','11:40:00',1.66),('15087','2014-02-11','11:45:00',2.25),('15087','2014-02-11','11:50:00',1.41),('15087','2014-02-11','11:55:00',1.24),('15087','2014-02-11','12:00:00',1.34),('15087','2014-02-11','12:05:00',1.7),('15087','2014-02-11','12:10:00',1.96),('15087','2014-02-11','12:15:00',1.71),('15087','2014-02-11','12:20:00',1.84),('15087','2014-02-11','12:25:00',2.47),('15087','2014-02-11','12:30:00',2.37),('15087','2014-02-11','12:35:00',2.13),('15087','2014-02-11','12:40:00',1.54),('15087','2014-02-11','12:45:00',1.86),('15087','2014-02-11','12:50:00',1.45),('15087','2014-02-11','12:55:00',1.83),('15087','2014-02-11','13:00:00',1.89),('15087','2014-02-11','13:05:00',2.36),('15087','2014-02-11','13:10:00',2.92),('15087','2014-02-11','13:15:00',2.71),('15087','2014-02-11','13:20:00',3.09),('15087','2014-02-11','13:25:00',2.77),('15087','2014-02-11','13:30:00',2.56),('15087','2014-02-11','13:35:00',2.38),('15087','2014-02-11','13:40:00',2.74),('15087','2014-02-11','13:45:00',2.07),('15087','2014-02-11','13:50:00',1.73),('15087','2014-02-11','13:55:00',1.4),('15087','2014-02-11','14:00:00',1.93),('15087','2014-02-11','14:05:00',2.24),('15087','2014-02-11','14:10:00',1.56),('15087','2014-02-11','14:15:00',2.21),('15087','2014-02-11','14:20:00',1.58),('15087','2014-02-11','14:25:00',1.45),('15087','2014-02-11','14:30:00',1.46),('15087','2014-02-11','14:35:00',1.39),('15087','2014-02-11','14:40:00',1.11),('15087','2014-02-11','14:45:00',1.14),('15087','2014-02-11','15:15:00',1.33),('15087','2014-02-11','15:20:00',1.39),('15087','2014-02-11','15:25:00',1.11),('15087','2014-02-10','12:55:00',1.01),('15087','2014-02-10','13:00:00',1.37),('15087','2014-02-10','13:05:00',1.12),('15087','2014-02-10','14:00:00',1.03),('15087','2014-02-10','14:30:00',1.03),('15087','2014-02-10','14:35:00',1.11),('15087','2014-02-10','14:40:00',1.16),('15087','2014-02-10','14:45:00',1.05),('15087','2014-02-09','11:25:00',1.05),('15087','2014-02-09','11:30:00',1.19),('15087','2014-02-09','11:35:00',1.53),('15087','2014-02-08','09:50:00',2.54),('15087','2014-02-08','09:55:00',1.08),('15087','2014-02-08','10:15:00',1.55),('15087','2014-02-08','10:20:00',1.11),('15087','2014-02-08','10:25:00',1.12),('15087','2014-02-08','10:30:00',2.44),('15087','2014-02-08','10:35:00',2.64),('15087','2014-02-08','10:40:00',1.15),('15087','2014-02-08','10:45:00',1.66),('15087','2014-02-08','10:50:00',2.19),('15087','2014-02-08','10:55:00',2.24),('15087','2014-02-08','11:00:00',2.17),('15087','2014-02-08','11:05:00',3.32),('15087','2014-02-08','11:10:00',2.14),('15087','2014-02-08','11:15:00',2.14),('15087','2014-02-08','11:20:00',1.04),('15087','2014-02-08','11:30:00',2.45),('15087','2014-02-08','11:35:00',3.69),('15087','2014-02-08','11:40:00',1.67),('15087','2014-02-08','11:50:00',2.16),('15087','2014-02-08','11:55:00',3.62),('15087','2014-02-08','12:05:00',1.37),('15087','2014-02-08','12:10:00',2.65),('15087','2014-02-08','12:15:00',2.92),('15087','2014-02-08','12:25:00',3.41),('15087','2014-02-08','12:30:00',3.43),('15087','2014-02-08','12:35:00',2.89),('15087','2014-02-08','12:40:00',1.82),('15087','2014-02-08','12:45:00',3.82),('15087','2014-02-08','12:50:00',2.82),('15087','2014-02-08','12:55:00',3.11),('15087','2014-02-08','13:00:00',2.44),('15087','2014-02-08','13:10:00',2.59),('15087','2014-02-08','13:15:00',4.1),('15087','2014-02-08','13:20:00',3.55),('15087','2014-02-08','13:25:00',2.82),('15087','2014-02-08','13:30:00',1.78),('15087','2014-02-08','13:35:00',2.55),('15087','2014-02-08','13:40:00',2.75),('15087','2014-02-08','13:45:00',3.2),('15087','2014-02-08','13:50:00',2.66),('15087','2014-02-08','13:55:00',2.74),('15087','2014-02-08','14:00:00',2.73),('15087','2014-02-08','14:05:00',2.61),('15087','2014-02-08','14:10:00',2.47),('15087','2014-02-08','14:15:00',1.35),('15087','2014-02-08','14:20:00',2.05),('15087','2014-02-08','14:25:00',1.8),('15087','2014-02-08','14:30:00',2.55),('15087','2014-02-08','14:35:00',1.32),('15087','2014-02-08','14:40:00',1.38),('15087','2014-02-08','14:50:00',2.23),('15087','2014-02-08','14:55:00',2.05),('15087','2014-02-08','15:15:00',1.07),('15087','2014-02-08','15:20:00',1.8),('15087','2014-02-08','15:40:00',1.58),('15087','2014-02-08','15:45:00',1.47),('15087','2014-02-08','15:50:00',1.17),('15087','2014-02-07','08:40:00',1.01),('15087','2014-02-07','08:45:00',1.17),('15087','2014-02-07','08:50:00',1.31),('15087','2014-02-07','08:55:00',1.43),('15087','2014-02-07','09:00:00',1.54),('15087','2014-02-07','09:05:00',1.65),('15087','2014-02-07','09:10:00',1.73),('15087','2014-02-07','09:15:00',1.82),('15087','2014-02-07','09:20:00',1.86),('15087','2014-02-07','09:25:00',1.97),('15087','2014-02-07','09:30:00',2.04),('15087','2014-02-07','09:35:00',2.1),('15087','2014-02-07','09:40:00',2.16),('15087','2014-02-07','09:45:00',2.22),('15087','2014-02-07','09:50:00',2.28),('15087','2014-02-07','09:55:00',2.33),('15087','2014-02-07','10:00:00',2.41),('15087','2014-02-07','10:05:00',2.47),('15087','2014-02-07','10:10:00',2.54),('15087','2014-02-07','10:15:00',2.71),('15087','2014-02-07','10:20:00',2.76),('15087','2014-02-07','10:25:00',2.73),('15087','2014-02-07','10:30:00',2.41),('15087','2014-02-07','10:35:00',2.78),('15087','2014-02-07','10:40:00',2.1),('15087','2014-02-07','10:45:00',2.89),('15087','2014-02-07','10:50:00',3.22),('15087','2014-02-07','10:55:00',3.12),('15087','2014-02-07','11:00:00',3.42),('15087','2014-02-07','11:05:00',3.4),('15087','2014-02-07','11:10:00',3.54),('15087','2014-02-07','11:15:00',3.58),('15087','2014-02-07','11:20:00',3.47),('15087','2014-02-07','11:25:00',2.02),('15087','2014-02-07','11:30:00',3.45),('15087','2014-02-07','11:35:00',3.11),('15087','2014-02-07','11:40:00',3.48),('15087','2014-02-07','11:45:00',2.88),('15087','2014-02-07','11:50:00',2.76),('15087','2014-02-07','11:55:00',3.27),('15087','2014-02-07','12:00:00',2.8),('15087','2014-02-07','12:05:00',1.99),('15087','2014-02-07','12:10:00',1.84),('15087','2014-02-07','12:15:00',3.96),('15087','2014-02-07','12:20:00',2.71),('15087','2014-02-07','12:25:00',1.52),('15087','2014-02-07','12:30:00',1.99),('15087','2014-02-07','12:35:00',1.13),('15087','2014-02-07','12:40:00',1.64),('15087','2014-02-07','12:45:00',2.57),('15087','2014-02-07','12:50:00',4.14),('15087','2014-02-07','12:55:00',3.95),('15087','2014-02-07','13:00:00',1.39),('15087','2014-02-07','13:05:00',2.82),('15087','2014-02-07','13:10:00',3.21),('15087','2014-02-07','13:15:00',1.14),('15087','2014-02-07','13:20:00',1.98),('15087','2014-02-07','13:25:00',1.04),('15087','2014-02-07','13:30:00',1.21),('15087','2014-02-07','13:35:00',2.05),('15087','2014-02-07','13:45:00',2.96),('15087','2014-02-07','13:50:00',2.98),('15087','2014-02-07','13:55:00',3.03),('15087','2014-02-07','14:00:00',1.71),('15087','2014-02-07','14:05:00',2.16),('15087','2014-02-07','14:10:00',2.67),('15087','2014-02-07','14:15:00',2.56),('15087','2014-02-07','14:20:00',2.08),('15087','2014-02-07','14:25:00',1.48),('15087','2014-02-07','14:30:00',2.16),('15087','2014-02-07','14:35:00',2.69),('15087','2014-02-07','14:40:00',2.44),('15087','2014-02-07','14:45:00',2.08),('15087','2014-02-07','14:50:00',2.01),('15087','2014-02-07','14:55:00',1.92),('15087','2014-02-07','15:00:00',1.78),('15087','2014-02-07','15:05:00',1.76),('15087','2014-02-07','15:10:00',1.69),('15087','2014-02-07','15:15:00',1.63),('15087','2014-02-07','15:20:00',1.61),('15087','2014-02-07','15:25:00',1.38),('15087','2014-02-07','15:30:00',1.37),('15087','2014-02-07','15:35:00',1.32),('15087','2014-02-07','15:40:00',1.25),('15087','2014-02-07','15:45:00',1.18),('15087','2014-02-07','15:50:00',1.11),('15087','2014-02-07','15:55:00',1.06),('15087','2014-02-06','08:45:00',1.04),('15087','2014-02-06','08:50:00',1.26),('15087','2014-02-06','08:55:00',1.58),('15087','2014-02-06','09:00:00',1.91),('15087','2014-02-06','09:05:00',2.12),('15087','2014-02-06','09:10:00',1.98),('15087','2014-02-06','09:15:00',1.79),('15087','2014-02-06','09:30:00',1.68),('15087','2014-02-06','09:35:00',2.17),('15087','2014-02-06','09:40:00',2.17),('15087','2014-02-06','09:45:00',2.28),('15087','2014-02-06','09:50:00',2.33),('15087','2014-02-06','09:55:00',2.41),('15087','2014-02-06','10:00:00',2.47),('15087','2014-02-06','10:05:00',2.53),('15087','2014-02-06','10:10:00',2.58),('15087','2014-02-06','10:15:00',2.66),('15087','2014-02-06','10:20:00',2.71),('15087','2014-02-06','10:25:00',2.54),('15087','2014-02-06','10:30:00',2.82),('15087','2014-02-06','10:35:00',2.47),('15087','2014-02-06','10:40:00',2.56),('15087','2014-02-06','10:45:00',2.44),('15087','2014-02-06','10:50:00',2.25),('15087','2014-02-06','10:55:00',2.56),('15087','2014-02-06','11:00:00',2.28),('15087','2014-02-06','11:05:00',2.1),('15087','2014-02-06','11:10:00',1.56),('15087','2014-02-06','11:15:00',1.52),('15087','2014-02-06','11:20:00',3.3),('15087','2014-02-06','11:25:00',2.17),('15087','2014-02-06','11:30:00',3.68),('15087','2014-02-06','11:35:00',3.42),('15087','2014-02-06','11:40:00',3.34),('15087','2014-02-06','11:45:00',3.38),('15087','2014-02-06','11:50:00',3.42),('15087','2014-02-06','11:55:00',3.43),('15087','2014-02-06','12:00:00',3.46),('15087','2014-02-06','12:05:00',3.55),('15087','2014-02-06','12:10:00',3.51),('15087','2014-02-06','12:15:00',3.49),('15087','2014-02-06','12:20:00',3.49),('15087','2014-02-06','12:25:00',3.45),('15087','2014-02-06','12:30:00',3.44),('15087','2014-02-06','12:35:00',2.97),('15087','2014-02-06','12:40:00',3.52),('15087','2014-02-06','12:45:00',3.46),('15087','2014-02-06','12:50:00',3.33),('15087','2014-02-06','12:55:00',3.04),('15087','2014-02-06','13:00:00',3.33),('15087','2014-02-06','13:05:00',2.66),('15087','2014-02-06','13:10:00',3.36),('15087','2014-02-06','13:15:00',3.28),('15087','2014-02-06','13:20:00',3.16),('15087','2014-02-06','13:25:00',1.77),('15087','2014-02-06','13:30:00',3.19),('15087','2014-02-06','13:35:00',2.93),('15087','2014-02-06','13:40:00',2.85),('15087','2014-02-06','13:45:00',2.88),('15087','2014-02-06','13:50:00',2.74),('15087','2014-02-06','13:55:00',2.7),('15087','2014-02-06','14:00:00',2.58),('15087','2014-02-06','14:05:00',2.48),('15087','2014-02-06','14:10:00',2.08),('15087','2014-02-06','14:15:00',2.39),('15087','2014-02-06','14:20:00',2.34),('15087','2014-02-06','14:25:00',2.31),('15087','2014-02-06','14:30:00',2.47),('15087','2014-02-06','14:35:00',2.35),('15087','2014-02-06','14:40:00',2.1),('15087','2014-02-06','14:45:00',2.23),('15087','2014-02-06','14:50:00',2.08),('15087','2014-02-06','14:55:00',1.93),('15087','2014-02-06','15:00:00',1.87),('15087','2014-02-06','15:05:00',1.75),('15087','2014-02-06','15:10:00',1.7),('15087','2014-02-06','15:15:00',1.62),('15087','2014-02-06','15:20:00',1.61),('15087','2014-02-06','15:25:00',1.37),('15087','2014-02-06','15:30:00',1.34),('15087','2014-02-06','15:35:00',1.27),('15087','2014-02-06','15:40:00',1.18),('15087','2014-02-06','15:45:00',1.14),('15087','2014-02-06','15:50:00',1.05),('15087','2014-02-06','15:55:00',1.01),('15087','2014-02-05','10:15:00',1.87),('15087','2014-02-05','10:20:00',3.17),('15087','2014-02-05','10:25:00',2.95),('15087','2014-02-05','10:35:00',1.1),('15087','2014-02-05','10:40:00',1.59),('15087','2014-02-05','11:10:00',1),('15087','2014-02-05','11:15:00',2.51),('15087','2014-02-05','11:20:00',4.15),('15087','2014-02-05','11:25:00',2.12),('15087','2014-02-05','11:30:00',1.35),('15087','2014-02-05','12:55:00',1.42),('15087','2014-02-05','13:00:00',1.11),('15087','2014-02-05','13:05:00',1.28),('15087','2014-02-05','13:10:00',1.66),('15087','2014-02-05','13:15:00',1.33),('15087','2014-02-05','13:20:00',1.63),('15087','2014-02-05','13:25:00',1.8),('15087','2014-02-05','13:30:00',1.78),('15087','2014-02-05','13:35:00',2.14),('15087','2014-02-05','13:40:00',2.2),('15087','2014-02-05','13:45:00',2.1),('15087','2014-02-05','13:50:00',1.87),('15087','2014-02-05','13:55:00',1.29),('15087','2014-02-05','14:30:00',2.72),('15087','2014-02-05','14:35:00',1.76),('15087','2014-02-04','09:15:00',1.14),('15087','2014-02-04','09:20:00',1.46),('15087','2014-02-04','09:25:00',1.47),('15087','2014-02-04','09:30:00',1.68),('15087','2014-02-04','09:35:00',1.45),('15087','2014-02-04','09:40:00',2.18),('15087','2014-02-04','09:45:00',2.33),('15087','2014-02-04','09:50:00',2.39),('15087','2014-02-04','09:55:00',1.5),('15087','2014-02-04','10:00:00',2.33),('15087','2014-02-04','10:05:00',2.73),('15087','2014-02-04','10:10:00',2.09),('15087','2014-02-04','10:15:00',1.82),('15087','2014-02-04','10:20:00',1.67),('15087','2014-02-04','10:40:00',1.22),('15087','2014-02-04','10:45:00',1.5),('15087','2014-02-04','10:50:00',2.25),('15087','2014-02-04','10:55:00',2.76),('15087','2014-02-04','11:00:00',3.51),('15087','2014-02-04','11:05:00',1.56),('15087','2014-02-04','11:10:00',1.15),('15087','2014-02-04','11:20:00',1.2),('15087','2014-02-04','11:25:00',1.01),('15087','2014-02-04','11:30:00',1.1),('15087','2014-02-04','11:50:00',1.64),('15087','2014-02-04','11:55:00',3.05),('15087','2014-02-04','12:00:00',2.79),('15087','2014-02-04','12:05:00',1.94),('15087','2014-02-04','12:10:00',2.13),('15087','2014-02-04','12:15:00',1.73),('15087','2014-02-04','12:20:00',1.73),('15087','2014-02-04','12:25:00',1.41),('15087','2014-02-04','12:45:00',1.18),('15087','2014-02-04','12:50:00',1.16),('15087','2014-02-04','12:55:00',1.07),('15087','2014-02-04','13:00:00',1.36),('15087','2014-02-04','13:05:00',1.38),('15087','2014-02-04','13:10:00',1.21),('15087','2014-02-04','13:15:00',1.42),('15087','2014-02-04','13:20:00',1.98),('15087','2014-02-04','13:25:00',1.68),('15087','2014-02-04','13:30:00',1.23),('15087','2014-02-04','13:35:00',1.07),('15087','2014-02-03','09:50:00',1.01),('15087','2014-02-03','10:15:00',1.13),('15087','2014-02-03','10:20:00',1.04),('15087','2014-02-03','10:25:00',1.07),('15087','2014-02-03','10:30:00',1.09),('15087','2014-02-03','10:35:00',1.09),('15087','2014-02-03','10:40:00',1.15),('15087','2014-02-03','10:45:00',1.18),('15087','2014-02-03','10:50:00',1.16),('15087','2014-02-03','10:55:00',1.16),('15087','2014-02-03','11:00:00',1.07),('15087','2014-02-03','11:05:00',1.04),('15087','2014-02-03','11:10:00',1.02),('15087','2014-02-03','11:15:00',1),('15087','2014-02-03','11:20:00',1.06),('15087','2014-02-03','11:25:00',1.19),('15087','2014-02-03','11:30:00',1.36),('15087','2014-02-03','11:35:00',1.42),('15087','2014-02-03','11:40:00',1.43),('15087','2014-02-03','11:45:00',1.46),('15087','2014-02-03','11:50:00',1.42),('15087','2014-02-03','11:55:00',1.28),('15087','2014-02-03','12:00:00',1.12),('15087','2014-02-03','12:05:00',1.03),('15087','2014-02-03','12:10:00',1.03),('15087','2014-02-03','12:15:00',1.11),('15087','2014-02-03','12:20:00',1.11),('15087','2014-02-03','12:25:00',1),('15087','2014-02-02','12:00:00',1.01),('15087','2014-02-02','12:05:00',1.04),('15087','2014-02-02','12:10:00',1.01),('15087','2014-02-01','11:00:00',1.19),('15087','2014-02-01','11:05:00',1.03),('15087','2014-02-01','11:15:00',1.01),('15087','2014-02-01','11:20:00',1.83),('15087','2014-02-01','11:25:00',1.31),('15087','2014-02-01','11:30:00',1.64),('15087','2014-02-01','11:35:00',1.66),('15087','2014-02-01','11:55:00',1.56),('15087','2014-02-01','12:00:00',1.31),('15087','2014-02-01','12:05:00',1.19),('15087','2014-02-01','12:10:00',2.1),('15087','2014-02-01','12:15:00',1.42),('15087','2014-02-01','12:20:00',2.4),('15087','2014-02-01','12:25:00',1.8),('15087','2014-02-01','12:35:00',1.01),('15087','2014-02-01','12:40:00',1.3),('15087','2014-02-01','12:45:00',2.16),('15087','2014-02-01','12:50:00',2.21),('15087','2014-02-01','12:55:00',1.78),('15087','2014-02-01','13:00:00',1.79),('15087','2014-02-01','13:05:00',1.25),('15087','2014-01-30','09:50:00',1.33),('15087','2014-01-30','09:55:00',2.01),('15087','2014-01-30','10:00:00',1.91),('15087','2014-01-30','10:05:00',1.38),('15087','2014-01-30','10:10:00',1.81),('15087','2014-01-30','10:15:00',2.39),('15087','2014-01-30','10:20:00',2.05),('15087','2014-01-30','10:25:00',2.47),('15087','2014-01-30','10:30:00',2.66),('15087','2014-01-30','10:35:00',2.68),('15087','2014-01-30','10:40:00',2.71),('15087','2014-01-30','10:45:00',2.36),('15087','2014-01-30','10:50:00',2.96),('15087','2014-01-30','10:55:00',3.41),('15087','2014-01-30','11:00:00',3.38),('15087','2014-01-30','11:05:00',3.22),('15087','2014-01-30','11:10:00',2.69),('15087','2014-01-30','11:15:00',2.66),('15087','2014-01-30','11:20:00',1.76),('15087','2014-01-30','11:25:00',2.61),('15087','2014-01-30','11:30:00',2.46),('15087','2014-01-30','11:35:00',2.64),('15087','2014-01-30','11:40:00',2.18),('15087','2014-01-30','11:45:00',3.15),('15087','2014-01-30','11:50:00',3.21),('15087','2014-01-30','11:55:00',3.11),('15087','2014-01-30','12:00:00',2.6),('15087','2014-01-30','12:05:00',3.31),('15087','2014-01-30','12:10:00',3.32),('15087','2014-01-30','12:15:00',3),('15087','2014-01-30','12:20:00',3.46),('15087','2014-01-30','12:25:00',2.82),('15087','2014-01-30','12:30:00',2.62),('15087','2014-01-30','12:35:00',2.69),('15087','2014-01-30','12:40:00',2.59),('15087','2014-01-30','12:45:00',3.13),('15087','2014-01-30','12:50:00',3.14),('15087','2014-01-30','12:55:00',2.97),('15087','2014-01-30','13:00:00',3.13),('15087','2014-01-30','13:05:00',3.22),('15087','2014-01-30','13:10:00',2.6),('15087','2014-01-30','13:15:00',2.87),('15087','2014-01-30','13:20:00',2.51),('15087','2014-01-30','13:25:00',2.61),('15087','2014-01-30','13:30:00',2.16),('15087','2014-01-30','13:35:00',1.98),('15087','2014-01-30','13:40:00',2.5),('15087','2014-01-30','13:45:00',2.65),('15087','2014-01-30','13:50:00',2.33),('15087','2014-01-30','13:55:00',2.13),('15087','2014-01-30','14:00:00',2.17),('15087','2014-01-30','14:05:00',1.94),('15087','2014-01-30','14:10:00',1.98),('15087','2014-01-30','14:15:00',1.78),('15087','2014-01-30','14:20:00',1.63),('15087','2014-01-30','14:25:00',1.76),('15087','2014-01-30','14:30:00',1.84),('15087','2014-01-30','14:35:00',1.69),('15087','2014-01-30','14:40:00',1.93),('15087','2014-01-30','14:45:00',1.81),('15087','2014-01-30','14:50:00',1.85),('15087','2014-01-30','14:55:00',1.71),('15087','2014-01-30','15:00:00',1.65),('15087','2014-01-30','15:05:00',1.63),('15087','2014-01-30','15:10:00',1.55),('15087','2014-01-30','15:15:00',1.46),('15087','2014-01-30','15:20:00',1.47),('15087','2014-01-30','15:25:00',1.42),('15087','2014-01-30','15:30:00',1.27),('15087','2014-01-30','15:35:00',1.25),('15087','2014-01-30','15:40:00',1.14),('15087','2014-01-29','09:20:00',1.35),('15087','2014-01-29','09:30:00',1.34),('15087','2014-01-29','09:35:00',2.1),('15087','2014-01-29','09:40:00',1.7),('15087','2014-01-29','09:45:00',1.87),('15087','2014-01-29','09:50:00',1.7),('15087','2014-01-29','09:55:00',1.74),('15087','2014-01-29','10:00:00',1.34),('15087','2014-01-29','10:05:00',1.35),('15087','2014-01-29','10:10:00',1.77),('15087','2014-01-29','10:15:00',1.77),('15087','2014-01-29','10:20:00',1.37),('15087','2014-01-29','10:25:00',2.92),('15087','2014-01-29','10:30:00',3.18),('15087','2014-01-29','10:35:00',2.53),('15087','2014-01-29','10:40:00',2.26),('15087','2014-01-29','10:45:00',2.12),('15087','2014-01-29','10:50:00',2.17),('15087','2014-01-29','10:55:00',1.92),('15087','2014-01-29','11:00:00',1.98),('15087','2014-01-29','11:05:00',2.22),('15087','2014-01-29','11:10:00',1.9),('15087','2014-01-29','11:15:00',1.94),('15087','2014-01-29','11:20:00',2.1),('15087','2014-01-29','11:25:00',2.2),('15087','2014-01-29','11:30:00',2.85),('15087','2014-01-29','11:35:00',2.33),('15087','2014-01-29','11:40:00',1.21),('15087','2014-01-29','11:45:00',1.18),('15087','2014-01-29','12:45:00',1.26),('15087','2014-01-29','12:50:00',2.86),('15087','2014-01-29','12:55:00',3.31),('15087','2014-01-29','13:00:00',1.75),('15087','2014-01-29','13:05:00',1.48),('15087','2014-01-29','13:35:00',1.85),('15087','2014-01-29','13:40:00',3.13),('15087','2014-01-29','13:45:00',2.15),('15087','2014-01-29','13:50:00',2.31),('15087','2014-01-29','13:55:00',2.63),('15087','2014-01-29','14:00:00',1.18),('15087','2014-01-29','15:10:00',1),('15087','2014-01-29','15:15:00',1.6),('15087','2014-01-29','15:20:00',1.05),('15087','2014-01-28','09:10:00',1.17),('15087','2014-01-28','09:15:00',1.27),('15087','2014-01-28','09:20:00',1.31),('15087','2014-01-28','09:25:00',1.35),('15087','2014-01-28','09:30:00',1.37),('15087','2014-01-28','09:35:00',1.56),('15087','2014-01-28','09:40:00',1.37),('15087','2014-01-28','09:45:00',1.7),('15087','2014-01-28','09:50:00',1.99),('15087','2014-01-28','09:55:00',2.16),('15087','2014-01-28','10:00:00',2.19),('15087','2014-01-28','10:05:00',2.1),('15087','2014-01-28','10:10:00',2.09),('15087','2014-01-28','10:15:00',2.25),('15087','2014-01-28','10:20:00',2.42),('15087','2014-01-28','10:25:00',2.56),('15087','2014-01-28','10:30:00',2.57),('15087','2014-01-28','10:35:00',2.69),('15087','2014-01-28','10:40:00',2.71),('15087','2014-01-28','10:45:00',2.53),('15087','2014-01-28','10:50:00',2.51),('15087','2014-01-28','10:55:00',2.19),('15087','2014-01-28','11:00:00',2.94),('15087','2014-01-28','11:05:00',1.86),('15087','2014-01-28','11:10:00',2.1),('15087','2014-01-28','11:15:00',1.41),('15087','2014-01-28','11:25:00',2.37),('15087','2014-01-28','11:30:00',1.29),('15087','2014-01-28','11:35:00',2.41),('15087','2014-01-28','11:40:00',3.51),('15087','2014-01-28','11:45:00',2.84),('15087','2014-01-28','12:00:00',2.87),('15087','2014-01-28','12:05:00',3.18),('15087','2014-01-28','12:10:00',2.2),('15087','2014-01-28','12:15:00',2.81),('15087','2014-01-28','12:20:00',1.58),('15087','2014-01-28','12:25:00',1.2),('15087','2014-01-28','12:30:00',1.2),('15087','2014-01-28','12:35:00',1.62),('15087','2014-01-28','12:40:00',1.77),('15087','2014-01-28','12:45:00',2.67),('15087','2014-01-28','12:50:00',2.81),('15087','2014-01-28','12:55:00',3.41),('15087','2014-01-28','13:00:00',3.45),('15087','2014-01-28','13:05:00',3.41),('15087','2014-01-28','13:10:00',2.42),('15087','2014-01-28','13:15:00',2.8),('15087','2014-01-28','13:20:00',2.41),('15087','2014-01-28','13:25:00',2.81),('15087','2014-01-28','13:30:00',2.76),('15087','2014-01-28','13:35:00',2.91),('15087','2014-01-28','13:40:00',2.75),('15087','2014-01-28','13:45:00',2.65),('15087','2014-01-28','13:50:00',2.48),('15087','2014-01-28','13:55:00',2.34),('15087','2014-01-28','14:00:00',2.23),('15087','2014-01-28','14:05:00',2.26),('15087','2014-01-28','14:10:00',2.27),('15087','2014-01-28','14:15:00',2.35),('15087','2014-01-28','14:20:00',2.26),('15087','2014-01-28','14:25:00',2.34),('15087','2014-01-28','14:30:00',2.27),('15087','2014-01-28','14:35:00',2.08),('15087','2014-01-28','14:40:00',1.98),('15087','2014-01-28','14:45:00',1.84),('15087','2014-01-28','14:50:00',1.8),('15087','2014-01-28','14:55:00',1.72),('15087','2014-01-28','15:00:00',1.65),('15087','2014-01-28','15:05:00',1.58),('15087','2014-01-28','15:10:00',1.49),('15087','2014-01-28','15:15:00',1.41),('15087','2014-01-28','15:20:00',1.29),('15087','2014-01-28','15:25:00',1.2),('15087','2014-01-28','15:30:00',1.12),('15128','2014-05-04','08:15:00',1.02),('15128','2014-05-04','08:20:00',1.09),('15128','2014-05-04','08:25:00',1.17),('15128','2014-05-04','08:30:00',1.22),('15128','2014-05-04','08:35:00',1.29),('15128','2014-05-04','08:40:00',1.37),('15128','2014-05-04','08:45:00',1.44),('15128','2014-05-04','08:50:00',1.52),('15128','2014-05-04','08:55:00',1.58),('15128','2014-05-04','09:00:00',1.67),('15128','2014-05-04','09:05:00',1.75),('15128','2014-05-04','09:10:00',1.85),('15128','2014-05-04','09:15:00',1.92),('15128','2014-05-04','09:20:00',2),('15128','2014-05-04','09:25:00',2.05),('15128','2014-05-04','09:30:00',2.04),('15128','2014-05-04','09:35:00',2.07),('15128','2014-05-04','09:40:00',2.03),('15128','2014-05-04','09:45:00',2.2),('15128','2014-05-04','09:50:00',2.25),('15128','2014-05-04','09:55:00',2.29),('15128','2014-05-04','10:00:00',2.36),('15128','2014-05-04','10:05:00',2.46),('15128','2014-05-04','10:10:00',2.59),('15128','2014-05-04','10:15:00',2.67),('15128','2014-05-04','10:20:00',2.63),('15128','2014-05-04','10:25:00',2.65),('15128','2014-05-04','10:30:00',2.68),('15128','2014-05-04','10:35:00',2.78),('15128','2014-05-04','10:40:00',2.85),('15128','2014-05-04','10:45:00',2.93),('15128','2014-05-04','10:50:00',3.01),('15128','2014-05-04','10:55:00',3.11),('15128','2014-05-04','11:00:00',3.03),('15128','2014-05-04','11:05:00',3.18),('15128','2014-05-04','11:10:00',3.14),('15128','2014-05-04','11:15:00',3.26),('15128','2014-05-04','11:20:00',3.29),('15128','2014-05-04','11:25:00',3.38),('15128','2014-05-04','11:30:00',3.51),('15128','2014-05-04','11:35:00',3.47),('15128','2014-05-04','11:40:00',3.78),('15128','2014-05-04','11:45:00',2.98),('15128','2014-05-04','11:50:00',2.86),('15128','2014-05-04','11:55:00',2.29),('15128','2014-05-04','12:00:00',2.86),('15128','2014-05-04','12:05:00',2.91),('15128','2014-05-04','12:10:00',4.24),('15128','2014-05-04','12:15:00',4.17),('15128','2014-05-04','12:20:00',4.22),('15128','2014-05-04','12:25:00',4.24),('15128','2014-05-04','12:30:00',4.28),('15128','2014-05-04','12:35:00',4.21),('15128','2014-05-04','12:40:00',4.21),('15128','2014-05-04','12:45:00',4.2),('15128','2014-05-04','12:50:00',4.17),('15128','2014-05-04','12:55:00',4.16),('15128','2014-05-04','13:00:00',4.15),('15128','2014-05-04','13:05:00',4.19),('15128','2014-05-04','13:10:00',4.27),('15128','2014-05-04','13:15:00',4.3),('15128','2014-05-04','13:20:00',4.28),('15128','2014-05-04','13:25:00',4.32),('15128','2014-05-04','13:30:00',4.45),('15128','2014-05-04','13:35:00',4.47),('15128','2014-05-04','13:40:00',4.62),('15128','2014-05-04','13:45:00',4.39),('15128','2014-05-04','13:50:00',2.06),('15128','2014-05-04','13:55:00',1.87),('15128','2014-05-04','14:00:00',1.53),('15128','2014-05-04','14:05:00',2.51),('15128','2014-05-04','14:10:00',4.95),('15128','2014-05-04','14:15:00',4.64),('15128','2014-05-04','14:20:00',4.57),('15128','2014-05-04','14:25:00',4.62),('15128','2014-05-04','14:30:00',4.56),('15128','2014-05-04','14:35:00',4.47),('15128','2014-05-04','14:40:00',4.39),('15128','2014-05-04','14:45:00',4.41),('15128','2014-05-04','14:50:00',4.4),('15128','2014-05-04','14:55:00',4.48),('15128','2014-05-04','15:00:00',4.25),('15128','2014-05-04','15:05:00',4.14),('15128','2014-05-04','15:10:00',4.13),('15128','2014-05-04','15:15:00',4.05),('15128','2014-05-04','15:20:00',4.04),('15128','2014-05-04','15:25:00',3.97),('15128','2014-05-04','15:30:00',3.94),('15128','2014-05-04','15:35:00',3.94),('15128','2014-05-04','15:40:00',3.9),('15128','2014-05-04','15:45:00',3.85),('15128','2014-05-04','15:50:00',3.83),('15128','2014-05-04','15:55:00',3.76),('15128','2014-05-04','16:00:00',3.7),('15128','2014-05-04','16:05:00',3.65),('15128','2014-05-04','16:10:00',3.65),('15128','2014-05-04','16:15:00',3.59),('15128','2014-05-04','16:20:00',3.56),('15128','2014-05-04','16:25:00',3.49),('15128','2014-05-04','16:30:00',3.41),('15128','2014-05-04','16:35:00',3.35),('15128','2014-05-04','16:40:00',3.29),('15128','2014-05-04','16:45:00',3.22),('15128','2014-05-04','16:50:00',3.2),('15128','2014-05-04','16:55:00',3.1),('15128','2014-05-04','17:00:00',2.99),('15128','2014-05-04','17:05:00',2.91),('15128','2014-05-04','17:10:00',2.86),('15128','2014-05-04','17:15:00',2.8),('15128','2014-05-04','17:20:00',2.72),('15128','2014-05-04','17:25:00',2.68),('15128','2014-05-04','17:30:00',2.67),('15128','2014-05-04','17:35:00',2.48),('15128','2014-05-04','17:40:00',2.29),('15128','2014-05-04','17:45:00',2.16),('15128','2014-05-04','17:50:00',2.07),('15128','2014-05-04','17:55:00',1.99),('15128','2014-05-04','18:00:00',1.89),('15128','2014-05-04','18:05:00',1.81),('15128','2014-05-04','18:10:00',1.72),('15128','2014-05-04','18:15:00',1.66),('15128','2014-05-04','18:20:00',1.6),('15128','2014-05-04','18:25:00',1.48),('15128','2014-05-04','18:30:00',1.4),('15128','2014-05-04','18:35:00',1.31),('15128','2014-05-04','18:40:00',1.2),('15128','2014-05-04','18:45:00',1.09),('15128','2014-04-25','09:10:00',1.03),('15128','2014-04-25','09:15:00',1.09),('15128','2014-04-25','09:20:00',1.17),('15128','2014-04-25','09:25:00',1.05),('15128','2014-04-25','09:45:00',1.09),('15128','2014-04-25','09:50:00',1.28),('15128','2014-04-25','09:55:00',1.43),('15128','2014-04-25','10:00:00',1.81),('15128','2014-04-25','10:05:00',1.94),('15128','2014-04-25','10:10:00',1.87),('15128','2014-04-25','10:15:00',2.3),('15128','2014-04-25','10:20:00',2.46),('15128','2014-04-25','10:25:00',1.98),('15128','2014-04-25','10:30:00',2.44),('15128','2014-04-25','10:35:00',1.74),('15128','2014-04-25','10:40:00',1.67),('15128','2014-04-25','10:45:00',1.8),('15128','2014-04-25','10:50:00',2.03),('15128','2014-04-25','10:55:00',1.98),('15128','2014-04-25','11:00:00',2.15),('15128','2014-04-25','11:05:00',2.35),('15128','2014-04-25','11:10:00',2.55),('15128','2014-04-25','11:15:00',3.32),('15128','2014-04-25','11:20:00',2.98),('15128','2014-04-25','11:25:00',2.67),('15128','2014-04-25','11:30:00',2.76),('15128','2014-04-25','11:35:00',3.19),('15128','2014-04-25','11:40:00',3.38),('15128','2014-04-25','11:45:00',1.93),('15128','2014-04-25','11:50:00',2.64),('15128','2014-04-25','11:55:00',3.24),('15128','2014-04-25','12:00:00',3.2),('15128','2014-04-25','12:05:00',2.74),('15128','2014-04-25','12:10:00',2.87),('15128','2014-04-25','12:15:00',2.52),('15128','2014-04-25','12:20:00',3.12),('15128','2014-04-25','12:25:00',2.92),('15128','2014-04-25','12:30:00',2.45),('15128','2014-04-25','12:35:00',3.32),('15128','2014-04-25','12:40:00',3.36),('15128','2014-04-25','12:45:00',3.23),('15128','2014-04-25','12:50:00',3.43),('15128','2014-04-25','12:55:00',3.61),('15128','2014-04-25','13:00:00',3.81),('15128','2014-04-25','13:05:00',2.96),('15128','2014-04-25','13:10:00',3.16),('15128','2014-04-25','13:15:00',3.43),('15128','2014-04-25','13:20:00',3.88),('15128','2014-04-25','13:25:00',3.9),('15128','2014-04-25','13:30:00',3.11),('15128','2014-04-25','13:35:00',3.85),('15128','2014-04-25','13:40:00',4.38),('15128','2014-04-25','13:45:00',3.66),('15128','2014-04-25','13:50:00',3.86),('15128','2014-04-25','13:55:00',3.57),('15128','2014-04-25','14:00:00',2.95),('15128','2014-04-25','14:05:00',2.05),('15128','2014-04-25','14:10:00',2.39),('15128','2014-04-25','14:15:00',3.48),('15128','2014-04-25','14:20:00',2.16),('15128','2014-04-25','14:25:00',1.71),('15128','2014-04-25','14:30:00',1.2),('15128','2014-04-25','14:45:00',3.18),('15128','2014-04-25','14:50:00',1.83),('15128','2014-04-25','18:30:00',1),('15128','2014-04-25','18:35:00',1.16),('15128','2014-04-25','18:40:00',1.29),('15128','2014-04-25','18:45:00',1.13),('15128','2014-01-25','09:45:00',1.01),('15128','2014-01-25','10:10:00',1.14),('15128','2014-01-25','10:15:00',1.21),('15128','2014-01-25','11:00:00',1.03),('15128','2014-01-25','11:05:00',1.02),('15128','2014-01-25','11:20:00',1.22),('15128','2014-01-25','11:25:00',1.38),('15128','2014-01-25','12:10:00',1.2),('15128','2014-01-25','12:15:00',1.29),('15128','2014-01-25','12:20:00',1.53),('15128','2014-01-25','12:25:00',2.29),('15128','2014-01-25','12:30:00',1.69),('15128','2014-01-25','12:35:00',1.15),('15128','2014-01-25','12:40:00',1.05),('15128','2014-01-25','12:55:00',1.02),('15128','2014-01-25','13:00:00',1.13),('15128','2014-01-25','13:05:00',1.2),('15128','2014-01-25','13:10:00',1.3),('15128','2014-01-25','13:15:00',1.37),('15128','2014-01-25','13:20:00',1.28),('15128','2014-01-25','13:25:00',1.02),('15128','2014-01-25','13:45:00',1.28),('15128','2014-01-25','15:40:00',1.51),('15128','2014-01-24','09:50:00',1.2),('15128','2014-01-24','09:55:00',1.05),('15128','2014-01-24','10:00:00',1.6),('15128','2014-01-24','10:05:00',1.73),('15128','2014-01-24','10:10:00',1.73),('15128','2014-01-24','10:15:00',1.75),('15128','2014-01-24','10:20:00',1.81),('15128','2014-01-24','10:25:00',1.74),('15128','2014-01-24','10:30:00',1.98),('15128','2014-01-24','10:35:00',1.51),('15128','2014-01-24','10:40:00',1.53),('15128','2014-01-24','10:45:00',1.98),('15128','2014-01-24','10:50:00',2.1),('15128','2014-01-24','10:55:00',2.08),('15128','2014-01-24','11:00:00',2.29),('15128','2014-01-24','11:05:00',2.22),('15128','2014-01-24','11:10:00',2.43),('15128','2014-01-24','11:15:00',2.64),('15128','2014-01-24','11:20:00',3.06),('15128','2014-01-24','11:25:00',2.93),('15128','2014-01-24','11:30:00',2.79),('15128','2014-01-24','11:35:00',2.03),('15128','2014-01-24','11:40:00',1.96),('15128','2014-01-24','11:45:00',1.84),('15128','2014-01-24','11:50:00',1.73),('15128','2014-01-24','11:55:00',1.62),('15128','2014-01-24','12:00:00',1.81),('15128','2014-01-24','12:05:00',1.92),('15128','2014-01-24','12:10:00',1.9),('15128','2014-01-24','12:15:00',1.72),('15128','2014-01-24','12:20:00',1.68),('15128','2014-01-24','12:25:00',1.65),('15128','2014-01-24','12:30:00',1.76),('15128','2014-01-24','12:35:00',1.84),('15128','2014-01-24','12:40:00',1.36),('15128','2014-01-24','12:45:00',1.52),('15128','2014-01-24','12:50:00',1.95),('15128','2014-01-24','12:55:00',2.08),('15128','2014-01-24','13:00:00',2.11),('15128','2014-01-24','13:05:00',2.55),('15128','2014-01-24','13:10:00',2.63),('15128','2014-01-24','13:15:00',2.66),('15128','2014-01-24','13:20:00',2.65),('15128','2014-01-24','13:25:00',2.68),('15128','2014-01-24','13:30:00',2.64),('15128','2014-01-24','13:35:00',2.72),('15128','2014-01-24','13:40:00',2.76),('15128','2014-01-24','13:45:00',2.73),('15128','2014-01-24','13:50:00',2.34),('15128','2014-01-24','13:55:00',2.51),('15128','2014-01-24','14:00:00',2.22),('15128','2014-01-24','14:05:00',1.75),('15128','2014-01-24','14:10:00',2.48),('15128','2014-01-24','14:15:00',2.43),('15128','2014-01-24','14:20:00',2.36),('15128','2014-01-24','14:25:00',2.5),('15128','2014-01-24','14:30:00',2.56),('15128','2014-01-24','14:35:00',2.4),('15128','2014-01-24','15:00:00',1.49),('15128','2014-01-24','15:05:00',1.93),('15128','2014-01-24','15:10:00',1.82),('15128','2014-01-24','15:15:00',1.78),('15128','2014-01-24','15:20:00',1.69),('15128','2014-01-24','15:25:00',1.6),('15128','2014-01-24','15:30:00',1.51),('15128','2014-01-24','15:35:00',1.42),('15128','2014-01-24','15:40:00',1.32),('15128','2014-01-24','15:45:00',1.2),('15128','2014-01-24','15:50:00',1.13),('15128','2014-01-24','15:55:00',1.01),('15128','2014-01-23','10:00:00',1.15),('15128','2014-01-23','10:05:00',1.38),('15128','2014-01-23','10:10:00',1.95),('15128','2014-01-23','10:15:00',1.68),('15128','2014-01-23','10:20:00',1.36),('15128','2014-01-23','10:30:00',1.45),('15128','2014-01-23','10:35:00',1.62),('15128','2014-01-23','10:40:00',2.43),('15128','2014-01-23','10:45:00',1.33),('15128','2014-01-23','10:50:00',1.42),('15128','2014-01-23','11:00:00',1.94),('15128','2014-01-23','11:05:00',1.07),('15128','2014-01-23','11:25:00',1.21),('15128','2014-01-23','11:30:00',1.55),('15128','2014-01-23','11:35:00',1.33),('15128','2014-01-23','11:40:00',3.08),('15128','2014-01-23','11:45:00',2.5),('15128','2014-01-23','11:50:00',2.54),('15128','2014-01-23','11:55:00',2.09),('15128','2014-01-23','12:00:00',2.25),('15128','2014-01-23','12:05:00',2.81),('15128','2014-01-23','12:10:00',1.37),('15128','2014-01-23','12:15:00',1.33),('15128','2014-01-23','12:20:00',2.34),('15128','2014-01-23','12:25:00',1.07),('15128','2014-01-23','12:35:00',1.32),('15128','2014-01-23','12:40:00',1.74),('15128','2014-01-23','12:45:00',1.48),('15128','2014-01-23','13:05:00',1.2),('15128','2014-01-23','13:10:00',1.64),('15128','2014-01-23','13:15:00',1.97),('15128','2014-01-23','13:20:00',1.08),('15128','2014-01-23','13:25:00',2.22),('15128','2014-01-23','13:30:00',2.34),('15128','2014-01-23','13:35:00',2),('15128','2014-01-23','13:40:00',2.46),('15128','2014-01-23','13:50:00',1.51),('15128','2014-01-23','14:00:00',1.04),('15128','2014-01-23','14:05:00',2.67),('15128','2014-01-23','14:10:00',2.89),('15128','2014-01-23','14:15:00',1.49),('15128','2014-01-23','14:20:00',1.24),('15128','2014-01-23','14:25:00',1.97),('15128','2014-01-23','14:30:00',1.22),('15128','2014-01-23','14:40:00',2.23),('15128','2014-01-23','14:45:00',1.57),('15128','2014-01-23','14:50:00',1.59),('15128','2014-01-22','10:45:00',1.1),('15128','2014-01-22','10:50:00',1),('15128','2014-01-22','12:05:00',1.11),('15128','2014-01-22','12:10:00',1.05),('15128','2014-01-22','12:40:00',1.06),('15128','2014-01-21','11:15:00',1.06),('15128','2014-01-21','11:20:00',1.04),('15128','2014-01-21','12:40:00',1.26),('15128','2014-01-21','12:45:00',1.56),('15128','2014-01-21','12:50:00',1.65),('15128','2014-01-21','12:55:00',1.07),('15128','2014-01-20','10:55:00',1.01),('15128','2014-01-20','11:00:00',1.07),('15128','2014-01-20','11:30:00',1.58),('15128','2014-01-20','11:35:00',2.79),('15128','2014-01-20','11:40:00',2.7),('15128','2014-01-20','11:45:00',1.3),('15128','2014-01-20','11:50:00',1.21),('15128','2014-01-20','11:55:00',1.74),('15128','2014-01-20','12:00:00',1.7),('15128','2014-01-20','12:05:00',1.43),('15128','2014-01-20','12:10:00',1.07),('15128','2014-01-20','12:15:00',1.51),('15128','2014-01-20','12:20:00',1.49),('15128','2014-01-20','12:25:00',1.53),('15128','2014-01-20','12:30:00',1.38),('15128','2014-01-20','12:35:00',1.13),('15128','2014-01-20','13:00:00',1.11),('15128','2014-01-20','13:05:00',1),('15128','2014-01-20','13:15:00',1.02),('15128','2014-01-20','15:00:00',1.26),('15128','2014-01-20','15:30:00',1.06),('15128','2014-01-20','15:35:00',1.28),('15128','2014-01-19','11:50:00',1.15),('15128','2014-01-19','11:55:00',1.87),('15128','2014-01-19','12:00:00',1.38),('15128','2014-01-19','12:05:00',1.53),('15128','2014-01-19','12:50:00',2.59),('15128','2014-01-19','12:55:00',2.25),('15128','2014-01-19','13:25:00',1.54),('15128','2014-01-19','13:30:00',2.02),('15128','2014-01-19','13:35:00',1.01),('15128','2014-01-19','13:40:00',1.07),('15128','2014-01-19','14:15:00',1.67),('15128','2014-01-19','14:20:00',1.17),('15128','2014-01-18','11:50:00',1.05),('15128','2014-01-18','11:55:00',1.18),('15128','2014-01-18','12:00:00',1.08),('15128','2014-01-18','12:05:00',1.02),('15128','2014-01-18','12:25:00',1.02),('15128','2014-01-18','13:10:00',1.06),('15128','2014-01-18','14:15:00',1.13),('15128','2014-01-18','14:20:00',1.55),('15128','2014-01-18','14:25:00',1.3),('15128','2014-01-18','14:30:00',1.14),('15128','2014-01-17','09:50:00',1),('15128','2014-01-17','10:00:00',1.04),('15128','2014-01-17','10:10:00',1.29),('15128','2014-01-17','10:15:00',1.67),('15128','2014-01-17','10:20:00',1.53),('15128','2014-01-17','10:25:00',1.43),('15128','2014-01-17','10:30:00',1.41),('15128','2014-01-17','10:35:00',1.4),('15128','2014-01-17','10:40:00',1.48),('15128','2014-01-17','10:45:00',1.04),('15128','2014-01-17','10:50:00',1.01),('15128','2014-01-17','11:05:00',1.63),('15128','2014-01-17','11:10:00',1.02),('15128','2014-01-17','11:20:00',1.9),('15128','2014-01-17','11:25:00',1.97),('15128','2014-01-17','11:30:00',2.07),('15128','2014-01-17','11:35:00',1.9),('15128','2014-01-17','11:40:00',1.31),('15128','2014-01-17','11:55:00',1.17),('15128','2014-01-17','12:00:00',1.87),('15128','2014-01-17','12:05:00',1.26),('15128','2014-01-17','12:10:00',2.39),('15128','2014-01-17','12:15:00',2.37),('15128','2014-01-17','12:20:00',2.4),('15128','2014-01-17','12:25:00',2.42),('15128','2014-01-17','12:30:00',2.42),('15128','2014-01-17','12:35:00',2.46),('15128','2014-01-17','12:40:00',2.23),('15128','2014-01-17','12:45:00',2.21),('15128','2014-01-17','12:50:00',1.93),('15128','2014-01-17','12:55:00',2),('15128','2014-01-17','13:00:00',2.17),('15128','2014-01-17','13:05:00',1.77),('15128','2014-01-17','13:10:00',2.29),('15128','2014-01-17','13:15:00',2.51),('15128','2014-01-17','13:20:00',2.63),('15128','2014-01-17','13:25:00',1.98),('15128','2014-01-17','13:30:00',2.36),('15128','2014-01-17','13:35:00',2.51),('15128','2014-01-17','13:40:00',2.18),('15128','2014-01-17','13:45:00',2.37),('15128','2014-01-17','13:50:00',2.09),('15128','2014-01-17','13:55:00',1.17),('15128','2014-01-17','14:00:00',2.33),('15128','2014-01-17','14:05:00',2.19),('15128','2014-01-17','14:10:00',2.02),('15128','2014-01-17','14:15:00',1.96),('15128','2014-01-17','14:20:00',2.05),('15128','2014-01-17','14:25:00',1.99),('15128','2014-01-17','14:30:00',1.93),('15128','2014-01-17','14:35:00',1.88),('15128','2014-01-17','14:40:00',1.84),('15128','2014-01-17','14:45:00',1.8),('15128','2014-01-17','14:50:00',1.72),('15128','2014-01-16','09:40:00',1.04),('15128','2014-01-16','09:45:00',1.09),('15128','2014-04-24','08:35:00',1.04),('15128','2014-04-24','08:40:00',1.08),('15128','2014-04-24','08:45:00',1.16),('15128','2014-04-24','08:50:00',1.34),('15128','2014-04-24','08:55:00',1.09),('15128','2014-04-24','09:00:00',1.35),('15128','2014-04-24','09:05:00',1.15),('15128','2014-04-24','09:45:00',1.07),('15128','2014-04-24','09:50:00',1.26),('15128','2014-04-24','09:55:00',1.33),('15128','2014-04-24','10:00:00',1.39),('15128','2014-04-24','10:05:00',1.31),('15128','2014-04-24','10:10:00',1.27),('15128','2014-04-24','10:15:00',1.15),('15128','2014-04-24','10:20:00',1.72),('15128','2014-04-24','10:25:00',2.05),('15128','2014-04-24','10:30:00',1.7),('15128','2014-04-24','10:35:00',1.67),('15128','2014-04-24','10:40:00',2.11),('15128','2014-04-24','10:45:00',1.24),('15128','2014-04-24','10:55:00',1.05),('15128','2014-04-24','11:00:00',1.18),('15128','2014-04-24','11:05:00',1.4),('15128','2014-04-24','11:10:00',3.52),('15128','2014-04-24','11:15:00',3.46),('15128','2014-04-24','11:20:00',2.42),('15128','2014-04-24','11:25:00',2.97),('15128','2014-04-24','11:30:00',1.43),('15128','2014-04-24','11:35:00',1.05),('15128','2014-04-24','11:40:00',2.01),('15128','2014-04-24','11:45:00',3.17),('15128','2014-04-24','11:50:00',1.7),('15128','2014-04-24','11:55:00',1.01),('15128','2014-04-24','12:00:00',1.08),('15128','2014-04-24','12:05:00',2.83),('15128','2014-04-24','12:10:00',2.65),('15128','2014-04-24','12:15:00',3.09),('15128','2014-04-24','12:20:00',4.26),('15128','2014-04-24','12:25:00',3.47),('15128','2014-04-24','12:30:00',3.29),('15128','2014-04-24','12:35:00',3.96),('15128','2014-04-24','12:40:00',3.96),('15128','2014-04-24','12:45:00',3.86),('15128','2014-04-24','12:50:00',2.34),('15128','2014-04-24','12:55:00',2.5),('15128','2014-04-24','13:00:00',3.99),('15128','2014-04-24','13:05:00',4.38),('15128','2014-04-24','13:10:00',4.24),('15128','2014-04-24','13:15:00',2.76),('15128','2014-04-24','13:20:00',1.74),('15128','2014-04-24','13:25:00',3.95),('15128','2014-04-24','13:30:00',3.7),('15128','2014-04-24','13:35:00',3.61),('15128','2014-04-24','13:40:00',4.7),('15128','2014-04-24','13:45:00',4.41),('15128','2014-04-24','13:50:00',3.28),('15128','2014-04-24','13:55:00',3.61),('15128','2014-04-24','14:00:00',3.98),('15128','2014-04-24','14:05:00',4.05),('15128','2014-04-24','14:10:00',3.97),('15128','2014-04-24','14:15:00',4.01),('15128','2014-04-24','14:20:00',3.96),('15128','2014-04-24','14:25:00',4),('15128','2014-04-24','14:30:00',3.98),('15128','2014-04-24','14:35:00',3.96),('15128','2014-04-24','14:40:00',3.93),('15128','2014-04-24','14:45:00',3.92),('15128','2014-04-24','14:50:00',3.89),('15128','2014-04-24','14:55:00',3.89),('15128','2014-04-24','15:00:00',3.87),('15128','2014-04-24','15:05:00',3.85),('15128','2014-04-24','15:10:00',3.78),('15128','2014-04-24','15:15:00',3.72),('15128','2014-04-24','15:20:00',3.7),('15128','2014-04-24','15:25:00',3.76),('15128','2014-04-24','15:30:00',3.66),('15128','2014-04-24','15:35:00',3.66),('15128','2014-04-24','15:40:00',3.55),('15128','2014-04-24','15:45:00',3.44),('15128','2014-04-24','15:50:00',3.49),('15128','2014-04-24','15:55:00',3.47),('15128','2014-04-24','16:00:00',3.34),('15128','2014-04-24','16:05:00',3.22),('15128','2014-04-24','16:10:00',3.03),('15128','2014-04-24','16:15:00',2.84),('15128','2014-04-24','16:20:00',3.03),('15128','2014-04-24','16:25:00',2.86),('15128','2014-04-24','16:30:00',2.68),('15128','2014-04-24','16:35:00',2.94),('15128','2014-04-24','16:40:00',2.99),('15128','2014-04-24','16:45:00',2.83),('15128','2014-04-24','16:50:00',2.25),('15128','2014-04-24','16:55:00',1.96),('15128','2014-04-24','17:00:00',2.03),('15128','2014-04-24','17:05:00',2.27),('15128','2014-04-24','17:10:00',2.38),('15128','2014-04-24','17:15:00',2.33),('15128','2014-04-24','17:20:00',2.11),('15128','2014-04-24','17:25:00',1.71),('15128','2014-04-24','17:30:00',2.05),('15128','2014-04-24','17:35:00',1.41),('15128','2014-04-24','17:40:00',1.29),('15128','2014-04-24','17:45:00',1.11),('15128','2014-04-24','17:55:00',1.01),('15128','2014-01-15','09:35:00',1.1),('15128','2014-01-15','09:40:00',1.09),('15128','2014-01-15','10:10:00',1.01),('15128','2014-01-15','10:20:00',1.11),('15128','2014-01-15','10:25:00',1.47),('15128','2014-01-15','10:30:00',1.8),('15128','2014-01-15','10:35:00',1.53),('15128','2014-01-15','10:40:00',1.24),('15128','2014-01-15','10:45:00',1.42),('15128','2014-01-15','10:50:00',1.47),('15128','2014-01-15','10:55:00',1.47),('15128','2014-01-15','11:00:00',1.53),('15128','2014-01-15','11:05:00',1.66),('15128','2014-01-15','11:10:00',1.67),('15128','2014-01-15','11:15:00',1.56),('15128','2014-01-15','11:20:00',1.65),('15128','2014-01-15','11:25:00',1.57),('15128','2014-01-15','11:30:00',1.52),('15128','2014-01-15','11:35:00',1.57),('15128','2014-01-15','11:40:00',1.6),('15128','2014-01-15','11:45:00',1.68),('15128','2014-01-15','11:50:00',1.75),('15128','2014-01-15','11:55:00',1.81),('15128','2014-01-15','12:00:00',1.73),('15128','2014-01-15','12:05:00',1.76),('15128','2014-01-15','12:10:00',1.69),('15128','2014-01-15','12:15:00',1.53),('15128','2014-01-15','12:20:00',1.47),('15128','2014-01-15','12:25:00',1.49),('15128','2014-01-15','12:30:00',1.7),('15128','2014-01-15','12:35:00',1.82),('15128','2014-01-15','12:40:00',1.86),('15128','2014-01-15','12:45:00',1.96),('15128','2014-01-15','12:50:00',2.03),('15128','2014-01-15','12:55:00',2.12),('15128','2014-01-15','13:00:00',2.19),('15128','2014-01-15','13:05:00',2.18),('15128','2014-01-15','13:10:00',2.17),('15128','2014-01-15','13:15:00',2.21),('15128','2014-01-15','13:20:00',2.21),('15128','2014-01-15','13:25:00',2.26),('15128','2014-01-15','13:30:00',2.31),('15128','2014-01-15','13:35:00',1.71),('15128','2014-01-15','13:40:00',1.22),('15128','2014-01-15','13:45:00',1.9),('15128','2014-01-15','13:50:00',1.09),('15128','2014-01-15','13:55:00',1.08),('15128','2014-01-15','14:00:00',1.08),('15128','2014-01-15','14:05:00',1.07),('15128','2014-01-15','14:10:00',1.02),('15128','2014-01-15','14:15:00',1.01),('15128','2014-01-15','15:00:00',1.07),('15128','2014-01-14','10:05:00',1.12),('15128','2014-01-14','10:10:00',1.19),('15128','2014-01-14','10:15:00',1.3),('15128','2014-01-14','10:20:00',1.35),('15128','2014-01-14','10:25:00',1.41),('15128','2014-01-14','10:30:00',1.48),('15128','2014-01-14','10:35:00',1.54),('15128','2014-01-14','10:40:00',1.16),('15128','2014-01-14','10:45:00',1.16),('15128','2014-01-14','10:50:00',1.16),('15128','2014-01-14','10:55:00',1.32),('15128','2014-01-14','11:00:00',1.79),('15128','2014-01-14','11:05:00',1.84),('15128','2014-01-14','11:10:00',1.92),('15128','2014-01-14','11:15:00',2.03),('15128','2014-01-14','11:20:00',2.09),('15128','2014-01-14','11:25:00',2.16),('15128','2014-01-14','11:30:00',1.59),('15128','2014-01-14','11:35:00',1.17),('15128','2014-01-14','11:40:00',1.44),('15128','2014-01-14','11:45:00',1.2),('15128','2014-01-14','11:50:00',1.14),('15128','2014-01-14','11:55:00',1.2),('15128','2014-01-14','12:00:00',1.41),('15128','2014-01-14','12:05:00',1.49),('15128','2014-01-14','12:10:00',1.74),('15128','2014-01-14','12:15:00',1.64),('15128','2014-01-14','12:20:00',1.18),('15128','2014-01-14','12:25:00',1.23),('15128','2014-01-14','12:30:00',1.77),('15128','2014-01-14','12:35:00',2.69),('15128','2014-01-14','12:40:00',1.97),('15128','2014-01-14','12:45:00',2.07),('15128','2014-01-14','12:50:00',2.18),('15128','2014-01-14','12:55:00',2.48),('15128','2014-01-14','13:00:00',2.57),('15128','2014-01-14','13:05:00',2.51),('15128','2014-01-14','13:10:00',2.52),('15128','2014-01-14','13:15:00',2.52),('15128','2014-01-14','13:20:00',2.5),('15128','2014-01-14','13:25:00',2.46),('15128','2014-01-14','13:30:00',2.41),('15128','2014-01-14','13:35:00',2.38),('15128','2014-01-14','13:40:00',2.35),('15128','2014-01-14','13:45:00',2.31),('15128','2014-01-14','13:50:00',2.29),('15128','2014-01-14','13:55:00',2.26),('15128','2014-01-14','14:00:00',2.1),('15128','2014-01-14','14:15:00',2.17),('15128','2014-01-14','14:20:00',2.07),('15128','2014-01-14','14:25:00',1.99),('15128','2014-01-14','14:30:00',1.92),('15128','2014-01-14','14:35:00',1.89),('15128','2014-01-14','14:40:00',1.86),('15128','2014-01-14','14:45:00',1.81),('15128','2014-01-14','14:50:00',1.78),('15128','2014-01-14','14:55:00',1.74),('15128','2014-01-14','15:00:00',1.68),('15128','2014-01-14','15:05:00',1.06),('15128','2014-01-14','15:10:00',1.44),('15128','2014-01-14','15:15:00',1.43),('15128','2014-01-14','15:20:00',1.37),('15128','2014-01-14','15:25:00',1.24),('15128','2014-01-14','15:30:00',1.15),('15128','2014-01-14','15:35:00',1.09),('15128','2014-01-13','10:25:00',1.34),('15128','2014-01-13','10:30:00',1.73),('15128','2014-01-13','10:35:00',1.35),('15128','2014-01-13','10:40:00',1.08),('15128','2014-01-13','10:45:00',1.04),('15128','2014-01-13','10:55:00',1.01),('15128','2014-01-12','10:05:00',1.02),('15128','2014-01-12','10:10:00',1.1),('15128','2014-01-12','10:15:00',1.14),('15128','2014-01-12','10:20:00',1.19),('15128','2014-01-12','10:25:00',1.25),('15128','2014-01-12','10:30:00',1.28),('15128','2014-01-12','10:35:00',1.31),('15128','2014-01-12','10:40:00',1.35),('15128','2014-01-12','10:45:00',1.4),('15128','2014-01-12','10:50:00',1.44),('15128','2014-01-12','10:55:00',1.48),('15128','2014-01-12','11:00:00',1.52),('15128','2014-01-12','11:05:00',1.56),('15128','2014-01-12','11:10:00',1.58),('15128','2014-01-12','11:15:00',1.63),('15128','2014-01-12','11:20:00',1.7),('15128','2014-01-12','11:25:00',1.73),('15128','2014-01-12','11:30:00',1.86),('15128','2014-01-12','11:35:00',1.9),('15128','2014-01-12','11:40:00',1.94),('15128','2014-01-12','11:45:00',1.95),('15128','2014-01-12','11:50:00',1.95),('15128','2014-01-12','11:55:00',1.99),('15128','2014-01-12','12:00:00',2),('15128','2014-01-12','12:05:00',2.01),('15128','2014-01-12','12:10:00',2.01),('15128','2014-01-12','12:15:00',2.02),('15128','2014-01-12','12:20:00',2.05),('15128','2014-01-12','12:25:00',2.07),('15128','2014-01-12','12:30:00',2.07),('15128','2014-01-12','12:35:00',2.1),('15128','2014-01-12','12:40:00',2.1),('15128','2014-01-12','12:45:00',2.07),('15128','2014-01-12','12:50:00',2.07),('15128','2014-01-12','12:55:00',2.13),('15128','2014-01-12','13:00:00',2.12),('15128','2014-01-12','13:05:00',2.13),('15128','2014-01-12','13:10:00',2.1),('15128','2014-01-12','13:15:00',2.05),('15128','2014-01-12','13:20:00',1.99),('15128','2014-01-12','13:25:00',1.96),('15128','2014-01-12','13:30:00',1.97),('15128','2014-01-12','13:35:00',1.99),('15128','2014-01-12','13:40:00',2.02),('15128','2014-01-12','13:45:00',2.04),('15128','2014-01-12','13:50:00',2.01),('15128','2014-01-12','13:55:00',1.98),('15128','2014-01-12','14:00:00',1.95),('15128','2014-01-12','14:05:00',1.91),('15128','2014-01-12','14:10:00',1.89),('15128','2014-01-12','14:15:00',1.82),('15128','2014-01-12','14:20:00',1.75),('15128','2014-01-12','14:25:00',1.68),('15128','2014-01-12','14:30:00',1.63),('15128','2014-01-12','14:35:00',1.58),('15128','2014-01-12','14:40:00',1.57),('15128','2014-01-12','14:45:00',1.52),('15128','2014-01-12','14:50:00',1.5),('15128','2014-01-12','14:55:00',1.48),('15128','2014-01-12','15:00:00',1.46),('15128','2014-01-12','15:05:00',1.41),('15128','2014-01-12','15:10:00',1.33),('15128','2014-01-12','15:15:00',1.25),('15128','2014-01-12','15:20:00',1.13),('15128','2014-01-11','10:35:00',1.02),('15128','2014-01-11','10:40:00',1.2),('15128','2014-01-11','10:45:00',1.23),('15128','2014-01-11','10:50:00',1.18),('15128','2014-01-11','10:55:00',1.21),('15128','2014-01-11','11:00:00',1.34),('15128','2014-01-11','11:05:00',1.44),('15128','2014-01-11','11:10:00',1.54),('15128','2014-01-11','11:15:00',1.61),('15128','2014-01-11','11:20:00',1.79),('15128','2014-01-11','11:25:00',1.64),('15128','2014-01-11','11:30:00',1.97),('15128','2014-01-11','11:35:00',2.07),('15128','2014-01-11','11:40:00',1.6),('15128','2014-01-11','11:45:00',1.83),('15128','2014-01-11','11:50:00',1.98),('15128','2014-01-11','11:55:00',1.57),('15128','2014-01-11','12:00:00',1.43),('15128','2014-01-11','12:05:00',1.4),('15128','2014-01-11','12:10:00',1.27),('15128','2014-01-11','12:15:00',1.23),('15128','2014-01-11','12:20:00',1.16),('15128','2014-01-11','12:25:00',1.15),('15128','2014-01-11','12:30:00',1.15),('15128','2014-01-11','12:35:00',1.09),('15128','2014-01-11','12:40:00',1),('15128','2014-01-11','13:20:00',1.07),('15128','2014-01-11','13:25:00',1.04),('15128','2014-01-11','13:30:00',1.26),('15128','2014-01-11','13:35:00',1.21),('15128','2014-01-11','13:40:00',1.17),('15128','2014-01-11','13:45:00',1.13),('15128','2014-01-11','13:50:00',1.04),('15128','2014-01-11','13:55:00',1),('15128','2014-01-10','10:10:00',1.01),('15128','2014-01-10','10:20:00',1.11),('15128','2014-01-10','10:25:00',1.02),('15128','2014-01-10','10:30:00',1.13),('15128','2014-01-10','10:35:00',1.25),('15128','2014-01-10','10:40:00',1.39),('15128','2014-01-10','10:45:00',1.51),('15128','2014-01-10','10:50:00',1.53),('15128','2014-01-10','10:55:00',1.56),('15128','2014-01-10','11:00:00',1.64),('15128','2014-01-10','11:05:00',1.54),('15128','2014-01-10','11:10:00',1.3),('15128','2014-01-10','11:15:00',1.35),('15128','2014-01-10','11:20:00',1.44),('15128','2014-01-10','11:25:00',1.4),('15128','2014-01-10','11:30:00',1.5),('15128','2014-01-10','11:35:00',1.74),('15128','2014-01-10','11:40:00',1.66),('15128','2014-01-10','11:45:00',1.63),('15128','2014-01-10','11:50:00',1.69),('15128','2014-01-10','11:55:00',1.78),('15128','2014-01-10','12:00:00',1.63),('15128','2014-01-10','12:05:00',1.63),('15128','2014-01-10','12:10:00',2),('15128','2014-01-10','12:15:00',2.21),('15128','2014-01-10','12:20:00',1.24),('15128','2014-01-10','12:25:00',1.49),('15128','2014-01-10','12:30:00',1.71),('15128','2014-01-10','12:35:00',1.39),('15128','2014-01-10','12:40:00',1.24),('15128','2014-01-10','12:45:00',1.32),('15128','2014-01-10','12:50:00',1.95),('15128','2014-01-10','12:55:00',1.75),('15128','2014-01-10','13:00:00',1.59),('15128','2014-01-10','13:05:00',1.43),('15128','2014-01-10','13:10:00',1.28),('15128','2014-01-10','13:15:00',1.48),('15128','2014-01-10','13:20:00',1.51),('15128','2014-01-10','13:25:00',1.26),('15128','2014-01-10','13:30:00',1.24),('15128','2014-01-10','13:35:00',1.05),('15128','2014-01-10','13:40:00',1.05),('15128','2014-01-10','13:50:00',1),('15128','2014-01-10','13:55:00',1.18),('15128','2014-01-10','14:00:00',1.39),('15128','2014-01-10','14:05:00',1.2),('15128','2014-01-09','11:50:00',1.08),('15128','2014-01-09','11:55:00',1.05),('15128','2014-01-08','10:35:00',1.09),('15128','2014-01-08','10:40:00',1.16),('15128','2014-01-08','10:45:00',1.13),('15128','2014-01-08','10:50:00',1.1),('15128','2014-01-08','10:55:00',1.03),('15128','2014-01-08','11:00:00',1.1),('15128','2014-01-08','11:05:00',1.19),('15128','2014-01-08','11:10:00',1.26),('15128','2014-01-08','11:15:00',1.4),('15128','2014-01-08','11:20:00',1.41),('15128','2014-01-08','11:25:00',1.31),('15128','2014-01-08','11:30:00',1.36),('15128','2014-01-08','11:35:00',1.24),('15128','2014-01-08','11:40:00',1.29),('15128','2014-01-08','11:45:00',1.29),('15128','2014-01-08','11:50:00',1.41),('15128','2014-01-08','11:55:00',1.31),('15128','2014-01-08','12:00:00',1.33),('15128','2014-01-08','12:05:00',1.49),('15128','2014-01-08','12:10:00',1.35),('15128','2014-01-08','12:15:00',1.5),('15128','2014-01-08','12:20:00',1.29),('15128','2014-01-08','12:25:00',1.25),('15128','2014-01-08','12:30:00',1.15),('15128','2014-01-08','12:35:00',1.32),('15128','2014-01-08','12:40:00',1.27),('15128','2014-01-08','12:45:00',1.24),('15128','2014-01-08','12:50:00',1.24),('15128','2014-01-08','12:55:00',1.38),('15128','2014-01-08','13:00:00',1.64),('15128','2014-01-08','13:05:00',1.56),('15128','2014-01-08','13:10:00',1.48),('15128','2014-01-08','13:15:00',1.57),('15128','2014-01-08','13:20:00',1.49),('15128','2014-01-08','13:25:00',1.08),('15128','2014-01-08','13:30:00',1.13),('15128','2014-01-08','13:35:00',1.15),('15128','2014-01-08','13:40:00',1.18),('15128','2014-01-08','13:45:00',1.22),('15128','2014-01-08','14:05:00',1.06),('15128','2014-01-08','14:10:00',1.03),('15128','2014-01-08','14:15:00',1.01),('15128','2014-01-08','14:25:00',1.03),('15128','2014-01-08','14:30:00',1.04),('15128','2014-01-08','14:45:00',1.01),('15128','2014-01-07','10:10:00',1.05),('15128','2014-01-07','10:15:00',1.15),('15128','2014-01-07','10:20:00',1.21),('15128','2014-01-07','10:25:00',1.25),('15128','2014-01-07','10:30:00',1.19),('15128','2014-01-07','10:35:00',1.22),('15128','2014-01-07','10:40:00',1.34),('15128','2014-01-07','10:45:00',1.39),('15128','2014-01-07','10:50:00',1.42),('15128','2014-01-07','10:55:00',1.47),('15128','2014-01-07','11:00:00',1.51),('15128','2014-01-07','11:05:00',1.56),('15128','2014-01-07','11:10:00',1.59),('15128','2014-01-07','11:15:00',1.62),('15128','2014-01-07','11:20:00',1.71),('15128','2014-01-07','11:25:00',1.82),('15128','2014-01-07','11:30:00',1.93),('15128','2014-01-07','11:35:00',2.01),('15128','2014-01-07','11:40:00',2.02),('15128','2014-01-07','11:45:00',2),('15128','2014-01-07','11:50:00',1.98),('15128','2014-01-07','11:55:00',1.98),('15128','2014-01-07','12:00:00',2.01),('15128','2014-01-07','12:05:00',2.09),('15128','2014-01-07','12:10:00',2.11),('15128','2014-01-07','12:15:00',2.11),('15128','2014-01-07','12:20:00',2.13),('15128','2014-01-07','12:25:00',2.14),('15128','2014-01-07','12:30:00',2.15),('15128','2014-01-07','12:35:00',2.14),('15128','2014-01-07','12:40:00',2.04),('15128','2014-01-07','12:45:00',2.07),('15128','2014-01-07','12:50:00',2.04),('15128','2014-01-07','12:55:00',2.03),('15128','2014-01-07','13:00:00',2.06),('15128','2014-01-07','13:05:00',2.07),('15128','2014-01-07','13:10:00',2.07),('15128','2014-01-07','13:15:00',2.07),('15128','2014-01-07','13:20:00',2.01),('15128','2014-01-07','13:25:00',2.04),('15128','2014-01-07','13:30:00',2.11),('15128','2014-01-07','13:35:00',2.1),('15128','2014-01-07','13:40:00',1.99),('15128','2014-01-07','13:45:00',1.98),('15128','2014-01-07','13:50:00',1.87),('15128','2014-01-07','13:55:00',1.92),('15128','2014-01-07','14:00:00',1.92),('15128','2014-01-07','14:05:00',1.76),('15128','2014-01-07','14:10:00',1.89),('15128','2014-01-07','14:15:00',1.81),('15128','2014-01-07','14:20:00',1.72),('15128','2014-01-07','14:25:00',1.8),('15128','2014-01-07','14:30:00',1.75),('15128','2014-01-07','14:35:00',1.54),('15128','2014-01-07','14:40:00',1.5),('15128','2014-01-07','14:45:00',1.56),('15128','2014-01-07','14:50:00',1.36),('15128','2014-01-07','14:55:00',1.13),('15128','2014-01-07','15:00:00',1.13),('15128','2014-01-07','15:05:00',1.01),('15128','2014-01-06','10:05:00',1.04),('15128','2014-01-06','10:10:00',1.1),('15128','2014-01-06','10:15:00',1.15),('15128','2014-01-06','10:20:00',1.2),('15128','2014-01-06','10:25:00',1.26),('15128','2014-01-06','10:30:00',1.3),('15128','2014-01-06','10:35:00',1.33),('15128','2014-01-06','10:40:00',1.35),('15128','2014-01-06','10:45:00',1.39),('15128','2014-01-06','10:50:00',1.45),('15128','2014-01-06','10:55:00',1.5),('15128','2014-01-06','11:00:00',1.56),('15128','2014-01-06','11:05:00',1.57),('15128','2014-01-06','11:10:00',1.6),('15128','2014-01-06','11:15:00',1.62),('15128','2014-01-06','11:20:00',1.71),('15128','2014-01-06','11:25:00',1.78),('15128','2014-01-06','11:30:00',1.89),('15128','2014-01-06','11:35:00',1.91),('15128','2014-01-06','11:40:00',1.98),('15128','2014-01-06','11:45:00',2.03),('15128','2014-01-06','11:50:00',2.04),('15128','2014-01-06','11:55:00',2.11),('15128','2014-01-06','12:00:00',2.15),('15128','2014-01-06','12:05:00',2.15),('15128','2014-01-06','12:10:00',2.18),('15128','2014-01-06','12:15:00',2.24),('15128','2014-01-06','12:20:00',2.26),('15128','2014-01-06','12:25:00',2.27),('15128','2014-01-06','12:30:00',2.27),('15128','2014-01-06','12:35:00',2.31),('15128','2014-01-06','12:40:00',2.24),('15128','2014-01-06','12:45:00',2.3),('15128','2014-01-06','12:50:00',2.3),('15128','2014-01-06','12:55:00',2.33),('15128','2014-01-06','13:00:00',2.31),('15128','2014-01-06','13:05:00',2.26),('15128','2014-01-06','13:10:00',2.26),('15128','2014-01-06','13:15:00',2.18),('15128','2014-01-06','13:20:00',2.11),('15128','2014-01-06','13:25:00',2.09),('15128','2014-01-06','13:30:00',2.09),('15128','2014-01-06','13:35:00',2.06),('15128','2014-01-06','13:40:00',2.13),('15128','2014-01-06','13:45:00',2.14),('15128','2014-01-06','13:50:00',2.08),('15128','2014-01-06','13:55:00',2.02),('15128','2014-01-06','14:00:00',1.95),('15128','2014-01-06','14:05:00',1.87),('15128','2014-01-06','14:10:00',1.88),('15128','2014-01-06','14:15:00',1.88),('15128','2014-01-06','14:20:00',1.8),('15128','2014-01-06','14:25:00',1.82),('15128','2014-01-06','14:30:00',1.72),('15128','2014-01-06','14:35:00',1.74),('15128','2014-01-06','14:40:00',1.69),('15128','2014-01-06','14:45:00',1.57),('15128','2014-01-06','14:50:00',1.55),('15128','2014-01-06','14:55:00',1.47),('15128','2014-01-06','15:00:00',1.51),('15128','2014-01-06','15:05:00',1.44),('15128','2014-01-06','15:10:00',1.28),('15128','2014-01-06','15:15:00',1.26),('15128','2014-01-06','15:20:00',1.13),('15128','2014-04-23','08:35:00',1.04),('15128','2014-04-23','08:40:00',1.09),('15128','2014-04-23','08:45:00',1.13),('15128','2014-04-23','08:50:00',1.24),('15128','2014-04-23','08:55:00',1.31),('15128','2014-04-23','09:00:00',1.37),('15128','2014-04-23','09:05:00',1.42),('15128','2014-04-23','09:10:00',1.5),('15128','2014-04-23','09:15:00',1.57),('15128','2014-04-23','09:20:00',1.67),('15128','2014-04-23','09:25:00',1.72),('15128','2014-04-23','09:30:00',1.8),('15128','2014-04-23','09:35:00',1.85),('15128','2014-04-23','09:40:00',1.84),('15128','2014-04-23','09:45:00',1.89),('15128','2014-04-23','09:50:00',1.95),('15128','2014-04-23','09:55:00',1.99),('15128','2014-04-23','10:00:00',2.06),('15128','2014-04-23','10:05:00',2.11),('15128','2014-04-23','10:10:00',2.17),('15128','2014-04-23','10:15:00',2.23),('15128','2014-04-23','10:20:00',2.33),('15128','2014-04-23','10:25:00',2.38),('15128','2014-04-23','10:30:00',2.45),('15128','2014-04-23','10:35:00',2.57),('15128','2014-04-23','10:40:00',2.59),('15128','2014-04-23','10:45:00',2.63),('15128','2014-04-23','10:50:00',2.66),('15128','2014-04-23','10:55:00',2.77),('15128','2014-04-23','11:00:00',2.83),('15128','2014-04-23','11:05:00',2.93),('15128','2014-04-23','11:10:00',3.01),('15128','2014-04-23','11:15:00',2.96),('15128','2014-04-23','11:20:00',3.07),('15128','2014-04-23','11:25:00',3.19),('15128','2014-04-23','11:30:00',3.17),('15128','2014-04-23','11:35:00',2.58),('15128','2014-04-23','11:40:00',1.03),('15128','2014-04-23','11:45:00',1.56),('15128','2014-04-23','11:50:00',3.58),('15128','2014-04-23','11:55:00',3.7),('15128','2014-04-23','12:00:00',3.63),('15128','2014-04-23','12:05:00',3.71),('15128','2014-04-23','12:10:00',3.72),('15128','2014-04-23','12:15:00',3.73),('15128','2014-04-23','12:20:00',3.75),('15128','2014-04-23','12:25:00',3.74),('15128','2014-04-23','12:30:00',3.75),('15128','2014-04-23','12:35:00',3.73),('15128','2014-04-23','12:40:00',3.8),('15128','2014-04-23','12:45:00',3.88),('15128','2014-04-23','12:50:00',3.94),('15128','2014-04-23','12:55:00',3.82),('15128','2014-04-23','13:00:00',2.57),('15128','2014-04-23','13:05:00',3.14),('15128','2014-04-23','13:10:00',4.07),('15128','2014-04-23','13:15:00',4.04),('15128','2014-04-23','13:20:00',3.81),('15128','2014-04-23','13:25:00',3.39),('15128','2014-04-23','13:30:00',2.3),('15128','2014-04-23','13:35:00',2.31),('15128','2014-04-23','13:40:00',2.67),('15128','2014-04-23','13:45:00',4.37),('15128','2014-04-23','13:50:00',3.96),('15128','2014-04-23','13:55:00',4.22),('15128','2014-04-23','14:00:00',4.2),('15128','2014-04-23','14:05:00',4.19),('15128','2014-04-23','14:10:00',4.19),('15128','2014-04-23','14:15:00',4.27),('15128','2014-04-23','14:20:00',4.41),('15128','2014-04-23','14:25:00',4.5),('15128','2014-04-23','14:30:00',4.7),('15128','2014-04-23','14:35:00',4.54),('15128','2014-04-23','14:40:00',4.32),('15128','2014-04-23','14:45:00',4.13),('15128','2014-04-23','14:50:00',4.06),('15128','2014-04-23','14:55:00',4.09),('15128','2014-04-23','15:00:00',4.27),('15128','2014-04-23','15:05:00',4.61),('15128','2014-04-23','15:10:00',3.8),('15128','2014-04-23','15:15:00',2.87),('15128','2014-04-23','15:20:00',3.27),('15128','2014-04-23','15:25:00',3.09),('15128','2014-04-23','15:30:00',4.44),('15128','2014-04-23','15:35:00',2.99),('15128','2014-04-23','15:40:00',3.34),('15128','2014-04-23','15:45:00',4.18),('15128','2014-04-23','15:50:00',4.31),('15128','2014-04-23','15:55:00',3.17),('15128','2014-04-23','16:00:00',3.62),('15128','2014-04-23','16:05:00',4),('15128','2014-04-23','16:10:00',3.52),('15128','2014-04-23','16:15:00',3.43),('15128','2014-04-23','16:20:00',2.97),('15128','2014-04-23','16:25:00',3.93),('15128','2014-04-23','16:30:00',3.97),('15128','2014-04-23','16:35:00',2.51),('15128','2014-04-23','16:40:00',3.03),('15128','2014-04-23','16:45:00',3.4),('15128','2014-04-23','16:50:00',2.07),('15128','2014-04-23','16:55:00',1.64),('15128','2014-04-23','17:00:00',1.43),('15128','2014-04-23','17:05:00',1.45),('15128','2014-04-23','17:10:00',1.55),('15128','2014-04-23','17:15:00',1.41),('15128','2014-04-23','17:20:00',1.35),('15128','2014-04-23','17:25:00',1.38),('15128','2014-04-23','17:30:00',1.15),('15128','2014-01-05','11:00:00',1.03),('15128','2014-01-05','11:25:00',1.19),('15128','2014-01-05','11:30:00',1.21),('15128','2014-01-05','11:35:00',1.4),('15128','2014-01-05','11:40:00',1.7),('15128','2014-01-05','11:45:00',2.1),('15128','2014-01-05','11:50:00',2.12),('15128','2014-01-05','11:55:00',2.18),('15128','2014-01-05','12:35:00',2.18),('15128','2014-01-05','12:40:00',2.19),('15128','2014-01-05','12:45:00',2.21),('15128','2014-01-05','12:50:00',2.22),('15128','2014-01-05','12:55:00',2.2),('15128','2014-01-05','13:00:00',2.2),('15128','2014-01-05','13:05:00',2.21),('15128','2014-01-05','13:10:00',2.21),('15128','2014-01-05','13:15:00',2.24),('15128','2014-01-05','13:20:00',2.25),('15128','2014-01-05','13:25:00',2.32),('15128','2014-01-05','13:30:00',2.44),('15128','2014-01-05','13:35:00',2.28),('15128','2014-01-05','13:40:00',2.2),('15128','2014-01-05','13:45:00',2.13),('15128','2014-01-05','13:50:00',2.09),('15128','2014-01-05','13:55:00',2.06),('15128','2014-01-05','14:00:00',2.04),('15128','2014-01-05','14:05:00',2.01),('15128','2014-01-05','14:10:00',1.94),('15128','2014-01-05','14:15:00',1.88),('15128','2014-01-05','14:20:00',2.06),('15128','2014-01-05','14:25:00',2.01),('15128','2014-01-05','14:30:00',1.89),('15128','2014-01-05','14:40:00',1.47),('15128','2014-01-05','14:45:00',1.84),('15128','2014-01-05','14:50:00',1.84),('15128','2014-01-05','14:55:00',1.71),('15128','2014-01-05','15:00:00',1.68),('15128','2014-01-05','15:05:00',1.49),('15128','2014-01-05','15:10:00',1.37),('15128','2014-01-05','15:15:00',1.26),('15128','2014-01-05','15:20:00',1.1),('15128','2014-01-05','15:25:00',1.18),('15128','2014-01-02','10:00:00',1.13),('15128','2014-01-02','10:05:00',1.43),('15128','2014-01-02','10:10:00',1.08),('15128','2014-01-02','10:15:00',1.09),('15128','2014-01-02','10:45:00',1.01),('15128','2014-01-02','10:50:00',1.1),('15128','2014-01-02','11:00:00',1.06),('15128','2014-01-02','11:05:00',1.02),('15128','2014-01-02','12:00:00',1.39),('15128','2014-01-02','12:05:00',2.15),('15128','2014-01-02','12:10:00',2.43),('15128','2014-01-02','12:15:00',2.43),('15128','2014-01-02','12:20:00',1.96),('15128','2014-01-02','12:25:00',1.97),('15128','2014-01-02','12:30:00',1.92),('15128','2014-01-02','12:35:00',2.11),('15128','2014-01-02','12:40:00',1.74),('15128','2014-01-02','12:45:00',2.51),('15128','2014-01-02','12:50:00',1.58),('15128','2014-01-02','12:55:00',2.15),('15128','2014-01-02','13:00:00',1.56),('15128','2014-01-02','13:05:00',1.64),('15128','2014-01-02','13:10:00',1.34),('15128','2014-01-02','13:15:00',1.36),('15128','2014-01-02','13:20:00',1.48),('15128','2014-01-02','13:25:00',1.63),('15128','2014-01-02','13:30:00',1.42),('15128','2014-01-02','13:35:00',1.42),('15128','2014-01-02','13:40:00',1.37),('15128','2014-01-02','13:45:00',1.37),('15128','2014-01-02','13:50:00',1.14),('15128','2014-01-02','13:55:00',1.02),('15128','2014-01-01','10:45:00',1.59),('15128','2014-01-01','10:50:00',1.12),('15128','2014-01-01','10:55:00',1.21),('15128','2014-01-01','11:00:00',1.4),('15128','2014-01-01','11:05:00',1.37),('15128','2014-01-01','11:10:00',1.32),('15128','2014-01-01','11:15:00',1.15),('15128','2014-01-01','11:20:00',1.19),('15128','2014-01-01','11:25:00',1.24),('15128','2014-01-01','11:30:00',1.38),('15128','2014-01-01','11:35:00',1.53),('15128','2014-01-01','11:40:00',1.32),('15128','2014-01-01','11:45:00',1.24),('15128','2014-01-01','11:50:00',1.16),('15128','2014-01-01','11:55:00',1.17),('15128','2014-01-01','12:00:00',1.11),('15128','2014-01-01','12:35:00',1.05),('15128','2014-01-01','12:40:00',1.18),('15128','2014-01-01','12:45:00',1.38),('15128','2014-01-01','12:50:00',2.02),('15128','2014-01-01','12:55:00',2.6),('15128','2014-01-01','13:00:00',2.18),('15128','2014-01-01','13:05:00',1.25),('15128','2013-12-31','11:10:00',1.01),('15128','2013-12-31','11:15:00',1.03),('15128','2013-12-31','11:20:00',1.04),('15128','2013-12-31','11:25:00',1.02),('15128','2013-12-31','11:30:00',1.02),('15128','2013-12-31','11:35:00',1.11),('15128','2013-12-31','11:40:00',1.12),('15128','2013-12-31','11:45:00',1.08),('15128','2013-12-31','11:50:00',1.05),('15128','2013-12-31','11:55:00',1.08),('15128','2013-12-31','12:00:00',1.12),('15128','2013-12-31','12:05:00',1.17),('15128','2013-12-31','12:10:00',1.23),('15128','2013-12-31','12:15:00',1.24),('15128','2013-12-31','12:20:00',1.25),('15128','2013-12-31','12:25:00',1.29),('15128','2013-12-31','12:30:00',1.34),('15128','2013-12-31','12:35:00',1.27),('15128','2013-12-31','12:40:00',1.33),('15128','2013-12-31','12:45:00',1.37),('15128','2013-12-31','12:50:00',1.49),('15128','2013-12-31','12:55:00',1.25),('15128','2013-12-31','13:00:00',1.14),('15128','2013-12-31','13:05:00',1.12),('15128','2013-12-31','13:10:00',1.13),('15128','2013-12-31','13:15:00',1.17),('15128','2013-12-31','13:20:00',1.16),('15128','2013-12-31','13:25:00',1.15),('15128','2013-12-31','13:30:00',1.56),('15128','2013-12-31','13:35:00',2.62),('15128','2013-12-31','13:40:00',2.14),('15128','2013-12-31','13:45:00',1.49),('15128','2013-12-31','13:50:00',2.06),('15128','2013-12-31','13:55:00',1.6),('15128','2013-12-31','14:00:00',2.28),('15128','2013-12-31','14:05:00',1.07),('15128','2013-12-31','14:10:00',1.46),('15128','2013-12-31','14:15:00',1.23),('15128','2013-12-31','14:40:00',1.26),('15128','2013-12-31','14:45:00',1.08),('15128','2013-12-31','15:00:00',1.26),('15128','2013-12-31','15:05:00',1.57),('15128','2013-12-31','15:10:00',1.22),('15128','2013-12-31','15:15:00',1.11),('15128','2013-12-31','15:20:00',1.01),('15128','2013-12-30','10:25:00',1.19),('15128','2013-12-30','11:05:00',1.03),('15128','2013-12-30','11:10:00',1.02),('15128','2013-12-30','11:20:00',1.13),('15128','2013-12-30','11:25:00',1.94),('15128','2013-12-30','11:30:00',2.31),('15128','2013-12-30','11:35:00',2.27),('15128','2013-12-30','11:40:00',2.17),('15128','2013-12-30','11:45:00',2.16),('15128','2013-12-30','11:50:00',2.15),('15128','2013-12-30','11:55:00',2.17),('15128','2013-12-30','12:00:00',2.17),('15128','2013-12-30','12:05:00',2.15),('15128','2013-12-30','12:10:00',2.13),('15128','2013-12-30','12:15:00',2.18),('15128','2013-12-30','12:20:00',2.18),('15128','2013-12-30','12:25:00',2.19),('15128','2013-12-30','12:30:00',2.2),('15128','2013-12-30','12:35:00',2.21),('15128','2013-12-30','12:40:00',2.22),('15128','2013-12-30','12:45:00',2.21),('15128','2013-12-30','12:50:00',2.21),('15128','2013-12-30','12:55:00',2.21),('15128','2013-12-30','13:00:00',2.21),('15128','2013-12-30','13:05:00',2.19),('15128','2013-12-30','13:10:00',2.17),('15128','2013-12-30','13:15:00',2.16),('15128','2013-12-30','13:20:00',2.15),('15128','2013-12-30','13:25:00',2.12),('15128','2013-12-30','13:30:00',2.11),('15128','2013-12-30','13:35:00',2.09),('15128','2013-12-30','13:40:00',2.07),('15128','2013-12-30','13:45:00',2.05),('15128','2013-12-30','13:50:00',2.01),('15128','2013-12-30','13:55:00',1.98),('15128','2013-12-30','14:00:00',1.95),('15128','2013-12-30','14:05:00',1.93),('15128','2013-12-30','14:10:00',1.88),('15128','2013-12-30','14:15:00',1.84),('15128','2013-12-30','14:20:00',1.8),('15128','2013-12-30','14:25:00',1.76),('15128','2013-12-30','14:30:00',1.7),('15128','2013-12-30','14:35:00',1.65),('15128','2013-12-30','14:40:00',1.55),('15128','2013-12-30','14:45:00',1.53),('15128','2013-12-30','14:50:00',1.46),('15128','2013-12-30','14:55:00',1.38),('15128','2013-12-30','15:00:00',1.27),('15128','2013-12-30','15:05:00',1.22),('15128','2013-12-30','15:10:00',1.14),('15128','2013-12-30','15:15:00',1.05),('15128','2013-12-28','09:45:00',1.02),('15128','2013-12-28','09:50:00',1.14),('15128','2013-12-28','10:05:00',1.2),('15128','2013-12-28','10:10:00',1.41),('15128','2013-12-28','10:15:00',1.65),('15128','2013-12-28','10:20:00',1.64),('15128','2013-12-28','10:25:00',1.62),('15128','2013-12-28','10:30:00',1.86),('15128','2013-12-28','10:35:00',1.62),('15128','2013-12-28','10:45:00',2.01),('15128','2013-12-28','10:50:00',1.9),('15128','2013-12-28','10:55:00',1.07),('15128','2013-12-28','11:05:00',1.02),('15128','2013-12-28','11:20:00',1.67),('15128','2013-12-28','11:25:00',1.5),('15128','2013-12-28','11:30:00',1.08),('15128','2013-12-28','11:35:00',1.1),('15128','2013-12-27','10:05:00',1.06),('15128','2013-12-27','10:10:00',1.12),('15128','2013-12-27','10:15:00',1.17),('15128','2013-12-27','10:20:00',1.23),('15128','2013-12-27','10:25:00',1.28),('15128','2013-12-27','10:30:00',1.32),('15128','2013-12-27','10:35:00',1.35),('15128','2013-12-27','10:40:00',1.39),('15128','2013-12-27','10:45:00',1.44),('15128','2013-12-27','10:50:00',1.49),('15128','2013-12-27','10:55:00',1.55),('15128','2013-12-27','11:00:00',1.58),('15128','2013-12-27','11:05:00',1.61),('15128','2013-12-27','11:10:00',1.66),('15128','2013-12-27','11:15:00',1.71),('15128','2013-12-27','11:20:00',1.79),('15128','2013-12-27','11:25:00',1.87),('15128','2013-12-27','11:30:00',1.91),('15128','2013-12-27','11:35:00',1.96),('15128','2013-12-27','11:40:00',2),('15128','2013-12-27','11:45:00',2.03),('15128','2013-12-27','11:50:00',2.07),('15128','2013-12-27','11:55:00',2.11),('15128','2013-12-27','12:00:00',2.12),('15128','2013-12-27','12:05:00',2.12),('15128','2013-12-27','12:10:00',2.17),('15128','2013-12-27','12:15:00',2.21),('15128','2013-12-27','12:20:00',2.17),('15128','2013-12-27','12:25:00',2.18),('15128','2013-12-27','12:30:00',2.18),('15128','2013-12-27','12:35:00',2.19),('15128','2013-12-27','12:40:00',2.18),('15128','2013-12-27','12:45:00',2.18),('15128','2013-12-27','12:50:00',2.2),('15128','2013-12-27','12:55:00',2.2),('15128','2013-12-27','13:00:00',2.15),('15128','2013-12-27','13:05:00',2.14),('15128','2013-12-27','13:10:00',2.11),('15128','2013-12-27','13:15:00',2.1),('15128','2013-12-27','13:20:00',2.08),('15128','2013-12-27','13:25:00',2.04),('15128','2013-12-27','13:30:00',2.03),('15128','2013-12-27','13:35:00',2.02),('15128','2013-12-27','13:40:00',2),('15128','2013-12-27','13:45:00',1.98),('15128','2013-12-27','13:50:00',1.97),('15128','2013-12-27','13:55:00',1.95),('15128','2013-12-27','14:00:00',1.94),('15128','2013-12-27','14:05:00',1.89),('15128','2013-12-27','14:10:00',1.84),('15128','2013-12-27','14:15:00',1.82),('15128','2013-12-27','14:20:00',1.8),('15128','2013-12-27','14:25:00',1.76),('15128','2013-12-27','14:30:00',1.73),('15128','2013-12-27','14:35:00',1.61),('15128','2013-12-27','14:40:00',1.27),('15128','2013-12-27','14:50:00',1),('15128','2013-12-27','14:55:00',1.34),('15128','2013-12-27','15:00:00',1.41),('15128','2013-12-27','15:05:00',1.3),('15128','2013-12-27','15:10:00',1.16),('15128','2013-12-27','15:15:00',1.08),('15128','2014-04-22','10:50:00',1.08),('15128','2014-04-22','10:55:00',1.16),('15128','2014-04-22','11:00:00',1.17),('15128','2014-04-22','11:05:00',1.11),('15128','2014-04-22','11:10:00',1.07),('15128','2014-04-22','13:30:00',1.05),('15128','2014-04-22','13:35:00',1.18),('15128','2014-04-22','13:40:00',1.28),('15128','2014-04-22','13:45:00',1.38),('15128','2014-04-22','13:50:00',1.36),('15128','2014-04-22','13:55:00',1.41),('15128','2014-04-22','14:00:00',1.49),('15128','2014-04-22','14:05:00',1.53),('15128','2014-04-22','14:10:00',1.53),('15128','2014-04-22','14:15:00',1.49),('15128','2014-04-22','14:20:00',1.43),('15128','2014-04-22','14:25:00',1.35),('15128','2014-04-22','14:30:00',1.26),('15128','2014-04-22','14:35:00',1.1),('15128','2014-04-22','14:40:00',1.02),('15128','2014-04-22','14:45:00',1.01),('15128','2014-04-22','14:50:00',1),('15128','2014-04-22','15:10:00',1),('15128','2014-04-22','15:15:00',1.09),('15128','2014-04-22','15:20:00',1.13),('15128','2014-04-22','15:25:00',1.16),('15128','2014-04-22','15:30:00',1.19),('15128','2014-04-22','15:35:00',1.13),('15128','2013-12-26','11:45:00',1.02),('15128','2013-12-26','11:50:00',1.25),('15128','2013-12-26','11:55:00',1.41),('15128','2013-12-26','12:00:00',1.67),('15128','2013-12-26','12:05:00',1.71),('15128','2013-12-26','12:10:00',1.54),('15128','2013-12-26','12:25:00',1.03),('15128','2013-12-26','12:35:00',1.08),('15128','2013-12-26','12:40:00',1.71),('15128','2013-12-26','12:45:00',1.99),('15128','2013-12-26','12:50:00',1.89),('15128','2013-12-26','12:55:00',1.72),('15128','2013-12-26','13:00:00',2.07),('15128','2013-12-26','13:05:00',2.12),('15128','2013-12-26','13:10:00',2.14),('15128','2013-12-26','13:15:00',2.14),('15128','2013-12-26','13:20:00',2.21),('15128','2013-12-26','13:25:00',2.56),('15128','2013-12-26','13:30:00',1.54),('15128','2013-12-26','13:35:00',1.4),('15128','2013-12-26','13:40:00',1.27),('15128','2013-12-26','13:45:00',1.17),('15128','2013-12-26','13:50:00',1.17),('15128','2013-12-26','13:55:00',1.25),('15128','2013-12-26','14:00:00',1.64),('15128','2013-12-26','14:05:00',1.89),('15128','2013-12-26','14:10:00',2.19),('15128','2013-12-26','14:15:00',1.27),('15128','2013-12-26','14:20:00',1.09),('15128','2013-12-26','14:25:00',1.16),('15128','2013-12-26','14:30:00',1.22),('15128','2013-12-26','14:35:00',1.31),('15128','2013-12-24','10:40:00',1.02),('15128','2013-12-24','10:45:00',1.01),('15128','2013-12-24','11:05:00',1.09),('15128','2013-12-24','11:10:00',1.29),('15128','2013-12-24','11:15:00',1.05),('15128','2013-12-24','11:35:00',1.04),('15128','2013-12-24','11:45:00',1.13),('15128','2013-12-24','11:50:00',1.34),('15128','2013-12-24','11:55:00',1.38),('15128','2013-12-24','12:05:00',1.23),('15128','2013-12-24','12:10:00',2.19),('15128','2013-12-24','12:15:00',2.22),('15128','2013-12-24','12:20:00',2.25),('15128','2013-12-24','12:25:00',1.54),('15128','2013-12-24','12:35:00',1.03),('15128','2013-12-24','12:40:00',1.42),('15128','2013-12-24','12:45:00',1.51),('15128','2013-12-24','12:50:00',1.14),('15128','2013-12-24','12:55:00',1.09),('15128','2013-12-24','13:00:00',1.04),('15128','2013-12-24','13:05:00',1.13),('15128','2013-12-24','13:40:00',1.16),('15128','2013-12-24','13:45:00',1.24),('15128','2013-12-24','13:50:00',1.16),('15128','2013-12-23','10:05:00',1.02),('15128','2013-12-23','10:10:00',1.09),('15128','2013-12-23','10:15:00',1.15),('15128','2013-12-23','10:20:00',1.18),('15128','2013-12-23','10:25:00',1.21),('15128','2013-12-23','10:30:00',1.22),('15128','2013-12-23','10:35:00',1.24),('15128','2013-12-23','10:40:00',1.29),('15128','2013-12-23','10:45:00',1.33),('15128','2013-12-23','10:50:00',1.37),('15128','2013-12-23','10:55:00',1.4),('15128','2013-12-23','11:00:00',1.43),('15128','2013-12-23','11:05:00',1.47),('15128','2013-12-23','11:10:00',1.54),('15128','2013-12-23','11:15:00',1.57),('15128','2013-12-23','11:20:00',1.69),('15128','2013-12-23','11:25:00',1.71),('15128','2013-12-23','11:30:00',1.8),('15128','2013-12-23','11:35:00',1.81),('15128','2013-12-23','11:40:00',1.83),('15128','2013-12-23','11:45:00',1.89),('15128','2013-12-23','11:50:00',1.91),('15128','2013-12-23','11:55:00',1.93),('15128','2013-12-23','12:00:00',1.94),('15128','2013-12-23','12:05:00',1.96),('15128','2013-12-23','12:10:00',1.95),('15128','2013-12-23','12:15:00',1.96),('15128','2013-12-23','12:20:00',1.95),('15128','2013-12-23','12:25:00',1.94),('15128','2013-12-23','12:30:00',1.96),('15128','2013-12-23','12:35:00',2.02),('15128','2013-12-23','12:40:00',2),('15128','2013-12-23','12:45:00',1.98),('15128','2013-12-23','12:50:00',1.97),('15128','2013-12-23','12:55:00',1.92),('15128','2013-12-23','13:00:00',1.88),('15128','2013-12-23','13:05:00',1.91),('15128','2013-12-23','13:10:00',1.88),('15128','2013-12-23','13:15:00',1.85),('15128','2013-12-23','13:20:00',1.84),('15128','2013-12-23','13:25:00',1.82),('15128','2013-12-23','13:30:00',1.78),('15128','2013-12-23','13:35:00',1.77),('15128','2013-12-23','13:40:00',1.72),('15128','2013-12-23','13:45:00',1.72),('15128','2013-12-23','13:50:00',1.69),('15128','2013-12-23','13:55:00',1.64),('15128','2013-12-23','14:00:00',1.61),('15128','2013-12-23','14:05:00',1.55),('15128','2013-12-23','14:10:00',1.52),('15128','2013-12-23','14:15:00',1.45),('15128','2013-12-23','14:20:00',1.4),('15128','2013-12-23','14:25:00',1.36),('15128','2013-12-23','14:30:00',1.28),('15128','2013-12-23','14:35:00',1.24),('15128','2013-12-23','14:40:00',1.21),('15128','2013-12-23','14:45:00',1.15),('15128','2013-12-23','14:50:00',1.1),('15128','2013-12-23','14:55:00',1.03),('15128','2013-12-22','10:15:00',1.14),('15128','2013-12-22','10:20:00',1.18),('15128','2013-12-22','10:25:00',1.35),('15128','2013-12-22','10:30:00',1.43),('15128','2013-12-22','10:35:00',1.41),('15128','2013-12-22','10:40:00',1.15),('15128','2013-12-22','10:45:00',1.27),('15128','2013-12-22','10:50:00',1.47),('15128','2013-12-22','10:55:00',1.49),('15128','2013-12-22','11:00:00',1.61),('15128','2013-12-22','11:05:00',1.67),('15128','2013-12-22','11:10:00',1.51),('15128','2013-12-22','11:15:00',1.68),('15128','2013-12-22','11:20:00',1.84),('15128','2013-12-22','11:25:00',1.83),('15128','2013-12-22','11:30:00',2.08),('15128','2013-12-22','11:35:00',2.15),('15128','2013-12-22','11:40:00',2.12),('15128','2013-12-22','11:45:00',2.11),('15128','2013-12-22','11:50:00',1.84),('15128','2013-12-22','11:55:00',2.11),('15128','2013-12-22','12:00:00',2.19),('15128','2013-12-22','12:05:00',2.15),('15128','2013-12-22','12:10:00',2.11),('15128','2013-12-22','12:15:00',2.08),('15128','2013-12-22','12:20:00',2.06),('15128','2013-12-22','12:25:00',2.06),('15128','2013-12-22','12:30:00',2.06),('15128','2013-12-22','12:35:00',2.03),('15128','2013-12-22','12:40:00',2.04),('15128','2013-12-22','12:45:00',2.04),('15128','2013-12-22','12:50:00',2.02),('15128','2013-12-22','12:55:00',1.99),('15128','2013-12-22','13:00:00',1.99),('15128','2013-12-22','13:05:00',2),('15128','2013-12-22','13:10:00',2),('15128','2013-12-22','13:15:00',2.01),('15128','2013-12-22','13:20:00',2.01),('15128','2013-12-22','13:25:00',2.01),('15128','2013-12-22','13:30:00',1.96),('15128','2013-12-22','13:35:00',1.92),('15128','2013-12-22','13:40:00',1.93),('15128','2013-12-22','13:45:00',1.79),('15128','2013-12-22','13:50:00',1.65),('15128','2013-12-22','13:55:00',1.89),('15128','2013-12-22','14:00:00',1.84),('15128','2013-12-22','14:05:00',1.8),('15128','2013-12-22','14:10:00',1.75),('15128','2013-12-22','14:15:00',1.72),('15128','2013-12-22','14:20:00',1.66),('15128','2013-12-22','14:25:00',1.61),('15128','2013-12-22','14:30:00',1.5),('15128','2013-12-22','14:35:00',1.49),('15128','2013-12-22','14:40:00',1.45),('15128','2013-12-22','14:45:00',1.4),('15128','2013-12-22','14:50:00',1.29),('15128','2013-12-22','14:55:00',1.26),('15128','2013-12-22','15:00:00',1.17),('15128','2013-12-22','15:05:00',1.07),('15128','2013-12-21','09:35:00',1.03),('15128','2013-12-21','09:40:00',1.22),('15128','2013-12-21','09:45:00',1.34),('15128','2013-12-21','09:50:00',1.4),('15128','2013-12-21','09:55:00',1.44),('15128','2013-12-21','10:00:00',1.54),('15128','2013-12-21','10:05:00',1.51),('15128','2013-12-21','10:10:00',1.5),('15128','2013-12-21','10:15:00',1.58),('15128','2013-12-21','10:20:00',1.57),('15128','2013-12-21','10:25:00',1.53),('15128','2013-12-21','10:30:00',1.46),('15128','2013-12-21','10:35:00',1.45),('15128','2013-12-21','10:40:00',1.55),('15128','2013-12-21','10:45:00',1.47),('15128','2013-12-21','10:50:00',1.62),('15128','2013-12-21','10:55:00',1.73),('15128','2013-12-21','11:00:00',1.68),('15128','2013-12-21','11:05:00',1.84),('15128','2013-12-21','11:10:00',1.79),('15128','2013-12-21','11:15:00',1.69),('15128','2013-12-21','11:20:00',1.95),('15128','2013-12-21','11:25:00',1.9),('15128','2013-12-21','11:30:00',1.78),('15128','2013-12-21','11:35:00',1.93),('15128','2013-12-21','11:40:00',1.91),('15128','2013-12-21','11:45:00',1.92),('15128','2013-12-21','11:50:00',1.52),('15128','2013-12-21','11:55:00',1.23),('15128','2013-12-21','12:00:00',1.01),('15128','2013-12-21','12:25:00',1.07),('15128','2013-12-21','12:30:00',1.15),('15128','2013-12-21','12:35:00',1.31),('15128','2013-12-21','12:40:00',1.5),('15128','2013-12-21','12:45:00',1.57),('15128','2013-12-21','12:50:00',1.37),('15128','2013-12-21','12:55:00',1.57),('15128','2013-12-21','13:00:00',2.15),('15128','2013-12-21','13:05:00',2.28),('15128','2013-12-21','13:10:00',2.35),('15128','2013-12-21','13:15:00',2.38),('15128','2013-12-21','13:20:00',1.98),('15128','2013-12-21','13:25:00',2.22),('15128','2013-12-21','13:30:00',2.21),('15128','2013-12-21','13:35:00',1.82),('15128','2013-12-21','13:40:00',1.91),('15128','2013-12-21','13:45:00',1.5),('15128','2013-12-21','13:50:00',1.19),('15128','2013-12-21','13:55:00',1.15),('15128','2013-12-21','14:00:00',1.33),('15128','2013-12-21','14:05:00',1.34),('15128','2013-12-21','14:10:00',1.41),('15128','2013-12-21','14:15:00',1.34),('15128','2013-12-21','14:20:00',1.04),('15128','2013-12-21','14:35:00',1.35),('15128','2013-12-21','14:40:00',1.57),('15128','2013-12-21','14:45:00',1.48),('15128','2013-12-21','14:50:00',1.03),('15128','2013-12-20','10:00:00',1.02),('15128','2013-12-20','10:05:00',1.05),('15128','2013-12-20','10:10:00',1.1),('15128','2013-12-20','10:15:00',1.17),('15128','2013-12-20','10:20:00',1.22),('15128','2013-12-20','10:25:00',1.26),('15128','2013-12-20','10:30:00',1.29),('15128','2013-12-20','10:35:00',1.33),('15128','2013-12-20','10:40:00',1.37),('15128','2013-12-20','10:45:00',1.42),('15128','2013-12-20','10:50:00',1.46),('15128','2013-12-20','10:55:00',1.5),('15128','2013-12-20','11:00:00',1.53),('15128','2013-12-20','11:05:00',1.57),('15128','2013-12-20','11:10:00',1.62),('15128','2013-12-20','11:15:00',1.68),('15128','2013-12-20','11:20:00',1.82),('15128','2013-12-20','11:25:00',1.86),('15128','2013-12-20','11:30:00',1.9),('15128','2013-12-20','11:35:00',1.93),('15128','2013-12-20','11:40:00',1.95),('15128','2013-12-20','11:45:00',2),('15128','2013-12-20','11:50:00',2.03),('15128','2013-12-20','11:55:00',2.04),('15128','2013-12-20','12:00:00',2.06),('15128','2013-12-20','12:05:00',2.08),('15128','2013-12-20','12:10:00',2.09),('15128','2013-12-20','12:15:00',2.09),('15128','2013-12-20','12:20:00',2.11),('15128','2013-12-20','12:25:00',2.11),('15128','2013-12-20','12:30:00',2.1),('15128','2013-12-20','12:35:00',2.1),('15128','2013-12-20','12:40:00',2.12),('15128','2013-12-20','12:45:00',2.12),('15128','2013-12-20','12:50:00',2.12),('15128','2013-12-20','12:55:00',2.13),('15128','2013-12-20','13:00:00',2.12),('15128','2013-12-20','13:05:00',2.1),('15128','2013-12-20','13:10:00',2.1),('15128','2013-12-20','13:15:00',2.1),('15128','2013-12-20','13:20:00',2.09),('15128','2013-12-20','13:25:00',2.09),('15128','2013-12-20','13:30:00',2.07),('15128','2013-12-20','13:35:00',2.05),('15128','2013-12-20','13:40:00',2.03),('15128','2013-12-20','13:45:00',2.01),('15128','2013-12-20','13:50:00',1.99),('15128','2013-12-20','13:55:00',1.95),('15128','2013-12-20','14:00:00',1.9),('15128','2013-12-20','14:05:00',1.84),('15128','2013-12-20','14:10:00',1.79),('15128','2013-12-20','14:15:00',1.76),('15128','2013-12-20','14:20:00',1.71),('15128','2013-12-20','14:25:00',1.64),('15128','2013-12-20','14:30:00',1.57),('15128','2013-12-20','14:35:00',1.52),('15128','2013-12-20','14:40:00',1.46),('15128','2013-12-20','14:45:00',1.41),('15128','2013-12-20','14:50:00',1.3),('15128','2013-12-20','14:55:00',1.28),('15128','2013-12-20','15:00:00',1.2),('15128','2013-12-20','15:05:00',1.1),('15128','2013-12-20','15:10:00',1.01),('15128','2013-12-19','10:05:00',1.02),('15128','2013-12-19','10:10:00',1.07),('15128','2013-12-19','10:15:00',1.14),('15128','2013-12-19','10:20:00',1.18),('15128','2013-12-19','10:25:00',1.21),('15128','2013-12-19','10:30:00',1.24),('15128','2013-12-19','10:35:00',1.27),('15128','2013-12-19','10:40:00',1.32),('15128','2013-12-19','10:45:00',1.36),('15128','2013-12-19','10:50:00',1.4),('15128','2013-12-19','10:55:00',1.42),('15128','2013-12-19','11:00:00',1.47),('15128','2013-12-19','11:05:00',1.49),('15128','2013-12-19','11:10:00',1.54),('15128','2013-12-19','11:15:00',1.62),('15128','2013-12-19','11:20:00',1.73),('15128','2013-12-19','11:25:00',1.79),('15128','2013-12-19','11:30:00',1.82),('15128','2013-12-19','11:35:00',1.85),('15128','2013-12-19','11:40:00',1.88),('15128','2013-12-19','11:45:00',1.89),('15128','2013-12-19','11:50:00',1.91),('15128','2013-12-19','11:55:00',1.96),('15128','2013-12-19','12:00:00',1.96),('15128','2013-12-19','12:05:00',1.97),('15128','2013-12-19','12:10:00',2),('15128','2013-12-19','12:15:00',1.98),('15128','2013-12-19','12:20:00',1.97),('15128','2013-12-19','12:25:00',1.99),('15128','2013-12-19','12:30:00',2),('15128','2013-12-19','12:35:00',2),('15128','2013-12-19','12:40:00',2),('15128','2013-12-19','12:45:00',1.98),('15128','2013-12-19','12:50:00',1.94),('15128','2013-12-19','12:55:00',1.96),('15128','2013-12-19','13:00:00',1.95),('15128','2013-12-19','13:05:00',1.94),('15128','2013-12-19','13:10:00',1.9),('15128','2013-12-19','13:15:00',1.84),('15128','2013-12-19','13:20:00',1.83),('15128','2013-12-19','13:25:00',1.86),('15128','2013-12-19','13:30:00',1.82),('15128','2013-12-19','13:35:00',1.75),('15128','2013-12-19','13:40:00',1.75),('15128','2013-12-19','13:45:00',1.74),('15128','2013-12-19','13:50:00',1.67),('15128','2013-12-19','13:55:00',1.49),('15128','2013-12-19','14:00:00',1.41),('15128','2013-12-19','14:05:00',1.52),('15128','2013-12-19','14:10:00',1.52),('15128','2013-12-19','14:15:00',1.42),('15128','2013-12-19','14:20:00',1.42),('15128','2013-12-19','14:30:00',1.08),('15128','2013-12-19','14:40:00',1.06),('15128','2013-12-19','14:45:00',1.2),('15128','2013-12-19','14:50:00',1.17),('15128','2013-12-19','14:55:00',1.07),('15128','2013-12-18','09:45:00',1.11),('15128','2013-12-18','10:40:00',1.46),('15128','2013-12-18','10:55:00',1.06),('15128','2013-12-18','12:25:00',1.05),('15128','2013-12-18','12:30:00',1.38),('15128','2013-12-18','14:30:00',1.04),('15128','2013-12-18','14:35:00',1.5),('15128','2013-12-18','14:40:00',1.52),('15128','2013-12-18','14:45:00',1.4),('15128','2013-12-18','14:50:00',1.12),('15128','2013-12-18','15:05:00',1.06),('15128','2013-12-17','10:00:00',1.04),('15128','2013-12-17','10:05:00',1.1),('15128','2013-12-17','10:10:00',1.16),('15128','2013-12-17','10:15:00',1.22),('15128','2013-12-17','10:20:00',1.26),('15128','2013-12-17','10:25:00',1.29),('15128','2013-12-17','10:30:00',1.32),('15128','2013-12-17','10:35:00',1.36),('15128','2013-12-17','10:40:00',1.4),('15128','2013-12-17','10:45:00',1.46),('15128','2013-12-17','10:50:00',1.49),('15128','2013-12-17','10:55:00',1.51),('15128','2013-12-17','11:00:00',1.55),('15128','2013-12-17','11:05:00',1.58),('15128','2013-12-17','11:10:00',1.62),('15128','2013-12-17','11:15:00',1.7),('15128','2013-12-17','11:20:00',1.83),('15128','2013-12-17','11:25:00',1.89),('15128','2013-12-17','11:30:00',1.92),('15128','2013-12-17','11:35:00',1.94),('15128','2013-12-17','11:40:00',1.98),('15128','2013-12-17','11:45:00',2),('15128','2013-12-17','11:50:00',2.04),('15128','2013-12-17','11:55:00',2.05),('15128','2013-12-17','12:00:00',2.07),('15128','2013-12-17','12:05:00',2.11),('15128','2013-12-17','12:10:00',2.12),('15128','2013-12-17','12:15:00',2.15),('15128','2013-12-17','12:20:00',2.15),('15128','2013-12-17','12:25:00',2.15),('15128','2013-12-17','12:30:00',2.16),('15128','2013-12-17','12:35:00',2.14),('15128','2013-12-17','12:40:00',2.16),('15128','2013-12-17','12:45:00',2.17),('15128','2013-12-17','12:50:00',2.17),('15128','2013-12-17','12:55:00',2.14),('15128','2013-12-17','13:00:00',2.11),('15128','2013-12-17','13:05:00',2.12),('15128','2013-12-17','13:10:00',2.13),('15128','2013-12-17','13:15:00',2.1),('15128','2013-12-17','13:20:00',2.1),('15128','2013-12-17','13:25:00',2.1),('15128','2013-12-17','13:30:00',2.06),('15128','2013-12-17','13:35:00',2.02),('15128','2013-12-17','13:40:00',2),('15128','2013-12-17','13:45:00',1.97),('15128','2013-12-17','13:50:00',1.94),('15128','2013-12-17','13:55:00',1.92),('15128','2013-12-17','14:00:00',1.87),('15128','2013-12-17','14:05:00',1.8),('15128','2013-12-17','14:10:00',1.76),('15128','2013-12-17','14:15:00',1.72),('15128','2013-12-17','14:20:00',1.68),('15128','2013-12-17','14:25:00',1.63),('15128','2013-12-17','14:30:00',1.54),('15128','2013-12-17','14:35:00',1.49),('15128','2013-12-17','14:40:00',1.43),('15128','2013-12-17','14:45:00',1.35),('15128','2013-12-17','14:50:00',1.27),('15128','2013-12-17','14:55:00',1.22),('15128','2013-12-17','15:00:00',1.13),('15128','2013-12-17','15:05:00',1.06),('15128','2014-04-21','08:30:00',1.01),('15128','2014-04-21','08:35:00',1.03),('15128','2014-04-21','08:40:00',1.06),('15128','2014-04-21','08:45:00',1.22),('15128','2014-04-21','08:50:00',1.31),('15128','2014-04-21','08:55:00',1.33),('15128','2014-04-21','09:00:00',1.46),('15128','2014-04-21','09:05:00',1.3),('15128','2014-04-21','09:15:00',1.46),('15128','2014-04-21','09:20:00',1.73),('15128','2014-04-21','09:25:00',1.9),('15128','2014-04-21','09:30:00',1.89),('15128','2014-04-21','09:35:00',1.98),('15128','2014-04-21','09:40:00',1.83),('15128','2014-04-21','09:45:00',2.24),('15128','2014-04-21','09:50:00',1.33),('15128','2014-04-21','09:55:00',1.25),('15128','2014-04-21','10:00:00',1.54),('15128','2014-04-21','10:05:00',1.55),('15128','2014-04-21','10:10:00',1.61),('15128','2014-04-21','10:15:00',1.69),('15128','2014-04-21','10:20:00',2.69),('15128','2014-04-21','10:25:00',1.55),('15128','2014-04-21','10:30:00',1.91),('15128','2014-04-21','10:35:00',1.85),('15128','2014-04-21','10:40:00',2.36),('15128','2014-04-21','10:45:00',2.71),('15128','2014-04-21','10:50:00',2.49),('15128','2014-04-21','10:55:00',2.59),('15128','2014-04-21','11:00:00',2.89),('15128','2014-04-21','11:05:00',2.54),('15128','2014-04-21','11:10:00',1.56),('15128','2014-04-21','11:15:00',1.55),('15128','2014-04-21','11:20:00',1.33),('15128','2014-04-21','11:25:00',1.09),('15128','2014-04-21','11:40:00',1),('15128','2014-04-21','11:45:00',1.05),('15128','2014-04-21','11:50:00',1.22),('15128','2014-04-21','11:55:00',1.08),('15128','2014-04-21','12:00:00',1.03),('15128','2014-04-21','12:05:00',1.12),('15128','2014-04-21','12:10:00',1.11),('15128','2014-04-21','12:15:00',1.14),('15128','2014-04-21','12:20:00',1.21),('15128','2014-04-21','12:25:00',1.26),('15128','2014-04-21','12:30:00',1.15),('15128','2014-04-21','12:50:00',1),('15128','2014-04-21','12:55:00',1.09),('15128','2014-04-21','13:00:00',1.13),('15128','2014-04-21','13:05:00',1.23),('15128','2014-04-21','13:10:00',1.43),('15128','2014-04-21','13:15:00',1.41),('15128','2014-04-21','13:20:00',1.31),('15128','2014-04-21','13:25:00',1.81),('15128','2014-04-21','13:30:00',2.57),('15128','2014-04-21','13:35:00',2.58),('15128','2014-04-21','13:40:00',2.85),('15128','2014-04-21','13:45:00',3.22),('15128','2014-04-21','13:50:00',2.05),('15128','2014-04-21','13:55:00',2.01),('15128','2014-04-21','14:00:00',1.86),('15128','2014-04-21','14:05:00',3.64),('15128','2014-04-21','14:10:00',3.64),('15128','2014-04-21','14:15:00',2.98),('15128','2014-04-21','14:20:00',2.04),('15128','2014-04-21','14:25:00',1.85),('15128','2014-04-21','14:30:00',2.17),('15128','2014-04-21','14:35:00',2.51),('15128','2014-04-21','14:40:00',1.8),('15128','2014-04-21','14:45:00',1.9),('15128','2014-04-21','14:50:00',3.09),('15128','2014-04-21','14:55:00',2.62),('15128','2014-04-21','15:00:00',1.55),('15128','2014-04-21','15:05:00',1.73),('15128','2014-04-21','15:10:00',1.45),('15128','2014-04-21','15:15:00',1.47),('15128','2014-04-21','15:20:00',1.58),('15128','2014-04-21','15:25:00',2.49),('15128','2014-04-21','15:30:00',2.1),('15128','2014-04-21','15:35:00',2.49),('15128','2014-04-21','15:40:00',2.23),('15128','2014-04-21','15:45:00',2.73),('15128','2014-04-21','15:50:00',2.56),('15128','2014-04-21','15:55:00',2.46),('15128','2014-04-21','16:00:00',3.03),('15128','2014-04-21','16:05:00',2.01),('15128','2014-04-21','16:10:00',1.67),('15128','2014-04-21','16:15:00',1.48),('15128','2014-04-21','16:20:00',1.59),('15128','2014-04-21','16:25:00',1.5),('15128','2014-04-21','16:30:00',1.39),('15128','2014-04-21','16:35:00',1.42),('15128','2014-04-21','16:40:00',1.42),('15128','2014-04-21','16:45:00',1.48),('15128','2014-04-21','16:50:00',1.38),('15128','2014-04-21','16:55:00',1.44),('15128','2014-04-21','17:00:00',1.87),('15128','2014-04-21','17:05:00',1.34),('15128','2014-04-21','17:10:00',1.02),('15128','2013-12-16','09:55:00',1.02),('15128','2013-12-16','10:00:00',1.08),('15128','2013-12-16','10:05:00',1.15),('15128','2013-12-16','10:10:00',1.2),('15128','2013-12-16','10:15:00',1.27),('15128','2013-12-16','10:20:00',1.3),('15128','2013-12-16','10:25:00',1.31),('15128','2013-12-16','10:30:00',1.34),('15128','2013-12-16','10:35:00',1.39),('15128','2013-12-16','10:40:00',1.44),('15128','2013-12-16','10:45:00',1.49),('15128','2013-12-16','10:50:00',1.54),('15128','2013-12-16','10:55:00',1.58),('15128','2013-12-16','11:00:00',1.61),('15128','2013-12-16','11:05:00',1.65),('15128','2013-12-16','11:10:00',1.69),('15128','2013-12-16','11:15:00',1.81),('15128','2013-12-16','11:20:00',1.93),('15128','2013-12-16','11:25:00',1.97),('15128','2013-12-16','11:30:00',2.01),('15128','2013-12-16','11:35:00',2.06),('15128','2013-12-16','11:40:00',2.09),('15128','2013-12-16','11:45:00',2.12),('15128','2013-12-16','11:50:00',2.13),('15128','2013-12-16','11:55:00',2.16),('15128','2013-12-16','12:00:00',2.19),('15128','2013-12-16','12:05:00',2.23),('15128','2013-12-16','12:10:00',2.24),('15128','2013-12-16','12:15:00',2.24),('15128','2013-12-16','12:20:00',2.25),('15128','2013-12-16','12:25:00',2.26),('15128','2013-12-16','12:30:00',2.26),('15128','2013-12-16','12:35:00',2.26),('15128','2013-12-16','12:40:00',2.28),('15128','2013-12-16','12:45:00',2.27),('15128','2013-12-16','12:50:00',2.27),('15128','2013-12-16','12:55:00',2.25),('15128','2013-12-16','13:00:00',2.25),('15128','2013-12-16','13:05:00',2.23),('15128','2013-12-16','13:10:00',2.22),('15128','2013-12-16','13:15:00',2.19),('15128','2013-12-16','13:20:00',2.16),('15128','2013-12-16','13:25:00',2.14),('15128','2013-12-16','13:30:00',2.1),('15128','2013-12-16','13:35:00',2.07),('15128','2013-12-16','13:40:00',2.05),('15128','2013-12-16','13:45:00',2.02),('15128','2013-12-16','13:50:00',2),('15128','2013-12-16','13:55:00',1.92),('15128','2013-12-16','14:00:00',1.89),('15128','2013-12-16','14:05:00',1.86),('15128','2013-12-16','14:10:00',1.83),('15128','2013-12-16','14:15:00',1.79),('15128','2013-12-16','14:20:00',1.75),('15128','2013-12-16','14:25:00',1.67),('15128','2013-12-16','14:30:00',1.6),('15128','2013-12-16','14:35:00',1.57),('15128','2013-12-16','14:40:00',1.51),('15128','2013-12-16','14:45:00',1.42),('15128','2013-12-16','14:50:00',1.34),('15128','2013-12-16','14:55:00',1.3),('15128','2013-12-16','15:00:00',1.2),('15128','2013-12-16','15:05:00',1.11),('15128','2013-12-16','15:10:00',1.03),('15128','2013-12-15','10:05:00',1.16),('15128','2013-12-15','10:10:00',1.19),('15128','2013-12-15','10:15:00',1.25),('15128','2013-12-15','10:20:00',1.28),('15128','2013-12-15','10:25:00',1.32),('15128','2013-12-15','10:30:00',1.35),('15128','2013-12-15','10:35:00',1.39),('15128','2013-12-15','10:40:00',1.45),('15128','2013-12-15','10:45:00',1.48),('15128','2013-12-15','10:50:00',1.54),('15128','2013-12-15','10:55:00',1.56),('15128','2013-12-15','11:00:00',1.58),('15128','2013-12-15','11:05:00',1.63),('15128','2013-12-15','11:10:00',1.68),('15128','2013-12-15','11:15:00',1.83),('15128','2013-12-15','11:20:00',1.93),('15128','2013-12-15','11:25:00',1.97),('15128','2013-12-15','11:30:00',2.01),('15128','2013-12-15','11:35:00',2.06),('15128','2013-12-15','11:40:00',2.09),('15128','2013-12-15','11:45:00',2.12),('15128','2013-12-15','11:50:00',2.14),('15128','2013-12-15','11:55:00',2.15),('15128','2013-12-15','12:00:00',2.17),('15128','2013-12-15','12:05:00',2.18),('15128','2013-12-15','12:10:00',2.2),('15128','2013-12-15','12:15:00',2.22),('15128','2013-12-15','12:25:00',2.23),('15128','2013-12-15','12:30:00',2.2),('15128','2013-12-15','12:35:00',2.22),('15128','2013-12-15','12:40:00',2.22),('15128','2013-12-15','12:45:00',2.23),('15128','2013-12-15','12:50:00',2.19),('15128','2013-12-15','12:55:00',2.2),('15128','2013-12-15','13:00:00',2.24),('15128','2013-12-15','13:05:00',2.21),('15128','2013-12-15','13:10:00',2.2),('15128','2013-12-15','13:15:00',2.14),('15128','2013-12-15','13:20:00',2.16),('15128','2013-12-15','13:25:00',2.12),('15128','2013-12-15','13:30:00',2.11),('15128','2013-12-15','13:35:00',2.08),('15128','2013-12-15','13:40:00',2.06),('15128','2013-12-15','13:45:00',2.04),('15128','2013-12-15','13:50:00',2.03),('15128','2013-12-15','13:55:00',1.98),('15128','2013-12-15','14:00:00',1.95),('15128','2013-12-15','14:05:00',1.9),('15128','2013-12-15','14:10:00',1.87),('15128','2013-12-15','14:15:00',1.82),('15128','2013-12-15','14:20:00',1.76),('15128','2013-12-15','14:25:00',1.7),('15128','2013-12-15','14:30:00',1.59),('15128','2013-12-15','14:35:00',1.54),('15128','2013-12-15','14:40:00',1.51),('15128','2013-12-15','14:45:00',1.42),('15128','2013-12-15','14:50:00',1.36),('15128','2013-12-15','14:55:00',1.32),('15128','2013-12-15','15:00:00',1.25),('15128','2013-12-15','15:05:00',1.14),('15128','2013-12-15','15:10:00',1.06),('15128','2013-12-14','10:25:00',1.16),('15128','2013-12-14','10:30:00',1.05),('15128','2013-12-14','11:15:00',1.07),('15128','2013-12-14','11:20:00',1.01),('15128','2013-12-14','11:25:00',1.02),('15128','2013-12-14','11:30:00',1.04),('15128','2013-12-14','11:55:00',1.03),('15128','2013-12-14','12:00:00',1.04),('15128','2013-12-13','09:55:00',1.01),('15128','2013-12-13','10:00:00',1.08),('15128','2013-12-13','10:05:00',1.13),('15128','2013-12-13','10:10:00',1.2),('15128','2013-12-13','10:15:00',1.26),('15128','2013-12-13','10:20:00',1.28),('15128','2013-12-13','10:25:00',1.31),('15128','2013-12-13','10:30:00',1.33),('15128','2013-12-13','10:35:00',1.38),('15128','2013-12-13','10:40:00',1.41),('15128','2013-12-13','10:45:00',1.47),('15128','2013-12-13','10:50:00',1.51),('15128','2013-12-13','10:55:00',1.55),('15128','2013-12-13','11:00:00',1.57),('15128','2013-12-13','11:05:00',1.61),('15128','2013-12-13','11:10:00',1.63),('15128','2013-12-13','11:15:00',1.76),('15128','2013-12-13','11:20:00',1.8),('15128','2013-12-13','11:25:00',1.84),('15128','2013-12-13','11:30:00',1.87),('15128','2013-12-13','11:35:00',1.9),('15128','2013-12-13','11:40:00',1.94),('15128','2013-12-13','11:45:00',2),('15128','2013-12-13','11:50:00',1.99),('15128','2013-12-13','11:55:00',2.01),('15128','2013-12-13','12:00:00',2.02),('15128','2013-12-13','12:05:00',2.03),('15128','2013-12-13','12:10:00',2.06),('15128','2013-12-13','12:15:00',2.1),('15128','2013-12-13','12:20:00',2.09),('15128','2013-12-13','12:25:00',2.11),('15128','2013-12-13','12:30:00',2.11),('15128','2013-12-13','12:35:00',2.12),('15128','2013-12-13','12:40:00',2.12),('15128','2013-12-13','12:45:00',2.13),('15128','2013-12-13','12:50:00',2.12),('15128','2013-12-13','12:55:00',2.12),('15128','2013-12-13','13:00:00',2.06),('15128','2013-12-13','13:05:00',2.08),('15128','2013-12-13','13:10:00',2.07),('15128','2013-12-13','13:15:00',2.08),('15128','2013-12-13','13:20:00',2.02),('15128','2013-12-13','13:25:00',2.01),('15128','2013-12-13','13:30:00',1.95),('15128','2013-12-13','13:35:00',1.92),('15128','2013-12-13','13:40:00',1.88),('15128','2013-12-13','13:45:00',1.89),('15128','2013-12-13','13:50:00',1.83),('15128','2013-12-13','13:55:00',1.81),('15128','2013-12-13','14:00:00',1.78),('15128','2013-12-13','14:05:00',1.75),('15128','2013-12-13','14:10:00',1.74),('15128','2013-12-13','14:15:00',1.72),('15128','2013-12-13','14:20:00',1.67),('15128','2013-12-13','14:25:00',1.62),('15128','2013-12-13','14:30:00',1.51),('15128','2013-12-13','14:35:00',1.48),('15128','2013-12-13','14:40:00',1.41),('15128','2013-12-13','14:45:00',1.33),('15128','2013-12-13','14:50:00',1.27),('15128','2013-12-13','14:55:00',1.21),('15128','2013-12-13','15:00:00',1.14),('15128','2013-12-13','15:05:00',1.02),('15128','2013-12-12','09:55:00',1.01),('15128','2013-12-12','10:00:00',1.08),('15128','2013-12-12','10:05:00',1.14),('15128','2013-12-12','10:10:00',1.17),('15128','2013-12-12','10:15:00',1.2),('15128','2013-12-12','10:20:00',1.25),('15128','2013-12-12','10:25:00',1.27),('15128','2013-12-12','10:30:00',1.31),('15128','2013-12-12','10:35:00',1.36),('15128','2013-12-12','10:40:00',1.39),('15128','2013-12-12','10:45:00',1.44),('15128','2013-12-12','10:50:00',1.48),('15128','2013-12-12','10:55:00',1.51),('15128','2013-12-12','11:00:00',1.54),('15128','2013-12-12','11:05:00',1.58),('15128','2013-12-12','11:10:00',1.62),('15128','2013-12-12','11:15:00',1.72),('15128','2013-12-12','11:20:00',1.8),('15128','2013-12-12','11:25:00',1.81),('15128','2013-12-12','11:30:00',1.84),('15128','2013-12-12','11:35:00',1.84),('15128','2013-12-12','11:40:00',1.89),('15128','2013-12-12','11:45:00',1.95),('15128','2013-12-12','11:50:00',1.96),('15128','2013-12-12','11:55:00',1.99),('15128','2013-12-12','12:00:00',2),('15128','2013-12-12','12:05:00',1.99),('15128','2013-12-12','12:10:00',1.98),('15128','2013-12-12','12:15:00',2.03),('15128','2013-12-12','12:20:00',2),('15128','2013-12-12','12:25:00',1.82),('15128','2013-12-12','12:30:00',1.91),('15128','2013-12-12','12:35:00',2),('15128','2013-12-12','12:40:00',2.02),('15128','2013-12-12','12:45:00',1.98),('15128','2013-12-12','12:50:00',2),('15128','2013-12-12','12:55:00',2.08),('15128','2013-12-12','13:00:00',2.02),('15128','2013-12-12','13:05:00',2),('15128','2013-12-12','13:10:00',1.98),('15128','2013-12-12','13:15:00',2.04),('15128','2013-12-12','13:20:00',2.03),('15128','2013-12-12','13:25:00',2.05),('15128','2013-12-12','13:30:00',2.03),('15128','2013-12-12','13:35:00',2.01),('15128','2013-12-12','13:40:00',1.97),('15128','2013-12-12','13:45:00',1.93),('15128','2013-12-12','13:50:00',1.87),('15128','2013-12-12','13:55:00',1.86),('15128','2013-12-12','14:00:00',1.79),('15128','2013-12-12','14:05:00',1.76),('15128','2013-12-12','14:10:00',1.7),('15128','2013-12-12','14:15:00',1.7),('15128','2013-12-12','14:20:00',1.6),('15128','2013-12-12','14:25:00',1.56),('15128','2013-12-12','14:30:00',1.47),('15128','2013-12-12','14:35:00',1.47),('15128','2013-12-12','14:40:00',1.4),('15128','2013-12-12','14:45:00',1.33),('15128','2013-12-12','14:50:00',1.26),('15128','2013-12-12','14:55:00',1.17),('15128','2013-12-12','15:00:00',1.11),('15128','2013-12-12','15:05:00',1.02),('15128','2013-12-11','09:55:00',1.01),('15128','2013-12-11','10:00:00',1.08),('15128','2013-12-11','10:05:00',1.13),('15128','2013-12-11','10:10:00',1.18),('15128','2013-12-11','10:15:00',1.23),('15128','2013-12-11','10:20:00',1.25),('15128','2013-12-11','10:25:00',1.3),('15128','2013-12-11','10:30:00',1.36),('15128','2013-12-11','10:35:00',1.39),('15128','2013-12-11','10:40:00',1.41),('15128','2013-12-11','10:45:00',1.43),('15128','2013-12-11','10:50:00',1.49),('15128','2013-12-11','10:55:00',1.53),('15128','2013-12-11','11:00:00',1.58),('15128','2013-12-11','11:05:00',1.62),('15128','2013-12-11','11:10:00',1.69),('15128','2013-12-11','11:15:00',1.78),('15128','2013-12-11','11:20:00',1.82),('15128','2013-12-11','11:25:00',1.86),('15128','2013-12-11','11:30:00',1.92),('15128','2013-12-11','11:35:00',1.95),('15128','2013-12-11','11:40:00',1.96),('15128','2013-12-11','11:45:00',2),('15128','2013-12-11','11:50:00',2.02),('15128','2013-12-11','11:55:00',2.05),('15128','2013-12-11','12:00:00',2.07),('15128','2013-12-11','12:05:00',2.08),('15128','2013-12-11','12:10:00',2.09),('15128','2013-12-11','12:15:00',2.1),('15128','2013-12-11','12:20:00',2.13),('15128','2013-12-11','12:25:00',2.15),('15128','2013-12-11','12:30:00',2.15),('15128','2013-12-11','12:35:00',2.17),('15128','2013-12-11','12:40:00',2.17),('15128','2013-12-11','12:45:00',2.15),('15128','2013-12-11','12:50:00',2.15),('15128','2013-12-11','12:55:00',2.14),('15128','2013-12-11','13:00:00',2.12),('15128','2013-12-11','13:05:00',2.13),('15128','2013-12-11','13:10:00',2.1),('15128','2013-12-11','13:15:00',2.09),('15128','2013-12-11','13:20:00',2.06),('15128','2013-12-11','13:25:00',2.05),('15128','2013-12-11','13:30:00',1.98),('15128','2013-12-11','13:35:00',1.98),('15128','2013-12-11','13:40:00',1.93),('15128','2013-12-11','13:45:00',1.91),('15128','2013-12-11','13:50:00',1.89),('15128','2013-12-11','13:55:00',1.86),('15128','2013-12-11','14:00:00',1.8),('15128','2013-12-11','14:05:00',1.79),('15128','2013-12-11','14:10:00',1.75),('15128','2013-12-11','14:15:00',1.7),('15128','2013-12-11','14:20:00',1.64),('15128','2013-12-11','14:25:00',1.57),('15128','2013-12-11','14:30:00',1.47),('15128','2013-12-11','14:35:00',1.46),('15128','2013-12-11','14:40:00',1.39),('15128','2013-12-11','14:45:00',1.31),('15128','2013-12-11','14:50:00',1.19),('15128','2013-12-11','14:55:00',1.17),('15128','2013-12-11','15:00:00',1.09),('15128','2013-12-10','09:55:00',1.04),('15128','2013-12-10','10:00:00',1.12),('15128','2013-12-10','10:05:00',1.18),('15128','2013-12-10','10:10:00',1.23),('15128','2013-12-10','10:15:00',1.27),('15128','2013-12-10','10:20:00',1.32),('15128','2013-12-10','10:25:00',1.35),('15128','2013-12-10','10:30:00',1.41),('15128','2013-12-10','10:35:00',1.45),('15128','2013-12-10','10:40:00',1.49),('15128','2013-12-10','10:45:00',1.51),('15128','2013-12-10','10:50:00',1.53),('15128','2013-12-10','10:55:00',1.54),('15128','2013-12-10','11:00:00',1.6),('15128','2013-12-10','11:05:00',1.65),('15128','2013-12-10','11:10:00',1.74),('15128','2013-12-10','11:15:00',1.85),('15128','2013-12-10','11:20:00',1.9),('15128','2013-12-10','11:25:00',1.92),('15128','2013-12-10','11:30:00',1.95),('15128','2013-12-10','11:35:00',2),('15128','2013-12-10','11:40:00',2.05),('15128','2013-12-10','11:45:00',2.09),('15128','2013-12-10','11:50:00',2.13),('15128','2013-12-10','11:55:00',2.15),('15128','2013-12-10','12:00:00',2.18),('15128','2013-12-10','12:05:00',2.19),('15128','2013-12-10','12:10:00',2.17),('15128','2013-12-10','12:15:00',2.19),('15128','2013-12-10','12:20:00',2.22),('15128','2013-12-10','12:25:00',2.23),('15128','2013-12-10','12:30:00',2.23),('15128','2013-12-10','12:35:00',2.23),('15128','2013-12-10','12:40:00',2.2),('15128','2013-12-10','12:45:00',2.22),('15128','2013-12-10','12:50:00',2.22),('15128','2013-12-10','12:55:00',2.22),('15128','2013-12-10','13:00:00',2.19),('15128','2013-12-10','13:05:00',2.19),('15128','2013-12-10','13:10:00',2.19),('15128','2013-12-10','13:15:00',2.17),('15128','2013-12-10','13:20:00',2.14),('15128','2013-12-10','13:25:00',2.12),('15128','2013-12-10','13:30:00',2.1),('15128','2013-12-10','13:35:00',2.05),('15128','2013-12-10','13:40:00',1.99),('15128','2013-12-10','13:45:00',1.99),('15128','2013-12-10','13:50:00',1.97),('15128','2013-12-10','13:55:00',1.95),('15128','2013-12-10','14:00:00',1.91),('15128','2013-12-10','14:05:00',1.88),('15128','2013-12-10','14:10:00',1.86),('15128','2013-12-10','14:15:00',1.79),('15128','2013-12-10','14:20:00',1.73),('15128','2013-12-10','14:25:00',1.69),('15128','2013-12-10','14:30:00',1.6),('15128','2013-12-10','14:35:00',1.55),('15128','2013-12-10','14:40:00',1.51),('15128','2013-12-10','14:45:00',1.42),('15128','2013-12-10','14:50:00',1.3),('15128','2013-12-10','14:55:00',1.25),('15128','2013-12-10','15:00:00',1.16),('15128','2013-12-10','15:05:00',1.05),('15128','2013-12-09','09:55:00',1.07),('15128','2013-12-09','10:00:00',1.13),('15128','2013-12-09','10:05:00',1.19),('15128','2013-12-09','10:10:00',1.25),('15128','2013-12-09','10:15:00',1.27),('15128','2013-12-09','10:20:00',1.31),('15128','2013-12-09','10:25:00',1.35),('15128','2013-12-09','10:30:00',1.41),('15128','2013-12-09','10:35:00',1.47),('15128','2013-12-09','10:40:00',1.5),('15128','2013-12-09','10:45:00',1.53),('15128','2013-12-09','10:50:00',1.58),('15128','2013-12-09','10:55:00',1.6),('15128','2013-12-09','11:00:00',1.67),('15128','2013-12-09','11:05:00',1.71),('15128','2013-12-09','11:10:00',1.82),('15128','2013-12-09','11:15:00',1.91),('15128','2013-12-09','11:20:00',1.95),('15128','2013-12-09','11:25:00',1.99),('15128','2013-12-09','11:30:00',2.01),('15128','2013-12-09','11:35:00',2.04),('15128','2013-12-09','11:40:00',2.08),('15128','2013-12-09','11:45:00',2.12),('15128','2013-12-09','11:50:00',2.13),('15128','2013-12-09','11:55:00',2.15),('15128','2013-12-09','12:00:00',2.16),('15128','2013-12-09','12:05:00',2.18),('15128','2013-12-09','12:10:00',2.17),('15128','2013-12-09','12:15:00',2.18),('15128','2013-12-09','12:20:00',2.21),('15128','2013-12-09','12:25:00',2.22),('15128','2013-12-09','12:30:00',2.24),('15128','2013-12-09','12:35:00',2.26),('15128','2013-12-09','12:40:00',2.25),('15128','2013-12-09','12:45:00',2.24),('15128','2013-12-09','12:50:00',2.22),('15128','2013-12-09','12:55:00',2.24),('15128','2013-12-09','13:00:00',2.22),('15128','2013-12-09','13:05:00',2.2),('15128','2013-12-09','13:10:00',2.18),('15128','2013-12-09','13:15:00',2.16),('15128','2013-12-09','13:20:00',2.14),('15128','2013-12-09','13:25:00',2.1),('15128','2013-12-09','13:30:00',2.06),('15128','2013-12-09','13:35:00',2.04),('15128','2013-12-09','13:40:00',2.03),('15128','2013-12-09','13:45:00',2.02),('15128','2013-12-09','13:50:00',1.97),('15128','2013-12-09','13:55:00',1.93),('15128','2013-12-09','14:00:00',1.91),('15128','2013-12-09','14:05:00',1.87),('15128','2013-12-09','14:10:00',1.82),('15128','2013-12-09','14:15:00',1.79),('15128','2013-12-09','14:20:00',1.74),('15128','2013-12-09','14:25:00',1.71),('15128','2013-12-09','14:30:00',1.64),('15128','2013-12-09','14:35:00',1.56),('15128','2013-12-09','14:40:00',1.41),('15128','2013-12-09','14:45:00',1.4),('15128','2013-12-09','14:50:00',1.29),('15128','2013-12-09','14:55:00',1.26),('15128','2013-12-09','15:00:00',1.19),('15128','2013-12-09','15:05:00',1.09),('15128','2013-12-08','09:40:00',1.02),('15128','2013-12-08','09:45:00',1.2),('15128','2013-12-08','09:50:00',1.55),('15128','2013-12-08','09:55:00',1.74),('15128','2013-12-08','10:00:00',1.69),('15128','2013-12-08','12:25:00',1.11),('15128','2013-12-08','12:30:00',1.21),('15128','2013-12-08','12:40:00',1.17),('15128','2013-12-08','12:45:00',1.83),('15128','2013-12-08','12:50:00',2.39),('15128','2013-12-08','12:55:00',2.27),('15128','2013-12-08','13:00:00',2.13),('15128','2013-12-08','13:05:00',2.11),('15128','2013-12-08','13:10:00',1.74),('15128','2013-12-08','13:15:00',1.97),('15128','2013-12-08','13:20:00',2.63),('15128','2013-12-08','13:25:00',2.24),('15128','2013-12-08','13:30:00',1.25),('15128','2013-12-08','13:35:00',1.48),('15128','2013-12-08','13:40:00',1.4),('15128','2013-12-08','13:45:00',1.26),('15128','2013-12-08','13:50:00',1.12),('15128','2013-12-07','11:25:00',1.05),('15128','2013-12-07','11:30:00',1),('15128','2013-12-07','12:30:00',1.15),('15128','2013-12-07','12:35:00',1.07),('15128','2013-12-07','12:40:00',1.25),('15128','2013-12-07','12:45:00',1.17),('15128','2013-12-07','12:50:00',1.3),('15128','2013-12-07','12:55:00',1.04),('15128','2013-12-07','15:00:00',1.22),('15128','2013-12-07','15:05:00',1.05),('15128','2014-04-20','08:50:00',1.07),('15128','2014-04-20','08:55:00',1.47),('15128','2014-04-20','09:00:00',1.38),('15128','2014-04-20','09:05:00',1.33),('15128','2014-04-20','09:10:00',1.17),('15128','2014-04-20','09:15:00',1.05),('15128','2014-04-20','09:25:00',1.19),('15128','2014-04-20','09:30:00',2.31),('15128','2014-04-20','09:35:00',2.31),('15128','2014-04-20','09:40:00',1.38),('15128','2014-04-20','09:50:00',1.06),('15128','2014-04-20','09:55:00',1.25),('15128','2014-04-20','10:00:00',1.34),('15128','2014-04-20','10:05:00',1.45),('15128','2014-04-20','10:10:00',1.77),('15128','2014-04-20','10:15:00',2.1),('15128','2014-04-20','10:20:00',2.17),('15128','2014-04-20','10:25:00',2.55),('15128','2014-04-20','10:30:00',2.48),('15128','2014-04-20','10:35:00',2.54),('15128','2014-04-20','10:40:00',2.65),('15128','2014-04-20','10:45:00',2.63),('15128','2014-04-20','10:50:00',2.68),('15128','2014-04-20','10:55:00',2.71),('15128','2014-04-20','11:00:00',2.77),('15128','2014-04-20','11:05:00',2.83),('15128','2014-04-20','11:10:00',2.91),('15128','2014-04-20','11:15:00',2.99),('15128','2014-04-20','11:20:00',3.04),('15128','2014-04-20','11:25:00',3.05),('15128','2014-04-20','11:30:00',3.09),('15128','2014-04-20','11:35:00',3.14),('15128','2014-04-20','11:40:00',3.24),('15128','2014-04-20','11:45:00',3.34),('15128','2014-04-20','11:50:00',3.49),('15128','2014-04-20','11:55:00',3.57),('15128','2014-04-20','12:00:00',3.62),('15128','2014-04-20','12:05:00',3.67),('15128','2014-04-20','12:10:00',3.71),('15128','2014-04-20','12:15:00',3.75),('15128','2014-04-20','12:20:00',3.78),('15128','2014-04-20','12:25:00',3.81),('15128','2014-04-20','12:30:00',3.84),('15128','2014-04-20','12:35:00',3.84),('15128','2014-04-20','12:40:00',3.86),('15128','2014-04-20','12:45:00',3.88),('15128','2014-04-20','12:50:00',3.92),('15128','2014-04-20','12:55:00',3.93),('15128','2014-04-20','13:00:00',3.96),('15128','2014-04-20','13:05:00',3.97),('15128','2014-04-20','13:10:00',3.98),('15128','2014-04-20','13:15:00',3.98),('15128','2014-04-20','13:20:00',3.97),('15128','2014-04-20','13:25:00',3.99),('15128','2014-04-20','13:30:00',4.02),('15128','2014-04-20','13:35:00',4.05),('15128','2014-04-20','13:40:00',4.06),('15128','2014-04-20','13:45:00',4.08),('15128','2014-04-20','13:50:00',4.08),('15128','2014-04-20','13:55:00',4.07),('15128','2014-04-20','14:00:00',4.08),('15128','2014-04-20','14:05:00',4.09),('15128','2014-04-20','14:10:00',4.09),('15128','2014-04-20','14:15:00',4.09),('15128','2014-04-20','14:20:00',4.09),('15128','2014-04-20','14:25:00',4.07),('15128','2014-04-20','14:30:00',4.05),('15128','2014-04-20','14:35:00',4.05),('15128','2014-04-20','14:40:00',4.04),('15128','2014-04-20','14:45:00',4.03),('15128','2014-04-20','14:50:00',3.99),('15128','2014-04-20','14:55:00',3.96),('15128','2014-04-20','15:00:00',3.91),('15128','2014-04-20','15:05:00',3.89),('15128','2014-04-20','15:10:00',3.87),('15128','2014-04-20','15:15:00',3.85),('15128','2014-04-20','15:20:00',3.82),('15128','2014-04-20','15:25:00',3.75),('15128','2014-04-20','15:30:00',3.74),('15128','2014-04-20','15:35:00',3.67),('15128','2014-04-20','15:40:00',3.63),('15128','2014-04-20','15:45:00',3.6),('15128','2014-04-20','15:50:00',3.55),('15128','2014-04-20','15:55:00',3.52),('15128','2014-04-20','16:00:00',3.46),('15128','2014-04-20','16:05:00',2.05),('15128','2014-04-20','16:10:00',3.53),('15128','2014-04-20','16:15:00',3.4),('15128','2014-04-20','16:20:00',3.34),('15128','2014-04-20','16:25:00',3.27),('15128','2014-04-20','16:30:00',3.18),('15128','2014-04-20','16:35:00',3.13),('15128','2014-04-20','16:40:00',3.09),('15128','2014-04-20','16:45:00',3.03),('15128','2014-04-20','16:50:00',2.97),('15128','2014-04-20','16:55:00',2.91),('15128','2014-04-20','17:00:00',2.85),('15128','2014-04-20','17:05:00',2.79),('15128','2014-04-20','17:10:00',2.71),('15128','2014-04-20','17:15:00',2.6),('15128','2014-04-20','17:20:00',2.53),('15128','2014-04-20','17:25:00',2.44),('15128','2014-04-20','17:30:00',2.36),('15128','2014-04-20','17:35:00',2.26),('15128','2014-04-20','17:40:00',2.15),('15128','2014-04-20','17:45:00',2.07),('15128','2014-04-20','17:50:00',1.91),('15128','2014-04-20','17:55:00',1.83),('15128','2014-04-20','18:00:00',1.74),('15128','2014-04-20','18:05:00',1.66),('15128','2014-04-20','18:10:00',1.56),('15128','2014-04-20','18:15:00',1.5),('15128','2014-04-20','18:20:00',1.41),('15128','2014-04-20','18:25:00',1.32),('15128','2014-04-20','18:30:00',1.23),('15128','2014-04-20','18:35:00',1.14),('15128','2014-04-20','18:40:00',1.02),('15128','2013-12-06','09:50:00',1.06),('15128','2013-12-06','09:55:00',1.1),('15128','2013-12-06','10:00:00',1.18),('15128','2013-12-06','10:05:00',1.25),('15128','2013-12-06','10:10:00',1.29),('15128','2013-12-06','10:15:00',1.33),('15128','2013-12-06','10:20:00',1.36),('15128','2013-12-06','10:25:00',1.39),('15128','2013-12-06','10:30:00',1.45),('15128','2013-12-06','10:35:00',1.51),('15128','2013-12-06','10:40:00',1.54),('15128','2013-12-06','10:45:00',1.59),('15128','2013-12-06','10:50:00',1.62),('15128','2013-12-06','10:55:00',1.62),('15128','2013-12-06','11:00:00',1.65),('15128','2013-12-06','11:05:00',1.72),('15128','2013-12-06','11:10:00',1.82),('15128','2013-12-06','11:15:00',1.88),('15128','2013-12-06','11:20:00',1.9),('15128','2013-12-06','11:25:00',1.93),('15128','2013-12-06','11:30:00',1.98),('15128','2013-12-06','11:35:00',2.03),('15128','2013-12-06','11:40:00',2.07),('15128','2013-12-06','11:45:00',2.09),('15128','2013-12-06','11:50:00',2.1),('15128','2013-12-06','11:55:00',2.11),('15128','2013-12-06','12:00:00',2.14),('15128','2013-12-06','12:05:00',2.15),('15128','2013-12-06','12:10:00',2.13),('15128','2013-12-06','12:15:00',2.13),('15128','2013-12-06','12:20:00',2.11),('15128','2013-12-06','12:25:00',2.11),('15128','2013-12-06','12:30:00',2.12),('15128','2013-12-06','12:35:00',2.12),('15128','2013-12-06','12:40:00',2.11),('15128','2013-12-06','12:45:00',2.13),('15128','2013-12-06','12:50:00',2.09),('15128','2013-12-06','12:55:00',2.08),('15128','2013-12-06','13:00:00',2.07),('15128','2013-12-06','13:05:00',2.07),('15128','2013-12-06','13:10:00',2.07),('15128','2013-12-06','13:15:00',2.08),('15128','2013-12-06','13:20:00',2.04),('15128','2013-12-06','13:25:00',2.02),('15128','2013-12-06','13:30:00',1.99),('15128','2013-12-06','13:35:00',1.96),('15128','2013-12-06','13:40:00',1.91),('15128','2013-12-06','13:45:00',1.88),('15128','2013-12-06','13:50:00',1.84),('15128','2013-12-06','13:55:00',1.81),('15128','2013-12-06','14:00:00',1.76),('15128','2013-12-06','14:05:00',1.75),('15128','2013-12-06','14:10:00',1.74),('15128','2013-12-06','14:15:00',1.69),('15128','2013-12-06','14:20:00',1.63),('15128','2013-12-06','14:25:00',1.6),('15128','2013-12-06','14:30:00',1.57),('15128','2013-12-06','14:35:00',1.47),('15128','2013-12-06','14:40:00',1.43),('15128','2013-12-06','14:45:00',1.36),('15128','2013-12-06','14:50:00',1.29),('15128','2013-12-06','14:55:00',1.21),('15128','2013-12-06','15:00:00',1.13),('15128','2013-12-05','10:15:00',1.14),('15128','2013-12-05','10:20:00',1.01),('15128','2013-12-05','10:40:00',1.26),('15128','2013-12-05','10:45:00',1.11),('15128','2013-12-05','11:00:00',1.01),('15128','2013-12-05','11:10:00',1.02),('15128','2013-12-05','11:15:00',1.08),('15128','2013-12-05','11:20:00',1.33),('15128','2013-12-05','11:25:00',1.44),('15128','2013-12-05','11:30:00',1.58),('15128','2013-12-05','11:35:00',2.04),('15128','2013-12-05','11:40:00',2.27),('15128','2013-12-05','11:45:00',1.94),('15128','2013-12-05','11:50:00',1.62),('15128','2013-12-05','11:55:00',1.85),('15128','2013-12-05','12:00:00',1.78),('15128','2013-12-05','12:05:00',1.96),('15128','2013-12-05','12:10:00',1.98),('15128','2013-12-05','12:15:00',2.64),('15128','2013-12-05','12:20:00',1.61),('15128','2013-12-05','12:25:00',1.25),('15128','2013-12-05','12:30:00',1.24),('15128','2013-12-05','12:35:00',1.09),('15128','2013-12-05','12:40:00',1.02),('15128','2013-12-05','13:25:00',1.01),('15128','2013-12-05','13:35:00',1.03),('15128','2013-12-05','13:40:00',1.06),('15128','2013-12-05','14:45:00',1.17),('15128','2013-12-05','14:55:00',1.39),('15128','2013-12-05','15:00:00',1.28),('15128','2013-12-05','15:05:00',1.15),('15128','2013-12-05','15:10:00',1.18),('15128','2013-12-05','15:15:00',1.27),('15128','2013-12-05','15:20:00',1.08),('15128','2013-12-04','09:45:00',1.02),('15128','2013-12-04','09:50:00',1.08),('15128','2013-12-04','09:55:00',1.13),('15128','2013-12-04','10:00:00',1.18),('15128','2013-12-04','10:05:00',1.24),('15128','2013-12-04','10:10:00',1.3),('15128','2013-12-04','10:15:00',1.35),('15128','2013-12-04','10:20:00',1.38),('15128','2013-12-04','10:25:00',1.41),('15128','2013-12-04','10:30:00',1.46),('15128','2013-12-04','10:35:00',1.51),('15128','2013-12-04','10:40:00',1.55),('15128','2013-12-04','10:45:00',1.6),('15128','2013-12-04','10:50:00',1.64),('15128','2013-12-04','10:55:00',1.69),('15128','2013-12-04','11:00:00',1.7),('15128','2013-12-04','11:05:00',1.76),('15128','2013-12-04','11:10:00',1.87),('15128','2013-12-04','11:15:00',1.95),('15128','2013-12-04','11:20:00',1.96),('15128','2013-12-04','11:25:00',2),('15128','2013-12-04','11:30:00',2.02),('15128','2013-12-04','11:35:00',2.04),('15128','2013-12-04','11:40:00',2.08),('15128','2013-12-04','11:45:00',2.11),('15128','2013-12-04','11:50:00',2.1),('15128','2013-12-04','11:55:00',2.11),('15128','2013-12-04','12:00:00',2.18),('15128','2013-12-04','12:05:00',2.22),('15128','2013-12-04','12:10:00',2.24),('15128','2013-12-04','12:15:00',2.27),('15128','2013-12-04','12:20:00',2.25),('15128','2013-12-04','12:25:00',2.24),('15128','2013-12-04','12:30:00',2.27),('15128','2013-12-04','12:35:00',2.31),('15128','2013-12-04','12:40:00',2.29),('15128','2013-12-04','12:45:00',2.24),('15128','2013-12-04','12:50:00',2.28),('15128','2013-12-04','12:55:00',2.28),('15128','2013-12-04','13:00:00',2.28),('15128','2013-12-04','13:05:00',2.24),('15128','2013-12-04','13:10:00',2.18),('15128','2013-12-04','13:15:00',2.2),('15128','2013-12-04','13:20:00',2.12),('15128','2013-12-04','13:25:00',2.06),('15128','2013-12-04','13:30:00',2.09),('15128','2013-12-04','13:35:00',2.07),('15128','2013-12-04','13:40:00',2),('15128','2013-12-04','13:45:00',2.03),('15128','2013-12-04','13:50:00',1.94),('15128','2013-12-04','13:55:00',1.92),('15128','2013-12-04','14:00:00',1.97),('15128','2013-12-04','14:05:00',1.9),('15128','2013-12-04','14:10:00',1.76),('15128','2013-12-04','14:15:00',1.64),('15128','2013-12-04','14:20:00',1.71),('15128','2013-12-04','14:25:00',1.72),('15128','2013-12-04','14:30:00',1.63),('15128','2013-12-04','14:35:00',1.57),('15128','2013-12-04','14:40:00',1.48),('15128','2013-12-04','14:45:00',1.4),('15128','2013-12-04','14:50:00',1.35),('15128','2013-12-04','14:55:00',1.21),('15128','2013-12-04','15:00:00',1.2),('15128','2013-12-04','15:05:00',1.06),('15128','2013-12-03','09:40:00',1.02),('15128','2013-12-03','09:45:00',1.09),('15128','2013-12-03','09:50:00',1.16),('15128','2013-12-03','09:55:00',1.22),('15128','2013-12-03','10:00:00',1.29),('15128','2013-12-03','10:05:00',1.33),('15128','2013-12-03','10:10:00',1.39),('15128','2013-12-03','10:15:00',1.43),('15128','2013-12-03','10:20:00',1.46),('15128','2013-12-03','10:25:00',1.51),('15128','2013-12-03','10:30:00',1.56),('15128','2013-12-03','10:35:00',1.58),('15128','2013-12-03','10:40:00',1.64),('15128','2013-12-03','10:45:00',1.68),('15128','2013-12-03','10:50:00',1.73),('15128','2013-12-03','10:55:00',1.76),('15128','2013-12-03','11:00:00',1.78),('15128','2013-12-03','11:05:00',1.89),('15128','2013-12-03','11:10:00',2.02),('15128','2013-12-03','11:15:00',2.06),('15128','2013-12-03','11:20:00',2.09),('15128','2013-12-03','11:25:00',2.12),('15128','2013-12-03','11:30:00',2.16),('15128','2013-12-03','11:35:00',2.21),('15128','2013-12-03','11:40:00',2.26),('15128','2013-12-03','11:45:00',2.29),('15128','2013-12-03','11:50:00',2.32),('15128','2013-12-03','11:55:00',2.34),('15128','2013-12-03','12:00:00',2.37),('15128','2013-12-03','12:05:00',2.4),('15128','2013-12-03','12:10:00',2.39),('15128','2013-12-03','12:15:00',2.39),('15128','2013-12-03','12:20:00',2.38),('15128','2013-12-03','12:25:00',2.4),('15128','2013-12-03','12:30:00',2.41),('15128','2013-12-03','12:35:00',2.41),('15128','2013-12-03','12:40:00',2.4),('15128','2013-12-03','12:45:00',2.4),('15128','2013-12-03','12:50:00',2.37),('15128','2013-12-03','12:55:00',2.37),('15128','2013-12-03','13:00:00',2.35),('15128','2013-12-03','13:05:00',2.35),('15128','2013-12-03','13:10:00',2.35),('15128','2013-12-03','13:15:00',2.33),('15128','2013-12-03','13:20:00',2.32),('15128','2013-12-03','13:25:00',2.29),('15128','2013-12-03','13:30:00',2.29),('15128','2013-12-03','13:35:00',2.25),('15128','2013-12-03','13:40:00',2.22),('15128','2013-12-03','13:45:00',2.19),('15128','2013-12-03','13:50:00',2.16),('15128','2013-12-03','13:55:00',2.11),('15128','2013-12-03','14:00:00',2.08),('15128','2013-12-03','14:05:00',2.03),('15128','2013-12-03','14:10:00',1.98),('15128','2013-12-03','14:15:00',1.95),('15128','2013-12-03','14:20:00',1.91),('15128','2013-12-03','14:25:00',1.85),('15128','2013-12-03','14:30:00',1.8),('15128','2013-12-03','14:35:00',1.75),('15128','2013-12-03','14:40:00',1.67),('15128','2013-12-03','14:45:00',1.62),('15128','2013-12-03','14:50:00',1.55),('15128','2013-12-03','14:55:00',1.36),('15128','2013-12-03','15:00:00',1.35),('15128','2013-12-03','15:05:00',1.25),('15128','2013-12-03','15:10:00',1.15),('15128','2013-12-03','15:15:00',1.06),('15128','2013-12-02','09:55:00',1.19),('15128','2013-12-02','10:00:00',1.29),('15128','2013-12-02','10:05:00',1.33),('15128','2013-12-02','10:10:00',1.39),('15128','2013-12-02','10:15:00',1.43),('15128','2013-12-02','10:20:00',1.47),('15128','2013-12-02','10:25:00',1.51),('15128','2013-12-02','10:30:00',1.57),('15128','2013-12-02','10:35:00',1.6),('15128','2013-12-02','10:40:00',1.64),('15128','2013-12-02','10:45:00',1.68),('15128','2013-12-02','10:50:00',1.72),('15128','2013-12-02','10:55:00',1.77),('15128','2013-12-02','11:00:00',1.84),('15128','2013-12-02','11:05:00',1.92),('15128','2013-12-02','11:10:00',2.06),('15128','2013-12-02','11:15:00',2.12),('15128','2013-12-02','11:20:00',2.19),('15128','2013-12-02','11:25:00',2.23),('15128','2013-12-02','11:30:00',2.27),('15128','2013-12-02','11:35:00',2.31),('15128','2013-12-02','11:40:00',2.34),('15128','2013-12-02','11:45:00',2.39),('15128','2013-12-02','11:50:00',2.43),('15128','2013-12-02','11:55:00',2.45),('15128','2013-12-02','12:00:00',2.48),('15128','2013-12-02','12:05:00',2.52),('15128','2013-12-02','12:10:00',2.58),('15128','2013-12-02','12:15:00',2.61),('15128','2013-12-02','12:20:00',2.64),('15128','2013-12-02','12:25:00',2.69),('15128','2013-12-02','12:30:00',2.74),('15128','2013-12-02','12:35:00',2.79),('15128','2013-12-02','12:40:00',2.83),('15128','2013-12-02','12:45:00',2.88),('15128','2013-12-02','12:50:00',2.94),('15128','2013-12-02','12:55:00',3.04),('15128','2013-12-02','13:00:00',3.13),('15128','2013-12-02','13:05:00',3.13),('15128','2013-12-02','13:10:00',3.11),('15128','2013-12-02','13:15:00',2.95),('15128','2013-12-02','13:20:00',2.39),('15128','2013-12-02','13:25:00',1.67),('15128','2013-12-02','13:30:00',1.44),('15128','2013-12-02','13:35:00',1.61),('15128','2013-12-02','13:40:00',1.34),('15128','2013-12-02','13:45:00',1.1),('15128','2013-12-02','13:50:00',1.02),('15128','2013-12-02','14:00:00',1.01),('15128','2013-12-02','14:05:00',1.38),('15128','2013-12-02','14:10:00',1.74),('15128','2013-12-02','14:15:00',1.78),('15128','2013-12-02','14:20:00',1.8),('15128','2013-12-02','14:25:00',1.81),('15128','2013-12-02','14:30:00',1.8),('15128','2013-12-02','14:35:00',1.74),('15128','2013-12-02','14:40:00',1.32),('15128','2013-12-02','14:45:00',1.2),('15128','2013-12-02','14:50:00',1.46),('15128','2013-12-02','14:55:00',1.35),('15128','2013-12-02','15:00:00',1.3),('15128','2013-12-02','15:05:00',1.19),('15128','2013-12-02','15:10:00',1.09),('15128','2013-12-02','15:15:00',1.01),('15128','2013-11-30','11:35:00',1.42),('15128','2013-11-30','11:40:00',2.17),('15128','2013-11-30','11:45:00',1.9),('15128','2013-11-30','11:50:00',1.69),('15128','2013-11-30','11:55:00',1.81),('15128','2013-11-30','12:00:00',2.29),('15128','2013-11-30','12:05:00',1.93),('15128','2013-11-30','12:10:00',2.12),('15128','2013-11-30','12:15:00',2.42),('15128','2013-11-30','12:20:00',1.43),('15128','2013-11-30','12:25:00',1.32),('15128','2013-11-30','12:50:00',2.11),('15128','2013-11-30','12:55:00',1.1),('15128','2013-11-30','13:00:00',1.08),('15128','2013-11-29','09:25:00',1.01),('15128','2013-11-29','09:30:00',1.23),('15128','2013-11-29','09:35:00',1.16),('15128','2013-11-29','09:40:00',1.05),('15128','2013-11-29','10:20:00',1.03),('15128','2013-11-29','10:25:00',1.01),('15128','2013-11-29','10:45:00',1.04),('15128','2013-11-29','10:50:00',1.02),('15128','2013-11-29','10:55:00',1.22),('15128','2013-11-29','11:00:00',1.19),('15128','2013-11-29','11:05:00',1.13),('15128','2013-11-29','11:10:00',1.2),('15128','2013-11-29','11:15:00',1.26),('15128','2013-11-29','11:20:00',1.34),('15128','2013-11-29','11:25:00',1.25),('15128','2013-11-29','11:30:00',1.29),('15128','2013-11-29','11:35:00',1.18),('15128','2013-11-29','11:50:00',1.01),('15128','2013-11-28','09:40:00',1.02),('15128','2013-11-28','09:45:00',1.11),('15128','2013-11-28','09:50:00',1.19),('15128','2013-11-28','09:55:00',1.26),('15128','2013-11-28','10:00:00',1.3),('15128','2013-11-28','10:05:00',1.35),('15128','2013-11-28','10:10:00',1.4),('15128','2013-11-28','10:15:00',1.44),('15128','2013-11-28','10:20:00',1.48),('15128','2013-11-28','10:25:00',1.55),('15128','2013-11-28','10:30:00',1.58),('15128','2013-11-28','10:35:00',1.62),('15128','2013-11-28','10:40:00',1.68),('15128','2013-11-28','10:45:00',1.72),('15128','2013-11-28','10:50:00',1.75),('15128','2013-11-28','10:55:00',1.81),('15128','2013-11-28','11:00:00',1.84),('15128','2013-11-28','11:05:00',1.9),('15128','2013-11-28','11:10:00',2.07),('15128','2013-11-28','11:15:00',2.13),('15128','2013-11-28','11:20:00',2.17),('15128','2013-11-28','11:25:00',2.22),('15128','2013-11-28','11:30:00',2.26),('15128','2013-11-28','11:35:00',2.28),('15128','2013-11-28','11:40:00',2.31),('15128','2013-11-28','11:45:00',2.35),('15128','2013-11-28','11:50:00',2.38),('15128','2013-11-28','11:55:00',2.4),('15128','2013-11-28','12:00:00',2.41),('15128','2013-11-28','12:05:00',2.42),('15128','2013-11-28','12:10:00',2.43),('15128','2013-11-28','12:15:00',2.44),('15128','2013-11-28','12:20:00',2.44),('15128','2013-11-28','12:25:00',2.46),('15128','2013-11-28','12:30:00',2.47),('15128','2013-11-28','12:35:00',2.46),('15128','2013-11-28','12:40:00',2.47),('15128','2013-11-28','12:45:00',2.47),('15128','2013-11-28','12:50:00',2.44),('15128','2013-11-28','12:55:00',2.42),('15128','2013-11-28','13:00:00',2.41),('15128','2013-11-28','13:05:00',2.4),('15128','2013-11-28','13:10:00',2.37),('15128','2013-11-28','13:15:00',2.35),('15128','2013-11-28','13:20:00',2.34),('15128','2013-11-28','13:25:00',2.31),('15128','2013-11-28','13:30:00',2.28),('15128','2013-11-28','13:35:00',2.24),('15128','2013-11-28','13:40:00',2.21),('15128','2013-11-28','13:45:00',2.19),('15128','2013-11-28','13:50:00',2.14),('15128','2013-11-28','13:55:00',2.1),('15128','2013-11-28','14:00:00',2.06),('15128','2013-11-28','14:05:00',2.01),('15128','2013-11-28','14:10:00',1.98),('15128','2013-11-28','14:15:00',1.95),('15128','2013-11-28','14:20:00',1.9),('15128','2013-11-28','14:25:00',1.82),('15128','2013-11-28','14:30:00',1.76),('15128','2013-11-28','14:35:00',1.73),('15128','2013-11-28','14:40:00',1.67),('15128','2013-11-28','14:45:00',1.56),('15128','2013-11-28','14:50:00',1.49),('15128','2013-11-28','14:55:00',1.39),('15128','2013-11-28','15:00:00',1.27),('15128','2013-11-28','15:05:00',1.2),('15128','2013-11-28','15:10:00',1.12),('15128','2013-11-28','15:15:00',1.01),('15128','2014-04-19','08:20:00',1.19),('15128','2014-04-19','08:25:00',1.67),('15128','2014-04-19','08:50:00',1.11),('15128','2014-04-19','08:55:00',1.35),('15128','2014-04-19','09:05:00',1.48),('15128','2014-04-19','09:10:00',1.54),('15128','2014-04-19','09:15:00',1.14),('15128','2014-04-19','09:20:00',1.78),('15128','2014-04-19','09:25:00',1.99),('15128','2014-04-19','09:30:00',2),('15128','2014-04-19','09:35:00',2.13),('15128','2014-04-19','09:40:00',2.48),('15128','2014-04-19','09:45:00',2.14),('15128','2014-04-19','09:50:00',1.66),('15128','2014-04-19','09:55:00',1.53),('15128','2014-04-19','10:00:00',1.71),('15128','2014-04-19','10:05:00',1.86),('15128','2014-04-19','10:10:00',2.25),('15128','2014-04-19','10:15:00',1.94),('15128','2014-04-19','10:20:00',1.65),('15128','2014-04-19','10:25:00',2.13),('15128','2014-04-19','10:30:00',1.94),('15128','2014-04-19','10:35:00',2),('15128','2014-04-19','10:40:00',1.91),('15128','2014-04-19','10:45:00',2.22),('15128','2014-04-19','10:50:00',2.31),('15128','2014-04-19','10:55:00',2.91),('15128','2014-04-19','11:00:00',2.71),('15128','2014-04-19','11:05:00',2.68),('15128','2014-04-19','11:10:00',2.7),('15128','2014-04-19','11:15:00',3.72),('15128','2014-04-19','11:20:00',3.56),('15128','2014-04-19','11:25:00',3.37),('15128','2014-04-19','11:30:00',3.37),('15128','2014-04-19','11:35:00',3.36),('15128','2014-04-19','11:40:00',3.44),('15128','2014-04-19','11:45:00',2.95),('15128','2014-04-19','11:50:00',3.61),('15128','2014-04-19','11:55:00',3.78),('15128','2014-04-19','12:00:00',3.8),('15128','2014-04-19','12:05:00',3.86),('15128','2014-04-19','12:10:00',3.88),('15128','2014-04-19','12:15:00',3.9),('15128','2014-04-19','12:20:00',3.93),('15128','2014-04-19','12:25:00',3.93),('15128','2014-04-19','12:30:00',3.93),('15128','2014-04-19','12:35:00',4),('15128','2014-04-19','12:40:00',3.96),('15128','2014-04-19','12:45:00',4),('15128','2014-04-19','12:50:00',4.07),('15128','2014-04-19','12:55:00',4.1),('15128','2014-04-19','13:00:00',4.1),('15128','2014-04-19','13:05:00',3.75),('15128','2014-04-19','13:10:00',2.43),('15128','2014-04-19','13:15:00',4.32),('15128','2014-04-19','13:20:00',4.27),('15128','2014-04-19','13:25:00',4.21),('15128','2014-04-19','13:30:00',4.16),('15128','2014-04-19','13:35:00',4.2),('15128','2014-04-19','13:40:00',4.18),('15128','2014-04-19','13:45:00',4.14),('15128','2014-04-19','13:50:00',4.14),('15128','2014-04-19','13:55:00',4.13),('15128','2014-04-19','14:00:00',4.13),('15128','2014-04-19','14:05:00',4.17),('15128','2014-04-19','14:10:00',3.95),('15128','2014-04-19','14:15:00',4.02),('15128','2014-04-19','14:20:00',3.46),('15128','2014-04-19','14:25:00',2.64),('15128','2014-04-19','14:30:00',2.64),('15128','2014-04-19','14:35:00',2.37),('15128','2014-04-19','14:40:00',2.23),('15128','2014-04-19','14:45:00',2.32),('15128','2014-04-19','14:50:00',2.65),('15128','2014-04-19','14:55:00',2.79),('15128','2014-04-19','15:00:00',4.24),('15128','2014-04-19','15:05:00',4.33),('15128','2014-04-19','15:10:00',4.01),('15128','2014-04-19','15:15:00',3.93),('15128','2014-04-19','15:20:00',3.91),('15128','2014-04-19','15:25:00',3.87),('15128','2014-04-19','15:30:00',3.6),('15128','2014-04-19','15:35:00',3.87),('15128','2014-04-19','15:40:00',3.81),('15128','2014-04-19','15:45:00',3.17),('15128','2014-04-19','15:50:00',3.31),('15128','2014-04-19','15:55:00',3.64),('15128','2014-04-19','16:00:00',3.58),('15128','2014-04-19','16:05:00',3.51),('15128','2014-04-19','16:10:00',3.47),('15128','2014-04-19','16:15:00',3.42),('15128','2014-04-19','16:20:00',3.41),('15128','2014-04-19','16:25:00',3.4),('15128','2014-04-19','16:30:00',3.25),('15128','2014-04-19','16:35:00',3.2),('15128','2014-04-19','16:40:00',3.12),('15128','2014-04-19','16:45:00',2.37),('15128','2014-04-19','16:50:00',3.11),('15128','2014-04-19','16:55:00',2.99),('15128','2014-04-19','17:00:00',2.86),('15128','2014-04-19','17:05:00',2.76),('15128','2014-04-19','17:10:00',2.67),('15128','2014-04-19','17:15:00',2.56),('15128','2014-04-19','17:20:00',2.39),('15128','2014-04-19','17:25:00',2.37),('15128','2014-04-19','17:30:00',2.28),('15128','2014-04-19','17:35:00',2.09),('15128','2014-04-19','17:40:00',1.95),('15128','2014-04-19','17:45:00',1.94),('15128','2014-04-19','17:50:00',1.79),('15128','2014-04-19','17:55:00',1.73),('15128','2014-04-19','18:00:00',1.65),('15128','2014-04-19','18:05:00',1.62),('15128','2014-04-19','18:10:00',1.55),('15128','2014-04-19','18:15:00',1.32),('15128','2014-04-19','18:20:00',1.26),('15128','2014-04-19','18:25:00',1.03),('15128','2014-04-19','18:30:00',1.22),('15128','2014-04-19','18:35:00',1.2),('15128','2014-04-19','18:40:00',1.03),('15128','2013-11-26','09:30:00',1.09),('15128','2013-11-26','09:40:00',1),('15128','2013-11-26','10:05:00',1),('15128','2013-11-26','10:10:00',1.13),('15128','2013-11-26','10:15:00',1.15),('15128','2013-11-26','10:20:00',1.22),('15128','2013-11-26','10:25:00',1.23),('15128','2013-11-26','10:30:00',1.35),('15128','2013-11-26','10:35:00',1.18),('15128','2013-11-26','10:40:00',1.14),('15128','2013-11-26','10:45:00',1.12),('15128','2013-11-26','10:50:00',1.2),('15128','2013-11-26','10:55:00',1.26),('15128','2013-11-26','11:00:00',1.29),('15128','2013-11-26','11:05:00',1.71),('15128','2013-11-26','11:10:00',1.48),('15128','2013-11-26','11:15:00',1.38),('15128','2013-11-26','11:20:00',1.91),('15128','2013-11-26','11:25:00',2.19),('15128','2013-11-26','11:30:00',2.01),('15128','2013-11-26','11:35:00',1.43),('15128','2013-11-26','11:40:00',1.53),('15128','2013-11-26','11:45:00',1.75),('15128','2013-11-26','11:50:00',2.54),('15128','2013-11-26','11:55:00',2.81),('15128','2013-11-26','12:00:00',1.51),('15128','2013-11-26','12:05:00',1.76),('15128','2013-11-26','12:10:00',1.78),('15128','2013-11-26','12:15:00',2.35),('15128','2013-11-26','12:20:00',2.17),('15128','2013-11-26','12:25:00',2.04),('15128','2013-11-26','12:30:00',1.91),('15128','2013-11-26','12:35:00',1.78),('15128','2013-11-26','12:40:00',1.69),('15128','2013-11-26','12:45:00',1.47),('15128','2013-11-26','13:10:00',1.05),('15128','2013-11-26','13:15:00',1.13),('15128','2013-11-26','13:20:00',1.07),('15128','2013-11-26','13:25:00',1.18),('15128','2013-11-26','13:30:00',1.07),('15128','2013-11-26','13:35:00',1.02),('15128','2013-11-25','09:50:00',1),('15128','2013-11-25','09:55:00',1.73),('15128','2013-11-25','10:20:00',1.03),('15128','2013-11-25','10:25:00',1.32),('15128','2013-11-25','10:30:00',1.98),('15128','2013-11-25','10:35:00',1.93),('15128','2013-11-25','10:40:00',2.02),('15128','2013-11-25','10:45:00',2.12),('15128','2013-11-25','10:50:00',2.06),('15128','2013-11-25','10:55:00',2.14),('15128','2013-11-25','11:00:00',2.35),('15128','2013-11-25','11:05:00',1.94),('15128','2013-11-25','11:10:00',1.29),('15128','2013-11-25','11:15:00',2.45),('15128','2013-11-25','11:20:00',2.76),('15128','2013-11-25','11:25:00',3.01),('15128','2013-11-25','11:30:00',1.62),('15128','2013-11-25','11:40:00',2.31),('15128','2013-11-25','11:45:00',3.09),('15128','2013-11-25','11:50:00',2.97),('15128','2013-11-25','11:55:00',2.58),('15128','2013-11-25','12:00:00',2.95),('15128','2013-11-25','12:05:00',2.07),('15128','2013-11-25','12:10:00',1.71),('15128','2013-11-25','12:15:00',2.65),('15128','2013-11-25','12:20:00',2.7),('15128','2013-11-25','12:25:00',2.43),('15128','2013-11-25','12:30:00',2.6),('15128','2013-11-25','12:35:00',2.78),('15128','2013-11-25','12:40:00',2.72),('15128','2013-11-25','12:45:00',2.72),('15128','2013-11-25','12:50:00',2.72),('15128','2013-11-25','12:55:00',2.7),('15128','2013-11-25','13:00:00',2.69),('15128','2013-11-25','13:05:00',2.67),('15128','2013-11-25','13:10:00',2.66),('15128','2013-11-25','13:15:00',2.64),('15128','2013-11-25','13:20:00',2.62),('15128','2013-11-25','13:25:00',2.6),('15128','2013-11-25','13:30:00',2.6),('15128','2013-11-25','13:35:00',2.56),('15128','2013-11-25','13:40:00',2.54),('15128','2013-11-25','13:45:00',2.43),('15128','2013-11-25','13:50:00',1.88),('15128','2013-11-25','13:55:00',1.64),('15128','2013-11-25','14:00:00',1.76),('15128','2013-11-25','14:05:00',2.65),('15128','2013-11-25','14:10:00',2.64),('15128','2013-11-25','14:15:00',2.75),('15128','2013-11-25','14:20:00',1.72),('15128','2013-11-25','14:25:00',1.6),('15128','2013-11-25','14:30:00',1.94),('15128','2013-11-25','14:35:00',2.2),('15128','2013-11-25','14:40:00',2.01),('15128','2013-11-25','14:45:00',1.48),('15128','2013-11-25','14:50:00',1.61),('15128','2013-11-25','14:55:00',1.75),('15128','2013-11-25','15:00:00',1.3),('15128','2013-11-25','15:05:00',1.44),('15128','2013-11-25','15:10:00',1.38),('15128','2013-11-25','15:15:00',1.25),('15128','2013-11-25','15:20:00',1.16),('15128','2013-11-25','15:25:00',1.06),('15128','2013-11-24','10:05:00',1.37),('15128','2013-11-24','10:10:00',1.67),('15128','2013-11-24','10:15:00',1.85),('15128','2013-11-24','10:20:00',1.15),('15128','2013-11-24','10:25:00',1.55),('15128','2013-11-24','10:30:00',1.57),('15128','2013-11-24','10:35:00',2.27),('15128','2013-11-24','10:40:00',2.08),('15128','2013-11-24','10:45:00',1.94),('15128','2013-11-24','10:50:00',1.98),('15128','2013-11-24','10:55:00',2.05),('15128','2013-11-24','11:00:00',2.18),('15128','2013-11-24','11:05:00',2.09),('15128','2013-11-24','11:20:00',1.96),('15128','2013-11-24','11:25:00',1.1),('15128','2013-11-24','11:30:00',1.26),('15128','2013-11-24','11:35:00',1.72),('15128','2013-11-24','11:40:00',2.27),('15128','2013-11-24','11:45:00',2.35),('15128','2013-11-24','11:50:00',1.77),('15128','2013-11-24','11:55:00',1.56),('15128','2013-11-24','12:00:00',1.22),('15128','2013-11-24','12:05:00',1.14),('15128','2013-11-24','12:10:00',1.26),('15128','2013-11-24','12:15:00',1.45),('15128','2013-11-24','12:20:00',1.37),('15128','2013-11-24','12:25:00',1.35),('15128','2013-11-24','12:30:00',1.11),('15128','2013-11-24','12:35:00',1),('15128','2013-11-24','12:40:00',1.5),('15128','2013-11-24','12:45:00',2.62),('15128','2013-11-24','12:50:00',2.67),('15128','2013-11-24','12:55:00',1.96),('15128','2013-11-24','13:00:00',1.47),('15128','2013-11-24','13:05:00',2.99),('15128','2013-11-24','13:10:00',3.26),('15128','2013-11-24','13:15:00',3.07),('15128','2013-11-24','13:20:00',2.72),('15128','2013-11-24','13:25:00',1.95),('15128','2013-11-24','13:30:00',1.24),('15128','2013-11-24','13:35:00',1.05),('15128','2013-11-24','13:40:00',1.21),('15128','2013-11-24','13:45:00',1.3),('15128','2013-11-24','13:50:00',1.24),('15128','2013-11-21','12:15:00',1.05),('15128','2013-11-21','12:20:00',1.23),('15128','2013-11-21','12:25:00',1.2),('15128','2013-11-20','09:50:00',1.5),('15128','2013-11-20','09:55:00',1.5),('15128','2013-11-20','10:00:00',1.54),('15128','2013-11-20','10:05:00',1.6),('15128','2013-11-20','10:10:00',1.44),('15128','2013-11-20','10:15:00',1.78),('15128','2013-11-20','10:20:00',2.29),('15128','2013-11-20','10:25:00',2.17),('15128','2013-11-20','10:30:00',1.49),('15128','2013-11-20','10:35:00',1.68),('15128','2013-11-20','10:40:00',1.97),('15128','2013-11-20','10:45:00',1.68),('15128','2013-11-20','10:50:00',1.82),('15128','2013-11-20','10:55:00',2.59),('15128','2013-11-20','11:00:00',2.01),('15128','2013-11-20','11:05:00',1.59),('15128','2013-11-20','11:10:00',2.22),('15128','2013-11-20','11:15:00',1.61),('15128','2013-11-20','11:20:00',2.02),('15128','2013-11-20','11:25:00',2.38),('15128','2013-11-20','11:30:00',2.46),('15128','2013-11-20','11:35:00',2.5),('15128','2013-11-20','11:40:00',2.52),('15128','2013-11-20','11:45:00',2.56),('15128','2013-11-20','11:50:00',2.58),('15128','2013-11-20','11:55:00',2.65),('15128','2013-11-20','12:00:00',2.79),('15128','2013-11-20','12:05:00',2.93),('15128','2013-11-20','12:10:00',3.04),('15128','2013-11-20','12:15:00',3.24),('15128','2013-11-20','12:20:00',2.99),('15128','2013-11-20','12:25:00',1.55),('15128','2013-11-20','12:55:00',2.57),('15128','2013-11-20','13:00:00',2.53),('15128','2013-11-20','13:05:00',2.42),('15128','2013-11-20','13:10:00',2.44),('15128','2013-11-20','13:15:00',2.12),('15128','2013-11-20','13:20:00',2),('15128','2013-11-20','13:25:00',2.21),('15128','2013-11-20','13:30:00',2.76),('15128','2013-11-20','13:35:00',2.56),('15128','2013-11-20','13:40:00',2.31),('15128','2013-11-20','13:45:00',2.23),('15128','2013-11-20','13:50:00',2.64),('15128','2013-11-20','13:55:00',1.74),('15128','2013-11-20','14:10:00',2.29),('15128','2013-11-20','14:15:00',1.3),('15128','2013-11-20','14:20:00',2.07),('15128','2013-11-20','14:25:00',2.06),('15128','2013-11-20','14:30:00',2.01),('15128','2013-11-20','14:35:00',1.92),('15128','2013-11-20','14:40:00',1.86),('15128','2013-11-20','14:45:00',1.8),('15128','2013-11-20','14:50:00',1.73),('15128','2013-11-20','14:55:00',1.61),('15128','2013-11-20','15:00:00',1.51),('15128','2013-11-20','15:05:00',1.39),('15128','2013-11-19','09:15:00',1.1),('15128','2013-11-19','09:20:00',1.16),('15128','2013-11-19','11:50:00',1.23),('15128','2013-11-19','11:55:00',1.3),('15128','2013-11-19','12:15:00',1.61),('15128','2013-11-19','12:20:00',1.73),('15128','2013-11-19','12:25:00',1.6),('15128','2013-11-19','12:30:00',1.15),('15128','2013-11-19','13:00:00',1.55),('15128','2013-11-19','13:05:00',1.03),('15128','2013-11-19','13:20:00',1.04),('15128','2013-11-19','13:25:00',1.39),('15128','2013-11-19','13:30:00',1.01),('15128','2013-11-19','13:35:00',1.07),('15128','2013-11-19','13:40:00',1.2),('15128','2013-11-19','13:45:00',1.47),('15128','2013-11-19','13:50:00',1.81),('15128','2013-11-19','13:55:00',1.03),('15128','2013-11-19','14:15:00',1.27),('15128','2013-11-19','14:25:00',1.08),('15128','2013-11-19','14:35:00',1.93),('15128','2013-11-19','14:40:00',1.45),('15128','2013-11-19','14:45:00',1.13),('15128','2013-11-19','14:50:00',1.82),('15128','2013-11-19','14:55:00',1.78),('15128','2013-11-19','15:00:00',1.36),('15128','2013-11-19','15:05:00',1.41),('15128','2013-11-19','15:10:00',1.37),('15128','2013-11-19','15:15:00',1.13),('15128','2013-11-19','15:20:00',1.05),('15128','2013-11-18','09:35:00',1.24),('15128','2013-11-18','09:40:00',1.36),('15128','2013-11-18','09:45:00',1.44),('15128','2013-11-18','09:50:00',1.46),('15128','2013-11-18','09:55:00',1.46),('15128','2013-11-18','10:00:00',1.7),('15128','2013-11-18','10:05:00',1.81),('15128','2013-11-18','10:10:00',1.84),('15128','2013-11-18','10:15:00',1.66),('15128','2013-11-18','11:15:00',1.48),('15128','2013-11-18','11:20:00',1.11),('15128','2013-11-18','11:25:00',1.29),('15128','2013-11-18','11:30:00',2.34),('15128','2013-11-18','11:35:00',2.3),('15128','2013-11-18','11:40:00',2.33),('15128','2013-11-18','11:45:00',1.84),('15128','2013-11-18','11:50:00',2.17),('15128','2013-11-18','11:55:00',2.4),('15128','2013-11-18','12:00:00',2.4),('15128','2013-11-18','12:05:00',2.41),('15128','2013-11-18','12:10:00',2.26),('15128','2013-11-18','12:15:00',2.47),('15128','2013-11-18','12:20:00',2.3),('15128','2013-11-18','12:25:00',1.78),('15128','2013-11-18','12:30:00',1.87),('15128','2013-11-18','12:35:00',2.45),('15128','2013-11-18','12:40:00',1.33),('15128','2013-11-18','12:45:00',1.64),('15128','2013-11-18','12:50:00',1.78),('15128','2013-11-18','13:15:00',1.89),('15128','2013-11-18','13:20:00',1.6),('15128','2013-11-18','13:30:00',1.3),('15128','2013-11-18','15:20:00',1.11),('15128','2013-11-18','15:25:00',1.44),('15128','2013-11-18','15:30:00',1.53),('15128','2013-11-18','15:35:00',1.12),('15128','2013-11-17','09:20:00',1.09),('15128','2013-11-17','09:25:00',1.14),('15128','2013-11-17','09:30:00',1.29),('15128','2013-11-17','09:35:00',1.39),('15128','2013-11-17','09:40:00',1.11),('15128','2013-11-17','10:00:00',1.05),('15128','2013-11-17','10:05:00',1.26),('15128','2013-11-17','10:10:00',1.37),('15128','2013-11-17','10:15:00',1.53),('15128','2013-11-17','10:20:00',1.42),('15128','2013-11-17','10:25:00',1.15),('15128','2013-11-17','10:30:00',1.07),('15128','2013-11-17','10:35:00',1.13),('15128','2013-11-17','10:40:00',1.26),('15128','2013-11-17','10:45:00',1.4),('15128','2013-11-17','10:50:00',1.29),('15128','2013-11-17','10:55:00',1.09),('15128','2013-11-17','11:25:00',1.08),('15128','2013-11-17','11:30:00',1.16),('15128','2013-11-17','11:35:00',1.21),('15128','2013-11-17','11:40:00',1.22),('15128','2013-11-17','11:45:00',1.23),('15128','2013-11-17','11:50:00',1.31),('15128','2013-11-17','11:55:00',1.37),('15128','2013-11-17','12:00:00',1.46),('15128','2013-11-17','12:05:00',1.42),('15128','2013-11-17','12:10:00',1.39),('15128','2013-11-17','12:15:00',1.42),('15128','2013-11-17','12:20:00',1.58),('15128','2013-11-17','12:25:00',1.93),('15128','2013-11-17','12:30:00',1.94),('15128','2013-11-17','12:35:00',1.57),('15128','2013-11-17','12:40:00',1.32),('15128','2013-11-17','12:45:00',1.1),('15128','2013-11-17','13:10:00',1.06),('15128','2013-11-17','13:15:00',1.03),('15128','2013-11-17','13:20:00',1),('15128','2013-11-17','13:35:00',1),('15128','2013-11-17','13:40:00',1.1),('15128','2013-11-17','13:45:00',1.19),('15128','2013-11-17','13:50:00',1.14),('15128','2014-04-18','08:15:00',1.09),('15128','2014-04-18','08:20:00',1.11),('15128','2014-04-18','08:25:00',1.05),('15128','2014-04-18','08:40:00',1.03),('15128','2014-04-18','09:20:00',1.09),('15128','2014-04-18','09:25:00',1.43),('15128','2014-04-18','09:30:00',1.09),('15128','2014-04-18','10:35:00',1.53),('15128','2014-04-18','10:40:00',1.69),('15128','2014-04-18','10:45:00',1.62),('15128','2014-04-18','10:50:00',1.83),('15128','2014-04-18','10:55:00',1.46),('15128','2014-04-18','11:00:00',1.07),('15128','2014-04-18','11:05:00',1.66),('15128','2014-04-18','11:10:00',2.43),('15128','2014-04-18','11:15:00',2.6),('15128','2014-04-18','11:20:00',3),('15128','2014-04-18','11:25:00',3.41),('15128','2014-04-18','11:30:00',3.18),('15128','2014-04-18','11:35:00',2.41),('15128','2014-04-18','11:40:00',2.06),('15128','2014-04-18','11:45:00',1.5),('15128','2014-04-18','11:50:00',1.12),('15128','2014-04-18','14:35:00',1.12),('15128','2014-04-18','14:40:00',1.33),('15128','2014-04-18','14:45:00',1.01),('15128','2014-04-18','15:00:00',1.28),('15128','2014-04-18','15:05:00',1.26),('15128','2014-04-18','15:25:00',1.14),('15128','2014-04-18','15:40:00',1.83),('15128','2014-04-18','15:45:00',4.11),('15128','2014-04-18','15:50:00',3.41),('15128','2014-04-18','15:55:00',2.42),('15128','2014-04-18','16:00:00',1.25),('15128','2014-04-18','16:05:00',1.42),('15128','2014-04-18','16:10:00',1.3),('15128','2014-04-18','16:15:00',2.27),('15128','2014-04-18','16:20:00',2.31),('15128','2014-04-18','16:25:00',2.56),('15128','2014-04-18','16:30:00',1.73),('15128','2014-04-18','16:35:00',1.33),('15128','2014-04-18','16:40:00',1.58),('15128','2014-04-18','17:00:00',1.35),('15128','2014-04-18','17:05:00',1.34),('15128','2014-04-18','17:10:00',1.07),('15128','2014-04-18','17:15:00',1.37),('15128','2014-04-18','17:20:00',1.3),('15128','2013-11-16','09:15:00',1.06),('15128','2013-11-16','09:20:00',1.03),('15128','2013-11-16','09:25:00',1.09),('15128','2013-11-16','09:30:00',1.17),('15128','2013-11-16','09:35:00',1.14),('15128','2013-11-16','09:40:00',1.19),('15128','2013-11-16','09:45:00',1.34),('15128','2013-11-16','09:50:00',1.34),('15128','2013-11-16','09:55:00',1.4),('15128','2013-11-16','10:00:00',1.45),('15128','2013-11-16','10:05:00',1.49),('15128','2013-11-16','10:10:00',1.53),('15128','2013-11-16','10:15:00',1.58),('15128','2013-11-16','10:20:00',1.63),('15128','2013-11-16','10:25:00',1.65),('15128','2013-11-16','10:30:00',1.72),('15128','2013-11-16','10:35:00',1.75),('15128','2013-11-16','10:40:00',1.79),('15128','2013-11-16','10:45:00',1.83),('15128','2013-11-16','10:50:00',1.86),('15128','2013-11-16','10:55:00',1.95),('15128','2013-11-16','11:00:00',2.07),('15128','2013-11-16','11:05:00',2.14),('15128','2013-11-16','11:10:00',2.2),('15128','2013-11-16','11:15:00',2.24),('15128','2013-11-16','11:20:00',2.28),('15128','2013-11-16','11:25:00',2.3),('15128','2013-11-16','11:30:00',2.33),('15128','2013-11-16','11:35:00',2.39),('15128','2013-11-16','11:40:00',2.42),('15128','2013-11-16','11:45:00',2.45),('15128','2013-11-16','11:50:00',2.47),('15128','2013-11-16','11:55:00',2.48),('15128','2013-11-16','12:00:00',2.49),('15128','2013-11-16','12:05:00',2.5),('15128','2013-11-16','12:10:00',2.52),('15128','2013-11-16','12:15:00',2.54),('15128','2013-11-16','12:20:00',2.59),('15128','2013-11-16','12:25:00',2.56),('15128','2013-11-16','12:30:00',2.53),('15128','2013-11-16','12:35:00',2.52),('15128','2013-11-16','12:40:00',2.52),('15128','2013-11-16','12:45:00',2.5),('15128','2013-11-16','12:50:00',2.49),('15128','2013-11-16','12:55:00',2.48),('15128','2013-11-16','13:00:00',2.47),('15128','2013-11-16','13:05:00',2.48),('15128','2013-11-16','13:10:00',2.45),('15128','2013-11-16','13:15:00',2.42),('15128','2013-11-16','13:20:00',2.44),('15128','2013-11-16','13:25:00',2.44),('15128','2013-11-16','13:30:00',2.45),('15128','2013-11-16','13:35:00',2.41),('15128','2013-11-16','13:40:00',2.32),('15128','2013-11-16','13:45:00',2.27),('15128','2013-11-16','13:50:00',2.18),('15128','2013-11-16','13:55:00',2.19),('15128','2013-11-16','14:00:00',2.07),('15128','2013-11-16','14:10:00',1.13),('15128','2013-11-16','14:15:00',1.92),('15128','2013-11-16','14:20:00',1.91),('15128','2013-11-16','14:25:00',1.83),('15128','2013-11-16','14:30:00',1.47),('15128','2013-11-16','14:40:00',1.16),('15128','2013-11-16','14:50:00',1.68),('15128','2013-11-16','14:55:00',1.37),('15128','2013-11-16','15:00:00',1.35),('15128','2013-11-16','15:05:00',1.52),('15128','2013-11-16','15:10:00',1.29),('15128','2013-11-16','15:15:00',1.16),('15128','2013-11-16','15:20:00',1.1),('15128','2013-11-16','15:25:00',1.07),('15128','2013-11-15','12:55:00',1.43),('15128','2013-11-15','13:00:00',1.43),('15128','2013-11-15','13:05:00',1.44),('15128','2013-11-15','13:10:00',1.12),('15128','2013-11-15','13:15:00',1.05),('15128','2013-11-14','09:20:00',1.12),('15128','2013-11-14','09:50:00',1.56),('15128','2013-11-14','09:55:00',1.35),('15128','2013-11-14','10:00:00',1.11),('15128','2013-11-14','10:05:00',1.11),('15128','2013-11-14','10:10:00',1.17),('15128','2013-11-14','10:15:00',1.24),('15128','2013-11-14','10:20:00',1.24),('15128','2013-11-14','10:25:00',1.24),('15128','2013-11-14','10:30:00',1.35),('15128','2013-11-14','10:35:00',1.46),('15128','2013-11-14','10:40:00',1.11),('15128','2013-11-14','11:00:00',1.03),('15128','2013-11-14','11:05:00',1.26),('15128','2013-11-14','11:10:00',1.51),('15128','2013-11-14','11:15:00',1.68),('15128','2013-11-14','11:20:00',1.31),('15128','2013-11-14','11:25:00',1.11),('15128','2013-11-14','11:30:00',1.12),('15128','2013-11-14','11:35:00',1.78),('15128','2013-11-14','11:40:00',1.67),('15128','2013-11-14','11:45:00',1.49),('15128','2013-11-14','11:50:00',1.63),('15128','2013-11-14','11:55:00',1.47),('15128','2013-11-14','12:00:00',1.3),('15128','2013-11-14','12:05:00',1.1),('15128','2013-11-14','13:00:00',1.01),('15128','2013-11-14','13:10:00',1.01),('15128','2013-11-14','13:15:00',1.02),('15128','2013-11-13','09:20:00',1.12),('15128','2013-11-13','09:25:00',1.15),('15128','2013-11-13','09:30:00',1.24),('15128','2013-11-13','09:35:00',1.31),('15128','2013-11-13','09:40:00',1.36),('15128','2013-11-13','09:45:00',1.42),('15128','2013-11-13','09:50:00',1.47),('15128','2013-11-13','09:55:00',1.51),('15128','2013-11-13','10:00:00',1.54),('15128','2013-11-13','10:05:00',1.55),('15128','2013-11-13','10:10:00',1.54),('15128','2013-11-13','10:15:00',1.6),('15128','2013-11-13','10:20:00',1.56),('15128','2013-11-13','10:25:00',1.58),('15128','2013-11-13','10:30:00',1.7),('15128','2013-11-13','10:35:00',1.83),('15128','2013-11-13','10:40:00',1.91),('15128','2013-11-13','10:45:00',1.99),('15128','2013-11-13','10:50:00',2.08),('15128','2013-11-13','10:55:00',2.2),('15128','2013-11-13','11:00:00',2.35),('15128','2013-11-13','11:05:00',2.51),('15128','2013-11-13','11:10:00',2.41),('15128','2013-11-13','11:15:00',1.92),('15128','2013-11-13','11:20:00',2.57),('15128','2013-11-13','11:25:00',2.75),('15128','2013-11-13','11:30:00',2.54),('15128','2013-11-13','11:35:00',2.32),('15128','2013-11-13','11:40:00',2.24),('15128','2013-11-13','11:45:00',2.3),('15128','2013-11-13','11:50:00',1.19),('15128','2013-11-13','11:55:00',1.15),('15128','2013-11-13','12:00:00',1.12),('15128','2013-11-13','12:05:00',1.1),('15128','2013-11-13','12:10:00',1.1),('15128','2013-11-13','12:15:00',1.07),('15128','2013-11-13','12:20:00',1.19),('15128','2013-11-13','12:25:00',1.46),('15128','2013-11-13','12:30:00',2.03),('15128','2013-11-13','12:35:00',2.1),('15128','2013-11-13','12:40:00',1.64),('15128','2013-11-13','12:45:00',1.97),('15128','2013-11-13','12:50:00',1.65),('15128','2013-11-13','12:55:00',1.7),('15128','2013-11-13','13:00:00',1.57),('15128','2013-11-13','13:05:00',1.1),('15128','2013-11-13','13:10:00',1.18),('15128','2013-11-13','13:15:00',1.46),('15128','2013-11-13','13:20:00',2.51),('15128','2013-11-13','13:25:00',3.12),('15128','2013-11-13','13:30:00',2.85),('15128','2013-11-13','13:35:00',2.34),('15128','2013-11-13','13:40:00',2.63),('15128','2013-11-13','13:45:00',2.85),('15128','2013-11-13','13:50:00',2.65),('15128','2013-11-13','13:55:00',2),('15128','2013-11-13','14:00:00',1.17),('15128','2013-11-13','14:05:00',2.43),('15128','2013-11-13','14:10:00',1.05),('15128','2013-11-12','10:10:00',1.2),('15128','2013-11-12','10:15:00',1),('15128','2013-11-12','10:20:00',1.03),('15128','2013-11-12','10:25:00',1.13),('15128','2013-11-12','10:35:00',1.02),('15128','2013-11-12','10:40:00',1.12),('15128','2013-11-12','10:45:00',1.1),('15128','2013-11-12','10:50:00',1.2),('15128','2013-11-12','10:55:00',1.14),('15128','2013-11-12','11:00:00',1.03),('15128','2013-11-12','11:05:00',1.01),('15128','2013-11-12','11:10:00',1.96),('15128','2013-11-12','11:15:00',2.1),('15128','2013-11-12','11:20:00',2.86),('15128','2013-11-12','11:25:00',3.33),('15128','2013-11-12','11:30:00',2.28),('15128','2013-11-12','11:55:00',1.18),('15128','2013-11-12','12:00:00',2.63),('15128','2013-11-12','12:05:00',1.84),('15128','2013-11-12','12:10:00',1.2),('15128','2013-11-12','12:15:00',1.03),('15128','2013-11-12','12:20:00',1.01),('15128','2013-11-12','12:50:00',1.1),('15128','2013-11-12','12:55:00',1.15),('15128','2013-11-12','13:00:00',1.14),('15128','2013-11-12','13:05:00',1.18),('15128','2013-11-12','13:10:00',1.29),('15128','2013-11-12','13:15:00',1.34),('15128','2013-11-12','13:20:00',1.5),('15128','2013-11-12','13:25:00',1.39),('15128','2013-11-12','13:30:00',1.13),('15128','2013-11-12','13:45:00',1.24),('15128','2013-11-12','13:50:00',1.25),('15128','2013-11-12','13:55:00',1.36),('15128','2013-11-12','14:00:00',1.73),('15128','2013-11-12','14:05:00',2),('15128','2013-11-12','14:10:00',2.14),('15128','2013-11-12','14:15:00',1.91),('15128','2013-11-12','14:20:00',1.7),('15128','2013-11-12','14:25:00',1.71),('15128','2013-11-12','14:30:00',1.81),('15128','2013-11-12','14:35:00',1.3),('15128','2013-11-11','11:40:00',2.35),('15128','2013-11-11','11:45:00',1.3),('15128','2013-11-11','12:00:00',1.89),('15128','2013-11-11','12:05:00',1.98),('15128','2013-11-11','12:10:00',1.07),('15128','2013-11-11','12:35:00',3.45),('15128','2013-11-11','12:40:00',3.05),('15128','2013-11-11','12:45:00',3.03),('15128','2013-11-11','12:50:00',1.88),('15128','2013-11-11','12:55:00',1.46),('15128','2013-11-11','13:00:00',1.79),('15128','2013-11-11','13:05:00',1.71),('15128','2013-11-11','13:10:00',1.59),('15128','2013-11-11','13:15:00',1.82),('15128','2013-11-11','13:20:00',1.85),('15128','2013-11-11','13:25:00',1.68),('15128','2013-11-11','13:30:00',1.68),('15128','2013-11-11','13:35:00',1.99),('15128','2013-11-11','13:40:00',2.86),('15128','2013-11-11','13:45:00',2.93),('15128','2013-11-11','13:50:00',3.09),('15128','2013-11-11','13:55:00',3.34),('15128','2013-11-11','14:00:00',1.73),('15128','2013-11-11','14:05:00',1.46),('15128','2013-11-11','14:10:00',1.5),('15128','2013-11-11','14:15:00',1.97),('15128','2013-11-11','14:20:00',2.66),('15128','2013-11-11','14:25:00',1.97),('15128','2013-11-11','14:35:00',1.03),('15128','2013-11-11','14:40:00',1.51),('15128','2013-11-11','14:45:00',1.66),('15128','2013-11-11','14:50:00',1.83),('15128','2013-11-11','14:55:00',1.79),('15128','2013-11-11','15:00:00',1.55),('15128','2013-11-11','15:05:00',1.48),('15128','2013-11-11','15:10:00',1.25),('15128','2013-11-11','15:25:00',1.16),('15128','2013-11-10','10:40:00',1.08),('15128','2013-11-10','10:45:00',1.06),('15128','2013-11-10','10:55:00',1.04),('15128','2013-11-10','11:00:00',1.21),('15128','2013-11-10','11:15:00',2.01),('15128','2013-11-10','11:20:00',3.41),('15128','2013-11-10','11:25:00',3.47),('15128','2013-11-10','11:30:00',2.58),('15128','2013-11-10','11:45:00',1.62),('15128','2013-11-10','11:50:00',1.99),('15128','2013-11-10','12:00:00',1.1),('15128','2013-11-10','12:05:00',1.81),('15128','2013-11-10','12:10:00',2.46),('15128','2013-11-10','12:15:00',2.73),('15128','2013-11-10','12:20:00',3.46),('15128','2013-11-10','12:25:00',3.01),('15128','2013-11-10','12:30:00',3.22),('15128','2013-11-10','12:35:00',2.85),('15128','2013-11-10','12:40:00',2.04),('15128','2013-11-10','12:45:00',1.17),('15128','2013-11-10','12:50:00',1.24),('15128','2013-11-10','12:55:00',1.15),('15128','2013-11-10','13:00:00',2.92),('15128','2013-11-10','13:05:00',2.8),('15128','2013-11-10','13:10:00',2.34),('15128','2013-11-10','13:15:00',2.79),('15128','2013-11-10','13:20:00',2.84),('15128','2013-11-10','13:25:00',2.58),('15128','2013-11-10','13:50:00',1.29),('15128','2013-11-10','13:55:00',2.23),('15128','2013-11-10','14:10:00',2.49),('15128','2013-11-10','14:15:00',2.71),('15128','2013-11-10','14:20:00',2.51),('15128','2013-11-10','14:25:00',2.34),('15128','2013-11-10','14:30:00',2.26),('15128','2013-11-10','14:35:00',2.15),('15128','2013-11-10','14:40:00',2.12),('15128','2013-11-10','14:45:00',2.07),('15128','2013-11-10','14:50:00',1.41),('15128','2013-11-10','14:55:00',1.76),('15128','2013-11-10','15:00:00',1.19),('15128','2013-11-09','08:55:00',1.02),('15128','2013-11-09','09:00:00',1.01),('15128','2013-11-09','09:10:00',1.13),('15128','2013-11-09','09:15:00',1.34),('15128','2013-11-09','09:20:00',1.43),('15128','2013-11-09','09:25:00',1.14),('15128','2013-11-09','09:35:00',1.39),('15128','2013-11-09','09:40:00',1.45),('15128','2013-11-09','09:45:00',1.6),('15128','2013-11-09','09:50:00',1.62),('15128','2013-11-09','09:55:00',1.58),('15128','2013-11-09','10:00:00',1.7),('15128','2013-11-09','10:05:00',1.86),('15128','2013-11-09','10:10:00',1.5),('15128','2013-11-09','10:15:00',1.15),('15128','2013-11-09','10:20:00',1.44),('15128','2013-11-09','10:25:00',1.58),('15128','2013-11-09','10:30:00',1.64),('15128','2013-11-09','10:35:00',1.85),('15128','2013-11-09','10:40:00',1.95),('15128','2013-11-09','10:45:00',1.26),('15128','2013-11-09','10:50:00',1.89),('15128','2013-11-09','10:55:00',1.32),('15128','2013-11-09','11:15:00',1.99),('15128','2013-11-09','11:20:00',1.25),('15128','2013-11-09','11:25:00',1.62),('15128','2013-11-09','11:30:00',1.57),('15128','2013-11-09','11:35:00',2.05),('15128','2013-11-09','11:40:00',1.72),('15128','2013-11-09','11:45:00',1.87),('15128','2013-11-09','11:50:00',1.29),('15128','2013-11-09','11:55:00',2.92),('15128','2013-11-09','12:00:00',1.4),('15128','2013-11-09','12:05:00',2.76),('15128','2013-11-09','12:10:00',2.88),('15128','2013-11-09','12:20:00',2.86),('15128','2013-11-09','12:25:00',1.49),('15128','2013-11-09','12:30:00',2.75),('15128','2013-11-09','12:35:00',2.9),('15128','2013-11-09','12:40:00',1.56),('15128','2013-11-09','12:45:00',1.02),('15128','2013-11-09','12:50:00',1.42),('15128','2013-11-09','12:55:00',1.7),('15128','2013-11-09','13:00:00',1.28),('15128','2013-11-09','13:05:00',2.19),('15128','2013-11-09','13:10:00',1.95),('15128','2013-11-09','13:25:00',2.46),('15128','2013-11-09','13:30:00',3.09),('15128','2013-11-09','13:35:00',1.82),('15128','2013-11-09','13:40:00',1.28),('15128','2013-11-08','09:30:00',1.07),('15128','2013-11-08','09:35:00',1.18),('15128','2013-11-08','09:40:00',1.6),('15128','2013-11-08','09:45:00',1.92),('15128','2013-11-08','09:50:00',1.97),('15128','2013-11-08','09:55:00',1.79),('15128','2013-11-08','10:00:00',1.36),('15128','2013-11-08','10:10:00',1),('15128','2013-11-08','10:15:00',1.09),('15128','2013-11-08','10:20:00',1.99),('15128','2013-11-08','10:25:00',1.62),('15128','2013-11-08','10:35:00',1.87),('15128','2013-11-08','10:40:00',1.97),('15128','2013-11-08','10:45:00',1.28),('15128','2013-11-08','10:55:00',1.8),('15128','2013-11-08','11:00:00',3.25),('15128','2013-11-08','11:05:00',1.71),('15128','2013-11-08','11:10:00',1.19),('15128','2013-11-08','11:15:00',1.01),('15128','2013-11-08','11:20:00',1.38),('15128','2013-11-08','11:25:00',2.44),('15128','2013-11-08','11:30:00',1.7),('15128','2013-11-08','11:35:00',2.88),('15128','2013-11-08','11:40:00',2.93),('15128','2013-11-08','11:45:00',3.35),('15128','2013-11-08','11:50:00',2.1),('15128','2013-11-08','11:55:00',1.98),('15128','2013-11-08','12:00:00',2.57),('15128','2013-11-08','12:05:00',2.13),('15128','2013-11-08','12:10:00',1.21),('15128','2013-11-08','12:15:00',1.02),('15128','2013-11-08','12:30:00',1.07),('15128','2013-11-08','12:35:00',1.19),('15128','2013-11-08','12:40:00',1.25),('15128','2013-11-08','12:45:00',1.13),('15128','2013-11-08','12:50:00',1.32),('15128','2013-11-08','12:55:00',2.31),('15128','2013-11-08','13:00:00',2.31),('15128','2013-11-08','13:05:00',2.34),('15128','2013-11-08','13:10:00',1.99),('15128','2013-11-08','13:15:00',1.65),('15128','2013-11-08','13:20:00',2.67),('15128','2013-11-08','13:25:00',2.86),('15128','2013-11-08','13:30:00',2.14),('15128','2013-11-08','13:35:00',1.74),('15128','2013-11-08','13:40:00',3.07),('15128','2013-11-08','13:45:00',2.59),('15128','2013-11-08','13:50:00',1.59),('15128','2013-11-08','13:55:00',2.36),('15128','2013-11-08','14:00:00',1.17),('15128','2013-11-08','14:15:00',2.02),('15128','2013-11-08','14:20:00',1.96),('15128','2013-11-08','14:25:00',1.76),('15128','2013-11-08','14:30:00',2.21),('15128','2013-11-08','14:35:00',2.13),('15128','2013-11-08','14:40:00',1.87),('15128','2013-11-08','14:45:00',1.63),('15128','2013-11-08','15:20:00',1.08),('15128','2013-11-08','15:25:00',1.39),('15128','2013-11-07','09:15:00',1.05),('15128','2013-11-07','09:25:00',1.22),('15128','2013-11-07','09:30:00',1.15),('15128','2013-11-07','09:35:00',1.59),('15128','2013-11-07','09:40:00',1.33),('15128','2013-11-07','09:45:00',1.27),('15128','2013-11-07','09:50:00',1.59),('15128','2013-11-07','09:55:00',1.33),('15128','2013-11-07','10:00:00',1.36),('15128','2013-11-07','10:05:00',2.06),('15128','2013-11-07','10:10:00',2.14),('15128','2013-11-07','10:15:00',2.09),('15128','2013-11-07','10:20:00',1.3),('15128','2013-11-07','10:30:00',1.16),('15128','2013-11-07','10:35:00',1.19),('15128','2013-11-07','10:40:00',2.33),('15128','2013-11-07','10:45:00',2.62),('15128','2013-11-07','10:50:00',2.52),('15128','2013-11-07','10:55:00',2.38),('15128','2013-11-07','11:00:00',1.59),('15128','2013-11-07','11:15:00',3.02),('15128','2013-11-07','11:20:00',2.88),('15128','2013-11-07','11:25:00',3.16),('15128','2013-11-07','11:30:00',3.01),('15128','2013-11-07','11:35:00',3.07),('15128','2013-11-07','11:40:00',2.32),('15128','2013-11-07','11:45:00',2.42),('15128','2013-11-07','11:50:00',2.46),('15128','2013-11-07','11:55:00',2.87),('15128','2013-11-07','12:00:00',2.84),('15128','2013-11-07','12:05:00',2.73),('15128','2013-11-07','12:10:00',2.73),('15128','2013-11-07','12:15:00',2.81),('15128','2013-11-07','12:20:00',2.95),('15128','2013-11-07','12:25:00',3.07),('15128','2013-11-07','12:30:00',3.02),('15128','2013-11-07','12:35:00',2.83),('15128','2013-11-07','12:40:00',2.85),('15128','2013-11-07','12:45:00',2.86),('15128','2013-11-07','12:50:00',2.85),('15128','2013-11-07','12:55:00',2.81),('15128','2013-11-07','13:00:00',2.85),('15128','2013-11-07','13:05:00',2.66),('15128','2013-11-07','13:10:00',1.29),('15128','2013-11-07','13:15:00',1.33),('15128','2013-11-07','13:20:00',2.77),('15128','2013-11-07','13:25:00',2.93),('15128','2013-11-07','13:30:00',2.82),('15128','2013-11-07','13:35:00',2.71),('15128','2013-11-07','13:40:00',2.17),('15128','2013-11-07','13:45:00',1.17),('15128','2013-11-07','13:50:00',2.4),('15128','2013-11-07','13:55:00',2.42),('15128','2013-11-07','14:00:00',2.35),('15128','2013-11-07','14:05:00',2.24),('15128','2013-11-07','14:10:00',2.15),('15128','2013-11-07','14:15:00',2.56),('15128','2013-11-07','14:20:00',1.55),('15128','2013-11-07','14:25:00',2.08),('15128','2013-11-07','14:30:00',2.23),('15128','2013-11-07','14:35:00',2.08),('15128','2013-11-07','14:40:00',2.01),('15128','2013-11-07','14:45:00',1.98),('15128','2013-11-07','14:50:00',1.43),('15128','2013-11-07','14:55:00',1.51),('15128','2013-11-07','15:00:00',1.76),('15128','2013-11-07','15:10:00',1.24),('15128','2013-11-07','15:15:00',1.46),('15128','2013-11-07','15:20:00',1.46),('15128','2013-11-07','15:25:00',1.42),('15128','2013-11-07','15:30:00',1.29),('15128','2013-11-07','15:35:00',1.08),('15128','2014-04-17','08:45:00',1.61),('15128','2014-04-17','08:50:00',1.2),('15128','2014-04-17','09:05:00',1.04),('15128','2014-04-17','09:10:00',2.06),('15128','2014-04-17','09:15:00',1.85),('15128','2014-04-17','09:20:00',1.92),('15128','2014-04-17','09:25:00',1.65),('15128','2014-04-17','09:30:00',1.88),('15128','2014-04-17','09:35:00',1.15),('15128','2014-04-17','09:40:00',1.81),('15128','2014-04-17','09:45:00',1.82),('15128','2014-04-17','09:50:00',1.79),('15128','2014-04-17','09:55:00',1.55),('15128','2014-04-17','10:00:00',1.44),('15128','2014-04-17','10:05:00',1.35),('15128','2014-04-17','10:10:00',1.41),('15128','2014-04-17','10:15:00',1.28),('15128','2014-04-17','10:20:00',1.57),('15128','2014-04-17','10:25:00',1.41),('15128','2014-04-17','10:30:00',1.32),('15128','2014-04-17','10:35:00',1.5),('15128','2014-04-17','10:40:00',2.28),('15128','2014-04-17','10:45:00',2.13),('15128','2014-04-17','10:50:00',2.78),('15128','2014-04-17','10:55:00',2.52),('15128','2014-04-17','11:00:00',2.35),('15128','2014-04-17','11:05:00',2.22),('15128','2014-04-17','11:10:00',1.94),('15128','2014-04-17','11:15:00',2.39),('15128','2014-04-17','11:20:00',1.77),('15128','2014-04-17','11:25:00',2.27),('15128','2014-04-17','11:30:00',2.72),('15128','2014-04-17','11:35:00',2.41),('15128','2014-04-17','11:40:00',2.75),('15128','2014-04-17','11:45:00',2.64),('15128','2014-04-17','11:50:00',2.44),('15128','2014-04-17','11:55:00',1.88),('15128','2014-04-17','12:00:00',1.96),('15128','2014-04-17','12:05:00',3.4),('15128','2014-04-17','12:10:00',4.51),('15128','2014-04-17','12:15:00',4.02),('15128','2014-04-17','12:20:00',4.17),('15128','2014-04-17','12:25:00',2.88),('15128','2014-04-17','12:30:00',4.13),('15128','2014-04-17','12:35:00',4.23),('15128','2014-04-17','12:40:00',3.66),('15128','2014-04-17','12:45:00',4.12),('15128','2014-04-17','12:50:00',2.89),('15128','2014-04-17','12:55:00',3.41),('15128','2014-04-17','13:00:00',2.59),('15128','2014-04-17','13:05:00',2.9),('15128','2014-04-17','13:10:00',2.77),('15128','2014-04-17','13:15:00',2.49),('15128','2014-04-17','13:20:00',2.15),('15128','2014-04-17','13:25:00',1.84),('15128','2014-04-17','13:30:00',1.29),('15128','2014-04-17','13:35:00',1.43),('15128','2014-04-17','13:40:00',1.52),('15128','2014-04-17','13:45:00',1.45),('15128','2014-04-17','13:50:00',1.27),('15128','2014-04-17','13:55:00',1.43),('15128','2014-04-17','14:00:00',1.53),('15128','2014-04-17','14:05:00',1.5),('15128','2014-04-17','14:10:00',1.63),('15128','2014-04-17','14:15:00',1.96),('15128','2014-04-17','14:20:00',1.81),('15128','2014-04-17','14:25:00',2),('15128','2014-04-17','14:30:00',2.3),('15128','2014-04-17','14:35:00',2.19),('15128','2014-04-17','14:40:00',2.71),('15128','2014-04-17','14:45:00',3.37),('15128','2014-04-17','14:50:00',3.73),('15128','2014-04-17','14:55:00',4.71),('15128','2014-04-17','15:00:00',4.17),('15128','2014-04-17','15:05:00',4.27),('15128','2014-04-17','15:10:00',3.96),('15128','2014-04-17','15:15:00',4.51),('15128','2014-04-17','15:20:00',4.21),('15128','2014-04-17','15:25:00',2.39),('15128','2014-04-17','15:30:00',4.2),('15128','2014-04-17','15:35:00',2.43),('15128','2014-04-17','15:40:00',3.59),('15128','2014-04-17','15:45:00',4.18),('15128','2014-04-17','15:50:00',2.14),('15128','2014-04-17','15:55:00',3.06),('15128','2014-04-17','16:00:00',2.27),('15128','2014-04-17','16:05:00',3.39),('15128','2014-04-17','16:10:00',3.74),('15128','2014-04-17','16:15:00',4.07),('15128','2014-04-17','16:20:00',3.63),('15128','2014-04-17','16:25:00',3.55),('15128','2014-04-17','16:30:00',3.52),('15128','2014-04-17','16:35:00',3.16),('15128','2014-04-17','16:40:00',2.57),('15128','2014-04-17','16:50:00',1.81),('15128','2014-04-17','16:55:00',3.11),('15128','2014-04-17','17:00:00',2.96),('15128','2014-04-17','17:05:00',2.83),('15128','2014-04-17','17:10:00',2.75),('15128','2014-04-17','17:15:00',2.65),('15128','2014-04-17','17:20:00',2.57),('15128','2014-04-17','17:25:00',1.77),('15128','2014-04-17','17:30:00',1.04),('15128','2014-04-17','17:35:00',2.26),('15128','2014-04-17','17:40:00',2.1),('15128','2014-04-17','17:45:00',1.99),('15128','2014-04-17','17:50:00',1.91),('15128','2014-04-17','17:55:00',1.79),('15128','2014-04-17','18:00:00',1.73),('15128','2014-04-17','18:05:00',1.65),('15128','2014-04-17','18:10:00',1.57),('15128','2014-04-17','18:15:00',1.44),('15128','2014-04-17','18:20:00',1.34),('15128','2014-04-17','18:25:00',1.21),('15128','2014-04-17','18:30:00',1.1),('15128','2014-04-17','18:35:00',1.06),('15128','2013-11-06','09:10:00',1.08),('15128','2013-11-06','09:15:00',1.13),('15128','2013-11-06','09:20:00',1.19),('15128','2013-11-06','09:25:00',1.29),('15128','2013-11-06','09:30:00',1.35),('15128','2013-11-06','09:35:00',1.41),('15128','2013-11-06','09:40:00',1.46),('15128','2013-11-06','09:45:00',1.49),('15128','2013-11-06','09:50:00',1.56),('15128','2013-11-06','09:55:00',1.6),('15128','2013-11-06','10:00:00',1.62),('15128','2013-11-06','10:05:00',1.68),('15128','2013-11-06','10:10:00',1.7),('15128','2013-11-06','10:15:00',1.78),('15128','2013-11-06','10:20:00',1.83),('15128','2013-11-06','10:25:00',1.89),('15128','2013-11-06','10:30:00',1.91),('15128','2013-11-06','10:35:00',1.95),('15128','2013-11-06','10:40:00',1.98),('15128','2013-11-06','10:45:00',1.99),('15128','2013-11-06','10:50:00',2.09),('15128','2013-11-06','10:55:00',2.2),('15128','2013-11-06','11:00:00',2.27),('15128','2013-11-06','11:05:00',2.32),('15128','2013-11-06','11:10:00',2.36),('15128','2013-11-06','11:15:00',2.38),('15128','2013-11-06','11:20:00',2.41),('15128','2013-11-06','11:25:00',2.45),('15128','2013-11-06','11:30:00',2.5),('15128','2013-11-06','11:35:00',2.51),('15128','2013-11-06','11:40:00',2.53),('15128','2013-11-06','11:45:00',2.44),('15128','2013-11-06','11:50:00',2.54),('15128','2013-11-06','11:55:00',2.53),('15128','2013-11-06','12:00:00',2.44),('15128','2013-11-06','12:05:00',2.21),('15128','2013-11-06','12:10:00',1.55),('15128','2013-11-06','12:15:00',2.21),('15128','2013-11-06','12:20:00',2.9),('15128','2013-11-06','12:25:00',3.01),('15128','2013-11-06','12:30:00',2.55),('15128','2013-11-06','12:35:00',3.04),('15128','2013-11-06','12:40:00',2.73),('15128','2013-11-06','12:45:00',1.65),('15128','2013-11-06','12:50:00',2.82),('15128','2013-11-06','12:55:00',2.91),('15128','2013-11-06','13:05:00',1.49),('15128','2013-11-06','13:10:00',1.04),('15128','2013-11-06','13:15:00',2.35),('15128','2013-11-06','13:20:00',3.09),('15128','2013-11-06','13:25:00',2.68),('15128','2013-11-06','13:30:00',2.57),('15128','2013-11-06','13:35:00',2.5),('15128','2013-11-06','13:40:00',2.46),('15128','2013-11-06','13:45:00',2.43),('15128','2013-11-06','13:50:00',2.43),('15128','2013-11-06','13:55:00',2.42),('15128','2013-11-06','14:00:00',2.4),('15128','2013-11-06','14:05:00',2.17),('15128','2013-11-06','14:10:00',2.38),('15128','2013-11-06','14:15:00',2.27),('15128','2013-11-06','14:20:00',2.22),('15128','2013-11-06','14:25:00',2.14),('15128','2013-11-06','14:30:00',2.11),('15128','2013-11-06','14:35:00',2.09),('15128','2013-11-06','14:40:00',2),('15128','2013-11-06','14:45:00',1.95),('15128','2013-11-06','14:50:00',1.89),('15128','2013-11-06','14:55:00',1.82),('15128','2013-11-06','15:00:00',1.74),('15128','2013-11-06','15:05:00',1.7),('15128','2013-11-06','15:10:00',1.62),('15128','2013-11-06','15:15:00',1.55),('15128','2013-11-06','15:20:00',1.45),('15128','2013-11-06','15:25:00',1.37),('15128','2013-11-06','15:30:00',1.29),('15128','2013-11-06','15:35:00',1.18),('15128','2013-11-06','15:40:00',1.06),('15128','2013-11-05','09:10:00',1.07),('15128','2013-11-05','09:15:00',1.09),('15128','2013-11-05','09:20:00',1.29),('15128','2013-11-05','09:25:00',1.35),('15128','2013-11-05','09:30:00',1.39),('15128','2013-11-05','09:35:00',1.46),('15128','2013-11-05','09:40:00',1.51),('15128','2013-11-05','09:45:00',1.55),('15128','2013-11-05','09:50:00',1.6),('15128','2013-11-05','09:55:00',1.65),('15128','2013-11-05','10:00:00',1.68),('15128','2013-11-05','10:05:00',1.74),('15128','2013-11-05','10:10:00',1.79),('15128','2013-11-05','10:15:00',1.84),('15128','2013-11-05','10:20:00',1.86),('15128','2013-11-05','10:25:00',1.94),('15128','2013-11-05','10:30:00',1.95),('15128','2013-11-05','10:35:00',2.02),('15128','2013-11-05','10:40:00',2.01),('15128','2013-11-05','10:45:00',2.08),('15128','2013-11-05','10:50:00',2.11),('15128','2013-11-05','10:55:00',2.24),('15128','2013-11-05','11:00:00',2.39),('15128','2013-11-05','11:05:00',2.45),('15128','2013-11-05','11:10:00',2.48),('15128','2013-11-05','11:15:00',2.52),('15128','2013-11-05','11:20:00',2.55),('15128','2013-11-05','11:25:00',2.59),('15128','2013-11-05','11:30:00',2.63),('15128','2013-11-05','11:35:00',2.66),('15128','2013-11-05','11:40:00',2.69),('15128','2013-11-05','11:45:00',2.72),('15128','2013-11-05','11:50:00',2.74),('15128','2013-11-05','11:55:00',2.77),('15128','2013-11-05','12:00:00',2.78),('15128','2013-11-05','12:05:00',2.79),('15128','2013-11-05','12:10:00',2.79),('15128','2013-11-05','12:15:00',2.79),('15128','2013-11-05','12:20:00',2.81),('15128','2013-11-05','12:25:00',2.82),('15128','2013-11-05','12:30:00',2.82),('15128','2013-11-05','12:35:00',2.82),('15128','2013-11-05','12:40:00',2.83),('15128','2013-11-05','12:45:00',2.8),('15128','2013-11-05','12:50:00',2.78),('15128','2013-11-05','12:55:00',2.76),('15128','2013-11-05','13:00:00',2.76),('15128','2013-11-05','13:05:00',2.75),('15128','2013-11-05','13:10:00',2.75),('15128','2013-11-05','13:15:00',2.74),('15128','2013-11-05','13:20:00',2.71),('15128','2013-11-05','13:25:00',2.68),('15128','2013-11-05','13:30:00',2.66),('15128','2013-11-05','13:35:00',2.63),('15128','2013-11-05','13:40:00',2.62),('15128','2013-11-05','13:45:00',2.58),('15128','2013-11-05','13:50:00',2.55),('15128','2013-11-05','13:55:00',2.5),('15128','2013-11-05','14:00:00',2.46),('15128','2013-11-05','14:05:00',2.43),('15128','2013-11-05','14:10:00',2.39),('15128','2013-11-05','14:15:00',2.35),('15128','2013-11-05','14:20:00',2.3),('15128','2013-11-05','14:25:00',2.25),('15128','2013-11-05','14:30:00',2.18),('15128','2013-11-05','14:35:00',2.12),('15128','2013-11-05','14:40:00',2.07),('15128','2013-11-05','14:45:00',2.01),('15128','2013-11-05','14:50:00',1.95),('15128','2013-11-05','14:55:00',1.88),('15128','2013-11-05','15:00:00',1.81),('15128','2013-11-05','15:05:00',1.74),('15128','2013-11-05','15:10:00',1.65),('15128','2013-11-05','15:15:00',1.57),('15128','2013-11-05','15:20:00',1.48),('15128','2013-11-05','15:25:00',1.42),('15128','2013-11-05','15:30:00',1.34),('15128','2013-11-05','15:35:00',1.25),('15128','2013-11-05','15:40:00',1.13),('15128','2013-11-05','15:45:00',1.04),('15128','2013-11-04','08:55:00',1.03),('15128','2013-11-04','10:20:00',1.07),('15128','2013-11-04','10:25:00',1.05),('15128','2013-11-04','10:30:00',1.17),('15128','2013-11-04','10:35:00',1.13),('15128','2013-11-04','10:40:00',1.33),('15128','2013-11-04','10:45:00',1.45),('15128','2013-11-04','10:50:00',1.13),('15128','2013-11-04','11:30:00',1.01),('15128','2013-11-04','11:35:00',1.33),('15128','2013-11-04','11:40:00',1.39),('15128','2013-11-04','11:45:00',1.13),('15128','2013-11-04','11:50:00',1.04),('15128','2013-11-04','12:25:00',1.25),('15128','2013-11-04','12:30:00',1.15),('15128','2013-11-04','12:40:00',1.14),('15128','2013-11-04','12:45:00',1.16),('15128','2013-11-04','13:10:00',1.06),('15128','2013-11-04','13:15:00',1.3),('15128','2013-11-04','13:20:00',1.51),('15128','2013-11-04','13:25:00',1.52),('15128','2013-11-04','13:30:00',1.53),('15128','2013-11-04','13:35:00',2.21),('15128','2013-11-04','13:40:00',2.42),('15128','2013-11-04','13:45:00',2.04),('15128','2013-11-04','13:50:00',2.66),('15128','2013-11-04','13:55:00',1.95),('15128','2013-11-04','14:00:00',1.28),('15128','2013-11-04','14:05:00',2.35),('15128','2013-11-04','14:10:00',2.78),('15128','2013-11-04','14:15:00',2.37),('15128','2013-11-04','14:20:00',2.32),('15128','2013-11-04','14:25:00',2.56),('15128','2013-11-04','14:30:00',2.15),('15128','2013-11-04','14:35:00',2.17),('15128','2013-11-04','14:40:00',2.31),('15128','2013-11-04','14:45:00',1.93),('15128','2013-11-04','14:50:00',1.62),('15128','2013-11-04','15:30:00',1.53),('15128','2013-11-04','15:35:00',1.35),('15128','2013-11-04','15:40:00',1.32),('15128','2013-11-04','15:45:00',1.25),('15128','2013-11-04','15:50:00',1.16),('15128','2013-11-04','15:55:00',1.02),('15128','2013-11-03','09:45:00',1.63),('15128','2013-11-03','09:50:00',1.53),('15128','2013-11-03','09:55:00',1.18),('15128','2013-11-03','10:00:00',1.04),('15128','2013-11-03','10:05:00',1.35),('15128','2013-11-03','10:10:00',1.45),('15128','2013-11-03','10:20:00',1.32),('15128','2013-11-03','10:40:00',1.93),('15128','2013-11-03','10:45:00',2.36),('15128','2013-11-03','10:50:00',2.39),('15128','2013-11-03','10:55:00',2.6),('15128','2013-11-03','11:00:00',2.91),('15128','2013-11-03','11:05:00',3.13),('15128','2013-11-03','11:10:00',2.13),('15128','2013-11-03','11:15:00',1.29),('15128','2013-11-03','11:20:00',1.81),('15128','2013-11-03','11:45:00',2.24),('15128','2013-11-03','11:50:00',2.74),('15128','2013-11-03','11:55:00',3.08),('15128','2013-11-03','12:00:00',3.06),('15128','2013-11-03','12:05:00',3.07),('15128','2013-11-03','12:10:00',3.02),('15128','2013-11-03','12:15:00',3),('15128','2013-11-03','12:20:00',2.03),('15128','2013-11-03','12:25:00',1.02),('15128','2013-11-03','12:30:00',1.29),('15128','2013-11-03','12:35:00',1.22),('15128','2013-11-03','12:40:00',2.34),('15128','2013-11-03','12:45:00',2.09),('15128','2013-11-03','12:50:00',2.59),('15128','2013-11-03','12:55:00',2.9),('15128','2013-11-03','13:00:00',1.84),('15128','2013-11-03','13:05:00',1.12),('15128','2013-11-03','13:10:00',2.52),('15128','2013-11-03','13:15:00',1.08),('15128','2013-11-03','13:20:00',1.77),('15128','2013-11-03','13:25:00',2.76),('15128','2013-11-03','13:30:00',1.51),('15128','2013-11-03','13:35:00',1.68),('15128','2013-11-03','13:40:00',2.86),('15128','2013-11-03','13:45:00',1.97),('15128','2013-11-03','13:50:00',1.88),('15128','2013-11-03','13:55:00',1.8),('15128','2013-11-03','14:00:00',1.27),('15128','2013-11-03','14:20:00',1.13),('15128','2013-11-03','14:25:00',1.65),('15128','2013-11-03','14:30:00',2.05),('15128','2013-11-03','14:35:00',1.97),('15128','2013-11-03','15:00:00',1.02),('15128','2013-11-03','15:10:00',1.86),('15128','2013-11-03','15:15:00',1.74),('15128','2013-11-03','15:25:00',1.49),('15128','2013-11-03','15:30:00',1.41),('15128','2013-11-02','08:45:00',1.05),('15128','2013-11-02','08:50:00',1.13),('15128','2013-11-02','09:10:00',1.06),('15128','2013-11-02','09:15:00',1.1),('15128','2013-11-02','09:20:00',1.07),('15128','2013-11-02','09:25:00',1.16),('15128','2013-11-02','09:30:00',1.43),('15128','2013-11-02','09:35:00',1.18),('15128','2013-11-02','09:50:00',1.03),('15128','2013-11-02','09:55:00',1.71),('15128','2013-11-02','10:00:00',1.91),('15128','2013-11-02','10:05:00',1.56),('15128','2013-11-02','10:10:00',1.83),('15128','2013-11-02','10:15:00',1.85),('15128','2013-11-02','10:20:00',1.62),('15128','2013-11-02','10:25:00',2.08),('15128','2013-11-02','10:30:00',1.94),('15128','2013-11-02','10:35:00',1.44),('15128','2013-11-02','10:40:00',1.18),('15128','2013-11-02','10:45:00',1.05),('15128','2013-11-02','11:05:00',1.34),('15128','2013-11-02','11:10:00',2.74),('15128','2013-11-02','11:15:00',3.13),('15128','2013-11-02','11:20:00',2.85),('15128','2013-11-02','11:25:00',2.24),('15128','2013-11-02','11:30:00',2.74),('15128','2013-11-02','11:35:00',3.57),('15128','2013-11-02','11:40:00',3.41),('15128','2013-11-02','11:45:00',3.12),('15128','2013-11-02','11:50:00',1.07),('15128','2013-11-02','11:55:00',1.32),('15128','2013-11-02','12:00:00',1.45),('15128','2013-11-02','12:05:00',1.31),('15128','2013-11-02','12:10:00',3),('15128','2013-11-02','12:15:00',2.84),('15128','2013-11-02','12:20:00',2.71),('15128','2013-11-02','12:45:00',1.11),('15128','2013-11-02','12:50:00',1.02),('15128','2013-11-02','12:55:00',1.05),('15128','2013-11-02','13:00:00',1.11),('15128','2013-11-02','13:05:00',1.06),('15128','2013-11-02','13:10:00',1.23),('15128','2013-11-02','13:15:00',1.1),('15128','2013-11-02','13:20:00',1.07),('15128','2013-11-02','14:00:00',1.28),('15128','2013-11-02','14:05:00',2.52),('15128','2013-11-02','14:15:00',1.54),('15128','2013-11-02','14:20:00',2.61),('15128','2013-11-02','14:25:00',2.1),('15128','2013-11-02','14:30:00',1.48),('15128','2013-11-02','14:35:00',1.28),('15128','2013-11-02','14:40:00',1.12),('15128','2013-11-02','14:50:00',1.04),('15128','2013-11-02','14:55:00',1.39),('15128','2013-11-02','15:15:00',1.1),('15128','2013-11-02','15:20:00',1.05),('15128','2013-11-02','15:25:00',1.18),('15128','2013-11-02','15:30:00',1.13),('15128','2013-11-01','08:55:00',1.28),('15128','2013-11-01','09:00:00',1.28),('15128','2013-11-01','09:05:00',1.24),('15128','2013-11-01','09:10:00',1.42),('15128','2013-11-01','09:15:00',1.26),('15128','2013-11-01','09:20:00',1.17),('15128','2013-11-01','09:25:00',1.35),('15128','2013-11-01','09:30:00',1.39),('15128','2013-11-01','09:35:00',1.5),('15128','2013-11-01','09:40:00',1.61),('15128','2013-11-01','09:45:00',1.68),('15128','2013-11-01','09:50:00',1.21),('15128','2013-11-01','09:55:00',1.65),('15128','2013-11-01','10:00:00',1.94),('15128','2013-11-01','10:05:00',1.57),('15128','2013-11-01','10:10:00',1.16),('15128','2013-11-01','10:55:00',1.26),('15128','2013-11-01','11:00:00',1.4),('15128','2013-11-01','11:05:00',1.58),('15128','2013-11-01','11:10:00',2.69),('15128','2013-11-01','11:15:00',2.37),('15128','2013-11-01','11:20:00',1.01),('15128','2013-11-01','11:25:00',1.19),('15128','2013-11-01','11:30:00',3.17),('15128','2013-11-01','11:35:00',3.19),('15128','2013-11-01','11:40:00',3.23),('15128','2013-11-01','11:45:00',3.11),('15128','2013-11-01','11:50:00',2.94),('15128','2013-11-01','11:55:00',2.89),('15128','2013-11-01','12:00:00',2.59),('15128','2013-11-01','12:05:00',1.72),('15128','2013-11-01','12:10:00',1.82),('15128','2013-11-01','12:15:00',1.27),('15128','2013-11-01','12:20:00',1.03),('15128','2013-11-01','12:25:00',1.01),('15128','2013-11-01','12:30:00',1.54),('15128','2013-11-01','12:35:00',1.45),('15128','2013-11-01','12:40:00',3.09),('15128','2013-11-01','12:45:00',1.08),('15128','2013-11-01','13:00:00',2.91),('15128','2013-11-01','13:05:00',2.9),('15128','2013-11-01','13:10:00',2.57),('15128','2013-11-01','13:15:00',2.65),('15128','2013-11-01','13:30:00',1.32),('15128','2013-11-01','13:35:00',2.2),('15128','2013-11-01','13:40:00',2.14),('15128','2013-11-01','13:45:00',2.65),('15128','2013-11-01','13:50:00',2.55),('15128','2013-11-01','13:55:00',3.14),('15128','2013-11-01','14:00:00',2.78),('15128','2013-11-01','14:05:00',2.48),('15128','2013-11-01','14:10:00',2.38),('15128','2013-11-01','14:15:00',2.39),('15128','2013-11-01','14:20:00',2.3),('15128','2013-11-01','14:25:00',2.24),('15128','2013-11-01','14:30:00',2.2),('15128','2013-11-01','14:35:00',2.16),('15128','2013-11-01','14:40:00',2.1),('15128','2013-11-01','14:45:00',2.08),('15128','2013-11-01','14:50:00',2),('15128','2013-11-01','14:55:00',2.14),('15128','2013-11-01','15:00:00',1.98),('15128','2013-11-01','15:05:00',1.89),('15128','2013-11-01','15:10:00',1.46),('15128','2013-11-01','15:20:00',1.15),('15128','2013-11-01','15:25:00',1.25),('15128','2013-11-01','15:45:00',1.19),('15128','2013-11-01','15:50:00',1.2),('15128','2013-10-31','09:00:00',1.08),('15128','2013-10-31','09:05:00',1.14),('15128','2013-10-31','09:10:00',1.21),('15128','2013-10-31','09:15:00',1.27),('15128','2013-10-31','09:20:00',1.33),('15128','2013-10-31','09:25:00',1.36),('15128','2013-10-31','09:30:00',1.43),('15128','2013-10-31','09:35:00',1.47),('15128','2013-10-31','09:40:00',1.52),('15128','2013-10-31','09:45:00',1.56),('15128','2013-10-31','09:50:00',1.62),('15128','2013-10-31','09:55:00',1.65),('15128','2013-10-31','10:00:00',1.72),('15128','2013-10-31','10:05:00',1.81),('15128','2013-10-31','10:10:00',1.86),('15128','2013-10-31','10:15:00',1.91),('15128','2013-10-31','10:20:00',1.95),('15128','2013-10-31','10:25:00',1.98),('15128','2013-10-31','10:30:00',2.06),('15128','2013-10-31','10:35:00',2.11),('15128','2013-10-31','10:40:00',2.19),('15128','2013-10-31','10:45:00',2.21),('15128','2013-10-31','10:50:00',2.22),('15128','2013-10-31','10:55:00',2.35),('15128','2013-10-31','11:00:00',2.51),('15128','2013-10-31','11:05:00',2.54),('15128','2013-10-31','11:10:00',2.31),('15128','2013-10-31','11:15:00',2.11),('15128','2013-10-31','11:20:00',2.08),('15128','2013-10-31','11:25:00',2.43),('15128','2013-10-31','11:30:00',2.73),('15128','2013-10-31','11:35:00',2.61),('15128','2013-10-31','11:40:00',2.41),('15128','2013-10-31','11:45:00',2.45),('15128','2013-10-31','11:50:00',2.62),('15128','2013-10-31','11:55:00',2.86),('15128','2013-10-31','12:00:00',2.98),('15128','2013-10-31','12:05:00',2.88),('15128','2013-10-31','12:10:00',2.49),('15128','2013-10-31','12:15:00',2.01),('15128','2013-10-31','12:20:00',2.31),('15128','2013-10-31','12:25:00',2.8),('15128','2013-10-31','12:30:00',2.23),('15128','2013-10-31','12:35:00',1.58),('15128','2013-10-31','12:40:00',1.16),('15128','2013-10-31','12:45:00',1.35),('15128','2013-10-31','12:50:00',2.67),('15128','2013-10-31','12:55:00',2.05),('15128','2013-10-31','13:00:00',2.06),('15128','2013-10-31','13:05:00',2.11),('15128','2013-10-31','13:10:00',1.87),('15128','2013-10-31','13:15:00',1.82),('15128','2013-10-31','13:20:00',1.37),('15128','2013-10-31','13:25:00',1.63),('15128','2013-10-31','13:30:00',1.11),('15128','2013-10-31','13:40:00',1.02),('15128','2013-10-31','14:00:00',1.03),('15128','2013-10-31','14:05:00',1.56),('15128','2013-10-31','14:10:00',1.44),('15128','2013-10-31','14:15:00',1.05),('15128','2013-10-31','14:20:00',1),('15128','2013-10-30','09:05:00',1.03),('15128','2013-10-30','09:10:00',1.24),('15128','2013-10-30','09:15:00',1.34),('15128','2013-10-30','09:20:00',1.34),('15128','2013-10-30','09:25:00',1.23),('15128','2013-10-30','09:30:00',1.16),('15128','2013-10-30','09:35:00',1.21),('15128','2013-10-30','09:40:00',1.31),('15128','2013-10-30','09:45:00',1.29),('15128','2013-10-30','09:50:00',1.35),('15128','2013-10-30','09:55:00',1.44),('15128','2013-10-30','10:00:00',1.64),('15128','2013-10-30','10:05:00',1.65),('15128','2013-10-30','10:10:00',1.75),('15128','2013-10-30','10:15:00',1.79),('15128','2013-10-30','10:20:00',1.82),('15128','2013-10-30','10:25:00',1.84),('15128','2013-10-30','10:30:00',1.8),('15128','2013-10-30','10:35:00',1.89),('15128','2013-10-30','10:40:00',1.94),('15128','2013-10-30','10:45:00',2.14),('15128','2013-10-30','10:50:00',2.05),('15128','2013-10-30','10:55:00',2.03),('15128','2013-10-30','11:00:00',1.9),('15128','2013-10-30','11:05:00',2.08),('15128','2013-10-30','11:10:00',2.33),('15128','2013-10-30','11:15:00',2.45),('15128','2013-10-30','11:20:00',2.26),('15128','2013-10-30','11:25:00',2.29),('15128','2013-10-30','11:30:00',2.33),('15128','2013-10-30','11:35:00',2.13),('15128','2013-10-30','11:40:00',1.98),('15128','2013-10-30','11:45:00',2.38),('15128','2013-10-30','11:50:00',2.4),('15128','2013-10-30','11:55:00',2.75),('15128','2013-10-30','12:00:00',2.8),('15128','2013-10-30','12:05:00',2.83),('15128','2013-10-30','12:10:00',2.84),('15128','2013-10-30','12:15:00',2.82),('15128','2013-10-30','12:20:00',2.8),('15128','2013-10-30','12:25:00',2.76),('15128','2013-10-30','12:30:00',2.76),('15128','2013-10-30','12:35:00',2.65),('15128','2013-10-30','12:40:00',2.61),('15128','2013-10-30','12:45:00',2.61),('15128','2013-10-30','12:50:00',2.7),('15128','2013-10-30','12:55:00',2.67),('15128','2013-10-30','13:00:00',2.67),('15128','2013-10-30','13:05:00',2.74),('15128','2013-10-30','13:10:00',2.71),('15128','2013-10-30','13:15:00',2.63),('15128','2013-10-30','13:20:00',2.64),('15128','2013-10-30','13:25:00',2.64),('15128','2013-10-30','13:30:00',2.59),('15128','2013-10-30','13:35:00',2.52),('15128','2013-10-30','13:40:00',2.47),('15128','2013-10-30','13:45:00',2.47),('15128','2013-10-30','13:50:00',2.41),('15128','2013-10-30','13:55:00',2.4),('15128','2013-10-30','14:00:00',2.34),('15128','2013-10-30','14:05:00',1.98),('15128','2013-10-30','14:10:00',2.23),('15128','2013-10-30','14:15:00',2.24),('15128','2013-10-30','14:20:00',2.21),('15128','2013-10-30','14:25:00',1.93),('15128','2013-10-30','14:30:00',1.88),('15128','2013-10-30','14:35:00',1.9),('15128','2013-10-30','14:40:00',1.79),('15128','2013-10-30','14:45:00',1.55),('15128','2013-10-30','14:50:00',1.59),('15128','2013-10-30','14:55:00',1.63),('15128','2013-10-30','15:00:00',1.57),('15128','2013-10-30','15:05:00',1.5),('15128','2013-10-30','15:10:00',1.42),('15128','2013-10-30','15:15:00',1.31),('15128','2013-10-30','15:20:00',1.21),('15128','2013-10-30','15:25:00',1.19),('15128','2013-10-30','15:30:00',1.03),('15128','2013-10-29','08:55:00',1.05),('15128','2013-10-29','09:00:00',1.11),('15128','2013-10-29','09:05:00',1.2),('15128','2013-10-29','09:10:00',1.24),('15128','2013-10-29','09:15:00',1.29),('15128','2013-10-29','09:20:00',1.35),('15128','2013-10-29','09:25:00',1.42),('15128','2013-10-29','09:30:00',1.38),('15128','2013-10-29','09:35:00',1.34),('15128','2013-10-29','09:40:00',1.38),('15128','2013-10-29','09:45:00',1.5),('15128','2013-10-29','09:50:00',1.52),('15128','2013-10-29','09:55:00',1.71),('15128','2013-10-29','10:00:00',1.64),('15128','2013-10-29','10:05:00',1.71),('15128','2013-10-29','10:10:00',1.85),('15128','2013-10-29','10:15:00',1.75),('15128','2013-10-29','10:20:00',1.96),('15128','2013-10-29','10:25:00',2.02),('15128','2013-10-29','10:30:00',2.18),('15128','2013-10-29','10:35:00',2.19),('15128','2013-10-29','10:40:00',2.08),('15128','2013-10-29','10:45:00',2.08),('15128','2013-10-29','10:50:00',2.13),('15128','2013-10-29','10:55:00',2.35),('15128','2013-10-29','11:00:00',2.46),('15128','2013-10-29','11:05:00',2.01),('15128','2013-10-29','11:10:00',1.82),('15128','2013-10-29','11:15:00',2.28),('15128','2013-10-29','11:20:00',1.11),('15128','2013-10-29','11:25:00',1.73),('15128','2013-10-29','11:30:00',1.21),('15128','2013-10-29','11:35:00',1.4),('15128','2013-10-29','11:40:00',1.64),('15128','2013-10-29','11:45:00',1.37),('15128','2013-10-29','11:50:00',1.37),('15128','2013-10-29','11:55:00',2.41),('15128','2013-10-29','12:00:00',2.72),('15128','2013-10-29','12:05:00',2.65),('15128','2013-10-29','12:10:00',1.85),('15128','2013-10-29','12:35:00',1.04),('15128','2013-10-29','12:40:00',1.43),('15128','2013-10-29','12:45:00',1.32),('15128','2013-10-29','12:50:00',2.31),('15128','2013-10-29','12:55:00',2.54),('15128','2013-10-29','13:00:00',2.08),('15128','2013-10-29','13:10:00',1.84),('15128','2013-10-29','13:15:00',2.58),('15128','2013-10-29','13:20:00',2.6),('15128','2013-10-29','13:25:00',2.04),('15128','2013-10-29','13:30:00',2.44),('15128','2013-10-29','13:35:00',2.78),('15128','2013-10-29','13:40:00',2.66),('15128','2013-10-29','13:45:00',2.49),('15128','2013-10-29','13:50:00',2.4),('15128','2013-10-29','13:55:00',2.36),('15128','2013-10-29','14:00:00',1.9),('15128','2013-10-29','14:55:00',1.65),('15128','2013-10-29','15:00:00',1.86),('15128','2013-10-29','15:05:00',1.53),('15128','2013-10-29','15:10:00',1.44),('15128','2013-10-29','15:15:00',1.59),('15128','2013-10-29','15:20:00',1.5),('15128','2013-10-29','15:45:00',1.02),('15128','2013-10-28','08:50:00',1.02),('15128','2013-10-28','08:55:00',1.07),('15128','2013-10-28','09:00:00',1.11),('15128','2013-10-28','09:05:00',1.19),('15128','2013-10-28','09:10:00',1.25),('15128','2013-10-28','09:15:00',1.32),('15128','2013-10-28','09:20:00',1.35),('15128','2013-10-28','09:25:00',1.42),('15128','2013-10-28','09:30:00',1.46),('15128','2013-10-28','09:35:00',1.49),('15128','2013-10-28','09:40:00',1.53),('15128','2013-10-28','09:45:00',1.55),('15128','2013-10-28','09:50:00',1.62),('15128','2013-10-28','09:55:00',1.74),('15128','2013-10-28','10:00:00',1.8),('15128','2013-10-28','10:05:00',1.88),('15128','2013-10-28','10:10:00',1.84),('15128','2013-10-28','10:15:00',1.16),('15128','2013-10-28','10:20:00',1.35),('15128','2013-10-28','10:25:00',1.18),('15128','2013-10-28','10:30:00',1.18),('15128','2013-10-28','10:35:00',1.84),('15128','2013-10-28','10:40:00',1.96),('15128','2013-10-28','10:50:00',1.52),('15128','2013-10-28','10:55:00',2.21),('15128','2013-10-28','11:00:00',2.71),('15128','2013-10-28','11:05:00',2.79),('15128','2013-10-28','11:10:00',1.64),('15128','2013-10-28','11:15:00',1.8),('15128','2013-10-28','11:20:00',1.88),('15128','2013-10-28','11:25:00',1.74),('15128','2013-10-28','11:30:00',1.95),('15128','2013-10-28','11:35:00',1.04),('15128','2013-10-28','11:40:00',2),('15128','2013-10-28','11:45:00',3.33),('15128','2013-10-28','11:50:00',3.34),('15128','2013-10-28','11:55:00',3.16),('15128','2013-10-28','12:00:00',3.1),('15128','2013-10-28','12:05:00',2.99),('15128','2013-10-28','12:10:00',2.83),('15128','2013-10-28','12:15:00',2.84),('15128','2013-10-28','12:20:00',2.82),('15128','2013-10-28','12:25:00',2.83),('15128','2013-10-28','12:30:00',2.86),('15128','2013-10-28','12:35:00',2.9),('15128','2013-10-28','12:40:00',2.82),('15128','2013-10-28','12:45:00',2.78),('15128','2013-10-28','12:50:00',2.78),('15128','2013-10-28','12:55:00',2.77),('15128','2013-10-28','13:00:00',2.73),('15128','2013-10-28','13:05:00',2.7),('15128','2013-10-28','13:10:00',1.89),('15128','2013-10-28','13:15:00',1.9),('15128','2013-10-28','13:20:00',2.57),('15128','2013-10-28','13:25:00',2.71),('15128','2013-10-28','13:30:00',2.72),('15128','2013-10-28','13:35:00',2.75),('15128','2013-10-28','13:40:00',1.96),('15128','2013-10-28','13:45:00',1.94),('15128','2013-10-28','13:50:00',1.73),('15128','2013-10-28','13:55:00',2.42),('15128','2013-10-28','14:00:00',2.39),('15128','2013-10-28','14:05:00',2.23),('15128','2013-10-28','14:10:00',2.29),('15128','2013-10-28','14:15:00',2.22),('15128','2013-10-28','14:20:00',2.23),('15128','2013-10-28','14:25:00',2.18),('15128','2013-10-28','14:30:00',2.11),('15128','2013-10-28','14:35:00',2.04),('15128','2013-10-28','14:40:00',1.99),('15128','2013-10-28','14:45:00',1.95),('15128','2013-10-28','14:50:00',1.9),('15128','2013-10-28','14:55:00',1.83),('15128','2013-10-28','15:00:00',1.74),('15128','2013-10-28','15:05:00',1.68),('15128','2013-10-28','15:10:00',1.6),('15128','2013-10-28','15:15:00',1.51),('15128','2013-10-28','15:20:00',1.44),('15128','2013-10-28','15:25:00',1.35),('15128','2013-10-28','15:30:00',1.26),('15128','2013-10-28','15:35:00',1.2),('15128','2013-10-28','15:40:00',1.11),('15128','2014-04-16','08:35:00',1.03),('15128','2014-04-16','08:40:00',1.09),('15128','2014-04-16','08:45:00',1.17),('15128','2014-04-16','08:50:00',1.25),('15128','2014-04-16','08:55:00',1.32),('15128','2014-04-16','09:00:00',1.41),('15128','2014-04-16','09:05:00',1.47),('15128','2014-04-16','09:10:00',1.54),('15128','2014-04-16','09:15:00',1.62),('15128','2014-04-16','09:20:00',1.71),('15128','2014-04-16','09:25:00',1.79),('15128','2014-04-16','09:30:00',1.87),('15128','2014-04-16','09:35:00',1.95),('15128','2014-04-16','09:40:00',2.02),('15128','2014-04-16','09:45:00',2.04),('15128','2014-04-16','09:50:00',2.11),('15128','2014-04-16','09:55:00',2.16),('15128','2014-04-16','10:00:00',2.28),('15128','2014-04-16','10:05:00',1.34),('15128','2014-04-16','10:10:00',1.46),('15128','2014-04-16','10:15:00',2.2),('15128','2014-04-16','10:20:00',1.41),('15128','2014-04-16','10:25:00',1.66),('15128','2014-04-16','10:30:00',1.7),('15128','2014-04-16','10:35:00',2.4),('15128','2014-04-16','10:40:00',2.34),('15128','2014-04-16','10:45:00',2.13),('15128','2014-04-16','10:50:00',2.06),('15128','2014-04-16','10:55:00',2.55),('15128','2014-04-16','11:00:00',2.1),('15128','2014-04-16','11:05:00',2.5),('15128','2014-04-16','11:10:00',2.22),('15128','2014-04-16','11:15:00',2.96),('15128','2014-04-16','11:20:00',2.54),('15128','2014-04-16','11:25:00',2.3),('15128','2014-04-16','11:30:00',3.2),('15128','2014-04-16','11:35:00',2.45),('15128','2014-04-16','11:40:00',3.74),('15128','2014-04-16','11:45:00',3.15),('15128','2014-04-16','11:50:00',2.8),('15128','2014-04-16','11:55:00',2.45),('15128','2014-04-16','12:00:00',2.58),('15128','2014-04-16','12:05:00',1.99),('15128','2014-04-16','12:10:00',2.33),('15128','2014-04-16','12:15:00',2.24),('15128','2014-04-16','12:20:00',2.87),('15128','2014-04-16','12:25:00',3.29),('15128','2014-04-16','12:30:00',3.87),('15128','2014-04-16','12:35:00',3.97),('15128','2014-04-16','12:40:00',4.05),('15128','2014-04-16','12:45:00',4.19),('15128','2014-04-16','12:50:00',4.27),('15128','2014-04-16','12:55:00',4.24),('15128','2014-04-16','13:00:00',4.25),('15128','2014-04-16','13:05:00',4.26),('15128','2014-04-16','13:10:00',4.27),('15128','2014-04-16','13:15:00',4.39),('15128','2014-04-16','13:20:00',4.44),('15128','2014-04-16','13:25:00',4.67),('15128','2014-04-16','13:30:00',4.52),('15128','2014-04-16','13:35:00',4.77),('15128','2014-04-16','13:40:00',4.76),('15128','2014-04-16','13:45:00',4.79),('15128','2014-04-16','13:50:00',4.88),('15128','2014-04-16','13:55:00',4.81),('15128','2014-04-16','14:00:00',3.74),('15128','2014-04-16','14:05:00',4.74),('15128','2014-04-16','14:10:00',4.79),('15128','2014-04-16','14:15:00',4.84),('15128','2014-04-16','14:20:00',3.19),('15128','2014-04-16','14:25:00',5.14),('15128','2014-04-16','14:30:00',4.9),('15128','2014-04-16','14:35:00',2.76),('15128','2014-04-16','14:40:00',3.92),('15128','2014-04-16','14:45:00',2),('15128','2014-04-16','14:50:00',1.13),('15128','2014-04-16','14:55:00',1.08),('15128','2014-04-16','15:00:00',1.11),('15128','2014-04-16','15:10:00',1.17),('15128','2014-04-16','15:15:00',1.53),('15128','2014-04-16','15:20:00',1.55),('15128','2014-04-16','15:25:00',1.29),('15128','2014-04-16','15:30:00',1.16),('15128','2014-04-16','15:35:00',1.04),('15128','2014-04-16','15:40:00',1.13),('15128','2014-04-16','15:45:00',1.26),('15128','2014-04-16','15:50:00',1.11),('15128','2014-04-16','16:25:00',1.01),('15128','2014-04-16','16:30:00',1.16),('15128','2014-04-16','16:35:00',1.2),('15128','2014-04-16','16:40:00',1.41),('15128','2014-04-16','16:45:00',1.82),('15128','2014-04-16','16:50:00',1.31),('15128','2014-04-16','16:55:00',1.23),('15128','2014-04-16','17:00:00',1.08),('15128','2014-04-16','17:15:00',1.11),('15128','2014-04-16','17:20:00',1.8),('15128','2014-04-16','17:25:00',1.61),('15128','2014-04-16','17:30:00',1.63),('15128','2014-04-16','17:35:00',1.56),('15128','2014-04-16','17:40:00',1.53),('15128','2014-04-16','17:45:00',1.09),('15128','2013-10-27','09:00:00',1.11),('15128','2013-10-27','09:05:00',1.16),('15128','2013-10-27','09:10:00',1.28),('15128','2013-10-27','09:15:00',1.33),('15128','2013-10-27','09:20:00',1.38),('15128','2013-10-27','09:25:00',1.49),('15128','2013-10-27','09:30:00',1.77),('15128','2013-10-27','09:35:00',2.05),('15128','2013-10-27','09:40:00',1.85),('15128','2013-10-27','09:45:00',1.07),('15128','2013-10-27','10:30:00',1.47),('15128','2013-10-27','10:35:00',2.13),('15128','2013-10-27','10:40:00',2.17),('15128','2013-10-27','10:45:00',2.23),('15128','2013-10-27','10:50:00',2.2),('15128','2013-10-27','10:55:00',2.33),('15128','2013-10-27','11:00:00',2.46),('15128','2013-10-27','11:05:00',2.49),('15128','2013-10-27','11:10:00',2.55),('15128','2013-10-27','11:15:00',2.58),('15128','2013-10-27','11:20:00',2.59),('15128','2013-10-27','11:25:00',2.61),('15128','2013-10-27','11:30:00',2.69),('15128','2013-10-27','11:35:00',2.64),('15128','2013-10-27','11:40:00',2.67),('15128','2013-10-27','11:45:00',2.7),('15128','2013-10-27','11:50:00',2.75),('15128','2013-10-27','11:55:00',2.78),('15128','2013-10-27','12:00:00',2.8),('15128','2013-10-27','12:05:00',3),('15128','2013-10-27','12:10:00',2.04),('15128','2013-10-27','12:15:00',2.27),('15128','2013-10-27','12:20:00',3.17),('15128','2013-10-27','12:25:00',2.88),('15128','2013-10-27','12:30:00',2.62),('15128','2013-10-27','12:35:00',3.08),('15128','2013-10-27','12:40:00',2.99),('15128','2013-10-27','12:45:00',2.86),('15128','2013-10-27','12:50:00',2.86),('15128','2013-10-27','12:55:00',2.87),('15128','2013-10-27','13:00:00',2.85),('15128','2013-10-27','13:05:00',2.84),('15128','2013-10-27','13:10:00',2.84),('15128','2013-10-27','13:15:00',2.82),('15128','2013-10-27','13:20:00',2.79),('15128','2013-10-27','13:25:00',2.77),('15128','2013-10-27','13:30:00',2.75),('15128','2013-10-27','13:35:00',2.74),('15128','2013-10-27','13:40:00',2.72),('15128','2013-10-27','13:45:00',2.66),('15128','2013-10-27','13:50:00',2.72),('15128','2013-10-27','13:55:00',2.68),('15128','2013-10-27','14:00:00',2.59),('15128','2013-10-27','14:05:00',2.1),('15128','2013-10-27','14:10:00',2.56),('15128','2013-10-27','14:15:00',2.5),('15128','2013-10-27','14:20:00',2.44),('15128','2013-10-27','14:25:00',2.32),('15128','2013-10-27','14:30:00',2.23),('15128','2013-10-27','14:35:00',2.23),('15128','2013-10-27','14:40:00',2.1),('15128','2013-10-27','14:45:00',2.15),('15128','2013-10-27','14:50:00',2.06),('15128','2013-10-27','14:55:00',1.95),('15128','2013-10-27','15:00:00',1.93),('15128','2013-10-27','15:05:00',1.84),('15128','2013-10-27','15:10:00',1.8),('15128','2013-10-27','15:15:00',1.71),('15128','2013-10-27','15:20:00',1.55),('15128','2013-10-27','15:25:00',1.31),('15128','2013-10-27','15:30:00',1.78),('15128','2013-10-27','15:35:00',1.08),('15128','2013-10-27','15:40:00',1.3),('15128','2013-10-27','15:45:00',1.2),('15128','2013-10-27','15:50:00',1.07),('15128','2013-10-26','09:55:00',1.03),('15128','2013-10-26','10:00:00',1.05),('15128','2013-10-26','10:05:00',1.04),('15128','2013-10-26','10:10:00',1.03),('15128','2013-10-26','10:15:00',1.15),('15128','2013-10-26','10:20:00',1.26),('15128','2013-10-26','10:25:00',1.34),('15128','2013-10-26','10:30:00',1.63),('15128','2013-10-26','10:35:00',1.47),('15128','2013-10-26','10:40:00',1.36),('15128','2013-10-26','10:45:00',1.24),('15128','2013-10-26','10:50:00',1.12),('15128','2013-10-26','10:55:00',1.11),('15128','2013-10-26','11:00:00',1.34),('15128','2013-10-26','11:05:00',1.46),('15128','2013-10-26','11:10:00',1.44),('15128','2013-10-26','11:15:00',1.42),('15128','2013-10-26','11:20:00',1.51),('15128','2013-10-26','11:25:00',1.51),('15128','2013-10-26','11:30:00',1.51),('15128','2013-10-26','11:35:00',1.6),('15128','2013-10-26','11:40:00',1.76),('15128','2013-10-26','11:45:00',2),('15128','2013-10-26','11:50:00',2.28),('15128','2013-10-26','11:55:00',1.89),('15128','2013-10-26','12:00:00',2.42),('15128','2013-10-26','12:05:00',2.15),('15128','2013-10-26','12:10:00',2.69),('15128','2013-10-26','12:15:00',3.5),('15128','2013-10-26','12:20:00',2.3),('15128','2013-10-26','12:25:00',3.22),('15128','2013-10-26','12:30:00',1.55),('15128','2013-10-26','12:35:00',1.68),('15128','2013-10-26','12:40:00',1.01),('15128','2013-10-26','12:45:00',2.38),('15128','2013-10-26','12:50:00',3.19),('15128','2013-10-26','12:55:00',2.05),('15128','2013-10-26','13:00:00',1.9),('15128','2013-10-26','13:05:00',2.88),('15128','2013-10-26','13:10:00',1.76),('15128','2013-10-26','13:15:00',2.34),('15128','2013-10-26','13:20:00',1.79),('15128','2013-10-26','13:25:00',1.06),('15128','2013-10-26','14:00:00',1.21),('15128','2013-10-26','14:15:00',1.99),('15128','2013-10-26','14:20:00',2.31),('15128','2013-10-26','14:25:00',2.27),('15128','2013-10-26','14:30:00',2.01),('15128','2013-10-26','14:35:00',2.21),('15128','2013-10-26','14:40:00',1.72),('15128','2013-10-26','14:45:00',1.64),('15128','2013-10-26','14:50:00',1.64),('15128','2013-10-26','14:55:00',1.91),('15128','2013-10-26','15:00:00',1.88),('15128','2013-10-26','15:05:00',1.95),('15128','2013-10-26','15:10:00',1.85),('15128','2013-10-26','15:15:00',1.85),('15128','2013-10-26','15:20:00',1.78),('15128','2013-10-26','15:25:00',1.53),('15128','2013-10-26','15:30:00',1.14),('15128','2013-10-26','15:40:00',1),('15128','2013-10-26','15:45:00',1.11),('15128','2013-10-26','15:50:00',1.03),('15128','2013-10-25','09:50:00',1.04),('15128','2013-10-25','09:55:00',1.11),('15128','2013-10-25','10:00:00',1.17),('15128','2013-10-25','10:05:00',1.22),('15128','2013-10-25','10:11:00',1.27),('15128','2013-10-25','10:15:00',1.35),('15128','2013-10-25','10:20:00',1.38),('15128','2013-10-25','10:25:00',1.42),('15128','2013-10-25','10:30:00',1.49),('15128','2013-10-25','10:35:00',1.52),('15128','2013-10-25','10:40:00',1.55),('15128','2013-10-25','10:45:00',1.61),('15128','2013-10-25','10:50:00',1.67),('15128','2013-10-25','10:55:00',1.75),('15128','2013-10-25','11:00:00',1.76),('15128','2013-10-25','11:05:00',1.81),('15128','2013-10-25','11:10:00',1.87),('15128','2013-10-25','11:15:00',1.92),('15128','2013-10-25','11:20:00',1.98),('15128','2013-10-25','11:25:00',2.03),('15128','2013-10-25','11:30:00',2.02),('15128','2013-10-25','11:35:00',2.07),('15128','2013-10-25','11:40:00',2.15),('15128','2013-10-25','11:45:00',2.19),('15128','2013-10-25','11:50:00',2.23),('15128','2013-10-25','11:55:00',2.35),('15128','2013-10-25','12:00:00',2.44),('15128','2013-10-25','12:05:00',2.48),('15128','2013-10-25','12:10:00',2.5),('15128','2013-10-25','12:15:00',2.51),('15128','2013-10-25','12:20:00',2.51),('15128','2013-10-25','12:25:00',2.59),('15128','2013-10-25','12:30:00',2.63),('15128','2013-10-25','12:35:00',2.66),('15128','2013-10-25','12:40:00',2.69),('15128','2013-10-25','12:45:00',2.7),('15128','2013-10-25','12:50:00',2.69),('15128','2013-10-25','12:55:00',2.72),('15128','2013-10-25','13:00:00',2.74),('15128','2013-10-25','13:05:00',2.74),('15128','2013-10-25','13:10:00',2.68),('15128','2013-10-25','13:15:00',2.77),('15128','2013-10-25','13:20:00',2.79),('15128','2013-10-25','13:25:00',2.75),('15128','2013-10-25','13:30:00',2.77),('15128','2013-10-25','13:35:00',2.77),('15128','2013-10-25','13:40:00',2.8),('15128','2013-10-25','13:45:00',2.71),('15128','2013-10-25','13:50:00',2.75),('15128','2013-10-25','13:55:00',2.71),('15128','2013-10-25','14:00:00',2.7),('15128','2013-10-25','14:05:00',2.69),('15128','2013-10-25','14:10:00',2.65),('15128','2013-10-25','14:15:00',2.67),('15128','2013-10-25','14:20:00',2.6),('15128','2013-10-25','14:25:00',2.55),('15128','2013-10-25','14:30:00',2.6),('15128','2013-10-25','14:35:00',2.5),('15128','2013-10-25','14:42:00',2.5),('15128','2013-10-25','14:45:00',2.47),('15128','2013-10-25','14:50:00',2.34),('15128','2013-10-25','14:55:00',2.45),('15128','2013-10-25','15:00:00',2.38),('15128','2013-10-25','15:05:00',2.3),('15128','2013-10-25','15:10:00',1.49),('15128','2013-10-25','15:15:00',2.18),('15128','2013-10-25','15:20:00',1.92),('15128','2013-10-25','15:25:00',2.12),('15128','2013-10-25','15:30:00',1.89),('15128','2013-10-25','15:35:00',1.96),('15128','2013-10-25','15:40:00',1.98),('15128','2013-10-25','15:45:00',1.9),('15128','2013-10-25','15:50:00',1.85),('15128','2013-10-25','15:55:00',1.79),('15128','2013-10-25','16:00:00',1.73),('15128','2013-10-25','16:05:00',1.64),('15128','2013-10-25','16:10:00',1.5),('15128','2013-10-25','16:15:00',1.47),('15128','2013-10-25','16:20:00',1.42),('15128','2013-10-25','16:25:00',1.34),('15128','2013-10-25','16:30:00',1.27),('15128','2013-10-25','16:35:00',1.16),('15128','2013-10-25','16:40:00',1.08),('15128','2013-10-25','16:45:00',1.03),('15128','2013-10-24','09:45:00',1),('15128','2013-10-24','09:50:00',1.07),('15128','2013-10-24','09:55:00',1.12),('15128','2013-10-24','10:00:00',1.18),('15128','2013-10-24','10:05:00',1.25),('15128','2013-10-24','10:10:00',1.31),('15128','2013-10-24','10:15:00',1.36),('15128','2013-10-24','10:20:00',1.41),('15128','2013-10-24','10:25:00',1.44),('15128','2013-10-24','10:30:00',1.51),('15128','2013-10-24','10:35:00',1.54),('15128','2013-10-24','10:40:00',1.57),('15128','2013-10-24','10:45:00',1.63),('15128','2013-10-24','10:50:00',1.67),('15128','2013-10-24','10:55:00',1.76),('15128','2013-10-24','11:00:00',1.82),('15128','2013-10-24','11:05:00',1.83),('15128','2013-10-24','11:10:00',1.91),('15128','2013-10-24','11:15:00',1.92),('15128','2013-10-24','11:20:00',2.02),('15128','2013-10-24','11:25:00',2.04),('15128','2013-10-24','11:30:00',2.09),('15128','2013-10-24','11:35:00',2.12),('15128','2013-10-24','11:40:00',2.15),('15128','2013-10-24','11:45:00',2.23),('15128','2013-10-24','11:50:00',2.27),('15128','2013-10-24','11:55:00',2.45),('15128','2013-10-24','12:00:00',2.52),('15128','2013-10-24','12:05:00',2.6),('15128','2013-10-24','12:10:00',2.6),('15128','2013-10-24','12:15:00',2.63),('15128','2013-10-24','12:20:00',2.64),('15128','2013-10-24','12:25:00',2.68),('15128','2013-10-24','12:30:00',2.72),('15128','2013-10-24','12:35:00',2.79),('15128','2013-10-24','12:40:00',2.8),('15128','2013-10-24','12:45:00',2.82),('15128','2013-10-24','12:50:00',2.85),('15128','2013-10-24','12:55:00',2.85),('15128','2013-10-24','13:00:00',2.87),('15128','2013-10-24','13:05:00',2.89),('15128','2013-10-24','13:10:00',2.88),('15128','2013-10-24','13:15:00',2.88),('15128','2013-10-24','13:20:00',2.89),('15128','2013-10-24','13:25:00',2.88),('15128','2013-10-24','13:30:00',2.88),('15128','2013-10-24','13:35:00',2.87),('15128','2013-10-24','13:40:00',2.85),('15128','2013-10-24','13:45:00',2.85),('15128','2013-10-24','13:50:00',2.83),('15128','2013-10-24','13:55:00',2.78),('15128','2013-10-24','14:00:00',2.78),('15128','2013-10-24','14:05:00',2.8),('15128','2013-10-24','14:10:00',2.83),('15128','2013-10-24','14:15:00',2.78),('15128','2013-10-24','14:20:00',2.74),('15128','2013-10-24','14:25:00',2.75),('15128','2013-10-24','14:30:00',2.74),('15128','2013-10-24','14:35:00',2.71),('15128','2013-10-24','14:40:00',2.63),('15128','2013-10-24','14:45:00',2.59),('15128','2013-10-24','14:50:00',2.58),('15128','2013-10-24','14:55:00',2.56),('15128','2013-10-24','15:00:00',2.51),('15128','2013-10-24','15:05:00',2.47),('15128','2013-10-24','15:10:00',2.41),('15128','2013-10-24','15:15:00',2.37),('15128','2013-10-24','15:20:00',2.36),('15128','2013-10-24','15:25:00',2.22),('15128','2013-10-24','15:30:00',2.19),('15128','2013-10-24','15:35:00',2.2),('15128','2013-10-24','15:40:00',2.14),('15128','2013-10-24','15:45:00',2.08),('15128','2013-10-24','15:50:00',2.02),('15128','2013-10-24','15:55:00',1.96),('15128','2013-10-24','16:00:00',1.91),('15128','2013-10-24','16:05:00',1.83),('15128','2013-10-24','16:10:00',1.76),('15128','2013-10-24','16:15:00',1.71),('15128','2013-10-24','16:20:00',1.63),('15128','2013-10-24','16:25:00',1.57),('15128','2013-10-24','16:30:00',1.49),('15128','2013-10-24','16:35:00',1.39),('15128','2013-10-24','16:40:00',1.3),('15128','2013-10-24','16:45:00',1.22),('15128','2013-10-24','16:50:00',1.11),('15128','2013-10-24','16:55:00',1.02),('15128','2013-10-23','09:45:00',1),('15128','2013-10-23','10:25:00',1.17),('15128','2013-10-23','10:30:00',1.73),('15128','2013-10-23','10:35:00',2.62),('15128','2013-10-23','10:40:00',2.33),('15128','2013-10-23','10:45:00',2.54),('15128','2013-10-23','10:50:00',2.12),('15128','2013-10-23','10:55:00',1.53),('15128','2013-10-23','11:00:00',1.34),('15128','2013-10-23','11:05:00',1.47),('15128','2013-10-23','11:10:00',1.26),('15128','2013-10-23','11:15:00',1.33),('15128','2013-10-23','11:20:00',1.21),('15128','2013-10-23','11:25:00',1.1),('15128','2013-10-23','11:30:00',1.65),('15128','2013-10-23','11:35:00',2.69),('15128','2013-10-23','11:40:00',3.07),('15128','2013-10-23','11:45:00',2.69),('15128','2013-10-23','11:50:00',2.62),('15128','2013-10-23','11:55:00',1.51),('15128','2013-10-23','12:00:00',1.32),('15128','2013-10-23','12:05:00',1.38),('15128','2013-10-23','12:10:00',1.49),('15128','2013-10-23','12:15:00',1.66),('15128','2013-10-23','12:20:00',1.89),('15128','2013-10-23','12:25:00',1.9),('15128','2013-10-23','12:30:00',1.89),('15128','2013-10-23','12:35:00',1.62),('15128','2013-10-23','12:40:00',1.63),('15128','2013-10-23','12:45:00',1.67),('15128','2013-10-23','12:50:00',1.5),('15128','2013-10-23','12:55:00',1.42),('15128','2013-10-23','13:00:00',1.35),('15128','2013-10-23','13:05:00',1.28),('15128','2013-10-23','13:10:00',1.25),('15128','2013-10-23','13:15:00',1.25),('15128','2013-10-23','13:20:00',1.23),('15128','2013-10-23','13:25:00',1.24),('15128','2013-10-23','13:30:00',1.26),('15128','2013-10-23','13:35:00',1.28),('15128','2013-10-23','13:40:00',1.28),('15128','2013-10-23','13:45:00',1.67),('15128','2013-10-23','13:50:00',2.07),('15128','2013-10-23','13:55:00',1.26),('15128','2013-10-23','14:00:00',1.32),('15128','2013-10-23','14:05:00',1.45),('15128','2013-10-23','14:10:00',1.35),('15128','2013-10-23','14:15:00',1.36),('15128','2013-10-23','14:20:00',1.42),('15128','2013-10-23','14:25:00',1.52),('15128','2013-10-23','14:30:00',2.12),('15128','2013-10-23','14:35:00',2.56),('15128','2013-10-23','14:40:00',2.22),('15128','2013-10-23','14:45:00',1.05),('15128','2013-10-23','14:55:00',1.39),('15128','2013-10-23','15:00:00',1.8),('15128','2013-10-23','15:05:00',1.38),('15128','2013-10-23','15:10:00',1.09),('15128','2013-10-23','15:15:00',1.05),('15128','2013-10-23','15:20:00',1.26),('15128','2013-10-23','15:25:00',1.3),('15128','2013-10-23','15:30:00',1.87),('15128','2013-10-23','15:35:00',2.82),('15128','2013-10-23','15:40:00',2.41),('15128','2013-10-23','15:45:00',2.25),('15128','2013-10-23','15:50:00',1.05),('15128','2013-10-22','10:30:00',1.13),('15128','2013-10-22','10:35:00',1.12),('15128','2013-10-22','10:40:00',1.23),('15128','2013-10-22','10:45:00',1.1),('15128','2013-10-22','10:50:00',1.25),('15128','2013-10-22','10:55:00',2.18),('15128','2013-10-22','11:00:00',2.13),('15128','2013-10-22','11:05:00',2.14),('15128','2013-10-22','11:10:00',2.03),('15128','2013-10-22','11:15:00',2.12),('15128','2013-10-22','11:20:00',2.23),('15128','2013-10-22','11:25:00',2.13),('15128','2013-10-22','11:30:00',2.2),('15128','2013-10-22','11:35:00',2),('15128','2013-10-22','11:40:00',1.99),('15128','2013-10-22','11:45:00',2.27),('15128','2013-10-22','11:50:00',2.91),('15128','2013-10-22','11:55:00',2.06),('15128','2013-10-22','12:00:00',2.82),('15128','2013-10-22','12:05:00',2.77),('15128','2013-10-22','12:10:00',1.96),('15128','2013-10-22','12:15:00',2.46),('15128','2013-10-22','12:20:00',2.65),('15128','2013-10-22','12:25:00',2.57),('15128','2013-10-22','12:30:00',2.4),('15128','2013-10-22','12:35:00',2.57),('15128','2013-10-22','12:40:00',2.73),('15128','2013-10-22','12:45:00',2.75),('15128','2013-10-22','12:50:00',2.78),('15128','2013-10-22','12:55:00',2.7),('15128','2013-10-22','13:00:00',2.75),('15128','2013-10-22','13:05:00',2.8),('15128','2013-10-22','13:10:00',2.78),('15128','2013-10-22','13:15:00',2.8),('15128','2013-10-22','13:20:00',2.79),('15128','2013-10-22','13:25:00',2.79),('15128','2013-10-22','13:30:00',2.77),('15128','2013-10-22','13:35:00',2.75),('15128','2013-10-22','13:40:00',2.79),('15128','2013-10-22','13:45:00',2.79),('15128','2013-10-22','13:50:00',2.74),('15128','2013-10-22','13:55:00',2.71),('15128','2013-10-22','14:00:00',2.77),('15128','2013-10-22','14:05:00',2.72),('15128','2013-10-22','14:10:00',2.66),('15128','2013-10-22','14:15:00',2.68),('15128','2013-10-22','14:20:00',2.49),('15128','2013-10-22','14:25:00',2.53),('15128','2013-10-22','14:30:00',2.5),('15128','2013-10-22','14:35:00',2.54),('15128','2013-10-22','14:40:00',2.5),('15128','2013-10-22','14:45:00',2.43),('15128','2013-10-22','14:50:00',2.42),('15128','2013-10-22','14:55:00',2.31),('15128','2013-10-22','15:00:00',2.26),('15128','2013-10-22','15:05:00',2.18),('15128','2013-10-22','15:10:00',1.94),('15128','2013-10-22','15:15:00',1.49),('15128','2013-10-22','15:20:00',1.47),('15128','2013-10-22','15:25:00',1.31),('15128','2013-10-22','15:30:00',1.2),('15128','2013-10-22','15:35:00',1.56),('15128','2013-10-22','15:40:00',1.65),('15128','2013-10-22','15:45:00',1.28),('15128','2013-10-22','16:10:00',1.07),('15128','2013-10-22','16:15:00',1.16),('15128','2013-10-22','16:20:00',1.29),('15128','2013-10-22','16:25:00',1.27),('15128','2013-10-22','16:30:00',1.39),('15128','2013-10-22','16:35:00',1.41),('15128','2013-10-22','16:40:00',1.25),('15128','2013-10-21','09:45:00',1.05),('15128','2013-10-21','09:50:00',1.11),('15128','2013-10-21','09:55:00',1.16),('15128','2013-10-21','10:00:00',1.23),('15128','2013-10-21','10:05:00',1.29),('15128','2013-10-21','10:10:00',1.35),('15128','2013-10-21','10:15:00',1.4),('15128','2013-10-21','10:20:00',1.46),('15128','2013-10-21','10:25:00',1.51),('15128','2013-10-21','10:30:00',1.56),('15128','2013-10-21','10:35:00',1.62),('15128','2013-10-21','10:40:00',1.64),('15128','2013-10-21','10:45:00',1.67),('15128','2013-10-21','10:50:00',1.72),('15128','2013-10-21','10:55:00',1.78),('15128','2013-10-21','11:00:00',1.81),('15128','2013-10-21','11:05:00',1.86),('15128','2013-10-21','11:10:00',1.87),('15128','2013-10-21','11:15:00',1.93),('15128','2013-10-21','11:20:00',2.02),('15128','2013-10-21','11:25:00',2.04),('15128','2013-10-21','11:30:00',2.05),('15128','2013-10-21','11:35:00',2.09),('15128','2013-10-21','11:40:00',2.14),('15128','2013-10-21','11:45:00',2.26),('15128','2013-10-21','11:50:00',2.3),('15128','2013-10-21','11:55:00',2.4),('15128','2013-10-21','12:00:00',2.5),('15128','2013-10-21','12:05:00',2.53),('15128','2013-10-21','12:10:00',2.54),('15128','2013-10-21','12:15:00',2.56),('15128','2013-10-21','12:20:00',2.6),('15128','2013-10-21','12:25:00',2.61),('15128','2013-10-21','12:30:00',2.5),('15128','2013-10-21','12:35:00',2.67),('15128','2013-10-21','12:40:00',2.77),('15128','2013-10-21','12:45:00',2.76),('15128','2013-10-21','12:50:00',2.8),('15128','2013-10-21','12:55:00',2.77),('15128','2013-10-21','13:00:00',2.68),('15128','2013-10-21','13:05:00',2.65),('15128','2013-10-21','13:10:00',2.74),('15128','2013-10-21','13:15:00',2.68),('15128','2013-10-21','13:20:00',2.71),('15128','2013-10-21','13:25:00',2.78),('15128','2013-10-21','13:30:00',2.75),('15128','2013-10-21','13:35:00',2.85),('15128','2013-10-21','13:40:00',2.93),('15128','2013-10-21','13:45:00',2.94),('15128','2013-10-21','13:50:00',3.05),('15128','2013-10-21','13:55:00',3.03),('15128','2013-10-21','14:00:00',3.04),('15128','2013-10-21','14:05:00',3.08),('15128','2013-10-21','14:10:00',2.96),('15128','2013-10-21','14:15:00',2.71),('15128','2013-10-21','14:20:00',2.72),('15128','2013-10-21','14:25:00',2.25),('15128','2013-10-21','14:30:00',2.53),('15128','2013-10-21','14:35:00',2.12),('15128','2013-10-21','14:40:00',2.56),('15128','2013-10-21','14:45:00',2.52),('15128','2013-10-21','14:50:00',2.57),('15128','2013-10-21','14:55:00',2.53),('15128','2013-10-21','15:00:00',2.46),('15128','2013-10-21','15:05:00',2.42),('15128','2013-10-21','15:10:00',2.33),('15128','2013-10-21','15:15:00',2.18),('15128','2013-10-21','15:20:00',2.25),('15128','2013-10-21','15:25:00',2.25),('15128','2013-10-21','15:30:00',2.08),('15128','2013-10-21','15:35:00',2.09),('15128','2013-10-21','15:40:00',2.05),('15128','2013-10-21','15:45:00',1.98),('15128','2013-10-21','15:50:00',1.9),('15128','2013-10-21','15:55:00',1.86),('15128','2013-10-21','16:00:00',1.83),('15128','2013-10-21','16:05:00',1.72),('15128','2013-10-21','16:10:00',1.66),('15128','2013-10-21','16:15:00',1.55),('15128','2013-10-21','16:20:00',1.48),('15128','2013-10-21','16:25:00',1.42),('15128','2013-10-21','16:30:00',1.35),('15128','2013-10-21','16:35:00',1.3),('15128','2013-10-21','16:40:00',1.23),('15128','2013-10-21','16:45:00',1.14),('15128','2013-10-21','16:50:00',1.06),('15128','2013-10-20','09:45:00',1.04),('15128','2013-10-20','09:50:00',1.15),('15128','2013-10-20','09:55:00',1.26),('15128','2013-10-20','10:00:00',1.34),('15128','2013-10-20','10:05:00',1.3),('15128','2013-10-20','10:10:00',1.36),('15128','2013-10-20','10:15:00',1.29),('15128','2013-10-20','10:20:00',1.61),('15128','2013-10-20','10:25:00',1.65),('15128','2013-10-20','10:30:00',1.64),('15128','2013-10-20','10:35:00',1.69),('15128','2013-10-20','10:40:00',1.75),('15128','2013-10-20','10:45:00',1.79),('15128','2013-10-20','10:50:00',1.85),('15128','2013-10-20','10:55:00',1.74),('15128','2013-10-20','11:00:00',1.88),('15128','2013-10-20','11:05:00',2.02),('15128','2013-10-20','11:10:00',2.06),('15128','2013-10-20','11:15:00',2.04),('15128','2013-10-20','11:20:00',2.09),('15128','2013-10-20','11:25:00',2.15),('15128','2013-10-20','11:30:00',2.18),('15128','2013-10-20','11:35:00',2.15),('15128','2013-10-20','11:40:00',2.23),('15128','2013-10-20','11:45:00',2.35),('15128','2013-10-20','11:50:00',2.43),('15128','2013-10-20','11:55:00',2.52),('15128','2013-10-20','12:00:00',2.64),('15128','2013-10-20','12:05:00',2.65),('15128','2013-10-20','12:10:00',2.66),('15128','2013-10-20','12:15:00',2.66),('15128','2013-10-20','12:20:00',2.68),('15128','2013-10-20','12:25:00',2.65),('15128','2013-10-20','12:30:00',2.74),('15128','2013-10-20','12:35:00',2.75),('15128','2013-10-20','12:40:00',2.81),('15128','2013-10-20','12:45:00',2.85),('15128','2013-10-20','12:50:00',2.84),('15128','2013-10-20','12:55:00',2.81),('15128','2013-10-20','13:00:00',2.77),('15128','2013-10-20','13:05:00',2.69),('15128','2013-10-20','13:10:00',2.84),('15128','2013-10-20','13:15:00',2.74),('15128','2013-10-20','13:20:00',2.72),('15128','2013-10-20','13:25:00',2.81),('15128','2013-10-20','13:30:00',2.85),('15128','2013-10-20','13:35:00',2.88),('15128','2013-10-20','13:40:00',2.84),('15128','2013-10-20','13:45:00',2.78),('15128','2013-10-20','13:50:00',2.78),('15128','2013-10-20','13:55:00',2.64),('15128','2013-10-20','14:00:00',2.83),('15128','2013-10-20','14:05:00',2.88),('15128','2013-10-20','14:10:00',2.87),('15128','2013-10-20','14:15:00',2.84),('15128','2013-10-20','14:20:00',2.79),('15128','2013-10-20','14:25:00',2.77),('15128','2013-10-20','14:30:00',2.74),('15128','2013-10-20','14:35:00',2.7),('15128','2013-10-20','14:40:00',2.65),('15128','2013-10-20','14:45:00',2.6),('15128','2013-10-20','14:50:00',2.6),('15128','2013-10-20','14:55:00',2.51),('15128','2013-10-20','15:00:00',2.48),('15128','2013-10-20','15:05:00',2.41),('15128','2013-10-20','15:10:00',2.3),('15128','2013-10-20','15:15:00',2.35),('15128','2013-10-20','15:20:00',2.37),('15128','2013-10-20','15:25:00',2.35),('15128','2013-10-20','15:30:00',2.31),('15128','2013-10-20','15:35:00',2.24),('15128','2013-10-20','15:40:00',2.17),('15128','2013-10-20','15:45:00',2.11),('15128','2013-10-20','15:50:00',2.05),('15128','2013-10-20','15:55:00',1.96),('15128','2013-10-20','16:00:00',1.92),('15128','2013-10-20','16:05:00',1.85),('15128','2013-10-20','16:10:00',1.81),('15128','2013-10-20','16:15:00',1.7),('15128','2013-10-20','16:20:00',1.57),('15128','2013-10-20','16:25:00',1.45),('15128','2013-10-20','16:30:00',1.42),('15128','2013-10-20','16:35:00',1.38),('15128','2013-10-20','16:40:00',1.37),('15128','2013-10-20','16:45:00',1.27),('15128','2013-10-20','16:50:00',1.04),('15128','2013-10-19','09:40:00',1.05),('15128','2013-10-19','09:45:00',1.11),('15128','2013-10-19','09:50:00',1.17),('15128','2013-10-19','09:55:00',1.25),('15128','2013-10-19','10:00:00',1.3),('15128','2013-10-19','10:05:00',1.37),('15128','2013-10-19','10:10:00',1.42),('15128','2013-10-19','10:15:00',1.42),('15128','2013-10-19','10:20:00',1.49),('15128','2013-10-19','10:25:00',1.56),('15128','2013-10-19','10:30:00',1.59),('15128','2013-10-19','10:35:00',1.64),('15128','2013-10-19','10:40:00',1.71),('15128','2013-10-19','10:45:00',1.77),('15128','2013-10-19','10:50:00',1.82),('15128','2013-10-19','10:55:00',1.88),('15128','2013-10-19','11:00:00',1.92),('15128','2013-10-19','11:05:00',1.98),('15128','2013-10-19','11:10:00',2),('15128','2013-10-19','11:15:00',2.05),('15128','2013-10-19','11:20:00',2.13),('15128','2013-10-19','11:25:00',2.2),('15128','2013-10-19','11:30:00',2.22),('15128','2013-10-19','11:35:00',2.29),('15128','2013-10-19','11:40:00',2.29),('15128','2013-10-19','11:45:00',2.37),('15128','2013-10-19','11:50:00',2.43),('15128','2013-10-19','11:55:00',2.56),('15128','2013-10-19','12:00:00',2.62),('15128','2013-10-19','12:05:00',2.53),('15128','2013-10-19','12:10:00',2.69),('15128','2013-10-19','12:15:00',2.66),('15128','2013-10-19','12:20:00',2.86),('15128','2013-10-19','12:25:00',2.91),('15128','2013-10-19','12:30:00',2.88),('15128','2013-10-19','12:35:00',2.88),('15128','2013-10-19','12:40:00',2),('15128','2013-10-19','12:45:00',2.21),('15128','2013-10-19','12:50:00',3),('15128','2013-10-19','12:55:00',1.39),('15128','2013-10-19','13:00:00',1.31),('15128','2013-10-19','13:05:00',1.89),('15128','2013-10-19','13:10:00',3.65),('15128','2013-10-19','13:15:00',3.65),('15128','2013-10-19','13:20:00',3.27),('15128','2013-10-19','13:25:00',2.71),('15128','2013-10-19','13:30:00',3.24),('15128','2013-10-19','13:35:00',3.21),('15128','2013-10-19','13:40:00',3.19),('15128','2013-10-19','13:45:00',3.33),('15128','2013-10-19','13:50:00',3.07),('15128','2013-10-19','13:55:00',3.26),('15128','2013-10-19','14:00:00',3.39),('15128','2013-10-19','14:05:00',3.34),('15128','2013-10-19','14:10:00',3.29),('15128','2013-10-19','14:15:00',3.3),('15128','2013-10-19','14:20:00',3.41),('15128','2013-10-19','14:25:00',3.27),('15128','2013-10-19','14:30:00',3.1),('15128','2013-10-19','14:35:00',3.03),('15128','2013-10-19','14:40:00',2.97),('15128','2013-10-19','14:45:00',2.9),('15128','2013-10-19','14:50:00',2.85),('15128','2013-10-19','14:55:00',2.81),('15128','2013-10-19','15:00:00',2.2),('15128','2013-10-19','15:05:00',2.73),('15128','2013-10-19','15:10:00',2.7),('15128','2013-10-19','15:15:00',2.62),('15128','2013-10-19','15:20:00',2.63),('15128','2013-10-19','15:25:00',2.64),('15128','2013-10-19','15:30:00',2.61),('15128','2013-10-19','15:35:00',2.61),('15128','2013-10-19','15:40:00',2.63),('15128','2013-10-19','15:45:00',2.2),('15128','2013-10-19','15:50:00',2.65),('15128','2013-10-19','15:55:00',2.16),('15128','2013-10-19','16:00:00',1.34),('15128','2013-10-19','16:05:00',2.19),('15128','2013-10-19','16:10:00',2.43),('15128','2013-10-19','16:15:00',2.24),('15128','2013-10-19','16:20:00',2.05),('15128','2013-10-19','16:25:00',1.85),('15128','2013-10-19','16:30:00',1.83),('15128','2013-10-19','16:35:00',1.67),('15128','2013-10-19','16:40:00',1.55),('15128','2013-10-19','16:45:00',1.42),('15128','2013-10-19','16:50:00',1.35),('15128','2013-10-19','16:55:00',1.23),('15128','2013-10-19','17:00:00',1.11),('15128','2013-10-18','09:30:00',1.13),('15128','2013-10-18','09:35:00',1.34),('15128','2013-10-18','09:40:00',1.44),('15128','2013-10-18','09:45:00',1.37),('15128','2013-10-18','09:50:00',1.5),('15128','2013-10-18','09:55:00',1.53),('15128','2013-10-18','10:00:00',1.52),('15128','2013-10-18','10:05:00',1.55),('15128','2013-10-18','10:10:00',1.56),('15128','2013-10-18','10:15:00',1.64),('15128','2013-10-18','10:20:00',1.68),('15128','2013-10-18','10:25:00',1.79),('15128','2013-10-18','10:30:00',1.81),('15128','2013-10-18','10:35:00',1.83),('15128','2013-10-18','10:40:00',1.86),('15128','2013-10-18','10:45:00',1.87),('15128','2013-10-18','10:50:00',1.84),('15128','2013-10-18','10:55:00',1.85),('15128','2013-10-18','11:00:00',1.7),('15128','2013-10-18','11:05:00',1.71),('15128','2013-10-18','11:10:00',1.9),('15128','2013-10-18','11:15:00',2.23),('15128','2013-10-18','11:20:00',2.31),('15128','2013-10-18','11:25:00',2.38),('15128','2013-10-18','11:30:00',2.36),('15128','2013-10-18','11:35:00',2.35),('15128','2013-10-18','11:40:00',2.47),('15128','2013-10-18','11:45:00',2.42),('15128','2013-10-18','11:50:00',2.51),('15128','2013-10-18','11:55:00',2.8),('15128','2013-10-18','12:00:00',2.93),('15128','2013-10-18','12:05:00',2.97),('15128','2013-10-18','12:10:00',3.03),('15128','2013-10-18','12:15:00',2.79),('15128','2013-10-18','12:20:00',2.98),('15128','2013-10-18','12:25:00',3.2),('15128','2013-10-18','12:30:00',3.21),('15128','2013-10-18','12:35:00',2.71),('15128','2013-10-18','12:40:00',3.72),('15128','2013-10-18','12:45:00',3.72),('15128','2013-10-18','12:50:00',3.74),('15128','2013-10-18','12:55:00',2.89),('15128','2013-10-18','13:00:00',3.48),('15128','2013-10-18','13:05:00',3.11),('15128','2013-10-18','13:10:00',2.81),('15128','2013-10-18','13:15:00',2.71),('15128','2013-10-18','13:20:00',2.74),('15128','2013-10-18','13:25:00',2.31),('15128','2013-10-18','13:30:00',2.58),('15128','2013-10-18','13:35:00',2.73),('15128','2013-10-18','13:40:00',3.21),('15128','2013-10-18','13:45:00',3.66),('15128','2013-10-18','13:50:00',3.11),('15128','2013-10-18','13:55:00',2.59),('15128','2013-10-18','14:00:00',2.7),('15128','2013-10-18','14:05:00',2.67),('15128','2013-10-18','14:10:00',2.69),('15128','2013-10-18','14:15:00',2.33),('15128','2013-10-18','14:20:00',3.23),('15128','2013-10-18','14:25:00',3.01),('15128','2013-10-18','14:30:00',3.05),('15128','2013-10-18','14:35:00',3.05),('15128','2013-10-18','14:40:00',2.97),('15128','2013-10-18','14:45:00',2.89),('15128','2013-10-18','14:50:00',2.88),('15128','2013-10-18','14:55:00',2.77),('15128','2013-10-18','15:00:00',2.78),('15128','2013-10-18','15:05:00',2.72),('15128','2013-10-18','15:10:00',2.57),('15128','2013-10-18','15:15:00',2.59),('15128','2013-10-18','15:20:00',2.65),('15128','2013-10-18','15:25:00',2.45),('15128','2013-10-18','15:30:00',2.38),('15128','2013-10-18','15:35:00',1.95),('15128','2013-10-18','15:40:00',2.33),('15128','2013-10-18','15:45:00',2.47),('15128','2013-10-18','15:50:00',2.49),('15128','2013-10-18','15:55:00',2.25),('15128','2013-10-18','16:00:00',2.14),('15128','2013-10-18','16:05:00',2.32),('15128','2013-10-18','16:10:00',1.62),('15128','2013-10-18','16:15:00',1.31),('15128','2013-10-18','16:20:00',1.71),('15128','2013-10-18','16:25:00',1.94),('15128','2013-10-18','16:30:00',1.62),('15128','2013-10-18','16:35:00',1.46),('15128','2013-10-18','16:40:00',1.79),('15128','2013-10-18','16:45:00',1.41),('15128','2013-10-18','16:50:00',1.3),('15128','2013-10-18','17:10:00',1.08),('15128','2013-10-18','17:15:00',1.08),('15128','2014-05-03','08:15:00',1.13),('15128','2014-05-03','08:20:00',1.19),('15128','2014-05-03','08:30:00',1.26),('15128','2014-05-03','09:05:00',1.02),('15128','2014-05-03','09:10:00',1.28),('15128','2014-05-03','09:15:00',1.34),('15128','2014-05-03','09:20:00',1.23),('15128','2014-05-03','09:25:00',1.78),('15128','2014-05-03','09:30:00',2.5),('15128','2014-05-03','09:35:00',2.23),('15128','2014-05-03','09:40:00',2.68),('15128','2014-05-03','09:45:00',1.43),('15128','2014-05-03','09:50:00',2.96),('15128','2014-05-03','09:55:00',2.43),('15128','2014-05-03','10:00:00',3.01),('15128','2014-05-03','10:05:00',2.56),('15128','2014-05-03','10:10:00',2.2),('15128','2014-05-03','10:15:00',1.75),('15128','2014-05-03','10:20:00',1.93),('15128','2014-05-03','10:25:00',1.85),('15128','2014-05-03','10:30:00',1.73),('15128','2014-05-03','10:35:00',1.92),('15128','2014-05-03','10:40:00',2.07),('15128','2014-05-03','10:45:00',1.9),('15128','2014-05-03','10:50:00',2.49),('15128','2014-05-03','10:55:00',3.29),('15128','2014-05-03','11:00:00',2.06),('15128','2014-05-03','11:05:00',3.65),('15128','2014-05-03','11:10:00',3.56),('15128','2014-05-03','11:15:00',3.55),('15128','2014-05-03','11:20:00',3.53),('15128','2014-05-03','11:25:00',3.57),('15128','2014-05-03','11:30:00',3.49),('15128','2014-05-03','11:35:00',2.47),('15128','2014-05-03','11:40:00',1.9),('15128','2014-05-03','11:45:00',2.22),('15128','2014-05-03','11:50:00',1.66),('15128','2014-05-03','11:55:00',2.04),('15128','2014-05-03','12:00:00',1.23),('15128','2014-05-03','12:05:00',2.74),('15128','2014-05-03','12:10:00',3.46),('15128','2014-05-03','12:15:00',4.58),('15128','2014-05-03','12:20:00',3.54),('15128','2014-05-03','12:25:00',1.97),('15128','2014-05-03','12:30:00',1.24),('15128','2014-05-03','12:35:00',1.26),('15128','2014-05-03','12:40:00',1.81),('15128','2014-05-03','12:45:00',2.27),('15128','2014-05-03','12:50:00',1.96),('15128','2014-05-03','12:55:00',1.55),('15128','2014-05-03','13:00:00',1.38),('15128','2014-05-03','13:05:00',1.35),('15128','2014-05-03','13:10:00',1.36),('15128','2014-05-03','13:15:00',1.32),('15128','2014-05-03','13:20:00',1.33),('15128','2014-05-03','13:25:00',1.39),('15128','2014-05-03','13:30:00',1.38),('15128','2014-05-03','13:35:00',1.44),('15128','2014-05-03','13:40:00',1.59),('15128','2014-05-03','13:45:00',2.7),('15128','2014-05-03','13:50:00',2.77),('15128','2014-05-03','13:55:00',1.35),('15128','2014-05-03','14:20:00',1.23),('15128','2014-05-03','14:25:00',1.3),('15128','2014-05-03','14:30:00',1.21),('15128','2014-05-03','14:35:00',1.44),('15128','2014-05-03','14:40:00',1.88),('15128','2014-05-03','14:45:00',2.31),('15128','2014-05-03','14:50:00',3.02),('15128','2014-05-03','14:55:00',2.08),('15128','2014-05-03','15:00:00',2.89),('15128','2014-05-03','15:05:00',2.62),('15128','2014-05-03','15:10:00',3.62),('15128','2014-05-03','15:15:00',4.06),('15128','2014-05-03','15:20:00',2.28),('15128','2014-05-03','15:25:00',1.47),('15128','2014-05-03','15:30:00',1.18),('15128','2014-05-03','15:35:00',1.16),('15128','2014-05-03','15:40:00',1.02),('15128','2014-05-03','17:35:00',1.19),('15128','2014-04-15','08:40:00',1.05),('15128','2014-04-15','08:45:00',1.17),('15128','2014-04-15','08:50:00',1.24),('15128','2014-04-15','08:55:00',1.32),('15128','2014-04-15','09:00:00',1.43),('15128','2014-04-15','09:05:00',1.49),('15128','2014-04-15','09:10:00',1.56),('15128','2014-04-15','09:15:00',1.61),('15128','2014-04-15','09:20:00',1.68),('15128','2014-04-15','09:25:00',1.78),('15128','2014-04-15','09:30:00',1.82),('15128','2014-04-15','09:35:00',1.57),('15128','2014-04-15','09:40:00',1.28),('15128','2014-04-15','09:45:00',1.52),('15128','2014-04-15','09:50:00',2.12),('15128','2014-04-15','09:55:00',2.28),('15128','2014-04-15','10:00:00',2.29),('15128','2014-04-15','10:05:00',2.31),('15128','2014-04-15','10:10:00',2.15),('15128','2014-04-15','10:15:00',2.41),('15128','2014-04-15','10:20:00',2.48),('15128','2014-04-15','10:25:00',2.63),('15128','2014-04-15','10:30:00',2.7),('15128','2014-04-15','10:35:00',2.84),('15128','2014-04-15','10:40:00',2.95),('15128','2014-04-15','10:55:00',2.36),('15128','2014-04-15','11:00:00',3.03),('15128','2014-04-15','11:05:00',2.02),('15128','2014-04-15','11:10:00',1.47),('15128','2014-04-15','11:15:00',2.25),('15128','2014-04-15','11:20:00',4.26),('15128','2014-04-15','11:25:00',4.15),('15128','2014-04-15','11:30:00',3.82),('15128','2014-04-15','11:35:00',1.43),('15128','2014-04-15','11:40:00',2.48),('15128','2014-04-15','11:45:00',1.66),('15128','2014-04-15','11:50:00',2.76),('15128','2014-04-15','11:55:00',1.74),('15128','2014-04-15','12:00:00',4.24),('15128','2014-04-15','12:05:00',4.71),('15128','2014-04-15','12:10:00',3.08),('15128','2014-04-15','12:15:00',2.27),('15128','2014-04-15','12:20:00',4.01),('15128','2014-04-15','12:25:00',4.99),('15128','2014-04-15','12:30:00',4.84),('15128','2014-04-15','12:35:00',4.43),('15128','2014-04-15','12:40:00',2.85),('15128','2014-04-15','12:45:00',5.04),('15128','2014-04-15','12:50:00',4.65),('15128','2014-04-15','12:55:00',2.9),('15128','2014-04-15','13:00:00',5.43),('15128','2014-04-15','13:05:00',2.25),('15128','2014-04-15','13:10:00',1.5),('15128','2014-04-15','13:15:00',1.4),('15128','2014-04-15','13:20:00',2.51),('15128','2014-04-15','13:25:00',2.05),('15128','2014-04-15','13:30:00',1.73),('15128','2014-04-15','13:35:00',1.95),('15128','2014-04-15','13:40:00',2.19),('15128','2014-04-15','13:45:00',4.77),('15128','2014-04-15','13:50:00',4.85),('15128','2014-04-15','13:55:00',3.45),('15128','2014-04-15','14:00:00',4.33),('15128','2014-04-15','14:05:00',5.03),('15128','2014-04-15','14:10:00',4.48),('15128','2014-04-15','14:15:00',2.61),('15128','2014-04-15','14:20:00',4.06),('15128','2014-04-15','14:25:00',4.59),('15128','2014-04-15','14:30:00',4.14),('15128','2014-04-15','14:35:00',4.06),('15128','2014-04-15','14:40:00',3.78),('15128','2014-04-15','14:45:00',4.6),('15128','2014-04-15','14:50:00',3.52),('15128','2014-04-15','14:55:00',4.43),('15128','2014-04-15','15:00:00',2.76),('15128','2014-04-15','15:05:00',2.02),('15128','2014-04-15','15:10:00',1.44),('15128','2014-04-15','15:15:00',1),('15128','2014-04-15','15:20:00',1.07),('15128','2014-04-15','15:25:00',1.11),('15128','2014-04-15','15:30:00',1.58),('15128','2014-04-15','15:35:00',1.45),('15128','2014-04-15','15:40:00',1.56),('15128','2014-04-15','15:45:00',1.61),('15128','2014-04-15','15:50:00',2.61),('15128','2014-04-15','16:00:00',3.47),('15128','2014-04-15','16:05:00',3.9),('15128','2014-04-15','16:10:00',3.78),('15128','2014-04-15','16:15:00',3.7),('15128','2014-04-15','16:20:00',3.54),('15128','2014-04-15','16:25:00',3.48),('15128','2014-04-15','16:30:00',3.55),('15128','2014-04-15','16:35:00',3.44),('15128','2014-04-15','16:40:00',3.37),('15128','2014-04-15','16:45:00',3.3),('15128','2014-04-15','16:50:00',3.22),('15128','2014-04-15','16:55:00',3.15),('15128','2014-04-15','17:00:00',3.08),('15128','2014-04-15','17:05:00',3),('15128','2014-04-15','17:10:00',2.92),('15128','2014-04-15','17:15:00',2.79),('15128','2014-04-15','17:20:00',2.65),('15128','2014-04-15','17:25:00',2.52),('15128','2014-04-15','17:30:00',2.4),('15128','2014-04-15','17:35:00',2.28),('15128','2014-04-15','17:40:00',2.2),('15128','2014-04-15','17:45:00',2.06),('15128','2014-04-15','17:50:00',1.99),('15128','2014-04-15','17:55:00',1.92),('15128','2014-04-15','18:00:00',1.89),('15128','2014-04-15','18:05:00',1.91),('15128','2014-04-15','18:10:00',1.73),('15128','2014-04-15','18:15:00',1.66),('15128','2014-04-15','18:20:00',1.55),('15128','2014-04-15','18:30:00',1.27),('15128','2014-04-15','18:35:00',1.34),('15128','2013-10-17','09:35:00',1.07),('15128','2013-10-17','09:40:00',1.17),('15128','2013-10-17','09:45:00',1.24),('15128','2013-10-17','09:50:00',1.3),('15128','2013-10-17','09:55:00',1.38),('15128','2013-10-17','10:00:00',1.42),('15128','2013-10-17','10:05:00',1.52),('15128','2013-10-17','10:10:00',1.56),('15128','2013-10-17','10:15:00',1.62),('15128','2013-10-17','10:20:00',1.63),('15128','2013-10-17','10:25:00',1.69),('15128','2013-10-17','10:30:00',1.76),('15128','2013-10-17','10:35:00',1.82),('15128','2013-10-17','10:40:00',1.85),('15128','2013-10-17','10:45:00',1.9),('15128','2013-10-17','10:50:00',1.98),('15128','2013-10-17','10:55:00',2.04),('15128','2013-10-17','11:00:00',2.05),('15128','2013-10-17','11:05:00',2.12),('15128','2013-10-17','11:10:00',1.86),('15128','2013-10-17','11:15:00',2.11),('15128','2013-10-17','11:20:00',1.92),('15128','2013-10-17','11:25:00',2.33),('15128','2013-10-17','11:30:00',2.35),('15128','2013-10-17','11:35:00',2.46),('15128','2013-10-17','11:40:00',2.37),('15128','2013-10-17','11:45:00',2.52),('15128','2013-10-17','11:50:00',2.55),('15128','2013-10-17','11:55:00',2.72),('15128','2013-10-17','12:00:00',2.8),('15128','2013-10-17','12:05:00',2.82),('15128','2013-10-17','12:10:00',2.85),('15128','2013-10-17','12:15:00',2.81),('15128','2013-10-17','12:20:00',2.9),('15128','2013-10-17','12:25:00',3.01),('15128','2013-10-17','12:30:00',2.98),('15128','2013-10-17','12:35:00',3),('15128','2013-10-17','12:40:00',3.06),('15128','2013-10-17','12:45:00',2.99),('15128','2013-10-17','12:50:00',2.98),('15128','2013-10-17','12:55:00',2.96),('15128','2013-10-17','13:00:00',2.95),('15128','2013-10-17','13:05:00',3.05),('15128','2013-10-17','13:10:00',3.12),('15128','2013-10-17','13:15:00',3.13),('15128','2013-10-17','13:20:00',3.15),('15128','2013-10-17','13:25:00',3.18),('15128','2013-10-17','13:30:00',3.19),('15128','2013-10-17','13:35:00',3.19),('15128','2013-10-17','13:40:00',3.16),('15128','2013-10-17','13:45:00',3.07),('15128','2013-10-17','13:50:00',3.12),('15128','2013-10-17','13:55:00',2.96),('15128','2013-10-17','14:00:00',3),('15128','2013-10-17','14:05:00',3.08),('15128','2013-10-17','14:10:00',3.07),('15128','2013-10-17','14:15:00',3.12),('15128','2013-10-17','14:20:00',3.13),('15128','2013-10-17','14:25:00',3.11),('15128','2013-10-17','14:30:00',3.02),('15128','2013-10-17','14:35:00',3),('15128','2013-10-17','14:40:00',2.96),('15128','2013-10-17','14:45:00',2.94),('15128','2013-10-17','14:50:00',2.94),('15128','2013-10-17','14:55:00',2.81),('15128','2013-10-17','15:00:00',2.57),('15128','2013-10-17','15:05:00',2.55),('15128','2013-10-17','15:10:00',2.59),('15128','2013-10-17','15:15:00',2.74),('15128','2013-10-17','15:20:00',2.63),('15128','2013-10-17','15:25:00',2.64),('15128','2013-10-17','15:30:00',2.62),('15128','2013-10-17','15:35:00',2.44),('15128','2013-10-17','15:40:00',2.29),('15128','2013-10-17','15:45:00',2.29),('15128','2013-10-17','15:50:00',2.24),('15128','2013-10-17','15:55:00',2.23),('15128','2013-10-17','16:00:00',2.16),('15128','2013-10-17','16:05:00',2.07),('15128','2013-10-17','16:10:00',1.93),('15128','2013-10-17','16:15:00',1.86),('15128','2013-10-17','16:20:00',1.42),('15128','2013-10-17','16:25:00',1.42),('15128','2013-10-17','16:30:00',1.27),('15128','2013-10-17','16:35:00',1.02),('15128','2013-10-17','16:50:00',1.16),('15128','2013-10-16','09:35:00',1.11),('15128','2013-10-16','09:40:00',1.18),('15128','2013-10-16','09:45:00',1.24),('15128','2013-10-16','09:50:00',1.3),('15128','2013-10-16','09:55:00',1.38),('15128','2013-10-16','10:00:00',1.42),('15128','2013-10-16','10:05:00',1.5),('15128','2013-10-16','10:10:00',1.53),('15128','2013-10-16','10:15:00',1.59),('15128','2013-10-16','10:20:00',1.63),('15128','2013-10-16','10:25:00',1.68),('15128','2013-10-16','10:30:00',1.77),('15128','2013-10-16','10:35:00',1.79),('15128','2013-10-16','10:40:00',1.86),('15128','2013-10-16','10:45:00',1.92),('15128','2013-10-16','10:50:00',1.97),('15128','2013-10-16','10:55:00',2.06),('15128','2013-10-16','11:00:00',2.07),('15128','2013-10-16','11:05:00',2.09),('15128','2013-10-16','11:10:00',2.11),('15128','2013-10-16','11:15:00',2.23),('15128','2013-10-16','11:20:00',2.31),('15128','2013-10-16','11:25:00',2.28),('15128','2013-10-16','11:30:00',2.41),('15128','2013-10-16','11:35:00',2.45),('15128','2013-10-16','11:40:00',2.41),('15128','2013-10-16','11:45:00',2.58),('15128','2013-10-16','11:50:00',2.66),('15128','2013-10-16','11:55:00',2.85),('15128','2013-10-16','12:00:00',2.92),('15128','2013-10-16','12:05:00',2.96),('15128','2013-10-16','12:10:00',2.99),('15128','2013-10-16','12:15:00',3.04),('15128','2013-10-16','12:20:00',3.08),('15128','2013-10-16','12:25:00',3.1),('15128','2013-10-16','12:30:00',3.14),('15128','2013-10-16','12:35:00',3.17),('15128','2013-10-16','12:40:00',3.2),('15128','2013-10-16','12:45:00',3.2),('15128','2013-10-16','12:50:00',3.23),('15128','2013-10-16','12:55:00',3.25),('15128','2013-10-16','13:00:00',3.29),('15128','2013-10-16','13:05:00',3.29),('15128','2013-10-16','13:10:00',3.3),('15128','2013-10-16','13:15:00',3.29),('15128','2013-10-16','13:20:00',3.29),('15128','2013-10-16','13:25:00',3.29),('15128','2013-10-16','13:30:00',3.28),('15128','2013-10-16','13:35:00',3.31),('15128','2013-10-16','13:40:00',3.3),('15128','2013-10-16','13:45:00',3.29),('15128','2013-10-16','13:50:00',3.29),('15128','2013-10-16','13:55:00',3.3),('15128','2013-10-16','14:00:00',3.29),('15128','2013-10-16','14:05:00',3.27),('15128','2013-10-16','14:10:00',3.24),('15128','2013-10-16','14:15:00',3.23),('15128','2013-10-16','14:20:00',3.22),('15128','2013-10-16','14:25:00',3.2),('15128','2013-10-16','14:30:00',3.17),('15128','2013-10-16','14:35:00',3.14),('15128','2013-10-16','14:40:00',3.11),('15128','2013-10-16','14:45:00',3.07),('15128','2013-10-16','14:50:00',3.04),('15128','2013-10-16','14:55:00',3.01),('15128','2013-10-16','15:00:00',2.98),('15128','2013-10-16','15:05:00',2.94),('15128','2013-10-16','15:10:00',2.88),('15128','2013-10-16','15:15:00',2.85),('15128','2013-10-16','15:20:00',2.81),('15128','2013-10-16','15:25:00',2.76),('15128','2013-10-16','15:30:00',2.71),('15128','2013-10-16','15:35:00',2.65),('15128','2013-10-16','15:40:00',2.58),('15128','2013-10-16','15:45:00',2.52),('15128','2013-10-16','15:50:00',2.46),('15128','2013-10-16','15:55:00',2.4),('15128','2013-10-16','16:00:00',2.35),('15128','2013-10-16','16:05:00',2.26),('15128','2013-10-16','16:10:00',2.2),('15128','2013-10-16','16:15:00',2.08),('15128','2013-10-16','16:20:00',2),('15128','2013-10-16','16:25:00',1.93),('15128','2013-10-16','16:30:00',1.82),('15128','2013-10-16','16:35:00',1.76),('15128','2013-10-16','16:40:00',1.69),('15128','2013-10-16','16:45:00',1.57),('15128','2013-10-16','16:50:00',1.53),('15128','2013-10-16','16:55:00',1.47),('15128','2013-10-16','17:00:00',1.41),('15128','2013-10-16','17:05:00',1.29),('15128','2013-10-16','17:10:00',1.18),('15128','2013-10-16','17:15:00',1.08),('15128','2013-10-15','09:40:00',1.44),('15128','2013-10-15','11:05:00',1.14),('15128','2013-10-15','11:40:00',1.01),('15128','2013-10-15','11:45:00',1.26),('15128','2013-10-15','12:05:00',1.21),('15128','2013-10-15','12:10:00',1.29),('15128','2013-10-15','12:15:00',1.53),('15128','2013-10-15','12:25:00',1.06),('15128','2013-10-15','12:30:00',1.43),('15128','2013-10-15','12:35:00',1.2),('15128','2013-10-15','12:40:00',1.11),('15128','2013-10-15','12:45:00',1.36),('15128','2013-10-15','12:50:00',1.32),('15128','2013-10-15','12:55:00',1.51),('15128','2013-10-15','13:00:00',1.5),('15128','2013-10-15','13:10:00',1.18),('15128','2013-10-15','13:15:00',2.33),('15128','2013-10-15','13:20:00',3.48),('15128','2013-10-15','13:25:00',3.41),('15128','2013-10-15','13:30:00',3.21),('15128','2013-10-15','13:35:00',1.53),('15128','2013-10-15','13:40:00',1.38),('15128','2013-10-15','13:45:00',3.08),('15128','2013-10-15','13:50:00',3.16),('15128','2013-10-15','13:55:00',1.06),('15128','2013-10-15','14:00:00',3.35),('15128','2013-10-15','14:05:00',3.34),('15128','2013-10-15','14:10:00',3.29),('15128','2013-10-15','14:15:00',3.07),('15128','2013-10-15','14:20:00',3.22),('15128','2013-10-15','14:25:00',2.67),('15128','2013-10-15','14:35:00',2.44),('15128','2013-10-15','14:40:00',3.16),('15128','2013-10-15','14:45:00',3.13),('15128','2013-10-15','14:50:00',3.18),('15128','2013-10-15','14:55:00',3.04),('15128','2013-10-15','15:00:00',3.05),('15128','2013-10-15','15:05:00',2.92),('15128','2013-10-15','15:10:00',2.91),('15128','2013-10-15','15:15:00',2.88),('15128','2013-10-15','15:20:00',2.8),('15128','2013-10-15','15:25:00',2.76),('15128','2013-10-15','15:30:00',2.76),('15128','2013-10-15','15:35:00',2.61),('15128','2013-10-15','15:40:00',2.54),('15128','2013-10-15','15:45:00',2.49),('15128','2013-10-15','15:50:00',2.43),('15128','2013-10-15','15:55:00',2.4),('15128','2013-10-15','16:00:00',2.13),('15128','2013-10-15','16:05:00',2.26),('15128','2013-10-15','16:10:00',2.15),('15128','2013-10-15','16:15:00',2.07),('15128','2013-10-15','16:20:00',1.98),('15128','2013-10-15','16:25:00',1.85),('15128','2013-10-15','16:30:00',1.67),('15128','2013-10-15','16:35:00',1.73),('15128','2013-10-15','16:40:00',1.65),('15128','2013-10-15','16:45:00',1.56),('15128','2013-10-15','16:50:00',1.46),('15128','2013-10-15','16:55:00',1.39),('15128','2013-10-15','17:00:00',1.36),('15128','2013-10-15','17:05:00',1.26),('15128','2013-10-15','17:10:00',1.13),('15128','2013-10-15','17:15:00',1.01),('15128','2013-10-14','09:45:00',1.08),('15128','2013-10-14','09:50:00',1.72),('15128','2013-10-14','09:55:00',1.8),('15128','2013-10-14','10:00:00',1.65),('15128','2013-10-14','10:05:00',1.66),('15128','2013-10-14','10:10:00',1.17),('15128','2013-10-14','10:15:00',1.21),('15128','2013-10-14','10:20:00',1.7),('15128','2013-10-14','10:25:00',1.97),('15128','2013-10-14','10:30:00',1.88),('15128','2013-10-14','10:35:00',2.2),('15128','2013-10-14','10:40:00',2.19),('15128','2013-10-14','10:45:00',1.74),('15128','2013-10-14','10:50:00',1.69),('15128','2013-10-14','10:55:00',1.71),('15128','2013-10-14','11:00:00',1.91),('15128','2013-10-14','11:05:00',2.49),('15128','2013-10-14','11:10:00',2.6),('15128','2013-10-14','11:15:00',2.33),('15128','2013-10-14','11:20:00',2.26),('15128','2013-10-14','11:25:00',2.35),('15128','2013-10-14','11:30:00',2.06),('15128','2013-10-14','11:35:00',1.6),('15128','2013-10-14','11:40:00',1.6),('15128','2013-10-14','11:45:00',1.68),('15128','2013-10-14','11:50:00',1.68),('15128','2013-10-14','11:55:00',1.56),('15128','2013-10-14','12:00:00',1.55),('15128','2013-10-14','12:05:00',1.53),('15128','2013-10-14','12:10:00',1.51),('15128','2013-10-14','12:15:00',1.54),('15128','2013-10-14','12:20:00',1.48),('15128','2013-10-14','12:25:00',1.39),('15128','2013-10-14','12:30:00',1.43),('15128','2013-10-14','12:35:00',1.46),('15128','2013-10-14','12:40:00',1.54),('15128','2013-10-14','12:45:00',1.39),('15128','2013-10-14','12:50:00',1.3),('15128','2013-10-14','12:55:00',1.3),('15128','2013-10-14','13:00:00',1.45),('15128','2013-10-14','13:05:00',1.7),('15128','2013-10-14','13:10:00',1.76),('15128','2013-10-14','13:15:00',2.56),('15128','2013-10-14','13:20:00',3.06),('15128','2013-10-14','13:25:00',1.86),('15128','2013-10-14','13:30:00',1.77),('15128','2013-10-14','13:35:00',1.72),('15128','2013-10-14','13:40:00',1.75),('15128','2013-10-14','13:45:00',1.51),('15128','2013-10-14','13:50:00',1.31),('15128','2013-10-14','13:55:00',1.22),('15128','2013-10-14','14:00:00',1.23),('15128','2013-10-14','14:05:00',1.36),('15128','2013-10-14','14:10:00',1.82),('15128','2013-10-14','14:15:00',2.08),('15128','2013-10-14','14:20:00',2.65),('15128','2013-10-14','14:25:00',2.05),('15128','2013-10-14','14:30:00',1.56),('15128','2013-10-14','14:35:00',2.21),('15128','2013-10-14','14:40:00',2.54),('15128','2013-10-14','14:45:00',2.56),('15128','2013-10-14','14:50:00',2.19),('15128','2013-10-14','14:55:00',1.55),('15128','2013-10-14','15:00:00',1.8),('15128','2013-10-14','15:05:00',1.52),('15128','2013-10-14','15:10:00',1.35),('15128','2013-10-14','15:15:00',1.11),('15128','2013-10-14','15:20:00',1.06),('15128','2013-10-14','15:25:00',1.07),('15128','2013-10-14','15:30:00',1.11),('15128','2013-10-14','15:35:00',1.21),('15128','2013-10-14','15:40:00',1.17),('15128','2013-10-14','15:45:00',1.04),('15128','2013-10-14','16:20:00',1.1),('15128','2013-10-14','16:25:00',1.33),('15128','2013-10-14','16:30:00',1.46),('15128','2013-10-14','16:35:00',1.17),('15128','2013-10-14','16:40:00',1.01),('15128','2013-10-14','16:50:00',1.01),('15128','2013-10-13','09:30:00',1.08),('15128','2013-10-13','09:45:00',1.05),('15128','2013-10-13','09:50:00',1.27),('15128','2013-10-13','09:55:00',1.29),('15128','2013-10-13','10:00:00',1.47),('15128','2013-10-13','10:05:00',1.5),('15128','2013-10-13','10:10:00',1.57),('15128','2013-10-13','10:15:00',1.61),('15128','2013-10-13','10:20:00',1.66),('15128','2013-10-13','10:25:00',1.73),('15128','2013-10-13','10:30:00',1.77),('15128','2013-10-13','10:35:00',1.79),('15128','2013-10-13','10:40:00',1.81),('15128','2013-10-13','10:45:00',1.85),('15128','2013-10-13','10:50:00',1.94),('15128','2013-10-13','10:55:00',2.02),('15128','2013-10-13','11:00:00',2.03),('15128','2013-10-13','11:05:00',2.04),('15128','2013-10-13','11:10:00',2.18),('15128','2013-10-13','11:15:00',2.14),('15128','2013-10-13','11:20:00',2.23),('15128','2013-10-13','11:25:00',2.3),('15128','2013-10-13','11:30:00',2.33),('15128','2013-10-13','11:35:00',2.36),('15128','2013-10-13','11:40:00',2.45),('15128','2013-10-13','11:45:00',2.41),('15128','2013-10-13','11:50:00',2.48),('15128','2013-10-13','11:55:00',2.64),('15128','2013-10-13','12:00:00',2.76),('15128','2013-10-13','12:05:00',2.8),('15128','2013-10-13','12:10:00',2.82),('15128','2013-10-13','12:15:00',2.71),('15128','2013-10-13','12:20:00',2.8),('15128','2013-10-13','12:25:00',2.92),('15128','2013-10-13','12:30:00',2.97),('15128','2013-10-13','12:35:00',3),('15128','2013-10-13','12:40:00',3.01),('15128','2013-10-13','12:45:00',3.02),('15128','2013-10-13','12:50:00',3.04),('15128','2013-10-13','12:55:00',3.04),('15128','2013-10-13','13:00:00',3.05),('15128','2013-10-13','13:05:00',3.06),('15128','2013-10-13','13:10:00',3.06),('15128','2013-10-13','13:15:00',3.05),('15128','2013-10-13','13:20:00',3.07),('15128','2013-10-13','13:25:00',3.07),('15128','2013-10-13','13:30:00',3.06),('15128','2013-10-13','13:35:00',3.07),('15128','2013-10-13','13:40:00',3.06),('15128','2013-10-13','13:45:00',3.06),('15128','2013-10-13','13:50:00',3.05),('15128','2013-10-13','13:55:00',3.04),('15128','2013-10-13','14:00:00',3.03),('15128','2013-10-13','14:05:00',3.03),('15128','2013-10-13','14:10:00',3.03),('15128','2013-10-13','14:15:00',3),('15128','2013-10-13','14:20:00',2.98),('15128','2013-10-13','14:25:00',2.97),('15128','2013-10-13','14:30:00',2.96),('15128','2013-10-13','14:35:00',2.94),('15128','2013-10-13','14:40:00',2.9),('15128','2013-10-13','14:45:00',2.87),('15128','2013-10-13','14:50:00',2.85),('15128','2013-10-13','14:55:00',2.81),('15128','2013-10-13','15:00:00',2.77),('15128','2013-10-13','15:05:00',2.74),('15128','2013-10-13','15:10:00',2.69),('15128','2013-10-13','15:15:00',2.64),('15128','2013-10-13','15:20:00',2.61),('15128','2013-10-13','15:25:00',2.57),('15128','2013-10-13','15:30:00',2.51),('15128','2013-10-13','15:35:00',2.46),('15128','2013-10-13','15:40:00',2.36),('15128','2013-10-13','15:45:00',2.03),('15128','2013-10-13','15:50:00',1.32),('15128','2013-10-13','15:55:00',1.71),('15128','2013-10-13','16:05:00',1.1),('15128','2013-10-13','16:10:00',1.5),('15128','2013-10-13','16:15:00',1.02),('15128','2013-10-13','16:20:00',1.06),('15128','2013-10-13','16:35:00',1.06),('15128','2013-10-13','16:40:00',1.63),('15128','2013-10-13','16:45:00',1.15),('15128','2013-10-12','09:35:00',1.04),('15128','2013-10-12','09:40:00',1.39),('15128','2013-10-12','09:45:00',1.54),('15128','2013-10-12','09:50:00',1.87),('15128','2013-10-12','09:55:00',1.46),('15128','2013-10-12','10:00:00',1.47),('15128','2013-10-12','10:05:00',1.47),('15128','2013-10-12','10:10:00',1.65),('15128','2013-10-12','10:15:00',1.39),('15128','2013-10-12','10:20:00',1.23),('15128','2013-10-12','10:25:00',1.44),('15128','2013-10-12','10:30:00',2.14),('15128','2013-10-12','10:35:00',2.74),('15128','2013-10-12','10:40:00',2.44),('15128','2013-10-12','10:45:00',2.64),('15128','2013-10-12','10:50:00',1.94),('15128','2013-10-12','10:55:00',1.91),('15128','2013-10-12','11:00:00',1.79),('15128','2013-10-12','11:05:00',1.88),('15128','2013-10-12','11:10:00',2.21),('15128','2013-10-12','11:15:00',2.32),('15128','2013-10-12','11:20:00',2.39),('15128','2013-10-12','11:25:00',2.27),('15128','2013-10-12','11:30:00',2.25),('15128','2013-10-12','11:35:00',2.49),('15128','2013-10-12','11:40:00',2.5),('15128','2013-10-12','11:45:00',2.52),('15128','2013-10-12','11:50:00',2.47),('15128','2013-10-12','11:55:00',2.74),('15128','2013-10-12','12:00:00',2.85),('15128','2013-10-12','12:05:00',2.89),('15128','2013-10-12','12:10:00',2.91),('15128','2013-10-12','12:15:00',2.95),('15128','2013-10-12','12:20:00',3),('15128','2013-10-12','12:25:00',2.95),('15128','2013-10-12','12:30:00',2.89),('15128','2013-10-12','12:35:00',3.12),('15128','2013-10-12','12:40:00',3.08),('15128','2013-10-12','12:45:00',3.07),('15128','2013-10-12','12:50:00',3.09),('15128','2013-10-12','12:55:00',3.11),('15128','2013-10-12','13:00:00',3.1),('15128','2013-10-12','13:05:00',3.16),('15128','2013-10-12','13:10:00',3.23),('15128','2013-10-12','13:15:00',3.26),('15128','2013-10-12','13:20:00',3.13),('15128','2013-10-12','13:25:00',3.16),('15128','2013-10-12','13:30:00',3.19),('15128','2013-10-12','13:35:00',3.27),('15128','2013-10-12','13:40:00',3.33),('15128','2013-10-12','13:45:00',3.17),('15128','2013-10-12','13:50:00',3.23),('15128','2013-10-12','13:55:00',3.3),('15128','2013-10-12','14:00:00',2.44),('15128','2013-10-12','14:05:00',3.56),('15128','2013-10-12','14:10:00',3.1),('15128','2013-10-12','14:15:00',3.44),('15128','2013-10-12','14:20:00',3.44),('15128','2013-10-12','14:25:00',3.33),('15128','2013-10-12','14:30:00',2.99),('15128','2013-10-12','14:35:00',2.11),('15128','2013-10-12','14:40:00',2.44),('15128','2013-10-12','14:45:00',2.81),('15128','2013-10-12','14:50:00',2.72),('15128','2013-10-12','14:55:00',2.7),('15128','2013-10-12','15:00:00',2.5),('15128','2013-10-12','15:05:00',2.99),('15128','2013-10-12','15:10:00',2.82),('15128','2013-10-12','15:15:00',2.85),('15128','2013-10-12','15:20:00',2.5),('15128','2013-10-12','15:25:00',2.29),('15128','2013-10-12','15:30:00',1.97),('15128','2013-10-12','15:35:00',1.77),('15128','2013-10-12','15:40:00',1.46),('15128','2013-10-12','15:45:00',1.81),('15128','2013-10-12','15:50:00',1.81),('15128','2013-10-12','15:55:00',2.19),('15128','2013-10-12','16:00:00',2.16),('15128','2013-10-12','16:05:00',2.45),('15128','2013-10-12','16:10:00',2.24),('15128','2013-10-12','16:15:00',2.21),('15128','2013-10-12','16:20:00',1.99),('15128','2013-10-12','16:25:00',1.65),('15128','2013-10-12','16:30:00',1.38),('15128','2013-10-12','16:35:00',1.64),('15128','2013-10-12','16:40:00',1.13),('15128','2013-10-12','16:45:00',1.1),('15128','2013-10-12','17:20:00',1.09),('15128','2013-10-11','11:15:00',1.11),('15128','2013-10-11','11:20:00',1.35),('15128','2013-10-11','11:25:00',1.4),('15128','2013-10-11','11:30:00',1.87),('15128','2013-10-11','11:35:00',1.92),('15128','2013-10-11','11:40:00',1.55),('15128','2013-10-11','11:45:00',1.34),('15128','2013-10-11','11:50:00',1.13),('15128','2013-10-11','12:10:00',1.2),('15128','2013-10-11','12:15:00',1.5),('15128','2013-10-11','12:20:00',2.93),('15128','2013-10-11','12:25:00',2.91),('15128','2013-10-11','12:30:00',2.76),('15128','2013-10-11','12:35:00',3.26),('15128','2013-10-11','12:40:00',3.07),('15128','2013-10-11','12:45:00',3.11),('15128','2013-10-11','12:50:00',2.9),('15128','2013-10-11','12:55:00',2.79),('15128','2013-10-11','13:00:00',2.62),('15128','2013-10-11','13:15:00',1.1),('15128','2013-10-11','13:20:00',1.41),('15128','2013-10-11','13:25:00',1.49),('15128','2013-10-11','15:50:00',1),('15128','2013-10-11','16:15:00',1.44),('15128','2013-10-11','16:20:00',1.64),('15128','2013-10-11','16:25:00',1.6),('15128','2013-10-11','16:30:00',1.3),('15128','2013-10-11','16:35:00',1.44),('15128','2013-10-11','16:40:00',1.52),('15128','2013-10-11','17:00:00',1.02),('15128','2013-10-10','09:25:00',1.13),('15128','2013-10-10','09:30:00',1.2),('15128','2013-10-10','09:35:00',1.31),('15128','2013-10-10','09:40:00',1.39),('15128','2013-10-10','09:45:00',1.44),('15128','2013-10-10','09:50:00',1.48),('15128','2013-10-10','09:55:00',1.54),('15128','2013-10-10','10:00:00',1.59),('15128','2013-10-10','10:05:00',1.69),('15128','2013-10-10','10:10:00',1.79),('15128','2013-10-10','10:15:00',1.52),('15128','2013-10-10','10:20:00',1.22),('15128','2013-10-10','10:25:00',1.6),('15128','2013-10-10','10:30:00',1.32),('15128','2013-10-10','10:35:00',1.79),('15128','2013-10-10','10:40:00',1.07),('15128','2013-10-10','10:45:00',1.89),('15128','2013-10-10','10:50:00',1.32),('15128','2013-10-10','10:55:00',1.26),('15128','2013-10-10','11:00:00',2.25),('15128','2013-10-10','11:05:00',2.64),('15128','2013-10-10','11:10:00',1.4),('15128','2013-10-10','11:15:00',1.48),('15128','2013-10-10','11:20:00',1.38),('15128','2013-10-10','11:25:00',1.22),('15128','2013-10-10','11:30:00',1.19),('15128','2013-10-10','11:35:00',1.43),('15128','2013-10-10','11:40:00',1.27),('15128','2013-10-10','11:45:00',1.21),('15128','2013-10-10','12:10:00',3.07),('15128','2013-10-10','12:15:00',3.54),('15128','2013-10-10','12:20:00',3.95),('15128','2013-10-10','12:25:00',1.49),('15128','2013-10-10','12:30:00',1.33),('15128','2013-10-10','12:50:00',1.96),('15128','2013-10-10','12:55:00',3.05),('15128','2013-10-10','13:00:00',1.92),('15128','2013-10-10','13:05:00',1.84),('15128','2013-10-10','13:20:00',1.08),('15128','2013-10-10','13:25:00',1.14),('15128','2013-10-10','13:30:00',3.87),('15128','2013-10-10','13:35:00',2.54),('15128','2013-10-10','13:45:00',1.06),('15128','2013-10-10','13:50:00',2.49),('15128','2013-10-10','13:55:00',1.17),('15128','2013-10-10','14:35:00',1.2),('15128','2013-10-10','14:40:00',1.78),('15128','2013-10-10','14:45:00',1.18),('15128','2013-10-10','14:50:00',1.12),('15128','2013-10-10','14:55:00',1.09),('15128','2013-10-10','16:50:00',1.14),('15128','2013-10-10','16:55:00',1.07),('15128','2013-10-10','17:10:00',1.32),('15128','2013-10-10','17:15:00',1.35),('15128','2013-10-10','17:20:00',1.08),('15128','2013-10-09','09:25:00',1.01),('15128','2013-10-09','09:30:00',1.11),('15128','2013-10-09','09:35:00',1.2),('15128','2013-10-09','09:40:00',1.28),('15128','2013-10-09','09:45:00',1.36),('15128','2013-10-09','09:50:00',1.38),('15128','2013-10-09','09:55:00',1.41),('15128','2013-10-09','10:00:00',1.5),('15128','2013-10-09','10:05:00',1.57),('15128','2013-10-09','10:10:00',1.72),('15128','2013-10-09','10:15:00',1.84),('15128','2013-10-09','10:20:00',1.64),('15128','2013-10-09','10:25:00',2.11),('15128','2013-10-09','10:30:00',2.04),('15128','2013-10-09','10:35:00',1.65),('15128','2013-10-09','10:45:00',2.26),('15128','2013-10-09','10:50:00',2.3),('15128','2013-10-09','10:55:00',2.45),('15128','2013-10-09','11:00:00',2.77),('15128','2013-10-09','11:05:00',1.45),('15128','2013-10-09','11:10:00',2.25),('15128','2013-10-09','11:20:00',2.92),('15128','2013-10-09','11:25:00',2.73),('15128','2013-10-09','11:30:00',2.06),('15128','2013-10-09','11:35:00',2.05),('15128','2013-10-09','11:40:00',3.07),('15128','2013-10-09','11:45:00',3.91),('15128','2013-10-09','11:50:00',2.1),('15128','2013-10-09','11:55:00',2.39),('15128','2013-10-09','12:00:00',2.79),('15128','2013-10-09','12:05:00',4.29),('15128','2013-10-09','12:10:00',4.01),('15128','2013-10-09','12:15:00',3.71),('15128','2013-10-09','12:20:00',2.43),('15128','2013-10-09','12:25:00',3.13),('15128','2013-10-09','12:30:00',1.06),('15128','2013-10-09','12:35:00',3.75),('15128','2013-10-09','12:40:00',3.88),('15128','2013-10-09','12:45:00',3.18),('15128','2013-10-09','12:50:00',3.65),('15128','2013-10-09','12:55:00',3.98),('15128','2013-10-09','13:00:00',2.51),('15128','2013-10-09','13:05:00',3.98),('15128','2013-10-09','13:10:00',2.17),('15128','2013-10-09','13:15:00',3.82),('15128','2013-10-09','13:20:00',3.71),('15128','2013-10-09','13:25:00',3.76),('15128','2013-10-09','13:30:00',3.78),('15128','2013-10-09','13:35:00',3.81),('15128','2013-10-09','13:40:00',3.84),('15128','2013-10-09','13:45:00',3.88),('15128','2013-10-09','13:50:00',3.65),('15128','2013-10-09','13:55:00',3),('15128','2013-10-09','14:00:00',1.03),('15128','2013-10-09','14:05:00',2.8),('15128','2013-10-09','14:10:00',2.24),('15128','2013-10-09','14:15:00',1.56),('15128','2013-10-09','14:20:00',2.26),('15128','2013-10-09','14:25:00',2.94),('15128','2013-10-09','14:30:00',3.69),('15128','2013-10-09','14:35:00',1.15),('15128','2013-10-09','14:40:00',2.56),('15128','2013-10-09','14:45:00',1.1),('15128','2013-10-09','14:50:00',2.33),('15128','2013-10-09','14:55:00',3.66),('15128','2013-10-09','15:00:00',2.51),('15128','2013-10-09','15:05:00',2.86),('15128','2013-10-09','15:10:00',3),('15128','2013-10-09','15:15:00',1.45),('15128','2013-10-09','15:25:00',2.68),('15128','2013-10-09','15:35:00',1.79),('15128','2013-10-09','15:40:00',1.54),('15128','2013-10-09','15:45:00',1.73),('15128','2013-10-09','15:50:00',1.05),('15128','2013-10-09','15:55:00',1.58),('15128','2013-10-09','16:00:00',3.07),('15128','2013-10-09','16:05:00',2),('15128','2013-10-09','16:10:00',2.51),('15128','2013-10-09','16:15:00',2.09),('15128','2013-10-09','16:20:00',2.37),('15128','2013-10-09','16:25:00',2.25),('15128','2013-10-09','16:30:00',2.17),('15128','2013-10-09','16:35:00',2.11),('15128','2013-10-09','16:45:00',1.68),('15128','2013-10-09','16:50:00',2),('15128','2013-10-09','16:55:00',1.9),('15128','2013-10-09','17:00:00',1.47),('15128','2013-10-09','17:05:00',1.02),('15128','2013-10-09','17:10:00',1.51),('15128','2013-10-09','17:15:00',1.34),('15128','2013-10-09','17:20:00',1.02),('15128','2013-10-08','09:20:00',1.09),('15128','2013-10-08','09:25:00',1.2),('15128','2013-10-08','09:30:00',1.39),('15128','2013-10-08','09:35:00',1.58),('15128','2013-10-08','09:40:00',1.86),('15128','2013-10-08','09:45:00',1.96),('15128','2013-10-08','09:50:00',1.93),('15128','2013-10-08','09:55:00',2.03),('15128','2013-10-08','10:00:00',1.75),('15128','2013-10-08','10:05:00',1.53),('15128','2013-10-08','10:15:00',1.18),('15128','2013-10-08','10:20:00',1.58),('15128','2013-10-08','10:25:00',1.57),('15128','2013-10-08','10:30:00',1.94),('15128','2013-10-08','10:35:00',1.87),('15128','2013-10-08','11:00:00',1.51),('15128','2013-10-08','11:15:00',1.05),('15128','2013-10-08','11:20:00',2.16),('15128','2013-10-08','11:25:00',1.1),('15128','2013-10-08','11:30:00',1.72),('15128','2013-10-08','11:40:00',1.49),('15128','2013-10-08','11:45:00',1.73),('15128','2013-10-08','11:50:00',1.3),('15128','2013-10-08','11:55:00',1.52),('15128','2013-10-08','12:00:00',1.99),('15128','2013-10-08','12:05:00',1.33),('15128','2013-10-08','12:25:00',1.66),('15128','2013-10-08','12:30:00',3.12),('15128','2013-10-08','12:35:00',2.96),('15128','2013-10-08','12:40:00',2.15),('15128','2013-10-08','12:45:00',1.36),('15128','2013-10-08','12:50:00',1.05),('15128','2013-10-08','12:55:00',1.12),('15128','2013-10-08','13:00:00',1.85),('15128','2013-10-08','13:05:00',2.86),('15128','2013-10-08','13:10:00',2.93),('15128','2013-10-08','13:15:00',3.94),('15128','2013-10-08','13:20:00',3.67),('15128','2013-10-08','13:25:00',2.43),('15128','2013-10-08','13:30:00',3.34),('15128','2013-10-08','13:35:00',3.83),('15128','2013-10-08','13:40:00',3.82),('15128','2013-10-08','13:45:00',3.81),('15128','2013-10-08','13:50:00',3.78),('15128','2013-10-08','13:55:00',3.73),('15128','2013-10-08','14:00:00',3.55),('15128','2013-10-08','14:05:00',3.71),('15128','2013-10-08','14:10:00',2.21),('15128','2013-10-08','14:15:00',2.33),('15128','2013-10-08','14:20:00',2.95),('15128','2013-10-08','14:25:00',1.61),('15128','2013-10-08','14:30:00',2.86),('15128','2013-10-08','14:35:00',3.83),('15128','2013-10-08','14:40:00',3.64),('15128','2013-10-08','14:45:00',1.5),('15128','2013-10-08','14:50:00',2.43),('15128','2013-10-08','14:55:00',2.31),('15128','2013-10-08','15:00:00',3.7),('15128','2013-10-08','15:05:00',3.42),('15128','2013-10-08','15:10:00',2.09),('15128','2013-10-08','15:15:00',1.55),('15128','2013-10-08','15:20:00',1.61),('15128','2013-10-08','15:25:00',2.87),('15128','2013-10-08','15:30:00',1.33),('15128','2013-10-08','15:45:00',1.74),('15128','2013-10-08','15:50:00',2.16),('15128','2013-10-08','15:55:00',2.58),('15128','2013-10-08','16:00:00',1.13),('15128','2013-10-08','16:05:00',1.03),('15128','2013-10-08','16:10:00',1.35),('15128','2013-10-08','16:15:00',1.96),('15128','2013-10-08','16:20:00',2.5),('15128','2013-10-08','16:25:00',1.22),('15128','2013-10-08','16:40:00',1.99),('15128','2014-04-14','08:55:00',1.33),('15128','2014-04-14','09:05:00',1.5),('15128','2014-04-14','09:10:00',1.49),('15128','2014-04-14','09:15:00',1.66),('15128','2014-04-14','09:20:00',1.22),('15128','2014-04-14','09:25:00',1.11),('15128','2014-04-14','09:30:00',1.3),('15128','2014-04-14','09:35:00',1.36),('15128','2014-04-14','09:40:00',1.15),('15128','2014-04-14','09:45:00',1.76),('15128','2014-04-14','09:50:00',1.41),('15128','2014-04-14','10:05:00',1.88),('15128','2014-04-14','10:10:00',1.16),('15128','2014-04-14','10:15:00',1.59),('15128','2014-04-14','10:20:00',2.14),('15128','2014-04-14','10:25:00',1.47),('15128','2014-04-14','10:30:00',2.1),('15128','2014-04-14','10:35:00',2.74),('15128','2014-04-14','10:40:00',1.83),('15128','2014-04-14','10:45:00',1.85),('15128','2014-04-14','10:50:00',3.16),('15128','2014-04-14','10:55:00',1.95),('15128','2014-04-14','11:00:00',1.85),('15128','2014-04-14','11:05:00',2.94),('15128','2014-04-14','11:10:00',2.11),('15128','2014-04-14','11:15:00',2.21),('15128','2014-04-14','11:20:00',1.02),('15128','2014-04-14','11:25:00',1.35),('15128','2014-04-14','11:30:00',1.38),('15128','2014-04-14','11:35:00',1.22),('15128','2014-04-14','11:40:00',1.32),('15128','2014-04-14','11:45:00',1.31),('15128','2014-04-14','11:50:00',1.4),('15128','2014-04-14','11:55:00',2),('15128','2014-04-14','12:00:00',1.05),('15128','2014-04-14','12:10:00',1.4),('15128','2014-04-14','12:15:00',3.24),('15128','2014-04-14','12:20:00',2.74),('15128','2014-04-14','12:25:00',1.05),('15128','2014-04-14','12:45:00',1.07),('15128','2014-04-14','13:05:00',1.57),('15128','2014-04-14','13:10:00',1.6),('15128','2014-04-14','13:15:00',1.62),('15128','2014-04-14','13:20:00',1.83),('15128','2014-04-14','13:30:00',1.09),('15128','2014-04-14','13:35:00',1.67),('15128','2014-04-14','13:45:00',2.82),('15128','2014-04-14','13:50:00',4.34),('15128','2014-04-14','13:55:00',3.83),('15128','2014-04-14','14:00:00',2.6),('15128','2014-04-14','14:05:00',2.6),('15128','2014-04-14','14:10:00',2.55),('15128','2014-04-14','14:15:00',2.69),('15128','2014-04-14','14:20:00',2.7),('15128','2014-04-14','14:25:00',3.74),('15128','2014-04-14','14:30:00',1.76),('15128','2014-04-14','14:35:00',1.3),('15128','2014-04-14','14:40:00',2.27),('15128','2014-04-14','14:45:00',1.87),('15128','2014-04-14','14:50:00',2.22),('15128','2014-04-14','14:55:00',2.63),('15128','2014-04-14','15:00:00',2.85),('15128','2014-04-14','15:05:00',2.38),('15128','2014-04-14','15:10:00',2.67),('15128','2014-04-14','15:15:00',3.91),('15128','2014-04-14','15:20:00',4.42),('15128','2014-04-14','15:25:00',2.71),('15128','2014-04-14','15:30:00',2.47),('15128','2014-04-14','15:35:00',1.92),('15128','2014-04-14','15:40:00',1.7),('15128','2014-04-14','15:45:00',1.9),('15128','2014-04-14','15:50:00',1.43),('15128','2014-04-14','15:55:00',1.25),('15128','2014-04-14','16:00:00',1.19),('15128','2014-04-14','16:05:00',1.18),('15128','2014-04-14','16:10:00',1.15),('15128','2013-10-07','09:50:00',1.45),('15128','2013-10-07','09:55:00',1.38),('15128','2013-10-07','10:00:00',2.24),('15128','2013-10-07','10:05:00',2.27),('15128','2013-10-07','10:10:00',1.32),('15128','2013-10-07','10:55:00',1.11),('15128','2013-10-07','11:00:00',1.13),('15128','2013-10-07','11:05:00',1.07),('15128','2013-10-07','11:25:00',1.16),('15128','2013-10-07','12:35:00',1.5),('15128','2013-10-07','12:40:00',1.54),('15128','2013-10-07','12:45:00',1.06),('15128','2013-10-07','12:50:00',1.08),('15128','2013-10-07','12:55:00',1.28),('15128','2013-10-07','13:00:00',1.18),('15128','2013-10-07','13:05:00',2.06),('15128','2013-10-07','13:10:00',3.9),('15128','2013-10-07','13:15:00',1.78),('15128','2013-10-07','13:20:00',1.56),('15128','2013-10-07','13:25:00',2.5),('15128','2013-10-07','13:30:00',1.35),('15128','2013-10-07','13:45:00',1.1),('15128','2013-10-07','13:50:00',1.16),('15128','2013-10-07','13:55:00',1.16),('15128','2013-10-07','14:25:00',1.23),('15128','2013-10-07','14:30:00',2.26),('15128','2013-10-07','14:35:00',4.26),('15128','2013-10-07','14:40:00',3.69),('15128','2013-10-07','14:45:00',3.36),('15128','2013-10-07','14:50:00',3.43),('15128','2013-10-07','14:55:00',3.39),('15128','2013-10-07','15:00:00',3.31),('15128','2013-10-07','15:05:00',3.3),('15128','2013-10-07','15:10:00',1.76),('15128','2013-10-07','15:15:00',2.17),('15128','2013-10-06','09:20:00',1.13),('15128','2013-10-06','09:25:00',1.11),('15128','2013-10-06','09:30:00',1.21),('15128','2013-10-06','09:35:00',1.32),('15128','2013-10-06','09:40:00',1.37),('15128','2013-10-06','09:45:00',1.41),('15128','2013-10-06','09:50:00',1.35),('15128','2013-10-06','09:55:00',1.54),('15128','2013-10-06','10:00:00',1.58),('15128','2013-10-06','10:05:00',1.63),('15128','2013-10-06','10:10:00',1.67),('15128','2013-10-06','10:15:00',1.71),('15128','2013-10-06','10:20:00',1.76),('15128','2013-10-06','10:25:00',1.81),('15128','2013-10-06','10:30:00',1.84),('15128','2013-10-06','10:35:00',1.93),('15128','2013-10-06','10:40:00',1.99),('15128','2013-10-06','10:45:00',2.07),('15128','2013-10-06','10:50:00',2.1),('15128','2013-10-06','10:55:00',2.11),('15128','2013-10-06','11:00:00',2.29),('15128','2013-10-06','11:05:00',2.26),('15128','2013-10-06','11:10:00',2.13),('15128','2013-10-06','11:15:00',2.38),('15128','2013-10-06','11:20:00',2.43),('15128','2013-10-06','11:25:00',2.51),('15128','2013-10-06','11:30:00',2.57),('15128','2013-10-06','11:35:00',2.59),('15128','2013-10-06','11:40:00',2.76),('15128','2013-10-06','11:45:00',2.92),('15128','2013-10-06','11:50:00',3.02),('15128','2013-10-06','11:55:00',2.28),('15128','2013-10-06','12:00:00',2.94),('15128','2013-10-06','12:05:00',3.55),('15128','2013-10-06','12:10:00',3.66),('15128','2013-10-06','12:15:00',3.85),('15128','2013-10-06','12:20:00',3.68),('15128','2013-10-06','12:25:00',1.73),('15128','2013-10-06','12:30:00',1.26),('15128','2013-10-06','12:35:00',1.65),('15128','2013-10-06','12:40:00',1.07),('15128','2013-10-06','12:55:00',1.76),('15128','2013-10-06','13:00:00',4.34),('15128','2013-10-06','13:05:00',3.48),('15128','2013-10-06','13:10:00',2.5),('15128','2013-10-06','13:15:00',3.87),('15128','2013-10-06','13:20:00',3.19),('15128','2013-10-06','13:25:00',1.12),('15128','2013-10-06','13:30:00',2.7),('15128','2013-10-06','13:40:00',1.49),('15128','2013-10-06','13:45:00',2.59),('15128','2013-10-06','14:00:00',3.63),('15128','2013-10-06','14:05:00',1.51),('15128','2013-10-06','14:10:00',4.23),('15128','2013-10-06','14:15:00',3.7),('15128','2013-10-06','14:20:00',4.22),('15128','2013-10-06','14:25:00',1.88),('15128','2013-10-06','14:30:00',3.57),('15128','2013-10-06','14:35:00',3.05),('15128','2013-10-06','14:40:00',1.24),('15128','2013-10-06','14:45:00',2.31),('15128','2013-10-06','14:50:00',2.18),('15128','2013-10-06','14:55:00',2.33),('15128','2013-10-06','15:00:00',2.27),('15128','2013-10-06','15:05:00',1.11),('15128','2013-10-06','15:10:00',2.35),('15128','2013-10-06','15:15:00',1.72),('15128','2013-10-06','15:20:00',1.73),('15128','2013-10-06','15:25:00',3.47),('15128','2013-10-06','15:30:00',2.51),('15128','2013-10-06','15:35:00',2.84),('15128','2013-10-06','15:40:00',2.49),('15128','2013-10-06','15:45:00',2.33),('15128','2013-10-06','15:50:00',2.37),('15128','2013-10-06','15:55:00',2.94),('15128','2013-10-06','16:00:00',1.48),('15128','2013-10-06','16:05:00',2.62),('15128','2013-10-06','16:10:00',2.52),('15128','2013-10-06','16:15:00',2.55),('15128','2013-10-06','16:20:00',2.35),('15128','2013-10-06','16:25:00',2.25),('15128','2013-10-06','16:30:00',2.19),('15128','2013-10-06','16:35:00',1.99),('15128','2013-10-06','16:40:00',1.96),('15128','2013-10-06','16:45:00',1.84),('15128','2013-10-06','16:50:00',1.76),('15128','2013-10-06','16:55:00',1.68),('15128','2013-10-06','17:00:00',1.63),('15128','2013-10-06','17:05:00',1.56),('15128','2013-10-06','17:10:00',1.5),('15128','2013-10-06','17:15:00',1.44),('15128','2013-10-06','17:20:00',1.32),('15128','2013-10-06','17:25:00',1.23),('15128','2013-10-06','17:30:00',1.12),('15128','2013-10-06','17:35:00',1.01),('15128','2013-10-05','09:25:00',1.14),('15128','2013-10-05','09:30:00',1.56),('15128','2013-10-05','09:35:00',1.43),('15128','2013-10-05','09:40:00',1.57),('15128','2013-10-05','09:45:00',1.5),('15128','2013-10-05','09:50:00',1.8),('15128','2013-10-05','09:55:00',1.54),('15128','2013-10-05','10:00:00',1.99),('15128','2013-10-05','10:05:00',1.87),('15128','2013-10-05','10:10:00',1.87),('15128','2013-10-05','10:15:00',1.77),('15128','2013-10-05','10:20:00',1.96),('15128','2013-10-05','10:25:00',2.03),('15128','2013-10-05','10:30:00',2.03),('15128','2013-10-05','10:35:00',2),('15128','2013-10-05','10:40:00',1.63),('15128','2013-10-05','10:45:00',1.89),('15128','2013-10-05','10:50:00',2.03),('15128','2013-10-05','10:55:00',2.21),('15128','2013-10-05','11:00:00',2.39),('15128','2013-10-05','11:05:00',2.13),('15128','2013-10-05','11:10:00',2.41),('15128','2013-10-05','11:15:00',2.3),('15128','2013-10-05','11:20:00',2.38),('15128','2013-10-05','11:25:00',2.26),('15128','2013-10-05','11:30:00',2.15),('15128','2013-10-05','11:35:00',1.92),('15128','2013-10-05','11:40:00',2.22),('15128','2013-10-05','11:45:00',2.07),('15128','2013-10-05','11:50:00',2.3),('15128','2013-10-05','11:55:00',1.34),('15128','2013-10-05','12:00:00',2.99),('15128','2013-10-05','12:05:00',3.07),('15128','2013-10-05','12:10:00',3.13),('15128','2013-10-05','12:15:00',2.72),('15128','2013-10-05','12:20:00',2.08),('15128','2013-10-05','12:25:00',1.4),('15128','2013-10-05','12:30:00',2.84),('15128','2013-10-05','12:35:00',2.79),('15128','2013-10-05','12:40:00',2.98),('15128','2013-10-05','12:45:00',3.13),('15128','2013-10-05','12:50:00',3.26),('15128','2013-10-05','12:55:00',2.98),('15128','2013-10-05','13:00:00',3.29),('15128','2013-10-05','13:05:00',2.14),('15128','2013-10-05','13:10:00',2.56),('15128','2013-10-05','13:15:00',1.65),('15128','2013-10-05','13:20:00',1.56),('15128','2013-10-05','13:25:00',1.83),('15128','2013-10-05','13:30:00',1.29),('15128','2013-10-05','13:35:00',1.09),('15128','2013-10-05','13:55:00',2.37),('15128','2013-10-05','14:00:00',2.34),('15128','2013-10-05','14:05:00',1.4),('15128','2013-10-05','14:10:00',1.36),('15128','2013-10-05','14:15:00',1.9),('15128','2013-10-05','14:20:00',1.79),('15128','2013-10-05','14:25:00',2.58),('15128','2013-10-05','14:30:00',2.68),('15128','2013-10-05','14:35:00',2.66),('15128','2013-10-05','14:40:00',2.44),('15128','2013-10-05','14:45:00',1.52),('15128','2013-10-05','14:50:00',1.56),('15128','2013-10-05','14:55:00',1.93),('15128','2013-10-05','15:00:00',2.27),('15128','2013-10-05','15:05:00',2.15),('15128','2013-10-05','15:10:00',2),('15128','2013-10-05','15:15:00',1.88),('15128','2013-10-05','15:20:00',1.27),('15128','2013-10-05','15:25:00',1.15),('15128','2013-10-05','15:30:00',1.08),('15128','2013-10-05','15:35:00',1.01),('15128','2013-10-05','15:55:00',1.13),('15128','2013-10-05','16:00:00',1.09),('15128','2013-10-05','17:10:00',1.42),('15128','2013-10-05','17:15:00',1.1),('15128','2013-10-04','15:55:00',1.1),('15128','2013-10-04','16:00:00',1.41),('15128','2013-10-04','16:05:00',1.35),('15128','2013-10-04','16:10:00',1.25),('15128','2013-10-04','16:15:00',1.24),('15128','2013-10-04','16:20:00',1.09),('15128','2013-10-04','16:45:00',1.22),('15128','2013-10-04','16:50:00',1.17),('15128','2013-10-04','16:55:00',1.34),('15128','2013-10-04','17:00:00',1.03),('15128','2013-10-03','09:30:00',1.01),('15128','2013-10-03','09:35:00',1),('15128','2013-10-03','09:40:00',1.08),('15128','2013-10-03','09:45:00',1.2),('15128','2013-10-03','09:50:00',1.45),('15128','2013-10-03','09:55:00',1.33),('15128','2013-10-03','10:00:00',1.25),('15128','2013-10-03','10:05:00',1.29),('15128','2013-10-03','10:10:00',1.34),('15128','2013-10-03','10:15:00',1.27),('15128','2013-10-03','10:20:00',1.4),('15128','2013-10-03','10:25:00',1.65),('15128','2013-10-03','10:30:00',1.88),('15128','2013-10-03','10:35:00',1.58),('15128','2013-10-03','10:40:00',2.83),('15128','2013-10-03','10:45:00',2.18),('15128','2013-10-03','10:50:00',1.94),('15128','2013-10-03','10:55:00',1.88),('15128','2013-10-03','11:00:00',1.58),('15128','2013-10-03','11:05:00',1.56),('15128','2013-10-03','11:10:00',1.71),('15128','2013-10-03','11:15:00',1.96),('15128','2013-10-03','11:20:00',2.36),('15128','2013-10-03','11:25:00',2.43),('15128','2013-10-03','11:30:00',2.04),('15128','2013-10-03','11:35:00',2.75),('15128','2013-10-03','11:40:00',2.88),('15128','2013-10-03','11:45:00',2.92),('15128','2013-10-03','11:50:00',2.98),('15128','2013-10-03','11:55:00',3.08),('15128','2013-10-03','12:00:00',3.21),('15128','2013-10-03','12:05:00',3.21),('15128','2013-10-03','12:10:00',3.11),('15128','2013-10-03','12:15:00',3.21),('15128','2013-10-03','12:20:00',3.27),('15128','2013-10-03','12:25:00',3.38),('15128','2013-10-03','12:30:00',3.39),('15128','2013-10-03','12:35:00',3.33),('15128','2013-10-03','12:40:00',3.35),('15128','2013-10-03','12:45:00',3.38),('15128','2013-10-03','12:50:00',3.3),('15128','2013-10-03','12:55:00',3.38),('15128','2013-10-03','13:00:00',3.44),('15128','2013-10-03','13:05:00',3.42),('15128','2013-10-03','13:10:00',3.53),('15128','2013-10-03','13:15:00',3.55),('15128','2013-10-03','13:20:00',3.31),('15128','2013-10-03','13:25:00',3.46),('15128','2013-10-03','13:30:00',3.52),('15128','2013-10-03','13:35:00',3.47),('15128','2013-10-03','13:40:00',3.44),('15128','2013-10-03','13:45:00',3.42),('15128','2013-10-03','13:50:00',3.46),('15128','2013-10-03','13:55:00',3.47),('15128','2013-10-03','14:00:00',3.49),('15128','2013-10-03','14:05:00',3.21),('15128','2013-10-03','14:10:00',2.62),('15128','2013-10-03','14:15:00',3.21),('15128','2013-10-03','14:20:00',3.46),('15128','2013-10-03','14:25:00',2.97),('15128','2013-10-03','14:30:00',2.35),('15128','2013-10-03','14:35:00',1.86),('15128','2013-10-03','14:40:00',2.02),('15128','2013-10-03','14:45:00',2.66),('15128','2013-10-03','14:50:00',2.44),('15128','2013-10-03','14:55:00',2.24),('15128','2013-10-03','15:00:00',2.73),('15128','2013-10-03','15:05:00',2.35),('15128','2013-10-03','15:10:00',1.82),('15128','2013-10-03','15:15:00',1.59),('15128','2013-10-03','15:20:00',2.42),('15128','2013-10-03','15:25:00',1.5),('15128','2013-10-03','15:30:00',1.48),('15128','2013-10-03','15:35:00',1.26),('15128','2013-10-03','15:40:00',1.01),('15128','2013-10-03','15:55:00',1.16),('15128','2013-10-03','16:00:00',1.31),('15128','2013-10-03','16:05:00',1.14),('15128','2013-10-02','09:15:00',1.02),('15128','2013-10-02','09:20:00',1.11),('15128','2013-10-02','09:25:00',1.23),('15128','2013-10-02','09:30:00',1.31),('15128','2013-10-02','09:35:00',1.38),('15128','2013-10-02','09:40:00',1.45),('15128','2013-10-02','09:45:00',1.49),('15128','2013-10-02','09:50:00',1.54),('15128','2013-10-02','09:55:00',1.64),('15128','2013-10-02','10:00:00',1.72),('15128','2013-10-02','10:05:00',1.77),('15128','2013-10-02','10:10:00',1.81),('15128','2013-10-02','10:15:00',1.87),('15128','2013-10-02','10:20:00',1.93),('15128','2013-10-02','10:25:00',1.98),('15128','2013-10-02','10:30:00',2.03),('15128','2013-10-02','10:35:00',2.1),('15128','2013-10-02','10:40:00',2.16),('15128','2013-10-02','10:45:00',2.21),('15128','2013-10-02','10:50:00',2.28),('15128','2013-10-02','10:55:00',2.36),('15128','2013-10-02','11:00:00',2.41),('15128','2013-10-02','11:05:00',2.47),('15128','2013-10-02','11:10:00',2.53),('15128','2013-10-02','11:15:00',2.61),('15128','2013-10-02','11:20:00',2.68),('15128','2013-10-02','11:25:00',2.74),('15128','2013-10-02','11:30:00',2.8),('15128','2013-10-02','11:35:00',2.84),('15128','2013-10-02','11:40:00',2.91),('15128','2013-10-02','11:45:00',2.91),('15128','2013-10-02','11:50:00',3.09),('15128','2013-10-02','11:55:00',3.18),('15128','2013-10-02','12:00:00',3.25),('15128','2013-10-02','12:05:00',3.3),('15128','2013-10-02','12:10:00',3.34),('15128','2013-10-02','12:15:00',3.37),('15128','2013-10-02','12:20:00',3.41),('15128','2013-10-02','12:25:00',3.45),('15128','2013-10-02','12:30:00',3.47),('15128','2013-10-02','12:35:00',3.51),('15128','2013-10-02','12:40:00',3.54),('15128','2013-10-02','12:45:00',3.56),('15128','2013-10-02','12:50:00',3.59),('15128','2013-10-02','12:55:00',3.62),('15128','2013-10-02','13:00:00',3.61),('15128','2013-10-02','13:05:00',3.63),('15128','2013-10-02','13:10:00',3.66),('15128','2013-10-02','13:15:00',3.64),('15128','2013-10-02','13:20:00',3.64),('15128','2013-10-02','13:25:00',3.67),('15128','2013-10-02','13:30:00',3.68),('15128','2013-10-02','13:35:00',3.68),('15128','2013-10-02','13:40:00',3.65),('15128','2013-10-02','13:45:00',3.66),('15128','2013-10-02','13:50:00',3.65),('15128','2013-10-02','13:55:00',3.64),('15128','2013-10-02','14:00:00',3.64),('15128','2013-10-02','14:05:00',3.61),('15128','2013-10-02','14:10:00',3.61),('15128','2013-10-02','14:15:00',3.61),('15128','2013-10-02','14:20:00',3.57),('15128','2013-10-02','14:25:00',3.53),('15128','2013-10-02','14:30:00',3.52),('15128','2013-10-02','14:35:00',3.5),('15128','2013-10-02','14:40:00',3.46),('15128','2013-10-02','14:45:00',3.42),('15128','2013-10-02','14:50:00',3.38),('15128','2013-10-02','14:55:00',3.35),('15128','2013-10-02','15:00:00',3.33),('15128','2013-10-02','15:05:00',3.29),('15128','2013-10-02','15:10:00',3.24),('15128','2013-10-02','15:15:00',3.21),('15128','2013-10-02','15:20:00',3.17),('15128','2013-10-02','15:25:00',3.14),('15128','2013-10-02','15:30:00',3.09),('15128','2013-10-02','15:35:00',3.04),('15128','2013-10-02','15:40:00',2.97),('15128','2013-10-02','15:45:00',2.93),('15128','2013-10-02','15:50:00',2.9),('15128','2013-10-02','15:55:00',2.85),('15128','2013-10-02','16:00:00',2.76),('15128','2013-10-02','16:05:00',2.71),('15128','2013-10-02','16:10:00',2.67),('15128','2013-10-02','16:15:00',2.59),('15128','2013-10-02','16:20:00',2.52),('15128','2013-10-02','16:25:00',2.42),('15128','2013-10-02','16:30:00',2.32),('15128','2013-10-02','16:35:00',2.2),('15128','2013-10-02','16:40:00',2.02),('15128','2013-10-02','16:45:00',1.92),('15128','2013-10-02','16:50:00',1.87),('15128','2013-10-02','16:55:00',1.82),('15128','2013-10-02','17:00:00',1.74),('15128','2013-10-02','17:05:00',1.66),('15128','2013-10-02','17:10:00',1.59),('15128','2013-10-02','17:15:00',1.52),('15128','2013-10-02','17:20:00',1.45),('15128','2013-10-02','17:25:00',1.35),('15128','2013-10-02','17:30:00',1.23),('15128','2013-10-02','17:35:00',1.13),('15128','2013-10-02','17:40:00',1.02),('15128','2013-10-01','09:15:00',1),('15128','2013-10-01','09:20:00',1.09),('15128','2013-10-01','09:25:00',1.19),('15128','2013-10-01','09:30:00',1.27),('15128','2013-10-01','09:35:00',1.34),('15128','2013-10-01','09:40:00',1.4),('15128','2013-10-01','09:45:00',1.44),('15128','2013-10-01','09:50:00',1.49),('15128','2013-10-01','09:55:00',1.57),('15128','2013-10-01','10:00:00',1.64),('15128','2013-10-01','10:05:00',1.7),('15128','2013-10-01','10:10:00',1.73),('15128','2013-10-01','10:15:00',1.77),('15128','2013-10-01','10:20:00',1.84),('15128','2013-10-01','10:25:00',1.89),('15128','2013-10-01','10:30:00',1.92),('15128','2013-10-01','10:35:00',1.99),('15128','2013-10-01','10:40:00',2.04),('15128','2013-10-01','10:45:00',2.09),('15128','2013-10-01','10:50:00',2.14),('15128','2013-10-01','10:55:00',2.26),('15128','2013-10-01','11:00:00',2.31),('15128','2013-10-01','11:05:00',2.39),('15128','2013-10-01','11:10:00',2.42),('15128','2013-10-01','11:15:00',2.45),('15128','2013-10-01','11:20:00',2.48),('15128','2013-10-01','11:25:00',2.57),('15128','2013-10-01','11:30:00',2.68),('15128','2013-10-01','11:35:00',2.69),('15128','2013-10-01','11:40:00',2.79),('15128','2013-10-01','11:45:00',2.81),('15128','2013-10-01','11:50:00',2.95),('15128','2013-10-01','11:55:00',3.07),('15128','2013-10-01','12:00:00',3.14),('15128','2013-10-01','12:05:00',3.17),('15128','2013-10-01','12:10:00',3.22),('15128','2013-10-01','12:15:00',3.25),('15128','2013-10-01','12:20:00',3.29),('15128','2013-10-01','12:25:00',3.32),('15128','2013-10-01','12:30:00',3.37),('15128','2013-10-01','12:35:00',3.41),('15128','2013-10-01','12:40:00',3.44),('15128','2013-10-01','12:45:00',3.46),('15128','2013-10-01','12:50:00',3.46),('15128','2013-10-01','12:55:00',3.48),('15128','2013-10-01','13:00:00',3.52),('15128','2013-10-01','13:05:00',3.52),('15128','2013-10-01','13:10:00',3.52),('15128','2013-10-01','13:15:00',3.52),('15128','2013-10-01','13:20:00',3.52),('15128','2013-10-01','13:25:00',3.51),('15128','2013-10-01','13:30:00',3.51),('15128','2013-10-01','13:35:00',3.52),('15128','2013-10-01','13:40:00',3.54),('15128','2013-10-01','13:45:00',3.51),('15128','2013-10-01','13:50:00',3.54),('15128','2013-10-01','13:55:00',3.67),('15128','2013-10-01','14:00:00',3.61),('15128','2013-10-01','14:05:00',3.5),('15128','2013-10-01','14:10:00',3.59),('15128','2013-10-01','14:15:00',3.56),('15128','2013-10-01','14:20:00',3.49),('15128','2013-10-01','14:25:00',3.49),('15128','2013-10-01','14:30:00',3.48),('15128','2013-10-01','14:35:00',3.4),('15128','2013-10-01','14:40:00',3.4),('15128','2013-10-01','14:45:00',3.36),('15128','2013-10-01','14:50:00',3.3),('15128','2013-10-01','14:55:00',3.3),('15128','2013-10-01','15:00:00',3.29),('15128','2013-10-01','15:05:00',3.23),('15128','2013-10-01','15:10:00',3.18),('15128','2013-10-01','15:15:00',3.15),('15128','2013-10-01','15:20:00',3.1),('15128','2013-10-01','15:25:00',3.07),('15128','2013-10-01','15:30:00',3.03),('15128','2013-10-01','15:35:00',2.98),('15128','2013-10-01','15:40:00',2.93),('15128','2013-10-01','15:45:00',2.86),('15128','2013-10-01','15:50:00',2.78),('15128','2013-10-01','15:55:00',2.74),('15128','2013-10-01','16:00:00',2.71),('15128','2013-10-01','16:05:00',2.66),('15128','2013-10-01','16:10:00',2.6),('15128','2013-10-01','16:15:00',2.52),('15128','2013-10-01','16:20:00',2.42),('15128','2013-10-01','16:25:00',2.31),('15128','2013-10-01','16:30:00',2.24),('15128','2013-10-01','16:35:00',2.13),('15128','2013-10-01','16:40:00',2.01),('15128','2013-10-01','16:45:00',1.88),('15128','2013-10-01','16:50:00',1.81),('15128','2013-10-01','16:55:00',1.69),('15128','2013-10-01','17:00:00',1.64),('15128','2013-10-01','17:05:00',1.59),('15128','2013-10-01','17:10:00',1.53),('15128','2013-10-01','17:15:00',1.43),('15128','2013-10-01','17:20:00',1.38),('15128','2013-10-01','17:25:00',1.29),('15128','2013-10-01','17:30:00',1.18),('15128','2013-10-01','17:35:00',1.08),('15128','2013-09-30','09:20:00',1.12),('15128','2013-09-30','09:25:00',1.21),('15128','2013-09-30','09:30:00',1.27),('15128','2013-09-30','09:35:00',1.33),('15128','2013-09-30','09:40:00',1.39),('15128','2013-09-30','09:45:00',1.45),('15128','2013-09-30','09:50:00',1.48),('15128','2013-09-30','09:55:00',1.56),('15128','2013-09-30','10:00:00',1.62),('15128','2013-09-30','10:05:00',1.7),('15128','2013-09-30','10:10:00',1.72),('15128','2013-09-30','10:15:00',1.74),('15128','2013-09-30','10:20:00',1.81),('15128','2013-09-30','10:25:00',1.86),('15128','2013-09-30','10:30:00',1.87),('15128','2013-09-30','10:35:00',1.98),('15128','2013-09-30','10:40:00',2.03),('15128','2013-09-30','10:45:00',2.11),('15128','2013-09-30','10:50:00',2.17),('15128','2013-09-30','10:55:00',2.23),('15128','2013-09-30','11:00:00',2.23),('15128','2013-09-30','11:05:00',2.37),('15128','2013-09-30','11:10:00',2.47),('15128','2013-09-30','11:15:00',2.53),('15128','2013-09-30','11:20:00',2.69),('15128','2013-09-30','11:25:00',2.8),('15128','2013-09-30','11:30:00',2.85),('15128','2013-09-30','11:35:00',2.79),('15128','2013-09-30','11:40:00',2.9),('15128','2013-09-30','11:45:00',2.71),('15128','2013-09-30','11:50:00',2.19),('15128','2013-09-30','11:55:00',2.16),('15128','2013-09-30','12:00:00',3.6),('15128','2013-09-30','12:05:00',2.46),('15128','2013-09-30','12:10:00',1.99),('15128','2013-09-30','12:15:00',1.96),('15128','2013-09-30','12:20:00',2.4),('15128','2013-09-30','12:25:00',2.2),('15128','2013-09-30','12:30:00',1.02),('15128','2013-09-30','12:35:00',3.09),('15128','2013-09-30','12:40:00',3.81),('15128','2013-09-30','12:45:00',3.78),('15128','2013-09-30','12:50:00',2.01),('15128','2013-09-30','12:55:00',1),('15128','2013-09-30','13:00:00',1.24),('15128','2013-09-30','13:05:00',1.98),('15128','2013-09-30','13:10:00',1.62),('15128','2013-09-30','13:15:00',3.19),('15128','2013-09-30','13:20:00',1.5),('15128','2013-09-30','13:30:00',1.59),('15128','2013-09-30','13:35:00',3.98),('15128','2013-09-30','13:40:00',3.88),('15128','2013-09-30','13:45:00',3.76),('15128','2013-09-30','13:50:00',3.61),('15128','2013-09-30','13:55:00',3.58),('15128','2013-09-30','14:00:00',3.59),('15128','2013-09-30','14:05:00',3.56),('15128','2013-09-30','14:10:00',3.54),('15128','2013-09-30','14:15:00',3.51),('15128','2013-09-30','14:20:00',3.5),('15128','2013-09-30','14:25:00',3.44),('15128','2013-09-30','14:30:00',3.44),('15128','2013-09-30','14:35:00',3.44),('15128','2013-09-30','14:40:00',3.41),('15128','2013-09-30','14:45:00',3.39),('15128','2013-09-30','14:50:00',3.39),('15128','2013-09-30','14:55:00',3.34),('15128','2013-09-30','15:00:00',3.3),('15128','2013-09-30','15:05:00',3.28),('15128','2013-09-30','15:10:00',3.22),('15128','2013-09-30','15:15:00',3.19),('15128','2013-09-30','15:20:00',3.17),('15128','2013-09-30','15:25:00',3.11),('15128','2013-09-30','15:30:00',3.08),('15128','2013-09-30','15:35:00',3.02),('15128','2013-09-30','15:40:00',2.95),('15128','2013-09-30','15:45:00',2.91),('15128','2013-09-30','15:50:00',2.88),('15128','2013-09-30','15:55:00',2.83),('15128','2013-09-30','16:00:00',2.76),('15128','2013-09-30','16:05:00',2.71),('15128','2013-09-30','16:10:00',2.66),('15128','2013-09-30','16:15:00',2.59),('15128','2013-09-30','16:20:00',2.52),('15128','2013-09-30','16:25:00',2.37),('15128','2013-09-30','16:30:00',2.18),('15128','2013-09-30','16:35:00',2.1),('15128','2013-09-30','16:40:00',2.03),('15128','2013-09-30','16:45:00',1.96),('15128','2013-09-30','16:50:00',1.86),('15128','2013-09-30','16:55:00',1.79),('15128','2013-09-30','17:00:00',1.71),('15128','2013-09-30','17:05:00',1.62),('15128','2013-09-30','17:10:00',1.61),('15128','2013-09-30','17:15:00',1.54),('15128','2013-09-30','17:20:00',1.44),('15128','2013-09-30','17:25:00',1.37),('15128','2013-09-30','17:30:00',1.26),('15128','2013-09-30','17:35:00',1.18),('15128','2013-09-30','17:40:00',1.08),('15128','2013-09-29','09:40:00',1.19),('15128','2013-09-29','09:45:00',1.66),('15128','2013-09-29','09:50:00',1.05),('15128','2013-09-29','10:10:00',1.11),('15128','2013-09-29','10:15:00',1.12),('15128','2013-09-29','10:20:00',1.13),('15128','2013-09-29','10:25:00',1.25),('15128','2013-09-29','10:30:00',1.27),('15128','2013-09-29','10:35:00',1.46),('15128','2013-09-29','10:40:00',1.87),('15128','2013-09-29','10:45:00',2.33),('15128','2013-09-29','10:50:00',2.19),('15128','2013-09-29','10:55:00',1.91),('15128','2013-09-29','11:00:00',2.21),('15128','2013-09-29','11:05:00',2.52),('15128','2013-09-29','11:10:00',2.57),('15128','2013-09-29','11:15:00',2.51),('15128','2013-09-29','11:20:00',2.38),('15128','2013-09-29','11:25:00',2.77),('15128','2013-09-29','11:30:00',2.66),('15128','2013-09-29','11:35:00',2.95),('15128','2013-09-29','11:40:00',2.55),('15128','2013-09-29','11:45:00',2.25),('15128','2013-09-29','11:50:00',1.54),('15128','2013-09-29','11:55:00',1.38),('15128','2013-09-29','12:00:00',3.45),('15128','2013-09-29','12:05:00',3.44),('15128','2013-09-29','12:10:00',3.43),('15128','2013-09-29','12:15:00',3.43),('15128','2013-09-29','12:20:00',3.44),('15128','2013-09-29','12:25:00',3.49),('15128','2013-09-29','12:30:00',3.49),('15128','2013-09-29','12:35:00',3.53),('15128','2013-09-29','12:40:00',3.64),('15128','2013-09-29','12:45:00',3.28),('15128','2013-09-29','12:50:00',3.92),('15128','2013-09-29','12:55:00',4.09),('15128','2013-09-29','13:00:00',3.17),('15128','2013-09-29','13:05:00',2.39),('15128','2013-09-29','13:10:00',3.45),('15128','2013-09-29','13:15:00',3.92),('15128','2013-09-29','13:20:00',3.9),('15128','2013-09-29','13:25:00',3.99),('15128','2013-09-29','13:30:00',4.2),('15128','2013-09-29','13:35:00',4.26),('15128','2013-09-29','13:40:00',2.16),('15128','2013-09-29','13:55:00',1.05),('15128','2013-09-29','14:00:00',1.2),('15128','2013-09-29','14:05:00',1.32),('15128','2013-09-29','14:10:00',1.18),('15128','2013-09-29','14:25:00',1.7),('15128','2013-09-29','14:30:00',3.96),('15128','2013-09-29','14:35:00',4.77),('15128','2013-09-29','14:40:00',4.8),('15128','2013-09-29','14:45:00',4.07),('15128','2013-09-29','14:50:00',4.11),('15128','2013-09-29','14:55:00',3.64),('15128','2013-09-29','15:00:00',3.09),('15128','2013-09-29','15:05:00',2.07),('15128','2013-09-29','15:10:00',2.13),('15128','2013-09-29','15:15:00',3.07),('15128','2013-09-29','15:20:00',1.01),('15128','2013-09-29','15:25:00',1.24),('15128','2013-09-29','15:50:00',2.49),('15128','2013-09-29','15:55:00',3.52),('15128','2013-09-29','16:00:00',3.41),('15128','2013-09-29','16:05:00',2.42),('15128','2013-09-29','16:10:00',1.48),('15128','2013-09-29','16:15:00',1.45),('15128','2013-09-29','16:20:00',1.13),('15128','2013-09-29','16:25:00',2.26),('15128','2013-09-29','16:30:00',2.29),('15128','2013-09-29','16:35:00',1.81),('15128','2013-09-29','16:40:00',2.24),('15128','2013-09-29','16:45:00',1.66),('15128','2013-09-29','16:50:00',2),('15128','2013-09-29','16:55:00',1.2),('15128','2013-09-29','17:15:00',1.32),('15128','2013-09-29','17:35:00',1.08),('15128','2013-09-28','09:50:00',1.04),('15128','2013-09-28','09:55:00',1.44),('15128','2013-09-28','10:00:00',1.8),('15128','2013-09-28','10:05:00',1.76),('15128','2013-09-28','10:10:00',2),('15128','2013-09-28','10:15:00',1.73),('15128','2013-09-28','10:20:00',1.86),('15128','2013-09-28','10:25:00',1.93),('15128','2013-09-28','10:30:00',1.86),('15128','2013-09-28','10:35:00',1.97),('15128','2013-09-28','10:40:00',2),('15128','2013-09-28','10:45:00',2.12),('15128','2013-09-28','10:50:00',2.17),('15128','2013-09-28','10:55:00',2.25),('15128','2013-09-28','11:00:00',2.26),('15128','2013-09-28','11:05:00',2.1),('15128','2013-09-28','11:10:00',2.22),('15128','2013-09-28','11:15:00',2.35),('15128','2013-09-28','11:20:00',2.24),('15128','2013-09-28','11:25:00',2.35),('15128','2013-09-28','11:30:00',2.53),('15128','2013-09-28','11:35:00',2.47),('15128','2013-09-28','11:40:00',2.69),('15128','2013-09-28','11:45:00',2.66),('15128','2013-09-28','11:50:00',2.96),('15128','2013-09-28','11:55:00',2.87),('15128','2013-09-28','12:00:00',2.98),('15128','2013-09-28','12:05:00',3.17),('15128','2013-09-28','12:10:00',2.98),('15128','2013-09-28','12:15:00',2.4),('15128','2013-09-28','12:20:00',1.37),('15128','2013-09-28','12:25:00',1.13),('15128','2013-09-28','12:30:00',1.23),('15128','2013-09-28','12:35:00',1.54),('15128','2013-09-28','12:40:00',1.48),('15128','2013-09-28','12:45:00',1.34),('15128','2013-09-28','12:50:00',1.46),('15128','2013-09-28','12:55:00',1.06),('15128','2013-09-28','13:20:00',1.03),('15128','2013-09-28','13:25:00',1.76),('15128','2013-09-28','13:30:00',2.22),('15128','2013-09-28','13:35:00',2.33),('15128','2013-09-28','13:40:00',2.1),('15128','2013-09-28','13:45:00',1.87),('15128','2013-09-28','13:50:00',1.84),('15128','2013-09-28','13:55:00',1.69),('15128','2013-09-28','14:00:00',1.45),('15128','2013-09-28','14:05:00',1.44),('15128','2013-09-28','14:10:00',1.2),('15128','2013-09-28','14:15:00',1.25),('15128','2013-09-28','14:20:00',1.21),('15128','2013-09-28','14:25:00',1.42),('15128','2013-09-28','14:50:00',1.76),('15128','2013-09-28','15:15:00',1.29),('15128','2013-09-28','15:20:00',1.15),('15128','2013-09-28','15:25:00',1.51),('15128','2013-09-28','15:55:00',1.21),('15128','2013-09-28','16:00:00',1.11),('15128','2013-09-28','16:25:00',1.63),('15128','2013-09-28','16:30:00',1.59),('15128','2013-09-28','16:35:00',1.17),('15128','2014-04-13','08:40:00',1.01),('15128','2014-04-13','08:45:00',1.09),('15128','2014-04-13','08:50:00',1.16),('15128','2014-04-13','08:55:00',1.22),('15128','2014-04-13','09:00:00',1.3),('15128','2014-04-13','09:05:00',1.36),('15128','2014-04-13','09:10:00',1.45),('15128','2014-04-13','09:15:00',1.52),('15128','2014-04-13','09:20:00',1.58),('15128','2014-04-13','09:25:00',1.64),('15128','2014-04-13','09:30:00',1.72),('15128','2014-04-13','09:35:00',1.79),('15128','2014-04-13','09:40:00',1.87),('15128','2014-04-13','09:45:00',1.94),('15128','2014-04-13','09:50:00',1.92),('15128','2014-04-13','09:55:00',1.97),('15128','2014-04-13','10:00:00',2.03),('15128','2014-04-13','10:05:00',2.11),('15128','2014-04-13','10:10:00',2.18),('15128','2014-04-13','10:15:00',2.25),('15128','2014-04-13','10:20:00',2.32),('15128','2014-04-13','10:25:00',2.41),('15128','2014-04-13','10:30:00',2.38),('15128','2014-04-13','10:35:00',2.52),('15128','2014-04-13','10:40:00',2.58),('15128','2014-04-13','10:45:00',2.67),('15128','2014-04-13','10:50:00',2.65),('15128','2014-04-13','10:55:00',2.73),('15128','2014-04-13','11:00:00',2.77),('15128','2014-04-13','11:05:00',2.84),('15128','2014-04-13','11:10:00',2.9),('15128','2014-04-13','11:15:00',2.94),('15128','2014-04-13','11:20:00',3),('15128','2014-04-13','11:25:00',3.02),('15128','2014-04-13','11:30:00',3.11),('15128','2014-04-13','11:35:00',3.06),('15128','2014-04-13','11:40:00',3.22),('15128','2014-04-13','11:45:00',3.22),('15128','2014-04-13','11:50:00',3.39),('15128','2014-04-13','11:55:00',3.57),('15128','2014-04-13','12:00:00',3.65),('15128','2014-04-13','12:05:00',3.67),('15128','2014-04-13','12:10:00',3.71),('15128','2014-04-13','12:15:00',3.76),('15128','2014-04-13','12:20:00',3.81),('15128','2014-04-13','12:25:00',3.84),('15128','2014-04-13','12:30:00',3.87),('15128','2014-04-13','12:35:00',3.89),('15128','2014-04-13','12:40:00',3.93),('15128','2014-04-13','12:45:00',3.97),('15128','2014-04-13','12:50:00',4.01),('15128','2014-04-13','12:55:00',4.02),('15128','2014-04-13','13:00:00',4.05),('15128','2014-04-13','13:05:00',4.08),('15128','2014-04-13','13:10:00',4.09),('15128','2014-04-13','13:15:00',4.09),('15128','2014-04-13','13:20:00',4.1),('15128','2014-04-13','13:25:00',4.13),('15128','2014-04-13','13:30:00',4.15),('15128','2014-04-13','13:35:00',4.14),('15128','2014-04-13','13:40:00',4.15),('15128','2014-04-13','13:45:00',4.15),('15128','2014-04-13','13:50:00',4.16),('15128','2014-04-13','13:55:00',4.16),('15128','2014-04-13','14:00:00',4.15),('15128','2014-04-13','14:05:00',4.15),('15128','2014-04-13','14:10:00',4.19),('15128','2014-04-13','14:15:00',4.14),('15128','2014-04-13','14:20:00',4.13),('15128','2014-04-13','14:25:00',4.12),('15128','2014-04-13','14:30:00',4.11),('15128','2014-04-13','14:35:00',4.09),('15128','2014-04-13','14:40:00',4.09),('15128','2014-04-13','14:45:00',4.05),('15128','2014-04-13','14:50:00',4.04),('15128','2014-04-13','14:55:00',4.03),('15128','2014-04-13','15:00:00',3.99),('15128','2014-04-13','15:05:00',3.98),('15128','2014-04-13','15:10:00',3.94),('15128','2014-04-13','15:15:00',3.89),('15128','2014-04-13','15:20:00',3.87),('15128','2014-04-13','15:25:00',3.85),('15128','2014-04-13','15:30:00',3.81),('15128','2014-04-13','15:35:00',3.77),('15128','2014-04-13','15:40:00',3.73),('15128','2014-04-13','15:45:00',3.68),('15128','2014-04-13','15:50:00',3.63),('15128','2014-04-13','15:55:00',3.58),('15128','2014-04-13','16:00:00',3.54),('15128','2014-04-13','16:05:00',3.48),('15128','2014-04-13','16:10:00',3.43),('15128','2014-04-13','16:15:00',3.38),('15128','2014-04-13','16:20:00',3.33),('15128','2014-04-13','16:25:00',3.26),('15128','2014-04-13','16:30:00',3.2),('15128','2014-04-13','16:35:00',3.15),('15128','2014-04-13','16:40:00',3.08),('15128','2014-04-13','16:45:00',3),('15128','2014-04-13','16:50:00',2.92),('15128','2014-04-13','16:55:00',2.87),('15128','2014-04-13','17:00:00',2.81),('15128','2014-04-13','17:05:00',2.73),('15128','2014-04-13','17:10:00',2.64),('15128','2014-04-13','17:15:00',2.55),('15128','2014-04-13','17:20:00',2.42),('15128','2014-04-13','17:25:00',2.29),('15128','2014-04-13','17:30:00',2.15),('15128','2014-04-13','17:35:00',2.05),('15128','2014-04-13','17:40:00',1.94),('15128','2014-04-13','17:45:00',1.88),('15128','2014-04-13','17:50:00',1.79),('15128','2014-04-13','17:55:00',1.7),('15128','2014-04-13','18:00:00',1.63),('15128','2014-04-13','18:05:00',1.57),('15128','2014-04-13','18:10:00',1.5),('15128','2014-04-13','18:15:00',1.43),('15128','2014-04-13','18:20:00',1.3),('15128','2014-04-13','18:25:00',1.2),('15128','2014-04-13','18:30:00',1.08),('15128','2014-04-13','18:35:00',1),('15128','2013-09-27','09:15:00',1.04),('15128','2013-09-27','09:20:00',1.1),('15128','2013-09-27','09:25:00',1.18),('15128','2013-09-27','09:30:00',1.27),('15128','2013-09-27','09:35:00',1.3),('15128','2013-09-27','09:40:00',1.32),('15128','2013-09-27','09:45:00',1.42),('15128','2013-09-27','09:50:00',1.5),('15128','2013-09-27','09:55:00',1.64),('15128','2013-09-27','10:00:00',1.44),('15128','2013-09-27','10:05:00',1.12),('15128','2013-09-27','10:10:00',1.15),('15128','2013-09-27','10:15:00',2.23),('15128','2013-09-27','10:20:00',2.2),('15128','2013-09-27','10:25:00',1.75),('15128','2013-09-27','10:30:00',1.79),('15128','2013-09-27','10:45:00',1.41),('15128','2013-09-27','10:50:00',2.27),('15128','2013-09-27','10:55:00',1.4),('15128','2013-09-27','11:00:00',1.26),('15128','2013-09-27','11:05:00',1.13),('15128','2013-09-27','11:10:00',1.04),('15128','2013-09-27','11:15:00',2.84),('15128','2013-09-27','11:20:00',2.67),('15128','2013-09-27','11:25:00',2.93),('15128','2013-09-27','11:30:00',2.38),('15128','2013-09-27','11:35:00',2.84),('15128','2013-09-27','11:40:00',3.13),('15128','2013-09-27','11:45:00',1.84),('15128','2013-09-27','11:50:00',2.81),('15128','2013-09-27','11:55:00',3.15),('15128','2013-09-27','12:00:00',3.26),('15128','2013-09-27','12:05:00',2.3),('15128','2013-09-27','12:10:00',3.66),('15128','2013-09-27','12:15:00',3.76),('15128','2013-09-27','12:20:00',3.71),('15128','2013-09-27','12:25:00',3.55),('15128','2013-09-27','12:30:00',3.51),('15128','2013-09-27','12:35:00',3.6),('15128','2013-09-27','12:40:00',3.66),('15128','2013-09-27','12:45:00',3.61),('15128','2013-09-27','12:50:00',3.22),('15128','2013-09-27','12:55:00',3.21),('15128','2013-09-27','13:05:00',3.2),('15128','2013-09-27','13:10:00',3.53),('15128','2013-09-27','13:15:00',3.2),('15128','2013-09-27','13:20:00',3.56),('15128','2013-09-27','13:25:00',3.57),('15128','2013-09-27','13:30:00',3.51),('15128','2013-09-27','13:35:00',2.82),('15128','2013-09-27','13:40:00',3.48),('15128','2013-09-27','13:45:00',2.81),('15128','2013-09-27','13:50:00',3.63),('15128','2013-09-27','13:55:00',3.53),('15128','2013-09-27','14:00:00',3.48),('15128','2013-09-27','14:05:00',3.53),('15128','2013-09-27','14:10:00',3.68),('15128','2013-09-27','14:15:00',3.47),('15128','2013-09-27','14:20:00',3.47),('15128','2013-09-27','14:25:00',3.43),('15128','2013-09-27','14:30:00',3.6),('15128','2013-09-27','14:35:00',1.79),('15128','2013-09-27','14:40:00',3.18),('15128','2013-09-27','14:45:00',3.66),('15128','2013-09-27','14:50:00',3.47),('15128','2013-09-27','14:55:00',2.4),('15128','2013-09-27','15:00:00',2.97),('15128','2013-09-27','15:05:00',3.28),('15128','2013-09-27','15:10:00',3.09),('15128','2013-09-27','15:15:00',2.98),('15128','2013-09-27','15:20:00',3.2),('15128','2013-09-27','15:25:00',2.76),('15128','2013-09-27','15:30:00',2.65),('15128','2013-09-27','15:35:00',2.19),('15128','2013-09-27','15:40:00',3.16),('15128','2013-09-27','15:45:00',2.85),('15128','2013-09-27','15:50:00',2.76),('15128','2013-09-27','15:55:00',2.69),('15128','2013-09-27','16:00:00',2.43),('15128','2013-09-27','16:05:00',2.03),('15128','2013-09-27','16:10:00',2.51),('15128','2013-09-27','16:15:00',2.53),('15128','2013-09-27','16:20:00',2.36),('15128','2013-09-27','16:25:00',1.99),('15128','2013-09-27','16:30:00',2.22),('15128','2013-09-27','16:35:00',2.21),('15128','2013-09-27','16:40:00',2.06),('15128','2013-09-27','16:45:00',1.88),('15128','2013-09-27','16:50:00',1.8),('15128','2013-09-27','16:55:00',1.72),('15128','2013-09-27','17:00:00',1.63),('15128','2013-09-27','17:05:00',1.57),('15128','2013-09-27','17:10:00',1.51),('15128','2013-09-27','17:15:00',1.43),('15128','2013-09-27','17:20:00',1.37),('15128','2013-09-27','17:25:00',1.34),('15128','2013-09-27','17:30:00',1.22),('15128','2013-09-27','17:35:00',1.09),('15128','2013-09-26','09:15:00',1.27),('15128','2013-09-26','09:20:00',1.4),('15128','2013-09-26','09:25:00',1),('15128','2013-09-26','10:05:00',1.8),('15128','2013-09-26','10:10:00',1.93),('15128','2013-09-26','10:15:00',1.95),('15128','2013-09-26','10:20:00',1.57),('15128','2013-09-26','10:25:00',1.83),('15128','2013-09-26','10:30:00',1.91),('15128','2013-09-26','10:35:00',2.04),('15128','2013-09-26','10:40:00',2.17),('15128','2013-09-26','10:45:00',2.17),('15128','2013-09-26','10:50:00',2.24),('15128','2013-09-26','10:55:00',2.26),('15128','2013-09-26','11:00:00',2.32),('15128','2013-09-26','11:05:00',2.37),('15128','2013-09-26','11:10:00',2.42),('15128','2013-09-26','11:15:00',2.51),('15128','2013-09-26','11:20:00',2.55),('15128','2013-09-26','11:25:00',2.73),('15128','2013-09-26','11:30:00',3.15),('15128','2013-09-26','11:35:00',2.69),('15128','2013-09-26','11:40:00',2.44),('15128','2013-09-26','11:45:00',1.35),('15128','2013-09-26','11:50:00',1.95),('15128','2013-09-26','11:55:00',3.47),('15128','2013-09-26','12:00:00',3.83),('15128','2013-09-26','12:05:00',3.35),('15128','2013-09-26','12:10:00',2.49),('15128','2013-09-26','12:15:00',3.04),('15128','2013-09-26','12:20:00',3.75),('15128','2013-09-26','12:25:00',3.83),('15128','2013-09-26','12:30:00',3.78),('15128','2013-09-26','12:35:00',2.23),('15128','2013-09-26','12:50:00',2.49),('15128','2013-09-26','12:55:00',2.12),('15128','2013-09-26','13:00:00',1.89),('15128','2013-09-26','13:05:00',2.35),('15128','2013-09-26','13:10:00',4.13),('15128','2013-09-26','13:15:00',4.11),('15128','2013-09-26','13:20:00',4.1),('15128','2013-09-26','13:25:00',3.99),('15128','2013-09-26','13:30:00',3.95),('15128','2013-09-26','13:35:00',3.37),('15128','2013-09-26','13:41:00',3.9),('15128','2013-09-26','13:45:00',3.83),('15128','2013-09-26','13:50:00',2.94),('15128','2013-09-26','13:55:00',2.94),('15128','2013-09-26','14:00:00',3.88),('15128','2013-09-26','14:05:00',3.67),('15128','2013-09-26','14:10:00',3.54),('15128','2013-09-26','14:15:00',3.51),('15128','2013-09-26','14:20:00',3.09),('15128','2013-09-26','14:25:00',2.98),('15128','2013-09-26','14:30:00',3.56),('15128','2013-09-26','14:35:00',2.43),('15128','2013-09-26','14:40:00',3.46),('15128','2013-09-26','14:45:00',3.63),('15128','2013-09-26','14:50:00',3.46),('15128','2013-09-26','14:55:00',3.22),('15128','2013-09-26','15:00:00',3.41),('15128','2013-09-26','15:05:00',3.22),('15128','2013-09-26','15:10:00',3.25),('15128','2013-09-26','15:15:00',3.24),('15128','2013-09-26','15:20:00',3.21),('15128','2013-09-26','15:25:00',3.12),('15128','2013-09-26','15:30:00',3),('15128','2013-09-26','15:35:00',2.94),('15128','2013-09-26','15:40:00',3.02),('15128','2013-09-26','15:45:00',3.08),('15128','2013-09-26','15:50:00',2.94),('15128','2013-09-26','15:55:00',2.83),('15128','2013-09-26','16:00:00',2.59),('15128','2013-09-26','16:05:00',2.64),('15128','2013-09-26','16:10:00',2.63),('15128','2013-09-26','16:15:00',2.51),('15128','2013-09-26','16:20:00',2.55),('15128','2013-09-26','16:25:00',2.46),('15128','2013-09-26','16:30:00',2.39),('15128','2013-09-26','16:35:00',2.28),('15128','2013-09-26','16:40:00',2.11),('15128','2013-09-26','16:45:00',2.01),('15128','2013-09-26','16:50:00',1.83),('15128','2013-09-26','16:55:00',1.23),('15128','2013-09-26','17:00:00',1.75),('15128','2013-09-26','17:05:00',1.55),('15128','2013-09-26','17:10:00',1.63),('15128','2013-09-26','17:15:00',1.49),('15128','2013-09-26','17:25:00',1.2),('15128','2013-09-26','17:30:00',1.34),('15128','2013-09-25','09:10:00',1.04),('15128','2013-09-25','09:15:00',1.12),('15128','2013-09-25','09:20:00',1.2),('15128','2013-09-25','09:25:00',1.28),('15128','2013-09-25','09:30:00',1.32),('15128','2013-09-25','09:35:00',1.38),('15128','2013-09-25','09:40:00',1.44),('15128','2013-09-25','09:45:00',1.51),('15128','2013-09-25','09:50:00',1.59),('15128','2013-09-25','09:55:00',1.63),('15128','2013-09-25','10:00:00',1.69),('15128','2013-09-25','10:05:00',1.71),('15128','2013-09-25','10:10:00',1.79),('15128','2013-09-25','10:15:00',1.84),('15128','2013-09-25','10:20:00',1.86),('15128','2013-09-25','10:25:00',1.99),('15128','2013-09-25','10:30:00',2.02),('15128','2013-09-25','10:35:00',2.02),('15128','2013-09-25','10:40:00',2.12),('15128','2013-09-25','10:45:00',2.17),('15128','2013-09-25','10:50:00',2.21),('15128','2013-09-25','10:55:00',2.27),('15128','2013-09-25','11:00:00',2.26),('15128','2013-09-25','11:05:00',2.35),('15128','2013-09-25','11:10:00',2.64),('15128','2013-09-25','11:15:00',2.18),('15128','2013-09-25','11:20:00',2.7),('15128','2013-09-25','11:25:00',2.21),('15128','2013-09-25','11:30:00',1.99),('15128','2013-09-25','11:40:00',1.15),('15128','2013-09-25','11:45:00',2.9),('15128','2013-09-25','11:50:00',2.99),('15128','2013-09-25','11:55:00',2.43),('15128','2013-09-25','12:00:00',1.88),('15128','2013-09-25','12:05:00',3.34),('15128','2013-09-25','12:10:00',3.39),('15128','2013-09-25','12:15:00',3.59),('15128','2013-09-25','12:20:00',3.35),('15128','2013-09-25','12:25:00',2.84),('15128','2013-09-25','12:30:00',1.16),('15128','2013-09-25','12:35:00',1.6),('15128','2013-09-25','12:40:00',3.26),('15128','2013-09-25','12:45:00',3.71),('15128','2013-09-25','12:50:00',3.24),('15128','2013-09-25','12:55:00',3.79),('15128','2013-09-25','13:00:00',3.58),('15128','2013-09-25','13:05:00',3.6),('15128','2013-09-25','13:10:00',3.66),('15128','2013-09-25','13:15:00',3.64),('15128','2013-09-25','13:20:00',2.87),('15128','2013-09-25','13:25:00',1.31),('15128','2013-09-25','13:30:00',1.81),('15128','2013-09-25','13:35:00',1.16),('15128','2013-09-25','13:40:00',1.36),('15128','2013-09-25','13:45:00',1.68),('15128','2013-09-25','13:50:00',1.93),('15128','2013-09-25','13:55:00',3.11),('15128','2013-09-25','14:00:00',2.41),('15128','2013-09-25','14:05:00',3.53),('15128','2013-09-25','14:10:00',3.78),('15128','2013-09-25','14:15:00',3.71),('15128','2013-09-25','14:20:00',2.21),('15128','2013-09-25','14:25:00',3.43),('15128','2013-09-25','14:30:00',3.66),('15128','2013-09-25','14:35:00',3.28),('15128','2013-09-25','14:40:00',2.66),('15128','2013-09-25','14:45:00',3.53),('15128','2013-09-25','14:50:00',3.45),('15128','2013-09-25','14:55:00',3.17),('15128','2013-09-25','15:00:00',2.13),('15128','2013-09-25','15:05:00',1.43),('15128','2013-09-25','15:10:00',3.17),('15128','2013-09-25','15:15:00',3.43),('15128','2013-09-25','15:20:00',3.29),('15128','2013-09-25','15:25:00',3.14),('15128','2013-09-25','15:30:00',3.04),('15128','2013-09-25','15:35:00',3.06),('15128','2013-09-25','15:40:00',3.04),('15128','2013-09-25','15:45:00',3.11),('15128','2013-09-25','15:50:00',2.93),('15128','2013-09-25','15:55:00',2.82),('15128','2013-09-25','16:00:00',2.7),('15128','2013-09-25','16:05:00',2.71),('15128','2013-09-25','16:10:00',2.67),('15128','2013-09-25','16:15:00',2.59),('15128','2013-09-25','16:20:00',2.56),('15128','2013-09-25','16:25:00',2.49),('15128','2013-09-25','16:30:00',2.08),('15128','2013-09-25','16:35:00',2.3),('15128','2013-09-25','16:40:00',2.09),('15128','2013-09-25','16:45:00',2.04),('15128','2013-09-25','16:50:00',1.91),('15128','2013-09-25','16:55:00',1.8),('15128','2013-09-25','17:00:00',1.59),('15128','2013-09-25','17:05:00',1.31),('15128','2013-09-25','17:10:00',1.41),('15128','2013-09-25','17:15:00',1.67),('15128','2013-09-25','17:20:00',1.74),('15128','2013-09-25','17:25:00',1.61),('15128','2013-09-25','17:30:00',1.38),('15128','2013-09-25','17:35:00',1.27),('15128','2013-09-25','17:40:00',1.12),('15128','2013-09-25','17:45:00',1.03),('15128','2013-09-24','10:05:00',1.08),('15128','2013-09-24','10:10:00',1.48),('15128','2013-09-24','10:15:00',1.89),('15128','2013-09-24','10:20:00',1.73),('15128','2013-09-24','10:25:00',1.96),('15128','2013-09-24','10:30:00',1.81),('15128','2013-09-24','10:35:00',2.1),('15128','2013-09-24','10:40:00',2.39),('15128','2013-09-24','10:45:00',2.65),('15128','2013-09-24','10:50:00',2.88),('15128','2013-09-24','10:55:00',2.26),('15128','2013-09-24','11:00:00',1.82),('15128','2013-09-24','11:20:00',1.75),('15128','2013-09-24','11:25:00',2.97),('15128','2013-09-24','11:30:00',2.98),('15128','2013-09-24','11:35:00',3.23),('15128','2013-09-24','11:40:00',2.93),('15128','2013-09-24','11:45:00',3.22),('15128','2013-09-24','11:50:00',2.37),('15128','2013-09-24','12:05:00',1.96),('15128','2013-09-24','12:10:00',3.75),('15128','2013-09-24','12:15:00',2.5),('15128','2013-09-24','12:20:00',3.87),('15128','2013-09-24','12:25:00',3.33),('15128','2013-09-24','12:30:00',1.5),('15128','2013-09-24','12:35:00',1.49),('15128','2013-09-24','12:40:00',4.08),('15128','2013-09-24','12:45:00',4.08),('15128','2013-09-24','12:50:00',4.12),('15128','2013-09-24','12:55:00',4.15),('15128','2013-09-24','13:00:00',4.4),('15128','2013-09-24','13:05:00',4.23),('15128','2013-09-24','13:10:00',1.78),('15128','2013-09-24','13:15:00',4.02),('15128','2013-09-24','13:20:00',4.03),('15128','2013-09-24','13:25:00',4.04),('15128','2013-09-24','13:30:00',4.17),('15128','2013-09-24','13:35:00',4.21),('15128','2013-09-24','13:40:00',3.99),('15128','2013-09-24','13:45:00',3.92),('15128','2013-09-24','13:50:00',4.17),('15128','2013-09-24','13:55:00',4.16),('15128','2013-09-24','14:00:00',3.91),('15128','2013-09-24','14:05:00',3.93),('15128','2013-09-24','14:10:00',3.92),('15128','2013-09-24','14:15:00',3.87),('15128','2013-09-24','14:20:00',3.39),('15128','2013-09-24','14:25:00',2.84),('15128','2013-09-24','14:30:00',3.83),('15128','2013-09-24','14:35:00',3.87),('15128','2013-09-24','14:40:00',3.99),('15128','2013-09-24','14:45:00',3.12),('15128','2013-09-24','14:50:00',2.91),('15128','2013-09-24','14:55:00',2.74),('15128','2013-09-24','15:00:00',2.14),('15128','2013-09-24','15:05:00',3.47),('15128','2013-09-24','15:10:00',2.82),('15128','2013-09-24','15:15:00',3.21),('15128','2013-09-24','15:20:00',3.53),('15128','2013-09-24','15:25:00',3.14),('15128','2013-09-24','15:30:00',3.45),('15128','2013-09-24','15:35:00',3.2),('15128','2013-09-24','15:40:00',3.09),('15128','2013-09-24','15:45:00',3.07),('15128','2013-09-24','15:50:00',3.2),('15128','2013-09-24','15:55:00',3.15),('15128','2013-09-24','16:00:00',3.13),('15128','2013-09-24','16:05:00',3.04),('15128','2013-09-24','16:10:00',2.9),('15128','2013-09-24','16:15:00',2.84),('15128','2013-09-24','16:20:00',2.75),('15128','2013-09-24','16:25:00',2.67),('15128','2013-09-24','16:30:00',2.56),('15128','2013-09-24','16:35:00',2.47),('15128','2013-09-24','16:40:00',2.36),('15128','2013-09-24','16:45:00',2.24),('15128','2013-09-24','16:50:00',2.1),('15128','2013-09-24','16:55:00',1.99),('15128','2013-09-24','17:00:00',1.87),('15128','2013-09-24','17:05:00',1.75),('15128','2013-09-24','17:10:00',1.68),('15128','2013-09-24','17:15:00',1.65),('15128','2013-09-24','17:20:00',1.62),('15128','2013-09-24','17:25:00',1.56),('15128','2013-09-24','17:30:00',1.5),('15128','2013-09-24','17:35:00',1.42),('15128','2013-09-24','17:40:00',1.31),('15128','2013-09-24','17:45:00',1.17),('15128','2013-09-24','17:50:00',1.06),('15128','2013-09-23','09:10:00',1.1),('15128','2013-09-23','09:15:00',1.18),('15128','2013-09-23','09:20:00',1.26),('15128','2013-09-23','09:25:00',1.34),('15128','2013-09-23','09:30:00',1.39),('15128','2013-09-23','09:35:00',1.44),('15128','2013-09-23','09:40:00',1.48),('15128','2013-09-23','09:45:00',1.57),('15128','2013-09-23','09:50:00',1.66),('15128','2013-09-23','09:55:00',1.72),('15128','2013-09-23','10:00:00',1.76),('15128','2013-09-23','10:05:00',1.78),('15128','2013-09-23','10:10:00',1.84),('15128','2013-09-23','10:15:00',1.88),('15128','2013-09-23','10:20:00',1.99),('15128','2013-09-23','10:25:00',2.05),('15128','2013-09-23','10:30:00',2.07),('15128','2013-09-23','10:35:00',2.12),('15128','2013-09-23','10:40:00',2.19),('15128','2013-09-23','10:45:00',2.26),('15128','2013-09-23','10:50:00',2.32),('15128','2013-09-23','10:55:00',2.41),('15128','2013-09-23','11:00:00',2.45),('15128','2013-09-23','11:05:00',2.46),('15128','2013-09-23','11:10:00',2.54),('15128','2013-09-23','11:15:00',2.62),('15128','2013-09-23','11:20:00',2.71),('15128','2013-09-23','11:25:00',2.71),('15128','2013-09-23','11:30:00',2.69),('15128','2013-09-23','11:35:00',2.77),('15128','2013-09-23','11:40:00',2.89),('15128','2013-09-23','11:45:00',2.95),('15128','2013-09-23','11:50:00',3.06),('15128','2013-09-23','11:55:00',3.12),('15128','2013-09-23','12:00:00',3.26),('15128','2013-09-23','12:05:00',3.3),('15128','2013-09-23','12:10:00',3.35),('15128','2013-09-23','12:15:00',3.4),('15128','2013-09-23','12:20:00',3.43),('15128','2013-09-23','12:25:00',3.46),('15128','2013-09-23','12:30:00',3.48),('15128','2013-09-23','12:35:00',3.51),('15128','2013-09-23','12:40:00',3.55),('15128','2013-09-23','12:45:00',3.58),('15128','2013-09-23','12:50:00',3.59),('15128','2013-09-23','12:55:00',3.6),('15128','2013-09-23','13:00:00',3.64),('15128','2013-09-23','13:05:00',3.65),('15128','2013-09-23','13:10:00',3.66),('15128','2013-09-23','13:15:00',3.64),('15128','2013-09-23','13:20:00',3.67),('15128','2013-09-23','13:25:00',3.65),('15128','2013-09-23','13:30:00',3.64),('15128','2013-09-23','13:35:00',3.66),('15128','2013-09-23','13:40:00',3.68),('15128','2013-09-23','13:45:00',3.67),('15128','2013-09-23','13:50:00',3.68),('15128','2013-09-23','13:55:00',3.7),('15128','2013-09-23','14:00:00',3.7),('15128','2013-09-23','14:05:00',3.71),('15128','2013-09-23','14:10:00',3.7),('15128','2013-09-23','14:15:00',3.68),('15128','2013-09-23','14:20:00',3.67),('15128','2013-09-23','14:25:00',3.66),('15128','2013-09-23','14:30:00',3.63),('15128','2013-09-23','14:35:00',3.64),('15128','2013-09-23','14:40:00',3.61),('15128','2013-09-23','14:45:00',3.58),('15128','2013-09-23','14:50:00',3.56),('15128','2013-09-23','14:55:00',3.51),('15128','2013-09-23','15:00:00',3.47),('15128','2013-09-23','15:05:00',3.45),('15128','2013-09-23','15:10:00',3.41),('15128','2013-09-23','15:15:00',3.37),('15128','2013-09-23','15:20:00',3.34),('15128','2013-09-23','15:25:00',3.32),('15128','2013-09-23','15:30:00',3.28),('15128','2013-09-23','15:35:00',3.25),('15128','2013-09-23','15:40:00',3.2),('15128','2013-09-23','15:45:00',3.16),('15128','2013-09-23','15:50:00',3.11),('15128','2013-09-23','15:55:00',3.06),('15128','2013-09-23','16:00:00',2.99),('15128','2013-09-23','16:05:00',2.94),('15128','2013-09-23','16:10:00',2.9),('15128','2013-09-23','16:15:00',2.81),('15128','2013-09-23','16:20:00',2.74),('15128','2013-09-23','16:25:00',2.69),('15128','2013-09-23','16:30:00',2.63),('15128','2013-09-23','16:35:00',2.52),('15128','2013-09-23','16:40:00',2.4),('15128','2013-09-23','16:45:00',2.29),('15128','2013-09-23','16:50:00',2.14),('15128','2013-09-23','16:55:00',2.02),('15128','2013-09-23','17:00:00',1.94),('15128','2013-09-23','17:05:00',1.86),('15128','2013-09-23','17:10:00',1.81),('15128','2013-09-23','17:15:00',1.73),('15128','2013-09-23','17:20:00',1.69),('15128','2013-09-23','17:25:00',1.63),('15128','2013-09-23','17:30:00',1.56),('15128','2013-09-23','17:35:00',1.49),('15128','2013-09-23','17:40:00',1.38),('15128','2013-09-23','17:45:00',1.25),('15128','2013-09-23','17:50:00',1.11),('15128','2013-09-23','17:55:00',1.05),('15128','2013-09-22','09:05:00',1.02),('15128','2013-09-22','09:10:00',1.13),('15128','2013-09-22','09:15:00',1.21),('15128','2013-09-22','09:20:00',1.3),('15128','2013-09-22','09:25:00',1.37),('15128','2013-09-22','09:30:00',1.43),('15128','2013-09-22','09:35:00',1.48),('15128','2013-09-22','09:40:00',1.52),('15128','2013-09-22','09:45:00',1.61),('15128','2013-09-22','09:50:00',1.69),('15128','2013-09-22','09:55:00',1.75),('15128','2013-09-22','10:00:00',1.75),('15128','2013-09-22','10:05:00',1.8),('15128','2013-09-22','10:10:00',1.87),('15128','2013-09-22','10:15:00',1.9),('15128','2013-09-22','10:20:00',2.01),('15128','2013-09-22','10:25:00',2.05),('15128','2013-09-22','10:30:00',2.09),('15128','2013-09-22','10:35:00',2.18),('15128','2013-09-22','10:40:00',2.25),('15128','2013-09-22','10:45:00',2.32),('15128','2013-09-22','10:50:00',2.35),('15128','2013-09-22','10:55:00',2.47),('15128','2013-09-22','11:00:00',2.49),('15128','2013-09-22','11:05:00',2.52),('15128','2013-09-22','11:10:00',2.61),('15128','2013-09-22','11:15:00',2.69),('15128','2013-09-22','11:20:00',2.7),('15128','2013-09-22','11:25:00',2.8),('15128','2013-09-22','11:30:00',2.77),('15128','2013-09-22','11:35:00',2.89),('15128','2013-09-22','11:40:00',3),('15128','2013-09-22','11:45:00',3.08),('15128','2013-09-22','11:50:00',3.11),('15128','2013-09-22','11:55:00',3.16),('15128','2013-09-22','12:00:00',3.35),('15128','2013-09-22','12:05:00',3.38),('15128','2013-09-22','12:10:00',3.42),('15128','2013-09-22','12:15:00',3.44),('15128','2013-09-22','12:20:00',3.44),('15128','2013-09-22','12:25:00',3.52),('15128','2013-09-22','12:30:00',3.55),('15128','2013-09-22','12:35:00',3.56),('15128','2013-09-22','12:40:00',3.59),('15128','2013-09-22','12:45:00',3.64),('15128','2013-09-22','12:50:00',3.65),('15128','2013-09-22','12:55:00',3.67),('15128','2013-09-22','13:00:00',3.67),('15128','2013-09-22','13:05:00',3.67),('15128','2013-09-22','13:10:00',3.68),('15128','2013-09-22','13:15:00',3.68),('15128','2013-09-22','13:20:00',3.67),('15128','2013-09-22','13:25:00',3.67),('15128','2013-09-22','13:30:00',3.68),('15128','2013-09-22','13:35:00',3.68),('15128','2013-09-22','13:40:00',3.68),('15128','2013-09-22','13:45:00',3.68),('15128','2013-09-22','13:50:00',3.67),('15128','2013-09-22','13:55:00',3.66),('15128','2013-09-22','14:00:00',3.64),('15128','2013-09-22','14:05:00',3.63),('15128','2013-09-22','14:10:00',3.63),('15128','2013-09-22','14:15:00',3.71),('15128','2013-09-22','14:20:00',3.76),('15128','2013-09-22','14:25:00',3.14),('15128','2013-09-22','14:30:00',3.57),('15128','2013-09-22','14:35:00',3.52),('15128','2013-09-22','14:40:00',3.59),('15128','2013-09-22','14:45:00',3.07),('15128','2013-09-22','14:50:00',2.87),('15128','2013-09-22','14:55:00',3.43),('15128','2013-09-22','15:00:00',3.33),('15128','2013-09-22','15:05:00',3.36),('15128','2013-09-22','15:10:00',3.33),('15128','2013-09-22','15:15:00',3.3),('15128','2013-09-22','15:20:00',3.25),('15128','2013-09-22','15:25:00',3.22),('15128','2013-09-22','15:30:00',3.24),('15128','2013-09-22','15:35:00',3.21),('15128','2013-09-22','15:40:00',3.12),('15128','2013-09-22','15:45:00',3.06),('15128','2013-09-22','15:50:00',3.08),('15128','2013-09-22','15:55:00',2.97),('15128','2013-09-22','16:00:00',2.9),('15128','2013-09-22','16:05:00',2.82),('15128','2013-09-22','16:10:00',2.79),('15128','2013-09-22','16:15:00',2.73),('15128','2013-09-22','16:20:00',2.73),('15128','2013-09-22','16:25:00',2.66),('15128','2013-09-22','16:30:00',2.56),('15128','2013-09-22','16:35:00',2.47),('15128','2013-09-22','16:40:00',2.4),('15128','2013-09-22','16:45:00',2.24),('15128','2013-09-22','16:50:00',2.13),('15128','2013-09-22','16:55:00',2.06),('15128','2013-09-22','17:00:00',1.97),('15128','2013-09-22','17:05:00',1.86),('15128','2013-09-22','17:10:00',1.79),('15128','2013-09-22','17:15:00',1.69),('15128','2013-09-22','17:20:00',1.64),('15128','2013-09-22','17:25:00',1.59),('15128','2013-09-22','17:30:00',1.51),('15128','2013-09-22','17:35:00',1.45),('15128','2013-09-22','17:40:00',1.33),('15128','2013-09-22','17:45:00',1.19),('15128','2013-09-22','17:50:00',1.06),('15128','2013-09-21','09:05:00',1.03),('15128','2013-09-21','09:10:00',1.13),('15128','2013-09-21','09:15:00',1.2),('15128','2013-09-21','09:20:00',1.29),('15128','2013-09-21','09:25:00',1.36),('15128','2013-09-21','09:30:00',1.43),('15128','2013-09-21','09:35:00',1.49),('15128','2013-09-21','09:40:00',1.53),('15128','2013-09-21','09:45:00',1.64),('15128','2013-09-21','09:50:00',1.72),('15128','2013-09-21','09:55:00',1.79),('15128','2013-09-21','10:00:00',1.81),('15128','2013-09-21','10:05:00',1.85),('15128','2013-09-21','10:10:00',1.91),('15128','2013-09-21','10:15:00',1.99),('15128','2013-09-21','10:20:00',2.06),('15128','2013-09-21','10:25:00',2.1),('15128','2013-09-21','10:30:00',2.15),('15128','2013-09-21','10:35:00',2.23),('15128','2013-09-21','10:40:00',2.28),('15128','2013-09-21','10:45:00',2.37),('15128','2013-09-21','10:50:00',2.42),('15128','2013-09-21','10:55:00',2.49),('15128','2013-09-21','11:00:00',2.54),('15128','2013-09-21','11:05:00',2.63),('15128','2013-09-21','11:10:00',2.67),('15128','2013-09-21','11:15:00',2.75),('15128','2013-09-21','11:20:00',2.75),('15128','2013-09-21','11:25:00',2.84),('15128','2013-09-21','11:30:00',2.91),('15128','2013-09-21','11:35:00',2.96),('15128','2013-09-21','11:40:00',3.03),('15128','2013-09-21','11:45:00',3.05),('15128','2013-09-21','11:50:00',3.15),('15128','2013-09-21','11:55:00',3.26),('15128','2013-09-21','12:00:00',3.37),('15128','2013-09-21','12:05:00',3.42),('15128','2013-09-21','12:10:00',3.47),('15128','2013-09-21','12:15:00',3.5),('15128','2013-09-21','12:20:00',3.51),('15128','2013-09-21','12:25:00',3.54),('15128','2013-09-21','12:30:00',3.62),('15128','2013-09-21','12:35:00',3.66),('15128','2013-09-21','12:40:00',3.68),('15128','2013-09-21','12:45:00',3.71),('15128','2013-09-21','12:50:00',3.72),('15128','2013-09-21','12:55:00',3.74),('15128','2013-09-21','13:00:00',3.76),('15128','2013-09-21','13:05:00',3.79),('15128','2013-09-21','13:10:00',3.78),('15128','2013-09-21','13:15:00',3.81),('15128','2013-09-21','13:20:00',3.83),('15128','2013-09-21','13:25:00',3.86),('15128','2013-09-21','13:30:00',3.97),('15128','2013-09-21','13:35:00',4.14),('15128','2013-09-21','13:40:00',3.38),('15128','2013-09-21','13:45:00',3.68),('15128','2013-09-21','13:50:00',2.6),('15128','2013-09-21','13:55:00',2.53),('15128','2013-09-21','14:00:00',3.6),('15128','2013-09-21','14:05:00',3.49),('15128','2013-09-21','14:10:00',4.14),('15128','2013-09-21','14:15:00',3.92),('15128','2013-09-21','14:20:00',4.08),('15128','2013-09-21','14:25:00',3.32),('15128','2013-09-21','14:30:00',1.43),('15128','2013-09-21','14:35:00',3.95),('15128','2013-09-21','14:40:00',3.15),('15128','2013-09-21','14:45:00',3.79),('15128','2013-09-21','14:50:00',3.8),('15128','2013-09-21','14:55:00',3.89),('15128','2013-09-21','15:00:00',1.59),('15128','2013-09-21','15:05:00',1.46),('15128','2013-09-21','15:10:00',2.27),('15128','2013-09-21','15:15:00',2.22),('15128','2013-09-21','15:20:00',1.78),('15128','2013-09-21','15:25:00',1.49),('15128','2013-09-21','15:30:00',3.75),('15128','2013-09-21','15:35:00',3.98),('15128','2013-09-21','15:40:00',3.47),('15128','2013-09-21','15:45:00',3.4),('15128','2013-09-21','15:50:00',3.49),('15128','2013-09-21','15:55:00',3.54),('15128','2013-09-21','16:00:00',3.5),('15128','2013-09-21','16:05:00',3.35),('15128','2013-09-21','16:10:00',2.16),('15128','2013-09-21','16:15:00',1.87),('15128','2013-09-21','16:20:00',2.06),('15128','2013-09-21','16:25:00',1.22),('15128','2013-09-21','16:30:00',1.11),('15128','2013-09-21','16:35:00',1.14),('15128','2013-09-21','16:40:00',1.23),('15128','2013-09-21','16:45:00',1.27),('15128','2013-09-21','16:50:00',2.13),('15128','2013-09-21','16:55:00',2.52),('15128','2013-09-21','17:00:00',2.33),('15128','2013-09-21','17:05:00',2.07),('15128','2013-09-21','17:10:00',1.97),('15128','2013-09-21','17:15:00',1.86),('15128','2013-09-21','17:20:00',1.81),('15128','2013-09-21','17:25:00',1.74),('15128','2013-09-21','17:30:00',1.58),('15128','2013-09-20','09:05:00',1.05),('15128','2013-09-20','09:10:00',1.15),('15128','2013-09-20','09:15:00',1.22),('15128','2013-09-20','09:20:00',1.31),('15128','2013-09-20','09:25:00',1.38),('15128','2013-09-20','09:30:00',1.44),('15128','2013-09-20','09:35:00',1.49),('15128','2013-09-20','09:40:00',1.52),('15128','2013-09-20','09:45:00',1.63),('15128','2013-09-20','09:50:00',1.64),('15128','2013-09-20','09:55:00',1.74),('15128','2013-09-20','10:00:00',1.78),('15128','2013-09-20','10:05:00',1.82),('15128','2013-09-20','10:10:00',1.85),('15128','2013-09-20','10:15:00',1.92),('15128','2013-09-20','10:20:00',1.99),('15128','2013-09-20','10:25:00',2.04),('15128','2013-09-20','10:30:00',2.08),('15128','2013-09-20','10:35:00',2.14),('15128','2013-09-20','10:40:00',2.24),('15128','2013-09-20','10:45:00',2.31),('15128','2013-09-20','10:50:00',2.34),('15128','2013-09-20','10:55:00',2.39),('15128','2013-09-20','11:00:00',2.43),('15128','2013-09-20','11:05:00',2.51),('15128','2013-09-20','11:10:00',2.57),('15128','2013-09-20','11:15:00',2.65),('15128','2013-09-20','11:20:00',2.67),('15128','2013-09-20','11:25:00',2.78),('15128','2013-09-20','11:30:00',2.73),('15128','2013-09-20','11:35:00',2.84),('15128','2013-09-20','11:40:00',2.9),('15128','2013-09-20','11:45:00',2.79),('15128','2013-09-20','11:50:00',3.11),('15128','2013-09-20','11:55:00',3.27),('15128','2013-09-20','12:00:00',3.37),('15128','2013-09-20','12:05:00',3.41),('15128','2013-09-20','12:10:00',3.45),('15128','2013-09-20','12:15:00',3.21),('15128','2013-09-20','12:20:00',3.03),('15128','2013-09-20','12:25:00',3.28),('15128','2013-09-20','12:30:00',3.06),('15128','2013-09-20','12:35:00',3.53),('15128','2013-09-20','12:40:00',3.03),('15128','2013-09-20','12:45:00',3.38),('15128','2013-09-20','12:50:00',3.68),('15128','2013-09-20','12:55:00',2.59),('15128','2013-09-20','13:00:00',3.56),('15128','2013-09-20','13:05:00',3.65),('15128','2013-09-20','13:10:00',3.8),('15128','2013-09-20','13:15:00',3.52),('15128','2013-09-20','13:20:00',2.4),('15128','2013-09-20','13:25:00',3.38),('15128','2013-09-20','13:30:00',3.15),('15128','2013-09-20','13:35:00',3.68),('15128','2013-09-20','13:40:00',3.78),('15128','2013-09-20','13:45:00',3.73),('15128','2013-09-20','13:50:00',3.71),('15128','2013-09-20','13:55:00',3.71),('15128','2013-09-20','14:00:00',3.49),('15128','2013-09-20','14:05:00',3.67),('15128','2013-09-20','14:10:00',3.65),('15128','2013-09-20','14:15:00',3.49),('15128','2013-09-20','14:20:00',3.65),('15128','2013-09-20','14:25:00',3.61),('15128','2013-09-20','14:30:00',3.56),('15128','2013-09-20','14:35:00',3.53),('15128','2013-09-20','14:40:00',3.52),('15128','2013-09-20','14:45:00',3.5),('15128','2013-09-20','14:50:00',3.47),('15128','2013-09-20','14:55:00',3.44),('15128','2013-09-20','15:00:00',3.27),('15128','2013-09-20','15:05:00',3.36),('15128','2013-09-20','15:10:00',3.34),('15128','2013-09-20','15:15:00',3.31),('15128','2013-09-20','15:20:00',3.27),('15128','2013-09-20','15:25:00',3.24),('15128','2013-09-20','15:30:00',3.2),('15128','2013-09-20','15:35:00',3.18),('15128','2013-09-20','15:40:00',3.16),('15128','2013-09-20','15:45:00',3.14),('15128','2013-09-20','15:50:00',3.14),('15128','2013-09-20','15:55:00',2.37),('15128','2013-09-20','16:00:00',2.54),('15128','2013-09-20','16:05:00',1.83),('15128','2013-09-20','16:10:00',2.21),('15128','2013-09-20','16:15:00',2.11),('15128','2013-09-20','16:20:00',1.25),('15128','2013-09-20','16:25:00',2.05),('15128','2013-09-20','16:30:00',2.26),('15128','2013-09-20','16:35:00',1.02),('15128','2013-09-20','16:40:00',1.28),('15128','2013-09-20','16:45:00',1.36),('15128','2013-09-20','16:55:00',1.22),('15128','2013-09-20','17:00:00',1.49),('15128','2013-09-20','17:05:00',1.16),('15128','2013-09-20','17:10:00',1.73),('15128','2013-09-20','17:15:00',1.05),('15128','2013-09-20','17:30:00',1.36),('15128','2013-09-20','17:35:00',1.31),('15128','2013-09-20','17:40:00',1.37),('15128','2013-09-20','17:45:00',1.18),('15128','2013-09-20','17:50:00',1.03),('15128','2013-09-19','09:25:00',1),('15128','2013-09-19','09:35:00',1.09),('15128','2013-09-19','09:40:00',1.2),('15128','2013-09-19','09:45:00',1.3),('15128','2013-09-19','09:50:00',1.31),('15128','2013-09-19','09:55:00',1.34),('15128','2013-09-19','10:00:00',1.41),('15128','2013-09-19','10:05:00',1.54),('15128','2013-09-19','10:10:00',1.67),('15128','2013-09-19','10:15:00',1.94),('15128','2013-09-19','10:20:00',2.5),('15128','2013-09-19','10:25:00',2.78),('15128','2013-09-19','10:30:00',2.62),('15128','2013-09-19','10:35:00',2.19),('15128','2013-09-19','10:40:00',2.2),('15128','2013-09-19','10:45:00',2.17),('15128','2013-09-19','10:50:00',2.02),('15128','2013-09-19','10:55:00',2.51),('15128','2013-09-19','11:00:00',2.59),('15128','2013-09-19','11:05:00',2.57),('15128','2013-09-19','11:10:00',2.45),('15128','2013-09-19','11:15:00',2.62),('15128','2013-09-19','11:20:00',2.35),('15128','2013-09-19','11:25:00',2.15),('15128','2013-09-19','11:30:00',2.31),('15128','2013-09-19','11:35:00',2.27),('15128','2013-09-19','11:40:00',2.36),('15128','2013-09-19','11:45:00',3.28),('15128','2013-09-19','11:50:00',2.06),('15128','2013-09-19','11:55:00',3.16),('15128','2013-09-19','12:00:00',3.63),('15128','2013-09-19','12:05:00',3.85),('15128','2013-09-19','12:10:00',3.64),('15128','2013-09-19','12:15:00',3.56),('15128','2013-09-19','12:20:00',3.58),('15128','2013-09-19','12:25:00',3.68),('15128','2013-09-19','12:30:00',3.7),('15128','2013-09-19','12:35:00',3.57),('15128','2013-09-19','12:40:00',1.89),('15128','2013-09-19','12:45:00',3.38),('15128','2013-09-19','12:50:00',3.79),('15128','2013-09-19','12:55:00',3.7),('15128','2013-09-19','13:00:00',3.67),('15128','2013-09-19','13:05:00',3.67),('15128','2013-09-19','13:10:00',3.67),('15128','2013-09-19','13:15:00',3.67),('15128','2013-09-19','13:20:00',3.73),('15128','2013-09-19','13:25:00',3.74),('15128','2013-09-19','13:30:00',3.75),('15128','2013-09-19','13:35:00',3.79),('15128','2013-09-19','13:40:00',3.77),('15128','2013-09-19','13:45:00',3.63),('15128','2013-09-19','13:50:00',3.67),('15128','2013-09-19','13:55:00',3.22),('15128','2013-09-19','14:00:00',3.39),('15128','2013-09-19','14:05:00',2.57),('15128','2013-09-19','14:10:00',2.63),('15128','2013-09-19','14:15:00',3.77),('15128','2013-09-19','14:20:00',3.82),('15128','2013-09-19','14:25:00',3.83),('15128','2013-09-19','14:30:00',3.16),('15128','2013-09-19','14:35:00',3.53),('15128','2013-09-19','14:40:00',3.77),('15128','2013-09-19','14:45:00',3.81),('15128','2013-09-19','14:50:00',3.61),('15128','2013-09-19','14:55:00',3.37),('15128','2013-09-19','15:00:00',3.35),('15128','2013-09-19','15:05:00',3.38),('15128','2013-09-19','15:10:00',1.48),('15128','2013-09-19','15:15:00',2.05),('15128','2013-09-19','15:20:00',3.47),('15128','2013-09-19','15:25:00',3.14),('15128','2013-09-19','15:30:00',3.11),('15128','2013-09-19','15:35:00',3.2),('15128','2013-09-19','15:40:00',3.4),('15128','2013-09-19','15:45:00',3.34),('15128','2013-09-19','15:50:00',2.74),('15128','2013-09-19','15:55:00',3.03),('15128','2013-09-19','16:00:00',3.18),('15128','2013-09-19','16:05:00',3.18),('15128','2013-09-19','16:10:00',3.22),('15128','2013-09-19','16:15:00',3.2),('15128','2013-09-19','16:20:00',3.17),('15128','2013-09-19','16:25:00',1.6),('15128','2013-09-19','16:30:00',1.21),('15128','2013-09-19','16:45:00',1.37),('15128','2013-09-19','16:50:00',2.07),('15128','2013-09-19','16:55:00',2.4),('15128','2013-09-19','17:00:00',2.4),('15128','2013-09-19','17:05:00',2.38),('15128','2013-09-19','17:10:00',2.38),('15128','2013-09-19','17:15:00',2.41),('15128','2013-09-19','17:20:00',2.33),('15128','2013-09-19','17:25:00',2.23),('15128','2013-09-19','17:30:00',2.3),('15128','2013-09-19','17:35:00',2.1),('15128','2013-09-19','17:40:00',2.11),('15128','2013-09-19','17:45:00',1.7),('15128','2013-09-19','17:50:00',1.05),('15128','2013-09-19','17:55:00',1.01),('15128','2013-09-18','09:05:00',1.16),('15128','2013-09-18','09:10:00',1),('15128','2013-09-18','09:25:00',1.26),('15128','2013-09-18','09:30:00',1.15),('15128','2013-09-18','09:35:00',1.52),('15128','2013-09-18','09:40:00',1.66),('15128','2013-09-18','09:45:00',1.76),('15128','2013-09-18','09:50:00',1.79),('15128','2013-09-18','09:55:00',1.42),('15128','2013-09-18','10:50:00',1.09),('15128','2013-09-18','10:55:00',2.03),('15128','2013-09-18','11:00:00',2.74),('15128','2013-09-18','11:05:00',2.56),('15128','2013-09-18','11:15:00',1.64),('15128','2013-09-18','11:20:00',2.93),('15128','2013-09-18','11:25:00',2.56),('15128','2013-09-18','11:30:00',2.29),('15128','2013-09-18','11:35:00',2.79),('15128','2013-09-18','11:40:00',2.13),('15128','2013-09-18','11:45:00',2.53),('15128','2013-09-18','11:50:00',1.51),('15128','2013-09-18','11:55:00',3.8),('15128','2013-09-18','12:00:00',2.43),('15128','2013-09-18','12:05:00',3.76),('15128','2013-09-18','12:10:00',2.72),('15128','2013-09-18','12:15:00',1.59),('15128','2013-09-18','12:20:00',2.21),('15128','2013-09-18','12:25:00',3.07),('15128','2013-09-18','12:30:00',3.06),('15128','2013-09-18','12:35:00',4.08),('15128','2013-09-18','12:40:00',3.1),('15128','2013-09-18','12:45:00',2.07),('15128','2013-09-18','12:50:00',4.19),('15128','2013-09-18','12:55:00',4.17),('15128','2013-09-18','13:00:00',4.28),('15128','2013-09-18','13:05:00',3.02),('15128','2013-09-18','13:10:00',3.98),('15128','2013-09-18','13:15:00',4.22),('15128','2013-09-18','13:20:00',4.15),('15128','2013-09-18','13:25:00',4.23),('15128','2013-09-18','13:30:00',4.28),('15128','2013-09-18','13:35:00',2.3),('15128','2013-09-18','13:40:00',1.59),('15128','2013-09-18','13:45:00',3.05),('15128','2013-09-18','13:50:00',4.33),('15128','2013-09-18','13:55:00',3.18),('15128','2013-09-18','14:00:00',4.12),('15128','2013-09-18','14:05:00',3.95),('15128','2013-09-18','14:10:00',3.91),('15128','2013-09-18','14:15:00',3.85),('15128','2013-09-18','14:20:00',3.85),('15128','2013-09-18','14:25:00',3.84),('15128','2013-09-18','14:30:00',3.82),('15128','2013-09-18','14:35:00',3.04),('15128','2013-09-18','14:40:00',3.75),('15128','2013-09-18','14:45:00',3.75),('15128','2013-09-18','14:50:00',3.24),('15128','2013-09-18','14:55:00',3.59),('15128','2013-09-18','15:00:00',3.6),('15128','2013-09-18','15:05:00',3.67),('15128','2013-09-18','15:10:00',3.88),('15128','2013-09-18','15:15:00',3.65),('15128','2013-09-18','15:20:00',3.44),('15128','2013-09-18','15:25:00',3.71),('15128','2013-09-18','15:30:00',3.42),('15128','2013-09-18','15:35:00',3.25),('15128','2013-09-18','15:40:00',3.1),('15128','2013-09-18','15:45:00',2.22),('15128','2013-09-18','15:50:00',1.67),('15128','2013-09-18','15:55:00',1.43),('15128','2013-09-18','16:00:00',1.72),('15128','2013-09-18','16:05:00',1.88),('15128','2013-09-18','16:10:00',2.99),('15128','2013-09-18','16:15:00',2.98),('15128','2013-09-18','16:20:00',2.55),('15128','2013-09-18','16:25:00',2.67),('15128','2013-09-18','16:30:00',2.38),('15128','2013-09-18','16:35:00',2.62),('15128','2013-09-18','16:40:00',1.87),('15128','2013-09-18','16:45:00',2.63),('15128','2013-09-18','16:50:00',2.18),('15128','2013-09-18','16:55:00',2.12),('15128','2013-09-18','17:00:00',2.09),('15128','2013-09-18','17:05:00',1.87),('15128','2013-09-18','17:10:00',1.9),('15128','2013-09-18','17:15:00',1.71),('15128','2013-09-18','17:20:00',1.6),('15128','2013-09-18','17:25:00',1.59),('15128','2013-09-18','17:30:00',1.16),('15128','2013-09-18','17:35:00',1.11),('15128','2013-09-17','09:20:00',1.04),('15128','2013-09-17','09:30:00',1.34),('15128','2013-09-17','09:50:00',1.86),('15128','2013-09-17','09:55:00',1.64),('15128','2013-09-17','10:00:00',1.83),('15128','2013-09-17','10:05:00',1.94),('15128','2013-09-17','10:10:00',1.97),('15128','2013-09-17','10:15:00',2.03),('15128','2013-09-17','10:20:00',2.06),('15128','2013-09-17','10:25:00',2.11),('15128','2013-09-17','10:30:00',2.17),('15128','2013-09-17','10:35:00',2.24),('15128','2013-09-17','10:40:00',2.26),('15128','2013-09-17','10:45:00',2.29),('15128','2013-09-17','10:50:00',2.34),('15128','2013-09-17','10:55:00',2.4),('15128','2013-09-17','11:00:00',2.51),('15128','2013-09-17','11:05:00',2.57),('15128','2013-09-17','11:10:00',2.63),('15128','2013-09-17','11:15:00',3.03),('15128','2013-09-17','11:20:00',3.13),('15128','2013-09-17','11:25:00',3.13),('15128','2013-09-17','11:30:00',2.83),('15128','2013-09-17','11:35:00',3.1),('15128','2013-09-17','11:40:00',3.19),('15128','2013-09-17','11:45:00',3.22),('15128','2013-09-17','11:50:00',3.35),('15128','2013-09-17','11:55:00',3.53),('15128','2013-09-17','12:00:00',3.53),('15128','2013-09-17','12:05:00',3.56),('15128','2013-09-17','12:10:00',3.84),('15128','2013-09-17','12:15:00',3.09),('15128','2013-09-17','12:20:00',3.66),('15128','2013-09-17','12:25:00',2.46),('15128','2013-09-17','12:30:00',3.02),('15128','2013-09-17','12:35:00',3.3),('15128','2013-09-17','12:40:00',1.14),('15128','2013-09-17','12:45:00',1.58),('15128','2013-09-17','12:50:00',2),('15128','2013-09-17','12:55:00',4.33),('15128','2013-09-17','13:00:00',3.65),('15128','2013-09-17','13:05:00',3.59),('15128','2013-09-17','13:10:00',1.71),('15128','2013-09-17','13:15:00',2.34),('15128','2013-09-17','13:20:00',4.22),('15128','2013-09-17','13:25:00',2.44),('15128','2013-09-17','13:30:00',4.38),('15128','2013-09-17','13:35:00',2.17),('15128','2013-09-17','13:40:00',3),('15128','2013-09-17','13:45:00',1.79),('15128','2013-09-17','13:50:00',1.29),('15128','2013-09-17','13:55:00',3.87),('15128','2013-09-17','14:00:00',4.58),('15128','2013-09-17','14:05:00',3.84),('15128','2013-09-17','14:10:00',3.47),('15128','2013-09-17','14:15:00',2.03),('15128','2013-09-17','14:20:00',3.72),('15128','2013-09-17','14:25:00',4.01),('15128','2013-09-17','14:30:00',3.91),('15128','2013-09-17','14:35:00',3.92),('15128','2013-09-17','14:40:00',3.95),('15128','2013-09-17','14:45:00',3.47),('15128','2013-09-17','14:50:00',3.2),('15128','2013-09-17','14:55:00',2.25),('15128','2013-09-17','15:00:00',2.09),('15128','2013-09-17','15:05:00',3.31),('15128','2013-09-17','15:10:00',2.38),('15128','2013-09-17','15:15:00',1.54),('15128','2013-09-17','15:20:00',1.32),('15128','2013-09-17','15:25:00',3.57),('15128','2013-09-17','15:30:00',3.21),('15128','2013-09-17','15:35:00',1.55),('15128','2013-09-17','15:40:00',2.68),('15128','2013-09-17','15:45:00',3.52),('15128','2013-09-17','15:50:00',3.37),('15128','2013-09-17','15:55:00',3.24),('15128','2013-09-17','16:00:00',2.8),('15128','2013-09-17','16:05:00',1.97),('15128','2013-09-17','16:10:00',1.65),('15128','2013-09-17','16:15:00',2.29);
INSERT INTO `solarlog` VALUES ('15128','2013-09-17','16:20:00',2.94),('15128','2013-09-17','16:25:00',2.78),('15128','2013-09-17','16:30:00',2.7),('15128','2013-09-17','16:35:00',2.46),('15128','2013-09-17','16:40:00',2.25),('15128','2013-09-17','16:45:00',2.21),('15128','2013-09-17','16:50:00',2.34),('15128','2013-09-17','16:55:00',2.24),('15128','2013-09-17','17:00:00',1.56),('15128','2013-09-17','17:05:00',2.11),('15128','2013-09-17','17:10:00',1.99),('15128','2013-09-17','17:15:00',2.05),('15128','2013-09-17','17:20:00',1.73),('15128','2013-09-17','17:25:00',1.87),('15128','2013-09-17','17:30:00',1.76),('15128','2013-09-17','17:35:00',1.6),('15128','2013-09-17','17:40:00',1.53),('15128','2013-09-17','17:45:00',1.39),('15128','2013-09-17','17:50:00',1.33),('15128','2013-09-17','17:55:00',1.16),('15128','2013-09-16','09:25:00',1.01),('15128','2013-09-16','09:40:00',2.18),('15128','2013-09-16','09:45:00',1.29),('15128','2013-09-16','09:50:00',1.59),('15128','2013-09-16','09:55:00',1.66),('15128','2013-09-16','10:00:00',1.83),('15128','2013-09-16','10:05:00',2),('15128','2013-09-16','10:10:00',1.04),('15128','2013-09-16','10:15:00',1.34),('15128','2013-09-16','10:20:00',2.9),('15128','2013-09-16','10:25:00',1.36),('15128','2013-09-16','10:30:00',1.5),('15128','2013-09-16','10:35:00',1.84),('15128','2013-09-16','10:40:00',2.7),('15128','2013-09-16','10:45:00',2.33),('15128','2013-09-16','10:50:00',2),('15128','2013-09-16','10:55:00',1.96),('15128','2013-09-16','11:00:00',1.85),('15128','2013-09-16','11:05:00',3.18),('15128','2013-09-16','11:10:00',2.21),('15128','2013-09-16','11:15:00',1.26),('15128','2013-09-16','11:20:00',1.55),('15128','2013-09-16','11:25:00',2.16),('15128','2013-09-16','11:30:00',1.53),('15128','2013-09-16','11:35:00',2.91),('15128','2013-09-16','11:40:00',3.13),('15128','2013-09-16','11:45:00',3.07),('15128','2013-09-16','11:50:00',1.79),('15128','2013-09-16','11:55:00',3.87),('15128','2013-09-16','12:00:00',2.24),('15128','2013-09-16','12:05:00',1.02),('15128','2013-09-16','12:10:00',1.43),('15128','2013-09-16','12:15:00',1.76),('15128','2013-09-16','12:20:00',1.81),('15128','2013-09-16','12:25:00',1.08),('15128','2013-09-16','12:30:00',1.48),('15128','2013-09-16','12:35:00',1.67),('15128','2013-09-16','12:40:00',2.93),('15128','2013-09-16','12:45:00',3.05),('15128','2013-09-16','12:50:00',3.61),('15128','2013-09-16','12:55:00',2.77),('15128','2013-09-16','13:00:00',3.63),('15128','2013-09-16','13:05:00',3.14),('15128','2013-09-16','13:10:00',2.91),('15128','2013-09-16','13:15:00',2.24),('15128','2013-09-16','13:20:00',1.71),('15128','2013-09-16','13:25:00',1.64),('15128','2013-09-16','13:30:00',1.09),('15128','2013-09-16','13:35:00',1.32),('15128','2013-09-16','13:40:00',2.38),('15128','2013-09-16','13:45:00',1.16),('15128','2013-09-16','13:50:00',1.79),('15128','2013-09-16','13:55:00',1.98),('15128','2013-09-16','14:00:00',1.21),('15128','2013-09-16','14:05:00',1.51),('15128','2013-09-16','14:10:00',1.61),('15128','2013-09-16','14:15:00',1.32),('15128','2013-09-16','14:20:00',1.04),('15128','2013-09-16','14:30:00',1.89),('15128','2013-09-16','14:35:00',1.11),('15128','2013-09-16','14:40:00',1.16),('15128','2013-09-16','14:45:00',1.28),('15128','2013-09-16','14:50:00',2.84),('15128','2013-09-16','14:55:00',4.02),('15128','2013-09-16','15:00:00',3.52),('15128','2013-09-16','15:05:00',2.95),('15128','2013-09-16','15:10:00',3.03),('15128','2013-09-16','15:15:00',1.26),('15128','2013-09-16','15:30:00',1.08),('15128','2013-09-16','15:35:00',1.42),('15128','2013-09-16','15:40:00',1.76),('15128','2013-09-16','15:45:00',2.67),('15128','2013-09-16','15:50:00',2.38),('15128','2013-09-16','15:55:00',2.63),('15128','2013-09-16','16:00:00',2.84),('15128','2013-09-16','16:05:00',2.13),('15128','2013-09-16','16:10:00',2.51),('15128','2013-09-16','16:15:00',1.58),('15128','2013-09-16','16:30:00',1.01),('15128','2013-09-16','16:35:00',1.23),('15128','2013-09-16','16:40:00',1.7),('15128','2013-09-16','16:45:00',1.81),('15128','2013-09-16','16:50:00',1.15),('15128','2013-09-16','16:55:00',1.49),('15128','2013-09-16','17:00:00',1.91),('15128','2013-09-16','17:05:00',1.84),('15128','2013-09-16','17:10:00',2.03),('15128','2013-09-16','17:15:00',1.77),('15128','2013-09-16','17:20:00',1.65),('15128','2013-09-16','17:25:00',1.64),('15128','2013-09-16','17:30:00',1.6),('15128','2013-09-16','17:35:00',1.53),('15128','2013-09-16','17:40:00',1.27),('15128','2013-09-15','08:50:00',1.08),('15128','2013-09-15','09:15:00',1.28),('15128','2013-09-15','09:20:00',1.44),('15128','2013-09-15','09:25:00',1.48),('15128','2013-09-15','09:30:00',1.49),('15128','2013-09-15','09:35:00',1.52),('15128','2013-09-15','09:40:00',1.58),('15128','2013-09-15','09:45:00',1.7),('15128','2013-09-15','09:50:00',1.8),('15128','2013-09-15','09:55:00',1.86),('15128','2013-09-15','10:00:00',1.75),('15128','2013-09-15','10:05:00',1.93),('15128','2013-09-15','10:10:00',2.31),('15128','2013-09-15','10:15:00',2.3),('15128','2013-09-15','10:20:00',1.68),('15128','2013-09-15','10:25:00',1.87),('15128','2013-09-15','10:40:00',2.84),('15128','2013-09-15','10:45:00',1.77),('15128','2013-09-15','10:50:00',2.24),('15128','2013-09-15','10:55:00',1.88),('15128','2013-09-15','11:00:00',1.99),('15128','2013-09-15','11:05:00',3.4),('15128','2013-09-15','11:10:00',3.14),('15128','2013-09-15','11:15:00',3.06),('15128','2013-09-15','11:20:00',3.38),('15128','2013-09-15','11:25:00',3.31),('15128','2013-09-15','11:30:00',3.13),('15128','2013-09-15','11:35:00',3.27),('15128','2013-09-15','11:40:00',1.84),('15128','2013-09-15','11:45:00',3.59),('15128','2013-09-15','11:50:00',3.7),('15128','2013-09-15','11:55:00',3.84),('15128','2013-09-15','12:00:00',4.02),('15128','2013-09-15','12:05:00',3.79),('15128','2013-09-15','12:10:00',3.43),('15128','2013-09-15','12:15:00',3.17),('15128','2013-09-15','12:20:00',2.01),('15128','2013-09-15','12:25:00',3.87),('15128','2013-09-15','12:30:00',3.95),('15128','2013-09-15','12:35:00',4.1),('15128','2013-09-15','12:40:00',1.22),('15128','2013-09-15','12:45:00',1.25),('15128','2013-09-15','12:55:00',2.23),('15128','2013-09-15','13:00:00',4.69),('15128','2013-09-15','13:05:00',2.1),('15128','2013-09-15','13:10:00',4.19),('15128','2013-09-15','13:15:00',3.47),('15128','2013-09-15','13:20:00',3.89),('15128','2013-09-15','13:25:00',4.08),('15128','2013-09-15','13:30:00',3.89),('15128','2013-09-15','13:35:00',4.06),('15128','2013-09-15','13:40:00',2.72),('15128','2013-09-15','13:45:00',4.13),('15128','2013-09-15','13:50:00',4.15),('15128','2013-09-15','13:55:00',4.15),('15128','2013-09-15','14:00:00',3.86),('15128','2013-09-15','14:05:00',3.98),('15128','2013-09-15','14:10:00',3.91),('15128','2013-09-15','14:15:00',3.88),('15128','2013-09-15','14:20:00',3.88),('15128','2013-09-15','14:25:00',3.87),('15128','2013-09-15','14:30:00',3.83),('15128','2013-09-15','14:35:00',3.81),('15128','2013-09-15','14:40:00',3.79),('15128','2013-09-15','14:45:00',3.79),('15128','2013-09-15','14:50:00',3.79),('15128','2013-09-15','14:55:00',3.78),('15128','2013-09-15','15:00:00',3.74),('15128','2013-09-15','15:05:00',3.71),('15128','2013-09-15','15:10:00',3.68),('15128','2013-09-15','15:15:00',3.66),('15128','2013-09-15','15:20:00',3.6),('15128','2013-09-15','15:25:00',3.57),('15128','2013-09-15','15:30:00',3.54),('15128','2013-09-15','15:35:00',3.5),('15128','2013-09-15','15:40:00',3.44),('15128','2013-09-15','15:45:00',3.41),('15128','2013-09-15','15:50:00',3.15),('15128','2013-09-15','15:55:00',3.42),('15128','2013-09-15','16:00:00',3.42),('15128','2013-09-15','16:05:00',3.23),('15128','2013-09-15','16:10:00',3.15),('15128','2013-09-15','16:15:00',3.09),('15128','2013-09-15','16:20:00',3.05),('15128','2013-09-15','16:25:00',2.99),('15128','2013-09-15','16:30:00',2.92),('15128','2013-09-15','16:35:00',2.85),('15128','2013-09-15','16:40:00',2.79),('15128','2013-09-15','16:45:00',2.71),('15128','2013-09-15','16:50:00',2.59),('15128','2013-09-15','16:55:00',2.47),('15128','2013-09-15','17:00:00',2.37),('15128','2013-09-15','17:05:00',2.26),('15128','2013-09-15','17:10:00',2.17),('15128','2013-09-15','17:15:00',2.04),('15128','2013-09-15','17:20:00',1.73),('15128','2013-09-15','17:25:00',1.33),('15128','2013-09-15','17:30:00',1.71),('15128','2013-09-15','17:35:00',1.62),('15128','2013-09-15','17:40:00',1.68),('15128','2013-09-15','17:45:00',1.59),('15128','2013-09-15','17:50:00',1.46),('15128','2013-09-15','17:55:00',1.33),('15128','2013-09-15','18:00:00',1.2),('15128','2013-09-15','18:05:00',1.1),('15128','2013-09-15','18:10:00',1.02),('15128','2013-09-14','08:55:00',1.04),('15128','2013-09-14','09:00:00',1.1),('15128','2013-09-14','09:05:00',1.18),('15128','2013-09-14','09:10:00',1.26),('15128','2013-09-14','09:15:00',1.39),('15128','2013-09-14','09:20:00',1.4),('15128','2013-09-14','09:25:00',1.44),('15128','2013-09-14','09:30:00',1.47),('15128','2013-09-14','09:35:00',1.54),('15128','2013-09-14','09:40:00',1.6),('15128','2013-09-14','09:45:00',1.72),('15128','2013-09-14','09:50:00',1.76),('15128','2013-09-14','09:55:00',1.87),('15128','2013-09-14','10:00:00',1.94),('15128','2013-09-14','10:05:00',1.91),('15128','2013-09-14','10:10:00',1.85),('15128','2013-09-14','10:15:00',1.97),('15128','2013-09-14','10:20:00',2.04),('15128','2013-09-14','10:25:00',2.04),('15128','2013-09-14','10:30:00',2.08),('15128','2013-09-14','10:35:00',2.29),('15128','2013-09-14','10:40:00',2.41),('15128','2013-09-14','10:45:00',2.25),('15128','2013-09-14','10:50:00',2.47),('15128','2013-09-14','10:55:00',2.62),('15128','2013-09-14','11:00:00',2.93),('15128','2013-09-14','11:05:00',2.16),('15128','2013-09-14','11:10:00',1.67),('15128','2013-09-14','11:20:00',1.02),('15128','2013-09-14','11:25:00',2.77),('15128','2013-09-14','11:30:00',1.63),('15128','2013-09-14','11:35:00',1.17),('15128','2013-09-14','11:45:00',1.63),('15128','2013-09-14','11:50:00',1.92),('15128','2013-09-14','11:55:00',1.54),('15128','2013-09-14','12:00:00',1.73),('15128','2013-09-14','12:05:00',2.22),('15128','2013-09-14','12:10:00',1.7),('15128','2013-09-14','12:15:00',1.72),('15128','2013-09-14','12:20:00',2.22),('15128','2013-09-14','12:25:00',1.86),('15128','2013-09-14','12:30:00',1.41),('15128','2013-09-14','12:35:00',1.36),('15128','2013-09-14','12:40:00',1.32),('15128','2013-09-14','12:45:00',1.31),('15128','2013-09-14','12:50:00',1.23),('15128','2013-09-14','12:55:00',1.3),('15128','2013-09-14','13:00:00',1.86),('15128','2013-09-14','13:05:00',1.83),('15128','2013-09-14','13:10:00',1.97),('15128','2013-09-14','13:15:00',1.15),('15128','2013-09-14','13:20:00',1.18),('15128','2013-09-14','13:25:00',1.48),('15128','2013-09-14','13:30:00',1.57),('15128','2013-09-14','13:35:00',1.99),('15128','2013-09-14','13:40:00',3.7),('15128','2013-09-14','13:45:00',4.09),('15128','2013-09-14','13:50:00',1.83),('15128','2013-09-14','13:55:00',2.65),('15128','2013-09-14','14:00:00',2.61),('15128','2013-09-14','14:05:00',1.55),('15128','2013-09-14','14:10:00',1.77),('15128','2013-09-14','14:15:00',1.81),('15128','2013-09-14','14:20:00',1.56),('15128','2013-09-14','14:25:00',1.42),('15128','2013-09-14','14:30:00',1.27),('15128','2013-09-14','14:35:00',1.17),('15128','2013-09-14','14:40:00',1.21),('15128','2013-09-14','14:45:00',1.32),('15128','2013-09-14','14:50:00',1.36),('15128','2013-09-14','14:55:00',1.3),('15128','2013-09-14','15:00:00',1.32),('15128','2013-09-14','15:05:00',1.31),('15128','2013-09-14','15:10:00',1.66),('15128','2013-09-14','15:15:00',2.09),('15128','2013-09-14','15:20:00',1.92),('15128','2013-09-14','15:25:00',1.18),('15128','2013-09-14','15:35:00',1.03),('15128','2013-09-14','16:05:00',1.01),('15128','2013-09-14','16:40:00',1.08),('15128','2013-09-13','08:55:00',1.04),('15128','2013-09-13','09:00:00',1.11),('15128','2013-09-13','09:05:00',1.17),('15128','2013-09-13','09:10:00',1.24),('15128','2013-09-13','09:15:00',1.34),('15128','2013-09-13','09:20:00',1.39),('15128','2013-09-13','09:25:00',1.45),('15128','2013-09-13','09:30:00',1.51),('15128','2013-09-13','09:35:00',1.54),('15128','2013-09-13','09:40:00',1.61),('15128','2013-09-13','09:45:00',1.7),('15128','2013-09-13','09:50:00',1.78),('15128','2013-09-13','09:55:00',1.83),('15128','2013-09-13','10:00:00',1.88),('15128','2013-09-13','10:05:00',1.96),('15128','2013-09-13','10:10:00',2),('15128','2013-09-13','10:15:00',1.96),('15128','2013-09-13','10:20:00',2.1),('15128','2013-09-13','10:25:00',2.1),('15128','2013-09-13','10:30:00',2.26),('15128','2013-09-13','10:35:00',2.33),('15128','2013-09-13','10:40:00',2.08),('15128','2013-09-13','10:45:00',1.12),('15128','2013-09-13','10:50:00',1.3),('15128','2013-09-13','10:55:00',1.19),('15128','2013-09-13','11:10:00',1.91),('15128','2013-09-13','11:15:00',3),('15128','2013-09-13','11:20:00',3.01),('15128','2013-09-13','11:25:00',2.89),('15128','2013-09-13','11:30:00',2.98),('15128','2013-09-13','11:35:00',2.91),('15128','2013-09-13','11:40:00',3.08),('15128','2013-09-13','11:45:00',3.14),('15128','2013-09-13','11:50:00',3.33),('15128','2013-09-13','11:55:00',3.38),('15128','2013-09-13','12:00:00',3.49),('15128','2013-09-13','12:05:00',3.55),('15128','2013-09-13','12:10:00',3.58),('15128','2013-09-13','12:15:00',3.71),('15128','2013-09-13','12:20:00',3.82),('15128','2013-09-13','12:25:00',3.87),('15128','2013-09-13','12:30:00',3.81),('15128','2013-09-13','12:35:00',3.86),('15128','2013-09-13','12:40:00',3.99),('15128','2013-09-13','12:45:00',4.05),('15128','2013-09-13','12:50:00',4),('15128','2013-09-13','12:55:00',4.07),('15128','2013-09-13','13:00:00',4.05),('15128','2013-09-13','13:05:00',4.14),('15128','2013-09-13','13:10:00',4.16),('15128','2013-09-13','13:15:00',3.94),('15128','2013-09-13','13:20:00',3.89),('15128','2013-09-13','13:25:00',3.9),('15128','2013-09-13','13:30:00',3.89),('15128','2013-09-13','13:35:00',3.82),('15128','2013-09-13','13:40:00',4.15),('15128','2013-09-13','13:45:00',2.31),('15128','2013-09-13','13:50:00',2.32),('15128','2013-09-13','13:55:00',3.76),('15128','2013-09-13','14:00:00',2.98),('15128','2013-09-13','14:05:00',3.53),('15128','2013-09-13','14:10:00',4.28),('15128','2013-09-13','14:15:00',4.07),('15128','2013-09-13','14:20:00',3.88),('15128','2013-09-13','14:25:00',3.85),('15128','2013-09-13','14:30:00',3.8),('15128','2013-09-13','14:35:00',3.75),('15128','2013-09-13','14:40:00',3.76),('15128','2013-09-13','14:45:00',3.75),('15128','2013-09-13','14:50:00',3.71),('15128','2013-09-13','14:55:00',3.69),('15128','2013-09-13','15:00:00',3.68),('15128','2013-09-13','15:05:00',3.64),('15128','2013-09-13','15:10:00',3.62),('15128','2013-09-13','15:15:00',3.59),('15128','2013-09-13','15:20:00',3.57),('15128','2013-09-13','15:25:00',3.51),('15128','2013-09-13','15:30:00',3.45),('15128','2013-09-13','15:35:00',3.44),('15128','2013-09-13','15:40:00',3.4),('15128','2013-09-13','15:45:00',3.37),('15128','2013-09-13','15:50:00',3.28),('15128','2013-09-13','15:55:00',3.24),('15128','2013-09-13','16:00:00',3.22),('15128','2013-09-13','16:05:00',3.14),('15128','2013-09-13','16:10:00',3.1),('15128','2013-09-13','16:15:00',3.04),('15128','2013-09-13','16:20:00',2.95),('15128','2013-09-13','16:25:00',2.93),('15128','2013-09-13','16:30:00',2.86),('15128','2013-09-13','16:35:00',2.77),('15128','2013-09-13','16:40:00',2.73),('15128','2013-09-13','16:45:00',2.66),('15128','2013-09-13','16:50:00',2.51),('15128','2013-09-13','16:55:00',2.46),('15128','2013-09-13','17:00:00',2.37),('15128','2013-09-13','17:05:00',2.28),('15128','2013-09-13','17:10:00',2.13),('15128','2013-09-13','17:15:00',2.04),('15128','2013-09-13','17:20:00',1.98),('15128','2013-09-13','17:25:00',1.88),('15128','2013-09-13','17:30:00',1.79),('15128','2013-09-13','17:35:00',1.73),('15128','2013-09-13','17:40:00',1.65),('15128','2013-09-13','17:45:00',1.58),('15128','2013-09-13','17:50:00',1.48),('15128','2013-09-13','17:55:00',1.4),('15128','2013-09-13','18:00:00',1.24),('15128','2013-09-13','18:05:00',1.11),('15128','2013-09-13','18:10:00',1.05),('15128','2013-09-12','09:30:00',1),('15128','2013-09-12','09:35:00',1.1),('15128','2013-09-12','09:40:00',1.15),('15128','2013-09-12','09:45:00',1.2),('15128','2013-09-12','09:50:00',1.51),('15128','2013-09-12','09:55:00',1.32),('15128','2013-09-12','10:00:00',2.71),('15128','2013-09-12','10:05:00',1.95),('15128','2013-09-12','10:10:00',2.34),('15128','2013-09-12','10:15:00',1.2),('15128','2013-09-12','10:20:00',1.36),('15128','2013-09-12','10:25:00',1.24),('15128','2013-09-12','10:30:00',2.26),('15128','2013-09-12','10:35:00',2.4),('15128','2013-09-12','10:40:00',2.43),('15128','2013-09-12','10:45:00',2.45),('15128','2013-09-12','10:50:00',2.47),('15128','2013-09-12','10:55:00',2.52),('15128','2013-09-12','11:00:00',2.56),('15128','2013-09-12','11:05:00',2.59),('15128','2013-09-12','11:10:00',2.66),('15128','2013-09-12','11:15:00',2.77),('15128','2013-09-12','11:20:00',2.85),('15128','2013-09-12','11:25:00',2.83),('15128','2013-09-12','11:30:00',2.96),('15128','2013-09-12','11:35:00',2.9),('15128','2013-09-12','11:40:00',3.06),('15128','2013-09-12','11:45:00',3.1),('15128','2013-09-12','11:50:00',3.27),('15128','2013-09-12','11:55:00',3.39),('15128','2013-09-12','12:00:00',3.47),('15128','2013-09-12','12:05:00',3.52),('15128','2013-09-12','12:10:00',3.57),('15128','2013-09-12','12:15:00',3.64),('15128','2013-09-12','12:20:00',3.67),('15128','2013-09-12','12:25:00',3.76),('15128','2013-09-12','12:30:00',3.87),('15128','2013-09-12','12:35:00',3.89),('15128','2013-09-12','12:40:00',3.86),('15128','2013-09-12','12:45:00',3.87),('15128','2013-09-12','12:50:00',3.91),('15128','2013-09-12','12:55:00',3.9),('15128','2013-09-12','13:00:00',3.91),('15128','2013-09-12','13:05:00',3.92),('15128','2013-09-12','13:10:00',3.92),('15128','2013-09-12','13:15:00',3.9),('15128','2013-09-12','13:20:00',3.89),('15128','2013-09-12','13:25:00',3.87),('15128','2013-09-12','13:30:00',3.86),('15128','2013-09-12','13:35:00',3.84),('15128','2013-09-12','13:40:00',3.83),('15128','2013-09-12','13:45:00',3.85),('15128','2013-09-12','13:50:00',3.88),('15128','2013-09-12','13:55:00',3.9),('15128','2013-09-12','14:00:00',3.97),('15128','2013-09-12','14:05:00',3.97),('15128','2013-09-12','14:10:00',3.89),('15128','2013-09-12','14:15:00',2.86),('15128','2013-09-12','14:20:00',3.89),('15128','2013-09-12','14:25:00',3.93),('15128','2013-09-12','14:30:00',3.9),('15128','2013-09-12','14:35:00',3.86),('15128','2013-09-12','14:40:00',3.81),('15128','2013-09-12','14:45:00',3.85),('15128','2013-09-12','14:50:00',3.82),('15128','2013-09-12','14:55:00',3.82),('15128','2013-09-12','15:00:00',3.76),('15128','2013-09-12','15:05:00',3.74),('15128','2013-09-12','15:10:00',3.71),('15128','2013-09-12','15:15:00',3.68),('15128','2013-09-12','15:20:00',3.63),('15128','2013-09-12','15:25:00',3.58),('15128','2013-09-12','15:30:00',3.57),('15128','2013-09-12','15:35:00',3.53),('15128','2013-09-12','15:40:00',3.48),('15128','2013-09-12','15:45:00',3.44),('15128','2013-09-12','15:50:00',3.41),('15128','2013-09-12','15:55:00',3.34),('15128','2013-09-12','16:00:00',3.3),('15128','2013-09-12','16:05:00',3.23),('15128','2013-09-12','16:10:00',3.16),('15128','2013-09-12','16:15:00',3.13),('15128','2013-09-12','16:20:00',3.06),('15128','2013-09-12','16:25:00',2.98),('15128','2013-09-12','16:30:00',2.93),('15128','2013-09-12','16:35:00',2.87),('15128','2013-09-12','16:40:00',2.8),('15128','2013-09-12','16:45:00',2.73),('15128','2013-09-12','16:50:00',2.63),('15128','2013-09-12','16:55:00',2.49),('15128','2013-09-12','17:00:00',2.41),('15128','2013-09-12','17:05:00',2.31),('15128','2013-09-12','17:10:00',2.19),('15128','2013-09-12','17:15:00',2.12),('15128','2013-09-12','17:20:00',2),('15128','2013-09-12','17:25:00',1.88),('15128','2013-09-12','17:30:00',1.82),('15128','2013-09-12','17:35:00',1.75),('15128','2013-09-12','17:40:00',1.68),('15128','2013-09-12','17:45:00',1.59),('15128','2013-09-12','17:50:00',1.52),('15128','2013-09-12','17:55:00',1.41),('15128','2013-09-12','18:00:00',1.28),('15128','2013-09-12','18:05:00',1.15),('15128','2013-09-12','18:10:00',1.05),('15128','2013-09-11','09:00:00',1.07),('15128','2013-09-11','09:05:00',1.08),('15128','2013-09-11','09:20:00',1.46),('15128','2013-09-11','09:25:00',1.53),('15128','2013-09-11','09:30:00',1.62),('15128','2013-09-11','09:35:00',1.21),('15128','2013-09-11','09:40:00',1.07),('15128','2013-09-11','09:50:00',1.89),('15128','2013-09-11','09:55:00',1.58),('15128','2013-09-11','10:00:00',2.09),('15128','2013-09-11','10:05:00',2.11),('15128','2013-09-11','10:10:00',1.43),('15128','2013-09-11','10:25:00',2.03),('15128','2013-09-11','10:30:00',1.87),('15128','2013-09-11','10:35:00',1.98),('15128','2013-09-11','10:40:00',2),('15128','2013-09-11','10:45:00',2.05),('15128','2013-09-11','10:50:00',2.48),('15128','2013-09-11','10:55:00',3.65),('15128','2013-09-11','11:00:00',3.53),('15128','2013-09-11','11:40:00',1.75),('15128','2013-09-11','11:45:00',2.27),('15128','2013-09-11','11:50:00',2.33),('15128','2013-09-11','11:55:00',3.48),('15128','2013-09-11','12:00:00',3.8),('15128','2013-09-11','12:05:00',3.84),('15128','2013-09-11','12:10:00',3.65),('15128','2013-09-11','12:15:00',3.35),('15128','2013-09-11','12:20:00',2.74),('15128','2013-09-11','12:25:00',4.07),('15128','2013-09-11','12:30:00',4.22),('15128','2013-09-11','12:35:00',2.39),('15128','2013-09-11','12:40:00',3.58),('15128','2013-09-11','12:45:00',3.56),('15128','2013-09-11','12:50:00',3.94),('15128','2013-09-11','12:55:00',3.68),('15128','2013-09-11','13:00:00',3.94),('15128','2013-09-11','13:05:00',4.05),('15128','2013-09-11','13:10:00',3.99),('15128','2013-09-11','13:15:00',2.87),('15128','2013-09-11','13:20:00',2.36),('15128','2013-09-11','13:25:00',2.92),('15128','2013-09-11','13:30:00',4.34),('15128','2013-09-11','13:35:00',3.15),('15128','2013-09-11','13:40:00',4.14),('15128','2013-09-11','13:45:00',3.57),('15128','2013-09-11','13:50:00',4.11),('15128','2013-09-11','13:55:00',3.63),('15128','2013-09-11','14:00:00',3.45),('15128','2013-09-11','14:20:00',4.1),('15128','2013-09-11','14:25:00',2.79),('15128','2013-09-11','14:30:00',3.07),('15128','2013-09-11','14:35:00',3.86),('15128','2013-09-11','14:40:00',4.28),('15128','2013-09-11','14:45:00',4.14),('15128','2013-09-11','14:50:00',3.97),('15128','2013-09-11','14:55:00',3.46),('15128','2013-09-11','15:00:00',3.92),('15128','2013-09-11','15:05:00',3.86),('15128','2013-09-11','15:10:00',3.83),('15128','2013-09-11','15:15:00',3.8),('15128','2013-09-11','15:20:00',3.72),('15128','2013-09-11','15:25:00',3.73),('15128','2013-09-11','15:30:00',3.69),('15128','2013-09-11','15:35:00',3.64),('15128','2013-09-11','15:40:00',3.59),('15128','2013-09-11','15:45:00',3.58),('15128','2013-09-11','15:50:00',3.59),('15128','2013-09-11','15:55:00',3.43),('15128','2013-09-11','16:00:00',3.54),('15128','2013-09-11','16:05:00',3.35),('15128','2013-09-11','16:10:00',3.36),('15128','2013-09-11','16:15:00',2.94),('15128','2013-09-11','16:20:00',3.04),('15128','2013-09-11','16:25:00',3.26),('15128','2013-09-11','16:30:00',3.02),('15128','2013-09-11','16:35:00',2.82),('15128','2013-09-11','16:40:00',3.19),('15128','2013-09-11','16:45:00',2.54),('15128','2013-09-11','16:50:00',2.88),('15128','2013-09-11','16:55:00',2.79),('15128','2013-09-11','17:00:00',2.68),('15128','2013-09-11','17:05:00',2.47),('15128','2013-09-11','17:10:00',2.35),('15128','2013-09-11','17:15:00',2.23),('15128','2013-09-11','17:20:00',2.14),('15128','2013-09-11','17:25:00',2.01),('15128','2013-09-11','17:30:00',1.93),('15128','2013-09-11','17:35:00',1.84),('15128','2013-09-11','17:40:00',1.8),('15128','2013-09-11','17:45:00',1.7),('15128','2013-09-11','17:50:00',1.45),('15128','2013-09-11','18:05:00',1.13),('15128','2013-09-11','18:20:00',1.05),('15128','2013-09-10','09:50:00',1.18),('15128','2013-09-10','09:55:00',1.31),('15128','2013-09-10','10:05:00',2.04),('15128','2013-09-10','10:10:00',2.02),('15128','2013-09-10','10:15:00',2.01),('15128','2013-09-10','10:20:00',2.09),('15128','2013-09-10','10:25:00',2.19),('15128','2013-09-10','10:30:00',1.66),('15128','2013-09-10','10:35:00',2.28),('15128','2013-09-10','10:40:00',1.76),('15128','2013-09-10','10:45:00',1.27),('15128','2013-09-10','10:50:00',1.66),('15128','2013-09-10','10:55:00',2.34),('15128','2013-09-10','11:00:00',1.3),('15128','2013-09-10','11:05:00',3.43),('15128','2013-09-10','11:10:00',3.07),('15128','2013-09-10','11:15:00',2.35),('15128','2013-09-10','11:20:00',2.35),('15128','2013-09-10','11:25:00',3.23),('15128','2013-09-10','11:30:00',1.18),('15128','2013-09-10','11:35:00',3.18),('15128','2013-09-10','11:40:00',3.06),('15128','2013-09-10','11:45:00',3.41),('15128','2013-09-10','11:50:00',3.6),('15128','2013-09-10','11:55:00',3.61),('15128','2013-09-10','12:00:00',1.79),('15128','2013-09-10','12:05:00',3.13),('15128','2013-09-10','12:10:00',3.41),('15128','2013-09-10','12:15:00',2.37),('15128','2013-09-10','12:20:00',2.7),('15128','2013-09-10','12:25:00',4.16),('15128','2013-09-10','12:30:00',4.39),('15128','2013-09-10','12:35:00',2.5),('15128','2013-09-10','12:40:00',3.7),('15128','2013-09-10','12:45:00',3.14),('15128','2013-09-10','12:50:00',3.74),('15128','2013-09-10','12:55:00',4.22),('15128','2013-09-10','13:00:00',3.17),('15128','2013-09-10','13:05:00',2.67),('15128','2013-09-10','13:10:00',4.68),('15128','2013-09-10','13:15:00',4.16),('15128','2013-09-10','13:20:00',3.46),('15128','2013-09-10','13:25:00',3.62),('15128','2013-09-10','13:30:00',2.2),('15128','2013-09-10','13:35:00',2.26),('15128','2013-09-10','13:40:00',1.5),('15128','2013-09-10','13:45:00',4.12),('15128','2013-09-10','13:50:00',3.22),('15128','2013-09-10','13:55:00',3.94),('15128','2013-09-10','14:00:00',4.2),('15128','2013-09-10','14:05:00',4.02),('15128','2013-09-10','14:10:00',4.14),('15128','2013-09-10','14:15:00',4.07),('15128','2013-09-10','14:20:00',4.06),('15128','2013-09-10','14:25:00',3.51),('15128','2013-09-10','14:30:00',1.75),('15128','2013-09-10','14:35:00',2.54),('15128','2013-09-10','14:40:00',2.23),('15128','2013-09-10','14:45:00',2.24),('15128','2013-09-10','14:50:00',1.29),('15128','2013-09-10','14:55:00',1.32),('15128','2013-09-10','15:00:00',2.7),('15128','2013-09-10','15:05:00',3.13),('15128','2013-09-10','15:10:00',1.9),('15128','2013-09-10','15:15:00',1.81),('15128','2013-09-10','15:20:00',2.92),('15128','2013-09-10','15:25:00',2.47),('15128','2013-09-10','15:30:00',2.97),('15128','2013-09-10','15:35:00',3.76),('15128','2013-09-10','15:40:00',2.07),('15128','2013-09-10','15:45:00',2.53),('15128','2013-09-10','15:50:00',1.64),('15128','2013-09-10','15:55:00',1.03),('15128','2013-09-10','16:00:00',2.03),('15128','2013-09-10','16:05:00',3.66),('15128','2013-09-10','16:10:00',3.44),('15128','2013-09-10','16:15:00',3.48),('15128','2013-09-10','16:20:00',1.87),('15128','2013-09-10','16:25:00',1.3),('15128','2013-09-10','16:30:00',3.52),('15128','2013-09-10','16:35:00',2.62),('15128','2013-09-10','16:40:00',2.69),('15128','2013-09-10','16:45:00',1.56),('15128','2013-09-10','16:50:00',1.73),('15128','2013-09-10','16:55:00',2.17),('15128','2013-09-10','17:00:00',2.55),('15128','2013-09-10','17:05:00',2.42),('15128','2013-09-10','17:10:00',2.24),('15128','2013-09-10','17:15:00',1.73),('15128','2013-09-10','17:20:00',1.65),('15128','2013-09-10','17:25:00',2.05),('15128','2013-09-10','17:30:00',1.42),('15128','2013-09-10','17:35:00',1.82),('15128','2013-09-10','17:40:00',1.75),('15128','2013-09-10','17:45:00',1.66),('15128','2013-09-10','17:50:00',1.59),('15128','2013-09-10','17:55:00',1.53),('15128','2013-09-10','18:00:00',1.4),('15128','2013-09-10','18:05:00',1.25),('15128','2013-09-10','18:10:00',1.12),('15128','2013-09-09','09:00:00',1.37),('15128','2013-09-09','09:05:00',1.09),('15128','2013-09-09','09:10:00',1.36),('15128','2013-09-09','09:15:00',1.28),('15128','2013-09-09','09:20:00',1.45),('15128','2013-09-09','09:25:00',1.41),('15128','2013-09-09','09:30:00',1.08),('15128','2013-09-09','09:35:00',1.24),('15128','2013-09-09','09:40:00',1.18),('15128','2013-09-09','09:45:00',1.24),('15128','2013-09-09','09:50:00',1.29),('15128','2013-09-09','09:55:00',1.11),('15128','2013-09-09','10:30:00',1.02),('15128','2013-09-09','10:35:00',1.24),('15128','2013-09-09','10:40:00',1.47),('15128','2013-09-09','10:45:00',1.56),('15128','2013-09-09','10:50:00',1.39),('15128','2013-09-09','10:55:00',1.68),('15128','2013-09-09','11:00:00',2.8),('15128','2013-09-09','11:05:00',1.74),('15128','2013-09-09','11:10:00',1.21),('15128','2013-09-09','11:20:00',1.29),('15128','2013-09-09','11:25:00',1.63),('15128','2013-09-09','11:30:00',1.01),('15128','2013-09-09','11:40:00',1.13),('15128','2013-09-09','11:45:00',1.61),('15128','2013-09-09','11:50:00',1.16),('15128','2013-09-09','11:55:00',1.12),('15128','2013-09-09','12:05:00',1.07),('15128','2013-09-09','12:10:00',1.01),('15128','2013-09-09','12:15:00',1.41),('15128','2013-09-09','12:20:00',1.19),('15128','2013-09-09','12:25:00',1.02),('15128','2013-09-09','12:55:00',1.06),('15128','2013-09-09','13:00:00',1.19),('15128','2013-09-09','13:05:00',1.06),('15128','2013-09-09','13:10:00',1.01),('15128','2013-09-09','13:15:00',1.26),('15128','2013-09-09','13:20:00',1.29),('15128','2013-09-09','13:25:00',1.32),('15128','2013-09-09','13:30:00',1.25),('15128','2013-09-09','13:35:00',1.66),('15128','2013-09-09','13:40:00',1.97),('15128','2013-09-09','13:45:00',2.44),('15128','2013-09-09','13:50:00',2.58),('15128','2013-09-09','13:55:00',2.39),('15128','2013-09-09','14:00:00',1.84),('15128','2013-09-09','14:05:00',1.54),('15128','2013-09-09','14:10:00',1.66),('15128','2013-09-09','14:15:00',1.94),('15128','2013-09-09','14:20:00',2.06),('15128','2013-09-09','14:25:00',2.42),('15128','2013-09-09','14:30:00',2.24),('15128','2013-09-09','14:35:00',1.54),('15128','2013-09-09','14:40:00',1.85),('15128','2013-09-09','14:45:00',2.2),('15128','2013-09-09','14:50:00',2.16),('15128','2013-09-09','14:55:00',2.32),('15128','2013-09-09','15:00:00',2.58),('15128','2013-09-09','15:05:00',2.72),('15128','2013-09-09','15:10:00',2.7),('15128','2013-09-09','15:15:00',2.45),('15128','2013-09-09','15:20:00',1.57),('15128','2013-09-09','15:25:00',1.5),('15128','2013-09-09','15:30:00',1.77),('15128','2013-09-09','15:35:00',1.46),('15128','2013-09-09','15:40:00',1.39),('15128','2013-09-09','15:45:00',1.38),('15128','2013-09-09','15:50:00',1.28),('15128','2013-09-09','15:55:00',1.1),('15128','2013-09-09','16:05:00',1.01),('15128','2013-09-09','16:15:00',1.01),('15128','2013-09-09','16:45:00',1.39),('15128','2013-09-09','16:55:00',1.1),('15128','2013-09-08','08:50:00',1.05),('15128','2013-09-08','08:55:00',1.11),('15128','2013-09-08','09:00:00',1.17),('15128','2013-09-08','09:05:00',1.07),('15128','2013-09-08','09:10:00',1.03),('15128','2013-09-08','09:15:00',1.09),('15128','2013-09-08','09:35:00',1.04),('15128','2013-09-08','09:40:00',1.44),('15128','2013-09-08','09:45:00',1.45),('15128','2013-09-08','09:50:00',1.28),('15128','2013-09-08','09:55:00',1.35),('15128','2013-09-08','10:00:00',1.43),('15128','2013-09-08','10:05:00',1.22),('15128','2013-09-08','10:15:00',1.11),('15128','2013-09-08','10:30:00',1.21),('15128','2013-09-08','10:35:00',1.64),('15128','2013-09-08','10:40:00',1.94),('15128','2013-09-08','10:45:00',2.31),('15128','2013-09-08','10:50:00',2.54),('15128','2013-09-08','10:55:00',2.63),('15128','2013-09-08','11:00:00',2.45),('15128','2013-09-08','11:05:00',2.01),('15128','2013-09-08','11:10:00',1.89),('15128','2013-09-08','11:15:00',1.96),('15128','2013-09-08','11:20:00',2.72),('15128','2013-09-08','11:25:00',2.38),('15128','2013-09-08','11:30:00',2.28),('15128','2013-09-08','11:35:00',2.01),('15128','2013-09-08','11:40:00',1.98),('15128','2013-09-08','11:45:00',2.15),('15128','2013-09-08','11:50:00',1.89),('15128','2013-09-08','11:55:00',1.68),('15128','2013-09-08','12:00:00',2.48),('15128','2013-09-08','12:05:00',2.4),('15128','2013-09-08','12:10:00',1.7),('15128','2013-09-08','12:15:00',2.09),('15128','2013-09-08','12:20:00',1.8),('15128','2013-09-08','12:25:00',2.23),('15128','2013-09-08','12:30:00',2.1),('15128','2013-09-08','12:35:00',1.61),('15128','2013-09-08','12:40:00',1.69),('15128','2013-09-08','12:45:00',1.69),('15128','2013-09-08','12:50:00',2.28),('15128','2013-09-08','12:55:00',2.01),('15128','2013-09-08','13:00:00',2.2),('15128','2013-09-08','13:05:00',3.2),('15128','2013-09-08','13:10:00',3.17),('15128','2013-09-08','13:15:00',3.31),('15128','2013-09-08','13:20:00',2.87),('15128','2013-09-08','13:25:00',2.55),('15128','2013-09-08','13:30:00',3.62),('15128','2013-09-08','13:35:00',3.8),('15128','2013-09-08','13:40:00',3.63),('15128','2013-09-08','13:45:00',4.02),('15128','2013-09-08','13:50:00',3.52),('15128','2013-09-08','13:55:00',2.42),('15128','2013-09-08','14:00:00',2.13),('15128','2013-09-08','14:05:00',2.56),('15128','2013-09-08','14:10:00',3.45),('15128','2013-09-08','14:15:00',2.22),('15128','2013-09-08','14:20:00',3.91),('15128','2013-09-08','14:25:00',3.15),('15128','2013-09-08','14:30:00',2.49),('15128','2013-09-08','14:35:00',2.62),('15128','2013-09-08','14:40:00',1.81),('15128','2013-09-08','14:45:00',2.99),('15128','2013-09-08','14:50:00',2.38),('15128','2013-09-08','14:55:00',3.43),('15128','2013-09-08','15:00:00',3.29),('15128','2013-09-08','15:05:00',2.78),('15128','2013-09-08','15:10:00',3.68),('15128','2013-09-08','15:15:00',3.02),('15128','2013-09-08','15:20:00',2.82),('15128','2013-09-08','15:25:00',3.44),('15128','2013-09-08','15:30:00',2.66),('15128','2013-09-08','15:35:00',2.97),('15128','2013-09-08','15:40:00',1.82),('15128','2013-09-08','15:45:00',1.41),('15128','2013-09-08','15:50:00',2.22),('15128','2013-09-08','15:55:00',1.76),('15128','2013-09-08','16:00:00',1.65),('15128','2013-09-08','16:05:00',1.76),('15128','2013-09-08','16:10:00',1.66),('15128','2013-09-08','16:15:00',1.36),('15128','2013-09-08','16:20:00',1.47),('15128','2013-09-08','16:35:00',1.08),('15128','2013-09-08','16:40:00',1.45),('15128','2013-09-08','16:45:00',1.37),('15128','2013-09-08','16:50:00',1.64),('15128','2013-09-08','18:00:00',1.15),('15128','2013-09-08','18:05:00',1.13),('15128','2013-09-08','18:20:00',1.08),('15128','2013-09-07','09:15:00',1.28),('15128','2013-09-07','09:20:00',1.33),('15128','2013-09-07','09:25:00',1.41),('15128','2013-09-07','09:30:00',1.45),('15128','2013-09-07','09:35:00',1.5),('15128','2013-09-07','09:40:00',1.58),('15128','2013-09-07','09:45:00',1.63),('15128','2013-09-07','09:50:00',1.67),('15128','2013-09-07','09:55:00',1.73),('15128','2013-09-07','10:00:00',1.77),('15128','2013-09-07','10:05:00',1.86),('15128','2013-09-07','10:10:00',1.9),('15128','2013-09-07','10:15:00',1.99),('15128','2013-09-07','10:20:00',2.06),('15128','2013-09-07','10:25:00',2.1),('15128','2013-09-07','10:30:00',2.17),('15128','2013-09-07','10:35:00',2.2),('15128','2013-09-07','10:40:00',2.3),('15128','2013-09-07','10:45:00',2.38),('15128','2013-09-07','10:50:00',2.38),('15128','2013-09-07','10:55:00',2.47),('15128','2013-09-07','11:00:00',2.48),('15128','2013-09-07','11:05:00',2.49),('15128','2013-09-07','11:10:00',2.57),('15128','2013-09-07','11:15:00',2.66),('15128','2013-09-07','11:20:00',2.72),('15128','2013-09-07','11:25:00',2.75),('15128','2013-09-07','11:30:00',2.73),('15128','2013-09-07','11:35:00',2.79),('15128','2013-09-07','11:40:00',2.91),('15128','2013-09-07','11:45:00',2.96),('15128','2013-09-07','11:50:00',2.97),('15128','2013-09-07','11:55:00',3.05),('15128','2013-09-07','12:00:00',3.12),('15128','2013-09-07','12:05:00',3.11),('15128','2013-09-07','12:10:00',3.33),('15128','2013-09-07','12:15:00',3.43),('15128','2013-09-07','12:20:00',3.4),('15128','2013-09-07','12:25:00',3.42),('15128','2013-09-07','12:30:00',3.47),('15128','2013-09-07','12:35:00',3.41),('15128','2013-09-07','12:40:00',3.54),('15128','2013-09-07','12:45:00',3.59),('15128','2013-09-07','12:50:00',3.6),('15128','2013-09-07','12:55:00',3.5),('15128','2013-09-07','13:00:00',3.47),('15128','2013-09-07','13:05:00',3.62),('15128','2013-09-07','13:10:00',3.53),('15128','2013-09-07','13:15:00',3.43),('15128','2013-09-07','13:20:00',3.43),('15128','2013-09-07','13:25:00',3.16),('15128','2013-09-07','13:30:00',3.23),('15128','2013-09-07','13:35:00',2.63),('15128','2013-09-07','13:40:00',2.29),('15128','2013-09-07','13:45:00',2.54),('15128','2013-09-07','13:50:00',3.17),('15128','2013-09-07','13:55:00',3.29),('15128','2013-09-07','14:00:00',3.12),('15128','2013-09-07','14:05:00',3.18),('15128','2013-09-07','14:10:00',2.73),('15128','2013-09-07','14:15:00',3.17),('15128','2013-09-07','14:20:00',3.53),('15128','2013-09-07','14:25:00',3.43),('15128','2013-09-07','14:30:00',3.85),('15128','2013-09-07','14:35:00',3.74),('15128','2013-09-07','14:40:00',3.84),('15128','2013-09-07','14:45:00',3.75),('15128','2013-09-07','14:50:00',3.24),('15128','2013-09-07','14:55:00',3.78),('15128','2013-09-07','15:00:00',3.59),('15128','2013-09-07','15:05:00',2.22),('15128','2013-09-07','15:10:00',2.79),('15128','2013-09-07','15:15:00',3.68),('15128','2013-09-07','15:20:00',3.76),('15128','2013-09-07','15:25:00',3.66),('15128','2013-09-07','15:30:00',3.56),('15128','2013-09-07','15:35:00',3.2),('15128','2013-09-07','15:40:00',3.4),('15128','2013-09-07','15:45:00',3.42),('15128','2013-09-07','15:50:00',2.69),('15128','2013-09-07','15:55:00',2.93),('15128','2013-09-07','16:00:00',2.64),('15128','2013-09-07','16:05:00',2.41),('15128','2013-09-07','16:10:00',3.04),('15128','2013-09-07','16:15:00',2.83),('15128','2013-09-07','16:20:00',2.82),('15128','2013-09-07','16:25:00',2.23),('15128','2013-09-07','16:30:00',2.71),('15128','2013-09-07','16:35:00',2.07),('15128','2013-09-07','16:40:00',2.32),('15128','2013-09-07','16:45:00',1.36),('15128','2013-09-07','16:50:00',1.14),('15128','2013-09-07','16:55:00',1.79),('15128','2013-09-07','17:00:00',2.59),('15128','2013-09-07','17:05:00',2.37),('15128','2013-09-07','17:10:00',2.16),('15128','2013-09-07','17:15:00',1.96),('15128','2013-09-07','17:20:00',1.89),('15128','2013-09-07','17:25:00',1.52),('15128','2013-09-07','17:35:00',1.25),('15128','2013-09-07','17:40:00',1.56),('15128','2013-09-07','17:45:00',1.44),('15128','2013-09-07','17:50:00',1.37),('15128','2013-09-07','17:55:00',1.28),('15128','2013-09-07','18:00:00',1.13),('15128','2013-09-06','09:15:00',1.31),('15128','2013-09-06','09:20:00',1.36),('15128','2013-09-06','09:25:00',1.41),('15128','2013-09-06','09:30:00',1.45),('15128','2013-09-06','09:35:00',1.5),('15128','2013-09-06','09:40:00',1.57),('15128','2013-09-06','09:45:00',1.67),('15128','2013-09-06','09:55:00',1.76),('15128','2013-09-06','10:00:00',1.81),('15128','2013-09-06','10:05:00',1.86),('15128','2013-09-06','10:10:00',1.85),('15128','2013-09-06','10:15:00',1.97),('15128','2013-09-06','10:20:00',2.03),('15128','2013-09-06','10:25:00',2.05),('15128','2013-09-06','10:30:00',2.11),('15128','2013-09-06','10:35:00',2.11),('15128','2013-09-06','10:40:00',2.25),('15128','2013-09-06','10:45:00',2.34),('15128','2013-09-06','10:50:00',2.39),('15128','2013-09-06','10:55:00',2.33),('15128','2013-09-06','11:00:00',2.41),('15128','2013-09-06','11:05:00',2.57),('15128','2013-09-06','11:10:00',2.62),('15128','2013-09-06','11:15:00',2.7),('15128','2013-09-06','11:20:00',2.76),('15128','2013-09-06','11:25:00',2.76),('15128','2013-09-06','11:30:00',2.79),('15128','2013-09-06','11:35:00',2.84),('15128','2013-09-06','11:40:00',2.93),('15128','2013-09-06','11:45:00',2.98),('15128','2013-09-06','11:50:00',3.07),('15128','2013-09-06','11:55:00',3.24),('15128','2013-09-06','12:00:00',3.32),('15128','2013-09-06','12:05:00',3.35),('15128','2013-09-06','12:10:00',3.4),('15128','2013-09-06','12:15:00',3.45),('15128','2013-09-06','12:20:00',3.48),('15128','2013-09-06','12:25:00',3.51),('15128','2013-09-06','12:30:00',3.57),('15128','2013-09-06','12:35:00',3.59),('15128','2013-09-06','12:40:00',3.57),('15128','2013-09-06','12:45:00',3.58),('15128','2013-09-06','12:50:00',3.59),('15128','2013-09-06','12:55:00',3.63),('15128','2013-09-06','13:00:00',3.78),('15128','2013-09-06','13:05:00',3.76),('15128','2013-09-06','13:10:00',3.7),('15128','2013-09-06','13:15:00',3.67),('15128','2013-09-06','13:20:00',3.58),('15128','2013-09-06','13:25:00',3.73),('15128','2013-09-06','13:30:00',3.77),('15128','2013-09-06','13:35:00',3.79),('15128','2013-09-06','13:40:00',3.82),('15128','2013-09-06','13:45:00',3.82),('15128','2013-09-06','13:50:00',3.82),('15128','2013-09-06','13:55:00',3.76),('15128','2013-09-06','14:00:00',3.78),('15128','2013-09-06','14:05:00',3.78),('15128','2013-09-06','14:10:00',3.83),('15128','2013-09-06','14:15:00',3.82),('15128','2013-09-06','14:20:00',3.82),('15128','2013-09-06','14:25:00',3.82),('15128','2013-09-06','14:30:00',3.79),('15128','2013-09-06','14:35:00',3.8),('15128','2013-09-06','14:40:00',3.77),('15128','2013-09-06','14:45:00',3.75),('15128','2013-09-06','14:50:00',3.71),('15128','2013-09-06','14:55:00',3.69),('15128','2013-09-06','15:00:00',3.66),('15128','2013-09-06','15:05:00',3.62),('15128','2013-09-06','15:10:00',3.6),('15128','2013-09-06','15:15:00',3.57),('15128','2013-09-06','15:20:00',3.55),('15128','2013-09-06','15:25:00',3.52),('15128','2013-09-06','15:30:00',3.48),('15128','2013-09-06','15:35:00',3.44),('15128','2013-09-06','15:40:00',3.4),('15128','2013-09-06','15:45:00',3.37),('15128','2013-09-06','15:50:00',3.33),('15128','2013-09-06','15:55:00',3.26),('15128','2013-09-06','16:00:00',3.22),('15128','2013-09-06','16:05:00',3.16),('15128','2013-09-06','16:10:00',3.1),('15128','2013-09-06','16:15:00',3.03),('15128','2013-09-06','16:20:00',2.96),('15128','2013-09-06','16:25:00',2.91),('15128','2013-09-06','16:30:00',2.86),('15128','2013-09-06','16:35:00',2.81),('15128','2013-09-06','16:40:00',2.74),('15128','2013-09-06','16:45:00',2.67),('15128','2013-09-06','16:50:00',2.59),('15128','2013-09-06','16:55:00',2.51),('15128','2013-09-06','17:00:00',2.41),('15128','2013-09-06','17:05:00',2.31),('15128','2013-09-06','17:10:00',2.21),('15128','2013-09-06','17:15:00',2.05),('15128','2013-09-06','17:20:00',1.95),('15128','2013-09-06','17:25:00',1.83),('15128','2013-09-06','17:30:00',1.75),('15128','2013-09-06','17:35:00',1.68),('15128','2013-09-06','17:40:00',1.59),('15128','2013-09-06','17:45:00',1.56),('15128','2013-09-06','17:50:00',1.52),('15128','2013-09-06','17:55:00',1.42),('15128','2013-09-06','18:00:00',1.35),('15128','2013-09-06','18:05:00',1.24),('15128','2013-09-06','18:10:00',1.13),('15128','2013-09-06','18:15:00',1.01),('15128','2013-09-05','08:50:00',1.02),('15128','2013-09-05','08:55:00',1.07),('15128','2013-09-05','09:00:00',1.12),('15128','2013-09-05','09:05:00',1.18),('15128','2013-09-05','09:10:00',1.27),('15128','2013-09-05','09:15:00',1.34),('15128','2013-09-05','09:20:00',1.41),('15128','2013-09-05','09:25:00',1.46),('15128','2013-09-05','09:30:00',1.49),('15128','2013-09-05','09:35:00',1.55),('15128','2013-09-05','09:40:00',1.7),('15128','2013-09-05','09:45:00',1.76),('15128','2013-09-05','09:50:00',1.81),('15128','2013-09-05','09:55:00',1.78),('15128','2013-09-05','10:00:00',1.84),('15128','2013-09-05','10:05:00',1.89),('15128','2013-09-05','10:10:00',1.91),('15128','2013-09-05','10:15:00',2.04),('15128','2013-09-05','10:20:00',2.06),('15128','2013-09-05','10:25:00',2.1),('15128','2013-09-05','10:30:00',2.14),('15128','2013-09-05','10:35:00',2.2),('15128','2013-09-05','10:40:00',2.29),('15128','2013-09-05','10:45:00',2.4),('15128','2013-09-05','10:50:00',2.46),('15128','2013-09-05','10:55:00',2.42),('15128','2013-09-05','11:00:00',2.5),('15128','2013-09-05','11:05:00',2.62),('15128','2013-09-05','11:10:00',2.66),('15128','2013-09-05','11:15:00',2.75),('15128','2013-09-05','11:20:00',2.76),('15128','2013-09-05','11:25:00',2.81),('15128','2013-09-05','11:30:00',2.82),('15128','2013-09-05','11:35:00',2.87),('15128','2013-09-05','11:40:00',2.96),('15128','2013-09-05','11:45:00',2.97),('15128','2013-09-05','11:50:00',3.09),('15128','2013-09-05','11:55:00',3.23),('15128','2013-09-05','12:00:00',3.34),('15128','2013-09-05','12:05:00',3.4),('15128','2013-09-05','12:10:00',3.44),('15128','2013-09-05','12:15:00',3.49),('15128','2013-09-05','12:20:00',3.53),('15128','2013-09-05','12:25:00',3.57),('15128','2013-09-05','12:30:00',3.57),('15128','2013-09-05','12:35:00',3.57),('15128','2013-09-05','12:40:00',3.61),('15128','2013-09-05','12:45:00',3.64),('15128','2013-09-05','12:50:00',3.65),('15128','2013-09-05','12:55:00',3.67),('15128','2013-09-05','13:00:00',3.71),('15128','2013-09-05','13:05:00',3.72),('15128','2013-09-05','13:10:00',3.72),('15128','2013-09-05','13:15:00',3.72),('15128','2013-09-05','13:20:00',3.72),('15128','2013-09-05','13:25:00',3.7),('15128','2013-09-05','13:30:00',3.7),('15128','2013-09-05','13:35:00',3.71),('15128','2013-09-05','13:40:00',3.71),('15128','2013-09-05','13:45:00',3.72),('15128','2013-09-05','13:50:00',3.73),('15128','2013-09-05','13:55:00',3.75),('15128','2013-09-05','14:00:00',3.69),('15128','2013-09-05','14:05:00',3.65),('15128','2013-09-05','14:10:00',3.69),('15128','2013-09-05','14:15:00',3.61),('15128','2013-09-05','14:20:00',3.52),('15128','2013-09-05','14:25:00',3.58),('15128','2013-09-05','14:30:00',3.6),('15128','2013-09-05','14:35:00',3.66),('15128','2013-09-05','14:40:00',3.66),('15128','2013-09-05','14:45:00',3.6),('15128','2013-09-05','14:50:00',3.61),('15128','2013-09-05','14:55:00',3.58),('15128','2013-09-05','15:00:00',3.57),('15128','2013-09-05','15:05:00',3.53),('15128','2013-09-05','15:10:00',3.52),('15128','2013-09-05','15:15:00',3.5),('15128','2013-09-05','15:20:00',3.52),('15128','2013-09-05','15:25:00',3.5),('15128','2013-09-05','15:30:00',3.44),('15128','2013-09-05','15:35:00',3.4),('15128','2013-09-05','15:40:00',3.37),('15128','2013-09-05','15:45:00',3.34),('15128','2013-09-05','15:50:00',3.3),('15128','2013-09-05','15:55:00',3.27),('15128','2013-09-05','16:00:00',3.23),('15128','2013-09-05','16:05:00',3.18),('15128','2013-09-05','16:10:00',3.14),('15128','2013-09-05','16:15:00',3.11),('15128','2013-09-05','16:20:00',3.04),('15128','2013-09-05','16:25:00',2.96),('15128','2013-09-05','16:30:00',2.94),('15128','2013-09-05','16:35:00',2.85),('15128','2013-09-05','16:40:00',2.75),('15128','2013-09-05','16:45:00',2.7),('15128','2013-09-05','16:50:00',2.62),('15128','2013-09-05','16:55:00',2.53),('15128','2013-09-05','17:00:00',2.41),('15128','2013-09-05','17:05:00',2.3),('15128','2013-09-05','17:10:00',2.14),('15128','2013-09-05','17:15:00',2.04),('15128','2013-09-05','17:20:00',1.97),('15128','2013-09-05','17:25:00',1.88),('15128','2013-09-05','17:30:00',1.76),('15128','2013-09-05','17:35:00',1.67),('15128','2013-09-05','17:40:00',1.59),('15128','2013-09-05','17:45:00',1.51),('15128','2013-09-05','17:50:00',1.48),('15128','2013-09-05','17:55:00',1.44),('15128','2013-09-05','18:00:00',1.38),('15128','2013-09-05','18:05:00',1.26),('15128','2013-09-05','18:10:00',1.09),('15128','2013-09-05','18:15:00',1.02),('15128','2013-09-04','08:50:00',1.08),('15128','2013-09-04','08:55:00',1.12),('15128','2013-09-04','09:00:00',1.18),('15128','2013-09-04','09:05:00',1.27),('15128','2013-09-04','09:10:00',1.34),('15128','2013-09-04','09:15:00',1.37),('15128','2013-09-04','09:20:00',1.45),('15128','2013-09-04','09:25:00',1.53),('15128','2013-09-04','09:30:00',1.6),('15128','2013-09-04','09:35:00',1.69),('15128','2013-09-04','09:40:00',1.76),('15128','2013-09-04','09:45:00',1.81),('15128','2013-09-04','09:50:00',1.86),('15128','2013-09-04','09:55:00',1.84),('15128','2013-09-04','10:00:00',1.89),('15128','2013-09-04','10:05:00',1.94),('15128','2013-09-04','10:10:00',2.01),('15128','2013-09-04','10:15:00',2.08),('15128','2013-09-04','10:20:00',2.08),('15128','2013-09-04','10:25:00',2.16),('15128','2013-09-04','10:30:00',2.2),('15128','2013-09-04','10:35:00',2.21),('15128','2013-09-04','10:40:00',2.29),('15128','2013-09-04','10:45:00',2.42),('15128','2013-09-04','10:50:00',2.47),('15128','2013-09-04','10:55:00',2.5),('15128','2013-09-04','11:00:00',2.55),('15128','2013-09-04','11:05:00',2.7),('15128','2013-09-04','11:10:00',2.74),('15128','2013-09-04','11:15:00',2.79),('15128','2013-09-04','11:20:00',2.85),('15128','2013-09-04','11:25:00',2.82),('15128','2013-09-04','11:30:00',2.91),('15128','2013-09-04','11:35:00',2.92),('15128','2013-09-04','11:40:00',3.03),('15128','2013-09-04','11:45:00',3.06),('15128','2013-09-04','11:50:00',3.22),('15128','2013-09-04','11:55:00',3.35),('15128','2013-09-04','12:00:00',3.46),('15128','2013-09-04','12:05:00',3.51),('15128','2013-09-04','12:10:00',3.57),('15128','2013-09-04','12:15:00',3.6),('15128','2013-09-04','12:20:00',3.64),('15128','2013-09-04','12:25:00',3.66),('15128','2013-09-04','12:30:00',3.71),('15128','2013-09-04','12:35:00',3.72),('15128','2013-09-04','12:40:00',3.73),('15128','2013-09-04','12:45:00',3.73),('15128','2013-09-04','12:50:00',3.76),('15128','2013-09-04','12:55:00',3.78),('15128','2013-09-04','13:00:00',3.82),('15128','2013-09-04','13:05:00',3.84),('15128','2013-09-04','13:10:00',3.83),('15128','2013-09-04','13:15:00',3.85),('15128','2013-09-04','13:20:00',3.87),('15128','2013-09-04','13:25:00',3.89),('15128','2013-09-04','13:30:00',3.88),('15128','2013-09-04','13:35:00',3.88),('15128','2013-09-04','13:40:00',3.88),('15128','2013-09-04','13:45:00',3.88),('15128','2013-09-04','13:50:00',3.84),('15128','2013-09-04','13:55:00',3.82),('15128','2013-09-04','14:00:00',3.81),('15128','2013-09-04','14:05:00',3.81),('15128','2013-09-04','14:10:00',3.81),('15128','2013-09-04','14:15:00',3.8),('15128','2013-09-04','14:20:00',3.83),('15128','2013-09-04','14:25:00',3.84),('15128','2013-09-04','14:30:00',3.82),('15128','2013-09-04','14:35:00',3.8),('15128','2013-09-04','14:40:00',3.77),('15128','2013-09-04','14:45:00',3.76),('15128','2013-09-04','14:50:00',3.77),('15128','2013-09-04','14:55:00',3.75),('15128','2013-09-04','15:00:00',3.72),('15128','2013-09-04','15:05:00',3.7),('15128','2013-09-04','15:10:00',3.71),('15128','2013-09-04','15:15:00',3.67),('15128','2013-09-04','15:20:00',3.62),('15128','2013-09-04','15:25:00',3.58),('15128','2013-09-04','15:30:00',3.57),('15128','2013-09-04','15:35:00',3.53),('15128','2013-09-04','15:40:00',3.48),('15128','2013-09-04','15:45:00',3.43),('15128','2013-09-04','15:50:00',3.39),('15128','2013-09-04','15:55:00',3.33),('15128','2013-09-04','16:00:00',3.29),('15128','2013-09-04','16:05:00',3.24),('15128','2013-09-04','16:10:00',3.19),('15128','2013-09-04','16:15:00',3.15),('15128','2013-09-04','16:20:00',3.12),('15128','2013-09-04','16:25:00',3.08),('15128','2013-09-04','16:30:00',3.02),('15128','2013-09-04','16:35:00',2.97),('15128','2013-09-04','16:40:00',2.94),('15128','2013-09-04','16:45:00',2.88),('15128','2013-09-04','16:50:00',2.85),('15128','2013-09-04','16:55:00',2.68),('15128','2013-09-04','17:00:00',1.95),('15128','2013-09-04','17:05:00',1.53),('15128','2013-09-04','17:10:00',1.71),('15128','2013-09-04','17:15:00',1.57),('15128','2013-09-04','17:20:00',1.49),('15128','2013-09-04','17:25:00',1.61),('15128','2013-09-04','17:30:00',1.55),('15128','2013-09-04','17:35:00',1.7),('15128','2013-09-04','17:40:00',1.86),('15128','2013-09-04','17:45:00',1.85),('15128','2013-09-04','17:50:00',1.68),('15128','2013-09-04','17:55:00',1.76),('15128','2013-09-04','18:00:00',1.43),('15128','2013-09-04','18:05:00',1.34),('15128','2013-09-04','18:10:00',1.23),('15128','2013-09-04','18:15:00',1.12),('15128','2013-09-04','18:20:00',1.04),('15128','2013-09-03','08:50:00',1.08),('15128','2013-09-03','08:55:00',1.14),('15128','2013-09-03','09:00:00',1.19),('15128','2013-09-03','09:05:00',1.29),('15128','2013-09-03','09:10:00',1.37),('15128','2013-09-03','09:15:00',1.42),('15128','2013-09-03','09:20:00',1.5),('15128','2013-09-03','09:25:00',1.56),('15128','2013-09-03','09:30:00',1.63),('15128','2013-09-03','09:35:00',1.73),('15128','2013-09-03','09:40:00',1.8),('15128','2013-09-03','09:45:00',1.85),('15128','2013-09-03','09:50:00',1.89),('15128','2013-09-03','09:55:00',1.87),('15128','2013-09-03','10:00:00',1.96),('15128','2013-09-03','10:05:00',2.01),('15128','2013-09-03','10:10:00',2.08),('15128','2013-09-03','10:15:00',2.15),('15128','2013-09-03','10:20:00',2.2),('15128','2013-09-03','10:25:00',2.26),('15128','2013-09-03','10:30:00',2.34),('15128','2013-09-03','10:35:00',2.34),('15128','2013-09-03','10:40:00',2.37),('15128','2013-09-03','10:45:00',2.44),('15128','2013-09-03','10:50:00',2.51),('15128','2013-09-03','10:55:00',2.56),('15128','2013-09-03','11:00:00',2.61),('15128','2013-09-03','11:05:00',2.72),('15128','2013-09-03','11:10:00',2.76),('15128','2013-09-03','11:15:00',2.79),('15128','2013-09-03','11:20:00',2.88),('15128','2013-09-03','11:25:00',2.87),('15128','2013-09-03','11:30:00',2.99),('15128','2013-09-03','11:35:00',2.96),('15128','2013-09-03','11:40:00',3.1),('15128','2013-09-03','11:45:00',3.14),('15128','2013-09-03','11:50:00',3.34),('15128','2013-09-03','11:55:00',3.44),('15128','2013-09-03','12:00:00',3.53),('15128','2013-09-03','12:05:00',3.57),('15128','2013-09-03','12:10:00',3.6),('15128','2013-09-03','12:15:00',3.64),('15128','2013-09-03','12:20:00',3.68),('15128','2013-09-03','12:25:00',3.72),('15128','2013-09-03','12:30:00',3.77),('15128','2013-09-03','12:35:00',3.79),('15128','2013-09-03','12:40:00',3.79),('15128','2013-09-03','12:45:00',3.79),('15128','2013-09-03','12:50:00',3.82),('15128','2013-09-03','12:55:00',3.85),('15128','2013-09-03','13:00:00',3.86),('15128','2013-09-03','13:05:00',3.86),('15128','2013-09-03','13:10:00',3.94),('15128','2013-09-03','13:15:00',3.95),('15128','2013-09-03','13:20:00',3.95),('15128','2013-09-03','13:25:00',3.94),('15128','2013-09-03','13:30:00',3.93),('15128','2013-09-03','13:35:00',3.93),('15128','2013-09-03','13:40:00',3.92),('15128','2013-09-03','13:45:00',3.94),('15128','2013-09-03','13:50:00',3.95),('15128','2013-09-03','13:55:00',3.94),('15128','2013-09-03','14:00:00',3.96),('15128','2013-09-03','14:05:00',3.95),('15128','2013-09-03','14:10:00',3.92),('15128','2013-09-03','14:15:00',3.89),('15128','2013-09-03','14:20:00',3.88),('15128','2013-09-03','14:25:00',3.86),('15128','2013-09-03','14:30:00',3.87),('15128','2013-09-03','14:35:00',3.86),('15128','2013-09-03','14:40:00',3.86),('15128','2013-09-03','14:45:00',3.83),('15128','2013-09-03','14:50:00',3.81),('15128','2013-09-03','14:55:00',3.79),('15128','2013-09-03','15:00:00',3.76),('15128','2013-09-03','15:05:00',3.76),('15128','2013-09-03','15:10:00',3.71),('15128','2013-09-03','15:15:00',3.67),('15128','2013-09-03','15:20:00',3.63),('15128','2013-09-03','15:25:00',3.58),('15128','2013-09-03','15:30:00',3.55),('15128','2013-09-03','15:35:00',3.5),('15128','2013-09-03','15:40:00',3.48),('15128','2013-09-03','15:45:00',3.13),('15128','2013-09-03','15:50:00',3.43),('15128','2013-09-03','15:55:00',3.39),('15128','2013-09-03','16:00:00',3.34),('15128','2013-09-03','16:05:00',3.28),('15128','2013-09-03','16:10:00',3.25),('15128','2013-09-03','16:15:00',3.21),('15128','2013-09-03','16:20:00',3.14),('15128','2013-09-03','16:25:00',3.05),('15128','2013-09-03','16:30:00',2.95),('15128','2013-09-03','16:35:00',2.91),('15128','2013-09-03','16:40:00',2.83),('15128','2013-09-03','16:45:00',2.8),('15128','2013-09-03','16:50:00',2.74),('15128','2013-09-03','16:55:00',2.67),('15128','2013-09-03','17:00:00',2.56),('15128','2013-09-03','17:05:00',2.42),('15128','2013-09-03','17:10:00',2.29),('15128','2013-09-03','17:15:00',2.23),('15128','2013-09-03','17:20:00',2.09),('15128','2013-09-03','17:25:00',1.95),('15128','2013-09-03','17:30:00',1.84),('15128','2013-09-03','17:35:00',1.8),('15128','2013-09-03','17:40:00',1.72),('15128','2013-09-03','17:45:00',1.68),('15128','2013-09-03','17:50:00',1.62),('15128','2013-09-03','17:55:00',1.6),('15128','2013-09-03','18:00:00',1.52),('15128','2013-09-03','18:05:00',1.45),('15128','2013-09-03','18:10:00',1.33),('15128','2013-09-03','18:15:00',1.21),('15128','2013-09-03','18:20:00',1.09),('15128','2013-09-03','18:25:00',1.01),('15128','2013-09-02','08:50:00',1.05),('15128','2013-09-02','08:55:00',1.1),('15128','2013-09-02','09:00:00',1.15),('15128','2013-09-02','09:05:00',1.24),('15128','2013-09-02','09:10:00',1.32),('15128','2013-09-02','09:15:00',1.37),('15128','2013-09-02','09:20:00',1.43),('15128','2013-09-02','09:25:00',1.5),('15128','2013-09-02','09:30:00',1.56),('15128','2013-09-02','09:35:00',1.63),('15128','2013-09-02','09:40:00',1.72),('15128','2013-09-02','09:45:00',1.79),('15128','2013-09-02','09:50:00',1.84),('15128','2013-09-02','09:55:00',1.85),('15128','2013-09-02','10:00:00',1.92),('15128','2013-09-02','10:05:00',1.96),('15128','2013-09-02','10:10:00',2.02),('15128','2013-09-02','10:15:00',2.07),('15128','2013-09-02','10:20:00',2.11),('15128','2013-09-02','10:25:00',2.18),('15128','2013-09-02','10:30:00',2.29),('15128','2013-09-02','10:35:00',2.33),('15128','2013-09-02','10:40:00',2.39),('15128','2013-09-02','10:45:00',2.43),('15128','2013-09-02','10:50:00',2.38),('15128','2013-09-02','10:55:00',2.46),('15128','2013-09-02','11:00:00',2.53),('15128','2013-09-02','11:05:00',2.66),('15128','2013-09-02','11:10:00',2.72),('15128','2013-09-02','11:15:00',2.73),('15128','2013-09-02','11:20:00',2.86),('15128','2013-09-02','11:25:00',2.85),('15128','2013-09-02','11:30:00',2.97),('15128','2013-09-02','11:35:00',2.96),('15128','2013-09-02','11:40:00',3.04),('15128','2013-09-02','11:45:00',3.14),('15128','2013-09-02','11:50:00',3.21),('15128','2013-09-02','11:55:00',3.36),('15128','2013-09-02','12:00:00',3.42),('15128','2013-09-02','12:05:00',3.49),('15128','2013-09-02','12:10:00',3.54),('15128','2013-09-02','12:15:00',3.55),('15128','2013-09-02','12:20:00',3.62),('15128','2013-09-02','12:25:00',3.65),('15128','2013-09-02','12:30:00',3.69),('15128','2013-09-02','12:35:00',3.74),('15128','2013-09-02','12:40:00',3.79),('15128','2013-09-02','12:45:00',3.78),('15128','2013-09-02','12:50:00',3.84),('15128','2013-09-02','12:55:00',3.9),('15128','2013-09-02','13:00:00',3.9),('15128','2013-09-02','13:05:00',3.9),('15128','2013-09-02','13:10:00',3.91),('15128','2013-09-02','13:15:00',3.86),('15128','2013-09-02','13:20:00',3.87),('15128','2013-09-02','13:25:00',3.86),('15128','2013-09-02','13:30:00',3.89),('15128','2013-09-02','13:35:00',3.94),('15128','2013-09-02','13:40:00',3.95),('15128','2013-09-02','13:45:00',3.92),('15128','2013-09-02','13:50:00',3.94),('15128','2013-09-02','13:55:00',3.99),('15128','2013-09-02','14:00:00',4.02),('15128','2013-09-02','14:05:00',4.01),('15128','2013-09-02','14:10:00',3.96),('15128','2013-09-02','14:15:00',3.92),('15128','2013-09-02','14:20:00',3.91),('15128','2013-09-02','14:25:00',3.89),('15128','2013-09-02','14:30:00',3.87),('15128','2013-09-02','14:35:00',3.86),('15128','2013-09-02','14:40:00',3.85),('15128','2013-09-02','14:45:00',3.82),('15128','2013-09-02','14:50:00',3.8),('15128','2013-09-02','14:55:00',3.76),('15128','2013-09-02','15:00:00',3.76),('15128','2013-09-02','15:05:00',3.72),('15128','2013-09-02','15:10:00',3.67),('15128','2013-09-02','15:15:00',3.63),('15128','2013-09-02','15:20:00',3.59),('15128','2013-09-02','15:25:00',3.57),('15128','2013-09-02','15:30:00',3.53),('15128','2013-09-02','15:35:00',3.48),('15128','2013-09-02','15:40:00',3.45),('15128','2013-09-02','15:45:00',3.41),('15128','2013-09-02','15:50:00',3.37),('15128','2013-09-02','15:55:00',3.32),('15128','2013-09-02','16:00:00',3.27),('15128','2013-09-02','16:05:00',3.21),('15128','2013-09-02','16:10:00',3.18),('15128','2013-09-02','16:15:00',3.12),('15128','2013-09-02','16:20:00',3.07),('15128','2013-09-02','16:25:00',3.02),('15128','2013-09-02','16:30:00',2.96),('15128','2013-09-02','16:35:00',2.92),('15128','2013-09-02','16:40:00',2.85),('15128','2013-09-02','16:45:00',2.77),('15128','2013-09-02','16:50:00',2.72),('15128','2013-09-02','16:55:00',2.67),('15128','2013-09-02','17:00:00',2.6),('15128','2013-09-02','17:05:00',2.49),('15128','2013-09-02','17:10:00',2.37),('15128','2013-09-02','17:15:00',2.26),('15128','2013-09-02','17:20:00',2.11),('15128','2013-09-02','17:25:00',1.89),('15128','2013-09-02','17:30:00',1.79),('15128','2013-09-02','17:35:00',1.7),('15128','2013-09-02','17:40:00',1.59),('15128','2013-09-02','17:45:00',1.52),('15128','2013-09-02','17:50:00',1.45),('15128','2013-09-02','17:55:00',1.49),('15128','2013-09-02','18:00:00',1.41),('15128','2013-09-02','18:05:00',1.37),('15128','2013-09-02','18:10:00',1.28),('15128','2013-09-02','18:15:00',1.19),('15128','2013-09-02','18:20:00',1.07),('15128','2013-09-01','08:45:00',1.03),('15128','2013-09-01','08:50:00',1.1),('15128','2013-09-01','08:55:00',1.15),('15128','2013-09-01','09:00:00',1.2),('15128','2013-09-01','09:05:00',1.3),('15128','2013-09-01','09:10:00',1.36),('15128','2013-09-01','09:15:00',1.41),('15128','2013-09-01','09:20:00',1.5),('15128','2013-09-01','09:25:00',1.58),('15128','2013-09-01','09:30:00',1.62),('15128','2013-09-01','09:35:00',1.69),('15128','2013-09-01','09:40:00',1.72),('15128','2013-09-01','09:45:00',1.78),('15128','2013-09-01','09:50:00',1.83),('15128','2013-09-01','09:55:00',1.89),('15128','2013-09-01','10:00:00',1.95),('15128','2013-09-01','10:05:00',2),('15128','2013-09-01','10:10:00',2.08),('15128','2013-09-01','10:15:00',2.13),('15128','2013-09-01','10:20:00',2.17),('15128','2013-09-01','10:25:00',2.24),('15128','2013-09-01','10:30:00',2.3),('15128','2013-09-01','10:35:00',2.39),('15128','2013-09-01','10:40:00',2.44),('15128','2013-09-01','10:45:00',2.49),('15128','2013-09-01','10:50:00',2.57),('15128','2013-09-01','10:55:00',2.6),('15128','2013-09-01','11:00:00',2.62),('15128','2013-09-01','11:05:00',2.71),('15128','2013-09-01','11:10:00',2.81),('15128','2013-09-01','11:15:00',2.82),('15128','2013-09-01','11:20:00',2.91),('15128','2013-09-01','11:25:00',2.92),('15128','2013-09-01','11:30:00',3.02),('15128','2013-09-01','11:35:00',3.07),('15128','2013-09-01','11:40:00',3.13),('15128','2013-09-01','11:45:00',3.17),('15128','2013-09-01','11:50:00',3.28),('15128','2013-09-01','11:55:00',3.38),('15128','2013-09-01','12:00:00',3.49),('15128','2013-09-01','12:05:00',3.55),('15128','2013-09-01','12:10:00',3.59),('15128','2013-09-01','12:15:00',3.62),('15128','2013-09-01','12:20:00',3.65),('15128','2013-09-01','12:25:00',3.68),('15128','2013-09-01','12:30:00',3.7),('15128','2013-09-01','12:35:00',3.72),('15128','2013-09-01','12:40:00',3.74),('15128','2013-09-01','12:45:00',3.76),('15128','2013-09-01','12:50:00',3.8),('15128','2013-09-01','12:55:00',3.81),('15128','2013-09-01','13:00:00',3.82),('15128','2013-09-01','13:05:00',3.84),('15128','2013-09-01','13:10:00',3.88),('15128','2013-09-01','13:15:00',3.88),('15128','2013-09-01','13:20:00',3.87),('15128','2013-09-01','13:25:00',3.9),('15128','2013-09-01','13:30:00',3.9),('15128','2013-09-01','13:35:00',3.89),('15128','2013-09-01','13:40:00',3.87),('15128','2013-09-01','13:45:00',3.89),('15128','2013-09-01','13:50:00',3.89),('15128','2013-09-01','13:55:00',3.86),('15128','2013-09-01','14:00:00',3.83),('15128','2013-09-01','14:05:00',3.85),('15128','2013-09-01','14:10:00',3.8),('15128','2013-09-01','14:15:00',3.9),('15128','2013-09-01','14:20:00',3.87),('15128','2013-09-01','14:25:00',3.89),('15128','2013-09-01','14:30:00',3.85),('15128','2013-09-01','14:35:00',3.87),('15128','2013-09-01','14:40:00',3.87),('15128','2013-09-01','14:45:00',3.84),('15128','2013-09-01','14:50:00',3.79),('15128','2013-09-01','14:55:00',3.74),('15128','2013-09-01','15:00:00',3.73),('15128','2013-09-01','15:05:00',3.71),('15128','2013-09-01','15:10:00',3.7),('15128','2013-09-01','15:15:00',3.66),('15128','2013-09-01','15:20:00',3.63),('15128','2013-09-01','15:25:00',3.58),('15128','2013-09-01','15:30:00',3.59),('15128','2013-09-01','15:35:00',3.54),('15128','2013-09-01','15:40:00',3.54),('15128','2013-09-01','15:45:00',3.53),('15128','2013-09-01','15:50:00',3.47),('15128','2013-09-01','15:55:00',3.36),('15128','2013-09-01','16:00:00',3.36),('15128','2013-09-01','16:05:00',3.32),('15128','2013-09-01','16:10:00',3.22),('15128','2013-09-01','16:15:00',3.15),('15128','2013-09-01','16:20:00',3.11),('15128','2013-09-01','16:25:00',3.05),('15128','2013-09-01','16:30:00',3.01),('15128','2013-09-01','16:35:00',2.96),('15128','2013-09-01','16:40:00',2.88),('15128','2013-09-01','16:45:00',2.8),('15128','2013-09-01','16:50:00',2.73),('15128','2013-09-01','16:55:00',2.67),('15128','2013-09-01','17:00:00',2.57),('15128','2013-09-01','17:05:00',2.46),('15128','2013-09-01','17:10:00',2.35),('15128','2013-09-01','17:15:00',2.24),('15128','2013-09-01','17:20:00',2.16),('15128','2013-09-01','17:25:00',2.03),('15128','2013-09-01','17:30:00',1.88),('15128','2013-09-01','17:35:00',1.83),('15128','2013-09-01','17:40:00',1.74),('15128','2013-09-01','17:45:00',1.65),('15128','2013-09-01','17:50:00',1.56),('15128','2013-09-01','17:55:00',1.54),('15128','2013-09-01','18:00:00',1.47),('15128','2013-09-01','18:05:00',1.4),('15128','2013-09-01','18:10:00',1.3),('15128','2013-09-01','18:15:00',1.18),('15128','2013-09-01','18:20:00',1.05),('15128','2013-08-31','08:45:00',1.05),('15128','2013-08-31','08:50:00',1.11),('15128','2013-08-31','08:55:00',1.16),('15128','2013-08-31','09:00:00',1.21),('15128','2013-08-31','09:05:00',1.31),('15128','2013-08-31','09:10:00',1.38),('15128','2013-08-31','09:15:00',1.44),('15128','2013-08-31','09:20:00',1.52),('15128','2013-08-31','09:25:00',1.61),('15128','2013-08-31','09:30:00',1.66),('15128','2013-08-31','09:35:00',1.72),('15128','2013-08-31','09:40:00',1.76),('15128','2013-08-31','09:45:00',1.83),('15128','2013-08-31','09:50:00',1.89),('15128','2013-08-31','09:55:00',1.93),('15128','2013-08-31','10:00:00',1.99),('15128','2013-08-31','10:05:00',2.04),('15128','2013-08-31','10:10:00',2.08),('15128','2013-08-31','10:15:00',2.12),('15128','2013-08-31','10:20:00',2.19),('15128','2013-08-31','10:25:00',2.27),('15128','2013-08-31','10:30:00',2.37),('15128','2013-08-31','10:35:00',2.44),('15128','2013-08-31','10:40:00',2.51),('15128','2013-08-31','10:45:00',2.57),('15128','2013-08-31','10:50:00',2.58),('15128','2013-08-31','10:55:00',2.65),('15128','2013-08-31','11:00:00',2.63),('15128','2013-08-31','11:05:00',2.71),('15128','2013-08-31','11:10:00',2.85),('15128','2013-08-31','11:15:00',2.88),('15128','2013-08-31','11:20:00',2.95),('15128','2013-08-31','11:25:00',3),('15128','2013-08-31','11:30:00',3.08),('15128','2013-08-31','11:35:00',3.14),('15128','2013-08-31','11:40:00',3.19),('15128','2013-08-31','11:45:00',3.19),('15128','2013-08-31','11:50:00',3.3),('15128','2013-08-31','11:55:00',3.41),('15128','2013-08-31','12:00:00',3.54),('15128','2013-08-31','12:05:00',3.61),('15128','2013-08-31','12:10:00',3.63),('15128','2013-08-31','12:15:00',3.68),('15128','2013-08-31','12:20:00',3.71),('15128','2013-08-31','12:25:00',3.73),('15128','2013-08-31','12:30:00',3.76),('15128','2013-08-31','12:35:00',3.8),('15128','2013-08-31','12:40:00',3.81),('15128','2013-08-31','12:45:00',3.8),('15128','2013-08-31','12:50:00',3.86),('15128','2013-08-31','12:55:00',3.8),('15128','2013-08-31','13:00:00',3.93),('15128','2013-08-31','13:05:00',3.49),('15128','2013-08-31','13:10:00',3.57),('15128','2013-08-31','13:15:00',3.82),('15128','2013-08-31','13:20:00',3.72),('15128','2013-08-31','13:25:00',3.43),('15128','2013-08-31','13:30:00',3.53),('15128','2013-08-31','13:35:00',3.84),('15128','2013-08-31','13:40:00',4.1),('15128','2013-08-31','13:45:00',4.06),('15128','2013-08-31','13:50:00',4.06),('15128','2013-08-31','13:55:00',3.88),('15128','2013-08-31','14:00:00',3.87),('15128','2013-08-31','14:05:00',3.8),('15128','2013-08-31','14:10:00',3.61),('15128','2013-08-31','14:15:00',3.76),('15128','2013-08-31','14:20:00',3.59),('15128','2013-08-31','14:25:00',3.51),('15128','2013-08-31','14:30:00',3.21),('15128','2013-08-31','14:35:00',3.07),('15128','2013-08-31','14:40:00',3.44),('15128','2013-08-31','14:45:00',3.84),('15128','2013-08-31','14:50:00',3.65),('15128','2013-08-31','14:55:00',3.7),('15128','2013-08-31','15:00:00',3.71),('15128','2013-08-31','15:05:00',3.67),('15128','2013-08-31','15:10:00',3.57),('15128','2013-08-31','15:15:00',3.47),('15128','2013-08-31','15:20:00',3.45),('15128','2013-08-31','15:25:00',3.33),('15128','2013-08-31','15:30:00',3),('15128','2013-08-31','15:35:00',2.94),('15128','2013-08-31','15:40:00',2.91),('15128','2013-08-31','15:45:00',2.91),('15128','2013-08-31','15:50:00',2.76),('15128','2013-08-31','15:55:00',2.3),('15128','2013-08-31','16:00:00',2.55),('15128','2013-08-31','16:05:00',2.8),('15128','2013-08-31','16:10:00',3.18),('15128','2013-08-31','16:15:00',3.17),('15128','2013-08-31','16:20:00',2.99),('15128','2013-08-31','16:25:00',3.02),('15128','2013-08-31','16:30:00',2.78),('15128','2013-08-31','16:35:00',2.94),('15128','2013-08-31','16:40:00',2.68),('15128','2013-08-31','16:45:00',2.52),('15128','2013-08-31','16:50:00',2.43),('15128','2013-08-31','16:55:00',2.4),('15128','2013-08-31','17:00:00',2.43),('15128','2013-08-31','17:05:00',2.44),('15128','2013-08-31','17:10:00',2.37),('15128','2013-08-31','17:15:00',2.31),('15128','2013-08-31','17:20:00',2.12),('15128','2013-08-31','17:25:00',1.9),('15128','2013-08-31','17:30:00',1.94),('15128','2013-08-31','17:35:00',1.84),('15128','2013-08-31','17:40:00',1.55),('15128','2013-08-31','17:45:00',1.8),('15128','2013-08-31','17:50:00',1.76),('15128','2013-08-31','17:55:00',1.67),('15128','2013-08-31','18:00:00',1.51),('15128','2013-08-31','18:05:00',1.36),('15128','2013-08-31','18:10:00',1.42),('15128','2013-08-31','18:15:00',1.12),('15128','2013-08-31','18:20:00',1.18),('15128','2013-08-31','18:25:00',1.22),('15128','2013-08-31','18:30:00',1.01),('15128','2013-08-31','18:35:00',1.04),('15128','2013-08-31','18:40:00',1.03),('15128','2013-08-30','08:45:00',1.15),('15128','2013-08-30','08:50:00',1.3),('15128','2013-08-30','08:55:00',1.41),('15128','2013-08-30','09:00:00',1.16),('15128','2013-08-30','09:10:00',1.17),('15128','2013-08-30','09:15:00',1.56),('15128','2013-08-30','09:20:00',1.59),('15128','2013-08-30','09:25:00',1.72),('15128','2013-08-30','09:30:00',1.79),('15128','2013-08-30','09:35:00',1.8),('15128','2013-08-30','09:40:00',1.76),('15128','2013-08-30','09:45:00',1.86),('15128','2013-08-30','09:50:00',2.06),('15128','2013-08-30','09:55:00',1.98),('15128','2013-08-30','10:00:00',2.11),('15128','2013-08-30','10:05:00',2.16),('15128','2013-08-30','10:10:00',2.15),('15128','2013-08-30','10:15:00',2.15),('15128','2013-08-30','10:20:00',2.22),('15128','2013-08-30','10:25:00',2.35),('15128','2013-08-30','10:30:00',2.46),('15128','2013-08-30','10:35:00',2.49),('15128','2013-08-30','10:40:00',2.57),('15128','2013-08-30','10:45:00',2.59),('15128','2013-08-30','10:50:00',2.69),('15128','2013-08-30','10:55:00',2.78),('15128','2013-08-30','11:00:00',2.79),('15128','2013-08-30','11:05:00',2.84),('15128','2013-08-30','11:10:00',2.92),('15128','2013-08-30','11:15:00',2.99),('15128','2013-08-30','11:20:00',3.03),('15128','2013-08-30','11:25:00',3.12),('15128','2013-08-30','11:30:00',3.15),('15128','2013-08-30','11:35:00',3.12),('15128','2013-08-30','11:40:00',3.24),('15128','2013-08-30','11:45:00',3.21),('15128','2013-08-30','11:50:00',3.34),('15128','2013-08-30','11:55:00',3.47),('15128','2013-08-30','12:00:00',3.63),('15128','2013-08-30','12:05:00',3.68),('15128','2013-08-30','12:10:00',3.7),('15128','2013-08-30','12:15:00',3.75),('15128','2013-08-30','12:20:00',3.76),('15128','2013-08-30','12:25:00',3.76),('15128','2013-08-30','12:30:00',3.79),('15128','2013-08-30','12:35:00',3.85),('15128','2013-08-30','12:40:00',3.87),('15128','2013-08-30','12:45:00',3.86),('15128','2013-08-30','12:50:00',3.93),('15128','2013-08-30','12:55:00',3.94),('15128','2013-08-30','13:00:00',3.95),('15128','2013-08-30','13:05:00',3.95),('15128','2013-08-30','13:10:00',3.97),('15128','2013-08-30','13:15:00',3.98),('15128','2013-08-30','13:20:00',3.96),('15128','2013-08-30','13:25:00',3.94),('15128','2013-08-30','13:30:00',3.91),('15128','2013-08-30','13:35:00',3.96),('15128','2013-08-30','13:40:00',3.99),('15128','2013-08-30','13:45:00',3.97),('15128','2013-08-30','13:50:00',3.94),('15128','2013-08-30','13:55:00',3.91),('15128','2013-08-30','14:00:00',3.92),('15128','2013-08-30','14:05:00',3.91),('15128','2013-08-30','14:10:00',3.92),('15128','2013-08-30','14:15:00',3.88),('15128','2013-08-30','14:20:00',3.91),('15128','2013-08-30','14:25:00',3.89),('15128','2013-08-30','14:30:00',3.8),('15128','2013-08-30','14:35:00',3.82),('15128','2013-08-30','14:40:00',3.78),('15128','2013-08-30','14:45:00',3.7),('15128','2013-08-30','14:50:00',3.67),('15128','2013-08-30','14:55:00',3.67),('15128','2013-08-30','15:00:00',3.71),('15128','2013-08-30','15:05:00',3.64),('15128','2013-08-30','15:10:00',3.61),('15128','2013-08-30','15:15:00',3.58),('15128','2013-08-30','15:20:00',3.55),('15128','2013-08-30','15:25:00',3.54),('15128','2013-08-30','15:30:00',3.5),('15128','2013-08-30','15:35:00',3.49),('15128','2013-08-30','15:40:00',3.39),('15128','2013-08-30','15:45:00',3.35),('15128','2013-08-30','15:50:00',3.34),('15128','2013-08-30','15:55:00',3.35),('15128','2013-08-30','16:00:00',3.34),('15128','2013-08-30','16:05:00',3.25),('15128','2013-08-30','16:10:00',3.18),('15128','2013-08-30','16:15:00',3.08),('15128','2013-08-30','16:20:00',3.01),('15128','2013-08-30','16:25:00',2.94),('15128','2013-08-30','16:30:00',2.99),('15128','2013-08-30','16:35:00',2.86),('15128','2013-08-30','16:40:00',2.72),('15128','2013-08-30','16:45:00',2.68),('15128','2013-08-30','16:50:00',2.73),('15128','2013-08-30','16:55:00',2.72),('15128','2013-08-30','17:00:00',2.64),('15128','2013-08-30','17:05:00',2.57),('15128','2013-08-30','17:10:00',2.46),('15128','2013-08-30','17:15:00',2.34),('15128','2013-08-30','17:20:00',2.17),('15128','2013-08-30','17:25:00',1.99),('15128','2013-08-30','17:30:00',1.95),('15128','2013-08-30','17:35:00',1.88),('15128','2013-08-30','17:40:00',1.77),('15128','2013-08-30','17:45:00',1.7),('15128','2013-08-30','17:50:00',1.32),('15128','2013-08-30','17:55:00',1.15),('15128','2013-08-30','18:00:00',1.01),('15128','2013-08-30','18:05:00',1.17),('15128','2013-08-30','18:10:00',1.09),('15128','2013-08-29','08:50:00',1.02),('15128','2013-08-29','08:55:00',1.21),('15128','2013-08-29','09:00:00',1.36),('15128','2013-08-29','09:05:00',1.34),('15128','2013-08-29','09:10:00',1.19),('15128','2013-08-29','09:15:00',1.06),('15128','2013-08-29','09:20:00',1.09),('15128','2013-08-29','09:25:00',1.37),('15128','2013-08-29','09:30:00',1.45),('15128','2013-08-29','09:35:00',1.45),('15128','2013-08-29','09:40:00',1.48),('15128','2013-08-29','09:45:00',1.55),('15128','2013-08-29','09:50:00',1.72),('15128','2013-08-29','09:55:00',1.76),('15128','2013-08-29','10:00:00',1.66),('15128','2013-08-29','10:05:00',1.71),('15128','2013-08-29','10:10:00',1.87),('15128','2013-08-29','10:15:00',1.88),('15128','2013-08-29','10:20:00',1.78),('15128','2013-08-29','10:25:00',1.99),('15128','2013-08-29','10:30:00',2.01),('15128','2013-08-29','10:35:00',1.97),('15128','2013-08-29','10:40:00',1.93),('15128','2013-08-29','10:45:00',2.05),('15128','2013-08-29','10:50:00',2.01),('15128','2013-08-29','10:55:00',1.97),('15128','2013-08-29','11:00:00',2.05),('15128','2013-08-29','11:05:00',2.19),('15128','2013-08-29','11:10:00',2.37),('15128','2013-08-29','11:15:00',2.3),('15128','2013-08-29','11:20:00',2.4),('15128','2013-08-29','11:25:00',2.42),('15128','2013-08-29','11:30:00',2.55),('15128','2013-08-29','11:35:00',2.47),('15128','2013-08-29','11:40:00',2.69),('15128','2013-08-29','11:45:00',2.79),('15128','2013-08-29','11:50:00',2.75),('15128','2013-08-29','11:55:00',2.7),('15128','2013-08-29','12:00:00',2.34),('15128','2013-08-29','12:05:00',2.57),('15128','2013-08-29','12:10:00',2.57),('15128','2013-08-29','12:15:00',2.43),('15128','2013-08-29','12:20:00',2.83),('15128','2013-08-29','12:25:00',3.1),('15128','2013-08-29','12:30:00',3.31),('15128','2013-08-29','12:35:00',3.12),('15128','2013-08-29','12:40:00',3.25),('15128','2013-08-29','12:45:00',3.15),('15128','2013-08-29','12:50:00',3),('15128','2013-08-29','12:55:00',2.89),('15128','2013-08-29','13:00:00',2.83),('15128','2013-08-29','13:05:00',2.61),('15128','2013-08-29','13:10:00',2.73),('15128','2013-08-29','13:15:00',2.93),('15128','2013-08-29','13:20:00',3.16),('15128','2013-08-29','13:25:00',4.2),('15128','2013-08-29','13:30:00',4.09),('15128','2013-08-29','13:35:00',3.78),('15128','2013-08-29','13:40:00',4.08),('15128','2013-08-29','13:45:00',3.98),('15128','2013-08-29','13:50:00',3.83),('15128','2013-08-29','13:55:00',3.91),('15128','2013-08-29','14:00:00',3.99),('15128','2013-08-29','14:05:00',4.05),('15128','2013-08-29','14:10:00',4.05),('15128','2013-08-29','14:15:00',3.79),('15128','2013-08-29','14:20:00',3.76),('15128','2013-08-29','14:25:00',3.71),('15128','2013-08-29','14:30:00',3.98),('15128','2013-08-29','14:35:00',3.84),('15128','2013-08-29','14:40:00',3.58),('15128','2013-08-29','14:45:00',3.33),('15128','2013-08-29','14:50:00',2.83),('15128','2013-08-29','14:55:00',3.47),('15128','2013-08-29','15:00:00',2.9),('15128','2013-08-29','15:05:00',3),('15128','2013-08-29','15:10:00',2.94),('15128','2013-08-29','15:15:00',3.06),('15128','2013-08-29','15:20:00',3.01),('15128','2013-08-29','15:25:00',2.86),('15128','2013-08-29','15:30:00',2.72),('15128','2013-08-29','15:35:00',2.71),('15128','2013-08-29','15:40:00',3.06),('15128','2013-08-29','15:45:00',2.8),('15128','2013-08-29','15:50:00',2.5),('15128','2013-08-29','15:55:00',2.32),('15128','2013-08-29','16:00:00',2.11),('15128','2013-08-29','16:05:00',2.12),('15128','2013-08-29','16:10:00',2.5),('15128','2013-08-29','16:15:00',2.45),('15128','2013-08-29','16:20:00',2.36),('15128','2013-08-29','16:25:00',2.19),('15128','2013-08-29','16:30:00',2.32),('15128','2013-08-29','16:35:00',2.47),('15128','2013-08-29','16:40:00',2.49),('15128','2013-08-29','16:45:00',2.59),('15128','2013-08-29','16:50:00',2.56),('15128','2013-08-29','16:55:00',2.11),('15128','2013-08-29','17:00:00',1.84),('15128','2013-08-29','17:05:00',1.22),('15128','2013-08-29','17:10:00',1.23),('15128','2013-08-29','17:15:00',1.99),('15128','2013-08-29','17:20:00',2.05),('15128','2013-08-29','17:25:00',1.71),('15128','2013-08-29','17:30:00',1.6),('15128','2013-08-29','17:35:00',1.47),('15128','2013-08-29','17:40:00',1.71),('15128','2013-08-29','17:45:00',1.84),('15128','2013-08-29','17:50:00',1.82),('15128','2013-08-29','17:55:00',1.55),('15128','2013-08-29','18:00:00',1.3),('15128','2014-04-10','08:40:00',1.02),('15128','2014-04-10','08:45:00',1.08),('15128','2013-08-28','08:40:00',1),('15128','2013-08-28','08:45:00',1.04),('15128','2013-08-28','08:50:00',1.13),('15128','2013-08-28','08:55:00',1.3),('15128','2013-08-28','09:00:00',1.28),('15128','2013-08-28','09:05:00',1.24),('15128','2013-08-28','09:10:00',1.29),('15128','2013-08-28','09:15:00',1.3),('15128','2013-08-28','09:20:00',1.4),('15128','2013-08-28','09:25:00',1.51),('15128','2013-08-28','09:30:00',1.54),('15128','2013-08-28','09:35:00',1.69),('15128','2013-08-28','09:40:00',1.57),('15128','2013-08-28','09:45:00',1.4),('15128','2013-08-28','09:50:00',1.41),('15128','2013-08-28','09:55:00',1.43),('15128','2013-08-28','10:00:00',1.47),('15128','2013-08-28','10:05:00',1.46),('15128','2013-08-28','10:10:00',1.43),('15128','2013-08-28','10:15:00',1.45),('15128','2013-08-28','10:20:00',1.5),('15128','2013-08-28','10:25:00',1.53),('15128','2013-08-28','10:30:00',1.52),('15128','2013-08-28','10:35:00',1.38),('15128','2013-08-28','10:40:00',1.29),('15128','2013-08-28','10:45:00',1.3),('15128','2013-08-28','10:50:00',1.44),('15128','2013-08-28','10:55:00',1.65),('15128','2013-08-28','11:00:00',1.64),('15128','2013-08-28','11:05:00',1.9),('15128','2013-08-28','11:10:00',2.09),('15128','2013-08-28','11:15:00',1.93),('15128','2013-08-28','11:20:00',1.6),('15128','2013-08-28','11:25:00',1.38),('15128','2013-08-28','11:30:00',1.36),('15128','2013-08-28','11:35:00',1.56),('15128','2013-08-28','11:40:00',1.77),('15128','2013-08-28','11:45:00',1.87),('15128','2013-08-28','11:50:00',1.93),('15128','2013-08-28','11:55:00',1.93),('15128','2013-08-28','12:00:00',2),('15128','2013-08-28','12:05:00',2.48),('15128','2013-08-28','12:10:00',3.48),('15128','2013-08-28','12:15:00',2.9),('15128','2013-08-28','12:20:00',3.05),('15128','2013-08-28','12:25:00',2.72),('15128','2013-08-28','12:30:00',2.42),('15128','2013-08-28','12:35:00',3.79),('15128','2013-08-28','12:40:00',4.52),('15128','2013-08-28','12:45:00',4.68),('15128','2013-08-28','12:50:00',2.96),('15128','2013-08-28','12:55:00',2.84),('15128','2013-08-28','13:00:00',2.95),('15128','2013-08-28','13:05:00',2.32),('15128','2013-08-28','13:10:00',2.23),('15128','2013-08-28','13:15:00',2.34),('15128','2013-08-28','13:20:00',2.21),('15128','2013-08-28','13:25:00',1.9),('15128','2013-08-28','13:30:00',1.82),('15128','2013-08-28','13:35:00',2.02),('15128','2013-08-28','13:40:00',1.82),('15128','2013-08-28','13:45:00',1.8),('15128','2013-08-28','13:50:00',2.39),('15128','2013-08-28','13:55:00',2.71),('15128','2013-08-28','14:00:00',2.1),('15128','2013-08-28','14:05:00',1.58),('15128','2013-08-28','14:10:00',1.4),('15128','2013-08-28','14:15:00',1.2),('15128','2013-08-28','14:20:00',1.15),('15128','2013-08-28','14:25:00',1.15),('15128','2013-08-28','14:30:00',1.18),('15128','2013-08-28','14:35:00',1.31),('15128','2013-08-28','14:40:00',1.45),('15128','2013-08-28','14:45:00',1.52),('15128','2013-08-28','14:50:00',1.62),('15128','2013-08-28','14:55:00',2.58),('15128','2013-08-28','15:00:00',2.65),('15128','2013-08-28','15:05:00',2.23),('15128','2013-08-28','15:10:00',1.42),('15128','2013-08-28','15:15:00',1.61),('15128','2013-08-28','15:20:00',2.16),('15128','2013-08-28','15:25:00',2.7),('15128','2013-08-28','15:30:00',2.52),('15128','2013-08-28','15:35:00',2.3),('15128','2013-08-28','15:40:00',2.14),('15128','2013-08-28','15:45:00',2.19),('15128','2013-08-28','15:50:00',2.5),('15128','2013-08-28','15:55:00',3.11),('15128','2013-08-28','16:00:00',4.3),('15128','2013-08-28','16:05:00',3.82),('15128','2013-08-28','16:10:00',3.48),('15128','2013-08-28','16:15:00',3.34),('15128','2013-08-28','16:20:00',3.11),('15128','2013-08-28','16:25:00',3.1),('15128','2013-08-28','16:30:00',3.21),('15128','2013-08-28','16:35:00',3.14),('15128','2013-08-28','16:40:00',3.07),('15128','2013-08-28','16:45:00',3),('15128','2013-08-28','16:50:00',2.94),('15128','2013-08-28','16:55:00',2.86),('15128','2013-08-28','17:00:00',2.8),('15128','2013-08-28','17:05:00',2.71),('15128','2013-08-28','17:10:00',2.59),('15128','2013-08-28','17:15:00',2.48),('15128','2013-08-28','17:20:00',2.31),('15128','2013-08-28','17:25:00',2.24),('15128','2013-08-28','17:30:00',2.11),('15128','2013-08-28','17:35:00',1.97),('15128','2013-08-28','17:40:00',1.94),('15128','2013-08-28','17:45:00',1.85),('15128','2013-08-28','17:50:00',1.8),('15128','2013-08-28','17:55:00',1.7),('15128','2013-08-28','18:00:00',1.67),('15128','2013-08-28','18:05:00',1.6),('15128','2013-08-28','18:10:00',1.52),('15128','2013-08-28','18:15:00',1.43),('15128','2013-08-28','18:20:00',1.32),('15128','2013-08-28','18:25:00',1.19),('15128','2013-08-28','18:30:00',1.1),('15128','2013-08-28','18:35:00',1.01),('15128','2013-08-27','08:50:00',1.18),('15128','2013-08-27','08:55:00',1.23),('15128','2013-08-27','09:00:00',1.3),('15128','2013-08-27','09:05:00',1.38),('15128','2013-08-27','09:10:00',1.23),('15128','2013-08-27','09:20:00',1.17),('15128','2013-08-27','09:30:00',1.46),('15128','2013-08-27','09:35:00',2.23),('15128','2013-08-27','09:40:00',1.92),('15128','2013-08-27','09:45:00',2.08),('15128','2013-08-27','09:50:00',1.98),('15128','2013-08-27','09:55:00',1.95),('15128','2013-08-27','10:00:00',2.03),('15128','2013-08-27','10:05:00',2.09),('15128','2013-08-27','10:10:00',2.17),('15128','2013-08-27','10:15:00',2.26),('15128','2013-08-27','10:20:00',2.33),('15128','2013-08-27','10:25:00',2.36),('15128','2013-08-27','10:30:00',2.49),('15128','2013-08-27','10:35:00',2.43),('15128','2013-08-27','10:40:00',2.22),('15128','2013-08-27','10:45:00',2.37),('15128','2013-08-27','10:50:00',2.98),('15128','2013-08-27','10:55:00',2.9),('15128','2013-08-27','11:00:00',2.96),('15128','2013-08-27','11:05:00',3.05),('15128','2013-08-27','11:10:00',2.95),('15128','2013-08-27','11:15:00',2.83),('15128','2013-08-27','11:20:00',2.58),('15128','2013-08-27','11:25:00',2.81),('15128','2013-08-27','11:30:00',1.16),('15128','2013-08-27','11:35:00',1.28),('15128','2013-08-27','11:40:00',2.3),('15128','2013-08-27','11:45:00',2.32),('15128','2013-08-27','11:50:00',2.3),('15128','2013-08-27','11:55:00',4.34),('15128','2013-08-27','12:00:00',4.19),('15128','2013-08-27','12:05:00',3.6),('15128','2013-08-27','12:10:00',4.04),('15128','2013-08-27','12:15:00',4.07),('15128','2013-08-27','12:20:00',3.43),('15128','2013-08-27','12:25:00',3.33),('15128','2013-08-27','12:30:00',3.92),('15128','2013-08-27','12:35:00',4.23),('15128','2013-08-27','12:40:00',3.68),('15128','2013-08-27','12:45:00',4.14),('15128','2013-08-27','12:50:00',3.57),('15128','2013-08-27','12:55:00',4.03),('15128','2013-08-27','13:00:00',4.24),('15128','2013-08-27','13:05:00',4.22),('15128','2013-08-27','13:10:00',4.19),('15128','2013-08-27','13:15:00',4.2),('15128','2013-08-27','13:20:00',4.08),('15128','2013-08-27','13:25:00',4.21),('15128','2013-08-27','13:30:00',4.28),('15128','2013-08-27','13:35:00',4.32),('15128','2013-08-27','13:40:00',4.4),('15128','2013-08-27','13:45:00',4.33),('15128','2013-08-27','13:50:00',4.45),('15128','2013-08-27','13:55:00',4.28),('15128','2013-08-27','14:00:00',4.32),('15128','2013-08-27','14:05:00',4.24),('15128','2013-08-27','14:10:00',4.26),('15128','2013-08-27','14:15:00',4.25),('15128','2013-08-27','14:20:00',4.27),('15128','2013-08-27','14:25:00',4.28),('15128','2013-08-27','14:30:00',4.26),('15128','2013-08-27','14:35:00',4.23),('15128','2013-08-27','14:40:00',4.19),('15128','2013-08-27','14:45:00',4),('15128','2013-08-27','14:50:00',4.19),('15128','2013-08-27','14:55:00',4.06),('15128','2013-08-27','15:00:00',4.23),('15128','2013-08-27','15:05:00',4.08),('15128','2013-08-27','15:10:00',4.02),('15128','2013-08-27','15:15:00',3.93),('15128','2013-08-27','15:20:00',3.7),('15128','2013-08-27','15:25:00',3.4),('15128','2013-08-27','15:30:00',2.72),('15128','2013-08-27','15:35:00',3.08),('15128','2013-08-27','15:40:00',4.04),('15128','2013-08-27','15:45:00',3.56),('15128','2013-08-27','15:50:00',3.83),('15128','2013-08-27','15:55:00',3.74),('15128','2013-08-27','16:00:00',3.69),('15128','2013-08-27','16:05:00',3.62),('15128','2013-08-27','16:10:00',3.57),('15128','2013-08-27','16:15:00',3.53),('15128','2013-08-27','16:20:00',3.49),('15128','2013-08-27','16:25:00',3.42),('15128','2013-08-27','16:30:00',3.35),('15128','2013-08-27','16:35:00',3.27),('15128','2013-08-27','16:40:00',3.18),('15128','2013-08-27','16:45:00',3.1),('15128','2013-08-27','16:50:00',3.09),('15128','2013-08-27','16:55:00',2.98),('15128','2013-08-27','17:00:00',2.91),('15128','2013-08-27','17:05:00',1.44),('15128','2013-08-27','17:10:00',1.6),('15128','2013-08-27','17:15:00',2.82),('15128','2013-08-27','17:20:00',2.5),('15128','2013-08-27','17:25:00',2.2),('15128','2013-08-27','17:35:00',1.62),('15128','2013-08-27','17:40:00',1.47),('15128','2013-08-27','17:50:00',1.51),('15128','2013-08-27','17:55:00',1.8),('15128','2013-08-27','18:00:00',1.35),('15128','2013-08-27','18:05:00',1.2),('15128','2013-08-27','18:10:00',1.3),('15128','2013-08-27','18:15:00',1.19),('15128','2013-08-27','18:20:00',1.31),('15128','2013-08-27','18:35:00',1.11),('15128','2013-08-27','18:40:00',1.22),('15128','2013-08-26','09:10:00',1.32),('15128','2013-08-26','09:15:00',1.28),('15128','2013-08-26','09:20:00',1.4),('15128','2013-08-26','09:25:00',1.61),('15128','2013-08-26','09:30:00',1.74),('15128','2013-08-26','09:35:00',1.4),('15128','2013-08-26','09:40:00',1.04),('15128','2013-08-26','09:45:00',1.16),('15128','2013-08-26','09:50:00',1.44),('15128','2013-08-26','09:55:00',1.25),('15128','2013-08-26','10:00:00',1.57),('15128','2013-08-26','10:05:00',1.97),('15128','2013-08-26','10:10:00',2.22),('15128','2013-08-26','10:15:00',2.26),('15128','2013-08-26','10:20:00',2.24),('15128','2013-08-26','10:25:00',2.31),('15128','2013-08-26','10:30:00',2.31),('15128','2013-08-26','10:35:00',2.4),('15128','2013-08-26','10:40:00',2.38),('15128','2013-08-26','10:45:00',2.59),('15128','2013-08-26','10:50:00',2.68),('15128','2013-08-26','10:55:00',2.64),('15128','2013-08-26','11:00:00',2.69),('15128','2013-08-26','11:05:00',2.82),('15128','2013-08-26','11:10:00',2.74),('15128','2013-08-26','11:15:00',2.91),('15128','2013-08-26','11:20:00',3.04),('15128','2013-08-26','11:25:00',2.51),('15128','2013-08-26','11:30:00',3.12),('15128','2013-08-26','11:35:00',3.14),('15128','2013-08-26','11:40:00',3.28),('15128','2013-08-26','11:55:00',3.45),('15128','2013-08-26','12:00:00',1.69),('15128','2013-08-26','12:05:00',2.51),('15128','2013-08-26','12:10:00',2.62),('15128','2013-08-26','12:15:00',2.9),('15128','2013-08-26','12:20:00',3.91),('15128','2013-08-26','12:25:00',4.09),('15128','2013-08-26','12:30:00',3.59),('15128','2013-08-26','12:35:00',1.98),('15128','2013-08-26','12:40:00',3.72),('15128','2013-08-26','12:45:00',3.16),('15128','2013-08-26','12:50:00',3.04),('15128','2013-08-26','12:55:00',1.56),('15128','2013-08-26','13:00:00',1.67),('15128','2013-08-26','13:05:00',1.96),('15128','2013-08-26','13:10:00',2.52),('15128','2013-08-26','13:15:00',1.99),('15128','2013-08-26','13:20:00',2.83),('15128','2013-08-26','13:25:00',2.93),('15128','2013-08-26','13:30:00',2.23),('15128','2013-08-26','13:35:00',2.26),('15128','2013-08-26','13:40:00',2.23),('15128','2013-08-26','13:45:00',3.14),('15128','2013-08-26','13:50:00',3.14),('15128','2013-08-26','13:55:00',2.78),('15128','2013-08-26','14:00:00',2.29),('15128','2013-08-26','14:05:00',3.16),('15128','2013-08-26','14:10:00',3.92),('15128','2013-08-26','14:15:00',3.32),('15128','2013-08-26','14:20:00',2.55),('15128','2013-08-26','14:25:00',1.66),('15128','2013-08-26','14:30:00',1.52),('15128','2013-08-26','14:35:00',1.51),('15128','2013-08-26','14:40:00',1.45),('15128','2013-08-26','14:45:00',1.22),('15128','2013-08-26','14:50:00',1.03),('15128','2013-08-26','15:00:00',1.03),('15128','2013-08-26','15:05:00',1.06),('15128','2013-08-26','15:50:00',1.71),('15128','2013-08-26','15:55:00',2.23),('15128','2013-08-26','16:00:00',1.07),('15128','2013-08-26','16:05:00',2.04),('15128','2013-08-26','16:10:00',2.25),('15128','2013-08-26','16:15:00',1.33),('15128','2013-08-26','16:30:00',1.27),('15128','2013-08-26','16:40:00',1.61),('15128','2013-08-26','16:45:00',1.5),('15128','2013-08-26','16:50:00',1.89),('15128','2013-08-26','16:55:00',2.44),('15128','2013-08-26','17:00:00',2.04),('15128','2013-08-26','17:05:00',1.97),('15128','2013-08-26','17:35:00',1.29),('15128','2013-08-25','08:40:00',1.04),('15128','2013-08-25','08:45:00',1.04),('15128','2013-08-25','08:50:00',1.1),('15128','2013-08-25','08:55:00',1.21),('15128','2013-08-25','09:00:00',1.3),('15128','2013-08-25','09:05:00',1.36),('15128','2013-08-25','09:10:00',1.42),('15128','2013-08-25','09:15:00',1.48),('15128','2013-08-25','09:20:00',1.52),('15128','2013-08-25','09:25:00',1.58),('15128','2013-08-25','09:30:00',1.66),('15128','2013-08-25','09:35:00',1.73),('15128','2013-08-25','09:40:00',1.81),('15128','2013-08-25','09:45:00',1.88),('15128','2013-08-25','09:50:00',1.9),('15128','2013-08-25','09:55:00',1.98),('15128','2013-08-25','10:00:00',2.04),('15128','2013-08-25','10:05:00',2.11),('15128','2013-08-25','10:10:00',2.18),('15128','2013-08-25','10:15:00',2.23),('15128','2013-08-25','10:20:00',2.3),('15128','2013-08-25','10:25:00',2.22),('15128','2013-08-25','10:30:00',2.45),('15128','2013-08-25','10:35:00',2.49),('15128','2013-08-25','10:40:00',2.55),('15128','2013-08-25','10:45:00',2.61),('15128','2013-08-25','10:50:00',2.65),('15128','2013-08-25','10:55:00',2.68),('15128','2013-08-25','11:00:00',2.76),('15128','2013-08-25','11:05:00',2.76),('15128','2013-08-25','11:10:00',2.82),('15128','2013-08-25','11:15:00',2.87),('15128','2013-08-25','11:20:00',2.99),('15128','2013-08-25','11:25:00',2.97),('15128','2013-08-25','11:30:00',3.1),('15128','2013-08-25','11:35:00',3.08),('15128','2013-08-25','11:40:00',3.19),('15128','2013-08-25','11:45:00',3.24),('15128','2013-08-25','11:50:00',3.3),('15128','2013-08-25','11:55:00',3.5),('15128','2013-08-25','12:00:00',3.59),('15128','2013-08-25','12:05:00',3.62),('15128','2013-08-25','12:10:00',3.64),('15128','2013-08-25','12:15:00',3.65),('15128','2013-08-25','12:20:00',3.68),('15128','2013-08-25','12:25:00',3.74),('15128','2013-08-25','12:30:00',3.84),('15128','2013-08-25','12:35:00',3.65),('15128','2013-08-25','12:40:00',3.28),('15128','2013-08-25','12:45:00',3.56),('15128','2013-08-25','12:50:00',3.84),('15128','2013-08-25','12:55:00',4.44),('15128','2013-08-25','13:00:00',2.89),('15128','2013-08-25','13:05:00',2.69),('15128','2013-08-25','13:10:00',3.51),('15128','2013-08-25','13:15:00',2.39),('15128','2013-08-25','13:20:00',3.86),('15128','2013-08-25','13:25:00',2.6),('15128','2013-08-25','13:30:00',2.71),('15128','2013-08-25','13:35:00',3.57),('15128','2013-08-25','13:40:00',4.12),('15128','2013-08-25','13:45:00',4.11),('15128','2013-08-25','13:50:00',3.4),('15128','2013-08-25','13:55:00',3.15),('15128','2013-08-25','14:00:00',3.55),('15128','2013-08-25','14:05:00',3.61),('15128','2013-08-25','14:10:00',3.67),('15128','2013-08-25','14:15:00',3.87),('15128','2013-08-25','14:20:00',3.88),('15128','2013-08-25','14:25:00',3.93),('15128','2013-08-25','14:30:00',3.98),('15128','2013-08-25','14:35:00',3.98),('15128','2013-08-25','14:40:00',3.96),('15128','2013-08-25','14:45:00',3.1),('15128','2013-08-25','14:50:00',3.21),('15128','2013-08-25','14:55:00',2.12),('15128','2013-08-25','15:00:00',2.15),('15128','2013-08-25','15:05:00',1.25),('15128','2013-08-25','15:10:00',1.13),('15128','2013-08-25','15:30:00',1.07),('15128','2013-08-25','15:35:00',1.26),('15128','2013-08-25','15:40:00',2.31),('15128','2013-08-25','15:45:00',1.48),('15128','2013-08-25','15:50:00',1.5),('15128','2013-08-25','15:55:00',2.1),('15128','2013-08-25','16:00:00',2.92),('15128','2013-08-25','16:05:00',3.8),('15128','2013-08-25','16:10:00',3.41),('15128','2013-08-25','16:15:00',3.25),('15128','2013-08-25','16:20:00',3.19),('15128','2013-08-25','16:25:00',3.1),('15128','2013-08-25','16:30:00',3.05),('15128','2013-08-25','16:35:00',3.01),('15128','2013-08-25','16:40:00',2.9),('15128','2013-08-25','16:45:00',2.79),('15128','2013-08-25','16:50:00',2.76),('15128','2013-08-25','16:55:00',2.68),('15128','2013-08-25','17:00:00',2.43),('15128','2013-08-25','17:05:00',2.49),('15128','2013-08-25','17:10:00',2.44),('15128','2013-08-25','17:15:00',2.33),('15128','2013-08-25','17:20:00',1.68),('15128','2013-08-25','17:25:00',1.51),('15128','2013-08-25','17:30:00',1.47),('15128','2013-08-25','17:35:00',1.09),('15128','2013-08-25','17:40:00',1.09),('15128','2013-08-25','17:45:00',1.9),('15128','2013-08-25','17:50:00',1.89),('15128','2013-08-25','17:55:00',1.67),('15128','2013-08-25','18:00:00',1.48),('15128','2013-08-25','18:05:00',1.39),('15128','2013-08-25','18:10:00',1.3),('15128','2013-08-25','18:15:00',1.2),('15128','2013-08-25','18:20:00',1.12),('15128','2013-08-25','18:25:00',1.02),('15128','2013-08-24','08:35:00',1.07),('15128','2013-08-24','08:40:00',1.31),('15128','2013-08-24','09:05:00',1.43),('15128','2013-08-24','09:10:00',1.44),('15128','2013-08-24','09:15:00',1.61),('15128','2013-08-24','09:20:00',1.76),('15128','2013-08-24','09:25:00',1.75),('15128','2013-08-24','09:30:00',1.65),('15128','2013-08-24','09:35:00',2.17),('15128','2013-08-24','09:40:00',2.45),('15128','2013-08-24','09:45:00',2.49),('15128','2013-08-24','09:50:00',2.65),('15128','2013-08-24','09:55:00',1.88),('15128','2013-08-24','10:00:00',1.2),('15128','2013-08-23','08:45:00',1.03),('15128','2013-08-23','08:50:00',1.09),('15128','2013-08-23','08:55:00',1.15),('15128','2013-08-23','09:00:00',1.24),('15128','2013-08-23','09:05:00',1.3),('15128','2013-08-23','09:10:00',1.36),('15128','2013-08-23','09:15:00',1.4),('15128','2013-08-23','09:20:00',1.44),('15128','2013-08-23','09:25:00',1.5),('15128','2013-08-23','09:30:00',1.6),('15128','2013-08-23','09:35:00',1.67),('15128','2013-08-23','09:40:00',1.76),('15128','2013-08-23','09:45:00',1.81),('15128','2013-08-23','09:50:00',1.85),('15128','2013-08-23','09:55:00',1.91),('15128','2013-08-23','10:00:00',1.94),('15128','2013-08-23','10:05:00',2.03),('15128','2013-08-23','10:10:00',2.1),('15128','2013-08-23','10:15:00',2.1),('15128','2013-08-23','10:20:00',2.13),('15128','2013-08-23','10:25:00',2.18),('15128','2013-08-23','10:30:00',2.36),('15128','2013-08-23','10:35:00',2.37),('15128','2013-08-23','10:40:00',2.44),('15128','2013-08-23','10:45:00',2.48),('15128','2013-08-23','10:50:00',2.5),('15128','2013-08-23','10:55:00',2.36),('15128','2013-08-23','11:00:00',2.67),('15128','2013-08-23','11:05:00',2.65),('15128','2013-08-23','11:10:00',2.6),('15128','2013-08-23','11:15:00',2.64),('15128','2013-08-23','11:20:00',2.57),('15128','2013-08-23','11:25:00',2.66),('15128','2013-08-23','11:30:00',3.07),('15128','2013-08-23','11:35:00',3.12),('15128','2013-08-23','11:40:00',3.27),('15128','2013-08-23','11:45:00',3.31),('15128','2013-08-23','11:50:00',3.39),('15128','2013-08-23','11:55:00',3.42),('15128','2013-08-23','12:00:00',3.53),('15128','2013-08-23','12:05:00',3.6),('15128','2013-08-23','12:10:00',3.62),('15128','2013-08-23','12:15:00',3.66),('15128','2013-08-23','12:20:00',3.66),('15128','2013-08-23','12:25:00',3.73),('15128','2013-08-23','12:30:00',3.73),('15128','2013-08-23','12:35:00',3.76),('15128','2013-08-23','12:40:00',3.82),('15128','2013-08-23','12:45:00',3.84),('15128','2013-08-23','12:50:00',3.87),('15128','2013-08-23','12:55:00',3.86),('15128','2013-08-23','13:00:00',3.87),('15128','2013-08-23','13:05:00',3.88),('15128','2013-08-23','13:10:00',3.93),('15128','2013-08-23','13:15:00',3.94),('15128','2013-08-23','13:20:00',3.93),('15128','2013-08-23','13:25:00',3.92),('15128','2013-08-23','13:30:00',3.93),('15128','2013-08-23','13:35:00',3.95),('15128','2013-08-23','13:40:00',3.97),('15128','2013-08-23','13:45:00',3.98),('15128','2013-08-23','13:50:00',3.99),('15128','2013-08-23','13:55:00',3.97),('15128','2013-08-23','14:00:00',3.96),('15128','2013-08-23','14:05:00',3.96),('15128','2013-08-23','14:10:00',3.98),('15128','2013-08-23','14:15:00',3.96),('15128','2013-08-23','14:20:00',3.94),('15128','2013-08-23','14:25:00',3.94),('15128','2013-08-23','14:30:00',3.93),('15128','2013-08-23','14:35:00',3.9),('15128','2013-08-23','14:40:00',3.9),('15128','2013-08-23','14:45:00',3.88),('15128','2013-08-23','14:50:00',3.85),('15128','2013-08-23','14:55:00',3.84),('15128','2013-08-23','15:00:00',3.81),('15128','2013-08-23','15:05:00',3.8),('15128','2013-08-23','15:10:00',3.78),('15128','2013-08-23','15:15:00',3.76),('15128','2013-08-23','15:20:00',3.71),('15128','2013-08-23','15:25:00',3.65),('15128','2013-08-23','15:30:00',3.63),('15128','2013-08-23','15:35:00',3.57),('15128','2013-08-23','15:40:00',3.55),('15128','2013-08-23','15:45:00',3.5),('15128','2013-08-23','15:50:00',3.47),('15128','2013-08-23','15:55:00',3.44),('15128','2013-08-23','16:00:00',3.39),('15128','2013-08-23','16:05:00',3.35),('15128','2013-08-23','16:10:00',3.28),('15128','2013-08-23','16:15:00',3.27),('15128','2013-08-23','16:20:00',3.22),('15128','2013-08-23','16:25:00',3.14),('15128','2013-08-23','16:30:00',3.09),('15128','2013-08-23','16:35:00',3.03),('15128','2013-08-23','16:40:00',2.99),('15128','2013-08-23','16:45:00',2.93),('15128','2013-08-23','16:50:00',2.87),('15128','2013-08-23','16:55:00',2.8),('15128','2013-08-23','17:00:00',2.74),('15128','2013-08-23','17:05:00',2.66),('15128','2013-08-23','17:10:00',2.59),('15128','2013-08-23','17:15:00',2.52),('15128','2013-08-23','17:20:00',2.43),('15128','2013-08-23','17:25:00',2.33),('15128','2013-08-23','17:30:00',2.21),('15128','2013-08-23','17:35:00',2.12),('15128','2013-08-23','17:40:00',2.02),('15128','2013-08-23','17:45:00',1.91),('15128','2013-08-23','17:50:00',1.78),('15128','2013-08-23','17:55:00',1.71),('15128','2013-08-23','18:00:00',1.65),('15128','2013-08-23','18:05:00',1.59),('15128','2013-08-23','18:10:00',1.54),('15128','2013-08-23','18:15:00',1.46),('15128','2013-08-23','18:20:00',1.38),('15128','2013-08-23','18:25:00',1.29),('15128','2013-08-23','18:30:00',1.17),('15128','2013-08-23','18:35:00',1.07),('15128','2013-08-22','08:45:00',1.07),('15128','2013-08-22','08:50:00',1.17),('15128','2013-08-22','08:55:00',1.17),('15128','2013-08-22','09:00:00',1.2),('15128','2013-08-22','09:05:00',1.26),('15128','2013-08-22','09:10:00',1.33),('15128','2013-08-22','09:15:00',1.4),('15128','2013-08-22','09:20:00',1.46),('15128','2013-08-22','09:25:00',1.48),('15128','2013-08-22','09:30:00',1.57),('15128','2013-08-22','09:35:00',1.63),('15128','2013-08-22','09:40:00',1.67),('15128','2013-08-22','09:45:00',1.75),('15128','2013-08-22','09:50:00',1.81),('15128','2013-08-22','09:55:00',1.85),('15128','2013-08-22','10:00:00',1.89),('15128','2013-08-22','10:05:00',1.96),('15128','2013-08-22','10:10:00',2.02),('15128','2013-08-22','10:15:00',2.09),('15128','2013-08-22','10:20:00',2.13),('15128','2013-08-22','10:25:00',2.2),('15128','2013-08-22','10:30:00',2.27),('15128','2013-08-22','10:35:00',2.3),('15128','2013-08-22','10:50:00',2.33),('15128','2013-08-22','10:55:00',2.47),('15128','2013-08-22','11:00:00',2.65),('15128','2013-08-22','11:05:00',2.52),('15128','2013-08-22','11:10:00',2.3),('15128','2013-08-22','11:15:00',2.31),('15128','2013-08-22','11:20:00',1.21),('15128','2013-08-22','11:25:00',1.14),('15128','2013-08-22','11:30:00',2.04),('15128','2013-08-22','11:35:00',3.2),('15128','2013-08-22','11:40:00',3.1),('15128','2013-08-22','11:45:00',3.49),('15128','2013-08-22','11:50:00',2.43),('15128','2013-08-22','11:55:00',3.44),('15128','2013-08-22','12:00:00',1.55),('15128','2013-08-22','12:05:00',1.53),('15128','2013-08-22','12:10:00',2.36),('15128','2013-08-22','12:15:00',3.44),('15128','2013-08-22','12:20:00',1.12),('15128','2013-08-22','12:25:00',1.27),('15128','2013-08-22','12:30:00',1.03),('15128','2013-08-22','12:35:00',2.78),('15128','2013-08-22','12:40:00',2.7),('15128','2013-08-22','12:45:00',3.16),('15128','2013-08-22','12:50:00',3.93),('15128','2013-08-22','12:55:00',3.9),('15128','2013-08-22','13:00:00',3.89),('15128','2013-08-22','13:05:00',3.88),('15128','2013-08-22','13:10:00',3.89),('15128','2013-08-22','13:15:00',3.9),('15128','2013-08-22','13:20:00',3.94),('15128','2013-08-22','13:25:00',3.93),('15128','2013-08-22','13:30:00',3.92),('15128','2013-08-22','13:35:00',3.94),('15128','2013-08-22','13:40:00',3.94),('15128','2013-08-22','13:45:00',3.95),('15128','2013-08-22','13:50:00',3.95),('15128','2013-08-22','13:55:00',3.94),('15128','2013-08-22','14:00:00',3.96),('15128','2013-08-22','14:05:00',3.98),('15128','2013-08-22','14:10:00',3.98),('15128','2013-08-22','14:15:00',3.98),('15128','2013-08-22','14:20:00',3.96),('15128','2013-08-22','14:25:00',3.96),('15128','2013-08-22','14:30:00',3.94),('15128','2013-08-22','14:35:00',3.92),('15128','2013-08-22','14:40:00',3.9),('15128','2013-08-22','14:45:00',3.89),('15128','2013-08-22','14:50:00',3.84),('15128','2013-08-22','14:55:00',3.7),('15128','2013-08-22','15:00:00',3.78),('15128','2013-08-22','15:05:00',3.79),('15128','2013-08-22','15:10:00',3.4),('15128','2013-08-22','15:15:00',3.07),('15128','2013-08-22','15:20:00',3.18),('15128','2013-08-22','15:25:00',3.5),('15128','2013-08-22','15:30:00',3.56),('15128','2013-08-22','15:35:00',3.67),('15128','2013-08-22','15:40:00',3.32),('15128','2013-08-22','15:45:00',3.33),('15128','2013-08-22','15:50:00',3.1),('15128','2013-08-22','15:55:00',3.03),('15128','2013-08-22','16:00:00',3.11),('15128','2013-08-22','16:05:00',3.02),('15128','2013-08-22','16:10:00',2.89),('15128','2013-08-22','16:15:00',2.95),('15128','2013-08-22','16:20:00',2.98),('15128','2013-08-22','16:25:00',2.9),('15128','2013-08-22','16:30:00',2.86),('15128','2013-08-22','16:35:00',2.92),('15128','2013-08-22','16:40:00',3.12),('15128','2013-08-22','16:45:00',3.02),('15128','2013-08-22','16:50:00',2.88),('15128','2013-08-22','16:55:00',2.85),('15128','2013-08-22','17:00:00',2.71),('15128','2013-08-22','17:05:00',2.61),('15128','2013-08-22','17:10:00',2.51),('15128','2013-08-22','17:15:00',2.45),('15128','2013-08-22','17:20:00',2.39),('15128','2013-08-22','17:25:00',2.3),('15128','2013-08-22','17:30:00',2.19),('15128','2013-08-22','17:35:00',2.06),('15128','2013-08-22','17:40:00',1.97),('15128','2013-08-22','17:45:00',1.9),('15128','2013-08-22','17:50:00',1.78),('15128','2013-08-22','17:55:00',1.14),('15128','2013-08-22','18:00:00',1.04),('15128','2013-08-22','18:05:00',1.48),('15128','2013-08-22','18:10:00',1.46),('15128','2013-08-22','18:15:00',1.42),('15128','2013-08-22','18:20:00',1.4),('15128','2013-08-22','18:25:00',1.32),('15128','2013-08-22','18:30:00',1.2),('15128','2013-08-22','18:35:00',1.1),('15128','2013-08-21','08:40:00',1.01),('15128','2013-08-21','08:45:00',1.1),('15128','2013-08-21','08:50:00',1.16),('15128','2013-08-21','08:55:00',1.26),('15128','2013-08-21','09:00:00',1.28),('15128','2013-08-21','09:05:00',1.39),('15128','2013-08-21','09:10:00',1.43),('15128','2013-08-21','09:15:00',1.28),('15128','2013-08-21','09:20:00',1.53),('15128','2013-08-21','09:25:00',1.66),('15128','2013-08-21','09:30:00',1.72),('15128','2013-08-21','09:35:00',1.73),('15128','2013-08-21','09:40:00',1.8),('15128','2013-08-21','09:45:00',1.84),('15128','2013-08-21','09:50:00',1.99),('15128','2013-08-21','09:55:00',1.92),('15128','2013-08-21','10:00:00',1.84),('15128','2013-08-21','10:05:00',2.04),('15128','2013-08-21','10:10:00',2.4),('15128','2013-08-21','10:15:00',2.38),('15128','2013-08-21','10:20:00',2.39),('15128','2013-08-21','10:25:00',1.93),('15128','2013-08-21','10:30:00',1.89),('15128','2013-08-21','10:35:00',2.15),('15128','2013-08-21','10:40:00',2.54),('15128','2013-08-21','10:45:00',2.58),('15128','2013-08-21','10:50:00',2.59),('15128','2013-08-21','10:55:00',2.63),('15128','2013-08-21','11:00:00',2.69),('15128','2013-08-21','11:05:00',2.73),('15128','2013-08-21','11:10:00',2.8),('15128','2013-08-21','11:15:00',2.86),('15128','2013-08-21','11:20:00',2.95),('15128','2013-08-21','11:25:00',2.98),('15128','2013-08-21','11:30:00',3.04),('15128','2013-08-21','11:35:00',3.07),('15128','2013-08-21','11:40:00',3.13),('15128','2013-08-21','11:45:00',3.17),('15128','2013-08-21','11:50:00',3.27),('15128','2013-08-21','11:55:00',3.32),('15128','2013-08-21','12:00:00',3.42),('15128','2013-08-21','12:05:00',3.47),('15128','2013-08-21','12:10:00',3.5),('15128','2013-08-21','12:15:00',3.55),('15128','2013-08-21','12:20:00',3.58),('15128','2013-08-21','12:25:00',3.61),('15128','2013-08-21','12:30:00',3.63),('15128','2013-08-21','12:35:00',3.63),('15128','2013-08-21','12:40:00',3.64),('15128','2013-08-21','12:45:00',3.65),('15128','2013-08-21','12:50:00',3.68),('15128','2013-08-21','12:55:00',3.68),('15128','2013-08-21','13:00:00',3.7),('15128','2013-08-21','13:05:00',3.7),('15128','2013-08-21','13:10:00',3.72),('15128','2013-08-21','13:15:00',3.72),('15128','2013-08-21','13:20:00',3.75),('15128','2013-08-21','13:25:00',3.8),('15128','2013-08-21','13:30:00',3.75),('15128','2013-08-21','13:35:00',3.79),('15128','2013-08-21','13:40:00',3.48),('15128','2013-08-21','13:45:00',3.68),('15128','2013-08-21','13:50:00',3.84),('15128','2013-08-21','13:55:00',3.84),('15128','2013-08-21','14:00:00',3.81),('15128','2013-08-21','14:05:00',3.79),('15128','2013-08-21','14:10:00',3.83),('15128','2013-08-21','14:15:00',2.75),('15128','2013-08-21','14:20:00',2.14),('15128','2013-08-21','14:25:00',3.92),('15128','2013-08-21','14:30:00',3.86),('15128','2013-08-21','14:35:00',3.76),('15128','2013-08-21','14:40:00',3.73),('15128','2013-08-21','14:45:00',3.72),('15128','2013-08-21','14:50:00',3.55),('15128','2013-08-21','14:55:00',3.54),('15128','2013-08-21','15:00:00',3.58),('15128','2013-08-21','15:05:00',3.56),('15128','2013-08-21','15:10:00',3.64),('15128','2013-08-21','15:15:00',3.58),('15128','2013-08-21','15:20:00',3.57),('15128','2013-08-21','15:25:00',3.57),('15128','2013-08-21','15:30:00',3.55),('15128','2013-08-21','15:35:00',3.5),('15128','2013-08-21','15:40:00',3.46),('15128','2013-08-21','15:45:00',3.44),('15128','2013-08-21','15:50:00',3.39),('15128','2013-08-21','15:55:00',3.37),('15128','2013-08-21','16:00:00',3.31),('15128','2013-08-21','16:05:00',3.24),('15128','2013-08-21','16:10:00',3.19),('15128','2013-08-21','16:15:00',3.11),('15128','2013-08-21','16:20:00',3.08),('15128','2013-08-21','16:25:00',3.05),('15128','2013-08-21','16:30:00',2.97),('15128','2013-08-21','16:35:00',2.9),('15128','2013-08-21','16:40:00',2.81),('15128','2013-08-21','16:45:00',2.73),('15128','2013-08-21','16:50:00',2.61),('15128','2013-08-21','16:55:00',2.61),('15128','2013-08-21','17:00:00',2.55),('15128','2013-08-21','17:05:00',2.49),('15128','2013-08-21','17:10:00',2.41),('15128','2013-08-21','17:15:00',2.32),('15128','2013-08-21','17:20:00',2.25),('15128','2013-08-21','17:25:00',2.12),('15128','2013-08-21','17:30:00',2.03),('15128','2013-08-21','17:35:00',1.96),('15128','2013-08-21','17:40:00',1.84),('15128','2013-08-21','17:45:00',1.75),('15128','2013-08-21','17:50:00',1.66),('15128','2013-08-21','17:55:00',1.59),('15128','2013-08-21','18:00:00',1.5),('15128','2013-08-21','18:05:00',1.45),('15128','2013-08-21','18:10:00',1.42),('15128','2013-08-21','18:15:00',1.36),('15128','2013-08-21','18:20:00',1.25),('15128','2013-08-21','18:25:00',1.11),('15128','2013-08-20','09:15:00',1.18),('15128','2013-08-20','09:20:00',1.27),('15128','2013-08-20','09:25:00',1.96),('15128','2013-08-20','09:30:00',1.53),('15128','2013-08-20','09:55:00',1.02),('15128','2013-08-20','10:00:00',1.27),('15128','2013-08-20','10:05:00',2.14),('15128','2013-08-20','10:10:00',2.27),('15128','2013-08-20','10:15:00',2.25),('15128','2013-08-20','10:20:00',2.15),('15128','2013-08-20','10:25:00',2.37),('15128','2013-08-20','10:30:00',2.39),('15128','2013-08-20','10:35:00',2.45),('15128','2013-08-20','10:40:00',2.44),('15128','2013-08-20','10:45:00',2.72),('15128','2013-08-20','10:50:00',2.64),('15128','2013-08-20','10:55:00',2.78),('15128','2013-08-20','11:00:00',2.94),('15128','2013-08-20','11:05:00',2.34),('15128','2013-08-20','11:10:00',2.82),('15128','2013-08-20','11:15:00',1.78),('15128','2013-08-20','11:20:00',1.57),('15128','2013-08-20','11:25:00',1.89),('15128','2013-08-20','11:30:00',3.68),('15128','2013-08-20','11:35:00',3.14),('15128','2013-08-20','11:40:00',3.48),('15128','2013-08-20','11:45:00',3.65),('15128','2013-08-20','11:50:00',3.6),('15128','2013-08-20','11:55:00',3.63),('15128','2013-08-20','12:00:00',3.59),('15128','2013-08-20','12:05:00',3.69),('15128','2013-08-20','12:10:00',3.8),('15128','2013-08-20','12:15:00',3.82),('15128','2013-08-20','12:20:00',3.71),('15128','2013-08-20','12:25:00',3.76),('15128','2013-08-20','12:30:00',3.88),('15128','2013-08-20','12:35:00',3.75),('15128','2013-08-20','12:40:00',3.6),('15128','2013-08-20','12:45:00',3.55),('15128','2013-08-20','12:50:00',3.66),('15128','2013-08-20','12:55:00',3.67),('15128','2013-08-20','13:00:00',3.51),('15128','2013-08-20','13:05:00',3.64),('15128','2013-08-20','13:10:00',3.75),('15128','2013-08-20','13:15:00',3.85),('15128','2013-08-20','13:20:00',3.86),('15128','2013-08-20','13:25:00',3.74),('15128','2013-08-20','13:30:00',3.79),('15128','2013-08-20','13:35:00',3.87),('15128','2013-08-20','13:40:00',3.88),('15128','2013-08-20','13:45:00',3.91),('15128','2013-08-20','13:50:00',3.93),('15128','2013-08-20','13:55:00',4),('15128','2013-08-20','14:00:00',4.03),('15128','2013-08-20','14:05:00',3.95),('15128','2013-08-20','14:10:00',3.99),('15128','2013-08-20','14:15:00',3.88),('15128','2013-08-20','14:20:00',3.8),('15128','2013-08-20','14:25:00',3.67),('15128','2013-08-20','14:30:00',3.32),('15128','2013-08-20','14:35:00',3.11),('15128','2013-08-20','14:40:00',3.68),('15128','2013-08-20','14:45:00',2.88),('15128','2013-08-20','14:50:00',3.55),('15128','2013-08-20','14:55:00',3.63),('15128','2013-08-20','15:00:00',3.66),('15128','2013-08-20','15:05:00',3.68),('15128','2013-08-20','15:10:00',3.68),('15128','2013-08-20','15:15:00',3.67),('15128','2013-08-20','15:20:00',3.53),('15128','2013-08-20','15:25:00',3.39),('15128','2013-08-20','15:30:00',3.2),('15128','2013-08-20','15:35:00',3.14),('15128','2013-08-20','15:40:00',3.01),('15128','2013-08-20','15:45:00',3.03),('15128','2013-08-20','15:50:00',3.08),('15128','2013-08-20','15:55:00',3.04),('15128','2013-08-20','16:00:00',3),('15128','2013-08-20','16:05:00',3.04),('15128','2013-08-20','16:10:00',3.18),('15128','2013-08-20','16:15:00',3.17),('15128','2013-08-20','16:20:00',3.16),('15128','2013-08-20','16:25:00',3.07),('15128','2013-08-20','16:30:00',3.06),('15128','2013-08-20','16:35:00',3.06),('15128','2013-08-20','16:40:00',2.98),('15128','2013-08-20','16:45:00',2.93),('15128','2013-08-20','16:50:00',2.87),('15128','2013-08-20','16:55:00',2.85),('15128','2013-08-20','17:00:00',2.78),('15128','2013-08-20','17:05:00',2.73),('15128','2013-08-20','17:10:00',2.67),('15128','2013-08-20','17:15:00',2.62),('15128','2013-08-20','17:20:00',2.52),('15128','2013-08-20','17:25:00',2.45),('15128','2013-08-20','17:30:00',2.38),('15128','2013-08-20','17:35:00',2.25),('15128','2013-08-20','17:40:00',2.19),('15128','2013-08-20','17:45:00',2.06),('15128','2013-08-20','17:50:00',1.99),('15128','2013-08-20','17:55:00',1.9),('15128','2013-08-20','18:00:00',1.8),('15128','2013-08-20','18:05:00',1.72),('15128','2013-08-20','18:10:00',1.64),('15128','2013-08-20','18:15:00',1.57),('15128','2013-08-20','18:20:00',1.4),('15128','2013-08-20','18:25:00',1.2),('15128','2013-08-20','18:30:00',1.16),('15128','2013-08-20','18:35:00',1.12),('15128','2013-08-19','08:55:00',1.11),('15128','2013-08-19','09:25:00',1.32),('15128','2013-08-19','09:30:00',2.01),('15128','2013-08-19','09:35:00',1.84),('15128','2013-08-19','09:40:00',1.08),('15128','2013-08-19','09:55:00',1.08),('15128','2013-08-19','10:00:00',1.54),('15128','2013-08-19','10:05:00',2.52),('15128','2013-08-19','10:10:00',2.55),('15128','2013-08-19','10:15:00',1.34),('15128','2013-08-19','10:20:00',1.38),('15128','2013-08-19','10:25:00',1.28),('15128','2013-08-19','10:30:00',1.7),('15128','2013-08-19','10:35:00',3.27),('15128','2013-08-19','10:40:00',2.43),('15128','2013-08-19','10:45:00',1.08),('15128','2013-08-19','11:00:00',2.95),('15128','2013-08-19','11:05:00',1.99),('15128','2013-08-19','11:10:00',1.37),('15128','2013-08-19','11:15:00',2.03),('15128','2013-08-19','11:20:00',3.19),('15128','2013-08-19','11:25:00',1.93),('15128','2013-08-19','11:30:00',1.2),('15128','2013-08-19','11:35:00',1.87),('15128','2013-08-19','11:40:00',3.78),('15128','2013-08-19','11:45:00',2.77),('15128','2013-08-19','11:50:00',2.36),('15128','2013-08-19','11:55:00',2.67),('15128','2013-08-19','12:00:00',1.87),('15128','2013-08-19','12:05:00',1.84),('15128','2013-08-19','12:10:00',1.59),('15128','2013-08-19','12:15:00',1.4),('15128','2013-08-19','12:20:00',1.44),('15128','2013-08-19','12:25:00',1.93),('15128','2013-08-19','12:30:00',2.2),('15128','2013-08-19','12:35:00',2.63),('15128','2013-08-19','12:40:00',2.86),('15128','2013-08-19','12:45:00',1.96),('15128','2013-08-19','12:50:00',2.58),('15128','2013-08-19','12:55:00',3.18),('15128','2013-08-19','13:00:00',1.98),('15128','2013-08-19','13:05:00',1.63),('15128','2013-08-19','13:10:00',1.88),('15128','2013-08-19','13:15:00',2.81),('15128','2013-08-19','13:20:00',2.03),('15128','2013-08-19','13:25:00',2),('15128','2013-08-19','13:30:00',2.3),('15128','2013-08-19','13:35:00',2.27),('15128','2013-08-19','13:40:00',4.62),('15128','2013-08-19','13:45:00',3.51),('15128','2013-08-19','13:50:00',4.34),('15128','2013-08-19','13:55:00',4.21),('15128','2013-08-19','14:00:00',4.12),('15128','2013-08-19','14:05:00',3.59),('15128','2013-08-19','14:10:00',3.98),('15128','2013-08-19','14:15:00',3.31),('15128','2013-08-19','14:20:00',4.04),('15128','2013-08-19','14:25:00',3.19),('15128','2013-08-19','14:30:00',3.39),('15128','2013-08-19','14:35:00',3.21),('15128','2013-08-19','14:40:00',4.45),('15128','2013-08-19','14:45:00',3.65),('15128','2013-08-19','14:50:00',4.18),('15128','2013-08-19','14:55:00',3.95),('15128','2013-08-19','15:00:00',3.75),('15128','2013-08-19','15:05:00',4.08),('15128','2013-08-19','15:10:00',3.35),('15128','2013-08-19','15:15:00',1.88),('15128','2013-08-19','15:20:00',3.5),('15128','2013-08-19','15:25:00',4.23),('15128','2013-08-19','15:30:00',3.62),('15128','2013-08-19','15:35:00',1.56),('15128','2013-08-19','15:40:00',1.45),('15128','2013-08-19','15:45:00',2.39),('15128','2013-08-19','15:50:00',4.43),('15128','2013-08-19','15:55:00',4.15),('15128','2013-08-19','16:00:00',3.91),('15128','2013-08-19','16:05:00',3.95),('15128','2013-08-19','16:10:00',4.11),('15128','2013-08-19','16:15:00',4.15),('15128','2013-08-19','16:20:00',4.13),('15128','2013-08-19','16:25:00',3.9),('15128','2013-08-19','16:30:00',3.74),('15128','2013-08-19','16:35:00',2.49),('15128','2013-08-19','16:40:00',2.73),('15128','2013-08-19','16:45:00',3.36),('15128','2013-08-19','16:50:00',2.93),('15128','2013-08-19','16:55:00',2.57),('15128','2013-08-19','17:00:00',2.99),('15128','2013-08-19','17:05:00',2.92),('15128','2013-08-19','17:10:00',2.81),('15128','2013-08-19','17:15:00',2.75),('15128','2013-08-19','17:20:00',2.67),('15128','2013-08-19','17:25:00',2.55),('15128','2013-08-19','17:30:00',2.44),('15128','2013-08-19','17:35:00',2.38),('15128','2013-08-19','17:40:00',2.25),('15128','2013-08-19','17:45:00',2.09),('15128','2013-08-19','17:50:00',1.89),('15128','2013-08-19','17:55:00',1.79),('15128','2013-08-19','18:00:00',1.73),('15128','2013-08-19','18:05:00',1.64),('15128','2013-08-19','18:10:00',1.6),('15128','2013-08-19','18:15:00',1.56),('15128','2013-08-19','18:20:00',1.51),('15128','2013-08-19','18:25:00',1.47),('15128','2013-08-19','18:30:00',1.31),('15128','2013-08-19','18:35:00',1.31),('15128','2013-08-19','18:40:00',1.23),('15128','2013-08-19','18:45:00',1.13),('15128','2013-08-19','18:50:00',1.03),('15128','2014-04-09','08:45:00',1.03),('15128','2014-04-09','08:50:00',1.1),('15128','2014-04-09','08:55:00',1.14),('15128','2014-04-09','09:00:00',1.22),('15128','2014-04-09','09:05:00',1.31),('15128','2014-04-09','09:10:00',1.37),('15128','2014-04-09','09:15:00',1.39),('15128','2014-04-09','09:20:00',1.49),('15128','2014-04-09','09:25:00',1.59),('15128','2014-04-09','09:30:00',1.67),('15128','2014-04-09','09:35:00',1.75),('15128','2014-04-09','09:40:00',1.76),('15128','2014-04-09','09:45:00',1.87),('15128','2014-04-09','09:50:00',1.94),('15128','2014-04-09','09:55:00',1.94),('15128','2014-04-09','10:00:00',2),('15128','2014-04-09','10:05:00',2.06),('15128','2014-04-09','10:10:00',2.13),('15128','2014-04-09','10:15:00',2.16),('15128','2014-04-09','10:20:00',2.23),('15128','2014-04-09','10:25:00',2.27),('15128','2014-04-09','10:30:00',2.4),('15128','2014-04-09','10:35:00',2.56),('15128','2014-04-09','10:40:00',2.56),('15128','2014-04-09','10:45:00',2.63),('15128','2014-04-09','10:50:00',2.64),('15128','2014-04-09','10:55:00',2.73),('15128','2014-04-09','11:00:00',2.83),('15128','2014-04-09','11:05:00',2.76),('15128','2014-04-09','11:10:00',2.87),('15128','2014-04-09','11:15:00',2.93),('15128','2014-04-09','11:20:00',3.05),('15128','2014-04-09','11:25:00',3.16),('15128','2014-04-09','11:30:00',3.23),('15128','2014-04-09','11:35:00',3.18),('15128','2014-04-09','11:40:00',3.32),('15128','2014-04-09','11:45:00',3.24),('15128','2014-04-09','11:50:00',3.35),('15128','2014-04-09','11:55:00',3.45),('15128','2014-04-09','12:00:00',3.41),('15128','2014-04-09','12:05:00',3.42),('15128','2014-04-09','12:10:00',3.69),('15128','2014-04-09','12:15:00',3.72),('15128','2014-04-09','12:20:00',3.63),('15128','2014-04-09','12:25:00',3.55),('15128','2014-04-09','12:30:00',3.72),('15128','2014-04-09','12:35:00',3.7),('15128','2014-04-09','12:40:00',3.68),('15128','2014-04-09','12:45:00',3.74),('15128','2014-04-09','12:50:00',3.83),('15128','2014-04-09','12:55:00',3.91),('15128','2014-04-09','13:00:00',3.65),('15128','2014-04-09','13:05:00',3.81),('15128','2014-04-09','13:10:00',4.04),('15128','2014-04-09','13:15:00',3.87),('15128','2014-04-09','13:20:00',3.68),('15128','2014-04-09','13:25:00',3.91),('15128','2014-04-09','13:30:00',4.01),('15128','2014-04-09','13:35:00',4.04),('15128','2014-04-09','13:40:00',3.96),('15128','2014-04-09','13:45:00',4.06),('15128','2014-04-09','13:50:00',4.04),('15128','2014-04-09','13:55:00',4.02),('15128','2014-04-09','14:00:00',3.99),('15128','2014-04-09','14:05:00',3.86),('15128','2014-04-09','14:10:00',3.94),('15128','2014-04-09','14:15:00',4.05),('15128','2014-04-09','14:20:00',4.03),('15128','2014-04-09','14:25:00',3.99),('15128','2014-04-09','14:30:00',3.98),('15128','2014-04-09','14:35:00',3.95),('15128','2014-04-09','14:40:00',3.93),('15128','2014-04-09','14:45:00',3.58),('15128','2014-04-09','14:50:00',3.96),('15128','2014-04-09','14:55:00',3.87),('15128','2014-04-09','15:00:00',3.84),('15128','2014-04-09','15:05:00',3.85),('15128','2014-04-09','15:10:00',3.75),('15128','2014-04-09','15:15:00',3.76),('15128','2014-04-09','15:20:00',3.67),('15128','2014-04-09','15:25:00',3.65),('15128','2014-04-09','15:30:00',3.35),('15128','2014-04-09','15:35:00',3.27),('15128','2014-04-09','15:40:00',3.46),('15128','2014-04-09','15:45:00',3.39),('15128','2014-04-09','15:50:00',3.33),('15128','2014-04-09','15:55:00',3.53),('15128','2014-04-09','16:00:00',3.54),('15128','2014-04-09','16:05:00',3.5),('15128','2014-04-09','16:10:00',3.58),('15128','2014-04-09','16:15:00',3.52),('15128','2014-04-09','16:20:00',3.2),('15128','2014-04-09','16:25:00',3.32),('15128','2014-04-09','16:30:00',3.33),('15128','2014-04-09','16:35:00',3.21),('15128','2014-04-09','16:40:00',3.19),('15128','2014-04-09','16:45:00',3.02),('15128','2014-04-09','16:50:00',3.02),('15128','2014-04-09','16:55:00',2.92),('15128','2014-04-09','17:00:00',2.81),('15128','2014-04-09','17:05:00',2.78),('15128','2014-04-09','17:10:00',2.64),('15128','2014-04-09','17:15:00',2.54),('15128','2014-04-09','17:20:00',2.41),('15128','2014-04-09','17:25:00',2.25),('15128','2014-04-09','17:30:00',2.13),('15128','2014-04-09','17:35:00',2.01),('15128','2014-04-09','17:40:00',1.91),('15128','2014-04-09','17:45:00',1.84),('15128','2014-04-09','17:50:00',1.77),('15128','2014-04-09','17:55:00',1.71),('15128','2014-04-09','18:00:00',1.66),('15128','2014-04-09','18:05:00',1.57),('15128','2014-04-09','18:10:00',1.48),('15128','2014-04-09','18:15:00',1.38),('15128','2014-04-09','18:20:00',1.25),('15128','2014-04-09','18:25:00',1.1),('15128','2014-04-09','18:30:00',1.01),('15128','2013-08-18','08:40:00',1.07),('15128','2013-08-18','08:45:00',1.12),('15128','2013-08-18','08:50:00',1.16),('15128','2013-08-18','08:55:00',1.23),('15128','2013-08-18','09:00:00',1.3),('15128','2013-08-18','09:05:00',1.38),('15128','2013-08-18','09:10:00',1.43),('15128','2013-08-18','09:15:00',1.48),('15128','2013-08-18','09:20:00',1.54),('15128','2013-08-18','09:25:00',1.59),('15128','2013-08-18','09:30:00',1.66),('15128','2013-08-18','09:35:00',1.7),('15128','2013-08-18','09:40:00',1.77),('15128','2013-08-18','09:45:00',1.78),('15128','2013-08-18','09:50:00',1.84),('15128','2013-08-18','09:55:00',1.96),('15128','2013-08-18','10:00:00',2),('15128','2013-08-18','10:05:00',2.05),('15128','2013-08-18','10:10:00',2.11),('15128','2013-08-18','10:15:00',2.16),('15128','2013-08-18','10:20:00',2.21),('15128','2013-08-18','10:25:00',2.28),('15128','2013-08-18','10:30:00',2.37),('15128','2013-08-18','10:35:00',2.46),('15128','2013-08-18','10:40:00',2.55),('15128','2013-08-18','10:45:00',2.6),('15128','2013-08-18','10:50:00',2.64),('15128','2013-08-18','10:55:00',2.7),('15128','2013-08-18','11:00:00',2.76),('15128','2013-08-18','11:05:00',2.79),('15128','2013-08-18','11:10:00',2.82),('15128','2013-08-18','11:15:00',2.94),('15128','2013-08-18','11:20:00',2.95),('15128','2013-08-18','11:25:00',2.97),('15128','2013-08-18','11:30:00',3.03),('15128','2013-08-18','11:35:00',2.98),('15128','2013-08-18','11:40:00',3.07),('15128','2013-08-18','11:45:00',3.14),('15128','2013-08-18','11:50:00',3.28),('15128','2013-08-18','11:55:00',3.4),('15128','2013-08-18','12:00:00',3.52),('15128','2013-08-18','12:05:00',3.6),('15128','2013-08-18','12:10:00',3.68),('15128','2013-08-18','12:15:00',3.67),('15128','2013-08-18','12:20:00',3.68),('15128','2013-08-18','12:25:00',3.72),('15128','2013-08-18','12:30:00',3.78),('15128','2013-08-18','12:35:00',3.83),('15128','2013-08-18','12:40:00',3.87),('15128','2013-08-18','12:45:00',3.87),('15128','2013-08-18','12:50:00',3.88),('15128','2013-08-18','12:55:00',3.91),('15128','2013-08-18','13:00:00',3.96),('15128','2013-08-18','13:05:00',3.96),('15128','2013-08-18','13:10:00',4),('15128','2013-08-18','13:15:00',4.01),('15128','2013-08-18','13:20:00',4.01),('15128','2013-08-18','13:25:00',4.02),('15128','2013-08-18','13:30:00',4.03),('15128','2013-08-18','13:35:00',4.04),('15128','2013-08-18','13:40:00',4.07),('15128','2013-08-18','13:45:00',4.09),('15128','2013-08-18','13:50:00',4.09),('15128','2013-08-18','13:55:00',4.1),('15128','2013-08-18','14:00:00',4.1),('15128','2013-08-18','14:05:00',4.11),('15128','2013-08-18','14:10:00',4.09),('15128','2013-08-18','14:15:00',4.07),('15128','2013-08-18','14:20:00',4.06),('15128','2013-08-18','14:25:00',4.06),('15128','2013-08-18','14:30:00',4.05),('15128','2013-08-18','14:35:00',4.04),('15128','2013-08-18','14:40:00',4.04),('15128','2013-08-18','14:45:00',4.03),('15128','2013-08-18','14:50:00',4.02),('15128','2013-08-18','14:55:00',3.99),('15128','2013-08-18','15:00:00',3.97),('15128','2013-08-18','15:05:00',3.95),('15128','2013-08-18','15:10:00',3.93),('15128','2013-08-18','15:15:00',3.9),('15128','2013-08-18','15:20:00',3.87),('15128','2013-08-18','15:25:00',3.84),('15128','2013-08-18','15:30:00',3.8),('15128','2013-08-18','15:35:00',3.75),('15128','2013-08-18','15:40:00',3.73),('15128','2013-08-18','15:45:00',3.71),('15128','2013-08-18','15:50:00',3.63),('15128','2013-08-18','15:55:00',3.62),('15128','2013-08-18','16:00:00',3.57),('15128','2013-08-18','16:05:00',3.52),('15128','2013-08-18','16:10:00',3.48),('15128','2013-08-18','16:15:00',3.41),('15128','2013-08-18','16:20:00',3.35),('15128','2013-08-18','16:25:00',3.31),('15128','2013-08-18','16:30:00',3.25),('15128','2013-08-18','16:35:00',3.2),('15128','2013-08-18','16:40:00',3.14),('15128','2013-08-18','16:45:00',3.09),('15128','2013-08-18','16:50:00',3.01),('15128','2013-08-18','16:55:00',2.96),('15128','2013-08-18','17:00:00',2.89),('15128','2013-08-18','17:05:00',2.81),('15128','2013-08-18','17:10:00',2.74),('15128','2013-08-18','17:15:00',2.67),('15128','2013-08-18','17:20:00',2.6),('15128','2013-08-18','17:25:00',2.51),('15128','2013-08-18','17:30:00',2.4),('15128','2013-08-18','17:35:00',2.32),('15128','2013-08-18','17:40:00',2.18),('15128','2013-08-18','17:45:00',2.04),('15128','2013-08-18','17:50:00',1.99),('15128','2013-08-18','17:55:00',1.88),('15128','2013-08-18','18:00:00',1.81),('15128','2013-08-18','18:05:00',1.72),('15128','2013-08-18','18:10:00',1.67),('15128','2013-08-18','18:15:00',1.6),('15128','2013-08-18','18:20:00',1.51),('15128','2013-08-18','18:25:00',1.44),('15128','2013-08-18','18:30:00',1.35),('15128','2013-08-18','18:35:00',1.25),('15128','2013-08-18','18:40:00',1.14),('15128','2013-08-18','18:45:00',1.06),('15128','2013-08-17','08:35:00',1.04),('15128','2013-08-17','08:40:00',1.1),('15128','2013-08-17','08:45:00',1.14),('15128','2013-08-17','08:50:00',1.17),('15128','2013-08-17','08:55:00',1.24),('15128','2013-08-17','09:00:00',1.32),('15128','2013-08-17','09:05:00',1.4),('15128','2013-08-17','09:10:00',1.48),('15128','2013-08-17','09:15:00',1.53),('15128','2013-08-17','09:20:00',1.57),('15128','2013-08-17','09:25:00',1.63),('15128','2013-08-17','09:30:00',1.68),('15128','2013-08-17','09:35:00',1.72),('15128','2013-08-17','09:40:00',1.74),('15128','2013-08-17','09:45:00',1.76),('15128','2013-08-17','09:50:00',1.88),('15128','2013-08-17','09:55:00',1.94),('15128','2013-08-17','10:00:00',2.06),('15128','2013-08-17','10:05:00',2.11),('15128','2013-08-17','10:10:00',2.16),('15128','2013-08-17','10:15:00',2.22),('15128','2013-08-17','10:20:00',2.23),('15128','2013-08-17','10:25:00',2.32),('15128','2013-08-17','10:30:00',2.39),('15128','2013-08-17','10:35:00',2.46),('15128','2013-08-17','10:40:00',2.55),('15128','2013-08-17','10:45:00',2.62),('15128','2013-08-17','10:50:00',2.7),('15128','2013-08-17','10:55:00',2.72),('15128','2013-08-17','11:00:00',2.78),('15128','2013-08-17','11:05:00',2.83),('15128','2013-08-17','11:10:00',2.87),('15128','2013-08-17','11:15:00',2.94),('15128','2013-08-17','11:20:00',2.97),('15128','2013-08-17','11:25:00',3),('15128','2013-08-17','11:30:00',3.1),('15128','2013-08-17','11:35:00',3.03),('15128','2013-08-17','11:40:00',3.15),('15128','2013-08-17','11:45:00',3.18),('15128','2013-08-17','11:50:00',3.3),('15128','2013-08-17','11:55:00',3.41),('15128','2013-08-17','12:00:00',3.52),('15128','2013-08-17','12:05:00',3.57),('15128','2013-08-17','12:10:00',3.62),('15128','2013-08-17','12:15:00',3.62),('15128','2013-08-17','12:20:00',3.68),('15128','2013-08-17','12:25:00',3.7),('15128','2013-08-17','12:30:00',3.87),('15128','2013-08-17','12:35:00',3.15),('15128','2013-08-17','12:40:00',2.35),('15128','2013-08-17','12:45:00',3.9),('15128','2013-08-17','12:50:00',3.9),('15128','2013-08-17','12:55:00',3.95),('15128','2013-08-17','13:00:00',3.93),('15128','2013-08-17','13:05:00',3.93),('15128','2013-08-17','13:10:00',3.97),('15128','2013-08-17','13:15:00',3.97),('15128','2013-08-17','13:20:00',3.99),('15128','2013-08-17','13:25:00',3.99),('15128','2013-08-17','13:30:00',4.04),('15128','2013-08-17','13:35:00',4.01),('15128','2013-08-17','13:40:00',4),('15128','2013-08-17','13:45:00',4.04),('15128','2013-08-17','13:50:00',4.04),('15128','2013-08-17','13:55:00',4.02),('15128','2013-08-17','14:00:00',4.06),('15128','2013-08-17','14:05:00',4.06),('15128','2013-08-17','14:10:00',4.06),('15128','2013-08-17','14:15:00',4.06),('15128','2013-08-17','14:20:00',4.03),('15128','2013-08-17','14:25:00',4.04),('15128','2013-08-17','14:30:00',4.03),('15128','2013-08-17','14:35:00',4.03),('15128','2013-08-17','14:40:00',4.02),('15128','2013-08-17','14:45:00',4.02),('15128','2013-08-17','14:50:00',4.01),('15128','2013-08-17','14:55:00',3.97),('15128','2013-08-17','15:00:00',3.94),('15128','2013-08-17','15:05:00',3.93),('15128','2013-08-17','15:10:00',3.89),('15128','2013-08-17','15:15:00',3.88),('15128','2013-08-17','15:20:00',3.84),('15128','2013-08-17','15:25:00',3.79),('15128','2013-08-17','15:30:00',3.74),('15128','2013-08-17','15:35:00',3.71),('15128','2013-08-17','15:40:00',3.67),('15128','2013-08-17','15:45:00',3.65),('15128','2013-08-17','15:50:00',3.62),('15128','2013-08-17','15:55:00',3.58),('15128','2013-08-17','16:00:00',3.54),('15128','2013-08-17','16:05:00',3.51),('15128','2013-08-17','16:10:00',3.47),('15128','2013-08-17','16:15:00',3.42),('15128','2013-08-17','16:20:00',3.38),('15128','2013-08-17','16:25:00',3.32),('15128','2013-08-17','16:30:00',3.26),('15128','2013-08-17','16:35:00',3.2),('15128','2013-08-17','16:40:00',3.16),('15128','2013-08-17','16:45:00',3.1),('15128','2013-08-17','16:50:00',3.04),('15128','2013-08-17','16:55:00',2.98),('15128','2013-08-17','17:00:00',2.9),('15128','2013-08-17','17:05:00',2.84),('15128','2013-08-17','17:10:00',2.77),('15128','2013-08-17','17:15:00',2.7),('15128','2013-08-17','17:20:00',2.62),('15128','2013-08-17','17:25:00',2.53),('15128','2013-08-17','17:30:00',2.42),('15128','2013-08-17','17:35:00',2.33),('15128','2013-08-17','17:40:00',2.22),('15128','2013-08-17','17:45:00',2.12),('15128','2013-08-17','17:50:00',2.02),('15128','2013-08-17','17:55:00',1.89),('15128','2013-08-17','18:00:00',1.81),('15128','2013-08-17','18:05:00',1.7),('15128','2013-08-17','18:10:00',1.66),('15128','2013-08-17','18:15:00',1.61),('15128','2013-08-17','18:20:00',1.53),('15128','2013-08-17','18:25:00',1.45),('15128','2013-08-17','18:30:00',1.37),('15128','2013-08-17','18:35:00',1.27),('15128','2013-08-17','18:40:00',1.16),('15128','2013-08-17','18:45:00',1.06),('15128','2013-08-16','08:40:00',1.05),('15128','2013-08-16','08:45:00',1.1),('15128','2013-08-16','08:50:00',1.16),('15128','2013-08-16','08:55:00',1.29),('15128','2013-08-16','09:00:00',1.36),('15128','2013-08-16','09:05:00',1.42),('15128','2013-08-16','09:10:00',1.48),('15128','2013-08-16','09:15:00',1.53),('15128','2013-08-16','09:20:00',1.57),('15128','2013-08-16','09:25:00',1.62),('15128','2013-08-16','09:30:00',1.68),('15128','2013-08-16','09:35:00',1.86),('15128','2013-08-16','09:40:00',1.93),('15128','2013-08-16','09:45:00',1.93),('15128','2013-08-16','09:50:00',1.92),('15128','2013-08-16','09:55:00',1.97),('15128','2013-08-16','10:00:00',2.04),('15128','2013-08-16','10:05:00',2.12),('15128','2013-08-16','10:10:00',2.13),('15128','2013-08-16','10:15:00',2.19),('15128','2013-08-16','10:20:00',2.23),('15128','2013-08-16','10:25:00',2.33),('15128','2013-08-16','10:30:00',2.46),('15128','2013-08-16','10:35:00',2.56),('15128','2013-08-16','10:40:00',2.59),('15128','2013-08-16','10:45:00',2.64),('15128','2013-08-16','10:50:00',2.69),('15128','2013-08-16','10:55:00',2.7),('15128','2013-08-16','11:00:00',2.75),('15128','2013-08-16','11:05:00',2.78),('15128','2013-08-16','11:10:00',2.85),('15128','2013-08-16','11:15:00',2.9),('15128','2013-08-16','11:20:00',2.97),('15128','2013-08-16','11:25:00',3.01),('15128','2013-08-16','11:30:00',3.08),('15128','2013-08-16','11:35:00',3.1),('15128','2013-08-16','11:40:00',3.21),('15128','2013-08-16','11:45:00',3.25),('15128','2013-08-16','11:50:00',3.32),('15128','2013-08-16','11:55:00',3.5),('15128','2013-08-16','12:00:00',3.54),('15128','2013-08-16','12:05:00',3.6),('15128','2013-08-16','12:10:00',3.64),('15128','2013-08-16','12:15:00',3.62),('15128','2013-08-16','12:20:00',3.63),('15128','2013-08-16','12:25:00',3.66),('15128','2013-08-16','12:30:00',3.79),('15128','2013-08-16','12:35:00',3.81),('15128','2013-08-16','12:40:00',3.78),('15128','2013-08-16','12:45:00',3.7),('15128','2013-08-16','12:50:00',3.76),('15128','2013-08-16','12:55:00',3.91),('15128','2013-08-16','13:00:00',3.96),('15128','2013-08-16','13:05:00',3.93),('15128','2013-08-16','13:10:00',3.95),('15128','2013-08-16','13:15:00',3.99),('15128','2013-08-16','13:20:00',3.96),('15128','2013-08-16','13:25:00',3.98),('15128','2013-08-16','13:30:00',3.95),('15128','2013-08-16','13:35:00',4.04),('15128','2013-08-16','13:40:00',3.91),('15128','2013-08-16','13:45:00',3.98),('15128','2013-08-16','13:50:00',4.1),('15128','2013-08-16','13:55:00',4.03),('15128','2013-08-16','14:00:00',3.99),('15128','2013-08-16','14:05:00',4.06),('15128','2013-08-16','14:10:00',4.04),('15128','2013-08-16','14:15:00',4.03),('15128','2013-08-16','14:20:00',4.05),('15128','2013-08-16','14:25:00',4.04),('15128','2013-08-16','14:30:00',4.05),('15128','2013-08-16','14:35:00',4.05),('15128','2013-08-16','14:40:00',4.03),('15128','2013-08-16','14:45:00',3.99),('15128','2013-08-16','14:50:00',3.97),('15128','2013-08-16','14:55:00',3.97),('15128','2013-08-16','15:00:00',3.94),('15128','2013-08-16','15:05:00',3.94),('15128','2013-08-16','15:10:00',3.93),('15128','2013-08-16','15:15:00',3.91),('15128','2013-08-16','15:20:00',3.87),('15128','2013-08-16','15:25:00',3.86),('15128','2013-08-16','15:30:00',3.83),('15128','2013-08-16','15:35:00',3.78),('15128','2013-08-16','15:40:00',3.73),('15128','2013-08-16','15:45:00',3.7),('15128','2013-08-16','15:50:00',3.7),('15128','2013-08-16','15:55:00',3.63),('15128','2013-08-16','16:00:00',3.57),('15128','2013-08-16','16:05:00',3.54),('15128','2013-08-16','16:10:00',3.52),('15128','2013-08-16','16:15:00',3.46),('15128','2013-08-16','16:20:00',3.42),('15128','2013-08-16','16:25:00',3.38),('15128','2013-08-16','16:30:00',3.33),('15128','2013-08-16','16:35:00',3.26),('15128','2013-08-16','16:40:00',3.22),('15128','2013-08-16','16:45:00',3.15),('15128','2013-08-16','16:50:00',3.08),('15128','2013-08-16','16:55:00',3.02),('15128','2013-08-16','17:00:00',2.94),('15128','2013-08-16','17:05:00',2.85),('15128','2013-08-16','17:10:00',2.81),('15128','2013-08-16','17:15:00',2.68),('15128','2013-08-16','17:20:00',2.72),('15128','2013-08-16','17:25:00',2.61),('15128','2013-08-16','17:30:00',2.5),('15128','2013-08-16','17:35:00',2.4),('15128','2013-08-16','17:40:00',2.31),('15128','2013-08-16','17:45:00',2.2),('15128','2013-08-16','17:50:00',2.11),('15128','2013-08-16','17:55:00',1.96),('15128','2013-08-16','18:00:00',1.9),('15128','2013-08-16','18:05:00',1.82),('15128','2013-08-16','18:10:00',1.67),('15128','2013-08-16','18:15:00',1.63),('15128','2013-08-16','18:20:00',1.58),('15128','2013-08-16','18:25:00',1.5),('15128','2013-08-16','18:30:00',1.42),('15128','2013-08-16','18:35:00',1.32),('15128','2013-08-16','18:40:00',1.22),('15128','2013-08-16','18:45:00',1.13),('15128','2013-08-16','18:50:00',1.01),('15128','2013-08-15','08:35:00',1.03),('15128','2013-08-15','08:40:00',1.08),('15128','2013-08-15','08:45:00',1.13),('15128','2013-08-15','08:50:00',1.18),('15128','2013-08-15','08:55:00',1.31),('15128','2013-08-15','09:00:00',1.38),('15128','2013-08-15','09:05:00',1.45),('15128','2013-08-15','09:10:00',1.52),('15128','2013-08-15','09:15:00',1.58),('15128','2013-08-15','09:20:00',1.61),('15128','2013-08-15','09:25:00',1.65),('15128','2013-08-15','09:30:00',1.76),('15128','2013-08-15','09:35:00',1.9),('15128','2013-08-15','09:40:00',1.97),('15128','2013-08-15','09:45:00',1.96),('15128','2013-08-15','09:50:00',1.99),('15128','2013-08-15','09:55:00',2.01),('15128','2013-08-15','10:00:00',2.11),('15128','2013-08-15','10:05:00',2.17),('15128','2013-08-15','10:10:00',2.21),('15128','2013-08-15','10:15:00',2.29),('15128','2013-08-15','10:20:00',2.36),('15128','2013-08-15','10:25:00',2.45),('15128','2013-08-15','10:30:00',2.57),('15128','2013-08-15','10:35:00',2.63),('15128','2013-08-15','10:40:00',2.67),('15128','2013-08-15','10:45:00',2.75),('15128','2013-08-15','10:50:00',2.84),('15128','2013-08-15','10:55:00',2.89),('15128','2013-08-15','11:00:00',2.92),('15128','2013-08-15','11:05:00',2.96),('15128','2013-08-15','11:10:00',2.99),('15128','2013-08-15','11:15:00',3.05),('15128','2013-08-15','11:20:00',3.1),('15128','2013-08-15','11:25:00',3.15),('15128','2013-08-15','11:30:00',3.16),('15128','2013-08-15','11:35:00',3.24),('15128','2013-08-15','11:40:00',3.29),('15128','2013-08-15','11:45:00',3.37),('15128','2013-08-15','11:50:00',3.47),('15128','2013-08-15','11:55:00',3.58),('15128','2013-08-15','12:00:00',3.64),('15128','2013-08-15','12:05:00',3.72),('15128','2013-08-15','12:10:00',3.75),('15128','2013-08-15','12:15:00',3.78),('15128','2013-08-15','12:20:00',3.79),('15128','2013-08-15','12:25:00',3.82),('15128','2013-08-15','12:30:00',3.85),('15128','2013-08-15','12:35:00',3.9),('15128','2013-08-15','12:40:00',3.93),('15128','2013-08-15','12:45:00',3.96),('15128','2013-08-15','12:50:00',3.98),('15128','2013-08-15','12:55:00',4),('15128','2013-08-15','13:00:00',3.99),('15128','2013-08-15','13:05:00',4),('15128','2013-08-15','13:10:00',4),('15128','2013-08-15','13:15:00',4.01),('15128','2013-08-15','13:20:00',4.05),('15128','2013-08-15','13:25:00',4.06),('15128','2013-08-15','13:30:00',4.03),('15128','2013-08-15','13:35:00',4.03),('15128','2013-08-15','13:40:00',4.03),('15128','2013-08-15','13:45:00',4.05),('15128','2013-08-15','13:50:00',4.06),('15128','2013-08-15','13:55:00',4.06),('15128','2013-08-15','14:00:00',4.06),('15128','2013-08-15','14:05:00',4.05),('15128','2013-08-15','14:10:00',4.04),('15128','2013-08-15','14:15:00',4.02),('15128','2013-08-15','14:20:00',4.03),('15128','2013-08-15','14:25:00',4.02),('15128','2013-08-15','14:30:00',3.98),('15128','2013-08-15','14:35:00',3.95),('15128','2013-08-15','14:40:00',3.95),('15128','2013-08-15','14:45:00',3.93),('15128','2013-08-15','14:50:00',3.9),('15128','2013-08-15','14:55:00',3.88),('15128','2013-08-15','15:00:00',3.89),('15128','2013-08-15','15:05:00',3.95),('15128','2013-08-15','15:10:00',3.94),('15128','2013-08-15','15:15:00',3.92),('15128','2013-08-15','15:20:00',3.88),('15128','2013-08-15','15:25:00',3.85),('15128','2013-08-15','15:30:00',3.8),('15128','2013-08-15','15:35:00',3.77),('15128','2013-08-15','15:40:00',3.74),('15128','2013-08-15','15:45:00',3.7),('15128','2013-08-15','15:50:00',3.67),('15128','2013-08-15','15:55:00',3.62),('15128','2013-08-15','16:00:00',3.57),('15128','2013-08-15','16:05:00',3.51),('15128','2013-08-15','16:10:00',3.47),('15128','2013-08-15','16:15:00',3.44),('15128','2013-08-15','16:20:00',3.4),('15128','2013-08-15','16:25:00',3.36),('15128','2013-08-15','16:30:00',3.3),('15128','2013-08-15','16:35:00',3.23),('15128','2013-08-15','16:40:00',3.18),('15128','2013-08-15','16:45:00',3.13),('15128','2013-08-15','16:50:00',3.06),('15128','2013-08-15','16:55:00',2.99),('15128','2013-08-15','17:00:00',2.92),('15128','2013-08-15','17:05:00',2.86),('15128','2013-08-15','17:10:00',2.78),('15128','2013-08-15','17:15:00',2.72),('15128','2013-08-15','17:20:00',2.65),('15128','2013-08-15','17:25:00',2.53),('15128','2013-08-15','17:30:00',2.47),('15128','2013-08-15','17:35:00',2.36),('15128','2013-08-15','17:40:00',2.26),('15128','2013-08-15','17:45:00',2.1),('15128','2013-08-15','17:50:00',2.04),('15128','2013-08-15','17:55:00',1.96),('15128','2013-08-15','18:00:00',1.86),('15128','2013-08-15','18:05:00',1.8),('15128','2013-08-15','18:10:00',1.69),('15128','2013-08-15','18:15:00',1.62),('15128','2013-08-15','18:20:00',1.51),('15128','2013-08-15','18:25:00',1.11),('15128','2013-08-15','18:40:00',1.06),('15128','2013-08-15','18:45:00',1.14),('15128','2013-08-15','18:50:00',1.04),('15128','2013-08-14','08:20:00',1.02),('15128','2013-08-14','08:25:00',1.05),('15128','2013-08-14','08:40:00',1.14),('15128','2013-08-14','08:45:00',1.18),('15128','2013-08-14','08:50:00',1.22),('15128','2013-08-14','08:55:00',1.33),('15128','2013-08-14','09:00:00',1.4),('15128','2013-08-14','09:05:00',1.48),('15128','2013-08-14','09:10:00',1.56),('15128','2013-08-14','09:15:00',1.62),('15128','2013-08-14','09:20:00',1.66),('15128','2013-08-14','09:25:00',1.69),('15128','2013-08-14','09:30:00',1.78),('15128','2013-08-14','09:35:00',1.94),('15128','2013-08-14','09:40:00',2.02),('15128','2013-08-14','09:45:00',1.98),('15128','2013-08-14','09:50:00',1.99),('15128','2013-08-14','09:55:00',2.04),('15128','2013-08-14','10:00:00',2.13),('15128','2013-08-14','10:05:00',2.19),('15128','2013-08-14','10:10:00',2.25),('15128','2013-08-14','10:15:00',2.28),('15128','2013-08-14','10:20:00',2.3),('15128','2013-08-14','10:25:00',2.38),('15128','2013-08-14','10:30:00',2.48),('15128','2013-08-14','10:35:00',2.62),('15128','2013-08-14','10:40:00',2.68),('15128','2013-08-14','10:45:00',2.75),('15128','2013-08-14','10:50:00',2.82),('15128','2013-08-14','10:55:00',2.88),('15128','2013-08-14','11:00:00',2.89),('15128','2013-08-14','11:05:00',2.92),('15128','2013-08-14','11:10:00',3.03),('15128','2013-08-14','11:15:00',3.1),('15128','2013-08-14','11:20:00',3.06),('15128','2013-08-14','11:25:00',2.96),('15128','2013-08-14','11:30:00',3.03),('15128','2013-08-14','11:35:00',3.03),('15128','2013-08-14','11:40:00',3.3),('15128','2013-08-14','11:45:00',3.28),('15128','2013-08-14','11:50:00',2.45),('15128','2013-08-14','11:55:00',2.39),('15128','2013-08-14','12:00:00',2.71),('15128','2013-08-14','12:05:00',3.22),('15128','2013-08-14','12:10:00',3.58),('15128','2013-08-14','12:15:00',3.76),('15128','2013-08-14','12:20:00',3.78),('15128','2013-08-14','12:25:00',3.73),('15128','2013-08-14','12:30:00',3.89),('15128','2013-08-14','12:35:00',4.03),('15128','2013-08-14','12:40:00',4.07),('15128','2013-08-14','12:45:00',4.05),('15128','2013-08-14','12:50:00',4.06),('15128','2013-08-14','12:55:00',3.92),('15128','2013-08-14','13:00:00',3.84),('15128','2013-08-14','13:05:00',3.76),('15128','2013-08-14','13:10:00',3.74),('15128','2013-08-14','13:15:00',3.86),('15128','2013-08-14','13:20:00',3.85),('15128','2013-08-14','13:25:00',3.78),('15128','2013-08-14','13:30:00',3.73),('15128','2013-08-14','13:35:00',3.75),('15128','2013-08-14','13:40:00',4.06),('15128','2013-08-14','13:45:00',4.13),('15128','2013-08-14','13:50:00',4.08),('15128','2013-08-14','13:55:00',3.89),('15128','2013-08-14','14:00:00',3.99),('15128','2013-08-14','14:05:00',3.97),('15128','2013-08-14','14:10:00',3.76),('15128','2013-08-14','14:15:00',3.16),('15128','2013-08-14','14:20:00',3.96),('15128','2013-08-14','14:25:00',3.99),('15128','2013-08-14','14:30:00',3.9),('15128','2013-08-14','14:35:00',3.98),('15128','2013-08-14','14:40:00',3.94),('15128','2013-08-14','14:45:00',3.88),('15128','2013-08-14','14:50:00',3.69),('15128','2013-08-14','14:55:00',3.8),('15128','2013-08-14','15:00:00',3.8),('15128','2013-08-14','15:05:00',3.77),('15128','2013-08-14','15:10:00',3.63),('15128','2013-08-14','15:15:00',3.74),('15128','2013-08-14','15:20:00',3.68),('15128','2013-08-14','15:25:00',3.77),('15128','2013-08-14','15:30:00',3.69),('15128','2013-08-14','15:35:00',2.43),('15128','2013-08-14','15:40:00',3.65),('15128','2013-08-14','15:45:00',3.57),('15128','2013-08-14','15:50:00',3.55),('15128','2013-08-14','15:55:00',3.49),('15128','2013-08-14','16:00:00',3.4),('15128','2013-08-14','16:05:00',3.37),('15128','2013-08-14','16:10:00',3.38),('15128','2013-08-14','16:15:00',3.35),('15128','2013-08-14','16:20:00',3.3),('15128','2013-08-14','16:25:00',3.23),('15128','2013-08-14','16:30:00',3.17),('15128','2013-08-14','16:35:00',3.2),('15128','2013-08-14','16:40:00',3.11),('15128','2013-08-14','16:45:00',3.04),('15128','2013-08-14','16:50:00',2.95),('15128','2013-08-14','16:55:00',2.88),('15128','2013-08-14','17:00:00',2.86),('15128','2013-08-14','17:05:00',2.75),('15128','2013-08-14','17:10:00',2.68),('15128','2013-08-14','17:15:00',2.62),('15128','2013-08-14','17:20:00',2.55),('15128','2013-08-14','17:25:00',2.48),('15128','2013-08-14','17:30:00',2.38),('15128','2013-08-14','17:35:00',2.23),('15128','2013-08-14','17:40:00',2.14),('15128','2013-08-14','17:45:00',2.06),('15128','2013-08-14','17:50:00',1.95),('15128','2013-08-14','17:55:00',1.82),('15128','2013-08-14','18:00:00',1.71),('15128','2013-08-14','18:05:00',1.67),('15128','2013-08-14','18:10:00',1.58),('15128','2013-08-14','18:15:00',1.51),('15128','2013-08-14','18:20:00',1.46),('15128','2013-08-14','18:25:00',1.4),('15128','2013-08-14','18:30:00',1.32),('15128','2013-08-14','18:35:00',1.12),('15128','2013-08-13','08:35:00',1.01),('15128','2013-08-13','08:40:00',1.12),('15128','2013-08-13','08:45:00',1.05),('15128','2013-08-13','08:50:00',1.14),('15128','2013-08-13','08:55:00',1.29),('15128','2013-08-13','09:00:00',1.37),('15128','2013-08-13','09:05:00',1.43),('15128','2013-08-13','09:10:00',1.57),('15128','2013-08-13','09:15:00',1.76),('15128','2013-08-13','09:20:00',2.01),('15128','2013-08-13','09:25:00',2.07),('15128','2013-08-13','09:30:00',1.99),('15128','2013-08-13','09:35:00',1.71),('15128','2013-08-13','09:40:00',1.07),('15128','2013-08-13','09:45:00',1.21),('15128','2013-08-13','09:50:00',1.99),('15128','2013-08-13','09:55:00',2.59),('15128','2013-08-13','10:00:00',2.71),('15128','2013-08-13','10:05:00',1.77),('15128','2013-08-13','10:10:00',2.03),('15128','2013-08-13','10:15:00',2.32),('15128','2013-08-13','10:20:00',1.63),('15128','2013-08-13','10:25:00',2.29),('15128','2013-08-13','10:30:00',2.84),('15128','2013-08-13','10:35:00',3.1),('15128','2013-08-13','10:40:00',2.72),('15128','2013-08-13','10:45:00',1.26),('15128','2013-08-13','10:50:00',1.08),('15128','2013-08-13','10:55:00',1.04),('15128','2013-08-13','11:00:00',1.67),('15128','2013-08-13','11:05:00',3.26),('15128','2013-08-13','11:10:00',3.28),('15128','2013-08-13','11:15:00',3.33),('15128','2013-08-13','11:20:00',3.39),('15128','2013-08-13','11:25:00',2.19),('15128','2013-08-13','11:30:00',1.09),('15128','2013-08-13','11:35:00',1.04),('15128','2013-08-13','11:40:00',1.1),('15128','2013-08-13','11:45:00',1.25),('15128','2013-08-13','11:50:00',2.07),('15128','2013-08-13','11:55:00',2.47),('15128','2013-08-13','12:00:00',1.75),('15128','2013-08-13','12:05:00',2.31),('15128','2013-08-13','12:10:00',1.61),('15128','2013-08-13','12:15:00',1.8),('15128','2013-08-13','12:20:00',2.63),('15128','2013-08-13','12:25:00',4.41),('15128','2013-08-13','12:30:00',4.26),('15128','2013-08-13','12:35:00',4.11),('15128','2013-08-13','12:40:00',3.83),('15128','2013-08-13','12:45:00',2.27),('15128','2013-08-13','12:50:00',1.58),('15128','2013-08-13','12:55:00',2.9),('15128','2013-08-13','13:00:00',3.54),('15128','2013-08-13','13:05:00',3.47),('15128','2013-08-13','13:10:00',3.69),('15128','2013-08-13','13:15:00',3.99),('15128','2013-08-13','13:20:00',3.99),('15128','2013-08-13','13:25:00',2.44),('15128','2013-08-13','13:30:00',4.48),('15128','2013-08-13','13:35:00',4.14),('15128','2013-08-13','13:40:00',4.11),('15128','2013-08-13','13:45:00',3.58),('15128','2013-08-13','13:50:00',4.14),('15128','2013-08-13','13:55:00',3.26),('15128','2013-08-13','14:00:00',2.64),('15128','2013-08-13','14:05:00',3.73),('15128','2013-08-13','14:10:00',3.2),('15128','2013-08-13','14:15:00',4.29),('15128','2013-08-13','14:20:00',4.19),('15128','2013-08-13','14:25:00',4.16),('15128','2013-08-13','14:30:00',4.08),('15128','2013-08-13','14:35:00',4.09),('15128','2013-08-13','14:40:00',4.08),('15128','2013-08-13','14:45:00',4.01),('15128','2013-08-13','14:50:00',4),('15128','2013-08-13','14:55:00',4),('15128','2013-08-13','15:00:00',3.95),('15128','2013-08-13','15:05:00',3.94),('15128','2013-08-13','15:10:00',3.91),('15128','2013-08-13','15:15:00',3.88),('15128','2013-08-13','15:20:00',3.86),('15128','2013-08-13','15:25:00',3.86),('15128','2013-08-13','15:30:00',3.8),('15128','2013-08-13','15:35:00',3.76),('15128','2013-08-13','15:40:00',3.72),('15128','2013-08-13','15:45:00',3.68),('15128','2013-08-13','15:50:00',3.66),('15128','2013-08-13','15:55:00',3.63),('15128','2013-08-13','16:00:00',3.61),('15128','2013-08-13','16:05:00',3.54),('15128','2013-08-13','16:10:00',3.5),('15128','2013-08-13','16:15:00',3.49),('15128','2013-08-13','16:20:00',3.44),('15128','2013-08-13','16:25:00',3.41),('15128','2013-08-13','16:30:00',3.34),('15128','2013-08-13','16:35:00',3.28),('15128','2013-08-13','16:40:00',3.21),('15128','2013-08-13','16:45:00',3.17),('15128','2013-08-13','16:50:00',3.12),('15128','2013-08-13','16:55:00',3.03),('15128','2013-08-13','17:00:00',2.97),('15128','2013-08-13','17:05:00',2.86),('15128','2013-08-13','17:10:00',2.83),('15128','2013-08-13','17:15:00',2.74),('15128','2013-08-13','17:20:00',2.67),('15128','2013-08-13','17:25:00',2.62),('15128','2013-08-13','17:30:00',2.5),('15128','2013-08-13','17:35:00',2.41),('15128','2013-08-13','17:40:00',2.32),('15128','2013-08-13','17:45:00',2.2),('15128','2013-08-13','17:50:00',2.02),('15128','2013-08-13','17:55:00',2.01),('15128','2013-08-13','18:00:00',1.88),('15128','2013-08-13','18:05:00',1.77),('15128','2013-08-13','18:10:00',1.69),('15128','2013-08-13','18:15:00',1.63),('15128','2013-08-13','18:20:00',1.58),('15128','2013-08-13','18:25:00',1.53),('15128','2013-08-13','18:30:00',1.49),('15128','2013-08-13','18:35:00',1.4),('15128','2013-08-13','18:40:00',1.25),('15128','2013-08-13','18:45:00',1.18),('15128','2013-08-13','18:50:00',1.16),('15128','2013-08-13','18:55:00',1.12),('15128','2013-08-13','19:00:00',1.1),('15128','2013-08-13','19:05:00',1.04),('15128','2013-08-12','08:30:00',1.04),('15128','2013-08-12','08:35:00',1.1),('15128','2013-08-12','08:40:00',1.15),('15128','2013-08-12','08:45:00',1.2),('15128','2013-08-12','08:50:00',1.28),('15128','2013-08-12','08:55:00',1.35),('15128','2013-08-12','09:00:00',1.42),('15128','2013-08-12','09:05:00',1.49),('15128','2013-08-12','09:10:00',1.56),('15128','2013-08-12','09:15:00',1.63),('15128','2013-08-12','09:20:00',1.7),('15128','2013-08-12','09:25:00',1.74),('15128','2013-08-12','09:30:00',1.78),('15128','2013-08-12','09:35:00',1.87),('15128','2013-08-12','09:40:00',1.92),('15128','2013-08-12','09:45:00',1.92),('15128','2013-08-12','09:50:00',1.99),('15128','2013-08-12','09:55:00',2.05),('15128','2013-08-12','10:00:00',2.27),('15128','2013-08-12','10:05:00',2.37),('15128','2013-08-12','10:10:00',2.43),('15128','2013-08-12','10:15:00',2.35),('15128','2013-08-12','10:20:00',2.5),('15128','2013-08-12','10:25:00',2.49),('15128','2013-08-12','10:30:00',2.81),('15128','2013-08-12','10:35:00',2.79),('15128','2013-08-12','10:40:00',1.64),('15128','2013-08-12','10:45:00',1.65),('15128','2013-08-12','10:50:00',2.28),('15128','2013-08-12','10:55:00',2.74),('15128','2013-08-12','11:00:00',2.84),('15128','2013-08-12','11:05:00',3.08),('15128','2013-08-12','11:10:00',1.69),('15128','2013-08-12','11:15:00',2.39),('15128','2013-08-12','11:20:00',3.01),('15128','2013-08-12','11:25:00',3.16),('15128','2013-08-12','11:30:00',3.11),('15128','2013-08-12','11:35:00',3.19),('15128','2013-08-12','11:40:00',3.26),('15128','2013-08-12','11:45:00',3.41),('15128','2013-08-12','11:50:00',3.53),('15128','2013-08-12','11:55:00',3.1),('15128','2013-08-12','12:00:00',2.93),('15128','2013-08-12','12:05:00',2.95),('15128','2013-08-12','12:10:00',3.18),('15128','2013-08-12','12:15:00',4.03),('15128','2013-08-12','12:20:00',1.4),('15128','2013-08-12','12:25:00',2.04),('15128','2013-08-12','12:30:00',4.3),('15128','2013-08-12','12:35:00',4.33),('15128','2013-08-12','12:40:00',4.38),('15128','2013-08-12','12:45:00',3.16),('15128','2013-08-12','12:50:00',2.94),('15128','2013-08-12','12:55:00',4.67),('15128','2013-08-12','13:00:00',4.48),('15128','2013-08-12','13:05:00',4.35),('15128','2013-08-12','13:10:00',4.09),('15128','2013-08-12','13:15:00',4.02),('15128','2013-08-12','13:20:00',4.05),('15128','2013-08-12','13:25:00',3.99),('15128','2013-08-12','13:30:00',4.06),('15128','2013-08-12','13:35:00',4.05),('15128','2013-08-12','13:40:00',3.98),('15128','2013-08-12','13:45:00',3.98),('15128','2013-08-12','13:50:00',3.92),('15128','2013-08-12','13:55:00',3.95),('15128','2013-08-12','14:00:00',4.02),('15128','2013-08-12','14:05:00',3.93),('15128','2013-08-12','14:10:00',4.05),('15128','2013-08-12','14:15:00',4.07),('15128','2013-08-12','14:20:00',4.04),('15128','2013-08-12','14:25:00',4.01),('15128','2013-08-12','14:30:00',4.09),('15128','2013-08-12','14:35:00',4.05),('15128','2013-08-12','14:40:00',4.07),('15128','2013-08-12','14:45:00',4.03),('15128','2013-08-12','14:50:00',4.01),('15128','2013-08-12','14:55:00',4.02),('15128','2013-08-12','15:00:00',3.98),('15128','2013-08-12','15:05:00',3.96),('15128','2013-08-12','15:10:00',3.96),('15128','2013-08-12','15:15:00',3.94),('15128','2013-08-12','15:20:00',3.88),('15128','2013-08-12','15:25:00',3.86),('15128','2013-08-12','15:30:00',3.86),('15128','2013-08-12','15:35:00',3.8),('15128','2013-08-12','15:40:00',3.79),('15128','2013-08-12','15:45:00',3.76),('15128','2013-08-12','15:50:00',3.73),('15128','2013-08-12','15:55:00',3.64),('15128','2013-08-12','16:00:00',3.6),('15128','2013-08-12','16:05:00',3.61),('15128','2013-08-12','16:10:00',3.54),('15128','2013-08-12','16:15:00',3.48),('15128','2013-08-12','16:20:00',3.43),('15128','2013-08-12','16:25:00',3.38),('15128','2013-08-12','16:30:00',3.32),('15128','2013-08-12','16:35:00',3.24),('15128','2013-08-12','16:40:00',3.19),('15128','2013-08-12','16:45:00',3.16),('15128','2013-08-12','16:50:00',3.11),('15128','2013-08-12','16:55:00',3.06),('15128','2013-08-12','17:00:00',3),('15128','2013-08-12','17:05:00',2.92),('15128','2013-08-12','17:10:00',2.84),('15128','2013-08-12','17:15:00',2.78),('15128','2013-08-12','17:20:00',2.7),('15128','2013-08-12','17:25:00',2.6),('15128','2013-08-12','17:30:00',2.49),('15128','2013-08-12','17:35:00',2.45),('15128','2013-08-12','17:40:00',2.34),('15128','2013-08-12','17:45:00',2.23),('15128','2013-08-12','17:50:00',2.07),('15128','2013-08-12','17:55:00',2.02),('15128','2013-08-12','18:00:00',1.91),('15128','2013-08-12','18:05:00',1.77),('15128','2013-08-12','18:10:00',1.69),('15128','2013-08-12','18:15:00',1.63),('15128','2013-08-12','18:20:00',1.59),('15128','2013-08-12','18:25:00',1.52),('15128','2013-08-12','18:30:00',1.43),('15128','2013-08-12','18:35:00',1.34),('15128','2013-08-12','18:40:00',1.24),('15128','2013-08-12','18:45:00',1.17),('15128','2013-08-12','18:50:00',1.08),('15128','2013-08-11','08:30:00',1.02),('15128','2013-08-11','08:35:00',1.07),('15128','2013-08-11','08:40:00',1.12),('15128','2013-08-11','08:45:00',1.18),('15128','2013-08-11','08:50:00',1.26),('15128','2013-08-11','08:55:00',1.33),('15128','2013-08-11','09:00:00',1.41),('15128','2013-08-11','09:05:00',1.48),('15128','2013-08-11','09:10:00',1.55),('15128','2013-08-11','09:15:00',1.62),('15128','2013-08-11','09:20:00',1.7),('15128','2013-08-11','09:25:00',1.75),('15128','2013-08-11','09:30:00',1.82),('15128','2013-08-11','09:35:00',1.9),('15128','2013-08-11','09:40:00',1.92),('15128','2013-08-11','09:45:00',1.92),('15128','2013-08-11','09:50:00',1.95),('15128','2013-08-11','09:55:00',1.99),('15128','2013-08-11','10:00:00',2.09),('15128','2013-08-11','10:05:00',2.14),('15128','2013-08-11','10:10:00',2.22),('15128','2013-08-11','10:15:00',2.28),('15128','2013-08-11','10:20:00',2.32),('15128','2013-08-11','10:25:00',2.36),('15128','2013-08-11','10:30:00',2.47),('15128','2013-08-11','10:35:00',2.47),('15128','2013-08-11','10:40:00',2.52),('15128','2013-08-11','10:45:00',2.54),('15128','2013-08-11','10:50:00',2.65),('15128','2013-08-11','10:55:00',2.77),('15128','2013-08-11','11:00:00',2.81),('15128','2013-08-11','11:05:00',2.9),('15128','2013-08-11','11:10:00',2.93),('15128','2013-08-11','11:15:00',2.98),('15128','2013-08-11','11:20:00',3.03),('15128','2013-08-11','11:25:00',3.09),('15128','2013-08-11','11:30:00',3.24),('15128','2013-08-11','11:35:00',3.29),('15128','2013-08-11','11:40:00',3.36),('15128','2013-08-11','11:45:00',3.21),('15128','2013-08-11','11:50:00',3.34),('15128','2013-08-11','11:55:00',2.19),('15128','2013-08-11','12:00:00',1.55),('15128','2013-08-11','12:05:00',1.21),('15128','2013-08-11','12:10:00',1.26),('15128','2013-08-11','12:15:00',1.73),('15128','2013-08-11','12:20:00',3.64),('15128','2013-08-11','12:25:00',4.07),('15128','2013-08-11','12:30:00',4.13),('15128','2013-08-11','12:35:00',4.24),('15128','2013-08-11','12:40:00',4.02),('15128','2013-08-11','12:45:00',4.12),('15128','2013-08-11','12:50:00',4.11),('15128','2013-08-11','12:55:00',2.26),('15128','2013-08-11','13:00:00',2.06),('15128','2013-08-11','13:05:00',1.95),('15128','2013-08-11','13:10:00',1.83),('15128','2013-08-11','13:15:00',1.89),('15128','2013-08-11','13:20:00',2.44),('15128','2013-08-11','13:25:00',1.62),('15128','2013-08-11','13:30:00',2.69),('15128','2013-08-11','13:35:00',3.09),('15128','2013-08-11','13:40:00',2.58),('15128','2013-08-11','13:45:00',2.13),('15128','2013-08-11','13:50:00',3.52),('15128','2013-08-11','13:55:00',4.41),('15128','2013-08-11','14:00:00',2.64),('15128','2013-08-11','14:05:00',3.59),('15128','2013-08-11','14:10:00',4.64),('15128','2013-08-11','14:15:00',3.39),('15128','2013-08-11','14:20:00',3.13),('15128','2013-08-11','14:25:00',3.59),('15128','2013-08-11','14:30:00',4.64),('15128','2013-08-11','14:35:00',4.58),('15128','2013-08-11','14:40:00',4.13),('15128','2013-08-11','14:45:00',4.12),('15128','2013-08-11','14:50:00',4.07),('15128','2013-08-11','14:55:00',4.06),('15128','2013-08-11','15:00:00',4.06),('15128','2013-08-11','15:05:00',3.95),('15128','2013-08-11','15:10:00',3.98),('15128','2013-08-11','15:15:00',3.89),('15128','2013-08-11','15:20:00',3.78),('15128','2013-08-11','15:25:00',3.91),('15128','2013-08-11','15:30:00',3.78),('15128','2013-08-11','15:35:00',3.81),('15128','2013-08-11','15:40:00',3.73),('15128','2013-08-11','15:45:00',3.19),('15128','2013-08-11','15:50:00',3.69),('15128','2013-08-11','15:55:00',3.58),('15128','2013-08-11','16:00:00',3.56),('15128','2013-08-11','16:05:00',3.53),('15128','2013-08-11','16:10:00',3.52),('15128','2013-08-11','16:15:00',3.47),('15128','2013-08-11','16:20:00',3.41),('15128','2013-08-11','16:25:00',3.38),('15128','2013-08-11','16:30:00',3.28),('15128','2013-08-11','16:35:00',3.2),('15128','2013-08-11','16:40:00',3.2),('15128','2013-08-11','16:45:00',3.18),('15128','2013-08-11','16:50:00',3.12),('15128','2013-08-11','16:55:00',3.05),('15128','2013-08-11','17:00:00',2.96),('15128','2013-08-11','17:05:00',2.86),('15128','2013-08-11','17:10:00',2.81),('15128','2013-08-11','17:15:00',2.75),('15128','2013-08-11','17:20:00',2.66),('15128','2013-08-11','17:25:00',2.57),('15128','2013-08-11','17:30:00',2.49),('15128','2013-08-11','17:35:00',2.38),('15128','2013-08-11','17:40:00',2.31),('15128','2013-08-11','17:45:00',2.21),('15128','2013-08-11','17:50:00',2.08),('15128','2013-08-11','17:55:00',1.96),('15128','2013-08-11','18:00:00',1.89),('15128','2013-08-11','18:05:00',1.78),('15128','2013-08-11','18:10:00',1.73),('15128','2013-08-11','18:15:00',1.65),('15128','2013-08-11','18:20:00',1.6),('15128','2013-08-11','18:25:00',1.55),('15128','2013-08-11','18:30:00',1.47),('15128','2013-08-11','18:35:00',1.4),('15128','2013-08-11','18:40:00',1.3),('15128','2013-08-11','18:45:00',1.22),('15128','2013-08-11','18:50:00',1.12),('15128','2013-08-11','18:55:00',1.01),('15128','2013-08-10','08:30:00',1.05),('15128','2013-08-10','08:35:00',1.1),('15128','2013-08-10','08:40:00',1.16),('15128','2013-08-10','08:45:00',1.23),('15128','2013-08-10','08:50:00',1.31),('15128','2013-08-10','08:55:00',1.39),('15128','2013-08-10','09:00:00',1.45),('15128','2013-08-10','09:05:00',1.52),('15128','2013-08-10','09:10:00',1.6),('15128','2013-08-10','09:15:00',1.66),('15128','2013-08-10','09:20:00',1.76),('15128','2013-08-10','09:25:00',1.82),('15128','2013-08-10','09:30:00',1.88),('15128','2013-08-10','09:35:00',1.92),('15128','2013-08-10','09:40:00',1.93),('15128','2013-08-10','09:45:00',1.96),('15128','2013-08-10','09:50:00',2.01),('15128','2013-08-10','09:55:00',2.07),('15128','2013-08-10','10:00:00',2.16),('15128','2013-08-10','10:05:00',2.22),('15128','2013-08-10','10:10:00',2.29),('15128','2013-08-10','10:15:00',2.34),('15128','2013-08-10','10:20:00',2.38),('15128','2013-08-10','10:25:00',2.51),('15128','2013-08-10','10:30:00',2.59),('15128','2013-08-10','10:35:00',2.65),('15128','2013-08-10','10:40:00',2.72),('15128','2013-08-10','10:45:00',2.73),('15128','2013-08-10','10:50:00',2.77),('15128','2013-08-10','10:55:00',2.74),('15128','2013-08-10','11:00:00',2.87),('15128','2013-08-10','11:05:00',2.97),('15128','2013-08-10','11:10:00',3.03),('15128','2013-08-10','11:15:00',3.07),('15128','2013-08-10','11:20:00',3.16),('15128','2013-08-10','11:25:00',3.2),('15128','2013-08-10','11:30:00',3.21),('15128','2013-08-10','11:35:00',3.27),('15128','2013-08-10','11:40:00',3.24),('15128','2013-08-10','11:45:00',3.27),('15128','2013-08-10','11:50:00',3.45),('15128','2013-08-10','11:55:00',3.54),('15128','2013-08-10','12:00:00',3.68),('15128','2013-08-10','12:05:00',3.72),('15128','2013-08-10','12:10:00',3.74),('15128','2013-08-10','12:15:00',3.77),('15128','2013-08-10','12:20:00',3.8),('15128','2013-08-10','12:25:00',3.81),('15128','2013-08-10','12:30:00',3.85),('15128','2013-08-10','12:35:00',3.88),('15128','2013-08-10','12:40:00',3.94),('15128','2013-08-10','12:45:00',3.95),('15128','2013-08-10','12:50:00',3.95),('15128','2013-08-10','12:55:00',3.97),('15128','2013-08-10','13:00:00',4),('15128','2013-08-10','13:05:00',4.02),('15128','2013-08-10','13:10:00',3.98),('15128','2013-08-10','13:15:00',3.99),('15128','2013-08-10','13:20:00',3.99),('15128','2013-08-10','13:25:00',3.98),('15128','2013-08-10','13:30:00',4.03),('15128','2013-08-10','13:35:00',4.08),('15128','2013-08-10','13:40:00',4.06),('15128','2013-08-10','13:45:00',4.06),('15128','2013-08-10','13:50:00',4.02),('15128','2013-08-10','13:55:00',4.03),('15128','2013-08-10','14:00:00',4.04),('15128','2013-08-10','14:05:00',4.04),('15128','2013-08-10','14:10:00',4.04),('15128','2013-08-10','14:15:00',4.06),('15128','2013-08-10','14:20:00',4.05),('15128','2013-08-10','14:25:00',4.02),('15128','2013-08-10','14:30:00',4),('15128','2013-08-10','14:35:00',4),('15128','2013-08-10','14:40:00',4),('15128','2013-08-10','14:45:00',3.97),('15128','2013-08-10','14:50:00',3.93),('15128','2013-08-10','14:55:00',3.89),('15128','2013-08-10','15:00:00',3.88),('15128','2013-08-10','15:05:00',3.88),('15128','2013-08-10','15:10:00',3.88),('15128','2013-08-10','15:15:00',3.85),('15128','2013-08-10','15:20:00',3.8),('15128','2013-08-10','15:25:00',3.71),('15128','2013-08-10','15:30:00',3.76),('15128','2013-08-10','15:35:00',3.76),('15128','2013-08-10','15:40:00',3.75),('15128','2013-08-10','15:45:00',3.72),('15128','2013-08-10','15:50:00',3.67),('15128','2013-08-10','15:55:00',3.66),('15128','2013-08-10','16:00:00',3.63),('15128','2013-08-10','16:05:00',3.57),('15128','2013-08-10','16:10:00',3.53),('15128','2013-08-10','16:15:00',3.48),('15128','2013-08-10','16:20:00',3.42),('15128','2013-08-10','16:25:00',3.36),('15128','2013-08-10','16:30:00',3.24),('15128','2013-08-10','16:35:00',3.21),('15128','2013-08-10','16:40:00',3.16),('15128','2013-08-10','16:45:00',3.1),('15128','2013-08-10','16:50:00',3.01),('15128','2013-08-10','16:55:00',2.98),('15128','2013-08-10','17:00:00',2.91),('15128','2013-08-10','17:05:00',2.87),('15128','2013-08-10','17:10:00',2.8),('15128','2013-08-10','17:15:00',2.73),('15128','2013-08-10','17:20:00',2.66),('15128','2013-08-10','17:25:00',2.59),('15128','2013-08-10','17:30:00',2.51),('15128','2013-08-10','17:35:00',2.43),('15128','2013-08-10','17:40:00',2.32),('15128','2013-08-10','17:45:00',2.21),('15128','2013-08-10','17:50:00',2.12),('15128','2013-08-10','17:55:00',1.99),('15128','2013-08-10','18:00:00',1.88),('15128','2013-08-10','18:05:00',1.77),('15128','2013-08-10','18:10:00',1.7),('15128','2013-08-10','18:15:00',1.61),('15128','2013-08-10','18:20:00',1.54),('15128','2013-08-10','18:25:00',1.49),('15128','2013-08-10','18:30:00',1.43),('15128','2013-08-10','18:35:00',1.36),('15128','2013-08-10','18:40:00',1.26),('15128','2013-08-10','18:45:00',1.16),('15128','2013-08-10','18:50:00',1.05),('15128','2013-08-09','08:25:00',1.01),('15128','2013-08-09','08:30:00',1.08),('15128','2013-08-09','08:35:00',1.14),('15128','2013-08-09','08:40:00',1.2),('15128','2013-08-09','08:45:00',1.27),('15128','2013-08-09','08:50:00',1.35),('15128','2013-08-09','08:55:00',1.42),('15128','2013-08-09','09:00:00',1.47),('15128','2013-08-09','09:05:00',1.53),('15128','2013-08-09','09:10:00',1.62),('15128','2013-08-09','09:15:00',1.69),('15128','2013-08-09','09:20:00',1.77),('15128','2013-08-09','09:25:00',1.85),('15128','2013-08-09','09:30:00',1.92),('15128','2013-08-09','09:35:00',1.95),('15128','2013-08-09','09:40:00',1.94),('15128','2013-08-09','09:45:00',2),('15128','2013-08-09','09:50:00',2),('15128','2013-08-09','09:55:00',2.06),('15128','2013-08-09','10:00:00',2.18),('15128','2013-08-09','10:05:00',2.23),('15128','2013-08-09','10:10:00',2.29),('15128','2013-08-09','10:15:00',2.36),('15128','2013-08-09','10:20:00',2.47),('15128','2013-08-09','10:25:00',2.55),('15128','2013-08-09','10:30:00',2.63),('15128','2013-08-09','10:35:00',2.66),('15128','2013-08-09','10:40:00',2.71),('15128','2013-08-09','10:45:00',2.74),('15128','2013-08-09','10:50:00',2.82),('15128','2013-08-09','10:55:00',2.87),('15128','2013-08-09','11:00:00',3.01),('15128','2013-08-09','11:05:00',3.05),('15128','2013-08-09','11:10:00',3.11),('15128','2013-08-09','11:15:00',3.14),('15128','2013-08-09','11:20:00',3.16),('15128','2013-08-09','11:25:00',3.2),('15128','2013-08-09','11:30:00',3.17),('15128','2013-08-09','11:35:00',3.21),('15128','2013-08-09','11:40:00',3.31),('15128','2013-08-09','11:45:00',3.3),('15128','2013-08-09','11:50:00',3.45),('15128','2013-08-09','11:55:00',3.61),('15128','2013-08-09','12:00:00',3.8),('15128','2013-08-09','12:05:00',3.77),('15128','2013-08-09','12:10:00',3.79),('15128','2013-08-09','12:15:00',3.82),('15128','2013-08-09','12:20:00',3.87),('15128','2013-08-09','12:25:00',3.84),('15128','2013-08-09','12:30:00',3.94),('15128','2013-08-09','12:35:00',4.06),('15128','2013-08-09','12:40:00',4.08),('15128','2013-08-09','12:45:00',4.4),('15128','2013-08-09','12:50:00',4.22),('15128','2013-08-09','12:55:00',3.85),('15128','2013-08-09','13:00:00',4.05),('15128','2013-08-09','13:05:00',4.03),('15128','2013-08-09','13:10:00',2.72),('15128','2013-08-09','13:15:00',3.82),('15128','2013-08-09','13:20:00',2.18),('15128','2013-08-09','13:30:00',4.41),('15128','2013-08-09','13:35:00',4.71),('15128','2013-08-09','13:40:00',2.49),('15128','2013-08-09','13:45:00',1.01),('15128','2013-08-09','13:50:00',2.07),('15128','2013-08-09','13:55:00',4.73),('15128','2013-08-09','14:00:00',4.08),('15128','2013-08-09','14:05:00',4.71),('15128','2013-08-09','14:10:00',3.13),('15128','2013-08-09','14:55:00',1.07),('15128','2013-08-09','15:15:00',1.08),('15128','2013-08-09','15:25:00',1.05),('15128','2013-08-09','15:30:00',1.2),('15128','2013-08-09','15:35:00',1.34),('15128','2013-08-09','15:40:00',1.73),('15128','2013-08-09','15:45:00',2.21),('15128','2013-08-09','15:50:00',2),('15128','2013-08-09','15:55:00',2.53),('15128','2013-08-09','16:00:00',1.86),('15128','2013-08-09','16:05:00',1.19),('15128','2013-08-09','16:10:00',1.07),('15128','2013-08-09','16:15:00',1.06),('15128','2013-08-09','16:20:00',1.73),('15128','2013-08-09','16:25:00',1.59),('15128','2013-08-09','16:30:00',1.52),('15128','2013-08-09','16:35:00',1.38),('15128','2013-08-09','16:40:00',1.09),('15128','2013-08-09','16:45:00',1.53),('15128','2013-08-09','16:50:00',2.76),('15128','2013-08-09','16:55:00',3.49),('15128','2013-08-09','17:00:00',2.45),('15128','2013-08-09','17:05:00',2.08),('15128','2013-08-09','17:10:00',1.16),('15128','2013-08-09','17:15:00',1.17),('15128','2013-08-09','17:20:00',1.18),('15128','2013-08-09','17:25:00',1.55),('15128','2013-08-09','17:30:00',1.07),('15128','2014-04-08','10:25:00',1.3),('15128','2014-04-08','10:40:00',1.66),('15128','2014-04-08','10:45:00',2.72),('15128','2014-04-08','10:50:00',2.92),('15128','2014-04-08','10:55:00',3.1),('15128','2014-04-08','11:00:00',3.26),('15128','2014-04-08','11:05:00',2.12),('15128','2014-04-08','11:10:00',2.01),('15128','2014-04-08','11:15:00',1.45),('15128','2014-04-08','11:20:00',1.38),('15128','2014-04-08','11:25:00',1.35),('15128','2014-04-08','11:30:00',2.48),('15128','2014-04-08','11:35:00',3.54),('15128','2014-04-08','11:40:00',2.06),('15128','2014-04-08','11:45:00',1.05),('15128','2014-04-08','11:50:00',1.11),('15128','2014-04-08','11:55:00',1.21),('15128','2014-04-08','12:00:00',1.52),('15128','2014-04-08','12:05:00',1.4),('15128','2014-04-08','12:10:00',1.17),('15128','2014-04-08','12:25:00',1.21),('15128','2014-04-08','12:30:00',1.08),('15128','2014-04-08','12:35:00',1.2),('15128','2014-04-08','12:40:00',1.23),('15128','2014-04-08','12:45:00',1.12),('15128','2014-04-08','13:10:00',1.03),('15128','2014-04-08','13:15:00',1.05),('15128','2014-04-08','13:20:00',1.19),('15128','2014-04-08','13:25:00',1.22),('15128','2014-04-08','13:30:00',1.28),('15128','2014-04-08','13:35:00',1.37),('15128','2014-04-08','13:40:00',1.66),('15128','2014-04-08','13:45:00',1.55),('15128','2014-04-08','13:50:00',1.43),('15128','2014-04-08','13:55:00',1.92),('15128','2014-04-08','14:00:00',1.62),('15128','2014-04-08','14:05:00',1.51),('15128','2014-04-08','14:10:00',1.82),('15128','2014-04-08','14:15:00',3.56),('15128','2014-04-08','14:20:00',2.97),('15128','2014-04-08','14:25:00',3.06),('15128','2014-04-08','14:30:00',2.18),('15128','2014-04-08','14:35:00',3.13),('15128','2014-04-08','14:40:00',4.19),('15128','2014-04-08','14:45:00',1.31),('15128','2014-04-08','14:50:00',1.25),('15128','2014-04-08','15:05:00',1.25),('15128','2014-04-08','15:30:00',1.08),('15128','2014-04-08','15:35:00',1.64),('15128','2014-04-08','15:40:00',3.71),('15128','2014-04-08','15:45:00',3.31),('15128','2014-04-08','15:50:00',3.51),('15128','2014-04-08','15:55:00',3.47),('15128','2014-04-08','16:00:00',3.39),('15128','2014-04-08','16:05:00',3.33),('15128','2014-04-08','16:10:00',3.3),('15128','2014-04-08','16:15:00',3.21),('15128','2014-04-08','16:20:00',3.1),('15128','2014-04-08','16:25:00',3.07),('15128','2014-04-08','16:30:00',2.94),('15128','2014-04-08','16:35:00',3),('15128','2014-04-08','16:40:00',2.95),('15128','2014-04-08','16:45:00',2.84),('15128','2014-04-08','16:50:00',2.86),('15128','2014-04-08','16:55:00',2.86),('15128','2014-04-08','17:00:00',1.65),('15128','2014-04-08','17:05:00',2.17),('15128','2014-04-08','17:10:00',2.37),('15128','2014-04-08','17:15:00',2.22),('15128','2014-04-08','17:20:00',1.97),('15128','2014-04-08','17:25:00',1.06),('15128','2014-04-08','17:30:00',1.81),('15128','2014-04-08','17:35:00',2.16),('15128','2014-04-08','17:40:00',1.74),('15128','2014-04-08','17:45:00',1.5),('15128','2014-04-08','17:50:00',1.52),('15128','2014-04-08','17:55:00',1.36),('15128','2014-04-08','18:00:00',1.29),('15128','2014-04-08','18:05:00',1.12),('15128','2014-04-08','18:10:00',1.09),('15128','2013-08-07','08:30:00',1),('15128','2013-08-07','08:35:00',1.06),('15128','2013-08-07','08:40:00',1.09),('15128','2013-08-07','08:45:00',1.15),('15128','2013-08-07','08:50:00',1.24),('15128','2013-08-07','08:55:00',1.3),('15128','2013-08-07','09:00:00',1.35),('15128','2013-08-07','09:05:00',1.41),('15128','2013-08-07','09:10:00',1.48),('15128','2013-08-07','09:15:00',1.55),('15128','2013-08-07','09:20:00',1.62),('15128','2013-08-07','09:25:00',1.69),('15128','2013-08-07','09:30:00',1.77),('15128','2013-08-07','09:35:00',1.79),('15128','2013-08-07','09:40:00',1.76),('15128','2013-08-07','09:45:00',1.78),('15128','2013-08-07','09:50:00',1.83),('15128','2013-08-07','09:55:00',1.9),('15128','2013-08-07','10:00:00',2.02),('15128','2013-08-07','10:05:00',2.06),('15128','2013-08-07','10:10:00',2.13),('15128','2013-08-07','10:15:00',2.21),('15128','2013-08-07','10:20:00',2.29),('15128','2013-08-07','10:25:00',2.35),('15128','2013-08-07','10:30:00',2.37),('15128','2013-08-07','10:35:00',2.41),('15128','2013-08-07','10:40:00',2.48),('15128','2013-08-07','10:45:00',2.53),('15128','2013-08-07','10:50:00',2.55),('15128','2013-08-07','11:05:00',1.05),('15128','2013-08-07','11:10:00',2.72),('15128','2013-08-07','11:15:00',2.87),('15128','2013-08-07','11:20:00',2.84),('15128','2013-08-07','11:25:00',2.22),('15128','2013-08-07','11:30:00',2.94),('15128','2013-08-07','11:35:00',3),('15128','2013-08-07','11:40:00',3.07),('15128','2013-08-06','08:30:00',1.03),('15128','2013-08-06','08:35:00',1.09),('15128','2013-08-06','08:40:00',1.12),('15128','2013-08-06','08:45:00',1.2),('15128','2013-08-06','08:50:00',1.29),('15128','2013-08-06','08:55:00',1.34),('15128','2013-08-06','09:00:00',1.39),('15128','2013-08-06','09:05:00',1.43),('15128','2013-08-06','09:10:00',1.49),('15128','2013-08-06','09:15:00',1.57),('15128','2013-08-06','09:20:00',1.65),('15128','2013-08-06','09:25:00',1.73),('15128','2013-08-06','09:30:00',1.81),('15128','2013-08-06','09:35:00',1.84),('15128','2013-08-06','09:40:00',1.77),('15128','2013-08-06','09:45:00',1.81),('15128','2013-08-06','09:50:00',1.84),('15128','2013-08-06','09:55:00',1.92),('15128','2013-08-06','10:00:00',2.03),('15128','2013-08-06','10:05:00',2.1),('15128','2013-08-06','10:10:00',2.16),('15128','2013-08-06','10:15:00',2.25),('15128','2013-08-06','10:20:00',2.3),('15128','2013-08-06','10:25:00',2.4),('15128','2013-08-06','10:30:00',2.42),('15128','2013-08-06','10:35:00',2.43),('15128','2013-08-06','10:40:00',2.51),('15128','2013-08-06','10:45:00',2.53),('15128','2013-08-06','10:50:00',2.58),('15128','2013-08-06','10:55:00',2.67),('15128','2013-08-06','11:00:00',2.69),('15128','2013-08-06','11:05:00',2.81),('15128','2013-08-06','11:10:00',2.8),('15128','2013-08-06','11:15:00',2.94),('15128','2013-08-06','11:20:00',2.89),('15128','2013-08-06','11:25:00',3.01),('15128','2013-08-06','11:30:00',3.04),('15128','2013-08-06','11:35:00',3.02),('15128','2013-08-06','11:40:00',3.09),('15128','2013-08-06','11:45:00',3.14),('15128','2013-08-06','11:50:00',3.27),('15128','2013-08-06','11:55:00',3.36),('15128','2013-08-06','12:00:00',3.5),('15128','2013-08-06','12:05:00',3.54),('15128','2013-08-06','12:10:00',3.57),('15128','2013-08-06','12:15:00',3.57),('15128','2013-08-06','12:20:00',3.61),('15128','2013-08-06','12:25:00',3.59),('15128','2013-08-06','12:30:00',3.5),('15128','2013-08-06','12:35:00',3.73),('15128','2013-08-06','12:40:00',3.81),('15128','2013-08-06','12:45:00',3.81),('15128','2013-08-06','12:50:00',3.8),('15128','2013-08-06','12:55:00',3.84),('15128','2013-08-06','13:00:00',3.89),('15128','2013-08-06','13:05:00',3.9),('15128','2013-08-06','13:10:00',3.9),('15128','2013-08-06','13:15:00',3.9),('15128','2013-08-06','13:20:00',3.93),('15128','2013-08-06','13:25:00',4),('15128','2013-08-06','13:30:00',3.95),('15128','2013-08-06','13:35:00',3.99),('15128','2013-08-06','13:40:00',4),('15128','2013-08-06','13:45:00',4.01),('15128','2013-08-06','13:50:00',3.94),('15128','2013-08-06','13:55:00',3.96),('15128','2013-08-06','14:00:00',3.96),('15128','2013-08-06','14:05:00',3.96),('15128','2013-08-06','14:10:00',3.96),('15128','2013-08-06','14:15:00',4),('15128','2013-08-06','14:20:00',3.99),('15128','2013-08-06','14:25:00',3.99),('15128','2013-08-06','14:30:00',4),('15128','2013-08-06','14:35:00',4.01),('15128','2013-08-06','14:40:00',3.99),('15128','2013-08-06','14:45:00',3.96),('15128','2013-08-06','14:50:00',3.95),('15128','2013-08-06','14:55:00',3.92),('15128','2013-08-06','15:00:00',3.91),('15128','2013-08-06','15:05:00',3.89),('15128','2013-08-06','15:10:00',3.87),('15128','2013-08-06','15:15:00',3.86),('15128','2013-08-06','15:20:00',3.81),('15128','2013-08-06','15:25:00',3.77),('15128','2013-08-06','15:30:00',3.74),('15128','2013-08-06','15:35:00',3.71),('15128','2013-08-06','15:40:00',3.68),('15128','2013-08-06','15:45:00',3.64),('15128','2013-08-06','15:50:00',3.6),('15128','2013-08-06','15:55:00',3.56),('15128','2013-08-06','16:00:00',3.53),('15128','2013-08-06','16:05:00',3.49),('15128','2013-08-06','16:10:00',3.45),('15128','2013-08-06','16:15:00',3.4),('15128','2013-08-06','16:20:00',3.34),('15128','2013-08-06','16:25:00',3.28),('15128','2013-08-06','16:30:00',3.23),('15128','2013-08-06','16:35:00',3.17),('15128','2013-08-06','16:40:00',3.12),('15128','2013-08-06','16:45:00',3.08),('15128','2013-08-06','16:50:00',3.03),('15128','2013-08-06','16:55:00',2.97),('15128','2013-08-06','17:00:00',2.91),('15128','2013-08-06','17:05:00',2.84),('15128','2013-08-06','17:10:00',2.76),('15128','2013-08-06','17:15:00',2.7),('15128','2013-08-06','17:20:00',2.62),('15128','2013-08-06','17:25:00',2.54),('15128','2013-08-06','17:30:00',2.46),('15128','2013-08-06','17:35:00',2.38),('15128','2013-08-06','17:40:00',2.26),('15128','2013-08-06','17:45:00',2.21),('15128','2013-08-06','17:50:00',2.12),('15128','2013-08-06','17:55:00',2),('15128','2013-08-06','18:00:00',1.85),('15128','2013-08-06','18:05:00',1.77),('15128','2013-08-06','18:10:00',1.67),('15128','2013-08-06','18:15:00',1.58),('15128','2013-08-06','18:20:00',1.51),('15128','2013-08-06','18:25:00',1.45),('15128','2013-08-06','18:30:00',1.41),('15128','2013-08-06','18:35:00',1.32),('15128','2013-08-05','08:30:00',1.02),('15128','2013-08-05','08:35:00',1.07),('15128','2013-08-05','08:40:00',1.1),('15128','2013-08-05','08:45:00',1.18),('15128','2013-08-05','08:50:00',1.24),('15128','2013-08-05','08:55:00',1.31),('15128','2013-08-05','09:00:00',1.36),('15128','2013-08-05','09:05:00',1.43),('15128','2013-08-05','09:10:00',1.49),('15128','2013-08-05','09:15:00',1.58),('15128','2013-08-05','09:20:00',1.67),('15128','2013-08-05','09:25:00',1.74),('15128','2013-08-05','09:30:00',1.81),('15128','2013-08-05','09:35:00',1.82),('15128','2013-08-05','09:40:00',1.77),('15128','2013-08-05','09:45:00',1.81),('15128','2013-08-05','09:50:00',1.91),('15128','2013-08-05','09:55:00',1.93),('15128','2013-08-05','10:00:00',2.05),('15128','2013-08-05','10:05:00',2.11),('15128','2013-08-05','10:10:00',2.19),('15128','2013-08-05','10:15:00',2.25),('15128','2013-08-05','10:20:00',2.31),('15128','2013-08-05','10:25:00',2.38),('15128','2013-08-05','10:30:00',2.41),('15128','2013-08-05','10:35:00',2.46),('15128','2013-08-05','10:40:00',2.54),('15128','2013-08-05','10:45:00',2.58),('15128','2013-08-05','10:50:00',2.62),('15128','2013-08-05','10:55:00',2.73),('15128','2013-08-05','11:00:00',2.76),('15128','2013-08-05','11:05:00',2.88),('15128','2013-08-05','11:10:00',2.85),('15128','2013-08-05','11:15:00',2.95),('15128','2013-08-05','11:20:00',2.92),('15128','2013-08-05','11:25:00',3.03),('15128','2013-08-05','11:30:00',3.04),('15128','2013-08-05','11:35:00',3.05),('15128','2013-08-05','11:40:00',3.16),('15128','2013-08-05','11:45:00',3.2),('15128','2013-08-05','11:50:00',3.33),('15128','2013-08-05','11:55:00',3.48),('15128','2013-08-05','12:00:00',3.54),('15128','2013-08-05','12:05:00',3.58),('15128','2013-08-05','12:10:00',3.53),('15128','2013-08-05','12:15:00',3.6),('15128','2013-08-05','12:20:00',3.62),('15128','2013-08-05','12:25:00',3.62),('15128','2013-08-05','12:30:00',3.64),('15128','2013-08-05','12:35:00',3.7),('15128','2013-08-05','12:40:00',3.7),('15128','2013-08-05','12:45:00',3.76),('15128','2013-08-05','12:50:00',3.8),('15128','2013-08-05','12:55:00',3.86),('15128','2013-08-05','13:00:00',3.86),('15128','2013-08-05','13:05:00',3.86),('15128','2013-08-05','13:10:00',3.9),('15128','2013-08-05','13:15:00',3.94),('15128','2013-08-05','13:20:00',3.95),('15128','2013-08-05','13:25:00',3.99),('15128','2013-08-05','13:30:00',4),('15128','2013-08-05','13:35:00',4.03),('15128','2013-08-05','13:40:00',4.03),('15128','2013-08-05','13:45:00',4.04),('15128','2013-08-05','13:50:00',4.04),('15128','2013-08-05','13:55:00',4.06),('15128','2013-08-05','14:00:00',4.08),('15128','2013-08-05','14:05:00',4.07),('15128','2013-08-05','14:10:00',4.07),('15128','2013-08-05','14:15:00',4.07),('15128','2013-08-05','14:20:00',4.07),('15128','2013-08-05','14:25:00',4.06),('15128','2013-08-05','14:30:00',4.04),('15128','2013-08-05','14:35:00',4.03),('15128','2013-08-05','14:40:00',4.03),('15128','2013-08-05','14:45:00',4.01),('15128','2013-08-05','14:50:00',4.01),('15128','2013-08-05','14:55:00',3.98),('15128','2013-08-05','15:00:00',3.95),('15128','2013-08-05','15:05:00',3.95),('15128','2013-08-05','15:10:00',3.92),('15128','2013-08-05','15:15:00',3.9),('15128','2013-08-05','15:20:00',3.87),('15128','2013-08-05','15:25:00',3.83),('15128','2013-08-05','15:30:00',3.8),('15128','2013-08-05','15:35:00',3.77),('15128','2013-08-05','15:40:00',3.72),('15128','2013-08-05','15:45:00',3.68),('15128','2013-08-05','15:50:00',3.64),('15128','2013-08-05','15:55:00',3.61),('15128','2013-08-05','16:00:00',3.57),('15128','2013-08-05','16:05:00',3.52),('15128','2013-08-05','16:10:00',3.48),('15128','2013-08-05','16:15:00',3.41),('15128','2013-08-05','16:20:00',3.39),('15128','2013-08-05','16:25:00',3.33),('15128','2013-08-05','16:30:00',3.27),('15128','2013-08-05','16:35:00',3.22),('15128','2013-08-05','16:40:00',3.16),('15128','2013-08-05','16:45:00',3.12),('15128','2013-08-05','16:50:00',3.09),('15128','2013-08-05','16:55:00',3.02),('15128','2013-08-05','17:00:00',2.97),('15128','2013-08-05','17:05:00',2.89),('15128','2013-08-05','17:10:00',2.82),('15128','2013-08-05','17:15:00',2.74),('15128','2013-08-05','17:20:00',2.66),('15128','2013-08-05','17:25:00',2.58),('15128','2013-08-05','17:30:00',2.5),('15128','2013-08-05','17:35:00',2.42),('15128','2013-08-05','17:40:00',2.26),('15128','2013-08-05','17:45:00',2.22),('15128','2013-08-05','17:50:00',2.13),('15128','2013-08-05','17:55:00',2.01),('15128','2013-08-05','18:00:00',1.87),('15128','2013-08-05','18:05:00',1.77),('15128','2013-08-05','18:10:00',1.69),('15128','2013-08-05','18:15:00',1.62),('15128','2013-08-05','18:20:00',1.57),('15128','2013-08-05','18:25:00',1.49),('15128','2013-08-05','18:30:00',1.44),('15128','2013-08-05','18:35:00',1.36),('15128','2013-08-05','18:40:00',1.3),('15128','2013-08-05','18:45:00',1.19),('15128','2013-08-05','18:50:00',1.08),('15128','2013-08-04','08:30:00',1.04),('15128','2013-08-04','08:35:00',1.08),('15128','2013-08-04','08:40:00',1.14),('15128','2013-08-04','08:45:00',1.22),('15128','2013-08-04','08:50:00',1.29),('15128','2013-08-04','08:55:00',1.33),('15128','2013-08-04','09:00:00',1.4),('15128','2013-08-04','09:05:00',1.46),('15128','2013-08-04','09:10:00',1.54),('15128','2013-08-04','09:15:00',1.64),('15128','2013-08-04','09:20:00',1.7),('15128','2013-08-04','09:25:00',1.79),('15128','2013-08-04','09:30:00',1.85),('15128','2013-08-04','09:35:00',1.87),('15128','2013-08-04','09:40:00',1.89),('15128','2013-08-04','09:45:00',1.94),('15128','2013-08-04','09:50:00',1.95),('15128','2013-08-04','09:55:00',1.94),('15128','2013-08-04','10:00:00',2.05),('15128','2013-08-04','10:05:00',2.12),('15128','2013-08-04','10:10:00',2.21),('15128','2013-08-04','10:15:00',2.3),('15128','2013-08-04','10:20:00',2.38),('15128','2013-08-04','10:25:00',2.49),('15128','2013-08-04','10:30:00',2.55),('15128','2013-08-04','10:35:00',2.6),('15128','2013-08-04','10:40:00',2.63),('15128','2013-08-04','10:45:00',2.69),('15128','2013-08-04','10:50:00',2.73),('15128','2013-08-04','10:55:00',2.8),('15128','2013-08-04','11:00:00',2.83),('15128','2013-08-04','11:05:00',2.91),('15128','2013-08-04','11:10:00',2.9),('15128','2013-08-04','11:15:00',3.02),('15128','2013-08-04','11:20:00',3.01),('15128','2013-08-04','11:25:00',3.13),('15128','2013-08-04','11:30:00',3.11),('15128','2013-08-04','11:35:00',3.2),('15128','2013-08-04','11:40:00',3.27),('15128','2013-08-04','11:45:00',3.27),('15128','2013-08-04','11:50:00',3.41),('15128','2013-08-04','11:55:00',3.56),('15128','2013-08-04','12:00:00',3.58),('15128','2013-08-04','12:05:00',3.66),('15128','2013-08-04','12:10:00',3.67),('15128','2013-08-04','12:15:00',3.71),('15128','2013-08-04','12:20:00',3.72),('15128','2013-08-04','12:25:00',3.73),('15128','2013-08-04','12:30:00',3.78),('15128','2013-08-04','12:35:00',3.82),('15128','2013-08-04','12:40:00',3.81),('15128','2013-08-04','12:45:00',3.84),('15128','2013-08-04','12:50:00',3.87),('15128','2013-08-04','12:55:00',3.87),('15128','2013-08-04','13:00:00',3.89),('15128','2013-08-04','13:05:00',3.91),('15128','2013-08-04','13:10:00',3.96),('15128','2013-08-04','13:15:00',3.97),('15128','2013-08-04','13:20:00',3.98),('15128','2013-08-04','13:25:00',3.97),('15128','2013-08-04','13:30:00',3.96),('15128','2013-08-04','13:35:00',3.97),('15128','2013-08-04','13:40:00',3.99),('15128','2013-08-04','13:45:00',3.97),('15128','2013-08-04','13:50:00',3.96),('15128','2013-08-04','13:55:00',3.98),('15128','2013-08-04','14:00:00',4),('15128','2013-08-04','14:05:00',4),('15128','2013-08-04','14:10:00',3.99),('15128','2013-08-04','14:15:00',3.97),('15128','2013-08-04','14:20:00',3.98),('15128','2013-08-04','14:25:00',3.99),('15128','2013-08-04','14:30:00',4),('15128','2013-08-04','14:35:00',3.97),('15128','2013-08-04','14:40:00',3.96),('15128','2013-08-04','14:45:00',3.95),('15128','2013-08-04','14:50:00',3.93),('15128','2013-08-04','14:55:00',3.9),('15128','2013-08-04','15:00:00',3.89),('15128','2013-08-04','15:05:00',3.86),('15128','2013-08-04','15:10:00',3.85),('15128','2013-08-04','15:15:00',3.8),('15128','2013-08-04','15:20:00',3.79),('15128','2013-08-04','15:25:00',3.78),('15128','2013-08-04','15:30:00',3.78),('15128','2013-08-04','15:35:00',3.73),('15128','2013-08-04','15:40:00',3.71),('15128','2013-08-04','15:45:00',3.67),('15128','2013-08-04','15:50:00',3.63),('15128','2013-08-04','15:55:00',3.59),('15128','2013-08-04','16:00:00',3.55),('15128','2013-08-04','16:05:00',3.5),('15128','2013-08-04','16:10:00',3.47),('15128','2013-08-04','16:15:00',3.43),('15128','2013-08-04','16:20:00',3.38),('15128','2013-08-04','16:25:00',3.32),('15128','2013-08-04','16:30:00',3.26),('15128','2013-08-04','16:35:00',3.19),('15128','2013-08-04','16:40:00',3.16),('15128','2013-08-04','16:45:00',3.11),('15128','2013-08-04','16:50:00',3.06),('15128','2013-08-04','16:55:00',3),('15128','2013-08-04','17:00:00',2.92),('15128','2013-08-04','17:05:00',2.84),('15128','2013-08-04','17:10:00',2.76),('15128','2013-08-04','17:15:00',2.71),('15128','2013-08-04','17:20:00',2.65),('15128','2013-08-04','17:25:00',2.56),('15128','2013-08-04','17:30:00',2.45),('15128','2013-08-04','17:35:00',2.38),('15128','2013-08-04','17:40:00',2.27),('15128','2013-08-04','17:45:00',2.18),('15128','2013-08-04','17:50:00',2.1),('15128','2013-08-04','17:55:00',1.96),('15128','2013-08-04','18:00:00',1.84),('15128','2013-08-04','18:05:00',1.76),('15128','2013-08-04','18:10:00',1.67),('15128','2013-08-04','18:15:00',1.57),('15128','2013-08-04','18:20:00',1.52),('15128','2013-08-04','18:25:00',1.49),('15128','2013-08-04','18:30:00',1.44),('15128','2013-08-04','18:35:00',1.36),('15128','2013-08-04','18:40:00',1.29),('15128','2013-08-04','18:45:00',1.2),('15128','2013-08-04','18:50:00',1.1),('15128','2013-08-03','08:25:00',1),('15128','2013-08-03','08:30:00',1.08),('15128','2013-08-03','08:35:00',1.13),('15128','2013-08-03','08:40:00',1.19),('15128','2013-08-03','08:45:00',1.28),('15128','2013-08-03','08:50:00',1.36),('15128','2013-08-03','08:55:00',1.42),('15128','2013-08-03','09:00:00',1.47),('15128','2013-08-03','09:05:00',1.55),('15128','2013-08-03','09:10:00',1.6),('15128','2013-08-03','09:15:00',1.72),('15128','2013-08-03','09:20:00',1.8),('15128','2013-08-03','09:25:00',1.86),('15128','2013-08-03','09:30:00',1.95),('15128','2013-08-03','09:35:00',1.94),('15128','2013-08-03','09:40:00',1.95),('15128','2013-08-03','09:45:00',1.98),('15128','2013-08-03','09:50:00',1.97),('15128','2013-08-03','09:55:00',1.95),('15128','2013-08-03','10:00:00',2.1),('15128','2013-08-03','10:05:00',2.16),('15128','2013-08-03','10:10:00',2.24),('15128','2013-08-03','10:15:00',2.33),('15128','2013-08-03','10:20:00',2.44),('15128','2013-08-03','10:25:00',2.51),('15128','2013-08-03','10:30:00',2.49),('15128','2013-08-03','10:35:00',2.54),('15128','2013-08-03','10:40:00',2.63),('15128','2013-08-03','10:45:00',2.65),('15128','2013-08-03','10:50:00',2.71),('15128','2013-08-03','10:55:00',2.78),('15128','2013-08-03','11:00:00',2.82),('15128','2013-08-03','11:05:00',2.97),('15128','2013-08-03','11:10:00',2.97),('15128','2013-08-03','11:15:00',3.09),('15128','2013-08-03','11:20:00',3.08),('15128','2013-08-03','11:25:00',3.17),('15128','2013-08-03','11:30:00',3.17),('15128','2013-08-03','11:35:00',3.21),('15128','2013-08-03','11:40:00',3.32),('15128','2013-08-03','11:45:00',3.34),('15128','2013-08-03','11:50:00',3.55),('15128','2013-08-03','11:55:00',3.64),('15128','2013-08-03','12:00:00',3.71),('15128','2013-08-03','12:05:00',3.71),('15128','2013-08-03','12:10:00',3.7),('15128','2013-08-03','12:15:00',3.7),('15128','2013-08-03','12:20:00',3.74),('15128','2013-08-03','12:25:00',3.81),('15128','2013-08-03','12:30:00',3.82),('15128','2013-08-03','12:35:00',3.87),('15128','2013-08-03','12:40:00',3.89),('15128','2013-08-03','12:45:00',3.93),('15128','2013-08-03','12:50:00',3.93),('15128','2013-08-03','12:55:00',3.95),('15128','2013-08-03','13:00:00',4),('15128','2013-08-03','13:05:00',4.01),('15128','2013-08-03','13:10:00',4.04),('15128','2013-08-03','13:15:00',4.05),('15128','2013-08-03','13:20:00',4.08),('15128','2013-08-03','13:25:00',4.07),('15128','2013-08-03','13:30:00',4.09),('15128','2013-08-03','13:35:00',4.11),('15128','2013-08-03','13:40:00',4.12),('15128','2013-08-03','13:45:00',4.14),('15128','2013-08-03','13:50:00',4.12),('15128','2013-08-03','13:55:00',4.14),('15128','2013-08-03','14:00:00',4.14),('15128','2013-08-03','14:05:00',4.14),('15128','2013-08-03','14:10:00',4.12),('15128','2013-08-03','14:15:00',4.1),('15128','2013-08-03','14:20:00',4.11),('15128','2013-08-03','14:25:00',4.11),('15128','2013-08-03','14:30:00',4.12),('15128','2013-08-03','14:35:00',4.1),('15128','2013-08-03','14:40:00',4.04),('15128','2013-08-03','14:45:00',4.02),('15128','2013-08-03','14:50:00',3.95),('15128','2013-08-03','14:55:00',4),('15128','2013-08-03','15:00:00',4.03),('15128','2013-08-03','15:05:00',4.03),('15128','2013-08-03','15:10:00',3.99),('15128','2013-08-03','15:15:00',3.94),('15128','2013-08-03','15:20:00',3.95),('15128','2013-08-03','15:25:00',3.93),('15128','2013-08-03','15:30:00',3.91),('15128','2013-08-03','15:35:00',3.92),('15128','2013-08-03','15:40:00',3.83),('15128','2013-08-03','15:45:00',3.82),('15128','2013-08-03','15:50:00',3.79),('15128','2013-08-03','15:55:00',3.75),('15128','2013-08-03','16:00:00',3.71),('15128','2013-08-03','16:05:00',3.67),('15128','2013-08-03','16:10:00',3.63),('15128','2013-08-03','16:15:00',3.56),('15128','2013-08-03','16:20:00',3.5),('15128','2013-08-03','16:25:00',3.45),('15128','2013-08-03','16:30:00',3.42),('15128','2013-08-03','16:35:00',3.35),('15128','2013-08-03','16:40:00',3.31),('15128','2013-08-03','16:45:00',3.24),('15128','2013-08-03','16:50:00',3.16),('15128','2013-08-03','16:55:00',3.1),('15128','2013-08-03','17:00:00',3.04),('15128','2013-08-03','17:05:00',2.95),('15128','2013-08-03','17:10:00',2.88),('15128','2013-08-03','17:15:00',2.78),('15128','2013-08-03','17:20:00',2.69),('15128','2013-08-03','17:25:00',2.65),('15128','2013-08-03','17:30:00',2.46),('15128','2013-08-03','17:35:00',2.42),('15128','2013-08-03','17:40:00',2.34),('15128','2013-08-03','17:45:00',2.21),('15128','2013-08-03','17:50:00',2.12),('15128','2013-08-03','17:55:00',1.97),('15128','2013-08-03','18:00:00',1.89),('15128','2013-08-03','18:05:00',1.83),('15128','2013-08-03','18:10:00',1.72),('15128','2013-08-03','18:15:00',1.65),('15128','2013-08-03','18:20:00',1.54),('15128','2013-08-03','18:25:00',1.52),('15128','2013-08-03','18:30:00',1.45),('15128','2013-08-03','18:35:00',1.4),('15128','2013-08-03','18:40:00',1.3),('15128','2013-08-03','18:45:00',1.19),('15128','2013-08-03','18:50:00',1.09),('15128','2013-08-02','08:30:00',1.07),('15128','2013-08-02','08:35:00',1.12),('15128','2013-08-02','08:40:00',1.2),('15128','2013-08-02','08:45:00',1.28),('15128','2013-08-02','08:50:00',1.34),('15128','2013-08-02','08:55:00',1.42),('15128','2013-08-02','09:00:00',1.49),('15128','2013-08-02','09:05:00',1.55),('15128','2013-08-02','09:10:00',1.62),('15128','2013-08-02','09:15:00',1.72),('15128','2013-08-02','09:20:00',1.8),('15128','2013-08-02','09:25:00',1.86),('15128','2013-08-02','09:30:00',1.94),('15128','2013-08-02','09:35:00',1.97),('15128','2013-08-02','09:40:00',1.99),('15128','2013-08-02','09:45:00',2),('15128','2013-08-02','09:50:00',2.08),('15128','2013-08-02','09:55:00',2.11),('15128','2013-08-02','10:00:00',2.13),('15128','2013-08-02','10:05:00',2.19),('15128','2013-08-02','10:10:00',2.26),('15128','2013-08-02','10:15:00',2.37),('15128','2013-08-02','10:20:00',2.46),('15128','2013-08-02','10:25:00',2.51),('15128','2013-08-02','10:30:00',2.54),('15128','2013-08-02','10:35:00',2.56),('15128','2013-08-02','10:40:00',2.67),('15128','2013-08-02','10:45:00',2.7),('15128','2013-08-02','10:50:00',2.74),('15128','2013-08-02','10:55:00',2.84),('15128','2013-08-02','11:00:00',2.88),('15128','2013-08-02','11:05:00',2.98),('15128','2013-08-02','11:10:00',3),('15128','2013-08-02','11:15:00',3.11),('15128','2013-08-02','11:20:00',3.11),('15128','2013-08-02','11:25:00',3.21),('15128','2013-08-02','11:30:00',3.15),('15128','2013-08-02','11:35:00',3.2),('15128','2013-08-02','11:40:00',3.3),('15128','2013-08-02','11:45:00',3.33),('15128','2013-08-02','11:50:00',3.44),('15128','2013-08-02','11:55:00',3.57),('15128','2013-08-02','12:00:00',3.64),('15128','2013-08-02','12:05:00',3.66),('15128','2013-08-02','12:10:00',3.7),('15128','2013-08-02','12:15:00',3.75),('15128','2013-08-02','12:20:00',3.76),('15128','2013-08-02','12:25:00',3.76),('15128','2013-08-02','12:30:00',3.81),('15128','2013-08-02','12:35:00',3.87),('15128','2013-08-02','12:40:00',3.91),('15128','2013-08-02','12:45:00',3.93),('15128','2013-08-02','12:50:00',3.93),('15128','2013-08-02','12:55:00',3.96),('15128','2013-08-02','13:00:00',3.98),('15128','2013-08-02','13:05:00',3.99),('15128','2013-08-02','13:10:00',4.01),('15128','2013-08-02','13:15:00',4),('15128','2013-08-02','13:20:00',4.03),('15128','2013-08-02','13:25:00',4.03),('15128','2013-08-02','13:30:00',4.04),('15128','2013-08-02','13:35:00',4.04),('15128','2013-08-02','13:40:00',4.04),('15128','2013-08-02','13:45:00',4.03),('15128','2013-08-02','13:50:00',4.04),('15128','2013-08-02','13:55:00',4.02),('15128','2013-08-02','14:00:00',4.01),('15128','2013-08-02','14:05:00',4.09),('15128','2013-08-02','14:10:00',4.14),('15128','2013-08-02','14:15:00',4.15),('15128','2013-08-02','14:20:00',4.13),('15128','2013-08-02','14:25:00',4.11),('15128','2013-08-02','14:30:00',4.11),('15128','2013-08-02','14:35:00',4.1),('15128','2013-08-02','14:40:00',4.11),('15128','2013-08-02','14:45:00',4.1),('15128','2013-08-02','14:50:00',4.06),('15128','2013-08-02','14:55:00',4.04),('15128','2013-08-02','15:00:00',4.01),('15128','2013-08-02','15:05:00',4),('15128','2013-08-02','15:10:00',3.99),('15128','2013-08-02','15:15:00',3.99),('15128','2013-08-02','15:20:00',3.92),('15128','2013-08-02','15:25:00',3.9),('15128','2013-08-02','15:30:00',3.87),('15128','2013-08-02','15:35:00',3.84),('15128','2013-08-02','15:40:00',3.82),('15128','2013-08-02','15:45:00',3.79),('15128','2013-08-02','15:50:00',3.76),('15128','2013-08-02','15:55:00',3.74),('15128','2013-08-02','16:00:00',3.69),('15128','2013-08-02','16:05:00',3.66),('15128','2013-08-02','16:10:00',3.62),('15128','2013-08-02','16:15:00',3.56),('15128','2013-08-02','16:20:00',3.48),('15128','2013-08-02','16:25:00',3.44),('15128','2013-08-02','16:30:00',3.39),('15128','2013-08-02','16:35:00',3.33),('15128','2013-08-02','16:40:00',3.29),('15128','2013-08-02','16:45:00',3.23),('15128','2013-08-02','16:50:00',3.16),('15128','2013-08-02','16:55:00',3.11),('15128','2013-08-02','17:00:00',3.05),('15128','2013-08-02','17:05:00',2.99),('15128','2013-08-02','17:10:00',2.94),('15128','2013-08-02','17:15:00',2.86),('15128','2013-08-02','17:20:00',2.78),('15128','2013-08-02','17:25:00',2.72),('15128','2013-08-02','17:30:00',2.65),('15128','2013-08-02','17:35:00',2.57),('15128','2013-08-02','17:40:00',2.49),('15128','2013-08-02','17:45:00',2.38),('15128','2013-08-02','17:50:00',2.26),('15128','2013-08-02','17:55:00',2.13),('15128','2013-08-02','18:00:00',1.97),('15128','2013-08-02','18:05:00',1.93),('15128','2013-08-02','18:10:00',1.86),('15128','2013-08-02','18:15:00',1.75),('15128','2013-08-02','18:20:00',1.67),('15128','2013-08-02','18:25:00',1.63),('15128','2013-08-02','18:30:00',1.57),('15128','2013-08-02','18:35:00',1.51),('15128','2013-08-02','18:40:00',1.42),('15128','2013-08-02','18:45:00',1.34),('15128','2013-08-02','18:50:00',1.23),('15128','2013-08-02','18:55:00',1.13),('15128','2013-08-02','19:00:00',1.04),('15128','2013-08-01','08:25:00',1.05),('15128','2013-08-01','08:30:00',1.11),('15128','2013-08-01','08:35:00',1.17),('15128','2013-08-01','08:40:00',1.25),('15128','2013-08-01','08:45:00',1.34),('15128','2013-08-01','08:50:00',1.41),('15128','2013-08-01','08:55:00',1.47),('15128','2013-08-01','09:00:00',1.54),('15128','2013-08-01','09:05:00',1.61),('15128','2013-08-01','09:10:00',1.69),('15128','2013-08-01','09:15:00',1.8),('15128','2013-08-01','09:20:00',1.88),('15128','2013-08-01','09:25:00',1.95),('15128','2013-08-01','09:30:00',2.02),('15128','2013-08-01','09:35:00',2.02),('15128','2013-08-01','09:40:00',2.1),('15128','2013-08-01','09:45:00',2.09),('15128','2013-08-01','09:50:00',2.1),('15128','2013-08-01','09:55:00',2.15),('15128','2013-08-01','10:00:00',2.22),('15128','2013-08-01','10:05:00',2.26),('15128','2013-08-01','10:10:00',2.31),('15128','2013-08-01','10:15:00',2.43),('15128','2013-08-01','10:20:00',2.52),('15128','2013-08-01','10:25:00',2.59),('15128','2013-08-01','10:30:00',2.58),('15128','2013-08-01','10:35:00',2.65),('15128','2013-08-01','10:40:00',2.72),('15128','2013-08-01','10:45:00',2.74),('15128','2013-08-01','10:50:00',2.8),('15128','2013-08-01','10:55:00',2.89),('15128','2013-08-01','11:00:00',2.9),('15128','2013-08-01','11:05:00',2.99),('15128','2013-08-01','11:10:00',3.01),('15128','2013-08-01','11:15:00',3.13),('15128','2013-08-01','11:20:00',3.16),('15128','2013-08-01','11:25:00',3.24),('15128','2013-08-01','11:30:00',3.22),('15128','2013-08-01','11:35:00',3.28),('15128','2013-08-01','11:40:00',3.35),('15128','2013-08-01','11:45:00',3.38),('15128','2013-08-01','11:50:00',3.49),('15128','2013-08-01','11:55:00',3.58),('15128','2013-08-01','12:00:00',3.7),('15128','2013-08-01','12:05:00',3.75),('15128','2013-08-01','12:10:00',3.79),('15128','2013-08-01','12:15:00',3.79),('15128','2013-08-01','12:20:00',3.85),('15128','2013-08-01','12:25:00',3.89),('15128','2013-08-01','12:30:00',3.91),('15128','2013-08-01','12:35:00',3.96),('15128','2013-08-01','12:40:00',3.99),('15128','2013-08-01','12:45:00',4),('15128','2013-08-01','12:50:00',4.01),('15128','2013-08-01','12:55:00',4.02),('15128','2013-08-01','13:00:00',4.01),('15128','2013-08-01','13:05:00',4.01),('15128','2013-08-01','13:10:00',4.02),('15128','2013-08-01','13:15:00',4.05),('15128','2013-08-01','13:20:00',4.06),('15128','2013-08-01','13:25:00',4.09),('15128','2013-08-01','13:30:00',4.08),('15128','2013-08-01','13:35:00',4.1),('15128','2013-08-01','13:40:00',4.11),('15128','2013-08-01','13:45:00',4.13),('15128','2013-08-01','13:50:00',4.16),('15128','2013-08-01','13:55:00',4.15),('15128','2013-08-01','14:00:00',4.06),('15128','2013-08-01','14:05:00',3.53),('15128','2013-08-01','14:10:00',4.17),('15128','2013-08-01','14:15:00',4.13),('15128','2013-08-01','14:20:00',4.07),('15128','2013-08-01','14:25:00',4.07),('15128','2013-08-01','14:30:00',4.1),('15128','2013-08-01','14:35:00',4.1),('15128','2013-08-01','14:40:00',4.08),('15128','2013-08-01','14:45:00',4.04),('15128','2013-08-01','14:50:00',4.04),('15128','2013-08-01','14:55:00',4.03),('15128','2013-08-01','15:00:00',3.97),('15128','2013-08-01','15:05:00',3.96),('15128','2013-08-01','15:10:00',3.98),('15128','2013-08-01','15:15:00',3.97),('15128','2013-08-01','15:20:00',3.96),('15128','2013-08-01','15:25:00',3.95),('15128','2013-08-01','15:30:00',3.9),('15128','2013-08-01','15:35:00',3.87),('15128','2013-08-01','15:40:00',3.82),('15128','2013-08-01','15:45:00',3.81),('15128','2013-08-01','15:50:00',3.81),('15128','2013-08-01','15:55:00',3.78),('15128','2013-08-01','16:00:00',3.76),('15128','2013-08-01','16:05:00',3.74),('15128','2013-08-01','16:10:00',3.65),('15128','2013-08-01','16:15:00',3.58),('15128','2013-08-01','16:20:00',3.54),('15128','2013-08-01','16:25:00',3.49),('15128','2013-08-01','16:30:00',3.42),('15128','2013-08-01','16:35:00',3.37),('15128','2013-08-01','16:40:00',3.31),('15128','2013-08-01','16:45:00',3.25),('15128','2013-08-01','16:50:00',3.24),('15128','2013-08-01','16:55:00',3.21),('15128','2013-08-01','17:00:00',3.13),('15128','2013-08-01','17:05:00',3.04),('15128','2013-08-01','17:10:00',2.97),('15128','2013-08-01','17:15:00',2.91),('15128','2013-08-01','17:20:00',2.83),('15128','2013-08-01','17:25:00',2.78),('15128','2013-08-01','17:30:00',2.72),('15128','2013-08-01','17:35:00',2.64),('15128','2013-08-01','17:40:00',2.51),('15128','2013-08-01','17:45:00',2.43),('15128','2013-08-01','17:50:00',2.28),('15128','2013-08-01','17:55:00',2.19),('15128','2013-08-01','18:00:00',2.07),('15128','2013-08-01','18:05:00',2.01),('15128','2013-08-01','18:10:00',1.88),('15128','2013-08-01','18:15:00',1.77),('15128','2013-08-01','18:20:00',1.72),('15128','2013-08-01','18:25:00',1.68),('15128','2013-08-01','18:30:00',1.62),('15128','2013-08-01','18:35:00',1.55),('15128','2013-08-01','18:40:00',1.47),('15128','2013-08-01','18:45:00',1.41),('15128','2013-08-01','18:50:00',1.31),('15128','2013-08-01','18:55:00',1.21),('15128','2013-08-01','19:00:00',1.11),('15128','2013-08-01','19:05:00',1.02),('15128','2013-07-31','08:25:00',1.05),('15128','2013-07-31','08:30:00',1.13),('15128','2013-07-31','08:35:00',1.19),('15128','2013-07-31','08:40:00',1.29),('15128','2013-07-31','08:45:00',1.37),('15128','2013-07-31','08:50:00',1.43),('15128','2013-07-31','08:55:00',1.5),('15128','2013-07-31','09:00:00',1.57),('15128','2013-07-31','09:05:00',1.64),('15128','2013-07-31','09:10:00',1.71),('15128','2013-07-31','09:15:00',1.81),('15128','2013-07-31','09:20:00',1.9),('15128','2013-07-31','09:25:00',1.99),('15128','2013-07-31','09:30:00',2.07),('15128','2013-07-31','09:35:00',2.13),('15128','2013-07-31','09:40:00',2.17),('15128','2013-07-31','09:45:00',2.21),('15128','2013-07-31','09:50:00',2.29),('15128','2013-07-31','09:55:00',2.35),('15128','2013-07-31','10:00:00',2.43),('15128','2013-07-31','10:05:00',2.49),('15128','2013-07-31','10:10:00',2.56),('15128','2013-07-31','10:15:00',2.62),('15128','2013-07-31','10:20:00',2.67),('15128','2013-07-31','10:25:00',2.72),('15128','2013-07-31','10:30:00',2.8),('15128','2013-07-31','10:35:00',2.83),('15128','2013-07-31','10:40:00',2.89),('15128','2013-07-31','10:45:00',2.97),('15128','2013-07-31','10:50:00',3.02),('15128','2013-07-31','10:55:00',3.08),('15128','2013-07-31','11:00:00',3.11),('15128','2013-07-31','11:05:00',3.18),('15128','2013-07-31','11:10:00',3.24),('15128','2013-07-31','11:15:00',3.33),('15128','2013-07-31','11:20:00',3.36),('15128','2013-07-31','11:25:00',3.41),('15128','2013-07-31','11:30:00',3.44),('15128','2013-07-31','11:35:00',3.5),('15128','2013-07-31','11:40:00',3.53),('15128','2013-07-31','11:45:00',3.65),('15128','2013-07-31','11:50:00',3.76),('15128','2013-07-31','11:55:00',3.84),('15128','2013-07-31','12:00:00',3.93),('15128','2013-07-31','12:05:00',3.99),('15128','2013-07-31','12:10:00',4.03),('15128','2013-07-31','12:15:00',4.08),('15128','2013-07-31','12:20:00',4.08),('15128','2013-07-31','12:25:00',4.1),('15128','2013-07-31','12:30:00',4.15),('15128','2013-07-31','12:35:00',4.2),('15128','2013-07-31','12:40:00',4.23),('15128','2013-07-31','12:45:00',4.26),('15128','2013-07-31','12:50:00',4.27),('15128','2013-07-31','12:55:00',4.27),('15128','2013-07-31','13:00:00',4.29),('15128','2013-07-31','13:05:00',4.26),('15128','2013-07-31','13:10:00',4.32),('15128','2013-07-31','13:15:00',4.34),('15128','2013-07-31','13:20:00',4.35),('15128','2013-07-31','13:25:00',4.34),('15128','2013-07-31','13:30:00',4.37),('15128','2013-07-31','13:35:00',4.36),('15128','2013-07-31','13:40:00',4.37),('15128','2013-07-31','13:45:00',4.38),('15128','2013-07-31','13:50:00',4.38),('15128','2013-07-31','13:55:00',4.35),('15128','2013-07-31','14:00:00',4.35),('15128','2013-07-31','14:05:00',4.36),('15128','2013-07-31','14:10:00',4.33),('15128','2013-07-31','14:15:00',4.32),('15128','2013-07-31','14:20:00',4.3),('15128','2013-07-31','14:25:00',4.33),('15128','2013-07-31','14:30:00',4.3),('15128','2013-07-31','14:35:00',4.27),('15128','2013-07-31','14:40:00',4.22),('15128','2013-07-31','14:45:00',4.18),('15128','2013-07-31','14:50:00',4.2),('15128','2013-07-31','14:55:00',4.2),('15128','2013-07-31','15:00:00',4.2),('15128','2013-07-31','15:05:00',4.18),('15128','2013-07-31','15:10:00',4.15),('15128','2013-07-31','15:15:00',4.13),('15128','2013-07-31','15:20:00',4.1),('15128','2013-07-31','15:25:00',4.07),('15128','2013-07-31','15:30:00',4.02),('15128','2013-07-31','15:35:00',4),('15128','2013-07-31','15:40:00',3.98),('15128','2013-07-31','15:45:00',3.91),('15128','2013-07-31','15:50:00',3.88),('15128','2013-07-31','15:55:00',3.83),('15128','2013-07-31','16:00:00',3.77),('15128','2013-07-31','16:05:00',3.73),('15128','2013-07-31','16:10:00',3.68),('15128','2013-07-31','16:15:00',3.62),('15128','2013-07-31','16:20:00',3.57),('15128','2013-07-31','16:25:00',3.52),('15128','2013-07-31','16:30:00',3.45),('15128','2013-07-31','16:35:00',3.41),('15128','2013-07-31','16:40:00',3.35),('15128','2013-07-31','16:45:00',3.28),('15128','2013-07-31','16:50:00',3.23),('15128','2013-07-31','16:55:00',3.18),('15128','2013-07-31','17:00:00',3.11),('15128','2013-07-31','17:05:00',3.07),('15128','2013-07-31','17:10:00',3),('15128','2013-07-31','17:15:00',2.92),('15128','2013-07-31','17:20:00',2.86),('15128','2013-07-31','17:25:00',2.8),('15128','2013-07-31','17:30:00',2.7),('15128','2013-07-31','17:35:00',2.62),('15128','2013-07-31','17:40:00',2.53),('15128','2013-07-31','17:45:00',2.42),('15128','2013-07-31','17:50:00',2.32),('15128','2013-07-31','17:55:00',2.23),('15128','2013-07-31','18:00:00',2.11),('15128','2013-07-31','18:05:00',1.99),('15128','2013-07-31','18:10:00',1.91),('15128','2013-07-31','18:15:00',1.8),('15128','2013-07-31','18:20:00',1.75),('15128','2013-07-31','18:25:00',1.68),('15128','2013-07-31','18:30:00',1.63),('15128','2013-07-31','18:35:00',1.59),('15128','2013-07-31','18:40:00',1.52),('15128','2013-07-31','18:45:00',1.44),('15128','2013-07-31','18:50:00',1.37),('15128','2013-07-31','18:55:00',1.26),('15128','2013-07-31','19:00:00',1.17),('15128','2013-07-31','19:05:00',1.06),('15128','2013-07-30','08:20:00',1.01),('15128','2013-07-30','08:25:00',1.06),('15128','2013-07-30','08:30:00',1.13),('15128','2013-07-30','08:35:00',1.2),('15128','2013-07-30','08:40:00',1.29),('15128','2013-07-30','08:45:00',1.38),('15128','2013-07-30','08:50:00',1.44),('15128','2013-07-30','08:55:00',1.51),('15128','2013-07-30','09:00:00',1.56),('15128','2013-07-30','09:05:00',1.63),('15128','2013-07-30','09:10:00',1.72),('15128','2013-07-30','09:15:00',1.81),('15128','2013-07-30','09:20:00',1.88),('15128','2013-07-30','09:25:00',1.98),('15128','2013-07-30','09:30:00',2.05),('15128','2013-07-30','09:35:00',2.08),('15128','2013-07-30','09:40:00',2.17),('15128','2013-07-30','09:45:00',2.18),('15128','2013-07-30','09:50:00',2.18),('15128','2013-07-30','09:55:00',2.21),('15128','2013-07-30','10:00:00',2.32),('15128','2013-07-30','10:05:00',2.44),('15128','2013-07-30','10:10:00',2.49),('15128','2013-07-30','10:15:00',2.57),('15128','2013-07-30','10:20:00',2.61),('15128','2013-07-30','10:25:00',2.66),('15128','2013-07-30','10:30:00',2.74),('15128','2013-07-30','10:35:00',2.8),('15128','2013-07-30','10:40:00',2.86),('15128','2013-07-30','10:45:00',2.94),('15128','2013-07-30','10:50:00',3),('15128','2013-07-30','10:55:00',3.07),('15128','2013-07-30','11:00:00',3.1),('15128','2013-07-30','11:05:00',3.18),('15128','2013-07-30','11:10:00',3.26),('15128','2013-07-30','11:15:00',3.31),('15128','2013-07-30','11:20:00',3.35),('15128','2013-07-30','11:25:00',3.42),('15128','2013-07-30','11:30:00',3.46),('15128','2013-07-30','11:35:00',3.52),('15128','2013-07-30','11:40:00',3.58),('15128','2013-07-30','11:45:00',3.62),('15128','2013-07-30','11:50:00',3.7),('15128','2013-07-30','11:55:00',3.86),('15128','2013-07-30','12:00:00',3.93),('15128','2013-07-30','12:05:00',3.97),('15128','2013-07-30','12:10:00',4),('15128','2013-07-30','12:15:00',4.02),('15128','2013-07-30','12:20:00',4.07),('15128','2013-07-30','12:25:00',4.09),('15128','2013-07-30','12:30:00',4.12),('15128','2013-07-30','12:35:00',4.14),('15128','2013-07-30','12:40:00',4.15),('15128','2013-07-30','12:45:00',4.2),('15128','2013-07-30','12:50:00',4.21),('15128','2013-07-30','12:55:00',4.21),('15128','2013-07-30','13:00:00',4.23),('15128','2013-07-30','13:05:00',4.28),('15128','2013-07-30','13:10:00',4.35),('15128','2013-07-30','13:15:00',4.34),('15128','2013-07-30','13:20:00',4.36),('15128','2013-07-30','13:25:00',4.34),('15128','2013-07-30','13:30:00',4.36),('15128','2013-07-30','13:35:00',4.39),('15128','2013-07-30','13:40:00',4.39),('15128','2013-07-30','13:45:00',4.37),('15128','2013-07-30','13:50:00',4.4),('15128','2013-07-30','13:55:00',4.43),('15128','2013-07-30','14:00:00',4.41),('15128','2013-07-30','14:05:00',4.42),('15128','2013-07-30','14:10:00',4.37),('15128','2013-07-30','14:15:00',4.42),('15128','2013-07-30','14:20:00',4.36),('15128','2013-07-30','14:25:00',4.3),('15128','2013-07-30','14:30:00',4.3),('15128','2013-07-30','14:35:00',4.26),('15128','2013-07-30','14:40:00',4.26),('15128','2013-07-30','14:45:00',4.21),('15128','2013-07-30','14:50:00',4.18),('15128','2013-07-30','14:55:00',4.19),('15128','2013-07-30','15:00:00',3.82),('15128','2013-07-30','15:05:00',4.18),('15128','2013-07-30','15:10:00',3.12),('15128','2013-07-30','15:15:00',4.16),('15128','2013-07-30','15:20:00',4.07),('15128','2013-07-30','15:25:00',4),('15128','2013-07-30','15:30:00',3.92),('15128','2013-07-30','15:35:00',3.91),('15128','2013-07-30','15:40:00',3.87),('15128','2013-07-30','15:45:00',3.89),('15128','2013-07-30','15:50:00',3.86),('15128','2013-07-30','15:55:00',3.58),('15128','2013-07-30','16:00:00',2.05),('15128','2013-07-30','16:05:00',3.79),('15128','2013-07-30','16:10:00',3.72),('15128','2013-07-30','16:15:00',3.67),('15128','2013-07-30','16:20:00',3.57),('15128','2013-07-30','16:25:00',3.53),('15128','2013-07-30','16:30:00',3.5),('15128','2013-07-30','16:35:00',3.47),('15128','2013-07-30','16:40:00',3.42),('15128','2013-07-30','16:45:00',3.4),('15128','2013-07-30','16:50:00',3.4),('15128','2013-07-30','16:55:00',3.34),('15128','2013-07-30','17:00:00',3.2),('15128','2013-07-30','17:05:00',3.13),('15128','2013-07-30','17:10:00',3.04),('15128','2013-07-30','17:15:00',2.85),('15128','2013-07-30','17:20:00',2.81),('15128','2013-07-30','17:25:00',2.8),('15128','2013-07-30','17:30:00',2.67),('15128','2013-07-30','17:35:00',2.61),('15128','2013-07-30','17:40:00',2.55),('15128','2013-07-30','17:45:00',2.44),('15128','2013-07-30','17:50:00',2.36),('15128','2013-07-30','17:55:00',2.22),('15128','2013-07-30','18:00:00',2.13),('15128','2013-07-30','18:05:00',1.99),('15128','2013-07-30','18:10:00',1.96),('15128','2013-07-30','18:15:00',1.87),('15128','2013-07-30','18:20:00',1.82),('15128','2013-07-30','18:25:00',1.77),('15128','2013-07-30','18:30:00',1.72),('15128','2013-07-30','18:35:00',1.65),('15128','2013-07-30','18:40:00',1.56),('15128','2013-07-30','18:45:00',1.47),('15128','2013-07-30','18:50:00',1.39),('15128','2013-07-30','18:55:00',1.29),('15128','2013-07-30','19:00:00',1.2),('15128','2013-07-30','19:05:00',1.09),('15128','2013-07-30','19:10:00',1.01),('15128','2014-04-07','08:50:00',1.01),('15128','2014-04-07','08:55:00',1.09),('15128','2014-04-07','09:00:00',1.15),('15128','2014-04-07','09:05:00',1.21),('15128','2014-04-07','09:10:00',1.29),('15128','2014-04-07','09:15:00',1.34),('15128','2014-04-07','09:20:00',1.42),('15128','2014-04-07','09:25:00',1.46),('15128','2014-04-07','09:30:00',1.48),('15128','2014-04-07','09:35:00',1.52),('15128','2014-04-07','09:40:00',1.62),('15128','2014-04-07','09:45:00',1.7),('15128','2014-04-07','09:50:00',1.71),('15128','2014-04-07','09:55:00',1.73),('15128','2014-04-07','10:00:00',1.89),('15128','2014-04-07','10:05:00',1.93),('15128','2014-04-07','10:10:00',1.96),('15128','2014-04-07','10:15:00',2.03),('15128','2014-04-07','10:20:00',2.12),('15128','2014-04-07','10:25:00',2.17),('15128','2014-04-07','10:30:00',2.22),('15128','2014-04-07','10:35:00',2.27),('15128','2014-04-07','10:40:00',2.3),('15128','2014-04-07','10:45:00',2.39),('15128','2014-04-07','10:50:00',2.51),('15128','2014-04-07','10:55:00',2.59),('15128','2014-04-07','11:00:00',2.67),('15128','2014-04-07','11:05:00',2.73),('15128','2014-04-07','11:10:00',2.76),('15128','2014-04-07','11:15:00',2.79),('15128','2014-04-07','11:20:00',2.8),('15128','2014-04-07','11:25:00',2.89),('15128','2014-04-07','11:30:00',2.92),('15128','2014-04-07','11:35:00',3.06),('15128','2014-04-07','11:40:00',3.09),('15128','2014-04-07','11:45:00',3.09),('15128','2014-04-07','11:50:00',3.19),('15128','2014-04-07','11:55:00',3.24),('15128','2014-04-07','12:00:00',3.25),('15128','2014-04-07','12:05:00',3.21),('15128','2014-04-07','12:10:00',3.06),('15128','2014-04-07','12:15:00',2.86),('15128','2014-04-07','12:20:00',3.54),('15128','2014-04-07','12:25:00',3.14),('15128','2014-04-07','12:30:00',3.05),('15128','2014-04-07','12:35:00',3.48),('15128','2014-04-07','12:40:00',3.38),('15128','2014-04-07','12:45:00',3.47),('15128','2014-04-07','12:50:00',3.62),('15128','2014-04-07','12:55:00',3.62),('15128','2014-04-07','13:00:00',3.86),('15128','2014-04-07','13:05:00',3.84),('15128','2014-04-07','13:10:00',3.83),('15128','2014-04-07','13:15:00',3.93),('15128','2014-04-07','13:20:00',3.97),('15128','2014-04-07','13:25:00',3.92),('15128','2014-04-07','13:30:00',3.92),('15128','2014-04-07','13:35:00',3.94),('15128','2014-04-07','13:40:00',3.97),('15128','2014-04-07','13:45:00',3.94),('15128','2014-04-07','13:50:00',3.91),('15128','2014-04-07','13:55:00',3.9),('15128','2014-04-07','14:00:00',3.92),('15128','2014-04-07','14:05:00',3.97),('15128','2014-04-07','14:10:00',4.02),('15128','2014-04-07','14:15:00',3.9),('15128','2014-04-07','14:20:00',3.23),('15128','2014-04-07','14:25:00',3.58),('15128','2014-04-07','14:30:00',3.98),('15128','2014-04-07','14:35:00',3.14),('15128','2014-04-07','14:40:00',3.59),('15128','2014-04-07','14:45:00',3.84),('15128','2014-04-07','14:50:00',3.89),('15128','2014-04-07','14:55:00',3.82),('15128','2014-04-07','15:00:00',3.77),('15128','2014-04-07','15:05:00',3.75),('15128','2014-04-07','15:10:00',3.6),('15128','2014-04-07','15:15:00',3.66),('15128','2014-04-07','15:20:00',3.65),('15128','2014-04-07','15:25:00',3.56),('15128','2014-04-07','15:30:00',3.54),('15128','2014-04-07','15:35:00',3.39),('15128','2014-04-07','15:40:00',3.41),('15128','2014-04-07','15:45:00',3.46),('15128','2014-04-07','15:50:00',3.37),('15128','2014-04-07','15:55:00',3.31),('15128','2014-04-07','16:00:00',3.35),('15128','2014-04-07','16:05:00',3.25),('15128','2014-04-07','16:10:00',3.07),('15128','2014-04-07','16:15:00',3),('15128','2014-04-07','16:20:00',2.9),('15128','2014-04-07','16:25:00',3.06),('15128','2014-04-07','16:30:00',2.95),('15128','2014-04-07','16:35:00',2.87),('15128','2014-04-07','16:40:00',2.77),('15128','2014-04-07','16:45:00',2.71),('15128','2014-04-07','16:50:00',2.59),('15128','2014-04-07','16:55:00',2.47),('15128','2014-04-07','17:00:00',2.56),('15128','2014-04-07','17:05:00',2.42),('15128','2014-04-07','17:10:00',2.34),('15128','2014-04-07','17:15:00',2.18),('15128','2014-04-07','17:20:00',1.98),('15128','2014-04-07','17:25:00',1.86),('15128','2014-04-07','17:30:00',1.72),('15128','2014-04-07','17:35:00',1.72),('15128','2014-04-07','17:40:00',1.62),('15128','2014-04-07','17:45:00',1.55),('15128','2014-04-07','17:50:00',1.45),('15128','2014-04-07','17:55:00',1.39),('15128','2014-04-07','18:00:00',1.46),('15128','2014-04-07','18:05:00',1.32),('15128','2014-04-07','18:10:00',1.29),('15128','2014-04-07','18:15:00',1.16),('15128','2013-07-29','08:20:00',1.03),('15128','2013-07-29','08:25:00',1.08),('15128','2013-07-29','08:30:00',1.13),('15128','2013-07-29','08:35:00',1.19),('15128','2013-07-29','08:40:00',1.3),('15128','2013-07-29','08:45:00',1.38),('15128','2013-07-29','08:50:00',1.47),('15128','2013-07-29','08:55:00',1.57),('15128','2013-07-29','09:00:00',1.68),('15128','2013-07-29','09:05:00',1.8),('15128','2013-07-29','09:10:00',1.86),('15128','2013-07-29','09:15:00',1.86),('15128','2013-07-29','09:20:00',2.02),('15128','2013-07-29','09:25:00',2.19),('15128','2013-07-29','09:30:00',2.19),('15128','2013-07-29','09:35:00',2.21),('15128','2013-07-29','09:40:00',2.34),('15128','2013-07-29','09:45:00',2.32),('15128','2013-07-29','09:50:00',2.43),('15128','2013-07-29','09:55:00',2.42),('15128','2013-07-29','10:00:00',2.45),('15128','2013-07-29','10:05:00',2.62),('15128','2013-07-29','10:10:00',2.66),('15128','2013-07-29','10:15:00',2.73),('15128','2013-07-29','10:20:00',2.89),('15128','2013-07-29','10:25:00',2.9),('15128','2013-07-29','10:30:00',2.89),('15128','2013-07-29','10:35:00',2.58),('15128','2013-07-29','10:40:00',2.73),('15128','2013-07-29','10:45:00',3.03),('15128','2013-07-29','10:50:00',2.93),('15128','2013-07-29','10:55:00',3.02),('15128','2013-07-29','11:00:00',3.01),('15128','2013-07-29','11:05:00',3.04),('15128','2013-07-29','11:10:00',2.76),('15128','2013-07-29','11:15:00',1.79),('15128','2013-07-29','11:20:00',3.36),('15128','2013-07-29','11:25:00',3.48),('15128','2013-07-29','11:30:00',3.48),('15128','2013-07-29','11:35:00',3.54),('15128','2013-07-29','11:40:00',3.62),('15128','2013-07-29','11:45:00',3.64),('15128','2013-07-29','11:50:00',3.8),('15128','2013-07-29','11:55:00',3.96),('15128','2013-07-29','12:00:00',3.56),('15128','2013-07-29','12:05:00',3.48),('15128','2013-07-29','12:10:00',2.67),('15128','2013-07-29','12:15:00',2.87),('15128','2013-07-29','12:20:00',3.49),('15128','2013-07-29','12:30:00',2.26),('15128','2013-07-29','12:35:00',4.44),('15128','2013-07-29','12:40:00',4.38),('15128','2013-07-29','12:45:00',4.38),('15128','2013-07-29','12:50:00',4.37),('15128','2013-07-29','12:55:00',4.49),('15128','2013-07-29','13:00:00',2.41),('15128','2013-07-29','13:15:00',1.2),('15128','2013-07-29','13:20:00',2.14),('15128','2013-07-29','13:25:00',4.51),('15128','2013-07-29','13:30:00',4.4),('15128','2013-07-29','13:35:00',4.48),('15128','2013-07-29','13:40:00',4.42),('15128','2013-07-29','13:45:00',4.1),('15128','2013-07-29','13:50:00',3.13),('15128','2013-07-29','13:55:00',4.59),('15128','2013-07-29','14:00:00',4.59),('15128','2013-07-29','14:05:00',4.45),('15128','2013-07-29','14:10:00',4.38),('15128','2013-07-29','14:15:00',4.27),('15128','2013-07-29','14:20:00',4.26),('15128','2013-07-29','14:25:00',4.23),('15128','2013-07-29','14:30:00',4.21),('15128','2013-07-29','14:35:00',4.2),('15128','2013-07-29','14:40:00',4.24),('15128','2013-07-29','14:45:00',4.24),('15128','2013-07-29','14:50:00',4.17),('15128','2013-07-29','14:55:00',4.1),('15128','2013-07-29','15:00:00',4.06),('15128','2013-07-29','15:05:00',4.09),('15128','2013-07-29','15:10:00',4.04),('15128','2013-07-29','15:15:00',4),('15128','2013-07-29','15:20:00',4.02),('15128','2013-07-29','15:25:00',4),('15128','2013-07-29','15:30:00',3.98),('15128','2013-07-29','15:35:00',3.94),('15128','2013-07-29','15:40:00',3.9),('15128','2013-07-29','15:45:00',3.87),('15128','2013-07-29','15:50:00',3.83),('15128','2013-07-29','15:55:00',3.79),('15128','2013-07-29','16:00:00',3.74),('15128','2013-07-29','16:05:00',3.66),('15128','2013-07-29','16:10:00',3.59),('15128','2013-07-29','16:15:00',3.53),('15128','2013-07-29','16:20:00',3.48),('15128','2013-07-29','16:25:00',3.44),('15128','2013-07-29','16:30:00',3.37),('15128','2013-07-29','16:35:00',3.37),('15128','2013-07-29','16:40:00',3.29),('15128','2013-07-29','16:45:00',3.22),('15128','2013-07-29','16:50:00',3.18),('15128','2013-07-29','16:55:00',3.11),('15128','2013-07-29','17:00:00',3.07),('15128','2013-07-29','17:05:00',2.99),('15128','2013-07-29','17:10:00',2.91),('15128','2013-07-29','17:15:00',2.89),('15128','2013-07-29','17:20:00',2.81),('15128','2013-07-29','17:25:00',2.7),('15128','2013-07-29','17:30:00',2.63),('15128','2013-07-29','17:35:00',2.59),('15128','2013-07-29','17:40:00',2.51),('15128','2013-07-29','17:45:00',2.39),('15128','2013-07-29','17:50:00',2.29),('15128','2013-07-29','17:55:00',2.18),('15128','2013-07-29','18:00:00',2.05),('15128','2013-07-29','18:05:00',1.93),('15128','2013-07-29','18:10:00',1.84),('15128','2013-07-29','18:15:00',1.76),('15128','2013-07-29','18:20:00',1.7),('15128','2013-07-29','18:25:00',1.61),('15128','2013-07-29','18:30:00',1.54),('15128','2013-07-29','18:35:00',1.51),('15128','2013-07-29','18:40:00',1.43),('15128','2013-07-29','18:45:00',1.33),('15128','2013-07-29','18:50:00',1.26),('15128','2013-07-29','18:55:00',1.17),('15128','2013-07-29','19:00:00',1.06),('15128','2013-07-28','08:25:00',1.05),('15128','2013-07-28','08:30:00',1.1),('15128','2013-07-28','08:35:00',1.16),('15128','2013-07-28','08:40:00',1.24),('15128','2013-07-28','08:45:00',1.32),('15128','2013-07-28','08:50:00',1.36),('15128','2013-07-28','08:55:00',1.42),('15128','2013-07-28','09:00:00',1.49),('15128','2013-07-28','09:05:00',1.54),('15128','2013-07-28','09:10:00',1.59),('15128','2013-07-28','09:15:00',1.65),('15128','2013-07-28','09:20:00',1.77),('15128','2013-07-28','09:25:00',1.85),('15128','2013-07-28','09:30:00',1.92),('15128','2013-07-28','09:35:00',1.97),('15128','2013-07-28','09:40:00',2.03),('15128','2013-07-28','09:45:00',2.07),('15128','2013-07-28','09:50:00',2.09),('15128','2013-07-28','09:55:00',2.12),('15128','2013-07-28','10:00:00',2.14),('15128','2013-07-28','10:05:00',2.2),('15128','2013-07-28','10:10:00',2.24),('15128','2013-07-28','10:15:00',2.32),('15128','2013-07-28','10:20:00',2.41),('15128','2013-07-28','10:25:00',2.52),('15128','2013-07-28','10:30:00',2.58),('15128','2013-07-28','10:35:00',2.63),('15128','2013-07-28','10:40:00',2.72),('15128','2013-07-28','10:45:00',2.75),('15128','2013-07-28','10:50:00',2.8),('15128','2013-07-28','10:55:00',2.81),('15128','2013-07-28','11:00:00',2.89),('15128','2013-07-28','11:05:00',2.98),('15128','2013-07-28','11:10:00',3.09),('15128','2013-07-28','11:15:00',3.09),('15128','2013-07-28','11:20:00',3.15),('15128','2013-07-28','11:25:00',3.15),('15128','2013-07-28','11:30:00',3.19),('15128','2013-07-28','11:35:00',3.25),('15128','2013-07-28','11:40:00',3.23),('15128','2013-07-28','11:45:00',3.36),('15128','2013-07-28','11:50:00',3.5),('15128','2013-07-28','11:55:00',3.55),('15128','2013-07-28','12:00:00',3.66),('15128','2013-07-28','12:05:00',3.68),('15128','2013-07-28','12:10:00',3.71),('15128','2013-07-28','12:15:00',3.75),('15128','2013-07-28','12:20:00',3.78),('15128','2013-07-28','12:25:00',3.8),('15128','2013-07-28','12:30:00',3.84),('15128','2013-07-28','12:35:00',3.85),('15128','2013-07-28','12:40:00',3.85),('15128','2013-07-28','12:45:00',3.89),('15128','2013-07-28','12:50:00',3.92),('15128','2013-07-28','12:55:00',3.98),('15128','2013-07-28','13:00:00',4.03),('15128','2013-07-28','13:05:00',4.03),('15128','2013-07-28','13:10:00',4.05),('15128','2013-07-28','13:15:00',4.12),('15128','2013-07-28','13:20:00',4.13),('15128','2013-07-28','13:25:00',4.15),('15128','2013-07-28','13:30:00',4.2),('15128','2013-07-28','13:35:00',4.21),('15128','2013-07-28','13:40:00',4.22),('15128','2013-07-28','13:45:00',4.21),('15128','2013-07-28','13:50:00',4.21),('15128','2013-07-28','13:55:00',4.2),('15128','2013-07-28','14:00:00',4.21),('15128','2013-07-28','14:05:00',4.2),('15128','2013-07-28','14:10:00',4.19),('15128','2013-07-28','14:15:00',4.17),('15128','2013-07-28','14:20:00',4.18),('15128','2013-07-28','14:25:00',4.16),('15128','2013-07-28','14:30:00',4.14),('15128','2013-07-28','14:35:00',4.13),('15128','2013-07-28','14:40:00',4.11),('15128','2013-07-28','14:45:00',4.09),('15128','2013-07-28','14:50:00',4.07),('15128','2013-07-28','14:55:00',4.05),('15128','2013-07-28','15:00:00',4.04),('15128','2013-07-28','15:05:00',4.02),('15128','2013-07-28','15:10:00',3.97),('15128','2013-07-28','15:15:00',3.96),('15128','2013-07-28','15:20:00',3.94),('15128','2013-07-28','15:25:00',3.98),('15128','2013-07-28','15:30:00',4),('15128','2013-07-28','15:35:00',4.07),('15128','2013-07-28','15:40:00',3.25),('15128','2013-07-28','15:45:00',3.27),('15128','2013-07-28','15:50:00',2.56),('15128','2013-07-28','15:55:00',2.52),('15128','2013-07-28','16:00:00',2.72),('15128','2013-07-28','16:05:00',3.74),('15128','2013-07-28','16:10:00',2.97),('15128','2013-07-28','16:15:00',3.45),('15128','2013-07-28','16:20:00',2.55),('15128','2013-07-28','16:25:00',3.37),('15128','2013-07-28','16:30:00',3.67),('15128','2013-07-28','16:35:00',3.54),('15128','2013-07-28','16:40:00',3.26),('15128','2013-07-28','16:45:00',2.7),('15128','2013-07-28','16:50:00',1.92),('15128','2013-07-28','16:55:00',1.71),('15128','2013-07-28','17:00:00',1.75),('15128','2013-07-28','17:05:00',2.24),('15128','2013-07-28','17:10:00',3.05),('15128','2013-07-28','17:15:00',2.97),('15128','2013-07-28','17:20:00',2.2),('15128','2013-07-28','17:25:00',2.55),('15128','2013-07-28','17:35:00',1.49),('15128','2013-07-28','17:40:00',2.91),('15128','2013-07-28','17:45:00',2.52),('15128','2013-07-28','17:50:00',2.21),('15128','2013-07-28','17:55:00',1.32),('15128','2013-07-28','18:00:00',1.94),('15128','2013-07-28','18:05:00',1.8),('15128','2013-07-28','18:10:00',1.68),('15128','2013-07-28','18:15:00',1.86),('15128','2013-07-28','18:20:00',1.75),('15128','2013-07-28','18:25:00',1.64),('15128','2013-07-28','18:30:00',1.52),('15128','2013-07-28','18:35:00',1.08),('15128','2013-07-28','18:40:00',1.04),('15128','2013-07-28','18:45:00',1.23),('15128','2013-07-28','18:50:00',1.15),('15128','2013-07-28','18:55:00',1.39),('15128','2013-07-28','19:00:00',1.25),('15128','2013-07-27','08:25:00',1.05),('15128','2013-07-27','08:30:00',1.09),('15128','2013-07-27','08:35:00',1.15),('15128','2013-07-27','08:40:00',1.26),('15128','2013-07-27','08:45:00',1.33),('15128','2013-07-27','08:50:00',1.4),('15128','2013-07-27','08:55:00',1.46),('15128','2013-07-27','09:00:00',1.53),('15128','2013-07-27','09:05:00',1.59),('15128','2013-07-27','09:10:00',1.67),('15128','2013-07-27','09:15:00',1.75),('15128','2013-07-27','09:20:00',1.81),('15128','2013-07-27','09:25:00',1.9),('15128','2013-07-27','09:30:00',1.91),('15128','2013-07-27','09:35:00',1.93),('15128','2013-07-27','09:40:00',1.98),('15128','2013-07-27','09:45:00',2.04),('15128','2013-07-27','09:50:00',2.1),('15128','2013-07-27','09:55:00',2.12),('15128','2013-07-27','10:00:00',2.2),('15128','2013-07-27','10:05:00',2.23),('15128','2013-07-27','10:10:00',2.31),('15128','2013-07-27','10:15:00',2.34),('15128','2013-07-27','10:20:00',2.45),('15128','2013-07-27','10:25:00',2.53),('15128','2013-07-27','10:30:00',2.54),('15128','2013-07-27','10:35:00',2.57),('15128','2013-07-27','10:40:00',2.63),('15128','2013-07-27','10:45:00',2.69),('15128','2013-07-27','10:50:00',2.73),('15128','2013-07-27','10:55:00',2.79),('15128','2013-07-27','11:00:00',2.88),('15128','2013-07-27','11:05:00',2.93),('15128','2013-07-27','11:10:00',2.99),('15128','2013-07-27','11:15:00',2.88),('15128','2013-07-27','11:20:00',3),('15128','2013-07-27','11:25:00',3.05),('15128','2013-07-27','11:30:00',3.13),('15128','2013-07-27','11:35:00',3.2),('15128','2013-07-27','11:40:00',3.24),('15128','2013-07-27','11:45:00',3.31),('15128','2013-07-27','11:50:00',3.45),('15128','2013-07-27','11:55:00',3.44),('15128','2013-07-27','12:00:00',3.62),('15128','2013-07-27','12:05:00',3.59),('15128','2013-07-27','12:10:00',3.75),('15128','2013-07-27','12:15:00',3.77),('15128','2013-07-27','12:20:00',3.82),('15128','2013-07-27','12:25:00',3.82),('15128','2013-07-27','12:30:00',3.57),('15128','2013-07-27','12:35:00',3.9),('15128','2013-07-27','12:40:00',3.97),('15128','2013-07-27','12:45:00',3.96),('15128','2013-07-27','12:50:00',4.01),('15128','2013-07-27','12:55:00',4.02),('15128','2013-07-27','13:00:00',4.03),('15128','2013-07-27','13:05:00',4.03),('15128','2013-07-27','13:10:00',4.06),('15128','2013-07-27','13:15:00',4.07),('15128','2013-07-27','13:20:00',4.08),('15128','2013-07-27','13:25:00',4.1),('15128','2013-07-27','13:30:00',4.09),('15128','2013-07-27','13:35:00',4.14),('15128','2013-07-27','13:40:00',4.12),('15128','2013-07-27','13:45:00',4.14),('15128','2013-07-27','13:50:00',4.15),('15128','2013-07-27','13:55:00',4.14),('15128','2013-07-27','14:00:00',4.15),('15128','2013-07-27','14:05:00',4.14),('15128','2013-07-27','14:10:00',4.15),('15128','2013-07-27','14:15:00',4.14),('15128','2013-07-27','14:20:00',4.12),('15128','2013-07-27','14:25:00',4.12),('15128','2013-07-27','14:30:00',4.11),('15128','2013-07-27','14:35:00',4.09),('15128','2013-07-27','14:40:00',4.09),('15128','2013-07-27','14:45:00',4.06),('15128','2013-07-27','14:50:00',4.03),('15128','2013-07-27','14:55:00',4.03),('15128','2013-07-27','15:00:00',4.02),('15128','2013-07-27','15:05:00',3.98),('15128','2013-07-27','15:10:00',3.92),('15128','2013-07-27','15:15:00',3.92),('15128','2013-07-27','15:20:00',3.9),('15128','2013-07-27','15:25:00',3.88),('15128','2013-07-27','15:30:00',3.86),('15128','2013-07-27','15:35:00',3.84),('15128','2013-07-27','15:40:00',3.84),('15128','2013-07-27','15:45:00',3.82),('15128','2013-07-27','15:50:00',3.79),('15128','2013-07-27','15:55:00',3.76),('15128','2013-07-27','16:00:00',3.73),('15128','2013-07-27','16:05:00',3.68),('15128','2013-07-27','16:10:00',3.66),('15128','2013-07-27','16:15:00',3.62),('15128','2013-07-27','16:20:00',3.56),('15128','2013-07-27','16:25:00',3.51),('15128','2013-07-27','16:30:00',3.46),('15128','2013-07-27','16:35:00',3.39),('15128','2013-07-27','16:40:00',3.35),('15128','2013-07-27','16:45:00',3.28),('15128','2013-07-27','16:50:00',3.24),('15128','2013-07-27','16:55:00',3.17),('15128','2013-07-27','17:00:00',3.12),('15128','2013-07-27','17:05:00',3.07),('15128','2013-07-27','17:10:00',3.01),('15128','2013-07-27','17:15:00',2.95),('15128','2013-07-27','17:20:00',2.88),('15128','2013-07-27','17:25:00',2.8),('15128','2013-07-27','17:30:00',2.74),('15128','2013-07-27','17:35:00',2.66),('15128','2013-07-27','17:40:00',2.57),('15128','2013-07-27','17:45:00',2.45),('15128','2013-07-27','17:50:00',2.35),('15128','2013-07-27','17:55:00',2.23),('15128','2013-07-27','18:00:00',2.12),('15128','2013-07-27','18:05:00',2.02),('15128','2013-07-27','18:10:00',1.89),('15128','2013-07-27','18:15:00',1.84),('15128','2013-07-27','18:20:00',1.74),('15128','2013-07-27','18:25:00',1.67),('15128','2013-07-27','18:30:00',1.59),('15128','2013-07-27','18:35:00',1.52),('15128','2013-07-27','18:40:00',1.47),('15128','2013-07-27','18:45:00',1.39),('15128','2013-07-27','18:50:00',1.32),('15128','2013-07-27','18:55:00',1.22),('15128','2013-07-27','19:00:00',1.12),('15128','2013-07-27','19:05:00',1.01),('15128','2013-07-26','08:25:00',1.08),('15128','2013-07-26','08:30:00',1.12),('15128','2013-07-26','08:35:00',1.19),('15128','2013-07-26','08:40:00',1.29),('15128','2013-07-26','08:45:00',1.36),('15128','2013-07-26','08:50:00',1.43),('15128','2013-07-26','08:55:00',1.49),('15128','2013-07-26','09:00:00',1.56),('15128','2013-07-26','09:05:00',1.62),('15128','2013-07-26','09:10:00',1.71),('15128','2013-07-26','09:15:00',1.78),('15128','2013-07-26','09:20:00',1.85),('15128','2013-07-26','09:25:00',1.97),('15128','2013-07-26','09:30:00',1.93),('15128','2013-07-26','09:35:00',1.95),('15128','2013-07-26','09:40:00',2.01),('15128','2013-07-26','09:45:00',2.06),('15128','2013-07-26','09:50:00',2.12),('15128','2013-07-26','09:55:00',2.17),('15128','2013-07-26','10:00:00',2.23),('15128','2013-07-26','10:05:00',2.28),('15128','2013-07-26','10:10:00',2.35),('15128','2013-07-26','10:20:00',2.56),('15128','2013-07-26','10:25:00',2.62),('15128','2013-07-26','10:30:00',2.61),('15128','2013-07-26','10:35:00',2.66),('15128','2013-07-26','10:50:00',2.86),('15128','2013-07-26','10:55:00',2.91),('15128','2013-07-26','11:00:00',2.97),('15128','2013-07-26','11:05:00',3.02),('15128','2013-07-26','11:10:00',3.09),('15128','2013-07-26','11:15:00',3.08),('15128','2013-07-26','11:20:00',3.14),('15128','2013-07-26','11:25:00',3.15),('15128','2013-07-26','11:30:00',3.2),('15128','2013-07-26','11:35:00',3.31),('15128','2013-07-26','11:40:00',3.18),('15128','2013-07-26','11:45:00',3.27),('15128','2013-07-26','11:50:00',3.48),('15128','2013-07-26','11:55:00',3.6),('15128','2013-07-26','12:00:00',3.64),('15128','2013-07-26','12:05:00',3.83),('15128','2013-07-26','12:10:00',3.79),('15128','2013-07-26','12:15:00',3.82),('15128','2013-07-26','12:20:00',3.84),('15128','2013-07-26','12:25:00',3.91),('15128','2013-07-26','12:30:00',3.87),('15128','2013-07-26','12:35:00',3.74),('15128','2013-07-26','12:40:00',3.94),('15128','2013-07-26','12:45:00',3.96),('15128','2013-07-26','12:50:00',3.91),('15128','2013-07-26','12:55:00',3.98),('15128','2013-07-26','13:00:00',4.04),('15128','2013-07-26','13:05:00',4.06),('15128','2013-07-26','13:10:00',4.05),('15128','2013-07-26','13:15:00',4.05),('15128','2013-07-26','13:20:00',4.09),('15128','2013-07-26','13:25:00',4.14),('15128','2013-07-26','13:30:00',4.14),('15128','2013-07-26','13:35:00',4.16),('15128','2013-07-26','13:40:00',4.15),('15128','2013-07-26','13:45:00',4.17),('15128','2013-07-26','13:50:00',4.17),('15128','2013-07-26','13:55:00',4.2),('15128','2013-07-26','14:00:00',4.19),('15128','2013-07-26','14:05:00',4.18),('15128','2013-07-26','14:10:00',4.16),('15128','2013-07-26','14:15:00',4.17),('15128','2013-07-26','14:20:00',4.15),('15128','2013-07-26','14:25:00',4.13),('15128','2013-07-26','14:30:00',4.14),('15128','2013-07-26','14:35:00',4.15),('15128','2013-07-26','14:40:00',4.11),('15128','2013-07-26','14:45:00',4.07),('15128','2013-07-26','14:50:00',4.07),('15128','2013-07-26','14:55:00',4.07),('15128','2013-07-26','15:00:00',4.06),('15128','2013-07-26','15:05:00',4.04),('15128','2013-07-26','15:10:00',4),('15128','2013-07-26','15:15:00',3.98),('15128','2013-07-26','15:20:00',3.94),('15128','2013-07-26','15:25:00',3.9),('15128','2013-07-26','15:30:00',3.87),('15128','2013-07-26','15:35:00',3.86),('15128','2013-07-26','15:40:00',3.84),('15128','2013-07-26','15:45:00',3.81),('15128','2013-07-26','15:50:00',3.76),('15128','2013-07-26','15:55:00',3.73),('15128','2013-07-26','16:00:00',3.69),('15128','2013-07-26','16:05:00',3.65),('15128','2013-07-26','16:10:00',3.61),('15128','2013-07-26','16:15:00',3.56),('15128','2013-07-26','16:20:00',3.54),('15128','2013-07-26','16:25:00',3.5),('15128','2013-07-26','16:30:00',3.46),('15128','2013-07-26','16:35:00',3.42),('15128','2013-07-26','16:40:00',3.36),('15128','2013-07-26','16:45:00',3.3),('15128','2013-07-26','16:50:00',3.25),('15128','2013-07-26','16:55:00',3.18),('15128','2013-07-26','17:00:00',3.14),('15128','2013-07-26','17:05:00',3.06),('15128','2013-07-26','17:10:00',2.99),('15128','2013-07-26','17:15:00',2.95),('15128','2013-07-26','17:20:00',2.89),('15128','2013-07-26','17:25:00',2.8),('15128','2013-07-26','17:30:00',2.72),('15128','2013-07-26','17:35:00',2.65),('15128','2013-07-26','17:40:00',2.56),('15128','2013-07-26','17:45:00',2.44),('15128','2013-07-26','17:50:00',2.36),('15128','2013-07-26','17:55:00',2.26),('15128','2013-07-26','18:00:00',2.15),('15128','2013-07-26','18:05:00',2.02),('15128','2013-07-26','18:10:00',1.94),('15128','2013-07-26','18:15:00',1.84),('15128','2013-07-26','18:20:00',1.79),('15128','2013-07-26','18:25:00',1.71),('15128','2013-07-26','18:30:00',1.63),('15128','2013-07-26','18:35:00',1.56),('15128','2013-07-26','18:40:00',1.49),('15128','2013-07-26','18:45:00',1.44),('15128','2013-07-26','18:50:00',1.38),('15128','2013-07-26','18:55:00',1.29),('15128','2013-07-26','19:00:00',1.2),('15128','2013-07-26','19:05:00',1.1),('15128','2013-07-25','08:25:00',1.07),('15128','2013-07-25','08:30:00',1.13),('15128','2013-07-25','08:35:00',1.21),('15128','2013-07-25','08:40:00',1.34),('15128','2013-07-25','08:45:00',1.37),('15128','2013-07-25','08:50:00',1.37),('15128','2013-07-25','08:55:00',1.43),('15128','2013-07-25','09:00:00',1.54),('15128','2013-07-25','09:05:00',1.62),('15128','2013-07-25','09:10:00',1.73),('15128','2013-07-25','09:15:00',1.79),('15128','2013-07-25','09:20:00',1.83),('15128','2013-07-25','09:25:00',1.93),('15128','2013-07-25','09:30:00',1.92),('15128','2013-07-25','09:35:00',2),('15128','2013-07-25','09:40:00',2.05),('15128','2013-07-25','09:45:00',2.07),('15128','2013-07-25','09:50:00',2.14),('15128','2013-07-25','09:55:00',2.19),('15128','2013-07-25','10:00:00',2.25),('15128','2013-07-25','10:05:00',2.33),('15128','2013-07-25','10:10:00',2.37),('15128','2013-07-25','10:15:00',2.43),('15128','2013-07-25','10:20:00',2.51),('15128','2013-07-25','10:25:00',2.51),('15128','2013-07-25','10:30:00',2.56),('15128','2013-07-25','10:35:00',2.62),('15128','2013-07-25','10:40:00',2.73),('15128','2013-07-25','10:45:00',2.78),('15128','2013-07-25','10:50:00',2.84),('15128','2013-07-25','10:55:00',2.91),('15128','2013-07-25','11:00:00',3.02),('15128','2013-07-25','11:05:00',3.01),('15128','2013-07-25','11:10:00',3.11),('15128','2013-07-25','11:15:00',3.14),('15128','2013-07-25','11:20:00',3.19),('15128','2013-07-25','11:25:00',3.24),('15128','2013-07-25','11:30:00',3.31),('15128','2013-07-25','11:35:00',3.32),('15128','2013-07-25','11:40:00',3.46),('15128','2013-07-25','11:45:00',3.49),('15128','2013-07-25','11:50:00',3.38),('15128','2013-07-25','11:55:00',2.86),('15128','2013-07-25','12:00:00',3.72),('15128','2013-07-25','12:05:00',3.87),('15128','2013-07-25','12:10:00',3.83),('15128','2013-07-25','12:15:00',2.47),('15128','2013-07-25','12:20:00',3.38),('15128','2013-07-25','12:25:00',3.22),('15128','2013-07-25','12:30:00',4.36),('15128','2013-07-25','12:35:00',3.1),('15128','2013-07-25','12:40:00',1.51),('15128','2013-07-25','12:45:00',2.05),('15128','2013-07-25','12:50:00',4.27),('15128','2013-07-25','12:55:00',3.05),('15128','2013-07-25','13:00:00',2.74),('15128','2013-07-25','13:05:00',4.23),('15128','2013-07-25','13:10:00',4.64),('15128','2013-07-25','13:15:00',2.72),('15128','2013-07-25','13:20:00',4.33),('15128','2013-07-25','13:25:00',3.68),('15128','2013-07-25','13:30:00',4.57),('15128','2013-07-25','13:35:00',4.29),('15128','2013-07-25','13:40:00',4.15),('15128','2013-07-25','13:45:00',4.2),('15128','2013-07-25','13:50:00',4.29),('15128','2013-07-25','13:55:00',4.24),('15128','2013-07-25','14:00:00',4.25),('15128','2013-07-25','14:05:00',4.26),('15128','2013-07-25','14:10:00',4.18),('15128','2013-07-25','14:15:00',4.24),('15128','2013-07-25','14:20:00',4.14),('15128','2013-07-25','14:25:00',4.21),('15128','2013-07-25','14:30:00',4.16),('15128','2013-07-25','14:35:00',4.2),('15128','2013-07-25','14:40:00',4.18),('15128','2013-07-25','14:45:00',4.15),('15128','2013-07-25','14:50:00',4.12),('15128','2013-07-25','14:55:00',4.13),('15128','2013-07-25','15:00:00',4.11),('15128','2013-07-25','15:05:00',4.06),('15128','2013-07-25','15:10:00',4.06),('15128','2013-07-25','15:15:00',4.04),('15128','2013-07-25','15:20:00',3.99),('15128','2013-07-25','15:25:00',3.95),('15128','2013-07-25','15:30:00',3.91),('15128','2013-07-25','15:35:00',3.9),('15128','2013-07-25','15:40:00',3.86),('15128','2013-07-25','15:45:00',3.88),('15128','2013-07-25','15:50:00',3.85),('15128','2013-07-25','15:55:00',3.8),('15128','2013-07-25','16:00:00',3.74),('15128','2013-07-25','16:05:00',3.72),('15128','2013-07-25','16:10:00',3.69),('15128','2013-07-25','16:15:00',3.61),('15128','2013-07-25','16:20:00',3.52),('15128','2013-07-25','16:25:00',3.51),('15128','2013-07-25','16:30:00',3.45),('15128','2013-07-25','16:35:00',3.43),('15128','2013-07-25','16:40:00',3.35),('15128','2013-07-25','16:45:00',3.25),('15128','2013-07-25','16:50:00',3.2),('15128','2013-07-25','16:55:00',3.13),('15128','2013-07-25','17:00:00',3.08),('15128','2013-07-25','17:05:00',3.01),('15128','2013-07-25','17:10:00',2.99),('15128','2013-07-25','17:15:00',2.92),('15128','2013-07-25','17:20:00',2.85),('15128','2013-07-25','17:25:00',2.77),('15128','2013-07-25','17:30:00',2.7),('15128','2013-07-25','17:35:00',2.6),('15128','2013-07-25','17:40:00',2.51),('15128','2013-07-25','17:45:00',2.41),('15128','2013-07-25','17:50:00',2.3),('15128','2013-07-25','17:55:00',2.19),('15128','2013-07-25','18:00:00',2.06),('15128','2013-07-25','18:05:00',1.95),('15128','2013-07-25','18:10:00',1.84),('15128','2013-07-25','18:15:00',1.78),('15128','2013-07-25','18:20:00',1.73),('15128','2013-07-25','18:25:00',1.65),('15128','2013-07-25','18:30:00',1.55),('15128','2013-07-25','18:35:00',1.46),('15128','2013-07-25','18:40:00',1.39),('15128','2013-07-25','18:45:00',1.33),('15128','2013-07-25','18:50:00',1.25),('15128','2013-07-25','18:55:00',1.16),('15128','2013-07-25','19:00:00',1.07),('15128','2013-07-24','08:25:00',1.07),('15128','2013-07-24','08:30:00',1.14),('15128','2013-07-24','08:35:00',1.2),('15128','2013-07-24','08:40:00',1.27),('15128','2013-07-24','08:45:00',1.35),('15128','2013-07-24','08:50:00',1.39),('15128','2013-07-24','08:55:00',1.43),('15128','2013-07-24','09:00:00',1.53),('15128','2013-07-24','09:05:00',1.61),('15128','2013-07-24','09:10:00',1.75),('15128','2013-07-24','09:15:00',1.75),('15128','2013-07-24','09:20:00',2.03),('15128','2013-07-24','09:25:00',2.19),('15128','2013-07-24','09:30:00',2.16),('15128','2013-07-24','09:35:00',1.47),('15128','2013-07-24','09:40:00',1.97),('15128','2013-07-24','09:45:00',2.07),('15128','2013-07-24','09:50:00',2.19),('15128','2013-07-24','09:55:00',2.4),('15128','2013-07-24','10:00:00',2.48),('15128','2013-07-24','10:05:00',2.6),('15128','2013-07-24','10:10:00',2.64),('15128','2013-07-24','10:15:00',1.56),('15128','2013-07-24','10:20:00',1.28),('15128','2013-07-24','10:30:00',2.39),('15128','2013-07-24','10:35:00',2.87),('15128','2013-07-24','10:40:00',2.9),('15128','2013-07-24','10:45:00',3),('15128','2013-07-24','10:50:00',2.99),('15128','2013-07-24','10:55:00',3.09),('15128','2013-07-24','11:00:00',3.01),('15128','2013-07-24','11:05:00',3.21),('15128','2013-07-24','11:10:00',3.17),('15128','2013-07-24','11:15:00',3.21),('15128','2013-07-24','11:20:00',3.01),('15128','2013-07-24','11:25:00',3.35),('15128','2013-07-24','11:30:00',3.36),('15128','2013-07-24','11:35:00',3.31),('15128','2013-07-24','11:40:00',3.44),('15128','2013-07-24','11:45:00',3.55),('15128','2013-07-24','11:50:00',2.71),('15128','2013-07-24','11:55:00',2),('15128','2013-07-24','12:00:00',3.75),('15128','2013-07-24','12:05:00',4.01),('15128','2013-07-24','12:10:00',4.05),('15128','2013-07-24','12:15:00',4.2),('15128','2013-07-24','12:20:00',4),('15128','2013-07-24','12:25:00',4.08),('15128','2013-07-24','12:30:00',3.95),('15128','2013-07-24','12:35:00',4.08),('15128','2013-07-24','12:40:00',4.03),('15128','2013-07-24','12:45:00',3.97),('15128','2013-07-24','12:50:00',3.93),('15128','2013-07-24','12:55:00',4.24),('15128','2013-07-24','13:00:00',2.92),('15128','2013-07-24','13:05:00',3.96),('15128','2013-07-24','13:10:00',4.26),('15128','2013-07-24','13:15:00',4.23),('15128','2013-07-24','13:20:00',4.15),('15128','2013-07-24','13:25:00',4.31),('15128','2013-07-24','13:30:00',4.32),('15128','2013-07-24','13:35:00',4.28),('15128','2013-07-24','13:40:00',4.35),('15128','2013-07-24','13:45:00',4.36),('15128','2013-07-24','13:50:00',4.36),('15128','2013-07-24','13:55:00',4.39),('15128','2013-07-24','14:00:00',4.36),('15128','2013-07-24','14:05:00',4.38),('15128','2013-07-24','14:10:00',4.36),('15128','2013-07-24','14:15:00',4.36),('15128','2013-07-24','14:20:00',4.37),('15128','2013-07-24','14:25:00',4.36),('15128','2013-07-24','14:30:00',4.36),('15128','2013-07-24','14:35:00',4.36),('15128','2013-07-24','14:40:00',4.33),('15128','2013-07-24','14:45:00',4.34),('15128','2013-07-24','14:50:00',4.3),('15128','2013-07-24','14:55:00',4.27),('15128','2013-07-24','15:00:00',4.22),('15128','2013-07-24','15:05:00',4.24),('15128','2013-07-24','15:10:00',4.21),('15128','2013-07-24','15:15:00',4.2),('15128','2013-07-24','15:20:00',4.2),('15128','2013-07-24','15:25:00',4.18),('15128','2013-07-24','15:30:00',4.12),('15128','2013-07-24','15:35:00',4.1),('15128','2013-07-24','15:40:00',4.09),('15128','2013-07-24','15:45:00',4.04),('15128','2013-07-24','15:50:00',4),('15128','2013-07-24','15:55:00',3.97),('15128','2013-07-24','16:00:00',3.91),('15128','2013-07-24','16:05:00',3.89),('15128','2013-07-24','16:10:00',3.85),('15128','2013-07-24','16:15:00',3.83),('15128','2013-07-24','16:20:00',3.76),('15128','2013-07-24','16:25:00',3.72),('15128','2013-07-24','16:30:00',3.62),('15128','2013-07-24','16:35:00',3.57),('15128','2013-07-24','16:40:00',3.54),('15128','2013-07-24','16:45:00',3.49),('15128','2013-07-24','16:50:00',3.42),('15128','2013-07-24','16:55:00',3.32),('15128','2013-07-24','17:00:00',3.31),('15128','2013-07-24','17:05:00',3.27),('15128','2013-07-24','17:10:00',3.18),('15128','2013-07-24','17:15:00',3.08),('15128','2013-07-24','17:20:00',3.02),('15128','2013-07-24','17:25:00',2.94),('15128','2013-07-24','17:30:00',2.87),('15128','2013-07-24','17:35:00',2.81),('15128','2013-07-24','17:40:00',2.73),('15128','2013-07-24','17:45:00',2.6),('15128','2013-07-24','17:50:00',2.48),('15128','2013-07-24','17:55:00',2.37),('15128','2013-07-24','18:00:00',2.23),('15128','2013-07-24','18:05:00',2.13),('15128','2013-07-24','18:10:00',2.01),('15128','2013-07-24','18:15:00',1.89),('15128','2013-07-24','18:20:00',1.84),('15128','2013-07-24','18:25:00',1.76),('15128','2013-07-24','18:30:00',1.69),('15128','2013-07-24','18:35:00',1.63),('15128','2013-07-24','18:40:00',1.57),('15128','2013-07-24','18:45:00',1.44),('15128','2013-07-24','18:50:00',1.39),('15128','2013-07-24','18:55:00',1.31),('15128','2013-07-24','19:00:00',1.17),('15128','2013-07-24','19:05:00',1.06),('15128','2013-07-23','08:15:00',1.22),('15128','2013-07-23','08:20:00',1.15),('15128','2013-07-23','08:25:00',1.08),('15128','2013-07-23','08:30:00',1.21),('15128','2013-07-23','08:45:00',1.03),('15128','2013-07-23','08:50:00',1.1),('15128','2013-07-23','08:55:00',1.14),('15128','2013-07-23','09:00:00',1.17),('15128','2013-07-23','09:05:00',1.52),('15128','2013-07-23','09:10:00',1.84),('15128','2013-07-23','09:15:00',2.09),('15128','2013-07-23','09:20:00',1.64),('15128','2013-07-23','09:25:00',1.8),('15128','2013-07-23','09:30:00',1.73),('15128','2013-07-23','09:50:00',1.69),('15128','2013-07-23','09:55:00',2.55),('15128','2013-07-23','10:00:00',2.56),('15128','2013-07-23','10:05:00',2.82),('15128','2013-07-23','10:10:00',1.93),('15128','2013-07-23','10:15:00',1.27),('15128','2013-07-23','10:30:00',1.28),('15128','2013-07-23','10:35:00',3.06),('15128','2013-07-23','10:40:00',3.11),('15128','2013-07-23','10:45:00',3.3),('15128','2013-07-23','10:50:00',2.6),('15128','2013-07-23','10:55:00',1.5),('15128','2013-07-23','11:00:00',1.2),('15128','2013-07-23','11:05:00',2.92),('15128','2013-07-23','11:10:00',3.43),('15128','2013-07-23','11:15:00',3.47),('15128','2013-07-23','11:20:00',2.39),('15128','2013-07-23','11:25:00',3.43),('15128','2013-07-23','11:30:00',3.57),('15128','2013-07-23','11:35:00',3.55),('15128','2013-07-23','11:40:00',3.09),('15128','2013-07-23','11:45:00',3.81),('15128','2013-07-23','11:50:00',3.89),('15128','2013-07-23','11:55:00',3.95),('15128','2013-07-23','12:00:00',4.12),('15128','2013-07-23','12:05:00',4.16),('15128','2013-07-23','12:10:00',4.08),('15128','2013-07-23','12:15:00',4.18),('15128','2013-07-23','12:20:00',4.19),('15128','2013-07-23','12:25:00',2.47),('15128','2013-07-23','12:30:00',3.87),('15128','2013-07-23','12:35:00',3.98),('15128','2013-07-23','12:40:00',4.21),('15128','2013-07-23','12:45:00',4.2),('15128','2013-07-23','12:50:00',4.19),('15128','2013-07-23','12:55:00',4.17),('15128','2013-07-23','13:00:00',4.08),('15128','2013-07-23','13:05:00',4.14),('15128','2013-07-23','13:10:00',4.11),('15128','2013-07-23','13:15:00',4.17),('15128','2013-07-23','13:20:00',4.23),('15128','2013-07-23','13:25:00',4.25),('15128','2013-07-23','13:30:00',4.27),('15128','2013-07-23','13:35:00',4.32),('15128','2013-07-23','13:40:00',4.22),('15128','2013-07-23','13:45:00',4.36),('15128','2013-07-23','13:50:00',4.25),('15128','2013-07-23','13:55:00',4.32),('15128','2013-07-23','14:00:00',4.34),('15128','2013-07-23','14:05:00',4.35),('15128','2013-07-23','14:10:00',4.34),('15128','2013-07-23','14:15:00',4.33),('15128','2013-07-23','14:20:00',4.36),('15128','2013-07-23','14:25:00',4.33),('15128','2013-07-23','14:30:00',4.35),('15128','2013-07-23','14:35:00',4.34),('15128','2013-07-23','14:40:00',4.31),('15128','2013-07-23','14:45:00',4.33),('15128','2013-07-23','14:50:00',4.33),('15128','2013-07-23','14:55:00',4.32),('15128','2013-07-23','15:00:00',4.32),('15128','2013-07-23','15:05:00',4.28),('15128','2013-07-23','15:10:00',4.27),('15128','2013-07-23','15:15:00',4.24),('15128','2013-07-23','15:20:00',3.89),('15128','2013-07-23','15:25:00',4.18),('15128','2013-07-23','15:30:00',4.18),('15128','2013-07-23','15:35:00',4.05),('15128','2013-07-23','15:40:00',3.96),('15128','2013-07-23','15:45:00',3.94),('15128','2013-07-23','15:50:00',3.74),('15128','2013-07-23','15:55:00',3.58),('15128','2013-07-23','16:00:00',3.89),('15128','2013-07-23','16:05:00',3.96),('15128','2013-07-23','16:10:00',3.85),('15128','2013-07-23','16:15:00',3.76),('15128','2013-07-23','16:20:00',3.74),('15128','2013-07-23','16:25:00',3.79),('15128','2013-07-23','16:30:00',3.45),('15128','2013-07-23','16:35:00',3.58),('15128','2013-07-23','16:40:00',3.92),('15128','2013-07-23','16:45:00',3.86),('15128','2013-07-23','16:50:00',3.56),('15128','2013-07-23','16:55:00',2.81),('15128','2013-07-23','17:00:00',3.62),('15128','2013-07-23','17:05:00',3.43),('15128','2013-07-23','17:10:00',3.3),('15128','2013-07-23','17:15:00',3.17),('15128','2013-07-23','17:20:00',3.04),('15128','2013-07-23','17:25:00',2.9),('15128','2013-07-23','17:30:00',2.8),('15128','2013-07-23','17:35:00',2.79),('15128','2013-07-23','17:40:00',2.6),('15128','2013-07-23','17:45:00',2.58),('15128','2013-07-23','17:50:00',2.45),('15128','2013-07-23','17:55:00',2.31),('15128','2013-07-23','18:00:00',2.23),('15128','2013-07-23','18:05:00',2.13),('15128','2013-07-23','18:10:00',1.83),('15128','2013-07-23','18:15:00',1.19),('15128','2013-07-23','18:20:00',1.52),('15128','2013-07-23','18:25:00',1.27),('15128','2013-07-23','18:30:00',1.63),('15128','2013-07-23','18:35:00',1.6),('15128','2013-07-23','18:40:00',1.55),('15128','2013-07-23','18:45:00',1.41),('15128','2013-07-23','18:50:00',1.19),('15128','2013-07-23','18:55:00',1.28),('15128','2013-07-22','08:30:00',1.2),('15128','2013-07-22','08:35:00',1.29),('15128','2013-07-22','08:40:00',1.37),('15128','2013-07-22','08:45:00',1.24),('15128','2013-07-22','08:50:00',1.5),('15128','2013-07-22','08:55:00',1.57),('15128','2013-07-22','09:00:00',1.64),('15128','2013-07-22','09:05:00',1.46),('15128','2013-07-22','09:10:00',1.81),('15128','2013-07-22','09:15:00',1.89),('15128','2013-07-22','09:20:00',1.99),('15128','2013-07-22','09:25:00',1.88),('15128','2013-07-22','09:30:00',1.88),('15128','2013-07-22','09:35:00',2.1),('15128','2013-07-22','09:40:00',2.15),('15128','2013-07-22','09:45:00',2.2),('15128','2013-07-22','09:50:00',1.8),('15128','2013-07-22','09:55:00',2.24),('15128','2013-07-22','10:00:00',2.34),('15128','2013-07-22','10:05:00',2.41),('15128','2013-07-22','10:10:00',2.49),('15128','2013-07-22','10:15:00',2.54),('15128','2013-07-22','10:20:00',2.61),('15128','2013-07-22','10:25:00',2.69),('15128','2013-07-22','10:30:00',2.7),('15128','2013-07-22','10:35:00',2.74),('15128','2013-07-22','10:40:00',2.79),('15128','2013-07-22','10:45:00',2.81),('15128','2013-07-22','10:50:00',2.88),('15128','2013-07-22','10:55:00',2.91),('15128','2013-07-22','11:00:00',3),('15128','2013-07-22','11:05:00',3.04),('15128','2013-07-22','11:10:00',3.15),('15128','2013-07-22','11:15:00',2.99),('15128','2013-07-22','11:20:00',3.1),('15128','2013-07-22','11:25:00',3.34),('15128','2013-07-22','11:30:00',3.47),('15128','2013-07-22','11:35:00',3.55),('15128','2013-07-22','11:40:00',3.3),('15128','2013-07-22','11:45:00',3.33),('15128','2013-07-22','11:50:00',1.39),('15128','2013-07-22','11:55:00',1.24),('15128','2013-07-22','12:00:00',1.28),('15128','2013-07-22','12:05:00',2.91),('15128','2013-07-22','12:10:00',2.76),('15128','2013-07-22','12:15:00',1.6),('15128','2013-07-22','12:20:00',4.28),('15128','2013-07-22','12:25:00',4.22),('15128','2013-07-22','12:30:00',2.56),('15128','2013-07-22','12:35:00',3.51),('15128','2013-07-22','12:40:00',4.26),('15128','2013-07-22','12:45:00',4),('15128','2013-07-22','12:50:00',3.97),('15128','2013-07-22','12:55:00',3.87),('15128','2013-07-22','13:00:00',4.31),('15128','2013-07-22','13:05:00',3.96),('15128','2013-07-22','13:10:00',4.3),('15128','2013-07-22','13:15:00',4.34),('15128','2013-07-22','13:20:00',4.26),('15128','2013-07-22','13:25:00',4.4),('15128','2013-07-22','13:30:00',4.39),('15128','2013-07-22','13:35:00',1.84),('15128','2013-07-22','13:40:00',3.55),('15128','2013-07-22','13:45:00',4.32),('15128','2013-07-22','13:50:00',1.19),('15128','2013-07-22','13:55:00',1.32),('15128','2013-07-22','14:00:00',1.38),('15128','2013-07-22','14:05:00',3.27),('15128','2013-07-22','14:10:00',1.77),('15128','2013-07-22','14:15:00',4.76),('15128','2013-07-22','14:20:00',4.66),('15128','2013-07-22','14:25:00',4.51),('15128','2013-07-22','14:30:00',4.49),('15128','2013-07-22','14:35:00',4.36),('15128','2013-07-22','14:40:00',4.3),('15128','2013-07-22','14:45:00',4.32),('15128','2013-07-22','14:50:00',4.26),('15128','2013-07-22','14:55:00',4.28),('15128','2013-07-22','15:00:00',4.26),('15128','2013-07-22','15:05:00',4.22),('15128','2013-07-22','15:10:00',4.19),('15128','2013-07-22','15:15:00',4.15),('15128','2013-07-22','15:20:00',4.09),('15128','2013-07-22','15:25:00',4.03),('15128','2013-07-22','15:30:00',4.01),('15128','2013-07-22','15:35:00',3.97),('15128','2013-07-22','15:40:00',3.98),('15128','2013-07-22','15:45:00',3.91),('15128','2013-07-22','15:50:00',3.92),('15128','2013-07-22','15:55:00',3.86),('15128','2013-07-22','16:00:00',3.83),('15128','2013-07-22','16:05:00',3.8),('15128','2013-07-22','16:10:00',3.76),('15128','2013-07-22','16:15:00',3.73),('15128','2013-07-22','16:20:00',3.7),('15128','2013-07-22','16:25:00',3.65),('15128','2013-07-22','16:30:00',3.57),('15128','2013-07-22','16:35:00',3.52),('15128','2013-07-22','16:40:00',3.46),('15128','2013-07-22','16:45:00',3.39),('15128','2013-07-22','16:50:00',3.32),('15128','2013-07-22','16:55:00',3.28),('15128','2013-07-22','17:00:00',3.23),('15128','2013-07-22','17:05:00',3.16),('15128','2013-07-22','17:10:00',3.11),('15128','2013-07-22','17:15:00',3.02),('15128','2013-07-22','17:20:00',2.94),('15128','2013-07-22','17:25:00',2.86),('15128','2013-07-22','17:30:00',2.81),('15128','2013-07-22','17:35:00',2.74),('15128','2013-07-22','17:40:00',2.64),('15128','2013-07-22','17:45:00',2.55),('15128','2013-07-22','17:50:00',2.46),('15128','2013-07-22','17:55:00',2.32),('15128','2013-07-22','18:00:00',2.25),('15128','2013-07-22','18:05:00',2.12),('15128','2013-07-22','18:10:00',1.99),('15128','2013-07-22','18:15:00',1.91),('15128','2013-07-22','18:20:00',1.86),('15128','2013-07-22','18:25:00',1.79),('15128','2013-07-22','18:30:00',1.7),('15128','2013-07-22','18:35:00',1.44),('15128','2013-07-22','18:40:00',1.09),('15128','2013-07-22','18:45:00',1.2),('15128','2013-07-22','18:50:00',1.38),('15128','2013-07-22','18:55:00',1.36),('15128','2013-07-22','19:00:00',1.24),('15128','2013-07-22','19:05:00',1.15),('15128','2013-07-22','19:10:00',1.03),('15128','2013-07-21','08:15:00',1.04),('15128','2013-07-21','08:20:00',1.12),('15128','2013-07-21','08:25:00',1.16),('15128','2013-07-21','08:30:00',1.2),('15128','2013-07-21','08:35:00',1.28),('15128','2013-07-21','08:40:00',1.38),('15128','2013-07-21','08:45:00',1.45),('15128','2013-07-21','08:50:00',1.52),('15128','2013-07-21','08:55:00',1.58),('15128','2013-07-21','09:00:00',1.65),('15128','2013-07-21','09:05:00',1.72),('15128','2013-07-21','09:10:00',1.81),('15128','2013-07-21','09:15:00',1.88),('15128','2013-07-21','09:20:00',1.98),('15128','2013-07-21','09:25:00',2.06),('15128','2013-07-21','09:30:00',2.01),('15128','2013-07-21','09:35:00',2.11),('15128','2013-07-21','09:40:00',2.15),('15128','2013-07-21','09:45:00',2.21),('15128','2013-07-21','09:50:00',2.31),('15128','2013-07-21','09:55:00',2.33),('15128','2013-07-21','10:00:00',2.41),('15128','2013-07-21','10:05:00',2.47),('15128','2013-07-21','10:10:00',2.53),('15128','2013-07-21','10:15:00',2.54),('15128','2013-07-21','10:20:00',2.6),('15128','2013-07-21','10:25:00',2.67),('15128','2013-07-21','10:30:00',2.71),('15128','2013-07-21','10:35:00',2.78),('15128','2013-07-21','10:40:00',2.79),('15128','2013-07-21','10:45:00',2.87),('15128','2013-07-21','10:50:00',2.98),('15128','2013-07-21','10:55:00',3.01),('15128','2013-07-21','11:00:00',3.1),('15128','2013-07-21','11:05:00',3.12),('15128','2013-07-21','11:10:00',3.19),('15128','2013-07-21','11:15:00',3.22),('15128','2013-07-21','11:20:00',3.28),('15128','2013-07-21','11:25:00',3.32),('15128','2013-07-21','11:30:00',3.33),('15128','2013-07-21','11:35:00',3.4),('15128','2013-07-21','11:40:00',3.42),('15128','2013-07-21','11:45:00',3.48),('15128','2013-07-21','11:50:00',3.68),('15128','2013-07-21','11:55:00',3.76),('15128','2013-07-21','12:00:00',3.78),('15128','2013-07-21','12:05:00',3.84),('15128','2013-07-21','12:10:00',3.89),('15128','2013-07-21','12:15:00',3.92),('15128','2013-07-21','12:20:00',3.94),('15128','2013-07-21','12:25:00',3.97),('15128','2013-07-21','12:30:00',3.98),('15128','2013-07-21','12:35:00',4),('15128','2013-07-21','12:40:00',4.02),('15128','2013-07-21','12:45:00',4.05),('15128','2013-07-21','12:50:00',4.08),('15128','2013-07-21','12:55:00',4.08),('15128','2013-07-21','13:00:00',4.06),('15128','2013-07-21','13:05:00',4.1),('15128','2013-07-21','13:10:00',4.16),('15128','2013-07-21','13:15:00',4.2),('15128','2013-07-21','13:20:00',4.17),('15128','2013-07-21','13:25:00',4.16),('15128','2013-07-21','13:30:00',4.12),('15128','2013-07-21','13:35:00',4.17),('15128','2013-07-21','13:40:00',4.14),('15128','2013-07-21','13:45:00',4.16),('15128','2013-07-21','13:50:00',4.23),('15128','2013-07-21','13:55:00',4.2),('15128','2013-07-21','14:00:00',4.18),('15128','2013-07-21','14:05:00',4.17),('15128','2013-07-21','14:10:00',4.17),('15128','2013-07-21','14:15:00',4.17),('15128','2013-07-21','14:20:00',4.15),('15128','2013-07-21','14:25:00',4.18),('15128','2013-07-21','14:30:00',4.13),('15128','2013-07-21','14:35:00',4.12),('15128','2013-07-21','14:40:00',3.01),('15128','2013-07-21','14:45:00',3.88),('15128','2013-07-21','14:50:00',3.92),('15128','2013-07-21','14:55:00',2.88),('15128','2013-07-21','15:00:00',4.01),('15128','2013-07-21','15:05:00',3.68),('15128','2013-07-21','15:10:00',4.17),('15128','2013-07-21','15:15:00',4.22),('15128','2013-07-21','15:20:00',4.22),('15128','2013-07-21','15:25:00',4.16),('15128','2013-07-21','15:30:00',2.33),('15128','2013-07-21','15:35:00',1.16),('15128','2013-07-21','15:40:00',1.01),('15128','2013-07-21','15:45:00',1.06),('15128','2013-07-21','15:50:00',1.2),('15128','2013-07-21','15:55:00',1.24),('15128','2013-07-21','16:00:00',1.39),('15128','2013-07-21','16:05:00',3.85),('15128','2013-07-21','16:10:00',3.94),('15128','2013-07-21','16:15:00',3.81),('15128','2013-07-21','16:20:00',3.73),('15128','2013-07-21','16:25:00',3.61),('15128','2013-07-21','16:30:00',3.43),('15128','2013-07-21','16:35:00',3.38),('15128','2013-07-21','16:40:00',3.25),('15128','2013-07-21','16:45:00',2.73),('15128','2013-07-21','16:50:00',3.14),('15128','2013-07-21','16:55:00',3.22),('15128','2013-07-21','17:00:00',3.12),('15128','2013-07-21','17:05:00',3.01),('15128','2013-07-21','17:10:00',2.94),('15128','2013-07-21','17:15:00',2.87),('15128','2013-07-21','17:20:00',2.88),('15128','2013-07-21','17:25:00',2.84),('15128','2013-07-21','17:30:00',2.8),('15128','2013-07-21','17:35:00',2.79),('15128','2013-07-21','17:40:00',2.83),('15128','2013-07-21','17:45:00',2.7),('15128','2013-07-21','17:50:00',2.52),('15128','2013-07-21','17:55:00',2.44),('15128','2013-07-21','18:00:00',2.31),('15128','2013-07-21','18:05:00',2.09),('15128','2013-07-21','18:10:00',1.95),('15128','2013-07-21','18:15:00',1.77),('15128','2013-07-21','18:20:00',1.72),('15128','2013-07-21','18:25:00',1.73),('15128','2013-07-21','18:30:00',1.63),('15128','2013-07-21','18:35:00',1.61),('15128','2013-07-21','18:40:00',1.43),('15128','2013-07-21','18:45:00',1.27),('15128','2013-07-21','18:50:00',1.07),('15128','2013-07-21','18:55:00',1.23),('15128','2013-07-21','19:00:00',1.15),('15128','2013-07-21','19:05:00',1.06),('15128','2013-07-20','08:15:00',1.01),('15128','2013-07-20','08:20:00',1.06),('15128','2013-07-20','08:25:00',1.13),('15128','2013-07-20','08:30:00',1.17),('15128','2013-07-20','08:35:00',1.26),('15128','2013-07-20','08:40:00',1.34),('15128','2013-07-20','08:45:00',1.41),('15128','2013-07-20','08:50:00',1.47),('15128','2013-07-20','08:55:00',1.54),('15128','2013-07-20','09:00:00',1.61),('15128','2013-07-20','09:05:00',1.69),('15128','2013-07-20','09:10:00',1.78),('15128','2013-07-20','09:15:00',1.86),('15128','2013-07-20','09:20:00',1.97),('15128','2013-07-20','09:25:00',2.02),('15128','2013-07-20','09:30:00',2.04),('15128','2013-07-20','09:35:00',2.09),('15128','2013-07-20','09:40:00',2.13),('15128','2013-07-20','09:45:00',2.18),('15128','2013-07-20','09:50:00',2.21),('15128','2013-07-20','09:55:00',2.26),('15128','2013-07-20','10:00:00',2.35),('15128','2013-07-20','10:05:00',2.39),('15128','2013-07-20','10:10:00',2.49),('15128','2013-07-20','10:15:00',2.49),('15128','2013-07-20','10:20:00',2.56),('15128','2013-07-20','10:25:00',2.64),('15128','2013-07-20','10:30:00',2.68),('15128','2013-07-20','10:35:00',2.74),('15128','2013-07-20','10:40:00',2.74),('15128','2013-07-20','10:45:00',2.82),('15128','2013-07-20','10:50:00',2.93),('15128','2013-07-20','10:55:00',2.98),('15128','2013-07-20','11:00:00',3.06),('15128','2013-07-20','11:05:00',3.09),('15128','2013-07-20','11:10:00',3.14),('15128','2013-07-20','11:15:00',3.18),('15128','2013-07-20','11:20:00',3.23),('15128','2013-07-20','11:25:00',3.24),('15128','2013-07-20','11:30:00',3.26),('15128','2013-07-20','11:35:00',3.33),('15128','2013-07-20','11:40:00',3.41),('15128','2013-07-20','11:45:00',3.48),('15128','2013-07-20','11:50:00',3.64),('15128','2013-07-20','11:55:00',3.75),('15128','2013-07-20','12:00:00',3.83),('15128','2013-07-20','12:05:00',3.87),('15128','2013-07-20','12:10:00',3.85),('15128','2013-07-20','12:15:00',3.81),('15128','2013-07-20','12:20:00',3.62),('15128','2013-07-20','12:25:00',3.04),('15128','2013-07-20','12:30:00',2.25),('15128','2013-07-20','12:35:00',2.18),('15128','2013-07-20','12:40:00',1.97),('15128','2013-07-20','12:45:00',1.99),('15128','2013-07-20','12:50:00',2.81),('15128','2013-07-20','12:55:00',2.34),('15128','2013-07-20','13:00:00',1.87),('15128','2013-07-20','13:05:00',1.96),('15128','2013-07-20','13:10:00',2.12),('15128','2013-07-20','13:15:00',3.05),('15128','2013-07-20','13:20:00',2.93),('15128','2013-07-20','13:25:00',2.04),('15128','2013-07-20','13:30:00',1.87),('15128','2013-07-20','13:35:00',1.87),('15128','2013-07-20','13:40:00',2.12),('15128','2013-07-20','13:45:00',2.5),('15128','2013-07-20','13:50:00',3.02),('15128','2013-07-20','13:55:00',3.27),('15128','2013-07-20','14:00:00',2.69),('15128','2013-07-20','14:05:00',2.92),('15128','2013-07-20','14:10:00',2.46),('15128','2013-07-20','14:15:00',2.43),('15128','2013-07-20','14:20:00',1.91),('15128','2013-07-20','14:25:00',1.81),('15128','2013-07-20','14:30:00',1.54),('15128','2013-07-20','14:35:00',1.42),('15128','2013-07-20','14:40:00',1.43),('15128','2013-07-20','14:45:00',1.5),('15128','2013-07-20','14:50:00',1.96),('15128','2013-07-20','14:55:00',1.74),('15128','2013-07-20','15:00:00',1.4),('15128','2013-07-20','15:05:00',1.37),('15128','2013-07-20','15:10:00',1.37),('15128','2013-07-20','15:15:00',1.44),('15128','2013-07-20','15:20:00',1.67),('15128','2013-07-20','15:25:00',1.65),('15128','2013-07-20','15:30:00',1.79),('15128','2013-07-20','15:35:00',2.24),('15128','2013-07-20','15:40:00',2.65),('15128','2013-07-20','15:45:00',2.28),('15128','2013-07-20','15:50:00',2.57),('15128','2013-07-20','15:55:00',2.02),('15128','2013-07-20','16:00:00',1.41),('15128','2013-07-20','16:05:00',1.03),('15128','2013-07-20','16:35:00',1.16),('15128','2013-07-20','16:40:00',1.2),('15128','2013-07-20','16:45:00',1.19),('15128','2013-07-20','16:50:00',1.15),('15128','2013-07-20','16:55:00',1.13),('15128','2013-07-20','17:00:00',1.33),('15128','2013-07-20','17:05:00',1.88),('15128','2013-07-20','17:10:00',1.43),('15128','2014-04-06','09:30:00',1.03),('15128','2014-04-06','09:35:00',1.07),('15128','2014-04-06','09:40:00',1.11),('15128','2014-04-06','09:45:00',1.12),('15128','2014-04-06','09:50:00',1.13),('15128','2014-04-06','09:55:00',1.15),('15128','2014-04-06','10:00:00',1.16),('15128','2014-04-06','10:05:00',1.18),('15128','2014-04-06','10:10:00',1.19),('15128','2014-04-06','10:15:00',1.22),('15128','2014-04-06','10:20:00',1.21),('15128','2014-04-06','10:25:00',1.2),('15128','2014-04-06','10:30:00',1.23),('15128','2014-04-06','10:35:00',1.28),('15128','2014-04-06','10:40:00',1.36),('15128','2014-04-06','10:45:00',1.43),('15128','2014-04-06','10:50:00',1.44),('15128','2014-04-06','10:55:00',1.48),('15128','2014-04-06','11:00:00',1.5),('15128','2014-04-06','11:05:00',1.51),('15128','2014-04-06','11:10:00',1.55),('15128','2014-04-06','11:15:00',1.59),('15128','2014-04-06','11:20:00',1.6),('15128','2014-04-06','11:25:00',1.58),('15128','2014-04-06','11:30:00',1.52),('15128','2014-04-06','11:35:00',1.49),('15128','2014-04-06','11:40:00',1.48),('15128','2014-04-06','11:45:00',1.49),('15128','2014-04-06','11:50:00',1.55),('15128','2014-04-06','11:55:00',1.79),('15128','2014-04-06','12:00:00',2.2),('15128','2014-04-06','12:05:00',2.96),('15128','2014-04-06','12:10:00',3.54),('15128','2014-04-06','12:15:00',3.44),('15128','2014-04-06','12:20:00',2.76),('15128','2014-04-06','12:25:00',1.53),('15128','2014-04-06','12:30:00',2.24),('15128','2014-04-06','12:35:00',3.85),('15128','2014-04-06','12:40:00',3.8),('15128','2014-04-06','12:45:00',3.7),('15128','2014-04-06','12:50:00',3.64),('15128','2014-04-06','12:55:00',3.66),('15128','2014-04-06','13:00:00',3.67),('15128','2014-04-06','13:05:00',3.68),('15128','2014-04-06','13:10:00',3.69),('15128','2014-04-06','13:15:00',3.68),('15128','2014-04-06','13:20:00',3.69),('15128','2014-04-06','13:25:00',3.68),('15128','2014-04-06','13:30:00',3.71),('15128','2014-04-06','13:35:00',3.77),('15128','2014-04-06','13:40:00',3.73),('15128','2014-04-06','13:45:00',3.72),('15128','2014-04-06','13:50:00',3.69),('15128','2014-04-06','13:55:00',3.71),('15128','2014-04-06','14:00:00',3.74),('15128','2014-04-06','14:05:00',3.74),('15128','2014-04-06','14:10:00',3.76),('15128','2014-04-06','14:15:00',3.73),('15128','2014-04-06','14:20:00',3.68),('15128','2014-04-06','14:25:00',3.67),('15128','2014-04-06','14:30:00',3.72),('15128','2014-04-06','14:35:00',3.74),('15128','2014-04-06','14:40:00',3.76),('15128','2014-04-06','14:45:00',3.66),('15128','2014-04-06','14:50:00',2.36),('15128','2014-04-06','14:55:00',3.7),('15128','2014-04-06','15:00:00',3.69),('15128','2014-04-06','15:05:00',3.6),('15128','2014-04-06','15:10:00',3.57),('15128','2014-04-06','15:15:00',3.58),('15128','2014-04-06','15:20:00',3.58),('15128','2014-04-06','15:25:00',3.5),('15128','2014-04-06','15:30:00',3.48),('15128','2014-04-06','15:35:00',3.45),('15128','2014-04-06','15:40:00',3.44),('15128','2014-04-06','15:45:00',3.38),('15128','2014-04-06','15:50:00',3.37),('15128','2014-04-06','15:55:00',3.38),('15128','2014-04-06','16:00:00',3.3),('15128','2014-04-06','16:05:00',3.37),('15128','2014-04-06','16:10:00',3.06),('15128','2014-04-06','16:30:00',1.01),('15128','2014-04-06','16:35:00',1.15),('15128','2014-04-06','16:45:00',2.22),('15128','2014-04-06','16:50:00',2.59),('15128','2014-04-06','16:55:00',3.03),('15128','2014-04-06','17:00:00',3.02),('15128','2014-04-06','17:05:00',2.95),('15128','2014-04-06','17:10:00',2.76),('15128','2014-04-06','17:15:00',2.52),('15128','2014-04-06','17:20:00',2.16),('15128','2014-04-06','17:25:00',2.22),('15128','2014-04-06','17:30:00',2.03),('15128','2014-04-06','17:35:00',2.09),('15128','2014-04-06','17:40:00',2.05),('15128','2014-04-06','17:45:00',1.74),('15128','2014-04-06','17:50:00',1.43),('15128','2014-04-06','17:55:00',1.33),('15128','2014-04-06','18:00:00',1.26),('15128','2014-04-06','18:05:00',1.3),('15128','2014-04-06','18:10:00',1.26),('15128','2014-04-06','18:15:00',1.23),('15128','2014-04-06','18:20:00',1.03),('15128','2013-07-19','08:15:00',1.06),('15128','2013-07-19','08:20:00',1.13),('15128','2013-07-19','08:25:00',1.18),('15128','2013-07-19','08:30:00',1.24),('15128','2013-07-19','08:35:00',1.34),('15128','2013-07-19','08:40:00',1.43),('15128','2013-07-19','08:45:00',1.51),('15128','2013-07-19','08:50:00',1.58),('15128','2013-07-19','08:55:00',1.66),('15128','2013-07-19','09:00:00',1.72),('15128','2013-07-19','09:05:00',1.85),('15128','2013-07-19','09:10:00',1.97),('15128','2013-07-19','09:15:00',2.04),('15128','2013-07-19','09:20:00',2.08),('15128','2013-07-19','09:25:00',2.1),('15128','2013-07-19','09:30:00',2.12),('15128','2013-07-19','09:35:00',2.14),('15128','2013-07-19','09:40:00',2.07),('15128','2013-07-19','09:45:00',2.14),('15128','2013-07-19','09:50:00',2.1),('15128','2013-07-19','09:55:00',2.33),('15128','2013-07-19','10:00:00',2.4),('15128','2013-07-19','10:05:00',2.45),('15128','2013-07-19','10:10:00',2.53),('15128','2013-07-19','10:15:00',2.55),('15128','2013-07-19','10:20:00',2.6),('15128','2013-07-19','10:25:00',2.67),('15128','2013-07-19','10:30:00',2.72),('15128','2013-07-19','10:35:00',2.75),('15128','2013-07-19','10:40:00',2.81),('15128','2013-07-19','10:45:00',2.86),('15128','2013-07-19','10:50:00',2.97),('15128','2013-07-19','10:55:00',3.05),('15128','2013-07-19','11:00:00',3.15),('15128','2013-07-19','11:05:00',3.18),('15128','2013-07-19','11:10:00',3.21),('15128','2013-07-19','11:15:00',3.25),('15128','2013-07-19','11:20:00',3.32),('15128','2013-07-19','11:25:00',3.37),('15128','2013-07-19','11:30:00',3.37),('15128','2013-07-19','11:35:00',3.42),('15128','2013-07-19','11:40:00',3.48),('15128','2013-07-19','11:45:00',3.62),('15128','2013-07-19','11:50:00',3.71),('15128','2013-07-19','11:55:00',3.78),('15128','2013-07-19','12:00:00',3.83),('15128','2013-07-19','12:05:00',3.83),('15128','2013-07-19','12:10:00',3.9),('15128','2013-07-19','12:15:00',3.92),('15128','2013-07-19','12:20:00',3.97),('15128','2013-07-19','12:25:00',4),('15128','2013-07-19','12:30:00',4.04),('15128','2013-07-19','12:35:00',4.09),('15128','2013-07-19','12:40:00',4.12),('15128','2013-07-19','12:45:00',4.07),('15128','2013-07-19','12:50:00',4.09),('15128','2013-07-19','12:55:00',4.12),('15128','2013-07-19','13:00:00',4.24),('15128','2013-07-19','13:05:00',4.24),('15128','2013-07-19','13:10:00',4.28),('15128','2013-07-19','13:15:00',4.12),('15128','2013-07-19','13:20:00',4.09),('15128','2013-07-19','13:25:00',4.31),('15128','2013-07-19','13:30:00',3.78),('15128','2013-07-19','13:35:00',3.11),('15128','2013-07-19','13:40:00',1.84),('15128','2013-07-19','13:45:00',4.65),('15128','2013-07-19','13:50:00',4.43),('15128','2013-07-19','13:55:00',4.33),('15128','2013-07-19','14:00:00',4.39),('15128','2013-07-19','14:05:00',4.29),('15128','2013-07-19','14:10:00',4.33),('15128','2013-07-19','14:15:00',4.27),('15128','2013-07-19','14:20:00',4.22),('15128','2013-07-19','14:25:00',3.55),('15128','2013-07-19','14:30:00',4.15),('15128','2013-07-19','14:35:00',4.25),('15128','2013-07-19','14:40:00',4.22),('15128','2013-07-19','14:45:00',4.22),('15128','2013-07-19','14:50:00',4.19),('15128','2013-07-19','14:55:00',4.15),('15128','2013-07-19','15:00:00',4.14),('15128','2013-07-19','15:05:00',4.12),('15128','2013-07-19','15:10:00',4.12),('15128','2013-07-19','15:15:00',4.11),('15128','2013-07-19','15:20:00',4.08),('15128','2013-07-19','15:25:00',4.06),('15128','2013-07-19','15:30:00',4.06),('15128','2013-07-19','15:35:00',4.03),('15128','2013-07-19','15:40:00',4.02),('15128','2013-07-19','15:45:00',3.98),('15128','2013-07-19','15:50:00',3.93),('15128','2013-07-19','15:55:00',3.89),('15128','2013-07-19','16:00:00',3.86),('15128','2013-07-19','16:05:00',3.8),('15128','2013-07-19','16:10:00',3.74),('15128','2013-07-19','16:15:00',3.7),('15128','2013-07-19','16:20:00',3.64),('15128','2013-07-19','16:25:00',3.59),('15128','2013-07-19','16:30:00',3.54),('15128','2013-07-19','16:35:00',3.48),('15128','2013-07-19','16:40:00',3.45),('15128','2013-07-19','16:45:00',3.4),('15128','2013-07-19','16:50:00',3.35),('15128','2013-07-19','16:55:00',3.29),('15128','2013-07-19','17:00:00',3.24),('15128','2013-07-19','17:05:00',3.17),('15128','2013-07-19','17:10:00',3.1),('15128','2013-07-19','17:15:00',3.04),('15128','2013-07-19','17:20:00',2.97),('15128','2013-07-19','17:25:00',2.88),('15128','2013-07-19','17:30:00',2.82),('15128','2013-07-19','17:35:00',2.75),('15128','2013-07-19','17:40:00',2.66),('15128','2013-07-19','17:45:00',2.59),('15128','2013-07-19','17:50:00',2.49),('15128','2013-07-19','17:55:00',2.4),('15128','2013-07-19','18:00:00',2.27),('15128','2013-07-19','18:05:00',2.15),('15128','2013-07-19','18:10:00',2),('15128','2013-07-19','18:15:00',1.92),('15128','2013-07-19','18:20:00',1.82),('15128','2013-07-19','18:25:00',1.78),('15128','2013-07-19','18:30:00',1.67),('15128','2013-07-19','18:35:00',1.57),('15128','2013-07-19','18:40:00',1.5),('15128','2013-07-19','18:45:00',1.42),('15128','2013-07-19','18:50:00',1.34),('15128','2013-07-19','18:55:00',1.25),('15128','2013-07-19','19:00:00',1.14),('15128','2013-07-19','19:05:00',1.04),('15128','2013-07-18','08:15:00',1.01),('15128','2013-07-18','08:20:00',1.07),('15128','2013-07-18','08:25:00',1.12),('15128','2013-07-18','08:30:00',1.19),('15128','2013-07-18','08:35:00',1.27),('15128','2013-07-18','08:40:00',1.33),('15128','2013-07-18','08:45:00',1.43),('15128','2013-07-18','08:50:00',1.5),('15128','2013-07-18','08:55:00',1.55),('15128','2013-07-18','09:00:00',1.62),('15128','2013-07-18','09:05:00',1.68),('15128','2013-07-18','09:10:00',1.78),('15128','2013-07-18','09:15:00',1.87),('15128','2013-07-18','09:20:00',1.94),('15128','2013-07-18','09:25:00',2.01),('15128','2013-07-18','09:30:00',1.99),('15128','2013-07-18','09:35:00',2.06),('15128','2013-07-18','09:40:00',2.11),('15128','2013-07-18','09:45:00',2.16),('15128','2013-07-18','09:50:00',2.22),('15128','2013-07-18','09:55:00',2.23),('15128','2013-07-18','10:00:00',2.29),('15128','2013-07-18','10:05:00',2.42),('15128','2013-07-18','10:10:00',2.52),('15128','2013-07-18','10:15:00',2.48),('15128','2013-07-18','10:20:00',2.52),('15128','2013-07-18','10:25:00',2.62),('15128','2013-07-18','10:30:00',2.67),('15128','2013-07-18','10:35:00',2.69),('15128','2013-07-18','10:40:00',2.81),('15128','2013-07-18','10:45:00',2.84),('15128','2013-07-18','10:50:00',2.91),('15128','2013-07-18','10:55:00',2.97),('15128','2013-07-18','11:00:00',3.02),('15128','2013-07-18','11:05:00',3.06),('15128','2013-07-18','11:10:00',3.12),('15128','2013-07-18','11:15:00',3.16),('15128','2013-07-18','11:20:00',3.2),('15128','2013-07-18','11:25:00',3.25),('15128','2013-07-18','11:30:00',3.34),('15128','2013-07-18','11:35:00',3.38),('15128','2013-07-18','11:40:00',3.38),('15128','2013-07-18','11:45:00',3.34),('15128','2013-07-18','11:50:00',3.54),('15128','2013-07-18','11:55:00',3.62),('15128','2013-07-18','12:00:00',3.81),('15128','2013-07-18','12:05:00',3.54),('15128','2013-07-18','12:10:00',2.37),('15128','2013-07-18','12:15:00',3.93),('15128','2013-07-18','12:20:00',3.88),('15128','2013-07-18','12:25:00',3.92),('15128','2013-07-18','12:30:00',3.94),('15128','2013-07-18','12:35:00',3.83),('15128','2013-07-18','12:40:00',4),('15128','2013-07-18','12:45:00',4.04),('15128','2013-07-18','12:50:00',4.08),('15128','2013-07-18','12:55:00',4.11),('15128','2013-07-18','13:00:00',4.09),('15128','2013-07-18','13:05:00',4.17),('15128','2013-07-18','13:10:00',4.26),('15128','2013-07-18','13:15:00',4.2),('15128','2013-07-18','13:20:00',4.28),('15128','2013-07-18','13:25:00',4.26),('15128','2013-07-18','13:30:00',4.3),('15128','2013-07-18','13:35:00',4.34),('15128','2013-07-18','13:40:00',4.34),('15128','2013-07-18','13:45:00',4.34),('15128','2013-07-18','13:50:00',4.39),('15128','2013-07-18','13:55:00',4.25),('15128','2013-07-18','14:00:00',4.3),('15128','2013-07-18','14:05:00',4.33),('15128','2013-07-18','14:10:00',4.33),('15128','2013-07-18','14:15:00',4.35),('15128','2013-07-18','14:20:00',4.36),('15128','2013-07-18','14:25:00',4.38),('15128','2013-07-18','14:30:00',4.34),('15128','2013-07-18','14:35:00',4.28),('15128','2013-07-18','14:40:00',4.37),('15128','2013-07-18','14:45:00',3.76),('15128','2013-07-18','14:50:00',4.04),('15128','2013-07-18','14:55:00',4.19),('15128','2013-07-18','15:00:00',3.99),('15128','2013-07-18','15:05:00',4.38),('15128','2013-07-18','15:10:00',3.33),('15128','2013-07-18','15:15:00',1.73),('15128','2013-07-18','15:20:00',2.55),('15128','2013-07-18','15:25:00',2.78),('15128','2013-07-18','15:30:00',4.07),('15128','2013-07-18','15:35:00',4.22),('15128','2013-07-18','15:40:00',4.19),('15128','2013-07-18','15:45:00',4.03),('15128','2013-07-18','15:50:00',3.98),('15128','2013-07-18','15:55:00',3.91),('15128','2013-07-18','16:00:00',3.75),('15128','2013-07-18','16:05:00',3.79),('15128','2013-07-18','16:10:00',3.76),('15128','2013-07-18','16:15:00',3.7),('15128','2013-07-18','16:20:00',3.65),('15128','2013-07-18','16:25:00',3.65),('15128','2013-07-18','16:30:00',3.61),('15128','2013-07-18','16:35:00',3.42),('15128','2013-07-18','16:40:00',3.32),('15128','2013-07-18','16:45:00',3.56),('15128','2013-07-18','16:50:00',3.53),('15128','2013-07-18','16:55:00',3.48),('15128','2013-07-18','17:00:00',3.41),('15128','2013-07-18','17:05:00',2.61),('15128','2013-07-18','17:10:00',2.12),('15128','2013-07-18','17:15:00',1.78),('15128','2013-07-18','17:20:00',2.26),('15128','2013-07-18','17:25:00',2.91),('15128','2013-07-18','17:30:00',2.27),('15128','2013-07-18','17:35:00',1.71),('15128','2013-07-18','17:40:00',2.06),('15128','2013-07-18','17:45:00',1.54),('15128','2013-07-18','17:50:00',1.2),('15128','2013-07-17','08:15:00',1.05),('15128','2013-07-17','08:20:00',1.12),('15128','2013-07-17','08:25:00',1.17),('15128','2013-07-17','08:30:00',1.24),('15128','2013-07-17','08:35:00',1.3),('15128','2013-07-17','08:40:00',1.37),('15128','2013-07-17','08:45:00',1.48),('15128','2013-07-17','08:50:00',1.55),('15128','2013-07-17','08:55:00',1.63),('15128','2013-07-17','09:00:00',1.7),('15128','2013-07-17','09:05:00',1.79),('15128','2013-07-17','09:10:00',1.86),('15128','2013-07-17','09:15:00',1.95),('15128','2013-07-17','09:20:00',2.05),('15128','2013-07-17','09:25:00',2.1),('15128','2013-07-17','09:30:00',2.07),('15128','2013-07-17','09:35:00',2.19),('15128','2013-07-17','09:40:00',2.26),('15128','2013-07-17','09:45:00',2.3),('15128','2013-07-17','09:50:00',2.35),('15128','2013-07-17','09:55:00',2.35),('15128','2013-07-17','10:00:00',2.4),('15128','2013-07-17','10:05:00',2.51),('15128','2013-07-17','10:10:00',2.57),('15128','2013-07-17','10:15:00',2.58),('15128','2013-07-17','10:20:00',2.62),('15128','2013-07-17','10:25:00',2.69),('15128','2013-07-17','10:30:00',2.76),('15128','2013-07-17','10:35:00',2.78),('15128','2013-07-17','10:40:00',2.87),('15128','2013-07-17','10:45:00',2.82),('15128','2013-07-17','10:50:00',2.98),('15128','2013-07-17','10:55:00',3.03),('15128','2013-07-17','11:00:00',3.09),('15128','2013-07-17','11:05:00',3.15),('15128','2013-07-17','11:10:00',3.17),('15128','2013-07-17','11:15:00',3.2),('15128','2013-07-17','11:20:00',3.28),('15128','2013-07-17','11:25:00',3.32),('15128','2013-07-17','11:30:00',3.36),('15128','2013-07-17','11:35:00',3.36),('15128','2013-07-17','11:40:00',3.48),('15128','2013-07-17','11:45:00',3.61),('15128','2013-07-17','11:50:00',3.68),('15128','2013-07-17','11:55:00',3.75),('15128','2013-07-17','12:00:00',3.81),('15128','2013-07-17','12:05:00',3.84),('15128','2013-07-17','12:10:00',3.87),('15128','2013-07-17','12:15:00',3.95),('15128','2013-07-17','12:20:00',3.97),('15128','2013-07-17','12:25:00',3.99),('15128','2013-07-17','12:30:00',4),('15128','2013-07-17','12:35:00',4.05),('15128','2013-07-17','12:40:00',4.09),('15128','2013-07-17','12:45:00',4.09),('15128','2013-07-17','12:50:00',4.12),('15128','2013-07-17','12:55:00',4.13),('15128','2013-07-17','13:00:00',4.14),('15128','2013-07-17','13:05:00',4.17),('15128','2013-07-17','13:10:00',4.17),('15128','2013-07-17','13:15:00',4.15),('15128','2013-07-17','13:20:00',4.2),('15128','2013-07-17','13:25:00',4.22),('15128','2013-07-17','13:30:00',4.22),('15128','2013-07-17','13:35:00',4.24),('15128','2013-07-17','13:40:00',4.25),('15128','2013-07-17','13:45:00',4.31),('15128','2013-07-17','13:50:00',4.32),('15128','2013-07-17','13:55:00',4.3),('15128','2013-07-17','14:00:00',4.33),('15128','2013-07-17','14:05:00',4.35),('15128','2013-07-17','14:10:00',4.36),('15128','2013-07-17','14:15:00',4.33),('15128','2013-07-17','14:20:00',4.29),('15128','2013-07-17','14:25:00',4.31),('15128','2013-07-17','14:30:00',4.29),('15128','2013-07-17','14:35:00',4.29),('15128','2013-07-17','14:40:00',4.26),('15128','2013-07-17','14:45:00',4.23),('15128','2013-07-17','14:50:00',4.24),('15128','2013-07-17','14:55:00',4.18),('15128','2013-07-17','15:00:00',4.15),('15128','2013-07-17','15:05:00',4.14),('15128','2013-07-17','15:10:00',4.14),('15128','2013-07-17','15:15:00',4.12),('15128','2013-07-17','15:20:00',4.07),('15128','2013-07-17','15:25:00',4.05),('15128','2013-07-17','15:30:00',4.04),('15128','2013-07-17','15:35:00',4),('15128','2013-07-17','15:40:00',3.97),('15128','2013-07-17','15:45:00',3.95),('15128','2013-07-17','15:50:00',3.89),('15128','2013-07-17','15:55:00',3.87),('15128','2013-07-17','16:00:00',3.84),('15128','2013-07-17','16:05:00',3.77),('15128','2013-07-17','16:10:00',3.72),('15128','2013-07-17','16:15:00',3.66),('15128','2013-07-17','16:20:00',3.62),('15128','2013-07-17','16:25:00',3.57),('15128','2013-07-17','16:30:00',3.51),('15128','2013-07-17','16:35:00',3.46),('15128','2013-07-17','16:40:00',3.39),('15128','2013-07-17','16:45:00',3.34),('15128','2013-07-17','16:50:00',3.28),('15128','2013-07-17','16:55:00',3.25),('15128','2013-07-17','17:00:00',3.17),('15128','2013-07-17','17:05:00',3.12),('15128','2013-07-17','17:10:00',3.06),('15128','2013-07-17','17:15:00',3.01),('15128','2013-07-17','17:20:00',2.93),('15128','2013-07-17','17:25:00',2.83),('15128','2013-07-17','17:30:00',2.64),('15128','2013-07-17','17:35:00',2.55),('15128','2013-07-17','17:40:00',2.49),('15128','2013-07-17','17:45:00',2.39),('15128','2013-07-17','17:50:00',1.99),('15128','2013-07-17','17:55:00',2.08),('15128','2013-07-17','18:00:00',2.04),('15128','2013-07-17','18:10:00',1.25),('15128','2013-07-17','18:15:00',1.12),('15128','2013-07-17','18:40:00',1.25),('15128','2013-07-17','18:45:00',1.54),('15128','2013-07-17','18:50:00',1.51),('15128','2013-07-17','18:55:00',1.41),('15128','2013-07-17','19:00:00',1.15),('15128','2013-07-17','19:05:00',1.07),('15128','2013-07-17','19:10:00',1.07),('15128','2013-07-17','19:15:00',1.02),('15128','2013-07-16','08:10:00',1.04),('15128','2013-07-16','08:15:00',1.1),('15128','2013-07-16','08:20:00',1.17),('15128','2013-07-16','08:25:00',1.23),('15128','2013-07-16','08:30:00',1.29),('15128','2013-07-16','08:35:00',1.38),('15128','2013-07-16','08:40:00',1.44),('15128','2013-07-16','08:45:00',1.53),('15128','2013-07-16','08:50:00',1.61),('15128','2013-07-16','08:55:00',1.68),('15128','2013-07-16','09:00:00',1.73),('15128','2013-07-16','09:05:00',1.8),('15128','2013-07-16','09:10:00',1.88),('15128','2013-07-16','09:15:00',2),('15128','2013-07-16','09:20:00',2.09),('15128','2013-07-16','09:25:00',2.1),('15128','2013-07-16','09:30:00',2.16),('15128','2013-07-16','09:35:00',2.23),('15128','2013-07-16','09:40:00',2.29),('15128','2013-07-16','09:45:00',2.36),('15128','2013-07-16','09:50:00',2.42),('15128','2013-07-16','09:55:00',2.38),('15128','2013-07-16','10:00:00',2.45),('15128','2013-07-16','10:05:00',2.56),('15128','2013-07-16','10:10:00',2.63),('15128','2013-07-16','10:15:00',2.66),('15128','2013-07-16','10:20:00',2.74),('15128','2013-07-16','10:25:00',2.77),('15128','2013-07-16','10:30:00',2.86),('15128','2013-07-16','10:35:00',2.84),('15128','2013-07-16','10:40:00',2.96),('15128','2013-07-16','10:45:00',2.98),('15128','2013-07-16','10:50:00',3.06),('15128','2013-07-16','10:55:00',3.16),('15128','2013-07-16','11:00:00',3.14),('15128','2013-07-16','11:05:00',3.24),('15128','2013-07-16','11:10:00',3.25),('15128','2013-07-16','11:15:00',3.33),('15128','2013-07-16','11:20:00',3.44),('15128','2013-07-16','11:25:00',3.47),('15128','2013-07-16','11:30:00',3.51),('15128','2013-07-16','11:35:00',3.47),('15128','2013-07-16','11:40:00',3.56),('15128','2013-07-16','11:45:00',3.65),('15128','2013-07-16','11:50:00',3.77),('15128','2013-07-16','11:55:00',3.9),('15128','2013-07-16','12:00:00',3.95),('15128','2013-07-16','12:05:00',3.99),('15128','2013-07-16','12:10:00',4.04),('15128','2013-07-16','12:15:00',4.04),('15128','2013-07-16','12:20:00',4.11),('15128','2013-07-16','12:25:00',4.15),('15128','2013-07-16','12:30:00',4.18),('15128','2013-07-16','12:35:00',4.22),('15128','2013-07-16','12:40:00',4.25),('15128','2013-07-16','12:45:00',4.23),('15128','2013-07-16','12:50:00',4.23),('15128','2013-07-16','12:55:00',4.24),('15128','2013-07-16','13:00:00',4.22),('15128','2013-07-16','13:05:00',4.23),('15128','2013-07-16','13:10:00',4.32),('15128','2013-07-16','13:15:00',4.28),('15128','2013-07-16','13:20:00',4.25),('15128','2013-07-16','13:25:00',4.26),('15128','2013-07-16','13:30:00',4.29),('15128','2013-07-16','13:35:00',4.31),('15128','2013-07-16','13:40:00',4.3),('15128','2013-07-16','13:45:00',4.3),('15128','2013-07-16','13:50:00',4.29),('15128','2013-07-16','13:55:00',4.32),('15128','2013-07-16','14:00:00',4.32),('15128','2013-07-16','14:05:00',4.32),('15128','2013-07-16','14:10:00',4.32),('15128','2013-07-16','14:15:00',4.31),('15128','2013-07-16','14:20:00',4.3),('15128','2013-07-16','14:25:00',4.28),('15128','2013-07-16','14:30:00',4.26),('15128','2013-07-16','14:35:00',4.27),('15128','2013-07-16','14:40:00',4.27),('15128','2013-07-16','14:45:00',4.29),('15128','2013-07-16','14:50:00',4.26),('15128','2013-07-16','14:55:00',4.24),('15128','2013-07-16','15:00:00',4.24),('15128','2013-07-16','15:05:00',4.23),('15128','2013-07-16','15:10:00',4.19),('15128','2013-07-16','15:15:00',4.2),('15128','2013-07-16','15:20:00',4.18),('15128','2013-07-16','15:25:00',4.04),('15128','2013-07-16','15:30:00',4.07),('15128','2013-07-16','15:35:00',4.16),('15128','2013-07-16','15:40:00',4.15),('15128','2013-07-16','15:45:00',4.1),('15128','2013-07-16','15:50:00',4.11),('15128','2013-07-16','15:55:00',3.92),('15128','2013-07-16','16:00:00',4.02),('15128','2013-07-16','16:05:00',4.07),('15128','2013-07-16','16:10:00',3.95),('15128','2013-07-16','16:15:00',3.67),('15128','2013-07-16','16:20:00',3.6),('15128','2013-07-16','16:25:00',3.61),('15128','2013-07-16','16:30:00',3.59),('15128','2013-07-16','16:35:00',3.47),('15128','2013-07-16','16:40:00',3.43),('15128','2013-07-16','16:45:00',3.36),('15128','2013-07-16','16:50:00',3.29),('15128','2013-07-16','16:55:00',3.25),('15128','2013-07-16','17:00:00',3.19),('15128','2013-07-16','17:05:00',3.16),('15128','2013-07-16','17:10:00',3.09),('15128','2013-07-16','17:15:00',3.03),('15128','2013-07-16','17:20:00',2.95),('15128','2013-07-16','17:25:00',2.91),('15128','2013-07-16','17:30:00',2.86),('15128','2013-07-16','17:35:00',2.76),('15128','2013-07-16','17:40:00',2.66),('15128','2013-07-16','17:45:00',2.63),('15128','2013-07-16','17:50:00',2.52),('15128','2013-07-16','17:55:00',2.44),('15128','2013-07-16','18:00:00',2.33),('15128','2013-07-16','18:05:00',2.25),('15128','2013-07-16','18:10:00',2.13),('15128','2013-07-16','18:15:00',2.02),('15128','2013-07-16','18:20:00',1.88),('15128','2013-07-16','18:25:00',1.8),('15128','2013-07-16','18:30:00',1.71),('15128','2013-07-16','18:35:00',1.66),('15128','2013-07-16','18:40:00',1.56),('15128','2013-07-16','18:45:00',1.51),('15128','2013-07-16','18:50:00',1.42),('15128','2013-07-16','18:55:00',1.33),('15128','2013-07-16','19:00:00',1.27),('15128','2013-07-16','19:05:00',1.18),('15128','2013-07-16','19:10:00',1.08),('15128','2013-07-15','08:10:00',1.04),('15128','2013-07-15','08:15:00',1.12),('15128','2013-07-15','08:20:00',1.18),('15128','2013-07-15','08:25:00',1.23),('15128','2013-07-15','08:30:00',1.3),('15128','2013-07-15','08:35:00',1.37),('15128','2013-07-15','08:40:00',1.41),('15128','2013-07-15','08:45:00',1.48),('15128','2013-07-15','08:50:00',1.6),('15128','2013-07-15','08:55:00',1.68),('15128','2013-07-15','09:00:00',1.74),('15128','2013-07-15','09:05:00',1.81),('15128','2013-07-15','09:10:00',1.88),('15128','2013-07-15','09:15:00',1.99),('15128','2013-07-15','09:20:00',2.07),('15128','2013-07-15','09:25:00',2.09),('15128','2013-07-15','09:30:00',2.1),('15128','2013-07-15','09:35:00',2.16),('15128','2013-07-15','09:40:00',2.24),('15128','2013-07-15','09:45:00',2.29),('15128','2013-07-15','09:50:00',2.32),('15128','2013-07-15','09:55:00',2.37),('15128','2013-07-15','10:00:00',2.44),('15128','2013-07-15','10:05:00',2.55),('15128','2013-07-15','10:10:00',2.57),('15128','2013-07-15','10:15:00',2.6),('15128','2013-07-15','10:20:00',2.63),('15128','2013-07-15','10:25:00',2.68),('15128','2013-07-15','10:30:00',2.76),('15128','2013-07-15','10:35:00',2.77),('15128','2013-07-15','10:40:00',2.88),('15128','2013-07-15','10:45:00',2.93),('15128','2013-07-15','10:50:00',2.99),('15128','2013-07-15','10:55:00',3.11),('15128','2013-07-15','11:00:00',3.09),('15128','2013-07-15','11:05:00',3.18),('15128','2013-07-15','11:10:00',3.19),('15128','2013-07-15','11:15:00',3.26),('15128','2013-07-15','11:20:00',3.37),('15128','2013-07-15','11:25:00',3.38),('15128','2013-07-15','11:30:00',3.42),('15128','2013-07-15','11:35:00',3.39),('15128','2013-07-15','11:40:00',3.5),('15128','2013-07-15','11:45:00',3.58),('15128','2013-07-15','11:50:00',3.64),('15128','2013-07-15','11:55:00',3.79),('15128','2013-07-15','12:00:00',3.9),('15128','2013-07-15','12:05:00',3.93),('15128','2013-07-15','12:10:00',3.97),('15128','2013-07-15','12:15:00',4.03),('15128','2013-07-15','12:20:00',4.09),('15128','2013-07-15','12:25:00',4.12),('15128','2013-07-15','12:30:00',4.13),('15128','2013-07-15','12:35:00',4.17),('15128','2013-07-15','12:40:00',4.2),('15128','2013-07-15','12:45:00',4.25),('15128','2013-07-15','12:50:00',4.25),('15128','2013-07-15','12:55:00',4.26),('15128','2013-07-15','13:00:00',4.27),('15128','2013-07-15','13:05:00',4.29),('15128','2013-07-15','13:10:00',4.27),('15128','2013-07-15','13:15:00',4.27),('15128','2013-07-15','13:20:00',4.25),('15128','2013-07-15','13:25:00',4.23),('15128','2013-07-15','13:30:00',4.17),('15128','2013-07-15','13:35:00',4.33),('15128','2013-07-15','13:40:00',4.3),('15128','2013-07-15','13:45:00',4.31),('15128','2013-07-15','13:50:00',4.3),('15128','2013-07-15','13:55:00',4.31),('15128','2013-07-15','14:00:00',4.29),('15128','2013-07-15','14:05:00',4.29),('15128','2013-07-15','14:10:00',4.27),('15128','2013-07-15','14:15:00',4.32),('15128','2013-07-15','14:20:00',4.32),('15128','2013-07-15','14:25:00',4.25),('15128','2013-07-15','14:30:00',4.21),('15128','2013-07-15','14:35:00',4.19),('15128','2013-07-15','14:40:00',3.99),('15128','2013-07-15','14:45:00',4.21),('15128','2013-07-15','14:50:00',4.17),('15128','2013-07-15','14:55:00',4.1),('15128','2013-07-15','15:00:00',4.11),('15128','2013-07-15','15:05:00',4.09),('15128','2013-07-15','15:10:00',4.06),('15128','2013-07-15','15:15:00',4.02),('15128','2013-07-15','15:20:00',3.97),('15128','2013-07-15','15:25:00',3.95),('15128','2013-07-15','15:30:00',3.89),('15128','2013-07-15','15:35:00',3.92),('15128','2013-07-15','15:40:00',3.94),('15128','2013-07-15','15:45:00',3.94),('15128','2013-07-15','15:50:00',3.89),('15128','2013-07-15','15:55:00',3.86),('15128','2013-07-15','16:00:00',3.81),('15128','2013-07-15','16:05:00',3.75),('15128','2013-07-15','16:10:00',3.78),('15128','2013-07-15','16:15:00',3.8),('15128','2013-07-15','16:20:00',3.74),('15128','2013-07-15','16:25:00',3.62),('15128','2013-07-15','16:30:00',3.65),('15128','2013-07-15','16:35:00',3.72),('15128','2013-07-15','16:40:00',3.74),('15128','2013-07-15','16:45:00',3.6),('15128','2013-07-15','16:50:00',3.47),('15128','2013-07-15','16:55:00',3.57),('15128','2013-07-15','17:00:00',3.37),('15128','2013-07-15','17:05:00',2.91),('15128','2013-07-15','17:10:00',3.13),('15128','2013-07-15','17:15:00',3.12),('15128','2013-07-15','17:20:00',3.11),('15128','2013-07-15','17:25:00',3.07),('15128','2013-07-15','17:30:00',2.91),('15128','2013-07-15','17:35:00',2.8),('15128','2013-07-15','17:40:00',2.62),('15128','2013-07-15','17:45:00',2.62),('15128','2013-07-15','17:50:00',2.3),('15128','2013-07-15','17:55:00',1.65),('15128','2013-07-15','18:05:00',1.75),('15128','2013-07-15','18:30:00',1.29),('15128','2013-07-15','18:40:00',1.28),('15128','2013-07-15','18:45:00',1.51),('15128','2013-07-15','18:50:00',1.36),('15128','2013-07-15','18:55:00',1.32),('15128','2013-07-15','19:00:00',1.28),('15128','2013-07-15','19:05:00',1.03),('15128','2013-07-14','08:10:00',1.08),('15128','2013-07-14','08:15:00',1.14),('15128','2013-07-14','08:20:00',1.21),('15128','2013-07-14','08:25:00',1.26),('15128','2013-07-14','08:30:00',1.34),('15128','2013-07-14','08:35:00',1.4),('15128','2013-07-14','08:40:00',1.45),('15128','2013-07-14','08:45:00',1.57),('15128','2013-07-14','08:50:00',1.65),('15128','2013-07-14','08:55:00',1.72),('15128','2013-07-14','09:00:00',1.79),('15128','2013-07-14','09:05:00',1.89),('15128','2013-07-14','09:10:00',1.97),('15128','2013-07-14','09:15:00',2.07),('15128','2013-07-14','09:20:00',2.14),('15128','2013-07-14','09:25:00',2.18),('15128','2013-07-14','09:30:00',2.15),('15128','2013-07-14','09:35:00',2.2),('15128','2013-07-14','09:40:00',2.29),('15128','2013-07-14','09:45:00',2.32),('15128','2013-07-14','09:50:00',2.39),('15128','2013-07-14','09:55:00',2.44),('15128','2013-07-14','10:00:00',2.48),('15128','2013-07-14','10:05:00',2.6),('15128','2013-07-14','10:10:00',2.67),('15128','2013-07-14','10:15:00',2.68),('15128','2013-07-14','10:20:00',2.72),('15128','2013-07-14','10:25:00',2.72),('15128','2013-07-14','10:30:00',2.81),('15128','2013-07-14','10:35:00',2.83),('15128','2013-07-14','10:40:00',2.92),('15128','2013-07-14','10:45:00',3.01),('15128','2013-07-14','10:50:00',3.09),('15128','2013-07-14','10:55:00',3.2),('15128','2013-07-14','11:00:00',3.16),('15128','2013-07-14','11:05:00',3.29),('15128','2013-07-14','11:10:00',3.26),('15128','2013-07-14','11:15:00',3.38),('15128','2013-07-14','11:20:00',3.47),('15128','2013-07-14','11:25:00',3.5),('15128','2013-07-14','11:30:00',3.57),('15128','2013-07-14','11:35:00',3.48),('15128','2013-07-14','11:40:00',3.58),('15128','2013-07-14','11:45:00',3.69),('15128','2013-07-14','11:50:00',3.79),('15128','2013-07-14','11:55:00',3.92),('15128','2013-07-14','12:00:00',3.97),('15128','2013-07-14','12:05:00',4),('15128','2013-07-14','12:10:00',4.02),('15128','2013-07-14','12:15:00',4.05),('15128','2013-07-14','12:20:00',4.04),('15128','2013-07-14','12:25:00',4.07),('15128','2013-07-14','12:30:00',4.07),('15128','2013-07-14','12:35:00',4.11),('15128','2013-07-14','12:40:00',4.18),('15128','2013-07-14','12:45:00',4.22),('15128','2013-07-14','12:50:00',4.19),('15128','2013-07-14','12:55:00',4.23),('15128','2013-07-14','13:00:00',4.29),('15128','2013-07-14','13:05:00',4.3),('15128','2013-07-14','13:10:00',4.26),('15128','2013-07-14','13:15:00',4.31),('15128','2013-07-14','13:20:00',4.34),('15128','2013-07-14','13:25:00',4.36),('15128','2013-07-14','13:30:00',4.4),('15128','2013-07-14','13:35:00',4.2),('15128','2013-07-14','13:40:00',4.38),('15128','2013-07-14','13:45:00',4.34),('15128','2013-07-14','13:50:00',4.39),('15128','2013-07-14','13:55:00',4.39),('15128','2013-07-14','14:00:00',3.5),('15128','2013-07-14','14:05:00',4.51),('15128','2013-07-14','14:10:00',2.58),('15128','2013-07-14','14:15:00',3.67),('15128','2013-07-14','14:20:00',4.52),('15128','2013-07-14','14:25:00',4.41),('15128','2013-07-14','14:30:00',4.32),('15128','2013-07-14','14:35:00',4.34),('15128','2013-07-14','14:40:00',4.29),('15128','2013-07-14','14:45:00',4.22),('15128','2013-07-14','14:50:00',4.18),('15128','2013-07-14','14:55:00',3.89),('15128','2013-07-14','15:00:00',4.21),('15128','2013-07-14','15:05:00',2.72),('15128','2013-07-14','15:10:00',3.34),('15128','2013-07-14','15:15:00',4.18),('15128','2013-07-14','15:20:00',4.07),('15128','2013-07-14','15:25:00',4.06),('15128','2013-07-14','15:30:00',3.63),('15128','2013-07-14','15:40:00',3),('15128','2013-07-14','15:45:00',4),('15128','2013-07-14','15:50:00',3.93),('15128','2013-07-14','15:55:00',3.9),('15128','2013-07-14','16:00:00',3.84),('15128','2013-07-14','16:05:00',3.83),('15128','2013-07-14','16:10:00',3.79),('15128','2013-07-14','16:15:00',3.73),('15128','2013-07-14','16:20:00',3.66),('15128','2013-07-14','16:25:00',3.63),('15128','2013-07-14','16:30:00',3.57),('15128','2013-07-14','16:35:00',3.49),('15128','2013-07-14','16:40:00',3.45),('15128','2013-07-14','16:45:00',3.32),('15128','2013-07-14','16:50:00',3.25),('15128','2013-07-14','16:55:00',3.19),('15128','2013-07-14','17:00:00',3.19),('15128','2013-07-14','17:05:00',3.13),('15128','2013-07-14','17:10:00',3.08),('15128','2013-07-14','17:15:00',2.99),('15128','2013-07-14','17:20:00',2.93),('15128','2013-07-14','17:25:00',2.87),('15128','2013-07-14','17:30:00',2.79),('15128','2013-07-14','17:35:00',2.69),('15128','2013-07-14','17:40:00',2.61),('15128','2013-07-14','17:45:00',2.55),('15128','2013-07-14','17:50:00',2.45),('15128','2013-07-14','17:55:00',2.29),('15128','2013-07-14','18:00:00',2.22),('15128','2013-07-14','18:05:00',2.13),('15128','2013-07-14','18:10:00',2.01),('15128','2013-07-14','18:15:00',1.95),('15128','2013-07-14','18:20:00',1.83),('15128','2013-07-14','18:25:00',1.73),('15128','2013-07-14','18:30:00',1.69),('15128','2013-07-14','18:35:00',1.6),('15128','2013-07-14','18:40:00',1.51),('15128','2013-07-14','18:45:00',1.42),('15128','2013-07-14','18:50:00',1.37),('15128','2013-07-14','18:55:00',1.32),('15128','2013-07-14','19:00:00',1.23),('15128','2013-07-14','19:05:00',1.12),('15128','2013-07-14','19:10:00',1.01),('15128','2013-07-13','07:50:00',1.16),('15128','2013-07-13','07:55:00',1.17),('15128','2013-07-13','08:00:00',1.05),('15128','2013-07-13','08:05:00',1.05),('15128','2013-07-13','08:30:00',1.17),('15128','2013-07-13','08:35:00',1.26),('15128','2013-07-13','08:50:00',1.22),('15128','2013-07-13','08:55:00',1.09),('15128','2013-07-13','09:15:00',1.62),('15128','2013-07-13','09:20:00',2.35),('15128','2013-07-13','09:25:00',1.54),('15128','2013-07-13','09:30:00',1.43),('15128','2013-07-13','09:35:00',1.45),('15128','2013-07-13','09:40:00',1.53),('15128','2013-07-13','09:45:00',1.75),('15128','2013-07-13','09:50:00',1.74),('15128','2013-07-13','09:55:00',1.73),('15128','2013-07-13','10:00:00',1.57),('15128','2013-07-13','10:05:00',1.36),('15128','2013-07-13','10:10:00',1.41),('15128','2013-07-13','10:15:00',2.11),('15128','2013-07-13','10:20:00',3.2),('15128','2013-07-13','10:25:00',3.13),('15128','2013-07-13','10:30:00',2.58),('15128','2013-07-13','10:35:00',2.36),('15128','2013-07-13','10:40:00',2.37),('15128','2013-07-13','10:45:00',2.58),('15128','2013-07-13','10:50:00',2.77),('15128','2013-07-13','10:55:00',3.07),('15128','2013-07-13','11:00:00',3.35),('15128','2013-07-13','11:05:00',3.33),('15128','2013-07-13','11:10:00',3.62),('15128','2013-07-13','11:15:00',3.36),('15128','2013-07-13','11:20:00',2.5),('15128','2013-07-13','11:25:00',3.77),('15128','2013-07-13','11:30:00',3.33),('15128','2013-07-13','11:35:00',3.26),('15128','2013-07-13','11:40:00',3.11),('15128','2013-07-13','11:45:00',3.85),('15128','2013-07-13','11:50:00',3.86),('15128','2013-07-13','11:55:00',4.01),('15128','2013-07-13','12:00:00',4.05),('15128','2013-07-13','12:05:00',3.82),('15128','2013-07-13','12:10:00',1.74),('15128','2013-07-13','12:15:00',2.87),('15128','2013-07-13','12:20:00',3.09),('15128','2013-07-13','12:25:00',4.09),('15128','2013-07-13','12:30:00',4.56),('15128','2013-07-13','12:35:00',4.51),('15128','2013-07-13','12:40:00',3.11),('15128','2013-07-13','12:45:00',3.89),('15128','2013-07-13','12:50:00',3.73),('15128','2013-07-13','12:55:00',4.64),('15128','2013-07-13','13:00:00',2.97),('15128','2013-07-13','13:05:00',3.23),('15128','2013-07-13','13:10:00',4.54),('15128','2013-07-13','13:15:00',4.35),('15128','2013-07-13','13:20:00',4.35),('15128','2013-07-13','13:25:00',4.3),('15128','2013-07-13','13:30:00',4.37),('15128','2013-07-13','13:35:00',4.42),('15128','2013-07-13','13:40:00',4.47),('15128','2013-07-13','13:45:00',4.52),('15128','2013-07-13','13:50:00',4.52),('15128','2013-07-13','13:55:00',4.55),('15128','2013-07-13','14:00:00',4.52),('15128','2013-07-13','14:05:00',4.52),('15128','2013-07-13','14:10:00',4.56),('15128','2013-07-13','14:15:00',4.51),('15128','2013-07-13','14:20:00',4.51),('15128','2013-07-13','14:25:00',4.48),('15128','2013-07-13','14:30:00',4.46),('15128','2013-07-13','14:35:00',4.4),('15128','2013-07-13','14:40:00',4.4),('15128','2013-07-13','14:45:00',4.4),('15128','2013-07-13','14:50:00',4.39),('15128','2013-07-13','14:55:00',4.31),('15128','2013-07-13','15:00:00',4.3),('15128','2013-07-13','15:05:00',4.33),('15128','2013-07-13','15:10:00',4.26),('15128','2013-07-13','15:15:00',4.22),('15128','2013-07-13','15:20:00',4.2),('15128','2013-07-13','15:25:00',4.21),('15128','2013-07-13','15:30:00',4.2),('15128','2013-07-13','15:35:00',4.16),('15128','2013-07-13','15:40:00',4.17),('15128','2013-07-13','15:45:00',4.1),('15128','2013-07-13','15:50:00',4.01),('15128','2013-07-13','15:55:00',4),('15128','2013-07-13','16:00:00',3.99),('15128','2013-07-13','16:05:00',3.95),('15128','2013-07-13','16:10:00',3.92),('15128','2013-07-13','16:15:00',2.28),('15128','2013-07-13','16:20:00',3.34),('15128','2013-07-13','16:25:00',3.91),('15128','2013-07-13','16:30:00',2.4),('15128','2013-07-13','16:35:00',2.59),('15128','2013-07-13','16:40:00',2.94),('15128','2013-07-13','16:45:00',3.73),('15128','2013-07-13','16:50:00',2.57),('15128','2013-07-13','16:55:00',3.32),('15128','2013-07-13','17:00:00',2.2),('15128','2013-07-13','17:05:00',1.82),('15128','2013-07-13','17:10:00',1.79),('15128','2013-07-13','17:15:00',1.82),('15128','2013-07-13','17:20:00',1.63),('15128','2013-07-13','17:25:00',2.69),('15128','2013-07-13','17:30:00',2.56),('15128','2013-07-13','17:35:00',2.49),('15128','2013-07-13','17:40:00',2.67),('15128','2013-07-13','17:45:00',1.54),('15128','2013-07-13','17:50:00',2.39),('15128','2013-07-13','17:55:00',1.01),('15128','2013-07-13','19:00:00',1.11),('15128','2013-07-13','19:05:00',1.21),('15128','2013-07-13','19:10:00',1.41),('15128','2013-07-13','19:15:00',1.09),('15128','2013-07-12','08:10:00',1.03),('15128','2013-07-12','08:15:00',1.1),('15128','2013-07-12','08:20:00',1.16),('15128','2013-07-12','08:25:00',1.19),('15128','2013-07-12','08:30:00',1.3),('15128','2013-07-12','08:35:00',1.36),('15128','2013-07-12','08:40:00',1.39),('15128','2013-07-12','08:45:00',1.46),('15128','2013-07-12','08:50:00',1.59),('15128','2013-07-12','08:55:00',1.66),('15128','2013-07-12','09:00:00',1.74),('15128','2013-07-12','09:05:00',1.82),('15128','2013-07-12','09:10:00',1.91),('15128','2013-07-12','09:15:00',1.98),('15128','2013-07-12','09:20:00',2.02),('15128','2013-07-12','09:25:00',2.09),('15128','2013-07-12','09:30:00',2.11),('15128','2013-07-12','09:35:00',2.24),('15128','2013-07-12','09:40:00',2.31),('15128','2013-07-12','09:45:00',2.36),('15128','2013-07-12','09:50:00',2.41),('15128','2013-07-12','09:55:00',2.4),('15128','2013-07-12','10:00:00',2.45),('15128','2013-07-12','10:05:00',2.44),('15128','2013-07-12','10:10:00',2.18),('15128','2013-07-12','10:15:00',2.06),('15128','2013-07-12','10:20:00',2.21),('15128','2013-07-12','10:25:00',2.76),('15128','2013-07-12','10:30:00',2.84),('15128','2013-07-12','10:35:00',2.14),('15128','2013-07-12','10:40:00',3.08),('15128','2013-07-12','10:45:00',3.04),('15128','2013-07-12','10:50:00',3.18),('15128','2013-07-12','10:55:00',3.39),('15128','2013-07-12','11:00:00',3.41),('15128','2013-07-12','11:05:00',1.79),('15128','2013-07-12','11:10:00',2.49),('15128','2013-07-12','11:15:00',2.06),('15128','2013-07-12','11:20:00',2.88),('15128','2013-07-12','11:25:00',3.84),('15128','2013-07-12','11:30:00',3.75),('15128','2013-07-12','11:35:00',3.67),('15128','2013-07-12','11:40:00',3.71),('15128','2013-07-12','11:45:00',3.82),('15128','2013-07-12','11:50:00',3.78),('15128','2013-07-12','11:55:00',4.03),('15128','2013-07-12','12:00:00',3.66),('15128','2013-07-12','12:05:00',3.36),('15128','2013-07-12','12:10:00',2.2),('15128','2013-07-12','12:15:00',3.73),('15128','2013-07-12','12:20:00',3.03),('15128','2013-07-12','12:25:00',2.5),('15128','2013-07-12','12:30:00',3.68),('15128','2013-07-12','12:35:00',3.56),('15128','2013-07-12','12:40:00',4.42),('15128','2013-07-12','12:45:00',2.02),('15128','2013-07-12','12:50:00',4.25),('15128','2013-07-12','12:55:00',4.41),('15128','2013-07-12','13:00:00',4.33),('15128','2013-07-12','13:05:00',4.33),('15128','2013-07-12','13:10:00',4.36),('15128','2013-07-12','13:15:00',4.34),('15128','2013-07-12','13:20:00',4.42),('15128','2013-07-12','13:25:00',4.39),('15128','2013-07-12','13:30:00',4.4),('15128','2013-07-12','13:35:00',4.43),('15128','2013-07-12','13:40:00',4.47),('15128','2013-07-12','13:45:00',4.44),('15128','2013-07-12','13:50:00',4.47),('15128','2013-07-12','13:55:00',4.5),('15128','2013-07-12','14:00:00',4.44),('15128','2013-07-12','14:05:00',4.49),('15128','2013-07-12','14:10:00',4.48),('15128','2013-07-12','14:15:00',4.48),('15128','2013-07-12','14:20:00',4.45),('15128','2013-07-12','14:25:00',4.45),('15128','2013-07-12','14:30:00',4.47),('15128','2013-07-12','14:35:00',4.45),('15128','2013-07-12','14:40:00',4.45),('15128','2013-07-12','14:45:00',4.41),('15128','2013-07-12','14:50:00',4.39),('15128','2013-07-12','14:55:00',4.41),('15128','2013-07-12','15:00:00',4.38),('15128','2013-07-12','15:05:00',4.4),('15128','2013-07-12','15:10:00',4.39),('15128','2013-07-12','15:15:00',4.33),('15128','2013-07-12','15:20:00',4.21),('15128','2013-07-12','15:25:00',4.34),('15128','2013-07-12','15:30:00',4.24),('15128','2013-07-12','15:35:00',4.25),('15128','2013-07-12','15:40:00',4.22),('15128','2013-07-12','15:45:00',4.2),('15128','2013-07-12','15:50:00',4.15),('15128','2013-07-12','15:55:00',4.1),('15128','2013-07-12','16:00:00',4.07),('15128','2013-07-12','16:05:00',4.03),('15128','2013-07-12','16:10:00',4),('15128','2013-07-12','16:15:00',3.92),('15128','2013-07-12','16:20:00',3.89),('15128','2013-07-12','16:25:00',3.84),('15128','2013-07-12','16:30:00',3.75),('15128','2013-07-12','16:35:00',3.74),('15128','2013-07-12','16:40:00',3.7),('15128','2013-07-12','16:45:00',3.64),('15128','2013-07-12','16:50:00',3.57),('15128','2013-07-12','16:55:00',3.47),('15128','2013-07-12','17:00:00',3.42),('15128','2013-07-12','17:05:00',3.29),('15128','2013-07-12','17:10:00',3.24),('15128','2013-07-12','17:15:00',3.22),('15128','2013-07-12','17:20:00',3.12),('15128','2013-07-12','17:25:00',3.12),('15128','2013-07-12','17:30:00',2.97),('15128','2013-07-12','17:35:00',2.89),('15128','2013-07-12','17:40:00',2.77),('15128','2013-07-12','17:45:00',2.74),('15128','2013-07-12','17:50:00',2.63),('15128','2013-07-12','17:55:00',2.59),('15128','2013-07-12','18:00:00',2.49),('15128','2013-07-12','18:05:00',2.37),('15128','2013-07-12','18:10:00',2.22),('15128','2013-07-12','18:15:00',2.06),('15128','2013-07-12','18:20:00',2.09),('15128','2013-07-12','18:25:00',1.95),('15128','2013-07-12','18:30:00',1.79),('15128','2013-07-12','18:35:00',1.14),('15128','2013-07-12','18:40:00',1.13),('15128','2013-07-12','18:45:00',1.55),('15128','2013-07-12','18:50:00',1.73),('15128','2013-07-12','18:55:00',1.58),('15128','2013-07-12','19:00:00',1.37),('15128','2013-07-12','19:05:00',1.28),('15128','2013-07-11','08:55:00',1.1),('15128','2013-07-11','09:00:00',1.66),('15128','2013-07-11','09:05:00',1.5),('15128','2013-07-11','09:15:00',1.12),('15128','2013-07-11','09:20:00',1.73),('15128','2013-07-11','09:25:00',1.59),('15128','2013-07-11','09:30:00',2.06),('15128','2013-07-11','09:35:00',2.23),('15128','2013-07-11','09:40:00',2.37),('15128','2013-07-11','09:45:00',2.37),('15128','2013-07-11','09:50:00',2.44),('15128','2013-07-11','09:55:00',2.54),('15128','2013-07-11','10:00:00',2.67),('15128','2013-07-11','10:05:00',2.65),('15128','2013-07-11','10:10:00',1.91),('15128','2013-07-11','10:15:00',1.13),('15128','2013-07-11','10:20:00',2.46),('15128','2013-07-11','10:25:00',2.34),('15128','2013-07-11','10:30:00',3.02),('15128','2013-07-11','10:35:00',2.26),('15128','2013-07-11','10:40:00',2.4),('15128','2013-07-11','10:45:00',1.41),('15128','2013-07-11','10:50:00',1.09),('15128','2013-07-11','10:55:00',1.98),('15128','2013-07-11','11:00:00',3.95),('15128','2013-07-11','11:05:00',3.95),('15128','2013-07-11','11:10:00',2.04),('15128','2013-07-11','11:15:00',3.64),('15128','2013-07-11','11:20:00',3.13),('15128','2013-07-11','11:25:00',3.96),('15128','2013-07-11','11:30:00',3.68),('15128','2013-07-11','11:35:00',3.32),('15128','2013-07-11','11:40:00',3.09),('15128','2013-07-11','11:45:00',2.34),('15128','2013-07-11','11:50:00',2.9),('15128','2013-07-11','11:55:00',4.34),('15128','2013-07-11','12:00:00',2.46),('15128','2013-07-11','12:05:00',4.08),('15128','2013-07-11','12:10:00',2.7),('15128','2013-07-11','12:15:00',4.45),('15128','2013-07-11','12:20:00',4.19),('15128','2013-07-11','12:25:00',4.46),('15128','2013-07-11','12:30:00',4.4),('15128','2013-07-11','12:35:00',4.45),('15128','2013-07-11','12:40:00',3.79),('15128','2013-07-11','12:45:00',3.78),('15128','2013-07-11','12:50:00',4.54),('15128','2013-07-11','12:55:00',4.31),('15128','2013-07-11','13:00:00',4.48),('15128','2013-07-11','13:05:00',4.31),('15128','2013-07-11','13:10:00',4.54),('15128','2013-07-11','13:15:00',4.22),('15128','2013-07-11','13:20:00',4.41),('15128','2013-07-11','13:25:00',4.46),('15128','2013-07-11','13:30:00',4.51),('15128','2013-07-11','13:35:00',4.38),('15128','2013-07-11','13:40:00',4.39),('15128','2013-07-11','13:45:00',4.29),('15128','2013-07-11','13:50:00',3.39),('15128','2013-07-11','13:55:00',2.7),('15128','2013-07-11','14:00:00',2.72),('15128','2013-07-11','14:05:00',4.28),('15128','2013-07-11','14:10:00',4.8),('15128','2013-07-11','14:15:00',4.57),('15128','2013-07-11','14:20:00',4.67),('15128','2013-07-11','14:25:00',2.61),('15128','2013-07-11','14:30:00',4.39),('15128','2013-07-11','14:35:00',4.2),('15128','2013-07-11','14:40:00',4.4),('15128','2013-07-11','14:45:00',4.33),('15128','2013-07-11','14:50:00',4.29),('15128','2013-07-11','14:55:00',4.29),('15128','2013-07-11','15:00:00',4.09),('15128','2013-07-11','15:05:00',4.25),('15128','2013-07-11','15:10:00',4.2),('15128','2013-07-11','15:15:00',4.16),('15128','2013-07-11','15:20:00',4.14),('15128','2013-07-11','15:25:00',4.18),('15128','2013-07-11','15:30:00',4.19),('15128','2013-07-11','15:35:00',4.15),('15128','2013-07-11','15:40:00',4.08),('15128','2013-07-11','15:45:00',3.93),('15128','2013-07-11','15:50:00',3.97),('15128','2013-07-11','15:55:00',3.93),('15128','2013-07-11','16:00:00',3.85),('15128','2013-07-11','16:05:00',3.86),('15128','2013-07-11','16:10:00',3.75),('15128','2013-07-11','16:15:00',3.73),('15128','2013-07-11','16:20:00',3.73),('15128','2013-07-11','16:25:00',3.66),('15128','2013-07-11','16:30:00',3.64),('15128','2013-07-11','16:35:00',3.61),('15128','2013-07-11','16:40:00',3.54),('15128','2013-07-11','16:45:00',3.47),('15128','2013-07-11','16:50:00',3.42),('15128','2013-07-11','16:55:00',3.31),('15128','2013-07-11','17:00:00',3.24),('15128','2013-07-11','17:05:00',3.16),('15128','2013-07-11','17:10:00',3.09),('15128','2013-07-11','17:15:00',3.06),('15128','2013-07-11','17:20:00',2.99),('15128','2013-07-11','17:25:00',2.85),('15128','2013-07-11','17:30:00',2.84),('15128','2013-07-11','17:35:00',2.78),('15128','2013-07-11','17:40:00',2.73),('15128','2013-07-11','17:45:00',2.68),('15128','2013-07-11','17:50:00',2.3),('15128','2013-07-11','17:55:00',2.06),('15128','2013-07-11','18:00:00',2.41),('15128','2013-07-11','18:05:00',1.57),('15128','2013-07-11','18:10:00',2.12),('15128','2013-07-11','18:15:00',2.04),('15128','2013-07-11','18:20:00',1.96),('15128','2013-07-11','18:25:00',1.85),('15128','2013-07-11','18:30:00',1.74),('15128','2013-07-11','18:35:00',1.64),('15128','2013-07-11','18:40:00',1.55),('15128','2013-07-11','18:45:00',1.51),('15128','2013-07-11','18:50:00',1.44),('15128','2013-07-11','18:55:00',1.35),('15128','2013-07-11','19:00:00',1.18),('15128','2013-07-11','19:05:00',1.12),('15128','2013-07-10','08:05:00',1.01),('15128','2013-07-10','08:10:00',1.05),('15128','2013-07-10','08:15:00',1.11),('15128','2013-07-10','08:20:00',1.16),('15128','2013-07-10','08:25:00',1.24),('15128','2013-07-10','08:30:00',1.31),('15128','2013-07-10','08:35:00',1.37),('15128','2013-07-10','08:40:00',1.43),('15128','2013-07-10','08:45:00',1.52),('15128','2013-07-10','08:50:00',1.61),('15128','2013-07-10','08:55:00',1.69),('15128','2013-07-10','09:00:00',1.8),('15128','2013-07-10','09:05:00',1.87),('15128','2013-07-10','09:10:00',1.97),('15128','2013-07-10','09:15:00',2.05),('15128','2013-07-10','09:20:00',2.16),('15128','2013-07-10','09:25:00',2.17),('15128','2013-07-10','09:30:00',2.15),('15128','2013-07-10','09:35:00',2.28),('15128','2013-07-10','09:40:00',1.64),('15128','2013-07-10','09:45:00',1.22),('15128','2013-07-10','09:50:00',1.35),('15128','2013-07-10','09:55:00',1.76),('15128','2013-07-10','10:00:00',1.76),('15128','2013-07-10','10:05:00',2.47),('15128','2013-07-10','10:10:00',2.28),('15128','2013-07-10','10:15:00',1.9),('15128','2013-07-10','10:20:00',1.64),('15128','2013-07-10','10:25:00',3.08),('15128','2013-07-10','10:30:00',1.7),('15128','2013-07-10','10:35:00',1.18),('15128','2013-07-10','10:40:00',3.1),('15128','2013-07-10','10:45:00',3.17),('15128','2013-07-10','10:50:00',3.54),('15128','2013-07-10','10:55:00',3.84),('15128','2013-07-10','11:00:00',3.57),('15128','2013-07-10','11:05:00',3.65),('15128','2013-07-10','11:10:00',1.28),('15128','2013-07-10','11:15:00',1.22),('15128','2013-07-10','11:20:00',3.26),('15128','2013-07-10','11:25:00',1.21),('15128','2013-07-10','11:30:00',1.33),('15128','2013-07-10','11:35:00',3.04),('15128','2013-07-10','11:40:00',1.27),('15128','2013-07-10','11:45:00',1.29),('15128','2013-07-10','11:50:00',3.71),('15128','2013-07-10','11:55:00',4.51),('15128','2013-07-10','12:00:00',4.01),('15128','2013-07-10','12:05:00',3.22),('15128','2013-07-10','12:10:00',3.72),('15128','2013-07-10','12:15:00',1.86),('15128','2013-07-10','12:20:00',2.94),('15128','2013-07-10','12:25:00',2.21),('15128','2013-07-10','12:30:00',3.87),('15128','2013-07-10','12:35:00',3.78),('15128','2013-07-10','12:40:00',4.4),('15128','2013-07-10','12:45:00',4.39),('15128','2013-07-10','12:50:00',4.35),('15128','2013-07-10','12:55:00',4.35),('15128','2013-07-10','13:00:00',4.32),('15128','2013-07-10','13:05:00',4.34),('15128','2013-07-10','13:10:00',4.38),('15128','2013-07-10','13:15:00',4.37),('15128','2013-07-10','13:20:00',4.41),('15128','2013-07-10','13:25:00',4.43),('15128','2013-07-10','13:30:00',4.42),('15128','2013-07-10','13:35:00',4.45),('15128','2013-07-10','13:40:00',4.46),('15128','2013-07-10','13:45:00',4.48),('15128','2013-07-10','13:50:00',4.48),('15128','2013-07-10','13:55:00',4.47),('15128','2013-07-10','14:00:00',4.48),('15128','2013-07-10','14:05:00',4.09),('15128','2013-07-10','14:10:00',4.62),('15128','2013-07-10','14:15:00',4.58),('15128','2013-07-10','14:20:00',4.38),('15128','2013-07-10','14:25:00',4.01),('15128','2013-07-10','14:30:00',4.35),('15128','2013-07-10','14:35:00',4.56),('15128','2013-07-10','14:40:00',4.57),('15128','2013-07-10','14:45:00',4.43),('15128','2013-07-10','14:50:00',3.19),('15128','2013-07-10','14:55:00',4.03),('15128','2013-07-10','15:00:00',3.35),('15128','2013-07-10','15:05:00',4.42),('15128','2013-07-10','15:10:00',4.45),('15128','2013-07-10','15:15:00',4.33),('15128','2013-07-10','15:20:00',4.28),('15128','2013-07-10','15:25:00',4.22),('15128','2013-07-10','15:30:00',4.23),('15128','2013-07-10','15:35:00',4.18),('15128','2013-07-10','15:40:00',3.2),('15128','2013-07-10','15:45:00',2.87),('15128','2013-07-10','15:50:00',3.91),('15128','2013-07-10','15:55:00',3.89),('15128','2013-07-10','16:00:00',3.42),('15128','2013-07-10','16:05:00',4.03),('15128','2013-07-10','16:10:00',3.78),('15128','2013-07-10','16:15:00',3.64),('15128','2013-07-10','16:20:00',3.89),('15128','2013-07-10','16:25:00',3.74),('15128','2013-07-10','16:30:00',3.72),('15128','2013-07-10','16:35:00',3.08),('15128','2013-07-10','16:40:00',3.69),('15128','2013-07-10','16:45:00',3.61),('15128','2013-07-10','16:50:00',3.48),('15128','2013-07-10','16:55:00',3.29),('15128','2013-07-10','17:00:00',2.54),('15128','2013-07-10','17:05:00',2.66),('15128','2013-07-10','17:10:00',2.92),('15128','2013-07-10','17:15:00',2.72),('15128','2013-07-10','17:20:00',1.92),('15128','2013-07-10','17:25:00',1.84),('15128','2013-07-10','17:30:00',1.74),('15128','2013-07-10','17:35:00',1.97),('15128','2013-07-10','17:40:00',1.47),('15128','2013-07-10','17:45:00',3.08),('15128','2013-07-10','17:50:00',2.61),('15128','2013-07-10','17:55:00',2.48),('15128','2013-07-10','18:00:00',2.5),('15128','2013-07-10','18:05:00',2.01),('15128','2013-07-10','18:10:00',1.53),('15128','2013-07-10','18:15:00',2.3),('15128','2013-07-10','18:30:00',1.28),('15128','2013-07-10','19:05:00',1.04),('15128','2013-07-10','19:10:00',1.04),('15128','2014-05-02','08:15:00',1.06),('15128','2014-05-02','08:20:00',1.17),('15128','2014-05-02','08:25:00',1.22),('15128','2014-05-02','08:30:00',1.35),('15128','2014-05-02','08:35:00',1.52),('15128','2014-05-02','08:40:00',1.43),('15128','2014-05-02','08:45:00',1.69),('15128','2014-05-02','08:55:00',1.29),('15128','2014-05-02','09:00:00',1.86),('15128','2014-05-02','09:05:00',1.85),('15128','2014-05-02','09:10:00',2.4),('15128','2014-05-02','09:15:00',1.74),('15128','2014-05-02','09:20:00',1.4),('15128','2014-05-02','09:25:00',1.41),('15128','2014-05-02','09:30:00',2.55),('15128','2014-05-02','09:35:00',1.95),('15128','2014-05-02','09:40:00',3.27),('15128','2014-05-02','09:45:00',2.13),('15128','2014-05-02','09:50:00',1.28),('15128','2014-05-02','09:55:00',1.27),('15128','2014-05-02','10:00:00',1.19),('15128','2014-05-02','10:05:00',1.4),('15128','2014-05-02','10:10:00',3.33),('15128','2014-05-02','10:15:00',4.01),('15128','2014-05-02','10:20:00',3.15),('15128','2014-05-02','10:25:00',1.97),('15128','2014-05-02','10:30:00',1.89),('15128','2014-05-02','10:35:00',3.76),('15128','2014-05-02','10:40:00',2.5),('15128','2014-05-02','10:45:00',1.42),('15128','2014-05-02','10:50:00',2.13),('15128','2014-05-02','10:55:00',1.3),('15128','2014-05-02','11:00:00',1.09),('15128','2014-05-02','11:05:00',1.31),('15128','2014-05-02','11:10:00',1.33),('15128','2014-05-02','11:15:00',1.05),('15128','2014-05-02','11:45:00',3.97),('15128','2014-05-02','11:50:00',3.66),('15128','2014-05-02','11:55:00',2.59),('15128','2014-05-02','12:00:00',2.22),('15128','2014-05-02','12:05:00',2.77),('15128','2014-05-02','12:10:00',2.57),('15128','2014-05-02','12:15:00',2.02),('15128','2014-05-02','12:20:00',1.89),('15128','2014-05-02','12:25:00',1.92),('15128','2014-05-02','12:30:00',1.61),('15128','2014-05-02','12:35:00',1.48),('15128','2014-05-02','12:40:00',1.67),('15128','2014-05-02','12:45:00',1.91),('15128','2014-05-02','12:50:00',2.18),('15128','2014-05-02','12:55:00',2.23),('15128','2014-05-02','13:00:00',2.84),('15128','2014-05-02','13:05:00',3.49),('15128','2014-05-02','13:10:00',3.28),('15128','2014-05-02','13:15:00',3.07),('15128','2014-05-02','13:20:00',2.73),('15128','2014-05-02','13:25:00',3.17),('15128','2014-05-02','13:30:00',2.72),('15128','2014-05-02','13:35:00',1.19),('15128','2014-05-02','13:40:00',1.09),('15128','2014-05-02','13:45:00',1.56),('15128','2014-05-02','13:50:00',2.24),('15128','2014-05-02','13:55:00',2.16),('15128','2014-05-02','14:00:00',1.58),('15128','2014-05-02','14:05:00',2.14),('15128','2014-05-02','14:10:00',3.15),('15128','2014-05-02','14:15:00',3.47),('15128','2014-05-02','14:20:00',3.45),('15128','2014-05-02','14:25:00',3.14),('15128','2014-05-02','14:30:00',2.77),('15128','2014-05-02','14:35:00',2.63),('15128','2014-05-02','14:40:00',2.33),('15128','2014-05-02','14:45:00',1.51),('15128','2014-05-02','17:15:00',1.02),('15128','2014-05-02','17:20:00',1.28),('15128','2014-05-02','17:25:00',1.55),('15128','2014-05-02','17:30:00',1.3),('15128','2014-05-02','17:35:00',1.57),('15128','2014-05-02','17:40:00',1.3),('15128','2014-05-02','17:45:00',1.22),('15128','2014-05-02','17:50:00',1.21),('15128','2014-05-02','17:55:00',1.26),('15128','2014-05-02','18:00:00',1.45),('15128','2014-05-02','18:05:00',1.43),('15128','2014-05-02','18:30:00',1.21),('15128','2014-05-02','18:35:00',1.41),('15128','2014-05-02','18:40:00',1.26),('15128','2014-04-05','08:55:00',1.06),('15128','2014-04-05','09:00:00',1.12),('15128','2014-04-05','09:05:00',1.2),('15128','2014-04-05','09:10:00',1.28),('15128','2014-04-05','09:15:00',1.38),('15128','2014-04-05','09:20:00',1.44),('15128','2014-04-05','09:25:00',1.27),('15128','2014-04-05','09:30:00',1.35),('15128','2014-04-05','09:35:00',1.22),('15128','2014-04-05','09:40:00',1.52),('15128','2014-04-05','09:45:00',1.39),('15128','2014-04-05','09:50:00',1.67),('15128','2014-04-05','09:55:00',2.37),('15128','2014-04-05','10:00:00',2.36),('15128','2014-04-05','10:05:00',2.25),('15128','2014-04-05','10:10:00',1.8),('15128','2014-04-05','10:15:00',1.98),('15128','2014-04-05','10:20:00',2.11),('15128','2014-04-05','10:25:00',3.2),('15128','2014-04-05','10:30:00',3.25),('15128','2014-04-05','10:35:00',3.31),('15128','2014-04-05','10:40:00',3.14),('15128','2014-04-05','10:45:00',3.3),('15128','2014-04-05','10:50:00',3.34),('15128','2014-04-05','10:55:00',2.85),('15128','2014-04-05','11:00:00',3.31),('15128','2014-04-05','11:05:00',3.24),('15128','2014-04-05','11:10:00',3.3),('15128','2014-04-05','11:15:00',2.89),('15128','2014-04-05','11:20:00',1.34),('15128','2014-04-05','11:25:00',2.73),('15128','2014-04-05','11:30:00',2.61),('15128','2014-04-05','11:35:00',3.52),('15128','2014-04-05','11:40:00',3.26),('15128','2014-04-05','11:45:00',3.42),('15128','2014-04-05','11:50:00',3.39),('15128','2014-04-05','11:55:00',3.54),('15128','2014-04-05','12:00:00',3.68),('15128','2014-04-05','12:05:00',3.68),('15128','2014-04-05','12:10:00',3.36),('15128','2014-04-05','12:15:00',3.7),('15128','2014-04-05','12:20:00',3.77),('15128','2014-04-05','12:25:00',3.52),('15128','2014-04-05','12:30:00',3.82),('15128','2014-04-05','12:35:00',3.82),('15128','2014-04-05','12:40:00',3.89),('15128','2014-04-05','12:45:00',3.95),('15128','2014-04-05','12:50:00',2.63),('15128','2014-04-05','12:55:00',4.06),('15128','2014-04-05','13:00:00',4),('15128','2014-04-05','13:05:00',4.21),('15128','2014-04-05','13:10:00',4.39),('15128','2014-04-05','13:15:00',4.42),('15128','2014-04-05','13:20:00',3.94),('15128','2014-04-05','13:25:00',4.34),('15128','2014-04-05','13:30:00',3.54),('15128','2014-04-05','13:35:00',3.6),('15128','2014-04-05','13:40:00',4.03),('15128','2014-04-05','13:45:00',4.04),('15128','2014-04-05','13:50:00',4.17),('15128','2014-04-05','13:55:00',4.1),('15128','2014-04-05','14:00:00',3.58),('15128','2014-04-05','14:05:00',3.97),('15128','2014-04-05','14:10:00',3.44),('15128','2014-04-05','14:15:00',4.17),('15128','2014-04-05','14:20:00',3.92),('15128','2014-04-05','14:25:00',4.02),('15128','2014-04-05','14:30:00',4.06),('15128','2014-04-05','14:35:00',3.83),('15128','2014-04-05','14:40:00',3.16),('15128','2014-04-05','14:45:00',4.06),('15128','2014-04-05','14:50:00',3.44),('15128','2014-04-05','14:55:00',1.84),('15128','2014-04-05','15:00:00',1.26),('15128','2014-04-05','15:20:00',2.06),('15128','2014-04-05','15:25:00',1.04),('15128','2014-04-05','16:00:00',1.72),('15128','2014-04-05','16:05:00',3.74),('15128','2014-04-05','16:10:00',2.17),('15128','2014-04-05','16:45:00',2.64),('15128','2014-04-05','16:50:00',2.05),('15128','2014-04-05','16:55:00',2.7),('15128','2014-04-05','17:00:00',1.15),('15128','2014-04-05','17:20:00',1.43),('15128','2014-04-05','17:25:00',2.29),('15128','2014-04-05','17:30:00',2.16),('15128','2014-04-05','17:35:00',2.04),('15128','2014-04-05','17:40:00',1.94),('15128','2014-04-05','17:45:00',1.8),('15128','2014-04-05','17:50:00',1.75),('15128','2014-04-05','17:55:00',1.67),('15128','2014-04-05','18:00:00',1.62),('15128','2014-04-05','18:05:00',1.53),('15128','2014-04-05','18:10:00',1.46),('15128','2014-04-05','18:15:00',1.35),('15128','2014-04-05','18:20:00',1.29),('15128','2014-04-05','18:25:00',1.19),('15128','2014-04-05','18:30:00',1.08),('15128','2013-07-09','08:30:00',1.1),('15128','2013-07-09','08:35:00',1.39),('15128','2013-07-09','08:40:00',1.64),('15128','2013-07-09','08:45:00',1.81),('15128','2013-07-09','08:50:00',1.8),('15128','2013-07-09','08:55:00',1.8),('15128','2013-07-09','09:00:00',1.88),('15128','2013-07-09','09:05:00',1.95),('15128','2013-07-09','09:10:00',2.01),('15128','2013-07-09','09:15:00',2.08),('15128','2013-07-09','09:20:00',2.15),('15128','2013-07-09','09:25:00',2.14),('15128','2013-07-09','09:30:00',2.19),('15128','2013-07-09','09:35:00',2.33),('15128','2013-07-09','09:40:00',2.37),('15128','2013-07-09','09:45:00',2.41),('15128','2013-07-09','09:50:00',2.47),('15128','2013-07-09','09:55:00',2.52),('15128','2013-07-09','10:00:00',2.59),('15128','2013-07-09','10:05:00',2.66),('15128','2013-07-09','10:10:00',2.69),('15128','2013-07-09','10:15:00',2.74),('15128','2013-07-09','10:20:00',2.76),('15128','2013-07-09','10:25:00',2.77),('15128','2013-07-09','10:30:00',2.83),('15128','2013-07-09','10:35:00',2.89),('15128','2013-07-09','10:40:00',2.89),('15128','2013-07-09','10:45:00',3.01),('15128','2013-07-09','10:50:00',3.07),('15128','2013-07-09','10:55:00',3.15),('15128','2013-07-09','11:00:00',3.16),('15128','2013-07-09','11:05:00',3.27),('15128','2013-07-09','11:10:00',3.19),('15128','2013-07-09','11:15:00',3.33),('15128','2013-07-09','11:20:00',3.39),('15128','2013-07-09','11:25:00',3.45),('15128','2013-07-09','11:30:00',3.47),('15128','2013-07-09','11:35:00',3.41),('15128','2013-07-09','11:40:00',3.55),('15128','2013-07-09','11:45:00',3.65),('15128','2013-07-09','11:50:00',3.72),('15128','2013-07-09','11:55:00',3.8),('15128','2013-07-09','12:00:00',3.87),('15128','2013-07-09','12:05:00',3.92),('15128','2013-07-09','12:10:00',3.98),('15128','2013-07-09','12:15:00',4.03),('15128','2013-07-09','12:20:00',4.06),('15128','2013-07-09','12:25:00',4.15),('15128','2013-07-09','12:30:00',4.16),('15128','2013-07-09','12:35:00',4.15),('15128','2013-07-09','12:40:00',4.17),('15128','2013-07-09','12:45:00',4.19),('15128','2013-07-09','12:50:00',4.26),('15128','2013-07-09','12:55:00',4.25),('15128','2013-07-09','13:00:00',4.27),('15128','2013-07-09','13:05:00',4.27),('15128','2013-07-09','13:10:00',4.33),('15128','2013-07-09','13:15:00',4.33),('15128','2013-07-09','13:20:00',4.38),('15128','2013-07-09','13:25:00',4.41),('15128','2013-07-09','13:30:00',4.41),('15128','2013-07-09','13:35:00',4.44),('15128','2013-07-09','13:40:00',4.47),('15128','2013-07-09','13:45:00',4.47),('15128','2013-07-09','13:50:00',4.48),('15128','2013-07-09','13:55:00',4.5),('15128','2013-07-09','14:00:00',4.51),('15128','2013-07-09','14:05:00',4.54),('15128','2013-07-09','14:10:00',4.52),('15128','2013-07-09','14:15:00',4.49),('15128','2013-07-09','14:20:00',4.5),('15128','2013-07-09','14:25:00',4.45),('15128','2013-07-09','14:30:00',4.43),('15128','2013-07-09','14:35:00',4.41),('15128','2013-07-09','14:40:00',4.4),('15128','2013-07-09','14:45:00',4.37),('15128','2013-07-09','14:50:00',4.34),('15128','2013-07-09','14:55:00',4.37),('15128','2013-07-09','15:00:00',4.4),('15128','2013-07-09','15:05:00',4.38),('15128','2013-07-09','15:10:00',4.37),('15128','2013-07-09','15:15:00',4.34),('15128','2013-07-09','15:20:00',4.32),('15128','2013-07-09','15:25:00',4.3),('15128','2013-07-09','15:30:00',4.22),('15128','2013-07-09','15:35:00',4.22),('15128','2013-07-09','15:40:00',4.2),('15128','2013-07-09','15:45:00',4.14),('15128','2013-07-09','15:50:00',4.09),('15128','2013-07-09','15:55:00',4.05),('15128','2013-07-09','16:00:00',4.02),('15128','2013-07-09','16:05:00',3.97),('15128','2013-07-09','16:10:00',3.9),('15128','2013-07-09','16:15:00',3.87),('15128','2013-07-09','16:20:00',3.78),('15128','2013-07-09','16:25:00',3.73),('15128','2013-07-09','16:30:00',3.68),('15128','2013-07-09','16:35:00',3.66),('15128','2013-07-09','16:40:00',3.63),('15128','2013-07-09','16:45:00',3.61),('15128','2013-07-09','16:50:00',3.68),('15128','2013-07-09','16:55:00',3.82),('15128','2013-07-09','17:00:00',3.75),('15128','2013-07-09','17:05:00',2.71),('15128','2013-07-09','17:10:00',2.14),('15128','2013-07-09','17:15:00',1.72),('15128','2013-07-09','17:20:00',2.12),('15128','2013-07-09','17:25:00',2.28),('15128','2013-07-09','17:30:00',2.6),('15128','2013-07-09','17:35:00',3.47),('15128','2013-07-09','17:40:00',3.23),('15128','2013-07-09','17:45:00',2.97),('15128','2013-07-09','17:50:00',2.17),('15128','2013-07-09','17:55:00',1.11),('15128','2013-07-09','18:00:00',1.47),('15128','2013-07-09','18:55:00',1.73),('15128','2013-07-09','19:00:00',1.16),('15128','2013-07-09','19:05:00',1.33),('15128','2013-07-09','19:10:00',1.16),('15128','2013-07-09','19:15:00',1.22),('15128','2013-07-09','19:20:00',1.07),('15128','2013-07-08','08:05:00',1.08),('15128','2013-07-08','08:10:00',1.13),('15128','2013-07-08','08:15:00',1.17),('15128','2013-07-08','08:20:00',1.23),('15128','2013-07-08','08:25:00',1.29),('15128','2013-07-08','08:30:00',1.38),('15128','2013-07-08','08:35:00',1.43),('15128','2013-07-08','08:40:00',1.46),('15128','2013-07-08','08:45:00',1.54),('15128','2013-07-08','08:50:00',1.65),('15128','2013-07-08','08:55:00',1.72),('15128','2013-07-08','09:00:00',1.84),('15128','2013-07-08','09:05:00',1.9),('15128','2013-07-08','09:10:00',1.97),('15128','2013-07-08','09:15:00',2.06),('15128','2013-07-08','09:20:00',2.13),('15128','2013-07-08','09:25:00',2.13),('15128','2013-07-08','09:30:00',2.2),('15128','2013-07-08','09:35:00',2.31),('15128','2013-07-08','09:40:00',2.35),('15128','2013-07-08','09:45:00',2.43),('15128','2013-07-08','09:50:00',2.48),('15128','2013-07-08','09:55:00',2.51),('15128','2013-07-08','10:00:00',2.56),('15128','2013-07-08','10:05:00',2.66),('15128','2013-07-08','10:10:00',2.68),('15128','2013-07-08','10:15:00',2.74),('15128','2013-07-08','10:20:00',2.78),('15128','2013-07-08','10:25:00',2.79),('15128','2013-07-08','10:30:00',2.84),('15128','2013-07-08','10:35:00',2.9),('15128','2013-07-08','10:40:00',2.87),('15128','2013-07-08','10:45:00',3),('15128','2013-07-08','10:50:00',3.05),('15128','2013-07-08','10:55:00',3.15),('15128','2013-07-08','11:00:00',3.1),('15128','2013-07-08','11:05:00',3.22),('15128','2013-07-08','11:10:00',3.17),('15128','2013-07-08','11:15:00',3.34),('15128','2013-07-08','11:20:00',3.47),('15128','2013-07-08','11:25:00',3.58),('15128','2013-07-08','11:30:00',3.61),('15128','2013-07-08','11:35:00',3.56),('15128','2013-07-08','11:40:00',3.72),('15128','2013-07-08','11:45:00',3.83),('15128','2013-07-08','11:50:00',3.86),('15128','2013-07-08','11:55:00',3.98),('15128','2013-07-08','12:00:00',4.01),('15128','2013-07-08','12:05:00',4.02),('15128','2013-07-08','12:10:00',4.06),('15128','2013-07-08','12:15:00',3.75),('15128','2013-07-08','12:20:00',3.61),('15128','2013-07-08','12:25:00',4.2),('15128','2013-07-08','12:30:00',4.15),('15128','2013-07-08','12:35:00',4.14),('15128','2013-07-08','12:40:00',4.18),('15128','2013-07-08','12:45:00',4.18),('15128','2013-07-08','12:50:00',3.79),('15128','2013-07-08','12:55:00',4.32),('15128','2013-07-08','13:00:00',4.46),('15128','2013-07-08','13:05:00',2.46),('15128','2013-07-08','13:10:00',2.45),('15128','2013-07-08','13:15:00',4),('15128','2013-07-08','13:20:00',4.59),('15128','2013-07-08','13:25:00',4.51),('15128','2013-07-08','13:30:00',4.53),('15128','2013-07-08','13:35:00',4.53),('15128','2013-07-08','13:40:00',4.42),('15128','2013-07-08','13:45:00',3.86),('15128','2013-07-08','13:50:00',4.18),('15128','2013-07-08','13:55:00',4.32),('15128','2013-07-08','14:00:00',3.89),('15128','2013-07-08','14:05:00',4.08),('15128','2013-07-08','14:10:00',4.4),('15128','2013-07-08','14:15:00',4.9),('15128','2013-07-08','14:20:00',3.57),('15128','2013-07-08','14:25:00',2.96),('15128','2013-07-08','14:30:00',1.11),('15128','2013-07-07','08:00:00',1.06),('15128','2013-07-07','08:05:00',1.14),('15128','2013-07-07','08:10:00',1.16),('15128','2013-07-07','08:15:00',1.2),('15128','2013-07-07','08:20:00',1.25),('15128','2013-07-07','08:25:00',1.3),('15128','2013-07-07','08:30:00',1.38),('15128','2013-07-07','08:35:00',1.41),('15128','2013-07-07','08:40:00',1.46),('15128','2013-07-07','08:45:00',1.55),('15128','2013-07-07','08:50:00',1.65),('15128','2013-07-07','08:55:00',1.72),('15128','2013-07-07','09:00:00',1.81),('15128','2013-07-07','09:05:00',1.88),('15128','2013-07-07','09:10:00',1.97),('15128','2013-07-07','09:15:00',2.07),('15128','2013-07-07','09:20:00',2.1),('15128','2013-07-07','09:25:00',2.08),('15128','2013-07-07','09:30:00',2.18),('15128','2013-07-07','09:35:00',2.29),('15128','2013-07-07','09:40:00',2.36),('15128','2013-07-07','09:45:00',2.4),('15128','2013-07-07','09:50:00',2.44),('15128','2013-07-07','09:55:00',2.5),('15128','2013-07-07','10:00:00',2.58),('15128','2013-07-07','10:05:00',2.64),('15128','2013-07-07','10:10:00',2.68),('15128','2013-07-07','10:15:00',2.74),('15128','2013-07-07','10:20:00',2.78),('15128','2013-07-07','10:25:00',2.81),('15128','2013-07-07','10:30:00',2.86),('15128','2013-07-07','10:35:00',2.6),('15128','2013-07-07','10:40:00',2.94),('15128','2013-07-07','10:45:00',3.04),('15128','2013-07-07','10:50:00',3),('15128','2013-07-07','10:55:00',3.15),('15128','2013-07-07','11:00:00',3.11),('15128','2013-07-07','11:05:00',3.26),('15128','2013-07-07','11:10:00',3.23),('15128','2013-07-07','11:15:00',3.41),('15128','2013-07-07','11:20:00',3.44),('15128','2013-07-07','11:25:00',3.29),('15128','2013-07-07','11:30:00',3.5),('15128','2013-07-07','11:35:00',3.02),('15128','2013-07-07','11:40:00',3.35),('15128','2013-07-07','11:45:00',3.92),('15128','2013-07-07','11:50:00',3.91),('15128','2013-07-07','11:55:00',3.87),('15128','2013-07-07','12:00:00',3.95),('15128','2013-07-07','12:05:00',4.12),('15128','2013-07-07','12:10:00',3.58),('15128','2013-07-07','12:15:00',3.92),('15128','2013-07-07','12:20:00',3.28),('15128','2013-07-07','12:25:00',3.41),('15128','2013-07-07','12:30:00',4.33),('15128','2013-07-07','12:35:00',4.28),('15128','2013-07-07','12:40:00',4.28),('15128','2013-07-07','12:45:00',4.43),('15128','2013-07-07','12:50:00',4.46),('15128','2013-07-07','12:55:00',4.22),('15128','2013-07-07','13:00:00',3.1),('15128','2013-07-07','13:05:00',4.46),('15128','2013-07-07','13:10:00',3.97),('15128','2013-07-07','13:15:00',1.6),('15128','2013-07-07','14:00:00',1.02),('15128','2013-07-07','14:05:00',1.28),('15128','2013-07-07','14:10:00',1.54),('15128','2013-07-07','14:15:00',1.67),('15128','2013-07-07','14:20:00',1.46),('15128','2013-07-07','14:25:00',1.45),('15128','2013-07-07','14:30:00',1.4),('15128','2013-07-07','14:35:00',1.81),('15128','2013-07-07','14:40:00',2.39),('15128','2013-07-07','14:45:00',2.5),('15128','2013-07-07','14:50:00',2.11),('15128','2013-07-07','14:55:00',1.65),('15128','2013-07-07','15:00:00',1.57),('15128','2013-07-07','15:05:00',1.71),('15128','2013-07-07','15:10:00',1.57),('15128','2013-07-07','15:15:00',1.32),('15128','2013-07-07','18:30:00',1.4),('15128','2013-07-07','18:35:00',1.46),('15128','2013-07-07','18:40:00',1.3),('15128','2013-07-07','18:45:00',1.25),('15128','2013-07-06','08:05:00',1.06),('15128','2013-07-06','08:10:00',1.13),('15128','2013-07-06','08:15:00',1.19),('15128','2013-07-06','08:20:00',1.25),('15128','2013-07-06','08:25:00',1.36),('15128','2013-07-06','08:30:00',1.35),('15128','2013-07-06','08:40:00',1.18),('15128','2013-07-06','08:45:00',1.71),('15128','2013-07-06','08:50:00',1.8),('15128','2013-07-06','08:55:00',1.89),('15128','2013-07-06','09:00:00',1.8),('15128','2013-07-06','09:05:00',1.53),('15128','2013-07-06','09:10:00',1.65),('15128','2013-07-06','09:15:00',1.24),('15128','2013-07-06','09:20:00',1.23),('15128','2013-07-06','09:25:00',1.29),('15128','2013-07-06','09:30:00',2.05),('15128','2013-07-06','09:35:00',2.47),('15128','2013-07-06','09:40:00',2.13),('15128','2013-07-06','09:45:00',2.56),('15128','2013-07-06','09:50:00',2.7),('15128','2013-07-06','09:55:00',2.68),('15128','2013-07-06','10:00:00',2.72),('15128','2013-07-06','10:05:00',2.65),('15128','2013-07-06','10:10:00',2.63),('15128','2013-07-06','10:15:00',2.34),('15128','2013-07-06','10:20:00',2.9),('15128','2013-07-06','10:25:00',2.98),('15128','2013-07-06','10:30:00',2.69),('15128','2013-07-06','10:35:00',2.88),('15128','2013-07-06','10:40:00',2.9),('15128','2013-07-06','10:45:00',3.12),('15128','2013-07-06','10:50:00',3.19),('15128','2013-07-06','10:55:00',3.27),('15128','2013-07-06','11:00:00',3.23),('15128','2013-07-06','11:05:00',3.34),('15128','2013-07-06','11:10:00',3.3),('15128','2013-07-06','11:15:00',3.45),('15128','2013-07-06','11:20:00',2.95),('15128','2013-07-06','11:25:00',2.99),('15128','2013-07-06','11:30:00',3.48),('15128','2013-07-06','11:35:00',3.19),('15128','2013-07-06','11:40:00',3.33),('15128','2013-07-06','11:45:00',3.51),('15128','2013-07-06','11:50:00',3.76),('15128','2013-07-06','11:55:00',3.63),('15128','2013-07-06','12:00:00',3.03),('15128','2013-07-06','12:05:00',3.13),('15128','2013-07-06','12:10:00',3.37),('15128','2013-07-06','12:15:00',3.08),('15128','2013-07-06','12:20:00',3.33),('15128','2013-07-06','12:25:00',3.96),('15128','2013-07-06','12:30:00',4.03),('15128','2013-07-06','12:35:00',4.07),('15128','2013-07-06','12:40:00',4.11),('15128','2013-07-06','12:45:00',4.12),('15128','2013-07-06','12:50:00',4.17),('15128','2013-07-06','12:55:00',4.33),('15128','2013-07-06','13:00:00',4.29),('15128','2013-07-06','13:05:00',4.12),('15128','2013-07-06','13:10:00',4.3),('15128','2013-07-06','13:15:00',4.39),('15128','2013-07-06','13:20:00',4.37),('15128','2013-07-06','13:25:00',4.42),('15128','2013-07-06','13:30:00',4.53),('15128','2013-07-06','13:35:00',3.4),('15128','2013-07-06','13:40:00',1.35),('15128','2013-07-06','13:45:00',1.24),('15128','2013-07-06','13:50:00',1.69),('15128','2013-07-06','13:55:00',1.27),('15128','2013-07-06','14:00:00',1.05),('15128','2013-07-06','14:10:00',1.18),('15128','2013-07-06','14:15:00',1.67),('15128','2013-07-06','14:20:00',3.47),('15128','2013-07-06','14:25:00',3.44),('15128','2013-07-06','14:30:00',3.06),('15128','2013-07-06','14:35:00',1.68),('15128','2013-07-06','14:40:00',1.32),('15128','2013-07-06','14:45:00',1.31),('15128','2013-07-06','14:50:00',1.31),('15128','2013-07-06','14:55:00',1.37),('15128','2013-07-06','15:00:00',1.57),('15128','2013-07-06','15:05:00',1.88),('15128','2013-07-06','15:10:00',2.15),('15128','2013-07-06','15:15:00',1.37),('15128','2013-07-06','17:00:00',1.12),('15128','2013-07-06','17:05:00',1.22),('15128','2013-07-06','17:10:00',1.31),('15128','2013-07-06','17:15:00',1.4),('15128','2013-07-06','17:20:00',1.46),('15128','2013-07-06','17:25:00',1.48),('15128','2013-07-06','17:30:00',1.54),('15128','2013-07-06','17:35:00',1.7),('15128','2013-07-06','17:40:00',1.77),('15128','2013-07-06','17:45:00',1.97),('15128','2013-07-06','17:50:00',1.91),('15128','2013-07-06','17:55:00',1.83),('15128','2013-07-06','18:00:00',1.58),('15128','2013-07-06','18:05:00',1.55),('15128','2013-07-06','18:10:00',1.17),('15128','2013-07-06','18:15:00',1.16),('15128','2013-07-06','18:20:00',1.17),('15128','2013-07-06','18:25:00',1.29),('15128','2013-07-06','18:30:00',1.13),('15128','2013-07-05','08:10:00',1.01),('15128','2013-07-05','08:15:00',1.06),('15128','2013-07-05','08:20:00',1.13),('15128','2013-07-05','08:25:00',1.21),('15128','2013-07-05','08:30:00',1.28),('15128','2013-07-05','08:35:00',1.32),('15128','2013-07-05','08:40:00',1.4),('15128','2013-07-05','08:45:00',1.48),('15128','2013-07-05','08:50:00',1.55),('15128','2013-07-05','08:55:00',1.63),('15128','2013-07-05','09:00:00',1.75),('15128','2013-07-05','09:05:00',1.81),('15128','2013-07-05','09:10:00',1.88),('15128','2013-07-05','09:15:00',1.95),('15128','2013-07-05','09:20:00',2),('15128','2013-07-05','09:25:00',1.98),('15128','2013-07-05','09:30:00',2.11),('15128','2013-07-05','09:35:00',2.21),('15128','2013-07-05','09:40:00',2.27),('15128','2013-07-05','09:45:00',2.33),('15128','2013-07-05','09:50:00',2.37),('15128','2013-07-05','09:55:00',2.43),('15128','2013-07-05','10:00:00',2.47),('15128','2013-07-05','10:05:00',2.56),('15128','2013-07-05','10:10:00',2.59),('15128','2013-07-05','10:15:00',2.65),('15128','2013-07-05','10:20:00',2.7),('15128','2013-07-05','10:25:00',2.72),('15128','2013-07-05','10:30:00',2.77),('15128','2013-07-05','10:35:00',2.84),('15128','2013-07-05','10:40:00',2.84),('15128','2013-07-05','10:45:00',2.93),('15128','2013-07-05','10:50:00',2.95),('15128','2013-07-05','10:55:00',3.04),('15128','2013-07-05','11:00:00',3.06),('15128','2013-07-05','11:05:00',3.17),('15128','2013-07-05','11:10:00',3.11),('15128','2013-07-05','11:15:00',3.28),('15128','2013-07-05','11:20:00',3.34),('15128','2013-07-05','11:25:00',3.41),('15128','2013-07-05','11:30:00',3.39),('15128','2013-07-05','11:35:00',3.32),('15128','2013-07-05','11:40:00',3.46),('15128','2013-07-05','11:45:00',3.64),('15128','2013-07-05','11:50:00',3.71),('15128','2013-07-05','11:55:00',3.81),('15128','2013-07-05','12:00:00',3.83),('15128','2013-07-05','12:05:00',3.86),('15128','2013-07-05','12:10:00',3.92),('15128','2013-07-05','12:15:00',3.96),('15128','2013-07-05','12:20:00',3.97),('15128','2013-07-05','12:25:00',4.02),('15128','2013-07-05','12:30:00',4.07),('15128','2013-07-05','12:35:00',4.12),('15128','2013-07-05','12:40:00',4.13),('15128','2013-07-05','12:45:00',4.15),('15128','2013-07-05','12:50:00',4.15),('15128','2013-07-05','12:55:00',4.17),('15128','2013-07-05','13:00:00',4.18),('15128','2013-07-05','13:05:00',4.19),('15128','2013-07-05','13:10:00',4.19),('15128','2013-07-05','13:15:00',4.2),('15128','2013-07-05','13:20:00',4.24),('15128','2013-07-05','13:25:00',4.25),('15128','2013-07-05','13:30:00',4.24),('15128','2013-07-05','13:35:00',4.28),('15128','2013-07-05','13:40:00',4.3),('15128','2013-07-05','13:45:00',4.28),('15128','2013-07-05','13:50:00',4.24),('15128','2013-07-05','13:55:00',4.26),('15128','2013-07-05','14:00:00',4.28),('15128','2013-07-05','14:05:00',4.25),('15128','2013-07-05','14:10:00',4.22),('15128','2013-07-05','14:15:00',4.21),('15128','2013-07-05','14:20:00',3.87),('15128','2013-07-05','14:25:00',4.21),('15128','2013-07-05','14:30:00',4.17),('15128','2013-07-05','14:35:00',4.15),('15128','2013-07-05','14:40:00',4.32),('15128','2013-07-05','14:45:00',4.34),('15128','2013-07-05','14:50:00',3.69),('15128','2013-07-05','14:55:00',1.18),('15128','2013-07-05','15:00:00',2.56),('15128','2013-07-05','15:05:00',1.4),('15128','2013-07-05','15:10:00',1.62),('15128','2013-07-05','15:15:00',2.37),('15128','2013-07-05','15:20:00',4.2),('15128','2013-07-05','15:25:00',1.1),('15128','2013-07-05','16:15:00',1.03),('15128','2013-07-05','16:20:00',1.08),('15128','2013-07-05','16:25:00',1.07),('15128','2013-07-05','16:30:00',1.29),('15128','2013-07-05','16:35:00',1.7),('15128','2013-07-05','16:40:00',1.49),('15128','2013-07-05','16:45:00',1.45),('15128','2013-07-05','16:50:00',3.37),('15128','2013-07-05','16:55:00',3.69),('15128','2013-07-05','17:00:00',3),('15128','2013-07-05','17:05:00',3.21),('15128','2013-07-05','17:10:00',2.63),('15128','2013-07-05','17:15:00',1.72),('15128','2013-07-05','17:20:00',1.3),('15128','2013-07-05','17:25:00',1.07),('15128','2013-07-05','19:10:00',1.29),('15128','2013-07-04','08:05:00',1.03),('15128','2013-07-04','08:10:00',1.09),('15128','2013-07-04','08:15:00',1.14),('15128','2013-07-04','08:20:00',1.21),('15128','2013-07-04','08:25:00',1.3),('15128','2013-07-04','08:30:00',1.36),('15128','2013-07-04','08:35:00',1.38),('15128','2013-07-04','08:40:00',1.42),('15128','2013-07-04','08:45:00',1.51),('15128','2013-07-04','08:50:00',1.59),('15128','2013-07-04','08:55:00',1.67),('15128','2013-07-04','09:00:00',1.78),('15128','2013-07-04','09:05:00',1.84),('15128','2013-07-04','09:10:00',1.91),('15128','2013-07-04','09:15:00',1.98),('15128','2013-07-04','09:20:00',2.03),('15128','2013-07-04','09:25:00',1.99),('15128','2013-07-04','09:30:00',2.11),('15128','2013-07-04','09:35:00',2.2),('15128','2013-07-04','09:40:00',2.27),('15128','2013-07-04','09:45:00',2.31),('15128','2013-07-04','09:50:00',2.35),('15128','2013-07-04','09:55:00',2.4),('15128','2013-07-04','10:00:00',2.45),('15128','2013-07-04','10:05:00',2.53),('15128','2013-07-04','10:10:00',2.57),('15128','2013-07-04','10:15:00',2.62),('15128','2013-07-04','10:20:00',2.66),('15128','2013-07-04','10:25:00',2.7),('15128','2013-07-04','10:30:00',2.77),('15128','2013-07-04','10:35:00',2.85),('15128','2013-07-04','10:40:00',2.83),('15128','2013-07-04','10:45:00',2.97),('15128','2013-07-04','10:50:00',2.99),('15128','2013-07-04','10:55:00',3.05),('15128','2013-07-04','11:00:00',3.04),('15128','2013-07-04','11:05:00',3.14),('15128','2013-07-04','11:10:00',3.11),('15128','2013-07-04','11:15:00',3.25),('15128','2013-07-04','11:20:00',3.32),('15128','2013-07-04','11:25:00',3.41),('15128','2013-07-04','11:30:00',3.4),('15128','2013-07-04','11:35:00',3.36),('15128','2013-07-04','11:40:00',3.47),('15128','2013-07-04','11:45:00',3.62),('15128','2013-07-04','11:50:00',3.68),('15128','2013-07-04','11:55:00',3.81),('15128','2013-07-04','12:00:00',3.89),('15128','2013-07-04','12:05:00',3.91),('15128','2013-07-04','12:10:00',3.97),('15128','2013-07-04','12:15:00',3.97),('15128','2013-07-04','12:20:00',3.71),('15128','2013-07-04','12:25:00',2.47),('15128','2013-07-04','12:30:00',3.12),('15128','2013-07-04','12:35:00',4.36),('15128','2013-07-04','12:40:00',2.99),('15128','2013-07-04','12:45:00',2.58),('15128','2013-07-04','12:50:00',1.95),('15128','2013-07-04','12:55:00',1.27),('15128','2013-07-04','13:00:00',2.72),('15128','2013-07-04','13:05:00',4.45),('15128','2013-07-04','13:10:00',4.51),('15128','2013-07-04','13:15:00',4.34),('15128','2013-07-04','13:20:00',4.5),('15128','2013-07-04','13:25:00',4.51),('15128','2013-07-04','13:30:00',4.65),('15128','2013-07-04','13:35:00',4.5),('15128','2013-07-04','13:40:00',3.88),('15128','2013-07-04','13:45:00',4.37),('15128','2013-07-04','13:50:00',4.36),('15128','2013-07-04','13:55:00',4.34),('15128','2013-07-04','14:00:00',4.46),('15128','2013-07-04','14:05:00',4.45),('15128','2013-07-04','14:10:00',4.23),('15128','2013-07-04','14:15:00',4.1),('15128','2013-07-04','14:20:00',4.27),('15128','2013-07-04','14:25:00',4.38),('15128','2013-07-04','14:30:00',4.33),('15128','2013-07-04','14:35:00',4.33),('15128','2013-07-04','14:40:00',4.32),('15128','2013-07-04','14:45:00',4.29),('15128','2013-07-04','14:50:00',4.33),('15128','2013-07-04','14:55:00',4.15),('15128','2013-07-04','15:00:00',1.63),('15128','2013-07-04','15:05:00',4.01),('15128','2013-07-04','15:10:00',3.35),('15128','2013-07-04','15:15:00',1.5),('15128','2013-07-04','15:20:00',3.28),('15128','2013-07-04','15:25:00',2.33),('15128','2013-07-04','15:30:00',2.26),('15128','2013-07-04','15:35:00',2.52),('15128','2013-07-04','15:40:00',4.12),('15128','2013-07-04','15:45:00',4.05),('15128','2013-07-04','15:50:00',3.89),('15128','2013-07-04','15:55:00',3.88),('15128','2013-07-04','16:00:00',3.83),('15128','2013-07-04','16:05:00',3.32),('15128','2013-07-04','16:10:00',3.45),('15128','2013-07-04','16:15:00',3.74),('15128','2013-07-04','16:20:00',3.69),('15128','2013-07-04','16:25:00',3.61),('15128','2013-07-04','16:30:00',3.51),('15128','2013-07-04','16:35:00',3.38),('15128','2013-07-04','16:40:00',3.44),('15128','2013-07-04','16:45:00',3.34),('15128','2013-07-04','16:50:00',2.28),('15128','2013-07-04','16:55:00',2.1),('15128','2013-07-04','17:00:00',2.06),('15128','2013-07-04','17:05:00',3.2),('15128','2013-07-04','17:10:00',2.43),('15128','2013-07-04','17:15:00',1.11),('15128','2013-07-04','17:20:00',2.56),('15128','2013-07-04','17:25:00',2.9),('15128','2013-07-04','17:30:00',2.82),('15128','2013-07-04','17:35:00',2.73),('15128','2013-07-04','17:40:00',2.65),('15128','2013-07-04','17:45:00',2.57),('15128','2013-07-04','17:50:00',2.54),('15128','2013-07-04','17:55:00',2.51),('15128','2013-07-04','18:00:00',2.49),('15128','2013-07-04','18:05:00',2.52),('15128','2013-07-04','18:10:00',2.45),('15128','2013-07-04','18:15:00',2.32),('15128','2013-07-04','18:20:00',2.13),('15128','2013-07-04','18:25:00',1.96),('15128','2013-07-04','18:30:00',1.82),('15128','2013-07-04','18:35:00',1.7),('15128','2013-07-04','18:40:00',1.6),('15128','2013-07-04','18:45:00',1.5),('15128','2013-07-04','18:50:00',1.45),('15128','2013-07-04','18:55:00',1.39),('15128','2013-07-04','19:00:00',1.28),('15128','2013-07-04','19:05:00',1.19),('15128','2013-07-04','19:10:00',1.1),('15128','2013-07-04','19:15:00',1.01),('15128','2013-07-03','11:00:00',1.07),('15128','2013-07-03','11:05:00',1.24),('15128','2013-07-03','11:10:00',1.19),('15128','2013-07-03','11:15:00',1.14),('15128','2013-07-03','11:20:00',1.14),('15128','2013-07-03','11:25:00',1.19),('15128','2013-07-03','11:30:00',1.34),('15128','2013-07-03','11:35:00',1.49),('15128','2013-07-03','11:40:00',1.75),('15128','2013-07-03','11:45:00',2.07),('15128','2013-07-03','11:50:00',1.93),('15128','2013-07-03','11:55:00',1.65),('15128','2013-07-03','12:00:00',1.7),('15128','2013-07-03','12:05:00',2),('15128','2013-07-03','12:10:00',2.58),('15128','2013-07-03','12:15:00',2.49),('15128','2013-07-03','12:20:00',1.93),('15128','2013-07-03','12:25:00',1.42),('15128','2013-07-03','12:55:00',1.06),('15128','2013-07-03','13:00:00',1.17),('15128','2013-07-03','13:05:00',1.72),('15128','2013-07-03','13:10:00',1.26),('15128','2013-07-03','13:15:00',1.71),('15128','2013-07-03','13:20:00',1.51),('15128','2013-07-03','13:25:00',1.81),('15128','2013-07-03','13:30:00',2.09),('15128','2013-07-03','13:35:00',2.08),('15128','2013-07-03','13:40:00',2.29),('15128','2013-07-03','13:45:00',2.92),('15128','2013-07-03','13:50:00',2.14),('15128','2013-07-03','13:55:00',1.94),('15128','2013-07-03','14:00:00',1.98),('15128','2013-07-03','14:05:00',2.02),('15128','2013-07-03','14:10:00',2.19),('15128','2013-07-03','14:15:00',3.5),('15128','2013-07-03','14:20:00',3),('15128','2013-07-03','14:25:00',3.07),('15128','2013-07-03','14:30:00',2.7),('15128','2013-07-03','14:35:00',1.82),('15128','2013-07-03','14:40:00',1.71),('15128','2013-07-03','14:45:00',1.66),('15128','2013-07-03','14:50:00',2.06),('15128','2013-07-03','14:55:00',4.71),('15128','2013-07-03','15:00:00',4.03),('15128','2013-07-03','15:05:00',3.33),('15128','2013-07-03','15:10:00',2.02),('15128','2013-07-03','15:15:00',4.35),('15128','2013-07-03','15:20:00',2.96),('15128','2013-07-03','15:25:00',1.81),('15128','2013-07-03','15:30:00',2.23),('15128','2013-07-03','15:35:00',3.3),('15128','2013-07-03','15:40:00',2.99),('15128','2013-07-03','15:45:00',3.55),('15128','2013-07-03','15:50:00',4.58),('15128','2013-07-03','15:55:00',3.59),('15128','2013-07-03','16:00:00',2.49),('15128','2013-07-03','16:05:00',2.43),('15128','2013-07-03','16:10:00',2.84),('15128','2013-07-03','16:15:00',2.94),('15128','2013-07-03','16:20:00',3.31),('15128','2013-07-03','16:25:00',2.31),('15128','2013-07-03','16:30:00',1.98),('15128','2013-07-03','16:35:00',1.73),('15128','2013-07-03','16:40:00',1.6),('15128','2013-07-03','16:45:00',1.57),('15128','2013-07-03','16:50:00',1.46),('15128','2013-07-03','16:55:00',1.9),('15128','2013-07-03','17:00:00',3.1),('15128','2013-07-03','17:05:00',2.25),('15128','2013-07-03','17:10:00',2.26),('15128','2013-07-03','17:15:00',2.99),('15128','2013-07-03','17:20:00',2.31),('15128','2013-07-03','17:25:00',3.35),('15128','2013-07-03','17:30:00',2.18),('15128','2013-07-03','17:35:00',2.65),('15128','2013-07-03','17:40:00',2.38),('15128','2013-07-03','17:45:00',2.73),('15128','2013-07-03','17:50:00',2.71),('15128','2013-07-03','17:55:00',2.66),('15128','2013-07-03','18:00:00',2.4),('15128','2013-07-03','18:05:00',2.08),('15128','2013-07-03','18:10:00',1.81),('15128','2013-07-03','18:15:00',1.77),('15128','2013-07-03','18:20:00',1.82),('15128','2013-07-03','18:25:00',1.25),('15128','2013-07-03','18:30:00',1),('15128','2013-07-02','08:05:00',1.03),('15128','2013-07-02','08:10:00',1.1),('15128','2013-07-02','08:15:00',1.15),('15128','2013-07-02','08:20:00',1.21),('15128','2013-07-02','08:25:00',1.29),('15128','2013-07-02','08:30:00',1.37),('15128','2013-07-02','08:35:00',1.41),('15128','2013-07-02','08:40:00',1.49),('15128','2013-07-02','08:45:00',1.57),('15128','2013-07-02','08:50:00',1.65),('15128','2013-07-02','08:55:00',1.74),('15128','2013-07-02','09:00:00',1.83),('15128','2013-07-02','09:05:00',1.9),('15128','2013-07-02','09:10:00',1.96),('15128','2013-07-02','09:15:00',2.05),('15128','2013-07-02','09:20:00',2.08),('15128','2013-07-02','09:25:00',2.06),('15128','2013-07-02','09:30:00',2.21),('15128','2013-07-02','09:35:00',2.28),('15128','2013-07-02','09:40:00',2.29),('15128','2013-07-02','09:45:00',2.33),('15128','2013-07-02','09:50:00',2.39),('15128','2013-07-02','09:55:00',2.51),('15128','2013-07-02','10:00:00',2.53),('15128','2013-07-02','10:05:00',2.62),('15128','2013-07-02','10:10:00',2.67),('15128','2013-07-02','10:15:00',2.56),('15128','2013-07-02','10:20:00',2.68),('15128','2013-07-02','10:25:00',2.77),('15128','2013-07-02','10:30:00',2.76),('15128','2013-07-02','10:35:00',2.77),('15128','2013-07-02','10:40:00',2.82),('15128','2013-07-02','10:45:00',3.02),('15128','2013-07-02','10:50:00',3.09),('15128','2013-07-02','10:55:00',3.17),('15128','2013-07-02','11:00:00',3.17),('15128','2013-07-02','11:05:00',3.23),('15128','2013-07-02','11:10:00',3.17),('15128','2013-07-02','11:15:00',3.42),('15128','2013-07-02','11:20:00',3.48),('15128','2013-07-02','11:25:00',3.54),('15128','2013-07-02','11:30:00',3.54),('15128','2013-07-02','11:35:00',3.66),('15128','2013-07-02','11:40:00',3.77),('15128','2013-07-02','11:45:00',3.85),('15128','2013-07-02','11:50:00',3.92),('15128','2013-07-02','11:55:00',4.03),('15128','2013-07-02','12:00:00',4.06),('15128','2013-07-02','12:05:00',4.08),('15128','2013-07-02','12:10:00',4.12),('15128','2013-07-02','12:15:00',4.17),('15128','2013-07-02','12:20:00',4.2),('15128','2013-07-02','12:25:00',4.2),('15128','2013-07-02','12:30:00',4.23),('15128','2013-07-02','12:35:00',4.25),('15128','2013-07-02','12:40:00',4.26),('15128','2013-07-02','12:45:00',4.29),('15128','2013-07-02','12:50:00',4.32),('15128','2013-07-02','12:55:00',4.33),('15128','2013-07-02','13:00:00',4.34),('15128','2013-07-02','13:05:00',4.35),('15128','2013-07-02','13:10:00',4.39),('15128','2013-07-02','13:15:00',4.39),('15128','2013-07-02','13:20:00',4.39),('15128','2013-07-02','13:25:00',4.4),('15128','2013-07-02','13:30:00',4.43),('15128','2013-07-02','13:35:00',4.44),('15128','2013-07-02','13:40:00',4.44),('15128','2013-07-02','13:45:00',4.45),('15128','2013-07-02','13:50:00',4.47),('15128','2013-07-02','13:55:00',4.47),('15128','2013-07-02','14:00:00',4.48),('15128','2013-07-02','14:05:00',4.47),('15128','2013-07-02','14:10:00',4.48),('15128','2013-07-02','14:15:00',4.49),('15128','2013-07-02','14:20:00',4.48),('15128','2013-07-02','14:25:00',4.48),('15128','2013-07-02','14:30:00',4.45),('15128','2013-07-02','14:35:00',4.42),('15128','2013-07-02','14:40:00',4.43),('15128','2013-07-02','14:45:00',4.46),('15128','2013-07-02','14:50:00',4.45),('15128','2013-07-02','14:55:00',4.41),('15128','2013-07-02','15:00:00',4.39),('15128','2013-07-02','15:05:00',4.36),('15128','2013-07-02','15:10:00',4.33),('15128','2013-07-02','15:15:00',4.31),('15128','2013-07-02','15:20:00',4.27),('15128','2013-07-02','15:25:00',4.26),('15128','2013-07-02','15:30:00',4.23),('15128','2013-07-02','15:35:00',4.19),('15128','2013-07-02','15:40:00',4.15),('15128','2013-07-02','15:45:00',4.11),('15128','2013-07-02','15:50:00',4.08),('15128','2013-07-02','15:55:00',4.03),('15128','2013-07-02','16:00:00',4),('15128','2013-07-02','16:05:00',3.97),('15128','2013-07-02','16:10:00',3.9),('15128','2013-07-02','16:15:00',3.85),('15128','2013-07-02','16:20:00',3.82),('15128','2013-07-02','16:25:00',3.79),('15128','2013-07-02','16:30:00',3.75),('15128','2013-07-02','16:35:00',3.7),('15128','2013-07-02','16:40:00',3.64),('15128','2013-07-02','16:45:00',3.59),('15128','2013-07-02','16:50:00',3.55),('15128','2013-07-02','16:55:00',3.48),('15128','2013-07-02','17:00:00',3.43),('15128','2013-07-02','17:05:00',3.39),('15128','2013-07-02','17:10:00',3.32),('15128','2013-07-02','17:15:00',3.26),('15128','2013-07-02','17:20:00',3.18),('15128','2013-07-02','17:25:00',3.11),('15128','2013-07-02','17:30:00',3.02),('15128','2013-07-02','17:35:00',2.97),('15128','2013-07-02','17:40:00',2.89),('15128','2013-07-02','17:45:00',2.81),('15128','2013-07-02','17:50:00',2.74),('15128','2013-07-02','17:55:00',2.69),('15128','2013-07-02','18:00:00',2.59),('15128','2013-07-02','18:05:00',2.49),('15128','2013-07-02','18:10:00',2.39),('15128','2013-07-02','18:15:00',2.28),('15128','2013-07-02','18:20:00',2.18),('15128','2013-07-02','18:25:00',2.08),('15128','2013-07-02','18:30:00',2.01),('15128','2013-07-02','18:35:00',1.91),('15128','2013-07-02','18:40:00',1.83),('15128','2013-07-02','18:45:00',1.75),('15128','2013-07-02','18:50:00',1.71),('15128','2013-07-02','18:55:00',1.65),('15128','2013-07-02','19:00:00',1.55),('15128','2013-07-02','19:05:00',1.45),('15128','2013-07-02','19:10:00',1.35),('15128','2013-07-02','19:15:00',1.27),('15128','2013-07-02','19:20:00',1.11),('15128','2013-07-01','08:05:00',1.03),('15128','2013-07-01','08:10:00',1.09),('15128','2013-07-01','08:15:00',1.13),('15128','2013-07-01','08:20:00',1.19),('15128','2013-07-01','08:25:00',1.28),('15128','2013-07-01','08:30:00',1.35),('15128','2013-07-01','08:35:00',1.4),('15128','2013-07-01','08:40:00',1.47),('15128','2013-07-01','08:45:00',1.53),('15128','2013-07-01','08:50:00',1.62),('15128','2013-07-01','08:55:00',1.72),('15128','2013-07-01','09:00:00',1.8),('15128','2013-07-01','09:05:00',1.88),('15128','2013-07-01','09:10:00',1.96),('15128','2013-07-01','09:15:00',2.03),('15128','2013-07-01','09:20:00',2.06),('15128','2013-07-01','09:25:00',2.05),('15128','2013-07-01','09:30:00',2.21),('15128','2013-07-01','09:35:00',2.29),('15128','2013-07-01','09:40:00',2.36),('15128','2013-07-01','09:45:00',2.41),('15128','2013-07-01','09:50:00',2.46),('15128','2013-07-01','09:55:00',2.5),('15128','2013-07-01','10:00:00',2.56),('15128','2013-07-01','10:05:00',2.61),('15128','2013-07-01','10:10:00',2.65),('15128','2013-07-01','10:15:00',2.68),('15128','2013-07-01','10:20:00',2.72),('15128','2013-07-01','10:25:00',2.75),('15128','2013-07-01','10:30:00',2.8),('15128','2013-07-01','10:35:00',2.88),('15128','2013-07-01','10:40:00',2.88),('15128','2013-07-01','10:45:00',2.97),('15128','2013-07-01','10:50:00',2.99),('15128','2013-07-01','10:55:00',3.07),('15128','2013-07-01','11:00:00',3.06),('15128','2013-07-01','11:05:00',3.14),('15128','2013-07-01','11:10:00',3.11),('15128','2013-07-01','11:15:00',3.26),('15128','2013-07-01','11:20:00',3.32),('15128','2013-07-01','11:25:00',3.39),('15128','2013-07-01','11:30:00',3.31),('15128','2013-07-01','11:35:00',3.32),('15128','2013-07-01','11:40:00',3.43),('15128','2013-07-01','11:45:00',3.62),('15128','2013-07-01','11:50:00',3.74),('15128','2013-07-01','11:55:00',3.78),('15128','2013-07-01','12:00:00',3.73),('15128','2013-07-01','12:05:00',3.62),('15128','2013-07-01','12:10:00',3.82),('15128','2013-07-01','12:15:00',4.07),('15128','2013-07-01','12:20:00',4.13),('15128','2013-07-01','12:25:00',3.88),('15128','2013-07-01','12:30:00',3.87),('15128','2013-07-01','12:35:00',4.17),('15128','2013-07-01','12:40:00',4.15),('15128','2013-07-01','12:45:00',4.15),('15128','2013-07-01','12:50:00',3.86),('15128','2013-07-01','12:55:00',3.99),('15128','2013-07-01','13:00:00',4.06),('15128','2013-07-01','13:05:00',4.19),('15128','2013-07-01','13:10:00',4.22),('15128','2013-07-01','13:15:00',4.2),('15128','2013-07-01','13:20:00',4.2),('15128','2013-07-01','13:25:00',4.17),('15128','2013-07-01','13:30:00',4.23),('15128','2013-07-01','13:35:00',4.24),('15128','2013-07-01','13:40:00',4.16),('15128','2013-07-01','13:45:00',4.22),('15128','2013-07-01','13:50:00',4.31),('15128','2013-07-01','13:55:00',4.31),('15128','2013-07-01','14:00:00',4.32),('15128','2013-07-01','14:05:00',4.33),('15128','2013-07-01','14:10:00',4.3),('15128','2013-07-01','14:15:00',4.27),('15128','2013-07-01','14:20:00',4.3),('15128','2013-07-01','14:25:00',4.3),('15128','2013-07-01','14:30:00',4.29),('15128','2013-07-01','14:35:00',4.29),('15128','2013-07-01','14:40:00',4.28),('15128','2013-07-01','14:45:00',4.28),('15128','2013-07-01','14:50:00',4.27),('15128','2013-07-01','14:55:00',4.26),('15128','2013-07-01','15:00:00',4.23),('15128','2013-07-01','15:05:00',4.2),('15128','2013-07-01','15:10:00',4.18),('15128','2013-07-01','15:15:00',4.19),('15128','2013-07-01','15:20:00',4.13),('15128','2013-07-01','15:25:00',4.15),('15128','2013-07-01','15:30:00',4.12),('15128','2013-07-01','15:35:00',4.09),('15128','2013-07-01','15:40:00',4.08),('15128','2013-07-01','15:45:00',4.05),('15128','2013-07-01','15:50:00',4),('15128','2013-07-01','15:55:00',3.96),('15128','2013-07-01','16:00:00',3.9),('15128','2013-07-01','16:05:00',3.86),('15128','2013-07-01','16:10:00',3.83),('15128','2013-07-01','16:15:00',3.76),('15128','2013-07-01','16:20:00',3.71),('15128','2013-07-01','16:25:00',3.67),('15128','2013-07-01','16:30:00',3.64),('15128','2013-07-01','16:35:00',3.58),('15128','2013-07-01','16:40:00',3.52),('15128','2013-07-01','16:45:00',3.45),('15128','2013-07-01','16:50:00',3.4),('15128','2013-07-01','16:55:00',3.34),('15128','2013-07-01','17:00:00',3.26),('15128','2013-07-01','17:05:00',3.22),('15128','2013-07-01','17:10:00',3.16),('15128','2013-07-01','17:15:00',3.09),('15128','2013-07-01','17:20:00',3.04),('15128','2013-07-01','17:25:00',2.98),('15128','2013-07-01','17:30:00',2.91),('15128','2013-07-01','17:35:00',2.84),('15128','2013-07-01','17:40:00',2.77),('15128','2013-07-01','17:45:00',2.7),('15128','2013-07-01','17:50:00',2.62),('15128','2013-07-01','17:55:00',2.55),('15128','2013-07-01','18:00:00',2.41),('15128','2013-07-01','18:05:00',2.32),('15128','2013-07-01','18:10:00',2.23),('15128','2013-07-01','18:15:00',2.12),('15128','2013-07-01','18:20:00',2),('15128','2013-07-01','18:25:00',1.91),('15128','2013-07-01','18:30:00',1.84),('15128','2013-07-01','18:35:00',1.74),('15128','2013-07-01','18:40:00',1.67),('15128','2013-07-01','18:45:00',1.59),('15128','2013-07-01','18:50:00',1.51),('15128','2013-07-01','18:55:00',1.46),('15128','2013-07-01','19:00:00',1.37),('15128','2013-07-01','19:05:00',1.28),('15128','2013-07-01','19:10:00',1.2),('15128','2013-07-01','19:15:00',1.1),('15128','2013-06-30','08:05:00',1.07),('15128','2013-06-30','08:10:00',1.13),('15128','2013-06-30','08:15:00',1.17),('15128','2013-06-30','08:20:00',1.25),('15128','2013-06-30','08:25:00',1.34),('15128','2013-06-30','08:30:00',1.41),('15128','2013-06-30','08:35:00',1.45),('15128','2013-06-30','08:40:00',1.52),('15128','2013-06-30','08:45:00',1.58),('15128','2013-06-30','08:50:00',1.65),('15128','2013-06-30','08:55:00',1.75),('15128','2013-06-30','09:00:00',1.86),('15128','2013-06-30','09:05:00',1.93),('15128','2013-06-30','09:10:00',2.01),('15128','2013-06-30','09:15:00',2.08),('15128','2013-06-30','09:20:00',2.1),('15128','2013-06-30','09:25:00',2.12),('15128','2013-06-30','09:30:00',2.29),('15128','2013-06-30','09:35:00',2.36),('15128','2013-06-30','09:40:00',2.42),('15128','2013-06-30','09:45:00',2.46),('15128','2013-06-30','09:50:00',2.52),('15128','2013-06-30','09:55:00',2.57),('15128','2013-06-30','10:00:00',2.61),('15128','2013-06-30','10:05:00',2.66),('15128','2013-06-30','10:10:00',2.7),('15128','2013-06-30','10:15:00',2.75),('15128','2013-06-30','10:20:00',2.78),('15128','2013-06-30','10:25:00',2.81),('15128','2013-06-30','10:30:00',2.85),('15128','2013-06-30','10:35:00',2.94),('15128','2013-06-30','10:40:00',2.95),('15128','2013-06-30','10:45:00',3.02),('15128','2013-06-30','10:50:00',3.07),('15128','2013-06-30','10:55:00',3.16),('15128','2013-06-30','11:00:00',3.16),('15128','2013-06-30','11:05:00',3.23),('15128','2013-06-30','11:10:00',3.21),('15128','2013-06-30','11:15:00',3.37),('15128','2013-06-30','11:20:00',3.44),('15128','2013-06-30','11:25:00',3.56),('15128','2013-06-30','11:30:00',3.49),('15128','2013-06-30','11:35:00',3.48),('15128','2013-06-30','11:40:00',3.62),('15128','2013-06-30','11:45:00',3.79),('15128','2013-06-30','11:50:00',3.84),('15128','2013-06-30','11:55:00',3.93),('15128','2013-06-30','12:00:00',3.94),('15128','2013-06-30','12:05:00',3.94),('15128','2013-06-30','12:10:00',3.97),('15128','2013-06-30','12:15:00',4.02),('15128','2013-06-30','12:20:00',4.07),('15128','2013-06-30','12:25:00',4.12),('15128','2013-06-30','12:30:00',4.14),('15128','2013-06-30','12:35:00',4.16),('15128','2013-06-30','12:40:00',4.13),('15128','2013-06-30','12:45:00',4.23),('15128','2013-06-30','12:50:00',4.25),('15128','2013-06-30','12:55:00',4.15),('15128','2013-06-30','13:00:00',4.22),('15128','2013-06-30','13:05:00',4.28),('15128','2013-06-30','13:10:00',4.39),('15128','2013-06-30','13:15:00',4.51),('15128','2013-06-30','13:20:00',4.44),('15128','2013-06-30','13:25:00',4.38),('15128','2013-06-30','13:30:00',4.35),('15128','2013-06-30','13:35:00',4.37),('15128','2013-06-30','13:40:00',4.32),('15128','2013-06-30','13:45:00',4.39),('15128','2013-06-30','13:50:00',4.43),('15128','2013-06-30','13:55:00',4.5),('15128','2013-06-30','14:00:00',4.46),('15128','2013-06-30','14:05:00',4.39),('15128','2013-06-30','14:10:00',4.36),('15128','2013-06-30','14:15:00',4.37),('15128','2013-06-30','14:20:00',4.35),('15128','2013-06-30','14:25:00',4.31),('15128','2013-06-30','14:30:00',4.32),('15128','2013-06-30','14:35:00',4.32),('15128','2013-06-30','14:40:00',4.33),('15128','2013-06-30','14:45:00',4.31),('15128','2013-06-30','14:50:00',4.32),('15128','2013-06-30','14:55:00',4.32),('15128','2013-06-30','15:00:00',4.29),('15128','2013-06-30','15:05:00',4.26),('15128','2013-06-30','15:10:00',4.25),('15128','2013-06-30','15:15:00',4.2),('15128','2013-06-30','15:20:00',4.16),('15128','2013-06-30','15:25:00',4.1),('15128','2013-06-30','15:30:00',4.07),('15128','2013-06-30','15:35:00',4.02),('15128','2013-06-30','15:40:00',4.01),('15128','2013-06-30','15:45:00',3.99),('15128','2013-06-30','15:50:00',3.96),('15128','2013-06-30','15:55:00',3.91),('15128','2013-06-30','16:00:00',3.87),('15128','2013-06-30','16:05:00',3.76),('15128','2013-06-30','16:10:00',3.72),('15128','2013-06-30','16:15:00',3.72),('15128','2013-06-30','16:20:00',3.67),('15128','2013-06-30','16:25:00',3.65),('15128','2013-06-30','16:30:00',3.61),('15128','2013-06-30','16:35:00',3.53),('15128','2013-06-30','16:40:00',3.48),('15128','2013-06-30','16:45:00',3.45),('15128','2013-06-30','16:50:00',3.37),('15128','2013-06-30','16:55:00',3.32),('15128','2013-06-30','17:00:00',3.26),('15128','2013-06-30','17:05:00',3.21),('15128','2013-06-30','17:10:00',3.14),('15128','2013-06-30','17:15:00',3.07),('15128','2013-06-30','17:20:00',2.99),('15128','2013-06-30','17:25:00',2.93),('15128','2013-06-30','17:30:00',2.86),('15128','2013-06-30','17:35:00',2.81),('15128','2013-06-30','17:40:00',2.72),('15128','2013-06-30','17:45:00',2.65),('15128','2013-06-30','17:50:00',2.57),('15128','2013-06-30','17:55:00',2.49),('15128','2013-06-30','18:00:00',2.43),('15128','2013-06-30','18:05:00',2.23),('15128','2013-06-30','18:10:00',2.07),('15128','2013-06-30','18:15:00',2.1),('15128','2013-06-30','18:20:00',2.06),('15128','2013-06-30','18:25:00',1.97),('15128','2013-06-30','18:30:00',1.79),('15128','2013-06-30','18:35:00',1.53),('15128','2013-06-30','18:40:00',1.64),('15128','2013-06-30','18:45:00',1.49),('15128','2013-06-30','18:50:00',1.37),('15128','2013-06-30','18:55:00',1.32),('15128','2013-06-30','19:00:00',1.33),('15128','2013-06-30','19:05:00',1.16),('15128','2013-06-30','19:10:00',1.09),('15128','2013-06-30','19:15:00',1.04),('15128','2014-04-04','08:35:00',1.1),('15128','2014-04-04','08:45:00',1.08),('15128','2014-04-04','09:20:00',1.06),('15128','2014-04-04','09:25:00',1.25),('15128','2014-04-04','09:30:00',1.56),('15128','2014-04-04','09:35:00',1.58),('15128','2014-04-04','09:40:00',1.55),('15128','2014-04-04','09:45:00',2.03),('15128','2014-04-04','09:50:00',2.17),('15128','2014-04-04','09:55:00',1.84),('15128','2014-04-04','10:00:00',2.07),('15128','2014-04-04','10:05:00',1.85),('15128','2014-04-04','10:10:00',1.84),('15128','2014-04-04','10:15:00',1.57),('15128','2014-04-04','10:20:00',1.33),('15128','2014-04-04','10:25:00',1.59),('15128','2014-04-04','10:30:00',2.81),('15128','2014-04-04','10:35:00',1.91),('15128','2014-04-04','10:40:00',2.43),('15128','2014-04-04','10:45:00',3.06),('15128','2014-04-04','10:50:00',2.62),('15128','2014-04-04','10:55:00',2.95),('15128','2014-04-04','11:00:00',2.52),('15128','2014-04-04','11:05:00',2.69),('15128','2014-04-04','11:10:00',2.63),('15128','2014-04-04','11:15:00',2.46),('15128','2014-04-04','11:20:00',2.2),('15128','2014-04-04','11:25:00',2.67),('15128','2014-04-04','11:30:00',3.11),('15128','2014-04-04','11:35:00',3.43),('15128','2014-04-04','11:40:00',3.51),('15128','2014-04-04','11:45:00',3.22),('15128','2014-04-04','11:50:00',3.33),('15128','2014-04-04','11:55:00',2.97),('15128','2014-04-04','12:00:00',2.69),('15128','2014-04-04','12:05:00',2.58),('15128','2014-04-04','12:10:00',2.49),('15128','2014-04-04','12:15:00',2.2),('15128','2014-04-04','12:20:00',2.05),('15128','2014-04-04','12:25:00',1.85),('15128','2014-04-04','12:30:00',1.64),('15128','2014-04-04','12:35:00',1.95),('15128','2014-04-04','12:40:00',2.91),('15128','2014-04-04','12:45:00',2.97),('15128','2014-04-04','12:50:00',3.6),('15128','2014-04-04','12:55:00',2.77),('15128','2014-04-04','13:00:00',2.21),('15128','2014-04-04','13:05:00',2.6),('15128','2014-04-04','13:10:00',3.56),('15128','2014-04-04','13:15:00',3.48),('15128','2014-04-04','13:20:00',4),('15128','2014-04-04','13:25:00',3.39),('15128','2014-04-04','13:30:00',3.19),('15128','2014-04-04','13:35:00',2.74),('15128','2014-04-04','13:40:00',1.8),('15128','2014-04-04','13:45:00',2.77),('15128','2014-04-04','13:50:00',3.97),('15128','2014-04-04','13:55:00',4.54),('15128','2014-04-04','14:00:00',2.43),('15128','2014-04-04','14:05:00',1.3),('15128','2014-04-04','14:10:00',4.4),('15128','2014-04-04','14:15:00',2.02),('15128','2014-04-04','14:55:00',4.35),('15128','2014-04-04','15:00:00',4.39),('15128','2014-04-04','15:05:00',1.8),('15128','2014-04-04','15:10:00',3.58),('15128','2014-04-04','15:15:00',2.96),('15128','2014-04-04','15:20:00',2.16),('15128','2014-04-04','15:25:00',1.95),('15128','2014-04-04','15:30:00',1.89),('15128','2014-04-04','15:35:00',2.83),('15128','2014-04-04','15:40:00',2.7),('15128','2014-04-04','15:45:00',1.84),('15128','2014-04-04','15:50:00',1.07),('15128','2014-04-04','15:55:00',1.08),('15128','2014-04-04','16:00:00',1.26),('15128','2014-04-04','16:05:00',1.4),('15128','2014-04-04','16:10:00',1.97),('15128','2014-04-04','16:15:00',1.27),('15128','2014-04-04','16:20:00',1.02),('15128','2014-04-04','16:25:00',1.86),('15128','2014-04-04','16:30:00',3.76),('15128','2014-04-04','16:35:00',3.23),('15128','2014-04-04','16:50:00',3.11),('15128','2014-04-04','16:55:00',3.1),('15128','2014-04-04','17:00:00',3.04),('15128','2014-04-04','17:05:00',2.24),('15128','2014-04-04','17:10:00',2.31),('15128','2014-04-04','17:15:00',2.26),('15128','2014-04-04','17:20:00',2.4),('15128','2014-04-04','17:25:00',2.02),('15128','2014-04-04','17:30:00',1.03),('15128','2014-04-04','18:00:00',1.29),('15128','2014-04-04','18:05:00',1.1),('15128','2014-04-04','18:15:00',1.09),('15128','2013-06-29','08:00:00',1.04),('15128','2013-06-29','08:05:00',1.12),('15128','2013-06-29','08:10:00',1.18),('15128','2013-06-29','08:15:00',1.23),('15128','2013-06-29','08:20:00',1.3),('15128','2013-06-29','08:25:00',1.39),('15128','2013-06-29','08:30:00',1.46),('15128','2013-06-29','08:35:00',1.52),('15128','2013-06-29','08:40:00',1.59),('15128','2013-06-29','08:45:00',1.65),('15128','2013-06-29','08:50:00',1.73),('15128','2013-06-29','08:55:00',1.83),('15128','2013-06-29','09:00:00',1.9),('15128','2013-06-29','09:05:00',1.98),('15128','2013-06-29','09:10:00',2.07),('15128','2013-06-29','09:15:00',2.13),('15128','2013-06-29','09:20:00',2.17),('15128','2013-06-29','09:25:00',2.24),('15128','2013-06-29','09:30:00',2.32),('15128','2013-06-29','09:35:00',2.39),('15128','2013-06-29','09:40:00',2.45),('15128','2013-06-29','09:45:00',2.5),('15128','2013-06-29','09:50:00',2.56),('15128','2013-06-29','09:55:00',2.62),('15128','2013-06-29','10:00:00',2.67),('15128','2013-06-29','10:05:00',2.73),('15128','2013-06-29','10:10:00',2.76),('15128','2013-06-29','10:15:00',2.78),('15128','2013-06-29','10:20:00',2.84),('15128','2013-06-29','10:25:00',2.89),('15128','2013-06-29','10:30:00',2.96),('15128','2013-06-29','10:35:00',3.04),('15128','2013-06-29','10:40:00',3.05),('15128','2013-06-29','10:45:00',3.13),('15128','2013-06-29','10:50:00',3.17),('15128','2013-06-29','10:55:00',3.24),('15128','2013-06-29','11:00:00',3.24),('15128','2013-06-29','11:05:00',3.29),('15128','2013-06-29','11:10:00',3.29),('15128','2013-06-29','11:15:00',3.47),('15128','2013-06-29','11:20:00',3.51),('15128','2013-06-29','11:25:00',3.57),('15128','2013-06-29','11:30:00',3.5),('15128','2013-06-29','11:35:00',3.49),('15128','2013-06-29','11:40:00',3.65),('15128','2013-06-29','11:45:00',3.86),('15128','2013-06-29','11:50:00',3.95),('15128','2013-06-29','11:55:00',4.02),('15128','2013-06-29','12:00:00',3.65),('15128','2013-06-29','12:05:00',4.1),('15128','2013-06-29','12:10:00',4.09),('15128','2013-06-29','12:15:00',4.13),('15128','2013-06-29','12:20:00',4.14),('15128','2013-06-29','12:25:00',4.22),('15128','2013-06-29','12:30:00',4.24),('15128','2013-06-29','12:35:00',4.29),('15128','2013-06-29','12:40:00',4.31),('15128','2013-06-29','12:45:00',4.37),('15128','2013-06-29','12:50:00',4.45),('15128','2013-06-29','12:55:00',4.55),('15128','2013-06-29','13:00:00',4.26),('15128','2013-06-29','13:05:00',3.33),('15128','2013-06-29','13:10:00',2.99),('15128','2013-06-29','13:15:00',2.25),('15128','2013-06-29','13:20:00',4.63),('15128','2013-06-29','13:25:00',2.53),('15128','2013-06-29','13:30:00',1.19),('15128','2013-06-29','13:35:00',3.75),('15128','2013-06-29','13:40:00',3.87),('15128','2013-06-29','13:45:00',3.91),('15128','2013-06-29','13:50:00',3.01),('15128','2013-06-29','13:55:00',4.18),('15128','2013-06-29','14:00:00',4.73),('15128','2013-06-29','14:05:00',4.73),('15128','2013-06-29','14:10:00',4.62),('15128','2013-06-29','14:15:00',4.5),('15128','2013-06-29','14:20:00',4.49),('15128','2013-06-29','14:25:00',4.49),('15128','2013-06-29','14:30:00',4.43),('15128','2013-06-29','14:35:00',4.43),('15128','2013-06-29','14:40:00',4.42),('15128','2013-06-29','14:45:00',4.4),('15128','2013-06-29','14:50:00',4.4),('15128','2013-06-29','14:55:00',4.35),('15128','2013-06-29','15:00:00',4.33),('15128','2013-06-29','15:05:00',4.31),('15128','2013-06-29','15:10:00',4.31),('15128','2013-06-29','15:15:00',4.3),('15128','2013-06-29','15:20:00',4.26),('15128','2013-06-29','15:25:00',4.28),('15128','2013-06-29','15:30:00',4.22),('15128','2013-06-29','15:35:00',3.41),('15128','2013-06-29','15:40:00',2.9),('15128','2013-06-29','15:45:00',3.96),('15128','2013-06-29','15:50:00',4.16),('15128','2013-06-29','15:55:00',4.16),('15128','2013-06-29','16:00:00',4.09),('15128','2013-06-29','16:05:00',4.08),('15128','2013-06-29','16:10:00',4.11),('15128','2013-06-29','16:15:00',3.69),('15128','2013-06-29','16:20:00',3.91),('15128','2013-06-29','16:25:00',3.81),('15128','2013-06-29','16:30:00',3.6),('15128','2013-06-29','16:35:00',3.49),('15128','2013-06-29','16:40:00',3.61),('15128','2013-06-29','16:45:00',3.54),('15128','2013-06-29','16:50:00',3.52),('15128','2013-06-29','16:55:00',3.39),('15128','2013-06-29','17:00:00',3.31),('15128','2013-06-29','17:05:00',3.22),('15128','2013-06-29','17:10:00',3.18),('15128','2013-06-29','17:15:00',3.04),('15128','2013-06-29','17:20:00',3.01),('15128','2013-06-29','17:25:00',2.94),('15128','2013-06-29','17:30:00',2.87),('15128','2013-06-29','17:35:00',2.82),('15128','2013-06-29','17:40:00',2.7),('15128','2013-06-29','17:45:00',2.75),('15128','2013-06-29','17:50:00',2.69),('15128','2013-06-29','17:55:00',2.5),('15128','2013-06-29','18:00:00',2.39),('15128','2013-06-29','18:05:00',2.29),('15128','2013-06-29','18:10:00',2.19),('15128','2013-06-29','18:15:00',2.1),('15128','2013-06-29','18:20:00',1.98),('15128','2013-06-29','18:25:00',1.87),('15128','2013-06-29','18:30:00',1.77),('15128','2013-06-29','18:35:00',1.73),('15128','2013-06-29','18:40:00',1.62),('15128','2013-06-29','18:45:00',1.56),('15128','2013-06-29','18:50:00',1.52),('15128','2013-06-29','18:55:00',1.46),('15128','2013-06-29','19:00:00',1.38),('15128','2013-06-29','19:05:00',1.31),('15128','2013-06-29','19:10:00',1.22),('15128','2013-06-29','19:15:00',1.11),('15128','2013-06-28','08:20:00',1.3),('15128','2013-06-28','08:25:00',1.36),('15128','2013-06-28','08:30:00',1.42),('15128','2013-06-28','08:35:00',1.46),('15128','2013-06-28','08:40:00',1.53),('15128','2013-06-28','08:45:00',1.62),('15128','2013-06-28','08:50:00',1.67),('15128','2013-06-28','08:55:00',1.81),('15128','2013-06-28','09:00:00',1.88),('15128','2013-06-28','09:05:00',1.96),('15128','2013-06-28','09:10:00',2.03),('15128','2013-06-28','09:15:00',2.09),('15128','2013-06-28','09:20:00',2.15),('15128','2013-06-28','09:25:00',2.23),('15128','2013-06-28','09:30:00',2.3),('15128','2013-06-28','09:35:00',2.37),('15128','2013-06-28','09:40:00',2.43),('15128','2013-06-28','09:45:00',2.51),('15128','2013-06-28','09:50:00',2.56),('15128','2013-06-28','09:55:00',2.6),('15128','2013-06-28','10:00:00',2.66),('15128','2013-06-28','10:05:00',2.71),('15128','2013-06-28','10:10:00',2.78),('15128','2013-06-28','10:15:00',2.79),('15128','2013-06-28','10:20:00',2.86),('15128','2013-06-28','10:25:00',2.93),('15128','2013-06-28','10:30:00',3),('15128','2013-06-28','10:35:00',3.06),('15128','2013-06-28','10:40:00',3.11),('15128','2013-06-28','10:45:00',3.18),('15128','2013-06-28','10:50:00',3.22),('15128','2013-06-28','10:55:00',3.36),('15128','2013-06-28','11:00:00',3.49),('15128','2013-06-28','11:05:00',3.55),('15128','2013-06-28','11:10:00',3.52),('15128','2013-06-28','11:15:00',3.81),('15128','2013-06-28','11:20:00',2.53),('15128','2013-06-28','11:25:00',1.58),('15128','2013-06-28','11:30:00',4.02),('15128','2013-06-28','11:35:00',3.96),('15128','2013-06-28','11:40:00',4.05),('15128','2013-06-28','11:45:00',4.13),('15128','2013-06-28','11:50:00',2.14),('15128','2013-06-28','11:55:00',4.23),('15128','2013-06-28','12:00:00',4.22),('15128','2013-06-28','12:05:00',4.23),('15128','2013-06-28','12:10:00',4.33),('15128','2013-06-28','12:15:00',4.42),('15128','2013-06-28','12:20:00',4.49),('15128','2013-06-28','12:25:00',3.38),('15128','2013-06-28','12:30:00',1.57),('15128','2013-06-28','12:35:00',3.24),('15128','2013-06-28','12:40:00',3.91),('15128','2013-06-28','12:45:00',2.78),('15128','2013-06-28','12:50:00',4.14),('15128','2013-06-28','12:55:00',1.55),('15128','2013-06-28','13:00:00',2.28),('15128','2013-06-28','13:05:00',3.92),('15128','2013-06-28','13:10:00',1.44),('15128','2013-06-28','13:15:00',1.64),('15128','2013-06-28','13:20:00',3.55),('15128','2013-06-28','13:25:00',2.84),('15128','2013-06-28','13:30:00',2.25),('15128','2013-06-28','13:35:00',4.97),('15128','2013-06-28','13:40:00',3.47),('15128','2013-06-28','13:45:00',4.93),('15128','2013-06-28','13:50:00',4.83),('15128','2013-06-28','13:55:00',4.8),('15128','2013-06-28','14:00:00',4.72),('15128','2013-06-28','14:05:00',4.72),('15128','2013-06-28','14:10:00',4.84),('15128','2013-06-28','14:15:00',3.05),('15128','2013-06-28','14:20:00',3.93),('15128','2013-06-28','14:25:00',4.81),('15128','2013-06-28','14:30:00',4.82),('15128','2013-06-28','14:35:00',4.83),('15128','2013-06-28','14:40:00',4.82),('15128','2013-06-28','14:45:00',4.72),('15128','2013-06-28','14:50:00',4.79),('15128','2013-06-28','14:55:00',4.89),('15128','2013-06-28','15:00:00',5.02),('15128','2013-06-28','15:05:00',4.86),('15128','2013-06-28','15:10:00',3.64),('15128','2013-06-28','15:15:00',2.86),('15128','2013-06-28','15:20:00',2.09),('15128','2013-06-28','15:25:00',1.54),('15128','2013-06-28','15:30:00',1.39),('15128','2013-06-28','15:35:00',1.01),('15128','2013-06-28','16:15:00',1.01),('15128','2013-06-28','16:20:00',1.33),('15128','2013-06-28','16:25:00',2.39),('15128','2013-06-28','16:30:00',3.53),('15128','2013-06-28','16:35:00',4.91),('15128','2013-06-28','16:40:00',4.81),('15128','2013-06-28','16:45:00',3.19),('15128','2013-06-28','16:50:00',2.21),('15128','2013-06-28','16:55:00',1.84),('15128','2013-06-28','17:00:00',2.65),('15128','2013-06-28','17:05:00',2.12),('15128','2013-06-28','17:10:00',1.8),('15128','2013-06-28','17:15:00',1.66),('15128','2013-06-28','17:20:00',1.78),('15128','2013-06-28','17:25:00',3.21),('15128','2013-06-28','17:30:00',3.19),('15128','2013-06-28','17:35:00',3.15),('15128','2013-06-28','17:40:00',2.92),('15128','2013-06-28','17:45:00',2.71),('15128','2013-06-28','18:05:00',1.06),('15128','2013-06-28','18:10:00',1.12),('15128','2013-06-28','18:15:00',2.16),('15128','2013-06-28','18:20:00',1.24),('15128','2013-06-28','18:25:00',1.49),('15128','2013-06-28','18:35:00',1.43),('15128','2013-06-28','18:40:00',1.18),('15128','2013-06-28','18:50:00',1.55),('15128','2013-06-28','18:55:00',1.66),('15128','2013-06-28','19:00:00',1.41),('15128','2013-06-28','19:05:00',1.35),('15128','2013-06-28','19:10:00',1.09),('15128','2013-06-27','07:55:00',1),('15128','2013-06-27','08:05:00',1.04),('15128','2013-06-27','08:10:00',1),('15128','2013-06-27','08:15:00',1.1),('15128','2013-06-27','08:20:00',1.2),('15128','2013-06-27','08:25:00',1.38),('15128','2013-06-27','08:30:00',1.45),('15128','2013-06-27','08:35:00',1.48),('15128','2013-06-27','08:40:00',1.55),('15128','2013-06-27','08:45:00',1.6),('15128','2013-06-27','08:50:00',1.69),('15128','2013-06-27','08:55:00',1.83),('15128','2013-06-27','09:00:00',1.38),('15128','2013-06-27','09:05:00',2.09),('15128','2013-06-27','09:10:00',2.22),('15128','2013-06-27','09:15:00',2.21),('15128','2013-06-27','09:20:00',2.25),('15128','2013-06-27','09:25:00',1.4),('15128','2013-06-27','09:35:00',2.67),('15128','2013-06-27','09:40:00',2.65),('15128','2013-06-27','09:45:00',2.93),('15128','2013-06-27','09:50:00',2.47),('15128','2013-06-27','09:55:00',1.15),('15128','2013-06-27','10:10:00',1.59),('15128','2013-06-27','10:15:00',2.15),('15128','2013-06-27','10:20:00',1.66),('15128','2013-06-27','10:30:00',2.63),('15128','2013-06-27','10:35:00',3.72),('15128','2013-06-27','10:40:00',3.71),('15128','2013-06-27','10:45:00',2.54),('15128','2013-06-27','10:50:00',2.54),('15128','2013-06-27','10:55:00',3.2),('15128','2013-06-27','11:00:00',3.26),('15128','2013-06-27','11:05:00',3.9),('15128','2013-06-27','11:10:00',3.87),('15128','2013-06-27','11:15:00',3.64),('15128','2013-06-27','11:20:00',3.69),('15128','2013-06-27','11:25:00',3.4),('15128','2013-06-27','11:30:00',3.96),('15128','2013-06-27','11:35:00',3.66),('15128','2013-06-27','11:40:00',4.44),('15128','2013-06-27','11:45:00',4.13),('15128','2013-06-27','11:50:00',3.44),('15128','2013-06-27','11:55:00',3.6),('15128','2013-06-27','12:00:00',1.44),('15128','2013-06-27','12:05:00',3.9),('15128','2013-06-27','12:10:00',3.92),('15128','2013-06-27','12:15:00',4.38),('15128','2013-06-27','12:20:00',4.08),('15128','2013-06-27','12:25:00',4.25),('15128','2013-06-27','12:30:00',4.12),('15128','2013-06-27','12:35:00',4.41),('15128','2013-06-27','12:40:00',3.08),('15128','2013-06-27','12:45:00',3.21),('15128','2013-06-27','12:50:00',2.86),('15128','2013-06-27','12:55:00',4.75),('15128','2013-06-27','13:00:00',4.73),('15128','2013-06-27','13:05:00',4.69),('15128','2013-06-27','13:10:00',4.74),('15128','2013-06-27','13:15:00',4.61),('15128','2013-06-27','13:20:00',4.47),('15128','2013-06-27','13:25:00',4.73),('15128','2013-06-27','13:30:00',4.77),('15128','2013-06-27','13:35:00',3.96),('15128','2013-06-27','13:40:00',3.41),('15128','2013-06-27','13:45:00',3.82),('15128','2013-06-27','13:50:00',4.52),('15128','2013-06-27','13:55:00',3.61),('15128','2013-06-27','14:00:00',4.35),('15128','2013-06-27','14:05:00',4.91),('15128','2013-06-27','14:10:00',4.63),('15128','2013-06-27','14:15:00',3.1),('15128','2013-06-27','14:20:00',4.93),('15128','2013-06-27','14:25:00',4.89),('15128','2013-06-27','14:30:00',4.35),('15128','2013-06-27','14:35:00',3.14),('15128','2013-06-27','14:40:00',4.85),('15128','2013-06-27','14:45:00',4.65),('15128','2013-06-27','14:50:00',4.76),('15128','2013-06-27','14:55:00',4.33),('15128','2013-06-27','15:00:00',4.83),('15128','2013-06-27','15:05:00',3.47),('15128','2013-06-27','15:10:00',4.05),('15128','2013-06-27','15:15:00',2.95),('15128','2013-06-27','15:20:00',2.66),('15128','2013-06-27','15:25:00',2.55),('15128','2013-06-27','15:30:00',2.91),('15128','2013-06-27','15:35:00',4.4),('15128','2013-06-27','15:40:00',3.53),('15128','2013-06-27','15:45:00',4.72),('15128','2013-06-27','15:50:00',3.52),('15128','2013-06-27','15:55:00',4.06),('15128','2013-06-27','16:00:00',1.17),('15128','2013-06-27','16:05:00',2.24),('15128','2013-06-27','16:10:00',2.24),('15128','2013-06-27','16:15:00',2.36),('15128','2013-06-27','16:20:00',2.57),('15128','2013-06-27','16:25:00',2.63),('15128','2013-06-27','16:30:00',3.36),('15128','2013-06-27','16:35:00',3.87),('15128','2013-06-27','16:40:00',2.43),('15128','2013-06-27','16:45:00',2.12),('15128','2013-06-27','16:50:00',1.69),('15128','2013-06-27','16:55:00',1.31),('15128','2013-06-27','17:00:00',2.49),('15128','2013-06-27','17:05:00',3.42),('15128','2013-06-27','17:10:00',2.87),('15128','2013-06-27','17:15:00',2.96),('15128','2013-06-27','17:20:00',3.13),('15128','2013-06-27','17:25:00',3.11),('15128','2013-06-27','17:30:00',3),('15128','2013-06-27','17:35:00',2.92),('15128','2013-06-27','17:40:00',2.86),('15128','2013-06-27','17:45:00',2.78),('15128','2013-06-27','17:50:00',2.7),('15128','2013-06-27','17:55:00',2.64),('15128','2013-06-27','18:00:00',2.52),('15128','2013-06-27','18:05:00',2.44),('15128','2013-06-27','18:10:00',2.33),('15128','2013-06-27','18:15:00',2.22),('15128','2013-06-27','18:20:00',2.03),('15128','2013-06-27','18:25:00',1.99),('15128','2013-06-27','18:30:00',1.68),('15128','2013-06-27','18:35:00',1.84),('15128','2013-06-27','18:40:00',1.74),('15128','2013-06-27','18:45:00',1.68),('15128','2013-06-27','18:50:00',1.6),('15128','2013-06-27','18:55:00',1.52),('15128','2013-06-27','19:00:00',1.41),('15128','2013-06-27','19:05:00',1.24),('15128','2013-06-27','19:20:00',1.01),('15128','2013-06-26','08:10:00',1.14),('15128','2013-06-26','08:15:00',1.23),('15128','2013-06-26','08:20:00',1.31),('15128','2013-06-26','08:25:00',1.4),('15128','2013-06-26','08:30:00',1.44),('15128','2013-06-26','08:35:00',1.49),('15128','2013-06-26','08:40:00',1.57),('15128','2013-06-26','08:45:00',1.63),('15128','2013-06-26','08:50:00',1.72),('15128','2013-06-26','08:55:00',1.87),('15128','2013-06-26','09:00:00',1.94),('15128','2013-06-26','09:05:00',2.01),('15128','2013-06-26','09:10:00',2.11),('15128','2013-06-26','09:15:00',2.16),('15128','2013-06-26','09:20:00',2.17),('15128','2013-06-26','09:25:00',2.3),('15128','2013-06-26','09:30:00',2.39),('15128','2013-06-26','09:35:00',2.44),('15128','2013-06-26','09:40:00',2.51),('15128','2013-06-26','09:45:00',2.61),('15128','2013-06-26','09:50:00',2.64),('15128','2013-06-26','09:55:00',2.69),('15128','2013-06-26','10:00:00',2.72),('15128','2013-06-26','10:05:00',2.73),('15128','2013-06-26','10:10:00',2.81),('15128','2013-06-26','10:15:00',2.82),('15128','2013-06-26','10:20:00',2.91),('15128','2013-06-26','10:25:00',2.99),('15128','2013-06-26','10:30:00',3.11),('15128','2013-06-26','10:35:00',3.2),('15128','2013-06-26','10:40:00',2.17),('15128','2013-06-26','10:45:00',3.06),('15128','2013-06-26','10:50:00',3.47),('15128','2013-06-26','10:55:00',3.49),('15128','2013-06-26','11:00:00',3.43),('15128','2013-06-26','11:05:00',3.75),('15128','2013-06-26','11:10:00',3.23),('15128','2013-06-26','11:15:00',2.8),('15128','2013-06-26','11:20:00',3.98),('15128','2013-06-26','11:25:00',4),('15128','2013-06-26','11:30:00',3.96),('15128','2013-06-26','11:35:00',3.96),('15128','2013-06-26','11:40:00',4.1),('15128','2013-06-26','11:45:00',3.7),('15128','2013-06-26','11:50:00',3.77),('15128','2013-06-26','11:55:00',2.61),('15128','2013-06-26','12:00:00',1.28),('15128','2013-06-26','12:05:00',1.1),('15128','2013-06-26','12:10:00',1.07),('15128','2013-06-26','12:15:00',1.12),('15128','2013-06-26','12:20:00',1.03),('15128','2013-06-26','12:25:00',1.04),('15128','2013-06-26','12:30:00',1.19),('15128','2013-06-26','12:35:00',1.3),('15128','2013-06-26','12:40:00',1.41),('15128','2013-06-26','12:45:00',2.17),('15128','2013-06-26','12:50:00',2.78),('15128','2013-06-26','12:55:00',2.27),('15128','2013-06-26','13:00:00',2.82),('15128','2013-06-26','13:05:00',3.44),('15128','2013-06-26','13:10:00',4.89),('15128','2013-06-26','13:15:00',4.82),('15128','2013-06-26','13:20:00',2.23),('15128','2013-06-26','13:25:00',3.44),('15128','2013-06-26','13:30:00',2.03),('15128','2013-06-26','13:35:00',1.76),('15128','2013-06-26','13:40:00',2.04),('15128','2013-06-26','13:45:00',4.55),('15128','2013-06-26','13:50:00',4.24),('15128','2013-06-26','13:55:00',4.77),('15128','2013-06-26','14:00:00',4.53),('15128','2013-06-26','14:05:00',4.49),('15128','2013-06-26','14:10:00',4.46),('15128','2013-06-26','14:15:00',4.44),('15128','2013-06-26','14:20:00',4.48),('15128','2013-06-26','14:25:00',4.54),('15128','2013-06-26','14:30:00',4.77),('15128','2013-06-26','14:35:00',4.63),('15128','2013-06-26','14:40:00',4.46),('15128','2013-06-26','14:45:00',4.34),('15128','2013-06-26','14:50:00',4.33),('15128','2013-06-26','14:55:00',4.28),('15128','2013-06-26','15:00:00',4.28),('15128','2013-06-26','15:05:00',4.3),('15128','2013-06-26','15:10:00',4.27),('15128','2013-06-26','15:15:00',4.27),('15128','2013-06-26','15:20:00',4.28),('15128','2013-06-26','15:25:00',4.27),('15128','2013-06-26','15:30:00',4.22),('15128','2013-06-26','15:35:00',4.17),('15128','2013-06-26','15:40:00',4.08),('15128','2013-06-26','15:45:00',4.06),('15128','2013-06-26','15:50:00',3.98),('15128','2013-06-26','15:55:00',3.91),('15128','2013-06-26','16:00:00',3.89),('15128','2013-06-26','16:05:00',3.85),('15128','2013-06-26','16:10:00',3.87),('15128','2013-06-26','16:15:00',3.83),('15128','2013-06-26','16:20:00',3.79),('15128','2013-06-26','16:25:00',3.73),('15128','2013-06-26','16:30:00',3.66),('15128','2013-06-26','16:35:00',3.54),('15128','2013-06-26','16:40:00',3.51),('15128','2013-06-26','16:45:00',3.44),('15128','2013-06-26','16:50:00',3.38),('15128','2013-06-26','16:55:00',3.36),('15128','2013-06-26','17:00:00',3.24),('15128','2013-06-26','17:05:00',3.17),('15128','2013-06-26','17:10:00',3),('15128','2013-06-26','17:15:00',3.1),('15128','2013-06-26','17:20:00',3.06),('15128','2013-06-26','17:25:00',3.09),('15128','2013-06-26','17:30:00',3.07),('15128','2013-06-26','17:35:00',2.81),('15128','2013-06-26','17:40:00',2.65),('15128','2013-06-26','17:45:00',2.75),('15128','2013-06-26','17:50:00',2.68),('15128','2013-06-26','17:55:00',2.62),('15128','2013-06-26','18:00:00',2.48),('15128','2013-06-26','18:05:00',2.39),('15128','2013-06-26','18:10:00',2.27),('15128','2013-06-26','18:15:00',2.03),('15128','2013-06-26','18:20:00',1.91),('15128','2013-06-26','18:25:00',1.73),('15128','2013-06-26','18:30:00',1.67),('15128','2013-06-26','18:35:00',1.59),('15128','2013-06-26','18:40:00',1.55),('15128','2013-06-26','18:45:00',1.5),('15128','2013-06-26','18:50:00',1.5),('15128','2013-06-26','18:55:00',1.44),('15128','2013-06-26','19:00:00',1.33),('15128','2013-06-26','19:05:00',1.22),('15128','2013-06-26','19:10:00',1.12),('15128','2013-06-26','19:15:00',1),('15128','2013-06-25','08:00:00',1.05),('15128','2013-06-25','08:05:00',1.11),('15128','2013-06-25','08:10:00',1.16),('15128','2013-06-25','08:15:00',1.23),('15128','2013-06-25','08:20:00',1.31),('15128','2013-06-25','08:25:00',1.4),('15128','2013-06-25','08:30:00',1.46),('15128','2013-06-25','08:35:00',1.53),('15128','2013-06-25','08:40:00',1.61),('15128','2013-06-25','08:45:00',1.67),('15128','2013-06-25','08:50:00',1.76),('15128','2013-06-25','08:55:00',1.89),('15128','2013-06-25','09:00:00',1.97),('15128','2013-06-25','09:05:00',2.03),('15128','2013-06-25','09:10:00',2.1),('15128','2013-06-25','09:15:00',2.16),('15128','2013-06-25','09:20:00',2.19),('15128','2013-06-25','09:25:00',2.3),('15128','2013-06-25','09:30:00',2.36),('15128','2013-06-25','09:35:00',2.41),('15128','2013-06-25','09:40:00',2.48),('15128','2013-06-25','09:45:00',2.54),('15128','2013-06-25','09:50:00',2.59),('15128','2013-06-25','09:55:00',2.64),('15128','2013-06-25','10:00:00',2.68),('15128','2013-06-25','10:05:00',2.74),('15128','2013-06-25','10:10:00',2.82),('15128','2013-06-25','10:15:00',2.82),('15128','2013-06-25','10:20:00',2.87),('15128','2013-06-25','10:25:00',2.96),('15128','2013-06-25','10:30:00',2.99),('15128','2013-06-25','10:35:00',3.04),('15128','2013-06-25','10:40:00',3.07),('15128','2013-06-25','10:45:00',3.14),('15128','2013-06-25','10:50:00',3.21),('15128','2013-06-25','10:55:00',3.25),('15128','2013-06-25','11:00:00',3.3),('15128','2013-06-25','11:05:00',3.34),('15128','2013-06-25','11:10:00',3.35),('15128','2013-06-25','11:15:00',3.48),('15128','2013-06-25','11:20:00',3.53),('15128','2013-06-25','11:25:00',3.62),('15128','2013-06-25','11:30:00',3.52),('15128','2013-06-25','11:35:00',3.57),('15128','2013-06-25','11:40:00',3.78),('15128','2013-06-25','11:45:00',3.83),('15128','2013-06-25','11:50:00',3.93),('15128','2013-06-25','11:55:00',3.98),('15128','2013-06-25','12:00:00',4.01),('15128','2013-06-25','12:05:00',4.04),('15128','2013-06-25','12:10:00',4.11),('15128','2013-06-25','12:15:00',4.16),('15128','2013-06-25','12:20:00',4.21),('15128','2013-06-25','12:25:00',4.26),('15128','2013-06-25','12:30:00',4.3),('15128','2013-06-25','12:35:00',3.69),('15128','2013-06-25','12:40:00',3.26),('15128','2013-06-25','12:45:00',1.12),('15128','2013-06-25','12:50:00',2.03),('15128','2013-06-25','12:55:00',5.06),('15128','2013-06-25','13:00:00',3.76),('15128','2013-06-25','13:05:00',3.03),('15128','2013-06-25','13:10:00',4.89),('15128','2013-06-25','13:15:00',4.8),('15128','2013-06-25','13:20:00',4.76),('15128','2013-06-25','13:25:00',4.76),('15128','2013-06-25','13:30:00',2.21),('15128','2013-06-25','13:35:00',1.71),('15128','2013-06-25','13:40:00',1.07),('15128','2013-06-25','13:45:00',2.81),('15128','2013-06-25','13:50:00',4.77),('15128','2013-06-25','13:55:00',4.64),('15128','2013-06-25','14:00:00',4.49),('15128','2013-06-25','14:05:00',4.48),('15128','2013-06-25','14:10:00',4.47),('15128','2013-06-25','14:15:00',4.45),('15128','2013-06-25','14:20:00',4.43),('15128','2013-06-25','14:25:00',4.44),('15128','2013-06-25','14:30:00',4.43),('15128','2013-06-25','14:35:00',4.42),('15128','2013-06-25','14:40:00',4.46),('15128','2013-06-25','14:45:00',4.46),('15128','2013-06-25','14:50:00',4.42),('15128','2013-06-25','14:55:00',4.39),('15128','2013-06-25','15:00:00',4.37),('15128','2013-06-25','15:05:00',4.34),('15128','2013-06-25','15:10:00',4.32),('15128','2013-06-25','15:15:00',4.28),('15128','2013-06-25','15:20:00',4.25),('15128','2013-06-25','15:25:00',4.24),('15128','2013-06-25','15:30:00',4.21),('15128','2013-06-25','15:35:00',4.17),('15128','2013-06-25','15:40:00',4.16),('15128','2013-06-25','15:45:00',4.1),('15128','2013-06-25','15:50:00',4.08),('15128','2013-06-25','15:55:00',4.03),('15128','2013-06-25','16:00:00',3.99),('15128','2013-06-25','16:05:00',3.94),('15128','2013-06-25','16:10:00',3.91),('15128','2013-06-25','16:15:00',3.87),('15128','2013-06-25','16:20:00',3.85),('15128','2013-06-25','16:25:00',3.78),('15128','2013-06-25','16:30:00',3.7),('15128','2013-06-25','16:35:00',3.67),('15128','2013-06-25','16:40:00',3.6),('15128','2013-06-25','16:45:00',3.54),('15128','2013-06-25','16:50:00',3.49),('15128','2013-06-25','16:55:00',3.43),('15128','2013-06-25','17:00:00',3.36),('15128','2013-06-25','17:05:00',3.3),('15128','2013-06-25','17:10:00',3.23),('15128','2013-06-25','17:15:00',3.16),('15128','2013-06-25','17:20:00',3.08),('15128','2013-06-25','17:25:00',3.04),('15128','2013-06-25','17:30:00',3),('15128','2013-06-25','17:35:00',2.9),('15128','2013-06-25','17:40:00',2.83),('15128','2013-06-25','17:45:00',2.75),('15128','2013-06-25','17:50:00',2.63),('15128','2013-06-25','17:55:00',2.53),('15128','2013-06-25','18:00:00',2.35),('15128','2013-06-25','18:05:00',2.31),('15128','2013-06-25','18:10:00',2.21),('15128','2013-06-25','18:15:00',1.76),('15128','2013-06-25','18:20:00',1.24),('15128','2013-06-25','18:25:00',1.3),('15128','2013-06-25','18:30:00',1.21),('15128','2013-06-25','18:35:00',1.57),('15128','2013-06-25','19:05:00',1.1),('15128','2013-06-25','19:10:00',1.13),('15128','2013-06-25','19:15:00',1),('15128','2013-06-24','08:05:00',1.09),('15128','2013-06-24','08:10:00',1.19),('15128','2013-06-24','08:15:00',1.25),('15128','2013-06-24','08:20:00',1.34),('15128','2013-06-24','08:25:00',1.43),('15128','2013-06-24','08:30:00',1.51),('15128','2013-06-24','08:35:00',1.55),('15128','2013-06-24','08:40:00',1.59),('15128','2013-06-24','08:45:00',1.68),('15128','2013-06-24','08:50:00',1.74),('15128','2013-06-24','08:55:00',1.07),('15128','2013-06-24','09:00:00',1.19),('15128','2013-06-24','09:05:00',2.1),('15128','2013-06-24','09:10:00',2.11),('15128','2013-06-24','09:15:00',2.15),('15128','2013-06-24','09:20:00',2.2),('15128','2013-06-24','09:25:00',2.35),('15128','2013-06-24','09:30:00',2.4),('15128','2013-06-24','09:35:00',2.53),('15128','2013-06-24','09:40:00',2.63),('15128','2013-06-24','09:45:00',2.65),('15128','2013-06-24','09:50:00',2.74),('15128','2013-06-24','09:55:00',2.86),('15128','2013-06-24','10:00:00',2.96),('15128','2013-06-24','10:05:00',2.48),('15128','2013-06-24','10:10:00',1.29),('15128','2013-06-24','10:30:00',1.65),('15128','2013-06-24','10:35:00',3.44),('15128','2013-06-24','10:40:00',3.32),('15128','2013-06-24','10:45:00',3.37),('15128','2013-06-24','10:50:00',3.43),('15128','2013-06-24','10:55:00',3.42),('15128','2013-06-24','11:00:00',3.48),('15128','2013-06-24','11:05:00',3.54),('15128','2013-06-24','11:10:00',3.64),('15128','2013-06-24','11:15:00',3.82),('15128','2013-06-24','11:20:00',3.93),('15128','2013-06-24','11:25:00',3.63),('15128','2013-06-24','11:30:00',2.18),('15128','2013-06-24','11:35:00',1.61),('15128','2013-06-24','11:40:00',1.51),('15128','2013-06-24','11:45:00',2.2),('15128','2013-06-24','11:50:00',1.37),('15128','2013-06-24','11:55:00',1.32),('15128','2013-06-24','12:00:00',1.42),('15128','2013-06-24','12:05:00',1.4),('15128','2013-06-24','12:10:00',3.99),('15128','2013-06-24','12:15:00',5.05),('15128','2013-06-24','12:20:00',4.77),('15128','2013-06-24','12:25:00',4.54),('15128','2013-06-24','12:30:00',4.43),('15128','2013-06-24','12:35:00',4.47),('15128','2013-06-24','12:40:00',4.65),('15128','2013-06-24','12:45:00',4.69),('15128','2013-06-24','12:50:00',4.8),('15128','2013-06-24','12:55:00',2.79),('15128','2013-06-24','13:00:00',4.67),('15128','2013-06-24','13:05:00',4.65),('15128','2013-06-24','13:10:00',4.53),('15128','2013-06-24','13:15:00',4.54),('15128','2013-06-24','13:20:00',4.55),('15128','2013-06-24','13:25:00',4.53),('15128','2013-06-24','13:30:00',4.52),('15128','2013-06-24','13:35:00',4.53),('15128','2013-06-24','13:40:00',4.55),('15128','2013-06-24','13:45:00',4.54),('15128','2013-06-24','13:50:00',4.56),('15128','2013-06-24','13:55:00',4.53),('15128','2013-06-24','14:00:00',4.49),('15128','2013-06-24','14:05:00',4.49),('15128','2013-06-24','14:10:00',4.5),('15128','2013-06-24','14:15:00',4.53),('15128','2013-06-24','14:20:00',4.54),('15128','2013-06-24','14:25:00',4.52),('15128','2013-06-24','14:30:00',4.48),('15128','2013-06-24','14:35:00',4.45),('15128','2013-06-24','14:40:00',4.46),('15128','2013-06-24','14:45:00',4.48),('15128','2013-06-24','14:50:00',4.41),('15128','2013-06-24','14:55:00',4.39),('15128','2013-06-24','15:00:00',4.37),('15128','2013-06-24','15:05:00',4.38),('15128','2013-06-24','15:10:00',4.36),('15128','2013-06-24','15:15:00',4.31),('15128','2013-06-24','15:20:00',4.3),('15128','2013-06-24','15:25:00',4.26),('15128','2013-06-24','15:30:00',4.23),('15128','2013-06-24','15:35:00',4.16),('15128','2013-06-24','15:40:00',4.14),('15128','2013-06-24','15:45:00',4.11),('15128','2013-06-24','15:50:00',4.04),('15128','2013-06-24','15:55:00',4.01),('15128','2013-06-24','16:00:00',3.97),('15128','2013-06-24','16:05:00',3.94),('15128','2013-06-24','16:10:00',3.89),('15128','2013-06-24','16:15:00',3.85),('15128','2013-06-24','16:20:00',3.82),('15128','2013-06-24','16:25:00',3.76),('15128','2013-06-24','16:30:00',3.72),('15128','2013-06-24','16:35:00',3.66),('15128','2013-06-24','16:40:00',3.6),('15128','2013-06-24','16:45:00',3.53),('15128','2013-06-24','16:50:00',3.48),('15128','2013-06-24','16:55:00',3.42),('15128','2013-06-24','17:00:00',3.36),('15128','2013-06-24','17:05:00',3.29),('15128','2013-06-24','17:10:00',3.22),('15128','2013-06-24','17:15:00',3.16),('15128','2013-06-24','17:20:00',3.1),('15128','2013-06-24','17:25:00',3.02),('15128','2013-06-24','17:30:00',2.93),('15128','2013-06-24','17:35:00',2.86),('15128','2013-06-24','17:40:00',2.81),('15128','2013-06-24','17:45:00',2.73),('15128','2013-06-24','17:50:00',2.64),('15128','2013-06-24','17:55:00',2.55),('15128','2013-06-24','18:00:00',2.39),('15128','2013-06-24','18:05:00',2.34),('15128','2013-06-24','18:10:00',2.2),('15128','2013-06-24','18:15:00',2.12),('15128','2013-06-24','18:20:00',2.03),('15128','2013-06-24','18:25:00',1.95),('15128','2013-06-24','18:30:00',1.86),('15128','2013-06-24','18:35:00',1.75),('15128','2013-06-24','18:40:00',1.67),('15128','2013-06-24','18:45:00',1.6),('15128','2013-06-24','18:50:00',1.56),('15128','2013-06-24','18:55:00',1.5),('15128','2013-06-24','19:00:00',1.39),('15128','2013-06-24','19:05:00',1.31),('15128','2013-06-24','19:10:00',1.22),('15128','2013-06-24','19:15:00',1.12),('15128','2013-06-23','08:40:00',1.46),('15128','2013-06-23','08:45:00',1.97),('15128','2013-06-23','09:00:00',2.03),('15128','2013-06-23','09:05:00',2.36),('15128','2013-06-23','09:10:00',2.48),('15128','2013-06-23','09:15:00',2.28),('15128','2013-06-23','09:20:00',1.64),('15128','2013-06-23','09:25:00',1.61),('15128','2013-06-23','09:35:00',2.04),('15128','2013-06-23','09:40:00',2.86),('15128','2013-06-23','09:45:00',2.85),('15128','2013-06-23','09:50:00',2.15),('15128','2013-06-23','09:55:00',2.05),('15128','2013-06-23','10:00:00',2.95),('15128','2013-06-23','10:05:00',3.41),('15128','2013-06-23','10:10:00',2.38),('15128','2013-06-23','10:15:00',3.2),('15128','2013-06-23','10:20:00',3),('15128','2013-06-23','10:25:00',3.76),('15128','2013-06-23','10:30:00',2.77),('15128','2013-06-23','10:35:00',3.54),('15128','2013-06-23','10:40:00',2.85),('15128','2013-06-23','10:45:00',3.16),('15128','2013-06-23','10:50:00',3.81),('15128','2013-06-23','10:55:00',1.79),('15128','2013-06-23','11:00:00',1.58),('15128','2013-06-23','11:05:00',1.91),('15128','2013-06-23','11:10:00',3.46),('15128','2013-06-23','11:15:00',3.27),('15128','2013-06-23','11:20:00',1.12),('15128','2013-06-23','11:25:00',2.5),('15128','2013-06-23','11:30:00',1.38),('15128','2013-06-23','11:35:00',1.61),('15128','2013-06-23','11:40:00',3.82),('15128','2013-06-23','11:45:00',1.52),('15128','2013-06-23','11:50:00',2.28),('15128','2013-06-23','11:55:00',2.23),('15128','2013-06-23','12:00:00',3.76),('15128','2013-06-23','12:05:00',2.73),('15128','2013-06-23','12:10:00',5.21),('15128','2013-06-23','12:15:00',4.23),('15128','2013-06-23','12:20:00',2.83),('15128','2013-06-23','12:25:00',3.29),('15128','2013-06-23','12:30:00',3.67),('15128','2013-06-23','12:35:00',3.31),('15128','2013-06-23','12:40:00',3.9),('15128','2013-06-23','12:45:00',4.16),('15128','2013-06-23','12:50:00',4.32),('15128','2013-06-23','12:55:00',3.97),('15128','2013-06-23','13:00:00',4.96),('15128','2013-06-23','13:05:00',3.8),('15128','2013-06-23','13:10:00',3.12),('15128','2013-06-23','13:15:00',5.26),('15128','2013-06-23','13:20:00',4.24),('15128','2013-06-23','13:25:00',4.32),('15128','2013-06-23','13:30:00',2.58),('15128','2013-06-23','13:35:00',5.05),('15128','2013-06-23','13:40:00',4.92),('15128','2013-06-23','13:45:00',4.94),('15128','2013-06-23','13:50:00',4.79),('15128','2013-06-23','13:55:00',4.91),('15128','2013-06-23','14:00:00',4.58),('15128','2013-06-23','14:05:00',4.8),('15128','2013-06-23','14:10:00',4.62),('15128','2013-06-23','14:15:00',3.68),('15128','2013-06-23','14:20:00',4.85),('15128','2013-06-23','14:25:00',4.98),('15128','2013-06-23','14:30:00',5.1),('15128','2013-06-23','14:35:00',3.74),('15128','2013-06-23','14:40:00',3.66),('15128','2013-06-23','14:45:00',2.61),('15128','2013-06-23','14:50:00',4.77),('15128','2013-06-23','14:55:00',2.07),('15128','2013-06-23','15:00:00',2.35),('15128','2013-06-23','15:05:00',2.36),('15128','2013-06-23','15:10:00',4.01),('15128','2013-06-23','15:15:00',4.17),('15128','2013-06-23','15:20:00',3.92),('15128','2013-06-23','15:25:00',3.56),('15128','2013-06-23','15:30:00',3.91),('15128','2013-06-23','15:35:00',4.66),('15128','2013-06-23','15:40:00',4.2),('15128','2013-06-23','15:45:00',3.17),('15128','2013-06-23','15:50:00',4.27),('15128','2013-06-23','15:55:00',3.12),('15128','2013-06-23','16:00:00',3.74),('15128','2013-06-23','16:05:00',2.88),('15128','2013-06-23','16:10:00',2.97),('15128','2013-06-23','16:15:00',4.42),('15128','2013-06-23','16:20:00',1.91),('15128','2013-06-23','16:25:00',3.85),('15128','2013-06-23','16:30:00',1.68),('15128','2013-06-23','16:35:00',3.04),('15128','2013-06-23','16:40:00',2.49),('15128','2013-06-23','16:45:00',2.53),('15128','2013-06-23','16:50:00',1.74),('15128','2013-06-23','16:55:00',1.41),('15128','2013-06-23','17:00:00',2.26),('15128','2013-06-23','17:05:00',2.14),('15128','2013-06-23','17:10:00',3.35),('15128','2013-06-23','17:15:00',3.47),('15128','2013-06-23','17:20:00',2.76),('15128','2013-06-23','17:25:00',1.37),('15128','2013-06-23','17:30:00',2.07),('15128','2013-06-23','17:35:00',1.71),('15128','2013-06-23','17:45:00',2.06),('15128','2013-06-23','17:50:00',2.79),('15128','2013-06-23','17:55:00',2.59),('15128','2013-06-23','18:00:00',1.82),('15128','2013-06-23','18:05:00',2.51),('15128','2013-06-23','18:10:00',2.41),('15128','2013-06-23','18:15:00',1.16),('15128','2013-06-23','18:20:00',1.64),('15128','2013-06-23','18:40:00',1.8),('15128','2013-06-23','18:45:00',1.66),('15128','2013-06-23','18:50:00',1.65),('15128','2013-06-23','18:55:00',1.54),('15128','2013-06-23','19:00:00',1.49),('15128','2013-06-23','19:05:00',1.38),('15128','2013-06-23','19:10:00',1.27),('15128','2013-06-23','19:15:00',1.17),('15128','2013-06-22','08:50:00',1.19),('15128','2013-06-22','08:55:00',1.04),('15128','2013-06-22','09:10:00',1.57),('15128','2013-06-22','09:15:00',2.08),('15128','2013-06-22','09:20:00',2.32),('15128','2013-06-22','09:25:00',2.36),('15128','2013-06-22','09:30:00',2.38),('15128','2013-06-22','09:35:00',2.57),('15128','2013-06-22','09:40:00',1.59),('15128','2013-06-22','09:45:00',2.28),('15128','2013-06-22','09:50:00',2.61),('15128','2013-06-22','09:55:00',2.7),('15128','2013-06-22','10:00:00',2.74),('15128','2013-06-22','10:05:00',2.82),('15128','2013-06-22','10:10:00',2.58),('15128','2013-06-22','10:15:00',2.31),('15128','2013-06-22','10:20:00',2.55),('15128','2013-06-22','10:25:00',2.58),('15128','2013-06-22','10:30:00',3.12),('15128','2013-06-22','10:35:00',2.92),('15128','2013-06-22','10:40:00',2.98),('15128','2013-06-22','10:45:00',3.16),('15128','2013-06-22','10:50:00',3.19),('15128','2013-06-22','10:55:00',3.22),('15128','2013-06-22','11:00:00',3.34),('15128','2013-06-22','11:05:00',3.27),('15128','2013-06-22','11:10:00',3.37),('15128','2013-06-22','11:15:00',3.41),('15128','2013-06-22','11:20:00',3.44),('15128','2013-06-22','11:25:00',3.52),('15128','2013-06-22','11:30:00',3.5),('15128','2013-06-22','11:35:00',3.54),('15128','2013-06-22','11:40:00',3.64),('15128','2013-06-22','11:45:00',3.76),('15128','2013-06-22','11:50:00',3.83),('15128','2013-06-22','11:55:00',4.01),('15128','2013-06-22','12:00:00',4.02),('15128','2013-06-22','12:05:00',4.06),('15128','2013-06-22','12:10:00',4.13),('15128','2013-06-22','12:15:00',4.19),('15128','2013-06-22','12:20:00',4.25),('15128','2013-06-22','12:25:00',4.26),('15128','2013-06-22','12:30:00',4.29),('15128','2013-06-22','12:35:00',4.33),('15128','2013-06-22','12:40:00',4.35),('15128','2013-06-22','12:45:00',4.38),('15128','2013-06-22','12:50:00',4.39),('15128','2013-06-22','12:55:00',4.44),('15128','2013-06-22','13:00:00',4.44),('15128','2013-06-22','13:05:00',4.45),('15128','2013-06-22','13:10:00',4.46),('15128','2013-06-22','13:15:00',4.47),('15128','2013-06-22','13:20:00',4.53),('15128','2013-06-22','13:25:00',4.54),('15128','2013-06-22','13:30:00',4.56),('15128','2013-06-22','13:35:00',4.58),('15128','2013-06-22','13:40:00',4.58),('15128','2013-06-22','13:45:00',4.59),('15128','2013-06-22','13:50:00',4.61),('15128','2013-06-22','13:55:00',4.59),('15128','2013-06-22','14:00:00',4.59),('15128','2013-06-22','14:05:00',4.6),('15128','2013-06-22','14:10:00',4.61),('15128','2013-06-22','14:15:00',4.64),('15128','2013-06-22','14:20:00',4.62),('15128','2013-06-22','14:25:00',4.61),('15128','2013-06-22','14:30:00',4.62),('15128','2013-06-22','14:35:00',4.59),('15128','2013-06-22','14:40:00',4.55),('15128','2013-06-22','14:45:00',4.55),('15128','2013-06-22','14:50:00',4.51),('15128','2013-06-22','14:55:00',4.5),('15128','2013-06-22','15:00:00',2.92),('15128','2013-06-22','15:10:00',3.69),('15128','2013-06-22','15:15:00',4.38),('15128','2013-06-22','15:20:00',1.31),('15128','2013-06-22','15:30:00',4.19),('15128','2013-06-22','15:35:00',4.25),('15128','2013-06-22','15:45:00',1.36),('15128','2013-06-22','15:50:00',4.12),('15128','2013-06-22','15:55:00',3.52),('15128','2013-06-22','16:05:00',2.81),('15128','2013-06-22','16:10:00',3.95),('15128','2013-06-22','16:15:00',3.94),('15128','2013-06-22','16:20:00',3.89),('15128','2013-06-22','16:25:00',2.48),('15128','2013-06-22','16:30:00',3.8),('15128','2013-06-22','16:35:00',3.75),('15128','2013-06-22','16:40:00',3.71),('15128','2013-06-22','16:45:00',2.48),('15128','2013-06-22','16:50:00',3.56),('15128','2013-06-22','16:55:00',3.53),('15128','2013-06-22','17:00:00',3.51),('15128','2013-06-22','17:05:00',2.68),('15128','2013-06-22','17:10:00',2.69),('15128','2013-06-22','17:15:00',3.3),('15128','2013-06-22','17:20:00',3.01),('15128','2013-06-22','17:25:00',2.77),('15128','2013-06-22','17:30:00',2.64),('15128','2013-06-22','17:35:00',3.03),('15128','2013-06-22','17:40:00',2.96),('15128','2013-06-22','17:45:00',2.21),('15128','2013-06-22','17:50:00',1.58),('15128','2013-06-22','17:55:00',2.25),('15128','2013-06-22','18:00:00',2.7),('15128','2013-06-22','18:05:00',2.49),('15128','2013-06-22','18:10:00',2.39),('15128','2013-06-22','18:15:00',2.29),('15128','2013-06-22','18:20:00',2.15),('15128','2013-06-22','18:25:00',2.05),('15128','2013-06-22','18:30:00',1.94),('15128','2013-06-22','18:35:00',1.87),('15128','2013-06-22','18:40:00',1.81),('15128','2013-06-22','18:45:00',1.69),('15128','2013-06-22','18:50:00',1.6),('15128','2013-06-22','18:55:00',1.19),('15128','2013-06-22','19:10:00',1.08),('15128','2013-06-22','19:15:00',1.34),('15128','2013-06-22','19:20:00',1.1),('15128','2013-06-21','08:00:00',1.02),('15128','2013-06-21','08:05:00',1.07),('15128','2013-06-21','08:10:00',1.11),('15128','2013-06-21','08:15:00',1.16),('15128','2013-06-21','08:20:00',1.25),('15128','2013-06-21','08:25:00',1.34),('15128','2013-06-21','08:30:00',1.4),('15128','2013-06-21','08:35:00',1.48),('15128','2013-06-21','08:40:00',1.56),('15128','2013-06-21','08:45:00',1.6),('15128','2013-06-21','08:50:00',1.7),('15128','2013-06-21','08:55:00',1.8),('15128','2013-06-21','09:00:00',1.86),('15128','2013-06-21','09:05:00',1.96),('15128','2013-06-21','09:10:00',2.03),('15128','2013-06-21','09:15:00',2.09),('15128','2013-06-21','09:20:00',2.1),('15128','2013-06-21','09:25:00',2.15),('15128','2013-06-21','09:30:00',2.28),('15128','2013-06-21','09:35:00',2.34),('15128','2013-06-21','09:40:00',2.42),('15128','2013-06-21','09:45:00',2.49),('15128','2013-06-21','09:50:00',2.54),('15128','2013-06-21','09:55:00',2.6),('15128','2013-06-21','10:00:00',2.67),('15128','2013-06-21','10:05:00',2.74),('15128','2013-06-21','10:10:00',2.79),('15128','2013-06-21','10:15:00',2.84),('15128','2013-06-21','10:20:00',2.88),('15128','2013-06-21','10:25:00',2.94),('15128','2013-06-21','10:30:00',2.99),('15128','2013-06-21','10:35:00',3.04),('15128','2013-06-21','10:40:00',3.1),('15128','2013-06-21','10:45:00',3.13),('15128','2013-06-21','10:50:00',3.22),('15128','2013-06-21','10:55:00',3.22),('15128','2013-06-21','11:00:00',3.3),('15128','2013-06-21','11:05:00',3.33),('15128','2013-06-21','11:10:00',3.36),('15128','2013-06-21','11:15:00',3.45),('15128','2013-06-21','11:20:00',3.52),('15128','2013-06-21','11:25:00',3.57),('15128','2013-06-21','11:30:00',3.51),('15128','2013-06-21','11:35:00',3.61),('15128','2013-06-21','11:40:00',3.79),('15128','2013-06-21','11:45:00',3.85),('15128','2013-06-21','11:50:00',3.94),('15128','2013-06-21','11:55:00',3.95),('15128','2013-06-21','12:00:00',4.05),('15128','2013-06-21','12:05:00',4.06),('15128','2013-06-21','12:10:00',4.12),('15128','2013-06-21','12:15:00',4.1),('15128','2013-06-21','12:20:00',4.14),('15128','2013-06-21','12:25:00',4.15),('15128','2013-06-21','12:30:00',4.1),('15128','2013-06-21','12:35:00',4.14),('15128','2013-06-21','12:40:00',4.17),('15128','2013-06-21','12:45:00',4.17),('15128','2013-06-21','12:50:00',4.17),('15128','2013-06-21','12:55:00',4.17),('15128','2013-06-21','13:00:00',4.14),('15128','2013-06-21','13:05:00',4.12),('15128','2013-06-21','13:10:00',4.21),('15128','2013-06-21','13:15:00',4.52),('15128','2013-06-21','13:20:00',4.32),('15128','2013-06-21','13:25:00',4.56),('15128','2013-06-21','13:30:00',4.54),('15128','2013-06-21','13:35:00',4.46),('15128','2013-06-21','13:40:00',4.23),('15128','2013-06-21','13:45:00',4.13),('15128','2013-06-21','13:50:00',3.54),('15128','2013-06-21','13:55:00',4.16),('15128','2013-06-21','14:00:00',4.9),('15128','2013-06-21','14:05:00',4.84),('15128','2013-06-21','14:10:00',4.71),('15128','2013-06-21','14:15:00',3.42),('15128','2013-06-21','14:20:00',2.29),('15128','2013-06-21','14:25:00',4.17),('15128','2013-06-21','14:30:00',2.51),('15128','2013-06-21','14:35:00',2.24),('15128','2013-06-21','14:40:00',3.39),('15128','2013-06-21','14:45:00',3.79),('15128','2013-06-21','14:50:00',4.86),('15128','2013-06-21','14:55:00',4.39),('15128','2013-06-21','15:00:00',4.66),('15128','2013-06-21','15:05:00',4.3),('15128','2013-06-21','15:10:00',4.39),('15128','2013-06-21','15:15:00',4.26),('15128','2013-06-21','15:20:00',4.46),('15128','2013-06-21','15:25:00',4.09),('15128','2013-06-21','15:30:00',3.82),('15128','2013-06-21','15:35:00',2.8),('15128','2013-06-21','15:40:00',2.05),('15128','2013-06-21','15:45:00',1.5),('15128','2013-06-21','15:50:00',1.67),('15128','2013-06-21','15:55:00',1.93),('15128','2013-06-21','16:00:00',1.57),('15128','2013-06-21','16:05:00',1.49),('15128','2013-06-21','16:10:00',1.7),('15128','2013-06-21','16:15:00',1.77),('15128','2013-06-21','16:20:00',1.58),('15128','2013-06-21','16:25:00',1.58),('15128','2013-06-21','16:30:00',1.42),('15128','2013-06-21','16:35:00',1.37),('15128','2013-06-21','16:40:00',1.24),('15128','2013-06-21','16:45:00',1.21),('15128','2013-06-21','16:50:00',1.41),('15128','2013-06-21','16:55:00',2.35),('15128','2013-06-21','17:00:00',3.36),('15128','2013-06-21','17:05:00',3.48),('15128','2013-06-21','17:10:00',3.7),('15128','2013-06-21','17:15:00',2.43),('15128','2013-06-21','17:20:00',3.03),('15128','2013-06-21','17:25:00',3.23),('15128','2013-06-21','17:30:00',2.91),('15128','2013-06-21','17:35:00',2.73),('15128','2013-06-21','17:40:00',2.69),('15128','2013-06-21','17:45:00',2.62),('15128','2013-06-21','17:50:00',2.48),('15128','2013-06-21','17:55:00',2.17),('15128','2013-06-21','18:00:00',2.03),('15128','2013-06-21','18:05:00',1.65),('15128','2013-06-21','18:10:00',1.28),('15128','2013-06-21','18:15:00',1.03),('15128','2013-06-21','18:20:00',1.01),('15128','2013-06-21','19:10:00',1.14),('15128','2013-06-21','19:15:00',1.23),('15128','2013-06-21','19:20:00',1.12),('15128','2013-06-20','08:00:00',1.01),('15128','2013-06-20','08:05:00',1.06),('15128','2013-06-20','08:10:00',1.11),('15128','2013-06-20','08:15:00',1.15),('15128','2013-06-20','08:20:00',1.24),('15128','2013-06-20','08:25:00',1.32),('15128','2013-06-20','08:30:00',1.38),('15128','2013-06-20','08:35:00',1.42),('15128','2013-06-20','08:40:00',1.5),('15128','2013-06-20','08:45:00',1.57),('15128','2013-06-20','08:50:00',1.65),('15128','2013-06-20','08:55:00',1.76),('15128','2013-06-20','09:00:00',1.83),('15128','2013-06-20','09:05:00',1.9),('15128','2013-06-20','09:10:00',1.98),('15128','2013-06-20','09:15:00',2.02),('15128','2013-06-20','09:20:00',2.02),('15128','2013-06-20','09:25:00',2.09),('15128','2013-06-20','09:30:00',2.19),('15128','2013-06-20','09:35:00',2.27),('15128','2013-06-20','09:40:00',2.32),('15128','2013-06-20','09:45:00',2.35),('15128','2013-06-20','09:50:00',2.41),('15128','2013-06-20','09:55:00',2.46),('15128','2013-06-20','10:00:00',2.55),('15128','2013-06-20','10:05:00',2.57),('15128','2013-06-20','10:10:00',2.65),('15128','2013-06-20','10:15:00',2.67),('15128','2013-06-20','10:20:00',2.69),('15128','2013-06-20','10:25:00',2.76),('15128','2013-06-20','10:30:00',2.74),('15128','2013-06-20','10:35:00',2.77),('15128','2013-06-20','10:40:00',2.96),('15128','2013-06-20','10:45:00',2.97),('15128','2013-06-20','10:50:00',3.05),('15128','2013-06-20','10:55:00',3.11),('15128','2013-06-20','11:00:00',3.13),('15128','2013-06-20','11:05:00',3.1),('15128','2013-06-20','11:10:00',3.22),('15128','2013-06-20','11:15:00',3.33),('15128','2013-06-20','11:20:00',3.39),('15128','2013-06-20','11:25:00',3.43),('15128','2013-06-20','11:30:00',3.4),('15128','2013-06-20','11:35:00',3.48),('15128','2013-06-20','11:40:00',3.62),('15128','2013-06-20','11:45:00',3.75),('15128','2013-06-20','11:50:00',3.78),('15128','2013-06-20','11:55:00',3.79),('15128','2013-06-20','12:00:00',3.81),('15128','2013-06-20','12:05:00',3.88),('15128','2013-06-20','12:10:00',3.9),('15128','2013-06-20','12:15:00',3.93),('15128','2013-06-20','12:20:00',3.96),('15128','2013-06-20','12:25:00',3.97),('15128','2013-06-20','12:30:00',4.02),('15128','2013-06-20','12:35:00',4.06),('15128','2013-06-20','12:40:00',4.13),('15128','2013-06-20','12:45:00',4.13),('15128','2013-06-20','12:50:00',4.16),('15128','2013-06-20','12:55:00',4.13),('15128','2013-06-20','13:00:00',4.14),('15128','2013-06-20','13:05:00',4.18),('15128','2013-06-20','13:10:00',4.23),('15128','2013-06-20','13:15:00',4.23),('15128','2013-06-20','13:20:00',4.27),('15128','2013-06-20','13:25:00',4.3),('15128','2013-06-20','13:30:00',4.31),('15128','2013-06-20','13:35:00',4.34),('15128','2013-06-20','13:40:00',4.37),('15128','2013-06-20','13:45:00',4.35),('15128','2013-06-20','13:50:00',4.36),('15128','2013-06-20','13:55:00',4.38),('15128','2013-06-20','14:00:00',4.4),('15128','2013-06-20','14:05:00',4.39),('15128','2013-06-20','14:10:00',4.37),('15128','2013-06-20','14:15:00',4.39),('15128','2013-06-20','14:20:00',4.37),('15128','2013-06-20','14:25:00',4.38),('15128','2013-06-20','14:30:00',4.38),('15128','2013-06-20','14:35:00',4.38),('15128','2013-06-20','14:40:00',4.37),('15128','2013-06-20','14:45:00',4.35),('15128','2013-06-20','14:50:00',4.33),('15128','2013-06-20','14:55:00',4.29),('15128','2013-06-20','15:00:00',4.27),('15128','2013-06-20','15:05:00',4.28),('15128','2013-06-20','15:10:00',4.25),('15128','2013-06-20','15:15:00',4.23),('15128','2013-06-20','15:20:00',4.21),('15128','2013-06-20','15:25:00',4.18),('15128','2013-06-20','15:30:00',4.15),('15128','2013-06-20','15:35:00',4.1),('15128','2013-06-20','15:40:00',4.07),('15128','2013-06-20','15:45:00',4.05),('15128','2013-06-20','15:50:00',4),('15128','2013-06-20','15:55:00',3.98),('15128','2013-06-20','16:00:00',3.92),('15128','2013-06-20','16:05:00',3.88),('15128','2013-06-20','16:10:00',3.83),('15128','2013-06-20','16:15:00',3.77),('15128','2013-06-20','16:20:00',3.72),('15128','2013-06-20','16:25:00',3.67),('15128','2013-06-20','16:30:00',3.64),('15128','2013-06-20','16:35:00',3.59),('15128','2013-06-20','16:40:00',3.54),('15128','2013-06-20','16:45:00',3.49),('15128','2013-06-20','16:50:00',3.43),('15128','2013-06-20','16:55:00',3.38),('15128','2013-06-20','17:00:00',3.32),('15128','2013-06-20','17:05:00',3.26),('15128','2013-06-20','17:10:00',3.2),('15128','2013-06-20','17:15:00',3.12),('15128','2013-06-20','17:20:00',3.06),('15128','2013-06-20','17:25:00',3),('15128','2013-06-20','17:30:00',2.93),('15128','2013-06-20','17:35:00',2.84),('15128','2013-06-20','17:40:00',2.76),('15128','2013-06-20','17:45:00',2.69),('15128','2013-06-20','17:50:00',2.61),('15128','2013-06-20','17:55:00',2.51),('15128','2013-06-20','18:00:00',2.42),('15128','2013-06-20','18:05:00',2.3),('15128','2013-06-20','18:10:00',2.17),('15128','2013-06-20','18:15:00',2.1),('15128','2013-06-20','18:20:00',2.01),('15128','2013-06-20','18:25:00',1.91),('15128','2013-06-20','18:30:00',1.81),('15128','2013-06-20','18:35:00',1.7),('15128','2013-06-20','18:40:00',1.62),('15128','2013-06-20','18:45:00',1.58),('15128','2013-06-20','18:50:00',1.53),('15128','2013-06-20','18:55:00',1.46),('15128','2013-06-20','19:00:00',1.36),('15128','2013-06-20','19:05:00',1.24),('15128','2013-06-20','19:10:00',1.15),('15128','2013-06-20','19:15:00',1.06),('15128','2014-04-03','11:05:00',1.23),('15128','2014-04-03','11:10:00',1.13),('15128','2014-04-03','12:35:00',1.1),('15128','2014-04-03','12:55:00',1.14),('15128','2014-04-03','13:00:00',1.42),('15128','2014-04-03','13:05:00',2.79),('15128','2014-04-03','13:10:00',1.73),('15128','2014-04-03','13:15:00',2.12),('15128','2014-04-03','13:20:00',2.92),('15128','2014-04-03','13:25:00',2.01),('15128','2014-04-03','13:30:00',2.5),('15128','2014-04-03','13:35:00',3.88),('15128','2014-04-03','13:40:00',2.14),('15128','2014-04-03','13:45:00',1.76),('15128','2014-04-03','13:50:00',2.39),('15128','2014-04-03','13:55:00',2.51),('15128','2014-04-03','14:00:00',4),('15128','2014-04-03','14:05:00',2.08),('15128','2014-04-03','14:10:00',2.51),('15128','2014-04-03','14:15:00',2.15),('15128','2014-04-03','14:20:00',2.41),('15128','2014-04-03','14:25:00',1.47),('15128','2014-04-03','14:30:00',1.39),('15128','2014-04-03','14:35:00',1.45),('15128','2014-04-03','14:40:00',2.2),('15128','2014-04-03','14:45:00',2.47),('15128','2014-04-03','14:50:00',1.97),('15128','2014-04-03','14:55:00',4.02),('15128','2014-04-03','15:00:00',2.35),('15128','2014-04-03','15:05:00',1.85),('15128','2014-04-03','15:10:00',2.33),('15128','2014-04-03','15:15:00',1.58),('15128','2014-04-03','15:20:00',3.44),('15128','2014-04-03','15:25:00',2),('15128','2014-04-03','15:30:00',1.78),('15128','2014-04-03','15:35:00',1.18),('15128','2014-04-03','15:40:00',1.19),('15128','2014-04-03','15:45:00',1.61),('15128','2014-04-03','15:50:00',2.35),('15128','2014-04-03','15:55:00',4.13),('15128','2014-04-03','16:00:00',3.92),('15128','2014-04-03','16:05:00',3),('15128','2014-04-03','16:10:00',1.55),('15128','2014-04-03','16:15:00',3.09),('15128','2014-04-03','16:20:00',1.32),('15128','2014-04-03','16:25:00',1.19),('15128','2014-04-03','16:30:00',1.63),('15128','2014-04-03','16:35:00',1.62),('15128','2014-04-03','16:40:00',1.58),('15128','2014-04-03','16:45:00',2.28),('15128','2014-04-03','16:50:00',1.33),('15128','2014-04-03','16:55:00',2.46),('15128','2014-04-03','17:00:00',1.48),('15128','2014-04-03','17:05:00',1.35),('15128','2014-04-03','17:15:00',2.1),('15128','2014-04-03','17:20:00',2.58),('15128','2014-04-03','17:25:00',2.25),('15128','2014-04-03','17:30:00',1.91),('15128','2014-04-03','17:35:00',2.16),('15128','2014-04-03','17:40:00',1.34),('15128','2014-04-03','17:45:00',1.07),('15128','2014-04-03','17:55:00',1.23),('15128','2013-06-19','08:00:00',1.01),('15128','2013-06-19','08:05:00',1.06),('15128','2013-06-19','08:10:00',1.1),('15128','2013-06-19','08:15:00',1.16),('15128','2013-06-19','08:20:00',1.25),('15128','2013-06-19','08:25:00',1.32),('15128','2013-06-19','08:30:00',1.39),('15128','2013-06-19','08:35:00',1.45),('15128','2013-06-19','08:40:00',1.53),('15128','2013-06-19','08:45:00',1.59),('15128','2013-06-19','08:50:00',1.67),('15128','2013-06-19','08:55:00',1.78),('15128','2013-06-19','09:00:00',1.87),('15128','2013-06-19','09:05:00',1.94),('15128','2013-06-19','09:10:00',2.02),('15128','2013-06-19','09:15:00',2.05),('15128','2013-06-19','09:20:00',2.09),('15128','2013-06-19','09:25:00',2.2),('15128','2013-06-19','09:30:00',2.26),('15128','2013-06-19','09:35:00',2.34),('15128','2013-06-19','09:40:00',2.4),('15128','2013-06-19','09:45:00',2.46),('15128','2013-06-19','09:50:00',2.51),('15128','2013-06-19','09:55:00',2.55),('15128','2013-06-19','10:00:00',2.6),('15128','2013-06-19','10:05:00',2.63),('15128','2013-06-19','10:10:00',2.72),('15128','2013-06-19','10:15:00',2.73),('15128','2013-06-19','10:20:00',2.77),('15128','2013-06-19','10:25:00',2.87),('15128','2013-06-19','10:30:00',2.9),('15128','2013-06-19','10:35:00',2.92),('15128','2013-06-19','10:40:00',2.96),('15128','2013-06-19','10:45:00',2.99),('15128','2013-06-19','10:50:00',3.09),('15128','2013-06-19','10:55:00',3.07),('15128','2013-06-19','11:00:00',3.15),('15128','2013-06-19','11:05:00',3.18),('15128','2013-06-19','11:10:00',3.27),('15128','2013-06-19','11:15:00',3.33),('15128','2013-06-19','11:20:00',3.38),('15128','2013-06-19','11:25:00',3.42),('15128','2013-06-19','11:30:00',3.33),('15128','2013-06-19','11:35:00',3.38),('15128','2013-06-19','11:40:00',3.6),('15128','2013-06-19','11:45:00',3.63),('15128','2013-06-19','11:50:00',3.74),('15128','2013-06-19','11:55:00',3.74),('15128','2013-06-19','12:00:00',3.91),('15128','2013-06-19','12:05:00',3.94),('15128','2013-06-19','12:10:00',3.95),('15128','2013-06-19','12:15:00',3.93),('15128','2013-06-19','12:20:00',3.88),('15128','2013-06-19','12:25:00',3.87),('15128','2013-06-19','12:30:00',3.9),('15128','2013-06-19','12:35:00',3.95),('15128','2013-06-19','12:40:00',4),('15128','2013-06-19','12:45:00',4.03),('15128','2013-06-19','12:50:00',4.03),('15128','2013-06-19','12:55:00',4.04),('15128','2013-06-19','13:00:00',4.1),('15128','2013-06-19','13:05:00',4.09),('15128','2013-06-19','13:10:00',4.11),('15128','2013-06-19','13:15:00',4.2),('15128','2013-06-19','13:20:00',4.22),('15128','2013-06-19','13:25:00',4.24),('15128','2013-06-19','13:30:00',4.31),('15128','2013-06-19','13:35:00',4.33),('15128','2013-06-19','13:40:00',4.37),('15128','2013-06-19','13:45:00',4.45),('15128','2013-06-19','13:50:00',4.47),('15128','2013-06-19','13:55:00',4.47),('15128','2013-06-19','14:00:00',4.45),('15128','2013-06-19','14:05:00',4.47),('15128','2013-06-19','14:10:00',4.51),('15128','2013-06-19','14:15:00',4.5),('15128','2013-06-19','14:20:00',4.5),('15128','2013-06-19','14:25:00',4.49),('15128','2013-06-19','14:30:00',4.49),('15128','2013-06-19','14:35:00',4.49),('15128','2013-06-19','14:40:00',4.49),('15128','2013-06-19','14:45:00',4.46),('15128','2013-06-19','14:50:00',4.45),('15128','2013-06-19','14:55:00',4.44),('15128','2013-06-19','15:00:00',4.41),('15128','2013-06-19','15:05:00',4.38),('15128','2013-06-19','15:10:00',4.33),('15128','2013-06-19','15:15:00',4.31),('15128','2013-06-19','15:20:00',4.27),('15128','2013-06-19','15:25:00',4.26),('15128','2013-06-19','15:30:00',4.21),('15128','2013-06-19','15:35:00',4.16),('15128','2013-06-19','15:40:00',4.1),('15128','2013-06-19','15:45:00',4.09),('15128','2013-06-19','15:50:00',4.03),('15128','2013-06-19','15:55:00',3.99),('15128','2013-06-19','16:00:00',3.94),('15128','2013-06-19','16:05:00',3.9),('15128','2013-06-19','16:10:00',3.88),('15128','2013-06-19','16:15:00',3.83),('15128','2013-06-19','16:20:00',3.79),('15128','2013-06-19','16:25:00',3.74),('15128','2013-06-19','16:30:00',3.68),('15128','2013-06-19','16:35:00',3.64),('15128','2013-06-19','16:40:00',3.56),('15128','2013-06-19','16:45:00',3.49),('15128','2013-06-19','16:50:00',3.44),('15128','2013-06-19','16:55:00',3.39),('15128','2013-06-19','17:00:00',3.34),('15128','2013-06-19','17:05:00',3.28),('15128','2013-06-19','17:10:00',3.23),('15128','2013-06-19','17:15:00',3.17),('15128','2013-06-19','17:20:00',3.11),('15128','2013-06-19','17:25:00',3.06),('15128','2013-06-19','17:30:00',2.99),('15128','2013-06-19','17:35:00',2.91),('15128','2013-06-19','17:40:00',2.85),('15128','2013-06-19','17:45:00',2.78),('15128','2013-06-19','17:50:00',2.7),('15128','2013-06-19','17:55:00',2.56),('15128','2013-06-19','18:00:00',2.43),('15128','2013-06-19','18:05:00',2.41),('15128','2013-06-19','18:10:00',2.27),('15128','2013-06-19','18:15:00',2.18),('15128','2013-06-19','18:20:00',2.09),('15128','2013-06-19','18:25:00',2),('15128','2013-06-19','18:30:00',1.9),('15128','2013-06-19','18:35:00',1.79),('15128','2013-06-19','18:40:00',1.72),('15128','2013-06-19','18:45:00',1.64),('15128','2013-06-19','18:50:00',1.59),('15128','2013-06-19','18:55:00',1.52),('15128','2013-06-19','19:00:00',1.41),('15128','2013-06-19','19:05:00',1.31),('15128','2013-06-19','19:10:00',1.21),('15128','2013-06-19','19:15:00',1.1),('15128','2013-06-18','08:05:00',1.05),('15128','2013-06-18','08:10:00',1.1),('15128','2013-06-18','08:15:00',1.16),('15128','2013-06-18','08:20:00',1.25),('15128','2013-06-18','08:25:00',1.32),('15128','2013-06-18','08:30:00',1.37),('15128','2013-06-18','08:35:00',1.44),('15128','2013-06-18','08:40:00',1.51),('15128','2013-06-18','08:45:00',1.58),('15128','2013-06-18','08:50:00',1.67),('15128','2013-06-18','08:55:00',1.77),('15128','2013-06-18','09:00:00',1.84),('15128','2013-06-18','09:05:00',1.92),('15128','2013-06-18','09:10:00',1.97),('15128','2013-06-18','09:15:00',2.01),('15128','2013-06-18','09:20:00',2.01),('15128','2013-06-18','09:25:00',2.07),('15128','2013-06-18','09:30:00',2.2),('15128','2013-06-18','09:35:00',2.26),('15128','2013-06-18','09:40:00',2.32),('15128','2013-06-18','09:45:00',2.38),('15128','2013-06-18','09:50:00',2.44),('15128','2013-06-18','09:55:00',2.49),('15128','2013-06-18','10:00:00',2.52),('15128','2013-06-18','10:05:00',2.56),('15128','2013-06-18','10:10:00',2.65),('15128','2013-06-18','10:15:00',2.65),('15128','2013-06-18','10:20:00',2.69),('15128','2013-06-18','10:25:00',2.78),('15128','2013-06-18','10:30:00',2.81),('15128','2013-06-18','10:35:00',2.86),('15128','2013-06-18','10:40:00',2.9),('15128','2013-06-18','10:45:00',2.94),('15128','2013-06-18','10:50:00',3.03),('15128','2013-06-18','10:55:00',3),('15128','2013-06-18','11:00:00',3.06),('15128','2013-06-18','11:05:00',3.03),('15128','2013-06-18','11:10:00',3.13),('15128','2013-06-18','11:15:00',3.23),('15128','2013-06-18','11:20:00',3.29),('15128','2013-06-18','11:25:00',3.37),('15128','2013-06-18','11:30:00',3.25),('15128','2013-06-18','11:35:00',3.37),('15128','2013-06-18','11:40:00',3.55),('15128','2013-06-18','11:45:00',3.61),('15128','2013-06-18','11:50:00',3.74),('15128','2013-06-18','11:55:00',3.77),('15128','2013-06-18','12:00:00',3.82),('15128','2013-06-18','12:05:00',3.9),('15128','2013-06-18','12:10:00',3.93),('15128','2013-06-18','12:15:00',3.98),('15128','2013-06-18','12:20:00',4),('15128','2013-06-18','12:25:00',4.02),('15128','2013-06-18','12:30:00',4.05),('15128','2013-06-18','12:35:00',4.1),('15128','2013-06-18','12:40:00',4.08),('15128','2013-06-18','12:45:00',4.11),('15128','2013-06-18','12:50:00',4.12),('15128','2013-06-18','12:55:00',4.11),('15128','2013-06-18','13:00:00',4.19),('15128','2013-06-18','13:05:00',4.2),('15128','2013-06-18','13:10:00',4.24),('15128','2013-06-18','13:15:00',4.26),('15128','2013-06-18','13:20:00',4.28),('15128','2013-06-18','13:25:00',4.28),('15128','2013-06-18','13:30:00',4.29),('15128','2013-06-18','13:35:00',4.29),('15128','2013-06-18','13:40:00',4.31),('15128','2013-06-18','13:45:00',4.35),('15128','2013-06-18','13:50:00',4.35),('15128','2013-06-18','13:55:00',4.34),('15128','2013-06-18','14:00:00',4.34),('15128','2013-06-18','14:05:00',4.35),('15128','2013-06-18','14:10:00',4.32),('15128','2013-06-18','14:15:00',4.31),('15128','2013-06-18','14:20:00',4.3),('15128','2013-06-18','14:25:00',4.26),('15128','2013-06-18','14:30:00',4.26),('15128','2013-06-18','14:35:00',4.27),('15128','2013-06-18','14:40:00',4.26),('15128','2013-06-18','14:45:00',4.25),('15128','2013-06-18','14:50:00',4.22),('15128','2013-06-18','14:55:00',4.21),('15128','2013-06-18','15:00:00',4.19),('15128','2013-06-18','15:05:00',4.17),('15128','2013-06-18','15:10:00',4.12),('15128','2013-06-18','15:15:00',4.09),('15128','2013-06-18','15:20:00',4.06),('15128','2013-06-18','15:25:00',4.02),('15128','2013-06-18','15:30:00',4.01),('15128','2013-06-18','15:35:00',3.97),('15128','2013-06-18','15:40:00',3.95),('15128','2013-06-18','15:45:00',3.92),('15128','2013-06-18','15:50:00',3.87),('15128','2013-06-18','15:55:00',3.83),('15128','2013-06-18','16:00:00',3.79),('15128','2013-06-18','16:05:00',3.75),('15128','2013-06-18','16:10:00',3.73),('15128','2013-06-18','16:15:00',3.68),('15128','2013-06-18','16:20:00',3.65),('15128','2013-06-18','16:25:00',3.6),('15128','2013-06-18','16:30:00',3.56),('15128','2013-06-18','16:35:00',3.53),('15128','2013-06-18','16:40:00',3.47),('15128','2013-06-18','16:45:00',3.42),('15128','2013-06-18','16:50:00',3.37),('15128','2013-06-18','16:55:00',3.33),('15128','2013-06-18','17:00:00',3.27),('15128','2013-06-18','17:05:00',3.2),('15128','2013-06-18','17:10:00',3.15),('15128','2013-06-18','17:15:00',3.08),('15128','2013-06-18','17:20:00',3),('15128','2013-06-18','17:25:00',2.94),('15128','2013-06-18','17:30:00',2.88),('15128','2013-06-18','17:35:00',2.81),('15128','2013-06-18','17:40:00',2.75),('15128','2013-06-18','17:45:00',2.67),('15128','2013-06-18','17:50:00',2.59),('15128','2013-06-18','17:55:00',2.47),('15128','2013-06-18','18:00:00',2.38),('15128','2013-06-18','18:05:00',2.27),('15128','2013-06-18','18:10:00',2.16),('15128','2013-06-18','18:15:00',2.04),('15128','2013-06-18','18:20:00',1.94),('15128','2013-06-18','18:25:00',1.88),('15128','2013-06-18','18:30:00',1.78),('15128','2013-06-18','18:35:00',1.7),('15128','2013-06-18','18:40:00',1.63),('15128','2013-06-18','18:45:00',1.59),('15128','2013-06-18','18:50:00',1.55),('15128','2013-06-18','18:55:00',1.45),('15128','2013-06-18','19:00:00',1.36),('15128','2013-06-18','19:05:00',1.26),('15128','2013-06-18','19:10:00',1.18),('15128','2013-06-18','19:15:00',1.09),('15128','2013-06-17','08:05:00',1.03),('15128','2013-06-17','08:10:00',1.07),('15128','2013-06-17','08:15:00',1.13),('15128','2013-06-17','08:20:00',1.2),('15128','2013-06-17','08:25:00',1.29),('15128','2013-06-17','08:30:00',1.36),('15128','2013-06-17','08:35:00',1.41),('15128','2013-06-17','08:40:00',1.48),('15128','2013-06-17','08:45:00',1.53),('15128','2013-06-17','08:50:00',1.64),('15128','2013-06-17','08:55:00',1.75),('15128','2013-06-17','09:00:00',1.81),('15128','2013-06-17','09:05:00',1.9),('15128','2013-06-17','09:10:00',1.95),('15128','2013-06-17','09:15:00',1.99),('15128','2013-06-17','09:20:00',2.01),('15128','2013-06-17','09:25:00',2.09),('15128','2013-06-17','09:30:00',2.21),('15128','2013-06-17','09:35:00',2.27),('15128','2013-06-17','09:40:00',2.33),('15128','2013-06-17','09:45:00',2.39),('15128','2013-06-17','09:50:00',2.45),('15128','2013-06-17','09:55:00',2.5),('15128','2013-06-17','10:00:00',2.54),('15128','2013-06-17','10:05:00',2.57),('15128','2013-06-17','10:10:00',2.63),('15128','2013-06-17','10:15:00',2.68),('15128','2013-06-17','10:20:00',2.71),('15128','2013-06-17','10:25:00',2.8),('15128','2013-06-17','10:30:00',2.83),('15128','2013-06-17','10:35:00',2.88),('15128','2013-06-17','10:40:00',2.97),('15128','2013-06-17','10:45:00',3),('15128','2013-06-17','10:50:00',3.09),('15128','2013-06-17','10:55:00',3.07),('15128','2013-06-17','11:00:00',3.13),('15128','2013-06-17','11:05:00',3.1),('15128','2013-06-17','11:10:00',3.21),('15128','2013-06-17','11:15:00',3.29),('15128','2013-06-17','11:20:00',3.35),('15128','2013-06-17','11:25:00',3.42),('15128','2013-06-17','11:30:00',3.37),('15128','2013-06-17','11:35:00',3.42),('15128','2013-06-17','11:40:00',3.61),('15128','2013-06-17','11:45:00',3.7),('15128','2013-06-17','11:50:00',3.73),('15128','2013-06-17','11:55:00',3.73),('15128','2013-06-17','12:00:00',3.74),('15128','2013-06-17','12:05:00',3.8),('15128','2013-06-17','12:10:00',3.82),('15128','2013-06-17','12:15:00',3.85),('15128','2013-06-17','12:20:00',3.89),('15128','2013-06-17','12:25:00',3.89),('15128','2013-06-17','12:30:00',3.89),('15128','2013-06-17','12:35:00',3.84),('15128','2013-06-17','12:40:00',3.91),('15128','2013-06-17','12:45:00',3.87),('15128','2013-06-17','12:50:00',3.84),('15128','2013-06-17','12:55:00',4),('15128','2013-06-17','13:00:00',3.95),('15128','2013-06-17','13:05:00',3.73),('15128','2013-06-17','13:10:00',3.67),('15128','2013-06-17','13:15:00',3.98),('15128','2013-06-17','13:20:00',4.2),('15128','2013-06-17','13:25:00',4.22),('15128','2013-06-17','13:30:00',4.2),('15128','2013-06-17','13:35:00',4.2),('15128','2013-06-17','13:40:00',4.14),('15128','2013-06-17','13:45:00',4.17),('15128','2013-06-17','13:50:00',4.22),('15128','2013-06-17','13:55:00',4.16),('15128','2013-06-17','14:00:00',4.29),('15128','2013-06-17','14:05:00',4.4),('15128','2013-06-17','14:10:00',4.46),('15128','2013-06-17','14:15:00',4.48),('15128','2013-06-17','14:20:00',4.41),('15128','2013-06-17','14:25:00',4.39),('15128','2013-06-17','14:30:00',4.47),('15128','2013-06-17','14:35:00',4.42),('15128','2013-06-17','14:40:00',3.31),('15128','2013-06-17','14:45:00',3.77),('15128','2013-06-17','14:50:00',4.43),('15128','2013-06-17','14:55:00',4.43),('15128','2013-06-17','15:00:00',4.39),('15128','2013-06-17','15:05:00',4.33),('15128','2013-06-17','15:10:00',4.29),('15128','2013-06-17','15:15:00',4.18),('15128','2013-06-17','15:20:00',4.13),('15128','2013-06-17','15:25:00',4.06),('15128','2013-06-17','15:30:00',4.03),('15128','2013-06-17','15:35:00',4.01),('15128','2013-06-17','15:40:00',3.96),('15128','2013-06-17','15:45:00',3.95),('15128','2013-06-17','15:50:00',3.91),('15128','2013-06-17','15:55:00',3.88),('15128','2013-06-17','16:00:00',3.91),('15128','2013-06-17','16:05:00',3.88),('15128','2013-06-17','16:10:00',3.84),('15128','2013-06-17','16:15:00',3.83),('15128','2013-06-17','16:20:00',3.81),('15128','2013-06-17','16:25:00',3.81),('15128','2013-06-17','16:30:00',3.67),('15128','2013-06-17','16:35:00',3.42),('15128','2013-06-17','16:40:00',3.35),('15128','2013-06-17','16:45:00',3.32),('15128','2013-06-17','16:50:00',3.45),('15128','2013-06-17','16:55:00',3.34),('15128','2013-06-17','17:00:00',3.29),('15128','2013-06-17','17:05:00',3.24),('15128','2013-06-17','17:10:00',3.04),('15128','2013-06-17','17:15:00',3.09),('15128','2013-06-17','17:20:00',3),('15128','2013-06-17','17:25:00',2.91),('15128','2013-06-17','17:30:00',2.87),('15128','2013-06-17','17:35:00',2.79),('15128','2013-06-17','17:40:00',2.71),('15128','2013-06-17','17:45:00',2.63),('15128','2013-06-17','17:50:00',2.56),('15128','2013-06-17','17:55:00',2.42),('15128','2013-06-17','18:00:00',2.32),('15128','2013-06-17','18:05:00',2.29),('15128','2013-06-17','18:10:00',2.14),('15128','2013-06-17','18:15:00',2.06),('15128','2013-06-17','18:20:00',1.99),('15128','2013-06-17','18:25:00',1.93),('15128','2013-06-17','18:30:00',1.83),('15128','2013-06-17','18:35:00',1.73),('15128','2013-06-17','18:40:00',1.64),('15128','2013-06-17','18:45:00',1.6),('15128','2013-06-17','18:50:00',1.54),('15128','2013-06-17','18:55:00',1.45),('15128','2013-06-17','19:00:00',1.39),('15128','2013-06-17','19:05:00',1.3),('15128','2013-06-17','19:10:00',1.22),('15128','2013-06-17','19:15:00',1.12),('15128','2013-06-16','08:00:00',1.03),('15128','2013-06-16','08:05:00',1.09),('15128','2013-06-16','08:10:00',1.13),('15128','2013-06-16','08:15:00',1.21),('15128','2013-06-16','08:20:00',1.31),('15128','2013-06-16','08:25:00',1.39),('15128','2013-06-16','08:30:00',1.46),('15128','2013-06-16','08:35:00',1.51),('15128','2013-06-16','08:40:00',1.59),('15128','2013-06-16','08:45:00',1.65),('15128','2013-06-16','08:50:00',1.73),('15128','2013-06-16','08:55:00',1.84),('15128','2013-06-16','09:00:00',1.9),('15128','2013-06-16','09:05:00',1.98),('15128','2013-06-16','09:10:00',2.06),('15128','2013-06-16','09:15:00',2.1),('15128','2013-06-16','09:20:00',2.1),('15128','2013-06-16','09:25:00',2.24),('15128','2013-06-16','09:30:00',2.32),('15128','2013-06-16','09:35:00',2.38),('15128','2013-06-16','09:40:00',2.43),('15128','2013-06-16','09:45:00',2.49),('15128','2013-06-16','09:50:00',2.55),('15128','2013-06-16','09:55:00',2.61),('15128','2013-06-16','10:00:00',2.66),('15128','2013-06-16','10:05:00',2.67),('15128','2013-06-16','10:10:00',2.73),('15128','2013-06-16','10:15:00',2.77),('15128','2013-06-16','10:20:00',2.81),('15128','2013-06-16','10:25:00',2.88),('15128','2013-06-16','10:30:00',2.96),('15128','2013-06-16','10:35:00',2.97),('15128','2013-06-16','10:40:00',3.04),('15128','2013-06-16','10:45:00',3.08),('15128','2013-06-16','10:50:00',3.16),('15128','2013-06-16','10:55:00',3.15),('15128','2013-06-16','11:00:00',3.25),('15128','2013-06-16','11:05:00',3.21),('15128','2013-06-16','11:10:00',3.3),('15128','2013-06-16','11:15:00',3.4),('15128','2013-06-16','11:20:00',3.44),('15128','2013-06-16','11:25:00',3.5),('15128','2013-06-16','11:30:00',3.4),('15128','2013-06-16','11:35:00',3.47),('15128','2013-06-16','11:40:00',3.63),('15128','2013-06-16','11:45:00',3.73),('15128','2013-06-16','11:50:00',3.83),('15128','2013-06-16','11:55:00',3.91),('15128','2013-06-16','12:00:00',3.97),('15128','2013-06-16','12:05:00',4.01),('15128','2013-06-16','12:10:00',4.08),('15128','2013-06-16','12:15:00',4.09),('15128','2013-06-16','12:20:00',4.11),('15128','2013-06-16','12:25:00',4.14),('15128','2013-06-16','12:30:00',4.17),('15128','2013-06-16','12:35:00',4.17),('15128','2013-06-16','12:40:00',4.19),('15128','2013-06-16','12:45:00',4.22),('15128','2013-06-16','12:50:00',4.25),('15128','2013-06-16','12:55:00',4.25),('15128','2013-06-16','13:00:00',4.28),('15128','2013-06-16','13:05:00',4.29),('15128','2013-06-16','13:10:00',4.32),('15128','2013-06-16','13:15:00',4.3),('15128','2013-06-16','13:20:00',4.28),('15128','2013-06-16','13:25:00',4.32),('15128','2013-06-16','13:30:00',4.3),('15128','2013-06-16','13:35:00',4.31),('15128','2013-06-16','13:40:00',4.32),('15128','2013-06-16','13:45:00',4.34),('15128','2013-06-16','13:50:00',4.34),('15128','2013-06-16','13:55:00',4.32),('15128','2013-06-16','14:00:00',4.33),('15128','2013-06-16','14:05:00',4.32),('15128','2013-06-16','14:10:00',4.32),('15128','2013-06-16','14:15:00',4.31),('15128','2013-06-16','14:20:00',4.31),('15128','2013-06-16','14:25:00',4.28),('15128','2013-06-16','14:30:00',4.29),('15128','2013-06-16','14:35:00',4.28),('15128','2013-06-16','14:40:00',4.27),('15128','2013-06-16','14:45:00',4.25),('15128','2013-06-16','14:50:00',4.22),('15128','2013-06-16','14:55:00',4.22),('15128','2013-06-16','15:00:00',4.22),('15128','2013-06-16','15:05:00',4.2),('15128','2013-06-16','15:10:00',4.18),('15128','2013-06-16','15:15:00',4.15),('15128','2013-06-16','15:20:00',4.15),('15128','2013-06-16','15:25:00',4.11),('15128','2013-06-16','15:30:00',4.09),('15128','2013-06-16','15:35:00',4.06),('15128','2013-06-16','15:40:00',4.02),('15128','2013-06-16','15:45:00',4.01),('15128','2013-06-16','15:50:00',3.98),('15128','2013-06-16','15:55:00',3.95),('15128','2013-06-16','16:00:00',3.9),('15128','2013-06-16','16:05:00',3.86),('15128','2013-06-16','16:10:00',3.8),('15128','2013-06-16','16:15:00',3.77),('15128','2013-06-16','16:20:00',3.72),('15128','2013-06-16','16:25:00',3.67),('15128','2013-06-16','16:30:00',3.65),('15128','2013-06-16','16:35:00',3.6),('15128','2013-06-16','16:40:00',3.55),('15128','2013-06-16','16:45:00',3.5),('15128','2013-06-16','16:50:00',3.45),('15128','2013-06-16','16:55:00',3.39),('15128','2013-06-16','17:00:00',3.33),('15128','2013-06-16','17:05:00',3.26),('15128','2013-06-16','17:10:00',3.19),('15128','2013-06-16','17:15:00',3.13),('15128','2013-06-16','17:20:00',3.06),('15128','2013-06-16','17:25:00',3.01),('15128','2013-06-16','17:30:00',2.96),('15128','2013-06-16','17:35:00',2.9),('15128','2013-06-16','17:40:00',2.85),('15128','2013-06-16','17:45:00',2.78),('15128','2013-06-16','17:50:00',2.72),('15128','2013-06-16','17:55:00',2.58),('15128','2013-06-16','18:00:00',2.48),('15128','2013-06-16','18:05:00',2.42),('15128','2013-06-16','18:10:00',2.29),('15128','2013-06-16','18:15:00',2.19),('15128','2013-06-16','18:20:00',2.11),('15128','2013-06-16','18:25:00',2.02),('15128','2013-06-16','18:30:00',1.92),('15128','2013-06-16','18:35:00',1.8),('15128','2013-06-16','18:40:00',1.66),('15128','2013-06-16','18:45:00',1.7),('15128','2013-06-16','18:50:00',1.63),('15128','2013-06-16','18:55:00',1.63),('15128','2013-06-16','19:00:00',1.54),('15128','2013-06-16','19:05:00',1.45),('15128','2013-06-16','19:10:00',1.36),('15128','2013-06-16','19:15:00',1.23),('15128','2013-06-16','19:20:00',1.04),('15128','2013-06-15','08:00:00',1.06),('15128','2013-06-15','08:05:00',1.11),('15128','2013-06-15','08:10:00',1.15),('15128','2013-06-15','08:15:00',1.23),('15128','2013-06-15','08:20:00',1.33),('15128','2013-06-15','08:25:00',1.41),('15128','2013-06-15','08:30:00',1.46),('15128','2013-06-15','08:35:00',1.52),('15128','2013-06-15','08:40:00',1.6),('15128','2013-06-15','08:45:00',1.67),('15128','2013-06-15','08:50:00',1.77),('15128','2013-06-15','08:55:00',1.89),('15128','2013-06-15','09:00:00',1.96),('15128','2013-06-15','09:05:00',2.04),('15128','2013-06-15','09:10:00',2.12),('15128','2013-06-15','09:15:00',2.13),('15128','2013-06-15','09:20:00',2.16),('15128','2013-06-15','09:25:00',2.3),('15128','2013-06-15','09:30:00',2.37),('15128','2013-06-15','09:35:00',2.43),('15128','2013-06-15','09:40:00',2.46),('15128','2013-06-15','09:45:00',2.5),('15128','2013-06-15','09:50:00',2.56),('15128','2013-06-15','09:55:00',2.6),('15128','2013-06-15','10:00:00',2.64),('15128','2013-06-15','10:05:00',2.72),('15128','2013-06-15','10:10:00',2.77),('15128','2013-06-15','10:15:00',2.79),('15128','2013-06-15','10:20:00',2.83),('15128','2013-06-15','10:25:00',2.92),('15128','2013-06-15','10:30:00',3.01),('15128','2013-06-15','10:35:00',3.02),('15128','2013-06-15','10:40:00',3.09),('15128','2013-06-15','10:45:00',3.13),('15128','2013-06-15','10:50:00',3.25),('15128','2013-06-15','10:55:00',3.22),('15128','2013-06-15','11:00:00',3.37),('15128','2013-06-15','11:05:00',3.3),('15128','2013-06-15','11:10:00',3.41),('15128','2013-06-15','11:15:00',3.47),('15128','2013-06-15','11:20:00',3.53),('15128','2013-06-15','11:25:00',3.55),('15128','2013-06-15','11:30:00',3.49),('15128','2013-06-15','11:35:00',3.58),('15128','2013-06-15','11:40:00',3.76),('15128','2013-06-15','11:45:00',3.83),('15128','2013-06-15','11:50:00',3.91),('15128','2013-06-15','11:55:00',3.95),('15128','2013-06-15','12:00:00',4),('15128','2013-06-15','12:05:00',4.06),('15128','2013-06-15','12:10:00',4.11),('15128','2013-06-15','12:15:00',4.14),('15128','2013-06-15','12:20:00',4.18),('15128','2013-06-15','12:25:00',4.19),('15128','2013-06-15','12:30:00',4.26),('15128','2013-06-15','12:35:00',4.29),('15128','2013-06-15','12:40:00',4.34),('15128','2013-06-15','12:45:00',4.37),('15128','2013-06-15','12:50:00',4.37),('15128','2013-06-15','12:55:00',4.39),('15128','2013-06-15','13:00:00',4.39),('15128','2013-06-15','13:05:00',4.42),('15128','2013-06-15','13:10:00',4.43),('15128','2013-06-15','13:15:00',4.46),('15128','2013-06-15','13:20:00',4.45),('15128','2013-06-15','13:25:00',4.46),('15128','2013-06-15','13:30:00',4.49),('15128','2013-06-15','13:35:00',4.49),('15128','2013-06-15','13:40:00',4.48),('15128','2013-06-15','13:45:00',4.47),('15128','2013-06-15','13:50:00',4.49),('15128','2013-06-15','13:55:00',4.49),('15128','2013-06-15','14:00:00',4.5),('15128','2013-06-15','14:05:00',4.52),('15128','2013-06-15','14:10:00',4.51),('15128','2013-06-15','14:15:00',4.47),('15128','2013-06-15','14:20:00',4.45),('15128','2013-06-15','14:25:00',4.44),('15128','2013-06-15','14:30:00',4.45),('15128','2013-06-15','14:35:00',4.45),('15128','2013-06-15','14:40:00',4.44),('15128','2013-06-15','14:45:00',4.43),('15128','2013-06-15','14:50:00',4.39),('15128','2013-06-15','14:55:00',4.38),('15128','2013-06-15','15:00:00',4.37),('15128','2013-06-15','15:05:00',4.34),('15128','2013-06-15','15:10:00',4.3),('15128','2013-06-15','15:15:00',4.28),('15128','2013-06-15','15:20:00',4.26),('15128','2013-06-15','15:25:00',4.22),('15128','2013-06-15','15:30:00',4.18),('15128','2013-06-15','15:35:00',4.16),('15128','2013-06-15','15:40:00',4.12),('15128','2013-06-15','15:45:00',4.09),('15128','2013-06-15','15:50:00',4.05),('15128','2013-06-15','15:55:00',4.02),('15128','2013-06-15','16:00:00',3.98),('15128','2013-06-15','16:05:00',3.92),('15128','2013-06-15','16:10:00',3.88),('15128','2013-06-15','16:15:00',3.83),('15128','2013-06-15','16:20:00',3.79),('15128','2013-06-15','16:25:00',3.74),('15128','2013-06-15','16:30:00',3.69),('15128','2013-06-15','16:35:00',3.64),('15128','2013-06-15','16:40:00',3.59),('15128','2013-06-15','16:45:00',3.54),('15128','2013-06-15','16:50:00',3.47),('15128','2013-06-15','16:55:00',3.41),('15128','2013-06-15','17:00:00',3.34),('15128','2013-06-15','17:05:00',3.29),('15128','2013-06-15','17:10:00',3.22),('15128','2013-06-15','17:15:00',3.15),('15128','2013-06-15','17:20:00',3.08),('15128','2013-06-15','17:25:00',3.02),('15128','2013-06-15','17:30:00',2.94),('15128','2013-06-15','17:35:00',2.86),('15128','2013-06-15','17:40:00',2.8),('15128','2013-06-15','17:45:00',2.72),('15128','2013-06-15','17:50:00',2.64),('15128','2013-06-15','17:55:00',2.54),('15128','2013-06-15','18:00:00',2.41),('15128','2013-06-15','18:05:00',2.33),('15128','2013-06-15','18:10:00',2.18),('15128','2013-06-15','18:15:00',2.08),('15128','2013-06-15','18:20:00',2.01),('15128','2013-06-15','18:25:00',1.93),('15128','2013-06-15','18:30:00',1.83),('15128','2013-06-15','18:35:00',1.75),('15128','2013-06-15','18:40:00',1.66),('15128','2013-06-15','18:45:00',1.61),('15128','2013-06-15','18:50:00',1.56),('15128','2013-06-15','18:55:00',1.46),('15128','2013-06-15','19:00:00',1.38),('15128','2013-06-15','19:05:00',1.29),('15128','2013-06-15','19:10:00',1.21),('15128','2013-06-15','19:15:00',1.09),('15128','2013-06-14','08:00:00',1.05),('15128','2013-06-14','08:05:00',1.13),('15128','2013-06-14','08:10:00',1.17),('15128','2013-06-14','08:15:00',1.23),('15128','2013-06-14','08:20:00',1.31),('15128','2013-06-14','08:25:00',1.37),('15128','2013-06-14','08:30:00',1.5),('15128','2013-06-14','08:35:00',1.62),('15128','2013-06-14','08:40:00',1.81),('15128','2013-06-14','08:45:00',1.74),('15128','2013-06-14','08:50:00',2.03),('15128','2013-06-14','08:55:00',2.02),('15128','2013-06-14','09:00:00',1.75),('15128','2013-06-14','09:05:00',1.93),('15128','2013-06-14','09:10:00',1.57),('15128','2013-06-14','09:15:00',2.13),('15128','2013-06-14','09:20:00',2.1),('15128','2013-06-14','09:25:00',2.03),('15128','2013-06-14','09:30:00',2.26),('15128','2013-06-14','09:35:00',2.34),('15128','2013-06-14','09:40:00',2.39),('15128','2013-06-14','09:45:00',2.51),('15128','2013-06-14','09:50:00',2.62),('15128','2013-06-14','09:55:00',2.5),('15128','2013-06-14','10:00:00',2.01),('15128','2013-06-14','10:05:00',2.74),('15128','2013-06-14','10:10:00',2.86),('15128','2013-06-14','10:15:00',2.82),('15128','2013-06-14','10:20:00',2.84),('15128','2013-06-14','10:25:00',2.84),('15128','2013-06-14','10:30:00',3.05),('15128','2013-06-14','10:35:00',3),('15128','2013-06-14','10:40:00',3.07),('15128','2013-06-14','10:45:00',2.99),('15128','2013-06-14','10:50:00',3.08),('15128','2013-06-14','10:55:00',3.29),('15128','2013-06-14','11:00:00',3.43),('15128','2013-06-14','11:05:00',3.4),('15128','2013-06-14','11:10:00',3.6),('15128','2013-06-14','11:15:00',3.57),('15128','2013-06-14','11:20:00',3.79),('15128','2013-06-14','11:25:00',3.8),('15128','2013-06-14','11:30:00',3.7),('15128','2013-06-14','11:35:00',3.76),('15128','2013-06-14','11:40:00',3.83),('15128','2013-06-14','11:45:00',3.97),('15128','2013-06-14','11:50:00',4),('15128','2013-06-14','11:55:00',4.06),('15128','2013-06-14','12:00:00',4.11),('15128','2013-06-14','12:05:00',4.14),('15128','2013-06-14','12:10:00',4.15),('15128','2013-06-14','12:15:00',4.22),('15128','2013-06-14','12:20:00',4.24),('15128','2013-06-14','12:25:00',4.28),('15128','2013-06-14','12:30:00',4.3),('15128','2013-06-14','12:35:00',4.3),('15128','2013-06-14','12:40:00',4.36),('15128','2013-06-14','12:45:00',4.35),('15128','2013-06-14','12:50:00',4.37),('15128','2013-06-14','12:55:00',4.36),('15128','2013-06-14','13:00:00',4.34),('15128','2013-06-14','13:05:00',4.42),('15128','2013-06-14','13:10:00',4.4),('15128','2013-06-14','13:15:00',4.34),('15128','2013-06-14','13:20:00',4.31),('15128','2013-06-14','13:25:00',4.41),('15128','2013-06-14','13:30:00',4.43),('15128','2013-06-14','13:35:00',4.46),('15128','2013-06-14','13:40:00',4.46),('15128','2013-06-14','13:45:00',4.48),('15128','2013-06-14','13:50:00',4.49),('15128','2013-06-14','13:55:00',4.48),('15128','2013-06-14','14:00:00',4.47),('15128','2013-06-14','14:05:00',4.5),('15128','2013-06-14','14:10:00',4.46),('15128','2013-06-14','14:15:00',4.49),('15128','2013-06-14','14:20:00',4.49),('15128','2013-06-14','14:25:00',4.48),('15128','2013-06-14','14:30:00',4.46),('15128','2013-06-14','14:35:00',4.46),('15128','2013-06-14','14:40:00',4.45),('15128','2013-06-14','14:45:00',4.41),('15128','2013-06-14','14:50:00',4.4),('15128','2013-06-14','14:55:00',4.38),('15128','2013-06-14','15:00:00',4.34),('15128','2013-06-14','15:05:00',4.32),('15128','2013-06-14','15:10:00',4.31),('15128','2013-06-14','15:15:00',4.29),('15128','2013-06-14','15:20:00',4.25),('15128','2013-06-14','15:25:00',4.21),('15128','2013-06-14','15:30:00',4.19),('15128','2013-06-14','15:35:00',4.16),('15128','2013-06-14','15:40:00',4.14),('15128','2013-06-14','15:45:00',4.08),('15128','2013-06-14','15:50:00',4.01),('15128','2013-06-14','15:55:00',3.98),('15128','2013-06-14','16:00:00',3.95),('15128','2013-06-14','16:05:00',3.92),('15128','2013-06-14','16:10:00',3.87),('15128','2013-06-14','16:15:00',3.83),('15128','2013-06-14','16:20:00',3.78),('15128','2013-06-14','16:25:00',3.73),('15128','2013-06-14','16:30:00',3.67),('15128','2013-06-14','16:35:00',3.61),('15128','2013-06-14','16:40:00',3.55),('15128','2013-06-14','16:45:00',3.47),('15128','2013-06-14','16:50:00',3.45),('15128','2013-06-14','16:55:00',3.37),('15128','2013-06-14','17:00:00',3.33),('15128','2013-06-14','17:05:00',3.25),('15128','2013-06-14','17:10:00',3.21),('15128','2013-06-14','17:15:00',3.07),('15128','2013-06-14','17:20:00',3.02),('15128','2013-06-14','17:25:00',2.95),('15128','2013-06-14','17:30:00',2.88),('15128','2013-06-14','17:35:00',2.81),('15128','2013-06-14','17:40:00',2.75),('15128','2013-06-14','17:45:00',2.65),('15128','2013-06-14','17:50:00',2.59),('15128','2013-06-14','17:55:00',2.43),('15128','2013-06-14','18:00:00',2.33),('15128','2013-06-14','18:05:00',2.29),('15128','2013-06-14','18:10:00',2.14),('15128','2013-06-14','18:15:00',2.04),('15128','2013-06-14','18:20:00',1.96),('15128','2013-06-14','18:25:00',1.87),('15128','2013-06-14','18:30:00',1.77),('15128','2013-06-14','18:35:00',1.71),('15128','2013-06-14','18:40:00',1.64),('15128','2013-06-14','18:45:00',1.58),('15128','2013-06-14','18:50:00',1.55),('15128','2013-06-14','18:55:00',1.45),('15128','2013-06-14','19:00:00',1.38),('15128','2013-06-14','19:05:00',1.28),('15128','2013-06-14','19:10:00',1.18),('15128','2013-06-14','19:15:00',1.04),('15128','2013-06-13','07:55:00',1.03),('15128','2013-06-13','08:00:00',1.11),('15128','2013-06-13','08:05:00',1.18),('15128','2013-06-13','08:10:00',1.23),('15128','2013-06-13','08:15:00',1.3),('15128','2013-06-13','08:20:00',1.4),('15128','2013-06-13','08:25:00',1.49),('15128','2013-06-13','08:30:00',1.57),('15128','2013-06-13','08:35:00',1.64),('15128','2013-06-13','08:40:00',1.71),('15128','2013-06-13','08:45:00',1.78),('15128','2013-06-13','08:50:00',1.88),('15128','2013-06-13','08:55:00',2),('15128','2013-06-13','09:00:00',2.07),('15128','2013-06-13','09:05:00',2.13),('15128','2013-06-13','09:10:00',2.19),('15128','2013-06-13','09:15:00',2.22),('15128','2013-06-13','09:20:00',2.2),('15128','2013-06-13','09:25:00',2.36),('15128','2013-06-13','09:30:00',2.46),('15128','2013-06-13','09:35:00',2.53),('15128','2013-06-13','09:40:00',2.6),('15128','2013-06-13','09:45:00',2.66),('15128','2013-06-13','09:50:00',2.71),('15128','2013-06-13','09:55:00',2.74),('15128','2013-06-13','10:00:00',2.75),('15128','2013-06-13','10:05:00',2.79),('15128','2013-06-13','10:10:00',2.88),('15128','2013-06-13','10:15:00',2.94),('15128','2013-06-13','10:20:00',2.96),('15128','2013-06-13','10:25:00',3.01),('15128','2013-06-13','10:30:00',2.97),('15128','2013-06-13','10:35:00',3.12),('15128','2013-06-13','10:40:00',3.19),('15128','2013-06-13','10:45:00',3.2),('15128','2013-06-13','10:50:00',3.31),('15128','2013-06-13','10:55:00',3.31),('15128','2013-06-13','11:00:00',3.41),('15128','2013-06-13','11:05:00',3.36),('15128','2013-06-13','11:10:00',3.41),('15128','2013-06-13','11:15:00',3.52),('15128','2013-06-13','11:20:00',3.65),('15128','2013-06-13','11:25:00',3.65),('15128','2013-06-13','11:30:00',3.57),('15128','2013-06-13','11:35:00',3.65),('15128','2013-06-13','11:40:00',3.85),('15128','2013-06-13','11:45:00',3.93),('15128','2013-06-13','11:50:00',4.02),('15128','2013-06-13','11:55:00',4.04),('15128','2013-06-13','12:00:00',4.03),('15128','2013-06-13','12:05:00',4.11),('15128','2013-06-13','12:10:00',4.16),('15128','2013-06-13','12:15:00',4.19),('15128','2013-06-13','12:20:00',4.28),('15128','2013-06-13','12:25:00',4.35),('15128','2013-06-13','12:30:00',4.34),('15128','2013-06-13','12:35:00',4.39),('15128','2013-06-13','12:40:00',4.38),('15128','2013-06-13','12:45:00',4.42),('15128','2013-06-13','12:50:00',4.42),('15128','2013-06-13','12:55:00',4.4),('15128','2013-06-13','13:00:00',4.35),('15128','2013-06-13','13:05:00',4.38),('15128','2013-06-13','13:10:00',4.41),('15128','2013-06-13','13:15:00',4.43),('15128','2013-06-13','13:20:00',4.47),('15128','2013-06-13','13:25:00',4.53),('15128','2013-06-13','13:30:00',4.5),('15128','2013-06-13','13:35:00',4.5),('15128','2013-06-13','13:40:00',4.53),('15128','2013-06-13','13:45:00',4.55),('15128','2013-06-13','13:50:00',4.53),('15128','2013-06-13','13:55:00',4.51),('15128','2013-06-13','14:00:00',4.46),('15128','2013-06-13','14:05:00',4.46),('15128','2013-06-13','14:10:00',4.5),('15128','2013-06-13','14:15:00',4.5),('15128','2013-06-13','14:20:00',4.46),('15128','2013-06-13','14:25:00',4.44),('15128','2013-06-13','14:30:00',4.47),('15128','2013-06-13','14:35:00',4.51),('15128','2013-06-13','14:40:00',4.52),('15128','2013-06-13','14:45:00',4.47),('15128','2013-06-13','14:50:00',4.46),('15128','2013-06-13','14:55:00',4.38),('15128','2013-06-13','15:00:00',4.36),('15128','2013-06-13','15:05:00',4.36),('15128','2013-06-13','15:10:00',4.36),('15128','2013-06-13','15:15:00',4.36),('15128','2013-06-13','15:20:00',4.33),('15128','2013-06-13','15:25:00',4.34),('15128','2013-06-13','15:30:00',4.32),('15128','2013-06-13','15:35:00',4.3),('15128','2013-06-13','15:40:00',4.25),('15128','2013-06-13','15:45:00',4.22),('15128','2013-06-13','15:50:00',4.19),('15128','2013-06-13','15:55:00',4.14),('15128','2013-06-13','16:00:00',4.06),('15128','2013-06-13','16:05:00',4.03),('15128','2013-06-13','16:10:00',4),('15128','2013-06-13','16:15:00',3.95),('15128','2013-06-13','16:20:00',3.9),('15128','2013-06-13','16:25:00',3.85),('15128','2013-06-13','16:30:00',3.8),('15128','2013-06-13','16:35:00',3.75),('15128','2013-06-13','16:40:00',3.68),('15128','2013-06-13','16:45:00',3.63),('15128','2013-06-13','16:50:00',3.56),('15128','2013-06-13','16:55:00',3.48),('15128','2013-06-13','17:00:00',3.43),('15128','2013-06-13','17:05:00',3.18),('15128','2013-06-13','17:10:00',3.24),('15128','2013-06-13','17:15:00',3.18),('15128','2013-06-13','17:20:00',3.11),('15128','2013-06-13','17:25:00',2.98),('15128','2013-06-13','17:30:00',3),('15128','2013-06-13','17:35:00',2.97),('15128','2013-06-13','17:40:00',2.91),('15128','2013-06-13','17:45:00',2.8),('15128','2013-06-13','17:50:00',2.73),('15128','2013-06-13','17:55:00',2.56),('15128','2013-06-13','18:00:00',2.44),('15128','2013-06-13','18:05:00',2.46),('15128','2013-06-13','18:10:00',2.32),('15128','2013-06-13','18:15:00',2.19),('15128','2013-06-13','18:20:00',2.08),('15128','2013-06-13','18:25:00',2.03),('15128','2013-06-13','18:30:00',1.96),('15128','2013-06-13','18:35:00',1.86),('15128','2013-06-13','18:40:00',1.76),('15128','2013-06-13','18:45:00',1.71),('15128','2013-06-13','18:50:00',1.66),('15128','2013-06-13','18:55:00',1.55),('15128','2013-06-13','19:00:00',1.46),('15128','2013-06-13','19:05:00',1.36),('15128','2013-06-13','19:10:00',1.28),('15128','2013-06-13','19:15:00',1.15),('15128','2013-06-12','07:55:00',1.05),('15128','2013-06-12','08:00:00',1.13),('15128','2013-06-12','08:05:00',1.2),('15128','2013-06-12','08:10:00',1.25),('15128','2013-06-12','08:15:00',1.32),('15128','2013-06-12','08:20:00',1.43),('15128','2013-06-12','08:25:00',1.51),('15128','2013-06-12','08:30:00',1.57),('15128','2013-06-12','08:35:00',1.64),('15128','2013-06-12','08:40:00',1.72),('15128','2013-06-12','08:45:00',1.79),('15128','2013-06-12','08:50:00',1.9),('15128','2013-06-12','08:55:00',2.02),('15128','2013-06-12','09:00:00',2.1),('15128','2013-06-12','09:05:00',2.18),('15128','2013-06-12','09:10:00',2.26),('15128','2013-06-12','09:15:00',2.29),('15128','2013-06-12','09:20:00',2.26),('15128','2013-06-12','09:25:00',2.44),('15128','2013-06-12','09:30:00',2.52),('15128','2013-06-12','09:35:00',2.58),('15128','2013-06-12','09:40:00',2.63),('15128','2013-06-12','09:45:00',2.68),('15128','2013-06-12','09:50:00',2.74),('15128','2013-06-12','09:55:00',2.8),('15128','2013-06-12','10:00:00',2.84),('15128','2013-06-12','10:05:00',2.88),('15128','2013-06-12','10:10:00',2.92),('15128','2013-06-12','10:15:00',2.97),('15128','2013-06-12','10:20:00',3.01),('15128','2013-06-12','10:25:00',3.12),('15128','2013-06-12','10:30:00',3.21),('15128','2013-06-12','10:35:00',3.22),('15128','2013-06-12','10:40:00',3.31),('15128','2013-06-12','10:45:00',3.33),('15128','2013-06-12','10:50:00',3.42),('15128','2013-06-12','10:55:00',3.37),('15128','2013-06-12','11:00:00',3.53),('15128','2013-06-12','11:05:00',3.58),('15128','2013-06-12','11:10:00',3.66),('15128','2013-06-12','11:15:00',3.68),('15128','2013-06-12','11:20:00',3.78),('15128','2013-06-12','11:25:00',3.77),('15128','2013-06-12','11:30:00',3.72),('15128','2013-06-12','11:35:00',3.81),('15128','2013-06-12','11:40:00',4),('15128','2013-06-12','11:45:00',4.07),('15128','2013-06-12','11:50:00',4.17),('15128','2013-06-12','11:55:00',4.27),('15128','2013-06-12','12:00:00',4.3),('15128','2013-06-12','12:05:00',4.37),('15128','2013-06-12','12:10:00',4.39),('15128','2013-06-12','12:15:00',4.38),('15128','2013-06-12','12:20:00',4.43),('15128','2013-06-12','12:25:00',4.48),('15128','2013-06-12','12:30:00',4.51),('15128','2013-06-12','12:35:00',4.5),('15128','2013-06-12','12:40:00',4.51),('15128','2013-06-12','12:45:00',4.51),('15128','2013-06-12','12:50:00',4.5),('15128','2013-06-12','12:55:00',4.51),('15128','2013-06-12','13:00:00',4.51),('15128','2013-06-12','13:05:00',4.5),('15128','2013-06-12','13:10:00',4.51),('15128','2013-06-12','13:15:00',4.54),('15128','2013-06-12','13:20:00',4.55),('15128','2013-06-12','13:25:00',4.54),('15128','2013-06-12','13:30:00',4.5),('15128','2013-06-12','13:35:00',4.53),('15128','2013-06-12','13:40:00',4.52),('15128','2013-06-12','13:45:00',4.5),('15128','2013-06-12','13:50:00',4.52),('15128','2013-06-12','13:55:00',4.56),('15128','2013-06-12','14:00:00',4.56),('15128','2013-06-12','14:05:00',4.54),('15128','2013-06-12','14:10:00',4.5),('15128','2013-06-12','14:15:00',4.46),('15128','2013-06-12','14:20:00',4.58),('15128','2013-06-12','14:25:00',2.61),('15128','2013-06-12','14:30:00',4.6),('15128','2013-06-12','14:35:00',4.53),('15128','2013-06-12','14:40:00',4.56),('15128','2013-06-12','14:45:00',4.74),('15128','2013-06-12','14:50:00',3.13),('15128','2013-06-12','14:55:00',4.64),('15128','2013-06-12','15:00:00',2.7),('15128','2013-06-12','15:05:00',2.91),('15128','2013-06-12','15:10:00',4.57),('15128','2013-06-12','15:15:00',4.34),('15128','2013-06-12','15:20:00',4.24),('15128','2013-06-12','15:25:00',4.18),('15128','2013-06-12','15:30:00',4.16),('15128','2013-06-12','15:35:00',4.15),('15128','2013-06-12','15:40:00',4.13),('15128','2013-06-12','15:45:00',4.11),('15128','2013-06-12','15:50:00',4.07),('15128','2013-06-12','15:55:00',3.9),('15128','2013-06-12','16:00:00',3.81),('15128','2013-06-12','16:05:00',3.85),('15128','2013-06-12','16:10:00',3.82),('15128','2013-06-12','16:15:00',3.8),('15128','2013-06-12','16:20:00',3.86),('15128','2013-06-12','16:25:00',3.77),('15128','2013-06-12','16:30:00',3.84),('15128','2013-06-12','16:35:00',3.68),('15128','2013-06-12','16:40:00',3.58),('15128','2013-06-12','16:45:00',3.51),('15128','2013-06-12','16:50:00',3.44),('15128','2013-06-12','16:55:00',3.44),('15128','2013-06-12','17:00:00',3.38),('15128','2013-06-12','17:05:00',3.34),('15128','2013-06-12','17:10:00',3.26),('15128','2013-06-12','17:15:00',3.17),('15128','2013-06-12','17:20:00',3.1),('15128','2013-06-12','17:25:00',3.01),('15128','2013-06-12','17:30:00',2.97),('15128','2013-06-12','17:35:00',2.9),('15128','2013-06-12','17:40:00',2.81),('15128','2013-06-12','17:45:00',2.73),('15128','2013-06-12','17:50:00',2.67),('15128','2013-06-12','17:55:00',2.49),('15128','2013-06-12','18:00:00',2.44),('15128','2013-06-12','18:05:00',2.39),('15128','2013-06-12','18:10:00',2.27),('15128','2013-06-12','18:15:00',2.12),('15128','2013-06-12','18:20:00',2.06),('15128','2013-06-12','18:25:00',1.96),('15128','2013-06-12','18:30:00',1.89),('15128','2013-06-12','18:35:00',1.81),('15128','2013-06-12','18:40:00',1.68),('15128','2013-06-12','18:45:00',1.66),('15128','2013-06-12','18:50:00',1.63),('15128','2013-06-12','18:55:00',1.53),('15128','2013-06-12','19:00:00',1.45),('15128','2013-06-12','19:05:00',1.34),('15128','2013-06-12','19:10:00',1.26),('15128','2013-06-12','19:15:00',1.11),('15128','2013-06-11','07:55:00',1.05),('15128','2013-06-11','08:00:00',1.13),('15128','2013-06-11','08:05:00',1.2),('15128','2013-06-11','08:10:00',1.26),('15128','2013-06-11','08:15:00',1.33),('15128','2013-06-11','08:20:00',1.44),('15128','2013-06-11','08:25:00',1.53),('15128','2013-06-11','08:30:00',1.59),('15128','2013-06-11','08:35:00',1.66),('15128','2013-06-11','08:40:00',1.72),('15128','2013-06-11','08:45:00',1.78),('15128','2013-06-11','08:50:00',1.91),('15128','2013-06-11','08:55:00',2.02),('15128','2013-06-11','09:00:00',2.1),('15128','2013-06-11','09:05:00',2.16),('15128','2013-06-11','09:10:00',2.25),('15128','2013-06-11','09:15:00',2.27),('15128','2013-06-11','09:20:00',2.23),('15128','2013-06-11','09:25:00',2.41),('15128','2013-06-11','09:30:00',2.49),('15128','2013-06-11','09:35:00',2.56),('15128','2013-06-11','09:40:00',2.62),('15128','2013-06-11','09:45:00',2.67),('15128','2013-06-11','09:50:00',2.73),('15128','2013-06-11','09:55:00',2.8),('15128','2013-06-11','10:00:00',2.84),('15128','2013-06-11','10:05:00',2.88),('15128','2013-06-11','10:10:00',2.93),('15128','2013-06-11','10:15:00',2.96),('15128','2013-06-11','10:20:00',2.96),('15128','2013-06-11','10:25:00',3.04),('15128','2013-06-11','10:30:00',3.11),('15128','2013-06-11','10:35:00',3.12),('15128','2013-06-11','10:40:00',3.25),('15128','2013-06-11','10:45:00',3.27),('15128','2013-06-11','10:50:00',3.4),('15128','2013-06-11','10:55:00',3.34),('15128','2013-06-11','11:00:00',3.43),('15128','2013-06-11','11:05:00',3.46),('15128','2013-06-11','11:10:00',3.59),('15128','2013-06-11','11:15:00',3.63),('15128','2013-06-11','11:20:00',3.68),('15128','2013-06-11','11:25:00',3.7),('15128','2013-06-11','11:30:00',3.82),('15128','2013-06-11','11:35:00',3.9),('15128','2013-06-11','11:40:00',3.99),('15128','2013-06-11','11:45:00',4.08),('15128','2013-06-11','11:50:00',4.19),('15128','2013-06-11','11:55:00',4.23),('15128','2013-06-11','12:00:00',4.25),('15128','2013-06-11','12:05:00',4.25),('15128','2013-06-11','12:10:00',4.28),('15128','2013-06-11','12:15:00',4.29),('15128','2013-06-11','12:20:00',4.32),('15128','2013-06-11','12:25:00',4.4),('15128','2013-06-11','12:30:00',4.42),('15128','2013-06-11','12:35:00',4.47),('15128','2013-06-11','12:40:00',4.43),('15128','2013-06-11','12:45:00',4.43),('15128','2013-06-11','12:50:00',4.15),('15128','2013-06-11','12:55:00',4.7),('15128','2013-06-11','13:00:00',4.62),('15128','2013-06-11','13:05:00',4.59),('15128','2013-06-11','13:10:00',4.6),('15128','2013-06-11','13:15:00',4.62),('15128','2013-06-11','13:20:00',4.64),('15128','2013-06-11','13:25:00',4.53),('15128','2013-06-11','13:30:00',4.01),('15128','2013-06-11','13:35:00',4.69),('15128','2013-06-11','13:40:00',3.85),('15128','2013-06-11','13:45:00',4.67),('15128','2013-06-11','13:50:00',4.55),('15128','2013-06-11','13:55:00',4.88),('15128','2013-06-11','14:00:00',4.02),('15128','2013-06-11','14:05:00',4.48),('15128','2013-06-11','14:10:00',4.7),('15128','2013-06-11','14:15:00',4.68),('15128','2013-06-11','14:20:00',4.61),('15128','2013-06-11','14:25:00',4.6),('15128','2013-06-11','14:30:00',4.59),('15128','2013-06-11','14:35:00',4.61),('15128','2013-06-11','14:40:00',4.52),('15128','2013-06-11','14:45:00',4.59),('15128','2013-06-11','14:50:00',4.54),('15128','2013-06-11','14:55:00',4.52),('15128','2013-06-11','15:00:00',4.51),('15128','2013-06-11','15:05:00',4.53),('15128','2013-06-11','15:10:00',4.53),('15128','2013-06-11','15:15:00',4.51),('15128','2013-06-11','15:20:00',4.49),('15128','2013-06-11','15:25:00',4.41),('15128','2013-06-11','15:30:00',4.37),('15128','2013-06-11','15:35:00',4.38),('15128','2013-06-11','15:40:00',4.35),('15128','2013-06-11','15:45:00',4.3),('15128','2013-06-11','15:50:00',4.23),('15128','2013-06-11','15:55:00',4.21),('15128','2013-06-11','16:00:00',4.18),('15128','2013-06-11','16:05:00',4.1),('15128','2013-06-11','16:10:00',4.06),('15128','2013-06-11','16:15:00',4.06),('15128','2013-06-11','16:20:00',3.95),('15128','2013-06-11','16:25:00',4),('15128','2013-06-11','16:30:00',3.95),('15128','2013-06-11','16:35:00',3.9),('15128','2013-06-11','16:40:00',3.98),('15128','2013-06-11','16:45:00',3.85),('15128','2013-06-11','16:50:00',3.72),('15128','2013-06-11','16:55:00',3.6),('15128','2013-06-11','17:00:00',3.57),('15128','2013-06-11','17:05:00',3.53),('15128','2013-06-11','17:10:00',3.42),('15128','2013-06-11','17:15:00',3.36),('15128','2013-06-11','17:20:00',3.26),('15128','2013-06-11','17:25:00',3.25),('15128','2013-06-11','17:30:00',3.32),('15128','2013-06-11','17:35:00',3.2),('15128','2013-06-11','17:40:00',3.29),('15128','2013-06-11','17:45:00',3.09),('15128','2013-06-11','17:50:00',2.99),('15128','2013-06-11','17:55:00',2.92),('15128','2013-06-11','18:00:00',2.44),('15128','2013-06-11','18:05:00',1.74),('15128','2013-06-11','18:10:00',2.41),('15128','2013-06-11','18:15:00',2.24),('15128','2013-06-11','18:20:00',2.15),('15128','2013-06-11','18:25:00',2.07),('15128','2013-06-11','18:30:00',1.98),('15128','2013-06-11','18:35:00',1.87),('15128','2013-06-11','18:40:00',1.73),('15128','2013-06-11','18:45:00',1.67),('15128','2013-06-11','18:50:00',1.62),('15128','2013-06-11','18:55:00',1.51),('15128','2013-06-11','19:00:00',1.4),('15128','2013-06-11','19:05:00',1.31),('15128','2013-06-11','19:10:00',1.21),('15128','2013-06-11','19:15:00',1.06),('15128','2013-06-10','07:55:00',1.03),('15128','2013-06-10','08:00:00',1.1),('15128','2013-06-10','08:05:00',1.18),('15128','2013-06-10','08:10:00',1.23),('15128','2013-06-10','08:15:00',1.3),('15128','2013-06-10','08:20:00',1.41),('15128','2013-06-10','08:25:00',1.49),('15128','2013-06-10','08:30:00',1.55),('15128','2013-06-10','08:35:00',1.62),('15128','2013-06-10','08:40:00',1.69),('15128','2013-06-10','08:45:00',1.79),('15128','2013-06-10','08:50:00',1.9),('15128','2013-06-10','08:55:00',2.01),('15128','2013-06-10','09:00:00',2.09),('15128','2013-06-10','09:05:00',2.18),('15128','2013-06-10','09:10:00',2.27),('15128','2013-06-10','09:15:00',2.25),('15128','2013-06-10','09:20:00',2.29),('15128','2013-06-10','09:25:00',2.41),('15128','2013-06-10','09:30:00',2.49),('15128','2013-06-10','09:35:00',2.53),('15128','2013-06-10','09:40:00',2.6),('15128','2013-06-10','09:45:00',2.71),('15128','2013-06-10','09:50:00',2.16),('15128','2013-06-10','09:55:00',2.58),('15128','2013-06-10','10:00:00',2.89),('15128','2013-06-10','10:05:00',2.97),('15128','2013-06-10','10:10:00',3.01),('15128','2013-06-10','10:15:00',2.3),('15128','2013-06-10','10:20:00',3.24),('15128','2013-06-10','10:25:00',2.35),('15128','2013-06-10','10:30:00',3.43),('15128','2013-06-10','10:35:00',3.43),('15128','2013-06-10','10:40:00',3.41),('15128','2013-06-10','10:45:00',3.6),('15128','2013-06-10','10:50:00',3.79),('15128','2013-06-10','10:55:00',1.5),('15128','2013-06-10','11:00:00',2.82),('15128','2013-06-10','11:05:00',2.8),('15128','2013-06-10','11:10:00',3.78),('15128','2013-06-10','11:15:00',3.77),('15128','2013-06-10','11:20:00',3.85),('15128','2013-06-10','11:25:00',3.8),('15128','2013-06-10','11:30:00',3.73),('15128','2013-06-10','11:35:00',3.85),('15128','2013-06-10','11:40:00',4.07),('15128','2013-06-10','11:45:00',4.13),('15128','2013-06-10','11:50:00',3.36),('15128','2013-06-10','11:55:00',4.38),('15128','2013-06-10','12:00:00',4.38),('15128','2013-06-10','12:05:00',4.4),('15128','2013-06-10','12:10:00',4.5),('15128','2013-06-10','12:15:00',4.54),('15128','2013-06-10','12:20:00',4.48),('15128','2013-06-10','12:25:00',4.51),('15128','2013-06-10','12:30:00',4.52),('15128','2013-06-10','12:35:00',4.59),('15128','2013-06-10','12:40:00',4.6),('15128','2013-06-10','12:45:00',4.64),('15128','2013-06-10','12:50:00',4.64),('15128','2013-06-10','12:55:00',4.66),('15128','2013-06-10','13:00:00',4.8),('15128','2013-06-10','13:05:00',4.82),('15128','2013-06-10','13:10:00',4.82),('15128','2013-06-10','13:15:00',4.75),('15128','2013-06-10','13:20:00',4.76),('15128','2013-06-10','13:25:00',4.75),('15128','2013-06-10','13:30:00',4.75),('15128','2013-06-10','13:35:00',4.83),('15128','2013-06-10','13:40:00',4.84),('15128','2013-06-10','13:45:00',4.84),('15128','2013-06-10','13:50:00',4.52),('15128','2013-06-10','13:55:00',4.76),('15128','2013-06-10','14:00:00',4.75),('15128','2013-06-10','14:05:00',4.74),('15128','2013-06-10','14:10:00',4.75),('15128','2013-06-10','14:15:00',4.73),('15128','2013-06-10','14:20:00',4.71),('15128','2013-06-10','14:25:00',4.7),('15128','2013-06-10','14:30:00',4.66),('15128','2013-06-10','14:35:00',4.71),('15128','2013-06-10','14:40:00',4.65),('15128','2013-06-10','14:45:00',4.64),('15128','2013-06-10','14:50:00',4.49),('15128','2013-06-10','14:55:00',4.54),('15128','2013-06-10','15:00:00',4.59),('15128','2013-06-10','15:05:00',4.58),('15128','2013-06-10','15:10:00',4.51),('15128','2013-06-10','15:15:00',4.5),('15128','2013-06-10','15:20:00',4.46),('15128','2013-06-10','15:25:00',4.29),('15128','2013-06-10','15:30:00',4.45),('15128','2013-06-10','15:35:00',4.57),('15128','2013-06-10','15:40:00',4.44),('15128','2013-06-10','15:45:00',4.34),('15128','2013-06-10','15:50:00',4.25),('15128','2013-06-10','15:55:00',4.28),('15128','2013-06-10','16:00:00',4.23),('15128','2013-06-10','16:05:00',4.15),('15128','2013-06-10','16:10:00',4.09),('15128','2013-06-10','16:15:00',4.04),('15128','2013-06-10','16:20:00',3.98),('15128','2013-06-10','16:25:00',3.93),('15128','2013-06-10','16:30:00',3.91),('15128','2013-06-10','16:35:00',3.95),('15128','2013-06-10','16:40:00',4.04),('15128','2013-06-10','16:45:00',4.08),('15128','2013-06-10','16:50:00',4),('15128','2013-06-10','16:55:00',2.64),('15128','2013-06-10','17:00:00',1.83),('15128','2013-06-10','17:05:00',1.21),('15128','2013-06-10','19:25:00',1.31),('15128','2014-04-02','09:00:00',1.06),('15128','2014-04-02','09:05:00',1.14),('15128','2014-04-02','09:10:00',1.07),('15128','2014-04-02','09:15:00',1.02),('15128','2014-04-02','09:20:00',1.12),('15128','2014-04-02','09:25:00',1.2),('15128','2014-04-02','09:30:00',1.27),('15128','2014-04-02','09:35:00',1.39),('15128','2014-04-02','09:40:00',1.42),('15128','2014-04-02','09:45:00',1.44),('15128','2014-04-02','09:50:00',1.46),('15128','2014-04-02','09:55:00',1.6),('15128','2014-04-02','10:00:00',1.82),('15128','2014-04-02','10:05:00',1.88),('15128','2014-04-02','10:10:00',2.01),('15128','2014-04-02','10:15:00',2.32),('15128','2014-04-02','10:20:00',2.16),('15128','2014-04-02','10:25:00',1.91),('15128','2014-04-02','10:30:00',2.34),('15128','2014-04-02','10:35:00',2.08),('15128','2014-04-02','10:40:00',2.13),('15128','2014-04-02','10:45:00',2.35),('15128','2014-04-02','10:50:00',2.06),('15128','2014-04-02','10:55:00',1.75),('15128','2014-04-02','11:00:00',1.77),('15128','2014-04-02','11:05:00',1.84),('15128','2014-04-02','11:10:00',1.67),('15128','2014-04-02','11:15:00',1.58),('15128','2014-04-02','11:20:00',1.44),('15128','2014-04-02','11:25:00',1.33),('15128','2014-04-02','11:30:00',1.33),('15128','2014-04-02','11:35:00',1.48),('15128','2014-04-02','11:40:00',1.58),('15128','2014-04-02','11:45:00',1.61),('15128','2014-04-02','11:50:00',1.82),('15128','2014-04-02','11:55:00',2.05),('15128','2014-04-02','12:00:00',2.37),('15128','2014-04-02','12:05:00',2.33),('15128','2014-04-02','12:10:00',2.13),('15128','2014-04-02','12:15:00',2.22),('15128','2014-04-02','12:20:00',2.33),('15128','2014-04-02','12:25:00',2.93),('15128','2014-04-02','12:30:00',3.83),('15128','2014-04-02','12:35:00',3.79),('15128','2014-04-02','12:40:00',2.58),('15128','2014-04-02','12:45:00',2.21),('15128','2014-04-02','12:50:00',2.28),('15128','2014-04-02','12:55:00',2.53),('15128','2014-04-02','13:00:00',2.11),('15128','2014-04-02','13:05:00',2.04),('15128','2014-04-02','13:10:00',2.61),('15128','2014-04-02','13:15:00',3.7),('15128','2014-04-02','13:20:00',2.26),('15128','2014-04-02','13:25:00',3.26),('15128','2014-04-02','13:30:00',3.54),('15128','2014-04-02','13:35:00',3.54),('15128','2014-04-02','13:40:00',2.8),('15128','2014-04-02','13:45:00',1.65),('15128','2014-04-02','13:50:00',2.37),('15128','2014-04-02','13:55:00',2.79),('15128','2014-04-02','14:00:00',2.24),('15128','2014-04-02','14:05:00',3.79),('15128','2014-04-02','14:10:00',3.38),('15128','2014-04-02','14:15:00',3.54),('15128','2014-04-02','14:20:00',3.51),('15128','2014-04-02','14:25:00',2.97),('15128','2014-04-02','14:30:00',3.71),('15128','2014-04-02','14:35:00',3.87),('15128','2014-04-02','14:40:00',3.73),('15128','2014-04-02','14:45:00',3.68),('15128','2014-04-02','14:50:00',3.65),('15128','2014-04-02','14:55:00',3.59),('15128','2014-04-02','15:00:00',3.56),('15128','2014-04-02','15:05:00',3.53),('15128','2014-04-02','15:10:00',3.53),('15128','2014-04-02','15:15:00',3.45),('15128','2014-04-02','15:20:00',3.51),('15128','2014-04-02','15:25:00',3.49),('15128','2014-04-02','15:30:00',3.45),('15128','2014-04-02','15:35:00',3.36),('15128','2014-04-02','15:40:00',3.35),('15128','2014-04-02','15:45:00',3.34),('15128','2014-04-02','15:50:00',3.34),('15128','2014-04-02','15:55:00',3.37),('15128','2014-04-02','16:00:00',3.37),('15128','2014-04-02','16:05:00',3.26),('15128','2014-04-02','16:10:00',3.23),('15128','2014-04-02','16:15:00',3.16),('15128','2014-04-02','16:20:00',3.12),('15128','2014-04-02','16:25:00',3.05),('15128','2014-04-02','16:30:00',2.96),('15128','2014-04-02','16:35:00',2.9),('15128','2014-04-02','16:40:00',2.84),('15128','2014-04-02','16:45:00',2.77),('15128','2014-04-02','16:50:00',2.74),('15128','2014-04-02','16:55:00',2.36),('15128','2014-04-02','17:00:00',2.02),('15128','2014-04-02','17:05:00',1.46),('15128','2014-04-02','17:10:00',1.57),('15128','2014-04-02','17:15:00',1.66),('15128','2014-04-02','17:20:00',1.29),('15128','2014-04-02','17:25:00',1.35),('15128','2014-04-02','17:30:00',1.16),('15128','2014-04-02','17:45:00',1.13),('15128','2014-04-02','17:50:00',1.76),('15128','2014-04-02','17:55:00',1.64),('15128','2014-04-02','18:00:00',1.51),('15128','2014-04-02','18:05:00',1.39),('15128','2014-04-02','18:10:00',1.29),('15128','2014-04-02','18:15:00',1.14),('15128','2014-04-02','18:20:00',1.03),('15128','2013-06-09','08:10:00',1.06),('15128','2013-06-09','08:15:00',1.03),('15128','2013-06-09','08:20:00',1.45),('15128','2013-06-09','08:25:00',1.2),('15128','2013-06-09','08:45:00',1.26),('15128','2013-06-09','08:50:00',1.93),('15128','2013-06-09','08:55:00',2),('15128','2013-06-09','09:05:00',1.31),('15128','2013-06-09','09:10:00',1.09),('15128','2013-06-09','09:15:00',2.35),('15128','2013-06-09','09:20:00',2.11),('15128','2013-06-09','09:25:00',2.26),('15128','2013-06-09','09:30:00',1.52),('15128','2013-06-09','09:35:00',1.84),('15128','2013-06-09','09:40:00',2.13),('15128','2013-06-09','09:45:00',1.99),('15128','2013-06-09','09:50:00',1.97),('15128','2013-06-09','09:55:00',1.83),('15128','2013-06-09','10:00:00',1.81),('15128','2013-06-09','10:05:00',2.03),('15128','2013-06-09','10:10:00',2.34),('15128','2013-06-09','10:15:00',2.07),('15128','2013-06-09','10:20:00',1.67),('15128','2013-06-09','10:25:00',2.69),('15128','2013-06-09','10:30:00',2.13),('15128','2013-06-09','10:35:00',2.65),('15128','2013-06-09','10:40:00',3.58),('15128','2013-06-09','10:45:00',3.23),('15128','2013-06-09','10:50:00',1.51),('15128','2013-06-09','10:55:00',3.22),('15128','2013-06-09','11:00:00',3.43),('15128','2013-06-09','11:05:00',2.81),('15128','2013-06-09','11:10:00',3.97),('15128','2013-06-09','11:15:00',3.89),('15128','2013-06-09','11:20:00',4.6),('15128','2013-06-09','11:25:00',2.9),('15128','2013-06-09','11:30:00',1.44),('15128','2013-06-09','11:35:00',1.43),('15128','2013-06-09','11:40:00',3.46),('15128','2013-06-09','11:45:00',3.58),('15128','2013-06-09','11:50:00',2.59),('15128','2013-06-09','11:55:00',4.58),('15128','2013-06-09','12:00:00',2.85),('15128','2013-06-09','12:05:00',4.38),('15128','2013-06-09','12:10:00',3.64),('15128','2013-06-09','12:15:00',4.72),('15128','2013-06-09','12:20:00',4.59),('15128','2013-06-09','12:25:00',2.81),('15128','2013-06-09','12:30:00',2.44),('15128','2013-06-09','12:35:00',3.79),('15128','2013-06-09','12:40:00',2.14),('15128','2013-06-09','12:45:00',4.93),('15128','2013-06-09','12:50:00',5.03),('15128','2013-06-09','12:55:00',4.8),('15128','2013-06-09','13:00:00',2.32),('15128','2013-06-09','13:05:00',2.3),('15128','2013-06-09','13:10:00',2.96),('15128','2013-06-09','13:15:00',3.17),('15128','2013-06-09','13:20:00',4.66),('15128','2013-06-09','13:25:00',1.58),('15128','2013-06-09','13:30:00',1.35),('15128','2013-06-09','13:35:00',1.24),('15128','2013-06-09','13:40:00',2.3),('15128','2013-06-09','13:45:00',2.02),('15128','2013-06-09','13:50:00',3.84),('15128','2013-06-09','13:55:00',4.21),('15128','2013-06-09','14:00:00',5.08),('15128','2013-06-09','14:05:00',3.45),('15128','2013-06-09','14:10:00',3.23),('15128','2013-06-09','14:15:00',4.97),('15128','2013-06-09','14:20:00',4.94),('15128','2013-06-09','14:25:00',4.73),('15128','2013-06-09','14:30:00',4.75),('15128','2013-06-09','14:35:00',4.74),('15128','2013-06-09','14:40:00',4.71),('15128','2013-06-09','14:45:00',4.69),('15128','2013-06-09','14:50:00',4.67),('15128','2013-06-09','14:55:00',4.64),('15128','2013-06-09','15:00:00',4.62),('15128','2013-06-09','15:05:00',4.59),('15128','2013-06-09','15:10:00',4.58),('15128','2013-06-09','15:15:00',4.57),('15128','2013-06-09','15:20:00',4.57),('15128','2013-06-09','15:25:00',4.52),('15128','2013-06-09','15:30:00',4.49),('15128','2013-06-09','15:35:00',4.47),('15128','2013-06-09','15:40:00',4.45),('15128','2013-06-09','15:45:00',4.4),('15128','2013-06-09','15:50:00',4.33),('15128','2013-06-09','15:55:00',4.29),('15128','2013-06-09','16:00:00',4.24),('15128','2013-06-09','16:05:00',4.21),('15128','2013-06-09','16:10:00',4.16),('15128','2013-06-09','16:15:00',4.12),('15128','2013-06-09','16:20:00',4.08),('15128','2013-06-09','16:25:00',4.05),('15128','2013-06-09','16:30:00',3.98),('15128','2013-06-09','16:35:00',3.94),('15128','2013-06-09','16:40:00',3.85),('15128','2013-06-09','16:45:00',3.79),('15128','2013-06-09','16:50:00',3.74),('15128','2013-06-09','16:55:00',3.7),('15128','2013-06-09','17:00:00',3.63),('15128','2013-06-09','17:05:00',3.56),('15128','2013-06-09','17:10:00',3.5),('15128','2013-06-09','17:15:00',3.45),('15128','2013-06-09','17:20:00',3.37),('15128','2013-06-09','17:25:00',3.29),('15128','2013-06-09','17:30:00',3.24),('15128','2013-06-09','17:35:00',3.1),('15128','2013-06-09','17:40:00',3.06),('15128','2013-06-09','17:45:00',2.99),('15128','2013-06-09','17:50:00',2.92),('15128','2013-06-09','17:55:00',2.75),('15128','2013-06-09','18:00:00',2.66),('15128','2013-06-09','18:05:00',2.56),('15128','2013-06-09','18:10:00',2.45),('15128','2013-06-09','18:15:00',2.35),('15128','2013-06-09','18:20:00',2.24),('15128','2013-06-09','18:25:00',2.13),('15128','2013-06-09','18:30:00',2.02),('15128','2013-06-09','18:35:00',1.94),('15128','2013-06-09','18:40:00',1.84),('15128','2013-06-09','18:45:00',1.77),('15128','2013-06-09','18:50:00',1.73),('15128','2013-06-09','18:55:00',1.63),('15128','2013-06-09','19:00:00',1.54),('15128','2013-06-09','19:05:00',1.43),('15128','2013-06-09','19:10:00',1.35),('15128','2013-06-09','19:15:00',1.17),('15128','2013-06-08','08:10:00',1.13),('15128','2013-06-08','08:15:00',1.29),('15128','2013-06-08','08:20:00',1.43),('15128','2013-06-08','08:25:00',1.49),('15128','2013-06-08','08:30:00',1.51),('15128','2013-06-08','08:35:00',1.6),('15128','2013-06-08','08:40:00',1.68),('15128','2013-06-08','08:45:00',1.67),('15128','2013-06-08','08:50:00',1.84),('15128','2013-06-08','08:55:00',1.93),('15128','2013-06-08','09:00:00',1.98),('15128','2013-06-08','09:05:00',2.11),('15128','2013-06-08','09:10:00',2.16),('15128','2013-06-08','09:15:00',2.11),('15128','2013-06-08','09:20:00',2.16),('15128','2013-06-08','09:25:00',2.31),('15128','2013-06-08','09:30:00',2.39),('15128','2013-06-08','09:35:00',2.46),('15128','2013-06-08','09:40:00',2.55),('15128','2013-06-08','09:45:00',2.59),('15128','2013-06-08','09:50:00',2.67),('15128','2013-06-08','09:55:00',2.7),('15128','2013-06-08','10:00:00',2.74),('15128','2013-06-08','10:05:00',2.81),('15128','2013-06-08','10:10:00',2.87),('15128','2013-06-08','10:15:00',2.93),('15128','2013-06-08','10:20:00',2.97),('15128','2013-06-08','10:25:00',3.01),('15128','2013-06-08','10:30:00',3.06),('15128','2013-06-08','10:35:00',3.06),('15128','2013-06-08','10:40:00',3.18),('15128','2013-06-08','10:45:00',3.25),('15128','2013-06-08','10:50:00',3.27),('15128','2013-06-08','10:55:00',3.26),('15128','2013-06-08','11:00:00',3.34),('15128','2013-06-08','11:05:00',3.34),('15128','2013-06-08','11:10:00',3.5),('15128','2013-06-08','11:15:00',3.53),('15128','2013-06-08','11:20:00',3.63),('15128','2013-06-08','11:25:00',3.58),('15128','2013-06-08','11:30:00',3.57),('15128','2013-06-08','11:35:00',3.7),('15128','2013-06-08','11:40:00',3.86),('15128','2013-06-08','11:45:00',3.89),('15128','2013-06-08','11:50:00',3.96),('15128','2013-06-08','11:55:00',4.02),('15128','2013-06-08','12:00:00',4.03),('15128','2013-06-08','12:05:00',3.92),('15128','2013-06-08','12:10:00',4.09),('15128','2013-06-08','12:15:00',4),('15128','2013-06-08','12:20:00',3.89),('15128','2013-06-08','12:25:00',4.15),('15128','2013-06-08','12:30:00',4.24),('15128','2013-06-08','12:35:00',4.23),('15128','2013-06-08','12:40:00',4.37),('15128','2013-06-08','12:45:00',4.18),('15128','2013-06-08','12:50:00',4.45),('15128','2013-06-08','12:55:00',4.42),('15128','2013-06-08','13:00:00',4.3),('15128','2013-06-08','13:05:00',4.31),('15128','2013-06-08','13:10:00',4.21),('15128','2013-06-08','13:15:00',4.56),('15128','2013-06-08','13:20:00',4.6),('15128','2013-06-08','13:25:00',4.53),('15128','2013-06-08','13:30:00',4.79),('15128','2013-06-08','13:35:00',2.63),('15128','2013-06-08','13:40:00',3.96),('15128','2013-06-08','13:45:00',4.12),('15128','2013-06-08','13:50:00',4.33),('15128','2013-06-08','13:55:00',4.88),('15128','2013-06-08','14:00:00',4.75),('15128','2013-06-08','14:05:00',4.88),('15128','2013-06-08','14:10:00',4.9),('15128','2013-06-08','14:15:00',3.94),('15128','2013-06-08','14:20:00',1.76),('15128','2013-06-08','14:25:00',1.31),('15128','2013-06-08','14:30:00',1.56),('15128','2013-06-08','14:35:00',3.5),('15128','2013-06-08','14:40:00',5.41),('15128','2013-06-08','14:45:00',4.12),('15128','2013-06-08','14:50:00',4.03),('15128','2013-06-08','14:55:00',4.78),('15128','2013-06-08','15:00:00',4.6),('15128','2013-06-08','15:05:00',4.62),('15128','2013-06-08','15:10:00',4.59),('15128','2013-06-08','15:15:00',4.39),('15128','2013-06-08','15:20:00',4.37),('15128','2013-06-08','15:25:00',4.32),('15128','2013-06-08','15:30:00',4.39),('15128','2013-06-08','15:35:00',4.44),('15128','2013-06-08','15:40:00',3.92),('15128','2013-06-08','15:45:00',3.27),('15128','2013-06-08','15:50:00',4.07),('15128','2013-06-08','15:55:00',4.46),('15128','2013-06-08','16:00:00',4.06),('15128','2013-06-08','16:05:00',3.96),('15128','2013-06-08','16:10:00',3.23),('15128','2013-06-08','16:15:00',3.46),('15128','2013-06-08','16:20:00',2.13),('15128','2013-06-08','16:25:00',2.85),('15128','2013-06-08','16:30:00',1.24),('15128','2013-06-08','16:35:00',1.24),('15128','2013-06-08','16:40:00',1.1),('15128','2013-06-08','16:45:00',1.14),('15128','2013-06-08','16:50:00',1.12),('15128','2013-06-08','16:55:00',1.13),('15128','2013-06-08','17:00:00',1.25),('15128','2013-06-08','17:05:00',1.11),('15128','2013-06-08','17:10:00',1.15),('15128','2013-06-08','18:00:00',1.29),('15128','2013-06-08','18:05:00',2.42),('15128','2013-06-08','18:10:00',1.75),('15128','2013-06-07','07:55:00',1.01),('15128','2013-06-07','08:00:00',1.09),('15128','2013-06-07','08:05:00',1.16),('15128','2013-06-07','08:10:00',1.22),('15128','2013-06-07','08:15:00',1.29),('15128','2013-06-07','08:20:00',1.4),('15128','2013-06-07','08:25:00',1.47),('15128','2013-06-07','08:30:00',1.51),('15128','2013-06-07','08:35:00',1.6),('15128','2013-06-07','08:40:00',1.68),('15128','2013-06-07','08:45:00',1.75),('15128','2013-06-07','08:50:00',1.85),('15128','2013-06-07','08:55:00',1.96),('15128','2013-06-07','09:00:00',2.04),('15128','2013-06-07','09:05:00',2.11),('15128','2013-06-07','09:10:00',2.16),('15128','2013-06-07','09:15:00',2.24),('15128','2013-06-07','09:20:00',2.3),('15128','2013-06-07','09:25:00',2.35),('15128','2013-06-07','09:30:00',2.41),('15128','2013-06-07','09:35:00',2.48),('15128','2013-06-07','09:40:00',2.52),('15128','2013-06-07','09:45:00',2.62),('15128','2013-06-07','09:50:00',2.43),('15128','2013-06-07','09:55:00',2.86),('15128','2013-06-07','10:00:00',3.16),('15128','2013-06-07','10:05:00',1.65),('15128','2013-06-07','10:10:00',3.09),('15128','2013-06-07','10:15:00',2.87),('15128','2013-06-07','10:25:00',2.6),('15128','2013-06-07','10:30:00',3.33),('15128','2013-06-07','10:35:00',3.35),('15128','2013-06-07','10:40:00',3.35),('15128','2013-06-07','10:45:00',3.41),('15128','2013-06-07','10:50:00',3.58),('15128','2013-06-07','10:55:00',2.21),('15128','2013-06-07','11:00:00',3.52),('15128','2013-06-07','11:05:00',3.94),('15128','2013-06-07','11:10:00',4.1),('15128','2013-06-07','11:15:00',4.15),('15128','2013-06-07','11:20:00',2.4),('15128','2013-06-07','11:25:00',2.87),('15128','2013-06-07','11:30:00',4),('15128','2013-06-07','11:35:00',4.18),('15128','2013-06-07','11:40:00',4.22),('15128','2013-06-07','11:45:00',4.25),('15128','2013-06-07','11:50:00',4.32),('15128','2013-06-07','11:55:00',4.05),('15128','2013-06-07','12:00:00',4.56),('15128','2013-06-07','12:05:00',4.58),('15128','2013-06-07','12:10:00',3.33),('15128','2013-06-07','12:15:00',4.52),('15128','2013-06-07','12:20:00',4.21),('15128','2013-06-07','12:25:00',4.34),('15128','2013-06-07','12:30:00',4.33),('15128','2013-06-07','12:35:00',4.27),('15128','2013-06-07','12:40:00',4.24),('15128','2013-06-07','12:45:00',4.42),('15128','2013-06-07','12:50:00',4.56),('15128','2013-06-07','12:55:00',4.56),('15128','2013-06-07','13:00:00',4.54),('15128','2013-06-07','13:05:00',4.52),('15128','2013-06-07','13:10:00',4.52),('15128','2013-06-07','13:15:00',4.52),('15128','2013-06-07','13:20:00',4.59),('15128','2013-06-07','13:25:00',4.67),('15128','2013-06-07','13:30:00',4.6),('15128','2013-06-07','13:35:00',4.61),('15128','2013-06-07','13:40:00',4.61),('15128','2013-06-07','13:45:00',4.55),('15128','2013-06-07','13:50:00',4.61),('15128','2013-06-07','13:55:00',4.64),('15128','2013-06-07','14:00:00',4.71),('15128','2013-06-07','14:05:00',4.65),('15128','2013-06-07','14:10:00',4.68),('15128','2013-06-07','14:15:00',4.66),('15128','2013-06-07','14:20:00',4.67),('15128','2013-06-07','14:25:00',4.68),('15128','2013-06-07','14:30:00',4.63),('15128','2013-06-07','14:35:00',4.63),('15128','2013-06-07','14:40:00',4.62),('15128','2013-06-07','14:45:00',4.64),('15128','2013-06-07','14:50:00',4.59),('15128','2013-06-07','14:55:00',4.6),('15128','2013-06-07','15:00:00',4.5),('15128','2013-06-07','15:05:00',4.41),('15128','2013-06-07','15:10:00',4.54),('15128','2013-06-07','15:15:00',4.56),('15128','2013-06-07','15:20:00',4.43),('15128','2013-06-07','15:25:00',4.51),('15128','2013-06-07','15:30:00',4.52),('15128','2013-06-07','15:35:00',4.52),('15128','2013-06-07','15:40:00',4.4),('15128','2013-06-07','15:45:00',4.5),('15128','2013-06-07','15:50:00',4.4),('15128','2013-06-07','15:55:00',4.3),('15128','2013-06-07','16:00:00',4.24),('15128','2013-06-07','16:05:00',3.78),('15128','2013-06-07','16:10:00',4.35),('15128','2013-06-07','16:15:00',4.14),('15128','2013-06-07','16:20:00',3.91),('15128','2013-06-07','16:25:00',3.97),('15128','2013-06-07','16:30:00',3.88),('15128','2013-06-07','16:35:00',3.83),('15128','2013-06-07','16:40:00',3.78),('15128','2013-06-07','16:45:00',3.44),('15128','2013-06-07','16:50:00',3.39),('15128','2013-06-07','16:55:00',3.28),('15128','2013-06-07','17:00:00',1.65),('15128','2013-06-07','17:05:00',3.74),('15128','2013-06-07','17:10:00',3.92),('15128','2013-06-07','17:15:00',3.72),('15128','2013-06-07','17:20:00',3.36),('15128','2013-06-07','17:25:00',1.25),('15128','2013-06-07','17:30:00',1),('15128','2013-06-07','17:35:00',1.96),('15128','2013-06-07','17:40:00',2.94),('15128','2013-06-07','17:45:00',2.67),('15128','2013-06-07','17:50:00',2.9),('15128','2013-06-07','17:55:00',2.31),('15128','2013-06-07','18:00:00',2.06),('15128','2013-06-07','18:05:00',1.6),('15128','2013-06-07','18:10:00',1.52),('15128','2013-06-07','18:15:00',1.56),('15128','2013-06-07','18:20:00',1.21),('15128','2013-06-06','07:55:00',1.07),('15128','2013-06-06','08:00:00',1.14),('15128','2013-06-06','08:05:00',1.22),('15128','2013-06-06','08:10:00',1.28),('15128','2013-06-06','08:15:00',1.35),('15128','2013-06-06','08:20:00',1.46),('15128','2013-06-06','08:25:00',1.54),('15128','2013-06-06','08:30:00',1.57),('15128','2013-06-06','08:35:00',1.68),('15128','2013-06-06','08:40:00',1.76),('15128','2013-06-06','08:45:00',1.85),('15128','2013-06-06','08:50:00',1.96),('15128','2013-06-06','08:55:00',2.07),('15128','2013-06-06','09:00:00',2.14),('15128','2013-06-06','09:05:00',2.22),('15128','2013-06-06','09:10:00',2.3),('15128','2013-06-06','09:15:00',2.33),('15128','2013-06-06','09:20:00',2.3),('15128','2013-06-06','09:25:00',2.48),('15128','2013-06-06','09:30:00',2.56),('15128','2013-06-06','09:35:00',2.62),('15128','2013-06-06','09:40:00',2.68),('15128','2013-06-06','09:45:00',2.71),('15128','2013-06-06','09:50:00',2.78),('15128','2013-06-06','09:55:00',2.84),('15128','2013-06-06','10:00:00',2.9),('15128','2013-06-06','10:05:00',2.97),('15128','2013-06-06','10:10:00',2.99),('15128','2013-06-06','10:15:00',3.03),('15128','2013-06-06','10:20:00',3.06),('15128','2013-06-06','10:25:00',3.1),('15128','2013-06-06','10:30:00',3.2),('15128','2013-06-06','10:35:00',3.23),('15128','2013-06-06','10:40:00',3.32),('15128','2013-06-06','10:45:00',3.35),('15128','2013-06-06','10:50:00',3.41),('15128','2013-06-06','10:55:00',3.42),('15128','2013-06-06','11:00:00',3.53),('15128','2013-06-06','11:05:00',3.5),('15128','2013-06-06','11:10:00',3.65),('15128','2013-06-06','11:15:00',3.71),('15128','2013-06-06','11:20:00',3.81),('15128','2013-06-06','11:25:00',3.74),('15128','2013-06-06','11:30:00',3.68),('15128','2013-06-06','11:35:00',3.82),('15128','2013-06-06','11:40:00',4.02),('15128','2013-06-06','11:45:00',4.08),('15128','2013-06-06','11:50:00',4.24),('15128','2013-06-06','11:55:00',4.28),('15128','2013-06-06','12:00:00',4.32),('15128','2013-06-06','12:05:00',4.38),('15128','2013-06-06','12:10:00',4.38),('15128','2013-06-06','12:15:00',4.38),('15128','2013-06-06','12:20:00',4.38),('15128','2013-06-06','12:25:00',4.41),('15128','2013-06-06','12:30:00',4.41),('15128','2013-06-06','12:35:00',4.43),('15128','2013-06-06','12:40:00',4.46),('15128','2013-06-06','12:45:00',4.49),('15128','2013-06-06','12:50:00',4.5),('15128','2013-06-06','12:55:00',4.5),('15128','2013-06-06','13:00:00',4.54),('15128','2013-06-06','13:05:00',4.56),('15128','2013-06-06','13:10:00',4.57),('15128','2013-06-06','13:15:00',4.54),('15128','2013-06-06','13:20:00',4.52),('15128','2013-06-06','13:25:00',4.53),('15128','2013-06-06','13:30:00',4.58),('15128','2013-06-06','13:35:00',4.57),('15128','2013-06-06','13:40:00',4.56),('15128','2013-06-06','13:45:00',4.55),('15128','2013-06-06','13:50:00',4.52),('15128','2013-06-06','13:55:00',4.5),('15128','2013-06-06','14:00:00',4.51),('15128','2013-06-06','14:05:00',4.53),('15128','2013-06-06','14:10:00',4.51),('15128','2013-06-06','14:15:00',4.5),('15128','2013-06-06','14:20:00',4.52),('15128','2013-06-06','14:25:00',4.51),('15128','2013-06-06','14:30:00',4.5),('15128','2013-06-06','14:35:00',4.49),('15128','2013-06-06','14:40:00',4.47),('15128','2013-06-06','14:45:00',4.44),('15128','2013-06-06','14:50:00',4.46),('15128','2013-06-06','14:55:00',4.49),('15128','2013-06-06','15:00:00',4.43),('15128','2013-06-06','15:05:00',4.44),('15128','2013-06-06','15:10:00',4.44),('15128','2013-06-06','15:15:00',4.43),('15128','2013-06-06','15:20:00',4.42),('15128','2013-06-06','15:25:00',4.39),('15128','2013-06-06','15:30:00',4.37),('15128','2013-06-06','15:35:00',4.36),('15128','2013-06-06','15:40:00',4.32),('15128','2013-06-06','15:45:00',4.28),('15128','2013-06-06','15:50:00',4.25),('15128','2013-06-06','15:55:00',4.23),('15128','2013-06-06','16:00:00',4.21),('15128','2013-06-06','16:05:00',4.17),('15128','2013-06-06','16:10:00',4.11),('15128','2013-06-06','16:15:00',4.03),('15128','2013-06-06','16:20:00',3.98),('15128','2013-06-06','16:25:00',3.94),('15128','2013-06-06','16:30:00',3.9),('15128','2013-06-06','16:35:00',3.83),('15128','2013-06-06','16:40:00',3.77),('15128','2013-06-06','16:45:00',3.72),('15128','2013-06-06','16:50:00',3.67),('15128','2013-06-06','16:55:00',3.6),('15128','2013-06-06','17:00:00',3.55),('15128','2013-06-06','17:05:00',3.48),('15128','2013-06-06','17:10:00',3.41),('15128','2013-06-06','17:15:00',3.34),('15128','2013-06-06','17:20:00',3.25),('15128','2013-06-06','17:25:00',3.21),('15128','2013-06-06','17:30:00',3.16),('15128','2013-06-06','17:35:00',3.17),('15128','2013-06-06','17:40:00',3.19),('15128','2013-06-06','17:45:00',3.21),('15128','2013-06-06','17:50:00',2.94),('15128','2013-06-06','17:55:00',2.18),('15128','2013-06-06','18:00:00',2.64),('15128','2013-06-06','18:05:00',2.56),('15128','2013-06-06','18:10:00',1.55),('15128','2013-06-06','18:15:00',2.16),('15128','2013-06-06','18:20:00',2.07),('15128','2013-06-06','18:25:00',1.88),('15128','2013-06-06','18:30:00',1.81),('15128','2013-06-06','18:35:00',1.76),('15128','2013-06-06','18:40:00',1.68),('15128','2013-06-06','18:45:00',1.63),('15128','2013-06-06','18:50:00',1.63),('15128','2013-06-06','18:55:00',1.57),('15128','2013-06-06','19:00:00',1.5),('15128','2013-06-06','19:05:00',1.17),('15128','2013-06-06','19:15:00',1.02),('15128','2013-06-05','07:50:00',1.08),('15128','2013-06-05','07:55:00',1.06),('15128','2013-06-05','08:00:00',1.17),('15128','2013-06-05','08:10:00',1.12),('15128','2013-06-05','08:15:00',1.28),('15128','2013-06-05','08:20:00',1.43),('15128','2013-06-05','08:25:00',1.51),('15128','2013-06-05','08:30:00',1.54),('15128','2013-06-05','08:35:00',1.61),('15128','2013-06-05','08:40:00',1.72),('15128','2013-06-05','08:45:00',1.8),('15128','2013-06-05','08:50:00',1.85),('15128','2013-06-05','08:55:00',2.04),('15128','2013-06-05','09:00:00',2.06),('15128','2013-06-05','09:05:00',2.16),('15128','2013-06-05','09:10:00',2.14),('15128','2013-06-05','09:15:00',2.29),('15128','2013-06-05','09:20:00',2.23),('15128','2013-06-05','09:25:00',2.46),('15128','2013-06-05','09:30:00',2.52),('15128','2013-06-05','09:35:00',2.57),('15128','2013-06-05','09:40:00',2.66),('15128','2013-06-05','09:45:00',2.73),('15128','2013-06-05','09:50:00',2.75),('15128','2013-06-05','09:55:00',2.77),('15128','2013-06-05','10:00:00',2.81),('15128','2013-06-05','10:05:00',2.75),('15128','2013-06-05','10:10:00',2.84),('15128','2013-06-05','10:15:00',2.93),('15128','2013-06-05','10:20:00',3.02),('15128','2013-06-05','10:25:00',3.11),('15128','2013-06-05','10:30:00',3.2),('15128','2013-06-05','10:35:00',3.18),('15128','2013-06-05','10:40:00',3.25),('15128','2013-06-05','10:45:00',3.34),('15128','2013-06-05','10:50:00',3.38),('15128','2013-06-05','10:55:00',3.44),('15128','2013-06-05','11:00:00',3.57),('15128','2013-06-05','11:05:00',3.58),('15128','2013-06-05','11:10:00',3.67),('15128','2013-06-05','11:15:00',3.33),('15128','2013-06-05','11:20:00',3.76),('15128','2013-06-05','11:25:00',3.74),('15128','2013-06-05','11:30:00',3.7),('15128','2013-06-05','11:35:00',3.82),('15128','2013-06-05','11:40:00',4),('15128','2013-06-05','11:45:00',4.06),('15128','2013-06-05','11:50:00',4.14),('15128','2013-06-05','11:55:00',4.06),('15128','2013-06-05','12:00:00',4.24),('15128','2013-06-05','12:05:00',4.25),('15128','2013-06-05','12:10:00',4.33),('15128','2013-06-05','12:15:00',4.35),('15128','2013-06-05','12:20:00',4.35),('15128','2013-06-05','12:25:00',4.35),('15128','2013-06-05','12:30:00',4.38),('15128','2013-06-05','12:35:00',4.36),('15128','2013-06-05','12:40:00',4.38),('15128','2013-06-05','12:45:00',4.4),('15128','2013-06-05','12:50:00',4.49),('15128','2013-06-05','12:55:00',4.52),('15128','2013-06-05','13:00:00',4.52),('15128','2013-06-05','13:05:00',4.63),('15128','2013-06-05','13:10:00',4.58),('15128','2013-06-05','13:15:00',4.62),('15128','2013-06-05','13:20:00',3.67),('15128','2013-06-05','13:25:00',4.58),('15128','2013-06-05','13:30:00',4.45),('15128','2013-06-05','13:35:00',4.75),('15128','2013-06-05','13:40:00',4.61),('15128','2013-06-05','13:45:00',4.65),('15128','2013-06-05','13:50:00',4.6),('15128','2013-06-05','13:55:00',4.57),('15128','2013-06-05','14:00:00',4.55),('15128','2013-06-05','14:05:00',4.63),('15128','2013-06-05','14:10:00',4.68),('15128','2013-06-05','14:15:00',4.64),('15128','2013-06-05','14:20:00',4.63),('15128','2013-06-05','14:25:00',4.61),('15128','2013-06-05','14:30:00',4.57),('15128','2013-06-05','14:35:00',4.51),('15128','2013-06-05','14:40:00',4.49),('15128','2013-06-05','14:45:00',4.48),('15128','2013-06-05','14:50:00',4.45),('15128','2013-06-05','14:55:00',4.47),('15128','2013-06-05','15:00:00',4.42),('15128','2013-06-05','15:05:00',4.42),('15128','2013-06-05','15:10:00',4.37),('15128','2013-06-05','15:15:00',4.29),('15128','2013-06-05','15:20:00',4.29),('15128','2013-06-05','15:25:00',4.31),('15128','2013-06-05','15:30:00',4.26),('15128','2013-06-05','15:40:00',4.1),('15128','2013-06-05','15:45:00',4.1),('15128','2013-06-05','15:50:00',4.03),('15128','2013-06-05','15:55:00',4.02),('15128','2013-06-05','16:00:00',4.01),('15128','2013-06-05','16:05:00',3.94),('15128','2013-06-05','16:10:00',3.9),('15128','2013-06-05','16:15:00',3.89),('15128','2013-06-05','16:20:00',3.82),('15128','2013-06-05','16:25:00',3.82),('15128','2013-06-05','16:30:00',3.74),('15128','2013-06-05','16:35:00',3.69),('15128','2013-06-05','16:40:00',3.62),('15128','2013-06-05','16:45:00',3.57),('15128','2013-06-05','16:50:00',3.5),('15128','2013-06-05','16:55:00',3.42),('15128','2013-06-05','17:00:00',3.36),('15128','2013-06-05','17:05:00',3.29),('15128','2013-06-05','17:10:00',3.2),('15128','2013-06-05','17:15:00',3.15),('15128','2013-06-05','17:20:00',3.1),('15128','2013-06-05','17:25:00',2.95),('15128','2013-06-05','17:30:00',2.86),('15128','2013-06-05','17:35:00',2.81),('15128','2013-06-05','17:40:00',2.77),('15128','2013-06-05','17:45:00',2.72),('15128','2013-06-05','17:50:00',2.66),('15128','2013-06-05','17:55:00',2.53),('15128','2013-06-05','18:00:00',2.38),('15128','2013-06-05','18:05:00',2.23),('15128','2013-06-05','18:10:00',2.16),('15128','2013-06-05','18:15:00',2.05),('15128','2013-06-05','18:20:00',1.98),('15128','2013-06-05','18:25:00',1.85),('15128','2013-06-05','18:30:00',1.77),('15128','2013-06-05','18:35:00',1.7),('15128','2013-06-05','18:40:00',1.62),('15128','2013-06-05','18:45:00',1.58),('15128','2013-06-05','18:50:00',1.52),('15128','2013-06-05','18:55:00',1.41),('15128','2013-06-05','19:00:00',1.29),('15128','2013-06-05','19:05:00',1.16),('15128','2013-06-05','19:10:00',1.07),('15128','2013-06-04','07:55:00',1.05),('15128','2013-06-04','08:00:00',1.11),('15128','2013-06-04','08:05:00',1.15),('15128','2013-06-04','08:10:00',1.26),('15128','2013-06-04','08:15:00',1.33),('15128','2013-06-04','08:20:00',1.43),('15128','2013-06-04','08:25:00',1.5),('15128','2013-06-04','08:30:00',1.53),('15128','2013-06-04','08:35:00',1.59),('15128','2013-06-04','08:40:00',1.71),('15128','2013-06-04','08:45:00',1.79),('15128','2013-06-04','08:50:00',1.88),('15128','2013-06-04','08:55:00',1.98),('15128','2013-06-04','09:00:00',2.04),('15128','2013-06-04','09:05:00',2.3),('15128','2013-06-04','09:10:00',2.04),('15128','2013-06-04','09:15:00',2.28),('15128','2013-06-04','09:20:00',1.99),('15128','2013-06-04','09:25:00',1.78),('15128','2013-06-04','09:30:00',1.63),('15128','2013-06-04','09:35:00',1.33),('15128','2013-06-04','09:40:00',1.24),('15128','2013-06-04','09:45:00',2.06),('15128','2013-06-04','09:50:00',3.34),('15128','2013-06-04','09:55:00',3.27),('15128','2013-06-04','10:00:00',2.38),('15128','2013-06-04','10:05:00',1.14),('15128','2013-06-04','10:10:00',1.04),('15128','2013-06-04','10:25:00',2.49),('15128','2013-06-04','10:30:00',3.61),('15128','2013-06-04','10:35:00',3.59),('15128','2013-06-04','10:40:00',3.72),('15128','2013-06-04','10:45:00',3.48),('15128','2013-06-04','10:50:00',2.87),('15128','2013-06-04','10:55:00',3),('15128','2013-06-04','11:00:00',4.49),('15128','2013-06-04','11:05:00',3.66),('15128','2013-06-04','11:10:00',4.61),('15128','2013-06-04','11:15:00',2.26),('15128','2013-06-04','11:20:00',4.41),('15128','2013-06-04','11:25:00',3.19),('15128','2013-06-04','11:30:00',2.3),('15128','2013-06-04','11:35:00',1.22),('15128','2013-06-04','11:40:00',2.12),('15128','2013-06-04','11:45:00',4.06),('15128','2013-06-04','11:50:00',4.68),('15128','2013-06-04','11:55:00',1.47),('15128','2013-06-04','12:00:00',2.87),('15128','2013-06-04','12:05:00',4.98),('15128','2013-06-04','12:10:00',3.98),('15128','2013-06-04','12:15:00',2.41),('15128','2013-06-04','12:20:00',1.64),('15128','2013-06-04','12:25:00',2.39),('15128','2013-06-04','12:30:00',5.52),('15128','2013-06-04','12:35:00',3.8),('15128','2013-06-04','12:40:00',2.55),('15128','2013-06-04','12:45:00',4.38),('15128','2013-06-04','12:50:00',4.81),('15128','2013-06-04','12:55:00',4.5),('15128','2013-06-04','13:00:00',5.09),('15128','2013-06-04','13:05:00',4.38),('15128','2013-06-04','13:10:00',5.05),('15128','2013-06-04','13:15:00',5.01),('15128','2013-06-04','13:20:00',4.98),('15128','2013-06-04','13:25:00',4.91),('15128','2013-06-04','13:30:00',4.95),('15128','2013-06-04','13:35:00',4.9),('15128','2013-06-04','13:40:00',3.95),('15128','2013-06-04','13:45:00',4.8),('15128','2013-06-04','13:50:00',4.54),('15128','2013-06-04','13:55:00',4.82),('15128','2013-06-04','14:00:00',4.78),('15128','2013-06-04','14:05:00',4.76),('15128','2013-06-04','14:10:00',4.76),('15128','2013-06-04','14:15:00',4.78),('15128','2013-06-04','14:20:00',4.99),('15128','2013-06-04','14:25:00',4.78),('15128','2013-06-04','14:30:00',1.91),('15128','2013-06-04','14:40:00',4.19),('15128','2013-06-04','14:45:00',4.59),('15128','2013-06-04','14:50:00',4.78),('15128','2013-06-04','14:55:00',3.71),('15128','2013-06-04','15:00:00',3.9),('15128','2013-06-04','15:05:00',4.76),('15128','2013-06-04','15:10:00',3.83),('15128','2013-06-04','15:15:00',2.48),('15128','2013-06-04','15:35:00',3.76),('15128','2013-06-04','15:40:00',3.89),('15128','2013-06-04','15:45:00',3.96),('15128','2013-06-04','15:50:00',3.65),('15128','2013-06-04','15:55:00',2.14),('15128','2013-06-04','16:00:00',3.72),('15128','2013-06-04','16:05:00',4.44),('15128','2013-06-04','16:10:00',3.27),('15128','2013-06-04','16:15:00',1.71),('15128','2013-06-04','16:30:00',1.67),('15128','2013-06-04','16:35:00',4.21),('15128','2013-06-04','16:40:00',4.02),('15128','2013-06-04','16:45:00',3.44),('15128','2013-06-04','16:50:00',2.14),('15128','2013-06-04','16:55:00',1.87),('15128','2013-06-04','17:00:00',2.78),('15128','2013-06-04','17:05:00',1.64),('15128','2013-06-04','17:10:00',1.85),('15128','2013-06-04','17:15:00',1.52),('15128','2013-06-04','17:20:00',1.69),('15128','2013-06-04','17:25:00',3.46),('15128','2013-06-04','17:30:00',1.81),('15128','2013-06-04','17:35:00',2.87),('15128','2013-06-04','17:40:00',2.66),('15128','2013-06-04','17:45:00',2.72),('15128','2013-06-04','17:50:00',2.18),('15128','2013-06-04','18:00:00',2.18),('15128','2013-06-04','18:05:00',1.6),('15128','2013-06-04','18:10:00',1.62),('15128','2013-06-04','18:15:00',1.37),('15128','2013-06-04','18:20:00',2.04),('15128','2013-06-04','18:25:00',1.98),('15128','2013-06-04','18:30:00',1.15),('15128','2013-06-04','18:50:00',1.67),('15128','2013-06-04','19:00:00',1.11),('15128','2013-06-03','07:50:00',1.03),('15128','2013-06-03','07:55:00',1.07),('15128','2013-06-03','08:00:00',1.13),('15128','2013-06-03','08:05:00',1.42),('15128','2013-06-03','08:10:00',1.78),('15128','2013-06-03','08:15:00',1.82),('15128','2013-06-03','08:20:00',1.76),('15128','2013-06-03','08:25:00',1.99),('15128','2013-06-03','08:30:00',1.7),('15128','2013-06-03','08:35:00',1.74),('15128','2013-06-03','08:40:00',1.49),('15128','2013-06-03','08:45:00',1.43),('15128','2013-06-03','08:50:00',1.66),('15128','2013-06-03','08:55:00',1.79),('15128','2013-06-03','09:00:00',2.05),('15128','2013-06-03','09:05:00',1.79),('15128','2013-06-03','09:10:00',2.04),('15128','2013-06-03','09:15:00',1.92),('15128','2013-06-03','09:20:00',1.71),('15128','2013-06-03','09:25:00',1.55),('15128','2013-06-03','09:30:00',1.47),('15128','2013-06-03','09:35:00',1.5),('15128','2013-06-03','09:40:00',1.58),('15128','2013-06-03','09:45:00',1.79),('15128','2013-06-03','09:50:00',2.73),('15128','2013-06-03','09:55:00',3.39),('15128','2013-06-03','10:00:00',2.02),('15128','2013-06-03','10:05:00',1.87),('15128','2013-06-03','10:10:00',2.34),('15128','2013-06-03','10:15:00',2.11),('15128','2013-06-03','10:20:00',1.72),('15128','2013-06-03','10:25:00',1.73),('15128','2013-06-03','10:30:00',1.82),('15128','2013-06-03','10:35:00',2.15),('15128','2013-06-03','10:40:00',2.6),('15128','2013-06-03','10:45:00',2.93),('15128','2013-06-03','10:50:00',2.14),('15128','2013-06-03','10:55:00',2.22),('15128','2013-06-03','11:00:00',2.29),('15128','2013-06-03','11:05:00',2.89),('15128','2013-06-03','11:10:00',2.15),('15128','2013-06-03','11:15:00',2.21),('15128','2013-06-03','11:20:00',2.51),('15128','2013-06-03','11:25:00',2.74),('15128','2013-06-03','11:30:00',2.87),('15128','2013-06-03','11:35:00',3.42),('15128','2013-06-03','11:40:00',4.16),('15128','2013-06-03','11:45:00',4.57),('15128','2013-06-03','11:50:00',2.86),('15128','2013-06-03','11:55:00',4.89),('15128','2013-06-03','12:00:00',3.08),('15128','2013-06-03','12:05:00',3.02),('15128','2013-06-03','12:10:00',2.24),('15128','2013-06-03','12:15:00',2.51),('15128','2013-06-03','12:20:00',2.13),('15128','2013-06-03','12:25:00',3.75),('15128','2013-06-03','12:30:00',3.25),('15128','2013-06-03','12:35:00',2.38),('15128','2013-06-03','12:40:00',2.64),('15128','2013-06-03','12:45:00',1.91),('15128','2013-06-03','12:50:00',1.78),('15128','2013-06-03','12:55:00',1.69),('15128','2013-06-03','13:00:00',1.14),('15128','2013-06-03','13:10:00',1.18),('15128','2013-06-03','13:15:00',1.68),('15128','2013-06-03','13:20:00',3.4),('15128','2013-06-03','13:25:00',5.45),('15128','2013-06-03','13:30:00',4.25),('15128','2013-06-03','13:35:00',3.07),('15128','2013-06-03','13:40:00',2.98),('15128','2013-06-03','13:45:00',4.39),('15128','2013-06-03','13:50:00',3.96),('15128','2013-06-03','13:55:00',2.85),('15128','2013-06-03','14:00:00',3.21),('15128','2013-06-03','14:05:00',5.81),('15128','2013-06-03','14:10:00',4.43),('15128','2013-06-03','14:15:00',2.68),('15128','2013-06-03','14:30:00',1.43),('15128','2013-06-03','14:35:00',2.11),('15128','2013-06-03','14:40:00',2.8),('15128','2013-06-03','14:45:00',4.19),('15128','2013-06-03','14:50:00',5.87),('15128','2013-06-03','14:55:00',5.6),('15128','2013-06-03','15:00:00',4.92),('15128','2013-06-03','15:05:00',1.84),('15128','2013-06-03','15:10:00',1.95),('15128','2013-06-03','15:15:00',1.74),('15128','2013-06-03','15:20:00',1.44),('15128','2013-06-03','15:25:00',1.32),('15128','2013-06-03','15:50:00',1.09),('15128','2013-06-03','18:35:00',1.13),('15128','2013-06-03','18:40:00',1.45),('15128','2013-06-03','18:45:00',1.58),('15128','2013-06-02','07:50:00',1.01),('15128','2013-06-02','08:05:00',1.2),('15128','2013-06-02','08:10:00',1.27),('15128','2013-06-02','08:15:00',1.34),('15128','2013-06-02','08:20:00',1.44),('15128','2013-06-02','08:25:00',1.51),('15128','2013-06-02','08:30:00',1.53),('15128','2013-06-02','08:35:00',1.62),('15128','2013-06-02','08:40:00',1.6),('15128','2013-06-02','08:45:00',2.08),('15128','2013-06-02','08:50:00',1.51),('15128','2013-06-02','08:55:00',1.5),('15128','2013-06-02','09:00:00',2.06),('15128','2013-06-02','09:05:00',1.91),('15128','2013-06-02','09:10:00',1.4),('15128','2013-06-02','09:15:00',1.81),('15128','2013-06-02','09:20:00',1.57),('15128','2013-06-02','09:25:00',2.36),('15128','2013-06-02','09:30:00',3.25),('15128','2013-06-02','09:35:00',1.69),('15128','2013-06-02','09:40:00',1.34),('15128','2013-06-02','09:45:00',1.44),('15128','2013-06-02','09:50:00',1.41),('15128','2013-06-02','09:55:00',1.56),('15128','2013-06-02','10:00:00',1.54),('15128','2013-06-02','10:05:00',1.06),('15128','2013-06-02','10:25:00',1.04),('15128','2013-06-02','10:30:00',1.58),('15128','2013-06-02','10:35:00',2.27),('15128','2013-06-02','10:40:00',2.67),('15128','2013-06-02','10:45:00',1.84),('15128','2013-06-02','10:50:00',1.72),('15128','2013-06-02','10:55:00',1.65),('15128','2013-06-02','11:00:00',1.83),('15128','2013-06-02','11:05:00',2.6),('15128','2013-06-02','11:10:00',2.81),('15128','2013-06-02','11:15:00',2.5),('15128','2013-06-02','11:20:00',2.29),('15128','2013-06-02','11:25:00',2.33),('15128','2013-06-02','11:30:00',2.66),('15128','2013-06-02','11:35:00',4.15),('15128','2013-06-02','11:40:00',3.63),('15128','2013-06-02','11:45:00',5.49),('15128','2013-06-02','11:50:00',4.23),('15128','2013-06-02','11:55:00',3.11),('15128','2013-06-02','12:00:00',3.14),('15128','2013-06-02','12:05:00',1.61),('15128','2013-06-02','12:10:00',1.62),('15128','2013-06-02','12:15:00',2.91),('15128','2013-06-02','12:20:00',4.35),('15128','2013-06-02','12:25:00',3.58),('15128','2013-06-02','12:30:00',1.62),('15128','2013-06-02','12:35:00',1.5),('15128','2013-06-02','12:40:00',1.4),('15128','2013-06-02','12:45:00',1.54),('15128','2013-06-02','12:50:00',1.32),('15128','2013-06-02','12:55:00',1.16),('15128','2013-06-02','13:00:00',1.42),('15128','2013-06-02','13:05:00',1.9),('15128','2013-06-02','13:10:00',2.48),('15128','2013-06-02','13:15:00',4.18),('15128','2013-06-02','13:20:00',3.9),('15128','2013-06-02','13:25:00',1.71),('15128','2013-06-02','13:30:00',1.54),('15128','2013-06-02','13:35:00',1.93),('15128','2013-06-02','13:40:00',2.77),('15128','2013-06-02','13:45:00',3.76),('15128','2013-06-02','13:50:00',2.01),('15128','2013-06-02','13:55:00',1.46),('15128','2013-06-02','14:00:00',1.28),('15128','2013-06-02','14:05:00',1.34),('15128','2013-06-02','14:10:00',4.66),('15128','2013-06-02','14:15:00',5.62),('15128','2013-06-02','14:20:00',5.58),('15128','2013-06-02','14:25:00',5.12),('15128','2013-06-02','14:30:00',4.93),('15128','2013-06-02','14:35:00',4.88),('15128','2013-06-02','14:40:00',4.92),('15128','2013-06-02','14:45:00',4.67),('15128','2013-06-02','14:50:00',4.66),('15128','2013-06-02','14:55:00',4.56),('15128','2013-06-02','15:00:00',4.33),('15128','2013-06-02','15:05:00',4.66),('15128','2013-06-02','15:10:00',4.51),('15128','2013-06-02','15:15:00',4.62),('15128','2013-06-02','15:20:00',4.62),('15128','2013-06-02','15:25:00',4.63),('15128','2013-06-02','15:30:00',4.29),('15128','2013-06-02','15:35:00',4.52),('15128','2013-06-02','15:40:00',4.42),('15128','2013-06-02','15:45:00',4.32),('15128','2013-06-02','15:50:00',4.33),('15128','2013-06-02','15:55:00',4.28),('15128','2013-06-02','16:00:00',4.18),('15128','2013-06-02','16:05:00',4.15),('15128','2013-06-02','16:10:00',3.87),('15128','2013-06-02','16:15:00',3.67),('15128','2013-06-02','16:20:00',3.87),('15128','2013-06-02','16:25:00',3.84),('15128','2013-06-02','16:30:00',3.08),('15128','2013-06-02','16:35:00',2.98),('15128','2013-06-02','16:40:00',2.51),('15128','2013-06-02','16:45:00',2.27),('15128','2013-06-02','16:50:00',3.89),('15128','2013-06-02','16:55:00',3.7),('15128','2013-06-02','17:00:00',3.35),('15128','2013-06-02','17:05:00',2.92),('15128','2013-06-02','17:10:00',2.34),('15128','2013-06-02','17:15:00',2.62),('15128','2013-06-02','17:20:00',2.67),('15128','2013-06-02','17:25:00',2.24),('15128','2013-06-02','17:30:00',1.42),('15128','2013-06-02','17:45:00',1.18),('15128','2013-06-02','17:50:00',1.17),('15128','2013-06-01','08:40:00',1.2),('15128','2013-06-01','08:45:00',1.13),('15128','2013-06-01','08:50:00',1.01),('15128','2013-06-01','09:10:00',1.19),('15128','2013-06-01','09:15:00',1.9),('15128','2013-06-01','09:20:00',2.62),('15128','2013-06-01','09:25:00',2.62),('15128','2013-06-01','09:30:00',2.65),('15128','2013-06-01','09:35:00',2.7),('15128','2013-06-01','09:40:00',2.74),('15128','2013-06-01','09:45:00',2.76),('15128','2013-06-01','09:50:00',2.82),('15128','2013-06-01','09:55:00',2.88),('15128','2013-06-01','10:00:00',2.93),('15128','2013-06-01','10:05:00',2.98),('15128','2013-06-01','10:10:00',2.96),('15128','2013-06-01','10:15:00',3.03),('15128','2013-06-01','10:20:00',3.11),('15128','2013-06-01','10:25:00',3.08),('15128','2013-06-01','10:30:00',3.3),('15128','2013-06-01','10:35:00',3.37),('15128','2013-06-01','10:40:00',2.05),('15128','2013-06-01','10:45:00',3.55),('15128','2013-06-01','10:50:00',3.22),('15128','2013-06-01','10:55:00',4.22),('15128','2013-06-01','11:00:00',2.61),('15128','2013-06-01','11:05:00',2.95),('15128','2013-06-01','11:10:00',2.73),('15128','2013-06-01','11:15:00',1.67),('15128','2013-06-01','11:20:00',3.04),('15128','2013-06-01','11:25:00',3.67),('15128','2013-06-01','11:30:00',1.48),('15128','2013-06-01','11:35:00',3.9),('15128','2013-06-01','11:40:00',5.05),('15128','2013-06-01','11:45:00',3.48),('15128','2013-06-01','11:50:00',1.34),('15128','2013-06-01','11:55:00',2.99),('15128','2013-06-01','12:00:00',2.4),('15128','2013-06-01','12:05:00',4.88),('15128','2013-06-01','12:10:00',4.93),('15128','2013-06-01','12:15:00',4.72),('15128','2013-06-01','12:20:00',4.29),('15128','2013-06-01','12:25:00',4.7),('15128','2013-06-01','12:30:00',3.5),('15128','2013-06-01','12:35:00',4.76),('15128','2013-06-01','12:40:00',4.73),('15128','2013-06-01','12:45:00',4.69),('15128','2013-06-01','12:50:00',4.69),('15128','2013-06-01','12:55:00',4.98),('15128','2013-06-01','13:00:00',4.85),('15128','2013-06-01','13:05:00',3.82),('15128','2013-06-01','13:10:00',3.64),('15128','2013-06-01','13:15:00',4.81),('15128','2013-06-01','13:20:00',4.81),('15128','2013-06-01','13:25:00',4.8),('15128','2013-06-01','13:30:00',4.75),('15128','2013-06-01','13:35:00',4.73),('15128','2013-06-01','13:40:00',4.75),('15128','2013-06-01','13:45:00',4.76),('15128','2013-06-01','13:50:00',4.74),('15128','2013-06-01','13:55:00',4.79),('15128','2013-06-01','14:00:00',4.84),('15128','2013-06-01','14:05:00',4.82),('15128','2013-06-01','14:10:00',4.82),('15128','2013-06-01','14:15:00',4.88),('15128','2013-06-01','14:20:00',4.89),('15128','2013-06-01','14:25:00',4.86),('15128','2013-06-01','14:30:00',4.66),('15128','2013-06-01','14:35:00',4.8),('15128','2013-06-01','14:40:00',4.74),('15128','2013-06-01','14:45:00',4.65),('15128','2013-06-01','14:50:00',4.77),('15128','2013-06-01','14:55:00',4.73),('15128','2013-06-01','15:00:00',4.43),('15128','2013-06-01','15:05:00',4.66),('15128','2013-06-01','15:10:00',4.57),('15128','2013-06-01','15:15:00',4.69),('15128','2013-06-01','15:20:00',4.58),('15128','2013-06-01','15:25:00',3.72),('15128','2013-06-01','15:30:00',2.84),('15128','2013-06-01','15:35:00',4.49),('15128','2013-06-01','15:40:00',4.99),('15128','2013-06-01','15:45:00',2.75),('15128','2013-06-01','15:50:00',4.26),('15128','2013-06-01','15:55:00',3.2),('15128','2013-06-01','16:00:00',3.05),('15128','2013-06-01','16:05:00',3.05),('15128','2013-06-01','16:10:00',3.59),('15128','2013-06-01','16:15:00',4.47),('15128','2013-06-01','16:20:00',3.93),('15128','2013-06-01','16:25:00',4.18),('15128','2013-06-01','16:30:00',3.9),('15128','2013-06-01','16:35:00',4),('15128','2013-06-01','16:40:00',3.86),('15128','2013-06-01','16:45:00',3.28),('15128','2013-06-01','16:50:00',3.58),('15128','2013-06-01','16:55:00',3.38),('15128','2013-06-01','17:00:00',3.6),('15128','2013-06-01','17:05:00',3.37),('15128','2013-06-01','17:10:00',3.49),('15128','2013-06-01','17:15:00',3.35),('15128','2013-06-01','17:20:00',2.96),('15128','2013-06-01','17:25:00',2.94),('15128','2013-06-01','17:30:00',2.5),('15128','2013-06-01','17:35:00',1.69),('15128','2013-06-01','17:40:00',1.69),('15128','2013-06-01','17:45:00',1.31),('15128','2013-06-01','17:50:00',1.96),('15128','2013-06-01','17:55:00',1.58),('15128','2013-06-01','18:05:00',1.11),('15128','2013-06-01','18:10:00',1.26),('15128','2013-06-01','18:15:00',1.09),('15128','2013-06-01','18:20:00',1.12),('15128','2013-06-01','18:40:00',1.02),('15128','2013-05-31','07:45:00',1.14),('15128','2013-05-31','07:50:00',1.5),('15128','2013-05-31','08:10:00',1.2),('15128','2013-05-31','08:15:00',1.81),('15128','2013-05-31','08:25:00',1.12),('15128','2013-05-31','08:30:00',1.14),('15128','2013-05-31','08:45:00',1.4),('15128','2013-05-31','10:35:00',1.14),('15128','2013-05-31','10:45:00',1.4),('15128','2013-05-31','10:50:00',2.73),('15128','2013-05-31','10:55:00',4.28),('15128','2013-05-31','11:00:00',1.85),('15128','2013-05-31','11:05:00',1.87),('15128','2013-05-31','11:10:00',1.56),('15128','2013-05-31','11:15:00',1.45),('15128','2013-05-31','11:20:00',1.98),('15128','2013-05-31','11:25:00',1.98),('15128','2013-05-31','11:30:00',1.9),('15128','2013-05-31','11:35:00',2.04),('15128','2013-05-31','11:40:00',2.2),('15128','2013-05-31','11:45:00',1.87),('15128','2013-05-31','11:50:00',3.41),('15128','2013-05-31','11:55:00',1.29),('15128','2013-05-31','12:10:00',1.87),('15128','2013-05-31','12:15:00',1.94),('15128','2013-05-31','12:20:00',2.3),('15128','2013-05-31','12:25:00',5.36),('15128','2013-05-31','12:30:00',2.16),('15128','2013-05-31','12:35:00',2.03),('15128','2013-05-31','12:40:00',2.41),('15128','2013-05-31','12:45:00',2.18),('15128','2013-05-31','12:50:00',2.19),('15128','2013-05-31','12:55:00',2.38),('15128','2013-05-31','13:00:00',2.46),('15128','2013-05-31','13:05:00',2.46),('15128','2013-05-31','13:10:00',2.62),('15128','2013-05-31','13:15:00',2.79),('15128','2013-05-31','13:20:00',2.67),('15128','2013-05-31','13:25:00',2.63),('15128','2013-05-31','13:30:00',2.35),('15128','2013-05-31','13:35:00',2.03),('15128','2013-05-31','13:40:00',2.35),('15128','2013-05-31','13:45:00',1.62),('15128','2013-05-31','13:50:00',1.61),('15128','2013-05-31','13:55:00',1.79),('15128','2013-05-31','14:00:00',2.61),('15128','2013-05-31','14:05:00',3.02),('15128','2013-05-31','14:10:00',2.75),('15128','2013-05-31','14:15:00',2.46),('15128','2013-05-31','14:20:00',3.25),('15128','2013-05-31','14:25:00',2.16),('15128','2013-05-31','14:30:00',1.95),('15128','2013-05-31','14:35:00',1.54),('15128','2013-05-31','14:40:00',1.45),('15128','2013-05-31','14:45:00',1.45),('15128','2013-05-31','14:50:00',1.54),('15128','2013-05-31','14:55:00',1.41),('15128','2013-05-31','15:00:00',1.03),('15128','2013-05-31','15:05:00',1.13),('15128','2013-05-31','15:45:00',1.4),('15128','2013-05-31','15:50:00',1.78),('15128','2013-05-31','15:55:00',1.71),('15128','2013-05-31','16:00:00',1.36),('15128','2013-05-31','16:05:00',1.05),('15128','2013-05-31','16:15:00',1.35),('15128','2013-05-31','16:20:00',1.37),('15128','2013-05-31','16:25:00',1.29),('15128','2013-05-31','16:30:00',1.16),('15128','2013-05-31','16:35:00',1.08),('15128','2013-05-31','16:40:00',1.12),('15128','2013-05-31','18:30:00',1.06),('15128','2013-05-31','18:35:00',1),('15128','2013-05-31','18:40:00',1.15),('15128','2013-05-31','18:45:00',1.78),('15128','2013-05-31','18:50:00',1.45),('15128','2013-05-31','18:55:00',1.85),('15128','2013-05-31','19:00:00',1.09),('15128','2014-04-01','09:10:00',1.4),('15128','2014-04-01','09:15:00',1.49),('15128','2014-04-01','09:20:00',1.81),('15128','2014-04-01','09:25:00',1.15),('15128','2014-04-01','10:00:00',1.38),('15128','2014-04-01','10:05:00',2.2),('15128','2014-04-01','10:10:00',2.58),('15128','2014-04-01','10:15:00',2.06),('15128','2014-04-01','10:20:00',1.14),('15128','2014-04-01','10:40:00',1.13),('15128','2014-04-01','10:45:00',1.88),('15128','2014-04-01','10:50:00',2.03),('15128','2014-04-01','10:55:00',2.24),('15128','2014-04-01','11:00:00',1.21),('15128','2014-04-01','11:05:00',1.25),('15128','2014-04-01','11:10:00',1.38),('15128','2014-04-01','11:15:00',2.23),('15128','2014-04-01','11:20:00',2.16),('15128','2014-04-01','11:25:00',1.57),('15128','2014-04-01','11:35:00',1.05),('15128','2014-04-01','11:40:00',1.44),('15128','2014-04-01','11:45:00',3.25),('15128','2014-04-01','11:50:00',3.68),('15128','2014-04-01','11:55:00',4.1),('15128','2014-04-01','12:00:00',2.13),('15128','2014-04-01','12:05:00',1.37),('15128','2014-04-01','12:10:00',2.93),('15128','2014-04-01','12:15:00',3.4),('15128','2014-04-01','12:20:00',2.17),('15128','2014-04-01','12:25:00',1.85),('15128','2014-04-01','12:30:00',2.29),('15128','2014-04-01','12:35:00',2.41),('15128','2014-04-01','12:40:00',3.96),('15128','2014-04-01','12:45:00',1.93),('15128','2014-04-01','12:50:00',2.23),('15128','2014-04-01','12:55:00',2.19),('15128','2014-04-01','13:00:00',1.34),('15128','2014-04-01','13:05:00',3.54),('15128','2014-04-01','13:10:00',3.16),('15128','2014-04-01','13:15:00',2.47),('15128','2014-04-01','13:20:00',4.02),('15128','2014-04-01','13:25:00',3.87),('15128','2014-04-01','13:30:00',3.59),('15128','2014-04-01','13:35:00',3.9),('15128','2014-04-01','13:40:00',4.05),('15128','2014-04-01','13:45:00',3.68),('15128','2014-04-01','13:50:00',3.89),('15128','2014-04-01','13:55:00',3.09),('15128','2014-04-01','14:00:00',3.12),('15128','2014-04-01','14:05:00',4.15),('15128','2014-04-01','14:10:00',3.18),('15128','2014-04-01','14:15:00',4.16),('15128','2014-04-01','14:20:00',3.99),('15128','2014-04-01','14:25:00',4.02),('15128','2014-04-01','14:30:00',3.66),('15128','2014-04-01','14:35:00',3.96),('15128','2014-04-01','14:40:00',3.95),('15128','2014-04-01','14:45:00',3.78),('15128','2014-04-01','14:50:00',3.47),('15128','2014-04-01','14:55:00',3.77),('15128','2014-04-01','15:00:00',3.75),('15128','2014-04-01','15:05:00',3.77),('15128','2014-04-01','15:10:00',3.4),('15128','2014-04-01','15:15:00',3.52),('15128','2014-04-01','15:20:00',3.63),('15128','2014-04-01','15:25:00',3.38),('15128','2014-04-01','15:30:00',3.33),('15128','2014-04-01','15:35:00',3.6),('15128','2014-04-01','15:40:00',3.6),('15128','2014-04-01','15:45:00',3.47),('15128','2014-04-01','15:50:00',3.19),('15128','2014-04-01','15:55:00',3.22),('15128','2014-04-01','16:00:00',3.28),('15128','2014-04-01','16:05:00',3.21),('15128','2014-04-01','16:10:00',3.2),('15128','2014-04-01','16:15:00',3.13),('15128','2014-04-01','16:20:00',3),('15128','2014-04-01','16:25:00',2.95),('15128','2014-04-01','16:30:00',2.95),('15128','2014-04-01','16:35:00',2.83),('15128','2014-04-01','16:40:00',2.83),('15128','2014-04-01','16:45:00',2.62),('15128','2014-04-01','16:50:00',2.56),('15128','2014-04-01','16:55:00',2.66),('15128','2014-04-01','17:00:00',2.53),('15128','2014-04-01','17:05:00',2.39),('15128','2014-04-01','17:10:00',2.31),('15128','2014-04-01','17:15:00',2.13),('15128','2014-04-01','17:20:00',2.04),('15128','2014-04-01','17:25:00',1.92),('15128','2014-04-01','17:30:00',1.76),('15128','2014-04-01','17:35:00',1.6),('15128','2014-04-01','17:40:00',1.39),('15128','2014-04-01','17:45:00',1.52),('15128','2014-04-01','17:50:00',1.56),('15128','2014-04-01','17:55:00',1.36),('15128','2013-05-30','07:50:00',1.02),('15128','2013-05-30','07:55:00',1.22),('15128','2013-05-30','08:10:00',1.06),('15128','2013-05-30','08:15:00',1.35),('15128','2013-05-30','08:20:00',1.45),('15128','2013-05-30','08:25:00',1.52),('15128','2013-05-30','08:30:00',1.62),('15128','2013-05-30','08:35:00',1.66),('15128','2013-05-30','08:40:00',1.71),('15128','2013-05-30','08:45:00',1.3),('15128','2013-05-30','08:50:00',1.18),('15128','2013-05-30','08:55:00',1.44),('15128','2013-05-30','09:00:00',1.87),('15128','2013-05-30','09:05:00',1.27),('15128','2013-05-30','09:10:00',2.41),('15128','2013-05-30','09:15:00',1.85),('15128','2013-05-30','09:20:00',1.57),('15128','2013-05-30','09:25:00',2.43),('15128','2013-05-30','09:30:00',2.83),('15128','2013-05-30','09:35:00',2.76),('15128','2013-05-30','09:40:00',2.73),('15128','2013-05-30','09:45:00',2.94),('15128','2013-05-30','09:50:00',2.98),('15128','2013-05-30','09:55:00',3.36),('15128','2013-05-30','10:00:00',3.13),('15128','2013-05-30','10:05:00',2.92),('15128','2013-05-30','10:10:00',2.25),('15128','2013-05-30','10:15:00',2.32),('15128','2013-05-30','10:20:00',1.98),('15128','2013-05-30','10:25:00',1.93),('15128','2013-05-30','10:30:00',3.12),('15128','2013-05-30','10:35:00',3.67),('15128','2013-05-30','10:40:00',3.78),('15128','2013-05-30','10:45:00',4.15),('15128','2013-05-30','10:50:00',3.33),('15128','2013-05-30','10:55:00',2.97),('15128','2013-05-30','11:00:00',1.67),('15128','2013-05-30','11:05:00',2.02),('15128','2013-05-30','11:10:00',1.89),('15128','2013-05-30','11:15:00',1.89),('15128','2013-05-30','11:20:00',3.34),('15128','2013-05-30','11:25:00',3.13),('15128','2013-05-30','11:30:00',1.89),('15128','2013-05-30','11:35:00',2.41),('15128','2013-05-30','11:40:00',3.39),('15128','2013-05-30','11:45:00',2.81),('15128','2013-05-30','11:50:00',3.22),('15128','2013-05-30','11:55:00',2.48),('15128','2013-05-30','12:00:00',4.58),('15128','2013-05-30','12:05:00',4.03),('15128','2013-05-30','12:10:00',2.92),('15128','2013-05-30','12:15:00',3.27),('15128','2013-05-30','12:20:00',3.64),('15128','2013-05-30','12:25:00',2.77),('15128','2013-05-30','12:30:00',2.12),('15128','2013-05-30','12:35:00',1.63),('15128','2013-05-30','12:50:00',4.31),('15128','2013-05-30','12:55:00',5.18),('15128','2013-05-30','13:00:00',1.9),('15128','2013-05-30','13:05:00',1.48),('15128','2013-05-30','13:10:00',1.85),('15128','2013-05-30','13:15:00',3.6),('15128','2013-05-30','13:20:00',3.02),('15128','2013-05-30','13:25:00',5.12),('15128','2013-05-30','13:30:00',1.9),('15128','2013-05-30','13:35:00',1.42),('15128','2013-05-30','13:40:00',2),('15128','2013-05-30','13:45:00',4.11),('15128','2013-05-30','13:50:00',4.2),('15128','2013-05-30','13:55:00',2.09),('15128','2013-05-30','14:25:00',1.72),('15128','2013-05-30','14:30:00',2.43),('15128','2013-05-30','14:35:00',1.4),('15128','2013-05-30','14:55:00',1.63),('15128','2013-05-30','15:00:00',1.34),('15128','2013-05-30','15:05:00',1.6),('15128','2013-05-30','15:10:00',3.14),('15128','2013-05-30','15:15:00',3.3),('15128','2013-05-30','15:20:00',2.5),('15128','2013-05-30','15:25:00',2.83),('15128','2013-05-30','15:30:00',2.34),('15128','2013-05-30','15:35:00',2.25),('15128','2013-05-30','15:40:00',1.98),('15128','2013-05-30','15:45:00',3.1),('15128','2013-05-30','15:50:00',2.51),('15128','2013-05-30','15:55:00',2.68),('15128','2013-05-30','16:00:00',1.62),('15128','2013-05-30','16:05:00',1.12),('15128','2013-05-30','16:20:00',1.53),('15128','2013-05-30','16:25:00',1.38),('15128','2013-05-30','16:30:00',1.09),('15128','2013-05-30','16:40:00',1.2),('15128','2013-05-29','07:45:00',1.2),('15128','2013-05-29','07:50:00',1.08),('15128','2013-05-29','08:30:00',1.72),('15128','2013-05-29','08:35:00',1.77),('15128','2013-05-29','08:40:00',1.86),('15128','2013-05-29','08:45:00',1.92),('15128','2013-05-29','08:50:00',2.01),('15128','2013-05-29','08:55:00',2.15),('15128','2013-05-29','09:00:00',2.24),('15128','2013-05-29','09:05:00',2.32),('15128','2013-05-29','09:10:00',2.49),('15128','2013-05-29','09:15:00',2.65),('15128','2013-05-29','09:20:00',1.35),('15128','2013-05-29','09:25:00',2.4),('15128','2013-05-29','09:30:00',1.25),('15128','2013-05-29','09:40:00',1.66),('15128','2013-05-29','09:45:00',1.17),('15128','2013-05-29','09:50:00',1.8),('15128','2013-05-29','09:55:00',2.86),('15128','2013-05-29','10:00:00',2.31),('15128','2013-05-29','10:05:00',3.26),('15128','2013-05-29','10:10:00',3.63),('15128','2013-05-29','10:15:00',1.95),('15128','2013-05-29','10:20:00',2.66),('15128','2013-05-29','10:25:00',2.86),('15128','2013-05-29','10:30:00',1.3),('15128','2013-05-29','10:35:00',3.03),('15128','2013-05-29','10:40:00',2.3),('15128','2013-05-29','10:45:00',3.99),('15128','2013-05-29','10:50:00',4.03),('15128','2013-05-29','10:55:00',3.32),('15128','2013-05-29','11:00:00',2.03),('15128','2013-05-29','11:05:00',2.82),('15128','2013-05-29','11:10:00',2.88),('15128','2013-05-29','11:15:00',2.62),('15128','2013-05-29','11:20:00',3.04),('15128','2013-05-29','11:25:00',3.79),('15128','2013-05-29','11:30:00',1.43),('15128','2013-05-29','11:35:00',2.96),('15128','2013-05-29','11:40:00',3.59),('15128','2013-05-29','11:45:00',3.6),('15128','2013-05-29','11:50:00',4.35),('15128','2013-05-29','11:55:00',5.54),('15128','2013-05-29','12:00:00',1.9),('15128','2013-05-29','12:05:00',1.76),('15128','2013-05-29','12:10:00',5.78),('15128','2013-05-29','12:15:00',3.88),('15128','2013-05-29','12:20:00',2.26),('15128','2013-05-29','12:25:00',4.51),('15128','2013-05-29','12:30:00',3.9),('15128','2013-05-29','12:35:00',5.41),('15128','2013-05-29','12:40:00',2.63),('15128','2013-05-29','12:45:00',3.97),('15128','2013-05-29','12:50:00',2.68),('15128','2013-05-29','12:55:00',5.04),('15128','2013-05-29','13:00:00',5.2),('15128','2013-05-29','13:05:00',5.22),('15128','2013-05-29','13:10:00',2.05),('15128','2013-05-29','13:15:00',2.11),('15128','2013-05-29','13:20:00',2.66),('15128','2013-05-29','13:25:00',5.88),('15128','2013-05-29','13:30:00',4.85),('15128','2013-05-29','13:35:00',4.92),('15128','2013-05-29','13:40:00',3.71),('15128','2013-05-29','13:45:00',5.32),('15128','2013-05-29','13:50:00',5.14),('15128','2013-05-29','13:55:00',1.73),('15128','2013-05-29','14:00:00',1),('15128','2013-05-29','14:05:00',3.59),('15128','2013-05-29','14:10:00',2.63),('15128','2013-05-29','14:15:00',1.74),('15128','2013-05-29','14:20:00',1.54),('15128','2013-05-29','14:25:00',2.86),('15128','2013-05-29','14:30:00',1.81),('15128','2013-05-29','14:35:00',2.52),('15128','2013-05-29','14:40:00',3.95),('15128','2013-05-29','14:45:00',2.11),('15128','2013-05-29','14:50:00',1.73),('15128','2013-05-29','14:55:00',3.16),('15128','2013-05-29','15:00:00',1.55),('15128','2013-05-29','15:05:00',2.24),('15128','2013-05-29','15:10:00',3.83),('15128','2013-05-29','15:15:00',4.08),('15128','2013-05-29','15:20:00',2.86),('15128','2013-05-29','15:25:00',1.92),('15128','2013-05-29','15:30:00',2.87),('15128','2013-05-29','15:35:00',4.59),('15128','2013-05-29','15:40:00',3.17),('15128','2013-05-29','15:45:00',3.25),('15128','2013-05-29','15:50:00',3.11),('15128','2013-05-29','15:55:00',1.86),('15128','2013-05-29','16:00:00',4.89),('15128','2013-05-29','16:05:00',4.9),('15128','2013-05-29','16:10:00',3.92),('15128','2013-05-29','16:15:00',1.93),('15128','2013-05-29','16:20:00',1.57),('15128','2013-05-29','16:25:00',1.63),('15128','2013-05-29','16:30:00',1.61),('15128','2013-05-29','16:35:00',1.74),('15128','2013-05-29','16:40:00',2.53),('15128','2013-05-29','16:45:00',1.49),('15128','2013-05-29','16:50:00',1.37),('15128','2013-05-29','16:55:00',4.47),('15128','2013-05-29','17:00:00',3.54),('15128','2013-05-29','17:50:00',1.63),('15128','2013-05-29','17:55:00',1.42),('15128','2013-05-29','18:00:00',1.86),('15128','2013-05-29','18:05:00',2.33),('15128','2013-05-29','18:10:00',1.53),('15128','2013-05-29','18:20:00',1.27),('15128','2013-05-29','18:25:00',2.52),('15128','2013-05-29','18:30:00',2.56),('15128','2013-05-29','18:35:00',2.37),('15128','2013-05-29','18:40:00',1.52),('15128','2013-05-29','18:45:00',1.08),('15128','2013-05-28','07:55:00',1.02),('15128','2013-05-28','08:00:00',1.12),('15128','2013-05-28','08:05:00',1.19),('15128','2013-05-28','08:10:00',1.26),('15128','2013-05-28','08:15:00',1.33),('15128','2013-05-28','08:20:00',1.43),('15128','2013-05-28','08:25:00',1.51),('15128','2013-05-28','08:30:00',1.59),('15128','2013-05-28','08:35:00',1.66),('15128','2013-05-28','08:40:00',1.78),('15128','2013-05-28','08:45:00',1.85),('15128','2013-05-28','08:50:00',1.93),('15128','2013-05-28','08:55:00',2.05),('15128','2013-05-28','09:00:00',2.12),('15128','2013-05-28','09:05:00',2.21),('15128','2013-05-28','09:10:00',2.3),('15128','2013-05-28','09:15:00',2.38),('15128','2013-05-28','09:20:00',2.43),('15128','2013-05-28','09:25:00',2.48),('15128','2013-05-28','09:30:00',2.55),('15128','2013-05-28','09:35:00',2.62),('15128','2013-05-28','09:40:00',2.69),('15128','2013-05-28','09:45:00',2.74),('15128','2013-05-28','09:50:00',2.8),('15128','2013-05-28','09:55:00',2.86),('15128','2013-05-28','10:00:00',2.92),('15128','2013-05-28','10:05:00',2.99),('15128','2013-05-28','10:10:00',2.99),('15128','2013-05-28','10:15:00',3.02),('15128','2013-05-28','10:20:00',3.12),('15128','2013-05-28','10:25:00',3.23),('15128','2013-05-28','10:30:00',3.29),('15128','2013-05-28','10:35:00',3.36),('15128','2013-05-28','10:40:00',3.47),('15128','2013-05-28','10:45:00',3.48),('15128','2013-05-28','10:50:00',3.71),('15128','2013-05-28','10:55:00',2.74),('15128','2013-05-28','11:00:00',3.7),('15128','2013-05-28','11:05:00',4.26),('15128','2013-05-28','11:10:00',3.32),('15128','2013-05-28','11:15:00',2.64),('15128','2013-05-28','11:20:00',3.08),('15128','2013-05-28','11:25:00',2.82),('15128','2013-05-28','11:30:00',2.81),('15128','2013-05-28','11:35:00',2.2),('15128','2013-05-28','11:40:00',4.49),('15128','2013-05-28','11:45:00',3.7),('15128','2013-05-28','11:50:00',4.1),('15128','2013-05-28','11:55:00',3.64),('15128','2013-05-28','12:00:00',4.43),('15128','2013-05-28','12:05:00',4.74),('15128','2013-05-28','12:10:00',4.54),('15128','2013-05-28','12:15:00',3.4),('15128','2013-05-28','12:20:00',4.72),('15128','2013-05-28','12:25:00',4.5),('15128','2013-05-28','12:30:00',4.3),('15128','2013-05-28','12:35:00',4.49),('15128','2013-05-28','12:40:00',4.88),('15128','2013-05-28','12:45:00',4.78),('15128','2013-05-28','12:50:00',4.83),('15128','2013-05-28','12:55:00',4.91),('15128','2013-05-28','13:00:00',4.99),('15128','2013-05-28','13:05:00',4.88),('15128','2013-05-28','13:10:00',4.79),('15128','2013-05-28','13:15:00',3.46),('15128','2013-05-28','13:20:00',3.32),('15128','2013-05-28','13:25:00',5.19),('15128','2013-05-28','13:30:00',2.33),('15128','2013-05-28','13:35:00',2.82),('15128','2013-05-28','13:40:00',3.63),('15128','2013-05-28','13:45:00',3.51),('15128','2013-05-28','13:50:00',3.6),('15128','2013-05-28','13:55:00',5.18),('15128','2013-05-28','14:00:00',5.16),('15128','2013-05-28','14:05:00',4.83),('15128','2013-05-28','14:10:00',4.82),('15128','2013-05-28','14:15:00',4.46),('15128','2013-05-28','14:20:00',4.43),('15128','2013-05-28','14:25:00',4),('15128','2013-05-28','14:30:00',3.82),('15128','2013-05-28','14:35:00',4.01),('15128','2013-05-28','14:40:00',3.76),('15128','2013-05-28','14:45:00',4.7),('15128','2013-05-28','14:50:00',5.2),('15128','2013-05-28','14:55:00',5.13),('15128','2013-05-28','15:00:00',4.49),('15128','2013-05-28','15:05:00',4.95),('15128','2013-05-28','15:10:00',3.75),('15128','2013-05-28','15:15:00',3.76),('15128','2013-05-28','15:20:00',3.56),('15128','2013-05-28','15:25:00',4.04),('15128','2013-05-28','15:30:00',4.57),('15128','2013-05-28','15:35:00',4.07),('15128','2013-05-28','15:40:00',4.01),('15128','2013-05-28','15:45:00',3.66),('15128','2013-05-28','15:50:00',3.27),('15128','2013-05-28','15:55:00',3.01),('15128','2013-05-28','16:00:00',2.56),('15128','2013-05-28','16:05:00',2.73),('15128','2013-05-28','16:10:00',2.9),('15128','2013-05-28','16:15:00',3.06),('15128','2013-05-28','16:20:00',3.52),('15128','2013-05-28','16:25:00',3.24),('15128','2013-05-28','16:30:00',2.77),('15128','2013-05-28','16:35:00',2.4),('15128','2013-05-28','16:40:00',2.17),('15128','2013-05-28','16:45:00',1.72),('15128','2013-05-28','16:50:00',1.21),('15128','2013-05-28','17:25:00',1.06),('15128','2013-05-28','17:30:00',1.74),('15128','2013-05-28','17:35:00',2.14),('15128','2013-05-28','17:40:00',1.95),('15128','2013-05-28','17:45:00',1.2),('15128','2013-05-28','17:50:00',1.06),('15128','2013-05-28','17:55:00',1.35),('15128','2013-05-28','18:00:00',1.51),('15128','2013-05-28','18:05:00',1.44),('15128','2013-05-28','18:10:00',2.22),('15128','2013-05-28','18:15:00',2.15),('15128','2013-05-27','08:05:00',1.06),('15128','2013-05-27','08:10:00',1.23),('15128','2013-05-27','08:15:00',1.46),('15128','2013-05-27','08:20:00',1.53),('15128','2013-05-27','08:25:00',1.3),('15128','2013-05-27','08:30:00',1.56),('15128','2013-05-27','08:35:00',1.66),('15128','2013-05-27','08:40:00',1.57),('15128','2013-05-27','08:45:00',1.43),('15128','2013-05-27','08:50:00',1.49),('15128','2013-05-27','08:55:00',1.77),('15128','2013-05-27','09:00:00',1.67),('15128','2013-05-27','09:05:00',1.69),('15128','2013-05-27','09:10:00',1.81),('15128','2013-05-27','09:15:00',1.89),('15128','2013-05-27','09:20:00',1.92),('15128','2013-05-27','09:25:00',2),('15128','2013-05-27','09:30:00',2.15),('15128','2013-05-27','09:35:00',2.36),('15128','2013-05-27','09:40:00',2.24),('15128','2013-05-27','09:45:00',2.39),('15128','2013-05-27','09:50:00',2.35),('15128','2013-05-27','09:55:00',2.5),('15128','2013-05-27','10:00:00',2.13),('15128','2013-05-27','10:05:00',2.16),('15128','2013-05-27','10:10:00',2.31),('15128','2013-05-27','10:15:00',2.48),('15128','2013-05-27','10:20:00',2.44),('15128','2013-05-27','10:25:00',2.43),('15128','2013-05-27','10:30:00',2.69),('15128','2013-05-27','10:35:00',2.93),('15128','2013-05-27','10:40:00',3.08),('15128','2013-05-27','10:45:00',2.83),('15128','2013-05-27','10:50:00',2.72),('15128','2013-05-27','10:55:00',2.77),('15128','2013-05-27','11:00:00',2.93),('15128','2013-05-27','11:05:00',3.23),('15128','2013-05-27','11:10:00',3.19),('15128','2013-05-27','11:15:00',2.83),('15128','2013-05-27','11:20:00',2.08),('15128','2013-05-27','11:25:00',2.98),('15128','2013-05-27','11:30:00',3.5),('15128','2013-05-27','11:35:00',3.36),('15128','2013-05-27','11:40:00',4.11),('15128','2013-05-27','11:45:00',1.94),('15128','2013-05-27','11:50:00',1.21),('15128','2013-05-27','11:55:00',1.21),('15128','2013-05-27','12:00:00',1.95),('15128','2013-05-27','12:05:00',2.54),('15128','2013-05-27','12:10:00',2.81),('15128','2013-05-27','12:15:00',2.86),('15128','2013-05-27','12:20:00',2.65),('15128','2013-05-27','12:25:00',2.93),('15128','2013-05-27','12:30:00',3.24),('15128','2013-05-27','12:35:00',2.24),('15128','2013-05-27','12:40:00',2.4),('15128','2013-05-27','12:45:00',2.36),('15128','2013-05-27','12:50:00',2.37),('15128','2013-05-27','12:55:00',2.66),('15128','2013-05-27','13:00:00',2.97),('15128','2013-05-27','13:05:00',2.89),('15128','2013-05-27','13:10:00',2.79),('15128','2013-05-27','13:15:00',1.77),('15128','2013-05-27','13:20:00',2.19),('15128','2013-05-27','13:25:00',4.01),('15128','2013-05-27','13:30:00',4),('15128','2013-05-27','13:35:00',4.1),('15128','2013-05-27','13:40:00',2.56),('15128','2013-05-27','13:45:00',2.64),('15128','2013-05-27','13:50:00',2.13),('15128','2013-05-27','13:55:00',2.6),('15128','2013-05-27','14:00:00',1.99),('15128','2013-05-27','14:05:00',2.65),('15128','2013-05-27','14:10:00',2.69),('15128','2013-05-27','14:15:00',3.17),('15128','2013-05-27','14:20:00',4.2),('15128','2013-05-27','14:25:00',3.75),('15128','2013-05-27','14:30:00',3.56),('15128','2013-05-27','14:35:00',3.88),('15128','2013-05-27','14:40:00',3.15),('15128','2013-05-27','14:45:00',2.98),('15128','2013-05-27','14:50:00',3.77),('15128','2013-05-27','14:55:00',3.95),('15128','2013-05-27','15:00:00',4.27),('15128','2013-05-27','15:05:00',3.08),('15128','2013-05-27','15:10:00',2.14),('15128','2013-05-27','15:15:00',2.36),('15128','2013-05-27','15:20:00',2.56),('15128','2013-05-27','15:25:00',2.01),('15128','2013-05-27','15:30:00',2),('15128','2013-05-27','15:35:00',2.38),('15128','2013-05-27','15:40:00',2.1),('15128','2013-05-27','15:45:00',2.09),('15128','2013-05-27','15:50:00',2.41),('15128','2013-05-27','15:55:00',3.99),('15128','2013-05-27','16:00:00',2.92),('15128','2013-05-27','16:05:00',3.78),('15128','2013-05-27','16:10:00',2.42),('15128','2013-05-27','16:15:00',2.13),('15128','2013-05-27','16:20:00',2.46),('15128','2013-05-27','16:25:00',1.73),('15128','2013-05-27','16:30:00',1.52),('15128','2013-05-27','16:35:00',1.56),('15128','2013-05-27','16:40:00',2.06),('15128','2013-05-27','16:45:00',3.76),('15128','2013-05-27','16:50:00',3.5),('15128','2013-05-27','16:55:00',3.39),('15128','2013-05-27','17:00:00',3.33),('15128','2013-05-27','17:05:00',3.26),('15128','2013-05-27','17:10:00',3.2),('15128','2013-05-27','17:15:00',3.13),('15128','2013-05-27','17:20:00',3.07),('15128','2013-05-27','17:25:00',2.98),('15128','2013-05-27','17:30:00',2.93),('15128','2013-05-27','17:35:00',2.86),('15128','2013-05-27','17:40:00',2.73),('15128','2013-05-27','17:45:00',2.61),('15128','2013-05-27','17:50:00',2.48),('15128','2013-05-27','17:55:00',1.86),('15128','2013-05-27','18:00:00',1.38),('15128','2013-05-27','18:05:00',1.06),('15128','2013-05-27','18:10:00',1.27),('15128','2013-05-27','18:15:00',1.39),('15128','2013-05-27','18:20:00',2.13),('15128','2013-05-27','18:25:00',1.93),('15128','2013-05-27','18:30:00',1.77),('15128','2013-05-27','18:35:00',1.64),('15128','2013-05-27','18:40:00',1.59),('15128','2013-05-27','18:45:00',1.53),('15128','2013-05-27','18:50:00',1.46),('15128','2013-05-27','18:55:00',1.36),('15128','2013-05-27','19:00:00',1.23),('15128','2013-05-27','19:05:00',1.12),('15128','2013-05-26','08:00:00',1.12),('15128','2013-05-26','08:05:00',1.29),('15128','2013-05-26','08:10:00',1.46),('15128','2013-05-26','08:15:00',1.04),('15128','2013-05-26','08:25:00',1.69),('15128','2013-05-26','08:30:00',1.8),('15128','2013-05-26','08:35:00',1.97),('15128','2013-05-26','08:40:00',2),('15128','2013-05-26','08:45:00',1.57),('15128','2013-05-26','08:50:00',2.16),('15128','2013-05-26','08:55:00',2.15),('15128','2013-05-26','09:00:00',2.19),('15128','2013-05-26','09:05:00',2.6),('15128','2013-05-26','09:10:00',1.56),('15128','2013-05-26','09:15:00',2.5),('15128','2013-05-26','09:20:00',2.93),('15128','2013-05-26','09:25:00',1.87),('15128','2013-05-26','09:30:00',1.21),('15128','2013-05-26','09:35:00',2.81),('15128','2013-05-26','09:40:00',2.84),('15128','2013-05-26','09:45:00',2.87),('15128','2013-05-26','09:50:00',2.99),('15128','2013-05-26','09:55:00',3.05),('15128','2013-05-26','10:00:00',3.07),('15128','2013-05-26','10:05:00',2.04),('15128','2013-05-26','10:10:00',1.83),('15128','2013-05-26','10:15:00',3.49),('15128','2013-05-26','10:20:00',2.58),('15128','2013-05-26','10:25:00',3.55),('15128','2013-05-26','10:30:00',3.81),('15128','2013-05-26','10:35:00',2.72),('15128','2013-05-26','10:40:00',2.39),('15128','2013-05-26','10:45:00',1.66),('15128','2013-05-26','10:50:00',2.2),('15128','2013-05-26','10:55:00',2.96),('15128','2013-05-26','11:00:00',4.12),('15128','2013-05-26','11:05:00',3.56),('15128','2013-05-26','11:10:00',3.53),('15128','2013-05-26','11:15:00',3.45),('15128','2013-05-26','11:20:00',4.83),('15128','2013-05-26','11:25:00',2.83),('15128','2013-05-26','11:30:00',1.7),('15128','2013-05-26','11:35:00',2.95),('15128','2013-05-26','11:40:00',2.41),('15128','2013-05-26','11:45:00',2.84),('15128','2013-05-26','11:50:00',2.03),('15128','2013-05-26','11:55:00',4.61),('15128','2013-05-26','12:00:00',4.89),('15128','2013-05-26','12:05:00',4.55),('15128','2013-05-26','12:10:00',4.31),('15128','2013-05-26','12:15:00',5.12),('15128','2013-05-26','12:20:00',4.87),('15128','2013-05-26','12:25:00',4.81),('15128','2013-05-26','12:30:00',3.95),('15128','2013-05-26','12:35:00',4.56),('15128','2013-05-26','12:40:00',4.92),('15128','2013-05-26','12:45:00',4.59),('15128','2013-05-26','12:50:00',4.9),('15128','2013-05-26','12:55:00',4.97),('15128','2013-05-26','13:00:00',4.28),('15128','2013-05-26','13:05:00',4.85),('15128','2013-05-26','13:10:00',4.82),('15128','2013-05-26','13:15:00',4.58),('15128','2013-05-26','13:20:00',4.19),('15128','2013-05-26','13:25:00',4.7),('15128','2013-05-26','13:30:00',4.7),('15128','2013-05-26','13:35:00',4.79),('15128','2013-05-26','13:40:00',5.06),('15128','2013-05-26','13:50:00',2.21),('15128','2013-05-26','13:55:00',4.87),('15128','2013-05-26','14:00:00',4.78),('15128','2013-05-26','14:05:00',4.9),('15128','2013-05-26','14:10:00',2.93),('15128','2013-05-26','14:15:00',4.67),('15128','2013-05-26','14:20:00',4.88),('15128','2013-05-26','14:25:00',4.78),('15128','2013-05-26','14:30:00',3.4),('15128','2013-05-26','14:35:00',4.31),('15128','2013-05-26','14:40:00',4.48),('15128','2013-05-26','14:45:00',4.83),('15128','2013-05-26','14:50:00',3.85),('15128','2013-05-26','14:55:00',3.1),('15128','2013-05-26','15:00:00',2.26),('15128','2013-05-26','15:05:00',4.97),('15128','2013-05-26','15:10:00',4.54),('15128','2013-05-26','15:15:00',2.38),('15128','2013-05-26','15:20:00',3.77),('15128','2013-05-26','15:25:00',4.52),('15128','2013-05-26','15:30:00',4.59),('15128','2013-05-26','15:35:00',4.21),('15128','2013-05-26','15:40:00',2.8),('15128','2013-05-26','15:45:00',4.38),('15128','2013-05-26','15:50:00',4.15),('15128','2013-05-26','15:55:00',3.88),('15128','2013-05-26','16:00:00',3.94),('15128','2013-05-26','16:05:00',3.35),('15128','2013-05-26','16:10:00',2.53),('15128','2013-05-26','16:15:00',3.11),('15128','2013-05-26','16:20:00',4.61),('15128','2013-05-26','16:25:00',4.05),('15128','2013-05-26','16:30:00',3.82),('15128','2013-05-26','16:35:00',3.82),('15128','2013-05-26','16:40:00',1.99),('15128','2013-05-26','16:45:00',1.47),('15128','2013-05-26','16:50:00',1.51),('15128','2013-05-26','16:55:00',1.6),('15128','2013-05-26','17:00:00',1.68),('15128','2013-05-26','17:05:00',1.92),('15128','2013-05-26','17:10:00',1.96),('15128','2013-05-26','17:15:00',1.49),('15128','2013-05-26','17:20:00',1.36),('15128','2013-05-26','17:25:00',1.35),('15128','2013-05-26','17:30:00',1.28),('15128','2013-05-26','17:35:00',1.18),('15128','2013-05-26','17:40:00',1.11),('15128','2013-05-26','17:45:00',1.07),('15128','2013-05-26','17:50:00',1.05),('15128','2013-05-26','17:55:00',1.03),('15128','2013-05-26','18:10:00',1.12),('15128','2013-05-26','18:15:00',1.19),('15128','2013-05-26','18:20:00',1.94),('15128','2013-05-26','18:25:00',2.53),('15128','2013-05-26','18:30:00',2.37),('15128','2013-05-26','18:35:00',1.32),('15128','2013-05-26','18:50:00',1.02),('15128','2013-05-26','18:55:00',1.43),('15128','2013-05-26','19:00:00',1.75),('15128','2013-05-26','19:05:00',1.63),('15128','2013-05-26','19:10:00',1.36),('15128','2013-05-26','19:15:00',1.09),('15128','2013-05-26','19:20:00',1.12),('15128','2013-05-26','19:25:00',1.06),('15128','2013-05-25','07:45:00',1.14),('15128','2013-05-25','08:00:00',1.02),('15128','2013-05-25','08:10:00',1.02),('15128','2013-05-25','08:15:00',1.82),('15128','2013-05-25','08:20:00',1.5),('15128','2013-05-25','08:25:00',1.17),('15128','2013-05-25','08:35:00',1.24),('15128','2013-05-25','08:40:00',1.98),('15128','2013-05-25','08:45:00',1.84),('15128','2013-05-25','08:55:00',1.72),('15128','2013-05-25','09:00:00',1.57),('15128','2013-05-25','09:05:00',1.67),('15128','2013-05-25','09:10:00',1.74),('15128','2013-05-25','09:15:00',1.41),('15128','2013-05-25','09:20:00',1.18),('15128','2013-05-25','09:25:00',1.92),('15128','2013-05-25','09:30:00',1.85),('15128','2013-05-25','09:35:00',1.01),('15128','2013-05-25','09:40:00',2.22),('15128','2013-05-25','09:50:00',2.21),('15128','2013-05-25','09:55:00',3.4),('15128','2013-05-25','10:00:00',3.07),('15128','2013-05-25','10:05:00',3.5),('15128','2013-05-25','10:10:00',2.92),('15128','2013-05-25','10:15:00',2.54),('15128','2013-05-25','10:20:00',3.39),('15128','2013-05-25','10:25:00',3.35),('15128','2013-05-25','10:30:00',3.46),('15128','2013-05-25','10:35:00',3.47),('15128','2013-05-25','10:40:00',3.51),('15128','2013-05-25','10:45:00',3.6),('15128','2013-05-25','10:50:00',3.69),('15128','2013-05-25','10:55:00',3.73),('15128','2013-05-25','11:00:00',3.7),('15128','2013-05-25','11:05:00',3.61),('15128','2013-05-25','11:10:00',3.94),('15128','2013-05-25','11:15:00',3.96),('15128','2013-05-25','11:20:00',4.05),('15128','2013-05-25','11:25:00',4.11),('15128','2013-05-25','11:30:00',4.22),('15128','2013-05-25','11:35:00',4.22),('15128','2013-05-25','11:40:00',4.34),('15128','2013-05-25','11:45:00',4.52),('15128','2013-05-25','11:50:00',4.61),('15128','2013-05-25','11:55:00',4.66),('15128','2013-05-25','12:00:00',4.71),('15128','2013-05-25','12:05:00',4.41),('15128','2013-05-25','12:10:00',4.74),('15128','2013-05-25','12:15:00',4.89),('15128','2013-05-25','12:20:00',4.46),('15128','2013-05-25','12:25:00',4.72),('15128','2013-05-25','12:30:00',5.11),('15128','2013-05-25','12:35:00',4.87),('15128','2013-05-25','12:40:00',5.01),('15128','2013-05-25','12:45:00',5),('15128','2013-05-25','12:50:00',5.34),('15128','2013-05-25','12:55:00',5.08),('15128','2013-05-25','13:00:00',3.53),('15128','2013-05-25','13:05:00',4.43),('15128','2013-05-25','13:10:00',4.54),('15128','2013-05-25','13:15:00',5.15),('15128','2013-05-25','13:20:00',5.14),('15128','2013-05-25','13:25:00',5.13),('15128','2013-05-25','13:30:00',5.16),('15128','2013-05-25','13:35:00',5.17),('15128','2013-05-25','13:40:00',5.12),('15128','2013-05-25','13:45:00',5.1),('15128','2013-05-25','13:50:00',5.12),('15128','2013-05-25','13:55:00',5.03),('15128','2013-05-25','14:00:00',5.1),('15128','2013-05-25','14:05:00',5.09),('15128','2013-05-25','14:10:00',5.08),('15128','2013-05-25','14:15:00',5.03),('15128','2013-05-25','14:20:00',5.04),('15128','2013-05-25','14:25:00',5.04),('15128','2013-05-25','14:30:00',5.05),('15128','2013-05-25','14:35:00',5.02),('15128','2013-05-25','14:40:00',4.99),('15128','2013-05-25','14:45:00',4.98),('15128','2013-05-25','14:50:00',4.94),('15128','2013-05-25','14:55:00',4.9),('15128','2013-05-25','15:00:00',4.86),('15128','2013-05-25','15:05:00',4.85),('15128','2013-05-25','15:10:00',4.81),('15128','2013-05-25','15:15:00',4.79),('15128','2013-05-25','15:20:00',4.74),('15128','2013-05-25','15:25:00',4.23),('15128','2013-05-25','15:35:00',2.69),('15128','2013-05-25','15:40:00',4.56),('15128','2013-05-25','15:45:00',4.54),('15128','2013-05-25','15:50:00',4.49),('15128','2013-05-25','15:55:00',2.76),('15128','2013-05-25','16:00:00',4.39),('15128','2013-05-25','16:05:00',4.36),('15128','2013-05-25','16:10:00',4.3),('15128','2013-05-25','16:15:00',2.93),('15128','2013-05-25','16:20:00',4.09),('15128','2013-05-25','16:25:00',4.15),('15128','2013-05-25','16:30:00',4.09),('15128','2013-05-25','16:35:00',3.09),('15128','2013-05-25','16:40:00',3.51),('15128','2013-05-25','16:45:00',3.9),('15128','2013-05-25','16:50:00',3.82),('15128','2013-05-25','16:55:00',3.61),('15128','2013-05-25','17:00:00',2.73),('15128','2013-05-25','17:05:00',3.62),('15128','2013-05-25','17:10:00',3.54),('15128','2013-05-25','17:15:00',3.48),('15128','2013-05-25','17:20:00',3.41),('15128','2013-05-25','17:25:00',3.33),('15128','2013-05-25','17:30:00',3.27),('15128','2013-05-25','17:35:00',3.16),('15128','2013-05-25','17:40:00',3.06),('15128','2013-05-25','17:45:00',2.97),('15128','2013-05-25','17:50:00',2.83),('15128','2013-05-25','17:55:00',2.74),('15128','2013-05-25','18:00:00',2.61),('15128','2013-05-25','18:05:00',2.49),('15128','2013-05-25','18:10:00',2.4),('15128','2013-05-25','18:15:00',2.3),('15128','2013-05-25','18:20:00',2.18),('15128','2013-05-25','18:25:00',2.09),('15128','2013-05-25','18:30:00',2.01),('15128','2013-05-25','18:35:00',1.95),('15128','2013-05-25','18:40:00',1.87),('15128','2013-05-25','18:45:00',1.8),('15128','2013-05-25','18:50:00',1.7),('15128','2013-05-25','18:55:00',1.6),('15128','2013-05-25','19:00:00',1.49),('15128','2013-05-25','19:05:00',1.37),('15128','2013-05-25','19:10:00',1.24),('15128','2013-05-25','19:15:00',1.03),('15128','2013-05-24','07:45:00',1.1),('15128','2013-05-24','08:15:00',1.29),('15128','2013-05-24','08:20:00',2.26),('15128','2013-05-24','08:25:00',1.12),('15128','2013-05-24','08:30:00',1.06),('15128','2013-05-24','08:35:00',2.01),('15128','2013-05-24','08:40:00',1.87),('15128','2013-05-24','08:45:00',1.5),('15128','2013-05-24','08:50:00',1.23),('15128','2013-05-24','08:55:00',2.32),('15128','2013-05-24','09:00:00',2.61),('15128','2013-05-24','09:05:00',3.18),('15128','2013-05-24','09:10:00',1.11),('15128','2013-05-24','09:15:00',1.14),('15128','2013-05-24','09:20:00',1.22),('15128','2013-05-24','09:25:00',2.85),('15128','2013-05-24','09:30:00',1.7),('15128','2013-05-24','09:35:00',1.19),('15128','2013-05-24','09:40:00',2.94),('15128','2013-05-24','09:45:00',1.78),('15128','2013-05-24','09:50:00',1.57),('15128','2013-05-24','10:05:00',1.31),('15128','2013-05-24','10:10:00',1.31),('15128','2013-05-24','10:15:00',1.31),('15128','2013-05-24','10:20:00',1.07),('15128','2013-05-24','10:30:00',1.69),('15128','2013-05-24','10:35:00',1.61),('15128','2013-05-24','10:50:00',1.35),('15128','2013-05-24','10:55:00',1.16),('15128','2013-05-24','11:00:00',2.55),('15128','2013-05-24','11:05:00',3.36),('15128','2013-05-24','11:10:00',1.44),('15128','2013-05-24','11:15:00',1.02),('15128','2013-05-24','11:25:00',1.74),('15128','2013-05-24','11:30:00',1.72),('15128','2013-05-24','11:35:00',1.46),('15128','2013-05-24','11:40:00',2.68),('15128','2013-05-24','11:45:00',3.49),('15128','2013-05-24','11:50:00',1.81),('15128','2013-05-24','11:55:00',2.22),('15128','2013-05-24','12:00:00',4.67),('15128','2013-05-24','12:05:00',3.54),('15128','2013-05-24','12:10:00',2.07),('15128','2013-05-24','12:15:00',1.78),('15128','2013-05-24','12:20:00',1.18),('15128','2013-05-24','12:30:00',1.05),('15128','2013-05-24','12:35:00',1.24),('15128','2013-05-24','12:40:00',2.38),('15128','2013-05-24','12:45:00',2.44),('15128','2013-05-24','12:50:00',2.85),('15128','2013-05-24','12:55:00',4.21),('15128','2013-05-24','13:00:00',3.64),('15128','2013-05-24','13:05:00',1.56),('15128','2013-05-24','13:10:00',2.33),('15128','2013-05-24','13:15:00',3.43),('15128','2013-05-24','13:20:00',2.08),('15128','2013-05-24','13:25:00',2.38),('15128','2013-05-24','13:30:00',4.4),('15128','2013-05-24','13:35:00',2.81),('15128','2013-05-24','13:40:00',3.26),('15128','2013-05-24','13:45:00',3.11),('15128','2013-05-24','13:50:00',3.5),('15128','2013-05-24','13:55:00',4.12),('15128','2013-05-24','14:00:00',3.97),('15128','2013-05-24','14:05:00',5.54),('15128','2013-05-24','14:10:00',5.56),('15128','2013-05-24','14:15:00',4.27),('15128','2013-05-24','14:20:00',3.16),('15128','2013-05-24','14:25:00',5.03),('15128','2013-05-24','14:30:00',4.57),('15128','2013-05-24','14:35:00',4.68),('15128','2013-05-24','14:40:00',5.45),('15128','2013-05-24','14:45:00',4.3),('15128','2013-05-24','14:50:00',4.4),('15128','2013-05-24','14:55:00',2.34),('15128','2013-05-24','15:00:00',3.13),('15128','2013-05-24','15:05:00',2.15),('15128','2013-05-24','15:10:00',5.37),('15128','2013-05-24','15:15:00',4.49),('15128','2013-05-24','15:20:00',3.08),('15128','2013-05-24','15:25:00',4.59),('15128','2013-05-24','15:30:00',4.68),('15128','2013-05-24','15:35:00',1.35),('15128','2013-05-24','15:40:00',2.15),('15128','2013-05-24','15:45:00',2.93),('15128','2013-05-24','15:50:00',3.61),('15128','2013-05-24','15:55:00',4.2),('15128','2013-05-24','16:00:00',3.01),('15128','2013-05-24','16:05:00',1.37),('15128','2013-05-24','16:10:00',1.38),('15128','2013-05-24','16:15:00',2.36),('15128','2013-05-24','16:20:00',4.47),('15128','2013-05-24','16:25:00',2.13),('15128','2013-05-24','16:30:00',2.48),('15128','2013-05-24','16:35:00',3.84),('15128','2013-05-24','16:40:00',2.19),('15128','2013-05-24','16:45:00',2.67),('15128','2013-05-24','16:50:00',2.86),('15128','2013-05-24','16:55:00',1.23),('15128','2013-05-24','17:00:00',3.03),('15128','2013-05-24','17:05:00',2.64),('15128','2013-05-24','17:10:00',2.12),('15128','2013-05-24','17:15:00',3.16),('15128','2013-05-24','17:20:00',2.83),('15128','2013-05-24','17:25:00',2.38),('15128','2013-05-24','17:30:00',1.92),('15128','2013-05-24','17:35:00',2.9),('15128','2013-05-24','17:40:00',2.36),('15128','2013-05-24','17:45:00',2.42),('15128','2013-05-24','17:50:00',2.1),('15128','2013-05-24','17:55:00',2.46),('15128','2013-05-24','18:00:00',1.6),('15128','2013-05-23','08:10:00',1.08),('15128','2013-05-23','08:20:00',1.35),('15128','2013-05-23','08:25:00',1.3),('15128','2013-05-23','08:30:00',1.05),('15128','2013-05-23','08:35:00',1.04),('15128','2013-05-23','08:40:00',1.69),('15128','2013-05-23','08:45:00',1.72),('15128','2013-05-23','08:50:00',1.95),('15128','2013-05-23','08:55:00',2.12),('15128','2013-05-23','09:00:00',2.16),('15128','2013-05-23','09:05:00',1.14),('15128','2013-05-23','09:10:00',2.51),('15128','2013-05-23','09:15:00',2.88),('15128','2013-05-23','09:20:00',1.1),('15128','2013-05-23','09:30:00',2.33),('15128','2013-05-23','09:35:00',2.71),('15128','2013-05-23','09:50:00',1.2),('15128','2013-05-23','09:55:00',3.2),('15128','2013-05-23','10:00:00',3.36),('15128','2013-05-23','10:05:00',1.98),('15128','2013-05-23','10:15:00',1.07),('15128','2013-05-23','10:20:00',1.07),('15128','2013-05-23','10:25:00',1.48),('15128','2013-05-23','10:30:00',3.79),('15128','2013-05-23','10:35:00',4.02),('15128','2013-05-23','10:40:00',3.85),('15128','2013-05-23','10:45:00',4.09),('15128','2013-05-23','10:50:00',3.91),('15128','2013-05-23','10:55:00',2.89),('15128','2013-05-23','11:00:00',2.11),('15128','2013-05-23','11:05:00',3.43),('15128','2013-05-23','11:10:00',1.8),('15128','2013-05-23','11:15:00',4.31),('15128','2013-05-23','11:20:00',3.82),('15128','2013-05-23','11:25:00',4.4),('15128','2013-05-23','11:30:00',3.53),('15128','2013-05-23','11:35:00',4.46),('15128','2013-05-23','11:40:00',3.07),('15128','2013-05-23','11:50:00',2.67),('15128','2013-05-23','11:55:00',1.81),('15128','2013-05-23','12:00:00',3.37),('15128','2013-05-23','12:05:00',4.11),('15128','2013-05-23','12:10:00',3.81),('15128','2013-05-23','12:15:00',2.42),('15128','2013-05-23','12:20:00',1.79),('15128','2013-05-23','12:25:00',2.88),('15128','2013-05-23','12:30:00',2.42),('15128','2013-05-23','12:35:00',2.42),('15128','2013-05-23','12:40:00',2.89),('15128','2013-05-23','12:45:00',3.12),('15128','2013-05-23','12:50:00',2.83),('15128','2013-05-23','12:55:00',2.78),('15128','2013-05-23','13:00:00',2.34),('15128','2013-05-23','13:05:00',4.17),('15128','2013-05-23','13:10:00',4.67),('15128','2013-05-23','13:15:00',4.35),('15128','2013-05-23','13:20:00',2.47),('15128','2013-05-23','13:25:00',2.73),('15128','2013-05-23','13:30:00',3.15),('15128','2013-05-23','13:35:00',3.51),('15128','2013-05-23','13:40:00',1.71),('15128','2013-05-23','13:45:00',1.34),('15128','2013-05-23','13:50:00',2.5),('15128','2013-05-23','13:55:00',2.55),('15128','2013-05-23','14:00:00',4.85),('15128','2013-05-23','14:05:00',4.44),('15128','2013-05-23','14:10:00',2.53),('15128','2013-05-23','14:15:00',2),('15128','2013-05-23','14:20:00',3.65),('15128','2013-05-23','14:25:00',5.17),('15128','2013-05-23','14:30:00',5.25),('15128','2013-05-23','14:35:00',4.6),('15128','2013-05-23','14:40:00',3.03),('15128','2013-05-23','14:45:00',3.29),('15128','2013-05-23','14:50:00',2.22),('15128','2013-05-23','14:55:00',2.11),('15128','2013-05-23','15:00:00',1.82),('15128','2013-05-23','15:05:00',2.22),('15128','2013-05-23','15:10:00',2.32),('15128','2013-05-23','15:15:00',5.27),('15128','2013-05-23','15:20:00',4.75),('15128','2013-05-23','15:25:00',4.34),('15128','2013-05-23','15:30:00',3.36),('15128','2013-05-23','15:35:00',3.03),('15128','2013-05-23','15:40:00',3.73),('15128','2013-05-23','15:45:00',3.93),('15128','2013-05-23','15:50:00',2.87),('15128','2013-05-23','15:55:00',2.11),('15128','2013-05-23','16:00:00',2.05),('15128','2013-05-23','16:05:00',2.03),('15128','2013-05-23','16:10:00',2.04),('15128','2013-05-23','16:15:00',1.69),('15128','2013-05-23','16:20:00',1.75),('15128','2013-05-23','16:25:00',1.65),('15128','2013-05-23','16:30:00',1.41),('15128','2013-05-23','16:35:00',1.41),('15128','2013-05-23','16:40:00',1.33),('15128','2013-05-23','16:45:00',1.55),('15128','2013-05-23','16:50:00',1.52),('15128','2013-05-23','16:55:00',1.22),('15128','2013-05-23','17:00:00',1.34),('15128','2013-05-23','17:05:00',1.41),('15128','2013-05-23','17:10:00',1.77),('15128','2013-05-23','17:15:00',1.87),('15128','2013-05-23','17:20:00',1.16),('15128','2013-05-23','17:25:00',1.41),('15128','2013-05-23','17:30:00',1.51),('15128','2013-05-23','17:35:00',1.46),('15128','2013-05-23','17:40:00',1.2),('15128','2013-05-22','07:00:00',1.11),('15128','2013-05-22','07:05:00',1.03),('15128','2013-05-22','07:45:00',1.17),('15128','2013-05-22','07:50:00',1.15),('15128','2013-05-22','08:05:00',1.05),('15128','2013-05-22','08:30:00',1.46),('15128','2013-05-22','08:35:00',2.23),('15128','2013-05-22','08:45:00',1.23),('15128','2013-05-22','08:50:00',1.53),('15128','2013-05-22','09:10:00',1.06),('15128','2013-05-22','09:15:00',1.62),('15128','2013-05-22','09:20:00',1.46),('15128','2013-05-22','09:25:00',2.72),('15128','2013-05-22','09:30:00',2.86),('15128','2013-05-22','09:35:00',2.09),('15128','2013-05-22','09:40:00',1.43),('15128','2013-05-22','09:45:00',1.34),('15128','2013-05-22','09:50:00',1.97),('15128','2013-05-22','09:55:00',1.11),('15128','2013-05-22','10:00:00',3.81),('15128','2013-05-22','10:05:00',1.24),('15128','2013-05-22','10:10:00',3.09),('15128','2013-05-22','10:15:00',3.29),('15128','2013-05-22','10:20:00',3.08),('15128','2013-05-22','10:25:00',3.12),('15128','2013-05-22','10:30:00',2.22),('15128','2013-05-22','10:35:00',2.61),('15128','2013-05-22','10:40:00',2.76),('15128','2013-05-22','10:45:00',3.15),('15128','2013-05-22','10:50:00',2.57),('15128','2013-05-22','10:55:00',2.54),('15128','2013-05-22','11:00:00',2.63),('15128','2013-05-22','11:05:00',3.27),('15128','2013-05-22','11:10:00',3.13),('15128','2013-05-22','11:15:00',2.45),('15128','2013-05-22','11:20:00',2.88),('15128','2013-05-22','11:25:00',1.41),('15128','2013-05-22','11:30:00',2.36),('15128','2013-05-22','11:35:00',1.68),('15128','2013-05-22','11:40:00',3.05),('15128','2013-05-22','11:45:00',2.25),('15128','2013-05-22','11:50:00',1.02),('15128','2013-05-22','11:55:00',1.44),('15128','2013-05-22','12:00:00',2.31),('15128','2013-05-22','12:05:00',2.37),('15128','2013-05-22','12:10:00',3.21),('15128','2013-05-22','12:15:00',4.81),('15128','2013-05-22','12:20:00',4.58),('15128','2013-05-22','12:25:00',4.41),('15128','2013-05-22','12:35:00',1.85),('15128','2013-05-22','12:40:00',5.69),('15128','2013-05-22','12:45:00',5.35),('15128','2013-05-22','12:50:00',4.91),('15128','2013-05-22','12:55:00',3.64),('15128','2013-05-22','13:00:00',2.36),('15128','2013-05-22','13:05:00',5.42),('15128','2013-05-22','13:10:00',4.43),('15128','2013-05-22','13:15:00',5.32),('15128','2013-05-22','13:20:00',4.28),('15128','2013-05-22','13:25:00',4.39),('15128','2013-05-22','13:30:00',5.02),('15128','2013-05-22','13:35:00',3.43),('15128','2013-05-22','13:40:00',4.65),('15128','2013-05-22','13:45:00',5.38),('15128','2013-05-22','13:50:00',4.73),('15128','2013-05-22','13:55:00',4.12),('15128','2013-05-22','14:00:00',3.42),('15128','2013-05-22','14:05:00',3.22),('15128','2013-05-22','14:10:00',5.53),('15128','2013-05-22','14:15:00',4.03),('15128','2013-05-22','14:20:00',4.69),('15128','2013-05-22','14:25:00',3.68),('15128','2013-05-22','14:30:00',5.18),('15128','2013-05-22','14:35:00',4.95),('15128','2013-05-22','14:45:00',2.7),('15128','2013-05-22','14:50:00',3.39),('15128','2013-05-22','14:55:00',4.31),('15128','2013-05-22','15:00:00',5.18),('15128','2013-05-22','15:05:00',2.16),('15128','2013-05-22','15:10:00',3.25),('15128','2013-05-22','15:15:00',2.63),('15128','2013-05-22','15:20:00',3.44),('15128','2013-05-22','15:25:00',2.67),('15128','2013-05-22','15:30:00',2),('15128','2013-05-22','15:35:00',3.93),('15128','2013-05-22','15:40:00',1.42),('15128','2013-05-22','15:45:00',3.22),('15128','2013-05-22','15:50:00',4),('15128','2013-05-22','15:55:00',4.44),('15128','2013-05-22','16:00:00',2.73),('15128','2013-05-22','16:05:00',3.03),('15128','2013-05-22','16:10:00',2.81),('15128','2013-05-22','16:15:00',2.65),('15128','2013-05-22','16:20:00',2.65),('15128','2013-05-22','16:25:00',1.46),('15128','2013-05-22','16:30:00',2.42),('15128','2013-05-22','16:35:00',2.05),('15128','2013-05-22','16:40:00',1.08),('15128','2013-05-22','16:45:00',1.85),('15128','2013-05-22','16:50:00',1.85),('15128','2013-05-22','16:55:00',2.1),('15128','2013-05-22','17:00:00',3.41),('15128','2013-05-22','17:05:00',1.15),('15128','2013-05-22','17:15:00',1.22),('15128','2013-05-22','17:30:00',1.67),('15128','2013-05-22','17:35:00',1.57),('15128','2013-05-22','17:40:00',1.56),('15128','2013-05-22','17:45:00',1.68),('15128','2013-05-22','17:50:00',3.28),('15128','2013-05-22','17:55:00',2.78),('15128','2013-05-22','18:00:00',1.01),('15128','2013-05-22','18:40:00',1.22),('15128','2013-05-22','18:45:00',1.38),('15128','2013-05-21','08:05:00',1.1),('15128','2013-05-21','08:10:00',1.29),('15128','2013-05-21','08:25:00',1.92),('15128','2013-05-21','08:30:00',2.16),('15128','2013-05-21','08:35:00',1.01),('15128','2013-05-21','09:25:00',1.62),('15128','2013-05-21','09:30:00',2.21),('15128','2013-05-21','09:35:00',2.62),('15128','2013-05-21','09:40:00',2.56),('15128','2013-05-21','09:45:00',2.54),('15128','2013-05-21','09:50:00',2.59),('15128','2013-05-21','09:55:00',2.65),('15128','2013-05-21','10:00:00',2.77),('15128','2013-05-21','10:05:00',2.81),('15128','2013-05-21','10:10:00',2.89),('15128','2013-05-21','10:15:00',2.93),('15128','2013-05-21','10:20:00',2.98),('15128','2013-05-21','10:25:00',3.05),('15128','2013-05-21','10:30:00',3.08),('15128','2013-05-21','10:35:00',2.52),('15128','2013-05-21','10:40:00',2),('15128','2013-05-21','10:45:00',3.05),('15128','2013-05-21','10:50:00',3.62),('15128','2013-05-21','10:55:00',3.51),('15128','2013-05-21','11:00:00',3.57),('15128','2013-05-21','11:05:00',3.57),('15128','2013-05-21','11:10:00',3.55),('15128','2013-05-21','11:15:00',3.62),('15128','2013-05-21','11:20:00',3.66),('15128','2013-05-21','11:25:00',3.82),('15128','2013-05-21','11:30:00',3.71),('15128','2013-05-21','11:35:00',3.93),('15128','2013-05-21','11:40:00',3.14),('15128','2013-05-21','11:45:00',3.26),('15128','2013-05-21','11:50:00',4.24),('15128','2013-05-21','11:55:00',3.43),('15128','2013-05-21','12:00:00',2.26),('15128','2013-05-21','12:05:00',2.57),('15128','2013-05-21','12:10:00',2.27),('15128','2013-05-21','12:15:00',2.29),('15128','2013-05-21','12:20:00',4.94),('15128','2013-05-21','12:25:00',5.01),('15128','2013-05-21','12:30:00',3.06),('15128','2013-05-21','12:35:00',1.62),('15128','2013-05-21','12:40:00',1.5),('15128','2013-05-21','12:45:00',1.12),('15128','2013-05-21','13:10:00',1.92),('15128','2013-05-21','13:15:00',2.52),('15128','2013-05-21','13:20:00',2.67),('15128','2013-05-21','13:25:00',1.59),('15128','2013-05-21','13:30:00',2.56),('15128','2013-05-21','13:35:00',2.52),('15128','2013-05-21','13:40:00',4.48),('15128','2013-05-21','13:45:00',3.73),('15128','2013-05-21','13:50:00',5.05),('15128','2013-05-21','13:55:00',4.17),('15128','2013-05-21','14:00:00',4.25),('15128','2013-05-21','14:05:00',3.69),('15128','2013-05-21','14:10:00',4.27),('15128','2013-05-21','14:15:00',4.46),('15128','2013-05-21','14:20:00',4.41),('15128','2013-05-21','14:25:00',4.42),('15128','2013-05-21','14:30:00',4.4),('15128','2013-05-21','14:35:00',4.38),('15128','2013-05-21','14:40:00',4.38),('15128','2013-05-21','14:45:00',4.35),('15128','2013-05-21','14:50:00',4.33),('15128','2013-05-21','14:55:00',4.29),('15128','2013-05-21','15:00:00',4.28),('15128','2013-05-21','15:05:00',4.14),('15128','2013-05-21','15:10:00',3.68),('15128','2013-05-21','15:15:00',3.95),('15128','2013-05-21','15:20:00',4.15),('15128','2013-05-21','15:25:00',3.52),('15128','2013-05-21','15:30:00',4.28),('15128','2013-05-21','15:35:00',4.21),('15128','2013-05-21','15:40:00',3.63),('15128','2013-05-21','15:45:00',4.18),('15128','2013-05-21','15:50:00',3.97),('15128','2013-05-21','15:55:00',3.84),('15128','2013-05-21','16:00:00',3.83),('15128','2013-05-21','16:05:00',3.75),('15128','2013-05-21','16:10:00',3.69),('15128','2013-05-21','16:15:00',3.67),('15128','2013-05-21','16:20:00',3.59),('15128','2013-05-21','16:25:00',3.55),('15128','2013-05-21','16:30:00',3.5),('15128','2013-05-21','16:35:00',2.41),('15128','2013-05-21','16:40:00',1.81),('15128','2013-05-21','16:45:00',3.26),('15128','2013-05-21','16:50:00',2.98),('15128','2013-05-21','16:55:00',1.01),('15128','2013-05-21','17:20:00',1.02),('15128','2013-05-21','17:25:00',1.32),('15128','2013-05-21','17:30:00',1.66),('15128','2013-05-21','17:35:00',1.48),('15128','2013-05-21','17:40:00',1.52),('15128','2013-05-21','17:45:00',1.12),('15128','2013-05-21','18:00:00',1.12),('15128','2013-05-21','18:05:00',1.95),('15128','2013-05-21','18:10:00',1.64),('15128','2013-05-21','18:15:00',1.16),('15128','2013-05-21','18:20:00',1.24),('15128','2013-05-21','18:35:00',1.36),('15128','2013-05-21','18:40:00',1.5),('15128','2013-05-21','18:45:00',1.57),('15128','2013-05-21','18:50:00',1.26),('15128','2014-03-31','09:00:00',1.03),('15128','2014-03-31','09:05:00',1.08),('15128','2014-03-31','09:10:00',1.16),('15128','2014-03-31','09:15:00',1.23),('15128','2014-03-31','09:20:00',1.33),('15128','2014-03-31','09:25:00',1.38),('15128','2014-03-31','09:30:00',1.43),('15128','2014-03-31','09:35:00',1.48),('15128','2014-03-31','09:40:00',1.52),('15128','2014-03-31','09:45:00',1.58),('15128','2014-03-31','09:50:00',1.64),('15128','2014-03-31','09:55:00',1.72),('15128','2014-03-31','10:00:00',1.79),('15128','2014-03-31','10:05:00',1.85),('15128','2014-03-31','10:10:00',1.93),('15128','2014-03-31','10:15:00',1.97),('15128','2014-03-31','10:20:00',2.01),('15128','2014-03-31','10:25:00',2.13),('15128','2014-03-31','10:30:00',2.12),('15128','2014-03-31','10:35:00',2.3),('15128','2014-03-31','10:40:00',2.39),('15128','2014-03-31','10:45:00',2.21),('15128','2014-03-31','10:50:00',2.64),('15128','2014-03-31','10:55:00',2.49),('15128','2014-03-31','11:00:00',2.41),('15128','2014-03-31','11:05:00',2.42),('15128','2014-03-31','11:10:00',2.62),('15128','2014-03-31','11:15:00',2.75),('15128','2014-03-31','11:20:00',2.84),('15128','2014-03-31','11:25:00',2.93),('15128','2014-03-31','11:30:00',2.97),('15128','2014-03-31','11:35:00',2.93),('15128','2014-03-31','11:40:00',3.01),('15128','2014-03-31','11:45:00',3.11),('15128','2014-03-31','11:50:00',3.23),('15128','2014-03-31','11:55:00',3.39),('15128','2014-03-31','12:00:00',2.9),('15128','2014-03-31','12:05:00',3.52),('15128','2014-03-31','12:10:00',3.5),('15128','2014-03-31','12:15:00',3.61),('15128','2014-03-31','12:20:00',3.69),('15128','2014-03-31','12:25:00',3.75),('15128','2014-03-31','12:30:00',3.8),('15128','2014-03-31','12:35:00',3.84),('15128','2014-03-31','12:40:00',3.87),('15128','2014-03-31','12:45:00',3.61),('15128','2014-03-31','12:50:00',3.96),('15128','2014-03-31','12:55:00',4.02),('15128','2014-03-31','13:00:00',3.97),('15128','2014-03-31','13:05:00',3.99),('15128','2014-03-31','13:10:00',4.01),('15128','2014-03-31','13:15:00',4.01),('15128','2014-03-31','13:20:00',3.97),('15128','2014-03-31','13:25:00',3.9),('15128','2014-03-31','13:30:00',3.66),('15128','2014-03-31','13:35:00',3.41),('15128','2014-03-31','13:40:00',4.13),('15128','2014-03-31','13:45:00',4.43),('15128','2014-03-31','13:50:00',3.81),('15128','2014-03-31','13:55:00',3.96),('15128','2014-03-31','14:00:00',3.37),('15128','2014-03-31','14:05:00',4.26),('15128','2014-03-31','14:10:00',4.22),('15128','2014-03-31','14:15:00',3.99),('15128','2014-03-31','14:20:00',4.11),('15128','2014-03-31','14:25:00',4.16),('15128','2014-03-31','14:30:00',3.86),('15128','2014-03-31','14:35:00',3.4),('15128','2014-03-31','14:40:00',4.31),('15128','2014-03-31','14:45:00',4.28),('15128','2014-03-31','14:50:00',4.11),('15128','2014-03-31','14:55:00',3.91),('15128','2014-03-31','15:00:00',4.02),('15128','2014-03-31','15:05:00',3.77),('15128','2014-03-31','15:10:00',3.29),('15128','2014-03-31','15:15:00',2.92),('15128','2014-03-31','15:20:00',3.32),('15128','2014-03-31','15:25:00',3.81),('15128','2014-03-31','15:30:00',3.91),('15128','2014-03-31','15:35:00',3.86),('15128','2014-03-31','15:40:00',3.52),('15128','2014-03-31','15:45:00',2.46),('15128','2014-03-31','15:50:00',3.83),('15128','2014-03-31','15:55:00',3.85),('15128','2014-03-31','16:00:00',2.02),('15128','2014-03-31','16:05:00',2.41),('15128','2014-03-31','16:10:00',2.28),('15128','2014-03-31','16:15:00',3.49),('15128','2014-03-31','16:20:00',3.36),('15128','2014-03-31','16:25:00',2.63),('15128','2014-03-31','16:30:00',2.95),('15128','2014-03-31','16:35:00',2.92),('15128','2014-03-31','16:40:00',2.4),('15128','2014-03-31','16:45:00',2.22),('15128','2014-03-31','16:50:00',1.57),('15128','2014-03-31','16:55:00',2.53),('15128','2014-03-31','17:00:00',2.79),('15128','2014-03-31','17:05:00',2.39),('15128','2014-03-31','17:10:00',2.09),('15128','2014-03-31','17:15:00',1.66),('15128','2014-03-31','17:20:00',1.01),('15128','2014-03-31','17:25:00',2.01),('15128','2014-03-31','17:30:00',2.07),('15128','2014-03-31','17:35:00',1.74),('15128','2014-03-31','17:40:00',1.78),('15128','2014-03-31','17:45:00',1.61),('15128','2014-03-31','17:50:00',1.53),('15128','2014-03-31','17:55:00',1.61),('15128','2014-03-31','18:00:00',1.49),('15128','2014-03-31','18:10:00',1.22),('15128','2014-03-31','18:20:00',1.03),('15128','2013-05-20','08:05:00',1.35),('15128','2013-05-20','08:10:00',1.68),('15128','2013-05-20','08:15:00',1.34),('15128','2013-05-20','08:20:00',1.38),('15128','2013-05-20','08:25:00',1.47),('15128','2013-05-20','08:30:00',1.27),('15128','2013-05-20','08:35:00',1.46),('15128','2013-05-20','08:40:00',1.49),('15128','2013-05-20','08:45:00',1.29),('15128','2013-05-20','08:50:00',1.29),('15128','2013-05-20','08:55:00',1.49),('15128','2013-05-20','09:00:00',1.51),('15128','2013-05-20','09:05:00',1.35),('15128','2013-05-20','09:10:00',1.55),('15128','2013-05-20','09:15:00',1.92),('15128','2013-05-20','09:20:00',2.26),('15128','2013-05-20','09:25:00',1.96),('15128','2013-05-20','09:30:00',2.03),('15128','2013-05-20','09:35:00',2.08),('15128','2013-05-20','09:40:00',1.89),('15128','2013-05-20','09:45:00',1.77),('15128','2013-05-20','09:50:00',1.87),('15128','2013-05-20','09:55:00',1.78),('15128','2013-05-20','10:00:00',2.17),('15128','2013-05-20','10:05:00',2.11),('15128','2013-05-20','10:10:00',1.94),('15128','2013-05-20','10:15:00',1.87),('15128','2013-05-20','10:20:00',1.91),('15128','2013-05-20','10:25:00',2.42),('15128','2013-05-20','10:30:00',2.03),('15128','2013-05-20','10:35:00',1.93),('15128','2013-05-20','10:40:00',2.62),('15128','2013-05-20','10:45:00',2.95),('15128','2013-05-20','10:50:00',2.55),('15128','2013-05-20','10:55:00',1.94),('15128','2013-05-20','11:00:00',1.54),('15128','2013-05-20','11:05:00',1.69),('15128','2013-05-20','11:10:00',2.83),('15128','2013-05-20','11:15:00',3.33),('15128','2013-05-20','11:20:00',3.49),('15128','2013-05-20','11:25:00',4.22),('15128','2013-05-20','11:30:00',2.68),('15128','2013-05-20','11:35:00',2.66),('15128','2013-05-20','11:40:00',2.46),('15128','2013-05-20','11:45:00',3.21),('15128','2013-05-20','11:50:00',3.15),('15128','2013-05-20','11:55:00',2.89),('15128','2013-05-20','12:00:00',2.36),('15128','2013-05-20','12:05:00',3.72),('15128','2013-05-20','12:10:00',3.74),('15128','2013-05-20','12:15:00',3.26),('15128','2013-05-20','12:20:00',2.54),('15128','2013-05-20','12:25:00',2.66),('15128','2013-05-20','12:30:00',2.73),('15128','2013-05-20','12:35:00',3.01),('15128','2013-05-20','12:40:00',3.06),('15128','2013-05-20','12:45:00',2.5),('15128','2013-05-20','12:50:00',4.65),('15128','2013-05-20','12:55:00',2.86),('15128','2013-05-20','13:00:00',3.12),('15128','2013-05-20','13:05:00',3.19),('15128','2013-05-20','13:10:00',3.6),('15128','2013-05-20','13:15:00',3.97),('15128','2013-05-20','13:20:00',3.73),('15128','2013-05-20','13:25:00',2.52),('15128','2013-05-20','13:30:00',1.75),('15128','2013-05-20','13:35:00',1.53),('15128','2013-05-20','13:40:00',1.38),('15128','2013-05-20','13:45:00',1),('15128','2013-05-20','14:10:00',1.69),('15128','2013-05-20','14:15:00',2.2),('15128','2013-05-20','14:20:00',2.33),('15128','2013-05-20','14:25:00',3.63),('15128','2013-05-20','14:30:00',4),('15128','2013-05-20','14:35:00',3.33),('15128','2013-05-20','14:40:00',2.4),('15128','2013-05-20','14:45:00',1.42),('15128','2013-05-20','15:15:00',1.26),('15128','2013-05-20','15:20:00',1.77),('15128','2013-05-20','15:25:00',2.86),('15128','2013-05-20','15:30:00',3.32),('15128','2013-05-20','15:35:00',3.67),('15128','2013-05-20','15:40:00',2.34),('15128','2013-05-20','15:45:00',2.31),('15128','2013-05-20','15:50:00',1.49),('15128','2013-05-20','15:55:00',1.11),('15128','2013-05-20','16:05:00',1.26),('15128','2013-05-20','16:10:00',1.25),('15128','2013-05-20','16:25:00',1.27),('15128','2013-05-20','16:30:00',1.71),('15128','2013-05-20','16:35:00',1.73),('15128','2013-05-20','16:40:00',1.52),('15128','2013-05-20','16:45:00',1.25),('15128','2013-05-19','08:10:00',1.26),('15128','2013-05-19','08:15:00',1.36),('15128','2013-05-19','08:20:00',1.6),('15128','2013-05-19','08:25:00',1.21),('15128','2013-05-19','08:30:00',1.39),('15128','2013-05-19','08:35:00',1.86),('15128','2013-05-19','08:40:00',1.67),('15128','2013-05-19','08:45:00',1.2),('15128','2013-05-19','09:40:00',1.6),('15128','2013-05-19','09:45:00',2.51),('15128','2013-05-19','09:55:00',1.08),('15128','2013-05-19','10:00:00',3.32),('15128','2013-05-19','10:05:00',3.25),('15128','2013-05-19','10:10:00',3.33),('15128','2013-05-19','10:15:00',3.21),('15128','2013-05-19','10:20:00',3.33),('15128','2013-05-19','10:25:00',3.42),('15128','2013-05-19','10:30:00',3.6),('15128','2013-05-19','10:35:00',1.62),('15128','2013-05-19','10:40:00',2.8),('15128','2013-05-19','10:45:00',3.23),('15128','2013-05-19','10:50:00',3.45),('15128','2013-05-19','10:55:00',3.91),('15128','2013-05-19','11:00:00',4.11),('15128','2013-05-19','11:05:00',3.62),('15128','2013-05-19','11:10:00',3.82),('15128','2013-05-19','11:15:00',2.34),('15128','2013-05-19','11:20:00',3.38),('15128','2013-05-19','11:25:00',2.29),('15128','2013-05-19','11:30:00',2.44),('15128','2013-05-19','11:35:00',2.93),('15128','2013-05-19','11:40:00',2.6),('15128','2013-05-19','11:45:00',3.96),('15128','2013-05-19','11:50:00',4.67),('15128','2013-05-19','11:55:00',3.65),('15128','2013-05-19','12:00:00',4.54),('15128','2013-05-19','12:05:00',4.56),('15128','2013-05-19','12:10:00',4.46),('15128','2013-05-19','12:15:00',4.03),('15128','2013-05-19','12:20:00',4.65),('15128','2013-05-19','12:25:00',4.64),('15128','2013-05-19','12:30:00',4.65),('15128','2013-05-19','12:35:00',4.66),('15128','2013-05-19','12:40:00',4.69),('15128','2013-05-19','12:45:00',4.7),('15128','2013-05-19','12:50:00',4.75),('15128','2013-05-19','12:55:00',4.79),('15128','2013-05-19','13:00:00',4.79),('15128','2013-05-19','13:05:00',4.71),('15128','2013-05-19','13:10:00',4.84),('15128','2013-05-19','13:15:00',4.87),('15128','2013-05-19','13:20:00',4.86),('15128','2013-05-19','13:25:00',4.84),('15128','2013-05-19','13:30:00',4.86),('15128','2013-05-19','13:35:00',4.85),('15128','2013-05-19','13:40:00',4.87),('15128','2013-05-19','13:45:00',4.86),('15128','2013-05-19','13:55:00',1.92),('15128','2013-05-19','14:00:00',4.79),('15128','2013-05-19','14:05:00',4.82),('15128','2013-05-19','14:10:00',4.81),('15128','2013-05-19','14:15:00',2.9),('15128','2013-05-19','14:20:00',4.61),('15128','2013-05-19','14:25:00',4.74),('15128','2013-05-19','14:30:00',4.72),('15128','2013-05-19','14:35:00',3.41),('15128','2013-05-19','14:40:00',4.07),('15128','2013-05-19','14:45:00',4.66),('15128','2013-05-19','14:50:00',4.64),('15128','2013-05-19','14:55:00',4.02),('15128','2013-05-19','15:00:00',3.29),('15128','2013-05-19','15:05:00',4.58),('15128','2013-05-19','15:10:00',4.56),('15128','2013-05-19','15:15:00',4.56),('15128','2013-05-19','15:20:00',2.74),('15128','2013-05-19','15:25:00',4.46),('15128','2013-05-19','15:30:00',4.45),('15128','2013-05-19','15:35:00',4.42),('15128','2013-05-19','15:40:00',4.35),('15128','2013-05-19','15:45:00',4.3),('15128','2013-05-19','15:50:00',4.27),('15128','2013-05-19','15:55:00',4.24),('15128','2013-05-19','16:00:00',4.17),('15128','2013-05-19','16:05:00',4.12),('15128','2013-05-19','16:10:00',4.1),('15128','2013-05-19','16:15:00',4.05),('15128','2013-05-19','16:20:00',4),('15128','2013-05-19','16:25:00',3.98),('15128','2013-05-19','16:30:00',3.92),('15128','2013-05-19','16:35:00',3.81),('15128','2013-05-19','16:40:00',3.61),('15128','2013-05-19','16:45:00',3.51),('15128','2013-05-19','16:50:00',3.72),('15128','2013-05-19','16:55:00',3.33),('15128','2013-05-19','17:00:00',2.05),('15128','2013-05-19','17:05:00',3.37),('15128','2013-05-19','17:10:00',2.84),('15128','2013-05-19','17:15:00',1.99),('15128','2013-05-19','17:20:00',3.78),('15128','2013-05-19','17:25:00',3.27),('15128','2013-05-19','17:30:00',3.06),('15128','2013-05-19','17:35:00',2.85),('15128','2013-05-19','17:40:00',2.79),('15128','2013-05-19','17:45:00',2.65),('15128','2013-05-19','17:50:00',2.51),('15128','2013-05-19','17:55:00',2.45),('15128','2013-05-19','18:00:00',1.97),('15128','2013-05-19','18:05:00',1.81),('15128','2013-05-19','18:10:00',2.17),('15128','2013-05-19','18:15:00',2.09),('15128','2013-05-19','18:20:00',1.94),('15128','2013-05-19','18:25:00',1.86),('15128','2013-05-19','18:30:00',1.77),('15128','2013-05-19','18:35:00',1.6),('15128','2013-05-19','18:45:00',1.13),('15128','2013-05-19','18:50:00',1.45),('15128','2013-05-19','18:55:00',1.33),('15128','2013-05-19','19:00:00',1.22),('15128','2013-05-19','19:05:00',1.12),('15128','2013-05-19','19:10:00',1.02),('15128','2013-05-18','08:30:00',1.13),('15128','2013-05-18','08:35:00',1.28),('15128','2013-05-18','08:40:00',1.11),('15128','2013-05-18','08:45:00',1.09),('15128','2013-05-18','08:50:00',1.12),('15128','2013-05-18','08:55:00',1.32),('15128','2013-05-18','09:30:00',1.53),('15128','2013-05-18','09:35:00',1.41),('15128','2013-05-18','09:40:00',1.13),('15128','2013-05-18','09:45:00',1.57),('15128','2013-05-18','09:50:00',1.55),('15128','2013-05-18','09:55:00',1.72),('15128','2013-05-18','10:00:00',1.86),('15128','2013-05-18','10:05:00',2.18),('15128','2013-05-18','10:10:00',2.19),('15128','2013-05-18','10:15:00',2.85),('15128','2013-05-18','10:20:00',2.91),('15128','2013-05-18','10:25:00',2.46),('15128','2013-05-18','10:30:00',3.22),('15128','2013-05-18','10:35:00',3.36),('15128','2013-05-18','10:40:00',2.73),('15128','2013-05-18','10:45:00',2.61),('15128','2013-05-18','10:50:00',2.01),('15128','2013-05-18','10:55:00',2.26),('15128','2013-05-18','11:00:00',2.36),('15128','2013-05-18','11:05:00',2.46),('15128','2013-05-18','11:10:00',2.93),('15128','2013-05-18','11:15:00',4.05),('15128','2013-05-18','11:20:00',4.3),('15128','2013-05-18','11:25:00',4.3),('15128','2013-05-18','11:30:00',4.15),('15128','2013-05-18','11:35:00',4.18),('15128','2013-05-18','11:40:00',4.25),('15128','2013-05-18','11:45:00',4.31),('15128','2013-05-18','11:50:00',4.52),('15128','2013-05-18','11:55:00',4.54),('15128','2013-05-18','12:00:00',4.57),('15128','2013-05-18','12:05:00',4.64),('15128','2013-05-18','12:10:00',4.68),('15128','2013-05-18','12:15:00',4.7),('15128','2013-05-18','12:20:00',4.73),('15128','2013-05-18','12:25:00',4.75),('15128','2013-05-18','12:30:00',4.78),('15128','2013-05-18','12:35:00',4.83),('15128','2013-05-18','12:40:00',4.92),('15128','2013-05-18','12:45:00',4.33),('15128','2013-05-18','12:50:00',4.95),('15128','2013-05-18','12:55:00',4.91),('15128','2013-05-18','13:00:00',4.93),('15128','2013-05-18','13:05:00',4.89),('15128','2013-05-18','13:10:00',4.9),('15128','2013-05-18','13:15:00',4.91),('15128','2013-05-18','13:20:00',4.91),('15128','2013-05-18','13:25:00',4.93),('15128','2013-05-18','13:30:00',4.96),('15128','2013-05-18','13:35:00',4.96),('15128','2013-05-18','13:40:00',4.94),('15128','2013-05-18','13:45:00',4.9),('15128','2013-05-18','13:50:00',4.93),('15128','2013-05-18','13:55:00',4.91),('15128','2013-05-18','14:00:00',4.94),('15128','2013-05-18','14:05:00',4.94),('15128','2013-05-18','14:10:00',4.93),('15128','2013-05-18','14:15:00',4.94),('15128','2013-05-18','14:20:00',4.92),('15128','2013-05-18','14:25:00',4.91),('15128','2013-05-18','14:30:00',4.87),('15128','2013-05-18','14:35:00',4.82),('15128','2013-05-18','14:40:00',4.79),('15128','2013-05-18','14:45:00',4.78),('15128','2013-05-18','14:50:00',4.83),('15128','2013-05-18','14:55:00',4.77),('15128','2013-05-18','15:00:00',4.75),('15128','2013-05-18','15:05:00',4.78),('15128','2013-05-18','15:10:00',4.78),('15128','2013-05-18','15:15:00',4.71),('15128','2013-05-18','15:20:00',4.68),('15128','2013-05-18','15:25:00',4.61),('15128','2013-05-18','15:30:00',4.58),('15128','2013-05-18','15:35:00',4.53),('15128','2013-05-18','15:40:00',4.5),('15128','2013-05-18','15:45:00',4.45),('15128','2013-05-18','15:50:00',4.43),('15128','2013-05-18','15:55:00',4.36),('15128','2013-05-18','16:00:00',4.33),('15128','2013-05-18','16:05:00',4.26),('15128','2013-05-18','16:10:00',4.19),('15128','2013-05-18','16:15:00',4.15),('15128','2013-05-18','16:20:00',4.1),('15128','2013-05-18','16:25:00',4.06),('15128','2013-05-18','16:30:00',4),('15128','2013-05-18','16:35:00',3.95),('15128','2013-05-18','16:40:00',3.88),('15128','2013-05-18','16:45:00',3.83),('15128','2013-05-18','16:50:00',3.73),('15128','2013-05-18','16:55:00',3.68),('15128','2013-05-18','17:00:00',3.63),('15128','2013-05-18','17:05:00',3.54),('15128','2013-05-18','17:10:00',3.46),('15128','2013-05-18','17:15:00',3.39),('15128','2013-05-18','17:20:00',3.33),('15128','2013-05-18','17:25:00',3.28),('15128','2013-05-18','17:30:00',3.2),('15128','2013-05-18','17:35:00',3.12),('15128','2013-05-18','17:40:00',3.02),('15128','2013-05-18','17:45:00',2.88),('15128','2013-05-18','17:50:00',2.75),('15128','2013-05-18','17:55:00',2.63),('15128','2013-05-18','18:00:00',2.5),('15128','2013-05-18','18:05:00',2.4),('15128','2013-05-18','18:10:00',2.31),('15128','2013-05-18','18:15:00',2.21),('15128','2013-05-18','18:20:00',2.1),('15128','2013-05-18','18:25:00',2.03),('15128','2013-05-18','18:30:00',1.96),('15128','2013-05-18','18:35:00',1.89),('15128','2013-05-18','18:40:00',1.81),('15128','2013-05-18','18:45:00',1.73),('15128','2013-05-18','18:50:00',1.61),('15128','2013-05-18','18:55:00',1.51),('15128','2013-05-18','19:00:00',1.38),('15128','2013-05-18','19:05:00',1.27),('15128','2013-05-18','19:10:00',1.12),('15128','2013-05-17','07:50:00',1.02),('15128','2013-05-17','08:00:00',1.32),('15128','2013-05-17','08:05:00',1.13),('15128','2013-05-17','08:15:00',1.01),('15128','2013-05-17','08:20:00',1.21),('15128','2013-05-17','08:25:00',1.24),('15128','2013-05-17','08:30:00',1),('15128','2013-05-17','08:40:00',1.28),('15128','2013-05-17','08:45:00',1.7),('15128','2013-05-17','08:50:00',1.92),('15128','2013-05-17','08:55:00',1.9),('15128','2013-05-17','09:00:00',1.89),('15128','2013-05-17','09:05:00',2.11),('15128','2013-05-17','09:10:00',2.22),('15128','2013-05-17','09:15:00',2.29),('15128','2013-05-17','09:20:00',2.3),('15128','2013-05-17','09:25:00',2.35),('15128','2013-05-17','09:30:00',2.41),('15128','2013-05-17','09:35:00',2.49),('15128','2013-05-17','09:40:00',2.55),('15128','2013-05-17','09:45:00',2.54),('15128','2013-05-17','09:50:00',2.57),('15128','2013-05-17','09:55:00',2.65),('15128','2013-05-17','10:00:00',2.73),('15128','2013-05-17','10:05:00',2.81),('15128','2013-05-17','10:10:00',2.88),('15128','2013-05-17','10:15:00',2.95),('15128','2013-05-17','10:20:00',2.92),('15128','2013-05-17','10:25:00',2.99),('15128','2013-05-17','10:30:00',3.02),('15128','2013-05-17','10:35:00',3.08),('15128','2013-05-17','10:40:00',3.16),('15128','2013-05-17','10:45:00',3.26),('15128','2013-05-17','10:50:00',3.36),('15128','2013-05-17','10:55:00',3.45),('15128','2013-05-17','11:00:00',3.62),('15128','2013-05-17','11:05:00',3.9),('15128','2013-05-17','11:10:00',3.15),('15128','2013-05-17','11:15:00',3.31),('15128','2013-05-17','11:20:00',3.08),('15128','2013-05-17','11:25:00',3.42),('15128','2013-05-17','11:30:00',3.95),('15128','2013-05-17','11:35:00',3.99),('15128','2013-05-17','11:40:00',3.91),('15128','2013-05-17','11:45:00',3.97),('15128','2013-05-17','11:50:00',4.06),('15128','2013-05-17','11:55:00',4.14),('15128','2013-05-17','12:00:00',4.14),('15128','2013-05-17','12:05:00',4.14),('15128','2013-05-17','12:10:00',4.16),('15128','2013-05-17','12:15:00',4.19),('15128','2013-05-17','12:20:00',4.25),('15128','2013-05-17','12:25:00',4.31),('15128','2013-05-17','12:30:00',4.28),('15128','2013-05-17','12:35:00',4.31),('15128','2013-05-17','12:40:00',4.34),('15128','2013-05-17','12:45:00',4.31),('15128','2013-05-17','12:50:00',4.2),('15128','2013-05-17','12:55:00',4.39),('15128','2013-05-17','13:00:00',4.39),('15128','2013-05-17','13:05:00',4.39),('15128','2013-05-17','13:10:00',4.41),('15128','2013-05-17','13:15:00',4.43),('15128','2013-05-17','13:20:00',4.43),('15128','2013-05-17','13:25:00',4.47),('15128','2013-05-17','13:30:00',4.47),('15128','2013-05-17','13:35:00',4.47),('15128','2013-05-17','13:40:00',4.49),('15128','2013-05-17','13:45:00',4.52),('15128','2013-05-17','13:50:00',4.44),('15128','2013-05-17','13:55:00',4.24),('15128','2013-05-17','14:00:00',3.83),('15128','2013-05-17','14:05:00',4.43),('15128','2013-05-17','14:10:00',3.31),('15128','2013-05-17','14:15:00',3.34),('15128','2013-05-17','14:20:00',3.74),('15128','2013-05-17','14:25:00',4.55),('15128','2013-05-17','14:30:00',4.59),('15128','2013-05-17','14:35:00',4.65),('15128','2013-05-17','14:40:00',4.66),('15128','2013-05-17','14:45:00',3.63),('15128','2013-05-17','14:50:00',4.09),('15128','2013-05-17','14:55:00',4.21),('15128','2013-05-17','15:00:00',4.09),('15128','2013-05-17','15:05:00',4.07),('15128','2013-05-17','15:10:00',4.04),('15128','2013-05-17','15:15:00',4),('15128','2013-05-17','15:20:00',3.98),('15128','2013-05-17','15:25:00',3.93),('15128','2013-05-17','15:30:00',3.9),('15128','2013-05-17','15:35:00',3.63),('15128','2013-05-17','15:40:00',3.89),('15128','2013-05-17','15:45:00',3.73),('15128','2013-05-17','15:50:00',3.69),('15128','2013-05-17','15:55:00',3.67),('15128','2013-05-17','16:00:00',3.6),('15128','2013-05-17','16:05:00',3.53),('15128','2013-05-17','16:10:00',3.47),('15128','2013-05-17','16:15:00',3.42),('15128','2013-05-17','16:20:00',3.37),('15128','2013-05-17','16:25:00',3.3),('15128','2013-05-17','16:30:00',3.29),('15128','2013-05-17','16:35:00',3.23),('15128','2013-05-17','16:40:00',3.14),('15128','2013-05-17','16:45:00',3.09),('15128','2013-05-17','16:50:00',2.98),('15128','2013-05-17','16:55:00',2.92),('15128','2013-05-17','17:00:00',2.84),('15128','2013-05-17','17:05:00',2.78),('15128','2013-05-17','17:10:00',2.72),('15128','2013-05-17','17:15:00',2.66),('15128','2013-05-17','17:20:00',2.59),('15128','2013-05-17','17:25:00',2.53),('15128','2013-05-17','17:30:00',2.45),('15128','2013-05-17','17:35:00',2.36),('15128','2013-05-17','17:40:00',2.26),('15128','2013-05-17','17:45:00',2.16),('15128','2013-05-17','17:50:00',2),('15128','2013-05-17','17:55:00',1.91),('15128','2013-05-17','18:00:00',1.85),('15128','2013-05-17','18:05:00',1.79),('15128','2013-05-17','18:10:00',1.71),('15128','2013-05-17','18:15:00',1.61),('15128','2013-05-17','18:20:00',1.52),('15128','2013-05-17','18:25:00',1.45),('15128','2013-05-17','18:30:00',1.35),('15128','2013-05-17','18:35:00',1.28),('15128','2013-05-17','18:40:00',1.17),('15128','2013-05-17','18:45:00',1.05),('15128','2013-05-16','07:50:00',1.17),('15128','2013-05-16','07:55:00',1.15),('15128','2013-05-16','08:00:00',1.03),('15128','2013-05-16','08:05:00',1.65),('15128','2013-05-16','08:10:00',1.45),('15128','2013-05-16','08:15:00',1.89),('15128','2013-05-16','08:20:00',2.06),('15128','2013-05-16','08:25:00',1.14),('15128','2013-05-16','09:15:00',1.29),('15128','2013-05-16','09:20:00',1.09),('15128','2013-05-16','10:15:00',1.07),('15128','2013-05-16','10:20:00',1.29),('15128','2013-05-16','10:25:00',1.26),('15128','2013-05-16','10:30:00',1.42),('15128','2013-05-16','10:35:00',1.36),('15128','2013-05-16','10:40:00',1.37),('15128','2013-05-16','10:45:00',2.35),('15128','2013-05-16','10:50:00',3.64),('15128','2013-05-16','10:55:00',2.69),('15128','2013-05-16','11:00:00',2.03),('15128','2013-05-16','11:05:00',1.83),('15128','2013-05-16','11:10:00',2.56),('15128','2013-05-16','11:15:00',2.98),('15128','2013-05-16','11:20:00',2.65),('15128','2013-05-16','11:25:00',3.55),('15128','2013-05-16','11:30:00',2.31),('15128','2013-05-16','11:35:00',2.8),('15128','2013-05-16','11:40:00',1.98),('15128','2013-05-16','11:45:00',2.18),('15128','2013-05-16','11:50:00',3.52),('15128','2013-05-16','11:55:00',4.09),('15128','2013-05-16','12:00:00',3.87),('15128','2013-05-16','12:05:00',4.16),('15128','2013-05-16','12:10:00',4.61),('15128','2013-05-16','12:15:00',4.84),('15128','2013-05-16','12:20:00',5.03),('15128','2013-05-16','12:25:00',5.14),('15128','2013-05-16','12:30:00',4.59),('15128','2013-05-16','12:35:00',4.28),('15128','2013-05-16','12:40:00',3.34),('15128','2013-05-16','12:45:00',4.15),('15128','2013-05-16','12:50:00',3.39),('15128','2013-05-16','12:55:00',4.6),('15128','2013-05-16','13:00:00',3.43),('15128','2013-05-16','13:05:00',1.28),('15128','2013-05-16','13:10:00',1.3),('15128','2013-05-16','13:20:00',1.06),('15128','2013-05-16','13:25:00',1.19),('15128','2013-05-16','13:30:00',2.52),('15128','2013-05-16','13:35:00',4.36),('15128','2013-05-16','13:40:00',3.14),('15128','2013-05-16','13:45:00',3.26),('15128','2013-05-16','13:50:00',3.33),('15128','2013-05-16','13:55:00',4.26),('15128','2013-05-16','14:00:00',4.76),('15128','2013-05-16','14:05:00',4.35),('15128','2013-05-16','14:10:00',4.66),('15128','2013-05-16','14:15:00',4.78),('15128','2013-05-16','14:20:00',4.32),('15128','2013-05-16','14:25:00',3.93),('15128','2013-05-16','14:30:00',4.51),('15128','2013-05-16','14:35:00',4.73),('15128','2013-05-16','14:40:00',4.28),('15128','2013-05-16','14:45:00',3.74),('15128','2013-05-16','14:50:00',4.27),('15128','2013-05-16','14:55:00',4.59),('15128','2013-05-16','15:00:00',3.84),('15128','2013-05-16','15:05:00',4.3),('15128','2013-05-16','15:10:00',4.72),('15128','2013-05-16','15:15:00',4.53),('15128','2013-05-16','15:20:00',4.19),('15128','2013-05-16','15:25:00',3.62),('15128','2013-05-16','15:30:00',4.46),('15128','2013-05-16','15:35:00',3.78),('15128','2013-05-16','15:40:00',4.35),('15128','2013-05-16','15:45:00',4.68),('15128','2013-05-16','15:50:00',4.42),('15128','2013-05-16','15:55:00',4.28),('15128','2013-05-16','16:00:00',4.33),('15128','2013-05-16','16:05:00',4.19),('15128','2013-05-16','16:10:00',3.53),('15128','2013-05-16','16:15:00',4.05),('15128','2013-05-16','16:20:00',4.01),('15128','2013-05-16','16:25:00',3.8),('15128','2013-05-16','16:30:00',3.56),('15128','2013-05-16','16:35:00',3.96),('15128','2013-05-16','16:40:00',3.8),('15128','2013-05-16','16:45:00',3.77),('15128','2013-05-16','16:50:00',3.71),('15128','2013-05-16','16:55:00',3.67),('15128','2013-05-16','17:00:00',3.62),('15128','2013-05-16','17:05:00',3.86),('15128','2013-05-16','17:10:00',3.69),('15128','2013-05-16','17:15:00',3.67),('15128','2013-05-16','17:20:00',3.48),('15128','2013-05-16','17:25:00',3.22),('15128','2013-05-16','17:30:00',3.1),('15128','2013-05-16','17:35:00',3.07),('15128','2013-05-16','17:40:00',3.05),('15128','2013-05-16','17:45:00',2.85),('15128','2013-05-16','17:50:00',2.6),('15128','2013-05-16','17:55:00',2.46),('15128','2013-05-16','18:00:00',2.34),('15128','2013-05-16','18:05:00',2.22),('15128','2013-05-16','18:10:00',2.18),('15128','2013-05-16','18:15:00',2.1),('15128','2013-05-16','18:20:00',2.02),('15128','2013-05-16','18:25:00',1.95),('15128','2013-05-16','18:30:00',1.92),('15128','2013-05-16','18:35:00',1.87),('15128','2013-05-16','18:40:00',1.81),('15128','2013-05-16','18:45:00',1.79),('15128','2013-05-16','18:50:00',1.72),('15128','2013-05-16','18:55:00',1.48),('15128','2013-05-16','19:00:00',1.34),('15128','2013-05-16','19:05:00',1.34),('15128','2013-05-16','19:10:00',1.34),('15128','2013-05-16','19:15:00',1.29),('15128','2013-05-16','19:20:00',1.25),('15128','2013-05-16','19:25:00',1.06),('15128','2013-05-15','09:20:00',1.14),('15128','2013-05-15','09:25:00',1.63),('15128','2013-05-15','09:30:00',1.46),('15128','2013-05-15','09:35:00',1.51),('15128','2013-05-15','09:40:00',1.74),('15128','2013-05-15','09:45:00',2.56),('15128','2013-05-15','09:50:00',2.42),('15128','2013-05-15','09:55:00',1.13),('15128','2013-05-15','10:00:00',1.93),('15128','2013-05-15','10:05:00',1.37),('15128','2013-05-15','10:10:00',1.16),('15128','2013-05-15','10:15:00',1.31),('15128','2013-05-15','10:20:00',1.96),('15128','2013-05-15','10:25:00',1.47),('15128','2013-05-15','10:30:00',1.69),('15128','2013-05-15','10:35:00',1.64),('15128','2013-05-15','10:40:00',2.19),('15128','2013-05-15','10:45:00',2.88),('15128','2013-05-15','10:50:00',1.8),('15128','2013-05-15','10:55:00',1.7),('15128','2013-05-15','11:00:00',2.6),('15128','2013-05-15','11:05:00',4.05),('15128','2013-05-15','11:10:00',2.87),('15128','2013-05-15','11:15:00',2.63),('15128','2013-05-15','11:20:00',2.15),('15128','2013-05-15','11:25:00',1.59),('15128','2013-05-15','11:30:00',1.88),('15128','2013-05-15','11:35:00',2.37),('15128','2013-05-15','11:40:00',3.68),('15128','2013-05-15','11:45:00',3.96),('15128','2013-05-15','11:50:00',4.07),('15128','2013-05-15','11:55:00',2.76),('15128','2013-05-15','12:00:00',1.55),('15128','2013-05-15','12:05:00',1.19),('15128','2013-05-15','12:10:00',1.28),('15128','2013-05-15','12:15:00',1.38),('15128','2013-05-15','12:20:00',1.77),('15128','2013-05-15','12:25:00',2.4),('15128','2013-05-15','12:30:00',3.31),('15128','2013-05-15','12:35:00',4.44),('15128','2013-05-15','12:40:00',3.94),('15128','2013-05-15','12:45:00',3.49),('15128','2013-05-15','12:50:00',3.73),('15128','2013-05-15','12:55:00',4.25),('15128','2013-05-15','13:00:00',4.14),('15128','2013-05-15','13:05:00',4.15),('15128','2013-05-15','13:10:00',4.19),('15128','2013-05-15','13:15:00',4.18),('15128','2013-05-15','13:20:00',4.14),('15128','2013-05-15','13:25:00',4.17),('15128','2013-05-15','13:30:00',4.17),('15128','2013-05-15','13:35:00',4.14),('15128','2013-05-15','13:40:00',4.15),('15128','2013-05-15','13:45:00',4.15),('15128','2013-05-15','13:50:00',4.14),('15128','2013-05-15','13:55:00',4.16),('15128','2013-05-15','14:00:00',4.15),('15128','2013-05-15','14:05:00',4.1),('15128','2013-05-15','14:10:00',4.08),('15128','2013-05-15','14:15:00',4.05),('15128','2013-05-15','14:20:00',4.02),('15128','2013-05-15','14:25:00',4.02),('15128','2013-05-15','14:30:00',4.01),('15128','2013-05-15','14:35:00',3.92),('15128','2013-05-15','14:40:00',3.98),('15128','2013-05-15','14:45:00',3.95),('15128','2013-05-15','14:50:00',3.91),('15128','2013-05-15','14:55:00',3.87),('15128','2013-05-15','15:00:00',3.52),('15128','2013-05-15','15:05:00',3.81),('15128','2013-05-15','15:10:00',3.84),('15128','2013-05-15','15:15:00',3.85),('15128','2013-05-15','15:20:00',3.81),('15128','2013-05-15','15:25:00',3.57),('15128','2013-05-15','15:30:00',3.61),('15128','2013-05-15','15:35:00',3.53),('15128','2013-05-15','15:40:00',3.53),('15128','2013-05-15','15:45:00',3.48),('15128','2013-05-15','15:50:00',3.46),('15128','2013-05-15','15:55:00',3.37),('15128','2013-05-15','16:00:00',3.31),('15128','2013-05-15','16:05:00',3.12),('15128','2013-05-15','16:10:00',3.29),('15128','2013-05-15','16:15:00',2.77),('15128','2013-05-15','16:20:00',3.05),('15128','2013-05-15','16:25:00',3.01),('15128','2013-05-15','16:30:00',2.92),('15128','2013-05-15','16:35:00',2.93),('15128','2013-05-15','16:40:00',3.07),('15128','2013-05-15','16:45:00',2.25),('15128','2013-05-15','16:50:00',2.49),('15128','2013-05-15','16:55:00',1.91),('15128','2013-05-15','17:00:00',1.79),('15128','2013-05-15','17:05:00',1.31),('15128','2013-05-15','17:10:00',1.51),('15128','2013-05-15','17:15:00',1.29),('15128','2013-05-15','17:20:00',1.5),('15128','2013-05-15','17:25:00',2.1),('15128','2013-05-15','17:30:00',2.37),('15128','2013-05-15','17:35:00',1.5),('15128','2013-05-15','18:20:00',1.14),('15128','2013-05-15','18:25:00',1.24),('15128','2013-05-15','18:30:00',1.32),('15128','2013-05-15','18:35:00',1.43),('15128','2013-05-15','18:40:00',1.41),('15128','2013-05-15','18:45:00',1.4),('15128','2013-05-15','18:50:00',1.33),('15128','2013-05-15','18:55:00',1.2),('15128','2013-05-15','19:00:00',1.01),('15128','2013-05-14','08:10:00',1.08),('15128','2013-05-14','08:15:00',1.17),('15128','2013-05-14','08:20:00',1.22),('15128','2013-05-14','08:25:00',1.23),('15128','2013-05-14','08:30:00',1.36),('15128','2013-05-14','08:35:00',1.48),('15128','2013-05-14','08:40:00',1.57),('15128','2013-05-14','08:45:00',1.62),('15128','2013-05-14','08:50:00',1.69),('15128','2013-05-14','08:55:00',1.7),('15128','2013-05-14','09:00:00',1.75),('15128','2013-05-14','09:05:00',1.79),('15128','2013-05-14','09:10:00',1.9),('15128','2013-05-14','09:15:00',1.99),('15128','2013-05-14','09:20:00',1.96),('15128','2013-05-14','09:25:00',1.96),('15128','2013-05-14','09:30:00',2.2),('15128','2013-05-14','09:35:00',2.21),('15128','2013-05-14','09:40:00',2.2),('15128','2013-05-14','09:45:00',2.26),('15128','2013-05-14','09:50:00',2.32),('15128','2013-05-14','09:55:00',2.36),('15128','2013-05-14','10:00:00',2.38),('15128','2013-05-14','10:05:00',2.5),('15128','2013-05-14','10:10:00',2.55),('15128','2013-05-14','10:15:00',2.69),('15128','2013-05-14','10:20:00',2.77),('15128','2013-05-14','10:25:00',2.84),('15128','2013-05-14','10:30:00',2.82),('15128','2013-05-14','10:35:00',2.84),('15128','2013-05-14','10:40:00',2.87),('15128','2013-05-14','10:45:00',2.95),('15128','2013-05-14','10:50:00',3.09),('15128','2013-05-14','10:55:00',3.18),('15128','2013-05-14','11:00:00',3.17),('15128','2013-05-14','11:05:00',3.24),('15128','2013-05-14','11:10:00',3.28),('15128','2013-05-14','11:15:00',3.23),('15128','2013-05-14','11:20:00',3.19),('15128','2013-05-14','11:25:00',3.5),('15128','2013-05-14','11:30:00',3.5),('15128','2013-05-14','11:35:00',3.68),('15128','2013-05-14','11:40:00',3.78),('15128','2013-05-14','11:45:00',3.99),('15128','2013-05-14','11:50:00',2.21),('15128','2013-05-14','11:55:00',2.48),('15128','2013-05-14','12:00:00',3.82),('15128','2013-05-14','12:05:00',3.73),('15128','2013-05-14','12:10:00',4.76),('15128','2013-05-14','12:15:00',3.3),('15128','2013-05-14','12:20:00',3.61),('15128','2013-05-14','12:25:00',3.55),('15128','2013-05-14','12:30:00',4.11),('15128','2013-05-14','12:35:00',3.36),('15128','2013-05-14','12:40:00',2.94),('15128','2013-05-14','12:45:00',2.53),('15128','2013-05-14','12:50:00',2.47),('15128','2013-05-14','12:55:00',2.47),('15128','2013-05-14','13:00:00',2.41),('15128','2013-05-14','13:05:00',2.59),('15128','2013-05-14','13:10:00',2.65),('15128','2013-05-14','13:15:00',2.61),('15128','2013-05-14','13:20:00',2.5),('15128','2013-05-14','13:25:00',2.55),('15128','2013-05-14','13:30:00',2.67),('15128','2013-05-14','13:35:00',2.64),('15128','2013-05-14','13:40:00',2.59),('15128','2013-05-14','13:45:00',2.13),('15128','2013-05-14','13:50:00',2.58),('15128','2013-05-14','13:55:00',2.44),('15128','2013-05-14','14:00:00',2.25),('15128','2013-05-14','14:05:00',2.61),('15128','2013-05-14','14:10:00',2.62),('15128','2013-05-14','14:15:00',2.69),('15128','2013-05-14','14:20:00',2.43),('15128','2013-05-14','14:25:00',2.22),('15128','2013-05-14','14:30:00',1.73),('15128','2013-05-14','14:35:00',1.49),('15128','2013-05-14','14:40:00',1.31),('15128','2013-05-14','14:45:00',1.24),('15128','2013-05-14','14:50:00',1.24),('15128','2013-05-14','14:55:00',1.37),('15128','2013-05-14','15:00:00',1.32),('15128','2013-05-14','15:05:00',1.12),('15128','2013-05-14','15:35:00',1.02),('15128','2013-05-14','15:40:00',1.08),('15128','2013-05-14','15:45:00',1.27),('15128','2013-05-14','15:50:00',1.72),('15128','2013-05-14','15:55:00',1.92),('15128','2013-05-14','16:00:00',1.89),('15128','2013-05-14','16:05:00',1.9),('15128','2013-05-14','16:10:00',1.77),('15128','2013-05-14','16:15:00',1.82),('15128','2013-05-14','16:20:00',1.88),('15128','2013-05-14','16:25:00',2),('15128','2013-05-14','16:30:00',1.64),('15128','2013-05-14','16:35:00',1.69),('15128','2013-05-14','16:40:00',1.54),('15128','2013-05-14','16:45:00',1.38),('15128','2013-05-14','16:50:00',1.32),('15128','2013-05-14','16:55:00',1.41),('15128','2013-05-14','17:00:00',1.75),('15128','2013-05-14','17:05:00',2.89),('15128','2013-05-14','17:10:00',3),('15128','2013-05-14','17:15:00',2.39),('15128','2013-05-14','17:20:00',2.3),('15128','2013-05-14','17:25:00',1.64),('15128','2013-05-14','17:30:00',1.26),('15128','2013-05-14','17:35:00',1.02),('15128','2013-05-13','08:05:00',1.03),('15128','2013-05-13','08:10:00',1.1),('15128','2013-05-13','08:15:00',1.15),('15128','2013-05-13','08:20:00',1.22),('15128','2013-05-13','08:25:00',1.3),('15128','2013-05-13','08:30:00',1.4),('15128','2013-05-13','08:35:00',1.49),('15128','2013-05-13','08:40:00',1.57),('15128','2013-05-13','08:45:00',1.63),('15128','2013-05-13','08:50:00',1.7),('15128','2013-05-13','08:55:00',1.76),('15128','2013-05-13','09:00:00',1.86),('15128','2013-05-13','09:05:00',1.96),('15128','2013-05-13','09:10:00',2.04),('15128','2013-05-13','09:15:00',2.12),('15128','2013-05-13','09:20:00',2.18),('15128','2013-05-13','09:25:00',2.1),('15128','2013-05-13','09:30:00',2.27),('15128','2013-05-13','09:35:00',2.36),('15128','2013-05-13','09:40:00',2.36),('15128','2013-05-13','09:45:00',2.32),('15128','2013-05-13','09:50:00',2.45),('15128','2013-05-13','09:55:00',2.46),('15128','2013-05-13','10:00:00',2.5),('15128','2013-05-13','10:05:00',2.68),('15128','2013-05-13','10:10:00',2.74),('15128','2013-05-13','10:15:00',2.83),('15128','2013-05-13','10:20:00',2.9),('15128','2013-05-13','10:25:00',2.95),('15128','2013-05-13','10:30:00',2.97),('15128','2013-05-13','10:35:00',3.08),('15128','2013-05-13','10:40:00',3.12),('15128','2013-05-13','10:45:00',3.17),('15128','2013-05-13','10:50:00',3.23),('15128','2013-05-13','10:55:00',3.28),('15128','2013-05-13','11:00:00',3.39),('15128','2013-05-13','11:05:00',3.39),('15128','2013-05-13','11:10:00',3.45),('15128','2013-05-13','11:15:00',3.47),('15128','2013-05-13','11:20:00',3.55),('15128','2013-05-13','11:25:00',3.63),('15128','2013-05-13','11:30:00',3.64),('15128','2013-05-13','11:35:00',3.77),('15128','2013-05-13','11:40:00',3.83),('15128','2013-05-13','11:45:00',3.88),('15128','2013-05-13','11:50:00',4.04),('15128','2013-05-13','11:55:00',4.08),('15128','2013-05-13','12:00:00',4.11),('15128','2013-05-13','12:05:00',4.14),('15128','2013-05-13','12:10:00',4.18),('15128','2013-05-13','12:15:00',4.19),('15128','2013-05-13','12:20:00',4.22),('15128','2013-05-13','12:25:00',4.26),('15128','2013-05-13','12:30:00',4.28),('15128','2013-05-13','12:35:00',4.31),('15128','2013-05-13','12:40:00',4.34),('15128','2013-05-13','12:45:00',4.38),('15128','2013-05-13','12:50:00',4.41),('15128','2013-05-13','12:55:00',4.43),('15128','2013-05-13','13:00:00',4.43),('15128','2013-05-13','13:05:00',4.42),('15128','2013-05-13','13:10:00',4.42),('15128','2013-05-13','13:15:00',4.22),('15128','2013-05-13','13:25:00',2.52),('15128','2013-05-13','13:30:00',4.46),('15128','2013-05-13','13:35:00',4.46),('15128','2013-05-13','13:45:00',2.3),('15128','2013-05-13','13:50:00',4.42),('15128','2013-05-13','13:55:00',4.42),('15128','2013-05-13','14:00:00',4.41),('15128','2013-05-13','14:05:00',2.84),('15128','2013-05-13','14:10:00',4.38),('15128','2013-05-13','14:15:00',4.43),('15128','2013-05-13','14:20:00',4.47),('15128','2013-05-13','14:25:00',3.02),('15128','2013-05-13','14:30:00',4.12),('15128','2013-05-13','14:35:00',4.44),('15128','2013-05-13','14:40:00',4.46),('15128','2013-05-13','14:45:00',3.71),('15128','2013-05-13','14:50:00',3.54),('15128','2013-05-13','14:55:00',4.4),('15128','2013-05-13','15:00:00',4.4),('15128','2013-05-13','15:05:00',4.37),('15128','2013-05-13','15:10:00',2.64),('15128','2013-05-13','15:15:00',4.31),('15128','2013-05-13','15:20:00',4.31),('15128','2013-05-13','15:25:00',4.31),('15128','2013-05-13','15:30:00',4.29),('15128','2013-05-13','15:35:00',4.27),('15128','2013-05-13','15:40:00',4.21),('15128','2013-05-13','15:45:00',4.15),('15128','2013-05-13','15:50:00',4.11),('15128','2013-05-13','15:55:00',4.08),('15128','2013-05-13','16:00:00',3.99),('15128','2013-05-13','16:05:00',3.95),('15128','2013-05-13','16:10:00',3.92),('15128','2013-05-13','16:15:00',3.88),('15128','2013-05-13','16:20:00',3.82),('15128','2013-05-13','16:25:00',3.76),('15128','2013-05-13','16:30:00',3.69),('15128','2013-05-13','16:35:00',3.65),('15128','2013-05-13','16:40:00',3.57),('15128','2013-05-13','16:45:00',3.48),('15128','2013-05-13','16:50:00',3.43),('15128','2013-05-13','16:55:00',3.37),('15128','2013-05-13','17:00:00',3.3),('15128','2013-05-13','17:05:00',3.23),('15128','2013-05-13','17:10:00',3.16),('15128','2013-05-13','17:15:00',3.09),('15128','2013-05-13','17:20:00',3.01),('15128','2013-05-13','17:25:00',2.93),('15128','2013-05-13','17:30:00',2.85),('15128','2013-05-13','17:35:00',2.74),('15128','2013-05-13','17:40:00',2.67),('15128','2013-05-13','17:45:00',2.54),('15128','2013-05-13','17:50:00',2.42),('15128','2013-05-13','17:55:00',2.31),('15128','2013-05-13','18:00:00',2.2),('15128','2013-05-13','18:05:00',2.1),('15128','2013-05-13','18:10:00',2.04),('15128','2013-05-13','18:15:00',1.98),('15128','2013-05-13','18:20:00',1.9),('15128','2013-05-13','18:25:00',1.83),('15128','2013-05-13','18:30:00',1.77),('15128','2013-05-13','18:35:00',1.68),('15128','2013-05-13','18:40:00',1.61),('15128','2013-05-13','18:45:00',1.5),('15128','2013-05-13','18:50:00',1.34),('15128','2013-05-13','18:55:00',1.25),('15128','2013-05-13','19:00:00',1.13),('15128','2013-05-13','19:05:00',1.08),('15128','2013-05-12','08:10:00',1.08),('15128','2013-05-12','08:15:00',1.13),('15128','2013-05-12','08:20:00',1.19),('15128','2013-05-12','08:25:00',1.26),('15128','2013-05-12','08:30:00',1.35),('15128','2013-05-12','08:35:00',1.43),('15128','2013-05-12','08:40:00',1.5),('15128','2013-05-12','08:45:00',1.56),('15128','2013-05-12','08:50:00',1.62),('15128','2013-05-12','08:55:00',1.66),('15128','2013-05-12','09:00:00',1.74),('15128','2013-05-12','09:05:00',1.84),('15128','2013-05-12','09:10:00',1.9),('15128','2013-05-12','09:15:00',2.01),('15128','2013-05-12','09:20:00',2.07),('15128','2013-05-12','09:25:00',1.64),('15128','2013-05-12','09:30:00',1.73),('15128','2013-05-12','09:35:00',2.28),('15128','2013-05-12','09:40:00',2.09),('15128','2013-05-12','09:45:00',1.48),('15128','2013-05-12','09:50:00',2.89),('15128','2013-05-12','09:55:00',2.14),('15128','2013-05-12','10:00:00',2.05),('15128','2013-05-12','10:05:00',2.5),('15128','2013-05-12','10:10:00',3.04),('15128','2013-05-12','10:15:00',3.06),('15128','2013-05-12','10:20:00',3.3),('15128','2013-05-12','10:25:00',3.46),('15128','2013-05-12','10:30:00',3.26),('15128','2013-05-12','10:35:00',3.23),('15128','2013-05-12','10:40:00',3.23),('15128','2013-05-12','10:45:00',3.36),('15128','2013-05-12','10:50:00',2.22),('15128','2013-05-12','10:55:00',2.93),('15128','2013-05-12','11:00:00',2.94),('15128','2013-05-12','11:05:00',1.53),('15128','2013-05-12','11:10:00',1.87),('15128','2013-05-12','11:15:00',1.06),('15128','2013-05-12','11:20:00',1.17),('15128','2013-05-12','11:25:00',1.61),('15128','2013-05-12','11:30:00',4.05),('15128','2013-05-12','11:35:00',4.19),('15128','2013-05-12','11:40:00',4.36),('15128','2013-05-12','11:45:00',4.62),('15128','2013-05-12','11:50:00',2.69),('15128','2013-05-12','11:55:00',1.79),('15128','2013-05-12','12:00:00',1.53),('15128','2013-05-12','12:05:00',4.11),('15128','2013-05-12','12:10:00',2.34),('15128','2013-05-12','12:15:00',3.47),('15128','2013-05-12','12:20:00',1.6),('15128','2013-05-12','12:25:00',1.48),('15128','2013-05-12','12:30:00',1.56),('15128','2013-05-12','12:35:00',2.35),('15128','2013-05-12','12:40:00',5.2),('15128','2013-05-12','12:45:00',4.87),('15128','2013-05-12','12:50:00',3.78),('15128','2013-05-12','12:55:00',1.23),('15128','2013-05-12','13:00:00',4.59),('15128','2013-05-12','13:05:00',2.54),('15128','2013-05-12','13:10:00',1.38),('15128','2013-05-12','13:15:00',1.19),('15128','2013-05-12','13:20:00',1.33),('15128','2013-05-12','13:25:00',4.36),('15128','2013-05-12','13:30:00',1.15),('15128','2013-05-12','13:35:00',2.46),('15128','2013-05-12','13:40:00',5.2),('15128','2013-05-12','13:45:00',1.69),('15128','2013-05-12','13:50:00',1.23),('15128','2013-05-12','13:55:00',3.2),('15128','2013-05-12','14:00:00',4.27),('15128','2013-05-12','14:05:00',4.71),('15128','2013-05-12','14:10:00',4.43),('15128','2013-05-12','14:15:00',5.22),('15128','2013-05-12','14:20:00',1.86),('15128','2013-05-12','14:40:00',2.53),('15128','2013-05-12','14:45:00',1.52),('15128','2013-05-12','14:50:00',3.85),('15128','2013-05-12','15:35:00',1.19),('15128','2013-05-12','15:40:00',3.35),('15128','2013-05-12','15:45:00',1.56),('15128','2013-05-12','15:50:00',1.12),('15128','2013-05-12','15:55:00',1.25),('15128','2013-05-12','16:00:00',1.3),('15128','2013-05-12','16:05:00',1.42),('15128','2013-05-12','16:10:00',1.51),('15128','2013-05-12','16:15:00',1.25),('15128','2013-05-12','16:25:00',1.03),('15128','2013-05-12','16:40:00',1.04),('15128','2013-05-12','16:50:00',1.8),('15128','2013-05-12','16:55:00',3.53),('15128','2013-05-12','17:00:00',3.14),('15128','2013-05-12','17:05:00',1.06),('15128','2013-05-12','17:10:00',1.06),('15128','2013-05-12','17:15:00',1.51),('15128','2013-05-12','17:20:00',1.34),('15128','2013-05-12','17:25:00',2.17),('15128','2013-05-12','17:30:00',1.27),('15128','2013-05-12','17:35:00',2.84),('15128','2013-05-12','17:40:00',2.73),('15128','2013-05-12','17:45:00',2.61),('15128','2013-05-12','17:50:00',2.46),('15128','2013-05-12','17:55:00',1.53),('15128','2013-05-12','18:05:00',1.07),('15128','2013-05-12','18:10:00',1.32),('15128','2013-05-12','18:15:00',1.73),('15128','2013-05-12','18:20:00',2.51),('15128','2013-05-12','18:25:00',2.35),('15128','2013-05-12','18:30:00',2.27),('15128','2013-05-12','18:35:00',1.88),('15128','2013-05-12','18:50:00',1.2),('15128','2013-05-11','07:55:00',1.09),('15128','2013-05-11','08:15:00',1.39),('15128','2013-05-11','08:20:00',1.65),('15128','2013-05-11','08:25:00',1.7),('15128','2013-05-11','08:30:00',1.99),('15128','2013-05-11','08:35:00',1.7),('15128','2013-05-11','08:40:00',1.71),('15128','2013-05-11','08:45:00',1.6),('15128','2013-05-11','08:50:00',1.08),('15128','2013-05-11','08:55:00',1.01),('15128','2013-05-11','09:05:00',1.41),('15128','2013-05-11','09:10:00',1.45),('15128','2013-05-11','09:15:00',1.71),('15128','2013-05-11','09:20:00',1.81),('15128','2013-05-11','09:25:00',1.71),('15128','2013-05-11','09:30:00',2.2),('15128','2013-05-11','09:35:00',2.67),('15128','2013-05-11','09:40:00',2.67),('15128','2013-05-11','09:45:00',2.79),('15128','2013-05-11','09:50:00',3.09),('15128','2013-05-11','09:55:00',3.18),('15128','2013-05-11','10:00:00',3.2),('15128','2013-05-11','10:05:00',3.23),('15128','2013-05-11','10:10:00',2.76),('15128','2013-05-11','10:15:00',2.71),('15128','2013-05-11','10:20:00',1.93),('15128','2013-05-11','10:25:00',1.28),('15128','2013-05-11','10:30:00',2.46),('15128','2013-05-11','10:35:00',3.34),('15128','2013-05-11','10:40:00',2.07),('15128','2013-05-11','10:45:00',2.95),('15128','2013-05-11','10:50:00',2.01),('15128','2013-05-11','10:55:00',1.2),('15128','2013-05-11','11:00:00',1.17),('15128','2013-05-11','11:05:00',2.13),('15128','2013-05-11','11:10:00',1.19),('15128','2013-05-11','11:15:00',1.29),('15128','2013-05-11','11:20:00',1.8),('15128','2013-05-11','11:25:00',2.37),('15128','2013-05-11','11:30:00',2.53),('15128','2013-05-11','11:35:00',3.66),('15128','2013-05-11','11:40:00',3.44),('15128','2013-05-11','11:45:00',1.93),('15128','2013-05-11','11:50:00',2.01),('15128','2013-05-11','11:55:00',4.73),('15128','2013-05-11','12:00:00',2.73),('15128','2013-05-11','12:05:00',4.07),('15128','2013-05-11','12:10:00',1.11),('15128','2013-05-11','12:15:00',1.11),('15128','2013-05-11','12:20:00',1.39),('15128','2013-05-11','12:25:00',1.44),('15128','2013-05-11','12:30:00',1.34),('15128','2013-05-11','12:35:00',2.4),('15128','2013-05-11','12:40:00',1.9),('15128','2013-05-11','12:45:00',4.06),('15128','2013-05-11','12:50:00',4.29),('15128','2013-05-11','12:55:00',4.63),('15128','2013-05-11','13:00:00',4.6),('15128','2013-05-11','13:05:00',4.57),('15128','2013-05-11','13:10:00',4.55),('15128','2013-05-11','13:15:00',4.58),('15128','2013-05-11','13:20:00',4.56),('15128','2013-05-11','13:25:00',4.61),('15128','2013-05-11','13:30:00',4.69),('15128','2013-05-11','13:35:00',3.88),('15128','2013-05-11','13:40:00',4.55),('15128','2013-05-11','13:45:00',4.61),('15128','2013-05-11','13:50:00',4.28),('15128','2013-05-11','13:55:00',4.45),('15128','2013-05-11','14:00:00',4.87),('15128','2013-05-11','14:05:00',4.86),('15128','2013-05-11','14:10:00',4.78),('15128','2013-05-11','14:15:00',4.79),('15128','2013-05-11','14:20:00',4.83),('15128','2013-05-11','14:25:00',4.32),('15128','2013-05-11','14:30:00',4.28),('15128','2013-05-11','14:35:00',4.51),('15128','2013-05-11','14:40:00',4.93),('15128','2013-05-11','14:45:00',4.07),('15128','2013-05-11','14:50:00',4.37),('15128','2013-05-11','14:55:00',2.44),('15128','2013-05-11','15:00:00',1.8),('15128','2013-05-11','15:05:00',4.12),('15128','2013-05-11','15:10:00',4.75),('15128','2013-05-11','15:15:00',3.78),('15128','2013-05-11','15:20:00',4.15),('15128','2013-05-11','15:25:00',4.35),('15128','2013-05-11','15:30:00',4.25),('15128','2013-05-11','15:35:00',4.21),('15128','2013-05-11','15:40:00',4.12),('15128','2013-05-11','15:45:00',4.06),('15128','2013-05-11','15:50:00',4.02),('15128','2013-05-11','15:55:00',4.04),('15128','2013-05-11','16:00:00',3.95),('15128','2013-05-11','16:05:00',3.89),('15128','2013-05-11','16:10:00',3.83),('15128','2013-05-11','16:15:00',3.72),('15128','2013-05-11','16:20:00',3.68),('15128','2013-05-11','16:25:00',2.55),('15128','2013-05-11','16:30:00',3.44),('15128','2013-05-11','16:35:00',3.33),('15128','2013-05-11','16:40:00',3.15),('15128','2013-05-11','16:45:00',2.96),('15128','2013-05-11','16:50:00',4.32),('15128','2013-05-11','16:55:00',3.25),('15128','2013-05-11','17:00:00',2.05),('15128','2013-05-11','17:05:00',3.77),('15128','2013-05-11','17:10:00',1.91),('15128','2013-05-11','17:15:00',3.21),('15128','2013-05-11','17:20:00',1.79),('15128','2013-05-11','17:25:00',1.98),('15128','2013-05-11','17:30:00',1.69),('15128','2013-05-11','17:35:00',2.2),('15128','2013-05-11','17:40:00',1.48),('15128','2013-05-11','17:45:00',1.4),('15128','2013-05-11','17:50:00',2.78),('15128','2013-05-11','17:55:00',2.98),('15128','2013-05-11','18:00:00',1.79),('15128','2013-05-11','18:05:00',2.01),('15128','2013-05-11','18:10:00',1.54),('15128','2013-05-11','18:15:00',1.6),('15128','2013-05-11','18:20:00',1.23),('15128','2013-05-11','18:25:00',1.16),('15128','2013-05-11','18:30:00',1.61),('15128','2013-05-11','18:35:00',1.38),('15128','2013-05-11','18:40:00',1.05),('15128','2013-05-11','19:05:00',1.04),('15128','2013-05-11','19:10:00',1.18),('15128','2014-03-30','09:00:00',1.02),('15128','2014-03-30','09:05:00',1.08),('15128','2014-03-30','09:50:00',1.72),('15128','2014-03-30','09:55:00',1.75),('15128','2014-03-30','10:00:00',1.8),('15128','2014-03-30','10:05:00',1.83),('15128','2014-03-30','10:10:00',1.89),('15128','2014-03-30','10:15:00',1.94),('15128','2014-03-30','10:20:00',1.94),('15128','2014-03-30','10:25:00',2.01),('15128','2014-03-30','10:30:00',2.11),('15128','2014-03-30','10:35:00',2.17),('15128','2014-03-30','10:40:00',2.2),('15128','2014-03-30','10:45:00',2.27),('15128','2014-03-30','10:50:00',2.35),('15128','2014-03-30','10:55:00',2.37),('15128','2014-03-30','11:00:00',2.33),('15128','2014-03-30','11:05:00',2.49),('15128','2014-03-30','11:10:00',2.55),('15128','2014-03-30','11:15:00',2.61),('15128','2014-03-30','11:20:00',2.72),('15128','2014-03-30','11:25:00',2.79),('15128','2014-03-30','11:30:00',2.82),('15128','2014-03-30','11:35:00',2.78),('15128','2014-03-30','11:40:00',2.93),('15128','2014-03-30','11:45:00',2.96),('15128','2014-03-30','11:50:00',3.12),('15128','2014-03-30','11:55:00',3.21),('15128','2014-03-30','12:00:00',3.34),('15128','2014-03-30','12:05:00',3.4),('15128','2014-03-30','12:10:00',3.43),('15128','2014-03-30','12:15:00',3.44),('15128','2014-03-30','12:20:00',3.51),('15128','2014-03-30','12:25:00',3.55),('15128','2014-03-30','12:30:00',3.58),('15128','2014-03-30','12:35:00',3.66),('15128','2014-03-30','12:40:00',3.68),('15128','2014-03-30','12:45:00',3.71),('15128','2014-03-30','12:50:00',3.74),('15128','2014-03-30','12:55:00',3.77),('15128','2014-03-30','13:00:00',3.77),('15128','2014-03-30','13:05:00',3.77),('15128','2014-03-30','13:10:00',3.79),('15128','2014-03-30','13:15:00',3.83),('15128','2014-03-30','13:20:00',3.84),('15128','2014-03-30','13:25:00',3.84),('15128','2014-03-30','13:30:00',3.85),('15128','2014-03-30','13:35:00',3.88),('15128','2014-03-30','13:40:00',3.87),('15128','2014-03-30','13:45:00',3.89),('15128','2014-03-30','13:50:00',3.9),('15128','2014-03-30','13:55:00',3.9),('15128','2014-03-30','14:00:00',3.91),('15128','2014-03-30','14:05:00',3.9),('15128','2014-03-30','14:10:00',3.89),('15128','2014-03-30','14:15:00',3.9),('15128','2014-03-30','14:20:00',3.91),('15128','2014-03-30','14:25:00',3.88),('15128','2014-03-30','14:30:00',3.88),('15128','2014-03-30','14:35:00',3.88),('15128','2014-03-30','14:40:00',3.85),('15128','2014-03-30','14:45:00',3.83),('15128','2014-03-30','14:50:00',3.82),('15128','2014-03-30','14:55:00',3.8),('15128','2014-03-30','15:00:00',3.78),('15128','2014-03-30','15:05:00',3.74),('15128','2014-03-30','15:10:00',3.7),('15128','2014-03-30','15:15:00',3.67),('15128','2014-03-30','15:20:00',3.66),('15128','2014-03-30','15:25:00',3.63),('15128','2014-03-30','15:30:00',3.58),('15128','2014-03-30','15:35:00',3.57),('15128','2014-03-30','15:40:00',3.52),('15128','2014-03-30','15:45:00',3.44),('15128','2014-03-30','15:50:00',3.36),('15128','2014-03-30','15:55:00',3.32),('15128','2014-03-30','16:00:00',3.29),('15128','2014-03-30','16:05:00',3.21),('15128','2014-03-30','16:10:00',3.15),('15128','2014-03-30','16:15:00',3.12),('15128','2014-03-30','16:20:00',3.05),('15128','2014-03-30','16:25:00',3),('15128','2014-03-30','16:30:00',2.94),('15128','2014-03-30','16:35:00',2.85),('15128','2014-03-30','16:40:00',2.78),('15128','2014-03-30','16:45:00',2.74),('15128','2014-03-30','16:50:00',2.64),('15128','2014-03-30','16:55:00',2.58),('15128','2014-03-30','17:00:00',2.47),('15128','2014-03-30','17:05:00',2.41),('15128','2014-03-30','17:10:00',2.29),('15128','2014-03-30','17:15:00',2.16),('15128','2014-03-30','17:20:00',2.02),('15128','2014-03-30','17:25:00',1.95),('15128','2014-03-30','17:30:00',1.87),('15128','2014-03-30','17:35:00',1.78),('15128','2014-03-30','17:40:00',1.65),('15128','2014-03-30','17:45:00',1.58),('15128','2014-03-30','17:50:00',1.53),('15128','2014-03-30','17:55:00',1.47),('15128','2014-03-30','18:00:00',1.41),('15128','2014-03-30','18:05:00',1.3),('15128','2014-03-30','18:10:00',1.17),('15128','2014-03-30','18:15:00',1.07),('15128','2013-05-10','08:00:00',1.14),('15128','2013-05-10','08:05:00',1.04),('15128','2013-05-10','08:35:00',1.05),('15128','2013-05-10','08:40:00',1.18),('15128','2013-05-10','08:45:00',1.3),('15128','2013-05-10','08:50:00',1.93),('15128','2013-05-10','08:55:00',1.46),('15128','2013-05-10','09:00:00',1.6),('15128','2013-05-10','09:05:00',1.22),('15128','2013-05-10','09:10:00',1.83),('15128','2013-05-10','09:15:00',1.47),('15128','2013-05-10','09:20:00',2.43),('15128','2013-05-10','09:25:00',1.36),('15128','2013-05-10','09:30:00',1.62),('15128','2013-05-10','09:35:00',1.25),('15128','2013-05-10','09:40:00',1.61),('15128','2013-05-10','09:45:00',1.81),('15128','2013-05-10','09:50:00',3.09),('15128','2013-05-10','09:55:00',3.29),('15128','2013-05-10','10:00:00',2.27),('15128','2013-05-10','10:15:00',2.16),('15128','2013-05-10','10:20:00',3.05),('15128','2013-05-10','10:25:00',3.19),('15128','2013-05-10','10:30:00',1.57),('15128','2013-05-10','10:40:00',2.35),('15128','2013-05-10','10:45:00',3.3),('15128','2013-05-10','10:50:00',3.29),('15128','2013-05-10','10:55:00',2.62),('15128','2013-05-10','11:00:00',3.76),('15128','2013-05-10','11:05:00',3.7),('15128','2013-05-10','11:10:00',3.84),('15128','2013-05-10','11:15:00',1.58),('15128','2013-05-10','11:20:00',3.94),('15128','2013-05-10','11:25:00',2.9),('15128','2013-05-10','11:30:00',1.77),('15128','2013-05-10','11:35:00',3.55),('15128','2013-05-10','11:40:00',4.23),('15128','2013-05-10','11:45:00',3.39),('15128','2013-05-10','11:50:00',2.39),('15128','2013-05-10','11:55:00',2.78),('15128','2013-05-10','12:00:00',3.8),('15128','2013-05-10','12:05:00',3.29),('15128','2013-05-10','12:10:00',3.61),('15128','2013-05-10','12:15:00',3.33),('15128','2013-05-10','12:20:00',3.66),('15128','2013-05-10','12:25:00',2.78),('15128','2013-05-10','12:30:00',3.23),('15128','2013-05-10','12:35:00',3.54),('15128','2013-05-10','12:40:00',3.55),('15128','2013-05-10','12:45:00',2.91),('15128','2013-05-10','12:50:00',2.09),('15128','2013-05-10','12:55:00',4),('15128','2013-05-10','13:00:00',3.65),('15128','2013-05-10','13:05:00',4.85),('15128','2013-05-10','13:10:00',3.61),('15128','2013-05-10','13:15:00',3.8),('15128','2013-05-10','13:20:00',3.43),('15128','2013-05-10','13:25:00',4.75),('15128','2013-05-10','13:30:00',2.14),('15128','2013-05-10','13:35:00',2.67),('15128','2013-05-10','13:40:00',4.01),('15128','2013-05-10','13:45:00',2.32),('15128','2013-05-10','13:50:00',3.6),('15128','2013-05-10','13:55:00',4.58),('15128','2013-05-10','14:00:00',4.84),('15128','2013-05-10','14:05:00',4.99),('15128','2013-05-10','14:10:00',3.72),('15128','2013-05-10','14:15:00',3.42),('15128','2013-05-10','14:20:00',3.01),('15128','2013-05-10','14:25:00',2.37),('15128','2013-05-10','14:30:00',2.98),('15128','2013-05-10','14:35:00',3.06),('15128','2013-05-10','14:40:00',3.14),('15128','2013-05-10','14:45:00',3.6),('15128','2013-05-10','14:50:00',4.53),('15128','2013-05-10','14:55:00',2.82),('15128','2013-05-10','15:00:00',1.86),('15128','2013-05-10','15:05:00',2.89),('15128','2013-05-10','15:10:00',2.25),('15128','2013-05-10','15:15:00',3.88),('15128','2013-05-10','15:20:00',2.74),('15128','2013-05-10','15:25:00',3.12),('15128','2013-05-10','15:30:00',2.43),('15128','2013-05-10','15:35:00',2.86),('15128','2013-05-10','15:40:00',2.75),('15128','2013-05-10','15:45:00',2.2),('15128','2013-05-10','15:50:00',4.18),('15128','2013-05-10','15:55:00',3.36),('15128','2013-05-10','16:00:00',2.69),('15128','2013-05-10','16:05:00',2.78),('15128','2013-05-10','16:10:00',4.14),('15128','2013-05-10','16:15:00',3.56),('15128','2013-05-10','16:20:00',3.79),('15128','2013-05-10','16:25:00',3.95),('15128','2013-05-10','16:30:00',3.61),('15128','2013-05-10','16:35:00',3.55),('15128','2013-05-10','16:40:00',2.96),('15128','2013-05-10','16:45:00',2.02),('15128','2013-05-10','16:50:00',2.2),('15128','2013-05-10','16:55:00',3.27),('15128','2013-05-10','17:00:00',2.18),('15128','2013-05-10','17:05:00',1.98),('15128','2013-05-10','17:10:00',1.6),('15128','2013-05-10','17:15:00',2.25),('15128','2013-05-10','17:20:00',1.78),('15128','2013-05-10','17:25:00',2.37),('15128','2013-05-10','17:30:00',2.73),('15128','2013-05-10','17:35:00',2.03),('15128','2013-05-10','17:40:00',2.22),('15128','2013-05-10','17:45:00',2.69),('15128','2013-05-10','17:50:00',2.07),('15128','2013-05-10','17:55:00',2.02),('15128','2013-05-10','18:00:00',2.11),('15128','2013-05-10','18:05:00',2.03),('15128','2013-05-10','18:10:00',1.87),('15128','2013-05-10','18:15:00',1.51),('15128','2013-05-10','18:20:00',2.08),('15128','2013-05-10','18:25:00',1.84),('15128','2013-05-10','18:40:00',1.14),('15128','2013-05-10','19:00:00',1.01),('15128','2013-05-09','07:50:00',1),('15128','2013-05-09','07:55:00',1.45),('15128','2013-05-09','08:00:00',1.49),('15128','2013-05-09','08:05:00',1.4),('15128','2013-05-09','08:10:00',1.05),('15128','2013-05-09','08:15:00',1.12),('15128','2013-05-09','08:20:00',1.3),('15128','2013-05-09','08:25:00',1.02),('15128','2013-05-09','08:50:00',1.49),('15128','2013-05-09','08:55:00',1.69),('15128','2013-05-09','09:00:00',1.77),('15128','2013-05-09','09:05:00',1.79),('15128','2013-05-09','09:10:00',1.93),('15128','2013-05-09','09:15:00',1.89),('15128','2013-05-09','09:20:00',1.66),('15128','2013-05-09','09:25:00',2),('15128','2013-05-09','09:30:00',2.1),('15128','2013-05-09','09:35:00',2.13),('15128','2013-05-09','09:40:00',2.31),('15128','2013-05-09','09:45:00',1.95),('15128','2013-05-09','09:50:00',1.44),('15128','2013-05-09','09:55:00',2.44),('15128','2013-05-09','10:00:00',2.69),('15128','2013-05-09','10:05:00',2.85),('15128','2013-05-09','10:10:00',3.1),('15128','2013-05-09','10:15:00',2.87),('15128','2013-05-09','10:20:00',2.99),('15128','2013-05-09','10:25:00',2.8),('15128','2013-05-09','10:30:00',2.93),('15128','2013-05-09','10:35:00',2.97),('15128','2013-05-09','10:40:00',3.03),('15128','2013-05-09','10:45:00',3.11),('15128','2013-05-09','10:50:00',3.43),('15128','2013-05-09','10:55:00',3.69),('15128','2013-05-09','11:00:00',3.5),('15128','2013-05-09','11:05:00',3.22),('15128','2013-05-09','11:10:00',3.44),('15128','2013-05-09','11:15:00',3.93),('15128','2013-05-09','11:20:00',2.92),('15128','2013-05-09','11:25:00',2.4),('15128','2013-05-09','11:30:00',4.18),('15128','2013-05-09','11:35:00',3.23),('15128','2013-05-09','11:40:00',2.17),('15128','2013-05-09','11:45:00',4.08),('15128','2013-05-09','11:50:00',2.53),('15128','2013-05-09','11:55:00',2.53),('15128','2013-05-09','12:00:00',3.29),('15128','2013-05-09','12:05:00',3.1),('15128','2013-05-09','12:10:00',2.98),('15128','2013-05-09','12:15:00',3.01),('15128','2013-05-09','12:20:00',2.94),('15128','2013-05-09','12:25:00',3.55),('15128','2013-05-09','12:30:00',4.68),('15128','2013-05-09','12:35:00',4.76),('15128','2013-05-09','12:40:00',4.42),('15128','2013-05-09','12:45:00',3.97),('15128','2013-05-09','12:50:00',5.01),('15128','2013-05-09','12:55:00',4.03),('15128','2013-05-09','13:00:00',2.95),('15128','2013-05-09','13:05:00',3.88),('15128','2013-05-09','13:10:00',4.92),('15128','2013-05-09','13:15:00',3.04),('15128','2013-05-09','13:20:00',3.1),('15128','2013-05-09','13:25:00',4.77),('15128','2013-05-09','13:30:00',4.55),('15128','2013-05-09','13:35:00',4.94),('15128','2013-05-09','13:40:00',2.87),('15128','2013-05-09','13:45:00',2.2),('15128','2013-05-09','13:50:00',2.05),('15128','2013-05-09','13:55:00',2.31),('15128','2013-05-09','14:00:00',2.84),('15128','2013-05-09','14:05:00',3.12),('15128','2013-05-09','14:10:00',3.28),('15128','2013-05-09','14:15:00',2.83),('15128','2013-05-09','14:20:00',2.71),('15128','2013-05-09','14:25:00',2.81),('15128','2013-05-09','14:30:00',2.64),('15128','2013-05-09','14:35:00',2.18),('15128','2013-05-09','14:40:00',1.79),('15128','2013-05-09','14:45:00',1.58),('15128','2013-05-09','14:50:00',1.82),('15128','2013-05-09','14:55:00',2.56),('15128','2013-05-09','15:00:00',4.78),('15128','2013-05-09','15:05:00',3.69),('15128','2013-05-09','15:10:00',2.78),('15128','2013-05-09','15:15:00',2.24),('15128','2013-05-09','15:20:00',2.32),('15128','2013-05-09','15:25:00',2.71),('15128','2013-05-09','15:30:00',2.94),('15128','2013-05-09','15:35:00',2.38),('15128','2013-05-09','15:40:00',2.25),('15128','2013-05-09','15:45:00',2.08),('15128','2013-05-09','15:50:00',1.98),('15128','2013-05-09','15:55:00',1.94),('15128','2013-05-09','16:00:00',1.84),('15128','2013-05-09','16:05:00',1.63),('15128','2013-05-09','16:10:00',1.64),('15128','2013-05-09','16:15:00',1.69),('15128','2013-05-09','16:20:00',1.66),('15128','2013-05-09','16:25:00',1.88),('15128','2013-05-09','16:30:00',1.8),('15128','2013-05-09','16:35:00',1.74),('15128','2013-05-09','16:40:00',1.64),('15128','2013-05-09','16:45:00',1.35),('15128','2013-05-09','16:50:00',1.38),('15128','2013-05-09','16:55:00',1.52),('15128','2013-05-09','17:00:00',2),('15128','2013-05-09','17:05:00',1.92),('15128','2013-05-09','17:10:00',2.18),('15128','2013-05-09','17:15:00',2.46),('15128','2013-05-09','17:20:00',3.82),('15128','2013-05-09','17:25:00',3.33),('15128','2013-05-09','17:30:00',1.94),('15128','2013-05-09','17:35:00',1.59),('15128','2013-05-09','17:40:00',1.48),('15128','2013-05-09','17:45:00',1.11),('15128','2013-05-08','08:10:00',1.03),('15128','2013-05-08','08:15:00',1.11),('15128','2013-05-08','08:20:00',1.19),('15128','2013-05-08','08:25:00',1.25),('15128','2013-05-08','08:30:00',1.33),('15128','2013-05-08','08:35:00',1.44),('15128','2013-05-08','08:40:00',1.5),('15128','2013-05-08','08:45:00',1.58),('15128','2013-05-08','08:50:00',1.64),('15128','2013-05-08','08:55:00',1.71),('15128','2013-05-08','09:00:00',1.77),('15128','2013-05-08','09:05:00',1.87),('15128','2013-05-08','09:10:00',1.95),('15128','2013-05-08','09:15:00',2.01),('15128','2013-05-08','09:20:00',2.1),('15128','2013-05-08','09:25:00',2.14),('15128','2013-05-08','09:30:00',2.15),('15128','2013-05-08','09:35:00',2.13),('15128','2013-05-08','09:40:00',2.12),('15128','2013-05-08','09:45:00',2.14),('15128','2013-05-08','09:50:00',2.27),('15128','2013-05-08','09:55:00',2.34),('15128','2013-05-08','10:00:00',2.41),('15128','2013-05-08','10:05:00',2.53),('15128','2013-05-08','10:10:00',2.64),('15128','2013-05-08','10:15:00',2.7),('15128','2013-05-08','10:20:00',2.68),('15128','2013-05-08','10:25:00',2.76),('15128','2013-05-08','10:30:00',2.84),('15128','2013-05-08','10:35:00',2.86),('15128','2013-05-08','10:40:00',2.93),('15128','2013-05-08','10:45:00',3.03),('15128','2013-05-08','10:50:00',3.07),('15128','2013-05-08','10:55:00',3.18),('15128','2013-05-08','11:00:00',3.21),('15128','2013-05-08','11:05:00',3.33),('15128','2013-05-08','11:10:00',3.28),('15128','2013-05-08','11:15:00',3.37),('15128','2013-05-08','11:20:00',3.37),('15128','2013-05-08','11:25:00',3.44),('15128','2013-05-08','11:30:00',3.52),('15128','2013-05-08','11:35:00',3.51),('15128','2013-05-08','11:40:00',3.63),('15128','2013-05-08','11:45:00',3.85),('15128','2013-05-08','11:50:00',3.96),('15128','2013-05-08','11:55:00',4.01),('15128','2013-05-08','12:00:00',4.04),('15128','2013-05-08','12:05:00',4.07),('15128','2013-05-08','12:10:00',4.09),('15128','2013-05-08','12:15:00',4.24),('15128','2013-05-08','12:20:00',4.24),('15128','2013-05-08','12:25:00',4.3),('15128','2013-05-08','12:30:00',4.35),('15128','2013-05-08','12:35:00',4.32),('15128','2013-05-08','12:40:00',4.44),('15128','2013-05-08','12:45:00',4.52),('15128','2013-05-08','12:50:00',4.46),('15128','2013-05-08','12:55:00',4.37),('15128','2013-05-08','13:00:00',4.31),('15128','2013-05-08','13:05:00',4.34),('15128','2013-05-08','13:10:00',4.37),('15128','2013-05-08','13:15:00',4.45),('15128','2013-05-08','13:20:00',4.43),('15128','2013-05-08','13:25:00',4.44),('15128','2013-05-08','13:30:00',4.49),('15128','2013-05-08','13:35:00',4.58),('15128','2013-05-08','13:40:00',1.8),('15128','2013-05-08','13:50:00',1.95),('15128','2013-05-08','13:55:00',1.33),('15128','2013-05-08','14:00:00',5.02),('15128','2013-05-08','14:05:00',4.66),('15128','2013-05-08','14:10:00',4.4),('15128','2013-05-08','14:15:00',2.17),('15128','2013-05-08','14:20:00',4.49),('15128','2013-05-08','14:25:00',4.78),('15128','2013-05-08','14:30:00',4.7),('15128','2013-05-08','14:35:00',3.99),('15128','2013-05-08','14:40:00',3.86),('15128','2013-05-08','14:45:00',4.45),('15128','2013-05-08','14:50:00',4.34),('15128','2013-05-08','14:55:00',4.31),('15128','2013-05-08','15:00:00',4.31),('15128','2013-05-08','15:05:00',4.25),('15128','2013-05-08','15:10:00',4.23),('15128','2013-05-08','15:15:00',4.21),('15128','2013-05-08','15:20:00',4.16),('15128','2013-05-08','15:25:00',4.11),('15128','2013-05-08','15:30:00',4.12),('15128','2013-05-08','15:35:00',4.09),('15128','2013-05-08','15:40:00',4.05),('15128','2013-05-08','15:45:00',4.01),('15128','2013-05-08','15:50:00',3.96),('15128','2013-05-08','15:55:00',3.89),('15128','2013-05-08','16:00:00',3.87),('15128','2013-05-08','16:05:00',3.82),('15128','2013-05-08','16:10:00',3.75),('15128','2013-05-08','16:15:00',3.7),('15128','2013-05-08','16:20:00',3.66),('15128','2013-05-08','16:25:00',3.63),('15128','2013-05-08','16:30:00',3.56),('15128','2013-05-08','16:35:00',3.48),('15128','2013-05-08','16:40:00',3.44),('15128','2013-05-08','16:45:00',3.4),('15128','2013-05-08','16:50:00',3.34),('15128','2013-05-08','16:55:00',3.26),('15128','2013-05-08','17:00:00',3.18),('15128','2013-05-08','17:05:00',3.1),('15128','2013-05-08','17:10:00',3.02),('15128','2013-05-08','17:15:00',2.96),('15128','2013-05-08','17:20:00',2.9),('15128','2013-05-08','17:25:00',2.82),('15128','2013-05-08','17:30:00',2.73),('15128','2013-05-08','17:35:00',2.64),('15128','2013-05-08','17:40:00',2.54),('15128','2013-05-08','17:45:00',2.42),('15128','2013-05-08','17:50:00',2.29),('15128','2013-05-08','17:55:00',2.18),('15128','2013-05-08','18:00:00',2.04),('15128','2013-05-08','18:05:00',1.94),('15128','2013-05-08','18:10:00',1.89),('15128','2013-05-08','18:15:00',1.83),('15128','2013-05-08','18:20:00',1.79),('15128','2013-05-08','18:25:00',1.72),('15128','2013-05-08','18:30:00',1.63),('15128','2013-05-08','18:35:00',1.54),('15128','2013-05-08','18:40:00',1.47),('15128','2013-05-08','18:45:00',1.35),('15128','2013-05-08','18:50:00',1.24),('15128','2013-05-08','18:55:00',1.13),('15128','2013-05-08','19:00:00',1.01),('15128','2013-05-07','08:10:00',1.02),('15128','2013-05-07','08:15:00',1.1),('15128','2013-05-07','08:20:00',1.18),('15128','2013-05-07','08:25:00',1.26),('15128','2013-05-07','08:30:00',1.41),('15128','2013-05-07','08:35:00',1.63),('15128','2013-05-07','08:40:00',1.48),('15128','2013-05-07','08:45:00',1.1),('15128','2013-05-07','08:50:00',1.11),('15128','2013-05-07','08:55:00',1.39),('15128','2013-05-07','09:00:00',1.35),('15128','2013-05-07','09:05:00',1.09),('15128','2013-05-07','09:10:00',1.07),('15128','2013-05-07','09:15:00',1.12),('15128','2013-05-07','09:55:00',2.2),('15128','2013-05-07','10:00:00',2.71),('15128','2013-05-07','10:05:00',2.87),('15128','2013-05-07','10:10:00',3.18),('15128','2013-05-07','10:15:00',3.45),('15128','2013-05-07','10:20:00',2.31),('15128','2013-05-07','10:25:00',1.92),('15128','2013-05-07','10:30:00',2.72),('15128','2013-05-07','10:35:00',1.71),('15128','2013-05-07','10:40:00',3.03),('15128','2013-05-07','10:45:00',3.51),('15128','2013-05-07','10:50:00',1.94),('15128','2013-05-07','10:55:00',2.26),('15128','2013-05-07','11:00:00',4.25),('15128','2013-05-07','11:05:00',2.16),('15128','2013-05-07','11:10:00',1.25),('15128','2013-05-07','11:30:00',2.3),('15128','2013-05-07','11:35:00',4.19),('15128','2013-05-07','11:40:00',4.28),('15128','2013-05-07','11:45:00',4.53),('15128','2013-05-07','11:50:00',4.43),('15128','2013-05-07','11:55:00',1.49),('15128','2013-05-07','12:00:00',1.45),('15128','2013-05-07','12:05:00',4.91),('15128','2013-05-07','12:10:00',4.94),('15128','2013-05-07','12:15:00',3.41),('15128','2013-05-07','12:20:00',2.32),('15128','2013-05-07','12:25:00',4.21),('15128','2013-05-07','12:30:00',4.84),('15128','2013-05-07','12:35:00',4.51),('15128','2013-05-07','12:40:00',1.39),('15128','2013-05-07','12:45:00',1.68),('15128','2013-05-07','12:50:00',5.33),('15128','2013-05-07','12:55:00',2.16),('15128','2013-05-07','13:00:00',1.17),('15128','2013-05-07','13:05:00',1.42),('15128','2013-05-07','13:10:00',2.1),('15128','2013-05-07','13:15:00',2.24),('15128','2013-05-07','13:20:00',4.05),('15128','2013-05-07','13:25:00',1.05),('15128','2013-05-07','13:30:00',1.12),('15128','2013-05-07','13:35:00',3.29),('15128','2013-05-07','13:40:00',5.57),('15128','2013-05-07','13:45:00',4.76),('15128','2013-05-07','13:50:00',5.26),('15128','2013-05-07','13:55:00',3.63),('15128','2013-05-07','14:00:00',3.69),('15128','2013-05-07','14:05:00',2.77),('15128','2013-05-07','14:10:00',4.72),('15128','2013-05-07','14:15:00',4.41),('15128','2013-05-07','14:20:00',3.75),('15128','2013-05-07','14:25:00',2.58),('15128','2013-05-07','14:30:00',1.32),('15128','2013-05-07','14:35:00',2.67),('15128','2013-05-07','14:40:00',3.29),('15128','2013-05-07','14:45:00',1.64),('15128','2013-05-07','14:50:00',1.71),('15128','2013-05-07','14:55:00',3.16),('15128','2013-05-07','15:00:00',4.69),('15128','2013-05-07','15:05:00',1.74),('15128','2013-05-07','15:10:00',3.69),('15128','2013-05-07','15:15:00',4.22),('15128','2013-05-07','15:20:00',3.93),('15128','2013-05-07','15:25:00',4.32),('15128','2013-05-07','15:30:00',4.28),('15128','2013-05-07','15:35:00',4.17),('15128','2013-05-07','15:40:00',4.11),('15128','2013-05-07','15:45:00',4.07),('15128','2013-05-07','15:50:00',3.98),('15128','2013-05-07','15:55:00',3.95),('15128','2013-05-07','16:00:00',3.9),('15128','2013-05-07','16:05:00',3.73),('15128','2013-05-07','16:10:00',3.82),('15128','2013-05-07','16:15:00',3.73),('15128','2013-05-07','16:20:00',3.68),('15128','2013-05-07','16:25:00',3.65),('15128','2013-05-07','16:30:00',3.65),('15128','2013-05-07','16:35:00',3.64),('15128','2013-05-07','16:40:00',3.59),('15128','2013-05-07','16:45:00',2.72),('15128','2013-05-07','16:50:00',3.26),('15128','2013-05-07','16:55:00',2.73),('15128','2013-05-07','17:00:00',2.27),('15128','2013-05-07','17:05:00',2.48),('15128','2013-05-07','17:10:00',1.69),('15128','2013-05-07','17:15:00',1.39),('15128','2013-05-07','17:20:00',1.57),('15128','2013-05-07','17:25:00',2.42),('15128','2013-05-07','17:30:00',2.95),('15128','2013-05-07','17:35:00',2.86),('15128','2013-05-07','17:40:00',2.91),('15128','2013-05-07','17:45:00',2.93),('15128','2013-05-07','17:50:00',2.9),('15128','2013-05-07','17:55:00',2.8),('15128','2013-05-07','18:00:00',2.61),('15128','2013-05-07','18:05:00',2.54),('15128','2013-05-07','18:10:00',2.32),('15128','2013-05-07','18:15:00',2.16),('15128','2013-05-07','18:20:00',2.02),('15128','2013-05-07','18:25:00',1.87),('15128','2013-05-07','18:45:00',1.35),('15128','2013-05-07','18:50:00',1.27),('15128','2013-05-07','18:55:00',1.18),('15128','2013-05-06','08:15:00',1.09),('15128','2013-05-06','08:20:00',1.16),('15128','2013-05-06','08:25:00',1.23),('15128','2013-05-06','08:30:00',1.3),('15128','2013-05-06','08:35:00',1.38),('15128','2013-05-06','08:40:00',1.42),('15128','2013-05-06','08:45:00',1.07),('15128','2013-05-06','08:50:00',1.42),('15128','2013-05-06','09:00:00',2.22),('15128','2013-05-06','09:05:00',1.04),('15128','2013-05-06','09:10:00',1.48),('15128','2013-05-06','09:15:00',2.22),('15128','2013-05-06','09:20:00',1.81),('15128','2013-05-06','09:35:00',1.36),('15128','2013-05-06','10:15:00',2.31),('15128','2013-05-06','10:20:00',3.12),('15128','2013-05-06','10:25:00',2.88),('15128','2013-05-06','10:30:00',3.53),('15128','2013-05-06','10:35:00',2.35),('15128','2013-05-06','10:40:00',1.25),('15128','2013-05-06','11:10:00',1.39),('15128','2013-05-06','11:15:00',2.91),('15128','2013-05-06','11:20:00',4.2),('15128','2013-05-06','11:25:00',4.22),('15128','2013-05-06','11:30:00',3.57),('15128','2013-05-06','11:35:00',4.68),('15128','2013-05-06','11:40:00',4.27),('15128','2013-05-06','11:45:00',2.66),('15128','2013-05-06','11:50:00',4.4),('15128','2013-05-06','11:55:00',2.1),('15128','2013-05-06','12:00:00',1.35),('15128','2013-05-06','12:05:00',1.14),('15128','2013-05-06','12:15:00',1),('15128','2013-05-06','12:40:00',1.13),('15128','2013-05-06','12:45:00',1.66),('15128','2013-05-06','12:50:00',2.18),('15128','2013-05-06','12:55:00',2.36),('15128','2013-05-06','13:00:00',2.49),('15128','2013-05-06','13:05:00',2.83),('15128','2013-05-06','13:10:00',1.54),('15128','2013-05-06','13:15:00',3.43),('15128','2013-05-06','13:20:00',5.56),('15128','2013-05-06','13:25:00',2.76),('15128','2013-05-06','13:30:00',4.26),('15128','2013-05-06','13:35:00',4.61),('15128','2013-05-06','13:40:00',2.91),('15128','2013-05-06','13:45:00',4.8),('15128','2013-05-06','13:50:00',4.89),('15128','2013-05-06','13:55:00',2.91),('15128','2013-05-06','14:00:00',2.78),('15128','2013-05-06','14:05:00',3.28),('15128','2013-05-06','14:10:00',3.36),('15128','2013-05-06','14:15:00',2.83),('15128','2013-05-06','14:20:00',4.86),('15128','2013-05-06','14:25:00',5.28),('15128','2013-05-06','14:30:00',4.66),('15128','2013-05-06','14:35:00',2.96),('15128','2013-05-06','14:40:00',5.1),('15128','2013-05-06','14:45:00',5.12),('15128','2013-05-06','14:50:00',4.34),('15128','2013-05-06','14:55:00',4.27),('15128','2013-05-06','15:00:00',3.37),('15128','2013-05-06','15:05:00',4.65),('15128','2013-05-06','15:10:00',2.78),('15128','2013-05-06','15:15:00',1.45),('15128','2013-05-06','15:20:00',2.51),('15128','2013-05-06','15:25:00',3.99),('15128','2013-05-06','15:30:00',3.72),('15128','2013-05-06','15:35:00',4.26),('15128','2013-05-06','15:40:00',5.46),('15128','2013-05-06','15:45:00',3.79),('15128','2013-05-06','15:50:00',2.58),('15128','2013-05-06','15:55:00',3.06),('15128','2013-05-06','16:00:00',4.69),('15128','2013-05-06','16:05:00',4.26),('15128','2013-05-06','16:10:00',3.69),('15128','2013-05-06','16:15:00',4.47),('15128','2013-05-06','16:20:00',3.22),('15128','2013-05-06','16:25:00',4.46),('15128','2013-05-06','16:30:00',4.11),('15128','2013-05-06','16:35:00',3.55),('15128','2013-05-06','16:40:00',2.09),('15128','2013-05-06','16:45:00',1.84),('15128','2013-05-06','16:50:00',2.19),('15128','2013-05-06','16:55:00',1.98),('15128','2013-05-06','17:00:00',2),('15128','2013-05-06','17:05:00',1.74),('15128','2013-05-06','17:10:00',1.46),('15128','2013-05-06','17:15:00',1.37),('15128','2013-05-06','17:20:00',1.8),('15128','2013-05-06','17:25:00',1.59),('15128','2013-05-06','17:30:00',1.26),('15128','2013-05-05','08:20:00',1.1),('15128','2013-05-05','08:25:00',1.44),('15128','2013-05-05','08:30:00',1.12),('15128','2013-05-05','08:35:00',1.09),('15128','2013-05-05','08:40:00',1.29),('15128','2013-05-05','08:45:00',1.45),('15128','2013-05-05','08:50:00',1.57),('15128','2013-05-05','08:55:00',1.32),('15128','2013-05-05','09:00:00',1.2),('15128','2013-05-05','09:05:00',1.29),('15128','2013-05-05','09:10:00',1.84),('15128','2013-05-05','09:15:00',2.15),('15128','2013-05-05','09:20:00',1.59),('15128','2013-05-05','09:25:00',1.2),('15128','2013-05-05','09:45:00',1.32),('15128','2013-05-05','10:00:00',1.17),('15128','2013-05-05','10:05:00',1.32),('15128','2013-05-05','10:10:00',1.48),('15128','2013-05-05','10:15:00',2.09),('15128','2013-05-05','10:20:00',2.13),('15128','2013-05-05','10:25:00',1.75),('15128','2013-05-05','10:30:00',1.84),('15128','2013-05-05','10:35:00',1.85),('15128','2013-05-05','10:40:00',2.53),('15128','2013-05-05','10:45:00',1.99),('15128','2013-05-05','10:50:00',1.99),('15128','2013-05-05','10:55:00',1.68),('15128','2013-05-05','11:00:00',1.08),('15128','2013-05-05','11:05:00',1.13),('15128','2013-05-05','11:10:00',1.47),('15128','2013-05-05','11:15:00',1.68),('15128','2013-05-05','11:20:00',1.16),('15128','2013-05-05','11:25:00',1.12),('15128','2013-05-05','11:30:00',2.45),('15128','2013-05-05','11:35:00',2.77),('15128','2013-05-05','11:40:00',1.91),('15128','2013-05-05','11:45:00',2.34),('15128','2013-05-05','11:50:00',2.15),('15128','2013-05-05','11:55:00',1.8),('15128','2013-05-05','12:00:00',2.47),('15128','2013-05-05','12:05:00',2.4),('15128','2013-05-05','12:10:00',2.32),('15128','2013-05-05','12:15:00',1.84),('15128','2013-05-05','12:20:00',3.97),('15128','2013-05-05','12:25:00',3.31),('15128','2013-05-05','12:30:00',2.54),('15128','2013-05-05','12:35:00',3.46),('15128','2013-05-05','12:40:00',4.39),('15128','2013-05-05','12:45:00',3.31),('15128','2013-05-05','12:50:00',3.73),('15128','2013-05-05','12:55:00',2.13),('15128','2013-05-05','13:00:00',4.46),('15128','2013-05-05','13:05:00',4.94),('15128','2013-05-05','13:10:00',4.69),('15128','2013-05-05','13:15:00',4.13),('15128','2013-05-05','13:20:00',4.14),('15128','2013-05-05','13:25:00',2.58),('15128','2013-05-05','13:30:00',3.1),('15128','2013-05-05','13:35:00',4.06),('15128','2013-05-05','13:40:00',3.62),('15128','2013-05-05','13:45:00',5.41),('15128','2013-05-05','13:50:00',2.88),('15128','2013-05-05','13:55:00',3.07),('15128','2013-05-05','14:00:00',2.48),('15128','2013-05-05','14:05:00',4.81),('15128','2013-05-05','14:10:00',3.54),('15128','2013-05-05','14:15:00',4.59),('15128','2013-05-05','14:20:00',3.27),('15128','2013-05-05','14:25:00',4.18),('15128','2013-05-05','14:30:00',4.41),('15128','2013-05-05','14:35:00',3.88),('15128','2013-05-05','14:40:00',1.83),('15128','2013-05-05','14:45:00',3.29),('15128','2013-05-05','14:50:00',2.42),('15128','2013-05-05','14:55:00',2.5),('15128','2013-05-05','15:00:00',2.17),('15128','2013-05-05','15:05:00',3.75),('15128','2013-05-05','15:10:00',4.4),('15128','2013-05-05','15:15:00',2.38),('15128','2013-05-05','15:20:00',1.71),('15128','2013-05-05','15:25:00',3.42),('15128','2013-05-05','15:30:00',2.42),('15128','2013-05-05','15:35:00',2.14),('15128','2013-05-05','15:40:00',3.4),('15128','2013-05-05','15:45:00',4.09),('15128','2013-05-05','15:50:00',3.93),('15128','2013-05-05','15:55:00',2.21),('15128','2013-05-05','16:00:00',2.11),('15128','2013-05-05','16:05:00',2.8),('15128','2013-05-05','16:10:00',2.82),('15128','2013-05-05','16:15:00',2.54),('15128','2013-05-05','16:20:00',2.1),('15128','2013-05-05','16:25:00',1.81),('15128','2013-05-05','16:30:00',1.99),('15128','2013-05-05','16:35:00',1.31),('15128','2013-05-05','16:40:00',2.33),('15128','2013-05-05','16:45:00',1.21),('15128','2013-05-05','17:05:00',2.9),('15128','2013-05-05','17:10:00',3.88),('15128','2013-05-05','17:15:00',1.21),('15128','2013-05-05','17:20:00',1.16),('15128','2013-05-05','17:25:00',1.69),('15128','2013-05-05','17:30:00',2.96),('15128','2013-05-05','17:35:00',3.33),('15128','2013-05-05','17:40:00',2.9),('15128','2013-05-05','17:45:00',2.68),('15128','2013-05-05','17:50:00',1.01),('15128','2013-05-05','17:55:00',2.31),('15128','2013-05-05','18:00:00',2.26),('15128','2013-05-05','18:05:00',2.05),('15128','2013-05-05','18:10:00',1.96),('15128','2013-05-05','18:15:00',2.19),('15128','2013-05-05','18:20:00',2.08),('15128','2013-05-05','18:25:00',1.07),('15128','2013-05-05','18:30:00',1.24),('15128','2013-05-04','08:15:00',1.01),('15128','2013-05-04','08:20:00',1.15),('15128','2013-05-04','08:25:00',1.03),('15128','2013-05-04','08:35:00',1.06),('15128','2013-05-04','08:40:00',1.47),('15128','2013-05-04','08:45:00',1.41),('15128','2013-05-04','08:50:00',1.37),('15128','2013-05-04','08:55:00',1.29),('15128','2013-05-04','09:00:00',1.51),('15128','2013-05-04','09:05:00',1.32),('15128','2013-05-04','09:10:00',1.33),('15128','2013-05-04','09:15:00',1.37),('15128','2013-05-04','09:20:00',1.75),('15128','2013-05-04','09:25:00',2.47),('15128','2013-05-04','09:30:00',2.25),('15128','2013-05-04','09:35:00',2.53),('15128','2013-05-04','09:40:00',2.36),('15128','2013-05-04','09:45:00',2.18),('15128','2013-05-04','09:50:00',2.71),('15128','2013-05-04','09:55:00',1.69),('15128','2013-05-04','10:00:00',1.29),('15128','2013-05-04','10:05:00',1.33),('15128','2013-05-04','10:10:00',1.32),('15128','2013-05-04','10:15:00',1.4),('15128','2013-05-04','10:20:00',1.36),('15128','2013-05-04','10:25:00',1.85),('15128','2013-05-04','10:30:00',1.8),('15128','2013-05-04','10:35:00',1.79),('15128','2013-05-04','10:40:00',1.19),('15128','2013-05-04','10:45:00',1.01),('15128','2013-05-04','10:55:00',1),('15128','2013-05-04','11:00:00',1.32),('15128','2013-05-04','11:05:00',1.3),('15128','2013-05-04','11:10:00',2.59),('15128','2013-05-04','11:15:00',3.51),('15128','2013-05-04','11:20:00',2.64),('15128','2013-05-04','11:25:00',3.29),('15128','2013-05-04','11:30:00',3.45),('15128','2013-05-04','11:35:00',2.7),('15128','2013-05-04','11:40:00',2.83),('15128','2013-05-04','11:45:00',2.4),('15128','2013-05-04','11:50:00',3.05),('15128','2013-05-04','11:55:00',4.1),('15128','2013-05-04','12:00:00',3.92),('15128','2013-05-04','12:05:00',3.66),('15128','2013-05-04','12:10:00',4.22),('15128','2013-05-04','12:15:00',4.32),('15128','2013-05-04','12:20:00',4.15),('15128','2013-05-04','12:25:00',3.96),('15128','2013-05-04','12:30:00',4.17),('15128','2013-05-04','12:35:00',4.37),('15128','2013-05-04','12:40:00',4.27),('15128','2013-05-04','12:45:00',3.57),('15128','2013-05-04','12:50:00',3.45),('15128','2013-05-04','12:55:00',4.17),('15128','2013-05-04','13:00:00',1.75),('15128','2013-05-04','13:05:00',1.25),('15128','2013-05-04','13:10:00',1.92),('15128','2013-05-04','13:15:00',3.77),('15128','2013-05-04','13:20:00',3.68),('15128','2013-05-04','13:25:00',3.59),('15128','2013-05-04','13:30:00',3.67),('15128','2013-05-04','13:35:00',2.77),('15128','2013-05-04','13:40:00',2.81),('15128','2013-05-04','13:45:00',3.88),('15128','2013-05-04','13:50:00',2.91),('15128','2013-05-04','13:55:00',3.64),('15128','2013-05-04','14:00:00',3.86),('15128','2013-05-04','14:05:00',4.41),('15128','2013-05-04','14:10:00',4.21),('15128','2013-05-04','14:15:00',4.14),('15128','2013-05-04','14:20:00',4.09),('15128','2013-05-04','14:25:00',3.96),('15128','2013-05-04','14:30:00',3.94),('15128','2013-05-04','14:35:00',3.93),('15128','2013-05-04','14:40:00',3.93),('15128','2013-05-04','14:45:00',3.88),('15128','2013-05-04','14:50:00',3.86),('15128','2013-05-04','14:55:00',3.85),('15128','2013-05-04','15:00:00',3.83),('15128','2013-05-04','15:05:00',3.8),('15128','2013-05-04','15:10:00',3.77),('15128','2013-05-04','15:15:00',3.73),('15128','2013-05-04','15:20:00',3.67),('15128','2013-05-04','15:25:00',3.63),('15128','2013-05-04','15:30:00',3.6),('15128','2013-05-04','15:35:00',3.56),('15128','2013-05-04','15:40:00',3.54),('15128','2013-05-04','15:45:00',3.5),('15128','2013-05-04','15:50:00',3.45),('15128','2013-05-04','15:55:00',3.41),('15128','2013-05-04','16:00:00',3.4),('15128','2013-05-04','16:05:00',3.38),('15128','2013-05-04','16:10:00',3.33),('15128','2013-05-04','16:15:00',3.29),('15128','2013-05-04','16:20:00',3.24),('15128','2013-05-04','16:25:00',3.21),('15128','2013-05-04','16:30:00',3.13),('15128','2013-05-04','16:35:00',3.08),('15128','2013-05-04','16:40:00',3.02),('15128','2013-05-04','16:45:00',2.98),('15128','2013-05-04','16:50:00',2.92),('15128','2013-05-04','16:55:00',2.85),('15128','2013-05-04','17:00:00',2.78),('15128','2013-05-04','17:05:00',2.7),('15128','2013-05-04','17:10:00',2.64),('15128','2013-05-04','17:15:00',2.58),('15128','2013-05-04','17:20:00',2.49),('15128','2013-05-04','17:25:00',2.42),('15128','2013-05-04','17:30:00',2.34),('15128','2013-05-04','17:35:00',2.26),('15128','2013-05-04','17:40:00',2.17),('15128','2013-05-04','17:45:00',2.06),('15128','2013-05-04','17:50:00',1.97),('15128','2013-05-04','17:55:00',1.86),('15128','2013-05-04','18:00:00',1.8),('15128','2013-05-04','18:05:00',1.69),('15128','2013-05-04','18:10:00',1.64),('15128','2013-05-04','18:15:00',1.58),('15128','2013-05-04','18:20:00',1.51),('15128','2013-05-04','18:25:00',1.44),('15128','2013-05-04','18:30:00',1.33),('15128','2013-05-04','18:35:00',1.25),('15128','2013-05-04','18:40:00',1.16),('15128','2013-05-04','18:45:00',1.08),('15128','2013-05-03','08:20:00',1.05),('15128','2013-05-03','08:25:00',1.1),('15128','2013-05-03','08:30:00',1.12),('15128','2013-05-03','08:35:00',1.16),('15128','2013-05-03','08:40:00',1.26),('15128','2013-05-03','08:45:00',1.33),('15128','2013-05-03','08:50:00',1.37),('15128','2013-05-03','08:55:00',1.43),('15128','2013-05-03','09:00:00',1.5),('15128','2013-05-03','09:05:00',1.59),('15128','2013-05-03','09:10:00',1.61),('15128','2013-05-03','09:15:00',1.63),('15128','2013-05-03','09:20:00',1.7),('15128','2013-05-03','09:25:00',1.81),('15128','2013-05-03','09:30:00',1.78),('15128','2013-05-03','09:35:00',1.76),('15128','2013-05-03','09:40:00',1.84),('15128','2013-05-03','09:45:00',1.97),('15128','2013-05-03','09:50:00',2.08),('15128','2013-05-03','09:55:00',2.15),('15128','2013-05-03','10:00:00',2.29),('15128','2013-05-03','10:05:00',2.13),('15128','2013-05-03','10:10:00',2.35),('15128','2013-05-03','10:15:00',2.39),('15128','2013-05-03','10:20:00',2.47),('15128','2013-05-03','10:25:00',2.53),('15128','2013-05-03','10:30:00',2.53),('15128','2013-05-03','10:35:00',2.52),('15128','2013-05-03','10:40:00',2.56),('15128','2013-05-03','10:45:00',2.56),('15128','2013-05-03','10:50:00',2.6),('15128','2013-05-03','10:55:00',2.81),('15128','2013-05-03','11:00:00',2.86),('15128','2013-05-03','11:05:00',2.99),('15128','2013-05-03','11:10:00',2.98),('15128','2013-05-03','11:15:00',2.88),('15128','2013-05-03','11:20:00',2.75),('15128','2013-05-03','11:25:00',3.08),('15128','2013-05-03','11:30:00',3),('15128','2013-05-03','11:35:00',2.97),('15128','2013-05-03','11:40:00',3.07),('15128','2013-05-03','11:45:00',3.14),('15128','2013-05-03','11:50:00',3.06),('15128','2013-05-03','11:55:00',3.15),('15128','2013-05-03','12:00:00',3.29),('15128','2013-05-03','12:05:00',3.25),('15128','2013-05-03','12:10:00',3.24),('15128','2013-05-03','12:15:00',3.51),('15128','2013-05-03','12:20:00',3.63),('15128','2013-05-03','12:25:00',3.71),('15128','2013-05-03','12:30:00',3.86),('15128','2013-05-03','12:35:00',3.82),('15128','2013-05-03','12:40:00',3.8),('15128','2013-05-03','12:45:00',3.79),('15128','2013-05-03','12:50:00',3.84),('15128','2013-05-03','12:55:00',3.74),('15128','2013-05-03','13:00:00',3.75),('15128','2013-05-03','13:05:00',3.82),('15128','2013-05-03','13:10:00',3.85),('15128','2013-05-03','13:15:00',3.81),('15128','2013-05-03','13:20:00',3.9),('15128','2013-05-03','13:25:00',3.94),('15128','2013-05-03','13:30:00',3.87),('15128','2013-05-03','13:35:00',3.61),('15128','2013-05-03','13:40:00',3.89),('15128','2013-05-03','13:45:00',3.72),('15128','2013-05-03','13:50:00',3.31),('15128','2013-05-03','13:55:00',3.37),('15128','2013-05-03','14:00:00',3.74),('15128','2013-05-03','14:05:00',3.73),('15128','2013-05-03','14:10:00',3.59),('15128','2013-05-03','14:15:00',3.85),('15128','2013-05-03','14:20:00',3.59),('15128','2013-05-03','14:25:00',3.72),('15128','2013-05-03','14:30:00',3.66),('15128','2013-05-03','14:35:00',3.6),('15128','2013-05-03','14:40:00',3.59),('15128','2013-05-03','14:45:00',3.53),('15128','2013-05-03','14:50:00',3.28),('15128','2013-05-03','14:55:00',3.44),('15128','2013-05-03','15:00:00',3.59),('15128','2013-05-03','15:05:00',3.35),('15128','2013-05-03','15:10:00',3.44),('15128','2013-05-03','15:15:00',3.64),('15128','2013-05-03','15:20:00',3.59),('15128','2013-05-03','15:25:00',3.65),('15128','2013-05-03','15:30:00',3.67),('15128','2013-05-03','15:35:00',3.5),('15128','2013-05-03','15:40:00',3.57),('15128','2013-05-03','15:45:00',3.58),('15128','2013-05-03','15:50:00',3.51),('15128','2013-05-03','15:55:00',3.46),('15128','2013-05-03','16:00:00',3.4),('15128','2013-05-03','16:05:00',3.36),('15128','2013-05-03','16:10:00',3.3),('15128','2013-05-03','16:15:00',3.25),('15128','2013-05-03','16:20:00',3.19),('15128','2013-05-03','16:25:00',3.13),('15128','2013-05-03','16:30:00',3.08),('15128','2013-05-03','16:35:00',3.02),('15128','2013-05-03','16:40:00',2.98),('15128','2013-05-03','16:45:00',2.9),('15128','2013-05-03','16:50:00',2.87),('15128','2013-05-03','16:55:00',2.81),('15128','2013-05-03','17:00:00',2.75),('15128','2013-05-03','17:05:00',2.7),('15128','2013-05-03','17:10:00',2.5),('15128','2013-05-03','17:15:00',2.19),('15128','2013-05-03','17:20:00',2.36),('15128','2013-05-03','17:25:00',2.43),('15128','2013-05-03','17:30:00',2.34),('15128','2013-05-03','17:35:00',2.23),('15128','2013-05-03','17:40:00',2.04),('15128','2013-05-03','17:45:00',1.75),('15128','2013-05-03','17:50:00',2),('15128','2013-05-03','17:55:00',1.9),('15128','2013-05-03','18:00:00',1.81),('15128','2013-05-03','18:05:00',1.69),('15128','2013-05-03','18:10:00',1.59),('15128','2013-05-03','18:15:00',1.16),('15128','2013-05-02','08:25:00',1.05),('15128','2013-05-02','08:50:00',1.06),('15128','2013-05-02','08:55:00',1.31),('15128','2013-05-02','09:00:00',1.44),('15128','2013-05-02','09:05:00',1.45),('15128','2013-05-02','09:10:00',1.56),('15128','2013-05-02','09:15:00',1.69),('15128','2013-05-02','09:20:00',1.86),('15128','2013-05-02','09:25:00',1.89),('15128','2013-05-02','09:30:00',1.85),('15128','2013-05-02','09:35:00',1.87),('15128','2013-05-02','09:40:00',1.94),('15128','2013-05-02','09:45:00',2.06),('15128','2013-05-02','09:50:00',2.11),('15128','2013-05-02','09:55:00',2.18),('15128','2013-05-02','10:00:00',2.24),('15128','2013-05-02','10:05:00',2.3),('15128','2013-05-02','10:10:00',2.4),('15128','2013-05-02','10:15:00',2.42),('15128','2013-05-02','10:20:00',2.42),('15128','2013-05-02','10:25:00',2.51),('15128','2013-05-02','10:30:00',2.47),('15128','2013-05-02','10:35:00',2.5),('15128','2013-05-02','10:40:00',2.61),('15128','2013-05-02','10:45:00',2.75),('15128','2013-05-02','10:50:00',2.79),('15128','2013-05-02','10:55:00',2.9),('15128','2013-05-02','11:00:00',2.83),('15128','2013-05-02','11:05:00',2.97),('15128','2013-05-02','11:10:00',2.99),('15128','2013-05-02','11:15:00',3.05),('15128','2013-05-02','11:20:00',3.1),('15128','2013-05-02','11:25:00',3.07),('15128','2013-05-02','11:30:00',3.21),('15128','2013-05-02','11:35:00',3.19),('15128','2013-05-02','11:40:00',3.31),('15128','2013-05-02','11:45:00',3.51),('15128','2013-05-02','11:50:00',3.58),('15128','2013-05-02','11:55:00',3.64),('15128','2013-05-02','12:00:00',3.66),('15128','2013-05-02','12:05:00',3.72),('15128','2013-05-02','12:10:00',3.78),('15128','2013-05-02','12:15:00',3.83),('15128','2013-05-02','12:20:00',3.87),('15128','2013-05-02','12:25:00',3.92),('15128','2013-05-02','12:30:00',3.9),('15128','2013-05-02','12:35:00',3.91),('15128','2013-05-02','12:40:00',3.92),('15128','2013-05-02','12:45:00',3.92),('15128','2013-05-02','12:50:00',3.95),('15128','2013-05-02','12:55:00',3.99),('15128','2013-05-02','13:00:00',4),('15128','2013-05-02','13:05:00',4.01),('15128','2013-05-02','13:10:00',4.04),('15128','2013-05-02','13:15:00',4.05),('15128','2013-05-02','13:20:00',4.05),('15128','2013-05-02','13:25:00',4.01),('15128','2013-05-02','13:30:00',3.92),('15128','2013-05-02','13:35:00',4.03),('15128','2013-05-02','13:40:00',4.05),('15128','2013-05-02','13:45:00',4.07),('15128','2013-05-02','13:50:00',4.03),('15128','2013-05-02','13:55:00',3.9),('15128','2013-05-02','14:00:00',3.9),('15128','2013-05-02','14:05:00',3.98),('15128','2013-05-02','14:10:00',3.92),('15128','2013-05-02','14:15:00',4.06),('15128','2013-05-02','14:20:00',4.06),('15128','2013-05-02','14:25:00',4.03),('15128','2013-05-02','14:30:00',4.05),('15128','2013-05-02','14:35:00',4.07),('15128','2013-05-02','14:40:00',4.04),('15128','2013-05-02','14:45:00',4.02),('15128','2013-05-02','14:50:00',3.97),('15128','2013-05-02','14:55:00',3.95),('15128','2013-05-02','15:00:00',3.9),('15128','2013-05-02','15:05:00',3.89),('15128','2013-05-02','15:10:00',3.89),('15128','2013-05-02','15:15:00',3.83),('15128','2013-05-02','15:20:00',3.79),('15128','2013-05-02','15:25:00',3.77),('15128','2013-05-02','15:30:00',3.71),('15128','2013-05-02','15:35:00',3.64),('15128','2013-05-02','15:40:00',3.62),('15128','2013-05-02','15:45:00',3.6),('15128','2013-05-02','15:50:00',3.57),('15128','2013-05-02','15:55:00',3.54),('15128','2013-05-02','16:00:00',3.5),('15128','2013-05-02','16:05:00',3.46),('15128','2013-05-02','16:10:00',3.41),('15128','2013-05-02','16:15:00',3.35),('15128','2013-05-02','16:20:00',3.3),('15128','2013-05-02','16:25:00',3.24),('15128','2013-05-02','16:30:00',3.19),('15128','2013-05-02','16:35:00',3.11),('15128','2013-05-02','16:40:00',3.04),('15128','2013-05-02','16:45:00',2.98),('15128','2013-05-02','16:50:00',2.93),('15128','2013-05-02','16:55:00',2.85),('15128','2013-05-02','17:00:00',2.79),('15128','2013-05-02','17:05:00',2.71),('15128','2013-05-02','17:10:00',2.64),('15128','2013-05-02','17:15:00',2.56),('15128','2013-05-02','17:20:00',2.48),('15128','2013-05-02','17:25:00',2.42),('15128','2013-05-02','17:30:00',2.35),('15128','2013-05-02','17:35:00',2.25),('15128','2013-05-02','17:40:00',2.14),('15128','2013-05-02','17:45:00',2),('15128','2013-05-02','17:50:00',1.92),('15128','2013-05-02','17:55:00',1.86),('15128','2013-05-02','18:00:00',1.77),('15128','2013-05-02','18:05:00',1.64),('15128','2013-05-02','18:10:00',1.56),('15128','2013-05-02','18:15:00',1.5),('15128','2013-05-02','18:20:00',1.44),('15128','2013-05-02','18:25:00',1.38),('15128','2013-05-02','18:30:00',1.31),('15128','2013-05-02','18:35:00',1.23),('15128','2013-05-02','18:40:00',1.11),('15128','2013-05-02','18:45:00',1.02),('15128','2013-05-01','08:50:00',1.4),('15128','2013-05-01','08:55:00',1.13),('15128','2013-05-01','09:00:00',1.17),('15128','2013-05-01','09:30:00',2.51),('15128','2013-05-01','09:35:00',1.76),('15128','2013-05-01','09:40:00',1.16),('15128','2013-05-01','09:45:00',1.1),('15128','2013-05-01','09:50:00',1.88),('15128','2013-05-01','09:55:00',1.44),('15128','2013-05-01','10:15:00',1.35),('15128','2013-05-01','10:20:00',2.17),('15128','2013-05-01','10:25:00',1.62),('15128','2013-05-01','10:30:00',1.63),('15128','2013-05-01','10:35:00',3.23),('15128','2013-05-01','10:40:00',3.5),('15128','2013-05-01','10:45:00',2.83),('15128','2013-05-01','10:50:00',2.64),('15128','2013-05-01','10:55:00',2.5),('15128','2013-05-01','11:00:00',3.38),('15128','2013-05-01','11:05:00',3.24),('15128','2013-05-01','11:10:00',2.15),('15128','2013-05-01','11:15:00',2.81),('15128','2013-05-01','11:20:00',3.07),('15128','2013-05-01','11:25:00',3.26),('15128','2013-05-01','11:30:00',2.82),('15128','2013-05-01','11:35:00',3.73),('15128','2013-05-01','11:40:00',3.69),('15128','2013-05-01','11:45:00',3.52),('15128','2013-05-01','11:50:00',3.54),('15128','2013-05-01','11:55:00',3.57),('15128','2013-05-01','12:00:00',3.63),('15128','2013-05-01','12:05:00',3.68),('15128','2013-05-01','12:10:00',3.67),('15128','2013-05-01','12:15:00',3.7),('15128','2013-05-01','12:20:00',3.74),('15128','2013-05-01','12:25:00',3.73),('15128','2013-05-01','12:30:00',3.77),('15128','2013-05-01','12:35:00',3.8),('15128','2013-05-01','12:40:00',2.99),('15128','2013-05-01','12:45:00',3.27),('15128','2013-05-01','12:50:00',4.03),('15128','2013-05-01','12:55:00',3.9),('15128','2013-05-01','13:00:00',3.91),('15128','2013-05-01','13:05:00',4.05),('15128','2013-05-01','13:10:00',4.04),('15128','2013-05-01','13:15:00',4.04),('15128','2013-05-01','13:20:00',4.03),('15128','2013-05-01','13:25:00',4.03),('15128','2013-05-01','13:30:00',4.05),('15128','2013-05-01','13:35:00',4.03),('15128','2013-05-01','13:40:00',4.01),('15128','2013-05-01','13:45:00',4),('15128','2013-05-01','13:50:00',4.01),('15128','2013-05-01','13:55:00',4.01),('15128','2013-05-01','14:00:00',4),('15128','2013-05-01','14:05:00',4.02),('15128','2013-05-01','14:10:00',3.99),('15128','2013-05-01','14:15:00',4.01),('15128','2013-05-01','14:20:00',4.04),('15128','2013-05-01','14:25:00',4.03),('15128','2013-05-01','14:30:00',3.98),('15128','2013-05-01','14:35:00',3.94),('15128','2013-05-01','14:40:00',3.93),('15128','2013-05-01','14:45:00',3.92),('15128','2013-05-01','14:50:00',3.9),('15128','2013-05-01','14:55:00',3.92),('15128','2013-05-01','15:00:00',3.89),('15128','2013-05-01','15:05:00',3.85),('15128','2013-05-01','15:10:00',3.8),('15128','2013-05-01','15:15:00',3.79),('15128','2013-05-01','15:20:00',3.77),('15128','2013-05-01','15:25:00',3.75),('15128','2013-05-01','15:30:00',3.73),('15128','2013-05-01','15:35:00',3.73),('15128','2013-05-01','15:40:00',3.69),('15128','2013-05-01','15:45:00',3.66),('15128','2013-05-01','15:50:00',3.6),('15128','2013-05-01','15:55:00',3.56),('15128','2013-05-01','16:00:00',3.51),('15128','2013-05-01','16:05:00',3.48),('15128','2013-05-01','16:10:00',3.42),('15128','2013-05-01','16:15:00',3.35),('15128','2013-05-01','16:20:00',3.32),('15128','2013-05-01','16:25:00',3.27),('15128','2013-05-01','16:30:00',3.22),('15128','2013-05-01','16:35:00',3.15),('15128','2013-05-01','16:40:00',3.1),('15128','2013-05-01','16:45:00',3.04),('15128','2013-05-01','16:50:00',2.97),('15128','2013-05-01','16:55:00',2.89),('15128','2013-05-01','17:00:00',2.82),('15128','2013-05-01','17:05:00',2.76),('15128','2013-05-01','17:10:00',2.68),('15128','2013-05-01','17:15:00',2.61),('15128','2013-05-01','17:20:00',2.55),('15128','2013-05-01','17:25:00',2.46),('15128','2013-05-01','17:30:00',2.38),('15128','2013-05-01','17:35:00',2.3),('15128','2013-05-01','17:40:00',2.21),('15128','2013-05-01','17:45:00',2.11),('15128','2013-05-01','17:50:00',2.03),('15128','2013-05-01','17:55:00',1.95),('15128','2013-05-01','18:00:00',1.84),('15128','2013-05-01','18:05:00',1.75),('15128','2013-05-01','18:10:00',1.68),('15128','2013-05-01','18:15:00',1.61),('15128','2013-05-01','18:20:00',1.56),('15128','2013-05-01','18:25:00',1.48),('15128','2013-05-01','18:30:00',1.39),('15128','2013-05-01','18:35:00',1.3),('15128','2013-05-01','18:40:00',1.2),('15128','2013-05-01','18:45:00',1.1),('15128','2014-03-29','09:15:00',1.14),('15128','2014-03-29','09:20:00',1.35),('15128','2014-03-29','09:25:00',1.41),('15128','2014-03-29','09:30:00',1.45),('15128','2014-03-29','09:35:00',1.55),('15128','2014-03-29','09:40:00',1.64),('15128','2014-03-29','09:45:00',1.72),('15128','2014-03-29','09:50:00',1.7),('15128','2014-03-29','09:55:00',1.74),('15128','2014-03-29','10:00:00',1.84),('15128','2014-03-29','10:05:00',1.92),('15128','2014-03-29','10:10:00',2),('15128','2014-03-29','10:15:00',2.1),('15128','2014-03-29','10:20:00',2.18),('15128','2014-03-29','10:25:00',2.23),('15128','2014-03-29','10:30:00',2.28),('15128','2014-03-29','10:35:00',2.3),('15128','2014-03-29','10:40:00',2.31),('15128','2014-03-29','10:45:00',2.36),('15128','2014-03-29','10:50:00',2.38),('15128','2014-03-29','10:55:00',2.47),('15128','2014-03-29','11:00:00',2.49),('15128','2014-03-29','11:05:00',2.52),('15128','2014-03-29','11:10:00',2.68),('15128','2014-03-29','11:15:00',2.7),('15128','2014-03-29','11:20:00',2.64),('15128','2014-03-29','11:25:00',2.63),('15128','2014-03-29','11:30:00',2.67),('15128','2014-03-29','11:35:00',2.83),('15128','2014-03-29','11:40:00',2.96),('15128','2014-03-29','11:45:00',3.04),('15128','2014-03-29','11:50:00',3.2),('15128','2014-03-29','11:55:00',3.2),('15128','2014-03-29','12:00:00',3.35),('15128','2014-03-29','12:05:00',3.38),('15128','2014-03-29','12:10:00',3.39),('15128','2014-03-29','12:15:00',3.5),('15128','2014-03-29','12:20:00',3.57),('15128','2014-03-29','12:25:00',3.65),('15128','2014-03-29','12:30:00',3.51),('15128','2014-03-29','12:35:00',3.67),('15128','2014-03-29','12:40:00',3.78),('15128','2014-03-29','12:45:00',3.83),('15128','2014-03-29','12:50:00',3.86),('15128','2014-03-29','12:55:00',3.85),('15128','2014-03-29','13:00:00',3.85),('15128','2014-03-29','13:05:00',3.87),('15128','2014-03-29','13:10:00',3.81),('15128','2014-03-29','13:15:00',3.79),('15128','2014-03-29','13:20:00',3.84),('15128','2014-03-29','13:25:00',3.95),('15128','2014-03-29','13:30:00',3.99),('15128','2014-03-29','13:35:00',4.03),('15128','2014-03-29','13:40:00',4.02),('15128','2014-03-29','13:45:00',4.04),('15128','2014-03-29','13:50:00',4.04),('15128','2014-03-29','13:55:00',4.08),('15128','2014-03-29','14:00:00',4.08),('15128','2014-03-29','14:05:00',4.05),('15128','2014-03-29','14:10:00',4.11),('15128','2014-03-29','14:15:00',3.62),('15128','2014-03-29','14:20:00',3.38),('15128','2014-03-29','14:25:00',3.08),('15128','2014-03-29','14:30:00',3.08),('15128','2014-03-29','14:35:00',2.87),('15128','2014-03-29','14:40:00',2.01),('15128','2014-03-29','14:45:00',1.99),('15128','2014-03-29','14:50:00',2.03),('15128','2014-03-29','14:55:00',2.1),('15128','2014-03-29','15:00:00',2.47),('15128','2014-03-29','15:05:00',2.94),('15128','2014-03-29','15:10:00',3.09),('15128','2014-03-29','15:15:00',3.12),('15128','2014-03-29','15:20:00',2.89),('15128','2014-03-29','15:25:00',2.95),('15128','2014-03-29','15:30:00',2.96),('15128','2014-03-29','15:35:00',3.05),('15128','2014-03-29','15:40:00',3.03),('15128','2014-03-29','15:45:00',3.09),('15128','2014-03-29','15:50:00',3.13),('15128','2014-03-29','15:55:00',3.18),('15128','2014-03-29','16:00:00',3.3),('15128','2014-03-29','16:05:00',3.28),('15128','2014-03-29','16:10:00',3.32),('15128','2014-03-29','16:15:00',3.34),('15128','2014-03-29','16:20:00',3.18),('15128','2014-03-29','16:25:00',2.89),('15128','2014-03-29','16:30:00',2.8),('15128','2014-03-29','16:35:00',2.75),('15128','2014-03-29','16:40:00',2.73),('15128','2014-03-29','16:45:00',2.89),('15128','2014-03-29','16:50:00',2.88),('15128','2014-03-29','16:55:00',2.76),('15128','2014-03-29','17:00:00',2.64),('15128','2014-03-29','17:05:00',2.47),('15128','2014-03-29','17:10:00',2.32),('15128','2014-03-29','17:15:00',2.26),('15128','2014-03-29','17:20:00',2.19),('15128','2014-03-29','17:25:00',2.09),('15128','2014-03-29','17:30:00',1.99),('15128','2014-03-29','17:35:00',1.89),('15128','2014-03-29','17:40:00',1.82),('15128','2014-03-29','17:45:00',1.79),('15128','2014-03-29','17:50:00',1.65),('15128','2014-03-29','17:55:00',1.6),('15128','2014-03-29','18:00:00',1.55),('15128','2014-03-29','18:05:00',1.17),('15128','2014-03-29','18:10:00',1.3),('15128','2014-03-29','18:15:00',1.15),('15128','2014-03-29','18:20:00',1.14),('15128','2014-03-29','18:25:00',1.06),('15128','2013-04-30','08:20:00',1.01),('15128','2013-04-30','08:25:00',1.07),('15128','2013-04-30','08:30:00',1.14),('15128','2013-04-30','08:35:00',1.2),('15128','2013-04-30','08:40:00',1.26),('15128','2013-04-30','08:45:00',1.33),('15128','2013-04-30','08:50:00',1.38),('15128','2013-04-30','08:55:00',1.47),('15128','2013-04-30','09:00:00',1.55),('15128','2013-04-30','09:05:00',1.61),('15128','2013-04-30','09:10:00',1.67),('15128','2013-04-30','09:15:00',1.72),('15128','2013-04-30','09:20:00',1.8),('15128','2013-04-30','09:25:00',1.83),('15128','2013-04-30','09:30:00',1.87),('15128','2013-04-30','09:35:00',1.92),('15128','2013-04-30','09:40:00',1.97),('15128','2013-04-30','09:45:00',2.02),('15128','2013-04-30','09:50:00',2.09),('15128','2013-04-30','09:55:00',2.14),('15128','2013-04-30','10:00:00',2.22),('15128','2013-04-30','10:05:00',2.28),('15128','2013-04-30','10:10:00',2.37),('15128','2013-04-30','10:15:00',2.44),('15128','2013-04-30','10:20:00',2.5),('15128','2013-04-30','10:25:00',2.53),('15128','2013-04-30','10:30:00',2.62),('15128','2013-04-30','10:35:00',2.69),('15128','2013-04-30','10:40:00',2.79),('15128','2013-04-30','10:45:00',2.86),('15128','2013-04-30','10:50:00',2.92),('15128','2013-04-30','10:55:00',3.02),('15128','2013-04-30','11:00:00',3.02),('15128','2013-04-30','11:05:00',3.07),('15128','2013-04-30','11:10:00',3.21),('15128','2013-04-30','11:15:00',3.28),('15128','2013-04-30','11:20:00',3.25),('15128','2013-04-30','11:25:00',3.43),('15128','2013-04-30','11:30:00',3.3),('15128','2013-04-30','11:35:00',3.37),('15128','2013-04-30','11:40:00',2.83),('15128','2013-04-30','11:45:00',3.52),('15128','2013-04-30','11:50:00',3.71),('15128','2013-04-30','11:55:00',3.74),('15128','2013-04-30','12:00:00',3.73),('15128','2013-04-30','12:05:00',3.74),('15128','2013-04-30','12:10:00',3.76),('15128','2013-04-30','12:15:00',3.77),('15128','2013-04-30','12:20:00',3.81),('15128','2013-04-30','12:25:00',3.83),('15128','2013-04-30','12:30:00',3.89),('15128','2013-04-30','12:35:00',3.98),('15128','2013-04-30','12:40:00',4.12),('15128','2013-04-30','12:45:00',2.79),('15128','2013-04-30','12:50:00',1.7),('15128','2013-04-30','12:55:00',1.49),('15128','2013-04-30','13:00:00',1.54),('15128','2013-04-30','13:05:00',1.62),('15128','2013-04-30','13:10:00',1.94),('15128','2013-04-30','13:15:00',3.25),('15128','2013-04-30','13:20:00',4.6),('15128','2013-04-30','13:25:00',4.93),('15128','2013-04-30','13:30:00',4.64),('15128','2013-04-30','13:35:00',3.82),('15128','2013-04-30','13:40:00',3.24),('15128','2013-04-30','13:45:00',4.44),('15128','2013-04-30','13:50:00',4.4),('15128','2013-04-30','13:55:00',4.21),('15128','2013-04-30','14:00:00',4.18),('15128','2013-04-30','14:05:00',4.3),('15128','2013-04-30','14:10:00',4.03),('15128','2013-04-30','14:15:00',4.28),('15128','2013-04-30','14:20:00',3.95),('15128','2013-04-30','14:25:00',4.36),('15128','2013-04-30','14:30:00',4.23),('15128','2013-04-30','14:35:00',4.3),('15128','2013-04-30','14:40:00',3.68),('15128','2013-04-30','14:45:00',2.98),('15128','2013-04-30','14:50:00',3.27),('15128','2013-04-30','14:55:00',3.25),('15128','2013-04-30','15:00:00',2.86),('15128','2013-04-30','15:05:00',2.84),('15128','2013-04-30','15:10:00',4.01),('15128','2013-04-30','15:15:00',3.39),('15128','2013-04-30','15:20:00',3.12),('15128','2013-04-30','15:25:00',2.97),('15128','2013-04-30','15:30:00',2.63),('15128','2013-04-30','15:35:00',2.51),('15128','2013-04-30','15:40:00',2.38),('15128','2013-04-30','15:45:00',2.2),('15128','2013-04-30','15:50:00',1.92),('15128','2013-04-30','15:55:00',1.92),('15128','2013-04-30','16:00:00',2.14),('15128','2013-04-30','16:05:00',2.35),('15128','2013-04-30','16:10:00',2.14),('15128','2013-04-30','16:15:00',2.08),('15128','2013-04-30','16:20:00',1.96),('15128','2013-04-30','16:25:00',1.55),('15128','2013-04-30','16:30:00',1.27),('15128','2013-04-30','16:35:00',1.24),('15128','2013-04-30','16:40:00',1.29),('15128','2013-04-30','16:45:00',1.22),('15128','2013-04-30','16:50:00',1.09),('15128','2013-04-29','08:40:00',1.03),('15128','2013-04-29','08:45:00',1.02),('15128','2013-04-29','08:50:00',1.32),('15128','2013-04-29','08:55:00',1.73),('15128','2013-04-29','09:00:00',1.81),('15128','2013-04-29','09:05:00',1.57),('15128','2013-04-29','09:10:00',1.55),('15128','2013-04-29','09:15:00',2.07),('15128','2013-04-29','09:20:00',2.29),('15128','2013-04-29','09:25:00',1.73),('15128','2013-04-29','09:30:00',1.86),('15128','2013-04-29','09:35:00',1.99),('15128','2013-04-29','09:40:00',1.83),('15128','2013-04-29','09:45:00',1.94),('15128','2013-04-29','09:50:00',2.15),('15128','2013-04-29','09:55:00',2.52),('15128','2013-04-29','10:00:00',2.8),('15128','2013-04-29','10:05:00',2.54),('15128','2013-04-29','10:10:00',2.66),('15128','2013-04-29','10:15:00',2),('15128','2013-04-29','10:20:00',2.17),('15128','2013-04-29','10:25:00',1.86),('15128','2013-04-29','10:30:00',2.04),('15128','2013-04-29','10:35:00',1.71),('15128','2013-04-29','10:40:00',1.62),('15128','2013-04-29','10:45:00',1.96),('15128','2013-04-29','10:50:00',1.73),('15128','2013-04-29','10:55:00',1.77),('15128','2013-04-29','11:00:00',2.21),('15128','2013-04-29','11:05:00',2.33),('15128','2013-04-29','11:10:00',2.34),('15128','2013-04-29','11:15:00',2.28),('15128','2013-04-29','11:20:00',2.24),('15128','2013-04-29','11:25:00',2.16),('15128','2013-04-29','11:30:00',2.13),('15128','2013-04-29','11:35:00',2.22),('15128','2013-04-29','11:40:00',2.3),('15128','2013-04-29','11:45:00',1.67),('15128','2013-04-29','11:50:00',1.48),('15128','2013-04-29','11:55:00',1.57),('15128','2013-04-29','12:00:00',2.03),('15128','2013-04-29','12:05:00',2.16),('15128','2013-04-29','12:10:00',1.92),('15128','2013-04-29','12:15:00',2.7),('15128','2013-04-29','12:20:00',2.94),('15128','2013-04-29','12:25:00',1.97),('15128','2013-04-29','12:30:00',1.57),('15128','2013-04-29','12:35:00',2.69),('15128','2013-04-29','12:40:00',4.44),('15128','2013-04-29','12:45:00',4.44),('15128','2013-04-29','12:50:00',3.56),('15128','2013-04-29','12:55:00',3.78),('15128','2013-04-29','13:00:00',4.07),('15128','2013-04-29','13:05:00',4.16),('15128','2013-04-29','13:10:00',4.1),('15128','2013-04-29','13:15:00',4.03),('15128','2013-04-29','13:20:00',4.01),('15128','2013-04-29','13:25:00',4.02),('15128','2013-04-29','13:30:00',4),('15128','2013-04-29','13:35:00',3.98),('15128','2013-04-29','13:40:00',3.98),('15128','2013-04-29','13:45:00',3.94),('15128','2013-04-29','13:50:00',3.94),('15128','2013-04-29','13:55:00',3.96),('15128','2013-04-29','14:00:00',3.99),('15128','2013-04-29','14:05:00',3.96),('15128','2013-04-29','14:10:00',3.93),('15128','2013-04-29','14:15:00',3.9),('15128','2013-04-29','14:20:00',3.89),('15128','2013-04-29','14:25:00',3.87),('15128','2013-04-29','14:30:00',3.84),('15128','2013-04-29','14:35:00',3.81),('15128','2013-04-29','14:40:00',3.78),('15128','2013-04-29','14:45:00',3.76),('15128','2013-04-29','14:50:00',3.74),('15128','2013-04-29','14:55:00',3.71),('15128','2013-04-29','15:00:00',3.68),('15128','2013-04-29','15:05:00',3.64),('15128','2013-04-29','15:10:00',3.65),('15128','2013-04-29','15:15:00',3.66),('15128','2013-04-29','15:20:00',3.64),('15128','2013-04-29','15:25:00',3.61),('15128','2013-04-29','15:30:00',3.58),('15128','2013-04-29','15:35:00',3.55),('15128','2013-04-29','15:40:00',3.51),('15128','2013-04-29','15:45:00',3.46),('15128','2013-04-29','15:50:00',3.44),('15128','2013-04-29','15:55:00',3.39),('15128','2013-04-29','16:00:00',3.33),('15128','2013-04-29','16:05:00',3.27),('15128','2013-04-29','16:10:00',3.22),('15128','2013-04-29','16:15:00',3.15),('15128','2013-04-29','16:20:00',3.07),('15128','2013-04-29','16:25:00',3.02),('15128','2013-04-29','16:30:00',2.96),('15128','2013-04-29','16:35:00',2.83),('15128','2013-04-29','16:40:00',2.5),('15128','2013-04-29','16:45:00',1.66),('15128','2013-04-29','16:50:00',1.39),('15128','2013-04-29','16:55:00',1.85),('15128','2013-04-29','17:00:00',2.02),('15128','2013-04-29','17:05:00',1.76),('15128','2013-04-29','17:10:00',1.16),('15128','2013-04-29','17:15:00',1.46),('15128','2013-04-29','17:20:00',1.55),('15128','2013-04-29','17:25:00',1.85),('15128','2013-04-29','17:30:00',1.97),('15128','2013-04-29','17:35:00',1.91),('15128','2013-04-29','17:40:00',1.84),('15128','2013-04-29','17:45:00',1.75),('15128','2013-04-29','17:50:00',1.65),('15128','2013-04-29','17:55:00',1.56),('15128','2013-04-29','18:00:00',1.49),('15128','2013-04-29','18:05:00',1.38),('15128','2013-04-29','18:10:00',1.31),('15128','2013-04-29','18:15:00',1.26),('15128','2013-04-29','18:20:00',1.19),('15128','2013-04-29','18:25:00',1.09),('15128','2013-04-29','18:30:00',1.01),('15128','2013-04-28','08:15:00',1.03),('15128','2013-04-28','08:20:00',1.22),('15128','2013-04-28','08:25:00',1.35),('15128','2013-04-28','08:30:00',1.54),('15128','2013-04-28','08:35:00',1.64),('15128','2013-04-28','08:40:00',1.51),('15128','2013-04-28','08:45:00',1.53),('15128','2013-04-28','08:50:00',1.56),('15128','2013-04-28','08:55:00',1.58),('15128','2013-04-28','09:00:00',1.62),('15128','2013-04-28','09:05:00',1.78),('15128','2013-04-28','09:10:00',1.54),('15128','2013-04-28','09:15:00',1.57),('15128','2013-04-28','09:20:00',1.77),('15128','2013-04-28','09:25:00',1.82),('15128','2013-04-28','09:30:00',1.86),('15128','2013-04-28','09:35:00',1.83),('15128','2013-04-28','09:40:00',1.95),('15128','2013-04-28','09:45:00',2.02),('15128','2013-04-28','09:50:00',1.94),('15128','2013-04-28','09:55:00',2.05),('15128','2013-04-28','10:00:00',2.25),('15128','2013-04-28','10:05:00',2.34),('15128','2013-04-28','10:10:00',2.14),('15128','2013-04-28','10:15:00',2.06),('15128','2013-04-28','10:20:00',2.57),('15128','2013-04-28','10:25:00',2.79),('15128','2013-04-28','10:30:00',2.82),('15128','2013-04-28','10:35:00',2.45),('15128','2013-04-28','10:40:00',2.49),('15128','2013-04-28','10:45:00',2.58),('15128','2013-04-28','10:50:00',2.84),('15128','2013-04-28','10:55:00',2.79),('15128','2013-04-28','11:00:00',2.63),('15128','2013-04-28','11:05:00',2.93),('15128','2013-04-28','11:10:00',3.1),('15128','2013-04-28','11:15:00',3.17),('15128','2013-04-28','11:20:00',3.45),('15128','2013-04-28','11:25:00',3.12),('15128','2013-04-28','11:30:00',3.01),('15128','2013-04-28','11:35:00',3.09),('15128','2013-04-28','11:40:00',3.05),('15128','2013-04-28','11:45:00',3.63),('15128','2013-04-28','11:50:00',3.37),('15128','2013-04-28','11:55:00',3.79),('15128','2013-04-28','12:00:00',3.76),('15128','2013-04-28','12:05:00',3.77),('15128','2013-04-28','12:10:00',3.82),('15128','2013-04-28','12:15:00',3.89),('15128','2013-04-28','12:20:00',3.95),('15128','2013-04-28','12:25:00',3.93),('15128','2013-04-28','12:30:00',3.94),('15128','2013-04-28','12:35:00',3.94),('15128','2013-04-28','12:40:00',3.98),('15128','2013-04-28','12:45:00',3.85),('15128','2013-04-28','12:50:00',3.7),('15128','2013-04-28','12:55:00',3.78),('15128','2013-04-28','13:00:00',3.77),('15128','2013-04-28','13:05:00',3.67),('15128','2013-04-28','13:10:00',3.77),('15128','2013-04-28','13:15:00',3.41),('15128','2013-04-28','13:20:00',4.13),('15128','2013-04-28','13:25:00',4.05),('15128','2013-04-28','13:30:00',4.05),('15128','2013-04-28','13:35:00',4.08),('15128','2013-04-28','13:40:00',4.05),('15128','2013-04-28','13:45:00',3.81),('15128','2013-04-28','13:50:00',3.83),('15128','2013-04-28','13:55:00',3.99),('15128','2013-04-28','14:00:00',3.94),('15128','2013-04-28','14:05:00',3.97),('15128','2013-04-28','14:10:00',4.06),('15128','2013-04-28','14:15:00',4.15),('15128','2013-04-28','14:20:00',4.05),('15128','2013-04-28','14:25:00',3.95),('15128','2013-04-28','14:30:00',3.68),('15128','2013-04-28','14:35:00',3.41),('15128','2013-04-28','14:40:00',3.42),('15128','2013-04-28','14:45:00',3.56),('15128','2013-04-28','14:50:00',3.39),('15128','2013-04-28','14:55:00',3.41),('15128','2013-04-28','15:00:00',3.14),('15128','2013-04-28','15:05:00',2.95),('15128','2013-04-28','15:10:00',3.64),('15128','2013-04-28','15:15:00',3.85),('15128','2013-04-28','15:20:00',3.82),('15128','2013-04-28','15:25:00',3.57),('15128','2013-04-28','15:30:00',3.19),('15128','2013-04-28','15:35:00',3.1),('15128','2013-04-28','15:40:00',3.04),('15128','2013-04-28','15:45:00',2.88),('15128','2013-04-28','15:50:00',2.94),('15128','2013-04-28','15:55:00',3.21),('15128','2013-04-28','16:00:00',3.19),('15128','2013-04-28','16:05:00',3.54),('15128','2013-04-28','16:10:00',3.5),('15128','2013-04-28','16:15:00',3.46),('15128','2013-04-28','16:20:00',2.82),('15128','2013-04-28','16:25:00',3.02),('15128','2013-04-28','16:30:00',2.96),('15128','2013-04-28','16:35:00',3.27),('15128','2013-04-28','16:40:00',3.16),('15128','2013-04-28','16:45:00',3.27),('15128','2013-04-28','16:50:00',3.31),('15128','2013-04-28','16:55:00',3.27),('15128','2013-04-28','17:00:00',3.12),('15128','2013-04-28','17:05:00',3.02),('15128','2013-04-28','17:10:00',2.69),('15128','2013-04-28','17:15:00',2.39),('15128','2013-04-28','17:20:00',2.44),('15128','2013-04-28','17:25:00',2.29),('15128','2013-04-28','17:30:00',2.21),('15128','2013-04-28','17:35:00',2.32),('15128','2013-04-28','17:40:00',1.68),('15128','2013-04-28','17:45:00',1.43),('15128','2013-04-28','17:50:00',1.77),('15128','2013-04-28','17:55:00',2.1),('15128','2013-04-28','18:00:00',1.91),('15128','2013-04-28','18:05:00',2.25),('15128','2013-04-28','18:10:00',1.97),('15128','2013-04-28','18:15:00',1.9),('15128','2013-04-28','18:20:00',1.84),('15128','2013-04-28','18:25:00',1.78),('15128','2013-04-28','18:30:00',1.44),('15128','2013-04-28','18:35:00',1.29),('15128','2013-04-28','18:40:00',1.03),('15128','2013-04-27','08:20:00',1.06),('15128','2013-04-27','08:25:00',1.16),('15128','2013-04-27','08:30:00',1.21),('15128','2013-04-27','08:35:00',1.26),('15128','2013-04-27','08:40:00',1.29),('15128','2013-04-27','08:45:00',1.41),('15128','2013-04-27','08:50:00',1.5),('15128','2013-04-27','08:55:00',1.58),('15128','2013-04-27','09:00:00',1.66),('15128','2013-04-27','09:05:00',1.72),('15128','2013-04-27','09:10:00',1.79),('15128','2013-04-27','09:15:00',1.82),('15128','2013-04-27','09:20:00',1.86),('15128','2013-04-27','09:25:00',2.02),('15128','2013-04-27','09:30:00',2.12),('15128','2013-04-27','09:35:00',2.16),('15128','2013-04-27','09:40:00',2.1),('15128','2013-04-27','09:45:00',2.13),('15128','2013-04-27','09:50:00',2.22),('15128','2013-04-27','09:55:00',2.34),('15128','2013-04-27','10:00:00',2.35),('15128','2013-04-27','10:05:00',2.41),('15128','2013-04-27','10:10:00',2.43),('15128','2013-04-27','10:15:00',2.5),('15128','2013-04-27','10:20:00',2.59),('15128','2013-04-27','10:25:00',2.68),('15128','2013-04-27','10:30:00',2.59),('15128','2013-04-27','10:35:00',2.66),('15128','2013-04-27','10:40:00',2.65),('15128','2013-04-27','10:45:00',2.78),('15128','2013-04-27','10:50:00',2.88),('15128','2013-04-27','10:55:00',3.03),('15128','2013-04-27','11:00:00',3.14),('15128','2013-04-27','11:05:00',3.06),('15128','2013-04-27','11:10:00',3.19),('15128','2013-04-27','11:15:00',3.33),('15128','2013-04-27','11:20:00',3.33),('15128','2013-04-27','11:25:00',3.41),('15128','2013-04-27','11:30:00',3.48),('15128','2013-04-27','11:35:00',3.46),('15128','2013-04-27','11:40:00',3.51),('15128','2013-04-27','11:45:00',3.49),('15128','2013-04-27','11:50:00',3.59),('15128','2013-04-27','11:55:00',3.25),('15128','2013-04-27','12:00:00',3.15),('15128','2013-04-27','12:05:00',3.23),('15128','2013-04-27','12:10:00',3.67),('15128','2013-04-27','12:15:00',3.49),('15128','2013-04-27','12:20:00',3.66),('15128','2013-04-27','12:25:00',3.89),('15128','2013-04-27','12:30:00',3.63),('15128','2013-04-27','12:35:00',3.58),('15128','2013-04-27','12:40:00',2.84),('15128','2013-04-27','12:45:00',3),('15128','2013-04-27','12:50:00',4.14),('15128','2013-04-27','12:55:00',4.01),('15128','2013-04-27','13:00:00',4.09),('15128','2013-04-27','13:05:00',4.25),('15128','2013-04-27','13:10:00',4.11),('15128','2013-04-27','13:15:00',3.86),('15128','2013-04-27','13:20:00',4.23),('15128','2013-04-27','13:25:00',3.88),('15128','2013-04-27','13:30:00',3.96),('15128','2013-04-27','13:35:00',4.2),('15128','2013-04-27','13:40:00',4.37),('15128','2013-04-27','13:45:00',3.96),('15128','2013-04-27','13:50:00',4.22),('15128','2013-04-27','13:55:00',4.21),('15128','2013-04-27','14:00:00',4.24),('15128','2013-04-27','14:05:00',3.97),('15128','2013-04-27','14:10:00',4.02),('15128','2013-04-27','14:15:00',4.33),('15128','2013-04-27','14:20:00',3.65),('15128','2013-04-27','14:25:00',3.96),('15128','2013-04-27','14:30:00',4.09),('15128','2013-04-27','14:35:00',4.26),('15128','2013-04-27','14:40:00',4.15),('15128','2013-04-27','14:45:00',3.31),('15128','2013-04-27','14:50:00',4.11),('15128','2013-04-27','14:55:00',3.77),('15128','2013-04-27','15:00:00',2.34),('15128','2013-04-27','15:05:00',3.83),('15128','2013-04-27','15:10:00',3.23),('15128','2013-04-27','15:15:00',3.32),('15128','2013-04-27','15:20:00',3.78),('15128','2013-04-27','15:25:00',3.59),('15128','2013-04-27','15:30:00',3.85),('15128','2013-04-27','15:35:00',3.8),('15128','2013-04-27','15:40:00',3.75),('15128','2013-04-27','15:45:00',3.71),('15128','2013-04-27','15:50:00',3.64),('15128','2013-04-27','15:55:00',3.56),('15128','2013-04-27','16:00:00',3.53),('15128','2013-04-27','16:05:00',3.48),('15128','2013-04-27','16:10:00',3.45),('15128','2013-04-27','16:15:00',3.41),('15128','2013-04-27','16:20:00',3.34),('15128','2013-04-27','16:25:00',3.3),('15128','2013-04-27','16:30:00',3.25),('15128','2013-04-27','16:35:00',3.21),('15128','2013-04-27','16:40:00',3.15),('15128','2013-04-27','16:45:00',3.04),('15128','2013-04-27','16:50:00',2.97),('15128','2013-04-27','16:55:00',2.93),('15128','2013-04-27','17:00:00',2.73),('15128','2013-04-27','17:05:00',2.66),('15128','2013-04-27','17:10:00',2.65),('15128','2013-04-27','17:15:00',2.55),('15128','2013-04-27','17:20:00',2.63),('15128','2013-04-27','17:25:00',2.56),('15128','2013-04-27','17:30:00',2.17),('15128','2013-04-27','17:35:00',2.13),('15128','2013-04-27','17:40:00',2.12),('15128','2013-04-27','17:45:00',2.05),('15128','2013-04-27','17:50:00',1.91),('15128','2013-04-27','17:55:00',1.7),('15128','2013-04-27','18:00:00',1.65),('15128','2013-04-27','18:05:00',1.64),('15128','2013-04-27','18:15:00',1.56),('15128','2013-04-27','18:20:00',1.54),('15128','2013-04-27','18:25:00',1.41),('15128','2013-04-27','18:30:00',1.02),('15128','2013-04-27','18:35:00',1.05),('15128','2013-04-27','18:40:00',1.06),('15128','2013-04-26','12:40:00',1.03),('15128','2013-04-26','12:45:00',1.1),('15128','2013-04-26','12:50:00',1.26),('15128','2013-04-26','12:55:00',1.43),('15128','2013-04-26','13:00:00',1.39),('15128','2013-04-26','13:05:00',1.27),('15128','2013-04-26','13:10:00',1.29),('15128','2013-04-26','13:15:00',1.9),('15128','2013-04-26','13:20:00',2.48),('15128','2013-04-26','13:25:00',1.63),('15128','2013-04-26','13:30:00',1.08),('15128','2013-04-26','14:30:00',1.21),('15128','2013-04-26','14:35:00',1.15),('15128','2013-04-26','14:40:00',1.58),('15128','2013-04-26','14:45:00',1.01),('15128','2013-04-26','16:55:00',1.14),('15128','2013-04-26','17:00:00',2.3),('15128','2013-04-26','17:05:00',1.32),('15128','2013-04-26','17:10:00',1.88),('15128','2013-04-26','17:15:00',1.3),('15128','2013-04-26','17:20:00',1.2),('15128','2013-04-26','17:40:00',2.59),('15128','2013-04-26','17:45:00',1.95),('15128','2013-04-25','08:25:00',1.02),('15128','2013-04-25','08:30:00',1.08),('15128','2013-04-25','08:35:00',1.14),('15128','2013-04-25','08:40:00',1.15),('15128','2013-04-25','08:45:00',1.31),('15128','2013-04-25','08:50:00',1.46),('15128','2013-04-25','08:55:00',1.72),('15128','2013-04-25','09:00:00',1.72),('15128','2013-04-25','09:05:00',1.79),('15128','2013-04-25','09:10:00',1.54),('15128','2013-04-25','09:15:00',1.26),('15128','2013-04-25','09:20:00',1.31),('15128','2013-04-25','09:25:00',1.28),('15128','2013-04-25','09:30:00',1.72),('15128','2013-04-25','09:35:00',1.89),('15128','2013-04-25','09:40:00',2.03),('15128','2013-04-25','09:45:00',1.91),('15128','2013-04-25','09:50:00',1.3),('15128','2013-04-25','09:55:00',1.76),('15128','2013-04-25','10:00:00',1.42),('15128','2013-04-25','10:05:00',1.91),('15128','2013-04-25','10:10:00',2.48),('15128','2013-04-25','10:15:00',2.49),('15128','2013-04-25','10:20:00',2.63),('15128','2013-04-25','10:25:00',2.55),('15128','2013-04-25','10:30:00',2.81),('15128','2013-04-25','10:35:00',2.73),('15128','2013-04-25','10:40:00',2.81),('15128','2013-04-25','10:45:00',2.75),('15128','2013-04-25','10:50:00',2.53),('15128','2013-04-25','10:55:00',3.17),('15128','2013-04-25','11:00:00',3.16),('15128','2013-04-25','11:05:00',3.17),('15128','2013-04-25','11:10:00',3.22),('15128','2013-04-25','11:15:00',3.26),('15128','2013-04-25','11:20:00',3.35),('15128','2013-04-25','11:25:00',3.06),('15128','2013-04-25','11:30:00',2.64),('15128','2013-04-25','11:35:00',3.19),('15128','2013-04-25','11:40:00',2.46),('15128','2013-04-25','11:45:00',2.68),('15128','2013-04-25','11:50:00',3.16),('15128','2013-04-25','11:55:00',2.94),('15128','2013-04-25','12:00:00',3.23),('15128','2013-04-25','12:05:00',2.47),('15128','2013-04-25','12:10:00',2.52),('15128','2013-04-25','12:15:00',2.69),('15128','2013-04-25','12:20:00',3.25),('15128','2013-04-25','12:25:00',2.84),('15128','2013-04-25','12:30:00',2.3),('15128','2013-04-25','12:35:00',2.67),('15128','2013-04-25','12:40:00',2.91),('15128','2013-04-25','12:45:00',2.81),('15128','2013-04-25','12:50:00',2.91),('15128','2013-04-25','12:55:00',1.63),('15128','2013-04-25','13:00:00',1.33),('15128','2013-04-25','13:05:00',1.4),('15128','2013-04-25','13:10:00',1.66),('15128','2013-04-25','13:15:00',3.76),('15128','2013-04-25','13:20:00',3.25),('15128','2013-04-25','13:25:00',3.84),('15128','2013-04-25','13:30:00',3.37),('15128','2013-04-25','13:35:00',2.77),('15128','2013-04-25','13:40:00',2.37),('15128','2013-04-25','13:45:00',2.64),('15128','2013-04-25','13:50:00',3.64),('15128','2013-04-25','13:55:00',2.94),('15128','2013-04-25','14:00:00',3.03),('15128','2013-04-25','14:05:00',2.99),('15128','2013-04-25','14:10:00',2.8),('15128','2013-04-25','14:15:00',3.16),('15128','2013-04-25','14:20:00',2.75),('15128','2013-04-25','14:25:00',3.65),('15128','2013-04-25','14:30:00',3.12),('15128','2013-04-25','14:35:00',2.23),('15128','2013-04-25','14:40:00',1.97),('15128','2013-04-25','14:45:00',1.94),('15128','2013-04-25','14:50:00',1.49),('15128','2013-04-25','14:55:00',1.47),('15128','2013-04-25','15:00:00',2.66),('15128','2013-04-25','15:05:00',3.26),('15128','2013-04-25','15:10:00',2.88),('15128','2013-04-25','15:15:00',4.37),('15128','2013-04-25','15:20:00',2.02),('15128','2013-04-25','15:25:00',1.84),('15128','2013-04-25','15:30:00',3.37),('15128','2013-04-25','15:35:00',4.36),('15128','2013-04-25','15:40:00',2.72),('15128','2013-04-25','15:45:00',2.93),('15128','2013-04-25','15:50:00',2.45),('15128','2013-04-25','15:55:00',1.08),('15128','2013-04-24','08:35:00',1.13),('15128','2013-04-24','08:40:00',1.31),('15128','2013-04-24','08:45:00',1.48),('15128','2013-04-24','08:50:00',1.23),('15128','2013-04-24','08:55:00',1.11),('15128','2013-04-24','09:00:00',1.14),('15128','2013-04-24','09:05:00',1.16),('15128','2013-04-24','09:10:00',1.17),('15128','2013-04-24','09:15:00',1.25),('15128','2013-04-24','09:20:00',1.33),('15128','2013-04-24','09:25:00',1.29),('15128','2013-04-24','09:30:00',1.72),('15128','2013-04-24','09:35:00',1.83),('15128','2013-04-24','09:40:00',2.02),('15128','2013-04-24','09:45:00',2.13),('15128','2013-04-24','09:50:00',2.14),('15128','2013-04-24','09:55:00',2.09),('15128','2013-04-24','10:00:00',1.94),('15128','2013-04-24','10:05:00',2.08),('15128','2013-04-24','10:10:00',2.37),('15128','2013-04-24','10:15:00',2.43),('15128','2013-04-24','10:20:00',2.58),('15128','2013-04-24','10:25:00',2.72),('15128','2013-04-24','10:30:00',2.71),('15128','2013-04-24','10:35:00',2.75),('15128','2013-04-24','10:40:00',2.78),('15128','2013-04-24','10:45:00',2.83),('15128','2013-04-24','10:50:00',2.85),('15128','2013-04-24','10:55:00',2.88),('15128','2013-04-24','11:00:00',2.94),('15128','2013-04-24','11:05:00',3.04),('15128','2013-04-24','11:10:00',3.1),('15128','2013-04-24','11:15:00',3.14),('15128','2013-04-24','11:20:00',3.21),('15128','2013-04-24','11:25:00',3.24),('15128','2013-04-24','11:30:00',3.34),('15128','2013-04-24','11:35:00',3.42),('15128','2013-04-24','11:40:00',3.49),('15128','2013-04-24','11:45:00',3.58),('15128','2013-04-24','11:50:00',3.74),('15128','2013-04-24','11:55:00',3.79),('15128','2013-04-24','12:00:00',3.74),('15128','2013-04-24','12:05:00',3.77),('15128','2013-04-24','12:10:00',3.82),('15128','2013-04-24','12:15:00',3.9),('15128','2013-04-24','12:20:00',3.9),('15128','2013-04-24','12:25:00',3.89),('15128','2013-04-24','12:30:00',3.91),('15128','2013-04-24','12:35:00',3.98),('15128','2013-04-24','12:40:00',3.99),('15128','2013-04-24','12:45:00',4.04),('15128','2013-04-24','12:50:00',4.09),('15128','2013-04-24','12:55:00',4.12),('15128','2013-04-24','13:00:00',4.2),('15128','2013-04-24','13:05:00',4.29),('15128','2013-04-24','13:10:00',4.3),('15128','2013-04-24','13:15:00',4.25),('15128','2013-04-24','13:20:00',4.13),('15128','2013-04-24','13:25:00',3.51),('15128','2013-04-24','13:30:00',2.72),('15128','2013-04-24','13:35:00',2.32),('15128','2013-04-24','13:40:00',2.22),('15128','2013-04-24','13:45:00',2.13),('15128','2013-04-24','13:50:00',2.02),('15128','2013-04-24','13:55:00',2.14),('15128','2013-04-24','14:00:00',2.12),('15128','2013-04-24','14:05:00',2.32),('15128','2013-04-24','14:10:00',2.42),('15128','2013-04-24','14:15:00',2.59),('15128','2013-04-24','14:20:00',3.14),('15128','2013-04-24','14:25:00',3.8),('15128','2013-04-24','14:30:00',4.09),('15128','2013-04-24','14:35:00',4.06),('15128','2013-04-24','14:40:00',3.86),('15128','2013-04-24','14:45:00',3.9),('15128','2013-04-24','14:50:00',3.67),('15128','2013-04-24','14:55:00',3.1),('15128','2013-04-24','15:00:00',3.54),('15128','2013-04-24','15:05:00',3.36),('15128','2013-04-24','15:10:00',3.15),('15128','2013-04-24','15:15:00',2.69),('15128','2013-04-24','15:20:00',3.32),('15128','2013-04-24','15:25:00',3.63),('15128','2013-04-24','15:30:00',3.4),('15128','2013-04-24','15:35:00',3.02),('15128','2013-04-24','15:40:00',2.71),('15128','2013-04-24','15:45:00',2.89),('15128','2013-04-24','15:50:00',2.36),('15128','2013-04-24','15:55:00',2.55),('15128','2013-04-24','16:00:00',2.65),('15128','2013-04-24','16:05:00',2.66),('15128','2013-04-24','16:10:00',2.92),('15128','2013-04-24','16:15:00',3.3),('15128','2013-04-24','16:20:00',2.92),('15128','2013-04-24','16:25:00',2.53),('15128','2013-04-24','16:30:00',2.61),('15128','2013-04-24','16:35:00',1.81),('15128','2013-04-24','16:40:00',1.99),('15128','2013-04-24','16:45:00',2.27),('15128','2013-04-24','16:50:00',2.13),('15128','2013-04-24','16:55:00',2.34),('15128','2013-04-24','17:00:00',1.98),('15128','2013-04-24','17:05:00',2.53),('15128','2013-04-24','17:10:00',2.18),('15128','2013-04-24','17:15:00',2.25),('15128','2013-04-24','17:20:00',2.33),('15128','2013-04-24','17:25:00',1.95),('15128','2013-04-24','17:30:00',1.85),('15128','2013-04-24','17:35:00',1.6),('15128','2013-04-24','17:40:00',1.53),('15128','2013-04-24','17:45:00',1.53),('15128','2013-04-24','17:50:00',1.59),('15128','2013-04-24','17:55:00',1.24),('15128','2013-04-24','18:00:00',1.21),('15128','2013-04-24','18:05:00',1.37),('15128','2013-04-24','18:10:00',1.04),('15128','2013-04-23','08:20:00',1.02),('15128','2013-04-23','08:25:00',1.09),('15128','2013-04-23','08:30:00',1.08),('15128','2013-04-23','08:35:00',1.06),('15128','2013-04-23','08:40:00',1.09),('15128','2013-04-23','08:45:00',1.17),('15128','2013-04-23','08:50:00',1.27),('15128','2013-04-23','08:55:00',1.37),('15128','2013-04-23','09:00:00',1.48),('15128','2013-04-23','09:05:00',1.62),('15128','2013-04-23','09:10:00',1.85),('15128','2013-04-23','09:15:00',1.83),('15128','2013-04-23','09:20:00',1.52),('15128','2013-04-23','09:25:00',1.51),('15128','2013-04-23','09:30:00',1.6),('15128','2013-04-23','09:35:00',1.7),('15128','2013-04-23','09:40:00',1.74),('15128','2013-04-23','09:45:00',1.86),('15128','2013-04-23','09:50:00',2.06),('15128','2013-04-23','09:55:00',2.15),('15128','2013-04-23','10:00:00',2.45),('15128','2013-04-23','10:05:00',2.55),('15128','2013-04-23','10:10:00',2.52),('15128','2013-04-23','10:15:00',2.48),('15128','2013-04-23','10:20:00',2.56),('15128','2013-04-23','10:25:00',2.66),('15128','2013-04-23','10:30:00',2.75),('15128','2013-04-23','10:35:00',2.67),('15128','2013-04-23','10:40:00',2.56),('15128','2013-04-23','10:45:00',2.68),('15128','2013-04-23','10:50:00',2.9),('15128','2013-04-23','10:55:00',2.98),('15128','2013-04-23','11:00:00',2.98),('15128','2013-04-23','11:05:00',3.02),('15128','2013-04-23','11:10:00',3.3),('15128','2013-04-23','11:15:00',3.4),('15128','2013-04-23','11:20:00',3.48),('15128','2013-04-23','11:25:00',3.52),('15128','2013-04-23','11:30:00',3.2),('15128','2013-04-23','11:35:00',3),('15128','2013-04-23','11:40:00',3.31),('15128','2013-04-23','11:45:00',4.09),('15128','2013-04-23','11:50:00',3.59),('15128','2013-04-23','11:55:00',2.9),('15128','2013-04-23','12:00:00',2.48),('15128','2013-04-23','12:05:00',3.12),('15128','2013-04-23','12:10:00',2.72),('15128','2013-04-23','12:15:00',2.88),('15128','2013-04-23','12:20:00',4.41),('15128','2013-04-23','12:25:00',2.81),('15128','2013-04-23','12:30:00',3.25),('15128','2013-04-23','12:35:00',2.78),('15128','2013-04-23','12:40:00',3.44),('15128','2013-04-23','12:45:00',3.23),('15128','2013-04-23','12:50:00',3.86),('15128','2013-04-23','12:55:00',4.17),('15128','2013-04-23','13:00:00',4.03),('15128','2013-04-23','13:05:00',4.43),('15128','2013-04-23','13:10:00',4.55),('15128','2013-04-23','13:15:00',4.15),('15128','2013-04-23','13:20:00',3.79),('15128','2013-04-23','13:25:00',4.32),('15128','2013-04-23','13:30:00',3.52),('15128','2013-04-23','13:35:00',3.74),('15128','2013-04-23','13:40:00',3.29),('15128','2013-04-23','13:45:00',2.75),('15128','2013-04-23','13:50:00',2.78),('15128','2013-04-23','13:55:00',3.54),('15128','2013-04-23','14:00:00',3.33),('15128','2013-04-23','14:05:00',3.09),('15128','2013-04-23','14:10:00',3.05),('15128','2013-04-23','14:15:00',2.67),('15128','2013-04-23','14:20:00',2.97),('15128','2013-04-23','14:25:00',3.13),('15128','2013-04-23','14:30:00',2.77),('15128','2013-04-23','14:35:00',3.17),('15128','2013-04-23','14:40:00',3.59),('15128','2013-04-23','14:45:00',2.64),('15128','2013-04-23','14:50:00',2.41),('15128','2013-04-23','14:55:00',2.5),('15128','2013-04-23','15:00:00',2.52),('15128','2013-04-23','15:05:00',2.35),('15128','2013-04-23','15:10:00',2.41),('15128','2013-04-23','15:15:00',2.25),('15128','2013-04-23','15:20:00',2.22),('15128','2013-04-23','15:25:00',2.2),('15128','2013-04-23','15:30:00',2.03),('15128','2013-04-23','15:35:00',2.07),('15128','2013-04-23','15:40:00',2.25),('15128','2013-04-23','15:45:00',1.96),('15128','2013-04-23','15:50:00',1.95),('15128','2013-04-23','15:55:00',2.2),('15128','2013-04-23','16:00:00',2.26),('15128','2013-04-23','16:05:00',2.18),('15128','2013-04-23','16:10:00',2.28),('15128','2013-04-23','16:15:00',2.99),('15128','2013-04-23','16:20:00',3.02),('15128','2013-04-23','16:25:00',2.31),('15128','2013-04-23','16:30:00',2.35),('15128','2013-04-23','16:35:00',2.26),('15128','2013-04-23','16:40:00',2.46),('15128','2013-04-23','16:45:00',2.71),('15128','2013-04-23','16:50:00',2.9),('15128','2013-04-23','16:55:00',2.93),('15128','2013-04-23','17:00:00',2.98),('15128','2013-04-23','17:05:00',3.03),('15128','2013-04-23','17:10:00',2.67),('15128','2013-04-23','17:15:00',2.62),('15128','2013-04-23','17:20:00',2.22),('15128','2013-04-23','17:25:00',1.14),('15128','2013-04-23','17:30:00',1.21),('15128','2013-04-23','17:35:00',1.35),('15128','2013-04-23','17:40:00',1.87),('15128','2013-04-23','17:45:00',1.82),('15128','2013-04-23','17:50:00',1.86),('15128','2013-04-23','17:55:00',1.42),('15128','2013-04-23','18:00:00',1.71),('15128','2013-04-23','18:05:00',1.31),('15128','2013-04-23','18:20:00',1.25),('15128','2013-04-23','18:25:00',1.3),('15128','2013-04-22','08:25:00',1.06),('15128','2013-04-22','08:30:00',1.16),('15128','2013-04-22','08:35:00',1.22),('15128','2013-04-22','08:40:00',1.28),('15128','2013-04-22','08:45:00',1.36),('15128','2013-04-22','08:50:00',1.47),('15128','2013-04-22','08:55:00',1.57),('15128','2013-04-22','09:00:00',1.65),('15128','2013-04-22','09:05:00',1.69),('15128','2013-04-22','09:10:00',1.74),('15128','2013-04-22','09:15:00',1.78),('15128','2013-04-22','09:20:00',1.84),('15128','2013-04-22','09:25:00',2),('15128','2013-04-22','09:30:00',2.08),('15128','2013-04-22','09:35:00',2.16),('15128','2013-04-22','09:40:00',2.15),('15128','2013-04-22','09:45:00',2.08),('15128','2013-04-22','09:50:00',2.14),('15128','2013-04-22','09:55:00',2.25),('15128','2013-04-22','10:00:00',2.36),('15128','2013-04-22','10:05:00',2.4),('15128','2013-04-22','10:10:00',2.43),('15128','2013-04-22','10:15:00',2.5),('15128','2013-04-22','10:20:00',2.57),('15128','2013-04-22','10:25:00',2.66),('15128','2013-04-22','10:30:00',2.74),('15128','2013-04-22','10:35:00',2.78),('15128','2013-04-22','10:40:00',2.9),('15128','2013-04-22','10:45:00',2.92),('15128','2013-04-22','10:50:00',3.06),('15128','2013-04-22','10:55:00',3.13),('15128','2013-04-22','11:00:00',3.13),('15128','2013-04-22','11:05:00',3.15),('15128','2013-04-22','11:10:00',3.24),('15128','2013-04-22','11:15:00',3.25),('15128','2013-04-22','11:20:00',3.3),('15128','2013-04-22','11:25:00',3.36),('15128','2013-04-22','11:30:00',3.23),('15128','2013-04-22','11:35:00',3.38),('15128','2013-04-22','11:40:00',3.42),('15128','2013-04-22','11:45:00',3.65),('15128','2013-04-22','11:50:00',3.76),('15128','2013-04-22','11:55:00',3.86),('15128','2013-04-22','12:00:00',3.95),('15128','2013-04-22','12:05:00',3.99),('15128','2013-04-22','12:10:00',4.02),('15128','2013-04-22','12:15:00',4.06),('15128','2013-04-22','12:20:00',4.06),('15128','2013-04-22','12:25:00',4.08),('15128','2013-04-22','12:30:00',4.11),('15128','2013-04-22','12:35:00',4.18),('15128','2013-04-22','12:40:00',4.29),('15128','2013-04-22','12:45:00',4.18),('15128','2013-04-22','12:50:00',3.81),('15128','2013-04-22','12:55:00',4.33),('15128','2013-04-22','13:00:00',4.43),('15128','2013-04-22','13:05:00',4.41),('15128','2013-04-22','13:10:00',4.5),('15128','2013-04-22','13:15:00',4.4),('15128','2013-04-22','13:20:00',4.6),('15128','2013-04-22','13:25:00',4.47),('15128','2013-04-22','13:30:00',4),('15128','2013-04-22','13:35:00',4.18),('15128','2013-04-22','13:40:00',4.22),('15128','2013-04-22','13:45:00',4.34),('15128','2013-04-22','13:50:00',3.83),('15128','2013-04-22','13:55:00',4.34),('15128','2013-04-22','14:00:00',4.61),('15128','2013-04-22','14:05:00',4.63),('15128','2013-04-22','14:10:00',2.71),('15128','2013-04-22','14:15:00',3.21),('15128','2013-04-22','14:20:00',3.56),('15128','2013-04-22','14:25:00',2.57),('15128','2013-04-22','14:30:00',3.53),('15128','2013-04-22','14:35:00',3.64),('15128','2013-04-22','14:40:00',2.87),('15128','2013-04-22','14:45:00',2.25),('15128','2013-04-22','14:50:00',2.75),('15128','2013-04-22','14:55:00',1.71),('15128','2013-04-22','15:00:00',1.45),('15128','2013-04-22','15:05:00',1.59),('15128','2013-04-22','15:10:00',2.69),('15128','2013-04-22','15:15:00',3.52),('15128','2013-04-22','15:20:00',3.29),('15128','2013-04-22','15:25:00',2.51),('15128','2013-04-22','15:30:00',2.17),('15128','2013-04-22','15:35:00',2.59),('15128','2013-04-22','15:40:00',3.19),('15128','2013-04-22','15:45:00',2.53),('15128','2013-04-22','15:50:00',2.33),('15128','2013-04-22','15:55:00',2.51),('15128','2013-04-22','16:00:00',3.01),('15128','2013-04-22','16:05:00',2.67),('15128','2013-04-22','16:10:00',2.64),('15128','2013-04-22','16:15:00',2.85),('15128','2013-04-22','16:20:00',2.01),('15128','2013-04-22','16:25:00',1.7),('15128','2013-04-22','16:30:00',1.46),('15128','2013-04-22','16:35:00',1.29),('15128','2013-04-22','16:40:00',1.33),('15128','2013-04-22','16:45:00',1.26),('15128','2013-04-22','16:50:00',1.72),('15128','2013-04-22','16:55:00',1.89),('15128','2013-04-22','17:00:00',1.9),('15128','2013-04-22','17:05:00',2.36),('15128','2013-04-22','17:10:00',2.47),('15128','2013-04-22','17:15:00',2.7),('15128','2013-04-22','17:20:00',2.61),('15128','2013-04-22','17:25:00',2.29),('15128','2013-04-22','17:30:00',2.31),('15128','2013-04-22','17:35:00',2.1),('15128','2013-04-22','17:40:00',2.35),('15128','2013-04-22','17:45:00',2.19),('15128','2013-04-22','17:50:00',1.88),('15128','2013-04-22','17:55:00',1.95),('15128','2013-04-22','18:00:00',1.87),('15128','2013-04-22','18:05:00',1.51),('15128','2013-04-22','18:10:00',1.12),('15128','2013-04-22','18:15:00',1.25),('15128','2013-04-22','18:20:00',1.45),('15128','2013-04-22','18:25:00',1.06),('15128','2013-04-22','18:30:00',1.18),('15128','2013-04-22','18:35:00',1.16),('15128','2013-04-21','08:45:00',1.17),('15128','2013-04-21','09:20:00',1.14),('15128','2013-04-21','09:30:00',1.02),('15128','2013-04-21','10:35:00',1.38),('15128','2013-04-21','10:40:00',2.66),('15128','2013-04-21','10:45:00',2.57),('15128','2013-04-21','10:50:00',2.97),('15128','2013-04-21','10:55:00',1.22),('15128','2013-04-21','11:05:00',1.15),('15128','2013-04-21','11:10:00',1.27),('15128','2013-04-21','11:25:00',1.74),('15128','2013-04-21','11:30:00',1.51),('15128','2013-04-21','11:35:00',1.05),('15128','2013-04-21','11:45:00',1.14),('15128','2013-04-21','11:50:00',4.31),('15128','2013-04-21','11:55:00',4.17),('15128','2013-04-21','12:00:00',4.29),('15128','2013-04-21','12:05:00',4.37),('15128','2013-04-21','12:10:00',4.46),('15128','2013-04-21','12:15:00',4.27),('15128','2013-04-21','12:20:00',4.32),('15128','2013-04-21','12:25:00',4.42),('15128','2013-04-21','12:30:00',4.5),('15128','2013-04-21','12:35:00',4.49),('15128','2013-04-21','12:40:00',4.57),('15128','2013-04-21','12:45:00',4.19),('15128','2013-04-21','12:50:00',3.81),('15128','2013-04-21','12:55:00',4.61),('15128','2013-04-21','13:00:00',4.78),('15128','2013-04-21','13:05:00',4.68),('15128','2013-04-21','13:10:00',2.41),('15128','2013-04-21','13:15:00',4.98),('15128','2013-04-21','13:20:00',3.82),('15128','2013-04-21','13:25:00',3.1),('15128','2013-04-21','13:30:00',1.43),('15128','2013-04-21','13:35:00',1.63),('15128','2013-04-21','13:40:00',1.24),('15128','2013-04-21','14:05:00',1.23),('15128','2013-04-21','14:10:00',1.48),('15128','2013-04-21','14:15:00',1.34),('15128','2013-04-21','14:20:00',1.96),('15128','2013-04-21','14:25:00',4.11),('15128','2013-04-21','14:30:00',1.11),('15128','2013-04-21','14:35:00',1.48),('15128','2013-04-21','14:40:00',3.15),('15128','2013-04-21','14:45:00',2.11),('15128','2013-04-21','14:50:00',2.4),('15128','2013-04-21','14:55:00',1.94),('15128','2013-04-21','15:00:00',1.93),('15128','2013-04-21','15:05:00',1.37),('15128','2013-04-21','15:10:00',1.49),('15128','2013-04-21','15:15:00',2.83),('15128','2013-04-21','15:20:00',1.06),('15128','2013-04-21','15:25:00',1.11),('15128','2013-04-21','15:30:00',1.13),('15128','2013-04-21','15:35:00',1.62),('15128','2013-04-21','15:40:00',3.17),('15128','2013-04-21','15:45:00',2.27),('15128','2013-04-21','15:50:00',1.52),('15128','2013-04-21','15:55:00',1.51),('15128','2013-04-21','16:00:00',1.24),('15128','2013-04-21','16:05:00',1.04),('15128','2013-04-21','17:10:00',1.72),('15128','2013-04-21','17:15:00',2.17),('15128','2013-04-21','17:20:00',2.4),('15128','2013-04-21','17:25:00',3.09),('15128','2013-04-21','17:30:00',3.41),('15128','2013-04-21','17:35:00',2.71),('15128','2013-04-21','17:40:00',2.05),('15128','2013-04-21','17:45:00',2.08),('15128','2013-04-21','17:50:00',2.66),('15128','2013-04-21','17:55:00',2.51),('15128','2013-04-21','18:00:00',2.89),('15128','2013-04-21','18:05:00',1.46),('15128','2013-04-21','18:15:00',1.47),('15128','2013-04-21','18:20:00',2.1),('15128','2013-04-21','18:25:00',1.96),('15128','2013-04-21','18:30:00',1.68),('15128','2013-04-21','18:35:00',1.54),('15128','2013-04-21','18:40:00',1.39),('15128','2013-04-21','18:45:00',1.33),('15128','2013-04-21','18:50:00',1.25),('15128','2014-03-28','08:05:00',1.07),('15128','2014-03-28','08:10:00',1.14),('15128','2014-03-28','08:15:00',1.2),('15128','2014-03-28','08:20:00',1.27),('15128','2014-03-28','08:25:00',1.35),('15128','2014-03-28','08:30:00',1.43),('15128','2014-03-28','08:35:00',1.48),('15128','2014-03-28','08:40:00',1.51),('15128','2014-03-28','08:45:00',1.56),('15128','2014-03-28','08:50:00',1.63),('15128','2014-03-28','08:55:00',1.7),('15128','2014-03-28','09:00:00',1.78),('15128','2014-03-28','09:05:00',1.83),('15128','2014-03-28','09:10:00',1.89),('15128','2014-03-28','09:15:00',1.93),('15128','2014-03-28','09:20:00',1.99),('15128','2014-03-28','09:25:00',2.04),('15128','2014-03-28','09:30:00',2.05),('15128','2014-03-28','09:35:00',2.17),('15128','2014-03-28','09:40:00',2.23),('15128','2014-03-28','09:45:00',2.3),('15128','2014-03-28','09:50:00',2.34),('15128','2014-03-28','09:55:00',2.41),('15128','2014-03-28','10:00:00',2.45),('15128','2014-03-28','10:05:00',2.51),('15128','2014-03-28','10:10:00',2.57),('15128','2014-03-28','10:15:00',2.6),('15128','2014-03-28','10:20:00',2.7),('15128','2014-03-28','10:25:00',2.76),('15128','2014-03-28','10:30:00',2.8),('15128','2014-03-28','10:35:00',2.81),('15128','2014-03-28','10:40:00',2.93),('15128','2014-03-28','10:45:00',2.89),('15128','2014-03-28','10:50:00',3.06),('15128','2014-03-28','10:55:00',3.08),('15128','2014-03-28','11:00:00',3.25),('15128','2014-03-28','11:05:00',3.36),('15128','2014-03-28','11:10:00',3.39),('15128','2014-03-28','11:15:00',3.45),('15128','2014-03-28','11:20:00',3.5),('15128','2014-03-28','11:25:00',3.53),('15128','2014-03-28','11:30:00',3.54),('15128','2014-03-28','11:35:00',3.48),('15128','2014-03-28','11:40:00',3.57),('15128','2014-03-28','11:45:00',3.62),('15128','2014-03-28','11:50:00',3.63),('15128','2014-03-28','11:55:00',3.59),('15128','2014-03-28','12:00:00',3.65),('15128','2014-03-28','12:05:00',3.73),('15128','2014-03-28','12:10:00',3.75),('15128','2014-03-28','12:15:00',3.75),('15128','2014-03-28','12:20:00',3.76),('15128','2014-03-28','12:25:00',3.81),('15128','2014-03-28','12:30:00',3.85),('15128','2014-03-28','12:35:00',3.85),('15128','2014-03-28','12:40:00',3.86),('15128','2014-03-28','12:45:00',3.77),('15128','2014-03-28','12:50:00',3.1),('15128','2014-03-28','12:55:00',3.62),('15128','2014-03-28','13:00:00',3.8),('15128','2014-03-28','13:05:00',3.72),('15128','2014-03-28','13:10:00',3.93),('15128','2014-03-28','13:15:00',3.97),('15128','2014-03-28','13:20:00',2.32),('15128','2014-03-28','13:25:00',2.36),('15128','2014-03-28','13:30:00',2.61),('15128','2014-03-28','13:35:00',2.93),('15128','2014-03-28','13:40:00',2.82),('15128','2014-03-28','13:45:00',3.09),('15128','2014-03-28','13:50:00',2.92),('15128','2014-03-28','13:55:00',3.38),('15128','2014-03-28','14:00:00',3.64),('15128','2014-03-28','14:05:00',3.49),('15128','2014-03-28','14:10:00',3.52),('15128','2014-03-28','14:15:00',3.53),('15128','2014-03-28','14:20:00',3.61),('15128','2014-03-28','14:25:00',3.57),('15128','2014-03-28','14:30:00',3.5),('15128','2014-03-28','14:35:00',3.47),('15128','2014-03-28','14:40:00',3.41),('15128','2014-03-28','14:45:00',3.35),('15128','2014-03-28','14:50:00',3.29),('15128','2014-03-28','14:55:00',3.19),('15128','2014-03-28','15:00:00',3.11),('15128','2014-03-28','15:05:00',3.13),('15128','2014-03-28','15:10:00',3.03),('15128','2014-03-28','15:15:00',2.97),('15128','2014-03-28','15:20:00',2.93),('15128','2014-03-28','15:25:00',2.86),('15128','2014-03-28','15:30:00',2.78),('15128','2014-03-28','15:35:00',2.71),('15128','2014-03-28','15:40:00',2.66),('15128','2014-03-28','15:45:00',2.6),('15128','2014-03-28','15:50:00',2.54),('15128','2014-03-28','15:55:00',2.46),('15128','2014-03-28','16:00:00',2.37),('15128','2014-03-28','16:05:00',2.25),('15128','2014-03-28','16:10:00',2.1),('15128','2014-03-28','16:15:00',1.96),('15128','2014-03-28','16:20:00',1.85),('15128','2014-03-28','16:25:00',1.83),('15128','2014-03-28','16:30:00',1.74),('15128','2014-03-28','16:35:00',1.45),('15128','2014-03-28','16:40:00',1.23),('15128','2014-03-28','16:45:00',1.37),('15128','2014-03-28','16:50:00',1.43),('15128','2014-03-28','16:55:00',1.33),('15128','2014-03-28','17:00:00',1.23),('15128','2014-03-28','17:05:00',1.15),('15128','2014-03-28','17:10:00',1.05),('15128','2013-04-20','08:45:00',1.05),('15128','2013-04-20','08:50:00',1.1),('15128','2013-04-20','09:10:00',1.05),('15128','2013-04-20','09:15:00',1.19),('15128','2013-04-20','09:25:00',1.31),('15128','2013-04-20','09:30:00',1.66),('15128','2013-04-20','09:35:00',2.31),('15128','2013-04-20','09:40:00',2.42),('15128','2013-04-20','09:45:00',1.92),('15128','2013-04-20','09:50:00',1.77),('15128','2013-04-20','09:55:00',1.52),('15128','2013-04-20','10:00:00',1.33),('15128','2013-04-20','10:05:00',1.49),('15128','2013-04-20','10:10:00',1.97),('15128','2013-04-20','10:15:00',1.7),('15128','2013-04-20','10:20:00',2.64),('15128','2013-04-20','10:25:00',2.63),('15128','2013-04-20','10:30:00',2.68),('15128','2013-04-20','10:35:00',2.77),('15128','2013-04-20','10:40:00',2.84),('15128','2013-04-20','10:45:00',2.94),('15128','2013-04-20','10:50:00',2.77),('15128','2013-04-20','10:55:00',3.01),('15128','2013-04-20','11:00:00',3.06),('15128','2013-04-20','11:05:00',3.25),('15128','2013-04-20','11:10:00',2.95),('15128','2013-04-20','11:15:00',3.15),('15128','2013-04-20','11:20:00',2.68),('15128','2013-04-20','11:25:00',2.5),('15128','2013-04-20','11:30:00',2.65),('15128','2013-04-20','11:35:00',2.72),('15128','2013-04-20','11:40:00',2.72),('15128','2013-04-20','11:45:00',2.63),('15128','2013-04-20','11:50:00',2.75),('15128','2013-04-20','11:55:00',2.46),('15128','2013-04-20','12:00:00',2.71),('15128','2013-04-20','12:05:00',2.65),('15128','2013-04-20','12:10:00',2.58),('15128','2013-04-20','12:15:00',2.29),('15128','2013-04-20','12:20:00',2.13),('15128','2013-04-20','12:25:00',2.25),('15128','2013-04-20','12:30:00',2.35),('15128','2013-04-20','12:35:00',2.38),('15128','2013-04-20','12:40:00',2.49),('15128','2013-04-20','12:45:00',2.47),('15128','2013-04-20','12:50:00',2.39),('15128','2013-04-20','12:55:00',2.42),('15128','2013-04-20','13:00:00',2.47),('15128','2013-04-20','13:05:00',3.06),('15128','2013-04-20','13:10:00',3.06),('15128','2013-04-20','13:15:00',2.66),('15128','2013-04-20','13:20:00',2.68),('15128','2013-04-20','13:25:00',2.64),('15128','2013-04-20','13:30:00',2.83),('15128','2013-04-20','13:35:00',3.25),('15128','2013-04-20','13:40:00',4.57),('15128','2013-04-20','13:45:00',4.4),('15128','2013-04-20','13:50:00',4.28),('15128','2013-04-20','13:55:00',4.76),('15128','2013-04-20','14:00:00',4),('15128','2013-04-20','14:05:00',3.75),('15128','2013-04-20','14:10:00',4.06),('15128','2013-04-20','14:15:00',2.6),('15128','2013-04-20','14:20:00',3.7),('15128','2013-04-20','14:25:00',4.34),('15128','2013-04-20','14:30:00',4.73),('15128','2013-04-20','14:35:00',4.55),('15128','2013-04-20','14:40:00',4.02),('15128','2013-04-20','14:45:00',4.41),('15128','2013-04-20','14:50:00',2.5),('15128','2013-04-20','14:55:00',3.49),('15128','2013-04-20','15:00:00',4.35),('15128','2013-04-20','15:05:00',4.29),('15128','2013-04-20','15:10:00',4.39),('15128','2013-04-20','15:15:00',3.91),('15128','2013-04-20','15:20:00',3.42),('15128','2013-04-20','15:25:00',4.33),('15128','2013-04-20','15:30:00',3.93),('15128','2013-04-20','15:35:00',2.82),('15128','2013-04-20','15:40:00',2.68),('15128','2013-04-20','15:45:00',1.98),('15128','2013-04-20','15:50:00',1.33),('15128','2013-04-20','15:55:00',1.09),('15128','2013-04-19','08:25:00',1.16),('15128','2013-04-19','08:30:00',1.22),('15128','2013-04-19','08:35:00',1.33),('15128','2013-04-19','08:40:00',1.32),('15128','2013-04-19','08:45:00',1.45),('15128','2013-04-19','08:50:00',1.37),('15128','2013-04-19','08:55:00',1.57),('15128','2013-04-19','09:00:00',1.65),('15128','2013-04-19','09:05:00',1.78),('15128','2013-04-19','09:10:00',1.49),('15128','2013-04-19','09:15:00',1.2),('15128','2013-04-19','09:20:00',1.12),('15128','2013-04-19','09:25:00',1.07),('15128','2013-04-19','10:30:00',1.13),('15128','2013-04-19','10:35:00',1.4),('15128','2013-04-19','10:40:00',1.59),('15128','2013-04-19','10:45:00',1.77),('15128','2013-04-19','10:50:00',3.05),('15128','2013-04-19','10:55:00',3.38),('15128','2013-04-19','11:00:00',2.21),('15128','2013-04-19','11:05:00',1.28),('15128','2013-04-19','11:10:00',1.25),('15128','2013-04-19','11:15:00',1.29),('15128','2013-04-19','11:20:00',1.32),('15128','2013-04-19','11:25:00',1.49),('15128','2013-04-19','11:30:00',1.75),('15128','2013-04-19','11:35:00',2.28),('15128','2013-04-19','11:40:00',3.88),('15128','2013-04-19','11:45:00',3.07),('15128','2013-04-19','11:50:00',1.48),('15128','2013-04-19','11:55:00',1.48),('15128','2013-04-19','12:00:00',2.01),('15128','2013-04-19','12:05:00',4.96),('15128','2013-04-19','12:10:00',2.31),('15128','2013-04-19','12:15:00',2.14),('15128','2013-04-19','12:20:00',3.76),('15128','2013-04-19','12:25:00',4.75),('15128','2013-04-19','12:30:00',4.37),('15128','2013-04-19','12:35:00',2.55),('15128','2013-04-19','12:40:00',1.5),('15128','2013-04-19','12:45:00',1.94),('15128','2013-04-19','12:50:00',2.52),('15128','2013-04-19','12:55:00',4.9),('15128','2013-04-19','13:00:00',4.38),('15128','2013-04-19','13:05:00',4.46),('15128','2013-04-19','13:10:00',4.55),('15128','2013-04-19','13:15:00',4.55),('15128','2013-04-19','13:20:00',4.58),('15128','2013-04-19','13:25:00',4.13),('15128','2013-04-19','13:30:00',4.43),('15128','2013-04-19','13:35:00',4.76),('15128','2013-04-19','13:40:00',4.68),('15128','2013-04-19','13:45:00',3.47),('15128','2013-04-19','13:50:00',3.82),('15128','2013-04-19','13:55:00',3.05),('15128','2013-04-19','14:00:00',4.38),('15128','2013-04-19','14:05:00',4.19),('15128','2013-04-19','14:10:00',3.34),('15128','2013-04-19','14:15:00',4.06),('15128','2013-04-19','14:20:00',3.95),('15128','2013-04-19','14:25:00',4.42),('15128','2013-04-19','14:30:00',3.82),('15128','2013-04-19','14:35:00',4.29),('15128','2013-04-19','14:40:00',4.15),('15128','2013-04-19','14:45:00',4.15),('15128','2013-04-19','14:50:00',4.17),('15128','2013-04-19','14:55:00',4.16),('15128','2013-04-19','15:00:00',4.19),('15128','2013-04-19','15:05:00',4.13),('15128','2013-04-19','15:10:00',3.65),('15128','2013-04-19','15:15:00',2.56),('15128','2013-04-19','15:20:00',2.93),('15128','2013-04-19','15:25:00',2.99),('15128','2013-04-19','15:30:00',1.42),('15128','2013-04-19','15:35:00',1.11),('15128','2013-04-19','16:00:00',1.31),('15128','2013-04-19','16:05:00',1.97),('15128','2013-04-19','16:10:00',3.4),('15128','2013-04-19','16:15:00',3.78),('15128','2013-04-19','16:20:00',2.99),('15128','2013-04-19','16:25:00',3.62),('15128','2013-04-19','16:30:00',3.77),('15128','2013-04-19','16:35:00',3.61),('15128','2013-04-19','16:40:00',3.44),('15128','2013-04-19','16:45:00',3.31),('15128','2013-04-19','16:50:00',3.14),('15128','2013-04-19','16:55:00',2.97),('15128','2013-04-19','17:00:00',3.02),('15128','2013-04-19','17:05:00',2.95),('15128','2013-04-19','17:10:00',2.83),('15128','2013-04-19','17:15:00',2.61),('15128','2013-04-19','17:20:00',2.73),('15128','2013-04-19','17:25:00',2.69),('15128','2013-04-19','17:30:00',2.68),('15128','2013-04-19','17:35:00',2.58),('15128','2013-04-19','17:40:00',1.21),('15128','2013-04-19','17:45:00',1.14),('15128','2013-04-19','17:50:00',2.02),('15128','2013-04-19','17:55:00',1.81),('15128','2013-04-19','18:00:00',1.62),('15128','2013-04-19','18:05:00',1.97),('15128','2013-04-19','18:10:00',1.85),('15128','2013-04-18','08:20:00',1.06),('15128','2013-04-18','08:25:00',1.03),('15128','2013-04-18','08:50:00',1.22),('15128','2013-04-18','08:55:00',1.09),('15128','2013-04-18','09:00:00',1.19),('15128','2013-04-18','09:05:00',1.44),('15128','2013-04-18','09:10:00',1.53),('15128','2013-04-18','09:15:00',1.65),('15128','2013-04-18','09:20:00',1.63),('15128','2013-04-18','09:25:00',1.7),('15128','2013-04-18','09:30:00',1.75),('15128','2013-04-18','09:35:00',1.84),('15128','2013-04-18','09:40:00',1.86),('15128','2013-04-18','09:45:00',1.9),('15128','2013-04-18','09:50:00',1.95),('15128','2013-04-18','09:55:00',1.99),('15128','2013-04-18','10:00:00',2.08),('15128','2013-04-18','10:05:00',2.17),('15128','2013-04-18','10:10:00',2.23),('15128','2013-04-18','10:15:00',2.28),('15128','2013-04-18','10:20:00',2.33),('15128','2013-04-18','10:25:00',2.37),('15128','2013-04-18','10:30:00',2.5),('15128','2013-04-18','10:35:00',2.58),('15128','2013-04-18','10:40:00',2.42),('15128','2013-04-18','10:45:00',2.61),('15128','2013-04-18','10:50:00',2.71),('15128','2013-04-18','10:55:00',2.73),('15128','2013-04-18','11:00:00',2.77),('15128','2013-04-18','11:05:00',2.85),('15128','2013-04-18','11:10:00',2.89),('15128','2013-04-18','11:15:00',2.99),('15128','2013-04-18','11:20:00',3.01),('15128','2013-04-18','11:25:00',3.07),('15128','2013-04-18','11:30:00',3.11),('15128','2013-04-18','11:35:00',3.21),('15128','2013-04-18','11:40:00',3.3),('15128','2013-04-18','11:45:00',3.4),('15128','2013-04-18','11:50:00',3.5),('15128','2013-04-18','11:55:00',3.6),('15128','2013-04-18','12:00:00',3.68),('15128','2013-04-18','12:05:00',3.72),('15128','2013-04-18','12:10:00',3.75),('15128','2013-04-18','12:15:00',3.77),('15128','2013-04-18','12:20:00',3.74),('15128','2013-04-18','12:25:00',3.88),('15128','2013-04-18','12:30:00',3.89),('15128','2013-04-18','12:35:00',3.93),('15128','2013-04-18','12:40:00',3.77),('15128','2013-04-18','12:45:00',3.98),('15128','2013-04-18','12:50:00',4.01),('15128','2013-04-18','12:55:00',4.03),('15128','2013-04-18','13:00:00',4),('15128','2013-04-18','13:05:00',4.06),('15128','2013-04-18','13:10:00',4.17),('15128','2013-04-18','13:15:00',4.09),('15128','2013-04-18','13:20:00',4.15),('15128','2013-04-18','13:25:00',4.12),('15128','2013-04-18','13:30:00',4.15),('15128','2013-04-18','13:35:00',4.1),('15128','2013-04-18','13:40:00',4.13),('15128','2013-04-18','13:45:00',4.16),('15128','2013-04-18','13:50:00',4.17),('15128','2013-04-18','13:55:00',4.16),('15128','2013-04-18','14:00:00',4.18),('15128','2013-04-18','14:05:00',4.17),('15128','2013-04-18','14:10:00',4.17),('15128','2013-04-18','14:15:00',4.15),('15128','2013-04-18','14:20:00',4.14),('15128','2013-04-18','14:25:00',4.11),('15128','2013-04-18','14:30:00',4.09),('15128','2013-04-18','14:35:00',4.08),('15128','2013-04-18','14:40:00',4.07),('15128','2013-04-18','14:45:00',4.09),('15128','2013-04-18','14:50:00',4.05),('15128','2013-04-18','14:55:00',4.02),('15128','2013-04-18','15:00:00',3.98),('15128','2013-04-18','15:05:00',3.95),('15128','2013-04-18','15:10:00',3.92),('15128','2013-04-18','15:15:00',3.88),('15128','2013-04-18','15:20:00',3.84),('15128','2013-04-18','15:25:00',3.8),('15128','2013-04-18','15:30:00',3.8),('15128','2013-04-18','15:35:00',3.78),('15128','2013-04-18','15:40:00',3.76),('15128','2013-04-18','15:45:00',3.72),('15128','2013-04-18','15:50:00',3.68),('15128','2013-04-18','15:55:00',3.61),('15128','2013-04-18','16:00:00',3.56),('15128','2013-04-18','16:05:00',3.53),('15128','2013-04-18','16:10:00',3.45),('15128','2013-04-18','16:15:00',3.39),('15128','2013-04-18','16:20:00',3.3),('15128','2013-04-18','16:25:00',3.22),('15128','2013-04-18','16:30:00',3.16),('15128','2013-04-18','16:35:00',3.11),('15128','2013-04-18','16:40:00',3.02),('15128','2013-04-18','16:45:00',2.95),('15128','2013-04-18','16:50:00',2.87),('15128','2013-04-18','16:55:00',2.8),('15128','2013-04-18','17:00:00',2.72),('15128','2013-04-18','17:05:00',2.64),('15128','2013-04-18','17:10:00',2.57),('15128','2013-04-18','17:15:00',2.51),('15128','2013-04-18','17:20:00',2.43),('15128','2013-04-18','17:25:00',2.27),('15128','2013-04-18','17:30:00',2.16),('15128','2013-04-18','17:35:00',2.05),('15128','2013-04-18','17:40:00',1.96),('15128','2013-04-18','17:45:00',1.86),('15128','2013-04-18','17:50:00',1.72),('15128','2013-04-18','17:55:00',1.67),('15128','2013-04-18','18:00:00',1.61),('15128','2013-04-18','18:05:00',1.56),('15128','2013-04-18','18:10:00',1.47),('15128','2013-04-18','18:15:00',1.4),('15128','2013-04-18','18:20:00',1.31),('15128','2013-04-18','18:25:00',1.18),('15128','2013-04-18','18:30:00',1.04),('15128','2013-04-17','09:10:00',1.01),('15128','2013-04-17','09:15:00',1.25),('15128','2013-04-17','09:20:00',1.4),('15128','2013-04-17','09:25:00',1.33),('15128','2013-04-17','09:30:00',1.32),('15128','2013-04-17','09:35:00',1.31),('15128','2013-04-17','09:40:00',1.2),('15128','2013-04-17','09:45:00',1.48),('15128','2013-04-17','09:50:00',2.03),('15128','2013-04-17','09:55:00',1.98),('15128','2013-04-17','10:00:00',1.98),('15128','2013-04-17','10:05:00',2.11),('15128','2013-04-17','10:10:00',2.15),('15128','2013-04-17','10:15:00',2.16),('15128','2013-04-17','10:20:00',2.3),('15128','2013-04-17','10:25:00',2.38),('15128','2013-04-17','10:30:00',2.54),('15128','2013-04-17','10:35:00',2.6),('15128','2013-04-17','10:40:00',2.65),('15128','2013-04-17','10:45:00',2.65),('15128','2013-04-17','10:50:00',2.73),('15128','2013-04-17','10:55:00',2.74),('15128','2013-04-17','11:00:00',2.85),('15128','2013-04-17','11:05:00',2.85),('15128','2013-04-17','11:10:00',2.92),('15128','2013-04-17','11:15:00',3.05),('15128','2013-04-17','11:20:00',3.07),('15128','2013-04-17','11:25:00',3.16),('15128','2013-04-17','11:30:00',3.21),('15128','2013-04-17','11:35:00',3.25),('15128','2013-04-17','11:40:00',3.42),('15128','2013-04-17','11:45:00',3.5),('15128','2013-04-17','11:50:00',3.64),('15128','2013-04-17','11:55:00',3.76),('15128','2013-04-17','12:00:00',3.67),('15128','2013-04-17','12:05:00',3.89),('15128','2013-04-17','12:10:00',3.94),('15128','2013-04-17','12:15:00',3.91),('15128','2013-04-17','12:20:00',4.01),('15128','2013-04-17','12:25:00',4.05),('15128','2013-04-17','12:30:00',4.07),('15128','2013-04-17','12:35:00',4.1),('15128','2013-04-17','12:40:00',4.12),('15128','2013-04-17','12:45:00',4.12),('15128','2013-04-17','12:50:00',4.14),('15128','2013-04-17','12:55:00',4.15),('15128','2013-04-17','13:00:00',4.16),('15128','2013-04-17','13:05:00',4.17),('15128','2013-04-17','13:10:00',4.18),('15128','2013-04-17','13:15:00',4.2),('15128','2013-04-17','13:20:00',4.21),('15128','2013-04-17','13:25:00',4.22),('15128','2013-04-17','13:30:00',4.25),('15128','2013-04-17','13:35:00',4.24),('15128','2013-04-17','13:40:00',4.23),('15128','2013-04-17','13:45:00',4.24),('15128','2013-04-17','13:50:00',4.26),('15128','2013-04-17','13:55:00',4.27),('15128','2013-04-17','14:00:00',4.26),('15128','2013-04-17','14:05:00',4.28),('15128','2013-04-17','14:10:00',4.28),('15128','2013-04-17','14:15:00',4.29),('15128','2013-04-17','14:20:00',4.26),('15128','2013-04-17','14:25:00',4.26),('15128','2013-04-17','14:30:00',4.25),('15128','2013-04-17','14:35:00',4.21),('15128','2013-04-17','14:40:00',4.19),('15128','2013-04-17','14:45:00',4.17),('15128','2013-04-17','14:50:00',4.14),('15128','2013-04-17','14:55:00',4.13),('15128','2013-04-17','15:00:00',4.09),('15128','2013-04-17','15:05:00',4.08),('15128','2013-04-17','15:10:00',4.05),('15128','2013-04-17','15:15:00',4),('15128','2013-04-17','15:20:00',3.97),('15128','2013-04-17','15:25:00',3.93),('15128','2013-04-17','15:30:00',3.88),('15128','2013-04-17','15:35:00',3.83),('15128','2013-04-17','15:40:00',3.81),('15128','2013-04-17','15:45:00',3.76),('15128','2013-04-17','15:50:00',3.71),('15128','2013-04-17','15:55:00',3.66),('15128','2013-04-17','16:00:00',3.59),('15128','2013-04-17','16:05:00',3.54),('15128','2013-04-17','16:10:00',3.47),('15128','2013-04-17','16:15:00',3.41),('15128','2013-04-17','16:20:00',3.35),('15128','2013-04-17','16:25:00',3.28),('15128','2013-04-17','16:30:00',3.26),('15128','2013-04-17','16:35:00',3.18),('15128','2013-04-17','16:40:00',3.13),('15128','2013-04-17','16:45:00',3.06),('15128','2013-04-17','16:50:00',2.97),('15128','2013-04-17','16:55:00',2.86),('15128','2013-04-17','17:00:00',2.8),('15128','2013-04-17','17:05:00',2.72),('15128','2013-04-17','17:10:00',2.64),('15128','2013-04-17','17:15:00',2.57),('15128','2013-04-17','17:20:00',2.5),('15128','2013-04-17','17:25:00',2.42),('15128','2013-04-17','17:30:00',2.28),('15128','2013-04-17','17:35:00',2.2),('15128','2013-04-17','17:40:00',2.06),('15128','2013-04-17','17:45:00',1.95),('15128','2013-04-17','17:50:00',1.84),('15128','2013-04-17','17:55:00',1.77),('15128','2013-04-17','18:00:00',1.71),('15128','2013-04-17','18:05:00',1.66),('15128','2013-04-17','18:10:00',1.54),('15128','2013-04-17','18:15:00',1.45),('15128','2013-04-17','18:20:00',1.33),('15128','2013-04-17','18:25:00',1.19),('15128','2013-04-17','18:30:00',1.09),('15128','2013-04-16','08:35:00',1.07),('15128','2013-04-16','08:40:00',1.14),('15128','2013-04-16','09:25:00',1.7),('15128','2013-04-16','09:30:00',1.77),('15128','2013-04-16','09:35:00',1.83),('15128','2013-04-16','09:40:00',1.9),('15128','2013-04-16','09:45:00',1.95),('15128','2013-04-16','09:50:00',2),('15128','2013-04-16','09:55:00',2.04),('15128','2013-04-16','10:00:00',2.11),('15128','2013-04-16','10:05:00',2.2),('15128','2013-04-16','10:10:00',2.27),('15128','2013-04-16','10:15:00',2.29),('15128','2013-04-16','10:20:00',2.38),('15128','2013-04-16','10:25:00',2.48),('15128','2013-04-16','10:30:00',2.53),('15128','2013-04-16','10:35:00',2.63),('15128','2013-04-16','10:40:00',2.71),('15128','2013-04-16','10:45:00',2.73),('15128','2013-04-16','10:50:00',2.76),('15128','2013-04-16','10:55:00',2.8),('15128','2013-04-16','11:00:00',2.9),('15128','2013-04-16','11:05:00',2.87),('15128','2013-04-16','11:10:00',2.82),('15128','2013-04-16','11:15:00',2.95),('15128','2013-04-16','11:20:00',3.08),('15128','2013-04-16','11:25:00',3.18),('15128','2013-04-16','11:30:00',3.25),('15128','2013-04-16','11:35:00',3.29),('15128','2013-04-16','11:40:00',3.42),('15128','2013-04-16','11:45:00',3.52),('15128','2013-04-16','11:50:00',3.63),('15128','2013-04-16','11:55:00',3.71),('15128','2013-04-16','12:00:00',3.83),('15128','2013-04-16','12:05:00',3.88),('15128','2013-04-16','12:10:00',3.89),('15128','2013-04-16','12:15:00',3.93),('15128','2013-04-16','12:20:00',3.96),('15128','2013-04-16','12:25:00',3.99),('15128','2013-04-16','12:30:00',4.02),('15128','2013-04-16','12:35:00',4.03),('15128','2013-04-16','12:40:00',4.07),('15128','2013-04-16','12:45:00',4.12),('15128','2013-04-16','12:50:00',4.18),('15128','2013-04-16','12:55:00',4.22),('15128','2013-04-16','13:00:00',4.19),('15128','2013-04-16','13:05:00',4.21),('15128','2013-04-16','13:10:00',4.25),('15128','2013-04-16','13:15:00',4.31),('15128','2013-04-16','13:20:00',4.22),('15128','2013-04-16','13:25:00',4.32),('15128','2013-04-16','13:30:00',4.35),('15128','2013-04-16','13:35:00',4.38),('15128','2013-04-16','13:40:00',4.49),('15128','2013-04-16','13:45:00',4.2),('15128','2013-04-16','13:50:00',3.99),('15128','2013-04-16','13:55:00',3.96),('15128','2013-04-16','14:00:00',3.75),('15128','2013-04-16','14:05:00',3.98),('15128','2013-04-16','14:10:00',4.71),('15128','2013-04-16','14:15:00',4.5),('15128','2013-04-16','14:20:00',4.35),('15128','2013-04-16','14:25:00',3.52),('15128','2013-04-16','14:30:00',4.33),('15128','2013-04-16','14:35:00',4.63),('15128','2013-04-16','14:40:00',4.29),('15128','2013-04-16','14:45:00',2.07),('15128','2013-04-16','14:50:00',3.57),('15128','2013-04-16','14:55:00',3.08),('15128','2013-04-16','15:00:00',4.6),('15128','2013-04-16','15:05:00',4.69),('15128','2013-04-16','15:10:00',4.65),('15128','2013-04-16','15:15:00',4.39),('15128','2013-04-16','15:20:00',2.53),('15128','2013-04-16','15:25:00',1.8),('15128','2013-04-16','15:30:00',2.88),('15128','2013-04-16','15:35:00',3.64),('15128','2013-04-16','15:40:00',3.8),('15128','2013-04-16','15:45:00',3.19),('15128','2013-04-16','15:50:00',3.35),('15128','2013-04-16','15:55:00',2.94),('15128','2013-04-16','16:00:00',3.22),('15128','2013-04-16','16:05:00',3.37),('15128','2013-04-16','16:10:00',3.68),('15128','2013-04-16','16:15:00',3.6),('15128','2013-04-16','16:20:00',3.48),('15128','2013-04-16','16:25:00',3.43),('15128','2013-04-16','16:30:00',3.35),('15128','2013-04-16','16:35:00',2.91),('15128','2013-04-16','16:40:00',2.51),('15128','2013-04-16','16:45:00',3.03),('15128','2013-04-16','16:50:00',3.05),('15128','2013-04-16','16:55:00',2.96),('15128','2013-04-16','17:00:00',2.88),('15128','2013-04-16','17:05:00',2.82),('15128','2013-04-16','17:10:00',2.72),('15128','2013-04-16','17:15:00',2.61),('15128','2013-04-16','17:20:00',2.53),('15128','2013-04-16','17:25:00',2.44),('15128','2013-04-16','17:30:00',2.31),('15128','2013-04-16','17:35:00',2.23),('15128','2013-04-16','17:40:00',2.1),('15128','2013-04-16','17:45:00',2),('15128','2013-04-16','17:50:00',1.92),('15128','2013-04-16','17:55:00',1.85),('15128','2013-04-16','18:00:00',1.76),('15128','2013-04-16','18:05:00',1.7),('15128','2013-04-16','18:10:00',1.61),('15128','2013-04-16','18:15:00',1.53),('15128','2013-04-16','18:20:00',1.43),('15128','2013-04-16','18:25:00',1.3),('15128','2013-04-16','18:30:00',1.17),('15128','2013-04-16','18:35:00',1.09),('15128','2013-04-15','09:05:00',1.37),('15128','2013-04-15','09:10:00',1.42),('15128','2013-04-15','09:15:00',1.6),('15128','2013-04-15','09:20:00',2),('15128','2013-04-15','09:25:00',1.45),('15128','2013-04-15','09:30:00',1.3),('15128','2013-04-15','09:35:00',1.4),('15128','2013-04-15','09:40:00',1.67),('15128','2013-04-15','09:45:00',1.56),('15128','2013-04-15','09:50:00',1.5),('15128','2013-04-15','09:55:00',1.48),('15128','2013-04-15','10:00:00',1.51),('15128','2013-04-15','10:05:00',1.45),('15128','2013-04-15','10:10:00',1.42),('15128','2013-04-15','10:15:00',1.45),('15128','2013-04-15','10:20:00',1.42),('15128','2013-04-15','10:25:00',1.43),('15128','2013-04-15','10:30:00',1.46),('15128','2013-04-15','10:35:00',1.54),('15128','2013-04-15','10:40:00',1.62),('15128','2013-04-15','10:45:00',1.69),('15128','2013-04-15','10:50:00',1.71),('15128','2013-04-15','10:55:00',1.68),('15128','2013-04-15','11:00:00',1.66),('15128','2013-04-15','11:05:00',1.71),('15128','2013-04-15','11:10:00',1.8),('15128','2013-04-15','11:15:00',1.82),('15128','2013-04-15','11:20:00',1.84),('15128','2013-04-15','11:25:00',1.84),('15128','2013-04-15','11:30:00',1.7),('15128','2013-04-15','11:35:00',1.72),('15128','2013-04-15','11:40:00',2.03),('15128','2013-04-15','11:45:00',2.31),('15128','2013-04-15','11:50:00',2.47),('15128','2013-04-15','11:55:00',2.7),('15128','2013-04-15','12:00:00',3.1),('15128','2013-04-15','12:05:00',3.35),('15128','2013-04-15','12:10:00',3.01),('15128','2013-04-15','12:15:00',3.02),('15128','2013-04-15','12:20:00',3.62),('15128','2013-04-15','12:25:00',3.66),('15128','2013-04-15','12:30:00',4.12),('15128','2013-04-15','12:35:00',3.27),('15128','2013-04-15','12:40:00',2.49),('15128','2013-04-15','12:45:00',2.44),('15128','2013-04-15','12:50:00',3.56),('15128','2013-04-15','12:55:00',3.85),('15128','2013-04-15','13:00:00',3.95),('15128','2013-04-15','13:05:00',3.87),('15128','2013-04-15','13:10:00',3.99),('15128','2013-04-15','13:15:00',3.97),('15128','2013-04-15','13:20:00',4.06),('15128','2013-04-15','13:25:00',4.08),('15128','2013-04-15','13:30:00',4.15),('15128','2013-04-15','13:35:00',4.04),('15128','2013-04-15','13:40:00',4.1),('15128','2013-04-15','13:45:00',4.09),('15128','2013-04-15','13:50:00',4.09),('15128','2013-04-15','13:55:00',4.22),('15128','2013-04-15','14:00:00',4.18),('15128','2013-04-15','14:05:00',4.16),('15128','2013-04-15','14:10:00',4.27),('15128','2013-04-15','14:15:00',4.32),('15128','2013-04-15','14:20:00',4.25),('15128','2013-04-15','14:25:00',3.51),('15128','2013-04-15','14:30:00',2.87),('15128','2013-04-15','14:35:00',3.68),('15128','2013-04-15','14:40:00',4.14),('15128','2013-04-15','14:45:00',4.11),('15128','2013-04-15','14:50:00',4.15),('15128','2013-04-15','14:55:00',3.83),('15128','2013-04-15','15:00:00',4.14),('15128','2013-04-15','15:05:00',4.16),('15128','2013-04-15','15:10:00',4.07),('15128','2013-04-15','15:15:00',2.94),('15128','2013-04-15','15:20:00',3.29),('15128','2013-04-15','15:25:00',3.3),('15128','2013-04-15','15:30:00',3.52),('15128','2013-04-15','15:35:00',3.78),('15128','2013-04-15','15:40:00',3.66),('15128','2013-04-15','15:45:00',3.65),('15128','2013-04-15','15:50:00',3.66),('15128','2013-04-15','15:55:00',3.53),('15128','2013-04-15','16:00:00',3.51),('15128','2013-04-15','16:05:00',3.45),('15128','2013-04-15','16:10:00',3.46),('15128','2013-04-15','16:15:00',3.38),('15128','2013-04-15','16:20:00',3.23),('15128','2013-04-15','16:25:00',3.27),('15128','2013-04-15','16:30:00',3.19),('15128','2013-04-15','16:35:00',3.12),('15128','2013-04-15','16:40:00',3.16),('15128','2013-04-15','16:45:00',3.02),('15128','2013-04-15','16:50:00',2.71),('15128','2013-04-15','16:55:00',2.84),('15128','2013-04-15','17:00:00',2.83),('15128','2013-04-15','17:05:00',2.73),('15128','2013-04-15','17:10:00',2.67),('15128','2013-04-15','17:15:00',2.56),('15128','2013-04-15','17:20:00',2.49),('15128','2013-04-15','17:25:00',2.33),('15128','2013-04-15','17:30:00',2.22),('15128','2013-04-15','17:35:00',2.13),('15128','2013-04-15','17:40:00',2.03),('15128','2013-04-15','17:45:00',1.92),('15128','2013-04-15','17:50:00',1.84),('15128','2013-04-15','17:55:00',1.95),('15128','2013-04-15','18:00:00',1.92),('15128','2013-04-15','18:05:00',1.78),('15128','2013-04-15','18:10:00',1.33),('15128','2013-04-15','18:15:00',1.38),('15128','2013-04-15','18:20:00',1.24),('15128','2013-04-15','18:25:00',1.14),('15128','2013-04-15','18:30:00',1.02),('15128','2013-04-14','08:35:00',1.02),('15128','2013-04-14','08:40:00',1.12),('15128','2013-04-14','08:45:00',1.17),('15128','2013-04-14','08:50:00',1.23),('15128','2013-04-14','08:55:00',1.31),('15128','2013-04-14','09:00:00',1.41),('15128','2013-04-14','09:05:00',1.5),('15128','2013-04-14','09:10:00',1.55),('15128','2013-04-14','09:15:00',1.61),('15128','2013-04-14','09:20:00',1.69),('15128','2013-04-14','09:25:00',1.77),('15128','2013-04-14','09:30:00',1.84),('15128','2013-04-14','09:35:00',1.9),('15128','2013-04-14','09:40:00',1.95),('15128','2013-04-14','09:45:00',2),('15128','2013-04-14','09:50:00',1.99),('15128','2013-04-14','09:55:00',2.03),('15128','2013-04-14','10:00:00',2.1),('15128','2013-04-14','10:05:00',2.2),('15128','2013-04-14','10:10:00',2.26),('15128','2013-04-14','10:15:00',2.32),('15128','2013-04-14','10:20:00',2.36),('15128','2013-04-14','10:25:00',2.47),('15128','2013-04-14','10:30:00',2.47),('15128','2013-04-14','10:35:00',2.6),('15128','2013-04-14','10:40:00',2.7),('15128','2013-04-14','10:45:00',2.76),('15128','2013-04-14','10:50:00',2.82),('15128','2013-04-14','10:55:00',2.82),('15128','2013-04-14','11:00:00',2.88),('15128','2013-04-14','11:05:00',2.89),('15128','2013-04-14','11:10:00',2.94),('15128','2013-04-14','11:15:00',3),('15128','2013-04-14','11:20:00',3.09),('15128','2013-04-14','11:25:00',3.1),('15128','2013-04-14','11:30:00',3.2),('15128','2013-04-14','11:35:00',3.19),('15128','2013-04-14','11:40:00',3.31),('15128','2013-04-14','11:45:00',3.36),('15128','2013-04-14','11:50:00',3.59),('15128','2013-04-14','11:55:00',3.7),('15128','2013-04-14','12:00:00',3.76),('15128','2013-04-14','12:05:00',3.79),('15128','2013-04-14','12:10:00',3.84),('15128','2013-04-14','12:15:00',3.88),('15128','2013-04-14','12:20:00',3.93),('15128','2013-04-14','12:25:00',3.99),('15128','2013-04-14','12:30:00',4),('15128','2013-04-14','12:35:00',4.01),('15128','2013-04-14','12:40:00',4.01),('15128','2013-04-14','12:45:00',4.08),('15128','2013-04-14','12:50:00',4.09),('15128','2013-04-14','12:55:00',4.11),('15128','2013-04-14','13:00:00',4.13),('15128','2013-04-14','13:05:00',4.15),('15128','2013-04-14','13:10:00',4.18),('15128','2013-04-14','13:15:00',4.17),('15128','2013-04-14','13:20:00',4.17),('15128','2013-04-14','13:25:00',4.17),('15128','2013-04-14','13:30:00',4.2),('15128','2013-04-14','13:35:00',4.19),('15128','2013-04-14','13:40:00',4.21),('15128','2013-04-14','13:45:00',4.26),('15128','2013-04-14','13:50:00',4.28),('15128','2013-04-14','13:55:00',4.3),('15128','2013-04-14','14:00:00',4.32),('15128','2013-04-14','14:05:00',4.37),('15128','2013-04-14','14:10:00',4.34),('15128','2013-04-14','14:15:00',4.34),('15128','2013-04-14','14:20:00',4.31),('15128','2013-04-14','14:25:00',4.3),('15128','2013-04-14','14:30:00',4.29),('15128','2013-04-14','14:35:00',4.23),('15128','2013-04-14','14:40:00',4.21),('15128','2013-04-14','14:45:00',4.2),('15128','2013-04-14','14:50:00',4.19),('15128','2013-04-14','14:55:00',4.15),('15128','2013-04-14','15:00:00',4.11),('15128','2013-04-14','15:05:00',4.09),('15128','2013-04-14','15:10:00',4.08),('15128','2013-04-14','15:15:00',4.06),('15128','2013-04-14','15:20:00',4.01),('15128','2013-04-14','15:25:00',3.98),('15128','2013-04-14','15:30:00',3.95),('15128','2013-04-14','15:35:00',3.91),('15128','2013-04-14','15:40:00',3.86),('15128','2013-04-14','15:45:00',3.82),('15128','2013-04-14','15:50:00',3.76),('15128','2013-04-14','15:55:00',3.71),('15128','2013-04-14','16:00:00',3.64),('15128','2013-04-14','16:05:00',3.58),('15128','2013-04-14','16:10:00',3.52),('15128','2013-04-14','16:15:00',3.47),('15128','2013-04-14','16:20:00',3.42),('15128','2013-04-14','16:25:00',3.36),('15128','2013-04-14','16:30:00',3.3),('15128','2013-04-14','16:35:00',3.22),('15128','2013-04-14','16:40:00',3.16),('15128','2013-04-14','16:45:00',3.11),('15128','2013-04-14','16:50:00',3.03),('15128','2013-04-14','16:55:00',2.95),('15128','2013-04-14','17:00:00',2.88),('15128','2013-04-14','17:05:00',2.8),('15128','2013-04-14','17:10:00',2.73),('15128','2013-04-14','17:15:00',2.63),('15128','2013-04-14','17:20:00',2.51),('15128','2013-04-14','17:25:00',2.38),('15128','2013-04-14','17:30:00',2.29),('15128','2013-04-14','17:35:00',2.18),('15128','2013-04-14','17:40:00',2.08),('15128','2013-04-14','17:45:00',2.02),('15128','2013-04-14','17:50:00',1.95),('15128','2013-04-14','17:55:00',1.86),('15128','2013-04-14','18:00:00',1.77),('15128','2013-04-14','18:05:00',1.7),('15128','2013-04-14','18:10:00',1.61),('15128','2013-04-14','18:15:00',1.54),('15128','2013-04-14','18:20:00',1.44),('15128','2013-04-14','18:25:00',1.31),('15128','2013-04-14','18:30:00',1.16),('15128','2013-04-14','18:35:00',1.09),('15128','2013-04-13','08:40:00',1.07),('15128','2013-04-13','08:45:00',1.14),('15128','2013-04-13','08:50:00',1.19),('15128','2013-04-13','08:55:00',1.23),('15128','2013-04-13','09:00:00',1.31),('15128','2013-04-13','09:05:00',1.4),('15128','2013-04-13','09:10:00',1.45),('15128','2013-04-13','09:15:00',1.51),('15128','2013-04-13','09:20:00',1.52),('15128','2013-04-13','09:25:00',1.64),('15128','2013-04-13','09:30:00',1.73),('15128','2013-04-13','09:35:00',1.8),('15128','2013-04-13','09:40:00',1.88),('15128','2013-04-13','09:45:00',1.96),('15128','2013-04-13','09:50:00',1.93),('15128','2013-04-13','09:55:00',1.97),('15128','2013-04-13','10:00:00',2.02),('15128','2013-04-13','10:05:00',2.11),('15128','2013-04-13','10:10:00',2.2),('15128','2013-04-13','10:15:00',2.27),('15128','2013-04-13','10:20:00',2.32),('15128','2013-04-13','10:25:00',2.42),('15128','2013-04-13','10:30:00',2.44),('15128','2013-04-13','10:35:00',2.53),('15128','2013-04-13','10:40:00',2.61),('15128','2013-04-13','10:45:00',2.68),('15128','2013-04-13','10:50:00',2.68),('15128','2013-04-13','10:55:00',2.76),('15128','2013-04-13','11:00:00',2.8),('15128','2013-04-13','11:05:00',2.85),('15128','2013-04-13','11:10:00',2.9),('15128','2013-04-13','11:15:00',2.95),('15128','2013-04-13','11:20:00',3.03),('15128','2013-04-13','11:25:00',3.02),('15128','2013-04-13','11:30:00',3.13),('15128','2013-04-13','11:35:00',3.1),('15128','2013-04-13','11:40:00',3.25),('15128','2013-04-13','11:45:00',3.24),('15128','2013-04-13','11:50:00',3.39),('15128','2013-04-13','11:55:00',3.58),('15128','2013-04-13','12:00:00',3.64),('15128','2013-04-13','12:05:00',3.74),('15128','2013-04-13','12:10:00',3.75),('15128','2013-04-13','12:15:00',3.77),('15128','2013-04-13','12:20:00',3.82),('15128','2013-04-13','12:25:00',3.86),('15128','2013-04-13','12:30:00',3.91),('15128','2013-04-13','12:35:00',3.99),('15128','2013-04-13','12:40:00',4.01),('15128','2013-04-13','12:45:00',3.98),('15128','2013-04-13','12:50:00',4),('15128','2013-04-13','12:55:00',4.04),('15128','2013-04-13','13:00:00',4.15),('15128','2013-04-13','13:05:00',4.12),('15128','2013-04-13','13:10:00',4.11),('15128','2013-04-13','13:15:00',4.22),('15128','2013-04-13','13:20:00',4.18),('15128','2013-04-13','13:25:00',4.18),('15128','2013-04-13','13:30:00',4.15),('15128','2013-04-13','13:35:00',4.19),('15128','2013-04-13','13:40:00',3.87),('15128','2013-04-13','13:45:00',1.59),('15128','2013-04-13','13:50:00',2.6),('15128','2013-04-13','13:55:00',4.38),('15128','2013-04-13','14:00:00',4.14),('15128','2013-04-13','14:05:00',4.1),('15128','2013-04-13','14:10:00',4.1),('15128','2013-04-13','14:15:00',4.04),('15128','2013-04-13','14:20:00',4.03),('15128','2013-04-13','14:25:00',3.99),('15128','2013-04-13','14:30:00',3.98),('15128','2013-04-13','14:35:00',3.98),('15128','2013-04-13','14:40:00',3.96),('15128','2013-04-13','14:45:00',3.97),('15128','2013-04-13','14:50:00',4.01),('15128','2013-04-13','14:55:00',4.03),('15128','2013-04-13','15:00:00',4.03),('15128','2013-04-13','15:05:00',4),('15128','2013-04-13','15:10:00',4.01),('15128','2013-04-13','15:15:00',3.95),('15128','2013-04-13','15:20:00',3.85),('15128','2013-04-13','15:25:00',3.87),('15128','2013-04-13','15:30:00',3.84),('15128','2013-04-13','15:35:00',3.75),('15128','2013-04-13','15:40:00',3.73),('15128','2013-04-13','15:45:00',3.71),('15128','2013-04-13','15:50:00',3.63),('15128','2013-04-13','15:55:00',3.55),('15128','2013-04-13','16:00:00',3.47),('15128','2013-04-13','16:05:00',3.41),('15128','2013-04-13','16:10:00',3.36),('15128','2013-04-13','16:15:00',3.32),('15128','2013-04-13','16:20:00',3.27),('15128','2013-04-13','16:25:00',3.24),('15128','2013-04-13','16:30:00',3.19),('15128','2013-04-13','16:35:00',3.1),('15128','2013-04-13','16:40:00',3.05),('15128','2013-04-13','16:45:00',2.98),('15128','2013-04-13','16:50:00',2.9),('15128','2013-04-13','16:55:00',2.83),('15128','2013-04-13','17:00:00',2.76),('15128','2013-04-13','17:05:00',2.71),('15128','2013-04-13','17:10:00',2.63),('15128','2013-04-13','17:15:00',2.54),('15128','2013-04-13','17:20:00',2.41),('15128','2013-04-13','17:25:00',2.28),('15128','2013-04-13','17:30:00',2.18),('15128','2013-04-13','17:35:00',2.1),('15128','2013-04-13','17:40:00',2),('15128','2013-04-13','17:45:00',1.92),('15128','2013-04-13','17:50:00',1.83),('15128','2013-04-13','17:55:00',1.75),('15128','2013-04-13','18:00:00',1.7),('15128','2013-04-13','18:05:00',1.63),('15128','2013-04-13','18:10:00',1.54),('15128','2013-04-13','18:15:00',1.43),('15128','2013-04-13','18:20:00',1.33),('15128','2013-04-13','18:25:00',1.21),('15128','2013-04-13','18:30:00',1.09),('15128','2013-04-13','18:35:00',1),('15128','2013-04-12','08:45:00',1.11),('15128','2013-04-12','08:50:00',1.15),('15128','2013-04-12','08:55:00',1.22),('15128','2013-04-12','09:00:00',1.27),('15128','2013-04-12','09:05:00',1.38),('15128','2013-04-12','09:10:00',1.45),('15128','2013-04-12','09:15:00',1.49),('15128','2013-04-12','09:20:00',1.53),('15128','2013-04-12','09:25:00',1.62),('15128','2013-04-12','09:30:00',1.73),('15128','2013-04-12','09:35:00',1.73),('15128','2013-04-12','09:40:00',1.96),('15128','2013-04-12','09:45:00',2.05),('15128','2013-04-12','09:50:00',2.09),('15128','2013-04-12','09:55:00',2.2),('15128','2013-04-12','10:00:00',2.22),('15128','2013-04-12','10:05:00',2.35),('15128','2013-04-12','10:10:00',2.68),('15128','2013-04-12','10:15:00',2.81),('15128','2013-04-12','10:20:00',2.89),('15128','2013-04-12','10:25:00',2.99),('15128','2013-04-12','10:30:00',2.92),('15128','2013-04-12','10:35:00',2.81),('15128','2013-04-12','10:40:00',2.74),('15128','2013-04-12','10:45:00',2.07),('15128','2013-04-12','10:50:00',1.68),('15128','2013-04-12','10:55:00',2.45),('15128','2013-04-12','11:00:00',3.35),('15128','2013-04-12','11:05:00',2.11),('15128','2013-04-12','11:10:00',2.6),('15128','2013-04-12','11:15:00',3.46),('15128','2013-04-12','11:20:00',1.38),('15128','2013-04-12','11:25:00',3.29),('15128','2013-04-12','11:30:00',2.76),('15128','2013-04-12','11:35:00',2.37),('15128','2013-04-12','11:40:00',3.19),('15128','2013-04-12','11:45:00',1.5),('15128','2013-04-12','11:50:00',3.46),('15128','2013-04-12','11:55:00',4.01),('15128','2013-04-12','12:00:00',4.04),('15128','2013-04-12','12:05:00',2.62),('15128','2013-04-12','12:10:00',2.36),('15128','2013-04-12','12:15:00',4.18),('15128','2013-04-12','12:20:00',3.59),('15128','2013-04-12','12:25:00',4.32),('15128','2013-04-12','12:30:00',3.8),('15128','2013-04-12','12:35:00',4.2),('15128','2013-04-12','12:40:00',3.93),('15128','2013-04-12','12:45:00',4.11),('15128','2013-04-12','12:50:00',4.19),('15128','2013-04-12','12:55:00',4),('15128','2013-04-12','13:00:00',4.07),('15128','2013-04-12','13:05:00',3.96),('15128','2013-04-12','13:10:00',4.05),('15128','2013-04-12','13:15:00',3.99),('15128','2013-04-12','13:20:00',3.99),('15128','2013-04-12','13:25:00',4.06),('15128','2013-04-12','13:30:00',3.79),('15128','2013-04-12','13:35:00',3.85),('15128','2013-04-12','13:40:00',3.66),('15128','2013-04-12','13:45:00',3.71),('15128','2013-04-12','13:50:00',3.55),('15128','2013-04-12','13:55:00',3.52),('15128','2013-04-12','14:00:00',3.62),('15128','2013-04-12','14:05:00',3.63),('15128','2013-04-12','14:10:00',3.57),('15128','2013-04-12','14:15:00',3.58),('15128','2013-04-12','14:20:00',3.57),('15128','2013-04-12','14:25:00',3.8),('15128','2013-04-12','14:30:00',4.03),('15128','2013-04-12','14:35:00',4),('15128','2013-04-12','14:40:00',3.94),('15128','2013-04-12','14:45:00',3.84),('15128','2013-04-12','14:50:00',3.74),('15128','2013-04-12','14:55:00',3.56),('15128','2013-04-12','15:00:00',3.49),('15128','2013-04-12','15:05:00',3.55),('15128','2013-04-12','15:10:00',3.39),('15128','2013-04-12','15:15:00',3.08),('15128','2013-04-12','15:20:00',3.05),('15128','2013-04-12','15:25:00',3.11),('15128','2013-04-12','15:30:00',2.96),('15128','2013-04-12','15:35:00',3.18),('15128','2013-04-12','15:40:00',3.14),('15128','2013-04-12','15:45:00',3.22),('15128','2013-04-12','15:50:00',3.32),('15128','2013-04-12','15:55:00',2.87),('15128','2013-04-12','16:00:00',2.84),('15128','2013-04-12','16:05:00',2.84),('15128','2013-04-12','16:10:00',2.92),('15128','2013-04-12','16:15:00',2.76),('15128','2013-04-12','16:20:00',2.5),('15128','2013-04-12','16:25:00',2.27),('15128','2013-04-12','16:30:00',2.27),('15128','2013-04-12','16:35:00',1.97),('15128','2013-04-12','16:40:00',2.03),('15128','2013-04-12','16:45:00',2.14),('15128','2013-04-12','16:50:00',1.86),('15128','2013-04-12','16:55:00',1.49),('15128','2013-04-12','17:00:00',1.98),('15128','2013-04-12','17:05:00',2.73),('15128','2013-04-12','17:10:00',2.58),('15128','2013-04-12','17:15:00',2.17),('15128','2013-04-12','17:20:00',2.33),('15128','2013-04-12','17:25:00',2.24),('15128','2013-04-12','17:30:00',2.01),('15128','2013-04-12','17:35:00',2.1),('15128','2013-04-12','17:40:00',1.98),('15128','2013-04-12','17:45:00',1.73),('15128','2013-04-12','17:50:00',1.67),('15128','2013-04-12','17:55:00',1.69),('15128','2013-04-12','18:00:00',1.42),('15128','2013-04-12','18:05:00',1.54),('15128','2013-04-12','18:10:00',1.41),('15128','2013-04-12','18:15:00',1.46),('15128','2013-04-12','18:20:00',1.35),('15128','2013-04-12','18:25:00',1.27),('15128','2013-04-12','18:30:00',1.14),('15128','2013-04-12','18:35:00',1.02),('15128','2013-04-11','09:05:00',1.01),('15128','2013-04-11','09:10:00',1.58),('15128','2013-04-11','09:15:00',2.06),('15128','2013-04-11','09:20:00',1.43),('15128','2013-04-11','09:25:00',1.11),('15128','2013-04-11','09:30:00',1.35),('15128','2013-04-11','09:35:00',1.07),('15128','2013-04-11','09:50:00',1.15),('15128','2013-04-11','09:55:00',1.32),('15128','2013-04-11','10:00:00',1.09),('15128','2013-04-11','10:05:00',1.12),('15128','2013-04-11','10:10:00',1.04),('15128','2013-04-11','10:20:00',1.01),('15128','2013-04-11','10:25:00',1.57),('15128','2013-04-11','10:30:00',2),('15128','2013-04-11','10:35:00',1.83),('15128','2013-04-11','10:40:00',1.53),('15128','2013-04-11','10:45:00',1.57),('15128','2013-04-11','10:50:00',1.28),('15128','2013-04-11','10:55:00',1.65),('15128','2013-04-11','11:00:00',1.75),('15128','2013-04-11','11:05:00',2.28),('15128','2013-04-11','11:10:00',1.55),('15128','2013-04-11','11:15:00',3.73),('15128','2013-04-11','11:20:00',3.79),('15128','2013-04-11','11:25:00',3.19),('15128','2013-04-11','11:30:00',3.54),('15128','2013-04-11','11:35:00',3.41),('15128','2013-04-11','11:40:00',3.53),('15128','2013-04-11','11:45:00',3.13),('15128','2013-04-11','11:50:00',2.5),('15128','2013-04-11','11:55:00',3.76),('15128','2013-04-11','12:00:00',4.01),('15128','2013-04-11','12:05:00',3.86),('15128','2013-04-11','12:10:00',3.9),('15128','2013-04-11','12:15:00',4.04),('15128','2013-04-11','12:20:00',3.92),('15128','2013-04-11','12:25:00',4.05),('15128','2013-04-11','12:30:00',4.04),('15128','2013-04-11','12:35:00',4.01),('15128','2013-04-11','12:40:00',4.05),('15128','2013-04-11','12:45:00',3.88),('15128','2013-04-11','12:50:00',4.2),('15128','2013-04-11','12:55:00',4.28),('15128','2013-04-11','13:00:00',4.16),('15128','2013-04-11','13:05:00',4.2),('15128','2013-04-11','13:10:00',4.3),('15128','2013-04-11','13:15:00',4.25),('15128','2013-04-11','13:20:00',4.29),('15128','2013-04-11','13:25:00',4.24),('15128','2013-04-11','13:30:00',4.24),('15128','2013-04-11','13:35:00',4.27),('15128','2013-04-11','13:40:00',3.92),('15128','2013-04-11','13:45:00',4.14),('15128','2013-04-11','13:50:00',4.23),('15128','2013-04-11','13:55:00',4.25),('15128','2013-04-11','14:00:00',4.25),('15128','2013-04-11','14:05:00',4.24),('15128','2013-04-11','14:10:00',4.23),('15128','2013-04-11','14:15:00',4.24),('15128','2013-04-11','14:20:00',4.22),('15128','2013-04-11','14:25:00',4.19),('15128','2013-04-11','14:30:00',4.18),('15128','2013-04-11','14:35:00',4.13),('15128','2013-04-11','14:40:00',4.11),('15128','2013-04-11','14:45:00',4.1),('15128','2013-04-11','14:50:00',4.07),('15128','2013-04-11','14:55:00',4.04),('15128','2013-04-11','15:00:00',4.03),('15128','2013-04-11','15:05:00',4),('15128','2013-04-11','15:10:00',3.96),('15128','2013-04-11','15:15:00',3.94),('15128','2013-04-11','15:20:00',3.91),('15128','2013-04-11','15:25:00',3.86),('15128','2013-04-11','15:30:00',3.83),('15128','2013-04-11','15:35:00',3.8),('15128','2013-04-11','15:40:00',3.74),('15128','2013-04-11','15:45:00',3.69),('15128','2013-04-11','15:50:00',3.64),('15128','2013-04-11','15:55:00',3.62),('15128','2013-04-11','16:00:00',3.59),('15128','2013-04-11','16:05:00',3.57),('15128','2013-04-11','16:10:00',2.82),('15128','2013-04-11','16:15:00',3.4),('15128','2013-04-11','16:20:00',3.33),('15128','2013-04-11','16:25:00',3.28),('15128','2013-04-11','16:30:00',3.28),('15128','2013-04-11','16:35:00',2.88),('15128','2013-04-11','16:40:00',3.19),('15128','2013-04-11','16:45:00',3.08),('15128','2013-04-11','16:50:00',2.96),('15128','2013-04-11','16:55:00',2.56),('15128','2013-04-11','17:00:00',2.1),('15128','2013-04-11','17:05:00',3.17),('15128','2013-04-11','17:10:00',2.61),('15128','2013-04-11','17:15:00',2.84),('15128','2013-04-11','17:20:00',2.64),('15128','2013-04-11','17:25:00',2.65),('15128','2013-04-11','17:30:00',2.33),('15128','2013-04-11','17:35:00',2.06),('15128','2013-04-11','17:40:00',2.03),('15128','2013-04-11','17:45:00',1.91),('15128','2013-04-11','17:50:00',1.87),('15128','2013-04-11','17:55:00',1.73),('15128','2013-04-11','18:00:00',1.7),('15128','2014-03-27','08:05:00',1.04),('15128','2014-03-27','08:10:00',1.12),('15128','2014-03-27','08:15:00',1.19),('15128','2014-03-27','08:20:00',1.26),('15128','2014-03-27','08:25:00',1.36),('15128','2014-03-27','08:30:00',1.41),('15128','2014-03-27','08:35:00',1.48),('15128','2014-03-27','08:40:00',1.56),('15128','2014-03-27','08:45:00',1.56),('15128','2014-03-27','08:50:00',1.74),('15128','2014-03-27','08:55:00',1.88),('15128','2014-03-27','09:00:00',2.03),('15128','2014-03-27','09:05:00',2.02),('15128','2014-03-27','09:10:00',1.96),('15128','2014-03-27','09:15:00',2.19),('15128','2014-03-27','09:20:00',2.44),('15128','2014-03-27','09:25:00',1.87),('15128','2014-03-27','09:30:00',1.29),('15128','2014-03-27','09:35:00',1.56),('15128','2014-03-27','09:40:00',2.12),('15128','2014-03-27','09:45:00',2.56),('15128','2014-03-27','09:50:00',2.43),('15128','2014-03-27','09:55:00',2.64),('15128','2014-03-27','10:00:00',2.29),('15128','2014-03-27','10:05:00',1.54),('15128','2014-03-27','10:10:00',2.13),('15128','2014-03-27','10:15:00',2.58),('15128','2014-03-27','10:20:00',2.49),('15128','2014-03-27','10:25:00',2.23),('15128','2014-03-27','10:30:00',2.2),('15128','2014-03-27','10:35:00',2.97),('15128','2014-03-27','10:40:00',3.06),('15128','2014-03-27','10:45:00',3.05),('15128','2014-03-27','10:50:00',3.12),('15128','2014-03-27','10:55:00',3.13),('15128','2014-03-27','11:00:00',3.3),('15128','2014-03-27','11:05:00',3.42),('15128','2014-03-27','11:10:00',3.59),('15128','2014-03-27','11:15:00',3.64),('15128','2014-03-27','11:20:00',3.67),('15128','2014-03-27','11:25:00',3.68),('15128','2014-03-27','11:30:00',3.71),('15128','2014-03-27','11:35:00',3.74),('15128','2014-03-27','11:40:00',3.77),('15128','2014-03-27','11:45:00',3.79),('15128','2014-03-27','11:50:00',3.84),('15128','2014-03-27','11:55:00',3.3),('15128','2014-03-27','12:00:00',4.01),('15128','2014-03-27','12:05:00',4.04),('15128','2014-03-27','12:10:00',3.95),('15128','2014-03-27','12:15:00',4.06),('15128','2014-03-27','12:20:00',4.09),('15128','2014-03-27','12:25:00',2.55),('15128','2014-03-27','12:30:00',1.21),('15128','2014-03-27','12:35:00',2.83),('15128','2014-03-27','12:40:00',4.52),('15128','2014-03-27','12:45:00',2.19),('15128','2014-03-27','12:50:00',3.57),('15128','2014-03-27','12:55:00',3.16),('15128','2014-03-27','13:00:00',1.9),('15128','2014-03-27','13:05:00',3.07),('15128','2014-03-27','13:10:00',3.49),('15128','2014-03-27','13:15:00',2.24),('15128','2014-03-27','13:20:00',2.98),('15128','2014-03-27','13:25:00',2.38),('15128','2014-03-27','13:30:00',3.01),('15128','2014-03-27','13:35:00',3.98),('15128','2014-03-27','13:40:00',4.05),('15128','2014-03-27','13:45:00',3.98),('15128','2014-03-27','13:50:00',3.93),('15128','2014-03-27','13:55:00',3.93),('15128','2014-03-27','14:00:00',3.87),('15128','2014-03-27','14:05:00',3.83),('15128','2014-03-27','14:10:00',3.81),('15128','2014-03-27','14:15:00',3.79),('15128','2014-03-27','14:20:00',3.76),('15128','2014-03-27','14:25:00',3.72),('15128','2014-03-27','14:30:00',3.67),('15128','2014-03-27','14:35:00',3.64),('15128','2014-03-27','14:40:00',3.66),('15128','2014-03-27','14:45:00',3.61),('15128','2014-03-27','14:50:00',3.57),('15128','2014-03-27','14:55:00',3.54),('15128','2014-03-27','15:00:00',3.46),('15128','2014-03-27','15:05:00',3.4),('15128','2014-03-27','15:10:00',3.33),('15128','2014-03-27','15:15:00',3.26),('15128','2014-03-27','15:20:00',3.21),('15128','2014-03-27','15:25:00',3.15),('15128','2014-03-27','15:30:00',3.1),('15128','2014-03-27','15:35:00',3.16),('15128','2014-03-27','15:40:00',3.04),('15128','2014-03-27','15:45:00',3),('15128','2014-03-27','15:50:00',3.1),('15128','2014-03-27','15:55:00',3.21),('15128','2014-03-27','16:00:00',3.2),('15128','2014-03-27','16:05:00',2.99),('15128','2014-03-27','16:10:00',2.73),('15128','2014-03-27','16:15:00',2.52),('15128','2014-03-27','16:20:00',1.75),('15128','2014-03-27','16:30:00',1.28),('15128','2014-03-27','16:50:00',1.74),('15128','2014-03-27','16:55:00',1.75),('15128','2014-03-27','17:00:00',1.59),('15128','2014-03-27','17:05:00',1.24),('15128','2014-03-27','17:10:00',1.05),('15128','2014-03-27','17:15:00',1.03),('15128','2014-03-27','17:20:00',1.14),('15128','2014-03-27','17:25:00',1.03),('15128','2013-04-10','08:45:00',1.09),('15128','2013-04-10','08:50:00',1.15),('15128','2013-04-10','08:55:00',1.21),('15128','2013-04-10','09:00:00',1.26),('15128','2013-04-10','09:05:00',1.34),('15128','2013-04-10','09:10:00',1.43),('15128','2013-04-10','09:15:00',1.48),('15128','2013-04-10','09:20:00',1.56),('15128','2013-04-10','09:25:00',1.66),('15128','2013-04-10','09:30:00',1.71),('15128','2013-04-10','09:35:00',1.77),('15128','2013-04-10','09:40:00',1.92),('15128','2013-04-10','09:45:00',1.92),('15128','2013-04-10','09:50:00',1.56),('15128','2013-04-10','09:55:00',2.16),('15128','2013-04-10','10:00:00',1.04),('15128','2013-04-10','10:05:00',2.25),('15128','2013-04-10','10:10:00',2.61),('15128','2013-04-10','10:15:00',2.63),('15128','2013-04-10','10:20:00',2.55),('15128','2013-04-10','10:25:00',1.75),('15128','2013-04-10','10:30:00',2.89),('15128','2013-04-10','10:35:00',2.79),('15128','2013-04-10','10:40:00',2.02),('15128','2013-04-10','10:50:00',1.14),('15128','2013-04-10','10:55:00',1.33),('15128','2013-04-10','11:00:00',2.96),('15128','2013-04-10','11:05:00',3.63),('15128','2013-04-10','11:10:00',3.54),('15128','2013-04-10','11:15:00',3.58),('15128','2013-04-10','11:20:00',2.5),('15128','2013-04-10','11:25:00',1.75),('15128','2013-04-10','11:30:00',1.74),('15128','2013-04-10','11:35:00',1.6),('15128','2013-04-10','11:40:00',1.33),('15128','2013-04-10','11:45:00',1.9),('15128','2013-04-10','11:50:00',4.32),('15128','2013-04-10','11:55:00',4.47),('15128','2013-04-10','12:00:00',4.3),('15128','2013-04-10','12:05:00',4.24),('15128','2013-04-10','12:10:00',4.25),('15128','2013-04-10','12:15:00',4.31),('15128','2013-04-10','12:20:00',4.42),('15128','2013-04-10','12:25:00',2.94),('15128','2013-04-10','12:30:00',2.09),('15128','2013-04-10','12:35:00',4.06),('15128','2013-04-10','12:40:00',1.26),('15128','2013-04-10','12:45:00',4.57),('15128','2013-04-10','12:50:00',4.42),('15128','2013-04-10','12:55:00',4.33),('15128','2013-04-10','13:00:00',2.2),('15128','2013-04-10','13:05:00',4.73),('15128','2013-04-10','13:10:00',4.15),('15128','2013-04-10','13:15:00',2.99),('15128','2013-04-10','13:20:00',4.53),('15128','2013-04-10','13:25:00',3.26),('15128','2013-04-10','13:30:00',4.11),('15128','2013-04-10','13:35:00',4.43),('15128','2013-04-10','13:40:00',4.43),('15128','2013-04-10','13:45:00',4.44),('15128','2013-04-10','13:50:00',4.12),('15128','2013-04-10','13:55:00',3.77),('15128','2013-04-10','14:00:00',4.49),('15128','2013-04-10','14:05:00',4.31),('15128','2013-04-10','14:10:00',4.38),('15128','2013-04-10','14:15:00',4.39),('15128','2013-04-10','14:20:00',4.28),('15128','2013-04-10','14:25:00',4.39),('15128','2013-04-10','14:30:00',4.34),('15128','2013-04-10','14:35:00',4.33),('15128','2013-04-10','14:40:00',2.73),('15128','2013-04-10','14:45:00',2.32),('15128','2013-04-10','14:50:00',3.93),('15128','2013-04-10','14:55:00',4.24),('15128','2013-04-10','15:00:00',3.89),('15128','2013-04-10','15:05:00',3.98),('15128','2013-04-10','15:10:00',3.99),('15128','2013-04-10','15:15:00',4),('15128','2013-04-10','15:20:00',3.95),('15128','2013-04-10','15:25:00',3.92),('15128','2013-04-10','15:30:00',3.87),('15128','2013-04-10','15:35:00',3.86),('15128','2013-04-10','15:40:00',3.82),('15128','2013-04-10','15:45:00',3.77),('15128','2013-04-10','15:50:00',3.73),('15128','2013-04-10','15:55:00',3.69),('15128','2013-04-10','16:00:00',3.65),('15128','2013-04-10','16:05:00',3.58),('15128','2013-04-10','16:10:00',3.52),('15128','2013-04-10','16:15:00',3.46),('15128','2013-04-10','16:20:00',3.42),('15128','2013-04-10','16:25:00',3.36),('15128','2013-04-10','16:30:00',3.29),('15128','2013-04-10','16:35:00',3.22),('15128','2013-04-10','16:40:00',3.17),('15128','2013-04-10','16:45:00',3.1),('15128','2013-04-10','16:50:00',3.05),('15128','2013-04-10','16:55:00',2.96),('15128','2013-04-10','17:00:00',2.88),('15128','2013-04-10','17:05:00',2.81),('15128','2013-04-10','17:10:00',2.7),('15128','2013-04-10','17:15:00',2.6),('15128','2013-04-10','17:20:00',2.44),('15128','2013-04-10','17:25:00',2.36),('15128','2013-04-10','17:30:00',2.24),('15128','2013-04-10','17:35:00',2.08),('15128','2013-04-10','17:40:00',2.03),('15128','2013-04-10','17:45:00',1.98),('15128','2013-04-10','17:50:00',1.89),('15128','2013-04-10','17:55:00',1.81),('15128','2013-04-10','18:00:00',1.68),('15128','2013-04-10','18:05:00',1.6),('15128','2013-04-10','18:10:00',1.44),('15128','2013-04-10','18:15:00',1.48),('15128','2013-04-10','18:20:00',1.38),('15128','2013-04-10','18:25:00',1.24),('15128','2013-04-10','18:30:00',1.09),('15128','2013-04-10','18:35:00',1.05),('15128','2013-04-09','08:50:00',1.16),('15128','2013-04-09','08:55:00',1.25),('15128','2013-04-09','09:00:00',1.28),('15128','2013-04-09','09:05:00',1.38),('15128','2013-04-09','09:10:00',1.32),('15128','2013-04-09','09:15:00',1.2),('15128','2013-04-09','09:20:00',1.56),('15128','2013-04-09','09:25:00',1.65),('15128','2013-04-09','09:30:00',1.24),('15128','2013-04-09','09:35:00',1.39),('15128','2013-04-09','09:40:00',1.9),('15128','2013-04-09','09:45:00',2.09),('15128','2013-04-09','09:50:00',1.97),('15128','2013-04-09','09:55:00',1.7),('15128','2013-04-09','10:00:00',2.3),('15128','2013-04-09','10:05:00',2.52),('15128','2013-04-09','10:10:00',2.7),('15128','2013-04-09','10:15:00',2.65),('15128','2013-04-09','10:20:00',2.61),('15128','2013-04-09','10:25:00',2.54),('15128','2013-04-09','10:30:00',2.59),('15128','2013-04-09','10:35:00',2.93),('15128','2013-04-09','10:40:00',3.03),('15128','2013-04-09','10:45:00',2.87),('15128','2013-04-09','10:50:00',1.61),('15128','2013-04-09','10:55:00',2.66),('15128','2013-04-09','11:00:00',1.38),('15128','2013-04-09','11:05:00',1.54),('15128','2013-04-09','11:10:00',1.76),('15128','2013-04-09','11:15:00',1),('15128','2013-04-09','11:20:00',2.33),('15128','2013-04-09','11:25:00',3.14),('15128','2013-04-09','11:30:00',3.06),('15128','2013-04-09','11:35:00',2.89),('15128','2013-04-09','11:40:00',2.37),('15128','2013-04-09','11:45:00',3.18),('15128','2013-04-09','11:50:00',2.33),('15128','2013-04-09','11:55:00',3.81),('15128','2013-04-09','12:00:00',2.05),('15128','2013-04-09','12:05:00',2.43),('15128','2013-04-09','12:10:00',4.38),('15128','2013-04-09','12:15:00',4.8),('15128','2013-04-09','12:20:00',4.76),('15128','2013-04-09','12:25:00',4.34),('15128','2013-04-09','12:30:00',4.32),('15128','2013-04-09','12:35:00',3.97),('15128','2013-04-09','12:40:00',2.74),('15128','2013-04-09','12:45:00',3.98),('15128','2013-04-09','12:50:00',4.46),('15128','2013-04-09','12:55:00',4.51),('15128','2013-04-09','13:00:00',4.34),('15128','2013-04-09','13:05:00',3.58),('15128','2013-04-09','13:10:00',3.87),('15128','2013-04-09','13:15:00',3.86),('15128','2013-04-09','13:20:00',4.53),('15128','2013-04-09','13:25:00',3.67),('15128','2013-04-09','13:30:00',3.09),('15128','2013-04-09','13:35:00',4.72),('15128','2013-04-09','13:40:00',4.68),('15128','2013-04-09','13:45:00',4.6),('15128','2013-04-09','13:50:00',3.96),('15128','2013-04-09','13:55:00',3.38),('15128','2013-04-09','14:00:00',2.23),('15128','2013-04-09','14:05:00',4.93),('15128','2013-04-09','14:10:00',3.2),('15128','2013-04-09','14:15:00',4.38),('15128','2013-04-09','14:20:00',2.54),('15128','2013-04-09','14:25:00',2.08),('15128','2013-04-09','14:30:00',2.39),('15128','2013-04-09','14:35:00',4.23),('15128','2013-04-09','14:40:00',1.94),('15128','2013-04-09','14:45:00',4.7),('15128','2013-04-09','14:50:00',2.04),('15128','2013-04-09','14:55:00',4.67),('15128','2013-04-09','15:00:00',4.39),('15128','2013-04-09','15:05:00',3.46),('15128','2013-04-09','15:10:00',4.09),('15128','2013-04-09','15:15:00',4.23),('15128','2013-04-09','15:20:00',3.5),('15128','2013-04-09','15:25:00',3.25),('15128','2013-04-09','15:30:00',3.79),('15128','2013-04-09','15:35:00',3.94),('15128','2013-04-09','15:40:00',3.88),('15128','2013-04-09','15:45:00',3.9),('15128','2013-04-09','15:50:00',2.98),('15128','2013-04-09','15:55:00',3.76),('15128','2013-04-09','16:00:00',3.68),('15128','2013-04-09','16:05:00',3.72),('15128','2013-04-09','16:10:00',3.39),('15128','2013-04-09','16:15:00',3),('15128','2013-04-09','16:20:00',1.75),('15128','2013-04-09','16:25:00',1.73),('15128','2013-04-09','16:30:00',1.64),('15128','2013-04-09','16:35:00',2.31),('15128','2013-04-09','16:40:00',1.62),('15128','2013-04-09','16:45:00',1.9),('15128','2013-04-09','16:50:00',1.39),('15128','2013-04-09','16:55:00',1.88),('15128','2013-04-09','17:05:00',1.52),('15128','2013-04-09','17:10:00',1.15),('15128','2013-04-09','17:15:00',2.69),('15128','2013-04-09','17:20:00',2.94),('15128','2013-04-09','17:25:00',2.85),('15128','2013-04-09','17:30:00',2.3),('15128','2013-04-09','17:35:00',1.16),('15128','2013-04-09','17:40:00',2.08),('15128','2013-04-09','17:45:00',2.29),('15128','2013-04-09','17:50:00',2.15),('15128','2013-04-09','17:55:00',1.71),('15128','2013-04-09','18:00:00',2.03),('15128','2013-04-09','18:05:00',1.79),('15128','2013-04-09','18:10:00',1.71),('15128','2013-04-09','18:15:00',1.59),('15128','2013-04-09','18:20:00',1.38),('15128','2013-04-09','18:25:00',1.42),('15128','2013-04-09','18:30:00',1.09),('15128','2013-04-09','18:35:00',1.49),('15128','2013-04-09','18:40:00',1.24),('15128','2013-04-08','08:45:00',1.09),('15128','2013-04-08','08:50:00',1.26),('15128','2013-04-08','08:55:00',1.29),('15128','2013-04-08','09:00:00',1.44),('15128','2013-04-08','09:25:00',1.08),('15128','2013-04-08','09:30:00',2.08),('15128','2013-04-08','09:35:00',2.35),('15128','2013-04-08','09:40:00',1.33),('15128','2013-04-08','09:45:00',1.31),('15128','2013-04-08','09:50:00',2.22),('15128','2013-04-08','09:55:00',2.08),('15128','2013-04-08','10:00:00',2.36),('15128','2013-04-08','10:05:00',1.36),('15128','2013-04-08','10:10:00',2.55),('15128','2013-04-08','10:15:00',2.33),('15128','2013-04-08','10:20:00',2.26),('15128','2013-04-08','10:25:00',1.23),('15128','2013-04-08','10:30:00',2.77),('15128','2013-04-08','10:35:00',3.5),('15128','2013-04-08','10:40:00',3.13),('15128','2013-04-08','10:45:00',2.06),('15128','2013-04-08','10:50:00',3.57),('15128','2013-04-08','10:55:00',2.97),('15128','2013-04-08','11:00:00',2.82),('15128','2013-04-08','11:05:00',4.02),('15128','2013-04-08','11:10:00',2.46),('15128','2013-04-08','11:15:00',2.9),('15128','2013-04-08','11:20:00',2.95),('15128','2013-04-08','11:25:00',2.1),('15128','2013-04-08','11:30:00',3.76),('15128','2013-04-08','11:35:00',1.99),('15128','2013-04-08','11:40:00',1.21),('15128','2013-04-08','11:50:00',2.67),('15128','2013-04-08','11:55:00',3.16),('15128','2013-04-08','12:00:00',4.76),('15128','2013-04-08','12:05:00',4.05),('15128','2013-04-08','12:10:00',4.47),('15128','2013-04-08','12:15:00',4.37),('15128','2013-04-08','12:20:00',2.88),('15128','2013-04-08','12:25:00',3.09),('15128','2013-04-08','12:30:00',2.6),('15128','2013-04-08','12:35:00',1.74),('15128','2013-04-08','12:40:00',1.37),('15128','2013-04-08','12:45:00',2.75),('15128','2013-04-08','12:50:00',1.5),('15128','2013-04-08','12:55:00',3.6),('15128','2013-04-08','13:00:00',4.17),('15128','2013-04-08','13:05:00',3.03),('15128','2013-04-08','13:10:00',2.68),('15128','2013-04-08','13:15:00',3.4),('15128','2013-04-08','13:20:00',3.88),('15128','2013-04-08','13:25:00',3.24),('15128','2013-04-08','13:30:00',1.47),('15128','2013-04-08','13:35:00',2.29),('15128','2013-04-08','13:40:00',3.19),('15128','2013-04-08','13:45:00',4.1),('15128','2013-04-08','13:50:00',2.91),('15128','2013-04-08','13:55:00',4.18),('15128','2013-04-08','14:00:00',4.1),('15128','2013-04-08','14:05:00',4.51),('15128','2013-04-08','14:10:00',4.29),('15128','2013-04-08','14:15:00',3.33),('15128','2013-04-08','14:20:00',3.28),('15128','2013-04-08','14:25:00',3.71),('15128','2013-04-08','14:30:00',3.94),('15128','2013-04-08','14:35:00',4.22),('15128','2013-04-08','14:40:00',3.9),('15128','2013-04-08','14:45:00',3.63),('15128','2013-04-08','14:50:00',4.13),('15128','2013-04-08','14:55:00',4.16),('15128','2013-04-08','15:00:00',4.29),('15128','2013-04-08','15:05:00',4.09),('15128','2013-04-08','15:10:00',3.97),('15128','2013-04-08','15:15:00',3.99),('15128','2013-04-08','15:20:00',4.13),('15128','2013-04-08','15:25:00',4.15),('15128','2013-04-08','15:30:00',4.1),('15128','2013-04-08','15:35:00',3.94),('15128','2013-04-08','15:40:00',4),('15128','2013-04-08','15:45:00',3.87),('15128','2013-04-08','15:50:00',3.58),('15128','2013-04-08','15:55:00',3.22),('15128','2013-04-08','16:00:00',3.33),('15128','2013-04-08','16:05:00',3.77),('15128','2013-04-08','16:10:00',3.58),('15128','2013-04-08','16:15:00',3.35),('15128','2013-04-08','16:20:00',3.4),('15128','2013-04-08','16:25:00',3.19),('15128','2013-04-08','16:30:00',2.86),('15128','2013-04-08','16:35:00',2.99),('15128','2013-04-08','16:40:00',2.61),('15128','2013-04-08','16:45:00',3.1),('15128','2013-04-08','16:50:00',3.01),('15128','2013-04-08','16:55:00',2.68),('15128','2013-04-08','17:00:00',2.86),('15128','2013-04-08','17:05:00',3.02),('15128','2013-04-08','17:10:00',2.6),('15128','2013-04-08','17:15:00',2.67),('15128','2013-04-08','17:20:00',2.58),('15128','2013-04-08','17:25:00',2.29),('15128','2013-04-08','17:30:00',2),('15128','2013-04-08','17:35:00',1.59),('15128','2013-04-08','17:40:00',1.33),('15128','2013-04-08','17:45:00',1.09),('15128','2013-04-08','17:55:00',1.14),('15128','2013-04-08','18:00:00',1.28),('15128','2013-04-08','18:05:00',1.03),('15128','2013-04-08','18:10:00',1.14),('15128','2013-04-08','18:15:00',1.38),('15128','2013-04-07','08:55:00',1.07),('15128','2013-04-07','09:05:00',1.2),('15128','2013-04-07','09:10:00',1.24),('15128','2013-04-07','09:15:00',1.27),('15128','2013-04-07','09:20:00',1.32),('15128','2013-04-07','09:25:00',1.42),('15128','2013-04-07','09:30:00',1.79),('15128','2013-04-07','09:35:00',1.95),('15128','2013-04-07','09:40:00',2.02),('15128','2013-04-07','09:45:00',1.95),('15128','2013-04-07','09:50:00',1.03),('15128','2013-04-07','09:55:00',1.7),('15128','2013-04-07','10:00:00',2.18),('15128','2013-04-07','10:05:00',1.69),('15128','2013-04-07','10:10:00',1.99),('15128','2013-04-07','10:15:00',2.24),('15128','2013-04-07','10:20:00',2.37),('15128','2013-04-07','10:25:00',2.23),('15128','2013-04-07','10:30:00',2.4),('15128','2013-04-07','10:35:00',2.47),('15128','2013-04-07','10:40:00',2.66),('15128','2013-04-07','10:45:00',2.74),('15128','2013-04-07','10:50:00',2.84),('15128','2013-04-07','10:55:00',2.7),('15128','2013-04-07','11:00:00',2.66),('15128','2013-04-07','11:05:00',2.63),('15128','2013-04-07','11:10:00',2.74),('15128','2013-04-07','11:15:00',2.44),('15128','2013-04-07','11:20:00',2.08),('15128','2013-04-07','11:25:00',2.16),('15128','2013-04-07','11:30:00',2.41),('15128','2013-04-07','11:35:00',2.43),('15128','2013-04-07','11:40:00',2.44),('15128','2013-04-07','11:45:00',2.55),('15128','2013-04-07','11:50:00',2.5),('15128','2013-04-07','11:55:00',2.6),('15128','2013-04-07','12:00:00',2.36),('15128','2013-04-07','12:05:00',2.5),('15128','2013-04-07','12:10:00',2.94),('15128','2013-04-07','12:15:00',2.98),('15128','2013-04-07','12:20:00',2.95),('15128','2013-04-07','12:25:00',3.07),('15128','2013-04-07','12:30:00',3.12),('15128','2013-04-07','12:35:00',3.28),('15128','2013-04-07','12:40:00',3.32),('15128','2013-04-07','12:45:00',3.09),('15128','2013-04-07','12:50:00',3.28),('15128','2013-04-07','12:55:00',3.54),('15128','2013-04-07','13:00:00',3.66),('15128','2013-04-07','13:05:00',3.02),('15128','2013-04-07','13:10:00',3.68),('15128','2013-04-07','13:15:00',3.1),('15128','2013-04-07','13:20:00',3.88),('15128','2013-04-07','13:25:00',3.67),('15128','2013-04-07','13:30:00',2.47),('15128','2013-04-07','13:35:00',1.79),('15128','2013-04-07','13:40:00',3.1),('15128','2013-04-07','13:45:00',3.72),('15128','2013-04-07','13:50:00',3.21),('15128','2013-04-07','13:55:00',3.45),('15128','2013-04-07','14:00:00',3.77),('15128','2013-04-07','14:05:00',3.92),('15128','2013-04-07','14:10:00',4.21),('15128','2013-04-07','14:15:00',3.34),('15128','2013-04-07','14:20:00',3.88),('15128','2013-04-07','14:25:00',3.96),('15128','2013-04-07','14:30:00',3.54),('15128','2013-04-07','14:35:00',3.84),('15128','2013-04-07','14:40:00',3.9),('15128','2013-04-07','14:45:00',4.08),('15128','2013-04-07','14:50:00',4.11),('15128','2013-04-07','14:55:00',3.87),('15128','2013-04-07','15:00:00',3.26),('15128','2013-04-07','15:05:00',3.83),('15128','2013-04-07','15:10:00',3.5),('15128','2013-04-07','15:15:00',3.52),('15128','2013-04-07','15:20:00',3.96),('15128','2013-04-07','15:25:00',3.99),('15128','2013-04-07','15:30:00',3.89),('15128','2013-04-07','15:35:00',3.86),('15128','2013-04-07','15:40:00',3.84),('15128','2013-04-07','15:45:00',3.82),('15128','2013-04-07','15:50:00',3.74),('15128','2013-04-07','15:55:00',3.69),('15128','2013-04-07','16:00:00',3.64),('15128','2013-04-07','16:05:00',3.39),('15128','2013-04-07','16:10:00',3.46),('15128','2013-04-07','16:15:00',3.55),('15128','2013-04-07','16:20:00',3.43),('15128','2013-04-07','16:25:00',3.35),('15128','2013-04-07','16:30:00',3.32),('15128','2013-04-07','16:35:00',3.24),('15128','2013-04-07','16:40:00',3.19),('15128','2013-04-07','16:45:00',3.12),('15128','2013-04-07','16:50:00',3.05),('15128','2013-04-07','16:55:00',2.97),('15128','2013-04-07','17:00:00',2.93),('15128','2013-04-07','17:05:00',2.84),('15128','2013-04-07','17:10:00',2.73),('15128','2013-04-07','17:15:00',2.6),('15128','2013-04-07','17:20:00',2.45),('15128','2013-04-07','17:25:00',2.43),('15128','2013-04-07','17:30:00',2.21),('15128','2013-04-07','17:35:00',2.06),('15128','2013-04-07','17:40:00',1.77),('15128','2013-04-07','17:45:00',1.77),('15128','2013-04-07','17:50:00',1.36),('15128','2013-04-07','17:55:00',1.4),('15128','2013-04-07','18:00:00',1.46),('15128','2013-04-07','18:10:00',1.01),('15128','2013-04-07','18:15:00',1.65),('15128','2013-04-07','18:20:00',1.77),('15128','2013-04-07','18:25:00',1.28),('15128','2013-04-06','08:55:00',1.01),('15128','2013-04-06','09:00:00',1.07),('15128','2013-04-06','09:05:00',1.09),('15128','2013-04-06','09:10:00',1.13),('15128','2013-04-06','09:15:00',1.1),('15128','2013-04-06','09:20:00',1.12),('15128','2013-04-06','09:25:00',1.13),('15128','2013-04-06','09:30:00',1.26),('15128','2013-04-06','09:35:00',1.42),('15128','2013-04-06','09:40:00',1.51),('15128','2013-04-06','09:45:00',1.53),('15128','2013-04-06','09:50:00',1.53),('15128','2013-04-06','09:55:00',1.41),('15128','2013-04-06','10:00:00',1.33),('15128','2013-04-06','10:05:00',1.56),('15128','2013-04-06','10:10:00',1.63),('15128','2013-04-06','10:15:00',1.76),('15128','2013-04-06','10:20:00',2.11),('15128','2013-04-06','10:25:00',2.25),('15128','2013-04-06','10:30:00',2.28),('15128','2013-04-06','10:35:00',2.37),('15128','2013-04-06','10:40:00',2.47),('15128','2013-04-06','10:45:00',2.29),('15128','2013-04-06','10:50:00',2.21),('15128','2013-04-06','10:55:00',2.34),('15128','2013-04-06','11:00:00',2.19),('15128','2013-04-06','11:05:00',2.16),('15128','2013-04-06','11:10:00',2.26),('15128','2013-04-06','11:15:00',2.04),('15128','2013-04-06','11:20:00',1.92),('15128','2013-04-06','11:25:00',1.98),('15128','2013-04-06','11:30:00',2.32),('15128','2013-04-06','11:35:00',3.05),('15128','2013-04-06','11:40:00',3.6),('15128','2013-04-06','11:45:00',3.6),('15128','2013-04-06','11:50:00',3.78),('15128','2013-04-06','11:55:00',3.56),('15128','2013-04-06','12:00:00',3.11),('15128','2013-04-06','12:05:00',2.71),('15128','2013-04-06','12:10:00',2.76),('15128','2013-04-06','12:15:00',2.75),('15128','2013-04-06','12:20:00',2.78),('15128','2013-04-06','12:25:00',3.07),('15128','2013-04-06','12:30:00',3.13),('15128','2013-04-06','12:35:00',3.4),('15128','2013-04-06','12:40:00',3.36),('15128','2013-04-06','12:45:00',3.02),('15128','2013-04-06','12:50:00',3.36),('15128','2013-04-06','12:55:00',3.11),('15128','2013-04-06','13:00:00',3.13),('15128','2013-04-06','13:05:00',3.09),('15128','2013-04-06','13:10:00',2.99),('15128','2013-04-06','13:15:00',3.31),('15128','2013-04-06','13:20:00',3.27),('15128','2013-04-06','13:25:00',3.2),('15128','2013-04-06','13:30:00',2.97),('15128','2013-04-06','13:35:00',3.11),('15128','2013-04-06','13:40:00',3.52),('15128','2013-04-06','13:45:00',3.92),('15128','2013-04-06','13:50:00',3.62),('15128','2013-04-06','13:55:00',3.23),('15128','2013-04-06','14:00:00',2.76),('15128','2013-04-06','14:05:00',2.86),('15128','2013-04-06','14:10:00',2.83),('15128','2013-04-06','14:15:00',2.95),('15128','2013-04-06','14:20:00',3.12),('15128','2013-04-06','14:25:00',3.06),('15128','2013-04-06','14:30:00',3.12),('15128','2013-04-06','14:35:00',2.84),('15128','2013-04-06','14:40:00',2.75),('15128','2013-04-06','14:45:00',2.57),('15128','2013-04-06','14:50:00',2.39),('15128','2013-04-06','14:55:00',2.53),('15128','2013-04-06','15:00:00',2.56),('15128','2013-04-06','15:05:00',2.59),('15128','2013-04-06','15:10:00',2.69),('15128','2013-04-06','15:15:00',2.74),('15128','2013-04-06','15:20:00',2.86),('15128','2013-04-06','15:25:00',2.88),('15128','2013-04-06','15:30:00',2.79),('15128','2013-04-06','15:35:00',2.85),('15128','2013-04-06','15:40:00',2.85),('15128','2013-04-06','15:45:00',2.8),('15128','2013-04-06','15:50:00',2.46),('15128','2013-04-06','15:55:00',1.59),('15128','2013-04-06','16:00:00',1.35),('15128','2013-04-06','16:05:00',1.31),('15128','2013-04-06','16:10:00',1.36),('15128','2013-04-06','16:15:00',1.34),('15128','2013-04-06','16:20:00',1.72),('15128','2013-04-06','16:25:00',1.97),('15128','2013-04-06','16:30:00',1.46),('15128','2013-04-06','16:35:00',1.46),('15128','2013-04-06','16:40:00',1.36),('15128','2013-04-06','16:45:00',1.12),('15128','2013-04-06','16:50:00',1.11),('15128','2013-04-06','16:55:00',1.14),('15128','2013-04-06','17:00:00',1.19),('15128','2013-04-06','17:05:00',1.71),('15128','2013-04-06','17:10:00',1.27),('15128','2013-04-06','17:15:00',1.82),('15128','2013-04-06','17:20:00',2.09),('15128','2013-04-06','17:25:00',1.45),('15128','2013-04-06','17:30:00',1.76),('15128','2013-04-06','17:40:00',1.84),('15128','2013-04-06','17:45:00',1.76),('15128','2013-04-06','17:50:00',1.27),('15128','2013-04-05','08:50:00',1.08),('15128','2013-04-05','08:55:00',1.17),('15128','2013-04-05','09:00:00',1.23),('15128','2013-04-05','09:05:00',1.28),('15128','2013-04-05','09:10:00',1.34),('15128','2013-04-05','09:15:00',1.44),('15128','2013-04-05','09:20:00',1.52),('15128','2013-04-05','09:25:00',1.56),('15128','2013-04-05','09:30:00',1.64),('15128','2013-04-05','09:35:00',1.73),('15128','2013-04-05','09:40:00',1.79),('15128','2013-04-05','09:45:00',1.88),('15128','2013-04-05','09:50:00',1.96),('15128','2013-04-05','09:55:00',1.67),('15128','2013-04-05','10:00:00',1.64),('15128','2013-04-05','10:05:00',1.92),('15128','2013-04-05','10:15:00',1.44),('15128','2013-04-05','10:25:00',1.84),('15128','2013-04-05','10:30:00',2.41),('15128','2013-04-05','10:35:00',2.49),('15128','2013-04-05','10:40:00',2.43),('15128','2013-04-05','10:45:00',2.49),('15128','2013-04-05','10:50:00',2.55),('15128','2013-04-05','10:55:00',2.65),('15128','2013-04-05','11:00:00',2.72),('15128','2013-04-05','11:05:00',2.78),('15128','2013-04-05','11:10:00',2.92),('15128','2013-04-05','11:15:00',2.9),('15128','2013-04-05','11:20:00',2.95),('15128','2013-04-05','11:25:00',3.12),('15128','2013-04-05','11:30:00',3.18),('15128','2013-04-05','11:35:00',3.37),('15128','2013-04-05','11:40:00',3.27),('15128','2013-04-05','11:45:00',3.32),('15128','2013-04-05','11:50:00',3.35),('15128','2013-04-05','11:55:00',3.4),('15128','2013-04-05','12:00:00',3.58),('15128','2013-04-05','12:05:00',3.72),('15128','2013-04-05','12:10:00',3.84),('15128','2013-04-05','12:15:00',3.88),('15128','2013-04-05','12:20:00',3.82),('15128','2013-04-05','12:25:00',3.84),('15128','2013-04-05','12:30:00',3.93),('15128','2013-04-05','12:35:00',3.94),('15128','2013-04-05','12:40:00',4.04),('15128','2013-04-05','12:45:00',4.08),('15128','2013-04-05','12:50:00',4.14),('15128','2013-04-05','12:55:00',4.24),('15128','2013-04-05','13:00:00',1.89),('15128','2013-04-05','13:10:00',1.6),('15128','2013-04-05','13:15:00',1.15),('15128','2013-04-05','13:20:00',1.51),('15128','2013-04-05','13:25:00',1.77),('15128','2013-04-05','13:30:00',3.3),('15128','2013-04-05','13:35:00',3.77),('15128','2013-04-05','13:40:00',4.61),('15128','2013-04-05','13:45:00',4.29),('15128','2013-04-05','13:50:00',2.54),('15128','2013-04-05','13:55:00',3.36),('15128','2013-04-05','14:00:00',4.13),('15128','2013-04-05','14:05:00',3.55),('15128','2013-04-05','14:10:00',4.55),('15128','2013-04-05','14:15:00',4.41),('15128','2013-04-05','14:20:00',4.25),('15128','2013-04-05','14:25:00',4.19),('15128','2013-04-05','14:30:00',4.15),('15128','2013-04-05','14:35:00',4.14),('15128','2013-04-05','14:40:00',4.1),('15128','2013-04-05','14:45:00',4.1),('15128','2013-04-05','14:50:00',4.13),('15128','2013-04-05','14:55:00',4.07),('15128','2013-04-05','15:00:00',4.03),('15128','2013-04-05','15:05:00',3.98),('15128','2013-04-05','15:10:00',3.91),('15128','2013-04-05','15:15:00',3.87),('15128','2013-04-05','15:20:00',3.9),('15128','2013-04-05','15:25:00',3.85),('15128','2013-04-05','15:30:00',3.84),('15128','2013-04-05','15:35:00',3.71),('15128','2013-04-05','15:40:00',3.66),('15128','2013-04-05','15:45:00',3.79),('15128','2013-04-05','15:50:00',3.74),('15128','2013-04-05','15:55:00',3.7),('15128','2013-04-05','16:00:00',3.46),('15128','2013-04-05','16:05:00',2.82),('15128','2013-04-05','16:10:00',2.36),('15128','2013-04-05','16:15:00',2.36),('15128','2013-04-05','16:20:00',3.16),('15128','2013-04-05','16:25:00',2.43),('15128','2013-04-05','16:30:00',1.79),('15128','2013-04-05','16:35:00',3.25),('15128','2013-04-05','16:40:00',2.43),('15128','2013-04-05','16:45:00',2.14),('15128','2013-04-05','16:50:00',2.69),('15128','2013-04-05','16:55:00',2.38),('15128','2013-04-05','17:00:00',2.22),('15128','2013-04-05','17:05:00',2.18),('15128','2013-04-05','17:10:00',2.01),('15128','2013-04-05','17:15:00',1.76),('15128','2013-04-05','17:20:00',1.32),('15128','2013-04-05','17:25:00',1.34),('15128','2013-04-05','17:30:00',1.14),('15128','2013-04-05','17:35:00',1.06),('15128','2013-04-04','08:45:00',1.01),('15128','2013-04-04','08:55:00',1.07),('15128','2013-04-04','09:20:00',1.01),('15128','2013-04-04','09:25:00',1.11),('15128','2013-04-04','09:30:00',1.32),('15128','2013-04-04','09:35:00',1.32),('15128','2013-04-04','09:40:00',2.01),('15128','2013-04-04','09:45:00',1.67),('15128','2013-04-04','09:50:00',1.2),('15128','2013-04-04','10:05:00',1.36),('15128','2013-04-04','10:10:00',1.77),('15128','2013-04-04','10:15:00',1.73),('15128','2013-04-04','10:20:00',2.3),('15128','2013-04-04','10:25:00',2.19),('15128','2013-04-04','10:30:00',2.23),('15128','2013-04-04','10:35:00',2.01),('15128','2013-04-04','10:40:00',2.71),('15128','2013-04-04','10:45:00',3.31),('15128','2013-04-04','10:50:00',2.8),('15128','2013-04-04','10:55:00',1.66),('15128','2013-04-04','11:00:00',2.01),('15128','2013-04-04','11:05:00',2.14),('15128','2013-04-04','11:10:00',3.08),('15128','2013-04-04','11:15:00',2.52),('15128','2013-04-04','11:20:00',3.29),('15128','2013-04-04','11:25:00',3.05),('15128','2013-04-04','11:30:00',3.32),('15128','2013-04-04','11:35:00',3.13),('15128','2013-04-04','11:40:00',3.41),('15128','2013-04-04','11:45:00',3.07),('15128','2013-04-04','11:50:00',2.88),('15128','2013-04-04','11:55:00',3.62),('15128','2013-04-04','12:00:00',3.68),('15128','2013-04-04','12:05:00',3.85),('15128','2013-04-04','12:10:00',2.87),('15128','2013-04-04','12:15:00',2.1),('15128','2013-04-04','12:20:00',1.86),('15128','2013-04-04','12:25:00',1.49),('15128','2013-04-04','12:30:00',4.63),('15128','2013-04-04','12:35:00',3.19),('15128','2013-04-04','12:40:00',1.43),('15128','2013-04-04','12:45:00',1.54),('15128','2013-04-04','12:50:00',3.11),('15128','2013-04-04','12:55:00',4.78),('15128','2013-04-04','13:00:00',3.97),('15128','2013-04-04','13:05:00',4.21),('15128','2013-04-04','13:10:00',4.34),('15128','2013-04-04','13:15:00',4.65),('15128','2013-04-04','13:20:00',4.23),('15128','2013-04-04','13:25:00',4.32),('15128','2013-04-04','13:30:00',4.64),('15128','2013-04-04','13:35:00',3.4),('15128','2013-04-04','13:40:00',4.76),('15128','2013-04-04','13:45:00',4.16),('15128','2013-04-04','13:50:00',4.73),('15128','2013-04-04','13:55:00',4.51),('15128','2013-04-04','14:00:00',3.7),('15128','2013-04-04','14:05:00',1.9),('15128','2013-04-04','14:10:00',3.45),('15128','2013-04-04','14:15:00',4.97),('15128','2013-04-04','14:20:00',5.15),('15128','2013-04-04','14:25:00',3.54),('15128','2013-04-04','14:30:00',3.79),('15128','2013-04-04','14:35:00',4.49),('15128','2013-04-04','14:40:00',2.49),('15128','2013-04-04','14:45:00',3.24),('15128','2013-04-04','14:50:00',2.49),('15128','2013-04-04','14:55:00',2.54),('15128','2013-04-04','15:00:00',2.67),('15128','2013-04-04','15:05:00',1.78),('15128','2013-04-04','15:10:00',1.43),('15128','2013-04-04','15:15:00',1.41),('15128','2013-04-04','15:20:00',1.39),('15128','2013-04-04','15:25:00',1.2),('15128','2013-04-04','15:35:00',1.08),('15128','2013-04-04','15:40:00',1.11),('15128','2013-04-04','15:55:00',1.04),('15128','2013-04-04','16:00:00',1.66),('15128','2013-04-04','16:05:00',2.28),('15128','2013-04-04','16:10:00',1.89),('15128','2013-04-04','16:15:00',1.62),('15128','2013-04-04','16:20:00',1.8),('15128','2013-04-04','16:25:00',1.49),('15128','2013-04-04','16:30:00',1.92),('15128','2013-04-04','16:35:00',1.93),('15128','2013-04-04','16:40:00',2.47),('15128','2013-04-04','16:45:00',2.28),('15128','2013-04-04','16:50:00',3.2),('15128','2013-04-04','16:55:00',3.24),('15128','2013-04-04','17:00:00',1.29),('15128','2013-04-04','17:05:00',1.46),('15128','2013-04-04','17:10:00',2.42),('15128','2013-04-04','17:15:00',1.9),('15128','2013-04-04','17:20:00',2.24),('15128','2013-04-04','17:25:00',1.65),('15128','2013-04-04','17:35:00',1.39),('15128','2013-04-04','17:40:00',2.3),('15128','2013-04-04','17:45:00',1.72),('15128','2013-04-04','17:50:00',1.56),('15128','2013-04-04','17:55:00',2.02),('15128','2013-04-04','18:00:00',2),('15128','2013-04-04','18:05:00',1.1),('15128','2013-04-04','18:15:00',1.02),('15128','2013-04-04','18:25:00',1.27),('15128','2013-04-03','08:50:00',1.04),('15128','2013-04-03','08:55:00',1.32),('15128','2013-04-03','09:00:00',1.11),('15128','2013-04-03','09:10:00',1.09),('15128','2013-04-03','09:15:00',1.11),('15128','2013-04-03','09:20:00',1.08),('15128','2013-04-03','09:25:00',1.19),('15128','2013-04-03','09:30:00',1.89),('15128','2013-04-03','09:35:00',2.32),('15128','2013-04-03','09:40:00',1.58),('15128','2013-04-03','09:45:00',1.26),('15128','2013-04-03','09:50:00',1.25),('15128','2013-04-03','09:55:00',1.51),('15128','2013-04-03','10:00:00',2.14),('15128','2013-04-03','10:05:00',2.38),('15128','2013-04-03','10:10:00',1.74),('15128','2013-04-03','10:15:00',1.62),('15128','2013-04-03','10:20:00',1.89),('15128','2013-04-03','10:25:00',2.56),('15128','2013-04-03','10:30:00',2.83),('15128','2013-04-03','10:35:00',2.86),('15128','2013-04-03','10:40:00',1.99),('15128','2013-04-03','10:45:00',2.11),('15128','2013-04-03','10:50:00',2.28),('15128','2013-04-03','10:55:00',2.16),('15128','2013-04-03','11:00:00',1.36),('15128','2013-04-03','11:05:00',1.22),('15128','2013-04-03','11:10:00',1.63),('15128','2013-04-03','11:15:00',1.51),('15128','2013-04-03','11:20:00',1.3),('15128','2013-04-03','11:25:00',1.26),('15128','2013-04-03','11:30:00',1.35),('15128','2013-04-03','11:35:00',1.76),('15128','2013-04-03','11:40:00',2.28),('15128','2013-04-03','11:45:00',2.73),('15128','2013-04-03','11:50:00',3.47),('15128','2013-04-03','11:55:00',3.52),('15128','2013-04-03','12:00:00',3.96),('15128','2013-04-03','12:05:00',4.17),('15128','2013-04-03','12:10:00',3.44),('15128','2013-04-03','12:15:00',3.01),('15128','2013-04-03','12:20:00',2.92),('15128','2013-04-03','12:25:00',3.8),('15128','2013-04-03','12:30:00',3.3),('15128','2013-04-03','12:35:00',3.75),('15128','2013-04-03','12:40:00',4.14),('15128','2013-04-03','12:45:00',3.74),('15128','2013-04-03','12:50:00',3.12),('15128','2013-04-03','12:55:00',3.32),('15128','2013-04-03','13:00:00',2.46),('15128','2013-04-03','13:05:00',1.93),('15128','2013-04-03','13:10:00',1.82),('15128','2013-04-03','13:15:00',2.39),('15128','2013-04-03','13:20:00',1.81),('15128','2013-04-03','13:25:00',3.5),('15128','2013-04-03','13:30:00',4.55),('15128','2013-04-03','13:35:00',3.69),('15128','2013-04-03','13:40:00',2.9),('15128','2013-04-03','13:45:00',3.19),('15128','2013-04-03','13:50:00',2.94),('15128','2013-04-03','13:55:00',2.46),('15128','2013-04-03','14:00:00',3.04),('15128','2013-04-03','14:05:00',3.6),('15128','2013-04-03','14:10:00',4.32),('15128','2013-04-03','14:15:00',3.96),('15128','2013-04-03','14:20:00',3.24),('15128','2013-04-03','14:25:00',3.99),('15128','2013-04-03','14:30:00',3.99),('15128','2013-04-03','14:35:00',4),('15128','2013-04-03','14:40:00',3.95),('15128','2013-04-03','14:45:00',3.98),('15128','2013-04-03','14:50:00',2.85),('15128','2013-04-03','14:55:00',3.35),('15128','2013-04-03','15:00:00',3.86),('15128','2013-04-03','15:05:00',3.75),('15128','2013-04-03','15:10:00',3.65),('15128','2013-04-03','15:15:00',3.72),('15128','2013-04-03','15:20:00',3.51),('15128','2013-04-03','15:25:00',3.34),('15128','2013-04-03','15:30:00',3.61),('15128','2013-04-03','15:35:00',3.55),('15128','2013-04-03','15:40:00',3.5),('15128','2013-04-03','15:45:00',3.39),('15128','2013-04-03','15:50:00',3.35),('15128','2013-04-03','15:55:00',3.35),('15128','2013-04-03','16:00:00',3.13),('15128','2013-04-03','16:05:00',3.21),('15128','2013-04-03','16:10:00',3.04),('15128','2013-04-03','16:15:00',2.72),('15128','2013-04-03','16:20:00',2.18),('15128','2013-04-03','16:25:00',3.26),('15128','2013-04-03','16:30:00',2.95),('15128','2013-04-03','16:35:00',2.47),('15128','2013-04-03','16:40:00',2.7),('15128','2013-04-03','16:45:00',2.17),('15128','2013-04-03','16:50:00',2.21),('15128','2013-04-03','16:55:00',2.36),('15128','2013-04-03','17:00:00',1.96),('15128','2013-04-03','17:05:00',2.19),('15128','2013-04-03','17:10:00',1.85),('15128','2013-04-03','17:15:00',1.73),('15128','2013-04-03','17:20:00',1.47),('15128','2013-04-03','17:25:00',1.27),('15128','2013-04-03','17:40:00',1.13),('15128','2013-04-03','17:50:00',1.31),('15128','2013-04-03','17:55:00',1.71),('15128','2013-04-03','18:00:00',1.56),('15128','2013-04-02','08:50:00',1.06),('15128','2013-04-02','08:55:00',1.16),('15128','2013-04-02','09:00:00',1.28),('15128','2013-04-02','09:05:00',1.31),('15128','2013-04-02','09:10:00',1.47),('15128','2013-04-02','09:15:00',1.58),('15128','2013-04-02','09:20:00',1.42),('15128','2013-04-02','09:30:00',1.54),('15128','2013-04-02','09:35:00',1.78),('15128','2013-04-02','09:40:00',1.94),('15128','2013-04-02','09:45:00',2.03),('15128','2013-04-02','09:50:00',2.16),('15128','2013-04-02','09:55:00',2.03),('15128','2013-04-02','10:00:00',1.49),('15128','2013-04-02','10:05:00',2.51),('15128','2013-04-02','10:10:00',2.66),('15128','2013-04-02','10:15:00',1.61),('15128','2013-04-02','10:20:00',1.5),('15128','2013-04-02','10:25:00',2.12),('15128','2013-04-02','10:30:00',1.77),('15128','2013-04-02','10:35:00',2.09),('15128','2013-04-02','10:40:00',1.36),('15128','2013-04-02','10:45:00',1.89),('15128','2013-04-02','10:50:00',3.28),('15128','2013-04-02','10:55:00',2.05),('15128','2013-04-02','11:00:00',2.29),('15128','2013-04-02','11:05:00',2.31),('15128','2013-04-02','11:10:00',2.82),('15128','2013-04-02','11:15:00',2.4),('15128','2013-04-02','11:20:00',1.82),('15128','2013-04-02','11:25:00',1.41),('15128','2013-04-02','11:30:00',3.39),('15128','2013-04-02','11:35:00',2.51),('15128','2013-04-02','11:40:00',1.65),('15128','2013-04-02','11:45:00',2.66),('15128','2013-04-02','11:50:00',3.28),('15128','2013-04-02','11:55:00',2.12),('15128','2013-04-02','12:00:00',4.67),('15128','2013-04-02','12:05:00',3.75),('15128','2013-04-02','12:10:00',4.78),('15128','2013-04-02','12:15:00',3.8),('15128','2013-04-02','12:20:00',3.83),('15128','2013-04-02','12:25:00',3.08),('15128','2013-04-02','12:30:00',3.5),('15128','2013-04-02','12:35:00',3.7),('15128','2013-04-02','12:40:00',3.96),('15128','2013-04-02','12:45:00',4.77),('15128','2013-04-02','12:50:00',3.42),('15128','2013-04-02','12:55:00',3.62),('15128','2013-04-02','13:00:00',3.58),('15128','2013-04-02','13:05:00',2.91),('15128','2013-04-02','13:10:00',4.77),('15128','2013-04-02','13:15:00',3.08),('15128','2013-04-02','13:20:00',3.74),('15128','2013-04-02','13:25:00',4.43),('15128','2013-04-02','13:30:00',4.82),('15128','2013-04-02','13:35:00',5.92),('15128','2013-04-02','13:40:00',5.44),('15128','2013-04-02','13:45:00',5.14),('15128','2013-04-02','13:50:00',5.03),('15128','2013-04-02','13:55:00',4.74),('15128','2013-04-02','14:00:00',4.04),('15128','2013-04-02','14:05:00',4.66),('15128','2013-04-02','14:10:00',4.81),('15128','2013-04-02','14:15:00',5.52),('15128','2013-04-02','14:20:00',3.97),('15128','2013-04-02','14:25:00',4.82),('15128','2013-04-02','14:30:00',3.66),('15128','2013-04-02','14:35:00',4.04),('15128','2013-04-02','14:40:00',4.73),('15128','2013-04-02','14:45:00',4.53),('15128','2013-04-02','14:50:00',4.64),('15128','2013-04-02','14:55:00',4.53),('15128','2013-04-02','15:00:00',4.7),('15128','2013-04-02','15:05:00',4.67),('15128','2013-04-02','15:10:00',4.53),('15128','2013-04-02','15:15:00',3.41),('15128','2013-04-02','15:20:00',4.71),('15128','2013-04-02','15:25:00',4.55),('15128','2013-04-02','15:30:00',4.43),('15128','2013-04-02','15:35:00',4.21),('15128','2013-04-02','15:40:00',4.2),('15128','2013-04-02','15:45:00',3.13),('15128','2013-04-02','15:50:00',3.82),('15128','2013-04-02','15:55:00',4.02),('15128','2013-04-02','16:00:00',3.9),('15128','2013-04-02','16:05:00',3.94),('15128','2013-04-02','16:10:00',3.81),('15128','2013-04-02','16:15:00',3.74),('15128','2013-04-02','16:20:00',3.66),('15128','2013-04-02','16:25:00',3.59),('15128','2013-04-02','16:30:00',3.53),('15128','2013-04-02','16:35:00',3.46),('15128','2013-04-02','16:40:00',3.4),('15128','2013-04-02','16:45:00',3.33),('15128','2013-04-02','16:50:00',3.23),('15128','2013-04-02','16:55:00',3.16),('15128','2013-04-02','17:00:00',3.05),('15128','2013-04-02','17:05:00',2.96),('15128','2013-04-02','17:10:00',2.84),('15128','2013-04-02','17:15:00',2.73),('15128','2013-04-02','17:20:00',2.59),('15128','2013-04-02','17:25:00',2.39),('15128','2013-04-02','17:30:00',2.35),('15128','2013-04-02','17:35:00',2.16),('15128','2013-04-02','17:40:00',2.11),('15128','2013-04-02','17:45:00',2.01),('15128','2013-04-02','17:50:00',1.17),('15128','2013-04-02','17:55:00',1.65),('15128','2013-04-02','18:00:00',1.76),('15128','2013-04-02','18:05:00',1.7),('15128','2013-04-02','18:10:00',1.6),('15128','2013-04-02','18:15:00',1.45),('15128','2013-04-02','18:20:00',1.32),('15128','2013-04-02','18:25:00',1.22),('15128','2013-04-02','18:30:00',1.12),('15128','2013-04-02','18:35:00',1.03),('15128','2013-04-01','09:00:00',1.23),('15128','2013-04-01','09:05:00',1.31),('15128','2013-04-01','09:10:00',1.39),('15128','2013-04-01','09:15:00',1.35),('15128','2013-04-01','09:20:00',1.73),('15128','2013-04-01','09:25:00',1.96),('15128','2013-04-01','09:30:00',1.55),('15128','2013-04-01','09:35:00',1.97),('15128','2013-04-01','09:40:00',1.72),('15128','2013-04-01','09:45:00',1.06),('15128','2013-04-01','09:50:00',1.75),('15128','2013-04-01','09:55:00',1.81),('15128','2013-04-01','10:00:00',2.11),('15128','2013-04-01','10:05:00',3.12),('15128','2013-04-01','10:10:00',2.96),('15128','2013-04-01','10:15:00',2.21),('15128','2013-04-01','10:20:00',3.14),('15128','2013-04-01','10:25:00',2.9),('15128','2013-04-01','10:30:00',2.42),('15128','2013-04-01','10:35:00',2.52),('15128','2013-04-01','10:40:00',1.46),('15128','2013-04-01','10:45:00',2.98),('15128','2013-04-01','10:50:00',2.96),('15128','2013-04-01','10:55:00',3.17),('15128','2013-04-01','11:00:00',2.99),('15128','2013-04-01','11:05:00',3.27),('15128','2013-04-01','11:10:00',3.3),('15128','2013-04-01','11:15:00',2.2),('15128','2013-04-01','11:20:00',2.96),('15128','2013-04-01','11:25:00',2.36),('15128','2013-04-01','11:30:00',4.13),('15128','2013-04-01','11:35:00',3.76),('15128','2013-04-01','11:40:00',3.16),('15128','2013-04-01','11:45:00',3.68),('15128','2013-04-01','11:50:00',3.54),('15128','2013-04-01','11:55:00',1.23),('15128','2013-04-01','12:00:00',1.18),('15128','2013-04-01','12:05:00',1.65),('15128','2013-04-01','12:10:00',2.84),('15128','2013-04-01','12:15:00',1.44),('15128','2013-04-01','12:20:00',1.38),('15128','2013-04-01','12:25:00',1.05),('15128','2013-04-01','12:30:00',2.11),('15128','2013-04-01','12:35:00',2.65),('15128','2013-04-01','12:40:00',1.82),('15128','2013-04-01','12:45:00',2.28),('15128','2013-04-01','12:50:00',1.79),('15128','2013-04-01','12:55:00',1.61),('15128','2013-04-01','13:00:00',1.7),('15128','2013-04-01','13:05:00',2.35),('15128','2013-04-01','13:10:00',1.7),('15128','2013-04-01','13:15:00',1.07),('15128','2013-04-01','13:20:00',1.41),('15128','2013-04-01','13:25:00',1.87),('15128','2013-04-01','13:30:00',1.69),('15128','2013-04-01','13:35:00',1.62),('15128','2013-04-01','13:40:00',1.49),('15128','2013-04-01','13:45:00',1.31),('15128','2013-04-01','13:50:00',2.37),('15128','2013-04-01','13:55:00',3.52),('15128','2013-04-01','14:00:00',2.8),('15128','2013-04-01','14:05:00',3.2),('15128','2013-04-01','14:10:00',4.67),('15128','2013-04-01','14:15:00',2.25),('15128','2013-04-01','14:20:00',1.51),('15128','2013-04-01','14:25:00',4.42),('15128','2013-04-01','14:30:00',2.38),('15128','2013-04-01','14:40:00',1.05),('15128','2013-04-01','14:50:00',1.32),('15128','2013-04-01','15:00:00',1.17),('15128','2013-04-01','15:20:00',1.41),('15128','2013-04-01','15:55:00',1.44),('15128','2013-04-01','16:00:00',1.4),('15128','2013-04-01','16:05:00',1.3),('15128','2013-04-01','16:10:00',1.06),('15128','2013-04-01','16:15:00',1.06),('15128','2013-04-01','16:30:00',1.14),('15128','2013-04-01','17:45:00',1),('15128','2014-05-01','08:30:00',1.03),('15128','2014-05-01','08:35:00',1.29),('15128','2014-05-01','08:40:00',1.43),('15128','2014-05-01','09:15:00',1.55),('15128','2014-05-01','09:20:00',1.57),('15128','2014-05-01','09:25:00',1.46),('15128','2014-05-01','09:30:00',1.69),('15128','2014-05-01','09:35:00',1.76),('15128','2014-05-01','09:40:00',1.66),('15128','2014-05-01','09:45:00',1.4),('15128','2014-05-01','09:50:00',1.13),('15128','2014-05-01','11:00:00',1.03),('15128','2014-05-01','11:05:00',1.05),('15128','2014-05-01','11:10:00',1),('15128','2014-05-01','12:35:00',1.13),('15128','2014-05-01','12:40:00',1.31),('15128','2014-05-01','12:45:00',1.66),('15128','2014-05-01','12:50:00',1.8),('15128','2014-05-01','12:55:00',2.18),('15128','2014-05-01','13:00:00',2.25),('15128','2014-05-01','13:05:00',2.05),('15128','2014-05-01','13:10:00',2.94),('15128','2014-05-01','13:15:00',2.14),('15128','2014-05-01','13:20:00',2.13),('15128','2014-05-01','13:25:00',1.96),('15128','2014-05-01','13:30:00',3.38),('15128','2014-05-01','13:35:00',1.89),('15128','2014-05-01','13:40:00',2.99),('15128','2014-05-01','13:45:00',1.51),('15128','2014-05-01','13:50:00',1.8),('15128','2014-05-01','13:55:00',2.55),('15128','2014-05-01','14:00:00',2.43),('15128','2014-05-01','14:05:00',1.97),('15128','2014-05-01','14:10:00',4.08),('15128','2014-05-01','14:15:00',4),('15128','2014-05-01','14:20:00',3.92),('15128','2014-05-01','14:25:00',5.35),('15128','2014-05-01','14:30:00',1.91),('15128','2014-05-01','14:35:00',2.19),('15128','2014-05-01','14:40:00',1.5),('15128','2014-05-01','14:45:00',1.34),('15128','2014-05-01','15:15:00',1.28),('15128','2014-05-01','15:20:00',1.63),('15128','2014-05-01','15:25:00',2.81),('15128','2014-05-01','15:30:00',2.84),('15128','2014-05-01','15:35:00',2.62),('15128','2014-05-01','15:40:00',1.32),('15128','2014-05-01','15:50:00',1.41),('15128','2014-05-01','15:55:00',1.6),('15128','2014-05-01','16:00:00',1.05),('15128','2014-05-01','16:05:00',1.01),('15128','2014-05-01','16:10:00',1.58),('15128','2014-05-01','16:15:00',1.45),('15128','2014-05-01','16:20:00',1.04),('15128','2014-05-01','16:25:00',1.6),('15128','2014-05-01','16:30:00',1.35),('15128','2014-05-01','16:35:00',1.1),('15128','2014-05-01','16:40:00',1.76),('15128','2014-05-01','16:45:00',4.17),('15128','2014-05-01','16:50:00',2.62),('15128','2014-05-01','16:55:00',1.17),('15128','2014-05-01','17:00:00',1.17),('15128','2014-05-01','17:05:00',1.04),('15128','2014-05-01','17:10:00',1.05),('15128','2014-03-26','09:25:00',1.13),('15128','2014-03-26','09:30:00',1.2),('15128','2014-03-26','10:05:00',1.21),('15128','2014-03-26','10:10:00',1.39),('15128','2014-03-26','10:15:00',1.39),('15128','2014-03-26','10:20:00',1.28),('15128','2014-03-26','10:25:00',1.45),('15128','2014-03-26','10:30:00',1.41),('15128','2014-03-26','10:35:00',1.78),('15128','2014-03-26','10:40:00',1.81),('15128','2014-03-26','10:45:00',2.03),('15128','2014-03-26','10:50:00',2.15),('15128','2014-03-26','10:55:00',1.48),('15128','2014-03-26','11:00:00',1.71),('15128','2014-03-26','11:05:00',2.45),('15128','2014-03-26','11:10:00',2.78),('15128','2014-03-26','11:15:00',1.16),('15128','2014-03-26','11:20:00',1.07),('15128','2014-03-26','11:25:00',1.06),('15128','2014-03-26','11:45:00',1.04),('15128','2014-03-26','11:50:00',1.3),('15128','2014-03-26','11:55:00',1.43),('15128','2014-03-26','12:00:00',1.05),('15128','2014-03-26','12:50:00',1.09),('15128','2014-03-26','12:55:00',1.33),('15128','2014-03-26','13:00:00',1.46),('15128','2014-03-26','13:05:00',1.51),('15128','2014-03-26','13:10:00',2.04),('15128','2014-03-26','13:15:00',2.7),('15128','2014-03-26','13:20:00',2.76),('15128','2014-03-26','13:25:00',2.99),('15128','2014-03-26','13:30:00',3.09),('15128','2014-03-26','13:35:00',2.77),('15128','2014-03-26','13:40:00',2.47),('15128','2014-03-26','13:45:00',2.22),('15128','2014-03-26','13:50:00',2.17),('15128','2014-03-26','13:55:00',1.57),('15128','2014-03-26','14:00:00',1.07),('15128','2014-03-26','14:05:00',1.94),('15128','2014-03-26','14:10:00',2.2),('15128','2014-03-26','14:15:00',1.03),('15128','2014-03-26','14:20:00',1.12),('15128','2014-03-26','14:25:00',2.77),('15128','2014-03-26','14:30:00',1.56),('15128','2014-03-26','15:35:00',1.03),('15128','2014-03-26','15:40:00',1.99),('15128','2014-03-26','15:45:00',2.92),('15128','2014-03-26','15:50:00',1.6),('15128','2014-03-26','15:55:00',2.16),('15128','2014-03-26','16:25:00',1.19),('15128','2014-03-26','16:45:00',1.33),('15128','2014-03-26','16:50:00',1.01),('15128','2013-03-31','09:00:00',1.26),('15128','2013-03-31','09:05:00',1.36),('15128','2013-03-31','09:10:00',1.48),('15128','2013-03-31','09:15:00',1.48),('15128','2013-03-31','09:20:00',1.51),('15128','2013-03-31','09:25:00',1.68),('15128','2013-03-31','09:30:00',1.11),('15128','2013-03-31','09:40:00',1.35),('15128','2013-03-31','09:45:00',1.02),('15128','2013-03-31','09:50:00',2.15),('15128','2013-03-31','09:55:00',2.04),('15128','2013-03-31','10:00:00',1.98),('15128','2013-03-31','10:05:00',2.51),('15128','2013-03-31','10:10:00',2.51),('15128','2013-03-31','10:15:00',2.15),('15128','2013-03-31','10:20:00',2.62),('15128','2013-03-31','10:25:00',2.96),('15128','2013-03-31','10:30:00',2.57),('15128','2013-03-31','10:35:00',2.01),('15128','2013-03-31','10:40:00',2.12),('15128','2013-03-31','10:45:00',2.59),('15128','2013-03-31','10:50:00',2.09),('15128','2013-03-31','10:55:00',2.13),('15128','2013-03-31','11:00:00',1.65),('15128','2013-03-31','11:05:00',1.44),('15128','2013-03-31','11:10:00',1.88),('15128','2013-03-31','11:15:00',2),('15128','2013-03-31','11:20:00',1.92),('15128','2013-03-31','11:25:00',2.56),('15128','2013-03-31','11:30:00',1.95),('15128','2013-03-31','11:35:00',2.12),('15128','2013-03-31','11:40:00',3.08),('15128','2013-03-31','11:45:00',2.38),('15128','2013-03-31','11:50:00',2.68),('15128','2013-03-31','11:55:00',2.71),('15128','2013-03-31','12:00:00',2.24),('15128','2013-03-31','12:05:00',2.5),('15128','2013-03-31','12:10:00',2.62),('15128','2013-03-31','12:15:00',2.24),('15128','2013-03-31','12:20:00',2.38),('15128','2013-03-31','12:25:00',2.39),('15128','2013-03-31','12:30:00',2.6),('15128','2013-03-31','12:35:00',2.21),('15128','2013-03-31','12:40:00',2.62),('15128','2013-03-31','12:45:00',2.61),('15128','2013-03-31','12:50:00',2.83),('15128','2013-03-31','12:55:00',2.96),('15128','2013-03-31','13:00:00',2.48),('15128','2013-03-31','13:05:00',2.59),('15128','2013-03-31','13:10:00',2.46),('15128','2013-03-31','13:15:00',2.82),('15128','2013-03-31','13:20:00',2.53),('15128','2013-03-31','13:25:00',2.14),('15128','2013-03-31','13:30:00',2.06),('15128','2013-03-31','13:35:00',2.25),('15128','2013-03-31','13:40:00',2.15),('15128','2013-03-31','13:45:00',2.88),('15128','2013-03-31','13:50:00',3.54),('15128','2013-03-31','13:55:00',3.51),('15128','2013-03-31','14:00:00',2.43),('15128','2013-03-31','14:05:00',2.03),('15128','2013-03-31','14:10:00',2.1),('15128','2013-03-31','14:15:00',2.61),('15128','2013-03-31','14:20:00',3.43),('15128','2013-03-31','14:25:00',4.07),('15128','2013-03-31','14:30:00',4.44),('15128','2013-03-31','14:35:00',2.43),('15128','2013-03-31','14:40:00',1.55),('15128','2013-03-31','14:45:00',2.45),('15128','2013-03-31','14:50:00',2.75),('15128','2013-03-31','14:55:00',2.15),('15128','2013-03-31','15:00:00',2.08),('15128','2013-03-31','15:05:00',1.96),('15128','2013-03-31','15:10:00',2.25),('15128','2013-03-31','15:15:00',2.34),('15128','2013-03-31','15:20:00',2.4),('15128','2013-03-31','15:25:00',2.95),('15128','2013-03-31','15:30:00',2.5),('15128','2013-03-31','15:35:00',2.7),('15128','2013-03-31','15:40:00',2.11),('15128','2013-03-31','15:45:00',2.71),('15128','2013-03-31','15:50:00',3.34),('15128','2013-03-31','15:55:00',2.74),('15128','2013-03-31','16:00:00',2.37),('15128','2013-03-31','16:05:00',1.86),('15128','2013-03-31','16:10:00',1.52),('15128','2013-03-31','16:15:00',1.02),('15128','2013-03-30','09:00:00',1.06),('15128','2013-03-30','09:10:00',1.42),('15128','2013-03-30','09:15:00',1.14),('15128','2013-03-30','09:20:00',1.01),('15128','2013-03-30','09:25:00',1.2),('15128','2013-03-30','09:45:00',1.86),('15128','2013-03-30','09:50:00',1.13),('15128','2013-03-30','10:05:00',1.05),('15128','2013-03-30','10:10:00',1.81),('15128','2013-03-30','10:15:00',1.82),('15128','2013-03-30','10:20:00',2.17),('15128','2013-03-30','10:25:00',2.01),('15128','2013-03-30','10:30:00',1.81),('15128','2013-03-30','10:35:00',1.61),('15128','2013-03-30','10:40:00',1.16),('15128','2013-03-30','10:50:00',2.12),('15128','2013-03-30','10:55:00',1.7),('15128','2013-03-30','11:00:00',3.01),('15128','2013-03-30','11:05:00',2.74),('15128','2013-03-30','11:10:00',2.32),('15128','2013-03-30','11:15:00',1.28),('15128','2013-03-30','11:20:00',1.83),('15128','2013-03-30','11:25:00',2.59),('15128','2013-03-30','11:30:00',2.4),('15128','2013-03-30','11:35:00',2.48),('15128','2013-03-30','11:40:00',3.35),('15128','2013-03-30','11:45:00',2.03),('15128','2013-03-30','11:50:00',1.58),('15128','2013-03-30','11:55:00',2.07),('15128','2013-03-30','12:00:00',1.27),('15128','2013-03-30','12:05:00',1.09),('15128','2013-03-30','12:10:00',1.06),('15128','2013-03-30','12:25:00',1.14),('15128','2013-03-30','12:30:00',1.36),('15128','2013-03-30','12:35:00',2.55),('15128','2013-03-30','12:40:00',3.56),('15128','2013-03-30','12:45:00',2.52),('15128','2013-03-30','12:50:00',1.46),('15128','2013-03-30','12:55:00',2.49),('15128','2013-03-30','13:00:00',2.96),('15128','2013-03-30','13:05:00',2.05),('15128','2013-03-30','13:10:00',2),('15128','2013-03-30','13:15:00',5.11),('15128','2013-03-30','13:20:00',3.88),('15128','2013-03-30','13:25:00',2.95),('15128','2013-03-30','13:30:00',2.01),('15128','2013-03-30','13:35:00',2.27),('15128','2013-03-30','13:40:00',1.87),('15128','2013-03-30','13:45:00',3.12),('15128','2013-03-30','13:50:00',2.48),('15128','2013-03-30','13:55:00',3.74),('15128','2013-03-30','14:00:00',3.14),('15128','2013-03-30','14:05:00',3.52),('15128','2013-03-30','14:10:00',3.43),('15128','2013-03-30','14:15:00',4.73),('15128','2013-03-30','14:20:00',4.01),('15128','2013-03-30','14:25:00',3.93),('15128','2013-03-30','14:30:00',3.04),('15128','2013-03-30','14:35:00',3.85),('15128','2013-03-30','14:40:00',3.35),('15128','2013-03-30','14:45:00',4.82),('15128','2013-03-30','14:50:00',4.63),('15128','2013-03-30','14:55:00',2.82),('15128','2013-03-30','15:00:00',3.47),('15128','2013-03-30','15:05:00',3.47),('15128','2013-03-30','15:10:00',4.6),('15128','2013-03-30','15:15:00',5.04),('15128','2013-03-30','15:20:00',4.79),('15128','2013-03-30','15:25:00',1.58),('15128','2013-03-30','15:35:00',2.29),('15128','2013-03-30','15:40:00',3.17),('15128','2013-03-30','15:45:00',4),('15128','2013-03-30','15:50:00',1.86),('15128','2013-03-30','16:20:00',1.33),('15128','2013-03-30','16:30:00',1.18),('15128','2013-03-30','16:35:00',1.26),('15128','2013-03-30','16:40:00',1.16),('15128','2013-03-30','16:45:00',1.01),('15128','2013-03-30','16:50:00',1.22),('15128','2013-03-30','16:55:00',1.33),('15128','2013-03-30','17:00:00',1.91),('15128','2013-03-30','17:05:00',1.28),('15128','2013-03-30','17:30:00',1.27),('15128','2013-03-30','17:40:00',1.13),('15128','2013-03-30','17:45:00',2),('15128','2013-03-30','17:50:00',2.24),('15128','2013-03-30','17:55:00',1.21),('15128','2013-03-30','18:10:00',1.23),('15128','2013-03-30','18:15:00',1.62),('15128','2013-03-30','18:20:00',1.07),('15128','2013-03-29','08:25:00',1.01),('15128','2013-03-29','09:00:00',1.06),('15128','2013-03-29','09:10:00',1.37),('15128','2013-03-29','09:15:00',1.2),('15128','2013-03-29','09:20:00',1.18),('15128','2013-03-29','09:25:00',1.38),('15128','2013-03-29','09:30:00',1.46),('15128','2013-03-29','09:35:00',1.53),('15128','2013-03-29','09:40:00',1.27),('15128','2013-03-29','09:45:00',1.3),('15128','2013-03-29','09:50:00',1.4),('15128','2013-03-29','09:55:00',1.68),('15128','2013-03-29','10:00:00',2.17),('15128','2013-03-29','10:05:00',2.16),('15128','2013-03-29','10:10:00',1.79),('15128','2013-03-29','10:15:00',1.41),('15128','2013-03-29','10:20:00',1.28),('15128','2013-03-29','10:25:00',1.47),('15128','2013-03-29','10:30:00',2.07),('15128','2013-03-29','10:35:00',2.23),('15128','2013-03-29','10:40:00',2.18),('15128','2013-03-29','10:45:00',1.9),('15128','2013-03-29','10:50:00',2.12),('15128','2013-03-29','10:55:00',2.49),('15128','2013-03-29','11:00:00',2.66),('15128','2013-03-29','11:05:00',2.69),('15128','2013-03-29','11:10:00',2.28),('15128','2013-03-29','11:15:00',3.51),('15128','2013-03-29','11:20:00',3.13),('15128','2013-03-29','11:25:00',2),('15128','2013-03-29','11:30:00',3.14),('15128','2013-03-29','11:35:00',3.85),('15128','2013-03-29','11:40:00',2.98),('15128','2013-03-29','11:45:00',2.83),('15128','2013-03-29','11:50:00',2.07),('15128','2013-03-29','11:55:00',2.94),('15128','2013-03-29','12:00:00',3.93),('15128','2013-03-29','12:05:00',2.57),('15128','2013-03-29','12:10:00',2.25),('15128','2013-03-29','12:15:00',1.7),('15128','2013-03-29','12:20:00',1.57),('15128','2013-03-29','12:25:00',1.19),('15128','2013-03-29','12:30:00',1.98),('15128','2013-03-29','12:35:00',1.11),('15128','2013-03-29','13:00:00',1.34),('15128','2013-03-29','13:05:00',1.9),('15128','2013-03-29','13:10:00',2.64),('15128','2013-03-29','13:15:00',1.84),('15128','2013-03-29','13:20:00',1.67),('15128','2013-03-29','13:25:00',1.31),('15128','2013-03-29','13:40:00',1.04),('15128','2013-03-29','13:45:00',1.45),('15128','2013-03-29','13:50:00',2.69),('15128','2013-03-29','13:55:00',3.18),('15128','2013-03-29','14:00:00',2.65),('15128','2013-03-29','14:05:00',3.33),('15128','2013-03-29','14:10:00',1.54),('15128','2013-03-29','14:15:00',1.87),('15128','2013-03-29','14:20:00',1.92),('15128','2013-03-29','14:25:00',1.48),('15128','2013-03-29','14:30:00',1.08),('15128','2013-03-29','14:35:00',1.24),('15128','2013-03-29','14:45:00',1.14),('15128','2013-03-28','08:10:00',1.56),('15128','2013-03-28','08:15:00',1.65),('15128','2013-03-28','08:20:00',1.55),('15128','2013-03-28','08:25:00',1.53),('15128','2013-03-28','08:30:00',1.61),('15128','2013-03-28','08:35:00',1.66),('15128','2013-03-28','08:40:00',1.62),('15128','2013-03-28','08:45:00',1.7),('15128','2013-03-28','08:50:00',1.55),('15128','2013-03-28','08:55:00',1.88),('15128','2013-03-28','09:00:00',1.81),('15128','2013-03-28','09:05:00',1.93),('15128','2013-03-28','09:10:00',2.19),('15128','2013-03-28','09:15:00',2.28),('15128','2013-03-28','09:20:00',1.94),('15128','2013-03-28','09:25:00',2.45),('15128','2013-03-28','09:30:00',2.53),('15128','2013-03-28','09:35:00',1.83),('15128','2013-03-28','09:40:00',2),('15128','2013-03-28','09:45:00',2.67),('15128','2013-03-28','09:50:00',2.55),('15128','2013-03-28','09:55:00',2.67),('15128','2013-03-28','10:00:00',2.58),('15128','2013-03-28','10:05:00',2.23),('15128','2013-03-28','10:10:00',2.74),('15128','2013-03-28','10:15:00',2.84),('15128','2013-03-28','10:20:00',2.66),('15128','2013-03-28','10:25:00',2.85),('15128','2013-03-28','10:30:00',2.84),('15128','2013-03-28','10:35:00',3.18),('15128','2013-03-28','10:40:00',2.81),('15128','2013-03-28','10:45:00',2.56),('15128','2013-03-28','10:50:00',2.29),('15128','2013-03-28','10:55:00',2.69),('15128','2013-03-28','11:00:00',3.03),('15128','2013-03-28','11:05:00',1.53),('15128','2013-03-28','11:10:00',3.45),('15128','2013-03-28','11:15:00',4.73),('15128','2013-03-28','11:20:00',4.05),('15128','2013-03-28','11:25:00',3.7),('15128','2013-03-28','11:30:00',2.34),('15128','2013-03-28','11:35:00',4.2),('15128','2013-03-28','11:40:00',4.13),('15128','2013-03-28','11:45:00',4.19),('15128','2013-03-28','11:50:00',4.2),('15128','2013-03-28','11:55:00',4.26),('15128','2013-03-28','12:00:00',4.32),('15128','2013-03-28','12:05:00',4.34),('15128','2013-03-28','12:10:00',3.96),('15128','2013-03-28','12:15:00',4.17),('15128','2013-03-28','12:20:00',3.99),('15128','2013-03-28','12:25:00',3.4),('15128','2013-03-28','12:30:00',3.73),('15128','2013-03-28','12:35:00',3.74),('15128','2013-03-28','12:40:00',4.55),('15128','2013-03-28','12:45:00',4.15),('15128','2013-03-28','12:50:00',3.52),('15128','2013-03-28','12:55:00',3.78),('15128','2013-03-28','13:00:00',3.02),('15128','2013-03-28','13:05:00',3.83),('15128','2013-03-28','13:10:00',3.45),('15128','2013-03-28','13:15:00',3.73),('15128','2013-03-28','13:20:00',4.92),('15128','2013-03-28','13:25:00',4.18),('15128','2013-03-28','13:30:00',3.88),('15128','2013-03-28','13:35:00',3.65),('15128','2013-03-28','13:40:00',3.59),('15128','2013-03-28','13:45:00',3.83),('15128','2013-03-28','13:50:00',3.8),('15128','2013-03-28','13:55:00',3.95),('15128','2013-03-28','14:00:00',3.62),('15128','2013-03-28','14:05:00',2.9),('15128','2013-03-28','14:10:00',2.61),('15128','2013-03-28','14:15:00',2.53),('15128','2013-03-28','14:20:00',2.57),('15128','2013-03-28','14:25:00',2.34),('15128','2013-03-28','14:30:00',2.14),('15128','2013-03-28','14:35:00',2.12),('15128','2013-03-28','14:40:00',2.13),('15128','2013-03-28','14:45:00',2.03),('15128','2013-03-28','14:50:00',1.94),('15128','2013-03-28','14:55:00',1.79),('15128','2013-03-28','15:00:00',1.68),('15128','2013-03-28','15:05:00',1.71),('15128','2013-03-28','15:10:00',1.63),('15128','2013-03-28','15:15:00',1.59),('15128','2013-03-28','15:20:00',1.42),('15128','2013-03-28','15:25:00',1.3),('15128','2013-03-28','15:30:00',1.24),('15128','2013-03-28','15:35:00',1.18),('15128','2013-03-28','15:40:00',1.16),('15128','2013-03-28','15:45:00',1.24),('15128','2013-03-28','15:50:00',1.39),('15128','2013-03-28','15:55:00',1.49),('15128','2013-03-28','16:00:00',1.47),('15128','2013-03-28','16:05:00',1.35),('15128','2013-03-28','16:10:00',1.18),('15128','2013-03-28','16:15:00',1.07),('15128','2013-03-28','16:20:00',1.18),('15128','2013-03-28','16:25:00',1.49),('15128','2013-03-28','16:30:00',1.26),('15128','2013-03-28','16:35:00',2.08),('15128','2013-03-28','16:40:00',2.2),('15128','2013-03-28','16:45:00',1.71),('15128','2013-03-28','16:50:00',1.21),('15128','2013-03-28','16:55:00',1.52),('15128','2013-03-28','17:00:00',2.05),('15128','2013-03-28','17:05:00',1.22),('15128','2013-03-28','17:15:00',1.03),('15128','2013-03-28','17:20:00',1.45),('15128','2013-03-28','17:25:00',1.31),('15128','2013-03-28','17:30:00',1.3),('15128','2013-03-27','09:15:00',1.3),('15128','2013-03-27','09:20:00',1.87),('15128','2013-03-27','09:25:00',1.91),('15128','2013-03-27','09:30:00',1.5),('15128','2013-03-27','12:50:00',1.79),('15128','2013-03-27','12:55:00',1.89),('15128','2013-03-27','13:00:00',1.42),('15128','2013-03-27','13:05:00',1.35),('15128','2013-03-27','13:25:00',1.48),('15128','2013-03-27','13:30:00',2.46),('15128','2013-03-27','13:35:00',1.48),('15128','2013-03-27','13:40:00',1.61),('15128','2013-03-27','13:45:00',1.4),('15128','2013-03-27','14:00:00',1.19),('15128','2013-03-27','14:05:00',2.55),('15128','2013-03-27','14:10:00',2.34),('15128','2013-03-27','14:15:00',3.1),('15128','2013-03-27','14:20:00',1.99),('15128','2013-03-27','14:25:00',1.5),('15128','2013-03-27','14:30:00',1.71),('15128','2013-03-27','14:35:00',2.19),('15128','2013-03-27','14:40:00',1.47),('15128','2013-03-27','14:45:00',1.07),('15128','2013-03-27','15:05:00',1.18),('15128','2013-03-27','15:10:00',1.54),('15128','2013-03-27','15:15:00',1.98),('15128','2013-03-27','15:20:00',1.83),('15128','2013-03-27','15:25:00',1.81),('15128','2013-03-27','15:30:00',1.58),('15128','2013-03-27','15:40:00',1.13),('15128','2013-03-27','15:45:00',2.49),('15128','2013-03-27','15:50:00',2.07),('15128','2013-03-27','15:55:00',1.6),('15128','2013-03-27','16:00:00',1.41),('15128','2013-03-27','16:05:00',1.21),('15128','2013-03-27','16:10:00',1.51),('15128','2013-03-27','16:15:00',1.15),('15128','2013-03-27','16:35:00',1.2),('15128','2013-03-27','16:40:00',2.31),('15128','2013-03-27','16:45:00',1.61),('15128','2013-03-27','16:50:00',1.01),('15128','2013-03-27','16:55:00',1.23),('15128','2013-03-27','17:00:00',1.95),('15128','2013-03-27','17:05:00',1.87),('15128','2013-03-27','17:10:00',1.6),('15128','2013-03-27','17:15:00',1.29),('15128','2013-03-26','08:10:00',1.08),('15128','2013-03-26','08:15:00',1.14),('15128','2013-03-26','08:20:00',1.06),('15128','2013-03-26','08:25:00',1.46),('15128','2013-03-26','08:30:00',1.56),('15128','2013-03-26','08:35:00',1.98),('15128','2013-03-26','08:40:00',1.74),('15128','2013-03-26','08:45:00',2.26),('15128','2013-03-26','08:50:00',1.67),('15128','2013-03-26','08:55:00',2.39),('15128','2013-03-26','09:00:00',1.35),('15128','2013-03-26','09:05:00',1.6),('15128','2013-03-26','09:10:00',2.66),('15128','2013-03-26','09:15:00',1.88),('15128','2013-03-26','09:20:00',1.16),('15128','2013-03-26','09:25:00',1.58),('15128','2013-03-26','09:30:00',1.08),('15128','2013-03-26','09:40:00',1.03),('15128','2013-03-26','09:45:00',2.11),('15128','2013-03-26','09:50:00',3.53),('15128','2013-03-26','09:55:00',1.92),('15128','2013-03-26','10:00:00',1.14),('15128','2013-03-26','10:05:00',1.56),('15128','2013-03-26','10:10:00',2.26),('15128','2013-03-26','10:15:00',3.41),('15128','2013-03-26','10:20:00',3.87),('15128','2013-03-26','10:25:00',3.3),('15128','2013-03-26','10:30:00',2.87),('15128','2013-03-26','10:35:00',3.14),('15128','2013-03-26','10:40:00',3.06),('15128','2013-03-26','10:45:00',2.6),('15128','2013-03-26','10:50:00',2.2),('15128','2013-03-26','10:55:00',2.04),('15128','2013-03-26','11:00:00',2.01),('15128','2013-03-26','11:05:00',2.1),('15128','2013-03-26','11:10:00',1.88),('15128','2013-03-26','11:15:00',1.69),('15128','2013-03-26','11:20:00',1.28),('15128','2013-03-26','11:25:00',1.06),('15128','2013-03-26','11:30:00',2.2),('15128','2013-03-26','11:35:00',2.24),('15128','2013-03-26','11:40:00',1.64),('15128','2013-03-26','11:45:00',1.56),('15128','2013-03-26','11:50:00',2.29),('15128','2013-03-26','11:55:00',2.21),('15128','2013-03-26','12:00:00',1.84),('15128','2013-03-26','12:05:00',2.43),('15128','2013-03-26','12:10:00',1.84),('15128','2013-03-26','12:15:00',1.67),('15128','2013-03-26','12:20:00',1.49),('15128','2013-03-26','12:25:00',2.26),('15128','2013-03-26','12:30:00',1.7),('15128','2013-03-26','12:35:00',1.3),('15128','2013-03-26','12:40:00',1.47),('15128','2013-03-26','12:45:00',1.68),('15128','2013-03-26','12:50:00',2.24),('15128','2013-03-26','12:55:00',2.32),('15128','2013-03-26','13:00:00',2.56),('15128','2013-03-26','13:05:00',2.33),('15128','2013-03-26','13:10:00',2.45),('15128','2013-03-26','13:15:00',2.22),('15128','2013-03-26','13:20:00',2.05),('15128','2013-03-26','13:25:00',1.91),('15128','2013-03-26','13:30:00',2.05),('15128','2013-03-26','13:35:00',2.21),('15128','2013-03-26','13:40:00',2.14),('15128','2013-03-26','13:45:00',2.4),('15128','2013-03-26','13:50:00',1.86),('15128','2013-03-26','13:55:00',1.81),('15128','2013-03-26','14:00:00',1.71),('15128','2013-03-26','14:05:00',1.92),('15128','2013-03-26','14:10:00',2.02),('15128','2013-03-26','14:15:00',2.06),('15128','2013-03-26','14:20:00',2.03),('15128','2013-03-26','14:25:00',1.82),('15128','2013-03-26','14:30:00',1.57),('15128','2013-03-26','14:35:00',1.67),('15128','2013-03-26','14:40:00',2),('15128','2013-03-26','14:45:00',2.09),('15128','2013-03-26','14:50:00',2.61),('15128','2013-03-26','14:55:00',3.09),('15128','2013-03-26','15:00:00',1.97),('15128','2013-03-26','15:05:00',1.53),('15128','2013-03-26','15:20:00',1.35),('15128','2013-03-26','15:25:00',1.64),('15128','2013-03-26','15:30:00',1.09),('15128','2013-03-26','16:20:00',1.56),('15128','2013-03-26','16:25:00',1.37),('15128','2013-03-26','16:30:00',1.61),('15128','2013-03-26','16:35:00',1.63),('15128','2013-03-26','16:40:00',1.76),('15128','2013-03-26','16:45:00',1.08),('15128','2013-03-26','16:50:00',1.06),('15128','2013-03-26','16:55:00',1.42),('15128','2013-03-26','17:00:00',1.74),('15128','2013-03-26','17:05:00',1.44),('15128','2013-03-25','08:30:00',1),('15128','2013-03-25','08:35:00',1.14),('15128','2013-03-25','08:40:00',1.12),('15128','2013-03-25','09:10:00',1.57),('15128','2013-03-25','09:15:00',1.16),('15128','2013-03-25','10:00:00',1.9),('15128','2013-03-25','10:05:00',1.48),('15128','2013-03-25','10:30:00',1.38),('15128','2013-03-25','10:35:00',1.56),('15128','2013-03-25','10:40:00',1.52),('15128','2013-03-25','10:45:00',1.68),('15128','2013-03-25','10:50:00',2.01),('15128','2013-03-25','10:55:00',2.57),('15128','2013-03-25','11:00:00',2.34),('15128','2013-03-25','11:35:00',1.25),('15128','2013-03-25','11:40:00',3.64),('15128','2013-03-25','11:45:00',4.49),('15128','2013-03-25','11:50:00',2.96),('15128','2013-03-25','11:55:00',3.78),('15128','2013-03-25','12:00:00',1.47),('15128','2013-03-25','12:10:00',1.14),('15128','2013-03-25','12:15:00',1.55),('15128','2013-03-25','12:20:00',2.71),('15128','2013-03-25','12:25:00',3.59),('15128','2013-03-25','12:30:00',3.29),('15128','2013-03-25','12:35:00',1.91),('15128','2013-03-25','12:40:00',1.33),('15128','2013-03-25','12:45:00',1.88),('15128','2013-03-25','12:50:00',3.08),('15128','2013-03-25','12:55:00',2.61),('15128','2013-03-25','13:00:00',1.88),('15128','2013-03-25','13:05:00',2.71),('15128','2013-03-25','13:10:00',1.86),('15128','2013-03-25','13:15:00',1.7),('15128','2013-03-25','13:20:00',1.61),('15128','2013-03-25','13:25:00',1.92),('15128','2013-03-25','13:30:00',1.9),('15128','2013-03-25','13:35:00',2.45),('15128','2013-03-25','13:40:00',2.83),('15128','2013-03-25','13:45:00',2.39),('15128','2013-03-25','13:50:00',2.02),('15128','2013-03-25','13:55:00',1.58),('15128','2013-03-25','14:00:00',1.13),('15128','2013-03-25','14:05:00',1.84),('15128','2013-03-25','14:10:00',2.28),('15128','2013-03-25','14:15:00',1.74),('15128','2013-03-25','14:20:00',1.39),('15128','2013-03-25','14:25:00',1.06),('15128','2013-03-25','14:30:00',1.18),('15128','2013-03-25','14:35:00',1.35),('15128','2013-03-25','14:40:00',1.36),('15128','2013-03-25','14:45:00',1.12),('15128','2013-03-25','15:05:00',1.1),('15128','2013-03-25','15:30:00',1),('15128','2013-03-24','08:20:00',1.01),('15128','2013-03-24','08:25:00',1.31),('15128','2013-03-24','08:30:00',1.92),('15128','2013-03-24','08:35:00',1.18),('15128','2013-03-24','08:50:00',1.02),('15128','2013-03-24','08:55:00',1.14),('15128','2013-03-24','09:00:00',1.05),('15128','2013-03-24','09:20:00',1.11),('15128','2013-03-24','09:25:00',2.07),('15128','2013-03-24','09:30:00',1.1),('15128','2013-03-24','09:40:00',1.07),('15128','2013-03-24','09:45:00',1.07),('15128','2013-03-24','09:50:00',1.11),('15128','2013-03-24','09:55:00',1.22),('15128','2013-03-24','10:00:00',1.17),('15128','2013-03-24','10:05:00',1.12),('15128','2013-03-24','10:10:00',1.44),('15128','2013-03-24','10:15:00',1.92),('15128','2013-03-24','10:20:00',1.25),('15128','2013-03-24','10:25:00',1.17),('15128','2013-03-24','10:30:00',1.5),('15128','2013-03-24','10:35:00',1.71),('15128','2013-03-24','10:40:00',1.84),('15128','2013-03-24','10:45:00',2.34),('15128','2013-03-24','10:50:00',2.89),('15128','2013-03-24','10:55:00',2.43),('15128','2013-03-24','11:00:00',1.28),('15128','2013-03-24','11:05:00',1.04),('15128','2013-03-24','11:10:00',1.06),('15128','2013-03-24','11:15:00',1.05),('15128','2013-03-24','11:25:00',1.23),('15128','2013-03-24','11:40:00',2.37),('15128','2013-03-24','11:45:00',4.71),('15128','2013-03-24','11:50:00',4.66),('15128','2013-03-24','11:55:00',4.73),('15128','2013-03-24','12:00:00',3.9),('15128','2013-03-24','12:05:00',3.02),('15128','2013-03-24','12:10:00',1.48),('15128','2013-03-24','12:15:00',3.02),('15128','2013-03-24','12:20:00',5.72),('15128','2013-03-24','12:25:00',5.2),('15128','2013-03-24','12:30:00',4.09),('15128','2013-03-24','12:35:00',3.76),('15128','2013-03-24','12:40:00',3.88),('15128','2013-03-24','12:45:00',5.02),('15128','2013-03-24','12:50:00',5),('15128','2013-03-24','12:55:00',2.92),('15128','2013-03-24','13:00:00',1.9),('15128','2013-03-24','13:05:00',1.8),('15128','2013-03-24','13:10:00',1.8),('15128','2013-03-24','13:15:00',2.8),('15128','2013-03-24','13:20:00',2.21),('15128','2013-03-24','13:25:00',3.53),('15128','2013-03-24','13:30:00',2.88),('15128','2013-03-24','13:35:00',2.73),('15128','2013-03-24','13:40:00',1.61),('15128','2013-03-24','13:45:00',2.58),('15128','2013-03-24','13:50:00',5.28),('15128','2013-03-24','13:55:00',5.33),('15128','2013-03-24','14:00:00',4.37),('15128','2013-03-24','14:05:00',2.93),('15128','2013-03-24','14:10:00',3.99),('15128','2013-03-24','14:15:00',4.11),('15128','2013-03-24','14:20:00',4.04),('15128','2013-03-24','14:25:00',4.57),('15128','2013-03-24','14:30:00',4.31),('15128','2013-03-24','14:35:00',2.43),('15128','2013-03-24','14:40:00',2.03),('15128','2013-03-24','14:45:00',2.28),('15128','2013-03-24','14:50:00',2.71),('15128','2013-03-24','14:55:00',2.93),('15128','2013-03-24','15:00:00',2.21),('15128','2013-03-24','15:05:00',3.77),('15128','2013-03-24','15:10:00',3.5),('15128','2013-03-24','15:15:00',3.39),('15128','2013-03-24','15:20:00',2.37),('15128','2013-03-24','15:25:00',3.99),('15128','2013-03-24','15:30:00',2.8),('15128','2013-03-24','15:35:00',3.36),('15128','2013-03-24','15:40:00',2.67),('15128','2013-03-24','15:45:00',3.44),('15128','2013-03-24','15:50:00',3.38),('15128','2013-03-24','15:55:00',2.75),('15128','2013-03-24','16:00:00',1.37),('15128','2013-03-24','16:05:00',1.02),('15128','2013-03-24','16:20:00',1.7),('15128','2013-03-24','16:25:00',1.69),('15128','2013-03-24','16:30:00',1.98),('15128','2013-03-24','16:35:00',1.07),('15128','2013-03-24','16:40:00',1.12),('15128','2013-03-24','16:45:00',1.02),('15128','2013-03-23','08:05:00',1.01),('15128','2013-03-23','08:10:00',1.09),('15128','2013-03-23','08:15:00',1.21),('15128','2013-03-23','08:20:00',1.29),('15128','2013-03-23','08:25:00',1.34),('15128','2013-03-23','08:30:00',1.43),('15128','2013-03-23','08:35:00',1.51),('15128','2013-03-23','08:40:00',1.58),('15128','2013-03-23','08:45:00',1.66),('15128','2013-03-23','08:50:00',1.69),('15128','2013-03-23','08:55:00',1.72),('15128','2013-03-23','09:00:00',1.79),('15128','2013-03-23','09:05:00',1.84),('15128','2013-03-23','09:10:00',1.93),('15128','2013-03-23','09:15:00',1.98),('15128','2013-03-23','09:20:00',2.02),('15128','2013-03-23','09:25:00',2.06),('15128','2013-03-23','09:30:00',2.15),('15128','2013-03-23','09:35:00',2.19),('15128','2013-03-23','09:40:00',2.24),('15128','2013-03-23','09:45:00',2.33),('15128','2013-03-23','09:50:00',2.34),('15128','2013-03-23','09:55:00',2.38),('15128','2013-03-23','10:00:00',2.41),('15128','2013-03-23','10:05:00',2.48),('15128','2013-03-23','10:10:00',2.54),('15128','2013-03-23','10:15:00',2.65),('15128','2013-03-23','10:20:00',2.75),('15128','2013-03-23','10:25:00',2.77),('15128','2013-03-23','10:30:00',2.89),('15128','2013-03-23','10:35:00',2.96),('15128','2013-03-23','10:40:00',2.93),('15128','2013-03-23','10:45:00',3.03),('15128','2013-03-23','10:50:00',3.04),('15128','2013-03-23','10:55:00',3.16),('15128','2013-03-23','11:00:00',3.22),('15128','2013-03-23','11:05:00',3.35),('15128','2013-03-23','11:10:00',3.44),('15128','2013-03-23','11:15:00',3.5),('15128','2013-03-23','11:20:00',3.54),('15128','2013-03-23','11:25:00',3.59),('15128','2013-03-23','11:30:00',3.61),('15128','2013-03-23','11:35:00',3.64),('15128','2013-03-23','11:40:00',3.67),('15128','2013-03-23','11:45:00',3.71),('15128','2013-03-23','11:50:00',3.72),('15128','2013-03-23','11:55:00',3.75),('15128','2013-03-23','12:00:00',3.78),('15128','2013-03-23','12:05:00',3.8),('15128','2013-03-23','12:10:00',3.8),('15128','2013-03-23','12:15:00',3.86),('15128','2013-03-23','12:20:00',3.92),('15128','2013-03-23','12:25:00',3.99),('15128','2013-03-23','12:30:00',4.02),('15128','2013-03-23','12:35:00',4.04),('15128','2013-03-23','12:40:00',4.05),('15128','2013-03-23','12:45:00',4.09),('15128','2013-03-23','12:50:00',4.11),('15128','2013-03-23','12:55:00',4.09),('15128','2013-03-23','13:00:00',4.09),('15128','2013-03-23','13:05:00',4.12),('15128','2013-03-23','13:10:00',4.09),('15128','2013-03-23','13:15:00',4.08),('15128','2013-03-23','13:20:00',4.08),('15128','2013-03-23','13:25:00',4.05),('15128','2013-03-23','13:30:00',4.04),('15128','2013-03-23','13:35:00',4.04),('15128','2013-03-23','13:40:00',4.01),('15128','2013-03-23','13:45:00',4.01),('15128','2013-03-23','13:50:00',3.98),('15128','2013-03-23','13:55:00',3.93),('15128','2013-03-23','14:00:00',3.87),('15128','2013-03-23','14:05:00',3.88),('15128','2013-03-23','14:10:00',3.84),('15128','2013-03-23','14:15:00',3.8),('15128','2013-03-23','14:20:00',3.71),('15128','2013-03-23','14:25:00',3.62),('15128','2013-03-23','14:30:00',3.56),('15128','2013-03-23','14:35:00',3.41),('15128','2013-03-23','14:40:00',3.49),('15128','2013-03-23','14:45:00',3.47),('15128','2013-03-23','14:50:00',3.37),('15128','2013-03-23','14:55:00',3.27),('15128','2013-03-23','15:00:00',3.23),('15128','2013-03-23','15:05:00',3.18),('15128','2013-03-23','15:10:00',3.14),('15128','2013-03-23','15:15:00',3.08),('15128','2013-03-23','15:20:00',3.11),('15128','2013-03-23','15:25:00',2.95),('15128','2013-03-23','15:30:00',2.8),('15128','2013-03-23','15:35:00',2.94),('15128','2013-03-23','15:40:00',2.65),('15128','2013-03-23','15:45:00',2.29),('15128','2013-03-23','15:50:00',1.39),('15128','2013-03-23','15:55:00',1.65),('15128','2013-03-23','16:00:00',1.5),('15128','2013-03-23','16:05:00',1.4),('15128','2013-03-23','16:10:00',1.25),('15128','2013-03-23','16:15:00',1.95),('15128','2013-03-23','16:20:00',1.76),('15128','2013-03-23','16:25:00',1.35),('15128','2013-03-23','16:30:00',1.26),('15128','2013-03-23','16:35:00',1.27),('15128','2013-03-22','08:10:00',1.06),('15128','2013-03-22','08:15:00',1.14),('15128','2013-03-22','08:20:00',1.24),('15128','2013-03-22','08:25:00',1.31),('15128','2013-03-22','08:30:00',1.41),('15128','2013-03-22','08:35:00',1.46),('15128','2013-03-22','08:40:00',1.57),('15128','2013-03-22','08:45:00',1.64),('15128','2013-03-22','08:50:00',1.73),('15128','2013-03-22','08:55:00',1.74),('15128','2013-03-22','09:00:00',1.86),('15128','2013-03-22','09:05:00',1.91),('15128','2013-03-22','09:10:00',2),('15128','2013-03-22','09:15:00',2.02),('15128','2013-03-22','09:20:00',2.08),('15128','2013-03-22','09:25:00',2.13),('15128','2013-03-22','09:30:00',2.2),('15128','2013-03-22','09:35:00',2.23),('15128','2013-03-22','09:40:00',2.23),('15128','2013-03-22','09:45:00',2.33),('15128','2013-03-22','09:50:00',2.34),('15128','2013-03-22','09:55:00',2.46),('15128','2013-03-22','10:00:00',2.47),('15128','2013-03-22','10:05:00',1.61),('15128','2013-03-22','10:10:00',2.59),('15128','2013-03-22','10:15:00',2.71),('15128','2013-03-22','10:20:00',2.89),('15128','2013-03-22','10:25:00',2.95),('15128','2013-03-22','10:30:00',2.88),('15128','2013-03-22','10:35:00',3.07),('15128','2013-03-22','10:40:00',3.1),('15128','2013-03-22','10:45:00',3.2),('15128','2013-03-22','10:50:00',3),('15128','2013-03-22','10:55:00',3.15),('15128','2013-03-22','11:00:00',2.79),('15128','2013-03-22','11:05:00',2.73),('15128','2013-03-22','11:10:00',3.24),('15128','2013-03-22','11:15:00',3.39),('15128','2013-03-22','11:20:00',3.09),('15128','2013-03-22','11:25:00',3.43),('15128','2013-03-22','11:30:00',3.64),('15128','2013-03-22','11:35:00',3.62),('15128','2013-03-22','11:40:00',3.41),('15128','2013-03-22','11:45:00',3.47),('15128','2013-03-22','11:50:00',3.6),('15128','2013-03-22','11:55:00',3.72),('15128','2013-03-22','12:00:00',3.79),('15128','2013-03-22','12:05:00',3.82),('15128','2013-03-22','12:10:00',3.9),('15128','2013-03-22','12:15:00',3.66),('15128','2013-03-22','12:20:00',3.95),('15128','2013-03-22','12:25:00',3.87),('15128','2013-03-22','12:30:00',3.75),('15128','2013-03-22','12:35:00',3.69),('15128','2013-03-22','12:40:00',3.87),('15128','2013-03-22','12:45:00',3.94),('15128','2013-03-22','12:50:00',4.04),('15128','2013-03-22','12:55:00',4),('15128','2013-03-22','13:00:00',3.64),('15128','2013-03-22','13:05:00',3.87),('15128','2013-03-22','13:10:00',3.87),('15128','2013-03-22','13:15:00',4.11),('15128','2013-03-22','13:20:00',4.05),('15128','2013-03-22','13:25:00',3.84),('15128','2013-03-22','13:30:00',3.35),('15128','2013-03-22','13:35:00',3.88),('15128','2013-03-22','13:40:00',3.94),('15128','2013-03-22','13:45:00',3.98),('15128','2013-03-22','13:50:00',3.96),('15128','2013-03-22','13:55:00',3.94),('15128','2013-03-22','14:00:00',3.96),('15128','2013-03-22','14:05:00',3.86),('15128','2013-03-22','14:10:00',3.7),('15128','2013-03-22','14:15:00',3.66),('15128','2013-03-22','14:20:00',3.78),('15128','2013-03-22','14:25:00',3.65),('15128','2013-03-22','14:30:00',3.64),('15128','2013-03-22','14:35:00',3.65),('15128','2013-03-22','14:40:00',3.42),('15128','2013-03-22','14:45:00',3.28),('15128','2013-03-22','14:50:00',3.39),('15128','2013-03-22','14:55:00',3.29),('15128','2013-03-22','15:00:00',3.23),('15128','2013-03-22','15:05:00',3.34),('15128','2013-03-22','15:10:00',2.88),('15128','2013-03-22','15:15:00',2.88),('15128','2013-03-22','15:20:00',3.06),('15128','2013-03-22','15:25:00',2.98),('15128','2013-03-22','15:30:00',2.8),('15128','2013-03-22','15:35:00',2.65),('15128','2013-03-22','15:40:00',2.72),('15128','2013-03-22','15:45:00',2.29),('15128','2013-03-22','15:50:00',1.94),('15128','2013-03-22','15:55:00',2.18),('15128','2013-03-22','16:00:00',1.97),('15128','2013-03-22','16:05:00',2.1),('15128','2013-03-22','16:10:00',2.29),('15128','2013-03-22','16:15:00',2.29),('15128','2013-03-22','16:20:00',2.02),('15128','2013-03-22','16:25:00',1.96),('15128','2013-03-22','16:30:00',1.68),('15128','2013-03-22','16:35:00',1.61),('15128','2013-03-22','16:40:00',1.35),('15128','2013-03-22','16:45:00',1.29),('15128','2013-03-22','16:50:00',1.35),('15128','2013-03-22','16:55:00',1.29),('15128','2013-03-22','17:00:00',1.6),('15128','2013-03-22','17:05:00',1.54),('15128','2013-03-22','17:10:00',1.31),('15128','2013-03-22','17:15:00',1.12),('15128','2014-03-25','08:00:00',1.06),('15128','2014-03-25','08:05:00',1.11),('15128','2014-03-25','08:10:00',1.11),('15128','2014-03-25','08:15:00',1.31),('15128','2014-03-25','08:20:00',1.62),('15128','2014-03-25','08:25:00',1.05),('15128','2014-03-25','08:30:00',1.03),('15128','2014-03-25','08:45:00',1.11),('15128','2014-03-25','08:50:00',1.03),('15128','2014-03-25','08:55:00',1.06),('15128','2014-03-25','09:00:00',1.19),('15128','2014-03-25','09:05:00',1.42),('15128','2014-03-25','09:10:00',1.73),('15128','2014-03-25','09:15:00',1.25),('15128','2014-03-25','09:20:00',1.59),('15128','2014-03-25','09:25:00',2.12),('15128','2014-03-25','09:30:00',2.2),('15128','2014-03-25','09:35:00',2.2),('15128','2014-03-25','09:40:00',2.19),('15128','2014-03-25','09:45:00',2.28),('15128','2014-03-25','09:50:00',2.37),('15128','2014-03-25','09:55:00',2.4),('15128','2014-03-25','10:00:00',2.51),('15128','2014-03-25','10:05:00',2.15),('15128','2014-03-25','10:10:00',2.58),('15128','2014-03-25','10:15:00',2.74),('15128','2014-03-25','10:20:00',2.88),('15128','2014-03-25','10:25:00',2.97),('15128','2014-03-25','10:30:00',2.79),('15128','2014-03-25','10:35:00',3.06),('15128','2014-03-25','10:40:00',1.81),('15128','2014-03-25','10:45:00',2.21),('15128','2014-03-25','10:50:00',1.35),('15128','2014-03-25','10:55:00',1.04),('15128','2014-03-25','11:00:00',1.08),('15128','2014-03-25','11:15:00',1.23),('15128','2014-03-25','11:20:00',1.6),('15128','2014-03-25','11:25:00',1.7),('15128','2014-03-25','11:30:00',1.3),('15128','2014-03-25','11:35:00',1.08),('15128','2014-03-25','12:00:00',1.83),('15128','2014-03-25','12:05:00',2.94),('15128','2014-03-25','12:10:00',2.08),('15128','2014-03-25','12:15:00',1.43),('15128','2014-03-25','12:20:00',1.08),('15128','2014-03-25','12:25:00',1.34),('15128','2014-03-25','12:30:00',1.77),('15128','2014-03-25','12:35:00',2.18),('15128','2014-03-25','12:40:00',2.97),('15128','2014-03-25','12:45:00',2.88),('15128','2014-03-25','12:50:00',4.37),('15128','2014-03-25','12:55:00',3.99),('15128','2014-03-25','13:00:00',2.17),('15128','2014-03-25','13:05:00',4.09),('15128','2014-03-25','13:10:00',1.58),('15128','2014-03-25','13:15:00',1.66),('15128','2014-03-25','13:20:00',1.62),('15128','2014-03-25','13:25:00',1.23),('15128','2014-03-25','13:30:00',1.09),('15128','2014-03-25','13:35:00',1.09),('15128','2014-03-25','13:40:00',1.67),('15128','2014-03-25','13:45:00',2.03),('15128','2014-03-25','13:50:00',2.39),('15128','2014-03-25','13:55:00',2.7),('15128','2014-03-25','14:00:00',3.69),('15128','2014-03-25','14:05:00',3.92),('15128','2014-03-25','14:10:00',3.59),('15128','2014-03-25','14:15:00',1.73),('15128','2014-03-25','14:20:00',3.81),('15128','2014-03-25','14:25:00',1.66),('15128','2014-03-25','15:10:00',1.28),('15128','2014-03-25','15:15:00',2.94),('15128','2014-03-25','15:20:00',3.46),('15128','2014-03-25','15:25:00',1.94),('15128','2014-03-25','15:30:00',3.03),('15128','2014-03-25','15:35:00',3.33),('15128','2014-03-25','15:40:00',2.87),('15128','2014-03-25','15:45:00',2.27),('15128','2014-03-25','15:50:00',1.4),('15128','2014-03-25','15:55:00',1.09),('15128','2014-03-25','16:25:00',1.61),('15128','2014-03-25','16:30:00',2.01),('15128','2014-03-25','16:35:00',1.18),('15128','2013-03-21','08:15:00',1.08),('15128','2013-03-21','08:20:00',1.18),('15128','2013-03-21','08:25:00',1.29),('15128','2013-03-21','08:30:00',1.37),('15128','2013-03-21','08:35:00',1.47),('15128','2013-03-21','08:40:00',1.56),('15128','2013-03-21','08:45:00',1.62),('15128','2013-03-21','08:50:00',1.67),('15128','2013-03-21','08:55:00',1.7),('15128','2013-03-21','09:00:00',1.81),('15128','2013-03-21','09:05:00',1.91),('15128','2013-03-21','09:10:00',1.97),('15128','2013-03-21','09:15:00',1.97),('15128','2013-03-21','09:20:00',2.01),('15128','2013-03-21','09:25:00',2.03),('15128','2013-03-21','09:30:00',2.1),('15128','2013-03-21','09:35:00',2.2),('15128','2013-03-21','09:40:00',2.23),('15128','2013-03-21','09:45:00',2.29),('15128','2013-03-21','09:50:00',2.38),('15128','2013-03-21','09:55:00',2.48),('15128','2013-03-21','10:00:00',2.51),('15128','2013-03-21','10:05:00',2.61),('15128','2013-03-21','10:10:00',2.62),('15128','2013-03-21','10:15:00',2.68),('15128','2013-03-21','10:20:00',2.76),('15128','2013-03-21','10:25:00',2.79),('15128','2013-03-21','10:30:00',2.88),('15128','2013-03-21','10:35:00',2.95),('15128','2013-03-21','10:40:00',3),('15128','2013-03-21','10:45:00',3.07),('15128','2013-03-21','10:50:00',3.11),('15128','2013-03-21','10:55:00',3.2),('15128','2013-03-21','11:00:00',3.24),('15128','2013-03-21','11:05:00',3.46),('15128','2013-03-21','11:10:00',3.57),('15128','2013-03-21','11:15:00',3.64),('15128','2013-03-21','11:20:00',3.67),('15128','2013-03-21','11:25:00',3.75),('15128','2013-03-21','11:30:00',3.79),('15128','2013-03-21','11:35:00',3.85),('15128','2013-03-21','11:40:00',3.87),('15128','2013-03-21','11:45:00',3.94),('15128','2013-03-21','11:50:00',3.96),('15128','2013-03-21','11:55:00',4.02),('15128','2013-03-21','12:00:00',4.05),('15128','2013-03-21','12:05:00',4.08),('15128','2013-03-21','12:10:00',4.12),('15128','2013-03-21','12:15:00',4.14),('15128','2013-03-21','12:20:00',4.17),('15128','2013-03-21','12:25:00',4.19),('15128','2013-03-21','12:30:00',4.22),('15128','2013-03-21','12:35:00',4.22),('15128','2013-03-21','12:40:00',4.24),('15128','2013-03-21','12:45:00',4.26),('15128','2013-03-21','12:50:00',3.72),('15128','2013-03-21','12:55:00',4.13),('15128','2013-03-21','13:00:00',4.13),('15128','2013-03-21','13:05:00',4.31),('15128','2013-03-21','13:10:00',4.25),('15128','2013-03-21','13:15:00',4.25),('15128','2013-03-21','13:20:00',4.06),('15128','2013-03-21','13:25:00',3.98),('15128','2013-03-21','13:30:00',4.17),('15128','2013-03-21','13:35:00',3.66),('15128','2013-03-21','13:40:00',3.29),('15128','2013-03-21','13:45:00',4.11),('15128','2013-03-21','13:50:00',4.11),('15128','2013-03-21','13:55:00',4.08),('15128','2013-03-21','14:00:00',4.07),('15128','2013-03-21','14:05:00',4.03),('15128','2013-03-21','14:10:00',3.99),('15128','2013-03-21','14:15:00',3.99),('15128','2013-03-21','14:20:00',3.93),('15128','2013-03-21','14:25:00',3.89),('15128','2013-03-21','14:30:00',3.85),('15128','2013-03-21','14:35:00',3.8),('15128','2013-03-21','14:40:00',3.76),('15128','2013-03-21','14:45:00',3.75),('15128','2013-03-21','14:50:00',3.63),('15128','2013-03-21','14:55:00',3.41),('15128','2013-03-21','15:00:00',2.64),('15128','2013-03-21','15:05:00',2.44),('15128','2013-03-21','15:10:00',3.41),('15128','2013-03-21','15:15:00',2.68),('15128','2013-03-21','15:20:00',2.75),('15128','2013-03-21','15:25:00',2.69),('15128','2013-03-21','15:30:00',2.97),('15128','2013-03-21','15:35:00',2.97),('15128','2013-03-21','15:40:00',2.83),('15128','2013-03-21','15:45:00',2.84),('15128','2013-03-21','15:50:00',2.77),('15128','2013-03-21','15:55:00',1.85),('15128','2013-03-21','16:00:00',1.56),('15128','2013-03-21','16:05:00',1.74),('15128','2013-03-21','16:10:00',2.25),('15128','2013-03-21','16:15:00',2.14),('15128','2013-03-21','16:20:00',1.15),('15128','2013-03-21','16:25:00',1.82),('15128','2013-03-21','16:30:00',2),('15128','2013-03-21','16:35:00',1.97),('15128','2013-03-21','16:40:00',1.84),('15128','2013-03-21','16:45:00',1.98),('15128','2013-03-21','16:50:00',2.03),('15128','2013-03-21','16:55:00',1.43),('15128','2013-03-21','17:00:00',1.7),('15128','2013-03-21','17:05:00',1.52),('15128','2013-03-21','17:10:00',1.02),('15128','2013-03-21','17:15:00',1.2),('15128','2013-03-20','08:15:00',1.11),('15128','2013-03-20','08:20:00',1.26),('15128','2013-03-20','08:25:00',1.41),('15128','2013-03-20','08:30:00',1.51),('15128','2013-03-20','08:35:00',1.64),('15128','2013-03-20','08:40:00',1.72),('15128','2013-03-20','08:45:00',2.14),('15128','2013-03-20','08:55:00',1.25),('15128','2013-03-20','09:00:00',1.93),('15128','2013-03-20','09:05:00',1.96),('15128','2013-03-20','09:10:00',1.66),('15128','2013-03-20','09:15:00',2.08),('15128','2013-03-20','09:20:00',2.14),('15128','2013-03-20','09:25:00',2.18),('15128','2013-03-20','09:30:00',2.28),('15128','2013-03-20','09:35:00',2.32),('15128','2013-03-20','09:40:00',2.37),('15128','2013-03-20','09:45:00',2.49),('15128','2013-03-20','09:50:00',2.53),('15128','2013-03-20','09:55:00',2.37),('15128','2013-03-20','10:00:00',2.66),('15128','2013-03-20','10:05:00',2.71),('15128','2013-03-20','10:10:00',2.88),('15128','2013-03-20','10:15:00',2.13),('15128','2013-03-20','10:20:00',2.52),('15128','2013-03-20','10:25:00',2.87),('15128','2013-03-20','10:30:00',3),('15128','2013-03-20','10:35:00',3.06),('15128','2013-03-20','10:40:00',3.19),('15128','2013-03-20','10:45:00',3.23),('15128','2013-03-20','10:50:00',3.27),('15128','2013-03-20','10:55:00',3.33),('15128','2013-03-20','11:00:00',3.42),('15128','2013-03-20','11:05:00',3.58),('15128','2013-03-20','11:10:00',3.66),('15128','2013-03-20','11:15:00',3.79),('15128','2013-03-20','11:20:00',3.82),('15128','2013-03-20','11:25:00',3.87),('15128','2013-03-20','11:30:00',3.93),('15128','2013-03-20','11:35:00',3.98),('15128','2013-03-20','11:40:00',4.01),('15128','2013-03-20','11:45:00',4.07),('15128','2013-03-20','11:50:00',4.1),('15128','2013-03-20','11:55:00',4.14),('15128','2013-03-20','12:00:00',4.18),('15128','2013-03-20','12:05:00',4.24),('15128','2013-03-20','12:10:00',4.26),('15128','2013-03-20','12:15:00',4.28),('15128','2013-03-20','12:20:00',4.33),('15128','2013-03-20','12:25:00',4.34),('15128','2013-03-20','12:30:00',4.34),('15128','2013-03-20','12:35:00',4.35),('15128','2013-03-20','12:40:00',4.38),('15128','2013-03-20','12:45:00',4.37),('15128','2013-03-20','12:50:00',4.38),('15128','2013-03-20','12:55:00',4.38),('15128','2013-03-20','13:00:00',4.37),('15128','2013-03-20','13:05:00',4.37),('15128','2013-03-20','13:10:00',4.37),('15128','2013-03-20','13:15:00',4.35),('15128','2013-03-20','13:20:00',4.36),('15128','2013-03-20','13:25:00',4.34),('15128','2013-03-20','13:30:00',4.31),('15128','2013-03-20','13:35:00',4.27),('15128','2013-03-20','13:40:00',4.26),('15128','2013-03-20','13:45:00',4.23),('15128','2013-03-20','13:50:00',4.22),('15128','2013-03-20','13:55:00',4.19),('15128','2013-03-20','14:00:00',4.16),('15128','2013-03-20','14:05:00',4.15),('15128','2013-03-20','14:10:00',4.09),('15128','2013-03-20','14:15:00',4.05),('15128','2013-03-20','14:20:00',4.02),('15128','2013-03-20','14:25:00',3.98),('15128','2013-03-20','14:30:00',3.93),('15128','2013-03-20','14:35:00',3.87),('15128','2013-03-20','14:40:00',3.81),('15128','2013-03-20','14:45:00',3.76),('15128','2013-03-20','14:50:00',3.7),('15128','2013-03-20','14:55:00',3.66),('15128','2013-03-20','15:00:00',3.62),('15128','2013-03-20','15:05:00',3.58),('15128','2013-03-20','15:10:00',3.5),('15128','2013-03-20','15:15:00',3.44),('15128','2013-03-20','15:20:00',3.39),('15128','2013-03-20','15:25:00',3.32),('15128','2013-03-20','15:30:00',3.26),('15128','2013-03-20','15:35:00',3.19),('15128','2013-03-20','15:40:00',3.11),('15128','2013-03-20','15:45:00',3.02),('15128','2013-03-20','15:50:00',2.95),('15128','2013-03-20','15:55:00',2.82),('15128','2013-03-20','16:00:00',2.71),('15128','2013-03-20','16:05:00',2.63),('15128','2013-03-20','16:10:00',2.52),('15128','2013-03-20','16:15:00',2.42),('15128','2013-03-20','16:20:00',2.32),('15128','2013-03-20','16:25:00',2.2),('15128','2013-03-20','16:30:00',2.08),('15128','2013-03-20','16:35:00',2.01),('15128','2013-03-20','16:40:00',1.96),('15128','2013-03-20','16:45:00',1.87),('15128','2013-03-20','16:50:00',1.79),('15128','2013-03-20','16:55:00',1.69),('15128','2013-03-20','17:00:00',1.55),('15128','2013-03-20','17:05:00',1.35),('15128','2013-03-20','17:10:00',1.23),('15128','2013-03-20','17:15:00',1.14),('15128','2013-03-20','17:20:00',1.02),('15128','2013-03-19','08:15:00',1.03),('15128','2013-03-19','08:20:00',1.13),('15128','2013-03-19','08:25:00',1.23),('15128','2013-03-19','08:30:00',1.33),('15128','2013-03-19','08:35:00',1.35),('15128','2013-03-19','08:40:00',1.36),('15128','2013-03-19','08:45:00',1.52),('15128','2013-03-19','08:50:00',1.52),('15128','2013-03-19','08:55:00',1.56),('15128','2013-03-19','09:00:00',1.88),('15128','2013-03-19','09:05:00',1.71),('15128','2013-03-19','09:10:00',1.58),('15128','2013-03-19','09:15:00',2.14),('15128','2013-03-19','09:20:00',2.27),('15128','2013-03-19','09:25:00',2.15),('15128','2013-03-19','09:30:00',1.75),('15128','2013-03-19','09:35:00',2),('15128','2013-03-19','09:40:00',2.19),('15128','2013-03-19','09:45:00',2.23),('15128','2013-03-19','09:50:00',2.33),('15128','2013-03-19','09:55:00',2.52),('15128','2013-03-19','10:00:00',2.62),('15128','2013-03-19','10:05:00',2.67),('15128','2013-03-19','10:10:00',2.59),('15128','2013-03-19','10:15:00',2.27),('15128','2013-03-19','10:20:00',2.02),('15128','2013-03-19','10:25:00',2.48),('15128','2013-03-19','10:30:00',2.97),('15128','2013-03-19','10:35:00',2.53),('15128','2013-03-19','10:40:00',2.22),('15128','2013-03-19','10:45:00',2.24),('15128','2013-03-19','10:50:00',2.74),('15128','2013-03-19','10:55:00',2.75),('15128','2013-03-19','11:00:00',2.47),('15128','2013-03-19','11:05:00',2.44),('15128','2013-03-19','11:10:00',2.33),('15128','2013-03-19','11:15:00',2.26),('15128','2013-03-19','11:20:00',2.51),('15128','2013-03-19','11:25:00',2.27),('15128','2013-03-19','11:30:00',2.32),('15128','2013-03-19','11:35:00',2.68),('15128','2013-03-19','11:40:00',2.27),('15128','2013-03-19','11:45:00',2.02),('15128','2013-03-19','11:50:00',2.06),('15128','2013-03-19','11:55:00',2.07),('15128','2013-03-19','12:00:00',2.24),('15128','2013-03-19','12:05:00',2.17),('15128','2013-03-19','12:10:00',2.02),('15128','2013-03-19','12:15:00',1.62),('15128','2013-03-19','12:20:00',1.48),('15128','2013-03-19','12:25:00',1.27),('15128','2013-03-19','12:30:00',1.24),('15128','2013-03-19','12:35:00',1.28),('15128','2013-03-19','12:40:00',1.08),('15128','2013-03-19','12:50:00',1.27),('15128','2013-03-19','12:55:00',1.68),('15128','2013-03-19','13:00:00',1.3),('15128','2013-03-19','13:05:00',1.01),('15128','2013-03-19','13:10:00',1.14),('15128','2013-03-19','13:15:00',1.01),('15128','2013-03-19','13:20:00',1.09),('15128','2013-03-19','13:25:00',1.4),('15128','2013-03-19','13:30:00',1.62),('15128','2013-03-19','13:35:00',1.53),('15128','2013-03-19','13:40:00',1.94),('15128','2013-03-19','13:45:00',2.03),('15128','2013-03-19','13:50:00',1.7),('15128','2013-03-19','13:55:00',1.8),('15128','2013-03-19','14:00:00',1.63),('15128','2013-03-19','14:05:00',1.36),('15128','2013-03-19','14:10:00',1.3),('15128','2013-03-19','14:15:00',1.7),('15128','2013-03-19','14:20:00',2.04),('15128','2013-03-19','14:25:00',2.28),('15128','2013-03-19','14:30:00',2.14),('15128','2013-03-19','14:35:00',1.55),('15128','2013-03-19','14:40:00',1.23),('15128','2013-03-19','14:45:00',1.03),('15128','2013-03-18','08:25:00',1.11),('15128','2013-03-18','08:30:00',1.23),('15128','2013-03-18','08:35:00',1.3),('15128','2013-03-18','08:40:00',1.39),('15128','2013-03-18','08:45:00',1.46),('15128','2013-03-18','08:50:00',1.5),('15128','2013-03-18','08:55:00',1.56),('15128','2013-03-18','09:00:00',1.63),('15128','2013-03-18','09:05:00',1.69),('15128','2013-03-18','09:10:00',1.8),('15128','2013-03-18','09:15:00',1.82),('15128','2013-03-18','09:20:00',1.86),('15128','2013-03-18','09:25:00',1.96),('15128','2013-03-18','09:30:00',2),('15128','2013-03-18','09:35:00',2.13),('15128','2013-03-18','09:40:00',2.17),('15128','2013-03-18','09:45:00',2.19),('15128','2013-03-18','09:50:00',2.31),('15128','2013-03-18','09:55:00',2.41),('15128','2013-03-18','10:00:00',2.45),('15128','2013-03-18','10:05:00',2.51),('15128','2013-03-18','10:10:00',2.6),('15128','2013-03-18','10:15:00',2.65),('15128','2013-03-18','10:20:00',2.66),('15128','2013-03-18','10:25:00',2.75),('15128','2013-03-18','10:30:00',2.85),('15128','2013-03-18','10:35:00',2.95),('15128','2013-03-18','10:40:00',2.96),('15128','2013-03-18','10:45:00',3.01),('15128','2013-03-18','10:50:00',3.13),('15128','2013-03-18','10:55:00',3.25),('15128','2013-03-18','11:00:00',3.34),('15128','2013-03-18','11:05:00',3.45),('15128','2013-03-18','11:10:00',3.59),('15128','2013-03-18','11:15:00',3.68),('15128','2013-03-18','11:20:00',3.7),('15128','2013-03-18','11:25:00',3.81),('15128','2013-03-18','11:30:00',3.65),('15128','2013-03-18','11:35:00',3.18),('15128','2013-03-18','11:40:00',3.1),('15128','2013-03-18','11:45:00',3.43),('15128','2013-03-18','11:50:00',3.68),('15128','2013-03-18','11:55:00',4.01),('15128','2013-03-18','12:00:00',4.03),('15128','2013-03-18','12:05:00',4.11),('15128','2013-03-18','12:10:00',4.11),('15128','2013-03-18','12:15:00',4.1),('15128','2013-03-18','12:20:00',4.1),('15128','2013-03-18','12:25:00',3.99),('15128','2013-03-18','12:30:00',4.13),('15128','2013-03-18','12:35:00',4.12),('15128','2013-03-18','12:40:00',4.11),('15128','2013-03-18','12:45:00',4.12),('15128','2013-03-18','12:50:00',4.12),('15128','2013-03-18','12:55:00',4.12),('15128','2013-03-18','13:00:00',4.13),('15128','2013-03-18','13:05:00',4.1),('15128','2013-03-18','13:10:00',4.1),('15128','2013-03-18','13:15:00',4.09),('15128','2013-03-18','13:20:00',4.08),('15128','2013-03-18','13:25:00',4.11),('15128','2013-03-18','13:30:00',4.1),('15128','2013-03-18','13:35:00',4.07),('15128','2013-03-18','13:40:00',4),('15128','2013-03-18','13:45:00',3.77),('15128','2013-03-18','13:50:00',3.97),('15128','2013-03-18','13:55:00',3.91),('15128','2013-03-18','14:00:00',3.9),('15128','2013-03-18','14:05:00',3.88),('15128','2013-03-18','14:10:00',3.9),('15128','2013-03-18','14:15:00',3.86),('15128','2013-03-18','14:20:00',3.8),('15128','2013-03-18','14:25:00',3.75),('15128','2013-03-18','14:30:00',3.71),('15128','2013-03-18','14:35:00',3.67),('15128','2013-03-18','14:40:00',3.66),('15128','2013-03-18','14:45:00',3.61),('15128','2013-03-18','14:50:00',3.57),('15128','2013-03-18','14:55:00',3.52),('15128','2013-03-18','15:00:00',3.46),('15128','2013-03-18','15:05:00',3.39),('15128','2013-03-18','15:10:00',3.33),('15128','2013-03-18','15:15:00',3.28),('15128','2013-03-18','15:20:00',3.21),('15128','2013-03-18','15:25:00',3.15),('15128','2013-03-18','15:30:00',3.1),('15128','2013-03-18','15:35:00',3.03),('15128','2013-03-18','15:40:00',2.96),('15128','2013-03-18','15:45:00',2.88),('15128','2013-03-18','15:50:00',2.82),('15128','2013-03-18','15:55:00',2.7),('15128','2013-03-18','16:00:00',2.58),('15128','2013-03-18','16:05:00',2.47),('15128','2013-03-18','16:10:00',2.36),('15128','2013-03-18','16:15:00',2.25),('15128','2013-03-18','16:20:00',2.17),('15128','2013-03-18','16:25:00',2.1),('15128','2013-03-18','16:30:00',2.04),('15128','2013-03-18','16:35:00',1.76),('15128','2013-03-18','16:40:00',1.91),('15128','2013-03-18','16:45:00',1.64),('15128','2013-03-18','16:50:00',1.2),('15128','2013-03-18','16:55:00',1.56),('15128','2013-03-18','17:15:00',1.13),('15128','2013-03-18','17:20:00',1.01),('15128','2013-03-17','08:40:00',1.38),('15128','2013-03-17','08:45:00',1.22),('15128','2013-03-17','09:55:00',1.22),('15128','2013-03-17','10:00:00',1.45),('15128','2013-03-17','10:05:00',1.56),('15128','2013-03-17','10:10:00',1.58),('15128','2013-03-17','10:15:00',2.27),('15128','2013-03-17','10:20:00',2.41),('15128','2013-03-17','10:25:00',2.81),('15128','2013-03-17','10:30:00',1.92),('15128','2013-03-17','10:35:00',1.67),('15128','2013-03-17','10:40:00',1.6),('15128','2013-03-17','10:45:00',1.81),('15128','2013-03-17','10:50:00',1.01),('15128','2013-03-17','11:00:00',1.17),('15128','2013-03-17','11:05:00',1.39),('15128','2013-03-17','11:10:00',1.66),('15128','2013-03-17','11:15:00',1.92),('15128','2013-03-17','11:20:00',2.06),('15128','2013-03-17','11:25:00',2.26),('15128','2013-03-17','11:30:00',2.15),('15128','2013-03-17','11:35:00',1.82),('15128','2013-03-17','11:40:00',1.38),('15128','2013-03-17','11:45:00',1.21),('15128','2013-03-17','11:50:00',1.12),('15128','2013-03-17','11:55:00',1.24),('15128','2013-03-17','12:00:00',1.44),('15128','2013-03-17','12:05:00',1.76),('15128','2013-03-17','12:10:00',2.08),('15128','2013-03-17','12:15:00',2.96),('15128','2013-03-17','12:20:00',3.41),('15128','2013-03-17','12:25:00',4.42),('15128','2013-03-17','12:30:00',3.58),('15128','2013-03-17','12:35:00',1.75),('15128','2013-03-17','12:40:00',1.84),('15128','2013-03-17','12:45:00',2.62),('15128','2013-03-17','12:50:00',3.41),('15128','2013-03-17','12:55:00',2.16),('15128','2013-03-17','13:00:00',1.22),('15128','2013-03-17','13:05:00',1.31),('15128','2013-03-17','13:10:00',1.14),('15128','2013-03-17','13:20:00',2),('15128','2013-03-17','13:25:00',2.01),('15128','2013-03-17','13:30:00',1.1),('15128','2013-03-17','13:35:00',1.34),('15128','2013-03-17','13:40:00',1.41),('15128','2013-03-17','13:45:00',1.23),('15128','2013-03-17','13:55:00',1.14),('15128','2013-03-17','14:00:00',2.07),('15128','2013-03-17','14:05:00',1.6),('15128','2013-03-17','14:10:00',1.91),('15128','2013-03-17','14:35:00',1.08),('15128','2013-03-17','14:40:00',1.1),('15128','2013-03-16','08:20:00',1.18),('15128','2013-03-16','08:25:00',1.27),('15128','2013-03-16','08:30:00',1.27),('15128','2013-03-16','08:35:00',1.12),('15128','2013-03-16','08:40:00',1.18),('15128','2013-03-16','08:45:00',1.22),('15128','2013-03-16','08:50:00',1.15),('15128','2013-03-16','08:55:00',1.11),('15128','2013-03-16','09:00:00',1.36),('15128','2013-03-16','09:05:00',1.63),('15128','2013-03-16','09:10:00',1.64),('15128','2013-03-16','09:15:00',1.59),('15128','2013-03-16','09:20:00',1.49),('15128','2013-03-16','09:25:00',1.34),('15128','2013-03-16','09:30:00',1.59),('15128','2013-03-16','09:35:00',1.59),('15128','2013-03-16','09:40:00',1.56),('15128','2013-03-16','09:45:00',1.68),('15128','2013-03-16','09:50:00',1.76),('15128','2013-03-16','09:55:00',1.85),('15128','2013-03-16','10:00:00',1.83),('15128','2013-03-16','10:05:00',1.7),('15128','2013-03-16','10:10:00',1.79),('15128','2013-03-16','10:15:00',1.82),('15128','2013-03-16','10:20:00',1.88),('15128','2013-03-16','10:25:00',2.02),('15128','2013-03-16','10:30:00',1.93),('15128','2013-03-16','10:35:00',1.91),('15128','2013-03-16','10:40:00',1.93),('15128','2013-03-16','10:45:00',1.88),('15128','2013-03-16','10:50:00',1.5),('15128','2013-03-16','10:55:00',1.33),('15128','2013-03-16','11:00:00',1.44),('15128','2013-03-16','11:05:00',1.61),('15128','2013-03-16','11:10:00',1.69),('15128','2013-03-16','11:15:00',2.06),('15128','2013-03-16','11:20:00',2.35),('15128','2013-03-16','11:25:00',2.04),('15128','2013-03-16','11:30:00',1.87),('15128','2013-03-16','11:35:00',1.8),('15128','2013-03-16','11:40:00',1.65),('15128','2013-03-16','11:45:00',1.46),('15128','2013-03-16','11:50:00',1.35),('15128','2013-03-16','11:55:00',1.26),('15128','2013-03-16','12:00:00',1.17),('15128','2013-03-16','12:05:00',1.39),('15128','2013-03-16','12:10:00',1.78),('15128','2013-03-16','12:15:00',2.33),('15128','2013-03-16','12:20:00',2.51),('15128','2013-03-16','12:25:00',2.63),('15128','2013-03-16','12:30:00',2.31),('15128','2013-03-16','12:35:00',2.18),('15128','2013-03-16','12:40:00',2.36),('15128','2013-03-16','12:45:00',2.3),('15128','2013-03-16','12:50:00',1.88),('15128','2013-03-16','12:55:00',1.82),('15128','2013-03-16','13:00:00',1.77),('15128','2013-03-16','13:05:00',1.74),('15128','2013-03-16','13:10:00',1.8),('15128','2013-03-16','13:15:00',1.66),('15128','2013-03-16','13:20:00',1.5),('15128','2013-03-16','13:25:00',2.34),('15128','2013-03-16','13:30:00',2.69),('15128','2013-03-16','13:35:00',2.57),('15128','2013-03-16','13:40:00',1.83),('15128','2013-03-16','13:45:00',1.42),('15128','2013-03-16','13:50:00',1.71),('15128','2013-03-16','13:55:00',2.06),('15128','2013-03-16','14:00:00',2.04),('15128','2013-03-16','14:05:00',2.47),('15128','2013-03-16','14:10:00',2.77),('15128','2013-03-16','14:15:00',2.91),('15128','2013-03-16','14:20:00',2.55),('15128','2013-03-16','14:25:00',2.46),('15128','2013-03-16','14:30:00',2.59),('15128','2013-03-16','14:35:00',2.59),('15128','2013-03-16','14:40:00',1.85),('15128','2013-03-16','14:45:00',1.52),('15128','2013-03-16','14:50:00',1.34),('15128','2013-03-16','14:55:00',1.73),('15128','2013-03-16','15:00:00',1.79),('15128','2013-03-16','15:05:00',2.87),('15128','2013-03-16','15:10:00',3.49),('15128','2013-03-16','15:15:00',2.3),('15128','2013-03-16','15:20:00',2.31),('15128','2013-03-16','15:25:00',3.07),('15128','2013-03-16','15:30:00',1.75),('15128','2013-03-16','15:35:00',1.47),('15128','2013-03-16','15:40:00',1.09),('15128','2013-03-16','15:45:00',1.18),('15128','2013-03-15','08:10:00',1.01),('15128','2013-03-15','08:20:00',1.23),('15128','2013-03-15','08:25:00',1.21),('15128','2013-03-15','08:30:00',1.29),('15128','2013-03-15','08:35:00',1.52),('15128','2013-03-15','08:40:00',1.7),('15128','2013-03-15','08:45:00',1.52),('15128','2013-03-15','08:50:00',1.81),('15128','2013-03-15','08:55:00',1.39),('15128','2013-03-15','09:00:00',1.89),('15128','2013-03-15','09:05:00',1.54),('15128','2013-03-15','09:10:00',1.95),('15128','2013-03-15','09:15:00',1.99),('15128','2013-03-15','09:20:00',2.05),('15128','2013-03-15','09:25:00',2.13),('15128','2013-03-15','09:30:00',2.12),('15128','2013-03-15','09:35:00',2.24),('15128','2013-03-15','09:40:00',1.87),('15128','2013-03-15','09:45:00',1.74),('15128','2013-03-15','09:50:00',2.49),('15128','2013-03-15','09:55:00',1.5),('15128','2013-03-15','10:00:00',1.62),('15128','2013-03-15','10:05:00',1.55),('15128','2013-03-15','10:10:00',1.58),('15128','2013-03-15','10:15:00',1.6),('15128','2013-03-15','10:20:00',2.23),('15128','2013-03-15','10:25:00',2.27),('15128','2013-03-15','10:30:00',3.12),('15128','2013-03-15','10:35:00',3.11),('15128','2013-03-15','10:40:00',3.13),('15128','2013-03-15','10:45:00',3.18),('15128','2013-03-15','10:50:00',3.18),('15128','2013-03-15','10:55:00',3.23),('15128','2013-03-15','11:00:00',3.33),('15128','2013-03-15','11:05:00',3.3),('15128','2013-03-15','11:10:00',3.45),('15128','2013-03-15','11:15:00',3.67),('15128','2013-03-15','11:20:00',3.74),('15128','2013-03-15','11:25:00',3.8),('15128','2013-03-15','11:30:00',3.86),('15128','2013-03-15','11:35:00',3.89),('15128','2013-03-15','11:40:00',3.93),('15128','2013-03-15','11:45:00',3.98),('15128','2013-03-15','11:50:00',4.09),('15128','2013-03-15','11:55:00',4.16),('15128','2013-03-15','12:00:00',4.13),('15128','2013-03-15','12:05:00',4.12),('15128','2013-03-15','12:10:00',4.26),('15128','2013-03-15','12:15:00',4.41),('15128','2013-03-15','12:20:00',4.37),('15128','2013-03-15','12:25:00',4.4),('15128','2013-03-15','12:30:00',4.44),('15128','2013-03-15','12:35:00',4.39),('15128','2013-03-15','12:40:00',4.1),('15128','2013-03-15','12:45:00',4.4),('15128','2013-03-15','12:50:00',4.11),('15128','2013-03-15','12:55:00',4.29),('15128','2013-03-15','13:00:00',4.34),('15128','2013-03-15','13:05:00',4.21),('15128','2013-03-15','13:10:00',2.75),('15128','2013-03-15','13:15:00',4.22),('15128','2013-03-15','13:20:00',4.43),('15128','2013-03-15','13:25:00',3.51),('15128','2013-03-15','13:30:00',3.1),('15128','2013-03-15','13:35:00',2.99),('15128','2013-03-15','13:40:00',3.98),('15128','2013-03-15','13:45:00',1.06),('15128','2013-03-15','13:50:00',2.5),('15128','2013-03-15','13:55:00',1.85),('15128','2013-03-15','14:00:00',2.6),('15128','2013-03-15','14:05:00',3.42),('15128','2013-03-15','14:10:00',4.34),('15128','2013-03-15','14:15:00',4.22),('15128','2013-03-15','14:20:00',1.33),('15128','2013-03-15','14:25:00',1.08),('15128','2013-03-15','14:30:00',4.28),('15128','2013-03-15','14:35:00',3.99),('15128','2013-03-15','14:40:00',3.14),('15128','2013-03-15','14:45:00',1.08),('15128','2013-03-15','14:50:00',1.84),('15128','2013-03-15','14:55:00',3.78),('15128','2013-03-15','15:00:00',3.65),('15128','2013-03-15','15:05:00',3.5),('15128','2013-03-15','15:10:00',3.44),('15128','2013-03-15','15:15:00',3.42),('15128','2013-03-15','15:20:00',3.41),('15128','2013-03-15','15:25:00',3.37),('15128','2013-03-15','15:30:00',3.26),('15128','2013-03-15','15:35:00',3.06),('15128','2013-03-15','15:40:00',2.96),('15128','2013-03-15','15:45:00',2.92),('15128','2013-03-15','15:50:00',2),('15128','2013-03-15','15:55:00',2.68),('15128','2013-03-15','16:00:00',2.47),('15128','2013-03-15','16:05:00',2.26),('15128','2013-03-15','16:10:00',1.19),('15128','2013-03-15','16:15:00',2.07),('15128','2013-03-15','16:20:00',2.39),('15128','2013-03-15','16:25:00',2.34),('15128','2013-03-15','16:30:00',2.17),('15128','2013-03-15','16:35:00',2.13),('15128','2013-03-15','16:40:00',2.13),('15128','2013-03-15','16:45:00',1.53),('15128','2013-03-15','16:55:00',1.6),('15128','2013-03-15','17:00:00',1.24),('15128','2013-03-15','17:20:00',1.08),('15128','2013-03-14','10:25:00',1.16),('15128','2013-03-14','10:30:00',1.3),('15128','2013-03-14','10:35:00',1.34),('15128','2013-03-14','10:40:00',1.4),('15128','2013-03-14','10:45:00',1.23),('15128','2013-03-14','10:50:00',1.2),('15128','2013-03-14','10:55:00',1.51),('15128','2013-03-14','11:00:00',1.71),('15128','2013-03-14','11:05:00',1.35),('15128','2013-03-14','11:10:00',1.11),('15128','2013-03-14','11:15:00',1.07),('15128','2013-03-14','11:20:00',1.06),('15128','2013-03-14','11:25:00',1.11),('15128','2013-03-14','11:30:00',1.35),('15128','2013-03-14','11:35:00',1.56),('15128','2013-03-14','11:40:00',1.77),('15128','2013-03-14','11:45:00',1.6),('15128','2013-03-14','11:50:00',1.47),('15128','2013-03-14','11:55:00',1.72),('15128','2013-03-14','12:00:00',1.93),('15128','2013-03-14','12:05:00',1.79),('15128','2013-03-14','12:10:00',1.96),('15128','2013-03-14','12:15:00',2.34),('15128','2013-03-14','12:20:00',2.42),('15128','2013-03-14','12:25:00',2.19),('15128','2013-03-14','12:30:00',1.72),('15128','2013-03-14','12:35:00',1.58),('15128','2013-03-14','12:40:00',1.66),('15128','2013-03-14','12:45:00',1.72),('15128','2013-03-14','12:50:00',1.57),('15128','2013-03-14','12:55:00',1.45),('15128','2013-03-14','13:00:00',1.55),('15128','2013-03-14','13:05:00',1.78),('15128','2013-03-14','13:10:00',2.13),('15128','2013-03-14','13:15:00',2.85),('15128','2013-03-14','13:20:00',2.42),('15128','2013-03-14','13:25:00',2),('15128','2013-03-14','13:30:00',1.68),('15128','2013-03-14','13:35:00',1.63),('15128','2013-03-14','13:40:00',1.35),('15128','2013-03-14','13:45:00',1.15),('15128','2013-03-14','13:50:00',1.24),('15128','2013-03-14','13:55:00',1.18),('15128','2013-03-14','14:00:00',1),('15128','2013-03-14','14:35:00',1.2),('15128','2013-03-14','14:40:00',1.35),('15128','2013-03-14','14:45:00',1.38),('15128','2013-03-14','14:50:00',1.41),('15128','2013-03-14','14:55:00',1.35),('15128','2013-03-14','15:00:00',1.38),('15128','2013-03-14','15:05:00',1.36),('15128','2013-03-14','15:10:00',1.32),('15128','2013-03-14','15:15:00',1.42),('15128','2013-03-14','15:20:00',1.42),('15128','2013-03-14','15:25:00',1.22),('15128','2013-03-14','15:30:00',1.19),('15128','2013-03-14','15:35:00',1.18),('15128','2013-03-14','15:40:00',1.03),('15128','2013-03-14','16:55:00',1.01),('15128','2013-03-14','17:00:00',1.44),('15128','2013-03-14','17:10:00',1.09),('15128','2013-03-14','17:15:00',1.13),('15128','2013-03-13','09:55:00',1.03),('15128','2013-03-13','12:25:00',1.03),('15128','2013-03-13','12:30:00',1.16),('15128','2013-03-13','12:35:00',1.25),('15128','2013-03-13','12:40:00',1.29),('15128','2013-03-13','12:45:00',1.17),('15128','2013-03-13','12:50:00',1.16),('15128','2013-03-13','12:55:00',1.29),('15128','2013-03-13','13:00:00',1.52),('15128','2013-03-13','13:05:00',1.58),('15128','2013-03-13','13:10:00',1.6),('15128','2013-03-13','13:15:00',1.57),('15128','2013-03-13','13:20:00',1.42),('15128','2013-03-13','13:25:00',1.4),('15128','2013-03-13','13:30:00',1.62),('15128','2013-03-13','13:35:00',1.64),('15128','2013-03-13','13:40:00',1.85),('15128','2013-03-13','13:45:00',1.69),('15128','2013-03-13','13:50:00',1.25),('15128','2013-03-13','13:55:00',1.01),('15128','2013-03-13','14:00:00',1.39),('15128','2013-03-13','14:05:00',1.62),('15128','2013-03-13','14:10:00',1.65),('15128','2013-03-13','14:15:00',1.69),('15128','2013-03-13','14:20:00',1.24),('15128','2013-03-13','15:15:00',1.08),('15128','2013-03-13','15:20:00',1.08),('15128','2013-03-12','09:10:00',1.02),('15128','2013-03-12','09:15:00',1.21),('15128','2013-03-12','09:20:00',1.35),('15128','2013-03-12','09:25:00',1.32),('15128','2013-03-12','09:30:00',1.17),('15128','2013-03-12','10:35:00',1.08),('15128','2013-03-12','10:40:00',2.25),('15128','2013-03-12','10:45:00',2.45),('15128','2013-03-12','10:50:00',2.28),('15128','2013-03-12','10:55:00',1.81),('15128','2013-03-12','11:00:00',1.23),('15128','2013-03-12','11:05:00',1.41),('15128','2013-03-12','11:10:00',2.07),('15128','2013-03-12','11:15:00',1.65),('15128','2013-03-12','11:25:00',1.36),('15128','2013-03-12','11:30:00',1.4),('15128','2013-03-12','11:35:00',1.88),('15128','2013-03-12','11:40:00',1.6),('15128','2013-03-12','11:45:00',1.77),('15128','2013-03-12','11:50:00',1.7),('15128','2013-03-12','11:55:00',1.5),('15128','2013-03-12','12:40:00',1.1),('15128','2013-03-12','12:45:00',1.15),('15128','2013-03-12','12:50:00',1.25),('15128','2013-03-12','12:55:00',1.28),('15128','2013-03-12','13:00:00',1.2),('15128','2013-03-12','13:05:00',1.15),('15128','2013-03-12','13:10:00',1.14),('15128','2013-03-12','13:35:00',1.24),('15128','2013-03-12','13:40:00',1.82),('15128','2013-03-12','13:45:00',1.65),('15128','2013-03-12','13:50:00',1.29),('15128','2013-03-12','13:55:00',1.02),('15128','2014-03-24','08:10:00',1),('15128','2014-03-24','08:35:00',1.08),('15128','2014-03-24','08:40:00',1.26),('15128','2014-03-24','08:45:00',1.38),('15128','2014-03-24','08:50:00',1.44),('15128','2014-03-24','08:55:00',1.46),('15128','2014-03-24','09:00:00',1.46),('15128','2014-03-24','09:05:00',1.59),('15128','2014-03-24','09:10:00',1.66),('15128','2014-03-24','09:15:00',1.96),('15128','2014-03-24','09:20:00',2.03),('15128','2014-03-24','09:25:00',1.79),('15128','2014-03-24','09:30:00',1.67),('15128','2014-03-24','09:35:00',1.65),('15128','2014-03-24','09:40:00',1.64),('15128','2014-03-24','09:45:00',1.62),('15128','2014-03-24','09:50:00',1.76),('15128','2014-03-24','09:55:00',1.94),('15128','2014-03-24','10:00:00',2.04),('15128','2014-03-24','10:05:00',2.16),('15128','2014-03-24','10:10:00',2.31),('15128','2014-03-24','10:15:00',2.43),('15128','2014-03-24','10:20:00',2.59),('15128','2014-03-24','10:25:00',2.4),('15128','2014-03-24','10:30:00',2.2),('15128','2014-03-24','10:35:00',2.14),('15128','2014-03-24','10:40:00',1.95),('15128','2014-03-24','10:45:00',1.81),('15128','2014-03-24','10:50:00',1.98),('15128','2014-03-24','10:55:00',2.25),('15128','2014-03-24','11:00:00',2.37),('15128','2014-03-24','11:05:00',2.51),('15128','2014-03-24','11:10:00',2.57),('15128','2014-03-24','11:15:00',2.65),('15128','2014-03-24','11:20:00',2.81),('15128','2014-03-24','11:25:00',2.97),('15128','2014-03-24','11:30:00',3.05),('15128','2014-03-24','11:35:00',3.02),('15128','2014-03-24','11:40:00',2.92),('15128','2014-03-24','11:45:00',2.76),('15128','2014-03-24','11:50:00',2.24),('15128','2014-03-24','11:55:00',1.86),('15128','2014-03-24','12:00:00',1.36),('15128','2014-03-24','12:05:00',1.16),('15128','2014-03-24','12:10:00',1.1),('15128','2014-03-24','12:15:00',1.28),('15128','2014-03-24','12:20:00',1.31),('15128','2014-03-24','12:25:00',1.32),('15128','2014-03-24','12:45:00',1.15),('15128','2014-03-24','12:50:00',1.21),('15128','2014-03-24','12:55:00',1.32),('15128','2014-03-24','13:00:00',1.16),('15128','2013-03-11','08:30:00',1.13),('15128','2013-03-11','08:35:00',1.18),('15128','2013-03-11','08:40:00',1.17),('15128','2013-03-11','08:45:00',1.35),('15128','2013-03-11','08:50:00',1.41),('15128','2013-03-11','08:55:00',1.52),('15128','2013-03-11','09:00:00',1.58),('15128','2013-03-11','09:05:00',1.64),('15128','2013-03-11','09:10:00',1.71),('15128','2013-03-11','09:15:00',1.81),('15128','2013-03-11','09:20:00',1.88),('15128','2013-03-11','09:25:00',1.96),('15128','2013-03-11','09:30:00',2),('15128','2013-03-11','09:35:00',2.04),('15128','2013-03-11','09:40:00',2.14),('15128','2013-03-11','09:45:00',2.21),('15128','2013-03-11','09:50:00',2.27),('15128','2013-03-11','09:55:00',2.05),('15128','2013-03-11','10:00:00',2.64),('15128','2013-03-11','10:05:00',2.56),('15128','2013-03-11','10:10:00',1.97),('15128','2013-03-11','10:15:00',1.26),('15128','2013-03-11','10:20:00',2.62),('15128','2013-03-11','10:25:00',3.25),('15128','2013-03-11','10:30:00',2.16),('15128','2013-03-11','10:35:00',3.22),('15128','2013-03-11','10:40:00',2.55),('15128','2013-03-11','10:45:00',3.14),('15128','2013-03-11','10:50:00',2.91),('15128','2013-03-11','10:55:00',3.19),('15128','2013-03-11','11:00:00',3.5),('15128','2013-03-11','11:05:00',2.42),('15128','2013-03-11','11:10:00',1.59),('15128','2013-03-11','11:15:00',3.55),('15128','2013-03-11','11:20:00',2.56),('15128','2013-03-11','11:25:00',2.17),('15128','2013-03-11','11:30:00',1.22),('15128','2013-03-11','11:35:00',1.12),('15128','2013-03-11','11:40:00',1.43),('15128','2013-03-11','11:45:00',1.48),('15128','2013-03-11','11:50:00',2.71),('15128','2013-03-11','11:55:00',5.32),('15128','2013-03-11','12:00:00',5.21),('15128','2013-03-11','12:05:00',1.46),('15128','2013-03-11','12:20:00',1.82),('15128','2013-03-11','12:25:00',1.88),('15128','2013-03-11','12:30:00',1.6),('15128','2013-03-11','12:35:00',1.93),('15128','2013-03-11','12:40:00',1.59),('15128','2013-03-11','12:45:00',2.63),('15128','2013-03-11','12:50:00',3.57),('15128','2013-03-11','12:55:00',2.33),('15128','2013-03-11','13:00:00',1.76),('15128','2013-03-11','13:05:00',3.51),('15128','2013-03-11','13:10:00',2.31),('15128','2013-03-11','13:15:00',2.2),('15128','2013-03-11','13:20:00',1.48),('15128','2013-03-11','13:25:00',1.56),('15128','2013-03-11','13:30:00',2.79),('15128','2013-03-11','13:35:00',2.63),('15128','2013-03-11','13:40:00',2.91),('15128','2013-03-11','13:45:00',2.97),('15128','2013-03-11','13:50:00',2.88),('15128','2013-03-11','13:55:00',3.44),('15128','2013-03-11','14:00:00',3.04),('15128','2013-03-11','14:05:00',3.23),('15128','2013-03-11','14:10:00',2.12),('15128','2013-03-11','14:15:00',4.39),('15128','2013-03-11','14:20:00',3.55),('15128','2013-03-11','14:25:00',2.67),('15128','2013-03-11','14:55:00',2.65),('15128','2013-03-11','15:00:00',2.54),('15128','2013-03-11','15:05:00',1.8),('15128','2013-03-11','15:10:00',1.76),('15128','2013-03-11','15:15:00',1.9),('15128','2013-03-11','15:20:00',2.02),('15128','2013-03-11','15:25:00',1.3),('15128','2013-03-10','08:20:00',1.05),('15128','2013-03-10','08:30:00',1.04),('15128','2013-03-10','08:35:00',1.13),('15128','2013-03-10','08:40:00',1.35),('15128','2013-03-10','08:45:00',1.26),('15128','2013-03-10','08:50:00',1.75),('15128','2013-03-10','08:55:00',1.45),('15128','2013-03-10','09:00:00',1.58),('15128','2013-03-10','09:05:00',1.32),('15128','2013-03-10','09:10:00',1.7),('15128','2013-03-10','09:15:00',1.79),('15128','2013-03-10','09:20:00',2),('15128','2013-03-10','09:25:00',2.25),('15128','2013-03-10','09:30:00',2.35),('15128','2013-03-10','09:35:00',1.99),('15128','2013-03-10','09:40:00',1.75),('15128','2013-03-10','09:45:00',1.54),('15128','2013-03-10','10:00:00',1.52),('15128','2013-03-10','10:05:00',2.01),('15128','2013-03-10','10:10:00',2.04),('15128','2013-03-10','10:15:00',1.74),('15128','2013-03-10','10:20:00',1.69),('15128','2013-03-10','10:25:00',1.91),('15128','2013-03-10','10:30:00',1.93),('15128','2013-03-10','10:35:00',1.77),('15128','2013-03-10','10:40:00',1.73),('15128','2013-03-10','10:45:00',1.83),('15128','2013-03-10','10:50:00',1.82),('15128','2013-03-10','10:55:00',1.5),('15128','2013-03-10','11:00:00',1.68),('15128','2013-03-10','11:05:00',1.51),('15128','2013-03-10','11:10:00',1.56),('15128','2013-03-10','11:15:00',1.66),('15128','2013-03-10','11:20:00',1.51),('15128','2013-03-10','11:25:00',1.77),('15128','2013-03-10','11:30:00',1.42),('15128','2013-03-10','11:35:00',1.52),('15128','2013-03-10','11:40:00',1.98),('15128','2013-03-10','11:45:00',1.86),('15128','2013-03-10','11:50:00',1.33),('15128','2013-03-10','11:55:00',1.74),('15128','2013-03-10','12:00:00',2.18),('15128','2013-03-10','12:05:00',2.37),('15128','2013-03-10','12:10:00',2.92),('15128','2013-03-10','12:15:00',3.79),('15128','2013-03-10','12:20:00',2.02),('15128','2013-03-10','12:25:00',3.71),('15128','2013-03-10','12:30:00',3.01),('15128','2013-03-10','12:35:00',4.44),('15128','2013-03-10','12:40:00',4.55),('15128','2013-03-10','12:45:00',4.33),('15128','2013-03-10','12:50:00',4.18),('15128','2013-03-10','12:55:00',3.96),('15128','2013-03-10','13:00:00',4.28),('15128','2013-03-10','13:05:00',4.01),('15128','2013-03-10','13:10:00',4.2),('15128','2013-03-10','13:15:00',4.11),('15128','2013-03-10','13:20:00',3.94),('15128','2013-03-10','13:25:00',4.21),('15128','2013-03-10','13:30:00',4.19),('15128','2013-03-10','13:35:00',2.67),('15128','2013-03-10','13:40:00',1.71),('15128','2013-03-10','13:45:00',2.35),('15128','2013-03-10','13:50:00',4.52),('15128','2013-03-10','13:55:00',4.25),('15128','2013-03-10','14:00:00',4.27),('15128','2013-03-10','14:05:00',3.68),('15128','2013-03-10','14:10:00',4.19),('15128','2013-03-10','14:15:00',4.15),('15128','2013-03-10','14:20:00',3.35),('15128','2013-03-10','14:25:00',3.48),('15128','2013-03-10','14:30:00',2.97),('15128','2013-03-10','14:35:00',2.58),('15128','2013-03-10','14:40:00',3.76),('15128','2013-03-10','14:45:00',3.5),('15128','2013-03-10','14:50:00',3.65),('15128','2013-03-10','14:55:00',3.17),('15128','2013-03-10','15:00:00',3.37),('15128','2013-03-10','15:05:00',2.56),('15128','2013-03-10','15:10:00',3.34),('15128','2013-03-10','15:15:00',3.31),('15128','2013-03-10','15:20:00',3.26),('15128','2013-03-10','15:25:00',3.26),('15128','2013-03-10','15:30:00',1.58),('15128','2013-03-10','15:35:00',2.86),('15128','2013-03-10','15:40:00',2.11),('15128','2013-03-10','15:45:00',1.85),('15128','2013-03-10','15:50:00',2.59),('15128','2013-03-10','15:55:00',2.38),('15128','2013-03-10','16:00:00',2.25),('15128','2013-03-10','16:05:00',2.09),('15128','2013-03-10','16:10:00',1.85),('15128','2013-03-10','16:15:00',1.97),('15128','2013-03-10','16:20:00',1.92),('15128','2013-03-10','16:25:00',1.77),('15128','2013-03-10','16:30:00',1.74),('15128','2013-03-10','16:35:00',1.6),('15128','2013-03-10','16:40:00',1.31),('15128','2013-03-09','08:35:00',1.09),('15128','2013-03-09','08:40:00',1.19),('15128','2013-03-09','08:45:00',1.29),('15128','2013-03-09','08:50:00',1.39),('15128','2013-03-09','08:55:00',1.47),('15128','2013-03-09','09:00:00',1.54),('15128','2013-03-09','09:05:00',1.59),('15128','2013-03-09','09:10:00',1.65),('15128','2013-03-09','09:15:00',1.77),('15128','2013-03-09','09:20:00',1.85),('15128','2013-03-09','09:25:00',1.89),('15128','2013-03-09','09:30:00',1.96),('15128','2013-03-09','09:35:00',2.03),('15128','2013-03-09','09:40:00',2.17),('15128','2013-03-09','09:45:00',2.29),('15128','2013-03-09','09:50:00',2.22),('15128','2013-03-09','09:55:00',2.27),('15128','2013-03-09','10:00:00',2.27),('15128','2013-03-09','10:15:00',2.52),('15128','2013-03-09','10:20:00',2.59),('15128','2013-03-09','10:25:00',2.71),('15128','2013-03-09','10:30:00',2.87),('15128','2013-03-09','10:35:00',2.79),('15128','2013-03-09','10:40:00',2.75),('15128','2013-03-09','10:45:00',2.66),('15128','2013-03-09','10:50:00',2.91),('15128','2013-03-09','10:55:00',3.01),('15128','2013-03-09','11:00:00',3.12),('15128','2013-03-09','11:05:00',3.08),('15128','2013-03-09','11:10:00',3.17),('15128','2013-03-09','11:15:00',3.34),('15128','2013-03-09','11:20:00',3.38),('15128','2013-03-09','11:55:00',3.21),('15128','2013-03-09','12:00:00',3.89),('15128','2013-03-09','12:05:00',3.32),('15128','2013-03-09','12:10:00',3.91),('15128','2013-03-09','12:15:00',4.04),('15128','2013-03-09','12:20:00',3.8),('15128','2013-03-09','12:25:00',3.97),('15128','2013-03-09','12:30:00',4.04),('15128','2013-03-09','12:35:00',3.99),('15128','2013-03-09','12:40:00',3.97),('15128','2013-03-09','12:45:00',2.7),('15128','2013-03-09','12:50:00',4.52),('15128','2013-03-09','12:55:00',4.66),('15128','2013-03-09','13:00:00',4.14),('15128','2013-03-09','13:05:00',4.22),('15128','2013-03-09','13:10:00',4.37),('15128','2013-03-09','13:15:00',3.84),('15128','2013-03-09','13:20:00',2.42),('15128','2013-03-09','13:25:00',4.56),('15128','2013-03-09','13:30:00',3.75),('15128','2013-03-09','13:35:00',3.01),('15128','2013-03-09','13:40:00',2.56),('15128','2013-03-09','13:45:00',2.13),('15128','2013-03-09','13:50:00',1.82),('15128','2013-03-09','13:55:00',1.74),('15128','2013-03-09','14:00:00',1.59),('15128','2013-03-09','14:05:00',1.8),('15128','2013-03-09','14:10:00',1.86),('15128','2013-03-09','14:15:00',1.89),('15128','2013-03-09','14:20:00',1.96),('15128','2013-03-09','14:25:00',2.13),('15128','2013-03-09','14:30:00',1.93),('15128','2013-03-09','14:35:00',1.67),('15128','2013-03-09','14:40:00',1.88),('15128','2013-03-09','14:45:00',1.54),('15128','2013-03-09','14:50:00',1.49),('15128','2013-03-09','14:55:00',1.34),('15128','2013-03-09','15:15:00',1.13),('15128','2013-03-08','08:35:00',1.07),('15128','2013-03-08','08:40:00',1.15),('15128','2013-03-08','08:45:00',1.24),('15128','2013-03-08','08:50:00',1.34),('15128','2013-03-08','08:55:00',1.41),('15128','2013-03-08','09:00:00',1.31),('15128','2013-03-08','09:15:00',1.32),('15128','2013-03-08','09:20:00',1.6),('15128','2013-03-08','09:25:00',1.17),('15128','2013-03-08','09:40:00',1.04),('15128','2013-03-08','09:45:00',1.38),('15128','2013-03-08','09:50:00',1.59),('15128','2013-03-08','09:55:00',1.92),('15128','2013-03-08','10:00:00',2.35),('15128','2013-03-08','10:15:00',1.55),('15128','2013-03-08','10:20:00',1.07),('15128','2013-03-08','10:25:00',1.3),('15128','2013-03-08','10:30:00',2.31),('15128','2013-03-08','10:35:00',2.33),('15128','2013-03-08','10:40:00',2.25),('15128','2013-03-08','10:45:00',2.02),('15128','2013-03-08','10:50:00',2.87),('15128','2013-03-08','10:55:00',3.12),('15128','2013-03-08','11:00:00',3.12),('15128','2013-03-08','11:05:00',3.05),('15128','2013-03-08','11:10:00',3.33),('15128','2013-03-08','11:15:00',3.39),('15128','2013-03-08','11:20:00',3.62),('15128','2013-03-08','11:25:00',3.61),('15128','2013-03-08','11:30:00',3.59),('15128','2013-03-08','11:35:00',3.68),('15128','2013-03-08','11:40:00',3.71),('15128','2013-03-08','11:45:00',3.64),('15128','2013-03-08','11:50:00',3.68),('15128','2013-03-08','11:55:00',3.75),('15128','2013-03-08','12:00:00',3.76),('15128','2013-03-08','12:05:00',3.84),('15128','2013-03-08','12:10:00',3.88),('15128','2013-03-08','12:15:00',2.39),('15128','2013-03-08','12:20:00',2.59),('15128','2013-03-08','12:25:00',4.51),('15128','2013-03-08','12:30:00',3.3),('15128','2013-03-08','12:35:00',1.98),('15128','2013-03-08','12:40:00',3.18),('15128','2013-03-08','12:45:00',3.8),('15128','2013-03-08','12:50:00',4.19),('15128','2013-03-08','12:55:00',3.95),('15128','2013-03-08','13:00:00',3.91),('15128','2013-03-08','13:05:00',3.95),('15128','2013-03-08','13:10:00',3.02),('15128','2013-03-08','13:15:00',4.1),('15128','2013-03-08','13:20:00',3.63),('15128','2013-03-08','13:25:00',4.04),('15128','2013-03-08','13:30:00',3.9),('15128','2013-03-08','13:35:00',3.83),('15128','2013-03-08','13:40:00',3.81),('15128','2013-03-08','13:45:00',3.59),('15128','2013-03-08','13:50:00',3.76),('15128','2013-03-08','13:55:00',3.77),('15128','2013-03-08','14:00:00',3.79),('15128','2013-03-08','14:05:00',3.69),('15128','2013-03-08','14:10:00',3.66),('15128','2013-03-08','14:15:00',3.63),('15128','2013-03-08','14:20:00',3.6),('15128','2013-03-08','14:25:00',2.55),('15128','2013-03-08','14:30:00',2.8),('15128','2013-03-08','14:35:00',3.3),('15128','2013-03-08','14:40:00',3.52),('15128','2013-03-08','14:45:00',3.42),('15128','2013-03-08','14:50:00',3.36),('15128','2013-03-08','14:55:00',3.29),('15128','2013-03-08','15:00:00',3.23),('15128','2013-03-08','15:05:00',3.16),('15128','2013-03-08','15:10:00',3.07),('15128','2013-03-08','15:15:00',3.02),('15128','2013-03-08','15:20:00',2.96),('15128','2013-03-08','15:25:00',2.94),('15128','2013-03-08','15:30:00',2.88),('15128','2013-03-08','15:35:00',2.83),('15128','2013-03-08','15:40:00',2.74),('15128','2013-03-08','15:45:00',2.65),('15128','2013-03-08','15:50:00',2.51),('15128','2013-03-08','15:55:00',2.34),('15128','2013-03-08','16:00:00',2.01),('15128','2013-03-08','16:05:00',1.81),('15128','2013-03-08','16:10:00',1.9),('15128','2013-03-08','16:15:00',1.38),('15128','2013-03-08','16:30:00',1.21),('15128','2013-03-08','16:40:00',1.25),('15128','2013-03-08','16:45:00',1.21),('15128','2013-03-07','08:30:00',1.32),('15128','2013-03-07','09:10:00',1.77),('15128','2013-03-07','09:15:00',2.01),('15128','2013-03-07','09:20:00',1.81),('15128','2013-03-07','09:25:00',1.62),('15128','2013-03-07','09:30:00',1.69),('15128','2013-03-07','09:35:00',1.73),('15128','2013-03-07','09:40:00',1.69),('15128','2013-03-07','09:45:00',1.73),('15128','2013-03-07','09:50:00',2.47),('15128','2013-03-07','09:55:00',1.81),('15128','2013-03-07','10:00:00',2.09),('15128','2013-03-07','10:05:00',1.31),('15128','2013-03-07','10:10:00',1.43),('15128','2013-03-07','10:15:00',1.76),('15128','2013-03-07','10:20:00',1.52),('15128','2013-03-07','12:05:00',1.31),('15128','2013-03-07','12:10:00',1.28),('15128','2013-03-07','12:15:00',1.04),('15128','2013-03-07','12:20:00',1.16),('15128','2013-03-07','12:30:00',1.08),('15128','2013-03-07','12:35:00',1.5),('15128','2013-03-07','12:40:00',1.59),('15128','2013-03-07','12:45:00',1.26),('15128','2013-03-07','12:50:00',1.61),('15128','2013-03-07','12:55:00',2.3),('15128','2013-03-07','13:00:00',2.05),('15128','2013-03-07','13:05:00',1.7),('15128','2013-03-07','13:10:00',1.39),('15128','2013-03-07','13:15:00',1.21),('15128','2013-03-07','13:20:00',1.06),('15128','2013-03-07','13:30:00',1.3),('15128','2013-03-07','13:35:00',2.07),('15128','2013-03-07','13:40:00',1.15),('15128','2013-03-07','13:45:00',1.29),('15128','2013-03-06','08:50:00',1.05),('15128','2013-03-06','08:55:00',1.01),('15128','2013-03-06','10:40:00',1.28),('15128','2013-03-06','10:45:00',2.03),('15128','2013-03-06','10:50:00',1.91),('15128','2013-03-06','10:55:00',2.23),('15128','2013-03-06','11:00:00',1.34),('15128','2013-03-06','11:05:00',1.04),('15128','2013-03-06','11:40:00',2.65),('15128','2013-03-06','11:45:00',2.79),('15128','2013-03-06','11:50:00',2.19),('15128','2013-03-06','11:55:00',2.04),('15128','2013-03-06','12:00:00',1.89),('15128','2013-03-06','12:05:00',1.48),('15128','2013-03-06','12:10:00',1.33),('15128','2013-03-06','12:15:00',1.02),('15128','2013-03-06','12:20:00',1.12),('15128','2013-03-06','12:25:00',2.14),('15128','2013-03-06','12:30:00',2.01),('15128','2013-03-06','12:35:00',1.24),('15128','2013-03-06','12:55:00',1.44),('15128','2013-03-06','13:00:00',1.92),('15128','2013-03-06','13:05:00',2.52),('15128','2013-03-06','13:10:00',2.63),('15128','2013-03-06','13:15:00',3.06),('15128','2013-03-06','13:20:00',1.35),('15128','2013-03-06','13:25:00',1.04),('15128','2013-03-06','13:30:00',1.01),('15128','2013-03-06','13:35:00',1.37),('15128','2013-03-06','13:40:00',1.55),('15128','2013-03-06','14:05:00',1.28),('15128','2013-03-06','14:10:00',1.18),('15128','2013-03-06','14:20:00',1.02),('15128','2013-03-06','15:20:00',1.2),('15128','2013-03-06','15:25:00',1.12),('15128','2013-03-06','16:30:00',1.22),('15128','2013-03-06','16:35:00',1.37),('15128','2013-03-06','16:40:00',1.01),('15128','2013-03-04','08:40:00',1.1),('15128','2013-03-04','08:45:00',1.24),('15128','2013-03-04','08:50:00',1.44),('15128','2013-03-04','08:55:00',1.53),('15128','2013-03-04','09:00:00',1.4),('15128','2013-03-04','09:05:00',1.36),('15128','2013-03-04','09:10:00',1.32),('15128','2013-03-04','09:15:00',1.38),('15128','2013-03-04','09:20:00',1.43),('15128','2013-03-04','09:25:00',1.38),('15128','2013-03-04','09:30:00',1.5),('15128','2013-03-04','09:35:00',1.6),('15128','2013-03-04','09:40:00',1.62),('15128','2013-03-04','09:45:00',1.64),('15128','2013-03-04','09:50:00',1.6),('15128','2013-03-04','09:55:00',1.92),('15128','2013-03-04','10:00:00',1.73),('15128','2013-03-04','10:05:00',1.61),('15128','2013-03-04','10:10:00',1.55),('15128','2013-03-04','10:15:00',1.66),('15128','2013-03-04','10:20:00',1.88),('15128','2013-03-04','10:25:00',1.62),('15128','2013-03-04','10:30:00',1.61),('15128','2013-03-04','10:35:00',1.81),('15128','2013-03-04','10:40:00',2.06),('15128','2013-03-04','10:45:00',2.27),('15128','2013-03-04','10:50:00',2.48),('15128','2013-03-04','10:55:00',2.49),('15128','2013-03-04','11:00:00',2.47),('15128','2013-03-04','11:05:00',2.58),('15128','2013-03-04','11:10:00',2.69),('15128','2013-03-04','11:15:00',2.47),('15128','2013-03-04','11:20:00',2.47),('15128','2013-03-04','11:25:00',2.39),('15128','2013-03-04','11:30:00',2.49),('15128','2013-03-04','11:35:00',2.87),('15128','2013-03-04','11:40:00',2.93),('15128','2013-03-04','11:45:00',2.97),('15128','2013-03-04','11:50:00',3.1),('15128','2013-03-04','11:55:00',3.15),('15128','2013-03-04','12:00:00',3.13),('15128','2013-03-04','12:05:00',3.3),('15128','2013-03-04','12:10:00',3.12),('15128','2013-03-04','12:15:00',3.05),('15128','2013-03-04','12:20:00',3.32),('15128','2013-03-04','12:25:00',2.96),('15128','2013-03-04','12:30:00',2.88),('15128','2013-03-04','12:35:00',2.84),('15128','2013-03-04','12:40:00',2.64),('15128','2013-03-04','12:45:00',2.48),('15128','2013-03-04','12:50:00',2.44),('15128','2013-03-04','12:55:00',2.01),('15128','2013-03-04','13:00:00',1.77),('15128','2013-03-04','13:05:00',1.77),('15128','2013-03-04','13:10:00',1.92),('15128','2013-03-04','13:15:00',1.94),('15128','2013-03-04','13:20:00',1.84),('15128','2013-03-04','13:25:00',1.67),('15128','2013-03-04','13:30:00',1.49),('15128','2013-03-04','13:35:00',1.4),('15128','2013-03-04','13:40:00',1.31),('15128','2013-03-04','13:45:00',1.18),('15128','2013-03-04','13:50:00',1.14),('15128','2013-03-04','13:55:00',1.2),('15128','2013-03-04','14:00:00',1.26),('15128','2013-03-04','14:05:00',1.25),('15128','2013-03-04','14:10:00',1.17),('15128','2013-03-04','14:15:00',1.05),('15128','2013-03-04','14:20:00',1.07),('15128','2013-03-04','14:25:00',1.11),('15128','2013-03-04','14:30:00',1.12),('15128','2013-03-04','14:35:00',1.11),('15128','2013-03-04','14:40:00',1.1),('15128','2013-03-04','14:45:00',1.12),('15128','2013-03-04','14:50:00',1.07),('15128','2013-03-04','15:30:00',1.03),('15128','2013-03-04','15:35:00',1.13),('15128','2013-03-04','15:40:00',1.29),('15128','2013-03-04','15:45:00',1.44),('15128','2013-03-04','15:50:00',1.23),('15128','2013-03-04','15:55:00',1.06),('15128','2013-03-03','08:45:00',1.1),('15128','2013-03-03','08:50:00',1.19),('15128','2013-03-03','08:55:00',1.26),('15128','2013-03-03','09:00:00',1.34),('15128','2013-03-03','09:05:00',1.42),('15128','2013-03-03','09:10:00',1.5),('15128','2013-03-03','09:15:00',1.54),('15128','2013-03-03','09:20:00',1.62),('15128','2013-03-03','09:25:00',1.72),('15128','2013-03-03','09:30:00',1.79),('15128','2013-03-03','09:35:00',1.83),('15128','2013-03-03','09:40:00',1.89),('15128','2013-03-03','09:45:00',1.94),('15128','2013-03-03','09:50:00',1.99),('15128','2013-03-03','09:55:00',2.02),('15128','2013-03-03','10:00:00',2.09),('15128','2013-03-03','10:05:00',2.18),('15128','2013-03-03','10:10:00',2.23),('15128','2013-03-03','10:15:00',2.28),('15128','2013-03-03','10:20:00',2.31),('15128','2013-03-03','10:25:00',2.42),('15128','2013-03-03','10:30:00',2.41),('15128','2013-03-03','10:35:00',2.45),('15128','2013-03-03','10:40:00',2.55),('15128','2013-03-03','10:45:00',2.53),('15128','2013-03-03','10:50:00',2.61),('15128','2013-03-03','10:55:00',2.66),('15128','2013-03-03','11:00:00',2.76),('15128','2013-03-03','11:05:00',2.85),('15128','2013-03-03','11:10:00',2.84),('15128','2013-03-03','11:15:00',3.05),('15128','2013-03-03','11:20:00',3.17),('15128','2013-03-03','11:25:00',3.26),('15128','2013-03-03','11:30:00',3.29),('15128','2013-03-03','11:35:00',3.35),('15128','2013-03-03','11:40:00',3.39),('15128','2013-03-03','11:45:00',3.42),('15128','2013-03-03','11:50:00',3.5),('15128','2013-03-03','11:55:00',3.51),('15128','2013-03-03','12:00:00',3.52),('15128','2013-03-03','12:05:00',3.59),('15128','2013-03-03','12:10:00',3.6),('15128','2013-03-03','12:15:00',3.62),('15128','2013-03-03','12:20:00',3.64),('15128','2013-03-03','12:25:00',3.65),('15128','2013-03-03','12:30:00',3.64),('15128','2013-03-03','12:35:00',3.68),('15128','2013-03-03','12:40:00',3.72),('15128','2013-03-03','12:45:00',3.73),('15128','2013-03-03','12:50:00',3.66),('15128','2013-03-03','12:55:00',3.56),('15128','2013-03-03','13:00:00',3.58),('15128','2013-03-03','13:05:00',3.63),('15128','2013-03-03','13:10:00',3.68),('15128','2013-03-03','13:15:00',3.64),('15128','2013-03-03','13:20:00',3.68),('15128','2013-03-03','13:25:00',3.65),('15128','2013-03-03','13:30:00',3.47),('15128','2013-03-03','13:35:00',3.29),('15128','2013-03-03','13:40:00',3.58),('15128','2013-03-03','13:45:00',3.5),('15128','2013-03-03','13:50:00',3.54),('15128','2013-03-03','13:55:00',3.51),('15128','2013-03-03','14:00:00',3.48),('15128','2013-03-03','14:05:00',3.45),('15128','2013-03-03','14:10:00',3.42),('15128','2013-03-03','14:15:00',3.37),('15128','2013-03-03','14:20:00',3.36),('15128','2013-03-03','14:25:00',3.33),('15128','2013-03-03','14:30:00',3.3),('15128','2013-03-03','14:35:00',3.25),('15128','2013-03-03','14:40:00',3.16),('15128','2013-03-03','14:45:00',3.14),('15128','2013-03-03','14:50:00',3.05),('15128','2013-03-03','14:55:00',3.02),('15128','2013-03-03','15:00:00',2.98),('15128','2013-03-03','15:05:00',2.92),('15128','2013-03-03','15:10:00',2.85),('15128','2013-03-03','15:15:00',2.82),('15128','2013-03-03','15:20:00',2.72),('15128','2013-03-03','15:25:00',2.68),('15128','2013-03-03','15:30:00',2.63),('15128','2013-03-03','15:35:00',2.55),('15128','2013-03-03','15:40:00',2.38),('15128','2013-03-03','15:45:00',2.29),('15128','2013-03-03','15:50:00',2.21),('15128','2013-03-03','15:55:00',2.12),('15128','2013-03-03','16:00:00',1.99),('15128','2013-03-03','16:05:00',1.85),('15128','2013-03-03','16:10:00',1.82),('15128','2013-03-03','16:15:00',1.73),('15128','2013-03-03','16:20:00',1.71),('15128','2013-03-03','16:25:00',1.67),('15128','2013-03-03','16:30:00',1.55),('15128','2013-03-03','16:35:00',1.48),('15128','2013-03-03','16:40:00',1.36),('15128','2013-03-03','16:45:00',1.22),('15128','2013-03-03','16:50:00',1.12),('15128','2013-03-03','16:55:00',1.01),('15128','2013-03-02','08:40:00',1.01),('15128','2013-03-02','08:45:00',1.12),('15128','2013-03-02','08:50:00',1.21),('15128','2013-03-02','08:55:00',1.29),('15128','2013-03-02','09:00:00',1.38),('15128','2013-03-02','09:05:00',1.47),('15128','2013-03-02','09:10:00',1.56),('15128','2013-03-02','09:15:00',1.61),('15128','2013-03-02','09:20:00',1.67),('15128','2013-03-02','09:25:00',1.77),('15128','2013-03-02','09:30:00',1.82),('15128','2013-03-02','09:35:00',1.87),('15128','2013-03-02','09:40:00',1.91),('15128','2013-03-02','09:45:00',1.97),('15128','2013-03-02','09:50:00',2.04),('15128','2013-03-02','09:55:00',2.08),('15128','2013-03-02','10:00:00',2.17),('15128','2013-03-02','10:05:00',2.24),('15128','2013-03-02','10:10:00',2.32),('15128','2013-03-02','10:15:00',2.39),('15128','2013-03-02','10:20:00',2.44),('15128','2013-03-02','10:25:00',2.48),('15128','2013-03-02','10:30:00',2.53),('15128','2013-03-02','10:35:00',2.6),('15128','2013-03-02','10:40:00',2.69),('15128','2013-03-02','10:45:00',2.79),('15128','2013-03-02','10:50:00',2.85),('15128','2013-03-02','10:55:00',2.78),('15128','2013-03-02','11:00:00',2.94),('15128','2013-03-02','11:05:00',2.97),('15128','2013-03-02','11:10:00',3.07),('15128','2013-03-02','11:15:00',3.22),('15128','2013-03-02','11:20:00',3.31),('15128','2013-03-02','11:25:00',3.37),('15128','2013-03-02','11:30:00',3.45),('15128','2013-03-02','11:35:00',3.49),('15128','2013-03-02','11:40:00',3.51),('15128','2013-03-02','11:45:00',3.55),('15128','2013-03-02','11:50:00',3.59),('15128','2013-03-02','11:55:00',3.62),('15128','2013-03-02','12:00:00',3.66),('15128','2013-03-02','12:05:00',3.7),('15128','2013-03-02','12:10:00',3.73),('15128','2013-03-02','12:15:00',3.74),('15128','2013-03-02','12:20:00',3.78),('15128','2013-03-02','12:25:00',3.79),('15128','2013-03-02','12:30:00',3.8),('15128','2013-03-02','12:35:00',3.81),('15128','2013-03-02','12:40:00',3.81),('15128','2013-03-02','12:45:00',3.78),('15128','2013-03-02','12:50:00',3.76),('15128','2013-03-02','12:55:00',3.79),('15128','2013-03-02','13:00:00',3.82),('15128','2013-03-02','13:05:00',3.82),('15128','2013-03-02','13:10:00',3.81),('15128','2013-03-02','13:15:00',3.81),('15128','2013-03-02','13:20:00',3.79),('15128','2013-03-02','13:25:00',3.78),('15128','2013-03-02','13:30:00',3.78),('15128','2013-03-02','13:35:00',3.77),('15128','2013-03-02','13:40:00',3.74),('15128','2013-03-02','13:45:00',3.74),('15128','2013-03-02','13:50:00',3.74),('15128','2013-03-02','13:55:00',3.7),('15128','2013-03-02','14:00:00',3.67),('15128','2013-03-02','14:05:00',3.64),('15128','2013-03-02','14:10:00',3.6),('15128','2013-03-02','14:15:00',3.56),('15128','2013-03-02','14:20:00',3.5),('15128','2013-03-02','14:25:00',3.47),('15128','2013-03-02','14:30:00',3.42),('15128','2013-03-02','14:35:00',3.39),('15128','2013-03-02','14:40:00',3.37),('15128','2013-03-02','14:45:00',3.3),('15128','2013-03-02','14:50:00',3.25),('15128','2013-03-02','14:55:00',3.2),('15128','2013-03-02','15:00:00',3.16),('15128','2013-03-02','15:05:00',3.1),('15128','2013-03-02','15:10:00',3.01),('15128','2013-03-02','15:15:00',2.98),('15128','2013-03-02','15:20:00',2.91),('15128','2013-03-02','15:25:00',2.84),('15128','2013-03-02','15:30:00',2.79),('15128','2013-03-02','15:35:00',2.74),('15128','2013-03-02','15:40:00',2.65),('15128','2013-03-02','15:45:00',2.55),('15128','2013-03-02','15:50:00',2.44),('15128','2013-03-02','15:55:00',2.3),('15128','2013-03-02','16:00:00',2.17),('15128','2013-03-02','16:05:00',2.06),('15128','2013-03-02','16:10:00',2.01),('15128','2013-03-02','16:15:00',1.88),('15128','2013-03-02','16:20:00',1.85),('15128','2013-03-02','16:25:00',1.77),('15128','2013-03-02','16:30:00',1.68),('15128','2013-03-02','16:35:00',1.62),('15128','2013-03-02','16:40:00',1.5),('15128','2013-03-02','16:45:00',1.38),('15128','2013-03-02','16:50:00',1.27),('15128','2013-03-02','16:55:00',1.15),('15128','2013-03-02','17:00:00',1.01),('15128','2014-03-23','08:45:00',1.06),('15128','2014-03-23','08:50:00',1.34),('15128','2014-03-23','09:15:00',1.74),('15128','2014-03-23','09:20:00',1.36),('15128','2014-03-23','09:25:00',1.81),('15128','2014-03-23','09:30:00',1.16),('15128','2014-03-23','09:35:00',1.97),('15128','2014-03-23','09:40:00',1.47),('15128','2014-03-23','09:45:00',1.05),('15128','2014-03-23','09:55:00',1.71),('15128','2014-03-23','10:00:00',2.94),('15128','2014-03-23','10:05:00',2.2),('15128','2014-03-23','10:10:00',1.46),('15128','2014-03-23','10:20:00',1.91),('15128','2014-03-23','10:25:00',1.14),('15128','2014-03-23','10:30:00',1.83),('15128','2014-03-23','10:35:00',1.18),('15128','2014-03-23','10:40:00',1.53),('15128','2014-03-23','10:45:00',2.07),('15128','2014-03-23','10:50:00',3.59),('15128','2014-03-23','10:55:00',3.51),('15128','2014-03-23','11:00:00',2.9),('15128','2014-03-23','11:05:00',3.46),('15128','2014-03-23','11:10:00',2.52),('15128','2014-03-23','11:15:00',3.62),('15128','2014-03-23','11:20:00',4.25),('15128','2014-03-23','11:25:00',3.78),('15128','2014-03-23','11:30:00',2.07),('15128','2014-03-23','12:20:00',1.01),('15128','2014-03-23','12:25:00',1.49),('15128','2014-03-23','12:30:00',2.09),('15128','2014-03-23','12:35:00',2.04),('15128','2014-03-23','12:40:00',1.6),('15128','2014-03-23','12:45:00',1.53),('15128','2014-03-23','12:50:00',1.55),('15128','2014-03-23','12:55:00',1.54),('15128','2014-03-23','13:00:00',1.61),('15128','2014-03-23','13:05:00',1.66),('15128','2014-03-23','13:10:00',2.03),('15128','2014-03-23','13:15:00',2.71),('15128','2014-03-23','13:20:00',2.65),('15128','2014-03-23','13:25:00',2.27),('15128','2014-03-23','13:30:00',2.12),('15128','2014-03-23','13:35:00',1.5),('15128','2014-03-23','13:40:00',1.29),('15128','2014-03-23','13:45:00',1.3),('15128','2014-03-23','13:50:00',1.03),('15128','2014-03-23','13:55:00',1.08),('15128','2014-03-23','14:00:00',1.24),('15128','2014-03-23','14:05:00',1.33),('15128','2014-03-23','14:10:00',1.49),('15128','2014-03-23','14:15:00',2.02),('15128','2014-03-23','14:20:00',2.62),('15128','2014-03-23','14:25:00',2.34),('15128','2014-03-23','14:30:00',2.74),('15128','2014-03-23','14:35:00',3.14),('15128','2014-03-23','14:40:00',2.44),('15128','2014-03-23','14:45:00',2.36),('15128','2014-03-23','14:50:00',2.44),('15128','2014-03-23','14:55:00',1.87),('15128','2014-03-23','15:00:00',2.2),('15128','2014-03-23','15:05:00',2.32),('15128','2014-03-23','15:10:00',2),('15128','2014-03-23','15:15:00',1.91),('15128','2014-03-23','15:20:00',1.87),('15128','2014-03-23','15:25:00',1.64),('15128','2014-03-23','15:30:00',1.85),('15128','2014-03-23','15:35:00',1.9),('15128','2014-03-23','15:40:00',1.29),('15128','2014-03-23','15:45:00',1.61),('15128','2014-03-23','15:50:00',2.1),('15128','2014-03-23','15:55:00',1.33),('15128','2014-03-23','16:00:00',1.01),('15128','2013-03-01','09:55:00',1.06),('15128','2013-03-01','10:40:00',1.02),('15128','2013-03-01','10:45:00',1.13),('15128','2013-03-01','10:50:00',1.19),('15128','2013-03-01','10:55:00',1.28),('15128','2013-03-01','11:00:00',1.26),('15128','2013-03-01','11:05:00',1.34),('15128','2013-03-01','11:10:00',1.38),('15128','2013-03-01','11:15:00',1.29),('15128','2013-03-01','11:20:00',1.47),('15128','2013-03-01','11:25:00',1.69),('15128','2013-03-01','11:30:00',1.78),('15128','2013-03-01','11:35:00',1.84),('15128','2013-03-01','11:40:00',2.32),('15128','2013-03-01','11:45:00',2.28),('15128','2013-03-01','11:50:00',2.1),('15128','2013-03-01','11:55:00',2.44),('15128','2013-03-01','12:00:00',1.97),('15128','2013-03-01','12:05:00',1.47),('15128','2013-03-01','12:10:00',1.34),('15128','2013-03-01','12:15:00',1.26),('15128','2013-03-01','12:20:00',1.55),('15128','2013-03-01','12:25:00',2.12),('15128','2013-03-01','12:30:00',1.4),('15128','2013-03-01','12:35:00',1.39),('15128','2013-03-01','12:40:00',1.39),('15128','2013-03-01','12:45:00',1.27),('15128','2013-03-01','12:50:00',1.19),('15128','2013-03-01','12:55:00',1.16),('15128','2013-03-01','13:00:00',1.06),('15128','2013-03-01','13:05:00',1.03),('15128','2013-03-01','13:10:00',1.05),('15128','2013-03-01','13:15:00',1.02),('15128','2013-03-01','13:20:00',1.05),('15128','2013-03-01','13:25:00',1.14),('15128','2013-03-01','13:30:00',1.26),('15128','2013-03-01','13:35:00',1.39),('15128','2013-03-01','13:40:00',1.45),('15128','2013-03-01','13:45:00',1.46),('15128','2013-03-01','13:50:00',1.41),('15128','2013-03-01','13:55:00',1.45),('15128','2013-03-01','14:00:00',1.34),('15128','2013-03-01','14:05:00',1.3),('15128','2013-02-28','08:40:00',1.02),('15128','2013-02-28','08:45:00',1.09),('15128','2013-02-28','08:50:00',1.21),('15128','2013-02-28','08:55:00',1.4),('15128','2013-02-28','09:00:00',1.48),('15128','2013-02-28','09:05:00',1.61),('15128','2013-02-28','09:10:00',1.63),('15128','2013-02-28','09:15:00',1.65),('15128','2013-02-28','09:20:00',1.63),('15128','2013-02-28','09:25:00',1.64),('15128','2013-02-28','09:30:00',1.74),('15128','2013-02-28','09:35:00',1.83),('15128','2013-02-28','09:40:00',1.84),('15128','2013-02-28','09:45:00',1.89),('15128','2013-02-28','09:50:00',2.02),('15128','2013-02-28','09:55:00',2.12),('15128','2013-02-28','10:00:00',2.03),('15128','2013-02-28','10:05:00',1.86),('15128','2013-02-28','10:10:00',1.78),('15128','2013-02-28','10:15:00',1.79),('15128','2013-02-28','10:20:00',1.86),('15128','2013-02-28','10:25:00',1.91),('15128','2013-02-28','10:30:00',2.07),('15128','2013-02-28','10:35:00',2.26),('15128','2013-02-28','10:40:00',2.44),('15128','2013-02-28','10:45:00',2.22),('15128','2013-02-28','10:50:00',2.14),('15128','2013-02-28','10:55:00',2.1),('15128','2013-02-28','11:00:00',2.08),('15128','2013-02-28','11:05:00',1.99),('15128','2013-02-28','11:10:00',1.91),('15128','2013-02-28','11:15:00',1.91),('15128','2013-02-28','11:20:00',1.98),('15128','2013-02-28','11:25:00',1.92),('15128','2013-02-28','11:30:00',1.86),('15128','2013-02-28','11:35:00',1.82),('15128','2013-02-28','11:40:00',1.73),('15128','2013-02-28','11:45:00',1.66),('15128','2013-02-28','11:50:00',1.64),('15128','2013-02-28','11:55:00',1.55),('15128','2013-02-28','12:00:00',1.46),('15128','2013-02-28','12:05:00',1.38),('15128','2013-02-28','12:10:00',1.31),('15128','2013-02-28','12:15:00',1.25),('15128','2013-02-28','12:20:00',1.23),('15128','2013-02-28','12:25:00',1.23),('15128','2013-02-28','12:30:00',1.28),('15128','2013-02-28','12:35:00',1.26),('15128','2013-02-28','12:40:00',1.23),('15128','2013-02-28','12:45:00',1.28),('15128','2013-02-28','12:50:00',1.38),('15128','2013-02-28','12:55:00',1.44),('15128','2013-02-28','13:00:00',1.47),('15128','2013-02-28','13:05:00',1.49),('15128','2013-02-28','13:10:00',1.52),('15128','2013-02-28','13:15:00',1.59),('15128','2013-02-28','13:20:00',1.74),('15128','2013-02-28','13:25:00',1.82),('15128','2013-02-28','13:30:00',1.71),('15128','2013-02-28','13:35:00',1.57),('15128','2013-02-28','13:40:00',1.49),('15128','2013-02-28','13:45:00',1.49),('15128','2013-02-28','13:50:00',1.52),('15128','2013-02-28','13:55:00',1.5),('15128','2013-02-28','14:00:00',1.44),('15128','2013-02-28','14:05:00',1.37),('15128','2013-02-28','14:10:00',1.31),('15128','2013-02-28','14:15:00',1.27),('15128','2013-02-28','14:20:00',1.26),('15128','2013-02-28','14:25:00',1.25),('15128','2013-02-28','14:30:00',1.24),('15128','2013-02-28','14:35:00',1.2),('15128','2013-02-28','14:40:00',1.14),('15128','2013-02-28','14:45:00',1.1),('15128','2013-02-28','14:50:00',1.07),('15128','2013-02-28','14:55:00',1.04),('15128','2013-02-28','15:00:00',1.02),('15128','2013-02-27','08:50:00',1.06),('15128','2013-02-27','08:55:00',1.16),('15128','2013-02-27','09:00:00',1.25),('15128','2013-02-27','09:05:00',1.32),('15128','2013-02-27','09:10:00',1.38),('15128','2013-02-27','09:15:00',1.47),('15128','2013-02-27','09:20:00',1.54),('15128','2013-02-27','09:25:00',1.61),('15128','2013-02-27','09:30:00',1.68),('15128','2013-02-27','09:35:00',1.74),('15128','2013-02-27','09:40:00',1.81),('15128','2013-02-27','09:45:00',1.83),('15128','2013-02-27','09:50:00',1.89),('15128','2013-02-27','09:55:00',1.95),('15128','2013-02-27','10:00:00',2.04),('15128','2013-02-27','10:05:00',2.08),('15128','2013-02-27','10:10:00',2.13),('15128','2013-02-27','10:15:00',2.18),('15128','2013-02-27','10:20:00',2.23),('15128','2013-02-27','10:25:00',2.29),('15128','2013-02-27','10:30:00',2.35),('15128','2013-02-27','10:35:00',2.4),('15128','2013-02-27','10:40:00',2.47),('15128','2013-02-27','10:45:00',2.55),('15128','2013-02-27','10:50:00',2.52),('15128','2013-02-27','10:55:00',2.65),('15128','2013-02-27','11:00:00',2.71),('15128','2013-02-27','11:05:00',2.65),('15128','2013-02-27','11:10:00',2.78),('15128','2013-02-27','11:15:00',2.87),('15128','2013-02-27','11:20:00',3.07),('15128','2013-02-27','11:25:00',3.12),('15128','2013-02-27','11:30:00',3.15),('15128','2013-02-27','11:35:00',3.15),('15128','2013-02-27','11:40:00',3.22),('15128','2013-02-27','11:45:00',3.31),('15128','2013-02-27','11:50:00',3.34),('15128','2013-02-27','11:55:00',3.34),('15128','2013-02-27','12:00:00',3.35),('15128','2013-02-27','12:05:00',3.41),('15128','2013-02-27','12:10:00',3.49),('15128','2013-02-27','12:15:00',3.51),('15128','2013-02-27','12:20:00',3.48),('15128','2013-02-27','12:25:00',3.52),('15128','2013-02-27','12:30:00',3.51),('15128','2013-02-27','12:35:00',3.54),('15128','2013-02-27','12:40:00',3.55),('15128','2013-02-27','12:45:00',3.59),('15128','2013-02-27','12:50:00',3.6),('15128','2013-02-27','12:55:00',3.43),('15128','2013-02-27','13:00:00',3.33),('15128','2013-02-27','13:05:00',3.5),('15128','2013-02-27','13:10:00',3.55),('15128','2013-02-27','13:15:00',3.55),('15128','2013-02-27','13:20:00',2.9),('15128','2013-02-27','13:25:00',3.32),('15128','2013-02-27','13:30:00',2.32),('15128','2013-02-27','13:35:00',3.59),('15128','2013-02-27','13:40:00',1.57),('15128','2013-02-27','13:45:00',1.14),('15128','2013-02-27','13:50:00',1.57),('15128','2013-02-27','13:55:00',2.37),('15128','2013-02-27','14:00:00',3.03),('15128','2013-02-27','14:05:00',3.57),('15128','2013-02-27','14:10:00',3.38),('15128','2013-02-27','14:15:00',3.33),('15128','2013-02-27','14:20:00',3.36),('15128','2013-02-27','14:25:00',3.21),('15128','2013-02-27','14:30:00',3.18),('15128','2013-02-27','14:35:00',3.1),('15128','2013-02-27','14:40:00',3.07),('15128','2013-02-27','14:45:00',2.99),('15128','2013-02-27','14:50:00',2.82),('15128','2013-02-27','14:55:00',2.76),('15128','2013-02-27','15:00:00',2.7),('15128','2013-02-27','15:05:00',2.64),('15128','2013-02-27','15:10:00',2.59),('15128','2013-02-27','15:15:00',2.59),('15128','2013-02-27','15:20:00',2.53),('15128','2013-02-27','15:25:00',2.52),('15128','2013-02-27','15:30:00',2.45),('15128','2013-02-27','15:35:00',2.36),('15128','2013-02-27','15:40:00',2.22),('15128','2013-02-27','15:45:00',2.04),('15128','2013-02-27','15:50:00',2.01),('15128','2013-02-27','15:55:00',1.93),('15128','2013-02-27','16:00:00',1.83),('15128','2013-02-27','16:05:00',1.75),('15128','2013-02-27','16:10:00',1.69),('15128','2013-02-27','16:15:00',1.62),('15128','2013-02-27','16:20:00',1.51),('15128','2013-02-27','16:25:00',1.41),('15128','2013-02-27','16:30:00',1.37),('15128','2013-02-27','16:35:00',1.28),('15128','2013-02-27','16:40:00',1.15),('15128','2013-02-27','16:45:00',1.04),('15128','2013-02-26','08:55:00',1.11),('15128','2013-02-26','09:00:00',1.21),('15128','2013-02-26','09:05:00',1.29),('15128','2013-02-26','09:10:00',1.36),('15128','2013-02-26','09:15:00',1.44),('15128','2013-02-26','09:20:00',1.52),('15128','2013-02-26','09:25:00',1.57),('15128','2013-02-26','09:30:00',1.64),('15128','2013-02-26','09:35:00',1.69),('15128','2013-02-26','09:40:00',1.74),('15128','2013-02-26','09:45:00',1.8),('15128','2013-02-26','09:50:00',1.88),('15128','2013-02-26','09:55:00',1.92),('15128','2013-02-26','10:00:00',2.01),('15128','2013-02-26','10:05:00',2.07),('15128','2013-02-26','10:10:00',2.11),('15128','2013-02-26','10:15:00',2.16),('15128','2013-02-26','10:20:00',2.23),('15128','2013-02-26','10:25:00',2.27),('15128','2013-02-26','10:30:00',2.32),('15128','2013-02-26','10:35:00',2.37),('15128','2013-02-26','10:40:00',2.46),('15128','2013-02-26','10:45:00',2.49),('15128','2013-02-26','10:50:00',2.52),('15128','2013-02-26','10:55:00',2.58),('15128','2013-02-26','11:00:00',2.6),('15128','2013-02-26','11:05:00',2.7),('15128','2013-02-26','11:10:00',2.84),('15128','2013-02-26','11:15:00',2.74),('15128','2013-02-26','11:20:00',2.87),('15128','2013-02-26','11:25:00',3.07),('15128','2013-02-26','11:30:00',3.12),('15128','2013-02-26','11:35:00',3.19),('15128','2013-02-26','11:40:00',3.21),('15128','2013-02-26','11:45:00',3.26),('15128','2013-02-26','11:50:00',3.39),('15128','2013-02-26','11:55:00',3.34),('15128','2013-02-26','12:00:00',3.52),('15128','2013-02-26','12:05:00',3.62),('15128','2013-02-26','12:10:00',3.12),('15128','2013-02-26','12:15:00',3.59),('15128','2013-02-26','12:20:00',3.56),('15128','2013-02-26','12:25:00',3.53),('15128','2013-02-26','12:30:00',3.67),('15128','2013-02-26','12:35:00',3.67),('15128','2013-02-26','12:40:00',3.65),('15128','2013-02-26','12:45:00',3.66),('15128','2013-02-26','12:50:00',3.54),('15128','2013-02-26','12:55:00',3.63),('15128','2013-02-26','13:00:00',2.17),('15128','2013-02-26','13:05:00',2.95),('15128','2013-02-26','13:10:00',3.68),('15128','2013-02-26','13:15:00',3.57),('15128','2013-02-26','13:20:00',3.5),('15128','2013-02-26','13:25:00',3.59),('15128','2013-02-26','13:30:00',3.68),('15128','2013-02-26','13:35:00',3.43),('15128','2013-02-26','13:40:00',3.46),('15128','2013-02-26','13:45:00',3.67),('15128','2013-02-26','13:50:00',3.64),('15128','2013-02-26','13:55:00',3.49),('15128','2013-02-26','14:00:00',3.45),('15128','2013-02-26','14:05:00',3.41),('15128','2013-02-26','14:10:00',3.4),('15128','2013-02-26','14:15:00',2.57),('15128','2013-02-26','14:20:00',3.39),('15128','2013-02-26','14:25:00',1.09),('15128','2013-02-26','14:35:00',2.47),('15128','2013-02-26','14:40:00',2.1),('15128','2013-02-26','14:45:00',3.01),('15128','2013-02-26','14:50:00',3.19),('15128','2013-02-26','14:55:00',3),('15128','2013-02-26','15:00:00',2.7),('15128','2013-02-26','15:05:00',2.77),('15128','2013-02-26','15:10:00',2.76),('15128','2013-02-26','15:15:00',2.69),('15128','2013-02-26','15:20:00',2.61),('15128','2013-02-26','15:25:00',2.55),('15128','2013-02-26','15:30:00',2.51),('15128','2013-02-26','15:35:00',2.39),('15128','2013-02-26','15:40:00',2.28),('15128','2013-02-26','15:45:00',2.26),('15128','2013-02-26','15:50:00',2.13),('15128','2013-02-26','15:55:00',1.99),('15128','2013-02-26','16:00:00',1.87),('15128','2013-02-26','16:05:00',1.88),('15128','2013-02-26','16:10:00',1.81),('15128','2013-02-26','16:15:00',1.72),('15128','2013-02-26','16:20:00',1.63),('15128','2013-02-26','16:25:00',1.55),('15128','2013-02-26','16:30:00',1.48),('15128','2013-02-26','16:35:00',1.37),('15128','2013-02-26','16:40:00',1.23),('15128','2013-02-26','16:45:00',1.13),('15128','2013-02-26','16:50:00',1),('15128','2013-02-25','09:15:00',1.01),('15128','2013-02-25','09:20:00',1.1),('15128','2013-02-25','09:25:00',1.18),('15128','2013-02-25','09:30:00',1.24),('15128','2013-02-25','09:35:00',1.33),('15128','2013-02-25','09:40:00',1.44),('15128','2013-02-25','09:45:00',1.5),('15128','2013-02-25','09:50:00',1.54),('15128','2013-02-25','09:55:00',1.77),('15128','2013-02-25','10:00:00',1.94),('15128','2013-02-25','10:05:00',2.07),('15128','2013-02-25','10:10:00',1.9),('15128','2013-02-25','10:15:00',1.86),('15128','2013-02-25','10:20:00',2.23),('15128','2013-02-25','10:25:00',1.69),('15128','2013-02-25','10:30:00',1.42),('15128','2013-02-25','10:35:00',1.97),('15128','2013-02-25','10:40:00',1.53),('15128','2013-02-25','10:45:00',1.53),('15128','2013-02-25','10:50:00',1.62),('15128','2013-02-25','10:55:00',1.51),('15128','2013-02-25','11:00:00',1.52),('15128','2013-02-25','11:05:00',1.43),('15128','2013-02-25','11:10:00',1.4),('15128','2013-02-25','11:15:00',1.53),('15128','2013-02-25','11:20:00',1.84),('15128','2013-02-25','11:25:00',2.02),('15128','2013-02-25','11:30:00',2.22),('15128','2013-02-25','11:35:00',2.62),('15128','2013-02-25','11:40:00',3.51),('15128','2013-02-25','11:45:00',3.01),('15128','2013-02-25','11:50:00',3.63),('15128','2013-02-25','11:55:00',3.18),('15128','2013-02-25','12:00:00',2.67),('15128','2013-02-25','12:05:00',2.53),('15128','2013-02-25','12:10:00',1.67),('15128','2013-02-25','12:15:00',1.93),('15128','2013-02-25','12:20:00',1.65),('15128','2013-02-25','12:25:00',1.68),('15128','2013-02-25','12:30:00',1.75),('15128','2013-02-25','12:35:00',1.59),('15128','2013-02-25','12:40:00',1.62),('15128','2013-02-25','12:45:00',1.52),('15128','2013-02-25','12:50:00',1.41),('15128','2013-02-25','12:55:00',1.39),('15128','2013-02-25','13:00:00',1.36),('15128','2013-02-25','13:05:00',1.18),('15128','2013-02-25','13:10:00',1.31),('15128','2013-02-25','13:15:00',1.46),('15128','2013-02-25','13:20:00',1.4),('15128','2013-02-25','13:25:00',1.33),('15128','2013-02-25','13:30:00',1.19),('15128','2013-02-25','13:35:00',1.01),('15128','2013-02-24','10:40:00',1.18),('15128','2013-02-24','10:45:00',1.57),('15128','2013-02-24','10:50:00',1.96),('15128','2013-02-24','10:55:00',2.44),('15128','2013-02-24','11:00:00',2.28),('15128','2013-02-24','11:05:00',2.04),('15128','2013-02-24','11:10:00',3.01),('15128','2013-02-24','11:15:00',2.77),('15128','2013-02-24','11:20:00',1.91),('15128','2013-02-24','11:25:00',2.23),('15128','2013-02-24','11:30:00',2.1),('15128','2013-02-24','11:35:00',1.58),('15128','2013-02-24','11:40:00',1.34),('15128','2013-02-24','11:45:00',1.22),('15128','2013-02-24','11:50:00',1.23),('15128','2013-02-24','11:55:00',1.36),('15128','2013-02-24','12:00:00',1.6),('15128','2013-02-24','12:05:00',1.89),('15128','2013-02-24','12:10:00',1.86),('15128','2013-02-24','12:15:00',2.37),('15128','2013-02-24','12:20:00',2.31),('15128','2013-02-24','12:25:00',2.52),('15128','2013-02-24','12:30:00',3.91),('15128','2013-02-24','12:35:00',2.25),('15128','2013-02-24','12:40:00',3.96),('15128','2013-02-24','12:45:00',3.63),('15128','2013-02-24','12:50:00',3.62),('15128','2013-02-24','12:55:00',3.35),('15128','2013-02-24','13:00:00',4.29),('15128','2013-02-24','13:05:00',4.13),('15128','2013-02-24','13:10:00',4.33),('15128','2013-02-24','13:15:00',3.74),('15128','2013-02-24','13:20:00',1.68),('15128','2013-02-24','13:25:00',1.71),('15128','2013-02-24','13:30:00',1.35),('15128','2013-02-24','13:35:00',1.34),('15128','2013-02-24','13:40:00',1.24),('15128','2013-02-24','13:45:00',1.45),('15128','2013-02-24','13:50:00',1.34),('15128','2013-02-24','13:55:00',1.23),('15128','2013-02-24','14:00:00',1.32),('15128','2013-02-24','14:05:00',1.33),('15128','2013-02-24','14:10:00',1.12),('15128','2013-02-24','16:40:00',1.12),('15128','2013-02-24','16:55:00',1.1),('15128','2013-02-23','10:45:00',1.43),('15128','2013-02-23','10:50:00',2.04),('15128','2013-02-23','10:55:00',2.35),('15128','2013-02-23','11:00:00',2.02),('15128','2013-02-23','11:05:00',1.35),('15128','2013-02-23','11:35:00',1.04),('15128','2013-02-23','11:40:00',1.14),('15128','2013-02-23','11:45:00',1.22),('15128','2013-02-23','11:50:00',1.31),('15128','2013-02-23','11:55:00',1.32),('15128','2013-02-23','12:00:00',1.02),('15128','2013-02-23','12:30:00',1.14),('15128','2013-02-23','12:35:00',1.52),('15128','2013-02-23','12:40:00',1.47),('15128','2013-02-23','12:45:00',1.38),('15128','2013-02-23','12:50:00',1.95),('15128','2013-02-23','12:55:00',2.08),('15128','2013-02-23','13:00:00',2.22),('15128','2013-02-23','13:05:00',2.82),('15128','2013-02-23','13:10:00',1.63),('15128','2013-02-23','13:20:00',1.29),('15128','2013-02-23','13:25:00',1.91),('15128','2013-02-23','13:30:00',1.19),('15128','2013-02-23','13:35:00',1.51),('15128','2013-02-23','13:40:00',1.62),('15128','2013-02-23','13:45:00',2),('15128','2013-02-23','13:50:00',1.32),('15128','2013-02-23','13:55:00',1.62),('15128','2013-02-23','14:00:00',1.97),('15128','2013-02-23','14:05:00',1.86),('15128','2013-02-23','14:10:00',2.12),('15128','2013-02-23','14:15:00',1.37),('15128','2013-02-23','14:20:00',1.2),('15128','2013-02-23','14:25:00',1.47),('15128','2013-02-23','14:30:00',1.09),('15128','2013-02-23','14:50:00',1.11),('15128','2013-02-23','14:55:00',2.82),('15128','2013-02-23','15:00:00',2.46),('15128','2013-02-23','15:05:00',1.69),('15128','2013-02-23','15:10:00',2.7),('15128','2013-02-23','15:20:00',1.83),('15128','2013-02-23','15:25:00',2.59),('15128','2013-02-23','15:30:00',1.76),('15128','2013-02-23','15:35:00',2.39),('15128','2013-02-23','15:45:00',2.44),('15128','2013-02-23','15:50:00',1.18),('15128','2013-02-23','16:05:00',1.66),('15128','2013-02-23','16:10:00',1.64),('15128','2013-02-23','16:15:00',1.9),('15128','2013-02-23','16:20:00',1.68),('15128','2013-02-22','08:55:00',1.05),('15128','2013-02-22','09:00:00',1.06),('15128','2013-02-22','09:05:00',1.13),('15128','2013-02-22','09:50:00',1.17),('15128','2013-02-22','09:55:00',1.26),('15128','2013-02-22','10:10:00',1.03),('15128','2013-02-22','10:30:00',1.1),('15128','2013-02-22','10:40:00',1.02),('15128','2013-02-22','10:45:00',1.18),('15128','2013-02-22','10:50:00',1.34),('15128','2013-02-22','10:55:00',1.36),('15128','2013-02-22','11:25:00',1.06),('15128','2013-02-22','11:30:00',1.21),('15128','2013-02-22','11:35:00',1.19),('15128','2013-02-21','14:30:00',1.05),('15128','2013-02-21','14:35:00',1.28),('15128','2013-02-21','14:40:00',1.8),('15128','2013-02-21','14:45:00',1.01),('15128','2013-02-21','14:55:00',1.1),('15128','2013-02-21','15:00:00',1.46),('15128','2013-02-21','15:05:00',1.12),('15128','2013-02-21','15:35:00',1.06),('15128','2013-02-20','11:40:00',1.04),('15128','2013-02-20','11:45:00',1.07),('15128','2013-02-20','11:50:00',1.04),('15128','2013-02-20','12:00:00',1.1),('15128','2013-02-20','12:05:00',1.25),('15128','2013-02-20','12:10:00',1.23),('15128','2013-02-20','12:15:00',1.22),('15128','2013-02-20','12:20:00',1.18),('15128','2013-02-20','12:25:00',1.18),('15128','2013-02-20','12:30:00',1.2),('15128','2013-02-20','12:35:00',1.35),('15128','2013-02-20','12:40:00',1.33),('15128','2013-02-20','12:45:00',1.25),('15128','2013-02-20','12:50:00',1.17),('15128','2013-02-20','12:55:00',1.18),('15128','2013-02-20','13:00:00',1.26),('15128','2013-02-20','13:05:00',1.23),('15128','2013-02-20','13:10:00',1.17),('15128','2013-02-20','13:15:00',1.29),('15128','2013-02-20','13:20:00',1.42),('15128','2013-02-20','13:25:00',1.32),('15128','2013-02-20','13:30:00',1.21),('15128','2013-02-20','13:35:00',1.16),('15128','2013-02-20','13:40:00',1.11),('15128','2013-02-20','13:45:00',1.13),('15128','2013-02-20','13:50:00',1.07),('15128','2013-02-20','13:55:00',1.08),('15128','2013-02-20','15:25:00',1),('15128','2013-02-20','15:30:00',1.09),('15128','2013-02-20','15:35:00',1.15),('15128','2013-02-20','15:40:00',1.21),('15128','2013-02-20','15:45:00',1.28),('15128','2013-02-20','15:50:00',1.16),('15128','2013-02-20','15:55:00',1.63),('15128','2013-02-20','16:00:00',1.68),('15128','2013-02-20','16:05:00',1.39),('15128','2013-02-20','16:10:00',1.82),('15128','2013-02-20','16:15:00',1.86),('15128','2013-02-20','16:20:00',1.75),('15128','2013-02-20','16:25:00',1.56),('15128','2013-02-20','16:30:00',1.35),('15128','2013-02-20','16:35:00',1.17),('15128','2014-03-22','08:20:00',1),('15128','2014-03-22','08:25:00',1.07),('15128','2014-03-22','08:30:00',1.53),('15128','2014-03-22','08:35:00',1.06),('15128','2014-03-22','08:50:00',1.57),('15128','2014-03-22','08:55:00',1.11),('15128','2014-03-22','09:00:00',1.37),('15128','2014-03-22','09:05:00',1.98),('15128','2014-03-22','09:10:00',1.96),('15128','2014-03-22','09:15:00',1.91),('15128','2014-03-22','09:20:00',1.12),('15128','2014-03-22','09:25:00',1.05),('15128','2014-03-22','09:30:00',1.36),('15128','2014-03-22','10:20:00',1),('15128','2014-03-22','10:25:00',1.48),('15128','2014-03-22','10:40:00',1.15),('15128','2014-03-22','10:45:00',1.19),('15128','2014-03-22','10:50:00',1.2),('15128','2014-03-22','10:55:00',1.11),('15128','2014-03-22','11:05:00',1.42),('15128','2014-03-22','11:20:00',1.13),('15128','2014-03-22','11:25:00',1.27),('15128','2014-03-22','11:30:00',1.31),('15128','2014-03-22','11:35:00',1.25),('15128','2014-03-22','13:35:00',2.52),('15128','2014-03-22','13:40:00',1.97),('15128','2014-03-22','13:45:00',1.22),('15128','2014-03-22','13:50:00',1.22),('15128','2014-03-22','14:55:00',1.3),('15128','2014-03-22','15:05:00',1.23),('15128','2014-03-22','15:10:00',1.74),('15128','2014-03-22','15:15:00',1.85),('15128','2014-03-22','15:20:00',1.11),('15128','2014-03-22','15:25:00',1.03),('15128','2013-02-19','09:05:00',1.13),('15128','2013-02-19','09:10:00',1.18),('15128','2013-02-19','09:15:00',1.42),('15128','2013-02-19','09:20:00',1.57),('15128','2013-02-19','09:25:00',1.52),('15128','2013-02-19','09:30:00',1.53),('15128','2013-02-19','09:35:00',1.71),('15128','2013-02-19','09:40:00',1.78),('15128','2013-02-19','09:45:00',1.41),('15128','2013-02-19','09:55:00',1.21),('15128','2013-02-19','10:00:00',1.92),('15128','2013-02-19','10:05:00',1.32),('15128','2013-02-19','10:10:00',1.33),('15128','2013-02-19','10:15:00',2.11),('15128','2013-02-19','10:20:00',2.09),('15128','2013-02-19','10:25:00',1.22),('15128','2013-02-19','10:30:00',2.29),('15128','2013-02-19','10:35:00',1.72),('15128','2013-02-19','10:40:00',2.38),('15128','2013-02-19','10:45:00',2.35),('15128','2013-02-19','10:50:00',1.24),('15128','2013-02-19','10:55:00',1.04),('15128','2013-02-19','11:05:00',1.34),('15128','2013-02-19','11:10:00',1.94),('15128','2013-02-19','11:15:00',3.37),('15128','2013-02-19','11:20:00',1.76),('15128','2013-02-19','11:25:00',3.29),('15128','2013-02-19','11:30:00',1.41),('15128','2013-02-19','11:35:00',3.59),('15128','2013-02-19','11:40:00',3.6),('15128','2013-02-19','11:45:00',1.65),('15128','2013-02-19','11:50:00',1.14),('15128','2013-02-19','11:55:00',1.76),('15128','2013-02-19','12:00:00',1.63),('15128','2013-02-19','12:05:00',1.34),('15128','2013-02-19','12:10:00',1.37),('15128','2013-02-19','12:15:00',1.45),('15128','2013-02-19','12:20:00',3.28),('15128','2013-02-19','12:25:00',4.73),('15128','2013-02-19','12:30:00',4.4),('15128','2013-02-19','12:35:00',1.84),('15128','2013-02-19','12:40:00',1.16),('15128','2013-02-19','12:45:00',2.73),('15128','2013-02-19','12:50:00',3.68),('15128','2013-02-19','12:55:00',1.78),('15128','2013-02-19','13:00:00',1.44),('15128','2013-02-19','13:05:00',2.91),('15128','2013-02-19','13:10:00',4.26),('15128','2013-02-19','13:15:00',1.42),('15128','2013-02-19','13:20:00',1.1),('15128','2013-02-19','13:25:00',2.49),('15128','2013-02-19','13:30:00',1.49),('15128','2013-02-19','13:35:00',1.61),('15128','2013-02-19','13:40:00',4.39),('15128','2013-02-19','13:45:00',1.73),('15128','2013-02-19','13:50:00',1.67),('15128','2013-02-19','13:55:00',1.28),('15128','2013-02-19','14:00:00',2.24),('15128','2013-02-19','14:05:00',3.21),('15128','2013-02-19','14:10:00',1.19),('15128','2013-02-19','14:15:00',1.27),('15128','2013-02-19','14:20:00',2.6),('15128','2013-02-19','14:25:00',2.76),('15128','2013-02-19','14:30:00',1.34),('15128','2013-02-19','14:35:00',1.79),('15128','2013-02-19','14:40:00',2.27),('15128','2013-02-19','14:45:00',1.39),('15128','2013-02-19','14:50:00',1.54),('15128','2013-02-19','14:55:00',1.73),('15128','2013-02-19','15:00:00',2.21),('15128','2013-02-19','15:05:00',2.52),('15128','2013-02-19','15:10:00',2.17),('15128','2013-02-19','15:15:00',2.48),('15128','2013-02-19','15:20:00',2.01),('15128','2013-02-19','15:25:00',1.94),('15128','2013-02-19','15:30:00',2.16),('15128','2013-02-19','15:35:00',1.87),('15128','2013-02-19','15:40:00',1.11),('15128','2013-02-19','15:50:00',1.23),('15128','2013-02-19','15:55:00',1.28),('15128','2013-02-19','16:00:00',1.1),('15128','2013-02-19','16:05:00',1.47),('15128','2013-02-19','16:10:00',1.22),('15128','2013-02-19','16:15:00',1.25),('15128','2013-02-19','16:25:00',1.11),('15128','2013-02-19','16:30:00',1.54),('15128','2013-02-19','16:35:00',1.19),('15128','2013-02-18','09:00:00',1),('15128','2013-02-18','09:05:00',1.09),('15128','2013-02-18','09:10:00',1.18),('15128','2013-02-18','09:15:00',1.28),('15128','2013-02-18','09:20:00',1.36),('15128','2013-02-18','09:25:00',1.43),('15128','2013-02-18','09:30:00',1.51),('15128','2013-02-18','09:35:00',1.54),('15128','2013-02-18','09:40:00',1.64),('15128','2013-02-18','09:45:00',1.7),('15128','2013-02-18','09:50:00',1.77),('15128','2013-02-18','09:55:00',1.79),('15128','2013-02-18','10:00:00',1.85),('15128','2013-02-18','10:05:00',1.92),('15128','2013-02-18','10:10:00',1.96),('15128','2013-02-18','10:15:00',2.06),('15128','2013-02-18','10:20:00',2.09),('15128','2013-02-18','10:25:00',2.15),('15128','2013-02-18','10:30:00',2.19),('15128','2013-02-18','10:35:00',2.28),('15128','2013-02-18','10:40:00',2.34),('15128','2013-02-18','10:45:00',2.33),('15128','2013-02-18','10:50:00',2.43),('15128','2013-02-18','10:55:00',2.45),('15128','2013-02-18','11:00:00',2.51),('15128','2013-02-18','11:05:00',2.59),('15128','2013-02-18','11:10:00',2.58),('15128','2013-02-18','11:15:00',2.68),('15128','2013-02-18','11:20:00',2.76),('15128','2013-02-18','11:25:00',2.94),('15128','2013-02-18','11:30:00',3.02),('15128','2013-02-18','11:35:00',3.09),('15128','2013-02-18','11:40:00',3.15),('15128','2013-02-18','11:45:00',3.19),('15128','2013-02-18','11:50:00',3.18),('15128','2013-02-18','11:55:00',3.22),('15128','2013-02-18','12:00:00',3.25),('15128','2013-02-18','12:05:00',3.3),('15128','2013-02-18','12:10:00',3.32),('15128','2013-02-18','12:15:00',3.34),('15128','2013-02-18','12:20:00',3.38),('15128','2013-02-18','12:25:00',3.39),('15128','2013-02-18','12:30:00',3.42),('15128','2013-02-18','12:35:00',3.45),('15128','2013-02-18','12:40:00',3.46),('15128','2013-02-18','12:45:00',3.45),('15128','2013-02-18','12:50:00',3.49),('15128','2013-02-18','12:55:00',3.45),('15128','2013-02-18','13:00:00',3.44),('15128','2013-02-18','13:05:00',3.46),('15128','2013-02-18','13:10:00',3.46),('15128','2013-02-18','13:15:00',3.49),('15128','2013-02-18','13:20:00',3.47),('15128','2013-02-18','13:25:00',3.47),('15128','2013-02-18','13:30:00',3.47),('15128','2013-02-18','13:35:00',3.44),('15128','2013-02-18','13:40:00',3.44),('15128','2013-02-18','13:45:00',3.38),('15128','2013-02-18','13:50:00',3.38),('15128','2013-02-18','13:55:00',3.35),('15128','2013-02-18','14:00:00',3.31),('15128','2013-02-18','14:05:00',3.29),('15128','2013-02-18','14:10:00',3.26),('15128','2013-02-18','14:15:00',3.18),('15128','2013-02-18','14:20:00',3.11),('15128','2013-02-18','14:25:00',3.04),('15128','2013-02-18','14:30:00',3.03),('15128','2013-02-18','14:35:00',2.97),('15128','2013-02-18','14:40:00',2.96),('15128','2013-02-18','14:45:00',2.89),('15128','2013-02-18','14:50:00',2.75),('15128','2013-02-18','14:55:00',2.72),('15128','2013-02-18','15:00:00',2.7),('15128','2013-02-18','15:05:00',2.67),('15128','2013-02-18','15:10:00',2.59),('15128','2013-02-18','15:15:00',2.54),('15128','2013-02-18','15:20:00',2.52),('15128','2013-02-18','15:25:00',2.42),('15128','2013-02-18','15:30:00',2.38),('15128','2013-02-18','15:35:00',2.32),('15128','2013-02-18','15:40:00',2.2),('15128','2013-02-18','15:45:00',2.14),('15128','2013-02-18','15:50:00',2.06),('15128','2013-02-18','15:55:00',1.96),('15128','2013-02-18','16:00:00',1.92),('15128','2013-02-18','16:05:00',1.84),('15128','2013-02-18','16:10:00',1.73),('15128','2013-02-18','16:15:00',1.65),('15128','2013-02-18','16:20:00',1.56),('15128','2013-02-18','16:25:00',1.45),('15128','2013-02-18','16:30:00',1.3),('15128','2013-02-18','16:35:00',1.2),('15128','2013-02-18','16:40:00',1.06),('15128','2013-02-17','09:05:00',1.06),('15128','2013-02-17','09:10:00',1.14),('15128','2013-02-17','09:15:00',1.24),('15128','2013-02-17','09:20:00',1.37),('15128','2013-02-17','09:25:00',1.53),('15128','2013-02-17','09:40:00',1.84),('15128','2013-02-17','09:45:00',1.43),('15128','2013-02-17','09:50:00',1.01),('15128','2013-02-17','10:05:00',2.06),('15128','2013-02-17','10:10:00',2.1),('15128','2013-02-17','10:15:00',2.09),('15128','2013-02-17','10:20:00',2.12),('15128','2013-02-17','10:25:00',2.08),('15128','2013-02-17','10:30:00',2.06),('15128','2013-02-17','10:35:00',2.07),('15128','2013-02-17','10:40:00',2.27),('15128','2013-02-17','10:45:00',1.6),('15128','2013-02-17','10:50:00',1.78),('15128','2013-02-17','10:55:00',2.19),('15128','2013-02-17','11:00:00',1.24),('15128','2013-02-17','11:05:00',1.54),('15128','2013-02-17','11:10:00',1.48),('15128','2013-02-17','11:15:00',1.7),('15128','2013-02-17','11:20:00',1.53),('15128','2013-02-17','11:25:00',1.58),('15128','2013-02-17','11:30:00',1.78),('15128','2013-02-17','11:35:00',1.77),('15128','2013-02-17','11:40:00',1.95),('15128','2013-02-17','11:45:00',2.1),('15128','2013-02-17','11:50:00',2.47),('15128','2013-02-17','11:55:00',2.3),('15128','2013-02-17','12:00:00',1.72),('15128','2013-02-17','12:05:00',1.55),('15128','2013-02-17','12:10:00',1.51),('15128','2013-02-17','12:15:00',1.41),('15128','2013-02-17','12:20:00',1.42),('15128','2013-02-17','12:25:00',1.75),('15128','2013-02-17','12:30:00',1.55),('15128','2013-02-17','12:35:00',1.45),('15128','2013-02-17','12:40:00',1.51),('15128','2013-02-17','12:45:00',1.57),('15128','2013-02-17','12:50:00',1.7),('15128','2013-02-17','12:55:00',2.21),('15128','2013-02-17','13:00:00',2.96),('15128','2013-02-17','13:05:00',2.79),('15128','2013-02-17','13:10:00',2.29),('15128','2013-02-17','13:15:00',3.02),('15128','2013-02-17','13:20:00',1.92),('15128','2013-02-17','13:25:00',1.46),('15128','2013-02-17','13:30:00',1.18),('15128','2013-02-17','13:40:00',1.25),('15128','2013-02-17','13:45:00',1.23),('15128','2013-02-17','13:50:00',1.33),('15128','2013-02-17','13:55:00',1.73),('15128','2013-02-17','14:00:00',1.83),('15128','2013-02-17','14:05:00',2.11),('15128','2013-02-17','14:10:00',2),('15128','2013-02-17','14:15:00',2.7),('15128','2013-02-17','14:20:00',2.13),('15128','2013-02-17','14:25:00',1.24),('15128','2013-02-17','14:35:00',1.11),('15128','2013-02-17','14:40:00',1.54),('15128','2013-02-17','14:45:00',1.01),('15128','2013-02-17','14:50:00',1.13),('15128','2013-02-17','14:55:00',1.6),('15128','2013-02-17','15:00:00',1.51),('15128','2013-02-17','15:05:00',1.21),('15128','2013-02-16','09:05:00',1),('15128','2013-02-16','09:10:00',1.04),('15128','2013-02-16','09:15:00',1.22),('15128','2013-02-16','09:20:00',1.28),('15128','2013-02-16','09:25:00',1.36),('15128','2013-02-16','09:30:00',1.38),('15128','2013-02-16','09:35:00',1.5),('15128','2013-02-16','09:40:00',1.56),('15128','2013-02-16','09:45:00',1.59),('15128','2013-02-16','09:50:00',1.67),('15128','2013-02-16','09:55:00',1.71),('15128','2013-02-16','10:00:00',1.74),('15128','2013-02-16','10:05:00',1.78),('15128','2013-02-16','10:10:00',1.84),('15128','2013-02-16','10:15:00',1.87),('15128','2013-02-16','10:20:00',2.01),('15128','2013-02-16','10:25:00',2.06),('15128','2013-02-16','10:30:00',2.13),('15128','2013-02-16','10:35:00',2.18),('15128','2013-02-16','10:40:00',2.24),('15128','2013-02-16','10:45:00',2.3),('15128','2013-02-16','10:50:00',2.33),('15128','2013-02-16','10:55:00',2.38),('15128','2013-02-16','11:00:00',2.45),('15128','2013-02-16','11:05:00',2.48),('15128','2013-02-16','11:10:00',2.54),('15128','2013-02-16','11:15:00',2.63),('15128','2013-02-16','11:20:00',2.65),('15128','2013-02-16','11:25:00',2.82),('15128','2013-02-16','11:30:00',2.9),('15128','2013-02-16','11:35:00',2.97),('15128','2013-02-16','11:40:00',3.02),('15128','2013-02-16','11:45:00',3.04),('15128','2013-02-16','11:50:00',3.08),('15128','2013-02-16','11:55:00',3.15),('15128','2013-02-16','12:00:00',3.19),('15128','2013-02-16','12:05:00',3.23),('15128','2013-02-16','12:10:00',3.17),('15128','2013-02-16','12:15:00',3.22),('15128','2013-02-16','12:20:00',3.24),('15128','2013-02-16','12:25:00',3.21),('15128','2013-02-16','12:30:00',3.22),('15128','2013-02-16','12:35:00',3.19),('15128','2013-02-16','12:40:00',3.19),('15128','2013-02-16','12:45:00',3.24),('15128','2013-02-16','12:50:00',3.27),('15128','2013-02-16','12:55:00',3.27),('15128','2013-02-16','13:00:00',3.27),('15128','2013-02-16','13:05:00',3.21),('15128','2013-02-16','13:10:00',1.34),('15128','2013-02-16','13:15:00',3.04),('15128','2013-02-16','13:20:00',3.25),('15128','2013-02-16','13:25:00',3.24),('15128','2013-02-16','13:30:00',3.22),('15128','2013-02-16','13:35:00',3.24),('15128','2013-02-16','13:40:00',3.24),('15128','2013-02-16','13:45:00',3.28),('15128','2013-02-16','13:50:00',3.21),('15128','2013-02-16','13:55:00',3.21),('15128','2013-02-16','14:00:00',3.09),('15128','2013-02-16','14:05:00',2.85),('15128','2013-02-16','14:10:00',1.86),('15128','2013-02-16','14:15:00',3.07),('15128','2013-02-16','14:20:00',1.54),('15128','2013-02-16','14:25:00',2.98),('15128','2013-02-16','14:30:00',2.84),('15128','2013-02-16','14:35:00',2.9),('15128','2013-02-16','14:40:00',2.91),('15128','2013-02-16','14:45:00',2.84),('15128','2013-02-16','14:50:00',2.81),('15128','2013-02-16','14:55:00',2.7),('15128','2013-02-16','15:00:00',2.66),('15128','2013-02-16','15:05:00',2.61),('15128','2013-02-16','15:10:00',2.53),('15128','2013-02-16','15:15:00',2.5),('15128','2013-02-16','15:20:00',2.43),('15128','2013-02-16','15:25:00',2.28),('15128','2013-02-16','15:30:00',2.1),('15128','2013-02-16','15:35:00',2.14),('15128','2013-02-16','15:40:00',2.07),('15128','2013-02-16','15:45:00',1.97),('15128','2013-02-16','15:50:00',1.67),('15128','2013-02-16','15:55:00',1.69),('15128','2013-02-16','16:00:00',1.33),('15128','2013-02-16','16:15:00',1.17),('15128','2013-02-16','16:20:00',1.3),('15128','2013-02-16','16:25:00',1.25),('15128','2013-02-16','16:30:00',1.04),('15128','2013-02-15','09:10:00',1.18),('15128','2013-02-15','09:15:00',1.36),('15128','2013-02-15','09:20:00',1.55),('15128','2013-02-15','09:25:00',1.64),('15128','2013-02-15','09:30:00',1.64),('15128','2013-02-15','09:35:00',1.72),('15128','2013-02-15','09:40:00',1.71),('15128','2013-02-15','09:45:00',1.66),('15128','2013-02-15','09:50:00',1.68),('15128','2013-02-15','09:55:00',1.67),('15128','2013-02-15','10:00:00',1.73),('15128','2013-02-15','10:05:00',1.8),('15128','2013-02-15','10:10:00',1.85),('15128','2013-02-15','10:15:00',1.88),('15128','2013-02-15','10:20:00',1.97),('15128','2013-02-15','10:25:00',2.04),('15128','2013-02-15','10:30:00',2.12),('15128','2013-02-15','10:35:00',2.15),('15128','2013-02-15','10:40:00',2.23),('15128','2013-02-15','10:45:00',2.28),('15128','2013-02-15','10:50:00',2.41),('15128','2013-02-15','10:55:00',2.46),('15128','2013-02-15','11:00:00',2.45),('15128','2013-02-15','11:05:00',2.43),('15128','2013-02-15','11:10:00',2.47),('15128','2013-02-15','11:15:00',2.54),('15128','2013-02-15','11:20:00',2.62),('15128','2013-02-15','11:25:00',2.72),('15128','2013-02-15','11:30:00',2.88),('15128','2013-02-15','11:35:00',2.95),('15128','2013-02-15','11:40:00',2.96),('15128','2013-02-15','11:45:00',3.02),('15128','2013-02-15','11:50:00',3.06),('15128','2013-02-15','11:55:00',3.1),('15128','2013-02-15','12:00:00',3.1),('15128','2013-02-15','12:05:00',3.12),('15128','2013-02-15','12:10:00',3.18),('15128','2013-02-15','12:15:00',3.2),('15128','2013-02-15','12:20:00',3.24),('15128','2013-02-15','12:25:00',3.28),('15128','2013-02-15','12:30:00',3.31),('15128','2013-02-15','12:35:00',3.3),('15128','2013-02-15','12:40:00',3.33),('15128','2013-02-15','12:45:00',3.35),('15128','2013-02-15','12:50:00',3.35),('15128','2013-02-15','12:55:00',3.35),('15128','2013-02-15','13:00:00',3.31),('15128','2013-02-15','13:05:00',3.06),('15128','2013-02-15','13:10:00',3.4),('15128','2013-02-15','13:15:00',3.28),('15128','2013-02-15','13:20:00',3.27),('15128','2013-02-15','13:25:00',2.94),('15128','2013-02-15','13:30:00',3.14),('15128','2013-02-15','13:35:00',3.24),('15128','2013-02-15','13:40:00',3.17),('15128','2013-02-15','13:45:00',3.23),('15128','2013-02-15','13:50:00',3.24),('15128','2013-02-15','13:55:00',3.14),('15128','2013-02-15','14:00:00',2.21),('15128','2013-02-15','14:05:00',3.18),('15128','2013-02-15','14:10:00',3.13),('15128','2013-02-15','14:15:00',3.05),('15128','2013-02-15','14:20:00',3.03),('15128','2013-02-15','14:25:00',3.02),('15128','2013-02-15','14:30:00',3.08),('15128','2013-02-15','14:35:00',3.06),('15128','2013-02-15','14:40:00',2.94),('15128','2013-02-15','14:45:00',2.82),('15128','2013-02-15','14:50:00',2.84),('15128','2013-02-15','14:55:00',1.41),('15128','2013-02-15','15:00:00',2.55),('15128','2013-02-15','15:05:00',2.87),('15128','2013-02-15','15:10:00',2),('15128','2013-02-15','15:15:00',3.1),('15128','2013-02-15','15:20:00',3.18),('15128','2013-02-15','15:25:00',2.36),('15128','2013-02-15','15:30:00',1.4),('15128','2013-02-15','15:35:00',1.09),('15128','2013-02-15','15:40:00',1.09),('15128','2013-02-15','15:45:00',1.16),('15128','2013-02-14','09:25:00',1.29),('15128','2013-02-14','09:40:00',1.45),('15128','2013-02-14','09:45:00',1.3),('15128','2013-02-14','09:50:00',1.59),('15128','2013-02-14','09:55:00',1.67),('15128','2013-02-14','10:00:00',1.61),('15128','2013-02-14','10:05:00',2.05),('15128','2013-02-14','10:10:00',1.62),('15128','2013-02-14','10:15:00',1.65),('15128','2013-02-14','10:20:00',1.52),('15128','2013-02-14','10:25:00',1.85),('15128','2013-02-14','10:30:00',2.24),('15128','2013-02-14','10:35:00',2.37),('15128','2013-02-14','10:40:00',2.6),('15128','2013-02-14','10:45:00',2.19),('15128','2013-02-14','10:50:00',1.55),('15128','2013-02-14','10:55:00',1.66),('15128','2013-02-14','11:00:00',1.94),('15128','2013-02-14','11:05:00',1.68),('15128','2013-02-14','11:10:00',2.36),('15128','2013-02-14','11:15:00',2.71),('15128','2013-02-14','11:20:00',2.75),('15128','2013-02-14','11:25:00',2.91),('15128','2013-02-14','11:30:00',2.98),('15128','2013-02-14','11:35:00',3.14),('15128','2013-02-14','11:40:00',3.36),('15128','2013-02-14','11:45:00',2.79),('15128','2013-02-14','11:50:00',2.12),('15128','2013-02-14','11:55:00',2.92),('15128','2013-02-14','12:00:00',1.91),('15128','2013-02-14','12:05:00',1.56),('15128','2013-02-14','12:10:00',2.89),('15128','2013-02-14','12:15:00',3.66),('15128','2013-02-14','12:20:00',3.23),('15128','2013-02-14','12:25:00',3.4),('15128','2013-02-14','12:30:00',3.34),('15128','2013-02-14','12:35:00',3.3),('15128','2013-02-14','12:40:00',3.29),('15128','2013-02-14','12:45:00',3.27),('15128','2013-02-14','12:50:00',3.32),('15128','2013-02-14','12:55:00',3.39),('15128','2013-02-14','13:00:00',3.5),('15128','2013-02-14','13:05:00',3.61),('15128','2013-02-14','13:10:00',3.04),('15128','2013-02-14','13:15:00',2.13),('15128','2013-02-14','13:20:00',1.6),('15128','2013-02-14','13:25:00',1.26),('15128','2013-02-14','13:30:00',2.08),('15128','2013-02-14','13:35:00',2.05),('15128','2013-02-14','13:40:00',1.85),('15128','2013-02-14','13:45:00',2.72),('15128','2013-02-14','13:50:00',3.34),('15128','2013-02-14','13:55:00',3.36),('15128','2013-02-14','14:00:00',3.13),('15128','2013-02-14','14:05:00',3.43),('15128','2013-02-14','14:10:00',2.46),('15128','2013-02-14','14:15:00',3.17),('15128','2013-02-14','14:20:00',2.44),('15128','2013-02-14','14:25:00',2.3),('15128','2013-02-14','14:30:00',2.62),('15128','2013-02-14','14:35:00',2.9),('15128','2013-02-14','14:40:00',3.04),('15128','2013-02-14','14:45:00',2.57),('15128','2013-02-14','14:50:00',2.13),('15128','2013-02-14','14:55:00',1.78),('15128','2013-02-14','15:00:00',1.62),('15128','2013-02-14','15:05:00',2.69),('15128','2013-02-14','15:10:00',2.09),('15128','2013-02-14','15:15:00',2.5),('15128','2013-02-14','15:20:00',2.38),('15128','2013-02-14','15:25:00',1.49),('15128','2013-02-14','15:30:00',1.14),('15128','2013-02-14','15:35:00',1.33),('15128','2013-02-14','15:40:00',1.46),('15128','2013-02-14','15:45:00',1.05),('15128','2013-02-14','15:50:00',1.04),('15128','2013-02-13','09:10:00',1.07),('15128','2013-02-13','09:15:00',1.16),('15128','2013-02-13','09:20:00',1.27),('15128','2013-02-13','09:25:00',1.34),('15128','2013-02-13','09:30:00',1.38),('15128','2013-02-13','09:35:00',1.47),('15128','2013-02-13','09:40:00',1.53),('15128','2013-02-13','09:45:00',1.6),('15128','2013-02-13','09:50:00',1.67),('15128','2013-02-13','09:55:00',1.75),('15128','2013-02-13','10:00:00',1.8),('15128','2013-02-13','10:05:00',1.83),('15128','2013-02-13','10:10:00',1.88),('15128','2013-02-13','10:15:00',1.92),('15128','2013-02-13','10:20:00',2),('15128','2013-02-13','10:25:00',2.1),('15128','2013-02-13','10:30:00',2.12),('15128','2013-02-13','10:35:00',2.21),('15128','2013-02-13','10:40:00',2.23),('15128','2013-02-13','10:45:00',2.28),('15128','2013-02-13','10:50:00',2.36),('15128','2013-02-13','10:55:00',2.42),('15128','2013-02-13','11:00:00',2.49),('15128','2013-02-13','11:05:00',2.54),('15128','2013-02-13','11:10:00',2.6),('15128','2013-02-13','11:15:00',2.69),('15128','2013-02-13','11:20:00',2.69),('15128','2013-02-13','11:25:00',2.91),('15128','2013-02-13','11:30:00',2.98),('15128','2013-02-13','11:35:00',3.02),('15128','2013-02-13','11:40:00',3.07),('15128','2013-02-13','11:45:00',3.12),('15128','2013-02-13','11:50:00',3.16),('15128','2013-02-13','11:55:00',3.2),('15128','2013-02-13','12:00:00',3.24),('15128','2013-02-13','12:05:00',3.3),('15128','2013-02-13','12:10:00',3.35),('15128','2013-02-13','12:15:00',3.35),('15128','2013-02-13','12:20:00',3.37),('15128','2013-02-13','12:25:00',3.39),('15128','2013-02-13','12:30:00',3.38),('15128','2013-02-13','12:35:00',3.4),('15128','2013-02-13','12:40:00',3.43),('15128','2013-02-13','12:45:00',3.44),('15128','2013-02-13','12:50:00',3.46),('15128','2013-02-13','12:55:00',3.46),('15128','2013-02-13','13:00:00',3.46),('15128','2013-02-13','13:05:00',3.46),('15128','2013-02-13','13:10:00',3.46),('15128','2013-02-13','13:15:00',3.44),('15128','2013-02-13','13:20:00',3.43),('15128','2013-02-13','13:25:00',3.41),('15128','2013-02-13','13:30:00',3.37),('15128','2013-02-13','13:35:00',3.37),('15128','2013-02-13','13:40:00',3.34),('15128','2013-02-13','13:45:00',3.28),('15128','2013-02-13','13:50:00',3.29),('15128','2013-02-13','13:55:00',3.25),('15128','2013-02-13','14:00:00',3.23),('15128','2013-02-13','14:05:00',3.19),('15128','2013-02-13','14:10:00',3.16),('15128','2013-02-13','14:15:00',3.13),('15128','2013-02-13','14:20:00',3.1),('15128','2013-02-13','14:25:00',3.08),('15128','2013-02-13','14:30:00',3.02),('15128','2013-02-13','14:35:00',2.98),('15128','2013-02-13','14:40:00',2.91),('15128','2013-02-13','14:45:00',2.88),('15128','2013-02-13','14:50:00',2.83),('15128','2013-02-13','14:55:00',2.76),('15128','2013-02-13','15:00:00',2.69),('15128','2013-02-13','15:05:00',2.62),('15128','2013-02-13','15:10:00',2.57),('15128','2013-02-13','15:15:00',2.5),('15128','2013-02-13','15:20:00',2.44),('15128','2013-02-13','15:25:00',2.39),('15128','2013-02-13','15:30:00',2.3),('15128','2013-02-13','15:35:00',2.19),('15128','2013-02-13','15:40:00',2.1),('15128','2013-02-13','15:45:00',2.03),('15128','2013-02-13','15:50:00',1.95),('15128','2013-02-13','15:55:00',1.88),('15128','2013-02-13','16:00:00',1.74),('15128','2013-02-13','16:05:00',1.63),('15128','2013-02-13','16:10:00',1.56),('15128','2013-02-13','16:15:00',1.46),('15128','2013-02-13','16:20:00',1.33),('15128','2013-02-13','16:25:00',1.23),('15128','2013-02-13','16:30:00',1.12),('15128','2013-02-12','09:20:00',1.13),('15128','2013-02-12','09:25:00',1.3),('15128','2013-02-12','09:30:00',1.33),('15128','2013-02-12','09:35:00',1.48),('15128','2013-02-12','09:40:00',1.56),('15128','2013-02-12','09:45:00',1.63),('15128','2013-02-12','09:50:00',1.65),('15128','2013-02-12','09:55:00',1.7),('15128','2013-02-12','10:00:00',1.79),('15128','2013-02-12','10:05:00',1.84),('15128','2013-02-12','10:10:00',1.98),('15128','2013-02-12','10:15:00',2.04),('15128','2013-02-12','10:20:00',2.1),('15128','2013-02-12','10:25:00',2.08),('15128','2013-02-12','10:30:00',2.13),('15128','2013-02-12','10:35:00',2.16),('15128','2013-02-12','10:40:00',2.29),('15128','2013-02-12','10:45:00',2.36),('15128','2013-02-12','10:50:00',2.49),('15128','2013-02-12','10:55:00',2.59),('15128','2013-02-12','11:00:00',2.56),('15128','2013-02-12','11:05:00',2.64),('15128','2013-02-12','11:10:00',2.6),('15128','2013-02-12','11:15:00',2.61),('15128','2013-02-12','11:20:00',2.48),('15128','2013-02-12','11:25:00',1.9),('15128','2013-02-12','11:30:00',1.63),('15128','2013-02-12','11:35:00',2.87),('15128','2013-02-12','11:40:00',3.34),('15128','2013-02-12','11:45:00',1.67),('15128','2013-02-12','11:50:00',1.99),('15128','2013-02-12','11:55:00',3.34),('15128','2013-02-12','12:00:00',3.16),('15128','2013-02-12','12:05:00',1.35),('15128','2013-02-12','12:10:00',1.87),('15128','2013-02-12','12:15:00',3.79),('15128','2013-02-12','12:20:00',2.77),('15128','2013-02-12','12:25:00',2.06),('15128','2013-02-12','12:30:00',2.77),('15128','2013-02-12','12:35:00',2.62),('15128','2013-02-12','12:40:00',1.43),('15128','2013-02-12','12:45:00',1.34),('15128','2013-02-12','12:50:00',1.29),('15128','2013-02-12','12:55:00',1.91),('15128','2013-02-12','13:00:00',1.12),('15128','2013-02-12','13:05:00',1.07),('15128','2013-02-12','13:15:00',1.14),('15128','2013-02-12','13:20:00',1.27),('15128','2013-02-12','13:25:00',1.87),('15128','2013-02-12','13:30:00',2.5),('15128','2013-02-12','13:35:00',1.44),('15128','2013-02-12','13:40:00',3.29),('15128','2013-02-12','13:45:00',2.55),('15128','2013-02-12','13:50:00',3.81),('15128','2013-02-12','13:55:00',3.53),('15128','2013-02-12','14:00:00',3.55),('15128','2013-02-12','14:05:00',3.41),('15128','2013-02-12','14:10:00',3.22),('15128','2013-02-12','14:15:00',3),('15128','2013-02-12','14:20:00',2.62),('15128','2013-02-12','14:25:00',2.72),('15128','2013-02-12','14:30:00',2.5),('15128','2013-02-12','14:35:00',2.55),('15128','2013-02-12','14:40:00',2.52),('15128','2013-02-12','14:45:00',2.64),('15128','2013-02-12','14:50:00',2.81),('15128','2013-02-12','14:55:00',2.82),('15128','2013-02-12','15:00:00',2.61),('15128','2013-02-12','15:05:00',2.64),('15128','2013-02-12','15:10:00',2.62),('15128','2013-02-12','15:15:00',2.54),('15128','2013-02-12','15:20:00',2.48),('15128','2013-02-12','15:25:00',2.42),('15128','2013-02-12','15:30:00',2.3),('15128','2013-02-12','15:35:00',2.21),('15128','2013-02-12','15:40:00',2.15),('15128','2013-02-12','15:45:00',2.09),('15128','2013-02-12','15:50:00',2.05),('15128','2013-02-12','15:55:00',1.95),('15128','2013-02-12','16:00:00',1.84),('15128','2013-02-12','16:05:00',1.75),('15128','2013-02-12','16:10:00',1.64),('15128','2013-02-12','16:15:00',1.53),('15128','2013-02-12','16:20:00',1.43),('15128','2013-02-12','16:25:00',1.31),('15128','2013-02-12','16:30:00',1.16),('15128','2013-02-12','16:35:00',1.03),('15128','2013-02-10','10:10:00',1.01),('15128','2013-02-10','10:15:00',1.19),('15128','2013-02-10','10:20:00',1.14),('15128','2013-02-10','11:20:00',1.03),('15128','2013-02-10','14:10:00',1.15),('15128','2013-02-10','14:15:00',1.01),('15128','2013-02-10','14:35:00',1.06),('15128','2013-02-10','14:40:00',1.45),('15128','2013-02-10','14:45:00',1.29),('15128','2013-02-10','14:50:00',1.16),('15128','2013-02-10','15:05:00',1.07),('15128','2014-03-21','08:30:00',1.15),('15128','2014-03-21','08:40:00',1.04),('15128','2014-03-21','08:45:00',1.15),('15128','2014-03-21','08:50:00',1.04),('15128','2014-03-21','08:55:00',1.26),('15128','2014-03-21','09:00:00',1.13),('15128','2014-03-21','09:05:00',1.17),('15128','2014-03-21','09:10:00',1.23),('15128','2014-03-21','09:15:00',1.16),('15128','2014-03-21','09:20:00',1.2),('15128','2014-03-21','09:25:00',1.44),('15128','2014-03-21','09:30:00',1.28),('15128','2014-03-21','09:35:00',1.54),('15128','2014-03-21','09:40:00',2.27),('15128','2014-03-21','09:45:00',1.61),('15128','2014-03-21','09:50:00',1.97),('15128','2014-03-21','09:55:00',2.68),('15128','2014-03-21','10:00:00',2.62),('15128','2014-03-21','10:05:00',2.81),('15128','2014-03-21','10:10:00',1.88),('15128','2014-03-21','10:15:00',1.53),('15128','2014-03-21','10:20:00',1.28),('15128','2014-03-21','10:25:00',1.02),('15128','2014-03-21','10:35:00',1.15),('15128','2014-03-21','10:40:00',1.61),('15128','2014-03-21','10:45:00',1.77),('15128','2014-03-21','10:50:00',1.82),('15128','2014-03-21','10:55:00',2.2),('15128','2014-03-21','11:00:00',1.44),('15128','2014-03-21','11:05:00',1.29),('15128','2014-03-21','11:10:00',2.07),('15128','2014-03-21','11:15:00',2.66),('15128','2014-03-21','11:20:00',2.54),('15128','2014-03-21','11:25:00',2.87),('15128','2014-03-21','11:30:00',4.15),('15128','2014-03-21','11:35:00',2.76),('15128','2014-03-21','11:40:00',2.38),('15128','2014-03-21','11:45:00',2.13),('15128','2014-03-21','11:50:00',2.23),('15128','2014-03-21','11:55:00',1.47),('15128','2014-03-21','12:00:00',2.49),('15128','2014-03-21','12:05:00',4.3),('15128','2014-03-21','12:10:00',2.69),('15128','2014-03-21','12:15:00',1.67),('15128','2014-03-21','12:20:00',2.26),('15128','2014-03-21','12:25:00',3.22),('15128','2014-03-21','12:30:00',2.61),('15128','2014-03-21','12:35:00',3.39),('15128','2014-03-21','12:40:00',3.03),('15128','2014-03-21','12:45:00',3.16),('15128','2014-03-21','12:50:00',1.43),('15128','2014-03-21','12:55:00',1.89),('15128','2014-03-21','13:00:00',1.73),('15128','2014-03-21','13:05:00',1.76),('15128','2014-03-21','13:10:00',4.45),('15128','2014-03-21','13:15:00',4.02),('15128','2014-03-21','13:20:00',3.85),('15128','2014-03-21','13:25:00',3.63),('15128','2014-03-21','13:30:00',3.75),('15128','2014-03-21','13:35:00',3.69),('15128','2014-03-21','13:40:00',3.48),('15128','2014-03-21','13:45:00',3.77),('15128','2014-03-21','13:50:00',3.63),('15128','2014-03-21','13:55:00',3.59),('15128','2014-03-21','14:00:00',3.48),('15128','2014-03-21','14:05:00',3.48),('15128','2014-03-21','14:10:00',3.35),('15128','2014-03-21','14:15:00',3.32),('15128','2014-03-21','14:20:00',3.27),('15128','2014-03-21','14:25:00',3.14),('15128','2014-03-21','14:30:00',3.35),('15128','2014-03-21','14:35:00',3.3),('15128','2014-03-21','14:40:00',3.18),('15128','2014-03-21','14:45:00',3.16),('15128','2014-03-21','14:50:00',3.14),('15128','2014-03-21','14:55:00',3.11),('15128','2014-03-21','15:00:00',3.06),('15128','2014-03-21','15:05:00',2.99),('15128','2014-03-21','15:10:00',2.88),('15128','2014-03-21','15:15:00',2.84),('15128','2014-03-21','15:20:00',2.86),('15128','2014-03-21','15:25:00',2.13),('15128','2014-03-21','15:30:00',2.33),('15128','2014-03-21','15:35:00',2.5),('15128','2014-03-21','15:40:00',2.71),('15128','2014-03-21','15:45:00',2.22),('15128','2014-03-21','15:50:00',2.44),('15128','2014-03-21','15:55:00',2.18),('15128','2014-03-21','16:00:00',1.75),('15128','2014-03-21','16:05:00',2.1),('15128','2014-03-21','16:10:00',1.83),('15128','2014-03-21','16:15:00',1.39),('15128','2014-03-21','16:20:00',1.73),('15128','2014-03-21','16:40:00',1.08),('15128','2013-02-09','09:25:00',1.32),('15128','2013-02-09','09:30:00',1.37),('15128','2013-02-09','09:40:00',1.02),('15128','2013-02-09','09:45:00',1.5),('15128','2013-02-09','09:50:00',1.61),('15128','2013-02-09','09:55:00',1.67),('15128','2013-02-09','10:00:00',1.71),('15128','2013-02-09','10:05:00',1.76),('15128','2013-02-09','10:10:00',1.82),('15128','2013-02-09','10:15:00',1.88),('15128','2013-02-09','10:20:00',1.95),('15128','2013-02-09','10:25:00',1.99),('15128','2013-02-09','10:30:00',2.03),('15128','2013-02-09','10:35:00',2.1),('15128','2013-02-09','10:40:00',2.17),('15128','2013-02-09','10:45:00',2.19),('15128','2013-02-09','10:50:00',2.25),('15128','2013-02-09','10:55:00',2.28),('15128','2013-02-09','11:00:00',2.32),('15128','2013-02-09','11:05:00',2.35),('15128','2013-02-09','11:10:00',2.46),('15128','2013-02-09','11:15:00',2.49),('15128','2013-02-09','11:20:00',2.55),('15128','2013-02-09','11:25:00',2.73),('15128','2013-02-09','11:30:00',2.86),('15128','2013-02-09','11:35:00',2.91),('15128','2013-02-09','11:40:00',2.94),('15128','2013-02-09','11:45:00',2.96),('15128','2013-02-09','11:50:00',3.01),('15128','2013-02-09','11:55:00',2.98),('15128','2013-02-09','12:00:00',3.13),('15128','2013-02-09','12:05:00',3.19),('15128','2013-02-09','12:10:00',3.22),('15128','2013-02-09','12:15:00',3.23),('15128','2013-02-09','12:20:00',3.28),('15128','2013-02-09','12:25:00',3.22),('15128','2013-02-09','12:30:00',3.15),('15128','2013-02-09','12:35:00',3.18),('15128','2013-02-09','12:40:00',3.25),('15128','2013-02-09','12:45:00',3.26),('15128','2013-02-09','12:50:00',3.31),('15128','2013-02-09','12:55:00',3.31),('15128','2013-02-09','13:00:00',3.36),('15128','2013-02-09','13:05:00',3.35),('15128','2013-02-09','13:10:00',3.34),('15128','2013-02-09','13:15:00',3.34),('15128','2013-02-09','13:20:00',3.34),('15128','2013-02-09','13:25:00',3.31),('15128','2013-02-09','13:30:00',3.31),('15128','2013-02-09','13:35:00',3.25),('15128','2013-02-09','13:40:00',3.22),('15128','2013-02-09','13:45:00',3.2),('15128','2013-02-09','13:50:00',3.18),('15128','2013-02-09','13:55:00',3.15),('15128','2013-02-09','14:00:00',3.12),('15128','2013-02-09','14:05:00',3.09),('15128','2013-02-09','14:10:00',3.09),('15128','2013-02-09','14:15:00',3.06),('15128','2013-02-09','14:20:00',3.03),('15128','2013-02-09','14:25:00',2.98),('15128','2013-02-09','14:30:00',2.9),('15128','2013-02-09','14:35:00',2.83),('15128','2013-02-09','14:40:00',2.8),('15128','2013-02-09','14:45:00',2.73),('15128','2013-02-09','14:50:00',2.64),('15128','2013-02-09','14:55:00',2.54),('15128','2013-02-09','15:00:00',2.55),('15128','2013-02-09','15:05:00',2.59),('15128','2013-02-09','15:10:00',2.63),('15128','2013-02-09','15:15:00',1.59),('15128','2013-02-09','16:15:00',1.32),('15128','2013-02-09','16:20:00',1.35),('15128','2013-02-09','16:25:00',1.26),('15128','2013-02-09','16:30:00',1.14),('15128','2013-02-08','10:45:00',1.04),('15128','2013-02-08','10:50:00',1.18),('15128','2013-02-08','10:55:00',1.26),('15128','2013-02-08','11:00:00',1.3),('15128','2013-02-08','11:05:00',1.35),('15128','2013-02-08','11:10:00',1.41),('15128','2013-02-08','11:15:00',1.45),('15128','2013-02-08','11:20:00',1.45),('15128','2013-02-08','11:25:00',1.38),('15128','2013-02-08','11:30:00',1.37),('15128','2013-02-08','11:35:00',1.39),('15128','2013-02-08','11:40:00',1.41),('15128','2013-02-08','11:45:00',1.4),('15128','2013-02-08','11:50:00',1.36),('15128','2013-02-08','11:55:00',1.35),('15128','2013-02-08','12:00:00',1.39),('15128','2013-02-08','12:05:00',1.46),('15128','2013-02-08','12:10:00',1.36),('15128','2013-02-08','12:15:00',1.29),('15128','2013-02-08','12:20:00',1.29),('15128','2013-02-08','12:25:00',1.3),('15128','2013-02-08','12:30:00',1.34),('15128','2013-02-08','12:35:00',1.35),('15128','2013-02-08','12:40:00',1.32),('15128','2013-02-08','12:45:00',1.34),('15128','2013-02-08','12:50:00',1.51),('15128','2013-02-08','12:55:00',1.72),('15128','2013-02-08','13:00:00',1.86),('15128','2013-02-08','13:05:00',2.19),('15128','2013-02-08','13:10:00',2.25),('15128','2013-02-08','13:15:00',2.32),('15128','2013-02-08','13:20:00',2.63),('15128','2013-02-08','13:25:00',2.85),('15128','2013-02-08','13:30:00',3.05),('15128','2013-02-08','13:35:00',3.54),('15128','2013-02-08','13:40:00',3.48),('15128','2013-02-08','13:45:00',3.41),('15128','2013-02-08','13:50:00',3.43),('15128','2013-02-08','13:55:00',3.33),('15128','2013-02-08','14:00:00',3.28),('15128','2013-02-08','14:05:00',1.83),('15128','2013-02-08','14:10:00',1.62),('15128','2013-02-08','14:15:00',3.71),('15128','2013-02-08','14:20:00',3.55),('15128','2013-02-08','14:25:00',3.21),('15128','2013-02-08','14:30:00',2.9),('15128','2013-02-08','14:35:00',2.32),('15128','2013-02-08','14:40:00',2.35),('15128','2013-02-08','14:45:00',2.76),('15128','2013-02-08','14:50:00',2.65),('15128','2013-02-08','14:55:00',2.59),('15128','2013-02-08','15:00:00',2.51),('15128','2013-02-08','15:05:00',2.16),('15128','2013-02-08','15:10:00',2.28),('15128','2013-02-08','15:15:00',2.3),('15128','2013-02-08','15:20:00',2.22),('15128','2013-02-08','15:25:00',2.22),('15128','2013-02-08','15:30:00',1.89),('15128','2013-02-08','15:35:00',2.04),('15128','2013-02-08','15:40:00',2.11),('15128','2013-02-08','15:45:00',2),('15128','2013-02-08','15:50:00',1.82),('15128','2013-02-08','15:55:00',1.74),('15128','2013-02-08','16:05:00',1.68),('15128','2013-02-08','16:10:00',1.61),('15128','2013-02-08','16:20:00',1.2),('15128','2013-02-08','16:25:00',1.28),('15128','2013-02-08','16:30:00',1.14),('15128','2013-02-07','09:45:00',1.58),('15128','2013-02-07','09:50:00',1.39),('15128','2013-02-07','09:55:00',1.67),('15128','2013-02-07','10:00:00',1.27),('15128','2013-02-07','10:05:00',1.42),('15128','2013-02-07','10:10:00',1.82),('15128','2013-02-07','10:15:00',1.42),('15128','2013-02-07','10:20:00',1.92),('15128','2013-02-07','10:25:00',2.13),('15128','2013-02-07','10:30:00',2.16),('15128','2013-02-07','10:35:00',2.43),('15128','2013-02-07','10:40:00',2.29),('15128','2013-02-07','10:45:00',1.76),('15128','2013-02-07','10:50:00',1.24),('15128','2013-02-07','10:55:00',1.96),('15128','2013-02-07','11:00:00',2.64),('15128','2013-02-07','11:05:00',2.47),('15128','2013-02-07','11:10:00',2.44),('15128','2013-02-07','11:15:00',2.5),('15128','2013-02-07','11:20:00',2.61),('15128','2013-02-07','11:25:00',2.69),('15128','2013-02-07','11:30:00',2.74),('15128','2013-02-07','11:35:00',2.86),('15128','2013-02-07','11:40:00',2.88),('15128','2013-02-07','11:45:00',2.94),('15128','2013-02-07','11:50:00',2.98),('15128','2013-02-07','11:55:00',3.04),('15128','2013-02-07','12:00:00',3.1),('15128','2013-02-07','12:05:00',3.14),('15128','2013-02-07','12:10:00',3.18),('15128','2013-02-07','12:15:00',3.24),('15128','2013-02-07','12:20:00',2.96),('15128','2013-02-07','12:25:00',2.95),('15128','2013-02-07','12:30:00',2.45),('15128','2013-02-07','12:35:00',2.32),('15128','2013-02-07','12:40:00',1.92),('15128','2013-02-07','12:45:00',2.04),('15128','2013-02-07','12:50:00',2),('15128','2013-02-07','12:55:00',2.05),('15128','2013-02-07','13:00:00',1.63),('15128','2013-02-07','13:05:00',1.64),('15128','2013-02-07','13:10:00',1.76),('15128','2013-02-07','13:15:00',1.89),('15128','2013-02-07','13:20:00',1.79),('15128','2013-02-07','13:25:00',1.86),('15128','2013-02-07','13:30:00',1.73),('15128','2013-02-07','13:35:00',2.11),('15128','2013-02-07','13:40:00',1.4),('15128','2013-02-07','13:45:00',1.45),('15128','2013-02-07','13:50:00',1.43),('15128','2013-02-07','13:55:00',1.44),('15128','2013-02-07','14:00:00',1.54),('15128','2013-02-07','14:05:00',1.68),('15128','2013-02-07','14:10:00',1.73),('15128','2013-02-07','14:15:00',1.71),('15128','2013-02-07','14:20:00',2.01),('15128','2013-02-07','14:25:00',2.23),('15128','2013-02-07','14:30:00',2.17),('15128','2013-02-07','14:35:00',2.12),('15128','2013-02-07','14:40:00',2.34),('15128','2013-02-07','14:45:00',2.54),('15128','2013-02-07','14:50:00',1.97),('15128','2013-02-07','14:55:00',2.83),('15128','2013-02-07','15:00:00',2.58),('15128','2013-02-07','15:05:00',2.84),('15128','2013-02-07','15:10:00',2.63),('15128','2013-02-07','15:15:00',2.2),('15128','2013-02-07','15:20:00',2.57),('15128','2013-02-07','15:25:00',2.46),('15128','2013-02-07','15:30:00',2.43),('15128','2013-02-07','15:35:00',2.36),('15128','2013-02-07','15:40:00',2.32),('15128','2013-02-07','15:45:00',1.63),('15128','2013-02-07','15:50:00',1.32),('15128','2013-02-07','16:00:00',1.22),('15128','2013-02-07','16:05:00',1.09),('15128','2013-02-06','10:25:00',1.03),('15128','2013-02-06','10:30:00',1.17),('15128','2013-02-06','10:35:00',1.07),('15128','2013-02-06','10:40:00',1.77),('15128','2013-02-06','10:45:00',1.83),('15128','2013-02-06','10:50:00',1.54),('15128','2013-02-06','10:55:00',1.83),('15128','2013-02-06','11:00:00',2.19),('15128','2013-02-06','11:05:00',1.35),('15128','2013-02-06','11:10:00',2.47),('15128','2013-02-06','11:15:00',1.97),('15128','2013-02-06','12:20:00',2.05),('15128','2013-02-06','12:25:00',2.41),('15128','2013-02-06','12:30:00',1.45),('15128','2013-02-06','12:35:00',1.42),('15128','2013-02-06','12:40:00',1.12),('15128','2013-02-06','12:45:00',1.06),('15128','2013-02-06','12:50:00',1.05),('15128','2013-02-06','13:05:00',1.04),('15128','2013-02-06','13:10:00',2.25),('15128','2013-02-06','13:15:00',3.91),('15128','2013-02-06','13:20:00',3.52),('15128','2013-02-06','13:25:00',2.26),('15128','2013-02-06','13:30:00',1.24),('15128','2013-02-06','13:45:00',1),('15128','2013-02-06','13:50:00',1.04),('15128','2013-02-06','13:55:00',1.23),('15128','2013-02-06','14:00:00',2.05),('15128','2013-02-06','14:05:00',2.67),('15128','2013-02-06','14:10:00',3.57),('15128','2013-02-06','14:15:00',2.19),('15128','2013-02-06','14:20:00',2.47),('15128','2013-02-06','14:25:00',1.24),('15128','2013-02-06','14:45:00',1.37),('15128','2013-02-06','14:50:00',1.27),('15128','2013-02-06','14:55:00',1.06),('15128','2013-02-06','15:00:00',1.86),('15128','2013-02-06','15:05:00',3.21),('15128','2013-02-06','15:10:00',2.91),('15128','2013-02-06','15:15:00',2.84),('15128','2013-02-06','15:20:00',2.11),('15128','2013-02-06','15:30:00',1.55),('15128','2013-02-06','15:35:00',2.35),('15128','2013-02-06','15:40:00',1.9),('15128','2013-02-05','09:25:00',1.02),('15128','2013-02-05','09:30:00',1.05),('15128','2013-02-05','09:35:00',1.17),('15128','2013-02-05','09:40:00',1.14),('15128','2013-02-05','09:45:00',1.2),('15128','2013-02-05','09:50:00',1.52),('15128','2013-02-05','09:55:00',1.31),('15128','2013-02-05','10:00:00',1.42),('15128','2013-02-05','10:05:00',1.6),('15128','2013-02-05','10:10:00',1.29),('15128','2013-02-05','10:15:00',1.41),('15128','2013-02-05','10:20:00',2.61),('15128','2013-02-05','10:25:00',2),('15128','2013-02-05','10:30:00',1.25),('15128','2013-02-05','10:35:00',1.2),('15128','2013-02-05','10:40:00',1.02),('15128','2013-02-05','10:45:00',1.12),('15128','2013-02-05','10:50:00',1.39),('15128','2013-02-05','10:55:00',1.49),('15128','2013-02-05','11:00:00',1.44),('15128','2013-02-05','11:05:00',1.68),('15128','2013-02-05','11:10:00',1.57),('15128','2013-02-05','11:15:00',1.8),('15128','2013-02-05','11:20:00',2.11),('15128','2013-02-05','11:25:00',1.54),('15128','2013-02-05','11:30:00',1.64),('15128','2013-02-05','11:35:00',1.68),('15128','2013-02-05','11:40:00',1.75),('15128','2013-02-05','11:45:00',1.63),('15128','2013-02-05','11:50:00',1.55),('15128','2013-02-05','11:55:00',1.34),('15128','2013-02-05','12:00:00',1.2),('15128','2013-02-05','12:05:00',1.22),('15128','2013-02-05','12:10:00',1.39),('15128','2013-02-05','12:15:00',1.3),('15128','2013-02-05','12:20:00',1.15),('15128','2013-02-05','12:25:00',1.07),('15128','2013-02-05','12:30:00',1.03),('15128','2013-02-05','12:35:00',1.09),('15128','2013-02-05','12:40:00',1.1),('15128','2013-02-05','13:10:00',1.14),('15128','2013-02-05','13:15:00',1.25),('15128','2013-02-05','13:20:00',1.73),('15128','2013-02-05','13:25:00',2.34),('15128','2013-02-05','13:30:00',1.94),('15128','2013-02-05','13:35:00',2.22),('15128','2013-02-05','13:40:00',1.61),('15128','2013-02-05','13:45:00',2.05),('15128','2013-02-05','13:50:00',2.3),('15128','2013-02-05','13:55:00',1.37),('15128','2013-02-05','14:00:00',1),('15128','2013-02-05','14:35:00',1.18),('15128','2013-02-05','15:20:00',2.6),('15128','2013-02-05','15:25:00',1.47),('15128','2013-02-04','09:25:00',1.05),('15128','2013-02-04','09:30:00',1.07),('15128','2013-02-04','09:35:00',1.15),('15128','2013-02-04','09:40:00',1.21),('15128','2013-02-04','09:45:00',1.34),('15128','2013-02-04','09:50:00',1.43),('15128','2013-02-04','09:55:00',1.5),('15128','2013-02-04','10:00:00',1.55),('15128','2013-02-04','10:05:00',1.46),('15128','2013-02-04','10:10:00',1.58),('15128','2013-02-04','10:15:00',1.74),('15128','2013-02-04','10:20:00',1.78),('15128','2013-02-04','10:25:00',1.81),('15128','2013-02-04','10:30:00',1.86),('15128','2013-02-04','10:35:00',1.9),('15128','2013-02-04','10:40:00',1.97),('15128','2013-02-04','10:45:00',2.06),('15128','2013-02-04','10:50:00',2.08),('15128','2013-02-04','10:55:00',2.13),('15128','2013-02-04','11:00:00',2.16),('15128','2013-02-04','11:05:00',2.24),('15128','2013-02-04','11:10:00',2.25),('15128','2013-02-04','11:15:00',2.35),('15128','2013-02-04','11:20:00',2.45),('15128','2013-02-04','11:25:00',2.48),('15128','2013-02-04','11:30:00',2.07),('15128','2013-02-04','11:35:00',1.66),('15128','2013-02-04','11:40:00',2.23),('15128','2013-02-04','11:45:00',1.82),('15128','2013-02-04','11:50:00',2.05),('15128','2013-02-04','11:55:00',3.07),('15128','2013-02-04','12:00:00',3.08),('15128','2013-02-04','12:05:00',1.56),('15128','2013-02-04','12:10:00',2.1),('15128','2013-02-04','12:15:00',1.55),('15128','2013-02-04','12:20:00',1.78),('15128','2013-02-04','12:25:00',2.48),('15128','2013-02-04','12:30:00',2.21),('15128','2013-02-04','12:35:00',2.57),('15128','2013-02-04','12:40:00',1.72),('15128','2013-02-04','12:45:00',1.79),('15128','2013-02-04','12:50:00',1.46),('15128','2013-02-04','12:55:00',1.01),('15128','2013-02-04','13:00:00',1.41),('15128','2013-02-04','13:05:00',1.99),('15128','2013-02-04','13:10:00',2.64),('15128','2013-02-04','13:15:00',2.29),('15128','2013-02-04','13:20:00',1.62),('15128','2013-02-04','13:25:00',1.36),('15128','2013-02-04','13:30:00',1.5),('15128','2013-02-04','13:35:00',1.53),('15128','2013-02-04','13:40:00',1.52),('15128','2013-02-04','13:45:00',1.56),('15128','2013-02-04','13:50:00',1.75),('15128','2013-02-04','13:55:00',1.44),('15128','2013-02-04','14:00:00',1.54),('15128','2013-02-04','14:05:00',1.41),('15128','2013-02-04','14:10:00',1.45),('15128','2013-02-04','14:15:00',1.51),('15128','2013-02-04','14:20:00',1.87),('15128','2013-02-04','14:25:00',1.81),('15128','2013-02-04','14:30:00',1.53),('15128','2013-02-04','14:35:00',1.44),('15128','2013-02-04','14:40:00',1.24),('15128','2013-02-04','14:45:00',1.4),('15128','2013-02-04','14:50:00',1.18),('15128','2013-02-03','09:25:00',1.17),('15128','2013-02-03','09:30:00',1.17),('15128','2013-02-03','09:35:00',1.28),('15128','2013-02-03','09:40:00',1.34),('15128','2013-02-03','09:45:00',1.42),('15128','2013-02-03','09:50:00',1.6),('15128','2013-02-03','09:55:00',1.75),('15128','2013-02-03','10:00:00',1.78),('15128','2013-02-03','10:05:00',1.86),('15128','2013-02-03','10:10:00',1.87),('15128','2013-02-03','10:15:00',1.64),('15128','2013-02-03','10:20:00',1.74),('15128','2013-02-03','10:25:00',1.9),('15128','2013-02-03','10:30:00',1.82),('15128','2013-02-03','10:35:00',1.96),('15128','2013-02-03','10:40:00',2.08),('15128','2013-02-03','10:45:00',2.13),('15128','2013-02-03','10:50:00',2.14),('15128','2013-02-03','10:55:00',2.18),('15128','2013-02-03','11:00:00',2.26),('15128','2013-02-03','11:05:00',2.31),('15128','2013-02-03','11:10:00',2.34),('15128','2013-02-03','11:15:00',2.43),('15128','2013-02-03','11:20:00',2.56),('15128','2013-02-03','11:25:00',2.66),('15128','2013-02-03','11:30:00',2.72),('15128','2013-02-03','11:35:00',2.79),('15128','2013-02-03','11:40:00',2.85),('15128','2013-02-03','11:45:00',2.87),('15128','2013-02-03','11:50:00',2.9),('15128','2013-02-03','11:55:00',2.96),('15128','2013-02-03','12:00:00',3.03),('15128','2013-02-03','12:05:00',3.05),('15128','2013-02-03','12:10:00',3.06),('15128','2013-02-03','12:15:00',3.08),('15128','2013-02-03','12:20:00',3.08),('15128','2013-02-03','12:25:00',3.06),('15128','2013-02-03','12:30:00',3.16),('15128','2013-02-03','12:35:00',3.16),('15128','2013-02-03','12:40:00',3.15),('15128','2013-02-03','12:45:00',3.16),('15128','2013-02-03','12:50:00',3.16),('15128','2013-02-03','12:55:00',3.17),('15128','2013-02-03','13:00:00',3.19),('15128','2013-02-03','13:05:00',3.19),('15128','2013-02-03','13:10:00',3.19),('15128','2013-02-03','13:15:00',3.19),('15128','2013-02-03','13:20:00',3.17),('15128','2013-02-03','13:25:00',3.15),('15128','2013-02-03','13:30:00',3.17),('15128','2013-02-03','13:35:00',3.13),('15128','2013-02-03','13:40:00',3.1),('15128','2013-02-03','13:45:00',3.1),('15128','2013-02-03','13:50:00',3.09),('15128','2013-02-03','13:55:00',3.07),('15128','2013-02-03','14:00:00',3.03),('15128','2013-02-03','14:05:00',3.01),('15128','2013-02-03','14:10:00',2.98),('15128','2013-02-03','14:15:00',2.94),('15128','2013-02-03','14:20:00',2.91),('15128','2013-02-03','14:25:00',2.88),('15128','2013-02-03','14:30:00',2.83),('15128','2013-02-03','14:35:00',2.79),('15128','2013-02-03','14:40:00',2.74),('15128','2013-02-03','14:45:00',2.69),('15128','2013-02-03','14:50:00',2.64),('15128','2013-02-03','14:55:00',2.59),('15128','2013-02-03','15:00:00',2.53),('15128','2013-02-03','15:05:00',2.47),('15128','2013-02-03','15:10:00',2.4),('15128','2013-02-03','15:15:00',2.33),('15128','2013-02-03','15:20:00',2.27),('15128','2013-02-03','15:25:00',2.2),('15128','2013-02-03','15:30:00',2.13),('15128','2013-02-03','15:35:00',2.05),('15128','2013-02-03','15:40:00',1.93),('15128','2013-02-03','15:45:00',1.81),('15128','2013-02-03','15:50:00',1.75),('15128','2013-02-03','15:55:00',1.67),('15128','2013-02-03','16:00:00',1.59),('15128','2013-02-03','16:05:00',1.49),('15128','2013-02-03','16:10:00',1.36),('15128','2013-02-03','16:15:00',1.22),('15128','2013-02-03','16:20:00',1.07),('15128','2013-02-02','09:30:00',1.15),('15128','2013-02-02','09:35:00',1.32),('15128','2013-02-02','09:40:00',1.66),('15128','2013-02-02','09:45:00',2.37),('15128','2013-02-02','09:50:00',2.26),('15128','2013-02-02','11:00:00',1.14),('15128','2013-02-02','11:20:00',1.09),('15128','2013-02-02','11:25:00',2.64),('15128','2013-02-02','11:30:00',2.76),('15128','2013-02-02','11:35:00',1.08),('15128','2013-02-02','12:15:00',1.94),('15128','2013-02-02','12:20:00',1.5),('15128','2013-02-01','10:15:00',1.06),('15128','2013-02-01','10:20:00',1.23),('15128','2013-02-01','10:30:00',1.11),('15128','2013-02-01','10:35:00',1.35),('15128','2013-02-01','10:40:00',1.71),('15128','2013-02-01','10:45:00',1.9),('15128','2013-02-01','10:50:00',1.89),('15128','2013-02-01','10:55:00',1.74),('15128','2013-02-01','11:00:00',1.83),('15128','2013-02-01','11:05:00',1.7),('15128','2013-02-01','11:10:00',2.01),('15128','2013-02-01','11:15:00',1.79),('15128','2013-02-01','11:20:00',2.1),('15128','2013-02-01','11:25:00',2.2),('15128','2013-02-01','11:30:00',1.82),('15128','2013-02-01','11:35:00',1.68),('15128','2013-02-01','11:40:00',1.62),('15128','2013-02-01','11:45:00',1.14),('15128','2013-02-01','11:50:00',1.29),('15128','2013-02-01','12:40:00',1.37),('15128','2013-02-01','12:45:00',1.51),('15128','2013-02-01','12:50:00',2.3),('15128','2013-02-01','12:55:00',2.12),('15128','2013-02-01','13:00:00',2.11),('15128','2013-02-01','13:05:00',1.66),('15128','2013-02-01','13:10:00',2.56),('15128','2013-02-01','13:15:00',2.45),('15128','2013-02-01','13:20:00',2.06),('15128','2013-02-01','13:25:00',1.62),('15128','2013-02-01','13:30:00',2.09),('15128','2013-02-01','13:35:00',2.32),('15128','2013-02-01','13:40:00',1.75),('15128','2013-02-01','13:45:00',1.6),('15128','2013-02-01','13:50:00',1.25),('15128','2013-01-31','09:20:00',1.12),('15128','2013-01-31','09:25:00',1.18),('15128','2013-01-31','09:45:00',1.33),('15128','2013-01-31','09:50:00',1.1),('15128','2013-01-31','09:55:00',1.23),('15128','2013-01-31','10:10:00',1.63),('15128','2013-01-31','10:15:00',1.34),('15128','2013-01-31','10:30:00',1.53),('15128','2013-01-31','10:35:00',1.62),('15128','2013-01-31','10:45:00',1.02),('15128','2013-01-31','10:50:00',2.04),('15128','2013-01-31','10:55:00',1.13),('15128','2013-01-31','11:25:00',2.52),('15128','2013-01-31','11:30:00',1.57),('15128','2013-01-31','11:35:00',1.8),('15128','2013-01-31','11:40:00',1.48),('15128','2013-01-31','11:50:00',1.15),('15128','2013-01-31','11:55:00',1.18),('15128','2013-01-31','12:00:00',1.17),('15128','2013-01-31','12:05:00',1.77),('15128','2013-01-31','12:10:00',1.47),('15128','2013-01-31','12:15:00',1.33),('15128','2013-01-31','12:20:00',2.24),('15128','2013-01-31','12:25:00',1.46),('15128','2013-01-31','12:30:00',1.32),('15128','2013-01-31','12:35:00',3.7),('15128','2013-01-31','12:40:00',2.38),('15128','2013-01-31','12:45:00',3.42),('15128','2013-01-31','12:50:00',1.19),('15128','2013-01-31','12:55:00',1.54),('15128','2013-01-31','13:00:00',1.64),('15128','2013-01-31','13:05:00',3.52),('15128','2013-01-31','13:10:00',3.16),('15128','2013-01-31','13:15:00',2.06),('15128','2013-01-31','13:20:00',1.01),('15128','2013-01-31','13:25:00',1.01),('15128','2013-01-31','13:30:00',2.43),('15128','2013-01-31','13:35:00',1.52),('15128','2013-01-31','13:40:00',2.74),('15128','2013-01-31','13:45:00',2.29),('15128','2013-01-31','13:50:00',2.63),('15128','2013-01-31','13:55:00',2.66),('15128','2013-01-31','14:00:00',2.28),('15128','2013-01-31','14:05:00',2.6),('15128','2013-01-31','14:10:00',2.75),('15128','2013-01-31','14:15:00',2.79),('15128','2013-01-31','14:20:00',2.61),('15128','2013-01-31','14:25:00',2.14),('15128','2013-01-31','14:30:00',1.11),('15128','2013-01-31','14:40:00',2.9),('15128','2013-01-31','14:45:00',1.35),('15128','2013-01-31','14:50:00',1.02),('15128','2013-01-31','14:55:00',1.28),('15128','2013-01-31','15:00:00',1.72),('15128','2013-01-31','15:20:00',1.24),('15128','2013-01-31','15:25:00',2.27),('15128','2013-01-31','15:30:00',1.36),('15128','2014-03-20','08:25:00',1.07),('15128','2014-03-20','08:30:00',1.16),('15128','2014-03-20','08:35:00',1.22),('15128','2014-03-20','08:40:00',1.28),('15128','2014-03-20','08:45:00',1.34),('15128','2014-03-20','08:50:00',1.38),('15128','2014-03-20','08:55:00',1.45),('15128','2014-03-20','09:00:00',1.52),('15128','2014-03-20','09:05:00',1.58),('15128','2014-03-20','09:10:00',1.67),('15128','2014-03-20','09:15:00',1.71),('15128','2014-03-20','09:20:00',1.75),('15128','2014-03-20','09:25:00',1.78),('15128','2014-03-20','09:30:00',1.84),('15128','2014-03-20','09:35:00',1.91),('15128','2014-03-20','09:40:00',1.99),('15128','2014-03-20','09:45:00',2.03),('15128','2014-03-20','09:50:00',2.06),('15128','2014-03-20','09:55:00',2.08),('15128','2014-03-20','10:00:00',2.19),('15128','2014-03-20','10:05:00',2.23),('15128','2014-03-20','10:10:00',2.28),('15128','2014-03-20','10:15:00',2.32),('15128','2014-03-20','10:20:00',2.42),('15128','2014-03-20','10:25:00',2.47),('15128','2014-03-20','10:30:00',2.52),('15128','2014-03-20','10:35:00',2.54),('15128','2014-03-20','10:40:00',2.52),('15128','2014-03-20','10:45:00',2.58),('15128','2014-03-20','10:50:00',2.66),('15128','2014-03-20','10:55:00',2.75),('15128','2014-03-20','11:00:00',2.72),('15128','2014-03-20','11:05:00',2.91),('15128','2014-03-20','11:10:00',3.04),('15128','2014-03-20','11:15:00',3),('15128','2014-03-20','11:20:00',3.12),('15128','2014-03-20','11:25:00',3.16),('15128','2014-03-20','11:30:00',3.23),('15128','2014-03-20','11:35:00',3.17),('15128','2014-03-20','11:40:00',3.22),('15128','2014-03-20','11:45:00',3.19),('15128','2014-03-20','11:50:00',3.26),('15128','2014-03-20','11:55:00',3.35),('15128','2014-03-20','12:00:00',3.37),('15128','2014-03-20','12:05:00',3.29),('15128','2014-03-20','12:10:00',3.51),('15128','2014-03-20','12:15:00',3.54),('15128','2014-03-20','12:20:00',3.57),('15128','2014-03-20','12:25:00',3.57),('15128','2014-03-20','12:30:00',3.52),('15128','2014-03-20','12:35:00',3.57),('15128','2014-03-20','12:40:00',3.63),('15128','2014-03-20','12:45:00',3.66),('15128','2014-03-20','12:50:00',3.64),('15128','2014-03-20','12:55:00',3.62),('15128','2014-03-20','13:00:00',3.6),('15128','2014-03-20','13:05:00',3.62),('15128','2014-03-20','13:10:00',3.62),('15128','2014-03-20','13:15:00',3.63),('15128','2014-03-20','13:20:00',3.61),('15128','2014-03-20','13:25:00',3.59),('15128','2014-03-20','13:30:00',3.62),('15128','2014-03-20','13:35:00',3.58),('15128','2014-03-20','13:40:00',3.6),('15128','2014-03-20','13:45:00',3.58),('15128','2014-03-20','13:50:00',3.57),('15128','2014-03-20','13:55:00',3.59),('15128','2014-03-20','14:00:00',3.57),('15128','2014-03-20','14:05:00',3.53),('15128','2014-03-20','14:10:00',3.49),('15128','2014-03-20','14:15:00',3.46),('15128','2014-03-20','14:20:00',3.41),('15128','2014-03-20','14:25:00',3.39),('15128','2014-03-20','14:30:00',3.34),('15128','2014-03-20','14:35:00',3.27),('15128','2014-03-20','14:40:00',3.05),('15128','2014-03-20','14:45:00',2.72),('15128','2014-03-20','14:50:00',1.61),('15128','2014-03-20','14:55:00',1.21),('15128','2014-03-20','15:00:00',1.54),('15128','2014-03-20','15:05:00',2.34),('15128','2014-03-20','15:10:00',3.39),('15128','2014-03-20','15:15:00',3.41),('15128','2014-03-20','15:20:00',3.07),('15128','2014-03-20','15:25:00',1.5),('15128','2014-03-20','15:30:00',3.15),('15128','2014-03-20','15:35:00',3.01),('15128','2014-03-20','15:40:00',2.97),('15128','2014-03-20','15:45:00',2.34),('15128','2014-03-20','15:50:00',2.88),('15128','2014-03-20','15:55:00',2.79),('15128','2014-03-20','16:00:00',2.61),('15128','2014-03-20','16:05:00',2.47),('15128','2014-03-20','16:10:00',2.28),('15128','2014-03-20','16:15:00',2.08),('15128','2014-03-20','16:20:00',1.91),('15128','2014-03-20','16:25:00',1.85),('15128','2014-03-20','16:30:00',1.71),('15128','2014-03-20','16:35:00',1.61),('15128','2014-03-20','16:40:00',1.57),('15128','2014-03-20','16:45:00',1.46),('15128','2014-03-20','16:50:00',1.42),('15128','2014-03-20','16:55:00',1.3),('15128','2014-03-20','17:00:00',1.06),('15128','2013-01-30','09:35:00',1),('15128','2013-01-30','09:40:00',1.08),('15128','2013-01-30','09:45:00',1.19),('15128','2013-01-30','09:50:00',1.19),('15128','2013-01-30','09:55:00',1.22),('15128','2013-01-30','10:00:00',1.36),('15128','2013-01-30','10:05:00',1.38),('15128','2013-01-30','10:10:00',1.47),('15128','2013-01-30','10:15:00',1.56),('15128','2013-01-30','10:20:00',1.61),('15128','2013-01-30','10:25:00',1.62),('15128','2013-01-30','10:30:00',1.72),('15128','2013-01-30','10:35:00',1.8),('15128','2013-01-30','10:40:00',1.82),('15128','2013-01-30','10:45:00',1.93),('15128','2013-01-30','10:50:00',1.99),('15128','2013-01-30','10:55:00',2.06),('15128','2013-01-30','11:00:00',2.24),('15128','2013-01-30','11:05:00',2.26),('15128','2013-01-30','11:10:00',2.33),('15128','2013-01-30','11:15:00',2.04),('15128','2013-01-30','11:30:00',2.63),('15128','2013-01-30','11:35:00',2.69),('15128','2013-01-30','11:40:00',2.65),('15128','2013-01-30','11:45:00',2.64),('15128','2013-01-30','11:50:00',2.7),('15128','2013-01-30','11:55:00',2.76),('15128','2013-01-30','12:00:00',2.78),('15128','2013-01-30','12:05:00',2.74),('15128','2013-01-30','12:10:00',2.81),('15128','2013-01-30','12:15:00',2.85),('15128','2013-01-30','12:20:00',2.83),('15128','2013-01-30','12:25:00',2.92),('15128','2013-01-30','12:30:00',2.92),('15128','2013-01-30','12:35:00',2.93),('15128','2013-01-30','12:40:00',2.9),('15128','2013-01-30','12:45:00',2.89),('15128','2013-01-30','12:50:00',2.82),('15128','2013-01-30','12:55:00',2.85),('15128','2013-01-30','13:00:00',2.85),('15128','2013-01-30','13:05:00',2.84),('15128','2013-01-30','13:10:00',2.83),('15128','2013-01-30','13:15:00',2.83),('15128','2013-01-30','13:20:00',2.79),('15128','2013-01-30','13:25:00',2.79),('15128','2013-01-30','13:30:00',2.76),('15128','2013-01-30','13:35:00',2.75),('15128','2013-01-30','13:40:00',2.77),('15128','2013-01-30','13:45:00',2.73),('15128','2013-01-30','13:50:00',2.72),('15128','2013-01-30','13:55:00',2.71),('15128','2013-01-30','14:00:00',2.67),('15128','2013-01-30','14:05:00',2.62),('15128','2013-01-30','14:10:00',2.55),('15128','2013-01-30','14:15:00',2.5),('15128','2013-01-30','14:20:00',2.35),('15128','2013-01-30','14:25:00',2.37),('15128','2013-01-30','14:30:00',2.31),('15128','2013-01-30','14:35:00',2.26),('15128','2013-01-30','14:40:00',2.28),('15128','2013-01-30','14:45:00',2.43),('15128','2013-01-30','14:50:00',2.17),('15128','2013-01-30','14:55:00',2.05),('15128','2013-01-30','15:00:00',2.1),('15128','2013-01-30','15:05:00',2.04),('15128','2013-01-30','15:10:00',2.01),('15128','2013-01-30','15:15:00',1.98),('15128','2013-01-30','15:20:00',1.88),('15128','2013-01-30','15:25:00',1.76),('15128','2013-01-30','15:30:00',1.73),('15128','2013-01-30','15:35:00',1.73),('15128','2013-01-30','15:40:00',1.65),('15128','2013-01-30','15:45:00',1.45),('15128','2013-01-30','15:50:00',1.48),('15128','2013-01-30','15:55:00',1.3),('15128','2013-01-30','16:00:00',1.06),('15128','2013-01-30','16:10:00',1.04),('15128','2013-01-29','09:35:00',1.12),('15128','2013-01-29','09:40:00',1.52),('15128','2013-01-29','09:45:00',1.3),('15128','2013-01-29','09:55:00',1.17),('15128','2013-01-29','10:00:00',1.23),('15128','2013-01-29','10:05:00',1.19),('15128','2013-01-29','10:10:00',1.36),('15128','2013-01-29','10:15:00',1.3),('15128','2013-01-29','10:20:00',1.12),('15128','2013-01-29','10:25:00',1.37),('15128','2013-01-29','10:30:00',1.56),('15128','2013-01-29','10:35:00',1.58),('15128','2013-01-29','10:40:00',1.37),('15128','2013-01-29','10:45:00',1.44),('15128','2013-01-29','10:50:00',1.73),('15128','2013-01-29','10:55:00',1.95),('15128','2013-01-29','11:00:00',1.92),('15128','2013-01-29','11:05:00',1.7),('15128','2013-01-29','11:10:00',2.1),('15128','2013-01-29','11:15:00',2.12),('15128','2013-01-29','11:20:00',2.2),('15128','2013-01-29','11:25:00',2.19),('15128','2013-01-29','11:30:00',1.81),('15128','2013-01-29','11:35:00',2.02),('15128','2013-01-29','11:40:00',2.35),('15128','2013-01-29','11:45:00',1.59),('15128','2013-01-29','11:50:00',1.24),('15128','2013-01-29','11:55:00',1.37),('15128','2013-01-29','12:00:00',2.23),('15128','2013-01-29','12:05:00',3.33),('15128','2013-01-29','12:10:00',3.19),('15128','2013-01-29','12:15:00',2.99),('15128','2013-01-29','12:20:00',2.89),('15128','2013-01-29','12:25:00',3.02),('15128','2013-01-29','12:30:00',3.13),('15128','2013-01-29','12:35:00',2.38),('15128','2013-01-29','12:40:00',1.87),('15128','2013-01-29','12:45:00',3.45),('15128','2013-01-29','12:50:00',1.76),('15128','2013-01-29','13:00:00',1.71),('15128','2013-01-29','13:05:00',1.88),('15128','2013-01-29','13:10:00',1.35),('15128','2013-01-29','13:20:00',1.59),('15128','2013-01-29','13:25:00',1.27),('15128','2013-01-29','13:30:00',1.56),('15128','2013-01-29','13:40:00',1.32),('15128','2013-01-29','14:00:00',1.58),('15128','2013-01-29','14:05:00',2.66),('15128','2013-01-29','14:10:00',2.23),('15128','2013-01-29','14:15:00',1.73),('15128','2013-01-29','14:20:00',1.93),('15128','2013-01-29','14:25:00',2.39),('15128','2013-01-29','14:30:00',2.14),('15128','2013-01-29','14:35:00',2.42),('15128','2013-01-29','14:40:00',2.31),('15128','2013-01-29','14:45:00',1.8),('15128','2013-01-28','09:40:00',1.07),('15128','2013-01-28','09:45:00',1.11),('15128','2013-01-28','09:50:00',1.22),('15128','2013-01-28','09:55:00',1.31),('15128','2013-01-28','10:00:00',1.33),('15128','2013-01-28','10:05:00',1.4),('15128','2013-01-28','10:10:00',1.47),('15128','2013-01-28','10:15:00',1.51),('15128','2013-01-28','10:20:00',1.59),('15128','2013-01-28','10:25:00',1.64),('15128','2013-01-28','10:30:00',1.72),('15128','2013-01-28','10:35:00',1.79),('15128','2013-01-28','10:40:00',1.82),('15128','2013-01-28','10:45:00',1.85),('15128','2013-01-28','10:50:00',1.88),('15128','2013-01-28','10:55:00',1.94),('15128','2013-01-28','11:00:00',1.99),('15128','2013-01-28','11:05:00',2.05),('15128','2013-01-28','11:10:00',2.08),('15128','2013-01-28','11:15:00',2.12),('15128','2013-01-28','11:20:00',2.2),('15128','2013-01-28','11:25:00',2.29),('15128','2013-01-28','11:30:00',2.38),('15128','2013-01-28','11:35:00',2.48),('15128','2013-01-28','11:40:00',2.53),('15128','2013-01-28','11:45:00',2.57),('15128','2013-01-28','11:50:00',2.62),('15128','2013-01-28','11:55:00',2.66),('15128','2013-01-28','12:00:00',2.73),('15128','2013-01-28','12:05:00',2.79),('15128','2013-01-28','12:10:00',2.82),('15128','2013-01-28','12:15:00',2.78),('15128','2013-01-28','12:20:00',2.81),('15128','2013-01-28','12:25:00',2.89),('15128','2013-01-28','12:30:00',2.92),('15128','2013-01-28','12:35:00',2.92),('15128','2013-01-28','12:40:00',2.89),('15128','2013-01-28','12:45:00',2.84),('15128','2013-01-28','12:50:00',2.88),('15128','2013-01-28','12:55:00',2.91),('15128','2013-01-28','13:00:00',2.86),('15128','2013-01-28','13:05:00',2.88),('15128','2013-01-28','13:10:00',2.87),('15128','2013-01-28','13:15:00',2.89),('15128','2013-01-28','13:20:00',2.87),('15128','2013-01-28','13:25:00',2.86),('15128','2013-01-28','13:30:00',2.85),('15128','2013-01-28','13:35:00',2.82),('15128','2013-01-28','13:40:00',2.77),('15128','2013-01-28','13:45:00',2.76),('15128','2013-01-28','13:50:00',2.72),('15128','2013-01-28','13:55:00',2.74),('15128','2013-01-28','14:00:00',2.74),('15128','2013-01-28','14:05:00',2.73),('15128','2013-01-28','14:10:00',2.67),('15128','2013-01-28','14:15:00',2.62),('15128','2013-01-28','14:20:00',2.56),('15128','2013-01-28','14:25:00',2.52),('15128','2013-01-28','14:30:00',2.49),('15128','2013-01-28','14:35:00',2.46),('15128','2013-01-28','14:40:00',2.4),('15128','2013-01-28','14:45:00',2.34),('15128','2013-01-28','14:50:00',2.3),('15128','2013-01-28','14:55:00',2.24),('15128','2013-01-28','15:00:00',2.16),('15128','2013-01-28','15:05:00',2.09),('15128','2013-01-28','15:10:00',2.04),('15128','2013-01-28','15:15:00',1.96),('15128','2013-01-28','15:20:00',1.88),('15128','2013-01-28','15:25:00',1.89),('15128','2013-01-28','15:30:00',1.82),('15128','2013-01-28','15:35:00',1.78),('15128','2013-01-28','15:40:00',1.7),('15128','2013-01-28','15:45:00',1.61),('15128','2013-01-28','15:50:00',1.51),('15128','2013-01-28','15:55:00',1.42),('15128','2013-01-28','16:00:00',1.32),('15128','2013-01-28','16:05:00',1.19),('15128','2013-01-28','16:10:00',1.09),('15128','2013-01-27','12:40:00',1.18),('15128','2013-01-27','12:45:00',1.29),('15128','2013-01-27','12:50:00',1.31),('15128','2013-01-27','12:55:00',1.27),('15128','2013-01-27','13:00:00',1.35),('15128','2013-01-27','13:05:00',1.35),('15128','2013-01-27','13:10:00',1.13),('15128','2013-01-27','13:35:00',1.02),('15128','2013-01-26','09:35:00',1.01),('15128','2013-01-26','09:40:00',1.04),('15128','2013-01-26','09:45:00',1.11),('15128','2013-01-26','09:50:00',1.16),('15128','2013-01-26','09:55:00',1.25),('15128','2013-01-26','10:00:00',1.33),('15128','2013-01-26','10:05:00',1.43),('15128','2013-01-26','10:10:00',1.48),('15128','2013-01-26','10:15:00',1.52),('15128','2013-01-26','10:20:00',1.55),('15128','2013-01-26','10:25:00',1.66),('15128','2013-01-26','10:30:00',1.71),('15128','2013-01-26','10:35:00',1.75),('15128','2013-01-26','10:40:00',1.8),('15128','2013-01-26','10:45:00',1.85),('15128','2013-01-26','10:50:00',1.89),('15128','2013-01-26','10:55:00',1.97),('15128','2013-01-26','11:00:00',2.02),('15128','2013-01-26','11:05:00',2.04),('15128','2013-01-26','11:10:00',2.07),('15128','2013-01-26','11:15:00',2.14),('15128','2013-01-26','11:20:00',2.23),('15128','2013-01-26','11:25:00',2.29),('15128','2013-01-26','11:30:00',2.42),('15128','2013-01-26','11:35:00',2.47),('15128','2013-01-26','11:40:00',2.47),('15128','2013-01-26','11:45:00',2.53),('15128','2013-01-26','11:50:00',2.59),('15128','2013-01-26','11:55:00',2.53),('15128','2013-01-26','12:00:00',2.67),('15128','2013-01-26','12:05:00',2.73),('15128','2013-01-26','12:10:00',2.76),('15128','2013-01-26','12:15:00',2.72),('15128','2013-01-26','12:20:00',2.77),('15128','2013-01-26','12:25:00',2.77),('15128','2013-01-26','12:30:00',2.81),('15128','2013-01-26','12:35:00',2.82),('15128','2013-01-26','12:40:00',2.83),('15128','2013-01-26','12:45:00',2.79),('15128','2013-01-26','12:50:00',2.75),('15128','2013-01-26','12:55:00',2.8),('15128','2013-01-26','13:00:00',2.8),('15128','2013-01-26','13:05:00',2.85),('15128','2013-01-26','13:10:00',2.89),('15128','2013-01-26','13:15:00',2.87),('15128','2013-01-26','13:20:00',2.86),('15128','2013-01-26','13:25:00',2.87),('15128','2013-01-26','13:30:00',2.84),('15128','2013-01-26','13:35:00',2.8),('15128','2013-01-26','13:40:00',2.78),('15128','2013-01-26','13:45:00',2.74),('15128','2013-01-26','13:50:00',2.73),('15128','2013-01-26','13:55:00',2.7),('15128','2013-01-26','14:00:00',2.65),('15128','2013-01-26','14:05:00',2.62),('15128','2013-01-26','14:10:00',2.57),('15128','2013-01-26','14:15:00',2.51),('15128','2013-01-26','14:20:00',2.48),('15128','2013-01-26','14:25:00',2.44),('15128','2013-01-26','14:30:00',2.41),('15128','2013-01-26','14:35:00',2.36),('15128','2013-01-26','14:40:00',2.3),('15128','2013-01-26','14:45:00',2.29),('15128','2013-01-26','14:50:00',2.21),('15128','2013-01-26','14:55:00',2.21),('15128','2013-01-26','15:00:00',2.12),('15128','2013-01-26','15:05:00',2.09),('15128','2013-01-26','15:10:00',2.04),('15128','2013-01-26','15:15:00',2),('15128','2013-01-26','15:20:00',1.92),('15128','2013-01-26','15:35:00',1.63),('15128','2013-01-26','15:40:00',1.53),('15128','2013-01-26','15:45:00',1.44),('15128','2013-01-26','15:50:00',1.33),('15128','2013-01-26','15:55:00',1.23),('15128','2013-01-26','16:00:00',1.09),('15128','2013-01-25','09:40:00',1.06),('15128','2013-01-25','10:35:00',1.23),('15128','2013-01-25','11:05:00',1.02),('15128','2013-01-25','11:10:00',1.03),('15128','2013-01-25','11:15:00',1.11),('15128','2013-01-25','11:20:00',1.13),('15128','2013-01-25','11:25:00',1.06),('15128','2013-01-25','11:30:00',1.09),('15128','2013-01-25','11:35:00',1.17),('15128','2013-01-25','11:40:00',1.19),('15128','2013-01-25','12:25:00',1.03),('15128','2013-01-25','12:30:00',1.13),('15128','2013-01-24','09:40:00',1.01),('15128','2013-01-24','09:50:00',1.05),('15128','2013-01-24','09:55:00',1.3),('15128','2013-01-24','10:00:00',1.45),('15128','2013-01-24','10:05:00',1.53),('15128','2013-01-24','10:10:00',1.68),('15128','2013-01-24','10:15:00',1.76),('15128','2013-01-24','10:20:00',1.8),('15128','2013-01-24','10:25:00',1.87),('15128','2013-01-24','10:30:00',1.89),('15128','2013-01-24','10:35:00',1.88),('15128','2013-01-24','10:40:00',1.92),('15128','2013-01-24','10:45:00',2),('15128','2013-01-24','10:50:00',2.04),('15128','2013-01-24','10:55:00',2.11),('15128','2013-01-24','11:00:00',2.1),('15128','2013-01-24','11:05:00',2.05),('15128','2013-01-24','11:10:00',2.09),('15128','2013-01-24','11:15:00',2.18),('15128','2013-01-24','11:20:00',2.24),('15128','2013-01-24','11:25:00',2.3),('15128','2013-01-24','11:30:00',2.38),('15128','2013-01-24','11:35:00',2.52),('15128','2013-01-24','11:40:00',2.63),('15128','2013-01-24','11:45:00',2.68),('15128','2013-01-24','11:50:00',2.73),('15128','2013-01-24','11:55:00',2.78),('15128','2013-01-24','12:00:00',2.8),('15128','2013-01-24','12:05:00',2.79),('15128','2013-01-24','12:10:00',2.8),('15128','2013-01-24','12:15:00',2.81),('15128','2013-01-24','12:20:00',2.82),('15128','2013-01-24','12:25:00',2.87),('15128','2013-01-24','12:30:00',2.71),('15128','2013-01-24','12:35:00',2.41),('15128','2013-01-24','12:40:00',2.7),('15128','2013-01-24','12:45:00',3.05),('15128','2013-01-24','12:50:00',3.01),('15128','2013-01-24','12:55:00',2.97),('15128','2013-01-24','13:00:00',2.92),('15128','2013-01-24','13:05:00',2.92),('15128','2013-01-24','13:10:00',2.92),('15128','2013-01-24','13:15:00',2.9),('15128','2013-01-24','13:20:00',2.9),('15128','2013-01-24','13:25:00',2.88),('15128','2013-01-24','13:30:00',2.82),('15128','2013-01-24','13:35:00',2.77),('15128','2013-01-24','13:40:00',2.8),('15128','2013-01-24','13:45:00',2.8),('15128','2013-01-24','13:50:00',2.76),('15128','2013-01-24','13:55:00',2.59),('15128','2013-01-24','14:00:00',2.32),('15128','2013-01-24','14:05:00',2.37),('15128','2013-01-24','14:10:00',2.34),('15128','2013-01-24','14:15:00',2.34),('15128','2013-01-24','14:20:00',2.34),('15128','2013-01-24','14:25:00',2.26),('15128','2013-01-24','14:30:00',2.21),('15128','2013-01-24','14:35:00',2.16),('15128','2013-01-24','14:40:00',2.11),('15128','2013-01-24','14:45:00',2.02),('15128','2013-01-24','14:50:00',2),('15128','2013-01-24','14:55:00',1.97),('15128','2013-01-24','15:00:00',1.81),('15128','2013-01-24','15:05:00',1.58),('15128','2013-01-24','15:10:00',1.42),('15128','2013-01-24','15:15:00',1.4),('15128','2013-01-24','15:20:00',1.47),('15128','2013-01-24','15:25:00',1.65),('15128','2013-01-24','15:30:00',1.68),('15128','2013-01-24','15:35:00',1.69),('15128','2013-01-24','15:40:00',1.58),('15128','2013-01-24','15:45:00',1.46),('15128','2013-01-24','15:50:00',1.34),('15128','2013-01-24','15:55:00',1.02),('15128','2013-01-23','09:35:00',1.17),('15128','2013-01-23','09:40:00',1.19),('15128','2013-01-23','09:45:00',1.05),('15128','2013-01-23','09:50:00',1.18),('15128','2013-01-23','09:55:00',1.32),('15128','2013-01-23','10:00:00',1.29),('15128','2013-01-23','10:05:00',1.21),('15128','2013-01-23','10:10:00',1.68),('15128','2013-01-23','10:15:00',1.72),('15128','2013-01-23','10:20:00',1.68),('15128','2013-01-23','10:25:00',1.66),('15128','2013-01-23','10:30:00',1.78),('15128','2013-01-23','10:35:00',1.79),('15128','2013-01-23','10:40:00',1.84),('15128','2013-01-23','10:45:00',1.91),('15128','2013-01-23','10:50:00',1.95),('15128','2013-01-23','10:55:00',1.77),('15128','2013-01-23','12:35:00',1.12),('15128','2013-01-23','12:40:00',1.17),('15128','2013-01-23','12:45:00',1.17),('15128','2013-01-23','12:50:00',1.08),('15128','2013-01-23','12:55:00',1.01),('15128','2013-01-23','13:50:00',1.07),('15128','2013-01-23','13:55:00',1.15),('15128','2013-01-23','14:00:00',1.18),('15128','2013-01-23','14:05:00',1.23),('15128','2013-01-23','14:10:00',1.26),('15128','2013-01-23','14:20:00',1.28),('15128','2013-01-23','14:25:00',3.07),('15128','2013-01-23','14:30:00',3.07),('15128','2013-01-23','14:35:00',2.17),('15128','2013-01-23','14:40:00',1.97),('15128','2013-01-23','14:45:00',2.5),('15128','2013-01-23','14:50:00',2.18),('15128','2013-01-23','14:55:00',1.46),('15128','2013-01-23','15:00:00',1.8),('15128','2013-01-23','15:05:00',2.13),('15128','2013-01-23','15:10:00',1.66),('15128','2013-01-23','15:15:00',1.35),('15128','2013-01-23','15:35:00',1.32),('15128','2013-01-23','15:40:00',1.68),('15128','2013-01-23','15:45:00',1.41),('15128','2013-01-23','15:50:00',1.42),('15128','2013-01-23','15:55:00',1.08),('15128','2013-01-22','09:15:00',1.13),('15128','2013-01-22','09:20:00',1.13),('15128','2013-01-22','09:40:00',1.2),('15128','2013-01-22','09:45:00',1.58),('15128','2013-01-22','09:50:00',1.86),('15128','2013-01-22','09:55:00',1.62),('15128','2013-01-22','10:00:00',1.14),('15128','2013-01-22','10:05:00',2.02),('15128','2013-01-22','10:10:00',1.97),('15128','2013-01-22','10:15:00',2.04),('15128','2013-01-22','10:20:00',2.28),('15128','2013-01-22','10:25:00',1.45),('15128','2013-01-22','10:30:00',1.4),('15128','2013-01-21','09:30:00',1.26),('15128','2013-01-21','09:35:00',1.21),('15128','2013-01-21','09:40:00',1),('15128','2013-01-21','09:50:00',1.24),('15128','2013-01-21','09:55:00',1.27),('15128','2013-01-21','10:00:00',1.29),('15128','2013-01-21','10:05:00',1.4),('15128','2013-01-21','10:10:00',1.61),('15128','2013-01-21','10:15:00',1.88),('15128','2013-01-21','10:20:00',1.05),('15128','2013-01-21','10:25:00',1.76),('15128','2013-01-21','10:30:00',1.18),('15128','2013-01-21','10:35:00',1.41),('15128','2013-01-21','10:40:00',1.03),('15128','2013-01-21','10:45:00',1.18),('15128','2013-01-21','10:50:00',1.05),('15128','2013-01-21','11:00:00',2.12),('15128','2013-01-21','11:10:00',1.61),('15128','2013-01-21','11:15:00',2.81),('15128','2013-01-21','11:20:00',2.63),('15128','2013-01-21','11:55:00',2),('15128','2013-01-21','12:00:00',1.29),('15128','2013-01-21','12:05:00',1.36),('15128','2013-01-21','12:10:00',1.48),('15128','2013-01-21','12:15:00',2.42),('15128','2013-01-21','12:20:00',2.22),('15128','2013-01-21','12:25:00',1.05),('15128','2013-01-21','12:30:00',3.08),('15128','2013-01-21','12:35:00',2.18),('15128','2013-01-21','12:40:00',2.31),('15128','2013-01-21','12:45:00',1.44),('15128','2013-01-21','12:50:00',1.13),('15128','2013-01-21','13:00:00',2.26),('15128','2013-01-21','13:05:00',2.46),('15128','2013-01-21','13:10:00',1.56),('15128','2013-01-21','13:15:00',2.02),('15128','2013-01-21','13:20:00',1.01),('15128','2013-01-21','13:25:00',2.22),('15128','2013-01-21','13:35:00',1.6),('15128','2013-01-21','13:45:00',1.21),('15128','2013-01-21','13:55:00',2.06),('15128','2013-01-21','14:00:00',2.09),('15128','2013-01-21','14:05:00',2.13),('15128','2013-01-21','14:10:00',2.72),('15128','2013-01-21','14:15:00',1.61),('15128','2013-01-21','14:20:00',1.55),('15128','2013-01-21','14:25:00',2.62),('15128','2013-01-21','14:30:00',2.09),('15128','2013-01-21','14:35:00',1.8),('15128','2013-01-21','14:40:00',2.48),('15128','2013-01-21','14:45:00',2.19),('15128','2013-01-21','14:55:00',2.18),('15128','2014-03-19','08:25:00',1.05),('15128','2014-03-19','08:30:00',1.13),('15128','2014-03-19','08:35:00',1.22),('15128','2014-03-19','08:40:00',1.29),('15128','2014-03-19','08:45:00',1.36),('15128','2014-03-19','08:50:00',1.41),('15128','2014-03-19','08:55:00',1.48),('15128','2014-03-19','09:00:00',1.49),('15128','2014-03-19','09:05:00',1.55),('15128','2014-03-19','09:10:00',1.67),('15128','2014-03-19','09:15:00',1.69),('15128','2014-03-19','09:20:00',1.76),('15128','2014-03-19','09:25:00',1.86),('15128','2014-03-19','09:30:00',1.9),('15128','2014-03-19','09:35:00',1.97),('15128','2014-03-19','09:40:00',1.95),('15128','2014-03-19','09:45:00',2.04),('15128','2014-03-19','09:50:00',2.06),('15128','2014-03-19','09:55:00',2.11),('15128','2014-03-19','10:00:00',2.25),('15128','2014-03-19','10:05:00',2.25),('15128','2014-03-19','10:10:00',2.38),('15128','2014-03-19','10:15:00',2.4),('15128','2014-03-19','10:20:00',2.48),('15128','2014-03-19','10:25:00',2.55),('15128','2014-03-19','10:30:00',2.61),('15128','2014-03-19','10:35:00',2.57),('15128','2014-03-19','10:40:00',2.59),('15128','2014-03-19','10:45:00',2.59),('15128','2014-03-19','10:50:00',2.77),('15128','2014-03-19','10:55:00',2.86),('15128','2014-03-19','11:00:00',2.91),('15128','2014-03-19','11:05:00',2.95),('15128','2014-03-19','11:10:00',3.08),('15128','2014-03-19','11:15:00',2.95),('15128','2014-03-19','11:20:00',3.07),('15128','2014-03-19','11:25:00',3.09),('15128','2014-03-19','11:30:00',3.09),('15128','2014-03-19','11:35:00',3.24),('15128','2014-03-19','11:40:00',3.27),('15128','2014-03-19','11:45:00',3.09),('15128','2014-03-19','11:50:00',3.26),('15128','2014-03-19','11:55:00',3.25),('15128','2014-03-19','12:00:00',3.24),('15128','2014-03-19','12:05:00',3.03),('15128','2014-03-19','12:10:00',3.2),('15128','2014-03-19','12:15:00',3.48),('15128','2014-03-19','12:20:00',3.58),('15128','2014-03-19','12:25:00',3.47),('15128','2014-03-19','12:30:00',3.33),('15128','2014-03-19','12:35:00',3.5),('15128','2014-03-19','12:40:00',3.61),('15128','2014-03-19','12:45:00',3.7),('15128','2014-03-19','12:50:00',3.71),('15128','2014-03-19','12:55:00',3.72),('15128','2014-03-19','13:00:00',3.69),('15128','2014-03-19','13:05:00',3.59),('15128','2014-03-19','13:10:00',3.53),('15128','2014-03-19','13:15:00',3.53),('15128','2014-03-19','13:20:00',3.54),('15128','2014-03-19','13:25:00',3.55),('15128','2014-03-19','13:30:00',3.51),('15128','2014-03-19','13:35:00',3.39),('15128','2014-03-19','13:40:00',3.22),('15128','2014-03-19','13:45:00',3.21),('15128','2014-03-19','13:50:00',3.11),('15128','2014-03-19','13:55:00',3.09),('15128','2014-03-19','14:00:00',2.98),('15128','2014-03-19','14:05:00',2.99),('15128','2014-03-19','14:10:00',3.09),('15128','2014-03-19','14:15:00',2.8),('15128','2014-03-19','14:20:00',2.71),('15128','2014-03-19','14:25:00',2.33),('15128','2014-03-19','14:30:00',2.41),('15128','2014-03-19','14:35:00',2.65),('15128','2014-03-19','14:40:00',2.57),('15128','2014-03-19','14:45:00',2.67),('15128','2014-03-19','14:50:00',2.67),('15128','2014-03-19','14:55:00',2.62),('15128','2014-03-19','15:00:00',2.57),('15128','2014-03-19','15:05:00',2.57),('15128','2014-03-19','15:10:00',2.42),('15128','2014-03-19','15:15:00',2.46),('15128','2014-03-19','15:20:00',2.44),('15128','2014-03-19','15:25:00',2.36),('15128','2014-03-19','15:30:00',2.1),('15128','2014-03-19','15:35:00',1.89),('15128','2014-03-19','15:40:00',1.76),('15128','2014-03-19','15:45:00',1.6),('15128','2014-03-19','15:50:00',1.4),('15128','2014-03-19','15:55:00',1.24),('15128','2014-03-19','16:00:00',1.21),('15128','2014-03-19','16:05:00',1.29),('15128','2014-03-19','16:10:00',1.23),('15128','2014-03-19','16:15:00',1.08),('15128','2014-03-19','16:20:00',1.02),('15128','2014-03-19','16:25:00',1.05),('15128','2014-03-19','16:40:00',1.02),('15128','2013-01-20','10:45:00',1.06),('15128','2013-01-20','10:50:00',1.01),('15128','2013-01-20','11:10:00',1.11),('15128','2013-01-20','11:15:00',1.07),('15128','2013-01-20','11:20:00',1.13),('15128','2013-01-20','11:35:00',1.05),('15128','2013-01-20','11:50:00',1.96),('15128','2013-01-20','11:55:00',2.6),('15128','2013-01-20','12:00:00',2.6),('15128','2013-01-20','12:05:00',2.01),('15128','2013-01-20','12:10:00',1.87),('15128','2013-01-20','12:15:00',1.42),('15128','2013-01-20','12:20:00',2.45),('15128','2013-01-20','12:25:00',1.81),('15128','2013-01-20','12:35:00',2.13),('15128','2013-01-20','13:10:00',1),('15128','2013-01-20','13:20:00',1.44),('15128','2013-01-20','13:25:00',3.66),('15128','2013-01-20','13:30:00',3.55),('15128','2013-01-20','13:35:00',2.84),('15128','2013-01-20','13:40:00',2.18),('15128','2013-01-20','13:45:00',1.04),('15128','2013-01-20','13:55:00',3.29),('15128','2013-01-20','14:00:00',2.43),('15128','2013-01-20','14:05:00',2.16),('15128','2013-01-20','14:10:00',2),('15128','2013-01-20','14:15:00',1.78),('15128','2013-01-20','14:20:00',2.46),('15128','2013-01-20','15:30:00',1.81),('15128','2013-01-19','11:00:00',1.01),('15128','2013-01-19','11:05:00',1.08),('15128','2013-01-19','11:10:00',1.49),('15128','2013-01-19','11:15:00',1.67),('15128','2013-01-19','11:20:00',1.26),('15128','2013-01-19','11:25:00',1.36),('15128','2013-01-19','11:30:00',1.65),('15128','2013-01-19','11:35:00',1.17),('15128','2013-01-19','11:40:00',1.02),('15128','2013-01-18','09:50:00',1.25),('15128','2013-01-18','09:55:00',1.4),('15128','2013-01-18','10:00:00',1.13),('15128','2013-01-18','10:40:00',1.02),('15128','2013-01-18','10:45:00',1.23),('15128','2013-01-18','11:15:00',1.12),('15128','2013-01-18','11:20:00',1.23),('15128','2013-01-18','11:25:00',1.08),('15128','2013-01-17','10:10:00',1.64),('15128','2013-01-17','10:15:00',2.06),('15128','2013-01-17','10:20:00',1.2),('15128','2013-01-17','10:25:00',1.14),('15128','2013-01-17','11:20:00',1.05),('15128','2013-01-17','11:25:00',1.27),('15128','2013-01-17','11:30:00',1.37),('15128','2013-01-17','11:35:00',1.14),('15128','2013-01-17','11:50:00',1.04),('15128','2013-01-17','11:55:00',1.02),('15128','2013-01-17','12:00:00',1.09),('15128','2013-01-17','12:05:00',1.25),('15128','2013-01-17','12:10:00',1.33),('15128','2013-01-17','12:15:00',1.43),('15128','2013-01-17','12:20:00',1.33),('15128','2013-01-17','12:25:00',1.27),('15128','2013-01-17','12:30:00',1.42),('15128','2013-01-17','12:35:00',1.42),('15128','2013-01-17','12:40:00',1.44),('15128','2013-01-17','12:45:00',1.71),('15128','2013-01-17','12:50:00',1.99),('15128','2013-01-17','12:55:00',2.63),('15128','2013-01-17','13:00:00',1.8),('15128','2013-01-17','13:05:00',2),('15128','2013-01-17','13:10:00',2.42),('15128','2013-01-17','13:15:00',2.31),('15128','2013-01-17','13:20:00',2.01),('15128','2013-01-17','13:25:00',1.97),('15128','2013-01-17','13:30:00',1.81),('15128','2013-01-17','13:35:00',1.85),('15128','2013-01-17','13:40:00',3.16),('15128','2013-01-17','13:45:00',3.14),('15128','2013-01-17','13:50:00',3.1),('15128','2013-01-17','13:55:00',3.1),('15128','2013-01-17','14:00:00',1.85),('15128','2013-01-17','14:05:00',2.35),('15128','2013-01-17','14:10:00',3.34),('15128','2013-01-17','14:15:00',3.18),('15128','2013-01-17','14:20:00',1.76);
INSERT INTO `solarlog` VALUES ('15128','2013-01-17','14:25:00',1.63),('15128','2013-01-17','14:30:00',1.1),('15128','2013-01-17','14:45:00',1.18),('15128','2013-01-17','14:50:00',1.68),('15128','2013-01-17','14:55:00',1.35),('15128','2013-01-17','15:00:00',1.27),('15128','2013-01-17','15:05:00',1.07),('15128','2013-01-17','15:40:00',1.01),('15128','2013-01-17','15:45:00',1.24),('15128','2013-01-17','15:50:00',1.24),('15128','2013-01-17','15:55:00',1.13),('15128','2013-01-16','09:45:00',1.23),('15128','2013-01-16','09:50:00',1.35),('15128','2013-01-16','09:55:00',1.27),('15128','2013-01-16','10:00:00',1.12),('15128','2013-01-16','10:05:00',1.14),('15128','2013-01-16','10:10:00',1.29),('15128','2013-01-16','10:15:00',1.35),('15128','2013-01-16','10:20:00',1.43),('15128','2013-01-16','10:25:00',1.49),('15128','2013-01-16','10:30:00',1.63),('15128','2013-01-16','10:35:00',1.65),('15128','2013-01-16','10:40:00',1.56),('15128','2013-01-16','10:45:00',1.35),('15128','2013-01-16','10:50:00',1.35),('15128','2013-01-16','10:55:00',1.34),('15128','2013-01-16','11:00:00',1.27),('15128','2013-01-16','11:05:00',1.35),('15128','2013-01-16','11:10:00',1.71),('15128','2013-01-16','11:15:00',1.61),('15128','2013-01-16','11:20:00',1.32),('15128','2013-01-16','11:25:00',1.32),('15128','2013-01-16','11:30:00',1.21),('15128','2013-01-16','11:35:00',1.5),('15128','2013-01-16','11:40:00',1.61),('15128','2013-01-16','11:45:00',1.61),('15128','2013-01-16','11:50:00',1.55),('15128','2013-01-16','11:55:00',1.44),('15128','2013-01-16','12:00:00',1.58),('15128','2013-01-16','12:05:00',1.67),('15128','2013-01-16','12:10:00',1.65),('15128','2013-01-16','12:15:00',1.73),('15128','2013-01-16','12:20:00',1.9),('15128','2013-01-16','12:25:00',1.72),('15128','2013-01-16','12:30:00',2.05),('15128','2013-01-16','12:35:00',2.06),('15128','2013-01-16','12:40:00',1.99),('15128','2013-01-16','12:45:00',2.01),('15128','2013-01-16','12:50:00',1.76),('15128','2013-01-16','12:55:00',1.69),('15128','2013-01-16','13:00:00',1.72),('15128','2013-01-16','13:05:00',1.51),('15128','2013-01-16','13:10:00',1.64),('15128','2013-01-16','13:15:00',1.55),('15128','2013-01-16','13:20:00',1.56),('15128','2013-01-16','13:25:00',1.59),('15128','2013-01-16','13:30:00',2.04),('15128','2013-01-16','13:35:00',2.11),('15128','2013-01-16','13:40:00',2.46),('15128','2013-01-16','13:45:00',2.8),('15128','2013-01-16','13:50:00',1.95),('15128','2013-01-16','13:55:00',1.28),('15128','2013-01-16','14:10:00',1.08),('15128','2013-01-15','13:10:00',2.53),('15128','2013-01-15','13:15:00',2.07),('15128','2014-03-18','09:05:00',1.12),('15128','2014-03-18','09:10:00',1.25),('15128','2014-03-18','09:15:00',1.43),('15128','2014-03-18','09:20:00',1.39),('15128','2014-03-18','09:25:00',1.66),('15128','2014-03-18','09:30:00',1.77),('15128','2014-03-18','09:35:00',1.96),('15128','2014-03-18','09:40:00',1.87),('15128','2014-03-18','09:45:00',1.83),('15128','2014-03-18','09:50:00',1.81),('15128','2014-03-18','09:55:00',2.37),('15128','2014-03-18','10:00:00',1.33),('15128','2014-03-18','10:05:00',1.1),('15128','2014-03-18','10:10:00',1.23),('15128','2014-03-18','10:15:00',1.34),('15128','2014-03-18','10:20:00',1.28),('15128','2014-03-18','10:25:00',1.3),('15128','2014-03-18','10:30:00',1.42),('15128','2014-03-18','10:35:00',1.5),('15128','2014-03-18','10:40:00',3.11),('15128','2014-03-18','10:45:00',2.59),('15128','2014-03-18','10:50:00',1.53),('15128','2014-03-18','10:55:00',1.67),('15128','2014-03-18','11:00:00',1.64),('15128','2014-03-18','11:05:00',1.71),('15128','2014-03-18','11:10:00',1.61),('15128','2014-03-18','11:15:00',1.77),('15128','2014-03-18','11:20:00',1.99),('15128','2014-03-18','11:25:00',1.52),('15128','2014-03-18','11:30:00',2.5),('15128','2014-03-18','11:35:00',3.98),('15128','2014-03-18','11:40:00',3.82),('15128','2014-03-18','11:45:00',3.02),('15128','2014-03-18','11:50:00',1.55),('15128','2014-03-18','11:55:00',3.08),('15128','2014-03-18','12:00:00',1.77),('15128','2014-03-18','12:05:00',2.97),('15128','2014-03-18','12:10:00',4),('15128','2014-03-18','12:15:00',3.99),('15128','2014-03-18','12:20:00',3.7),('15128','2014-03-18','12:25:00',2.88),('15128','2014-03-18','12:30:00',3.76),('15128','2014-03-18','12:35:00',3.93),('15128','2014-03-18','12:40:00',3.79),('15128','2014-03-18','12:45:00',3.77),('15128','2014-03-18','12:50:00',3.66),('15128','2014-03-18','12:55:00',3.58),('15128','2014-03-18','13:00:00',3.65),('15128','2014-03-18','13:05:00',3.6),('15128','2014-03-18','13:10:00',3.49),('15128','2014-03-18','13:15:00',3.29),('15128','2014-03-18','13:20:00',2.94),('15128','2014-03-18','13:25:00',3.55),('15128','2014-03-18','13:30:00',3.55),('15128','2014-03-18','13:35:00',3.53),('15128','2014-03-18','13:40:00',3.55),('15128','2014-03-18','13:45:00',3.53),('15128','2014-03-18','13:50:00',3.46),('15128','2014-03-18','13:55:00',3.46),('15128','2014-03-18','14:00:00',3.45),('15128','2014-03-18','14:05:00',3.41),('15128','2014-03-18','14:10:00',3.34),('15128','2014-03-18','14:15:00',3.33),('15128','2014-03-18','14:20:00',3.29),('15128','2014-03-18','14:25:00',3.19),('15128','2014-03-18','14:30:00',3.17),('15128','2014-03-18','14:35:00',3.26),('15128','2014-03-18','14:40:00',3.19),('15128','2014-03-18','14:45:00',3.15),('15128','2014-03-18','14:50:00',3.09),('15128','2014-03-18','14:55:00',3.05),('15128','2014-03-18','15:00:00',2.97),('15128','2014-03-18','15:05:00',2.95),('15128','2014-03-18','15:10:00',2.92),('15128','2014-03-18','15:15:00',2.79),('15128','2014-03-18','15:20:00',2.81),('15128','2014-03-18','15:25:00',2.75),('15128','2014-03-18','15:30:00',2.65),('15128','2014-03-18','15:35:00',2.57),('15128','2014-03-18','15:40:00',2.54),('15128','2014-03-18','15:45:00',2.5),('15128','2014-03-18','15:50:00',2.39),('15128','2014-03-18','15:55:00',2.27),('15128','2014-03-18','16:00:00',2.16),('15128','2014-03-18','16:05:00',2.12),('15128','2014-03-18','16:10:00',1.98),('15128','2014-03-18','16:15:00',1.88),('15128','2014-03-18','16:20:00',1.78),('15128','2014-03-18','16:25:00',1.74),('15128','2014-03-18','16:30:00',1.55),('15128','2014-03-18','16:35:00',1.49),('15128','2014-03-18','16:40:00',1.39),('15128','2014-03-18','16:45:00',1.34),('15128','2014-03-18','16:50:00',1.2),('15128','2014-03-18','16:55:00',1.16),('15128','2014-03-17','08:40:00',1.07),('15128','2014-03-17','08:45:00',1.03),('15128','2014-03-17','08:50:00',1.19),('15128','2014-03-17','08:55:00',1.87),('15128','2014-03-17','09:00:00',1.87),('15128','2014-03-17','09:05:00',2.25),('15128','2014-03-17','09:10:00',1.76),('15128','2014-03-17','09:15:00',1.2),('15128','2014-03-17','09:20:00',1.2),('15128','2014-03-17','09:50:00',1.43),('15128','2014-03-17','09:55:00',1.81),('15128','2014-03-17','10:00:00',2.11),('15128','2014-03-17','10:05:00',1.27),('15128','2014-03-17','10:10:00',1.05),('15128','2014-03-17','10:15:00',2),('15128','2014-03-17','10:20:00',2.27),('15128','2014-03-17','10:25:00',3.21),('15128','2014-03-17','10:30:00',2.9),('15128','2014-03-17','10:35:00',1.63),('15128','2014-03-17','10:40:00',1.17),('15128','2014-03-17','10:45:00',1.12),('15128','2014-03-17','10:50:00',1.08),('15128','2014-03-17','10:55:00',1.92),('15128','2014-03-17','11:00:00',1.45),('15128','2014-03-17','11:05:00',1.36),('15128','2014-03-17','11:10:00',1.67),('15128','2014-03-17','11:15:00',3.72),('15128','2014-03-17','11:20:00',3.63),('15128','2014-03-17','11:25:00',3.46),('15128','2014-03-17','11:30:00',3.56),('15128','2014-03-17','11:35:00',3.57),('15128','2014-03-17','11:40:00',2.25),('15128','2014-03-17','11:45:00',3.02),('15128','2014-03-17','11:50:00',3.28),('15128','2014-03-17','11:55:00',3.55),('15128','2014-03-17','12:00:00',3.78),('15128','2014-03-17','12:05:00',3.33),('15128','2014-03-17','12:10:00',2.03),('15128','2014-03-17','12:15:00',3.21),('15128','2014-03-17','12:20:00',3.62),('15128','2014-03-17','12:25:00',2.93),('15128','2014-03-17','12:30:00',2.76),('15128','2014-03-17','12:35:00',3.55),('15128','2014-03-17','12:40:00',2.83),('15128','2014-03-17','12:45:00',3.69),('15128','2014-03-17','12:50:00',3.77),('15128','2014-03-17','12:55:00',2.85),('15128','2014-03-17','13:00:00',3.51),('15128','2014-03-17','13:05:00',3.33),('15128','2014-03-17','13:10:00',3.81),('15128','2014-03-17','13:15:00',3.55),('15128','2014-03-17','13:20:00',2.77),('15128','2014-03-17','13:25:00',3.11),('15128','2014-03-17','13:30:00',3.64),('15128','2014-03-17','13:35:00',3.52),('15128','2014-03-17','13:40:00',3.59),('15128','2014-03-17','13:45:00',3.61),('15128','2014-03-17','13:50:00',3.51),('15128','2014-03-17','13:55:00',3.56),('15128','2014-03-17','14:00:00',3.48),('15128','2014-03-17','14:05:00',3.52),('15128','2014-03-17','14:10:00',3.4),('15128','2014-03-17','14:15:00',3.39),('15128','2014-03-17','14:20:00',3.34),('15128','2014-03-17','14:25:00',3.28),('15128','2014-03-17','14:30:00',3.33),('15128','2014-03-17','14:35:00',3.31),('15128','2014-03-17','14:40:00',3.2),('15128','2014-03-17','14:45:00',3.12),('15128','2014-03-17','14:50:00',3.09),('15128','2014-03-17','14:55:00',3.04),('15128','2014-03-17','15:00:00',3.02),('15128','2014-03-17','15:05:00',2.93),('15128','2014-03-17','15:10:00',2.92),('15128','2014-03-17','15:15:00',2.88),('15128','2014-03-17','15:20:00',2.79),('15128','2014-03-17','15:25:00',2.7),('15128','2014-03-17','15:30:00',2.56),('15128','2014-03-17','15:35:00',2.53),('15128','2014-03-17','15:40:00',2.44),('15128','2014-03-17','15:45:00',2.43),('15128','2014-03-17','15:50:00',2.36),('15128','2014-03-17','15:55:00',2.27),('15128','2014-03-17','16:00:00',2.16),('15128','2014-03-17','16:05:00',2.03),('15128','2014-03-17','16:10:00',1.91),('15128','2014-03-17','16:15:00',1.79),('15128','2014-03-17','16:20:00',1.75),('15128','2014-03-17','16:25:00',1.64),('15128','2014-03-17','16:30:00',1.62),('15128','2014-03-17','16:35:00',1.36),('15128','2014-03-17','16:40:00',1.46),('15128','2014-03-17','16:45:00',1.33),('15128','2014-03-17','16:50:00',1.27),('15128','2014-03-17','16:55:00',1.22),('15128','2014-03-17','17:00:00',1.04),('15128','2014-04-30','08:20:00',1.04),('15128','2014-04-30','08:25:00',1.11),('15128','2014-04-30','08:30:00',1.19),('15128','2014-04-30','08:35:00',1.59),('15128','2014-04-30','08:40:00',1.38),('15128','2014-04-30','08:55:00',1.26),('15128','2014-04-30','09:00:00',1.42),('15128','2014-04-30','09:05:00',1.37),('15128','2014-04-30','09:10:00',1.86),('15128','2014-04-30','09:15:00',2.09),('15128','2014-04-30','09:20:00',1.37),('15128','2014-04-30','09:25:00',2.08),('15128','2014-04-30','09:30:00',1.67),('15128','2014-04-30','09:35:00',1.55),('15128','2014-04-30','09:40:00',1.02),('15128','2014-04-30','09:55:00',1.12),('15128','2014-04-30','10:00:00',1.59),('15128','2014-04-30','10:05:00',1.8),('15128','2014-04-30','10:10:00',2.93),('15128','2014-04-30','10:15:00',2.68),('15128','2014-04-30','10:20:00',2.72),('15128','2014-04-30','10:25:00',2.11),('15128','2014-04-30','10:30:00',2.17),('15128','2014-04-30','10:35:00',3.14),('15128','2014-04-30','10:40:00',3.32),('15128','2014-04-30','10:45:00',2.99),('15128','2014-04-30','10:50:00',1.68),('15128','2014-04-30','10:55:00',1.93),('15128','2014-04-30','11:00:00',1.42),('15128','2014-04-30','11:05:00',2.75),('15128','2014-04-30','11:10:00',3.48),('15128','2014-04-30','11:15:00',3.52),('15128','2014-04-30','11:20:00',3.49),('15128','2014-04-30','11:25:00',3.56),('15128','2014-04-30','11:30:00',3.61),('15128','2014-04-30','11:35:00',3.57),('15128','2014-04-30','11:40:00',3.74),('15128','2014-04-30','11:45:00',2.24),('15128','2014-04-30','11:50:00',2.65),('15128','2014-04-30','11:55:00',3.17),('15128','2014-04-30','12:00:00',4.37),('15128','2014-04-30','12:05:00',4.39),('15128','2014-04-30','12:10:00',2.84),('15128','2014-04-30','12:15:00',3.13),('15128','2014-04-30','12:20:00',2.8),('15128','2014-04-30','12:25:00',4.64),('15128','2014-04-30','12:30:00',3.86),('15128','2014-04-30','12:40:00',1.16),('15128','2014-04-30','12:45:00',1.34),('15128','2014-04-30','13:00:00',3.32),('15128','2014-04-30','13:05:00',3.87),('15128','2014-04-30','13:10:00',1.73),('15128','2014-04-30','13:15:00',4.73),('15128','2014-04-30','13:20:00',4.64),('15128','2014-04-30','13:25:00',4.9),('15128','2014-04-30','13:30:00',5.11),('15128','2014-04-30','13:35:00',4.77),('15128','2014-04-30','13:40:00',3.64),('15128','2014-04-30','13:45:00',1.11),('15128','2014-04-30','13:50:00',3.82),('15128','2014-04-30','13:55:00',4.5),('15128','2014-04-30','14:00:00',4.38),('15128','2014-04-30','14:05:00',4.36),('15128','2014-04-30','14:10:00',4.3),('15128','2014-04-30','14:15:00',4.25),('15128','2014-04-30','14:20:00',4.28),('15128','2014-04-30','14:25:00',4.27),('15128','2014-04-30','14:30:00',4.26),('15128','2014-04-30','14:35:00',4.27),('15128','2014-04-30','14:40:00',4.28),('15128','2014-04-30','14:45:00',4.31),('15128','2014-04-30','14:50:00',4.21),('15128','2014-04-30','14:55:00',4.2),('15128','2014-04-30','15:00:00',4.25),('15128','2014-04-30','15:05:00',4.2),('15128','2014-04-30','15:10:00',4.21),('15128','2014-04-30','15:15:00',4.18),('15128','2014-04-30','15:20:00',4.01),('15128','2014-04-30','15:25:00',4.04),('15128','2014-04-30','15:30:00',4.04),('15128','2014-04-30','15:35:00',3.93),('15128','2014-04-30','15:40:00',3.97),('15128','2014-04-30','15:45:00',3.92),('15128','2014-04-30','15:50:00',3.84),('15128','2014-04-30','15:55:00',3.76),('15128','2014-04-30','16:00:00',3.77),('15128','2014-04-30','16:05:00',3.73),('15128','2014-04-30','16:10:00',3.7),('15128','2014-04-30','16:15:00',3.56),('15128','2014-04-30','16:20:00',3.24),('15128','2014-04-30','16:25:00',3.32),('15128','2014-04-30','16:30:00',3.29),('15128','2014-04-30','16:35:00',3.17),('15128','2014-04-30','16:40:00',2.89),('15128','2014-04-30','16:45:00',3.01),('15128','2014-04-30','16:50:00',3.21),('15128','2014-04-30','16:55:00',3.06),('15128','2014-04-30','17:00:00',3.06),('15128','2014-04-30','17:05:00',2.99),('15128','2014-04-30','17:10:00',2.91),('15128','2014-04-30','17:15:00',2.83),('15128','2014-04-30','17:20:00',2.75),('15128','2014-04-30','17:25:00',2.67),('15128','2014-04-30','17:30:00',2.65),('15128','2014-04-30','17:35:00',2.58),('15128','2014-04-30','17:40:00',2.19),('15128','2014-04-30','17:45:00',2.05),('15128','2014-04-30','17:50:00',1.38),('15128','2014-04-30','17:55:00',2.05),('15128','2014-04-30','18:00:00',1.68),('15128','2014-04-30','18:05:00',1.3),('15128','2014-04-30','18:10:00',1.8),('15128','2014-04-30','18:15:00',1.21),('15128','2014-04-30','18:20:00',1.38),('15128','2014-04-30','18:25:00',1.52),('15128','2014-04-30','18:30:00',1.44),('15128','2014-04-30','18:35:00',1.41),('15128','2014-04-30','18:40:00',1.03),('15128','2014-04-30','18:45:00',1.02),('15128','2014-04-30','18:50:00',1.04),('15128','2014-03-16','09:15:00',1.03),('15128','2014-03-16','09:20:00',1.01),('15128','2014-03-16','09:35:00',1.1),('15128','2014-03-16','09:40:00',1.16),('15128','2014-03-16','09:45:00',1.16),('15128','2014-03-16','09:50:00',1.17),('15128','2014-03-16','10:05:00',1.14),('15128','2014-03-16','10:10:00',1.26),('15128','2014-03-16','10:15:00',1.3),('15128','2014-03-16','10:20:00',1.13),('15128','2014-03-16','10:25:00',1.17),('15128','2014-03-16','10:30:00',1.06),('15128','2014-03-16','10:35:00',1.12),('15128','2014-03-16','10:40:00',1.4),('15128','2014-03-16','10:45:00',1.57),('15128','2014-03-16','10:50:00',1.23),('15128','2014-03-16','10:55:00',1.72),('15128','2014-03-16','11:00:00',1.78),('15128','2014-03-16','11:05:00',2.09),('15128','2014-03-16','11:10:00',1.38),('15128','2014-03-16','11:15:00',1.33),('15128','2014-03-16','11:20:00',1.24),('15128','2014-03-16','11:25:00',1.44),('15128','2014-03-16','11:30:00',2.24),('15128','2014-03-16','11:35:00',1.08),('15128','2014-03-16','11:45:00',1.07),('15128','2014-03-16','11:50:00',2.31),('15128','2014-03-16','11:55:00',1.33),('15128','2014-03-16','12:00:00',1.34),('15128','2014-03-16','12:05:00',1.73),('15128','2014-03-16','12:10:00',2.26),('15128','2014-03-16','12:15:00',3.11),('15128','2014-03-16','12:20:00',1.99),('15128','2014-03-16','12:25:00',2.89),('15128','2014-03-16','12:30:00',3.74),('15128','2014-03-16','12:35:00',3.49),('15128','2014-03-16','12:40:00',2.15),('15128','2014-03-16','12:45:00',3.91),('15128','2014-03-16','12:50:00',4.04),('15128','2014-03-16','12:55:00',3.39),('15128','2014-03-16','13:00:00',2.45),('15128','2014-03-16','13:05:00',3.49),('15128','2014-03-16','13:10:00',3.61),('15128','2014-03-16','13:15:00',3.65),('15128','2014-03-16','13:20:00',3.64),('15128','2014-03-16','13:25:00',3.68),('15128','2014-03-16','13:30:00',3.26),('15128','2014-03-16','13:35:00',3.67),('15128','2014-03-16','13:40:00',3.61),('15128','2014-03-16','13:45:00',2.77),('15128','2014-03-16','13:50:00',2.64),('15128','2014-03-16','13:55:00',2.55),('15128','2014-03-16','14:00:00',2.49),('15128','2014-03-16','14:05:00',3.42),('15128','2014-03-16','14:10:00',3.42),('15128','2014-03-16','14:15:00',3.59),('15128','2014-03-16','14:20:00',3.5),('15128','2014-03-16','14:25:00',3.11),('15128','2014-03-16','14:30:00',2.14),('15128','2014-03-16','14:35:00',2.07),('15128','2014-03-16','14:40:00',2.84),('15128','2014-03-16','14:45:00',2.72),('15128','2014-03-16','14:50:00',3.15),('15128','2014-03-16','14:55:00',2.48),('15128','2014-03-16','15:00:00',3.09),('15128','2014-03-16','15:05:00',2.98),('15128','2014-03-16','15:10:00',2.85),('15128','2014-03-16','15:15:00',2.75),('15128','2014-03-16','15:20:00',2.62),('15128','2014-03-16','15:25:00',2.33),('15128','2014-03-16','15:30:00',1.68),('15128','2014-03-16','15:35:00',2.2),('15128','2014-03-16','15:40:00',2.35),('15128','2014-03-16','15:45:00',2.2),('15128','2014-03-16','15:50:00',1.96),('15128','2014-03-16','15:55:00',1.79),('15128','2014-03-16','16:00:00',2),('15128','2014-03-16','16:05:00',1.81),('15128','2014-03-16','16:10:00',1.72),('15128','2014-03-16','16:15:00',1.65),('15128','2014-03-16','16:20:00',1.57),('15128','2014-03-16','16:25:00',1.49),('15128','2014-03-16','16:30:00',1.32),('15128','2014-03-15','08:30:00',1.03),('15128','2014-03-15','08:35:00',1.1),('15128','2014-03-15','08:40:00',1.16),('15128','2014-03-15','08:45:00',1.24),('15128','2014-03-15','08:50:00',1.32),('15128','2014-03-15','08:55:00',1.36),('15128','2014-03-15','09:00:00',1.31),('15128','2014-03-15','09:05:00',1.41),('15128','2014-03-15','09:10:00',1.54),('15128','2014-03-15','09:15:00',1.63),('15128','2014-03-15','09:20:00',1.64),('15128','2014-03-15','09:25:00',1.67),('15128','2014-03-15','09:30:00',1.7),('15128','2014-03-15','09:35:00',1.73),('15128','2014-03-15','09:40:00',1.79),('15128','2014-03-15','09:45:00',1.92),('15128','2014-03-15','09:50:00',1.98),('15128','2014-03-15','09:55:00',1.98),('15128','2014-03-15','10:00:00',2.05),('15128','2014-03-15','10:05:00',2.12),('15128','2014-03-15','10:10:00',2.17),('15128','2014-03-15','10:15:00',2.25),('15128','2014-03-15','10:20:00',2.29),('15128','2014-03-15','10:25:00',2.34),('15128','2014-03-15','10:30:00',2.39),('15128','2014-03-15','10:35:00',2.41),('15128','2014-03-15','10:40:00',2.43),('15128','2014-03-15','10:45:00',2.5),('15128','2014-03-15','10:50:00',2.58),('15128','2014-03-15','10:55:00',2.66),('15128','2014-03-15','11:00:00',2.72),('15128','2014-03-15','11:05:00',2.75),('15128','2014-03-15','11:10:00',2.93),('15128','2014-03-15','11:15:00',3.04),('15128','2014-03-15','11:20:00',3.09),('15128','2014-03-15','11:25:00',3.01),('15128','2014-03-15','11:30:00',3.04),('15128','2014-03-15','11:35:00',3.07),('15128','2014-03-15','11:40:00',3.09),('15128','2014-03-15','11:45:00',3.1),('15128','2014-03-15','11:50:00',3.15),('15128','2014-03-15','11:55:00',3.19),('15128','2014-03-15','12:00:00',3.2),('15128','2014-03-15','12:05:00',3.25),('15128','2014-03-15','12:10:00',3.3),('15128','2014-03-15','12:15:00',3.31),('15128','2014-03-15','12:20:00',3.31),('15128','2014-03-15','12:25:00',3.33),('15128','2014-03-15','12:30:00',3.29),('15128','2014-03-15','12:35:00',3.36),('15128','2014-03-15','12:40:00',3.37),('15128','2014-03-15','12:45:00',3.34),('15128','2014-03-15','12:50:00',3.38),('15128','2014-03-15','12:55:00',3.37),('15128','2014-03-15','13:00:00',3.24),('15128','2014-03-15','13:05:00',3.3),('15128','2014-03-15','13:10:00',3.34),('15128','2014-03-15','13:15:00',3.35),('15128','2014-03-15','13:20:00',3.38),('15128','2014-03-15','13:25:00',3.43),('15128','2014-03-15','13:30:00',3.35),('15128','2014-03-15','13:35:00',3.34),('15128','2014-03-15','13:40:00',3.27),('15128','2014-03-15','13:45:00',3.29),('15128','2014-03-15','13:50:00',3.2),('15128','2014-03-15','13:55:00',3.28),('15128','2014-03-15','14:00:00',3.26),('15128','2014-03-15','14:05:00',3.22),('15128','2014-03-15','14:10:00',3.19),('15128','2014-03-15','14:15:00',3.18),('15128','2014-03-15','14:20:00',3.15),('15128','2014-03-15','14:25:00',3.13),('15128','2014-03-15','14:30:00',3.07),('15128','2014-03-15','14:35:00',3.04),('15128','2014-03-15','14:40:00',2.94),('15128','2014-03-15','14:45:00',2.73),('15128','2014-03-15','14:50:00',2.77),('15128','2014-03-15','14:55:00',2.79),('15128','2014-03-15','15:00:00',2.61),('15128','2014-03-15','15:05:00',2.44),('15128','2014-03-15','15:10:00',2.17),('15128','2014-03-15','15:15:00',1.87),('15128','2014-03-15','15:20:00',2.04),('15128','2014-03-15','15:25:00',2.04),('15128','2014-03-15','15:30:00',1.96),('15128','2014-03-15','15:35:00',1.38),('15128','2014-03-15','15:40:00',1.65),('15128','2014-03-15','15:45:00',1.88),('15128','2014-03-15','15:50:00',1.6),('15128','2014-03-15','15:55:00',1.44),('15128','2014-03-15','16:00:00',1.52),('15128','2014-03-15','16:05:00',1.67),('15128','2014-03-15','16:10:00',1.71),('15128','2014-03-15','16:15:00',1.67),('15128','2014-03-15','16:20:00',1.54),('15128','2014-03-15','16:25:00',1.49),('15128','2014-03-15','16:30:00',1.5),('15128','2014-03-15','16:35:00',1.35),('15128','2014-03-15','16:40:00',1.27),('15128','2014-03-15','16:45:00',1.18),('15128','2014-03-14','08:35:00',1.03),('15128','2014-03-14','08:40:00',1.09),('15128','2014-03-14','08:45:00',1.17),('15128','2014-03-14','08:50:00',1.24),('15128','2014-03-14','08:55:00',1.3),('15128','2014-03-14','09:00:00',1.36),('15128','2014-03-14','09:05:00',1.41),('15128','2014-03-14','09:10:00',1.46),('15128','2014-03-14','09:15:00',1.52),('15128','2014-03-14','09:20:00',1.58),('15128','2014-03-14','09:25:00',1.62),('15128','2014-03-14','09:30:00',1.68),('15128','2014-03-14','09:35:00',1.74),('15128','2014-03-14','09:40:00',1.77),('15128','2014-03-14','09:45:00',1.83),('15128','2014-03-14','09:50:00',1.88),('15128','2014-03-14','09:55:00',1.95),('15128','2014-03-14','10:00:00',2.03),('15128','2014-03-14','10:05:00',2.05),('15128','2014-03-14','10:10:00',2.15),('15128','2014-03-14','10:15:00',2.19),('15128','2014-03-14','10:20:00',2.22),('15128','2014-03-14','10:25:00',2.25),('15128','2014-03-14','10:30:00',2.31),('15128','2014-03-14','10:35:00',2.38),('15128','2014-03-14','10:40:00',2.37),('15128','2014-03-14','10:45:00',2.44),('15128','2014-03-14','10:50:00',2.46),('15128','2014-03-14','10:55:00',2.57),('15128','2014-03-14','11:00:00',2.67),('15128','2014-03-14','11:05:00',2.71),('15128','2014-03-14','11:10:00',2.74),('15128','2014-03-14','11:15:00',2.94),('15128','2014-03-14','11:20:00',2.89),('15128','2014-03-14','11:25:00',2.98),('15128','2014-03-14','11:30:00',2.92),('15128','2014-03-14','11:35:00',3.01),('15128','2014-03-14','11:40:00',3.08),('15128','2014-03-14','11:45:00',3.11),('15128','2014-03-14','11:50:00',3.15),('15128','2014-03-14','11:55:00',3.21),('15128','2014-03-14','12:00:00',3.25),('15128','2014-03-14','12:05:00',3.27),('15128','2014-03-14','12:10:00',3.27),('15128','2014-03-14','12:15:00',3.28),('15128','2014-03-14','12:20:00',3.34),('15128','2014-03-14','12:25:00',3.3),('15128','2014-03-14','12:30:00',3.34),('15128','2014-03-14','12:35:00',3.34),('15128','2014-03-14','12:40:00',3.4),('15128','2014-03-14','12:45:00',3.41),('15128','2014-03-14','12:50:00',3.41),('15128','2014-03-14','12:55:00',3.39),('15128','2014-03-14','13:00:00',3.37),('15128','2014-03-14','13:05:00',3.39),('15128','2014-03-14','13:10:00',3.39),('15128','2014-03-14','13:15:00',3.39),('15128','2014-03-14','13:20:00',3.4),('15128','2014-03-14','13:25:00',3.41),('15128','2014-03-14','13:30:00',3.42),('15128','2014-03-14','13:35:00',3.44),('15128','2014-03-14','13:40:00',3.41),('15128','2014-03-14','13:45:00',3.39),('15128','2014-03-14','13:50:00',3.39),('15128','2014-03-14','13:55:00',3.33),('15128','2014-03-14','14:00:00',3.26),('15128','2014-03-14','14:05:00',3.25),('15128','2014-03-14','14:10:00',3.22),('15128','2014-03-14','14:15:00',3.2),('15128','2014-03-14','14:20:00',3.18),('15128','2014-03-14','14:25:00',3.14),('15128','2014-03-14','14:30:00',3.1),('15128','2014-03-14','14:35:00',3.05),('15128','2014-03-14','14:40:00',2.97),('15128','2014-03-14','14:45:00',2.97),('15128','2014-03-14','14:50:00',2.93),('15128','2014-03-14','14:55:00',2.88),('15128','2014-03-14','15:00:00',2.78),('15128','2014-03-14','15:05:00',2.78),('15128','2014-03-14','15:10:00',2.72),('15128','2014-03-14','15:15:00',2.62),('15128','2014-03-14','15:20:00',2.6),('15128','2014-03-14','15:25:00',2.53),('15128','2014-03-14','15:30:00',2.44),('15128','2014-03-14','15:35:00',2.38),('15128','2014-03-14','15:40:00',2.31),('15128','2014-03-14','15:45:00',2.18),('15128','2014-03-14','15:50:00',2.01),('15128','2014-03-14','15:55:00',1.92),('15128','2014-03-14','16:00:00',1.77),('15128','2014-03-14','16:05:00',1.68),('15128','2014-03-14','16:10:00',1.59),('15128','2014-03-14','16:15:00',1.5),('15128','2014-03-14','16:20:00',1.44),('15128','2014-03-14','16:25:00',1.39),('15128','2014-03-14','16:30:00',1.3),('15128','2014-03-14','16:35:00',1.24),('15128','2014-03-14','16:40:00',1.18),('15128','2014-03-14','16:45:00',1.1),('15128','2014-03-13','09:10:00',1.1),('15128','2014-03-13','09:15:00',1.35),('15128','2014-03-13','09:20:00',1.63),('15128','2014-03-13','09:25:00',1.71),('15128','2014-03-13','09:30:00',1.57),('15128','2014-03-13','09:35:00',1.63),('15128','2014-03-13','09:40:00',1.63),('15128','2014-03-13','09:45:00',1.79),('15128','2014-03-13','09:50:00',2.02),('15128','2014-03-13','09:55:00',2.16),('15128','2014-03-13','10:00:00',2.39),('15128','2014-03-13','10:05:00',2.43),('15128','2014-03-13','10:10:00',2.55),('15128','2014-03-13','10:15:00',2.58),('15128','2014-03-13','10:20:00',2.57),('15128','2014-03-13','10:25:00',2.53),('15128','2014-03-13','10:30:00',2.59),('15128','2014-03-13','10:35:00',2.53),('15128','2014-03-13','10:40:00',2.56),('15128','2014-03-13','10:45:00',2.7),('15128','2014-03-13','10:50:00',2.7),('15128','2014-03-13','10:55:00',2.35),('15128','2014-03-13','11:00:00',1.94),('15128','2014-03-13','11:05:00',2.74),('15128','2014-03-13','11:10:00',2.85),('15128','2014-03-13','11:15:00',3.16),('15128','2014-03-13','11:20:00',3.31),('15128','2014-03-13','11:25:00',3.35),('15128','2014-03-13','11:30:00',3.24),('15128','2014-03-13','11:35:00',3.21),('15128','2014-03-13','11:40:00',3.18),('15128','2014-03-13','11:45:00',3.08),('15128','2014-03-13','11:50:00',3.04),('15128','2014-03-13','11:55:00',3.23),('15128','2014-03-13','12:00:00',3.18),('15128','2014-03-13','12:05:00',3.21),('15128','2014-03-13','12:10:00',3.32),('15128','2014-03-13','12:15:00',3.28),('15128','2014-03-13','12:20:00',3.19),('15128','2014-03-13','12:25:00',3.15),('15128','2014-03-13','12:30:00',3.06),('15128','2014-03-13','12:35:00',3.02),('15128','2014-03-13','12:40:00',2.38),('15128','2014-03-13','12:45:00',2.11),('15128','2014-03-13','12:50:00',1.82),('15128','2014-03-13','12:55:00',1.93),('15128','2014-03-13','13:00:00',2.16),('15128','2014-03-13','13:05:00',1.92),('15128','2014-03-13','13:10:00',1.54),('15128','2014-03-13','13:15:00',1.79),('15128','2014-03-13','13:20:00',2.45),('15128','2014-03-13','13:25:00',2.42),('15128','2014-03-13','13:30:00',2.35),('15128','2014-03-13','13:35:00',2.58),('15128','2014-03-13','13:40:00',2.62),('15128','2014-03-13','13:45:00',1.97),('15128','2014-03-13','13:50:00',1.97),('15128','2014-03-13','13:55:00',2.08),('15128','2014-03-13','14:00:00',2.25),('15128','2014-03-13','14:05:00',2.32),('15128','2014-03-13','14:10:00',2.19),('15128','2014-03-13','14:15:00',2.25),('15128','2014-03-13','14:20:00',2.34),('15128','2014-03-13','14:25:00',2.26),('15128','2014-03-13','14:30:00',2.65),('15128','2014-03-13','14:35:00',2.69),('15128','2014-03-13','14:40:00',2.79),('15128','2014-03-13','14:45:00',2.41),('15128','2014-03-13','14:50:00',1.87),('15128','2014-03-13','14:55:00',1.67),('15128','2014-03-13','15:00:00',1.52),('15128','2014-03-13','15:05:00',1.37),('15128','2014-03-13','15:10:00',1.28),('15128','2014-03-13','15:15:00',1.23),('15128','2014-03-13','15:20:00',1.16),('15128','2014-03-13','15:25:00',1.16),('15128','2014-03-13','15:30:00',1.22),('15128','2014-03-13','15:35:00',1.39),('15128','2014-03-13','15:40:00',1.33),('15128','2014-03-13','15:45:00',1.55),('15128','2014-03-13','15:50:00',1.6),('15128','2014-03-13','15:55:00',1.27),('15128','2014-03-13','16:00:00',1.16),('15128','2014-03-13','16:05:00',1.06),('15128','2014-03-12','08:35:00',1.06),('15128','2014-03-12','08:40:00',1.16),('15128','2014-03-12','08:45:00',1.23),('15128','2014-03-12','08:50:00',1.31),('15128','2014-03-12','08:55:00',1.37),('15128','2014-03-12','09:00:00',1.44),('15128','2014-03-12','09:05:00',1.48),('15128','2014-03-12','09:10:00',1.54),('15128','2014-03-12','09:15:00',1.61),('15128','2014-03-12','09:20:00',1.69),('15128','2014-03-12','09:25:00',1.74),('15128','2014-03-12','09:30:00',1.78),('15128','2014-03-12','09:35:00',1.82),('15128','2014-03-12','09:40:00',1.89),('15128','2014-03-12','09:45:00',1.93),('15128','2014-03-12','09:50:00',1.94),('15128','2014-03-12','09:55:00',2.03),('15128','2014-03-12','10:00:00',2.09),('15128','2014-03-12','10:05:00',2.18),('15128','2014-03-12','10:10:00',2.24),('15128','2014-03-12','10:15:00',2.29),('15128','2014-03-12','10:20:00',2.38),('15128','2014-03-12','10:25:00',2.35),('15128','2014-03-12','10:30:00',2.44),('15128','2014-03-12','10:35:00',2.5),('15128','2014-03-12','10:40:00',2.6),('15128','2014-03-12','10:45:00',2.59),('15128','2014-03-12','10:50:00',2.64),('15128','2014-03-12','10:55:00',2.71),('15128','2014-03-12','11:00:00',2.79),('15128','2014-03-12','11:05:00',2.88),('15128','2014-03-12','11:10:00',2.94),('15128','2014-03-12','11:15:00',3.02),('15128','2014-03-12','11:20:00',3.11),('15128','2014-03-12','11:25:00',3.15),('15128','2014-03-12','11:30:00',3.17),('15128','2014-03-12','11:35:00',3.22),('15128','2014-03-12','11:40:00',3.28),('15128','2014-03-12','11:45:00',3.33),('15128','2014-03-12','11:50:00',3.36),('15128','2014-03-12','11:55:00',3.4),('15128','2014-03-12','12:00:00',3.44),('15128','2014-03-12','12:05:00',3.44),('15128','2014-03-12','12:10:00',3.45),('15128','2014-03-12','12:15:00',3.47),('15128','2014-03-12','12:20:00',3.47),('15128','2014-03-12','12:25:00',3.47),('15128','2014-03-12','12:30:00',3.47),('15128','2014-03-12','12:35:00',3.47),('15128','2014-03-12','12:40:00',3.48),('15128','2014-03-12','12:45:00',3.47),('15128','2014-03-12','12:50:00',3.44),('15128','2014-03-12','12:55:00',3.47),('15128','2014-03-12','13:00:00',3.49),('15128','2014-03-12','13:05:00',3.48),('15128','2014-03-12','13:10:00',3.51),('15128','2014-03-12','13:15:00',3.53),('15128','2014-03-12','13:20:00',3.55),('15128','2014-03-12','13:25:00',3.51),('15128','2014-03-12','13:30:00',3.51),('15128','2014-03-12','13:35:00',3.49),('15128','2014-03-12','13:40:00',3.49),('15128','2014-03-12','13:45:00',3.47),('15128','2014-03-12','13:50:00',3.43),('15128','2014-03-12','13:55:00',3.4),('15128','2014-03-12','14:00:00',3.36),('15128','2014-03-12','14:05:00',3.32),('15128','2014-03-12','14:10:00',3.3),('15128','2014-03-12','14:15:00',3.27),('15128','2014-03-12','14:20:00',3.23),('15128','2014-03-12','14:25:00',3.19),('15128','2014-03-12','14:30:00',3.16),('15128','2014-03-12','14:35:00',3.12),('15128','2014-03-12','14:40:00',3.07),('15128','2014-03-12','14:45:00',3.02),('15128','2014-03-12','14:50:00',2.96),('15128','2014-03-12','14:55:00',2.9),('15128','2014-03-12','15:00:00',2.84),('15128','2014-03-12','15:05:00',2.77),('15128','2014-03-12','15:10:00',2.69),('15128','2014-03-12','15:15:00',2.62),('15128','2014-03-12','15:20:00',2.57),('15128','2014-03-12','15:25:00',2.5),('15128','2014-03-12','15:30:00',2.43),('15128','2014-03-12','15:35:00',2.37),('15128','2014-03-12','15:40:00',2.31),('15128','2014-03-12','15:45:00',2.22),('15128','2014-03-12','15:50:00',2.13),('15128','2014-03-12','15:55:00',2.02),('15128','2014-03-12','16:00:00',1.91),('15128','2014-03-12','16:05:00',1.79),('15128','2014-03-12','16:10:00',1.66),('15128','2014-03-12','16:15:00',1.51),('15128','2014-03-12','16:20:00',1.49),('15128','2014-03-12','16:25:00',1.47),('15128','2014-03-12','16:30:00',1.39),('15128','2014-03-12','16:35:00',1.36),('15128','2014-03-12','16:40:00',1.28),('15128','2014-03-12','16:45:00',1.23),('15128','2014-03-12','16:50:00',1.15),('15128','2014-03-12','16:55:00',1.03),('15128','2014-03-11','08:40:00',1.1),('15128','2014-03-11','08:45:00',1.18),('15128','2014-03-11','08:50:00',1.26),('15128','2014-03-11','08:55:00',1.33),('15128','2014-03-11','09:00:00',1.39),('15128','2014-03-11','09:05:00',1.44),('15128','2014-03-11','09:10:00',1.5),('15128','2014-03-11','09:15:00',1.58),('15128','2014-03-11','09:20:00',1.64),('15128','2014-03-11','09:25:00',1.69),('15128','2014-03-11','09:30:00',1.75),('15128','2014-03-11','09:35:00',1.8),('15128','2014-03-11','09:40:00',1.85),('15128','2014-03-11','09:45:00',1.89),('15128','2014-03-11','09:50:00',1.9),('15128','2014-03-11','09:55:00',2.02),('15128','2014-03-11','10:00:00',2.05),('15128','2014-03-11','10:05:00',2.14),('15128','2014-03-11','10:10:00',2.19),('15128','2014-03-11','10:15:00',2.25),('15128','2014-03-11','10:20:00',2.33),('15128','2014-03-11','10:25:00',2.35),('15128','2014-03-11','10:30:00',2.44),('15128','2014-03-11','10:35:00',2.49),('15128','2014-03-11','10:40:00',2.55),('15128','2014-03-11','10:45:00',2.61),('15128','2014-03-11','10:50:00',2.69),('15128','2014-03-11','10:55:00',2.72),('15128','2014-03-11','11:00:00',2.75),('15128','2014-03-11','11:05:00',2.8),('15128','2014-03-11','11:10:00',2.98),('15128','2014-03-11','11:15:00',3.07),('15128','2014-03-11','11:20:00',3.13),('15128','2014-03-11','11:25:00',3.15),('15128','2014-03-11','11:30:00',3.19),('15128','2014-03-11','11:35:00',3.21),('15128','2014-03-11','11:40:00',3.27),('15128','2014-03-11','11:45:00',3.31),('15128','2014-03-11','11:50:00',3.35),('15128','2014-03-11','11:55:00',3.38),('15128','2014-03-11','12:00:00',3.41),('15128','2014-03-11','12:05:00',3.41),('15128','2014-03-11','12:10:00',3.42),('15128','2014-03-11','12:15:00',3.46),('15128','2014-03-11','12:20:00',3.48),('15128','2014-03-11','12:25:00',3.5),('15128','2014-03-11','12:30:00',3.53),('15128','2014-03-11','12:35:00',3.52),('15128','2014-03-11','12:40:00',3.5),('15128','2014-03-11','12:45:00',3.48),('15128','2014-03-11','12:50:00',3.53),('15128','2014-03-11','12:55:00',3.49),('15128','2014-03-11','13:00:00',3.49),('15128','2014-03-11','13:05:00',3.52),('15128','2014-03-11','13:10:00',3.49),('15128','2014-03-11','13:15:00',3.47),('15128','2014-03-11','13:20:00',3.49),('15128','2014-03-11','13:25:00',3.47),('15128','2014-03-11','13:30:00',3.44),('15128','2014-03-11','13:35:00',3.44),('15128','2014-03-11','13:40:00',3.44),('15128','2014-03-11','13:45:00',3.4),('15128','2014-03-11','13:50:00',3.36),('15128','2014-03-11','13:55:00',3.36),('15128','2014-03-11','14:00:00',3.33),('15128','2014-03-11','14:05:00',3.35),('15128','2014-03-11','14:10:00',3.31),('15128','2014-03-11','14:15:00',3.23),('15128','2014-03-11','14:20:00',3.25),('15128','2014-03-11','14:25:00',3.27),('15128','2014-03-11','14:30:00',3.18),('15128','2014-03-11','14:35:00',3.19),('15128','2014-03-11','14:40:00',3.17),('15128','2014-03-11','14:45:00',3.01),('15128','2014-03-11','14:50:00',3.02),('15128','2014-03-11','14:55:00',2.99),('15128','2014-03-11','15:00:00',2.84),('15128','2014-03-11','15:05:00',2.68),('15128','2014-03-11','15:10:00',2.74),('15128','2014-03-11','15:15:00',2.7),('15128','2014-03-11','15:20:00',2.62),('15128','2014-03-11','15:25:00',2.51),('15128','2014-03-11','15:30:00',2.45),('15128','2014-03-11','15:35:00',2.39),('15128','2014-03-11','15:40:00',2.35),('15128','2014-03-11','15:45:00',2.27),('15128','2014-03-11','15:50:00',2.12),('15128','2014-03-11','15:55:00',2.03),('15128','2014-03-11','16:00:00',1.9),('15128','2014-03-11','16:05:00',1.79),('15128','2014-03-11','16:10:00',1.73),('15128','2014-03-11','16:15:00',1.65),('15128','2014-03-11','16:20:00',1.54),('15128','2014-03-11','16:25:00',1.49),('15128','2014-03-11','16:30:00',1.39),('15128','2014-03-11','16:35:00',1.33),('15128','2014-03-11','16:40:00',1.28),('15128','2014-03-11','16:45:00',1.2),('15128','2014-03-11','16:50:00',1.1),('15128','2014-03-10','11:55:00',1.2),('15128','2014-03-10','12:00:00',1.29),('15128','2014-03-10','12:05:00',1.37),('15128','2014-03-10','12:10:00',1.57),('15128','2014-03-10','12:15:00',1.84),('15128','2014-03-10','12:20:00',1.9),('15128','2014-03-10','12:25:00',1.62),('15128','2014-03-10','12:30:00',1.56),('15128','2014-03-10','12:35:00',1.5),('15128','2014-03-10','12:40:00',1.41),('15128','2014-03-10','12:45:00',1.48),('15128','2014-03-10','12:50:00',1.61),('15128','2014-03-10','12:55:00',1.72),('15128','2014-03-10','13:00:00',2.15),('15128','2014-03-10','13:05:00',1.94),('15128','2014-03-10','13:10:00',2.05),('15128','2014-03-10','13:15:00',1.61),('15128','2014-03-10','13:20:00',1.54),('15128','2014-03-10','13:25:00',1.48),('15128','2014-03-10','13:30:00',1.3),('15128','2014-03-10','13:35:00',1.34),('15128','2014-03-10','13:40:00',1.48),('15128','2014-03-10','13:45:00',1.84),('15128','2014-03-10','13:50:00',2.61),('15128','2014-03-10','13:55:00',2.4),('15128','2014-03-10','14:00:00',2.26),('15128','2014-03-10','14:05:00',2.02),('15128','2014-03-10','14:10:00',1.87),('15128','2014-03-10','14:15:00',2.12),('15128','2014-03-10','14:20:00',2.29),('15128','2014-03-10','14:25:00',2.19),('15128','2014-03-10','14:30:00',2.11),('15128','2014-03-10','14:35:00',1.83),('15128','2014-03-10','14:40:00',1.87),('15128','2014-03-10','14:45:00',1.88),('15128','2014-03-10','14:50:00',1.6),('15128','2014-03-10','14:55:00',1.63),('15128','2014-03-10','15:00:00',2.02),('15128','2014-03-10','15:05:00',1.66),('15128','2014-03-10','15:10:00',1.47),('15128','2014-03-10','15:15:00',1.43),('15128','2014-03-10','15:20:00',1.09),('15128','2014-03-09','08:55:00',1.04),('15128','2014-03-09','09:00:00',1.08),('15128','2014-03-09','09:05:00',1.08),('15128','2014-03-09','09:25:00',1.05),('15128','2014-03-09','09:30:00',1.06),('15128','2014-03-09','09:35:00',1.15),('15128','2014-03-09','09:40:00',1.34),('15128','2014-03-09','09:45:00',1.51),('15128','2014-03-09','09:50:00',1.46),('15128','2014-03-09','09:55:00',1.2),('15128','2014-03-09','13:00:00',1.02),('15128','2014-03-09','13:05:00',1.09),('15128','2014-03-09','13:10:00',1.24),('15128','2014-03-09','13:15:00',1.15),('15128','2014-03-09','14:45:00',1.02),('15128','2014-03-09','14:50:00',1.07),('15128','2014-03-09','15:00:00',1.01),('15128','2014-03-09','15:05:00',1.76),('15128','2014-03-09','15:10:00',2.96),('15128','2014-03-09','15:15:00',3.09),('15128','2014-03-09','15:20:00',2.89),('15128','2014-03-09','15:25:00',2.15),('15128','2014-03-09','15:30:00',1.97),('15128','2014-03-09','15:35:00',1.75),('15128','2014-03-09','15:40:00',1.03),('15128','2014-03-09','15:50:00',1.07),('15128','2014-03-09','16:30:00',1.36),('15128','2014-03-09','16:35:00',1.59),('15128','2014-03-09','16:40:00',1.53),('15128','2014-03-09','16:45:00',1.14),('15128','2014-03-08','08:40:00',1.04),('15128','2014-03-08','08:45:00',1.14),('15128','2014-03-08','08:50:00',1.22),('15128','2014-03-08','08:55:00',1.29),('15128','2014-03-08','09:00:00',1.36),('15128','2014-03-08','09:05:00',1.43),('15128','2014-03-08','09:10:00',1.46),('15128','2014-03-08','09:15:00',1.55),('15128','2014-03-08','09:20:00',1.63),('15128','2014-03-08','09:25:00',1.71),('15128','2014-03-08','09:30:00',1.5),('15128','2014-03-08','09:40:00',1.25),('15128','2014-03-08','09:45:00',2.13),('15128','2014-03-08','09:50:00',2.22),('15128','2014-03-08','09:55:00',2.26),('15128','2014-03-08','10:00:00',2.29),('15128','2014-03-08','10:05:00',2.32),('15128','2014-03-08','10:10:00',2.38),('15128','2014-03-08','10:15:00',2.41),('15128','2014-03-08','10:20:00',2.43),('15128','2014-03-08','10:25:00',2.49),('15128','2014-03-08','10:30:00',2.48),('15128','2014-03-08','10:35:00',2.6),('15128','2014-03-08','10:40:00',2.62),('15128','2014-03-08','10:45:00',2.71),('15128','2014-03-08','10:50:00',2.71),('15128','2014-03-08','10:55:00',2.34),('15128','2014-03-08','11:00:00',3),('15128','2014-03-08','11:05:00',3.1),('15128','2014-03-08','11:10:00',3.22),('15128','2014-03-08','11:15:00',3.34),('15128','2014-03-08','11:20:00',1.84),('15128','2014-03-08','11:35:00',1.78),('15128','2014-03-08','11:40:00',3.87),('15128','2014-03-08','11:45:00',3.85),('15128','2014-03-08','11:50:00',3.37),('15128','2014-03-08','11:55:00',1.32),('15128','2014-03-08','12:00:00',1.75),('15128','2014-03-08','12:05:00',4.24),('15128','2014-03-08','12:10:00',4.1),('15128','2014-03-08','12:15:00',3.92),('15128','2014-03-08','12:20:00',4.03),('15128','2014-03-08','12:25:00',4.01),('15128','2014-03-08','12:30:00',3.92),('15128','2014-03-08','12:35:00',3.98),('15128','2014-03-08','12:40:00',3.95),('15128','2014-03-08','12:45:00',3.82),('15128','2014-03-08','12:50:00',3.78),('15128','2014-03-08','12:55:00',3.7),('15128','2014-03-08','13:00:00',3.79),('15128','2014-03-08','13:05:00',3.88),('15128','2014-03-08','13:10:00',3.33),('15128','2014-03-08','13:15:00',2.04),('15128','2014-03-08','13:20:00',4.01),('15128','2014-03-08','13:25:00',3.58),('15128','2014-03-08','13:30:00',1.11),('15128','2014-03-08','13:40:00',1.33),('15128','2014-03-08','13:45:00',1.12),('15128','2014-03-08','13:50:00',2.61),('15128','2014-03-08','13:55:00',1.42),('15128','2014-03-08','14:00:00',1.15),('15128','2014-03-08','14:05:00',1.73),('15128','2014-03-08','14:10:00',2.41),('15128','2014-03-08','14:15:00',3.15),('15128','2014-03-08','14:20:00',3.4),('15128','2014-03-08','14:25:00',3.36),('15128','2014-03-08','14:30:00',3.3),('15128','2014-03-08','14:35:00',3.3),('15128','2014-03-08','14:40:00',3.25),('15128','2014-03-08','14:45:00',3.1),('15128','2014-03-08','14:50:00',3.12),('15128','2014-03-08','14:55:00',3.08),('15128','2014-03-08','15:00:00',3.21),('15128','2014-03-08','15:05:00',3.33),('15128','2014-03-08','15:10:00',3.31),('15128','2014-03-08','15:15:00',3.09),('15128','2014-03-08','15:20:00',2.04),('15128','2014-03-08','15:50:00',2.26),('15128','2014-03-08','15:55:00',1.51),('15128','2014-03-08','16:10:00',1.39),('15128','2014-03-08','16:20:00',1.18),('15128','2014-03-08','16:25:00',1.63),('15128','2014-03-08','16:30:00',1.57),('15128','2014-03-08','16:35:00',1.42),('15128','2014-03-08','16:40:00',1.33),('15128','2014-03-08','16:45:00',1.26),('15128','2014-03-08','16:50:00',1.14),('15128','2014-03-08','16:55:00',1.04),('15128','2014-03-07','08:45:00',1.06),('15128','2014-03-07','08:50:00',1.17),('15128','2014-03-07','08:55:00',1.26),('15128','2014-03-07','09:00:00',1.32),('15128','2014-03-07','09:05:00',1.38),('15128','2014-03-07','09:10:00',1.43),('15128','2014-03-07','09:15:00',1.49),('15128','2014-03-07','09:20:00',1.56),('15128','2014-03-07','09:25:00',1.63),('15128','2014-03-07','09:30:00',1.68),('15128','2014-03-07','09:35:00',1.73),('15128','2014-03-07','09:40:00',1.78),('15128','2014-03-07','09:45:00',1.82),('15128','2014-03-07','09:50:00',1.87),('15128','2014-03-07','09:55:00',1.96),('15128','2014-03-07','10:00:00',1.97),('15128','2014-03-07','10:05:00',1.98),('15128','2014-03-07','10:10:00',2.11),('15128','2014-03-07','10:15:00',2.2),('15128','2014-03-07','10:20:00',2.25),('15128','2014-03-07','10:25:00',2.33),('15128','2014-03-07','10:30:00',2.38),('15128','2014-03-07','10:35:00',2.48),('15128','2014-03-07','10:40:00',2.41),('15128','2014-03-07','10:45:00',2.15),('15128','2014-03-07','10:50:00',2.72),('15128','2014-03-07','10:55:00',2.77),('15128','2014-03-07','11:00:00',2.78),('15128','2014-03-07','11:05:00',2.87),('15128','2014-03-07','11:10:00',3),('15128','2014-03-07','11:15:00',3.2),('15128','2014-03-07','11:20:00',3.27),('15128','2014-03-07','11:25:00',2.71),('15128','2014-03-07','11:30:00',3.6),('15128','2014-03-07','11:35:00',3.87),('15128','2014-03-07','11:40:00',2.44),('15128','2014-03-07','11:45:00',4.02),('15128','2014-03-07','11:50:00',4.36),('15128','2014-03-07','11:55:00',4.46),('15128','2014-03-07','12:00:00',4.42),('15128','2014-03-07','12:05:00',3.4),('15128','2014-03-07','12:10:00',3.83),('15128','2014-03-07','12:15:00',3.37),('15128','2014-03-07','12:20:00',2.35),('15128','2014-03-07','12:25:00',3.05),('15128','2014-03-07','12:30:00',2.84),('15128','2014-03-07','12:35:00',1.93),('15128','2014-03-07','12:40:00',1.91),('15128','2014-03-07','12:45:00',1.85),('15128','2014-03-07','12:50:00',1.81),('15128','2014-03-07','12:55:00',1.69),('15128','2014-03-07','13:00:00',1.94),('15128','2014-03-07','13:05:00',2.63),('15128','2014-03-07','13:10:00',1.84),('15128','2014-03-07','13:15:00',1.62),('15128','2014-03-07','13:20:00',1.42),('15128','2014-03-07','13:25:00',1.14),('15128','2014-03-07','13:30:00',1.09),('15128','2014-03-07','13:35:00',1.09),('15128','2014-03-07','13:40:00',1.3),('15128','2014-03-07','13:45:00',2.28),('15128','2014-03-07','13:50:00',1.83),('15128','2014-03-07','13:55:00',2.14),('15128','2014-03-07','14:00:00',1.59),('15128','2014-03-07','14:05:00',1.38),('15128','2014-03-07','14:10:00',1.08),('15128','2014-03-07','15:05:00',1.15),('15128','2014-03-07','15:10:00',1.03),('15128','2014-03-07','15:20:00',1.02),('15128','2014-03-07','15:25:00',1.54),('15128','2014-03-07','15:30:00',1.14),('15128','2014-03-07','16:45:00',1.45),('15128','2014-03-07','16:50:00',1.28),('15128','2014-03-07','16:55:00',1.13),('15128','2014-04-29','08:20:00',1),('15128','2014-04-29','08:25:00',1.07),('15128','2014-04-29','08:30:00',1.15),('15128','2014-04-29','08:35:00',1.19),('15128','2014-04-29','08:40:00',1.27),('15128','2014-04-29','08:45:00',1.34),('15128','2014-04-29','08:50:00',1.41),('15128','2014-04-29','08:55:00',1.44),('15128','2014-04-29','09:00:00',1.54),('15128','2014-04-29','09:05:00',1.6),('15128','2014-04-29','09:10:00',1.65),('15128','2014-04-29','09:15:00',1.72),('15128','2014-04-29','09:20:00',1.8),('15128','2014-04-29','09:25:00',1.87),('15128','2014-04-29','09:30:00',1.93),('15128','2014-04-29','09:35:00',1.8),('15128','2014-04-29','09:40:00',2.06),('15128','2014-04-29','09:45:00',2.02),('15128','2014-04-29','09:50:00',1.53),('15128','2014-04-29','09:55:00',2.38),('15128','2014-04-29','10:00:00',2.16),('15128','2014-04-29','10:05:00',2.4),('15128','2014-04-29','10:10:00',2.65),('15128','2014-04-29','10:15:00',2.11),('15128','2014-04-29','10:20:00',1.82),('15128','2014-04-29','10:25:00',2.63),('15128','2014-04-29','10:30:00',1.61),('15128','2014-04-29','10:35:00',1.34),('15128','2014-04-29','10:40:00',1.35),('15128','2014-04-29','10:45:00',2.72),('15128','2014-04-29','10:50:00',1.25),('15128','2014-04-29','10:55:00',1.99),('15128','2014-04-29','11:00:00',1.82),('15128','2014-04-29','11:05:00',1.58),('15128','2014-04-29','11:10:00',1.78),('15128','2014-04-29','11:15:00',2.09),('15128','2014-04-29','11:20:00',3.41),('15128','2014-04-29','11:25:00',3.66),('15128','2014-04-29','11:30:00',3.83),('15128','2014-04-29','11:35:00',3.1),('15128','2014-04-29','11:40:00',3.13),('15128','2014-04-29','11:45:00',3.17),('15128','2014-04-29','11:50:00',3.16),('15128','2014-04-29','11:55:00',2.26),('15128','2014-04-29','12:00:00',4.29),('15128','2014-04-29','12:05:00',2.01),('15128','2014-04-29','12:10:00',2.16),('15128','2014-04-29','12:15:00',3.51),('15128','2014-04-29','12:20:00',3.97),('15128','2014-04-29','12:25:00',3.27),('15128','2014-04-29','12:30:00',2.18),('15128','2014-04-29','12:35:00',3.57),('15128','2014-04-29','12:40:00',4.67),('15128','2014-04-29','12:45:00',4.01),('15128','2014-04-29','12:50:00',2.46),('15128','2014-04-29','12:55:00',3.49),('15128','2014-04-29','13:00:00',3.69),('15128','2014-04-29','13:05:00',1.04),('15128','2014-04-29','13:10:00',4.41),('15128','2014-04-29','13:15:00',2.15),('15128','2014-04-29','13:20:00',1.82),('15128','2014-04-29','13:25:00',3.01),('15128','2014-04-29','13:30:00',1.42),('15128','2014-04-29','13:35:00',2.25),('15128','2014-04-29','13:40:00',4.64),('15128','2014-04-29','13:45:00',2.12),('15128','2014-04-29','13:50:00',1.58),('15128','2014-04-29','13:55:00',2.04),('15128','2014-04-29','14:00:00',2.1),('15128','2014-04-29','14:05:00',1.93),('15128','2014-04-29','14:10:00',1.27),('15128','2014-04-29','14:15:00',1.61),('15128','2014-04-29','14:20:00',1.51),('15128','2014-04-29','14:25:00',1.78),('15128','2014-04-29','14:30:00',1.23),('15128','2014-04-29','14:35:00',1.42),('15128','2014-04-29','14:40:00',1.46),('15128','2014-04-29','14:45:00',1.86),('15128','2014-04-29','14:50:00',1.73),('15128','2014-04-29','14:55:00',1.52),('15128','2014-04-29','15:00:00',1.5),('15128','2014-04-29','15:05:00',1.76),('15128','2014-04-29','15:10:00',2.44),('15128','2014-04-29','15:15:00',1.22),('15128','2014-04-29','15:20:00',1.49),('15128','2014-04-29','15:25:00',2.18),('15128','2014-04-29','15:30:00',2.29),('15128','2014-04-29','15:35:00',3.71),('15128','2014-04-29','15:40:00',3.97),('15128','2014-04-29','15:45:00',4.3),('15128','2014-04-29','15:50:00',4.05),('15128','2014-04-29','15:55:00',2),('15128','2014-04-29','16:00:00',1.71),('15128','2014-04-29','16:05:00',2.77),('15128','2014-04-29','16:10:00',2.36),('15128','2014-04-29','16:15:00',4.15),('15128','2014-04-29','16:20:00',2.73),('15128','2014-04-29','16:25:00',1.83),('15128','2014-04-29','16:30:00',3.42),('15128','2014-04-29','16:35:00',3.54),('15128','2014-04-29','16:40:00',3.57),('15128','2014-04-29','16:45:00',2.71),('15128','2014-04-29','16:50:00',2.34),('15128','2014-04-29','16:55:00',2.16),('15128','2014-04-29','17:00:00',2.36),('15128','2014-04-29','17:10:00',2),('15128','2014-04-29','17:15:00',1.63),('15128','2014-04-29','17:25:00',1.06),('15128','2014-04-29','17:30:00',1.38),('15128','2014-04-29','17:35:00',1.37),('15128','2014-04-29','17:40:00',1.3),('15128','2014-03-06','10:15:00',1.11),('15128','2014-03-06','10:20:00',1.46),('15128','2014-03-06','10:25:00',2.76),('15128','2014-03-06','10:30:00',2.01),('15128','2014-03-06','10:35:00',1.42),('15128','2014-03-06','10:45:00',2.22),('15128','2014-03-06','10:50:00',3.47),('15128','2014-03-06','10:55:00',3.43),('15128','2014-03-06','11:00:00',1.97),('15128','2014-03-06','11:10:00',1.08),('15128','2014-03-06','11:15:00',1.26),('15128','2014-03-06','11:20:00',3.7),('15128','2014-03-06','11:25:00',2.6),('15128','2014-03-06','11:30:00',3.64),('15128','2014-03-06','11:35:00',4.06),('15128','2014-03-06','11:40:00',4.01),('15128','2014-03-06','11:45:00',4.06),('15128','2014-03-06','11:50:00',4.07),('15128','2014-03-06','11:55:00',3.94),('15128','2014-03-06','12:00:00',3.99),('15128','2014-03-06','12:05:00',4),('15128','2014-03-06','12:10:00',3.6),('15128','2014-03-06','12:15:00',3.59),('15128','2014-03-06','12:20:00',3.32),('15128','2014-03-06','12:25:00',3.32),('15128','2014-03-06','12:30:00',3.33),('15128','2014-03-06','12:35:00',3.63),('15128','2014-03-06','12:40:00',3.5),('15128','2014-03-06','12:45:00',3.7),('15128','2014-03-06','12:50:00',3.71),('15128','2014-03-06','12:55:00',3.86),('15128','2014-03-06','13:00:00',3.88),('15128','2014-03-06','13:05:00',3.64),('15128','2014-03-06','13:10:00',2.7),('15128','2014-03-06','13:15:00',3.19),('15128','2014-03-06','13:20:00',3.38),('15128','2014-03-06','13:25:00',1.93),('15128','2014-03-06','13:30:00',2.18),('15128','2014-03-06','13:35:00',2.09),('15128','2014-03-06','13:40:00',1.87),('15128','2014-03-06','13:45:00',2.09),('15128','2014-03-06','13:50:00',1.85),('15128','2014-03-06','13:55:00',1.54),('15128','2014-03-06','14:00:00',1.39),('15128','2014-03-06','14:05:00',1.33),('15128','2014-03-06','14:10:00',1.27),('15128','2014-03-06','14:15:00',1.23),('15128','2014-03-06','14:20:00',1.26),('15128','2014-03-06','14:25:00',1.29),('15128','2014-03-06','14:30:00',1.34),('15128','2014-03-06','14:35:00',1.41),('15128','2014-03-06','14:40:00',1.47),('15128','2014-03-06','14:45:00',1.69),('15128','2014-03-06','14:50:00',2.06),('15128','2014-03-06','14:55:00',2.27),('15128','2014-03-06','15:00:00',2.54),('15128','2014-03-06','15:05:00',2.8),('15128','2014-03-06','15:10:00',2.83),('15128','2014-03-06','15:15:00',2.82),('15128','2014-03-06','15:20:00',2.01),('15128','2014-03-06','15:25:00',1.67),('15128','2014-03-06','15:30:00',2.27),('15128','2014-03-06','15:35:00',1.52),('15128','2014-03-06','15:40:00',1.69),('15128','2014-03-06','15:45:00',2.43),('15128','2014-03-06','15:50:00',1.9),('15128','2014-03-06','15:55:00',1.12),('15128','2014-03-06','16:00:00',1.89),('15128','2014-03-06','16:05:00',2.02),('15128','2014-03-06','16:10:00',1.87),('15128','2014-03-06','16:15:00',1.12),('15128','2014-03-06','16:25:00',1.26),('15128','2014-03-06','16:35:00',1.44),('15128','2014-03-06','16:40:00',1.4),('15128','2014-03-06','16:45:00',1.31),('15128','2014-03-06','16:50:00',1.2),('15128','2014-03-06','16:55:00',1.06),('15128','2014-03-05','09:05:00',1.03),('15128','2014-03-05','09:10:00',1.19),('15128','2014-03-05','09:15:00',1.4),('15128','2014-03-05','09:20:00',1.91),('15128','2014-03-05','09:25:00',1.82),('15128','2014-03-05','09:30:00',1.65),('15128','2014-03-05','09:35:00',1.44),('15128','2014-03-05','09:40:00',1.29),('15128','2014-03-05','09:45:00',1.33),('15128','2014-03-05','09:50:00',1.46),('15128','2014-03-05','09:55:00',1.56),('15128','2014-03-05','10:00:00',1.68),('15128','2014-03-05','10:05:00',1.72),('15128','2014-03-05','10:10:00',1.8),('15128','2014-03-05','10:15:00',1.9),('15128','2014-03-05','10:20:00',1.73),('15128','2014-03-05','10:25:00',2.29),('15128','2014-03-05','10:30:00',2.26),('15128','2014-03-05','10:35:00',2.69),('15128','2014-03-05','10:40:00',2.3),('15128','2014-03-05','10:45:00',2.62),('15128','2014-03-05','10:50:00',2.71),('15128','2014-03-05','10:55:00',2.89),('15128','2014-03-05','11:00:00',2.9),('15128','2014-03-05','11:05:00',3.41),('15128','2014-03-05','11:10:00',3.08),('15128','2014-03-05','11:15:00',3.26),('15128','2014-03-05','11:20:00',3.34),('15128','2014-03-05','11:25:00',3.52),('15128','2014-03-05','11:30:00',2.26),('15128','2014-03-05','11:35:00',1.42),('15128','2014-03-05','11:40:00',1.68),('15128','2014-03-05','11:45:00',1.74),('15128','2014-03-05','11:50:00',1.88),('15128','2014-03-05','11:55:00',3.34),('15128','2014-03-05','12:00:00',1.93),('15128','2014-03-05','12:05:00',1.61),('15128','2014-03-05','12:10:00',1.36),('15128','2014-03-05','12:15:00',2.28),('15128','2014-03-05','12:20:00',1.53),('15128','2014-03-05','12:25:00',1.01),('15128','2014-03-05','12:30:00',1.01),('15128','2014-03-05','12:35:00',1.09),('15128','2014-03-05','12:40:00',2.83),('15128','2014-03-05','12:45:00',4.3),('15128','2014-03-05','12:50:00',1.9),('15128','2014-03-05','12:55:00',1.64),('15128','2014-03-05','13:00:00',2.04),('15128','2014-03-05','13:05:00',1.68),('15128','2014-03-05','13:10:00',1.44),('15128','2014-03-05','13:15:00',1.48),('15128','2014-03-05','13:20:00',1.3),('15128','2014-03-05','13:25:00',1.69),('15128','2014-03-05','13:30:00',1.22),('15128','2014-03-05','13:35:00',1.14),('15128','2014-03-05','13:45:00',1.13),('15128','2014-03-05','13:50:00',1.32),('15128','2014-03-05','13:55:00',1.31),('15128','2014-03-05','14:00:00',1.34),('15128','2014-03-05','14:05:00',1.34),('15128','2014-03-05','14:10:00',1.28),('15128','2014-03-05','14:15:00',1.24),('15128','2014-03-05','14:20:00',1.33),('15128','2014-03-05','14:25:00',1.18),('15128','2014-03-05','14:30:00',1.37),('15128','2014-03-05','14:35:00',1.16),('15128','2014-03-05','14:55:00',1.09),('15128','2014-03-05','15:00:00',1.9),('15128','2014-03-05','15:05:00',1.17),('15128','2014-03-05','15:10:00',1.28),('15128','2014-03-05','15:15:00',1.29),('15128','2014-03-05','15:20:00',1.01),('15128','2014-03-05','15:25:00',1.02),('15128','2014-03-05','15:50:00',1.4),('15128','2014-03-05','17:00:00',1.01),('15128','2014-03-04','08:35:00',1),('15128','2014-03-04','08:40:00',1.33),('15128','2014-03-04','08:45:00',1.32),('15128','2014-03-04','08:50:00',1.31),('15128','2014-03-04','08:55:00',1.32),('15128','2014-03-04','09:00:00',1.38),('15128','2014-03-04','09:05:00',1.4),('15128','2014-03-04','09:10:00',1.44),('15128','2014-03-04','09:15:00',1.42),('15128','2014-03-04','09:20:00',1.34),('15128','2014-03-04','09:25:00',1.57),('15128','2014-03-04','09:30:00',1.66),('15128','2014-03-04','09:35:00',1.69),('15128','2014-03-04','09:40:00',1.76),('15128','2014-03-04','09:45:00',1.85),('15128','2014-03-04','09:50:00',1.88),('15128','2014-03-04','09:55:00',1.88),('15128','2014-03-04','10:00:00',1.97),('15128','2014-03-04','10:05:00',2.02),('15128','2014-03-04','10:10:00',2.09),('15128','2014-03-04','10:15:00',2.13),('15128','2014-03-04','10:20:00',2.21),('15128','2014-03-04','10:25:00',2.25),('15128','2014-03-04','10:30:00',2.37),('15128','2014-03-04','10:35:00',2.4),('15128','2014-03-04','10:40:00',2.48),('15128','2014-03-04','10:45:00',2.45),('15128','2014-03-04','10:50:00',2.6),('15128','2014-03-04','10:55:00',2.66),('15128','2014-03-04','11:00:00',2.67),('15128','2014-03-04','11:05:00',2.75),('15128','2014-03-04','11:10:00',2.86),('15128','2014-03-04','11:15:00',3.06),('15128','2014-03-04','11:20:00',3.14),('15128','2014-03-04','11:25:00',3.26),('15128','2014-03-04','11:30:00',3.31),('15128','2014-03-04','11:35:00',2.81),('15128','2014-03-04','11:40:00',3.66),('15128','2014-03-04','11:45:00',3.76),('15128','2014-03-04','11:50:00',3.63),('15128','2014-03-04','11:55:00',3.45),('15128','2014-03-04','12:00:00',2.93),('15128','2014-03-04','12:05:00',2.5),('15128','2014-03-04','12:10:00',1.48),('15128','2014-03-04','12:15:00',3.62),('15128','2014-03-04','12:20:00',3.73),('15128','2014-03-04','12:25:00',3.55),('15128','2014-03-04','12:30:00',3.54),('15128','2014-03-04','12:35:00',3.49),('15128','2014-03-04','12:40:00',3.82),('15128','2014-03-04','12:45:00',3.6),('15128','2014-03-04','12:50:00',1.61),('15128','2014-03-04','12:55:00',1.37),('15128','2014-03-04','13:00:00',2.44),('15128','2014-03-04','13:05:00',1.41),('15128','2014-03-04','13:10:00',2.81),('15128','2014-03-04','13:15:00',3.96),('15128','2014-03-04','13:20:00',3.63),('15128','2014-03-04','13:25:00',3.74),('15128','2014-03-04','13:30:00',4),('15128','2014-03-04','13:35:00',4.59),('15128','2014-03-04','13:40:00',4.15),('15128','2014-03-04','13:45:00',3.91),('15128','2014-03-04','13:50:00',2.66),('15128','2014-03-04','13:55:00',1.25),('15128','2014-03-04','14:00:00',1.17),('15128','2014-03-04','14:05:00',1.33),('15128','2014-03-04','14:10:00',2.95),('15128','2014-03-04','14:15:00',1.5),('15128','2014-03-04','14:20:00',1.76),('15128','2014-03-04','14:25:00',1.57),('15128','2014-03-04','14:30:00',1.58),('15128','2014-03-04','14:35:00',1.96),('15128','2014-03-04','14:40:00',2.72),('15128','2014-03-04','14:45:00',2.78),('15128','2014-03-04','14:50:00',3.47),('15128','2014-03-04','14:55:00',1.69),('15128','2014-03-04','15:00:00',1.13),('15128','2014-03-04','15:30:00',1.05),('15128','2014-03-04','15:35:00',1.45),('15128','2014-03-04','15:40:00',1.12),('15128','2014-03-04','15:45:00',1.15),('15128','2014-03-04','15:50:00',2.18),('15128','2014-03-04','15:55:00',3.12),('15128','2014-03-04','16:00:00',2.03),('15128','2014-03-04','16:05:00',1.27),('15128','2014-03-03','09:05:00',1.45),('15128','2014-03-03','09:10:00',1.31),('15128','2014-03-03','09:55:00',1.48),('15128','2014-03-03','10:00:00',1.98),('15128','2014-03-03','10:05:00',2.4),('15128','2014-03-03','10:30:00',1.16),('15128','2014-03-03','10:35:00',1.21),('15128','2014-03-03','10:40:00',1.28),('15128','2014-03-03','10:45:00',1.58),('15128','2014-03-03','10:50:00',3.5),('15128','2014-03-03','10:55:00',2.77),('15128','2014-03-03','11:00:00',1.74),('15128','2014-03-03','11:25:00',2.24),('15128','2014-03-03','11:30:00',4.23),('15128','2014-03-03','11:45:00',2.66),('15128','2014-03-03','11:50:00',3.72),('15128','2014-03-03','11:55:00',1.48),('15128','2014-03-03','12:00:00',2.98),('15128','2014-03-03','12:05:00',3.27),('15128','2014-03-03','12:10:00',3.63),('15128','2014-03-03','12:15:00',3.36),('15128','2014-03-03','12:20:00',2.56),('15128','2014-03-03','12:25:00',3.15),('15128','2014-03-03','12:30:00',3.56),('15128','2014-03-03','12:35:00',3.54),('15128','2014-03-03','12:40:00',3.54),('15128','2014-03-03','12:45:00',3.24),('15128','2014-03-03','12:50:00',3.56),('15128','2014-03-03','12:55:00',3.38),('15128','2014-03-03','13:00:00',3.69),('15128','2014-03-03','13:05:00',3.47),('15128','2014-03-03','13:10:00',3.4),('15128','2014-03-03','13:15:00',2.32),('15128','2014-03-03','13:45:00',1.18),('15128','2014-03-03','13:50:00',3.29),('15128','2014-03-03','13:55:00',2.97),('15128','2014-03-03','14:00:00',3.45),('15128','2014-03-03','14:05:00',3.09),('15128','2014-03-03','14:10:00',3.76),('15128','2014-03-03','14:15:00',3.56),('15128','2014-03-03','14:20:00',2.69),('15128','2014-03-03','14:25:00',2.82),('15128','2014-03-03','14:30:00',3.51),('15128','2014-03-03','14:35:00',3.33),('15128','2014-03-03','14:40:00',3.29),('15128','2014-03-03','14:45:00',3.12),('15128','2014-03-03','14:50:00',3.13),('15128','2014-03-03','14:55:00',2.7),('15128','2014-03-03','15:00:00',3),('15128','2014-03-03','15:05:00',2.91),('15128','2014-03-03','15:10:00',2.88),('15128','2014-03-03','15:15:00',2.82),('15128','2014-03-03','15:20:00',2.79),('15128','2014-03-03','15:25:00',2.85),('15128','2014-03-03','15:30:00',2.22),('15128','2014-03-03','15:35:00',1.4),('15128','2014-03-03','15:40:00',1.79),('15128','2014-03-03','15:45:00',1.9),('15128','2014-03-03','16:00:00',1.19),('15128','2014-03-03','16:05:00',1.05),('15128','2014-03-03','16:25:00',1.89),('15128','2014-03-03','16:30:00',1.64),('15128','2014-03-03','16:35:00',1.34),('15128','2014-03-03','16:40:00',1.33),('15128','2014-03-03','16:45:00',1.28),('15128','2014-03-03','16:50:00',1.16),('15128','2014-03-02','08:50:00',1.09),('15128','2014-03-02','08:55:00',1.08),('15128','2014-03-02','09:00:00',1.1),('15128','2014-03-02','09:05:00',1.24),('15128','2014-03-02','09:10:00',1.43),('15128','2014-03-02','09:15:00',1.47),('15128','2014-03-02','09:20:00',1.51),('15128','2014-03-02','09:25:00',1.5),('15128','2014-03-02','09:30:00',1.56),('15128','2014-03-02','09:35:00',1.64),('15128','2014-03-02','09:40:00',1.64),('15128','2014-03-02','09:45:00',1.69),('15128','2014-03-02','09:50:00',1.77),('15128','2014-03-02','09:55:00',1.86),('15128','2014-03-02','10:00:00',1.92),('15128','2014-03-02','10:05:00',1.99),('15128','2014-03-02','10:10:00',2.05),('15128','2014-03-02','10:15:00',2.08),('15128','2014-03-02','10:20:00',2.14),('15128','2014-03-02','10:25:00',2.19),('15128','2014-03-02','10:30:00',2.24),('15128','2014-03-02','10:35:00',2.34),('15128','2014-03-02','10:40:00',2.41),('15128','2014-03-02','10:45:00',2.45),('15128','2014-03-02','10:50:00',2.47),('15128','2014-03-02','10:55:00',2.43),('15128','2014-03-02','11:00:00',2.56),('15128','2014-03-02','11:05:00',2.63),('15128','2014-03-02','11:10:00',2.62),('15128','2014-03-02','11:15:00',2.77),('15128','2014-03-02','11:20:00',2.89),('15128','2014-03-02','11:25:00',3.02),('15128','2014-03-02','11:30:00',3.08),('15128','2014-03-02','11:35:00',3.16),('15128','2014-03-02','11:40:00',3.2),('15128','2014-03-02','11:45:00',3.25),('15128','2014-03-02','11:50:00',3.31),('15128','2014-03-02','11:55:00',3.33),('15128','2014-03-02','12:00:00',3.38),('15128','2014-03-02','12:05:00',3.41),('15128','2014-03-02','12:10:00',3.43),('15128','2014-03-02','12:15:00',3.47),('15128','2014-03-02','12:20:00',3.5),('15128','2014-03-02','12:25:00',3.51),('15128','2014-03-02','12:30:00',3.52),('15128','2014-03-02','12:35:00',3.54),('15128','2014-03-02','12:40:00',3.55),('15128','2014-03-02','12:45:00',3.56),('15128','2014-03-02','12:50:00',3.55),('15128','2014-03-02','12:55:00',3.53),('15128','2014-03-02','13:00:00',3.54),('15128','2014-03-02','13:05:00',3.54),('15128','2014-03-02','13:10:00',3.55),('15128','2014-03-02','13:15:00',3.55),('15128','2014-03-02','13:20:00',3.54),('15128','2014-03-02','13:25:00',3.54),('15128','2014-03-02','13:30:00',3.52),('15128','2014-03-02','13:35:00',3.22),('15128','2014-03-02','13:40:00',3.54),('15128','2014-03-02','13:45:00',2.43),('15128','2014-03-02','13:50:00',3.49),('15128','2014-03-02','13:55:00',3.05),('15128','2014-03-02','14:00:00',3.43),('15128','2014-03-02','14:05:00',3.41),('15128','2014-03-02','14:10:00',3.39),('15128','2014-03-02','14:15:00',3.36),('15128','2014-03-02','14:20:00',3.35),('15128','2014-03-02','14:25:00',3.3),('15128','2014-03-02','14:30:00',3.22),('15128','2014-03-02','14:35:00',3.2),('15128','2014-03-02','14:40:00',3.14),('15128','2014-03-02','14:45:00',3.09),('15128','2014-03-02','14:50:00',3),('15128','2014-03-02','14:55:00',2.99),('15128','2014-03-02','15:00:00',2.59),('15128','2014-03-02','15:05:00',2.92),('15128','2014-03-02','15:10:00',2.8),('15128','2014-03-02','15:15:00',2.78),('15128','2014-03-02','15:20:00',2.55),('15128','2014-03-02','15:25:00',2.26),('15128','2014-03-02','15:30:00',2.62),('15128','2014-03-02','15:35:00',2.58),('15128','2014-03-02','15:40:00',2.48),('15128','2014-03-02','15:45:00',2.24),('15128','2014-03-02','15:50:00',2.28),('15128','2014-03-02','15:55:00',2.06),('15128','2014-03-02','16:00:00',1.98),('15128','2014-03-02','16:05:00',1.9),('15128','2014-03-02','16:10:00',1.82),('15128','2014-03-02','16:15:00',1.74),('15128','2014-03-02','16:20:00',1.67),('15128','2014-03-02','16:25:00',1.58),('15128','2014-03-02','16:30:00',1.53),('15128','2014-03-02','16:35:00',1.47),('15128','2014-03-02','16:40:00',1.35),('15128','2014-03-02','16:45:00',1.22),('15128','2014-03-02','16:50:00',1.13),('15128','2014-03-02','16:55:00',1.03),('15128','2014-03-01','08:50:00',1.08),('15128','2014-03-01','08:55:00',1.18),('15128','2014-03-01','09:00:00',1.31),('15128','2014-03-01','09:05:00',1.44),('15128','2014-03-01','09:10:00',1.55),('15128','2014-03-01','09:15:00',1.46),('15128','2014-03-01','09:20:00',1.72),('15128','2014-03-01','09:25:00',1.65),('15128','2014-03-01','09:30:00',2.54),('15128','2014-03-01','09:35:00',2.36),('15128','2014-03-01','09:40:00',2.17),('15128','2014-03-01','10:15:00',1.3),('15128','2014-03-01','10:20:00',1.48),('15128','2014-03-01','10:25:00',1.68),('15128','2014-03-01','10:30:00',2.47),('15128','2014-03-01','10:35:00',3.45),('15128','2014-03-01','10:40:00',3.46),('15128','2014-03-01','10:45:00',2.3),('15128','2014-03-01','10:50:00',3.06),('15128','2014-03-01','10:55:00',1.87),('15128','2014-03-01','11:00:00',1.15),('15128','2014-03-01','11:05:00',1.33),('15128','2014-03-01','11:10:00',1.41),('15128','2014-03-01','11:15:00',1.48),('15128','2014-03-01','11:20:00',1.78),('15128','2014-03-01','11:25:00',1.63),('15128','2014-03-01','11:30:00',1.71),('15128','2014-03-01','11:35:00',2.68),('15128','2014-03-01','11:40:00',2.74),('15128','2014-03-01','11:45:00',1.99),('15128','2014-03-01','11:50:00',2.55),('15128','2014-03-01','11:55:00',3.34),('15128','2014-03-01','12:00:00',3.33),('15128','2014-03-01','12:05:00',3.37),('15128','2014-03-01','12:10:00',2.6),('15128','2014-03-01','12:15:00',2.9),('15128','2014-03-01','12:20:00',1.46),('15128','2014-03-01','12:25:00',1.01),('15128','2014-03-01','13:35:00',1.05),('15128','2014-03-01','13:45:00',1),('15128','2014-03-01','13:50:00',1.11),('15128','2014-03-01','13:55:00',1.05),('15128','2014-03-01','14:55:00',1.03),('15128','2014-03-01','15:00:00',1.14),('15128','2014-03-01','15:05:00',1.2),('15128','2014-03-01','15:10:00',1.23),('15128','2014-03-01','15:15:00',1.24),('15128','2014-03-01','15:20:00',1.26),('15128','2014-03-01','15:25:00',1.25),('15128','2014-03-01','15:30:00',1.3),('15128','2014-03-01','15:35:00',1.41),('15128','2014-03-01','15:40:00',1.48),('15128','2014-03-01','15:45:00',1.5),('15128','2014-03-01','15:50:00',1.53),('15128','2014-03-01','15:55:00',1.55),('15128','2014-03-01','16:00:00',1.39),('15128','2014-03-01','16:05:00',1.24),('15128','2014-03-01','16:10:00',1),('15128','2014-02-27','09:15:00',1.12),('15128','2014-02-27','09:20:00',1.24),('15128','2014-02-27','09:25:00',1.07),('15128','2014-02-27','09:30:00',1.69),('15128','2014-02-27','09:35:00',1.94),('15128','2014-02-27','09:40:00',1.95),('15128','2014-02-27','09:45:00',1.15),('15128','2014-02-27','09:50:00',1.86),('15128','2014-02-27','09:55:00',1.18),('15128','2014-02-27','10:00:00',1.01),('15128','2014-02-27','10:15:00',1.53),('15128','2014-02-27','10:20:00',1.58),('15128','2014-02-27','10:25:00',2.24),('15128','2014-02-27','10:30:00',2.18),('15128','2014-02-27','10:35:00',1.23),('15128','2014-02-27','10:40:00',1.36),('15128','2014-02-27','10:45:00',1.21),('15128','2014-02-27','10:50:00',1.2),('15128','2014-02-27','10:55:00',1.02),('15128','2014-02-27','11:00:00',1.14),('15128','2014-02-27','11:05:00',1.25),('15128','2014-02-27','11:10:00',1.22),('15128','2014-02-27','11:15:00',1.35),('15128','2014-02-27','11:20:00',1.17),('15128','2014-02-27','11:50:00',1.07),('15128','2014-02-27','11:55:00',1.29),('15128','2014-02-27','12:20:00',1.49),('15128','2014-02-27','12:25:00',4.23),('15128','2014-02-27','12:30:00',3.74),('15128','2014-02-27','12:35:00',4.47),('15128','2014-02-27','12:40:00',2.52),('15128','2014-02-27','12:45:00',1.55),('15128','2014-02-27','12:50:00',1.29),('15128','2014-02-27','12:55:00',1.72),('15128','2014-02-27','13:00:00',1.02),('15128','2014-02-27','13:40:00',1.2),('15128','2014-02-27','13:45:00',1.28),('15128','2014-02-27','13:50:00',1.21),('15128','2014-02-27','13:55:00',1.13),('15128','2014-02-27','14:15:00',2.69),('15128','2014-02-27','14:20:00',1.95),('15128','2014-02-27','14:25:00',1.04),('15128','2014-02-27','15:30:00',1.69),('15128','2014-02-27','15:35:00',2.87),('15128','2014-02-27','15:40:00',1.09),('15128','2014-02-26','10:30:00',1.03),('15128','2014-02-26','10:35:00',1.18),('15128','2014-02-26','10:40:00',1.34),('15128','2014-02-26','10:45:00',1.34),('15128','2014-02-26','10:50:00',1.24),('15128','2014-02-26','10:55:00',1.27),('15128','2014-02-26','11:00:00',1.29),('15128','2014-02-26','11:05:00',1.36),('15128','2014-02-26','11:10:00',1.33),('15128','2014-02-26','11:15:00',1.35),('15128','2014-02-26','11:20:00',1.37),('15128','2014-02-26','11:25:00',1.51),('15128','2014-02-26','11:30:00',1.44),('15128','2014-02-26','11:35:00',1.31),('15128','2014-02-26','11:40:00',1.25),('15128','2014-02-26','11:45:00',1.21),('15128','2014-02-26','11:50:00',1.2),('15128','2014-02-26','11:55:00',1.14),('15128','2014-02-26','12:00:00',1.3),('15128','2014-02-26','12:05:00',1.39),('15128','2014-02-26','12:10:00',1.43),('15128','2014-02-26','12:15:00',1.44),('15128','2014-02-26','12:20:00',1.41),('15128','2014-02-26','12:25:00',1.39),('15128','2014-02-26','12:30:00',1.38),('15128','2014-02-26','12:35:00',1.36),('15128','2014-02-26','12:40:00',1.37),('15128','2014-02-26','12:45:00',1.38),('15128','2014-02-26','12:50:00',1.33),('15128','2014-02-26','12:55:00',1.33),('15128','2014-02-26','13:00:00',1.34),('15128','2014-02-26','13:05:00',1.28),('15128','2014-02-26','13:10:00',1.3),('15128','2014-02-26','13:15:00',1.44),('15128','2014-02-26','13:20:00',1.55),('15128','2014-02-26','13:25:00',1.63),('15128','2014-02-26','13:30:00',1.68),('15128','2014-02-26','13:35:00',1.74),('15128','2014-02-26','13:40:00',1.66),('15128','2014-02-26','13:45:00',1.64),('15128','2014-02-26','13:50:00',1.85),('15128','2014-02-26','13:55:00',1.7),('15128','2014-02-26','14:00:00',1.5),('15128','2014-02-26','14:05:00',1.69),('15128','2014-02-26','14:10:00',1.49),('15128','2014-02-26','14:15:00',1.46),('15128','2014-02-26','14:20:00',1.44),('15128','2014-02-26','14:25:00',1.19),('15128','2014-02-26','14:30:00',1.04),('15128','2014-02-26','14:35:00',1.17),('15128','2014-02-26','14:40:00',1.55),('15128','2014-02-26','14:45:00',1.66),('15128','2014-02-26','14:50:00',1.53),('15128','2014-02-26','14:55:00',1.59),('15128','2014-02-26','15:00:00',1.4),('15128','2014-02-26','15:05:00',1.68),('15128','2014-02-26','15:10:00',2.03),('15128','2014-02-26','15:15:00',1.77),('15128','2014-02-26','15:20:00',1.43),('15128','2014-02-26','15:25:00',1.25),('15128','2014-02-26','15:30:00',1.07),('15128','2014-02-26','16:40:00',1.4),('15128','2014-02-26','16:45:00',1.19),('15128','2014-02-26','16:50:00',1.18),('15128','2014-02-25','08:55:00',1.02),('15128','2014-02-25','09:00:00',1.17),('15128','2014-02-25','09:05:00',1.19),('15128','2014-02-25','09:10:00',1.26),('15128','2014-02-25','09:15:00',1.36),('15128','2014-02-25','09:20:00',1.27),('15128','2014-02-25','09:30:00',1.52),('15128','2014-02-25','09:35:00',1.56),('15128','2014-02-25','09:40:00',1.49),('15128','2014-02-25','09:45:00',1.34),('15128','2014-02-25','09:50:00',1.51),('15128','2014-02-25','09:55:00',1.74),('15128','2014-02-25','10:00:00',1.24),('15128','2014-02-25','10:05:00',1.1),('15128','2014-02-25','12:25:00',1.82),('15128','2014-02-25','12:30:00',1.56),('15128','2014-02-25','12:35:00',1.67),('15128','2014-02-25','12:40:00',1.71),('15128','2014-02-25','12:45:00',2.14),('15128','2014-02-25','12:50:00',2.7),('15128','2014-02-25','12:55:00',1.99),('15128','2014-02-25','13:00:00',2.68),('15128','2014-02-25','13:05:00',2.03),('15128','2014-02-25','13:10:00',2.99),('15128','2014-02-25','13:15:00',2.76),('15128','2014-02-25','13:20:00',3.37),('15128','2014-02-25','13:25:00',3.59),('15128','2014-02-25','13:30:00',3.13),('15128','2014-02-25','13:35:00',1.82),('15128','2014-02-25','13:40:00',3.22),('15128','2014-02-25','13:45:00',3.79),('15128','2014-02-25','13:50:00',3.53),('15128','2014-02-25','13:55:00',3.69),('15128','2014-02-25','14:00:00',2.7),('15128','2014-02-25','14:05:00',2.41),('15128','2014-02-25','14:10:00',1.38),('15128','2014-02-25','14:15:00',1.26),('15128','2014-02-25','14:30:00',1.59),('15128','2014-02-25','14:35:00',2.15),('15128','2014-02-25','14:40:00',1.1),('15128','2014-02-25','14:45:00',1.71),('15128','2014-02-25','14:50:00',1.84),('15128','2014-02-25','14:55:00',3.23),('15128','2014-02-25','15:00:00',3.02),('15128','2014-02-25','15:05:00',2.84),('15128','2014-02-25','15:10:00',2.41),('15128','2014-02-25','15:15:00',1.95),('15128','2014-02-25','15:20:00',1.46),('15128','2014-02-25','15:25:00',1.48),('15128','2014-02-25','15:30:00',2.19),('15128','2014-02-25','15:35:00',1.85),('15128','2014-02-25','15:40:00',1.77),('15128','2014-02-25','15:45:00',1.84),('15128','2014-02-25','15:50:00',2.14),('15128','2014-02-25','15:55:00',1.8),('15128','2014-02-25','16:00:00',1.6),('15128','2014-02-25','16:05:00',1.3),('15128','2014-02-25','16:10:00',1.28),('15128','2014-02-25','16:15:00',1.38),('15128','2014-02-25','16:20:00',1.05),('15128','2014-04-28','09:50:00',1.33),('15128','2014-04-28','09:55:00',2.09),('15128','2014-04-28','10:00:00',2.56),('15128','2014-04-28','10:05:00',2.7),('15128','2014-04-28','10:10:00',2.3),('15128','2014-04-28','10:15:00',2.83),('15128','2014-04-28','10:20:00',2.92),('15128','2014-04-28','10:25:00',2.52),('15128','2014-04-28','10:30:00',2.91),('15128','2014-04-28','10:35:00',3),('15128','2014-04-28','10:40:00',3),('15128','2014-04-28','10:45:00',3.01),('15128','2014-04-28','10:50:00',3.14),('15128','2014-04-28','10:55:00',3.1),('15128','2014-04-28','11:00:00',3.15),('15128','2014-04-28','11:05:00',3.19),('15128','2014-04-28','11:10:00',3.28),('15128','2014-04-28','11:15:00',3.31),('15128','2014-04-28','11:20:00',3.43),('15128','2014-04-28','11:25:00',2.95),('15128','2014-04-28','11:30:00',2.85),('15128','2014-04-28','11:35:00',1.22),('15128','2014-04-28','11:40:00',1.11),('15128','2014-04-28','11:45:00',1.12),('15128','2014-04-28','11:50:00',1.27),('15128','2014-04-28','11:55:00',1.09),('15128','2014-04-28','12:05:00',1.26),('15128','2014-04-28','12:10:00',1.35),('15128','2014-04-28','12:15:00',2.03),('15128','2014-04-28','12:20:00',2.7),('15128','2014-04-28','12:25:00',2.57),('15128','2014-04-28','12:30:00',1.32),('15128','2014-04-28','12:35:00',1.32),('15128','2014-04-28','12:40:00',1.59),('15128','2014-04-28','12:45:00',3.74),('15128','2014-04-28','12:50:00',5.09),('15128','2014-04-28','12:55:00',5.22),('15128','2014-04-28','13:00:00',4.12),('15128','2014-04-28','13:05:00',5.1),('15128','2014-04-28','13:10:00',1.63),('15128','2014-04-28','13:15:00',4.55),('15128','2014-04-28','13:20:00',4.77),('15128','2014-04-28','13:25:00',1.43),('15128','2014-04-28','13:30:00',1.83),('15128','2014-04-28','13:35:00',1.69),('15128','2014-04-28','13:40:00',1.51),('15128','2014-04-28','13:45:00',1.75),('15128','2014-04-28','13:50:00',1.53),('15128','2014-04-28','13:55:00',1.64),('15128','2014-04-28','14:00:00',2.25),('15128','2014-04-28','14:05:00',2.36),('15128','2014-04-28','14:10:00',1.67),('15128','2014-04-28','14:15:00',1.48),('15128','2014-04-28','14:20:00',1.45),('15128','2014-04-28','14:25:00',1.36),('15128','2014-04-28','14:30:00',1.68),('15128','2014-04-28','14:35:00',2),('15128','2014-04-28','14:40:00',1.58),('15128','2014-04-28','14:45:00',1.8),('15128','2014-04-28','14:50:00',2.63),('15128','2014-04-28','14:55:00',2.71),('15128','2014-04-28','15:00:00',2.77),('15128','2014-04-28','15:05:00',1.85),('15128','2014-04-28','15:10:00',1.59),('15128','2014-04-28','15:15:00',1.81),('15128','2014-04-28','15:20:00',1.18),('15128','2014-04-28','15:25:00',1.02),('15128','2014-04-28','15:30:00',1.05),('15128','2014-04-28','15:45:00',1.03),('15128','2014-04-28','15:50:00',1.11),('15128','2014-04-28','15:55:00',1.03),('15128','2014-04-28','17:05:00',1.02),('15128','2014-04-28','17:10:00',2.81),('15128','2014-04-28','17:15:00',2.16),('15128','2014-04-28','17:20:00',1.63),('15128','2014-04-28','17:25:00',3.12),('15128','2014-04-28','17:30:00',1.44),('15128','2014-04-28','18:55:00',1.02),('15128','2014-02-24','09:00:00',1.04),('15128','2014-02-24','09:05:00',1.13),('15128','2014-02-24','09:10:00',1.19),('15128','2014-02-24','09:15:00',1.25),('15128','2014-02-24','09:20:00',1.32),('15128','2014-02-24','09:25:00',1.38),('15128','2014-02-24','09:30:00',1.43),('15128','2014-02-24','09:35:00',1.5),('15128','2014-02-24','09:40:00',1.53),('15128','2014-02-24','09:45:00',1.59),('15128','2014-02-24','09:50:00',1.63),('15128','2014-02-24','09:55:00',1.69),('15128','2014-02-24','10:00:00',1.75),('15128','2014-02-24','10:05:00',1.8),('15128','2014-02-24','10:10:00',1.87),('15128','2014-02-24','10:15:00',1.93),('15128','2014-02-24','10:20:00',1.97),('15128','2014-02-24','10:25:00',2.03),('15128','2014-02-24','10:30:00',2.08),('15128','2014-02-24','10:35:00',2.12),('15128','2014-02-24','10:40:00',2.17),('15128','2014-02-24','10:45:00',2.24),('15128','2014-02-24','10:50:00',2.31),('15128','2014-02-24','10:55:00',2.36),('15128','2014-02-24','11:00:00',2.41),('15128','2014-02-24','11:05:00',2.4),('15128','2014-02-24','11:10:00',2.46),('15128','2014-02-24','11:15:00',2.53),('15128','2014-02-24','11:20:00',2.7),('15128','2014-02-24','11:25:00',2.8),('15128','2014-02-24','11:30:00',2.84),('15128','2014-02-24','11:35:00',2.87),('15128','2014-02-24','11:40:00',2.91),('15128','2014-02-24','11:45:00',2.95),('15128','2014-02-24','11:50:00',2.96),('15128','2014-02-24','11:55:00',3),('15128','2014-02-24','12:00:00',3.11),('15128','2014-02-24','12:05:00',3.15),('15128','2014-02-24','12:10:00',3.17),('15128','2014-02-24','12:15:00',3.18),('15128','2014-02-24','12:20:00',3.2),('15128','2014-02-24','12:25:00',3.23),('15128','2014-02-24','12:30:00',3.22),('15128','2014-02-24','12:35:00',3.23),('15128','2014-02-24','12:40:00',3.24),('15128','2014-02-24','12:45:00',3.24),('15128','2014-02-24','12:50:00',3.29),('15128','2014-02-24','12:55:00',3.23),('15128','2014-02-24','13:00:00',3.21),('15128','2014-02-24','13:05:00',3.25),('15128','2014-02-24','13:10:00',3.23),('15128','2014-02-24','13:15:00',3.26),('15128','2014-02-24','13:20:00',3.25),('15128','2014-02-24','13:25:00',3.28),('15128','2014-02-24','13:30:00',3.29),('15128','2014-02-24','13:35:00',3.24),('15128','2014-02-24','13:40:00',3.1),('15128','2014-02-24','13:45:00',3.13),('15128','2014-02-24','13:50:00',2.98),('15128','2014-02-24','13:55:00',2.66),('15128','2014-02-24','14:00:00',2.73),('15128','2014-02-24','14:05:00',2.67),('15128','2014-02-24','14:10:00',2.7),('15128','2014-02-24','14:15:00',3),('15128','2014-02-24','14:20:00',2.91),('15128','2014-02-24','14:25:00',2.75),('15128','2014-02-24','14:30:00',2.41),('15128','2014-02-24','14:35:00',2.65),('15128','2014-02-24','14:40:00',2.64),('15128','2014-02-24','14:45:00',2.54),('15128','2014-02-24','14:50:00',2.52),('15128','2014-02-24','14:55:00',2.61),('15128','2014-02-24','15:00:00',2.57),('15128','2014-02-24','15:05:00',2.53),('15128','2014-02-24','15:10:00',2.48),('15128','2014-02-24','15:15:00',2.29),('15128','2014-02-24','15:20:00',2.33),('15128','2014-02-24','15:25:00',2.19),('15128','2014-02-24','15:30:00',2.19),('15128','2014-02-24','15:35:00',1.68),('15128','2014-02-24','15:45:00',1.15),('15128','2014-02-24','15:50:00',1.46),('15128','2014-02-24','15:55:00',1.35),('15128','2014-02-24','16:00:00',1.27),('15128','2014-02-24','16:05:00',1.27),('15128','2014-02-24','16:15:00',1),('15128','2014-02-24','16:20:00',1.1),('15128','2014-02-23','09:00:00',1.05),('15128','2014-02-23','09:05:00',1.11),('15128','2014-02-23','09:10:00',1.18),('15128','2014-02-23','09:15:00',1.24),('15128','2014-02-23','09:20:00',1.32),('15128','2014-02-23','09:25:00',1.38),('15128','2014-02-23','09:30:00',1.44),('15128','2014-02-23','09:35:00',1.5),('15128','2014-02-23','09:40:00',1.55),('15128','2014-02-23','09:45:00',1.6),('15128','2014-02-23','09:50:00',1.64),('15128','2014-02-23','09:55:00',1.72),('15128','2014-02-23','10:00:00',1.77),('15128','2014-02-23','10:05:00',1.82),('15128','2014-02-23','10:10:00',1.87),('15128','2014-02-23','10:15:00',1.93),('15128','2014-02-23','10:20:00',1.99),('15128','2014-02-23','10:25:00',2.07),('15128','2014-02-23','10:30:00',2.08),('15128','2014-02-23','10:35:00',2.1),('15128','2014-02-23','10:40:00',2.22),('15128','2014-02-23','10:45:00',2.3),('15128','2014-02-23','10:50:00',2.32),('15128','2014-02-23','10:55:00',2.38),('15128','2014-02-23','11:00:00',2.45),('15128','2014-02-23','11:05:00',2.43),('15128','2014-02-23','11:10:00',2.58),('15128','2014-02-23','11:15:00',2.69),('15128','2014-02-23','11:20:00',2.94),('15128','2014-02-23','11:25:00',2.12),('15128','2014-02-23','11:30:00',2.79),('15128','2014-02-23','11:35:00',2.46),('15128','2014-02-23','11:40:00',1.51),('15128','2014-02-23','11:45:00',2.35),('15128','2014-02-23','11:50:00',3.18),('15128','2014-02-23','11:55:00',3.13),('15128','2014-02-23','12:00:00',3.15),('15128','2014-02-23','12:05:00',3.16),('15128','2014-02-23','12:10:00',3.18),('15128','2014-02-23','12:15:00',3.19),('15128','2014-02-23','12:20:00',3.21),('15128','2014-02-23','12:25:00',3.21),('15128','2014-02-23','12:30:00',3.24),('15128','2014-02-23','12:35:00',3.27),('15128','2014-02-23','12:40:00',3.27),('15128','2014-02-23','12:45:00',3.36),('15128','2014-02-23','12:50:00',3.46),('15128','2014-02-23','12:55:00',3.62),('15128','2014-02-23','13:00:00',3.55),('15128','2014-02-23','13:05:00',4.06),('15128','2014-02-23','13:10:00',2.15),('15128','2014-02-23','13:15:00',1.15),('15128','2014-02-23','13:20:00',1.04),('15128','2014-02-23','13:35:00',1.1),('15128','2014-02-23','13:40:00',1.14),('15128','2014-02-23','13:45:00',1.08),('15128','2014-02-23','13:50:00',1.08),('15128','2014-02-23','13:55:00',1.17),('15128','2014-02-23','14:00:00',1.29),('15128','2014-02-23','14:05:00',1.39),('15128','2014-02-23','14:10:00',1.41),('15128','2014-02-23','14:15:00',1.47),('15128','2014-02-23','14:20:00',1.42),('15128','2014-02-23','14:50:00',1.02),('15128','2014-02-23','14:55:00',1.11),('15128','2014-02-23','15:00:00',1.29),('15128','2014-02-23','15:05:00',3.33),('15128','2014-02-23','15:10:00',2.2),('15128','2014-02-23','15:15:00',2.95),('15128','2014-02-23','15:20:00',2.68),('15128','2014-02-23','15:25:00',2.52),('15128','2014-02-23','15:30:00',2.39),('15128','2014-02-23','15:35:00',2.27),('15128','2014-02-23','15:40:00',2.03),('15128','2014-02-23','15:45:00',2.06),('15128','2014-02-23','15:50:00',1.99),('15128','2014-02-23','15:55:00',1.81),('15128','2014-02-23','16:00:00',1.73),('15128','2014-02-23','16:05:00',1.7),('15128','2014-02-23','16:10:00',1.29),('15128','2014-02-23','16:30:00',1.33),('15128','2014-02-23','16:35:00',1.08),('15128','2014-02-23','16:40:00',1.09),('15128','2014-02-22','09:05:00',1.11),('15128','2014-02-22','09:10:00',1.2),('15128','2014-02-22','09:15:00',1.26),('15128','2014-02-22','09:20:00',1.25),('15128','2014-02-22','09:25:00',1.35),('15128','2014-02-22','09:30:00',1.42),('15128','2014-02-22','09:35:00',1.48),('15128','2014-02-22','09:40:00',1.53),('15128','2014-02-22','09:45:00',1.59),('15128','2014-02-22','09:50:00',1.62),('15128','2014-02-22','09:55:00',1.69),('15128','2014-02-22','10:00:00',1.75),('15128','2014-02-22','10:05:00',1.8),('15128','2014-02-22','10:10:00',1.85),('15128','2014-02-22','10:15:00',1.89),('15128','2014-02-22','10:20:00',1.97),('15128','2014-02-22','10:25:00',2.05),('15128','2014-02-22','10:30:00',2.08),('15128','2014-02-22','10:35:00',2.12),('15128','2014-02-22','10:40:00',2.19),('15128','2014-02-22','10:45:00',2.26),('15128','2014-02-22','10:50:00',2.3),('15128','2014-02-22','10:55:00',2.34),('15128','2014-02-22','11:00:00',2.37),('15128','2014-02-22','11:05:00',2.49),('15128','2014-02-22','11:10:00',2.55),('15128','2014-02-22','11:15:00',2.64),('15128','2014-02-22','11:20:00',2.76),('15128','2014-02-22','11:25:00',2.84),('15128','2014-02-22','11:30:00',2.87),('15128','2014-02-22','11:35:00',2.91),('15128','2014-02-22','11:40:00',2.97),('15128','2014-02-22','11:45:00',3),('15128','2014-02-22','11:50:00',3.12),('15128','2014-02-22','11:55:00',3.23),('15128','2014-02-22','12:00:00',3.28),('15128','2014-02-22','12:05:00',3.32),('15128','2014-02-22','12:10:00',3.07),('15128','2014-02-22','12:15:00',2.7),('15128','2014-02-22','12:20:00',1.67),('15128','2014-02-22','12:25:00',3.62),('15128','2014-02-22','12:30:00',2.59),('15128','2014-02-22','12:35:00',2.22),('15128','2014-02-22','12:40:00',2.57),('15128','2014-02-22','12:45:00',3.63),('15128','2014-02-22','12:50:00',3.41),('15128','2014-02-22','12:55:00',3.22),('15128','2014-02-22','13:00:00',3.22),('15128','2014-02-22','13:05:00',3.32),('15128','2014-02-22','13:10:00',3.37),('15128','2014-02-22','13:15:00',3.43),('15128','2014-02-22','13:20:00',3.44),('15128','2014-02-22','13:25:00',2.83),('15128','2014-02-22','13:30:00',2.64),('15128','2014-02-22','13:35:00',3.08),('15128','2014-02-22','13:40:00',2.9),('15128','2014-02-22','13:45:00',2.19),('15128','2014-02-22','13:50:00',2.91),('15128','2014-02-22','13:55:00',2.84),('15128','2014-02-22','14:00:00',3.39),('15128','2014-02-22','14:05:00',1.96),('15128','2014-02-22','14:10:00',2.4),('15128','2014-02-22','14:15:00',2.85),('15128','2014-02-22','14:20:00',2.2),('15128','2014-02-22','14:25:00',2.58),('15128','2014-02-22','14:30:00',3.45),('15128','2014-02-22','14:35:00',3.67),('15128','2014-02-22','14:40:00',3.09),('15128','2014-02-22','14:45:00',2.23),('15128','2014-02-22','14:50:00',1.13),('15128','2014-02-22','14:55:00',1.07),('15128','2014-02-22','15:00:00',1.02),('15128','2014-02-22','15:05:00',1.11),('15128','2014-02-22','15:10:00',1.15),('15128','2014-02-22','15:15:00',2.72),('15128','2014-02-22','15:20:00',2.03),('15128','2014-02-22','15:25:00',2.9),('15128','2014-02-22','15:30:00',3.01),('15128','2014-02-22','15:35:00',2.63),('15128','2014-02-22','15:40:00',2.26),('15128','2014-02-22','15:45:00',2.68),('15128','2014-02-22','15:50:00',2.64),('15128','2014-02-22','15:55:00',1.95),('15128','2014-02-22','16:00:00',1.84),('15128','2014-02-22','16:05:00',1.15),('15128','2014-02-21','09:35:00',1.13),('15128','2014-02-21','09:40:00',1.55),('15128','2014-02-21','09:45:00',1.71),('15128','2014-02-21','09:50:00',1.89),('15128','2014-02-21','09:55:00',1.26),('15128','2014-02-21','10:00:00',1.78),('15128','2014-02-21','10:05:00',1.29),('15128','2014-02-21','10:20:00',1.3),('15128','2014-02-21','10:25:00',2.6),('15128','2014-02-21','10:30:00',1.29),('15128','2014-02-21','10:35:00',1.43),('15128','2014-02-21','10:40:00',1.89),('15128','2014-02-21','10:45:00',1.01),('15128','2014-02-21','12:00:00',1.25),('15128','2014-02-21','12:05:00',1.37),('15128','2014-02-21','12:10:00',1.52),('15128','2014-02-21','12:15:00',1.44),('15128','2014-02-21','12:20:00',1.55),('15128','2014-02-21','12:25:00',1.29),('15128','2014-02-21','12:30:00',1.79),('15128','2014-02-21','12:35:00',2.23),('15128','2014-02-21','12:40:00',3.6),('15128','2014-02-21','12:45:00',3.49),('15128','2014-02-21','12:50:00',2.78),('15128','2014-02-21','12:55:00',2.07),('15128','2014-02-21','13:00:00',4.3),('15128','2014-02-21','13:05:00',1.57),('15128','2014-02-21','13:15:00',1.01),('15128','2014-02-21','13:20:00',1.77),('15128','2014-02-21','13:25:00',3.42),('15128','2014-02-21','13:30:00',1.93),('15128','2014-02-21','13:35:00',2.68),('15128','2014-02-21','13:40:00',2.74),('15128','2014-02-21','13:45:00',1.66),('15128','2014-02-21','13:50:00',2.05),('15128','2014-02-21','13:55:00',1.31),('15128','2014-02-21','14:00:00',1.52),('15128','2014-02-21','14:05:00',1.09),('15128','2014-02-21','14:10:00',1.53),('15128','2014-02-21','14:15:00',2.21),('15128','2014-02-21','14:20:00',2.78),('15128','2014-02-21','14:25:00',2.6),('15128','2014-02-21','14:30:00',1.61),('15128','2014-02-21','14:35:00',2.21),('15128','2014-02-21','14:40:00',2.33),('15128','2014-02-21','14:45:00',1.09),('15128','2014-02-21','14:50:00',1.23),('15128','2014-02-21','14:55:00',2.64),('15128','2014-02-21','15:00:00',2.67),('15128','2014-02-21','15:05:00',1.56),('15128','2014-02-21','15:10:00',2.25),('15128','2014-02-21','15:15:00',2.51),('15128','2014-02-21','15:20:00',2.57),('15128','2014-02-21','15:25:00',1.87),('15128','2014-02-21','15:30:00',1.53),('15128','2014-02-21','15:35:00',1.09),('15128','2014-02-21','15:40:00',1.46),('15128','2014-02-21','15:45:00',2.42),('15128','2014-02-21','15:50:00',1.89),('15128','2014-02-21','15:55:00',1.97),('15128','2014-02-21','16:00:00',1.85),('15128','2014-02-21','16:05:00',1.71),('15128','2014-02-21','16:10:00',1.3),('15128','2014-02-21','16:15:00',1.41),('15128','2014-02-21','16:20:00',1.51),('15128','2014-02-21','16:25:00',1.39),('15128','2014-02-21','16:30:00',1.19),('15128','2014-02-21','16:35:00',1.17),('15128','2014-02-20','09:20:00',1),('15128','2014-02-20','09:25:00',1.04),('15128','2014-02-20','09:30:00',1.05),('15128','2014-02-20','09:35:00',1.06),('15128','2014-02-20','09:40:00',1.07),('15128','2014-02-20','09:45:00',1.08),('15128','2014-02-20','09:50:00',1.16),('15128','2014-02-20','09:55:00',1.26),('15128','2014-02-20','10:00:00',1.24),('15128','2014-02-20','10:05:00',1.23),('15128','2014-02-20','10:10:00',1.5),('15128','2014-02-20','10:15:00',1.56),('15128','2014-02-20','10:20:00',1.58),('15128','2014-02-20','10:25:00',1.71),('15128','2014-02-20','10:30:00',1.65),('15128','2014-02-20','10:35:00',1.3),('15128','2014-02-20','10:40:00',1.4),('15128','2014-02-20','10:45:00',1.5),('15128','2014-02-20','10:50:00',2.13),('15128','2014-02-20','10:55:00',2.64),('15128','2014-02-20','11:00:00',2.56),('15128','2014-02-20','11:05:00',2.83),('15128','2014-02-20','11:10:00',2.88),('15128','2014-02-20','11:15:00',2.37),('15128','2014-02-20','11:20:00',2.78),('15128','2014-02-20','11:25:00',1.77),('15128','2014-02-20','11:30:00',2.69),('15128','2014-02-20','11:35:00',1.81),('15128','2014-02-20','11:40:00',3.31),('15128','2014-02-20','11:45:00',3.14),('15128','2014-02-20','11:50:00',3.35),('15128','2014-02-20','11:55:00',3.51),('15128','2014-02-20','12:00:00',2.48),('15128','2014-02-20','12:05:00',4.04),('15128','2014-02-20','12:10:00',2.15),('15128','2014-02-20','12:15:00',1.15),('15128','2014-02-20','12:20:00',1.06),('15128','2014-02-20','13:10:00',1.23),('15128','2014-02-20','13:35:00',1.01),('15128','2014-02-20','13:40:00',1.05),('15128','2014-02-20','13:45:00',1.71),('15128','2014-02-20','13:50:00',1.04),('15128','2014-02-20','14:05:00',1.06),('15128','2014-02-20','14:10:00',1.32),('15128','2014-02-20','14:15:00',1.41),('15128','2014-02-20','14:20:00',1.09),('15128','2014-02-20','14:25:00',1.58),('15128','2014-02-20','14:30:00',2.03),('15128','2014-02-20','14:35:00',2.43),('15128','2014-02-20','14:40:00',2.2),('15128','2014-02-20','14:45:00',2.47),('15128','2014-02-20','14:50:00',1.18),('15128','2014-02-20','14:55:00',1.47),('15128','2014-02-20','15:00:00',2.28),('15128','2014-02-20','15:05:00',1.85),('15128','2014-02-20','15:10:00',2.43),('15128','2014-02-20','15:15:00',2.69),('15128','2014-02-20','15:20:00',2.31),('15128','2014-02-20','15:25:00',2.22),('15128','2014-02-20','15:30:00',2.12),('15128','2014-02-20','15:35:00',2),('15128','2014-02-20','15:40:00',1.91),('15128','2014-02-20','15:45:00',1.82),('15128','2014-02-20','15:50:00',1.73),('15128','2014-02-20','15:55:00',1.57),('15128','2014-02-20','16:00:00',1.56),('15128','2014-02-20','16:05:00',1.47),('15128','2014-02-20','16:10:00',1.45),('15128','2014-02-20','16:15:00',1.37),('15128','2014-02-20','16:20:00',1.32),('15128','2014-02-20','16:25:00',1.22),('15128','2014-02-20','16:30:00',1.1),('15128','2014-02-19','10:15:00',1.05),('15128','2014-02-19','10:20:00',1.13),('15128','2014-02-19','10:25:00',1.14),('15128','2014-02-19','10:30:00',1.08),('15128','2014-02-19','10:35:00',1.08),('15128','2014-02-19','10:40:00',1.21),('15128','2014-02-19','10:45:00',1.2),('15128','2014-02-19','10:50:00',1.13),('15128','2014-02-19','10:55:00',1.07),('15128','2014-02-19','11:00:00',1.06),('15128','2014-02-19','11:20:00',1.07),('15128','2014-02-19','11:25:00',1.39),('15128','2014-02-19','11:30:00',1.46),('15128','2014-02-19','11:35:00',1.46),('15128','2014-02-19','11:40:00',1.33),('15128','2014-02-19','11:45:00',1.16),('15128','2014-02-19','11:50:00',1),('15128','2014-02-19','11:55:00',1.11),('15128','2014-02-19','12:00:00',1.22),('15128','2014-02-19','12:05:00',1.04),('15128','2014-02-19','12:10:00',1),('15128','2014-02-19','12:15:00',1.01),('15128','2014-02-19','12:20:00',1.08),('15128','2014-02-19','13:00:00',1.07),('15128','2014-02-19','13:10:00',1.28),('15128','2014-02-19','13:15:00',1.56),('15128','2014-02-19','13:20:00',1.01),('15128','2014-02-19','13:25:00',1),('15128','2014-02-19','13:30:00',1.12),('15128','2014-02-19','13:35:00',1.22),('15128','2014-02-19','13:40:00',1.35),('15128','2014-02-19','13:45:00',1.33),('15128','2014-02-19','13:50:00',1.44),('15128','2014-02-19','13:55:00',1.26),('15128','2014-02-19','14:00:00',1.31),('15128','2014-02-19','14:05:00',1.25),('15128','2014-02-19','14:10:00',1.05),('15128','2014-02-18','09:40:00',1.04),('15128','2014-02-18','09:45:00',1.28),('15128','2014-02-18','09:50:00',1.28),('15128','2014-02-18','09:55:00',1.17),('15128','2014-02-18','10:00:00',1.24),('15128','2014-02-18','10:05:00',1.3),('15128','2014-02-18','10:10:00',1.3),('15128','2014-02-18','10:15:00',1.43),('15128','2014-02-18','10:20:00',1.38),('15128','2014-02-18','10:25:00',1.31),('15128','2014-02-18','10:30:00',1.18),('15128','2014-02-18','10:35:00',1.19),('15128','2014-02-18','10:40:00',1.28),('15128','2014-02-18','10:45:00',1.3),('15128','2014-02-18','10:50:00',1.35),('15128','2014-02-18','10:55:00',1.34),('15128','2014-02-18','11:00:00',1.19),('15128','2014-02-18','11:15:00',1.28),('15128','2014-02-18','11:20:00',1.44),('15128','2014-02-18','11:25:00',1.42),('15128','2014-02-18','11:30:00',1.09),('15128','2014-02-18','11:35:00',1.08),('15128','2014-02-18','11:40:00',1.6),('15128','2014-02-18','11:45:00',1.58),('15128','2014-02-18','11:50:00',1.54),('15128','2014-02-18','11:55:00',1.42),('15128','2014-02-18','12:00:00',1.43),('15128','2014-02-18','12:05:00',1.51),('15128','2014-02-18','12:10:00',1.56),('15128','2014-02-18','12:15:00',1.24),('15128','2014-02-18','12:50:00',1.07),('15128','2014-02-18','13:15:00',1.18),('15128','2014-02-18','13:20:00',1.34),('15128','2014-02-18','13:25:00',1.32),('15128','2014-02-18','13:30:00',1.47),('15128','2014-02-18','13:35:00',1.87),('15128','2014-02-18','13:40:00',1.75),('15128','2014-02-18','13:45:00',2.06),('15128','2014-02-18','13:50:00',2.01),('15128','2014-02-18','13:55:00',2.05),('15128','2014-02-18','14:00:00',1.74),('15128','2014-02-18','14:05:00',1.22),('15128','2014-02-18','14:10:00',1.13),('15128','2014-02-18','14:15:00',1.12),('15128','2014-02-18','14:20:00',1.18),('15128','2014-02-18','14:25:00',1.38),('15128','2014-02-18','14:30:00',1.8),('15128','2014-02-18','14:35:00',1.32),('15128','2014-02-18','14:50:00',1.07),('15128','2014-02-18','15:00:00',1.13),('15128','2014-02-18','15:05:00',1.03),('15128','2014-02-18','15:15:00',1),('15128','2014-02-17','09:10:00',1.01),('15128','2014-02-17','09:15:00',1.09),('15128','2014-02-17','09:20:00',1.16),('15128','2014-02-17','09:25:00',1.23),('15128','2014-02-17','09:30:00',1.3),('15128','2014-02-17','09:35:00',1.36),('15128','2014-02-17','09:40:00',1.41),('15128','2014-02-17','09:45:00',1.46),('15128','2014-02-17','09:50:00',1.54),('15128','2014-02-17','09:55:00',1.58),('15128','2014-02-17','10:00:00',1.63),('15128','2014-02-17','10:05:00',1.68),('15128','2014-02-17','10:10:00',1.71),('15128','2014-02-17','10:15:00',1.78),('15128','2014-02-17','10:20:00',1.86),('15128','2014-02-17','10:25:00',1.86),('15128','2014-02-17','10:30:00',1.89),('15128','2014-02-17','10:35:00',1.98),('15128','2014-02-17','10:40:00',2.03),('15128','2014-02-17','10:45:00',2.06),('15128','2014-02-17','10:50:00',2.1),('15128','2014-02-17','10:55:00',2.18),('15128','2014-02-17','11:00:00',2.25),('15128','2014-02-17','11:05:00',2.2),('15128','2014-02-17','11:10:00',2.09),('15128','2014-02-17','11:15:00',2.11),('15128','2014-02-17','11:20:00',2.43),('15128','2014-02-17','11:25:00',2.63),('15128','2014-02-17','11:30:00',1.89),('15128','2014-02-17','11:35:00',1.28),('15128','2014-02-17','11:40:00',1.48),('15128','2014-02-17','11:45:00',1.34),('15128','2014-02-17','11:50:00',1.25),('15128','2014-02-17','11:55:00',1.33),('15128','2014-02-17','12:00:00',1.43),('15128','2014-02-17','12:05:00',1.42),('15128','2014-02-17','12:10:00',1.44),('15128','2014-02-17','12:15:00',1.57),('15128','2014-02-17','12:20:00',1.76),('15128','2014-02-17','12:25:00',1.97),('15128','2014-02-17','12:30:00',1.76),('15128','2014-02-17','12:35:00',1.58),('15128','2014-02-17','12:40:00',1.51),('15128','2014-02-17','12:45:00',1.48),('15128','2014-02-17','12:50:00',1.35),('15128','2014-02-17','12:55:00',1.39),('15128','2014-02-17','13:00:00',1.39),('15128','2014-02-17','13:05:00',1.3),('15128','2014-02-17','13:10:00',1.29),('15128','2014-02-17','13:15:00',1.49),('15128','2014-02-17','13:20:00',2.16),('15128','2014-02-17','13:25:00',2.84),('15128','2014-02-17','13:30:00',1.98),('15128','2014-02-17','13:35:00',1.68),('15128','2014-02-17','13:40:00',1.91),('15128','2014-02-17','13:45:00',2.02),('15128','2014-02-17','13:50:00',1.64),('15128','2014-02-17','13:55:00',1.51),('15128','2014-02-17','14:00:00',1.55),('15128','2014-02-17','14:05:00',1.79),('15128','2014-02-17','14:10:00',1.81),('15128','2014-02-17','14:15:00',1.47),('15128','2014-02-17','14:20:00',1.24),('15128','2014-02-17','14:25:00',1.13),('15128','2014-02-17','14:30:00',1.26),('15128','2014-02-17','14:35:00',1.29),('15128','2014-02-17','14:40:00',1.17),('15128','2014-02-17','14:45:00',1.02),('15128','2014-02-17','15:35:00',1.21),('15128','2014-02-17','15:40:00',1.24),('15128','2014-02-17','15:45:00',1.07),('15128','2014-02-17','16:00:00',1.12),('15128','2014-02-17','16:05:00',1.19),('15128','2014-02-16','09:15:00',1.07),('15128','2014-02-16','09:20:00',1.13),('15128','2014-02-16','09:25:00',1.2),('15128','2014-02-16','09:30:00',1.29),('15128','2014-02-16','09:35:00',1.36),('15128','2014-02-16','09:40:00',1.39),('15128','2014-02-16','09:45:00',1.43),('15128','2014-02-16','09:50:00',1.48),('15128','2014-02-16','09:55:00',1.51),('15128','2014-02-16','10:00:00',1.55),('15128','2014-02-16','10:05:00',1.6),('15128','2014-02-16','10:10:00',1.62),('15128','2014-02-16','10:15:00',1.66),('15128','2014-02-16','10:20:00',1.74),('15128','2014-02-16','10:25:00',1.78),('15128','2014-02-16','10:30:00',1.84),('15128','2014-02-16','10:35:00',1.89),('15128','2014-02-16','10:40:00',1.94),('15128','2014-02-16','10:45:00',1.99),('15128','2014-02-16','10:50:00',2.02),('15128','2014-02-16','10:55:00',2.04),('15128','2014-02-16','11:00:00',2.1),('15128','2014-02-16','11:05:00',2.11),('15128','2014-02-16','11:10:00',2.15),('15128','2014-02-16','11:15:00',2.22),('15128','2014-02-16','11:20:00',2.25),('15128','2014-02-16','11:25:00',2.35),('15128','2014-02-16','11:30:00',2.41),('15128','2014-02-16','11:35:00',2.43),('15128','2014-02-16','11:40:00',2.46),('15128','2014-02-16','11:45:00',2.5),('15128','2014-02-16','11:50:00',2.56),('15128','2014-02-16','11:55:00',2.61),('15128','2014-02-16','12:00:00',2.66),('15128','2014-02-16','12:05:00',2.72),('15128','2014-02-16','12:10:00',2.74),('15128','2014-02-16','12:15:00',2.78),('15128','2014-02-16','12:20:00',2.8),('15128','2014-02-16','12:25:00',2.82),('15128','2014-02-16','12:30:00',2.82),('15128','2014-02-16','12:35:00',2.83),('15128','2014-02-16','12:40:00',2.84),('15128','2014-02-16','12:45:00',2.86),('15128','2014-02-16','12:50:00',2.87),('15128','2014-02-16','12:55:00',2.86),('15128','2014-02-16','13:00:00',2.84),('15128','2014-02-16','13:05:00',2.85),('15128','2014-02-16','13:10:00',2.83),('15128','2014-02-16','13:15:00',2.82),('15128','2014-02-16','13:20:00',2.81),('15128','2014-02-16','13:25:00',2.82),('15128','2014-02-16','13:30:00',2.83),('15128','2014-02-16','13:35:00',2.77),('15128','2014-02-16','13:40:00',2.76),('15128','2014-02-16','13:45:00',2.74),('15128','2014-02-16','13:50:00',2.71),('15128','2014-02-16','13:55:00',2.71),('15128','2014-02-16','14:00:00',2.66),('15128','2014-02-16','14:05:00',2.67),('15128','2014-02-16','14:10:00',2.54),('15128','2014-02-16','14:15:00',2.62),('15128','2014-02-16','14:20:00',2.58),('15128','2014-02-16','14:25:00',2.51),('15128','2014-02-16','14:30:00',2.44),('15128','2014-02-16','14:35:00',2.35),('15128','2014-02-16','14:40:00',2.35),('15128','2014-02-16','14:45:00',2.32),('15128','2014-02-16','14:50:00',2.29),('15128','2014-02-16','14:55:00',2.26),('15128','2014-02-16','15:00:00',2.22),('15128','2014-02-16','15:05:00',2.08),('15128','2014-02-16','15:10:00',1.95),('15128','2014-02-16','15:15:00',2.06),('15128','2014-02-16','15:20:00',1.97),('15128','2014-02-16','15:25:00',1.93),('15128','2014-02-16','15:30:00',1.9),('15128','2014-02-16','15:35:00',1.76),('15128','2014-02-16','15:40:00',1.7),('15128','2014-02-16','15:45:00',1.64),('15128','2014-02-16','15:50:00',1.57),('15128','2014-02-16','15:55:00',1.52),('15128','2014-02-16','16:00:00',1.4),('15128','2014-02-16','16:05:00',1.36),('15128','2014-02-16','16:10:00',1.27),('15128','2014-02-16','16:15:00',1.16),('15128','2014-02-16','16:20:00',1.08),('15128','2014-02-15','09:15:00',1.09),('15128','2014-02-15','09:20:00',1.1),('15128','2014-02-15','09:25:00',1.17),('15128','2014-02-15','09:30:00',1.01),('15128','2014-02-15','09:35:00',1.35),('15128','2014-02-15','09:40:00',1.39),('15128','2014-02-15','09:45:00',1.45),('15128','2014-02-15','09:50:00',1.46),('15128','2014-02-15','09:55:00',1.53),('15128','2014-02-15','10:00:00',1.58),('15128','2014-02-15','10:05:00',1.71),('15128','2014-02-15','10:10:00',1.69),('15128','2014-02-15','10:15:00',1.7),('15128','2014-02-15','10:20:00',1.79),('15128','2014-02-15','10:25:00',1.91),('15128','2014-02-15','10:30:00',2.03),('15128','2014-02-15','10:35:00',2.05),('15128','2014-02-15','10:40:00',2.13),('15128','2014-02-15','10:45:00',2.12),('15128','2014-02-15','10:50:00',1.91),('15128','2014-02-15','10:55:00',2.14),('15128','2014-02-15','11:00:00',2.18),('15128','2014-02-15','11:05:00',2.03),('15128','2014-02-15','11:10:00',2.16),('15128','2014-02-15','11:15:00',2.32),('15128','2014-02-15','11:20:00',1.98),('15128','2014-02-15','11:25:00',2.37),('15128','2014-02-15','11:30:00',2.61),('15128','2014-02-15','11:35:00',2.6),('15128','2014-02-15','11:40:00',2.35),('15128','2014-02-15','11:45:00',2.72),('15128','2014-02-15','11:50:00',2.43),('15128','2014-02-15','11:55:00',2.75),('15128','2014-02-15','12:00:00',2.78),('15128','2014-02-15','12:05:00',2.8),('15128','2014-02-15','12:10:00',2.87),('15128','2014-02-15','12:15:00',2.9),('15128','2014-02-15','12:20:00',2.91),('15128','2014-02-15','12:25:00',2.92),('15128','2014-02-15','12:30:00',2.93),('15128','2014-02-15','12:35:00',2.95),('15128','2014-02-15','12:40:00',2.95),('15128','2014-02-15','12:45:00',2.96),('15128','2014-02-15','12:50:00',2.95),('15128','2014-02-15','12:55:00',2.97),('15128','2014-02-15','13:00:00',2.95),('15128','2014-02-15','13:05:00',2.84),('15128','2014-02-15','13:10:00',2.97),('15128','2014-02-15','13:15:00',3.01),('15128','2014-02-15','13:20:00',2.98),('15128','2014-02-15','13:25:00',2.95),('15128','2014-02-15','13:30:00',2.96),('15128','2014-02-15','13:35:00',2.88),('15128','2014-02-15','13:40:00',2.95),('15128','2014-02-15','13:45:00',2.8),('15128','2014-02-15','13:50:00',2.88),('15128','2014-02-15','13:55:00',2.89),('15128','2014-02-15','14:00:00',2.89),('15128','2014-02-15','14:05:00',2.86),('15128','2014-02-15','14:10:00',2.85),('15128','2014-02-15','14:15:00',2.81),('15128','2014-02-15','14:20:00',2.71),('15128','2014-02-15','14:25:00',2.78),('15128','2014-02-15','14:30:00',2.72),('15128','2014-02-15','14:35:00',2.58),('15128','2014-02-15','14:40:00',2.65),('15128','2014-02-15','14:45:00',2.61),('15128','2014-02-15','14:50:00',2.35),('15128','2014-02-15','14:55:00',1.92),('15128','2014-02-15','15:00:00',2.4),('15128','2014-02-15','15:05:00',2.44),('15128','2014-02-15','15:10:00',2.36),('15128','2014-02-15','15:15:00',2.29),('15128','2014-02-15','15:20:00',2.23),('15128','2014-02-15','15:25:00',2.16),('15128','2014-02-15','15:30:00',2.02),('15128','2014-02-15','15:35:00',1.81),('15128','2014-02-15','15:40:00',1.37),('15128','2014-02-15','15:50:00',1.15),('15128','2014-02-15','16:10:00',1.39),('15128','2014-02-15','16:15:00',1.43),('15128','2014-02-15','16:20:00',1.64),('15128','2014-02-15','16:25:00',1.46),('15128','2014-02-15','16:30:00',1.07),('15128','2014-04-27','08:15:00',1.43),('15128','2014-04-27','08:20:00',1.14),('15128','2014-04-27','08:35:00',1.03),('15128','2014-04-27','08:40:00',1.07),('15128','2014-04-27','08:45:00',1.03),('15128','2014-04-27','09:05:00',1.71),('15128','2014-04-27','09:10:00',1.8),('15128','2014-04-27','09:15:00',1.67),('15128','2014-04-27','09:20:00',1.63),('15128','2014-04-27','09:25:00',1.89),('15128','2014-04-27','09:30:00',2.66),('15128','2014-04-27','09:35:00',1.9),('15128','2014-04-27','09:40:00',2.5),('15128','2014-04-27','09:45:00',1.62),('15128','2014-04-27','09:50:00',1.48),('15128','2014-04-27','09:55:00',1.62),('15128','2014-04-27','10:00:00',1.42),('15128','2014-04-27','10:05:00',1.1),('15128','2014-04-27','10:25:00',1.01),('15128','2014-04-27','10:30:00',1.2),('15128','2014-04-27','10:35:00',1.25),('15128','2014-04-27','10:40:00',1.19),('15128','2014-04-27','10:50:00',1.12),('15128','2014-04-27','10:55:00',1.33),('15128','2014-04-27','11:00:00',1.57),('15128','2014-04-27','11:05:00',1.86),('15128','2014-04-27','11:10:00',1.77),('15128','2014-04-27','11:15:00',1.4),('15128','2014-04-27','11:20:00',1.45),('15128','2014-04-27','11:25:00',1.25),('15128','2014-04-27','11:30:00',1.62),('15128','2014-04-27','11:35:00',1.91),('15128','2014-04-27','11:40:00',1.84),('15128','2014-04-27','11:45:00',1.74),('15128','2014-04-27','11:50:00',1.55),('15128','2014-04-27','11:55:00',1.85),('15128','2014-04-27','12:00:00',2.07),('15128','2014-04-27','12:05:00',2.1),('15128','2014-04-27','12:10:00',1.83),('15128','2014-04-27','12:15:00',1.53),('15128','2014-04-27','12:20:00',1.91),('15128','2014-04-27','12:25:00',2.38),('15128','2014-04-27','12:30:00',2.61),('15128','2014-04-27','12:35:00',2.62),('15128','2014-04-27','12:40:00',2.39),('15128','2014-04-27','12:45:00',2.03),('15128','2014-04-27','12:50:00',2.07),('15128','2014-04-27','12:55:00',2.63),('15128','2014-04-27','13:00:00',2.93),('15128','2014-04-27','13:05:00',3.01),('15128','2014-04-27','13:10:00',3.33),('15128','2014-04-27','13:15:00',3.25),('15128','2014-04-27','13:20:00',4.49),('15128','2014-04-27','13:25:00',3.14),('15128','2014-04-27','13:30:00',3.69),('15128','2014-04-27','13:35:00',2.66),('15128','2014-04-27','13:40:00',2.37),('15128','2014-04-27','13:45:00',2.1),('15128','2014-04-27','13:50:00',1.98),('15128','2014-04-27','13:55:00',1.82),('15128','2014-04-27','14:00:00',2.89),('15128','2014-04-27','14:05:00',3.81),('15128','2014-04-27','14:10:00',3.36),('15128','2014-04-27','14:15:00',3.51),('15128','2014-04-27','14:20:00',5.05),('15128','2014-04-27','14:25:00',3.03),('15128','2014-04-27','14:30:00',3.46),('15128','2014-04-27','14:35:00',4.07),('15128','2014-04-27','14:40:00',2.19),('15128','2014-04-27','14:45:00',3.38),('15128','2014-04-27','14:50:00',2.12),('15128','2014-04-27','14:55:00',2.33),('15128','2014-04-27','15:00:00',2.14),('15128','2014-04-27','15:05:00',1.8),('15128','2014-04-27','15:10:00',4.31),('15128','2014-04-27','15:15:00',1.67),('15128','2014-04-27','15:20:00',3.3),('15128','2014-04-27','15:25:00',1.26),('15128','2014-04-27','15:30:00',1.4),('15128','2014-04-27','15:35:00',1.92),('15128','2014-04-27','15:40:00',2.31),('15128','2014-04-27','15:45:00',1.02),('15128','2014-04-27','15:50:00',1.41),('15128','2014-04-27','15:55:00',2.36),('15128','2014-04-27','16:10:00',1.37),('15128','2014-04-27','16:15:00',1.48),('15128','2014-04-27','16:20:00',1.14),('15128','2014-04-27','16:25:00',1.68),('15128','2014-04-27','16:30:00',3.05),('15128','2014-04-27','16:35:00',1.37),('15128','2014-04-27','16:55:00',1.15),('15128','2014-04-27','17:00:00',2.13),('15128','2014-04-27','17:05:00',1.29),('15128','2014-04-27','17:50:00',1.07),('15128','2014-04-27','17:55:00',1.05),('15128','2014-02-14','09:15:00',1.02),('15128','2014-02-14','09:20:00',1.09),('15128','2014-02-14','09:25:00',1.15),('15128','2014-02-14','09:30:00',1.21),('15128','2014-02-14','09:35:00',1.27),('15128','2014-02-14','09:40:00',1.33),('15128','2014-02-14','09:45:00',1.39),('15128','2014-02-14','09:50:00',1.44),('15128','2014-02-14','09:55:00',1.47),('15128','2014-02-14','10:00:00',1.53),('15128','2014-02-14','10:05:00',1.58),('15128','2014-02-14','10:10:00',1.62),('15128','2014-02-14','10:15:00',1.65),('15128','2014-02-14','10:20:00',1.72),('15128','2014-02-14','10:25:00',1.78),('15128','2014-02-14','10:30:00',1.79),('15128','2014-02-14','10:35:00',1.85),('15128','2014-02-14','10:40:00',1.91),('15128','2014-02-14','10:45:00',1.81),('15128','2014-02-14','10:50:00',2),('15128','2014-02-14','10:55:00',2.04),('15128','2014-02-14','11:00:00',2.04),('15128','2014-02-14','11:05:00',2.12),('15128','2014-02-14','11:10:00',2.2),('15128','2014-02-14','11:15:00',2.24),('15128','2014-02-14','11:20:00',2.28),('15128','2014-02-14','11:25:00',2.42),('15128','2014-02-14','11:30:00',2.48),('15128','2014-02-14','11:35:00',2.5),('15128','2014-02-14','11:40:00',2.53),('15128','2014-02-14','11:45:00',2.61),('15128','2014-02-14','12:15:00',2.99),('15128','2014-02-14','12:20:00',3.06),('15128','2014-02-14','12:25:00',1.78),('15128','2014-02-14','12:30:00',2.74),('15128','2014-02-14','12:35:00',2.94),('15128','2014-02-14','12:40:00',3.01),('15128','2014-02-14','12:45:00',3.05),('15128','2014-02-14','12:50:00',3.04),('15128','2014-02-14','12:55:00',3.01),('15128','2014-02-14','13:00:00',3.02),('15128','2014-02-14','13:05:00',2.99),('15128','2014-02-14','13:10:00',2.98),('15128','2014-02-14','13:15:00',2.98),('15128','2014-02-14','13:20:00',2.97),('15128','2014-02-14','13:25:00',3.02),('15128','2014-02-14','13:30:00',2.31),('15128','2014-02-14','13:35:00',2.94),('15128','2014-02-14','13:40:00',2.97),('15128','2014-02-14','13:45:00',2.87),('15128','2014-02-14','13:50:00',2.86),('15128','2014-02-14','13:55:00',2.83),('15128','2014-02-14','14:00:00',2.81),('15128','2014-02-14','14:05:00',2.79),('15128','2014-02-14','14:10:00',2.76),('15128','2014-02-14','14:15:00',2.71),('15128','2014-02-14','14:20:00',2.71),('15128','2014-02-14','14:25:00',2.69),('15128','2014-02-14','14:30:00',2.65),('15128','2014-02-14','14:35:00',2.61),('15128','2014-02-14','14:40:00',2.58),('15128','2014-02-14','14:45:00',2.54),('15128','2014-02-14','14:50:00',2.5),('15128','2014-02-14','14:55:00',2.43),('15128','2014-02-14','15:00:00',2.38),('15128','2014-02-14','15:05:00',2.33),('15128','2014-02-14','15:10:00',2.28),('15128','2014-02-14','15:15:00',2.23),('15128','2014-02-14','15:20:00',2.16),('15128','2014-02-14','15:25:00',2.1),('15128','2014-02-14','15:30:00',2.03),('15128','2014-02-14','15:35:00',1.93),('15128','2014-02-14','15:40:00',1.85),('15128','2014-02-14','15:45:00',1.77),('15128','2014-02-14','15:50:00',1.7),('15128','2014-02-14','15:55:00',1.66),('15128','2014-02-14','16:00:00',1.59),('15128','2014-02-14','16:05:00',1.49),('15128','2014-02-14','16:10:00',1.38),('15128','2014-02-14','16:15:00',1.3),('15128','2014-02-14','16:20:00',1.21),('15128','2014-02-14','16:25:00',1.12),('15128','2014-02-13','09:30:00',1.18),('15128','2014-02-13','09:35:00',1.07),('15128','2014-02-13','09:40:00',1.32),('15128','2014-02-13','09:45:00',1.31),('15128','2014-02-13','09:50:00',1.44),('15128','2014-02-13','09:55:00',1.3),('15128','2014-02-13','10:00:00',1.29),('15128','2014-02-13','10:05:00',1.53),('15128','2014-02-13','10:10:00',1.56),('15128','2014-02-13','10:15:00',1.55),('15128','2014-02-13','10:20:00',1.26),('15128','2014-02-13','10:25:00',1.9),('15128','2014-02-13','10:30:00',1.85),('15128','2014-02-13','10:35:00',1.2),('15128','2014-02-13','10:40:00',1.86),('15128','2014-02-13','10:45:00',1.9),('15128','2014-02-13','10:50:00',2.15),('15128','2014-02-13','10:55:00',2.2),('15128','2014-02-13','11:00:00',2.26),('15128','2014-02-13','11:05:00',2.26),('15128','2014-02-13','11:10:00',2.29),('15128','2014-02-13','11:15:00',2.37),('15128','2014-02-13','11:20:00',2.4),('15128','2014-02-13','11:25:00',2.64),('15128','2014-02-13','11:30:00',2.81),('15128','2014-02-13','11:35:00',2.74),('15128','2014-02-13','11:40:00',2.76),('15128','2014-02-13','11:45:00',2.42),('15128','2014-02-13','11:50:00',2.84),('15128','2014-02-13','11:55:00',2.96),('15128','2014-02-13','12:00:00',2.95),('15128','2014-02-13','12:05:00',2.95),('15128','2014-02-13','12:10:00',2.95),('15128','2014-02-13','12:15:00',2.99),('15128','2014-02-13','12:20:00',3.02),('15128','2014-02-13','12:25:00',2.89),('15128','2014-02-13','12:30:00',2.96),('15128','2014-02-13','12:35:00',2.96),('15128','2014-02-13','12:40:00',3.06),('15128','2014-02-13','12:45:00',3.08),('15128','2014-02-13','12:50:00',3.1),('15128','2014-02-13','12:55:00',3.09),('15128','2014-02-13','13:00:00',3.12),('15128','2014-02-13','13:05:00',3.12),('15128','2014-02-13','13:10:00',3.13),('15128','2014-02-13','13:15:00',3.12),('15128','2014-02-13','13:20:00',3.09),('15128','2014-02-13','13:25:00',3.09),('15128','2014-02-13','13:30:00',3.08),('15128','2014-02-13','13:35:00',3.05),('15128','2014-02-13','13:40:00',3.03),('15128','2014-02-13','13:45:00',3.01),('15128','2014-02-13','13:50:00',3.01),('15128','2014-02-13','13:55:00',2.96),('15128','2014-02-13','14:00:00',2.94),('15128','2014-02-13','14:05:00',2.92),('15128','2014-02-13','14:10:00',2.89),('15128','2014-02-13','14:15:00',2.85),('15128','2014-02-13','14:20:00',2.8),('15128','2014-02-13','14:25:00',2.77),('15128','2014-02-13','14:30:00',2.74),('15128','2014-02-13','14:35:00',2.71),('15128','2014-02-13','14:40:00',2.67),('15128','2014-02-13','14:45:00',2.62),('15128','2014-02-13','14:50:00',2.56),('15128','2014-02-13','14:55:00',2.49),('15128','2014-02-13','15:00:00',2.41),('15128','2014-02-13','15:05:00',2.35),('15128','2014-02-13','15:10:00',2.31),('15128','2014-02-13','15:15:00',2.24),('15128','2014-02-13','15:20:00',2.19),('15128','2014-02-13','15:25:00',2.12),('15128','2014-02-13','15:30:00',2.05),('15128','2014-02-13','15:35:00',1.95),('15128','2014-02-13','15:40:00',1.87),('15128','2014-02-13','15:45:00',1.81),('15128','2014-02-13','15:50:00',1.74),('15128','2014-02-13','15:55:00',1.65),('15128','2014-02-13','16:00:00',1.57),('15128','2014-02-13','16:05:00',1.46),('15128','2014-02-13','16:10:00',1.36),('15128','2014-02-13','16:15:00',1.26),('15128','2014-02-13','16:20:00',1.17),('15128','2014-02-13','16:25:00',1.08),('15128','2014-02-12','09:20:00',1.08),('15128','2014-02-12','09:25:00',1.14),('15128','2014-02-12','09:30:00',1.21),('15128','2014-02-12','09:35:00',1.28),('15128','2014-02-12','09:40:00',1.34),('15128','2014-02-12','09:45:00',1.4),('15128','2014-02-12','09:50:00',1.46),('15128','2014-02-12','09:55:00',1.52),('15128','2014-02-12','10:00:00',1.57),('15128','2014-02-12','10:05:00',1.63),('15128','2014-02-12','10:10:00',1.66),('15128','2014-02-12','10:15:00',1.7),('15128','2014-02-12','10:20:00',1.74),('15128','2014-02-12','10:25:00',1.8),('15128','2014-02-12','10:30:00',1.86),('15128','2014-02-12','10:35:00',1.92),('15128','2014-02-12','10:40:00',1.95),('15128','2014-02-12','10:45:00',1.99),('15128','2014-02-12','10:50:00',2.08),('15128','2014-02-12','10:55:00',2.1),('15128','2014-02-12','11:00:00',2.12),('15128','2014-02-12','11:05:00',2.22),('15128','2014-02-12','11:10:00',2.35),('15128','2014-02-12','11:15:00',2.48),('15128','2014-02-12','11:20:00',2.57),('15128','2014-02-12','11:25:00',2.65),('15128','2014-02-12','11:30:00',2.71),('15128','2014-02-12','11:35:00',2.01),('15128','2014-02-12','11:40:00',2.31),('15128','2014-02-12','11:45:00',2.02),('15128','2014-02-12','11:50:00',1.03),('15128','2014-02-12','11:55:00',1.8),('15128','2014-02-12','12:00:00',2.47),('15128','2014-02-12','12:05:00',1.5),('15128','2014-02-12','12:15:00',1.57),('15128','2014-02-12','12:20:00',1.51),('15128','2014-02-12','12:25:00',1.38),('15128','2014-02-12','12:30:00',1.66),('15128','2014-02-12','12:35:00',3.46),('15128','2014-02-12','12:40:00',3.42),('15128','2014-02-12','12:45:00',3.31),('15128','2014-02-12','12:50:00',3.44),('15128','2014-02-12','12:55:00',3.3),('15128','2014-02-12','13:00:00',3.41),('15128','2014-02-12','13:05:00',3.42),('15128','2014-02-12','13:10:00',3.34),('15128','2014-02-12','13:15:00',3.08),('15128','2014-02-12','13:20:00',3.04),('15128','2014-02-12','13:25:00',3.06),('15128','2014-02-12','13:30:00',3.05),('15128','2014-02-12','13:35:00',3.03),('15128','2014-02-12','13:40:00',3.03),('15128','2014-02-12','13:45:00',3.02),('15128','2014-02-12','13:50:00',3.02),('15128','2014-02-12','13:55:00',3),('15128','2014-02-12','14:00:00',2.52),('15128','2014-02-12','14:05:00',2.98),('15128','2014-02-12','14:10:00',2.61),('15128','2014-02-12','14:15:00',2.9),('15128','2014-02-12','14:20:00',2.86),('15128','2014-02-12','14:25:00',2.85),('15128','2014-02-12','14:30:00',2.16),('15128','2014-02-12','14:35:00',1.84),('15128','2014-02-12','14:40:00',2.91),('15128','2014-02-12','14:45:00',1.26),('15128','2014-02-12','14:50:00',2.49),('15128','2014-02-12','14:55:00',1.99),('15128','2014-02-12','15:00:00',1.12),('15128','2014-02-12','15:05:00',1.12),('15128','2014-02-12','15:15:00',1.98),('15128','2014-02-12','15:20:00',1.4),('15128','2014-02-12','15:30:00',1.56),('15128','2014-02-12','15:35:00',1.18),('15128','2014-02-12','15:45:00',1.4),('15128','2014-02-12','15:50:00',1.92),('15128','2014-02-12','15:55:00',1.76),('15128','2014-02-12','16:00:00',1.16),('15128','2014-02-12','16:05:00',1.49),('15128','2014-02-12','16:10:00',1.34),('15128','2014-02-11','09:20:00',1.07),('15128','2014-02-11','09:25:00',1.13),('15128','2014-02-11','09:50:00',1.38),('15128','2014-02-11','09:55:00',1.47),('15128','2014-02-11','10:00:00',1.25),('15128','2014-02-11','10:05:00',1.07),('15128','2014-02-11','10:10:00',1.03),('15128','2014-02-11','10:15:00',1.04),('15128','2014-02-11','10:20:00',1.12),('15128','2014-02-11','10:25:00',1.25),('15128','2014-02-11','10:30:00',1.15),('15128','2014-02-11','10:35:00',1.59),('15128','2014-02-11','10:40:00',1.22),('15128','2014-02-11','10:45:00',1.23),('15128','2014-02-11','10:50:00',1.19),('15128','2014-02-11','10:55:00',1.03),('15128','2014-02-11','11:00:00',1.03),('15128','2014-02-11','11:05:00',1.09),('15128','2014-02-11','11:10:00',1.2),('15128','2014-02-11','11:15:00',1.91),('15128','2014-02-11','11:20:00',2.14),('15128','2014-02-11','11:25:00',2.53),('15128','2014-02-11','11:30:00',2.96),('15128','2014-02-11','11:35:00',2.46),('15128','2014-02-11','11:40:00',1.57),('15128','2014-02-11','11:45:00',2.51),('15128','2014-02-11','11:50:00',1.56),('15128','2014-02-11','11:55:00',1.41),('15128','2014-02-11','12:00:00',1.09),('15128','2014-02-11','12:05:00',1.27),('15128','2014-02-11','12:10:00',1.23),('15128','2014-02-11','12:15:00',1.04),('15128','2014-02-11','12:20:00',1.02),('15128','2014-02-11','12:25:00',1.13),('15128','2014-02-11','12:30:00',1.24),('15128','2014-02-11','12:35:00',1.33),('15128','2014-02-11','12:40:00',1.36),('15128','2014-02-11','12:45:00',1.46),('15128','2014-02-11','12:50:00',1.66),('15128','2014-02-11','12:55:00',1.72),('15128','2014-02-11','13:00:00',1.75),('15128','2014-02-11','13:05:00',1.72),('15128','2014-02-11','13:10:00',1.61),('15128','2014-02-11','13:15:00',2.2),('15128','2014-02-11','13:20:00',3.05),('15128','2014-02-11','13:25:00',2.22),('15128','2014-02-11','13:30:00',2.46),('15128','2014-02-11','13:35:00',1.91),('15128','2014-02-11','13:40:00',1.28),('15128','2014-02-11','13:45:00',1.22),('15128','2014-02-11','13:50:00',1.29),('15128','2014-02-11','13:55:00',1.3),('15128','2014-02-11','14:00:00',1.5),('15128','2014-02-11','14:05:00',1.68),('15128','2014-02-11','14:10:00',3.09),('15128','2014-02-11','14:15:00',2.98),('15128','2014-02-11','14:20:00',2.3),('15128','2014-02-11','14:25:00',3.2),('15128','2014-02-11','14:30:00',2.89),('15128','2014-02-11','14:35:00',3.01),('15128','2014-02-11','14:40:00',2.86),('15128','2014-02-11','14:45:00',2.03),('15128','2014-02-11','14:50:00',2.48),('15128','2014-02-11','14:55:00',2.53),('15128','2014-02-11','15:00:00',1.81),('15128','2014-02-11','15:10:00',2.15),('15128','2014-02-11','15:15:00',1.15),('15128','2014-02-11','15:20:00',1.91),('15128','2014-02-11','15:25:00',1.26),('15128','2014-02-11','15:30:00',1.02),('15128','2014-02-11','15:35:00',1.43),('15128','2014-02-11','15:40:00',2.38),('15128','2014-02-11','15:45:00',1.16),('15128','2014-02-11','15:50:00',1.11),('15128','2014-02-11','15:55:00',1.11),('15128','2014-02-10','09:30:00',1.01),('15128','2014-02-10','09:45:00',1.07),('15128','2014-02-10','09:50:00',1.17),('15128','2014-02-10','09:55:00',1.03),('15128','2014-02-10','10:10:00',1.02),('15128','2014-02-10','10:15:00',1.19),('15128','2014-02-10','10:20:00',1.28),('15128','2014-02-10','10:25:00',1.39),('15128','2014-02-10','10:30:00',1.5),('15128','2014-02-10','10:35:00',1.65),('15128','2014-02-10','10:40:00',1.58),('15128','2014-02-10','10:45:00',1.5),('15128','2014-02-10','10:50:00',1.77),('15128','2014-02-10','10:55:00',1.74),('15128','2014-02-10','11:00:00',1.83),('15128','2014-02-10','11:05:00',2.08),('15128','2014-02-10','11:10:00',1.89),('15128','2014-02-10','11:15:00',1.8),('15128','2014-02-10','11:20:00',2.15),('15128','2014-02-10','11:25:00',2.33),('15128','2014-02-10','11:30:00',2.29),('15128','2014-02-10','11:35:00',2.17),('15128','2014-02-10','11:40:00',2.27),('15128','2014-02-10','11:45:00',2.18),('15128','2014-02-10','11:50:00',1.98),('15128','2014-02-10','11:55:00',1.59),('15128','2014-02-10','12:00:00',1.4),('15128','2014-02-10','12:05:00',1.45),('15128','2014-02-10','12:10:00',2.03),('15128','2014-02-10','12:15:00',1.88),('15128','2014-02-10','12:20:00',1.27),('15128','2014-02-10','12:25:00',1.49),('15128','2014-02-10','12:30:00',2),('15128','2014-02-10','12:35:00',2.28),('15128','2014-02-10','12:40:00',1.71),('15128','2014-02-10','12:45:00',1.61),('15128','2014-02-10','12:50:00',2.29),('15128','2014-02-10','12:55:00',1.52),('15128','2014-02-10','13:00:00',2.43),('15128','2014-02-10','13:05:00',1.89),('15128','2014-02-10','13:10:00',2.77),('15128','2014-02-10','13:15:00',3.17),('15128','2014-02-10','13:20:00',2.97),('15128','2014-02-10','13:25:00',2.62),('15128','2014-02-10','13:30:00',2.47),('15128','2014-02-10','13:35:00',2.46),('15128','2014-02-10','13:40:00',2.64),('15128','2014-02-10','13:45:00',1.88),('15128','2014-02-10','13:50:00',2.24),('15128','2014-02-10','13:55:00',1.78),('15128','2014-02-10','14:00:00',1.25),('15128','2014-02-10','14:05:00',1.31),('15128','2014-02-10','14:10:00',1.84),('15128','2014-02-10','14:15:00',1.48),('15128','2014-02-10','14:20:00',1.54),('15128','2014-02-10','14:25:00',1.55),('15128','2014-02-10','14:30:00',1.49),('15128','2014-02-10','14:35:00',1.27),('15128','2014-02-10','14:40:00',1.07),('15128','2014-02-10','14:45:00',1.01),('15128','2014-02-10','15:10:00',1.34),('15128','2014-02-10','15:15:00',1.3),('15128','2014-02-10','15:20:00',1.51),('15128','2014-02-10','15:25:00',1.02),('15128','2014-02-10','16:15:00',1.09),('15128','2014-02-09','13:00:00',1),('15128','2014-02-08','11:25:00',1.02),('15128','2014-02-08','12:05:00',1.87),('15128','2014-02-08','12:10:00',1.17),('15128','2014-02-08','12:15:00',1.99),('15128','2014-02-08','12:40:00',1.44),('15128','2014-02-08','12:55:00',2.65),('15128','2014-02-08','13:00:00',2.94),('15128','2014-02-08','13:05:00',1.17),('15128','2014-02-08','13:10:00',1.8),('15128','2014-02-08','13:20:00',1.29),('15128','2014-02-08','13:25:00',1.91),('15128','2014-02-08','13:35:00',3.02),('15128','2014-02-08','13:40:00',1.12),('15128','2014-02-08','13:45:00',2.65),('15128','2014-02-08','13:50:00',2.18),('15128','2014-02-08','13:55:00',2.62),('15128','2014-02-08','14:00:00',2.86),('15128','2014-02-08','14:05:00',1.8),('15128','2014-02-08','14:10:00',1.15),('15128','2014-02-08','14:15:00',1.3),('15128','2014-02-08','14:20:00',2.58),('15128','2014-02-08','14:25:00',2.76),('15128','2014-02-08','14:30:00',1.72),('15128','2014-02-08','14:35:00',1.35),('15128','2014-02-08','14:40:00',1.5),('15128','2014-02-08','14:45:00',1.49),('15128','2014-02-08','14:50:00',1.2),('15128','2014-02-08','14:55:00',1.43),('15128','2014-02-08','15:05:00',1.55),('15128','2014-02-08','15:10:00',1.81),('15128','2014-02-08','15:15:00',1.54),('15128','2014-02-08','15:20:00',1.55),('15128','2014-02-08','15:25:00',1.75),('15128','2014-02-08','15:30:00',1.6),('15128','2014-02-08','15:35:00',1.67),('15128','2014-02-08','15:40:00',1.6),('15128','2014-02-08','15:45:00',1.43),('15128','2014-02-08','15:50:00',1.32),('15128','2014-02-08','15:55:00',1.23),('15128','2014-02-08','16:00:00',1.14),('15128','2014-02-08','16:05:00',1.11),('15128','2014-02-07','09:50:00',1),('15128','2014-02-07','09:55:00',1.33),('15128','2014-02-07','10:00:00',1.39),('15128','2014-02-07','10:05:00',1.42),('15128','2014-02-07','10:10:00',1.52),('15128','2014-02-07','10:15:00',1.58),('15128','2014-02-07','10:25:00',1.37),('15128','2014-02-07','10:30:00',1.24),('15128','2014-02-07','10:45:00',1.36),('15128','2014-02-07','10:55:00',1.99),('15128','2014-02-07','11:00:00',2.23),('15128','2014-02-07','11:05:00',2.89),('15128','2014-02-07','11:10:00',1.8),('15128','2014-02-07','11:20:00',1.76),('15128','2014-02-07','11:30:00',1.89),('15128','2014-02-07','11:35:00',1.13),('15128','2014-02-07','11:40:00',1.06),('15128','2014-02-07','11:50:00',1.68),('15128','2014-02-07','11:55:00',2.75),('15128','2014-02-07','12:00:00',1.63),('15128','2014-02-07','12:05:00',1.05),('15128','2014-02-07','12:10:00',2.02),('15128','2014-02-07','12:20:00',1.76),('15128','2014-02-07','12:30:00',1.52),('15128','2014-02-07','12:35:00',2.08),('15128','2014-02-07','12:40:00',2.59),('15128','2014-02-07','12:45:00',1.14),('15128','2014-02-07','12:50:00',1.54),('15128','2014-02-07','12:55:00',3.27),('15128','2014-02-07','13:00:00',3.25),('15128','2014-02-07','13:05:00',2.24),('15128','2014-02-07','13:10:00',1.79),('15128','2014-02-07','13:15:00',2.98),('15128','2014-02-07','13:20:00',2.31),('15128','2014-02-07','13:25:00',3.11),('15128','2014-02-07','13:30:00',2.55),('15128','2014-02-07','13:35:00',1.83),('15128','2014-02-07','13:40:00',1.64),('15128','2014-02-07','13:45:00',1.39),('15128','2014-02-07','13:50:00',1.41),('15128','2014-02-07','13:55:00',1.82),('15128','2014-02-07','14:00:00',2.96),('15128','2014-02-07','14:05:00',3.02),('15128','2014-02-07','14:10:00',2.88),('15128','2014-02-07','14:15:00',2.21),('15128','2014-02-07','14:20:00',1.96),('15128','2014-02-07','14:25:00',2.87),('15128','2014-02-07','14:30:00',1.16),('15128','2014-02-07','14:35:00',2.3),('15128','2014-02-07','14:40:00',2.82),('15128','2014-02-07','14:55:00',1.32),('15128','2014-02-07','15:00:00',1.7),('15128','2014-02-07','15:05:00',1.28),('15128','2014-02-07','15:10:00',1.16),('15128','2014-02-07','15:20:00',1.97),('15128','2014-02-07','15:25:00',1.27),('15128','2014-02-07','15:55:00',1.33),('15128','2014-02-06','09:35:00',1.02),('15128','2014-02-06','09:40:00',1.11),('15128','2014-02-06','09:45:00',1.15),('15128','2014-02-06','09:50:00',1.24),('15128','2014-02-06','09:55:00',1.27),('15128','2014-02-06','10:00:00',1.3),('15128','2014-02-06','10:05:00',1.35),('15128','2014-02-06','10:10:00',1.41),('15128','2014-02-06','10:15:00',1.53),('15128','2014-02-06','10:20:00',1.54),('15128','2014-02-06','10:25:00',1.61),('15128','2014-02-06','10:30:00',1.68),('15128','2014-02-06','10:35:00',1.73),('15128','2014-02-06','10:40:00',1.87),('15128','2014-02-06','10:45:00',1.92),('15128','2014-02-06','10:50:00',1.92),('15128','2014-02-06','10:55:00',1.86),('15128','2014-02-06','11:10:00',1.83),('15128','2014-02-06','11:15:00',1.44),('15128','2014-02-06','11:25:00',1.24),('15128','2014-02-06','11:30:00',2.42),('15128','2014-02-06','11:35:00',1.11),('15128','2014-02-06','11:40:00',2.3),('15128','2014-02-06','11:45:00',1.15),('15128','2014-02-06','11:50:00',1.83),('15128','2014-02-06','11:55:00',2.69),('15128','2014-02-06','12:00:00',3.02),('15128','2014-02-06','12:05:00',2),('15128','2014-02-06','12:10:00',2.99),('15128','2014-02-06','12:15:00',3.09),('15128','2014-02-06','12:20:00',2.11),('15128','2014-02-06','12:30:00',2.56),('15128','2014-02-06','12:35:00',2.19),('15128','2014-02-06','12:40:00',1.32),('15128','2014-02-06','12:45:00',3.1),('15128','2014-02-06','12:50:00',1.56),('15128','2014-02-06','12:55:00',1.15),('15128','2014-02-06','13:00:00',3.33),('15128','2014-02-06','13:05:00',1.84),('15128','2014-02-06','13:10:00',2.09),('15128','2014-02-06','13:15:00',1.93),('15128','2014-02-06','13:20:00',2.71),('15128','2014-02-06','13:25:00',1.98),('15128','2014-02-06','13:30:00',1.05),('15128','2014-02-06','13:35:00',3.06),('15128','2014-02-06','13:40:00',2.91),('15128','2014-02-06','13:45:00',2.82),('15128','2014-02-06','13:50:00',2.73),('15128','2014-02-06','13:55:00',2.72),('15128','2014-02-06','14:00:00',2.69),('15128','2014-02-06','14:05:00',2.67),('15128','2014-02-06','14:10:00',2.65),('15128','2014-02-06','14:15:00',2.6),('15128','2014-02-06','14:20:00',2.56),('15128','2014-02-06','14:25:00',2.52),('15128','2014-02-06','14:30:00',2.49),('15128','2014-02-06','14:35:00',2.38),('15128','2014-02-06','14:40:00',2.45),('15128','2014-02-06','14:45:00',2.43),('15128','2014-02-06','14:50:00',2.33),('15128','2014-02-06','15:00:00',2.26),('15128','2014-02-06','15:05:00',2.17),('15128','2014-02-06','15:10:00',2.03),('15128','2014-02-06','15:15:00',2.06),('15128','2014-02-06','15:20:00',1.97),('15128','2014-02-06','15:25:00',1.88),('15128','2014-02-06','15:30:00',1.8),('15128','2014-02-06','15:35:00',1.75),('15128','2014-02-06','15:40:00',1.65),('15128','2014-02-06','15:45:00',1.58),('15128','2014-02-06','15:50:00',1.49),('15128','2014-02-06','15:55:00',1.38),('15128','2014-02-06','16:00:00',1.3),('15128','2014-02-06','16:05:00',1.23),('15128','2014-02-06','16:10:00',1.16),('15128','2014-02-06','16:15:00',1.06),('15128','2014-02-05','09:40:00',1.07),('15128','2014-02-05','09:45:00',1.2),('15128','2014-02-05','09:50:00',1.26),('15128','2014-02-05','09:55:00',1.31),('15128','2014-02-05','10:00:00',1.37),('15128','2014-02-05','10:05:00',1.4),('15128','2014-02-05','10:10:00',1.45),('15128','2014-02-05','10:15:00',1.51),('15128','2014-02-05','10:20:00',1.55),('15128','2014-02-05','10:25:00',1.6),('15128','2014-02-05','10:30:00',1.57),('15128','2014-02-05','10:35:00',1.75),('15128','2014-02-05','10:40:00',1.88),('15128','2014-02-05','10:45:00',1.34),('15128','2014-02-05','10:50:00',2.21),('15128','2014-02-05','10:55:00',2.13),('15128','2014-02-05','11:00:00',2.11),('15128','2014-02-05','11:05:00',2.1),('15128','2014-02-05','11:10:00',2.11),('15128','2014-02-05','11:15:00',1.09),('15128','2014-02-05','11:20:00',2.29),('15128','2014-02-05','11:25:00',2.43),('15128','2014-02-05','11:30:00',2.44),('15128','2014-02-05','11:35:00',2.44),('15128','2014-02-05','11:40:00',2.48),('15128','2014-02-05','11:45:00',2.5),('15128','2014-02-05','11:50:00',2.56),('15128','2014-02-05','11:55:00',2.38),('15128','2014-02-05','12:00:00',2.62),('15128','2014-02-05','12:05:00',2.25),('15128','2014-02-05','12:10:00',2.72),('15128','2014-02-05','12:15:00',2.84),('15128','2014-02-05','12:20:00',2.78),('15128','2014-02-05','12:25:00',2.76),('15128','2014-02-05','12:30:00',2.77),('15128','2014-02-05','12:35:00',2.8),('15128','2014-02-05','12:40:00',2.8),('15128','2014-02-05','12:45:00',2.8),('15128','2014-02-05','12:50:00',2.83),('15128','2014-02-05','12:55:00',2.84),('15128','2014-02-05','13:00:00',2.82),('15128','2014-02-05','13:05:00',2.82),('15128','2014-02-05','13:10:00',2.83),('15128','2014-02-05','13:15:00',2.83),('15128','2014-02-05','13:20:00',2.82),('15128','2014-02-05','13:25:00',2.83),('15128','2014-02-05','13:30:00',2.8),('15128','2014-02-05','13:35:00',2.79),('15128','2014-02-05','13:40:00',2.78),('15128','2014-02-05','13:45:00',2.73),('15128','2014-02-05','13:50:00',2.73),('15128','2014-02-05','13:55:00',1.86),('15128','2014-02-05','14:00:00',2.69),('15128','2014-02-05','14:05:00',2.68),('15128','2014-02-05','14:10:00',2.62),('15128','2014-02-05','14:15:00',2.57),('15128','2014-02-05','14:20:00',2.54),('15128','2014-02-05','14:25:00',2.19),('15128','2014-02-05','14:30:00',2.49),('15128','2014-02-05','14:35:00',2.42),('15128','2014-02-05','14:40:00',2.21),('15128','2014-02-05','14:45:00',2.31),('15128','2014-02-05','14:50:00',2.27),('15128','2014-02-05','14:55:00',2.22),('15128','2014-02-05','15:00:00',2.17),('15128','2014-02-05','15:05:00',2.1),('15128','2014-02-05','15:10:00',2.05),('15128','2014-02-05','15:15:00',1.98),('15128','2014-02-05','15:20:00',1.91),('15128','2014-02-05','15:25:00',1.83),('15128','2014-02-05','15:30:00',1.78),('15128','2014-02-05','15:35:00',1.72),('15128','2014-02-05','15:40:00',1.65),('15128','2014-02-05','15:45:00',1.57),('15128','2014-02-05','15:50:00',1.47),('15128','2014-02-05','15:55:00',1.39),('15128','2014-02-05','16:00:00',1.3),('15128','2014-02-05','16:05:00',1.2),('15128','2014-02-05','16:10:00',1.12),('15128','2014-02-05','16:15:00',1.03),('15128','2014-04-26','08:50:00',1.02),('15128','2014-04-26','08:55:00',1.17),('15128','2014-04-26','10:05:00',1.04),('15128','2014-04-26','10:10:00',1.49),('15128','2014-04-26','10:15:00',1.5),('15128','2014-04-26','10:20:00',1.6),('15128','2014-04-26','10:25:00',1.16),('15128','2014-04-26','10:45:00',1.33),('15128','2014-04-26','10:50:00',1.19),('15128','2014-04-26','11:05:00',1.28),('15128','2014-04-26','11:10:00',1.17),('15128','2014-04-26','11:25:00',1.81),('15128','2014-04-26','11:30:00',2.23),('15128','2014-04-26','11:35:00',2.9),('15128','2014-04-26','11:40:00',2.34),('15128','2014-04-26','11:45:00',2.25),('15128','2014-04-26','11:50:00',1.68),('15128','2014-04-26','11:55:00',1.92),('15128','2014-04-26','12:00:00',1.77),('15128','2014-04-26','12:05:00',1.82),('15128','2014-04-26','12:10:00',1.98),('15128','2014-04-26','12:15:00',1.38),('15128','2014-04-26','12:20:00',1.36),('15128','2014-04-26','12:25:00',1.81),('15128','2014-04-26','12:30:00',2.31),('15128','2014-04-26','12:35:00',2.57),('15128','2014-04-26','12:40:00',2.43),('15128','2014-04-26','12:45:00',1.88),('15128','2014-04-26','12:50:00',1.93),('15128','2014-04-26','12:55:00',1.3),('15128','2014-04-26','13:00:00',1.13),('15128','2014-04-26','13:05:00',1.78),('15128','2014-04-26','13:10:00',1.6),('15128','2014-04-26','13:15:00',1.7),('15128','2014-04-26','13:20:00',2.05),('15128','2014-04-26','13:25:00',2.69),('15128','2014-04-26','13:30:00',2.35),('15128','2014-04-26','13:35:00',1.66),('15128','2014-04-26','13:40:00',1.31),('15128','2014-04-26','13:45:00',1.5),('15128','2014-04-26','13:50:00',2.35),('15128','2014-04-26','13:55:00',1.55),('15128','2014-04-26','14:00:00',1.88),('15128','2014-04-26','14:05:00',1.62),('15128','2014-04-26','14:10:00',1.39),('15128','2014-04-26','14:15:00',1.47),('15128','2014-04-26','14:20:00',1.99),('15128','2014-04-26','14:25:00',2.12),('15128','2014-04-26','14:30:00',1.75),('15128','2014-04-26','14:35:00',1.86),('15128','2014-04-26','14:40:00',1.81),('15128','2014-04-26','14:45:00',2.28),('15128','2014-04-26','14:50:00',1.77),('15128','2014-04-26','14:55:00',1.8),('15128','2014-04-26','15:00:00',2.39),('15128','2014-04-26','15:05:00',2.77),('15128','2014-04-26','15:10:00',3.02),('15128','2014-04-26','15:15:00',3.43),('15128','2014-04-26','15:20:00',1.65),('15128','2014-04-26','15:35:00',1.22),('15128','2014-04-26','15:40:00',1.22),('15128','2014-02-04','10:15:00',1.09),('15128','2014-02-04','10:20:00',1.08),('15128','2014-02-04','10:25:00',1.26),('15128','2014-02-04','10:30:00',1.88),('15128','2014-02-04','10:35:00',1.75),('15128','2014-02-04','10:40:00',1.74),('15128','2014-02-04','10:45:00',1.83),('15128','2014-02-04','10:50:00',1.81),('15128','2014-02-04','10:55:00',1.78),('15128','2014-02-04','11:00:00',1.75),('15128','2014-02-04','11:05:00',1.39),('15128','2014-02-04','11:10:00',1.62),('15128','2014-02-04','11:15:00',2.34),('15128','2014-02-04','11:20:00',1.68),('15128','2014-02-04','12:30:00',1.02),('15128','2014-02-04','12:35:00',1.05),('15128','2014-02-04','12:40:00',1.21),('15128','2014-02-04','12:45:00',1.98),('15128','2014-02-04','12:50:00',1.45),('15128','2014-02-04','12:55:00',1.81),('15128','2014-02-04','13:00:00',1.97),('15128','2014-02-04','13:05:00',1.94),('15128','2014-02-04','13:10:00',1.48),('15128','2014-02-04','13:30:00',1.09),('15128','2014-02-04','13:35:00',1.47),('15128','2014-02-04','13:40:00',1.52),('15128','2014-02-04','13:45:00',1.41),('15128','2014-02-04','14:10:00',1.07),('15128','2014-02-04','14:15:00',1.05),('15128','2014-02-04','14:20:00',2.3),('15128','2014-02-04','14:25:00',2.76),('15128','2014-02-04','14:30:00',1.89),('15128','2014-02-04','14:35:00',1.62),('15128','2014-02-04','14:40:00',1.1),('15128','2014-02-04','14:50:00',1.13),('15128','2014-02-04','14:55:00',1.07),('15128','2014-02-04','15:25:00',1.09),('15128','2014-02-03','09:40:00',1.02),('15128','2014-02-03','09:45:00',1.28),('15128','2014-02-03','09:50:00',1.3),('15128','2014-02-03','09:55:00',1.32),('15128','2014-02-03','10:00:00',1.35),('15128','2014-02-03','10:05:00',1.41),('15128','2014-02-03','10:10:00',1.36),('15128','2014-02-03','10:15:00',1.51),('15128','2014-02-03','10:20:00',1.6),('15128','2014-02-03','10:25:00',1.61),('15128','2014-02-03','10:30:00',1.67),('15128','2014-02-03','10:35:00',1.94),('15128','2014-02-03','10:40:00',1.32),('15128','2014-02-03','10:45:00',1.83),('15128','2014-02-03','10:50:00',1.9),('15128','2014-02-03','10:55:00',1.82),('15128','2014-02-03','11:00:00',1.16),('15128','2014-02-03','11:05:00',1.57),('15128','2014-02-03','11:10:00',2.03),('15128','2014-02-03','11:15:00',1.52),('15128','2014-02-03','11:20:00',2.47),('15128','2014-02-03','11:35:00',1.11),('15128','2014-02-03','11:40:00',1.32),('15128','2014-02-03','11:45:00',1.23),('15128','2014-02-03','11:50:00',1.03),('15128','2014-02-03','12:00:00',1),('15128','2014-02-03','12:05:00',1.09),('15128','2014-02-03','12:50:00',1.32),('15128','2014-02-03','12:55:00',1.26),('15128','2014-02-03','13:00:00',1.2),('15128','2014-02-03','13:05:00',1.09),('15128','2014-02-03','13:10:00',1.55),('15128','2014-02-03','13:15:00',1.61),('15128','2014-02-03','13:20:00',1.19),('15128','2014-02-02','10:25:00',1.01),('15128','2014-02-02','11:30:00',1.03),('15128','2014-02-02','11:35:00',1.08),('15128','2014-02-02','11:40:00',1.13),('15128','2014-02-02','11:45:00',1.17),('15128','2014-02-02','11:50:00',1.16),('15128','2014-02-02','11:55:00',1.12),('15128','2014-02-02','12:00:00',1.08),('15128','2014-02-02','12:05:00',1.02),('15128','2014-02-02','12:10:00',1.04),('15128','2014-02-02','12:15:00',1.05),('15128','2014-02-02','12:25:00',1.01),('15128','2014-02-02','12:35:00',1.03),('15128','2014-02-02','12:40:00',1.02),('15128','2014-01-31','11:00:00',1.09),('15128','2014-01-31','11:05:00',1.11),('15128','2014-01-31','11:10:00',1.17),('15128','2014-01-31','11:15:00',1.52),('15128','2014-01-31','11:20:00',1.77),('15128','2014-01-31','11:25:00',1.85),('15128','2014-01-31','11:30:00',1.68),('15128','2014-01-31','11:35:00',1.74),('15128','2014-01-31','11:40:00',1.88),('15128','2014-01-31','11:45:00',1.79),('15128','2014-01-31','11:50:00',1.57),('15128','2014-01-31','11:55:00',1.39),('15128','2014-01-31','12:05:00',1.58),('15128','2014-01-31','12:10:00',1.96),('15128','2014-01-31','12:15:00',1.63),('15128','2014-01-31','12:30:00',1.35),('15128','2014-01-31','12:35:00',2.01),('15128','2014-01-31','12:40:00',1.89),('15128','2014-01-31','12:45:00',2.05),('15128','2014-01-31','12:50:00',1.92),('15128','2014-01-31','12:55:00',1.87),('15128','2014-01-31','13:00:00',1.39),('15128','2014-01-30','10:35:00',1.08),('15128','2014-01-29','09:55:00',1.14),('15128','2014-01-29','10:00:00',1.29),('15128','2014-01-29','10:05:00',1.75),('15128','2014-01-29','10:10:00',1.85),('15128','2014-01-29','10:15:00',1.43),('15128','2014-01-29','10:20:00',1.22),('15128','2014-01-29','10:25:00',1.21),('15128','2014-01-29','10:30:00',1.2),('15128','2014-01-29','10:35:00',1.38),('15128','2014-01-29','10:40:00',1.16),('15128','2014-01-29','10:45:00',1.19),('15128','2014-01-29','10:50:00',1.3),('15128','2014-01-29','10:55:00',1.13),('15128','2014-01-29','11:00:00',1.37),('15128','2014-01-29','11:05:00',1.52),('15128','2014-01-29','11:10:00',1.48),('15128','2014-01-29','11:15:00',1.96),('15128','2014-01-29','11:20:00',1.59),('15128','2014-01-29','11:25:00',2.07),('15128','2014-01-29','11:30:00',2.08),('15128','2014-01-29','11:35:00',1.91),('15128','2014-01-29','11:40:00',2.38),('15128','2014-01-29','11:45:00',2.55),('15128','2014-01-29','11:50:00',2.51),('15128','2014-01-29','11:55:00',2.47),('15128','2014-01-29','12:00:00',2.01),('15128','2014-01-29','12:05:00',2.2),('15128','2014-01-29','12:10:00',1.45),('15128','2014-01-29','12:15:00',1.31),('15128','2014-01-29','12:20:00',1.87),('15128','2014-01-29','12:25:00',2.17),('15128','2014-01-29','12:30:00',2.22),('15128','2014-01-29','12:35:00',2.55),('15128','2014-01-29','12:40:00',2.57),('15128','2014-01-29','12:45:00',2.53),('15128','2014-01-29','12:50:00',2.52),('15128','2014-01-29','12:55:00',2.56),('15128','2014-01-29','13:00:00',2.58),('15128','2014-01-29','13:05:00',2.6),('15128','2014-01-29','13:10:00',2.68),('15128','2014-01-29','13:15:00',2.62),('15128','2014-01-29','13:20:00',2.6),('15128','2014-01-29','13:25:00',2.42),('15128','2014-01-29','13:30:00',1.95),('15128','2014-01-29','13:35:00',1.93),('15128','2014-01-29','13:40:00',2.09),('15128','2014-01-29','13:45:00',2.67),('15128','2014-01-29','13:50:00',2.67),('15128','2014-01-29','13:55:00',2.4),('15128','2014-01-29','14:00:00',1.98),('15128','2014-01-29','14:05:00',1.88),('15128','2014-01-29','14:10:00',2.06),('15128','2014-01-29','14:15:00',1.92),('15128','2014-01-29','14:20:00',1.52),('15128','2014-01-29','14:25:00',1.63),('15128','2014-01-29','14:30:00',1.82),('15128','2014-01-29','14:35:00',1.54),('15128','2014-01-29','14:40:00',1.87),('15128','2014-01-29','14:45:00',2.26),('15128','2014-01-29','14:50:00',2.16),('15128','2014-01-29','14:55:00',2.09),('15128','2014-01-29','15:00:00',1.9),('15128','2014-01-29','15:05:00',1.62),('15128','2014-01-29','15:10:00',1.31),('15128','2014-01-29','15:15:00',1.66),('15128','2014-01-29','15:20:00',1.7),('15128','2014-01-29','15:25:00',1.69),('15128','2014-01-29','15:30:00',1.23),('15128','2014-01-29','15:35:00',1.36),('15128','2014-01-29','15:40:00',1.16),('15128','2014-01-28','09:35:00',1.01),('15128','2014-01-28','10:05:00',1.01),('15128','2014-01-28','10:10:00',1.05),('15128','2014-01-28','10:20:00',2.04),('15128','2014-01-28','10:25:00',1.63),('15128','2014-01-28','10:30:00',1.55),('15128','2014-01-28','10:35:00',1.44),('15128','2014-01-28','10:40:00',1.41),('15128','2014-01-28','10:45:00',1.28),('15128','2014-01-28','10:50:00',1.35),('15128','2014-01-28','10:55:00',1.39),('15128','2014-01-28','11:00:00',1.6),('15128','2014-01-28','11:05:00',1.84),('15128','2014-01-28','11:10:00',1.58),('15128','2014-01-28','11:15:00',1.5),('15128','2014-01-28','11:20:00',1.53),('15128','2014-01-28','11:25:00',1.41),('15128','2014-01-28','11:30:00',1.57),('15128','2014-01-28','11:35:00',1.96),('15128','2014-01-28','11:40:00',2.16),('15128','2014-01-28','11:45:00',2.33),('15128','2014-01-28','11:50:00',1.11),('15128','2014-01-28','12:15:00',1.01),('15128','2014-01-28','12:20:00',1.23),('15128','2014-01-28','12:35:00',1.2),('15128','2014-01-28','12:40:00',1.8),('15128','2014-01-28','12:45:00',2.21),('15128','2014-01-28','12:50:00',2.96),('15128','2014-01-28','12:55:00',2.6),('15128','2014-01-28','13:00:00',2.43),('15128','2014-01-28','13:05:00',2.43),('15128','2014-01-28','13:35:00',1.69),('15128','2014-01-28','13:40:00',2.18),('15128','2014-01-28','13:45:00',2.43),('15128','2014-01-28','13:50:00',2.92),('15128','2014-01-28','13:55:00',2.88),('15128','2014-01-28','14:00:00',2.43),('15128','2014-01-28','14:05:00',1.29),('15128','2014-01-27','09:50:00',1.12),('15128','2014-01-27','09:55:00',1.14),('15128','2014-01-27','10:00:00',1.18),('15128','2014-01-27','10:05:00',1.26),('15128','2014-01-27','10:10:00',1.37),('15128','2014-01-27','10:15:00',1.47),('15128','2014-01-27','10:20:00',1.54),('15128','2014-01-27','10:25:00',1.54),('15128','2014-01-27','10:30:00',1.61),('15128','2014-01-27','10:35:00',1.82),('15128','2014-01-27','10:40:00',1),('15128','2014-01-27','10:45:00',1.24),('15128','2014-01-27','10:55:00',1.56),('15128','2014-01-27','11:00:00',1.47),('15128','2014-01-27','11:05:00',1.24),('15128','2014-01-27','11:10:00',1.25),('15128','2014-01-27','11:15:00',1.74),('15128','2014-01-27','11:20:00',2.23),('15128','2014-01-27','11:25:00',1.81),('15128','2014-01-27','11:30:00',2.36),('15128','2014-01-27','11:35:00',2.49),('15128','2014-01-27','11:40:00',2.55),('15128','2014-01-27','11:45:00',2.74),('15128','2014-01-27','11:50:00',2.45),('15128','2014-01-27','11:55:00',2.42),('15128','2014-01-27','12:00:00',2.11),('15128','2014-01-27','12:05:00',2.03),('15128','2014-01-27','12:10:00',1.88),('15128','2014-01-27','12:15:00',1.57),('15128','2014-01-27','12:20:00',1.19),('15128','2014-01-27','12:25:00',1.18),('15128','2014-01-27','12:30:00',1.22),('15128','2014-01-27','12:35:00',1.32),('15128','2014-01-27','12:40:00',1.23),('15128','2014-01-27','12:45:00',2.49),('15128','2014-01-27','12:50:00',3.31),('15128','2014-01-27','12:55:00',2.3),('15128','2014-01-27','13:00:00',3.02),('15128','2014-01-27','13:05:00',2.37),('15128','2014-01-27','13:10:00',2.57),('15128','2014-01-27','13:15:00',2.67),('15128','2014-01-27','13:20:00',2.5),('15128','2014-01-27','13:25:00',2.65),('15128','2014-01-27','13:30:00',2.54),('15128','2014-01-27','13:35:00',2.83),('15128','2014-01-27','13:40:00',2.81),('15128','2014-01-27','13:45:00',2.66),('15128','2014-01-27','13:50:00',2.61),('15128','2014-01-27','13:55:00',2.56),('15128','2014-01-27','14:00:00',2.53),('15128','2014-01-27','14:05:00',2.5),('15128','2014-01-27','14:10:00',2.45),('15128','2014-01-27','14:15:00',2.41),('15128','2014-01-27','14:20:00',2.38),('15128','2014-01-27','14:25:00',2.36),('15128','2014-01-27','14:30:00',2.32),('15128','2014-01-27','14:35:00',2.25),('15128','2014-01-27','14:40:00',2.22),('15128','2014-01-27','14:45:00',2.17),('15128','2014-01-27','14:50:00',2.11),('15128','2014-01-27','14:55:00',2.06),('15128','2014-01-27','15:00:00',2),('15128','2014-01-27','15:05:00',1.93),('15128','2014-01-27','15:10:00',1.87),('15128','2014-01-27','15:15:00',1.79),('15128','2014-01-27','15:20:00',1.73),('15128','2014-01-27','15:25:00',1.69),('15128','2014-01-27','15:30:00',1.61),('15128','2014-01-27','15:35:00',1.51),('15128','2014-01-27','15:40:00',1.42),('15128','2014-01-27','15:45:00',1.33),('15128','2014-01-27','15:50:00',1.21),('15128','2014-01-27','15:55:00',1.11),('15128','2014-01-27','16:00:00',1),('15529','2014-05-04','08:40:00',1.05),('15529','2014-05-04','08:45:00',1.1),('15529','2014-05-04','08:50:00',1.16),('15529','2014-05-04','08:55:00',1.2),('15529','2014-05-04','09:00:00',1.25),('15529','2014-05-04','09:05:00',1.29),('15529','2014-05-04','09:10:00',1.33),('15529','2014-05-04','09:15:00',1.37),('15529','2014-05-04','09:20:00',1.41),('15529','2014-05-04','09:25:00',1.46),('15529','2014-05-04','09:30:00',1.49),('15529','2014-05-04','09:35:00',1.55),('15529','2014-05-04','09:40:00',1.58),('15529','2014-05-04','09:45:00',1.63),('15529','2014-05-04','09:50:00',1.67),('15529','2014-05-04','09:55:00',1.74),('15529','2014-05-04','10:00:00',1.76),('15529','2014-05-04','10:05:00',1.78),('15529','2014-05-04','10:10:00',1.82),('15529','2014-05-04','10:15:00',1.85),('15529','2014-05-04','10:20:00',1.88),('15529','2014-05-04','10:25:00',1.92),('15529','2014-05-04','10:30:00',1.95),('15529','2014-05-04','10:35:00',2),('15529','2014-05-04','10:40:00',2.03),('15529','2014-05-04','10:45:00',2.03),('15529','2014-05-04','10:50:00',2.04),('15529','2014-05-04','10:55:00',2.07),('15529','2014-05-04','11:00:00',2.09),('15529','2014-05-04','11:05:00',2.11),('15529','2014-05-04','11:10:00',2.13),('15529','2014-05-04','11:15:00',2.07),('15529','2014-05-04','11:20:00',2.17),('15529','2014-05-04','11:25:00',2.21),('15529','2014-05-04','11:30:00',2.26),('15529','2014-05-04','11:35:00',2.26),('15529','2014-05-04','11:40:00',2.23),('15529','2014-05-04','11:45:00',2.27),('15529','2014-05-04','11:50:00',2.39),('15529','2014-05-04','11:55:00',2.48),('15529','2014-05-04','12:00:00',2.41),('15529','2014-05-04','12:05:00',1.22),('15529','2014-05-04','12:10:00',2),('15529','2014-05-04','12:15:00',1.52),('15529','2014-05-04','12:20:00',2.5),('15529','2014-05-04','12:25:00',2.64),('15529','2014-05-04','12:30:00',2.11),('15529','2014-05-04','12:35:00',2.17),('15529','2014-05-04','12:40:00',1.48),('15529','2014-05-04','12:45:00',1.3),('15529','2014-05-04','12:50:00',1.08),('15529','2014-05-04','12:55:00',2.29),('15529','2014-05-04','13:00:00',2.51),('15529','2014-05-04','13:05:00',2.54),('15529','2014-05-04','13:10:00',2.42),('15529','2014-05-04','13:15:00',2.4),('15529','2014-05-04','13:20:00',2.39),('15529','2014-05-04','13:25:00',2.1),('15529','2014-05-04','14:00:00',2.64),('15529','2014-05-04','14:05:00',2.53),('15529','2014-05-04','14:10:00',2.53),('15529','2014-05-04','14:15:00',2.49),('15529','2014-05-04','14:20:00',1.84),('15529','2014-05-04','14:25:00',2.09),('15529','2014-05-04','14:30:00',2.5),('15529','2014-05-04','14:35:00',2.09),('15529','2014-05-04','14:40:00',1.29),('15529','2014-05-04','14:45:00',1.52),('15529','2014-05-04','14:55:00',1.01),('15529','2014-05-04','15:00:00',1.94),('15529','2014-05-04','15:05:00',2.44),('15529','2014-05-04','15:10:00',1.75),('15529','2014-05-04','15:15:00',1.92),('15529','2014-05-04','15:20:00',2.21),('15529','2014-05-04','15:25:00',1.29),('15529','2014-05-04','15:30:00',2.04),('15529','2014-05-04','15:35:00',1.69),('15529','2014-05-04','15:40:00',2.12),('15529','2014-05-04','15:45:00',1.85),('15529','2014-05-04','15:50:00',1.58),('15529','2014-05-04','15:55:00',1.51),('15529','2014-05-04','16:00:00',1.98),('15529','2014-05-04','16:05:00',1.31),('15529','2014-05-04','16:10:00',1.83),('15529','2014-05-04','16:15:00',2),('15529','2014-05-04','16:20:00',1.61),('15529','2014-05-04','16:25:00',1.71),('15529','2014-05-04','16:30:00',1.7),('15529','2014-05-04','16:35:00',1.6),('15529','2014-05-04','16:40:00',1.51),('15529','2014-05-04','16:45:00',1.44),('15529','2014-05-04','16:50:00',1.37),('15529','2014-05-04','16:55:00',1.32),('15529','2014-05-04','17:00:00',1.28),('15529','2014-05-04','17:05:00',1.22),('15529','2014-05-04','17:10:00',1.19),('15529','2014-05-04','17:15:00',1.14),('15529','2014-05-04','17:20:00',1.09),('15529','2014-05-04','17:25:00',1.03),('15529','2014-04-25','10:35:00',1.01),('15529','2014-04-25','10:50:00',1.04),('15529','2014-04-25','10:55:00',1.56),('15529','2014-04-25','11:00:00',1.96),('15529','2014-04-25','11:05:00',2.03),('15529','2014-04-25','11:10:00',1.65),('15529','2014-04-25','11:15:00',1.72),('15529','2014-04-25','11:20:00',1.8),('15529','2014-04-25','11:25:00',1.66),('15529','2014-04-25','11:30:00',1.78),('15529','2014-04-25','11:35:00',1.76),('15529','2014-04-25','11:40:00',1.67),('15529','2014-04-25','11:45:00',1.69),('15529','2014-04-25','11:50:00',1.79),('15529','2014-04-25','11:55:00',1.65),('15529','2014-04-25','12:00:00',1.56),('15529','2014-04-25','12:05:00',1.46),('15529','2014-04-25','12:10:00',1.44),('15529','2014-04-25','12:15:00',1.48),('15529','2014-04-25','12:25:00',1.43),('15529','2014-04-25','12:30:00',1.24),('15529','2014-04-25','12:35:00',1.62),('15529','2014-04-25','12:40:00',1.41),('15529','2014-04-25','12:50:00',1.59),('15529','2014-04-25','12:55:00',2.27),('15529','2014-04-25','13:00:00',2.45),('15529','2014-04-25','13:05:00',2.41),('15529','2014-04-25','13:10:00',1.94),('15529','2014-04-25','13:15:00',1.98),('15529','2014-04-25','13:20:00',2.32),('15529','2014-04-25','13:25:00',2.48),('15529','2014-04-25','13:30:00',1.66),('15529','2014-04-25','13:40:00',1.38),('15529','2014-04-25','13:45:00',1.46),('15529','2014-04-25','13:50:00',1.23),('15529','2014-04-25','13:55:00',2.01),('15529','2014-01-25','09:05:00',1.09),('15529','2014-01-25','10:15:00',1.1),('15529','2014-01-25','12:25:00',1.03),('15529','2014-01-25','12:30:00',1.63),('15529','2014-01-24','10:10:00',1.82),('15529','2014-01-24','10:15:00',1.87),('15529','2014-01-24','10:20:00',1.51),('15529','2014-01-24','10:25:00',1.02),('15529','2014-01-24','10:30:00',1.22),('15529','2014-01-24','10:35:00',1.33),('15529','2014-01-24','10:40:00',1.35),('15529','2014-01-24','10:45:00',1.02),('15529','2014-01-24','10:50:00',1.4),('15529','2014-01-24','10:55:00',1.59),('15529','2014-01-24','11:00:00',1.96),('15529','2014-01-24','11:05:00',1.68),('15529','2014-01-24','11:10:00',1.39),('15529','2014-01-24','11:15:00',1.83),('15529','2014-01-24','11:20:00',2.15),('15529','2014-01-24','11:25:00',1.91),('15529','2014-01-24','11:30:00',1.83),('15529','2014-01-24','11:35:00',1.25),('15529','2014-01-24','12:05:00',1.04),('15529','2014-01-24','12:10:00',1.06),('15529','2014-01-24','12:15:00',1.13),('15529','2014-01-24','12:20:00',1.08),('15529','2014-01-24','12:25:00',1.16),('15529','2014-01-24','12:30:00',1.07),('15529','2014-01-24','12:35:00',1),('15529','2014-01-24','12:40:00',1.26),('15529','2014-01-24','12:45:00',1.43),('15529','2014-01-24','12:50:00',1.43),('15529','2014-01-24','12:55:00',1.77),('15529','2014-01-24','13:00:00',1.93),('15529','2014-01-24','13:05:00',1.98),('15529','2014-01-24','13:10:00',1.97),('15529','2014-01-24','13:15:00',1.88),('15529','2014-01-24','13:20:00',1.85),('15529','2014-01-24','13:25:00',1.89),('15529','2014-01-24','13:30:00',1.04),('15529','2014-01-24','14:05:00',1.35),('15529','2014-01-24','14:10:00',1.6),('15529','2014-01-24','14:15:00',1.25),('15529','2014-01-24','14:20:00',1.28),('15529','2014-01-24','14:25:00',1.59),('15529','2014-01-24','14:30:00',1.74),('15529','2014-01-24','14:35:00',1.74),('15529','2014-01-24','14:45:00',1.57),('15529','2014-01-24','14:50:00',1.43),('15529','2014-01-24','14:55:00',1.17),('15529','2014-01-24','15:00:00',1.5),('15529','2014-01-24','15:05:00',1.4),('15529','2014-01-24','15:10:00',1.35),('15529','2014-01-24','15:15:00',1.29),('15529','2014-01-24','15:20:00',1.23),('15529','2014-01-24','15:25:00',1.17),('15529','2014-01-24','15:30:00',1.11),('15529','2014-01-24','15:35:00',1.05),('15529','2014-01-24','15:40:00',1),('15529','2014-01-23','10:15:00',1.09),('15529','2014-01-23','10:25:00',2.03),('15529','2014-01-23','10:35:00',1.56),('15529','2014-01-23','10:40:00',1.9),('15529','2014-01-23','10:45:00',1.42),('15529','2014-01-23','11:30:00',1.29),('15529','2014-01-23','11:45:00',2.24),('15529','2014-01-23','11:50:00',2.22),('15529','2014-01-23','11:55:00',1.18),('15529','2014-01-23','12:00:00',1.82),('15529','2014-01-23','12:05:00',1.85),('15529','2014-01-23','12:25:00',1.4),('15529','2014-01-23','12:35:00',1.66),('15529','2014-01-23','12:40:00',1.55),('15529','2014-01-23','12:45:00',1.02),('15529','2014-01-23','12:55:00',1.18),('15529','2014-01-23','13:00:00',1.07),('15529','2014-01-23','13:05:00',1.2),('15529','2014-01-23','13:35:00',1.04),('15529','2014-01-23','13:40:00',1.53),('15529','2014-01-23','14:05:00',1.19),('15529','2014-01-23','14:10:00',1.26),('15529','2014-01-23','14:15:00',1.76),('15529','2014-01-23','14:20:00',1.88),('15529','2014-01-23','14:35:00',1.44),('15529','2014-01-20','12:10:00',1.06),('15529','2014-01-20','12:15:00',1),('15529','2014-01-19','11:25:00',1.31),('15529','2014-01-19','11:30:00',1.36),('15529','2014-01-19','11:35:00',1.48),('15529','2014-01-19','11:40:00',1.09),('15529','2014-01-19','11:45:00',1.11),('15529','2014-01-19','13:20:00',1.01),('15529','2014-01-19','13:25:00',2),('15529','2014-01-19','13:30:00',1.33),('15529','2014-01-19','13:35:00',1.92),('15529','2014-01-19','13:40:00',1.43),('15529','2014-01-19','14:00:00',1.22),('15529','2014-01-19','14:10:00',1.57),('15529','2014-01-18','14:25:00',1.11),('15529','2014-01-18','14:30:00',1.04),('15529','2014-01-17','10:05:00',1.52),('15529','2014-01-17','10:10:00',1.49),('15529','2014-01-17','10:15:00',1.77),('15529','2014-01-17','10:20:00',1.3),('15529','2014-01-17','10:25:00',1.1),('15529','2014-01-17','10:30:00',1),('15529','2014-01-17','11:05:00',1.51),('15529','2014-01-17','11:10:00',2.04),('15529','2014-01-17','11:15:00',1.99),('15529','2014-01-17','11:20:00',1.9),('15529','2014-01-17','11:25:00',1.87),('15529','2014-01-17','11:30:00',1.9),('15529','2014-01-17','11:35:00',1.95),('15529','2014-01-17','11:40:00',2.04),('15529','2014-01-17','11:45:00',2.16),('15529','2014-01-17','11:50:00',2.19),('15529','2014-01-17','11:55:00',2.15),('15529','2014-01-17','12:00:00',2.08),('15529','2014-01-17','12:05:00',1.79),('15529','2014-01-17','12:10:00',1.91),('15529','2014-01-17','12:15:00',1.9),('15529','2014-01-17','12:20:00',1.87),('15529','2014-01-17','12:25:00',1.87),('15529','2014-01-17','12:30:00',1.9),('15529','2014-01-17','12:35:00',1.9),('15529','2014-01-17','12:40:00',1.92),('15529','2014-01-17','12:45:00',1.86),('15529','2014-01-17','12:50:00',1.6),('15529','2014-01-17','12:55:00',1.91),('15529','2014-01-17','13:00:00',1.49),('15529','2014-01-17','13:05:00',1.28),('15529','2014-01-17','13:10:00',1.54),('15529','2014-01-17','13:15:00',1.98),('15529','2014-01-17','13:20:00',1.47),('15529','2014-01-17','13:30:00',1.68),('15529','2014-01-17','13:35:00',1.53),('15529','2014-01-17','13:40:00',1.76),('15529','2014-01-17','13:45:00',1.7),('15529','2014-01-17','13:50:00',1.65),('15529','2014-01-17','13:55:00',1.76),('15529','2014-01-17','14:00:00',1.7),('15529','2014-01-17','14:05:00',1.63),('15529','2014-01-17','14:10:00',1.47),('15529','2014-01-17','14:15:00',1.43),('15529','2014-01-17','14:20:00',1.55),('15529','2014-01-17','14:25:00',1.49),('15529','2014-01-17','14:30:00',1.45),('15529','2014-01-17','14:35:00',1.41),('15529','2014-01-17','14:40:00',1.37),('15529','2014-01-17','14:45:00',1.34),('15529','2014-01-17','14:50:00',1.27),('15529','2014-01-16','09:30:00',1.09),('15529','2014-01-16','09:35:00',1.14),('15529','2014-01-16','11:35:00',1.2),('15529','2014-04-24','08:45:00',1.01),('15529','2014-04-24','09:00:00',1.2),('15529','2014-04-24','09:05:00',1.23),('15529','2014-04-24','09:10:00',1.28),('15529','2014-04-24','09:15:00',1.33),('15529','2014-04-24','09:20:00',1.21),('15529','2014-04-24','09:25:00',1.23),('15529','2014-04-24','09:45:00',1.24),('15529','2014-04-24','09:50:00',1.29),('15529','2014-04-24','10:30:00',1.74),('15529','2014-04-24','10:35:00',1),('15529','2014-04-24','10:40:00',1.02),('15529','2014-04-24','11:00:00',1.46),('15529','2014-04-24','11:10:00',1.36),('15529','2014-04-24','11:15:00',2.23),('15529','2014-04-24','11:20:00',2.32),('15529','2014-04-24','11:25:00',1.73),('15529','2014-04-24','11:30:00',1.27),('15529','2014-04-24','11:35:00',2.15),('15529','2014-04-24','11:40:00',2.24),('15529','2014-04-24','11:45:00',2.04),('15529','2014-04-24','11:50:00',1.03),('15529','2014-04-24','11:55:00',1.2),('15529','2014-04-24','12:10:00',1.28),('15529','2014-04-24','12:15:00',2.38),('15529','2014-04-24','12:20:00',2.35),('15529','2014-04-24','12:25:00',2.39),('15529','2014-04-24','12:30:00',2.21),('15529','2014-04-24','12:35:00',2.12),('15529','2014-04-24','12:40:00',2.58),('15529','2014-04-24','12:45:00',2.57),('15529','2014-04-24','12:50:00',2.49),('15529','2014-04-24','12:55:00',2.56),('15529','2014-04-24','13:00:00',2.43),('15529','2014-04-24','13:05:00',1.46),('15529','2014-04-24','13:10:00',2.37),('15529','2014-04-24','13:15:00',2.18),('15529','2014-04-24','13:20:00',1.87),('15529','2014-04-24','13:25:00',1.78),('15529','2014-04-24','13:35:00',1.48),('15529','2014-04-24','13:45:00',1.96),('15529','2014-04-24','13:50:00',1.24),('15529','2014-04-24','13:55:00',2.43),('15529','2014-04-24','14:00:00',1.94),('15529','2014-04-24','14:05:00',2.21),('15529','2014-04-24','14:10:00',1.95),('15529','2014-04-24','14:15:00',1.87),('15529','2014-04-24','14:20:00',2.22),('15529','2014-04-24','14:25:00',2.21),('15529','2014-04-24','14:30:00',2.19),('15529','2014-04-24','14:35:00',2.14),('15529','2014-04-24','14:40:00',2.1),('15529','2014-04-24','14:45:00',2.1),('15529','2014-04-24','14:50:00',2.09),('15529','2014-04-24','14:55:00',2.05),('15529','2014-04-24','15:00:00',2.02),('15529','2014-04-24','15:05:00',1.99),('15529','2014-04-24','15:10:00',2.01),('15529','2014-04-24','15:15:00',1.98),('15529','2014-04-24','15:20:00',1.92),('15529','2014-04-24','15:25:00',1.88),('15529','2014-04-24','15:30:00',1.87),('15529','2014-04-24','15:35:00',1.83),('15529','2014-04-24','15:40:00',1.81),('15529','2014-04-24','15:45:00',1.75),('15529','2014-04-24','15:50:00',1.75),('15529','2014-04-24','15:55:00',1.74),('15529','2014-04-24','16:00:00',1.69),('15529','2014-04-24','16:05:00',1.65),('15529','2014-04-24','16:10:00',1.57),('15529','2014-04-24','16:15:00',1.46),('15529','2014-04-24','16:20:00',1.36),('15529','2014-04-24','16:25:00',1.49),('15529','2014-04-24','16:30:00',1.45),('15529','2014-04-24','16:35:00',1.45),('15529','2014-04-24','16:40:00',1.43),('15529','2014-04-24','16:45:00',1.38),('15529','2014-04-24','16:50:00',1.22),('15529','2014-04-24','17:00:00',1.13),('15529','2014-04-24','17:05:00',1.11),('15529','2014-01-15','09:20:00',1.21),('15529','2014-01-15','09:25:00',1.27),('15529','2014-01-15','09:30:00',1.24),('15529','2014-01-15','09:35:00',1.26),('15529','2014-01-15','09:40:00',1.28),('15529','2014-01-15','10:25:00',1.19),('15529','2014-01-15','10:30:00',1.62),('15529','2014-01-15','10:35:00',1.88),('15529','2014-01-15','10:40:00',1.24),('15529','2014-01-15','10:45:00',1.19),('15529','2014-01-15','10:50:00',1.37),('15529','2014-01-15','10:55:00',1.32),('15529','2014-01-15','11:00:00',1.46),('15529','2014-01-15','11:05:00',1.44),('15529','2014-01-15','11:10:00',1.46),('15529','2014-01-15','11:15:00',1.29),('15529','2014-01-15','11:20:00',1.2),('15529','2014-01-15','11:25:00',1.22),('15529','2014-01-15','11:30:00',1.12),('15529','2014-01-15','11:35:00',1.16),('15529','2014-01-15','11:40:00',1.12),('15529','2014-01-15','11:55:00',1.16),('15529','2014-01-15','12:05:00',1.11),('15529','2014-01-15','12:10:00',1.1),('15529','2014-01-15','12:30:00',1.04),('15529','2014-01-15','12:35:00',1.23),('15529','2014-01-15','12:40:00',1.17),('15529','2014-01-15','12:45:00',1.2),('15529','2014-01-15','12:50:00',1.35),('15529','2014-01-15','12:55:00',1.33),('15529','2014-01-15','13:00:00',1.39),('15529','2014-01-15','13:05:00',1.44),('15529','2014-01-15','13:10:00',1.48),('15529','2014-01-15','13:40:00',1.24),('15529','2014-01-15','13:45:00',1.61),('15529','2014-01-15','13:50:00',1.57),('15529','2014-01-15','13:55:00',1),('15529','2014-01-14','10:10:00',1.12),('15529','2014-01-14','10:15:00',1.39),('15529','2014-01-14','10:20:00',1.65),('15529','2014-01-14','10:25:00',1.44),('15529','2014-01-14','10:30:00',1.08),('15529','2014-01-14','10:35:00',1.1),('15529','2014-01-14','10:40:00',1.17),('15529','2014-01-14','10:45:00',1.29),('15529','2014-01-14','10:50:00',1.02),('15529','2014-01-14','10:55:00',1.92),('15529','2014-01-14','11:00:00',1.53),('15529','2014-01-14','11:05:00',1.93),('15529','2014-01-14','11:10:00',1.88),('15529','2014-01-14','11:15:00',1.86),('15529','2014-01-14','11:20:00',1.67),('15529','2014-01-14','11:25:00',1.39),('15529','2014-01-14','11:30:00',1.63),('15529','2014-01-14','11:35:00',1.27),('15529','2014-01-14','11:40:00',1.55),('15529','2014-01-14','11:45:00',1.5),('15529','2014-01-14','11:50:00',1.48),('15529','2014-01-14','11:55:00',1.18),('15529','2014-01-14','12:00:00',1.13),('15529','2014-01-14','12:20:00',1.16),('15529','2014-01-14','12:55:00',1.09),('15529','2014-01-14','13:00:00',1.51),('15529','2014-01-14','13:05:00',1.6),('15529','2014-01-14','13:10:00',2.01),('15529','2014-01-14','13:15:00',2.01),('15529','2014-01-14','13:20:00',1.93),('15529','2014-01-14','13:25:00',1.89),('15529','2014-01-14','13:30:00',1.56),('15529','2014-01-14','13:40:00',1.14),('15529','2014-01-14','13:50:00',1.15),('15529','2014-01-14','13:55:00',1.66),('15529','2014-01-14','14:00:00',1.64),('15529','2014-01-14','14:05:00',1.63),('15529','2014-01-14','14:10:00',1.6),('15529','2014-01-14','14:15:00',1.58),('15529','2014-01-14','14:20:00',1.56),('15529','2014-01-14','14:25:00',1.55),('15529','2014-01-14','14:30:00',1.51),('15529','2014-01-14','14:35:00',1.44),('15529','2014-01-14','14:40:00',1.4),('15529','2014-01-14','14:45:00',1.36),('15529','2014-01-14','14:50:00',1.32),('15529','2014-01-14','14:55:00',1.29),('15529','2014-01-14','15:00:00',1.25),('15529','2014-01-14','15:05:00',1.2),('15529','2014-01-14','15:10:00',1.14),('15529','2014-01-14','15:15:00',1.09),('15529','2014-01-14','15:20:00',1.05),('15529','2014-01-13','10:25:00',1.05),('15529','2014-01-13','10:30:00',1.94),('15529','2014-01-13','10:35:00',1.78),('15529','2014-01-13','10:40:00',1.09),('15529','2014-01-12','09:20:00',1.06),('15529','2014-01-12','09:25:00',1.09),('15529','2014-01-12','09:30:00',1.12),('15529','2014-01-12','09:35:00',1.16),('15529','2014-01-12','09:40:00',1.2),('15529','2014-01-12','09:45:00',1.23),('15529','2014-01-12','09:50:00',1.27),('15529','2014-01-12','09:55:00',1.32),('15529','2014-01-12','10:00:00',1.34),('15529','2014-01-12','10:05:00',1.38),('15529','2014-01-12','10:10:00',1.4),('15529','2014-01-12','10:15:00',1.43),('15529','2014-01-12','10:20:00',1.44),('15529','2014-01-12','10:25:00',1.47),('15529','2014-01-12','10:30:00',1.51),('15529','2014-01-12','10:35:00',1.52),('15529','2014-01-12','10:40:00',1.53),('15529','2014-01-12','10:45:00',1.57),('15529','2014-01-12','10:50:00',1.58),('15529','2014-01-12','10:55:00',1.6),('15529','2014-01-12','11:00:00',1.61),('15529','2014-01-12','11:05:00',1.62),('15529','2014-01-12','11:10:00',1.65),('15529','2014-01-12','11:15:00',1.67),('15529','2014-01-12','11:20:00',1.67),('15529','2014-01-12','11:25:00',1.67),('15529','2014-01-12','11:30:00',1.68),('15529','2014-01-12','11:35:00',1.69),('15529','2014-01-12','11:40:00',1.69),('15529','2014-01-12','11:45:00',1.71),('15529','2014-01-12','11:50:00',1.7),('15529','2014-01-12','11:55:00',1.7),('15529','2014-01-12','12:00:00',1.69),('15529','2014-01-12','12:05:00',1.67),('15529','2014-01-12','12:10:00',1.67),('15529','2014-01-12','12:15:00',1.68),('15529','2014-01-12','12:20:00',1.68),('15529','2014-01-12','12:25:00',1.7),('15529','2014-01-12','12:30:00',1.71),('15529','2014-01-12','12:35:00',1.69),('15529','2014-01-12','12:40:00',1.67),('15529','2014-01-12','12:45:00',1.63),('15529','2014-01-12','12:50:00',1.6),('15529','2014-01-12','13:00:00',1.43),('15529','2014-01-12','13:05:00',1.45),('15529','2014-01-12','13:10:00',1.6),('15529','2014-01-12','13:15:00',1.55),('15529','2014-01-12','13:20:00',1.53),('15529','2014-01-12','13:25:00',1.5),('15529','2014-01-12','13:30:00',1.47),('15529','2014-01-12','13:35:00',1.49),('15529','2014-01-12','13:40:00',1.48),('15529','2014-01-12','13:45:00',1.45),('15529','2014-01-12','13:50:00',1.42),('15529','2014-01-12','13:55:00',1.44),('15529','2014-01-12','14:00:00',1.38),('15529','2014-01-12','14:05:00',1.37),('15529','2014-01-12','14:10:00',1.33),('15529','2014-01-12','14:15:00',1.33),('15529','2014-01-12','14:20:00',1.28),('15529','2014-01-12','14:25:00',1.25),('15529','2014-01-12','14:30:00',1.26),('15529','2014-01-12','14:35:00',1.22),('15529','2014-01-12','14:40:00',1.19),('15529','2014-01-12','14:45:00',1.18),('15529','2014-01-12','14:50:00',1.13),('15529','2014-01-12','14:55:00',1.08),('15529','2014-01-12','15:00:00',1.04),('15529','2014-01-12','15:05:00',1.02),('15529','2014-01-11','11:05:00',1.02),('15529','2014-01-11','11:10:00',1.19),('15529','2014-01-11','11:15:00',1.05),('15529','2014-01-11','11:45:00',1.42),('15529','2014-01-11','11:50:00',1.26),('15529','2014-01-10','09:55:00',1.12),('15529','2014-01-10','10:00:00',1.03),('15529','2014-01-10','10:20:00',1.15),('15529','2014-01-10','10:25:00',1.19),('15529','2014-01-10','10:30:00',1.21),('15529','2014-01-10','10:35:00',1.36),('15529','2014-01-10','10:40:00',1.61),('15529','2014-01-10','10:45:00',1.67),('15529','2014-01-10','10:50:00',1.67),('15529','2014-01-10','10:55:00',1.63),('15529','2014-01-10','11:00:00',1.58),('15529','2014-01-10','11:05:00',1.55),('15529','2014-01-10','11:10:00',1.63),('15529','2014-01-10','11:15:00',1.39),('15529','2014-01-10','11:20:00',1.32),('15529','2014-01-10','11:25:00',1.35),('15529','2014-01-10','11:30:00',1.34),('15529','2014-01-10','11:35:00',1.17),('15529','2014-01-10','11:40:00',1.1),('15529','2014-01-10','11:45:00',1.13),('15529','2014-01-10','11:50:00',1.24),('15529','2014-01-10','11:55:00',1.21),('15529','2014-01-10','12:00:00',1.3),('15529','2014-01-10','12:05:00',1.32),('15529','2014-01-10','12:10:00',1.31),('15529','2014-01-10','12:15:00',1.35),('15529','2014-01-10','12:20:00',1.33),('15529','2014-01-10','12:25:00',1.12),('15529','2014-01-10','12:30:00',1.28),('15529','2014-01-10','12:35:00',1.06),('15529','2014-01-10','12:40:00',1.01),('15529','2014-01-10','12:45:00',1.07),('15529','2014-01-10','12:50:00',1.35),('15529','2014-01-10','12:55:00',1.4),('15529','2014-01-10','13:05:00',1.05),('15529','2014-01-10','13:15:00',1.23),('15529','2014-01-10','13:20:00',1),('15529','2014-01-08','09:50:00',1.39),('15529','2014-01-08','09:55:00',1.45),('15529','2014-01-08','10:00:00',1.45),('15529','2014-01-08','10:05:00',1.32),('15529','2014-01-08','10:10:00',1.18),('15529','2014-01-08','10:15:00',1.25),('15529','2014-01-08','10:20:00',1.38),('15529','2014-01-08','10:25:00',1.34),('15529','2014-01-08','10:30:00',1.29),('15529','2014-01-08','11:25:00',1.12),('15529','2014-01-07','09:15:00',1.02),('15529','2014-01-07','09:20:00',1.07),('15529','2014-01-07','09:25:00',1.11),('15529','2014-01-07','09:30:00',1.1),('15529','2014-01-07','09:35:00',1.13),('15529','2014-01-07','09:40:00',1.21),('15529','2014-01-07','09:45:00',1.2),('15529','2014-01-07','09:50:00',1.25),('15529','2014-01-07','09:55:00',1.31),('15529','2014-01-07','10:00:00',1.27),('15529','2014-01-07','10:05:00',1.18),('15529','2014-01-07','10:10:00',1.23),('15529','2014-01-07','10:15:00',1.37),('15529','2014-01-07','10:20:00',1.47),('15529','2014-01-07','10:25:00',1.51),('15529','2014-01-07','10:30:00',1.51),('15529','2014-01-07','10:35:00',1.45),('15529','2014-01-07','10:40:00',1.48),('15529','2014-01-07','10:45:00',1.58),('15529','2014-01-07','10:50:00',1.6),('15529','2014-01-07','10:55:00',1.62),('15529','2014-01-07','11:00:00',1.63),('15529','2014-01-07','11:05:00',1.64),('15529','2014-01-07','11:10:00',1.66),('15529','2014-01-07','11:15:00',1.67),('15529','2014-01-07','11:20:00',1.65),('15529','2014-01-07','11:25:00',1.61),('15529','2014-01-07','11:30:00',1.67),('15529','2014-01-07','11:35:00',1.73),('15529','2014-01-07','11:40:00',1.74),('15529','2014-01-07','11:45:00',1.75),('15529','2014-01-07','11:50:00',1.73),('15529','2014-01-07','11:55:00',1.68),('15529','2014-01-07','12:00:00',1.68),('15529','2014-01-07','12:05:00',1.67),('15529','2014-01-07','12:10:00',1.68),('15529','2014-01-07','12:15:00',1.71),('15529','2014-01-07','12:20:00',1.7),('15529','2014-01-07','12:25:00',1.73),('15529','2014-01-07','12:30:00',1.71),('15529','2014-01-07','12:35:00',1.7),('15529','2014-01-07','12:40:00',1.66),('15529','2014-01-07','12:45:00',1.56),('15529','2014-01-07','12:50:00',1.65),('15529','2014-01-07','12:55:00',1.67),('15529','2014-01-07','13:00:00',1.59),('15529','2014-01-07','13:05:00',1.63),('15529','2014-01-07','13:10:00',1.61),('15529','2014-01-07','13:15:00',1.63),('15529','2014-01-07','13:20:00',1.59),('15529','2014-01-07','13:25:00',1.58),('15529','2014-01-07','13:30:00',1.51),('15529','2014-01-07','13:35:00',1.52),('15529','2014-01-07','13:40:00',1.48),('15529','2014-01-07','13:45:00',1.52),('15529','2014-01-07','13:50:00',1.51),('15529','2014-01-07','13:55:00',1.5),('15529','2014-01-07','14:00:00',1.43),('15529','2014-01-07','14:05:00',1.41),('15529','2014-01-07','14:10:00',1.38),('15529','2014-01-07','14:15:00',1.38),('15529','2014-01-07','14:20:00',1.36),('15529','2014-01-07','14:25:00',1.34),('15529','2014-01-07','14:30:00',1.33),('15529','2014-01-07','14:35:00',1.27),('15529','2014-01-07','14:40:00',1.12),('15529','2014-01-07','14:45:00',1.12),('15529','2014-01-06','09:05:00',1.01),('15529','2014-01-06','09:10:00',1.06),('15529','2014-01-06','09:15:00',1.09),('15529','2014-01-06','09:20:00',1.14),('15529','2014-01-06','09:25:00',1.19),('15529','2014-01-06','09:30:00',1.22),('15529','2014-01-06','09:35:00',1.26),('15529','2014-01-06','09:40:00',1.29),('15529','2014-01-06','09:45:00',1.32),('15529','2014-01-06','09:50:00',1.36),('15529','2014-01-06','09:55:00',1.38),('15529','2014-01-06','10:00:00',1.42),('15529','2014-01-06','10:05:00',1.44),('15529','2014-01-06','10:10:00',1.46),('15529','2014-01-06','10:15:00',1.49),('15529','2014-01-06','10:20:00',1.51),('15529','2014-01-06','10:25:00',1.54),('15529','2014-01-06','10:30:00',1.57),('15529','2014-01-06','10:35:00',1.59),('15529','2014-01-06','10:40:00',1.62),('15529','2014-01-06','10:45:00',1.66),('15529','2014-01-06','10:50:00',1.68),('15529','2014-01-06','10:55:00',1.7),('15529','2014-01-06','11:00:00',1.72),('15529','2014-01-06','11:05:00',1.74),('15529','2014-01-06','11:10:00',1.74),('15529','2014-01-06','11:15:00',1.75),('15529','2014-01-06','11:20:00',1.77),('15529','2014-01-06','11:25:00',1.77),('15529','2014-01-06','11:30:00',1.78),('15529','2014-01-06','11:35:00',1.79),('15529','2014-01-06','11:40:00',1.8),('15529','2014-01-06','11:45:00',1.78),('15529','2014-01-06','11:50:00',1.81),('15529','2014-01-06','11:55:00',1.8),('15529','2014-01-06','12:00:00',1.8),('15529','2014-01-06','12:05:00',1.77),('15529','2014-01-06','12:10:00',1.75),('15529','2014-01-06','12:15:00',1.77),('15529','2014-01-06','12:20:00',1.76),('15529','2014-01-06','12:25:00',1.74),('15529','2014-01-06','12:30:00',1.76),('15529','2014-01-06','12:35:00',1.75),('15529','2014-01-06','12:40:00',1.72),('15529','2014-01-06','12:45:00',1.66),('15529','2014-01-06','12:50:00',1.64),('15529','2014-01-06','12:55:00',1.66),('15529','2014-01-06','13:00:00',1.71),('15529','2014-01-06','13:05:00',1.67),('15529','2014-01-06','13:10:00',1.73),('15529','2014-01-06','13:15:00',1.69),('15529','2014-01-06','13:20:00',1.63),('15529','2014-01-06','13:25:00',1.58),('15529','2014-01-06','13:30:00',1.57),('15529','2014-01-06','13:35:00',1.59),('15529','2014-01-06','13:40:00',1.57),('15529','2014-01-06','13:45:00',1.61),('15529','2014-01-06','13:50:00',1.6),('15529','2014-01-06','13:55:00',1.51),('15529','2014-01-06','14:00:00',1.5),('15529','2014-01-06','14:05:00',1.44),('15529','2014-01-06','14:10:00',1.42),('15529','2014-01-06','14:15:00',1.43),('15529','2014-01-06','14:20:00',1.39),('15529','2014-01-06','14:25:00',1.36),('15529','2014-01-06','14:30:00',1.31),('15529','2014-01-06','14:35:00',1.27),('15529','2014-01-06','14:40:00',1.29),('15529','2014-01-06','14:45:00',1.21),('15529','2014-01-06','14:50:00',1.14),('15529','2014-01-06','14:55:00',1.15),('15529','2014-01-06','15:00:00',1.13),('15529','2014-01-06','15:05:00',1.11),('15529','2014-01-06','15:10:00',1.07),('15529','2014-01-06','15:15:00',1.02),('15529','2014-04-23','08:50:00',1.02),('15529','2014-04-23','08:55:00',1.08),('15529','2014-04-23','09:00:00',1.13),('15529','2014-04-23','09:05:00',1.17),('15529','2014-04-23','09:10:00',1.2),('15529','2014-04-23','09:15:00',1.24),('15529','2014-04-23','09:20:00',1.28),('15529','2014-04-23','09:25:00',1.34),('15529','2014-04-23','09:30:00',1.37),('15529','2014-04-23','09:35:00',1.41),('15529','2014-04-23','09:40:00',1.46),('15529','2014-04-23','09:45:00',1.49),('15529','2014-04-23','09:50:00',1.53),('15529','2014-04-23','09:55:00',1.57),('15529','2014-04-23','10:00:00',1.6),('15529','2014-04-23','10:05:00',1.62),('15529','2014-04-23','10:10:00',1.66),('15529','2014-04-23','10:15:00',1.69),('15529','2014-04-23','10:20:00',1.72),('15529','2014-04-23','10:25:00',1.75),('15529','2014-04-23','10:30:00',1.78),('15529','2014-04-23','10:35:00',1.79),('15529','2014-04-23','10:40:00',1.79),('15529','2014-04-23','10:45:00',1.82),('15529','2014-04-23','10:50:00',1.89),('15529','2014-04-23','10:55:00',1.92),('15529','2014-04-23','11:00:00',1.98),('15529','2014-04-23','11:05:00',2),('15529','2014-04-23','11:10:00',1.99),('15529','2014-04-23','11:15:00',2.02),('15529','2014-04-23','11:20:00',2.06),('15529','2014-04-23','11:25:00',2.1),('15529','2014-04-23','11:30:00',2.11),('15529','2014-04-23','11:40:00',2.12),('15529','2014-04-23','11:45:00',2.07),('15529','2014-04-23','11:50:00',2.14),('15529','2014-04-23','11:55:00',2.22),('15529','2014-04-23','12:00:00',2.19),('15529','2014-04-23','12:05:00',2.07),('15529','2014-04-23','12:10:00',1.78),('15529','2014-04-23','12:15:00',2.3),('15529','2014-04-23','12:20:00',2.18),('15529','2014-04-23','12:25:00',2.28),('15529','2014-04-23','12:30:00',2.31),('15529','2014-04-23','12:35:00',2.34),('15529','2014-04-23','12:40:00',2.35),('15529','2014-04-23','12:45:00',1.76),('15529','2014-04-23','12:50:00',1.2),('15529','2014-04-23','13:00:00',1.66),('15529','2014-04-23','13:05:00',2.17),('15529','2014-04-23','13:10:00',1.98),('15529','2014-04-23','13:15:00',2.43),('15529','2014-04-23','13:20:00',1.56),('15529','2014-04-23','13:25:00',2.1),('15529','2014-04-23','13:30:00',2.52),('15529','2014-04-23','13:35:00',2.38),('15529','2014-04-23','13:40:00',2.39),('15529','2014-04-23','14:05:00',2.15),('15529','2014-04-23','14:10:00',2.32),('15529','2014-04-23','14:15:00',2.3),('15529','2014-04-23','14:20:00',2.3),('15529','2014-04-23','14:25:00',2.27),('15529','2014-04-23','14:30:00',2.31),('15529','2014-04-23','14:35:00',2.23),('15529','2014-04-23','14:40:00',1.42),('15529','2014-04-23','14:45:00',2.12),('15529','2014-04-23','14:50:00',2.37),('15529','2014-04-23','14:55:00',2.22),('15529','2014-04-23','15:00:00',2.13),('15529','2014-04-23','15:05:00',2.14),('15529','2014-04-23','15:10:00',1.99),('15529','2014-04-23','15:15:00',2.25),('15529','2014-04-23','15:20:00',1.54),('15529','2014-04-23','15:25:00',1.84),('15529','2014-04-23','15:30:00',2.51),('15529','2014-04-23','15:35:00',1.96),('15529','2014-04-23','15:40:00',1.96),('15529','2014-04-23','15:45:00',1.41),('15529','2014-04-23','15:50:00',1.8),('15529','2014-04-23','15:55:00',2.04),('15529','2014-04-23','16:00:00',1.86),('15529','2014-04-23','16:05:00',1.74),('15529','2014-04-23','16:10:00',1.77),('15529','2014-04-23','16:15:00',1.56),('15529','2014-04-23','16:20:00',1.44),('15529','2014-04-23','16:25:00',1.21),('15529','2014-04-23','16:30:00',1.38),('15529','2014-04-23','16:40:00',1.01),('15529','2014-04-23','16:45:00',1.27),('15529','2014-01-05','11:40:00',2.18),('15529','2014-01-05','11:45:00',1.1),('15529','2014-01-05','11:50:00',1.7),('15529','2014-01-05','11:55:00',1.89),('15529','2014-01-05','12:00:00',1.87),('15529','2014-01-05','12:05:00',1.85),('15529','2014-01-05','12:10:00',1.82),('15529','2014-01-05','12:15:00',1.82),('15529','2014-01-05','12:20:00',1.81),('15529','2014-01-05','12:25:00',1.79),('15529','2014-01-05','12:30:00',1.79),('15529','2014-01-05','12:35:00',1.79),('15529','2014-01-05','12:40:00',1.77),('15529','2014-01-05','12:45:00',1.77),('15529','2014-01-05','12:50:00',1.74),('15529','2014-01-05','12:55:00',1.71),('15529','2014-01-05','13:00:00',1.68),('15529','2014-01-05','13:05:00',1.7),('15529','2014-01-05','13:10:00',1.68),('15529','2014-01-05','13:15:00',1.68),('15529','2014-01-05','13:20:00',1.65),('15529','2014-01-05','13:25:00',1.64),('15529','2014-01-05','13:30:00',1.62),('15529','2014-01-05','13:35:00',1.58),('15529','2014-01-05','13:40:00',1.6),('15529','2014-01-05','13:45:00',1.53),('15529','2014-01-05','13:55:00',1.27),('15529','2014-01-05','14:00:00',1.5),('15529','2014-01-05','14:05:00',1.47),('15529','2014-01-05','14:10:00',1.49),('15529','2014-01-05','14:15:00',1.44),('15529','2014-01-05','14:20:00',1.18),('15529','2014-01-05','14:30:00',1.29),('15529','2014-01-05','14:35:00',1.45),('15529','2014-01-05','14:40:00',1.33),('15529','2014-01-05','14:45:00',1.29),('15529','2014-01-05','14:50:00',1.26),('15529','2014-01-05','14:55:00',1.18),('15529','2014-01-05','15:00:00',1.13),('15529','2014-01-02','09:15:00',1.03),('15529','2014-01-02','09:20:00',1.1),('15529','2014-01-02','09:25:00',1.17),('15529','2014-01-02','09:30:00',1.24),('15529','2014-01-02','09:35:00',1.36),('15529','2014-01-02','09:40:00',1.49),('15529','2014-01-02','09:45:00',1.03),('15529','2014-01-02','09:55:00',1.32),('15529','2014-01-02','10:00:00',1.45),('15529','2014-01-02','10:05:00',1.4),('15529','2014-01-02','10:10:00',1.32),('15529','2014-01-02','10:15:00',1.31),('15529','2014-01-02','12:10:00',1.37),('15529','2014-01-02','12:15:00',1.37),('15529','2014-01-02','12:20:00',1.57),('15529','2014-01-02','12:25:00',1.51),('15529','2014-01-02','12:30:00',1.42),('15529','2014-01-02','12:40:00',1.2),('15529','2014-01-02','12:45:00',1.34),('15529','2014-01-02','12:50:00',1.14),('15529','2014-01-02','13:00:00',1.22),('15529','2014-01-02','13:05:00',1.25),('15529','2014-01-02','13:15:00',1.22),('15529','2014-01-02','13:30:00',1.21),('15529','2014-01-01','09:10:00',1.03),('15529','2014-01-01','09:15:00',1.08),('15529','2014-01-01','09:20:00',1.11),('15529','2014-01-01','09:25:00',1.15),('15529','2014-01-01','09:30:00',1.19),('15529','2014-01-01','09:35:00',1.23),('15529','2014-01-01','09:40:00',1.27),('15529','2014-01-01','09:45:00',1.31),('15529','2014-01-01','09:50:00',1.34),('15529','2014-01-01','09:55:00',1.39),('15529','2014-01-01','10:00:00',1.42),('15529','2014-01-01','10:05:00',1.45),('15529','2014-01-01','10:10:00',1.47),('15529','2014-01-01','10:15:00',1.48),('15529','2014-01-01','10:20:00',1.52),('15529','2014-01-01','10:25:00',1.58),('15529','2014-01-01','10:30:00',1.61),('15529','2014-01-01','10:35:00',1.6),('15529','2014-01-01','10:40:00',1.64),('15529','2014-01-01','10:45:00',1.65),('15529','2014-01-01','10:50:00',1.63),('15529','2014-01-01','10:55:00',1.62),('15529','2014-01-01','11:00:00',1.58),('15529','2014-01-01','11:05:00',1.46),('15529','2014-01-01','11:10:00',1.4),('15529','2014-01-01','11:15:00',1.11),('15529','2014-01-01','11:30:00',1.02),('15529','2014-01-01','11:35:00',1.1),('15529','2014-01-01','12:50:00',1.47),('15529','2014-01-01','12:55:00',2.03),('15529','2014-01-01','13:00:00',1.2),('15529','2014-01-01','13:30:00',1.7),('15529','2013-12-31','08:55:00',1.04),('15529','2013-12-31','09:45:00',1.23),('15529','2013-12-31','09:50:00',1.21),('15529','2013-12-31','13:35:00',1.05),('15529','2013-12-31','13:40:00',1.91),('15529','2013-12-31','13:45:00',1.6),('15529','2013-12-31','13:50:00',1.84),('15529','2013-12-31','13:55:00',1.23),('15529','2013-12-31','15:05:00',1.19),('15529','2013-12-31','15:10:00',1.13),('15529','2013-12-30','09:15:00',1.14),('15529','2013-12-30','09:20:00',1.22),('15529','2013-12-30','09:25:00',1.27),('15529','2013-12-30','09:30:00',1.31),('15529','2013-12-30','09:35:00',1.44),('15529','2013-12-30','09:40:00',1.35),('15529','2013-12-30','09:45:00',1.18),('15529','2013-12-30','09:55:00',1.28),('15529','2013-12-30','10:00:00',1.11),('15529','2013-12-30','10:05:00',1.19),('15529','2013-12-30','11:10:00',1.03),('15529','2013-12-30','11:15:00',1.49),('15529','2013-12-30','11:20:00',1.22),('15529','2013-12-30','11:25:00',2.09),('15529','2013-12-30','11:30:00',1.78),('15529','2013-12-30','11:45:00',1.18),('15529','2013-12-30','11:55:00',1.48),('15529','2013-12-30','12:00:00',1.29),('15529','2013-12-30','12:05:00',2.01),('15529','2013-12-30','12:10:00',1.95),('15529','2013-12-30','12:15:00',1.91),('15529','2013-12-30','12:20:00',1.89),('15529','2013-12-30','12:25:00',1.88),('15529','2013-12-30','12:30:00',1.81),('15529','2013-12-30','12:35:00',1.8),('15529','2013-12-30','12:40:00',1.8),('15529','2013-12-30','12:45:00',1.79),('15529','2013-12-30','12:50:00',1.77),('15529','2013-12-30','12:55:00',1.76),('15529','2013-12-30','13:00:00',1.75),('15529','2013-12-30','13:05:00',1.74),('15529','2013-12-30','13:10:00',1.74),('15529','2013-12-30','13:15:00',1.73),('15529','2013-12-30','13:20:00',1.71),('15529','2013-12-30','13:25:00',1.69),('15529','2013-12-30','13:30:00',1.66),('15529','2013-12-30','13:35:00',1.65),('15529','2013-12-30','13:40:00',1.63),('15529','2013-12-30','13:45:00',1.61),('15529','2013-12-30','13:50:00',1.58),('15529','2013-12-30','13:55:00',1.55),('15529','2013-12-30','14:00:00',1.52),('15529','2013-12-30','14:05:00',1.49),('15529','2013-12-30','14:10:00',1.46),('15529','2013-12-30','14:15:00',1.43),('15529','2013-12-30','14:20:00',1.39),('15529','2013-12-30','14:25:00',1.35),('15529','2013-12-30','14:30:00',1.32),('15529','2013-12-30','14:35:00',1.29),('15529','2013-12-30','14:40:00',1.25),('15529','2013-12-30','14:45:00',1.21),('15529','2013-12-30','14:50:00',1.16),('15529','2013-12-30','14:55:00',1.12),('15529','2013-12-30','15:00:00',1.07),('15529','2013-12-30','15:05:00',1.02),('15529','2013-12-28','09:10:00',1.02),('15529','2013-12-28','09:15:00',1.05),('15529','2013-12-28','09:20:00',1.13),('15529','2013-12-28','09:25:00',1.17),('15529','2013-12-28','09:30:00',1.23),('15529','2013-12-28','09:35:00',1.25),('15529','2013-12-28','09:40:00',1.32),('15529','2013-12-28','09:45:00',1.33),('15529','2013-12-28','09:50:00',1.2),('15529','2013-12-28','09:55:00',1.1),('15529','2013-12-28','10:00:00',1.12),('15529','2013-12-28','10:05:00',1.38),('15529','2013-12-28','10:10:00',1.27),('15529','2013-12-28','10:15:00',1.35),('15529','2013-12-27','09:05:00',1.01),('15529','2013-12-27','09:10:00',1.07),('15529','2013-12-27','09:15:00',1.12),('15529','2013-12-27','09:20:00',1.17),('15529','2013-12-27','09:25:00',1.22),('15529','2013-12-27','09:30:00',1.26),('15529','2013-12-27','09:35:00',1.31),('15529','2013-12-27','09:40:00',1.34),('15529','2013-12-27','09:45:00',1.38),('15529','2013-12-27','09:50:00',1.41),('15529','2013-12-27','09:55:00',1.44),('15529','2013-12-27','10:00:00',1.47),('15529','2013-12-27','10:05:00',1.5),('15529','2013-12-27','10:10:00',1.52),('15529','2013-12-27','10:15:00',1.54),('15529','2013-12-27','10:20:00',1.57),('15529','2013-12-27','10:25:00',1.6),('15529','2013-12-27','10:30:00',1.62),('15529','2013-12-27','10:35:00',1.64),('15529','2013-12-27','10:40:00',1.64),('15529','2013-12-27','10:45:00',1.68),('15529','2013-12-27','10:50:00',1.69),('15529','2013-12-27','10:55:00',1.71),('15529','2013-12-27','11:00:00',1.72),('15529','2013-12-27','11:05:00',1.74),('15529','2013-12-27','11:10:00',1.75),('15529','2013-12-27','11:15:00',1.76),('15529','2013-12-27','11:20:00',1.76),('15529','2013-12-27','11:25:00',1.77),('15529','2013-12-27','11:30:00',1.78),('15529','2013-12-27','11:35:00',1.8),('15529','2013-12-27','11:40:00',1.79),('15529','2013-12-27','11:45:00',1.79),('15529','2013-12-27','11:50:00',1.81),('15529','2013-12-27','11:55:00',1.8),('15529','2013-12-27','12:00:00',1.8),('15529','2013-12-27','12:05:00',1.8),('15529','2013-12-27','12:10:00',1.81),('15529','2013-12-27','12:15:00',1.8),('15529','2013-12-27','12:20:00',1.78),('15529','2013-12-27','12:25:00',1.77),('15529','2013-12-27','12:30:00',1.77),('15529','2013-12-27','12:35:00',1.77),('15529','2013-12-27','12:40:00',1.74),('15529','2013-12-27','12:45:00',1.71),('15529','2013-12-27','12:50:00',1.71),('15529','2013-12-27','12:55:00',1.68),('15529','2013-12-27','13:00:00',1.66),('15529','2013-12-27','13:05:00',1.66),('15529','2013-12-27','13:10:00',1.63),('15529','2013-12-27','13:15:00',1.61),('15529','2013-12-27','13:20:00',1.58),('15529','2013-12-27','13:25:00',1.56),('15529','2013-12-27','13:30:00',1.53),('15529','2013-12-27','13:35:00',1.51),('15529','2013-12-27','13:40:00',1.49),('15529','2013-12-27','13:45:00',1.47),('15529','2013-12-27','13:50:00',1.42),('15529','2013-12-27','13:55:00',1.38),('15529','2013-12-27','14:00:00',1.35),('15529','2013-12-27','14:05:00',1.35),('15529','2013-12-27','14:10:00',1.32),('15529','2013-12-27','14:15:00',1.28),('15529','2013-12-27','14:20:00',1.26),('15529','2013-12-27','14:25:00',1.28),('15529','2013-12-27','14:30:00',1.24),('15529','2013-12-27','14:35:00',1.19),('15529','2013-12-27','14:40:00',1.12),('15529','2013-12-27','15:00:00',1),('15529','2013-12-27','15:05:00',1),('15529','2013-12-26','12:10:00',1.24),('15529','2013-12-26','12:15:00',1.41),('15529','2013-12-26','12:45:00',1.43),('15529','2013-12-26','12:50:00',1.66),('15529','2013-12-26','12:55:00',1.25),('15529','2013-12-26','13:00:00',1.58),('15529','2013-12-26','13:05:00',1.51),('15529','2013-12-26','13:10:00',1.23),('15529','2013-12-26','13:15:00',1.49),('15529','2013-12-26','13:20:00',1.68),('15529','2013-12-26','13:25:00',1.34),('15529','2013-12-26','13:30:00',1.02),('15529','2013-12-26','14:10:00',1.04),('15529','2013-12-24','11:20:00',1.04),('15529','2013-12-24','11:40:00',1.71),('15529','2013-12-24','11:45:00',1.66),('15529','2013-12-24','11:50:00',1.38),('15529','2013-12-24','11:55:00',1.75),('15529','2013-12-24','12:15:00',1.65),('15529','2013-12-24','12:20:00',1.62),('15529','2013-12-24','12:25:00',1.04),('15529','2013-12-24','12:35:00',1.22),('15529','2013-12-23','09:15:00',1.03),('15529','2013-12-23','09:20:00',1.07),('15529','2013-12-23','09:25:00',1.1),('15529','2013-12-23','09:30:00',1.14),('15529','2013-12-23','09:35:00',1.18),('15529','2013-12-23','09:40:00',1.21),('15529','2013-12-23','09:45:00',1.25),('15529','2013-12-23','09:50:00',1.29),('15529','2013-12-23','09:55:00',1.31),('15529','2013-12-23','10:00:00',1.34),('15529','2013-12-23','10:05:00',1.38),('15529','2013-12-23','10:10:00',1.42),('15529','2013-12-23','10:15:00',1.45),('15529','2013-12-23','10:20:00',1.47),('15529','2013-12-23','10:25:00',1.5),('15529','2013-12-23','10:30:00',1.51),('15529','2013-12-23','10:35:00',1.53),('15529','2013-12-23','10:40:00',1.54),('15529','2013-12-23','10:45:00',1.54),('15529','2013-12-23','10:50:00',1.56),('15529','2013-12-23','10:55:00',1.55),('15529','2013-12-23','11:00:00',1.61),('15529','2013-12-23','11:05:00',1.57),('15529','2013-12-23','11:10:00',1.56),('15529','2013-12-23','11:15:00',1.56),('15529','2013-12-23','11:20:00',1.59),('15529','2013-12-23','11:25:00',1.61),('15529','2013-12-23','11:30:00',1.62),('15529','2013-12-23','11:35:00',1.63),('15529','2013-12-23','11:40:00',1.64),('15529','2013-12-23','11:45:00',1.64),('15529','2013-12-23','11:50:00',1.63),('15529','2013-12-23','11:55:00',1.61),('15529','2013-12-23','12:00:00',1.6),('15529','2013-12-23','12:05:00',1.61),('15529','2013-12-23','12:10:00',1.62),('15529','2013-12-23','12:15:00',1.61),('15529','2013-12-23','12:20:00',1.58),('15529','2013-12-23','12:25:00',1.59),('15529','2013-12-23','12:30:00',1.57),('15529','2013-12-23','12:35:00',1.59),('15529','2013-12-23','12:40:00',1.54),('15529','2013-12-23','12:45:00',1.53),('15529','2013-12-23','12:50:00',1.54),('15529','2013-12-23','12:55:00',1.54),('15529','2013-12-23','13:00:00',1.48),('15529','2013-12-23','13:05:00',1.48),('15529','2013-12-23','13:10:00',1.48),('15529','2013-12-23','13:15:00',1.44),('15529','2013-12-23','13:20:00',1.44),('15529','2013-12-23','13:25:00',1.42),('15529','2013-12-23','13:30:00',1.38),('15529','2013-12-23','13:35:00',1.35),('15529','2013-12-23','13:40:00',1.3),('15529','2013-12-23','13:45:00',1.3),('15529','2013-12-23','13:50:00',1.27),('15529','2013-12-23','13:55:00',1.24),('15529','2013-12-23','14:00:00',1.21),('15529','2013-12-23','14:05:00',1.17),('15529','2013-12-23','14:10:00',1.11),('15529','2013-12-23','14:15:00',1.07),('15529','2013-12-22','09:55:00',1.07),('15529','2013-12-22','10:00:00',1.31),('15529','2013-12-22','10:05:00',1.44),('15529','2013-12-22','10:10:00',1.51),('15529','2013-12-22','10:15:00',1.52),('15529','2013-12-22','10:20:00',1.49),('15529','2013-12-22','10:25:00',1.43),('15529','2013-12-22','10:30:00',1.42),('15529','2013-12-22','10:35:00',1.39),('15529','2013-12-22','10:40:00',1.41),('15529','2013-12-22','10:45:00',1.44),('15529','2013-12-22','10:50:00',1.47),('15529','2013-12-22','10:55:00',1.58),('15529','2013-12-22','11:00:00',1.68),('15529','2013-12-22','11:05:00',1.72),('15529','2013-12-22','11:10:00',1.73),('15529','2013-12-22','11:15:00',1.67),('15529','2013-12-22','11:20:00',1.58),('15529','2013-12-22','11:25:00',1.73),('15529','2013-12-22','11:30:00',1.78),('15529','2013-12-22','11:35:00',1.63),('15529','2013-12-22','11:40:00',1.54),('15529','2013-12-22','11:45:00',1.69),('15529','2013-12-22','11:50:00',1.56),('15529','2013-12-22','11:55:00',1.59),('15529','2013-12-22','12:00:00',1.67),('15529','2013-12-22','12:05:00',1.69),('15529','2013-12-22','12:10:00',1.69),('15529','2013-12-22','12:15:00',1.68),('15529','2013-12-22','12:20:00',1.69),('15529','2013-12-22','12:25:00',1.69),('15529','2013-12-22','12:30:00',1.65),('15529','2013-12-22','12:35:00',1.7),('15529','2013-12-22','12:40:00',1.71),('15529','2013-12-22','12:45:00',1.71),('15529','2013-12-22','12:50:00',1.72),('15529','2013-12-22','12:55:00',1.69),('15529','2013-12-22','13:00:00',1.7),('15529','2013-12-22','13:05:00',1.69),('15529','2013-12-22','13:10:00',1.66),('15529','2013-12-22','13:15:00',1.48),('15529','2013-12-22','13:20:00',1.35),('15529','2013-12-22','13:25:00',1.37),('15529','2013-12-22','13:35:00',1.32),('15529','2013-12-22','13:45:00',1.06),('15529','2013-12-22','13:50:00',1.25),('15529','2013-12-22','13:55:00',1.33),('15529','2013-12-22','14:00:00',1.1),('15529','2013-12-22','14:05:00',1.1),('15529','2013-12-22','14:10:00',1.26),('15529','2013-12-22','14:15:00',1.21),('15529','2013-12-22','14:20:00',1.18),('15529','2013-12-22','14:25:00',1.1),('15529','2013-12-22','14:30:00',1.08),('15529','2013-12-22','14:35:00',1.13),('15529','2013-12-22','14:40:00',1.09),('15529','2013-12-22','14:45:00',1.05),('15529','2013-12-21','09:35:00',1.3),('15529','2013-12-21','09:40:00',1.48),('15529','2013-12-21','09:45:00',1.51),('15529','2013-12-21','09:50:00',1.58),('15529','2013-12-21','09:55:00',1.57),('15529','2013-12-21','10:00:00',1.56),('15529','2013-12-21','10:05:00',1.57),('15529','2013-12-21','10:10:00',1.58),('15529','2013-12-21','10:15:00',1.53),('15529','2013-12-21','10:20:00',1.5),('15529','2013-12-21','10:25:00',1.53),('15529','2013-12-21','10:30:00',1.57),('15529','2013-12-21','10:35:00',1.44),('15529','2013-12-21','10:40:00',1.37),('15529','2013-12-21','10:45:00',1.52),('15529','2013-12-21','10:50:00',1.54),('15529','2013-12-21','10:55:00',1.33),('15529','2013-12-21','11:00:00',1.3),('15529','2013-12-21','11:05:00',1.39),('15529','2013-12-21','11:10:00',1.69),('15529','2013-12-21','11:15:00',1.55),('15529','2013-12-21','11:20:00',1.51),('15529','2013-12-21','11:25:00',1.52),('15529','2013-12-21','11:30:00',1.44),('15529','2013-12-21','11:35:00',1.52),('15529','2013-12-21','11:40:00',1.55),('15529','2013-12-21','11:45:00',1.32),('15529','2013-12-21','11:50:00',1.01),('15529','2013-12-21','12:35:00',1.05),('15529','2013-12-21','12:50:00',1.16),('15529','2013-12-21','12:55:00',1.55),('15529','2013-12-21','13:00:00',1.4),('15529','2013-12-21','13:05:00',1.84),('15529','2013-12-21','13:10:00',1.75),('15529','2013-12-21','13:15:00',1.36),('15529','2013-12-21','13:20:00',1.36),('15529','2013-12-21','13:25:00',1.46),('15529','2013-12-21','13:30:00',1.32),('15529','2013-12-21','13:35:00',1.19),('15529','2013-12-21','13:40:00',1.17),('15529','2013-12-21','13:45:00',1.25),('15529','2013-12-21','14:05:00',1.02),('15529','2013-12-21','14:10:00',1.05),('15529','2013-12-20','09:15:00',1.04),('15529','2013-12-20','09:20:00',1.09),('15529','2013-12-20','09:25:00',1.13),('15529','2013-12-20','09:30:00',1.18),('15529','2013-12-20','09:35:00',1.22),('15529','2013-12-20','09:40:00',1.26),('15529','2013-12-20','09:45:00',1.29),('15529','2013-12-20','09:50:00',1.31),('15529','2013-12-20','09:55:00',1.35),('15529','2013-12-20','10:00:00',1.38),('15529','2013-12-20','10:05:00',1.42),('15529','2013-12-20','10:10:00',1.46),('15529','2013-12-20','10:15:00',1.48),('15529','2013-12-20','10:20:00',1.51),('15529','2013-12-20','10:25:00',1.53),('15529','2013-12-20','10:30:00',1.54),('15529','2013-12-20','10:35:00',1.58),('15529','2013-12-20','10:40:00',1.6),('15529','2013-12-20','10:45:00',1.62),('15529','2013-12-20','10:50:00',1.65),('15529','2013-12-20','10:55:00',1.66),('15529','2013-12-20','11:00:00',1.69),('15529','2013-12-20','11:05:00',1.73),('15529','2013-12-20','11:10:00',1.74),('15529','2013-12-20','11:15:00',1.75),('15529','2013-12-20','11:20:00',1.76),('15529','2013-12-20','11:25:00',1.76),('15529','2013-12-20','11:30:00',1.79),('15529','2013-12-20','11:35:00',1.79),('15529','2013-12-20','11:40:00',1.79),('15529','2013-12-20','11:45:00',1.8),('15529','2013-12-20','11:50:00',1.79),('15529','2013-12-20','11:55:00',1.8),('15529','2013-12-20','12:00:00',1.81),('15529','2013-12-20','12:05:00',1.81),('15529','2013-12-20','12:10:00',1.81),('15529','2013-12-20','12:15:00',1.8),('15529','2013-12-20','12:20:00',1.8),('15529','2013-12-20','12:25:00',1.8),('15529','2013-12-20','12:30:00',1.8),('15529','2013-12-20','12:35:00',1.79),('15529','2013-12-20','12:40:00',1.78),('15529','2013-12-20','12:45:00',1.77),('15529','2013-12-20','12:50:00',1.76),('15529','2013-12-20','12:55:00',1.75),('15529','2013-12-20','13:00:00',1.74),('15529','2013-12-20','13:05:00',1.72),('15529','2013-12-20','13:10:00',1.71),('15529','2013-12-20','13:15:00',1.69),('15529','2013-12-20','13:20:00',1.66),('15529','2013-12-20','13:25:00',1.63),('15529','2013-12-20','13:30:00',1.6),('15529','2013-12-20','13:35:00',1.59),('15529','2013-12-20','13:40:00',1.56),('15529','2013-12-20','13:45:00',1.53),('15529','2013-12-20','13:50:00',1.51),('15529','2013-12-20','13:55:00',1.49),('15529','2013-12-20','14:00:00',1.46),('15529','2013-12-20','14:05:00',1.44),('15529','2013-12-20','14:10:00',1.42),('15529','2013-12-20','14:15:00',1.38),('15529','2013-12-20','14:20:00',1.34),('15529','2013-12-20','14:25:00',1.32),('15529','2013-12-20','14:30:00',1.27),('15529','2013-12-20','14:35:00',1.23),('15529','2013-12-20','14:40:00',1.19),('15529','2013-12-20','14:45:00',1.15),('15529','2013-12-20','14:50:00',1.1),('15529','2013-12-20','14:55:00',1.06),('15529','2013-12-19','09:15:00',1.01),('15529','2013-12-19','09:20:00',1.05),('15529','2013-12-19','09:25:00',1.1),('15529','2013-12-19','09:30:00',1.13),('15529','2013-12-19','09:35:00',1.18),('15529','2013-12-19','09:40:00',1.21),('15529','2013-12-19','09:45:00',1.25),('15529','2013-12-19','09:50:00',1.26),('15529','2013-12-19','09:55:00',1.29),('15529','2013-12-19','10:00:00',1.34),('15529','2013-12-19','10:05:00',1.37),('15529','2013-12-19','10:10:00',1.39),('15529','2013-12-19','10:15:00',1.42),('15529','2013-12-19','10:20:00',1.45),('15529','2013-12-19','10:25:00',1.45),('15529','2013-12-19','10:30:00',1.47),('15529','2013-12-19','10:35:00',1.5),('15529','2013-12-19','10:40:00',1.54),('15529','2013-12-19','10:45:00',1.55),('15529','2013-12-19','10:50:00',1.57),('15529','2013-12-19','10:55:00',1.59),('15529','2013-12-19','11:00:00',1.61),('15529','2013-12-19','11:05:00',1.62),('15529','2013-12-19','11:10:00',1.64),('15529','2013-12-19','11:15:00',1.65),('15529','2013-12-19','11:20:00',1.65),('15529','2013-12-19','11:25:00',1.66),('15529','2013-12-19','11:30:00',1.66),('15529','2013-12-19','11:35:00',1.67),('15529','2013-12-19','11:40:00',1.68),('15529','2013-12-19','11:45:00',1.68),('15529','2013-12-19','11:50:00',1.68),('15529','2013-12-19','11:55:00',1.69),('15529','2013-12-19','12:00:00',1.66),('15529','2013-12-19','12:05:00',1.67),('15529','2013-12-19','12:10:00',1.68),('15529','2013-12-19','12:15:00',1.66),('15529','2013-12-19','12:20:00',1.67),('15529','2013-12-19','12:30:00',1.66),('15529','2013-12-19','12:35:00',1.65),('15529','2013-12-19','12:40:00',1.63),('15529','2013-12-19','12:45:00',1.59),('15529','2013-12-19','12:50:00',1.58),('15529','2013-12-19','12:55:00',1.58),('15529','2013-12-19','13:00:00',1.55),('15529','2013-12-19','13:05:00',1.53),('15529','2013-12-19','13:10:00',1.5),('15529','2013-12-19','13:15:00',1.47),('15529','2013-12-19','13:20:00',1.46),('15529','2013-12-19','13:25:00',1.47),('15529','2013-12-19','13:30:00',1.39),('15529','2013-12-19','13:35:00',1.3),('15529','2013-12-19','13:40:00',1.25),('15529','2013-12-19','13:45:00',1.18),('15529','2013-12-18','09:05:00',1.05),('15529','2013-12-18','09:10:00',1.06),('15529','2013-12-18','09:15:00',1.03),('15529','2013-12-18','09:55:00',1.23),('15529','2013-12-18','10:00:00',1.3),('15529','2013-12-18','10:05:00',1.61),('15529','2013-12-18','10:10:00',1.59),('15529','2013-12-18','10:15:00',1.57),('15529','2013-12-18','14:40:00',1.12),('15529','2013-12-17','09:05:00',1),('15529','2013-12-17','09:10:00',1.05),('15529','2013-12-17','09:15:00',1.1),('15529','2013-12-17','09:20:00',1.14),('15529','2013-12-17','09:25:00',1.18),('15529','2013-12-17','09:30:00',1.22),('15529','2013-12-17','09:35:00',1.26),('15529','2013-12-17','09:40:00',1.31),('15529','2013-12-17','09:45:00',1.33),('15529','2013-12-17','09:50:00',1.38),('15529','2013-12-17','09:55:00',1.41),('15529','2013-12-17','10:00:00',1.44),('15529','2013-12-17','10:05:00',1.49),('15529','2013-12-17','10:10:00',1.51),('15529','2013-12-17','10:15:00',1.52),('15529','2013-12-17','10:20:00',1.54),('15529','2013-12-17','10:25:00',1.57),('15529','2013-12-17','10:30:00',1.59),('15529','2013-12-17','10:35:00',1.61),('15529','2013-12-17','10:40:00',1.62),('15529','2013-12-17','10:45:00',1.65),('15529','2013-12-17','10:50:00',1.67),('15529','2013-12-17','10:55:00',1.68),('15529','2013-12-17','11:00:00',1.69),('15529','2013-12-17','11:05:00',1.7),('15529','2013-12-17','11:10:00',1.7),('15529','2013-12-17','11:15:00',1.7),('15529','2013-12-17','11:20:00',1.73),('15529','2013-12-17','11:25:00',1.72),('15529','2013-12-17','11:30:00',1.73),('15529','2013-12-17','11:35:00',1.72),('15529','2013-12-17','11:40:00',1.74),('15529','2013-12-17','11:45:00',1.75),('15529','2013-12-17','11:50:00',1.75),('15529','2013-12-17','11:55:00',1.75),('15529','2013-12-17','12:00:00',1.74),('15529','2013-12-17','12:05:00',1.74),('15529','2013-12-17','12:10:00',1.75),('15529','2013-12-17','12:15:00',1.75),('15529','2013-12-17','12:20:00',1.75),('15529','2013-12-17','12:25:00',1.74),('15529','2013-12-17','12:30:00',1.75),('15529','2013-12-17','12:35:00',1.75),('15529','2013-12-17','12:40:00',1.71),('15529','2013-12-17','12:45:00',1.7),('15529','2013-12-17','12:50:00',1.68),('15529','2013-12-17','12:55:00',1.66),('15529','2013-12-17','13:00:00',1.64),('15529','2013-12-17','13:05:00',1.62),('15529','2013-12-17','13:10:00',1.58),('15529','2013-12-17','13:15:00',1.54),('15529','2013-12-17','13:20:00',1.53),('15529','2013-12-17','13:25:00',1.5),('15529','2013-12-17','13:30:00',1.49),('15529','2013-12-17','13:35:00',1.45),('15529','2013-12-17','13:40:00',1.41),('15529','2013-12-17','13:45:00',1.41),('15529','2013-12-17','13:50:00',1.39),('15529','2013-12-17','13:55:00',1.35),('15529','2013-12-17','14:00:00',1.33),('15529','2013-12-17','14:05:00',1.34),('15529','2013-12-17','14:10:00',1.33),('15529','2013-12-17','14:15:00',1.31),('15529','2013-12-17','14:20:00',1.26),('15529','2013-12-17','14:25:00',1.23),('15529','2013-12-17','14:30:00',1.2),('15529','2013-12-17','14:35:00',1.17),('15529','2013-12-17','14:40:00',1.12),('15529','2013-12-17','14:45:00',1.09),('15529','2013-12-17','14:50:00',1.05),('15529','2013-12-17','14:55:00',1.01),('15529','2014-04-21','09:00:00',1.1),('15529','2014-04-21','09:05:00',1.2),('15529','2014-04-21','09:10:00',1.11),('15529','2014-04-21','09:15:00',1.11),('15529','2014-04-21','09:20:00',1.28),('15529','2014-04-21','09:25:00',1.37),('15529','2014-04-21','09:30:00',1.34),('15529','2014-04-21','09:35:00',1.45),('15529','2014-04-21','09:40:00',1.12),('15529','2014-04-21','09:45:00',1.54),('15529','2014-04-21','09:50:00',1.02),('15529','2014-04-21','10:10:00',1.08),('15529','2014-04-21','10:15:00',1.07),('15529','2014-04-21','10:20:00',1.64),('15529','2014-04-21','10:25:00',1.2),('15529','2014-04-21','10:30:00',1.84),('15529','2014-04-21','10:35:00',1.54),('15529','2014-04-21','10:40:00',1.79),('15529','2014-04-21','10:45:00',2.05),('15529','2014-04-21','10:50:00',2.03),('15529','2014-04-21','10:55:00',1.44),('15529','2014-04-21','11:00:00',1.08),('15529','2014-04-21','11:05:00',1.36),('15529','2014-04-21','13:20:00',1.01),('15529','2014-04-21','13:25:00',1.35),('15529','2014-04-21','13:30:00',1.23),('15529','2014-04-21','13:35:00',1.33),('15529','2014-04-21','13:40:00',1.41),('15529','2014-04-21','13:45:00',1.32),('15529','2014-04-21','13:50:00',1.04),('15529','2014-04-21','14:05:00',1.66),('15529','2014-04-21','14:10:00',1.87),('15529','2014-04-21','14:15:00',1.55),('15529','2014-04-21','14:20:00',1.78),('15529','2014-04-21','14:30:00',1.09),('15529','2014-04-21','14:35:00',1.4),('15529','2014-04-21','14:40:00',2.02),('15529','2014-04-21','14:45:00',1.55),('15529','2014-04-21','14:50:00',1.62),('15529','2014-04-21','14:55:00',1.22),('15529','2014-04-21','15:30:00',1.04),('15529','2014-04-21','15:35:00',1.13),('15529','2014-04-21','15:45:00',1.06),('15529','2014-04-21','15:50:00',1.04),('15529','2014-04-21','16:00:00',1.07),('15529','2013-12-16','08:55:00',1.01),('15529','2013-12-16','09:00:00',1.06),('15529','2013-12-16','09:05:00',1.11),('15529','2013-12-16','09:10:00',1.15),('15529','2013-12-16','09:15:00',1.2),('15529','2013-12-16','09:20:00',1.24),('15529','2013-12-16','09:25:00',1.25),('15529','2013-12-16','09:30:00',1.3),('15529','2013-12-16','09:35:00',1.29),('15529','2013-12-16','09:40:00',1.35),('15529','2013-12-16','09:45:00',1.39),('15529','2013-12-16','09:50:00',1.42),('15529','2013-12-16','09:55:00',1.46),('15529','2013-12-16','10:00:00',1.5),('15529','2013-12-16','10:05:00',1.54),('15529','2013-12-16','10:10:00',1.56),('15529','2013-12-16','10:15:00',1.58),('15529','2013-12-16','10:20:00',1.59),('15529','2013-12-16','10:25:00',1.62),('15529','2013-12-16','10:30:00',1.64),('15529','2013-12-16','10:35:00',1.66),('15529','2013-12-16','10:40:00',1.67),('15529','2013-12-16','10:45:00',1.68),('15529','2013-12-16','10:50:00',1.7),('15529','2013-12-16','10:55:00',1.71),('15529','2013-12-16','11:00:00',1.73),('15529','2013-12-16','11:05:00',1.75),('15529','2013-12-16','11:10:00',1.78),('15529','2013-12-16','11:15:00',1.8),('15529','2013-12-16','11:20:00',1.81),('15529','2013-12-16','11:25:00',1.82),('15529','2013-12-16','11:30:00',1.81),('15529','2013-12-16','11:35:00',1.81),('15529','2013-12-16','11:40:00',1.82),('15529','2013-12-16','11:45:00',1.83),('15529','2013-12-16','11:50:00',1.83),('15529','2013-12-16','11:55:00',1.82),('15529','2013-12-16','12:00:00',1.82),('15529','2013-12-16','12:05:00',1.83),('15529','2013-12-16','12:10:00',1.82),('15529','2013-12-16','12:15:00',1.82),('15529','2013-12-16','12:20:00',1.84),('15529','2013-12-16','12:25:00',1.83),('15529','2013-12-16','12:30:00',1.82),('15529','2013-12-16','12:35:00',1.82),('15529','2013-12-16','12:40:00',1.81),('15529','2013-12-16','12:45:00',1.8),('15529','2013-12-16','12:50:00',1.76),('15529','2013-12-16','12:55:00',1.74),('15529','2013-12-16','13:00:00',1.74),('15529','2013-12-16','13:05:00',1.72),('15529','2013-12-16','13:10:00',1.72),('15529','2013-12-16','13:15:00',1.7),('15529','2013-12-16','13:20:00',1.68),('15529','2013-12-16','13:25:00',1.67),('15529','2013-12-16','13:30:00',1.65),('15529','2013-12-16','13:35:00',1.62),('15529','2013-12-16','13:40:00',1.6),('15529','2013-12-16','13:45:00',1.58),('15529','2013-12-16','13:50:00',1.55),('15529','2013-12-16','13:55:00',1.51),('15529','2013-12-16','14:00:00',1.48),('15529','2013-12-16','14:05:00',1.45),('15529','2013-12-16','14:10:00',1.44),('15529','2013-12-16','14:15:00',1.39),('15529','2013-12-16','14:20:00',1.33),('15529','2013-12-16','14:25:00',1.29),('15529','2013-12-16','14:30:00',1.26),('15529','2013-12-16','14:35:00',1.21),('15529','2013-12-16','14:40:00',1.16),('15529','2013-12-16','14:45:00',1.1),('15529','2013-12-16','14:50:00',1.05),('15529','2013-12-16','14:55:00',1.01),('15529','2013-12-15','09:00:00',1.04),('15529','2013-12-15','09:05:00',1.1),('15529','2013-12-15','09:10:00',1.14),('15529','2013-12-15','09:15:00',1.18),('15529','2013-12-15','09:20:00',1.23),('15529','2013-12-15','09:25:00',1.26),('15529','2013-12-15','09:30:00',1.3),('15529','2013-12-15','09:35:00',1.34),('15529','2013-12-15','09:40:00',1.37),('15529','2013-12-15','09:45:00',1.4),('15529','2013-12-15','09:50:00',1.42),('15529','2013-12-15','09:55:00',1.45),('15529','2013-12-15','10:00:00',1.47),('15529','2013-12-15','10:05:00',1.5),('15529','2013-12-15','10:10:00',1.52),('15529','2013-12-15','10:15:00',1.54),('15529','2013-12-15','10:20:00',1.55),('15529','2013-12-15','10:25:00',1.57),('15529','2013-12-15','10:30:00',1.58),('15529','2013-12-15','10:35:00',1.61),('15529','2013-12-15','10:40:00',1.64),('15529','2013-12-15','10:45:00',1.65),('15529','2013-12-15','10:50:00',1.67),('15529','2013-12-15','10:55:00',1.69),('15529','2013-12-15','11:00:00',1.7),('15529','2013-12-15','11:05:00',1.72),('15529','2013-12-15','11:10:00',1.73),('15529','2013-12-15','11:15:00',1.74),('15529','2013-12-15','11:20:00',1.76),('15529','2013-12-15','11:25:00',1.76),('15529','2013-12-15','11:30:00',1.79),('15529','2013-12-15','11:35:00',1.79),('15529','2013-12-15','11:40:00',1.79),('15529','2013-12-15','11:45:00',1.81),('15529','2013-12-15','11:50:00',1.81),('15529','2013-12-15','11:55:00',1.83),('15529','2013-12-15','12:00:00',1.83),('15529','2013-12-15','12:05:00',1.84),('15529','2013-12-15','12:10:00',1.82),('15529','2013-12-15','12:15:00',1.81),('15529','2013-12-15','12:20:00',1.81),('15529','2013-12-15','12:25:00',1.81),('15529','2013-12-15','12:30:00',1.8),('15529','2013-12-15','12:35:00',1.8),('15529','2013-12-15','12:40:00',1.78),('15529','2013-12-15','12:45:00',1.76),('15529','2013-12-15','12:50:00',1.75),('15529','2013-12-15','12:55:00',1.72),('15529','2013-12-15','13:00:00',1.71),('15529','2013-12-15','13:05:00',1.71),('15529','2013-12-15','13:10:00',1.69),('15529','2013-12-15','13:15:00',1.68),('15529','2013-12-15','13:20:00',1.65),('15529','2013-12-15','13:25:00',1.63),('15529','2013-12-15','13:30:00',1.61),('15529','2013-12-15','13:35:00',1.57),('15529','2013-12-15','13:40:00',1.54),('15529','2013-12-15','13:45:00',1.52),('15529','2013-12-15','13:50:00',1.51),('15529','2013-12-15','13:55:00',1.47),('15529','2013-12-15','14:00:00',1.44),('15529','2013-12-15','14:05:00',1.41),('15529','2013-12-15','14:10:00',1.39),('15529','2013-12-15','14:15:00',1.37),('15529','2013-12-15','14:20:00',1.32),('15529','2013-12-15','14:25:00',1.27),('15529','2013-12-15','14:30:00',1.23),('15529','2013-12-15','14:35:00',1.2),('15529','2013-12-15','14:40:00',1.14),('15529','2013-12-15','14:45:00',1.11),('15529','2013-12-15','14:50:00',1.06),('15529','2013-12-15','14:55:00',1.01),('15529','2013-12-13','09:05:00',1),('15529','2013-12-13','09:10:00',1.05),('15529','2013-12-13','09:15:00',1.09),('15529','2013-12-13','09:20:00',1.13),('15529','2013-12-13','09:25:00',1.18),('15529','2013-12-13','09:30:00',1.23),('15529','2013-12-13','09:35:00',1.26),('15529','2013-12-13','09:40:00',1.3),('15529','2013-12-13','09:45:00',1.35),('15529','2013-12-13','09:50:00',1.39),('15529','2013-12-13','09:55:00',1.42),('15529','2013-12-13','10:00:00',1.44),('15529','2013-12-13','10:05:00',1.46),('15529','2013-12-13','10:10:00',1.49),('15529','2013-12-13','10:15:00',1.51),('15529','2013-12-13','10:20:00',1.53),('15529','2013-12-13','10:25:00',1.55),('15529','2013-12-13','10:30:00',1.58),('15529','2013-12-13','10:35:00',1.59),('15529','2013-12-13','10:40:00',1.61),('15529','2013-12-13','10:45:00',1.62),('15529','2013-12-13','10:50:00',1.63),('15529','2013-12-13','10:55:00',1.62),('15529','2013-12-13','11:00:00',1.64),('15529','2013-12-13','11:05:00',1.66),('15529','2013-12-13','11:10:00',1.67),('15529','2013-12-13','11:15:00',1.69),('15529','2013-12-13','11:20:00',1.7),('15529','2013-12-13','11:25:00',1.72),('15529','2013-12-13','11:30:00',1.71),('15529','2013-12-13','11:35:00',1.7),('15529','2013-12-13','11:40:00',1.72),('15529','2013-12-13','11:45:00',1.72),('15529','2013-12-13','11:50:00',1.74),('15529','2013-12-13','11:55:00',1.69),('15529','2013-12-13','12:00:00',1.72),('15529','2013-12-13','12:05:00',1.72),('15529','2013-12-13','12:10:00',1.71),('15529','2013-12-13','12:15:00',1.7),('15529','2013-12-13','12:20:00',1.73),('15529','2013-12-13','12:25:00',1.7),('15529','2013-12-13','12:30:00',1.71),('15529','2013-12-13','12:35:00',1.69),('15529','2013-12-13','12:40:00',1.66),('15529','2013-12-13','12:45:00',1.62),('15529','2013-12-13','12:50:00',1.63),('15529','2013-12-13','12:55:00',1.64),('15529','2013-12-13','13:00:00',1.61),('15529','2013-12-13','13:05:00',1.61),('15529','2013-12-13','13:10:00',1.61),('15529','2013-12-13','13:15:00',1.62),('15529','2013-12-13','13:20:00',1.6),('15529','2013-12-13','13:25:00',1.59),('15529','2013-12-13','13:30:00',1.55),('15529','2013-12-13','13:35:00',1.53),('15529','2013-12-13','13:40:00',1.52),('15529','2013-12-13','13:45:00',1.48),('15529','2013-12-13','13:50:00',1.44),('15529','2013-12-13','13:55:00',1.44),('15529','2013-12-13','14:00:00',1.41),('15529','2013-12-13','14:05:00',1.36),('15529','2013-12-13','14:10:00',1.33),('15529','2013-12-13','14:15:00',1.32),('15529','2013-12-13','14:20:00',1.25),('15529','2013-12-13','14:25:00',1.2),('15529','2013-12-13','14:30:00',1.18),('15529','2013-12-13','14:35:00',1.14),('15529','2013-12-13','14:40:00',1.1),('15529','2013-12-13','14:45:00',1.05),('15529','2013-12-13','14:50:00',1.01),('15529','2013-12-12','09:20:00',1.04),('15529','2013-12-12','09:25:00',1.06),('15529','2013-12-12','09:30:00',1.1),('15529','2013-12-12','09:35:00',1.15),('15529','2013-12-12','09:40:00',1.17),('15529','2013-12-12','09:45:00',1.21),('15529','2013-12-12','09:50:00',1.25),('15529','2013-12-12','09:55:00',1.28),('15529','2013-12-12','10:00:00',1.32),('15529','2013-12-12','10:05:00',1.35),('15529','2013-12-12','10:10:00',1.36),('15529','2013-12-12','10:15:00',1.36),('15529','2013-12-12','10:20:00',1.4),('15529','2013-12-12','10:25:00',1.41),('15529','2013-12-12','10:30:00',1.42),('15529','2013-12-12','10:35:00',1.45),('15529','2013-12-12','10:40:00',1.47),('15529','2013-12-12','10:45:00',1.5),('15529','2013-12-12','10:50:00',1.51),('15529','2013-12-12','10:55:00',1.55),('15529','2013-12-12','11:00:00',1.53),('15529','2013-12-12','11:05:00',1.57),('15529','2013-12-12','11:10:00',1.59),('15529','2013-12-12','11:15:00',1.62),('15529','2013-12-12','11:20:00',1.62),('15529','2013-12-12','11:25:00',1.64),('15529','2013-12-12','11:30:00',1.66),('15529','2013-12-12','11:35:00',1.68),('15529','2013-12-12','11:40:00',1.69),('15529','2013-12-12','11:45:00',1.7),('15529','2013-12-12','11:50:00',1.69),('15529','2013-12-12','11:55:00',1.64),('15529','2013-12-12','12:00:00',1.61),('15529','2013-12-12','12:05:00',1.64),('15529','2013-12-12','12:10:00',1.63),('15529','2013-12-12','12:15:00',1.64),('15529','2013-12-12','12:20:00',1.69),('15529','2013-12-12','12:25:00',1.6),('15529','2013-12-12','12:30:00',1.6),('15529','2013-12-12','12:35:00',1.63),('15529','2013-12-12','12:40:00',1.46),('15529','2013-12-12','12:45:00',1.61),('15529','2013-12-12','12:50:00',1.62),('15529','2013-12-12','12:55:00',1.63),('15529','2013-12-12','13:00:00',1.66),('15529','2013-12-12','13:05:00',1.64),('15529','2013-12-12','13:10:00',1.62),('15529','2013-12-12','13:15:00',1.62),('15529','2013-12-12','13:20:00',1.59),('15529','2013-12-12','13:25:00',1.59),('15529','2013-12-12','13:30:00',1.53),('15529','2013-12-12','13:35:00',1.54),('15529','2013-12-12','13:40:00',1.49),('15529','2013-12-12','13:45:00',1.48),('15529','2013-12-12','13:50:00',1.44),('15529','2013-12-12','13:55:00',1.42),('15529','2013-12-12','14:00:00',1.41),('15529','2013-12-12','14:05:00',1.38),('15529','2013-12-12','14:10:00',1.34),('15529','2013-12-12','14:15:00',1.27),('15529','2013-12-12','14:20:00',1.26),('15529','2013-12-12','14:25:00',1.24),('15529','2013-12-12','14:30:00',1.16),('15529','2013-12-12','14:35:00',1.16),('15529','2013-12-12','14:40:00',1.1),('15529','2013-12-12','14:45:00',1.04),('15529','2013-12-11','09:10:00',1.04),('15529','2013-12-11','09:15:00',1.09),('15529','2013-12-11','09:20:00',1.13),('15529','2013-12-11','09:25:00',1.18),('15529','2013-12-11','09:30:00',1.21),('15529','2013-12-11','09:35:00',1.22),('15529','2013-12-11','09:40:00',1.26),('15529','2013-12-11','09:45:00',1.31),('15529','2013-12-11','09:50:00',1.33),('15529','2013-12-11','09:55:00',1.37),('15529','2013-12-11','10:00:00',1.4),('15529','2013-12-11','10:05:00',1.45),('15529','2013-12-11','10:10:00',1.48),('15529','2013-12-11','10:15:00',1.49),('15529','2013-12-11','10:20:00',1.52),('15529','2013-12-11','10:25:00',1.53),('15529','2013-12-11','10:30:00',1.56),('15529','2013-12-11','10:35:00',1.58),('15529','2013-12-11','10:40:00',1.59),('15529','2013-12-11','10:45:00',1.6),('15529','2013-12-11','10:50:00',1.62),('15529','2013-12-11','10:55:00',1.63),('15529','2013-12-11','11:00:00',1.65),('15529','2013-12-11','11:05:00',1.66),('15529','2013-12-11','11:10:00',1.68),('15529','2013-12-11','11:15:00',1.7),('15529','2013-12-11','11:20:00',1.69),('15529','2013-12-11','11:25:00',1.69),('15529','2013-12-11','11:30:00',1.69),('15529','2013-12-11','11:35:00',1.71),('15529','2013-12-11','11:40:00',1.71),('15529','2013-12-11','11:45:00',1.7),('15529','2013-12-11','11:50:00',1.7),('15529','2013-12-11','11:55:00',1.72),('15529','2013-12-11','12:00:00',1.72),('15529','2013-12-11','12:05:00',1.73),('15529','2013-12-11','12:10:00',1.73),('15529','2013-12-11','12:15:00',1.72),('15529','2013-12-11','12:20:00',1.7),('15529','2013-12-11','12:25:00',1.69),('15529','2013-12-11','12:30:00',1.69),('15529','2013-12-11','12:35:00',1.66),('15529','2013-12-11','12:40:00',1.63),('15529','2013-12-11','12:45:00',1.63),('15529','2013-12-11','12:50:00',1.63),('15529','2013-12-11','12:55:00',1.58),('15529','2013-12-11','13:00:00',1.58),('15529','2013-12-11','13:05:00',1.58),('15529','2013-12-11','13:10:00',1.54),('15529','2013-12-11','13:15:00',1.55),('15529','2013-12-11','13:20:00',1.55),('15529','2013-12-11','13:25:00',1.5),('15529','2013-12-11','13:30:00',1.5),('15529','2013-12-11','13:35:00',1.49),('15529','2013-12-11','13:40:00',1.46),('15529','2013-12-11','13:45:00',1.43),('15529','2013-12-11','13:50:00',1.41),('15529','2013-12-11','13:55:00',1.39),('15529','2013-12-11','14:00:00',1.33),('15529','2013-12-11','14:05:00',1.3),('15529','2013-12-11','14:10:00',1.27),('15529','2013-12-11','14:15:00',1.23),('15529','2013-12-11','14:20:00',1.23),('15529','2013-12-11','14:25:00',1.18),('15529','2013-12-11','14:30:00',1.14),('15529','2013-12-11','14:35:00',1.09),('15529','2013-12-11','14:40:00',1.05),('15529','2013-12-11','14:45:00',1.01),('15529','2013-12-10','09:05:00',1.03),('15529','2013-12-10','09:10:00',1.07),('15529','2013-12-10','09:15:00',1.1),('15529','2013-12-10','09:20:00',1.15),('15529','2013-12-10','09:25:00',1.21),('15529','2013-12-10','09:30:00',1.25),('15529','2013-12-10','09:35:00',1.29),('15529','2013-12-10','09:40:00',1.33),('15529','2013-12-10','09:45:00',1.39),('15529','2013-12-10','09:50:00',1.43),('15529','2013-12-10','09:55:00',1.46),('15529','2013-12-10','10:00:00',1.49),('15529','2013-12-10','10:05:00',1.51),('15529','2013-12-10','10:10:00',1.55),('15529','2013-12-10','10:15:00',1.57),('15529','2013-12-10','10:20:00',1.6),('15529','2013-12-10','10:25:00',1.63),('15529','2013-12-10','10:30:00',1.63),('15529','2013-12-10','10:35:00',1.65),('15529','2013-12-10','10:40:00',1.67),('15529','2013-12-10','10:45:00',1.69),('15529','2013-12-10','10:50:00',1.71),('15529','2013-12-10','10:55:00',1.72),('15529','2013-12-10','11:00:00',1.74),('15529','2013-12-10','11:05:00',1.76),('15529','2013-12-10','11:10:00',1.78),('15529','2013-12-10','11:15:00',1.79),('15529','2013-12-10','11:20:00',1.8),('15529','2013-12-10','11:25:00',1.8),('15529','2013-12-10','11:30:00',1.78),('15529','2013-12-10','11:35:00',1.76),('15529','2013-12-10','11:40:00',1.77),('15529','2013-12-10','11:45:00',1.8),('15529','2013-12-10','11:50:00',1.79),('15529','2013-12-10','11:55:00',1.81),('15529','2013-12-10','12:00:00',1.8),('15529','2013-12-10','12:05:00',1.79),('15529','2013-12-10','12:10:00',1.79),('15529','2013-12-10','12:15:00',1.79),('15529','2013-12-10','12:20:00',1.79),('15529','2013-12-10','12:25:00',1.78),('15529','2013-12-10','12:30:00',1.76),('15529','2013-12-10','12:35:00',1.75),('15529','2013-12-10','12:40:00',1.76),('15529','2013-12-10','12:45:00',1.74),('15529','2013-12-10','12:50:00',1.73),('15529','2013-12-10','12:55:00',1.71),('15529','2013-12-10','13:00:00',1.69),('15529','2013-12-10','13:05:00',1.71),('15529','2013-12-10','13:10:00',1.69),('15529','2013-12-10','13:15:00',1.65),('15529','2013-12-10','13:20:00',1.62),('15529','2013-12-10','13:25:00',1.61),('15529','2013-12-10','13:30:00',1.56),('15529','2013-12-10','13:35:00',1.54),('15529','2013-12-10','13:40:00',1.53),('15529','2013-12-10','13:45:00',1.52),('15529','2013-12-10','13:50:00',1.49),('15529','2013-12-10','13:55:00',1.45),('15529','2013-12-10','14:00:00',1.41),('15529','2013-12-10','14:05:00',1.38),('15529','2013-12-10','14:10:00',1.34),('15529','2013-12-10','14:15:00',1.32),('15529','2013-12-10','14:20:00',1.29),('15529','2013-12-10','14:25:00',1.27),('15529','2013-12-10','14:30:00',1.23),('15529','2013-12-10','14:35:00',1.19),('15529','2013-12-10','14:40:00',1.13),('15529','2013-12-10','14:45:00',1.09),('15529','2013-12-10','14:50:00',1.05),('15529','2013-12-10','14:55:00',1.01),('15529','2013-12-09','09:00:00',1.04),('15529','2013-12-09','09:05:00',1.1),('15529','2013-12-09','09:10:00',1.13),('15529','2013-12-09','09:15:00',1.17),('15529','2013-12-09','09:20:00',1.21),('15529','2013-12-09','09:25:00',1.25),('15529','2013-12-09','09:30:00',1.28),('15529','2013-12-09','09:35:00',1.31),('15529','2013-12-09','09:40:00',1.33),('15529','2013-12-09','09:45:00',1.36),('15529','2013-12-09','09:50:00',1.4),('15529','2013-12-09','09:55:00',1.43),('15529','2013-12-09','10:00:00',1.47),('15529','2013-12-09','10:05:00',1.51),('15529','2013-12-09','10:10:00',1.54),('15529','2013-12-09','10:15:00',1.55),('15529','2013-12-09','10:20:00',1.57),('15529','2013-12-09','10:25:00',1.59),('15529','2013-12-09','10:30:00',1.62),('15529','2013-12-09','10:35:00',1.64),('15529','2013-12-09','10:40:00',1.66),('15529','2013-12-09','10:45:00',1.66),('15529','2013-12-09','10:50:00',1.68),('15529','2013-12-09','10:55:00',1.7),('15529','2013-12-09','11:00:00',1.7),('15529','2013-12-09','11:05:00',1.73),('15529','2013-12-09','11:10:00',1.74),('15529','2013-12-09','11:15:00',1.77),('15529','2013-12-09','11:20:00',1.77),('15529','2013-12-09','11:25:00',1.78),('15529','2013-12-09','11:30:00',1.79),('15529','2013-12-09','11:35:00',1.79),('15529','2013-12-09','11:40:00',1.79),('15529','2013-12-09','11:45:00',1.8),('15529','2013-12-09','11:50:00',1.81),('15529','2013-12-09','11:55:00',1.82),('15529','2013-12-09','12:00:00',1.81),('15529','2013-12-09','12:05:00',1.82),('15529','2013-12-09','12:10:00',1.81),('15529','2013-12-09','12:15:00',1.8),('15529','2013-12-09','12:20:00',1.79),('15529','2013-12-09','12:25:00',1.78),('15529','2013-12-09','12:30:00',1.75),('15529','2013-12-09','12:35:00',1.71),('15529','2013-12-09','12:40:00',1.66),('15529','2013-12-09','12:45:00',1.63),('15529','2013-12-09','12:50:00',1.66),('15529','2013-12-09','12:55:00',1.67),('15529','2013-12-09','13:00:00',1.67),('15529','2013-12-09','13:05:00',1.65),('15529','2013-12-09','13:10:00',1.64),('15529','2013-12-09','13:15:00',1.63),('15529','2013-12-09','13:20:00',1.6),('15529','2013-12-09','13:25:00',1.58),('15529','2013-12-09','13:30:00',1.55),('15529','2013-12-09','13:35:00',1.54),('15529','2013-12-09','13:40:00',1.51),('15529','2013-12-09','13:45:00',1.52),('15529','2013-12-09','13:50:00',1.5),('15529','2013-12-09','13:55:00',1.45),('15529','2013-12-09','14:00:00',1.43),('15529','2013-12-09','14:05:00',1.41),('15529','2013-12-09','14:10:00',1.39),('15529','2013-12-09','14:15:00',1.36),('15529','2013-12-09','14:20:00',1.32),('15529','2013-12-09','14:25:00',1.29),('15529','2013-12-09','14:30:00',1.26),('15529','2013-12-09','14:35:00',1.22),('15529','2013-12-09','14:40:00',1.19),('15529','2013-12-09','14:45:00',1.11),('15529','2013-12-09','14:50:00',1.1),('15529','2013-12-09','14:55:00',1.06),('15529','2013-12-09','15:00:00',1),('15529','2013-12-08','09:25:00',1.07),('15529','2013-12-08','09:30:00',1.23),('15529','2013-12-08','09:35:00',1.27),('15529','2013-12-08','09:40:00',1.31),('15529','2013-12-08','09:45:00',1.35),('15529','2013-12-08','09:50:00',1.4),('15529','2013-12-08','09:55:00',1.44),('15529','2013-12-08','10:00:00',1.62),('15529','2013-12-08','10:05:00',1.74),('15529','2013-12-08','10:10:00',1.85),('15529','2013-12-08','10:15:00',1.75),('15529','2013-12-08','12:50:00',1.3),('15529','2013-12-08','12:55:00',1.44),('15529','2013-12-08','13:00:00',1.63),('15529','2014-04-20','10:10:00',1.14),('15529','2014-04-20','10:15:00',1.49),('15529','2014-04-20','10:20:00',1.78),('15529','2014-04-20','10:25:00',1.77),('15529','2014-04-20','10:30:00',1.78),('15529','2014-04-20','10:35:00',1.8),('15529','2014-04-20','10:40:00',1.81),('15529','2014-04-20','10:45:00',1.85),('15529','2014-04-20','10:50:00',1.86),('15529','2014-04-20','10:55:00',1.89),('15529','2014-04-20','11:00:00',1.91),('15529','2014-04-20','11:05:00',1.93),('15529','2014-04-20','11:10:00',1.97),('15529','2014-04-20','11:15:00',2),('15529','2014-04-20','11:20:00',2.02),('15529','2014-04-20','11:25:00',2.03),('15529','2014-04-20','11:30:00',2.06),('15529','2014-04-20','11:35:00',2.08),('15529','2014-04-20','11:40:00',2.06),('15529','2014-04-20','11:45:00',2.12),('15529','2014-04-20','11:50:00',2.12),('15529','2014-04-20','11:55:00',2.14),('15529','2014-04-20','12:00:00',2.19),('15529','2014-04-20','12:05:00',2.17),('15529','2014-04-20','12:10:00',2.23),('15529','2014-04-20','12:15:00',2.23),('15529','2014-04-20','12:20:00',2.24),('15529','2014-04-20','12:25:00',2.25),('15529','2014-04-20','12:30:00',2.24),('15529','2014-04-20','12:35:00',2.24),('15529','2014-04-20','12:40:00',2.27),('15529','2014-04-20','12:45:00',2.27),('15529','2014-04-20','12:50:00',2.24),('15529','2014-04-20','12:55:00',2.25),('15529','2014-04-20','13:00:00',2.28),('15529','2014-04-20','13:05:00',2.26),('15529','2014-04-20','13:10:00',2.28),('15529','2014-04-20','13:15:00',2.28),('15529','2014-04-20','13:20:00',2.28),('15529','2014-04-20','13:25:00',2.29),('15529','2014-04-20','13:30:00',2.25),('15529','2014-04-20','13:35:00',2.25),('15529','2014-04-20','13:40:00',2.28),('15529','2014-04-20','13:45:00',2.25),('15529','2014-04-20','13:50:00',2.28),('15529','2014-04-20','13:55:00',2.27),('15529','2014-04-20','14:00:00',2.26),('15529','2014-04-20','14:05:00',2.23),('15529','2014-04-20','14:10:00',2.24),('15529','2014-04-20','14:15:00',2.19),('15529','2014-04-20','14:20:00',2.21),('15529','2014-04-20','14:25:00',2.19),('15529','2014-04-20','14:30:00',2.18),('15529','2014-04-20','14:35:00',2.15),('15529','2014-04-20','14:40:00',2.14),('15529','2014-04-20','14:45:00',2.1),('15529','2014-04-20','14:50:00',2.08),('15529','2014-04-20','14:55:00',2.05),('15529','2014-04-20','15:00:00',2.02),('15529','2014-04-20','15:05:00',2.01),('15529','2014-04-20','15:10:00',2.01),('15529','2014-04-20','15:15:00',1.98),('15529','2014-04-20','15:20:00',1.94),('15529','2014-04-20','15:25:00',1.92),('15529','2014-04-20','15:30:00',1.89),('15529','2014-04-20','15:35:00',1.85),('15529','2014-04-20','15:40:00',1.83),('15529','2014-04-20','15:45:00',1.81),('15529','2014-04-20','15:50:00',1.77),('15529','2014-04-20','15:55:00',1.74),('15529','2014-04-20','16:00:00',1.72),('15529','2014-04-20','16:05:00',1.7),('15529','2014-04-20','16:10:00',1.65),('15529','2014-04-20','16:15:00',1.66),('15529','2014-04-20','16:20:00',1.56),('15529','2014-04-20','16:25:00',1.54),('15529','2014-04-20','16:30:00',1.51),('15529','2014-04-20','16:35:00',1.45),('15529','2014-04-20','16:40:00',1.41),('15529','2014-04-20','16:45:00',1.38),('15529','2014-04-20','16:50:00',1.32),('15529','2014-04-20','16:55:00',1.28),('15529','2014-04-20','17:00:00',1.24),('15529','2014-04-20','17:05:00',1.19),('15529','2014-04-20','17:10:00',1.15),('15529','2014-04-20','17:15:00',1.1),('15529','2014-04-20','17:20:00',1.05),('15529','2014-04-20','17:25:00',1.02),('15529','2013-12-06','09:05:00',1.04),('15529','2013-12-06','09:10:00',1.09),('15529','2013-12-06','09:15:00',1.14),('15529','2013-12-06','09:20:00',1.19),('15529','2013-12-06','09:25:00',1.24),('15529','2013-12-06','09:30:00',1.28),('15529','2013-12-06','09:35:00',1.32),('15529','2013-12-06','09:40:00',1.34),('15529','2013-12-06','09:45:00',1.37),('15529','2013-12-06','09:50:00',1.41),('15529','2013-12-06','09:55:00',1.44),('15529','2013-12-06','10:00:00',1.47),('15529','2013-12-06','10:05:00',1.49),('15529','2013-12-06','10:10:00',1.52),('15529','2013-12-06','10:15:00',1.53),('15529','2013-12-06','10:20:00',1.54),('15529','2013-12-06','10:25:00',1.55),('15529','2013-12-06','10:30:00',1.58),('15529','2013-12-06','10:35:00',1.61),('15529','2013-12-06','10:40:00',1.66),('15529','2013-12-06','10:45:00',1.69),('15529','2013-12-06','10:50:00',1.7),('15529','2013-12-06','10:55:00',1.69),('15529','2013-12-06','11:00:00',1.68),('15529','2013-12-06','11:05:00',1.7),('15529','2013-12-06','11:10:00',1.7),('15529','2013-12-06','11:15:00',1.7),('15529','2013-12-06','11:20:00',1.7),('15529','2013-12-06','11:25:00',1.7),('15529','2013-12-06','11:30:00',1.71),('15529','2013-12-06','11:35:00',1.71),('15529','2013-12-06','11:40:00',1.71),('15529','2013-12-06','11:45:00',1.69),('15529','2013-12-06','11:50:00',1.69),('15529','2013-12-06','11:55:00',1.7),('15529','2013-12-06','12:00:00',1.69),('15529','2013-12-06','12:05:00',1.69),('15529','2013-12-06','12:10:00',1.68),('15529','2013-12-06','12:15:00',1.71),('15529','2013-12-06','12:20:00',1.71),('15529','2013-12-06','12:25:00',1.69),('15529','2013-12-06','12:30:00',1.68),('15529','2013-12-06','12:35:00',1.67),('15529','2013-12-06','12:40:00',1.67),('15529','2013-12-06','12:45:00',1.64),('15529','2013-12-06','12:50:00',1.63),('15529','2013-12-06','12:55:00',1.64),('15529','2013-12-06','13:00:00',1.6),('15529','2013-12-06','13:05:00',1.59),('15529','2013-12-06','13:10:00',1.59),('15529','2013-12-06','13:15:00',1.59),('15529','2013-12-06','13:20:00',1.57),('15529','2013-12-06','13:25:00',1.57),('15529','2013-12-06','13:30:00',1.54),('15529','2013-12-06','13:35:00',1.52),('15529','2013-12-06','13:40:00',1.52),('15529','2013-12-06','13:45:00',1.49),('15529','2013-12-06','13:50:00',1.46),('15529','2013-12-06','13:55:00',1.44),('15529','2013-12-06','14:00:00',1.38),('15529','2013-12-06','14:05:00',1.36),('15529','2013-12-06','14:10:00',1.34),('15529','2013-12-06','14:15:00',1.3),('15529','2013-12-06','14:20:00',1.25),('15529','2013-12-06','14:25:00',1.18),('15529','2013-12-06','14:30:00',1.15),('15529','2013-12-06','14:35:00',1.12),('15529','2013-12-06','14:40:00',1.07),('15529','2013-12-05','11:50:00',1.2),('15529','2013-12-05','11:55:00',1.42),('15529','2013-12-05','12:00:00',1.31),('15529','2013-12-05','12:05:00',1.2),('15529','2013-12-05','12:10:00',1.2),('15529','2013-12-05','12:15:00',1.29),('15529','2013-12-05','12:30:00',1.34),('15529','2013-12-05','12:35:00',1.88),('15529','2013-12-05','15:05:00',1.06),('15529','2013-12-04','08:55:00',1.03),('15529','2013-12-04','09:00:00',1.07),('15529','2013-12-04','09:05:00',1.12),('15529','2013-12-04','09:10:00',1.15),('15529','2013-12-04','09:15:00',1.22),('15529','2013-12-04','09:20:00',1.26),('15529','2013-12-04','09:25:00',1.31),('15529','2013-12-04','09:30:00',1.34),('15529','2013-12-04','09:35:00',1.37),('15529','2013-12-04','09:40:00',1.39),('15529','2013-12-04','09:45:00',1.41),('15529','2013-12-04','09:50:00',1.44),('15529','2013-12-04','09:55:00',1.47),('15529','2013-12-04','10:00:00',1.51),('15529','2013-12-04','10:05:00',1.54),('15529','2013-12-04','10:10:00',1.55),('15529','2013-12-04','10:15:00',1.58),('15529','2013-12-04','10:20:00',1.59),('15529','2013-12-04','10:25:00',1.61),('15529','2013-12-04','10:30:00',1.63),('15529','2013-12-04','10:35:00',1.63),('15529','2013-12-04','10:40:00',1.67),('15529','2013-12-04','10:45:00',1.65),('15529','2013-12-04','10:50:00',1.68),('15529','2013-12-04','10:55:00',1.69),('15529','2013-12-04','11:00:00',1.71),('15529','2013-12-04','11:05:00',1.71),('15529','2013-12-04','11:10:00',1.74),('15529','2013-12-04','11:15:00',1.76),('15529','2013-12-04','11:20:00',1.77),('15529','2013-12-04','11:25:00',1.79),('15529','2013-12-04','11:30:00',1.78),('15529','2013-12-04','11:35:00',1.77),('15529','2013-12-04','11:40:00',1.8),('15529','2013-12-04','11:45:00',1.78),('15529','2013-12-04','11:50:00',1.76),('15529','2013-12-04','11:55:00',1.76),('15529','2013-12-04','12:00:00',1.75),('15529','2013-12-04','12:05:00',1.78),('15529','2013-12-04','12:10:00',1.74),('15529','2013-12-04','12:15:00',1.73),('15529','2013-12-04','12:20:00',1.77),('15529','2013-12-04','12:25:00',1.74),('15529','2013-12-04','12:30:00',1.73),('15529','2013-12-04','12:35:00',1.75),('15529','2013-12-04','12:40:00',1.77),('15529','2013-12-04','12:45:00',1.74),('15529','2013-12-04','12:50:00',1.8),('15529','2013-12-04','12:55:00',1.73),('15529','2013-12-04','13:00:00',1.71),('15529','2013-12-04','13:05:00',1.69),('15529','2013-12-04','13:10:00',1.66),('15529','2013-12-04','13:15:00',1.64),('15529','2013-12-04','13:20:00',1.64),('15529','2013-12-04','13:25:00',1.62),('15529','2013-12-04','13:30:00',1.36),('15529','2013-12-04','13:35:00',1.46),('15529','2013-12-04','13:40:00',1.5),('15529','2013-12-04','13:45:00',1.46),('15529','2013-12-04','13:50:00',1.43),('15529','2013-12-04','13:55:00',1.39),('15529','2013-12-04','14:00:00',1.39),('15529','2013-12-04','14:05:00',1.38),('15529','2013-12-04','14:10:00',1.31),('15529','2013-12-04','14:15:00',1.28),('15529','2013-12-04','14:20:00',1.2),('15529','2013-12-04','14:25:00',1.2),('15529','2013-12-04','14:30:00',1.16),('15529','2013-12-04','14:35:00',1.17),('15529','2013-12-04','14:40:00',1.11),('15529','2013-12-04','14:45:00',1.08),('15529','2013-12-04','14:50:00',1.02),('15529','2013-12-03','08:45:00',1.04),('15529','2013-12-03','08:50:00',1.09),('15529','2013-12-03','08:55:00',1.13),('15529','2013-12-03','09:00:00',1.17),('15529','2013-12-03','09:05:00',1.22),('15529','2013-12-03','09:10:00',1.26),('15529','2013-12-03','09:15:00',1.3),('15529','2013-12-03','09:20:00',1.34),('15529','2013-12-03','09:25:00',1.38),('15529','2013-12-03','09:30:00',1.41),('15529','2013-12-03','09:35:00',1.44),('15529','2013-12-03','09:40:00',1.48),('15529','2013-12-03','09:45:00',1.52),('15529','2013-12-03','09:50:00',1.56),('15529','2013-12-03','09:55:00',1.58),('15529','2013-12-03','10:00:00',1.6),('15529','2013-12-03','10:05:00',1.64),('15529','2013-12-03','10:10:00',1.66),('15529','2013-12-03','10:15:00',1.68),('15529','2013-12-03','10:20:00',1.7),('15529','2013-12-03','10:25:00',1.72),('15529','2013-12-03','10:30:00',1.73),('15529','2013-12-03','10:35:00',1.75),('15529','2013-12-03','10:40:00',1.77),('15529','2013-12-03','10:45:00',1.78),('15529','2013-12-03','10:50:00',1.79),('15529','2013-12-03','10:55:00',1.8),('15529','2013-12-03','11:00:00',1.81),('15529','2013-12-03','11:05:00',1.83),('15529','2013-12-03','11:10:00',1.85),('15529','2013-12-03','11:15:00',1.85),('15529','2013-12-03','11:20:00',1.85),('15529','2013-12-03','11:25:00',1.88),('15529','2013-12-03','11:30:00',1.88),('15529','2013-12-03','11:35:00',1.87),('15529','2013-12-03','11:40:00',1.87),('15529','2013-12-03','11:45:00',1.87),('15529','2013-12-03','11:50:00',1.87),('15529','2013-12-03','11:55:00',1.86),('15529','2013-12-03','12:00:00',1.87),('15529','2013-12-03','12:05:00',1.86),('15529','2013-12-03','12:10:00',1.86),('15529','2013-12-03','12:15:00',1.84),('15529','2013-12-03','12:20:00',1.83),('15529','2013-12-03','12:25:00',1.83),('15529','2013-12-03','12:30:00',1.83),('15529','2013-12-03','12:35:00',1.82),('15529','2013-12-03','12:40:00',1.81),('15529','2013-12-03','12:45:00',1.8),('15529','2013-12-03','12:50:00',1.8),('15529','2013-12-03','12:55:00',1.76),('15529','2013-12-03','13:00:00',1.75),('15529','2013-12-03','13:05:00',1.74),('15529','2013-12-03','13:10:00',1.72),('15529','2013-12-03','13:15:00',1.71),('15529','2013-12-03','13:20:00',1.7),('15529','2013-12-03','13:25:00',1.66),('15529','2013-12-03','13:30:00',1.63),('15529','2013-12-03','13:35:00',1.62),('15529','2013-12-03','13:40:00',1.59),('15529','2013-12-03','13:45:00',1.57),('15529','2013-12-03','13:50:00',1.54),('15529','2013-12-03','13:55:00',1.52),('15529','2013-12-03','14:00:00',1.49),('15529','2013-12-03','14:05:00',1.46),('15529','2013-12-03','14:10:00',1.42),('15529','2013-12-03','14:15:00',1.4),('15529','2013-12-03','14:20:00',1.38),('15529','2013-12-03','14:25:00',1.34),('15529','2013-12-03','14:30:00',1.29),('15529','2013-12-03','14:35:00',1.25),('15529','2013-12-03','14:40:00',1.21),('15529','2013-12-03','14:45:00',1.17),('15529','2013-12-03','14:50:00',1.12),('15529','2013-12-03','14:55:00',1.08),('15529','2013-12-03','15:00:00',1.03),('15529','2013-12-02','09:35:00',1.11),('15529','2013-12-02','09:40:00',1.29),('15529','2013-12-02','09:45:00',1.31),('15529','2013-12-02','09:50:00',1.45),('15529','2013-12-02','09:55:00',1.37),('15529','2013-12-02','10:00:00',1.63),('15529','2013-12-02','10:05:00',1.64),('15529','2013-12-02','10:10:00',1.65),('15529','2013-12-02','10:15:00',1.66),('15529','2013-12-02','10:20:00',1.68),('15529','2013-12-02','10:25:00',1.7),('15529','2013-12-02','10:30:00',1.71),('15529','2013-12-02','10:35:00',1.74),('15529','2013-12-02','10:40:00',1.76),('15529','2013-12-02','10:45:00',1.79),('15529','2013-12-02','10:50:00',1.83),('15529','2013-12-02','10:55:00',1.84),('15529','2013-12-02','11:00:00',1.85),('15529','2013-12-02','11:05:00',1.87),('15529','2013-12-02','11:10:00',1.87),('15529','2013-12-02','11:15:00',1.88),('15529','2013-12-02','11:20:00',1.88),('15529','2013-12-02','11:25:00',1.88),('15529','2013-12-02','11:30:00',1.89),('15529','2013-12-02','11:35:00',1.88),('15529','2013-12-02','11:40:00',1.88),('15529','2013-12-02','11:45:00',1.88),('15529','2013-12-02','11:50:00',1.89),('15529','2013-12-02','11:55:00',1.89),('15529','2013-12-02','12:00:00',1.89),('15529','2013-12-02','12:05:00',1.9),('15529','2013-12-02','12:10:00',1.89),('15529','2013-12-02','12:15:00',1.89),('15529','2013-12-02','12:20:00',1.91),('15529','2013-12-02','12:25:00',1.89),('15529','2013-12-02','12:30:00',1.9),('15529','2013-12-02','12:35:00',1.92),('15529','2013-12-02','12:40:00',1.92),('15529','2013-12-02','12:45:00',1.94),('15529','2013-12-02','12:50:00',1.99),('15529','2013-12-02','12:55:00',2.02),('15529','2013-12-02','13:00:00',2.05),('15529','2013-12-02','13:05:00',2.08),('15529','2013-12-02','13:10:00',2.08),('15529','2013-12-02','13:15:00',2.08),('15529','2013-12-02','13:20:00',2),('15529','2013-12-02','13:25:00',1.97),('15529','2013-12-02','13:30:00',1.86),('15529','2013-12-02','13:35:00',1.76),('15529','2013-12-02','13:40:00',1.82),('15529','2013-12-02','13:45:00',1.74),('15529','2013-12-02','13:50:00',1.62),('15529','2013-12-02','13:55:00',1.55),('15529','2013-12-02','14:00:00',1.42),('15529','2013-12-02','14:05:00',1.22),('15529','2013-12-02','14:10:00',1.13),('15529','2013-12-02','14:15:00',1.14),('15529','2013-12-02','14:20:00',1.08),('15529','2013-12-02','14:25:00',1.08),('15529','2013-12-02','14:30:00',1.22),('15529','2013-12-02','14:35:00',1.26),('15529','2013-12-02','14:40:00',1.21),('15529','2013-12-02','14:45:00',1.16),('15529','2013-12-02','14:50:00',1.11),('15529','2013-12-02','14:55:00',1.06),('15529','2013-12-02','15:00:00',1.01),('15529','2013-11-29','09:15:00',1.08),('15529','2013-11-29','09:20:00',1.08),('15529','2013-11-29','09:25:00',1.36),('15529','2013-11-29','09:30:00',1.52),('15529','2013-11-29','09:35:00',1.34),('15529','2013-11-29','09:40:00',1.15),('15529','2013-11-29','10:40:00',1.09),('15529','2013-11-28','08:45:00',1.03),('15529','2013-11-28','08:50:00',1.08),('15529','2013-11-28','08:55:00',1.12),('15529','2013-11-28','09:00:00',1.17),('15529','2013-11-28','09:05:00',1.22),('15529','2013-11-28','09:10:00',1.26),('15529','2013-11-28','09:15:00',1.3),('15529','2013-11-28','09:20:00',1.34),('15529','2013-11-28','09:25:00',1.38),('15529','2013-11-28','09:30:00',1.42),('15529','2013-11-28','09:35:00',1.47),('15529','2013-11-28','09:40:00',1.5),('15529','2013-11-28','09:45:00',1.54),('15529','2013-11-28','09:50:00',1.57),('15529','2013-11-28','09:55:00',1.6),('15529','2013-11-28','10:00:00',1.63),('15529','2013-11-28','10:05:00',1.66),('15529','2013-11-28','10:10:00',1.68),('15529','2013-11-28','10:15:00',1.7),('15529','2013-11-28','10:20:00',1.73),('15529','2013-11-28','10:25:00',1.75),('15529','2013-11-28','10:30:00',1.77),('15529','2013-11-28','10:35:00',1.78),('15529','2013-11-28','10:40:00',1.8),('15529','2013-11-28','10:45:00',1.82),('15529','2013-11-28','10:50:00',1.83),('15529','2013-11-28','10:55:00',1.84),('15529','2013-11-28','11:00:00',1.85),('15529','2013-11-28','11:05:00',1.87),('15529','2013-11-28','11:10:00',1.88),('15529','2013-11-28','11:15:00',1.89),('15529','2013-11-28','11:20:00',1.9),('15529','2013-11-28','11:25:00',1.91),('15529','2013-11-28','11:30:00',1.92),('15529','2013-11-28','11:35:00',1.92),('15529','2013-11-28','11:40:00',1.92),('15529','2013-11-28','11:45:00',1.93),('15529','2013-11-28','11:50:00',1.92),('15529','2013-11-28','11:55:00',1.93),('15529','2013-11-28','12:00:00',1.92),('15529','2013-11-28','12:05:00',1.92),('15529','2013-11-28','12:10:00',1.91),('15529','2013-11-28','12:15:00',1.9),('15529','2013-11-28','12:20:00',1.89),('15529','2013-11-28','12:25:00',1.87),('15529','2013-11-28','12:30:00',1.88),('15529','2013-11-28','12:35:00',1.88),('15529','2013-11-28','12:40:00',1.87),('15529','2013-11-28','12:45:00',1.85),('15529','2013-11-28','12:50:00',1.84),('15529','2013-11-28','12:55:00',1.82),('15529','2013-11-28','13:00:00',1.81),('15529','2013-11-28','13:05:00',1.78),('15529','2013-11-28','13:10:00',1.77),('15529','2013-11-28','13:15:00',1.76),('15529','2013-11-28','13:20:00',1.73),('15529','2013-11-28','13:25:00',1.7),('15529','2013-11-28','13:30:00',1.68),('15529','2013-11-28','13:35:00',1.65),('15529','2013-11-28','13:40:00',1.63),('15529','2013-11-28','13:45:00',1.6),('15529','2013-11-28','13:50:00',1.57),('15529','2013-11-28','13:55:00',1.54),('15529','2013-11-28','14:00:00',1.5),('15529','2013-11-28','14:05:00',1.46),('15529','2013-11-28','14:10:00',1.42),('15529','2013-11-28','14:15:00',1.4),('15529','2013-11-28','14:20:00',1.37),('15529','2013-11-28','14:25:00',1.33),('15529','2013-11-28','14:30:00',1.28),('15529','2013-11-28','14:35:00',1.24),('15529','2013-11-28','14:40:00',1.19),('15529','2013-11-28','14:45:00',1.15),('15529','2013-11-28','14:50:00',1.1),('15529','2013-11-28','14:55:00',1.05),('15529','2013-11-28','15:00:00',1.01),('15529','2014-04-19','09:10:00',1.27),('15529','2014-04-19','09:15:00',1.39),('15529','2014-04-19','09:20:00',1.33),('15529','2014-04-19','09:30:00',1.18),('15529','2014-04-19','09:35:00',1.73),('15529','2014-04-19','09:45:00',1),('15529','2014-04-19','09:55:00',1.02),('15529','2014-04-19','10:00:00',1.2),('15529','2014-04-19','10:05:00',1.46),('15529','2014-04-19','10:10:00',1.24),('15529','2014-04-19','10:15:00',1.58),('15529','2014-04-19','10:20:00',1.69),('15529','2014-04-19','10:25:00',1.58),('15529','2014-04-19','10:30:00',1.29),('15529','2014-04-19','10:35:00',1.45),('15529','2014-04-19','10:40:00',1.32),('15529','2014-04-19','10:45:00',1.35),('15529','2014-04-19','10:50:00',1.43),('15529','2014-04-19','10:55:00',1.76),('15529','2014-04-19','11:00:00',1.87),('15529','2014-04-19','11:05:00',1.75),('15529','2014-04-19','11:10:00',1.95),('15529','2014-04-19','11:15:00',2.2),('15529','2014-04-19','11:20:00',1.92),('15529','2014-04-19','11:25:00',2.15),('15529','2014-04-19','11:30:00',2.22),('15529','2014-04-19','11:35:00',2.27),('15529','2014-04-19','11:40:00',2.29),('15529','2014-04-19','11:45:00',2.3),('15529','2014-04-19','11:50:00',1.58),('15529','2014-04-19','11:55:00',1.99),('15529','2014-04-19','12:00:00',1.38),('15529','2014-04-19','12:05:00',2.35),('15529','2014-04-19','12:10:00',2.24),('15529','2014-04-19','12:15:00',1.87),('15529','2014-04-19','12:20:00',1.96),('15529','2014-04-19','12:25:00',1.36),('15529','2014-04-19','12:30:00',2.33),('15529','2014-04-19','12:40:00',1.13),('15529','2014-04-19','12:45:00',2.48),('15529','2014-04-19','12:50:00',2.47),('15529','2014-04-19','12:55:00',2.38),('15529','2014-04-19','13:00:00',2.38),('15529','2014-04-19','13:05:00',2.37),('15529','2014-04-19','13:10:00',2.09),('15529','2014-04-19','13:15:00',2.38),('15529','2014-04-19','13:20:00',2.37),('15529','2014-04-19','13:25:00',2.34),('15529','2014-04-19','13:30:00',2.32),('15529','2014-04-19','13:35:00',2.35),('15529','2014-04-19','13:40:00',2.33),('15529','2014-04-19','13:45:00',2.31),('15529','2014-04-19','13:50:00',2.31),('15529','2014-04-19','13:55:00',2.31),('15529','2014-04-19','14:00:00',2.31),('15529','2014-04-19','14:05:00',2.29),('15529','2014-04-19','14:10:00',2.29),('15529','2014-04-19','14:15:00',2.35),('15529','2014-04-19','14:20:00',1.51),('15529','2014-04-19','14:25:00',1.54),('15529','2014-04-19','14:30:00',1.39),('15529','2014-04-19','14:35:00',1.23),('15529','2014-04-19','14:40:00',1.25),('15529','2014-04-19','14:45:00',1.34),('15529','2014-04-19','14:50:00',1.37),('15529','2014-04-19','14:55:00',1.52),('15529','2014-04-19','15:00:00',2.33),('15529','2014-04-19','15:05:00',1.9),('15529','2014-04-19','15:10:00',1.99),('15529','2014-04-19','15:15:00',2.03),('15529','2014-04-19','15:20:00',1.99),('15529','2014-04-19','15:25:00',1.97),('15529','2014-04-19','15:30:00',1.96),('15529','2014-04-19','15:35:00',1.94),('15529','2014-04-19','15:40:00',2),('15529','2014-04-19','15:45:00',1.27),('15529','2014-04-19','15:50:00',1.8),('15529','2014-04-19','15:55:00',1.81),('15529','2014-04-19','16:00:00',1.76),('15529','2014-04-19','16:05:00',1.72),('15529','2014-04-19','16:10:00',1.7),('15529','2014-04-19','16:15:00',1.67),('15529','2014-04-19','16:20:00',1.63),('15529','2014-04-19','16:25:00',1.7),('15529','2014-04-19','16:30:00',1.54),('15529','2014-04-19','16:35:00',1.52),('15529','2014-04-19','16:40:00',1.26),('15529','2014-04-19','16:45:00',1.04),('15529','2014-04-19','16:50:00',1.45),('15529','2014-04-19','16:55:00',1.38),('15529','2014-04-19','17:00:00',1.3),('15529','2014-04-19','17:05:00',1.23),('15529','2014-04-19','17:10:00',1.17),('15529','2014-04-19','17:15:00',1.11),('15529','2014-04-19','17:20:00',1.06),('15529','2014-04-19','17:25:00',1),('15529','2013-11-26','11:30:00',1.25),('15529','2013-11-26','11:35:00',1.05),('15529','2013-11-26','11:45:00',1.4),('15529','2013-11-26','11:50:00',2.24),('15529','2013-11-26','11:55:00',2.11),('15529','2013-11-26','12:00:00',1.95),('15529','2013-11-26','12:10:00',1),('15529','2013-11-26','12:15:00',1.46),('15529','2013-11-26','12:20:00',1.66),('15529','2013-11-26','12:25:00',1.98),('15529','2013-11-25','10:00:00',1.53),('15529','2013-11-25','10:10:00',1.07),('15529','2013-11-25','10:15:00',1.54),('15529','2013-11-25','10:20:00',2.11),('15529','2013-11-25','10:25:00',2.03),('15529','2013-11-25','10:30:00',1.56),('15529','2013-11-25','10:35:00',1.54),('15529','2013-11-25','10:40:00',1.98),('15529','2013-11-25','10:45:00',1.96),('15529','2013-11-25','10:50:00',1.98),('15529','2013-11-25','10:55:00',1.98),('15529','2013-11-25','11:00:00',2.03),('15529','2013-11-25','11:05:00',2.16),('15529','2013-11-25','11:10:00',2.26),('15529','2013-11-25','11:15:00',2.08),('15529','2013-11-25','11:20:00',1.08),('15529','2013-11-25','11:25:00',2.3),('15529','2013-11-25','11:30:00',2.13),('15529','2013-11-25','11:35:00',2.28),('15529','2013-11-25','11:40:00',1.66),('15529','2013-11-25','11:45:00',2.03),('15529','2013-11-25','11:50:00',1.69),('15529','2013-11-25','11:55:00',1.46),('15529','2013-11-25','12:00:00',1.3),('15529','2013-11-25','12:15:00',1.53),('15529','2013-11-25','12:20:00',2.1),('15529','2013-11-25','12:25:00',2.05),('15529','2013-11-25','12:30:00',2.02),('15529','2013-11-25','12:35:00',2),('15529','2013-11-25','12:40:00',2.03),('15529','2013-11-25','12:45:00',2),('15529','2013-11-25','12:50:00',1.99),('15529','2013-11-25','12:55:00',1.98),('15529','2013-11-25','13:00:00',1.95),('15529','2013-11-25','13:05:00',1.94),('15529','2013-11-25','13:10:00',1.92),('15529','2013-11-25','13:15:00',1.91),('15529','2013-11-25','13:20:00',1.88),('15529','2013-11-25','13:25:00',1.86),('15529','2013-11-25','13:30:00',1.84),('15529','2013-11-25','13:35:00',1.81),('15529','2013-11-25','13:40:00',1.79),('15529','2013-11-25','13:45:00',1.77),('15529','2013-11-25','13:50:00',1.75),('15529','2013-11-25','13:55:00',1.71),('15529','2013-11-25','14:00:00',1.78),('15529','2013-11-25','14:05:00',1.86),('15529','2013-11-25','14:10:00',1.8),('15529','2013-11-25','14:15:00',1.99),('15529','2013-11-25','14:20:00',1.72),('15529','2013-11-25','14:25:00',1.71),('15529','2013-11-25','14:30:00',1.21),('15529','2013-11-25','14:35:00',1.35),('15529','2013-11-25','14:40:00',1.26),('15529','2013-11-25','14:45:00',1.24),('15529','2013-11-25','14:50:00',1.23),('15529','2013-11-25','14:55:00',1.37),('15529','2013-11-25','15:00:00',1.28),('15529','2013-11-25','15:05:00',1.2),('15529','2013-11-25','15:10:00',1.12),('15529','2013-11-25','15:15:00',1.04),('15529','2013-11-24','08:35:00',1.06),('15529','2013-11-24','08:50:00',1.1),('15529','2013-11-24','08:55:00',1.45),('15529','2013-11-24','09:00:00',1.56),('15529','2013-11-24','09:05:00',1.62),('15529','2013-11-24','09:10:00',1.61),('15529','2013-11-24','09:15:00',1.57),('15529','2013-11-24','09:20:00',1.68),('15529','2013-11-24','09:25:00',1.32),('15529','2013-11-24','09:30:00',1.48),('15529','2013-11-24','09:35:00',1.22),('15529','2013-11-24','09:40:00',1.05),('15529','2013-11-24','09:50:00',1.03),('15529','2013-11-24','09:55:00',1.58),('15529','2013-11-24','10:00:00',1.1),('15529','2013-11-24','10:10:00',1.12),('15529','2013-11-24','10:30:00',1.03),('15529','2013-11-24','10:35:00',1.66),('15529','2013-11-24','10:40:00',1.58),('15529','2013-11-24','10:45:00',1.97),('15529','2013-11-24','10:50:00',1.94),('15529','2013-11-24','10:55:00',1.89),('15529','2013-11-24','11:00:00',1.88),('15529','2013-11-24','11:05:00',1.94),('15529','2013-11-24','11:10:00',2.18),('15529','2013-11-24','11:15:00',1.8),('15529','2013-11-24','11:50:00',1.59),('15529','2013-11-24','11:55:00',1.08),('15529','2013-11-24','12:05:00',1.72),('15529','2013-11-24','12:10:00',1.37),('15529','2013-11-24','12:25:00',1),('15529','2013-11-24','12:35:00',1.99),('15529','2013-11-24','12:40:00',1.85),('15529','2013-11-24','12:45:00',1.42),('15529','2013-11-24','12:50:00',1.62),('15529','2013-11-24','12:55:00',1.9),('15529','2013-11-24','13:00:00',1.72),('15529','2013-11-24','13:05:00',1.93),('15529','2013-11-24','13:10:00',2.23),('15529','2013-11-24','13:15:00',1.9),('15529','2013-11-24','13:20:00',2.21),('15529','2013-11-24','13:25:00',2.13),('15529','2013-11-23','12:50:00',1.33),('15529','2013-11-23','12:55:00',1.53),('15529','2013-11-23','13:05:00',1.05),('15529','2013-11-23','13:10:00',1.29),('15529','2013-11-22','10:25:00',1.28),('15529','2013-11-22','10:30:00',1.49),('15529','2013-11-22','10:35:00',1.29),('15529','2013-11-22','13:35:00',1.25),('15529','2013-11-20','09:45:00',1.18),('15529','2013-11-20','10:00:00',1.15),('15529','2013-11-20','10:05:00',1.1),('15529','2013-11-20','10:10:00',1.58),('15529','2013-11-20','10:15:00',1.59),('15529','2013-11-20','10:20:00',1.29),('15529','2013-11-20','10:25:00',1.35),('15529','2013-11-20','10:30:00',1.8),('15529','2013-11-20','10:35:00',1.85),('15529','2013-11-20','10:40:00',1.71),('15529','2013-11-20','11:15:00',1.04),('15529','2013-11-20','11:20:00',1.79),('15529','2013-11-20','11:25:00',1.63),('15529','2013-11-20','11:30:00',1.36),('15529','2013-11-20','11:35:00',2.03),('15529','2013-11-20','11:40:00',1.35),('15529','2013-11-20','11:45:00',2.03),('15529','2013-11-20','11:50:00',1.9),('15529','2013-11-20','12:00:00',1.92),('15529','2013-11-20','12:05:00',2.01),('15529','2013-11-20','12:10:00',1.99),('15529','2013-11-20','12:15:00',1.98),('15529','2013-11-20','12:20:00',2.01),('15529','2013-11-20','12:25:00',2.05),('15529','2013-11-20','12:30:00',2.12),('15529','2013-11-20','12:35:00',1.76),('15529','2013-11-20','12:40:00',2.14),('15529','2013-11-20','12:45:00',2.09),('15529','2013-11-20','12:50:00',2.14),('15529','2013-11-20','12:55:00',1.43),('15529','2013-11-20','13:00:00',1.88),('15529','2013-11-20','13:10:00',1.79),('15529','2013-11-20','13:15:00',1.76),('15529','2013-11-20','13:20:00',1.08),('15529','2013-11-20','13:40:00',1.92),('15529','2013-11-20','13:45:00',1.33),('15529','2013-11-20','13:50:00',1.75),('15529','2013-11-20','13:55:00',1.56),('15529','2013-11-20','14:35:00',1.37),('15529','2013-11-20','14:40:00',1.3),('15529','2013-11-20','14:45:00',1.25),('15529','2013-11-20','14:50:00',1.2),('15529','2013-11-20','14:55:00',1.14),('15529','2013-11-20','15:00:00',1.09),('15529','2013-11-20','15:05:00',1.02),('15529','2013-11-19','09:10:00',1.33),('15529','2013-11-19','09:15:00',1.3),('15529','2013-11-19','09:20:00',1.34),('15529','2013-11-19','11:40:00',1.99),('15529','2013-11-19','11:45:00',1.79),('15529','2013-11-19','11:50:00',1.49),('15529','2013-11-19','12:15:00',1.22),('15529','2013-11-19','12:20:00',1.86),('15529','2013-11-19','12:45:00',1.06),('15529','2013-11-19','12:50:00',1.43),('15529','2013-11-19','13:15:00',1.13),('15529','2013-11-19','13:25:00',1.01),('15529','2013-11-19','13:35:00',1.21),('15529','2013-11-18','09:35:00',1.34),('15529','2013-11-18','09:40:00',1.48),('15529','2013-11-18','09:45:00',1.48),('15529','2013-11-18','11:25:00',1.29),('15529','2013-11-18','11:35:00',1.97),('15529','2013-11-18','11:40:00',1.86),('15529','2013-11-18','11:45:00',1.81),('15529','2013-11-18','11:50:00',1.79),('15529','2013-11-18','11:55:00',1.78),('15529','2013-11-18','12:00:00',1.66),('15529','2013-11-18','12:05:00',1.58),('15529','2013-11-18','12:10:00',1.14),('15529','2013-11-18','12:15:00',1.62),('15529','2013-11-18','12:20:00',1.36),('15529','2013-11-18','12:40:00',2.04),('15529','2013-11-18','12:45:00',2.02),('15529','2013-11-18','12:50:00',2.04),('15529','2013-11-18','15:30:00',1.06),('15529','2013-11-17','09:20:00',1.03),('15529','2013-11-17','09:25:00',1.07),('15529','2013-11-17','09:30:00',1.12),('15529','2013-11-17','09:35:00',1.38),('15529','2013-11-17','10:10:00',1.07),('15529','2013-11-17','10:15:00',1.07),('15529','2013-11-17','12:20:00',1.06),('15529','2013-11-17','12:25:00',1.11),('15529','2014-04-18','08:25:00',1.03),('15529','2014-04-18','08:30:00',1.07),('15529','2014-04-18','09:30:00',1.06),('15529','2014-04-18','11:15:00',1.21),('15529','2014-04-18','11:20:00',1.68),('15529','2014-04-18','11:25:00',1.28),('15529','2014-04-18','11:30:00',1.09),('15529','2014-04-18','11:35:00',1.24),('15529','2014-04-18','11:40:00',1.17),('15529','2014-04-18','14:40:00',1.16),('15529','2014-04-18','14:45:00',1.04),('15529','2014-04-18','15:50:00',1.25),('15529','2014-04-18','15:55:00',1.24),('15529','2014-04-18','16:00:00',1.55),('15529','2014-04-18','16:15:00',1.19),('15529','2014-04-18','16:20:00',1.02),('15529','2014-04-18','16:30:00',1.13),('15529','2013-11-16','08:50:00',1.39),('15529','2013-11-16','08:55:00',1.38),('15529','2013-11-16','09:00:00',1.3),('15529','2013-11-16','09:05:00',1.3),('15529','2013-11-16','09:20:00',1.33),('15529','2013-11-16','09:30:00',1.5),('15529','2013-11-16','09:35:00',1.61),('15529','2013-11-16','09:40:00',1.57),('15529','2013-11-16','09:45:00',1.51),('15529','2013-11-16','09:50:00',1.56),('15529','2013-11-16','09:55:00',1.59),('15529','2013-11-16','10:00:00',1.61),('15529','2013-11-16','10:05:00',1.64),('15529','2013-11-16','10:10:00',1.67),('15529','2013-11-16','10:15:00',1.68),('15529','2013-11-16','10:20:00',1.7),('15529','2013-11-16','10:25:00',1.72),('15529','2013-11-16','10:30:00',1.75),('15529','2013-11-16','10:35:00',1.76),('15529','2013-11-16','10:40:00',1.77),('15529','2013-11-16','10:45:00',1.79),('15529','2013-11-16','10:50:00',1.79),('15529','2013-11-16','10:55:00',1.81),('15529','2013-11-16','11:00:00',1.82),('15529','2013-11-16','11:05:00',1.81),('15529','2013-11-16','11:10:00',1.82),('15529','2013-11-16','11:15:00',1.83),('15529','2013-11-16','11:20:00',1.84),('15529','2013-11-16','11:25:00',1.83),('15529','2013-11-16','11:30:00',1.83),('15529','2013-11-16','11:35:00',1.84),('15529','2013-11-16','11:40:00',1.84),('15529','2013-11-16','11:45:00',1.83),('15529','2013-11-16','11:50:00',1.83),('15529','2013-11-16','11:55:00',1.83),('15529','2013-11-16','12:00:00',1.82),('15529','2013-11-16','12:05:00',1.82),('15529','2013-11-16','12:10:00',1.79),('15529','2013-11-16','12:15:00',1.8),('15529','2013-11-16','12:20:00',1.81),('15529','2013-11-16','12:25:00',1.8),('15529','2013-11-16','12:30:00',1.78),('15529','2013-11-16','12:35:00',1.77),('15529','2013-11-16','12:40:00',1.77),('15529','2013-11-16','12:45:00',1.76),('15529','2013-11-16','12:50:00',1.76),('15529','2013-11-16','12:55:00',1.73),('15529','2013-11-16','13:00:00',1.7),('15529','2013-11-16','13:05:00',1.69),('15529','2013-11-16','13:10:00',1.69),('15529','2013-11-16','13:15:00',1.67),('15529','2013-11-16','13:20:00',1.65),('15529','2013-11-16','13:25:00',1.64),('15529','2013-11-16','14:05:00',1.05),('15529','2013-11-16','14:10:00',1.27),('15529','2013-11-16','14:15:00',1.17),('15529','2013-11-16','14:20:00',1.34),('15529','2013-11-16','14:25:00',1.29),('15529','2013-11-16','14:30:00',1.23),('15529','2013-11-16','14:35:00',1.17),('15529','2013-11-13','08:55:00',1.18),('15529','2013-11-13','09:00:00',1.28),('15529','2013-11-13','09:05:00',1.35),('15529','2013-11-13','09:10:00',1.34),('15529','2013-11-13','09:15:00',1.28),('15529','2013-11-13','09:20:00',1.33),('15529','2013-11-13','09:25:00',1.4),('15529','2013-11-13','09:30:00',1.43),('15529','2013-11-13','09:35:00',1.46),('15529','2013-11-13','09:40:00',1.47),('15529','2013-11-13','09:45:00',1.49),('15529','2013-11-13','09:50:00',1.53),('15529','2013-11-13','09:55:00',1.59),('15529','2013-11-13','10:00:00',1.6),('15529','2013-11-13','10:05:00',1.33),('15529','2013-11-13','10:10:00',1.62),('15529','2013-11-13','10:15:00',1.67),('15529','2013-11-13','10:20:00',1.67),('15529','2013-11-13','10:25:00',1.65),('15529','2013-11-13','10:30:00',1.69),('15529','2013-11-13','10:35:00',1.61),('15529','2013-11-13','10:40:00',1.63),('15529','2013-11-13','10:45:00',1.7),('15529','2013-11-13','10:50:00',1.7),('15529','2013-11-13','10:55:00',1.73),('15529','2013-11-13','11:00:00',1.78),('15529','2013-11-13','11:05:00',1.82),('15529','2013-11-13','11:10:00',1.84),('15529','2013-11-13','11:15:00',1.88),('15529','2013-11-13','11:20:00',1.89),('15529','2013-11-13','11:25:00',1.9),('15529','2013-11-13','11:30:00',1.9),('15529','2013-11-13','11:35:00',1.67),('15529','2013-11-13','11:40:00',1.64),('15529','2013-11-13','11:45:00',1.26),('15529','2013-11-13','11:50:00',1.12),('15529','2013-11-13','11:55:00',1.33),('15529','2013-11-13','12:00:00',2.28),('15529','2013-11-13','12:05:00',2.32),('15529','2013-11-13','12:10:00',1.35),('15529','2013-11-13','13:55:00',1.27),('15529','2013-11-13','14:05:00',1.09),('15529','2013-11-12','10:05:00',1.01),('15529','2013-11-12','14:00:00',1.28),('15529','2013-11-12','14:05:00',1.15),('15529','2013-11-12','14:10:00',1.2),('15529','2013-11-12','14:15:00',1.04),('15529','2013-11-12','14:20:00',1),('15529','2013-11-12','14:30:00',1.07),('15529','2013-11-11','11:40:00',1.47),('15529','2013-11-11','11:50:00',1.42),('15529','2013-11-11','12:00:00',1.2),('15529','2013-11-11','12:05:00',1.25),('15529','2013-11-11','12:30:00',2.33),('15529','2013-11-11','12:35:00',1.97),('15529','2013-11-11','12:40:00',1.32),('15529','2013-11-11','12:45:00',1.15),('15529','2013-11-11','12:55:00',1.43),('15529','2013-11-11','13:00:00',1.38),('15529','2013-11-11','13:05:00',1.01),('15529','2013-11-11','13:10:00',1.34),('15529','2013-11-11','13:15:00',1.29),('15529','2013-11-11','13:40:00',1),('15529','2013-11-11','13:45:00',1.21),('15529','2013-11-11','13:50:00',1.34),('15529','2013-11-11','13:55:00',1.28),('15529','2013-11-11','14:00:00',1.45),('15529','2013-11-11','14:05:00',1.25),('15529','2013-11-11','14:10:00',1.89),('15529','2013-11-11','14:15:00',1.82),('15529','2013-11-11','14:20:00',1.22),('15529','2013-11-11','14:35:00',1.42),('15529','2013-11-11','14:40:00',1.35),('15529','2013-11-11','14:45:00',1.16),('15529','2013-11-10','11:05:00',1.4),('15529','2013-11-10','11:10:00',1.26),('15529','2013-11-10','11:15:00',2.39),('15529','2013-11-10','11:20:00',1.81),('15529','2013-11-10','11:35:00',1.79),('15529','2013-11-10','11:40:00',1.81),('15529','2013-11-10','11:45:00',1.69),('15529','2013-11-10','11:50:00',2.19),('15529','2013-11-10','11:55:00',2.44),('15529','2013-11-10','12:00:00',2.24),('15529','2013-11-10','12:05:00',1.94),('15529','2013-11-10','12:10:00',2.07),('15529','2013-11-10','12:15:00',2.04),('15529','2013-11-10','12:20:00',2.05),('15529','2013-11-10','12:25:00',2.06),('15529','2013-11-10','12:30:00',1.47),('15529','2013-11-10','12:35:00',1.23),('15529','2013-11-10','12:45:00',1.21),('15529','2013-11-10','12:50:00',1.14),('15529','2013-11-10','13:00:00',1.29),('15529','2013-11-10','13:05:00',1.49),('15529','2013-11-10','14:00:00',1.58),('15529','2013-11-10','14:05:00',1.91),('15529','2013-11-10','14:25:00',1.68),('15529','2013-11-10','14:30:00',1.39),('15529','2013-11-10','14:35:00',1.23),('15529','2013-11-10','14:40:00',1.31),('15529','2013-11-09','09:00:00',1.05),('15529','2013-11-09','09:15:00',1.1),('15529','2013-11-09','09:20:00',1.34),('15529','2013-11-09','09:25:00',1.44),('15529','2013-11-09','09:30:00',1.3),('15529','2013-11-09','09:35:00',1.31),('15529','2013-11-09','09:40:00',1.45),('15529','2013-11-09','09:45:00',1.52),('15529','2013-11-09','09:50:00',1.65),('15529','2013-11-09','09:55:00',1.53),('15529','2013-11-09','10:00:00',1.53),('15529','2013-11-09','10:05:00',1.59),('15529','2013-11-09','10:10:00',1.78),('15529','2013-11-09','10:15:00',1.68),('15529','2013-11-09','10:20:00',1.6),('15529','2013-11-09','10:25:00',1.83),('15529','2013-11-09','10:30:00',1.75),('15529','2013-11-09','10:35:00',1.88),('15529','2013-11-09','10:40:00',1.7),('15529','2013-11-09','10:45:00',1.6),('15529','2013-11-09','10:50:00',1.6),('15529','2013-11-09','10:55:00',2.11),('15529','2013-11-09','11:00:00',1.32),('15529','2013-11-09','11:35:00',1.24),('15529','2013-11-09','11:40:00',1.22),('15529','2013-11-09','11:45:00',1.08),('15529','2013-11-09','12:10:00',2.03),('15529','2013-11-09','12:15:00',2.01),('15529','2013-11-09','12:20:00',2.04),('15529','2013-11-09','12:25:00',1.84),('15529','2013-11-09','12:30:00',1.08),('15529','2013-11-09','12:35:00',1.9),('15529','2013-11-09','12:40:00',1.74),('15529','2013-11-09','12:45:00',1.83),('15529','2013-11-09','12:50:00',1.15),('15529','2013-11-09','13:50:00',1.49),('15529','2013-11-08','09:40:00',1.75),('15529','2013-11-08','09:45:00',1.9),('15529','2013-11-08','09:50:00',1.92),('15529','2013-11-08','09:55:00',1.74),('15529','2013-11-08','10:00:00',1.78),('15529','2013-11-08','10:05:00',1.48),('15529','2013-11-08','10:10:00',1.25),('15529','2013-11-08','10:15:00',1.44),('15529','2013-11-08','10:40:00',1.23),('15529','2013-11-08','11:10:00',1.05),('15529','2013-11-08','11:15:00',1.22),('15529','2013-11-08','11:20:00',1.34),('15529','2013-11-08','11:25:00',1.74),('15529','2013-11-08','11:30:00',1.39),('15529','2013-11-08','11:55:00',1.06),('15529','2013-11-08','12:00:00',2.09),('15529','2013-11-08','12:05:00',2.07),('15529','2013-11-08','12:15:00',1.16),('15529','2013-11-08','12:30:00',1.05),('15529','2013-11-08','12:35:00',1.79),('15529','2013-11-08','12:40:00',1.35),('15529','2013-11-08','12:45:00',1.67),('15529','2013-11-08','12:55:00',1.32),('15529','2013-11-08','13:05:00',1.1),('15529','2013-11-08','13:10:00',2.01),('15529','2013-11-08','13:15:00',1.52),('15529','2013-11-08','13:25:00',1.8),('15529','2013-11-08','13:30:00',1.73),('15529','2013-11-08','13:35:00',1.74),('15529','2013-11-08','13:40:00',1.67),('15529','2013-11-08','13:45:00',1.64),('15529','2013-11-08','13:50:00',1.64),('15529','2013-11-08','13:55:00',1.61),('15529','2013-11-08','14:00:00',1.47),('15529','2013-11-08','14:05:00',1.21),('15529','2013-11-08','14:15:00',1.24),('15529','2013-11-08','14:20:00',1.25),('15529','2013-11-08','14:35:00',1.12),('15529','2013-11-08','14:40:00',1.15),('15529','2013-11-07','09:15:00',1.09),('15529','2013-11-07','09:25:00',1.68),('15529','2013-11-07','09:30:00',1.44),('15529','2013-11-07','09:35:00',1.02),('15529','2013-11-07','09:40:00',1.12),('15529','2013-11-07','09:45:00',1.55),('15529','2013-11-07','09:50:00',1.64),('15529','2013-11-07','09:55:00',1.31),('15529','2013-11-07','10:00:00',1.64),('15529','2013-11-07','10:05:00',1.43),('15529','2013-11-07','10:15:00',1.05),('15529','2013-11-07','10:20:00',1.06),('15529','2013-11-07','10:25:00',1.31),('15529','2013-11-07','10:30:00',1.29),('15529','2013-11-07','10:35:00',1.83),('15529','2013-11-07','10:40:00',1.29),('15529','2013-11-07','10:45:00',1.28),('15529','2013-11-07','10:50:00',1.62),('15529','2013-11-07','11:10:00',1.14),('15529','2013-11-07','11:15:00',2),('15529','2013-11-07','11:20:00',1.51),('15529','2013-11-07','11:35:00',1.59),('15529','2013-11-07','11:40:00',2.11),('15529','2013-11-07','11:45:00',2.03),('15529','2013-11-07','11:50:00',1.56),('15529','2013-11-07','11:55:00',1.56),('15529','2013-11-07','12:10:00',1.97),('15529','2013-11-07','12:15:00',1.84),('15529','2013-11-07','12:40:00',2),('15529','2013-11-07','12:45:00',2.02),('15529','2013-11-07','12:50:00',1.95),('15529','2013-11-07','12:55:00',2),('15529','2013-11-07','13:00:00',2.03),('15529','2013-11-07','13:05:00',1.95),('15529','2013-11-07','13:10:00',1.88),('15529','2013-11-07','13:15:00',1.85),('15529','2013-11-07','13:25:00',1.83),('15529','2013-11-07','13:30:00',1.38),('15529','2013-11-07','13:35:00',1.5),('15529','2013-11-07','13:40:00',1.67),('15529','2013-11-07','13:45:00',1.74),('15529','2013-11-07','13:50:00',1.74),('15529','2013-11-07','13:55:00',1.52),('15529','2013-11-07','14:10:00',1.12),('15529','2013-11-07','14:15:00',1.52),('15529','2013-11-07','14:20:00',1.4),('15529','2013-11-07','14:30:00',1.45),('15529','2013-11-07','14:35:00',1.02),('15529','2013-11-07','14:40:00',1.21),('15529','2014-04-17','09:05:00',1.04),('15529','2014-04-17','09:10:00',1.67),('15529','2014-04-17','09:15:00',1.59),('15529','2014-04-17','09:20:00',1.52),('15529','2014-04-17','09:30:00',1.46),('15529','2014-04-17','09:45:00',1.38),('15529','2014-04-17','09:50:00',1.39),('15529','2014-04-17','09:55:00',1.71),('15529','2014-04-17','10:00:00',1.18),('15529','2014-04-17','10:45:00',1.37),('15529','2014-04-17','10:50:00',1.59),('15529','2014-04-17','10:55:00',1.95),('15529','2014-04-17','11:00:00',1.02),('15529','2014-04-17','11:15:00',1.46),('15529','2014-04-17','11:20:00',1.11),('15529','2014-04-17','11:50:00',1.11),('15529','2014-04-17','11:55:00',1.02),('15529','2014-04-17','12:00:00',1.28),('15529','2014-04-17','12:05:00',1.4),('15529','2014-04-17','12:10:00',1.52),('15529','2014-04-17','12:15:00',2.01),('15529','2014-04-17','12:20:00',1.98),('15529','2014-04-17','12:25:00',1.71),('15529','2014-04-17','12:30:00',2.46),('15529','2014-04-17','12:35:00',2.52),('15529','2014-04-17','12:40:00',2.38),('15529','2014-04-17','12:45:00',2.06),('15529','2014-04-17','12:50:00',2.08),('15529','2014-04-17','12:55:00',2.03),('15529','2014-04-17','13:00:00',1.97),('15529','2014-04-17','13:05:00',2.08),('15529','2014-04-17','13:10:00',2.62),('15529','2014-04-17','13:15:00',1.93),('15529','2014-04-17','13:20:00',1.33),('15529','2014-04-17','13:55:00',1.06),('15529','2014-04-17','14:00:00',1.09),('15529','2014-04-17','14:25:00',1.04),('15529','2014-04-17','14:30:00',1.15),('15529','2014-04-17','14:35:00',1.38),('15529','2014-04-17','14:40:00',1.23),('15529','2014-04-17','14:45:00',1.43),('15529','2014-04-17','14:50:00',1.9),('15529','2014-04-17','14:55:00',2.23),('15529','2014-04-17','15:00:00',2.08),('15529','2014-04-17','15:05:00',2.14),('15529','2014-04-17','15:15:00',1),('15529','2014-04-17','15:20:00',1.17),('15529','2014-04-17','15:25:00',2.01),('15529','2014-04-17','15:30:00',1.59),('15529','2014-04-17','15:35:00',2.3),('15529','2014-04-17','15:40:00',1.78),('15529','2014-04-17','15:45:00',1.17),('15529','2014-04-17','15:50:00',1.78),('15529','2014-04-17','15:55:00',2.22),('15529','2014-04-17','16:00:00',1.78),('15529','2014-04-17','16:05:00',1.58),('15529','2014-04-17','16:25:00',1.48),('15529','2014-04-17','16:30:00',1.13),('15529','2014-04-17','16:35:00',1.79),('15529','2014-04-17','16:40:00',1.58),('15529','2014-04-17','16:45:00',1.5),('15529','2014-04-17','16:50:00',1.44),('15529','2014-04-17','16:55:00',1.59),('15529','2014-04-17','17:00:00',1.16),('15529','2014-04-17','17:05:00',1.36),('15529','2014-04-17','17:25:00',1.08),('15529','2013-11-06','08:25:00',1.01),('15529','2013-11-06','08:30:00',1.06),('15529','2013-11-06','08:35:00',1.1),('15529','2013-11-06','08:40:00',1.15),('15529','2013-11-06','08:45:00',1.19),('15529','2013-11-06','08:50:00',1.23),('15529','2013-11-06','08:55:00',1.27),('15529','2013-11-06','09:00:00',1.3),('15529','2013-11-06','09:05:00',1.34),('15529','2013-11-06','09:10:00',1.37),('15529','2013-11-06','09:15:00',1.4),('15529','2013-11-06','09:20:00',1.42),('15529','2013-11-06','09:25:00',1.46),('15529','2013-11-06','09:30:00',1.49),('15529','2013-11-06','09:35:00',1.52),('15529','2013-11-06','09:40:00',1.53),('15529','2013-11-06','09:45:00',1.54),('15529','2013-11-06','09:50:00',1.54),('15529','2013-11-06','09:55:00',1.59),('15529','2013-11-06','10:00:00',1.61),('15529','2013-11-06','10:05:00',1.62),('15529','2013-11-06','10:10:00',1.63),('15529','2013-11-06','10:15:00',1.65),('15529','2013-11-06','10:20:00',1.67),('15529','2013-11-06','10:25:00',1.71),('15529','2013-11-06','10:30:00',1.73),('15529','2013-11-06','10:35:00',1.73),('15529','2013-11-06','10:40:00',1.74),('15529','2013-11-06','10:45:00',1.75),('15529','2013-11-06','10:50:00',1.75),('15529','2013-11-06','10:55:00',1.76),('15529','2013-11-06','11:00:00',1.76),('15529','2013-11-06','11:05:00',1.77),('15529','2013-11-06','11:10:00',1.79),('15529','2013-11-06','11:15:00',1.79),('15529','2013-11-06','11:20:00',1.79),('15529','2013-11-06','11:25:00',1.78),('15529','2013-11-06','11:30:00',1.79),('15529','2013-11-06','11:35:00',1.8),('15529','2013-11-06','11:40:00',1.8),('15529','2013-11-06','11:45:00',1.81),('15529','2013-11-06','11:50:00',1.81),('15529','2013-11-06','11:55:00',1.8),('15529','2013-11-06','12:00:00',1.77),('15529','2013-11-06','12:05:00',1.78),('15529','2013-11-06','12:10:00',1.78),('15529','2013-11-06','12:15:00',1.82),('15529','2013-11-06','12:20:00',1.85),('15529','2013-11-06','12:25:00',1.38),('15529','2013-11-06','12:35:00',1.03),('15529','2013-11-06','12:40:00',1.42),('15529','2013-11-06','12:45:00',1.3),('15529','2013-11-06','13:05:00',2.09),('15529','2013-11-06','13:10:00',1.61),('15529','2013-11-06','13:15:00',1.94),('15529','2013-11-06','13:20:00',1.53),('15529','2013-11-06','13:25:00',1.86),('15529','2013-11-06','13:30:00',1.86),('15529','2013-11-06','13:35:00',1.76),('15529','2013-11-06','13:40:00',1.65),('15529','2013-11-06','13:45:00',1.62),('15529','2013-11-06','13:50:00',1.54),('15529','2013-11-06','14:00:00',1.6),('15529','2013-11-06','14:05:00',1.74),('15529','2013-11-06','14:20:00',1.51),('15529','2013-11-06','14:25:00',1.4),('15529','2013-11-06','14:30:00',1.37),('15529','2013-11-06','14:35:00',1.3),('15529','2013-11-06','14:40:00',1.26),('15529','2013-11-06','14:45:00',1.21),('15529','2013-11-06','14:50:00',1.19),('15529','2013-11-06','14:55:00',1.15),('15529','2013-11-06','15:00:00',1.1),('15529','2013-11-06','15:05:00',1.05),('15529','2013-11-05','08:15:00',1.01),('15529','2013-11-05','08:35:00',1.18),('15529','2013-11-05','08:40:00',1.21),('15529','2013-11-05','08:45:00',1.25),('15529','2013-11-05','08:50:00',1.32),('15529','2013-11-05','08:55:00',1.14),('15529','2013-11-05','09:05:00',1.03),('15529','2013-11-05','09:10:00',1.15),('15529','2013-11-05','09:15:00',1.22),('15529','2013-11-05','09:20:00',1.43),('15529','2013-11-05','09:25:00',1.5),('15529','2013-11-05','09:30:00',1.54),('15529','2013-11-05','09:35:00',1.57),('15529','2013-11-05','09:40:00',1.59),('15529','2013-11-05','09:45:00',1.6),('15529','2013-11-05','09:50:00',1.62),('15529','2013-11-05','09:55:00',1.65),('15529','2013-11-05','10:00:00',1.67),('15529','2013-11-05','10:05:00',1.71),('15529','2013-11-05','10:10:00',1.73),('15529','2013-11-05','10:15:00',1.75),('15529','2013-11-05','10:20:00',1.76),('15529','2013-11-05','10:25:00',1.78),('15529','2013-11-05','10:30:00',1.81),('15529','2013-11-05','10:35:00',1.81),('15529','2013-11-05','10:40:00',1.81),('15529','2013-11-05','10:45:00',1.85),('15529','2013-11-05','10:50:00',1.85),('15529','2013-11-05','10:55:00',1.87),('15529','2013-11-05','11:00:00',1.87),('15529','2013-11-05','11:05:00',1.88),('15529','2013-11-05','11:10:00',1.87),('15529','2013-11-05','11:15:00',1.91),('15529','2013-11-05','11:20:00',1.92),('15529','2013-11-05','11:25:00',1.94),('15529','2013-11-05','11:30:00',1.9),('15529','2013-11-05','11:35:00',1.92),('15529','2013-11-05','11:40:00',1.94),('15529','2013-11-05','11:45:00',1.94),('15529','2013-11-05','11:50:00',1.93),('15529','2013-11-05','11:55:00',1.91),('15529','2013-11-05','12:00:00',1.93),('15529','2013-11-05','12:05:00',1.91),('15529','2013-11-05','12:10:00',1.92),('15529','2013-11-05','12:15:00',1.91),('15529','2013-11-05','12:20:00',1.92),('15529','2013-11-05','12:25:00',1.92),('15529','2013-11-05','12:30:00',1.91),('15529','2013-11-05','12:35:00',1.89),('15529','2013-11-05','12:40:00',1.88),('15529','2013-11-05','12:45:00',1.85),('15529','2013-11-05','12:50:00',1.84),('15529','2013-11-05','12:55:00',1.83),('15529','2013-11-05','13:00:00',1.82),('15529','2013-11-05','13:05:00',1.81),('15529','2013-11-05','13:10:00',1.79),('15529','2013-11-05','13:15:00',1.77),('15529','2013-11-05','13:20:00',1.75),('15529','2013-11-05','13:25:00',1.73),('15529','2013-11-05','13:30:00',1.71),('15529','2013-11-05','13:35:00',1.68),('15529','2013-11-05','13:40:00',1.65),('15529','2013-11-05','13:45:00',1.63),('15529','2013-11-05','13:50:00',1.6),('15529','2013-11-05','13:55:00',1.57),('15529','2013-11-05','14:00:00',1.55),('15529','2013-11-05','14:05:00',1.54),('15529','2013-11-05','14:10:00',1.52),('15529','2013-11-05','14:15:00',1.48),('15529','2013-11-05','14:20:00',1.44),('15529','2013-11-05','14:25:00',1.41),('15529','2013-11-05','14:30:00',1.38),('15529','2013-11-05','14:35:00',1.33),('15529','2013-11-05','14:40:00',1.29),('15529','2013-11-05','14:45:00',1.25),('15529','2013-11-05','14:50:00',1.21),('15529','2013-11-05','14:55:00',1.17),('15529','2013-11-05','15:00:00',1.14),('15529','2013-11-05','15:05:00',1.08),('15529','2013-11-05','15:10:00',1.04),('15529','2013-11-04','08:35:00',1.21),('15529','2013-11-04','10:25:00',1.01),('15529','2013-11-04','12:25:00',1.13),('15529','2013-11-04','13:35:00',1.53),('15529','2013-11-04','13:40:00',1.53),('15529','2013-11-04','13:45:00',1.17),('15529','2013-11-04','13:50:00',1.34),('15529','2013-11-04','13:55:00',1.92),('15529','2013-11-04','14:00:00',1.19),('15529','2013-11-04','14:05:00',1.47),('15529','2013-11-04','14:25:00',1.22),('15529','2013-11-04','14:30:00',1.34),('15529','2013-11-03','09:05:00',1.37),('15529','2013-11-03','09:10:00',1.19),('15529','2013-11-03','09:55:00',1.74),('15529','2013-11-03','10:00:00',1.79),('15529','2013-11-03','10:05:00',1.83),('15529','2013-11-03','10:10:00',1.88),('15529','2013-11-03','10:15:00',1.88),('15529','2013-11-03','10:20:00',1.9),('15529','2013-11-03','10:25:00',2.15),('15529','2013-11-03','10:30:00',1.5),('15529','2013-11-03','10:35:00',1.04),('15529','2013-11-03','10:45:00',1.16),('15529','2013-11-03','11:30:00',1.17),('15529','2013-11-03','11:40:00',1.11),('15529','2013-11-03','11:45:00',1.15),('15529','2013-11-03','11:50:00',1.97),('15529','2013-11-03','11:55:00',2.18),('15529','2013-11-03','12:00:00',2.17),('15529','2013-11-03','12:05:00',1.76),('15529','2013-11-03','12:10:00',2.08),('15529','2013-11-03','12:15:00',2.05),('15529','2013-11-03','12:20:00',1.97),('15529','2013-11-03','12:25:00',1.87),('15529','2013-11-03','12:30:00',1.29),('15529','2013-11-03','12:35:00',1.76),('15529','2013-11-03','12:40:00',1.77),('15529','2013-11-03','12:45:00',1.99),('15529','2013-11-03','12:50:00',1.56),('15529','2013-11-03','12:55:00',1.93),('15529','2013-11-03','13:00:00',1.86),('15529','2013-11-03','13:05:00',1.91),('15529','2013-11-03','13:10:00',1.53),('15529','2013-11-03','13:15:00',1.79),('15529','2013-11-03','13:20:00',1.63),('15529','2013-11-03','13:25:00',1.35),('15529','2013-11-03','13:30:00',1.12),('15529','2013-11-03','13:35:00',1.43),('15529','2013-11-03','13:50:00',1.71),('15529','2013-11-03','14:00:00',1.68),('15529','2013-11-03','14:05:00',1.27),('15529','2013-11-03','14:10:00',1.2),('15529','2013-11-03','14:20:00',1.01),('15529','2013-11-03','14:25:00',1.66),('15529','2013-11-03','14:30:00',1.52),('15529','2013-11-03','14:35:00',1.28),('15529','2013-11-03','14:40:00',1.18),('15529','2013-11-03','14:45:00',1.2),('15529','2013-11-03','14:50:00',1.27),('15529','2013-11-03','14:55:00',1.16),('15529','2013-11-03','15:00:00',1.11),('15529','2013-11-03','15:05:00',1.2),('15529','2013-11-03','15:10:00',1.1),('15529','2013-11-03','15:15:00',1.03),('15529','2013-11-02','08:45:00',1.06),('15529','2013-11-02','09:35:00',1.13),('15529','2013-11-02','10:25:00',1.36),('15529','2013-11-02','10:30:00',1.72),('15529','2013-11-02','11:15:00',1.86),('15529','2013-11-02','11:20:00',1.85),('15529','2013-11-02','11:30:00',1.46),('15529','2013-11-02','11:35:00',1.84),('15529','2013-11-02','11:40:00',2.08),('15529','2013-11-02','11:45:00',1.43),('15529','2013-11-02','11:55:00',1.23),('15529','2013-11-02','12:00:00',2.38),('15529','2013-11-02','12:05:00',2.33),('15529','2013-11-02','12:10:00',2.3),('15529','2013-11-02','12:15:00',2.21),('15529','2013-11-02','12:20:00',2.04),('15529','2013-11-02','12:25:00',1.41),('15529','2013-11-02','14:10:00',1.42),('15529','2013-11-02','14:15:00',1.35),('15529','2013-11-02','14:20:00',1.48),('15529','2013-11-02','14:25:00',1.28),('15529','2013-11-02','14:40:00',1.11),('15529','2013-11-01','08:30:00',1),('15529','2013-11-01','08:35:00',1.04),('15529','2013-11-01','08:40:00',1.09),('15529','2013-11-01','08:45:00',1.13),('15529','2013-11-01','08:50:00',1.17),('15529','2013-11-01','08:55:00',1.22),('15529','2013-11-01','09:00:00',1.31),('15529','2013-11-01','09:05:00',1.4),('15529','2013-11-01','09:10:00',1.34),('15529','2013-11-01','09:20:00',1.16),('15529','2013-11-01','09:25:00',1.49),('15529','2013-11-01','09:30:00',1.35),('15529','2013-11-01','09:35:00',1.49),('15529','2013-11-01','09:40:00',1.48),('15529','2013-11-01','09:45:00',1.52),('15529','2013-11-01','10:05:00',1.31),('15529','2013-11-01','11:50:00',2.1),('15529','2013-11-01','11:55:00',1.91),('15529','2013-11-01','12:00:00',1.63),('15529','2013-11-01','12:05:00',1.72),('15529','2013-11-01','12:10:00',2.22),('15529','2013-11-01','12:15:00',2.13),('15529','2013-11-01','12:20:00',1.65),('15529','2013-11-01','12:25:00',1.38),('15529','2013-11-01','12:30:00',1.69),('15529','2013-11-01','12:35:00',2.08),('15529','2013-11-01','12:40:00',1.3),('15529','2013-11-01','12:45:00',1.9),('15529','2013-11-01','12:50:00',1.47),('15529','2013-11-01','13:10:00',1.22),('15529','2013-11-01','13:15:00',2.06),('15529','2013-11-01','13:20:00',1.2),('15529','2013-11-01','13:25:00',1.12),('15529','2013-11-01','13:30:00',1.25),('15529','2013-11-01','13:35:00',1.7),('15529','2013-11-01','13:40:00',2.1),('15529','2013-11-01','13:45:00',1.88),('15529','2013-11-01','13:50:00',1.93),('15529','2013-11-01','13:55:00',1.78),('15529','2013-11-01','14:00:00',1.68),('15529','2013-11-01','14:05:00',1.54),('15529','2013-11-01','14:10:00',1.53),('15529','2013-11-01','14:15:00',1.52),('15529','2013-11-01','14:20:00',1.49),('15529','2013-11-01','14:25:00',1.26),('15529','2013-11-01','14:30:00',1.46),('15529','2013-11-01','14:35:00',1.35),('15529','2013-11-01','14:40:00',1.29),('15529','2013-11-01','14:45:00',1.1),('15529','2013-11-01','15:00:00',1.21),('15529','2013-11-01','15:05:00',1.21),('15529','2013-10-31','08:35:00',1.03),('15529','2013-10-31','08:40:00',1.08),('15529','2013-10-31','08:50:00',1.07),('15529','2013-10-31','08:55:00',1.07),('15529','2013-10-31','09:00:00',1.21),('15529','2013-10-31','09:05:00',1.29),('15529','2013-10-31','09:10:00',1.32),('15529','2013-10-31','09:15:00',1.36),('15529','2013-10-31','09:20:00',1.4),('15529','2013-10-31','09:25:00',1.44),('15529','2013-10-31','09:30:00',1.46),('15529','2013-10-31','09:35:00',1.49),('15529','2013-10-31','09:40:00',1.52),('15529','2013-10-31','09:45:00',1.55),('15529','2013-10-31','09:50:00',1.59),('15529','2013-10-31','09:55:00',1.62),('15529','2013-10-31','10:00:00',1.64),('15529','2013-10-31','10:05:00',1.67),('15529','2013-10-31','10:10:00',1.69),('15529','2013-10-31','10:15:00',1.71),('15529','2013-10-31','10:20:00',1.73),('15529','2013-10-31','10:25:00',1.72),('15529','2013-10-31','10:30:00',1.71),('15529','2013-10-31','10:35:00',1.72),('15529','2013-10-31','10:40:00',1.72),('15529','2013-10-31','10:45:00',1.7),('15529','2013-10-31','10:50:00',1.69),('15529','2013-10-31','10:55:00',1.8),('15529','2013-10-31','11:00:00',1.76),('15529','2013-10-31','11:05:00',1.57),('15529','2013-10-31','11:10:00',1.51),('15529','2013-10-31','11:15:00',1.68),('15529','2013-10-31','11:20:00',1.85),('15529','2013-10-31','11:25:00',1.9),('15529','2013-10-31','11:30:00',1.86),('15529','2013-10-31','11:35:00',1.73),('15529','2013-10-31','11:40:00',1.83),('15529','2013-10-31','11:45:00',1.96),('15529','2013-10-31','11:50:00',1.96),('15529','2013-10-31','11:55:00',1.8),('15529','2013-10-31','12:00:00',1.87),('15529','2013-10-31','12:05:00',1.89),('15529','2013-10-31','12:10:00',1.75),('15529','2013-10-31','12:15:00',1.85),('15529','2013-10-31','12:20:00',1.82),('15529','2013-10-31','12:25:00',1.7),('15529','2013-10-31','12:30:00',1.1),('15529','2013-10-31','13:05:00',1.11),('15529','2013-10-30','08:35:00',1.03),('15529','2013-10-30','08:40:00',1.11),('15529','2013-10-30','08:45:00',1.16),('15529','2013-10-30','09:25:00',1.1),('15529','2013-10-30','09:30:00',1.25),('15529','2013-10-30','09:35:00',1.2),('15529','2013-10-30','09:40:00',1.12),('15529','2013-10-30','09:45:00',1.16),('15529','2013-10-30','09:50:00',1.28),('15529','2013-10-30','09:55:00',1.31),('15529','2013-10-30','10:00:00',1.34),('15529','2013-10-30','10:05:00',1.29),('15529','2013-10-30','10:10:00',1.33),('15529','2013-10-30','10:15:00',1.32),('15529','2013-10-30','10:20:00',1.24),('15529','2013-10-30','10:25:00',1.22),('15529','2013-10-30','10:30:00',1.19),('15529','2013-10-30','10:35:00',1.23),('15529','2013-10-30','10:40:00',1.34),('15529','2013-10-30','10:45:00',1.22),('15529','2013-10-30','10:50:00',1.13),('15529','2013-10-30','10:55:00',1.32),('15529','2013-10-30','11:00:00',1.33),('15529','2013-10-30','11:05:00',1.51),('15529','2013-10-30','11:10:00',1.28),('15529','2013-10-30','11:15:00',1.73),('15529','2013-10-30','11:20:00',1.68),('15529','2013-10-30','11:25:00',1.53),('15529','2013-10-30','11:30:00',1.57),('15529','2013-10-30','11:35:00',1.59),('15529','2013-10-30','11:40:00',1.75),('15529','2013-10-30','11:45:00',1.8),('15529','2013-10-30','11:50:00',1.79),('15529','2013-10-30','11:55:00',1.81),('15529','2013-10-30','12:00:00',1.83),('15529','2013-10-30','12:05:00',1.8),('15529','2013-10-30','12:10:00',1.76),('15529','2013-10-30','12:15:00',1.79),('15529','2013-10-30','12:20:00',1.76),('15529','2013-10-30','12:25:00',1.73),('15529','2013-10-30','12:30:00',1.68),('15529','2013-10-30','12:35:00',1.66),('15529','2013-10-30','12:40:00',1.7),('15529','2013-10-30','12:45:00',1.76),('15529','2013-10-30','12:50:00',1.8),('15529','2013-10-30','12:55:00',1.81),('15529','2013-10-30','13:00:00',1.79),('15529','2013-10-30','13:05:00',1.76),('15529','2013-10-30','13:10:00',1.73),('15529','2013-10-30','13:15:00',1.71),('15529','2013-10-30','13:20:00',1.65),('15529','2013-10-30','13:25:00',1.63),('15529','2013-10-30','13:30:00',1.63),('15529','2013-10-30','13:35:00',1.62),('15529','2013-10-30','13:40:00',1.55),('15529','2013-10-30','13:45:00',1.54),('15529','2013-10-30','13:50:00',1.5),('15529','2013-10-30','13:55:00',1.28),('15529','2013-10-30','14:00:00',1.36),('15529','2013-10-30','14:05:00',1.35),('15529','2013-10-30','14:10:00',1.26),('15529','2013-10-29','08:45:00',1.06),('15529','2013-10-29','08:50:00',1.06),('15529','2013-10-29','08:55:00',1.04),('15529','2013-10-29','09:00:00',1.13),('15529','2013-10-29','09:05:00',1.24),('15529','2013-10-29','09:10:00',1.25),('15529','2013-10-29','09:15:00',1.27),('15529','2013-10-29','09:20:00',1.32),('15529','2013-10-29','09:25:00',1.33),('15529','2013-10-29','09:30:00',1.4),('15529','2013-10-29','09:35:00',1.45),('15529','2013-10-29','09:40:00',1.47),('15529','2013-10-29','09:45:00',1.37),('15529','2013-10-29','09:50:00',1.39),('15529','2013-10-29','09:55:00',1.08),('15529','2013-10-29','10:20:00',1.14),('15529','2013-10-29','10:25:00',1.34),('15529','2013-10-29','10:40:00',1.13),('15529','2013-10-29','10:45:00',1.35),('15529','2013-10-29','10:50:00',1.62),('15529','2013-10-29','10:55:00',1.69),('15529','2013-10-29','11:00:00',1.74),('15529','2013-10-29','11:05:00',1.59),('15529','2013-10-29','11:10:00',1.36),('15529','2013-10-29','11:15:00',1.41),('15529','2013-10-29','11:35:00',1.04),('15529','2013-10-29','11:40:00',1.49),('15529','2013-10-29','11:45:00',1.09),('15529','2013-10-29','11:50:00',1.62),('15529','2013-10-29','11:55:00',1.58),('15529','2013-10-29','12:00:00',1.6),('15529','2013-10-29','12:05:00',1.55),('15529','2013-10-29','12:15:00',1.04),('15529','2013-10-29','12:20:00',1.01),('15529','2013-10-29','12:25:00',1.1),('15529','2013-10-29','12:35:00',1.01),('15529','2013-10-29','12:40:00',1.56),('15529','2013-10-29','12:45:00',1.78),('15529','2013-10-29','12:50:00',1.82),('15529','2013-10-29','12:55:00',1.96),('15529','2013-10-29','13:00:00',2.03),('15529','2013-10-29','13:05:00',1.94),('15529','2013-10-29','13:10:00',1.56),('15529','2013-10-29','13:15:00',1.29),('15529','2013-10-29','13:20:00',1.41),('15529','2013-10-29','13:25:00',1.93),('15529','2013-10-29','13:30:00',1.39),('15529','2013-10-29','13:40:00',1.04),('15529','2013-10-29','13:45:00',1.41),('15529','2013-10-29','14:25:00',1.22),('15529','2013-10-29','14:30:00',1.1),('15529','2013-10-29','14:40:00',1.18),('15529','2013-10-29','14:45:00',1.11),('15529','2013-10-29','14:50:00',1.13),('15529','2013-10-29','14:55:00',1.14),('15529','2013-10-29','15:00:00',1.08),('15529','2013-10-29','15:05:00',1),('15529','2013-10-28','08:45:00',1.09),('15529','2013-10-28','08:50:00',1.15),('15529','2013-10-28','08:55:00',1.19),('15529','2013-10-28','09:00:00',1.22),('15529','2013-10-28','09:05:00',1.27),('15529','2013-10-28','09:10:00',1.33),('15529','2013-10-28','09:15:00',1.35),('15529','2013-10-28','09:20:00',1.38),('15529','2013-10-28','09:25:00',1.42),('15529','2013-10-28','09:30:00',1.45),('15529','2013-10-28','09:35:00',1.48),('15529','2013-10-28','09:40:00',1.57),('15529','2013-10-28','09:45:00',1.52),('15529','2013-10-28','09:50:00',1),('15529','2013-10-28','09:55:00',1.64),('15529','2013-10-28','10:00:00',1.59),('15529','2013-10-28','10:05:00',1.56),('15529','2013-10-28','10:10:00',1.66),('15529','2013-10-28','10:15:00',1.23),('15529','2013-10-28','10:20:00',1.04),('15529','2013-10-28','10:25:00',1.09),('15529','2013-10-28','10:30:00',1.71),('15529','2013-10-28','10:35:00',1.27),('15529','2013-10-28','10:45:00',1.38),('15529','2013-10-28','10:50:00',1.36),('15529','2013-10-28','11:15:00',1.35),('15529','2013-10-28','11:20:00',1.95),('15529','2013-10-28','11:25:00',1.72),('15529','2013-10-28','11:30:00',1.51),('15529','2013-10-28','11:35:00',1.67),('15529','2013-10-28','11:40:00',1.76),('15529','2013-10-28','11:45:00',1.54),('15529','2013-10-28','11:55:00',1.95),('15529','2013-10-28','12:00:00',1.9),('15529','2013-10-28','12:05:00',1.88),('15529','2013-10-28','12:10:00',1.89),('15529','2013-10-28','12:15:00',1.87),('15529','2013-10-28','12:20:00',1.87),('15529','2013-10-28','12:25:00',1.83),('15529','2013-10-28','12:30:00',1.83),('15529','2013-10-28','12:35:00',1.78),('15529','2013-10-28','12:40:00',1.74),('15529','2013-10-28','12:45:00',1.79),('15529','2013-10-28','12:50:00',1.73),('15529','2013-10-28','12:55:00',1.75),('15529','2013-10-28','13:00:00',1.72),('15529','2013-10-28','13:05:00',1.74),('15529','2013-10-28','13:10:00',1.66),('15529','2013-10-28','13:15:00',1.69),('15529','2013-10-28','13:20:00',1.64),('15529','2013-10-28','13:25:00',1.5),('15529','2013-10-28','13:30:00',1.61),('15529','2013-10-28','13:35:00',1.61),('15529','2013-10-28','13:40:00',1.54),('15529','2013-10-28','13:45:00',1.55),('15529','2013-10-28','13:50:00',1.54),('15529','2013-10-28','13:55:00',1.45),('15529','2013-10-28','14:00:00',1.42),('15529','2013-10-28','14:05:00',1.39),('15529','2013-10-28','14:10:00',1.36),('15529','2013-10-28','14:15:00',1.35),('15529','2013-10-28','14:20:00',1.32),('15529','2013-10-28','14:25:00',1.26),('15529','2013-10-28','14:30:00',1.23),('15529','2013-10-28','14:35:00',1.2),('15529','2013-10-28','14:40:00',1.16),('15529','2013-10-28','14:45:00',1.1),('15529','2013-10-28','14:50:00',1.07),('15529','2013-10-28','14:55:00',1.05),('15529','2014-04-16','08:45:00',1.03),('15529','2014-04-16','08:50:00',1.09),('15529','2014-04-16','08:55:00',1.01),('15529','2014-04-16','09:00:00',1.14),('15529','2014-04-16','09:05:00',1.25),('15529','2014-04-16','09:10:00',1.3),('15529','2014-04-16','09:15:00',1.35),('15529','2014-04-16','09:20:00',1.4),('15529','2014-04-16','09:25:00',1.45),('15529','2014-04-16','09:30:00',1.49),('15529','2014-04-16','09:35:00',1.53),('15529','2014-04-16','09:40:00',1.57),('15529','2014-04-16','09:45:00',1.61),('15529','2014-04-16','09:50:00',1.67),('15529','2014-04-16','09:55:00',1.71),('15529','2014-04-16','10:00:00',1.77),('15529','2014-04-16','10:05:00',1.42),('15529','2014-04-16','10:10:00',1.28),('15529','2014-04-16','10:15:00',1.14),('15529','2014-04-16','10:20:00',1.86),('15529','2014-04-16','10:25:00',1.99),('15529','2014-04-16','10:30:00',2.01),('15529','2014-04-16','10:35:00',2.11),('15529','2014-04-16','10:40:00',1.91),('15529','2014-04-16','10:45:00',1.93),('15529','2014-04-16','10:50:00',1.41),('15529','2014-04-16','10:55:00',1.15),('15529','2014-04-16','11:00:00',1.81),('15529','2014-04-16','11:05:00',1.51),('15529','2014-04-16','11:10:00',1.7),('15529','2014-04-16','11:15:00',1.44),('15529','2014-04-16','11:20:00',1.63),('15529','2014-04-16','11:25:00',1.66),('15529','2014-04-16','11:30:00',1.27),('15529','2014-04-16','11:40:00',1.07),('15529','2014-04-16','11:45:00',2.11),('15529','2014-04-16','11:50:00',2.18),('15529','2014-04-16','11:55:00',1.98),('15529','2014-04-16','12:00:00',1.98),('15529','2014-04-16','12:05:00',1.35),('15529','2014-04-16','12:10:00',1.19),('15529','2014-04-16','12:15:00',1.12),('15529','2014-04-16','12:20:00',1.48),('15529','2014-04-16','12:25:00',1.91),('15529','2014-04-16','12:30:00',1.68),('15529','2014-04-16','12:35:00',2.14),('15529','2014-04-16','12:40:00',2.38),('15529','2014-04-16','12:45:00',2.36),('15529','2014-04-16','12:50:00',2.47),('15529','2014-04-16','12:55:00',2.46),('15529','2014-04-16','13:00:00',2.43),('15529','2014-04-16','13:05:00',2.46),('15529','2014-04-16','13:10:00',2.47),('15529','2014-04-16','13:15:00',2.51),('15529','2014-04-16','13:20:00',2.53),('15529','2014-04-16','13:25:00',2.61),('15529','2014-04-16','13:30:00',2.65),('15529','2014-04-16','13:35:00',1.61),('15529','2014-04-16','13:50:00',2.48),('15529','2014-04-16','13:55:00',1.84),('15529','2014-04-16','14:15:00',2.07),('15529','2014-04-16','14:35:00',2.04),('15529','2014-04-16','14:40:00',1.51),('15529','2014-04-16','15:35:00',1.12),('15529','2014-04-16','16:45:00',1.2),('15529','2014-04-16','16:50:00',1.17),('15529','2013-10-27','08:50:00',1.16),('15529','2013-10-27','08:55:00',1.2),('15529','2013-10-27','09:00:00',1.28),('15529','2013-10-27','09:05:00',1.34),('15529','2013-10-27','09:10:00',1.32),('15529','2013-10-27','09:15:00',1.3),('15529','2013-10-27','09:20:00',1.49),('15529','2013-10-27','09:25:00',1.29),('15529','2013-10-27','09:30:00',1.2),('15529','2013-10-27','10:45:00',1.52),('15529','2013-10-27','10:50:00',1.9),('15529','2013-10-27','10:55:00',1.88),('15529','2013-10-27','11:00:00',1.87),('15529','2013-10-27','11:05:00',1.89),('15529','2013-10-27','11:10:00',1.86),('15529','2013-10-27','11:15:00',1.9),('15529','2013-10-27','11:20:00',1.9),('15529','2013-10-27','11:25:00',1.9),('15529','2013-10-27','11:30:00',1.9),('15529','2013-10-27','11:35:00',1.91),('15529','2013-10-27','11:40:00',1.9),('15529','2013-10-27','11:45:00',1.88),('15529','2013-10-27','11:50:00',1.85),('15529','2013-10-27','11:55:00',1.9),('15529','2013-10-27','12:00:00',1.85),('15529','2013-10-27','12:05:00',1.97),('15529','2013-10-27','12:10:00',1.93),('15529','2013-10-27','12:15:00',1.62),('15529','2013-10-27','12:20:00',1.85),('15529','2013-10-27','12:25:00',2.11),('15529','2013-10-27','12:30:00',2.03),('15529','2013-10-27','12:35:00',1.9),('15529','2013-10-27','12:40:00',1.97),('15529','2013-10-27','12:45:00',1.89),('15529','2013-10-27','12:50:00',1.86),('15529','2013-10-27','12:55:00',1.83),('15529','2013-10-27','13:00:00',1.83),('15529','2013-10-27','13:05:00',1.8),('15529','2013-10-27','13:10:00',1.79),('15529','2013-10-27','13:15:00',1.8),('15529','2013-10-27','13:20:00',1.77),('15529','2013-10-27','13:25:00',1.73),('15529','2013-10-27','13:30:00',1.64),('15529','2013-10-27','13:35:00',1.57),('15529','2013-10-27','13:40:00',1.28),('15529','2013-10-27','13:45:00',1.65),('15529','2013-10-27','13:50:00',1.71),('15529','2013-10-27','13:55:00',1.67),('15529','2013-10-27','14:00:00',1.65),('15529','2013-10-27','14:05:00',1.56),('15529','2013-10-27','14:10:00',1.51),('15529','2013-10-27','14:15:00',1.53),('15529','2013-10-27','14:20:00',1.06),('15529','2013-10-27','14:25:00',1.08),('15529','2013-10-27','14:30:00',1.28),('15529','2013-10-27','14:35:00',1.37),('15529','2013-10-27','14:40:00',1.36),('15529','2013-10-27','14:45:00',1.24),('15529','2013-10-27','14:50:00',1.19),('15529','2013-10-27','14:55:00',1.21),('15529','2013-10-27','15:00:00',1.13),('15529','2013-10-27','15:05:00',1.07),('15529','2013-10-27','15:10:00',1.04),('15529','2013-10-26','11:30:00',1.01),('15529','2013-10-26','11:35:00',1.37),('15529','2013-10-26','11:40:00',1.41),('15529','2013-10-26','12:10:00',1.42),('15529','2013-10-26','12:15:00',1.75),('15529','2013-10-26','12:20:00',1.03),('15529','2013-10-26','12:25:00',1.33),('15529','2013-10-26','12:30:00',1.89),('15529','2013-10-26','12:35:00',1.26),('15529','2013-10-26','12:45:00',1.15),('15529','2013-10-26','13:15:00',1.03),('15529','2013-10-26','13:20:00',1.71),('15529','2013-10-26','13:25:00',1.5),('15529','2013-10-26','13:30:00',1.09),('15529','2013-10-26','14:10:00',1.08),('15529','2013-10-26','14:15:00',1.03),('15529','2013-10-26','14:20:00',1.57),('15529','2013-10-26','14:25:00',1.48),('15529','2013-10-26','14:40:00',1.14),('15529','2013-10-26','14:45:00',1.31),('15529','2013-10-26','14:50:00',1.25),('15529','2013-10-26','14:55:00',1.18),('15529','2013-10-26','15:00:00',1.1),('15529','2013-10-25','09:30:00',1.02),('15529','2013-10-25','09:35:00',1.05),('15529','2013-10-25','09:40:00',1.1),('15529','2013-10-25','09:45:00',1.14),('15529','2013-10-25','09:50:00',1.19),('15529','2013-10-25','09:55:00',1.22),('15529','2013-10-25','10:00:00',1.26),('15529','2013-10-25','10:05:00',1.29),('15529','2013-10-25','10:10:00',1.33),('15529','2013-10-25','10:15:00',1.37),('15529','2013-10-25','10:20:00',1.38),('15529','2013-10-25','10:25:00',1.42),('15529','2013-10-25','10:30:00',1.45),('15529','2013-10-25','10:35:00',1.47),('15529','2013-10-25','10:40:00',1.5),('15529','2013-10-25','10:45:00',1.53),('15529','2013-10-25','10:50:00',1.57),('15529','2013-10-25','10:55:00',1.59),('15529','2013-10-25','11:00:00',1.62),('15529','2013-10-25','11:05:00',1.65),('15529','2013-10-25','11:10:00',1.69),('15529','2013-10-25','11:15:00',1.69),('15529','2013-10-25','11:20:00',1.71),('15529','2013-10-25','11:25:00',1.7),('15529','2013-10-25','11:30:00',1.74),('15529','2013-10-25','11:35:00',1.78),('15529','2013-10-25','11:40:00',1.78),('15529','2013-10-25','11:45:00',1.78),('15529','2013-10-25','11:50:00',1.79),('15529','2013-10-25','11:55:00',1.8),('15529','2013-10-25','12:00:00',1.8),('15529','2013-10-25','12:05:00',1.81),('15529','2013-10-25','12:10:00',1.82),('15529','2013-10-25','12:15:00',1.81),('15529','2013-10-25','12:20:00',1.84),('15529','2013-10-25','12:25:00',1.8),('15529','2013-10-25','12:30:00',1.8),('15529','2013-10-25','12:35:00',1.86),('15529','2013-10-25','12:40:00',1.86),('15529','2013-10-25','12:45:00',1.84),('15529','2013-10-25','12:50:00',1.85),('15529','2013-10-25','12:55:00',1.05),('15529','2013-10-25','13:00:00',1.66),('15529','2013-10-25','13:05:00',1.89),('15529','2013-10-25','13:10:00',1.84),('15529','2013-10-25','13:15:00',1.82),('15529','2013-10-25','13:20:00',1.77),('15529','2013-10-25','13:25:00',1.83),('15529','2013-10-25','13:30:00',1.76),('15529','2013-10-25','13:35:00',1.71),('15529','2013-10-25','13:40:00',1.7),('15529','2013-10-25','13:45:00',1.65),('15529','2013-10-25','13:50:00',1.72),('15529','2013-10-25','13:55:00',1.57),('15529','2013-10-25','14:00:00',1.39),('15529','2013-10-25','14:05:00',1.44),('15529','2013-10-25','14:10:00',1.04),('15529','2013-10-25','14:15:00',1.12),('15529','2013-10-25','14:20:00',1.32),('15529','2013-10-25','14:25:00',1.22),('15529','2013-10-25','14:30:00',1.41),('15529','2013-10-25','14:45:00',1.25),('15529','2013-10-25','14:50:00',1.43),('15529','2013-10-25','14:55:00',1.43),('15529','2013-10-25','15:00:00',1.43),('15529','2013-10-25','15:05:00',1.39),('15529','2013-10-25','15:10:00',1.31),('15529','2013-10-25','15:15:00',1.29),('15529','2013-10-25','15:20:00',1.3),('15529','2013-10-25','15:25:00',1.26),('15529','2013-10-25','15:30:00',1.15),('15529','2013-10-25','15:35:00',1.14),('15529','2013-10-25','15:40:00',1.09),('15529','2013-10-25','15:45:00',1.01),('15529','2013-10-25','15:50:00',1.05),('15529','2013-10-25','15:55:00',1.02),('15529','2013-10-24','09:30:00',1.04),('15529','2013-10-24','09:35:00',1.08),('15529','2013-10-24','09:40:00',1.12),('15529','2013-10-24','09:45:00',1.15),('15529','2013-10-24','09:50:00',1.18),('15529','2013-10-24','09:55:00',1.22),('15529','2013-10-24','10:00:00',1.26),('15529','2013-10-24','10:05:00',1.3),('15529','2013-10-24','10:10:00',1.34),('15529','2013-10-24','10:15:00',1.38),('15529','2013-10-24','10:20:00',1.41),('15529','2013-10-24','10:25:00',1.46),('15529','2013-10-24','10:30:00',1.48),('15529','2013-10-24','10:35:00',1.5),('15529','2013-10-24','10:40:00',1.54),('15529','2013-10-24','10:45:00',1.55),('15529','2013-10-24','10:50:00',1.59),('15529','2013-10-24','10:55:00',1.62),('15529','2013-10-24','11:00:00',1.64),('15529','2013-10-24','11:05:00',1.67),('15529','2013-10-24','11:10:00',1.72),('15529','2013-10-24','11:15:00',1.73),('15529','2013-10-24','11:20:00',1.75),('15529','2013-10-24','11:25:00',1.74),('15529','2013-10-24','11:30:00',1.76),('15529','2013-10-24','11:35:00',1.8),('15529','2013-10-24','11:40:00',1.79),('15529','2013-10-24','11:45:00',1.82),('15529','2013-10-24','11:50:00',1.83),('15529','2013-10-24','11:55:00',1.86),('15529','2013-10-24','12:00:00',1.86),('15529','2013-10-24','12:05:00',1.89),('15529','2013-10-24','12:10:00',1.89),('15529','2013-10-24','12:15:00',1.9),('15529','2013-10-24','12:20:00',1.89),('15529','2013-10-24','12:25:00',1.89),('15529','2013-10-24','12:30:00',1.9),('15529','2013-10-24','12:35:00',1.91),('15529','2013-10-24','12:40:00',1.9),('15529','2013-10-24','12:45:00',1.91),('15529','2013-10-24','12:50:00',1.89),('15529','2013-10-24','12:55:00',1.89),('15529','2013-10-24','13:00:00',1.86),('15529','2013-10-24','13:05:00',1.86),('15529','2013-10-24','13:10:00',1.87),('15529','2013-10-24','13:15:00',1.86),('15529','2013-10-24','13:20:00',1.88),('15529','2013-10-24','13:25:00',1.89),('15529','2013-10-24','13:30:00',1.88),('15529','2013-10-24','13:35:00',1.86),('15529','2013-10-24','13:40:00',1.82),('15529','2013-10-24','13:45:00',1.81),('15529','2013-10-24','13:50:00',1.81),('15529','2013-10-24','13:55:00',1.81),('15529','2013-10-24','14:00:00',1.79),('15529','2013-10-24','14:05:00',1.77),('15529','2013-10-24','14:10:00',1.74),('15529','2013-10-24','14:15:00',1.74),('15529','2013-10-24','14:20:00',1.7),('15529','2013-10-24','14:25:00',1.7),('15529','2013-10-24','14:30:00',1.68),('15529','2013-10-24','14:35:00',1.64),('15529','2013-10-24','14:40:00',1.62),('15529','2013-10-24','14:45:00',1.62),('15529','2013-10-24','14:50:00',1.58),('15529','2013-10-24','14:55:00',1.55),('15529','2013-10-24','15:00:00',1.5),('15529','2013-10-24','15:05:00',1.47),('15529','2013-10-24','15:10:00',1.44),('15529','2013-10-24','15:15:00',1.4),('15529','2013-10-24','15:20:00',1.32),('15529','2013-10-24','15:25:00',1.31),('15529','2013-10-24','15:30:00',1.3),('15529','2013-10-24','15:35:00',1.27),('15529','2013-10-24','15:40:00',1.24),('15529','2013-10-24','15:45:00',1.21),('15529','2013-10-24','15:50:00',1.18),('15529','2013-10-24','15:55:00',1.13),('15529','2013-10-24','16:00:00',1.1),('15529','2013-10-24','16:05:00',1.06),('15529','2013-10-24','16:10:00',1.04),('15529','2013-10-23','10:50:00',1.32),('15529','2013-10-23','10:55:00',1.23),('15529','2013-10-23','11:00:00',1.57),('15529','2013-10-23','11:05:00',1.08),('15529','2013-10-23','11:10:00',1.06),('15529','2013-10-23','11:15:00',1.17),('15529','2013-10-23','11:50:00',1.28),('15529','2013-10-23','11:55:00',1.25),('15529','2013-10-23','12:30:00',1.02),('15529','2013-10-23','12:35:00',1.11),('15529','2013-10-23','12:40:00',1.07),('15529','2013-10-23','12:45:00',1.03),('15529','2013-10-23','12:50:00',1.47),('15529','2013-10-23','12:55:00',2.09),('15529','2013-10-23','13:00:00',1.93),('15529','2013-10-23','13:05:00',1.49),('15529','2013-10-23','13:10:00',1.01),('15529','2013-10-23','13:15:00',1.43),('15529','2013-10-23','13:20:00',1.05),('15529','2013-10-23','13:50:00',1.52),('15529','2013-10-23','13:55:00',1.31),('15529','2013-10-23','14:30:00',1.21),('15529','2013-10-23','14:35:00',1.43),('15529','2013-10-23','14:40:00',1.76),('15529','2013-10-23','14:45:00',1.8),('15529','2013-10-23','15:05:00',1.27),('15529','2013-10-23','15:30:00',1.14),('15529','2013-10-23','15:35:00',1.57),('15529','2013-10-23','15:40:00',1.29),('15529','2013-10-23','15:45:00',1.4),('15529','2013-10-22','10:50:00',1.06),('15529','2013-10-22','10:55:00',1.46),('15529','2013-10-22','11:00:00',1.51),('15529','2013-10-22','11:05:00',1.55),('15529','2013-10-22','11:10:00',1.72),('15529','2013-10-22','11:15:00',1.65),('15529','2013-10-22','11:20:00',1.57),('15529','2013-10-22','11:25:00',1.71),('15529','2013-10-22','11:30:00',1.73),('15529','2013-10-22','11:35:00',1.71),('15529','2013-10-22','11:40:00',1.78),('15529','2013-10-22','11:45:00',1.67),('15529','2013-10-22','11:50:00',1.81),('15529','2013-10-22','11:55:00',1.73),('15529','2013-10-22','12:00:00',1.7),('15529','2013-10-22','12:05:00',1.68),('15529','2013-10-22','12:10:00',1.67),('15529','2013-10-22','12:15:00',1.69),('15529','2013-10-22','12:20:00',1.75),('15529','2013-10-22','12:25:00',1.71),('15529','2013-10-22','12:30:00',1.79),('15529','2013-10-22','12:35:00',1.79),('15529','2013-10-22','12:40:00',1.49),('15529','2013-10-22','12:45:00',1.32),('15529','2013-10-22','12:50:00',1.26),('15529','2013-10-22','12:55:00',1.08),('15529','2013-10-22','13:00:00',1.02),('15529','2013-10-22','13:05:00',1.71),('15529','2013-10-22','13:10:00',1.82),('15529','2013-10-22','13:15:00',1.85),('15529','2013-10-22','13:20:00',1.67),('15529','2013-10-22','13:25:00',1.74),('15529','2013-10-22','13:30:00',1.73),('15529','2013-10-22','13:35:00',1.78),('15529','2013-10-22','13:40:00',1.78),('15529','2013-10-22','13:45:00',1.6),('15529','2013-10-22','13:50:00',1.6),('15529','2013-10-22','13:55:00',1.62),('15529','2013-10-22','14:00:00',1.67),('15529','2013-10-22','14:05:00',1.65),('15529','2013-10-22','14:10:00',1.69),('15529','2013-10-22','14:15:00',1.62),('15529','2013-10-22','14:20:00',1.6),('15529','2013-10-22','14:25:00',1.48),('15529','2013-10-22','14:30:00',1.27),('15529','2013-10-22','14:35:00',1.44),('15529','2013-10-22','14:40:00',1.35),('15529','2013-10-22','14:45:00',1.45),('15529','2013-10-22','14:50:00',1.4),('15529','2013-10-22','14:55:00',1.38),('15529','2013-10-22','15:00:00',1.35),('15529','2013-10-22','15:05:00',1.41),('15529','2013-10-22','15:10:00',1.42),('15529','2013-10-22','15:15:00',1.36),('15529','2013-10-22','15:20:00',1.43),('15529','2013-10-22','15:25:00',1.4),('15529','2013-10-22','15:30:00',1.18),('15529','2013-10-22','15:35:00',1.11),('15529','2013-10-22','15:40:00',1.27),('15529','2013-10-22','15:45:00',1.3),('15529','2013-10-22','15:50:00',1.23),('15529','2013-10-22','15:55:00',1.07),('15529','2013-10-21','09:30:00',1),('15529','2013-10-21','09:35:00',1.06),('15529','2013-10-21','09:40:00',1.09),('15529','2013-10-21','09:45:00',1.13),('15529','2013-10-21','09:50:00',1.17),('15529','2013-10-21','09:55:00',1.2),('15529','2013-10-21','10:00:00',1.23),('15529','2013-10-21','10:05:00',1.28),('15529','2013-10-21','10:10:00',1.3),('15529','2013-10-21','10:15:00',1.34),('15529','2013-10-21','10:20:00',1.38),('15529','2013-10-21','10:25:00',1.39),('15529','2013-10-21','10:30:00',1.42),('15529','2013-10-21','10:35:00',1.44),('15529','2013-10-21','10:40:00',1.46),('15529','2013-10-21','10:45:00',1.48),('15529','2013-10-21','10:50:00',1.52),('15529','2013-10-21','10:55:00',1.54),('15529','2013-10-21','11:00:00',1.54),('15529','2013-10-21','11:05:00',1.57),('15529','2013-10-21','11:10:00',1.59),('15529','2013-10-21','11:15:00',1.6),('15529','2013-10-21','11:20:00',1.61),('15529','2013-10-21','11:25:00',1.64),('15529','2013-10-21','11:30:00',1.68),('15529','2013-10-21','11:35:00',1.68),('15529','2013-10-21','11:40:00',1.71),('15529','2013-10-21','11:45:00',1.72),('15529','2013-10-21','11:50:00',1.73),('15529','2013-10-21','11:55:00',1.75),('15529','2013-10-21','12:00:00',1.76),('15529','2013-10-21','12:05:00',1.76),('15529','2013-10-21','12:10:00',1.77),('15529','2013-10-21','12:15:00',1.79),('15529','2013-10-21','12:20:00',1.81),('15529','2013-10-21','12:25:00',1.79),('15529','2013-10-21','12:30:00',1.8),('15529','2013-10-21','12:35:00',1.85),('15529','2013-10-21','12:40:00',1.85),('15529','2013-10-21','12:45:00',1.84),('15529','2013-10-21','12:50:00',1.82),('15529','2013-10-21','12:55:00',1.82),('15529','2013-10-21','13:00:00',1.78),('15529','2013-10-21','13:05:00',1.8),('15529','2013-10-21','13:10:00',1.75),('15529','2013-10-21','13:15:00',1.76),('15529','2013-10-21','13:20:00',1.82),('15529','2013-10-21','13:25:00',1.83),('15529','2013-10-21','13:30:00',1.77),('15529','2013-10-21','13:35:00',1.83),('15529','2013-10-21','13:40:00',1.82),('15529','2013-10-21','13:45:00',1.8),('15529','2013-10-21','13:50:00',1.81),('15529','2013-10-21','13:55:00',1.79),('15529','2013-10-21','14:00:00',1.72),('15529','2013-10-21','14:05:00',1.6),('15529','2013-10-21','14:10:00',1.19),('15529','2013-10-21','14:20:00',1.45),('15529','2013-10-21','14:25:00',1.72),('15529','2013-10-21','14:30:00',1.66),('15529','2013-10-21','14:35:00',1.54),('15529','2013-10-21','14:40:00',1.62),('15529','2013-10-21','14:45:00',1.63),('15529','2013-10-21','14:50:00',1.52),('15529','2013-10-21','14:55:00',1.47),('15529','2013-10-21','15:00:00',1.41),('15529','2013-10-21','15:05:00',1.4),('15529','2013-10-21','15:10:00',1.39),('15529','2013-10-21','15:15:00',1.22),('15529','2013-10-21','15:20:00',1.29),('15529','2013-10-21','15:25:00',1.26),('15529','2013-10-21','15:40:00',1.16),('15529','2013-10-21','15:45:00',1.13),('15529','2013-10-21','15:50:00',1.05),('15529','2013-10-21','15:55:00',1.05),('15529','2013-10-20','09:20:00',1.04),('15529','2013-10-20','09:35:00',1.01),('15529','2013-10-20','09:50:00',1.05),('15529','2013-10-20','09:55:00',1.09),('15529','2013-10-20','10:00:00',1.15),('15529','2013-10-20','10:05:00',1.36),('15529','2013-10-20','10:10:00',1.36),('15529','2013-10-20','10:15:00',1.39),('15529','2013-10-20','10:20:00',1.41),('15529','2013-10-20','10:25:00',1.46),('15529','2013-10-20','10:30:00',1.42),('15529','2013-10-20','10:35:00',1.4),('15529','2013-10-20','10:40:00',1.46),('15529','2013-10-20','10:45:00',1.49),('15529','2013-10-20','10:50:00',1.56),('15529','2013-10-20','10:55:00',1.63),('15529','2013-10-20','11:00:00',1.64),('15529','2013-10-20','11:05:00',1.27),('15529','2013-10-20','11:10:00',1.71),('15529','2013-10-20','11:15:00',1.73),('15529','2013-10-20','11:20:00',1.74),('15529','2013-10-20','11:25:00',1.74),('15529','2013-10-20','11:30:00',1.81),('15529','2013-10-20','11:35:00',1.77),('15529','2013-10-20','11:40:00',1.8),('15529','2013-10-20','11:45:00',1.85),('15529','2013-10-20','11:50:00',1.85),('15529','2013-10-20','11:55:00',1.88),('15529','2013-10-20','12:00:00',1.92),('15529','2013-10-20','12:05:00',1.92),('15529','2013-10-20','12:10:00',1.93),('15529','2013-10-20','12:15:00',1.9),('15529','2013-10-20','12:20:00',1.88),('15529','2013-10-20','12:25:00',1.82),('15529','2013-10-20','12:30:00',1.82),('15529','2013-10-20','12:35:00',1.91),('15529','2013-10-20','12:40:00',1.93),('15529','2013-10-20','12:45:00',1.93),('15529','2013-10-20','12:50:00',1.91),('15529','2013-10-20','12:55:00',1.89),('15529','2013-10-20','13:00:00',1.88),('15529','2013-10-20','13:05:00',1.82),('15529','2013-10-20','13:10:00',1.83),('15529','2013-10-20','13:15:00',1.87),('15529','2013-10-20','13:20:00',1.79),('15529','2013-10-20','13:25:00',1.88),('15529','2013-10-20','13:30:00',1.87),('15529','2013-10-20','13:35:00',1.85),('15529','2013-10-20','13:40:00',1.85),('15529','2013-10-20','13:45:00',1.82),('15529','2013-10-20','13:50:00',1.77),('15529','2013-10-20','13:55:00',1.7),('15529','2013-10-20','14:00:00',1.78),('15529','2013-10-20','14:05:00',1.79),('15529','2013-10-20','14:10:00',1.76),('15529','2013-10-20','14:15:00',1.73),('15529','2013-10-20','14:20:00',1.72),('15529','2013-10-20','14:25:00',1.7),('15529','2013-10-20','14:30:00',1.69),('15529','2013-10-20','14:35:00',1.61),('15529','2013-10-20','14:40:00',1.54),('15529','2013-10-20','14:45:00',1.56),('15529','2013-10-20','14:50:00',1.49),('15529','2013-10-20','14:55:00',1.47),('15529','2013-10-20','15:00:00',1.49),('15529','2013-10-20','15:05:00',1.44),('15529','2013-10-20','15:10:00',1.43),('15529','2013-10-20','15:15:00',1.41),('15529','2013-10-20','15:20:00',1.38),('15529','2013-10-20','15:25:00',1.32),('15529','2013-10-20','15:30:00',1.27),('15529','2013-10-20','15:35:00',1.29),('15529','2013-10-20','15:40:00',1.26),('15529','2013-10-20','15:45:00',1.21),('15529','2013-10-20','15:50:00',1.14),('15529','2013-10-20','15:55:00',1.14),('15529','2013-10-20','16:00:00',1.1),('15529','2013-10-20','16:05:00',1.06),('15529','2013-10-20','16:10:00',1.02),('15529','2013-10-19','09:20:00',1.01),('15529','2013-10-19','09:25:00',1.05),('15529','2013-10-19','09:30:00',1.1),('15529','2013-10-19','09:35:00',1.14),('15529','2013-10-19','09:40:00',1.16),('15529','2013-10-19','09:45:00',1.22),('15529','2013-10-19','09:50:00',1.26),('15529','2013-10-19','09:55:00',1.31),('15529','2013-10-19','10:00:00',1.34),('15529','2013-10-19','10:05:00',1.38),('15529','2013-10-19','10:10:00',1.42),('15529','2013-10-19','10:15:00',1.45),('15529','2013-10-19','10:20:00',1.49),('15529','2013-10-19','10:25:00',1.52),('15529','2013-10-19','10:30:00',1.54),('15529','2013-10-19','10:35:00',1.57),('15529','2013-10-19','10:40:00',1.6),('15529','2013-10-19','10:45:00',1.64),('15529','2013-10-19','10:50:00',1.66),('15529','2013-10-19','10:55:00',1.69),('15529','2013-10-19','11:00:00',1.71),('15529','2013-10-19','11:05:00',1.73),('15529','2013-10-19','11:10:00',1.76),('15529','2013-10-19','11:15:00',1.8),('15529','2013-10-19','11:20:00',1.81),('15529','2013-10-19','11:25:00',1.83),('15529','2013-10-19','11:30:00',1.84),('15529','2013-10-19','11:35:00',1.86),('15529','2013-10-19','11:40:00',1.87),('15529','2013-10-19','11:45:00',1.91),('15529','2013-10-19','11:50:00',1.91),('15529','2013-10-19','11:55:00',1.89),('15529','2013-10-19','12:00:00',1.94),('15529','2013-10-19','12:05:00',1.98),('15529','2013-10-19','12:10:00',1.93),('15529','2013-10-19','12:15:00',1.6),('15529','2013-10-19','12:20:00',1.09),('15529','2013-10-19','12:25:00',1.8),('15529','2013-10-19','12:30:00',2.15),('15529','2013-10-19','12:35:00',1.83),('15529','2013-10-19','12:40:00',1.14),('15529','2013-10-19','12:50:00',1.46),('15529','2013-10-19','12:55:00',2.3),('15529','2013-10-19','13:05:00',1.38),('15529','2013-10-19','13:10:00',1.12),('15529','2013-10-19','16:15:00',1.13),('15529','2013-10-19','16:20:00',1.2),('15529','2013-10-19','16:25:00',1.17),('15529','2013-10-19','16:30:00',1.11),('15529','2013-10-19','16:35:00',1.06),('15529','2013-10-19','16:40:00',1),('15529','2013-10-18','09:10:00',1.08),('15529','2013-10-18','09:15:00',1.17),('15529','2013-10-18','09:20:00',1.19),('15529','2013-10-18','09:25:00',1.21),('15529','2013-10-18','09:30:00',1.22),('15529','2013-10-18','09:35:00',1.28),('15529','2013-10-18','09:40:00',1.32),('15529','2013-10-18','09:45:00',1.33),('15529','2013-10-18','09:50:00',1.43),('15529','2013-10-18','09:55:00',1.47),('15529','2013-10-18','10:00:00',1.41),('15529','2013-10-18','10:05:00',1.49),('15529','2013-10-18','10:10:00',1.61),('15529','2013-10-18','10:15:00',1.68),('15529','2013-10-18','10:20:00',1.66),('15529','2013-10-18','10:25:00',1.7),('15529','2013-10-18','10:30:00',1.73),('15529','2013-10-18','10:35:00',1.74),('15529','2013-10-18','10:40:00',1.74),('15529','2013-10-18','10:45:00',1.76),('15529','2013-10-18','10:50:00',1.8),('15529','2013-10-18','10:55:00',1.81),('15529','2013-10-18','11:00:00',1.77),('15529','2013-10-18','11:05:00',1.34),('15529','2013-10-18','11:15:00',1.23),('15529','2013-10-18','11:20:00',1.94),('15529','2013-10-18','11:25:00',2.1),('15529','2013-10-18','11:30:00',2.07),('15529','2013-10-18','11:35:00',1.99),('15529','2013-10-18','11:40:00',1.99),('15529','2013-10-18','11:45:00',1.98),('15529','2013-10-18','11:50:00',1.67),('15529','2013-10-18','11:55:00',2.09),('15529','2013-10-18','12:00:00',2.08),('15529','2013-10-18','12:05:00',2.07),('15529','2013-10-18','12:10:00',2.04),('15529','2013-10-18','12:15:00',2.08),('15529','2013-10-18','12:20:00',1.89),('15529','2013-10-18','12:25:00',2.01),('15529','2013-10-18','12:30:00',2.09),('15529','2013-10-18','12:35:00',2.11),('15529','2013-10-18','12:40:00',2.15),('15529','2013-10-18','12:45:00',2.2),('15529','2013-10-18','12:50:00',2.12),('15529','2013-10-18','12:55:00',2.24),('15529','2013-10-18','13:00:00',2.13),('15529','2013-10-18','13:05:00',1.94),('15529','2013-10-18','13:10:00',2),('15529','2013-10-18','13:15:00',1.72),('15529','2013-10-18','13:20:00',1.75),('15529','2013-10-18','13:25:00',2.12),('15529','2013-10-18','13:30:00',1.75),('15529','2013-10-18','13:35:00',1.56),('15529','2013-10-18','13:40:00',1.39),('15529','2013-10-18','13:45:00',1.77),('15529','2013-10-18','13:50:00',2.23),('15529','2013-10-18','13:55:00',2.01),('15529','2013-10-18','14:00:00',1.96),('15529','2013-10-18','14:05:00',1.59),('15529','2013-10-18','14:10:00',1.88),('15529','2013-10-18','14:15:00',1.39),('15529','2013-10-18','14:20:00',1.02),('15529','2013-10-18','14:25:00',1.26),('15529','2013-10-18','14:30:00',2.1),('15529','2013-10-18','14:35:00',1.85),('15529','2013-10-18','14:40:00',1.05),('15529','2013-10-18','14:45:00',1.92),('15529','2013-10-18','14:50:00',1.85),('15529','2013-10-18','14:55:00',1.78),('15529','2013-10-18','15:00:00',1.73),('15529','2013-10-18','15:05:00',1.7),('15529','2013-10-18','15:10:00',1.68),('15529','2013-10-18','15:15:00',1.59),('15529','2013-10-18','15:20:00',1.54),('15529','2013-10-18','15:25:00',1.45),('15529','2013-10-18','15:30:00',1.42),('15529','2013-10-18','15:35:00',1.38),('15529','2013-10-18','15:40:00',1.24),('15529','2013-10-18','15:45:00',1.16),('15529','2013-10-18','15:50:00',1.36),('15529','2013-10-18','15:55:00',1.1),('15529','2013-10-18','16:00:00',1.19),('15529','2013-10-18','16:05:00',1.2),('15529','2013-10-18','16:10:00',1.17),('15529','2013-10-18','16:15:00',1.22),('15529','2013-10-18','16:25:00',1.01),('15529','2013-10-18','16:30:00',1.11),('15529','2013-10-18','16:35:00',1.05),('15529','2014-05-03','09:25:00',1.32),('15529','2014-05-03','09:30:00',1.28),('15529','2014-05-03','09:40:00',1.01),('15529','2014-05-03','09:55:00',1.49),('15529','2014-05-03','10:00:00',2.05),('15529','2014-05-03','10:05:00',1.95),('15529','2014-05-03','10:10:00',1.71),('15529','2014-05-03','10:15:00',1.77),('15529','2014-05-03','10:40:00',1.02),('15529','2014-05-03','10:45:00',1.18),('15529','2014-05-03','10:50:00',1.12),('15529','2014-05-03','10:55:00',1.06),('15529','2014-05-03','11:00:00',1.08),('15529','2014-05-03','11:05:00',1.34),('15529','2014-05-03','11:10:00',2.01),('15529','2014-05-03','11:15:00',2.48),('15529','2014-05-03','11:20:00',2.52),('15529','2014-05-03','11:25:00',2.47),('15529','2014-05-03','11:30:00',2.17),('15529','2014-05-03','11:35:00',1.65),('15529','2014-05-03','11:40:00',1.82),('15529','2014-05-03','11:45:00',2.27),('15529','2014-05-03','11:50:00',2.12),('15529','2014-05-03','11:55:00',2.18),('15529','2014-05-03','12:00:00',2.59),('15529','2014-05-03','12:05:00',1.02),('15529','2014-05-03','12:15:00',1.07),('15529','2014-05-03','12:20:00',1.08),('15529','2014-05-03','12:35:00',1.17),('15529','2014-05-03','12:40:00',2.72),('15529','2014-05-03','12:45:00',1.45),('15529','2014-05-03','12:50:00',2.4),('15529','2014-05-03','12:55:00',1.16),('15529','2014-05-03','13:05:00',1.64),('15529','2014-05-03','15:00:00',1.16),('15529','2014-05-03','15:05:00',1.14),('15529','2014-05-03','15:10:00',1.05),('15529','2014-05-03','15:15:00',1.61),('15529','2014-05-03','15:20:00',2.27),('15529','2014-05-03','15:25:00',2.01),('15529','2014-04-15','08:50:00',1.1),('15529','2014-04-15','08:55:00',1.16),('15529','2014-04-15','09:00:00',1.21),('15529','2014-04-15','09:05:00',1.25),('15529','2014-04-15','09:10:00',1.3),('15529','2014-04-15','09:15:00',1.34),('15529','2014-04-15','09:20:00',1.4),('15529','2014-04-15','09:25:00',1.49),('15529','2014-04-15','09:50:00',1.07),('15529','2014-04-15','09:55:00',1.28),('15529','2014-04-15','10:00:00',1.8),('15529','2014-04-15','10:05:00',1.8),('15529','2014-04-15','10:10:00',1.84),('15529','2014-04-15','10:15:00',1.87),('15529','2014-04-15','10:20:00',1.91),('15529','2014-04-15','10:25:00',1.94),('15529','2014-04-15','10:30:00',1.98),('15529','2014-04-15','10:35:00',2.03),('15529','2014-04-15','10:40:00',2.05),('15529','2014-04-15','10:45:00',2.1),('15529','2014-04-15','10:50:00',2.16),('15529','2014-04-15','10:55:00',1.96),('15529','2014-04-15','11:05:00',1.56),('15529','2014-04-15','11:10:00',1.09),('15529','2014-04-15','11:20:00',1.11),('15529','2014-04-15','11:25:00',2.68),('15529','2014-04-15','11:30:00',2.74),('15529','2014-04-15','11:35:00',2.42),('15529','2014-04-15','11:40:00',2.15),('15529','2014-04-15','11:45:00',2.81),('15529','2014-04-15','11:50:00',2.62),('15529','2014-04-15','11:55:00',2.23),('15529','2014-04-15','12:00:00',2.54),('15529','2014-04-15','12:05:00',2.31),('15529','2014-04-15','12:10:00',2.56),('15529','2014-04-15','12:15:00',2.48),('15529','2014-04-15','12:20:00',1.05),('15529','2014-04-15','12:45:00',1.53),('15529','2014-04-15','12:50:00',2.07),('15529','2014-04-15','12:55:00',2.5),('15529','2014-04-15','13:00:00',2.72),('15529','2014-04-15','13:40:00',1.76),('15529','2014-04-15','13:45:00',2.52),('15529','2014-04-15','13:50:00',2.84),('15529','2014-04-15','13:55:00',2.57),('15529','2014-04-15','14:05:00',1.58),('15529','2014-04-15','14:10:00',2.32),('15529','2014-04-15','14:15:00',2.67),('15529','2014-04-15','14:20:00',2.6),('15529','2014-04-15','14:25:00',1.92),('15529','2014-04-15','14:30:00',2.43),('15529','2014-04-15','14:35:00',2.36),('15529','2014-04-15','14:40:00',2.33),('15529','2014-04-15','14:45:00',2.03),('15529','2014-04-15','14:50:00',1.72),('15529','2014-04-15','15:00:00',1.6),('15529','2014-04-15','15:05:00',1.68),('15529','2014-04-15','15:10:00',2.09),('15529','2014-04-15','15:15:00',1.34),('15529','2014-04-15','15:30:00',1.25),('15529','2014-04-15','15:35:00',2.12),('15529','2014-04-15','15:40:00',2.16),('15529','2014-04-15','15:45:00',2.12),('15529','2014-04-15','15:50:00',1.56),('15529','2014-04-15','15:55:00',1.33),('15529','2014-04-15','16:00:00',1.94),('15529','2014-04-15','16:05:00',1.85),('15529','2014-04-15','16:10:00',1.79),('15529','2014-04-15','16:15:00',1.75),('15529','2014-04-15','16:20:00',1.73),('15529','2014-04-15','16:25:00',1.67),('15529','2014-04-15','16:30:00',1.63),('15529','2014-04-15','16:35:00',1.58),('15529','2014-04-15','16:40:00',1.53),('15529','2014-04-15','16:45:00',1.48),('15529','2014-04-15','16:50:00',1.43),('15529','2014-04-15','16:55:00',1.39),('15529','2014-04-15','17:00:00',1.34),('15529','2014-04-15','17:05:00',1.23),('15529','2014-04-15','17:10:00',1.24),('15529','2014-04-15','17:15:00',1.18),('15529','2014-04-15','17:20:00',1.13),('15529','2014-04-15','17:25:00',1.07),('15529','2014-04-15','17:30:00',1),('15529','2013-10-17','09:10:00',1.06),('15529','2013-10-17','09:15:00',1.09),('15529','2013-10-17','09:20:00',1.16),('15529','2013-10-17','09:25:00',1.21),('15529','2013-10-17','09:30:00',1.25),('15529','2013-10-17','09:35:00',1.3),('15529','2013-10-17','09:40:00',1.34),('15529','2013-10-17','09:45:00',1.38),('15529','2013-10-17','09:50:00',1.42),('15529','2013-10-17','09:55:00',1.46),('15529','2013-10-17','10:00:00',1.49),('15529','2013-10-17','10:05:00',1.53),('15529','2013-10-17','10:10:00',1.55),('15529','2013-10-17','10:15:00',1.58),('15529','2013-10-17','10:20:00',1.6),('15529','2013-10-17','10:25:00',1.66),('15529','2013-10-17','10:30:00',1.7),('15529','2013-10-17','10:35:00',1.72),('15529','2013-10-17','10:40:00',1.74),('15529','2013-10-17','10:45:00',1.75),('15529','2013-10-17','10:50:00',1.75),('15529','2013-10-17','10:55:00',1.76),('15529','2013-10-17','11:00:00',1.78),('15529','2013-10-17','11:05:00',1.75),('15529','2013-10-17','11:10:00',1.8),('15529','2013-10-17','11:15:00',1.81),('15529','2013-10-17','11:20:00',1.93),('15529','2013-10-17','11:25:00',1.9),('15529','2013-10-17','11:30:00',1.89),('15529','2013-10-17','11:35:00',1.98),('15529','2013-10-17','11:40:00',2.02),('15529','2013-10-17','11:45:00',1.88),('15529','2013-10-17','11:50:00',1.93),('15529','2013-10-17','11:55:00',2.01),('15529','2013-10-17','12:00:00',2.02),('15529','2013-10-17','12:05:00',1.99),('15529','2013-10-17','12:10:00',2),('15529','2013-10-17','12:15:00',1.96),('15529','2013-10-17','12:20:00',1.94),('15529','2013-10-17','12:25:00',2),('15529','2013-10-17','12:30:00',1.98),('15529','2013-10-17','12:35:00',2),('15529','2013-10-17','12:40:00',2),('15529','2013-10-17','12:45:00',1.98),('15529','2013-10-17','12:50:00',1.95),('15529','2013-10-17','12:55:00',2.04),('15529','2013-10-17','13:00:00',2.02),('15529','2013-10-17','13:05:00',1.99),('15529','2013-10-17','13:10:00',1.9),('15529','2013-10-17','13:15:00',1.95),('15529','2013-10-17','13:20:00',2.06),('15529','2013-10-17','13:25:00',2.01),('15529','2013-10-17','13:30:00',2.03),('15529','2013-10-17','13:35:00',2.03),('15529','2013-10-17','13:40:00',2.01),('15529','2013-10-17','13:45:00',1.95),('15529','2013-10-17','13:50:00',1.94),('15529','2013-10-17','13:55:00',1.91),('15529','2013-10-17','14:00:00',1.78),('15529','2013-10-17','14:05:00',1.83),('15529','2013-10-17','14:10:00',1.83),('15529','2013-10-17','14:15:00',1.87),('15529','2013-10-17','14:20:00',1.84),('15529','2013-10-17','14:25:00',1.81),('15529','2013-10-17','14:30:00',1.8),('15529','2013-10-17','14:35:00',1.74),('15529','2013-10-17','14:40:00',1.73),('15529','2013-10-17','14:45:00',1.65),('15529','2013-10-17','14:50:00',1.67),('15529','2013-10-17','14:55:00',1.67),('15529','2013-10-17','15:00:00',1.41),('15529','2013-10-17','15:05:00',1.39),('15529','2013-10-17','15:10:00',1.52),('15529','2013-10-17','15:15:00',1.52),('15529','2013-10-17','15:20:00',1.56),('15529','2013-10-17','15:25:00',1.44),('15529','2013-10-17','15:30:00',1.4),('15529','2013-10-17','15:35:00',1.38),('15529','2013-10-17','15:40:00',1.3),('15529','2013-10-17','15:45:00',1.17),('15529','2013-10-17','15:50:00',1.1),('15529','2013-10-17','15:55:00',1.13),('15529','2013-10-17','16:00:00',1.16),('15529','2013-10-17','16:05:00',1.09),('15529','2013-10-17','16:10:00',1.04),('15529','2013-10-16','09:10:00',1.05),('15529','2013-10-16','09:15:00',1.1),('15529','2013-10-16','09:20:00',1.14),('15529','2013-10-16','09:25:00',1.19),('15529','2013-10-16','09:30:00',1.24),('15529','2013-10-16','09:35:00',1.29),('15529','2013-10-16','09:40:00',1.33),('15529','2013-10-16','09:45:00',1.37),('15529','2013-10-16','09:50:00',1.41),('15529','2013-10-16','09:55:00',1.45),('15529','2013-10-16','10:00:00',1.48),('15529','2013-10-16','10:05:00',1.52),('15529','2013-10-16','10:10:00',1.55),('15529','2013-10-16','10:15:00',1.59),('15529','2013-10-16','10:20:00',1.62),('15529','2013-10-16','10:25:00',1.66),('15529','2013-10-16','10:30:00',1.68),('15529','2013-10-16','10:35:00',1.72),('15529','2013-10-16','10:40:00',1.75),('15529','2013-10-16','10:45:00',1.77),('15529','2013-10-16','10:50:00',1.77),('15529','2013-10-16','10:55:00',1.83),('15529','2013-10-16','11:00:00',1.84),('15529','2013-10-16','11:05:00',1.87),('15529','2013-10-16','11:10:00',1.9),('15529','2013-10-16','11:15:00',1.91),('15529','2013-10-16','11:20:00',1.94),('15529','2013-10-16','11:25:00',1.93),('15529','2013-10-16','11:30:00',2),('15529','2013-10-16','11:35:00',2.01),('15529','2013-10-16','11:40:00',2.02),('15529','2013-10-16','11:45:00',2.03),('15529','2013-10-16','11:50:00',2.04),('15529','2013-10-16','11:55:00',2.08),('15529','2013-10-16','12:00:00',2.07),('15529','2013-10-16','12:05:00',2.08),('15529','2013-10-16','12:10:00',2.06),('15529','2013-10-16','12:15:00',2.07),('15529','2013-10-16','12:20:00',2.07),('15529','2013-10-16','12:25:00',2.06),('15529','2013-10-16','12:30:00',2.07),('15529','2013-10-16','12:35:00',2.07),('15529','2013-10-16','12:40:00',2.09),('15529','2013-10-16','12:45:00',2.11),('15529','2013-10-16','12:50:00',2.11),('15529','2013-10-16','12:55:00',2.11),('15529','2013-10-16','13:00:00',2.08),('15529','2013-10-16','13:05:00',2.1),('15529','2013-10-16','13:10:00',2.06),('15529','2013-10-16','13:15:00',2.07),('15529','2013-10-16','13:20:00',2.07),('15529','2013-10-16','13:25:00',2.08),('15529','2013-10-16','13:30:00',2.07),('15529','2013-10-16','13:35:00',2.06),('15529','2013-10-16','13:40:00',2.04),('15529','2013-10-16','13:45:00',2),('15529','2013-10-16','13:50:00',1.99),('15529','2013-10-16','13:55:00',1.98),('15529','2013-10-16','14:00:00',1.98),('15529','2013-10-16','14:05:00',1.95),('15529','2013-10-16','14:10:00',1.93),('15529','2013-10-16','14:15:00',1.89),('15529','2013-10-16','14:20:00',1.9),('15529','2013-10-16','14:25:00',1.9),('15529','2013-10-16','14:30:00',1.89),('15529','2013-10-16','14:35:00',1.85),('15529','2013-10-16','14:40:00',1.83),('15529','2013-10-16','14:45:00',1.81),('15529','2013-10-16','14:50:00',1.78),('15529','2013-10-16','14:55:00',1.74),('15529','2013-10-16','15:00:00',1.71),('15529','2013-10-16','15:05:00',1.68),('15529','2013-10-16','15:10:00',1.66),('15529','2013-10-16','15:15:00',1.62),('15529','2013-10-16','15:20:00',1.6),('15529','2013-10-16','15:25:00',1.57),('15529','2013-10-16','15:30:00',1.53),('15529','2013-10-16','15:35:00',1.51),('15529','2013-10-16','15:40:00',1.46),('15529','2013-10-16','15:45:00',1.42),('15529','2013-10-16','15:50:00',1.36),('15529','2013-10-16','15:55:00',1.33),('15529','2013-10-16','16:00:00',1.3),('15529','2013-10-16','16:05:00',1.25),('15529','2013-10-16','16:10:00',1.22),('15529','2013-10-16','16:15:00',1.18),('15529','2013-10-16','16:20:00',1.13),('15529','2013-10-16','16:25:00',1.08),('15529','2013-10-16','16:30:00',1.03),('15529','2013-10-15','09:45:00',1.23),('15529','2013-10-15','12:10:00',1.5),('15529','2013-10-15','12:30:00',1.51),('15529','2013-10-15','12:35:00',1.66),('15529','2013-10-15','13:00:00',1.47),('15529','2013-10-15','13:05:00',1.28),('15529','2013-10-15','13:10:00',1.5),('15529','2013-10-15','13:15:00',2.3),('15529','2013-10-15','13:20:00',2.25),('15529','2013-10-15','13:25:00',2.17),('15529','2013-10-15','13:30:00',2.1),('15529','2013-10-15','13:35:00',2.13),('15529','2013-10-15','13:40:00',2.16),('15529','2013-10-15','13:45:00',2.07),('15529','2013-10-15','13:50:00',2.11),('15529','2013-10-15','13:55:00',2.18),('15529','2013-10-15','14:00:00',1.16),('15529','2013-10-15','14:05:00',1.86),('15529','2013-10-15','14:10:00',2.05),('15529','2013-10-15','14:15:00',1.95),('15529','2013-10-15','14:20:00',2.02),('15529','2013-10-15','14:25:00',1.96),('15529','2013-10-15','14:30:00',1.94),('15529','2013-10-15','14:35:00',1.94),('15529','2013-10-15','14:40:00',1.56),('15529','2013-10-15','14:45:00',1.57),('15529','2013-10-15','14:50:00',1.54),('15529','2013-10-15','14:55:00',1.81),('15529','2013-10-15','15:00:00',1.39),('15529','2013-10-15','15:05:00',1.6),('15529','2013-10-15','15:10:00',1.63),('15529','2013-10-15','15:15:00',1.67),('15529','2013-10-15','15:20:00',1.55),('15529','2013-10-15','15:25:00',1.25),('15529','2013-10-15','15:35:00',1.31),('15529','2013-10-15','15:40:00',1.48),('15529','2013-10-15','15:45:00',1.43),('15529','2013-10-15','15:50:00',1.38),('15529','2013-10-15','15:55:00',1.34),('15529','2013-10-15','16:00:00',1.3),('15529','2013-10-15','16:05:00',1.25),('15529','2013-10-15','16:10:00',1.19),('15529','2013-10-15','16:15:00',1.15),('15529','2013-10-15','16:20:00',1.11),('15529','2013-10-15','16:25:00',1.05),('15529','2013-10-15','16:30:00',1),('15529','2013-10-14','09:45:00',1.27),('15529','2013-10-14','09:50:00',1.36),('15529','2013-10-14','09:55:00',1.35),('15529','2013-10-14','10:00:00',1.35),('15529','2013-10-14','10:05:00',1.4),('15529','2013-10-14','10:10:00',1),('15529','2013-10-14','10:25:00',1.07),('15529','2013-10-14','10:30:00',1.12),('15529','2013-10-14','10:40:00',1.21),('15529','2013-10-14','10:45:00',1.34),('15529','2013-10-14','10:50:00',1.15),('15529','2013-10-14','10:55:00',1.09),('15529','2013-10-14','11:00:00',1.04),('15529','2013-10-14','11:05:00',1.28),('15529','2013-10-14','11:10:00',1.57),('15529','2013-10-14','11:15:00',1.65),('15529','2013-10-14','11:20:00',1.65),('15529','2013-10-14','11:25:00',1.54),('15529','2013-10-14','11:30:00',1.58),('15529','2013-10-14','11:35:00',1.23),('15529','2013-10-14','13:15:00',1.2),('15529','2013-10-14','13:20:00',1.83),('15529','2013-10-14','13:25:00',1.62),('15529','2013-10-14','13:30:00',1.08),('15529','2013-10-14','14:15:00',1.06),('15529','2013-10-14','14:20:00',1.08),('15529','2013-10-14','14:25:00',1.43),('15529','2013-10-14','14:30:00',1.01),('15529','2013-10-14','14:40:00',1.34),('15529','2013-10-14','14:45:00',1.37),('15529','2013-10-14','14:50:00',1.55),('15529','2013-10-13','09:25:00',1.11),('15529','2013-10-13','09:30:00',1.13),('15529','2013-10-13','09:35:00',1.01),('15529','2013-10-13','09:50:00',1.1),('15529','2013-10-13','09:55:00',1.24),('15529','2013-10-13','10:00:00',1.32),('15529','2013-10-13','10:05:00',1.32),('15529','2013-10-13','10:10:00',1.45),('15529','2013-10-13','10:15:00',1.49),('15529','2013-10-13','10:20:00',1.52),('15529','2013-10-13','10:25:00',1.56),('15529','2013-10-13','10:30:00',1.58),('15529','2013-10-13','10:35:00',1.58),('15529','2013-10-13','10:40:00',1.57),('15529','2013-10-13','10:45:00',1.62),('15529','2013-10-13','10:50:00',1.68),('15529','2013-10-13','10:55:00',1.68),('15529','2013-10-13','11:00:00',1.7),('15529','2013-10-13','11:05:00',1.7),('15529','2013-10-13','11:10:00',1.79),('15529','2013-10-13','11:15:00',1.75),('15529','2013-10-13','11:20:00',1.8),('15529','2013-10-13','11:25:00',1.84),('15529','2013-10-13','11:30:00',1.88),('15529','2013-10-13','11:35:00',1.85),('15529','2013-10-13','11:40:00',1.85),('15529','2013-10-13','11:45:00',1.83),('15529','2013-10-13','11:50:00',1.88),('15529','2013-10-13','11:55:00',1.88),('15529','2013-10-13','12:00:00',1.89),('15529','2013-10-13','12:05:00',1.91),('15529','2013-10-13','12:10:00',1.91),('15529','2013-10-13','12:15:00',1.88),('15529','2013-10-13','12:20:00',1.78),('15529','2013-10-13','12:25:00',1.95),('15529','2013-10-13','12:30:00',2),('15529','2013-10-13','12:35:00',1.96),('15529','2013-10-13','12:40:00',1.95),('15529','2013-10-13','12:45:00',1.95),('15529','2013-10-13','12:50:00',1.96),('15529','2013-10-13','12:55:00',1.95),('15529','2013-10-13','13:00:00',1.92),('15529','2013-10-13','13:05:00',1.98),('15529','2013-10-13','13:10:00',1.98),('15529','2013-10-13','13:15:00',1.98),('15529','2013-10-13','13:20:00',1.97),('15529','2013-10-13','13:25:00',1.93),('15529','2013-10-13','13:30:00',1.94),('15529','2013-10-13','13:35:00',1.94),('15529','2013-10-13','13:40:00',1.94),('15529','2013-10-13','13:45:00',1.92),('15529','2013-10-13','13:50:00',1.89),('15529','2013-10-13','13:55:00',1.89),('15529','2013-10-13','14:00:00',1.87),('15529','2013-10-13','14:05:00',1.86),('15529','2013-10-13','14:10:00',1.85),('15529','2013-10-13','14:15:00',1.83),('15529','2013-10-13','14:20:00',1.8),('15529','2013-10-13','14:25:00',1.78),('15529','2013-10-13','14:30:00',1.76),('15529','2013-10-13','14:35:00',1.72),('15529','2013-10-13','14:40:00',1.7),('15529','2013-10-13','14:45:00',1.68),('15529','2013-10-13','14:50:00',1.63),('15529','2013-10-13','14:55:00',1.6),('15529','2013-10-13','15:00:00',1.58),('15529','2013-10-13','15:05:00',1.56),('15529','2013-10-13','15:10:00',1.51),('15529','2013-10-13','15:15:00',1.49),('15529','2013-10-13','15:20:00',1.47),('15529','2013-10-13','15:25:00',1.43),('15529','2013-10-13','15:30:00',1.39),('15529','2013-10-13','15:35:00',1.35),('15529','2013-10-13','15:40:00',1.13),('15529','2013-10-12','09:15:00',1.08),('15529','2013-10-12','09:20:00',1.09),('15529','2013-10-12','09:40:00',1.3),('15529','2013-10-12','09:45:00',1.61),('15529','2013-10-12','09:50:00',1.57),('15529','2013-10-12','09:55:00',1.43),('15529','2013-10-12','10:10:00',1.39),('15529','2013-10-12','10:15:00',1.24),('15529','2013-10-12','10:25:00',1.17),('15529','2013-10-12','10:30:00',1.69),('15529','2013-10-12','10:35:00',1.87),('15529','2013-10-12','10:40:00',1.9),('15529','2013-10-12','10:45:00',1.92),('15529','2013-10-12','10:50:00',1.73),('15529','2013-10-12','10:55:00',1.44),('15529','2013-10-12','11:00:00',1.91),('15529','2013-10-12','11:05:00',1.59),('15529','2013-10-12','11:10:00',1.86),('15529','2013-10-12','11:15:00',1.86),('15529','2013-10-12','11:20:00',1.83),('15529','2013-10-12','11:25:00',1.83),('15529','2013-10-12','11:30:00',1.85),('15529','2013-10-12','11:35:00',1.87),('15529','2013-10-12','11:40:00',1.87),('15529','2013-10-12','11:45:00',1.91),('15529','2013-10-12','11:50:00',1.89),('15529','2013-10-12','11:55:00',1.9),('15529','2013-10-12','12:00:00',1.93),('15529','2013-10-12','12:05:00',1.96),('15529','2013-10-12','12:10:00',1.93),('15529','2013-10-12','12:15:00',1.96),('15529','2013-10-12','12:20:00',1.94),('15529','2013-10-12','12:25:00',1.91),('15529','2013-10-12','12:30:00',1.94),('15529','2013-10-12','12:35:00',1.96),('15529','2013-10-12','12:40:00',1.98),('15529','2013-10-12','12:45:00',1.96),('15529','2013-10-12','12:50:00',1.95),('15529','2013-10-12','12:55:00',1.94),('15529','2013-10-12','13:00:00',1.95),('15529','2013-10-12','13:05:00',1.96),('15529','2013-10-12','13:10:00',1.98),('15529','2013-10-12','13:15:00',2),('15529','2013-10-12','13:20:00',1.99),('15529','2013-10-12','13:25:00',1.75),('15529','2013-10-12','13:30:00',1.62),('15529','2013-10-12','13:35:00',1.54),('15529','2013-10-12','13:40:00',1.34),('15529','2013-10-12','13:45:00',1.69),('15529','2013-10-12','13:50:00',1.7),('15529','2013-10-12','13:55:00',1.59),('15529','2013-10-12','14:00:00',1.9),('15529','2013-10-12','14:05:00',1.85),('15529','2013-10-12','14:10:00',1.93),('15529','2013-10-12','14:15:00',1.73),('15529','2013-10-12','14:20:00',1.81),('15529','2013-10-12','14:25:00',1.96),('15529','2013-10-12','14:30:00',1.45),('15529','2013-10-12','14:35:00',1.52),('15529','2013-10-12','14:40:00',1.61),('15529','2013-10-12','14:45:00',1.19),('15529','2013-10-12','14:50:00',1.02),('15529','2013-10-12','14:55:00',1.33),('15529','2013-10-12','15:00:00',1.6),('15529','2013-10-12','15:05:00',1.26),('15529','2013-10-12','15:15:00',1.16),('15529','2013-10-12','15:20:00',1.27),('15529','2013-10-12','15:25:00',1.15),('15529','2013-10-12','16:05:00',1.03),('15529','2013-10-12','16:25:00',1.11),('15529','2013-10-12','16:30:00',1.04),('15529','2013-10-11','11:35:00',1.38),('15529','2013-10-11','11:40:00',1.3),('15529','2013-10-11','12:20:00',1.62),('15529','2013-10-11','12:25:00',1.75),('15529','2013-10-11','12:30:00',1.48),('15529','2013-10-11','12:35:00',1.74),('15529','2013-10-11','12:40:00',1.88),('15529','2013-10-11','12:45:00',1.37),('15529','2013-10-11','12:50:00',1.85),('15529','2013-10-11','12:55:00',1.41),('15529','2013-10-11','13:25:00',1.01),('15529','2013-10-11','13:30:00',1.95),('15529','2013-10-10','09:20:00',1.13),('15529','2013-10-10','09:25:00',1.17),('15529','2013-10-10','09:30:00',1.23),('15529','2013-10-10','09:35:00',1.18),('15529','2013-10-10','09:40:00',1.32),('15529','2013-10-10','09:45:00',1.36),('15529','2013-10-10','09:50:00',1.4),('15529','2013-10-10','09:55:00',1.44),('15529','2013-10-10','10:00:00',1.49),('15529','2013-10-10','10:05:00',1.55),('15529','2013-10-10','10:10:00',1.46),('15529','2013-10-10','10:15:00',1.66),('15529','2013-10-10','10:20:00',1.55),('15529','2013-10-10','10:25:00',1.61),('15529','2013-10-10','10:30:00',1.49),('15529','2013-10-10','10:35:00',1.81),('15529','2013-10-10','10:40:00',1.73),('15529','2013-10-10','11:55:00',1.44),('15529','2013-10-10','12:00:00',1.5),('15529','2013-10-10','12:05:00',2.59),('15529','2013-10-10','12:10:00',1.75),('15529','2013-10-10','12:25:00',1.41),('15529','2013-10-10','13:10:00',1.45),('15529','2013-10-10','13:15:00',1.1),('15529','2013-10-10','13:25:00',1.12),('15529','2013-10-10','13:30:00',1.02),('15529','2013-10-10','13:40:00',2.09),('15529','2013-10-10','13:45:00',2.47),('15529','2013-10-10','15:30:00',1.36),('15529','2013-10-09','09:05:00',1.03),('15529','2013-10-09','09:10:00',1.07),('15529','2013-10-09','09:15:00',1.1),('15529','2013-10-09','09:20:00',1.16),('15529','2013-10-09','09:25:00',1.21),('15529','2013-10-09','09:30:00',1.22),('15529','2013-10-09','09:35:00',1.19),('15529','2013-10-09','09:40:00',1.34),('15529','2013-10-09','09:45:00',1.35),('15529','2013-10-09','09:50:00',1.41),('15529','2013-10-09','09:55:00',1.43),('15529','2013-10-09','10:00:00',1.23),('15529','2013-10-09','10:05:00',1.51),('15529','2013-10-09','10:15:00',1.6),('15529','2013-10-09','10:20:00',1.51),('15529','2013-10-09','10:25:00',1.35),('15529','2013-10-09','10:30:00',1.45),('15529','2013-10-09','10:35:00',1.77),('15529','2013-10-09','10:40:00',1.81),('15529','2013-10-09','10:45:00',2.01),('15529','2013-10-09','10:50:00',2.04),('15529','2013-10-09','10:55:00',1.95),('15529','2013-10-09','11:00:00',1.52),('15529','2013-10-09','11:10:00',1.58),('15529','2013-10-09','11:15:00',1.2),('15529','2013-10-09','11:25:00',1.78),('15529','2013-10-09','11:30:00',2.22),('15529','2013-10-09','11:35:00',2.13),('15529','2013-10-09','11:40:00',2),('15529','2013-10-09','11:45:00',2.09),('15529','2013-10-09','11:50:00',2.3),('15529','2013-10-09','11:55:00',2.25),('15529','2013-10-09','12:00:00',2.25),('15529','2013-10-09','12:05:00',1.69),('15529','2013-10-09','12:10:00',2.12),('15529','2013-10-09','12:15:00',2.31),('15529','2013-10-09','12:20:00',2.37),('15529','2013-10-09','12:25:00',2.38),('15529','2013-10-09','12:30:00',2.11),('15529','2013-10-09','12:35:00',1.52),('15529','2013-10-09','12:40:00',1.21),('15529','2013-10-09','12:45:00',1.28),('15529','2013-10-09','12:50:00',1.27),('15529','2013-10-09','13:05:00',1.12),('15529','2013-10-09','13:35:00',1.48),('15529','2013-10-09','13:40:00',1.56),('15529','2013-10-09','13:45:00',1.69),('15529','2013-10-09','13:50:00',1.91),('15529','2013-10-09','13:55:00',1.28),('15529','2013-10-09','14:00:00',1.36),('15529','2013-10-09','14:20:00',1.3),('15529','2013-10-09','14:30:00',1.01),('15529','2013-10-09','14:35:00',1.82),('15529','2013-10-09','14:45:00',1.67),('15529','2013-10-09','14:50:00',1.9),('15529','2013-10-09','14:55:00',1.36),('15529','2013-10-09','15:10:00',1.14),('15529','2013-10-09','15:30:00',1.12),('15529','2013-10-09','15:40:00',1.32),('15529','2013-10-09','15:45:00',1.46),('15529','2013-10-09','16:00:00',1.71),('15529','2013-10-09','16:05:00',1.51),('15529','2013-10-09','16:10:00',1.59),('15529','2013-10-09','16:30:00',1.05),('15529','2013-10-08','09:05:00',1.03),('15529','2013-10-08','09:10:00',1.09),('15529','2013-10-08','09:20:00',1.18),('15529','2013-10-08','09:25:00',1.26),('15529','2013-10-08','09:30:00',1.31),('15529','2013-10-08','09:35:00',1.34),('15529','2013-10-08','09:40:00',1.39),('15529','2013-10-08','09:45:00',1.45),('15529','2013-10-08','09:50:00',1.5),('15529','2013-10-08','09:55:00',1.56),('15529','2013-10-08','10:00:00',1.63),('15529','2013-10-08','10:05:00',1.34),('15529','2013-10-08','10:45:00',1.43),('15529','2013-10-08','10:50:00',1.49),('15529','2013-10-08','10:55:00',1.46),('15529','2013-10-08','11:00:00',1.35),('15529','2013-10-08','11:05:00',1.71),('15529','2013-10-08','11:10:00',2.31),('15529','2013-10-08','11:15:00',1.99),('15529','2013-10-08','11:20:00',1.96),('15529','2013-10-08','11:25:00',2.1),('15529','2013-10-08','11:40:00',1.02),('15529','2013-10-08','11:50:00',2.03),('15529','2013-10-08','11:55:00',2.19),('15529','2013-10-08','12:00:00',2.21),('15529','2013-10-08','12:05:00',1.14),('15529','2013-10-08','12:10:00',1.15),('15529','2013-10-08','12:15:00',2.09),('15529','2013-10-08','12:20:00',1.22),('15529','2013-10-08','12:25:00',1.52),('15529','2013-10-08','12:30:00',1.44),('15529','2013-10-08','12:35:00',1.77),('15529','2013-10-08','13:15:00',1.03),('15529','2013-10-08','13:20:00',1.81),('15529','2013-10-08','13:25:00',2.21),('15529','2013-10-08','13:30:00',1.04),('15529','2013-10-08','13:35:00',1.04),('15529','2013-10-08','14:10:00',1.59),('15529','2013-10-08','14:50:00',1.99),('15529','2013-10-08','15:00:00',1.92),('15529','2013-10-08','15:05:00',1.92),('15529','2013-10-08','15:10:00',1.88),('15529','2013-10-08','15:15:00',1.52),('15529','2013-10-08','15:20:00',1.8),('15529','2013-10-08','15:25:00',1.79),('15529','2013-10-08','15:45:00',1.09),('15529','2013-10-08','16:00:00',1.16),('15529','2013-10-08','16:20:00',1.07),('15529','2013-10-08','16:25:00',1.08),('15529','2014-04-14','09:05:00',1.21),('15529','2014-04-14','09:10:00',1.23),('15529','2014-04-14','09:15:00',1.27),('15529','2014-04-14','09:20:00',1.31),('15529','2014-04-14','09:25:00',1.43),('15529','2014-04-14','10:00:00',1.8),('15529','2014-04-14','10:05:00',1.33),('15529','2014-04-14','10:10:00',1.17),('15529','2014-04-14','10:15:00',1.67),('15529','2014-04-14','10:20:00',1.31),('15529','2014-04-14','10:25:00',1.39),('15529','2014-04-14','10:30:00',1.89),('15529','2014-04-14','10:35:00',1.15),('15529','2014-04-14','10:40:00',1.81),('15529','2014-04-14','10:45:00',1.51),('15529','2014-04-14','10:50:00',1.23),('15529','2014-04-14','10:55:00',1),('15529','2014-04-14','11:00:00',1.38),('15529','2014-04-14','11:05:00',1.8),('15529','2014-04-14','11:10:00',1.36),('15529','2014-04-14','11:20:00',1.12),('15529','2014-04-14','12:15:00',1.02),('15529','2014-04-14','13:15:00',1.56),('15529','2014-04-14','13:30:00',1.41),('15529','2014-04-14','13:35:00',1.62),('15529','2014-04-14','13:55:00',1.13),('15529','2014-04-14','14:00:00',2),('15529','2014-04-14','14:05:00',1.13),('15529','2014-04-14','14:15:00',1.93),('15529','2014-04-14','14:20:00',2.25),('15529','2014-04-14','14:25:00',1.62),('15529','2014-04-14','14:30:00',1.19),('15529','2014-04-14','14:35:00',1.55),('15529','2014-04-14','14:40:00',1.4),('15529','2014-04-14','14:45:00',1.61),('15529','2014-04-14','14:50:00',1.9),('15529','2014-04-14','14:55:00',1.65),('15529','2014-04-14','15:00:00',2.25),('15529','2014-04-14','15:05:00',1.28),('15529','2014-04-14','15:10:00',1.31),('15529','2014-04-14','15:15:00',1.83),('15529','2014-04-14','15:20:00',2.02),('15529','2014-04-14','15:25:00',1.73),('15529','2014-04-14','15:30:00',1.09),('15529','2013-10-07','11:15:00',1.25),('15529','2013-10-07','11:20:00',1.78),('15529','2013-10-07','11:25:00',1.58),('15529','2013-10-07','12:30:00',1.3),('15529','2013-10-07','12:35:00',1.07),('15529','2013-10-07','12:45:00',1.46),('15529','2013-10-07','12:50:00',2.32),('15529','2013-10-07','12:55:00',2.41),('15529','2013-10-07','13:00:00',1.72),('15529','2013-10-07','13:05:00',1.04),('15529','2013-10-07','13:30:00',2.56),('15529','2013-10-07','13:35:00',1.51),('15529','2013-10-07','14:15:00',1.1),('15529','2013-10-07','14:20:00',1.21),('15529','2013-10-07','14:25:00',1.45),('15529','2013-10-07','14:30:00',1.11),('15529','2013-10-07','14:40:00',1.16),('15529','2013-10-07','14:45:00',1.67),('15529','2013-10-07','14:50:00',1.98),('15529','2013-10-07','14:55:00',1.9),('15529','2013-10-07','15:00:00',1.87),('15529','2013-10-07','15:05:00',1.69),('15529','2013-10-07','15:10:00',1.44),('15529','2013-10-07','15:15:00',1.79),('15529','2013-10-07','15:20:00',1.28),('15529','2013-10-07','15:30:00',1.2),('15529','2013-10-07','15:40:00',1.19),('15529','2013-10-07','15:50:00',1.09),('15529','2013-10-06','09:00:00',1.01),('15529','2013-10-06','09:05:00',1.12),('15529','2013-10-06','09:10:00',1.12),('15529','2013-10-06','09:15:00',1.12),('15529','2013-10-06','09:20:00',1.17),('15529','2013-10-06','09:25:00',1.22),('15529','2013-10-06','09:30:00',1.25),('15529','2013-10-06','09:35:00',1.3),('15529','2013-10-06','09:40:00',1.34),('15529','2013-10-06','09:45:00',1.37),('15529','2013-10-06','09:50:00',1.41),('15529','2013-10-06','09:55:00',1.44),('15529','2013-10-06','10:00:00',1.47),('15529','2013-10-06','10:05:00',1.5),('15529','2013-10-06','10:10:00',1.54),('15529','2013-10-06','10:15:00',1.57),('15529','2013-10-06','10:20:00',1.63),('15529','2013-10-06','10:25:00',1.67),('15529','2013-10-06','10:30:00',1.55),('15529','2013-10-06','10:35:00',1.11),('15529','2013-10-06','10:40:00',1.83),('15529','2013-10-06','10:45:00',1.8),('15529','2013-10-06','10:50:00',1.8),('15529','2013-10-06','10:55:00',1.68),('15529','2013-10-06','11:05:00',1.91),('15529','2013-10-06','11:10:00',1.85),('15529','2013-10-06','11:15:00',1.9),('15529','2013-10-06','11:20:00',1.93),('15529','2013-10-06','11:25:00',1.97),('15529','2013-10-06','11:30:00',1.98),('15529','2013-10-06','11:35:00',1.99),('15529','2013-10-06','11:40:00',1.97),('15529','2013-10-06','11:45:00',2.1),('15529','2013-10-06','11:50:00',2.05),('15529','2013-10-06','11:55:00',2.08),('15529','2013-10-06','12:00:00',2.13),('15529','2013-10-06','12:05:00',2.22),('15529','2013-10-06','12:10:00',1.77),('15529','2013-10-06','12:15:00',2.35),('15529','2013-10-06','12:20:00',1.29),('15529','2013-10-06','12:25:00',2.27),('15529','2013-10-06','12:30:00',1.99),('15529','2013-10-06','12:35:00',1.74),('15529','2013-10-06','12:40:00',2.28),('15529','2013-10-06','12:45:00',1.88),('15529','2013-10-06','12:50:00',1.95),('15529','2013-10-06','12:55:00',2.31),('15529','2013-10-06','13:00:00',1.81),('15529','2013-10-06','13:10:00',1.19),('15529','2013-10-06','13:25:00',1.33),('15529','2013-10-06','14:00:00',1.7),('15529','2013-10-06','14:05:00',1.16),('15529','2013-10-06','14:10:00',1.35),('15529','2013-10-06','14:15:00',2.36),('15529','2013-10-06','14:20:00',2.24),('15529','2013-10-06','14:25:00',2.23),('15529','2013-10-06','14:30:00',1.68),('15529','2013-10-06','14:35:00',2.13),('15529','2013-10-06','14:40:00',1.83),('15529','2013-10-06','14:45:00',1.12),('15529','2013-10-06','14:50:00',1.89),('15529','2013-10-06','14:55:00',1.99),('15529','2013-10-06','15:00:00',1.96),('15529','2013-10-06','15:05:00',1.35),('15529','2013-10-06','15:10:00',1.69),('15529','2013-10-06','15:15:00',1.78),('15529','2013-10-06','15:20:00',1.82),('15529','2013-10-06','15:25:00',1.8),('15529','2013-10-06','15:30:00',1.81),('15529','2013-10-06','15:35:00',1.8),('15529','2013-10-06','15:40:00',1.71),('15529','2013-10-06','15:45:00',1.56),('15529','2013-10-06','15:50:00',1.6),('15529','2013-10-06','15:55:00',1.56),('15529','2013-10-06','16:00:00',1.48),('15529','2013-10-06','16:05:00',1.47),('15529','2013-10-06','16:10:00',1.38),('15529','2013-10-06','16:25:00',1.24),('15529','2013-10-06','16:30:00',1.23),('15529','2013-10-06','16:35:00',1.17),('15529','2013-10-06','16:40:00',1.1),('15529','2013-10-06','16:45:00',1.03),('15529','2013-10-05','09:35:00',1.07),('15529','2013-10-05','09:50:00',1.3),('15529','2013-10-05','09:55:00',1.48),('15529','2013-10-05','10:00:00',1.66),('15529','2013-10-05','10:05:00',1.61),('15529','2013-10-05','10:10:00',1.54),('15529','2013-10-05','10:15:00',1.42),('15529','2013-10-05','10:20:00',1.53),('15529','2013-10-05','10:25:00',1.7),('15529','2013-10-05','10:30:00',1.64),('15529','2013-10-05','10:35:00',1.51),('15529','2013-10-05','10:40:00',1.29),('15529','2013-10-05','10:50:00',1.29),('15529','2013-10-05','10:55:00',1.29),('15529','2013-10-05','11:00:00',1.39),('15529','2013-10-05','11:05:00',1.61),('15529','2013-10-05','11:10:00',1.74),('15529','2013-10-05','11:15:00',1.68),('15529','2013-10-05','11:20:00',1.45),('15529','2013-10-05','11:25:00',1.65),('15529','2013-10-05','11:30:00',1.68),('15529','2013-10-05','11:35:00',1.32),('15529','2013-10-05','11:50:00',1.06),('15529','2013-10-05','11:55:00',1.55),('15529','2013-10-05','12:00:00',1.61),('15529','2013-10-05','12:05:00',1.75),('15529','2013-10-05','12:10:00',1.95),('15529','2013-10-05','12:15:00',1.34),('15529','2013-10-05','12:20:00',1.39),('15529','2013-10-05','12:25:00',1.34),('15529','2013-10-05','12:35:00',1.13),('15529','2013-10-05','12:40:00',1.3),('15529','2013-10-05','12:45:00',1.77),('15529','2013-10-05','12:50:00',1.87),('15529','2013-10-05','12:55:00',1.99),('15529','2013-10-05','13:00:00',2.01),('15529','2013-10-05','13:05:00',2.05),('15529','2013-10-05','13:10:00',1.27),('15529','2013-10-05','13:20:00',1.72),('15529','2013-10-05','13:40:00',1.58),('15529','2013-10-05','13:45:00',1.98),('15529','2013-10-05','13:50:00',2.04),('15529','2013-10-05','13:55:00',1.84),('15529','2013-10-05','14:00:00',1.85),('15529','2013-10-05','14:05:00',1.3),('15529','2013-10-05','14:20:00',1.2),('15529','2013-10-05','14:25:00',1.33),('15529','2013-10-05','14:30:00',1.18),('15529','2013-10-05','14:35:00',1.02),('15529','2013-10-05','14:40:00',1.4),('15529','2013-10-05','14:45:00',1.01),('15529','2013-10-05','14:50:00',1.09),('15529','2013-10-05','14:55:00',1.35),('15529','2013-10-05','15:05:00',1.2),('15529','2013-10-03','09:50:00',1.1),('15529','2013-10-03','10:25:00',1.22),('15529','2013-10-03','10:30:00',1.57),('15529','2013-10-03','10:35:00',1.26),('15529','2013-10-03','10:40:00',1.75),('15529','2013-10-03','10:45:00',2.04),('15529','2013-10-03','10:50:00',1.24),('15529','2013-10-03','11:00:00',1.2),('15529','2013-10-03','11:10:00',1.03),('15529','2013-10-03','11:15:00',1.91),('15529','2013-10-03','11:20:00',1.56),('15529','2013-10-03','11:25:00',1.68),('15529','2013-10-03','11:30:00',2.16),('15529','2013-10-03','11:35:00',1.79),('15529','2013-10-03','11:40:00',1.91),('15529','2013-10-03','11:45:00',2.12),('15529','2013-10-03','11:50:00',2.07),('15529','2013-10-03','11:55:00',2.01),('15529','2013-10-03','12:00:00',2.06),('15529','2013-10-03','12:05:00',2.09),('15529','2013-10-03','12:10:00',2.06),('15529','2013-10-03','12:15:00',1.74),('15529','2013-10-03','12:20:00',2.15),('15529','2013-10-03','12:25:00',2.14),('15529','2013-10-03','12:30:00',2.18),('15529','2013-10-03','12:35:00',2.11),('15529','2013-10-03','12:40:00',2.06),('15529','2013-10-03','12:45:00',2.09),('15529','2013-10-03','12:50:00',2.04),('15529','2013-10-03','12:55:00',2.04),('15529','2013-10-03','13:00:00',2.09),('15529','2013-10-03','13:05:00',2.11),('15529','2013-10-03','13:10:00',2.11),('15529','2013-10-03','13:15:00',2.16),('15529','2013-10-03','13:20:00',2.06),('15529','2013-10-03','13:25:00',2.06),('15529','2013-10-03','13:30:00',2.12),('15529','2013-10-03','13:35:00',2.12),('15529','2013-10-03','13:40:00',2.07),('15529','2013-10-03','13:45:00',2.05),('15529','2013-10-03','13:50:00',2.02),('15529','2013-10-03','13:55:00',2.03),('15529','2013-10-03','14:00:00',2.01),('15529','2013-10-03','14:05:00',1.99),('15529','2013-10-03','14:10:00',1.69),('15529','2013-10-03','14:15:00',1.64),('15529','2013-10-03','14:20:00',1.92),('15529','2013-10-03','14:25:00',1.81),('15529','2013-10-03','14:30:00',1.58),('15529','2013-10-03','14:35:00',1.01),('15529','2013-10-03','14:45:00',1.25),('15529','2013-10-03','14:50:00',1.52),('15529','2013-10-03','14:55:00',1.27),('15529','2013-10-03','15:00:00',1.15),('15529','2013-10-03','15:05:00',1.36),('15529','2013-10-03','15:10:00',1.23),('15529','2013-10-03','15:25:00',1.29),('15529','2013-10-02','09:00:00',1.05),('15529','2013-10-02','09:05:00',1.1),('15529','2013-10-02','09:10:00',1.15),('15529','2013-10-02','09:15:00',1.21),('15529','2013-10-02','09:20:00',1.26),('15529','2013-10-02','09:25:00',1.31),('15529','2013-10-02','09:30:00',1.35),('15529','2013-10-02','09:35:00',1.4),('15529','2013-10-02','09:40:00',1.44),('15529','2013-10-02','09:45:00',1.48),('15529','2013-10-02','09:50:00',1.52),('15529','2013-10-02','09:55:00',1.57),('15529','2013-10-02','10:00:00',1.61),('15529','2013-10-02','10:05:00',1.66),('15529','2013-10-02','10:10:00',1.69),('15529','2013-10-02','10:15:00',1.73),('15529','2013-10-02','10:20:00',1.77),('15529','2013-10-02','10:25:00',1.79),('15529','2013-10-02','10:30:00',1.82),('15529','2013-10-02','10:35:00',1.85),('15529','2013-10-02','10:40:00',1.88),('15529','2013-10-02','10:45:00',1.9),('15529','2013-10-02','10:50:00',1.92),('15529','2013-10-02','10:55:00',1.95),('15529','2013-10-02','11:00:00',1.98),('15529','2013-10-02','11:05:00',2),('15529','2013-10-02','11:10:00',2.03),('15529','2013-10-02','11:15:00',2.06),('15529','2013-10-02','11:20:00',2.07),('15529','2013-10-02','11:25:00',2.1),('15529','2013-10-02','11:30:00',2.12),('15529','2013-10-02','11:35:00',2.13),('15529','2013-10-02','11:40:00',2.16),('15529','2013-10-02','11:45:00',2.17),('15529','2013-10-02','11:50:00',2.18),('15529','2013-10-02','11:55:00',2.19),('15529','2013-10-02','12:00:00',2.2),('15529','2013-10-02','12:05:00',2.21),('15529','2013-10-02','12:10:00',2.23),('15529','2013-10-02','12:15:00',2.23),('15529','2013-10-02','12:20:00',2.25),('15529','2013-10-02','12:25:00',2.23),('15529','2013-10-02','12:30:00',2.24),('15529','2013-10-02','12:35:00',2.26),('15529','2013-10-02','12:40:00',2.26),('15529','2013-10-02','12:45:00',2.22),('15529','2013-10-02','12:50:00',2.24),('15529','2013-10-02','12:55:00',2.26),('15529','2013-10-02','13:00:00',2.23),('15529','2013-10-02','13:05:00',2.24),('15529','2013-10-02','13:10:00',2.24),('15529','2013-10-02','13:15:00',2.22),('15529','2013-10-02','13:20:00',2.24),('15529','2013-10-02','13:25:00',2.23),('15529','2013-10-02','13:30:00',2.24),('15529','2013-10-02','13:35:00',2.25),('15529','2013-10-02','13:40:00',2.21),('15529','2013-10-02','13:45:00',2.21),('15529','2013-10-02','13:50:00',2.19),('15529','2013-10-02','13:55:00',2.15),('15529','2013-10-02','14:00:00',2.16),('15529','2013-10-02','14:05:00',2.13),('15529','2013-10-02','14:10:00',2.11),('15529','2013-10-02','14:15:00',2.1),('15529','2013-10-02','14:20:00',2.09),('15529','2013-10-02','14:25:00',2.06),('15529','2013-10-02','14:30:00',2.06),('15529','2013-10-02','14:35:00',2.03),('15529','2013-10-02','14:40:00',2),('15529','2013-10-02','14:45:00',1.97),('15529','2013-10-02','14:50:00',1.95),('15529','2013-10-02','14:55:00',1.9),('15529','2013-10-02','15:00:00',1.87),('15529','2013-10-02','15:05:00',1.85),('15529','2013-10-02','15:10:00',1.82),('15529','2013-10-02','15:15:00',1.79),('15529','2013-10-02','15:20:00',1.78),('15529','2013-10-02','15:25:00',1.73),('15529','2013-10-02','15:30:00',1.72),('15529','2013-10-02','15:35:00',1.68),('15529','2013-10-02','15:40:00',1.64),('15529','2013-10-02','15:45:00',1.59),('15529','2013-10-02','15:50:00',1.55),('15529','2013-10-02','15:55:00',1.52),('15529','2013-10-02','16:00:00',1.47),('15529','2013-10-02','16:05:00',1.43),('15529','2013-10-02','16:10:00',1.39),('15529','2013-10-02','16:15:00',1.34),('15529','2013-10-02','16:20:00',1.3),('15529','2013-10-02','16:25:00',1.24),('15529','2013-10-02','16:30:00',1.2),('15529','2013-10-02','16:35:00',1.15),('15529','2013-10-02','16:40:00',1.11),('15529','2013-10-02','16:45:00',1.05),('15529','2013-10-01','09:05:00',1.04),('15529','2013-10-01','09:10:00',1.08),('15529','2013-10-01','09:15:00',1.13),('15529','2013-10-01','09:20:00',1.19),('15529','2013-10-01','09:25:00',1.23),('15529','2013-10-01','09:30:00',1.28),('15529','2013-10-01','09:35:00',1.32),('15529','2013-10-01','09:40:00',1.36),('15529','2013-10-01','09:45:00',1.4),('15529','2013-10-01','09:50:00',1.43),('15529','2013-10-01','09:55:00',1.46),('15529','2013-10-01','10:00:00',1.49),('15529','2013-10-01','10:05:00',1.54),('15529','2013-10-01','10:10:00',1.56),('15529','2013-10-01','10:15:00',1.61),('15529','2013-10-01','10:20:00',1.64),('15529','2013-10-01','10:25:00',1.68),('15529','2013-10-01','10:30:00',1.71),('15529','2013-10-01','10:35:00',1.74),('15529','2013-10-01','10:40:00',1.79),('15529','2013-10-01','10:45:00',1.81),('15529','2013-10-01','10:50:00',1.84),('15529','2013-10-01','10:55:00',1.86),('15529','2013-10-01','11:00:00',1.88),('15529','2013-10-01','11:05:00',1.91),('15529','2013-10-01','11:10:00',1.94),('15529','2013-10-01','11:15:00',1.94),('15529','2013-10-01','11:20:00',1.96),('15529','2013-10-01','11:25:00',1.97),('15529','2013-10-01','11:30:00',2.01),('15529','2013-10-01','11:35:00',2.02),('15529','2013-10-01','11:40:00',2.05),('15529','2013-10-01','11:45:00',2.07),('15529','2013-10-01','11:50:00',2.07),('15529','2013-10-01','11:55:00',2.09),('15529','2013-10-01','12:00:00',2.11),('15529','2013-10-01','12:05:00',2.1),('15529','2013-10-01','12:10:00',2.1),('15529','2013-10-01','12:15:00',2.12),('15529','2013-10-01','12:20:00',2.15),('15529','2013-10-01','12:25:00',2.14),('15529','2013-10-01','12:30:00',2.12),('15529','2013-10-01','12:35:00',2.15),('15529','2013-10-01','12:40:00',2.14),('15529','2013-10-01','12:45:00',2.14),('15529','2013-10-01','12:50:00',2.14),('15529','2013-10-01','12:55:00',2.16),('15529','2013-10-01','13:00:00',2.18),('15529','2013-10-01','13:05:00',2.17),('15529','2013-10-01','13:10:00',2.16),('15529','2013-10-01','13:15:00',2.16),('15529','2013-10-01','13:20:00',2.16),('15529','2013-10-01','13:25:00',2.15),('15529','2013-10-01','13:30:00',2.15),('15529','2013-10-01','13:35:00',2.12),('15529','2013-10-01','13:40:00',2.08),('15529','2013-10-01','13:45:00',2.11),('15529','2013-10-01','13:50:00',2.1),('15529','2013-10-01','13:55:00',2.1),('15529','2013-10-01','14:00:00',2.06),('15529','2013-10-01','14:05:00',2.06),('15529','2013-10-01','14:10:00',2.06),('15529','2013-10-01','14:15:00',2.04),('15529','2013-10-01','14:20:00',1.99),('15529','2013-10-01','14:25:00',1.99),('15529','2013-10-01','14:30:00',1.97),('15529','2013-10-01','14:35:00',1.93),('15529','2013-10-01','14:40:00',1.91),('15529','2013-10-01','14:45:00',1.89),('15529','2013-10-01','14:50:00',1.88),('15529','2013-10-01','14:55:00',1.85),('15529','2013-10-01','15:00:00',1.83),('15529','2013-10-01','15:05:00',1.8),('15529','2013-10-01','15:10:00',1.76),('15529','2013-10-01','15:15:00',1.73),('15529','2013-10-01','15:20:00',1.7),('15529','2013-10-01','15:25:00',1.67),('15529','2013-10-01','15:30:00',1.64),('15529','2013-10-01','15:35:00',1.61),('15529','2013-10-01','15:40:00',1.57),('15529','2013-10-01','15:45:00',1.53),('15529','2013-10-01','15:50:00',1.49),('15529','2013-10-01','15:55:00',1.47),('15529','2013-10-01','16:00:00',1.44),('15529','2013-10-01','16:05:00',1.39),('15529','2013-10-01','16:10:00',1.35),('15529','2013-10-01','16:15:00',1.29),('15529','2013-10-01','16:20:00',1.26),('15529','2013-10-01','16:25:00',1.21),('15529','2013-10-01','16:30:00',1.17),('15529','2013-10-01','16:35:00',1.13),('15529','2013-10-01','16:40:00',1.08),('15529','2013-10-01','16:45:00',1.02),('15529','2013-09-30','09:05:00',1.02),('15529','2013-09-30','09:10:00',1.07),('15529','2013-09-30','09:15:00',1.11),('15529','2013-09-30','09:20:00',1.16),('15529','2013-09-30','09:25:00',1.2),('15529','2013-09-30','09:30:00',1.24),('15529','2013-09-30','09:35:00',1.28),('15529','2013-09-30','09:40:00',1.32),('15529','2013-09-30','09:45:00',1.36),('15529','2013-09-30','09:50:00',1.4),('15529','2013-09-30','09:55:00',1.43),('15529','2013-09-30','10:00:00',1.47),('15529','2013-09-30','10:05:00',1.52),('15529','2013-09-30','10:10:00',1.55),('15529','2013-09-30','10:15:00',1.57),('15529','2013-09-30','10:30:00',1.76),('15529','2013-09-30','10:35:00',1.8),('15529','2013-09-30','10:40:00',1.86),('15529','2013-09-30','10:45:00',1.9),('15529','2013-09-30','10:50:00',1.91),('15529','2013-09-30','10:55:00',1.44),('15529','2013-09-30','11:15:00',1.51),('15529','2013-09-30','11:20:00',2.02),('15529','2013-09-30','11:25:00',2.16),('15529','2013-09-30','11:30:00',1.44),('15529','2013-09-30','11:50:00',2.23),('15529','2013-09-30','11:55:00',1.3),('15529','2013-09-30','12:05:00',1.32),('15529','2013-09-30','12:10:00',2.26),('15529','2013-09-30','12:15:00',2.34),('15529','2013-09-30','12:20:00',1.54),('15529','2013-09-30','12:25:00',2.07),('15529','2013-09-30','12:30:00',1.46),('15529','2013-09-30','12:35:00',1.37),('15529','2013-09-30','12:45:00',1.59),('15529','2013-09-30','12:50:00',2.42),('15529','2013-09-30','12:55:00',2.37),('15529','2013-09-30','13:00:00',2.08),('15529','2013-09-30','13:05:00',1.13),('15529','2013-09-30','13:10:00',1.56),('15529','2013-09-30','13:15:00',1.32),('15529','2013-09-30','13:20:00',1.59),('15529','2013-09-30','13:25:00',2.21),('15529','2013-09-30','13:30:00',2.2),('15529','2013-09-30','13:35:00',2.15),('15529','2013-09-30','13:40:00',2.13),('15529','2013-09-30','13:45:00',2.1),('15529','2013-09-30','13:50:00',2.06),('15529','2013-09-30','13:55:00',2.07),('15529','2013-09-30','14:00:00',2.04),('15529','2013-09-30','14:05:00',2.01),('15529','2013-09-30','14:10:00',2.03),('15529','2013-09-30','14:15:00',2.02),('15529','2013-09-30','14:20:00',1.97),('15529','2013-09-30','14:25:00',1.96),('15529','2013-09-30','14:30:00',1.9),('15529','2013-09-30','14:35:00',1.96),('15529','2013-09-30','14:40:00',1.95),('15529','2013-09-30','14:45:00',1.93),('15529','2013-09-30','14:50:00',1.94),('15529','2013-09-30','14:55:00',1.87),('15529','2013-09-30','15:00:00',1.83),('15529','2013-09-30','15:05:00',1.81),('15529','2013-09-30','15:10:00',1.78),('15529','2013-09-30','15:15:00',1.75),('15529','2013-09-30','15:20:00',1.72),('15529','2013-09-30','15:25:00',1.69),('15529','2013-09-30','15:30:00',1.67),('15529','2013-09-30','15:35:00',1.63),('15529','2013-09-30','15:40:00',1.59),('15529','2013-09-30','15:45:00',1.54),('15529','2013-09-30','15:50:00',1.5),('15529','2013-09-30','15:55:00',1.45),('15529','2013-09-30','16:00:00',1.41),('15529','2013-09-30','16:05:00',1.37),('15529','2013-09-30','16:10:00',1.33),('15529','2013-09-30','16:15:00',1.3),('15529','2013-09-30','16:20:00',1.26),('15529','2013-09-30','16:25:00',1.22),('15529','2013-09-30','16:30:00',1.17),('15529','2013-09-30','16:35:00',1.13),('15529','2013-09-30','16:40:00',1.08),('15529','2013-09-30','16:45:00',1.03),('15529','2013-09-29','10:35:00',1.05),('15529','2013-09-29','10:40:00',1.43),('15529','2013-09-29','10:45:00',1.96),('15529','2013-09-29','10:50:00',1.87),('15529','2013-09-29','10:55:00',1.55),('15529','2013-09-29','11:00:00',1.59),('15529','2013-09-29','11:05:00',1.93),('15529','2013-09-29','11:10:00',1.63),('15529','2013-09-29','11:15:00',1.55),('15529','2013-09-29','11:20:00',1.79),('15529','2013-09-29','11:25:00',1.54),('15529','2013-09-29','11:30:00',1.71),('15529','2013-09-29','11:35:00',2.08),('15529','2013-09-29','11:40:00',2.08),('15529','2013-09-29','11:50:00',1.07),('15529','2013-09-29','11:55:00',1.83),('15529','2013-09-29','12:00:00',1.01),('15529','2013-09-29','12:05:00',1.8),('15529','2013-09-29','12:10:00',2.23),('15529','2013-09-29','12:15:00',2.23),('15529','2013-09-29','12:20:00',2.24),('15529','2013-09-29','12:25:00',2.22),('15529','2013-09-29','12:30:00',2.22),('15529','2013-09-29','12:35:00',1.45),('15529','2013-09-29','12:40:00',2.04),('15529','2013-09-29','12:45:00',2.34),('15529','2013-09-29','12:50:00',2.27),('15529','2013-09-29','12:55:00',2.28),('15529','2013-09-29','13:00:00',2.29),('15529','2013-09-29','13:05:00',2.34),('15529','2013-09-29','13:10:00',2.13),('15529','2013-09-29','13:15:00',1.88),('15529','2013-09-29','13:20:00',2.12),('15529','2013-09-29','13:25:00',2.43),('15529','2013-09-29','13:30:00',1.68),('15529','2013-09-29','13:35:00',1.54),('15529','2013-09-29','13:45:00',1.43),('15529','2013-09-29','13:50:00',1.47),('15529','2013-09-29','13:55:00',1.01),('15529','2013-09-29','14:30:00',1.92),('15529','2013-09-29','14:35:00',1.69),('15529','2013-09-29','14:40:00',1.68),('15529','2013-09-29','14:45:00',2.12),('15529','2013-09-29','14:50:00',1.41),('15529','2013-09-29','14:55:00',2.08),('15529','2013-09-29','15:00:00',1.42),('15529','2013-09-29','15:05:00',2.16),('15529','2013-09-29','15:10:00',1.52),('15529','2013-09-29','15:20:00',1.53),('15529','2013-09-29','15:25:00',1.37),('15529','2013-09-29','15:30:00',1.91),('15529','2013-09-29','15:35:00',1.95),('15529','2013-09-29','15:40:00',1.24),('15529','2013-09-29','16:10:00',1.6),('15529','2013-09-29','16:55:00',1.14),('15529','2013-09-29','17:00:00',1.01),('15529','2013-09-28','10:10:00',1.23),('15529','2013-09-28','10:15:00',1.46),('15529','2013-09-28','10:20:00',1.07),('15529','2013-09-28','10:25:00',1.16),('15529','2013-09-28','10:30:00',1.43),('15529','2013-09-28','10:35:00',1.52),('15529','2013-09-28','10:40:00',1.46),('15529','2013-09-28','10:45:00',1.63),('15529','2013-09-28','10:50:00',1.62),('15529','2013-09-28','10:55:00',1.65),('15529','2013-09-28','11:00:00',1.68),('15529','2013-09-28','11:05:00',1.57),('15529','2013-09-28','11:10:00',1.61),('15529','2013-09-28','11:15:00',1.73),('15529','2013-09-28','11:20:00',1.65),('15529','2013-09-28','11:25:00',1.65),('15529','2013-09-28','11:30:00',1.71),('15529','2013-09-28','11:35:00',1.71),('15529','2013-09-28','11:40:00',1.74),('15529','2013-09-28','11:45:00',1.89),('15529','2013-09-28','11:50:00',1.98),('15529','2013-09-28','11:55:00',1.84),('15529','2013-09-28','12:00:00',1.41),('15529','2013-09-28','12:05:00',1.96),('15529','2013-09-28','12:10:00',2.03),('15529','2013-09-28','12:15:00',1.58),('15529','2013-09-28','13:35:00',1.28),('15529','2013-09-28','13:40:00',1.03),('15529','2013-09-28','13:45:00',1.02),('15529','2013-09-28','13:50:00',1.04),('15529','2013-09-28','14:00:00',1.27),('15529','2013-09-28','14:05:00',1),('15529','2013-09-28','14:20:00',1.23),('15529','2014-04-13','08:50:00',1.03),('15529','2014-04-13','08:55:00',1.08),('15529','2014-04-13','09:00:00',1.12),('15529','2014-04-13','09:05:00',1.18),('15529','2014-04-13','09:10:00',1.22),('15529','2014-04-13','09:15:00',1.27),('15529','2014-04-13','09:20:00',1.32),('15529','2014-04-13','09:25:00',1.35),('15529','2014-04-13','09:30:00',1.39),('15529','2014-04-13','09:35:00',1.43),('15529','2014-04-13','09:40:00',1.48),('15529','2014-04-13','09:45:00',1.52),('15529','2014-04-13','09:50:00',1.56),('15529','2014-04-13','09:55:00',1.6),('15529','2014-04-13','10:00:00',1.63),('15529','2014-04-13','10:05:00',1.67),('15529','2014-04-13','10:10:00',1.71),('15529','2014-04-13','10:15:00',1.73),('15529','2014-04-13','10:20:00',1.77),('15529','2014-04-13','10:25:00',1.79),('15529','2014-04-13','10:30:00',1.83),('15529','2014-04-13','10:35:00',1.87),('15529','2014-04-13','10:40:00',1.89),('15529','2014-04-13','10:45:00',1.91),('15529','2014-04-13','10:50:00',1.96),('15529','2014-04-13','10:55:00',1.97),('15529','2014-04-13','11:00:00',2),('15529','2014-04-13','11:05:00',2.04),('15529','2014-04-13','11:10:00',2.06),('15529','2014-04-13','11:15:00',2.06),('15529','2014-04-13','11:20:00',2.1),('15529','2014-04-13','11:25:00',2.13),('15529','2014-04-13','11:30:00',2.16),('15529','2014-04-13','11:35:00',2.19),('15529','2014-04-13','11:40:00',2.2),('15529','2014-04-13','11:45:00',2.24),('15529','2014-04-13','11:50:00',2.2),('15529','2014-04-13','11:55:00',2.24),('15529','2014-04-13','12:00:00',2.23),('15529','2014-04-13','12:05:00',2.21),('15529','2014-04-13','12:10:00',2.28),('15529','2014-04-13','12:15:00',2.27),('15529','2014-04-13','12:20:00',2.28),('15529','2014-04-13','12:25:00',2.26),('15529','2014-04-13','12:30:00',2.31),('15529','2014-04-13','12:35:00',2.33),('15529','2014-04-13','12:40:00',2.34),('15529','2014-04-13','12:45:00',2.34),('15529','2014-04-13','12:50:00',2.32),('15529','2014-04-13','12:55:00',2.33),('15529','2014-04-13','13:00:00',2.33),('15529','2014-04-13','13:05:00',2.37),('15529','2014-04-13','13:10:00',2.36),('15529','2014-04-13','13:15:00',2.37),('15529','2014-04-13','13:20:00',2.37),('15529','2014-04-13','13:25:00',2.34),('15529','2014-04-13','13:30:00',2.36),('15529','2014-04-13','13:35:00',2.35),('15529','2014-04-13','13:40:00',2.35),('15529','2014-04-13','13:45:00',2.33),('15529','2014-04-13','13:50:00',2.32),('15529','2014-04-13','13:55:00',2.3),('15529','2014-04-13','14:00:00',2.29),('15529','2014-04-13','14:05:00',2.25),('15529','2014-04-13','14:10:00',2.28),('15529','2014-04-13','14:15:00',2.29),('15529','2014-04-13','14:20:00',2.28),('15529','2014-04-13','14:25:00',2.27),('15529','2014-04-13','14:30:00',2.23),('15529','2014-04-13','14:35:00',2.21),('15529','2014-04-13','14:40:00',2.21),('15529','2014-04-13','14:45:00',2.17),('15529','2014-04-13','14:50:00',2.17),('15529','2014-04-13','14:55:00',2.12),('15529','2014-04-13','15:00:00',2.12),('15529','2014-04-13','15:05:00',2.09),('15529','2014-04-13','15:10:00',2.07),('15529','2014-04-13','15:15:00',2.05),('15529','2014-04-13','15:20:00',2.02),('15529','2014-04-13','15:25:00',1.98),('15529','2014-04-13','15:30:00',1.95),('15529','2014-04-13','15:35:00',1.92),('15529','2014-04-13','15:40:00',1.9),('15529','2014-04-13','15:45:00',1.86),('15529','2014-04-13','15:50:00',1.83),('15529','2014-04-13','15:55:00',1.8),('15529','2014-04-13','16:00:00',1.77),('15529','2014-04-13','16:05:00',1.74),('15529','2014-04-13','16:10:00',1.69),('15529','2014-04-13','16:15:00',1.65),('15529','2014-04-13','16:20:00',1.61),('15529','2014-04-13','16:25:00',1.57),('15529','2014-04-13','16:30:00',1.53),('15529','2014-04-13','16:35:00',1.48),('15529','2014-04-13','16:40:00',1.43),('15529','2014-04-13','16:45:00',1.4),('15529','2014-04-13','16:50:00',1.34),('15529','2014-04-13','16:55:00',1.29),('15529','2014-04-13','17:00:00',1.24),('15529','2014-04-13','17:05:00',1.19),('15529','2014-04-13','17:10:00',1.15),('15529','2014-04-13','17:15:00',1.1),('15529','2014-04-13','17:20:00',1.05),('15529','2013-09-27','09:15:00',1.04),('15529','2013-09-27','09:20:00',1.09),('15529','2013-09-27','09:25:00',1.14),('15529','2013-09-27','09:30:00',1.18),('15529','2013-09-27','09:35:00',1.06),('15529','2013-09-27','09:40:00',1.23),('15529','2013-09-27','09:45:00',1.27),('15529','2013-09-27','09:50:00',1.35),('15529','2013-09-27','10:00:00',1.45),('15529','2013-09-27','10:05:00',1),('15529','2013-09-27','10:10:00',1.65),('15529','2013-09-27','10:15:00',1.69),('15529','2013-09-27','10:20:00',1.8),('15529','2013-09-27','10:25:00',1.84),('15529','2013-09-27','10:30:00',1.52),('15529','2013-09-27','10:50:00',1.06),('15529','2013-09-27','10:55:00',1.4),('15529','2013-09-27','11:00:00',2.01),('15529','2013-09-27','11:05:00',1.49),('15529','2013-09-27','11:25:00',1.9),('15529','2013-09-27','11:30:00',2.09),('15529','2013-09-27','11:35:00',2.16),('15529','2013-09-27','11:40:00',2.21),('15529','2013-09-27','11:45:00',1.04),('15529','2013-09-27','11:50:00',1.85),('15529','2013-09-27','11:55:00',1.48),('15529','2013-09-27','12:00:00',2.17),('15529','2013-09-27','12:05:00',2.13),('15529','2013-09-27','12:10:00',1.99),('15529','2013-09-27','12:15:00',1.68),('15529','2013-09-27','12:30:00',1.2),('15529','2013-09-27','12:45:00',2.28),('15529','2013-09-27','12:50:00',1.4),('15529','2013-09-27','12:55:00',2.26),('15529','2013-09-27','13:00:00',2.17),('15529','2013-09-27','13:05:00',2.21),('15529','2013-09-27','13:10:00',2.03),('15529','2013-09-27','13:15:00',1.84),('15529','2013-09-27','13:20:00',2.08),('15529','2013-09-27','13:25:00',1.74),('15529','2013-09-27','13:30:00',1.42),('15529','2013-09-27','13:35:00',2.12),('15529','2013-09-27','13:40:00',2.32),('15529','2013-09-27','13:45:00',1.34),('15529','2013-09-27','13:50:00',1),('15529','2013-09-27','13:55:00',2.26),('15529','2013-09-27','14:00:00',2.25),('15529','2013-09-27','14:05:00',2.16),('15529','2013-09-27','14:10:00',2.15),('15529','2013-09-27','14:15:00',2.04),('15529','2013-09-27','14:20:00',2.07),('15529','2013-09-27','14:25:00',2.05),('15529','2013-09-27','14:30:00',2.05),('15529','2013-09-27','14:35:00',2.07),('15529','2013-09-27','14:40:00',2.02),('15529','2013-09-27','14:45:00',1.92),('15529','2013-09-27','14:50:00',1.87),('15529','2013-09-27','14:55:00',1.8),('15529','2013-09-27','15:00:00',1.78),('15529','2013-09-27','15:05:00',1.69),('15529','2013-09-27','15:10:00',1.71),('15529','2013-09-27','15:15:00',1.72),('15529','2013-09-27','15:20:00',1.66),('15529','2013-09-27','15:25:00',1.59),('15529','2013-09-27','15:30:00',1.58),('15529','2013-09-27','15:35:00',1.58),('15529','2013-09-27','15:40:00',1),('15529','2013-09-27','15:45:00',1.43),('15529','2013-09-27','15:50:00',1.45),('15529','2013-09-27','16:00:00',1.31),('15529','2013-09-27','16:05:00',1.11),('15529','2013-09-27','16:10:00',1.13),('15529','2013-09-27','16:15:00',1.11),('15529','2013-09-27','16:20:00',1.18),('15529','2013-09-27','16:25:00',1.11),('15529','2013-09-27','16:30:00',1.14),('15529','2013-09-27','16:35:00',1.08),('15529','2013-09-27','16:40:00',1.05),('15529','2013-09-26','09:55:00',1.11),('15529','2013-09-26','10:05:00',1.01),('15529','2013-09-26','10:10:00',1.12),('15529','2013-09-26','10:15:00',1.05),('15529','2013-09-26','10:40:00',1.07),('15529','2013-09-26','10:45:00',1.15),('15529','2013-09-26','10:50:00',1.82),('15529','2013-09-26','10:55:00',1.51),('15529','2013-09-26','11:00:00',1.77),('15529','2013-09-26','11:05:00',1.19),('15529','2013-09-26','11:10:00',1.9),('15529','2013-09-26','11:15:00',1.94),('15529','2013-09-26','11:30:00',1.06),('15529','2013-09-26','11:40:00',1.21),('15529','2013-09-26','11:45:00',1.62),('15529','2013-09-26','11:50:00',2.05),('15529','2013-09-26','12:40:00',1.21),('15529','2013-09-26','12:45:00',2.09),('15529','2013-09-26','12:50:00',2.08),('15529','2013-09-26','12:55:00',1.37),('15529','2013-09-26','13:00:00',2.05),('15529','2013-09-26','13:05:00',1.06),('15529','2013-09-26','13:15:00',1.26),('15529','2013-09-26','13:30:00',2.01),('15529','2013-09-26','13:35:00',2.28),('15529','2013-09-26','13:40:00',1.77),('15529','2013-09-26','13:50:00',2.39),('15529','2013-09-26','13:55:00',2.26),('15529','2013-09-26','14:00:00',2.11),('15529','2013-09-26','14:05:00',2.14),('15529','2013-09-26','14:10:00',2.13),('15529','2013-09-26','14:15:00',1.72),('15529','2013-09-26','14:20:00',1.75),('15529','2013-09-26','14:25:00',2.02),('15529','2013-09-26','14:30:00',1.91),('15529','2013-09-26','14:35:00',1.97),('15529','2013-09-26','14:40:00',1.99),('15529','2013-09-26','14:45:00',1.53),('15529','2013-09-26','14:50:00',1.09),('15529','2013-09-26','14:55:00',1.51),('15529','2013-09-26','15:00:00',1.92),('15529','2013-09-26','15:05:00',1.94),('15529','2013-09-26','15:10:00',1.65),('15529','2013-09-26','15:25:00',1.09),('15529','2013-09-26','15:45:00',1.56),('15529','2013-09-26','15:50:00',1.33),('15529','2013-09-26','16:10:00',1.44),('15529','2013-09-26','16:15:00',1.3),('15529','2013-09-26','16:20:00',1.28),('15529','2013-09-26','16:25:00',1.24),('15529','2013-09-26','16:30:00',1.17),('15529','2013-09-26','16:35:00',1.14),('15529','2013-09-26','16:45:00',1.03),('15529','2013-09-26','16:50:00',1),('15529','2013-09-25','09:00:00',1.03),('15529','2013-09-25','09:05:00',1.04),('15529','2013-09-25','09:10:00',1.06),('15529','2013-09-25','09:15:00',1.1),('15529','2013-09-25','09:20:00',1.13),('15529','2013-09-25','09:25:00',1.18),('15529','2013-09-25','09:30:00',1.24),('15529','2013-09-25','09:35:00',1.29),('15529','2013-09-25','09:40:00',1.33),('15529','2013-09-25','09:45:00',1.36),('15529','2013-09-25','09:50:00',1.4),('15529','2013-09-25','09:55:00',1.45),('15529','2013-09-25','10:00:00',1.48),('15529','2013-09-25','10:05:00',1.51),('15529','2013-09-25','10:10:00',1.52),('15529','2013-09-25','10:15:00',1.54),('15529','2013-09-25','10:20:00',1.59),('15529','2013-09-25','10:25:00',1.61),('15529','2013-09-25','10:30:00',1.64),('15529','2013-09-25','10:35:00',1.65),('15529','2013-09-25','10:40:00',1.69),('15529','2013-09-25','10:45:00',1.73),('15529','2013-09-25','10:50:00',1.76),('15529','2013-09-25','10:55:00',1.79),('15529','2013-09-25','11:00:00',1.8),('15529','2013-09-25','11:05:00',1.85),('15529','2013-09-25','11:10:00',1.85),('15529','2013-09-25','11:15:00',1.85),('15529','2013-09-25','11:20:00',1.79),('15529','2013-09-25','11:25:00',1.85),('15529','2013-09-25','11:30:00',1.72),('15529','2013-09-25','11:35:00',1.76),('15529','2013-09-25','11:40:00',2.05),('15529','2013-09-25','11:45:00',1.96),('15529','2013-09-25','11:50:00',1.69),('15529','2013-09-25','11:55:00',2.09),('15529','2013-09-25','12:00:00',1.81),('15529','2013-09-25','12:05:00',1.21),('15529','2013-09-25','12:20:00',1.02),('15529','2013-09-25','12:40:00',1.35),('15529','2013-09-25','12:45:00',1.29),('15529','2013-09-25','12:50:00',1.95),('15529','2013-09-25','12:55:00',2.27),('15529','2013-09-25','13:00:00',1.33),('15529','2013-09-25','13:05:00',1.47),('15529','2013-09-25','13:10:00',1.45),('15529','2013-09-25','13:15:00',1.99),('15529','2013-09-25','13:25:00',1.37),('15529','2013-09-25','13:30:00',1.69),('15529','2013-09-25','13:40:00',1.19),('15529','2013-09-25','13:45:00',1.19),('15529','2013-09-25','14:00:00',2.08),('15529','2013-09-25','14:05:00',1.53),('15529','2013-09-25','14:10:00',1.56),('15529','2013-09-25','14:25:00',1.56),('15529','2013-09-25','14:30:00',1.22),('15529','2013-09-25','14:35:00',1.61),('15529','2013-09-25','14:40:00',2.04),('15529','2013-09-25','14:45:00',2.02),('15529','2013-09-25','14:50:00',1.49),('15529','2013-09-25','14:55:00',1.7),('15529','2013-09-25','15:00:00',1.44),('15529','2013-09-25','15:15:00',1.89),('15529','2013-09-25','15:25:00',1.02),('15529','2013-09-25','15:30:00',1.14),('15529','2013-09-25','15:50:00',1.66),('15529','2013-09-25','15:55:00',1.14),('15529','2013-09-25','16:15:00',1.28),('15529','2013-09-25','16:20:00',1.17),('15529','2013-09-25','16:25:00',1.23),('15529','2013-09-25','16:30:00',1.19),('15529','2013-09-25','16:35:00',1.14),('15529','2013-09-25','16:40:00',1.07),('15529','2013-09-25','16:45:00',1.04),('15529','2013-09-24','09:30:00',1.26),('15529','2013-09-24','09:35:00',1.13),('15529','2013-09-24','10:00:00',1.63),('15529','2013-09-24','10:20:00',1.62),('15529','2013-09-24','10:25:00',1.9),('15529','2013-09-24','10:30:00',1.93),('15529','2013-09-24','10:35:00',1.89),('15529','2013-09-24','10:40:00',1.88),('15529','2013-09-24','11:00:00',1.8),('15529','2013-09-24','11:05:00',1.98),('15529','2013-09-24','11:10:00',1.93),('15529','2013-09-24','11:15:00',1.97),('15529','2013-09-24','11:20:00',2.04),('15529','2013-09-24','11:25:00',2.04),('15529','2013-09-24','11:30:00',1.79),('15529','2013-09-24','11:55:00',1.08),('15529','2013-09-24','12:00:00',2.11),('15529','2013-09-24','12:10:00',1.11),('15529','2013-09-24','12:15:00',1.86),('15529','2013-09-24','12:20:00',2.37),('15529','2013-09-24','12:25:00',1.58),('15529','2013-09-24','12:40:00',2.17),('15529','2013-09-24','12:45:00',1.03),('15529','2013-09-24','12:50:00',1.65),('15529','2013-09-24','12:55:00',1.91),('15529','2013-09-24','13:00:00',1.2),('15529','2013-09-24','13:10:00',1.1),('15529','2013-09-24','13:15:00',2.56),('15529','2013-09-24','13:20:00',2.49),('15529','2013-09-24','13:25:00',2.47),('15529','2013-09-24','13:30:00',2.36),('15529','2013-09-24','13:35:00',2.29),('15529','2013-09-24','13:40:00',2.23),('15529','2013-09-24','13:45:00',1.93),('15529','2013-09-24','13:50:00',1.2),('15529','2013-09-24','13:55:00',1.15),('15529','2013-09-24','14:00:00',1.1),('15529','2013-09-24','14:20:00',1.06),('15529','2013-09-24','14:30:00',2.27),('15529','2013-09-24','14:35:00',2.19),('15529','2013-09-24','14:40:00',1.19),('15529','2013-09-24','14:45:00',2.03),('15529','2013-09-24','14:50:00',2.23),('15529','2013-09-24','14:55:00',2.08),('15529','2013-09-24','15:00:00',1.99),('15529','2013-09-24','15:05:00',1.14),('15529','2013-09-24','15:10:00',1.72),('15529','2013-09-24','15:15:00',1.88),('15529','2013-09-24','15:20:00',1.77),('15529','2013-09-24','15:25:00',1.32),('15529','2013-09-24','15:35:00',1.7),('15529','2013-09-24','15:40:00',1.75),('15529','2013-09-24','15:50:00',1.59),('15529','2013-09-24','15:55:00',1.64),('15529','2013-09-24','16:00:00',1.56),('15529','2013-09-24','16:05:00',1.38),('15529','2013-09-24','16:10:00',1.46),('15529','2013-09-24','16:15:00',1.41),('15529','2013-09-24','16:20:00',1.37),('15529','2013-09-24','16:25:00',1.34),('15529','2013-09-24','16:30:00',1.27),('15529','2013-09-24','16:35:00',1.15),('15529','2013-09-24','16:40:00',1.17),('15529','2013-09-24','16:45:00',1.11),('15529','2013-09-24','16:50:00',1.05),('15529','2013-09-24','16:55:00',1.02),('15529','2013-09-23','09:00:00',1.03),('15529','2013-09-23','09:05:00',1.08),('15529','2013-09-23','09:10:00',1.12),('15529','2013-09-23','09:15:00',1.17),('15529','2013-09-23','09:20:00',1.22),('15529','2013-09-23','09:25:00',1.28),('15529','2013-09-23','09:30:00',1.31),('15529','2013-09-23','09:35:00',1.36),('15529','2013-09-23','09:40:00',1.4),('15529','2013-09-23','09:45:00',1.43),('15529','2013-09-23','09:50:00',1.47),('15529','2013-09-23','09:55:00',1.51),('15529','2013-09-23','10:00:00',1.54),('15529','2013-09-23','10:05:00',1.58),('15529','2013-09-23','10:10:00',1.61),('15529','2013-09-23','10:15:00',1.64),('15529','2013-09-23','10:20:00',1.68),('15529','2013-09-23','10:25:00',1.7),('15529','2013-09-23','10:30:00',1.73),('15529','2013-09-23','10:35:00',1.77),('15529','2013-09-23','10:40:00',1.8),('15529','2013-09-23','10:45:00',1.81),('15529','2013-09-23','10:50:00',1.83),('15529','2013-09-23','10:55:00',1.89),('15529','2013-09-23','11:00:00',1.88),('15529','2013-09-23','11:05:00',1.89),('15529','2013-09-23','11:10:00',1.93),('15529','2013-09-23','11:15:00',1.93),('15529','2013-09-23','11:20:00',1.98),('15529','2013-09-23','11:25:00',2),('15529','2013-09-23','11:30:00',2),('15529','2013-09-23','11:35:00',2.01),('15529','2013-09-23','11:40:00',2.06),('15529','2013-09-23','11:45:00',2.02),('15529','2013-09-23','11:50:00',2.03),('15529','2013-09-23','11:55:00',2.04),('15529','2013-09-23','12:00:00',2.07),('15529','2013-09-23','12:05:00',2.1),('15529','2013-09-23','12:10:00',2.13),('15529','2013-09-23','12:15:00',2.11),('15529','2013-09-23','12:20:00',2.13),('15529','2013-09-23','12:25:00',2.11),('15529','2013-09-23','12:30:00',2.14),('15529','2013-09-23','12:35:00',2.15),('15529','2013-09-23','12:40:00',2.15),('15529','2013-09-23','12:45:00',2.18),('15529','2013-09-23','12:50:00',2.2),('15529','2013-09-23','12:55:00',2.17),('15529','2013-09-23','13:00:00',2.19),('15529','2013-09-23','13:05:00',2.19),('15529','2013-09-23','13:10:00',2.18),('15529','2013-09-23','13:15:00',2.17),('15529','2013-09-23','13:20:00',2.15),('15529','2013-09-23','13:25:00',2.19),('15529','2013-09-23','13:30:00',2.17),('15529','2013-09-23','13:35:00',2.17),('15529','2013-09-23','13:40:00',2.13),('15529','2013-09-23','13:45:00',2.15),('15529','2013-09-23','13:50:00',2.13),('15529','2013-09-23','13:55:00',2.12),('15529','2013-09-23','14:00:00',2.12),('15529','2013-09-23','14:05:00',2.07),('15529','2013-09-23','14:10:00',2.07),('15529','2013-09-23','14:15:00',2.06),('15529','2013-09-23','14:20:00',2.02),('15529','2013-09-23','14:25:00',2.03),('15529','2013-09-23','14:30:00',2.01),('15529','2013-09-23','14:35:00',1.96),('15529','2013-09-23','14:40:00',1.95),('15529','2013-09-23','14:45:00',1.93),('15529','2013-09-23','14:50:00',1.93),('15529','2013-09-23','14:55:00',1.91),('15529','2013-09-23','15:00:00',1.87),('15529','2013-09-23','15:05:00',1.84),('15529','2013-09-23','15:10:00',1.82),('15529','2013-09-23','15:15:00',1.81),('15529','2013-09-23','15:20:00',1.8),('15529','2013-09-23','15:25:00',1.75),('15529','2013-09-23','15:30:00',1.72),('15529','2013-09-23','15:35:00',1.7),('15529','2013-09-23','15:40:00',1.66),('15529','2013-09-23','15:45:00',1.63),('15529','2013-09-23','15:50:00',1.59),('15529','2013-09-23','15:55:00',1.56),('15529','2013-09-23','16:00:00',1.52),('15529','2013-09-23','16:05:00',1.48),('15529','2013-09-23','16:10:00',1.45),('15529','2013-09-23','16:15:00',1.41),('15529','2013-09-23','16:20:00',1.37),('15529','2013-09-23','16:25:00',1.35),('15529','2013-09-23','16:30:00',1.29),('15529','2013-09-23','16:35:00',1.25),('15529','2013-09-23','16:40:00',1.19),('15529','2013-09-23','16:45:00',1.16),('15529','2013-09-23','16:50:00',1.09),('15529','2013-09-23','16:55:00',1.04),('15529','2013-09-22','09:00:00',1.05),('15529','2013-09-22','09:05:00',1.1),('15529','2013-09-22','09:10:00',1.14),('15529','2013-09-22','09:15:00',1.19),('15529','2013-09-22','09:20:00',1.24),('15529','2013-09-22','09:25:00',1.28),('15529','2013-09-22','09:30:00',1.32),('15529','2013-09-22','09:35:00',1.37),('15529','2013-09-22','09:40:00',1.4),('15529','2013-09-22','09:45:00',1.44),('15529','2013-09-22','09:50:00',1.48),('15529','2013-09-22','09:55:00',1.52),('15529','2013-09-22','10:00:00',1.56),('15529','2013-09-22','10:05:00',1.6),('15529','2013-09-22','10:10:00',1.63),('15529','2013-09-22','10:15:00',1.66),('15529','2013-09-22','10:20:00',1.7),('15529','2013-09-22','10:25:00',1.74),('15529','2013-09-22','10:30:00',1.75),('15529','2013-09-22','10:35:00',1.79),('15529','2013-09-22','10:40:00',1.83),('15529','2013-09-22','10:45:00',1.86),('15529','2013-09-22','10:50:00',1.87),('15529','2013-09-22','10:55:00',1.9),('15529','2013-09-22','11:00:00',1.92),('15529','2013-09-22','11:05:00',1.95),('15529','2013-09-22','11:10:00',1.98),('15529','2013-09-22','11:15:00',2),('15529','2013-09-22','11:20:00',2),('15529','2013-09-22','11:25:00',2.04),('15529','2013-09-22','11:30:00',2.05),('15529','2013-09-22','11:35:00',2.07),('15529','2013-09-22','11:40:00',2.08),('15529','2013-09-22','11:45:00',2.13),('15529','2013-09-22','11:50:00',2.13),('15529','2013-09-22','11:55:00',2.15),('15529','2013-09-22','12:00:00',2.17),('15529','2013-09-22','12:05:00',2.18),('15529','2013-09-22','12:10:00',2.17),('15529','2013-09-22','12:15:00',2.18),('15529','2013-09-22','12:20:00',2.2),('15529','2013-09-22','12:25:00',2.19),('15529','2013-09-22','12:30:00',2.22),('15529','2013-09-22','12:35:00',2.23),('15529','2013-09-22','12:40:00',2.23),('15529','2013-09-22','12:45:00',2.22),('15529','2013-09-22','12:50:00',2.22),('15529','2013-09-22','12:55:00',2.22),('15529','2013-09-22','13:00:00',2.22),('15529','2013-09-22','13:05:00',2.19),('15529','2013-09-22','13:10:00',2.18),('15529','2013-09-22','13:15:00',2.19),('15529','2013-09-22','13:20:00',2.17),('15529','2013-09-22','13:25:00',2.18),('15529','2013-09-22','13:30:00',2.18),('15529','2013-09-22','13:35:00',2.15),('15529','2013-09-22','13:40:00',2.13),('15529','2013-09-22','13:45:00',2.12),('15529','2013-09-22','13:50:00',2.14),('15529','2013-09-22','13:55:00',2.1),('15529','2013-09-22','14:00:00',2.08),('15529','2013-09-22','14:05:00',2.08),('15529','2013-09-22','14:10:00',2.07),('15529','2013-09-22','14:15:00',2.07),('15529','2013-09-22','14:20:00',2.07),('15529','2013-09-22','14:25:00',2.02),('15529','2013-09-22','14:30:00',1.68),('15529','2013-09-22','14:35:00',2),('15529','2013-09-22','14:40:00',1.98),('15529','2013-09-22','14:45:00',1.94),('15529','2013-09-22','14:50:00',1.91),('15529','2013-09-22','14:55:00',1.9),('15529','2013-09-22','15:00:00',1.88),('15529','2013-09-22','15:05:00',1.87),('15529','2013-09-22','15:10:00',1.85),('15529','2013-09-22','15:15:00',1.81),('15529','2013-09-22','15:20:00',1.77),('15529','2013-09-22','15:25:00',1.73),('15529','2013-09-22','15:30:00',1.7),('15529','2013-09-22','15:35:00',1.66),('15529','2013-09-22','15:40:00',1.65),('15529','2013-09-22','15:45:00',1.62),('15529','2013-09-22','15:50:00',1.56),('15529','2013-09-22','15:55:00',1.52),('15529','2013-09-22','16:00:00',1.49),('15529','2013-09-22','16:05:00',1.43),('15529','2013-09-22','16:10:00',1.2),('15529','2013-09-22','16:20:00',1.28),('15529','2013-09-22','16:25:00',1.28),('15529','2013-09-22','16:30:00',1.23),('15529','2013-09-22','16:35:00',1.2),('15529','2013-09-22','16:40:00',1.14),('15529','2013-09-22','16:45:00',1.09),('15529','2013-09-22','16:50:00',1.05),('15529','2013-09-22','16:55:00',1.01),('15529','2013-09-21','09:00:00',1.03),('15529','2013-09-21','09:05:00',1.08),('15529','2013-09-21','09:10:00',1.12),('15529','2013-09-21','09:15:00',1.18),('15529','2013-09-21','09:20:00',1.23),('15529','2013-09-21','09:25:00',1.27),('15529','2013-09-21','09:30:00',1.31),('15529','2013-09-21','09:35:00',1.37),('15529','2013-09-21','09:40:00',1.4),('15529','2013-09-21','09:45:00',1.44),('15529','2013-09-21','09:50:00',1.47),('15529','2013-09-21','09:55:00',1.51),('15529','2013-09-21','10:00:00',1.55),('15529','2013-09-21','10:05:00',1.6),('15529','2013-09-21','10:10:00',1.65),('15529','2013-09-21','10:15:00',1.68),('15529','2013-09-21','10:20:00',1.72),('15529','2013-09-21','10:25:00',1.75),('15529','2013-09-21','10:30:00',1.76),('15529','2013-09-21','10:35:00',1.81),('15529','2013-09-21','10:40:00',1.83),('15529','2013-09-21','10:45:00',1.85),('15529','2013-09-21','10:50:00',1.89),('15529','2013-09-21','10:55:00',1.9),('15529','2013-09-21','11:00:00',1.95),('15529','2013-09-21','11:05:00',1.95),('15529','2013-09-21','11:10:00',1.97),('15529','2013-09-21','11:15:00',2.01),('15529','2013-09-21','11:20:00',2),('15529','2013-09-21','11:25:00',2.04),('15529','2013-09-21','11:30:00',2.07),('15529','2013-09-21','11:35:00',2.07),('15529','2013-09-21','11:40:00',2.11),('15529','2013-09-21','11:45:00',2.12),('15529','2013-09-21','11:50:00',2.12),('15529','2013-09-21','11:55:00',2.14),('15529','2013-09-21','12:00:00',2.13),('15529','2013-09-21','12:05:00',2.17),('15529','2013-09-21','12:10:00',2.19),('15529','2013-09-21','12:15:00',2.19),('15529','2013-09-21','12:20:00',2.21),('15529','2013-09-21','12:25:00',2.21),('15529','2013-09-21','12:30:00',2.21),('15529','2013-09-21','12:35:00',2.21),('15529','2013-09-21','12:40:00',2.25),('15529','2013-09-21','12:45:00',2.26),('15529','2013-09-21','12:50:00',2.25),('15529','2013-09-21','12:55:00',2.24),('15529','2013-09-21','13:00:00',2.22),('15529','2013-09-21','13:05:00',2.23),('15529','2013-09-21','13:10:00',2.21),('15529','2013-09-21','13:15:00',2.24),('15529','2013-09-21','13:20:00',2.21),('15529','2013-09-21','13:25:00',2.21),('15529','2013-09-21','13:30:00',2.22),('15529','2013-09-21','13:35:00',2.17),('15529','2013-09-21','13:40:00',2.18),('15529','2013-09-21','13:45:00',2.15),('15529','2013-09-21','13:50:00',2.16),('15529','2013-09-21','13:55:00',2.16),('15529','2013-09-21','14:00:00',2.18),('15529','2013-09-21','14:05:00',2.18),('15529','2013-09-21','14:10:00',2.15),('15529','2013-09-21','14:15:00',1.92),('15529','2013-09-21','14:20:00',1.66),('15529','2013-09-21','14:25:00',1.44),('15529','2013-09-21','14:35:00',1.07),('15529','2013-09-21','14:40:00',2.14),('15529','2013-09-21','14:45:00',2.03),('15529','2013-09-21','14:50:00',1.97),('15529','2013-09-21','14:55:00',1.99),('15529','2013-09-21','15:00:00',2),('15529','2013-09-21','15:05:00',2.01),('15529','2013-09-21','15:10:00',1.97),('15529','2013-09-21','15:15:00',1.35),('15529','2013-09-21','15:20:00',1.91),('15529','2013-09-21','15:25:00',2.02),('15529','2013-09-21','15:35:00',1.59),('15529','2013-09-21','15:40:00',1.87),('15529','2013-09-21','15:45:00',1.7),('15529','2013-09-21','15:50:00',1.61),('15529','2013-09-21','15:55:00',1.6),('15529','2013-09-21','16:00:00',1.63),('15529','2013-09-21','16:05:00',1.66),('15529','2013-09-21','16:10:00',1.57),('15529','2013-09-21','16:15:00',1.62),('15529','2013-09-21','16:20:00',1.32),('15529','2013-09-21','16:55:00',1.07),('15529','2013-09-21','17:00:00',1.15),('15529','2013-09-21','17:05:00',1.06),('15529','2013-09-20','09:00:00',1.01),('15529','2013-09-20','09:05:00',1.06),('15529','2013-09-20','09:10:00',1.11),('15529','2013-09-20','09:15:00',1.16),('15529','2013-09-20','09:20:00',1.21),('15529','2013-09-20','09:25:00',1.25),('15529','2013-09-20','09:30:00',1.29),('15529','2013-09-20','09:35:00',1.33),('15529','2013-09-20','09:40:00',1.36),('15529','2013-09-20','09:45:00',1.42),('15529','2013-09-20','09:50:00',1.45),('15529','2013-09-20','09:55:00',1.49),('15529','2013-09-20','10:00:00',1.53),('15529','2013-09-20','10:05:00',1.57),('15529','2013-09-20','10:10:00',1.6),('15529','2013-09-20','10:15:00',1.62),('15529','2013-09-20','10:20:00',1.66),('15529','2013-09-20','10:25:00',1.7),('15529','2013-09-20','10:30:00',1.72),('15529','2013-09-20','10:35:00',1.75),('15529','2013-09-20','10:40:00',1.78),('15529','2013-09-20','10:45:00',1.77),('15529','2013-09-20','10:50:00',1.83),('15529','2013-09-20','10:55:00',1.87),('15529','2013-09-20','11:00:00',1.88),('15529','2013-09-20','11:05:00',1.91),('15529','2013-09-20','11:10:00',1.93),('15529','2013-09-20','11:15:00',1.96),('15529','2013-09-20','11:20:00',1.98),('15529','2013-09-20','11:25:00',2),('15529','2013-09-20','11:30:00',2.04),('15529','2013-09-20','11:35:00',2.04),('15529','2013-09-20','11:40:00',2.05),('15529','2013-09-20','11:45:00',2.09),('15529','2013-09-20','11:50:00',2.08),('15529','2013-09-20','11:55:00',2.08),('15529','2013-09-20','12:00:00',2.13),('15529','2013-09-20','12:05:00',2.12),('15529','2013-09-20','12:10:00',2.16),('15529','2013-09-20','12:15:00',2.17),('15529','2013-09-20','12:20:00',1.98),('15529','2013-09-20','12:25:00',2.15),('15529','2013-09-20','12:30:00',2.24),('15529','2013-09-20','12:35:00',2.16),('15529','2013-09-20','12:40:00',2.14),('15529','2013-09-20','12:45:00',2.16),('15529','2013-09-20','12:50:00',2.16),('15529','2013-09-20','12:55:00',2.22),('15529','2013-09-20','13:00:00',2.18),('15529','2013-09-20','13:05:00',2.14),('15529','2013-09-20','13:10:00',2.19),('15529','2013-09-20','13:15:00',2.19),('15529','2013-09-20','13:20:00',1.92),('15529','2013-09-20','13:25:00',2.09),('15529','2013-09-20','13:30:00',2.1),('15529','2013-09-20','13:35:00',2.08),('15529','2013-09-20','13:40:00',1.9),('15529','2013-09-20','13:45:00',1.88),('15529','2013-09-20','13:50:00',1.96),('15529','2013-09-20','13:55:00',1.79),('15529','2013-09-20','14:00:00',2.13),('15529','2013-09-20','14:05:00',2.02),('15529','2013-09-20','14:10:00',2.04),('15529','2013-09-20','14:15:00',2.11),('15529','2013-09-20','14:20:00',2.08),('15529','2013-09-20','14:25:00',2.03),('15529','2013-09-20','14:30:00',2.02),('15529','2013-09-20','14:35:00',2.01),('15529','2013-09-20','14:40:00',1.97),('15529','2013-09-20','14:45:00',1.97),('15529','2013-09-20','14:50:00',1.92),('15529','2013-09-20','14:55:00',1.92),('15529','2013-09-20','15:00:00',1.89),('15529','2013-09-20','15:05:00',1.87),('15529','2013-09-20','15:10:00',1.79),('15529','2013-09-20','15:15:00',1.8),('15529','2013-09-20','15:20:00',1.78),('15529','2013-09-20','15:25:00',1.75),('15529','2013-09-20','15:30:00',1.73),('15529','2013-09-20','15:35:00',1.68),('15529','2013-09-20','15:40:00',1.48),('15529','2013-09-20','15:45:00',1.35),('15529','2013-09-20','15:50:00',1.56),('15529','2013-09-20','15:55:00',1.37),('15529','2013-09-19','10:05:00',1.04),('15529','2013-09-19','10:10:00',1.2),('15529','2013-09-19','10:15:00',1.35),('15529','2013-09-19','10:20:00',1.07),('15529','2013-09-19','10:30:00',1.02),('15529','2013-09-19','10:35:00',1.18),('15529','2013-09-19','10:40:00',1.19),('15529','2013-09-19','10:45:00',1.12),('15529','2013-09-19','10:50:00',1.01),('15529','2013-09-19','10:55:00',1.02),('15529','2013-09-19','11:00:00',1.11),('15529','2013-09-19','11:05:00',1.03),('15529','2013-09-19','11:10:00',1.07),('15529','2013-09-19','11:15:00',1.51),('15529','2013-09-19','11:20:00',1.68),('15529','2013-09-19','11:25:00',2.4),('15529','2013-09-19','11:30:00',2.01),('15529','2013-09-19','11:35:00',1.59),('15529','2013-09-19','11:40:00',2.3),('15529','2013-09-19','11:45:00',2.32),('15529','2013-09-19','11:50:00',2.26),('15529','2013-09-19','11:55:00',2.15),('15529','2013-09-19','12:00:00',2.1),('15529','2013-09-19','12:05:00',2.11),('15529','2013-09-19','12:10:00',2.21),('15529','2013-09-19','12:15:00',2.3),('15529','2013-09-19','12:20:00',1.63),('15529','2013-09-19','12:25:00',2.11),('15529','2013-09-19','12:30:00',1.89),('15529','2013-09-19','12:35:00',1.95),('15529','2013-09-19','12:40:00',2.1),('15529','2013-09-19','12:45:00',2.33),('15529','2013-09-19','12:50:00',2.04),('15529','2013-09-19','12:55:00',1.4),('15529','2013-09-19','13:00:00',2.27),('15529','2013-09-19','13:05:00',2.16),('15529','2013-09-19','13:10:00',2.24),('15529','2013-09-19','13:15:00',2.29),('15529','2013-09-19','13:20:00',2.24),('15529','2013-09-19','13:25:00',2.18),('15529','2013-09-19','13:30:00',1.96),('15529','2013-09-19','13:35:00',2.18),('15529','2013-09-19','13:40:00',2.25),('15529','2013-09-19','13:45:00',2.19),('15529','2013-09-19','13:50:00',1.8),('15529','2013-09-19','13:55:00',2.08),('15529','2013-09-19','14:00:00',2.16),('15529','2013-09-19','14:05:00',2.22),('15529','2013-09-19','14:10:00',2.06),('15529','2013-09-19','14:15:00',1.06),('15529','2013-09-19','14:20:00',1.3),('15529','2013-09-19','14:45:00',1.48),('15529','2013-09-19','14:50:00',1.94),('15529','2013-09-19','14:55:00',1.92),('15529','2013-09-19','15:00:00',1.98),('15529','2013-09-19','15:05:00',1.52),('15529','2013-09-19','15:10:00',1.56),('15529','2013-09-19','15:15:00',2.05),('15529','2013-09-19','15:20:00',1.78),('15529','2013-09-19','15:30:00',1.03),('15529','2013-09-19','15:35:00',1.2),('15529','2013-09-19','15:40:00',1.88),('15529','2013-09-19','15:45:00',1.76),('15529','2013-09-19','15:50:00',1.4),('15529','2013-09-19','15:55:00',1.48),('15529','2013-09-19','16:00:00',1.72),('15529','2013-09-19','16:05:00',1.55),('15529','2013-09-19','16:15:00',1.39),('15529','2013-09-19','16:20:00',1.53),('15529','2013-09-19','16:25:00',1.04),('15529','2013-09-19','16:45:00',1.29),('15529','2013-09-19','16:50:00',1.35),('15529','2013-09-19','16:55:00',1.21),('15529','2013-09-19','17:00:00',1.12),('15529','2013-09-18','09:10:00',1.1),('15529','2013-09-18','09:15:00',1.09),('15529','2013-09-18','10:05:00',1.15),('15529','2013-09-18','10:25:00',1.16),('15529','2013-09-18','10:30:00',1.19),('15529','2013-09-18','10:40:00',1.44),('15529','2013-09-18','10:50:00',2.04),('15529','2013-09-18','10:55:00',1.72),('15529','2013-09-18','11:00:00',1.14),('15529','2013-09-18','11:10:00',1.31),('15529','2013-09-18','11:15:00',2.16),('15529','2013-09-18','11:20:00',2.23),('15529','2013-09-18','11:25:00',1.75),('15529','2013-09-18','11:30:00',1.93),('15529','2013-09-18','11:35:00',1.23),('15529','2013-09-18','11:40:00',1.21),('15529','2013-09-18','11:45:00',2.26),('15529','2013-09-18','11:50:00',1.68),('15529','2013-09-18','11:55:00',1.93),('15529','2013-09-18','12:00:00',1.35),('15529','2013-09-18','12:05:00',1.73),('15529','2013-09-18','12:10:00',1.56),('15529','2013-09-18','12:15:00',2.46),('15529','2013-09-18','12:20:00',2.38),('15529','2013-09-18','12:25:00',2.33),('15529','2013-09-18','12:30:00',2.09),('15529','2013-09-18','12:35:00',1.67),('15529','2013-09-18','12:40:00',1.53),('15529','2013-09-18','12:45:00',2.43),('15529','2013-09-18','12:50:00',2.37),('15529','2013-09-18','12:55:00',2.41),('15529','2013-09-18','13:00:00',2.43),('15529','2013-09-18','13:05:00',2.54),('15529','2013-09-18','13:10:00',1.95),('15529','2013-09-18','13:15:00',1.46),('15529','2013-09-18','13:20:00',1.04),('15529','2013-09-18','13:25:00',2.35),('15529','2013-09-18','13:30:00',2.36),('15529','2013-09-18','13:35:00',2.41),('15529','2013-09-18','13:40:00',2.53),('15529','2013-09-18','13:45:00',2.39),('15529','2013-09-18','14:00:00',1.78),('15529','2013-09-18','14:05:00',2.11),('15529','2013-09-18','14:10:00',2.02),('15529','2013-09-18','14:15:00',2.06),('15529','2013-09-18','14:20:00',2.05),('15529','2013-09-18','14:25:00',2.12),('15529','2013-09-18','14:30:00',2.08),('15529','2013-09-18','14:35:00',2.07),('15529','2013-09-18','14:40:00',1.91),('15529','2013-09-18','14:45:00',2.03),('15529','2013-09-18','14:50:00',2.03),('15529','2013-09-18','14:55:00',1.86),('15529','2013-09-18','15:00:00',1.46),('15529','2013-09-18','15:05:00',1.66),('15529','2013-09-18','15:10:00',1.98),('15529','2013-09-18','15:15:00',1.79),('15529','2013-09-18','15:20:00',1.81),('15529','2013-09-18','15:25:00',1.29),('15529','2013-09-18','15:30:00',1.16),('15529','2013-09-18','15:35:00',1.84),('15529','2013-09-18','15:40:00',1.56),('15529','2013-09-18','15:45:00',1.78),('15529','2013-09-18','15:50:00',1.64),('15529','2013-09-18','15:55:00',1.37),('15529','2013-09-18','16:00:00',1.6),('15529','2013-09-18','16:10:00',1.47),('15529','2013-09-18','16:15:00',1.41),('15529','2013-09-18','16:25:00',1.22),('15529','2013-09-18','16:40:00',1.19),('15529','2013-09-18','16:50:00',1.1),('15529','2013-09-18','16:55:00',1.03),('15529','2014-04-12','09:55:00',1.03),('15529','2014-04-12','10:00:00',1.35),('15529','2014-04-12','10:05:00',1.39),('15529','2014-04-12','10:10:00',1.23),('15529','2014-04-12','10:15:00',1.47),('15529','2014-04-12','10:20:00',1.27),('15529','2014-04-12','10:25:00',1.08),('15529','2014-04-12','10:30:00',1.52),('15529','2014-04-12','10:35:00',1.95),('15529','2014-04-12','10:40:00',1.94),('15529','2014-04-12','10:45:00',1.92),('15529','2014-04-12','10:50:00',2.04),('15529','2014-04-12','10:55:00',2.07),('15529','2014-04-12','11:00:00',2.11),('15529','2014-04-12','11:05:00',2.18),('15529','2014-04-12','11:10:00',2.16),('15529','2014-04-12','11:15:00',2.21),('15529','2014-04-12','11:20:00',1.92),('15529','2014-04-12','11:25:00',1.69),('15529','2014-04-12','11:30:00',2.24),('15529','2014-04-12','11:35:00',1.74),('15529','2014-04-12','11:40:00',2.27),('15529','2014-04-12','11:45:00',2.11),('15529','2014-04-12','11:50:00',1.72),('15529','2014-04-12','11:55:00',1.06),('15529','2014-04-12','12:00:00',1.48),('15529','2014-04-12','13:10:00',1.08),('15529','2014-04-12','13:15:00',1.58),('15529','2014-04-12','13:20:00',2.25),('15529','2014-04-12','13:25:00',2.39),('15529','2014-04-12','13:30:00',2.26),('15529','2014-04-12','13:35:00',2.26),('15529','2014-04-12','13:40:00',1.98),('15529','2014-04-12','13:45:00',1.07),('15529','2014-04-12','13:50:00',2.06),('15529','2014-04-12','13:55:00',2.07),('15529','2014-04-12','14:00:00',2.13),('15529','2014-04-12','14:05:00',2.31),('15529','2014-04-12','14:10:00',2.09),('15529','2014-04-12','14:15:00',1.46),('15529','2014-04-12','14:45:00',1.25),('15529','2014-04-12','14:50:00',2.27),('15529','2014-04-12','14:55:00',2.02),('15529','2014-04-12','15:00:00',1.6),('15529','2014-04-12','15:05:00',2.15),('15529','2014-04-12','15:10:00',2.04),('15529','2014-04-12','15:15:00',1.68),('15529','2014-04-12','15:20:00',1.85),('15529','2014-04-12','15:25:00',2),('15529','2014-04-12','15:30:00',1.61),('15529','2014-04-12','15:40:00',1.18),('15529','2014-04-12','15:45:00',1.01),('15529','2014-04-12','15:55:00',1.27),('15529','2014-04-12','16:00:00',1.72),('15529','2014-04-12','16:25:00',1.06),('15529','2014-04-12','16:40:00',1.41),('15529','2014-04-12','16:45:00',1.15),('15529','2014-04-12','16:55:00',1.18),('15529','2013-09-17','09:35:00',1.15),('15529','2013-09-17','09:45:00',1.45),('15529','2013-09-17','10:05:00',1.2),('15529','2013-09-17','10:10:00',1.61),('15529','2013-09-17','10:15:00',1.65),('15529','2013-09-17','10:20:00',1.67),('15529','2013-09-17','10:25:00',1.7),('15529','2013-09-17','10:30:00',1.71),('15529','2013-09-17','10:35:00',1.74),('15529','2013-09-17','10:40:00',1.79),('15529','2013-09-17','10:45:00',1.81),('15529','2013-09-17','10:50:00',1.86),('15529','2013-09-17','10:55:00',1.9),('15529','2013-09-17','11:00:00',1.99),('15529','2013-09-17','11:05:00',1.98),('15529','2013-09-17','11:10:00',2.06),('15529','2013-09-17','11:15:00',2.05),('15529','2013-09-17','11:20:00',1.95),('15529','2013-09-17','11:25:00',1.99),('15529','2013-09-17','11:30:00',1.72),('15529','2013-09-17','11:35:00',1.82),('15529','2013-09-17','11:40:00',2.14),('15529','2013-09-17','11:45:00',2.12),('15529','2013-09-17','11:50:00',2.11),('15529','2013-09-17','11:55:00',2.12),('15529','2013-09-17','12:00:00',2.16),('15529','2013-09-17','12:05:00',2.27),('15529','2013-09-17','12:10:00',1.47),('15529','2013-09-17','12:25:00',1.95),('15529','2013-09-17','12:35:00',1.52),('15529','2013-09-17','12:40:00',1.02),('15529','2013-09-17','12:45:00',2.23),('15529','2013-09-17','12:50:00',1.39),('15529','2013-09-17','12:55:00',1.96),('15529','2013-09-17','13:00:00',2.48),('15529','2013-09-17','13:05:00',2.39),('15529','2013-09-17','13:10:00',2.35),('15529','2013-09-17','13:15:00',2.3),('15529','2013-09-17','13:20:00',2.3),('15529','2013-09-17','13:25:00',2.39),('15529','2013-09-17','13:30:00',2.39),('15529','2013-09-17','13:35:00',1.9),('15529','2013-09-17','13:40:00',2.16),('15529','2013-09-17','13:45:00',1.98),('15529','2013-09-17','13:50:00',1.27),('15529','2013-09-17','13:55:00',1.73),('15529','2013-09-17','14:00:00',2.08),('15529','2013-09-17','14:05:00',2.14),('15529','2013-09-17','14:10:00',2.28),('15529','2013-09-17','14:15:00',2.08),('15529','2013-09-17','14:20:00',2.15),('15529','2013-09-17','14:25:00',2.15),('15529','2013-09-17','14:30:00',1.85),('15529','2013-09-17','14:35:00',2.11),('15529','2013-09-17','14:40:00',2.11),('15529','2013-09-17','14:45:00',1.25),('15529','2013-09-17','14:50:00',2.11),('15529','2013-09-17','14:55:00',2.07),('15529','2013-09-17','15:00:00',2.03),('15529','2013-09-17','15:05:00',1.12),('15529','2013-09-17','15:10:00',2.02),('15529','2013-09-17','15:15:00',1.36),('15529','2013-09-17','15:20:00',1.99),('15529','2013-09-17','15:25:00',1.96),('15529','2013-09-17','15:30:00',1.69),('15529','2013-09-17','15:35:00',1.64),('15529','2013-09-17','15:40:00',1.39),('15529','2013-09-17','15:45:00',1.67),('15529','2013-09-17','15:50:00',1.63),('15529','2013-09-17','15:55:00',1.68),('15529','2013-09-17','16:00:00',1.45),('15529','2013-09-17','16:05:00',1.6),('15529','2013-09-17','16:10:00',1.4),('15529','2013-09-17','16:15:00',1.41),('15529','2013-09-17','16:20:00',1.39),('15529','2013-09-17','16:25:00',1.28),('15529','2013-09-17','16:30:00',1.19),('15529','2013-09-17','16:35:00',1.11),('15529','2013-09-17','16:40:00',1.21),('15529','2013-09-17','16:45:00',1.15),('15529','2013-09-17','16:50:00',1),('15529','2013-09-17','17:00:00',1.05),('15529','2013-09-16','09:45:00',1.11),('15529','2013-09-16','09:55:00',1.17),('15529','2013-09-16','10:05:00',1.42),('15529','2013-09-16','10:45:00',2.07),('15529','2013-09-16','10:50:00',2.11),('15529','2013-09-16','10:55:00',1.59),('15529','2013-09-16','11:00:00',1.15),('15529','2013-09-16','11:05:00',1.27),('15529','2013-09-16','11:10:00',2.01),('15529','2013-09-16','11:15:00',1.42),('15529','2013-09-16','11:20:00',1.26),('15529','2013-09-16','11:30:00',1.12),('15529','2013-09-16','11:35:00',1.74),('15529','2013-09-16','11:40:00',1.66),('15529','2013-09-16','11:45:00',1.4),('15529','2013-09-16','11:50:00',1.46),('15529','2013-09-16','11:55:00',2.05),('15529','2013-09-16','12:00:00',1.98),('15529','2013-09-16','12:05:00',2.13),('15529','2013-09-16','12:10:00',1.1),('15529','2013-09-16','12:15:00',1.48),('15529','2013-09-16','12:20:00',1.91),('15529','2013-09-16','12:25:00',2.01),('15529','2013-09-16','12:30:00',1.03),('15529','2013-09-16','12:35:00',1.25),('15529','2013-09-16','12:40:00',2.02),('15529','2013-09-16','12:45:00',2),('15529','2013-09-16','12:50:00',1.11),('15529','2013-09-16','12:55:00',2.04),('15529','2013-09-16','13:00:00',1),('15529','2013-09-16','13:10:00',2.13),('15529','2013-09-16','13:15:00',1.25),('15529','2013-09-16','13:20:00',1.14),('15529','2013-09-16','13:25:00',1.23),('15529','2013-09-16','13:30:00',1.05),('15529','2013-09-16','13:35:00',1.33),('15529','2013-09-16','14:50:00',1.09),('15529','2013-09-16','14:55:00',2.01),('15529','2013-09-16','15:00:00',1.81),('15529','2013-09-16','15:05:00',1.36),('15529','2013-09-16','15:10:00',1.45),('15529','2013-09-16','15:15:00',1.67),('15529','2013-09-16','15:20:00',1.66),('15529','2013-09-16','15:25:00',1.47),('15529','2013-09-16','15:50:00',1.07),('15529','2013-09-16','17:05:00',1.03),('15529','2013-09-15','09:15:00',1.16),('15529','2013-09-15','09:20:00',1.08),('15529','2013-09-15','09:30:00',1.32),('15529','2013-09-15','09:35:00',1.36),('15529','2013-09-15','09:40:00',1.39),('15529','2013-09-15','09:45:00',1.44),('15529','2013-09-15','09:50:00',1.49),('15529','2013-09-15','09:55:00',1.56),('15529','2013-09-15','10:00:00',1.61),('15529','2013-09-15','10:10:00',1.05),('15529','2013-09-15','10:15:00',1.4),('15529','2013-09-15','10:20:00',1.4),('15529','2013-09-15','10:25:00',1.82),('15529','2013-09-15','10:30:00',1.85),('15529','2013-09-15','10:35:00',1.98),('15529','2013-09-15','10:40:00',2.06),('15529','2013-09-15','10:45:00',2.17),('15529','2013-09-15','10:55:00',1.48),('15529','2013-09-15','11:15:00',1.76),('15529','2013-09-15','11:20:00',2.11),('15529','2013-09-15','11:25:00',2.25),('15529','2013-09-15','11:30:00',2.33),('15529','2013-09-15','11:35:00',2.18),('15529','2013-09-15','11:40:00',2.05),('15529','2013-09-15','11:45:00',2.22),('15529','2013-09-15','11:50:00',2.23),('15529','2013-09-15','11:55:00',2.27),('15529','2013-09-15','12:00:00',2.15),('15529','2013-09-15','12:05:00',1.87),('15529','2013-09-15','12:10:00',2.5),('15529','2013-09-15','12:15:00',2.3),('15529','2013-09-15','12:20:00',2.11),('15529','2013-09-15','12:25:00',2.32),('15529','2013-09-15','12:30:00',2.32),('15529','2013-09-15','12:35:00',2.29),('15529','2013-09-15','12:40:00',2.44),('15529','2013-09-15','12:45:00',2.47),('15529','2013-09-15','12:50:00',2.53),('15529','2013-09-15','12:55:00',1.83),('15529','2013-09-15','13:00:00',2.68),('15529','2013-09-15','13:05:00',2.44),('15529','2013-09-15','13:10:00',2.33),('15529','2013-09-15','13:15:00',2.3),('15529','2013-09-15','13:20:00',2.28),('15529','2013-09-15','13:25:00',2.28),('15529','2013-09-15','13:30:00',2.26),('15529','2013-09-15','13:35:00',2.27),('15529','2013-09-15','13:40:00',2.29),('15529','2013-09-15','13:45:00',2.3),('15529','2013-09-15','13:50:00',2.33),('15529','2013-09-15','13:55:00',2.26),('15529','2013-09-15','14:00:00',2.13),('15529','2013-09-15','14:05:00',2.16),('15529','2013-09-15','14:10:00',2.2),('15529','2013-09-15','14:15:00',2.2),('15529','2013-09-15','14:20:00',2.15),('15529','2013-09-15','14:25:00',2.12),('15529','2013-09-15','14:30:00',2.12),('15529','2013-09-15','14:35:00',2.1),('15529','2013-09-15','14:40:00',2.07),('15529','2013-09-15','14:45:00',2.05),('15529','2013-09-15','14:50:00',2),('15529','2013-09-15','14:55:00',2),('15529','2013-09-15','15:00:00',1.98),('15529','2013-09-15','15:05:00',1.97),('15529','2013-09-15','15:10:00',1.94),('15529','2013-09-15','15:15:00',1.92),('15529','2013-09-15','15:20:00',1.87),('15529','2013-09-15','15:25:00',1.85),('15529','2013-09-15','15:30:00',1.82),('15529','2013-09-15','15:35:00',1.78),('15529','2013-09-15','15:40:00',1.76),('15529','2013-09-15','15:45:00',1.72),('15529','2013-09-15','15:50:00',1.68),('15529','2013-09-15','15:55:00',1.41),('15529','2013-09-15','16:00:00',1.09),('15529','2013-09-15','16:05:00',1.64),('15529','2013-09-15','16:10:00',1.54),('15529','2013-09-15','16:15:00',1.49),('15529','2013-09-15','16:20:00',1.46),('15529','2013-09-15','16:25:00',1.42),('15529','2013-09-15','16:30:00',1.37),('15529','2013-09-15','16:35:00',1.33),('15529','2013-09-15','16:40:00',1.29),('15529','2013-09-15','16:45:00',1.25),('15529','2013-09-15','16:50:00',1.19),('15529','2013-09-15','16:55:00',1.15),('15529','2013-09-15','17:00:00',1.09),('15529','2013-09-15','17:05:00',1.04),('15529','2013-09-14','09:05:00',1.03),('15529','2013-09-14','09:10:00',1.13),('15529','2013-09-14','09:15:00',1.22),('15529','2013-09-14','09:20:00',1.19),('15529','2013-09-14','09:25:00',1.27),('15529','2013-09-14','09:30:00',1.27),('15529','2013-09-14','09:35:00',1.35),('15529','2013-09-14','09:40:00',1.39),('15529','2013-09-14','09:45:00',1.43),('15529','2013-09-14','09:50:00',1.43),('15529','2013-09-14','09:55:00',1.53),('15529','2013-09-14','10:00:00',1.54),('15529','2013-09-14','10:05:00',1.6),('15529','2013-09-14','10:10:00',1.58),('15529','2013-09-14','10:15:00',1.62),('15529','2013-09-14','10:20:00',1.66),('15529','2013-09-14','10:25:00',1.67),('15529','2013-09-14','10:30:00',1.43),('15529','2013-09-14','10:35:00',1.64),('15529','2013-09-14','10:40:00',1.91),('15529','2013-09-14','10:45:00',1.89),('15529','2013-09-14','10:50:00',2.08),('15529','2013-09-14','10:55:00',1.9),('15529','2013-09-14','11:00:00',1.43),('15529','2013-09-14','11:05:00',1.17),('15529','2013-09-14','11:10:00',1.87),('15529','2013-09-14','11:15:00',2.03),('15529','2013-09-14','11:20:00',2.16),('15529','2013-09-14','11:25:00',1.64),('15529','2013-09-14','11:35:00',1.96),('15529','2013-09-14','11:40:00',2.44),('15529','2013-09-14','11:45:00',2.39),('15529','2013-09-14','12:25:00',1.11),('15529','2013-09-14','13:20:00',1.21),('15529','2013-09-14','13:45:00',1.02),('15529','2013-09-14','13:50:00',1.07),('15529','2013-09-14','14:00:00',1.16),('15529','2013-09-14','15:15:00',1.33),('15529','2013-09-13','09:00:00',1.02),('15529','2013-09-13','09:05:00',1.07),('15529','2013-09-13','09:10:00',1.11),('15529','2013-09-13','09:15:00',1.17),('15529','2013-09-13','09:20:00',1.21),('15529','2013-09-13','09:25:00',1.26),('15529','2013-09-13','09:30:00',1.31),('15529','2013-09-13','09:35:00',1.35),('15529','2013-09-13','09:40:00',1.38),('15529','2013-09-13','09:45:00',1.43),('15529','2013-09-13','09:50:00',1.45),('15529','2013-09-13','09:55:00',1.5),('15529','2013-09-13','10:00:00',1.52),('15529','2013-09-13','10:05:00',1.51),('15529','2013-09-13','10:10:00',1.48),('15529','2013-09-13','10:15:00',1.52),('15529','2013-09-13','10:20:00',1.58),('15529','2013-09-13','10:25:00',1.7),('15529','2013-09-13','10:30:00',1.5),('15529','2013-09-13','10:35:00',1.1),('15529','2013-09-13','10:40:00',1.82),('15529','2013-09-13','11:00:00',2.01),('15529','2013-09-13','11:05:00',1.85),('15529','2013-09-13','11:10:00',1.89),('15529','2013-09-13','11:15:00',2),('15529','2013-09-13','11:20:00',1.82),('15529','2013-09-13','11:25:00',2.1),('15529','2013-09-13','11:30:00',2.1),('15529','2013-09-13','11:35:00',1.92),('15529','2013-09-13','11:40:00',2.2),('15529','2013-09-13','11:45:00',1.71),('15529','2013-09-13','12:00:00',1.15),('15529','2013-09-13','12:05:00',1.44),('15529','2013-09-13','12:10:00',1.71),('15529','2013-09-13','12:15:00',1.51),('15529','2013-09-13','12:25:00',2.17),('15529','2013-09-13','12:30:00',1.42),('15529','2013-09-13','12:40:00',2.24),('15529','2013-09-13','12:45:00',1.16),('15529','2013-09-13','12:50:00',2.38),('15529','2013-09-13','12:55:00',2.4),('15529','2013-09-13','13:00:00',1.37),('15529','2013-09-13','13:05:00',2.39),('15529','2013-09-13','13:10:00',2.39),('15529','2013-09-13','13:15:00',2.36),('15529','2013-09-13','13:20:00',2.19),('15529','2013-09-13','13:25:00',2.26),('15529','2013-09-13','13:30:00',2.07),('15529','2013-09-13','13:35:00',1.21),('15529','2013-09-13','13:40:00',1.09),('15529','2013-09-13','13:45:00',1.64),('15529','2013-09-13','13:50:00',2.41),('15529','2013-09-13','13:55:00',2.38),('15529','2013-09-13','14:00:00',2.29),('15529','2013-09-13','14:05:00',2.18),('15529','2013-09-13','14:10:00',2.14),('15529','2013-09-13','14:15:00',2.12),('15529','2013-09-13','14:20:00',2.12),('15529','2013-09-13','14:25:00',2.1),('15529','2013-09-13','14:30:00',2.09),('15529','2013-09-13','14:35:00',2.07),('15529','2013-09-13','14:40:00',2.05),('15529','2013-09-13','14:45:00',2.03),('15529','2013-09-13','14:50:00',2.02),('15529','2013-09-13','14:55:00',1.99),('15529','2013-09-13','15:00:00',1.98),('15529','2013-09-13','15:05:00',1.93),('15529','2013-09-13','15:10:00',1.9),('15529','2013-09-13','15:15:00',1.89),('15529','2013-09-13','15:20:00',1.87),('15529','2013-09-13','15:25:00',1.83),('15529','2013-09-13','15:30:00',1.8),('15529','2013-09-13','15:35:00',1.77),('15529','2013-09-13','15:40:00',1.72),('15529','2013-09-13','15:45:00',1.7),('15529','2013-09-13','15:50:00',1.68),('15529','2013-09-13','15:55:00',1.64),('15529','2013-09-13','16:00:00',1.59),('15529','2013-09-13','16:05:00',1.54),('15529','2013-09-13','16:10:00',1.52),('15529','2013-09-13','16:15:00',1.46),('15529','2013-09-13','16:20:00',1.44),('15529','2013-09-13','16:25:00',1.39),('15529','2013-09-13','16:30:00',1.36),('15529','2013-09-13','16:35:00',1.32),('15529','2013-09-13','16:40:00',1.26),('15529','2013-09-13','16:45:00',1.21),('15529','2013-09-13','16:50:00',1.04),('15529','2013-09-13','17:00:00',1.09),('15529','2013-09-13','17:05:00',1.03),('15529','2013-09-12','09:55:00',1.2),('15529','2013-09-12','10:05:00',1.18),('15529','2013-09-12','10:10:00',1.93),('15529','2013-09-12','10:15:00',1.21),('15529','2013-09-12','10:25:00',1.77),('15529','2013-09-12','10:30:00',1.68),('15529','2013-09-12','10:35:00',1.48),('15529','2013-09-12','10:40:00',1.84),('15529','2013-09-12','10:45:00',1.85),('15529','2013-09-12','10:50:00',1.88),('15529','2013-09-12','10:55:00',1.91),('15529','2013-09-12','11:00:00',1.95),('15529','2013-09-12','11:05:00',1.96),('15529','2013-09-12','11:10:00',1.97),('15529','2013-09-12','11:15:00',2.03),('15529','2013-09-12','11:20:00',2.05),('15529','2013-09-12','11:25:00',2.01),('15529','2013-09-12','11:30:00',2.06),('15529','2013-09-12','11:35:00',2.12),('15529','2013-09-12','11:40:00',2.12),('15529','2013-09-12','11:45:00',2.12),('15529','2013-09-12','11:50:00',2.12),('15529','2013-09-12','11:55:00',2.19),('15529','2013-09-12','12:00:00',2.16),('15529','2013-09-12','12:05:00',2.2),('15529','2013-09-12','12:10:00',2.2),('15529','2013-09-12','12:20:00',1.84),('15529','2013-09-12','12:25:00',2.35),('15529','2013-09-12','12:30:00',2.38),('15529','2013-09-12','12:35:00',2.33),('15529','2013-09-12','12:40:00',2.36),('15529','2013-09-12','12:45:00',2.3),('15529','2013-09-12','12:50:00',2.03),('15529','2013-09-12','13:00:00',1.73),('15529','2013-09-12','13:05:00',1.55),('15529','2013-09-12','13:10:00',2.33),('15529','2013-09-12','13:15:00',2.25),('15529','2013-09-12','13:20:00',2.23),('15529','2013-09-12','13:25:00',2.23),('15529','2013-09-12','13:30:00',2.2),('15529','2013-09-12','13:35:00',2.16),('15529','2013-09-12','13:40:00',2.23),('15529','2013-09-12','13:45:00',2.18),('15529','2013-09-12','13:50:00',2.21),('15529','2013-09-12','13:55:00',2.06),('15529','2013-09-12','14:00:00',2.15),('15529','2013-09-12','14:05:00',1.29),('15529','2013-09-12','14:10:00',2.14),('15529','2013-09-12','14:15:00',1.64),('15529','2013-09-12','14:20:00',1.86),('15529','2013-09-12','14:25:00',1.99),('15529','2013-09-12','14:30:00',2.12),('15529','2013-09-12','14:35:00',2.1),('15529','2013-09-12','14:40:00',2.04),('15529','2013-09-12','14:45:00',2.07),('15529','2013-09-12','14:50:00',2.03),('15529','2013-09-12','14:55:00',1.98),('15529','2013-09-12','15:00:00',1.97),('15529','2013-09-12','15:05:00',1.94),('15529','2013-09-12','15:10:00',1.93),('15529','2013-09-12','15:15:00',1.9),('15529','2013-09-12','15:20:00',1.86),('15529','2013-09-12','15:25:00',1.84),('15529','2013-09-12','15:30:00',1.81),('15529','2013-09-12','15:35:00',1.8),('15529','2013-09-12','15:40:00',1.75),('15529','2013-09-12','15:45:00',1.71),('15529','2013-09-12','15:50:00',1.69),('15529','2013-09-12','15:55:00',1.65),('15529','2013-09-12','16:00:00',1.61),('15529','2013-09-12','16:05:00',1.58),('15529','2013-09-12','16:10:00',1.53),('15529','2013-09-12','16:15:00',1.5),('15529','2013-09-12','16:20:00',1.45),('15529','2013-09-12','16:25:00',1.41),('15529','2013-09-12','16:30:00',1.37),('15529','2013-09-12','16:35:00',1.32),('15529','2013-09-12','16:40:00',1.28),('15529','2013-09-12','16:45:00',1.23),('15529','2013-09-12','16:50:00',1.17),('15529','2013-09-12','16:55:00',1.13),('15529','2013-09-12','17:00:00',1.07),('15529','2013-09-12','17:05:00',1.03),('15529','2013-09-11','09:00:00',1.03),('15529','2013-09-11','09:15:00',1.08),('15529','2013-09-11','09:20:00',1.1),('15529','2013-09-11','09:25:00',1.22),('15529','2013-09-11','09:30:00',1.33),('15529','2013-09-11','09:35:00',1.06),('15529','2013-09-11','09:45:00',1.06),('15529','2013-09-11','10:10:00',1.25),('15529','2013-09-11','10:15:00',1.04),('15529','2013-09-11','10:30:00',1.42),('15529','2013-09-11','10:55:00',1.09),('15529','2013-09-11','11:00:00',1.59),('15529','2013-09-11','11:05:00',1.86),('15529','2013-09-11','11:10:00',1.81),('15529','2013-09-11','11:15:00',1.6),('15529','2013-09-11','11:50:00',1.37),('15529','2013-09-11','11:55:00',1.75),('15529','2013-09-11','12:00:00',1.6),('15529','2013-09-11','12:05:00',2.17),('15529','2013-09-11','12:10:00',2.37),('15529','2013-09-11','12:15:00',1.53),('15529','2013-09-11','12:35:00',2.19),('15529','2013-09-11','12:40:00',1.13),('15529','2013-09-11','12:50:00',1.62),('15529','2013-09-11','12:55:00',2.45),('15529','2013-09-11','13:00:00',1.7),('15529','2013-09-11','13:05:00',1.96),('15529','2013-09-11','13:10:00',2.05),('15529','2013-09-11','13:15:00',2.48),('15529','2013-09-11','13:20:00',2.41),('15529','2013-09-11','13:25:00',1.42),('15529','2013-09-11','13:30:00',1.74),('15529','2013-09-11','13:35:00',1.7),('15529','2013-09-11','13:40:00',1.13),('15529','2013-09-11','13:45:00',1.89),('15529','2013-09-11','13:50:00',2.28),('15529','2013-09-11','13:55:00',2.28),('15529','2013-09-11','14:00:00',1.98),('15529','2013-09-11','14:05:00',2.09),('15529','2013-09-11','14:10:00',2.22),('15529','2013-09-11','14:15:00',2.26),('15529','2013-09-11','14:20:00',2.24),('15529','2013-09-11','14:25:00',2.14),('15529','2013-09-11','14:30:00',1.83),('15529','2013-09-11','14:35:00',1.32),('15529','2013-09-11','14:40:00',2.26),('15529','2013-09-11','14:45:00',1.14),('15529','2013-09-11','14:55:00',1.61),('15529','2013-09-11','15:00:00',1.36),('15529','2013-09-11','15:05:00',1.06),('15529','2013-09-11','15:10:00',1.83),('15529','2013-09-11','15:15:00',1.93),('15529','2013-09-11','15:20:00',1.71),('15529','2013-09-11','15:25:00',1.91),('15529','2013-09-11','15:30:00',1.87),('15529','2013-09-11','15:35:00',1.81),('15529','2013-09-11','15:40:00',1.81),('15529','2013-09-11','15:45:00',1.75),('15529','2013-09-11','15:50:00',1.77),('15529','2013-09-11','15:55:00',1.67),('15529','2013-09-11','16:05:00',1.75),('15529','2013-09-11','16:10:00',1.48),('15529','2013-09-11','16:15:00',1.23),('15529','2013-09-11','16:20:00',1.38),('15529','2013-09-11','16:25:00',1.05),('15529','2013-09-11','16:35:00',1.28),('15529','2013-09-11','16:40:00',1.42),('15529','2013-09-11','16:50:00',1.01),('15529','2013-09-11','16:55:00',1.01),('15529','2013-09-11','17:00:00',1.29),('15529','2013-09-10','09:05:00',1.05),('15529','2013-09-10','09:10:00',1.32),('15529','2013-09-10','09:15:00',1.29),('15529','2013-09-10','09:20:00',1.02),('15529','2013-09-10','10:10:00',1.01),('15529','2013-09-10','10:15:00',1.5),('15529','2013-09-10','10:20:00',1.72),('15529','2013-09-10','10:25:00',1.76),('15529','2013-09-10','10:30:00',1.8),('15529','2013-09-10','10:35:00',1.24),('15529','2013-09-10','10:40:00',1.82),('15529','2013-09-10','10:45:00',1.67),('15529','2013-09-10','10:50:00',1.42),('15529','2013-09-10','11:00:00',1),('15529','2013-09-10','11:05:00',1.88),('15529','2013-09-10','11:15:00',1.82),('15529','2013-09-10','11:20:00',1.65),('15529','2013-09-10','11:25:00',1.1),('15529','2013-09-10','11:30:00',1.32),('15529','2013-09-10','11:35:00',2.23),('15529','2013-09-10','11:40:00',2.17),('15529','2013-09-10','11:45:00',2.13),('15529','2013-09-10','11:50:00',1.72),('15529','2013-09-10','11:55:00',2.32),('15529','2013-09-10','12:00:00',1.45),('15529','2013-09-10','12:05:00',1.84),('15529','2013-09-10','12:15:00',1.47),('15529','2013-09-10','12:20:00',1.4),('15529','2013-09-10','12:25:00',1.59),('15529','2013-09-10','12:30:00',1.82),('15529','2013-09-10','12:35:00',1.42),('15529','2013-09-10','12:40:00',1.01),('15529','2013-09-10','12:45:00',2.04),('15529','2013-09-10','12:55:00',1.84),('15529','2013-09-10','13:00:00',2.25),('15529','2013-09-10','13:05:00',2.25),('15529','2013-09-10','13:10:00',2.5),('15529','2013-09-10','13:15:00',2.47),('15529','2013-09-10','13:20:00',2.44),('15529','2013-09-10','13:25:00',1.58),('15529','2013-09-10','13:30:00',1.63),('15529','2013-09-10','13:35:00',2.03),('15529','2013-09-10','13:40:00',1.67),('15529','2013-09-10','13:45:00',1.93),('15529','2013-09-10','13:50:00',1.66),('15529','2013-09-10','13:55:00',1.87),('15529','2013-09-10','14:00:00',2.24),('15529','2013-09-10','14:05:00',1.97),('15529','2013-09-10','14:10:00',2.24),('15529','2013-09-10','14:15:00',2.08),('15529','2013-09-10','14:20:00',2.14),('15529','2013-09-10','14:30:00',1.93),('15529','2013-09-10','14:35:00',1.27),('15529','2013-09-10','14:40:00',1.62),('15529','2013-09-10','14:45:00',2.33),('15529','2013-09-10','14:50:00',2.21),('15529','2013-09-10','14:55:00',1.56),('15529','2013-09-10','15:00:00',1.64),('15529','2013-09-10','15:05:00',1.77),('15529','2013-09-10','15:10:00',1.75),('15529','2013-09-10','15:15:00',1.14),('15529','2013-09-10','15:20:00',1.77),('15529','2013-09-10','15:25:00',1.57),('15529','2013-09-10','15:30:00',1.03),('15529','2013-09-10','15:35:00',1.15),('15529','2013-09-10','15:40:00',1.22),('15529','2013-09-10','15:45:00',1.97),('15529','2013-09-10','15:50:00',1.03),('15529','2013-09-10','15:55:00',1.3),('15529','2013-09-10','16:00:00',1.1),('15529','2013-09-10','16:05:00',1.27),('15529','2013-09-10','16:10:00',1.65),('15529','2013-09-10','16:15:00',1.56),('15529','2013-09-10','16:20:00',1.13),('15529','2013-09-10','16:30:00',1.16),('15529','2013-09-10','16:40:00',1.41),('15529','2013-09-10','16:50:00',1.18),('15529','2013-09-10','16:55:00',1.08),('15529','2013-09-10','17:00:00',1.16),('15529','2013-09-10','17:05:00',1.08),('15529','2013-09-10','17:10:00',1.01),('15529','2013-09-09','09:05:00',1.15),('15529','2013-09-09','09:10:00',1.26),('15529','2013-09-09','09:30:00',1.55),('15529','2013-09-09','09:35:00',1.21),('15529','2013-09-09','13:45:00',1.31),('15529','2013-09-09','14:25:00',1.25),('15529','2013-09-09','14:45:00',1.02),('15529','2013-09-09','14:50:00',1.25),('15529','2013-09-09','14:55:00',1.1),('15529','2013-09-09','15:00:00',1.4),('15529','2013-09-09','15:05:00',1.09),('15529','2013-09-09','15:20:00',1.06),('15529','2013-09-09','15:30:00',1.2),('15529','2013-09-08','10:45:00',1.05),('15529','2013-09-08','10:50:00',1.21),('15529','2013-09-08','10:55:00',1.04),('15529','2013-09-08','11:00:00',1.35),('15529','2013-09-08','11:05:00',1.09),('15529','2013-09-08','11:25:00',1.23),('15529','2013-09-08','11:30:00',1.08),('15529','2013-09-08','11:35:00',1.24),('15529','2013-09-08','11:55:00',1.24),('15529','2013-09-08','12:00:00',1.09),('15529','2013-09-08','12:05:00',1.15),('15529','2013-09-08','13:05:00',1.04),('15529','2013-09-08','13:10:00',1.83),('15529','2013-09-08','13:15:00',1.76),('15529','2013-09-08','13:20:00',1.59),('15529','2013-09-08','13:25:00',1.74),('15529','2013-09-08','13:30:00',2.07),('15529','2013-09-08','13:35:00',2.17),('15529','2013-09-08','13:40:00',2.04),('15529','2013-09-08','13:45:00',1.89),('15529','2013-09-08','13:50:00',2.18),('15529','2013-09-08','13:55:00',2.14),('15529','2013-09-08','14:00:00',2.01),('15529','2013-09-08','14:05:00',1.65),('15529','2013-09-08','14:10:00',1.02),('15529','2013-09-08','14:15:00',1.19),('15529','2013-09-08','14:30:00',1.87),('15529','2013-09-08','14:35:00',1.44),('15529','2013-09-08','14:40:00',2.06),('15529','2013-09-08','14:45:00',1.66),('15529','2013-09-08','14:50:00',1.09),('15529','2013-09-08','14:55:00',1.56),('15529','2013-09-08','15:00:00',1.63),('15529','2013-09-08','15:05:00',1.89),('15529','2013-09-08','15:10:00',1.75),('15529','2013-09-08','15:15:00',1.76),('15529','2013-09-08','15:20:00',1.78),('15529','2013-09-08','15:30:00',1.34),('15529','2013-09-08','15:35:00',1.35),('15529','2013-09-08','15:40:00',1.02),('15529','2013-09-08','15:45:00',1.01),('15529','2013-09-08','16:10:00',1.07),('15529','2013-09-08','16:15:00',1.31),('15529','2013-09-08','16:20:00',1.04),('15529','2014-04-11','09:30:00',1.1),('15529','2014-04-11','10:30:00',1.1),('15529','2014-04-11','10:35:00',1.08),('15529','2014-04-11','10:40:00',1.11),('15529','2014-04-11','10:45:00',1.16),('15529','2014-04-11','10:50:00',1.19),('15529','2014-04-11','10:55:00',1.28),('15529','2014-04-11','11:00:00',1.4),('15529','2014-04-11','11:05:00',1.93),('15529','2014-04-11','11:10:00',1.93),('15529','2014-04-11','11:15:00',1.91),('15529','2014-04-11','11:20:00',1.89),('15529','2014-04-11','11:25:00',2.06),('15529','2014-04-11','11:30:00',2.02),('15529','2014-04-11','11:35:00',2.11),('15529','2014-04-11','11:40:00',1.82),('15529','2014-04-11','11:45:00',1.61),('15529','2014-04-11','11:55:00',1.23),('15529','2014-04-11','12:10:00',1.4),('15529','2014-04-11','12:15:00',2.34),('15529','2014-04-11','12:20:00',1.98),('15529','2014-04-11','12:25:00',1.51),('15529','2014-04-11','12:30:00',1.29),('15529','2014-04-11','12:45:00',1.5),('15529','2014-04-11','12:50:00',2.1),('15529','2014-04-11','12:55:00',1.45),('15529','2014-04-11','13:00:00',1.03),('15529','2014-04-11','13:05:00',1.88),('15529','2014-04-11','13:10:00',1.8),('15529','2014-04-11','13:15:00',1.45),('15529','2014-04-11','13:20:00',1.12),('15529','2014-04-11','13:25:00',2.13),('15529','2014-04-11','13:30:00',2.58),('15529','2014-04-11','13:35:00',2.2),('15529','2014-04-11','13:40:00',1.96),('15529','2014-04-11','13:45:00',2.42),('15529','2014-04-11','13:50:00',2.07),('15529','2014-04-11','13:55:00',1.85),('15529','2014-04-11','14:00:00',2.19),('15529','2014-04-11','14:05:00',2.27),('15529','2014-04-11','14:10:00',1.28),('15529','2014-04-11','14:30:00',1.45),('15529','2014-04-11','14:35:00',1.02),('15529','2014-04-11','14:40:00',1.21),('15529','2014-04-11','14:45:00',2.12),('15529','2014-04-11','14:50:00',1.51),('15529','2014-04-11','14:55:00',1.92),('15529','2014-04-11','15:00:00',1.85),('15529','2014-04-11','15:05:00',2.01),('15529','2014-04-11','15:10:00',2.05),('15529','2014-04-11','15:15:00',1.8),('15529','2014-04-11','15:20:00',1.45),('15529','2014-04-11','15:25:00',1.55),('15529','2014-04-11','15:30:00',1.5),('15529','2014-04-11','15:35:00',1.15),('15529','2014-04-11','15:40:00',1.28),('15529','2014-04-11','15:45:00',1.74),('15529','2014-04-11','15:50:00',1.88),('15529','2014-04-11','15:55:00',1.87),('15529','2014-04-11','16:00:00',1.83),('15529','2014-04-11','16:05:00',1.8),('15529','2014-04-11','16:10:00',1.68),('15529','2014-04-11','16:15:00',1.55),('15529','2014-04-11','16:20:00',1.36),('15529','2014-04-11','16:25:00',1.37),('15529','2014-04-11','16:30:00',1.07),('15529','2014-04-11','16:35:00',1.42),('15529','2014-04-11','16:40:00',1.26),('15529','2014-04-11','16:45:00',1.26),('15529','2014-04-11','16:50:00',1.52),('15529','2014-04-11','16:55:00',1.16),('15529','2014-04-11','17:00:00',1.22),('15529','2014-04-11','17:05:00',1.14),('15529','2014-04-11','17:10:00',1.15),('15529','2014-04-11','17:30:00',1.05),('15529','2014-04-11','17:35:00',1.02),('15529','2013-09-07','09:30:00',1.1),('15529','2013-09-07','09:35:00',1.23),('15529','2013-09-07','09:40:00',1.27),('15529','2013-09-07','09:45:00',1.29),('15529','2013-09-07','09:50:00',1.32),('15529','2013-09-07','09:55:00',1.35),('15529','2013-09-07','10:00:00',1.41),('15529','2013-09-07','10:05:00',1.41),('15529','2013-09-07','10:10:00',1.47),('15529','2013-09-07','10:15:00',1.5),('15529','2013-09-07','10:20:00',1.58),('15529','2013-09-07','10:25:00',1.59),('15529','2013-09-07','10:30:00',1.63),('15529','2013-09-07','10:35:00',1.62),('15529','2013-09-07','10:40:00',1.66),('15529','2013-09-07','10:45:00',1.7),('15529','2013-09-07','10:50:00',1.73),('15529','2013-09-07','10:55:00',1.68),('15529','2013-09-07','11:00:00',1.76),('15529','2013-09-07','11:05:00',1.8),('15529','2013-09-07','11:10:00',1.78),('15529','2013-09-07','11:15:00',1.77),('15529','2013-09-07','11:20:00',1.79),('15529','2013-09-07','11:25:00',1.79),('15529','2013-09-07','11:30:00',1.87),('15529','2013-09-07','11:35:00',1.87),('15529','2013-09-07','11:40:00',1.87),('15529','2013-09-07','11:45:00',1.9),('15529','2013-09-07','11:50:00',1.86),('15529','2013-09-07','11:55:00',1.87),('15529','2013-09-07','12:00:00',1.75),('15529','2013-09-07','12:05:00',1.79),('15529','2013-09-07','12:10:00',1.94),('15529','2013-09-07','12:15:00',1.98),('15529','2013-09-07','12:20:00',1.98),('15529','2013-09-07','12:25:00',2.01),('15529','2013-09-07','12:30:00',2),('15529','2013-09-07','12:35:00',1.97),('15529','2013-09-07','12:40:00',1.97),('15529','2013-09-07','12:45:00',2.01),('15529','2013-09-07','12:50:00',2),('15529','2013-09-07','12:55:00',2.07),('15529','2013-09-07','13:00:00',1.98),('15529','2013-09-07','13:05:00',2.09),('15529','2013-09-07','13:10:00',2.06),('15529','2013-09-07','13:15:00',1.95),('15529','2013-09-07','13:20:00',2),('15529','2013-09-07','13:25:00',1.77),('15529','2013-09-07','13:30:00',1.83),('15529','2013-09-07','13:35:00',1.57),('15529','2013-09-07','13:40:00',1.06),('15529','2013-09-07','13:45:00',1.32),('15529','2013-09-07','13:50:00',1.82),('15529','2013-09-07','13:55:00',1.76),('15529','2013-09-07','14:00:00',1.88),('15529','2013-09-07','14:05:00',1.88),('15529','2013-09-07','14:10:00',1.91),('15529','2013-09-07','14:15:00',1.95),('15529','2013-09-07','14:20:00',2.18),('15529','2013-09-07','14:25:00',2.07),('15529','2013-09-07','14:30:00',1.99),('15529','2013-09-07','14:35:00',2.05),('15529','2013-09-07','14:40:00',1.97),('15529','2013-09-07','14:45:00',1.98),('15529','2013-09-07','14:50:00',1.96),('15529','2013-09-07','14:55:00',1.9),('15529','2013-09-07','15:00:00',1.9),('15529','2013-09-07','15:05:00',1.24),('15529','2013-09-07','15:15:00',1.64),('15529','2013-09-07','15:20:00',1.75),('15529','2013-09-07','15:25:00',1.84),('15529','2013-09-07','15:30:00',1.8),('15529','2013-09-07','15:35:00',1.72),('15529','2013-09-07','15:40:00',1.61),('15529','2013-09-07','15:45:00',1.67),('15529','2013-09-07','15:50:00',1.45),('15529','2013-09-07','15:55:00',1.36),('15529','2013-09-07','16:00:00',1.37),('15529','2013-09-07','16:05:00',1.3),('15529','2013-09-07','16:10:00',1.17),('15529','2013-09-07','16:15:00',1.36),('15529','2013-09-07','16:20:00',1.27),('15529','2013-09-07','16:25:00',1.15),('15529','2013-09-07','16:30:00',1.27),('15529','2013-09-07','16:35:00',1.12),('15529','2013-09-07','17:00:00',1.04),('15529','2013-09-07','17:05:00',1.08),('15529','2013-09-06','09:05:00',1),('15529','2013-09-06','09:10:00',1.05),('15529','2013-09-06','09:15:00',1.1),('15529','2013-09-06','09:20:00',1.16),('15529','2013-09-06','09:25:00',1.2),('15529','2013-09-06','09:30:00',1.23),('15529','2013-09-06','09:35:00',1.27),('15529','2013-09-06','09:40:00',1.3),('15529','2013-09-06','09:45:00',1.33),('15529','2013-09-06','09:50:00',1.37),('15529','2013-09-06','09:55:00',1.4),('15529','2013-09-06','10:00:00',1.44),('15529','2013-09-06','10:05:00',1.48),('15529','2013-09-06','10:10:00',1.5),('15529','2013-09-06','10:15:00',1.54),('15529','2013-09-06','10:20:00',1.58),('15529','2013-09-06','10:25:00',1.61),('15529','2013-09-06','10:30:00',1.62),('15529','2013-09-06','10:35:00',1.66),('15529','2013-09-06','10:40:00',1.69),('15529','2013-09-06','10:45:00',1.73),('15529','2013-09-06','10:50:00',1.75),('15529','2013-09-06','10:55:00',1.79),('15529','2013-09-06','11:00:00',1.8),('15529','2013-09-06','11:05:00',1.84),('15529','2013-09-06','11:10:00',1.81),('15529','2013-09-06','11:15:00',1.85),('15529','2013-09-06','11:20:00',1.88),('15529','2013-09-06','11:25:00',1.89),('15529','2013-09-06','11:30:00',1.94),('15529','2013-09-06','11:35:00',1.93),('15529','2013-09-06','11:40:00',1.93),('15529','2013-09-06','11:45:00',1.92),('15529','2013-09-06','11:50:00',1.94),('15529','2013-09-06','11:55:00',1.99),('15529','2013-09-06','12:00:00',1.97),('15529','2013-09-06','12:05:00',1.96),('15529','2013-09-06','12:10:00',1.94),('15529','2013-09-06','12:15:00',2.05),('15529','2013-09-06','12:20:00',2.02),('15529','2013-09-06','12:25:00',2.03),('15529','2013-09-06','12:30:00',2.01),('15529','2013-09-06','12:35:00',1.97),('15529','2013-09-06','12:40:00',2.05),('15529','2013-09-06','12:45:00',2.01),('15529','2013-09-06','12:50:00',2.05),('15529','2013-09-06','12:55:00',2.05),('15529','2013-09-06','13:00:00',2.05),('15529','2013-09-06','13:05:00',2.05),('15529','2013-09-06','13:10:00',2.05),('15529','2013-09-06','13:15:00',2.03),('15529','2013-09-06','13:20:00',2.04),('15529','2013-09-06','13:25:00',2.04),('15529','2013-09-06','13:30:00',2.06),('15529','2013-09-06','13:35:00',2.06),('15529','2013-09-06','13:40:00',2.07),('15529','2013-09-06','13:45:00',2.1),('15529','2013-09-06','13:50:00',2.09),('15529','2013-09-06','13:55:00',2.05),('15529','2013-09-06','14:00:00',2.06),('15529','2013-09-06','14:05:00',2.01),('15529','2013-09-06','14:10:00',2.01),('15529','2013-09-06','14:15:00',1.99),('15529','2013-09-06','14:20:00',1.97),('15529','2013-09-06','14:25:00',2.01),('15529','2013-09-06','14:30:00',1.99),('15529','2013-09-06','14:35:00',1.99),('15529','2013-09-06','14:40:00',2.01),('15529','2013-09-06','14:45:00',1.98),('15529','2013-09-06','14:50:00',1.93),('15529','2013-09-06','14:55:00',1.93),('15529','2013-09-06','15:00:00',1.91),('15529','2013-09-06','15:05:00',1.9),('15529','2013-09-06','15:10:00',1.84),('15529','2013-09-06','15:15:00',1.84),('15529','2013-09-06','15:20:00',1.82),('15529','2013-09-06','15:25:00',1.8),('15529','2013-09-06','15:30:00',1.78),('15529','2013-09-06','15:35:00',1.73),('15529','2013-09-06','15:40:00',1.69),('15529','2013-09-06','15:45:00',1.66),('15529','2013-09-06','15:50:00',1.61),('15529','2013-09-06','15:55:00',1.57),('15529','2013-09-06','16:00:00',1.53),('15529','2013-09-06','16:05:00',1.5),('15529','2013-09-06','16:10:00',1.45),('15529','2013-09-06','16:15:00',1.42),('15529','2013-09-06','16:20:00',1.37),('15529','2013-09-06','16:25:00',1.32),('15529','2013-09-06','16:30:00',1.28),('15529','2013-09-06','16:35:00',1.25),('15529','2013-09-06','16:40:00',1.21),('15529','2013-09-06','16:45:00',1.16),('15529','2013-09-06','16:50:00',1.11),('15529','2013-09-06','16:55:00',1.07),('15529','2013-09-06','17:00:00',1.03),('15529','2013-09-05','09:05:00',1.03),('15529','2013-09-05','09:10:00',1.07),('15529','2013-09-05','09:15:00',1.13),('15529','2013-09-05','09:20:00',1.17),('15529','2013-09-05','09:25:00',1.21),('15529','2013-09-05','09:30:00',1.24),('15529','2013-09-05','09:35:00',1.28),('15529','2013-09-05','09:40:00',1.33),('15529','2013-09-05','09:45:00',1.37),('15529','2013-09-05','09:50:00',1.4),('15529','2013-09-05','09:55:00',1.43),('15529','2013-09-05','10:00:00',1.48),('15529','2013-09-05','10:05:00',1.5),('15529','2013-09-05','10:10:00',1.55),('15529','2013-09-05','10:15:00',1.58),('15529','2013-09-05','10:20:00',1.6),('15529','2013-09-05','10:25:00',1.63),('15529','2013-09-05','10:30:00',1.68),('15529','2013-09-05','10:35:00',1.7),('15529','2013-09-05','10:40:00',1.75),('15529','2013-09-05','10:45:00',1.77),('15529','2013-09-05','10:50:00',1.81),('15529','2013-09-05','10:55:00',1.83),('15529','2013-09-05','11:00:00',1.83),('15529','2013-09-05','11:05:00',1.85),('15529','2013-09-05','11:10:00',1.88),('15529','2013-09-05','11:15:00',1.91),('15529','2013-09-05','11:20:00',1.92),('15529','2013-09-05','11:25:00',1.97),('15529','2013-09-05','11:30:00',1.94),('15529','2013-09-05','11:35:00',1.97),('15529','2013-09-05','11:40:00',1.96),('15529','2013-09-05','11:45:00',2.02),('15529','2013-09-05','11:50:00',2.01),('15529','2013-09-05','11:55:00',2.05),('15529','2013-09-05','12:00:00',2.05),('15529','2013-09-05','12:05:00',2.07),('15529','2013-09-05','12:10:00',2.1),('15529','2013-09-05','12:15:00',2.11),('15529','2013-09-05','12:20:00',2.07),('15529','2013-09-05','12:25:00',2.1),('15529','2013-09-05','12:30:00',2.09),('15529','2013-09-05','12:35:00',2.09),('15529','2013-09-05','12:40:00',2.12),('15529','2013-09-05','12:45:00',2.1),('15529','2013-09-05','12:50:00',2.11),('15529','2013-09-05','12:55:00',2.11),('15529','2013-09-05','13:00:00',2.11),('15529','2013-09-05','13:05:00',2.12),('15529','2013-09-05','13:10:00',2.15),('15529','2013-09-05','13:15:00',2.14),('15529','2013-09-05','13:20:00',2.08),('15529','2013-09-05','13:25:00',2.08),('15529','2013-09-05','13:30:00',2.08),('15529','2013-09-05','13:35:00',2.06),('15529','2013-09-05','13:40:00',2.07),('15529','2013-09-05','13:45:00',2.08),('15529','2013-09-05','13:50:00',2.09),('15529','2013-09-05','13:55:00',2.04),('15529','2013-09-05','14:00:00',2.02),('15529','2013-09-05','14:05:00',2.03),('15529','2013-09-05','14:10:00',2.02),('15529','2013-09-05','14:15:00',1.98),('15529','2013-09-05','14:20:00',1.83),('15529','2013-09-05','14:25:00',1.89),('15529','2013-09-05','14:30:00',1.93),('15529','2013-09-05','14:35:00',1.93),('15529','2013-09-05','14:40:00',1.91),('15529','2013-09-05','14:45:00',1.9),('15529','2013-09-05','14:50:00',1.89),('15529','2013-09-05','14:55:00',1.9),('15529','2013-09-05','15:00:00',1.88),('15529','2013-09-05','15:05:00',1.85),('15529','2013-09-05','15:10:00',1.83),('15529','2013-09-05','15:15:00',1.82),('15529','2013-09-05','15:20:00',1.81),('15529','2013-09-05','15:25:00',1.77),('15529','2013-09-05','15:30:00',1.72),('15529','2013-09-05','15:35:00',1.69),('15529','2013-09-05','15:40:00',1.65),('15529','2013-09-05','15:45:00',1.62),('15529','2013-09-05','15:50:00',1.59),('15529','2013-09-05','15:55:00',1.56),('15529','2013-09-05','16:00:00',1.53),('15529','2013-09-05','16:05:00',1.5),('15529','2013-09-05','16:10:00',1.46),('15529','2013-09-05','16:15:00',1.42),('15529','2013-09-05','16:20:00',1.38),('15529','2013-09-05','16:25:00',1.35),('15529','2013-09-05','16:30:00',1.3),('15529','2013-09-05','16:35:00',1.26),('15529','2013-09-05','16:40:00',1.23),('15529','2013-09-05','16:45:00',1.17),('15529','2013-09-05','16:50:00',1.13),('15529','2013-09-05','16:55:00',1.09),('15529','2013-09-05','17:00:00',1.04),('15529','2013-09-05','17:05:00',1),('15529','2013-09-04','08:55:00',1.01),('15529','2013-09-04','09:00:00',1.06),('15529','2013-09-04','09:05:00',1.1),('15529','2013-09-04','09:10:00',1.15),('15529','2013-09-04','09:15:00',1.19),('15529','2013-09-04','09:20:00',1.23),('15529','2013-09-04','09:25:00',1.28),('15529','2013-09-04','09:30:00',1.31),('15529','2013-09-04','09:35:00',1.35),('15529','2013-09-04','09:40:00',1.38),('15529','2013-09-04','09:45:00',1.42),('15529','2013-09-04','09:50:00',1.46),('15529','2013-09-04','09:55:00',1.49),('15529','2013-09-04','10:00:00',1.53),('15529','2013-09-04','10:05:00',1.56),('15529','2013-09-04','10:10:00',1.6),('15529','2013-09-04','10:15:00',1.63),('15529','2013-09-04','10:20:00',1.68),('15529','2013-09-04','10:25:00',1.7),('15529','2013-09-04','10:30:00',1.73),('15529','2013-09-04','10:35:00',1.76),('15529','2013-09-04','10:40:00',1.78),('15529','2013-09-04','10:45:00',1.8),('15529','2013-09-04','10:50:00',1.84),('15529','2013-09-04','10:55:00',1.85),('15529','2013-09-04','11:00:00',1.87),('15529','2013-09-04','11:05:00',1.89),('15529','2013-09-04','11:10:00',1.91),('15529','2013-09-04','11:15:00',1.95),('15529','2013-09-04','11:20:00',1.97),('15529','2013-09-04','11:25:00',1.96),('15529','2013-09-04','11:30:00',1.98),('15529','2013-09-04','11:35:00',2.01),('15529','2013-09-04','11:40:00',2.02),('15529','2013-09-04','11:45:00',1.99),('15529','2013-09-04','11:50:00',2.01),('15529','2013-09-04','11:55:00',2.06),('15529','2013-09-04','12:00:00',2.07),('15529','2013-09-04','12:05:00',2.08),('15529','2013-09-04','12:10:00',2.08),('15529','2013-09-04','12:15:00',2.09),('15529','2013-09-04','12:20:00',2.11),('15529','2013-09-04','12:25:00',2.11),('15529','2013-09-04','12:30:00',2.11),('15529','2013-09-04','12:35:00',2.14),('15529','2013-09-04','12:40:00',2.12),('15529','2013-09-04','12:45:00',2.1),('15529','2013-09-04','12:50:00',2.15),('15529','2013-09-04','12:55:00',2.12),('15529','2013-09-04','13:00:00',2.12),('15529','2013-09-04','13:05:00',2.15),('15529','2013-09-04','13:10:00',2.14),('15529','2013-09-04','13:15:00',2.17),('15529','2013-09-04','13:20:00',2.16),('15529','2013-09-04','13:25:00',2.15),('15529','2013-09-04','13:30:00',2.15),('15529','2013-09-04','13:35:00',2.13),('15529','2013-09-04','13:40:00',2.16),('15529','2013-09-04','13:45:00',2.17),('15529','2013-09-04','13:50:00',2.15),('15529','2013-09-04','13:55:00',2.13),('15529','2013-09-04','14:00:00',2.09),('15529','2013-09-04','14:05:00',2.1),('15529','2013-09-04','14:10:00',2.11),('15529','2013-09-04','14:15:00',2.1),('15529','2013-09-04','14:20:00',2.05),('15529','2013-09-04','14:25:00',2.03),('15529','2013-09-04','14:30:00',2.02),('15529','2013-09-04','14:35:00',1.97),('15529','2013-09-04','14:40:00',1.95),('15529','2013-09-04','14:45:00',1.97),('15529','2013-09-04','14:50:00',1.97),('15529','2013-09-04','14:55:00',1.94),('15529','2013-09-04','15:00:00',1.93),('15529','2013-09-04','15:05:00',1.9),('15529','2013-09-04','15:10:00',1.9),('15529','2013-09-04','15:15:00',1.86),('15529','2013-09-04','15:20:00',1.82),('15529','2013-09-04','15:25:00',1.79),('15529','2013-09-04','15:30:00',1.77),('15529','2013-09-04','15:35:00',1.73),('15529','2013-09-04','15:40:00',1.71),('15529','2013-09-04','15:45:00',1.69),('15529','2013-09-04','15:50:00',1.66),('15529','2013-09-04','15:55:00',1.64),('15529','2013-09-04','16:00:00',1.6),('15529','2013-09-04','16:05:00',1.57),('15529','2013-09-04','16:10:00',1.54),('15529','2013-09-04','16:15:00',1.5),('15529','2013-09-04','16:20:00',1.46),('15529','2013-09-04','16:25:00',1.43),('15529','2013-09-04','16:30:00',1.4),('15529','2013-09-04','16:35:00',1.38),('15529','2013-09-04','16:40:00',1.35),('15529','2013-09-04','16:45:00',1.33),('15529','2013-09-04','16:50:00',1.05),('15529','2013-09-03','09:00:00',1.05),('15529','2013-09-03','09:05:00',1.1),('15529','2013-09-03','09:10:00',1.14),('15529','2013-09-03','09:15:00',1.19),('15529','2013-09-03','09:20:00',1.23),('15529','2013-09-03','09:25:00',1.28),('15529','2013-09-03','09:30:00',1.33),('15529','2013-09-03','09:35:00',1.38),('15529','2013-09-03','09:40:00',1.42),('15529','2013-09-03','09:45:00',1.46),('15529','2013-09-03','09:50:00',1.5),('15529','2013-09-03','09:55:00',1.54),('15529','2013-09-03','10:00:00',1.57),('15529','2013-09-03','10:05:00',1.61),('15529','2013-09-03','10:10:00',1.64),('15529','2013-09-03','10:15:00',1.67),('15529','2013-09-03','10:20:00',1.7),('15529','2013-09-03','10:25:00',1.73),('15529','2013-09-03','10:30:00',1.75),('15529','2013-09-03','10:35:00',1.79),('15529','2013-09-03','10:40:00',1.82),('15529','2013-09-03','10:45:00',1.85),('15529','2013-09-03','10:50:00',1.89),('15529','2013-09-03','10:55:00',1.93),('15529','2013-09-03','11:00:00',1.92),('15529','2013-09-03','11:05:00',2),('15529','2013-09-03','11:10:00',2.02),('15529','2013-09-03','11:15:00',2.04),('15529','2013-09-03','11:20:00',2.05),('15529','2013-09-03','11:25:00',2.06),('15529','2013-09-03','11:30:00',2.06),('15529','2013-09-03','11:35:00',2.11),('15529','2013-09-03','11:40:00',2.08),('15529','2013-09-03','11:45:00',2.11),('15529','2013-09-03','11:50:00',2.12),('15529','2013-09-03','11:55:00',2.14),('15529','2013-09-03','12:00:00',2.12),('15529','2013-09-03','12:05:00',2.18),('15529','2013-09-03','12:10:00',2.15),('15529','2013-09-03','12:15:00',2.15),('15529','2013-09-03','12:20:00',2.18),('15529','2013-09-03','12:25:00',2.15),('15529','2013-09-03','12:30:00',2.16),('15529','2013-09-03','12:35:00',2.19),('15529','2013-09-03','12:40:00',2.19),('15529','2013-09-03','12:45:00',2.19),('15529','2013-09-03','12:50:00',2.2),('15529','2013-09-03','12:55:00',2.13),('15529','2013-09-03','13:00:00',2.23),('15529','2013-09-03','13:05:00',2.23),('15529','2013-09-03','13:10:00',2.21),('15529','2013-09-03','13:15:00',2.18),('15529','2013-09-03','13:20:00',2.19),('15529','2013-09-03','13:25:00',2.22),('15529','2013-09-03','13:30:00',2.15),('15529','2013-09-03','13:35:00',2.2),('15529','2013-09-03','13:40:00',2.16),('15529','2013-09-03','13:45:00',2.15),('15529','2013-09-03','13:50:00',2.2),('15529','2013-09-03','13:55:00',2.2),('15529','2013-09-03','14:00:00',2.17),('15529','2013-09-03','14:05:00',2.17),('15529','2013-09-03','14:10:00',2.14),('15529','2013-09-03','14:15:00',2.15),('15529','2013-09-03','14:20:00',2.09),('15529','2013-09-03','14:25:00',2.11),('15529','2013-09-03','14:30:00',2.08),('15529','2013-09-03','14:35:00',2.11),('15529','2013-09-03','14:40:00',2.06),('15529','2013-09-03','14:45:00',2.03),('15529','2013-09-03','14:50:00',1.99),('15529','2013-09-03','14:55:00',1.99),('15529','2013-09-03','15:00:00',1.97),('15529','2013-09-03','15:05:00',1.94),('15529','2013-09-03','15:10:00',1.92),('15529','2013-09-03','15:15:00',1.9),('15529','2013-09-03','15:20:00',1.87),('15529','2013-09-03','15:25:00',1.85),('15529','2013-09-03','15:30:00',1.8),('15529','2013-09-03','15:35:00',1.78),('15529','2013-09-03','15:40:00',1.76),('15529','2013-09-03','15:45:00',1.73),('15529','2013-09-03','15:50:00',1.69),('15529','2013-09-03','15:55:00',1.67),('15529','2013-09-03','16:00:00',1.61),('15529','2013-09-03','16:05:00',1.57),('15529','2013-09-03','16:10:00',1.52),('15529','2013-09-03','16:15:00',1.49),('15529','2013-09-03','16:20:00',1.46),('15529','2013-09-03','16:25:00',1.41),('15529','2013-09-03','16:30:00',1.36),('15529','2013-09-03','16:35:00',1.33),('15529','2013-09-03','16:40:00',1.29),('15529','2013-09-03','16:45:00',1.25),('15529','2013-09-03','16:50:00',1.2),('15529','2013-09-03','16:55:00',1.15),('15529','2013-09-03','17:00:00',1.11),('15529','2013-09-03','17:05:00',1.06),('15529','2013-09-03','17:10:00',1.01),('15529','2013-09-02','09:05:00',1),('15529','2013-09-02','09:10:00',1.05),('15529','2013-09-02','09:15:00',1.1),('15529','2013-09-02','09:20:00',1.15),('15529','2013-09-02','09:25:00',1.2),('15529','2013-09-02','09:30:00',1.24),('15529','2013-09-02','09:35:00',1.28),('15529','2013-09-02','09:40:00',1.33),('15529','2013-09-02','09:45:00',1.36),('15529','2013-09-02','09:50:00',1.39),('15529','2013-09-02','09:55:00',1.43),('15529','2013-09-02','10:00:00',1.46),('15529','2013-09-02','10:05:00',1.5),('15529','2013-09-02','10:10:00',1.53),('15529','2013-09-02','10:15:00',1.57),('15529','2013-09-02','10:20:00',1.62),('15529','2013-09-02','10:25:00',1.66),('15529','2013-09-02','10:30:00',1.67),('15529','2013-09-02','10:35:00',1.72),('15529','2013-09-02','10:40:00',1.75),('15529','2013-09-02','10:45:00',1.8),('15529','2013-09-02','10:50:00',1.8),('15529','2013-09-02','10:55:00',1.83),('15529','2013-09-02','11:00:00',1.86),('15529','2013-09-02','11:05:00',1.85),('15529','2013-09-02','11:10:00',1.86),('15529','2013-09-02','11:15:00',1.88),('15529','2013-09-02','11:20:00',1.91),('15529','2013-09-02','11:25:00',1.93),('15529','2013-09-02','11:30:00',1.96),('15529','2013-09-02','11:35:00',1.98),('15529','2013-09-02','11:40:00',1.99),('15529','2013-09-02','11:45:00',2.01),('15529','2013-09-02','11:50:00',2.05),('15529','2013-09-02','11:55:00',2.05),('15529','2013-09-02','12:00:00',2.06),('15529','2013-09-02','12:05:00',2.1),('15529','2013-09-02','12:10:00',2.1),('15529','2013-09-02','12:15:00',2.1),('15529','2013-09-02','12:20:00',2.14),('15529','2013-09-02','12:25:00',2.13),('15529','2013-09-02','12:30:00',2.16),('15529','2013-09-02','12:35:00',2.15),('15529','2013-09-02','12:40:00',2.15),('15529','2013-09-02','12:45:00',2.16),('15529','2013-09-02','12:50:00',2.15),('15529','2013-09-02','12:55:00',2.14),('15529','2013-09-02','13:00:00',2.15),('15529','2013-09-02','13:05:00',2.19),('15529','2013-09-02','13:10:00',2.15),('15529','2013-09-02','13:15:00',2.15),('15529','2013-09-02','13:20:00',2.19),('15529','2013-09-02','13:25:00',2.2),('15529','2013-09-02','13:30:00',2.18),('15529','2013-09-02','13:35:00',2.16),('15529','2013-09-02','13:40:00',2.16),('15529','2013-09-02','13:45:00',2.17),('15529','2013-09-02','13:50:00',2.16),('15529','2013-09-02','13:55:00',2.14),('15529','2013-09-02','14:00:00',2.11),('15529','2013-09-02','14:05:00',2.11),('15529','2013-09-02','14:10:00',2.06),('15529','2013-09-02','14:15:00',2.08),('15529','2013-09-02','14:20:00',2.05),('15529','2013-09-02','14:25:00',2.04),('15529','2013-09-02','14:30:00',2.03),('15529','2013-09-02','14:35:00',2.03),('15529','2013-09-02','14:40:00',2.04),('15529','2013-09-02','14:45:00',2.02),('15529','2013-09-02','14:50:00',2),('15529','2013-09-02','14:55:00',1.98),('15529','2013-09-02','15:00:00',1.94),('15529','2013-09-02','15:05:00',1.93),('15529','2013-09-02','15:10:00',1.92),('15529','2013-09-02','15:15:00',1.84),('15529','2013-09-02','15:20:00',1.84),('15529','2013-09-02','15:25:00',1.82),('15529','2013-09-02','15:30:00',1.8),('15529','2013-09-02','15:35:00',1.76),('15529','2013-09-02','15:40:00',1.74),('15529','2013-09-02','15:45:00',1.71),('15529','2013-09-02','15:50:00',1.66),('15529','2013-09-02','15:55:00',1.62),('15529','2013-09-02','16:00:00',1.59),('15529','2013-09-02','16:05:00',1.56),('15529','2013-09-02','16:10:00',1.52),('15529','2013-09-02','16:15:00',1.49),('15529','2013-09-02','16:20:00',1.45),('15529','2013-09-02','16:25:00',1.4),('15529','2013-09-02','16:30:00',1.36),('15529','2013-09-02','16:35:00',1.32),('15529','2013-09-02','16:40:00',1.29),('15529','2013-09-02','16:45:00',1.25),('15529','2013-09-02','16:50:00',1.19),('15529','2013-09-02','16:55:00',1.15),('15529','2013-09-02','17:00:00',1.1),('15529','2013-09-02','17:05:00',1.06),('15529','2013-09-02','17:10:00',1.01),('15529','2013-09-01','09:05:00',1.04),('15529','2013-09-01','09:10:00',1.08),('15529','2013-09-01','09:15:00',1.13),('15529','2013-09-01','09:20:00',1.18),('15529','2013-09-01','09:25:00',1.22),('15529','2013-09-01','09:30:00',1.26),('15529','2013-09-01','09:35:00',1.3),('15529','2013-09-01','09:40:00',1.34),('15529','2013-09-01','09:45:00',1.39),('15529','2013-09-01','09:50:00',1.43),('15529','2013-09-01','09:55:00',1.47),('15529','2013-09-01','10:00:00',1.49),('15529','2013-09-01','10:05:00',1.52),('15529','2013-09-01','10:10:00',1.56),('15529','2013-09-01','10:15:00',1.59),('15529','2013-09-01','10:20:00',1.62),('15529','2013-09-01','10:25:00',1.67),('15529','2013-09-01','10:30:00',1.69),('15529','2013-09-01','10:35:00',1.71),('15529','2013-09-01','10:40:00',1.74),('15529','2013-09-01','10:45:00',1.78),('15529','2013-09-01','10:50:00',1.8),('15529','2013-09-01','10:55:00',1.84),('15529','2013-09-01','11:00:00',1.85),('15529','2013-09-01','11:05:00',1.88),('15529','2013-09-01','11:10:00',1.92),('15529','2013-09-01','11:15:00',1.92),('15529','2013-09-01','11:20:00',1.94),('15529','2013-09-01','11:25:00',1.97),('15529','2013-09-01','11:30:00',1.98),('15529','2013-09-01','11:35:00',2),('15529','2013-09-01','11:40:00',2.02),('15529','2013-09-01','11:45:00',2.01),('15529','2013-09-01','11:50:00',2.01),('15529','2013-09-01','11:55:00',2.01),('15529','2013-09-01','12:00:00',2.06),('15529','2013-09-01','12:05:00',2.1),('15529','2013-09-01','12:10:00',2.08),('15529','2013-09-01','12:15:00',2.14),('15529','2013-09-01','12:20:00',2.12),('15529','2013-09-01','12:25:00',2.14),('15529','2013-09-01','12:30:00',2.15),('15529','2013-09-01','12:35:00',2.11),('15529','2013-09-01','12:40:00',2.15),('15529','2013-09-01','12:45:00',2.12),('15529','2013-09-01','12:50:00',2.11),('15529','2013-09-01','12:55:00',2.11),('15529','2013-09-01','13:00:00',2.14),('15529','2013-09-01','13:05:00',2.16),('15529','2013-09-01','13:10:00',2.15),('15529','2013-09-01','13:15:00',2.14),('15529','2013-09-01','13:20:00',2.15),('15529','2013-09-01','13:25:00',2.14),('15529','2013-09-01','13:30:00',2.17),('15529','2013-09-01','13:35:00',2.14),('15529','2013-09-01','13:40:00',2.2),('15529','2013-09-01','13:45:00',2.16),('15529','2013-09-01','13:50:00',2.17),('15529','2013-09-01','13:55:00',2.13),('15529','2013-09-01','14:00:00',2.09),('15529','2013-09-01','14:05:00',2.11),('15529','2013-09-01','14:10:00',2.1),('15529','2013-09-01','14:15:00',2.1),('15529','2013-09-01','14:20:00',2.1),('15529','2013-09-01','14:25:00',2.09),('15529','2013-09-01','14:30:00',2.12),('15529','2013-09-01','14:35:00',2.12),('15529','2013-09-01','14:40:00',2.04),('15529','2013-09-01','14:45:00',2.06),('15529','2013-09-01','14:50:00',2.02),('15529','2013-09-01','14:55:00',1.98),('15529','2013-09-01','15:10:00',1.23),('15529','2013-09-01','15:15:00',1.96),('15529','2013-09-01','15:20:00',1.91),('15529','2013-09-01','15:25:00',1.87),('15529','2013-09-01','15:30:00',1.86),('15529','2013-09-01','15:35:00',1.81),('15529','2013-09-01','15:40:00',1.73),('15529','2013-09-01','15:45:00',1.69),('15529','2013-09-01','15:50:00',1.65),('15529','2013-09-01','15:55:00',1.62),('15529','2013-09-01','16:00:00',1.61),('15529','2013-09-01','16:05:00',1.58),('15529','2013-09-01','16:10:00',1.52),('15529','2013-09-01','16:15:00',1.48),('15529','2013-09-01','16:20:00',1.44),('15529','2013-09-01','16:25:00',1.41),('15529','2013-09-01','16:30:00',1.35),('15529','2013-09-01','16:35:00',1.29),('15529','2013-09-01','16:40:00',1.27),('15529','2013-09-01','16:45:00',1.23),('15529','2013-09-01','16:50:00',1.18),('15529','2013-09-01','16:55:00',1.11),('15529','2013-09-01','17:00:00',1.06),('15529','2013-09-01','17:05:00',1.03),('15529','2013-08-31','09:00:00',1.01),('15529','2013-08-31','09:05:00',1.05),('15529','2013-08-31','09:10:00',1.11),('15529','2013-08-31','09:15:00',1.16),('15529','2013-08-31','09:20:00',1.2),('15529','2013-08-31','09:25:00',1.24),('15529','2013-08-31','09:30:00',1.29),('15529','2013-08-31','09:35:00',1.33),('15529','2013-08-31','09:40:00',1.38),('15529','2013-08-31','09:45:00',1.41),('15529','2013-08-31','09:50:00',1.46),('15529','2013-08-31','09:55:00',1.49),('15529','2013-08-31','10:00:00',1.53),('15529','2013-08-31','10:05:00',1.55),('15529','2013-08-31','10:10:00',1.59),('15529','2013-08-31','10:15:00',1.61),('15529','2013-08-31','10:20:00',1.64),('15529','2013-08-31','10:25:00',1.68),('15529','2013-08-31','10:30:00',1.71),('15529','2013-08-31','10:35:00',1.75),('15529','2013-08-31','10:40:00',1.78),('15529','2013-08-31','10:45:00',1.81),('15529','2013-08-31','10:50:00',1.83),('15529','2013-08-31','10:55:00',1.86),('15529','2013-08-31','11:00:00',1.88),('15529','2013-08-31','11:05:00',1.93),('15529','2013-08-31','11:10:00',1.93),('15529','2013-08-31','11:15:00',1.98),('15529','2013-08-31','11:20:00',1.98),('15529','2013-08-31','11:25:00',1.99),('15529','2013-08-31','11:30:00',2.01),('15529','2013-08-31','11:35:00',2.06),('15529','2013-08-31','11:40:00',2.06),('15529','2013-08-31','11:45:00',2.09),('15529','2013-08-31','11:50:00',2.08),('15529','2013-08-31','11:55:00',2.08),('15529','2013-08-31','12:00:00',2.08),('15529','2013-08-31','12:05:00',2.08),('15529','2013-08-31','12:10:00',2.07),('15529','2013-08-31','12:15:00',2.12),('15529','2013-08-31','12:20:00',2.07),('15529','2013-08-31','12:25:00',2.06),('15529','2013-08-31','12:30:00',2.16),('15529','2013-08-31','12:35:00',2.15),('15529','2013-08-31','12:40:00',2.17),('15529','2013-08-31','12:45:00',2.15),('15529','2013-08-31','12:50:00',2.15),('15529','2013-08-31','12:55:00',2.17),('15529','2013-08-31','13:00:00',2.18),('15529','2013-08-31','13:05:00',1.95),('15529','2013-08-31','13:10:00',2.16),('15529','2013-08-31','13:15:00',2.22),('15529','2013-08-31','13:20:00',1.87),('15529','2013-08-31','13:25:00',2.16),('15529','2013-08-31','13:30:00',2.21),('15529','2013-08-31','13:35:00',2.19),('15529','2013-08-31','13:40:00',2.2),('15529','2013-08-31','13:45:00',1.99),('15529','2013-08-31','13:50:00',1.9),('15529','2013-08-31','13:55:00',1.96),('15529','2013-08-31','14:00:00',1.79),('15529','2013-08-31','14:05:00',1.96),('15529','2013-08-31','14:10:00',1.94),('15529','2013-08-31','14:15:00',1.72),('15529','2013-08-31','14:20:00',1.81),('15529','2013-08-31','14:25:00',1.92),('15529','2013-08-31','14:30:00',1.73),('15529','2013-08-31','14:35:00',1.79),('15529','2013-08-31','14:40:00',1.84),('15529','2013-08-31','14:45:00',1.74),('15529','2013-08-31','14:50:00',1.08),('15529','2013-08-31','14:55:00',1.61),('15529','2013-08-31','15:00:00',1.73),('15529','2013-08-31','15:05:00',1.78),('15529','2013-08-31','15:10:00',1.73),('15529','2013-08-31','15:15:00',1.68),('15529','2013-08-31','15:20:00',1.68),('15529','2013-08-31','15:25:00',1.49),('15529','2013-08-31','15:30:00',1.35),('15529','2013-08-31','15:35:00',1.41),('15529','2013-08-31','15:40:00',1.51),('15529','2013-08-31','15:45:00',1.42),('15529','2013-08-31','15:50:00',1.24),('15529','2013-08-31','15:55:00',1.16),('15529','2013-08-31','16:00:00',1.34),('15529','2013-08-31','16:05:00',1.45),('15529','2013-08-31','16:10:00',1.38),('15529','2013-08-31','16:15:00',1.42),('15529','2013-08-31','16:20:00',1.43),('15529','2013-08-31','16:25:00',1.32),('15529','2013-08-31','16:30:00',1.43),('15529','2013-08-31','16:35:00',1.45),('15529','2013-08-31','16:40:00',1.31),('15529','2013-08-31','16:45:00',1.19),('15529','2013-08-31','16:50:00',1.14),('15529','2013-08-30','08:50:00',1.01),('15529','2013-08-30','08:55:00',1.09),('15529','2013-08-30','09:00:00',1.14),('15529','2013-08-30','09:05:00',1.03),('15529','2013-08-30','09:15:00',1.14),('15529','2013-08-30','09:20:00',1.24),('15529','2013-08-30','09:25:00',1.33),('15529','2013-08-30','09:30:00',1.36),('15529','2013-08-30','09:35:00',1.43),('15529','2013-08-30','09:40:00',1.41),('15529','2013-08-30','09:45:00',1.38),('15529','2013-08-30','09:50:00',1.42),('15529','2013-08-30','09:55:00',1.5),('15529','2013-08-30','10:00:00',1.6),('15529','2013-08-30','10:05:00',1.56),('15529','2013-08-30','10:10:00',1.62),('15529','2013-08-30','10:15:00',1.66),('15529','2013-08-30','10:20:00',1.67),('15529','2013-08-30','10:25:00',1.7),('15529','2013-08-30','10:30:00',1.73),('15529','2013-08-30','10:35:00',1.77),('15529','2013-08-30','10:40:00',1.81),('15529','2013-08-30','10:45:00',1.85),('15529','2013-08-30','10:50:00',1.9),('15529','2013-08-30','10:55:00',1.9),('15529','2013-08-30','11:00:00',1.95),('15529','2013-08-30','11:05:00',1.97),('15529','2013-08-30','11:10:00',1.99),('15529','2013-08-30','11:15:00',1.99),('15529','2013-08-30','11:20:00',2.05),('15529','2013-08-30','11:25:00',2.04),('15529','2013-08-30','11:30:00',2.07),('15529','2013-08-30','11:35:00',2.1),('15529','2013-08-30','11:40:00',2.09),('15529','2013-08-30','11:45:00',2.12),('15529','2013-08-30','11:50:00',2.13),('15529','2013-08-30','11:55:00',2.14),('15529','2013-08-30','12:00:00',2.17),('15529','2013-08-30','12:05:00',2.16),('15529','2013-08-30','12:10:00',2.2),('15529','2013-08-30','12:15:00',1.99),('15529','2013-08-30','12:20:00',2.21),('15529','2013-08-30','12:25:00',2.19),('15529','2013-08-30','12:30:00',2.18),('15529','2013-08-30','12:35:00',2.2),('15529','2013-08-30','12:40:00',2.22),('15529','2013-08-30','12:45:00',2.18),('15529','2013-08-30','12:50:00',2.21),('15529','2013-08-30','12:55:00',2.21),('15529','2013-08-30','13:00:00',2.21),('15529','2013-08-30','13:05:00',2.2),('15529','2013-08-30','13:10:00',2.18),('15529','2013-08-30','13:15:00',2.16),('15529','2013-08-30','13:20:00',2.16),('15529','2013-08-30','13:25:00',2.18),('15529','2013-08-30','13:30:00',2.2),('15529','2013-08-30','13:35:00',2.17),('15529','2013-08-30','13:40:00',2.2),('15529','2013-08-30','13:45:00',2.17),('15529','2013-08-30','13:50:00',2.18),('15529','2013-08-30','13:55:00',2.17),('15529','2013-08-30','14:00:00',2.18),('15529','2013-08-30','14:05:00',2.15),('15529','2013-08-30','14:10:00',2.08),('15529','2013-08-30','14:15:00',2.1),('15529','2013-08-30','14:20:00',2.07),('15529','2013-08-30','14:25:00',2.05),('15529','2013-08-30','14:30:00',2),('15529','2013-08-30','14:35:00',1.97),('15529','2013-08-30','14:40:00',2.01),('15529','2013-08-30','14:45:00',1.96),('15529','2013-08-30','14:50:00',1.91),('15529','2013-08-30','14:55:00',1.88),('15529','2013-08-30','15:00:00',1.89),('15529','2013-08-30','15:05:00',1.88),('15529','2013-08-30','15:10:00',1.84),('15529','2013-08-30','15:15:00',1.8),('15529','2013-08-30','15:20:00',1.8),('15529','2013-08-30','15:25:00',1.77),('15529','2013-08-30','15:30:00',1.75),('15529','2013-08-30','15:35:00',1.71),('15529','2013-08-30','15:40:00',1.7),('15529','2013-08-30','15:45:00',1.64),('15529','2013-08-30','15:50:00',1.59),('15529','2013-08-30','15:55:00',1.56),('15529','2013-08-30','16:00:00',1.54),('15529','2013-08-30','16:05:00',1.51),('15529','2013-08-30','16:10:00',1.47),('15529','2013-08-30','16:15:00',1.43),('15529','2013-08-30','16:20:00',1.43),('15529','2013-08-30','16:25:00',1.34),('15529','2013-08-30','16:30:00',1.33),('15529','2013-08-30','16:35:00',1.32),('15529','2013-08-30','16:40:00',1.25),('15529','2013-08-30','16:45:00',1.18),('15529','2013-08-30','16:50:00',1.15),('15529','2013-08-30','16:55:00',1.1),('15529','2013-08-30','17:00:00',1.05),('15529','2013-08-30','17:05:00',1.05),('15529','2013-08-30','17:10:00',1),('15529','2013-08-29','10:15:00',1.07),('15529','2013-08-29','10:20:00',1.09),('15529','2013-08-29','10:25:00',1.05),('15529','2013-08-29','10:30:00',1.14),('15529','2013-08-29','10:35:00',1.08),('15529','2013-08-29','10:45:00',1),('15529','2013-08-29','10:50:00',1.06),('15529','2013-08-29','11:00:00',1.07),('15529','2013-08-29','11:05:00',1.14),('15529','2013-08-29','11:10:00',1.23),('15529','2013-08-29','11:15:00',1.2),('15529','2013-08-29','11:20:00',1.22),('15529','2013-08-29','11:25:00',1.27),('15529','2013-08-29','11:30:00',1.34),('15529','2013-08-29','11:35:00',1.28),('15529','2013-08-29','11:40:00',1.4),('15529','2013-08-29','11:45:00',1.42),('15529','2013-08-29','11:50:00',1.61),('15529','2013-08-29','11:55:00',1.36),('15529','2013-08-29','12:00:00',1.17),('15529','2013-08-29','12:05:00',1.05),('15529','2013-08-29','12:10:00',1.2),('15529','2013-08-29','12:15:00',1.28),('15529','2013-08-29','12:20:00',1.41),('15529','2013-08-29','12:25:00',1.64),('15529','2013-08-29','12:30:00',1.75),('15529','2013-08-29','12:35:00',1.64),('15529','2013-08-29','12:40:00',1.65),('15529','2013-08-29','12:45:00',1.68),('15529','2013-08-29','12:50:00',1.62),('15529','2013-08-29','12:55:00',1.46),('15529','2013-08-29','13:00:00',1.48),('15529','2013-08-29','13:05:00',1.43),('15529','2013-08-29','13:10:00',1.39),('15529','2013-08-29','13:15:00',1.37),('15529','2013-08-29','13:20:00',1.85),('15529','2013-08-29','13:25:00',1.92),('15529','2013-08-29','13:30:00',2.13),('15529','2013-08-29','13:35:00',2.07),('15529','2013-08-29','13:40:00',2.19),('15529','2013-08-29','13:45:00',1.9),('15529','2013-08-29','13:50:00',1.98),('15529','2013-08-29','13:55:00',2.08),('15529','2013-08-29','14:00:00',2.07),('15529','2013-08-29','14:05:00',2.03),('15529','2013-08-29','14:10:00',2.1),('15529','2013-08-29','14:15:00',2.03),('15529','2013-08-29','14:20:00',2.15),('15529','2013-08-29','14:25:00',2.05),('15529','2013-08-29','14:30:00',1.98),('15529','2013-08-29','14:35:00',2.12),('15529','2013-08-29','14:40:00',1.87),('15529','2013-08-29','14:45:00',1.56),('15529','2013-08-29','14:50:00',1.54),('15529','2013-08-29','14:55:00',1.46),('15529','2013-08-29','15:00:00',1.28),('15529','2013-08-29','15:05:00',1.2),('15529','2013-08-29','15:10:00',1.32),('15529','2013-08-29','15:15:00',1.4),('15529','2013-08-29','15:20:00',1.27),('15529','2013-08-29','15:25:00',1.14),('15529','2013-08-29','15:30:00',1.08),('15529','2013-08-29','15:40:00',1.06),('15529','2013-08-29','15:45:00',1.23),('15529','2013-08-29','15:50:00',1.24),('15529','2013-08-29','15:55:00',1.17),('15529','2013-08-29','16:00:00',1.08),('15529','2013-08-29','16:35:00',1.24),('15529','2013-08-29','16:50:00',1.23),('15529','2013-08-29','16:55:00',1.21),('15529','2013-08-29','17:00:00',1.17),('15529','2014-04-10','08:50:00',1.01),('15529','2014-04-10','08:55:00',1.08),('15529','2014-04-10','09:00:00',1.12),('15529','2014-04-10','09:05:00',1.17),('15529','2014-04-10','09:10:00',1.21),('15529','2014-04-10','09:15:00',1.25),('15529','2014-04-10','09:20:00',1.29),('15529','2014-04-10','09:25:00',1.32),('15529','2014-04-10','09:30:00',1.36),('15529','2014-04-10','09:35:00',1.41),('15529','2014-04-10','09:40:00',1.46),('15529','2014-04-10','09:45:00',1.5),('15529','2014-04-10','09:50:00',1.53),('15529','2014-04-10','09:55:00',1.58),('15529','2014-04-10','10:00:00',1.64),('15529','2014-04-10','10:05:00',1.68),('15529','2014-04-10','10:10:00',1.71),('15529','2014-04-10','10:15:00',1.74),('15529','2014-04-10','10:20:00',1.78),('15529','2014-04-10','10:25:00',1.81),('15529','2014-04-10','10:30:00',1.83),('15529','2014-04-10','10:35:00',1.88),('15529','2014-04-10','10:40:00',1.89),('15529','2014-04-10','10:45:00',1.94),('15529','2014-04-10','10:50:00',1.99),('15529','2014-04-10','10:55:00',2.01),('15529','2014-04-10','11:00:00',2.02),('15529','2014-04-10','11:05:00',2),('15529','2014-04-10','11:10:00',2.09),('15529','2014-04-10','11:15:00',2.1),('15529','2014-04-10','11:20:00',2.14),('15529','2014-04-10','11:25:00',2.18),('15529','2014-04-10','11:30:00',2.19),('15529','2014-04-10','11:35:00',2.18),('15529','2014-04-10','11:40:00',2.24),('15529','2014-04-10','11:45:00',2),('15529','2014-04-10','11:50:00',2.35),('15529','2014-04-10','11:55:00',2.28),('15529','2014-04-10','12:00:00',2.29),('15529','2014-04-10','12:05:00',2.33),('15529','2014-04-10','12:10:00',2.37),('15529','2014-04-10','12:15:00',2.36),('15529','2014-04-10','12:20:00',2.44),('15529','2014-04-10','12:25:00',2.28),('15529','2014-04-10','12:30:00',2.11),('15529','2014-04-10','12:35:00',2.55),('15529','2014-04-10','12:40:00',2.08),('15529','2014-04-10','12:45:00',2.67),('15529','2014-04-10','12:50:00',2.43),('15529','2014-04-10','12:55:00',2.27),('15529','2014-04-10','13:00:00',1.84),('15529','2014-04-10','13:05:00',2.37),('15529','2014-04-10','13:10:00',2.47),('15529','2014-04-10','13:15:00',2.49),('15529','2014-04-10','13:20:00',2.03),('15529','2014-04-10','13:25:00',1.87),('15529','2014-04-10','13:30:00',2.01),('15529','2014-04-10','13:35:00',2.14),('15529','2014-04-10','13:40:00',2.48),('15529','2014-04-10','13:45:00',2.4),('15529','2014-04-10','13:50:00',2.26),('15529','2014-04-10','13:55:00',1.66),('15529','2014-04-10','14:00:00',2.51),('15529','2014-04-10','14:05:00',1.74),('15529','2014-04-10','14:10:00',2.06),('15529','2014-04-10','14:15:00',1.68),('15529','2014-04-10','14:20:00',2.56),('15529','2014-04-10','14:25:00',1.83),('15529','2014-04-10','14:30:00',1.57),('15529','2014-04-10','14:35:00',2.18),('15529','2014-04-10','14:40:00',2.33),('15529','2014-04-10','14:45:00',2.11),('15529','2014-04-10','14:50:00',2.28),('15529','2014-04-10','14:55:00',2.17),('15529','2014-04-10','15:00:00',2.18),('15529','2014-04-10','15:05:00',2.17),('15529','2014-04-10','15:10:00',2.06),('15529','2014-04-10','15:15:00',2.01),('15529','2014-04-10','15:20:00',1.88),('15529','2014-04-10','15:25:00',1.99),('15529','2014-04-10','15:30:00',1.95),('15529','2014-04-10','15:35:00',1.89),('15529','2014-04-10','15:40:00',1.88),('15529','2014-04-10','15:45:00',1.84),('15529','2014-04-10','15:50:00',1.82),('15529','2014-04-10','15:55:00',1.77),('15529','2014-04-10','16:00:00',1.74),('15529','2014-04-10','16:05:00',1.68),('15529','2014-04-10','16:10:00',1.64),('15529','2014-04-10','16:15:00',1.61),('15529','2014-04-10','16:20:00',1.56),('15529','2014-04-10','16:25:00',1.54),('15529','2014-04-10','16:30:00',1.42),('15529','2014-04-10','16:35:00',1.28),('15529','2014-04-10','16:40:00',1.46),('15529','2014-04-10','16:45:00',1.38),('15529','2014-04-10','16:50:00',1.36),('15529','2014-04-10','16:55:00',1.03),('15529','2014-04-10','17:00:00',1.32),('15529','2014-04-10','17:05:00',1.16),('15529','2014-04-10','17:10:00',1.19),('15529','2014-04-10','17:20:00',1.02),('15529','2013-08-28','11:10:00',1.05),('15529','2013-08-28','11:15:00',1.02),('15529','2013-08-28','12:05:00',1.12),('15529','2013-08-28','12:10:00',1.43),('15529','2013-08-28','12:15:00',1.4),('15529','2013-08-28','12:20:00',1.69),('15529','2013-08-28','12:25:00',1.42),('15529','2013-08-28','12:30:00',1.5),('15529','2013-08-28','12:35:00',1.81),('15529','2013-08-28','12:40:00',2.47),('15529','2013-08-28','12:45:00',2.26),('15529','2013-08-28','12:50:00',1.52),('15529','2013-08-28','12:55:00',1.65),('15529','2013-08-28','13:00:00',1.27),('15529','2013-08-28','13:05:00',1.31),('15529','2013-08-28','13:10:00',1.18),('15529','2013-08-28','13:15:00',1.18),('15529','2013-08-28','13:20:00',1.1),('15529','2013-08-28','14:00:00',1.05),('15529','2013-08-28','15:30:00',1.41),('15529','2013-08-28','15:35:00',1),('15529','2013-08-28','15:40:00',1.2),('15529','2013-08-28','15:45:00',1.15),('15529','2013-08-28','15:50:00',1.42),('15529','2013-08-28','15:55:00',1.83),('15529','2013-08-28','16:00:00',1.37),('15529','2013-08-28','16:05:00',1.78),('15529','2013-08-28','16:10:00',1.71),('15529','2013-08-28','16:15:00',1.62),('15529','2013-08-28','16:20:00',1.56),('15529','2013-08-28','16:25:00',1.49),('15529','2013-08-28','16:30:00',1.41),('15529','2013-08-28','16:35:00',1.4),('15529','2013-08-28','16:40:00',1.36),('15529','2013-08-28','16:45:00',1.31),('15529','2013-08-28','16:50:00',1.26),('15529','2013-08-28','16:55:00',1.21),('15529','2013-08-28','17:00:00',1.16),('15529','2013-08-28','17:05:00',1.11),('15529','2013-08-28','17:10:00',1.07),('15529','2013-08-28','17:15:00',1.03),('15529','2013-08-27','09:35:00',1.39),('15529','2013-08-27','09:40:00',1.38),('15529','2013-08-27','09:45:00',1.43),('15529','2013-08-27','09:50:00',1.47),('15529','2013-08-27','09:55:00',1.46),('15529','2013-08-27','10:00:00',1.51),('15529','2013-08-27','10:05:00',1.6),('15529','2013-08-27','10:10:00',1.74),('15529','2013-08-27','10:15:00',1.87),('15529','2013-08-27','10:25:00',1.1),('15529','2013-08-27','10:30:00',1.14),('15529','2013-08-27','10:40:00',1.71),('15529','2013-08-27','10:50:00',1.9),('15529','2013-08-27','10:55:00',1.99),('15529','2013-08-27','11:15:00',1.9),('15529','2013-08-27','11:20:00',2.01),('15529','2013-08-27','11:25:00',1.68),('15529','2013-08-27','11:30:00',2.24),('15529','2013-08-27','11:35:00',1.5),('15529','2013-08-27','11:40:00',2.28),('15529','2013-08-27','11:45:00',2.29),('15529','2013-08-27','11:50:00',1.02),('15529','2013-08-27','11:55:00',1.2),('15529','2013-08-27','12:05:00',2.37),('15529','2013-08-27','12:10:00',2.32),('15529','2013-08-27','12:15:00',2.3),('15529','2013-08-27','12:20:00',1.68),('15529','2013-08-27','12:25:00',2.03),('15529','2013-08-27','12:30:00',2.13),('15529','2013-08-27','12:35:00',2.31),('15529','2013-08-27','12:40:00',2.34),('15529','2013-08-27','12:45:00',2.1),('15529','2013-08-27','12:50:00',2.24),('15529','2013-08-27','12:55:00',1.96),('15529','2013-08-27','13:00:00',1.85),('15529','2013-08-27','13:05:00',2.35),('15529','2013-08-27','13:10:00',2.31),('15529','2013-08-27','13:15:00',2.31),('15529','2013-08-27','13:20:00',2.23),('15529','2013-08-27','13:25:00',1.97),('15529','2013-08-27','13:30:00',2.08),('15529','2013-08-27','13:35:00',2.34),('15529','2013-08-27','13:40:00',1.55),('15529','2013-08-27','13:45:00',2.39),('15529','2013-08-27','13:50:00',2.35),('15529','2013-08-27','13:55:00',2.33),('15529','2013-08-27','14:00:00',2.26),('15529','2013-08-27','14:05:00',2.27),('15529','2013-08-27','14:10:00',2.27),('15529','2013-08-27','14:15:00',2.2),('15529','2013-08-27','14:20:00',2.24),('15529','2013-08-27','14:25:00',2.24),('15529','2013-08-27','14:30:00',2.1),('15529','2013-08-27','14:35:00',2.17),('15529','2013-08-27','14:40:00',2.13),('15529','2013-08-27','14:45:00',2.09),('15529','2013-08-27','14:50:00',2.09),('15529','2013-08-27','14:55:00',2.04),('15529','2013-08-27','15:00:00',2.03),('15529','2013-08-27','15:05:00',2.06),('15529','2013-08-27','15:10:00',2),('15529','2013-08-27','15:15:00',1.96),('15529','2013-08-27','15:20:00',1.86),('15529','2013-08-27','15:25:00',1.8),('15529','2013-08-27','15:30:00',1.09),('15529','2013-08-27','15:35:00',1),('15529','2013-08-27','15:40:00',1.35),('15529','2013-08-27','15:45:00',1.18),('15529','2013-08-27','15:50:00',1.88),('15529','2013-08-27','15:55:00',1.84),('15529','2013-08-27','16:00:00',1.79),('15529','2013-08-27','16:05:00',1.76),('15529','2013-08-27','16:10:00',1.59),('15529','2013-08-27','16:15:00',1.35),('15529','2013-08-27','16:20:00',1.66),('15529','2013-08-27','16:25:00',1.49),('15529','2013-08-27','16:30:00',1.35),('15529','2013-08-27','16:35:00',1.41),('15529','2013-08-27','16:40:00',1.41),('15529','2013-08-27','16:45:00',1.34),('15529','2013-08-27','16:50:00',1.29),('15529','2013-08-27','16:55:00',1.26),('15529','2013-08-27','17:00:00',1.22),('15529','2013-08-27','17:15:00',1.07),('15529','2013-08-26','09:25:00',1.12),('15529','2013-08-26','09:30:00',1.17),('15529','2013-08-26','10:00:00',1.12),('15529','2013-08-26','10:05:00',1.32),('15529','2013-08-26','10:10:00',1.54),('15529','2013-08-26','10:15:00',1.6),('15529','2013-08-26','10:20:00',1.64),('15529','2013-08-26','10:25:00',1.67),('15529','2013-08-26','10:30:00',1.7),('15529','2013-08-26','10:35:00',1.72),('15529','2013-08-26','10:40:00',1.69),('15529','2013-08-26','10:45:00',1.75),('15529','2013-08-26','10:50:00',1.79),('15529','2013-08-26','10:55:00',1.82),('15529','2013-08-26','11:00:00',1.82),('15529','2013-08-26','11:05:00',1.82),('15529','2013-08-26','11:10:00',1.85),('15529','2013-08-26','11:15:00',1.9),('15529','2013-08-26','11:20:00',1.88),('15529','2013-08-26','11:25:00',1.89),('15529','2013-08-26','11:30:00',1.94),('15529','2013-08-26','11:35:00',1.9),('15529','2013-08-26','11:40:00',1.73),('15529','2013-08-26','11:45:00',1.61),('15529','2013-08-26','11:50:00',1.44),('15529','2013-08-26','11:55:00',2.05),('15529','2013-08-26','12:00:00',1.94),('15529','2013-08-26','12:05:00',1.81),('15529','2013-08-26','12:10:00',1.57),('15529','2013-08-26','12:15:00',2.01),('15529','2013-08-26','12:20:00',2.16),('15529','2013-08-26','12:35:00',1.11),('15529','2013-08-26','12:40:00',1.65),('15529','2013-08-26','12:45:00',1.04),('15529','2013-08-26','13:15:00',1.15),('15529','2013-08-26','13:45:00',1.32),('15529','2013-08-26','13:50:00',1.27),('15529','2013-08-26','13:55:00',1.88),('15529','2013-08-26','14:00:00',2.17),('15529','2013-08-26','14:05:00',1.08),('15529','2013-08-26','14:10:00',1.26),('15529','2013-08-26','14:15:00',1.46),('15529','2013-08-26','16:05:00',1.5),('15529','2013-08-26','16:10:00',1.88),('15529','2013-08-26','16:15:00',1.53),('15529','2013-08-26','16:35:00',1.02),('15529','2013-08-26','16:45:00',1.21),('15529','2013-08-26','16:50:00',1.43),('15529','2013-08-26','16:55:00',1.23),('15529','2013-08-26','17:05:00',1.22),('15529','2013-08-26','17:10:00',1.12),('15529','2013-08-25','09:00:00',1.02),('15529','2013-08-25','09:05:00',1.06),('15529','2013-08-25','09:10:00',1.11),('15529','2013-08-25','09:15:00',1.14),('15529','2013-08-25','09:20:00',1.19),('15529','2013-08-25','09:25:00',1.22),('15529','2013-08-25','09:30:00',1.26),('15529','2013-08-25','09:35:00',1.31),('15529','2013-08-25','09:40:00',1.35),('15529','2013-08-25','09:45:00',1.39),('15529','2013-08-25','09:50:00',1.42),('15529','2013-08-25','09:55:00',1.46),('15529','2013-08-25','10:00:00',1.48),('15529','2013-08-25','10:05:00',1.53),('15529','2013-08-25','10:10:00',1.58),('15529','2013-08-25','10:15:00',1.59),('15529','2013-08-25','10:20:00',1.64),('15529','2013-08-25','10:25:00',1.68),('15529','2013-08-25','10:30:00',1.71),('15529','2013-08-25','10:35:00',1.73),('15529','2013-08-25','10:40:00',1.78),('15529','2013-08-25','10:45:00',1.78),('15529','2013-08-25','10:50:00',1.82),('15529','2013-08-25','10:55:00',1.86),('15529','2013-08-25','11:00:00',1.89),('15529','2013-08-25','11:05:00',1.9),('15529','2013-08-25','11:10:00',1.89),('15529','2013-08-25','11:15:00',1.97),('15529','2013-08-25','11:20:00',1.96),('15529','2013-08-25','11:25:00',1.95),('15529','2013-08-25','11:30:00',1.99),('15529','2013-08-25','11:35:00',2.04),('15529','2013-08-25','11:40:00',2.05),('15529','2013-08-25','11:45:00',2.05),('15529','2013-08-25','11:50:00',2.06),('15529','2013-08-25','11:55:00',2.06),('15529','2013-08-25','12:00:00',2.01),('15529','2013-08-25','12:05:00',2.07),('15529','2013-08-25','12:10:00',2.09),('15529','2013-08-25','12:15:00',2.1),('15529','2013-08-25','12:20:00',2.09),('15529','2013-08-25','12:25:00',2.11),('15529','2013-08-25','12:30:00',2.08),('15529','2013-08-25','12:35:00',2.11),('15529','2013-08-25','12:40:00',2.03),('15529','2013-08-25','12:45:00',2.11),('15529','2013-08-25','12:50:00',2.15),('15529','2013-08-25','12:55:00',2.16),('15529','2013-08-25','13:00:00',1.96),('15529','2013-08-25','13:05:00',2),('15529','2013-08-25','13:10:00',1.8),('15529','2013-08-25','13:15:00',2.25),('15529','2013-08-25','13:20:00',1.97),('15529','2013-08-25','13:25:00',1.86),('15529','2013-08-25','13:30:00',1.45),('15529','2013-08-25','13:35:00',2.17),('15529','2013-08-25','13:40:00',2.14),('15529','2013-08-25','13:45:00',2.22),('15529','2013-08-25','13:50:00',2),('15529','2013-08-25','13:55:00',1.65),('15529','2013-08-25','14:00:00',1.72),('15529','2013-08-25','14:05:00',1.87),('15529','2013-08-25','14:10:00',1.75),('15529','2013-08-25','14:15:00',1.86),('15529','2013-08-25','14:20:00',2.08),('15529','2013-08-25','14:25:00',2.11),('15529','2013-08-25','14:30:00',2.08),('15529','2013-08-25','14:35:00',1.96),('15529','2013-08-25','14:40:00',1.79),('15529','2013-08-25','14:45:00',1.24),('15529','2013-08-25','14:50:00',1.05),('15529','2013-08-25','16:00:00',1.51),('15529','2013-08-25','16:05:00',1.69),('15529','2013-08-25','16:10:00',1.52),('15529','2013-08-25','16:15:00',1.49),('15529','2013-08-25','16:20:00',1.44),('15529','2013-08-25','16:25:00',1.39),('15529','2013-08-25','16:30:00',1.36),('15529','2013-08-25','16:35:00',1.34),('15529','2013-08-25','16:40:00',1.31),('15529','2013-08-25','16:45:00',1.25),('15529','2013-08-25','16:50:00',1.16),('15529','2013-08-25','16:55:00',1.15),('15529','2013-08-25','17:00:00',1.11),('15529','2013-08-25','17:05:00',1.01),('15529','2013-08-25','17:10:00',1.01),('15529','2013-08-24','09:15:00',1.03),('15529','2013-08-24','09:20:00',1.18),('15529','2013-08-24','09:25:00',1.24),('15529','2013-08-24','09:30:00',1.27),('15529','2013-08-24','09:50:00',1.39),('15529','2013-08-24','09:55:00',1.54),('15529','2013-08-24','10:00:00',1.11),('15529','2013-08-24','15:30:00',1.29),('15529','2013-08-24','15:35:00',1.87),('15529','2013-08-24','15:40:00',1.33),('15529','2013-08-24','15:50:00',1.3),('15529','2013-08-24','15:55:00',1.7),('15529','2013-08-24','16:00:00',1.88),('15529','2013-08-24','16:05:00',1.72),('15529','2013-08-24','16:10:00',1.65),('15529','2013-08-24','16:15:00',1.6),('15529','2013-08-24','16:20:00',1.56),('15529','2013-08-24','16:25:00',1.52),('15529','2013-08-24','16:30:00',1.46),('15529','2013-08-24','16:35:00',1.37),('15529','2013-08-24','16:50:00',1.16),('15529','2013-08-24','16:55:00',1.39),('15529','2013-08-24','17:00:00',1.26),('15529','2013-08-24','17:05:00',1.19),('15529','2013-08-24','17:10:00',1.11),('15529','2013-08-24','17:15:00',1.03),('15529','2013-08-23','09:10:00',1.08),('15529','2013-08-23','09:15:00',1.12),('15529','2013-08-23','09:20:00',1.05),('15529','2013-08-23','09:35:00',1.31),('15529','2013-08-23','09:40:00',1.33),('15529','2013-08-23','09:45:00',1.39),('15529','2013-08-23','09:50:00',1.4),('15529','2013-08-23','09:55:00',1.46),('15529','2013-08-23','10:00:00',1.48),('15529','2013-08-23','10:05:00',1.51),('15529','2013-08-23','10:10:00',1.31),('15529','2013-08-23','10:15:00',1.61),('15529','2013-08-23','10:20:00',1.62),('15529','2013-08-23','10:25:00',1.64),('15529','2013-08-23','10:30:00',1.68),('15529','2013-08-23','10:35:00',1.72),('15529','2013-08-23','10:40:00',1.74),('15529','2013-08-23','10:45:00',1.82),('15529','2013-08-23','10:50:00',1.82),('15529','2013-08-23','10:55:00',1.85),('15529','2013-08-23','11:00:00',1.88),('15529','2013-08-23','11:05:00',1.87),('15529','2013-08-23','11:10:00',1.89),('15529','2013-08-23','11:15:00',1.92),('15529','2013-08-23','11:20:00',1.94),('15529','2013-08-23','11:25:00',1.94),('15529','2013-08-23','11:30:00',1.95),('15529','2013-08-23','11:35:00',1.95),('15529','2013-08-23','11:40:00',2.01),('15529','2013-08-23','11:45:00',2.01),('15529','2013-08-23','11:50:00',2),('15529','2013-08-23','11:55:00',2),('15529','2013-08-23','12:00:00',2.02),('15529','2013-08-23','12:05:00',2.06),('15529','2013-08-23','12:10:00',2.09),('15529','2013-08-23','12:15:00',2.11),('15529','2013-08-23','12:20:00',2.1),('15529','2013-08-23','12:25:00',2.13),('15529','2013-08-23','12:30:00',2.11),('15529','2013-08-23','12:35:00',2.13),('15529','2013-08-23','12:40:00',2.14),('15529','2013-08-23','12:45:00',2.15),('15529','2013-08-23','12:50:00',2.14),('15529','2013-08-23','12:55:00',2.14),('15529','2013-08-23','13:00:00',2.2),('15529','2013-08-23','13:05:00',2.14),('15529','2013-08-23','13:10:00',2.16),('15529','2013-08-23','13:15:00',2.13),('15529','2013-08-23','13:20:00',2.11),('15529','2013-08-23','13:25:00',2.18),('15529','2013-08-23','13:30:00',2.12),('15529','2013-08-23','13:35:00',2.05),('15529','2013-08-23','13:40:00',2.15),('15529','2013-08-23','13:45:00',2.18),('15529','2013-08-23','13:50:00',2.1),('15529','2013-08-23','13:55:00',2.13),('15529','2013-08-23','14:00:00',2.12),('15529','2013-08-23','14:05:00',2.1),('15529','2013-08-23','14:10:00',2.1),('15529','2013-08-23','14:15:00',2.1),('15529','2013-08-23','14:20:00',2.08),('15529','2013-08-23','14:25:00',2.06),('15529','2013-08-23','14:30:00',2.05),('15529','2013-08-23','14:35:00',2.05),('15529','2013-08-23','14:40:00',2.05),('15529','2013-08-23','14:45:00',2.01),('15529','2013-08-23','14:50:00',1.99),('15529','2013-08-23','14:55:00',1.95),('15529','2013-08-23','15:00:00',1.93),('15529','2013-08-23','15:05:00',1.91),('15529','2013-08-23','15:10:00',1.89),('15529','2013-08-23','15:15:00',1.87),('15529','2013-08-23','15:20:00',1.84),('15529','2013-08-23','15:25:00',1.83),('15529','2013-08-23','15:30:00',1.78),('15529','2013-08-23','15:35:00',1.76),('15529','2013-08-23','15:40:00',1.73),('15529','2013-08-23','15:45:00',1.7),('15529','2013-08-23','15:50:00',1.68),('15529','2013-08-23','15:55:00',1.65),('15529','2013-08-23','16:00:00',1.61),('15529','2013-08-23','16:05:00',1.56),('15529','2013-08-23','16:10:00',1.55),('15529','2013-08-23','16:15:00',1.51),('15529','2013-08-23','16:20:00',1.46),('15529','2013-08-23','16:25:00',1.42),('15529','2013-08-23','16:30:00',1.39),('15529','2013-08-23','16:35:00',1.36),('15529','2013-08-23','16:40:00',1.31),('15529','2013-08-23','16:45:00',1.27),('15529','2013-08-23','16:50:00',1.22),('15529','2013-08-23','16:55:00',1.19),('15529','2013-08-23','17:00:00',1.14),('15529','2013-08-23','17:05:00',1.1),('15529','2013-08-23','17:10:00',1.05),('15529','2013-08-23','17:15:00',1.01),('15529','2013-08-22','09:15:00',1.03),('15529','2013-08-22','09:20:00',1.06),('15529','2013-08-22','09:25:00',1.1),('15529','2013-08-22','09:30:00',1.13),('15529','2013-08-22','09:35:00',1.17),('15529','2013-08-22','09:40:00',1.2),('15529','2013-08-22','09:45:00',1.23),('15529','2013-08-22','09:50:00',1.28),('15529','2013-08-22','09:55:00',1.31),('15529','2013-08-22','10:00:00',1.34),('15529','2013-08-22','10:05:00',1.38),('15529','2013-08-22','10:10:00',1.43),('15529','2013-08-22','10:15:00',1.42),('15529','2013-08-22','10:20:00',1.48),('15529','2013-08-22','10:25:00',1.48),('15529','2013-08-22','10:30:00',1.53),('15529','2013-08-22','10:35:00',1.57),('15529','2013-08-22','10:40:00',1.59),('15529','2013-08-22','10:45:00',1.65),('15529','2013-08-22','10:50:00',1.74),('15529','2013-08-22','10:55:00',1.74),('15529','2013-08-22','11:00:00',1.7),('15529','2013-08-22','11:05:00',1.76),('15529','2013-08-22','11:10:00',1.7),('15529','2013-08-22','11:15:00',1.6),('15529','2013-08-22','11:20:00',1.92),('15529','2013-08-22','11:25:00',1.92),('15529','2013-08-22','11:30:00',1.72),('15529','2013-08-22','11:50:00',1.82),('15529','2013-08-22','12:05:00',1.93),('15529','2013-08-22','12:10:00',2.13),('15529','2013-08-22','12:15:00',2.03),('15529','2013-08-22','12:20:00',2.11),('15529','2013-08-22','12:25:00',2.17),('15529','2013-08-22','12:40:00',1.16),('15529','2013-08-22','12:50:00',1.93),('15529','2013-08-22','12:55:00',2.2),('15529','2013-08-22','13:00:00',1.05),('15529','2013-08-22','13:05:00',2.32),('15529','2013-08-22','13:10:00',1.38),('15529','2013-08-22','13:15:00',2.09),('15529','2013-08-22','13:20:00',2.15),('15529','2013-08-22','13:25:00',1.91),('15529','2013-08-22','13:30:00',2.09),('15529','2013-08-22','13:35:00',2.1),('15529','2013-08-22','13:40:00',1.47),('15529','2013-08-22','13:45:00',1.96),('15529','2013-08-22','13:50:00',1.98),('15529','2013-08-22','13:55:00',2.17),('15529','2013-08-22','14:00:00',1.95),('15529','2013-08-22','14:05:00',2.13),('15529','2013-08-22','14:10:00',1.84),('15529','2013-08-22','14:15:00',2.06),('15529','2013-08-22','14:20:00',2.03),('15529','2013-08-22','14:25:00',2.04),('15529','2013-08-22','14:30:00',2),('15529','2013-08-22','14:35:00',2.03),('15529','2013-08-22','14:40:00',1.98),('15529','2013-08-22','14:45:00',1.97),('15529','2013-08-22','14:50:00',1.95),('15529','2013-08-22','14:55:00',1.97),('15529','2013-08-22','15:00:00',1.92),('15529','2013-08-22','15:05:00',1.87),('15529','2013-08-22','15:10:00',1.88),('15529','2013-08-22','15:15:00',1.82),('15529','2013-08-22','15:20:00',1.84),('15529','2013-08-22','15:25:00',1.81),('15529','2013-08-22','15:30:00',1.84),('15529','2013-08-22','15:35:00',1.66),('15529','2013-08-22','15:40:00',1.7),('15529','2013-08-22','15:45:00',1.64),('15529','2013-08-22','15:50:00',1.52),('15529','2013-08-22','15:55:00',1.62),('15529','2013-08-22','16:00:00',1.53),('15529','2013-08-22','16:05:00',1.44),('15529','2013-08-22','16:10:00',1.33),('15529','2013-08-22','16:15:00',1.51),('15529','2013-08-22','16:20:00',1.51),('15529','2013-08-22','16:25:00',1.48),('15529','2013-08-22','16:30:00',1.44),('15529','2013-08-22','16:35:00',1.41),('15529','2013-08-22','16:40:00',1.35),('15529','2013-08-22','16:45:00',1.28),('15529','2013-08-22','16:50:00',1.23),('15529','2013-08-22','16:55:00',1.19),('15529','2013-08-22','17:00:00',1.13),('15529','2013-08-22','17:05:00',1.08),('15529','2013-08-22','17:10:00',1.03),('15529','2013-08-21','09:00:00',1),('15529','2013-08-21','09:05:00',1.11),('15529','2013-08-21','09:10:00',1.15),('15529','2013-08-21','09:15:00',1.02),('15529','2013-08-21','09:20:00',1.27),('15529','2013-08-21','09:25:00',1.32),('15529','2013-08-21','09:30:00',1.4),('15529','2013-08-21','09:35:00',1.17),('15529','2013-08-21','09:40:00',1.39),('15529','2013-08-21','09:45:00',1.4),('15529','2013-08-21','09:50:00',1.39),('15529','2013-08-21','09:55:00',1.46),('15529','2013-08-21','10:00:00',1.52),('15529','2013-08-21','10:05:00',1.55),('15529','2013-08-21','10:10:00',1.56),('15529','2013-08-21','10:15:00',1.55),('15529','2013-08-21','10:20:00',1.58),('15529','2013-08-21','10:25:00',1.63),('15529','2013-08-21','10:30:00',1.66),('15529','2013-08-21','10:35:00',1.68),('15529','2013-08-21','10:40:00',1.69),('15529','2013-08-21','10:45:00',1.72),('15529','2013-08-21','10:50:00',1.75),('15529','2013-08-21','10:55:00',1.78),('15529','2013-08-21','11:00:00',1.79),('15529','2013-08-21','11:05:00',1.82),('15529','2013-08-21','11:10:00',1.82),('15529','2013-08-21','11:15:00',1.87),('15529','2013-08-21','11:20:00',1.88),('15529','2013-08-21','11:25:00',1.91),('15529','2013-08-21','11:30:00',1.9),('15529','2013-08-21','11:35:00',1.9),('15529','2013-08-21','11:40:00',1.95),('15529','2013-08-21','11:45:00',1.95),('15529','2013-08-21','11:50:00',1.94),('15529','2013-08-21','11:55:00',1.95),('15529','2013-08-21','12:00:00',1.94),('15529','2013-08-21','12:05:00',1.94),('15529','2013-08-21','12:10:00',1.99),('15529','2013-08-21','12:15:00',1.99),('15529','2013-08-21','12:20:00',2.01),('15529','2013-08-21','12:25:00',2),('15529','2013-08-21','12:30:00',1.94),('15529','2013-08-21','12:35:00',2),('15529','2013-08-21','12:40:00',2.02),('15529','2013-08-21','12:45:00',2.04),('15529','2013-08-21','12:50:00',2.04),('15529','2013-08-21','12:55:00',2.06),('15529','2013-08-21','13:00:00',2.06),('15529','2013-08-21','13:05:00',2.07),('15529','2013-08-21','13:10:00',2.03),('15529','2013-08-21','13:15:00',2.05),('15529','2013-08-21','13:20:00',2.03),('15529','2013-08-21','13:25:00',1.99),('15529','2013-08-21','13:30:00',2.01),('15529','2013-08-21','13:35:00',2.01),('15529','2013-08-21','13:40:00',2.03),('15529','2013-08-21','13:45:00',2),('15529','2013-08-21','13:50:00',1.95),('15529','2013-08-21','13:55:00',1.93),('15529','2013-08-21','14:00:00',1.95),('15529','2013-08-21','14:05:00',1.97),('15529','2013-08-21','14:10:00',1.97),('15529','2013-08-21','14:15:00',1.96),('15529','2013-08-21','14:20:00',1.96),('15529','2013-08-21','14:25:00',1.9),('15529','2013-08-21','14:30:00',1.78),('15529','2013-08-21','14:35:00',1.08),('15529','2013-08-21','14:50:00',1.96),('15529','2013-08-21','14:55:00',1.86),('15529','2013-08-21','15:00:00',1.86),('15529','2013-08-21','15:05:00',1.84),('15529','2013-08-21','15:10:00',1.82),('15529','2013-08-21','15:15:00',1.79),('15529','2013-08-21','15:20:00',1.75),('15529','2013-08-21','15:25:00',1.74),('15529','2013-08-21','15:30:00',1.71),('15529','2013-08-21','15:35:00',1.68),('15529','2013-08-21','15:40:00',1.64),('15529','2013-08-21','15:45:00',1.63),('15529','2013-08-21','15:50:00',1.58),('15529','2013-08-21','15:55:00',1.56),('15529','2013-08-21','16:00:00',1.54),('15529','2013-08-21','16:05:00',1.51),('15529','2013-08-21','16:10:00',1.48),('15529','2013-08-21','16:15:00',1.44),('15529','2013-08-21','16:20:00',1.4),('15529','2013-08-21','16:25:00',1.36),('15529','2013-08-21','16:30:00',1.33),('15529','2013-08-21','16:35:00',1.29),('15529','2013-08-21','16:40:00',1.24),('15529','2013-08-21','16:45:00',1.2),('15529','2013-08-21','16:50:00',1.16),('15529','2013-08-21','16:55:00',1.1),('15529','2013-08-21','17:00:00',1.08),('15529','2013-08-21','17:05:00',1.02),('15529','2013-08-20','09:55:00',1.31),('15529','2013-08-20','10:00:00',1.71),('15529','2013-08-20','10:05:00',1.67),('15529','2013-08-20','10:10:00',1.53),('15529','2013-08-20','10:15:00',1.45),('15529','2013-08-20','10:20:00',1.48),('15529','2013-08-20','10:25:00',1.54),('15529','2013-08-20','10:30:00',1.45),('15529','2013-08-20','10:35:00',1.74),('15529','2013-08-20','10:40:00',1.43),('15529','2013-08-20','10:45:00',1.54),('15529','2013-08-20','10:50:00',1.6),('15529','2013-08-20','10:55:00',1.23),('15529','2013-08-20','11:00:00',1.35),('15529','2013-08-20','11:15:00',1.01),('15529','2013-08-20','11:20:00',1.6),('15529','2013-08-20','11:25:00',2.16),('15529','2013-08-20','11:30:00',2.27),('15529','2013-08-20','11:35:00',2.22),('15529','2013-08-20','11:40:00',2.14),('15529','2013-08-20','11:45:00',2.13),('15529','2013-08-20','11:50:00',2.04),('15529','2013-08-20','11:55:00',2.11),('15529','2013-08-20','12:00:00',2.13),('15529','2013-08-20','12:05:00',2.12),('15529','2013-08-20','12:10:00',2.09),('15529','2013-08-20','12:15:00',2.09),('15529','2013-08-20','12:20:00',2.15),('15529','2013-08-20','12:25:00',2.12),('15529','2013-08-20','12:30:00',1.97),('15529','2013-08-20','12:35:00',1.75),('15529','2013-08-20','12:40:00',1.9),('15529','2013-08-20','12:45:00',2.06),('15529','2013-08-20','12:50:00',1.91),('15529','2013-08-20','12:55:00',2.02),('15529','2013-08-20','13:00:00',2.01),('15529','2013-08-20','13:05:00',1.99),('15529','2013-08-20','13:10:00',2.07),('15529','2013-08-20','13:15:00',2.08),('15529','2013-08-20','13:20:00',2.12),('15529','2013-08-20','13:25:00',2.07),('15529','2013-08-20','13:30:00',2.08),('15529','2013-08-20','13:35:00',2),('15529','2013-08-20','13:40:00',1.95),('15529','2013-08-20','13:45:00',1.92),('15529','2013-08-20','13:50:00',1.97),('15529','2013-08-20','13:55:00',2.07),('15529','2013-08-20','14:00:00',2.06),('15529','2013-08-20','14:05:00',1.92),('15529','2013-08-20','14:10:00',2.06),('15529','2013-08-20','14:15:00',1.92),('15529','2013-08-20','14:20:00',1.32),('15529','2013-08-20','14:25:00',1.35),('15529','2013-08-20','14:30:00',1.94),('15529','2013-08-20','14:35:00',1.89),('15529','2013-08-20','14:40:00',1.82),('15529','2013-08-20','14:45:00',1.8),('15529','2013-08-20','14:50:00',1.81),('15529','2013-08-20','14:55:00',1.83),('15529','2013-08-20','15:00:00',1.84),('15529','2013-08-20','15:05:00',1.74),('15529','2013-08-20','15:10:00',1.73),('15529','2013-08-20','15:15:00',1.6),('15529','2013-08-20','15:20:00',1.58),('15529','2013-08-20','15:25:00',1.51),('15529','2013-08-20','15:30:00',1.46),('15529','2013-08-20','15:35:00',1.37),('15529','2013-08-20','15:40:00',1.38),('15529','2013-08-20','15:45:00',1.42),('15529','2013-08-20','15:50:00',1.41),('15529','2013-08-20','15:55:00',1.42),('15529','2013-08-20','16:00:00',1.32),('15529','2013-08-20','16:05:00',1.26),('15529','2013-08-20','16:10:00',1.21),('15529','2013-08-20','16:15:00',1.24),('15529','2013-08-20','16:20:00',1.3),('15529','2013-08-20','16:25:00',1.33),('15529','2013-08-20','16:30:00',1.39),('15529','2013-08-20','16:35:00',1.36),('15529','2013-08-20','16:40:00',1.28),('15529','2013-08-20','16:45:00',1.25),('15529','2013-08-20','16:50:00',1.21),('15529','2013-08-20','16:55:00',1.17),('15529','2013-08-20','17:00:00',1.14),('15529','2013-08-20','17:05:00',1.11),('15529','2013-08-20','17:10:00',1.07),('15529','2013-08-20','17:15:00',1.03),('15529','2013-08-20','17:20:00',1.01),('15529','2013-08-19','09:25:00',1.38),('15529','2013-08-19','09:30:00',1.22),('15529','2013-08-19','09:35:00',1.22),('15529','2013-08-19','10:35:00',1.22),('15529','2013-08-19','10:45:00',1.24),('15529','2013-08-19','10:55:00',1.91),('15529','2013-08-19','11:10:00',1.78),('15529','2013-08-19','11:15:00',2.13),('15529','2013-08-19','11:20:00',2.11),('15529','2013-08-19','11:25:00',1.49),('15529','2013-08-19','11:30:00',2.26),('15529','2013-08-19','11:35:00',2.14),('15529','2013-08-19','11:40:00',1.17),('15529','2013-08-19','11:45:00',1.43),('15529','2013-08-19','11:50:00',1.55),('15529','2013-08-19','13:30:00',1.03),('15529','2013-08-19','13:35:00',1.23),('15529','2013-08-19','13:40:00',1.34),('15529','2013-08-19','13:45:00',1.87),('15529','2013-08-19','13:50:00',2.33),('15529','2013-08-19','13:55:00',2.2),('15529','2013-08-19','14:00:00',2.19),('15529','2013-08-19','14:05:00',2.17),('15529','2013-08-19','14:10:00',2.19),('15529','2013-08-19','14:15:00',2.08),('15529','2013-08-19','14:20:00',2.15),('15529','2013-08-19','14:25:00',2.19),('15529','2013-08-19','14:30:00',2.05),('15529','2013-08-19','14:35:00',1.6),('15529','2013-08-19','14:40:00',1.4),('15529','2013-08-19','14:45:00',1.93),('15529','2013-08-19','14:50:00',1.5),('15529','2013-08-19','14:55:00',1.43),('15529','2013-08-19','15:00:00',1.93),('15529','2013-08-19','15:05:00',2.04),('15529','2013-08-19','15:10:00',1.98),('15529','2013-08-19','15:15:00',1.96),('15529','2013-08-19','15:20:00',1.95),('15529','2013-08-19','15:25:00',1.91),('15529','2013-08-19','15:30:00',1.91),('15529','2013-08-19','15:35:00',1.92),('15529','2013-08-19','15:40:00',1.92),('15529','2013-08-19','15:45:00',1.9),('15529','2013-08-19','15:50:00',1.95),('15529','2013-08-19','15:55:00',1.94),('15529','2013-08-19','16:00:00',1.87),('15529','2013-08-19','16:05:00',1.85),('15529','2013-08-19','16:10:00',1.81),('15529','2013-08-19','16:15:00',1.79),('15529','2013-08-19','16:20:00',1.77),('15529','2013-08-19','16:25:00',1.72),('15529','2013-08-19','16:30:00',1.62),('15529','2013-08-19','16:35:00',1.53),('15529','2013-08-19','16:40:00',1.51),('15529','2013-08-19','16:45:00',1.46),('15529','2013-08-19','16:50:00',1.37),('15529','2013-08-19','16:55:00',1.35),('15529','2013-08-19','17:00:00',1.22),('15529','2013-08-19','17:05:00',1.14),('15529','2013-08-19','17:10:00',1.11),('15529','2013-08-19','17:15:00',1.06),('15529','2013-08-19','17:20:00',1.01),('15529','2014-04-09','08:50:00',1.04),('15529','2014-04-09','08:55:00',1.09),('15529','2014-04-09','09:00:00',1.14),('15529','2014-04-09','09:05:00',1.2),('15529','2014-04-09','09:10:00',1.24),('15529','2014-04-09','09:15:00',1.27),('15529','2014-04-09','09:20:00',1.31),('15529','2014-04-09','09:25:00',1.38),('15529','2014-04-09','09:30:00',1.43),('15529','2014-04-09','09:35:00',1.48),('15529','2014-04-09','09:40:00',1.5),('15529','2014-04-09','09:45:00',1.54),('15529','2014-04-09','09:50:00',1.6),('15529','2014-04-09','09:55:00',1.63),('15529','2014-04-09','10:00:00',1.67),('15529','2014-04-09','10:05:00',1.71),('15529','2014-04-09','10:10:00',1.75),('15529','2014-04-09','10:15:00',1.75),('15529','2014-04-09','10:20:00',1.78),('15529','2014-04-09','10:25:00',1.82),('15529','2014-04-09','10:30:00',1.86),('15529','2014-04-09','10:35:00',1.92),('15529','2014-04-09','10:40:00',1.95),('15529','2014-04-09','10:45:00',1.94),('15529','2014-04-09','10:50:00',1.93),('15529','2014-04-09','10:55:00',1.97),('15529','2014-04-09','11:00:00',1.99),('15529','2014-04-09','11:05:00',2.08),('15529','2014-04-09','11:10:00',2.02),('15529','2014-04-09','11:15:00',2.08),('15529','2014-04-09','11:20:00',2.13),('15529','2014-04-09','11:25:00',2.16),('15529','2014-04-09','11:30:00',2.18),('15529','2014-04-09','11:35:00',2.2),('15529','2014-04-09','11:40:00',2.14),('15529','2014-04-09','11:45:00',2.2),('15529','2014-04-09','11:50:00',2.15),('15529','2014-04-09','11:55:00',2.24),('15529','2014-04-09','12:00:00',2.18),('15529','2014-04-09','12:05:00',2.06),('15529','2014-04-09','12:10:00',2.22),('15529','2014-04-09','12:15:00',2.25),('15529','2014-04-09','12:20:00',2.21),('15529','2014-04-09','12:25:00',2.13),('15529','2014-04-09','12:30:00',2.17),('15529','2014-04-09','12:35:00',2.29),('15529','2014-04-09','12:40:00',2.11),('15529','2014-04-09','12:45:00',2.18),('15529','2014-04-09','12:50:00',2.22),('15529','2014-04-09','12:55:00',2.25),('15529','2014-04-09','13:00:00',2.21),('15529','2014-04-09','13:05:00',2.19),('15529','2014-04-09','13:10:00',2.32),('15529','2014-04-09','13:15:00',2.27),('15529','2014-04-09','13:20:00',2.16),('15529','2014-04-09','13:25:00',2.28),('15529','2014-04-09','13:30:00',2.32),('15529','2014-04-09','13:35:00',2.37),('15529','2014-04-09','13:40:00',2.29),('15529','2014-04-09','13:45:00',2.37),('15529','2014-04-09','13:50:00',2.37),('15529','2014-04-09','13:55:00',2.34),('15529','2014-04-09','14:00:00',2.32),('15529','2014-04-09','14:05:00',2.27),('15529','2014-04-09','14:10:00',2.21),('15529','2014-04-09','14:15:00',2.29),('15529','2014-04-09','14:20:00',2.27),('15529','2014-04-09','14:25:00',2.22),('15529','2014-04-09','14:30:00',2.19),('15529','2014-04-09','14:35:00',2.2),('15529','2014-04-09','14:40:00',2.18),('15529','2014-04-09','14:45:00',1.95),('15529','2014-04-09','14:50:00',2.14),('15529','2014-04-09','14:55:00',2.12),('15529','2014-04-09','15:00:00',2.1),('15529','2014-04-09','15:05:00',2.07),('15529','2014-04-09','15:10:00',2.02),('15529','2014-04-09','15:15:00',2),('15529','2014-04-09','15:20:00',2.01),('15529','2014-04-09','15:25:00',1.91),('15529','2014-04-09','15:30:00',1.8),('15529','2014-04-09','15:35:00',1.7),('15529','2014-04-09','15:40:00',1.74),('15529','2014-04-09','15:45:00',1.74),('15529','2014-04-09','15:50:00',1.69),('15529','2014-04-09','15:55:00',1.74),('15529','2014-04-09','16:00:00',1.73),('15529','2014-04-09','16:05:00',1.74),('15529','2014-04-09','16:10:00',1.77),('15529','2014-04-09','16:15:00',1.73),('15529','2014-04-09','16:20:00',1.63),('15529','2014-04-09','16:25:00',1.58),('15529','2014-04-09','16:30:00',1.58),('15529','2014-04-09','16:35:00',1.53),('15529','2014-04-09','16:40:00',1.49),('15529','2014-04-09','16:45:00',1.47),('15529','2014-04-09','16:50:00',1.38),('15529','2014-04-09','16:55:00',1.35),('15529','2014-04-09','17:00:00',1.29),('15529','2014-04-09','17:05:00',1.24),('15529','2014-04-09','17:10:00',1.2),('15529','2014-04-09','17:15:00',1.12),('15529','2014-04-09','17:20:00',1.08),('15529','2014-04-09','17:25:00',1.02),('15529','2013-08-18','09:05:00',1.04),('15529','2013-08-18','09:10:00',1.08),('15529','2013-08-18','09:15:00',1.13),('15529','2013-08-18','09:20:00',1.17),('15529','2013-08-18','09:25:00',1.21),('15529','2013-08-18','09:30:00',1.26),('15529','2013-08-18','09:35:00',1.28),('15529','2013-08-18','09:40:00',1.32),('15529','2013-08-18','09:45:00',1.36),('15529','2013-08-18','09:50:00',1.39),('15529','2013-08-18','09:55:00',1.4),('15529','2013-08-18','10:00:00',1.44),('15529','2013-08-18','10:05:00',1.48),('15529','2013-08-18','10:10:00',1.49),('15529','2013-08-18','10:15:00',1.52),('15529','2013-08-18','10:20:00',1.57),('15529','2013-08-18','10:25:00',1.62),('15529','2013-08-18','10:30:00',1.64),('15529','2013-08-18','10:35:00',1.67),('15529','2013-08-18','10:40:00',1.71),('15529','2013-08-18','10:45:00',1.72),('15529','2013-08-18','10:50:00',1.75),('15529','2013-08-18','10:55:00',1.76),('15529','2013-08-18','11:00:00',1.74),('15529','2013-08-18','11:05:00',1.79),('15529','2013-08-18','11:10:00',1.79),('15529','2013-08-18','11:15:00',1.82),('15529','2013-08-18','11:20:00',1.85),('15529','2013-08-18','11:25:00',1.87),('15529','2013-08-18','11:30:00',1.91),('15529','2013-08-18','11:35:00',1.93),('15529','2013-08-18','11:40:00',1.94),('15529','2013-08-18','11:45:00',1.96),('15529','2013-08-18','11:50:00',1.98),('15529','2013-08-18','11:55:00',1.99),('15529','2013-08-18','12:00:00',1.99),('15529','2013-08-18','12:05:00',1.98),('15529','2013-08-18','12:10:00',2),('15529','2013-08-18','12:15:00',2),('15529','2013-08-18','12:20:00',2.03),('15529','2013-08-18','12:25:00',2),('15529','2013-08-18','12:30:00',1.99),('15529','2013-08-18','12:35:00',2.04),('15529','2013-08-18','12:40:00',2.06),('15529','2013-08-18','12:45:00',2.07),('15529','2013-08-18','12:50:00',2.09),('15529','2013-08-18','12:55:00',2.1),('15529','2013-08-18','13:00:00',2.1),('15529','2013-08-18','13:05:00',2.1),('15529','2013-08-18','13:10:00',2.11),('15529','2013-08-18','13:15:00',2.14),('15529','2013-08-18','13:20:00',2.11),('15529','2013-08-18','13:25:00',2.08),('15529','2013-08-18','13:30:00',2.1),('15529','2013-08-18','13:35:00',2.07),('15529','2013-08-18','13:40:00',2.11),('15529','2013-08-18','13:45:00',2.08),('15529','2013-08-18','13:50:00',2.08),('15529','2013-08-18','13:55:00',2.05),('15529','2013-08-18','14:00:00',2.08),('15529','2013-08-18','14:05:00',2.06),('15529','2013-08-18','14:10:00',2.04),('15529','2013-08-18','14:15:00',2.05),('15529','2013-08-18','14:20:00',2.01),('15529','2013-08-18','14:25:00',2.04),('15529','2013-08-18','14:30:00',2.03),('15529','2013-08-18','14:35:00',2),('15529','2013-08-18','14:40:00',2),('15529','2013-08-18','14:45:00',1.98),('15529','2013-08-18','14:50:00',1.97),('15529','2013-08-18','14:55:00',1.95),('15529','2013-08-18','15:00:00',1.92),('15529','2013-08-18','15:05:00',1.92),('15529','2013-08-18','15:10:00',1.9),('15529','2013-08-18','15:15:00',1.87),('15529','2013-08-18','15:20:00',1.85),('15529','2013-08-18','15:25:00',1.85),('15529','2013-08-18','15:30:00',1.81),('15529','2013-08-18','15:35:00',1.79),('15529','2013-08-18','15:40:00',1.76),('15529','2013-08-18','15:45:00',1.74),('15529','2013-08-18','15:50:00',1.72),('15529','2013-08-18','15:55:00',1.68),('15529','2013-08-18','16:00:00',1.64),('15529','2013-08-18','16:05:00',1.6),('15529','2013-08-18','16:10:00',1.57),('15529','2013-08-18','16:15:00',1.53),('15529','2013-08-18','16:20:00',1.5),('15529','2013-08-18','16:25:00',1.46),('15529','2013-08-18','16:30:00',1.43),('15529','2013-08-18','16:35:00',1.39),('15529','2013-08-18','16:40:00',1.35),('15529','2013-08-18','16:45:00',1.32),('15529','2013-08-18','16:50:00',1.28),('15529','2013-08-18','16:55:00',1.24),('15529','2013-08-18','17:00:00',1.19),('15529','2013-08-18','17:05:00',1.14),('15529','2013-08-18','17:10:00',1.09),('15529','2013-08-18','17:15:00',1.05),('15529','2013-08-18','17:20:00',1.01),('15529','2013-08-17','09:00:00',1.01),('15529','2013-08-17','09:05:00',1.06),('15529','2013-08-17','09:10:00',1.1),('15529','2013-08-17','09:15:00',1.14),('15529','2013-08-17','09:20:00',1.19),('15529','2013-08-17','09:25:00',1.22),('15529','2013-08-17','09:30:00',1.26),('15529','2013-08-17','09:35:00',1.32),('15529','2013-08-17','09:40:00',1.26),('15529','2013-08-17','09:45:00',1.31),('15529','2013-08-17','09:50:00',1.24),('15529','2013-08-17','09:55:00',1.44),('15529','2013-08-17','10:00:00',1.16),('15529','2013-08-17','10:05:00',1.45),('15529','2013-08-17','10:10:00',1.55),('15529','2013-08-17','10:15:00',1.57),('15529','2013-08-17','10:20:00',1.6),('15529','2013-08-17','10:25:00',1.62),('15529','2013-08-17','10:30:00',1.63),('15529','2013-08-17','10:35:00',1.67),('15529','2013-08-17','10:40:00',1.69),('15529','2013-08-17','10:45:00',1.7),('15529','2013-08-17','10:50:00',1.65),('15529','2013-08-17','10:55:00',1.74),('15529','2013-08-17','11:00:00',1.78),('15529','2013-08-17','11:05:00',1.81),('15529','2013-08-17','11:10:00',1.83),('15529','2013-08-17','11:15:00',1.87),('15529','2013-08-17','11:20:00',1.86),('15529','2013-08-17','11:25:00',1.88),('15529','2013-08-17','11:30:00',1.9),('15529','2013-08-17','11:35:00',1.89),('15529','2013-08-17','11:40:00',1.92),('15529','2013-08-17','11:45:00',1.95),('15529','2013-08-17','11:50:00',1.99),('15529','2013-08-17','11:55:00',2),('15529','2013-08-17','12:00:00',2.04),('15529','2013-08-17','12:05:00',2.04),('15529','2013-08-17','12:10:00',1.92),('15529','2013-08-17','12:20:00',1.44),('15529','2013-08-17','12:30:00',1.47),('15529','2013-08-17','12:35:00',2.05),('15529','2013-08-17','12:40:00',1.03),('15529','2013-08-17','12:45:00',2.14),('15529','2013-08-17','12:50:00',2.2),('15529','2013-08-17','12:55:00',2.21),('15529','2013-08-17','13:00:00',2.15),('15529','2013-08-17','13:05:00',2.1),('15529','2013-08-17','13:10:00',2.17),('15529','2013-08-17','13:15:00',2.1),('15529','2013-08-17','13:20:00',2.13),('15529','2013-08-17','13:25:00',2.11),('15529','2013-08-17','13:30:00',2.15),('15529','2013-08-17','13:35:00',2.1),('15529','2013-08-17','13:40:00',2.11),('15529','2013-08-17','13:45:00',2.11),('15529','2013-08-17','13:50:00',2.12),('15529','2013-08-17','13:55:00',2.1),('15529','2013-08-17','14:00:00',2.13),('15529','2013-08-17','14:05:00',2.13),('15529','2013-08-17','14:10:00',2.07),('15529','2013-08-17','14:15:00',2.06),('15529','2013-08-17','14:20:00',2.07),('15529','2013-08-17','14:25:00',2.06),('15529','2013-08-17','14:30:00',2.04),('15529','2013-08-17','14:35:00',2.04),('15529','2013-08-17','14:40:00',2.03),('15529','2013-08-17','14:45:00',2),('15529','2013-08-17','14:50:00',1.98),('15529','2013-08-17','14:55:00',1.95),('15529','2013-08-17','15:00:00',1.95),('15529','2013-08-17','15:05:00',1.94),('15529','2013-08-17','15:10:00',1.92),('15529','2013-08-17','15:15:00',1.88),('15529','2013-08-17','15:20:00',1.86),('15529','2013-08-17','15:25:00',1.83),('15529','2013-08-17','15:30:00',1.8),('15529','2013-08-17','15:35:00',1.79),('15529','2013-08-17','15:40:00',1.76),('15529','2013-08-17','15:45:00',1.72),('15529','2013-08-17','15:50:00',1.7),('15529','2013-08-17','15:55:00',1.67),('15529','2013-08-17','16:00:00',1.63),('15529','2013-08-17','16:05:00',1.59),('15529','2013-08-17','16:10:00',1.57),('15529','2013-08-17','16:15:00',1.54),('15529','2013-08-17','16:20:00',1.49),('15529','2013-08-17','16:25:00',1.47),('15529','2013-08-17','16:30:00',1.43),('15529','2013-08-17','16:35:00',1.38),('15529','2013-08-17','16:40:00',1.35),('15529','2013-08-17','16:45:00',1.31),('15529','2013-08-17','16:50:00',1.27),('15529','2013-08-17','16:55:00',1.24),('15529','2013-08-17','17:00:00',1.19),('15529','2013-08-17','17:05:00',1.15),('15529','2013-08-17','17:10:00',1.11),('15529','2013-08-17','17:15:00',1.07),('15529','2013-08-17','17:20:00',1.02),('15529','2013-08-16','09:00:00',1.01),('15529','2013-08-16','09:05:00',1.05),('15529','2013-08-16','09:10:00',1.1),('15529','2013-08-16','09:15:00',1.14),('15529','2013-08-16','09:20:00',1.19),('15529','2013-08-16','09:25:00',1.23),('15529','2013-08-16','09:30:00',1.26),('15529','2013-08-16','09:35:00',1.3),('15529','2013-08-16','09:40:00',1.34),('15529','2013-08-16','09:45:00',1.38),('15529','2013-08-16','09:50:00',1.41),('15529','2013-08-16','09:55:00',1.44),('15529','2013-08-16','10:00:00',1.49),('15529','2013-08-16','10:05:00',1.52),('15529','2013-08-16','10:10:00',1.55),('15529','2013-08-16','10:15:00',1.58),('15529','2013-08-16','10:20:00',1.61),('15529','2013-08-16','10:25:00',1.63),('15529','2013-08-16','10:30:00',1.66),('15529','2013-08-16','10:35:00',1.68),('15529','2013-08-16','10:40:00',1.71),('15529','2013-08-16','10:45:00',1.72),('15529','2013-08-16','10:50:00',1.74),('15529','2013-08-16','10:55:00',1.77),('15529','2013-08-16','11:00:00',1.8),('15529','2013-08-16','11:05:00',1.81),('15529','2013-08-16','11:10:00',1.84),('15529','2013-08-16','11:15:00',1.87),('15529','2013-08-16','11:20:00',1.88),('15529','2013-08-16','11:25:00',1.89),('15529','2013-08-16','11:30:00',1.91),('15529','2013-08-16','11:35:00',1.93),('15529','2013-08-16','11:40:00',1.92),('15529','2013-08-16','11:45:00',1.9),('15529','2013-08-16','11:50:00',1.97),('15529','2013-08-16','11:55:00',1.92),('15529','2013-08-16','12:00:00',2),('15529','2013-08-16','12:05:00',2.05),('15529','2013-08-16','12:10:00',2.08),('15529','2013-08-16','12:15:00',2.03),('15529','2013-08-16','12:20:00',2.02),('15529','2013-08-16','12:25:00',2.09),('15529','2013-08-16','12:30:00',2.07),('15529','2013-08-16','12:35:00',2.1),('15529','2013-08-16','12:40:00',2.07),('15529','2013-08-16','12:45:00',2.09),('15529','2013-08-16','12:50:00',2.12),('15529','2013-08-16','12:55:00',2.1),('15529','2013-08-16','13:00:00',1.33),('15529','2013-08-16','13:10:00',2.17),('15529','2013-08-16','13:15:00',2.12),('15529','2013-08-16','13:20:00',2.08),('15529','2013-08-16','13:25:00',2.03),('15529','2013-08-16','13:30:00',1.24),('15529','2013-08-16','13:35:00',2.12),('15529','2013-08-16','13:40:00',2.1),('15529','2013-08-16','13:45:00',1.7),('15529','2013-08-16','14:00:00',1.99),('15529','2013-08-16','14:05:00',2.09),('15529','2013-08-16','14:10:00',2.04),('15529','2013-08-16','14:15:00',2.04),('15529','2013-08-16','14:20:00',2.04),('15529','2013-08-16','14:25:00',2.02),('15529','2013-08-16','14:30:00',2.02),('15529','2013-08-16','14:35:00',2.02),('15529','2013-08-16','14:40:00',1.99),('15529','2013-08-16','14:45:00',1.99),('15529','2013-08-16','14:50:00',1.99),('15529','2013-08-16','14:55:00',1.93),('15529','2013-08-16','15:00:00',1.93),('15529','2013-08-16','15:05:00',1.94),('15529','2013-08-16','15:10:00',1.89),('15529','2013-08-16','15:15:00',1.87),('15529','2013-08-16','15:20:00',1.86),('15529','2013-08-16','15:25:00',1.85),('15529','2013-08-16','15:30:00',1.81),('15529','2013-08-16','15:35:00',1.8),('15529','2013-08-16','15:40:00',1.75),('15529','2013-08-16','15:45:00',1.74),('15529','2013-08-16','15:50:00',1.7),('15529','2013-08-16','15:55:00',1.68),('15529','2013-08-16','16:00:00',1.65),('15529','2013-08-16','16:05:00',1.63),('15529','2013-08-16','16:10:00',1.6),('15529','2013-08-16','16:15:00',1.57),('15529','2013-08-16','16:20:00',1.53),('15529','2013-08-16','16:25:00',1.49),('15529','2013-08-16','16:30:00',1.46),('15529','2013-08-16','16:35:00',1.42),('15529','2013-08-16','16:40:00',1.38),('15529','2013-08-16','16:45:00',1.3),('15529','2013-08-16','16:50:00',1.3),('15529','2013-08-16','16:55:00',1.26),('15529','2013-08-16','17:00:00',1.22),('15529','2013-08-16','17:05:00',1.17),('15529','2013-08-16','17:10:00',1.02),('15529','2013-08-16','17:15:00',1.08),('15529','2013-08-16','17:20:00',1.01),('15529','2013-08-16','17:25:00',1.04),('15529','2013-08-15','09:00:00',1.02),('15529','2013-08-15','09:05:00',1.07),('15529','2013-08-15','09:10:00',1.12),('15529','2013-08-15','09:15:00',1.17),('15529','2013-08-15','09:20:00',1.21),('15529','2013-08-15','09:25:00',1.26),('15529','2013-08-15','09:30:00',1.3),('15529','2013-08-15','09:35:00',1.34),('15529','2013-08-15','09:40:00',1.37),('15529','2013-08-15','09:45:00',1.41),('15529','2013-08-15','09:50:00',1.45),('15529','2013-08-15','09:55:00',1.49),('15529','2013-08-15','10:00:00',1.53),('15529','2013-08-15','10:05:00',1.56),('15529','2013-08-15','10:10:00',1.59),('15529','2013-08-15','10:15:00',1.62),('15529','2013-08-15','10:20:00',1.65),('15529','2013-08-15','10:25:00',1.69),('15529','2013-08-15','10:30:00',1.71),('15529','2013-08-15','10:35:00',1.74),('15529','2013-08-15','10:40:00',1.77),('15529','2013-08-15','10:45:00',1.79),('15529','2013-08-15','10:50:00',1.81),('15529','2013-08-15','10:55:00',1.85),('15529','2013-08-15','11:00:00',1.87),('15529','2013-08-15','11:05:00',1.9),('15529','2013-08-15','11:10:00',1.92),('15529','2013-08-15','11:15:00',1.9),('15529','2013-08-15','11:20:00',1.97),('15529','2013-08-15','11:25:00',1.96),('15529','2013-08-15','11:30:00',1.94),('15529','2013-08-15','11:35:00',1.99),('15529','2013-08-15','11:40:00',2.02),('15529','2013-08-15','11:45:00',2),('15529','2013-08-15','11:50:00',2.01),('15529','2013-08-15','11:55:00',2.05),('15529','2013-08-15','12:00:00',2.07),('15529','2013-08-15','12:05:00',2.07),('15529','2013-08-15','12:10:00',2.09),('15529','2013-08-15','12:15:00',2.11),('15529','2013-08-15','12:20:00',2.1),('15529','2013-08-15','12:25:00',2.12),('15529','2013-08-15','12:30:00',2.04),('15529','2013-08-15','12:35:00',2.1),('15529','2013-08-15','12:40:00',2.09),('15529','2013-08-15','12:45:00',2.11),('15529','2013-08-15','12:50:00',2.11),('15529','2013-08-15','12:55:00',2.1),('15529','2013-08-15','13:00:00',2.08),('15529','2013-08-15','13:05:00',2.09),('15529','2013-08-15','13:10:00',2.09),('15529','2013-08-15','13:15:00',2.06),('15529','2013-08-15','13:20:00',2.08),('15529','2013-08-15','13:25:00',2.09),('15529','2013-08-15','13:30:00',2.1),('15529','2013-08-15','13:35:00',2.1),('15529','2013-08-15','13:40:00',2.05),('15529','2013-08-15','13:45:00',2.02),('15529','2013-08-15','13:50:00',2.07),('15529','2013-08-15','13:55:00',2.06),('15529','2013-08-15','14:00:00',2.04),('15529','2013-08-15','14:05:00',2.01),('15529','2013-08-15','14:10:00',2.02),('15529','2013-08-15','14:15:00',2.01),('15529','2013-08-15','14:20:00',2),('15529','2013-08-15','14:25:00',1.98),('15529','2013-08-15','14:30:00',1.96),('15529','2013-08-15','14:35:00',1.93),('15529','2013-08-15','14:40:00',1.95),('15529','2013-08-15','14:45:00',1.92),('15529','2013-08-15','14:50:00',1.89),('15529','2013-08-15','14:55:00',1.9),('15529','2013-08-15','15:00:00',1.91),('15529','2013-08-15','15:05:00',1.88),('15529','2013-08-15','15:10:00',1.87),('15529','2013-08-15','15:15:00',1.87),('15529','2013-08-15','15:20:00',1.85),('15529','2013-08-15','15:25:00',1.82),('15529','2013-08-15','15:30:00',1.79),('15529','2013-08-15','15:35:00',1.77),('15529','2013-08-15','15:40:00',1.74),('15529','2013-08-15','15:45:00',1.72),('15529','2013-08-15','15:50:00',1.7),('15529','2013-08-15','15:55:00',1.66),('15529','2013-08-15','16:00:00',1.63),('15529','2013-08-15','16:05:00',1.6),('15529','2013-08-15','16:10:00',1.57),('15529','2013-08-15','16:15:00',1.54),('15529','2013-08-15','16:20:00',1.51),('15529','2013-08-15','16:25:00',1.47),('15529','2013-08-15','16:30:00',1.44),('15529','2013-08-15','16:35:00',1.4),('15529','2013-08-15','16:40:00',1.36),('15529','2013-08-15','16:45:00',1.31),('15529','2013-08-15','16:50:00',1.28),('15529','2013-08-15','16:55:00',1.24),('15529','2013-08-15','17:00:00',1.19),('15529','2013-08-15','17:05:00',1.15),('15529','2013-08-15','17:10:00',1.1),('15529','2013-08-15','17:15:00',1.06),('15529','2013-08-15','17:20:00',1.02),('15529','2013-08-14','09:15:00',1.2),('15529','2013-08-14','09:25:00',1.18),('15529','2013-08-14','09:30:00',1.3),('15529','2013-08-14','09:35:00',1.33),('15529','2013-08-14','09:40:00',1.38),('15529','2013-08-14','09:45:00',1.41),('15529','2013-08-14','09:50:00',1.45),('15529','2013-08-14','09:55:00',1.49),('15529','2013-08-14','10:00:00',1.52),('15529','2013-08-14','10:05:00',1.55),('15529','2013-08-14','10:10:00',1.59),('15529','2013-08-14','10:15:00',1.62),('15529','2013-08-14','10:20:00',1.66),('15529','2013-08-14','10:25:00',1.69),('15529','2013-08-14','10:30:00',1.72),('15529','2013-08-14','10:35:00',1.73),('15529','2013-08-14','10:40:00',1.78),('15529','2013-08-14','10:45:00',1.83),('15529','2013-08-14','10:50:00',1.86),('15529','2013-08-14','10:55:00',1.89),('15529','2013-08-14','11:00:00',1.93),('15529','2013-08-14','11:05:00',1.91),('15529','2013-08-14','11:10:00',1.73),('15529','2013-08-14','11:15:00',1.35),('15529','2013-08-14','11:20:00',1.36),('15529','2013-08-14','11:25:00',1.14),('15529','2013-08-14','11:30:00',1.34),('15529','2013-08-14','11:35:00',1.56),('15529','2013-08-14','11:40:00',1.81),('15529','2013-08-14','11:45:00',2.04),('15529','2013-08-14','11:50:00',2.12),('15529','2013-08-14','11:55:00',2.12),('15529','2013-08-14','12:00:00',2.14),('15529','2013-08-14','12:05:00',2.12),('15529','2013-08-14','12:10:00',2.12),('15529','2013-08-14','12:15:00',2.1),('15529','2013-08-14','12:20:00',2.11),('15529','2013-08-14','12:25:00',2.08),('15529','2013-08-14','12:30:00',2.13),('15529','2013-08-14','12:35:00',2.15),('15529','2013-08-14','12:40:00',2.14),('15529','2013-08-14','12:45:00',2.16),('15529','2013-08-14','12:50:00',2.13),('15529','2013-08-14','12:55:00',2.15),('15529','2013-08-14','13:00:00',2.17),('15529','2013-08-14','13:05:00',2.13),('15529','2013-08-14','13:10:00',2.07),('15529','2013-08-14','13:15:00',2.08),('15529','2013-08-14','13:20:00',2.07),('15529','2013-08-14','13:25:00',2.13),('15529','2013-08-14','13:30:00',2.16),('15529','2013-08-14','13:35:00',2.16),('15529','2013-08-14','13:40:00',2.1),('15529','2013-08-14','13:45:00',2.07),('15529','2013-08-14','13:50:00',2.09),('15529','2013-08-14','13:55:00',2.04),('15529','2013-08-14','14:00:00',2.05),('15529','2013-08-14','14:05:00',2.03),('15529','2013-08-14','14:10:00',2.06),('15529','2013-08-14','14:15:00',2.05),('15529','2013-08-14','14:20:00',2.04),('15529','2013-08-14','14:25:00',2.02),('15529','2013-08-14','14:30:00',1.96),('15529','2013-08-14','14:35:00',1.98),('15529','2013-08-14','14:40:00',1.97),('15529','2013-08-14','14:45:00',1.98),('15529','2013-08-14','14:50:00',1.91),('15529','2013-08-14','14:55:00',1.84),('15529','2013-08-14','15:00:00',1.87),('15529','2013-08-14','15:05:00',1.88),('15529','2013-08-14','15:10:00',1.87),('15529','2013-08-14','15:15:00',1.84),('15529','2013-08-14','15:20:00',1.8),('15529','2013-08-14','15:25:00',1.79),('15529','2013-08-14','15:30:00',1.78),('15529','2013-08-14','15:35:00',1.75),('15529','2013-08-14','15:40:00',1.73),('15529','2013-08-14','15:45:00',1.71),('15529','2013-08-14','15:50:00',1.68),('15529','2013-08-14','15:55:00',1.65),('15529','2013-08-14','16:00:00',1.57),('15529','2013-08-14','16:05:00',1.57),('15529','2013-08-14','16:10:00',1.54),('15529','2013-08-14','16:15:00',1.51),('15529','2013-08-14','16:20:00',1.48),('15529','2013-08-14','16:25:00',1.42),('15529','2013-08-14','16:30:00',1.36),('15529','2013-08-14','16:35:00',1.3),('15529','2013-08-14','16:40:00',1.31),('15529','2013-08-14','16:45:00',1.28),('15529','2013-08-14','16:50:00',1.21),('15529','2013-08-14','16:55:00',1.19),('15529','2013-08-14','17:00:00',1.17),('15529','2013-08-14','17:05:00',1.1),('15529','2013-08-14','17:10:00',1.04),('15529','2013-08-13','09:00:00',1.03),('15529','2013-08-13','09:05:00',1.13),('15529','2013-08-13','09:10:00',1.22),('15529','2013-08-13','09:15:00',1.31),('15529','2013-08-13','09:20:00',1.27),('15529','2013-08-13','09:25:00',1.18),('15529','2013-08-13','09:30:00',1.24),('15529','2013-08-13','09:50:00',1.26),('15529','2013-08-13','09:55:00',1.53),('15529','2013-08-13','10:00:00',1.56),('15529','2013-08-13','10:30:00',1.07),('15529','2013-08-13','10:35:00',1.82),('15529','2013-08-13','10:40:00',1.79),('15529','2013-08-13','10:45:00',1.8),('15529','2013-08-13','10:50:00',1.9),('15529','2013-08-13','10:55:00',1.9),('15529','2013-08-13','11:00:00',1.61),('15529','2013-08-13','11:30:00',1.6),('15529','2013-08-13','11:35:00',2.05),('15529','2013-08-13','11:40:00',1.56),('15529','2013-08-13','11:45:00',1.3),('15529','2013-08-13','12:15:00',1.17),('15529','2013-08-13','12:20:00',1.36),('15529','2013-08-13','12:30:00',1.06),('15529','2013-08-13','12:35:00',1.92),('15529','2013-08-13','12:45:00',1.39),('15529','2013-08-13','12:50:00',1.79),('15529','2013-08-13','12:55:00',1.74),('15529','2013-08-13','13:00:00',1.13),('15529','2013-08-13','13:05:00',1.88),('15529','2013-08-13','13:10:00',1.73),('15529','2013-08-13','13:15:00',1.76),('15529','2013-08-13','13:20:00',2.15),('15529','2013-08-13','13:25:00',1.78),('15529','2013-08-13','13:45:00',1.05),('15529','2013-08-13','13:50:00',2.42),('15529','2013-08-13','13:55:00',2.31),('15529','2013-08-13','14:00:00',2.15),('15529','2013-08-13','14:05:00',2.21),('15529','2013-08-13','14:10:00',2.18),('15529','2013-08-13','14:15:00',2.17),('15529','2013-08-13','14:20:00',1.62),('15529','2013-08-13','14:25:00',2.11),('15529','2013-08-13','14:30:00',2.13),('15529','2013-08-13','14:35:00',2.08),('15529','2013-08-13','14:40:00',2.06),('15529','2013-08-13','14:45:00',1.98),('15529','2013-08-13','14:50:00',1.92),('15529','2013-08-13','14:55:00',1.98),('15529','2013-08-13','15:00:00',1.94),('15529','2013-08-13','15:05:00',1.89),('15529','2013-08-13','15:10:00',1.87),('15529','2013-08-13','15:15:00',1.87),('15529','2013-08-13','15:20:00',1.85),('15529','2013-08-13','15:25:00',1.79),('15529','2013-08-13','15:30:00',1.79),('15529','2013-08-13','15:35:00',1.78),('15529','2013-08-13','15:40:00',1.76),('15529','2013-08-13','15:45:00',1.75),('15529','2013-08-13','15:50:00',1.72),('15529','2013-08-13','15:55:00',1.68),('15529','2013-08-13','16:00:00',1.65),('15529','2013-08-13','16:05:00',1.62),('15529','2013-08-13','16:10:00',1.59),('15529','2013-08-13','16:15:00',1.56),('15529','2013-08-13','16:20:00',1.54),('15529','2013-08-13','16:25:00',1.51),('15529','2013-08-13','16:30:00',1.47),('15529','2013-08-13','16:35:00',1.43),('15529','2013-08-13','16:40:00',1.39),('15529','2013-08-13','16:45:00',1.36),('15529','2013-08-13','16:50:00',1.31),('15529','2013-08-13','16:55:00',1.26),('15529','2013-08-13','17:00:00',1.2),('15529','2013-08-13','17:05:00',1.17),('15529','2013-08-13','17:10:00',1.12),('15529','2013-08-13','17:15:00',1.09),('15529','2013-08-13','17:20:00',1.02),('15529','2013-08-12','09:00:00',1.03),('15529','2013-08-12','09:05:00',1.06),('15529','2013-08-12','09:10:00',1.1),('15529','2013-08-12','09:15:00',1.15),('15529','2013-08-12','09:20:00',1.19),('15529','2013-08-12','09:25:00',1.24),('15529','2013-08-12','09:30:00',1.27),('15529','2013-08-12','09:35:00',1.33),('15529','2013-08-12','09:40:00',1.35),('15529','2013-08-12','09:45:00',1.39),('15529','2013-08-12','09:50:00',1.38),('15529','2013-08-12','09:55:00',1.45),('15529','2013-08-12','10:00:00',1.51),('15529','2013-08-12','10:05:00',1.54),('15529','2013-08-12','10:10:00',1.56),('15529','2013-08-12','10:15:00',1.59),('15529','2013-08-12','10:20:00',1.62),('15529','2013-08-12','10:25:00',1.63),('15529','2013-08-12','10:30:00',1.68),('15529','2013-08-12','10:35:00',1.7),('15529','2013-08-12','10:40:00',1.74),('15529','2013-08-12','10:45:00',1.77),('15529','2013-08-12','10:50:00',1.78),('15529','2013-08-12','10:55:00',1.8),('15529','2013-08-12','11:00:00',1.82),('15529','2013-08-12','11:05:00',1.86),('15529','2013-08-12','11:10:00',1.84),('15529','2013-08-12','11:15:00',1.91),('15529','2013-08-12','11:20:00',1.94),('15529','2013-08-12','11:25:00',1.92),('15529','2013-08-12','11:30:00',1.93),('15529','2013-08-12','11:35:00',1.91),('15529','2013-08-12','11:40:00',1.95),('15529','2013-08-12','11:45:00',1.95),('15529','2013-08-12','11:50:00',1.89),('15529','2013-08-12','11:55:00',1.22),('15529','2013-08-12','12:00:00',2.04),('15529','2013-08-12','12:05:00',2.07),('15529','2013-08-12','12:10:00',2.07),('15529','2013-08-12','12:15:00',1.53),('15529','2013-08-12','12:20:00',2.23),('15529','2013-08-12','12:25:00',2.17),('15529','2013-08-12','12:30:00',2.18),('15529','2013-08-12','12:35:00',2.18),('15529','2013-08-12','12:40:00',2.21),('15529','2013-08-12','12:45:00',2.2),('15529','2013-08-12','12:50:00',2.26),('15529','2013-08-12','12:55:00',2.26),('15529','2013-08-12','13:00:00',2.24),('15529','2013-08-12','13:05:00',1.4),('15529','2013-08-12','13:20:00',2.32),('15529','2013-08-12','13:25:00',2.33),('15529','2013-08-12','13:30:00',2.24),('15529','2013-08-12','13:35:00',2.09),('15529','2013-08-12','13:45:00',2.37),('15529','2013-08-12','13:50:00',2.22),('15529','2013-08-12','13:55:00',2.16),('15529','2013-08-12','14:00:00',1.84),('15529','2013-08-12','14:05:00',2.15),('15529','2013-08-12','14:10:00',2.1),('15529','2013-08-12','14:15:00',2.07),('15529','2013-08-12','14:20:00',2.14),('15529','2013-08-12','14:25:00',2.11),('15529','2013-08-12','14:30:00',2.17),('15529','2013-08-12','14:35:00',2.14),('15529','2013-08-12','14:40:00',2.08),('15529','2013-08-12','14:45:00',2.03),('15529','2013-08-12','14:50:00',2.02),('15529','2013-08-12','14:55:00',1.97),('15529','2013-08-12','15:00:00',1.95),('15529','2013-08-12','15:05:00',1.93),('15529','2013-08-12','15:10:00',1.9),('15529','2013-08-12','15:15:00',1.88),('15529','2013-08-12','15:20:00',1.88),('15529','2013-08-12','15:25:00',1.82),('15529','2013-08-12','15:30:00',1.81),('15529','2013-08-12','15:35:00',1.78),('15529','2013-08-12','15:40:00',1.75),('15529','2013-08-12','15:45:00',1.71),('15529','2013-08-12','15:50:00',1.7),('15529','2013-08-12','15:55:00',1.68),('15529','2013-08-12','16:00:00',1.64),('15529','2013-08-12','16:05:00',1.62),('15529','2013-08-12','16:10:00',1.58),('15529','2013-08-12','16:15:00',1.55),('15529','2013-08-12','16:20:00',1.51),('15529','2013-08-12','16:25:00',1.49),('15529','2013-08-12','16:30:00',1.45),('15529','2013-08-12','16:35:00',1.42),('15529','2013-08-12','16:40:00',1.38),('15529','2013-08-12','16:45:00',1.35),('15529','2013-08-12','16:50:00',1.3),('15529','2013-08-12','16:55:00',1.25),('15529','2013-08-12','17:00:00',1.22),('15529','2013-08-12','17:05:00',1.18),('15529','2013-08-12','17:10:00',1.13),('15529','2013-08-12','17:15:00',1.09),('15529','2013-08-12','17:20:00',1.04),('15529','2013-08-11','09:05:00',1.04),('15529','2013-08-11','09:10:00',1.08),('15529','2013-08-11','09:15:00',1.13),('15529','2013-08-11','09:20:00',1.18),('15529','2013-08-11','09:25:00',1.21),('15529','2013-08-11','09:30:00',1.24),('15529','2013-08-11','09:35:00',1.28),('15529','2013-08-11','09:40:00',1.32),('15529','2013-08-11','09:45:00',1.36),('15529','2013-08-11','09:50:00',1.39),('15529','2013-08-11','09:55:00',1.43),('15529','2013-08-11','10:00:00',1.45),('15529','2013-08-11','10:05:00',1.49),('15529','2013-08-11','10:10:00',1.52),('15529','2013-08-11','10:15:00',1.56),('15529','2013-08-11','10:20:00',1.59),('15529','2013-08-11','10:25:00',1.63),('15529','2013-08-11','10:30:00',1.67),('15529','2013-08-11','10:35:00',1.68),('15529','2013-08-11','10:40:00',1.73),('15529','2013-08-11','10:45:00',1.72),('15529','2013-08-11','10:50:00',1.72),('15529','2013-08-11','10:55:00',1.78),('15529','2013-08-11','11:00:00',1.79),('15529','2013-08-11','11:05:00',1.81),('15529','2013-08-11','11:10:00',1.81),('15529','2013-08-11','11:15:00',1.84),('15529','2013-08-11','11:20:00',1.86),('15529','2013-08-11','11:25:00',1.85),('15529','2013-08-11','11:30:00',1.87),('15529','2013-08-11','11:35:00',1.92),('15529','2013-08-11','11:40:00',1.56),('15529','2013-08-11','11:45:00',1.96),('15529','2013-08-11','11:50:00',1.97),('15529','2013-08-11','11:55:00',2.05),('15529','2013-08-11','12:00:00',2.05),('15529','2013-08-11','12:05:00',1.76),('15529','2013-08-11','12:10:00',1.82),('15529','2013-08-11','12:15:00',2.1),('15529','2013-08-11','12:20:00',1.99),('15529','2013-08-11','12:25:00',2.04),('15529','2013-08-11','12:30:00',1.49),('15529','2013-08-11','12:35:00',1.11),('15529','2013-08-11','12:50:00',1.01),('15529','2013-08-11','13:15:00',1.2),('15529','2013-08-11','13:25:00',1.25),('15529','2013-08-11','13:30:00',1.99),('15529','2013-08-11','13:35:00',1.06),('15529','2013-08-11','13:45:00',1.21),('15529','2013-08-11','14:35:00',2.12),('15529','2013-08-11','14:40:00',1.01),('15529','2013-08-11','14:45:00',1.92),('15529','2013-08-11','14:50:00',1.76),('15529','2013-08-11','14:55:00',2.17),('15529','2013-08-11','15:00:00',1.95),('15529','2013-08-11','15:05:00',1.8),('15529','2013-08-11','15:10:00',2),('15529','2013-08-11','15:15:00',1.92),('15529','2013-08-11','15:20:00',1.87),('15529','2013-08-11','15:25:00',1.82),('15529','2013-08-11','15:30:00',1.5),('15529','2013-08-11','15:35:00',1.28),('15529','2013-08-11','15:40:00',1.57),('15529','2013-08-11','15:45:00',1.7),('15529','2013-08-11','15:50:00',1.68),('15529','2013-08-11','15:55:00',1.68),('15529','2013-08-11','16:00:00',1.65),('15529','2013-08-11','16:05:00',1.66),('15529','2013-08-11','16:10:00',1.59),('15529','2013-08-11','16:15:00',1.52),('15529','2013-08-11','16:20:00',1.52),('15529','2013-08-11','16:25:00',1.34),('15529','2013-08-11','16:30:00',1.42),('15529','2013-08-11','16:35:00',1.38),('15529','2013-08-11','16:40:00',1.34),('15529','2013-08-11','16:45:00',1.31),('15529','2013-08-11','16:50:00',1.27),('15529','2013-08-11','16:55:00',1.24),('15529','2013-08-11','17:00:00',1.2),('15529','2013-08-11','17:05:00',1.15),('15529','2013-08-11','17:10:00',1.12),('15529','2013-08-11','17:15:00',1.07),('15529','2013-08-11','17:20:00',1.03),('15529','2013-08-10','09:00:00',1.02),('15529','2013-08-10','09:05:00',1.07),('15529','2013-08-10','09:10:00',1.11),('15529','2013-08-10','09:15:00',1.16),('15529','2013-08-10','09:20:00',1.2),('15529','2013-08-10','09:25:00',1.24),('15529','2013-08-10','09:30:00',1.27),('15529','2013-08-10','09:35:00',1.32),('15529','2013-08-10','09:40:00',1.35),('15529','2013-08-10','09:45:00',1.39),('15529','2013-08-10','09:50:00',1.42),('15529','2013-08-10','09:55:00',1.46),('15529','2013-08-10','10:00:00',1.5),('15529','2013-08-10','10:05:00',1.53),('15529','2013-08-10','10:10:00',1.56),('15529','2013-08-10','10:15:00',1.6),('15529','2013-08-10','10:20:00',1.62),('15529','2013-08-10','10:25:00',1.66),('15529','2013-08-10','10:30:00',1.69),('15529','2013-08-10','10:35:00',1.72),('15529','2013-08-10','10:40:00',1.75),('15529','2013-08-10','10:45:00',1.77),('15529','2013-08-10','10:50:00',1.79),('15529','2013-08-10','10:55:00',1.82),('15529','2013-08-10','11:00:00',1.84),('15529','2013-08-10','11:05:00',1.87),('15529','2013-08-10','11:10:00',1.89),('15529','2013-08-10','11:15:00',1.92),('15529','2013-08-10','11:20:00',1.93),('15529','2013-08-10','11:25:00',1.94),('15529','2013-08-10','11:30:00',1.96),('15529','2013-08-10','11:35:00',1.96),('15529','2013-08-10','11:40:00',1.97),('15529','2013-08-10','11:45:00',2),('15529','2013-08-10','11:50:00',2.01),('15529','2013-08-10','11:55:00',2.02),('15529','2013-08-10','12:00:00',2.03),('15529','2013-08-10','12:05:00',2.04),('15529','2013-08-10','12:10:00',2.05),('15529','2013-08-10','12:15:00',2.07),('15529','2013-08-10','12:20:00',2.06),('15529','2013-08-10','12:25:00',2.07),('15529','2013-08-10','12:30:00',2.08),('15529','2013-08-10','12:35:00',2.09),('15529','2013-08-10','12:40:00',2.08),('15529','2013-08-10','12:45:00',2.11),('15529','2013-08-10','12:50:00',2.09),('15529','2013-08-10','12:55:00',2.11),('15529','2013-08-10','13:00:00',2.1),('15529','2013-08-10','13:05:00',2.11),('15529','2013-08-10','13:10:00',2.11),('15529','2013-08-10','13:15:00',2.08),('15529','2013-08-10','13:20:00',2.08),('15529','2013-08-10','13:25:00',2.13),('15529','2013-08-10','13:30:00',2.11),('15529','2013-08-10','13:35:00',2.08),('15529','2013-08-10','13:40:00',2.08),('15529','2013-08-10','13:45:00',2.01),('15529','2013-08-10','13:50:00',2.07),('15529','2013-08-10','13:55:00',2.06),('15529','2013-08-10','14:00:00',2.03),('15529','2013-08-10','14:05:00',2.05),('15529','2013-08-10','14:10:00',2.07),('15529','2013-08-10','14:15:00',2.01),('15529','2013-08-10','14:20:00',2.03),('15529','2013-08-10','14:25:00',2.01),('15529','2013-08-10','14:30:00',1.99),('15529','2013-08-10','14:35:00',1.98),('15529','2013-08-10','14:40:00',1.97),('15529','2013-08-10','14:45:00',1.94),('15529','2013-08-10','14:50:00',1.93),('15529','2013-08-10','14:55:00',1.93),('15529','2013-08-10','15:00:00',1.91),('15529','2013-08-10','15:05:00',1.93),('15529','2013-08-10','15:10:00',1.84),('15529','2013-08-10','15:15:00',1.84),('15529','2013-08-10','15:20:00',1.81),('15529','2013-08-10','15:25:00',1.8),('15529','2013-08-10','15:30:00',1.8),('15529','2013-08-10','15:35:00',1.77),('15529','2013-08-10','15:40:00',1.73),('15529','2013-08-10','15:45:00',1.72),('15529','2013-08-10','15:50:00',1.7),('15529','2013-08-10','15:55:00',1.65),('15529','2013-08-10','16:00:00',1.64),('15529','2013-08-10','16:05:00',1.6),('15529','2013-08-10','16:10:00',1.56),('15529','2013-08-10','16:15:00',1.53),('15529','2013-08-10','16:20:00',1.5),('15529','2013-08-10','16:25:00',1.46),('15529','2013-08-10','16:30:00',1.42),('15529','2013-08-10','16:35:00',1.39),('15529','2013-08-10','16:40:00',1.35),('15529','2013-08-10','16:45:00',1.31),('15529','2013-08-10','16:50:00',1.27),('15529','2013-08-10','16:55:00',1.22),('15529','2013-08-10','17:00:00',1.18),('15529','2013-08-10','17:05:00',1.14),('15529','2013-08-10','17:10:00',1.1),('15529','2013-08-10','17:15:00',1.07),('15529','2013-08-10','17:20:00',1.03),('15529','2013-08-09','08:55:00',1),('15529','2013-08-09','09:00:00',1.05),('15529','2013-08-09','09:05:00',1.08),('15529','2013-08-09','09:10:00',1.13),('15529','2013-08-09','09:15:00',1.17),('15529','2013-08-09','09:20:00',1.21),('15529','2013-08-09','09:25:00',1.26),('15529','2013-08-09','09:30:00',1.3),('15529','2013-08-09','09:35:00',1.34),('15529','2013-08-09','09:40:00',1.37),('15529','2013-08-09','09:45:00',1.4),('15529','2013-08-09','09:50:00',1.44),('15529','2013-08-09','09:55:00',1.47),('15529','2013-08-09','10:00:00',1.5),('15529','2013-08-09','10:05:00',1.54),('15529','2013-08-09','10:10:00',1.57),('15529','2013-08-09','10:15:00',1.6),('15529','2013-08-09','10:20:00',1.62),('15529','2013-08-09','10:25:00',1.66),('15529','2013-08-09','10:30:00',1.69),('15529','2013-08-09','10:35:00',1.72),('15529','2013-08-09','10:40:00',1.73),('15529','2013-08-09','10:45:00',1.76),('15529','2013-08-09','10:50:00',1.8),('15529','2013-08-09','10:55:00',1.83),('15529','2013-08-09','11:00:00',1.85),('15529','2013-08-09','11:05:00',1.87),('15529','2013-08-09','11:10:00',1.88),('15529','2013-08-09','11:15:00',1.98),('15529','2013-08-09','11:20:00',1.98),('15529','2013-08-09','11:25:00',2.02),('15529','2013-08-09','11:30:00',2.03),('15529','2013-08-09','11:35:00',2.01),('15529','2013-08-09','11:40:00',2.01),('15529','2013-08-09','11:45:00',2.01),('15529','2013-08-09','11:50:00',2.04),('15529','2013-08-09','11:55:00',2.06),('15529','2013-08-09','12:00:00',2.09),('15529','2013-08-09','12:05:00',2.1),('15529','2013-08-09','12:10:00',2.08),('15529','2013-08-09','12:15:00',2.1),('15529','2013-08-09','12:20:00',2.11),('15529','2013-08-09','12:25:00',2.1),('15529','2013-08-09','12:30:00',2.12),('15529','2013-08-09','12:35:00',2.12),('15529','2013-08-09','12:40:00',2.14),('15529','2013-08-09','12:45:00',2.19),('15529','2013-08-09','12:50:00',2.27),('15529','2013-08-09','12:55:00',2.26),('15529','2013-08-09','13:00:00',1.92),('15529','2013-08-09','13:05:00',2.08),('15529','2013-08-09','13:10:00',2.2),('15529','2013-08-09','13:15:00',2.05),('15529','2013-08-09','13:20:00',2.29),('15529','2013-08-09','13:25:00',2.13),('15529','2013-08-09','13:30:00',1.92),('15529','2013-08-09','14:00:00',2.31),('15529','2013-08-09','14:05:00',2.31),('15529','2013-08-09','14:10:00',2.34),('15529','2013-08-09','14:15:00',1.57),('15529','2013-08-09','15:50:00',1.05),('15529','2013-08-09','15:55:00',1.02),('15529','2013-08-09','16:05:00',1.39),('15529','2013-08-09','16:25:00',1.03),('15529','2013-08-09','16:30:00',1.54),('15529','2013-08-09','16:35:00',1.39),('15529','2013-08-09','16:40:00',1.29),('15529','2013-08-09','16:50:00',1.33),('15529','2013-08-09','16:55:00',1.09),('15529','2014-04-08','09:50:00',1.58),('15529','2014-04-08','09:55:00',1.55),('15529','2014-04-08','10:00:00',1.56),('15529','2014-04-08','10:05:00',1.61),('15529','2014-04-08','10:10:00',1.67),('15529','2014-04-08','10:15:00',1.73),('15529','2014-04-08','10:20:00',1.6),('15529','2014-04-08','10:25:00',1.75),('15529','2014-04-08','10:35:00',1.22),('15529','2014-04-08','10:40:00',1.05),('15529','2014-04-08','10:45:00',2.13),('15529','2014-04-08','10:50:00',2.12),('15529','2014-04-08','10:55:00',2.11),('15529','2014-04-08','11:00:00',2.11),('15529','2014-04-08','11:05:00',2.1),('15529','2014-04-08','11:10:00',1.73),('15529','2014-04-08','11:15:00',2.02),('15529','2014-04-08','11:20:00',2.25),('15529','2014-04-08','11:25:00',2.26),('15529','2014-04-08','11:30:00',2.27),('15529','2014-04-08','11:35:00',2.31),('15529','2014-04-08','11:40:00',2.38),('15529','2014-04-08','11:45:00',1.93),('15529','2014-04-08','11:50:00',2.24),('15529','2014-04-08','11:55:00',1.74),('15529','2014-04-08','12:00:00',2.19),('15529','2014-04-08','12:05:00',1.46),('15529','2014-04-08','12:10:00',1.23),('15529','2014-04-08','14:50:00',1.92),('15529','2014-04-08','15:00:00',1.95),('15529','2014-04-08','15:05:00',1.65),('15529','2014-04-08','15:10:00',1.06),('15529','2014-04-08','15:15:00',1.02),('15529','2014-04-08','15:20:00',1.93),('15529','2014-04-08','16:10:00',1.78),('15529','2014-04-08','16:15:00',1.64),('15529','2014-04-08','16:20:00',1.51),('15529','2014-04-08','16:25:00',1.35),('15529','2014-04-08','16:30:00',1.14),('15529','2014-04-08','16:35:00',1.45),('15529','2014-04-08','16:50:00',1.1),('15529','2014-04-08','17:05:00',1.24),('15529','2014-04-08','17:10:00',1.11),('15529','2014-04-08','17:15:00',1.02),('15529','2013-08-08','09:05:00',1.03),('15529','2013-08-08','09:10:00',1.12),('15529','2013-08-08','09:25:00',1.09),('15529','2013-08-08','09:30:00',1.07),('15529','2013-08-08','09:35:00',1.07),('15529','2013-08-08','09:50:00',1.2),('15529','2013-08-08','10:05:00',1.21),('15529','2013-08-08','10:10:00',1.39),('15529','2013-08-08','10:15:00',1.43),('15529','2013-08-08','10:20:00',1.48),('15529','2013-08-08','10:25:00',1.48),('15529','2013-08-08','10:30:00',1.49),('15529','2013-08-08','10:35:00',1.44),('15529','2013-08-08','10:40:00',1.05),('15529','2013-08-08','10:45:00',1.24),('15529','2013-08-08','10:50:00',1.65),('15529','2013-08-08','10:55:00',1.66),('15529','2013-08-08','11:00:00',1.69),('15529','2013-08-08','11:05:00',1.69),('15529','2013-08-08','11:10:00',1.68),('15529','2013-08-08','11:15:00',1.73),('15529','2013-08-08','11:20:00',1.74),('15529','2013-08-08','11:25:00',1.77),('15529','2013-08-08','11:30:00',1.77),('15529','2013-08-08','11:35:00',1.8),('15529','2013-08-08','11:40:00',1.81),('15529','2013-08-08','11:45:00',1.82),('15529','2013-08-08','11:50:00',1.84),('15529','2013-08-08','11:55:00',1.87),('15529','2013-08-08','12:00:00',1.85),('15529','2013-08-08','12:05:00',1.91),('15529','2013-08-08','12:10:00',1.92),('15529','2013-08-08','12:15:00',1.94),('15529','2013-08-08','12:20:00',1.71),('15529','2013-08-08','12:25:00',2.04),('15529','2013-08-08','12:30:00',1.67),('15529','2013-08-08','12:35:00',1.19),('15529','2013-08-08','12:40:00',1.79),('15529','2013-08-08','12:45:00',2),('15529','2013-08-08','12:50:00',1.75),('15529','2013-08-08','12:55:00',1.17),('15529','2013-08-08','13:20:00',1.2),('15529','2013-08-08','15:10:00',1.37),('15529','2013-08-08','15:15:00',1.58),('15529','2013-08-08','15:35:00',1.05),('15529','2013-08-08','15:40:00',1.18),('15529','2013-08-08','15:45:00',1.11),('15529','2013-08-07','09:10:00',1.01),('15529','2013-08-07','09:15:00',1.05),('15529','2013-08-07','09:20:00',1.1),('15529','2013-08-07','09:25:00',1.13),('15529','2013-08-07','09:30:00',1.17),('15529','2013-08-07','09:35:00',1.2),('15529','2013-08-07','09:40:00',1.24),('15529','2013-08-07','09:45:00',1.27),('15529','2013-08-07','09:50:00',1.31),('15529','2013-08-07','09:55:00',1.34),('15529','2013-08-07','10:00:00',1.37),('15529','2013-08-07','10:05:00',1.41),('15529','2013-08-07','10:10:00',1.43),('15529','2013-08-07','10:15:00',1.46),('15529','2013-08-07','10:20:00',1.49),('15529','2013-08-07','10:25:00',1.52),('15529','2013-08-07','10:30:00',1.54),('15529','2013-08-07','10:35:00',1.56),('15529','2013-08-07','10:40:00',1.58),('15529','2013-08-07','10:45:00',1.6),('15529','2013-08-07','10:50:00',1.63),('15529','2013-08-07','10:55:00',1.65),('15529','2013-08-07','11:00:00',1.67),('15529','2013-08-07','11:05:00',1.69),('15529','2013-08-07','11:10:00',1.72),('15529','2013-08-07','11:15:00',1.73),('15529','2013-08-07','11:20:00',1.75),('15529','2013-08-07','11:25:00',1.75),('15529','2013-08-07','11:30:00',1.77),('15529','2013-08-07','11:35:00',1.78),('15529','2013-08-07','11:40:00',1.78),('15529','2013-08-07','11:45:00',1.82),('15529','2013-08-07','11:50:00',1.83),('15529','2013-08-07','11:55:00',1.86),('15529','2013-08-07','12:00:00',1.89),('15529','2013-08-07','12:05:00',1.86),('15529','2013-08-07','12:10:00',1.86),('15529','2013-08-07','12:15:00',1.84),('15529','2013-08-07','12:20:00',1.86),('15529','2013-08-07','12:25:00',1.92),('15529','2013-08-07','12:30:00',1.94),('15529','2013-08-07','12:35:00',1.96),('15529','2013-08-07','12:40:00',1.97),('15529','2013-08-07','12:45:00',1.97),('15529','2013-08-07','12:50:00',2),('15529','2013-08-07','12:55:00',1.96),('15529','2013-08-07','13:00:00',2),('15529','2013-08-07','13:05:00',1.99),('15529','2013-08-07','13:10:00',1.99),('15529','2013-08-07','13:15:00',1.99),('15529','2013-08-07','13:20:00',2),('15529','2013-08-07','13:25:00',1.99),('15529','2013-08-07','13:30:00',2),('15529','2013-08-07','13:35:00',1.97),('15529','2013-08-07','13:40:00',1.98),('15529','2013-08-07','13:45:00',1.95),('15529','2013-08-07','13:50:00',1.96),('15529','2013-08-07','13:55:00',1.95),('15529','2013-08-07','14:00:00',1.9),('15529','2013-08-07','14:05:00',1.93),('15529','2013-08-07','14:10:00',1.93),('15529','2013-08-07','14:15:00',1.91),('15529','2013-08-07','14:20:00',1.88),('15529','2013-08-07','14:25:00',1.9),('15529','2013-08-07','14:30:00',1.9),('15529','2013-08-07','14:35:00',1.87),('15529','2013-08-07','14:40:00',1.85),('15529','2013-08-07','14:45:00',1.84),('15529','2013-08-07','14:50:00',1.8),('15529','2013-08-07','14:55:00',1.81),('15529','2013-08-07','15:00:00',1.79),('15529','2013-08-07','15:05:00',1.77),('15529','2013-08-07','15:10:00',1.76),('15529','2013-08-07','15:15:00',1.74),('15529','2013-08-07','15:20:00',1.7),('15529','2013-08-07','15:25:00',1.68),('15529','2013-08-07','15:30:00',1.65),('15529','2013-08-07','15:35:00',1.63),('15529','2013-08-07','15:40:00',1.61),('15529','2013-08-07','15:45:00',1.58),('15529','2013-08-07','15:50:00',1.55),('15529','2013-08-07','15:55:00',1.54),('15529','2013-08-07','16:00:00',1.52),('15529','2013-08-07','16:05:00',1.49),('15529','2013-08-07','16:10:00',1.47),('15529','2013-08-07','16:15:00',1.45),('15529','2013-08-07','16:20:00',1.42),('15529','2013-08-07','16:25:00',1.38),('15529','2013-08-07','16:30:00',1.34),('15529','2013-08-07','16:35:00',1.31),('15529','2013-08-07','16:40:00',1.27),('15529','2013-08-07','16:45:00',1.22),('15529','2013-08-07','17:10:00',1),('15529','2013-08-06','09:10:00',1.02),('15529','2013-08-06','09:15:00',1.06),('15529','2013-08-06','09:20:00',1.1),('15529','2013-08-06','09:25:00',1.15),('15529','2013-08-06','09:30:00',1.18),('15529','2013-08-06','09:35:00',1.22),('15529','2013-08-06','09:40:00',1.25),('15529','2013-08-06','09:45:00',1.29),('15529','2013-08-06','09:50:00',1.32),('15529','2013-08-06','09:55:00',1.36),('15529','2013-08-06','10:00:00',1.39),('15529','2013-08-06','10:05:00',1.41),('15529','2013-08-06','10:10:00',1.43),('15529','2013-08-06','10:15:00',1.46),('15529','2013-08-06','10:20:00',1.51),('15529','2013-08-06','10:25:00',1.53),('15529','2013-08-06','10:30:00',1.56),('15529','2013-08-06','10:35:00',1.6),('15529','2013-08-06','10:40:00',1.63),('15529','2013-08-06','10:45:00',1.63),('15529','2013-08-06','10:50:00',1.67),('15529','2013-08-06','10:55:00',1.68),('15529','2013-08-06','11:00:00',1.7),('15529','2013-08-06','11:05:00',1.72),('15529','2013-08-06','11:10:00',1.74),('15529','2013-08-06','11:15:00',1.77),('15529','2013-08-06','11:20:00',1.74),('15529','2013-08-06','11:25:00',1.77),('15529','2013-08-06','11:30:00',1.78),('15529','2013-08-06','11:35:00',1.81),('15529','2013-08-06','11:40:00',1.85),('15529','2013-08-06','11:45:00',1.85),('15529','2013-08-06','11:50:00',1.83),('15529','2013-08-06','11:55:00',1.86),('15529','2013-08-06','12:00:00',1.89),('15529','2013-08-06','12:05:00',1.87),('15529','2013-08-06','12:10:00',1.87),('15529','2013-08-06','12:15:00',1.93),('15529','2013-08-06','12:20:00',1.92),('15529','2013-08-06','12:25:00',1.93),('15529','2013-08-06','12:30:00',1.89),('15529','2013-08-06','12:35:00',1.97),('15529','2013-08-06','12:40:00',1.93),('15529','2013-08-06','12:45:00',1.9),('15529','2013-08-06','12:50:00',1.93),('15529','2013-08-06','12:55:00',1.89),('15529','2013-08-06','13:00:00',1.92),('15529','2013-08-06','13:05:00',1.96),('15529','2013-08-06','13:10:00',2.04),('15529','2013-08-06','13:15:00',1.98),('15529','2013-08-06','13:20:00',1.97),('15529','2013-08-06','13:25:00',1.97),('15529','2013-08-06','13:30:00',2.01),('15529','2013-08-06','13:35:00',1.94),('15529','2013-08-06','13:40:00',2),('15529','2013-08-06','13:45:00',1.97),('15529','2013-08-06','13:50:00',2.01),('15529','2013-08-06','13:55:00',2),('15529','2013-08-06','14:00:00',1.96),('15529','2013-08-06','14:05:00',1.94),('15529','2013-08-06','14:10:00',1.9),('15529','2013-08-06','14:15:00',1.88),('15529','2013-08-06','14:20:00',1.83),('15529','2013-08-06','14:25:00',1.87),('15529','2013-08-06','14:30:00',1.85),('15529','2013-08-06','14:35:00',1.87),('15529','2013-08-06','14:40:00',1.89),('15529','2013-08-06','14:45:00',1.87),('15529','2013-08-06','14:50:00',1.84),('15529','2013-08-06','14:55:00',1.83),('15529','2013-08-06','15:00:00',1.82),('15529','2013-08-06','15:05:00',1.8),('15529','2013-08-06','15:10:00',1.78),('15529','2013-08-06','15:15:00',1.76),('15529','2013-08-06','15:20:00',1.73),('15529','2013-08-06','15:25:00',1.72),('15529','2013-08-06','15:30:00',1.69),('15529','2013-08-06','15:35:00',1.66),('15529','2013-08-06','15:40:00',1.64),('15529','2013-08-06','15:45:00',1.59),('15529','2013-08-06','15:50:00',1.56),('15529','2013-08-06','15:55:00',1.56),('15529','2013-08-06','16:00:00',1.5),('15529','2013-08-06','16:05:00',1.49),('15529','2013-08-06','16:10:00',1.47),('15529','2013-08-06','16:15:00',1.45),('15529','2013-08-06','16:20:00',1.42),('15529','2013-08-06','16:25:00',1.38),('15529','2013-08-06','16:30:00',1.34),('15529','2013-08-06','16:35:00',1.31),('15529','2013-08-06','16:40:00',1.28),('15529','2013-08-06','16:45:00',1.25),('15529','2013-08-06','16:50:00',1.21),('15529','2013-08-06','16:55:00',1.16),('15529','2013-08-06','17:00:00',1.1),('15529','2013-08-06','17:05:00',1.06),('15529','2013-08-06','17:10:00',1.04),('15529','2013-08-05','09:10:00',1.02),('15529','2013-08-05','09:15:00',1.06),('15529','2013-08-05','09:20:00',1.1),('15529','2013-08-05','09:25:00',1.13),('15529','2013-08-05','09:30:00',1.16),('15529','2013-08-05','09:35:00',1.2),('15529','2013-08-05','09:40:00',1.24),('15529','2013-08-05','09:45:00',1.27),('15529','2013-08-05','09:50:00',1.3),('15529','2013-08-05','09:55:00',1.35),('15529','2013-08-05','10:00:00',1.37),('15529','2013-08-05','10:05:00',1.41),('15529','2013-08-05','10:10:00',1.45),('15529','2013-08-05','10:15:00',1.46),('15529','2013-08-05','10:20:00',1.49),('15529','2013-08-05','10:25:00',1.51),('15529','2013-08-05','10:30:00',1.55),('15529','2013-08-05','10:35:00',1.58),('15529','2013-08-05','10:40:00',1.62),('15529','2013-08-05','10:45:00',1.61),('15529','2013-08-05','10:50:00',1.64),('15529','2013-08-05','10:55:00',1.66),('15529','2013-08-05','11:00:00',1.69),('15529','2013-08-05','11:05:00',1.71),('15529','2013-08-05','11:10:00',1.73),('15529','2013-08-05','11:15:00',1.75),('15529','2013-08-05','11:20:00',1.75),('15529','2013-08-05','11:25:00',1.8),('15529','2013-08-05','11:30:00',1.81),('15529','2013-08-05','11:35:00',1.82),('15529','2013-08-05','11:40:00',1.81),('15529','2013-08-05','11:45:00',1.81),('15529','2013-08-05','11:50:00',1.81),('15529','2013-08-05','11:55:00',1.85),('15529','2013-08-05','12:00:00',1.87),('15529','2013-08-05','12:05:00',1.89),('15529','2013-08-05','12:10:00',1.86),('15529','2013-08-05','12:15:00',1.87),('15529','2013-08-05','12:20:00',1.89),('15529','2013-08-05','12:25:00',1.92),('15529','2013-08-05','12:30:00',1.94),('15529','2013-08-05','12:35:00',1.89),('15529','2013-08-05','12:40:00',1.93),('15529','2013-08-05','12:45:00',1.94),('15529','2013-08-05','12:50:00',1.91),('15529','2013-08-05','12:55:00',1.96),('15529','2013-08-05','13:00:00',1.96),('15529','2013-08-05','13:05:00',1.99),('15529','2013-08-05','13:10:00',1.98),('15529','2013-08-05','13:15:00',1.95),('15529','2013-08-05','13:20:00',1.95),('15529','2013-08-05','13:25:00',1.94),('15529','2013-08-05','13:30:00',1.99),('15529','2013-08-05','13:35:00',2),('15529','2013-08-05','13:40:00',2.01),('15529','2013-08-05','13:45:00',2.02),('15529','2013-08-05','13:50:00',2.01),('15529','2013-08-05','13:55:00',1.98),('15529','2013-08-05','14:00:00',2),('15529','2013-08-05','14:05:00',2),('15529','2013-08-05','14:10:00',2.01),('15529','2013-08-05','14:15:00',2),('15529','2013-08-05','14:20:00',1.99),('15529','2013-08-05','14:25:00',1.96),('15529','2013-08-05','14:30:00',1.95),('15529','2013-08-05','14:35:00',1.93),('15529','2013-08-05','14:40:00',1.92),('15529','2013-08-05','14:45:00',1.92),('15529','2013-08-05','14:50:00',1.9),('15529','2013-08-05','14:55:00',1.89),('15529','2013-08-05','15:00:00',1.86),('15529','2013-08-05','15:05:00',1.85),('15529','2013-08-05','15:10:00',1.84),('15529','2013-08-05','15:15:00',1.83),('15529','2013-08-05','15:20:00',1.8),('15529','2013-08-05','15:25:00',1.78),('15529','2013-08-05','15:30:00',1.76),('15529','2013-08-05','15:35:00',1.72),('15529','2013-08-05','15:40:00',1.69),('15529','2013-08-05','15:45:00',1.66),('15529','2013-08-05','15:50:00',1.63),('15529','2013-08-05','15:55:00',1.61),('15529','2013-08-05','16:00:00',1.58),('15529','2013-08-05','16:05:00',1.55),('15529','2013-08-05','16:10:00',1.52),('15529','2013-08-05','16:15:00',1.48),('15529','2013-08-05','16:20:00',1.45),('15529','2013-08-05','16:25:00',1.42),('15529','2013-08-05','16:30:00',1.39),('15529','2013-08-05','16:35:00',1.35),('15529','2013-08-05','16:40:00',1.32),('15529','2013-08-05','16:45:00',1.28),('15529','2013-08-05','16:50:00',1.25),('15529','2013-08-05','16:55:00',1.21),('15529','2013-08-05','17:00:00',1.17),('15529','2013-08-05','17:05:00',1.12),('15529','2013-08-05','17:10:00',1.08),('15529','2013-08-05','17:15:00',1.03),('15529','2013-08-04','09:10:00',1.04),('15529','2013-08-04','09:15:00',1.07),('15529','2013-08-04','09:20:00',1.12),('15529','2013-08-04','09:25:00',1.15),('15529','2013-08-04','09:30:00',1.2),('15529','2013-08-04','09:35:00',1.22),('15529','2013-08-04','09:40:00',1.27),('15529','2013-08-04','09:45:00',1.3),('15529','2013-08-04','09:50:00',1.33),('15529','2013-08-04','09:55:00',1.37),('15529','2013-08-04','10:00:00',1.4),('15529','2013-08-04','10:05:00',1.42),('15529','2013-08-04','10:10:00',1.45),('15529','2013-08-04','10:15:00',1.48),('15529','2013-08-04','10:20:00',1.51),('15529','2013-08-04','10:25:00',1.55),('15529','2013-08-04','10:30:00',1.59),('15529','2013-08-04','10:35:00',1.62),('15529','2013-08-04','10:40:00',1.65),('15529','2013-08-04','10:45:00',1.69),('15529','2013-08-04','10:50:00',1.71),('15529','2013-08-04','10:55:00',1.7),('15529','2013-08-04','11:00:00',1.73),('15529','2013-08-04','11:05:00',1.75),('15529','2013-08-04','11:10:00',1.78),('15529','2013-08-04','11:15:00',1.78),('15529','2013-08-04','11:20:00',1.81),('15529','2013-08-04','11:25:00',1.83),('15529','2013-08-04','11:30:00',1.84),('15529','2013-08-04','11:35:00',1.88),('15529','2013-08-04','11:40:00',1.9),('15529','2013-08-04','11:45:00',1.91),('15529','2013-08-04','11:50:00',1.93),('15529','2013-08-04','11:55:00',1.96),('15529','2013-08-04','12:00:00',1.93),('15529','2013-08-04','12:05:00',1.94),('15529','2013-08-04','12:10:00',1.95),('15529','2013-08-04','12:15:00',1.95),('15529','2013-08-04','12:20:00',1.96),('15529','2013-08-04','12:25:00',1.98),('15529','2013-08-04','12:30:00',1.99),('15529','2013-08-04','12:35:00',1.98),('15529','2013-08-04','12:40:00',2.03),('15529','2013-08-04','12:45:00',2.02),('15529','2013-08-04','12:50:00',2),('15529','2013-08-04','12:55:00',1.99),('15529','2013-08-04','13:00:00',1.99),('15529','2013-08-04','13:05:00',1.99),('15529','2013-08-04','13:10:00',2.02),('15529','2013-08-04','13:15:00',2.02),('15529','2013-08-04','13:20:00',1.98),('15529','2013-08-04','13:25:00',1.99),('15529','2013-08-04','13:30:00',1.96),('15529','2013-08-04','13:35:00',1.95),('15529','2013-08-04','13:40:00',2),('15529','2013-08-04','13:45:00',1.98),('15529','2013-08-04','13:50:00',1.96),('15529','2013-08-04','13:55:00',1.94),('15529','2013-08-04','14:00:00',1.96),('15529','2013-08-04','14:05:00',1.96),('15529','2013-08-04','14:10:00',1.97),('15529','2013-08-04','14:15:00',1.95),('15529','2013-08-04','14:20:00',1.92),('15529','2013-08-04','14:25:00',1.89),('15529','2013-08-04','14:30:00',1.89),('15529','2013-08-04','14:35:00',1.93),('15529','2013-08-04','14:40:00',1.92),('15529','2013-08-04','14:45:00',1.92),('15529','2013-08-04','14:50:00',1.85),('15529','2013-08-04','14:55:00',1.82),('15529','2013-08-04','15:00:00',1.83),('15529','2013-08-04','15:05:00',1.82),('15529','2013-08-04','15:10:00',1.78),('15529','2013-08-04','15:15:00',1.79),('15529','2013-08-04','15:20:00',1.79),('15529','2013-08-04','15:25:00',1.79),('15529','2013-08-04','15:30:00',1.76),('15529','2013-08-04','15:35:00',1.76),('15529','2013-08-04','15:40:00',1.73),('15529','2013-08-04','15:45:00',1.68),('15529','2013-08-04','15:50:00',1.66),('15529','2013-08-04','15:55:00',1.61),('15529','2013-08-04','16:00:00',1.59),('15529','2013-08-04','16:05:00',1.58),('15529','2013-08-04','16:10:00',1.54),('15529','2013-08-04','16:15:00',1.5),('15529','2013-08-04','16:20:00',1.44),('15529','2013-08-04','16:25:00',1.41),('15529','2013-08-04','16:30:00',1.37),('15529','2013-08-04','16:35:00',1.35),('15529','2013-08-04','16:40:00',1.31),('15529','2013-08-04','16:45:00',1.28),('15529','2013-08-04','16:50:00',1.24),('15529','2013-08-04','16:55:00',1.19),('15529','2013-08-04','17:00:00',1.14),('15529','2013-08-04','17:05:00',1.1),('15529','2013-08-04','17:10:00',1.07),('15529','2013-08-04','17:15:00',1.03),('15529','2013-08-03','09:00:00',1),('15529','2013-08-03','09:05:00',1.05),('15529','2013-08-03','09:10:00',1.09),('15529','2013-08-03','09:15:00',1.13),('15529','2013-08-03','09:20:00',1.17),('15529','2013-08-03','09:25:00',1.21),('15529','2013-08-03','09:30:00',1.25),('15529','2013-08-03','09:35:00',1.29),('15529','2013-08-03','09:40:00',1.32),('15529','2013-08-03','09:45:00',1.36),('15529','2013-08-03','09:50:00',1.4),('15529','2013-08-03','09:55:00',1.44),('15529','2013-08-03','10:00:00',1.46),('15529','2013-08-03','10:05:00',1.5),('15529','2013-08-03','10:10:00',1.54),('15529','2013-08-03','10:15:00',1.57),('15529','2013-08-03','10:20:00',1.58),('15529','2013-08-03','10:25:00',1.62),('15529','2013-08-03','10:30:00',1.65),('15529','2013-08-03','10:35:00',1.67),('15529','2013-08-03','10:40:00',1.68),('15529','2013-08-03','10:45:00',1.71),('15529','2013-08-03','10:50:00',1.73),('15529','2013-08-03','10:55:00',1.77),('15529','2013-08-03','11:00:00',1.77),('15529','2013-08-03','11:05:00',1.78),('15529','2013-08-03','11:10:00',1.82),('15529','2013-08-03','11:15:00',1.86),('15529','2013-08-03','11:20:00',1.87),('15529','2013-08-03','11:25:00',1.87),('15529','2013-08-03','11:30:00',1.86),('15529','2013-08-03','11:35:00',1.96),('15529','2013-08-03','11:40:00',1.96),('15529','2013-08-03','11:45:00',1.97),('15529','2013-08-03','11:50:00',1.98),('15529','2013-08-03','11:55:00',2),('15529','2013-08-03','12:00:00',2.05),('15529','2013-08-03','12:05:00',2.04),('15529','2013-08-03','12:10:00',2.07),('15529','2013-08-03','12:15:00',2.01),('15529','2013-08-03','12:20:00',2.04),('15529','2013-08-03','12:25:00',2.07),('15529','2013-08-03','12:30:00',2.09),('15529','2013-08-03','12:35:00',2.12),('15529','2013-08-03','12:40:00',2.1),('15529','2013-08-03','12:45:00',2.11),('15529','2013-08-03','12:50:00',2.1),('15529','2013-08-03','12:55:00',2.08),('15529','2013-08-03','13:00:00',2.05),('15529','2013-08-03','13:05:00',2.07),('15529','2013-08-03','13:10:00',2.04),('15529','2013-08-03','13:15:00',2.04),('15529','2013-08-03','13:20:00',2.11),('15529','2013-08-03','13:25:00',2.1),('15529','2013-08-03','13:30:00',2.08),('15529','2013-08-03','13:35:00',2.1),('15529','2013-08-03','13:40:00',2.12),('15529','2013-08-03','13:45:00',2.13),('15529','2013-08-03','13:50:00',2.15),('15529','2013-08-03','13:55:00',2.13),('15529','2013-08-03','14:00:00',2.05),('15529','2013-08-03','14:05:00',2.04),('15529','2013-08-03','14:10:00',2.02),('15529','2013-08-03','14:15:00',1.99),('15529','2013-08-03','14:20:00',2.07),('15529','2013-08-03','14:25:00',2.02),('15529','2013-08-03','14:30:00',2.04),('15529','2013-08-03','14:35:00',2),('15529','2013-08-03','14:40:00',1.99),('15529','2013-08-03','14:45:00',1.95),('15529','2013-08-03','14:50:00',1.96),('15529','2013-08-03','14:55:00',1.95),('15529','2013-08-03','15:00:00',1.96),('15529','2013-08-03','15:05:00',1.91),('15529','2013-08-03','15:10:00',1.87),('15529','2013-08-03','15:15:00',1.86),('15529','2013-08-03','15:20:00',1.84),('15529','2013-08-03','15:25:00',1.79),('15529','2013-08-03','15:30:00',1.77),('15529','2013-08-03','15:35:00',1.76),('15529','2013-08-03','15:40:00',1.73),('15529','2013-08-03','15:45:00',1.72),('15529','2013-08-03','15:50:00',1.68),('15529','2013-08-03','15:55:00',1.63),('15529','2013-08-03','16:00:00',1.64),('15529','2013-08-03','16:05:00',1.6),('15529','2013-08-03','16:10:00',1.57),('15529','2013-08-03','16:15:00',1.55),('15529','2013-08-03','16:20:00',1.51),('15529','2013-08-03','16:25:00',1.48),('15529','2013-08-03','16:30:00',1.43),('15529','2013-08-03','16:35:00',1.39),('15529','2013-08-03','16:40:00',1.35),('15529','2013-08-03','16:45:00',1.31),('15529','2013-08-03','16:50:00',1.28),('15529','2013-08-03','16:55:00',1.23),('15529','2013-08-03','17:00:00',1.19),('15529','2013-08-03','17:05:00',1.15),('15529','2013-08-03','17:10:00',1.1),('15529','2013-08-03','17:15:00',1.07),('15529','2013-08-03','17:20:00',1.02),('15529','2013-08-02','09:00:00',1),('15529','2013-08-02','09:05:00',1.04),('15529','2013-08-02','09:10:00',1.08),('15529','2013-08-02','09:15:00',1.12),('15529','2013-08-02','09:20:00',1.16),('15529','2013-08-02','09:25:00',1.2),('15529','2013-08-02','09:30:00',1.24),('15529','2013-08-02','09:35:00',1.27),('15529','2013-08-02','09:40:00',1.31),('15529','2013-08-02','09:45:00',1.35),('15529','2013-08-02','09:50:00',1.38),('15529','2013-08-02','09:55:00',1.41),('15529','2013-08-02','10:00:00',1.44),('15529','2013-08-02','10:05:00',1.47),('15529','2013-08-02','10:10:00',1.51),('15529','2013-08-02','10:15:00',1.56),('15529','2013-08-02','10:20:00',1.59),('15529','2013-08-02','10:25:00',1.63),('15529','2013-08-02','10:30:00',1.66),('15529','2013-08-02','10:35:00',1.69),('15529','2013-08-02','10:40:00',1.69),('15529','2013-08-02','10:45:00',1.69),('15529','2013-08-02','10:50:00',1.73),('15529','2013-08-02','10:55:00',1.79),('15529','2013-08-02','11:00:00',1.79),('15529','2013-08-02','11:05:00',1.79),('15529','2013-08-02','11:10:00',1.79),('15529','2013-08-02','11:15:00',1.83),('15529','2013-08-02','11:20:00',1.83),('15529','2013-08-02','11:25:00',1.86),('15529','2013-08-02','11:30:00',1.86),('15529','2013-08-02','11:35:00',1.91),('15529','2013-08-02','11:40:00',1.92),('15529','2013-08-02','11:45:00',1.93),('15529','2013-08-02','11:50:00',1.91),('15529','2013-08-02','11:55:00',1.93),('15529','2013-08-02','12:00:00',1.93),('15529','2013-08-02','12:05:00',1.94),('15529','2013-08-02','12:10:00',1.93),('15529','2013-08-02','12:15:00',1.93),('15529','2013-08-02','12:20:00',1.97),('15529','2013-08-02','12:25:00',1.98),('15529','2013-08-02','12:30:00',1.99),('15529','2013-08-02','12:35:00',2.04),('15529','2013-08-02','12:40:00',2.03),('15529','2013-08-02','12:45:00',2),('15529','2013-08-02','12:50:00',1.99),('15529','2013-08-02','12:55:00',1.95),('15529','2013-08-02','13:00:00',1.97),('15529','2013-08-02','13:05:00',1.99),('15529','2013-08-02','13:10:00',1.95),('15529','2013-08-02','13:15:00',1.98),('15529','2013-08-02','13:20:00',2.03),('15529','2013-08-02','13:25:00',1.97),('15529','2013-08-02','13:30:00',1.95),('15529','2013-08-02','13:35:00',2.02),('15529','2013-08-02','13:40:00',2),('15529','2013-08-02','13:45:00',1.98),('15529','2013-08-02','13:50:00',1.96),('15529','2013-08-02','13:55:00',1.99),('15529','2013-08-02','14:00:00',2),('15529','2013-08-02','14:05:00',1.97),('15529','2013-08-02','14:10:00',1.95),('15529','2013-08-02','14:15:00',1.94),('15529','2013-08-02','14:20:00',1.97),('15529','2013-08-02','14:25:00',2),('15529','2013-08-02','14:30:00',1.99),('15529','2013-08-02','14:35:00',1.98),('15529','2013-08-02','14:40:00',1.96),('15529','2013-08-02','14:45:00',1.93),('15529','2013-08-02','14:50:00',1.92),('15529','2013-08-02','14:55:00',1.92),('15529','2013-08-02','15:00:00',1.91),('15529','2013-08-02','15:05:00',1.86),('15529','2013-08-02','15:10:00',1.84),('15529','2013-08-02','15:15:00',1.85),('15529','2013-08-02','15:20:00',1.82),('15529','2013-08-02','15:25:00',1.82),('15529','2013-08-02','15:30:00',1.77),('15529','2013-08-02','15:35:00',1.75),('15529','2013-08-02','15:40:00',1.73),('15529','2013-08-02','15:45:00',1.71),('15529','2013-08-02','15:50:00',1.68),('15529','2013-08-02','15:55:00',1.64),('15529','2013-08-02','16:00:00',1.64),('15529','2013-08-02','16:05:00',1.59),('15529','2013-08-02','16:10:00',1.54),('15529','2013-08-02','16:15:00',1.51),('15529','2013-08-02','16:20:00',1.47),('15529','2013-08-02','16:25:00',1.44),('15529','2013-08-02','16:30:00',1.41),('15529','2013-08-02','16:35:00',1.37),('15529','2013-08-02','16:40:00',1.33),('15529','2013-08-02','16:45:00',1.29),('15529','2013-08-02','16:50:00',1.25),('15529','2013-08-02','16:55:00',1.21),('15529','2013-08-02','17:00:00',1.17),('15529','2013-08-02','17:05:00',1.14),('15529','2013-08-02','17:10:00',1.11),('15529','2013-08-02','17:15:00',1.06),('15529','2013-08-02','17:20:00',1.01),('15529','2013-08-01','09:00:00',1.04),('15529','2013-08-01','09:05:00',1.08),('15529','2013-08-01','09:10:00',1.12),('15529','2013-08-01','09:15:00',1.17),('15529','2013-08-01','09:20:00',1.21),('15529','2013-08-01','09:25:00',1.24),('15529','2013-08-01','09:30:00',1.28),('15529','2013-08-01','09:35:00',1.32),('15529','2013-08-01','09:40:00',1.35),('15529','2013-08-01','09:45:00',1.38),('15529','2013-08-01','09:50:00',1.41),('15529','2013-08-01','09:55:00',1.45),('15529','2013-08-01','10:00:00',1.48),('15529','2013-08-01','10:05:00',1.53),('15529','2013-08-01','10:10:00',1.57),('15529','2013-08-01','10:15:00',1.59),('15529','2013-08-01','10:20:00',1.62),('15529','2013-08-01','10:25:00',1.65),('15529','2013-08-01','10:30:00',1.67),('15529','2013-08-01','10:35:00',1.72),('15529','2013-08-01','10:40:00',1.74),('15529','2013-08-01','10:45:00',1.76),('15529','2013-08-01','10:50:00',1.78),('15529','2013-08-01','10:55:00',1.81),('15529','2013-08-01','11:00:00',1.84),('15529','2013-08-01','11:05:00',1.84),('15529','2013-08-01','11:10:00',1.87),('15529','2013-08-01','11:15:00',1.89),('15529','2013-08-01','11:20:00',1.92),('15529','2013-08-01','11:25:00',1.92),('15529','2013-08-01','11:30:00',1.92),('15529','2013-08-01','11:35:00',1.93),('15529','2013-08-01','11:40:00',1.97),('15529','2013-08-01','11:45:00',1.97),('15529','2013-08-01','11:50:00',2),('15529','2013-08-01','11:55:00',2.02),('15529','2013-08-01','12:00:00',2.03),('15529','2013-08-01','12:05:00',2.03),('15529','2013-08-01','12:10:00',2.05),('15529','2013-08-01','12:15:00',2.05),('15529','2013-08-01','12:20:00',2.02),('15529','2013-08-01','12:25:00',2.02),('15529','2013-08-01','12:30:00',2.03),('15529','2013-08-01','12:35:00',2.08),('15529','2013-08-01','12:40:00',2.06),('15529','2013-08-01','12:45:00',2.06),('15529','2013-08-01','12:50:00',2.08),('15529','2013-08-01','12:55:00',2.11),('15529','2013-08-01','13:00:00',2.06),('15529','2013-08-01','13:05:00',2.09),('15529','2013-08-01','13:10:00',2.1),('15529','2013-08-01','13:15:00',2.09),('15529','2013-08-01','13:20:00',2.08),('15529','2013-08-01','13:25:00',2.06),('15529','2013-08-01','13:30:00',2.05),('15529','2013-08-01','13:35:00',2.05),('15529','2013-08-01','13:40:00',2.07),('15529','2013-08-01','13:45:00',2.01),('15529','2013-08-01','13:50:00',2.03),('15529','2013-08-01','13:55:00',2.06),('15529','2013-08-01','14:00:00',2.02),('15529','2013-08-01','14:05:00',2.06),('15529','2013-08-01','14:10:00',2.07),('15529','2013-08-01','14:15:00',2.1),('15529','2013-08-01','14:20:00',2.06),('15529','2013-08-01','14:25:00',2.03),('15529','2013-08-01','14:30:00',2.02),('15529','2013-08-01','14:35:00',1.99),('15529','2013-08-01','14:40:00',1.98),('15529','2013-08-01','14:45:00',1.98),('15529','2013-08-01','14:50:00',1.96),('15529','2013-08-01','14:55:00',1.93),('15529','2013-08-01','15:00:00',1.92),('15529','2013-08-01','15:05:00',1.88),('15529','2013-08-01','15:10:00',1.87),('15529','2013-08-01','15:15:00',1.86),('15529','2013-08-01','15:20:00',1.84),('15529','2013-08-01','15:25:00',1.83),('15529','2013-08-01','15:30:00',1.79),('15529','2013-08-01','15:35:00',1.78),('15529','2013-08-01','15:40:00',1.77),('15529','2013-08-01','15:45:00',1.73),('15529','2013-08-01','15:50:00',1.71),('15529','2013-08-01','15:55:00',1.68),('15529','2013-08-01','16:00:00',1.65),('15529','2013-08-01','16:05:00',1.6),('15529','2013-08-01','16:10:00',1.59),('15529','2013-08-01','16:15:00',1.55),('15529','2013-08-01','16:20:00',1.52),('15529','2013-08-01','16:25:00',1.48),('15529','2013-08-01','16:30:00',1.42),('15529','2013-08-01','16:35:00',1.39),('15529','2013-08-01','16:40:00',1.36),('15529','2013-08-01','16:45:00',1.34),('15529','2013-08-01','16:50:00',1.29),('15529','2013-08-01','16:55:00',1.25),('15529','2013-08-01','17:00:00',1.21),('15529','2013-08-01','17:05:00',1.16),('15529','2013-08-01','17:10:00',1.12),('15529','2013-08-01','17:15:00',1.08),('15529','2013-08-01','17:20:00',1.05),('15529','2013-08-01','17:25:00',1.01),('15529','2013-07-31','09:00:00',1.05),('15529','2013-07-31','09:05:00',1.09),('15529','2013-07-31','09:10:00',1.14),('15529','2013-07-31','09:15:00',1.18),('15529','2013-07-31','09:20:00',1.24),('15529','2013-07-31','09:25:00',1.28),('15529','2013-07-31','09:30:00',1.31),('15529','2013-07-31','09:35:00',1.35),('15529','2013-07-31','09:40:00',1.38),('15529','2013-07-31','09:45:00',1.42),('15529','2013-07-31','09:50:00',1.47),('15529','2013-07-31','09:55:00',1.51),('15529','2013-07-31','10:00:00',1.55),('15529','2013-07-31','10:05:00',1.59),('15529','2013-07-31','10:10:00',1.62),('15529','2013-07-31','10:15:00',1.66),('15529','2013-07-31','10:20:00',1.69),('15529','2013-07-31','10:25:00',1.71),('15529','2013-07-31','10:30:00',1.75),('15529','2013-07-31','10:35:00',1.76),('15529','2013-07-31','10:40:00',1.8),('15529','2013-07-31','10:45:00',1.83),('15529','2013-07-31','10:50:00',1.86),('15529','2013-07-31','10:55:00',1.87),('15529','2013-07-31','11:00:00',1.91),('15529','2013-07-31','11:05:00',1.91),('15529','2013-07-31','11:10:00',1.93),('15529','2013-07-31','11:15:00',1.96),('15529','2013-07-31','11:20:00',1.99),('15529','2013-07-31','11:25:00',2),('15529','2013-07-31','11:30:00',2.04),('15529','2013-07-31','11:35:00',2.06),('15529','2013-07-31','11:40:00',2.07),('15529','2013-07-31','11:45:00',2.11),('15529','2013-07-31','11:50:00',2.1),('15529','2013-07-31','11:55:00',2.09),('15529','2013-07-31','12:00:00',2.09),('15529','2013-07-31','12:05:00',2.11),('15529','2013-07-31','12:10:00',2.07),('15529','2013-07-31','12:15:00',2.11),('15529','2013-07-31','12:20:00',2.17),('15529','2013-07-31','12:25:00',2.18),('15529','2013-07-31','12:30:00',2.17),('15529','2013-07-31','12:35:00',2.15),('15529','2013-07-31','12:40:00',2.19),('15529','2013-07-31','12:45:00',2.16),('15529','2013-07-31','12:50:00',2.18),('15529','2013-07-31','12:55:00',2.19),('15529','2013-07-31','13:00:00',2.21),('15529','2013-07-31','13:05:00',2.18),('15529','2013-07-31','13:10:00',1.79),('15529','2013-07-31','13:15:00',2.1),('15529','2013-07-31','13:20:00',2.07),('15529','2013-07-31','13:25:00',2.23),('15529','2013-07-31','13:30:00',2.24),('15529','2013-07-31','13:35:00',2.22),('15529','2013-07-31','13:40:00',2.22),('15529','2013-07-31','13:45:00',2.22),('15529','2013-07-31','13:50:00',2.24),('15529','2013-07-31','13:55:00',2.2),('15529','2013-07-31','14:00:00',2.19),('15529','2013-07-31','14:05:00',2.17),('15529','2013-07-31','14:10:00',2.13),('15529','2013-07-31','14:15:00',2.17),('15529','2013-07-31','14:20:00',2.15),('15529','2013-07-31','14:25:00',2.12),('15529','2013-07-31','14:30:00',2.07),('15529','2013-07-31','14:35:00',2.07),('15529','2013-07-31','14:40:00',2.07),('15529','2013-07-31','14:45:00',2.05),('15529','2013-07-31','14:50:00',1.84),('15529','2013-07-31','14:55:00',1.98),('15529','2013-07-31','15:00:00',1.95),('15529','2013-07-31','15:05:00',1.93),('15529','2013-07-31','15:10:00',1.94),('15529','2013-07-31','15:15:00',1.92),('15529','2013-07-31','15:20:00',1.89),('15529','2013-07-31','15:25:00',1.87),('15529','2013-07-31','15:30:00',1.88),('15529','2013-07-31','15:35:00',1.83),('15529','2013-07-31','15:40:00',1.88),('15529','2013-07-31','15:45:00',1.76),('15529','2013-07-31','15:50:00',1.76),('15529','2013-07-31','15:55:00',1.74),('15529','2013-07-31','16:00:00',1.7),('15529','2013-07-31','16:05:00',1.7),('15529','2013-07-31','16:10:00',1.66),('15529','2013-07-31','16:15:00',1.59),('15529','2013-07-31','16:20:00',1.55),('15529','2013-07-31','16:25:00',1.52),('15529','2013-07-31','16:30:00',1.48),('15529','2013-07-31','16:35:00',1.45),('15529','2013-07-31','16:40:00',1.4),('15529','2013-07-31','16:45:00',1.36),('15529','2013-07-31','16:50:00',1.32),('15529','2013-07-31','16:55:00',1.28),('15529','2013-07-31','17:00:00',1.23),('15529','2013-07-31','17:05:00',1.19),('15529','2013-07-31','17:10:00',1.13),('15529','2013-07-31','17:15:00',1.1),('15529','2013-07-31','17:20:00',1.06),('15529','2013-07-31','17:25:00',1.02),('15529','2013-07-30','08:55:00',1.03),('15529','2013-07-30','09:00:00',1.07),('15529','2013-07-30','09:05:00',1.11),('15529','2013-07-30','09:10:00',1.15),('15529','2013-07-30','09:15:00',1.2),('15529','2013-07-30','09:20:00',1.24),('15529','2013-07-30','09:25:00',1.28),('15529','2013-07-30','09:30:00',1.31),('15529','2013-07-30','09:35:00',1.36),('15529','2013-07-30','09:40:00',1.39),('15529','2013-07-30','09:45:00',1.43),('15529','2013-07-30','09:50:00',1.45),('15529','2013-07-30','09:55:00',1.49),('15529','2013-07-30','10:00:00',1.52),('15529','2013-07-30','10:05:00',1.56),('15529','2013-07-30','10:10:00',1.57),('15529','2013-07-30','10:15:00',1.59),('15529','2013-07-30','10:20:00',1.66),('15529','2013-07-30','10:25:00',1.69),('15529','2013-07-30','10:30:00',1.71),('15529','2013-07-30','10:35:00',1.75),('15529','2013-07-30','10:40:00',1.79),('15529','2013-07-30','10:45:00',1.81),('15529','2013-07-30','10:50:00',1.84),('15529','2013-07-30','10:55:00',1.89),('15529','2013-07-30','11:00:00',1.92),('15529','2013-07-30','11:05:00',1.96),('15529','2013-07-30','11:10:00',1.96),('15529','2013-07-30','11:15:00',1.96),('15529','2013-07-30','11:20:00',2),('15529','2013-07-30','11:25:00',1.98),('15529','2013-07-30','11:30:00',2.01),('15529','2013-07-30','11:35:00',2.03),('15529','2013-07-30','11:40:00',2.05),('15529','2013-07-30','11:45:00',2.06),('15529','2013-07-30','11:50:00',2.08),('15529','2013-07-30','11:55:00',1.86),('15529','2013-07-30','12:00:00',2.06),('15529','2013-07-30','12:05:00',2.05),('15529','2013-07-30','12:10:00',2.14),('15529','2013-07-30','12:15:00',1.95),('15529','2013-07-30','12:20:00',2.16),('15529','2013-07-30','12:25:00',2.12),('15529','2013-07-30','12:30:00',1.05),('15529','2013-07-30','12:35:00',2.09),('15529','2013-07-30','12:40:00',2.16),('15529','2013-07-30','12:45:00',2.15),('15529','2013-07-30','12:55:00',1.63),('15529','2013-07-30','13:00:00',1.86),('15529','2013-07-30','13:05:00',1.86),('15529','2013-07-30','13:10:00',1.9),('15529','2013-07-30','13:15:00',2.25),('15529','2013-07-30','13:20:00',1.23),('15529','2013-07-30','13:35:00',2.1),('15529','2013-07-30','13:40:00',2.12),('15529','2013-07-30','13:45:00',2.08),('15529','2013-07-30','13:50:00',2.1),('15529','2013-07-30','13:55:00',2.12),('15529','2013-07-30','14:00:00',2.02),('15529','2013-07-30','14:05:00',1.86),('15529','2013-07-30','14:10:00',2.07),('15529','2013-07-30','14:15:00',2.06),('15529','2013-07-30','14:20:00',2.05),('15529','2013-07-30','14:25:00',1.79),('15529','2013-07-30','14:45:00',1.61),('15529','2013-07-30','14:50:00',2.05),('15529','2013-07-30','14:55:00',2.06),('15529','2013-07-30','15:00:00',2.03),('15529','2013-07-30','15:05:00',2.01),('15529','2013-07-30','15:10:00',1.95),('15529','2013-07-30','15:15:00',1.92),('15529','2013-07-30','15:20:00',1.92),('15529','2013-07-30','15:25:00',1.9),('15529','2013-07-30','15:30:00',1.85),('15529','2013-07-30','15:35:00',1.84),('15529','2013-07-30','15:40:00',1.82),('15529','2013-07-30','15:45:00',1.66),('15529','2013-07-30','15:50:00',1.69),('15529','2013-07-30','15:55:00',1.69),('15529','2013-07-30','16:00:00',1.67),('15529','2013-07-30','16:05:00',1.64),('15529','2013-07-30','16:10:00',1.62),('15529','2013-07-30','16:15:00',1.58),('15529','2013-07-30','16:20:00',1.56),('15529','2013-07-30','16:25:00',1.56),('15529','2013-07-30','16:30:00',1.52),('15529','2013-07-30','16:35:00',1.45),('15529','2013-07-30','16:40:00',1.4),('15529','2013-07-30','16:45:00',1.36),('15529','2013-07-30','16:50:00',1.27),('15529','2013-07-30','16:55:00',1.28),('15529','2013-07-30','17:00:00',1.27),('15529','2013-07-30','17:20:00',1.12),('15529','2014-04-07','09:05:00',1.05),('15529','2014-04-07','09:10:00',1.1),('15529','2014-04-07','09:15:00',1.14),('15529','2014-04-07','09:20:00',1.19),('15529','2014-04-07','09:25:00',1.24),('15529','2014-04-07','09:30:00',1.26),('15529','2014-04-07','09:35:00',1.28),('15529','2014-04-07','09:40:00',1.3),('15529','2014-04-07','09:45:00',1.36),('15529','2014-04-07','09:50:00',1.39),('15529','2014-04-07','09:55:00',1.43),('15529','2014-04-07','10:00:00',1.43),('15529','2014-04-07','10:05:00',1.49),('15529','2014-04-07','10:10:00',1.59),('15529','2014-04-07','10:15:00',1.61),('15529','2014-04-07','10:20:00',1.64),('15529','2014-04-07','10:25:00',1.67),('15529','2014-04-07','10:30:00',1.7),('15529','2014-04-07','10:35:00',1.76),('15529','2014-04-07','10:40:00',1.77),('15529','2014-04-07','10:45:00',1.82),('15529','2014-04-07','10:50:00',1.85),('15529','2014-04-07','10:55:00',1.87),('15529','2014-04-07','11:00:00',1.89),('15529','2014-04-07','11:05:00',1.91),('15529','2014-04-07','11:10:00',1.91),('15529','2014-04-07','11:15:00',1.94),('15529','2014-04-07','11:20:00',1.96),('15529','2014-04-07','11:25:00',2),('15529','2014-04-07','11:30:00',1.96),('15529','2014-04-07','11:35:00',2.03),('15529','2014-04-07','11:40:00',2.04),('15529','2014-04-07','11:45:00',2.07),('15529','2014-04-07','11:50:00',2.1),('15529','2014-04-07','11:55:00',2.14),('15529','2014-04-07','12:00:00',2.13),('15529','2014-04-07','12:05:00',2.07),('15529','2014-04-07','12:10:00',2),('15529','2014-04-07','12:15:00',1.85),('15529','2014-04-07','12:20:00',1.9),('15529','2014-04-07','12:25:00',1.96),('15529','2014-04-07','12:30:00',1.92),('15529','2014-04-07','12:35:00',2.09),('15529','2014-04-07','12:40:00',1.84),('15529','2014-04-07','12:45:00',1.99),('15529','2014-04-07','12:50:00',1.88),('15529','2014-04-07','12:55:00',2.22),('15529','2014-04-07','13:00:00',2.15),('15529','2014-04-07','13:05:00',2.27),('15529','2014-04-07','13:10:00',2.23),('15529','2014-04-07','13:15:00',2.31),('15529','2014-04-07','13:20:00',2.31),('15529','2014-04-07','13:25:00',2.3),('15529','2014-04-07','13:30:00',2.32),('15529','2014-04-07','13:35:00',2.3),('15529','2014-04-07','13:40:00',2.32),('15529','2014-04-07','13:45:00',2.28),('15529','2014-04-07','13:50:00',2.26),('15529','2014-04-07','13:55:00',2.27),('15529','2014-04-07','14:00:00',2.22),('15529','2014-04-07','14:05:00',2.21),('15529','2014-04-07','14:10:00',2.22),('15529','2014-04-07','14:15:00',2.21),('15529','2014-04-07','14:20:00',2.05),('15529','2014-04-07','14:25:00',1.95),('15529','2014-04-07','14:30:00',2.17),('15529','2014-04-07','14:35:00',2.13),('15529','2014-04-07','14:40:00',1.75),('15529','2014-04-07','14:45:00',2.02),('15529','2014-04-07','14:50:00',2.07),('15529','2014-04-07','14:55:00',2.09),('15529','2014-04-07','15:00:00',2.06),('15529','2014-04-07','15:05:00',2.02),('15529','2014-04-07','15:10:00',1.99),('15529','2014-04-07','15:15:00',1.92),('15529','2014-04-07','15:20:00',1.93),('15529','2014-04-07','15:25:00',1.92),('15529','2014-04-07','15:30:00',1.88),('15529','2014-04-07','15:35:00',1.84),('15529','2014-04-07','15:40:00',1.76),('15529','2014-04-07','15:45:00',1.75),('15529','2014-04-07','15:50:00',1.76),('15529','2014-04-07','15:55:00',1.71),('15529','2014-04-07','16:00:00',1.63),('15529','2014-04-07','16:05:00',1.66),('15529','2014-04-07','16:10:00',1.57),('15529','2014-04-07','16:15:00',1.49),('15529','2014-04-07','16:20:00',1.4),('15529','2014-04-07','16:25:00',1.4),('15529','2014-04-07','16:30:00',1.48),('15529','2014-04-07','16:35:00',1.39),('15529','2014-04-07','16:40:00',1.36),('15529','2014-04-07','16:45:00',1.31),('15529','2014-04-07','16:50:00',1.28),('15529','2014-04-07','16:55:00',1.18),('15529','2014-04-07','17:00:00',1.13),('15529','2014-04-07','17:05:00',1.13),('15529','2014-04-07','17:10:00',1.07),('15529','2014-04-07','17:15:00',1.02),('15529','2013-07-29','09:05:00',1.15),('15529','2013-07-29','09:10:00',1.22),('15529','2013-07-29','09:25:00',1.33),('15529','2013-07-29','09:30:00',1.07),('15529','2013-07-29','09:35:00',1.34),('15529','2013-07-29','09:40:00',1.42),('15529','2013-07-29','09:45:00',1.5),('15529','2013-07-29','09:50:00',1.57),('15529','2013-07-29','09:55:00',1.58),('15529','2013-07-29','10:00:00',1.59),('15529','2013-07-29','10:05:00',1.66),('15529','2013-07-29','10:10:00',1.7),('15529','2013-07-29','10:15:00',1.73),('15529','2013-07-29','10:20:00',1.76),('15529','2013-07-29','10:25:00',1.81),('15529','2013-07-29','10:30:00',1.83),('15529','2013-07-29','10:35:00',1.79),('15529','2013-07-29','10:40:00',1.83),('15529','2013-07-29','10:45:00',1.42),('15529','2013-07-29','10:50:00',1.35),('15529','2013-07-29','10:55:00',1.74),('15529','2013-07-29','11:00:00',1.82),('15529','2013-07-29','11:05:00',1.86),('15529','2013-07-29','11:10:00',1.82),('15529','2013-07-29','11:15:00',1.86),('15529','2013-07-29','11:20:00',1.88),('15529','2013-07-29','11:25:00',1.89),('15529','2013-07-29','11:30:00',1.91),('15529','2013-07-29','11:35:00',1.9),('15529','2013-07-29','11:40:00',1.9),('15529','2013-07-29','11:45:00',1.71),('15529','2013-07-29','11:50:00',1.75),('15529','2013-07-29','11:55:00',1.7),('15529','2013-07-29','12:00:00',1.7),('15529','2013-07-29','12:05:00',1.18),('15529','2013-07-29','12:10:00',1.15),('15529','2013-07-29','12:15:00',1.14),('15529','2013-07-29','12:20:00',1.14),('15529','2013-07-29','12:40:00',1.82),('15529','2013-07-29','12:45:00',2.19),('15529','2013-07-29','12:50:00',2.14),('15529','2013-07-29','12:55:00',1.5),('15529','2013-07-29','13:15:00',1.52),('15529','2013-07-29','13:20:00',2.3),('15529','2013-07-29','13:25:00',2.21),('15529','2013-07-29','13:30:00',2.19),('15529','2013-07-29','13:35:00',1.48),('15529','2013-07-29','13:40:00',2.25),('15529','2013-07-29','13:45:00',2.17),('15529','2013-07-29','13:50:00',2.17),('15529','2013-07-29','13:55:00',2.17),('15529','2013-07-29','14:00:00',2.12),('15529','2013-07-29','14:05:00',2.12),('15529','2013-07-29','14:10:00',2.19),('15529','2013-07-29','14:15:00',1.52),('15529','2013-07-29','14:20:00',2.06),('15529','2013-07-29','14:25:00',2.12),('15529','2013-07-29','14:35:00',1.5),('15529','2013-07-29','14:40:00',2.05),('15529','2013-07-29','14:45:00',1.99),('15529','2013-07-29','14:50:00',1.96),('15529','2013-07-29','14:55:00',1.98),('15529','2013-07-29','15:00:00',1.84),('15529','2013-07-29','15:05:00',1.84),('15529','2013-07-29','15:10:00',1.86),('15529','2013-07-29','15:15:00',1.87),('15529','2013-07-29','15:20:00',1.86),('15529','2013-07-29','15:25:00',1.83),('15529','2013-07-29','15:30:00',1.81),('15529','2013-07-29','15:35:00',1.78),('15529','2013-07-29','15:40:00',1.77),('15529','2013-07-29','15:45:00',1.74),('15529','2013-07-29','15:50:00',1.7),('15529','2013-07-29','15:55:00',1.66),('15529','2013-07-29','16:00:00',1.64),('15529','2013-07-29','16:05:00',1.6),('15529','2013-07-29','16:10:00',1.57),('15529','2013-07-29','16:15:00',1.54),('15529','2013-07-29','16:20:00',1.5),('15529','2013-07-29','16:25:00',1.46),('15529','2013-07-29','16:30:00',1.42),('15529','2013-07-29','16:35:00',1.38),('15529','2013-07-29','16:40:00',1.35),('15529','2013-07-29','16:45:00',1.33),('15529','2013-07-29','16:50:00',1.29),('15529','2013-07-29','16:55:00',1.24),('15529','2013-07-29','17:00:00',1.2),('15529','2013-07-29','17:05:00',1.17),('15529','2013-07-29','17:10:00',1.12),('15529','2013-07-29','17:15:00',1.07),('15529','2013-07-29','17:20:00',1.02),('15529','2013-07-28','09:10:00',1.03),('15529','2013-07-28','09:15:00',1.06),('15529','2013-07-28','09:20:00',1.12),('15529','2013-07-28','09:25:00',1.16),('15529','2013-07-28','09:30:00',1.19),('15529','2013-07-28','09:35:00',1.22),('15529','2013-07-28','09:40:00',1.28),('15529','2013-07-28','09:45:00',1.32),('15529','2013-07-28','09:50:00',1.35),('15529','2013-07-28','09:55:00',1.37),('15529','2013-07-28','10:00:00',1.41),('15529','2013-07-28','10:05:00',1.43),('15529','2013-07-28','10:10:00',1.46),('15529','2013-07-28','10:15:00',1.52),('15529','2013-07-28','10:20:00',1.56),('15529','2013-07-28','10:25:00',1.58),('15529','2013-07-28','10:30:00',1.63),('15529','2013-07-28','10:35:00',1.64),('15529','2013-07-28','10:40:00',1.64),('15529','2013-07-28','10:45:00',1.69),('15529','2013-07-28','10:50:00',1.73),('15529','2013-07-28','10:55:00',1.73),('15529','2013-07-28','11:00:00',1.79),('15529','2013-07-28','11:05:00',1.81),('15529','2013-07-28','11:10:00',1.79),('15529','2013-07-28','11:15:00',1.85),('15529','2013-07-28','11:20:00',1.88),('15529','2013-07-28','11:25:00',1.9),('15529','2013-07-28','11:30:00',1.94),('15529','2013-07-28','11:35:00',1.88),('15529','2013-07-28','11:40:00',1.95),('15529','2013-07-28','11:45:00',1.95),('15529','2013-07-28','11:50:00',1.97),('15529','2013-07-28','11:55:00',1.9),('15529','2013-07-28','12:00:00',1.94),('15529','2013-07-28','12:05:00',2.03),('15529','2013-07-28','12:10:00',2.02),('15529','2013-07-28','12:15:00',1.95),('15529','2013-07-28','12:20:00',1.99),('15529','2013-07-28','12:25:00',1.96),('15529','2013-07-28','12:30:00',1.92),('15529','2013-07-28','12:35:00',1.97),('15529','2013-07-28','12:40:00',2.03),('15529','2013-07-28','12:45:00',2),('15529','2013-07-28','12:50:00',1.99),('15529','2013-07-28','12:55:00',2.04),('15529','2013-07-28','13:00:00',1.58),('15529','2013-07-28','13:05:00',2.08),('15529','2013-07-28','13:10:00',2.1),('15529','2013-07-28','13:15:00',2.07),('15529','2013-07-28','13:20:00',2.08),('15529','2013-07-28','13:25:00',2.14),('15529','2013-07-28','13:30:00',2.13),('15529','2013-07-28','13:35:00',2.07),('15529','2013-07-28','13:40:00',2.11),('15529','2013-07-28','13:45:00',2.11),('15529','2013-07-28','13:50:00',2.08),('15529','2013-07-28','13:55:00',2.04),('15529','2013-07-28','14:00:00',2.04),('15529','2013-07-28','14:05:00',2.03),('15529','2013-07-28','14:10:00',2.01),('15529','2013-07-28','14:15:00',2.01),('15529','2013-07-28','14:20:00',2.03),('15529','2013-07-28','14:25:00',2.01),('15529','2013-07-28','14:30:00',1.99),('15529','2013-07-28','14:35:00',1.99),('15529','2013-07-28','14:40:00',1.94),('15529','2013-07-28','14:45:00',1.92),('15529','2013-07-28','14:50:00',1.9),('15529','2013-07-28','14:55:00',1.9),('15529','2013-07-28','15:00:00',1.88),('15529','2013-07-28','15:05:00',1.88),('15529','2013-07-28','15:10:00',1.85),('15529','2013-07-28','15:15:00',1.81),('15529','2013-07-28','15:20:00',1.79),('15529','2013-07-28','15:25:00',1.79),('15529','2013-07-28','15:30:00',1.78),('15529','2013-07-28','15:35:00',1.78),('15529','2013-07-28','15:40:00',1.81),('15529','2013-07-28','15:45:00',1.51),('15529','2013-07-28','15:50:00',1.24),('15529','2013-07-28','16:00:00',1.05),('15529','2013-07-28','16:05:00',1.56),('15529','2013-07-28','16:10:00',1.34),('15529','2013-07-28','16:15:00',1.19),('15529','2013-07-28','16:20:00',1.11),('15529','2013-07-28','16:25:00',1.51),('15529','2013-07-28','16:30:00',1.45),('15529','2013-07-28','16:35:00',1.07),('15529','2013-07-28','16:40:00',1.48),('15529','2013-07-28','16:45:00',1.42),('15529','2013-07-28','17:05:00',1.04),('15529','2013-07-28','17:20:00',1.12),('15529','2013-07-27','09:05:00',1.02),('15529','2013-07-27','09:10:00',1.07),('15529','2013-07-27','09:15:00',1.1),('15529','2013-07-27','09:20:00',1.13),('15529','2013-07-27','09:25:00',1.17),('15529','2013-07-27','09:30:00',1.21),('15529','2013-07-27','09:35:00',1.24),('15529','2013-07-27','09:40:00',1.28),('15529','2013-07-27','09:45:00',1.33),('15529','2013-07-27','09:50:00',1.36),('15529','2013-07-27','09:55:00',1.39),('15529','2013-07-27','10:00:00',1.42),('15529','2013-07-27','10:05:00',1.46),('15529','2013-07-27','10:10:00',1.49),('15529','2013-07-27','10:15:00',1.53),('15529','2013-07-27','10:20:00',1.56),('15529','2013-07-27','10:25:00',1.6),('15529','2013-07-27','10:30:00',1.6),('15529','2013-07-27','10:35:00',1.65),('15529','2013-07-27','10:40:00',1.66),('15529','2013-07-27','10:45:00',1.66),('15529','2013-07-27','10:50:00',1.71),('15529','2013-07-27','10:55:00',1.7),('15529','2013-07-27','11:00:00',1.74),('15529','2013-07-27','11:05:00',1.76),('15529','2013-07-27','11:10:00',1.78),('15529','2013-07-27','11:15:00',1.78),('15529','2013-07-27','11:20:00',1.82),('15529','2013-07-27','11:25:00',1.84),('15529','2013-07-27','11:30:00',1.84),('15529','2013-07-27','11:35:00',1.89),('15529','2013-07-27','11:40:00',1.86),('15529','2013-07-27','11:45:00',1.93),('15529','2013-07-27','11:50:00',1.91),('15529','2013-07-27','11:55:00',1.88),('15529','2013-07-27','12:00:00',1.91),('15529','2013-07-27','12:05:00',1.92),('15529','2013-07-27','12:10:00',1.88),('15529','2013-07-27','12:15:00',1.94),('15529','2013-07-27','12:20:00',1.96),('15529','2013-07-27','12:25:00',1.92),('15529','2013-07-27','12:30:00',1.96),('15529','2013-07-27','12:35:00',2),('15529','2013-07-27','12:40:00',2.02),('15529','2013-07-27','12:45:00',1.99),('15529','2013-07-27','12:50:00',2.05),('15529','2013-07-27','12:55:00',2.04),('15529','2013-07-27','13:00:00',2.05),('15529','2013-07-27','13:05:00',2.04),('15529','2013-07-27','13:10:00',2.02),('15529','2013-07-27','13:15:00',1.97),('15529','2013-07-27','13:20:00',1.97),('15529','2013-07-27','13:25:00',2),('15529','2013-07-27','13:30:00',2.05),('15529','2013-07-27','13:35:00',2.08),('15529','2013-07-27','13:40:00',2.07),('15529','2013-07-27','13:45:00',2.08),('15529','2013-07-27','13:50:00',2.13),('15529','2013-07-27','13:55:00',2.04),('15529','2013-07-27','14:00:00',2.08),('15529','2013-07-27','14:05:00',2.06),('15529','2013-07-27','14:10:00',2.07),('15529','2013-07-27','14:15:00',2.02),('15529','2013-07-27','14:20:00',2),('15529','2013-07-27','14:25:00',2.02),('15529','2013-07-27','14:30:00',1.99),('15529','2013-07-27','14:35:00',1.98),('15529','2013-07-27','14:40:00',1.96),('15529','2013-07-27','14:45:00',1.94),('15529','2013-07-27','14:50:00',1.91),('15529','2013-07-27','14:55:00',1.88),('15529','2013-07-27','15:00:00',1.91),('15529','2013-07-27','15:05:00',1.86),('15529','2013-07-27','15:10:00',1.81),('15529','2013-07-27','15:15:00',1.8),('15529','2013-07-27','15:20:00',1.81),('15529','2013-07-27','15:25:00',1.75),('15529','2013-07-27','15:30:00',1.76),('15529','2013-07-27','15:35:00',1.73),('15529','2013-07-27','15:40:00',1.69),('15529','2013-07-27','15:45:00',1.68),('15529','2013-07-27','15:50:00',1.66),('15529','2013-07-27','15:55:00',1.63),('15529','2013-07-27','16:00:00',1.62),('15529','2013-07-27','16:05:00',1.6),('15529','2013-07-27','16:10:00',1.59),('15529','2013-07-27','16:15:00',1.54),('15529','2013-07-27','16:20:00',1.51),('15529','2013-07-27','16:25:00',1.49),('15529','2013-07-27','16:30:00',1.45),('15529','2013-07-27','16:35:00',1.4),('15529','2013-07-27','16:40:00',1.36),('15529','2013-07-27','16:45:00',1.33),('15529','2013-07-27','16:50:00',1.3),('15529','2013-07-27','16:55:00',1.26),('15529','2013-07-27','17:00:00',1.22),('15529','2013-07-27','17:05:00',1.18),('15529','2013-07-27','17:10:00',1.14),('15529','2013-07-27','17:15:00',1.1),('15529','2013-07-27','17:20:00',1.05),('15529','2013-07-27','17:25:00',1.01),('15529','2013-07-26','09:05:00',1.03),('15529','2013-07-26','09:10:00',1.08),('15529','2013-07-26','09:15:00',1.12),('15529','2013-07-26','09:20:00',1.17),('15529','2013-07-26','09:25:00',1.21),('15529','2013-07-26','09:30:00',1.24),('15529','2013-07-26','09:35:00',1.28),('15529','2013-07-26','09:40:00',1.31),('15529','2013-07-26','09:45:00',1.34),('15529','2013-07-26','09:50:00',1.39),('15529','2013-07-26','09:55:00',1.43),('15529','2013-07-26','10:00:00',1.46),('15529','2013-07-26','10:05:00',1.5),('15529','2013-07-26','10:10:00',1.53),('15529','2013-07-26','10:15:00',1.58),('15529','2013-07-26','10:20:00',1.59),('15529','2013-07-26','10:25:00',1.64),('15529','2013-07-26','10:30:00',1.66),('15529','2013-07-26','10:35:00',1.64),('15529','2013-07-26','10:40:00',1.72),('15529','2013-07-26','10:45:00',1.76),('15529','2013-07-26','10:50:00',1.74),('15529','2013-07-26','10:55:00',1.78),('15529','2013-07-26','11:00:00',1.8),('15529','2013-07-26','11:05:00',1.8),('15529','2013-07-26','11:10:00',1.8),('15529','2013-07-26','11:15:00',1.83),('15529','2013-07-26','11:20:00',1.89),('15529','2013-07-26','11:25:00',1.84),('15529','2013-07-26','11:30:00',1.89),('15529','2013-07-26','11:35:00',1.9),('15529','2013-07-26','11:40:00',1.9),('15529','2013-07-26','11:45:00',1.93),('15529','2013-07-26','11:50:00',1.96),('15529','2013-07-26','11:55:00',1.9),('15529','2013-07-26','12:00:00',1.85),('15529','2013-07-26','12:05:00',1.94),('15529','2013-07-26','12:10:00',1.98),('15529','2013-07-26','12:15:00',1.97),('15529','2013-07-26','12:20:00',2.02),('15529','2013-07-26','12:25:00',2),('15529','2013-07-26','12:30:00',1.99),('15529','2013-07-26','12:35:00',2.01),('15529','2013-07-26','12:40:00',2.05),('15529','2013-07-26','12:45:00',2.07),('15529','2013-07-26','12:50:00',1.94),('15529','2013-07-26','12:55:00',1.97),('15529','2013-07-26','13:00:00',2.12),('15529','2013-07-26','13:05:00',2.15),('15529','2013-07-26','13:10:00',1.98),('15529','2013-07-26','13:15:00',2),('15529','2013-07-26','13:20:00',2.07),('15529','2013-07-26','13:25:00',2.1),('15529','2013-07-26','13:30:00',2),('15529','2013-07-26','13:35:00',2.08),('15529','2013-07-26','13:40:00',2.04),('15529','2013-07-26','13:45:00',2.04),('15529','2013-07-26','13:50:00',2.07),('15529','2013-07-26','13:55:00',2.04),('15529','2013-07-26','14:00:00',2.04),('15529','2013-07-26','14:05:00',2.01),('15529','2013-07-26','14:10:00',2.03),('15529','2013-07-26','14:15:00',2.02),('15529','2013-07-26','14:20:00',2.01),('15529','2013-07-26','14:25:00',1.98),('15529','2013-07-26','14:30:00',1.96),('15529','2013-07-26','14:35:00',1.96),('15529','2013-07-26','14:40:00',1.99),('15529','2013-07-26','14:45:00',1.95),('15529','2013-07-26','14:50:00',1.91),('15529','2013-07-26','14:55:00',1.9),('15529','2013-07-26','15:00:00',1.87),('15529','2013-07-26','15:05:00',1.91),('15529','2013-07-26','15:10:00',1.88),('15529','2013-07-26','15:15:00',1.85),('15529','2013-07-26','15:20:00',1.83),('15529','2013-07-26','15:25:00',1.8),('15529','2013-07-26','15:30:00',1.78),('15529','2013-07-26','15:35:00',1.77),('15529','2013-07-26','15:40:00',1.75),('15529','2013-07-26','15:45:00',1.72),('15529','2013-07-26','15:50:00',1.7),('15529','2013-07-26','15:55:00',1.66),('15529','2013-07-26','16:00:00',1.63),('15529','2013-07-26','16:05:00',1.59),('15529','2013-07-26','16:10:00',1.56),('15529','2013-07-26','16:15:00',1.55),('15529','2013-07-26','16:20:00',1.51),('15529','2013-07-26','16:25:00',1.48),('15529','2013-07-26','16:30:00',1.45),('15529','2013-07-26','16:35:00',1.42),('15529','2013-07-26','16:40:00',1.37),('15529','2013-07-26','16:45:00',1.34),('15529','2013-07-26','16:50:00',1.3),('15529','2013-07-26','16:55:00',1.25),('15529','2013-07-26','17:00:00',1.22),('15529','2013-07-26','17:05:00',1.18),('15529','2013-07-26','17:10:00',1.14),('15529','2013-07-26','17:15:00',1.09),('15529','2013-07-26','17:20:00',1.06),('15529','2013-07-26','17:25:00',1.01),('15529','2013-07-25','09:10:00',1.04),('15529','2013-07-25','09:15:00',1.1),('15529','2013-07-25','09:20:00',1.14),('15529','2013-07-25','09:25:00',1.17),('15529','2013-07-25','09:30:00',1.19),('15529','2013-07-25','09:35:00',1.23),('15529','2013-07-25','09:40:00',1.25),('15529','2013-07-25','09:45:00',1.34),('15529','2013-07-25','09:50:00',1.38),('15529','2013-07-25','09:55:00',1.42),('15529','2013-07-25','10:00:00',1.42),('15529','2013-07-25','10:05:00',1.5),('15529','2013-07-25','10:10:00',1.52),('15529','2013-07-25','10:15:00',1.49),('15529','2013-07-25','10:20:00',1.56),('15529','2013-07-25','10:25:00',1.61),('15529','2013-07-25','10:30:00',1.61),('15529','2013-07-25','10:35:00',1.65),('15529','2013-07-25','10:40:00',1.67),('15529','2013-07-25','10:45:00',1.74),('15529','2013-07-25','10:50:00',1.73),('15529','2013-07-25','10:55:00',1.74),('15529','2013-07-25','11:00:00',1.8),('15529','2013-07-25','11:05:00',1.75),('15529','2013-07-25','11:10:00',1.81),('15529','2013-07-25','11:15:00',1.86),('15529','2013-07-25','11:20:00',1.87),('15529','2013-07-25','11:25:00',1.9),('15529','2013-07-25','11:30:00',1.93),('15529','2013-07-25','11:35:00',1.91),('15529','2013-07-25','11:40:00',1.82),('15529','2013-07-25','11:45:00',1.91),('15529','2013-07-25','11:50:00',1.99),('15529','2013-07-25','11:55:00',2.05),('15529','2013-07-25','12:00:00',2.08),('15529','2013-07-25','12:05:00',1.57),('15529','2013-07-25','12:10:00',1.67),('15529','2013-07-25','12:15:00',2.09),('15529','2013-07-25','12:20:00',2.12),('15529','2013-07-25','12:25:00',2.12),('15529','2013-07-25','12:30:00',2.15),('15529','2013-07-25','12:35:00',1.56),('15529','2013-07-25','12:40:00',2.2),('15529','2013-07-25','12:45:00',2.21),('15529','2013-07-25','12:50:00',2),('15529','2013-07-25','12:55:00',1.91),('15529','2013-07-25','13:00:00',1.7),('15529','2013-07-25','13:05:00',1.44),('15529','2013-07-25','13:15:00',2.21),('15529','2013-07-25','13:20:00',1.88),('15529','2013-07-25','13:25:00',1.05),('15529','2013-07-25','13:35:00',2.17),('15529','2013-07-25','13:40:00',2.18),('15529','2013-07-25','13:45:00',2.19),('15529','2013-07-25','13:50:00',2.13),('15529','2013-07-25','13:55:00',1.99),('15529','2013-07-25','14:00:00',2.06),('15529','2013-07-25','14:05:00',2.08),('15529','2013-07-25','14:10:00',2.07),('15529','2013-07-25','14:15:00',2.11),('15529','2013-07-25','14:20:00',2.02),('15529','2013-07-25','14:25:00',2.03),('15529','2013-07-25','14:30:00',1.99),('15529','2013-07-25','14:35:00',2.02),('15529','2013-07-25','14:40:00',2.01),('15529','2013-07-25','14:45:00',1.97),('15529','2013-07-25','14:50:00',1.93),('15529','2013-07-25','14:55:00',1.88),('15529','2013-07-25','15:00:00',1.92),('15529','2013-07-25','15:05:00',1.93),('15529','2013-07-25','15:10:00',1.87),('15529','2013-07-25','15:15:00',1.89),('15529','2013-07-25','15:20:00',1.86),('15529','2013-07-25','15:25:00',1.85),('15529','2013-07-25','15:30:00',1.8),('15529','2013-07-25','15:35:00',1.74),('15529','2013-07-25','15:40:00',1.73),('15529','2013-07-25','15:45:00',1.72),('15529','2013-07-25','15:50:00',1.69),('15529','2013-07-25','15:55:00',1.66),('15529','2013-07-25','16:00:00',1.62),('15529','2013-07-25','16:05:00',1.58),('15529','2013-07-25','16:10:00',1.58),('15529','2013-07-25','16:15:00',1.54),('15529','2013-07-25','16:20:00',1.51),('15529','2013-07-25','16:25:00',1.49),('15529','2013-07-25','16:30:00',1.47),('15529','2013-07-25','16:35:00',1.42),('15529','2013-07-25','16:40:00',1.38),('15529','2013-07-25','16:45:00',1.35),('15529','2013-07-25','16:50:00',1.3),('15529','2013-07-25','16:55:00',1.25),('15529','2013-07-25','17:00:00',1.22),('15529','2013-07-25','17:05:00',1.19),('15529','2013-07-25','17:10:00',1.14),('15529','2013-07-25','17:15:00',1.1),('15529','2013-07-25','17:20:00',1.05),('15529','2013-07-25','17:25:00',1),('15529','2013-07-24','09:00:00',1.02),('15529','2013-07-24','09:05:00',1.09),('15529','2013-07-24','09:10:00',1.16),('15529','2013-07-24','09:15:00',1),('15529','2013-07-24','09:45:00',1.4),('15529','2013-07-24','09:50:00',1.35),('15529','2013-07-24','09:55:00',1.39),('15529','2013-07-24','10:00:00',1.43),('15529','2013-07-24','10:05:00',1.53),('15529','2013-07-24','10:10:00',1.57),('15529','2013-07-24','10:15:00',1.66),('15529','2013-07-24','10:20:00',1.61),('15529','2013-07-24','10:25:00',1.66),('15529','2013-07-24','10:30:00',1.32),('15529','2013-07-24','10:35:00',1.13),('15529','2013-07-24','10:40:00',1.39),('15529','2013-07-24','10:45:00',1.8),('15529','2013-07-24','10:50:00',1.8),('15529','2013-07-24','10:55:00',1.83),('15529','2013-07-24','11:00:00',1.82),('15529','2013-07-24','11:05:00',1.81),('15529','2013-07-24','11:10:00',1.89),('15529','2013-07-24','11:15:00',1.84),('15529','2013-07-24','11:20:00',1.56),('15529','2013-07-24','11:25:00',1.86),('15529','2013-07-24','11:30:00',1.98),('15529','2013-07-24','11:35:00',1.95),('15529','2013-07-24','11:40:00',2.04),('15529','2013-07-24','11:45:00',2.14),('15529','2013-07-24','11:55:00',1.57),('15529','2013-07-24','12:00:00',1.24),('15529','2013-07-24','12:05:00',2.13),('15529','2013-07-24','12:10:00',2.21),('15529','2013-07-24','12:15:00',2.24),('15529','2013-07-24','12:20:00',2.19),('15529','2013-07-24','12:25:00',1.51),('15529','2013-07-24','12:35:00',1.49),('15529','2013-07-24','12:40:00',2.25),('15529','2013-07-24','12:45:00',2.09),('15529','2013-07-24','12:50:00',2.16),('15529','2013-07-24','12:55:00',2.14),('15529','2013-07-24','13:00:00',2.13),('15529','2013-07-24','13:05:00',2.18),('15529','2013-07-24','13:10:00',2.09),('15529','2013-07-24','13:15:00',2.19),('15529','2013-07-24','13:20:00',2.17),('15529','2013-07-24','13:25:00',2.19),('15529','2013-07-24','13:30:00',2.15),('15529','2013-07-24','13:35:00',2.14),('15529','2013-07-24','13:40:00',2.11),('15529','2013-07-24','13:45:00',2.13),('15529','2013-07-24','13:50:00',2.22),('15529','2013-07-24','13:55:00',2.17),('15529','2013-07-24','14:00:00',2.13),('15529','2013-07-24','14:05:00',2.13),('15529','2013-07-24','14:10:00',2.17),('15529','2013-07-24','14:15:00',2.15),('15529','2013-07-24','14:20:00',2.11),('15529','2013-07-24','14:25:00',2.1),('15529','2013-07-24','14:30:00',2.09),('15529','2013-07-24','14:35:00',2.06),('15529','2013-07-24','14:40:00',2.05),('15529','2013-07-24','14:45:00',2.04),('15529','2013-07-24','14:50:00',2.02),('15529','2013-07-24','14:55:00',2.02),('15529','2013-07-24','15:00:00',2),('15529','2013-07-24','15:05:00',1.96),('15529','2013-07-24','15:10:00',1.97),('15529','2013-07-24','15:15:00',1.92),('15529','2013-07-24','15:20:00',1.89),('15529','2013-07-24','15:25:00',1.9),('15529','2013-07-24','15:30:00',1.88),('15529','2013-07-24','15:35:00',1.83),('15529','2013-07-24','15:40:00',1.8),('15529','2013-07-24','15:45:00',1.8),('15529','2013-07-24','15:50:00',1.78),('15529','2013-07-24','15:55:00',1.73),('15529','2013-07-24','16:00:00',1.68),('15529','2013-07-24','16:05:00',1.66),('15529','2013-07-24','16:10:00',1.62),('15529','2013-07-24','16:15:00',1.59),('15529','2013-07-24','16:20:00',1.56),('15529','2013-07-24','16:25:00',1.53),('15529','2013-07-24','16:30:00',1.51),('15529','2013-07-24','16:35:00',1.47),('15529','2013-07-24','16:40:00',1.43),('15529','2013-07-24','16:45:00',1.4),('15529','2013-07-24','16:50:00',1.36),('15529','2013-07-24','16:55:00',1.33),('15529','2013-07-24','17:00:00',1.27),('15529','2013-07-24','17:05:00',1.23),('15529','2013-07-24','17:10:00',1.18),('15529','2013-07-24','17:15:00',1.15),('15529','2013-07-24','17:20:00',1.11),('15529','2013-07-24','17:25:00',1.07),('15529','2013-07-24','17:30:00',1.01),('15529','2013-07-23','08:55:00',1.01),('15529','2013-07-23','09:00:00',1.09),('15529','2013-07-23','09:05:00',1.18),('15529','2013-07-23','09:30:00',1.11),('15529','2013-07-23','10:05:00',1.7),('15529','2013-07-23','10:10:00',1.72),('15529','2013-07-23','10:15:00',1.4),('15529','2013-07-23','10:20:00',1.36),('15529','2013-07-23','10:25:00',1.19),('15529','2013-07-23','10:45:00',1.32),('15529','2013-07-23','10:50:00',1.91),('15529','2013-07-23','10:55:00',1.87),('15529','2013-07-23','11:00:00',1.88),('15529','2013-07-23','11:05:00',1.86),('15529','2013-07-23','11:10:00',1.93),('15529','2013-07-23','11:15:00',1.93),('15529','2013-07-23','11:20:00',1.93),('15529','2013-07-23','11:25:00',1.96),('15529','2013-07-23','11:35:00',1.75),('15529','2013-07-23','11:40:00',2.11),('15529','2013-07-23','11:45:00',2.08),('15529','2013-07-23','11:50:00',2.08),('15529','2013-07-23','11:55:00',1.9),('15529','2013-07-23','12:00:00',1.58),('15529','2013-07-23','12:05:00',1.46),('15529','2013-07-23','12:10:00',1.43),('15529','2013-07-23','12:15:00',1.61),('15529','2013-07-23','12:20:00',2.19),('15529','2013-07-23','12:25:00',2.16),('15529','2013-07-23','12:30:00',2.18),('15529','2013-07-23','12:35:00',2.18),('15529','2013-07-23','12:40:00',2.18),('15529','2013-07-23','12:45:00',2.22),('15529','2013-07-23','12:50:00',2.15),('15529','2013-07-23','12:55:00',2.17),('15529','2013-07-23','13:00:00',2.15),('15529','2013-07-23','13:05:00',2.16),('15529','2013-07-23','13:10:00',2.2),('15529','2013-07-23','13:15:00',1.96),('15529','2013-07-23','13:20:00',2.24),('15529','2013-07-23','13:25:00',2.26),('15529','2013-07-23','13:30:00',2.18),('15529','2013-07-23','13:35:00',2.19),('15529','2013-07-23','13:40:00',2.18),('15529','2013-07-23','13:45:00',2.21),('15529','2013-07-23','13:50:00',2.22),('15529','2013-07-23','13:55:00',2.1),('15529','2013-07-23','14:00:00',2.24),('15529','2013-07-23','14:05:00',2.05),('15529','2013-07-23','14:10:00',2.16),('15529','2013-07-23','14:15:00',2.06),('15529','2013-07-23','14:20:00',1.85),('15529','2013-07-23','14:25:00',2.1),('15529','2013-07-23','14:30:00',2.18),('15529','2013-07-23','14:35:00',2.12),('15529','2013-07-23','14:40:00',2.07),('15529','2013-07-23','14:45:00',2.08),('15529','2013-07-23','14:50:00',2.06),('15529','2013-07-23','14:55:00',2.06),('15529','2013-07-23','15:00:00',2),('15529','2013-07-23','15:05:00',1.97),('15529','2013-07-23','15:10:00',1.96),('15529','2013-07-23','15:15:00',1.95),('15529','2013-07-23','15:20:00',1.95),('15529','2013-07-23','15:25:00',1.9),('15529','2013-07-23','15:30:00',1.81),('15529','2013-07-23','15:35:00',1.83),('15529','2013-07-23','15:40:00',1.85),('15529','2013-07-23','15:45:00',1.74),('15529','2013-07-23','15:50:00',1.7),('15529','2013-07-23','15:55:00',1.69),('15529','2013-07-23','16:00:00',1.71),('15529','2013-07-23','16:05:00',1.67),('15529','2013-07-23','16:10:00',1.55),('15529','2013-07-23','16:15:00',1.65),('15529','2013-07-23','16:20:00',1.62),('15529','2013-07-23','16:25:00',1.59),('15529','2013-07-23','16:30:00',1.52),('15529','2013-07-23','16:35:00',1.51),('15529','2013-07-23','16:40:00',1.47),('15529','2013-07-23','16:45:00',1.42),('15529','2013-07-23','16:50:00',1.44),('15529','2013-07-23','16:55:00',1.38),('15529','2013-07-23','17:00:00',1.37),('15529','2013-07-23','17:05:00',1.31),('15529','2013-07-23','17:10:00',1.24),('15529','2013-07-23','17:15:00',1.18),('15529','2013-07-23','17:20:00',1.1),('15529','2013-07-23','17:25:00',1.07),('15529','2013-07-23','17:30:00',1.01),('15529','2013-07-22','08:55:00',1.01),('15529','2013-07-22','09:00:00',1.05),('15529','2013-07-22','09:05:00',1.08),('15529','2013-07-22','09:10:00',1.11),('15529','2013-07-22','09:15:00',1.16),('15529','2013-07-22','09:20:00',1.19),('15529','2013-07-22','09:25:00',1.23),('15529','2013-07-22','09:30:00',1.26),('15529','2013-07-22','09:35:00',1.3),('15529','2013-07-22','09:40:00',1.34),('15529','2013-07-22','09:45:00',1.37),('15529','2013-07-22','09:50:00',1.4),('15529','2013-07-22','09:55:00',1.43),('15529','2013-07-22','10:00:00',1.45),('15529','2013-07-22','10:05:00',1.49),('15529','2013-07-22','10:10:00',1.52),('15529','2013-07-22','10:15:00',1.56),('15529','2013-07-22','10:20:00',1.6),('15529','2013-07-22','10:25:00',1.64),('15529','2013-07-22','10:30:00',1.68),('15529','2013-07-22','10:35:00',1.7),('15529','2013-07-22','10:40:00',1.72),('15529','2013-07-22','10:45:00',1.75),('15529','2013-07-22','10:50:00',1.78),('15529','2013-07-22','10:55:00',1.79),('15529','2013-07-22','11:00:00',1.83),('15529','2013-07-22','11:05:00',1.9),('15529','2013-07-22','11:10:00',1.94),('15529','2013-07-22','11:15:00',1.96),('15529','2013-07-22','11:20:00',1.99),('15529','2013-07-22','11:25:00',2.02),('15529','2013-07-22','11:30:00',2.06),('15529','2013-07-22','11:35:00',2.09),('15529','2013-07-22','11:40:00',2.1),('15529','2013-07-22','11:45:00',2.06),('15529','2013-07-22','11:50:00',2.05),('15529','2013-07-22','11:55:00',2.16),('15529','2013-07-22','12:00:00',1.97),('15529','2013-07-22','12:05:00',1.37),('15529','2013-07-22','12:10:00',1.14),('15529','2013-07-22','12:15:00',1.4),('15529','2013-07-22','13:25:00',2.01),('15529','2013-07-22','13:30:00',1.65),('15529','2013-07-22','14:05:00',1.22),('15529','2013-07-22','14:30:00',1.56),('15529','2013-07-22','14:35:00',1.69),('15529','2013-07-22','14:40:00',1.19),('15529','2013-07-22','14:45:00',2.19),('15529','2013-07-22','14:50:00',2.25),('15529','2013-07-22','14:55:00',2.15),('15529','2013-07-22','15:00:00',2.1),('15529','2013-07-22','15:05:00',2.02),('15529','2013-07-22','15:10:00',1.98),('15529','2013-07-22','15:15:00',1.93),('15529','2013-07-22','15:20:00',1.91),('15529','2013-07-22','15:25:00',1.89),('15529','2013-07-22','15:30:00',1.87),('15529','2013-07-22','15:35:00',1.82),('15529','2013-07-22','15:40:00',1.82),('15529','2013-07-22','15:45:00',1.78),('15529','2013-07-22','15:50:00',1.74),('15529','2013-07-22','15:55:00',1.67),('15529','2013-07-22','16:00:00',1.69),('15529','2013-07-22','16:05:00',1.66),('15529','2013-07-22','16:10:00',1.64),('15529','2013-07-22','16:15:00',1.6),('15529','2013-07-22','16:20:00',1.56),('15529','2013-07-22','16:25:00',1.52),('15529','2013-07-22','16:30:00',1.49),('15529','2013-07-22','16:35:00',1.47),('15529','2013-07-22','16:40:00',1.42),('15529','2013-07-22','16:45:00',1.37),('15529','2013-07-22','16:50:00',1.33),('15529','2013-07-22','16:55:00',1.29),('15529','2013-07-22','17:00:00',1.25),('15529','2013-07-22','17:05:00',1.21),('15529','2013-07-22','17:10:00',1.18),('15529','2013-07-22','17:15:00',1.13),('15529','2013-07-22','17:20:00',1.09),('15529','2013-07-22','17:25:00',1.05),('15529','2013-07-22','17:30:00',1.01),('15529','2013-07-21','09:00:00',1.05),('15529','2013-07-21','09:05:00',1.09),('15529','2013-07-21','09:10:00',1.12),('15529','2013-07-21','09:15:00',1.16),('15529','2013-07-21','09:20:00',1.2),('15529','2013-07-21','09:25:00',1.24),('15529','2013-07-21','09:30:00',1.28),('15529','2013-07-21','09:35:00',1.31),('15529','2013-07-21','09:40:00',1.34),('15529','2013-07-21','09:45:00',1.37),('15529','2013-07-21','09:50:00',1.42),('15529','2013-07-21','09:55:00',1.45),('15529','2013-07-21','10:00:00',1.49),('15529','2013-07-21','10:05:00',1.51),('15529','2013-07-21','10:10:00',1.55),('15529','2013-07-21','10:15:00',1.59),('15529','2013-07-21','10:20:00',1.62),('15529','2013-07-21','10:25:00',1.65),('15529','2013-07-21','10:30:00',1.68),('15529','2013-07-21','10:35:00',1.72),('15529','2013-07-21','10:40:00',1.74),('15529','2013-07-21','10:45:00',1.75),('15529','2013-07-21','10:50:00',1.8),('15529','2013-07-21','10:55:00',1.85),('15529','2013-07-21','11:00:00',1.86),('15529','2013-07-21','11:05:00',1.9),('15529','2013-07-21','11:10:00',1.91),('15529','2013-07-21','11:15:00',1.9),('15529','2013-07-21','11:20:00',1.94),('15529','2013-07-21','11:25:00',1.96),('15529','2013-07-21','11:30:00',1.96),('15529','2013-07-21','11:35:00',1.96),('15529','2013-07-21','11:40:00',2.01),('15529','2013-07-21','11:45:00',2.02),('15529','2013-07-21','11:50:00',2.01),('15529','2013-07-21','11:55:00',2.04),('15529','2013-07-21','12:00:00',2.03),('15529','2013-07-21','12:05:00',2.06),('15529','2013-07-21','12:10:00',2.09),('15529','2013-07-21','12:15:00',2.07),('15529','2013-07-21','12:20:00',2.08),('15529','2013-07-21','12:25:00',2.03),('15529','2013-07-21','12:30:00',2.09),('15529','2013-07-21','12:35:00',2.1),('15529','2013-07-21','12:40:00',2.1),('15529','2013-07-21','12:45:00',2.07),('15529','2013-07-21','12:50:00',2.13),('15529','2013-07-21','12:55:00',2.14),('15529','2013-07-21','13:00:00',2.15),('15529','2013-07-21','13:05:00',2.13),('15529','2013-07-21','13:10:00',2.12),('15529','2013-07-21','13:15:00',2.11),('15529','2013-07-21','13:20:00',2.16),('15529','2013-07-21','13:25:00',2.15),('15529','2013-07-21','13:30:00',2.14),('15529','2013-07-21','13:35:00',2.14),('15529','2013-07-21','13:40:00',2.13),('15529','2013-07-21','13:45:00',2.07),('15529','2013-07-21','13:50:00',2.09),('15529','2013-07-21','13:55:00',2.09),('15529','2013-07-21','14:00:00',2.09),('15529','2013-07-21','14:05:00',2.08),('15529','2013-07-21','14:10:00',2.06),('15529','2013-07-21','14:15:00',2.08),('15529','2013-07-21','14:20:00',2.07),('15529','2013-07-21','14:25:00',2.02),('15529','2013-07-21','14:30:00',2.04),('15529','2013-07-21','14:35:00',1.98),('15529','2013-07-21','14:40:00',1.98),('15529','2013-07-21','14:45:00',1.98),('15529','2013-07-21','14:50:00',1.99),('15529','2013-07-21','14:55:00',1.99),('15529','2013-07-21','15:00:00',1.91),('15529','2013-07-21','15:05:00',1.92),('15529','2013-07-21','15:10:00',1.91),('15529','2013-07-21','15:15:00',1.91),('15529','2013-07-21','15:20:00',1.91),('15529','2013-07-21','15:25:00',1.49),('15529','2013-07-21','15:30:00',1.88),('15529','2013-07-21','15:35:00',1.3),('15529','2013-07-21','16:00:00',1.61),('15529','2013-07-21','16:05:00',1.78),('15529','2013-07-21','16:10:00',1.79),('15529','2013-07-21','16:15:00',1.67),('15529','2013-07-21','16:20:00',1.59),('15529','2013-07-21','16:25:00',1.52),('15529','2013-07-21','16:30:00',1.47),('15529','2013-07-21','16:35:00',1.44),('15529','2013-07-21','16:40:00',1.38),('15529','2013-07-21','16:45:00',1.3),('15529','2013-07-21','16:50:00',1.28),('15529','2013-07-21','16:55:00',1.26),('15529','2013-07-21','17:00:00',1.23),('15529','2013-07-21','17:05:00',1.17),('15529','2013-07-21','17:10:00',1.15),('15529','2013-07-21','17:15:00',1.1),('15529','2013-07-21','17:20:00',1.08),('15529','2013-07-21','17:25:00',1.05),('15529','2013-07-20','09:00:00',1.01),('15529','2013-07-20','09:05:00',1.05),('15529','2013-07-20','09:10:00',1.1),('15529','2013-07-20','09:15:00',1.14),('15529','2013-07-20','09:20:00',1.17),('15529','2013-07-20','09:25:00',1.21),('15529','2013-07-20','09:30:00',1.24),('15529','2013-07-20','09:35:00',1.28),('15529','2013-07-20','09:40:00',1.32),('15529','2013-07-20','09:45:00',1.35),('15529','2013-07-20','09:50:00',1.38),('15529','2013-07-20','09:55:00',1.43),('15529','2013-07-20','10:00:00',1.46),('15529','2013-07-20','10:05:00',1.5),('15529','2013-07-20','10:10:00',1.51),('15529','2013-07-20','10:15:00',1.55),('15529','2013-07-20','10:20:00',1.58),('15529','2013-07-20','10:25:00',1.62),('15529','2013-07-20','10:30:00',1.64),('15529','2013-07-20','10:35:00',1.67),('15529','2013-07-20','10:40:00',1.69),('15529','2013-07-20','10:45:00',1.72),('15529','2013-07-20','10:50:00',1.76),('15529','2013-07-20','10:55:00',1.76),('15529','2013-07-20','11:00:00',1.79),('15529','2013-07-20','11:05:00',1.84),('15529','2013-07-20','11:10:00',1.86),('15529','2013-07-20','11:15:00',1.87),('15529','2013-07-20','11:20:00',1.9),('15529','2013-07-20','11:25:00',1.91),('15529','2013-07-20','11:30:00',1.92),('15529','2013-07-20','11:35:00',1.95),('15529','2013-07-20','11:40:00',1.95),('15529','2013-07-20','11:45:00',1.99),('15529','2013-07-20','11:50:00',1.98),('15529','2013-07-20','11:55:00',2),('15529','2013-07-20','12:00:00',1.97),('15529','2013-07-20','12:05:00',1.92),('15529','2013-07-20','12:10:00',2),('15529','2013-07-20','12:15:00',1.92),('15529','2013-07-20','12:20:00',1.81),('15529','2013-07-20','12:25:00',1.74),('15529','2013-07-20','12:30:00',2),('15529','2013-07-20','12:35:00',1.13),('15529','2013-07-20','12:40:00',1.11),('15529','2013-07-20','12:45:00',1.3),('15529','2013-07-20','12:50:00',1.24),('15529','2013-07-20','12:55:00',1.31),('15529','2013-07-20','13:05:00',1.72),('15529','2013-07-20','13:10:00',1.13),('15529','2013-07-20','13:20:00',2.17),('15529','2013-07-20','13:25:00',2.32),('15529','2013-07-20','13:30:00',2.31),('15529','2013-07-20','13:35:00',2.32),('15529','2013-07-20','13:40:00',1.95),('15529','2013-07-20','13:45:00',2.08),('15529','2013-07-20','13:50:00',1.96),('15529','2013-07-20','14:25:00',1.51),('15529','2014-04-06','11:35:00',1.01),('15529','2014-04-06','12:05:00',1.08),('15529','2014-04-06','12:10:00',1.28),('15529','2014-04-06','12:15:00',1.55),('15529','2014-04-06','12:20:00',1.76),('15529','2014-04-06','12:25:00',1.74),('15529','2014-04-06','12:30:00',1.34),('15529','2014-04-06','12:35:00',1.19),('15529','2014-04-06','12:40:00',1.91),('15529','2014-04-06','12:45:00',2.32),('15529','2014-04-06','12:50:00',2.25),('15529','2014-04-06','12:55:00',2.21),('15529','2014-04-06','13:00:00',2.21),('15529','2014-04-06','13:05:00',2.25),('15529','2014-04-06','13:10:00',2.22),('15529','2014-04-06','13:15:00',2.23),('15529','2014-04-06','13:20:00',2.22),('15529','2014-04-06','13:25:00',2.23),('15529','2014-04-06','13:30:00',2.24),('15529','2014-04-06','13:35:00',2.18),('15529','2014-04-06','13:40:00',2.21),('15529','2014-04-06','13:45:00',2.22),('15529','2014-04-06','13:50:00',2.2),('15529','2014-04-06','13:55:00',2.16),('15529','2014-04-06','14:00:00',2.14),('15529','2014-04-06','14:05:00',2.13),('15529','2014-04-06','14:10:00',2.16),('15529','2014-04-06','14:15:00',2.13),('15529','2014-04-06','14:20:00',2.11),('15529','2014-04-06','14:25:00',2.11),('15529','2014-04-06','14:30:00',2.09),('15529','2014-04-06','14:35:00',2.06),('15529','2014-04-06','14:40:00',2.03),('15529','2014-04-06','14:45:00',2.02),('15529','2014-04-06','14:50:00',2.02),('15529','2014-04-06','14:55:00',2.03),('15529','2014-04-06','15:00:00',2.02),('15529','2014-04-06','15:05:00',1.95),('15529','2014-04-06','15:10:00',1.98),('15529','2014-04-06','15:15:00',1.96),('15529','2014-04-06','15:20:00',1.94),('15529','2014-04-06','15:25:00',1.91),('15529','2014-04-06','15:30:00',1.86),('15529','2014-04-06','15:35:00',1.84),('15529','2014-04-06','15:40:00',1.81),('15529','2014-04-06','15:45:00',1.79),('15529','2014-04-06','15:50:00',1.81),('15529','2014-04-06','15:55:00',1.84),('15529','2014-04-06','16:00:00',1.87),('15529','2014-04-06','16:05:00',1.79),('15529','2014-04-06','16:10:00',1.57),('15529','2014-04-06','16:15:00',1.57),('15529','2014-04-06','16:20:00',1.49),('15529','2014-04-06','16:25:00',1.41),('15529','2014-04-06','16:30:00',1.29),('15529','2014-04-06','16:35:00',1.01),('15529','2014-04-06','16:55:00',1.28),('15529','2014-04-06','17:00:00',1.25),('15529','2014-04-06','17:05:00',1.23),('15529','2014-04-06','17:10:00',1.19),('15529','2014-04-06','17:15:00',1.11),('15529','2013-07-19','08:55:00',1.06),('15529','2013-07-19','09:00:00',1.08),('15529','2013-07-19','09:05:00',1.16),('15529','2013-07-19','09:10:00',1.22),('15529','2013-07-19','09:15:00',1.26),('15529','2013-07-19','09:20:00',1.26),('15529','2013-07-19','09:25:00',1.23),('15529','2013-07-19','09:30:00',1.18),('15529','2013-07-19','09:35:00',1.25),('15529','2013-07-19','09:40:00',1.27),('15529','2013-07-19','09:45:00',1.43),('15529','2013-07-19','09:50:00',1.33),('15529','2013-07-19','09:55:00',1.34),('15529','2013-07-19','10:00:00',1.48),('15529','2013-07-19','10:05:00',1.54),('15529','2013-07-19','10:10:00',1.55),('15529','2013-07-19','10:15:00',1.58),('15529','2013-07-19','10:20:00',1.61),('15529','2013-07-19','10:25:00',1.63),('15529','2013-07-19','10:30:00',1.65),('15529','2013-07-19','10:35:00',1.68),('15529','2013-07-19','10:40:00',1.72),('15529','2013-07-19','10:45:00',1.75),('15529','2013-07-19','10:50:00',1.76),('15529','2013-07-19','10:55:00',1.79),('15529','2013-07-19','11:00:00',1.83),('15529','2013-07-19','11:05:00',1.86),('15529','2013-07-19','11:10:00',1.86),('15529','2013-07-19','11:15:00',1.9),('15529','2013-07-19','11:20:00',1.93),('15529','2013-07-19','11:25:00',1.94),('15529','2013-07-19','11:30:00',1.98),('15529','2013-07-19','11:35:00',1.98),('15529','2013-07-19','11:40:00',2.02),('15529','2013-07-19','11:45:00',2.01),('15529','2013-07-19','11:50:00',2.02),('15529','2013-07-19','11:55:00',2.08),('15529','2013-07-19','12:00:00',1.63),('15529','2013-07-19','12:05:00',1.31),('15529','2013-07-19','12:15:00',2.18),('15529','2013-07-19','12:20:00',2.15),('15529','2013-07-19','12:25:00',1.73),('15529','2013-07-19','12:30:00',1.8),('15529','2013-07-19','12:45:00',2.21),('15529','2013-07-19','12:50:00',2.05),('15529','2013-07-19','13:00:00',1.12),('15529','2013-07-19','13:05:00',2.11),('15529','2013-07-19','13:10:00',2.35),('15529','2013-07-19','13:15:00',1.74),('15529','2013-07-19','13:20:00',2.07),('15529','2013-07-19','13:25:00',2.23),('15529','2013-07-19','13:30:00',2.28),('15529','2013-07-19','13:35:00',2.09),('15529','2013-07-19','13:40:00',2.27),('15529','2013-07-19','13:45:00',2.29),('15529','2013-07-19','13:50:00',2.21),('15529','2013-07-19','13:55:00',2.18),('15529','2013-07-19','14:00:00',2.17),('15529','2013-07-19','14:05:00',2.16),('15529','2013-07-19','14:10:00',2.14),('15529','2013-07-19','14:15:00',2.1),('15529','2013-07-19','14:20:00',2.15),('15529','2013-07-19','14:25:00',2.13),('15529','2013-07-19','14:30:00',2.09),('15529','2013-07-19','14:35:00',2.08),('15529','2013-07-19','14:40:00',2.06),('15529','2013-07-19','14:45:00',2.04),('15529','2013-07-19','14:50:00',2.05),('15529','2013-07-19','14:55:00',2.05),('15529','2013-07-19','15:00:00',2.02),('15529','2013-07-19','15:05:00',2.01),('15529','2013-07-19','15:10:00',1.96),('15529','2013-07-19','15:15:00',1.93),('15529','2013-07-19','15:20:00',1.89),('15529','2013-07-19','15:25:00',1.9),('15529','2013-07-19','15:30:00',1.89),('15529','2013-07-19','15:35:00',1.84),('15529','2013-07-19','15:40:00',1.81),('15529','2013-07-19','15:45:00',1.8),('15529','2013-07-19','15:50:00',1.78),('15529','2013-07-19','15:55:00',1.73),('15529','2013-07-19','16:00:00',1.69),('15529','2013-07-19','16:05:00',1.66),('15529','2013-07-19','16:10:00',1.63),('15529','2013-07-19','16:15:00',1.6),('15529','2013-07-19','16:20:00',1.57),('15529','2013-07-19','16:25:00',1.53),('15529','2013-07-19','16:30:00',1.5),('15529','2013-07-19','16:35:00',1.47),('15529','2013-07-19','16:40:00',1.43),('15529','2013-07-19','16:45:00',1.38),('15529','2013-07-19','16:50:00',1.35),('15529','2013-07-19','16:55:00',1.31),('15529','2013-07-19','17:00:00',1.25),('15529','2013-07-19','17:05:00',1.22),('15529','2013-07-19','17:10:00',1.18),('15529','2013-07-19','17:15:00',1.13),('15529','2013-07-19','17:20:00',1.09),('15529','2013-07-19','17:25:00',1.04),('15529','2013-07-19','17:30:00',1),('15529','2013-07-18','09:00:00',1.01),('15529','2013-07-18','09:05:00',1.05),('15529','2013-07-18','09:10:00',1.09),('15529','2013-07-18','09:15:00',1.11),('15529','2013-07-18','09:20:00',1.18),('15529','2013-07-18','09:25:00',1.2),('15529','2013-07-18','09:30:00',1.23),('15529','2013-07-18','09:35:00',1.26),('15529','2013-07-18','09:40:00',1.3),('15529','2013-07-18','09:45:00',1.33),('15529','2013-07-18','09:50:00',1.37),('15529','2013-07-18','09:55:00',1.4),('15529','2013-07-18','10:00:00',1.43),('15529','2013-07-18','10:05:00',1.44),('15529','2013-07-18','10:10:00',1.47),('15529','2013-07-18','10:15:00',1.49),('15529','2013-07-18','10:20:00',1.55),('15529','2013-07-18','10:25:00',1.55),('15529','2013-07-18','10:30:00',1.59),('15529','2013-07-18','10:35:00',1.61),('15529','2013-07-18','10:40:00',1.67),('15529','2013-07-18','10:45:00',1.67),('15529','2013-07-18','10:50:00',1.7),('15529','2013-07-18','10:55:00',1.73),('15529','2013-07-18','11:00:00',1.73),('15529','2013-07-18','11:05:00',1.74),('15529','2013-07-18','11:10:00',1.75),('15529','2013-07-18','11:15:00',1.8),('15529','2013-07-18','11:20:00',1.81),('15529','2013-07-18','11:25:00',1.84),('15529','2013-07-18','11:30:00',1.86),('15529','2013-07-18','11:35:00',1.83),('15529','2013-07-18','11:40:00',1.84),('15529','2013-07-18','11:45:00',1.96),('15529','2013-07-18','11:50:00',1.93),('15529','2013-07-18','11:55:00',1.89),('15529','2013-07-18','12:00:00',2.03),('15529','2013-07-18','12:05:00',2.11),('15529','2013-07-18','12:10:00',2.06),('15529','2013-07-18','12:15:00',2.03),('15529','2013-07-18','12:20:00',2.07),('15529','2013-07-18','12:25:00',2.05),('15529','2013-07-18','12:30:00',2.05),('15529','2013-07-18','12:35:00',2.11),('15529','2013-07-18','12:40:00',2.04),('15529','2013-07-18','12:45:00',2.08),('15529','2013-07-18','12:50:00',1.74),('15529','2013-07-18','12:55:00',2.24),('15529','2013-07-18','13:00:00',2.2),('15529','2013-07-18','13:05:00',2.14),('15529','2013-07-18','13:10:00',2.22),('15529','2013-07-18','13:15:00',2.24),('15529','2013-07-18','13:20:00',2.25),('15529','2013-07-18','13:25:00',2.19),('15529','2013-07-18','13:30:00',2.22),('15529','2013-07-18','13:35:00',1.66),('15529','2013-07-18','13:40:00',2.15),('15529','2013-07-18','13:45:00',2.15),('15529','2013-07-18','13:50:00',2.18),('15529','2013-07-18','13:55:00',2.13),('15529','2013-07-18','14:00:00',2.15),('15529','2013-07-18','14:05:00',2.14),('15529','2013-07-18','14:10:00',2.15),('15529','2013-07-18','14:15:00',2.11),('15529','2013-07-18','14:20:00',2.15),('15529','2013-07-18','14:25:00',2.09),('15529','2013-07-18','14:30:00',2.08),('15529','2013-07-18','14:35:00',1.64),('15529','2013-07-18','14:40:00',2.14),('15529','2013-07-18','14:45:00',1.79),('15529','2013-07-18','14:50:00',2.05),('15529','2013-07-18','14:55:00',1.89),('15529','2013-07-18','15:00:00',2.03),('15529','2013-07-18','15:05:00',1.93),('15529','2013-07-18','15:10:00',1.92),('15529','2013-07-18','15:15:00',1.26),('15529','2013-07-18','15:20:00',1.63),('15529','2013-07-18','15:25:00',2.01),('15529','2013-07-18','15:30:00',1.97),('15529','2013-07-18','15:35:00',1.93),('15529','2013-07-18','15:40:00',1.89),('15529','2013-07-18','15:45:00',1.83),('15529','2013-07-18','15:50:00',1.79),('15529','2013-07-18','15:55:00',1.72),('15529','2013-07-18','16:00:00',1.7),('15529','2013-07-18','16:05:00',1.67),('15529','2013-07-18','16:10:00',1.62),('15529','2013-07-18','16:15:00',1.63),('15529','2013-07-18','16:20:00',1.58),('15529','2013-07-18','16:25:00',1.56),('15529','2013-07-18','16:30:00',1.53),('15529','2013-07-18','16:35:00',1.51),('15529','2013-07-18','16:40:00',1.48),('15529','2013-07-18','16:45:00',1.43),('15529','2013-07-18','16:50:00',1.42),('15529','2013-07-18','16:55:00',1.24),('15529','2013-07-18','17:00:00',1.36),('15529','2013-07-18','17:05:00',1.31),('15529','2013-07-18','17:10:00',1.03),('15529','2013-07-18','17:15:00',1.07),('15529','2013-07-18','17:30:00',1.04),('15529','2013-07-17','08:55:00',1.01),('15529','2013-07-17','09:00:00',1.05),('15529','2013-07-17','09:05:00',1.09),('15529','2013-07-17','09:10:00',1.13),('15529','2013-07-17','09:15:00',1.17),('15529','2013-07-17','09:20:00',1.21),('15529','2013-07-17','09:25:00',1.26),('15529','2013-07-17','09:30:00',1.3),('15529','2013-07-17','09:35:00',1.33),('15529','2013-07-17','09:40:00',1.36),('15529','2013-07-17','09:45:00',1.39),('15529','2013-07-17','09:50:00',1.42),('15529','2013-07-17','09:55:00',1.47),('15529','2013-07-17','10:00:00',1.5),('15529','2013-07-17','10:05:00',1.54),('15529','2013-07-17','10:10:00',1.57),('15529','2013-07-17','10:15:00',1.59),('15529','2013-07-17','10:20:00',1.62),('15529','2013-07-17','10:25:00',1.65),('15529','2013-07-17','10:30:00',1.67),('15529','2013-07-17','10:35:00',1.7),('15529','2013-07-17','10:40:00',1.71),('15529','2013-07-17','10:45:00',1.75),('15529','2013-07-17','10:50:00',1.78),('15529','2013-07-17','10:55:00',1.76),('15529','2013-07-17','11:00:00',1.81),('15529','2013-07-17','11:05:00',1.82),('15529','2013-07-17','11:10:00',1.87),('15529','2013-07-17','11:15:00',1.91),('15529','2013-07-17','11:20:00',1.88),('15529','2013-07-17','11:25:00',1.91),('15529','2013-07-17','11:30:00',1.93),('15529','2013-07-17','11:35:00',1.92),('15529','2013-07-17','11:40:00',1.97),('15529','2013-07-17','11:45:00',1.99),('15529','2013-07-17','11:50:00',2),('15529','2013-07-17','11:55:00',2.03),('15529','2013-07-17','12:00:00',2),('15529','2013-07-17','12:05:00',2.04),('15529','2013-07-17','12:10:00',2.04),('15529','2013-07-17','12:15:00',2.04),('15529','2013-07-17','12:20:00',2.07),('15529','2013-07-17','12:25:00',2.06),('15529','2013-07-17','12:30:00',2.15),('15529','2013-07-17','12:35:00',2.13),('15529','2013-07-17','12:40:00',2.13),('15529','2013-07-17','12:45:00',2.17),('15529','2013-07-17','12:50:00',2.18),('15529','2013-07-17','12:55:00',2.14),('15529','2013-07-17','13:00:00',2.18),('15529','2013-07-17','13:05:00',2.1),('15529','2013-07-17','13:10:00',2.16),('15529','2013-07-17','13:15:00',2.16),('15529','2013-07-17','13:20:00',2.17),('15529','2013-07-17','13:25:00',2.11),('15529','2013-07-17','13:30:00',2.11),('15529','2013-07-17','13:35:00',2.16),('15529','2013-07-17','13:40:00',2.26),('15529','2013-07-17','13:45:00',2.17),('15529','2013-07-17','13:50:00',2.15),('15529','2013-07-17','13:55:00',2.21),('15529','2013-07-17','14:00:00',1.95),('15529','2013-07-17','14:10:00',2.1),('15529','2013-07-17','14:15:00',2.13),('15529','2013-07-17','14:20:00',2.11),('15529','2013-07-17','14:25:00',2.1),('15529','2013-07-17','14:30:00',2.09),('15529','2013-07-17','14:35:00',2.07),('15529','2013-07-17','14:40:00',2.05),('15529','2013-07-17','14:45:00',1.97),('15529','2013-07-17','14:50:00',1.93),('15529','2013-07-17','14:55:00',1.99),('15529','2013-07-17','15:00:00',1.99),('15529','2013-07-17','15:05:00',1.95),('15529','2013-07-17','15:10:00',1.96),('15529','2013-07-17','15:15:00',1.91),('15529','2013-07-17','15:20:00',1.9),('15529','2013-07-17','15:25:00',1.9),('15529','2013-07-17','15:30:00',1.83),('15529','2013-07-17','15:35:00',1.83),('15529','2013-07-17','15:40:00',1.8),('15529','2013-07-17','15:45:00',1.78),('15529','2013-07-17','15:50:00',1.71),('15529','2013-07-17','15:55:00',1.72),('15529','2013-07-17','16:00:00',1.7),('15529','2013-07-17','16:05:00',1.65),('15529','2013-07-17','16:10:00',1.62),('15529','2013-07-17','16:15:00',1.6),('15529','2013-07-17','16:20:00',1.54),('15529','2013-07-17','16:25:00',1.51),('15529','2013-07-17','16:30:00',1.47),('15529','2013-07-17','16:35:00',1.42),('15529','2013-07-17','16:40:00',1.4),('15529','2013-07-17','16:45:00',1.36),('15529','2013-07-17','16:50:00',1.32),('15529','2013-07-17','16:55:00',1.27),('15529','2013-07-17','17:00:00',1.23),('15529','2013-07-17','17:05:00',1.16),('15529','2013-07-17','17:10:00',1.07),('15529','2013-07-17','17:15:00',1.09),('15529','2013-07-17','17:20:00',1.06),('15529','2013-07-17','17:25:00',1.02),('15529','2013-07-16','08:50:00',1.02),('15529','2013-07-16','08:55:00',1.07),('15529','2013-07-16','09:00:00',1.1),('15529','2013-07-16','09:05:00',1.14),('15529','2013-07-16','09:10:00',1.19),('15529','2013-07-16','09:15:00',1.23),('15529','2013-07-16','09:20:00',1.27),('15529','2013-07-16','09:25:00',1.31),('15529','2013-07-16','09:30:00',1.35),('15529','2013-07-16','09:35:00',1.37),('15529','2013-07-16','09:40:00',1.42),('15529','2013-07-16','09:45:00',1.45),('15529','2013-07-16','09:50:00',1.49),('15529','2013-07-16','09:55:00',1.52),('15529','2013-07-16','10:00:00',1.55),('15529','2013-07-16','10:05:00',1.58),('15529','2013-07-16','10:10:00',1.61),('15529','2013-07-16','10:15:00',1.63),('15529','2013-07-16','10:20:00',1.67),('15529','2013-07-16','10:25:00',1.68),('15529','2013-07-16','10:30:00',1.71),('15529','2013-07-16','10:35:00',1.75),('15529','2013-07-16','10:40:00',1.78),('15529','2013-07-16','10:45:00',1.79),('15529','2013-07-16','10:50:00',1.82),('15529','2013-07-16','10:55:00',1.89),('15529','2013-07-16','11:00:00',1.89),('15529','2013-07-16','11:05:00',1.94),('15529','2013-07-16','11:10:00',1.96),('15529','2013-07-16','11:15:00',1.96),('15529','2013-07-16','11:20:00',2),('15529','2013-07-16','11:25:00',2.04),('15529','2013-07-16','11:30:00',2.06),('15529','2013-07-16','11:35:00',1.99),('15529','2013-07-16','11:40:00',2.08),('15529','2013-07-16','11:45:00',2.08),('15529','2013-07-16','11:50:00',2.03),('15529','2013-07-16','11:55:00',2.05),('15529','2013-07-16','12:00:00',2.07),('15529','2013-07-16','12:05:00',2.09),('15529','2013-07-16','12:10:00',2.1),('15529','2013-07-16','12:15:00',2.13),('15529','2013-07-16','12:20:00',2.15),('15529','2013-07-16','12:25:00',2.15),('15529','2013-07-16','12:30:00',2.16),('15529','2013-07-16','12:35:00',2.16),('15529','2013-07-16','12:40:00',2.06),('15529','2013-07-16','12:45:00',2.11),('15529','2013-07-16','12:50:00',2.11),('15529','2013-07-16','12:55:00',2.16),('15529','2013-07-16','13:00:00',2.17),('15529','2013-07-16','13:05:00',2.16),('15529','2013-07-16','13:10:00',2.12),('15529','2013-07-16','13:15:00',2.2),('15529','2013-07-16','13:20:00',2.12),('15529','2013-07-16','13:25:00',2.07),('15529','2013-07-16','13:30:00',2.12),('15529','2013-07-16','13:35:00',2.12),('15529','2013-07-16','13:40:00',2.06),('15529','2013-07-16','13:45:00',2.09),('15529','2013-07-16','13:50:00',2.1),('15529','2013-07-16','13:55:00',2.12),('15529','2013-07-16','14:00:00',2.15),('15529','2013-07-16','14:05:00',2.08),('15529','2013-07-16','14:10:00',2.08),('15529','2013-07-16','14:15:00',2.14),('15529','2013-07-16','14:20:00',2.05),('15529','2013-07-16','14:25:00',1.36),('15529','2013-07-16','14:30:00',2.02),('15529','2013-07-16','14:35:00',2.06),('15529','2013-07-16','14:40:00',2.04),('15529','2013-07-16','14:45:00',2.01),('15529','2013-07-16','14:50:00',2.01),('15529','2013-07-16','14:55:00',1.99),('15529','2013-07-16','15:00:00',1.99),('15529','2013-07-16','15:05:00',1.9),('15529','2013-07-16','15:10:00',1.89),('15529','2013-07-16','15:15:00',1.92),('15529','2013-07-16','15:20:00',1.92),('15529','2013-07-16','15:25:00',1.89),('15529','2013-07-16','15:30:00',1.81),('15529','2013-07-16','15:35:00',1.4),('15529','2013-07-16','15:45:00',1.09),('15529','2013-07-16','15:50:00',1.54),('15529','2013-07-16','16:10:00',1.6),('15529','2013-07-16','16:15:00',1.53),('15529','2013-07-16','16:20:00',1.51),('15529','2013-07-16','16:25:00',1.45),('15529','2013-07-16','16:30:00',1.43),('15529','2013-07-16','16:35:00',1.43),('15529','2013-07-16','16:40:00',1.41),('15529','2013-07-16','16:45:00',1.35),('15529','2013-07-16','16:50:00',1.33),('15529','2013-07-16','16:55:00',1.29),('15529','2013-07-16','17:00:00',1.27),('15529','2013-07-16','17:05:00',1.14),('15529','2013-07-16','17:20:00',1.11),('15529','2013-07-16','17:25:00',1.08),('15529','2013-07-16','17:30:00',1.02),('15529','2013-07-15','08:55:00',1.02),('15529','2013-07-15','09:00:00',1.07),('15529','2013-07-15','09:05:00',1.12),('15529','2013-07-15','09:10:00',1.16),('15529','2013-07-15','09:15:00',1.19),('15529','2013-07-15','09:20:00',1.22),('15529','2013-07-15','09:25:00',1.25),('15529','2013-07-15','09:30:00',1.29),('15529','2013-07-15','09:35:00',1.33),('15529','2013-07-15','09:40:00',1.37),('15529','2013-07-15','09:45:00',1.41),('15529','2013-07-15','09:50:00',1.45),('15529','2013-07-15','09:55:00',1.49),('15529','2013-07-15','10:00:00',1.52),('15529','2013-07-15','10:05:00',1.55),('15529','2013-07-15','10:10:00',1.58),('15529','2013-07-15','10:15:00',1.61),('15529','2013-07-15','10:20:00',1.65),('15529','2013-07-15','10:25:00',1.66),('15529','2013-07-15','10:30:00',1.69),('15529','2013-07-15','10:35:00',1.71),('15529','2013-07-15','10:40:00',1.75),('15529','2013-07-15','10:45:00',1.78),('15529','2013-07-15','10:50:00',1.81),('15529','2013-07-15','10:55:00',1.83),('15529','2013-07-15','11:00:00',1.87),('15529','2013-07-15','11:05:00',1.91),('15529','2013-07-15','11:10:00',1.91),('15529','2013-07-15','11:15:00',1.93),('15529','2013-07-15','11:20:00',1.93),('15529','2013-07-15','11:25:00',1.96),('15529','2013-07-15','11:30:00',1.97),('15529','2013-07-15','11:35:00',1.97),('15529','2013-07-15','11:40:00',2.01),('15529','2013-07-15','11:45:00',2.02),('15529','2013-07-15','11:50:00',2.04),('15529','2013-07-15','11:55:00',2.04),('15529','2013-07-15','12:00:00',2.08),('15529','2013-07-15','12:05:00',2.06),('15529','2013-07-15','12:10:00',2.12),('15529','2013-07-15','12:15:00',2.12),('15529','2013-07-15','12:20:00',2.14),('15529','2013-07-15','12:25:00',2.1),('15529','2013-07-15','12:30:00',2.16),('15529','2013-07-15','12:35:00',2.14),('15529','2013-07-15','12:40:00',2.15),('15529','2013-07-15','12:45:00',2.15),('15529','2013-07-15','12:50:00',2.17),('15529','2013-07-15','12:55:00',2.19),('15529','2013-07-15','13:00:00',2.17),('15529','2013-07-15','13:05:00',2.17),('15529','2013-07-15','13:10:00',2.17),('15529','2013-07-15','13:15:00',2.19),('15529','2013-07-15','13:20:00',2.19),('15529','2013-07-15','13:25:00',2.19),('15529','2013-07-15','13:30:00',2.14),('15529','2013-07-15','13:35:00',2.16),('15529','2013-07-15','13:40:00',2.16),('15529','2013-07-15','13:45:00',2.2),('15529','2013-07-15','13:50:00',2.17),('15529','2013-07-15','13:55:00',2.18),('15529','2013-07-15','14:00:00',2.14),('15529','2013-07-15','14:05:00',1.96),('15529','2013-07-15','14:10:00',2.04),('15529','2013-07-15','14:15:00',2.07),('15529','2013-07-15','14:20:00',2.08),('15529','2013-07-15','14:25:00',2.13),('15529','2013-07-15','14:30:00',2.1),('15529','2013-07-15','14:35:00',2.05),('15529','2013-07-15','14:40:00',2.02),('15529','2013-07-15','14:45:00',2.03),('15529','2013-07-15','14:50:00',1.99),('15529','2013-07-15','14:55:00',2.01),('15529','2013-07-15','15:00:00',1.98),('15529','2013-07-15','15:05:00',1.96),('15529','2013-07-15','15:10:00',1.92),('15529','2013-07-15','15:15:00',1.91),('15529','2013-07-15','15:20:00',1.9),('15529','2013-07-15','15:25:00',1.87),('15529','2013-07-15','15:30:00',1.89),('15529','2013-07-15','15:45:00',1.33),('15529','2013-07-15','15:50:00',1.29),('15529','2013-07-15','15:55:00',1.58),('15529','2013-07-15','16:00:00',1.53),('15529','2013-07-15','16:05:00',1.55),('15529','2013-07-15','16:10:00',1.68),('15529','2013-07-15','16:15:00',1.41),('15529','2013-07-15','16:20:00',1.03),('15529','2013-07-15','16:25:00',1.25),('15529','2013-07-15','16:30:00',1.05),('15529','2013-07-15','16:50:00',1.5),('15529','2013-07-15','16:55:00',1.33),('15529','2013-07-15','17:10:00',1.2),('15529','2013-07-15','17:15:00',1.16),('15529','2013-07-15','17:20:00',1.14),('15529','2013-07-15','17:25:00',1.18),('15529','2013-07-15','17:30:00',1.09),('15529','2013-07-15','17:40:00',1.03),('15529','2013-07-14','08:50:00',1.02),('15529','2013-07-14','08:55:00',1.06),('15529','2013-07-14','09:00:00',1.1),('15529','2013-07-14','09:05:00',1.14),('15529','2013-07-14','09:10:00',1.18),('15529','2013-07-14','09:15:00',1.22),('15529','2013-07-14','09:20:00',1.26),('15529','2013-07-14','09:25:00',1.31),('15529','2013-07-14','09:30:00',1.34),('15529','2013-07-14','09:35:00',1.38),('15529','2013-07-14','09:40:00',1.42),('15529','2013-07-14','09:45:00',1.45),('15529','2013-07-14','09:50:00',1.48),('15529','2013-07-14','09:55:00',1.52),('15529','2013-07-14','10:00:00',1.56),('15529','2013-07-14','10:05:00',1.58),('15529','2013-07-14','10:10:00',1.62),('15529','2013-07-14','10:15:00',1.64),('15529','2013-07-14','10:20:00',1.67),('15529','2013-07-14','10:25:00',1.7),('15529','2013-07-14','10:30:00',1.73),('15529','2013-07-14','10:35:00',1.75),('15529','2013-07-14','10:40:00',1.79),('15529','2013-07-14','10:45:00',1.8),('15529','2013-07-14','10:50:00',1.83),('15529','2013-07-14','10:55:00',1.86),('15529','2013-07-14','11:00:00',1.88),('15529','2013-07-14','11:05:00',1.91),('15529','2013-07-14','11:10:00',1.93),('15529','2013-07-14','11:15:00',1.97),('15529','2013-07-14','11:20:00',1.97),('15529','2013-07-14','11:25:00',2),('15529','2013-07-14','11:30:00',2.02),('15529','2013-07-14','11:35:00',2.04),('15529','2013-07-14','11:40:00',2.03),('15529','2013-07-14','11:45:00',2.05),('15529','2013-07-14','11:50:00',2.05),('15529','2013-07-14','11:55:00',2.06),('15529','2013-07-14','12:00:00',2.09),('15529','2013-07-14','12:05:00',2.1),('15529','2013-07-14','12:10:00',2.08),('15529','2013-07-14','12:15:00',2.08),('15529','2013-07-14','12:20:00',2.11),('15529','2013-07-14','12:25:00',2.12),('15529','2013-07-14','12:30:00',2.09),('15529','2013-07-14','12:35:00',2.1),('15529','2013-07-14','12:40:00',2.1),('15529','2013-07-14','12:45:00',2.15),('15529','2013-07-14','12:50:00',2.11),('15529','2013-07-14','12:55:00',2.16),('15529','2013-07-14','13:00:00',2.18),('15529','2013-07-14','13:05:00',2.17),('15529','2013-07-14','13:10:00',2.12),('15529','2013-07-14','13:15:00',2.14),('15529','2013-07-14','13:20:00',2.23),('15529','2013-07-14','13:25:00',2.19),('15529','2013-07-14','13:30:00',2.23),('15529','2013-07-14','13:35:00',2.27),('15529','2013-07-14','13:40:00',2.28),('15529','2013-07-14','13:45:00',2.05),('15529','2013-07-14','13:50:00',1.85),('15529','2013-07-14','13:55:00',2.26),('15529','2013-07-14','14:00:00',2.26),('15529','2013-07-14','14:05:00',1.47),('15529','2013-07-14','14:10:00',1.62),('15529','2013-07-14','14:15:00',2.27),('15529','2013-07-14','14:20:00',1.96),('15529','2013-07-14','14:25:00',2.17),('15529','2013-07-14','14:30:00',1.96),('15529','2013-07-14','14:40:00',1.11),('15529','2013-07-14','14:45:00',1.62),('15529','2013-07-14','14:50:00',2.11),('15529','2013-07-14','14:55:00',2.04),('15529','2013-07-14','15:00:00',1.99),('15529','2013-07-14','15:05:00',1.96),('15529','2013-07-14','15:10:00',1.96),('15529','2013-07-14','15:15:00',1.94),('15529','2013-07-14','15:20:00',1.95),('15529','2013-07-14','15:25:00',1.81),('15529','2013-07-14','15:40:00',1.72),('15529','2013-07-14','15:45:00',1.82),('15529','2013-07-14','15:50:00',1.79),('15529','2013-07-14','15:55:00',1.75),('15529','2013-07-14','16:00:00',1.71),('15529','2013-07-14','16:05:00',1.67),('15529','2013-07-14','16:10:00',1.59),('15529','2013-07-14','16:15:00',1.57),('15529','2013-07-14','16:20:00',1.57),('15529','2013-07-14','16:25:00',1.52),('15529','2013-07-14','16:30:00',1.48),('15529','2013-07-14','16:35:00',1.43),('15529','2013-07-14','16:40:00',1.41),('15529','2013-07-14','16:45:00',1.38),('15529','2013-07-14','16:50:00',1.34),('15529','2013-07-14','16:55:00',1.3),('15529','2013-07-14','17:00:00',1.27),('15529','2013-07-14','17:05:00',1.23),('15529','2013-07-14','17:10:00',1.18),('15529','2013-07-14','17:15:00',1.13),('15529','2013-07-14','17:20:00',1.09),('15529','2013-07-14','17:25:00',1.06),('15529','2013-07-14','17:30:00',1.01),('15529','2013-07-13','09:25:00',1.22),('15529','2013-07-13','09:30:00',1.07),('15529','2013-07-13','09:35:00',1.12),('15529','2013-07-13','10:20:00',1.2),('15529','2013-07-13','10:25:00',1.88),('15529','2013-07-13','10:30:00',1.73),('15529','2013-07-13','10:35:00',1.75),('15529','2013-07-13','10:40:00',1.18),('15529','2013-07-13','10:45:00',1.6),('15529','2013-07-13','10:50:00',1.99),('15529','2013-07-13','10:55:00',1.97),('15529','2013-07-13','11:00:00',2.15),('15529','2013-07-13','11:05:00',2.03),('15529','2013-07-13','11:10:00',1.51),('15529','2013-07-13','11:15:00',1.92),('15529','2013-07-13','11:20:00',2.2),('15529','2013-07-13','11:25:00',1.78),('15529','2013-07-13','11:30:00',1.91),('15529','2013-07-13','11:35:00',2.07),('15529','2013-07-13','11:40:00',2.17),('15529','2013-07-13','11:45:00',2.23),('15529','2013-07-13','11:50:00',2.19),('15529','2013-07-13','11:55:00',2.19),('15529','2013-07-13','12:00:00',1.55),('15529','2013-07-13','12:05:00',2.07),('15529','2013-07-13','12:10:00',1.31),('15529','2013-07-13','12:15:00',2.17),('15529','2013-07-13','12:20:00',2.19),('15529','2013-07-13','12:25:00',1.19),('15529','2013-07-13','12:35:00',1.55),('15529','2013-07-13','12:40:00',1.28),('15529','2013-07-13','13:00:00',2.39),('15529','2013-07-13','13:05:00',2.36),('15529','2013-07-13','13:10:00',2.21),('15529','2013-07-13','13:15:00',2.18),('15529','2013-07-13','13:20:00',2.2),('15529','2013-07-13','13:25:00',2.23),('15529','2013-07-13','13:30:00',2.18),('15529','2013-07-13','13:35:00',2.11),('15529','2013-07-13','13:40:00',2.2),('15529','2013-07-13','13:45:00',2.19),('15529','2013-07-13','13:50:00',2.19),('15529','2013-07-13','13:55:00',2.17),('15529','2013-07-13','14:00:00',2.23),('15529','2013-07-13','14:05:00',2.23),('15529','2013-07-13','14:10:00',2.13),('15529','2013-07-13','14:15:00',2.18),('15529','2013-07-13','14:20:00',2.14),('15529','2013-07-13','14:25:00',2.13),('15529','2013-07-13','14:30:00',2.09),('15529','2013-07-13','14:35:00',2.1),('15529','2013-07-13','14:40:00',2.1),('15529','2013-07-13','14:45:00',2.08),('15529','2013-07-13','14:50:00',2.02),('15529','2013-07-13','14:55:00',2.04),('15529','2013-07-13','15:00:00',1.99),('15529','2013-07-13','15:05:00',1.97),('15529','2013-07-13','15:10:00',1.96),('15529','2013-07-13','15:15:00',1.93),('15529','2013-07-13','15:20:00',1.93),('15529','2013-07-13','15:25:00',1.92),('15529','2013-07-13','15:30:00',1.87),('15529','2013-07-13','15:35:00',1.85),('15529','2013-07-13','15:40:00',1.82),('15529','2013-07-13','15:45:00',1.79),('15529','2013-07-13','15:50:00',1.78),('15529','2013-07-13','15:55:00',1.76),('15529','2013-07-13','16:00:00',1.71),('15529','2013-07-13','16:05:00',1.68),('15529','2013-07-13','16:10:00',1.65),('15529','2013-07-13','16:15:00',1.6),('15529','2013-07-13','16:20:00',1.17),('15529','2013-07-13','16:25:00',1.29),('15529','2013-07-13','16:30:00',1.54),('15529','2013-07-13','16:35:00',1.49),('15529','2013-07-13','16:40:00',1.5),('15529','2013-07-13','16:45:00',1.47),('15529','2013-07-13','16:50:00',1.44),('15529','2013-07-13','16:55:00',1.38),('15529','2013-07-13','17:00:00',1.01),('15529','2013-07-13','17:05:00',1.37),('15529','2013-07-13','17:10:00',1.24),('15529','2013-07-13','17:25:00',1.13),('15529','2013-07-12','09:00:00',1.04),('15529','2013-07-12','09:05:00',1.09),('15529','2013-07-12','09:10:00',1.14),('15529','2013-07-12','09:15:00',1.19),('15529','2013-07-12','09:20:00',1.22),('15529','2013-07-12','09:25:00',1.26),('15529','2013-07-12','09:30:00',1.29),('15529','2013-07-12','09:35:00',1.33),('15529','2013-07-12','09:40:00',1.33),('15529','2013-07-12','09:45:00',1.35),('15529','2013-07-12','09:50:00',1.39),('15529','2013-07-12','09:55:00',1.48),('15529','2013-07-12','10:00:00',1.51),('15529','2013-07-12','10:05:00',1.5),('15529','2013-07-12','10:10:00',1.49),('15529','2013-07-12','10:15:00',1.63),('15529','2013-07-12','10:20:00',1.66),('15529','2013-07-12','10:25:00',1.64),('15529','2013-07-12','10:30:00',1.69),('15529','2013-07-12','10:35:00',1.57),('15529','2013-07-12','10:40:00',1.8),('15529','2013-07-12','10:45:00',1.86),('15529','2013-07-12','10:50:00',1.18),('15529','2013-07-12','10:55:00',1.74),('15529','2013-07-12','11:00:00',2.07),('15529','2013-07-12','11:05:00',1.09),('15529','2013-07-12','11:20:00',1.33),('15529','2013-07-12','11:25:00',1.46),('15529','2013-07-12','11:30:00',1.3),('15529','2013-07-12','11:35:00',2.1),('15529','2013-07-12','11:40:00',2.12),('15529','2013-07-12','11:45:00',2.05),('15529','2013-07-12','11:50:00',1.79),('15529','2013-07-12','12:00:00',1.58),('15529','2013-07-12','12:05:00',1.32),('15529','2013-07-12','12:15:00',1.94),('15529','2013-07-12','12:20:00',1.57),('15529','2013-07-12','12:25:00',1.85),('15529','2013-07-12','12:30:00',2.03),('15529','2013-07-12','12:35:00',2.08),('15529','2013-07-12','12:40:00',1.85),('15529','2013-07-12','12:45:00',1.47),('15529','2013-07-12','12:50:00',2.2),('15529','2013-07-12','12:55:00',2.34),('15529','2013-07-12','13:00:00',1.06),('15529','2013-07-12','13:05:00',2.14),('15529','2013-07-12','13:10:00',2.08),('15529','2013-07-12','13:15:00',2.11),('15529','2013-07-12','13:20:00',2.15),('15529','2013-07-12','13:25:00',2.13),('15529','2013-07-12','13:30:00',2.12),('15529','2013-07-12','13:35:00',2.12),('15529','2013-07-12','13:40:00',2.1),('15529','2013-07-12','13:45:00',2.09),('15529','2013-07-12','13:50:00',2.09),('15529','2013-07-12','13:55:00',2.09),('15529','2013-07-12','14:00:00',2.09),('15529','2013-07-12','14:05:00',2.09),('15529','2013-07-12','14:10:00',2.06),('15529','2013-07-12','14:15:00',2.05),('15529','2013-07-12','14:20:00',2.06),('15529','2013-07-12','14:25:00',1.74),('15529','2013-07-12','14:30:00',1.17),('15529','2013-07-12','14:35:00',1.17),('15529','2013-07-12','14:40:00',1.17),('15529','2013-07-12','14:45:00',1.18),('15529','2013-07-12','14:50:00',1.17),('15529','2013-07-12','14:55:00',1.18),('15529','2013-07-12','15:00:00',1.02),('15529','2013-07-12','15:05:00',2.03),('15529','2013-07-12','15:10:00',2.03),('15529','2013-07-12','15:15:00',2.03),('15529','2013-07-12','15:20:00',1.9),('15529','2013-07-12','15:25:00',1.97),('15529','2013-07-12','15:30:00',1.86),('15529','2013-07-12','15:35:00',1.91),('15529','2013-07-12','15:40:00',1.89),('15529','2013-07-12','15:45:00',1.85),('15529','2013-07-12','15:50:00',1.82),('15529','2013-07-12','15:55:00',1.8),('15529','2013-07-12','16:00:00',1.77),('15529','2013-07-12','16:05:00',1.74),('15529','2013-07-12','16:10:00',1.71),('15529','2013-07-12','16:15:00',1.64),('15529','2013-07-12','16:20:00',1.63),('15529','2013-07-12','16:25:00',1.6),('15529','2013-07-12','16:30:00',1.56),('15529','2013-07-12','16:35:00',1.52),('15529','2013-07-12','16:40:00',1.47),('15529','2013-07-12','16:45:00',1.44),('15529','2013-07-12','16:50:00',1.4),('15529','2013-07-12','16:55:00',1.35),('15529','2013-07-12','17:00:00',1.31),('15529','2013-07-12','17:05:00',1.24),('15529','2013-07-12','17:10:00',1.24),('15529','2013-07-12','17:15:00',1.2),('15529','2013-07-12','17:20:00',1.11),('15529','2013-07-12','17:25:00',1.14),('15529','2013-07-12','17:30:00',1.04),('15529','2013-07-12','17:35:00',1.01),('15529','2013-07-11','09:10:00',1.15),('15529','2013-07-11','09:40:00',1.06),('15529','2013-07-11','09:45:00',1.45),('15529','2013-07-11','09:50:00',1.5),('15529','2013-07-11','09:55:00',1.53),('15529','2013-07-11','10:00:00',1.43),('15529','2013-07-11','10:05:00',1.77),('15529','2013-07-11','10:10:00',1.28),('15529','2013-07-11','10:20:00',1.33),('15529','2013-07-11','10:25:00',1.73),('15529','2013-07-11','10:30:00',1.43),('15529','2013-07-11','10:40:00',1.7),('15529','2013-07-11','11:10:00',1.52),('15529','2013-07-11','11:15:00',1.11),('15529','2013-07-11','11:30:00',1.46),('15529','2013-07-11','11:35:00',1.54),('15529','2013-07-11','11:45:00',2.34),('15529','2013-07-11','11:50:00',2.32),('15529','2013-07-11','11:55:00',1.73),('15529','2013-07-11','12:00:00',1.55),('15529','2013-07-11','12:05:00',1.41),('15529','2013-07-11','12:10:00',1.46),('15529','2013-07-11','12:15:00',1.11),('15529','2013-07-11','12:20:00',2.06),('15529','2013-07-11','12:25:00',2.34),('15529','2013-07-11','12:30:00',2.23),('15529','2013-07-11','12:35:00',2.05),('15529','2013-07-11','12:40:00',1.3),('15529','2013-07-11','12:45:00',1.09),('15529','2013-07-11','12:50:00',1.32),('15529','2013-07-11','12:55:00',2.12),('15529','2013-07-11','13:00:00',2.3),('15529','2013-07-11','13:05:00',2.15),('15529','2013-07-11','13:10:00',2.31),('15529','2013-07-11','13:15:00',2.31),('15529','2013-07-11','13:20:00',2.29),('15529','2013-07-11','13:25:00',2.19),('15529','2013-07-11','13:30:00',2.08),('15529','2013-07-11','13:35:00',1.89),('15529','2013-07-11','13:40:00',2.21),('15529','2013-07-11','13:45:00',2.28),('15529','2013-07-11','13:50:00',1.81),('15529','2013-07-11','13:55:00',2.28),('15529','2013-07-11','14:00:00',1.77),('15529','2013-07-11','14:05:00',2.4),('15529','2013-07-11','14:10:00',2.3),('15529','2013-07-11','14:15:00',2.22),('15529','2013-07-11','14:20:00',2.13),('15529','2013-07-11','14:25:00',1.94),('15529','2013-07-11','14:30:00',2.18),('15529','2013-07-11','14:35:00',2.1),('15529','2013-07-11','14:40:00',2.09),('15529','2013-07-11','14:45:00',2.03),('15529','2013-07-11','14:50:00',2.03),('15529','2013-07-11','14:55:00',2.02),('15529','2013-07-11','15:00:00',1.96),('15529','2013-07-11','15:05:00',2.01),('15529','2013-07-11','15:10:00',1.96),('15529','2013-07-11','15:15:00',1.95),('15529','2013-07-11','15:20:00',1.93),('15529','2013-07-11','15:25:00',1.88),('15529','2013-07-11','15:30:00',1.88),('15529','2013-07-11','15:35:00',1.78),('15529','2013-07-11','15:40:00',1.81),('15529','2013-07-11','15:45:00',1.8),('15529','2013-07-11','15:50:00',1.71),('15529','2013-07-11','15:55:00',1.72),('15529','2013-07-11','16:00:00',1.69),('15529','2013-07-11','16:05:00',1.65),('15529','2013-07-11','16:10:00',1.63),('15529','2013-07-11','16:15:00',1.58),('15529','2013-07-11','16:20:00',1.56),('15529','2013-07-11','16:25:00',1.53),('15529','2013-07-11','16:30:00',1.48),('15529','2013-07-11','16:35:00',1.46),('15529','2013-07-11','16:40:00',1.43),('15529','2013-07-11','16:45:00',1.39),('15529','2013-07-11','16:50:00',1.35),('15529','2013-07-11','16:55:00',1.3),('15529','2013-07-11','17:00:00',1.26),('15529','2013-07-11','17:05:00',1.23),('15529','2013-07-11','17:10:00',1.18),('15529','2013-07-11','17:15:00',1.14),('15529','2013-07-11','17:20:00',1.09),('15529','2013-07-11','17:25:00',1.06),('15529','2013-07-11','17:30:00',1.02),('15529','2013-07-10','08:55:00',1),('15529','2013-07-10','09:00:00',1.01),('15529','2013-07-10','09:05:00',1.08),('15529','2013-07-10','09:10:00',1.16),('15529','2013-07-10','09:15:00',1.18),('15529','2013-07-10','09:20:00',1.27),('15529','2013-07-10','09:25:00',1.28),('15529','2013-07-10','09:30:00',1.36),('15529','2013-07-10','09:35:00',1.12),('15529','2013-07-10','09:45:00',1.28),('15529','2013-07-10','09:50:00',1.32),('15529','2013-07-10','09:55:00',1.16),('15529','2013-07-10','10:00:00',1.29),('15529','2013-07-10','10:05:00',1.82),('15529','2013-07-10','10:10:00',1.64),('15529','2013-07-10','10:15:00',1.07),('15529','2013-07-10','10:35:00',1.93),('15529','2013-07-10','10:40:00',1.95),('15529','2013-07-10','10:45:00',1.99),('15529','2013-07-10','10:50:00',1.66),('15529','2013-07-10','10:55:00',1.19),('15529','2013-07-10','11:00:00',1.82),('15529','2013-07-10','11:05:00',1.55),('15529','2013-07-10','11:20:00',2.16),('15529','2013-07-10','11:25:00',1.55),('15529','2013-07-10','11:30:00',1.84),('15529','2013-07-10','11:35:00',1.14),('15529','2013-07-10','11:40:00',1.83),('15529','2013-07-10','11:45:00',2.31),('15529','2013-07-10','11:50:00',1.11),('15529','2013-07-10','12:00:00',1.8),('15529','2013-07-10','12:05:00',2.29),('15529','2013-07-10','12:10:00',2.29),('15529','2013-07-10','12:15:00',2.26),('15529','2013-07-10','12:20:00',2.28),('15529','2013-07-10','12:25:00',2.21),('15529','2013-07-10','12:30:00',2.24),('15529','2013-07-10','12:35:00',1.7),('15529','2013-07-10','12:40:00',2.24),('15529','2013-07-10','12:45:00',2.29),('15529','2013-07-10','12:50:00',2.12),('15529','2013-07-10','12:55:00',2.27),('15529','2013-07-10','13:00:00',1.88),('15529','2013-07-10','13:05:00',2.21),('15529','2013-07-10','13:10:00',2.09),('15529','2013-07-10','13:15:00',2.38),('15529','2013-07-10','13:20:00',2.08),('15529','2013-07-10','13:25:00',1.83),('15529','2013-07-10','13:30:00',2.02),('15529','2013-07-10','13:35:00',2.35),('15529','2013-07-10','13:40:00',2.3),('15529','2013-07-10','13:45:00',2.3),('15529','2013-07-10','13:50:00',2.25),('15529','2013-07-10','13:55:00',2.25),('15529','2013-07-10','14:00:00',1.92),('15529','2013-07-10','14:05:00',2.2),('15529','2013-07-10','14:10:00',1.98),('15529','2013-07-10','14:15:00',2.12),('15529','2013-07-10','14:20:00',2.14),('15529','2013-07-10','14:25:00',2.13),('15529','2013-07-10','14:30:00',2.15),('15529','2013-07-10','14:35:00',2.09),('15529','2013-07-10','14:40:00',2.11),('15529','2013-07-10','14:45:00',2.1),('15529','2013-07-10','14:50:00',2.09),('15529','2013-07-10','14:55:00',2.08),('15529','2013-07-10','15:00:00',2.1),('15529','2013-07-10','15:05:00',2.07),('15529','2013-07-10','15:10:00',2.05),('15529','2013-07-10','15:15:00',2.06),('15529','2013-07-10','15:20:00',1.98),('15529','2013-07-10','15:25:00',1.95),('15529','2013-07-10','15:30:00',1.91),('15529','2013-07-10','15:35:00',1.91),('15529','2013-07-10','15:40:00',1.88),('15529','2013-07-10','15:45:00',1.92),('15529','2013-07-10','15:50:00',1.91),('15529','2013-07-10','15:55:00',1.51),('15529','2013-07-10','16:05:00',1.49),('15529','2013-07-10','16:10:00',1.07),('15529','2013-07-10','16:20:00',1.2),('15529','2013-07-10','16:30:00',1),('15529','2013-07-10','16:35:00',1.7),('15529','2013-07-10','16:40:00',1.22),('15529','2013-07-10','16:45:00',1.53),('15529','2013-07-10','16:50:00',1.36),('15529','2013-07-10','16:55:00',1.37),('15529','2013-07-10','17:00:00',1.27),('15529','2013-07-10','17:15:00',1.27),('15529','2013-07-10','17:25:00',1.09),('15529','2013-07-10','17:30:00',1.13),('15529','2014-05-02','08:40:00',1.03),('15529','2014-05-02','08:45:00',1.25),('15529','2014-05-02','09:10:00',1.39),('15529','2014-05-02','09:20:00',1.55),('15529','2014-05-02','09:25:00',1.27),('15529','2014-05-02','09:30:00',1.34),('15529','2014-05-02','09:35:00',1.47),('15529','2014-05-02','09:40:00',1.9),('15529','2014-05-02','09:45:00',2.02),('15529','2014-05-02','09:50:00',1.73),('15529','2014-05-02','09:55:00',1.89),('15529','2014-05-02','10:00:00',1.89),('15529','2014-05-02','10:10:00',1.12),('15529','2014-05-02','10:25:00',1.89),('15529','2014-05-02','10:30:00',1.09),('15529','2014-05-02','10:35:00',1.92),('15529','2014-05-02','10:40:00',1.56),('15529','2014-05-02','10:45:00',2.48),('15529','2014-05-02','10:50:00',2.63),('15529','2014-05-02','10:55:00',2.21),('15529','2014-05-02','11:00:00',1.78),('15529','2014-05-02','11:05:00',1.47),('15529','2014-05-02','11:10:00',1.77),('15529','2014-05-02','11:15:00',2.04),('15529','2014-05-02','11:20:00',2.11),('15529','2014-05-02','11:25:00',1.97),('15529','2014-05-02','11:30:00',1.27),('15529','2014-05-02','11:35:00',1.31),('15529','2014-05-02','11:40:00',1.41),('15529','2014-05-02','11:45:00',1.35),('15529','2014-05-02','11:50:00',1.22),('15529','2014-05-02','11:55:00',1.01),('15529','2014-05-02','12:35:00',1.12),('15529','2014-05-02','12:40:00',1.22),('15529','2014-05-02','13:00:00',1.24),('15529','2014-05-02','13:05:00',1.96),('15529','2014-05-02','13:10:00',1.82),('15529','2014-05-02','13:15:00',1.45),('15529','2014-05-02','13:20:00',1.4),('15529','2014-05-02','13:25:00',1.37),('15529','2014-05-02','13:30:00',1.55),('15529','2014-05-02','13:35:00',1.3),('15529','2014-05-02','13:40:00',1.34),('15529','2014-05-02','13:45:00',1.27),('15529','2014-05-02','13:50:00',1.09),('15529','2014-05-02','13:55:00',1.04),('15529','2014-05-02','14:00:00',1.04),('15529','2014-05-02','14:05:00',1.18),('15529','2014-05-02','14:10:00',1.42),('15529','2014-05-02','14:15:00',1.53),('15529','2014-05-02','14:20:00',1.54),('15529','2014-05-02','14:25:00',2.03),('15529','2014-05-02','14:30:00',1.75),('15529','2014-05-02','15:00:00',1.03),('15529','2014-04-05','09:05:00',1.1),('15529','2014-04-05','09:10:00',1.24),('15529','2014-04-05','09:15:00',1.2),('15529','2014-04-05','09:40:00',1.16),('15529','2014-04-05','09:50:00',1.66),('15529','2014-04-05','09:55:00',1.89),('15529','2014-04-05','10:00:00',1.97),('15529','2014-04-05','10:05:00',1.97),('15529','2014-04-05','10:10:00',1.64),('15529','2014-04-05','10:45:00',1),('15529','2014-04-05','10:50:00',1.53),('15529','2014-04-05','10:55:00',1.06),('15529','2014-04-05','11:10:00',1.09),('15529','2014-04-05','11:15:00',2.36),('15529','2014-04-05','11:20:00',2.28),('15529','2014-04-05','11:25:00',2.25),('15529','2014-04-05','11:30:00',2.27),('15529','2014-04-05','11:35:00',1.07),('15529','2014-04-05','11:55:00',1),('15529','2014-04-05','12:10:00',1.51),('15529','2014-04-05','12:30:00',1.29),('15529','2014-04-05','12:40:00',1.22),('15529','2014-04-05','12:50:00',1.55),('15529','2014-04-05','12:55:00',1.72),('15529','2014-04-05','13:00:00',1.87),('15529','2014-04-05','13:05:00',2.51),('15529','2014-04-05','13:10:00',2.08),('15529','2014-04-05','13:20:00',1.54),('15529','2014-04-05','13:25:00',2.07),('15529','2014-04-05','13:30:00',2.57),('15529','2014-04-05','13:35:00',1.45),('15529','2014-04-05','13:40:00',1.43),('15529','2014-04-05','13:45:00',1.91),('15529','2014-04-05','13:50:00',1.27),('15529','2014-04-05','13:55:00',1.46),('15529','2014-04-05','14:25:00',1.54),('15529','2014-04-05','14:40:00',1.03),('15529','2014-04-05','14:45:00',1.92),('15529','2014-04-05','14:50:00',1.2),('15529','2014-04-05','15:05:00',1.05),('15529','2014-04-05','15:10:00',1.2),('15529','2014-04-05','15:55:00',1.45),('15529','2014-04-05','16:00:00',1.78),('15529','2014-04-05','16:05:00',2.03),('15529','2014-04-05','16:10:00',2),('15529','2014-04-05','16:40:00',1),('15529','2014-04-05','16:45:00',1.33),('15529','2014-04-05','16:50:00',1.6),('15529','2014-04-05','16:55:00',1.57),('15529','2014-04-05','17:30:00',1),('15529','2013-07-09','08:30:00',1.13),('15529','2013-07-09','08:35:00',1.08),('15529','2013-07-09','08:40:00',1.04),('15529','2013-07-09','08:45:00',1.1),('15529','2013-07-09','08:50:00',1.15),('15529','2013-07-09','08:55:00',1.11),('15529','2013-07-09','09:00:00',1.08),('15529','2013-07-09','09:05:00',1.05),('15529','2013-07-09','09:10:00',1.03),('15529','2013-07-09','09:20:00',1.09),('15529','2013-07-09','09:25:00',1.31),('15529','2013-07-09','09:30:00',1.34),('15529','2013-07-09','09:35:00',1.37),('15529','2013-07-09','09:40:00',1.39),('15529','2013-07-09','09:45:00',1.42),('15529','2013-07-09','09:50:00',1.45),('15529','2013-07-09','09:55:00',1.5),('15529','2013-07-09','10:00:00',1.52),('15529','2013-07-09','10:05:00',1.54),('15529','2013-07-09','10:10:00',1.58),('15529','2013-07-09','10:15:00',1.62),('15529','2013-07-09','10:20:00',1.66),('15529','2013-07-09','10:25:00',1.7),('15529','2013-07-09','10:30:00',1.72),('15529','2013-07-09','10:35:00',1.74),('15529','2013-07-09','10:40:00',1.77),('15529','2013-07-09','10:45:00',1.79),('15529','2013-07-09','10:50:00',1.81),('15529','2013-07-09','10:55:00',1.82),('15529','2013-07-09','11:00:00',1.86),('15529','2013-07-09','11:05:00',1.87),('15529','2013-07-09','11:10:00',1.88),('15529','2013-07-09','11:15:00',1.88),('15529','2013-07-09','11:20:00',1.9),('15529','2013-07-09','11:25:00',1.94),('15529','2013-07-09','11:30:00',1.96),('15529','2013-07-09','11:35:00',2),('15529','2013-07-09','11:40:00',2.02),('15529','2013-07-09','11:45:00',2.02),('15529','2013-07-09','11:50:00',2.02),('15529','2013-07-09','11:55:00',2.05),('15529','2013-07-09','12:00:00',2.05),('15529','2013-07-09','12:05:00',2.08),('15529','2013-07-09','12:10:00',2.08),('15529','2013-07-09','12:15:00',2.12),('15529','2013-07-09','12:20:00',2.12),('15529','2013-07-09','12:25:00',2.15),('15529','2013-07-09','12:30:00',2.18),('15529','2013-07-09','12:35:00',2.15),('15529','2013-07-09','12:40:00',2.16),('15529','2013-07-09','12:45:00',2.16),('15529','2013-07-09','12:50:00',2.2),('15529','2013-07-09','12:55:00',2.17),('15529','2013-07-09','13:00:00',2.19),('15529','2013-07-09','13:05:00',2.19),('15529','2013-07-09','13:10:00',2.22),('15529','2013-07-09','13:15:00',2.24),('15529','2013-07-09','13:20:00',2.22),('15529','2013-07-09','13:25:00',2.22),('15529','2013-07-09','13:30:00',2.21),('15529','2013-07-09','13:35:00',2.23),('15529','2013-07-09','13:40:00',2.24),('15529','2013-07-09','13:45:00',2.22),('15529','2013-07-09','13:50:00',2.2),('15529','2013-07-09','13:55:00',2.21),('15529','2013-07-09','14:00:00',2.21),('15529','2013-07-09','14:05:00',2.17),('15529','2013-07-09','14:10:00',2.16),('15529','2013-07-09','14:15:00',2.15),('15529','2013-07-09','14:20:00',2.17),('15529','2013-07-09','14:25:00',2.14),('15529','2013-07-09','14:30:00',2.09),('15529','2013-07-09','14:35:00',2.1),('15529','2013-07-09','14:40:00',2.11),('15529','2013-07-09','14:45:00',2.1),('15529','2013-07-09','14:50:00',2.08),('15529','2013-07-09','14:55:00',2.05),('15529','2013-07-09','15:00:00',2.04),('15529','2013-07-09','15:05:00',2.02),('15529','2013-07-09','15:10:00',2),('15529','2013-07-09','15:15:00',1.99),('15529','2013-07-09','15:20:00',1.96),('15529','2013-07-09','15:25:00',1.93),('15529','2013-07-09','15:30:00',1.91),('15529','2013-07-09','15:35:00',1.89),('15529','2013-07-09','15:40:00',1.85),('15529','2013-07-09','15:45:00',1.82),('15529','2013-07-09','15:50:00',1.78),('15529','2013-07-09','15:55:00',1.75),('15529','2013-07-09','16:00:00',1.72),('15529','2013-07-09','16:05:00',1.67),('15529','2013-07-09','16:10:00',1.64),('15529','2013-07-09','16:15:00',1.6),('15529','2013-07-09','16:20:00',1.57),('15529','2013-07-09','16:25:00',1.54),('15529','2013-07-09','16:30:00',1.5),('15529','2013-07-09','16:35:00',1.46),('15529','2013-07-09','16:40:00',1.43),('15529','2013-07-09','16:45:00',1.4),('15529','2013-07-09','16:50:00',1.37),('15529','2013-07-09','16:55:00',1.34),('15529','2013-07-09','17:00:00',1.33),('15529','2013-07-09','17:05:00',1.08),('15529','2013-07-08','08:55:00',1.03),('15529','2013-07-08','09:00:00',1.07),('15529','2013-07-08','09:05:00',1.11),('15529','2013-07-08','09:10:00',1.15),('15529','2013-07-08','09:15:00',1.2),('15529','2013-07-08','09:20:00',1.23),('15529','2013-07-08','09:25:00',1.26),('15529','2013-07-08','09:30:00',1.3),('15529','2013-07-08','09:35:00',1.34),('15529','2013-07-08','09:40:00',1.38),('15529','2013-07-08','09:45:00',1.42),('15529','2013-07-08','09:50:00',1.45),('15529','2013-07-08','09:55:00',1.48),('15529','2013-07-08','10:00:00',1.51),('15529','2013-07-08','10:05:00',1.54),('15529','2013-07-08','10:10:00',1.57),('15529','2013-07-08','10:15:00',1.6),('15529','2013-07-08','10:20:00',1.64),('15529','2013-07-08','10:25:00',1.67),('15529','2013-07-08','10:30:00',1.7),('15529','2013-07-08','10:35:00',1.73),('15529','2013-07-08','10:40:00',1.77),('15529','2013-07-08','10:45:00',1.76),('15529','2013-07-08','10:50:00',1.81),('15529','2013-07-08','10:55:00',1.82),('15529','2013-07-08','11:00:00',1.81),('15529','2013-07-08','11:05:00',1.83),('15529','2013-07-08','11:10:00',1.89),('15529','2013-07-08','11:15:00',1.92),('15529','2013-07-08','11:20:00',1.97),('15529','2013-07-08','11:25:00',1.82),('15529','2013-07-08','11:30:00',1.51),('15529','2013-07-08','11:35:00',1.75),('15529','2013-07-08','11:40:00',1.9),('15529','2013-07-08','11:45:00',1.43),('15529','2013-07-08','11:50:00',2.01),('15529','2013-07-08','11:55:00',2.13),('15529','2013-07-08','12:00:00',2.19),('15529','2013-07-08','12:05:00',2.17),('15529','2013-07-08','12:10:00',2.1),('15529','2013-07-08','12:15:00',2.15),('15529','2013-07-08','12:20:00',2.1),('15529','2013-07-08','12:25:00',2.15),('15529','2013-07-08','12:30:00',2.17),('15529','2013-07-08','12:35:00',2.17),('15529','2013-07-08','12:40:00',2.21),('15529','2013-07-08','12:45:00',2.15),('15529','2013-07-08','12:50:00',2.14),('15529','2013-07-08','12:55:00',2.18),('15529','2013-07-08','13:00:00',2.21),('15529','2013-07-08','13:05:00',2.21),('15529','2013-07-08','13:10:00',2.24),('15529','2013-07-08','13:15:00',2.2),('15529','2013-07-08','13:20:00',2.23),('15529','2013-07-08','13:25:00',2.22),('15529','2013-07-08','13:30:00',2.24),('15529','2013-07-08','13:35:00',2.27),('15529','2013-07-08','13:40:00',2.23),('15529','2013-07-08','13:45:00',2.14),('15529','2013-07-08','13:50:00',1.83),('15529','2013-07-08','13:55:00',2),('15529','2013-07-08','14:00:00',1.95),('15529','2013-07-08','14:05:00',1.8),('15529','2013-07-08','14:10:00',1.81),('15529','2013-07-08','14:15:00',1.88),('15529','2013-07-08','14:20:00',1.96),('15529','2013-07-08','14:25:00',1.85),('15529','2013-07-07','08:55:00',1.03),('15529','2013-07-07','09:00:00',1.07),('15529','2013-07-07','09:05:00',1.11),('15529','2013-07-07','09:10:00',1.14),('15529','2013-07-07','09:15:00',1.18),('15529','2013-07-07','09:20:00',1.21),('15529','2013-07-07','09:25:00',1.21),('15529','2013-07-07','09:30:00',1.28),('15529','2013-07-07','09:35:00',1.31),('15529','2013-07-07','09:40:00',1.37),('15529','2013-07-07','09:45:00',1.4),('15529','2013-07-07','09:50:00',1.44),('15529','2013-07-07','09:55:00',1.46),('15529','2013-07-07','10:00:00',1.49),('15529','2013-07-07','10:05:00',1.55),('15529','2013-07-07','10:10:00',1.58),('15529','2013-07-07','10:15:00',1.59),('15529','2013-07-07','10:20:00',1.65),('15529','2013-07-07','10:25:00',1.66),('15529','2013-07-07','10:30:00',1.55),('15529','2013-07-07','10:35:00',1.51),('15529','2013-07-07','10:40:00',1.75),('15529','2013-07-07','10:45:00',1.81),('15529','2013-07-07','10:50:00',1.8),('15529','2013-07-07','10:55:00',1.83),('15529','2013-07-07','11:00:00',1.84),('15529','2013-07-07','11:05:00',1.86),('15529','2013-07-07','11:10:00',1.88),('15529','2013-07-07','11:15:00',1.9),('15529','2013-07-07','11:20:00',1.93),('15529','2013-07-07','11:25:00',1.93),('15529','2013-07-07','11:30:00',2.01),('15529','2013-07-07','11:35:00',2.03),('15529','2013-07-07','11:40:00',1.99),('15529','2013-07-07','11:45:00',1.89),('15529','2013-07-07','11:50:00',2.1),('15529','2013-07-07','11:55:00',2.13),('15529','2013-07-07','12:00:00',2.02),('15529','2013-07-07','12:05:00',1.86),('15529','2013-07-07','12:10:00',1.89),('15529','2013-07-07','12:15:00',2.23),('15529','2013-07-07','12:20:00',1.25),('15529','2013-07-07','12:25:00',1.85),('15529','2013-07-07','12:30:00',2.07),('15529','2013-07-07','12:35:00',2.09),('15529','2013-07-07','12:40:00',2.18),('15529','2013-07-07','12:45:00',2.2),('15529','2013-07-07','12:50:00',2.15),('15529','2013-07-07','12:55:00',2.12),('15529','2013-07-07','13:00:00',2.17),('15529','2013-07-07','13:05:00',2.2),('15529','2013-07-07','13:10:00',2.24),('15529','2013-07-07','13:15:00',1.58),('15529','2013-07-07','13:20:00',2),('15529','2013-07-06','08:55:00',1.02),('15529','2013-07-06','09:00:00',1.19),('15529','2013-07-06','09:05:00',1.25),('15529','2013-07-06','09:10:00',1.23),('15529','2013-07-06','09:15:00',1.05),('15529','2013-07-06','09:20:00',1.09),('15529','2013-07-06','09:25:00',1.09),('15529','2013-07-06','09:30:00',1.1),('15529','2013-07-06','09:35:00',1.4),('15529','2013-07-06','09:40:00',1.41),('15529','2013-07-06','09:45:00',1.37),('15529','2013-07-06','09:50:00',1.55),('15529','2013-07-06','09:55:00',1.66),('15529','2013-07-06','10:00:00',1.66),('15529','2013-07-06','10:05:00',1.62),('15529','2013-07-06','10:10:00',1.47),('15529','2013-07-06','10:15:00',1.62),('15529','2013-07-06','10:20:00',1.54),('15529','2013-07-06','10:25:00',1.76),('15529','2013-07-06','10:30:00',1.68),('15529','2013-07-06','10:35:00',1.57),('15529','2013-07-06','10:40:00',1.84),('15529','2013-07-06','10:45:00',1.8),('15529','2013-07-06','10:50:00',1.9),('15529','2013-07-06','10:55:00',1.93),('15529','2013-07-06','11:00:00',1.93),('15529','2013-07-06','11:05:00',1.93),('15529','2013-07-06','11:10:00',1.97),('15529','2013-07-06','11:15:00',1.98),('15529','2013-07-06','11:20:00',1.83),('15529','2013-07-06','11:25:00',1.87),('15529','2013-07-06','11:30:00',1.8),('15529','2013-07-06','11:35:00',1.81),('15529','2013-07-06','11:40:00',1.8),('15529','2013-07-06','11:45:00',1.55),('15529','2013-07-06','11:50:00',1.79),('15529','2013-07-06','11:55:00',1.42),('15529','2013-07-06','12:00:00',1.28),('15529','2013-07-06','12:05:00',1.67),('15529','2013-07-06','12:10:00',2.01),('15529','2013-07-06','12:15:00',2.12),('15529','2013-07-06','12:20:00',2.12),('15529','2013-07-06','12:25:00',1.91),('15529','2013-07-06','12:30:00',1.93),('15529','2013-07-06','12:35:00',2.05),('15529','2013-07-06','12:40:00',2.18),('15529','2013-07-06','12:45:00',2.26),('15529','2013-07-06','12:50:00',2.23),('15529','2013-07-06','12:55:00',2.17),('15529','2013-07-06','13:00:00',2.27),('15529','2013-07-06','13:05:00',2.1),('15529','2013-07-06','13:10:00',2.22),('15529','2013-07-06','13:15:00',2.28),('15529','2013-07-06','13:20:00',2.24),('15529','2013-07-06','13:25:00',2.25),('15529','2013-07-06','13:30:00',2.15),('15529','2013-07-06','13:50:00',1.19),('15529','2013-07-06','13:55:00',2.15),('15529','2013-07-06','14:00:00',2.26),('15529','2013-07-05','08:55:00',1.04),('15529','2013-07-05','09:00:00',1.08),('15529','2013-07-05','09:05:00',1.12),('15529','2013-07-05','09:10:00',1.17),('15529','2013-07-05','09:15:00',1.2),('15529','2013-07-05','09:20:00',1.24),('15529','2013-07-05','09:25:00',1.28),('15529','2013-07-05','09:30:00',1.32),('15529','2013-07-05','09:35:00',1.35),('15529','2013-07-05','09:40:00',1.39),('15529','2013-07-05','09:45:00',1.44),('15529','2013-07-05','09:50:00',1.46),('15529','2013-07-05','09:55:00',1.49),('15529','2013-07-05','10:00:00',1.53),('15529','2013-07-05','10:05:00',1.57),('15529','2013-07-05','10:10:00',1.6),('15529','2013-07-05','10:15:00',1.64),('15529','2013-07-05','10:20:00',1.67),('15529','2013-07-05','10:25:00',1.67),('15529','2013-07-05','10:30:00',1.71),('15529','2013-07-05','10:35:00',1.74),('15529','2013-07-05','10:40:00',1.76),('15529','2013-07-05','10:45:00',1.79),('15529','2013-07-05','10:50:00',1.83),('15529','2013-07-05','10:55:00',1.85),('15529','2013-07-05','11:00:00',1.88),('15529','2013-07-05','11:05:00',1.92),('15529','2013-07-05','11:10:00',1.9),('15529','2013-07-05','11:15:00',1.96),('15529','2013-07-05','11:20:00',1.93),('15529','2013-07-05','11:25:00',1.94),('15529','2013-07-05','11:30:00',2),('15529','2013-07-05','11:35:00',1.96),('15529','2013-07-05','11:40:00',2.02),('15529','2013-07-05','11:45:00',2.01),('15529','2013-07-05','11:50:00',2.02),('15529','2013-07-05','11:55:00',2.06),('15529','2013-07-05','12:00:00',2.06),('15529','2013-07-05','12:05:00',2.05),('15529','2013-07-05','12:10:00',2.09),('15529','2013-07-05','12:15:00',2.11),('15529','2013-07-05','12:20:00',2.08),('15529','2013-07-05','12:25:00',2.16),('15529','2013-07-05','12:30:00',2.16),('15529','2013-07-05','12:35:00',2.2),('15529','2013-07-05','12:40:00',2.13),('15529','2013-07-05','12:45:00',2.15),('15529','2013-07-05','12:50:00',2.14),('15529','2013-07-05','12:55:00',2.16),('15529','2013-07-05','13:00:00',2.14),('15529','2013-07-05','13:05:00',2.15),('15529','2013-07-05','13:10:00',2.18),('15529','2013-07-05','13:15:00',2.17),('15529','2013-07-05','13:20:00',2.01),('15529','2013-07-05','13:25:00',2.18),('15529','2013-07-05','13:30:00',2.2),('15529','2013-07-05','13:35:00',2.18),('15529','2013-07-05','13:40:00',2.21),('15529','2013-07-05','13:45:00',2.19),('15529','2013-07-05','13:50:00',2.2),('15529','2013-07-05','13:55:00',2.2),('15529','2013-07-05','14:00:00',2.15),('15529','2013-07-05','14:05:00',2.11),('15529','2013-07-05','14:10:00',2.09),('15529','2013-07-05','14:15:00',2.15),('15529','2013-07-05','14:20:00',2.18),('15529','2013-07-05','14:25:00',2.1),('15529','2013-07-05','14:30:00',2.1),('15529','2013-07-05','14:35:00',2.04),('15529','2013-07-05','14:40:00',1.97),('15529','2013-07-05','14:45:00',1.94),('15529','2013-07-05','14:50:00',1.61),('15529','2013-07-05','14:55:00',2.12),('15529','2013-07-05','15:00:00',1.94),('15529','2013-07-05','15:05:00',2.1),('15529','2013-07-05','15:10:00',2.03),('15529','2013-07-05','15:15:00',1.95),('15529','2013-07-05','15:20:00',1.96),('15529','2013-07-05','15:25:00',1.95),('15529','2013-07-05','15:30:00',1.68),('15529','2013-07-05','17:15:00',1.31),('15529','2013-07-05','17:20:00',1.12),('15529','2013-07-04','08:50:00',1.01),('15529','2013-07-04','08:55:00',1.05),('15529','2013-07-04','09:00:00',1.09),('15529','2013-07-04','09:05:00',1.14),('15529','2013-07-04','09:10:00',1.2),('15529','2013-07-04','09:15:00',1.24),('15529','2013-07-04','09:20:00',1.28),('15529','2013-07-04','09:25:00',1.31),('15529','2013-07-04','09:30:00',1.34),('15529','2013-07-04','09:35:00',1.37),('15529','2013-07-04','09:40:00',1.4),('15529','2013-07-04','09:45:00',1.45),('15529','2013-07-04','09:50:00',1.48),('15529','2013-07-04','09:55:00',1.51),('15529','2013-07-04','10:00:00',1.54),('15529','2013-07-04','10:05:00',1.58),('15529','2013-07-04','10:10:00',1.62),('15529','2013-07-04','10:15:00',1.64),('15529','2013-07-04','10:20:00',1.66),('15529','2013-07-04','10:25:00',1.69),('15529','2013-07-04','10:30:00',1.72),('15529','2013-07-04','10:35:00',1.74),('15529','2013-07-04','10:40:00',1.76),('15529','2013-07-04','10:45:00',1.8),('15529','2013-07-04','10:50:00',1.81),('15529','2013-07-04','10:55:00',1.83),('15529','2013-07-04','11:00:00',1.87),('15529','2013-07-04','11:05:00',1.89),('15529','2013-07-04','11:10:00',1.88),('15529','2013-07-04','11:15:00',1.92),('15529','2013-07-04','11:20:00',1.98),('15529','2013-07-04','11:25:00',1.96),('15529','2013-07-04','11:30:00',1.97),('15529','2013-07-04','11:35:00',1.97),('15529','2013-07-04','11:40:00',2),('15529','2013-07-04','11:45:00',2),('15529','2013-07-04','11:50:00',1.99),('15529','2013-07-04','11:55:00',2),('15529','2013-07-04','12:00:00',2.03),('15529','2013-07-04','12:05:00',2.03),('15529','2013-07-04','12:10:00',2.05),('15529','2013-07-04','12:15:00',2.1),('15529','2013-07-04','12:20:00',2.1),('15529','2013-07-04','12:25:00',2.19),('15529','2013-07-04','12:30:00',2.21),('15529','2013-07-04','12:35:00',2.12),('15529','2013-07-04','12:40:00',2.08),('15529','2013-07-04','12:45:00',2.2),('15529','2013-07-04','12:50:00',2.18),('15529','2013-07-04','12:55:00',2.18),('15529','2013-07-04','13:00:00',2.29),('15529','2013-07-04','13:05:00',2.28),('15529','2013-07-04','13:10:00',2.33),('15529','2013-07-04','13:15:00',2.26),('15529','2013-07-04','13:20:00',1.15),('15529','2013-07-04','13:25:00',1.39),('15529','2013-07-04','13:30:00',1.61),('15529','2013-07-04','13:35:00',2.14),('15529','2013-07-04','13:40:00',2.13),('15529','2013-07-04','13:45:00',2.12),('15529','2013-07-04','13:50:00',2.11),('15529','2013-07-04','13:55:00',2.1),('15529','2013-07-04','14:00:00',2.09),('15529','2013-07-04','14:05:00',2.08),('15529','2013-07-04','14:10:00',1.74),('15529','2013-07-04','14:15:00',2.06),('15529','2013-07-04','14:20:00',2.06),('15529','2013-07-04','14:25:00',2.02),('15529','2013-07-04','14:30:00',2.02),('15529','2013-07-04','14:35:00',2.02),('15529','2013-07-04','14:40:00',1.85),('15529','2013-07-04','14:45:00',1.98),('15529','2013-07-04','14:50:00',1.98),('15529','2013-07-04','14:55:00',1.95),('15529','2013-07-04','15:00:00',1.93),('15529','2013-07-04','15:05:00',1.97),('15529','2013-07-04','15:10:00',1.92),('15529','2013-07-04','15:15:00',1.91),('15529','2013-07-04','15:20:00',1.89),('15529','2013-07-04','15:25:00',1.86),('15529','2013-07-04','15:30:00',1.86),('15529','2013-07-04','15:35:00',1.81),('15529','2013-07-04','15:40:00',1.77),('15529','2013-07-04','15:45:00',1.69),('15529','2013-07-04','15:50:00',1.74),('15529','2013-07-04','15:55:00',1.7),('15529','2013-07-04','16:00:00',1.65),('15529','2013-07-04','16:05:00',1.62),('15529','2013-07-04','16:10:00',1.6),('15529','2013-07-04','16:15:00',1.57),('15529','2013-07-04','16:20:00',1.54),('15529','2013-07-04','16:25:00',1.51),('15529','2013-07-04','16:30:00',1.48),('15529','2013-07-04','16:35:00',1.45),('15529','2013-07-04','16:40:00',1.4),('15529','2013-07-04','16:45:00',1.36),('15529','2013-07-04','16:50:00',1.33),('15529','2013-07-04','16:55:00',1.27),('15529','2013-07-04','17:00:00',1.21),('15529','2013-07-04','17:05:00',1.19),('15529','2013-07-04','17:10:00',1.16),('15529','2013-07-04','17:15:00',1.08),('15529','2013-07-03','12:05:00',1.08),('15529','2013-07-03','12:10:00',1.29),('15529','2013-07-03','12:15:00',1.01),('15529','2013-07-03','13:10:00',1.33),('15529','2013-07-03','13:15:00',2.08),('15529','2013-07-03','13:20:00',1.23),('15529','2013-07-03','13:25:00',1.54),('15529','2013-07-03','13:30:00',1.43),('15529','2013-07-03','13:35:00',1.69),('15529','2013-07-03','13:40:00',2.52),('15529','2013-07-03','13:45:00',2.49),('15529','2013-07-03','13:50:00',2.4),('15529','2013-07-03','13:55:00',1.63),('15529','2013-07-03','14:00:00',1.53),('15529','2013-07-03','14:05:00',1.27),('15529','2013-07-03','14:10:00',1.24),('15529','2013-07-03','14:15:00',1.05),('15529','2013-07-03','14:25:00',1),('15529','2013-07-03','14:35:00',1.02),('15529','2013-07-03','14:40:00',1.05),('15529','2013-07-03','14:45:00',1.18),('15529','2013-07-03','14:50:00',1.12),('15529','2013-07-03','14:55:00',1.67),('15529','2013-07-03','15:00:00',1.22),('15529','2013-07-03','15:05:00',1.01),('15529','2013-07-03','15:10:00',1.47),('15529','2013-07-03','15:15:00',1.44),('15529','2013-07-03','15:20:00',1.81),('15529','2013-07-03','15:25:00',1.18),('15529','2013-07-03','15:30:00',1.01),('15529','2013-07-03','15:35:00',1.41),('15529','2013-07-03','15:40:00',1.23),('15529','2013-07-03','15:45:00',1.31),('15529','2013-07-03','15:50:00',1.24),('15529','2013-07-03','15:55:00',1.09),('15529','2013-07-03','16:00:00',1.11),('15529','2013-07-03','16:05:00',1.16),('15529','2013-07-03','16:20:00',1.01),('15529','2013-07-03','16:25:00',1.11),('15529','2013-07-03','17:30:00',1.09),('15529','2013-07-03','17:35:00',1.17),('15529','2013-07-03','17:40:00',1.07),('15529','2013-07-03','17:45:00',1.01),('15529','2013-07-02','08:45:00',1),('15529','2013-07-02','08:50:00',1.05),('15529','2013-07-02','08:55:00',1.1),('15529','2013-07-02','09:00:00',1.14),('15529','2013-07-02','09:05:00',1.18),('15529','2013-07-02','09:10:00',1.21),('15529','2013-07-02','09:15:00',1.25),('15529','2013-07-02','09:20:00',1.29),('15529','2013-07-02','09:25:00',1.33),('15529','2013-07-02','09:30:00',1.36),('15529','2013-07-02','09:35:00',1.4),('15529','2013-07-02','09:40:00',1.42),('15529','2013-07-02','09:45:00',1.44),('15529','2013-07-02','09:50:00',1.48),('15529','2013-07-02','09:55:00',1.53),('15529','2013-07-02','10:00:00',1.53),('15529','2013-07-02','10:05:00',1.57),('15529','2013-07-02','10:10:00',1.61),('15529','2013-07-02','10:15:00',1.65),('15529','2013-07-02','10:20:00',1.65),('15529','2013-07-02','10:25:00',1.68),('15529','2013-07-02','10:30:00',1.77),('15529','2013-07-02','10:35:00',1.8),('15529','2013-07-02','10:40:00',1.82),('15529','2013-07-02','10:45:00',1.85),('15529','2013-07-02','10:50:00',1.86),('15529','2013-07-02','10:55:00',1.87),('15529','2013-07-02','11:00:00',1.89),('15529','2013-07-02','11:05:00',1.9),('15529','2013-07-02','11:10:00',1.9),('15529','2013-07-02','11:15:00',1.92),('15529','2013-07-02','11:20:00',1.96),('15529','2013-07-02','11:25:00',2),('15529','2013-07-02','11:30:00',2.02),('15529','2013-07-02','11:35:00',2.04),('15529','2013-07-02','11:40:00',2.06),('15529','2013-07-02','11:45:00',2.09),('15529','2013-07-02','11:50:00',2.11),('15529','2013-07-02','11:55:00',2.13),('15529','2013-07-02','12:00:00',2.13),('15529','2013-07-02','12:05:00',2.15),('15529','2013-07-02','12:10:00',2.17),('15529','2013-07-02','12:15:00',2.16),('15529','2013-07-02','12:20:00',2.21),('15529','2013-07-02','12:25:00',2.19),('15529','2013-07-02','12:30:00',2.2),('15529','2013-07-02','12:35:00',2.18),('15529','2013-07-02','12:40:00',2.22),('15529','2013-07-02','12:45:00',2.22),('15529','2013-07-02','12:50:00',2.24),('15529','2013-07-02','12:55:00',2.26),('15529','2013-07-02','13:00:00',2.25),('15529','2013-07-02','13:05:00',2.21),('15529','2013-07-02','13:10:00',2.24),('15529','2013-07-02','13:15:00',2.27),('15529','2013-07-02','13:20:00',2.28),('15529','2013-07-02','13:25:00',2.26),('15529','2013-07-02','13:30:00',2.26),('15529','2013-07-02','13:35:00',2.26),('15529','2013-07-02','13:40:00',2.27),('15529','2013-07-02','13:45:00',2.22),('15529','2013-07-02','13:50:00',2.21),('15529','2013-07-02','13:55:00',2.26),('15529','2013-07-02','14:00:00',2.19),('15529','2013-07-02','14:05:00',2.22),('15529','2013-07-02','14:10:00',2.23),('15529','2013-07-02','14:15:00',2.2),('15529','2013-07-02','14:20:00',2.18),('15529','2013-07-02','14:25:00',2.19),('15529','2013-07-02','14:30:00',2.16),('15529','2013-07-02','14:35:00',2.16),('15529','2013-07-02','14:40:00',2.13),('15529','2013-07-02','14:45:00',2.05),('15529','2013-07-02','14:50:00',2.09),('15529','2013-07-02','14:55:00',2.09),('15529','2013-07-02','15:00:00',2.05),('15529','2013-07-02','15:05:00',2.03),('15529','2013-07-02','15:10:00',2.02),('15529','2013-07-02','15:15:00',2.01),('15529','2013-07-02','15:20:00',1.99),('15529','2013-07-02','15:25:00',1.96),('15529','2013-07-02','15:30:00',1.93),('15529','2013-07-02','15:35:00',1.9),('15529','2013-07-02','15:40:00',1.89),('15529','2013-07-02','15:45:00',1.86),('15529','2013-07-02','15:50:00',1.82),('15529','2013-07-02','15:55:00',1.79),('15529','2013-07-02','16:00:00',1.74),('15529','2013-07-02','16:05:00',1.72),('15529','2013-07-02','16:10:00',1.69),('15529','2013-07-02','16:15:00',1.66),('15529','2013-07-02','16:20:00',1.63),('15529','2013-07-02','16:25:00',1.59),('15529','2013-07-02','16:30:00',1.56),('15529','2013-07-02','16:35:00',1.53),('15529','2013-07-02','16:40:00',1.51),('15529','2013-07-02','16:45:00',1.47),('15529','2013-07-02','16:50:00',1.41),('15529','2013-07-02','16:55:00',1.38),('15529','2013-07-02','17:00:00',1.34),('15529','2013-07-02','17:05:00',1.29),('15529','2013-07-02','17:10:00',1.25),('15529','2013-07-02','17:15:00',1.21),('15529','2013-07-02','17:20:00',1.17),('15529','2013-07-02','17:25:00',1.12),('15529','2013-07-02','17:30:00',1.08),('15529','2013-07-02','17:35:00',1.04),('15529','2013-07-01','08:50:00',1.04),('15529','2013-07-01','08:55:00',1.08),('15529','2013-07-01','09:00:00',1.12),('15529','2013-07-01','09:05:00',1.15),('15529','2013-07-01','09:10:00',1.19),('15529','2013-07-01','09:15:00',1.24),('15529','2013-07-01','09:20:00',1.27),('15529','2013-07-01','09:25:00',1.3),('15529','2013-07-01','09:30:00',1.34),('15529','2013-07-01','09:35:00',1.38),('15529','2013-07-01','09:40:00',1.41),('15529','2013-07-01','09:45:00',1.44),('15529','2013-07-01','09:50:00',1.46),('15529','2013-07-01','09:55:00',1.5),('15529','2013-07-01','10:00:00',1.53),('15529','2013-07-01','10:05:00',1.57),('15529','2013-07-01','10:10:00',1.62),('15529','2013-07-01','10:15:00',1.64),('15529','2013-07-01','10:20:00',1.67),('15529','2013-07-01','10:25:00',1.7),('15529','2013-07-01','10:30:00',1.71),('15529','2013-07-01','10:35:00',1.73),('15529','2013-07-01','10:40:00',1.75),('15529','2013-07-01','10:45:00',1.78),('15529','2013-07-01','10:50:00',1.79),('15529','2013-07-01','10:55:00',1.82),('15529','2013-07-01','11:00:00',1.83),('15529','2013-07-01','11:05:00',1.86),('15529','2013-07-01','11:10:00',1.9),('15529','2013-07-01','11:15:00',1.9),('15529','2013-07-01','11:20:00',1.94),('15529','2013-07-01','11:25:00',1.96),('15529','2013-07-01','11:30:00',1.95),('15529','2013-07-01','11:35:00',2),('15529','2013-07-01','11:40:00',2.01),('15529','2013-07-01','11:45:00',2.05),('15529','2013-07-01','11:50:00',2.04),('15529','2013-07-01','11:55:00',2.03),('15529','2013-07-01','12:00:00',2.01),('15529','2013-07-01','12:05:00',2.06),('15529','2013-07-01','12:10:00',2.11),('15529','2013-07-01','12:15:00',2.15),('15529','2013-07-01','12:20:00',2.13),('15529','2013-07-01','12:25:00',2.16),('15529','2013-07-01','12:30:00',2.26),('15529','2013-07-01','12:35:00',2.28),('15529','2013-07-01','12:40:00',2.27),('15529','2013-07-01','12:50:00',1.31),('15529','2013-07-01','12:55:00',1.97),('15529','2013-07-01','13:00:00',2.31),('15529','2013-07-01','13:05:00',2.26),('15529','2013-07-01','13:10:00',2.23),('15529','2013-07-01','13:15:00',2.22),('15529','2013-07-01','13:20:00',2.19),('15529','2013-07-01','13:25:00',2.17),('15529','2013-07-01','13:30:00',2.21),('15529','2013-07-01','13:35:00',2.15),('15529','2013-07-01','13:40:00',2.19),('15529','2013-07-01','13:45:00',2.18),('15529','2013-07-01','13:50:00',2.19),('15529','2013-07-01','13:55:00',2.19),('15529','2013-07-01','14:00:00',2.17),('15529','2013-07-01','14:05:00',2.15),('15529','2013-07-01','14:10:00',2.12),('15529','2013-07-01','14:15:00',2.14),('15529','2013-07-01','14:20:00',2.12),('15529','2013-07-01','14:25:00',2.12),('15529','2013-07-01','14:30:00',2.11),('15529','2013-07-01','14:35:00',2.07),('15529','2013-07-01','14:40:00',2.05),('15529','2013-07-01','14:45:00',2.05),('15529','2013-07-01','14:50:00',2.05),('15529','2013-07-01','14:55:00',2.03),('15529','2013-07-01','15:00:00',2),('15529','2013-07-01','15:05:00',1.99),('15529','2013-07-01','15:10:00',1.97),('15529','2013-07-01','15:15:00',1.95),('15529','2013-07-01','15:20:00',1.92),('15529','2013-07-01','15:25:00',1.89),('15529','2013-07-01','15:30:00',1.87),('15529','2013-07-01','15:35:00',1.84),('15529','2013-07-01','15:40:00',1.82),('15529','2013-07-01','15:45:00',1.8),('15529','2013-07-01','15:50:00',1.78),('15529','2013-07-01','15:55:00',1.75),('15529','2013-07-01','16:00:00',1.72),('15529','2013-07-01','16:05:00',1.69),('15529','2013-07-01','16:10:00',1.64),('15529','2013-07-01','16:15:00',1.58),('15529','2013-07-01','16:20:00',1.57),('15529','2013-07-01','16:25:00',1.56),('15529','2013-07-01','16:30:00',1.53),('15529','2013-07-01','16:35:00',1.48),('15529','2013-07-01','16:40:00',1.44),('15529','2013-07-01','16:45:00',1.4),('15529','2013-07-01','16:50:00',1.35),('15529','2013-07-01','16:55:00',1.33),('15529','2013-07-01','17:00:00',1.29),('15529','2013-07-01','17:05:00',1.25),('15529','2013-07-01','17:10:00',1.2),('15529','2013-07-01','17:15:00',1.17),('15529','2013-07-01','17:20:00',1.12),('15529','2013-07-01','17:25:00',1.08),('15529','2013-07-01','17:30:00',1.03),('15529','2013-06-30','08:45:00',1.01),('15529','2013-06-30','08:50:00',1.05),('15529','2013-06-30','08:55:00',1.1),('15529','2013-06-30','09:00:00',1.15),('15529','2013-06-30','09:05:00',1.19),('15529','2013-06-30','09:10:00',1.23),('15529','2013-06-30','09:15:00',1.27),('15529','2013-06-30','09:20:00',1.31),('15529','2013-06-30','09:25:00',1.36),('15529','2013-06-30','09:30:00',1.4),('15529','2013-06-30','09:35:00',1.44),('15529','2013-06-30','09:40:00',1.46),('15529','2013-06-30','09:45:00',1.49),('15529','2013-06-30','09:50:00',1.54),('15529','2013-06-30','09:55:00',1.55),('15529','2013-06-30','10:00:00',1.6),('15529','2013-06-30','10:05:00',1.61),('15529','2013-06-30','10:10:00',1.66),('15529','2013-06-30','10:15:00',1.69),('15529','2013-06-30','10:20:00',1.72),('15529','2013-06-30','10:25:00',1.76),('15529','2013-06-30','10:30:00',1.8),('15529','2013-06-30','10:35:00',1.83),('15529','2013-06-30','10:40:00',1.85),('15529','2013-06-30','10:45:00',1.88),('15529','2013-06-30','10:50:00',1.9),('15529','2013-06-30','10:55:00',1.91),('15529','2013-06-30','11:00:00',1.93),('15529','2013-06-30','11:05:00',1.95),('15529','2013-06-30','11:10:00',2.01),('15529','2013-06-30','11:15:00',2.01),('15529','2013-06-30','11:20:00',2.03),('15529','2013-06-30','11:25:00',2.07),('15529','2013-06-30','11:30:00',2.07),('15529','2013-06-30','11:35:00',2.09),('15529','2013-06-30','11:40:00',2.13),('15529','2013-06-30','11:45:00',2.1),('15529','2013-06-30','11:50:00',2.12),('15529','2013-06-30','11:55:00',2.15),('15529','2013-06-30','12:00:00',2.17),('15529','2013-06-30','12:05:00',2.17),('15529','2013-06-30','12:10:00',2.16),('15529','2013-06-30','12:15:00',2.18),('15529','2013-06-30','12:20:00',2.16),('15529','2013-06-30','12:25:00',2.2),('15529','2013-06-30','12:30:00',2.18),('15529','2013-06-30','12:35:00',2.18),('15529','2013-06-30','12:40:00',2.21),('15529','2013-06-30','12:45:00',2.23),('15529','2013-06-30','12:50:00',2.24),('15529','2013-06-30','12:55:00',2.22),('15529','2013-06-30','13:00:00',2.23),('15529','2013-06-30','13:05:00',2.21),('15529','2013-06-30','13:10:00',2.25),('15529','2013-06-30','13:15:00',2.24),('15529','2013-06-30','13:20:00',2.26),('15529','2013-06-30','13:25:00',2.24),('15529','2013-06-30','13:30:00',2.21),('15529','2013-06-30','13:35:00',2.23),('15529','2013-06-30','13:40:00',2.2),('15529','2013-06-30','13:45:00',2.21),('15529','2013-06-30','13:50:00',2.23),('15529','2013-06-30','13:55:00',2.22),('15529','2013-06-30','14:00:00',2.23),('15529','2013-06-30','14:05:00',2.21),('15529','2013-06-30','14:10:00',2.17),('15529','2013-06-30','14:15:00',2.18),('15529','2013-06-30','14:20:00',2.18),('15529','2013-06-30','14:25:00',2.15),('15529','2013-06-30','14:30:00',2.13),('15529','2013-06-30','14:35:00',2.12),('15529','2013-06-30','14:40:00',2.12),('15529','2013-06-30','14:45:00',2.11),('15529','2013-06-30','14:50:00',2.07),('15529','2013-06-30','14:55:00',2.03),('15529','2013-06-30','15:00:00',1.99),('15529','2013-06-30','15:05:00',2),('15529','2013-06-30','15:10:00',1.97),('15529','2013-06-30','15:15:00',1.94),('15529','2013-06-30','15:20:00',1.92),('15529','2013-06-30','15:25:00',1.89),('15529','2013-06-30','15:30:00',1.87),('15529','2013-06-30','15:35:00',1.84),('15529','2013-06-30','15:40:00',1.83),('15529','2013-06-30','15:45:00',1.79),('15529','2013-06-30','15:50:00',1.77),('15529','2013-06-30','15:55:00',1.73),('15529','2013-06-30','16:00:00',1.69),('15529','2013-06-30','16:05:00',1.67),('15529','2013-06-30','16:10:00',1.63),('15529','2013-06-30','16:15:00',1.59),('15529','2013-06-30','16:20:00',1.54),('15529','2013-06-30','16:25:00',1.51),('15529','2013-06-30','16:30:00',1.48),('15529','2013-06-30','16:35:00',1.45),('15529','2013-06-30','16:40:00',1.4),('15529','2013-06-30','16:45:00',1.37),('15529','2013-06-30','16:50:00',1.34),('15529','2013-06-30','16:55:00',1.32),('15529','2013-06-30','17:00:00',1.29),('15529','2013-06-30','17:05:00',1.25),('15529','2013-06-30','17:10:00',1.21),('15529','2013-06-30','17:15:00',1.16),('15529','2013-06-30','17:20:00',1.11),('15529','2013-06-30','17:25:00',1.06),('15529','2013-06-30','17:30:00',1.03),('15529','2014-04-04','09:40:00',1.33),('15529','2014-04-04','09:45:00',1.8),('15529','2014-04-04','09:50:00',1.15),('15529','2014-04-04','09:55:00',1.12),('15529','2014-04-04','10:00:00',1.04),('15529','2014-04-04','10:20:00',1.12),('15529','2014-04-04','10:25:00',1.76),('15529','2014-04-04','10:30:00',1.66),('15529','2014-04-04','10:35:00',1.57),('15529','2014-04-04','10:40:00',1.53),('15529','2014-04-04','10:45:00',1.52),('15529','2014-04-04','10:50:00',1.63),('15529','2014-04-04','10:55:00',1.88),('15529','2014-04-04','11:00:00',1.43),('15529','2014-04-04','11:05:00',1.48),('15529','2014-04-04','11:10:00',1.85),('15529','2014-04-04','11:15:00',1.96),('15529','2014-04-04','11:20:00',1.97),('15529','2014-04-04','11:25:00',2.26),('15529','2014-04-04','11:30:00',2.16),('15529','2014-04-04','11:35:00',1.77),('15529','2014-04-04','11:40:00',1.49),('15529','2014-04-04','11:45:00',1.12),('15529','2014-04-04','11:50:00',1.43),('15529','2014-04-04','11:55:00',1.93),('15529','2014-04-04','12:00:00',2.01),('15529','2014-04-04','12:05:00',2.13),('15529','2014-04-04','12:10:00',2.23),('15529','2014-04-04','12:15:00',1.71),('15529','2014-04-04','12:20:00',1.81),('15529','2014-04-04','12:25:00',2.04),('15529','2014-04-04','12:30:00',1.77),('15529','2014-04-04','12:35:00',1.82),('15529','2014-04-04','12:40:00',1.63),('15529','2014-04-04','12:45:00',1.87),('15529','2014-04-04','12:50:00',2.27),('15529','2014-04-04','12:55:00',2.25),('15529','2014-04-04','13:00:00',1.1),('15529','2014-04-04','13:05:00',1.46),('15529','2014-04-04','13:10:00',1.3),('15529','2014-04-04','13:15:00',1.01),('15529','2014-04-04','13:20:00',1.18),('15529','2014-04-04','13:25:00',1.84),('15529','2014-04-04','13:30:00',1.57),('15529','2014-04-04','13:35:00',2.04),('15529','2014-04-04','13:40:00',2.16),('15529','2014-04-04','13:45:00',2.59),('15529','2014-04-04','13:50:00',2.56),('15529','2014-04-04','13:55:00',2.48),('15529','2014-04-04','14:00:00',2.56),('15529','2014-04-04','14:05:00',2.08),('15529','2014-04-04','14:10:00',1.69),('15529','2014-04-04','15:00:00',2.23),('15529','2014-04-04','15:05:00',2.25),('15529','2014-04-04','15:10:00',2.29),('15529','2014-04-04','15:15:00',2.28),('15529','2014-04-04','15:20:00',1.64),('15529','2014-04-04','15:25:00',1.96),('15529','2014-04-04','15:50:00',1.25),('15529','2014-04-04','16:20:00',1.7),('15529','2014-04-04','16:25:00',2.02),('15529','2014-04-04','16:30:00',1.66),('15529','2014-04-04','16:45:00',1.25),('15529','2014-04-04','16:50:00',1.74),('15529','2014-04-04','16:55:00',1.23),('15529','2014-04-04','17:05:00',1.26),('15529','2013-06-29','08:40:00',1),('15529','2013-06-29','08:45:00',1.05),('15529','2013-06-29','08:50:00',1.1),('15529','2013-06-29','08:55:00',1.14),('15529','2013-06-29','09:00:00',1.18),('15529','2013-06-29','09:05:00',1.23),('15529','2013-06-29','09:10:00',1.26),('15529','2013-06-29','09:15:00',1.3),('15529','2013-06-29','09:20:00',1.35),('15529','2013-06-29','09:25:00',1.38),('15529','2013-06-29','09:30:00',1.42),('15529','2013-06-29','09:35:00',1.46),('15529','2013-06-29','09:40:00',1.5),('15529','2013-06-29','09:45:00',1.53),('15529','2013-06-29','09:50:00',1.57),('15529','2013-06-29','09:55:00',1.61),('15529','2013-06-29','10:00:00',1.64),('15529','2013-06-29','10:05:00',1.67),('15529','2013-06-29','10:10:00',1.7),('15529','2013-06-29','10:15:00',1.74),('15529','2013-06-29','10:20:00',1.76),('15529','2013-06-29','10:25:00',1.79),('15529','2013-06-29','10:30:00',1.84),('15529','2013-06-29','10:35:00',1.85),('15529','2013-06-29','10:40:00',1.86),('15529','2013-06-29','10:45:00',1.89),('15529','2013-06-29','10:50:00',1.94),('15529','2013-06-29','10:55:00',1.96),('15529','2013-06-29','11:00:00',1.99),('15529','2013-06-29','11:05:00',2.01),('15529','2013-06-29','11:10:00',2.03),('15529','2013-06-29','11:15:00',2.05),('15529','2013-06-29','11:20:00',2.06),('15529','2013-06-29','11:25:00',2.09),('15529','2013-06-29','11:30:00',2.11),('15529','2013-06-29','11:35:00',2.13),('15529','2013-06-29','11:40:00',2.15),('15529','2013-06-29','11:45:00',2.17),('15529','2013-06-29','11:50:00',2.17),('15529','2013-06-29','11:55:00',2.16),('15529','2013-06-29','12:00:00',2.19),('15529','2013-06-29','12:05:00',2.24),('15529','2013-06-29','12:10:00',2.26),('15529','2013-06-29','12:15:00',2.23),('15529','2013-06-29','12:20:00',2.21),('15529','2013-06-29','12:25:00',2.23),('15529','2013-06-29','12:30:00',2.27),('15529','2013-06-29','12:35:00',2.24),('15529','2013-06-29','12:40:00',2.26),('15529','2013-06-29','12:45:00',2.26),('15529','2013-06-29','12:50:00',2.26),('15529','2013-06-29','12:55:00',2.26),('15529','2013-06-29','13:00:00',2.27),('15529','2013-06-29','13:05:00',2.34),('15529','2013-06-29','13:10:00',2.3),('15529','2013-06-29','13:15:00',2.31),('15529','2013-06-29','13:20:00',2.31),('15529','2013-06-29','13:25:00',2.31),('15529','2013-06-29','13:30:00',2.3),('15529','2013-06-29','13:35:00',2.28),('15529','2013-06-29','13:40:00',2.27),('15529','2013-06-29','13:45:00',2.27),('15529','2013-06-29','13:50:00',2.26),('15529','2013-06-29','13:55:00',2.27),('15529','2013-06-29','14:00:00',2.1),('15529','2013-06-29','14:05:00',2.22),('15529','2013-06-29','14:10:00',2.1),('15529','2013-06-29','14:15:00',2.2),('15529','2013-06-29','14:20:00',2.16),('15529','2013-06-29','14:25:00',2.16),('15529','2013-06-29','14:30:00',2.13),('15529','2013-06-29','14:35:00',2.11),('15529','2013-06-29','14:40:00',2.13),('15529','2013-06-29','14:45:00',2.1),('15529','2013-06-29','14:50:00',2.06),('15529','2013-06-29','14:55:00',2.05),('15529','2013-06-29','15:00:00',2.04),('15529','2013-06-29','15:05:00',2.05),('15529','2013-06-29','15:10:00',2.03),('15529','2013-06-29','15:15:00',2),('15529','2013-06-29','15:20:00',1.99),('15529','2013-06-29','15:25:00',1.96),('15529','2013-06-29','15:30:00',1.93),('15529','2013-06-29','15:35:00',1.89),('15529','2013-06-29','15:40:00',1.88),('15529','2013-06-29','15:45:00',1.86),('15529','2013-06-29','15:50:00',1.83),('15529','2013-06-29','15:55:00',1.8),('15529','2013-06-29','16:00:00',1.78),('15529','2013-06-29','16:05:00',1.75),('15529','2013-06-29','16:10:00',1.72),('15529','2013-06-29','16:15:00',1.68),('15529','2013-06-29','16:20:00',1.65),('15529','2013-06-29','16:25:00',1.6),('15529','2013-06-29','16:30:00',1.58),('15529','2013-06-29','16:35:00',1.51),('15529','2013-06-29','16:40:00',1.5),('15529','2013-06-29','16:45:00',1.45),('15529','2013-06-29','16:50:00',1.4),('15529','2013-06-29','16:55:00',1.35),('15529','2013-06-29','17:00:00',1.29),('15529','2013-06-29','17:05:00',1.25),('15529','2013-06-29','17:10:00',1.22),('15529','2013-06-29','17:15:00',1.18),('15529','2013-06-29','17:20:00',1.14),('15529','2013-06-29','17:25:00',1.09),('15529','2013-06-29','17:30:00',1.03),('15529','2013-06-28','08:45:00',1.07),('15529','2013-06-28','08:50:00',1.09),('15529','2013-06-28','08:55:00',1.13),('15529','2013-06-28','09:00:00',1.17),('15529','2013-06-28','09:05:00',1.21),('15529','2013-06-28','09:10:00',1.24),('15529','2013-06-28','09:15:00',1.28),('15529','2013-06-28','09:20:00',1.32),('15529','2013-06-28','09:25:00',1.37),('15529','2013-06-28','09:30:00',1.41),('15529','2013-06-28','09:35:00',1.44),('15529','2013-06-28','09:40:00',1.48),('15529','2013-06-28','09:45:00',1.52),('15529','2013-06-28','09:50:00',1.55),('15529','2013-06-28','09:55:00',1.58),('15529','2013-06-28','10:00:00',1.6),('15529','2013-06-28','10:05:00',1.63),('15529','2013-06-28','10:10:00',1.67),('15529','2013-06-28','10:15:00',1.7),('15529','2013-06-28','10:20:00',1.71),('15529','2013-06-28','10:25:00',1.77),('15529','2013-06-28','10:30:00',1.81),('15529','2013-06-28','10:35:00',1.81),('15529','2013-06-28','10:40:00',1.82),('15529','2013-06-28','10:45:00',1.89),('15529','2013-06-28','10:50:00',1.94),('15529','2013-06-28','10:55:00',2),('15529','2013-06-28','11:00:00',2.06),('15529','2013-06-28','11:05:00',2.14),('15529','2013-06-28','11:10:00',1.53),('15529','2013-06-28','11:15:00',2.19),('15529','2013-06-28','11:20:00',1.41),('15529','2013-06-28','11:25:00',1.22),('15529','2013-06-28','11:30:00',1.1),('15529','2013-06-28','11:45:00',1.96),('15529','2013-06-28','11:50:00',2.23),('15529','2013-06-28','11:55:00',1.15),('15529','2013-06-28','12:00:00',1.31),('15529','2013-06-28','12:05:00',1.22),('15529','2013-06-28','12:10:00',2.45),('15529','2013-06-28','12:15:00',1.5),('15529','2013-06-28','12:25:00',1.17),('15529','2013-06-28','12:30:00',2.04),('15529','2013-06-28','12:35:00',2.41),('15529','2013-06-28','12:40:00',1.91),('15529','2013-06-28','12:45:00',1.77),('15529','2013-06-28','13:00:00',2.42),('15529','2013-06-28','13:05:00',1.31),('15529','2013-06-28','13:15:00',2.59),('15529','2013-06-28','13:20:00',1.26),('15529','2013-06-28','13:40:00',1.11),('15529','2013-06-28','13:45:00',2.07),('15529','2013-06-28','13:55:00',2.33),('15529','2013-06-28','14:00:00',2.36),('15529','2013-06-28','14:05:00',2.34),('15529','2013-06-28','14:10:00',2.31),('15529','2013-06-28','14:15:00',2.38),('15529','2013-06-28','14:20:00',2.18),('15529','2013-06-28','14:25:00',2.18),('15529','2013-06-28','14:30:00',2.29),('15529','2013-06-28','14:35:00',2.27),('15529','2013-06-28','14:40:00',2.32),('15529','2013-06-28','14:45:00',2.27),('15529','2013-06-28','14:50:00',2.31),('15529','2013-06-28','14:55:00',2.44),('15529','2013-06-28','15:00:00',2.48),('15529','2013-06-28','15:05:00',2.31),('15529','2013-06-28','15:10:00',1.19),('15529','2013-06-28','15:15:00',1.52),('15529','2013-06-28','15:20:00',1.18),('15529','2013-06-28','17:20:00',1.38),('15529','2013-06-28','17:25:00',1.04),('15529','2013-06-28','17:30:00',1.23),('15529','2013-06-27','08:45:00',1.03),('15529','2013-06-27','08:50:00',1.09),('15529','2013-06-27','08:55:00',1.09),('15529','2013-06-27','09:00:00',1.19),('15529','2013-06-27','09:05:00',1.22),('15529','2013-06-27','09:10:00',1.29),('15529','2013-06-27','09:20:00',1.16),('15529','2013-06-27','09:25:00',1.25),('15529','2013-06-27','09:30:00',1.5),('15529','2013-06-27','09:35:00',1.56),('15529','2013-06-27','09:40:00',1),('15529','2013-06-27','09:45:00',1.08),('15529','2013-06-27','09:50:00',1.01),('15529','2013-06-27','09:55:00',1.73),('15529','2013-06-27','10:00:00',1.78),('15529','2013-06-27','10:05:00',1.82),('15529','2013-06-27','10:10:00',1.9),('15529','2013-06-27','10:15:00',2),('15529','2013-06-27','10:20:00',1.97),('15529','2013-06-27','10:55:00',1.14),('15529','2013-06-27','11:00:00',1.91),('15529','2013-06-27','11:05:00',1.15),('15529','2013-06-27','11:15:00',1.12),('15529','2013-06-27','11:20:00',1.03),('15529','2013-06-27','11:25:00',1.95),('15529','2013-06-27','11:30:00',1.56),('15529','2013-06-27','11:35:00',1.03),('15529','2013-06-27','11:40:00',2.21),('15529','2013-06-27','11:45:00',2.35),('15529','2013-06-27','11:50:00',1.87),('15529','2013-06-27','11:55:00',2.44),('15529','2013-06-27','12:00:00',1.98),('15529','2013-06-27','12:05:00',1.3),('15529','2013-06-27','12:10:00',2.15),('15529','2013-06-27','12:15:00',2.03),('15529','2013-06-27','12:20:00',2.25),('15529','2013-06-27','12:25:00',2.16),('15529','2013-06-27','12:30:00',2.11),('15529','2013-06-27','12:35:00',2.19),('15529','2013-06-27','12:40:00',2.33),('15529','2013-06-27','12:45:00',2.33),('15529','2013-06-27','12:50:00',2.31),('15529','2013-06-27','12:55:00',2.26),('15529','2013-06-27','13:00:00',2.35),('15529','2013-06-27','13:05:00',2.38),('15529','2013-06-27','13:10:00',2.36),('15529','2013-06-27','13:15:00',2.23),('15529','2013-06-27','13:20:00',2.33),('15529','2013-06-27','13:25:00',2.32),('15529','2013-06-27','13:30:00',2.32),('15529','2013-06-27','13:35:00',2.35),('15529','2013-06-27','13:40:00',2.09),('15529','2013-06-27','13:45:00',1.78),('15529','2013-06-27','13:50:00',1.77),('15529','2013-06-27','13:55:00',1.78),('15529','2013-06-27','14:00:00',1.83),('15529','2013-06-27','14:05:00',2.05),('15529','2013-06-27','14:10:00',1.64),('15529','2013-06-27','14:15:00',1.99),('15529','2013-06-27','14:20:00',2.28),('15529','2013-06-27','14:25:00',2.38),('15529','2013-06-27','14:30:00',2.3),('15529','2013-06-27','14:35:00',2.17),('15529','2013-06-27','14:45:00',1.37),('15529','2013-06-27','14:50:00',2.02),('15529','2013-06-27','14:55:00',1.53),('15529','2013-06-27','15:00:00',2.06),('15529','2013-06-27','15:05:00',1.89),('15529','2013-06-27','15:10:00',1.16),('15529','2013-06-27','15:15:00',1.5),('15529','2013-06-27','15:20:00',1.59),('15529','2013-06-27','15:25:00',1.31),('15529','2013-06-27','15:30:00',1.23),('15529','2013-06-27','15:35:00',1.47),('15529','2013-06-27','15:40:00',1.26),('15529','2013-06-27','15:45:00',2.04),('15529','2013-06-27','15:50:00',1.49),('15529','2013-06-27','15:55:00',1.62),('15529','2013-06-27','16:00:00',1.05),('15529','2013-06-27','16:05:00',1.7),('15529','2013-06-27','16:10:00',1.58),('15529','2013-06-27','16:15:00',1.26),('15529','2013-06-27','16:20:00',1.7),('15529','2013-06-27','16:25:00',1),('15529','2013-06-27','16:30:00',1.14),('15529','2013-06-27','16:35:00',1.22),('15529','2013-06-27','16:40:00',1.17),('15529','2013-06-27','16:55:00',1.48),('15529','2013-06-27','17:00:00',1.42),('15529','2013-06-27','17:05:00',1.03),('15529','2013-06-27','17:10:00',1.29),('15529','2013-06-27','17:15:00',1.2),('15529','2013-06-27','17:20:00',1.15),('15529','2013-06-27','17:25:00',1.11),('15529','2013-06-27','17:30:00',1.07),('15529','2013-06-27','17:35:00',1.02),('15529','2013-06-26','08:45:00',1.01),('15529','2013-06-26','08:50:00',1.11),('15529','2013-06-26','08:55:00',1.24),('15529','2013-06-26','09:00:00',1.18),('15529','2013-06-26','09:05:00',1.23),('15529','2013-06-26','09:10:00',1.19),('15529','2013-06-26','09:15:00',1.31),('15529','2013-06-26','09:20:00',1.38),('15529','2013-06-26','09:25:00',1.44),('15529','2013-06-26','09:30:00',1.49),('15529','2013-06-26','09:35:00',1.53),('15529','2013-06-26','09:40:00',1.53),('15529','2013-06-26','09:45:00',1.56),('15529','2013-06-26','09:50:00',1.58),('15529','2013-06-26','09:55:00',1.55),('15529','2013-06-26','10:00:00',1.61),('15529','2013-06-26','10:10:00',1.69),('15529','2013-06-26','10:15:00',1.78),('15529','2013-06-26','10:20:00',1.76),('15529','2013-06-26','10:25:00',1.79),('15529','2013-06-26','10:30:00',1.9),('15529','2013-06-26','10:35:00',2.05),('15529','2013-06-26','10:40:00',2.02),('15529','2013-06-26','10:45:00',1.38),('15529','2013-06-26','10:50:00',2.11),('15529','2013-06-26','10:55:00',2.12),('15529','2013-06-26','11:00:00',1.64),('15529','2013-06-26','11:10:00',1.49),('15529','2013-06-26','11:15:00',2.13),('15529','2013-06-26','11:20:00',2.2),('15529','2013-06-26','11:25:00',1.83),('15529','2013-06-26','11:30:00',1.5),('15529','2013-06-26','11:35:00',2.36),('15529','2013-06-26','11:40:00',1.54),('15529','2013-06-26','12:00:00',2.09),('15529','2013-06-26','12:15:00',1.35),('15529','2013-06-26','12:20:00',1.13),('15529','2013-06-26','13:45:00',1.21),('15529','2013-06-26','13:50:00',1.03),('15529','2013-06-26','14:00:00',2.02),('15529','2013-06-26','14:05:00',1.68),('15529','2013-06-26','14:10:00',2.29),('15529','2013-06-26','14:15:00',2.27),('15529','2013-06-26','14:20:00',2.22),('15529','2013-06-26','14:25:00',1.8),('15529','2013-06-26','14:30:00',2.38),('15529','2013-06-26','14:35:00',2.25),('15529','2013-06-26','14:40:00',2.2),('15529','2013-06-26','14:45:00',2.12),('15529','2013-06-26','14:50:00',2.08),('15529','2013-06-26','14:55:00',2.04),('15529','2013-06-26','15:00:00',1.99),('15529','2013-06-26','15:05:00',1.97),('15529','2013-06-26','15:10:00',1.96),('15529','2013-06-26','15:15:00',1.94),('15529','2013-06-26','15:20:00',1.93),('15529','2013-06-26','15:25:00',1.89),('15529','2013-06-26','15:30:00',1.87),('15529','2013-06-26','15:35:00',1.84),('15529','2013-06-26','15:40:00',1.8),('15529','2013-06-26','15:45:00',1.78),('15529','2013-06-26','15:50:00',1.78),('15529','2013-06-26','15:55:00',1.72),('15529','2013-06-26','16:00:00',1.68),('15529','2013-06-26','16:05:00',1.65),('15529','2013-06-26','16:10:00',1.62),('15529','2013-06-26','16:15:00',1.62),('15529','2013-06-26','16:20:00',1.59),('15529','2013-06-26','16:25:00',1.55),('15529','2013-06-26','16:30:00',1.51),('15529','2013-06-26','16:35:00',1.38),('15529','2013-06-26','16:40:00',1.42),('15529','2013-06-26','16:45:00',1.41),('15529','2013-06-26','16:50:00',1.34),('15529','2013-06-26','16:55:00',1.31),('15529','2013-06-26','17:00:00',1.27),('15529','2013-06-26','17:05:00',1.21),('15529','2013-06-26','17:10:00',1.15),('15529','2013-06-26','17:15:00',1.14),('15529','2013-06-26','17:20:00',1.15),('15529','2013-06-26','17:25:00',1.09),('15529','2013-06-26','17:30:00',1.05),('15529','2013-06-25','08:45:00',1.03),('15529','2013-06-25','08:50:00',1.07),('15529','2013-06-25','08:55:00',1.11),('15529','2013-06-25','09:00:00',1.16),('15529','2013-06-25','09:05:00',1.19),('15529','2013-06-25','09:10:00',1.24),('15529','2013-06-25','09:15:00',1.27),('15529','2013-06-25','09:20:00',1.31),('15529','2013-06-25','09:25:00',1.35),('15529','2013-06-25','09:30:00',1.38),('15529','2013-06-25','09:35:00',1.4),('15529','2013-06-25','09:40:00',1.44),('15529','2013-06-25','09:45:00',1.48),('15529','2013-06-25','09:50:00',1.51),('15529','2013-06-25','09:55:00',1.54),('15529','2013-06-25','10:00:00',1.57),('15529','2013-06-25','10:05:00',1.61),('15529','2013-06-25','10:10:00',1.66),('15529','2013-06-25','10:15:00',1.7),('15529','2013-06-25','10:20:00',1.73),('15529','2013-06-25','10:25:00',1.76),('15529','2013-06-25','10:30:00',1.76),('15529','2013-06-25','10:35:00',1.8),('15529','2013-06-25','10:40:00',1.82),('15529','2013-06-25','10:45:00',1.84),('15529','2013-06-25','10:50:00',1.86),('15529','2013-06-25','10:55:00',1.9),('15529','2013-06-25','11:00:00',1.91),('15529','2013-06-25','11:05:00',1.93),('15529','2013-06-25','11:10:00',1.97),('15529','2013-06-25','11:15:00',1.98),('15529','2013-06-25','11:20:00',2.02),('15529','2013-06-25','11:25:00',2.03),('15529','2013-06-25','11:30:00',2.05),('15529','2013-06-25','11:35:00',2.06),('15529','2013-06-25','11:40:00',2.09),('15529','2013-06-25','11:45:00',2.13),('15529','2013-06-25','11:50:00',2.15),('15529','2013-06-25','11:55:00',2.15),('15529','2013-06-25','12:00:00',2.15),('15529','2013-06-25','12:05:00',2.18),('15529','2013-06-25','12:10:00',2.2),('15529','2013-06-25','12:15:00',2.18),('15529','2013-06-25','12:20:00',2.16),('15529','2013-06-25','12:25:00',2.19),('15529','2013-06-25','12:30:00',2.19),('15529','2013-06-25','12:35:00',2.24),('15529','2013-06-25','12:40:00',2.26),('15529','2013-06-25','12:45:00',2.25),('15529','2013-06-25','12:50:00',2.34),('15529','2013-06-25','12:55:00',2.31),('15529','2013-06-25','13:00:00',2.25),('15529','2013-06-25','13:05:00',2.14),('15529','2013-06-25','13:10:00',1.39),('15529','2013-06-25','13:35:00',1.01),('15529','2013-06-25','13:40:00',2.45),('15529','2013-06-25','13:45:00',2.43),('15529','2013-06-25','13:50:00',2.33),('15529','2013-06-25','13:55:00',2.31),('15529','2013-06-25','14:00:00',2.26),('15529','2013-06-25','14:05:00',2.24),('15529','2013-06-25','14:10:00',2.22),('15529','2013-06-25','14:15:00',2.19),('15529','2013-06-25','14:20:00',2.18),('15529','2013-06-25','14:25:00',2.22),('15529','2013-06-25','14:30:00',2.24),('15529','2013-06-25','14:35:00',2.18),('15529','2013-06-25','14:40:00',2.18),('15529','2013-06-25','14:45:00',2.14),('15529','2013-06-25','14:50:00',2.11),('15529','2013-06-25','14:55:00',2.08),('15529','2013-06-25','15:00:00',2.02),('15529','2013-06-25','15:05:00',2.02),('15529','2013-06-25','15:10:00',1.98),('15529','2013-06-25','15:15:00',1.95),('15529','2013-06-25','15:20:00',1.93),('15529','2013-06-25','15:25:00',1.9),('15529','2013-06-25','15:30:00',1.9),('15529','2013-06-25','15:35:00',1.9),('15529','2013-06-25','15:40:00',1.9),('15529','2013-06-25','15:45:00',1.83),('15529','2013-06-25','15:50:00',1.79),('15529','2013-06-25','15:55:00',1.74),('15529','2013-06-25','16:00:00',1.71),('15529','2013-06-25','16:05:00',1.68),('15529','2013-06-25','16:10:00',1.66),('15529','2013-06-25','16:15:00',1.64),('15529','2013-06-25','16:20:00',1.6),('15529','2013-06-25','16:25:00',1.57),('15529','2013-06-25','16:30:00',1.53),('15529','2013-06-25','16:35:00',1.48),('15529','2013-06-25','16:40:00',1.45),('15529','2013-06-25','16:45:00',1.42),('15529','2013-06-25','16:50:00',1.38),('15529','2013-06-25','16:55:00',1.34),('15529','2013-06-25','17:00:00',1.31),('15529','2013-06-25','17:05:00',1.27),('15529','2013-06-25','17:10:00',1.22),('15529','2013-06-25','17:15:00',1.18),('15529','2013-06-25','17:20:00',1.13),('15529','2013-06-25','17:25:00',1.09),('15529','2013-06-25','17:30:00',1.03),('15529','2013-06-24','08:45:00',1.05),('15529','2013-06-24','08:50:00',1.08),('15529','2013-06-24','08:55:00',1.13),('15529','2013-06-24','09:00:00',1.18),('15529','2013-06-24','09:05:00',1.21),('15529','2013-06-24','09:10:00',1.24),('15529','2013-06-24','09:15:00',1.3),('15529','2013-06-24','09:20:00',1.34),('15529','2013-06-24','09:25:00',1.38),('15529','2013-06-24','09:30:00',1.44),('15529','2013-06-24','09:45:00',1.36),('15529','2013-06-24','10:05:00',1.19),('15529','2013-06-24','10:10:00',1.36),('15529','2013-06-24','10:20:00',1.27),('15529','2013-06-24','10:25:00',1.54),('15529','2013-06-24','10:35:00',1.51),('15529','2013-06-24','10:40:00',2.07),('15529','2013-06-24','10:45:00',2.05),('15529','2013-06-24','10:50:00',2.09),('15529','2013-06-24','10:55:00',2.09),('15529','2013-06-24','11:00:00',2.07),('15529','2013-06-24','11:05:00',2.07),('15529','2013-06-24','11:10:00',2.19),('15529','2013-06-24','11:15:00',2.22),('15529','2013-06-24','11:20:00',2.23),('15529','2013-06-24','11:40:00',1.11),('15529','2013-06-24','11:45:00',2.36),('15529','2013-06-24','11:50:00',2),('15529','2013-06-24','12:30:00',2.54),('15529','2013-06-24','12:35:00',1.25),('15529','2013-06-24','12:40:00',1.91),('15529','2013-06-24','12:45:00',1.26),('15529','2013-06-24','12:50:00',2.34),('15529','2013-06-24','12:55:00',2.42),('15529','2013-06-24','13:00:00',2.41),('15529','2013-06-24','13:05:00',2.41),('15529','2013-06-24','13:10:00',2.02),('15529','2013-06-24','13:15:00',2.49),('15529','2013-06-24','13:20:00',2.37),('15529','2013-06-24','13:25:00',2.45),('15529','2013-06-24','13:30:00',1.94),('15529','2013-06-24','13:35:00',2.33),('15529','2013-06-24','13:40:00',2.3),('15529','2013-06-24','13:45:00',2.3),('15529','2013-06-24','13:50:00',2.3),('15529','2013-06-24','13:55:00',2.26),('15529','2013-06-24','14:00:00',2.23),('15529','2013-06-24','14:05:00',2.23),('15529','2013-06-24','14:10:00',2.22),('15529','2013-06-24','14:15:00',2.2),('15529','2013-06-24','14:20:00',2.17),('15529','2013-06-24','14:25:00',2.17),('15529','2013-06-24','14:30:00',2.16),('15529','2013-06-24','14:35:00',2.16),('15529','2013-06-24','14:40:00',2.13),('15529','2013-06-24','14:45:00',2.09),('15529','2013-06-24','14:50:00',2.11),('15529','2013-06-24','14:55:00',2.05),('15529','2013-06-24','15:00:00',2.05),('15529','2013-06-24','15:05:00',2),('15529','2013-06-24','15:10:00',1.99),('15529','2013-06-24','15:15:00',1.99),('15529','2013-06-24','15:20:00',1.96),('15529','2013-06-24','15:25:00',1.92),('15529','2013-06-24','15:30:00',1.9),('15529','2013-06-24','15:35:00',1.86),('15529','2013-06-24','15:40:00',1.83),('15529','2013-06-24','15:45:00',1.81),('15529','2013-06-24','15:50:00',1.77),('15529','2013-06-24','15:55:00',1.74),('15529','2013-06-24','16:00:00',1.72),('15529','2013-06-24','16:05:00',1.68),('15529','2013-06-24','16:10:00',1.65),('15529','2013-06-24','16:15:00',1.62),('15529','2013-06-24','16:20:00',1.61),('15529','2013-06-24','16:25:00',1.55),('15529','2013-06-24','16:30:00',1.52),('15529','2013-06-24','16:35:00',1.49),('15529','2013-06-24','16:40:00',1.43),('15529','2013-06-24','16:45:00',1.41),('15529','2013-06-24','16:50:00',1.36),('15529','2013-06-24','16:55:00',1.32),('15529','2013-06-24','17:00:00',1.29),('15529','2013-06-24','17:05:00',1.24),('15529','2013-06-24','17:10:00',1.21),('15529','2013-06-24','17:15:00',1.17),('15529','2013-06-24','17:20:00',1.13),('15529','2013-06-24','17:25:00',1.07),('15529','2013-06-24','17:30:00',1.03),('15529','2013-06-23','08:45:00',1.08),('15529','2013-06-23','08:50:00',1.15),('15529','2013-06-23','09:00:00',1.2),('15529','2013-06-23','09:10:00',1.17),('15529','2013-06-23','09:15:00',1.48),('15529','2013-06-23','09:20:00',1.06),('15529','2013-06-23','09:35:00',1.49),('15529','2013-06-23','09:40:00',1.07),('15529','2013-06-23','09:50:00',1.5),('15529','2013-06-23','09:55:00',1.69),('15529','2013-06-23','10:00:00',1.73),('15529','2013-06-23','10:05:00',1.81),('15529','2013-06-23','10:10:00',1.17),('15529','2013-06-23','10:15:00',1.95),('15529','2013-06-23','10:20:00',2),('15529','2013-06-23','10:25:00',1.67),('15529','2013-06-23','10:30:00',1.33),('15529','2013-06-23','10:35:00',1),('15529','2013-06-23','10:45:00',2.34),('15529','2013-06-23','10:50:00',1.36),('15529','2013-06-23','10:55:00',1.41),('15529','2013-06-23','11:00:00',2.24),('15529','2013-06-23','11:05:00',1.68),('15529','2013-06-23','11:10:00',1.52),('15529','2013-06-23','11:15:00',1.47),('15529','2013-06-23','11:20:00',1.04),('15529','2013-06-23','11:25:00',1.56),('15529','2013-06-23','11:45:00',1.13),('15529','2013-06-23','11:50:00',1.78),('15529','2013-06-23','11:55:00',1.54),('15529','2013-06-23','12:00:00',1.52),('15529','2013-06-23','12:05:00',2.4),('15529','2013-06-23','12:10:00',1.88),('15529','2013-06-23','12:15:00',2.13),('15529','2013-06-23','12:20:00',1.14),('15529','2013-06-23','12:25:00',1.29),('15529','2013-06-23','12:30:00',2.35),('15529','2013-06-23','12:35:00',2.37),('15529','2013-06-23','12:40:00',2.04),('15529','2013-06-23','12:45:00',2.63),('15529','2013-06-23','12:50:00',2.64),('15529','2013-06-23','12:55:00',2.01),('15529','2013-06-23','13:00:00',2.39),('15529','2013-06-23','13:05:00',2.01),('15529','2013-06-23','13:10:00',2.12),('15529','2013-06-23','13:15:00',1.99),('15529','2013-06-23','13:20:00',2.39),('15529','2013-06-23','13:25:00',1.94),('15529','2013-06-23','13:30:00',2.32),('15529','2013-06-23','13:35:00',2.39),('15529','2013-06-23','13:40:00',2.41),('15529','2013-06-23','13:45:00',2.39),('15529','2013-06-23','13:50:00',2.09),('15529','2013-06-23','13:55:00',2.27),('15529','2013-06-23','14:00:00',2.33),('15529','2013-06-23','14:05:00',2.29),('15529','2013-06-23','14:10:00',2.27),('15529','2013-06-23','14:15:00',2.29),('15529','2013-06-23','14:20:00',2.31),('15529','2013-06-23','14:25:00',2.34),('15529','2013-06-23','14:30:00',2.29),('15529','2013-06-23','14:35:00',2.31),('15529','2013-06-23','14:40:00',2.34),('15529','2013-06-23','14:45:00',2.32),('15529','2013-06-23','14:50:00',2.13),('15529','2013-06-23','14:55:00',1.77),('15529','2013-06-23','15:00:00',1.87),('15529','2013-06-23','15:05:00',1.4),('15529','2013-06-23','15:10:00',2.28),('15529','2013-06-23','15:15:00',2.11),('15529','2013-06-23','15:20:00',1.45),('15529','2013-06-23','15:25:00',1.68),('15529','2013-06-23','15:40:00',1.25),('15529','2013-06-23','15:45:00',1.31),('15529','2013-06-23','15:50:00',1.26),('15529','2013-06-23','15:55:00',1.33),('15529','2013-06-23','16:00:00',1.39),('15529','2013-06-23','16:05:00',1.17),('15529','2013-06-23','16:10:00',2.06),('15529','2013-06-23','16:15:00',1.49),('15529','2013-06-23','16:20:00',1.62),('15529','2013-06-23','16:25:00',1.68),('15529','2013-06-23','16:30:00',1.15),('15529','2013-06-23','16:35:00',1.06),('15529','2013-06-23','16:40:00',1.31),('15529','2013-06-23','16:45:00',1.22),('15529','2013-06-23','17:00:00',1.17),('15529','2013-06-23','17:05:00',1.22),('15529','2013-06-23','17:25:00',1.05),('15529','2013-06-22','09:25:00',1.39),('15529','2013-06-22','09:30:00',1.43),('15529','2013-06-22','09:35:00',1.54),('15529','2013-06-22','09:40:00',1.3),('15529','2013-06-22','10:00:00',1.42),('15529','2013-06-22','10:05:00',1.17),('15529','2013-06-22','10:10:00',1.42),('15529','2013-06-22','10:15:00',1.66),('15529','2013-06-22','10:20:00',1.76),('15529','2013-06-22','10:25:00',1.77),('15529','2013-06-22','10:30:00',1.82),('15529','2013-06-22','10:35:00',1.81),('15529','2013-06-22','10:40:00',1.84),('15529','2013-06-22','10:45:00',1.85),('15529','2013-06-22','10:50:00',1.86),('15529','2013-06-22','10:55:00',1.87),('15529','2013-06-22','11:00:00',1.91),('15529','2013-06-22','11:05:00',1.93),('15529','2013-06-22','11:10:00',1.96),('15529','2013-06-22','11:15:00',1.93),('15529','2013-06-22','11:20:00',1.83),('15529','2013-06-22','11:25:00',1.99),('15529','2013-06-22','11:30:00',2.01),('15529','2013-06-22','11:35:00',2.05),('15529','2013-06-22','11:40:00',2.06),('15529','2013-06-22','11:45:00',2.09),('15529','2013-06-22','11:50:00',2.11),('15529','2013-06-22','11:55:00',2.1),('15529','2013-06-22','12:00:00',2.09),('15529','2013-06-22','12:05:00',2.09),('15529','2013-06-22','12:10:00',2.12),('15529','2013-06-22','12:15:00',2.09),('15529','2013-06-22','12:20:00',2.17),('15529','2013-06-22','12:25:00',2.18),('15529','2013-06-22','12:30:00',2.17),('15529','2013-06-22','12:35:00',2.25),('15529','2013-06-22','12:40:00',2.28),('15529','2013-06-22','12:45:00',2.17),('15529','2013-06-22','12:50:00',2.22),('15529','2013-06-22','12:55:00',2.27),('15529','2013-06-22','13:00:00',2.19),('15529','2013-06-22','13:05:00',2.21),('15529','2013-06-22','13:10:00',2.21),('15529','2013-06-22','13:15:00',2.22),('15529','2013-06-22','13:20:00',2.15),('15529','2013-06-22','13:25:00',2.23),('15529','2013-06-22','13:30:00',2.22),('15529','2013-06-22','13:35:00',2.23),('15529','2013-06-22','13:40:00',2.21),('15529','2013-06-22','13:45:00',2.23),('15529','2013-06-22','13:50:00',2.15),('15529','2013-06-22','13:55:00',2.24),('15529','2013-06-22','14:00:00',2.25),('15529','2013-06-22','14:05:00',2.21),('15529','2013-06-22','14:10:00',2.19),('15529','2013-06-22','14:15:00',2.23),('15529','2013-06-22','14:20:00',2.2),('15529','2013-06-22','14:25:00',2.2),('15529','2013-06-22','14:30:00',2.2),('15529','2013-06-22','14:35:00',2.2),('15529','2013-06-22','14:40:00',2.17),('15529','2013-06-22','14:45:00',2.15),('15529','2013-06-22','14:50:00',2.12),('15529','2013-06-22','14:55:00',2.1),('15529','2013-06-22','15:00:00',2.06),('15529','2013-06-22','15:05:00',2.08),('15529','2013-06-22','15:10:00',2.02),('15529','2013-06-22','15:15:00',2.01),('15529','2013-06-22','15:20:00',1.98),('15529','2013-06-22','15:25:00',1.98),('15529','2013-06-22','15:30:00',1.96),('15529','2013-06-22','15:35:00',1.92),('15529','2013-06-22','15:40:00',1.87),('15529','2013-06-22','15:45:00',1.83),('15529','2013-06-22','15:50:00',1.8),('15529','2013-06-22','15:55:00',1.8),('15529','2013-06-22','16:00:00',1.76),('15529','2013-06-22','16:05:00',1.73),('15529','2013-06-22','16:10:00',1.68),('15529','2013-06-22','16:15:00',1.66),('15529','2013-06-22','16:20:00',1.63),('15529','2013-06-22','16:25:00',1.59),('15529','2013-06-22','16:30:00',1.53),('15529','2013-06-22','16:35:00',1.5),('15529','2013-06-22','16:40:00',1.47),('15529','2013-06-22','16:45:00',1.44),('15529','2013-06-22','16:50:00',1.41),('15529','2013-06-22','16:55:00',1.38),('15529','2013-06-22','17:00:00',1.34),('15529','2013-06-22','17:05:00',1.27),('15529','2013-06-22','17:10:00',1.24),('15529','2013-06-22','17:15:00',1.2),('15529','2013-06-22','17:20:00',1.16),('15529','2013-06-22','17:25:00',1.11),('15529','2013-06-22','17:30:00',1.07),('15529','2013-06-22','17:35:00',1.03),('15529','2013-06-21','08:50:00',1.03),('15529','2013-06-21','08:55:00',1.06),('15529','2013-06-21','09:00:00',1.09),('15529','2013-06-21','09:05:00',1.14),('15529','2013-06-21','09:10:00',1.18),('15529','2013-06-21','09:15:00',1.22),('15529','2013-06-21','09:20:00',1.25),('15529','2013-06-21','09:25:00',1.28),('15529','2013-06-21','09:30:00',1.33),('15529','2013-06-21','09:35:00',1.37),('15529','2013-06-21','09:40:00',1.41),('15529','2013-06-21','09:45:00',1.44),('15529','2013-06-21','09:50:00',1.48),('15529','2013-06-21','09:55:00',1.51),('15529','2013-06-21','10:00:00',1.54),('15529','2013-06-21','10:05:00',1.57),('15529','2013-06-21','10:10:00',1.6),('15529','2013-06-21','10:15:00',1.64),('15529','2013-06-21','10:20:00',1.67),('15529','2013-06-21','10:25:00',1.69),('15529','2013-06-21','10:30:00',1.71),('15529','2013-06-21','10:35:00',1.77),('15529','2013-06-21','10:40:00',1.77),('15529','2013-06-21','10:45:00',1.82),('15529','2013-06-21','10:50:00',1.83),('15529','2013-06-21','10:55:00',1.85),('15529','2013-06-21','11:00:00',1.9),('15529','2013-06-21','11:05:00',1.92),('15529','2013-06-21','11:10:00',1.95),('15529','2013-06-21','11:15:00',1.96),('15529','2013-06-21','11:20:00',1.98),('15529','2013-06-21','11:25:00',2),('15529','2013-06-21','11:30:00',2),('15529','2013-06-21','11:35:00',2.03),('15529','2013-06-21','11:40:00',2.04),('15529','2013-06-21','11:45:00',2.07),('15529','2013-06-21','11:50:00',2.04),('15529','2013-06-21','11:55:00',2.07),('15529','2013-06-21','12:00:00',2.12),('15529','2013-06-21','12:05:00',2.04),('15529','2013-06-21','12:10:00',2.1),('15529','2013-06-21','12:15:00',2.12),('15529','2013-06-21','12:20:00',2.1),('15529','2013-06-21','12:25:00',2.14),('15529','2013-06-21','12:30:00',2.15),('15529','2013-06-21','12:35:00',2.19),('15529','2013-06-21','12:40:00',2.17),('15529','2013-06-21','12:45:00',2.13),('15529','2013-06-21','12:50:00',2.13),('15529','2013-06-21','12:55:00',2.11),('15529','2013-06-21','13:00:00',2.09),('15529','2013-06-21','13:05:00',2.11),('15529','2013-06-21','13:10:00',2.06),('15529','2013-06-21','13:15:00',2.08),('15529','2013-06-21','13:20:00',2.21),('15529','2013-06-21','13:25:00',2.28),('15529','2013-06-21','13:30:00',2.25),('15529','2013-06-21','13:35:00',2.26),('15529','2013-06-21','13:40:00',1.96),('15529','2013-06-21','13:45:00',2.3),('15529','2013-06-21','13:50:00',2.08),('15529','2013-06-21','13:55:00',1.02),('15529','2013-06-21','14:00:00',2.04),('15529','2013-06-21','14:05:00',2.38),('15529','2013-06-21','14:10:00',2.32),('15529','2013-06-21','14:15:00',2.05),('15529','2013-06-21','14:20:00',1.94),('15529','2013-06-21','14:25:00',1.9),('15529','2013-06-21','14:30:00',1.2),('15529','2013-06-21','14:35:00',1.02),('15529','2013-06-21','14:45:00',1.4),('15529','2013-06-21','14:50:00',1.96),('15529','2013-06-21','14:55:00',2),('15529','2013-06-21','15:00:00',2),('15529','2013-06-21','15:05:00',1.56),('15529','2013-06-21','15:10:00',2.16),('15529','2013-06-21','15:15:00',2.08),('15529','2013-06-21','15:20:00',1.85),('15529','2013-06-21','15:25:00',1.59),('15529','2013-06-21','15:30:00',1.44),('15529','2013-06-21','15:35:00',1.25),('15529','2013-06-21','15:40:00',1.8),('15529','2013-06-21','15:45:00',1.53),('15529','2013-06-21','15:50:00',1.21),('15529','2013-06-21','15:55:00',1.2),('15529','2013-06-21','17:10:00',1.16),('15529','2013-06-21','17:15:00',1.32),('15529','2013-06-21','17:20:00',1.35),('15529','2013-06-21','17:25:00',1.3),('15529','2013-06-21','17:30:00',1.16),('15529','2013-06-21','17:40:00',1),('15529','2013-06-20','08:55:00',1.03),('15529','2013-06-20','09:00:00',1.06),('15529','2013-06-20','09:05:00',1.1),('15529','2013-06-20','09:10:00',1.14),('15529','2013-06-20','09:15:00',1.18),('15529','2013-06-20','09:20:00',1.21),('15529','2013-06-20','09:25:00',1.24),('15529','2013-06-20','09:30:00',1.27),('15529','2013-06-20','09:35:00',1.29),('15529','2013-06-20','09:40:00',1.33),('15529','2013-06-20','09:45:00',1.37),('15529','2013-06-20','09:50:00',1.4),('15529','2013-06-20','09:55:00',1.43),('15529','2013-06-20','10:00:00',1.45),('15529','2013-06-20','10:05:00',1.47),('15529','2013-06-20','10:10:00',1.51),('15529','2013-06-20','10:15:00',1.55),('15529','2013-06-20','10:20:00',1.55),('15529','2013-06-20','10:25:00',1.59),('15529','2013-06-20','10:30:00',1.59),('15529','2013-06-20','10:35:00',1.66),('15529','2013-06-20','10:40:00',1.67),('15529','2013-06-20','10:45:00',1.69),('15529','2013-06-20','10:50:00',1.73),('15529','2013-06-20','10:55:00',1.76),('15529','2013-06-20','11:00:00',1.81),('15529','2013-06-20','11:05:00',1.83),('15529','2013-06-20','11:10:00',1.82),('15529','2013-06-20','11:15:00',1.81),('15529','2013-06-20','11:20:00',1.83),('15529','2013-06-20','11:25:00',1.81),('15529','2013-06-20','11:30:00',1.8),('15529','2013-06-20','11:35:00',1.81),('15529','2013-06-20','11:40:00',1.85),('15529','2013-06-20','11:45:00',1.96),('15529','2013-06-20','11:50:00',1.95),('15529','2013-06-20','11:55:00',1.99),('15529','2013-06-20','12:00:00',1.99),('15529','2013-06-20','12:05:00',2.01),('15529','2013-06-20','12:10:00',1.99),('15529','2013-06-20','12:15:00',1.93),('15529','2013-06-20','12:20:00',1.95),('15529','2013-06-20','12:25:00',2.02),('15529','2013-06-20','12:30:00',2.04),('15529','2013-06-20','12:35:00',1.97),('15529','2013-06-20','12:40:00',1.91),('15529','2013-06-20','12:45:00',1.99),('15529','2013-06-20','12:50:00',1.98),('15529','2013-06-20','12:55:00',2.02),('15529','2013-06-20','13:00:00',2.08),('15529','2013-06-20','13:05:00',2.05),('15529','2013-06-20','13:10:00',1.93),('15529','2013-06-20','13:15:00',1.98),('15529','2013-06-20','13:20:00',2.01),('15529','2013-06-20','13:25:00',2.04),('15529','2013-06-20','13:30:00',2.08),('15529','2013-06-20','13:35:00',2.08),('15529','2013-06-20','13:40:00',2.1),('15529','2013-06-20','13:45:00',2.1),('15529','2013-06-20','13:50:00',2.06),('15529','2013-06-20','13:55:00',2.06),('15529','2013-06-20','14:00:00',1.99),('15529','2013-06-20','14:05:00',2.09),('15529','2013-06-20','14:10:00',2.08),('15529','2013-06-20','14:15:00',2.08),('15529','2013-06-20','14:20:00',2.04),('15529','2013-06-20','14:25:00',2.07),('15529','2013-06-20','14:30:00',2.08),('15529','2013-06-20','14:35:00',2.05),('15529','2013-06-20','14:40:00',2.04),('15529','2013-06-20','14:45:00',2),('15529','2013-06-20','14:50:00',2),('15529','2013-06-20','14:55:00',1.97),('15529','2013-06-20','15:00:00',1.95),('15529','2013-06-20','15:05:00',1.93),('15529','2013-06-20','15:10:00',1.9),('15529','2013-06-20','15:15:00',1.9),('15529','2013-06-20','15:20:00',1.87),('15529','2013-06-20','15:25:00',1.87),('15529','2013-06-20','15:30:00',1.84),('15529','2013-06-20','15:35:00',1.81),('15529','2013-06-20','15:40:00',1.78),('15529','2013-06-20','15:45:00',1.77),('15529','2013-06-20','15:50:00',1.73),('15529','2013-06-20','15:55:00',1.68),('15529','2013-06-20','16:00:00',1.66),('15529','2013-06-20','16:05:00',1.62),('15529','2013-06-20','16:10:00',1.6),('15529','2013-06-20','16:15:00',1.59),('15529','2013-06-20','16:20:00',1.55),('15529','2013-06-20','16:25:00',1.51),('15529','2013-06-20','16:30:00',1.48),('15529','2013-06-20','16:35:00',1.45),('15529','2013-06-20','16:40:00',1.41),('15529','2013-06-20','16:45:00',1.37),('15529','2013-06-20','16:50:00',1.33),('15529','2013-06-20','16:55:00',1.29),('15529','2013-06-20','17:00:00',1.25),('15529','2013-06-20','17:05:00',1.21),('15529','2013-06-20','17:10:00',1.17),('15529','2013-06-20','17:15:00',1.13),('15529','2013-06-20','17:20:00',1.09),('15529','2013-06-20','17:25:00',1.04),('15529','2014-04-03','09:05:00',1.04),('15529','2014-04-03','09:10:00',1.09),('15529','2014-04-03','09:15:00',1.01),('15529','2014-04-03','13:20:00',1.06),('15529','2014-04-03','13:25:00',1.29),('15529','2014-04-03','13:30:00',1.04),('15529','2014-04-03','13:35:00',1.99),('15529','2014-04-03','13:40:00',1.82),('15529','2014-04-03','13:45:00',1.96),('15529','2014-04-03','13:50:00',1.51),('15529','2014-04-03','13:55:00',1.62),('15529','2014-04-03','14:00:00',1.96),('15529','2014-04-03','14:05:00',2.67),('15529','2014-04-03','14:10:00',2.43),('15529','2014-04-03','14:15:00',1.8),('15529','2014-04-03','14:20:00',1.15),('15529','2014-04-03','14:30:00',1.29),('15529','2014-04-03','14:45:00',1.23),('15529','2014-04-03','14:50:00',1.38),('15529','2014-04-03','15:00:00',1.71),('15529','2014-04-03','15:05:00',1.16),('15529','2014-04-03','15:10:00',1.37),('15529','2014-04-03','15:15:00',2.2),('15529','2014-04-03','15:20:00',1.96),('15529','2014-04-03','15:50:00',1.19),('15529','2014-04-03','15:55:00',1.64),('15529','2014-04-03','16:00:00',2),('15529','2014-04-03','16:05:00',1.86),('15529','2014-04-03','16:10:00',1.21),('15529','2014-04-03','16:20:00',1.37),('15529','2014-04-03','16:35:00',1.12),('15529','2014-04-03','16:40:00',1.09),('15529','2014-04-03','16:45:00',1.69),('15529','2014-04-03','16:50:00',1.78),('15529','2014-04-03','16:55:00',1.09),('15529','2014-04-03','17:00:00',1.09),('15529','2014-04-03','17:15:00',1.15),('15529','2014-04-03','17:30:00',1.06),('15529','2014-04-03','17:35:00',1.06),('15529','2013-06-19','08:50:00',1.01),('15529','2013-06-19','08:55:00',1.05),('15529','2013-06-19','09:00:00',1.09),('15529','2013-06-19','09:05:00',1.13),('15529','2013-06-19','09:10:00',1.17),('15529','2013-06-19','09:15:00',1.21),('15529','2013-06-19','09:20:00',1.24),('15529','2013-06-19','09:25:00',1.28),('15529','2013-06-19','09:30:00',1.31),('15529','2013-06-19','09:35:00',1.36),('15529','2013-06-19','09:40:00',1.39),('15529','2013-06-19','09:45:00',1.42),('15529','2013-06-19','09:50:00',1.47),('15529','2013-06-19','09:55:00',1.5),('15529','2013-06-19','10:00:00',1.53),('15529','2013-06-19','10:05:00',1.55),('15529','2013-06-19','10:10:00',1.58),('15529','2013-06-19','10:15:00',1.61),('15529','2013-06-19','10:20:00',1.64),('15529','2013-06-19','10:25:00',1.65),('15529','2013-06-19','10:30:00',1.67),('15529','2013-06-19','10:35:00',1.72),('15529','2013-06-19','10:40:00',1.74),('15529','2013-06-19','10:45:00',1.76),('15529','2013-06-19','10:50:00',1.78),('15529','2013-06-19','10:55:00',1.8),('15529','2013-06-19','11:00:00',1.82),('15529','2013-06-19','11:05:00',1.84),('15529','2013-06-19','11:10:00',1.83),('15529','2013-06-19','11:15:00',1.85),('15529','2013-06-19','11:20:00',1.87),('15529','2013-06-19','11:25:00',1.89),('15529','2013-06-19','11:30:00',1.91),('15529','2013-06-19','11:35:00',1.9),('15529','2013-06-19','11:40:00',1.91),('15529','2013-06-19','11:45:00',1.9),('15529','2013-06-19','11:50:00',1.9),('15529','2013-06-19','11:55:00',1.88),('15529','2013-06-19','12:00:00',1.93),('15529','2013-06-19','12:05:00',1.97),('15529','2013-06-19','12:10:00',1.99),('15529','2013-06-19','12:15:00',1.95),('15529','2013-06-19','12:20:00',1.98),('15529','2013-06-19','12:25:00',1.98),('15529','2013-06-19','12:30:00',1.99),('15529','2013-06-19','12:35:00',2.03),('15529','2013-06-19','12:40:00',2.04),('15529','2013-06-19','12:45:00',2.04),('15529','2013-06-19','12:50:00',2.04),('15529','2013-06-19','12:55:00',2.03),('15529','2013-06-19','13:00:00',2.04),('15529','2013-06-19','13:05:00',2.03),('15529','2013-06-19','13:10:00',2.06),('15529','2013-06-19','13:15:00',2.09),('15529','2013-06-19','13:20:00',2.03),('15529','2013-06-19','13:25:00',2.11),('15529','2013-06-19','13:30:00',2.11),('15529','2013-06-19','13:35:00',2.13),('15529','2013-06-19','13:40:00',2.16),('15529','2013-06-19','13:45:00',2.1),('15529','2013-06-19','13:50:00',2.14),('15529','2013-06-19','13:55:00',2.16),('15529','2013-06-19','14:00:00',2.16),('15529','2013-06-19','14:05:00',2.18),('15529','2013-06-19','14:10:00',2.13),('15529','2013-06-19','14:15:00',2.12),('15529','2013-06-19','14:20:00',2.11),('15529','2013-06-19','14:25:00',2.1),('15529','2013-06-19','14:30:00',2.11),('15529','2013-06-19','14:35:00',2.05),('15529','2013-06-19','14:40:00',2.08),('15529','2013-06-19','14:45:00',2.05),('15529','2013-06-19','14:50:00',2.03),('15529','2013-06-19','14:55:00',2.02),('15529','2013-06-19','15:00:00',1.99),('15529','2013-06-19','15:05:00',1.96),('15529','2013-06-19','15:10:00',1.95),('15529','2013-06-19','15:15:00',1.94),('15529','2013-06-19','15:20:00',1.9),('15529','2013-06-19','15:25:00',1.87),('15529','2013-06-19','15:30:00',1.86),('15529','2013-06-19','15:35:00',1.84),('15529','2013-06-19','15:40:00',1.81),('15529','2013-06-19','15:45:00',1.81),('15529','2013-06-19','15:50:00',1.75),('15529','2013-06-19','15:55:00',1.72),('15529','2013-06-19','16:00:00',1.71),('15529','2013-06-19','16:05:00',1.65),('15529','2013-06-19','16:10:00',1.63),('15529','2013-06-19','16:15:00',1.6),('15529','2013-06-19','16:20:00',1.56),('15529','2013-06-19','16:25:00',1.54),('15529','2013-06-19','16:30:00',1.51),('15529','2013-06-19','16:35:00',1.46),('15529','2013-06-19','16:40:00',1.41),('15529','2013-06-19','16:45:00',1.39),('15529','2013-06-19','16:50:00',1.34),('15529','2013-06-19','16:55:00',1.32),('15529','2013-06-19','17:00:00',1.27),('15529','2013-06-19','17:05:00',1.22),('15529','2013-06-19','17:10:00',1.18),('15529','2013-06-19','17:15:00',1.14),('15529','2013-06-19','17:20:00',1.1),('15529','2013-06-19','17:25:00',1.05),('15529','2013-06-19','17:30:00',1.01),('15529','2013-06-18','08:55:00',1.02),('15529','2013-06-18','09:00:00',1.06),('15529','2013-06-18','09:05:00',1.1),('15529','2013-06-18','09:10:00',1.13),('15529','2013-06-18','09:15:00',1.17),('15529','2013-06-18','09:20:00',1.21),('15529','2013-06-18','09:25:00',1.25),('15529','2013-06-18','09:30:00',1.28),('15529','2013-06-18','09:35:00',1.32),('15529','2013-06-18','09:40:00',1.35),('15529','2013-06-18','09:45:00',1.38),('15529','2013-06-18','09:50:00',1.42),('15529','2013-06-18','09:55:00',1.44),('15529','2013-06-18','10:00:00',1.47),('15529','2013-06-18','10:05:00',1.49),('15529','2013-06-18','10:10:00',1.53),('15529','2013-06-18','10:15:00',1.56),('15529','2013-06-18','10:20:00',1.59),('15529','2013-06-18','10:25:00',1.6),('15529','2013-06-18','10:30:00',1.63),('15529','2013-06-18','10:35:00',1.63),('15529','2013-06-18','10:40:00',1.68),('15529','2013-06-18','10:45:00',1.69),('15529','2013-06-18','10:50:00',1.71),('15529','2013-06-18','10:55:00',1.75),('15529','2013-06-18','11:00:00',1.78),('15529','2013-06-18','11:05:00',1.76),('15529','2013-06-18','11:10:00',1.79),('15529','2013-06-18','11:15:00',1.8),('15529','2013-06-18','11:20:00',1.8),('15529','2013-06-18','11:25:00',1.83),('15529','2013-06-18','11:30:00',1.86),('15529','2013-06-18','11:35:00',1.86),('15529','2013-06-18','11:40:00',1.88),('15529','2013-06-18','11:45:00',1.9),('15529','2013-06-18','11:50:00',1.88),('15529','2013-06-18','11:55:00',1.91),('15529','2013-06-18','12:00:00',1.89),('15529','2013-06-18','12:05:00',1.93),('15529','2013-06-18','12:10:00',1.93),('15529','2013-06-18','12:15:00',1.95),('15529','2013-06-18','12:20:00',1.97),('15529','2013-06-18','12:25:00',2.01),('15529','2013-06-18','12:30:00',2.04),('15529','2013-06-18','12:35:00',2.02),('15529','2013-06-18','12:40:00',2.02),('15529','2013-06-18','12:45:00',2.03),('15529','2013-06-18','12:50:00',2),('15529','2013-06-18','12:55:00',2.1),('15529','2013-06-18','13:00:00',2.04),('15529','2013-06-18','13:05:00',2.04),('15529','2013-06-18','13:10:00',2.08),('15529','2013-06-18','13:15:00',2.06),('15529','2013-06-18','13:20:00',2.06),('15529','2013-06-18','13:25:00',2.09),('15529','2013-06-18','13:30:00',2.07),('15529','2013-06-18','13:35:00',2.07),('15529','2013-06-18','13:40:00',2.08),('15529','2013-06-18','13:45:00',2.05),('15529','2013-06-18','13:50:00',2.06),('15529','2013-06-18','13:55:00',2.03),('15529','2013-06-18','14:00:00',2.05),('15529','2013-06-18','14:05:00',2.07),('15529','2013-06-18','14:10:00',2.05),('15529','2013-06-18','14:15:00',2.01),('15529','2013-06-18','14:20:00',2.03),('15529','2013-06-18','14:25:00',2),('15529','2013-06-18','14:30:00',1.99),('15529','2013-06-18','14:35:00',1.97),('15529','2013-06-18','14:40:00',2),('15529','2013-06-18','14:45:00',1.97),('15529','2013-06-18','14:50:00',1.95),('15529','2013-06-18','14:55:00',1.94),('15529','2013-06-18','15:00:00',1.91),('15529','2013-06-18','15:05:00',1.89),('15529','2013-06-18','15:10:00',1.87),('15529','2013-06-18','15:15:00',1.87),('15529','2013-06-18','15:20:00',1.84),('15529','2013-06-18','15:25:00',1.82),('15529','2013-06-18','15:30:00',1.79),('15529','2013-06-18','15:35:00',1.75),('15529','2013-06-18','15:40:00',1.72),('15529','2013-06-18','15:45:00',1.7),('15529','2013-06-18','15:50:00',1.67),('15529','2013-06-18','15:55:00',1.63),('15529','2013-06-18','16:00:00',1.6),('15529','2013-06-18','16:05:00',1.59),('15529','2013-06-18','16:10:00',1.54),('15529','2013-06-18','16:15:00',1.51),('15529','2013-06-18','16:20:00',1.49),('15529','2013-06-18','16:25:00',1.45),('15529','2013-06-18','16:30:00',1.42),('15529','2013-06-18','16:35:00',1.39),('15529','2013-06-18','16:40:00',1.35),('15529','2013-06-18','16:45:00',1.32),('15529','2013-06-18','16:50:00',1.27),('15529','2013-06-18','16:55:00',1.24),('15529','2013-06-18','17:00:00',1.2),('15529','2013-06-18','17:05:00',1.17),('15529','2013-06-18','17:10:00',1.12),('15529','2013-06-18','17:15:00',1.08),('15529','2013-06-18','17:20:00',1.06),('15529','2013-06-18','17:25:00',1.01),('15529','2013-06-17','08:55:00',1.02),('15529','2013-06-17','09:00:00',1.06),('15529','2013-06-17','09:05:00',1.1),('15529','2013-06-17','09:10:00',1.13),('15529','2013-06-17','09:15:00',1.17),('15529','2013-06-17','09:20:00',1.2),('15529','2013-06-17','09:25:00',1.24),('15529','2013-06-17','09:30:00',1.27),('15529','2013-06-17','09:35:00',1.31),('15529','2013-06-17','09:40:00',1.34),('15529','2013-06-17','09:45:00',1.37),('15529','2013-06-17','09:50:00',1.4),('15529','2013-06-17','09:55:00',1.43),('15529','2013-06-17','10:00:00',1.46),('15529','2013-06-17','10:05:00',1.51),('15529','2013-06-17','10:10:00',1.54),('15529','2013-06-17','10:15:00',1.55),('15529','2013-06-17','10:20:00',1.59),('15529','2013-06-17','10:25:00',1.63),('15529','2013-06-17','10:30:00',1.64),('15529','2013-06-17','10:35:00',1.68),('15529','2013-06-17','10:40:00',1.69),('15529','2013-06-17','10:45:00',1.72),('15529','2013-06-17','10:50:00',1.74),('15529','2013-06-17','10:55:00',1.72),('15529','2013-06-17','11:00:00',1.78),('15529','2013-06-17','11:05:00',1.78),('15529','2013-06-17','11:10:00',1.84),('15529','2013-06-17','11:15:00',1.86),('15529','2013-06-17','11:20:00',1.86),('15529','2013-06-17','11:25:00',1.84),('15529','2013-06-17','11:30:00',1.86),('15529','2013-06-17','11:35:00',1.89),('15529','2013-06-17','11:40:00',1.91),('15529','2013-06-17','11:45:00',1.9),('15529','2013-06-17','11:50:00',1.91),('15529','2013-06-17','11:55:00',1.95),('15529','2013-06-17','12:00:00',1.94),('15529','2013-06-17','12:05:00',1.92),('15529','2013-06-17','12:10:00',1.94),('15529','2013-06-17','12:15:00',1.93),('15529','2013-06-17','12:20:00',1.94),('15529','2013-06-17','12:25:00',1.89),('15529','2013-06-17','12:30:00',1.93),('15529','2013-06-17','12:35:00',1.97),('15529','2013-06-17','12:40:00',1.96),('15529','2013-06-17','12:45:00',1.91),('15529','2013-06-17','12:50:00',1.92),('15529','2013-06-17','12:55:00',2.03),('15529','2013-06-17','13:00:00',2.01),('15529','2013-06-17','13:05:00',2.01),('15529','2013-06-17','13:10:00',2.02),('15529','2013-06-17','13:15:00',2.05),('15529','2013-06-17','13:20:00',2.04),('15529','2013-06-17','13:25:00',2.12),('15529','2013-06-17','13:30:00',2.02),('15529','2013-06-17','13:35:00',2.06),('15529','2013-06-17','13:40:00',2.08),('15529','2013-06-17','13:45:00',2.04),('15529','2013-06-17','13:50:00',2.08),('15529','2013-06-17','13:55:00',2.06),('15529','2013-06-17','14:00:00',2.06),('15529','2013-06-17','14:05:00',2.04),('15529','2013-06-17','14:10:00',2.05),('15529','2013-06-17','14:15:00',2.03),('15529','2013-06-17','14:20:00',2.01),('15529','2013-06-17','14:25:00',2.01),('15529','2013-06-17','14:30:00',2.06),('15529','2013-06-17','14:35:00',2.1),('15529','2013-06-17','14:40:00',2.07),('15529','2013-06-17','14:45:00',2.04),('15529','2013-06-17','14:50:00',1.97),('15529','2013-06-17','14:55:00',1.95),('15529','2013-06-17','15:00:00',1.96),('15529','2013-06-17','15:05:00',1.9),('15529','2013-06-17','15:10:00',1.87),('15529','2013-06-17','15:15:00',1.84),('15529','2013-06-17','15:20:00',1.86),('15529','2013-06-17','15:25:00',1.82),('15529','2013-06-17','15:30:00',1.81),('15529','2013-06-17','15:35:00',1.79),('15529','2013-06-17','15:40:00',1.73),('15529','2013-06-17','15:45:00',1.72),('15529','2013-06-17','15:50:00',1.69),('15529','2013-06-17','15:55:00',1.68),('15529','2013-06-17','16:00:00',1.65),('15529','2013-06-17','16:05:00',1.64),('15529','2013-06-17','16:10:00',1.61),('15529','2013-06-17','16:15:00',1.57),('15529','2013-06-17','16:20:00',1.55),('15529','2013-06-17','16:25:00',1.52),('15529','2013-06-17','16:30:00',1.47),('15529','2013-06-17','16:35:00',1.42),('15529','2013-06-17','16:40:00',1.36),('15529','2013-06-17','16:45:00',1.34),('15529','2013-06-17','16:50:00',1.3),('15529','2013-06-17','16:55:00',1.26),('15529','2013-06-17','17:00:00',1.22),('15529','2013-06-17','17:05:00',1.18),('15529','2013-06-17','17:10:00',1.14),('15529','2013-06-17','17:15:00',1.11),('15529','2013-06-17','17:20:00',1.07),('15529','2013-06-17','17:25:00',1.02),('15529','2013-06-16','08:50:00',1.03),('15529','2013-06-16','08:55:00',1.07),('15529','2013-06-16','09:00:00',1.11),('15529','2013-06-16','09:05:00',1.15),('15529','2013-06-16','09:10:00',1.19),('15529','2013-06-16','09:15:00',1.23),('15529','2013-06-16','09:20:00',1.27),('15529','2013-06-16','09:25:00',1.31),('15529','2013-06-16','09:30:00',1.34),('15529','2013-06-16','09:35:00',1.38),('15529','2013-06-16','09:40:00',1.4),('15529','2013-06-16','09:45:00',1.44),('15529','2013-06-16','09:50:00',1.48),('15529','2013-06-16','09:55:00',1.51),('15529','2013-06-16','10:00:00',1.53),('15529','2013-06-16','10:05:00',1.55),('15529','2013-06-16','10:10:00',1.59),('15529','2013-06-16','10:15:00',1.62),('15529','2013-06-16','10:20:00',1.64),('15529','2013-06-16','10:25:00',1.67),('15529','2013-06-16','10:30:00',1.68),('15529','2013-06-16','10:35:00',1.74),('15529','2013-06-16','10:40:00',1.73),('15529','2013-06-16','10:45:00',1.78),('15529','2013-06-16','10:50:00',1.77),('15529','2013-06-16','10:55:00',1.81),('15529','2013-06-16','11:00:00',1.81),('15529','2013-06-16','11:05:00',1.85),('15529','2013-06-16','11:10:00',1.89),('15529','2013-06-16','11:15:00',1.9),('15529','2013-06-16','11:20:00',1.88),('15529','2013-06-16','11:25:00',1.9),('15529','2013-06-16','11:30:00',1.91),('15529','2013-06-16','11:35:00',1.97),('15529','2013-06-16','11:40:00',1.97),('15529','2013-06-16','11:45:00',1.93),('15529','2013-06-16','11:50:00',1.96),('15529','2013-06-16','11:55:00',1.99),('15529','2013-06-16','12:00:00',2),('15529','2013-06-16','12:05:00',2.03),('15529','2013-06-16','12:10:00',2.01),('15529','2013-06-16','12:15:00',2.04),('15529','2013-06-16','12:20:00',1.99),('15529','2013-06-16','12:25:00',2.08),('15529','2013-06-16','12:30:00',2.05),('15529','2013-06-16','12:35:00',2.07),('15529','2013-06-16','12:40:00',2.09),('15529','2013-06-16','12:45:00',2.09),('15529','2013-06-16','12:50:00',2.09),('15529','2013-06-16','12:55:00',2.14),('15529','2013-06-16','13:00:00',2.09),('15529','2013-06-16','13:05:00',2.13),('15529','2013-06-16','13:10:00',2.14),('15529','2013-06-16','13:15:00',2.16),('15529','2013-06-16','13:20:00',2.15),('15529','2013-06-16','13:25:00',2.15),('15529','2013-06-16','13:30:00',2.14),('15529','2013-06-16','13:35:00',2.12),('15529','2013-06-16','13:40:00',2.07),('15529','2013-06-16','13:45:00',2.07),('15529','2013-06-16','13:50:00',2.07),('15529','2013-06-16','13:55:00',2.09),('15529','2013-06-16','14:00:00',2.05),('15529','2013-06-16','14:05:00',2.04),('15529','2013-06-16','14:10:00',2.04),('15529','2013-06-16','14:15:00',2.02),('15529','2013-06-16','14:20:00',2.04),('15529','2013-06-16','14:25:00',2.03),('15529','2013-06-16','14:30:00',1.99),('15529','2013-06-16','14:35:00',2),('15529','2013-06-16','14:40:00',2),('15529','2013-06-16','14:45:00',2.01),('15529','2013-06-16','14:50:00',1.94),('15529','2013-06-16','14:55:00',1.91),('15529','2013-06-16','15:00:00',1.91),('15529','2013-06-16','15:05:00',1.9),('15529','2013-06-16','15:10:00',1.89),('15529','2013-06-16','15:15:00',1.88),('15529','2013-06-16','15:20:00',1.85),('15529','2013-06-16','15:25:00',1.82),('15529','2013-06-16','15:30:00',1.82),('15529','2013-06-16','15:35:00',1.78),('15529','2013-06-16','15:40:00',1.78),('15529','2013-06-16','15:45:00',1.73),('15529','2013-06-16','15:50:00',1.69),('15529','2013-06-16','15:55:00',1.68),('15529','2013-06-16','16:00:00',1.66),('15529','2013-06-16','16:05:00',1.63),('15529','2013-06-16','16:10:00',1.58),('15529','2013-06-16','16:15:00',1.56),('15529','2013-06-16','16:20:00',1.52),('15529','2013-06-16','16:25:00',1.5),('15529','2013-06-16','16:30:00',1.47),('15529','2013-06-16','16:35:00',1.43),('15529','2013-06-16','16:40:00',1.38),('15529','2013-06-16','16:45:00',1.34),('15529','2013-06-16','16:50:00',1.32),('15529','2013-06-16','16:55:00',1.28),('15529','2013-06-16','17:00:00',1.23),('15529','2013-06-16','17:05:00',1.2),('15529','2013-06-16','17:10:00',1.15),('15529','2013-06-16','17:15:00',1.11),('15529','2013-06-16','17:20:00',1.07),('15529','2013-06-16','17:25:00',1.03),('15529','2013-06-15','08:45:00',1),('15529','2013-06-15','08:50:00',1.05),('15529','2013-06-15','08:55:00',1.1),('15529','2013-06-15','09:00:00',1.13),('15529','2013-06-15','09:05:00',1.16),('15529','2013-06-15','09:10:00',1.2),('15529','2013-06-15','09:15:00',1.26),('15529','2013-06-15','09:20:00',1.28),('15529','2013-06-15','09:25:00',1.31),('15529','2013-06-15','09:30:00',1.35),('15529','2013-06-15','09:35:00',1.4),('15529','2013-06-15','09:40:00',1.43),('15529','2013-06-15','09:45:00',1.45),('15529','2013-06-15','09:50:00',1.49),('15529','2013-06-15','09:55:00',1.52),('15529','2013-06-15','10:00:00',1.55),('15529','2013-06-15','10:05:00',1.56),('15529','2013-06-15','10:10:00',1.61),('15529','2013-06-15','10:15:00',1.64),('15529','2013-06-15','10:20:00',1.66),('15529','2013-06-15','10:25:00',1.7),('15529','2013-06-15','10:30:00',1.71),('15529','2013-06-15','10:35:00',1.77),('15529','2013-06-15','10:40:00',1.79),('15529','2013-06-15','10:45:00',1.81),('15529','2013-06-15','10:50:00',1.82),('15529','2013-06-15','10:55:00',1.83),('15529','2013-06-15','11:00:00',1.87),('15529','2013-06-15','11:05:00',1.89),('15529','2013-06-15','11:10:00',1.92),('15529','2013-06-15','11:15:00',1.94),('15529','2013-06-15','11:20:00',1.95),('15529','2013-06-15','11:25:00',1.98),('15529','2013-06-15','11:30:00',2.03),('15529','2013-06-15','11:35:00',2.01),('15529','2013-06-15','11:40:00',2.02),('15529','2013-06-15','11:45:00',2.04),('15529','2013-06-15','11:50:00',2.04),('15529','2013-06-15','11:55:00',2.07),('15529','2013-06-15','12:00:00',2.11),('15529','2013-06-15','12:05:00',2.11),('15529','2013-06-15','12:10:00',2.1),('15529','2013-06-15','12:15:00',2.12),('15529','2013-06-15','12:20:00',2.11),('15529','2013-06-15','12:25:00',2.12),('15529','2013-06-15','12:30:00',2.14),('15529','2013-06-15','12:35:00',2.14),('15529','2013-06-15','12:40:00',2.17),('15529','2013-06-15','12:45:00',2.16),('15529','2013-06-15','12:50:00',2.18),('15529','2013-06-15','12:55:00',2.18),('15529','2013-06-15','13:00:00',2.21),('15529','2013-06-15','13:05:00',2.21),('15529','2013-06-15','13:10:00',2.22),('15529','2013-06-15','13:15:00',2.2),('15529','2013-06-15','13:20:00',2.21),('15529','2013-06-15','13:25:00',2.17),('15529','2013-06-15','13:30:00',2.22),('15529','2013-06-15','13:35:00',2.2),('15529','2013-06-15','13:40:00',2.19),('15529','2013-06-15','13:45:00',1.3),('15529','2013-06-15','13:50:00',2.17),('15529','2013-06-15','13:55:00',2.13),('15529','2013-06-15','14:00:00',2.17),('15529','2013-06-15','14:05:00',1.3),('15529','2013-06-15','14:10:00',2.16),('15529','2013-06-15','14:15:00',1.1),('15529','2013-06-15','14:20:00',2.01),('15529','2013-06-15','14:25:00',2.01),('15529','2013-06-15','14:30:00',2),('15529','2013-06-15','14:35:00',1.97),('15529','2013-06-15','14:40:00',1.96),('15529','2013-06-15','14:45:00',1.95),('15529','2013-06-15','14:50:00',1.93),('15529','2013-06-15','14:55:00',1.93),('15529','2013-06-15','15:00:00',1.9),('15529','2013-06-15','15:05:00',1.89),('15529','2013-06-15','15:10:00',1.87),('15529','2013-06-15','15:15:00',1.44),('15529','2013-06-15','15:20:00',1.14),('15529','2013-06-15','15:25:00',1.13),('15529','2013-06-15','15:30:00',1.13),('15529','2013-06-15','15:35:00',1.6),('15529','2013-06-15','15:40:00',1.84),('15529','2013-06-15','15:45:00',1.77),('15529','2013-06-15','15:50:00',1.74),('15529','2013-06-15','15:55:00',1.72),('15529','2013-06-15','16:00:00',1.66),('15529','2013-06-15','16:05:00',1.64),('15529','2013-06-15','16:10:00',1.62),('15529','2013-06-15','16:15:00',1.58),('15529','2013-06-15','16:20:00',1.56),('15529','2013-06-15','16:25:00',1.51),('15529','2013-06-15','16:30:00',1.47),('15529','2013-06-15','16:35:00',1.44),('15529','2013-06-15','16:40:00',1.4),('15529','2013-06-15','16:45:00',1.37),('15529','2013-06-15','16:50:00',1.33),('15529','2013-06-15','16:55:00',1.29),('15529','2013-06-15','17:00:00',1.24),('15529','2013-06-15','17:05:00',1.2),('15529','2013-06-15','17:10:00',1.17),('15529','2013-06-15','17:15:00',1.13),('15529','2013-06-15','17:20:00',1.08),('15529','2013-06-15','17:25:00',1.04),('15529','2013-06-14','08:45:00',1.01),('15529','2013-06-14','08:50:00',1.09),('15529','2013-06-14','08:55:00',1.16),('15529','2013-06-14','09:00:00',1.22),('15529','2013-06-14','09:05:00',1.23),('15529','2013-06-14','09:10:00',1.01),('15529','2013-06-14','09:15:00',1.26),('15529','2013-06-14','09:25:00',1.06),('15529','2013-06-14','09:35:00',1.45),('15529','2013-06-14','09:40:00',1.42),('15529','2013-06-14','09:45:00',1.46),('15529','2013-06-14','09:50:00',1.5),('15529','2013-06-14','09:55:00',1.53),('15529','2013-06-14','10:00:00',1.59),('15529','2013-06-14','10:05:00',1.6),('15529','2013-06-14','10:10:00',1.15),('15529','2013-06-14','10:15:00',1.55),('15529','2013-06-14','10:20:00',1.7),('15529','2013-06-14','10:25:00',1.74),('15529','2013-06-14','10:30:00',1.73),('15529','2013-06-14','10:35:00',1.8),('15529','2013-06-14','10:40:00',1.82),('15529','2013-06-14','10:45:00',1.75),('15529','2013-06-14','10:50:00',1.81),('15529','2013-06-14','10:55:00',1.88),('15529','2013-06-14','11:00:00',1.93),('15529','2013-06-14','11:05:00',1.91),('15529','2013-06-14','11:10:00',1.94),('15529','2013-06-14','11:15:00',1.96),('15529','2013-06-14','11:20:00',1.99),('15529','2013-06-14','11:25:00',1.93),('15529','2013-06-14','11:30:00',2.01),('15529','2013-06-14','11:35:00',2.06),('15529','2013-06-14','11:40:00',2.08),('15529','2013-06-14','11:45:00',2.09),('15529','2013-06-14','11:50:00',2.09),('15529','2013-06-14','11:55:00',2.11),('15529','2013-06-14','12:00:00',2.11),('15529','2013-06-14','12:05:00',2.13),('15529','2013-06-14','12:10:00',2.12),('15529','2013-06-14','12:15:00',2.12),('15529','2013-06-14','12:20:00',2.15),('15529','2013-06-14','12:25:00',2.14),('15529','2013-06-14','12:30:00',2.18),('15529','2013-06-14','12:35:00',2.17),('15529','2013-06-14','12:40:00',2.17),('15529','2013-06-14','12:45:00',2.18),('15529','2013-06-14','12:50:00',2.19),('15529','2013-06-14','12:55:00',2.16),('15529','2013-06-14','13:00:00',2.12),('15529','2013-06-14','13:05:00',2.22),('15529','2013-06-14','13:10:00',2.21),('15529','2013-06-14','13:15:00',2.15),('15529','2013-06-14','13:20:00',2.18),('15529','2013-06-14','13:25:00',2.17),('15529','2013-06-14','13:30:00',2.23),('15529','2013-06-14','13:35:00',1.1),('15529','2013-06-14','13:40:00',2.07),('15529','2013-06-14','13:45:00',2.07),('15529','2013-06-14','13:50:00',2.07),('15529','2013-06-14','13:55:00',2.06),('15529','2013-06-14','14:00:00',2.07),('15529','2013-06-14','14:05:00',2.07),('15529','2013-06-14','14:10:00',2.03),('15529','2013-06-14','14:15:00',2),('15529','2013-06-14','14:20:00',2.02),('15529','2013-06-14','14:25:00',2.01),('15529','2013-06-14','14:30:00',1.96),('15529','2013-06-14','14:35:00',1.83),('15529','2013-06-14','14:40:00',1.45),('15529','2013-06-14','14:45:00',1.41),('15529','2013-06-14','14:50:00',1.41),('15529','2013-06-14','14:55:00',1.41),('15529','2013-06-14','15:00:00',1.41),('15529','2013-06-14','15:05:00',1.4),('15529','2013-06-14','15:10:00',1.41),('15529','2013-06-14','15:15:00',1.41),('15529','2013-06-14','15:20:00',1.41),('15529','2013-06-14','15:30:00',1.86),('15529','2013-06-14','15:35:00',1.83),('15529','2013-06-14','15:40:00',1.79),('15529','2013-06-14','15:45:00',1.76),('15529','2013-06-14','15:50:00',1.73),('15529','2013-06-14','15:55:00',1.71),('15529','2013-06-14','16:00:00',1.68),('15529','2013-06-14','16:05:00',1.64),('15529','2013-06-14','16:10:00',1.6),('15529','2013-06-14','16:15:00',1.57),('15529','2013-06-14','16:20:00',1.53),('15529','2013-06-14','16:25:00',1.51),('15529','2013-06-14','16:30:00',1.47),('15529','2013-06-14','16:35:00',1.44),('15529','2013-06-14','16:40:00',1.41),('15529','2013-06-14','16:45:00',1.37),('15529','2013-06-14','16:50:00',1.32),('15529','2013-06-14','16:55:00',1.28),('15529','2013-06-14','17:00:00',1.24),('15529','2013-06-14','17:05:00',1.2),('15529','2013-06-14','17:10:00',1.16),('15529','2013-06-14','17:15:00',1.11),('15529','2013-06-14','17:20:00',1.07),('15529','2013-06-14','17:25:00',1.02),('15529','2013-06-13','08:40:00',1.02),('15529','2013-06-13','08:45:00',1.07),('15529','2013-06-13','08:50:00',1.09),('15529','2013-06-13','08:55:00',1.14),('15529','2013-06-13','09:00:00',1.19),('15529','2013-06-13','09:05:00',1.23),('15529','2013-06-13','09:10:00',1.26),('15529','2013-06-13','09:15:00',1.3),('15529','2013-06-13','09:20:00',1.33),('15529','2013-06-13','09:25:00',1.37),('15529','2013-06-13','09:30:00',1.39),('15529','2013-06-13','09:35:00',1.46),('15529','2013-06-13','09:40:00',1.49),('15529','2013-06-13','09:45:00',1.53),('15529','2013-06-13','09:50:00',1.57),('15529','2013-06-13','09:55:00',1.61),('15529','2013-06-13','10:00:00',1.64),('15529','2013-06-13','10:05:00',1.64),('15529','2013-06-13','10:10:00',1.68),('15529','2013-06-13','10:15:00',1.72),('15529','2013-06-13','10:20:00',1.77),('15529','2013-06-13','10:25:00',1.76),('15529','2013-06-13','10:30:00',1.73),('15529','2013-06-13','10:35:00',1.84),('15529','2013-06-13','10:40:00',1.87),('15529','2013-06-13','10:45:00',1.89),('15529','2013-06-13','10:50:00',1.89),('15529','2013-06-13','10:55:00',1.92),('15529','2013-06-13','11:00:00',1.96),('15529','2013-06-13','11:05:00',1.97),('15529','2013-06-13','11:10:00',1.99),('15529','2013-06-13','11:15:00',2),('15529','2013-06-13','11:20:00',1.97),('15529','2013-06-13','11:25:00',2.04),('15529','2013-06-13','11:30:00',2.08),('15529','2013-06-13','11:35:00',2.05),('15529','2013-06-13','11:40:00',2.08),('15529','2013-06-13','11:45:00',2.09),('15529','2013-06-13','11:50:00',2.08),('15529','2013-06-13','11:55:00',2.06),('15529','2013-06-13','12:00:00',2.13),('15529','2013-06-13','12:05:00',2.13),('15529','2013-06-13','12:10:00',2.15),('15529','2013-06-13','12:15:00',2.18),('15529','2013-06-13','12:20:00',2.22),('15529','2013-06-13','12:25:00',2.21),('15529','2013-06-13','12:30:00',2.19),('15529','2013-06-13','12:35:00',2.18),('15529','2013-06-13','12:40:00',2.23),('15529','2013-06-13','12:45:00',2.2),('15529','2013-06-13','12:50:00',2.22),('15529','2013-06-13','12:55:00',2.21),('15529','2013-06-13','13:00:00',2.23),('15529','2013-06-13','13:05:00',2.17),('15529','2013-06-13','13:10:00',2.23),('15529','2013-06-13','13:15:00',2.2),('15529','2013-06-13','13:20:00',2.2),('15529','2013-06-13','13:25:00',2.23),('15529','2013-06-13','13:30:00',2.19),('15529','2013-06-13','13:35:00',2.23),('15529','2013-06-13','13:40:00',2.23),('15529','2013-06-13','13:45:00',2.19),('15529','2013-06-13','13:50:00',2.2),('15529','2013-06-13','13:55:00',2.18),('15529','2013-06-13','14:00:00',2.13),('15529','2013-06-13','14:05:00',2.15),('15529','2013-06-13','14:10:00',2.12),('15529','2013-06-13','14:15:00',2.14),('15529','2013-06-13','14:20:00',2.14),('15529','2013-06-13','14:25:00',2.12),('15529','2013-06-13','14:30:00',2.13),('15529','2013-06-13','14:35:00',2.09),('15529','2013-06-13','14:40:00',2.1),('15529','2013-06-13','14:45:00',2.08),('15529','2013-06-13','14:50:00',2.04),('15529','2013-06-13','14:55:00',2.02),('15529','2013-06-13','15:00:00',2.02),('15529','2013-06-13','15:05:00',2),('15529','2013-06-13','15:10:00',1.98),('15529','2013-06-13','15:15:00',1.94),('15529','2013-06-13','15:20:00',1.92),('15529','2013-06-13','15:25:00',1.9),('15529','2013-06-13','15:30:00',1.89),('15529','2013-06-13','15:35:00',1.85),('15529','2013-06-13','15:40:00',1.84),('15529','2013-06-13','15:45:00',1.82),('15529','2013-06-13','15:50:00',1.77),('15529','2013-06-13','15:55:00',1.75),('15529','2013-06-13','16:00:00',1.71),('15529','2013-06-13','16:05:00',1.69),('15529','2013-06-13','16:10:00',1.66),('15529','2013-06-13','16:15:00',1.6),('15529','2013-06-13','16:20:00',1.56),('15529','2013-06-13','16:25:00',1.54),('15529','2013-06-13','16:30:00',1.51),('15529','2013-06-13','16:35:00',1.49),('15529','2013-06-13','16:40:00',1.43),('15529','2013-06-13','16:45:00',1.4),('15529','2013-06-13','16:50:00',1.36),('15529','2013-06-13','16:55:00',1.31),('15529','2013-06-13','17:00:00',1.27),('15529','2013-06-13','17:05:00',1.22),('15529','2013-06-13','17:10:00',1.17),('15529','2013-06-13','17:15:00',1.14),('15529','2013-06-13','17:20:00',1.1),('15529','2013-06-13','17:25:00',1.04),('15529','2013-06-12','08:40:00',1.03),('15529','2013-06-12','08:45:00',1.07),('15529','2013-06-12','08:50:00',1.12),('15529','2013-06-12','08:55:00',1.16),('15529','2013-06-12','09:00:00',1.2),('15529','2013-06-12','09:05:00',1.25),('15529','2013-06-12','09:10:00',1.29),('15529','2013-06-12','09:15:00',1.32),('15529','2013-06-12','09:20:00',1.37),('15529','2013-06-12','09:25:00',1.42),('15529','2013-06-12','09:30:00',1.45),('15529','2013-06-12','09:35:00',1.49),('15529','2013-06-12','09:40:00',1.54),('15529','2013-06-12','09:45:00',1.57),('15529','2013-06-12','09:50:00',1.6),('15529','2013-06-12','09:55:00',1.63),('15529','2013-06-12','10:00:00',1.66),('15529','2013-06-12','10:05:00',1.7),('15529','2013-06-12','10:10:00',1.73),('15529','2013-06-12','10:15:00',1.75),('15529','2013-06-12','10:20:00',1.76),('15529','2013-06-12','10:25:00',1.8),('15529','2013-06-12','10:30:00',1.83),('15529','2013-06-12','10:35:00',1.86),('15529','2013-06-12','10:40:00',1.89),('15529','2013-06-12','10:45:00',1.91),('15529','2013-06-12','10:50:00',1.93),('15529','2013-06-12','10:55:00',1.96),('15529','2013-06-12','11:00:00',1.96),('15529','2013-06-12','11:05:00',2),('15529','2013-06-12','11:10:00',2.03),('15529','2013-06-12','11:15:00',2.05),('15529','2013-06-12','11:20:00',2.06),('15529','2013-06-12','11:25:00',2.08),('15529','2013-06-12','11:30:00',2.11),('15529','2013-06-12','11:35:00',2.12),('15529','2013-06-12','11:40:00',2.14),('15529','2013-06-12','11:45:00',2.16),('15529','2013-06-12','11:50:00',2.17),('15529','2013-06-12','11:55:00',2.18),('15529','2013-06-12','12:00:00',2.15),('15529','2013-06-12','12:05:00',2.18),('15529','2013-06-12','12:10:00',2.19),('15529','2013-06-12','12:15:00',2.21),('15529','2013-06-12','12:20:00',2.2),('15529','2013-06-12','12:25:00',2.24),('15529','2013-06-12','12:30:00',2.24),('15529','2013-06-12','12:35:00',2.25),('15529','2013-06-12','12:40:00',2.24),('15529','2013-06-12','12:45:00',2.21),('15529','2013-06-12','12:50:00',2.25),('15529','2013-06-12','12:55:00',2.24),('15529','2013-06-12','13:00:00',2.2),('15529','2013-06-12','13:05:00',2.26),('15529','2013-06-12','13:10:00',2.24),('15529','2013-06-12','13:15:00',2.23),('15529','2013-06-12','13:20:00',2.24),('15529','2013-06-12','13:25:00',2.28),('15529','2013-06-12','13:30:00',2.26),('15529','2013-06-12','13:35:00',2.25),('15529','2013-06-12','13:40:00',2.25),('15529','2013-06-12','13:45:00',2.19),('15529','2013-06-12','13:50:00',2.26),('15529','2013-06-12','13:55:00',2.27),('15529','2013-06-12','14:00:00',2.18),('15529','2013-06-12','14:05:00',2.17),('15529','2013-06-12','14:10:00',2.16),('15529','2013-06-12','14:15:00',2.16),('15529','2013-06-12','14:20:00',2.15),('15529','2013-06-12','14:25:00',2.13),('15529','2013-06-12','14:30:00',2.15),('15529','2013-06-12','14:35:00',2.23),('15529','2013-06-12','14:40:00',2.17),('15529','2013-06-12','14:45:00',2.11),('15529','2013-06-12','14:50:00',2.08),('15529','2013-06-12','14:55:00',2.05),('15529','2013-06-12','15:00:00',2.03),('15529','2013-06-12','15:05:00',2.01),('15529','2013-06-12','15:10:00',1.98),('15529','2013-06-12','15:15:00',1.94),('15529','2013-06-12','15:20:00',1.93),('15529','2013-06-12','15:25:00',1.9),('15529','2013-06-12','15:30:00',1.89),('15529','2013-06-12','15:35:00',1.86),('15529','2013-06-12','15:40:00',1.81),('15529','2013-06-12','15:45:00',1.81),('15529','2013-06-12','15:50:00',1.77),('15529','2013-06-12','15:55:00',1.74),('15529','2013-06-12','16:00:00',1.7),('15529','2013-06-12','16:05:00',1.68),('15529','2013-06-12','16:10:00',1.65),('15529','2013-06-12','16:15:00',1.6),('15529','2013-06-12','16:20:00',1.56),('15529','2013-06-12','16:25:00',1.53),('15529','2013-06-12','16:30:00',1.48),('15529','2013-06-12','16:35:00',1.43),('15529','2013-06-12','16:40:00',1.39),('15529','2013-06-12','16:45:00',1.37),('15529','2013-06-12','16:50:00',1.35),('15529','2013-06-12','16:55:00',1.31),('15529','2013-06-12','17:00:00',1.26),('15529','2013-06-12','17:05:00',1.23),('15529','2013-06-12','17:10:00',1.18),('15529','2013-06-12','17:15:00',1.14),('15529','2013-06-12','17:20:00',1.1),('15529','2013-06-12','17:25:00',1.05),('15529','2013-06-12','17:30:00',1.01),('15529','2013-06-11','08:40:00',1.05),('15529','2013-06-11','08:45:00',1.09),('15529','2013-06-11','08:50:00',1.14),('15529','2013-06-11','08:55:00',1.18),('15529','2013-06-11','09:00:00',1.22),('15529','2013-06-11','09:05:00',1.26),('15529','2013-06-11','09:10:00',1.32),('15529','2013-06-11','09:15:00',1.36),('15529','2013-06-11','09:20:00',1.4),('15529','2013-06-11','09:25:00',1.43),('15529','2013-06-11','09:30:00',1.47),('15529','2013-06-11','09:35:00',1.5),('15529','2013-06-11','09:40:00',1.55),('15529','2013-06-11','09:45:00',1.58),('15529','2013-06-11','09:50:00',1.62),('15529','2013-06-11','09:55:00',1.66),('15529','2013-06-11','10:00:00',1.68),('15529','2013-06-11','10:05:00',1.73),('15529','2013-06-11','10:10:00',1.75),('15529','2013-06-11','10:15:00',1.77),('15529','2013-06-11','10:20:00',1.8),('15529','2013-06-11','10:25:00',1.82),('15529','2013-06-11','10:30:00',1.82),('15529','2013-06-11','10:35:00',1.87),('15529','2013-06-11','10:40:00',1.9),('15529','2013-06-11','10:45:00',1.91),('15529','2013-06-11','10:50:00',1.93),('15529','2013-06-11','10:55:00',1.95),('15529','2013-06-11','11:00:00',1.99),('15529','2013-06-11','11:05:00',2.01),('15529','2013-06-11','11:10:00',2.03),('15529','2013-06-11','11:15:00',2.04),('15529','2013-06-11','11:20:00',2.05),('15529','2013-06-11','11:25:00',2.08),('15529','2013-06-11','11:30:00',2.11),('15529','2013-06-11','11:35:00',2.15),('15529','2013-06-11','11:40:00',2.19),('15529','2013-06-11','11:45:00',2.19),('15529','2013-06-11','11:50:00',2.18),('15529','2013-06-11','11:55:00',2.18),('15529','2013-06-11','12:00:00',2.22),('15529','2013-06-11','12:05:00',2.22),('15529','2013-06-11','12:10:00',2.22),('15529','2013-06-11','12:15:00',2.22),('15529','2013-06-11','12:20:00',2.1),('15529','2013-06-11','12:25:00',2.23),('15529','2013-06-11','12:30:00',2.3),('15529','2013-06-11','12:35:00',2.28),('15529','2013-06-11','12:40:00',2.32),('15529','2013-06-11','12:45:00',2.33),('15529','2013-06-11','12:50:00',2.37),('15529','2013-06-11','12:55:00',2.37),('15529','2013-06-11','13:00:00',2.34),('15529','2013-06-11','13:05:00',2.3),('15529','2013-06-11','13:10:00',2.28),('15529','2013-06-11','13:15:00',2.29),('15529','2013-06-11','13:20:00',2.26),('15529','2013-06-11','13:25:00',2.26),('15529','2013-06-11','13:30:00',2.22),('15529','2013-06-11','13:35:00',2.28),('15529','2013-06-11','13:40:00',2.25),('15529','2013-06-11','13:45:00',2.09),('15529','2013-06-11','13:50:00',2.32),('15529','2013-06-11','13:55:00',2.41),('15529','2013-06-11','14:00:00',2.26),('15529','2013-06-11','14:10:00',1.11),('15529','2013-06-11','14:15:00',1.65),('15529','2013-06-11','14:20:00',2.43),('15529','2013-06-11','14:25:00',2.13),('15529','2013-06-11','14:30:00',2.21),('15529','2013-06-11','14:35:00',2.13),('15529','2013-06-11','14:40:00',2.13),('15529','2013-06-11','14:45:00',2.14),('15529','2013-06-11','14:50:00',2.15),('15529','2013-06-11','14:55:00',2.09),('15529','2013-06-11','15:00:00',2.09),('15529','2013-06-11','15:05:00',2.06),('15529','2013-06-11','15:10:00',2.06),('15529','2013-06-11','15:15:00',2.03),('15529','2013-06-11','15:20:00',1.94),('15529','2013-06-11','15:25:00',1.97),('15529','2013-06-11','15:30:00',1.83),('15529','2013-06-11','15:35:00',1.86),('15529','2013-06-11','15:40:00',1.88),('15529','2013-06-11','15:45:00',1.83),('15529','2013-06-11','15:50:00',1.82),('15529','2013-06-11','15:55:00',1.82),('15529','2013-06-11','16:05:00',1.39),('15529','2013-06-11','16:10:00',1.71),('15529','2013-06-11','16:15:00',1.64),('15529','2013-06-11','16:20:00',1.6),('15529','2013-06-11','16:25:00',1.6),('15529','2013-06-11','16:30:00',1.61),('15529','2013-06-11','16:35:00',1.05),('15529','2013-06-11','16:40:00',1.5),('15529','2013-06-11','16:45:00',1.37),('15529','2013-06-11','16:50:00',1.36),('15529','2013-06-11','16:55:00',1.31),('15529','2013-06-11','17:00:00',1.31),('15529','2013-06-11','17:05:00',1.28),('15529','2013-06-11','17:10:00',1.23),('15529','2013-06-11','17:15:00',1.18),('15529','2013-06-11','17:20:00',1.14),('15529','2013-06-11','17:25:00',1.08),('15529','2013-06-11','17:30:00',1.04),('15529','2013-06-11','17:35:00',1.01),('15529','2013-06-10','08:30:00',1.11),('15529','2013-06-10','08:45:00',1.06),('15529','2013-06-10','08:50:00',1),('15529','2013-06-10','08:55:00',1.2),('15529','2013-06-10','09:00:00',1.06),('15529','2013-06-10','09:10:00',1.34),('15529','2013-06-10','09:15:00',1.47),('15529','2013-06-10','09:20:00',1.4),('15529','2013-06-10','09:25:00',1.35),('15529','2013-06-10','09:30:00',1.34),('15529','2013-06-10','09:35:00',1.56),('15529','2013-06-10','09:40:00',1.64),('15529','2013-06-10','09:45:00',1.67),('15529','2013-06-10','09:50:00',1.68),('15529','2013-06-10','09:55:00',1.68),('15529','2013-06-10','10:00:00',1.72),('15529','2013-06-10','10:05:00',1.73),('15529','2013-06-10','10:10:00',1.75),('15529','2013-06-10','10:15:00',1.29),('15529','2013-06-10','10:20:00',1.9),('15529','2013-06-10','10:25:00',1.86),('15529','2013-06-10','10:40:00',2.08),('15529','2013-06-10','10:45:00',1.85),('15529','2013-06-10','10:50:00',2.05),('15529','2013-06-10','10:55:00',2.17),('15529','2013-06-10','11:05:00',1.56),('15529','2013-06-10','11:10:00',2.13),('15529','2013-06-10','11:15:00',2.1),('15529','2013-06-10','11:20:00',2.15),('15529','2013-06-10','11:25:00',2.15),('15529','2013-06-10','11:30:00',2.17),('15529','2013-06-10','11:35:00',2.16),('15529','2013-06-10','11:40:00',2.15),('15529','2013-06-10','11:45:00',2.18),('15529','2013-06-10','11:50:00',2.2),('15529','2013-06-10','11:55:00',2.23),('15529','2013-06-10','12:00:00',2.29),('15529','2013-06-10','12:05:00',2.23),('15529','2013-06-10','12:10:00',2.25),('15529','2013-06-10','12:15:00',2.28),('15529','2013-06-10','12:20:00',2.3),('15529','2013-06-10','12:25:00',2.25),('15529','2013-06-10','12:30:00',2.29),('15529','2013-06-10','12:35:00',2.18),('15529','2013-06-10','12:40:00',2.05),('15529','2013-06-10','12:45:00',2.27),('15529','2013-06-10','12:50:00',2.31),('15529','2013-06-10','12:55:00',2.33),('15529','2013-06-10','13:00:00',2.3),('15529','2013-06-10','13:05:00',2.35),('15529','2013-06-10','13:10:00',2.31),('15529','2013-06-10','13:15:00',2.3),('15529','2013-06-10','13:20:00',2.33),('15529','2013-06-10','13:25:00',2.37),('15529','2013-06-10','13:30:00',2.34),('15529','2013-06-10','13:35:00',2.3),('15529','2013-06-10','13:40:00',1.71),('15529','2013-06-10','13:45:00',2.18),('15529','2013-06-10','13:50:00',2.27),('15529','2013-06-10','13:55:00',2.3),('15529','2013-06-10','14:00:00',2.25),('15529','2013-06-10','14:05:00',2.23),('15529','2013-06-10','14:10:00',2.24),('15529','2013-06-10','14:15:00',2.26),('15529','2013-06-10','14:20:00',2.21),('15529','2013-06-10','14:25:00',2.19),('15529','2013-06-10','14:30:00',2.2),('15529','2013-06-10','14:35:00',2.19),('15529','2013-06-10','14:40:00',2.14),('15529','2013-06-10','14:45:00',2.15),('15529','2013-06-10','14:50:00',2.13),('15529','2013-06-10','14:55:00',2.11),('15529','2013-06-10','15:00:00',2.05),('15529','2013-06-10','15:05:00',2.05),('15529','2013-06-10','15:10:00',2.04),('15529','2013-06-10','15:15:00',1.99),('15529','2013-06-10','15:20:00',1.96),('15529','2013-06-10','15:25:00',1.88),('15529','2013-06-10','15:30:00',1.54),('15529','2013-06-10','15:35:00',1.94),('15529','2013-06-10','15:40:00',1.67),('15529','2013-06-10','15:45:00',1.76),('15529','2013-06-10','15:50:00',1.76),('15529','2013-06-10','15:55:00',1.61),('15529','2013-06-10','16:00:00',1.81),('15529','2013-06-10','16:05:00',1.76),('15529','2013-06-10','16:10:00',1.71),('15529','2013-06-10','16:15:00',1.67),('15529','2013-06-10','16:20:00',1.64),('15529','2013-06-10','16:25:00',1.6),('15529','2013-06-10','16:30:00',1.57),('15529','2013-06-10','16:35:00',1.53),('15529','2013-06-10','16:40:00',1.51),('15529','2013-06-10','16:45:00',1.53),('15529','2013-06-10','16:50:00',1.52),('15529','2013-06-10','16:55:00',1.46),('15529','2014-04-02','09:55:00',1.01),('15529','2014-04-02','10:00:00',1.24),('15529','2014-04-02','10:05:00',1.41),('15529','2014-04-02','10:10:00',1.52),('15529','2014-04-02','10:15:00',1.77),('15529','2014-04-02','10:20:00',1.67),('15529','2014-04-02','10:25:00',1.59),('15529','2014-04-02','10:30:00',1.53),('15529','2014-04-02','10:35:00',1.53),('15529','2014-04-02','10:40:00',1.22),('15529','2014-04-02','10:45:00',1.3),('15529','2014-04-02','10:50:00',1.06),('15529','2014-04-02','10:55:00',1.14),('15529','2014-04-02','11:50:00',1.15),('15529','2014-04-02','11:55:00',1.19),('15529','2014-04-02','12:00:00',1.15),('15529','2014-04-02','12:05:00',1.14),('15529','2014-04-02','12:10:00',1.09),('15529','2014-04-02','12:15:00',1.09),('15529','2014-04-02','12:20:00',1.32),('15529','2014-04-02','12:25:00',1.67),('15529','2014-04-02','12:30:00',2.15),('15529','2014-04-02','12:35:00',2.01),('15529','2014-04-02','12:40:00',1.91),('15529','2014-04-02','12:45:00',1.19),('15529','2014-04-02','12:50:00',1.5),('15529','2014-04-02','12:55:00',1.42),('15529','2014-04-02','13:00:00',1.22),('15529','2014-04-02','13:05:00',1.65),('15529','2014-04-02','13:10:00',1.61),('15529','2014-04-02','13:15:00',2.1),('15529','2014-04-02','13:20:00',1.14),('15529','2014-04-02','13:25:00',1.31),('15529','2014-04-02','13:30:00',1.8),('15529','2014-04-02','13:35:00',2.38),('15529','2014-04-02','13:40:00',1.95),('15529','2014-04-02','13:45:00',1.04),('15529','2014-04-02','13:50:00',1.12),('15529','2014-04-02','13:55:00',1.64),('15529','2014-04-02','14:00:00',1.91),('15529','2014-04-02','14:05:00',1.86),('15529','2014-04-02','14:10:00',1.54),('15529','2014-04-02','14:15:00',2.06),('15529','2014-04-02','14:20:00',1.99),('15529','2014-04-02','14:25:00',2.04),('15529','2014-04-02','14:30:00',2.22),('15529','2014-04-02','14:35:00',2.21),('15529','2014-04-02','14:40:00',2.07),('15529','2014-04-02','14:45:00',2.09),('15529','2014-04-02','14:50:00',2.05),('15529','2014-04-02','14:55:00',1.98),('15529','2014-04-02','15:00:00',1.99),('15529','2014-04-02','15:05:00',1.97),('15529','2014-04-02','15:10:00',1.94),('15529','2014-04-02','15:15:00',1.91),('15529','2014-04-02','15:20:00',1.93),('15529','2014-04-02','15:25:00',1.9),('15529','2014-04-02','15:30:00',1.85),('15529','2014-04-02','15:35:00',1.85),('15529','2014-04-02','15:40:00',1.83),('15529','2014-04-02','15:45:00',1.81),('15529','2014-04-02','15:50:00',1.81),('15529','2014-04-02','15:55:00',1.79),('15529','2014-04-02','16:00:00',1.76),('15529','2014-04-02','16:05:00',1.71),('15529','2014-04-02','16:10:00',1.71),('15529','2014-04-02','16:15:00',1.65),('15529','2014-04-02','16:20:00',1.56),('15529','2014-04-02','16:25:00',1.51),('15529','2014-04-02','16:30:00',1.49),('15529','2014-04-02','16:35:00',1.43),('15529','2014-04-02','16:40:00',1.39),('15529','2014-04-02','16:45:00',1.3),('15529','2014-04-02','16:50:00',1.04),('15529','2013-06-09','09:15:00',1.07),('15529','2013-06-09','09:20:00',1.45),('15529','2013-06-09','09:25:00',1.5),('15529','2013-06-09','09:45:00',1.28),('15529','2013-06-09','09:50:00',1.4),('15529','2013-06-09','10:00:00',1.15),('15529','2013-06-09','10:05:00',1.6),('15529','2013-06-09','10:10:00',1.57),('15529','2013-06-09','10:15:00',1.67),('15529','2013-06-09','10:20:00',1.08),('15529','2013-06-09','10:30:00',1.08),('15529','2013-06-09','10:50:00',1.39),('15529','2013-06-09','10:55:00',1.01),('15529','2013-06-09','11:05:00',1.47),('15529','2013-06-09','11:10:00',1.94),('15529','2013-06-09','11:15:00',2.26),('15529','2013-06-09','11:20:00',2.09),('15529','2013-06-09','11:25:00',2.11),('15529','2013-06-09','11:35:00',1.58),('15529','2013-06-09','11:40:00',2.09),('15529','2013-06-09','11:45:00',1.8),('15529','2013-06-09','11:50:00',2.2),('15529','2013-06-09','11:55:00',1.61),('15529','2013-06-09','12:05:00',1.13),('15529','2013-06-09','12:10:00',1.26),('15529','2013-06-09','12:15:00',1.81),('15529','2013-06-09','12:20:00',2.59),('15529','2013-06-09','12:25:00',1.65),('15529','2013-06-09','12:30:00',1.68),('15529','2013-06-09','12:35:00',1.6),('15529','2013-06-09','12:40:00',2.41),('15529','2013-06-09','12:45:00',2.04),('15529','2013-06-09','12:50:00',2.09),('15529','2013-06-09','12:55:00',2.41),('15529','2013-06-09','13:00:00',1.43),('15529','2013-06-09','13:05:00',1.2),('15529','2013-06-09','13:10:00',2.56),('15529','2013-06-09','13:15:00',2.02),('15529','2013-06-09','13:20:00',1.47),('15529','2013-06-09','13:25:00',1.73),('15529','2013-06-09','13:30:00',2.5),('15529','2013-06-09','13:35:00',2.57),('15529','2013-06-09','13:40:00',2.2),('15529','2013-06-09','13:45:00',1.46),('15529','2013-06-09','13:50:00',1.8),('15529','2013-06-09','13:55:00',2.31),('15529','2013-06-09','14:00:00',1.59),('15529','2013-06-09','14:05:00',1.18),('15529','2013-06-09','14:10:00',1.72),('15529','2013-06-09','14:15:00',2.36),('15529','2013-06-09','14:20:00',2.3),('15529','2013-06-09','14:25:00',2.25),('15529','2013-06-09','14:30:00',2.26),('15529','2013-06-09','14:35:00',1.14),('15529','2013-06-09','14:40:00',2.18),('15529','2013-06-09','14:45:00',2.14),('15529','2013-06-09','14:50:00',2.15),('15529','2013-06-09','14:55:00',2.11),('15529','2013-06-09','15:00:00',2.11),('15529','2013-06-09','15:05:00',2.06),('15529','2013-06-09','15:10:00',2.07),('15529','2013-06-09','15:15:00',2.04),('15529','2013-06-09','15:20:00',2.01),('15529','2013-06-09','15:25:00',1.98),('15529','2013-06-09','15:30:00',1.98),('15529','2013-06-09','15:35:00',1.95),('15529','2013-06-09','15:40:00',1.93),('15529','2013-06-09','15:45:00',1.89),('15529','2013-06-09','15:50:00',1.86),('15529','2013-06-09','15:55:00',1.85),('15529','2013-06-09','16:00:00',1.81),('15529','2013-06-09','16:05:00',1.76),('15529','2013-06-09','16:10:00',1.73),('15529','2013-06-09','16:15:00',1.69),('15529','2013-06-09','16:20:00',1.66),('15529','2013-06-09','16:25:00',1.62),('15529','2013-06-09','16:30:00',1.59),('15529','2013-06-09','16:35:00',1.55),('15529','2013-06-09','16:40:00',1.51),('15529','2013-06-09','16:45:00',1.48),('15529','2013-06-09','16:50:00',1.44),('15529','2013-06-09','16:55:00',1.39),('15529','2013-06-09','17:00:00',1.34),('15529','2013-06-09','17:05:00',1.3),('15529','2013-06-09','17:10:00',1.26),('15529','2013-06-09','17:15:00',1.22),('15529','2013-06-09','17:20:00',1.18),('15529','2013-06-09','17:25:00',1.12),('15529','2013-06-09','17:30:00',1.08),('15529','2013-06-09','17:35:00',1.02),('15529','2013-06-08','08:40:00',1.03),('15529','2013-06-08','08:45:00',1.03),('15529','2013-06-08','08:50:00',1.07),('15529','2013-06-08','08:55:00',1.09),('15529','2013-06-08','09:00:00',1.14),('15529','2013-06-08','09:05:00',1.18),('15529','2013-06-08','09:10:00',1.24),('15529','2013-06-08','09:15:00',1.28),('15529','2013-06-08','09:20:00',1.3),('15529','2013-06-08','09:25:00',1.34),('15529','2013-06-08','09:30:00',1.37),('15529','2013-06-08','09:35:00',1.42),('15529','2013-06-08','09:40:00',1.45),('15529','2013-06-08','09:45:00',1.5),('15529','2013-06-08','09:50:00',1.53),('15529','2013-06-08','09:55:00',1.58),('15529','2013-06-08','10:00:00',1.6),('15529','2013-06-08','10:05:00',1.64),('15529','2013-06-08','10:10:00',1.65),('15529','2013-06-08','10:15:00',1.66),('15529','2013-06-08','10:20:00',1.73),('15529','2013-06-08','10:25:00',1.74),('15529','2013-06-08','10:30:00',1.76),('15529','2013-06-08','10:35:00',1.81),('15529','2013-06-08','10:40:00',1.82),('15529','2013-06-08','10:45:00',1.82),('15529','2013-06-08','10:50:00',1.84),('15529','2013-06-08','10:55:00',1.9),('15529','2013-06-08','11:00:00',1.92),('15529','2013-06-08','11:05:00',1.94),('15529','2013-06-08','11:10:00',1.96),('15529','2013-06-08','11:15:00',1.96),('15529','2013-06-08','11:20:00',1.93),('15529','2013-06-08','11:25:00',1.97),('15529','2013-06-08','11:30:00',1.95),('15529','2013-06-08','11:35:00',1.96),('15529','2013-06-08','11:40:00',1.96),('15529','2013-06-08','11:45:00',1.97),('15529','2013-06-08','11:50:00',2.04),('15529','2013-06-08','11:55:00',2.05),('15529','2013-06-08','12:00:00',2.08),('15529','2013-06-08','12:05:00',2.09),('15529','2013-06-08','12:10:00',2),('15529','2013-06-08','12:15:00',2.17),('15529','2013-06-08','12:20:00',2.16),('15529','2013-06-08','12:25:00',2.17),('15529','2013-06-08','12:30:00',2.19),('15529','2013-06-08','12:35:00',2.19),('15529','2013-06-08','12:40:00',2.12),('15529','2013-06-08','12:45:00',2.05),('15529','2013-06-08','12:50:00',1.99),('15529','2013-06-08','12:55:00',2.28),('15529','2013-06-08','13:00:00',1.9),('15529','2013-06-08','13:05:00',1.72),('15529','2013-06-08','13:10:00',2.06),('15529','2013-06-08','13:15:00',2.22),('15529','2013-06-08','13:20:00',1.89),('15529','2013-06-08','13:25:00',1.76),('15529','2013-06-08','13:30:00',2.21),('15529','2013-06-08','13:35:00',2.29),('15529','2013-06-08','13:40:00',1.81),('15529','2013-06-08','13:45:00',2.43),('15529','2013-06-08','13:50:00',1.94),('15529','2013-06-08','13:55:00',2.32),('15529','2013-06-08','14:00:00',2.39),('15529','2013-06-08','14:05:00',1.95),('15529','2013-06-08','14:10:00',2.4),('15529','2013-06-08','14:15:00',1.95),('15529','2013-06-08','14:30:00',1.01),('15529','2013-06-08','14:35:00',2.23),('15529','2013-06-08','14:40:00',1.69),('15529','2013-06-08','14:45:00',2.02),('15529','2013-06-08','14:50:00',2.13),('15529','2013-06-08','14:55:00',2.1),('15529','2013-06-08','15:00:00',2.1),('15529','2013-06-08','15:05:00',2.04),('15529','2013-06-08','15:10:00',2.01),('15529','2013-06-08','15:15:00',1.94),('15529','2013-06-08','15:20:00',1.98),('15529','2013-06-08','15:25:00',1.98),('15529','2013-06-08','15:30:00',1.89),('15529','2013-06-08','15:35:00',1.94),('15529','2013-06-08','15:40:00',1.35),('15529','2013-06-08','15:45:00',1.6),('15529','2013-06-08','15:50:00',1.73),('15529','2013-06-08','15:55:00',1.81),('15529','2013-06-08','16:00:00',1.64),('15529','2013-06-08','16:05:00',1.61),('15529','2013-06-08','16:10:00',1.63),('15529','2013-06-08','16:15:00',1.11),('15529','2013-06-08','16:20:00',1.2),('15529','2013-06-07','08:40:00',1.01),('15529','2013-06-07','08:45:00',1.05),('15529','2013-06-07','08:50:00',1.1),('15529','2013-06-07','08:55:00',1.13),('15529','2013-06-07','09:00:00',1.16),('15529','2013-06-07','09:05:00',1.22),('15529','2013-06-07','09:10:00',1.25),('15529','2013-06-07','09:15:00',1.3),('15529','2013-06-07','09:20:00',1.35),('15529','2013-06-07','09:25:00',1.36),('15529','2013-06-07','09:30:00',1.39),('15529','2013-06-07','09:35:00',1.39),('15529','2013-06-07','09:40:00',1.45),('15529','2013-06-07','09:45:00',1.5),('15529','2013-06-07','09:50:00',1.57),('15529','2013-06-07','09:55:00',1.53),('15529','2013-06-07','10:00:00',1.1),('15529','2013-06-07','10:05:00',1.71),('15529','2013-06-07','10:10:00',1.73),('15529','2013-06-07','10:15:00',1.85),('15529','2013-06-07','10:20:00',1.85),('15529','2013-06-07','10:25:00',1.82),('15529','2013-06-07','10:30:00',1.23),('15529','2013-06-07','10:35:00',1.42),('15529','2013-06-07','10:40:00',1.39),('15529','2013-06-07','10:45:00',1.69),('15529','2013-06-07','10:50:00',2.13),('15529','2013-06-07','10:55:00',1.19),('15529','2013-06-07','11:25:00',1.06),('15529','2013-06-07','11:30:00',2.24),('15529','2013-06-07','11:35:00',2.28),('15529','2013-06-07','11:40:00',2.22),('15529','2013-06-07','11:45:00',1.48),('15529','2013-06-07','11:50:00',2.25),('15529','2013-06-07','11:55:00',2.36),('15529','2013-06-07','12:00:00',2.09),('15529','2013-06-07','12:10:00',2.26),('15529','2013-06-07','12:15:00',2.37),('15529','2013-06-07','12:20:00',2.36),('15529','2013-06-07','12:25:00',2.23),('15529','2013-06-07','12:30:00',2.18),('15529','2013-06-07','12:35:00',2.26),('15529','2013-06-07','12:40:00',2.19),('15529','2013-06-07','12:45:00',2.22),('15529','2013-06-07','12:50:00',2.32),('15529','2013-06-07','12:55:00',2.21),('15529','2013-06-07','13:00:00',2.34),('15529','2013-06-07','13:05:00',2.29),('15529','2013-06-07','13:10:00',2.27),('15529','2013-06-07','13:15:00',2.31),('15529','2013-06-07','13:20:00',2.34),('15529','2013-06-07','13:25:00',2.31),('15529','2013-06-07','13:30:00',2.32),('15529','2013-06-07','13:35:00',2.29),('15529','2013-06-07','13:40:00',2.27),('15529','2013-06-07','13:45:00',2.29),('15529','2013-06-07','13:50:00',2.28),('15529','2013-06-07','13:55:00',2.25),('15529','2013-06-07','14:00:00',2.23),('15529','2013-06-07','14:05:00',2.27),('15529','2013-06-07','14:10:00',2.25),('15529','2013-06-07','14:15:00',2.2),('15529','2013-06-07','14:20:00',2.2),('15529','2013-06-07','14:25:00',2.22),('15529','2013-06-07','14:30:00',2.17),('15529','2013-06-07','14:35:00',2.17),('15529','2013-06-07','14:40:00',2.15),('15529','2013-06-07','14:45:00',2.12),('15529','2013-06-07','14:50:00',2.11),('15529','2013-06-07','14:55:00',2.12),('15529','2013-06-07','15:00:00',2.09),('15529','2013-06-07','15:05:00',2),('15529','2013-06-07','15:10:00',1.84),('15529','2013-06-07','15:15:00',2.01),('15529','2013-06-07','15:20:00',2.02),('15529','2013-06-07','15:25:00',1.84),('15529','2013-06-07','15:30:00',1.88),('15529','2013-06-07','15:35:00',1.79),('15529','2013-06-07','15:40:00',1.83),('15529','2013-06-07','15:45:00',2.02),('15529','2013-06-07','15:50:00',1.95),('15529','2013-06-07','15:55:00',1.79),('15529','2013-06-07','16:00:00',1.8),('15529','2013-06-07','16:05:00',1.75),('15529','2013-06-07','16:10:00',1.74),('15529','2013-06-07','16:15:00',1.71),('15529','2013-06-07','16:20:00',1.68),('15529','2013-06-07','16:25:00',1.6),('15529','2013-06-07','16:30:00',1.54),('15529','2013-06-07','16:35:00',1.5),('15529','2013-06-07','16:40:00',1.46),('15529','2013-06-07','16:45:00',1.39),('15529','2013-06-07','16:50:00',1.17),('15529','2013-06-07','16:55:00',1.32),('15529','2013-06-07','17:00:00',1.31),('15529','2013-06-07','17:05:00',1.29),('15529','2013-06-07','17:10:00',1.32),('15529','2013-06-07','17:15:00',1.26),('15529','2013-06-07','17:20:00',1.18),('15529','2013-06-07','17:25:00',1.08),('15529','2013-06-07','17:40:00',1.05),('15529','2013-06-06','08:40:00',1.04),('15529','2013-06-06','08:45:00',1.09),('15529','2013-06-06','08:50:00',1.13),('15529','2013-06-06','08:55:00',1.18),('15529','2013-06-06','09:00:00',1.22),('15529','2013-06-06','09:05:00',1.26),('15529','2013-06-06','09:10:00',1.31),('15529','2013-06-06','09:15:00',1.34),('15529','2013-06-06','09:20:00',1.38),('15529','2013-06-06','09:25:00',1.42),('15529','2013-06-06','09:30:00',1.46),('15529','2013-06-06','09:35:00',1.5),('15529','2013-06-06','09:40:00',1.53),('15529','2013-06-06','09:45:00',1.57),('15529','2013-06-06','09:50:00',1.61),('15529','2013-06-06','09:55:00',1.65),('15529','2013-06-06','10:00:00',1.7),('15529','2013-06-06','10:05:00',1.72),('15529','2013-06-06','10:10:00',1.76),('15529','2013-06-06','10:15:00',1.78),('15529','2013-06-06','10:20:00',1.82),('15529','2013-06-06','10:25:00',1.85),('15529','2013-06-06','10:30:00',1.88),('15529','2013-06-06','10:35:00',1.91),('15529','2013-06-06','10:40:00',1.93),('15529','2013-06-06','10:45:00',1.95),('15529','2013-06-06','10:50:00',1.98),('15529','2013-06-06','10:55:00',2.01),('15529','2013-06-06','11:00:00',2.04),('15529','2013-06-06','11:05:00',2.06),('15529','2013-06-06','11:10:00',2.08),('15529','2013-06-06','11:15:00',2.09),('15529','2013-06-06','11:20:00',2.11),('15529','2013-06-06','11:25:00',2.14),('15529','2013-06-06','11:30:00',2.11),('15529','2013-06-06','11:35:00',2.16),('15529','2013-06-06','11:40:00',2.19),('15529','2013-06-06','11:45:00',2.22),('15529','2013-06-06','11:50:00',2.21),('15529','2013-06-06','11:55:00',2.22),('15529','2013-06-06','12:00:00',2.24),('15529','2013-06-06','12:05:00',2.2),('15529','2013-06-06','12:10:00',2.26),('15529','2013-06-06','12:15:00',2.27),('15529','2013-06-06','12:20:00',2.25),('15529','2013-06-06','12:25:00',2.26),('15529','2013-06-06','12:30:00',2.29),('15529','2013-06-06','12:35:00',2.28),('15529','2013-06-06','12:40:00',2.3),('15529','2013-06-06','12:45:00',2.3),('15529','2013-06-06','12:50:00',2.24),('15529','2013-06-06','12:55:00',2.25),('15529','2013-06-06','13:00:00',2.28),('15529','2013-06-06','13:05:00',2.3),('15529','2013-06-06','13:10:00',2.31),('15529','2013-06-06','13:15:00',2.28),('15529','2013-06-06','13:20:00',2.28),('15529','2013-06-06','13:25:00',2.26),('15529','2013-06-06','13:30:00',2.28),('15529','2013-06-06','13:35:00',2.25),('15529','2013-06-06','13:40:00',2.25),('15529','2013-06-06','13:45:00',2.22),('15529','2013-06-06','13:50:00',2.22),('15529','2013-06-06','13:55:00',2.23),('15529','2013-06-06','14:00:00',2.2),('15529','2013-06-06','14:05:00',2.19),('15529','2013-06-06','14:10:00',2.16),('15529','2013-06-06','14:15:00',2.18),('15529','2013-06-06','14:20:00',2.14),('15529','2013-06-06','14:25:00',2.1),('15529','2013-06-06','14:30:00',2.1),('15529','2013-06-06','14:35:00',2.05),('15529','2013-06-06','14:40:00',2.09),('15529','2013-06-06','14:45:00',2.04),('15529','2013-06-06','14:50:00',2.03),('15529','2013-06-06','14:55:00',2.02),('15529','2013-06-06','15:00:00',1.41),('15529','2013-06-06','15:05:00',2.09),('15529','2013-06-06','15:10:00',1.99),('15529','2013-06-06','15:15:00',2),('15529','2013-06-06','15:20:00',1.97),('15529','2013-06-06','15:25:00',1.95),('15529','2013-06-06','15:30:00',1.9),('15529','2013-06-06','15:35:00',1.86),('15529','2013-06-06','15:40:00',1.86),('15529','2013-06-06','15:45:00',1.83),('15529','2013-06-06','15:50:00',1.79),('15529','2013-06-06','15:55:00',1.76),('15529','2013-06-06','16:00:00',1.72),('15529','2013-06-06','16:05:00',1.66),('15529','2013-06-06','16:10:00',1.59),('15529','2013-06-06','16:15:00',1.55),('15529','2013-06-06','16:20:00',1.58),('15529','2013-06-06','16:25:00',1.57),('15529','2013-06-06','16:30:00',1.53),('15529','2013-06-06','16:35:00',1.5),('15529','2013-06-06','16:40:00',1.46),('15529','2013-06-06','16:45:00',1.42),('15529','2013-06-06','16:50:00',1.37),('15529','2013-06-06','16:55:00',1.33),('15529','2013-06-06','17:00:00',1.29),('15529','2013-06-06','17:05:00',1.25),('15529','2013-06-06','17:10:00',1.2),('15529','2013-06-06','17:15:00',1.16),('15529','2013-06-06','17:20:00',1.11),('15529','2013-06-06','17:25:00',1.08),('15529','2013-06-06','17:30:00',1.03),('15529','2013-06-05','08:45:00',1.07),('15529','2013-06-05','08:50:00',1.11),('15529','2013-06-05','08:55:00',1.17),('15529','2013-06-05','09:00:00',1.2),('15529','2013-06-05','09:05:00',1.24),('15529','2013-06-05','09:10:00',1.28),('15529','2013-06-05','09:15:00',1.34),('15529','2013-06-05','09:20:00',1.39),('15529','2013-06-05','09:25:00',1.41),('15529','2013-06-05','09:30:00',1.45),('15529','2013-06-05','09:35:00',1.47),('15529','2013-06-05','09:40:00',1.52),('15529','2013-06-05','09:45:00',1.57),('15529','2013-06-05','09:50:00',1.61),('15529','2013-06-05','09:55:00',1.61),('15529','2013-06-05','10:00:00',1.63),('15529','2013-06-05','10:05:00',1.7),('15529','2013-06-05','10:10:00',1.73),('15529','2013-06-05','10:15:00',1.72),('15529','2013-06-05','10:20:00',1.76),('15529','2013-06-05','10:25:00',1.8),('15529','2013-06-05','10:30:00',1.82),('15529','2013-06-05','10:35:00',1.87),('15529','2013-06-05','10:40:00',1.9),('15529','2013-06-05','10:45:00',1.9),('15529','2013-06-05','10:50:00',1.95),('15529','2013-06-05','10:55:00',1.99),('15529','2013-06-05','11:00:00',1.98),('15529','2013-06-05','11:05:00',2.01),('15529','2013-06-05','11:10:00',2.04),('15529','2013-06-05','11:15:00',2.03),('15529','2013-06-05','11:20:00',2.06),('15529','2013-06-05','11:25:00',2.07),('15529','2013-06-05','11:30:00',2.1),('15529','2013-06-05','11:35:00',2.07),('15529','2013-06-05','11:40:00',2.13),('15529','2013-06-05','11:45:00',2.15),('15529','2013-06-05','11:50:00',2.14),('15529','2013-06-05','11:55:00',2.17),('15529','2013-06-05','12:00:00',2.18),('15529','2013-06-05','12:05:00',2.16),('15529','2013-06-05','12:10:00',2.23),('15529','2013-06-05','12:15:00',2.22),('15529','2013-06-05','12:20:00',2.2),('15529','2013-06-05','12:25:00',2.21),('15529','2013-06-05','12:30:00',2.18),('15529','2013-06-05','12:35:00',1.93),('15529','2013-06-05','12:40:00',2.15),('15529','2013-06-05','12:45:00',2.24),('15529','2013-06-05','12:50:00',1.89),('15529','2013-06-05','12:55:00',1.96),('15529','2013-06-05','13:00:00',2.35),('15529','2013-06-05','13:05:00',2.33),('15529','2013-06-05','13:10:00',2.37),('15529','2013-06-05','13:15:00',2.3),('15529','2013-06-05','13:20:00',2.3),('15529','2013-06-05','13:25:00',2.28),('15529','2013-06-05','13:30:00',2.31),('15529','2013-06-05','13:35:00',2.32),('15529','2013-06-05','13:40:00',2.34),('15529','2013-06-05','13:45:00',2.33),('15529','2013-06-05','13:50:00',2.25),('15529','2013-06-05','13:55:00',2.19),('15529','2013-06-05','14:00:00',2.21),('15529','2013-06-05','14:05:00',2.17),('15529','2013-06-05','14:10:00',2.15),('15529','2013-06-05','14:15:00',2.14),('15529','2013-06-05','14:20:00',2.05),('15529','2013-06-05','14:25:00',2.12),('15529','2013-06-05','14:30:00',2.09),('15529','2013-06-05','14:35:00',2.08),('15529','2013-06-05','14:40:00',2.12),('15529','2013-06-05','14:45:00',2.13),('15529','2013-06-05','14:50:00',2.08),('15529','2013-06-05','14:55:00',2.08),('15529','2013-06-05','15:00:00',2.05),('15529','2013-06-05','15:05:00',2.01),('15529','2013-06-05','15:10:00',2.02),('15529','2013-06-05','15:15:00',1.98),('15529','2013-06-05','15:20:00',1.96),('15529','2013-06-05','15:25:00',1.87),('15529','2013-06-05','15:30:00',1.85),('15529','2013-06-05','15:35:00',1.81),('15529','2013-06-05','15:40:00',1.73),('15529','2013-06-05','15:45:00',1.78),('15529','2013-06-05','15:50:00',1.77),('15529','2013-06-05','15:55:00',1.72),('15529','2013-06-05','16:00:00',1.75),('15529','2013-06-05','16:05:00',1.72),('15529','2013-06-05','16:10:00',1.64),('15529','2013-06-05','16:15:00',1.61),('15529','2013-06-05','16:20:00',1.55),('15529','2013-06-05','16:25:00',1.53),('15529','2013-06-05','16:30:00',1.51),('15529','2013-06-05','16:35:00',1.46),('15529','2013-06-05','16:40:00',1.43),('15529','2013-06-05','16:45:00',1.39),('15529','2013-06-05','16:50:00',1.35),('15529','2013-06-05','16:55:00',1.31),('15529','2013-06-05','17:00:00',1.26),('15529','2013-06-05','17:05:00',1.21),('15529','2013-06-05','17:10:00',1.17),('15529','2013-06-05','17:15:00',1.14),('15529','2013-06-05','17:20:00',1.09),('15529','2013-06-05','17:25:00',1.04),('15529','2013-06-05','17:30:00',1.01),('15529','2013-06-04','08:40:00',1.04),('15529','2013-06-04','08:45:00',1.08),('15529','2013-06-04','08:50:00',1.13),('15529','2013-06-04','08:55:00',1.2),('15529','2013-06-04','09:00:00',1.23),('15529','2013-06-04','09:05:00',1.37),('15529','2013-06-04','09:10:00',1.48),('15529','2013-06-04','09:25:00',1),('15529','2013-06-04','09:35:00',1.53),('15529','2013-06-04','09:40:00',1.46),('15529','2013-06-04','09:45:00',1.1),('15529','2013-06-04','09:50:00',1.02),('15529','2013-06-04','10:05:00',1.53),('15529','2013-06-04','10:10:00',1.93),('15529','2013-06-04','10:15:00',1.17),('15529','2013-06-04','10:40:00',1.25),('15529','2013-06-04','10:45:00',1.97),('15529','2013-06-04','10:50:00',2.18),('15529','2013-06-04','10:55:00',2.19),('15529','2013-06-04','11:00:00',2.17),('15529','2013-06-04','11:05:00',1.94),('15529','2013-06-04','11:10:00',2.14),('15529','2013-06-04','11:15:00',2.23),('15529','2013-06-04','11:20:00',2.37),('15529','2013-06-04','11:25:00',2.42),('15529','2013-06-04','11:30:00',2.42),('15529','2013-06-04','11:35:00',2.43),('15529','2013-06-04','11:40:00',2.41),('15529','2013-06-04','11:45:00',1.76),('15529','2013-06-04','11:50:00',2.38),('15529','2013-06-04','11:55:00',2.4),('15529','2013-06-04','12:00:00',2.43),('15529','2013-06-04','12:05:00',2.42),('15529','2013-06-04','12:10:00',2.51),('15529','2013-06-04','12:15:00',2.13),('15529','2013-06-04','12:35:00',1.29),('15529','2013-06-04','12:40:00',2.38),('15529','2013-06-04','12:45:00',2.15),('15529','2013-06-04','12:50:00',2.24),('15529','2013-06-04','12:55:00',1.86),('15529','2013-06-04','13:00:00',1.9),('15529','2013-06-04','13:05:00',2.15),('15529','2013-06-04','13:10:00',1.6),('15529','2013-06-04','13:15:00',2.59),('15529','2013-06-04','13:20:00',1.97),('15529','2013-06-04','13:25:00',2.59),('15529','2013-06-04','13:30:00',2.15),('15529','2013-06-04','13:35:00',2.39),('15529','2013-06-04','13:40:00',2.26),('15529','2013-06-04','13:45:00',2.38),('15529','2013-06-04','13:50:00',2.35),('15529','2013-06-04','13:55:00',2.36),('15529','2013-06-04','14:00:00',2.31),('15529','2013-06-04','14:05:00',2.32),('15529','2013-06-04','14:10:00',2.28),('15529','2013-06-04','14:15:00',2.26),('15529','2013-06-04','14:20:00',2.27),('15529','2013-06-04','14:25:00',2.22),('15529','2013-06-04','14:30:00',2.22),('15529','2013-06-04','14:35:00',2.21),('15529','2013-06-04','14:40:00',2.19),('15529','2013-06-04','14:45:00',2.14),('15529','2013-06-04','14:50:00',2.17),('15529','2013-06-04','14:55:00',2.14),('15529','2013-06-04','15:00:00',2.09),('15529','2013-06-04','15:05:00',2.06),('15529','2013-06-04','15:10:00',2.05),('15529','2013-06-04','15:15:00',2.04),('15529','2013-06-04','15:20:00',2.04),('15529','2013-06-04','15:25:00',1.97),('15529','2013-06-04','15:30:00',1.5),('15529','2013-06-04','15:35:00',1.99),('15529','2013-06-04','15:40:00',1.42),('15529','2013-06-04','15:45:00',1.95),('15529','2013-06-04','15:50:00',1.89),('15529','2013-06-04','15:55:00',1.86),('15529','2013-06-04','16:00:00',1.59),('15529','2013-06-04','16:05:00',1.86),('15529','2013-06-04','16:10:00',1.7),('15529','2013-06-04','16:15:00',1.7),('15529','2013-06-04','16:20:00',1.67),('15529','2013-06-04','16:25:00',1.64),('15529','2013-06-04','16:30:00',1.58),('15529','2013-06-04','16:35:00',1.18),('15529','2013-06-04','16:40:00',1.2),('15529','2013-06-04','16:45:00',1.59),('15529','2013-06-04','16:50:00',1.28),('15529','2013-06-04','16:55:00',1.37),('15529','2013-06-04','17:05:00',1.1),('15529','2013-06-04','17:15:00',1.4),('15529','2013-06-04','17:20:00',1.26),('15529','2013-06-04','17:25:00',1.16),('15529','2013-06-04','17:35:00',1.02),('15529','2013-06-03','08:10:00',1.07),('15529','2013-06-03','08:15:00',1.11),('15529','2013-06-03','08:20:00',1.15),('15529','2013-06-03','08:25:00',1.09),('15529','2013-06-03','08:30:00',1.03),('15529','2013-06-03','09:15:00',1.53),('15529','2013-06-03','09:20:00',1.53),('15529','2013-06-03','09:25:00',1.61),('15529','2013-06-03','09:30:00',1.18),('15529','2013-06-03','09:40:00',1.21),('15529','2013-06-03','09:45:00',1.13),('15529','2013-06-03','09:50:00',1.11),('15529','2013-06-03','10:20:00',1.09),('15529','2013-06-03','10:40:00',1.06),('15529','2013-06-03','10:45:00',1.22),('15529','2013-06-03','10:50:00',1.27),('15529','2013-06-03','10:55:00',1.36),('15529','2013-06-03','11:00:00',1.23),('15529','2013-06-03','11:05:00',1.76),('15529','2013-06-03','11:10:00',1.82),('15529','2013-06-03','11:15:00',1.46),('15529','2013-06-03','11:20:00',1.21),('15529','2013-06-03','11:25:00',1.34),('15529','2013-06-03','11:30:00',1.48),('15529','2013-06-03','11:35:00',1.51),('15529','2013-06-03','11:40:00',1.69),('15529','2013-06-03','11:45:00',1.78),('15529','2013-06-03','11:50:00',2.33),('15529','2013-06-03','11:55:00',2.33),('15529','2013-06-03','12:00:00',1.24),('15529','2013-06-03','12:05:00',1.69),('15529','2013-06-03','12:10:00',1.48),('15529','2013-06-03','12:15:00',1.32),('15529','2013-06-03','12:20:00',1.68),('15529','2013-06-03','12:25:00',1.08),('15529','2013-06-03','12:55:00',1.26),('15529','2013-06-03','13:00:00',1.85),('15529','2013-06-03','13:30:00',2.1),('15529','2013-06-03','13:35:00',2.72),('15529','2013-06-03','13:40:00',2.76),('15529','2013-06-03','13:45:00',2.77),('15529','2013-06-03','13:50:00',1.59),('15529','2013-06-03','13:55:00',1.22),('15529','2013-06-03','14:00:00',2.35),('15529','2013-06-03','14:05:00',2.36),('15529','2013-06-03','14:10:00',1.22),('15529','2013-06-03','14:40:00',1.3),('15529','2013-06-03','14:45:00',1.07),('15529','2013-06-03','14:50:00',1.33),('15529','2013-06-03','14:55:00',2.61),('15529','2013-06-03','15:00:00',1.75),('15529','2013-06-03','15:10:00',2.45),('15529','2013-06-03','15:25:00',1.11),('15529','2013-06-03','15:30:00',1.14),('15529','2013-06-02','08:35:00',1),('15529','2013-06-02','08:40:00',1.05),('15529','2013-06-02','08:45:00',1.1),('15529','2013-06-02','08:50:00',1.15),('15529','2013-06-02','08:55:00',1.18),('15529','2013-06-02','09:00:00',1.2),('15529','2013-06-02','09:05:00',1.12),('15529','2013-06-02','09:15:00',1.19),('15529','2013-06-02','10:50:00',1.42),('15529','2013-06-02','10:55:00',2.07),('15529','2013-06-02','11:00:00',2.21),('15529','2013-06-02','11:05:00',2.03),('15529','2013-06-02','11:10:00',1.16),('15529','2013-06-02','11:15:00',1.28),('15529','2013-06-02','11:20:00',2.2),('15529','2013-06-02','11:25:00',1.77),('15529','2013-06-02','11:30:00',2.16),('15529','2013-06-02','11:35:00',2.49),('15529','2013-06-02','11:40:00',2.16),('15529','2013-06-02','11:45:00',2.51),('15529','2013-06-02','11:50:00',2.33),('15529','2013-06-02','11:55:00',2.15),('15529','2013-06-02','12:00:00',2.66),('15529','2013-06-02','12:05:00',2.17),('15529','2013-06-02','12:45:00',1.43),('15529','2013-06-02','12:50:00',2.78),('15529','2013-06-02','12:55:00',1.77),('15529','2013-06-02','13:00:00',1.32),('15529','2013-06-02','13:05:00',1.68),('15529','2013-06-02','13:10:00',2.12),('15529','2013-06-02','13:15:00',2.29),('15529','2013-06-02','13:20:00',2.5),('15529','2013-06-02','13:25:00',2.01),('15529','2013-06-02','13:30:00',2.49),('15529','2013-06-02','13:35:00',2.41),('15529','2013-06-02','13:40:00',2.37),('15529','2013-06-02','13:45:00',1.74),('15529','2013-06-02','13:50:00',1.73),('15529','2013-06-02','13:55:00',1.58),('15529','2013-06-02','14:00:00',1.3),('15529','2013-06-02','14:05:00',1.1),('15529','2013-06-02','14:10:00',1.95),('15529','2013-06-02','14:15:00',1.5),('15529','2013-06-02','14:20:00',1.96),('15529','2013-06-02','14:25:00',1.64),('15529','2013-06-02','14:30:00',2.14),('15529','2013-06-02','14:35:00',2.45),('15529','2013-06-02','14:40:00',2.39),('15529','2013-06-02','14:45:00',1.29),('15529','2013-06-02','14:50:00',2.11),('15529','2013-06-02','14:55:00',1.74),('15529','2013-06-02','15:00:00',1.27),('15529','2013-06-02','15:05:00',1.97),('15529','2013-06-02','15:10:00',1.94),('15529','2013-06-02','15:15:00',1.81),('15529','2013-06-02','15:20:00',1.9),('15529','2013-06-02','15:25:00',1.54),('15529','2013-06-02','15:30:00',1.9),('15529','2013-06-02','15:35:00',2.01),('15529','2013-06-02','15:40:00',1.98),('15529','2013-06-02','15:45:00',1.93),('15529','2013-06-02','15:50:00',1.86),('15529','2013-06-02','15:55:00',1.86),('15529','2013-06-02','16:00:00',1.84),('15529','2013-06-02','16:05:00',1.79),('15529','2013-06-02','16:10:00',1.75),('15529','2013-06-02','16:15:00',1.71),('15529','2013-06-02','16:20:00',1.57),('15529','2013-06-02','16:25:00',1.58),('15529','2013-06-02','16:30:00',1.5),('15529','2013-06-02','16:35:00',1.5),('15529','2013-06-02','16:40:00',1.3),('15529','2013-06-02','16:45:00',1.28),('15529','2013-06-02','16:50:00',1.11),('15529','2013-06-02','17:00:00',1.38),('15529','2013-06-02','17:05:00',1.3),('15529','2013-06-02','17:10:00',1.2),('15529','2013-06-02','17:15:00',1.06),('15529','2013-06-02','17:20:00',1.07),('15529','2013-06-01','10:45:00',1.44),('15529','2013-06-01','10:50:00',1.27),('15529','2013-06-01','10:55:00',1.21),('15529','2013-06-01','11:00:00',1.01),('15529','2013-06-01','11:05:00',2.29),('15529','2013-06-01','11:10:00',2.15),('15529','2013-06-01','11:15:00',1.49),('15529','2013-06-01','11:20:00',1.08),('15529','2013-06-01','11:25:00',1.23),('15529','2013-06-01','11:35:00',1.2),('15529','2013-06-01','11:40:00',1.56),('15529','2013-06-01','11:45:00',1.55),('15529','2013-06-01','11:50:00',2.48),('15529','2013-06-01','12:05:00',2.24),('15529','2013-06-01','12:20:00',2.52),('15529','2013-06-01','12:25:00',2.19),('15529','2013-06-01','12:30:00',2.36),('15529','2013-06-01','12:35:00',1.86),('15529','2013-06-01','12:40:00',1.58),('15529','2013-06-01','12:45:00',2.25),('15529','2013-06-01','12:50:00',1.51),('15529','2013-06-01','12:55:00',2.48),('15529','2013-06-01','13:00:00',1.97),('15529','2013-06-01','13:05:00',2.49),('15529','2013-06-01','13:10:00',2.28),('15529','2013-06-01','13:15:00',2.43),('15529','2013-06-01','13:20:00',2.23),('15529','2013-06-01','13:25:00',2.39),('15529','2013-06-01','13:30:00',2.37),('15529','2013-06-01','13:35:00',2.34),('15529','2013-06-01','13:40:00',2),('15529','2013-06-01','13:45:00',1.86),('15529','2013-06-01','13:50:00',2.37),('15529','2013-06-01','13:55:00',2.1),('15529','2013-06-01','14:00:00',2.3),('15529','2013-06-01','14:05:00',2.27),('15529','2013-06-01','14:10:00',2.31),('15529','2013-06-01','14:15:00',2.31),('15529','2013-06-01','14:20:00',2.26),('15529','2013-06-01','14:25:00',2.26),('15529','2013-06-01','14:30:00',2.25),('15529','2013-06-01','14:35:00',2.23),('15529','2013-06-01','14:40:00',2.19),('15529','2013-06-01','14:45:00',2.17),('15529','2013-06-01','14:50:00',2.17),('15529','2013-06-01','14:55:00',2.14),('15529','2013-06-01','15:00:00',2.16),('15529','2013-06-01','15:05:00',2.17),('15529','2013-06-01','15:10:00',2.11),('15529','2013-06-01','15:15:00',2.09),('15529','2013-06-01','15:20:00',2.13),('15529','2013-06-01','15:25:00',2.07),('15529','2013-06-01','15:30:00',1.98),('15529','2013-06-01','15:35:00',2.02),('15529','2013-06-01','15:40:00',1.91),('15529','2013-06-01','15:45:00',1.75),('15529','2013-06-01','15:50:00',1.92),('15529','2013-06-01','15:55:00',1.85),('15529','2013-06-01','16:00:00',1.36),('15529','2013-06-01','16:05:00',1.45),('15529','2013-06-01','16:10:00',1.24),('15529','2013-06-01','16:15:00',1.26),('15529','2013-06-01','16:20:00',1.16),('15529','2013-06-01','16:25:00',1.35),('15529','2013-06-01','16:30:00',1.65),('15529','2013-06-01','16:35:00',1.58),('15529','2013-06-01','16:40:00',1.56),('15529','2013-06-01','16:45:00',1.5),('15529','2013-06-01','16:50:00',1),('15529','2013-06-01','16:55:00',1.11),('15529','2013-06-01','17:00:00',1.17),('15529','2013-06-01','17:05:00',1.33),('15529','2013-06-01','17:10:00',1.27),('15529','2013-06-01','17:15:00',1.25),('15529','2013-06-01','17:20:00',1.19),('15529','2013-06-01','17:30:00',1.18),('15529','2013-05-31','10:50:00',1.74),('15529','2013-05-31','12:00:00',2.7),('15529','2013-05-31','12:05:00',2.31),('15529','2013-05-31','12:10:00',1.87),('15529','2013-05-31','12:50:00',1.03),('15529','2013-05-31','12:55:00',1.12),('15529','2013-05-31','13:00:00',1.17),('15529','2013-05-31','13:05:00',1.17),('15529','2013-05-31','13:10:00',1.2),('15529','2013-05-31','14:00:00',1.1),('15529','2013-05-31','14:05:00',1.21),('15529','2013-05-31','14:10:00',1.05),('15529','2013-05-31','14:15:00',1.07),('15529','2013-05-31','14:20:00',1.05),('15529','2014-04-01','09:45:00',1.53),('15529','2014-04-01','09:50:00',1.29),('15529','2014-04-01','09:55:00',1.3),('15529','2014-04-01','10:00:00',1.49),('15529','2014-04-01','10:15:00',1.06),('15529','2014-04-01','10:20:00',1.34),('15529','2014-04-01','10:25:00',1.59),('15529','2014-04-01','10:30:00',1.25),('15529','2014-04-01','11:05:00',1.81),('15529','2014-04-01','11:10:00',1.93),('15529','2014-04-01','11:15:00',1.47),('15529','2014-04-01','11:35:00',1.12),('15529','2014-04-01','11:40:00',2.33),('15529','2014-04-01','11:45:00',2.32),('15529','2014-04-01','11:50:00',1.91),('15529','2014-04-01','12:05:00',2.52),('15529','2014-04-01','12:10:00',2.4),('15529','2014-04-01','12:20:00',2.09),('15529','2014-04-01','12:30:00',2.03),('15529','2014-04-01','12:35:00',2.59),('15529','2014-04-01','12:40:00',2.32),('15529','2014-04-01','12:55:00',2.32),('15529','2014-04-01','13:00:00',2.6),('15529','2014-04-01','13:05:00',1.72),('15529','2014-04-01','13:10:00',1.93),('15529','2014-04-01','13:15:00',2.56),('15529','2014-04-01','13:20:00',1.84),('15529','2014-04-01','13:30:00',2.01),('15529','2014-04-01','13:35:00',2.45),('15529','2014-04-01','13:40:00',2.39),('15529','2014-04-01','13:45:00',2.39),('15529','2014-04-01','13:50:00',2.39),('15529','2014-04-01','13:55:00',2.38),('15529','2014-04-01','14:00:00',2.33),('15529','2014-04-01','14:05:00',2.32),('15529','2014-04-01','14:10:00',2.31),('15529','2014-04-01','14:15:00',2.26),('15529','2014-04-01','14:20:00',2.24),('15529','2014-04-01','14:25:00',2.19),('15529','2014-04-01','14:30:00',2.24),('15529','2014-04-01','14:35:00',2.23),('15529','2014-04-01','14:40:00',2.23),('15529','2014-04-01','14:45:00',2.2),('15529','2014-04-01','14:50:00',2.07),('15529','2014-04-01','14:55:00',1.66),('15529','2014-04-01','15:00:00',2.04),('15529','2014-04-01','15:05:00',2.01),('15529','2014-04-01','15:10:00',1.92),('15529','2014-04-01','15:15:00',1.93),('15529','2014-04-01','15:20:00',1.93),('15529','2014-04-01','15:25:00',1.92),('15529','2014-04-01','15:30:00',1.82),('15529','2014-04-01','15:35:00',1.78),('15529','2014-04-01','15:40:00',1.77),('15529','2014-04-01','15:45:00',1.82),('15529','2014-04-01','15:50:00',1.8),('15529','2014-04-01','15:55:00',1.61),('15529','2014-04-01','16:00:00',1.68),('15529','2014-04-01','16:05:00',1.64),('15529','2014-04-01','16:10:00',1.6),('15529','2014-04-01','16:15:00',1.53),('15529','2014-04-01','16:20:00',1.51),('15529','2014-04-01','16:25:00',1.45),('15529','2014-04-01','16:30:00',1.49),('15529','2014-04-01','16:35:00',1.43),('15529','2014-04-01','16:40:00',1.36),('15529','2014-04-01','16:45:00',1.3),('15529','2014-04-01','16:50:00',1.21),('15529','2014-04-01','16:55:00',1.22),('15529','2014-04-01','17:00:00',1.21),('15529','2014-04-01','17:05:00',1.08),('15529','2014-04-01','17:10:00',1.03),('15529','2013-05-30','08:30:00',1.01),('15529','2013-05-30','08:35:00',1.08),('15529','2013-05-30','08:40:00',1.2),('15529','2013-05-30','09:35:00',1.13),('15529','2013-05-30','09:40:00',1.77),('15529','2013-05-30','09:45:00',1.85),('15529','2013-05-30','09:50:00',1.19),('15529','2013-05-30','09:55:00',1.95),('15529','2013-05-30','10:00:00',2),('15529','2013-05-30','10:05:00',1.73),('15529','2013-05-30','10:10:00',1.92),('15529','2013-05-30','10:15:00',1.86),('15529','2013-05-30','10:20:00',1.18),('15529','2013-05-30','10:30:00',1.13),('15529','2013-05-30','10:35:00',1.51),('15529','2013-05-30','10:40:00',2.45),('15529','2013-05-30','10:45:00',1.22),('15529','2013-05-30','10:50:00',1.79),('15529','2013-05-30','10:55:00',1.11),('15529','2013-05-30','11:05:00',2.04),('15529','2013-05-30','11:10:00',2.34),('15529','2013-05-30','11:15:00',1.6),('15529','2013-05-30','11:20:00',2.22),('15529','2013-05-30','11:25:00',1.96),('15529','2013-05-30','11:30:00',1.08),('15529','2013-05-30','11:40:00',2.02),('15529','2013-05-30','11:45:00',2.09),('15529','2013-05-30','11:50:00',1.1),('15529','2013-05-30','11:55:00',1.17),('15529','2013-05-30','12:00:00',1.85),('15529','2013-05-30','12:05:00',2.79),('15529','2013-05-30','12:10:00',1.15),('15529','2013-05-30','12:20:00',1.92),('15529','2013-05-30','12:25:00',1.84),('15529','2013-05-30','12:35:00',2.05),('15529','2013-05-30','12:40:00',1.73),('15529','2013-05-30','12:55:00',1.59),('15529','2013-05-30','13:00:00',2.11),('15529','2013-05-30','13:30:00',1.82),('15529','2013-05-30','13:35:00',1.96),('15529','2013-05-30','13:40:00',1.27),('15529','2013-05-30','13:55:00',1),('15529','2013-05-30','15:15:00',1.91),('15529','2013-05-30','15:20:00',1.62),('15529','2013-05-30','15:25:00',1.69),('15529','2013-05-30','15:50:00',1.36),('15529','2013-05-29','08:40:00',1.14),('15529','2013-05-29','08:45:00',1.18),('15529','2013-05-29','08:50:00',1.23),('15529','2013-05-29','08:55:00',1.27),('15529','2013-05-29','09:00:00',1.31),('15529','2013-05-29','09:05:00',1.37),('15529','2013-05-29','09:10:00',1.34),('15529','2013-05-29','09:15:00',1.46),('15529','2013-05-29','09:20:00',1.56),('15529','2013-05-29','09:25:00',1.45),('15529','2013-05-29','09:30:00',1.62),('15529','2013-05-29','09:35:00',1.68),('15529','2013-05-29','09:40:00',1.28),('15529','2013-05-29','09:45:00',1.84),('15529','2013-05-29','09:50:00',1.18),('15529','2013-05-29','09:55:00',1.53),('15529','2013-05-29','10:05:00',1.4),('15529','2013-05-29','10:15:00',2.01),('15529','2013-05-29','10:25:00',1.65),('15529','2013-05-29','10:35:00',1.86),('15529','2013-05-29','10:40:00',2.35),('15529','2013-05-29','10:45:00',1.76),('15529','2013-05-29','10:50:00',2.34),('15529','2013-05-29','10:55:00',2.28),('15529','2013-05-29','11:00:00',2.5),('15529','2013-05-29','11:15:00',2.2),('15529','2013-05-29','11:20:00',1.02),('15529','2013-05-29','11:25:00',1.37),('15529','2013-05-29','11:30:00',2.4),('15529','2013-05-29','11:35:00',2.51),('15529','2013-05-29','11:40:00',1.19),('15529','2013-05-29','11:45:00',2.63),('15529','2013-05-29','11:50:00',1.09),('15529','2013-05-29','11:55:00',2.32),('15529','2013-05-29','12:00:00',2.58),('15529','2013-05-29','12:05:00',1.52),('15529','2013-05-29','12:10:00',1.7),('15529','2013-05-29','12:15:00',2.16),('15529','2013-05-29','12:20:00',2.56),('15529','2013-05-29','12:25:00',1.94),('15529','2013-05-29','12:30:00',1.2),('15529','2013-05-29','12:35:00',2.64),('15529','2013-05-29','12:40:00',1.47),('15529','2013-05-29','12:45:00',1.77),('15529','2013-05-29','12:50:00',2.65),('15529','2013-05-29','12:55:00',1.62),('15529','2013-05-29','13:00:00',1.57),('15529','2013-05-29','13:05:00',1.07),('15529','2013-05-29','13:10:00',1.71),('15529','2013-05-29','13:15:00',1.11),('15529','2013-05-29','13:20:00',1.04),('15529','2013-05-29','13:25:00',1.02),('15529','2013-05-29','13:35:00',2.06),('15529','2013-05-29','13:40:00',2.74),('15529','2013-05-29','13:45:00',1.02),('15529','2013-05-29','13:55:00',2.13),('15529','2013-05-29','14:00:00',2.06),('15529','2013-05-29','14:05:00',2.63),('15529','2013-05-29','14:10:00',1.37),('15529','2013-05-29','14:15:00',2.21),('15529','2013-05-29','14:20:00',2.5),('15529','2013-05-29','14:25:00',2.53),('15529','2013-05-29','14:30:00',1.52),('15529','2013-05-29','14:35:00',2.7),('15529','2013-05-29','14:40:00',1.31),('15529','2013-05-29','14:45:00',1.74),('15529','2013-05-29','14:50:00',1.89),('15529','2013-05-29','14:55:00',1.73),('15529','2013-05-29','15:00:00',2.12),('15529','2013-05-29','15:10:00',1.95),('15529','2013-05-29','15:15:00',2.29),('15529','2013-05-29','15:20:00',2.1),('15529','2013-05-29','15:25:00',2),('15529','2013-05-29','15:30:00',2.37),('15529','2013-05-29','15:35:00',2.15),('15529','2013-05-29','15:40:00',1.96),('15529','2013-05-29','15:45:00',2.33),('15529','2013-05-29','15:50:00',2.38),('15529','2013-05-29','15:55:00',2.22),('15529','2013-05-29','16:00:00',2.16),('15529','2013-05-29','16:05:00',2.03),('15529','2013-05-29','16:10:00',1.93),('15529','2013-05-29','16:15:00',1.82),('15529','2013-05-29','16:20:00',1.52),('15529','2013-05-29','16:45:00',1.49),('15529','2013-05-29','16:50:00',1.34),('15529','2013-05-28','08:35:00',1.04),('15529','2013-05-28','08:40:00',1.09),('15529','2013-05-28','08:45:00',1.14),('15529','2013-05-28','08:50:00',1.19),('15529','2013-05-28','08:55:00',1.23),('15529','2013-05-28','09:00:00',1.28),('15529','2013-05-28','09:05:00',1.32),('15529','2013-05-28','09:10:00',1.37),('15529','2013-05-28','09:15:00',1.41),('15529','2013-05-28','09:20:00',1.45),('15529','2013-05-28','09:25:00',1.49),('15529','2013-05-28','09:30:00',1.54),('15529','2013-05-28','09:35:00',1.58),('15529','2013-05-28','09:40:00',1.62),('15529','2013-05-28','09:45:00',1.65),('15529','2013-05-28','09:50:00',1.68),('15529','2013-05-28','09:55:00',1.72),('15529','2013-05-28','10:00:00',1.77),('15529','2013-05-28','10:05:00',1.79),('15529','2013-05-28','10:10:00',1.82),('15529','2013-05-28','10:15:00',1.86),('15529','2013-05-28','10:20:00',1.91),('15529','2013-05-28','10:25:00',1.94),('15529','2013-05-28','10:30:00',1.98),('15529','2013-05-28','10:35:00',2.01),('15529','2013-05-28','10:40:00',2.03),('15529','2013-05-28','10:45:00',2.06),('15529','2013-05-28','10:50:00',2.1),('15529','2013-05-28','10:55:00',2.12),('15529','2013-05-28','11:00:00',2.2),('15529','2013-05-28','11:05:00',2.28),('15529','2013-05-28','11:10:00',2.19),('15529','2013-05-28','11:15:00',2.31),('15529','2013-05-28','11:20:00',1.72),('15529','2013-05-28','11:25:00',2.17),('15529','2013-05-28','11:30:00',2.05),('15529','2013-05-28','11:35:00',2.39),('15529','2013-05-28','11:40:00',1.79),('15529','2013-05-28','11:45:00',1.74),('15529','2013-05-28','11:50:00',2.07),('15529','2013-05-28','11:55:00',2.55),('15529','2013-05-28','12:00:00',2.19),('15529','2013-05-28','12:05:00',2.22),('15529','2013-05-28','12:10:00',2.51),('15529','2013-05-28','12:15:00',2.46),('15529','2013-05-28','12:20:00',2.45),('15529','2013-05-28','12:25:00',2.49),('15529','2013-05-28','12:30:00',2.25),('15529','2013-05-28','12:35:00',2),('15529','2013-05-28','12:40:00',2.51),('15529','2013-05-28','12:45:00',2.48),('15529','2013-05-28','12:50:00',2.39),('15529','2013-05-28','12:55:00',2.38),('15529','2013-05-28','13:00:00',2.36),('15529','2013-05-28','13:05:00',2.55),('15529','2013-05-28','13:10:00',2.55),('15529','2013-05-28','13:15:00',2.29),('15529','2013-05-28','13:20:00',2.7),('15529','2013-05-28','13:25:00',2.1),('15529','2013-05-28','13:30:00',1.92),('15529','2013-05-28','13:35:00',1.6),('15529','2013-05-28','13:40:00',1.68),('15529','2013-05-28','13:45:00',2.41),('15529','2013-05-28','13:50:00',2.49),('15529','2013-05-28','13:55:00',2.34),('15529','2013-05-28','14:00:00',2.4),('15529','2013-05-28','14:05:00',2.28),('15529','2013-05-28','14:10:00',2.33),('15529','2013-05-28','14:15:00',2.36),('15529','2013-05-28','14:20:00',2.35),('15529','2013-05-28','14:25:00',2.2),('15529','2013-05-28','14:30:00',2.08),('15529','2013-05-28','14:35:00',2.3),('15529','2013-05-28','14:40:00',2.22),('15529','2013-05-28','14:45:00',2.33),('15529','2013-05-28','14:50:00',2.32),('15529','2013-05-28','14:55:00',2.15),('15529','2013-05-28','15:00:00',2.21),('15529','2013-05-28','15:05:00',1.87),('15529','2013-05-28','15:10:00',1.42),('15529','2013-05-28','15:15:00',1.86),('15529','2013-05-28','15:20:00',1.28),('15529','2013-05-28','15:25:00',1.46),('15529','2013-05-28','15:30:00',1.38),('15529','2013-05-28','15:35:00',1.76),('15529','2013-05-28','15:40:00',1.53),('15529','2013-05-28','15:45:00',1.37),('15529','2013-05-28','15:50:00',1.47),('15529','2013-05-28','15:55:00',1.28),('15529','2013-05-28','16:00:00',1.35),('15529','2013-05-28','16:05:00',1.31),('15529','2013-05-28','16:10:00',1.17),('15529','2013-05-28','16:15:00',1.24),('15529','2013-05-28','16:20:00',1.07),('15529','2013-05-28','16:25:00',1.23),('15529','2013-05-28','16:30:00',1.01),('15529','2013-05-28','16:35:00',1.11),('15529','2013-05-28','16:40:00',1.23),('15529','2013-05-28','16:45:00',1.07),('15529','2013-05-27','09:25:00',1.07),('15529','2013-05-27','09:30:00',1.21),('15529','2013-05-27','09:35:00',1.26),('15529','2013-05-27','09:40:00',1.09),('15529','2013-05-27','09:45:00',1.1),('15529','2013-05-27','09:50:00',1.1),('15529','2013-05-27','09:55:00',1.14),('15529','2013-05-27','10:00:00',1.06),('15529','2013-05-27','10:05:00',1.14),('15529','2013-05-27','10:10:00',1.28),('15529','2013-05-27','10:15:00',1.34),('15529','2013-05-27','10:20:00',1.36),('15529','2013-05-27','10:25:00',1.32),('15529','2013-05-27','10:30:00',1.5),('15529','2013-05-27','10:35:00',1.55),('15529','2013-05-27','10:40:00',1.48),('15529','2013-05-27','10:45:00',1.37),('15529','2013-05-27','10:50:00',1.32),('15529','2013-05-27','10:55:00',1.38),('15529','2013-05-27','11:00:00',1.36),('15529','2013-05-27','11:05:00',1.56),('15529','2013-05-27','11:10:00',1.15),('15529','2013-05-27','11:15:00',1.49),('15529','2013-05-27','11:20:00',1.11),('15529','2013-05-27','11:25:00',1.57),('15529','2013-05-27','11:30:00',1.78),('15529','2013-05-27','11:35:00',2.13),('15529','2013-05-27','11:40:00',2.07),('15529','2013-05-27','11:45:00',1.35),('15529','2013-05-27','12:05:00',1.05),('15529','2013-05-27','12:10:00',1.24),('15529','2013-05-27','12:15:00',1.2),('15529','2013-05-27','12:20:00',1.15),('15529','2013-05-27','12:25:00',1.31),('15529','2013-05-27','12:30:00',1.37),('15529','2013-05-27','12:35:00',1.29),('15529','2013-05-27','12:40:00',1.36),('15529','2013-05-27','12:45:00',1.31),('15529','2013-05-27','12:50:00',1.29),('15529','2013-05-27','12:55:00',1.36),('15529','2013-05-27','13:00:00',1.4),('15529','2013-05-27','13:05:00',1.58),('15529','2013-05-27','13:10:00',1.71),('15529','2013-05-27','13:15:00',1.26),('15529','2013-05-27','13:20:00',1.11),('15529','2013-05-27','13:30:00',1.28),('15529','2013-05-27','13:35:00',1.25),('15529','2013-05-27','13:40:00',1.2),('15529','2013-05-27','13:45:00',1.12),('15529','2013-05-27','13:50:00',1.02),('15529','2013-05-27','13:55:00',1.03),('15529','2013-05-27','14:00:00',1.18),('15529','2013-05-27','14:05:00',1.37),('15529','2013-05-27','14:10:00',1.46),('15529','2013-05-27','14:15:00',1.65),('15529','2013-05-27','14:20:00',1.34),('15529','2013-05-27','14:25:00',1.2),('15529','2013-05-27','14:30:00',1.58),('15529','2013-05-27','14:35:00',1.39),('15529','2013-05-27','14:40:00',1.68),('15529','2013-05-27','14:45:00',1.85),('15529','2013-05-27','14:50:00',1.95),('15529','2013-05-27','14:55:00',1.91),('15529','2013-05-27','15:00:00',1.35),('15529','2013-05-27','15:05:00',1.29),('15529','2013-05-27','15:15:00',1.33),('15529','2013-05-27','15:20:00',1.54),('15529','2013-05-27','15:40:00',1.32),('15529','2013-05-27','15:45:00',1.8),('15529','2013-05-27','15:50:00',1.35),('15529','2013-05-27','16:20:00',1.16),('15529','2013-05-27','16:25:00',1.15),('15529','2013-05-27','16:30:00',1.73),('15529','2013-05-27','16:35:00',1.5),('15529','2013-05-27','16:40:00',1.42),('15529','2013-05-27','16:45:00',1.37),('15529','2013-05-27','16:50:00',1.33),('15529','2013-05-27','16:55:00',1.29),('15529','2013-05-27','17:00:00',1.23),('15529','2013-05-27','17:05:00',1.19),('15529','2013-05-27','17:10:00',1.14),('15529','2013-05-27','17:15:00',1.11),('15529','2013-05-27','17:20:00',1.07),('15529','2013-05-27','17:25:00',1),('15529','2013-05-26','08:35:00',1.06),('15529','2013-05-26','08:40:00',1.15),('15529','2013-05-26','08:55:00',1.37),('15529','2013-05-26','09:00:00',1.42),('15529','2013-05-26','09:05:00',1.66),('15529','2013-05-26','09:25:00',1.57),('15529','2013-05-26','09:30:00',1.63),('15529','2013-05-26','09:35:00',1.65),('15529','2013-05-26','09:40:00',1.68),('15529','2013-05-26','09:45:00',1.75),('15529','2013-05-26','09:50:00',1.84),('15529','2013-05-26','09:55:00',1.87),('15529','2013-05-26','10:00:00',1.49),('15529','2013-05-26','10:05:00',1.9),('15529','2013-05-26','10:10:00',1.9),('15529','2013-05-26','10:15:00',1.98),('15529','2013-05-26','10:20:00',2.02),('15529','2013-05-26','10:30:00',1.18),('15529','2013-05-26','10:35:00',1.88),('15529','2013-05-26','10:40:00',1.53),('15529','2013-05-26','10:45:00',2.29),('15529','2013-05-26','10:50:00',2.33),('15529','2013-05-26','10:55:00',1.72),('15529','2013-05-26','11:00:00',1.58),('15529','2013-05-26','11:05:00',1.51),('15529','2013-05-26','11:10:00',1.34),('15529','2013-05-26','11:15:00',2.54),('15529','2013-05-26','11:20:00',2.33),('15529','2013-05-26','11:25:00',2.21),('15529','2013-05-26','11:35:00',1.68),('15529','2013-05-26','11:45:00',1.37),('15529','2013-05-26','11:50:00',1.68),('15529','2013-05-26','11:55:00',1.69),('15529','2013-05-26','12:05:00',2.06),('15529','2013-05-26','12:10:00',2.58),('15529','2013-05-26','12:15:00',1.26),('15529','2013-05-26','12:25:00',2.08),('15529','2013-05-26','12:30:00',1.31),('15529','2013-05-26','12:35:00',2.34),('15529','2013-05-26','12:45:00',2.35),('15529','2013-05-26','12:55:00',1.06),('15529','2013-05-26','13:00:00',2.25),('15529','2013-05-26','13:05:00',2.12),('15529','2013-05-26','13:10:00',1.14),('15529','2013-05-26','13:15:00',1.34),('15529','2013-05-26','13:20:00',1.43),('15529','2013-05-26','13:25:00',2.51),('15529','2013-05-26','13:30:00',2.41),('15529','2013-05-26','13:35:00',1.96),('15529','2013-05-26','13:40:00',2.56),('15529','2013-05-26','13:45:00',2.51),('15529','2013-05-26','13:50:00',2.48),('15529','2013-05-26','13:55:00',2.42),('15529','2013-05-26','14:00:00',2.33),('15529','2013-05-26','14:05:00',2.41),('15529','2013-05-26','14:10:00',2.3),('15529','2013-05-26','14:15:00',2.25),('15529','2013-05-26','14:20:00',2.37),('15529','2013-05-26','14:25:00',2.35),('15529','2013-05-26','14:30:00',1.86),('15529','2013-05-26','14:35:00',2.11),('15529','2013-05-26','14:40:00',2.35),('15529','2013-05-26','14:45:00',2.27),('15529','2013-05-26','14:50:00',2.3),('15529','2013-05-26','14:55:00',1.89),('15529','2013-05-26','15:00:00',1.39),('15529','2013-05-26','15:05:00',1.58),('15529','2013-05-26','15:10:00',2.29),('15529','2013-05-26','15:15:00',1.53),('15529','2013-05-26','15:20:00',1.93),('15529','2013-05-26','15:25:00',1.78),('15529','2013-05-26','15:30:00',1.99),('15529','2013-05-26','15:35:00',2.04),('15529','2013-05-26','15:40:00',1.8),('15529','2013-05-26','15:45:00',1.63),('15529','2013-05-26','15:50:00',1.91),('15529','2013-05-26','15:55:00',1.28),('15529','2013-05-26','16:00:00',1.54),('15529','2013-05-26','16:05:00',1.23),('15529','2013-05-26','16:10:00',1.18),('15529','2013-05-26','16:15:00',1.32),('15529','2013-05-26','16:20:00',1.99),('15529','2013-05-26','16:25:00',1.82),('15529','2013-05-26','16:30:00',1.71),('15529','2013-05-26','16:35:00',1.25),('15529','2013-05-25','08:05:00',1.08),('15529','2013-05-25','08:30:00',1.07),('15529','2013-05-25','08:40:00',1.19),('15529','2013-05-25','08:45:00',1.41),('15529','2013-05-25','08:55:00',1.35),('15529','2013-05-25','09:10:00',1.67),('15529','2013-05-25','09:40:00',1.27),('15529','2013-05-25','10:05:00',1.96),('15529','2013-05-25','10:10:00',1.24),('15529','2013-05-25','10:20:00',1.66),('15529','2013-05-25','10:25:00',1.96),('15529','2013-05-25','10:30:00',2.04),('15529','2013-05-25','10:35:00',2.16),('15529','2013-05-25','10:40:00',2.15),('15529','2013-05-25','10:45:00',2.21),('15529','2013-05-25','10:50:00',2.27),('15529','2013-05-25','10:55:00',1.96),('15529','2013-05-25','11:00:00',2.16),('15529','2013-05-25','11:05:00',2.27),('15529','2013-05-25','11:10:00',2.3),('15529','2013-05-25','11:15:00',2.31),('15529','2013-05-25','11:20:00',2.29),('15529','2013-05-25','11:25:00',2.37),('15529','2013-05-25','11:30:00',2.25),('15529','2013-05-25','11:35:00',2.28),('15529','2013-05-25','11:40:00',2.05),('15529','2013-05-25','11:45:00',2.45),('15529','2013-05-25','11:50:00',2.44),('15529','2013-05-25','11:55:00',2.41),('15529','2013-05-25','12:00:00',2.47),('15529','2013-05-25','12:05:00',2.52),('15529','2013-05-25','12:10:00',2.49),('15529','2013-05-25','12:15:00',1.6),('15529','2013-05-25','12:20:00',2.5),('15529','2013-05-25','12:25:00',2.54),('15529','2013-05-25','12:30:00',2.53),('15529','2013-05-25','12:35:00',2.33),('15529','2013-05-25','12:40:00',2.71),('15529','2013-05-25','12:45:00',2.59),('15529','2013-05-25','12:50:00',2.55),('15529','2013-05-25','12:55:00',2.52),('15529','2013-05-25','13:00:00',2.32),('15529','2013-05-25','13:05:00',2.6),('15529','2013-05-25','13:10:00',2.4),('15529','2013-05-25','13:15:00',2.44),('15529','2013-05-25','13:20:00',2.56),('15529','2013-05-25','13:25:00',2.55),('15529','2013-05-25','13:30:00',2.57),('15529','2013-05-25','13:35:00',2.51),('15529','2013-05-25','13:40:00',2.49),('15529','2013-05-25','13:45:00',2.51),('15529','2013-05-25','13:50:00',2.36),('15529','2013-05-25','13:55:00',2.46),('15529','2013-05-25','14:00:00',2.46),('15529','2013-05-25','14:05:00',2.42),('15529','2013-05-25','14:10:00',2.43),('15529','2013-05-25','14:15:00',2.4),('15529','2013-05-25','14:20:00',2.38),('15529','2013-05-25','14:25:00',2.36),('15529','2013-05-25','14:30:00',2.34),('15529','2013-05-25','14:35:00',2.33),('15529','2013-05-25','14:40:00',2.31),('15529','2013-05-25','14:45:00',2.31),('15529','2013-05-25','14:50:00',2.27),('15529','2013-05-25','14:55:00',2.24),('15529','2013-05-25','15:00:00',2.24),('15529','2013-05-25','15:05:00',2.21),('15529','2013-05-25','15:10:00',2.19),('15529','2013-05-25','15:15:00',2.14),('15529','2013-05-25','15:20:00',2.13),('15529','2013-05-25','15:25:00',2.11),('15529','2013-05-25','15:30:00',2.07),('15529','2013-05-25','15:35:00',2.06),('15529','2013-05-25','15:40:00',2.03),('15529','2013-05-25','15:45:00',1.99),('15529','2013-05-25','15:50:00',1.94),('15529','2013-05-25','15:55:00',1.92),('15529','2013-05-25','16:00:00',1.89),('15529','2013-05-25','16:05:00',1.87),('15529','2013-05-25','16:10:00',1.82),('15529','2013-05-25','16:15:00',1.79),('15529','2013-05-25','16:20:00',1.75),('15529','2013-05-25','16:25:00',1.71),('15529','2013-05-25','16:30:00',1.66),('15529','2013-05-25','16:35:00',1.62),('15529','2013-05-25','16:40:00',1.58),('15529','2013-05-25','16:45:00',1.53),('15529','2013-05-25','16:50:00',1.49),('15529','2013-05-25','16:55:00',1.44),('15529','2013-05-25','17:00:00',1.39),('15529','2013-05-25','17:05:00',1.35),('15529','2013-05-25','17:10:00',1.3),('15529','2013-05-25','17:15:00',1.25),('15529','2013-05-25','17:20:00',1.2),('15529','2013-05-25','17:25:00',1.15),('15529','2013-05-25','17:30:00',1.05),('15529','2013-05-25','17:35:00',1.04),('15529','2013-05-24','08:25:00',1.38),('15529','2013-05-24','08:50:00',1.14),('15529','2013-05-24','08:55:00',1.5),('15529','2013-05-24','09:00:00',1.5),('15529','2013-05-24','09:05:00',1.13),('15529','2013-05-24','09:10:00',1.24),('15529','2013-05-24','09:25:00',1.19),('15529','2013-05-24','09:35:00',1.53),('15529','2013-05-24','09:40:00',1.7),('15529','2013-05-24','09:45:00',1.53),('15529','2013-05-24','09:50:00',1.73),('15529','2013-05-24','11:05:00',1.65),('15529','2013-05-24','11:10:00',2.04),('15529','2013-05-24','11:15:00',1.74),('15529','2013-05-24','11:35:00',1.52),('15529','2013-05-24','11:45:00',1.07),('15529','2013-05-24','12:00:00',1.52),('15529','2013-05-24','12:05:00',1.02),('15529','2013-05-24','12:20:00',2.38),('15529','2013-05-24','12:25:00',1.29),('15529','2013-05-24','12:35:00',1.53),('15529','2013-05-24','12:40:00',1.41),('15529','2013-05-24','13:15:00',1.13),('15529','2013-05-24','13:25:00',1.45),('15529','2013-05-24','13:40:00',1.22),('15529','2013-05-24','13:45:00',1.47),('15529','2013-05-24','13:50:00',1.68),('15529','2013-05-24','13:55:00',2.29),('15529','2013-05-24','14:00:00',1.58),('15529','2013-05-24','14:05:00',2.23),('15529','2013-05-24','14:10:00',2.6),('15529','2013-05-24','14:15:00',2.38),('15529','2013-05-24','14:25:00',1),('15529','2013-05-24','14:30:00',1.11),('15529','2013-05-24','14:35:00',1.45),('15529','2013-05-24','14:40:00',1.35),('15529','2013-05-24','14:45:00',1.72),('15529','2013-05-24','14:50:00',1.45),('15529','2013-05-24','14:55:00',1.87),('15529','2013-05-24','15:00:00',1.93),('15529','2013-05-24','15:10:00',1.14),('15529','2013-05-24','15:15:00',1.77),('15529','2013-05-24','15:20:00',1.17),('15529','2013-05-24','15:25:00',1.44),('15529','2013-05-24','15:30:00',2.24),('15529','2013-05-24','15:35:00',2.33),('15529','2013-05-24','15:40:00',2.06),('15529','2013-05-24','15:45:00',1.75),('15529','2013-05-24','15:50:00',1.37),('15529','2013-05-24','15:55:00',1.59),('15529','2013-05-24','16:00:00',1.58),('15529','2013-05-24','16:20:00',1.23),('15529','2013-05-24','16:25:00',1.66),('15529','2013-05-24','16:35:00',1.38),('15529','2013-05-24','16:40:00',1.09),('15529','2013-05-24','17:10:00',1.17),('15529','2013-05-24','17:35:00',1.32),('15529','2013-05-23','08:40:00',1.14),('15529','2013-05-23','08:45:00',1.17),('15529','2013-05-23','08:50:00',1.24),('15529','2013-05-23','08:55:00',1.29),('15529','2013-05-23','09:00:00',1.54),('15529','2013-05-23','09:25:00',1.15),('15529','2013-05-23','09:55:00',1.76),('15529','2013-05-23','10:20:00',1.03),('15529','2013-05-23','10:25:00',1.64),('15529','2013-05-23','10:30:00',2.09),('15529','2013-05-23','10:35:00',2.18),('15529','2013-05-23','10:40:00',1.94),('15529','2013-05-23','10:45:00',1.61),('15529','2013-05-23','10:50:00',2.06),('15529','2013-05-23','10:55:00',2.4),('15529','2013-05-23','11:00:00',1.6),('15529','2013-05-23','11:05:00',2.25),('15529','2013-05-23','11:10:00',2.22),('15529','2013-05-23','11:15:00',1.98),('15529','2013-05-23','11:20:00',2.37),('15529','2013-05-23','11:25:00',2.5),('15529','2013-05-23','11:30:00',1.1),('15529','2013-05-23','11:45:00',2.33),('15529','2013-05-23','11:50:00',1.66),('15529','2013-05-23','11:55:00',2.02),('15529','2013-05-23','12:00:00',1.75),('15529','2013-05-23','12:05:00',1.07),('15529','2013-05-23','12:10:00',1.7),('15529','2013-05-23','12:15:00',2.33),('15529','2013-05-23','12:20:00',1.38),('15529','2013-05-23','12:25:00',1.39),('15529','2013-05-23','12:30:00',1.57),('15529','2013-05-23','12:35:00',1.5),('15529','2013-05-23','12:40:00',1.14),('15529','2013-05-23','12:45:00',1.49),('15529','2013-05-23','12:50:00',2.07),('15529','2013-05-23','12:55:00',2.03),('15529','2013-05-23','13:00:00',1.81),('15529','2013-05-23','13:05:00',1.48),('15529','2013-05-23','13:10:00',1.44),('15529','2013-05-23','13:15:00',1.4),('15529','2013-05-23','13:20:00',1.43),('15529','2013-05-23','13:30:00',1.36),('15529','2013-05-23','13:35:00',1.12),('15529','2013-05-23','13:55:00',1.28),('15529','2013-05-23','14:00:00',1.18),('15529','2013-05-23','14:10:00',1.73),('15529','2013-05-23','14:15:00',1.9),('15529','2013-05-23','14:20:00',1.01),('15529','2013-05-23','14:25:00',1.15),('15529','2013-05-23','14:30:00',1.26),('15529','2013-05-23','14:35:00',2.18),('15529','2013-05-23','14:40:00',2.22),('15529','2013-05-23','14:45:00',1.11),('15529','2013-05-23','14:50:00',1.33),('15529','2013-05-23','15:05:00',1.51),('15529','2013-05-23','15:10:00',1.04),('15529','2013-05-23','15:15:00',2.15),('15529','2013-05-23','15:20:00',2.55),('15529','2013-05-23','15:25:00',2.46),('15529','2013-05-23','15:30:00',2.34),('15529','2013-05-23','15:35:00',1.68),('15529','2013-05-23','15:40:00',1.82),('15529','2013-05-23','15:45:00',1.7),('15529','2013-05-23','15:50:00',1.61),('15529','2013-05-23','15:55:00',1.09),('15529','2013-05-23','16:00:00',1.13),('15529','2013-05-23','16:05:00',1.08),('15529','2013-05-23','16:10:00',1.12),('15529','2013-05-23','16:15:00',1.23),('15529','2013-05-23','16:20:00',1.14),('15529','2013-05-23','16:25:00',1.74),('15529','2013-05-22','08:30:00',1.13),('15529','2013-05-22','08:40:00',1.08),('15529','2013-05-22','09:20:00',1.65),('15529','2013-05-22','09:25:00',1.74),('15529','2013-05-22','09:35:00',1.44),('15529','2013-05-22','09:45:00',1.62),('15529','2013-05-22','10:00:00',1.97),('15529','2013-05-22','10:10:00',1.53),('15529','2013-05-22','10:15:00',1.03),('15529','2013-05-22','10:20:00',2),('15529','2013-05-22','10:25:00',1),('15529','2013-05-22','10:30:00',2.2),('15529','2013-05-22','10:35:00',2),('15529','2013-05-22','10:40:00',1.42),('15529','2013-05-22','10:45:00',2.02),('15529','2013-05-22','10:50:00',1.2),('15529','2013-05-22','11:05:00',1.23),('15529','2013-05-22','11:10:00',1.63),('15529','2013-05-22','11:15:00',1.78),('15529','2013-05-22','11:25:00',1.41),('15529','2013-05-22','11:30:00',1.12),('15529','2013-05-22','11:35:00',1.54),('15529','2013-05-22','11:40:00',1.74),('15529','2013-05-22','11:50:00',1.25),('15529','2013-05-22','11:55:00',2.06),('15529','2013-05-22','12:00:00',2.58),('15529','2013-05-22','12:05:00',2.43),('15529','2013-05-22','12:10:00',2.57),('15529','2013-05-22','12:15:00',1.44),('15529','2013-05-22','12:35:00',1.5),('15529','2013-05-22','12:40:00',2.34),('15529','2013-05-22','12:45:00',2.58),('15529','2013-05-22','12:50:00',2.68),('15529','2013-05-22','12:55:00',2.1),('15529','2013-05-22','13:00:00',1.71),('15529','2013-05-22','13:05:00',2.45),('15529','2013-05-22','13:10:00',2.63),('15529','2013-05-22','13:15:00',2.01),('15529','2013-05-22','13:20:00',2.49),('15529','2013-05-22','13:25:00',2.13),('15529','2013-05-22','13:30:00',1.88),('15529','2013-05-22','13:35:00',2.08),('15529','2013-05-22','13:40:00',1.61),('15529','2013-05-22','13:45:00',1.35),('15529','2013-05-22','13:50:00',1.63),('15529','2013-05-22','13:55:00',2.09),('15529','2013-05-22','14:00:00',2.16),('15529','2013-05-22','14:05:00',1.29),('15529','2013-05-22','14:10:00',2.17),('15529','2013-05-22','14:15:00',2.25),('15529','2013-05-22','14:30:00',1.96),('15529','2013-05-22','14:35:00',1.26),('15529','2013-05-22','14:40:00',1.04),('15529','2013-05-22','14:45:00',1.77),('15529','2013-05-22','14:50:00',2.52),('15529','2013-05-22','14:55:00',2.31),('15529','2013-05-22','15:00:00',1.62),('15529','2013-05-22','15:05:00',1.8),('15529','2013-05-22','15:15:00',1.56),('15529','2013-05-22','15:20:00',1.73),('15529','2013-05-22','15:25:00',1.76),('15529','2013-05-22','15:30:00',2.08),('15529','2013-05-22','15:35:00',1.42),('15529','2013-05-22','15:40:00',1.57),('15529','2013-05-22','15:45:00',1.04),('15529','2013-05-22','15:55:00',1.91),('15529','2013-05-22','16:00:00',1.91),('15529','2013-05-22','16:05:00',1.36),('15529','2013-05-22','16:10:00',1.34),('15529','2013-05-22','16:15:00',1.96),('15529','2013-05-22','16:25:00',1.23),('15529','2013-05-22','16:35:00',1.05),('15529','2013-05-22','16:40:00',1.05),('15529','2013-05-22','17:05:00',1.09),('15529','2013-05-22','17:10:00',1.13),('15529','2013-05-22','18:00:00',1.07),('15529','2013-05-21','08:30:00',1.16),('15529','2013-05-21','08:35:00',1.16),('15529','2013-05-21','09:25:00',1.06),('15529','2013-05-21','09:30:00',1.5),('15529','2013-05-21','09:35:00',1.49),('15529','2013-05-21','09:40:00',1.5),('15529','2013-05-21','09:45:00',1.51),('15529','2013-05-21','09:50:00',1.55),('15529','2013-05-21','09:55:00',1.59),('15529','2013-05-21','10:00:00',1.63),('15529','2013-05-21','10:05:00',1.66),('15529','2013-05-21','10:10:00',1.69),('15529','2013-05-21','10:15:00',1.71),('15529','2013-05-21','10:20:00',1.68),('15529','2013-05-21','10:25:00',1.46),('15529','2013-05-21','10:30:00',1.72),('15529','2013-05-21','10:35:00',1.89),('15529','2013-05-21','10:40:00',1.96),('15529','2013-05-21','10:45:00',1.89),('15529','2013-05-21','10:50:00',1.89),('15529','2013-05-21','10:55:00',1.91),('15529','2013-05-21','11:00:00',1.97),('15529','2013-05-21','11:05:00',1.97),('15529','2013-05-21','11:10:00',2.05),('15529','2013-05-21','11:15:00',2.05),('15529','2013-05-21','11:20:00',2.08),('15529','2013-05-21','11:25:00',1.83),('15529','2013-05-21','11:30:00',1.43),('15529','2013-05-21','11:35:00',1.96),('15529','2013-05-21','11:40:00',2.25),('15529','2013-05-21','11:45:00',1.97),('15529','2013-05-21','11:50:00',1.78),('15529','2013-05-21','11:55:00',1.2),('15529','2013-05-21','12:00:00',1.37),('15529','2013-05-21','12:05:00',1.18),('15529','2013-05-21','12:10:00',1.17),('15529','2013-05-21','12:15:00',1.62),('15529','2013-05-21','12:20:00',1.75),('15529','2013-05-21','12:25:00',1.59),('15529','2013-05-21','12:30:00',1.05),('15529','2013-05-21','13:05:00',1.9),('15529','2013-05-21','13:10:00',1.33),('15529','2013-05-21','13:15:00',1.38),('15529','2013-05-21','13:30:00',1.8),('15529','2013-05-21','13:35:00',2.04),('15529','2013-05-21','13:40:00',1.88),('15529','2013-05-21','13:45:00',1.56),('15529','2013-05-21','13:50:00',2.07),('15529','2013-05-21','13:55:00',2.28),('15529','2013-05-21','14:00:00',1.73),('15529','2013-05-21','14:05:00',1.38),('15529','2013-05-21','14:10:00',2.24),('15529','2013-05-21','14:15:00',2.2),('15529','2013-05-21','14:20:00',2.13),('15529','2013-05-21','14:25:00',2.12),('15529','2013-05-21','14:30:00',2.11),('15529','2013-05-21','14:35:00',2.08),('15529','2013-05-21','14:40:00',2.09),('15529','2013-05-21','14:45:00',2.06),('15529','2013-05-21','14:50:00',2.03),('15529','2013-05-21','14:55:00',2.01),('15529','2013-05-21','15:00:00',2),('15529','2013-05-21','15:05:00',1.97),('15529','2013-05-21','15:10:00',1.86),('15529','2013-05-21','15:15:00',1.93),('15529','2013-05-21','15:20:00',1.85),('15529','2013-05-21','15:25:00',1.9),('15529','2013-05-21','15:30:00',1.6),('15529','2013-05-21','15:35:00',1.3),('15529','2013-05-21','15:40:00',1.97),('15529','2013-05-21','15:45:00',1.81),('15529','2013-05-21','15:50:00',1.57),('15529','2013-05-21','15:55:00',1.7),('15529','2013-05-21','16:00:00',1.66),('15529','2013-05-21','16:05:00',1.59),('15529','2013-05-21','16:10:00',1.58),('15529','2013-05-21','16:15:00',1.57),('15529','2013-05-21','16:20:00',1.53),('15529','2013-05-21','16:25:00',1.44),('15529','2013-05-21','16:30:00',1.01),('15529','2013-05-21','16:35:00',1.09),('15529','2013-05-21','16:40:00',1.35),('15529','2014-03-31','09:00:00',1.02),('15529','2014-03-31','09:05:00',1.07),('15529','2014-03-31','09:10:00',1.11),('15529','2014-03-31','09:15:00',1.15),('15529','2014-03-31','09:20:00',1.2),('15529','2014-03-31','09:25:00',1.25),('15529','2014-03-31','09:30:00',1.31),('15529','2014-03-31','09:35:00',1.35),('15529','2014-03-31','09:40:00',1.36),('15529','2014-03-31','09:45:00',1.44),('15529','2014-03-31','09:50:00',1.49),('15529','2014-03-31','09:55:00',1.49),('15529','2014-03-31','10:00:00',1.5),('15529','2014-03-31','10:05:00',1.67),('15529','2014-03-31','10:25:00',1.21),('15529','2014-03-31','10:30:00',1.85),('15529','2014-03-31','10:35:00',1.84),('15529','2014-03-31','10:40:00',1.88),('15529','2014-03-31','10:45:00',1.91),('15529','2014-03-31','10:50:00',1.89),('15529','2014-03-31','10:55:00',1.92),('15529','2014-03-31','11:00:00',1.99),('15529','2014-03-31','11:05:00',2.01),('15529','2014-03-31','11:10:00',2.01),('15529','2014-03-31','11:15:00',2.04),('15529','2014-03-31','11:20:00',2.09),('15529','2014-03-31','11:25:00',2.11),('15529','2014-03-31','11:30:00',2.16),('15529','2014-03-31','11:35:00',2.18),('15529','2014-03-31','11:40:00',2.15),('15529','2014-03-31','11:45:00',2.21),('15529','2014-03-31','11:50:00',2.15),('15529','2014-03-31','11:55:00',2.21),('15529','2014-03-31','12:00:00',2.23),('15529','2014-03-31','12:05:00',2.26),('15529','2014-03-31','12:10:00',2.3),('15529','2014-03-31','12:15:00',2.32),('15529','2014-03-31','12:20:00',2.32),('15529','2014-03-31','12:25:00',2.35),('15529','2014-03-31','12:30:00',2.36),('15529','2014-03-31','12:35:00',2.35),('15529','2014-03-31','12:40:00',2.4),('15529','2014-03-31','12:45:00',2.4),('15529','2014-03-31','12:50:00',2.36),('15529','2014-03-31','12:55:00',2.36),('15529','2014-03-31','13:00:00',2.33),('15529','2014-03-31','13:05:00',2.4),('15529','2014-03-31','13:10:00',2.4),('15529','2014-03-31','13:15:00',2.39),('15529','2014-03-31','13:20:00',2.37),('15529','2014-03-31','13:25:00',2.39),('15529','2014-03-31','13:30:00',2.31),('15529','2014-03-31','13:35:00',2.22),('15529','2014-03-31','13:40:00',2.41),('15529','2014-03-31','13:45:00',2.35),('15529','2014-03-31','13:50:00',2.37),('15529','2014-03-31','13:55:00',2.35),('15529','2014-03-31','14:00:00',2.31),('15529','2014-03-31','14:05:00',2.34),('15529','2014-03-31','14:10:00',2.32),('15529','2014-03-31','14:15:00',1.93),('15529','2014-03-31','14:20:00',2.26),('15529','2014-03-31','14:25:00',1.99),('15529','2014-03-31','14:30:00',2.23),('15529','2014-03-31','14:35:00',2.27),('15529','2014-03-31','14:40:00',1.93),('15529','2014-03-31','14:45:00',1.95),('15529','2014-03-31','14:50:00',2.29),('15529','2014-03-31','14:55:00',1.96),('15529','2014-03-31','15:00:00',2.23),('15529','2014-03-31','15:05:00',2.04),('15529','2014-03-31','15:10:00',1.17),('15529','2014-03-31','15:15:00',1.53),('15529','2014-03-31','15:20:00',2.22),('15529','2014-03-31','15:25:00',1.53),('15529','2014-03-31','15:30:00',1.83),('15529','2014-03-31','15:35:00',1.87),('15529','2014-03-31','15:40:00',1.54),('15529','2014-03-31','15:45:00',1.43),('15529','2014-03-31','15:50:00',1.31),('15529','2014-03-31','15:55:00',1.35),('15529','2014-03-31','16:00:00',1.35),('15529','2014-03-31','16:05:00',1.44),('15529','2014-03-31','16:10:00',1.21),('15529','2014-03-31','16:15:00',1.39),('15529','2014-03-31','16:20:00',1.33),('15529','2014-03-31','16:25:00',1.57),('15529','2014-03-31','16:30:00',1.24),('15529','2014-03-31','16:35:00',1.19),('15529','2014-03-31','16:40:00',1.34),('15529','2014-03-31','16:55:00',1.27),('15529','2014-03-31','17:00:00',1.27),('15529','2014-03-31','17:10:00',1.1),('15529','2014-03-31','17:15:00',1.13),('15529','2013-05-20','09:20:00',1.11),('15529','2013-05-20','09:25:00',1.23),('15529','2013-05-20','09:35:00',1.06),('15529','2013-05-20','10:00:00',1.06),('15529','2013-05-20','10:05:00',1.07),('15529','2013-05-20','10:10:00',1.06),('15529','2013-05-20','10:15:00',1.12),('15529','2013-05-20','10:35:00',1.02),('15529','2013-05-20','10:40:00',1.2),('15529','2013-05-20','10:45:00',1.51),('15529','2013-05-20','11:05:00',1.04),('15529','2013-05-20','11:10:00',1.5),('15529','2013-05-20','11:15:00',1.81),('15529','2013-05-20','11:20:00',2),('15529','2013-05-20','11:25:00',2.31),('15529','2013-05-20','11:30:00',1.77),('15529','2013-05-20','11:35:00',1.24),('15529','2013-05-20','11:40:00',1.46),('15529','2013-05-20','11:45:00',1.59),('15529','2013-05-20','11:50:00',1.4),('15529','2013-05-20','11:55:00',1.68),('15529','2013-05-20','12:00:00',1.42),('15529','2013-05-20','12:05:00',1.84),('15529','2013-05-20','12:10:00',1.57),('15529','2013-05-20','12:15:00',1.47),('15529','2013-05-20','12:20:00',1.31),('15529','2013-05-20','12:25:00',1.75),('15529','2013-05-20','12:30:00',1.76),('15529','2013-05-20','12:35:00',1.32),('15529','2013-05-20','12:40:00',1.74),('15529','2013-05-20','12:45:00',2.03),('15529','2013-05-20','12:50:00',1.77),('15529','2013-05-20','12:55:00',2.18),('15529','2013-05-20','13:00:00',2.11),('15529','2013-05-20','13:05:00',1.83),('15529','2013-05-20','13:10:00',1.73),('15529','2013-05-20','13:15:00',1.75),('15529','2013-05-20','13:20:00',1.82),('15529','2013-05-20','13:25:00',1.61),('15529','2013-05-20','13:30:00',1.27),('15529','2013-05-20','14:25:00',1.24),('15529','2013-05-20','14:30:00',1.27),('15529','2013-05-20','14:35:00',1.1),('15529','2013-05-20','15:30:00',1.21),('15529','2013-05-19','08:30:00',1.03),('15529','2013-05-19','08:55:00',1.26),('15529','2013-05-19','09:00:00',1.37),('15529','2013-05-19','09:05:00',1.14),('15529','2013-05-19','09:20:00',1.1),('15529','2013-05-19','09:25:00',1.61),('15529','2013-05-19','09:30:00',1.74),('15529','2013-05-19','09:35:00',1.76),('15529','2013-05-19','09:40:00',1.75),('15529','2013-05-19','09:45:00',1.78),('15529','2013-05-19','09:50:00',1.85),('15529','2013-05-19','09:55:00',2.05),('15529','2013-05-19','10:00:00',2),('15529','2013-05-19','10:05:00',1.94),('15529','2013-05-19','10:10:00',1.17),('15529','2013-05-19','10:15:00',1.19),('15529','2013-05-19','10:20:00',1.62),('15529','2013-05-19','10:30:00',1.82),('15529','2013-05-19','10:35:00',1.76),('15529','2013-05-19','10:40:00',1.57),('15529','2013-05-19','10:45:00',1.85),('15529','2013-05-19','10:55:00',2.21),('15529','2013-05-19','11:00:00',1.76),('15529','2013-05-19','11:05:00',1.74),('15529','2013-05-19','11:10:00',1.53),('15529','2013-05-19','11:15:00',2.53),('15529','2013-05-19','11:20:00',1.45),('15529','2013-05-19','11:25:00',2.49),('15529','2013-05-19','11:30:00',1.82),('15529','2013-05-19','11:35:00',2.64),('15529','2013-05-19','11:40:00',1.5),('15529','2013-05-19','11:45:00',2.53),('15529','2013-05-19','11:50:00',1.9),('15529','2013-05-19','11:55:00',1.76),('15529','2013-05-19','12:00:00',1.17),('15529','2013-05-19','12:10:00',1.78),('15529','2013-05-19','12:25:00',2.03),('15529','2013-05-19','12:30:00',1.9),('15529','2013-05-19','12:35:00',1.37),('15529','2013-05-19','12:40:00',1.81),('15529','2013-05-19','12:45:00',1.34),('15529','2013-05-19','12:55:00',1.92),('15529','2013-05-19','13:00:00',1.93),('15529','2013-05-19','13:05:00',2.35),('15529','2013-05-19','13:10:00',2.55),('15529','2013-05-19','13:15:00',2.19),('15529','2013-05-19','13:20:00',1.56),('15529','2013-05-19','13:25:00',1.41),('15529','2013-05-19','13:30:00',1.63),('15529','2013-05-19','13:35:00',2.31),('15529','2013-05-19','13:40:00',2.63),('15529','2013-05-19','13:45:00',2.5),('15529','2013-05-19','13:50:00',2.53),('15529','2013-05-19','13:55:00',1.01),('15529','2013-05-19','14:00:00',2.05),('15529','2013-05-19','14:05:00',2.34),('15529','2013-05-19','14:10:00',2.46),('15529','2013-05-19','14:15:00',2.43),('15529','2013-05-19','14:20:00',2.42),('15529','2013-05-19','14:25:00',2.36),('15529','2013-05-19','14:30:00',2.32),('15529','2013-05-19','14:35:00',2.4),('15529','2013-05-19','14:40:00',2.41),('15529','2013-05-19','14:45:00',2.29),('15529','2013-05-19','14:50:00',2.08),('15529','2013-05-19','14:55:00',2.33),('15529','2013-05-19','15:00:00',2.31),('15529','2013-05-19','15:05:00',1.79),('15529','2013-05-19','15:10:00',1.62),('15529','2013-05-19','15:15:00',2.34),('15529','2013-05-19','15:20:00',1.48),('15529','2013-05-19','15:25:00',1.14),('15529','2013-05-19','15:30:00',2.16),('15529','2013-05-19','15:40:00',1.63),('15529','2013-05-19','15:45:00',1.57),('15529','2013-05-19','15:50:00',2.11),('15529','2013-05-19','15:55:00',2.04),('15529','2013-05-19','16:00:00',1.94),('15529','2013-05-19','16:05:00',1.88),('15529','2013-05-19','16:10:00',1.73),('15529','2013-05-19','16:15:00',1.75),('15529','2013-05-19','16:20:00',1.7),('15529','2013-05-19','16:25:00',1.66),('15529','2013-05-19','16:30:00',1.62),('15529','2013-05-19','16:35:00',1.56),('15529','2013-05-19','16:40:00',1.49),('15529','2013-05-19','16:45:00',1.37),('15529','2013-05-19','16:50:00',1.4),('15529','2013-05-19','16:55:00',1.33),('15529','2013-05-19','17:00:00',1.15),('15529','2013-05-19','17:05:00',1.17),('15529','2013-05-19','17:10:00',1.18),('15529','2013-05-19','17:20:00',1.37),('15529','2013-05-19','17:25:00',1.36),('15529','2013-05-19','17:30:00',1.15),('15529','2013-05-18','10:10:00',1.05),('15529','2013-05-18','10:20:00',1.24),('15529','2013-05-18','10:25:00',1.44),('15529','2013-05-18','10:30:00',1.25),('15529','2013-05-18','10:35:00',1.78),('15529','2013-05-18','10:40:00',1.72),('15529','2013-05-18','10:45:00',1.84),('15529','2013-05-18','10:50:00',2.09),('15529','2013-05-18','10:55:00',2.18),('15529','2013-05-18','11:00:00',2.23),('15529','2013-05-18','11:05:00',2.51),('15529','2013-05-18','11:10:00',2.44),('15529','2013-05-18','11:15:00',2.51),('15529','2013-05-18','11:20:00',2.34),('15529','2013-05-18','11:25:00',2.25),('15529','2013-05-18','11:30:00',2.32),('15529','2013-05-18','11:35:00',2.28),('15529','2013-05-18','11:40:00',2.34),('15529','2013-05-18','11:45:00',2.27),('15529','2013-05-18','11:50:00',2.36),('15529','2013-05-18','11:55:00',2.42),('15529','2013-05-18','12:00:00',2.44),('15529','2013-05-18','12:05:00',2.38),('15529','2013-05-18','12:10:00',2.44),('15529','2013-05-18','12:15:00',2.52),('15529','2013-05-18','12:20:00',1.37),('15529','2013-05-18','12:25:00',1.28),('15529','2013-05-18','12:30:00',1.16),('15529','2013-05-18','12:35:00',1.75),('15529','2013-05-18','12:40:00',1.62),('15529','2013-05-18','12:45:00',1.76),('15529','2013-05-18','12:50:00',1.85),('15529','2013-05-18','12:55:00',1.44),('15529','2013-05-18','13:00:00',2.2),('15529','2013-05-18','13:05:00',2.24),('15529','2013-05-18','13:10:00',2.31),('15529','2013-05-18','13:15:00',2.41),('15529','2013-05-18','13:20:00',2.53),('15529','2013-05-18','13:25:00',2.43),('15529','2013-05-18','13:30:00',2.38),('15529','2013-05-18','13:35:00',2.36),('15529','2013-05-18','13:40:00',2.35),('15529','2013-05-18','13:45:00',2.39),('15529','2013-05-18','13:50:00',2.39),('15529','2013-05-18','13:55:00',2.38),('15529','2013-05-18','14:00:00',2.34),('15529','2013-05-18','14:05:00',2.35),('15529','2013-05-18','14:10:00',2.34),('15529','2013-05-18','14:15:00',2.32),('15529','2013-05-18','14:20:00',2.32),('15529','2013-05-18','14:25:00',2.27),('15529','2013-05-18','14:30:00',2.29),('15529','2013-05-18','14:35:00',2.28),('15529','2013-05-18','14:40:00',2.25),('15529','2013-05-18','14:45:00',2.25),('15529','2013-05-18','14:50:00',2.22),('15529','2013-05-18','14:55:00',2.24),('15529','2013-05-18','15:00:00',2.21),('15529','2013-05-18','15:05:00',2.17),('15529','2013-05-18','15:10:00',2.16),('15529','2013-05-18','15:15:00',2.12),('15529','2013-05-18','15:20:00',2.09),('15529','2013-05-18','15:25:00',2.07),('15529','2013-05-18','15:30:00',2.05),('15529','2013-05-18','15:35:00',1.98),('15529','2013-05-18','15:40:00',1.97),('15529','2013-05-18','15:45:00',1.93),('15529','2013-05-18','15:50:00',1.93),('15529','2013-05-18','15:55:00',1.88),('15529','2013-05-18','16:00:00',1.83),('15529','2013-05-18','16:05:00',1.81),('15529','2013-05-18','16:10:00',1.77),('15529','2013-05-18','16:15:00',1.74),('15529','2013-05-18','16:20:00',1.7),('15529','2013-05-18','16:25:00',1.66),('15529','2013-05-18','16:30:00',1.63),('15529','2013-05-18','16:35:00',1.59),('15529','2013-05-18','16:40:00',1.55),('15529','2013-05-18','16:45:00',1.51),('15529','2013-05-18','16:50:00',1.46),('15529','2013-05-18','16:55:00',1.42),('15529','2013-05-18','17:00:00',1.37),('15529','2013-05-18','17:05:00',1.33),('15529','2013-05-18','17:10:00',1.28),('15529','2013-05-18','17:15:00',1.23),('15529','2013-05-18','17:20:00',1.17),('15529','2013-05-18','17:25:00',1.11),('15529','2013-05-18','17:30:00',1.07),('15529','2013-05-18','17:35:00',1.03),('15529','2013-05-17','08:25:00',1.19),('15529','2013-05-17','08:40:00',1.08),('15529','2013-05-17','08:45:00',1.11),('15529','2013-05-17','08:50:00',1.17),('15529','2013-05-17','08:55:00',1.22),('15529','2013-05-17','09:00:00',1.25),('15529','2013-05-17','09:05:00',1.29),('15529','2013-05-17','09:10:00',1.35),('15529','2013-05-17','09:15:00',1.38),('15529','2013-05-17','09:20:00',1.41),('15529','2013-05-17','09:25:00',1.46),('15529','2013-05-17','09:30:00',1.49),('15529','2013-05-17','09:35:00',1.54),('15529','2013-05-17','09:40:00',1.57),('15529','2013-05-17','09:45:00',1.6),('15529','2013-05-17','09:50:00',1.63),('15529','2013-05-17','09:55:00',1.67),('15529','2013-05-17','10:00:00',1.69),('15529','2013-05-17','10:05:00',1.73),('15529','2013-05-17','10:10:00',1.77),('15529','2013-05-17','10:15:00',1.8),('15529','2013-05-17','10:20:00',1.82),('15529','2013-05-17','10:25:00',1.85),('15529','2013-05-17','10:30:00',1.87),('15529','2013-05-17','10:35:00',1.88),('15529','2013-05-17','10:40:00',1.92),('15529','2013-05-17','10:45:00',1.94),('15529','2013-05-17','10:50:00',1.99),('15529','2013-05-17','10:55:00',2.07),('15529','2013-05-17','11:00:00',2.12),('15529','2013-05-17','11:05:00',1.91),('15529','2013-05-17','11:10:00',1.8),('15529','2013-05-17','11:15:00',2.17),('15529','2013-05-17','11:20:00',2.31),('15529','2013-05-17','11:25:00',2.25),('15529','2013-05-17','11:30:00',2.23),('15529','2013-05-17','11:35:00',2.21),('15529','2013-05-17','11:40:00',2.2),('15529','2013-05-17','11:45:00',2.15),('15529','2013-05-17','11:50:00',2.24),('15529','2013-05-17','11:55:00',1.48),('15529','2013-05-17','12:00:00',2.12),('15529','2013-05-17','12:05:00',2.23),('15529','2013-05-17','12:10:00',2.22),('15529','2013-05-17','12:15:00',2.23),('15529','2013-05-17','12:20:00',2.24),('15529','2013-05-17','12:25:00',2.3),('15529','2013-05-17','12:30:00',1.74),('15529','2013-05-17','12:35:00',2.25),('15529','2013-05-17','12:40:00',2.27),('15529','2013-05-17','12:45:00',2.27),('15529','2013-05-17','12:50:00',2.29),('15529','2013-05-17','12:55:00',2.24),('15529','2013-05-17','13:00:00',2.25),('15529','2013-05-17','13:05:00',2.24),('15529','2013-05-17','13:10:00',2.24),('15529','2013-05-17','13:15:00',2.22),('15529','2013-05-17','13:20:00',2.25),('15529','2013-05-17','13:25:00',2.25),('15529','2013-05-17','13:30:00',2.28),('15529','2013-05-17','13:35:00',2.3),('15529','2013-05-17','13:40:00',2.24),('15529','2013-05-17','13:45:00',2.12),('15529','2013-05-17','13:50:00',1.82),('15529','2013-05-17','13:55:00',1.42),('15529','2013-05-17','14:00:00',1.52),('15529','2013-05-17','14:05:00',2.13),('15529','2013-05-17','14:10:00',2.18),('15529','2013-05-17','14:15:00',1.86),('15529','2013-05-17','14:20:00',2.33),('15529','2013-05-17','14:25:00',2.24),('15529','2013-05-17','14:30:00',2.2),('15529','2013-05-17','14:35:00',2.04),('15529','2013-05-17','14:40:00',1.84),('15529','2013-05-17','14:45:00',1.24),('15529','2013-05-17','14:50:00',1.91),('15529','2013-05-17','14:55:00',2.07),('15529','2013-05-17','15:00:00',1.98),('15529','2013-05-17','15:05:00',1.91),('15529','2013-05-17','15:10:00',1.89),('15529','2013-05-17','15:15:00',1.86),('15529','2013-05-17','15:20:00',1.81),('15529','2013-05-17','15:25:00',1.79),('15529','2013-05-17','15:30:00',1.74),('15529','2013-05-17','15:35:00',1.74),('15529','2013-05-17','15:40:00',1.7),('15529','2013-05-17','15:45:00',1.67),('15529','2013-05-17','15:50:00',1.64),('15529','2013-05-17','15:55:00',1.63),('15529','2013-05-17','16:00:00',1.6),('15529','2013-05-17','16:05:00',1.56),('15529','2013-05-17','16:10:00',1.51),('15529','2013-05-17','16:15:00',1.48),('15529','2013-05-17','16:20:00',1.44),('15529','2013-05-17','16:25:00',1.4),('15529','2013-05-17','16:30:00',1.37),('15529','2013-05-17','16:35:00',1.33),('15529','2013-05-17','16:40:00',1.28),('15529','2013-05-17','16:45:00',1.25),('15529','2013-05-17','16:50:00',1.2),('15529','2013-05-17','16:55:00',1.14),('15529','2013-05-17','17:00:00',1.11),('15529','2013-05-17','17:05:00',1.08),('15529','2013-05-17','17:10:00',1.04),('15529','2013-05-17','17:15:00',1.01),('15529','2013-05-16','08:15:00',1.07),('15529','2013-05-16','10:50:00',1.94),('15529','2013-05-16','10:55:00',1.14),('15529','2013-05-16','11:00:00',1.01),('15529','2013-05-16','11:15:00',1.84),('15529','2013-05-16','11:20:00',1.05),('15529','2013-05-16','11:30:00',1.56),('15529','2013-05-16','11:35:00',1.7),('15529','2013-05-16','11:40:00',2.04),('15529','2013-05-16','11:45:00',2.19),('15529','2013-05-16','11:50:00',1.88),('15529','2013-05-16','11:55:00',2.47),('15529','2013-05-16','12:00:00',2.62),('15529','2013-05-16','12:05:00',2.01),('15529','2013-05-16','12:10:00',1.99),('15529','2013-05-16','12:15:00',1.56),('15529','2013-05-16','12:20:00',2.29),('15529','2013-05-16','12:25:00',1.97),('15529','2013-05-16','12:30:00',1.86),('15529','2013-05-16','12:35:00',2.23),('15529','2013-05-16','12:40:00',2.62),('15529','2013-05-16','12:45:00',2.5),('15529','2013-05-16','12:50:00',2.19),('15529','2013-05-16','12:55:00',2.39),('15529','2013-05-16','13:00:00',2.39),('15529','2013-05-16','13:05:00',2.57),('15529','2013-05-16','13:10:00',2.39),('15529','2013-05-16','13:15:00',2.47),('15529','2013-05-16','13:20:00',2.34),('15529','2013-05-16','13:25:00',2.41),('15529','2013-05-16','13:30:00',2.05),('15529','2013-05-16','13:35:00',2.48),('15529','2013-05-16','13:40:00',2.3),('15529','2013-05-16','13:45:00',2.21),('15529','2013-05-16','13:50:00',2.11),('15529','2013-05-16','13:55:00',2.56),('15529','2013-05-16','14:00:00',2.14),('15529','2013-05-16','14:05:00',2.22),('15529','2013-05-16','14:10:00',2.14),('15529','2013-05-16','14:15:00',2.41),('15529','2013-05-16','14:20:00',2.35),('15529','2013-05-16','14:25:00',1.85),('15529','2013-05-16','14:30:00',1.71),('15529','2013-05-16','14:35:00',1.9),('15529','2013-05-16','14:40:00',1.04),('15529','2013-05-16','14:45:00',1.31),('15529','2013-05-16','15:10:00',1.02),('15529','2013-05-16','15:15:00',1.03),('15529','2013-05-16','15:20:00',1.39),('15529','2013-05-16','15:25:00',1.63),('15529','2013-05-16','15:30:00',1.87),('15529','2013-05-16','15:35:00',1.21),('15529','2013-05-16','15:40:00',1.5),('15529','2013-05-16','15:45:00',2.01),('15529','2013-05-16','15:50:00',1.32),('15529','2013-05-16','15:55:00',1.19),('15529','2013-05-16','16:10:00',1.93),('15529','2013-05-16','16:15:00',1.8),('15529','2013-05-16','16:20:00',1.46),('15529','2013-05-16','16:25:00',1.7),('15529','2013-05-16','16:30:00',1.38),('15529','2013-05-16','16:35:00',1.01),('15529','2013-05-16','16:40:00',1.39),('15529','2013-05-16','16:45:00',1.52),('15529','2013-05-16','16:50:00',1.44),('15529','2013-05-16','16:55:00',1.39),('15529','2013-05-16','17:00:00',1.33),('15529','2013-05-16','17:05:00',1.27),('15529','2013-05-16','17:10:00',1.23),('15529','2013-05-16','17:15:00',1.17),('15529','2013-05-16','17:20:00',1.12),('15529','2013-05-16','17:25:00',1.08),('15529','2013-05-16','17:30:00',1.04),('15529','2013-05-15','09:40:00',1),('15529','2013-05-15','09:45:00',1.45),('15529','2013-05-15','09:50:00',1.03),('15529','2013-05-15','10:20:00',1.14),('15529','2013-05-15','11:00:00',1.78),('15529','2013-05-15','11:05:00',1.88),('15529','2013-05-15','11:10:00',2.1),('15529','2013-05-15','11:15:00',1.76),('15529','2013-05-15','11:55:00',1.81),('15529','2013-05-15','12:00:00',1.09),('15529','2013-05-15','12:05:00',1.1),('15529','2013-05-15','12:15:00',1.46),('15529','2013-05-15','12:30:00',1.35),('15529','2013-05-15','12:35:00',1.93),('15529','2013-05-15','12:40:00',2.24),('15529','2013-05-15','12:45:00',1.72),('15529','2013-05-15','12:50:00',1.56),('15529','2013-05-15','12:55:00',1.59),('15529','2013-05-15','13:00:00',2.19),('15529','2013-05-15','13:05:00',2.2),('15529','2013-05-15','13:10:00',2.15),('15529','2013-05-15','13:15:00',2.17),('15529','2013-05-15','13:20:00',2.14),('15529','2013-05-15','13:25:00',2.14),('15529','2013-05-15','13:30:00',2.16),('15529','2013-05-15','13:35:00',2.18),('15529','2013-05-15','13:40:00',2.1),('15529','2013-05-15','13:45:00',2.15),('15529','2013-05-15','13:50:00',2.13),('15529','2013-05-15','13:55:00',2.12),('15529','2013-05-15','14:00:00',2.16),('15529','2013-05-15','14:05:00',2.08),('15529','2013-05-15','14:10:00',2.01),('15529','2013-05-15','14:15:00',2.03),('15529','2013-05-15','14:20:00',2.01),('15529','2013-05-15','14:25:00',2.01),('15529','2013-05-15','14:30:00',1.91),('15529','2013-05-15','14:35:00',1.93),('15529','2013-05-15','14:40:00',1.91),('15529','2013-05-15','14:45:00',1.94),('15529','2013-05-15','14:50:00',1.97),('15529','2013-05-15','14:55:00',1.9),('15529','2013-05-15','15:00:00',1.82),('15529','2013-05-15','15:05:00',1.6),('15529','2013-05-15','15:10:00',1.47),('15529','2013-05-15','15:15:00',1.62),('15529','2013-05-15','15:20:00',1.77),('15529','2013-05-15','15:25:00',1.71),('15529','2013-05-15','15:30:00',1.71),('15529','2013-05-15','15:35:00',1.66),('15529','2013-05-15','15:40:00',1.66),('15529','2013-05-15','15:45:00',1.63),('15529','2013-05-15','15:50:00',1.62),('15529','2013-05-15','15:55:00',1.59),('15529','2013-05-15','16:00:00',1.56),('15529','2013-05-15','16:05:00',1.48),('15529','2013-05-15','16:10:00',1.51),('15529','2013-05-15','16:15:00',1.34),('15529','2013-05-15','16:20:00',1.44),('15529','2013-05-15','16:25:00',1.39),('15529','2013-05-15','16:30:00',1.35),('15529','2013-05-15','16:35:00',1.31),('15529','2013-05-15','16:50:00',1.02),('15529','2013-05-14','08:40:00',1.05),('15529','2013-05-14','08:45:00',1.09),('15529','2013-05-14','08:50:00',1.13),('15529','2013-05-14','08:55:00',1.17),('15529','2013-05-14','09:00:00',1.17),('15529','2013-05-14','09:05:00',1.24),('15529','2013-05-14','09:10:00',1.24),('15529','2013-05-14','09:15:00',1.28),('15529','2013-05-14','09:20:00',1.29),('15529','2013-05-14','09:25:00',1.37),('15529','2013-05-14','09:30:00',1.45),('15529','2013-05-14','09:35:00',1.46),('15529','2013-05-14','09:40:00',1.48),('15529','2013-05-14','09:45:00',1.56),('15529','2013-05-14','09:50:00',1.59),('15529','2013-05-14','09:55:00',1.62),('15529','2013-05-14','10:00:00',1.66),('15529','2013-05-14','10:05:00',1.7),('15529','2013-05-14','10:10:00',1.72),('15529','2013-05-14','10:15:00',1.73),('15529','2013-05-14','10:20:00',1.81),('15529','2013-05-14','10:25:00',1.83),('15529','2013-05-14','10:30:00',1.81),('15529','2013-05-14','10:35:00',1.88),('15529','2013-05-14','10:40:00',1.93),('15529','2013-05-14','10:45:00',1.94),('15529','2013-05-14','10:50:00',1.93),('15529','2013-05-14','10:55:00',1.87),('15529','2013-05-14','11:00:00',1.87),('15529','2013-05-14','11:05:00',2.02),('15529','2013-05-14','11:10:00',2.03),('15529','2013-05-14','11:15:00',2.05),('15529','2013-05-14','11:20:00',1.99),('15529','2013-05-14','11:25:00',2.1),('15529','2013-05-14','11:30:00',2.11),('15529','2013-05-14','11:35:00',1.97),('15529','2013-05-14','11:40:00',1.61),('15529','2013-05-14','11:45:00',1.63),('15529','2013-05-14','11:50:00',1.32),('15529','2013-05-14','12:00:00',1.29),('15529','2013-05-14','12:05:00',1.62),('15529','2013-05-14','12:10:00',2.64),('15529','2013-05-14','12:15:00',2.68),('15529','2013-05-14','12:20:00',2.54),('15529','2013-05-14','12:25:00',1.72),('15529','2013-05-14','12:30:00',1.63),('15529','2013-05-14','12:35:00',2.22),('15529','2013-05-14','12:40:00',1.97),('15529','2013-05-14','12:45:00',1.31),('15529','2013-05-14','12:50:00',1.27),('15529','2013-05-14','12:55:00',1.39),('15529','2013-05-14','13:00:00',1.33),('15529','2013-05-14','13:05:00',1.74),('15529','2013-05-14','13:10:00',1.18),('15529','2013-05-14','13:15:00',1.42),('15529','2013-05-14','13:20:00',1.37),('15529','2013-05-14','13:25:00',1.54),('15529','2013-05-14','13:30:00',1.35),('15529','2013-05-14','13:35:00',1.24),('15529','2013-05-14','13:40:00',1.6),('15529','2013-05-14','13:45:00',1.28),('15529','2013-05-14','13:50:00',1.07),('15529','2013-05-14','13:55:00',1.05),('15529','2013-05-14','14:20:00',1.05),('15529','2013-05-14','15:55:00',1.11),('15529','2013-05-14','17:10:00',1.59),('15529','2013-05-14','17:15:00',1.15),('15529','2013-05-13','08:35:00',1.05),('15529','2013-05-13','08:40:00',1.09),('15529','2013-05-13','08:45:00',1.14),('15529','2013-05-13','08:50:00',1.19),('15529','2013-05-13','08:55:00',1.24),('15529','2013-05-13','09:00:00',1.29),('15529','2013-05-13','09:05:00',1.32),('15529','2013-05-13','09:10:00',1.37),('15529','2013-05-13','09:15:00',1.41),('15529','2013-05-13','09:20:00',1.45),('15529','2013-05-13','09:25:00',1.5),('15529','2013-05-13','09:30:00',1.54),('15529','2013-05-13','09:35:00',1.58),('15529','2013-05-13','09:40:00',1.62),('15529','2013-05-13','09:45:00',1.65),('15529','2013-05-13','09:50:00',1.68),('15529','2013-05-13','09:55:00',1.71),('15529','2013-05-13','10:00:00',1.74),('15529','2013-05-13','10:05:00',1.79),('15529','2013-05-13','10:10:00',1.81),('15529','2013-05-13','10:15:00',1.85),('15529','2013-05-13','10:20:00',1.86),('15529','2013-05-13','10:25:00',1.92),('15529','2013-05-13','10:30:00',1.92),('15529','2013-05-13','10:35:00',1.96),('15529','2013-05-13','10:40:00',2),('15529','2013-05-13','10:45:00',2.03),('15529','2013-05-13','10:50:00',2.02),('15529','2013-05-13','10:55:00',2.08),('15529','2013-05-13','11:00:00',2.05),('15529','2013-05-13','11:05:00',2.11),('15529','2013-05-13','11:10:00',2.12),('15529','2013-05-13','11:15:00',2.15),('15529','2013-05-13','11:20:00',2.15),('15529','2013-05-13','11:25:00',2.17),('15529','2013-05-13','11:30:00',2.16),('15529','2013-05-13','11:35:00',2.19),('15529','2013-05-13','11:40:00',2.21),('15529','2013-05-13','11:45:00',2.2),('15529','2013-05-13','11:50:00',2.21),('15529','2013-05-13','11:55:00',2.23),('15529','2013-05-13','12:00:00',2.23),('15529','2013-05-13','12:05:00',2.24),('15529','2013-05-13','12:10:00',2.24),('15529','2013-05-13','12:15:00',2.29),('15529','2013-05-13','12:20:00',2.32),('15529','2013-05-13','12:25:00',2.3),('15529','2013-05-13','12:30:00',2.32),('15529','2013-05-13','12:35:00',2.33),('15529','2013-05-13','12:40:00',2.33),('15529','2013-05-13','12:45:00',2.31),('15529','2013-05-13','12:50:00',2.33),('15529','2013-05-13','12:55:00',2.31),('15529','2013-05-13','13:00:00',2.34),('15529','2013-05-13','13:05:00',2.3),('15529','2013-05-13','13:10:00',2.33),('15529','2013-05-13','13:15:00',2.33),('15529','2013-05-13','13:20:00',2.33),('15529','2013-05-13','13:25:00',2.35),('15529','2013-05-13','13:30:00',2.31),('15529','2013-05-13','13:35:00',2.31),('15529','2013-05-13','13:40:00',2.29),('15529','2013-05-13','13:45:00',2.27),('15529','2013-05-13','13:50:00',2.24),('15529','2013-05-13','13:55:00',2.25),('15529','2013-05-13','14:00:00',2.26),('15529','2013-05-13','14:05:00',2.22),('15529','2013-05-13','14:10:00',2.21),('15529','2013-05-13','14:15:00',2.19),('15529','2013-05-13','14:20:00',2.19),('15529','2013-05-13','14:25:00',2.17),('15529','2013-05-13','14:30:00',2.17),('15529','2013-05-13','14:35:00',2.16),('15529','2013-05-13','14:40:00',2.2),('15529','2013-05-13','14:45:00',2.19),('15529','2013-05-13','14:50:00',2.15),('15529','2013-05-13','14:55:00',2.14),('15529','2013-05-13','15:00:00',2.12),('15529','2013-05-13','15:05:00',2.09),('15529','2013-05-13','15:10:00',2.07),('15529','2013-05-13','15:15:00',2.05),('15529','2013-05-13','15:20:00',2.01),('15529','2013-05-13','15:25:00',2),('15529','2013-05-13','15:30:00',1.96),('15529','2013-05-13','15:35:00',1.94),('15529','2013-05-13','15:40:00',1.91),('15529','2013-05-13','15:45:00',1.89),('15529','2013-05-13','15:50:00',1.86),('15529','2013-05-13','15:55:00',1.83),('15529','2013-05-13','16:00:00',1.79),('15529','2013-05-13','16:05:00',1.76),('15529','2013-05-13','16:10:00',1.71),('15529','2013-05-13','16:15:00',1.68),('15529','2013-05-13','16:20:00',1.64),('15529','2013-05-13','16:25:00',1.6),('15529','2013-05-13','16:30:00',1.56),('15529','2013-05-13','16:35:00',1.52),('15529','2013-05-13','16:40:00',1.47),('15529','2013-05-13','16:45:00',1.43),('15529','2013-05-13','16:50:00',1.39),('15529','2013-05-13','16:55:00',1.35),('15529','2013-05-13','17:00:00',1.3),('15529','2013-05-13','17:05:00',1.26),('15529','2013-05-13','17:10:00',1.2),('15529','2013-05-13','17:15:00',1.16),('15529','2013-05-13','17:20:00',1.12),('15529','2013-05-13','17:25:00',1.06),('15529','2013-05-13','17:30:00',1.01),('15529','2013-05-12','08:40:00',1.02),('15529','2013-05-12','08:45:00',1.08),('15529','2013-05-12','08:50:00',1.13),('15529','2013-05-12','08:55:00',1.17),('15529','2013-05-12','09:00:00',1.21),('15529','2013-05-12','09:05:00',1.25),('15529','2013-05-12','09:10:00',1.3),('15529','2013-05-12','09:15:00',1.32),('15529','2013-05-12','09:20:00',1.37),('15529','2013-05-12','09:25:00',1.27),('15529','2013-05-12','09:30:00',1.44),('15529','2013-05-12','09:35:00',1.56),('15529','2013-05-12','09:40:00',1.59),('15529','2013-05-12','09:45:00',1.69),('15529','2013-05-12','09:55:00',1.9),('15529','2013-05-12','10:00:00',1.43),('15529','2013-05-12','10:05:00',1.89),('15529','2013-05-12','10:10:00',1.85),('15529','2013-05-12','10:15:00',1.85),('15529','2013-05-12','10:20:00',1.92),('15529','2013-05-12','10:25:00',1.91),('15529','2013-05-12','10:30:00',1.96),('15529','2013-05-12','10:35:00',2.01),('15529','2013-05-12','10:40:00',2.14),('15529','2013-05-12','10:45:00',1.49),('15529','2013-05-12','10:50:00',2.08),('15529','2013-05-12','10:55:00',1.35),('15529','2013-05-12','11:00:00',2.03),('15529','2013-05-12','11:05:00',1.39),('15529','2013-05-12','11:10:00',1.65),('15529','2013-05-12','11:40:00',2.58),('15529','2013-05-12','11:45:00',2.43),('15529','2013-05-12','11:50:00',1.92),('15529','2013-05-12','11:55:00',1.82),('15529','2013-05-12','12:00:00',1.16),('15529','2013-05-12','12:30:00',1.15),('15529','2013-05-12','12:35:00',2.71),('15529','2013-05-12','12:40:00',2.58),('15529','2013-05-12','12:45:00',2.52),('15529','2013-05-12','12:50:00',2.58),('15529','2013-05-12','12:55:00',1.49),('15529','2013-05-12','13:00:00',1.73),('15529','2013-05-12','13:05:00',2.48),('15529','2013-05-12','13:10:00',2.52),('15529','2013-05-12','13:15:00',2.3),('15529','2013-05-12','13:20:00',1.89),('15529','2013-05-12','13:30:00',1.26),('15529','2013-05-12','13:35:00',2.35),('15529','2013-05-12','13:40:00',2.51),('15529','2013-05-12','13:45:00',2.55),('15529','2013-05-12','13:50:00',2.49),('15529','2013-05-12','13:55:00',2.54),('15529','2013-05-12','14:00:00',2.38),('15529','2013-05-12','14:05:00',2.44),('15529','2013-05-12','14:10:00',2.39),('15529','2013-05-12','14:15:00',2.38),('15529','2013-05-12','14:20:00',2.44),('15529','2013-05-12','14:25:00',2.28),('15529','2013-05-12','14:30:00',1.54),('15529','2013-05-12','14:50:00',1.11),('15529','2013-05-12','14:55:00',2.38),('15529','2013-05-12','15:00:00',2.23),('15529','2013-05-12','15:45:00',1.18),('15529','2013-05-12','16:55:00',1.42),('15529','2013-05-12','17:00:00',1.41),('15529','2013-05-12','17:20:00',1.02),('15529','2013-05-12','17:25:00',1.02),('15529','2013-05-12','17:30:00',1.17),('15529','2013-05-12','17:35:00',1.14),('15529','2013-05-12','17:40:00',1.1),('15529','2013-05-12','17:45:00',1.03),('15529','2013-05-12','17:50:00',1.08),('15529','2013-05-12','17:55:00',1.12),('15529','2013-05-11','08:35:00',1.19),('15529','2013-05-11','09:00:00',1.5),('15529','2013-05-11','09:05:00',1.07),('15529','2013-05-11','09:10:00',1.47),('15529','2013-05-11','09:40:00',1.07),('15529','2013-05-11','09:55:00',1.31),('15529','2013-05-11','10:00:00',1.84),('15529','2013-05-11','10:05:00',1.85),('15529','2013-05-11','10:10:00',1.92),('15529','2013-05-11','10:15:00',2.02),('15529','2013-05-11','10:20:00',1.94),('15529','2013-05-11','10:25:00',2.15),('15529','2013-05-11','10:30:00',2.1),('15529','2013-05-11','10:35:00',2.22),('15529','2013-05-11','10:40:00',2.07),('15529','2013-05-11','10:45:00',2.31),('15529','2013-05-11','10:50:00',2.24),('15529','2013-05-11','10:55:00',1.59),('15529','2013-05-11','11:00:00',1.13),('15529','2013-05-11','11:05:00',2.44),('15529','2013-05-11','11:10:00',2.47),('15529','2013-05-11','11:15:00',2.4),('15529','2013-05-11','11:20:00',2.39),('15529','2013-05-11','11:50:00',1.33),('15529','2013-05-11','11:55:00',2.47),('15529','2013-05-11','12:00:00',1.61),('15529','2013-05-11','12:05:00',1.2),('15529','2013-05-11','12:25:00',1.23),('15529','2013-05-11','12:45:00',1.26),('15529','2013-05-11','12:55:00',1.39),('15529','2013-05-11','13:00:00',2.73),('15529','2013-05-11','13:05:00',1.59),('15529','2013-05-11','13:10:00',1.19),('15529','2013-05-11','13:15:00',2.44),('15529','2013-05-11','13:20:00',2.58),('15529','2013-05-11','13:25:00',2.37),('15529','2013-05-11','13:30:00',2.14),('15529','2013-05-11','13:35:00',2.46),('15529','2013-05-11','13:40:00',2.32),('15529','2013-05-11','13:45:00',1.97),('15529','2013-05-11','13:50:00',2.55),('15529','2013-05-11','13:55:00',1.31),('15529','2013-05-11','14:00:00',2.11),('15529','2013-05-11','14:05:00',1.91),('15529','2013-05-11','14:10:00',1.72),('15529','2013-05-11','14:15:00',1.67),('15529','2013-05-11','14:20:00',2.28),('15529','2013-05-11','14:25:00',2.1),('15529','2013-05-11','14:30:00',2.17),('15529','2013-05-11','14:35:00',2.38),('15529','2013-05-11','14:40:00',2.34),('15529','2013-05-11','14:45:00',1.78),('15529','2013-05-11','14:50:00',1.85),('15529','2013-05-11','14:55:00',2.33),('15529','2013-05-11','15:00:00',1.57),('15529','2013-05-11','15:05:00',1.71),('15529','2013-05-11','15:10:00',1.55),('15529','2013-05-11','15:15:00',2.12),('15529','2013-05-11','15:20:00',2.15),('15529','2013-05-11','15:25:00',2.03),('15529','2013-05-11','15:30:00',1.99),('15529','2013-05-11','15:35:00',1.97),('15529','2013-05-11','15:40:00',1.94),('15529','2013-05-11','15:45:00',1.85),('15529','2013-05-11','15:50:00',1.82),('15529','2013-05-11','15:55:00',1.79),('15529','2013-05-11','16:00:00',1.76),('15529','2013-05-11','16:05:00',1.71),('15529','2013-05-11','16:10:00',1.69),('15529','2013-05-11','16:15:00',1.65),('15529','2013-05-11','16:20:00',1.61),('15529','2013-05-11','16:25:00',1.57),('15529','2013-05-11','16:30:00',1.54),('15529','2013-05-11','16:35:00',1.53),('15529','2013-05-11','16:40:00',1.44),('15529','2013-05-11','16:45:00',1.46),('15529','2013-05-11','16:50:00',1.48),('15529','2013-05-11','16:55:00',1.55),('15529','2013-05-11','17:00:00',1.6),('15529','2013-05-11','17:05:00',1.44),('15529','2013-05-11','17:10:00',1.26),('15529','2013-05-11','17:15:00',1.44),('15529','2013-05-11','17:20:00',1.01),('15529','2013-05-11','17:25:00',1.02),('15529','2013-05-11','17:30:00',1.21),('15529','2013-05-11','17:40:00',1.16),('15529','2014-03-30','09:00:00',1.01),('15529','2014-03-30','09:05:00',1.07),('15529','2014-03-30','09:10:00',1.11),('15529','2014-03-30','09:15:00',1.16),('15529','2014-03-30','09:20:00',1.22),('15529','2014-03-30','09:25:00',1.26),('15529','2014-03-30','09:30:00',1.3),('15529','2014-03-30','09:35:00',1.35),('15529','2014-03-30','09:40:00',1.4),('15529','2014-03-30','09:45:00',1.43),('15529','2014-03-30','09:50:00',1.46),('15529','2014-03-30','09:55:00',1.5),('15529','2014-03-30','10:00:00',1.54),('15529','2014-03-30','10:05:00',1.59),('15529','2014-03-30','10:10:00',1.63),('15529','2014-03-30','10:15:00',1.67),('15529','2014-03-30','10:20:00',1.71),('15529','2014-03-30','10:25:00',1.72),('15529','2014-03-30','10:30:00',1.76),('15529','2014-03-30','10:35:00',1.79),('15529','2014-03-30','10:40:00',1.81),('15529','2014-03-30','10:45:00',1.83),('15529','2014-03-30','10:50:00',1.86),('15529','2014-03-30','10:55:00',1.9),('15529','2014-03-30','11:00:00',1.92),('15529','2014-03-30','11:05:00',1.92),('15529','2014-03-30','11:10:00',1.97),('15529','2014-03-30','11:15:00',2),('15529','2014-03-30','11:20:00',2.02),('15529','2014-03-30','11:25:00',2.04),('15529','2014-03-30','11:30:00',2.05),('15529','2014-03-30','11:35:00',2.07),('15529','2014-03-30','11:40:00',2.07),('15529','2014-03-30','11:45:00',2.1),('15529','2014-03-30','11:50:00',2.11),('15529','2014-03-30','11:55:00',2.13),('15529','2014-03-30','12:00:00',2.12),('15529','2014-03-30','12:05:00',2.14),('15529','2014-03-30','12:10:00',2.18),('15529','2014-03-30','12:15:00',2.21),('15529','2014-03-30','12:20:00',2.23),('15529','2014-03-30','12:25:00',2.21),('15529','2014-03-30','12:30:00',2.26),('15529','2014-03-30','12:35:00',2.22),('15529','2014-03-30','12:40:00',2.23),('15529','2014-03-30','12:45:00',2.22),('15529','2014-03-30','12:50:00',2.24),('15529','2014-03-30','12:55:00',2.28),('15529','2014-03-30','13:00:00',2.31),('15529','2014-03-30','13:05:00',2.32),('15529','2014-03-30','13:10:00',2.32),('15529','2014-03-30','13:15:00',2.3),('15529','2014-03-30','13:20:00',2.3),('15529','2014-03-30','13:25:00',2.29),('15529','2014-03-30','13:30:00',2.27),('15529','2014-03-30','13:35:00',2.24),('15529','2014-03-30','13:40:00',2.28),('15529','2014-03-30','13:45:00',2.29),('15529','2014-03-30','13:50:00',2.29),('15529','2014-03-30','13:55:00',2.28),('15529','2014-03-30','14:00:00',2.29),('15529','2014-03-30','14:05:00',2.27),('15529','2014-03-30','14:10:00',2.24),('15529','2014-03-30','14:15:00',2.21),('15529','2014-03-30','14:20:00',2.23),('15529','2014-03-30','14:25:00',2.19),('15529','2014-03-30','14:30:00',2.18),('15529','2014-03-30','14:35:00',2.16),('15529','2014-03-30','14:40:00',2.16),('15529','2014-03-30','14:45:00',2.13),('15529','2014-03-30','14:50:00',2.13),('15529','2014-03-30','14:55:00',2.09),('15529','2014-03-30','15:00:00',2.06),('15529','2014-03-30','15:05:00',2.05),('15529','2014-03-30','15:10:00',2.04),('15529','2014-03-30','15:15:00',1.99),('15529','2014-03-30','15:20:00',1.96),('15529','2014-03-30','15:25:00',1.94),('15529','2014-03-30','15:30:00',1.9),('15529','2014-03-30','15:35:00',1.87),('15529','2014-03-30','15:40:00',1.85),('15529','2014-03-30','15:45:00',1.82),('15529','2014-03-30','15:50:00',1.79),('15529','2014-03-30','15:55:00',1.74),('15529','2014-03-30','16:00:00',1.7),('15529','2014-03-30','16:05:00',1.65),('15529','2014-03-30','16:10:00',1.61),('15529','2014-03-30','16:15:00',1.57),('15529','2014-03-30','16:20:00',1.53),('15529','2014-03-30','16:25:00',1.48),('15529','2014-03-30','16:30:00',1.45),('15529','2014-03-30','16:35:00',1.41),('15529','2014-03-30','16:40:00',1.36),('15529','2014-03-30','16:45:00',1.33),('15529','2014-03-30','16:50:00',1.27),('15529','2014-03-30','16:55:00',1.23),('15529','2014-03-30','17:00:00',1.18),('15529','2014-03-30','17:05:00',1.14),('15529','2014-03-30','17:10:00',1.08),('15529','2014-03-30','17:15:00',1.03),('15529','2013-05-10','09:00:00',1.21),('15529','2013-05-10','09:05:00',1.47),('15529','2013-05-10','09:15:00',1.16),('15529','2013-05-10','09:25:00',1.01),('15529','2013-05-10','09:30:00',1.01),('15529','2013-05-10','09:40:00',1.15),('15529','2013-05-10','09:45:00',1.11),('15529','2013-05-10','09:50:00',1.62),('15529','2013-05-10','10:40:00',1.32),('15529','2013-05-10','10:50:00',1.48),('15529','2013-05-10','10:55:00',2.21),('15529','2013-05-10','11:00:00',1.94),('15529','2013-05-10','11:25:00',1.85),('15529','2013-05-10','11:35:00',1.71),('15529','2013-05-10','11:40:00',2.39),('15529','2013-05-10','12:15:00',1.52),('15529','2013-05-10','12:20:00',2.23),('15529','2013-05-10','12:25:00',1.1),('15529','2013-05-10','12:35:00',1.3),('15529','2013-05-10','13:55:00',1.04),('15529','2013-05-10','14:00:00',2.46),('15529','2013-05-10','14:05:00',1.79),('15529','2013-05-10','14:10:00',2.2),('15529','2013-05-10','14:15:00',2.33),('15529','2013-05-10','14:20:00',2.13),('15529','2013-05-10','14:35:00',1.89),('15529','2013-05-10','14:40:00',1.45),('15529','2013-05-10','14:45:00',2),('15529','2013-05-10','14:50:00',1.55),('15529','2013-05-10','14:55:00',1.93),('15529','2013-05-10','15:00:00',1.35),('15529','2013-05-10','15:05:00',1.36),('15529','2013-05-10','15:10:00',1.84),('15529','2013-05-10','15:15:00',1.95),('15529','2013-05-10','15:20:00',1.14),('15529','2013-05-10','15:25:00',1.22),('15529','2013-05-10','15:30:00',1.36),('15529','2013-05-10','15:35:00',1.77),('15529','2013-05-10','15:40:00',1.67),('15529','2013-05-10','15:45:00',1.75),('15529','2013-05-10','15:50:00',1.39),('15529','2013-05-10','15:55:00',1.74),('15529','2013-05-10','16:00:00',1.55),('15529','2013-05-10','16:05:00',1.47),('15529','2013-05-10','16:10:00',1.5),('15529','2013-05-10','16:15:00',1.31),('15529','2013-05-10','16:20:00',1.75),('15529','2013-05-10','16:25:00',1.71),('15529','2013-05-10','16:30:00',1.66),('15529','2013-05-10','16:35:00',1.62),('15529','2013-05-10','16:40:00',1.23),('15529','2013-05-10','16:45:00',1.48),('15529','2013-05-10','16:50:00',1.48),('15529','2013-05-10','16:55:00',1.25),('15529','2013-05-10','17:15:00',1.1),('15529','2013-05-10','17:20:00',1.21),('15529','2013-05-09','09:00:00',1.03),('15529','2013-05-09','09:05:00',1.3),('15529','2013-05-09','09:10:00',1.34),('15529','2013-05-09','09:15:00',1.35),('15529','2013-05-09','09:20:00',1.31),('15529','2013-05-09','09:25:00',1.25),('15529','2013-05-09','09:30:00',1.54),('15529','2013-05-09','09:35:00',1.44),('15529','2013-05-09','09:40:00',1.33),('15529','2013-05-09','09:45:00',1.38),('15529','2013-05-09','09:50:00',1.41),('15529','2013-05-09','09:55:00',1.45),('15529','2013-05-09','10:00:00',1.27),('15529','2013-05-09','10:05:00',1.27),('15529','2013-05-09','10:10:00',1.7),('15529','2013-05-09','10:15:00',1.47),('15529','2013-05-09','10:20:00',1.07),('15529','2013-05-09','10:25:00',1.22),('15529','2013-05-09','10:45:00',1.7),('15529','2013-05-09','10:50:00',2.08),('15529','2013-05-09','10:55:00',2.11),('15529','2013-05-09','11:00:00',2.07),('15529','2013-05-09','11:05:00',2.22),('15529','2013-05-09','11:10:00',2.2),('15529','2013-05-09','11:15:00',2.33),('15529','2013-05-09','11:20:00',2.04),('15529','2013-05-09','11:25:00',1.58),('15529','2013-05-09','11:30:00',2.24),('15529','2013-05-09','11:35:00',1.94),('15529','2013-05-09','11:40:00',2.29),('15529','2013-05-09','11:45:00',1.78),('15529','2013-05-09','11:55:00',1.06),('15529','2013-05-09','12:00:00',1.38),('15529','2013-05-09','12:05:00',1.33),('15529','2013-05-09','12:10:00',1.8),('15529','2013-05-09','12:15:00',1.56),('15529','2013-05-09','12:20:00',1.47),('15529','2013-05-09','12:25:00',1.31),('15529','2013-05-09','12:30:00',1.57),('15529','2013-05-09','12:35:00',2),('15529','2013-05-09','12:40:00',2.13),('15529','2013-05-09','12:45:00',2.13),('15529','2013-05-09','12:50:00',2.2),('15529','2013-05-09','12:55:00',2.26),('15529','2013-05-09','13:00:00',2.51),('15529','2013-05-09','13:05:00',2.34),('15529','2013-05-09','13:10:00',2.47),('15529','2013-05-09','13:15:00',2.36),('15529','2013-05-09','13:20:00',1.55),('15529','2013-05-09','13:25:00',1.58),('15529','2013-05-09','13:30:00',2.13),('15529','2013-05-09','13:35:00',2.05),('15529','2013-05-09','13:40:00',2.07),('15529','2013-05-09','13:45:00',1.15),('15529','2013-05-09','13:50:00',1.04),('15529','2013-05-09','13:55:00',1),('15529','2013-05-09','14:00:00',1.05),('15529','2013-05-09','14:05:00',1.26),('15529','2013-05-09','14:10:00',1.47),('15529','2013-05-09','14:15:00',1.36),('15529','2013-05-09','14:20:00',1.26),('15529','2013-05-09','14:25:00',1.2),('15529','2013-05-09','14:30:00',1.33),('15529','2013-05-09','14:35:00',1.56),('15529','2013-05-09','14:40:00',1.01),('15529','2013-05-09','15:10:00',1.53),('15529','2013-05-09','15:15:00',1.27),('15529','2013-05-09','15:20:00',1.06),('15529','2013-05-09','15:30:00',1.04),('15529','2013-05-09','15:35:00',1.12),('15529','2013-05-09','15:40:00',1.08),('15529','2013-05-09','17:15:00',1.13),('15529','2013-05-09','17:20:00',1.35),('15529','2013-05-09','17:25:00',1.35),('15529','2013-05-09','17:30:00',1.42),('15529','2013-05-08','08:40:00',1.03),('15529','2013-05-08','08:45:00',1.08),('15529','2013-05-08','08:50:00',1.13),('15529','2013-05-08','08:55:00',1.18),('15529','2013-05-08','09:00:00',1.22),('15529','2013-05-08','09:05:00',1.27),('15529','2013-05-08','09:10:00',1.31),('15529','2013-05-08','09:15:00',1.36),('15529','2013-05-08','09:20:00',1.4),('15529','2013-05-08','09:25:00',1.44),('15529','2013-05-08','09:30:00',1.48),('15529','2013-05-08','09:35:00',1.53),('15529','2013-05-08','09:40:00',1.56),('15529','2013-05-08','09:45:00',1.59),('15529','2013-05-08','09:50:00',1.63),('15529','2013-05-08','09:55:00',1.68),('15529','2013-05-08','10:00:00',1.71),('15529','2013-05-08','10:05:00',1.74),('15529','2013-05-08','10:10:00',1.77),('15529','2013-05-08','10:15:00',1.8),('15529','2013-05-08','10:20:00',1.82),('15529','2013-05-08','10:25:00',1.86),('15529','2013-05-08','10:30:00',1.9),('15529','2013-05-08','10:35:00',1.93),('15529','2013-05-08','10:40:00',1.93),('15529','2013-05-08','10:45:00',1.96),('15529','2013-05-08','10:50:00',1.99),('15529','2013-05-08','10:55:00',1.99),('15529','2013-05-08','11:00:00',2.03),('15529','2013-05-08','11:05:00',2.04),('15529','2013-05-08','11:10:00',2.06),('15529','2013-05-08','11:15:00',2.09),('15529','2013-05-08','11:20:00',2.14),('15529','2013-05-08','11:25:00',2.14),('15529','2013-05-08','11:30:00',2.13),('15529','2013-05-08','11:35:00',2.12),('15529','2013-05-08','11:40:00',2.16),('15529','2013-05-08','11:45:00',2.2),('15529','2013-05-08','11:50:00',2.2),('15529','2013-05-08','11:55:00',2.25),('15529','2013-05-08','12:00:00',2.23),('15529','2013-05-08','12:05:00',2.25),('15529','2013-05-08','12:10:00',2.25),('15529','2013-05-08','12:15:00',2.25),('15529','2013-05-08','12:20:00',2.31),('15529','2013-05-08','12:25:00',2.27),('15529','2013-05-08','12:30:00',2.31),('15529','2013-05-08','12:35:00',2.3),('15529','2013-05-08','12:40:00',2.29),('15529','2013-05-08','12:45:00',2.29),('15529','2013-05-08','12:50:00',2.28),('15529','2013-05-08','12:55:00',2.33),('15529','2013-05-08','13:00:00',2.35),('15529','2013-05-08','13:05:00',2.32),('15529','2013-05-08','13:10:00',2.28),('15529','2013-05-08','13:15:00',2.19),('15529','2013-05-08','13:20:00',2.35),('15529','2013-05-08','13:25:00',2.36),('15529','2013-05-08','13:30:00',2.36),('15529','2013-05-08','13:35:00',2.38),('15529','2013-05-08','13:40:00',2.33),('15529','2013-05-08','13:45:00',2.41),('15529','2013-05-08','13:50:00',1.56),('15529','2013-05-08','14:00:00',1.17),('15529','2013-05-08','14:05:00',1.67),('15529','2013-05-08','14:10:00',2.1),('15529','2013-05-08','14:15:00',2.42),('15529','2013-05-08','14:20:00',1.21),('15529','2013-05-08','14:25:00',2.05),('15529','2013-05-08','14:30:00',2.23),('15529','2013-05-08','14:35:00',2.19),('15529','2013-05-08','14:40:00',2.16),('15529','2013-05-08','14:45:00',2.17),('15529','2013-05-08','14:50:00',2.15),('15529','2013-05-08','14:55:00',2.11),('15529','2013-05-08','15:00:00',2.07),('15529','2013-05-08','15:05:00',2.07),('15529','2013-05-08','15:10:00',2.04),('15529','2013-05-08','15:15:00',2.01),('15529','2013-05-08','15:20:00',1.95),('15529','2013-05-08','15:25:00',1.94),('15529','2013-05-08','15:30:00',1.92),('15529','2013-05-08','15:35:00',1.91),('15529','2013-05-08','15:40:00',1.87),('15529','2013-05-08','15:45:00',1.85),('15529','2013-05-08','15:50:00',1.81),('15529','2013-05-08','15:55:00',1.78),('15529','2013-05-08','16:00:00',1.76),('15529','2013-05-08','16:05:00',1.73),('15529','2013-05-08','16:10:00',1.67),('15529','2013-05-08','16:15:00',1.63),('15529','2013-05-08','16:20:00',1.59),('15529','2013-05-08','16:25:00',1.56),('15529','2013-05-08','16:30:00',1.53),('15529','2013-05-08','16:35:00',1.48),('15529','2013-05-08','16:40:00',1.44),('15529','2013-05-08','16:45:00',1.39),('15529','2013-05-08','16:50:00',1.34),('15529','2013-05-08','16:55:00',1.3),('15529','2013-05-08','17:00:00',1.25),('15529','2013-05-08','17:05:00',1.21),('15529','2013-05-08','17:10:00',1.15),('15529','2013-05-08','17:15:00',1.11),('15529','2013-05-08','17:20:00',1.07),('15529','2013-05-08','17:25:00',1.03),('15529','2013-05-07','08:40:00',1.03),('15529','2013-05-07','09:10:00',1.07),('15529','2013-05-07','09:15:00',1.44),('15529','2013-05-07','09:20:00',1.54),('15529','2013-05-07','09:25:00',1.68),('15529','2013-05-07','09:30:00',1.78),('15529','2013-05-07','09:35:00',1.47),('15529','2013-05-07','09:40:00',1.5),('15529','2013-05-07','09:45:00',1.53),('15529','2013-05-07','09:50:00',1.7),('15529','2013-05-07','09:55:00',1.93),('15529','2013-05-07','10:00:00',1.93),('15529','2013-05-07','10:05:00',1.84),('15529','2013-05-07','10:10:00',1.1),('15529','2013-05-07','10:40:00',1.44),('15529','2013-05-07','10:55:00',1.86),('15529','2013-05-07','11:10:00',1.09),('15529','2013-05-07','11:15:00',2.36),('15529','2013-05-07','11:20:00',2.28),('15529','2013-05-07','11:25:00',2.32),('15529','2013-05-07','11:30:00',2.05),('15529','2013-05-07','11:35:00',1.27),('15529','2013-05-07','11:40:00',1.61),('15529','2013-05-07','11:45:00',1.02),('15529','2013-05-07','12:10:00',2.63),('15529','2013-05-07','12:15:00',1.01),('15529','2013-05-07','13:20:00',1.02),('15529','2013-05-07','13:25:00',1.72),('15529','2013-05-07','13:30:00',2.86),('15529','2013-05-07','13:35:00',2.43),('15529','2013-05-07','13:40:00',1.39),('15529','2013-05-07','13:55:00',2.2),('15529','2013-05-07','14:00:00',2.01),('15529','2013-05-07','14:05:00',2.14),('15529','2013-05-07','14:10:00',2.18),('15529','2013-05-07','14:15:00',1.53),('15529','2013-05-07','14:20:00',1.51),('15529','2013-05-07','14:25:00',2.11),('15529','2013-05-07','14:30:00',2.36),('15529','2013-05-07','14:35:00',2.34),('15529','2013-05-07','14:40:00',1.85),('15529','2013-05-07','14:45:00',2.2),('15529','2013-05-07','14:50:00',2.19),('15529','2013-05-07','14:55:00',2.11),('15529','2013-05-07','15:00:00',2.1),('15529','2013-05-07','15:05:00',2.06),('15529','2013-05-07','15:10:00',2.04),('15529','2013-05-07','15:15:00',2.01),('15529','2013-05-07','15:20:00',1.98),('15529','2013-05-07','15:25:00',1.95),('15529','2013-05-07','15:30:00',1.94),('15529','2013-05-07','15:35:00',1.89),('15529','2013-05-07','15:40:00',1.85),('15529','2013-05-07','15:45:00',1.83),('15529','2013-05-07','15:50:00',1.82),('15529','2013-05-07','15:55:00',1.8),('15529','2013-05-07','16:00:00',1.78),('15529','2013-05-07','16:05:00',1.34),('15529','2013-05-07','16:10:00',1.71),('15529','2013-05-07','16:15:00',1.64),('15529','2013-05-07','16:25:00',1.41),('15529','2013-05-07','16:35:00',1.62),('15529','2013-05-07','16:40:00',1.6),('15529','2013-05-07','16:45:00',1.51),('15529','2013-05-07','16:50:00',1.42),('15529','2013-05-07','16:55:00',1.32),('15529','2013-05-07','17:00:00',1.23),('15529','2013-05-07','17:05:00',1.19),('15529','2013-05-07','17:10:00',1.2),('15529','2013-05-07','17:35:00',1.02),('15529','2013-05-06','08:35:00',1.01),('15529','2013-05-06','08:40:00',1.06),('15529','2013-05-06','08:45:00',1.1),('15529','2013-05-06','08:50:00',1.18),('15529','2013-05-06','08:55:00',1.02),('15529','2013-05-06','09:00:00',1.36),('15529','2013-05-06','09:05:00',1.47),('15529','2013-05-06','09:10:00',1.58),('15529','2013-05-06','09:35:00',1.69),('15529','2013-05-06','09:40:00',1.6),('15529','2013-05-06','10:45:00',1.02),('15529','2013-05-06','10:50:00',1.11),('15529','2013-05-06','11:50:00',1.05),('15529','2013-05-06','11:55:00',2.64),('15529','2013-05-06','12:00:00',2.62),('15529','2013-05-06','12:05:00',2.66),('15529','2013-05-06','12:10:00',1.69),('15529','2013-05-06','13:30:00',1.34),('15529','2013-05-06','13:35:00',1.93),('15529','2013-05-06','13:40:00',2.53),('15529','2013-05-06','13:45:00',2.55),('15529','2013-05-06','13:50:00',2.54),('15529','2013-05-06','13:55:00',2.36),('15529','2013-05-06','14:00:00',2.7),('15529','2013-05-06','14:05:00',1.42),('15529','2013-05-06','14:10:00',1.97),('15529','2013-05-06','14:15:00',1.34),('15529','2013-05-06','14:25:00',2.16),('15529','2013-05-06','14:30:00',2.52),('15529','2013-05-06','14:35:00',2.38),('15529','2013-05-06','14:40:00',2.22),('15529','2013-05-06','14:45:00',2.29),('15529','2013-05-06','14:50:00',2.24),('15529','2013-05-06','14:55:00',2.34),('15529','2013-05-06','15:00:00',2.19),('15529','2013-05-06','15:05:00',2.13),('15529','2013-05-06','15:10:00',2.15),('15529','2013-05-06','15:15:00',2.15),('15529','2013-05-06','15:20:00',1.97),('15529','2013-05-06','15:25:00',2.26),('15529','2013-05-06','15:30:00',2.26),('15529','2013-05-06','15:35:00',1.92),('15529','2013-05-06','15:40:00',1.7),('15529','2013-05-06','15:55:00',1.69),('15529','2013-05-06','16:00:00',1.12),('15529','2013-05-06','16:10:00',2.25),('15529','2013-05-06','16:15:00',1.28),('15529','2013-05-06','16:20:00',1.8),('15529','2013-05-06','16:25:00',1.31),('15529','2013-05-06','16:30:00',1.83),('15529','2013-05-06','16:35:00',1.8),('15529','2013-05-06','16:40:00',1.55),('15529','2013-05-06','16:45:00',1.51),('15529','2013-05-06','16:50:00',1.28),('15529','2013-05-06','16:55:00',1.25),('15529','2013-05-06','17:00:00',1.54),('15529','2013-05-05','09:15:00',1.1),('15529','2013-05-05','09:20:00',1.2),('15529','2013-05-05','09:25:00',1.21),('15529','2013-05-05','10:25:00',1.06),('15529','2013-05-05','11:20:00',1.02),('15529','2013-05-05','11:35:00',1.02),('15529','2013-05-05','11:40:00',1.87),('15529','2013-05-05','11:45:00',1.06),('15529','2013-05-05','11:55:00',1.09),('15529','2013-05-05','12:05:00',1.07),('15529','2013-05-05','12:10:00',1.06),('15529','2013-05-05','12:20:00',1.5),('15529','2013-05-05','12:25:00',2.52),('15529','2013-05-05','12:30:00',1.71),('15529','2013-05-05','12:35:00',1.54),('15529','2013-05-05','12:40:00',2.03),('15529','2013-05-05','12:45:00',1.58),('15529','2013-05-05','12:55:00',1.5),('15529','2013-05-05','13:00:00',2.82),('15529','2013-05-05','13:05:00',1.97),('15529','2013-05-05','13:10:00',2.51),('15529','2013-05-05','13:15:00',2.33),('15529','2013-05-05','13:20:00',2.19),('15529','2013-05-05','13:25:00',1.58),('15529','2013-05-05','13:30:00',2.29),('15529','2013-05-05','13:35:00',1.94),('15529','2013-05-05','13:40:00',2.45),('15529','2013-05-05','13:45:00',1.81),('15529','2013-05-05','13:50:00',1.89),('15529','2013-05-05','13:55:00',2.04),('15529','2013-05-05','14:00:00',2.52),('15529','2013-05-05','14:05:00',1.28),('15529','2013-05-05','14:10:00',1.7),('15529','2013-05-05','14:15:00',1.39),('15529','2013-05-05','14:20:00',1.73),('15529','2013-05-05','14:25:00',2.03),('15529','2013-05-05','14:30:00',1.44),('15529','2013-05-05','14:40:00',1.86),('15529','2013-05-05','14:45:00',1.39),('15529','2013-05-05','14:50:00',1.32),('15529','2013-05-05','14:55:00',1.13),('15529','2013-05-05','15:00:00',1.4),('15529','2013-05-05','15:05:00',1.14),('15529','2013-05-05','15:10:00',1.19),('15529','2013-05-05','15:15:00',1.14),('15529','2013-05-05','15:20:00',1.04),('15529','2013-05-05','15:30:00',1.7),('15529','2013-05-05','15:45:00',2.11),('15529','2013-05-05','15:50:00',1.66),('15529','2013-05-05','16:00:00',1.39),('15529','2013-05-05','16:15:00',1.17),('15529','2013-05-05','16:20:00',1.74),('15529','2013-05-05','16:30:00',1.11),('15529','2013-05-05','16:35:00',1.31),('15529','2013-05-05','16:45:00',1.31),('15529','2013-05-05','16:50:00',1.13),('15529','2013-05-05','17:10:00',1.15),('15529','2013-05-05','17:35:00',1.01),('15529','2013-05-05','17:40:00',1.05),('15529','2013-05-04','08:30:00',1.04),('15529','2013-05-04','09:25:00',1.16),('15529','2013-05-04','09:30:00',1.47),('15529','2013-05-04','09:35:00',1.37),('15529','2013-05-04','09:40:00',1.74),('15529','2013-05-04','09:45:00',1.75),('15529','2013-05-04','09:50:00',1.68),('15529','2013-05-04','09:55:00',1.88),('15529','2013-05-04','10:00:00',1.98),('15529','2013-05-04','10:05:00',2.01),('15529','2013-05-04','10:10:00',1.89),('15529','2013-05-04','10:15:00',1.48),('15529','2013-05-04','10:20:00',1.81),('15529','2013-05-04','10:25:00',1.7),('15529','2013-05-04','10:30:00',1.46),('15529','2013-05-04','10:35:00',1.02),('15529','2013-05-04','11:15:00',1),('15529','2013-05-04','11:20:00',1.48),('15529','2013-05-04','11:25:00',1.09),('15529','2013-05-04','11:30:00',1.52),('15529','2013-05-04','11:35:00',1.56),('15529','2013-05-04','11:40:00',1.42),('15529','2013-05-04','11:45:00',1.77),('15529','2013-05-04','11:50:00',2.68),('15529','2013-05-04','11:55:00',2.07),('15529','2013-05-04','12:00:00',1.51),('15529','2013-05-04','12:05:00',1.95),('15529','2013-05-04','12:10:00',2.1),('15529','2013-05-04','12:15:00',1.41),('15529','2013-05-04','12:20:00',1.92),('15529','2013-05-04','12:25:00',2.01),('15529','2013-05-04','12:30:00',1.89),('15529','2013-05-04','12:35:00',2.42),('15529','2013-05-04','12:40:00',2.23),('15529','2013-05-04','12:45:00',2.31),('15529','2013-05-04','12:50:00',2.48),('15529','2013-05-04','12:55:00',2.03),('15529','2013-05-04','13:00:00',2.48),('15529','2013-05-04','13:05:00',1.94),('15529','2013-05-04','13:25:00',2.15),('15529','2013-05-04','13:30:00',2.43),('15529','2013-05-04','13:35:00',2.05),('15529','2013-05-04','13:40:00',1.95),('15529','2013-05-04','13:45:00',2.34),('15529','2013-05-04','13:50:00',1.48),('15529','2013-05-04','13:55:00',1.38),('15529','2013-05-04','14:00:00',1.65),('15529','2013-05-04','14:05:00',2.23),('15529','2013-05-04','14:10:00',2.27),('15529','2013-05-04','14:15:00',2.31),('15529','2013-05-04','14:20:00',2.2),('15529','2013-05-04','14:25:00',2.13),('15529','2013-05-04','14:30:00',2.12),('15529','2013-05-04','14:35:00',2.08),('15529','2013-05-04','14:40:00',2.07),('15529','2013-05-04','14:45:00',2.06),('15529','2013-05-04','14:50:00',2.03),('15529','2013-05-04','14:55:00',2),('15529','2013-05-04','15:00:00',2.01),('15529','2013-05-04','15:05:00',1.97),('15529','2013-05-04','15:10:00',1.93),('15529','2013-05-04','15:15:00',1.93),('15529','2013-05-04','15:20:00',1.9),('15529','2013-05-04','15:25:00',1.88),('15529','2013-05-04','15:30:00',1.83),('15529','2013-05-04','15:35:00',1.82),('15529','2013-05-04','15:40:00',1.8),('15529','2013-05-04','15:45:00',1.77),('15529','2013-05-04','15:50:00',1.76),('15529','2013-05-04','15:55:00',1.72),('15529','2013-05-04','16:00:00',1.67),('15529','2013-05-04','16:05:00',1.64),('15529','2013-05-04','16:10:00',1.6),('15529','2013-05-04','16:15:00',1.58),('15529','2013-05-04','16:20:00',1.54),('15529','2013-05-04','16:25:00',1.49),('15529','2013-05-04','16:30:00',1.46),('15529','2013-05-04','16:35:00',1.42),('15529','2013-05-04','16:40:00',1.38),('15529','2013-05-04','16:45:00',1.33),('15529','2013-05-04','16:50:00',1.29),('15529','2013-05-04','16:55:00',1.25),('15529','2013-05-04','17:00:00',1.2),('15529','2013-05-04','17:05:00',1.15),('15529','2013-05-04','17:10:00',1.11),('15529','2013-05-04','17:15:00',1.06),('15529','2013-05-04','17:20:00',1.01),('15529','2013-05-03','08:50:00',1.03),('15529','2013-05-03','08:55:00',1.08),('15529','2013-05-03','09:00:00',1.12),('15529','2013-05-03','09:05:00',1.17),('15529','2013-05-03','09:10:00',1.2),('15529','2013-05-03','09:15:00',1.24),('15529','2013-05-03','09:20:00',1.28),('15529','2013-05-03','09:25:00',1.32),('15529','2013-05-03','09:30:00',1.36),('15529','2013-05-03','09:35:00',1.4),('15529','2013-05-03','09:40:00',1.46),('15529','2013-05-03','09:45:00',1.5),('15529','2013-05-03','09:50:00',1.55),('15529','2013-05-03','09:55:00',1.59),('15529','2013-05-03','10:00:00',1.63),('15529','2013-05-03','10:05:00',1.64),('15529','2013-05-03','10:10:00',1.7),('15529','2013-05-03','10:15:00',1.71),('15529','2013-05-03','10:20:00',1.76),('15529','2013-05-03','10:25:00',1.78),('15529','2013-05-03','10:30:00',1.82),('15529','2013-05-03','10:35:00',1.82),('15529','2013-05-03','10:40:00',1.8),('15529','2013-05-03','10:45:00',1.8),('15529','2013-05-03','10:50:00',1.81),('15529','2013-05-03','10:55:00',1.86),('15529','2013-05-03','11:00:00',1.85),('15529','2013-05-03','11:05:00',1.84),('15529','2013-05-03','11:10:00',1.74),('15529','2013-05-03','11:15:00',1.7),('15529','2013-05-03','11:20:00',1.85),('15529','2013-05-03','11:25:00',1.87),('15529','2013-05-03','11:30:00',1.81),('15529','2013-05-03','11:35:00',1.81),('15529','2013-05-03','11:40:00',1.8),('15529','2013-05-03','11:45:00',1.84),('15529','2013-05-03','11:50:00',1.85),('15529','2013-05-03','11:55:00',1.91),('15529','2013-05-03','12:00:00',1.88),('15529','2013-05-03','12:05:00',1.91),('15529','2013-05-03','12:10:00',1.98),('15529','2013-05-03','12:15:00',2.03),('15529','2013-05-03','12:20:00',2.06),('15529','2013-05-03','12:25:00',2.05),('15529','2013-05-03','12:30:00',2.09),('15529','2013-05-03','12:35:00',2.12),('15529','2013-05-03','12:40:00',2.12),('15529','2013-05-03','12:45:00',2.12),('15529','2013-05-03','12:50:00',2.09),('15529','2013-05-03','12:55:00',2.07),('15529','2013-05-03','13:00:00',1.99),('15529','2013-05-03','13:05:00',1.85),('15529','2013-05-03','13:10:00',1.99),('15529','2013-05-03','13:15:00',2.21),('15529','2013-05-03','13:20:00',2.19),('15529','2013-05-03','13:25:00',2.08),('15529','2013-05-03','13:30:00',2.07),('15529','2013-05-03','13:35:00',2.05),('15529','2013-05-03','13:40:00',2.06),('15529','2013-05-03','13:45:00',1.98),('15529','2013-05-03','13:50:00',1.88),('15529','2013-05-03','13:55:00',1.98),('15529','2013-05-03','14:00:00',1.81),('15529','2013-05-03','14:05:00',1.06),('15529','2013-05-03','14:10:00',1.91),('15529','2013-05-03','14:15:00',2.05),('15529','2013-05-03','14:20:00',1.91),('15529','2013-05-03','14:25:00',1.82),('15529','2013-05-03','14:30:00',1.84),('15529','2013-05-03','14:35:00',1.74),('15529','2013-05-03','14:40:00',1.85),('15529','2013-05-03','14:45:00',1.78),('15529','2013-05-03','14:50:00',1.75),('15529','2013-05-03','14:55:00',1.81),('15529','2013-05-03','15:00:00',1.8),('15529','2013-05-03','15:05:00',1.81),('15529','2013-05-03','15:10:00',1.73),('15529','2013-05-03','15:15:00',1.79),('15529','2013-05-03','15:20:00',1.78),('15529','2013-05-03','15:25:00',1.79),('15529','2013-05-03','15:30:00',1.8),('15529','2013-05-03','15:35:00',1.67),('15529','2013-05-03','15:40:00',1.77),('15529','2013-05-03','15:45:00',1.71),('15529','2013-05-03','15:50:00',1.68),('15529','2013-05-03','15:55:00',1.64),('15529','2013-05-03','16:00:00',1.61),('15529','2013-05-03','16:05:00',1.57),('15529','2013-05-03','16:10:00',1.52),('15529','2013-05-03','16:15:00',1.5),('15529','2013-05-03','16:20:00',1.45),('15529','2013-05-03','16:25:00',1.43),('15529','2013-05-03','16:30:00',1.39),('15529','2013-05-03','16:35:00',1.36),('15529','2013-05-03','16:40:00',1.31),('15529','2013-05-03','16:45:00',1.27),('15529','2013-05-03','16:50:00',1.23),('15529','2013-05-03','16:55:00',1.18),('15529','2013-05-03','17:00:00',1.14),('15529','2013-05-03','17:05:00',1.1),('15529','2013-05-02','08:50:00',1.04),('15529','2013-05-02','08:55:00',1.1),('15529','2013-05-02','09:00:00',1.17),('15529','2013-05-02','09:05:00',1.19),('15529','2013-05-02','09:10:00',1.24),('15529','2013-05-02','09:15:00',1.29),('15529','2013-05-02','09:20:00',1.34),('15529','2013-05-02','09:25:00',1.39),('15529','2013-05-02','09:30:00',1.42),('15529','2013-05-02','09:35:00',1.47),('15529','2013-05-02','09:40:00',1.51),('15529','2013-05-02','09:45:00',1.54),('15529','2013-05-02','09:50:00',1.58),('15529','2013-05-02','09:55:00',1.61),('15529','2013-05-02','10:00:00',1.65),('15529','2013-05-02','10:05:00',1.69),('15529','2013-05-02','10:10:00',1.71),('15529','2013-05-02','10:15:00',1.76),('15529','2013-05-02','10:20:00',1.79),('15529','2013-05-02','10:25:00',1.79),('15529','2013-05-02','10:30:00',1.84),('15529','2013-05-02','10:35:00',1.87),('15529','2013-05-02','10:40:00',1.89),('15529','2013-05-02','10:45:00',1.93),('15529','2013-05-02','10:50:00',1.97),('15529','2013-05-02','10:55:00',1.97),('15529','2013-05-02','11:00:00',2.02),('15529','2013-05-02','11:05:00',2.04),('15529','2013-05-02','11:10:00',2.04),('15529','2013-05-02','11:15:00',2.06),('15529','2013-05-02','11:20:00',2.09),('15529','2013-05-02','11:25:00',2.09),('15529','2013-05-02','11:30:00',2.13),('15529','2013-05-02','11:35:00',2.15),('15529','2013-05-02','11:40:00',2.11),('15529','2013-05-02','11:45:00',2.13),('15529','2013-05-02','11:50:00',2.19),('15529','2013-05-02','11:55:00',2.18),('15529','2013-05-02','12:00:00',2.18),('15529','2013-05-02','12:05:00',2.22),('15529','2013-05-02','12:10:00',2.2),('15529','2013-05-02','12:15:00',2.22),('15529','2013-05-02','12:20:00',2.2),('15529','2013-05-02','12:25:00',2.22),('15529','2013-05-02','12:30:00',2.2),('15529','2013-05-02','12:35:00',2.21),('15529','2013-05-02','12:40:00',2.24),('15529','2013-05-02','12:45:00',2.17),('15529','2013-05-02','12:50:00',2.24),('15529','2013-05-02','12:55:00',2.28),('15529','2013-05-02','13:00:00',2.29),('15529','2013-05-02','13:05:00',2.32),('15529','2013-05-02','13:10:00',2.3),('15529','2013-05-02','13:15:00',2.33),('15529','2013-05-02','13:20:00',2.29),('15529','2013-05-02','13:25:00',2.29),('15529','2013-05-02','13:30:00',2.27),('15529','2013-05-02','13:35:00',2.17),('15529','2013-05-02','13:40:00',2.13),('15529','2013-05-02','13:45:00',2.19),('15529','2013-05-02','13:50:00',2.19),('15529','2013-05-02','13:55:00',2.18),('15529','2013-05-02','14:00:00',2.09),('15529','2013-05-02','14:05:00',2.07),('15529','2013-05-02','14:10:00',2.05),('15529','2013-05-02','14:15:00',2.13),('15529','2013-05-02','14:20:00',2.1),('15529','2013-05-02','14:25:00',2.05),('15529','2013-05-02','14:30:00',2.04),('15529','2013-05-02','14:35:00',2.03),('15529','2013-05-02','14:40:00',2.02),('15529','2013-05-02','14:45:00',1.99),('15529','2013-05-02','14:50:00',2),('15529','2013-05-02','14:55:00',1.93),('15529','2013-05-02','15:00:00',1.93),('15529','2013-05-02','15:05:00',1.93),('15529','2013-05-02','15:10:00',1.92),('15529','2013-05-02','15:15:00',1.92),('15529','2013-05-02','15:20:00',1.92),('15529','2013-05-02','15:25:00',1.88),('15529','2013-05-02','15:30:00',1.85),('15529','2013-05-02','15:35:00',1.82),('15529','2013-05-02','15:40:00',1.79),('15529','2013-05-02','15:45:00',1.76),('15529','2013-05-02','15:50:00',1.7),('15529','2013-05-02','15:55:00',1.7),('15529','2013-05-02','16:00:00',1.67),('15529','2013-05-02','16:05:00',1.64),('15529','2013-05-02','16:10:00',1.6),('15529','2013-05-02','16:15:00',1.54),('15529','2013-05-02','16:20:00',1.47),('15529','2013-05-02','16:25:00',1.47),('15529','2013-05-02','16:30:00',1.46),('15529','2013-05-02','16:35:00',1.41),('15529','2013-05-02','16:40:00',1.37),('15529','2013-05-02','16:45:00',1.32),('15529','2013-05-02','16:50:00',1.27),('15529','2013-05-02','16:55:00',1.23),('15529','2013-05-02','17:00:00',1.18),('15529','2013-05-02','17:05:00',1.13),('15529','2013-05-02','17:10:00',1.08),('15529','2013-05-02','17:15:00',1.03),('15529','2013-05-01','09:25:00',1.04),('15529','2013-05-01','09:30:00',1.1),('15529','2013-05-01','09:40:00',1.07),('15529','2013-05-01','09:45:00',1.22),('15529','2013-05-01','10:30:00',1.37),('15529','2013-05-01','10:35:00',1.93),('15529','2013-05-01','10:40:00',1.67),('15529','2013-05-01','10:45:00',1.64),('15529','2013-05-01','10:50:00',1.96),('15529','2013-05-01','10:55:00',1.84),('15529','2013-05-01','11:00:00',1.6),('15529','2013-05-01','11:05:00',1.82),('15529','2013-05-01','11:10:00',1.91),('15529','2013-05-01','11:15:00',1.24),('15529','2013-05-01','11:20:00',1.77),('15529','2013-05-01','11:25:00',1.78),('15529','2013-05-01','11:30:00',1.92),('15529','2013-05-01','11:35:00',2.11),('15529','2013-05-01','11:40:00',2.13),('15529','2013-05-01','11:45:00',2.15),('15529','2013-05-01','11:50:00',2.17),('15529','2013-05-01','11:55:00',2.17),('15529','2013-05-01','12:00:00',2.21),('15529','2013-05-01','12:05:00',2.15),('15529','2013-05-01','12:10:00',2.09),('15529','2013-05-01','12:15:00',2.11),('15529','2013-05-01','12:20:00',2.13),('15529','2013-05-01','12:25:00',2.13),('15529','2013-05-01','12:30:00',2.12),('15529','2013-05-01','12:35:00',2.1),('15529','2013-05-01','12:40:00',2.22),('15529','2013-05-01','12:45:00',2.27),('15529','2013-05-01','12:50:00',2.27),('15529','2013-05-01','12:55:00',2.26),('15529','2013-05-01','13:00:00',2.25),('15529','2013-05-01','13:05:00',2.26),('15529','2013-05-01','13:10:00',2.29),('15529','2013-05-01','13:15:00',2.32),('15529','2013-05-01','13:20:00',2.31),('15529','2013-05-01','13:25:00',2.27),('15529','2013-05-01','13:30:00',2.22),('15529','2013-05-01','13:35:00',2.26),('15529','2013-05-01','13:40:00',2.29),('15529','2013-05-01','13:45:00',2.3),('15529','2013-05-01','13:50:00',2.26),('15529','2013-05-01','13:55:00',2.23),('15529','2013-05-01','14:00:00',2.23),('15529','2013-05-01','14:05:00',2.22),('15529','2013-05-01','14:10:00',2.08),('15529','2013-05-01','14:15:00',2.12),('15529','2013-05-01','14:20:00',2.13),('15529','2013-05-01','14:25:00',2.08),('15529','2013-05-01','14:30:00',2.09),('15529','2013-05-01','14:35:00',2.11),('15529','2013-05-01','14:40:00',2.04),('15529','2013-05-01','14:45:00',2.06),('15529','2013-05-01','14:50:00',2.01),('15529','2013-05-01','14:55:00',1.99),('15529','2013-05-01','15:00:00',2.02),('15529','2013-05-01','15:05:00',1.97),('15529','2013-05-01','15:10:00',1.94),('15529','2013-05-01','15:15:00',1.91),('15529','2013-05-01','15:20:00',1.89),('15529','2013-05-01','15:25:00',1.89),('15529','2013-05-01','15:30:00',1.86),('15529','2013-05-01','15:35:00',1.83),('15529','2013-05-01','15:40:00',1.8),('15529','2013-05-01','15:45:00',1.76),('15529','2013-05-01','15:50:00',1.75),('15529','2013-05-01','15:55:00',1.7),('15529','2013-05-01','16:00:00',1.66),('15529','2013-05-01','16:05:00',1.63),('15529','2013-05-01','16:10:00',1.59),('15529','2013-05-01','16:15:00',1.55),('15529','2013-05-01','16:20:00',1.52),('15529','2013-05-01','16:25:00',1.48),('15529','2013-05-01','16:30:00',1.43),('15529','2013-05-01','16:35:00',1.4),('15529','2013-05-01','16:40:00',1.36),('15529','2013-05-01','16:45:00',1.32),('15529','2013-05-01','16:50:00',1.28),('15529','2013-05-01','16:55:00',1.23),('15529','2013-05-01','17:00:00',1.2),('15529','2013-05-01','17:05:00',1.15),('15529','2013-05-01','17:10:00',1.11),('15529','2013-05-01','17:15:00',1.06),('15529','2013-05-01','17:20:00',1.01),('15529','2014-03-29','09:25:00',1.09),('15529','2014-03-29','09:30:00',1.12),('15529','2014-03-29','09:35:00',1.2),('15529','2014-03-29','09:40:00',1.28),('15529','2014-03-29','09:45:00',1.3),('15529','2014-03-29','09:50:00',1.27),('15529','2014-03-29','09:55:00',1.32),('15529','2014-03-29','10:00:00',1.46),('15529','2014-03-29','10:05:00',1.45),('15529','2014-03-29','10:10:00',1.4),('15529','2014-03-29','10:15:00',1.58),('15529','2014-03-29','10:20:00',1.64),('15529','2014-03-29','10:25:00',1.65),('15529','2014-03-29','10:30:00',1.67),('15529','2014-03-29','10:35:00',1.72),('15529','2014-03-29','10:40:00',1.72),('15529','2014-03-29','10:45:00',1.71),('15529','2014-03-29','10:50:00',1.73),('15529','2014-03-29','10:55:00',1.72),('15529','2014-03-29','11:00:00',1.75),('15529','2014-03-29','11:05:00',1.72),('15529','2014-03-29','11:10:00',1.71),('15529','2014-03-29','11:15:00',1.69),('15529','2014-03-29','11:20:00',1.77),('15529','2014-03-29','11:25:00',1.88),('15529','2014-03-29','11:30:00',1.91),('15529','2014-03-29','11:35:00',1.99),('15529','2014-03-29','11:40:00',2.05),('15529','2014-03-29','11:45:00',2.08),('15529','2014-03-29','11:50:00',2.08),('15529','2014-03-29','11:55:00',2.16),('15529','2014-03-29','12:00:00',2.19),('15529','2014-03-29','12:05:00',2.21),('15529','2014-03-29','12:10:00',2.31),('15529','2014-03-29','12:15:00',2.17),('15529','2014-03-29','12:20:00',2.15),('15529','2014-03-29','12:25:00',2.28),('15529','2014-03-29','12:30:00',2.14),('15529','2014-03-29','12:35:00',2.15),('15529','2014-03-29','12:40:00',2.19),('15529','2014-03-29','12:45:00',2.14),('15529','2014-03-29','12:50:00',2.24),('15529','2014-03-29','12:55:00',2.25),('15529','2014-03-29','13:00:00',2.33),('15529','2014-03-29','13:05:00',2.32),('15529','2014-03-29','13:10:00',2.32),('15529','2014-03-29','13:15:00',2.33),('15529','2014-03-29','13:20:00',2.32),('15529','2014-03-29','13:25:00',2.35),('15529','2014-03-29','13:30:00',2.36),('15529','2014-03-29','13:35:00',2.35),('15529','2014-03-29','13:40:00',2.39),('15529','2014-03-29','13:45:00',2.3),('15529','2014-03-29','13:50:00',2.27),('15529','2014-03-29','13:55:00',2.27),('15529','2014-03-29','14:00:00',2.19),('15529','2014-03-29','14:05:00',2.09),('15529','2014-03-29','14:10:00',1.94),('15529','2014-03-29','14:15:00',1.86),('15529','2014-03-29','14:20:00',1.67),('15529','2014-03-29','14:25:00',1.53),('15529','2014-03-29','14:30:00',1.42),('15529','2014-03-29','14:35:00',1.42),('15529','2014-03-29','14:40:00',1.27),('15529','2014-03-29','14:50:00',1.35),('15529','2014-03-29','14:55:00',1.75),('15529','2014-03-29','15:00:00',1.87),('15529','2014-03-29','15:05:00',1.95),('15529','2014-03-29','15:10:00',1.9),('15529','2014-03-29','15:15:00',1.85),('15529','2014-03-29','15:20:00',1.83),('15529','2014-03-29','15:25:00',1.74),('15529','2014-03-29','15:30:00',1.79),('15529','2014-03-29','15:35:00',1.82),('15529','2014-03-29','15:40:00',1.82),('15529','2014-03-29','15:45:00',1.81),('15529','2014-03-29','15:50:00',1.59),('15529','2014-03-29','15:55:00',1.32),('15529','2014-03-29','16:00:00',1.36),('15529','2014-03-29','16:05:00',1.28),('15529','2014-03-29','16:10:00',1.28),('15529','2014-03-29','16:15:00',1.28),('15529','2014-03-29','16:20:00',1.42),('15529','2014-03-29','16:25:00',1.41),('15529','2014-03-29','16:30:00',1.35),('15529','2014-03-29','16:35:00',1.42),('15529','2014-03-29','16:40:00',1.25),('15529','2014-03-29','16:45:00',1.19),('15529','2014-03-29','16:50:00',1.16),('15529','2014-03-29','16:55:00',1.18),('15529','2014-03-29','17:00:00',1.17),('15529','2014-03-29','17:05:00',1.2),('15529','2014-03-29','17:10:00',1.19),('15529','2014-03-29','17:15:00',1.14),('15529','2014-03-29','17:20:00',1.07),('15529','2013-04-30','08:55:00',1.04),('15529','2013-04-30','09:00:00',1.08),('15529','2013-04-30','09:05:00',1.12),('15529','2013-04-30','09:10:00',1.15),('15529','2013-04-30','09:15:00',1.18),('15529','2013-04-30','09:20:00',1.22),('15529','2013-04-30','09:25:00',1.24),('15529','2013-04-30','09:30:00',1.26),('15529','2013-04-30','09:35:00',1.32),('15529','2013-04-30','09:40:00',1.35),('15529','2013-04-30','09:45:00',1.4),('15529','2013-04-30','09:50:00',1.42),('15529','2013-04-30','09:55:00',1.46),('15529','2013-04-30','10:00:00',1.47),('15529','2013-04-30','10:05:00',1.52),('15529','2013-04-30','10:10:00',1.6),('15529','2013-04-30','10:15:00',1.61),('15529','2013-04-30','10:20:00',1.64),('15529','2013-04-30','10:25:00',1.68),('15529','2013-04-30','10:30:00',1.72),('15529','2013-04-30','10:35:00',1.78),('15529','2013-04-30','10:40:00',1.81),('15529','2013-04-30','10:45:00',1.85),('15529','2013-04-30','10:50:00',1.86),('15529','2013-04-30','10:55:00',1.89),('15529','2013-04-30','11:00:00',1.89),('15529','2013-04-30','11:05:00',1.92),('15529','2013-04-30','11:10:00',1.94),('15529','2013-04-30','11:15:00',1.83),('15529','2013-04-30','11:20:00',2),('15529','2013-04-30','11:25:00',1.82),('15529','2013-04-30','11:30:00',1.89),('15529','2013-04-30','11:35:00',1.63),('15529','2013-04-30','11:40:00',1.16),('15529','2013-04-30','11:45:00',1.27),('15529','2013-04-30','11:50:00',2.09),('15529','2013-04-30','11:55:00',2.11),('15529','2013-04-30','12:00:00',2.07),('15529','2013-04-30','12:05:00',2.07),('15529','2013-04-30','12:10:00',2.07),('15529','2013-04-30','12:15:00',2.06),('15529','2013-04-30','12:20:00',2.09),('15529','2013-04-30','12:25:00',2.11),('15529','2013-04-30','12:30:00',2.1),('15529','2013-04-30','12:35:00',2.16),('15529','2013-04-30','12:40:00',2.15),('15529','2013-04-30','12:45:00',1.82),('15529','2013-04-30','13:05:00',1.44),('15529','2013-04-30','13:10:00',1.84),('15529','2013-04-30','13:15:00',2.22),('15529','2013-04-30','13:20:00',2.39),('15529','2013-04-30','13:25:00',2.18),('15529','2013-04-30','13:30:00',1.97),('15529','2013-04-30','13:35:00',2.08),('15529','2013-04-30','13:40:00',2.31),('15529','2013-04-30','13:45:00',2.2),('15529','2013-04-30','13:50:00',2.12),('15529','2013-04-30','13:55:00',2.1),('15529','2013-04-30','14:00:00',2.13),('15529','2013-04-30','14:05:00',2.07),('15529','2013-04-30','14:10:00',2.07),('15529','2013-04-30','14:15:00',1.81),('15529','2013-04-30','14:20:00',2.18),('15529','2013-04-30','14:25:00',2.13),('15529','2013-04-30','14:30:00',2.14),('15529','2013-04-30','14:35:00',1.98),('15529','2013-04-30','14:40:00',2.02),('15529','2013-04-30','14:45:00',1.79),('15529','2013-04-30','14:50:00',1.8),('15529','2013-04-30','14:55:00',1.44),('15529','2013-04-30','15:00:00',1.61),('15529','2013-04-30','15:05:00',1.9),('15529','2013-04-30','15:10:00',1.85),('15529','2013-04-30','15:15:00',1.78),('15529','2013-04-30','15:20:00',1.84),('15529','2013-04-30','15:25:00',1.6),('15529','2013-04-30','15:30:00',1.25),('15529','2013-04-30','15:35:00',1.19),('15529','2013-04-30','15:40:00',1.19),('15529','2013-04-30','15:45:00',1.12),('15529','2013-04-29','08:55:00',1.14),('15529','2013-04-29','09:10:00',1.06),('15529','2013-04-29','09:15:00',1.29),('15529','2013-04-29','09:20:00',1.3),('15529','2013-04-29','09:25:00',1.29),('15529','2013-04-29','09:30:00',1.4),('15529','2013-04-29','09:35:00',1.14),('15529','2013-04-29','09:45:00',1.09),('15529','2013-04-29','09:50:00',1.43),('15529','2013-04-29','09:55:00',1.63),('15529','2013-04-29','10:00:00',1.74),('15529','2013-04-29','10:05:00',1.35),('15529','2013-04-29','10:10:00',1.27),('15529','2013-04-29','10:15:00',1.02),('15529','2013-04-29','10:20:00',1.02),('15529','2013-04-29','10:25:00',1.46),('15529','2013-04-29','10:30:00',1.05),('15529','2013-04-29','11:05:00',1.02),('15529','2013-04-29','11:15:00',1.14),('15529','2013-04-29','11:20:00',1.16),('15529','2013-04-29','11:25:00',1.1),('15529','2013-04-29','11:30:00',1.13),('15529','2013-04-29','11:35:00',1.2),('15529','2013-04-29','12:35:00',1.84),('15529','2013-04-29','12:40:00',2.39),('15529','2013-04-29','12:45:00',2.28),('15529','2013-04-29','12:50:00',2.25),('15529','2013-04-29','13:10:00',1.23),('15529','2013-04-29','13:15:00',2.04),('15529','2013-04-29','13:20:00',2.03),('15529','2013-04-29','13:25:00',2.02),('15529','2013-04-29','13:30:00',2.04),('15529','2013-04-29','13:35:00',2.03),('15529','2013-04-29','13:40:00',2.03),('15529','2013-04-29','13:45:00',2.01),('15529','2013-04-29','13:50:00',2),('15529','2013-04-29','13:55:00',1.98),('15529','2013-04-29','14:00:00',1.95),('15529','2013-04-29','14:05:00',1.94),('15529','2013-04-29','14:10:00',1.93),('15529','2013-04-29','14:15:00',1.92),('15529','2013-04-29','14:20:00',1.89),('15529','2013-04-29','14:25:00',1.87),('15529','2013-04-29','14:30:00',1.79),('15529','2013-04-29','14:35:00',1.65),('15529','2013-04-29','14:40:00',1.09),('15529','2013-04-29','15:05:00',1.15),('15529','2013-04-29','15:10:00',1.78),('15529','2013-04-29','15:15:00',1.76),('15529','2013-04-29','15:20:00',1.75),('15529','2013-04-29','15:25:00',1.69),('15529','2013-04-29','15:30:00',1.66),('15529','2013-04-29','15:35:00',1.65),('15529','2013-04-29','15:40:00',1.63),('15529','2013-04-29','15:45:00',1.59),('15529','2013-04-29','15:50:00',1.56),('15529','2013-04-29','15:55:00',1.54),('15529','2013-04-29','16:00:00',1.49),('15529','2013-04-29','16:05:00',1.46),('15529','2013-04-29','16:10:00',1.42),('15529','2013-04-29','16:15:00',1.38),('15529','2013-04-29','16:20:00',1.34),('15529','2013-04-29','16:25:00',1.32),('15529','2013-04-29','16:30:00',1.27),('15529','2013-04-29','16:35:00',1.15),('15529','2013-04-29','16:40:00',1.07),('15529','2013-04-29','16:55:00',1.03),('15529','2013-04-29','17:00:00',1.02),('15529','2013-04-28','08:35:00',1.02),('15529','2013-04-28','08:45:00',1.02),('15529','2013-04-28','08:55:00',1.02),('15529','2013-04-28','09:05:00',1.21),('15529','2013-04-28','09:10:00',1.29),('15529','2013-04-28','09:15:00',1.32),('15529','2013-04-28','09:20:00',1.23),('15529','2013-04-28','09:25:00',1.27),('15529','2013-04-28','09:30:00',1.29),('15529','2013-04-28','09:35:00',1.33),('15529','2013-04-28','09:40:00',1.37),('15529','2013-04-28','09:45:00',1.39),('15529','2013-04-28','09:50:00',1.42),('15529','2013-04-28','09:55:00',1.37),('15529','2013-04-28','10:00:00',1.48),('15529','2013-04-28','10:05:00',1.44),('15529','2013-04-28','10:10:00',1.34),('15529','2013-04-28','10:15:00',1.13),('15529','2013-04-28','10:20:00',1.49),('15529','2013-04-28','10:25:00',1.54),('15529','2013-04-28','10:30:00',1.71),('15529','2013-04-28','10:35:00',1.73),('15529','2013-04-28','10:40:00',1.74),('15529','2013-04-28','10:45:00',1.67),('15529','2013-04-28','10:50:00',1.66),('15529','2013-04-28','10:55:00',1.64),('15529','2013-04-28','11:00:00',1.75),('15529','2013-04-28','11:05:00',1.62),('15529','2013-04-28','11:10:00',1.5),('15529','2013-04-28','11:15:00',1.74),('15529','2013-04-28','11:20:00',1.98),('15529','2013-04-28','11:25:00',1.85),('15529','2013-04-28','11:30:00',1.91),('15529','2013-04-28','11:35:00',2),('15529','2013-04-28','11:40:00',2.07),('15529','2013-04-28','11:45:00',2),('15529','2013-04-28','11:50:00',2.11),('15529','2013-04-28','11:55:00',2.12),('15529','2013-04-28','12:00:00',2.16),('15529','2013-04-28','12:05:00',2.05),('15529','2013-04-28','12:10:00',2.09),('15529','2013-04-28','12:15:00',2.15),('15529','2013-04-28','12:20:00',2.15),('15529','2013-04-28','12:25:00',2.19),('15529','2013-04-28','12:30:00',2.18),('15529','2013-04-28','12:35:00',2.17),('15529','2013-04-28','12:40:00',2.14),('15529','2013-04-28','12:45:00',2.14),('15529','2013-04-28','12:50:00',2.14),('15529','2013-04-28','12:55:00',2.14),('15529','2013-04-28','13:00:00',2.15),('15529','2013-04-28','13:05:00',2.18),('15529','2013-04-28','13:10:00',2.06),('15529','2013-04-28','13:15:00',2),('15529','2013-04-28','13:20:00',2.17),('15529','2013-04-28','13:25:00',2.27),('15529','2013-04-28','13:30:00',2.15),('15529','2013-04-28','13:35:00',2.15),('15529','2013-04-28','13:40:00',2.07),('15529','2013-04-28','13:45:00',2.12),('15529','2013-04-28','13:50:00',1.99),('15529','2013-04-28','13:55:00',2.16),('15529','2013-04-28','14:00:00',2.04),('15529','2013-04-28','14:05:00',2.01),('15529','2013-04-28','14:10:00',2.11),('15529','2013-04-28','14:15:00',2.18),('15529','2013-04-28','14:20:00',2.12),('15529','2013-04-28','14:25:00',1.95),('15529','2013-04-28','14:30:00',1.94),('15529','2013-04-28','14:35:00',1.95),('15529','2013-04-28','14:40:00',1.84),('15529','2013-04-28','14:45:00',1.94),('15529','2013-04-28','14:50:00',2.01),('15529','2013-04-28','14:55:00',1.9),('15529','2013-04-28','15:00:00',1.81),('15529','2013-04-28','15:05:00',1.7),('15529','2013-04-28','15:10:00',1.64),('15529','2013-04-28','15:15:00',1.76),('15529','2013-04-28','15:20:00',1.82),('15529','2013-04-28','15:25:00',1.81),('15529','2013-04-28','15:30:00',1.67),('15529','2013-04-28','15:35:00',1.51),('15529','2013-04-28','15:40:00',1.44),('15529','2013-04-28','15:45:00',1.4),('15529','2013-04-28','15:50:00',1.46),('15529','2013-04-28','16:45:00',1.12),('15529','2013-04-28','16:50:00',1.44),('15529','2013-04-28','16:55:00',1.42),('15529','2013-04-28','17:00:00',1.32),('15529','2013-04-28','17:05:00',1.19),('15529','2013-04-28','17:10:00',1.15),('15529','2013-04-27','08:45:00',1.02),('15529','2013-04-27','08:50:00',1.07),('15529','2013-04-27','08:55:00',1.12),('15529','2013-04-27','09:00:00',1.16),('15529','2013-04-27','09:05:00',1.2),('15529','2013-04-27','09:10:00',1.25),('15529','2013-04-27','09:15:00',1.3),('15529','2013-04-27','09:20:00',1.34),('15529','2013-04-27','09:25:00',1.39),('15529','2013-04-27','09:30:00',1.43),('15529','2013-04-27','09:35:00',1.47),('15529','2013-04-27','09:40:00',1.51),('15529','2013-04-27','09:45:00',1.55),('15529','2013-04-27','09:50:00',1.59),('15529','2013-04-27','09:55:00',1.62),('15529','2013-04-27','10:00:00',1.65),('15529','2013-04-27','10:05:00',1.67),('15529','2013-04-27','10:10:00',1.68),('15529','2013-04-27','10:15:00',1.76),('15529','2013-04-27','10:20:00',1.77),('15529','2013-04-27','10:25:00',1.8),('15529','2013-04-27','10:30:00',1.71),('15529','2013-04-27','10:35:00',1.84),('15529','2013-04-27','10:40:00',1.7),('15529','2013-04-27','10:45:00',1.9),('15529','2013-04-27','10:50:00',1.91),('15529','2013-04-27','10:55:00',1.96),('15529','2013-04-27','11:00:00',1.98),('15529','2013-04-27','11:05:00',2),('15529','2013-04-27','11:10:00',1.97),('15529','2013-04-27','11:15:00',2.05),('15529','2013-04-27','11:20:00',2.04),('15529','2013-04-27','11:25:00',2.1),('15529','2013-04-27','11:30:00',2.12),('15529','2013-04-27','11:35:00',2.06),('15529','2013-04-27','11:40:00',2.09),('15529','2013-04-27','11:45:00',2.01),('15529','2013-04-27','11:50:00',2.07),('15529','2013-04-27','11:55:00',2.08),('15529','2013-04-27','12:00:00',1.78),('15529','2013-04-27','12:05:00',1.83),('15529','2013-04-27','12:10:00',2.02),('15529','2013-04-27','12:15:00',1.94),('15529','2013-04-27','12:20:00',2.04),('15529','2013-04-27','12:25:00',1.83),('15529','2013-04-27','12:30:00',1.87),('15529','2013-04-27','12:35:00',1.81),('15529','2013-04-27','12:40:00',1.65),('15529','2013-04-27','12:45:00',2.14),('15529','2013-04-27','12:50:00',2.14),('15529','2013-04-27','12:55:00',2.1),('15529','2013-04-27','13:00:00',2.04),('15529','2013-04-27','13:05:00',1.45),('15529','2013-04-27','13:10:00',2.16),('15529','2013-04-27','13:15:00',1.24),('15529','2013-04-27','13:20:00',2.21),('15529','2013-04-27','13:25:00',2.03),('15529','2013-04-27','13:30:00',2.21),('15529','2013-04-27','13:35:00',2.35),('15529','2013-04-27','13:40:00',2.34),('15529','2013-04-27','13:45:00',2.36),('15529','2013-04-27','13:50:00',2),('15529','2013-04-27','13:55:00',2.11),('15529','2013-04-27','14:00:00',1.93),('15529','2013-04-27','14:05:00',2.22),('15529','2013-04-27','14:10:00',2.16),('15529','2013-04-27','14:15:00',2.19),('15529','2013-04-27','14:20:00',2.15),('15529','2013-04-27','14:25:00',2.13),('15529','2013-04-27','14:30:00',2.09),('15529','2013-04-27','14:35:00',2.09),('15529','2013-04-27','14:40:00',2.08),('15529','2013-04-27','14:45:00',2.06),('15529','2013-04-27','14:50:00',2.01),('15529','2013-04-27','14:55:00',2.05),('15529','2013-04-27','15:00:00',2),('15529','2013-04-27','15:05:00',1.97),('15529','2013-04-27','15:10:00',1.94),('15529','2013-04-27','15:15:00',1.87),('15529','2013-04-27','15:20:00',1.88),('15529','2013-04-27','15:25:00',1.84),('15529','2013-04-27','15:30:00',1.81),('15529','2013-04-27','15:35:00',1.81),('15529','2013-04-27','15:40:00',1.78),('15529','2013-04-27','15:45:00',1.74),('15529','2013-04-27','15:50:00',1.72),('15529','2013-04-27','15:55:00',1.7),('15529','2013-04-27','16:00:00',1.65),('15529','2013-04-27','16:05:00',1.61),('15529','2013-04-27','16:10:00',1.59),('15529','2013-04-27','16:15:00',1.55),('15529','2013-04-27','16:20:00',1.51),('15529','2013-04-27','16:25:00',1.46),('15529','2013-04-27','16:30:00',1.42),('15529','2013-04-27','16:35:00',1.39),('15529','2013-04-27','16:40:00',1.34),('15529','2013-04-27','16:45:00',1.31),('15529','2013-04-27','16:50:00',1.27),('15529','2013-04-27','16:55:00',1.22),('15529','2013-04-27','17:00:00',1.17),('15529','2013-04-27','17:05:00',1.05),('15529','2013-04-27','17:10:00',1.05),('15529','2013-04-27','17:15:00',1.06),('15529','2013-04-26','14:30:00',1.14),('15529','2013-04-26','16:50:00',1.11),('15529','2013-04-25','09:25:00',1.1),('15529','2013-04-25','09:35:00',1.08),('15529','2013-04-25','09:40:00',1.18),('15529','2013-04-25','09:45:00',1.22),('15529','2013-04-25','09:50:00',1.36),('15529','2013-04-25','10:00:00',1.23),('15529','2013-04-25','10:05:00',1.51),('15529','2013-04-25','10:10:00',1.65),('15529','2013-04-25','10:15:00',1.63),('15529','2013-04-25','10:20:00',1.68),('15529','2013-04-25','10:25:00',1.62),('15529','2013-04-25','10:30:00',1.63),('15529','2013-04-25','10:35:00',1.88),('15529','2013-04-25','10:40:00',1.51),('15529','2013-04-25','10:50:00',1.37),('15529','2013-04-25','10:55:00',1.93),('15529','2013-04-25','11:00:00',1.93),('15529','2013-04-25','11:05:00',1.9),('15529','2013-04-25','11:10:00',1.91),('15529','2013-04-25','11:15:00',1.65),('15529','2013-04-25','11:20:00',1.55),('15529','2013-04-25','11:25:00',1.74),('15529','2013-04-25','11:30:00',1.96),('15529','2013-04-25','11:35:00',2.28),('15529','2013-04-25','11:40:00',1.91),('15529','2013-04-25','11:45:00',1.77),('15529','2013-04-25','11:50:00',1.64),('15529','2013-04-25','11:55:00',1.49),('15529','2013-04-25','12:00:00',1.39),('15529','2013-04-25','12:05:00',1.3),('15529','2013-04-25','12:10:00',1.35),('15529','2013-04-25','12:15:00',1.43),('15529','2013-04-25','12:20:00',1.01),('15529','2013-04-25','12:35:00',1.04),('15529','2013-04-25','12:40:00',1.19),('15529','2013-04-25','12:45:00',1.12),('15529','2013-04-25','13:10:00',1.05),('15529','2013-04-25','13:15:00',1.08),('15529','2013-04-25','13:20:00',1.4),('15529','2013-04-25','13:25:00',1.51),('15529','2013-04-25','13:30:00',1.36),('15529','2013-04-25','13:35:00',2),('15529','2013-04-25','13:40:00',1.08),('15529','2013-04-25','13:45:00',1.81),('15529','2013-04-25','13:50:00',1.58),('15529','2013-04-25','13:55:00',1.22),('15529','2013-04-25','14:00:00',1.29),('15529','2013-04-25','14:05:00',1.61),('15529','2013-04-25','14:10:00',1.42),('15529','2013-04-25','14:15:00',1.59),('15529','2013-04-25','14:20:00',2.3),('15529','2013-04-25','14:25:00',2.04),('15529','2013-04-25','14:30:00',1.59),('15529','2013-04-25','14:35:00',1.08),('15529','2013-04-25','14:50:00',1.49),('15529','2013-04-25','14:55:00',2.19),('15529','2013-04-25','15:00:00',1.87),('15529','2013-04-25','15:05:00',1),('15529','2013-04-25','15:10:00',1.48),('15529','2013-04-25','15:15:00',1.17),('15529','2013-04-25','15:25:00',1.12),('15529','2013-04-25','15:30:00',1.17),('15529','2013-04-25','15:40:00',1.22),('15529','2013-04-25','15:45:00',1.08),('15529','2013-04-24','08:50:00',1.14),('15529','2013-04-24','08:55:00',1.04),('15529','2013-04-24','09:40:00',1.18),('15529','2013-04-24','09:45:00',1.55),('15529','2013-04-24','09:50:00',1.62),('15529','2013-04-24','09:55:00',1.62),('15529','2013-04-24','10:00:00',1.57),('15529','2013-04-24','10:05:00',1.5),('15529','2013-04-24','10:10:00',1.5),('15529','2013-04-24','10:15:00',1.62),('15529','2013-04-24','10:20:00',1.71),('15529','2013-04-24','10:25:00',1.78),('15529','2013-04-24','10:30:00',1.79),('15529','2013-04-24','10:35:00',1.81),('15529','2013-04-24','10:40:00',1.83),('15529','2013-04-24','10:45:00',1.84),('15529','2013-04-24','10:50:00',1.87),('15529','2013-04-24','10:55:00',1.94),('15529','2013-04-24','11:00:00',1.96),('15529','2013-04-24','11:05:00',1.98),('15529','2013-04-24','11:10:00',1.98),('15529','2013-04-24','11:15:00',2),('15529','2013-04-24','11:20:00',2.04),('15529','2013-04-24','11:25:00',2.08),('15529','2013-04-24','11:30:00',2.08),('15529','2013-04-24','11:35:00',2.11),('15529','2013-04-24','11:40:00',2.11),('15529','2013-04-24','11:45:00',2.16),('15529','2013-04-24','11:50:00',2.16),('15529','2013-04-24','11:55:00',2.16),('15529','2013-04-24','12:00:00',2.11),('15529','2013-04-24','12:05:00',2.14),('15529','2013-04-24','12:10:00',2.18),('15529','2013-04-24','12:15:00',2.2),('15529','2013-04-24','12:20:00',2.18),('15529','2013-04-24','12:25:00',2.17),('15529','2013-04-24','12:30:00',2.15),('15529','2013-04-24','12:35:00',2.19),('15529','2013-04-24','12:40:00',2.21),('15529','2013-04-24','12:45:00',2.22),('15529','2013-04-24','12:50:00',2.19),('15529','2013-04-24','12:55:00',2.19),('15529','2013-04-24','13:00:00',2.21),('15529','2013-04-24','13:05:00',2.24),('15529','2013-04-24','13:10:00',2.27),('15529','2013-04-24','13:15:00',2.02),('15529','2013-04-24','13:20:00',1.99),('15529','2013-04-24','13:25:00',1.55),('15529','2013-04-24','13:30:00',1.37),('15529','2013-04-24','13:35:00',1.29),('15529','2013-04-24','13:40:00',1.18),('15529','2013-04-24','13:45:00',1.1),('15529','2013-04-24','13:50:00',1.12),('15529','2013-04-24','13:55:00',1.25),('15529','2013-04-24','14:00:00',1.22),('15529','2013-04-24','14:05:00',1.13),('15529','2013-04-24','14:10:00',1.16),('15529','2013-04-24','14:15:00',1.21),('15529','2013-04-24','14:20:00',1.43),('15529','2013-04-24','14:25:00',1.5),('15529','2013-04-24','14:30:00',1.85),('15529','2013-04-24','14:35:00',1.88),('15529','2013-04-24','14:40:00',1.82),('15529','2013-04-24','14:45:00',1.81),('15529','2013-04-24','14:50:00',1.77),('15529','2013-04-24','14:55:00',1.73),('15529','2013-04-24','15:00:00',1.63),('15529','2013-04-24','15:05:00',1.44),('15529','2013-04-24','15:10:00',1.6),('15529','2013-04-24','15:15:00',1.79),('15529','2013-04-24','15:20:00',1.81),('15529','2013-04-24','15:25:00',1.79),('15529','2013-04-24','15:30:00',1.74),('15529','2013-04-24','15:35:00',1.67),('15529','2013-04-24','15:40:00',1.52),('15529','2013-04-24','15:45:00',1.61),('15529','2013-04-24','15:50:00',1.33),('15529','2013-04-24','15:55:00',1.5),('15529','2013-04-24','16:00:00',1.31),('15529','2013-04-24','16:05:00',1.3),('15529','2013-04-24','16:10:00',1.14),('15529','2013-04-24','16:15:00',1.1),('15529','2013-04-24','16:20:00',1.35),('15529','2013-04-24','16:25:00',1.06),('15529','2013-04-24','16:30:00',1.25),('15529','2013-04-24','16:35:00',1.23),('15529','2013-04-24','16:40:00',1.22),('15529','2013-04-24','16:45:00',1.07),('15529','2013-04-24','17:00:00',1.08),('15529','2013-04-24','17:05:00',1.09),('15529','2013-04-24','17:15:00',1.07),('15529','2013-04-24','17:20:00',1.02),('15529','2013-04-23','08:55:00',1.02),('15529','2013-04-23','09:00:00',1.16),('15529','2013-04-23','09:05:00',1.29),('15529','2013-04-23','09:10:00',1.37),('15529','2013-04-23','09:25:00',1.25),('15529','2013-04-23','09:30:00',1.12),('15529','2013-04-23','09:35:00',1.35),('15529','2013-04-23','09:40:00',1.37),('15529','2013-04-23','09:45:00',1.31),('15529','2013-04-23','09:50:00',1.56),('15529','2013-04-23','09:55:00',1.55),('15529','2013-04-23','10:00:00',1.72),('15529','2013-04-23','10:05:00',1.76),('15529','2013-04-23','10:10:00',1.7),('15529','2013-04-23','10:15:00',1.79),('15529','2013-04-23','10:20:00',1.74),('15529','2013-04-23','10:25:00',1.74),('15529','2013-04-23','10:30:00',1.71),('15529','2013-04-23','10:35:00',1.75),('15529','2013-04-23','10:40:00',1.92),('15529','2013-04-23','10:45:00',1.9),('15529','2013-04-23','10:50:00',1.96),('15529','2013-04-23','10:55:00',2.03),('15529','2013-04-23','11:00:00',1.99),('15529','2013-04-23','11:05:00',2.04),('15529','2013-04-23','11:10:00',2.17),('15529','2013-04-23','11:15:00',2.17),('15529','2013-04-23','11:20:00',2.25),('15529','2013-04-23','11:25:00',2.15),('15529','2013-04-23','11:30:00',1.88),('15529','2013-04-23','11:35:00',1.4),('15529','2013-04-23','11:40:00',1.45),('15529','2013-04-23','11:45:00',1.17),('15529','2013-04-23','11:50:00',1.1),('15529','2013-04-23','11:55:00',2),('15529','2013-04-23','12:00:00',1.58),('15529','2013-04-23','12:05:00',1.44),('15529','2013-04-23','12:10:00',1.68),('15529','2013-04-23','12:15:00',2.19),('15529','2013-04-23','12:20:00',2.29),('15529','2013-04-23','12:25:00',1.96),('15529','2013-04-23','12:30:00',2.06),('15529','2013-04-23','12:35:00',2.11),('15529','2013-04-23','12:40:00',1.97),('15529','2013-04-23','12:45:00',2.1),('15529','2013-04-23','12:50:00',2.2),('15529','2013-04-23','12:55:00',2.16),('15529','2013-04-23','13:00:00',1.96),('15529','2013-04-23','13:05:00',1.96),('15529','2013-04-23','13:10:00',2.38),('15529','2013-04-23','13:15:00',2.13),('15529','2013-04-23','13:20:00',2.13),('15529','2013-04-23','13:25:00',2.25),('15529','2013-04-23','13:30:00',1.88),('15529','2013-04-23','13:35:00',2.23),('15529','2013-04-23','13:40:00',2.35),('15529','2013-04-23','13:45:00',1.69),('15529','2013-04-23','13:50:00',1.71),('15529','2013-04-23','13:55:00',2.32),('15529','2013-04-23','14:00:00',1.93),('15529','2013-04-23','14:05:00',1.48),('15529','2013-04-23','14:10:00',1.85),('15529','2013-04-23','14:15:00',2.12),('15529','2013-04-23','14:20:00',1.99),('15529','2013-04-23','14:25:00',2.03),('15529','2013-04-23','14:30:00',1.82),('15529','2013-04-23','14:35:00',1.79),('15529','2013-04-23','14:40:00',1.59),('15529','2013-04-23','14:45:00',1.57),('15529','2013-04-23','14:50:00',1.38),('15529','2013-04-23','14:55:00',1.28),('15529','2013-04-23','15:00:00',1.29),('15529','2013-04-23','15:05:00',1.22),('15529','2013-04-23','15:10:00',1.12),('15529','2013-04-23','15:15:00',1.18),('15529','2013-04-23','15:20:00',1.27),('15529','2013-04-23','15:55:00',1.32),('15529','2013-04-23','16:00:00',1.36),('15529','2013-04-23','16:05:00',1.48),('15529','2013-04-23','16:10:00',1.34),('15529','2013-04-23','16:15:00',1.45),('15529','2013-04-23','16:20:00',1.62),('15529','2013-04-23','16:25:00',1.26),('15529','2013-04-23','16:35:00',1.12),('15529','2013-04-23','16:40:00',1.26),('15529','2013-04-23','16:45:00',1.26),('15529','2013-04-23','16:50:00',1.23),('15529','2013-04-23','16:55:00',1.45),('15529','2013-04-23','17:00:00',1.38),('15529','2013-04-23','17:05:00',1.28),('15529','2013-04-23','17:10:00',1.18),('15529','2013-04-22','08:40:00',1.02),('15529','2013-04-22','08:45:00',1.08),('15529','2013-04-22','08:50:00',1.13),('15529','2013-04-22','08:55:00',1.18),('15529','2013-04-22','09:00:00',1.23),('15529','2013-04-22','09:05:00',1.27),('15529','2013-04-22','09:10:00',1.32),('15529','2013-04-22','09:15:00',1.37),('15529','2013-04-22','09:20:00',1.41),('15529','2013-04-22','09:25:00',1.45),('15529','2013-04-22','09:30:00',1.49),('15529','2013-04-22','09:35:00',1.55),('15529','2013-04-22','09:40:00',1.43),('15529','2013-04-22','09:45:00',1.33),('15529','2013-04-22','09:50:00',1.53),('15529','2013-04-22','09:55:00',1.73),('15529','2013-04-22','10:00:00',1.76),('15529','2013-04-22','10:05:00',1.78),('15529','2013-04-22','10:10:00',1.82),('15529','2013-04-22','10:15:00',1.84),('15529','2013-04-22','10:20:00',1.88),('15529','2013-04-22','10:25:00',1.9),('15529','2013-04-22','10:30:00',1.92),('15529','2013-04-22','10:35:00',1.95),('15529','2013-04-22','10:40:00',1.99),('15529','2013-04-22','10:45:00',1.92),('15529','2013-04-22','10:50:00',2.02),('15529','2013-04-22','10:55:00',2.07),('15529','2013-04-22','11:00:00',2.07),('15529','2013-04-22','11:05:00',2.11),('15529','2013-04-22','11:10:00',2.12),('15529','2013-04-22','11:15:00',2.14),('15529','2013-04-22','11:20:00',2.15),('15529','2013-04-22','11:25:00',2.18),('15529','2013-04-22','11:30:00',2.2),('15529','2013-04-22','11:35:00',2.2),('15529','2013-04-22','11:40:00',2.24),('15529','2013-04-22','11:45:00',2.23),('15529','2013-04-22','11:50:00',2.21),('15529','2013-04-22','11:55:00',2.23),('15529','2013-04-22','12:00:00',2.25),('15529','2013-04-22','12:05:00',2.28),('15529','2013-04-22','12:10:00',2.29),('15529','2013-04-22','12:15:00',2.31),('15529','2013-04-22','12:20:00',2.29),('15529','2013-04-22','12:25:00',2.35),('15529','2013-04-22','12:30:00',1.33),('15529','2013-04-22','12:35:00',1.78),('15529','2013-04-22','12:50:00',1.98),('15529','2013-04-22','12:55:00',2.47),('15529','2013-04-22','13:00:00',2.11),('15529','2013-04-22','13:05:00',1.37),('15529','2013-04-22','13:15:00',2.07),('15529','2013-04-22','13:20:00',2.61),('15529','2013-04-22','13:25:00',2.43),('15529','2013-04-22','13:30:00',2.42),('15529','2013-04-22','13:35:00',2.4),('15529','2013-04-22','13:40:00',2.44),('15529','2013-04-22','13:45:00',1.9),('15529','2013-04-22','13:50:00',2.25),('15529','2013-04-22','13:55:00',2.51),('15529','2013-04-22','14:00:00',2.36),('15529','2013-04-22','14:05:00',2.49),('15529','2013-04-22','14:10:00',2.27),('15529','2013-04-22','14:15:00',2.2),('15529','2013-04-22','14:20:00',1.6),('15529','2013-04-22','14:25:00',1.68),('15529','2013-04-22','14:30:00',2.31),('15529','2013-04-22','14:35:00',2.12),('15529','2013-04-22','14:40:00',2.22),('15529','2013-04-22','14:45:00',1.75),('15529','2013-04-22','14:50:00',1.15),('15529','2013-04-22','14:55:00',1.11),('15529','2013-04-22','15:00:00',1.28),('15529','2013-04-22','15:05:00',1.42),('15529','2013-04-22','15:10:00',1.59),('15529','2013-04-22','15:15:00',1.56),('15529','2013-04-22','15:20:00',1.5),('15529','2013-04-22','15:25:00',1.29),('15529','2013-04-22','15:30:00',1.31),('15529','2013-04-22','15:35:00',1.31),('15529','2013-04-22','15:40:00',1.13),('15529','2013-04-22','15:45:00',1.13),('15529','2013-04-22','15:50:00',1.05),('15529','2013-04-22','15:55:00',1.33),('15529','2013-04-22','16:00:00',1.52),('15529','2013-04-22','16:05:00',1.42),('15529','2013-04-22','16:10:00',1.47),('15529','2013-04-22','16:15:00',1.27),('15529','2013-04-22','16:20:00',1.24),('15529','2013-04-21','10:35:00',2.12),('15529','2013-04-21','10:40:00',1.86),('15529','2013-04-21','10:45:00',1.91),('15529','2013-04-21','10:50:00',1.11),('15529','2013-04-21','11:30:00',2.11),('15529','2013-04-21','11:35:00',2.49),('15529','2013-04-21','11:40:00',1.61),('15529','2013-04-21','11:45:00',1.43),('15529','2013-04-21','11:50:00',2.65),('15529','2013-04-21','11:55:00',1.53),('15529','2013-04-21','12:00:00',1.03),('15529','2013-04-21','12:05:00',2.37),('15529','2013-04-21','12:10:00',2.23),('15529','2013-04-21','12:15:00',2.75),('15529','2013-04-21','12:20:00',1.45),('15529','2013-04-21','12:25:00',2.32),('15529','2013-04-21','12:30:00',1.99),('15529','2013-04-21','12:35:00',1.64),('15529','2013-04-21','12:40:00',2.8),('15529','2013-04-21','12:45:00',2.13),('15529','2013-04-21','12:50:00',2.05),('15529','2013-04-21','12:55:00',2.63),('15529','2013-04-21','13:00:00',1.96),('15529','2013-04-21','13:05:00',1.98),('15529','2013-04-21','13:10:00',1.49),('15529','2013-04-21','13:20:00',1.15),('15529','2013-04-21','13:25:00',2.75),('15529','2013-04-21','13:30:00',2.28),('15529','2013-04-21','13:35:00',1.83),('15529','2013-04-21','13:40:00',1.21),('15529','2013-04-21','14:15:00',2.48),('15529','2013-04-21','14:20:00',2.57),('15529','2013-04-21','14:25:00',2.5),('15529','2013-04-21','14:30:00',2.46),('15529','2013-04-21','14:35:00',2.08),('15529','2013-04-21','14:40:00',1.67),('15529','2013-04-21','14:45:00',2.36),('15529','2013-04-21','14:50:00',2.4),('15529','2013-04-21','14:55:00',2.39),('15529','2013-04-21','15:00:00',2.45),('15529','2013-04-21','15:05:00',1.44),('15529','2013-04-21','15:10:00',2.09),('15529','2013-04-21','15:15:00',2.44),('15529','2013-04-21','15:20:00',1.99),('15529','2013-04-21','15:25:00',1.29),('15529','2013-04-21','15:35:00',1.74),('15529','2013-04-21','15:40:00',2),('15529','2013-04-21','15:45:00',2.15),('15529','2013-04-21','15:50:00',1.9),('15529','2014-03-28','08:05:00',1.03),('15529','2014-03-28','08:10:00',1.08),('15529','2014-03-28','08:15:00',1.13),('15529','2014-03-28','08:20:00',1.19),('15529','2014-03-28','08:25:00',1.24),('15529','2014-03-28','08:30:00',1.29),('15529','2014-03-28','08:35:00',1.33),('15529','2014-03-28','08:40:00',1.37),('15529','2014-03-28','08:45:00',1.4),('15529','2014-03-28','08:50:00',1.44),('15529','2014-03-28','08:55:00',1.46),('15529','2014-03-28','09:00:00',1.5),('15529','2014-03-28','09:05:00',1.53),('15529','2014-03-28','09:10:00',1.57),('15529','2014-03-28','09:15:00',1.61),('15529','2014-03-28','09:20:00',1.66),('15529','2014-03-28','09:25:00',1.71),('15529','2014-03-28','09:30:00',1.76),('15529','2014-03-28','09:35:00',1.78),('15529','2014-03-28','09:40:00',1.8),('15529','2014-03-28','09:45:00',1.84),('15529','2014-03-28','09:50:00',1.87),('15529','2014-03-28','09:55:00',1.9),('15529','2014-03-28','10:00:00',1.93),('15529','2014-03-28','10:05:00',1.96),('15529','2014-03-28','10:10:00',1.97),('15529','2014-03-28','10:15:00',2.03),('15529','2014-03-28','10:20:00',2.06),('15529','2014-03-28','10:25:00',2.07),('15529','2014-03-28','10:30:00',2.08),('15529','2014-03-28','10:35:00',2.08),('15529','2014-03-28','10:40:00',2.1),('15529','2014-03-28','10:45:00',2.15),('15529','2014-03-28','10:50:00',2.18),('15529','2014-03-28','10:55:00',2.16),('15529','2014-03-28','11:00:00',2.19),('15529','2014-03-28','11:05:00',2.19),('15529','2014-03-28','11:10:00',2.21),('15529','2014-03-28','11:15:00',2.25),('15529','2014-03-28','11:20:00',2.23),('15529','2014-03-28','11:25:00',2.23),('15529','2014-03-28','11:30:00',2.24),('15529','2014-03-28','11:35:00',2.24),('15529','2014-03-28','11:40:00',2.21),('15529','2014-03-28','11:45:00',2.26),('15529','2014-03-28','11:50:00',2.3),('15529','2014-03-28','11:55:00',2.29),('15529','2014-03-28','12:00:00',2.25),('15529','2014-03-28','12:05:00',2.27),('15529','2014-03-28','12:10:00',2.3),('15529','2014-03-28','12:15:00',2.29),('15529','2014-03-28','12:20:00',2.28),('15529','2014-03-28','12:25:00',2.27),('15529','2014-03-28','12:30:00',2.3),('15529','2014-03-28','12:35:00',2.26),('15529','2014-03-28','12:40:00',2.29),('15529','2014-03-28','12:45:00',2.29),('15529','2014-03-28','12:50:00',2.24),('15529','2014-03-28','12:55:00',2.22),('15529','2014-03-28','13:00:00',2.21),('15529','2014-03-28','13:05:00',2.21),('15529','2014-03-28','13:10:00',2.2),('15529','2014-03-28','13:15:00',2.19),('15529','2014-03-28','13:20:00',2.2),('15529','2014-03-28','13:25:00',2.14),('15529','2014-03-28','13:30:00',2.12),('15529','2014-03-28','13:35:00',2.09),('15529','2014-03-28','13:40:00',2.08),('15529','2014-03-28','13:45:00',2.06),('15529','2014-03-28','13:50:00',2.05),('15529','2014-03-28','13:55:00',2.04),('15529','2014-03-28','14:00:00',2.01),('15529','2014-03-28','14:05:00',1.96),('15529','2014-03-28','14:10:00',1.93),('15529','2014-03-28','14:15:00',1.88),('15529','2014-03-28','14:20:00',1.86),('15529','2014-03-28','14:25:00',1.85),('15529','2014-03-28','14:30:00',1.78),('15529','2014-03-28','14:35:00',1.75),('15529','2014-03-28','14:40:00',1.81),('15529','2014-03-28','14:45:00',1.55),('15529','2014-03-28','14:50:00',1.47),('15529','2014-03-28','14:55:00',1.72),('15529','2014-03-28','15:00:00',1.68),('15529','2014-03-28','15:05:00',1.65),('15529','2014-03-28','15:10:00',1.6),('15529','2014-03-28','15:15:00',1.52),('15529','2014-03-28','15:20:00',1.48),('15529','2014-03-28','15:25:00',1.44),('15529','2014-03-28','15:30:00',1.41),('15529','2014-03-28','15:35:00',1.37),('15529','2014-03-28','15:40:00',1.32),('15529','2014-03-28','15:45:00',1.27),('15529','2014-03-28','15:50:00',1.23),('15529','2014-03-28','15:55:00',1.18),('15529','2014-03-28','16:00:00',1.13),('15529','2014-03-28','16:05:00',1.08),('15529','2014-03-28','16:10:00',1.03),('15529','2013-04-20','09:00:00',1.43),('15529','2013-04-20','09:15:00',1.2),('15529','2013-04-20','09:20:00',1.61),('15529','2013-04-20','09:25:00',1.51),('15529','2013-04-20','09:30:00',1.77),('15529','2013-04-20','09:35:00',1.62),('15529','2013-04-20','09:40:00',1.83),('15529','2013-04-20','09:45:00',1.77),('15529','2013-04-20','09:50:00',1.24),('15529','2013-04-20','09:55:00',1.24),('15529','2013-04-20','10:30:00',1.1),('15529','2013-04-20','10:40:00',1.1),('15529','2013-04-20','10:45:00',1.35),('15529','2013-04-20','10:50:00',1.54),('15529','2013-04-20','10:55:00',2.12),('15529','2013-04-20','11:00:00',1.59),('15529','2013-04-20','11:05:00',1.56),('15529','2013-04-20','11:10:00',1.57),('15529','2013-04-20','11:15:00',1.67),('15529','2013-04-20','11:20:00',1.58),('15529','2013-04-20','11:25:00',1.39),('15529','2013-04-20','11:30:00',1.44),('15529','2013-04-20','11:35:00',1.62),('15529','2013-04-20','11:40:00',1.9),('15529','2013-04-20','11:45:00',1.79),('15529','2013-04-20','11:50:00',1.34),('15529','2013-04-20','11:55:00',1.44),('15529','2013-04-20','12:00:00',1.36),('15529','2013-04-20','12:05:00',1.24),('15529','2013-04-20','12:10:00',1.2),('15529','2013-04-20','12:15:00',1.01),('15529','2013-04-20','12:25:00',1),('15529','2013-04-20','12:30:00',1.03),('15529','2013-04-20','12:35:00',1.14),('15529','2013-04-20','12:40:00',1.13),('15529','2013-04-20','12:45:00',1.08),('15529','2013-04-20','12:50:00',1.09),('15529','2013-04-20','12:55:00',1.07),('15529','2013-04-20','13:00:00',1.22),('15529','2013-04-20','13:05:00',1.92),('15529','2013-04-20','13:10:00',1.42),('15529','2013-04-20','13:15:00',1.21),('15529','2013-04-20','13:20:00',1.21),('15529','2013-04-20','13:25:00',1.27),('15529','2013-04-20','13:30:00',2.04),('15529','2013-04-20','13:35:00',2.4),('15529','2013-04-20','13:40:00',2.56),('15529','2013-04-20','13:45:00',2.65),('15529','2013-04-20','13:50:00',1.96),('15529','2013-04-20','13:55:00',1.86),('15529','2013-04-20','14:00:00',1.94),('15529','2013-04-20','14:05:00',2.4),('15529','2013-04-20','14:10:00',2.5),('15529','2013-04-20','14:15:00',2.06),('15529','2013-04-20','14:20:00',2.38),('15529','2013-04-20','14:25:00',1.74),('15529','2013-04-20','14:30:00',2.27),('15529','2013-04-20','14:35:00',2.32),('15529','2013-04-20','14:40:00',1.74),('15529','2013-04-20','14:45:00',2),('15529','2013-04-20','14:50:00',1.46),('15529','2013-04-20','14:55:00',2.23),('15529','2013-04-20','15:00:00',1.35),('15529','2013-04-20','15:05:00',1.97),('15529','2013-04-20','15:10:00',1.53),('15529','2013-04-20','15:15:00',1.18),('15529','2013-04-19','08:40:00',1.02),('15529','2013-04-19','08:45:00',1.05),('15529','2013-04-19','08:50:00',1.15),('15529','2013-04-19','08:55:00',1.26),('15529','2013-04-19','09:00:00',1.22),('15529','2013-04-19','09:05:00',1.06),('15529','2013-04-19','09:15:00',1.13),('15529','2013-04-19','09:20:00',1.05),('15529','2013-04-19','10:40:00',1.69),('15529','2013-04-19','10:45:00',2.03),('15529','2013-04-19','10:50:00',1.89),('15529','2013-04-19','10:55:00',1.3),('15529','2013-04-19','11:00:00',2.13),('15529','2013-04-19','11:05:00',2.22),('15529','2013-04-19','11:10:00',1.98),('15529','2013-04-19','11:15:00',1.54),('15529','2013-04-19','11:20:00',1.56),('15529','2013-04-19','11:25:00',1.14),('15529','2013-04-19','11:30:00',1.97),('15529','2013-04-19','11:35:00',1.64),('15529','2013-04-19','11:40:00',2.03),('15529','2013-04-19','11:45:00',1.28),('15529','2013-04-19','11:55:00',1.98),('15529','2013-04-19','12:05:00',1.88),('15529','2013-04-19','12:10:00',1.86),('15529','2013-04-19','12:15:00',2.03),('15529','2013-04-19','12:20:00',1.06),('15529','2013-04-19','12:25:00',2.03),('15529','2013-04-19','12:30:00',1.18),('15529','2013-04-19','12:35:00',1.89),('15529','2013-04-19','12:40:00',2.5),('15529','2013-04-19','12:45:00',2.4),('15529','2013-04-19','12:50:00',2.36),('15529','2013-04-19','12:55:00',2.33),('15529','2013-04-19','13:00:00',2.35),('15529','2013-04-19','13:05:00',2.35),('15529','2013-04-19','13:10:00',2.41),('15529','2013-04-19','13:15:00',1.34),('15529','2013-04-19','13:20:00',1.04),('15529','2013-04-19','13:25:00',2.08),('15529','2013-04-19','13:30:00',2.16),('15529','2013-04-19','13:35:00',1.5),('15529','2013-04-19','13:40:00',1.84),('15529','2013-04-19','13:45:00',1.32),('15529','2013-04-19','13:50:00',1.28),('15529','2013-04-19','13:55:00',1.95),('15529','2013-04-19','14:00:00',1.89),('15529','2013-04-19','14:05:00',2),('15529','2013-04-19','14:10:00',1.86),('15529','2013-04-19','14:15:00',2.35),('15529','2013-04-19','14:20:00',2.23),('15529','2013-04-19','14:25:00',2.18),('15529','2013-04-19','14:30:00',2.17),('15529','2013-04-19','14:35:00',2.15),('15529','2013-04-19','14:40:00',2.13),('15529','2013-04-19','14:45:00',2.12),('15529','2013-04-19','14:50:00',2.14),('15529','2013-04-19','14:55:00',2.14),('15529','2013-04-19','15:00:00',2.14),('15529','2013-04-19','15:05:00',2.11),('15529','2013-04-19','15:10:00',1.86),('15529','2013-04-19','15:15:00',2.01),('15529','2013-04-19','15:20:00',1.57),('15529','2013-04-19','15:25:00',1.29),('15529','2013-04-19','16:05:00',1.05),('15529','2013-04-19','16:10:00',1.62),('15529','2013-04-19','16:15:00',1.53),('15529','2013-04-19','16:20:00',1.42),('15529','2013-04-19','16:25:00',1.35),('15529','2013-04-19','16:30:00',1.4),('15529','2013-04-19','16:35:00',1.63),('15529','2013-04-19','16:40:00',1.63),('15529','2013-04-19','16:45:00',1.49),('15529','2013-04-19','16:50:00',1.39),('15529','2013-04-19','16:55:00',1.31),('15529','2013-04-19','17:00:00',1.23),('15529','2013-04-19','17:05:00',1.17),('15529','2013-04-19','17:10:00',1.12),('15529','2013-04-19','17:15:00',1.08),('15529','2013-04-19','17:20:00',1.03),('15529','2013-04-19','17:25:00',1.02),('15529','2013-04-19','17:30:00',1.01),('15529','2013-04-18','08:50:00',1.03),('15529','2013-04-18','08:55:00',1.02),('15529','2013-04-18','09:05:00',1.15),('15529','2013-04-18','09:10:00',1.2),('15529','2013-04-18','09:15:00',1.22),('15529','2013-04-18','09:20:00',1.28),('15529','2013-04-18','09:25:00',1.31),('15529','2013-04-18','09:30:00',1.36),('15529','2013-04-18','09:35:00',1.37),('15529','2013-04-18','09:40:00',1.29),('15529','2013-04-18','09:45:00',1.42),('15529','2013-04-18','09:50:00',1.46),('15529','2013-04-18','09:55:00',1.51),('15529','2013-04-18','10:00:00',1.55),('15529','2013-04-18','10:05:00',1.59),('15529','2013-04-18','10:10:00',1.61),('15529','2013-04-18','10:15:00',1.66),('15529','2013-04-18','10:20:00',1.7),('15529','2013-04-18','10:25:00',1.73),('15529','2013-04-18','10:30:00',1.74),('15529','2013-04-18','10:35:00',1.77),('15529','2013-04-18','10:40:00',1.72),('15529','2013-04-18','10:45:00',1.83),('15529','2013-04-18','10:50:00',1.83),('15529','2013-04-18','10:55:00',1.81),('15529','2013-04-18','11:00:00',1.9),('15529','2013-04-18','11:05:00',1.92),('15529','2013-04-18','11:10:00',1.95),('15529','2013-04-18','11:15:00',1.97),('15529','2013-04-18','11:20:00',1.97),('15529','2013-04-18','11:25:00',2.01),('15529','2013-04-18','11:30:00',1.98),('15529','2013-04-18','11:35:00',2.03),('15529','2013-04-18','11:40:00',2.01),('15529','2013-04-18','11:45:00',2.05),('15529','2013-04-18','11:50:00',2.07),('15529','2013-04-18','11:55:00',2.07),('15529','2013-04-18','12:00:00',2.11),('15529','2013-04-18','12:05:00',2.11),('15529','2013-04-18','12:10:00',2.18),('15529','2013-04-18','12:15:00',2.14),('15529','2013-04-18','12:20:00',2.18),('15529','2013-04-18','12:25:00',2.19),('15529','2013-04-18','12:30:00',2.19),('15529','2013-04-18','12:35:00',2.18),('15529','2013-04-18','12:40:00',2.2),('15529','2013-04-18','12:45:00',2.24),('15529','2013-04-18','12:50:00',2.21),('15529','2013-04-18','12:55:00',2.16),('15529','2013-04-18','13:00:00',2.15),('15529','2013-04-18','13:05:00',2.28),('15529','2013-04-18','13:10:00',2.28),('15529','2013-04-18','13:15:00',2.23),('15529','2013-04-18','13:20:00',2.21),('15529','2013-04-18','13:25:00',2.27),('15529','2013-04-18','13:30:00',2.24),('15529','2013-04-18','13:35:00',2.19),('15529','2013-04-18','13:40:00',2.19),('15529','2013-04-18','13:45:00',2.17),('15529','2013-04-18','13:50:00',2.17),('15529','2013-04-18','13:55:00',2.2),('15529','2013-04-18','14:00:00',2.13),('15529','2013-04-18','14:05:00',2.17),('15529','2013-04-18','14:10:00',2.13),('15529','2013-04-18','14:15:00',2.11),('15529','2013-04-18','14:20:00',2.11),('15529','2013-04-18','14:25:00',2.09),('15529','2013-04-18','14:30:00',2.07),('15529','2013-04-18','14:35:00',2.05),('15529','2013-04-18','14:40:00',2.02),('15529','2013-04-18','14:45:00',2),('15529','2013-04-18','14:50:00',1.96),('15529','2013-04-18','14:55:00',1.95),('15529','2013-04-18','15:00:00',1.91),('15529','2013-04-18','15:05:00',1.88),('15529','2013-04-18','15:10:00',1.9),('15529','2013-04-18','15:15:00',1.88),('15529','2013-04-18','15:20:00',1.87),('15529','2013-04-18','15:25:00',1.82),('15529','2013-04-18','15:30:00',1.81),('15529','2013-04-18','15:35:00',1.79),('15529','2013-04-18','15:40:00',1.75),('15529','2013-04-18','15:45:00',1.71),('15529','2013-04-18','15:50:00',1.67),('15529','2013-04-18','15:55:00',1.64),('15529','2013-04-18','16:00:00',1.61),('15529','2013-04-18','16:05:00',1.57),('15529','2013-04-18','16:10:00',1.56),('15529','2013-04-18','16:15:00',1.51),('15529','2013-04-18','16:20:00',1.45),('15529','2013-04-18','16:25:00',1.42),('15529','2013-04-18','16:30:00',1.39),('15529','2013-04-18','16:35:00',1.35),('15529','2013-04-18','16:40:00',1.29),('15529','2013-04-18','16:45:00',1.24),('15529','2013-04-18','16:50:00',1.21),('15529','2013-04-18','16:55:00',1.16),('15529','2013-04-18','17:00:00',1.11),('15529','2013-04-18','17:05:00',1.06),('15529','2013-04-18','17:10:00',1.01),('15529','2013-04-17','09:10:00',1.11),('15529','2013-04-17','09:15:00',1.1),('15529','2013-04-17','09:20:00',1.05),('15529','2013-04-17','09:25:00',1.02),('15529','2013-04-17','09:30:00',1.06),('15529','2013-04-17','09:35:00',1.12),('15529','2013-04-17','09:40:00',1.24),('15529','2013-04-17','09:45:00',1.35),('15529','2013-04-17','09:50:00',1.41),('15529','2013-04-17','09:55:00',1.5),('15529','2013-04-17','10:00:00',1.42),('15529','2013-04-17','10:05:00',1.51),('15529','2013-04-17','10:10:00',1.57),('15529','2013-04-17','10:15:00',1.74),('15529','2013-04-17','10:20:00',1.8),('15529','2013-04-17','10:25:00',1.77),('15529','2013-04-17','10:30:00',1.81),('15529','2013-04-17','10:35:00',1.85),('15529','2013-04-17','10:40:00',1.85),('15529','2013-04-17','10:45:00',1.88),('15529','2013-04-17','10:50:00',1.91),('15529','2013-04-17','10:55:00',1.94),('15529','2013-04-17','11:00:00',1.97),('15529','2013-04-17','11:05:00',2),('15529','2013-04-17','11:10:00',2.02),('15529','2013-04-17','11:15:00',2.04),('15529','2013-04-17','11:20:00',2.06),('15529','2013-04-17','11:25:00',2.08),('15529','2013-04-17','11:30:00',2.06),('15529','2013-04-17','11:35:00',2.07),('15529','2013-04-17','11:40:00',2.14),('15529','2013-04-17','11:45:00',2.12),('15529','2013-04-17','11:50:00',2.17),('15529','2013-04-17','11:55:00',2.18),('15529','2013-04-17','12:00:00',2.16),('15529','2013-04-17','12:05:00',2.23),('15529','2013-04-17','12:10:00',2.21),('15529','2013-04-17','12:15:00',2.23),('15529','2013-04-17','12:20:00',2.23),('15529','2013-04-17','12:25:00',2.25),('15529','2013-04-17','12:30:00',2.26),('15529','2013-04-17','12:35:00',2.28),('15529','2013-04-17','12:40:00',2.27),('15529','2013-04-17','12:45:00',2.31),('15529','2013-04-17','12:50:00',2.33),('15529','2013-04-17','12:55:00',2.32),('15529','2013-04-17','13:00:00',2.31),('15529','2013-04-17','13:05:00',2.31),('15529','2013-04-17','13:10:00',2.34),('15529','2013-04-17','13:15:00',2.31),('15529','2013-04-17','13:20:00',2.32),('15529','2013-04-17','13:25:00',2.31),('15529','2013-04-17','13:30:00',2.34),('15529','2013-04-17','13:35:00',2.31),('15529','2013-04-17','13:40:00',2.3),('15529','2013-04-17','13:45:00',2.3),('15529','2013-04-17','13:50:00',2.33),('15529','2013-04-17','13:55:00',2.26),('15529','2013-04-17','14:00:00',2.23),('15529','2013-04-17','14:05:00',2.26),('15529','2013-04-17','14:10:00',2.23),('15529','2013-04-17','14:15:00',2.26),('15529','2013-04-17','14:20:00',2.22),('15529','2013-04-17','14:25:00',2.19),('15529','2013-04-17','14:30:00',2.18),('15529','2013-04-17','14:35:00',2.15),('15529','2013-04-17','14:40:00',2.13),('15529','2013-04-17','14:45:00',2.14),('15529','2013-04-17','14:50:00',2.09),('15529','2013-04-17','14:55:00',2.07),('15529','2013-04-17','15:00:00',2.05),('15529','2013-04-17','15:05:00',2.02),('15529','2013-04-17','15:10:00',1.99),('15529','2013-04-17','15:15:00',1.96),('15529','2013-04-17','15:20:00',1.93),('15529','2013-04-17','15:25:00',1.91),('15529','2013-04-17','15:30:00',1.87),('15529','2013-04-17','15:35:00',1.84),('15529','2013-04-17','15:40:00',1.82),('15529','2013-04-17','15:45:00',1.8),('15529','2013-04-17','15:50:00',1.76),('15529','2013-04-17','15:55:00',1.73),('15529','2013-04-17','16:00:00',1.7),('15529','2013-04-17','16:05:00',1.65),('15529','2013-04-17','16:10:00',1.6),('15529','2013-04-17','16:15:00',1.58),('15529','2013-04-17','16:20:00',1.54),('15529','2013-04-17','16:25:00',1.49),('15529','2013-04-17','16:30:00',1.44),('15529','2013-04-17','16:35:00',1.4),('15529','2013-04-17','16:40:00',1.36),('15529','2013-04-17','16:45:00',1.32),('15529','2013-04-17','16:50:00',1.27),('15529','2013-04-17','16:55:00',1.22),('15529','2013-04-17','17:00:00',1.17),('15529','2013-04-17','17:05:00',1.12),('15529','2013-04-17','17:10:00',1.07),('15529','2013-04-17','17:15:00',1.03),('15529','2013-04-16','08:50:00',1.03),('15529','2013-04-16','08:55:00',1.08),('15529','2013-04-16','09:00:00',1.13),('15529','2013-04-16','09:05:00',1.19),('15529','2013-04-16','09:10:00',1.24),('15529','2013-04-16','09:15:00',1.28),('15529','2013-04-16','09:20:00',1.33),('15529','2013-04-16','09:25:00',1.37),('15529','2013-04-16','09:30:00',1.4),('15529','2013-04-16','09:35:00',1.45),('15529','2013-04-16','09:40:00',1.49),('15529','2013-04-16','09:45:00',1.53),('15529','2013-04-16','09:50:00',1.57),('15529','2013-04-16','09:55:00',1.6),('15529','2013-04-16','10:00:00',1.64),('15529','2013-04-16','10:05:00',1.67),('15529','2013-04-16','10:10:00',1.7),('15529','2013-04-16','10:15:00',1.73),('15529','2013-04-16','10:20:00',1.77),('15529','2013-04-16','10:25:00',1.81),('15529','2013-04-16','10:30:00',1.81),('15529','2013-04-16','10:35:00',1.84),('15529','2013-04-16','10:40:00',1.89),('15529','2013-04-16','10:45:00',1.92),('15529','2013-04-16','10:50:00',1.97),('15529','2013-04-16','10:55:00',2),('15529','2013-04-16','11:00:00',2.02),('15529','2013-04-16','11:05:00',2.02),('15529','2013-04-16','11:10:00',2.05),('15529','2013-04-16','11:15:00',2.01),('15529','2013-04-16','11:20:00',2.06),('15529','2013-04-16','11:25:00',2.09),('15529','2013-04-16','11:30:00',2.11),('15529','2013-04-16','11:35:00',2.15),('15529','2013-04-16','11:40:00',2.12),('15529','2013-04-16','11:45:00',2.18),('15529','2013-04-16','11:50:00',2.18),('15529','2013-04-16','11:55:00',2.21),('15529','2013-04-16','12:00:00',2.24),('15529','2013-04-16','12:05:00',2.2),('15529','2013-04-16','12:10:00',2.24),('15529','2013-04-16','12:15:00',2.26),('15529','2013-04-16','12:20:00',2.25),('15529','2013-04-16','12:25:00',2.26),('15529','2013-04-16','12:30:00',2.27),('15529','2013-04-16','12:35:00',2.26),('15529','2013-04-16','12:40:00',2.29),('15529','2013-04-16','12:45:00',2.31),('15529','2013-04-16','12:50:00',2.32),('15529','2013-04-16','12:55:00',2.32),('15529','2013-04-16','13:00:00',2.29),('15529','2013-04-16','13:05:00',2.31),('15529','2013-04-16','13:10:00',2.32),('15529','2013-04-16','13:15:00',2.31),('15529','2013-04-16','13:20:00',2.29),('15529','2013-04-16','13:25:00',2.3),('15529','2013-04-16','13:30:00',2.26),('15529','2013-04-16','13:35:00',2.31),('15529','2013-04-16','13:40:00',2.28),('15529','2013-04-16','13:45:00',2.23),('15529','2013-04-16','13:50:00',2.29),('15529','2013-04-16','13:55:00',2.14),('15529','2013-04-16','14:00:00',2.07),('15529','2013-04-16','14:05:00',2.31),('15529','2013-04-16','14:10:00',2.43),('15529','2013-04-16','14:15:00',2.43),('15529','2013-04-16','14:20:00',2.31),('15529','2013-04-16','14:25:00',2.38),('15529','2013-04-16','14:30:00',1.74),('15529','2013-04-16','14:35:00',2.2),('15529','2013-04-16','14:40:00',2.02),('15529','2013-04-16','14:45:00',2.04),('15529','2013-04-16','14:50:00',2.04),('15529','2013-04-16','14:55:00',2.27),('15529','2013-04-16','15:00:00',2.25),('15529','2013-04-16','15:05:00',2.27),('15529','2013-04-16','15:10:00',2.29),('15529','2013-04-16','15:15:00',2.09),('15529','2013-04-16','15:20:00',1.38),('15529','2013-04-16','15:30:00',1.59),('15529','2013-04-16','15:35:00',1.77),('15529','2013-04-16','15:40:00',1.93),('15529','2013-04-16','15:45:00',1.92),('15529','2013-04-16','15:50:00',1.92),('15529','2013-04-16','15:55:00',1.88),('15529','2013-04-16','16:00:00',1.89),('15529','2013-04-16','16:05:00',1.56),('15529','2013-04-16','16:10:00',1.64),('15529','2013-04-16','16:15:00',1.72),('15529','2013-04-16','16:20:00',1.63),('15529','2013-04-16','16:25:00',1.58),('15529','2013-04-16','16:30:00',1.53),('15529','2013-04-16','16:35:00',1.48),('15529','2013-04-16','16:40:00',1.28),('15529','2013-04-16','16:45:00',1.36),('15529','2013-04-16','16:50:00',1.36),('15529','2013-04-16','16:55:00',1.29),('15529','2013-04-16','17:00:00',1.22),('15529','2013-04-16','17:05:00',1.17),('15529','2013-04-16','17:10:00',1.11),('15529','2013-04-16','17:15:00',1.06),('15529','2013-04-16','17:20:00',1.01),('15529','2013-04-15','09:15:00',1.34),('15529','2013-04-15','09:20:00',1.46),('15529','2013-04-15','09:25:00',1.65),('15529','2013-04-15','09:30:00',1.47),('15529','2013-04-15','09:35:00',1.01),('15529','2013-04-15','09:40:00',1.11),('15529','2013-04-15','09:45:00',1.02),('15529','2013-04-15','11:45:00',1.06),('15529','2013-04-15','11:50:00',1.21),('15529','2013-04-15','11:55:00',1.29),('15529','2013-04-15','12:00:00',1.41),('15529','2013-04-15','12:05:00',1.83),('15529','2013-04-15','12:10:00',1.69),('15529','2013-04-15','12:15:00',1.64),('15529','2013-04-15','12:20:00',1.65),('15529','2013-04-15','12:25:00',1.66),('15529','2013-04-15','12:30:00',1.64),('15529','2013-04-15','12:35:00',1.48),('15529','2013-04-15','12:40:00',1.38),('15529','2013-04-15','12:45:00',1.55),('15529','2013-04-15','12:50:00',1.63),('15529','2013-04-15','12:55:00',2.21),('15529','2013-04-15','13:00:00',2.27),('15529','2013-04-15','13:05:00',2.26),('15529','2013-04-15','13:10:00',2.2),('15529','2013-04-15','13:15:00',2.23),('15529','2013-04-15','13:20:00',2.28),('15529','2013-04-15','13:25:00',2.28),('15529','2013-04-15','13:30:00',2.25),('15529','2013-04-15','13:35:00',2.24),('15529','2013-04-15','13:40:00',2.23),('15529','2013-04-15','13:45:00',2.26),('15529','2013-04-15','13:50:00',2.2),('15529','2013-04-15','13:55:00',2.19),('15529','2013-04-15','14:00:00',2.24),('15529','2013-04-15','14:05:00',2.2),('15529','2013-04-15','14:10:00',2.16),('15529','2013-04-15','14:15:00',2.23),('15529','2013-04-15','14:20:00',2.25),('15529','2013-04-15','14:25:00',2.19),('15529','2013-04-15','14:30:00',1.98),('15529','2013-04-15','14:35:00',1.6),('15529','2013-04-15','14:40:00',1.86),('15529','2013-04-15','14:45:00',2.11),('15529','2013-04-15','14:50:00',2.06),('15529','2013-04-15','14:55:00',2.06),('15529','2013-04-15','15:00:00',1.94),('15529','2013-04-15','15:05:00',2),('15529','2013-04-15','15:10:00',2.01),('15529','2013-04-15','15:15:00',2),('15529','2013-04-15','15:20:00',1.65),('15529','2013-04-15','15:25:00',1.59),('15529','2013-04-15','15:30:00',1.66),('15529','2013-04-15','15:35:00',1.75),('15529','2013-04-15','15:40:00',1.8),('15529','2013-04-15','15:45:00',1.77),('15529','2013-04-15','15:50:00',1.72),('15529','2013-04-15','15:55:00',1.72),('15529','2013-04-15','16:00:00',1.65),('15529','2013-04-15','16:05:00',1.62),('15529','2013-04-15','16:10:00',1.52),('15529','2013-04-15','16:15:00',1.54),('15529','2013-04-15','16:20:00',1.52),('15529','2013-04-15','16:25:00',1.45),('15529','2013-04-15','16:30:00',1.44),('15529','2013-04-15','16:35:00',1.4),('15529','2013-04-15','16:40:00',1.38),('15529','2013-04-15','16:45:00',1.39),('15529','2013-04-15','16:50:00',1.32),('15529','2013-04-15','16:55:00',1.1),('15529','2013-04-15','17:00:00',1.16),('15529','2013-04-15','17:05:00',1.15),('15529','2013-04-15','17:10:00',1.11),('15529','2013-04-15','17:15:00',1.07),('15529','2013-04-14','08:50:00',1.04),('15529','2013-04-14','08:55:00',1.09),('15529','2013-04-14','09:00:00',1.14),('15529','2013-04-14','09:05:00',1.18),('15529','2013-04-14','09:10:00',1.23),('15529','2013-04-14','09:15:00',1.28),('15529','2013-04-14','09:20:00',1.33),('15529','2013-04-14','09:25:00',1.38),('15529','2013-04-14','09:30:00',1.42),('15529','2013-04-14','09:35:00',1.45),('15529','2013-04-14','09:40:00',1.49),('15529','2013-04-14','09:45:00',1.53),('15529','2013-04-14','09:50:00',1.57),('15529','2013-04-14','09:55:00',1.6),('15529','2013-04-14','10:00:00',1.62),('15529','2013-04-14','10:05:00',1.66),('15529','2013-04-14','10:10:00',1.69),('15529','2013-04-14','10:15:00',1.73),('15529','2013-04-14','10:20:00',1.76),('15529','2013-04-14','10:25:00',1.8),('15529','2013-04-14','10:30:00',1.83),('15529','2013-04-14','10:35:00',1.87),('15529','2013-04-14','10:40:00',1.89),('15529','2013-04-14','10:45:00',1.91),('15529','2013-04-14','10:50:00',1.95),('15529','2013-04-14','10:55:00',1.98),('15529','2013-04-14','11:00:00',1.98),('15529','2013-04-14','11:05:00',2.02),('15529','2013-04-14','11:10:00',2.07),('15529','2013-04-14','11:15:00',2.07),('15529','2013-04-14','11:20:00',2.1),('15529','2013-04-14','11:25:00',2.11),('15529','2013-04-14','11:30:00',2.14),('15529','2013-04-14','11:35:00',2.14),('15529','2013-04-14','11:40:00',2.17),('15529','2013-04-14','11:45:00',2.21),('15529','2013-04-14','11:50:00',2.2),('15529','2013-04-14','11:55:00',2.19),('15529','2013-04-14','12:00:00',2.23),('15529','2013-04-14','12:05:00',2.23),('15529','2013-04-14','12:10:00',2.19),('15529','2013-04-14','12:15:00',2.23),('15529','2013-04-14','12:20:00',2.3),('15529','2013-04-14','12:25:00',2.29),('15529','2013-04-14','12:30:00',2.29),('15529','2013-04-14','12:35:00',2.26),('15529','2013-04-14','12:40:00',2.29),('15529','2013-04-14','12:45:00',2.28),('15529','2013-04-14','12:50:00',2.28),('15529','2013-04-14','12:55:00',2.27),('15529','2013-04-14','13:00:00',2.29),('15529','2013-04-14','13:05:00',2.28),('15529','2013-04-14','13:10:00',2.3),('15529','2013-04-14','13:15:00',2.33),('15529','2013-04-14','13:20:00',2.33),('15529','2013-04-14','13:25:00',2.3),('15529','2013-04-14','13:30:00',2.31),('15529','2013-04-14','13:35:00',2.3),('15529','2013-04-14','13:40:00',2.3),('15529','2013-04-14','13:45:00',2.32),('15529','2013-04-14','13:50:00',2.3),('15529','2013-04-14','13:55:00',2.28),('15529','2013-04-14','14:00:00',2.3),('15529','2013-04-14','14:05:00',2.3),('15529','2013-04-14','14:10:00',2.27),('15529','2013-04-14','14:15:00',2.25),('15529','2013-04-14','14:20:00',2.24),('15529','2013-04-14','14:25:00',2.24),('15529','2013-04-14','14:30:00',2.22),('15529','2013-04-14','14:35:00',2.2),('15529','2013-04-14','14:40:00',2.17),('15529','2013-04-14','14:45:00',2.14),('15529','2013-04-14','14:50:00',2.14),('15529','2013-04-14','14:55:00',2.11),('15529','2013-04-14','15:00:00',2.08),('15529','2013-04-14','15:05:00',2.07),('15529','2013-04-14','15:10:00',2.05),('15529','2013-04-14','15:15:00',2.02),('15529','2013-04-14','15:20:00',2),('15529','2013-04-14','15:25:00',1.96),('15529','2013-04-14','15:30:00',1.93),('15529','2013-04-14','15:35:00',1.89),('15529','2013-04-14','15:40:00',1.86),('15529','2013-04-14','15:45:00',1.82),('15529','2013-04-14','15:50:00',1.8),('15529','2013-04-14','15:55:00',1.77),('15529','2013-04-14','16:00:00',1.73),('15529','2013-04-14','16:05:00',1.69),('15529','2013-04-14','16:10:00',1.64),('15529','2013-04-14','16:15:00',1.61),('15529','2013-04-14','16:20:00',1.57),('15529','2013-04-14','16:25:00',1.53),('15529','2013-04-14','16:30:00',1.49),('15529','2013-04-14','16:35:00',1.45),('15529','2013-04-14','16:40:00',1.4),('15529','2013-04-14','16:45:00',1.35),('15529','2013-04-14','16:50:00',1.3),('15529','2013-04-14','16:55:00',1.26),('15529','2013-04-14','17:00:00',1.21),('15529','2013-04-14','17:05:00',1.16),('15529','2013-04-14','17:10:00',1.11),('15529','2013-04-14','17:15:00',1.06),('15529','2013-04-14','17:20:00',1.01),('15529','2013-04-13','08:55:00',1.04),('15529','2013-04-13','09:00:00',1.09),('15529','2013-04-13','09:05:00',1.12),('15529','2013-04-13','09:10:00',1.17),('15529','2013-04-13','09:15:00',1.21),('15529','2013-04-13','09:20:00',1.25),('15529','2013-04-13','09:25:00',1.3),('15529','2013-04-13','09:30:00',1.34),('15529','2013-04-13','09:35:00',1.38),('15529','2013-04-13','09:40:00',1.43),('15529','2013-04-13','09:45:00',1.47),('15529','2013-04-13','09:50:00',1.51),('15529','2013-04-13','09:55:00',1.54),('15529','2013-04-13','10:00:00',1.58),('15529','2013-04-13','10:05:00',1.62),('15529','2013-04-13','10:10:00',1.66),('15529','2013-04-13','10:15:00',1.69),('15529','2013-04-13','10:20:00',1.71),('15529','2013-04-13','10:25:00',1.76),('15529','2013-04-13','10:30:00',1.8),('15529','2013-04-13','10:35:00',1.83),('15529','2013-04-13','10:40:00',1.86),('15529','2013-04-13','10:45:00',1.88),('15529','2013-04-13','10:50:00',1.91),('15529','2013-04-13','10:55:00',1.97),('15529','2013-04-13','11:00:00',1.98),('15529','2013-04-13','11:05:00',2),('15529','2013-04-13','11:10:00',1.99),('15529','2013-04-13','11:15:00',2.05),('15529','2013-04-13','11:20:00',2.06),('15529','2013-04-13','11:25:00',2.08),('15529','2013-04-13','11:30:00',2.1),('15529','2013-04-13','11:35:00',2.11),('15529','2013-04-13','11:40:00',2.12),('15529','2013-04-13','11:45:00',2.1),('15529','2013-04-13','11:50:00',2.13),('15529','2013-04-13','11:55:00',2.16),('15529','2013-04-13','12:00:00',2.16),('15529','2013-04-13','12:05:00',2.19),('15529','2013-04-13','12:10:00',2.2),('15529','2013-04-13','12:15:00',2.23),('15529','2013-04-13','12:20:00',2.15),('15529','2013-04-13','12:25:00',2.19),('15529','2013-04-13','12:30:00',2.22),('15529','2013-04-13','12:35:00',2.29),('15529','2013-04-13','12:40:00',2.32),('15529','2013-04-13','12:45:00',2.26),('15529','2013-04-13','12:50:00',2.33),('15529','2013-04-13','12:55:00',2.31),('15529','2013-04-13','13:00:00',2.28),('15529','2013-04-13','13:05:00',2.31),('15529','2013-04-13','13:10:00',2.32),('15529','2013-04-13','13:15:00',1.96),('15529','2013-04-13','13:20:00',1.88),('15529','2013-04-13','13:25:00',2.29),('15529','2013-04-13','13:30:00',2.34),('15529','2013-04-13','13:35:00',2.22),('15529','2013-04-13','13:40:00',2.26),('15529','2013-04-13','13:45:00',2.31),('15529','2013-04-13','13:50:00',2.25),('15529','2013-04-13','13:55:00',2.25),('15529','2013-04-13','14:00:00',2.26),('15529','2013-04-13','14:05:00',2.23),('15529','2013-04-13','14:10:00',2.23),('15529','2013-04-13','14:15:00',2.18),('15529','2013-04-13','14:20:00',2.16),('15529','2013-04-13','14:25:00',2.16),('15529','2013-04-13','14:30:00',2.13),('15529','2013-04-13','14:35:00',2.14),('15529','2013-04-13','14:40:00',2.15),('15529','2013-04-13','14:45:00',2.13),('15529','2013-04-13','14:50:00',1.87),('15529','2013-04-13','14:55:00',1.87),('15529','2013-04-13','15:00:00',2.1),('15529','2013-04-13','15:05:00',2.08),('15529','2013-04-13','15:10:00',1.97),('15529','2013-04-13','15:15:00',1.98),('15529','2013-04-13','15:20:00',1.96),('15529','2013-04-13','15:25:00',1.93),('15529','2013-04-13','15:30:00',1.89),('15529','2013-04-13','15:35:00',1.85),('15529','2013-04-13','15:40:00',1.83),('15529','2013-04-13','15:45:00',1.81),('15529','2013-04-13','15:50:00',1.78),('15529','2013-04-13','15:55:00',1.75),('15529','2013-04-13','16:00:00',1.7),('15529','2013-04-13','16:05:00',1.65),('15529','2013-04-13','16:10:00',1.61),('15529','2013-04-13','16:15:00',1.56),('15529','2013-04-13','16:20:00',1.53),('15529','2013-04-13','16:25:00',1.49),('15529','2013-04-13','16:30:00',1.44),('15529','2013-04-13','16:35:00',1.38),('15529','2013-04-13','16:40:00',1.34),('15529','2013-04-13','16:45:00',1.32),('15529','2013-04-13','16:50:00',1.25),('15529','2013-04-13','16:55:00',1.22),('15529','2013-04-13','17:00:00',1.17),('15529','2013-04-13','17:05:00',1.12),('15529','2013-04-13','17:10:00',1.07),('15529','2013-04-13','17:15:00',1.03),('15529','2013-04-12','09:25:00',1.4),('15529','2013-04-12','09:30:00',1.41),('15529','2013-04-12','09:35:00',1.31),('15529','2013-04-12','09:40:00',1.32),('15529','2013-04-12','09:45:00',1.48),('15529','2013-04-12','09:50:00',1.52),('15529','2013-04-12','09:55:00',1.59),('15529','2013-04-12','10:00:00',1.65),('15529','2013-04-12','10:05:00',1.78),('15529','2013-04-12','10:15:00',1.93),('15529','2013-04-12','10:20:00',1.74),('15529','2013-04-12','10:25:00',1.76),('15529','2013-04-12','10:30:00',1.91),('15529','2013-04-12','10:35:00',1.95),('15529','2013-04-12','10:40:00',1.97),('15529','2013-04-12','10:45:00',1.61),('15529','2013-04-12','10:55:00',1.33),('15529','2013-04-12','11:05:00',1.49),('15529','2013-04-12','11:10:00',1.45),('15529','2013-04-12','11:15:00',2.08),('15529','2013-04-12','11:20:00',2.27),('15529','2013-04-12','11:25:00',2.2),('15529','2013-04-12','11:30:00',1.99),('15529','2013-04-12','11:35:00',1.91),('15529','2013-04-12','11:40:00',2.16),('15529','2013-04-12','11:45:00',2.26),('15529','2013-04-12','11:50:00',2.37),('15529','2013-04-12','11:55:00',1.97),('15529','2013-04-12','12:00:00',2.25),('15529','2013-04-12','12:10:00',2.17),('15529','2013-04-12','12:15:00',1.96),('15529','2013-04-12','12:20:00',2.39),('15529','2013-04-12','12:25:00',2.44),('15529','2013-04-12','12:30:00',2.05),('15529','2013-04-12','12:35:00',2.4),('15529','2013-04-12','12:40:00',2.42),('15529','2013-04-12','12:45:00',2.23),('15529','2013-04-12','12:50:00',2.24),('15529','2013-04-12','12:55:00',2.18),('15529','2013-04-12','13:00:00',2.34),('15529','2013-04-12','13:05:00',2.38),('15529','2013-04-12','13:10:00',2.37),('15529','2013-04-12','13:15:00',2.27),('15529','2013-04-12','13:20:00',2.3),('15529','2013-04-12','13:25:00',2.33),('15529','2013-04-12','13:30:00',2.22),('15529','2013-04-12','13:35:00',1.99),('15529','2013-04-12','13:40:00',1.99),('15529','2013-04-12','13:45:00',1.69),('15529','2013-04-12','13:50:00',1.96),('15529','2013-04-12','13:55:00',1.95),('15529','2013-04-12','14:00:00',1.87),('15529','2013-04-12','14:05:00',1.92),('15529','2013-04-12','14:10:00',1.68),('15529','2013-04-12','14:15:00',1.76),('15529','2013-04-12','14:20:00',1.46),('15529','2013-04-12','14:25:00',1.8),('15529','2013-04-12','14:30:00',2.03),('15529','2013-04-12','14:35:00',2.06),('15529','2013-04-12','14:40:00',2.05),('15529','2013-04-12','14:45:00',2.06),('15529','2013-04-12','14:50:00',1.97),('15529','2013-04-12','14:55:00',1.87),('15529','2013-04-12','15:00:00',1.76),('15529','2013-04-12','15:05:00',1.59),('15529','2013-04-12','15:10:00',1.67),('15529','2013-04-12','15:15:00',1.58),('15529','2013-04-12','15:20:00',1.55),('15529','2013-04-12','15:25:00',1.44),('15529','2013-04-12','15:30:00',1.46),('15529','2013-04-12','15:35:00',1.44),('15529','2013-04-12','15:40:00',1.51),('15529','2013-04-12','15:45:00',1.53),('15529','2013-04-12','15:50:00',1.46),('15529','2013-04-12','15:55:00',1.48),('15529','2013-04-12','16:00:00',1.45),('15529','2013-04-12','16:05:00',1.34),('15529','2013-04-12','16:10:00',1.32),('15529','2013-04-12','16:15:00',1.29),('15529','2013-04-12','16:20:00',1.24),('15529','2013-04-12','16:25:00',1.14),('15529','2013-04-12','16:30:00',1.08),('15529','2013-04-12','16:35:00',1.03),('15529','2013-04-12','17:10:00',1.02),('15529','2013-04-12','17:15:00',1.06),('15529','2013-04-12','17:25:00',1.01),('15529','2013-04-11','09:50:00',1.39),('15529','2013-04-11','09:55:00',1.18),('15529','2013-04-11','10:00:00',1.32),('15529','2013-04-11','10:55:00',1.11),('15529','2013-04-11','11:00:00',1.65),('15529','2013-04-11','11:05:00',1.09),('15529','2013-04-11','11:15:00',1.35),('15529','2013-04-11','11:20:00',1.12),('15529','2013-04-11','11:30:00',1.41),('15529','2013-04-11','11:35:00',2.25),('15529','2013-04-11','11:40:00',2.35),('15529','2013-04-11','11:45:00',2.27),('15529','2013-04-11','11:50:00',2.25),('15529','2013-04-11','11:55:00',2.26),('15529','2013-04-11','12:00:00',2.19),('15529','2013-04-11','12:05:00',2.2),('15529','2013-04-11','12:10:00',2.22),('15529','2013-04-11','12:15:00',2.34),('15529','2013-04-11','12:20:00',2.38),('15529','2013-04-11','12:25:00',2.39),('15529','2013-04-11','12:30:00',2.37),('15529','2013-04-11','12:35:00',2.35),('15529','2013-04-11','12:40:00',2.32),('15529','2013-04-11','12:45:00',2.32),('15529','2013-04-11','12:50:00',2.2),('15529','2013-04-11','12:55:00',2.27),('15529','2013-04-11','13:00:00',2.42),('15529','2013-04-11','13:05:00',2.19),('15529','2013-04-11','13:10:00',2.39),('15529','2013-04-11','13:15:00',2.4),('15529','2013-04-11','13:20:00',2.37),('15529','2013-04-11','13:25:00',2.37),('15529','2013-04-11','13:30:00',2.34),('15529','2013-04-11','13:35:00',2.35),('15529','2013-04-11','13:40:00',2.31),('15529','2013-04-11','13:45:00',2.26),('15529','2013-04-11','13:50:00',2.3),('15529','2013-04-11','13:55:00',2.27),('15529','2013-04-11','14:00:00',2.29),('15529','2013-04-11','14:05:00',2.23),('15529','2013-04-11','14:10:00',2.22),('15529','2013-04-11','14:15:00',2.23),('15529','2013-04-11','14:20:00',2.23),('15529','2013-04-11','14:25:00',2.22),('15529','2013-04-11','14:30:00',2.19),('15529','2013-04-11','14:35:00',2.15),('15529','2013-04-11','14:40:00',2.14),('15529','2013-04-11','14:45:00',2.1),('15529','2013-04-11','14:50:00',2.09),('15529','2013-04-11','14:55:00',2.06),('15529','2013-04-11','15:00:00',2.03),('15529','2013-04-11','15:05:00',2),('15529','2013-04-11','15:10:00',2),('15529','2013-04-11','15:15:00',1.97),('15529','2013-04-11','15:20:00',1.94),('15529','2013-04-11','15:25:00',1.93),('15529','2013-04-11','15:30:00',1.89),('15529','2013-04-11','15:35:00',1.87),('15529','2013-04-11','15:40:00',1.84),('15529','2013-04-11','15:45:00',1.81),('15529','2013-04-11','15:50:00',1.77),('15529','2013-04-11','15:55:00',1.75),('15529','2013-04-11','16:00:00',1.72),('15529','2013-04-11','16:05:00',1.69),('15529','2013-04-11','16:10:00',1.57),('15529','2013-04-11','16:15:00',1.52),('15529','2013-04-11','16:20:00',1.55),('15529','2013-04-11','16:25:00',1.51),('15529','2013-04-11','16:40:00',1.3),('15529','2013-04-11','16:45:00',1.37),('15529','2013-04-11','16:50:00',1.29),('15529','2013-04-11','16:55:00',1.24),('15529','2013-04-11','17:00:00',1.18),('15529','2013-04-11','17:05:00',1.15),('15529','2013-04-11','17:10:00',1.09),('15529','2013-04-11','17:15:00',1.01),('15529','2014-03-27','08:00:00',1.01),('15529','2014-03-27','08:05:00',1.07),('15529','2014-03-27','08:10:00',1.13),('15529','2014-03-27','08:15:00',1.18),('15529','2014-03-27','08:20:00',1.22),('15529','2014-03-27','08:25:00',1.27),('15529','2014-03-27','08:30:00',1.31),('15529','2014-03-27','08:35:00',1.36),('15529','2014-03-27','08:40:00',1.41),('15529','2014-03-27','08:45:00',1.44),('15529','2014-03-27','08:50:00',1.5),('15529','2014-03-27','08:55:00',1.55),('15529','2014-03-27','09:00:00',1.6),('15529','2014-03-27','09:05:00',1.68),('15529','2014-03-27','09:10:00',1.76),('15529','2014-03-27','09:15:00',1.72),('15529','2014-03-27','09:20:00',1.74),('15529','2014-03-27','09:25:00',1.84),('15529','2014-03-27','09:30:00',2),('15529','2014-03-27','09:35:00',1.58),('15529','2014-03-27','09:40:00',1.29),('15529','2014-03-27','09:45:00',1.08),('15529','2014-03-27','09:50:00',1.88),('15529','2014-03-27','09:55:00',1.94),('15529','2014-03-27','10:00:00',2.01),('15529','2014-03-27','10:05:00',2.09),('15529','2014-03-27','10:10:00',2.07),('15529','2014-03-27','10:15:00',1.62),('15529','2014-03-27','10:20:00',1.82),('15529','2014-03-27','10:25:00',1.84),('15529','2014-03-27','10:30:00',1.97),('15529','2014-03-27','10:35:00',1.6),('15529','2014-03-27','10:40:00',1.93),('15529','2014-03-27','10:45:00',2.23),('15529','2014-03-27','10:50:00',2.22),('15529','2014-03-27','10:55:00',2.11),('15529','2014-03-27','11:00:00',2.22),('15529','2014-03-27','11:05:00',2.32),('15529','2014-03-27','11:10:00',1.82),('15529','2014-03-27','11:15:00',2.42),('15529','2014-03-27','11:20:00',1.83),('15529','2014-03-27','11:25:00',1.39),('15529','2014-03-27','11:30:00',2.33),('15529','2014-03-27','11:35:00',1.66),('15529','2014-03-27','11:40:00',1.79),('15529','2014-03-27','11:45:00',1.77),('15529','2014-03-27','11:50:00',2.63),('15529','2014-03-27','11:55:00',1.7),('15529','2014-03-27','12:00:00',1.06),('15529','2014-03-27','12:05:00',1.8),('15529','2014-03-27','12:10:00',1.04),('15529','2014-03-27','12:20:00',2.13),('15529','2014-03-27','12:25:00',2.17),('15529','2014-03-27','12:40:00',1.64),('15529','2014-03-27','12:45:00',2.45),('15529','2014-03-27','12:50:00',2.32),('15529','2014-03-27','12:55:00',2.61),('15529','2014-03-27','13:15:00',1.17),('15529','2014-03-27','13:20:00',1.56),('15529','2014-03-27','13:25:00',1.51),('15529','2014-03-27','13:30:00',1.82),('15529','2014-03-27','13:35:00',1.55),('15529','2014-03-27','13:40:00',2.01),('15529','2014-03-27','13:45:00',2.31),('15529','2014-03-27','13:50:00',2.21),('15529','2014-03-27','13:55:00',2.11),('15529','2014-03-27','14:00:00',2.15),('15529','2014-03-27','14:05:00',2.13),('15529','2014-03-27','14:10:00',2.11),('15529','2014-03-27','14:15:00',2.08),('15529','2014-03-27','14:20:00',2.04),('15529','2014-03-27','14:25:00',2.01),('15529','2014-03-27','14:30:00',1.97),('15529','2014-03-27','14:35:00',1.94),('15529','2014-03-27','14:40:00',1.91),('15529','2014-03-27','14:45:00',1.9),('15529','2014-03-27','14:50:00',1.86),('15529','2014-03-27','14:55:00',1.83),('15529','2014-03-27','15:00:00',1.79),('15529','2014-03-27','15:05:00',1.76),('15529','2014-03-27','15:10:00',1.71),('15529','2014-03-27','15:15:00',1.68),('15529','2014-03-27','15:20:00',1.63),('15529','2014-03-27','15:25:00',1.58),('15529','2014-03-27','15:30:00',1.54),('15529','2014-03-27','15:35:00',1.5),('15529','2014-03-27','15:40:00',1.45),('15529','2014-03-27','15:45:00',1.43),('15529','2014-03-27','15:50:00',1.38),('15529','2014-03-27','15:55:00',1.33),('15529','2014-03-27','16:00:00',1.31),('15529','2014-03-27','16:05:00',1.3),('15529','2014-03-27','16:10:00',1.25),('15529','2014-03-27','16:15:00',1.2),('15529','2014-03-27','16:20:00',1.07),('15529','2013-04-10','08:55:00',1.03),('15529','2013-04-10','09:00:00',1.09),('15529','2013-04-10','09:05:00',1.13),('15529','2013-04-10','09:10:00',1.18),('15529','2013-04-10','09:15:00',1.22),('15529','2013-04-10','09:20:00',1.26),('15529','2013-04-10','09:25:00',1.31),('15529','2013-04-10','09:30:00',1.34),('15529','2013-04-10','09:35:00',1.46),('15529','2013-04-10','09:40:00',1.48),('15529','2013-04-10','09:45:00',1.5),('15529','2013-04-10','09:50:00',1.54),('15529','2013-04-10','09:55:00',1.62),('15529','2013-04-10','10:00:00',1.67),('15529','2013-04-10','10:05:00',1.77),('15529','2013-04-10','10:10:00',1.81),('15529','2013-04-10','10:15:00',1.29),('15529','2013-04-10','10:20:00',1.07),('15529','2013-04-10','10:25:00',1.36),('15529','2013-04-10','10:30:00',1.09),('15529','2013-04-10','10:45:00',2),('15529','2013-04-10','10:50:00',2.12),('15529','2013-04-10','10:55:00',2.24),('15529','2013-04-10','11:00:00',1.81),('15529','2013-04-10','11:05:00',1.02),('15529','2013-04-10','11:10:00',1.6),('15529','2013-04-10','11:15:00',2.24),('15529','2013-04-10','11:20:00',2.29),('15529','2013-04-10','11:25:00',1.6),('15529','2013-04-10','11:35:00',1.06),('15529','2013-04-10','11:40:00',2.33),('15529','2013-04-10','11:50:00',1.07),('15529','2013-04-10','11:55:00',2.52),('15529','2013-04-10','12:00:00',2.26),('15529','2013-04-10','12:05:00',2.03),('15529','2013-04-10','12:10:00',2.39),('15529','2013-04-10','12:15:00',2.38),('15529','2013-04-10','12:20:00',2.33),('15529','2013-04-10','12:25:00',2.13),('15529','2013-04-10','12:30:00',1.28),('15529','2013-04-10','12:35:00',2.49),('15529','2013-04-10','12:40:00',2.43),('15529','2013-04-10','12:45:00',2.48),('15529','2013-04-10','12:50:00',2.47),('15529','2013-04-10','13:00:00',2.51),('15529','2013-04-10','13:05:00',2.56),('15529','2013-04-10','13:10:00',1.75),('15529','2013-04-10','13:15:00',2.1),('15529','2013-04-10','13:20:00',2.02),('15529','2013-04-10','13:25:00',2.5),('15529','2013-04-10','13:30:00',2.47),('15529','2013-04-10','13:35:00',2.44),('15529','2013-04-10','13:40:00',1.98),('15529','2013-04-10','13:45:00',2.4),('15529','2013-04-10','13:50:00',2.35),('15529','2013-04-10','13:55:00',2.35),('15529','2013-04-10','14:00:00',2.02),('15529','2013-04-10','14:05:00',2.34),('15529','2013-04-10','14:10:00',2.33),('15529','2013-04-10','14:15:00',2.34),('15529','2013-04-10','14:20:00',2.27),('15529','2013-04-10','14:25:00',2.26),('15529','2013-04-10','14:30:00',2.26),('15529','2013-04-10','14:35:00',2.25),('15529','2013-04-10','14:40:00',2.19),('15529','2013-04-10','14:45:00',2.24),('15529','2013-04-10','14:50:00',2.14),('15529','2013-04-10','14:55:00',1.98),('15529','2013-04-10','15:00:00',2.11),('15529','2013-04-10','15:05:00',2.07),('15529','2013-04-10','15:10:00',2.05),('15529','2013-04-10','15:15:00',2.02),('15529','2013-04-10','15:20:00',2),('15529','2013-04-10','15:25:00',1.94),('15529','2013-04-10','15:30:00',1.93),('15529','2013-04-10','15:35:00',1.9),('15529','2013-04-10','15:40:00',1.86),('15529','2013-04-10','15:45:00',1.83),('15529','2013-04-10','15:50:00',1.8),('15529','2013-04-10','15:55:00',1.76),('15529','2013-04-10','16:00:00',1.74),('15529','2013-04-10','16:05:00',1.7),('15529','2013-04-10','16:10:00',1.67),('15529','2013-04-10','16:15:00',1.63),('15529','2013-04-10','16:20:00',1.59),('15529','2013-04-10','16:25:00',1.55),('15529','2013-04-10','16:30:00',1.5),('15529','2013-04-10','16:35:00',1.46),('15529','2013-04-10','16:40:00',1.41),('15529','2013-04-10','16:45:00',1.37),('15529','2013-04-10','16:50:00',1.33),('15529','2013-04-10','16:55:00',1.27),('15529','2013-04-10','17:00:00',1.23),('15529','2013-04-10','17:05:00',1.19),('15529','2013-04-10','17:10:00',1.13),('15529','2013-04-10','17:15:00',1.08),('15529','2013-04-10','17:20:00',1.03),('15529','2013-04-09','08:50:00',1.08),('15529','2013-04-09','08:55:00',1.15),('15529','2013-04-09','09:00:00',1.23),('15529','2013-04-09','09:05:00',1.35),('15529','2013-04-09','09:10:00',1.35),('15529','2013-04-09','09:15:00',1.19),('15529','2013-04-09','09:20:00',1.08),('15529','2013-04-09','09:25:00',1.34),('15529','2013-04-09','09:30:00',1.4),('15529','2013-04-09','09:35:00',1.44),('15529','2013-04-09','09:40:00',1.5),('15529','2013-04-09','09:45:00',1.55),('15529','2013-04-09','09:50:00',1.59),('15529','2013-04-09','09:55:00',1.65),('15529','2013-04-09','10:00:00',1.7),('15529','2013-04-09','10:05:00',1.77),('15529','2013-04-09','10:10:00',1.87),('15529','2013-04-09','10:15:00',1.91),('15529','2013-04-09','10:20:00',1.94),('15529','2013-04-09','10:25:00',1.95),('15529','2013-04-09','10:30:00',1.95),('15529','2013-04-09','10:35:00',1.97),('15529','2013-04-09','10:40:00',1.99),('15529','2013-04-09','10:45:00',2.02),('15529','2013-04-09','10:50:00',1.81),('15529','2013-04-09','10:55:00',1.98),('15529','2013-04-09','11:00:00',1.96),('15529','2013-04-09','11:05:00',1.93),('15529','2013-04-09','11:10:00',2.02),('15529','2013-04-09','11:15:00',2.02),('15529','2013-04-09','11:20:00',2.13),('15529','2013-04-09','11:25:00',2.22),('15529','2013-04-09','11:30:00',1.62),('15529','2013-04-09','11:35:00',2.34),('15529','2013-04-09','11:40:00',2.27),('15529','2013-04-09','11:45:00',2.28),('15529','2013-04-09','11:50:00',2.31),('15529','2013-04-09','11:55:00',2.1),('15529','2013-04-09','12:00:00',2.19),('15529','2013-04-09','12:05:00',2.21),('15529','2013-04-09','12:10:00',2.48),('15529','2013-04-09','12:15:00',2.54),('15529','2013-04-09','12:20:00',2.02),('15529','2013-04-09','12:25:00',2.62),('15529','2013-04-09','12:30:00',2.25),('15529','2013-04-09','12:35:00',2.46),('15529','2013-04-09','12:40:00',1.88),('15529','2013-04-09','12:45:00',1.85),('15529','2013-04-09','12:50:00',1.26),('15529','2013-04-09','12:55:00',2.02),('15529','2013-04-09','13:00:00',1.55),('15529','2013-04-09','13:05:00',2.6),('15529','2013-04-09','13:10:00',2.31),('15529','2013-04-09','13:15:00',2.26),('15529','2013-04-09','13:20:00',1.81),('15529','2013-04-09','13:25:00',1.79),('15529','2013-04-09','13:30:00',2.42),('15529','2013-04-09','13:35:00',2.09),('15529','2013-04-09','13:40:00',2.02),('15529','2013-04-09','13:45:00',1.53),('15529','2013-04-09','13:50:00',1.53),('15529','2013-04-09','13:55:00',2.39),('15529','2013-04-09','14:00:00',2.32),('15529','2013-04-09','14:05:00',1.99),('15529','2013-04-09','14:10:00',2.27),('15529','2013-04-09','14:15:00',2.03),('15529','2013-04-09','14:20:00',1.13),('15529','2013-04-09','14:25:00',1.65),('15529','2013-04-09','14:30:00',1.55),('15529','2013-04-09','14:35:00',1.39),('15529','2013-04-09','14:40:00',1.54),('15529','2013-04-09','14:45:00',1.98),('15529','2013-04-09','14:50:00',1.87),('15529','2013-04-09','14:55:00',1.91),('15529','2013-04-09','15:00:00',2.2),('15529','2013-04-09','15:05:00',2.14),('15529','2013-04-09','15:10:00',2.1),('15529','2013-04-09','15:15:00',2.07),('15529','2013-04-09','15:20:00',1.65),('15529','2013-04-09','15:25:00',2.01),('15529','2013-04-09','15:30:00',1.94),('15529','2013-04-09','15:35:00',1.94),('15529','2013-04-09','15:40:00',1.89),('15529','2013-04-09','15:45:00',1.84),('15529','2013-04-09','15:50:00',1.41),('15529','2013-04-09','15:55:00',1.75),('15529','2013-04-09','16:00:00',1.81),('15529','2013-04-09','16:05:00',1.76),('15529','2013-04-09','16:10:00',1.58),('15529','2013-04-09','16:15:00',1.69),('15529','2013-04-09','16:20:00',1.63),('15529','2013-04-09','16:25:00',1.59),('15529','2013-04-09','16:30:00',1.59),('15529','2013-04-09','16:35:00',1.56),('15529','2013-04-09','16:40:00',1.47),('15529','2013-04-09','16:45:00',1.32),('15529','2013-04-09','16:50:00',1.34),('15529','2013-04-09','16:55:00',1.15),('15529','2013-04-09','17:00:00',1.16),('15529','2013-04-09','17:05:00',1.06),('15529','2013-04-09','17:15:00',1.11),('15529','2013-04-08','09:40:00',1.05),('15529','2013-04-08','09:45:00',1.28),('15529','2013-04-08','09:50:00',1.57),('15529','2013-04-08','09:55:00',1.24),('15529','2013-04-08','10:30:00',1.4),('15529','2013-04-08','10:35:00',2.06),('15529','2013-04-08','10:40:00',1.56),('15529','2013-04-08','10:45:00',2.13),('15529','2013-04-08','10:50:00',2.22),('15529','2013-04-08','10:55:00',1.11),('15529','2013-04-08','11:00:00',1.14),('15529','2013-04-08','11:05:00',2.15),('15529','2013-04-08','11:15:00',1.28),('15529','2013-04-08','11:20:00',2.02),('15529','2013-04-08','11:40:00',1.66),('15529','2013-04-08','11:45:00',2.66),('15529','2013-04-08','11:50:00',1.37),('15529','2013-04-08','11:55:00',2.59),('15529','2013-04-08','12:00:00',2.52),('15529','2013-04-08','12:05:00',1.35),('15529','2013-04-08','12:10:00',2.15),('15529','2013-04-08','12:15:00',2.09),('15529','2013-04-08','12:20:00',2.17),('15529','2013-04-08','12:25:00',2.07),('15529','2013-04-08','12:30:00',2.07),('15529','2013-04-08','12:35:00',2.11),('15529','2013-04-08','12:40:00',2.03),('15529','2013-04-08','12:45:00',2.53),('15529','2013-04-08','12:50:00',2.53),('15529','2013-04-08','12:55:00',2.51),('15529','2013-04-08','13:00:00',1.89),('15529','2013-04-08','13:05:00',2.15),('15529','2013-04-08','13:10:00',2.81),('15529','2013-04-08','13:15:00',2.69),('15529','2013-04-08','13:20:00',2.19),('15529','2013-04-08','13:25:00',1.84),('15529','2013-04-08','13:30:00',1.65),('15529','2013-04-08','13:35:00',1.71),('15529','2013-04-08','13:40:00',1.32),('15529','2013-04-08','13:45:00',1.66),('15529','2013-04-08','13:50:00',2.34),('15529','2013-04-08','13:55:00',1.67),('15529','2013-04-08','14:00:00',2.34),('15529','2013-04-08','14:05:00',2.09),('15529','2013-04-08','14:10:00',1.25),('15529','2013-04-08','14:15:00',2.14),('15529','2013-04-08','14:20:00',1.9),('15529','2013-04-08','14:25:00',1.82),('15529','2013-04-08','14:30:00',2.19),('15529','2013-04-08','14:35:00',2.11),('15529','2013-04-08','14:40:00',2.12),('15529','2013-04-08','14:45:00',1.96),('15529','2013-04-08','14:50:00',2.04),('15529','2013-04-08','14:55:00',2.22),('15529','2013-04-08','15:00:00',2.24),('15529','2013-04-08','15:05:00',2.15),('15529','2013-04-08','15:10:00',2.1),('15529','2013-04-08','15:15:00',2.15),('15529','2013-04-08','15:20:00',2.15),('15529','2013-04-08','15:25:00',2.11),('15529','2013-04-08','15:30:00',1.79),('15529','2013-04-08','15:35:00',1.44),('15529','2013-04-08','15:40:00',1.99),('15529','2013-04-08','15:45:00',2.01),('15529','2013-04-08','15:50:00',1.95),('15529','2013-04-08','15:55:00',1.46),('15529','2013-04-08','16:00:00',1.47),('15529','2013-04-08','16:05:00',1.87),('15529','2013-04-08','16:10:00',1.82),('15529','2013-04-08','16:15:00',1.65),('15529','2013-04-08','16:30:00',1.51),('15529','2013-04-08','16:45:00',1.03),('15529','2013-04-08','16:50:00',1.35),('15529','2013-04-07','09:15:00',1.33),('15529','2013-04-07','09:20:00',1.31),('15529','2013-04-07','09:25:00',1.43),('15529','2013-04-07','09:30:00',1.48),('15529','2013-04-07','09:35:00',1.59),('15529','2013-04-07','09:40:00',1.51),('15529','2013-04-07','09:45:00',1.39),('15529','2013-04-07','09:55:00',1.34),('15529','2013-04-07','10:00:00',1.72),('15529','2013-04-07','10:05:00',1.56),('15529','2013-04-07','10:10:00',1.76),('15529','2013-04-07','10:15:00',1.77),('15529','2013-04-07','10:20:00',1.81),('15529','2013-04-07','10:25:00',1.78),('15529','2013-04-07','10:30:00',1.82),('15529','2013-04-07','10:35:00',1.73),('15529','2013-04-07','10:40:00',1.98),('15529','2013-04-07','10:45:00',2.02),('15529','2013-04-07','10:50:00',2.03),('15529','2013-04-07','10:55:00',1.92),('15529','2013-04-07','11:00:00',1.88),('15529','2013-04-07','11:05:00',1.75),('15529','2013-04-07','11:10:00',1.62),('15529','2013-04-07','11:15:00',1.32),('15529','2013-04-07','11:20:00',1.13),('15529','2013-04-07','11:25:00',1.09),('15529','2013-04-07','11:30:00',1.46),('15529','2013-04-07','11:35:00',1.73),('15529','2013-04-07','11:40:00',1.62),('15529','2013-04-07','11:45:00',1.47),('15529','2013-04-07','11:50:00',1.26),('15529','2013-04-07','11:55:00',1.21),('15529','2013-04-07','12:00:00',1.08),('15529','2013-04-07','12:05:00',1.12),('15529','2013-04-07','12:10:00',1.36),('15529','2013-04-07','12:15:00',1.52),('15529','2013-04-07','12:20:00',1.49),('15529','2013-04-07','12:25:00',1.51),('15529','2013-04-07','12:30:00',1.7),('15529','2013-04-07','12:35:00',1.54),('15529','2013-04-07','12:40:00',1.91),('15529','2013-04-07','12:45:00',1.56),('15529','2013-04-07','12:50:00',1.15),('15529','2013-04-07','12:55:00',1.84),('15529','2013-04-07','13:00:00',1.47),('15529','2013-04-07','13:05:00',1.21),('15529','2013-04-07','13:10:00',1.44),('15529','2013-04-07','13:15:00',1.81),('15529','2013-04-07','13:20:00',1.93),('15529','2013-04-07','13:25:00',1.63),('15529','2013-04-07','13:30:00',1.51),('15529','2013-04-07','13:35:00',1.93),('15529','2013-04-07','13:40:00',1.91),('15529','2013-04-07','13:45:00',1.54),('15529','2013-04-07','13:50:00',2.04),('15529','2013-04-07','13:55:00',2.26),('15529','2013-04-07','14:00:00',1.81),('15529','2013-04-07','14:05:00',1.67),('15529','2013-04-07','14:10:00',1.78),('15529','2013-04-07','14:15:00',2.17),('15529','2013-04-07','14:20:00',1.91),('15529','2013-04-07','14:25:00',2.2),('15529','2013-04-07','14:30:00',2.1),('15529','2013-04-07','14:35:00',1.89),('15529','2013-04-07','14:40:00',2.04),('15529','2013-04-07','14:45:00',2.08),('15529','2013-04-07','14:50:00',2.1),('15529','2013-04-07','14:55:00',1.9),('15529','2013-04-07','15:00:00',1.53),('15529','2013-04-07','15:05:00',1.9),('15529','2013-04-07','15:10:00',1.74),('15529','2013-04-07','15:15:00',1.44),('15529','2013-04-07','15:20:00',1.87),('15529','2013-04-07','15:25:00',2.1),('15529','2013-04-07','15:30:00',2.01),('15529','2013-04-07','15:35:00',1.94),('15529','2013-04-07','15:40:00',1.91),('15529','2013-04-07','15:45:00',1.86),('15529','2013-04-07','15:50:00',1.82),('15529','2013-04-07','15:55:00',1.79),('15529','2013-04-07','16:00:00',1.77),('15529','2013-04-07','16:05:00',1.62),('15529','2013-04-07','16:10:00',1.61),('15529','2013-04-07','16:15:00',1.66),('15529','2013-04-07','16:20:00',1.62),('15529','2013-04-07','16:25:00',1.55),('15529','2013-04-07','16:30:00',1.53),('15529','2013-04-07','16:35:00',1.47),('15529','2013-04-07','16:40:00',1.46),('15529','2013-04-07','16:45:00',1.41),('15529','2013-04-07','16:50:00',1.36),('15529','2013-04-07','16:55:00',1.32),('15529','2013-04-07','17:00:00',1.28),('15529','2013-04-07','17:05:00',1.21),('15529','2013-04-07','17:10:00',1.13),('15529','2013-04-07','17:15:00',1.07),('15529','2013-04-07','17:20:00',1.03),('15529','2013-04-07','17:25:00',1.04),('15529','2013-04-06','09:40:00',1.02),('15529','2013-04-06','09:55:00',1.02),('15529','2013-04-06','10:00:00',1.2),('15529','2013-04-06','10:05:00',1.28),('15529','2013-04-06','10:10:00',1.46),('15529','2013-04-06','10:15:00',1.54),('15529','2013-04-06','10:20:00',1.54),('15529','2013-04-06','10:25:00',1.67),('15529','2013-04-06','10:30:00',1.67),('15529','2013-04-06','10:35:00',1.5),('15529','2013-04-06','10:40:00',1.44),('15529','2013-04-06','10:45:00',1.53),('15529','2013-04-06','10:50:00',1.54),('15529','2013-04-06','11:00:00',1.26),('15529','2013-04-06','11:05:00',1.15),('15529','2013-04-06','11:10:00',1.09),('15529','2013-04-06','11:15:00',1.07),('15529','2013-04-06','11:20:00',1.46),('15529','2013-04-06','11:25:00',1.98),('15529','2013-04-06','11:30:00',2.07),('15529','2013-04-06','11:35:00',2.12),('15529','2013-04-06','11:40:00',1.97),('15529','2013-04-06','11:45:00',1.85),('15529','2013-04-06','11:50:00',1.42),('15529','2013-04-06','11:55:00',1.27),('15529','2013-04-06','12:00:00',1.38),('15529','2013-04-06','12:05:00',1.33),('15529','2013-04-06','12:10:00',1.36),('15529','2013-04-06','12:15:00',1.44),('15529','2013-04-06','12:20:00',1.46),('15529','2013-04-06','12:25:00',1.6),('15529','2013-04-06','12:30:00',1.68),('15529','2013-04-06','12:35:00',1.48),('15529','2013-04-06','12:40:00',1.79),('15529','2013-04-06','12:45:00',1.51),('15529','2013-04-06','12:50:00',1.49),('15529','2013-04-06','12:55:00',1.39),('15529','2013-04-06','13:00:00',1.51),('15529','2013-04-06','13:05:00',1.65),('15529','2013-04-06','13:10:00',1.65),('15529','2013-04-06','13:15:00',1.62),('15529','2013-04-06','13:20:00',1.54),('15529','2013-04-06','13:25:00',1.6),('15529','2013-04-06','13:30:00',1.71),('15529','2013-04-06','13:35:00',1.85),('15529','2013-04-06','13:40:00',1.75),('15529','2013-04-06','13:45:00',1.52),('15529','2013-04-06','13:50:00',1.3),('15529','2013-04-06','13:55:00',1.49),('15529','2013-04-06','14:00:00',1.67),('15529','2013-04-06','14:05:00',1.98),('15529','2013-04-06','14:10:00',1.84),('15529','2013-04-06','14:15:00',1.71),('15529','2013-04-06','14:20:00',1.2),('15529','2013-04-06','15:20:00',1.27),('15529','2013-04-06','15:25:00',1.33),('15529','2013-04-06','15:30:00',1.37),('15529','2013-04-06','15:35:00',1.38),('15529','2013-04-06','15:40:00',1.4),('15529','2013-04-06','15:45:00',1.42),('15529','2013-04-06','15:50:00',1.41),('15529','2013-04-06','15:55:00',1.29),('15529','2013-04-06','16:00:00',1.12),('15529','2013-04-06','16:40:00',1.06),('15529','2013-04-06','16:45:00',1.23),('15529','2013-04-06','17:05:00',1.18),('15529','2013-04-06','17:25:00',1.07),('15529','2013-04-05','08:55:00',1.03),('15529','2013-04-05','09:00:00',1.09),('15529','2013-04-05','09:05:00',1.14),('15529','2013-04-05','09:10:00',1.19),('15529','2013-04-05','09:15:00',1.23),('15529','2013-04-05','09:20:00',1.28),('15529','2013-04-05','09:25:00',1.32),('15529','2013-04-05','09:30:00',1.36),('15529','2013-04-05','09:35:00',1.38),('15529','2013-04-05','09:40:00',1.44),('15529','2013-04-05','09:45:00',1.5),('15529','2013-04-05','09:50:00',1.54),('15529','2013-04-05','09:55:00',1.58),('15529','2013-04-05','10:00:00',1.61),('15529','2013-04-05','10:05:00',1.65),('15529','2013-04-05','10:10:00',1.69),('15529','2013-04-05','10:15:00',1.72),('15529','2013-04-05','10:20:00',1.76),('15529','2013-04-05','10:25:00',1.79),('15529','2013-04-05','10:30:00',1.79),('15529','2013-04-05','10:35:00',1.84),('15529','2013-04-05','10:40:00',1.86),('15529','2013-04-05','10:45:00',1.89),('15529','2013-04-05','10:50:00',1.93),('15529','2013-04-05','10:55:00',1.97),('15529','2013-04-05','11:00:00',1.98),('15529','2013-04-05','11:05:00',2.03),('15529','2013-04-05','11:10:00',2.06),('15529','2013-04-05','11:15:00',2.08),('15529','2013-04-05','11:20:00',2.11),('15529','2013-04-05','11:25:00',2.13),('15529','2013-04-05','11:30:00',1.94),('15529','2013-04-05','11:35:00',1.5),('15529','2013-04-05','11:40:00',2.21),('15529','2013-04-05','11:45:00',2.25),('15529','2013-04-05','11:50:00',2.18),('15529','2013-04-05','11:55:00',2.21),('15529','2013-04-05','12:00:00',2.2),('15529','2013-04-05','12:05:00',2.08),('15529','2013-04-05','12:10:00',2.29),('15529','2013-04-05','12:15:00',2.33),('15529','2013-04-05','12:20:00',2.31),('15529','2013-04-05','12:25:00',2.37),('15529','2013-04-05','12:30:00',2.36),('15529','2013-04-05','12:35:00',2.05),('15529','2013-04-05','12:40:00',2.15),('15529','2013-04-05','12:45:00',2.23),('15529','2013-04-05','12:50:00',1.87),('15529','2013-04-05','12:55:00',2.59),('15529','2013-04-05','13:00:00',2.52),('15529','2013-04-05','13:05:00',2.53),('15529','2013-04-05','13:15:00',1.31),('15529','2013-04-05','13:35:00',1.54),('15529','2013-04-05','13:40:00',1.01),('15529','2013-04-05','13:45:00',1.41),('15529','2013-04-05','13:55:00',1.34),('15529','2013-04-05','14:00:00',2.49),('15529','2013-04-05','14:05:00',2.3),('15529','2013-04-05','14:15:00',2.06),('15529','2013-04-05','14:20:00',2.03),('15529','2013-04-05','14:25:00',1.74),('15529','2013-04-05','14:35:00',2.23),('15529','2013-04-05','14:40:00',2.26),('15529','2013-04-05','14:45:00',2.27),('15529','2013-04-05','14:50:00',2.19),('15529','2013-04-05','14:55:00',1.9),('15529','2013-04-05','15:00:00',2.1),('15529','2013-04-05','15:05:00',2.05),('15529','2013-04-05','15:10:00',2),('15529','2013-04-05','15:15:00',1.98),('15529','2013-04-05','15:20:00',1.97),('15529','2013-04-05','15:25:00',1.95),('15529','2013-04-05','15:30:00',1.83),('15529','2013-04-05','15:35:00',1.81),('15529','2013-04-05','15:40:00',1.73),('15529','2013-04-05','15:45:00',1.67),('15529','2013-04-05','15:50:00',1.8),('15529','2013-04-05','15:55:00',1.72),('15529','2013-04-05','16:00:00',1.74),('15529','2013-04-05','16:05:00',1.76),('15529','2013-04-05','16:10:00',1.73),('15529','2013-04-05','16:15:00',1.6),('15529','2013-04-05','16:20:00',1.3),('15529','2013-04-05','16:25:00',1.23),('15529','2013-04-05','16:30:00',1.13),('15529','2013-04-05','16:35:00',1.13),('15529','2013-04-05','16:40:00',1.17),('15529','2013-04-05','16:45:00',1.32),('15529','2013-04-05','16:50:00',1.27),('15529','2013-04-05','16:55:00',1.18),('15529','2013-04-05','17:00:00',1.06),('15529','2013-04-04','09:15:00',1.16),('15529','2013-04-04','09:40:00',1.09),('15529','2013-04-04','10:10:00',1.52),('15529','2013-04-04','10:15:00',1.56),('15529','2013-04-04','10:20:00',1.84),('15529','2013-04-04','10:25:00',2.05),('15529','2013-04-04','10:30:00',1.94),('15529','2013-04-04','10:35:00',1.95),('15529','2013-04-04','10:40:00',1.4),('15529','2013-04-04','10:50:00',1.41),('15529','2013-04-04','10:55:00',1.95),('15529','2013-04-04','11:00:00',1.75),('15529','2013-04-04','11:05:00',1.84),('15529','2013-04-04','11:10:00',1.77),('15529','2013-04-04','11:15:00',2.03),('15529','2013-04-04','11:20:00',1.71),('15529','2013-04-04','11:25:00',1.74),('15529','2013-04-04','11:30:00',1.79),('15529','2013-04-04','11:35:00',2.36),('15529','2013-04-04','11:40:00',2.27),('15529','2013-04-04','11:45:00',2.03),('15529','2013-04-04','11:50:00',2.22),('15529','2013-04-04','11:55:00',2.12),('15529','2013-04-04','12:00:00',1.39),('15529','2013-04-04','12:05:00',1.26),('15529','2013-04-04','12:10:00',1.46),('15529','2013-04-04','12:20:00',1.21),('15529','2013-04-04','12:25:00',1.07),('15529','2013-04-04','12:40:00',1.03),('15529','2013-04-04','12:45:00',2.02),('15529','2013-04-04','12:50:00',2.49),('15529','2013-04-04','12:55:00',1.97),('15529','2013-04-04','13:00:00',1.89),('15529','2013-04-04','13:05:00',1.14),('15529','2013-04-04','13:10:00',1.51),('15529','2013-04-04','13:15:00',1.13),('15529','2013-04-04','13:20:00',1.8),('15529','2013-04-04','13:25:00',1.01),('15529','2013-04-04','13:30:00',1.23),('15529','2013-04-04','13:35:00',2.49),('15529','2013-04-04','13:40:00',2.57),('15529','2013-04-04','13:45:00',2.47),('15529','2013-04-04','13:50:00',2.03),('15529','2013-04-04','13:55:00',2.48),('15529','2013-04-04','14:00:00',1.61),('15529','2013-04-04','14:05:00',1.98),('15529','2013-04-04','14:10:00',2.2),('15529','2013-04-04','14:15:00',1.28),('15529','2013-04-04','14:20:00',1.31),('15529','2013-04-04','14:25:00',1.82),('15529','2013-04-04','14:30:00',2.45),('15529','2013-04-04','14:35:00',1.63),('15529','2013-04-04','14:40:00',2.21),('15529','2013-04-04','14:45:00',1.78),('15529','2013-04-04','14:50:00',1.29),('15529','2013-04-04','15:00:00',1.04),('15529','2013-04-04','15:05:00',1.11),('15529','2013-04-04','16:50:00',1.06),('15529','2013-04-04','17:05:00',1.69),('15529','2013-04-04','17:10:00',1.43),('15529','2013-04-04','17:20:00',1.25),('15529','2013-04-04','17:25:00',1.12),('15529','2013-04-03','09:00:00',1.01),('15529','2013-04-03','09:30:00',1),('15529','2013-04-03','09:35:00',1.38),('15529','2013-04-03','09:40:00',1.04),('15529','2013-04-03','10:00:00',1.02),('15529','2013-04-03','10:05:00',1.23),('15529','2013-04-03','10:20:00',1.17),('15529','2013-04-03','10:25:00',1.9),('15529','2013-04-03','10:30:00',1.29),('15529','2013-04-03','10:35:00',1.18),('15529','2013-04-03','10:40:00',1.79),('15529','2013-04-03','10:50:00',1.42),('15529','2013-04-03','10:55:00',2.08),('15529','2013-04-03','11:35:00',1.07),('15529','2013-04-03','11:40:00',1.72),('15529','2013-04-03','11:45:00',1.91),('15529','2013-04-03','11:50:00',2.12),('15529','2013-04-03','11:55:00',2.2),('15529','2013-04-03','12:00:00',1.65),('15529','2013-04-03','12:05:00',2.19),('15529','2013-04-03','12:10:00',2.1),('15529','2013-04-03','12:15:00',2.12),('15529','2013-04-03','12:20:00',1.63),('15529','2013-04-03','12:25:00',1.86),('15529','2013-04-03','12:30:00',2.06),('15529','2013-04-03','12:35:00',1.94),('15529','2013-04-03','12:40:00',1.63),('15529','2013-04-03','12:45:00',1.44),('15529','2013-04-03','12:50:00',2.25),('15529','2013-04-03','12:55:00',2.05),('15529','2013-04-03','13:00:00',2.09),('15529','2013-04-03','13:05:00',2.17),('15529','2013-04-03','13:10:00',2.2),('15529','2013-04-03','13:15:00',2.24),('15529','2013-04-03','13:20:00',2.18),('15529','2013-04-03','13:25:00',2.25),('15529','2013-04-03','13:30:00',2.16),('15529','2013-04-03','13:35:00',1.94),('15529','2013-04-03','13:40:00',1.75),('15529','2013-04-03','13:45:00',1.76),('15529','2013-04-03','13:50:00',1.71),('15529','2013-04-03','13:55:00',1.28),('15529','2013-04-03','14:00:00',1.51),('15529','2013-04-03','14:05:00',2),('15529','2013-04-03','14:10:00',2.13),('15529','2013-04-03','14:15:00',2.13),('15529','2013-04-03','14:20:00',2.09),('15529','2013-04-03','14:25:00',2.05),('15529','2013-04-03','14:30:00',2.07),('15529','2013-04-03','14:35:00',2.07),('15529','2013-04-03','14:40:00',2.04),('15529','2013-04-03','14:45:00',1.98),('15529','2013-04-03','14:50:00',2.03),('15529','2013-04-03','14:55:00',2),('15529','2013-04-03','15:00:00',1.94),('15529','2013-04-03','15:05:00',1.85),('15529','2013-04-03','15:10:00',1.71),('15529','2013-04-03','15:15:00',1.82),('15529','2013-04-03','15:20:00',1.79),('15529','2013-04-03','15:25:00',1.84),('15529','2013-04-03','15:30:00',1.8),('15529','2013-04-03','15:35:00',1.75),('15529','2013-04-03','15:40:00',1.69),('15529','2013-04-03','15:45:00',1.64),('15529','2013-04-03','15:50:00',1.6),('15529','2013-04-03','15:55:00',1.6),('15529','2013-04-03','16:00:00',1.56),('15529','2013-04-03','16:05:00',1.48),('15529','2013-04-03','16:10:00',1.44),('15529','2013-04-03','16:15:00',1.25),('15529','2013-04-03','16:20:00',1.32),('15529','2013-04-03','16:25:00',1.26),('15529','2013-04-03','16:30:00',1.03),('15529','2013-04-03','16:40:00',1.14),('15529','2013-04-02','08:55:00',1.05),('15529','2013-04-02','09:00:00',1.14),('15529','2013-04-02','09:05:00',1.02),('15529','2013-04-02','09:10:00',1.09),('15529','2013-04-02','09:15:00',1.17),('15529','2013-04-02','09:25:00',1.21),('15529','2013-04-02','09:30:00',1.55),('15529','2013-04-02','09:35:00',1.44),('15529','2013-04-02','09:40:00',1.55),('15529','2013-04-02','09:45:00',1.65),('15529','2013-04-02','09:50:00',1.49),('15529','2013-04-02','09:55:00',1.22),('15529','2013-04-02','10:10:00',1.43),('15529','2013-04-02','10:15:00',1.23),('15529','2013-04-02','10:20:00',1.68),('15529','2013-04-02','10:25:00',1.81),('15529','2013-04-02','10:30:00',2.09),('15529','2013-04-02','10:35:00',1.07),('15529','2013-04-02','10:50:00',1.3),('15529','2013-04-02','10:55:00',2.27),('15529','2013-04-02','11:00:00',2.35),('15529','2013-04-02','11:05:00',2.53),('15529','2013-04-02','11:10:00',2.09),('15529','2013-04-02','11:15:00',1.25),('15529','2013-04-02','11:25:00',1.12),('15529','2013-04-02','11:30:00',1.16),('15529','2013-04-02','11:40:00',1.32),('15529','2013-04-02','11:45:00',1.56),('15529','2013-04-02','11:50:00',1.18),('15529','2013-04-02','11:55:00',1.22),('15529','2013-04-02','12:00:00',2.04),('15529','2013-04-02','12:05:00',2.51),('15529','2013-04-02','12:10:00',2.49),('15529','2013-04-02','12:15:00',1.74),('15529','2013-04-02','12:20:00',2.49),('15529','2013-04-02','12:25:00',2.62),('15529','2013-04-02','12:30:00',2.31),('15529','2013-04-02','12:35:00',2.63),('15529','2013-04-02','12:40:00',2.16),('15529','2013-04-02','12:45:00',2.27),('15529','2013-04-02','12:50:00',2.11),('15529','2013-04-02','12:55:00',2.04),('15529','2013-04-02','13:00:00',2.03),('15529','2013-04-02','13:05:00',2.27),('15529','2013-04-02','13:10:00',2.43),('15529','2013-04-02','13:15:00',1.23),('15529','2013-04-02','13:20:00',1.71),('15529','2013-04-02','13:25:00',2.11),('15529','2013-04-02','13:30:00',2.12),('15529','2013-04-02','13:35:00',1.81),('15529','2013-04-02','13:40:00',2.1),('15529','2013-04-02','13:45:00',2.49),('15529','2013-04-02','13:50:00',2.02),('15529','2013-04-02','13:55:00',1.86),('15529','2013-04-02','14:00:00',2.43),('15529','2013-04-02','14:05:00',2.29),('15529','2013-04-02','14:10:00',1.19),('15529','2013-04-02','14:15:00',1.57),('15529','2013-04-02','14:20:00',2.12),('15529','2013-04-02','14:25:00',2.09),('15529','2013-04-02','14:30:00',1.55),('15529','2013-04-02','14:35:00',2.27),('15529','2013-04-02','14:40:00',1.39),('15529','2013-04-02','14:45:00',2.55),('15529','2013-04-02','14:50:00',2.51),('15529','2013-04-02','14:55:00',2.25),('15529','2013-04-02','15:00:00',2.32),('15529','2013-04-02','15:05:00',1.89),('15529','2013-04-02','15:10:00',2.37),('15529','2013-04-02','15:15:00',2.02),('15529','2013-04-02','15:20:00',2.19),('15529','2013-04-02','15:25:00',1.8),('15529','2013-04-02','15:30:00',1.46),('15529','2013-04-02','15:35:00',1.46),('15529','2013-04-02','15:40:00',1.5),('15529','2013-04-02','15:45:00',1.88),('15529','2013-04-02','15:50:00',2.13),('15529','2013-04-02','15:55:00',1.29),('15529','2013-04-02','16:00:00',1.31),('15529','2013-04-02','16:05:00',1.76),('15529','2013-04-02','16:10:00',1.85),('15529','2013-04-02','16:15:00',1.79),('15529','2013-04-02','16:20:00',1.71),('15529','2013-04-02','16:25:00',1.67),('15529','2013-04-02','16:30:00',1.65),('15529','2013-04-02','16:35:00',1.58),('15529','2013-04-02','16:40:00',1.49),('15529','2013-04-02','16:45:00',1.47),('15529','2013-04-02','16:50:00',1.43),('15529','2013-04-02','16:55:00',1.38),('15529','2013-04-02','17:00:00',1.33),('15529','2013-04-02','17:05:00',1.28),('15529','2013-04-02','17:10:00',1.2),('15529','2013-04-02','17:15:00',1.15),('15529','2013-04-02','17:20:00',1.09),('15529','2013-04-02','17:25:00',1.04),('15529','2013-04-01','09:00:00',1.1),('15529','2013-04-01','09:05:00',1.15),('15529','2013-04-01','09:10:00',1.2),('15529','2013-04-01','09:15:00',1.26),('15529','2013-04-01','09:20:00',1.29),('15529','2013-04-01','09:25:00',1.32),('15529','2013-04-01','09:30:00',1.07),('15529','2013-04-01','09:35:00',1.6),('15529','2013-04-01','09:40:00',1.57),('15529','2013-04-01','09:50:00',1.02),('15529','2013-04-01','09:55:00',1.59),('15529','2013-04-01','10:00:00',1.02),('15529','2013-04-01','10:10:00',1.27),('15529','2013-04-01','10:20:00',1.67),('15529','2013-04-01','10:35:00',2.07),('15529','2013-04-01','10:40:00',1.03),('15529','2013-04-01','10:45:00',1.29),('15529','2013-04-01','10:50:00',2.01),('15529','2013-04-01','11:00:00',1.18),('15529','2013-04-01','11:05:00',1.67),('15529','2013-04-01','11:20:00',1.89),('15529','2013-04-01','11:25:00',1.43),('15529','2013-04-01','11:30:00',2.22),('15529','2013-04-01','11:35:00',1.69),('15529','2013-04-01','12:05:00',2.02),('15529','2013-04-01','12:10:00',2.38),('15529','2013-04-01','12:35:00',1.24),('15529','2013-04-01','12:40:00',1.07),('15529','2013-04-01','12:45:00',1.65),('15529','2013-04-01','12:50:00',1.13),('15529','2013-04-01','12:55:00',1.67),('15529','2013-04-01','13:00:00',1.48),('15529','2013-04-01','13:05:00',1.41),('15529','2013-04-01','13:10:00',1.24),('15529','2013-04-01','13:15:00',1.14),('15529','2013-04-01','13:25:00',1.14),('15529','2013-04-01','13:30:00',1.04),('15529','2013-04-01','13:35:00',1.19),('15529','2013-04-01','13:40:00',1.62),('15529','2013-04-01','13:45:00',1.21),('15529','2013-04-01','14:05:00',1.48),('15529','2013-04-01','14:10:00',1.37),('15529','2013-04-01','14:15:00',1.41),('15529','2013-04-01','14:20:00',1.91),('15529','2013-04-01','14:25:00',2.45),('15529','2013-04-01','14:30:00',1.5),('15529','2013-04-01','14:35:00',1.33),('15529','2013-04-01','14:40:00',2.1),('15529','2013-04-01','14:45:00',1.53),('15529','2014-05-01','09:20:00',1.26),('15529','2014-05-01','09:25:00',1.05),('15529','2014-05-01','09:30:00',1.03),('15529','2014-05-01','09:35:00',1.23),('15529','2014-05-01','09:40:00',1.03),('15529','2014-05-01','10:00:00',1.14),('15529','2014-05-01','12:45:00',1.08),('15529','2014-05-01','12:50:00',1.01),('15529','2014-05-01','13:10:00',1.2),('15529','2014-05-01','13:15:00',2.21),('15529','2014-05-01','13:20:00',1.89),('15529','2014-05-01','13:25:00',1.85),('15529','2014-05-01','13:30:00',1.81),('15529','2014-05-01','13:35:00',1.25),('15529','2014-05-01','13:40:00',1.64),('15529','2014-05-01','13:45:00',1.44),('15529','2014-05-01','14:30:00',1.34),('15529','2014-05-01','14:35:00',1.15),('15529','2014-05-01','14:40:00',1.07),('15529','2014-05-01','14:55:00',1.31),('15529','2014-05-01','15:00:00',1.06),('15529','2014-05-01','15:05:00',1.36),('15529','2014-05-01','15:10:00',1.49),('15529','2014-05-01','15:15:00',1.19),('15529','2014-05-01','15:20:00',1.08),('15529','2014-05-01','15:55:00',1.06),('15529','2014-03-26','10:20:00',1.4),('15529','2014-03-26','10:25:00',1.41),('15529','2014-03-26','11:10:00',1.09),('15529','2014-03-26','13:10:00',1.13),('15529','2014-03-26','13:15:00',1.23),('15529','2014-03-26','13:20:00',1.2),('15529','2014-03-26','13:25:00',1.27),('15529','2014-03-26','13:35:00',1.01),('15529','2014-03-26','13:50:00',1.3),('15529','2014-03-26','13:55:00',1.51),('15529','2014-03-26','14:00:00',1.4),('15529','2014-03-26','14:15:00',1.12),('15529','2014-03-26','14:20:00',2.41),('15529','2014-03-26','14:25:00',1.02),('15529','2014-03-26','14:30:00',1.57),('15529','2014-03-26','14:35:00',1.85),('15529','2014-03-26','14:40:00',1.85),('15529','2014-03-26','14:55:00',1.73),('15529','2014-03-26','15:25:00',1.01),('15529','2014-03-26','15:30:00',1.14),('15529','2013-03-31','09:00:00',1.1),('15529','2013-03-31','09:05:00',1.14),('15529','2013-03-31','09:10:00',1.22),('15529','2013-03-31','09:15:00',1.15),('15529','2013-03-31','09:20:00',1.08),('15529','2013-03-31','09:25:00',1.24),('15529','2013-03-31','09:35:00',1.2),('15529','2013-03-31','09:40:00',1.37),('15529','2013-03-31','09:45:00',1.47),('15529','2013-03-31','09:50:00',1.52),('15529','2013-03-31','09:55:00',1.49),('15529','2013-03-31','10:00:00',1.63),('15529','2013-03-31','10:05:00',1.67),('15529','2013-03-31','10:10:00',1.45),('15529','2013-03-31','10:15:00',1.72),('15529','2013-03-31','10:20:00',1.85),('15529','2013-03-31','10:25:00',1.98),('15529','2013-03-31','10:30:00',1.86),('15529','2013-03-31','10:35:00',1.61),('15529','2013-03-31','10:40:00',1.57),('15529','2013-03-31','10:45:00',1.88),('15529','2013-03-31','10:50:00',2.11),('15529','2013-03-31','10:55:00',2.08),('15529','2013-03-31','11:00:00',1.77),('15529','2013-03-31','11:15:00',1.45),('15529','2013-03-31','11:20:00',1.22),('15529','2013-03-31','11:25:00',1.51),('15529','2013-03-31','11:30:00',1.28),('15529','2013-03-31','11:35:00',1.14),('15529','2013-03-31','11:40:00',1.27),('15529','2013-03-31','11:45:00',1.07),('15529','2013-03-31','11:50:00',1.12),('15529','2013-03-31','12:00:00',1.41),('15529','2013-03-31','12:30:00',1.39),('15529','2013-03-31','12:35:00',1.2),('15529','2013-03-31','12:40:00',1.3),('15529','2013-03-31','12:45:00',1.43),('15529','2013-03-31','12:50:00',1.58),('15529','2013-03-31','12:55:00',1.49),('15529','2013-03-31','13:00:00',1.63),('15529','2013-03-31','13:05:00',1.62),('15529','2013-03-31','13:10:00',1.48),('15529','2013-03-31','13:15:00',1.65),('15529','2013-03-31','13:20:00',1.52),('15529','2013-03-31','13:25:00',1.48),('15529','2013-03-31','13:30:00',1.54),('15529','2013-03-31','13:35:00',1.42),('15529','2013-03-31','13:40:00',2.01),('15529','2013-03-31','13:45:00',2),('15529','2013-03-31','13:50:00',2.28),('15529','2013-03-31','13:55:00',1.94),('15529','2013-03-31','14:00:00',1.01),('15529','2013-03-31','14:10:00',1.29);
INSERT INTO `solarlog` VALUES ('15529','2013-03-31','14:15:00',1.32),('15529','2013-03-31','14:20:00',1.62),('15529','2013-03-31','14:25:00',2.2),('15529','2013-03-31','14:30:00',1.24),('15529','2013-03-31','14:35:00',1.09),('15529','2013-03-31','14:45:00',1.02),('15529','2013-03-31','14:50:00',1.11),('15529','2013-03-31','14:55:00',1.04),('15529','2013-03-31','15:10:00',1.02),('15529','2013-03-31','15:15:00',1.09),('15529','2013-03-31','15:20:00',1.18),('15529','2013-03-31','15:25:00',1.14),('15529','2013-03-31','15:30:00',1.14),('15529','2013-03-31','15:35:00',1.3),('15529','2013-03-31','15:40:00',1.11),('15529','2013-03-31','15:45:00',1.27),('15529','2013-03-31','15:50:00',1.34),('15529','2013-03-30','09:20:00',1.36),('15529','2013-03-30','09:25:00',1.54),('15529','2013-03-30','09:30:00',1.23),('15529','2013-03-30','09:35:00',1.22),('15529','2013-03-30','09:40:00',1.47),('15529','2013-03-30','09:55:00',1.31),('15529','2013-03-30','10:20:00',1.1),('15529','2013-03-30','10:25:00',1.28),('15529','2013-03-30','10:30:00',1.2),('15529','2013-03-30','11:45:00',1.11),('15529','2013-03-30','12:30:00',1.11),('15529','2013-03-30','12:35:00',2.25),('15529','2013-03-30','12:40:00',2.24),('15529','2013-03-30','12:50:00',1.2),('15529','2013-03-30','12:55:00',1.23),('15529','2013-03-30','13:00:00',1.25),('15529','2013-03-30','13:05:00',1.05),('15529','2013-03-30','13:10:00',1.94),('15529','2013-03-30','13:15:00',2.45),('15529','2013-03-30','13:20:00',2.71),('15529','2013-03-30','13:25:00',1.09),('15529','2013-03-30','13:40:00',1.39),('15529','2013-03-30','13:50:00',1.1),('15529','2013-03-30','13:55:00',1.29),('15529','2013-03-30','14:00:00',1.74),('15529','2013-03-30','14:05:00',1.26),('15529','2013-03-30','14:10:00',1.76),('15529','2013-03-30','14:15:00',1.52),('15529','2013-03-30','14:20:00',1.09),('15529','2013-03-30','14:30:00',1.77),('15529','2013-03-30','14:35:00',2.12),('15529','2013-03-30','14:40:00',2.6),('15529','2013-03-30','14:45:00',2.37),('15529','2013-03-30','14:50:00',2.1),('15529','2013-03-30','14:55:00',2.42),('15529','2013-03-30','15:00:00',1.83),('15529','2013-03-30','15:05:00',2.1),('15529','2013-03-30','15:10:00',1.4),('15529','2013-03-30','15:15:00',2.2),('15529','2013-03-30','15:20:00',2.02),('15529','2013-03-30','15:25:00',1.47),('15529','2013-03-30','15:30:00',1.59),('15529','2013-03-30','15:35:00',2.36),('15529','2013-03-30','15:40:00',1.81),('15529','2013-03-30','15:45:00',1.06),('15529','2013-03-30','16:00:00',1.02),('15529','2013-03-30','16:10:00',1.47),('15529','2013-03-30','16:15:00',1.44),('15529','2013-03-29','09:05:00',1.42),('15529','2013-03-29','09:10:00',1.04),('15529','2013-03-29','09:15:00',1.55),('15529','2013-03-29','09:20:00',1.48),('15529','2013-03-29','10:35:00',1.03),('15529','2013-03-29','10:40:00',1.18),('15529','2013-03-29','10:45:00',1.31),('15529','2013-03-29','10:50:00',1.19),('15529','2013-03-29','10:55:00',1.49),('15529','2013-03-29','11:00:00',1.8),('15529','2013-03-29','11:05:00',1.94),('15529','2013-03-29','11:10:00',2.01),('15529','2013-03-29','11:15:00',2.61),('15529','2013-03-29','11:20:00',2.01),('15529','2013-03-29','11:30:00',1.82),('15529','2013-03-29','11:35:00',1.7),('15529','2013-03-29','11:40:00',2.02),('15529','2013-03-29','11:45:00',1.58),('15529','2013-03-29','11:50:00',1.65),('15529','2013-03-29','11:55:00',1.98),('15529','2013-03-29','12:00:00',1.84),('15529','2013-03-29','12:05:00',1.1),('15529','2013-03-29','13:40:00',1.41),('15529','2013-03-29','13:45:00',1.4),('15529','2013-03-29','13:50:00',1.15),('15529','2013-03-28','08:15:00',1.15),('15529','2013-03-28','08:20:00',1.21),('15529','2013-03-28','08:25:00',1.26),('15529','2013-03-28','08:30:00',1.33),('15529','2013-03-28','08:35:00',1.39),('15529','2013-03-28','08:40:00',1.42),('15529','2013-03-28','08:45:00',1.41),('15529','2013-03-28','08:50:00',1.38),('15529','2013-03-28','08:55:00',1.21),('15529','2013-03-28','09:00:00',1.5),('15529','2013-03-28','09:05:00',1.52),('15529','2013-03-28','09:10:00',1.44),('15529','2013-03-28','09:15:00',1.68),('15529','2013-03-28','09:20:00',1.73),('15529','2013-03-28','09:25:00',1.41),('15529','2013-03-28','09:30:00',1.77),('15529','2013-03-28','09:35:00',1.13),('15529','2013-03-28','09:40:00',1.78),('15529','2013-03-28','09:45:00',1.6),('15529','2013-03-28','09:50:00',1.52),('15529','2013-03-28','09:55:00',1.89),('15529','2013-03-28','10:00:00',1.79),('15529','2013-03-28','10:05:00',1.61),('15529','2013-03-28','10:10:00',1.57),('15529','2013-03-28','10:15:00',1.68),('15529','2013-03-28','10:20:00',1.38),('15529','2013-03-28','10:25:00',1.48),('15529','2013-03-28','10:30:00',1.71),('15529','2013-03-28','10:35:00',1.04),('15529','2013-03-28','10:40:00',1.65),('15529','2013-03-28','10:45:00',1.86),('15529','2013-03-28','10:50:00',2.08),('15529','2013-03-28','10:55:00',1.44),('15529','2013-03-28','11:00:00',2.06),('15529','2013-03-28','11:05:00',1.56),('15529','2013-03-28','11:10:00',1.97),('15529','2013-03-28','11:15:00',2.05),('15529','2013-03-28','11:20:00',2.41),('15529','2013-03-28','11:25:00',2.36),('15529','2013-03-28','11:30:00',2.32),('15529','2013-03-28','11:35:00',2.27),('15529','2013-03-28','11:40:00',2.37),('15529','2013-03-28','11:45:00',2.41),('15529','2013-03-28','11:50:00',2.41),('15529','2013-03-28','11:55:00',2.41),('15529','2013-03-28','12:00:00',2.37),('15529','2013-03-28','12:05:00',2.44),('15529','2013-03-28','12:10:00',2.37),('15529','2013-03-28','12:15:00',2.32),('15529','2013-03-28','12:20:00',2.35),('15529','2013-03-28','12:25:00',2.29),('15529','2013-03-28','12:30:00',2.3),('15529','2013-03-28','12:35:00',2.25),('15529','2013-03-28','12:40:00',2.05),('15529','2013-03-28','12:45:00',2.41),('15529','2013-03-28','12:50:00',2.33),('15529','2013-03-28','12:55:00',2.27),('15529','2013-03-28','13:00:00',2.14),('15529','2013-03-28','13:05:00',2.14),('15529','2013-03-28','13:10:00',2.19),('15529','2013-03-28','13:15:00',2.24),('15529','2013-03-28','13:20:00',2.35),('15529','2013-03-28','13:25:00',2.48),('15529','2013-03-28','13:30:00',1.94),('15529','2013-03-28','13:35:00',1.7),('15529','2013-03-28','13:40:00',1.73),('15529','2013-03-28','13:45:00',1.88),('15529','2013-03-28','13:50:00',1.86),('15529','2013-03-28','13:55:00',1.96),('15529','2013-03-28','14:00:00',1.97),('15529','2013-03-28','14:05:00',1.42),('15529','2013-03-28','14:10:00',1.31),('15529','2013-03-28','14:15:00',1.32),('15529','2013-03-28','14:20:00',1.32),('15529','2013-03-28','14:25:00',1.38),('15529','2013-03-28','14:30:00',1.11),('15529','2013-03-28','14:35:00',1.05),('15529','2013-03-28','14:40:00',1.02),('15529','2013-03-28','16:40:00',1.05),('15529','2013-03-27','09:15:00',1.07),('15529','2013-03-27','12:50:00',1.14),('15529','2013-03-27','12:55:00',1.22),('15529','2013-03-27','13:00:00',1.89),('15529','2013-03-27','13:05:00',1.42),('15529','2013-03-27','13:10:00',1.97),('15529','2013-03-27','13:15:00',1.18),('15529','2013-03-27','13:20:00',2.29),('15529','2013-03-27','13:25:00',1.53),('15529','2013-03-27','13:30:00',2.19),('15529','2013-03-27','13:45:00',1.03),('15529','2013-03-27','15:10:00',1.61),('15529','2013-03-27','15:15:00',1.58),('15529','2013-03-27','15:20:00',1.17),('15529','2013-03-26','07:55:00',1.02),('15529','2013-03-26','09:20:00',1.16),('15529','2013-03-26','09:45:00',1.16),('15529','2013-03-26','10:30:00',1.1),('15529','2013-03-26','10:35:00',1.19),('15529','2013-03-26','10:40:00',1.28),('15529','2013-03-26','10:45:00',1.17),('15529','2013-03-26','10:50:00',1.19),('15529','2013-03-26','11:30:00',1.14),('15529','2013-03-26','11:50:00',1.06),('15529','2013-03-26','11:55:00',1.5),('15529','2013-03-26','12:00:00',1.41),('15529','2013-03-26','12:05:00',1.41),('15529','2013-03-26','12:10:00',1.35),('15529','2013-03-26','12:15:00',1.25),('15529','2013-03-26','12:20:00',1.11),('15529','2013-03-26','12:25:00',1.14),('15529','2013-03-26','12:30:00',1.78),('15529','2013-03-26','12:35:00',2.47),('15529','2013-03-26','12:40:00',1.56),('15529','2013-03-26','12:45:00',1.86),('15529','2013-03-26','12:55:00',1.02),('15529','2013-03-26','14:35:00',1.06),('15529','2013-03-26','14:40:00',1.27),('15529','2013-03-25','09:10:00',1.01),('15529','2013-03-25','09:50:00',1.36),('15529','2013-03-25','12:00:00',1.26),('15529','2013-03-25','12:25:00',1.42),('15529','2013-03-25','12:30:00',1.17),('15529','2013-03-25','12:45:00',1.13),('15529','2013-03-25','13:00:00',1.36),('15529','2013-03-25','13:10:00',1.06),('15529','2013-03-25','13:20:00',1.22),('15529','2013-03-25','13:25:00',1.06),('15529','2013-03-25','13:30:00',1.31),('15529','2013-03-25','13:35:00',1.54),('15529','2013-03-25','13:40:00',1.33),('15529','2013-03-24','08:25:00',1.37),('15529','2013-03-24','09:50:00',1.42),('15529','2013-03-24','10:15:00',1.17),('15529','2013-03-24','10:20:00',1.36),('15529','2013-03-24','10:25:00',1.27),('15529','2013-03-24','10:45:00',1.65),('15529','2013-03-24','10:50:00',2.16),('15529','2013-03-24','10:55:00',2.14),('15529','2013-03-24','11:00:00',1.22),('15529','2013-03-24','11:15:00',1.61),('15529','2013-03-24','11:20:00',1.19),('15529','2013-03-24','11:25:00',2.23),('15529','2013-03-24','11:30:00',1.4),('15529','2013-03-24','11:50:00',1.13),('15529','2013-03-24','11:55:00',2.54),('15529','2013-03-24','12:00:00',1.87),('15529','2013-03-24','12:05:00',1.45),('15529','2013-03-24','12:10:00',2.57),('15529','2013-03-24','12:15:00',2.62),('15529','2013-03-24','12:20:00',2.78),('15529','2013-03-24','12:25:00',2.53),('15529','2013-03-24','12:30:00',2.02),('15529','2013-03-24','12:35:00',1.69),('15529','2013-03-24','12:40:00',1.44),('15529','2013-03-24','12:45:00',1.51),('15529','2013-03-24','12:50:00',1.54),('15529','2013-03-24','12:55:00',2.05),('15529','2013-03-24','13:00:00',2.54),('15529','2013-03-24','13:05:00',1.89),('15529','2013-03-24','13:15:00',1.62),('15529','2013-03-24','13:40:00',1.05),('15529','2013-03-24','14:05:00',1.86),('15529','2013-03-24','14:10:00',1.55),('15529','2013-03-24','14:15:00',1.78),('15529','2013-03-24','14:20:00',2.13),('15529','2013-03-24','14:25:00',1.94),('15529','2013-03-24','14:30:00',1.9),('15529','2013-03-24','14:35:00',1.53),('15529','2013-03-24','14:40:00',1.11),('15529','2013-03-24','14:45:00',1.49),('15529','2013-03-24','14:50:00',1.13),('15529','2013-03-24','14:55:00',1.25),('15529','2013-03-24','15:00:00',2.08),('15529','2013-03-24','15:05:00',1.17),('15529','2013-03-24','15:10:00',1.82),('15529','2013-03-24','15:15:00',1.93),('15529','2013-03-24','15:20:00',1.43),('15529','2013-03-24','15:25:00',1.41),('15529','2013-03-24','15:30:00',1.54),('15529','2013-03-24','15:35:00',1.45),('15529','2013-03-24','15:40:00',1.52),('15529','2013-03-24','15:50:00',1.03),('15529','2013-03-24','15:55:00',1.32),('15529','2013-03-24','16:30:00',1.08),('15529','2013-03-23','08:10:00',1.03),('15529','2013-03-23','08:15:00',1.11),('15529','2013-03-23','08:20:00',1.17),('15529','2013-03-23','08:25:00',1.22),('15529','2013-03-23','08:30:00',1.26),('15529','2013-03-23','08:35:00',1.31),('15529','2013-03-23','08:40:00',1.35),('15529','2013-03-23','08:45:00',1.38),('15529','2013-03-23','08:50:00',1.4),('15529','2013-03-23','08:55:00',1.44),('15529','2013-03-23','09:00:00',1.48),('15529','2013-03-23','09:05:00',1.52),('15529','2013-03-23','09:10:00',1.58),('15529','2013-03-23','09:15:00',1.61),('15529','2013-03-23','09:20:00',1.64),('15529','2013-03-23','09:25:00',1.69),('15529','2013-03-23','09:30:00',1.73),('15529','2013-03-23','09:35:00',1.76),('15529','2013-03-23','09:40:00',1.78),('15529','2013-03-23','09:45:00',1.82),('15529','2013-03-23','09:50:00',1.83),('15529','2013-03-23','09:55:00',1.85),('15529','2013-03-23','10:00:00',1.89),('15529','2013-03-23','10:05:00',1.93),('15529','2013-03-23','10:10:00',1.95),('15529','2013-03-23','10:15:00',1.96),('15529','2013-03-23','10:20:00',1.99),('15529','2013-03-23','10:25:00',2.02),('15529','2013-03-23','10:30:00',2.05),('15529','2013-03-23','10:35:00',2.07),('15529','2013-03-23','10:40:00',2.09),('15529','2013-03-23','10:45:00',2.11),('15529','2013-03-23','10:50:00',2.14),('15529','2013-03-23','10:55:00',2.15),('15529','2013-03-23','11:00:00',2.12),('15529','2013-03-23','11:05:00',2.15),('15529','2013-03-23','11:10:00',2.15),('15529','2013-03-23','11:15:00',2.15),('15529','2013-03-23','11:20:00',2.17),('15529','2013-03-23','11:25:00',2.2),('15529','2013-03-23','11:30:00',2.22),('15529','2013-03-23','11:35:00',2.22),('15529','2013-03-23','11:40:00',2.22),('15529','2013-03-23','11:45:00',2.21),('15529','2013-03-23','11:50:00',2.23),('15529','2013-03-23','11:55:00',2.24),('15529','2013-03-23','12:00:00',2.27),('15529','2013-03-23','12:05:00',2.27),('15529','2013-03-23','12:10:00',2.27),('15529','2013-03-23','12:15:00',2.29),('15529','2013-03-23','12:20:00',2.29),('15529','2013-03-23','12:25:00',2.34),('15529','2013-03-23','12:30:00',2.36),('15529','2013-03-23','12:35:00',2.36),('15529','2013-03-23','12:40:00',2.36),('15529','2013-03-23','12:45:00',2.34),('15529','2013-03-23','12:50:00',2.35),('15529','2013-03-23','12:55:00',2.32),('15529','2013-03-23','13:00:00',2.31),('15529','2013-03-23','13:05:00',2.3),('15529','2013-03-23','13:10:00',2.28),('15529','2013-03-23','13:15:00',2.28),('15529','2013-03-23','13:20:00',2.25),('15529','2013-03-23','13:25:00',2.22),('15529','2013-03-23','13:30:00',2.2),('15529','2013-03-23','13:35:00',2.18),('15529','2013-03-23','13:40:00',2.19),('15529','2013-03-23','13:45:00',2.18),('15529','2013-03-23','13:50:00',2.16),('15529','2013-03-23','13:55:00',2.11),('15529','2013-03-23','14:00:00',2.11),('15529','2013-03-23','14:05:00',2.05),('15529','2013-03-23','14:10:00',2.04),('15529','2013-03-23','14:15:00',2),('15529','2013-03-23','14:20:00',1.96),('15529','2013-03-23','14:25:00',1.91),('15529','2013-03-23','14:30:00',1.83),('15529','2013-03-23','14:35:00',1.82),('15529','2013-03-23','14:40:00',1.81),('15529','2013-03-23','14:45:00',1.78),('15529','2013-03-23','14:50:00',1.71),('15529','2013-03-23','14:55:00',1.72),('15529','2013-03-23','15:00:00',1.65),('15529','2013-03-23','15:05:00',1.64),('15529','2013-03-23','15:10:00',1.52),('15529','2013-03-23','15:15:00',1.61),('15529','2013-03-23','15:20:00',1.56),('15529','2013-03-23','15:25:00',1.45),('15529','2013-03-23','15:30:00',1.36),('15529','2013-03-23','15:35:00',1.28),('15529','2013-03-23','15:40:00',1.25),('15529','2013-03-22','08:05:00',1.04),('15529','2013-03-22','08:10:00',1.08),('15529','2013-03-22','08:15:00',1.14),('15529','2013-03-22','08:20:00',1.17),('15529','2013-03-22','08:25:00',1.22),('15529','2013-03-22','08:30:00',1.24),('15529','2013-03-22','08:35:00',1.29),('15529','2013-03-22','08:40:00',1.36),('15529','2013-03-22','08:45:00',1.4),('15529','2013-03-22','08:50:00',1.45),('15529','2013-03-22','08:55:00',1.53),('15529','2013-03-22','09:00:00',1.57),('15529','2013-03-22','09:05:00',1.62),('15529','2013-03-22','09:10:00',1.63),('15529','2013-03-22','09:15:00',1.7),('15529','2013-03-22','09:20:00',1.74),('15529','2013-03-22','09:25:00',1.77),('15529','2013-03-22','09:30:00',1.81),('15529','2013-03-22','09:35:00',1.84),('15529','2013-03-22','09:40:00',1.8),('15529','2013-03-22','09:45:00',1.88),('15529','2013-03-22','09:50:00',1.87),('15529','2013-03-22','09:55:00',1.91),('15529','2013-03-22','10:00:00',1.91),('15529','2013-03-22','10:05:00',1.93),('15529','2013-03-22','10:10:00',1.99),('15529','2013-03-22','10:15:00',1.98),('15529','2013-03-22','10:20:00',1.97),('15529','2013-03-22','10:25:00',2.02),('15529','2013-03-22','10:30:00',2.09),('15529','2013-03-22','10:35:00',2.11),('15529','2013-03-22','10:40:00',2.07),('15529','2013-03-22','10:45:00',2.08),('15529','2013-03-22','10:50:00',2.06),('15529','2013-03-22','10:55:00',1.99),('15529','2013-03-22','11:00:00',2.02),('15529','2013-03-22','11:05:00',1.81),('15529','2013-03-22','11:10:00',1.74),('15529','2013-03-22','11:15:00',1.68),('15529','2013-03-22','11:20:00',2.03),('15529','2013-03-22','11:25:00',2.08),('15529','2013-03-22','11:30:00',2.11),('15529','2013-03-22','11:35:00',2.19),('15529','2013-03-22','11:40:00',2.17),('15529','2013-03-22','11:45:00',2.19),('15529','2013-03-22','11:50:00',2.16),('15529','2013-03-22','11:55:00',2.22),('15529','2013-03-22','12:00:00',2.23),('15529','2013-03-22','12:05:00',2.25),('15529','2013-03-22','12:10:00',2.25),('15529','2013-03-22','12:15:00',2.25),('15529','2013-03-22','12:20:00',2.29),('15529','2013-03-22','12:25:00',2.25),('15529','2013-03-22','12:30:00',2.24),('15529','2013-03-22','12:35:00',2.25),('15529','2013-03-22','12:40:00',2.17),('15529','2013-03-22','12:45:00',2.21),('15529','2013-03-22','12:50:00',2.23),('15529','2013-03-22','12:55:00',2.12),('15529','2013-03-22','13:00:00',1.86),('15529','2013-03-22','13:05:00',2.25),('15529','2013-03-22','13:10:00',2.27),('15529','2013-03-22','13:15:00',2.11),('15529','2013-03-22','13:20:00',2.16),('15529','2013-03-22','13:25:00',2.17),('15529','2013-03-22','13:30:00',2.15),('15529','2013-03-22','13:35:00',2.17),('15529','2013-03-22','13:40:00',2.13),('15529','2013-03-22','13:45:00',2.11),('15529','2013-03-22','13:50:00',2.09),('15529','2013-03-22','13:55:00',2.09),('15529','2013-03-22','14:00:00',2.05),('15529','2013-03-22','14:05:00',2.06),('15529','2013-03-22','14:10:00',1.98),('15529','2013-03-22','14:15:00',1.93),('15529','2013-03-22','14:20:00',1.98),('15529','2013-03-22','14:25:00',1.94),('15529','2013-03-22','14:30:00',1.91),('15529','2013-03-22','14:35:00',1.88),('15529','2013-03-22','14:40:00',1.81),('15529','2013-03-22','14:45:00',1.69),('15529','2013-03-22','14:50:00',1.68),('15529','2013-03-22','14:55:00',1.69),('15529','2013-03-22','15:00:00',1.67),('15529','2013-03-22','15:05:00',1.54),('15529','2013-03-22','15:10:00',1.59),('15529','2013-03-22','15:15:00',1.45),('15529','2013-03-22','15:20:00',1.52),('15529','2013-03-22','15:25:00',1.46),('15529','2013-03-22','15:30:00',1.33),('15529','2013-03-22','15:35:00',1.33),('15529','2013-03-22','15:40:00',1.27),('15529','2013-03-22','15:45:00',1.14),('15529','2013-03-22','15:50:00',1.11),('15529','2013-03-22','15:55:00',1.05),('15529','2013-03-22','16:10:00',1.12),('15529','2014-03-25','08:00:00',1.02),('15529','2014-03-25','08:05:00',1.09),('15529','2014-03-25','08:10:00',1.17),('15529','2014-03-25','08:15:00',1.35),('15529','2014-03-25','09:20:00',1.46),('15529','2014-03-25','09:25:00',1.66),('15529','2014-03-25','09:30:00',1.85),('15529','2014-03-25','09:35:00',1.87),('15529','2014-03-25','09:40:00',1.89),('15529','2014-03-25','09:45:00',1.91),('15529','2014-03-25','09:50:00',1.95),('15529','2014-03-25','09:55:00',1.98),('15529','2014-03-25','10:00:00',2.03),('15529','2014-03-25','10:05:00',2.09),('15529','2014-03-25','10:10:00',2.14),('15529','2014-03-25','10:15:00',2.06),('15529','2014-03-25','10:20:00',1.05),('15529','2014-03-25','10:25:00',2),('15529','2014-03-25','10:30:00',1.13),('15529','2014-03-25','10:45:00',2.2),('15529','2014-03-25','10:50:00',1.28),('15529','2014-03-25','11:05:00',1.37),('15529','2014-03-25','11:10:00',1.31),('15529','2014-03-25','11:15:00',1.18),('15529','2014-03-25','11:35:00',1.39),('15529','2014-03-25','11:40:00',2.67),('15529','2014-03-25','11:45:00',2.9),('15529','2014-03-25','11:50:00',2.61),('15529','2014-03-25','11:55:00',2.81),('15529','2014-03-25','12:00:00',2.82),('15529','2014-03-25','12:05:00',2.57),('15529','2014-03-25','12:10:00',1.47),('15529','2014-03-25','12:40:00',1.14),('15529','2014-03-25','12:45:00',1.03),('15529','2014-03-25','12:50:00',1.34),('15529','2014-03-25','12:55:00',1.29),('15529','2014-03-25','13:00:00',2.41),('15529','2014-03-25','13:05:00',2.33),('15529','2014-03-25','13:10:00',2.13),('15529','2014-03-25','13:15:00',2.54),('15529','2014-03-25','13:20:00',2.4),('15529','2014-03-25','13:25:00',2.26),('15529','2014-03-25','13:30:00',1.75),('15529','2014-03-25','13:35:00',1.01),('15529','2014-03-25','13:40:00',1.92),('15529','2014-03-25','13:45:00',1.68),('15529','2014-03-25','13:50:00',2.27),('15529','2014-03-25','13:55:00',2.62),('15529','2014-03-25','14:00:00',2.56),('15529','2014-03-25','14:05:00',1.16),('15529','2014-03-25','14:45:00',1.33),('15529','2014-03-25','14:50:00',1.73),('15529','2014-03-25','14:55:00',1.91),('15529','2014-03-25','15:00:00',1.74),('15529','2014-03-25','15:05:00',1.6),('15529','2014-03-25','15:10:00',1.72),('15529','2014-03-25','15:15:00',1.72),('15529','2014-03-25','15:20:00',1.79),('15529','2014-03-25','15:25:00',1.62),('15529','2014-03-25','15:30:00',1.71),('15529','2014-03-25','15:35:00',1.62),('15529','2014-03-25','15:40:00',1.32),('15529','2014-03-25','15:45:00',1.24),('15529','2013-03-21','08:10:00',1.06),('15529','2013-03-21','08:15:00',1.12),('15529','2013-03-21','08:20:00',1.18),('15529','2013-03-21','08:25:00',1.24),('15529','2013-03-21','08:30:00',1.29),('15529','2013-03-21','08:35:00',1.34),('15529','2013-03-21','08:40:00',1.39),('15529','2013-03-21','08:45:00',1.43),('15529','2013-03-21','08:50:00',1.47),('15529','2013-03-21','08:55:00',1.5),('15529','2013-03-21','09:00:00',1.53),('15529','2013-03-21','09:05:00',1.59),('15529','2013-03-21','09:10:00',1.64),('15529','2013-03-21','09:15:00',1.68),('15529','2013-03-21','09:20:00',1.71),('15529','2013-03-21','09:25:00',1.73),('15529','2013-03-21','09:30:00',1.77),('15529','2013-03-21','09:35:00',1.81),('15529','2013-03-21','09:40:00',1.86),('15529','2013-03-21','09:45:00',1.86),('15529','2013-03-21','09:50:00',1.9),('15529','2013-03-21','09:55:00',1.95),('15529','2013-03-21','10:00:00',1.96),('15529','2013-03-21','10:05:00',1.98),('15529','2013-03-21','10:10:00',2.03),('15529','2013-03-21','10:15:00',2.05),('15529','2013-03-21','10:20:00',2.08),('15529','2013-03-21','10:25:00',2.11),('15529','2013-03-21','10:30:00',2.12),('15529','2013-03-21','10:35:00',2.14),('15529','2013-03-21','10:40:00',2.17),('15529','2013-03-21','10:45:00',2.18),('15529','2013-03-21','10:50:00',2.2),('15529','2013-03-21','10:55:00',2.23),('15529','2013-03-21','11:00:00',2.24),('15529','2013-03-21','11:05:00',2.25),('15529','2013-03-21','11:10:00',2.31),('15529','2013-03-21','11:15:00',2.31),('15529','2013-03-21','11:20:00',2.3),('15529','2013-03-21','11:25:00',2.31),('15529','2013-03-21','11:30:00',2.33),('15529','2013-03-21','11:35:00',2.36),('15529','2013-03-21','11:40:00',2.39),('15529','2013-03-21','11:45:00',2.39),('15529','2013-03-21','11:50:00',2.4),('15529','2013-03-21','11:55:00',2.39),('15529','2013-03-21','12:00:00',2.38),('15529','2013-03-21','12:05:00',2.41),('15529','2013-03-21','12:10:00',2.38),('15529','2013-03-21','12:15:00',2.42),('15529','2013-03-21','12:20:00',2.44),('15529','2013-03-21','12:25:00',2.41),('15529','2013-03-21','12:30:00',2.39),('15529','2013-03-21','12:35:00',2.42),('15529','2013-03-21','12:40:00',2.37),('15529','2013-03-21','12:45:00',2.39),('15529','2013-03-21','12:50:00',2.35),('15529','2013-03-21','12:55:00',2.36),('15529','2013-03-21','13:00:00',2.37),('15529','2013-03-21','13:05:00',2.37),('15529','2013-03-21','13:10:00',2.38),('15529','2013-03-21','13:15:00',2.36),('15529','2013-03-21','13:20:00',2.3),('15529','2013-03-21','13:25:00',2.08),('15529','2013-03-21','13:30:00',2.19),('15529','2013-03-21','13:35:00',2.29),('15529','2013-03-21','13:40:00',2.01),('15529','2013-03-21','13:45:00',2.26),('15529','2013-03-21','13:50:00',2.24),('15529','2013-03-21','13:55:00',2.2),('15529','2013-03-21','14:00:00',2.18),('15529','2013-03-21','14:05:00',2.15),('15529','2013-03-21','14:10:00',2.13),('15529','2013-03-21','14:15:00',2.1),('15529','2013-03-21','14:20:00',2.06),('15529','2013-03-21','14:25:00',2.04),('15529','2013-03-21','14:30:00',1.99),('15529','2013-03-21','14:35:00',1.97),('15529','2013-03-21','14:40:00',1.94),('15529','2013-03-21','14:45:00',1.88),('15529','2013-03-21','14:50:00',1.87),('15529','2013-03-21','14:55:00',1.85),('15529','2013-03-21','15:00:00',1.31),('15529','2013-03-21','15:05:00',1.77),('15529','2013-03-21','15:10:00',1.55),('15529','2013-03-21','15:15:00',1.3),('15529','2013-03-21','15:20:00',1.15),('15529','2013-03-21','15:25:00',1.26),('15529','2013-03-21','15:30:00',1.29),('15529','2013-03-21','15:35:00',1.38),('15529','2013-03-21','15:40:00',1.28),('15529','2013-03-21','15:45:00',1.19),('15529','2013-03-21','15:50:00',1.22),('15529','2013-03-21','15:55:00',1.05),('15529','2013-03-21','16:10:00',1.11),('15529','2013-03-21','16:15:00',1.15),('15529','2013-03-21','16:35:00',1.02),('15529','2013-03-20','07:45:00',1.08),('15529','2013-03-20','08:10:00',1.14),('15529','2013-03-20','08:15:00',1.06),('15529','2013-03-20','08:20:00',1.26),('15529','2013-03-20','08:25:00',1.23),('15529','2013-03-20','08:30:00',1.31),('15529','2013-03-20','08:35:00',1.18),('15529','2013-03-20','08:45:00',1.44),('15529','2013-03-20','08:50:00',1.54),('15529','2013-03-20','08:55:00',1.7),('15529','2013-03-20','09:00:00',1.95),('15529','2013-03-20','09:05:00',1.6),('15529','2013-03-20','09:10:00',1.41),('15529','2013-03-20','09:15:00',1.23),('15529','2013-03-20','09:25:00',1.67),('15529','2013-03-20','09:30:00',1.99),('15529','2013-03-20','09:35:00',1.81),('15529','2013-03-20','09:40:00',1.81),('15529','2013-03-20','09:45:00',2.03),('15529','2013-03-20','09:50:00',2.07),('15529','2013-03-20','09:55:00',2.09),('15529','2013-03-20','10:00:00',2.11),('15529','2013-03-20','10:05:00',2.11),('15529','2013-03-20','10:10:00',2.13),('15529','2013-03-20','10:15:00',2.14),('15529','2013-03-20','10:20:00',2.18),('15529','2013-03-20','10:25:00',2.21),('15529','2013-03-20','10:30:00',2.23),('15529','2013-03-20','10:35:00',2.24),('15529','2013-03-20','10:40:00',2.25),('15529','2013-03-20','10:45:00',2.25),('15529','2013-03-20','10:50:00',2.02),('15529','2013-03-20','10:55:00',1.37),('15529','2013-03-20','11:00:00',2.38),('15529','2013-03-20','11:05:00',2.38),('15529','2013-03-20','11:10:00',2.4),('15529','2013-03-20','11:15:00',2.41),('15529','2013-03-20','11:20:00',2.43),('15529','2013-03-20','11:25:00',2.45),('15529','2013-03-20','11:30:00',2.46),('15529','2013-03-20','11:35:00',2.48),('15529','2013-03-20','11:40:00',2.49),('15529','2013-03-20','11:45:00',2.51),('15529','2013-03-20','11:50:00',2.5),('15529','2013-03-20','11:55:00',2.52),('15529','2013-03-20','12:00:00',2.52),('15529','2013-03-20','12:05:00',2.53),('15529','2013-03-20','12:10:00',2.55),('15529','2013-03-20','12:15:00',2.53),('15529','2013-03-20','12:20:00',2.52),('15529','2013-03-20','12:25:00',2.52),('15529','2013-03-20','12:30:00',2.53),('15529','2013-03-20','12:35:00',2.52),('15529','2013-03-20','12:40:00',2.5),('15529','2013-03-20','12:45:00',2.48),('15529','2013-03-20','12:50:00',2.48),('15529','2013-03-20','12:55:00',2.46),('15529','2013-03-20','13:00:00',2.45),('15529','2013-03-20','13:05:00',2.43),('15529','2013-03-20','13:10:00',2.43),('15529','2013-03-20','13:15:00',2.41),('15529','2013-03-20','13:20:00',2.41),('15529','2013-03-20','13:25:00',2.38),('15529','2013-03-20','13:30:00',2.37),('15529','2013-03-20','13:35:00',2.36),('15529','2013-03-20','13:40:00',2.33),('15529','2013-03-20','13:45:00',2.32),('15529','2013-03-20','13:50:00',2.3),('15529','2013-03-20','13:55:00',2.27),('15529','2013-03-20','14:00:00',2.23),('15529','2013-03-20','14:05:00',2.19),('15529','2013-03-20','14:10:00',2.17),('15529','2013-03-20','14:15:00',2.14),('15529','2013-03-20','14:20:00',2.11),('15529','2013-03-20','14:25:00',2.07),('15529','2013-03-20','14:30:00',2.04),('15529','2013-03-20','14:35:00',2.02),('15529','2013-03-20','14:40:00',1.98),('15529','2013-03-20','14:45:00',1.94),('15529','2013-03-20','14:50:00',1.92),('15529','2013-03-20','14:55:00',1.88),('15529','2013-03-20','15:00:00',1.85),('15529','2013-03-20','15:05:00',1.81),('15529','2013-03-20','15:10:00',1.76),('15529','2013-03-20','15:15:00',1.72),('15529','2013-03-20','15:20:00',1.68),('15529','2013-03-20','15:25:00',1.64),('15529','2013-03-20','15:30:00',1.6),('15529','2013-03-20','15:35:00',1.55),('15529','2013-03-20','15:40:00',1.49),('15529','2013-03-20','15:45:00',1.44),('15529','2013-03-20','15:50:00',1.39),('15529','2013-03-20','15:55:00',1.34),('15529','2013-03-20','16:00:00',1.28),('15529','2013-03-20','16:05:00',1.22),('15529','2013-03-20','16:10:00',1.17),('15529','2013-03-20','16:15:00',1.12),('15529','2013-03-20','16:20:00',1.06),('15529','2013-03-19','08:05:00',1.06),('15529','2013-03-19','08:10:00',1.06),('15529','2013-03-19','08:15:00',1.12),('15529','2013-03-19','08:20:00',1.17),('15529','2013-03-19','08:25:00',1.24),('15529','2013-03-19','08:30:00',1.32),('15529','2013-03-19','08:35:00',1.35),('15529','2013-03-19','08:40:00',1.3),('15529','2013-03-19','08:45:00',1.39),('15529','2013-03-19','08:50:00',1.41),('15529','2013-03-19','08:55:00',1.35),('15529','2013-03-19','09:00:00',1.61),('15529','2013-03-19','09:05:00',1.41),('15529','2013-03-19','09:10:00',1.72),('15529','2013-03-19','09:15:00',1.65),('15529','2013-03-19','09:20:00',1.23),('15529','2013-03-19','09:25:00',1.77),('15529','2013-03-19','09:30:00',1.77),('15529','2013-03-19','09:35:00',1.76),('15529','2013-03-19','09:40:00',1.87),('15529','2013-03-19','09:45:00',1.89),('15529','2013-03-19','09:50:00',1.9),('15529','2013-03-19','09:55:00',1.89),('15529','2013-03-19','10:00:00',1.98),('15529','2013-03-19','10:05:00',1.92),('15529','2013-03-19','10:10:00',1.97),('15529','2013-03-19','10:15:00',1.96),('15529','2013-03-19','10:20:00',1.17),('15529','2013-03-19','10:25:00',1.51),('15529','2013-03-19','10:30:00',2.15),('15529','2013-03-19','10:35:00',2.26),('15529','2013-03-19','10:40:00',1.4),('15529','2013-03-19','10:45:00',1.9),('15529','2013-03-19','10:50:00',1.78),('15529','2013-03-19','10:55:00',1.51),('15529','2013-03-19','11:00:00',1.55),('15529','2013-03-19','11:05:00',1.9),('15529','2013-03-19','11:10:00',1.19),('15529','2013-03-19','11:15:00',1.31),('15529','2013-03-19','11:20:00',1.56),('15529','2013-03-19','11:25:00',1.44),('15529','2013-03-19','11:30:00',1.3),('15529','2013-03-19','11:35:00',1.49),('15529','2013-03-19','11:40:00',1.14),('15529','2013-03-19','11:45:00',1.09),('15529','2013-03-19','11:50:00',1.06),('15529','2013-03-19','11:55:00',1.11),('15529','2013-03-19','12:00:00',1.17),('15529','2013-03-19','12:05:00',1.23),('15529','2013-03-19','12:55:00',1.05),('15529','2013-03-19','14:20:00',1.07),('15529','2013-03-18','08:10:00',1.06),('15529','2013-03-18','08:15:00',1.13),('15529','2013-03-18','08:20:00',1.16),('15529','2013-03-18','08:25:00',1.22),('15529','2013-03-18','08:30:00',1.04),('15529','2013-03-18','08:35:00',1.25),('15529','2013-03-18','08:40:00',1.41),('15529','2013-03-18','08:45:00',1.46),('15529','2013-03-18','08:50:00',1.52),('15529','2013-03-18','08:55:00',1.53),('15529','2013-03-18','09:00:00',1.59),('15529','2013-03-18','09:05:00',1.65),('15529','2013-03-18','09:10:00',1.66),('15529','2013-03-18','09:15:00',1.64),('15529','2013-03-18','09:20:00',1.69),('15529','2013-03-18','09:25:00',1.83),('15529','2013-03-18','09:30:00',1.86),('15529','2013-03-18','09:35:00',1.89),('15529','2013-03-18','09:40:00',1.95),('15529','2013-03-18','09:45:00',1.68),('15529','2013-03-18','09:50:00',1.81),('15529','2013-03-18','09:55:00',2.02),('15529','2013-03-18','10:00:00',1.76),('15529','2013-03-18','10:05:00',1.99),('15529','2013-03-18','10:10:00',2.14),('15529','2013-03-18','10:15:00',2.17),('15529','2013-03-18','10:20:00',2.14),('15529','2013-03-18','10:25:00',2.21),('15529','2013-03-18','10:30:00',2.26),('15529','2013-03-18','10:35:00',2.26),('15529','2013-03-18','10:40:00',2.31),('15529','2013-03-18','10:45:00',2.31),('15529','2013-03-18','10:50:00',2.38),('15529','2013-03-18','10:55:00',2.41),('15529','2013-03-18','11:00:00',2.4),('15529','2013-03-18','11:05:00',2.41),('15529','2013-03-18','11:10:00',2.34),('15529','2013-03-18','11:15:00',2.5),('15529','2013-03-18','11:20:00',2.46),('15529','2013-03-18','11:25:00',2.47),('15529','2013-03-18','11:30:00',2.37),('15529','2013-03-18','11:35:00',1.41),('15529','2013-03-18','11:40:00',2.44),('15529','2013-03-18','11:45:00',2.27),('15529','2013-03-18','11:50:00',2.57),('15529','2013-03-18','11:55:00',2.51),('15529','2013-03-18','12:00:00',2.54),('15529','2013-03-18','12:05:00',2.5),('15529','2013-03-18','12:10:00',2.49),('15529','2013-03-18','12:15:00',2.38),('15529','2013-03-18','12:20:00',2.49),('15529','2013-03-18','12:25:00',2.46),('15529','2013-03-18','12:30:00',2.46),('15529','2013-03-18','12:35:00',2.51),('15529','2013-03-18','12:40:00',2.46),('15529','2013-03-18','12:45:00',2.47),('15529','2013-03-18','12:50:00',2.46),('15529','2013-03-18','12:55:00',2.46),('15529','2013-03-18','13:00:00',2.44),('15529','2013-03-18','13:05:00',2.44),('15529','2013-03-18','13:10:00',2.43),('15529','2013-03-18','13:15:00',2.37),('15529','2013-03-18','13:20:00',2.34),('15529','2013-03-18','13:25:00',2.34),('15529','2013-03-18','13:30:00',2.31),('15529','2013-03-18','13:35:00',2.29),('15529','2013-03-18','13:40:00',2.25),('15529','2013-03-18','13:45:00',2.28),('15529','2013-03-18','13:50:00',2.24),('15529','2013-03-18','13:55:00',2.22),('15529','2013-03-18','14:00:00',2.19),('15529','2013-03-18','14:05:00',2.18),('15529','2013-03-18','14:10:00',2.14),('15529','2013-03-18','14:15:00',2.05),('15529','2013-03-18','14:20:00',2.1),('15529','2013-03-18','14:25:00',2.07),('15529','2013-03-18','14:30:00',2.03),('15529','2013-03-18','14:35:00',2),('15529','2013-03-18','14:40:00',1.97),('15529','2013-03-18','14:45:00',1.92),('15529','2013-03-18','14:50:00',1.89),('15529','2013-03-18','14:55:00',1.85),('15529','2013-03-18','15:00:00',1.84),('15529','2013-03-18','15:05:00',1.78),('15529','2013-03-18','15:10:00',1.71),('15529','2013-03-18','15:15:00',1.71),('15529','2013-03-18','15:20:00',1.66),('15529','2013-03-18','15:25:00',1.62),('15529','2013-03-18','15:30:00',1.58),('15529','2013-03-18','15:35:00',1.54),('15529','2013-03-18','15:40:00',1.48),('15529','2013-03-18','15:45:00',1.44),('15529','2013-03-18','15:50:00',1.39),('15529','2013-03-18','15:55:00',1.32),('15529','2013-03-18','16:00:00',1.26),('15529','2013-03-18','16:05:00',1.22),('15529','2013-03-18','16:10:00',1.17),('15529','2013-03-18','16:15:00',1.12),('15529','2013-03-18','16:20:00',1.06),('15529','2013-03-18','16:25:00',1.01),('15529','2013-03-17','11:15:00',1),('15529','2013-03-17','11:20:00',1.01),('15529','2013-03-17','11:25:00',1.2),('15529','2013-03-17','11:30:00',1.54),('15529','2013-03-17','11:35:00',1.09),('15529','2013-03-17','12:05:00',1.5),('15529','2013-03-17','12:10:00',1.5),('15529','2013-03-17','12:15:00',1.99),('15529','2013-03-17','12:20:00',1.58),('15529','2013-03-17','12:25:00',1.52),('15529','2013-03-17','12:30:00',2.19),('15529','2013-03-17','12:35:00',2.05),('15529','2013-03-17','12:40:00',1.28),('15529','2013-03-17','12:45:00',1.68),('15529','2013-03-17','12:50:00',1.89),('15529','2013-03-17','12:55:00',2.1),('15529','2013-03-17','13:00:00',1.99),('15529','2013-03-17','13:05:00',1.15),('15529','2013-03-17','13:25:00',1.43),('15529','2013-03-17','13:40:00',1.24),('15529','2013-03-17','13:45:00',1.06),('15529','2013-03-17','14:05:00',1.29),('15529','2013-03-17','14:10:00',1.1),('15529','2013-03-16','10:00:00',1.06),('15529','2013-03-16','10:25:00',1.01),('15529','2013-03-16','12:15:00',1.1),('15529','2013-03-16','12:20:00',1.31),('15529','2013-03-16','12:25:00',1.46),('15529','2013-03-16','12:30:00',1.58),('15529','2013-03-16','12:35:00',1.27),('15529','2013-03-16','12:40:00',1.22),('15529','2013-03-16','12:45:00',1.2),('15529','2013-03-16','12:50:00',1.02),('15529','2013-03-16','13:00:00',1.18),('15529','2013-03-16','13:05:00',1.19),('15529','2013-03-16','13:10:00',1.36),('15529','2013-03-16','13:15:00',1.27),('15529','2013-03-16','13:20:00',1.06),('15529','2013-03-16','13:25:00',1),('15529','2013-03-16','13:30:00',1.53),('15529','2013-03-16','13:35:00',1.31),('15529','2013-03-16','13:40:00',1.09),('15529','2013-03-16','13:55:00',1.44),('15529','2013-03-16','14:00:00',1.07),('15529','2013-03-16','14:05:00',1.33),('15529','2013-03-16','14:10:00',1.54),('15529','2013-03-16','14:15:00',1.33),('15529','2013-03-16','14:20:00',1.54),('15529','2013-03-16','14:25:00',1.3),('15529','2013-03-16','14:30:00',1.12),('15529','2013-03-16','14:35:00',1.08),('15529','2013-03-16','15:05:00',1.41),('15529','2013-03-16','15:10:00',1.92),('15529','2013-03-16','15:15:00',1.84),('15529','2013-03-16','15:20:00',1.76),('15529','2013-03-16','15:25:00',1.65),('15529','2013-03-16','15:30:00',1.27),('15529','2013-03-15','08:25:00',1.28),('15529','2013-03-15','08:30:00',1.34),('15529','2013-03-15','08:35:00',1.38),('15529','2013-03-15','08:40:00',1.41),('15529','2013-03-15','08:45:00',1.47),('15529','2013-03-15','08:50:00',1.63),('15529','2013-03-15','08:55:00',1.7),('15529','2013-03-15','09:00:00',1.75),('15529','2013-03-15','09:10:00',1.82),('15529','2013-03-15','09:15:00',1.84),('15529','2013-03-15','09:20:00',1.32),('15529','2013-03-15','09:25:00',1.2),('15529','2013-03-15','09:30:00',1.66),('15529','2013-03-15','09:35:00',1.84),('15529','2013-03-15','09:40:00',1.18),('15529','2013-03-15','09:45:00',1.72),('15529','2013-03-15','09:50:00',2.09),('15529','2013-03-15','09:55:00',2.24),('15529','2013-03-15','10:00:00',1.95),('15529','2013-03-15','10:05:00',2.23),('15529','2013-03-15','10:10:00',2.12),('15529','2013-03-15','10:15:00',1.6),('15529','2013-03-15','10:20:00',1.73),('15529','2013-03-15','10:25:00',1.41),('15529','2013-03-15','10:30:00',2.24),('15529','2013-03-15','10:35:00',2.18),('15529','2013-03-15','10:40:00',2.32),('15529','2013-03-15','10:45:00',2.3),('15529','2013-03-15','10:50:00',2.29),('15529','2013-03-15','10:55:00',2.34),('15529','2013-03-15','11:00:00',2.33),('15529','2013-03-15','11:05:00',2.34),('15529','2013-03-15','11:10:00',2.36),('15529','2013-03-15','11:15:00',2.37),('15529','2013-03-15','11:20:00',2.38),('15529','2013-03-15','11:25:00',2.39),('15529','2013-03-15','11:30:00',2.4),('15529','2013-03-15','11:35:00',2.41),('15529','2013-03-15','11:40:00',2.43),('15529','2013-03-15','11:45:00',2.42),('15529','2013-03-15','11:50:00',2.4),('15529','2013-03-15','11:55:00',2.41),('15529','2013-03-15','12:00:00',2.43),('15529','2013-03-15','12:05:00',2.44),('15529','2013-03-15','12:10:00',2.43),('15529','2013-03-15','12:15:00',2.39),('15529','2013-03-15','12:20:00',2.41),('15529','2013-03-15','12:25:00',2.41),('15529','2013-03-15','12:30:00',2.38),('15529','2013-03-15','12:35:00',2.39),('15529','2013-03-15','12:40:00',2.4),('15529','2013-03-15','12:45:00',2.27),('15529','2013-03-15','12:50:00',1.79),('15529','2013-03-15','12:55:00',2.21),('15529','2013-03-15','13:00:00',2.37),('15529','2013-03-15','13:05:00',2.32),('15529','2013-03-15','13:10:00',2.36),('15529','2013-03-15','13:15:00',2.33),('15529','2013-03-15','13:20:00',2.37),('15529','2013-03-15','13:25:00',2.36),('15529','2013-03-15','13:30:00',2.32),('15529','2013-03-15','13:35:00',2.31),('15529','2013-03-15','13:40:00',2.28),('15529','2013-03-15','13:45:00',2.33),('15529','2013-03-15','13:50:00',2.29),('15529','2013-03-15','13:55:00',2.08),('15529','2013-03-15','14:00:00',2.29),('15529','2013-03-15','14:05:00',1.54),('15529','2013-03-15','14:10:00',2.34),('15529','2013-03-15','14:15:00',1.47),('15529','2013-03-15','14:20:00',2.25),('15529','2013-03-15','14:25:00',2.26),('15529','2013-03-15','14:30:00',2.17),('15529','2013-03-15','14:35:00',2.09),('15529','2013-03-15','14:40:00',2.07),('15529','2013-03-15','14:45:00',1.73),('15529','2013-03-15','14:50:00',1.57),('15529','2013-03-15','15:35:00',1.26),('15529','2013-03-15','15:40:00',1.61),('15529','2013-03-15','15:45:00',1.12),('15529','2013-03-15','15:55:00',1.28),('15529','2013-03-15','16:00:00',1.31),('15529','2013-03-15','16:05:00',1.26),('15529','2013-03-15','16:10:00',1.24),('15529','2013-03-15','16:15:00',1.08),('15529','2013-03-14','11:35:00',1.3),('15529','2013-03-14','11:40:00',1.08),('15529','2013-03-14','11:45:00',1.12),('15529','2013-03-14','11:50:00',1.07),('15529','2013-03-14','11:55:00',1.17),('15529','2013-03-14','12:00:00',1.07),('15529','2013-03-14','12:10:00',1.06),('15529','2013-03-14','12:30:00',1.14),('15529','2013-03-14','12:35:00',1.02),('15529','2013-03-12','10:10:00',1.12),('15529','2013-03-12','10:25:00',1.36),('15529','2013-03-12','10:30:00',1.8),('15529','2013-03-12','10:35:00',1.81),('15529','2013-03-12','10:40:00',1.53),('15529','2013-03-12','10:45:00',1.38),('15529','2014-03-24','08:50:00',1.03),('15529','2014-03-24','08:55:00',1.07),('15529','2014-03-24','09:15:00',1.29),('15529','2014-03-24','09:20:00',1.34),('15529','2014-03-24','09:25:00',1.12),('15529','2014-03-24','09:55:00',1.17),('15529','2014-03-24','10:00:00',1.31),('15529','2014-03-24','10:05:00',1.45),('15529','2014-03-24','10:10:00',1.58),('15529','2014-03-24','10:15:00',1.69),('15529','2014-03-24','10:20:00',1.57),('15529','2014-03-24','10:25:00',1.64),('15529','2014-03-24','10:30:00',1.59),('15529','2014-03-24','10:35:00',1.25),('15529','2014-03-24','10:40:00',1.03),('15529','2014-03-24','11:00:00',1.07),('15529','2014-03-24','11:05:00',1.2),('15529','2014-03-24','11:10:00',1.39),('15529','2014-03-24','11:15:00',1.51),('15529','2014-03-24','11:20:00',1.45),('15529','2014-03-24','11:25:00',1.65),('15529','2014-03-24','11:30:00',1.71),('15529','2014-03-24','11:35:00',1.63),('15529','2014-03-24','11:40:00',1.42),('15529','2014-03-24','11:50:00',1.18),('15529','2013-03-11','08:20:00',1.12),('15529','2013-03-11','08:25:00',1.14),('15529','2013-03-11','08:35:00',1.22),('15529','2013-03-11','08:40:00',1.08),('15529','2013-03-11','09:00:00',1.54),('15529','2013-03-11','09:05:00',1.55),('15529','2013-03-11','09:10:00',1.58),('15529','2013-03-11','09:15:00',1.6),('15529','2013-03-11','09:20:00',1.64),('15529','2013-03-11','09:25:00',1.7),('15529','2013-03-11','09:30:00',1.74),('15529','2013-03-11','09:35:00',1.79),('15529','2013-03-11','09:40:00',1.52),('15529','2013-03-11','09:45:00',1.73),('15529','2013-03-11','09:50:00',1.92),('15529','2013-03-11','09:55:00',1.99),('15529','2013-03-11','10:00:00',2.05),('15529','2013-03-11','10:05:00',2.1),('15529','2013-03-11','10:10:00',1.8),('15529','2013-03-11','10:15:00',2.19),('15529','2013-03-11','10:20:00',2.23),('15529','2013-03-11','10:25:00',2.3),('15529','2013-03-11','10:30:00',1.43),('15529','2013-03-11','10:35:00',1.5),('15529','2013-03-11','10:40:00',1.83),('15529','2013-03-11','10:45:00',2.14),('15529','2013-03-11','10:50:00',1.96),('15529','2013-03-11','10:55:00',2.14),('15529','2013-03-11','11:00:00',2.33),('15529','2013-03-11','11:05:00',2.57),('15529','2013-03-11','11:10:00',2.15),('15529','2013-03-11','11:15:00',2.39),('15529','2013-03-11','11:20:00',1.13),('15529','2013-03-11','11:25:00',1.55),('15529','2013-03-11','11:30:00',1.11),('15529','2013-03-11','11:40:00',1.05),('15529','2013-03-11','11:45:00',1.07),('15529','2013-03-11','11:50:00',2.42),('15529','2013-03-11','12:00:00',2.37),('15529','2013-03-11','12:05:00',2.6),('15529','2013-03-11','12:10:00',1.94),('15529','2013-03-11','12:20:00',1.25),('15529','2013-03-11','12:25:00',2.2),('15529','2013-03-11','12:30:00',2.23),('15529','2013-03-11','12:35:00',1.7),('15529','2013-03-11','12:40:00',2.03),('15529','2013-03-11','12:45:00',1.96),('15529','2013-03-11','12:50:00',2.07),('15529','2013-03-11','12:55:00',2.34),('15529','2013-03-11','13:00:00',2.59),('15529','2013-03-11','13:05:00',2.26),('15529','2013-03-11','13:10:00',1.93),('15529','2013-03-11','13:15:00',1.62),('15529','2013-03-11','13:20:00',1.25),('15529','2013-03-11','13:25:00',1.02),('15529','2013-03-11','13:40:00',1.68),('15529','2013-03-11','13:45:00',1.28),('15529','2013-03-11','13:50:00',1.65),('15529','2013-03-11','13:55:00',1.42),('15529','2013-03-11','14:00:00',1.38),('15529','2013-03-11','14:20:00',1.14),('15529','2013-03-11','15:15:00',1.45),('15529','2013-03-11','15:20:00',1.37),('15529','2013-03-10','08:15:00',1.01),('15529','2013-03-10','08:20:00',1.07),('15529','2013-03-10','08:25:00',1.12),('15529','2013-03-10','08:30:00',1.18),('15529','2013-03-10','08:35:00',1.24),('15529','2013-03-10','08:40:00',1.27),('15529','2013-03-10','08:45:00',1.33),('15529','2013-03-10','08:50:00',1.4),('15529','2013-03-10','08:55:00',1.43),('15529','2013-03-10','09:00:00',1.48),('15529','2013-03-10','09:05:00',1.52),('15529','2013-03-10','09:10:00',1.56),('15529','2013-03-10','09:15:00',1.62),('15529','2013-03-10','09:20:00',1.71),('15529','2013-03-10','09:25:00',1.65),('15529','2013-03-10','09:30:00',1.16),('15529','2013-03-10','09:40:00',1.36),('15529','2013-03-10','10:35:00',1),('15529','2013-03-10','10:40:00',1.16),('15529','2013-03-10','10:45:00',1.65),('15529','2013-03-10','10:50:00',1.57),('15529','2013-03-10','10:55:00',1.94),('15529','2013-03-10','11:00:00',1.03),('15529','2013-03-10','11:30:00',1.12),('15529','2013-03-10','11:45:00',2.28),('15529','2013-03-10','11:50:00',1.27),('15529','2013-03-10','11:55:00',1.1),('15529','2013-03-10','12:10:00',1.15),('15529','2013-03-10','12:15:00',1.44),('15529','2013-03-10','12:35:00',2.22),('15529','2013-03-10','12:40:00',1.32),('15529','2013-03-10','12:50:00',1.01),('15529','2013-03-10','13:05:00',1.09),('15529','2013-03-10','13:10:00',1.3),('15529','2013-03-10','13:15:00',1.62),('15529','2013-03-10','13:20:00',2.64),('15529','2013-03-10','13:25:00',2.37),('15529','2013-03-10','13:30:00',2.23),('15529','2013-03-10','14:10:00',2.12),('15529','2013-03-10','14:15:00',2.29),('15529','2013-03-10','14:20:00',1.08),('15529','2013-03-10','14:30:00',1.29),('15529','2013-03-10','14:35:00',1.16),('15529','2013-03-10','14:45:00',1.1),('15529','2013-03-10','14:50:00',1.84),('15529','2013-03-10','14:55:00',1.9),('15529','2013-03-10','15:00:00',1.64),('15529','2013-03-10','15:05:00',1.83),('15529','2013-03-10','15:10:00',1.72),('15529','2013-03-10','15:15:00',1.55),('15529','2013-03-10','15:20:00',1.46),('15529','2013-03-10','15:25:00',1.16),('15529','2013-03-10','15:30:00',1.7),('15529','2013-03-10','15:35:00',1.67),('15529','2013-03-10','15:40:00',1.49),('15529','2013-03-10','15:45:00',1.32),('15529','2013-03-10','15:50:00',1.4),('15529','2013-03-10','15:55:00',1.06),('15529','2013-03-10','16:15:00',1.07),('15529','2013-03-10','16:20:00',1.02),('15529','2013-03-09','08:15:00',1.01),('15529','2013-03-09','08:20:00',1.08),('15529','2013-03-09','08:25:00',1.13),('15529','2013-03-09','08:30:00',1.18),('15529','2013-03-09','08:35:00',1.21),('15529','2013-03-09','08:40:00',1.27),('15529','2013-03-09','08:45:00',1.32),('15529','2013-03-09','08:50:00',1.37),('15529','2013-03-09','08:55:00',1.43),('15529','2013-03-09','09:00:00',1.47),('15529','2013-03-09','09:05:00',1.52),('15529','2013-03-09','09:10:00',1.56),('15529','2013-03-09','09:15:00',1.59),('15529','2013-03-09','09:20:00',1.61),('15529','2013-03-09','09:25:00',1.68),('15529','2013-03-09','09:30:00',1.78),('15529','2013-03-09','09:35:00',1.81),('15529','2013-03-09','09:40:00',1.93),('15529','2013-03-09','09:45:00',1.97),('15529','2013-03-09','09:50:00',1.68),('15529','2013-03-09','09:55:00',1.87),('15529','2013-03-09','10:05:00',1.97),('15529','2013-03-09','10:10:00',1.86),('15529','2013-03-09','10:15:00',2.06),('15529','2013-03-09','10:20:00',2.15),('15529','2013-03-09','10:25:00',2.07),('15529','2013-03-09','10:30:00',2.16),('15529','2013-03-09','10:35:00',1.91),('15529','2013-03-09','10:40:00',2.18),('15529','2013-03-09','10:45:00',2.18),('15529','2013-03-09','10:50:00',2.19),('15529','2013-03-09','10:55:00',2.19),('15529','2013-03-09','11:00:00',2.21),('15529','2013-03-09','11:05:00',2.27),('15529','2013-03-09','11:10:00',2.28),('15529','2013-03-09','11:15:00',1.19),('15529','2013-03-09','11:20:00',2.36),('15529','2013-03-09','11:25:00',1.33),('15529','2013-03-09','11:30:00',1.72),('15529','2013-03-09','11:40:00',1.6),('15529','2013-03-09','11:45:00',1.01),('15529','2013-03-09','11:50:00',1.97),('15529','2013-03-09','11:55:00',1.67),('15529','2013-03-09','12:00:00',2.37),('15529','2013-03-09','12:05:00',2.35),('15529','2013-03-09','12:10:00',2.33),('15529','2013-03-09','12:15:00',2.33),('15529','2013-03-09','12:20:00',2.35),('15529','2013-03-09','12:25:00',2.34),('15529','2013-03-09','12:30:00',2.32),('15529','2013-03-09','12:35:00',2.3),('15529','2013-03-09','12:40:00',1.97),('15529','2013-03-09','12:45:00',2.2),('15529','2013-03-09','12:50:00',2.42),('15529','2013-03-09','12:55:00',2.33),('15529','2013-03-09','13:00:00',1.81),('15529','2013-03-09','13:05:00',1.95),('15529','2013-03-09','13:10:00',2.16),('15529','2013-03-09','13:15:00',2.33),('15529','2013-03-09','13:20:00',2.21),('15529','2013-03-09','13:25:00',2.1),('15529','2013-03-09','13:30:00',2.15),('15529','2013-03-09','13:35:00',1.78),('15529','2013-03-09','13:40:00',1.23),('15529','2013-03-09','13:45:00',1.14),('15529','2013-03-09','13:50:00',1.02),('15529','2013-03-09','13:55:00',1),('15529','2013-03-09','14:05:00',1.18),('15529','2013-03-09','14:10:00',1.15),('15529','2013-03-09','14:15:00',1.71),('15529','2013-03-09','14:20:00',1.52),('15529','2013-03-09','14:25:00',1.23),('15529','2013-03-09','14:30:00',1.26),('15529','2013-03-09','14:35:00',1.32),('15529','2013-03-09','14:40:00',1.71),('15529','2013-03-08','08:20:00',1.05),('15529','2013-03-08','08:25:00',1.09),('15529','2013-03-08','08:30:00',1.16),('15529','2013-03-08','08:35:00',1.22),('15529','2013-03-08','08:40:00',1.26),('15529','2013-03-08','08:45:00',1.21),('15529','2013-03-08','08:55:00',1.56),('15529','2013-03-08','09:00:00',1.37),('15529','2013-03-08','09:05:00',1.41),('15529','2013-03-08','09:10:00',1.31),('15529','2013-03-08','09:25:00',1.34),('15529','2013-03-08','09:45:00',1.37),('15529','2013-03-08','09:55:00',1.04),('15529','2013-03-08','10:00:00',2.24),('15529','2013-03-08','10:05:00',2.28),('15529','2013-03-08','10:10:00',2.26),('15529','2013-03-08','10:15:00',2.08),('15529','2013-03-08','10:20:00',1.59),('15529','2013-03-08','10:25:00',1.07),('15529','2013-03-08','10:35:00',1.37),('15529','2013-03-08','10:40:00',2.12),('15529','2013-03-08','10:45:00',2.41),('15529','2013-03-08','10:50:00',1.66),('15529','2013-03-08','10:55:00',2.15),('15529','2013-03-08','11:00:00',2.34),('15529','2013-03-08','11:05:00',2.24),('15529','2013-03-08','11:10:00',2.04),('15529','2013-03-08','11:15:00',1.97),('15529','2013-03-08','11:20:00',2.33),('15529','2013-03-08','11:25:00',2.39),('15529','2013-03-08','11:30:00',2.34),('15529','2013-03-08','11:35:00',2.34),('15529','2013-03-08','11:40:00',2.35),('15529','2013-03-08','11:45:00',2.34),('15529','2013-03-08','11:50:00',2.34),('15529','2013-03-08','11:55:00',2.37),('15529','2013-03-08','12:00:00',2.36),('15529','2013-03-08','12:05:00',2.41),('15529','2013-03-08','12:10:00',2.07),('15529','2013-03-08','12:15:00',1.51),('15529','2013-03-08','12:20:00',1.47),('15529','2013-03-08','12:25:00',2.06),('15529','2013-03-08','12:30:00',2.09),('15529','2013-03-08','12:35:00',1.23),('15529','2013-03-08','12:40:00',2.21),('15529','2013-03-08','12:45:00',2.58),('15529','2013-03-08','12:50:00',2.39),('15529','2013-03-08','12:55:00',2.33),('15529','2013-03-08','13:00:00',2.31),('15529','2013-03-08','13:05:00',2.29),('15529','2013-03-08','13:10:00',2.28),('15529','2013-03-08','13:15:00',2.32),('15529','2013-03-08','13:20:00',2.31),('15529','2013-03-08','13:25:00',2.18),('15529','2013-03-08','13:30:00',2.23),('15529','2013-03-08','13:35:00',2.27),('15529','2013-03-08','13:40:00',2.29),('15529','2013-03-08','13:45:00',1.98),('15529','2013-03-08','13:50:00',1.62),('15529','2013-03-08','13:55:00',1.72),('15529','2013-03-08','14:00:00',2.35),('15529','2013-03-08','14:05:00',2.18),('15529','2013-03-08','14:10:00',1.34),('15529','2013-03-08','14:15:00',1.52),('15529','2013-03-08','14:20:00',2.07),('15529','2013-03-08','14:25:00',1.99),('15529','2013-03-08','14:30:00',1.92),('15529','2013-03-08','14:35:00',1.89),('15529','2013-03-08','14:40:00',1.85),('15529','2013-03-08','14:45:00',1.83),('15529','2013-03-08','14:50:00',1.79),('15529','2013-03-08','14:55:00',1.76),('15529','2013-03-08','15:00:00',1.73),('15529','2013-03-08','15:05:00',1.69),('15529','2013-03-08','15:10:00',1.65),('15529','2013-03-08','15:15:00',1.61),('15529','2013-03-08','15:20:00',1.57),('15529','2013-03-08','15:25:00',1.52),('15529','2013-03-08','15:30:00',1.48),('15529','2013-03-08','15:35:00',1.38),('15529','2013-03-08','15:40:00',1.38),('15529','2013-03-08','15:45:00',1.33),('15529','2013-03-08','15:50:00',1.27),('15529','2013-03-08','15:55:00',1.14),('15529','2013-03-08','16:00:00',1.05),('15529','2013-03-08','16:05:00',1.12),('15529','2013-03-08','16:15:00',1.04),('15529','2013-03-07','09:35:00',1.77),('15529','2013-03-07','09:45:00',1.08),('15529','2013-03-07','09:50:00',1.7),('15529','2013-03-07','09:55:00',1.4),('15529','2013-03-07','10:10:00',1.14),('15529','2013-03-07','10:30:00',1.16),('15529','2013-03-07','11:55:00',1.64),('15529','2013-03-07','12:00:00',1.46),('15529','2013-03-07','12:20:00',1.06),('15529','2013-03-07','12:40:00',1.09),('15529','2013-03-07','12:45:00',1.54),('15529','2013-03-07','12:50:00',1.19),('15529','2013-03-07','12:55:00',1.56),('15529','2013-03-07','13:00:00',1.73),('15529','2013-03-07','13:05:00',1.18),('15529','2013-03-06','11:35:00',1.25),('15529','2013-03-06','11:40:00',1.89),('15529','2013-03-06','11:45:00',1.61),('15529','2013-03-06','11:50:00',1.25),('15529','2013-03-06','12:25:00',1.32),('15529','2013-03-06','12:30:00',1.06),('15529','2013-03-06','13:05:00',1.01),('15529','2013-03-06','13:10:00',1.28),('15529','2013-03-06','13:25:00',1.22),('15529','2013-03-04','08:30:00',1.08),('15529','2013-03-04','08:35:00',1.02),('15529','2013-03-04','10:15:00',1.04),('15529','2013-03-04','10:20:00',1.1),('15529','2013-03-04','10:30:00',1.11),('15529','2013-03-04','10:35:00',1.32),('15529','2013-03-04','10:40:00',1.32),('15529','2013-03-04','10:45:00',1.39),('15529','2013-03-04','10:50:00',1.53),('15529','2013-03-04','10:55:00',1.46),('15529','2013-03-04','11:00:00',1.38),('15529','2013-03-04','11:05:00',1.54),('15529','2013-03-04','11:10:00',1.55),('15529','2013-03-04','11:15:00',1.51),('15529','2013-03-04','11:20:00',1.44),('15529','2013-03-04','11:25:00',1.41),('15529','2013-03-04','11:30:00',1.47),('15529','2013-03-04','11:35:00',1.65),('15529','2013-03-04','11:40:00',1.74),('15529','2013-03-04','11:45:00',1.7),('15529','2013-03-04','11:50:00',1.75),('15529','2013-03-04','11:55:00',1.81),('15529','2013-03-04','12:00:00',1.88),('15529','2013-03-04','12:05:00',1.91),('15529','2013-03-04','12:10:00',2.02),('15529','2013-03-04','12:15:00',1.54),('15529','2013-03-04','12:20:00',1.88),('15529','2013-03-04','12:25:00',1.76),('15529','2013-03-04','12:30:00',1.42),('15529','2013-03-04','12:35:00',1.22),('15529','2013-03-04','12:40:00',1.42),('15529','2013-03-04','12:45:00',1.43),('15529','2013-03-04','12:50:00',1.23),('15529','2013-03-04','12:55:00',1.01),('15529','2013-03-03','08:25:00',1.03),('15529','2013-03-03','08:30:00',1.08),('15529','2013-03-03','08:35:00',1.14),('15529','2013-03-03','08:40:00',1.19),('15529','2013-03-03','08:45:00',1.24),('15529','2013-03-03','08:50:00',1.28),('15529','2013-03-03','08:55:00',1.33),('15529','2013-03-03','09:00:00',1.36),('15529','2013-03-03','09:05:00',1.41),('15529','2013-03-03','09:10:00',1.45),('15529','2013-03-03','09:15:00',1.5),('15529','2013-03-03','09:20:00',1.54),('15529','2013-03-03','09:25:00',1.58),('15529','2013-03-03','09:30:00',1.61),('15529','2013-03-03','09:35:00',1.67),('15529','2013-03-03','09:40:00',1.69),('15529','2013-03-03','09:45:00',1.73),('15529','2013-03-03','09:50:00',1.75),('15529','2013-03-03','09:55:00',1.79),('15529','2013-03-03','10:00:00',1.83),('15529','2013-03-03','10:05:00',1.84),('15529','2013-03-03','10:10:00',1.88),('15529','2013-03-03','10:15:00',1.91),('15529','2013-03-03','10:20:00',1.93),('15529','2013-03-03','10:25:00',1.94),('15529','2013-03-03','10:30:00',1.98),('15529','2013-03-03','10:35:00',2),('15529','2013-03-03','10:40:00',2.03),('15529','2013-03-03','10:45:00',2.04),('15529','2013-03-03','10:50:00',2.04),('15529','2013-03-03','10:55:00',2.07),('15529','2013-03-03','11:00:00',2.07),('15529','2013-03-03','11:05:00',2.12),('15529','2013-03-03','11:10:00',2.1),('15529','2013-03-03','11:15:00',2.13),('15529','2013-03-03','11:20:00',2.17),('15529','2013-03-03','11:25:00',2.17),('15529','2013-03-03','11:30:00',2.16),('15529','2013-03-03','11:35:00',2.16),('15529','2013-03-03','11:40:00',2.19),('15529','2013-03-03','11:45:00',2.16),('15529','2013-03-03','11:50:00',2.17),('15529','2013-03-03','11:55:00',2.16),('15529','2013-03-03','12:00:00',2.17),('15529','2013-03-03','12:05:00',2.16),('15529','2013-03-03','12:10:00',2.21),('15529','2013-03-03','12:15:00',2.23),('15529','2013-03-03','12:20:00',2.21),('15529','2013-03-03','12:25:00',2.25),('15529','2013-03-03','12:30:00',2.28),('15529','2013-03-03','12:35:00',2.23),('15529','2013-03-03','12:40:00',2.18),('15529','2013-03-03','12:45:00',2.16),('15529','2013-03-03','12:50:00',2.17),('15529','2013-03-03','12:55:00',2.16),('15529','2013-03-03','13:00:00',2.13),('15529','2013-03-03','13:05:00',2.12),('15529','2013-03-03','13:10:00',2.08),('15529','2013-03-03','13:15:00',2.05),('15529','2013-03-03','13:20:00',2.09),('15529','2013-03-03','13:25:00',2.11),('15529','2013-03-03','13:30:00',2.11),('15529','2013-03-03','13:35:00',2.17),('15529','2013-03-03','13:40:00',2.08),('15529','2013-03-03','13:45:00',1.97),('15529','2013-03-03','13:50:00',2.01),('15529','2013-03-03','13:55:00',1.96),('15529','2013-03-03','14:00:00',1.91),('15529','2013-03-03','14:05:00',1.86),('15529','2013-03-03','14:10:00',1.83),('15529','2013-03-03','14:15:00',1.82),('15529','2013-03-03','14:20:00',1.78),('15529','2013-03-03','14:25:00',1.75),('15529','2013-03-03','14:30:00',1.74),('15529','2013-03-03','14:35:00',1.71),('15529','2013-03-03','14:40:00',1.65),('15529','2013-03-03','14:45:00',1.61),('15529','2013-03-03','14:50:00',1.61),('15529','2013-03-03','14:55:00',1.55),('15529','2013-03-03','15:00:00',1.51),('15529','2013-03-03','15:05:00',1.5),('15529','2013-03-03','15:10:00',1.48),('15529','2013-03-03','15:15:00',1.42),('15529','2013-03-03','15:20:00',1.4),('15529','2013-03-03','15:25:00',1.36),('15529','2013-03-03','15:30:00',1.3),('15529','2013-03-03','15:35:00',1.27),('15529','2013-03-03','15:40:00',1.22),('15529','2013-03-03','15:45:00',1.17),('15529','2013-03-03','15:50:00',1.13),('15529','2013-03-03','15:55:00',1.09),('15529','2013-03-03','16:00:00',1.03),('15529','2013-03-02','08:20:00',1.03),('15529','2013-03-02','08:25:00',1.09),('15529','2013-03-02','08:30:00',1.14),('15529','2013-03-02','08:35:00',1.2),('15529','2013-03-02','08:40:00',1.25),('15529','2013-03-02','08:45:00',1.31),('15529','2013-03-02','08:50:00',1.36),('15529','2013-03-02','08:55:00',1.41),('15529','2013-03-02','09:00:00',1.45),('15529','2013-03-02','09:05:00',1.49),('15529','2013-03-02','09:10:00',1.54),('15529','2013-03-02','09:15:00',1.59),('15529','2013-03-02','09:20:00',1.62),('15529','2013-03-02','09:25:00',1.66),('15529','2013-03-02','09:30:00',1.7),('15529','2013-03-02','09:35:00',1.74),('15529','2013-03-02','09:40:00',1.77),('15529','2013-03-02','09:45:00',1.79),('15529','2013-03-02','09:50:00',1.83),('15529','2013-03-02','09:55:00',1.86),('15529','2013-03-02','10:00:00',1.89),('15529','2013-03-02','10:05:00',1.92),('15529','2013-03-02','10:10:00',1.97),('15529','2013-03-02','10:15:00',2.01),('15529','2013-03-02','10:20:00',2.05),('15529','2013-03-02','10:25:00',2.06),('15529','2013-03-02','10:30:00',2.07),('15529','2013-03-02','10:35:00',2.09),('15529','2013-03-02','10:40:00',2.11),('15529','2013-03-02','10:45:00',2.11),('15529','2013-03-02','10:50:00',2.13),('15529','2013-03-02','10:55:00',2.16),('15529','2013-03-02','11:00:00',2.14),('15529','2013-03-02','11:05:00',2.15),('15529','2013-03-02','11:10:00',2.17),('15529','2013-03-02','11:15:00',2.2),('15529','2013-03-02','11:20:00',2.23),('15529','2013-03-02','11:25:00',2.23),('15529','2013-03-02','11:30:00',2.24),('15529','2013-03-02','11:35:00',2.27),('15529','2013-03-02','11:40:00',2.22),('15529','2013-03-02','11:45:00',2.27),('15529','2013-03-02','11:50:00',2.26),('15529','2013-03-02','11:55:00',2.29),('15529','2013-03-02','12:00:00',2.28),('15529','2013-03-02','12:05:00',2.3),('15529','2013-03-02','12:10:00',2.27),('15529','2013-03-02','12:15:00',2.26),('15529','2013-03-02','12:20:00',2.28),('15529','2013-03-02','12:25:00',2.25),('15529','2013-03-02','12:30:00',2.26),('15529','2013-03-02','12:35:00',2.25),('15529','2013-03-02','12:40:00',2.24),('15529','2013-03-02','12:45:00',2.29),('15529','2013-03-02','12:50:00',2.23),('15529','2013-03-02','12:55:00',2.22),('15529','2013-03-02','13:00:00',2.23),('15529','2013-03-02','13:05:00',2.21),('15529','2013-03-02','13:10:00',2.22),('15529','2013-03-02','13:15:00',2.21),('15529','2013-03-02','13:20:00',2.16),('15529','2013-03-02','13:25:00',2.15),('15529','2013-03-02','13:30:00',2.15),('15529','2013-03-02','13:35:00',2.14),('15529','2013-03-02','13:40:00',2.1),('15529','2013-03-02','13:45:00',2.09),('15529','2013-03-02','13:50:00',2.08),('15529','2013-03-02','13:55:00',2.08),('15529','2013-03-02','14:00:00',2.06),('15529','2013-03-02','14:05:00',2.04),('15529','2013-03-02','14:10:00',2.01),('15529','2013-03-02','14:15:00',1.97),('15529','2013-03-02','14:20:00',1.95),('15529','2013-03-02','14:25:00',1.93),('15529','2013-03-02','14:30:00',1.88),('15529','2013-03-02','14:35:00',1.86),('15529','2013-03-02','14:40:00',1.82),('15529','2013-03-02','14:45:00',1.78),('15529','2013-03-02','14:50:00',1.75),('15529','2013-03-02','14:55:00',1.72),('15529','2013-03-02','15:00:00',1.7),('15529','2013-03-02','15:05:00',1.67),('15529','2013-03-02','15:10:00',1.64),('15529','2013-03-02','15:15:00',1.59),('15529','2013-03-02','15:20:00',1.56),('15529','2013-03-02','15:25:00',1.51),('15529','2013-03-02','15:30:00',1.47),('15529','2013-03-02','15:35:00',1.42),('15529','2013-03-02','15:40:00',1.38),('15529','2013-03-02','15:45:00',1.33),('15529','2013-03-02','15:50:00',1.28),('15529','2013-03-02','15:55:00',1.23),('15529','2013-03-02','16:00:00',1.17),('15529','2013-03-02','16:05:00',1.12),('15529','2013-03-02','16:10:00',1.07),('15529','2013-03-02','16:15:00',1.01),('15529','2014-03-23','08:55:00',1.09),('15529','2014-03-23','09:40:00',1.19),('15529','2014-03-23','10:00:00',1.49),('15529','2014-03-23','10:05:00',1.95),('15529','2014-03-23','10:10:00',2.23),('15529','2014-03-23','10:35:00',1.01),('15529','2014-03-23','10:45:00',1.68),('15529','2014-03-23','10:50:00',2.6),('15529','2014-03-23','10:55:00',1.38),('15529','2014-03-23','11:00:00',1.32),('15529','2014-03-23','11:10:00',1.69),('15529','2014-03-23','11:15:00',1.97),('15529','2014-03-23','11:20:00',1.72),('15529','2014-03-23','11:25:00',1.3),('15529','2014-03-23','11:30:00',1.43),('15529','2014-03-23','12:35:00',1.01),('15529','2014-03-23','14:20:00',1.12),('15529','2014-03-23','14:25:00',1.02),('15529','2014-03-23','14:30:00',1.2),('15529','2014-03-23','14:35:00',1.4),('15529','2014-03-23','14:40:00',1.66),('15529','2014-03-23','14:45:00',1.93),('15529','2014-03-23','14:50:00',1.71),('15529','2014-03-23','14:55:00',1.53),('15529','2014-03-23','15:00:00',1.34),('15529','2014-03-23','15:05:00',1.23),('15529','2014-03-23','15:10:00',1.02),('15529','2014-03-23','15:55:00',1.52),('15529','2013-03-01','12:30:00',1.09),('15529','2013-03-01','12:35:00',1.19),('15529','2013-03-01','12:40:00',1.76),('15529','2013-03-01','12:45:00',1.61),('15529','2013-03-01','12:50:00',1.35),('15529','2013-02-28','08:55:00',1.03),('15529','2013-02-28','09:00:00',1.15),('15529','2013-02-28','09:05:00',1.19),('15529','2013-02-28','09:10:00',1.18),('15529','2013-02-28','09:15:00',1.21),('15529','2013-02-28','09:20:00',1.24),('15529','2013-02-28','09:25:00',1.36),('15529','2013-02-28','09:30:00',1.37),('15529','2013-02-28','09:35:00',1.38),('15529','2013-02-28','09:40:00',1.5),('15529','2013-02-28','09:45:00',1.53),('15529','2013-02-28','09:50:00',1.51),('15529','2013-02-28','09:55:00',1.45),('15529','2013-02-28','10:00:00',1.44),('15529','2013-02-28','10:05:00',1.37),('15529','2013-02-28','10:10:00',1.31),('15529','2013-02-28','10:15:00',1.16),('15529','2013-02-28','10:20:00',1.18),('15529','2013-02-28','10:25:00',1.28),('15529','2013-02-28','10:30:00',1.54),('15529','2013-02-28','10:35:00',1.43),('15529','2013-02-28','10:40:00',1.28),('15529','2013-02-28','10:45:00',1.22),('15529','2013-02-28','10:50:00',1.14),('15529','2013-02-28','10:55:00',1.03),('15529','2013-02-27','08:40:00',1.03),('15529','2013-02-27','08:45:00',1.11),('15529','2013-02-27','08:50:00',1.18),('15529','2013-02-27','08:55:00',1.25),('15529','2013-02-27','09:00:00',1.3),('15529','2013-02-27','09:05:00',1.34),('15529','2013-02-27','09:10:00',1.34),('15529','2013-02-27','09:15:00',1.42),('15529','2013-02-27','09:20:00',1.46),('15529','2013-02-27','09:25:00',1.48),('15529','2013-02-27','09:30:00',1.52),('15529','2013-02-27','09:35:00',1.55),('15529','2013-02-27','09:40:00',1.61),('15529','2013-02-27','09:45:00',1.65),('15529','2013-02-27','09:50:00',1.57),('15529','2013-02-27','09:55:00',1.69),('15529','2013-02-27','10:00:00',1.71),('15529','2013-02-27','10:05:00',1.77),('15529','2013-02-27','10:10:00',1.79),('15529','2013-02-27','10:15:00',1.8),('15529','2013-02-27','10:20:00',1.81),('15529','2013-02-27','10:25:00',1.84),('15529','2013-02-27','10:30:00',1.85),('15529','2013-02-27','10:35:00',1.89),('15529','2013-02-27','10:40:00',1.9),('15529','2013-02-27','10:45:00',1.88),('15529','2013-02-27','10:50:00',1.91),('15529','2013-02-27','10:55:00',1.95),('15529','2013-02-27','11:00:00',2),('15529','2013-02-27','11:05:00',1.99),('15529','2013-02-27','11:10:00',2),('15529','2013-02-27','11:15:00',2),('15529','2013-02-27','11:20:00',2.03),('15529','2013-02-27','11:25:00',2.08),('15529','2013-02-27','11:30:00',2.13),('15529','2013-02-27','11:35:00',2.14),('15529','2013-02-27','11:40:00',2.05),('15529','2013-02-27','11:45:00',2.03),('15529','2013-02-27','11:50:00',2.11),('15529','2013-02-27','11:55:00',2.12),('15529','2013-02-27','12:00:00',2.09),('15529','2013-02-27','12:05:00',2.09),('15529','2013-02-27','12:10:00',2.08),('15529','2013-02-27','12:15:00',2.17),('15529','2013-02-27','12:20:00',2.22),('15529','2013-02-27','12:25:00',2.13),('15529','2013-02-27','12:30:00',2.17),('15529','2013-02-27','12:35:00',2.15),('15529','2013-02-27','12:40:00',2.13),('15529','2013-02-27','12:45:00',2.08),('15529','2013-02-27','12:50:00',2.08),('15529','2013-02-27','12:55:00',2.08),('15529','2013-02-27','13:00:00',1.96),('15529','2013-02-27','13:05:00',2.09),('15529','2013-02-27','13:10:00',2.03),('15529','2013-02-27','13:20:00',1.4),('15529','2013-02-27','13:25:00',1.47),('15529','2013-02-27','13:30:00',1.6),('15529','2013-02-27','13:35:00',1.86),('15529','2013-02-27','13:40:00',1.93),('15529','2013-02-27','13:45:00',1.54),('15529','2013-02-27','13:50:00',1.88),('15529','2013-02-27','13:55:00',1.87),('15529','2013-02-27','14:00:00',1.83),('15529','2013-02-27','14:05:00',1.75),('15529','2013-02-27','14:10:00',1.8),('15529','2013-02-27','14:15:00',1.82),('15529','2013-02-27','14:20:00',1.73),('15529','2013-02-27','14:25:00',1.78),('15529','2013-02-27','14:30:00',1.78),('15529','2013-02-27','14:35:00',1.62),('15529','2013-02-27','14:40:00',1.68),('15529','2013-02-27','14:45:00',1.64),('15529','2013-02-27','14:50:00',1.62),('15529','2013-02-27','14:55:00',1.56),('15529','2013-02-27','15:00:00',1.53),('15529','2013-02-27','15:05:00',1.53),('15529','2013-02-27','15:10:00',1.49),('15529','2013-02-27','15:15:00',1.41),('15529','2013-02-27','15:20:00',1.36),('15529','2013-02-27','15:25:00',1.29),('15529','2013-02-27','15:30:00',1.22),('15529','2013-02-27','15:35:00',1.18),('15529','2013-02-27','15:40:00',1.14),('15529','2013-02-27','15:45:00',1.09),('15529','2013-02-27','15:50:00',1.06),('15529','2013-02-27','15:55:00',1.02),('15529','2013-02-26','08:40:00',1.05),('15529','2013-02-26','08:45:00',1.12),('15529','2013-02-26','08:50:00',1.15),('15529','2013-02-26','08:55:00',1.19),('15529','2013-02-26','09:00:00',1.24),('15529','2013-02-26','09:05:00',1.29),('15529','2013-02-26','09:10:00',1.34),('15529','2013-02-26','09:15:00',1.39),('15529','2013-02-26','09:20:00',1.43),('15529','2013-02-26','09:25:00',1.47),('15529','2013-02-26','09:30:00',1.51),('15529','2013-02-26','09:35:00',1.56),('15529','2013-02-26','09:40:00',1.6),('15529','2013-02-26','09:45:00',1.63),('15529','2013-02-26','09:50:00',1.68),('15529','2013-02-26','09:55:00',1.71),('15529','2013-02-26','10:00:00',1.74),('15529','2013-02-26','10:05:00',1.77),('15529','2013-02-26','10:10:00',1.78),('15529','2013-02-26','10:15:00',1.81),('15529','2013-02-26','10:20:00',1.84),('15529','2013-02-26','10:25:00',1.89),('15529','2013-02-26','10:30:00',1.92),('15529','2013-02-26','10:35:00',1.93),('15529','2013-02-26','10:40:00',1.95),('15529','2013-02-26','10:45:00',2),('15529','2013-02-26','10:50:00',1.94),('15529','2013-02-26','10:55:00',1.96),('15529','2013-02-26','11:00:00',1.97),('15529','2013-02-26','11:05:00',2.04),('15529','2013-02-26','11:10:00',2.07),('15529','2013-02-26','11:15:00',1.91),('15529','2013-02-26','11:25:00',1.59),('15529','2013-02-26','11:30:00',2.17),('15529','2013-02-26','11:35:00',2.08),('15529','2013-02-26','11:40:00',2.09),('15529','2013-02-26','11:45:00',2.24),('15529','2013-02-26','11:50:00',2.2),('15529','2013-02-26','11:55:00',1.26),('15529','2013-02-26','12:00:00',2.1),('15529','2013-02-26','12:05:00',2.31),('15529','2013-02-26','12:10:00',2.27),('15529','2013-02-26','12:15:00',2.24),('15529','2013-02-26','12:20:00',2.25),('15529','2013-02-26','12:25:00',2.27),('15529','2013-02-26','12:30:00',2.25),('15529','2013-02-26','12:35:00',2.25),('15529','2013-02-26','12:40:00',2.24),('15529','2013-02-26','12:45:00',2.24),('15529','2013-02-26','12:50:00',2.23),('15529','2013-02-26','12:55:00',2.21),('15529','2013-02-26','13:00:00',2.19),('15529','2013-02-26','13:05:00',2.13),('15529','2013-02-26','13:10:00',2.17),('15529','2013-02-26','13:15:00',2.14),('15529','2013-02-26','13:20:00',2.19),('15529','2013-02-26','13:25:00',2.19),('15529','2013-02-26','13:30:00',2.24),('15529','2013-02-26','13:35:00',2.2),('15529','2013-02-26','13:40:00',2.15),('15529','2013-02-26','13:45:00',2.14),('15529','2013-02-26','13:50:00',2.05),('15529','2013-02-26','13:55:00',2.06),('15529','2013-02-26','14:00:00',2.02),('15529','2013-02-26','14:05:00',1.97),('15529','2013-02-26','14:10:00',1.28),('15529','2013-02-26','14:15:00',1.09),('15529','2013-02-26','14:20:00',1.68),('15529','2013-02-26','14:25:00',1.86),('15529','2013-02-26','14:30:00',1.83),('15529','2013-02-26','14:35:00',1.79),('15529','2013-02-26','14:40:00',1.78),('15529','2013-02-26','14:45:00',1.76),('15529','2013-02-26','14:50:00',1.65),('15529','2013-02-26','15:00:00',1.17),('15529','2013-02-26','15:05:00',1.73),('15529','2013-02-26','15:10:00',1.63),('15529','2013-02-26','15:15:00',1.47),('15529','2013-02-26','15:20:00',1.41),('15529','2013-02-26','15:25:00',1.37),('15529','2013-02-26','15:30:00',1.33),('15529','2013-02-26','15:35:00',1.3),('15529','2013-02-26','15:40:00',1.25),('15529','2013-02-26','15:45:00',1.19),('15529','2013-02-26','15:50:00',1.15),('15529','2013-02-26','15:55:00',1.1),('15529','2013-02-26','16:00:00',1.05),('15529','2013-02-26','16:05:00',1.01),('15529','2013-02-25','09:45:00',1.21),('15529','2013-02-25','09:50:00',1.31),('15529','2013-02-25','09:55:00',1.44),('15529','2013-02-25','10:00:00',1.45),('15529','2013-02-25','10:05:00',1.38),('15529','2013-02-25','10:10:00',1.45),('15529','2013-02-25','10:15:00',1.6),('15529','2013-02-25','10:20:00',1.93),('15529','2013-02-25','10:25:00',1.42),('15529','2013-02-25','10:30:00',1.83),('15529','2013-02-25','10:35:00',1.8),('15529','2013-02-25','10:40:00',1.05),('15529','2013-02-25','10:45:00',1.03),('15529','2013-02-25','10:50:00',1.08),('15529','2013-02-25','10:55:00',1.37),('15529','2013-02-25','11:00:00',1.32),('15529','2013-02-25','11:05:00',1.51),('15529','2013-02-25','11:10:00',1),('15529','2013-02-25','11:15:00',1.08),('15529','2013-02-25','11:20:00',1.04),('15529','2013-02-25','11:25:00',1.15),('15529','2013-02-25','11:30:00',1.12),('15529','2013-02-25','11:35:00',1.35),('15529','2013-02-25','11:40:00',1.02),('15529','2013-02-25','11:45:00',1.22),('15529','2013-02-25','11:50:00',1.21),('15529','2013-02-25','11:55:00',1.04),('15529','2013-02-25','12:00:00',1.03),('15529','2013-02-24','10:45:00',1.15),('15529','2013-02-24','10:50:00',2.51),('15529','2013-02-24','10:55:00',2.6),('15529','2013-02-24','11:00:00',2),('15529','2013-02-24','11:05:00',1.89),('15529','2013-02-24','11:10:00',2.38),('15529','2013-02-24','11:15:00',1.51),('15529','2013-02-24','11:20:00',1.89),('15529','2013-02-24','11:25:00',2.13),('15529','2013-02-24','11:30:00',1.39),('15529','2013-02-24','11:35:00',1.75),('15529','2013-02-24','11:40:00',1.87),('15529','2013-02-24','11:45:00',1.63),('15529','2013-02-24','11:50:00',1.36),('15529','2013-02-24','12:05:00',1.81),('15529','2013-02-24','12:10:00',1.36),('15529','2013-02-24','12:15:00',2.18),('15529','2013-02-24','12:20:00',2.26),('15529','2013-02-24','12:25:00',1.61),('15529','2013-02-24','12:30:00',2.6),('15529','2013-02-24','12:35:00',2.16),('15529','2013-02-24','12:40:00',2.33),('15529','2013-02-24','12:50:00',1.84),('15529','2013-02-24','12:55:00',2.42),('15529','2013-02-24','13:00:00',1.88),('15529','2013-02-24','13:40:00',1.09),('15529','2013-02-23','10:50:00',1.12),('15529','2013-02-23','14:05:00',1.17),('15529','2013-02-23','15:05:00',1.52),('15529','2013-02-23','15:20:00',1.33),('15529','2013-02-23','15:30:00',1.12),('15529','2013-02-23','15:35:00',1.08),('15529','2013-02-23','15:55:00',1.1),('15529','2013-02-22','08:10:00',1),('15529','2013-02-22','14:05:00',1.15),('15529','2013-02-21','16:15:00',1.07),('15529','2013-02-20','16:20:00',1.03),('15529','2014-03-22','09:05:00',1.32),('15529','2014-03-22','09:10:00',1.59),('15529','2014-03-22','09:15:00',1.28),('15529','2014-03-22','11:35:00',1.58),('15529','2014-03-22','11:40:00',1.72),('15529','2014-03-22','13:45:00',1.11),('15529','2014-03-22','15:25:00',1.09),('15529','2013-02-19','08:35:00',1.05),('15529','2013-02-19','08:40:00',1.1),('15529','2013-02-19','08:45:00',1.15),('15529','2013-02-19','08:50:00',1.21),('15529','2013-02-19','08:55:00',1.21),('15529','2013-02-19','09:20:00',1.15),('15529','2013-02-19','09:25:00',1.41),('15529','2013-02-19','09:30:00',1.69),('15529','2013-02-19','09:35:00',1.27),('15529','2013-02-19','09:45:00',1.39),('15529','2013-02-19','09:50:00',1.65),('15529','2013-02-19','10:45:00',1.39),('15529','2013-02-19','10:50:00',2.28),('15529','2013-02-19','10:55:00',1.74),('15529','2013-02-19','11:00:00',1.66),('15529','2013-02-19','11:05:00',2.38),('15529','2013-02-19','11:10:00',2.41),('15529','2013-02-19','11:15:00',2.4),('15529','2013-02-19','11:20:00',2.42),('15529','2013-02-19','11:25:00',2.42),('15529','2013-02-19','11:30:00',2.52),('15529','2013-02-19','11:35:00',2.42),('15529','2013-02-19','11:40:00',2.55),('15529','2013-02-19','11:45:00',2.46),('15529','2013-02-19','11:50:00',2.52),('15529','2013-02-19','11:55:00',1.13),('15529','2013-02-19','12:15:00',1.23),('15529','2013-02-19','12:20:00',1.16),('15529','2013-02-19','12:25:00',1.32),('15529','2013-02-19','12:30:00',2.66),('15529','2013-02-19','12:35:00',1.43),('15529','2013-02-19','12:40:00',1.97),('15529','2013-02-19','12:45:00',2.18),('15529','2013-02-19','12:50:00',1.71),('15529','2013-02-19','12:55:00',1.07),('15529','2013-02-19','13:00:00',2.08),('15529','2013-02-19','13:05:00',2.37),('15529','2013-02-19','13:10:00',2.25),('15529','2013-02-19','13:15:00',1.14),('15529','2013-02-19','13:40:00',2.32),('15529','2013-02-19','13:50:00',1.56),('15529','2013-02-19','13:55:00',1.37),('15529','2013-02-19','14:45:00',1.13),('15529','2013-02-19','14:50:00',1.44),('15529','2013-02-19','14:55:00',1.75),('15529','2013-02-19','15:00:00',1.05),('15529','2013-02-19','15:10:00',1.24),('15529','2013-02-19','15:15:00',1.13),('15529','2013-02-19','16:05:00',1.21),('15529','2013-02-18','08:35:00',1.02),('15529','2013-02-18','08:40:00',1.08),('15529','2013-02-18','08:45:00',1.13),('15529','2013-02-18','08:50:00',1.17),('15529','2013-02-18','08:55:00',1.23),('15529','2013-02-18','09:00:00',1.27),('15529','2013-02-18','09:05:00',1.32),('15529','2013-02-18','09:10:00',1.37),('15529','2013-02-18','09:15:00',1.41),('15529','2013-02-18','09:20:00',1.45),('15529','2013-02-18','09:25:00',1.48),('15529','2013-02-18','09:30:00',1.53),('15529','2013-02-18','09:35:00',1.56),('15529','2013-02-18','09:40:00',1.61),('15529','2013-02-18','09:45:00',1.65),('15529','2013-02-18','09:50:00',1.68),('15529','2013-02-18','09:55:00',1.72),('15529','2013-02-18','10:00:00',1.74),('15529','2013-02-18','10:05:00',1.78),('15529','2013-02-18','10:10:00',1.81),('15529','2013-02-18','10:15:00',1.82),('15529','2013-02-18','10:20:00',1.86),('15529','2013-02-18','10:25:00',1.89),('15529','2013-02-18','10:30:00',1.92),('15529','2013-02-18','10:35:00',1.95),('15529','2013-02-18','10:40:00',1.94),('15529','2013-02-18','10:45:00',1.94),('15529','2013-02-18','10:50:00',2),('15529','2013-02-18','10:55:00',2.02),('15529','2013-02-18','11:00:00',2.01),('15529','2013-02-18','11:05:00',2.05),('15529','2013-02-18','11:10:00',2.06),('15529','2013-02-18','11:15:00',2.06),('15529','2013-02-18','11:20:00',2.1),('15529','2013-02-18','11:25:00',2.11),('15529','2013-02-18','11:30:00',2.13),('15529','2013-02-18','11:35:00',2.14),('15529','2013-02-18','11:40:00',2.13),('15529','2013-02-18','11:45:00',2.14),('15529','2013-02-18','11:50:00',2.16),('15529','2013-02-18','11:55:00',2.17),('15529','2013-02-18','12:00:00',2.16),('15529','2013-02-18','12:05:00',2.17),('15529','2013-02-18','12:10:00',2.18),('15529','2013-02-18','12:15:00',2.15),('15529','2013-02-18','12:20:00',2.15),('15529','2013-02-18','12:25:00',2.17),('15529','2013-02-18','12:30:00',2.17),('15529','2013-02-18','12:35:00',2.17),('15529','2013-02-18','12:40:00',2.16),('15529','2013-02-18','12:45:00',2.17),('15529','2013-02-18','12:50:00',2.16),('15529','2013-02-18','12:55:00',2.15),('15529','2013-02-18','13:00:00',2.14),('15529','2013-02-18','13:05:00',2.12),('15529','2013-02-18','13:10:00',2.12),('15529','2013-02-18','13:15:00',2.1),('15529','2013-02-18','13:20:00',2.08),('15529','2013-02-18','13:25:00',2.07),('15529','2013-02-18','13:30:00',1.99),('15529','2013-02-18','13:35:00',1.94),('15529','2013-02-18','13:40:00',2),('15529','2013-02-18','13:45:00',1.98),('15529','2013-02-18','13:50:00',1.88),('15529','2013-02-18','13:55:00',1.83),('15529','2013-02-18','14:00:00',1.89),('15529','2013-02-18','14:05:00',1.73),('15529','2013-02-18','14:10:00',1.56),('15529','2013-02-18','14:15:00',1.82),('15529','2013-02-18','14:20:00',1.75),('15529','2013-02-18','14:25:00',1.74),('15529','2013-02-18','14:30:00',1.72),('15529','2013-02-18','14:35:00',1.71),('15529','2013-02-18','14:40:00',1.67),('15529','2013-02-18','14:45:00',1.66),('15529','2013-02-18','14:50:00',1.62),('15529','2013-02-18','14:55:00',1.59),('15529','2013-02-18','15:00:00',1.54),('15529','2013-02-18','15:05:00',1.5),('15529','2013-02-18','15:10:00',1.5),('15529','2013-02-18','15:15:00',1.47),('15529','2013-02-18','15:20:00',1.41),('15529','2013-02-18','15:25:00',1.34),('15529','2013-02-18','15:30:00',1.31),('15529','2013-02-18','15:35:00',1.25),('15529','2013-02-18','15:40:00',1.18),('15529','2013-02-18','15:45:00',1.15),('15529','2013-02-18','15:50:00',1.13),('15529','2013-02-18','15:55:00',1.09),('15529','2013-02-18','16:00:00',1.03),('15529','2013-02-17','08:45:00',1.04),('15529','2013-02-17','08:50:00',1.1),('15529','2013-02-17','08:55:00',1.15),('15529','2013-02-17','09:00:00',1.19),('15529','2013-02-17','09:05:00',1.25),('15529','2013-02-17','09:10:00',1.26),('15529','2013-02-17','09:15:00',1.38),('15529','2013-02-17','09:20:00',1.48),('15529','2013-02-17','09:25:00',1.13),('15529','2013-02-17','11:50:00',1.04),('15529','2013-02-17','11:55:00',1.32),('15529','2013-02-17','12:00:00',1),('15529','2013-02-16','08:40:00',1.02),('15529','2013-02-16','08:55:00',1.13),('15529','2013-02-16','09:00:00',1.07),('15529','2013-02-16','09:05:00',1.19),('15529','2013-02-16','09:10:00',1.24),('15529','2013-02-16','09:15:00',1.32),('15529','2013-02-16','09:20:00',1.35),('15529','2013-02-16','09:25:00',1.41),('15529','2013-02-16','09:30:00',1.43),('15529','2013-02-16','09:35:00',1.48),('15529','2013-02-16','09:40:00',1.51),('15529','2013-02-16','09:45:00',1.54),('15529','2013-02-16','09:50:00',1.58),('15529','2013-02-16','09:55:00',1.63),('15529','2013-02-16','10:00:00',1.64),('15529','2013-02-16','10:05:00',1.68),('15529','2013-02-16','10:10:00',1.71),('15529','2013-02-16','10:15:00',1.75),('15529','2013-02-16','10:20:00',1.76),('15529','2013-02-16','10:25:00',1.79),('15529','2013-02-16','10:30:00',1.8),('15529','2013-02-16','10:35:00',1.83),('15529','2013-02-16','10:40:00',1.85),('15529','2013-02-16','10:45:00',1.88),('15529','2013-02-16','10:50:00',1.9),('15529','2013-02-16','10:55:00',1.94),('15529','2013-02-16','11:00:00',1.95),('15529','2013-02-16','11:05:00',1.97),('15529','2013-02-16','11:10:00',1.98),('15529','2013-02-16','11:15:00',2.03),('15529','2013-02-16','11:20:00',2.03),('15529','2013-02-16','11:25:00',2.03),('15529','2013-02-16','11:30:00',2.05),('15529','2013-02-16','11:35:00',2.06),('15529','2013-02-16','11:40:00',2.07),('15529','2013-02-16','11:45:00',2.1),('15529','2013-02-16','11:50:00',2.11),('15529','2013-02-16','11:55:00',2.12),('15529','2013-02-16','12:00:00',2.1),('15529','2013-02-16','12:05:00',2.09),('15529','2013-02-16','12:10:00',2.09),('15529','2013-02-16','12:15:00',2.11),('15529','2013-02-16','12:20:00',2.09),('15529','2013-02-16','12:25:00',2.11),('15529','2013-02-16','12:30:00',2.1),('15529','2013-02-16','12:35:00',2.11),('15529','2013-02-16','12:40:00',2.08),('15529','2013-02-16','12:45:00',2.05),('15529','2013-02-16','12:50:00',2.03),('15529','2013-02-16','12:55:00',2.02),('15529','2013-02-16','13:00:00',1.96),('15529','2013-02-16','13:05:00',1.05),('15529','2013-02-16','13:25:00',1.95),('15529','2013-02-16','13:30:00',1.84),('15529','2013-02-16','13:55:00',1.5),('15529','2013-02-16','14:05:00',1.13),('15529','2013-02-16','14:10:00',1.89),('15529','2013-02-16','14:50:00',1.3),('15529','2013-02-16','14:55:00',1.65),('15529','2013-02-16','15:00:00',1.64),('15529','2013-02-16','15:05:00',1.64),('15529','2013-02-16','15:10:00',1.6),('15529','2013-02-16','15:15:00',1.49),('15529','2013-02-16','15:20:00',1.43),('15529','2013-02-16','15:25:00',1.4),('15529','2013-02-16','15:30:00',1.35),('15529','2013-02-16','15:35:00',1.29),('15529','2013-02-16','15:40:00',1.26),('15529','2013-02-16','15:45:00',1.19),('15529','2013-02-16','15:50:00',1.12),('15529','2013-02-16','15:55:00',1.06),('15529','2013-02-16','16:00:00',1),('15529','2013-02-15','09:05:00',1.31),('15529','2013-02-15','09:10:00',1.35),('15529','2013-02-15','09:15:00',1.39),('15529','2013-02-15','09:20:00',1.4),('15529','2013-02-15','09:25:00',1.4),('15529','2013-02-15','09:30:00',1.52),('15529','2013-02-15','09:35:00',1.56),('15529','2013-02-15','09:40:00',1.55),('15529','2013-02-15','09:45:00',1.58),('15529','2013-02-15','09:50:00',1.62),('15529','2013-02-15','09:55:00',1.65),('15529','2013-02-15','10:00:00',1.68),('15529','2013-02-15','10:05:00',1.72),('15529','2013-02-15','10:10:00',1.75),('15529','2013-02-15','10:15:00',1.76),('15529','2013-02-15','10:20:00',1.8),('15529','2013-02-15','10:25:00',1.85),('15529','2013-02-15','10:30:00',1.85),('15529','2013-02-15','10:35:00',1.91),('15529','2013-02-15','10:40:00',1.94),('15529','2013-02-15','10:45:00',1.96),('15529','2013-02-15','10:50:00',1.98),('15529','2013-02-15','10:55:00',1.95),('15529','2013-02-15','11:00:00',2.02),('15529','2013-02-15','11:05:00',2.02),('15529','2013-02-15','11:10:00',2.03),('15529','2013-02-15','11:15:00',2.05),('15529','2013-02-15','11:20:00',2.06),('15529','2013-02-15','11:25:00',2.08),('15529','2013-02-15','11:30:00',2.12),('15529','2013-02-15','11:35:00',2.11),('15529','2013-02-15','11:40:00',2.13),('15529','2013-02-15','11:45:00',2.14),('15529','2013-02-15','11:50:00',2.17),('15529','2013-02-15','11:55:00',2.18),('15529','2013-02-15','12:00:00',2.17),('15529','2013-02-15','12:05:00',2.19),('15529','2013-02-15','12:10:00',2.17),('15529','2013-02-15','12:15:00',2.17),('15529','2013-02-15','12:20:00',2.15),('15529','2013-02-15','12:25:00',2.14),('15529','2013-02-15','12:30:00',2.14),('15529','2013-02-15','12:35:00',2.14),('15529','2013-02-15','12:40:00',2.12),('15529','2013-02-15','12:45:00',2.14),('15529','2013-02-15','12:50:00',2.15),('15529','2013-02-15','12:55:00',2.15),('15529','2013-02-15','13:00:00',2.12),('15529','2013-02-15','13:05:00',2.12),('15529','2013-02-15','13:10:00',2.06),('15529','2013-02-15','13:15:00',2.09),('15529','2013-02-15','13:20:00',2.07),('15529','2013-02-15','13:25:00',2.05),('15529','2013-02-15','13:30:00',2.03),('15529','2013-02-15','13:35:00',2.03),('15529','2013-02-15','13:40:00',1.95),('15529','2013-02-15','13:45:00',1.95),('15529','2013-02-15','13:50:00',2),('15529','2013-02-15','13:55:00',1.39),('15529','2013-02-15','14:00:00',1.23),('15529','2013-02-15','14:05:00',1.99),('15529','2013-02-15','14:10:00',1.92),('15529','2013-02-15','14:15:00',1.89),('15529','2013-02-15','14:20:00',1.49),('15529','2013-02-15','15:20:00',1.11),('15529','2013-02-15','15:25:00',1.59),('15529','2013-02-15','15:30:00',1.25),('15529','2013-02-15','15:35:00',1.37),('15529','2013-02-14','09:55:00',1.3),('15529','2013-02-14','10:00:00',1.29),('15529','2013-02-14','10:05:00',1.13),('15529','2013-02-14','10:10:00',1.19),('15529','2013-02-14','10:15:00',1.1),('15529','2013-02-14','10:20:00',1.22),('15529','2013-02-14','10:25:00',1.15),('15529','2013-02-14','10:30:00',1.61),('15529','2013-02-14','10:35:00',1.59),('15529','2013-02-14','10:40:00',1.73),('15529','2013-02-14','10:45:00',1.7),('15529','2013-02-14','10:55:00',1.02),('15529','2013-02-14','11:00:00',1.18),('15529','2013-02-14','11:05:00',1.23),('15529','2013-02-14','11:10:00',1.4),('15529','2013-02-14','11:15:00',2.22),('15529','2013-02-14','11:20:00',2.12),('15529','2013-02-14','11:25:00',2.07),('15529','2013-02-14','11:30:00',2.19),('15529','2013-02-14','11:35:00',1.8),('15529','2013-02-14','11:40:00',2.17),('15529','2013-02-14','11:45:00',2.38),('15529','2013-02-14','11:50:00',1.72),('15529','2013-02-14','11:55:00',1.56),('15529','2013-02-14','12:00:00',1.85),('15529','2013-02-14','12:05:00',1.85),('15529','2013-02-14','12:10:00',2.29),('15529','2013-02-14','12:15:00',2.27),('15529','2013-02-14','12:20:00',2.18),('15529','2013-02-14','12:25:00',2.24),('15529','2013-02-14','12:30:00',2.19),('15529','2013-02-14','12:35:00',2.17),('15529','2013-02-14','12:40:00',2.16),('15529','2013-02-14','12:45:00',2.15),('15529','2013-02-14','12:50:00',2.13),('15529','2013-02-14','12:55:00',2.16),('15529','2013-02-14','13:00:00',2.15),('15529','2013-02-14','13:05:00',2.19),('15529','2013-02-14','13:10:00',1.9),('15529','2013-02-14','13:15:00',1.8),('15529','2013-02-14','13:20:00',1.67),('15529','2013-02-14','13:25:00',1.49),('15529','2013-02-14','13:30:00',1.46),('15529','2013-02-14','13:35:00',1.56),('15529','2013-02-14','13:40:00',1.71),('15529','2013-02-14','13:45:00',1.56),('15529','2013-02-14','13:50:00',1.73),('15529','2013-02-14','13:55:00',1.1),('15529','2013-02-14','14:00:00',1.74),('15529','2013-02-14','14:05:00',2.24),('15529','2013-02-14','14:10:00',1.53),('15529','2013-02-14','14:15:00',1.75),('15529','2013-02-14','14:20:00',1.31),('15529','2013-02-14','14:25:00',1.22),('15529','2013-02-14','14:30:00',1.18),('15529','2013-02-14','14:35:00',1.83),('15529','2013-02-14','14:40:00',1.62),('15529','2013-02-14','14:45:00',1.19),('15529','2013-02-14','15:00:00',1.12),('15529','2013-02-14','15:25:00',1.03),('15529','2013-02-13','08:35:00',1.02),('15529','2013-02-13','08:40:00',1.07),('15529','2013-02-13','08:45:00',1.12),('15529','2013-02-13','08:50:00',1.18),('15529','2013-02-13','08:55:00',1.23),('15529','2013-02-13','09:00:00',1.29),('15529','2013-02-13','09:05:00',1.33),('15529','2013-02-13','09:10:00',1.37),('15529','2013-02-13','09:15:00',1.42),('15529','2013-02-13','09:20:00',1.47),('15529','2013-02-13','09:25:00',1.52),('15529','2013-02-13','09:30:00',1.55),('15529','2013-02-13','09:35:00',1.59),('15529','2013-02-13','09:40:00',1.64),('15529','2013-02-13','09:45:00',1.67),('15529','2013-02-13','09:50:00',1.71),('15529','2013-02-13','09:55:00',1.74),('15529','2013-02-13','10:00:00',1.79),('15529','2013-02-13','10:05:00',1.82),('15529','2013-02-13','10:10:00',1.86),('15529','2013-02-13','10:15:00',1.89),('15529','2013-02-13','10:20:00',1.9),('15529','2013-02-13','10:25:00',1.93),('15529','2013-02-13','10:30:00',1.95),('15529','2013-02-13','10:35:00',1.98),('15529','2013-02-13','10:40:00',2),('15529','2013-02-13','10:45:00',2.03),('15529','2013-02-13','10:50:00',2.05),('15529','2013-02-13','10:55:00',2.07),('15529','2013-02-13','11:00:00',2.08),('15529','2013-02-13','11:05:00',2.1),('15529','2013-02-13','11:10:00',2.13),('15529','2013-02-13','11:15:00',2.13),('15529','2013-02-13','11:20:00',2.14),('15529','2013-02-13','11:25:00',2.16),('15529','2013-02-13','11:30:00',2.16),('15529','2013-02-13','11:35:00',2.17),('15529','2013-02-13','11:40:00',2.18),('15529','2013-02-13','11:45:00',2.18),('15529','2013-02-13','11:50:00',2.18),('15529','2013-02-13','11:55:00',2.18),('15529','2013-02-13','12:00:00',2.19),('15529','2013-02-13','12:05:00',2.2),('15529','2013-02-13','12:10:00',2.2),('15529','2013-02-13','12:15:00',2.19),('15529','2013-02-13','12:20:00',2.2),('15529','2013-02-13','12:25:00',2.19),('15529','2013-02-13','12:30:00',2.2),('15529','2013-02-13','12:35:00',2.2),('15529','2013-02-13','12:40:00',2.18),('15529','2013-02-13','12:45:00',2.18),('15529','2013-02-13','12:50:00',2.15),('15529','2013-02-13','12:55:00',2.15),('15529','2013-02-13','13:00:00',2.16),('15529','2013-02-13','13:05:00',2.16),('15529','2013-02-13','13:10:00',2.13),('15529','2013-02-13','13:15:00',2.12),('15529','2013-02-13','13:20:00',2.08),('15529','2013-02-13','13:25:00',2.07),('15529','2013-02-13','13:30:00',2.07),('15529','2013-02-13','13:35:00',2.06),('15529','2013-02-13','13:40:00',2.04),('15529','2013-02-13','13:45:00',2.03),('15529','2013-02-13','13:50:00',2),('15529','2013-02-13','13:55:00',1.96),('15529','2013-02-13','14:00:00',1.95),('15529','2013-02-13','14:05:00',1.93),('15529','2013-02-13','14:10:00',1.91),('15529','2013-02-13','14:15:00',1.87),('15529','2013-02-13','14:20:00',1.85),('15529','2013-02-13','14:25:00',1.83),('15529','2013-02-13','14:30:00',1.79),('15529','2013-02-13','14:35:00',1.76),('15529','2013-02-13','14:40:00',1.73),('15529','2013-02-13','14:45:00',1.69),('15529','2013-02-13','14:50:00',1.66),('15529','2013-02-13','14:55:00',1.61),('15529','2013-02-13','15:00:00',1.56),('15529','2013-02-13','15:05:00',1.52),('15529','2013-02-13','15:10:00',1.48),('15529','2013-02-13','15:15:00',1.44),('15529','2013-02-13','15:20:00',1.4),('15529','2013-02-13','15:25:00',1.36),('15529','2013-02-13','15:30:00',1.31),('15529','2013-02-13','15:35:00',1.27),('15529','2013-02-13','15:40:00',1.22),('15529','2013-02-13','15:45:00',1.16),('15529','2013-02-13','15:50:00',1.09),('15529','2013-02-13','15:55:00',1.04),('15529','2013-02-12','09:35:00',1.26),('15529','2013-02-12','09:40:00',1.38),('15529','2013-02-12','09:45:00',1.29),('15529','2013-02-12','09:50:00',1.17),('15529','2013-02-12','09:55:00',1.24),('15529','2013-02-12','10:00:00',1.49),('15529','2013-02-12','10:05:00',1.63),('15529','2013-02-12','10:10:00',1.68),('15529','2013-02-12','10:15:00',1.76),('15529','2013-02-12','10:20:00',1.84),('15529','2013-02-12','10:25:00',1.85),('15529','2013-02-12','10:30:00',1.88),('15529','2013-02-12','10:35:00',1.96),('15529','2013-02-12','10:40:00',1.99),('15529','2013-02-12','10:45:00',1.94),('15529','2013-02-12','10:50:00',1.85),('15529','2013-02-12','10:55:00',1.82),('15529','2013-02-12','11:00:00',2.04),('15529','2013-02-12','11:05:00',2.01),('15529','2013-02-12','11:10:00',1.94),('15529','2013-02-12','11:15:00',1.56),('15529','2013-02-12','11:45:00',1.1),('15529','2013-02-12','11:50:00',1.09),('15529','2013-02-12','11:55:00',1.04),('15529','2013-02-12','12:10:00',1.43),('15529','2013-02-12','12:15:00',1.51),('15529','2013-02-12','12:35:00',1.18),('15529','2013-02-12','12:40:00',1.74),('15529','2013-02-12','12:45:00',1.92),('15529','2013-02-12','12:50:00',1.59),('15529','2013-02-12','12:55:00',1.4),('15529','2013-02-12','13:00:00',1.53),('15529','2013-02-12','13:05:00',1.61),('15529','2013-02-12','13:10:00',1.67),('15529','2013-02-12','13:15:00',1.74),('15529','2013-02-12','13:20:00',1.86),('15529','2013-02-12','13:25:00',1.91),('15529','2013-02-12','13:30:00',2.09),('15529','2013-02-12','13:35:00',2.09),('15529','2013-02-12','13:40:00',2.13),('15529','2013-02-12','13:45:00',2.02),('15529','2013-02-12','13:50:00',1.82),('15529','2013-02-12','13:55:00',1.7),('15529','2013-02-12','14:00:00',1.72),('15529','2013-02-12','14:05:00',1.71),('15529','2013-02-12','14:10:00',1.87),('15529','2013-02-12','14:15:00',1.91),('15529','2013-02-12','14:20:00',1.82),('15529','2013-02-12','14:25:00',1.71),('15529','2013-02-12','14:30:00',1.59),('15529','2013-02-12','14:35:00',1.72),('15529','2013-02-12','14:40:00',1.73),('15529','2013-02-12','14:45:00',1.69),('15529','2013-02-12','14:50:00',1.62),('15529','2013-02-12','14:55:00',1.61),('15529','2013-02-12','15:00:00',1.55),('15529','2013-02-12','15:05:00',1.55),('15529','2013-02-12','15:10:00',1.51),('15529','2013-02-12','15:15:00',1.47),('15529','2013-02-12','15:20:00',1.4),('15529','2013-02-12','15:25:00',1.37),('15529','2013-02-12','15:30:00',1.35),('15529','2013-02-12','15:35:00',1.29),('15529','2013-02-12','15:40:00',1.24),('15529','2013-02-12','15:45:00',1.21),('15529','2013-02-12','15:50:00',1.15),('15529','2013-02-12','15:55:00',1.07),('15529','2013-02-12','16:00:00',1.01),('15529','2013-02-10','14:30:00',1.1),('15529','2014-03-21','08:25:00',1.03),('15529','2014-03-21','08:40:00',1.33),('15529','2014-03-21','08:45:00',1.26),('15529','2014-03-21','08:55:00',1.13),('15529','2014-03-21','09:25:00',1.34),('15529','2014-03-21','09:30:00',1.09),('15529','2014-03-21','09:35:00',1.22),('15529','2014-03-21','09:40:00',1.43),('15529','2014-03-21','09:45:00',1.6),('15529','2014-03-21','09:50:00',1.42),('15529','2014-03-21','09:55:00',1.3),('15529','2014-03-21','10:00:00',2.04),('15529','2014-03-21','10:05:00',1.83),('15529','2014-03-21','10:10:00',1.02),('15529','2014-03-21','11:15:00',2.07),('15529','2014-03-21','11:20:00',1.86),('15529','2014-03-21','11:25:00',1.2),('15529','2014-03-21','11:30:00',1.13),('15529','2014-03-21','11:35:00',1.91),('15529','2014-03-21','11:40:00',1.87),('15529','2014-03-21','11:45:00',1.69),('15529','2014-03-21','11:50:00',1.4),('15529','2014-03-21','11:55:00',1.86),('15529','2014-03-21','12:05:00',1.02),('15529','2014-03-21','12:15:00',1.27),('15529','2014-03-21','12:20:00',2.35),('15529','2014-03-21','12:25:00',2.39),('15529','2014-03-21','12:30:00',1.66),('15529','2014-03-21','12:35:00',1.71),('15529','2014-03-21','12:40:00',2.22),('15529','2014-03-21','12:45:00',1.01),('15529','2014-03-21','12:50:00',1.59),('15529','2014-03-21','12:55:00',1.24),('15529','2014-03-21','13:05:00',2),('15529','2014-03-21','13:10:00',1.78),('15529','2014-03-21','13:15:00',1.07),('15529','2014-03-21','13:20:00',1.08),('15529','2014-03-21','13:25:00',2.13),('15529','2014-03-21','13:30:00',2.18),('15529','2014-03-21','13:35:00',1.91),('15529','2014-03-21','13:40:00',1.93),('15529','2014-03-21','13:45:00',2.14),('15529','2014-03-21','13:50:00',2.09),('15529','2014-03-21','13:55:00',2.02),('15529','2014-03-21','14:00:00',1.97),('15529','2014-03-21','14:05:00',1.96),('15529','2014-03-21','14:10:00',1.93),('15529','2014-03-21','14:15:00',1.92),('15529','2014-03-21','14:20:00',1.85),('15529','2014-03-21','14:25:00',1.79),('15529','2014-03-21','14:30:00',1.65),('15529','2014-03-21','14:35:00',1.61),('15529','2014-03-21','14:40:00',1.6),('15529','2014-03-21','14:45:00',1.69),('15529','2014-03-21','14:50:00',1.67),('15529','2014-03-21','14:55:00',1.62),('15529','2014-03-21','15:00:00',1.61),('15529','2014-03-21','15:05:00',1.59),('15529','2014-03-21','15:10:00',1.52),('15529','2014-03-21','15:15:00',1.47),('15529','2014-03-21','15:20:00',1.44),('15529','2014-03-21','15:25:00',1.28),('15529','2014-03-21','15:30:00',1.62),('15529','2014-03-21','15:35:00',1.63),('15529','2014-03-21','15:40:00',1.53),('15529','2014-03-21','15:45:00',1.45),('15529','2014-03-21','15:50:00',1.35),('15529','2014-03-21','15:55:00',1.15),('15529','2014-03-21','16:00:00',1.18),('15529','2014-03-21','16:05:00',1.05),('15529','2013-02-09','09:50:00',1.3),('15529','2013-02-09','09:55:00',1.86),('15529','2013-02-09','10:00:00',1.82),('15529','2013-02-09','10:05:00',1.81),('15529','2013-02-09','10:10:00',1.83),('15529','2013-02-09','10:15:00',1.86),('15529','2013-02-09','10:20:00',1.87),('15529','2013-02-09','10:25:00',1.91),('15529','2013-02-09','10:30:00',1.94),('15529','2013-02-09','10:35:00',1.95),('15529','2013-02-09','10:40:00',1.97),('15529','2013-02-09','10:45:00',2),('15529','2013-02-09','10:50:00',2.01),('15529','2013-02-09','10:55:00',2.02),('15529','2013-02-09','11:00:00',2.05),('15529','2013-02-09','11:05:00',2.07),('15529','2013-02-09','11:10:00',2.08),('15529','2013-02-09','11:15:00',2.07),('15529','2013-02-09','11:20:00',2.09),('15529','2013-02-09','11:25:00',2.11),('15529','2013-02-09','11:30:00',2.12),('15529','2013-02-09','11:35:00',2.13),('15529','2013-02-09','11:40:00',2.14),('15529','2013-02-09','11:45:00',2.15),('15529','2013-02-09','11:50:00',2.18),('15529','2013-02-09','11:55:00',2.17),('15529','2013-02-09','12:00:00',2.18),('15529','2013-02-09','12:05:00',2.19),('15529','2013-02-09','12:10:00',2.2),('15529','2013-02-09','12:15:00',2.21),('15529','2013-02-09','12:20:00',2.2),('15529','2013-02-09','12:25:00',2.2),('15529','2013-02-09','12:30:00',2.18),('15529','2013-02-09','12:35:00',2.2),('15529','2013-02-09','12:40:00',2.19),('15529','2013-02-09','12:45:00',2.18),('15529','2013-02-09','12:50:00',2.17),('15529','2013-02-09','12:55:00',2.17),('15529','2013-02-09','13:00:00',2.15),('15529','2013-02-09','13:05:00',2.14),('15529','2013-02-09','13:10:00',2.14),('15529','2013-02-09','13:15:00',2.12),('15529','2013-02-09','13:20:00',2.1),('15529','2013-02-09','13:25:00',2.07),('15529','2013-02-09','13:30:00',2.03),('15529','2013-02-09','13:35:00',2.03),('15529','2013-02-09','13:40:00',1.99),('15529','2013-02-09','13:45:00',1.97),('15529','2013-02-09','13:50:00',1.93),('15529','2013-02-09','13:55:00',1.9),('15529','2013-02-09','14:00:00',1.9),('15529','2013-02-09','14:05:00',1.87),('15529','2013-02-09','14:10:00',1.82),('15529','2013-02-09','14:15:00',1.79),('15529','2013-02-09','14:20:00',1.79),('15529','2013-02-09','14:25:00',1.8),('15529','2013-02-09','14:30:00',1.77),('15529','2013-02-09','14:35:00',1.74),('15529','2013-02-09','14:40:00',1.67),('15529','2013-02-09','14:45:00',1.65),('15529','2013-02-09','14:50:00',1.54),('15529','2013-02-09','14:55:00',1.55),('15529','2013-02-09','15:00:00',1.47),('15529','2013-02-09','15:05:00',1.46),('15529','2013-02-09','15:10:00',1.42),('15529','2013-02-09','15:15:00',1.43),('15529','2013-02-09','15:20:00',1.47),('15529','2013-02-09','15:25:00',1.3),('15529','2013-02-09','15:30:00',1.2),('15529','2013-02-09','15:35:00',1.41),('15529','2013-02-08','13:10:00',1.09),('15529','2013-02-08','13:15:00',1.25),('15529','2013-02-08','13:20:00',1.41),('15529','2013-02-08','13:25:00',1.58),('15529','2013-02-08','13:30:00',1.68),('15529','2013-02-08','13:35:00',1.87),('15529','2013-02-08','13:40:00',1.85),('15529','2013-02-08','13:45:00',2.08),('15529','2013-02-08','13:50:00',2.13),('15529','2013-02-08','13:55:00',2.09),('15529','2013-02-08','14:00:00',1.91),('15529','2013-02-08','14:05:00',1.9),('15529','2013-02-08','14:10:00',1.51),('15529','2013-02-08','14:15:00',1.82),('15529','2013-02-08','14:20:00',2.16),('15529','2013-02-08','14:25:00',1.99),('15529','2013-02-08','14:30:00',1.86),('15529','2013-02-08','14:35:00',1.73),('15529','2013-02-08','14:40:00',1.57),('15529','2013-02-08','14:45:00',1.54),('15529','2013-02-08','14:50:00',1.62),('15529','2013-02-08','14:55:00',1.55),('15529','2013-02-08','15:00:00',1.52),('15529','2013-02-08','15:05:00',1.47),('15529','2013-02-08','15:10:00',1.43),('15529','2013-02-08','15:15:00',1.34),('15529','2013-02-08','15:20:00',1.34),('15529','2013-02-08','15:25:00',1.04),('15529','2013-02-08','15:30:00',1.22),('15529','2013-02-08','15:35:00',1.18),('15529','2013-02-08','15:40:00',1.12),('15529','2013-02-08','15:45:00',1.03),('15529','2013-02-07','09:30:00',1.05),('15529','2013-02-07','09:35:00',1.86),('15529','2013-02-07','09:40:00',1.97),('15529','2013-02-07','09:45:00',1.35),('15529','2013-02-07','09:50:00',1.97),('15529','2013-02-07','09:55:00',1.94),('15529','2013-02-07','10:00:00',1.97),('15529','2013-02-07','10:05:00',2.01),('15529','2013-02-07','10:20:00',1.4),('15529','2013-02-07','10:25:00',1.97),('15529','2013-02-07','10:35:00',1.54),('15529','2013-02-07','10:40:00',2.18),('15529','2013-02-07','10:45:00',2.19),('15529','2013-02-07','10:50:00',2.26),('15529','2013-02-07','10:55:00',2.18),('15529','2013-02-07','11:00:00',2.09),('15529','2013-02-07','11:05:00',2.08),('15529','2013-02-07','11:10:00',2.1),('15529','2013-02-07','11:15:00',2.1),('15529','2013-02-07','11:20:00',2.11),('15529','2013-02-07','11:25:00',2.11),('15529','2013-02-07','11:30:00',2.12),('15529','2013-02-07','11:35:00',2.11),('15529','2013-02-07','11:40:00',2.13),('15529','2013-02-07','11:45:00',2.15),('15529','2013-02-07','11:50:00',2.15),('15529','2013-02-07','11:55:00',2.16),('15529','2013-02-07','12:00:00',2.16),('15529','2013-02-07','12:05:00',2.16),('15529','2013-02-07','12:10:00',2.17),('15529','2013-02-07','12:15:00',2.17),('15529','2013-02-07','12:20:00',2.18),('15529','2013-02-07','12:25:00',2.19),('15529','2013-02-07','12:30:00',2.19),('15529','2013-02-07','12:35:00',2.18),('15529','2013-02-07','12:40:00',2.09),('15529','2013-02-07','12:45:00',1.27),('15529','2013-02-07','12:50:00',1.7),('15529','2013-02-07','12:55:00',1.85),('15529','2013-02-07','13:00:00',1.4),('15529','2013-02-07','13:15:00',1.02),('15529','2013-02-07','13:20:00',1.06),('15529','2013-02-07','14:25:00',1.03),('15529','2013-02-07','14:30:00',1.52),('15529','2013-02-07','14:35:00',2.14),('15529','2013-02-07','14:40:00',1.67),('15529','2013-02-07','14:45:00',1.39),('15529','2013-02-07','14:50:00',1.53),('15529','2013-02-07','14:55:00',1.99),('15529','2013-02-07','15:00:00',1.93),('15529','2013-02-07','15:05:00',1.78),('15529','2013-02-07','15:10:00',1.67),('15529','2013-02-07','15:15:00',1.6),('15529','2013-02-07','15:20:00',1.48),('15529','2013-02-07','15:25:00',1.38),('15529','2013-02-07','15:30:00',1.31),('15529','2013-02-07','15:35:00',1.27),('15529','2013-02-07','15:40:00',1.22),('15529','2013-02-07','15:45:00',1.15),('15529','2013-02-07','15:50:00',1.09),('15529','2013-02-07','15:55:00',1.04),('15529','2013-02-06','10:35:00',1),('15529','2013-02-06','10:40:00',1.09),('15529','2013-02-06','10:45:00',1.23),('15529','2013-02-06','13:15:00',1.75),('15529','2013-02-06','13:20:00',1.11),('15529','2013-02-06','14:05:00',1.51),('15529','2013-02-06','14:10:00',2.14),('15529','2013-02-06','14:15:00',1.48),('15529','2013-02-06','15:00:00',1.11),('15529','2013-02-06','15:05:00',1.25),('15529','2013-02-05','10:35:00',1.04),('15529','2013-02-05','10:50:00',1.16),('15529','2013-02-05','10:55:00',1.2),('15529','2013-02-05','11:20:00',1.34),('15529','2013-02-05','11:25:00',1.43),('15529','2013-02-05','14:30:00',1.15),('15529','2013-02-04','08:50:00',1.02),('15529','2013-02-04','08:55:00',1.07),('15529','2013-02-04','09:00:00',1.14),('15529','2013-02-04','09:05:00',1.18),('15529','2013-02-04','09:10:00',1.25),('15529','2013-02-04','09:15:00',1.3),('15529','2013-02-04','09:20:00',1.34),('15529','2013-02-04','09:25:00',1.38),('15529','2013-02-04','09:30:00',1.42),('15529','2013-02-04','09:35:00',1.46),('15529','2013-02-04','09:40:00',1.49),('15529','2013-02-04','09:45:00',1.53),('15529','2013-02-04','09:50:00',1.57),('15529','2013-02-04','09:55:00',1.6),('15529','2013-02-04','10:00:00',1.63),('15529','2013-02-04','10:05:00',1.58),('15529','2013-02-04','10:10:00',1.56),('15529','2013-02-04','10:15:00',1.55),('15529','2013-02-04','10:20:00',1.73),('15529','2013-02-04','10:25:00',1.74),('15529','2013-02-04','10:30:00',1.77),('15529','2013-02-04','10:35:00',1.78),('15529','2013-02-04','10:40:00',1.77),('15529','2013-02-04','10:45:00',1.79),('15529','2013-02-04','10:50:00',1.8),('15529','2013-02-04','10:55:00',1.83),('15529','2013-02-04','11:00:00',1.85),('15529','2013-02-04','11:05:00',1.81),('15529','2013-02-04','11:10:00',1.9),('15529','2013-02-04','11:15:00',1.91),('15529','2013-02-04','11:20:00',1.9),('15529','2013-02-04','11:25:00',1.89),('15529','2013-02-04','11:30:00',1.76),('15529','2013-02-04','11:35:00',1.42),('15529','2013-02-04','11:40:00',1.01),('15529','2013-02-04','11:45:00',1.07),('15529','2013-02-04','12:30:00',1.37),('15529','2013-02-04','12:35:00',1.21),('15529','2013-02-04','12:45:00',1.29),('15529','2013-02-03','08:45:00',1.04),('15529','2013-02-03','08:50:00',1.09),('15529','2013-02-03','08:55:00',1.06),('15529','2013-02-03','09:00:00',1.22),('15529','2013-02-03','09:05:00',1.28),('15529','2013-02-03','09:10:00',1.33),('15529','2013-02-03','09:15:00',1.37),('15529','2013-02-03','09:20:00',1.22),('15529','2013-02-03','09:25:00',1.34),('15529','2013-02-03','09:30:00',1.45),('15529','2013-02-03','09:35:00',1.49),('15529','2013-02-03','09:40:00',1.52),('15529','2013-02-03','09:45:00',1.52),('15529','2013-02-03','09:50:00',1.66),('15529','2013-02-03','09:55:00',1.71),('15529','2013-02-03','10:00:00',1.75),('15529','2013-02-03','10:05:00',1.79),('15529','2013-02-03','10:10:00',1.81),('15529','2013-02-03','10:15:00',1.83),('15529','2013-02-03','10:20:00',1.68),('15529','2013-02-03','10:25:00',1.85),('15529','2013-02-03','10:30:00',1.69),('15529','2013-02-03','10:35:00',1.69),('15529','2013-02-03','10:40:00',1.8),('15529','2013-02-03','10:45:00',1.92),('15529','2013-02-03','10:50:00',1.96),('15529','2013-02-03','10:55:00',1.99),('15529','2013-02-03','11:00:00',1.96),('15529','2013-02-03','11:05:00',2.02),('15529','2013-02-03','11:10:00',2.03),('15529','2013-02-03','11:15:00',2.04),('15529','2013-02-03','11:20:00',2.04),('15529','2013-02-03','11:25:00',2.05),('15529','2013-02-03','11:30:00',2.06),('15529','2013-02-03','11:35:00',2.07),('15529','2013-02-03','11:40:00',2.08),('15529','2013-02-03','11:45:00',2.09),('15529','2013-02-03','11:50:00',2.09),('15529','2013-02-03','11:55:00',2.11),('15529','2013-02-03','12:00:00',2.11),('15529','2013-02-03','12:05:00',2.1),('15529','2013-02-03','12:10:00',2.11),('15529','2013-02-03','12:15:00',2.12),('15529','2013-02-03','12:20:00',2.12),('15529','2013-02-03','12:25:00',2.11),('15529','2013-02-03','12:30:00',2.1),('15529','2013-02-03','12:35:00',2.1),('15529','2013-02-03','12:40:00',2.1),('15529','2013-02-03','12:45:00',2.08),('15529','2013-02-03','12:50:00',2.06),('15529','2013-02-03','12:55:00',2.05),('15529','2013-02-03','13:00:00',2.06),('15529','2013-02-03','13:05:00',2.06),('15529','2013-02-03','13:10:00',2.05),('15529','2013-02-03','13:15:00',2.03),('15529','2013-02-03','13:20:00',2.02),('15529','2013-02-03','13:25:00',2.01),('15529','2013-02-03','13:30:00',1.99),('15529','2013-02-03','13:35:00',1.97),('15529','2013-02-03','13:40:00',1.96),('15529','2013-02-03','13:45:00',1.94),('15529','2013-02-03','13:50:00',1.93),('15529','2013-02-03','13:55:00',1.9),('15529','2013-02-03','14:00:00',1.87),('15529','2013-02-03','14:05:00',1.86),('15529','2013-02-03','14:10:00',1.84),('15529','2013-02-03','14:15:00',1.81),('15529','2013-02-03','14:20:00',1.79),('15529','2013-02-03','14:25:00',1.75),('15529','2013-02-03','14:30:00',1.72),('15529','2013-02-03','14:35:00',1.69),('15529','2013-02-03','14:40:00',1.66),('15529','2013-02-03','14:45:00',1.62),('15529','2013-02-03','14:50:00',1.59),('15529','2013-02-03','14:55:00',1.56),('15529','2013-02-03','15:00:00',1.52),('15529','2013-02-03','15:05:00',1.47),('15529','2013-02-03','15:10:00',1.43),('15529','2013-02-03','15:15:00',1.38),('15529','2013-02-03','15:20:00',1.34),('15529','2013-02-03','15:25:00',1.29),('15529','2013-02-03','15:30:00',1.24),('15529','2013-02-03','15:35:00',1.2),('15529','2013-02-03','15:40:00',1.15),('15529','2013-02-03','15:45:00',1.1),('15529','2013-02-03','15:50:00',1.05),('15529','2013-02-02','09:45:00',1.03),('15529','2013-02-01','10:45:00',1.06),('15529','2013-02-01','10:50:00',1.03),('15529','2013-02-01','10:55:00',1.26),('15529','2013-02-01','11:00:00',1.22),('15529','2013-02-01','11:05:00',1.06),('15529','2013-02-01','11:10:00',1.19),('15529','2013-02-01','11:15:00',1.06),('15529','2013-02-01','11:20:00',1.1),('15529','2013-02-01','11:25:00',1.32),('15529','2013-02-01','11:30:00',1.14),('15529','2013-02-01','11:35:00',1.02),('15529','2013-02-01','12:50:00',1.07),('15529','2013-02-01','12:55:00',1.53),('15529','2013-02-01','13:00:00',1),('15529','2013-02-01','13:05:00',1.06),('15529','2013-02-01','13:10:00',1.72),('15529','2013-02-01','13:15:00',1.01),('15529','2013-02-01','13:20:00',1.3),('15529','2013-02-01','13:35:00',1.28),('15529','2013-02-01','13:40:00',1.29),('15529','2013-01-31','09:00:00',1.06),('15529','2013-01-31','09:20:00',1.08),('15529','2013-01-31','09:50:00',1.15),('15529','2013-01-31','10:55:00',1.77),('15529','2013-01-31','11:00:00',1.59),('15529','2013-01-31','11:25:00',1.25),('15529','2013-01-31','11:40:00',1.01),('15529','2013-01-31','11:45:00',1.25),('15529','2013-01-31','11:50:00',2.09),('15529','2013-01-31','11:55:00',1),('15529','2013-01-31','12:00:00',1.38),('15529','2013-01-31','12:05:00',2.29),('15529','2013-01-31','12:15:00',2.09),('15529','2013-01-31','12:20:00',2.17),('15529','2013-01-31','12:25:00',1.65),('15529','2013-01-31','12:30:00',1.13),('15529','2013-01-31','12:35:00',1.41),('15529','2013-01-31','12:40:00',2.12),('15529','2013-01-31','12:45:00',2.08),('15529','2013-01-31','12:50:00',1.31),('15529','2013-01-31','12:55:00',1.97),('15529','2013-01-31','13:00:00',2.08),('15529','2013-01-31','13:05:00',1.96),('15529','2013-01-31','13:10:00',1.96),('15529','2013-01-31','13:15:00',1.97),('15529','2013-01-31','13:20:00',2.02),('15529','2013-01-31','13:25:00',1.12),('15529','2013-01-31','13:50:00',1.63),('15529','2013-01-31','13:55:00',1.5),('15529','2013-01-31','14:00:00',1.77),('15529','2013-01-31','14:05:00',1.62),('15529','2013-01-31','14:10:00',1.36),('15529','2013-01-31','14:25:00',1.68),('15529','2013-01-31','14:30:00',1.67),('15529','2013-01-31','14:35:00',1.65),('15529','2013-01-31','15:30:00',1.15),('15529','2014-03-20','08:25:00',1.05),('15529','2014-03-20','08:30:00',1.1),('15529','2014-03-20','08:35:00',1.14),('15529','2014-03-20','08:40:00',1.19),('15529','2014-03-20','08:45:00',1.22),('15529','2014-03-20','08:50:00',1.27),('15529','2014-03-20','08:55:00',1.31),('15529','2014-03-20','09:00:00',1.36),('15529','2014-03-20','09:05:00',1.4),('15529','2014-03-20','09:10:00',1.46),('15529','2014-03-20','09:15:00',1.5),('15529','2014-03-20','09:20:00',1.56),('15529','2014-03-20','09:25:00',1.51),('15529','2014-03-20','09:30:00',1.58),('15529','2014-03-20','09:35:00',1.58),('15529','2014-03-20','09:40:00',1.65),('15529','2014-03-20','09:45:00',1.69),('15529','2014-03-20','09:50:00',1.74),('15529','2014-03-20','09:55:00',1.73),('15529','2014-03-20','10:00:00',1.76),('15529','2014-03-20','10:05:00',1.8),('15529','2014-03-20','10:10:00',1.81),('15529','2014-03-20','10:15:00',1.84),('15529','2014-03-20','10:20:00',1.86),('15529','2014-03-20','10:25:00',1.9),('15529','2014-03-20','10:30:00',1.88),('15529','2014-03-20','10:35:00',1.87),('15529','2014-03-20','10:40:00',1.86),('15529','2014-03-20','10:45:00',1.89),('15529','2014-03-20','10:50:00',1.9),('15529','2014-03-20','10:55:00',1.92),('15529','2014-03-20','11:00:00',1.92),('15529','2014-03-20','11:05:00',1.95),('15529','2014-03-20','11:10:00',2.03),('15529','2014-03-20','11:15:00',2.06),('15529','2014-03-20','11:20:00',1.76),('15529','2014-03-20','11:25:00',1.88),('15529','2014-03-20','11:30:00',1.84),('15529','2014-03-20','11:35:00',1.94),('15529','2014-03-20','11:40:00',2.08),('15529','2014-03-20','11:45:00',2.02),('15529','2014-03-20','11:50:00',1.94),('15529','2014-03-20','11:55:00',1.22),('15529','2014-03-20','12:00:00',1.89),('15529','2014-03-20','12:05:00',2.06),('15529','2014-03-20','12:10:00',2.04),('15529','2014-03-20','12:15:00',2.1),('15529','2014-03-20','12:20:00',2.12),('15529','2014-03-20','12:25:00',2.12),('15529','2014-03-20','12:30:00',2.14),('15529','2014-03-20','12:35:00',2.17),('15529','2014-03-20','12:40:00',2.16),('15529','2014-03-20','12:45:00',2.14),('15529','2014-03-20','12:50:00',2.13),('15529','2014-03-20','12:55:00',2.12),('15529','2014-03-20','13:00:00',2.13),('15529','2014-03-20','13:05:00',2.11),('15529','2014-03-20','13:10:00',2.12),('15529','2014-03-20','13:15:00',2.11),('15529','2014-03-20','13:20:00',2.11),('15529','2014-03-20','13:25:00',2.09),('15529','2014-03-20','13:30:00',2.07),('15529','2014-03-20','13:35:00',2.07),('15529','2014-03-20','13:40:00',2.04),('15529','2014-03-20','13:45:00',2.04),('15529','2014-03-20','13:50:00',2.03),('15529','2014-03-20','13:55:00',2.02),('15529','2014-03-20','14:00:00',2),('15529','2014-03-20','14:05:00',2.01),('15529','2014-03-20','14:10:00',1.98),('15529','2014-03-20','14:15:00',1.93),('15529','2014-03-20','14:20:00',1.91),('15529','2014-03-20','14:25:00',1.87),('15529','2014-03-20','14:30:00',1.82),('15529','2014-03-20','14:35:00',1.73),('15529','2014-03-20','14:40:00',1.72),('15529','2014-03-20','14:45:00',1.4),('15529','2014-03-20','15:00:00',1.04),('15529','2014-03-20','15:05:00',1.32),('15529','2014-03-20','15:10:00',1.75),('15529','2014-03-20','15:15:00',1.62),('15529','2014-03-20','15:25:00',1.64),('15529','2014-03-20','15:30:00',1.49),('15529','2014-03-20','15:35:00',1.41),('15529','2014-03-20','15:40:00',1.38),('15529','2014-03-20','15:45:00',1.45),('15529','2014-03-20','15:50:00',1.44),('15529','2014-03-20','15:55:00',1.37),('15529','2014-03-20','16:00:00',1.27),('15529','2014-03-20','16:05:00',1.17),('15529','2014-03-20','16:10:00',1.09),('15529','2014-03-20','16:15:00',1.01),('15529','2013-01-30','13:35:00',1.79),('15529','2013-01-30','13:40:00',1.78),('15529','2013-01-30','13:45:00',1.76),('15529','2013-01-30','13:50:00',1.74),('15529','2013-01-30','13:55:00',1.68),('15529','2013-01-30','14:00:00',1.7),('15529','2013-01-30','14:05:00',1.65),('15529','2013-01-30','14:10:00',1.61),('15529','2013-01-30','14:15:00',1.57),('15529','2013-01-30','14:20:00',1.54),('15529','2013-01-30','14:30:00',1.5),('15529','2013-01-30','14:35:00',1.46),('15529','2013-01-30','14:40:00',1.44),('15529','2013-01-30','14:45:00',1.43),('15529','2013-01-30','14:50:00',1.38),('15529','2013-01-30','14:55:00',1.35),('15529','2013-01-30','15:00:00',1.32),('15529','2013-01-30','15:05:00',1.26),('15529','2013-01-30','15:10:00',1.22),('15529','2013-01-30','15:15:00',1.19),('15529','2013-01-30','15:20:00',1.14),('15529','2013-01-30','15:25:00',1.03),('15529','2013-01-30','15:30:00',1.01),('15529','2013-01-30','15:35:00',1.04),('15529','2014-03-19','08:25:00',1.04),('15529','2014-03-19','08:30:00',1.1),('15529','2014-03-19','08:35:00',1.17),('15529','2014-03-19','08:40:00',1.22),('15529','2014-03-19','08:45:00',1.28),('15529','2014-03-19','08:50:00',1.3),('15529','2014-03-19','08:55:00',1.34),('15529','2014-03-19','09:00:00',1.35),('15529','2014-03-19','09:05:00',1.46),('15529','2014-03-19','09:10:00',1.48),('15529','2014-03-19','09:15:00',1.5),('15529','2014-03-19','09:20:00',1.53),('15529','2014-03-19','09:25:00',1.54),('15529','2014-03-19','09:30:00',1.59),('15529','2014-03-19','09:35:00',1.6),('15529','2014-03-19','09:40:00',1.66),('15529','2014-03-19','09:45:00',1.66),('15529','2014-03-19','09:50:00',1.66),('15529','2014-03-19','09:55:00',1.74),('15529','2014-03-19','10:00:00',1.8),('15529','2014-03-19','10:05:00',1.84),('15529','2014-03-19','10:10:00',1.84),('15529','2014-03-19','10:15:00',1.83),('15529','2014-03-19','10:20:00',1.82),('15529','2014-03-19','10:25:00',1.91),('15529','2014-03-19','10:30:00',1.9),('15529','2014-03-19','10:35:00',1.83),('15529','2014-03-19','10:40:00',1.81),('15529','2014-03-19','10:45:00',1.91),('15529','2014-03-19','10:50:00',2.03),('15529','2014-03-19','10:55:00',2.06),('15529','2014-03-19','11:00:00',2.06),('15529','2014-03-19','11:05:00',2.05),('15529','2014-03-19','11:10:00',2),('15529','2014-03-19','11:15:00',1.92),('15529','2014-03-19','11:20:00',2),('15529','2014-03-19','11:25:00',2.02),('15529','2014-03-19','11:30:00',2.08),('15529','2014-03-19','11:35:00',2.09),('15529','2014-03-19','11:40:00',2.14),('15529','2014-03-19','11:45:00',2.01),('15529','2014-03-19','11:50:00',2.01),('15529','2014-03-19','11:55:00',1.83),('15529','2014-03-19','12:00:00',1.79),('15529','2014-03-19','12:05:00',2.09),('15529','2014-03-19','12:10:00',2.1),('15529','2014-03-19','12:15:00',2.15),('15529','2014-03-19','12:20:00',2.04),('15529','2014-03-19','12:25:00',1.98),('15529','2014-03-19','12:30:00',2.06),('15529','2014-03-19','12:35:00',2.15),('15529','2014-03-19','12:40:00',2.18),('15529','2014-03-19','12:45:00',2.14),('15529','2014-03-19','12:50:00',2.13),('15529','2014-03-19','12:55:00',2.12),('15529','2014-03-19','13:00:00',2.1),('15529','2014-03-19','13:05:00',2.12),('15529','2014-03-19','13:10:00',2.09),('15529','2014-03-19','13:15:00',2.06),('15529','2014-03-19','13:20:00',2.04),('15529','2014-03-19','13:25:00',2.02),('15529','2014-03-19','13:30:00',2.02),('15529','2014-03-19','13:35:00',1.94),('15529','2014-03-19','13:40:00',1.84),('15529','2014-03-19','13:45:00',1.81),('15529','2014-03-19','13:50:00',1.71),('15529','2014-03-19','13:55:00',1.61),('15529','2014-03-19','14:00:00',1.72),('15529','2014-03-19','14:05:00',1.76),('15529','2014-03-19','14:10:00',1.69),('15529','2014-03-19','14:15:00',1.67),('15529','2014-03-19','14:20:00',1.52),('15529','2014-03-19','14:25:00',1.39),('15529','2014-03-19','14:30:00',1.33),('15529','2014-03-19','14:35:00',1.35),('15529','2014-03-19','14:40:00',1.35),('15529','2014-03-19','14:45:00',1.35),('15529','2014-03-19','14:50:00',1.3),('15529','2014-03-19','14:55:00',1.28),('15529','2014-03-19','15:00:00',1.22),('15529','2014-03-19','15:05:00',1.25),('15529','2014-03-19','15:10:00',1.26),('15529','2014-03-19','15:15:00',1.19),('15529','2014-03-19','15:20:00',1.21),('15529','2014-03-19','15:25:00',1.09),('15529','2014-03-19','15:30:00',1.02),('15529','2014-03-18','09:30:00',1.39),('15529','2014-03-18','09:40:00',1.22),('15529','2014-03-18','10:35:00',1.61),('15529','2014-03-18','10:40:00',2.03),('15529','2014-03-18','10:45:00',2.27),('15529','2014-03-18','10:50:00',1.97),('15529','2014-03-18','10:55:00',1.76),('15529','2014-03-18','11:30:00',1.41),('15529','2014-03-18','11:40:00',1.71),('15529','2014-03-18','11:45:00',1.76),('15529','2014-03-18','11:50:00',1.59),('15529','2014-03-18','11:55:00',1.79),('15529','2014-03-18','12:00:00',1.96),('15529','2014-03-18','12:05:00',1),('15529','2014-03-18','12:10:00',2.14),('15529','2014-03-18','12:15:00',2.39),('15529','2014-03-18','12:20:00',1.69),('15529','2014-03-18','12:25:00',2.16),('15529','2014-03-18','12:30:00',1.94),('15529','2014-03-18','12:35:00',2.11),('15529','2014-03-18','12:40:00',2.14),('15529','2014-03-18','12:45:00',2.17),('15529','2014-03-18','12:50:00',2.13),('15529','2014-03-18','12:55:00',1.46),('15529','2014-03-18','13:00:00',1.45),('15529','2014-03-18','13:05:00',2.1),('15529','2014-03-18','13:10:00',2.15),('15529','2014-03-18','13:15:00',2.13),('15529','2014-03-18','13:20:00',1.79),('15529','2014-03-18','13:25:00',1.87),('15529','2014-03-18','13:30:00',2.09),('15529','2014-03-18','13:35:00',2.07),('15529','2014-03-18','13:40:00',2.03),('15529','2014-03-18','13:45:00',1.99),('15529','2014-03-18','13:50:00',1.92),('15529','2014-03-18','13:55:00',1.95),('15529','2014-03-18','14:00:00',1.92),('15529','2014-03-18','14:05:00',1.92),('15529','2014-03-18','14:10:00',1.89),('15529','2014-03-18','14:15:00',1.85),('15529','2014-03-18','14:20:00',1.83),('15529','2014-03-18','14:25:00',1.8),('15529','2014-03-18','14:30:00',1.74),('15529','2014-03-18','14:35:00',1.78),('15529','2014-03-18','14:40:00',1.73),('15529','2014-03-18','14:45:00',1.71),('15529','2014-03-18','14:50:00',1.64),('15529','2014-03-18','14:55:00',1.6),('15529','2014-03-18','15:00:00',1.58),('15529','2014-03-18','15:05:00',1.56),('15529','2014-03-18','15:10:00',1.54),('15529','2014-03-18','15:15:00',1.49),('15529','2014-03-18','15:20:00',1.44),('15529','2014-03-18','15:25:00',1.43),('15529','2014-03-18','15:30:00',1.37),('15529','2014-03-18','15:35:00',1.29),('15529','2014-03-18','15:40:00',1.28),('15529','2014-03-18','15:45:00',1.26),('15529','2014-03-18','15:50:00',1.2),('15529','2014-03-18','15:55:00',1.17),('15529','2014-03-18','16:00:00',1.11),('15529','2014-03-18','16:05:00',1.07),('15529','2014-03-18','16:10:00',1.03),('15529','2014-03-17','08:30:00',1.04),('15529','2014-03-17','08:35:00',1.3),('15529','2014-03-17','08:40:00',1.36),('15529','2014-03-17','09:20:00',1.09),('15529','2014-03-17','09:25:00',1.06),('15529','2014-03-17','09:45:00',1.16),('15529','2014-03-17','09:50:00',1.71),('15529','2014-03-17','09:55:00',1.85),('15529','2014-03-17','10:00:00',2.03),('15529','2014-03-17','10:05:00',2.01),('15529','2014-03-17','10:10:00',1.67),('15529','2014-03-17','10:15:00',2.1),('15529','2014-03-17','10:20:00',1.32),('15529','2014-03-17','10:35:00',1.07),('15529','2014-03-17','10:55:00',1.62),('15529','2014-03-17','11:00:00',1.23),('15529','2014-03-17','11:10:00',1.9),('15529','2014-03-17','11:15:00',2.52),('15529','2014-03-17','11:20:00',2.47),('15529','2014-03-17','11:25:00',2.32),('15529','2014-03-17','11:30:00',2.3),('15529','2014-03-17','11:35:00',2.5),('15529','2014-03-17','11:40:00',1.91),('15529','2014-03-17','11:45:00',2.08),('15529','2014-03-17','11:50:00',1.74),('15529','2014-03-17','11:55:00',1.26),('15529','2014-03-17','12:00:00',2.45),('15529','2014-03-17','12:05:00',2.32),('15529','2014-03-17','12:10:00',1.38),('15529','2014-03-17','12:20:00',1.33),('15529','2014-03-17','12:25:00',2.45),('15529','2014-03-17','12:30:00',2.29),('15529','2014-03-17','12:35:00',2.29),('15529','2014-03-17','12:40:00',2.22),('15529','2014-03-17','12:45:00',2.21),('15529','2014-03-17','12:50:00',1.64),('15529','2014-03-17','12:55:00',1.67),('15529','2014-03-17','13:00:00',2.24),('15529','2014-03-17','13:05:00',1.41),('15529','2014-03-17','13:10:00',1.83),('15529','2014-03-17','13:15:00',2.1),('15529','2014-03-17','13:20:00',2.11),('15529','2014-03-17','13:25:00',2.09),('15529','2014-03-17','13:30:00',2.11),('15529','2014-03-17','13:35:00',2.08),('15529','2014-03-17','13:40:00',2.07),('15529','2014-03-17','13:45:00',2.04),('15529','2014-03-17','13:50:00',2.05),('15529','2014-03-17','13:55:00',1.99),('15529','2014-03-17','14:00:00',1.99),('15529','2014-03-17','14:05:00',1.96),('15529','2014-03-17','14:10:00',1.93),('15529','2014-03-17','14:15:00',1.92),('15529','2014-03-17','14:20:00',1.87),('15529','2014-03-17','14:25:00',1.83),('15529','2014-03-17','14:30:00',1.83),('15529','2014-03-17','14:35:00',1.81),('15529','2014-03-17','14:40:00',1.76),('15529','2014-03-17','14:45:00',1.72),('15529','2014-03-17','14:50:00',1.68),('15529','2014-03-17','14:55:00',1.66),('15529','2014-03-17','15:00:00',1.63),('15529','2014-03-17','15:05:00',1.6),('15529','2014-03-17','15:10:00',1.56),('15529','2014-03-17','15:15:00',1.51),('15529','2014-03-17','15:20:00',1.48),('15529','2014-03-17','15:25:00',1.45),('15529','2014-03-17','15:30:00',1.4),('15529','2014-03-17','15:35:00',1.36),('15529','2014-03-17','15:40:00',1.29),('15529','2014-03-17','15:45:00',1.24),('15529','2014-03-17','15:50:00',1.19),('15529','2014-03-17','15:55:00',1.15),('15529','2014-03-17','16:00:00',1.07),('15529','2014-03-17','16:05:00',1.05),('15529','2014-04-30','08:40:00',1.03),('15529','2014-04-30','08:45:00',1.09),('15529','2014-04-30','09:00:00',1.1),('15529','2014-04-30','09:20:00',1.38),('15529','2014-04-30','09:25:00',1.58),('15529','2014-04-30','09:30:00',1.73),('15529','2014-04-30','09:35:00',1.7),('15529','2014-04-30','10:15:00',1.04),('15529','2014-04-30','10:20:00',1.99),('15529','2014-04-30','10:25:00',1.2),('15529','2014-04-30','10:30:00',1.3),('15529','2014-04-30','10:35:00',1.84),('15529','2014-04-30','10:45:00',1.7),('15529','2014-04-30','10:50:00',2.36),('15529','2014-04-30','10:55:00',2.39),('15529','2014-04-30','11:00:00',1.71),('15529','2014-04-30','11:05:00',2.3),('15529','2014-04-30','11:10:00',2.22),('15529','2014-04-30','11:15:00',2.26),('15529','2014-04-30','11:20:00',2.4),('15529','2014-04-30','11:25:00',1.2),('15529','2014-04-30','11:40:00',2.24),('15529','2014-04-30','11:45:00',2.48),('15529','2014-04-30','11:50:00',2.53),('15529','2014-04-30','11:55:00',2.57),('15529','2014-04-30','12:00:00',2.06),('15529','2014-04-30','12:05:00',1.86),('15529','2014-04-30','12:10:00',1.95),('15529','2014-04-30','12:15:00',1.82),('15529','2014-04-30','12:20:00',1.12),('15529','2014-04-30','12:25:00',2.61),('15529','2014-04-30','12:30:00',1.39),('15529','2014-04-30','12:40:00',1.59),('15529','2014-04-30','12:45:00',2.8),('15529','2014-04-30','12:50:00',1.74),('15529','2014-04-30','13:05:00',1.91),('15529','2014-04-30','13:10:00',2.3),('15529','2014-04-30','13:15:00',2.53),('15529','2014-04-30','13:20:00',1.78),('15529','2014-04-30','13:25:00',2.67),('15529','2014-04-30','13:30:00',2.64),('15529','2014-04-30','13:35:00',2.6),('15529','2014-04-30','13:40:00',2.67),('15529','2014-04-30','13:45:00',2.57),('15529','2014-04-30','13:50:00',2.48),('15529','2014-04-30','13:55:00',2.48),('15529','2014-04-30','14:00:00',2.43),('15529','2014-04-30','14:05:00',2.34),('15529','2014-04-30','14:10:00',2.34),('15529','2014-04-30','14:15:00',2.3),('15529','2014-04-30','14:20:00',2.22),('15529','2014-04-30','14:25:00',2.25),('15529','2014-04-30','14:30:00',2.17),('15529','2014-04-30','14:35:00',2.15),('15529','2014-04-30','14:40:00',2.23),('15529','2014-04-30','14:45:00',2.25),('15529','2014-04-30','14:50:00',2.04),('15529','2014-04-30','14:55:00',2.21),('15529','2014-04-30','15:00:00',2.22),('15529','2014-04-30','15:05:00',1.43),('15529','2014-04-30','15:10:00',2.02),('15529','2014-04-30','15:15:00',2.06),('15529','2014-04-30','15:20:00',2.08),('15529','2014-04-30','15:25:00',2.05),('15529','2014-04-30','15:30:00',2),('15529','2014-04-30','15:35:00',1.97),('15529','2014-04-30','15:40:00',1.94),('15529','2014-04-30','15:45:00',1.87),('15529','2014-04-30','15:50:00',1.86),('15529','2014-04-30','15:55:00',1.79),('15529','2014-04-30','16:00:00',1.81),('15529','2014-04-30','16:05:00',1.79),('15529','2014-04-30','16:10:00',1.68),('15529','2014-04-30','16:15:00',1.67),('15529','2014-04-30','16:20:00',1.55),('15529','2014-04-30','16:25:00',1.49),('15529','2014-04-30','16:30:00',1.55),('15529','2014-04-30','16:35:00',1.54),('15529','2014-04-30','16:40:00',1.41),('15529','2014-04-30','16:45:00',1.18),('15529','2014-04-30','16:55:00',1.37),('15529','2014-04-30','17:00:00',1.19),('15529','2014-04-30','17:05:00',1.18),('15529','2014-04-30','17:10:00',1.23),('15529','2014-04-30','17:15:00',1.17),('15529','2014-04-30','17:20:00',1.11),('15529','2014-04-30','17:25:00',1.07),('15529','2014-04-30','17:30:00',1.03),('15529','2014-03-16','11:05:00',1),('15529','2014-03-16','11:10:00',1.17),('15529','2014-03-16','12:20:00',1.32),('15529','2014-03-16','12:25:00',1.81),('15529','2014-03-16','12:30:00',1.55),('15529','2014-03-16','12:35:00',2.27),('15529','2014-03-16','12:40:00',2.35),('15529','2014-03-16','12:45:00',1.4),('15529','2014-03-16','12:50:00',1.48),('15529','2014-03-16','12:55:00',2.34),('15529','2014-03-16','13:00:00',2.14),('15529','2014-03-16','13:05:00',2.09),('15529','2014-03-16','13:10:00',2.23),('15529','2014-03-16','13:15:00',1.95),('15529','2014-03-16','13:20:00',1.96),('15529','2014-03-16','13:25:00',2),('15529','2014-03-16','13:30:00',1.16),('15529','2014-03-16','13:35:00',1.3),('15529','2014-03-16','13:40:00',1.78),('15529','2014-03-16','13:45:00',2.17),('15529','2014-03-16','13:50:00',1.51),('15529','2014-03-16','13:55:00',1.54),('15529','2014-03-16','14:00:00',2.16),('15529','2014-03-16','14:05:00',1.23),('15529','2014-03-16','14:15:00',1.94),('15529','2014-03-16','14:20:00',1.92),('15529','2014-03-16','14:25:00',1.88),('15529','2014-03-16','14:30:00',1.85),('15529','2014-03-16','14:35:00',1.27),('15529','2014-03-16','14:40:00',1.75),('15529','2014-03-16','14:45:00',1.7),('15529','2014-03-16','14:50:00',1.3),('15529','2014-03-16','15:00:00',1.72),('15529','2014-03-16','15:05:00',1.68),('15529','2014-03-16','15:25:00',1.31),('15529','2014-03-16','15:30:00',1.28),('15529','2014-03-16','15:35:00',1.26),('15529','2014-03-16','15:40:00',1.08),('15529','2014-03-16','15:45:00',1.25),('15529','2014-03-16','16:05:00',1.07),('15529','2014-03-16','16:10:00',1.08),('15529','2014-03-15','08:35:00',1.01),('15529','2014-03-15','08:40:00',1.03),('15529','2014-03-15','08:45:00',1.1),('15529','2014-03-15','08:50:00',1.13),('15529','2014-03-15','08:55:00',1.17),('15529','2014-03-15','09:00:00',1.16),('15529','2014-03-15','09:05:00',1.2),('15529','2014-03-15','09:10:00',1.26),('15529','2014-03-15','09:15:00',1.37),('15529','2014-03-15','09:20:00',1.4),('15529','2014-03-15','09:25:00',1.39),('15529','2014-03-15','09:30:00',1.41),('15529','2014-03-15','09:35:00',1.42),('15529','2014-03-15','09:40:00',1.49),('15529','2014-03-15','09:45:00',1.53),('15529','2014-03-15','09:50:00',1.6),('15529','2014-03-15','09:55:00',1.62),('15529','2014-03-15','10:00:00',1.66),('15529','2014-03-15','10:05:00',1.68),('15529','2014-03-15','10:10:00',1.72),('15529','2014-03-15','10:15:00',1.78),('15529','2014-03-15','10:20:00',1.76),('15529','2014-03-15','10:25:00',1.74),('15529','2014-03-15','10:30:00',1.78),('15529','2014-03-15','10:35:00',1.85),('15529','2014-03-15','10:40:00',1.9),('15529','2014-03-15','10:45:00',1.94),('15529','2014-03-15','10:50:00',1.95),('15529','2014-03-15','10:55:00',1.96),('15529','2014-03-15','11:00:00',1.95),('15529','2014-03-15','11:05:00',1.93),('15529','2014-03-15','11:10:00',1.89),('15529','2014-03-15','11:15:00',2),('15529','2014-03-15','11:20:00',2.05),('15529','2014-03-15','11:25:00',2.01),('15529','2014-03-15','11:30:00',2.02),('15529','2014-03-15','11:35:00',2.03),('15529','2014-03-15','11:40:00',2.06),('15529','2014-03-15','11:45:00',2),('15529','2014-03-15','11:50:00',2),('15529','2014-03-15','11:55:00',2.01),('15529','2014-03-15','12:00:00',2.06),('15529','2014-03-15','12:05:00',2.08),('15529','2014-03-15','12:10:00',2.14),('15529','2014-03-15','12:15:00',2.11),('15529','2014-03-15','12:20:00',2.08),('15529','2014-03-15','12:25:00',2.08),('15529','2014-03-15','12:30:00',2.07),('15529','2014-03-15','12:35:00',2.03),('15529','2014-03-15','12:40:00',2.04),('15529','2014-03-15','12:45:00',2.07),('15529','2014-03-15','12:50:00',2.08),('15529','2014-03-15','12:55:00',1.98),('15529','2014-03-15','13:00:00',1.95),('15529','2014-03-15','13:05:00',1.96),('15529','2014-03-15','13:10:00',2),('15529','2014-03-15','13:15:00',1.96),('15529','2014-03-15','13:20:00',1.92),('15529','2014-03-15','13:25:00',1.94),('15529','2014-03-15','13:30:00',1.94),('15529','2014-03-15','13:35:00',1.94),('15529','2014-03-15','13:40:00',1.96),('15529','2014-03-15','13:45:00',1.95),('15529','2014-03-15','13:50:00',1.93),('15529','2014-03-15','13:55:00',1.9),('15529','2014-03-15','14:00:00',1.87),('15529','2014-03-15','14:05:00',1.86),('15529','2014-03-15','14:10:00',1.78),('15529','2014-03-15','14:15:00',1.75),('15529','2014-03-15','14:20:00',1.73),('15529','2014-03-15','14:25:00',1.74),('15529','2014-03-15','14:30:00',1.71),('15529','2014-03-15','14:35:00',1.66),('15529','2014-03-15','14:40:00',1.64),('15529','2014-03-15','14:45:00',1.66),('15529','2014-03-15','14:50:00',1.48),('15529','2014-03-15','14:55:00',1.51),('15529','2014-03-15','15:00:00',1.49),('15529','2014-03-15','15:05:00',1.45),('15529','2014-03-15','15:10:00',1.35),('15529','2014-03-15','15:15:00',1.2),('15529','2014-03-15','15:20:00',1.03),('15529','2014-03-15','15:25:00',1.19),('15529','2014-03-15','15:30:00',1.05),('15529','2014-03-14','08:40:00',1.01),('15529','2014-03-14','08:45:00',1.06),('15529','2014-03-14','08:50:00',1.1),('15529','2014-03-14','08:55:00',1.15),('15529','2014-03-14','09:00:00',1.2),('15529','2014-03-14','09:05:00',1.24),('15529','2014-03-14','09:10:00',1.28),('15529','2014-03-14','09:15:00',1.32),('15529','2014-03-14','09:20:00',1.36),('15529','2014-03-14','09:25:00',1.39),('15529','2014-03-14','09:30:00',1.42),('15529','2014-03-14','09:35:00',1.46),('15529','2014-03-14','09:40:00',1.5),('15529','2014-03-14','09:45:00',1.52),('15529','2014-03-14','09:50:00',1.56),('15529','2014-03-14','09:55:00',1.58),('15529','2014-03-14','10:00:00',1.62),('15529','2014-03-14','10:05:00',1.64),('15529','2014-03-14','10:10:00',1.67),('15529','2014-03-14','10:15:00',1.69),('15529','2014-03-14','10:20:00',1.72),('15529','2014-03-14','10:25:00',1.75),('15529','2014-03-14','10:30:00',1.77),('15529','2014-03-14','10:35:00',1.74),('15529','2014-03-14','10:40:00',1.81),('15529','2014-03-14','10:45:00',1.83),('15529','2014-03-14','10:50:00',1.89),('15529','2014-03-14','10:55:00',1.87),('15529','2014-03-14','11:00:00',1.93),('15529','2014-03-14','11:05:00',1.94),('15529','2014-03-14','11:10:00',2),('15529','2014-03-14','11:15:00',1.96),('15529','2014-03-14','11:20:00',1.97),('15529','2014-03-14','11:25:00',2.01),('15529','2014-03-14','11:30:00',2.02),('15529','2014-03-14','11:35:00',2.03),('15529','2014-03-14','11:40:00',1.99),('15529','2014-03-14','11:45:00',2.02),('15529','2014-03-14','11:50:00',1.99),('15529','2014-03-14','11:55:00',1.99),('15529','2014-03-14','12:00:00',2.01),('15529','2014-03-14','12:05:00',2.03),('15529','2014-03-14','12:10:00',2.02),('15529','2014-03-14','12:15:00',2.06),('15529','2014-03-14','12:20:00',2.1),('15529','2014-03-14','12:25:00',2.12),('15529','2014-03-14','12:30:00',2.08),('15529','2014-03-14','12:35:00',2.12),('15529','2014-03-14','12:40:00',2.07),('15529','2014-03-14','12:45:00',2.07),('15529','2014-03-14','12:50:00',2.04),('15529','2014-03-14','12:55:00',2.08),('15529','2014-03-14','13:00:00',2.06),('15529','2014-03-14','13:05:00',2.04),('15529','2014-03-14','13:10:00',2.04),('15529','2014-03-14','13:15:00',2.03),('15529','2014-03-14','13:20:00',2.04),('15529','2014-03-14','13:25:00',2.03),('15529','2014-03-14','13:30:00',2.02),('15529','2014-03-14','13:35:00',2.02),('15529','2014-03-14','13:40:00',2.01),('15529','2014-03-14','13:45:00',1.97),('15529','2014-03-14','13:50:00',1.97),('15529','2014-03-14','13:55:00',1.96),('15529','2014-03-14','14:00:00',1.93),('15529','2014-03-14','14:05:00',1.91),('15529','2014-03-14','14:10:00',1.89),('15529','2014-03-14','14:15:00',1.85),('15529','2014-03-14','14:20:00',1.83),('15529','2014-03-14','14:25:00',1.81),('15529','2014-03-14','14:30:00',1.77),('15529','2014-03-14','14:35:00',1.75),('15529','2014-03-14','14:40:00',1.71),('15529','2014-03-14','14:45:00',1.66),('15529','2014-03-14','14:50:00',1.63),('15529','2014-03-14','14:55:00',1.6),('15529','2014-03-14','15:00:00',1.56),('15529','2014-03-14','15:05:00',1.52),('15529','2014-03-14','15:10:00',1.47),('15529','2014-03-14','15:15:00',1.43),('15529','2014-03-14','15:20:00',1.39),('15529','2014-03-14','15:25:00',1.36),('15529','2014-03-14','15:30:00',1.3),('15529','2014-03-14','15:35:00',1.25),('15529','2014-03-14','15:40:00',1.21),('15529','2014-03-14','15:45:00',1.17),('15529','2014-03-14','15:50:00',1.12),('15529','2014-03-14','15:55:00',1.06),('15529','2014-03-13','09:40:00',1.17),('15529','2014-03-13','09:45:00',1.36),('15529','2014-03-13','09:50:00',1.63),('15529','2014-03-13','09:55:00',1.79),('15529','2014-03-13','10:00:00',1.89),('15529','2014-03-13','10:05:00',1.95),('15529','2014-03-13','10:10:00',1.99),('15529','2014-03-13','10:15:00',1.96),('15529','2014-03-13','10:20:00',1.91),('15529','2014-03-13','10:25:00',1.82),('15529','2014-03-13','10:30:00',1.8),('15529','2014-03-13','10:35:00',1.91),('15529','2014-03-13','10:40:00',1.93),('15529','2014-03-13','10:45:00',1.85),('15529','2014-03-13','10:50:00',1.17),('15529','2014-03-13','10:55:00',1.5),('15529','2014-03-13','11:00:00',1.85),('15529','2014-03-13','11:05:00',1.86),('15529','2014-03-13','11:10:00',2.01),('15529','2014-03-13','11:15:00',2.03),('15529','2014-03-13','11:20:00',1.99),('15529','2014-03-13','11:25:00',1.96),('15529','2014-03-13','11:30:00',1.96),('15529','2014-03-13','11:35:00',1.95),('15529','2014-03-13','11:40:00',1.98),('15529','2014-03-13','11:45:00',2.06),('15529','2014-03-13','11:50:00',2.19),('15529','2014-03-13','11:55:00',2.13),('15529','2014-03-13','12:00:00',2.12),('15529','2014-03-13','12:05:00',2.13),('15529','2014-03-13','12:10:00',2.06),('15529','2014-03-13','12:15:00',2),('15529','2014-03-13','12:20:00',1.81),('15529','2014-03-13','12:25:00',1.35),('15529','2014-03-13','12:30:00',1.3),('15529','2014-03-13','12:35:00',1.06),('15529','2014-03-13','12:40:00',1.1),('15529','2014-03-13','12:45:00',1.44),('15529','2014-03-13','12:50:00',1.65),('15529','2014-03-13','12:55:00',1.64),('15529','2014-03-13','13:00:00',1.3),('15529','2014-03-13','13:05:00',1.15),('15529','2014-03-13','13:10:00',1.39),('15529','2014-03-13','13:15:00',1.35),('15529','2014-03-13','13:20:00',1.48),('15529','2014-03-13','13:25:00',1.39),('15529','2014-03-13','13:30:00',1.27),('15529','2014-03-13','13:35:00',1.17),('15529','2014-03-13','13:40:00',1.07),('15529','2014-03-13','13:45:00',1.22),('15529','2014-03-13','13:50:00',1.22),('15529','2014-03-13','13:55:00',1.18),('15529','2014-03-13','14:00:00',1.26),('15529','2014-03-13','14:05:00',1.52),('15529','2014-03-13','14:10:00',1.49),('15529','2014-03-13','14:15:00',1.31),('15529','2014-03-13','14:20:00',1.51),('15529','2014-03-13','14:25:00',1.52),('15529','2014-03-13','14:30:00',1.33),('15529','2014-03-13','14:35:00',1.32),('15529','2014-03-13','14:40:00',1.07),('15529','2014-03-12','08:20:00',1.04),('15529','2014-03-12','08:25:00',1.1),('15529','2014-03-12','08:30:00',1.14),('15529','2014-03-12','08:35:00',1.2),('15529','2014-03-12','08:40:00',1.25),('15529','2014-03-12','08:45:00',1.3),('15529','2014-03-12','08:50:00',1.33),('15529','2014-03-12','08:55:00',1.38),('15529','2014-03-12','09:00:00',1.42),('15529','2014-03-12','09:05:00',1.48),('15529','2014-03-12','09:10:00',1.51),('15529','2014-03-12','09:15:00',1.54),('15529','2014-03-12','09:20:00',1.58),('15529','2014-03-12','09:25:00',1.62),('15529','2014-03-12','09:30:00',1.65),('15529','2014-03-12','09:35:00',1.69),('15529','2014-03-12','09:40:00',1.71),('15529','2014-03-12','09:45:00',1.74),('15529','2014-03-12','09:50:00',1.77),('15529','2014-03-12','09:55:00',1.8),('15529','2014-03-12','10:00:00',1.84),('15529','2014-03-12','10:05:00',1.89),('15529','2014-03-12','10:10:00',1.92),('15529','2014-03-12','10:15:00',1.94),('15529','2014-03-12','10:20:00',1.97),('15529','2014-03-12','10:25:00',1.98),('15529','2014-03-12','10:30:00',2.01),('15529','2014-03-12','10:35:00',2.03),('15529','2014-03-12','10:40:00',2.06),('15529','2014-03-12','10:45:00',2.06),('15529','2014-03-12','10:50:00',2.07),('15529','2014-03-12','10:55:00',2.09),('15529','2014-03-12','11:00:00',2.13),('15529','2014-03-12','11:05:00',2.16),('15529','2014-03-12','11:10:00',2.14),('15529','2014-03-12','11:15:00',2.16),('15529','2014-03-12','11:20:00',2.19),('15529','2014-03-12','11:25:00',2.18),('15529','2014-03-12','11:30:00',2.16),('15529','2014-03-12','11:35:00',2.19),('15529','2014-03-12','11:40:00',2.19),('15529','2014-03-12','11:45:00',2.21),('15529','2014-03-12','11:50:00',2.18),('15529','2014-03-12','11:55:00',2.21),('15529','2014-03-12','12:00:00',2.21),('15529','2014-03-12','12:05:00',2.19),('15529','2014-03-12','12:10:00',2.16),('15529','2014-03-12','12:15:00',2.21),('15529','2014-03-12','12:20:00',2.2),('15529','2014-03-12','12:25:00',2.21),('15529','2014-03-12','12:30:00',2.17),('15529','2014-03-12','12:35:00',2.18),('15529','2014-03-12','12:40:00',2.17),('15529','2014-03-12','12:45:00',2.15),('15529','2014-03-12','12:50:00',2.15),('15529','2014-03-12','12:55:00',2.14),('15529','2014-03-12','13:00:00',2.11),('15529','2014-03-12','13:05:00',2.12),('15529','2014-03-12','13:10:00',2.11),('15529','2014-03-12','13:15:00',2.1),('15529','2014-03-12','13:20:00',2.12),('15529','2014-03-12','13:25:00',2.09),('15529','2014-03-12','13:30:00',2.08),('15529','2014-03-12','13:35:00',2.05),('15529','2014-03-12','13:40:00',2.05),('15529','2014-03-12','13:45:00',2.01),('15529','2014-03-12','13:50:00',2),('15529','2014-03-12','13:55:00',1.97),('15529','2014-03-12','14:00:00',1.94),('15529','2014-03-12','14:05:00',1.92),('15529','2014-03-12','14:10:00',1.89),('15529','2014-03-12','14:15:00',1.86),('15529','2014-03-12','14:20:00',1.84),('15529','2014-03-12','14:25:00',1.8),('15529','2014-03-12','14:30:00',1.79),('15529','2014-03-12','14:35:00',1.75),('15529','2014-03-12','14:40:00',1.72),('15529','2014-03-12','14:45:00',1.69),('15529','2014-03-12','14:50:00',1.65),('15529','2014-03-12','14:55:00',1.61),('15529','2014-03-12','15:00:00',1.57),('15529','2014-03-12','15:05:00',1.54),('15529','2014-03-12','15:10:00',1.49),('15529','2014-03-12','15:15:00',1.45),('15529','2014-03-12','15:20:00',1.4),('15529','2014-03-12','15:25:00',1.36),('15529','2014-03-12','15:30:00',1.32),('15529','2014-03-12','15:35:00',1.28),('15529','2014-03-12','15:40:00',1.24),('15529','2014-03-12','15:45:00',1.2),('15529','2014-03-12','15:50:00',1.15),('15529','2014-03-12','15:55:00',1.1),('15529','2014-03-12','16:00:00',1.04),('15529','2014-03-11','08:20:00',1.03),('15529','2014-03-11','08:25:00',1.08),('15529','2014-03-11','08:30:00',1.14),('15529','2014-03-11','08:35:00',1.2),('15529','2014-03-11','08:40:00',1.25),('15529','2014-03-11','08:45:00',1.29),('15529','2014-03-11','08:50:00',1.34),('15529','2014-03-11','08:55:00',1.39),('15529','2014-03-11','09:00:00',1.43),('15529','2014-03-11','09:05:00',1.47),('15529','2014-03-11','09:10:00',1.51),('15529','2014-03-11','09:15:00',1.55),('15529','2014-03-11','09:20:00',1.59),('15529','2014-03-11','09:25:00',1.63),('15529','2014-03-11','09:30:00',1.65),('15529','2014-03-11','09:35:00',1.69),('15529','2014-03-11','09:40:00',1.72),('15529','2014-03-11','09:45:00',1.74),('15529','2014-03-11','09:50:00',1.77),('15529','2014-03-11','09:55:00',1.81),('15529','2014-03-11','10:00:00',1.84),('15529','2014-03-11','10:05:00',1.86),('15529','2014-03-11','10:10:00',1.89),('15529','2014-03-11','10:15:00',1.91),('15529','2014-03-11','10:20:00',1.93),('15529','2014-03-11','10:25:00',1.97),('15529','2014-03-11','10:30:00',1.99),('15529','2014-03-11','10:35:00',2),('15529','2014-03-11','10:40:00',2.05),('15529','2014-03-11','10:45:00',2.09),('15529','2014-03-11','10:50:00',2.1),('15529','2014-03-11','10:55:00',2.12),('15529','2014-03-11','11:00:00',2.12),('15529','2014-03-11','11:05:00',2.16),('15529','2014-03-11','11:10:00',2.18),('15529','2014-03-11','11:15:00',2.22),('15529','2014-03-11','11:20:00',2.22),('15529','2014-03-11','11:25:00',2.21),('15529','2014-03-11','11:30:00',2.22),('15529','2014-03-11','11:35:00',2.22),('15529','2014-03-11','11:40:00',2.22),('15529','2014-03-11','11:45:00',2.23),('15529','2014-03-11','11:50:00',2.26),('15529','2014-03-11','11:55:00',2.25),('15529','2014-03-11','12:00:00',2.24),('15529','2014-03-11','12:05:00',2.26),('15529','2014-03-11','12:10:00',2.24),('15529','2014-03-11','12:15:00',2.23),('15529','2014-03-11','12:20:00',2.25),('15529','2014-03-11','12:25:00',2.24),('15529','2014-03-11','12:30:00',2.24),('15529','2014-03-11','12:35:00',2.22),('15529','2014-03-11','12:40:00',2.24),('15529','2014-03-11','12:45:00',2.22),('15529','2014-03-11','12:50:00',2.22),('15529','2014-03-11','12:55:00',2.19),('15529','2014-03-11','13:00:00',2.2),('15529','2014-03-11','13:05:00',2.19),('15529','2014-03-11','13:10:00',2.19),('15529','2014-03-11','13:15:00',2.14),('15529','2014-03-11','13:20:00',2.16),('15529','2014-03-11','13:25:00',2.14),('15529','2014-03-11','13:30:00',2.12),('15529','2014-03-11','13:35:00',2.1),('15529','2014-03-11','13:40:00',2.09),('15529','2014-03-11','13:45:00',2.07),('15529','2014-03-11','13:50:00',2.01),('15529','2014-03-11','13:55:00',2.02),('15529','2014-03-11','14:00:00',2),('15529','2014-03-11','14:05:00',1.99),('15529','2014-03-11','14:10:00',1.93),('15529','2014-03-11','14:15:00',1.9),('15529','2014-03-11','14:20:00',1.89),('15529','2014-03-11','14:25:00',1.88),('15529','2014-03-11','14:30:00',1.82),('15529','2014-03-11','14:35:00',1.76),('15529','2014-03-11','14:40:00',1.68),('15529','2014-03-11','14:45:00',1.69),('15529','2014-03-11','14:50:00',1.64),('15529','2014-03-11','14:55:00',1.6),('15529','2014-03-11','15:00:00',1.58),('15529','2014-03-11','15:05:00',1.51),('15529','2014-03-11','15:10:00',1.47),('15529','2014-03-11','15:15:00',1.44),('15529','2014-03-11','15:20:00',1.38),('15529','2014-03-11','15:25:00',1.37),('15529','2014-03-11','15:30:00',1.33),('15529','2014-03-11','15:35:00',1.3),('15529','2014-03-11','15:40:00',1.26),('15529','2014-03-11','15:45:00',1.22),('15529','2014-03-11','15:50:00',1.17),('15529','2014-03-11','15:55:00',1.11),('15529','2014-03-11','16:00:00',1.07),('15529','2014-03-11','16:05:00',1.02),('15529','2014-03-10','14:05:00',1.17),('15529','2014-03-10','14:10:00',1.16),('15529','2014-03-10','14:15:00',1.33),('15529','2014-03-10','14:20:00',1.84),('15529','2014-03-10','14:25:00',1.05),('15529','2014-03-10','15:15:00',1.37),('15529','2014-03-09','14:40:00',1.06),('15529','2014-03-09','14:45:00',1.46),('15529','2014-03-09','14:50:00',1.5),('15529','2014-03-09','14:55:00',1.35),('15529','2014-03-09','15:00:00',1.65),('15529','2014-03-09','15:05:00',1.66),('15529','2014-03-09','15:10:00',1.6),('15529','2014-03-09','15:15:00',1.57),('15529','2014-03-09','15:20:00',1.61),('15529','2014-03-09','15:25:00',1.61),('15529','2014-03-09','15:30:00',1.61),('15529','2014-03-09','15:35:00',1.39),('15529','2014-03-09','15:40:00',1.11),('15529','2014-03-09','15:45:00',1.05),('15529','2014-03-08','08:25:00',1.04),('15529','2014-03-08','08:45:00',1),('15529','2014-03-08','08:50:00',1.19),('15529','2014-03-08','08:55:00',1.16),('15529','2014-03-08','09:00:00',1.42),('15529','2014-03-08','09:05:00',1.48),('15529','2014-03-08','09:10:00',1.53),('15529','2014-03-08','09:15:00',1.56),('15529','2014-03-08','09:20:00',1.61),('15529','2014-03-08','09:25:00',1.64),('15529','2014-03-08','09:30:00',1.7),('15529','2014-03-08','09:35:00',1.77),('15529','2014-03-08','09:40:00',1.79),('15529','2014-03-08','09:45:00',1.82),('15529','2014-03-08','09:50:00',1.84),('15529','2014-03-08','09:55:00',1.86),('15529','2014-03-08','10:00:00',1.89),('15529','2014-03-08','10:05:00',1.91),('15529','2014-03-08','10:10:00',1.94),('15529','2014-03-08','10:15:00',1.96),('15529','2014-03-08','10:20:00',1.99),('15529','2014-03-08','10:25:00',2.03),('15529','2014-03-08','10:30:00',2.08),('15529','2014-03-08','10:35:00',2.12),('15529','2014-03-08','10:40:00',2.12),('15529','2014-03-08','10:45:00',1.98),('15529','2014-03-08','10:50:00',2.18),('15529','2014-03-08','10:55:00',2.21),('15529','2014-03-08','11:00:00',2.26),('15529','2014-03-08','11:05:00',2.26),('15529','2014-03-08','11:10:00',2.33),('15529','2014-03-08','11:15:00',2.45),('15529','2014-03-08','11:20:00',1.9),('15529','2014-03-08','11:25:00',1.05),('15529','2014-03-08','11:35:00',1.08),('15529','2014-03-08','11:50:00',1.5),('15529','2014-03-08','11:55:00',2),('15529','2014-03-08','12:15:00',1.23),('15529','2014-03-08','12:20:00',1.53),('15529','2014-03-08','12:25:00',2.5),('15529','2014-03-08','12:30:00',1.68),('15529','2014-03-08','12:35:00',2.37),('15529','2014-03-08','12:40:00',2.09),('15529','2014-03-08','12:45:00',2.43),('15529','2014-03-08','12:50:00',2.38),('15529','2014-03-08','12:55:00',2.38),('15529','2014-03-08','13:00:00',2.04),('15529','2014-03-08','13:05:00',1.97),('15529','2014-03-08','13:10:00',1.78),('15529','2014-03-08','13:20:00',1.15),('15529','2014-03-08','13:25:00',2.41),('15529','2014-03-08','13:30:00',2.32),('15529','2014-03-08','13:35:00',2.29),('15529','2014-03-08','13:40:00',2.31),('15529','2014-03-08','13:45:00',2.31),('15529','2014-03-08','13:50:00',2.23),('15529','2014-03-08','13:55:00',1.88),('15529','2014-03-08','14:05:00',1.17),('15529','2014-03-08','14:10:00',2.07),('15529','2014-03-08','14:15:00',1.84),('15529','2014-03-08','14:20:00',2.04),('15529','2014-03-08','14:25:00',2),('15529','2014-03-08','14:30:00',2.04),('15529','2014-03-08','14:55:00',1.83),('15529','2014-03-08','15:00:00',1.75),('15529','2014-03-08','15:05:00',1.74),('15529','2014-03-08','15:10:00',1.71),('15529','2014-03-08','15:15:00',1.63),('15529','2014-03-08','15:20:00',1.57),('15529','2014-03-08','15:25:00',1.53),('15529','2014-03-08','15:30:00',1.49),('15529','2014-03-08','15:35:00',1.42),('15529','2014-03-08','15:40:00',1.37),('15529','2014-03-08','15:45:00',1.32),('15529','2014-03-08','16:05:00',1.13),('15529','2014-03-07','08:25:00',1.05),('15529','2014-03-07','08:30:00',1.1),('15529','2014-03-07','08:35:00',1.15),('15529','2014-03-07','08:40:00',1.2),('15529','2014-03-07','08:45:00',1.26),('15529','2014-03-07','08:50:00',1.3),('15529','2014-03-07','08:55:00',1.35),('15529','2014-03-07','09:00:00',1.4),('15529','2014-03-07','09:05:00',1.44),('15529','2014-03-07','09:10:00',1.48),('15529','2014-03-07','09:15:00',1.52),('15529','2014-03-07','09:20:00',1.56),('15529','2014-03-07','09:25:00',1.59),('15529','2014-03-07','09:30:00',1.64),('15529','2014-03-07','09:35:00',1.67),('15529','2014-03-07','09:40:00',1.71),('15529','2014-03-07','09:45:00',1.74),('15529','2014-03-07','09:50:00',1.78),('15529','2014-03-07','09:55:00',1.8),('15529','2014-03-07','10:00:00',1.83),('15529','2014-03-07','10:05:00',1.86),('15529','2014-03-07','10:10:00',1.88),('15529','2014-03-07','10:15:00',1.92),('15529','2014-03-07','10:20:00',1.94),('15529','2014-03-07','10:25:00',1.96),('15529','2014-03-07','10:30:00',2),('15529','2014-03-07','10:35:00',2.02),('15529','2014-03-07','10:40:00',2.05),('15529','2014-03-07','10:45:00',2.07),('15529','2014-03-07','10:50:00',2.1),('15529','2014-03-07','10:55:00',2.11),('15529','2014-03-07','11:00:00',2.13),('15529','2014-03-07','11:05:00',2.14),('15529','2014-03-07','11:10:00',2.16),('15529','2014-03-07','11:15:00',2.19),('15529','2014-03-07','11:20:00',2.21),('15529','2014-03-07','11:25:00',2.27),('15529','2014-03-07','11:30:00',2.39),('15529','2014-03-07','11:35:00',2.44),('15529','2014-03-07','11:40:00',2.49),('15529','2014-03-07','11:45:00',1.62),('15529','2014-03-07','11:50:00',1.83),('15529','2014-03-07','12:40:00',1.07),('15529','2014-03-07','13:00:00',1.18),('15529','2014-03-07','13:35:00',1.22),('15529','2014-03-07','13:40:00',1.26),('15529','2014-03-07','13:45:00',1.43),('15529','2014-03-07','13:50:00',2.01),('15529','2014-03-07','15:20:00',1.27),('15529','2014-03-07','15:25:00',1.01),('15529','2014-03-07','15:35:00',1.13),('15529','2014-04-29','08:45:00',1.05),('15529','2014-04-29','08:50:00',1.13),('15529','2014-04-29','08:55:00',1.08),('15529','2014-04-29','09:00:00',1.21),('15529','2014-04-29','09:05:00',1.24),('15529','2014-04-29','09:10:00',1.35),('15529','2014-04-29','09:20:00',1.28),('15529','2014-04-29','09:25:00',1.54),('15529','2014-04-29','09:30:00',1.53),('15529','2014-04-29','09:35:00',1.56),('15529','2014-04-29','09:40:00',1.44),('15529','2014-04-29','09:45:00',1.71),('15529','2014-04-29','09:50:00',1.85),('15529','2014-04-29','09:55:00',1.2),('15529','2014-04-29','10:00:00',1.67),('15529','2014-04-29','10:05:00',1.09),('15529','2014-04-29','10:10:00',1.14),('15529','2014-04-29','10:30:00',1.05),('15529','2014-04-29','10:35:00',1.02),('15529','2014-04-29','10:40:00',1.14),('15529','2014-04-29','10:45:00',1.41),('15529','2014-04-29','10:50:00',2.26),('15529','2014-04-29','10:55:00',2.25),('15529','2014-04-29','11:00:00',2.62),('15529','2014-04-29','11:05:00',2.02),('15529','2014-04-29','11:10:00',1.41),('15529','2014-04-29','11:15:00',1.22),('15529','2014-04-29','11:20:00',1.63),('15529','2014-04-29','11:25:00',1.49),('15529','2014-04-29','11:30:00',1.11),('15529','2014-04-29','11:35:00',2.65),('15529','2014-04-29','11:40:00',1.38),('15529','2014-04-29','11:45:00',1.33),('15529','2014-04-29','11:50:00',1.38),('15529','2014-04-29','11:55:00',1.22),('15529','2014-04-29','12:10:00',1.17),('15529','2014-04-29','12:45:00',1.85),('15529','2014-04-29','12:50:00',2.27),('15529','2014-04-29','12:55:00',2.53),('15529','2014-04-29','13:00:00',1.64),('15529','2014-04-29','13:05:00',2.54),('15529','2014-04-29','13:15:00',1.11),('15529','2014-04-29','13:20:00',2.71),('15529','2014-04-29','13:25:00',1.23),('15529','2014-04-29','13:35:00',1.74),('15529','2014-04-29','13:40:00',2.36),('15529','2014-04-29','13:45:00',1.26),('15529','2014-04-29','13:50:00',2.09),('15529','2014-04-29','13:55:00',1.04),('15529','2014-04-29','14:15:00',2.16),('15529','2014-04-29','14:20:00',1.9),('15529','2014-04-29','14:25:00',1.75),('15529','2014-04-29','14:30:00',1.93),('15529','2014-04-29','14:35:00',1.23),('15529','2014-04-29','15:30:00',1.25),('15529','2014-04-29','15:35:00',2.27),('15529','2014-04-29','15:40:00',1.33),('15529','2014-04-29','15:45:00',1.08),('15529','2014-04-29','15:55:00',1.15),('15529','2014-04-29','16:15:00',1.25),('15529','2014-04-29','16:35:00',1.02),('15529','2014-04-29','16:40:00',1.64),('15529','2014-04-29','16:45:00',1.1),('15529','2014-04-29','16:50:00',1.26),('15529','2014-04-29','16:55:00',1.01),('15529','2014-04-29','17:00:00',1.06),('15529','2014-04-29','17:05:00',1.1),('15529','2014-03-06','10:40:00',1.02),('15529','2014-03-06','11:20:00',1.03),('15529','2014-03-06','11:25:00',1.42),('15529','2014-03-06','11:35:00',1.26),('15529','2014-03-06','11:50:00',1.25),('15529','2014-03-06','11:55:00',2.32),('15529','2014-03-06','12:00:00',1.12),('15529','2014-03-06','12:05:00',1.78),('15529','2014-03-06','12:10:00',2.37),('15529','2014-03-06','12:15:00',2.41),('15529','2014-03-06','12:20:00',2.38),('15529','2014-03-06','12:55:00',2.1),('15529','2014-03-06','13:00:00',1.13),('15529','2014-03-06','13:05:00',1.32),('15529','2014-03-06','13:10:00',1.49),('15529','2014-03-06','13:15:00',1.22),('15529','2014-03-06','13:20:00',2.05),('15529','2014-03-06','13:25:00',2.15),('15529','2014-03-06','13:30:00',1.22),('15529','2014-03-06','14:50:00',1.26),('15529','2014-03-06','14:55:00',1.6),('15529','2014-03-06','15:00:00',1.85),('15529','2014-03-06','15:05:00',1.89),('15529','2014-03-06','15:10:00',1.91),('15529','2014-03-06','15:15:00',1.86),('15529','2014-03-06','15:20:00',1.81),('15529','2014-03-06','15:25:00',1.75),('15529','2014-03-06','15:30:00',1.64),('15529','2014-03-06','15:35:00',1.58),('15529','2014-03-06','15:40:00',1.44),('15529','2014-03-06','15:45:00',1.43),('15529','2014-03-06','15:50:00',1.35),('15529','2014-03-06','15:55:00',1.29),('15529','2014-03-06','16:00:00',1.21),('15529','2014-03-06','16:05:00',1.09),('15529','2014-03-06','16:10:00',1.05),('15529','2014-03-06','16:15:00',1.02),('15529','2014-03-05','08:15:00',1.2),('15529','2014-03-05','08:20:00',1),('15529','2014-03-05','09:20:00',1.21),('15529','2014-03-05','09:25:00',1.07),('15529','2014-03-05','09:40:00',1.11),('15529','2014-03-05','09:45:00',1.25),('15529','2014-03-05','09:50:00',1.5),('15529','2014-03-05','09:55:00',1.42),('15529','2014-03-05','10:00:00',1.39),('15529','2014-03-05','10:05:00',1.61),('15529','2014-03-05','10:10:00',1.76),('15529','2014-03-05','10:15:00',1.95),('15529','2014-03-05','10:20:00',1.89),('15529','2014-03-05','10:25:00',1.93),('15529','2014-03-05','10:30:00',2.1),('15529','2014-03-05','10:35:00',2.02),('15529','2014-03-05','10:40:00',2.1),('15529','2014-03-05','10:45:00',1.54),('15529','2014-03-05','10:50:00',1.95),('15529','2014-03-05','10:55:00',2.04),('15529','2014-03-05','11:00:00',2.13),('15529','2014-03-05','11:05:00',1.83),('15529','2014-03-05','11:10:00',2.47),('15529','2014-03-05','11:15:00',1.67),('15529','2014-03-05','11:20:00',1.89),('15529','2014-03-05','12:05:00',1.27),('15529','2014-03-05','12:10:00',1.15),('15529','2014-03-05','15:10:00',1.07),('15529','2014-03-04','08:20:00',1.25),('15529','2014-03-04','08:25:00',1.08),('15529','2014-03-04','08:40:00',1.04),('15529','2014-03-04','08:50:00',1.24),('15529','2014-03-04','09:05:00',1.06),('15529','2014-03-04','09:10:00',1.56),('15529','2014-03-04','09:15:00',1.61),('15529','2014-03-04','09:20:00',1.62),('15529','2014-03-04','09:25:00',1.65),('15529','2014-03-04','09:30:00',1.68),('15529','2014-03-04','09:35:00',1.72),('15529','2014-03-04','09:40:00',1.76),('15529','2014-03-04','09:45:00',1.78),('15529','2014-03-04','09:50:00',1.78),('15529','2014-03-04','09:55:00',1.85),('15529','2014-03-04','10:00:00',1.88),('15529','2014-03-04','10:05:00',1.91),('15529','2014-03-04','10:10:00',1.94),('15529','2014-03-04','10:15:00',1.95),('15529','2014-03-04','10:20:00',1.98),('15529','2014-03-04','10:25:00',2),('15529','2014-03-04','10:30:00',2.02),('15529','2014-03-04','10:35:00',2.05),('15529','2014-03-04','10:40:00',2.06),('15529','2014-03-04','10:45:00',2.07),('15529','2014-03-04','10:50:00',2.1),('15529','2014-03-04','10:55:00',2.11),('15529','2014-03-04','11:00:00',2.11),('15529','2014-03-04','11:05:00',2.14),('15529','2014-03-04','11:10:00',2.17),('15529','2014-03-04','11:15:00',2.17),('15529','2014-03-04','11:20:00',2.23),('15529','2014-03-04','11:25:00',2.31),('15529','2014-03-04','11:30:00',2.31),('15529','2014-03-04','11:35:00',2.27),('15529','2014-03-04','11:40:00',2.31),('15529','2014-03-04','11:45:00',2.18),('15529','2014-03-04','11:50:00',2.31),('15529','2014-03-04','11:55:00',2.14),('15529','2014-03-04','12:00:00',1.92),('15529','2014-03-04','12:05:00',1.77),('15529','2014-03-04','12:10:00',1.84),('15529','2014-03-04','12:15:00',1.2),('15529','2014-03-04','12:20:00',1.83),('15529','2014-03-04','12:30:00',1.06),('15529','2014-03-04','12:35:00',1.22),('15529','2014-03-04','12:40:00',1.73),('15529','2014-03-04','12:45:00',1.36),('15529','2014-03-04','13:05:00',1.2),('15529','2014-03-04','13:10:00',1.52),('15529','2014-03-04','13:15:00',1.84),('15529','2014-03-04','13:20:00',1.42),('15529','2014-03-04','13:25:00',1.38),('15529','2014-03-04','13:30:00',1.64),('15529','2014-03-04','13:40:00',1.51),('15529','2014-03-04','13:45:00',1.34),('15529','2014-03-04','14:30:00',1.32),('15529','2014-03-04','14:40:00',1.48),('15529','2014-03-04','14:45:00',1.98),('15529','2014-03-04','14:50:00',2.22),('15529','2014-03-04','14:55:00',1.42),('15529','2014-03-04','15:45:00',1.06),('15529','2014-03-04','15:50:00',1.04),('15529','2014-03-04','16:00:00',1.41),('15529','2014-03-04','16:05:00',1.55),('15529','2014-03-04','16:10:00',1.4),('15529','2014-03-04','16:15:00',1.13),('15529','2014-03-03','10:30:00',1.36),('15529','2014-03-03','10:35:00',2.44),('15529','2014-03-03','10:40:00',2.57),('15529','2014-03-03','10:45:00',2.58),('15529','2014-03-03','10:50:00',1.63),('15529','2014-03-03','10:55:00',2.47),('15529','2014-03-03','11:00:00',2.28),('15529','2014-03-03','11:05:00',2.52),('15529','2014-03-03','11:10:00',2.68),('15529','2014-03-03','11:15:00',1.87),('15529','2014-03-03','11:45:00',1.25),('15529','2014-03-03','11:50:00',2.71),('15529','2014-03-03','11:55:00',2.43),('15529','2014-03-03','12:00:00',2.38),('15529','2014-03-03','12:05:00',2.34),('15529','2014-03-03','12:10:00',2.36),('15529','2014-03-03','12:15:00',2.34),('15529','2014-03-03','12:20:00',2.13),('15529','2014-03-03','12:25:00',2.33),('15529','2014-03-03','12:30:00',2.27),('15529','2014-03-03','12:35:00',2.29),('15529','2014-03-03','12:40:00',1.73),('15529','2014-03-03','12:45:00',2.12),('15529','2014-03-03','12:50:00',2.21),('15529','2014-03-03','12:55:00',2.32),('15529','2014-03-03','13:00:00',1.17),('15529','2014-03-03','13:05:00',1.94),('15529','2014-03-03','13:10:00',1.34),('15529','2014-03-03','13:20:00',1.44),('15529','2014-03-03','13:25:00',1.19),('15529','2014-03-03','14:00:00',1.16),('15529','2014-03-03','14:05:00',2.06),('15529','2014-03-03','14:10:00',2.22),('15529','2014-03-03','14:20:00',1.32),('15529','2014-03-03','14:25:00',2.1),('15529','2014-03-03','14:30:00',1.99),('15529','2014-03-03','14:35:00',1.93),('15529','2014-03-03','14:40:00',1.92),('15529','2014-03-03','14:45:00',1.33),('15529','2014-03-03','14:50:00',2.02),('15529','2014-03-03','14:55:00',1.81),('15529','2014-03-03','15:00:00',1.76),('15529','2014-03-03','15:05:00',1.7),('15529','2014-03-03','15:10:00',1.25),('15529','2014-03-03','15:15:00',1.67),('15529','2014-03-03','15:20:00',1.64),('15529','2014-03-03','15:25:00',1.6),('15529','2014-03-03','15:30:00',1.53),('15529','2014-03-03','15:35:00',1.55),('15529','2014-03-03','15:40:00',1.46),('15529','2014-03-03','15:45:00',1.49),('15529','2014-03-03','15:50:00',1.22),('15529','2014-03-02','08:20:00',1.02),('15529','2014-03-02','08:25:00',1.06),('15529','2014-03-02','08:30:00',1.1),('15529','2014-03-02','08:35:00',1.16),('15529','2014-03-02','08:40:00',1.22),('15529','2014-03-02','08:45:00',1.27),('15529','2014-03-02','08:50:00',1.29),('15529','2014-03-02','08:55:00',1.32),('15529','2014-03-02','09:00:00',1.2),('15529','2014-03-02','09:05:00',1.09),('15529','2014-03-02','09:10:00',1.15),('15529','2014-03-02','09:15:00',1.53),('15529','2014-03-02','09:20:00',1.55),('15529','2014-03-02','09:25:00',1.61),('15529','2014-03-02','09:30:00',1.54),('15529','2014-03-02','09:35:00',1.6),('15529','2014-03-02','09:40:00',1.46),('15529','2014-03-02','09:45:00',1.63),('15529','2014-03-02','09:50:00',1.74),('15529','2014-03-02','09:55:00',1.68),('15529','2014-03-02','10:00:00',1.83),('15529','2014-03-02','10:05:00',1.85),('15529','2014-03-02','10:10:00',1.9),('15529','2014-03-02','10:15:00',1.91),('15529','2014-03-02','10:20:00',1.95),('15529','2014-03-02','10:25:00',1.97),('15529','2014-03-02','10:30:00',1.99),('15529','2014-03-02','10:35:00',2.01),('15529','2014-03-02','10:40:00',2.02),('15529','2014-03-02','10:45:00',2.04),('15529','2014-03-02','10:50:00',2.06),('15529','2014-03-02','10:55:00',2.07),('15529','2014-03-02','11:00:00',2.09),('15529','2014-03-02','11:05:00',2.1),('15529','2014-03-02','11:10:00',2.11),('15529','2014-03-02','11:15:00',2.12),('15529','2014-03-02','11:20:00',2.14),('15529','2014-03-02','11:25:00',2.21),('15529','2014-03-02','11:30:00',2.25),('15529','2014-03-02','11:35:00',2.25),('15529','2014-03-02','11:40:00',2.25),('15529','2014-03-02','11:45:00',2.3),('15529','2014-03-02','11:50:00',2.28),('15529','2014-03-02','11:55:00',2.29),('15529','2014-03-02','12:00:00',2.31),('15529','2014-03-02','12:05:00',2.29),('15529','2014-03-02','12:10:00',2.3),('15529','2014-03-02','12:15:00',2.3),('15529','2014-03-02','12:20:00',2.32),('15529','2014-03-02','12:25:00',2.31),('15529','2014-03-02','12:30:00',2.3),('15529','2014-03-02','12:35:00',2.3),('15529','2014-03-02','12:40:00',2.29),('15529','2014-03-02','12:45:00',2.28),('15529','2014-03-02','12:50:00',2.27),('15529','2014-03-02','12:55:00',2.27),('15529','2014-03-02','13:00:00',2.26),('15529','2014-03-02','13:05:00',2.26),('15529','2014-03-02','13:10:00',2.24),('15529','2014-03-02','13:15:00',2.23),('15529','2014-03-02','13:20:00',2.21),('15529','2014-03-02','13:25:00',2.22),('15529','2014-03-02','13:30:00',2.2),('15529','2014-03-02','13:35:00',2.2),('15529','2014-03-02','13:40:00',2.15),('15529','2014-03-02','13:45:00',2.19),('15529','2014-03-02','13:50:00',2.17),('15529','2014-03-02','13:55:00',2.14),('15529','2014-03-02','14:00:00',2.09),('15529','2014-03-02','14:05:00',2.08),('15529','2014-03-02','14:10:00',2.1),('15529','2014-03-02','14:15:00',1.99),('15529','2014-03-02','14:20:00',1.95),('15529','2014-03-02','14:25:00',1.98),('15529','2014-03-02','14:30:00',1.97),('15529','2014-03-02','14:35:00',1.94),('15529','2014-03-02','14:40:00',1.88),('15529','2014-03-02','14:45:00',1.83),('15529','2014-03-02','14:50:00',1.8),('15529','2014-03-02','14:55:00',1.74),('15529','2014-03-02','15:00:00',1.48),('15529','2014-03-02','15:05:00',1.64),('15529','2014-03-02','15:10:00',1.6),('15529','2014-03-02','15:20:00',1.12),('15529','2014-03-02','15:30:00',1.22),('15529','2014-03-02','15:35:00',1.13),('15529','2014-03-02','15:40:00',1.4),('15529','2014-03-02','15:45:00',1.33),('15529','2014-03-02','15:50:00',1.28),('15529','2014-03-02','15:55:00',1.22),('15529','2014-03-02','16:00:00',1.17),('15529','2014-03-02','16:05:00',1.11),('15529','2014-03-02','16:10:00',1.06),('15529','2014-03-02','16:15:00',1),('15529','2014-03-01','08:15:00',1.01),('15529','2014-03-01','08:25:00',1.1),('15529','2014-03-01','08:30:00',1.12),('15529','2014-03-01','08:35:00',1.16),('15529','2014-03-01','08:40:00',1.25),('15529','2014-03-01','08:45:00',1.3),('15529','2014-03-01','08:50:00',1.36),('15529','2014-03-01','08:55:00',1.4),('15529','2014-03-01','09:00:00',1.46),('15529','2014-03-01','09:05:00',1.53),('15529','2014-03-01','09:10:00',1.61),('15529','2014-03-01','09:15:00',1.44),('15529','2014-03-01','09:20:00',1.75),('15529','2014-03-01','09:25:00',1.78),('15529','2014-03-01','09:30:00',1.71),('15529','2014-03-01','09:35:00',1.65),('15529','2014-03-01','10:20:00',1.02),('15529','2014-03-01','10:25:00',1.1),('15529','2014-03-01','10:30:00',1.57),('15529','2014-03-01','10:35:00',2.14),('15529','2014-03-01','10:40:00',2.19),('15529','2014-03-01','10:45:00',2.26),('15529','2014-03-01','10:50:00',2.33),('15529','2014-03-01','10:55:00',2.48),('15529','2014-03-01','11:00:00',2.31),('15529','2014-03-01','11:15:00',1.07),('15529','2014-03-01','11:20:00',1.24),('15529','2014-03-01','11:25:00',2.51),('15529','2014-03-01','11:30:00',2.45),('15529','2014-03-01','11:35:00',1.34),('15529','2014-03-01','11:40:00',2.58),('15529','2014-03-01','11:45:00',2.54),('15529','2014-03-01','11:50:00',2.55),('15529','2014-03-01','11:55:00',1.86),('15529','2014-03-01','12:05:00',1.05),('15529','2014-03-01','12:10:00',1.22),('15529','2014-03-01','12:15:00',1.15),('15529','2014-02-27','09:25:00',1.24),('15529','2014-02-27','09:40:00',1.93),('15529','2014-02-27','09:45:00',2.01),('15529','2014-02-27','09:50:00',1.57),('15529','2014-02-27','10:20:00',1.97),('15529','2014-02-27','10:25:00',2.1),('15529','2014-02-27','10:30:00',1.83),('15529','2014-02-27','10:35:00',1.16),('15529','2014-02-27','12:00:00',1.06),('15529','2014-02-27','12:05:00',1.15),('15529','2014-02-27','12:25:00',1.35),('15529','2014-02-27','12:30:00',2.3),('15529','2014-02-27','12:35:00',2.26),('15529','2014-02-27','12:40:00',1.21),('15529','2014-02-27','12:45:00',1.16),('15529','2014-02-27','12:50:00',1.12),('15529','2014-02-27','12:55:00',1.44),('15529','2014-02-27','13:00:00',1.07),('15529','2014-02-27','13:45:00',1.21),('15529','2014-02-27','14:25:00',1.66),('15529','2014-02-27','14:30:00',1.08),('15529','2014-02-27','15:20:00',1.05),('15529','2014-02-27','16:15:00',1.32),('15529','2014-02-26','13:55:00',1.22),('15529','2014-02-26','14:00:00',1.12),('15529','2014-02-25','08:30:00',1.03),('15529','2014-02-25','08:35:00',1.1),('15529','2014-02-25','08:40:00',1.21),('15529','2014-02-25','08:55:00',1.27),('15529','2014-02-25','09:00:00',1.25),('15529','2014-02-25','09:05:00',1.27),('15529','2014-02-25','09:10:00',1.43),('15529','2014-02-25','09:15:00',1.25),('15529','2014-02-25','09:20:00',1.44),('15529','2014-02-25','09:25:00',1.2),('15529','2014-02-25','09:30:00',1.45),('15529','2014-02-25','09:35:00',1.16),('15529','2014-02-25','09:40:00',1.01),('15529','2014-02-25','12:15:00',1.28),('15529','2014-02-25','12:20:00',1.8),('15529','2014-02-25','12:30:00',1.32),('15529','2014-02-25','12:35:00',1.37),('15529','2014-02-25','12:40:00',1.7),('15529','2014-02-25','12:45:00',1.56),('15529','2014-02-25','12:50:00',2.03),('15529','2014-02-25','12:55:00',1.72),('15529','2014-02-25','13:05:00',1.72),('15529','2014-02-25','13:20:00',1.85),('15529','2014-02-25','13:25:00',1.63),('15529','2014-02-25','13:30:00',2.19),('15529','2014-02-25','13:35:00',1.74),('15529','2014-02-25','13:40:00',1.31),('15529','2014-02-25','13:45:00',1.75),('15529','2014-02-25','13:50:00',1.05),('15529','2014-02-25','14:00:00',1.38),('15529','2014-02-25','14:15:00',1.52),('15529','2014-02-25','14:20:00',1.23),('15529','2014-02-25','14:25:00',1.47),('15529','2014-02-25','14:30:00',1.52),('15529','2014-02-25','14:35:00',1.29),('15529','2014-02-25','14:40:00',1.73),('15529','2014-02-25','14:45:00',1.8),('15529','2014-02-25','14:50:00',1.56),('15529','2014-02-25','14:55:00',1.69),('15529','2014-02-25','15:00:00',1.69),('15529','2014-02-25','15:05:00',1.12),('15529','2014-02-25','15:10:00',1.58),('15529','2014-02-25','15:15:00',1.29),('15529','2014-02-25','15:30:00',1),('15529','2014-02-25','15:35:00',1.05),('15529','2014-02-25','15:40:00',1.07),('15529','2014-02-25','16:00:00',1.17),('15529','2014-04-28','10:05:00',1.72),('15529','2014-04-28','10:10:00',1.94),('15529','2014-04-28','10:15:00',1.94),('15529','2014-04-28','10:20:00',1.63),('15529','2014-04-28','10:25:00',2.02),('15529','2014-04-28','10:30:00',2.08),('15529','2014-04-28','10:35:00',2.09),('15529','2014-04-28','10:40:00',2.13),('15529','2014-04-28','10:45:00',2.15),('15529','2014-04-28','10:50:00',2.12),('15529','2014-04-28','10:55:00',2),('15529','2014-04-28','11:00:00',2.18),('15529','2014-04-28','11:05:00',1.98),('15529','2014-04-28','11:10:00',2.37),('15529','2014-04-28','11:15:00',1.75),('15529','2014-04-28','11:20:00',2.41),('15529','2014-04-28','11:25:00',2.29),('15529','2014-04-28','11:30:00',1.65),('15529','2014-04-28','12:15:00',1.86),('15529','2014-04-28','12:20:00',1.26),('15529','2014-04-28','12:30:00',1.22),('15529','2014-04-28','12:35:00',1.11),('15529','2014-04-28','12:45:00',1.34),('15529','2014-04-28','12:50:00',1.47),('15529','2014-04-28','12:55:00',1.1),('15529','2014-04-28','13:00:00',2.02),('15529','2014-04-28','13:05:00',1.79),('15529','2014-04-28','13:20:00',1.68),('15529','2014-04-28','13:25:00',2.73),('15529','2014-04-28','13:30:00',1.09),('15529','2014-04-28','13:35:00',1.51),('15529','2014-04-28','13:40:00',1.01),('15529','2014-04-28','17:35:00',1.13),('15529','2014-02-24','08:35:00',1.03),('15529','2014-02-24','08:40:00',1.09),('15529','2014-02-24','08:45:00',1.15),('15529','2014-02-24','08:50:00',1.2),('15529','2014-02-24','08:55:00',1.24),('15529','2014-02-24','09:00:00',1.29),('15529','2014-02-24','09:05:00',1.33),('15529','2014-02-24','09:10:00',1.37),('15529','2014-02-24','09:15:00',1.41),('15529','2014-02-24','09:20:00',1.46),('15529','2014-02-24','09:25:00',1.49),('15529','2014-02-24','09:30:00',1.53),('15529','2014-02-24','09:35:00',1.56),('15529','2014-02-24','09:40:00',1.59),('15529','2014-02-24','09:45:00',1.63),('15529','2014-02-24','09:50:00',1.65),('15529','2014-02-24','09:55:00',1.68),('15529','2014-02-24','10:00:00',1.72),('15529','2014-02-24','10:05:00',1.75),('15529','2014-02-24','10:10:00',1.78),('15529','2014-02-24','10:15:00',1.82),('15529','2014-02-24','10:20:00',1.84),('15529','2014-02-24','10:25:00',1.85),('15529','2014-02-24','10:30:00',1.88),('15529','2014-02-24','10:35:00',1.91),('15529','2014-02-24','10:40:00',1.92),('15529','2014-02-24','10:45:00',1.95),('15529','2014-02-24','10:50:00',1.96),('15529','2014-02-24','10:55:00',1.95),('15529','2014-02-24','11:00:00',1.99),('15529','2014-02-24','11:05:00',2.02),('15529','2014-02-24','11:10:00',2.04),('15529','2014-02-24','11:15:00',2.04),('15529','2014-02-24','11:20:00',2.07),('15529','2014-02-24','11:25:00',2.08),('15529','2014-02-24','11:30:00',2.08),('15529','2014-02-24','11:35:00',2.11),('15529','2014-02-24','11:40:00',2.12),('15529','2014-02-24','11:45:00',2.11),('15529','2014-02-24','11:50:00',2.12),('15529','2014-02-24','11:55:00',2.1),('15529','2014-02-24','12:00:00',2.13),('15529','2014-02-24','12:05:00',2.16),('15529','2014-02-24','12:10:00',2.14),('15529','2014-02-24','12:15:00',2.14),('15529','2014-02-24','12:20:00',2.14),('15529','2014-02-24','12:25:00',2.12),('15529','2014-02-24','12:30:00',2.15),('15529','2014-02-24','12:35:00',2.14),('15529','2014-02-24','12:40:00',2.12),('15529','2014-02-24','12:45:00',2.15),('15529','2014-02-24','12:50:00',2.11),('15529','2014-02-24','12:55:00',2.12),('15529','2014-02-24','13:00:00',2.12),('15529','2014-02-24','13:05:00',2.03),('15529','2014-02-24','13:10:00',1.2),('15529','2014-02-24','13:15:00',1.78),('15529','2014-02-24','13:20:00',2.04),('15529','2014-02-24','13:25:00',1.29),('15529','2014-02-24','13:45:00',1.78),('15529','2014-02-24','13:50:00',2.15),('15529','2014-02-24','13:55:00',2.14),('15529','2014-02-24','14:00:00',2.02),('15529','2014-02-24','14:05:00',1.99),('15529','2014-02-24','14:10:00',1.85),('15529','2014-02-24','14:15:00',1.73),('15529','2014-02-24','14:20:00',1.61),('15529','2014-02-24','14:25:00',1.6),('15529','2014-02-24','14:30:00',1.65),('15529','2014-02-24','14:35:00',1.68),('15529','2014-02-24','14:40:00',1.76),('15529','2014-02-24','14:45:00',1.72),('15529','2014-02-24','14:50:00',1.55),('15529','2014-02-24','14:55:00',1.62),('15529','2014-02-24','15:00:00',1.52),('15529','2014-02-24','15:05:00',1.52),('15529','2014-02-24','15:10:00',1.44),('15529','2014-02-24','15:15:00',1.43),('15529','2014-02-24','15:20:00',1.33),('15529','2014-02-24','15:25:00',1.16),('15529','2014-02-24','15:30:00',1.08),('15529','2014-02-24','15:35:00',1.02),('15529','2014-02-23','08:15:00',1.05),('15529','2014-02-23','08:20:00',1.09),('15529','2014-02-23','08:55:00',1.39),('15529','2014-02-23','09:00:00',1.36),('15529','2014-02-23','09:05:00',1.37),('15529','2014-02-23','09:10:00',1.4),('15529','2014-02-23','09:15:00',1.44),('15529','2014-02-23','09:20:00',1.48),('15529','2014-02-23','09:25:00',1.52),('15529','2014-02-23','09:30:00',1.54),('15529','2014-02-23','09:35:00',1.58),('15529','2014-02-23','09:40:00',1.61),('15529','2014-02-23','09:45:00',1.65),('15529','2014-02-23','09:50:00',1.69),('15529','2014-02-23','09:55:00',1.73),('15529','2014-02-23','10:00:00',1.77),('15529','2014-02-23','10:05:00',1.8),('15529','2014-02-23','10:10:00',1.83),('15529','2014-02-23','10:15:00',1.85),('15529','2014-02-23','10:20:00',1.88),('15529','2014-02-23','10:25:00',1.91),('15529','2014-02-23','10:30:00',1.94),('15529','2014-02-23','10:35:00',1.96),('15529','2014-02-23','10:40:00',1.98),('15529','2014-02-23','10:45:00',1.97),('15529','2014-02-23','10:50:00',2.01),('15529','2014-02-23','10:55:00',2.04),('15529','2014-02-23','11:00:00',2.04),('15529','2014-02-23','11:05:00',2.06),('15529','2014-02-23','11:10:00',2.06),('15529','2014-02-23','11:15:00',2.05),('15529','2014-02-23','11:20:00',2.08),('15529','2014-02-23','11:25:00',2.14),('15529','2014-02-23','11:30:00',2.2),('15529','2014-02-23','11:35:00',2.07),('15529','2014-02-23','11:40:00',1.25),('15529','2014-02-23','11:45:00',1.72),('15529','2014-02-23','11:50:00',1.54),('15529','2014-02-23','11:55:00',2.06),('15529','2014-02-23','12:00:00',1.55),('15529','2014-02-23','12:05:00',2.28),('15529','2014-02-23','12:10:00',2.21),('15529','2014-02-23','12:15:00',2.18),('15529','2014-02-23','12:20:00',2.2),('15529','2014-02-23','12:25:00',2.19),('15529','2014-02-23','12:30:00',2.22),('15529','2014-02-23','12:35:00',2.22),('15529','2014-02-23','12:40:00',2.25),('15529','2014-02-23','12:45:00',2.23),('15529','2014-02-23','12:50:00',2.21),('15529','2014-02-23','12:55:00',2.11),('15529','2014-02-23','13:00:00',1.06),('15529','2014-02-23','13:05:00',1.9),('15529','2014-02-23','15:25:00',1.32),('15529','2014-02-23','15:35:00',1.14),('15529','2014-02-23','15:40:00',1.24),('15529','2014-02-23','15:45:00',1.37),('15529','2014-02-23','15:50:00',1.36),('15529','2014-02-23','15:55:00',1.34),('15529','2014-02-23','16:00:00',1.35),('15529','2014-02-23','16:05:00',1.29),('15529','2014-02-23','16:10:00',1.22),('15529','2014-02-23','16:15:00',1.08),('15529','2014-02-22','08:35:00',1.03),('15529','2014-02-22','08:40:00',1.08),('15529','2014-02-22','08:45:00',1.13),('15529','2014-02-22','08:50:00',1.19),('15529','2014-02-22','08:55:00',1.24),('15529','2014-02-22','09:00:00',1.29),('15529','2014-02-22','09:05:00',1.34),('15529','2014-02-22','09:10:00',1.4),('15529','2014-02-22','09:15:00',1.45),('15529','2014-02-22','09:20:00',1.49),('15529','2014-02-22','09:25:00',1.38),('15529','2014-02-22','09:30:00',1.37),('15529','2014-02-22','09:35:00',1.58),('15529','2014-02-22','09:40:00',1.61),('15529','2014-02-22','09:45:00',1.63),('15529','2014-02-22','09:50:00',1.65),('15529','2014-02-22','09:55:00',1.69),('15529','2014-02-22','10:00:00',1.72),('15529','2014-02-22','10:05:00',1.74),('15529','2014-02-22','10:10:00',1.78),('15529','2014-02-22','10:15:00',1.79),('15529','2014-02-22','10:20:00',1.82),('15529','2014-02-22','10:25:00',1.85),('15529','2014-02-22','10:30:00',1.88),('15529','2014-02-22','10:35:00',1.89),('15529','2014-02-22','10:40:00',1.93),('15529','2014-02-22','10:45:00',1.94),('15529','2014-02-22','10:50:00',1.93),('15529','2014-02-22','10:55:00',2),('15529','2014-02-22','11:00:00',2.02),('15529','2014-02-22','11:05:00',2.03),('15529','2014-02-22','11:10:00',2.01),('15529','2014-02-22','11:15:00',2.09),('15529','2014-02-22','11:20:00',2.13),('15529','2014-02-22','11:25:00',2.18),('15529','2014-02-22','11:30:00',2.16),('15529','2014-02-22','11:35:00',2.11),('15529','2014-02-22','11:40:00',1.91),('15529','2014-02-22','11:45:00',1.97),('15529','2014-02-22','11:50:00',2.15),('15529','2014-02-22','11:55:00',1.78),('15529','2014-02-22','12:00:00',2.21),('15529','2014-02-22','12:05:00',2.32),('15529','2014-02-22','12:10:00',2.1),('15529','2014-02-22','12:15:00',2.4),('15529','2014-02-22','12:20:00',1.81),('15529','2014-02-22','12:30:00',2.05),('15529','2014-02-22','12:35:00',1.53),('15529','2014-02-22','12:40:00',1.54),('15529','2014-02-22','12:45:00',1.39),('15529','2014-02-22','12:50:00',1.45),('15529','2014-02-22','12:55:00',1.64),('15529','2014-02-22','13:00:00',1.99),('15529','2014-02-22','13:05:00',2.19),('15529','2014-02-22','13:10:00',2.21),('15529','2014-02-22','13:15:00',2.21),('15529','2014-02-22','13:20:00',2.2),('15529','2014-02-22','13:25:00',2.17),('15529','2014-02-22','13:30:00',1.81),('15529','2014-02-22','13:35:00',1.74),('15529','2014-02-22','13:40:00',1.85),('15529','2014-02-22','13:45:00',1.68),('15529','2014-02-22','13:50:00',1.12),('15529','2014-02-22','14:05:00',1.05),('15529','2014-02-22','14:10:00',2),('15529','2014-02-22','14:20:00',1.41),('15529','2014-02-22','14:25:00',1.87),('15529','2014-02-22','14:30:00',1.27),('15529','2014-02-22','14:35:00',1.58),('15529','2014-02-22','14:40:00',1.96),('15529','2014-02-22','14:45:00',2.05),('15529','2014-02-22','14:50:00',1.99),('15529','2014-02-22','14:55:00',1.62),('15529','2014-02-22','15:25:00',1.35),('15529','2014-02-21','10:10:00',1.31),('15529','2014-02-21','10:40:00',1.39),('15529','2014-02-21','10:45:00',2.27),('15529','2014-02-21','12:20:00',1.09),('15529','2014-02-21','12:40:00',2),('15529','2014-02-21','12:45:00',2.31),('15529','2014-02-21','12:50:00',2.35),('15529','2014-02-21','12:55:00',1.06),('15529','2014-02-21','13:05:00',2.17),('15529','2014-02-21','13:10:00',2.24),('15529','2014-02-21','13:30:00',1.78),('15529','2014-02-21','13:35:00',1.89),('15529','2014-02-21','13:40:00',1.4),('15529','2014-02-21','13:45:00',1.53),('15529','2014-02-21','13:50:00',2.31),('15529','2014-02-21','13:55:00',2.24),('15529','2014-02-21','14:00:00',1.57),('15529','2014-02-21','14:05:00',1.65),('15529','2014-02-21','14:10:00',2.04),('15529','2014-02-21','14:15:00',1.99),('15529','2014-02-21','14:20:00',1.93),('15529','2014-02-21','14:25:00',1.74),('15529','2014-02-21','14:30:00',1.91),('15529','2014-02-21','14:35:00',1.72),('15529','2014-02-21','14:40:00',1.97),('15529','2014-02-21','14:45:00',1.99),('15529','2014-02-21','15:00:00',1.02),('15529','2014-02-21','15:20:00',1.02),('15529','2014-02-21','15:45:00',1.17),('15529','2014-02-20','10:20:00',1.2),('15529','2014-02-20','10:25:00',1.31),('15529','2014-02-20','10:30:00',1.09),('15529','2014-02-20','10:50:00',1.5),('15529','2014-02-20','10:55:00',1.71),('15529','2014-02-20','11:00:00',1.62),('15529','2014-02-20','11:10:00',1.03),('15529','2014-02-20','11:55:00',1.74),('15529','2014-02-20','12:00:00',2.62),('15529','2014-02-20','12:05:00',1.89),('15529','2014-02-20','12:10:00',1.81),('15529','2014-02-20','12:15:00',1.19),('15529','2014-02-20','15:35:00',1.14),('15529','2014-02-20','15:40:00',1.19),('15529','2014-02-20','15:45:00',1.13),('15529','2014-02-18','13:45:00',1.23),('15529','2014-02-18','13:50:00',1.12),('15529','2014-02-18','13:55:00',1.08),('15529','2014-02-18','14:00:00',1.02),('15529','2014-02-18','14:20:00',1.07),('15529','2014-02-17','08:45:00',1.01),('15529','2014-02-17','08:50:00',1.04),('15529','2014-02-17','08:55:00',1.11),('15529','2014-02-17','09:00:00',1.15),('15529','2014-02-17','09:05:00',1.2),('15529','2014-02-17','09:10:00',1.24),('15529','2014-02-17','09:15:00',1.28),('15529','2014-02-17','09:20:00',1.33),('15529','2014-02-17','09:25:00',1.37),('15529','2014-02-17','09:30:00',1.41),('15529','2014-02-17','09:35:00',1.44),('15529','2014-02-17','09:40:00',1.48),('15529','2014-02-17','09:45:00',1.51),('15529','2014-02-17','09:50:00',1.55),('15529','2014-02-17','09:55:00',1.59),('15529','2014-02-17','10:00:00',1.61),('15529','2014-02-17','10:05:00',1.64),('15529','2014-02-17','10:10:00',1.67),('15529','2014-02-17','10:15:00',1.69),('15529','2014-02-17','10:20:00',1.71),('15529','2014-02-17','10:25:00',1.73),('15529','2014-02-17','10:30:00',1.76),('15529','2014-02-17','10:35:00',1.78),('15529','2014-02-17','10:40:00',1.8),('15529','2014-02-17','10:45:00',1.82),('15529','2014-02-17','10:50:00',1.85),('15529','2014-02-17','10:55:00',1.89),('15529','2014-02-17','11:00:00',1.92),('15529','2014-02-17','11:05:00',1.67),('15529','2014-02-17','11:10:00',1.66),('15529','2014-02-17','11:15:00',1.56),('15529','2014-02-17','11:20:00',1.78),('15529','2014-02-17','11:25:00',1.92),('15529','2014-02-17','11:30:00',1.82),('15529','2014-02-17','11:35:00',1.72),('15529','2014-02-17','11:40:00',1.06),('15529','2014-02-17','11:45:00',1.09),('15529','2014-02-17','12:25:00',1.14),('15529','2014-02-17','12:30:00',1.13),('15529','2014-02-17','13:15:00',1.11),('15529','2014-02-17','13:20:00',1.14),('15529','2014-02-17','13:25:00',1.5),('15529','2014-02-17','13:40:00',1.18),('15529','2014-02-17','13:45:00',1.18),('15529','2014-02-17','14:00:00',1.02),('15529','2014-02-17','14:05:00',1.46),('15529','2014-02-16','09:05:00',1.05),('15529','2014-02-16','09:10:00',1.11),('15529','2014-02-16','09:15:00',1.17),('15529','2014-02-16','09:20:00',1.21),('15529','2014-02-16','09:25:00',1.25),('15529','2014-02-16','09:30:00',1.3),('15529','2014-02-16','09:35:00',1.33),('15529','2014-02-16','09:40:00',1.37),('15529','2014-02-16','09:45:00',1.39),('15529','2014-02-16','09:50:00',1.41),('15529','2014-02-16','09:55:00',1.44),('15529','2014-02-16','10:00:00',1.46),('15529','2014-02-16','10:05:00',1.5),('15529','2014-02-16','10:10:00',1.53),('15529','2014-02-16','10:15:00',1.55),('15529','2014-02-16','10:20:00',1.56),('15529','2014-02-16','10:25:00',1.59),('15529','2014-02-16','10:30:00',1.6),('15529','2014-02-16','10:35:00',1.61),('15529','2014-02-16','10:40:00',1.6),('15529','2014-02-16','10:45:00',1.62),('15529','2014-02-16','10:50:00',1.65),('15529','2014-02-16','10:55:00',1.68),('15529','2014-02-16','11:00:00',1.69),('15529','2014-02-16','11:05:00',1.71),('15529','2014-02-16','11:10:00',1.73),('15529','2014-02-16','11:15:00',1.74),('15529','2014-02-16','11:20:00',1.74),('15529','2014-02-16','11:25:00',1.8),('15529','2014-02-16','11:30:00',1.85),('15529','2014-02-16','11:35:00',1.88),('15529','2014-02-16','11:40:00',1.87),('15529','2014-02-16','11:45:00',1.89),('15529','2014-02-16','11:50:00',1.89),('15529','2014-02-16','11:55:00',1.89),('15529','2014-02-16','12:00:00',1.88),('15529','2014-02-16','12:05:00',1.9),('15529','2014-02-16','12:10:00',1.89),('15529','2014-02-16','12:15:00',1.9),('15529','2014-02-16','12:20:00',1.9),('15529','2014-02-16','12:25:00',1.89),('15529','2014-02-16','12:30:00',1.88),('15529','2014-02-16','12:35:00',1.9),('15529','2014-02-16','12:40:00',1.89),('15529','2014-02-16','12:45:00',1.87),('15529','2014-02-16','12:50:00',1.88),('15529','2014-02-16','12:55:00',1.86),('15529','2014-02-16','13:00:00',1.86),('15529','2014-02-16','13:05:00',1.87),('15529','2014-02-16','13:10:00',1.87),('15529','2014-02-16','13:15:00',1.85),('15529','2014-02-16','13:20:00',1.83),('15529','2014-02-16','13:25:00',1.82),('15529','2014-02-16','13:30:00',1.83),('15529','2014-02-16','13:35:00',1.82),('15529','2014-02-16','13:40:00',1.8),('15529','2014-02-16','13:45:00',1.74),('15529','2014-02-16','13:50:00',1.74),('15529','2014-02-16','13:55:00',1.73),('15529','2014-02-16','14:00:00',1.7),('15529','2014-02-16','14:05:00',1.69),('15529','2014-02-16','14:10:00',1.62),('15529','2014-02-16','14:15:00',1.59),('15529','2014-02-16','14:20:00',1.63),('15529','2014-02-16','14:25:00',1.58),('15529','2014-02-16','14:30:00',1.51),('15529','2014-02-16','14:35:00',1.47),('15529','2014-02-16','14:40:00',1.46),('15529','2014-02-16','14:45:00',1.49),('15529','2014-02-16','14:50:00',1.45),('15529','2014-02-16','14:55:00',1.37),('15529','2014-02-16','15:00:00',1.3),('15529','2014-02-16','15:05:00',1.27),('15529','2014-02-16','15:10:00',1.25),('15529','2014-02-16','15:15:00',1.27),('15529','2014-02-16','15:20:00',1.21),('15529','2014-02-16','15:25:00',1.16),('15529','2014-02-16','15:30:00',1.12),('15529','2014-02-16','15:35:00',1.07),('15529','2014-02-15','08:45:00',1.01),('15529','2014-02-15','08:50:00',1.02),('15529','2014-02-15','08:55:00',1.11),('15529','2014-02-15','09:00:00',1.21),('15529','2014-02-15','09:05:00',1.24),('15529','2014-02-15','09:10:00',1.16),('15529','2014-02-15','09:15:00',1),('15529','2014-02-15','09:20:00',1.31),('15529','2014-02-15','09:25:00',1.33),('15529','2014-02-15','09:30:00',1.31),('15529','2014-02-15','09:35:00',1.1),('15529','2014-02-15','09:40:00',1.47),('15529','2014-02-15','09:45:00',1.52),('15529','2014-02-15','09:50:00',1.54),('15529','2014-02-15','09:55:00',1.44),('15529','2014-02-15','10:00:00',1.5),('15529','2014-02-15','10:05:00',1.64),('15529','2014-02-15','10:10:00',1.67),('15529','2014-02-15','10:15:00',1.69),('15529','2014-02-15','10:20:00',1.7),('15529','2014-02-15','10:25:00',1.75),('15529','2014-02-15','10:30:00',1.75),('15529','2014-02-15','10:35:00',1.8),('15529','2014-02-15','10:40:00',1.82),('15529','2014-02-15','10:45:00',1.74),('15529','2014-02-15','10:50:00',1.45),('15529','2014-02-15','10:55:00',1.72),('15529','2014-02-15','11:00:00',1.87),('15529','2014-02-15','11:05:00',1.88),('15529','2014-02-15','11:10:00',1.81),('15529','2014-02-15','11:15:00',1.87),('15529','2014-02-15','11:20:00',1.77),('15529','2014-02-15','11:25:00',1.82),('15529','2014-02-15','11:30:00',1.81),('15529','2014-02-15','11:35:00',1.93),('15529','2014-02-15','11:40:00',1.85),('15529','2014-02-15','11:45:00',1.85),('15529','2014-02-15','11:50:00',1.88),('15529','2014-02-15','11:55:00',1.76),('15529','2014-02-15','12:00:00',1.98),('15529','2014-02-15','12:05:00',1.99),('15529','2014-02-15','12:10:00',1.97),('15529','2014-02-15','12:15:00',1.99),('15529','2014-02-15','12:20:00',1.93),('15529','2014-02-15','12:25:00',1.99),('15529','2014-02-15','12:30:00',1.99),('15529','2014-02-15','12:35:00',1.97),('15529','2014-02-15','12:40:00',1.98),('15529','2014-02-15','12:45:00',1.96),('15529','2014-02-15','12:50:00',1.97),('15529','2014-02-15','12:55:00',1.95),('15529','2014-02-15','13:00:00',1.93),('15529','2014-02-15','13:05:00',1.91),('15529','2014-02-15','13:10:00',1.85),('15529','2014-02-15','13:15:00',1.93),('15529','2014-02-15','13:20:00',1.9),('15529','2014-02-15','13:25:00',1.85),('15529','2014-02-15','13:30:00',1.84),('15529','2014-02-15','13:35:00',1.83),('15529','2014-02-15','13:40:00',1.82),('15529','2014-02-15','13:45:00',1.81),('15529','2014-02-15','13:50:00',1.83),('15529','2014-02-15','13:55:00',1.81),('15529','2014-02-15','14:00:00',1.83),('15529','2014-02-15','14:05:00',1.8),('15529','2014-02-15','14:10:00',1.78),('15529','2014-02-15','14:15:00',1.75),('15529','2014-02-15','14:20:00',1.74),('15529','2014-02-15','14:25:00',1.71),('15529','2014-02-15','14:30:00',1.68),('15529','2014-02-15','14:35:00',1.63),('15529','2014-02-15','14:40:00',1.58),('15529','2014-02-15','14:45:00',1.58),('15529','2014-02-15','14:50:00',1.55),('15529','2014-02-15','14:55:00',1.48),('15529','2014-02-15','15:00:00',1.41),('15529','2014-02-15','15:05:00',1.44),('15529','2014-02-15','15:10:00',1.41),('15529','2014-02-15','15:15:00',1.36),('15529','2014-02-15','15:20:00',1.3),('15529','2014-02-15','15:25:00',1.27),('15529','2014-02-15','15:30:00',1.22),('15529','2014-02-15','15:35:00',1.18),('15529','2014-02-15','15:45:00',1.12),('15529','2014-04-27','08:20:00',1.05),('15529','2014-04-27','09:05:00',1.16),('15529','2014-04-27','09:10:00',1.46),('15529','2014-04-27','09:15:00',1.53),('15529','2014-04-27','09:20:00',1.58),('15529','2014-04-27','09:30:00',1.41),('15529','2014-04-27','09:35:00',1.44),('15529','2014-04-27','10:00:00',1.1),('15529','2014-04-27','10:05:00',1.11),('15529','2014-04-27','10:55:00',1.02),('15529','2014-04-27','11:00:00',1.36),('15529','2014-04-27','11:05:00',1.41),('15529','2014-04-27','11:10:00',1.51),('15529','2014-04-27','11:15:00',1.42),('15529','2014-04-27','11:20:00',1.04),('15529','2014-04-27','12:05:00',1.05),('15529','2014-04-27','12:10:00',1.54),('15529','2014-04-27','12:15:00',1.39),('15529','2014-04-27','12:20:00',1.31),('15529','2014-04-27','12:25:00',1.44),('15529','2014-04-27','12:30:00',1.29),('15529','2014-04-27','12:35:00',1.03),('15529','2014-04-27','12:45:00',1.02),('15529','2014-04-27','12:50:00',1.06),('15529','2014-04-27','12:55:00',1.06),('15529','2014-04-27','13:00:00',1.74),('15529','2014-04-27','13:05:00',1.27),('15529','2014-04-27','13:10:00',1.1),('15529','2014-04-27','13:15:00',1.64),('15529','2014-04-27','13:20:00',1.47),('15529','2014-04-27','13:25:00',1.24),('15529','2014-04-27','13:30:00',2.59),('15529','2014-04-27','13:35:00',2.08),('15529','2014-04-27','13:40:00',2.46),('15529','2014-04-27','13:45:00',2.54),('15529','2014-04-27','13:50:00',1.27),('15529','2014-04-27','13:55:00',1.73),('15529','2014-04-27','14:00:00',1.98),('15529','2014-04-27','14:05:00',2.55),('15529','2014-04-27','14:10:00',1.38),('15529','2014-04-27','14:15:00',1.75),('15529','2014-04-27','14:20:00',2.25),('15529','2014-04-27','14:25:00',2.11),('15529','2014-04-27','14:35:00',2.08),('15529','2014-04-27','14:40:00',2.29),('15529','2014-04-27','14:45:00',1.72),('15529','2014-04-27','14:50:00',1.81),('15529','2014-04-27','14:55:00',1.08),('15529','2014-04-27','15:00:00',1.56),('15529','2014-04-27','15:10:00',1.1),('15529','2014-04-27','15:15:00',1.49),('15529','2014-04-27','15:20:00',1.53),('15529','2014-04-27','15:30:00',1.1),('15529','2014-04-27','15:35:00',1.14),('15529','2014-04-27','15:45:00',1.76),('15529','2014-04-27','15:55:00',1.15),('15529','2014-04-27','16:00:00',1.22),('15529','2014-04-27','16:05:00',1.62),('15529','2014-04-27','16:10:00',1.5),('15529','2014-04-27','16:15:00',1.2),('15529','2014-04-27','16:20:00',1.33),('15529','2014-04-27','16:25:00',1.72),('15529','2014-04-27','16:30:00',1.48),('15529','2014-04-27','16:50:00',1.33),('15529','2014-02-14','08:55:00',1.05),('15529','2014-02-14','09:00:00',1.12),('15529','2014-02-14','09:05:00',1.16),('15529','2014-02-14','09:10:00',1.2),('15529','2014-02-14','09:15:00',1.22),('15529','2014-02-14','09:20:00',1.28),('15529','2014-02-14','09:25:00',1.31),('15529','2014-02-14','09:30:00',1.32),('15529','2014-02-14','09:35:00',1.37),('15529','2014-02-14','09:40:00',1.43),('15529','2014-02-14','09:45:00',1.44),('15529','2014-02-14','09:50:00',1.47),('15529','2014-02-14','09:55:00',1.52),('15529','2014-02-14','10:00:00',1.55),('15529','2014-02-14','10:05:00',1.57),('15529','2014-02-14','10:10:00',1.59),('15529','2014-02-14','10:15:00',1.61),('15529','2014-02-14','10:20:00',1.61),('15529','2014-02-14','10:25:00',1.64),('15529','2014-02-14','10:30:00',1.65),('15529','2014-02-14','10:35:00',1.67),('15529','2014-02-14','10:40:00',1.72),('15529','2014-02-14','10:45:00',1.76),('15529','2014-02-14','10:50:00',1.75),('15529','2014-02-14','10:55:00',1.77),('15529','2014-02-14','11:00:00',1.77),('15529','2014-02-14','11:05:00',1.82),('15529','2014-02-14','11:10:00',1.88),('15529','2014-02-14','11:15:00',1.43),('15529','2014-02-14','11:25:00',1.27),('15529','2014-02-14','11:35:00',2.07),('15529','2014-02-14','11:40:00',1.03),('15529','2014-02-14','11:45:00',2.24),('15529','2014-02-14','11:50:00',1.83),('15529','2014-02-14','11:55:00',1.33),('15529','2014-02-14','12:00:00',2.18),('15529','2014-02-14','12:05:00',2.15),('15529','2014-02-14','12:10:00',2.07),('15529','2014-02-14','12:15:00',2.07),('15529','2014-02-14','12:20:00',1.77),('15529','2014-02-14','12:25:00',2.06),('15529','2014-02-14','12:35:00',1.55),('15529','2014-02-14','12:40:00',2.11),('15529','2014-02-14','12:45:00',2.08),('15529','2014-02-14','12:50:00',2.02),('15529','2014-02-14','12:55:00',2.01),('15529','2014-02-14','13:00:00',1.96),('15529','2014-02-14','13:05:00',1.3),('15529','2014-02-14','13:10:00',1.22),('15529','2014-02-14','13:15:00',2.12),('15529','2014-02-14','13:20:00',2.09),('15529','2014-02-14','13:25:00',1.99),('15529','2014-02-14','13:30:00',1.86),('15529','2014-02-14','13:35:00',1.87),('15529','2014-02-14','13:40:00',1.97),('15529','2014-02-14','13:45:00',1.46),('15529','2014-02-14','13:50:00',1.85),('15529','2014-02-14','13:55:00',1.84),('15529','2014-02-14','14:00:00',1.54),('15529','2014-02-14','14:05:00',1.63),('15529','2014-02-14','14:10:00',1.64),('15529','2014-02-14','14:15:00',1.69),('15529','2014-02-14','14:20:00',1.71),('15529','2014-02-14','14:25:00',1.67),('15529','2014-02-14','14:30:00',1.66),('15529','2014-02-14','14:35:00',1.62),('15529','2014-02-14','14:40:00',1.59),('15529','2014-02-14','14:45:00',1.54),('15529','2014-02-14','14:50:00',1.52),('15529','2014-02-14','14:55:00',1.48),('15529','2014-02-14','15:00:00',1.46),('15529','2014-02-14','15:05:00',1.42),('15529','2014-02-14','15:10:00',1.38),('15529','2014-02-14','15:15:00',1.35),('15529','2014-02-14','15:20:00',1.3),('15529','2014-02-14','15:25:00',1.26),('15529','2014-02-14','15:30:00',1.21),('15529','2014-02-14','15:35:00',1.18),('15529','2014-02-14','15:40:00',1.13),('15529','2014-02-14','15:45:00',1.09),('15529','2014-02-14','15:50:00',1.04),('15529','2014-02-13','08:50:00',1),('15529','2014-02-13','08:55:00',1.04),('15529','2014-02-13','09:00:00',1.09),('15529','2014-02-13','09:05:00',1.15),('15529','2014-02-13','09:10:00',1.2),('15529','2014-02-13','09:20:00',1.04),('15529','2014-02-13','09:25:00',1.04),('15529','2014-02-13','09:35:00',1.06),('15529','2014-02-13','09:40:00',1.02),('15529','2014-02-13','09:45:00',1.28),('15529','2014-02-13','09:50:00',1.34),('15529','2014-02-13','09:55:00',1.55),('15529','2014-02-13','10:00:00',1.57),('15529','2014-02-13','10:05:00',1.55),('15529','2014-02-13','10:10:00',1.6),('15529','2014-02-13','10:15:00',1.79),('15529','2014-02-13','10:20:00',1.78),('15529','2014-02-13','10:25:00',1.7),('15529','2014-02-13','10:30:00',1.85),('15529','2014-02-13','10:35:00',1.83),('15529','2014-02-13','10:40:00',1.87),('15529','2014-02-13','10:45:00',1.94),('15529','2014-02-13','10:50:00',1.91),('15529','2014-02-13','10:55:00',1.92),('15529','2014-02-13','11:00:00',1.94),('15529','2014-02-13','11:05:00',1.97),('15529','2014-02-13','11:10:00',1.98),('15529','2014-02-13','11:15:00',2.01),('15529','2014-02-13','11:20:00',2.04),('15529','2014-02-13','11:25:00',2.04),('15529','2014-02-13','11:30:00',2.06),('15529','2014-02-13','11:35:00',2),('15529','2014-02-13','11:40:00',2.05),('15529','2014-02-13','11:45:00',2.08),('15529','2014-02-13','11:50:00',2.09),('15529','2014-02-13','11:55:00',2.04),('15529','2014-02-13','12:00:00',1.91),('15529','2014-02-13','12:05:00',1.96),('15529','2014-02-13','12:10:00',2.12),('15529','2014-02-13','12:15:00',2.09),('15529','2014-02-13','12:20:00',2.11),('15529','2014-02-13','12:25:00',2.1),('15529','2014-02-13','12:30:00',2.09),('15529','2014-02-13','12:35:00',2.09),('15529','2014-02-13','12:40:00',2.08),('15529','2014-02-13','12:45:00',2.05),('15529','2014-02-13','12:50:00',2.06),('15529','2014-02-13','12:55:00',2.06),('15529','2014-02-13','13:00:00',2.04),('15529','2014-02-13','13:05:00',2.06),('15529','2014-02-13','13:10:00',2.05),('15529','2014-02-13','13:15:00',2.03),('15529','2014-02-13','13:20:00',2.03),('15529','2014-02-13','13:25:00',2.01),('15529','2014-02-13','13:30:00',1.99),('15529','2014-02-13','13:35:00',1.98),('15529','2014-02-13','13:40:00',1.95),('15529','2014-02-13','13:45:00',1.95),('15529','2014-02-13','13:50:00',1.93),('15529','2014-02-13','13:55:00',1.91),('15529','2014-02-13','14:00:00',1.86),('15529','2014-02-13','14:05:00',1.85),('15529','2014-02-13','14:10:00',1.82),('15529','2014-02-13','14:15:00',1.79),('15529','2014-02-13','14:20:00',1.76),('15529','2014-02-13','14:25:00',1.74),('15529','2014-02-13','14:30:00',1.72),('15529','2014-02-13','14:35:00',1.68),('15529','2014-02-13','14:40:00',1.64),('15529','2014-02-13','14:45:00',1.61),('15529','2014-02-13','14:50:00',1.56),('15529','2014-02-13','14:55:00',1.53),('15529','2014-02-13','15:00:00',1.48),('15529','2014-02-13','15:05:00',1.44),('15529','2014-02-13','15:10:00',1.4),('15529','2014-02-13','15:15:00',1.36),('15529','2014-02-13','15:20:00',1.33),('15529','2014-02-13','15:25:00',1.28),('15529','2014-02-13','15:30:00',1.24),('15529','2014-02-13','15:35:00',1.2),('15529','2014-02-13','15:40:00',1.13),('15529','2014-02-13','15:45:00',1.07),('15529','2014-02-13','15:50:00',1.01),('15529','2014-02-12','08:55:00',1.04),('15529','2014-02-12','09:00:00',1.09),('15529','2014-02-12','09:05:00',1.14),('15529','2014-02-12','09:10:00',1.19),('15529','2014-02-12','09:15:00',1.24),('15529','2014-02-12','09:20:00',1.26),('15529','2014-02-12','09:25:00',1.32),('15529','2014-02-12','09:30:00',1.35),('15529','2014-02-12','09:35:00',1.39),('15529','2014-02-12','09:40:00',1.42),('15529','2014-02-12','09:45:00',1.46),('15529','2014-02-12','09:50:00',1.49),('15529','2014-02-12','09:55:00',1.52),('15529','2014-02-12','10:00:00',1.54),('15529','2014-02-12','10:05:00',1.58),('15529','2014-02-12','10:10:00',1.6),('15529','2014-02-12','10:15:00',1.62),('15529','2014-02-12','10:20:00',1.65),('15529','2014-02-12','10:25:00',1.7),('15529','2014-02-12','10:30:00',1.71),('15529','2014-02-12','10:35:00',1.73),('15529','2014-02-12','10:40:00',1.73),('15529','2014-02-12','10:45:00',1.75),('15529','2014-02-12','10:50:00',1.81),('15529','2014-02-12','10:55:00',1.82),('15529','2014-02-12','11:00:00',1.81),('15529','2014-02-12','11:05:00',1.86),('15529','2014-02-12','11:10:00',1.87),('15529','2014-02-12','11:15:00',1.87),('15529','2014-02-12','11:20:00',1.86),('15529','2014-02-12','11:25:00',1.15),('15529','2014-02-12','11:30:00',1.23),('15529','2014-02-12','11:40:00',1.5),('15529','2014-02-12','11:45:00',1.41),('15529','2014-02-12','11:55:00',1.06),('15529','2014-02-12','12:00:00',2.31),('15529','2014-02-12','12:05:00',1.96),('15529','2014-02-12','12:10:00',1.15),('15529','2014-02-12','12:15:00',1.73),('15529','2014-02-12','12:20:00',1.77),('15529','2014-02-12','12:25:00',2.23),('15529','2014-02-12','12:30:00',2.18),('15529','2014-02-12','12:35:00',2.18),('15529','2014-02-12','12:40:00',2.22),('15529','2014-02-12','12:45:00',2.1),('15529','2014-02-12','12:50:00',2.06),('15529','2014-02-12','12:55:00',2.05),('15529','2014-02-12','13:00:00',2.05),('15529','2014-02-12','13:05:00',2.04),('15529','2014-02-12','13:10:00',2.02),('15529','2014-02-12','13:15:00',2.01),('15529','2014-02-12','13:20:00',1.97),('15529','2014-02-12','13:25:00',1.97),('15529','2014-02-12','13:30:00',1.98),('15529','2014-02-12','13:35:00',1.97),('15529','2014-02-12','13:40:00',1.93),('15529','2014-02-12','13:45:00',1.92),('15529','2014-02-12','13:50:00',1.92),('15529','2014-02-12','13:55:00',1.89),('15529','2014-02-12','14:00:00',1.87),('15529','2014-02-12','14:05:00',1.84),('15529','2014-02-12','14:10:00',1.82),('15529','2014-02-12','14:15:00',1.8),('15529','2014-02-12','14:20:00',1.77),('15529','2014-02-12','14:25:00',1.73),('15529','2014-02-12','14:30:00',1.71),('15529','2014-02-12','14:35:00',1.71),('15529','2014-02-12','14:40:00',1.68),('15529','2014-02-12','14:45:00',1.17),('15529','2014-02-12','14:50:00',1.4),('15529','2014-02-12','15:00:00',1.56),('15529','2014-02-12','15:05:00',1.54),('15529','2014-02-12','15:15:00',1.5),('15529','2014-02-12','15:20:00',1.43),('15529','2014-02-12','15:30:00',1.45),('15529','2014-02-12','15:35:00',1.31),('15529','2014-02-12','15:40:00',1.03),('15529','2014-02-11','08:45:00',1.04),('15529','2014-02-11','08:50:00',1.05),('15529','2014-02-11','08:55:00',1.06),('15529','2014-02-11','09:00:00',1.09),('15529','2014-02-11','09:05:00',1.09),('15529','2014-02-11','09:10:00',1.31),('15529','2014-02-11','09:15:00',1.26),('15529','2014-02-11','09:20:00',1.02),('15529','2014-02-11','09:40:00',1.13),('15529','2014-02-11','09:45:00',1.36),('15529','2014-02-11','10:40:00',1.15),('15529','2014-02-11','11:30:00',1.09),('15529','2014-02-11','12:55:00',1.17),('15529','2014-02-11','13:00:00',1.26),('15529','2014-02-11','13:30:00',1.11),('15529','2014-02-11','13:35:00',1.74),('15529','2014-02-11','13:40:00',1.84),('15529','2014-02-11','13:45:00',1.39),('15529','2014-02-11','13:50:00',1.3),('15529','2014-02-11','13:55:00',1.54),('15529','2014-02-11','14:00:00',2.12),('15529','2014-02-11','14:05:00',1.79),('15529','2014-02-11','14:10:00',1.58),('15529','2014-02-11','14:15:00',2.05),('15529','2014-02-11','14:20:00',1.04),('15529','2014-02-11','14:25:00',1.01),('15529','2014-02-11','14:30:00',1.62),('15529','2014-02-11','14:40:00',1.68),('15529','2014-02-11','14:45:00',1.8),('15529','2014-02-11','14:50:00',1.69),('15529','2014-02-11','14:55:00',1.41),('15529','2014-02-11','15:00:00',1.13),('15529','2014-02-11','15:10:00',1.33),('15529','2014-02-11','15:15:00',1.4),('15529','2014-02-11','15:20:00',1.34),('15529','2014-02-11','15:35:00',1.48),('15529','2014-02-11','15:50:00',1.06),('15529','2014-02-11','15:55:00',1.13),('15529','2014-02-11','16:00:00',1.05),('15529','2014-02-10','10:20:00',1.15),('15529','2014-02-10','10:25:00',1.3),('15529','2014-02-10','10:30:00',1.38),('15529','2014-02-10','10:35:00',1.31),('15529','2014-02-10','10:40:00',1.21),('15529','2014-02-10','10:45:00',1.25),('15529','2014-02-10','10:50:00',1.37),('15529','2014-02-10','10:55:00',1.15),('15529','2014-02-10','11:00:00',1.33),('15529','2014-02-10','11:05:00',1.41),('15529','2014-02-10','11:10:00',1.25),('15529','2014-02-10','11:15:00',1.5),('15529','2014-02-10','11:20:00',1.32),('15529','2014-02-10','11:25:00',1.45),('15529','2014-02-10','11:30:00',1.08),('15529','2014-02-10','12:10:00',1.07),('15529','2014-02-10','12:15:00',1.07),('15529','2014-02-10','12:25:00',1.24),('15529','2014-02-10','12:30:00',1.26),('15529','2014-02-10','12:35:00',1.18),('15529','2014-02-10','13:05:00',1.43),('15529','2014-02-10','13:10:00',1.89),('15529','2014-02-10','13:15:00',1.89),('15529','2014-02-10','13:20:00',1.93),('15529','2014-02-10','13:25:00',1.61),('15529','2014-02-10','13:30:00',1.54),('15529','2014-02-10','13:35:00',1.58),('15529','2014-02-10','13:40:00',1.56),('15529','2014-02-10','13:45:00',1.44),('15529','2014-02-10','14:05:00',1.26),('15529','2014-02-10','14:15:00',1.23),('15529','2014-02-10','14:25:00',1.08),('15529','2014-02-08','12:55:00',1.69),('15529','2014-02-08','13:00:00',1.34),('15529','2014-02-08','13:05:00',1.95),('15529','2014-02-08','13:10:00',1.03),('15529','2014-02-08','13:40:00',1.16),('15529','2014-02-08','13:45:00',1.75),('15529','2014-02-08','13:55:00',1.48),('15529','2014-02-08','14:00:00',1.11),('15529','2014-02-08','14:05:00',1.51),('15529','2014-02-08','14:25:00',1.15),('15529','2014-02-08','14:30:00',1.41),('15529','2014-02-08','15:20:00',1.13),('15529','2014-02-07','09:45:00',1.2),('15529','2014-02-07','10:00:00',1.01),('15529','2014-02-07','10:30:00',1.33),('15529','2014-02-07','10:50:00',1.59),('15529','2014-02-07','11:00:00',1.99),('15529','2014-02-07','11:05:00',1.49),('15529','2014-02-07','11:10:00',1.53),('15529','2014-02-07','11:15:00',1.12),('15529','2014-02-07','11:25:00',1.11),('15529','2014-02-07','11:30:00',1.64),('15529','2014-02-07','11:35:00',1.34),('15529','2014-02-07','11:50:00',2.35),('15529','2014-02-07','12:10:00',1.3),('15529','2014-02-07','12:20:00',2.12),('15529','2014-02-07','12:25:00',1.89),('15529','2014-02-07','12:30:00',1.6),('15529','2014-02-07','12:40:00',1.38),('15529','2014-02-07','12:45:00',1.71),('15529','2014-02-07','12:50:00',1.45),('15529','2014-02-07','12:55:00',2.14),('15529','2014-02-07','13:05:00',1.09),('15529','2014-02-07','13:10:00',1.68),('15529','2014-02-07','13:15:00',1.58),('15529','2014-02-07','13:20:00',1.25),('15529','2014-02-07','13:25:00',2.18),('15529','2014-02-07','13:30:00',2.03),('15529','2014-02-07','13:35:00',2.16),('15529','2014-02-07','13:40:00',2.16),('15529','2014-02-07','13:45:00',1.8),('15529','2014-02-07','13:50:00',2.02),('15529','2014-02-07','13:55:00',1.98),('15529','2014-02-07','14:00:00',1.96),('15529','2014-02-07','14:05:00',1.97),('15529','2014-02-07','14:10:00',1.91),('15529','2014-02-07','14:15:00',1.38),('15529','2014-02-07','14:20:00',1.69),('15529','2014-02-07','14:35:00',1.52),('15529','2014-02-07','14:45:00',1.21),('15529','2014-02-07','14:50:00',1.6),('15529','2014-02-07','15:40:00',1.11),('15529','2014-02-06','08:50:00',1.02),('15529','2014-02-06','08:55:00',1.06),('15529','2014-02-06','09:00:00',1.11),('15529','2014-02-06','09:05:00',1.16),('15529','2014-02-06','09:10:00',1.21),('15529','2014-02-06','09:15:00',1.25),('15529','2014-02-06','09:20:00',1.29),('15529','2014-02-06','09:25:00',1.32),('15529','2014-02-06','09:30:00',1.36),('15529','2014-02-06','09:35:00',1.39),('15529','2014-02-06','09:40:00',1.41),('15529','2014-02-06','09:45:00',1.45),('15529','2014-02-06','09:50:00',1.48),('15529','2014-02-06','09:55:00',1.51),('15529','2014-02-06','10:00:00',1.59),('15529','2014-02-06','10:05:00',1.73),('15529','2014-02-06','10:10:00',1.82),('15529','2014-02-06','10:15:00',1.86),('15529','2014-02-06','10:20:00',1.9),('15529','2014-02-06','10:25:00',1.85),('15529','2014-02-06','10:30:00',2.04),('15529','2014-02-06','10:35:00',1.2),('15529','2014-02-06','10:40:00',1.66),('15529','2014-02-06','10:45:00',1),('15529','2014-02-06','10:50:00',1.66),('15529','2014-02-06','10:55:00',2.16),('15529','2014-02-06','11:00:00',1.7),('15529','2014-02-06','11:15:00',2.26),('15529','2014-02-06','11:20:00',2.2),('15529','2014-02-06','11:25:00',2.2),('15529','2014-02-06','11:30:00',2.12),('15529','2014-02-06','11:35:00',2.23),('15529','2014-02-06','11:40:00',1.75),('15529','2014-02-06','11:45:00',1.7),('15529','2014-02-06','11:55:00',2.32),('15529','2014-02-06','12:00:00',1.4),('15529','2014-02-06','12:05:00',1.1),('15529','2014-02-06','12:10:00',1.6),('15529','2014-02-06','12:55:00',1.24),('15529','2014-02-06','13:00:00',1.97),('15529','2014-02-06','13:05:00',1.16),('15529','2014-02-06','13:10:00',2.03),('15529','2014-02-06','13:15:00',2.11),('15529','2014-02-06','13:20:00',2.22),('15529','2014-02-06','13:25:00',2.29),('15529','2014-02-06','13:30:00',1.94),('15529','2014-02-06','13:35:00',1.98),('15529','2014-02-06','13:45:00',1.14),('15529','2014-02-06','13:50:00',1.63),('15529','2014-02-06','13:55:00',1.82),('15529','2014-02-06','14:00:00',1.84),('15529','2014-02-06','14:05:00',1.57),('15529','2014-02-06','14:10:00',1.91),('15529','2014-02-06','14:15:00',1.85),('15529','2014-02-06','14:20:00',1.81),('15529','2014-02-06','14:25:00',1.79),('15529','2014-02-06','14:30:00',1.77),('15529','2014-02-06','14:35:00',1.78),('15529','2014-02-06','14:40:00',1.69),('15529','2014-02-06','14:45:00',1.6),('15529','2014-02-06','14:50:00',1.08),('15529','2014-02-06','14:55:00',1.25),('15529','2014-02-06','15:10:00',1.32),('15529','2014-02-06','15:15:00',1.43),('15529','2014-02-06','15:25:00',1.21),('15529','2014-02-06','15:30:00',1.24),('15529','2014-02-06','15:35:00',1.11),('15529','2014-02-06','15:40:00',1.13),('15529','2014-02-06','15:45:00',1.1),('15529','2014-02-06','15:50:00',1.05),('15529','2014-02-06','15:55:00',1.01),('15529','2014-02-05','08:50:00',1.02),('15529','2014-02-05','08:55:00',1.12),('15529','2014-02-05','09:00:00',1.26),('15529','2014-02-05','09:05:00',1.31),('15529','2014-02-05','09:10:00',1.03),('15529','2014-02-05','09:15:00',1.12),('15529','2014-02-05','09:30:00',1.41),('15529','2014-02-05','09:35:00',1.41),('15529','2014-02-05','09:40:00',1.49),('15529','2014-02-05','09:45:00',1.49),('15529','2014-02-05','09:50:00',1.54),('15529','2014-02-05','09:55:00',1.58),('15529','2014-02-05','10:00:00',1.64),('15529','2014-02-05','10:05:00',1.65),('15529','2014-02-05','10:10:00',1.68),('15529','2014-02-05','10:15:00',1.71),('15529','2014-02-05','10:20:00',1.76),('15529','2014-02-05','10:25:00',1.77),('15529','2014-02-05','10:30:00',1.68),('15529','2014-02-05','10:35:00',1.85),('15529','2014-02-05','10:45:00',1.76),('15529','2014-02-05','10:50:00',1.73),('15529','2014-02-05','11:00:00',1.78),('15529','2014-02-05','11:05:00',1.1),('15529','2014-02-05','11:10:00',1.55),('15529','2014-02-05','11:15:00',1.78),('15529','2014-02-05','11:20:00',2.2),('15529','2014-02-05','11:25:00',2.11),('15529','2014-02-05','11:30:00',2.09),('15529','2014-02-05','11:35:00',2.07),('15529','2014-02-05','11:40:00',2.08),('15529','2014-02-05','11:45:00',2.08),('15529','2014-02-05','11:50:00',2.12),('15529','2014-02-05','11:55:00',2.13),('15529','2014-02-05','12:00:00',2.13),('15529','2014-02-05','12:05:00',2.13),('15529','2014-02-05','12:10:00',2.15),('15529','2014-02-05','12:15:00',2.15),('15529','2014-02-05','12:20:00',2.13),('15529','2014-02-05','12:25:00',2.1),('15529','2014-02-05','12:30:00',2.12),('15529','2014-02-05','12:35:00',2.12),('15529','2014-02-05','12:40:00',2.12),('15529','2014-02-05','12:45:00',2.1),('15529','2014-02-05','12:50:00',2.09),('15529','2014-02-05','12:55:00',2.1),('15529','2014-02-05','13:00:00',2.08),('15529','2014-02-05','13:05:00',2.08),('15529','2014-02-05','13:10:00',2.08),('15529','2014-02-05','13:15:00',2.06),('15529','2014-02-05','13:20:00',2.05),('15529','2014-02-05','13:25:00',2.09),('15529','2014-02-05','13:30:00',2.11),('15529','2014-02-05','13:35:00',2.1),('15529','2014-02-05','13:40:00',2),('15529','2014-02-05','13:45:00',1.96),('15529','2014-02-05','13:50:00',1.94),('15529','2014-02-05','13:55:00',1.76),('15529','2014-02-05','14:00:00',1.91),('15529','2014-02-05','14:05:00',1.89),('15529','2014-02-05','14:10:00',1.83),('15529','2014-02-05','14:15:00',1.79),('15529','2014-02-05','14:20:00',1.47),('15529','2014-02-05','14:25:00',1.83),('15529','2014-02-05','14:30:00',1.44),('15529','2014-02-05','14:35:00',1.72),('15529','2014-02-05','14:40:00',1.7),('15529','2014-02-05','14:45:00',1.66),('15529','2014-02-05','14:50:00',1.62),('15529','2014-02-05','14:55:00',1.56),('15529','2014-02-05','15:00:00',1.48),('15529','2014-02-05','15:05:00',1.45),('15529','2014-02-05','15:10:00',1.39),('15529','2014-02-05','15:15:00',1.36),('15529','2014-02-05','15:20:00',1.32),('15529','2014-02-05','15:25:00',1.28),('15529','2014-02-05','15:30:00',1.22),('15529','2014-02-05','15:35:00',1.17),('15529','2014-02-05','15:40:00',1.12),('15529','2014-02-05','15:45:00',1.07),('15529','2014-02-05','15:50:00',1.01),('15529','2014-04-26','11:40:00',1.36),('15529','2014-04-26','11:45:00',1.82),('15529','2014-04-26','11:50:00',1.68),('15529','2014-04-26','11:55:00',1.21),('15529','2014-04-26','12:00:00',1.24),('15529','2014-04-26','12:05:00',1.46),('15529','2014-04-26','12:10:00',1.41),('15529','2014-04-26','12:15:00',1.45),('15529','2014-04-26','12:20:00',1.41),('15529','2014-04-26','12:25:00',1.42),('15529','2014-04-26','12:30:00',1.49),('15529','2014-04-26','12:35:00',1.73),('15529','2014-04-26','12:40:00',1.47),('15529','2014-04-26','12:45:00',1.12),('15529','2014-04-26','12:55:00',1.25),('15529','2014-04-26','13:00:00',1.04),('15529','2014-04-26','13:15:00',1.1),('15529','2014-04-26','13:20:00',1.16),('15529','2014-04-26','13:25:00',1.03),('15529','2014-04-26','14:00:00',1.42),('15529','2014-04-26','14:20:00',1.04),('15529','2014-04-26','14:25:00',1.18),('15529','2014-04-26','14:30:00',1.17),('15529','2014-04-26','14:35:00',1.41),('15529','2014-04-26','14:40:00',1.34),('15529','2014-04-26','14:45:00',1.01),('15529','2014-04-26','14:55:00',1.01),('15529','2014-04-26','15:00:00',1.2),('15529','2014-04-26','15:05:00',1.66),('15529','2014-04-26','15:10:00',1.51),('15529','2014-04-26','15:15:00',1.08),('15529','2014-02-04','10:10:00',1.2),('15529','2014-02-04','10:15:00',2.26),('15529','2014-02-04','10:20:00',2.16),('15529','2014-02-04','10:25:00',1.12),('15529','2014-02-04','10:35:00',1),('15529','2014-02-04','10:40:00',1.35),('15529','2014-02-04','11:20:00',2.05),('15529','2014-02-04','11:25:00',1.74),('15529','2014-02-04','13:05:00',1.09),('15529','2014-02-04','13:10:00',1.14),('15529','2014-02-04','13:35:00',1.03),('15529','2014-02-04','13:40:00',1.04),('15529','2014-02-04','13:45:00',1.02),('15529','2014-02-04','14:25:00',1.74),('15529','2014-02-04','14:30:00',1.61),('15529','2014-02-04','14:35:00',1.06),('15529','2014-02-03','09:35:00',1.16),('15529','2014-02-03','09:40:00',1.68),('15529','2014-02-03','09:45:00',1.32),('15529','2014-02-03','09:50:00',1.56),('15529','2014-02-03','10:15:00',1.16),('15529','2014-02-03','10:20:00',1.21),('15529','2014-02-03','10:25:00',1.3),('15529','2014-02-03','10:50:00',1.47),('15529','2014-02-03','10:55:00',1.75),('15529','2014-02-03','11:00:00',2.08),('15529','2014-02-03','11:05:00',2.33),('15529','2014-02-03','11:10:00',2.03),('15529','2014-02-03','11:15:00',1.31),('15529','2014-02-03','11:20:00',1.51),('15529','2014-02-03','11:50:00',1.26),('15529','2014-02-03','11:55:00',1.45),('15529','2014-02-03','12:00:00',1.32),('15529','2014-02-03','12:05:00',1.64),('15529','2014-02-03','13:15:00',1.01),('15529','2014-02-03','13:20:00',1.37),('15529','2014-01-31','12:10:00',1.2),('15529','2014-01-31','12:15:00',1.54),('15529','2014-01-31','12:20:00',1.56),('15529','2014-01-31','12:25:00',1.54),('15529','2014-01-31','12:30:00',1.28),('15529','2014-01-31','12:35:00',1.3),('15529','2014-01-31','12:40:00',1.2),('15529','2014-01-31','12:45:00',1.5),('15529','2014-01-31','12:55:00',1.41),('15529','2014-01-29','10:10:00',1.2),('15529','2014-01-29','10:15:00',1.53),('15529','2014-01-29','10:20:00',1.24),('15529','2014-01-29','10:25:00',1.5),('15529','2014-01-29','10:30:00',1.62),('15529','2014-01-29','10:35:00',1.73),('15529','2014-01-29','10:40:00',1.78),('15529','2014-01-29','10:45:00',1.51),('15529','2014-01-29','10:50:00',1.84),('15529','2014-01-29','10:55:00',1.64),('15529','2014-01-29','11:00:00',1.98),('15529','2014-01-29','11:05:00',1.8),('15529','2014-01-29','11:10:00',1.54),('15529','2014-01-29','11:15:00',2.02),('15529','2014-01-29','11:20:00',1.91),('15529','2014-01-29','11:25:00',1.94),('15529','2014-01-29','11:30:00',1.67),('15529','2014-01-29','11:35:00',1.83),('15529','2014-01-29','11:40:00',1.95),('15529','2014-01-29','11:45:00',1.97),('15529','2014-01-29','11:50:00',1.97),('15529','2014-01-29','11:55:00',1.87),('15529','2014-01-29','12:00:00',1.83),('15529','2014-01-29','12:05:00',2.01),('15529','2014-01-29','12:10:00',2.1),('15529','2014-01-29','12:15:00',2.12),('15529','2014-01-29','12:20:00',1.92),('15529','2014-01-29','12:25:00',1.68),('15529','2014-01-29','12:30:00',1.72),('15529','2014-01-29','12:35:00',1.74),('15529','2014-01-29','12:40:00',1.81),('15529','2014-01-29','12:45:00',1.97),('15529','2014-01-29','12:50:00',1.99),('15529','2014-01-29','12:55:00',1.99),('15529','2014-01-29','13:00:00',1.97),('15529','2014-01-29','13:05:00',1.98),('15529','2014-01-29','13:10:00',1.97),('15529','2014-01-29','13:15:00',1.93),('15529','2014-01-29','13:20:00',1.9),('15529','2014-01-29','13:25:00',1.81),('15529','2014-01-29','13:30:00',1.39),('15529','2014-01-29','13:35:00',1.44),('15529','2014-01-29','13:40:00',1.76),('15529','2014-01-29','13:45:00',1.96),('15529','2014-01-29','13:50:00',1.81),('15529','2014-01-29','13:55:00',1.6),('15529','2014-01-29','14:00:00',1.6),('15529','2014-01-29','14:05:00',1.41),('15529','2014-01-29','14:10:00',1.54),('15529','2014-01-29','14:15:00',1.29),('15529','2014-01-29','14:20:00',1.22),('15529','2014-01-29','14:25:00',1.31),('15529','2014-01-29','14:30:00',1.23),('15529','2014-01-29','14:35:00',1.24),('15529','2014-01-29','14:40:00',1.38),('15529','2014-01-29','14:45:00',1.43),('15529','2014-01-29','14:50:00',1.51),('15529','2014-01-29','14:55:00',1.45),('15529','2014-01-29','15:00:00',1.38),('15529','2014-01-29','15:05:00',1.34),('15529','2014-01-29','15:10:00',1.29),('15529','2014-01-29','15:15:00',1.26),('15529','2014-01-29','15:20:00',1.28),('15529','2014-01-29','15:25:00',1.2),('15529','2014-01-29','15:30:00',1.11),('15529','2014-01-29','15:35:00',1.09),('15529','2014-01-28','09:20:00',1.11),('15529','2014-01-28','09:35:00',1.06),('15529','2014-01-28','10:10:00',1.61),('15529','2014-01-28','10:15:00',1.37),('15529','2014-01-28','10:20:00',1.28),('15529','2014-01-28','10:25:00',2.21),('15529','2014-01-28','10:30:00',2.1),('15529','2014-01-28','10:35:00',1.45),('15529','2014-01-28','10:40:00',1.45),('15529','2014-01-28','10:45:00',1.18),('15529','2014-01-28','10:50:00',1.16),('15529','2014-01-28','10:55:00',1.04),('15529','2014-01-28','11:00:00',1.31),('15529','2014-01-28','11:05:00',1.35),('15529','2014-01-28','11:10:00',1.14),('15529','2014-01-28','11:15:00',1.18),('15529','2014-01-28','11:20:00',1.38),('15529','2014-01-28','11:25:00',1.45),('15529','2014-01-28','11:30:00',1.28),('15529','2014-01-28','12:45:00',1.49),('15529','2014-01-28','12:50:00',1.95),('15529','2014-01-28','12:55:00',1.84),('15529','2014-01-28','13:00:00',1.12),('15529','2014-01-28','13:30:00',1.23),('15529','2014-01-28','13:35:00',1.36),('15529','2014-01-28','13:40:00',2.19),('15529','2014-01-28','13:45:00',1.97),('15529','2014-01-28','13:50:00',1.83),('15529','2014-01-28','13:55:00',1.31),('15529','2014-01-28','15:15:00',1.11),('15529','2014-01-27','09:35:00',1),('15529','2014-01-27','09:45:00',1.24),('15529','2014-01-27','09:50:00',1.38),('15529','2014-01-27','09:55:00',1.42),('15529','2014-01-27','10:00:00',1.31),('15529','2014-01-27','10:05:00',1.34),('15529','2014-01-27','10:10:00',1.5),('15529','2014-01-27','10:15:00',1.64),('15529','2014-01-27','10:20:00',1.71),('15529','2014-01-27','10:25:00',1.72),('15529','2014-01-27','10:30:00',1.76),('15529','2014-01-27','10:35:00',1.79),('15529','2014-01-27','10:40:00',1.81),('15529','2014-01-27','10:45:00',1.83),('15529','2014-01-27','10:50:00',1.74),('15529','2014-01-27','10:55:00',2.05),('15529','2014-01-27','11:00:00',1.39),('15529','2014-01-27','11:05:00',1.84),('15529','2014-01-27','11:10:00',1.2),('15529','2014-01-27','11:15:00',1.1),('15529','2014-01-27','11:20:00',1.25),('15529','2014-01-27','11:30:00',2.15),('15529','2014-01-27','11:35:00',2.12),('15529','2014-01-27','11:40:00',1.24),('15529','2014-01-27','11:45:00',1.21),('15529','2014-01-27','11:50:00',1.65),('15529','2014-01-27','11:55:00',1.73),('15529','2014-01-27','12:00:00',1.49),('15529','2014-01-27','12:05:00',1.2),('15529','2014-01-27','12:10:00',1.52),('15529','2014-01-27','12:15:00',1.33),('15529','2014-01-27','12:35:00',1.03),('15529','2014-01-27','12:40:00',1.02),('15529','2014-01-27','12:45:00',2.1),('15529','2014-01-27','12:50:00',1.21),('15529','2014-01-27','12:55:00',2.28),('15529','2014-01-27','13:00:00',2.33),('15529','2014-01-27','13:05:00',1.72),('15529','2014-01-27','13:10:00',1.69),('15529','2014-01-27','13:15:00',2.02),('15529','2014-01-27','13:20:00',2.12),('15529','2014-01-27','13:25:00',1.87),('15529','2014-01-27','13:30:00',2.05),('15529','2014-01-27','13:35:00',2.04),('15529','2014-01-27','13:40:00',1.98),('15529','2014-01-27','13:45:00',1.93),('15529','2014-01-27','13:50:00',1.9),('15529','2014-01-27','13:55:00',1.86),('15529','2014-01-27','14:00:00',1.83),('15529','2014-01-27','14:05:00',1.82),('15529','2014-01-27','14:10:00',1.8),('15529','2014-01-27','14:15:00',1.79),('15529','2014-01-27','14:20:00',1.75),('15529','2014-01-27','14:25:00',1.61),('15529','2014-01-27','14:30:00',1.66),('15529','2014-01-27','14:35:00',1.62),('15529','2014-01-27','14:40:00',1.58),('15529','2014-01-27','14:45:00',1.56),('15529','2014-01-27','14:50:00',1.53),('15529','2014-01-27','14:55:00',1.48),('15529','2014-01-27','15:00:00',1.42),('15529','2014-01-27','15:05:00',1.38),('15529','2014-01-27','15:10:00',1.29),('15529','2014-01-27','15:15:00',1.28),('15529','2014-01-27','15:20:00',1.24),('15529','2014-01-27','15:25:00',1.19),('15529','2014-01-27','15:30:00',1.13),('15529','2014-01-27','15:35:00',1.08),('15529','2014-01-27','15:40:00',1.03),('15844','2014-05-05','08:20:00',1.02),('15844','2014-05-05','08:25:00',1.14),('15844','2014-05-05','08:30:00',1.24),('15844','2014-05-05','08:35:00',1.33),('15844','2014-05-05','08:40:00',1.43),('15844','2014-05-05','08:45:00',1.53),('15844','2014-05-05','08:50:00',1.6),('15844','2014-05-05','08:55:00',1.66),('15844','2014-05-05','09:00:00',1.72),('15844','2014-05-05','09:05:00',1.81),('15844','2014-05-05','09:10:00',1.95),('15844','2014-05-05','09:15:00',2.09),('15844','2014-05-05','09:20:00',2.2),('15844','2014-05-05','09:25:00',2.3),('15844','2014-05-05','09:30:00',2.41),('15844','2014-05-05','09:35:00',2.41),('15844','2014-05-05','09:40:00',2.56),('15844','2014-05-05','09:45:00',2.62),('15844','2014-05-05','09:50:00',2.79),('15844','2014-05-05','09:55:00',2.91),('15844','2014-05-05','10:00:00',2.96),('15844','2014-05-05','10:05:00',3.12),('15844','2014-05-05','10:10:00',3.27),('15844','2014-05-05','10:15:00',3.4),('15844','2014-05-05','10:20:00',3.5),('15844','2014-05-05','10:25:00',3.56),('15844','2014-05-05','10:30:00',3.51),('15844','2014-05-05','10:35:00',3.95),('15844','2014-05-05','10:40:00',3.6),('15844','2014-05-05','10:45:00',3.87),('15844','2014-05-05','10:50:00',4.12),('15844','2014-05-05','10:55:00',4.19),('15844','2014-05-05','11:00:00',4.24),('15844','2014-05-05','11:05:00',4.27),('15844','2014-05-05','11:10:00',3.98),('15844','2014-05-05','11:15:00',4.28),('15844','2014-05-05','11:20:00',4.43),('15844','2014-05-05','11:25:00',2.87),('15844','2014-05-05','11:30:00',2.73),('15844','2014-05-05','11:35:00',3.51),('15844','2014-05-05','11:40:00',4.49),('15844','2014-05-05','11:45:00',4.72),('15844','2014-05-05','11:50:00',3.56),('15844','2014-05-05','11:55:00',3.1),('15844','2014-05-05','12:00:00',2.58),('15844','2014-05-05','12:05:00',3.83),('15844','2014-05-05','12:10:00',4.19),('15844','2014-05-05','12:15:00',4.46),('15844','2014-05-05','12:20:00',3.47),('15844','2014-05-05','12:25:00',3.79),('15844','2014-05-05','12:30:00',2.62),('15844','2014-05-05','12:35:00',1.56),('15844','2014-05-05','12:40:00',2.64),('15844','2014-05-05','12:45:00',2.96),('15844','2014-05-05','12:50:00',4.41),('15844','2014-05-05','12:55:00',3.96),('15844','2014-05-05','13:00:00',4.41),('15844','2014-05-05','13:05:00',4.24),('15844','2014-05-05','13:10:00',4.19),('15844','2014-05-05','13:15:00',4.2),('15844','2014-05-05','13:20:00',4.22),('15844','2014-05-05','13:25:00',4.21),('15844','2014-05-05','13:30:00',4.28),('15844','2014-05-05','13:35:00',3.33),('15844','2014-05-05','13:50:00',1.11),('15844','2014-05-05','13:55:00',1.78),('15844','2014-05-05','14:00:00',3.05),('15844','2014-05-05','14:05:00',1.52),('15844','2014-05-05','14:10:00',2.58),('15844','2014-05-05','14:15:00',3.88),('15844','2014-05-05','14:20:00',3.54),('15844','2014-05-05','14:25:00',3.54),('15844','2014-05-05','14:30:00',3.43),('15844','2014-05-05','14:35:00',3.39),('15844','2014-05-05','14:40:00',3.4),('15844','2014-05-05','14:45:00',3.37),('15844','2014-05-05','14:50:00',3.26),('15844','2014-05-05','14:55:00',3.09),('15844','2014-05-05','15:00:00',2.86),('15844','2014-05-05','15:05:00',2.64),('15844','2014-05-05','15:10:00',2.55),('15844','2014-05-05','15:15:00',2.5),('15844','2014-05-05','15:20:00',2.41),('15844','2014-05-05','15:25:00',2.33),('15844','2014-05-05','15:30:00',1.94),('15844','2014-05-05','15:35:00',2.03),('15844','2014-05-05','15:40:00',2.05),('15844','2014-05-05','15:45:00',2.03),('15844','2014-05-05','15:50:00',1.84),('15844','2014-05-05','15:55:00',1.81),('15844','2014-05-05','16:00:00',1.73),('15844','2014-05-05','16:05:00',1.68),('15844','2014-05-05','16:10:00',1.67),('15844','2014-05-05','16:15:00',1.56),('15844','2014-05-05','16:20:00',1.44),('15844','2014-05-05','16:25:00',1.29),('15844','2014-05-05','16:30:00',1.18),('15844','2014-05-05','16:35:00',1.06),('15844','2014-04-26','09:10:00',1.05),('15844','2014-04-26','10:00:00',1.23),('15844','2014-04-26','10:05:00',1.56),('15844','2014-04-26','10:10:00',1.36),('15844','2014-04-26','10:15:00',1.2),('15844','2014-04-26','10:20:00',1.36),('15844','2014-04-26','10:25:00',1.52),('15844','2014-04-26','10:30:00',1.43),('15844','2014-04-26','10:35:00',1.91),('15844','2014-04-26','10:40:00',1.59),('15844','2014-04-26','10:45:00',1.47),('15844','2014-04-26','10:50:00',2),('15844','2014-04-26','10:55:00',3.43),('15844','2014-04-26','11:00:00',3.18),('15844','2014-04-26','11:05:00',3.83),('15844','2014-04-26','11:10:00',4.09),('15844','2014-04-26','11:15:00',3.62),('15844','2014-04-26','11:20:00',3.74),('15844','2014-04-26','11:25:00',3.67),('15844','2014-04-26','11:30:00',2.8),('15844','2014-04-26','11:35:00',3.05),('15844','2014-04-26','11:40:00',3.14),('15844','2014-04-26','11:45:00',3.37),('15844','2014-04-26','11:50:00',3.06),('15844','2014-04-26','11:55:00',3.29),('15844','2014-04-26','12:00:00',3.19),('15844','2014-04-26','12:05:00',2.28),('15844','2014-04-26','12:10:00',2.3),('15844','2014-04-26','12:15:00',2.9),('15844','2014-04-26','12:20:00',2.28),('15844','2014-04-26','12:25:00',2.2),('15844','2014-04-26','12:30:00',2.45),('15844','2014-04-26','12:35:00',2.33),('15844','2014-04-26','12:40:00',1.28),('15844','2014-04-26','12:45:00',1.75),('15844','2014-04-26','12:50:00',1.87),('15844','2014-04-26','12:55:00',3.23),('15844','2014-04-26','13:00:00',3.76),('15844','2014-04-26','13:05:00',2.49),('15844','2014-04-26','13:10:00',3.44),('15844','2014-04-26','13:15:00',4.46),('15844','2014-04-26','13:20:00',3.77),('15844','2014-04-26','13:25:00',2.19),('15844','2014-04-26','13:30:00',1.57),('15844','2014-04-26','13:35:00',1.75),('15844','2014-04-26','13:40:00',2.08),('15844','2014-04-26','13:45:00',1.92),('15844','2014-04-26','13:50:00',1.29),('15844','2014-04-26','13:55:00',1.02),('15844','2014-04-26','14:00:00',1.09),('15844','2014-04-26','14:05:00',2.21),('15844','2014-01-26','09:05:00',1.17),('15844','2014-01-26','09:25:00',1.19),('15844','2014-01-26','09:30:00',1.12),('15844','2014-01-26','09:50:00',1.09),('15844','2014-01-26','10:10:00',1.26),('15844','2014-01-26','10:15:00',1.28),('15844','2014-01-26','11:25:00',1.22),('15844','2014-01-26','12:15:00',1.06),('15844','2014-01-26','12:20:00',1.13),('15844','2014-01-26','12:25:00',1.8),('15844','2014-01-26','12:30:00',1.42),('15844','2014-01-26','13:05:00',1.02),('15844','2014-01-26','13:15:00',1.06),('15844','2014-01-26','13:20:00',1.03),('15844','2014-01-25','09:55:00',1.54),('15844','2014-01-25','10:00:00',1.73),('15844','2014-01-25','10:05:00',2.06),('15844','2014-01-25','10:10:00',2.42),('15844','2014-01-25','10:15:00',2.34),('15844','2014-01-25','10:20:00',2.06),('15844','2014-01-25','10:25:00',1.97),('15844','2014-01-25','10:30:00',1.92),('15844','2014-01-25','10:35:00',2.14),('15844','2014-01-25','10:40:00',1.44),('15844','2014-01-25','10:45:00',1.65),('15844','2014-01-25','10:50:00',2.51),('15844','2014-01-25','10:55:00',2.68),('15844','2014-01-25','11:00:00',2.35),('15844','2014-01-25','11:05:00',2.21),('15844','2014-01-25','11:10:00',2.35),('15844','2014-01-25','11:15:00',2.65),('15844','2014-01-25','11:20:00',1.76),('15844','2014-01-25','11:25:00',1.17),('15844','2014-01-25','11:30:00',1.17),('15844','2014-01-25','11:35:00',1.34),('15844','2014-01-25','11:40:00',1.81),('15844','2014-01-25','11:45:00',1.48),('15844','2014-01-25','11:50:00',1.31),('15844','2014-01-25','11:55:00',1.21),('15844','2014-01-25','12:00:00',1.38),('15844','2014-01-25','12:05:00',1.43),('15844','2014-01-25','12:10:00',1.56),('15844','2014-01-25','12:15:00',1.48),('15844','2014-01-25','12:20:00',1.48),('15844','2014-01-25','12:25:00',1.39),('15844','2014-01-25','12:30:00',1.25),('15844','2014-01-25','12:35:00',1.31),('15844','2014-01-25','12:40:00',1.41),('15844','2014-01-25','12:45:00',1.45),('15844','2014-01-25','12:50:00',1.67),('15844','2014-01-25','12:55:00',1.76),('15844','2014-01-25','13:00:00',1.68),('15844','2014-01-25','13:05:00',1.7),('15844','2014-01-25','13:10:00',1.68),('15844','2014-01-25','13:15:00',1.5),('15844','2014-01-25','13:20:00',1.62),('15844','2014-01-25','13:25:00',1.56),('15844','2014-01-25','13:30:00',1.44),('15844','2014-01-25','13:35:00',1.2),('15844','2014-01-25','13:40:00',1.26),('15844','2014-01-25','13:50:00',1.02),('15844','2014-01-24','10:10:00',1.5),('15844','2014-01-24','10:20:00',1.83),('15844','2014-01-24','10:25:00',1.68),('15844','2014-01-24','10:30:00',2.09),('15844','2014-01-24','10:35:00',2.79),('15844','2014-01-24','10:40:00',2.53),('15844','2014-01-24','10:45:00',1.16),('15844','2014-01-24','10:50:00',1.4),('15844','2014-01-24','10:55:00',1.04),('15844','2014-01-24','11:25:00',1.04),('15844','2014-01-24','11:30:00',1.3),('15844','2014-01-24','11:40:00',2.07),('15844','2014-01-24','11:45:00',2.3),('15844','2014-01-24','11:50:00',2.66),('15844','2014-01-24','11:55:00',1.91),('15844','2014-01-24','12:00:00',2.65),('15844','2014-01-24','12:05:00',2.1),('15844','2014-01-24','12:10:00',1.39),('15844','2014-01-24','12:15:00',1.21),('15844','2014-01-24','12:20:00',1.25),('15844','2014-01-24','12:25:00',1.3),('15844','2014-01-24','12:30:00',1.21),('15844','2014-01-24','12:35:00',1.46),('15844','2014-01-24','12:40:00',2.04),('15844','2014-01-24','12:45:00',1.18),('15844','2014-01-24','12:50:00',1.58),('15844','2014-01-24','12:55:00',1.23),('15844','2014-01-24','13:00:00',1.21),('15844','2014-01-24','13:15:00',1.21),('15844','2014-01-24','13:40:00',1.44),('15844','2014-01-24','14:05:00',1.24),('15844','2014-01-23','12:25:00',1.06),('15844','2014-01-23','12:30:00',1.15),('15844','2014-01-23','12:35:00',1.03),('15844','2014-01-21','09:55:00',1.37),('15844','2014-01-21','10:55:00',1.03),('15844','2014-01-21','11:40:00',1.25),('15844','2014-01-21','11:45:00',1.15),('15844','2014-01-21','11:55:00',1.03),('15844','2014-01-21','12:00:00',1.48),('15844','2014-01-21','12:05:00',1.26),('15844','2014-01-21','12:10:00',1.41),('15844','2014-01-21','12:15:00',1.63),('15844','2014-01-21','12:20:00',1.49),('15844','2014-01-21','12:25:00',1.53),('15844','2014-01-21','12:30:00',1.36),('15844','2014-01-20','11:20:00',1.2),('15844','2014-01-20','11:25:00',1.61),('15844','2014-01-20','11:30:00',1.7),('15844','2014-01-20','11:35:00',1.61),('15844','2014-01-20','11:55:00',1.13),('15844','2014-01-20','12:00:00',1.48),('15844','2014-01-20','12:05:00',1.57),('15844','2014-01-20','12:10:00',1.41),('15844','2014-01-20','12:15:00',1.04),('15844','2014-01-20','12:30:00',1.4),('15844','2014-01-20','12:35:00',1.21),('15844','2014-01-20','12:40:00',1.4),('15844','2014-01-20','12:45:00',1.29),('15844','2014-01-20','12:55:00',1.89),('15844','2014-01-20','14:10:00',1.09),('15844','2014-01-19','14:20:00',1.06),('15844','2014-01-19','14:30:00',1.01),('15844','2014-01-18','09:55:00',1.07),('15844','2014-01-18','10:00:00',1.65),('15844','2014-01-18','10:05:00',1.22),('15844','2014-01-18','10:10:00',1.85),('15844','2014-01-18','10:15:00',2.22),('15844','2014-01-18','10:20:00',1.77),('15844','2014-01-18','10:25:00',1.78),('15844','2014-01-18','10:30:00',1.61),('15844','2014-01-18','10:35:00',1.21),('15844','2014-01-18','10:40:00',1.3),('15844','2014-01-18','10:45:00',1.08),('15844','2014-01-18','10:50:00',1),('15844','2014-01-18','11:00:00',1.03),('15844','2014-01-18','11:05:00',2.15),('15844','2014-01-18','11:10:00',2.31),('15844','2014-01-18','11:15:00',2.33),('15844','2014-01-18','11:20:00',2.2),('15844','2014-01-18','11:25:00',2.16),('15844','2014-01-18','11:30:00',2.14),('15844','2014-01-18','11:35:00',2.19),('15844','2014-01-18','11:40:00',2.02),('15844','2014-01-18','11:45:00',2.03),('15844','2014-01-18','11:50:00',1.25),('15844','2014-01-18','11:55:00',2.33),('15844','2014-01-18','12:00:00',2),('15844','2014-01-18','12:05:00',1.56),('15844','2014-01-18','12:10:00',2.02),('15844','2014-01-18','12:15:00',2.01),('15844','2014-01-18','12:20:00',1.99),('15844','2014-01-18','12:25:00',1.96),('15844','2014-01-18','12:30:00',1.93),('15844','2014-01-18','12:35:00',1.89),('15844','2014-01-18','12:40:00',1.89),('15844','2014-01-18','12:45:00',1.79),('15844','2014-01-18','12:50:00',1.49),('15844','2014-01-18','12:55:00',1.48),('15844','2014-01-18','13:00:00',1.53),('15844','2014-01-18','13:05:00',1.12),('15844','2014-01-18','13:10:00',1.44),('15844','2014-01-18','13:15:00',1.72),('15844','2014-01-18','13:20:00',1.39),('15844','2014-01-18','13:30:00',1.28),('15844','2014-01-18','13:35:00',1.33),('15844','2014-01-18','13:40:00',1.13),('15844','2014-01-18','13:45:00',1.19),('15844','2014-01-18','13:50:00',1.06),('15844','2014-01-18','14:00:00',1),('15844','2014-01-17','09:10:00',1.04),('15844','2014-01-17','09:20:00',1.15),('15844','2014-01-17','09:30:00',1.27),('15844','2014-04-25','08:35:00',1),('15844','2014-04-25','08:40:00',1.05),('15844','2014-04-25','08:45:00',1.22),('15844','2014-04-25','08:50:00',1.33),('15844','2014-04-25','08:55:00',1.09),('15844','2014-04-25','09:00:00',1.29),('15844','2014-04-25','09:05:00',1.25),('15844','2014-04-25','09:10:00',1.39),('15844','2014-04-25','09:15:00',1.11),('15844','2014-04-25','09:20:00',1.08),('15844','2014-04-25','09:25:00',2.05),('15844','2014-04-25','09:30:00',1.4),('15844','2014-04-25','09:35:00',1.29),('15844','2014-04-25','09:40:00',1.27),('15844','2014-04-25','09:45:00',1.18),('15844','2014-04-25','09:50:00',1.15),('15844','2014-04-25','09:55:00',1.68),('15844','2014-04-25','10:00:00',1.29),('15844','2014-04-25','10:05:00',1.27),('15844','2014-04-25','10:10:00',1.22),('15844','2014-04-25','10:15:00',1.17),('15844','2014-04-25','10:40:00',2.09),('15844','2014-04-25','10:45:00',2.35),('15844','2014-04-25','11:00:00',1.89),('15844','2014-04-25','11:05:00',2.63),('15844','2014-04-25','11:10:00',2.74),('15844','2014-04-25','11:15:00',1.84),('15844','2014-04-25','11:20:00',3.56),('15844','2014-04-25','11:25:00',4.68),('15844','2014-04-25','11:30:00',1.56),('15844','2014-04-25','11:35:00',1.09),('15844','2014-04-25','11:45:00',1.37),('15844','2014-04-25','11:50:00',1.79),('15844','2014-04-25','11:55:00',4.38),('15844','2014-04-25','12:00:00',4.52),('15844','2014-04-25','12:05:00',4.36),('15844','2014-04-25','12:10:00',4.37),('15844','2014-04-25','12:15:00',3.29),('15844','2014-04-25','12:20:00',4.02),('15844','2014-04-25','12:25:00',1.91),('15844','2014-04-25','12:30:00',3.02),('15844','2014-04-25','12:35:00',3.31),('15844','2014-04-25','12:40:00',4.15),('15844','2014-04-25','12:45:00',2.03),('15844','2014-04-25','12:50:00',2.18),('15844','2014-04-25','12:55:00',1.42),('15844','2014-04-25','13:00:00',2.86),('15844','2014-04-25','13:05:00',1.4),('15844','2014-04-25','13:10:00',1.33),('15844','2014-04-25','13:15:00',1.82),('15844','2014-04-25','13:20:00',3.65),('15844','2014-04-25','13:25:00',2.11),('15844','2014-04-25','13:30:00',3.59),('15844','2014-04-25','13:35:00',4.34),('15844','2014-04-25','13:40:00',4.23),('15844','2014-04-25','13:45:00',2.82),('15844','2014-04-25','13:50:00',2.78),('15844','2014-04-25','13:55:00',4.03),('15844','2014-04-25','14:00:00',3.85),('15844','2014-04-25','14:05:00',3.51),('15844','2014-04-25','14:10:00',3.43),('15844','2014-04-25','14:15:00',3.32),('15844','2014-04-25','14:20:00',3.25),('15844','2014-04-25','14:25:00',3.19),('15844','2014-04-25','14:30:00',3.07),('15844','2014-04-25','14:35:00',2.95),('15844','2014-04-25','14:40:00',2.87),('15844','2014-04-25','14:45:00',2.8),('15844','2014-04-25','14:50:00',2.71),('15844','2014-04-25','14:55:00',2.61),('15844','2014-04-25','15:00:00',2.48),('15844','2014-04-25','15:05:00',2.39),('15844','2014-04-25','15:10:00',2.34),('15844','2014-04-25','15:15:00',2.25),('15844','2014-04-25','15:20:00',2.16),('15844','2014-04-25','15:25:00',2.1),('15844','2014-04-25','15:30:00',2.01),('15844','2014-04-25','15:35:00',1.88),('15844','2014-04-25','15:40:00',1.73),('15844','2014-04-25','15:45:00',1.6),('15844','2014-04-25','15:50:00',1.54),('15844','2014-04-25','15:55:00',1.45),('15844','2014-04-25','16:00:00',1.32),('15844','2014-04-25','16:05:00',1.27),('15844','2014-04-25','16:10:00',1.14),('15844','2014-04-25','16:15:00',1.05),('15844','2014-04-25','16:20:00',1.02),('15844','2014-04-25','16:25:00',1.02),('15844','2014-01-16','09:15:00',1.18),('15844','2014-01-16','09:20:00',1.39),('15844','2014-01-16','09:25:00',1.46),('15844','2014-01-16','09:30:00',1.47),('15844','2014-01-16','09:35:00',1.54),('15844','2014-01-16','09:40:00',1.48),('15844','2014-01-16','09:45:00',1.16),('15844','2014-01-16','10:10:00',1.07),('15844','2014-01-16','10:15:00',1.14),('15844','2014-01-16','10:20:00',1.27),('15844','2014-01-16','10:25:00',1.71),('15844','2014-01-16','10:30:00',2.21),('15844','2014-01-16','10:35:00',2.03),('15844','2014-01-16','10:40:00',1.37),('15844','2014-01-16','10:45:00',1.58),('15844','2014-01-16','10:50:00',1.69),('15844','2014-01-16','10:55:00',1.64),('15844','2014-01-16','11:00:00',1.71),('15844','2014-01-16','11:05:00',1.79),('15844','2014-01-16','11:10:00',1.66),('15844','2014-01-16','11:15:00',1.46),('15844','2014-01-16','11:20:00',1.49),('15844','2014-01-16','11:25:00',1.47),('15844','2014-01-16','11:30:00',1.42),('15844','2014-01-16','11:35:00',1.46),('15844','2014-01-16','11:40:00',1.39),('15844','2014-01-16','11:45:00',1.39),('15844','2014-01-16','11:50:00',1.56),('15844','2014-01-16','11:55:00',1.54),('15844','2014-01-16','12:00:00',1.43),('15844','2014-01-16','12:05:00',1.43),('15844','2014-01-16','12:10:00',1.28),('15844','2014-01-16','12:15:00',1.2),('15844','2014-01-16','12:20:00',1.12),('15844','2014-01-16','12:25:00',1.14),('15844','2014-01-16','12:30:00',1.32),('15844','2014-01-16','12:35:00',1.43),('15844','2014-01-16','12:40:00',1.39),('15844','2014-01-16','12:45:00',1.44),('15844','2014-01-16','12:50:00',1.49),('15844','2014-01-16','12:55:00',1.53),('15844','2014-01-16','13:00:00',1.57),('15844','2014-01-16','13:05:00',1.55),('15844','2014-01-16','13:10:00',1.49),('15844','2014-01-16','13:15:00',1.42),('15844','2014-01-16','13:20:00',1.39),('15844','2014-01-16','13:25:00',1.29),('15844','2014-01-16','13:40:00',1.07),('15844','2014-01-16','13:45:00',1.03),('15844','2014-01-16','13:50:00',1.04),('15844','2014-01-15','10:00:00',1.06),('15844','2014-01-15','10:05:00',1.27),('15844','2014-01-15','10:10:00',1.51),('15844','2014-01-15','10:15:00',1.79),('15844','2014-01-15','10:20:00',1.71),('15844','2014-01-15','10:25:00',1.17),('15844','2014-01-15','10:30:00',1.96),('15844','2014-01-15','10:35:00',1.69),('15844','2014-01-15','10:40:00',1.68),('15844','2014-01-15','10:45:00',2.1),('15844','2014-01-15','10:50:00',1.74),('15844','2014-01-15','10:55:00',1.96),('15844','2014-01-15','11:00:00',2.26),('15844','2014-01-15','11:05:00',2.23),('15844','2014-01-15','11:10:00',2.12),('15844','2014-01-15','11:15:00',2.31),('15844','2014-01-15','11:20:00',2.28),('15844','2014-01-15','11:25:00',2.36),('15844','2014-01-15','11:30:00',1.5),('15844','2014-01-15','11:35:00',1.68),('15844','2014-01-15','11:40:00',1.24),('15844','2014-01-15','11:45:00',1.28),('15844','2014-01-15','11:50:00',1.22),('15844','2014-01-15','11:55:00',1.19),('15844','2014-01-15','12:00:00',1.23),('15844','2014-01-15','12:05:00',1.29),('15844','2014-01-15','12:10:00',1.23),('15844','2014-01-15','12:15:00',1.27),('15844','2014-01-15','12:20:00',1.11),('15844','2014-01-15','12:25:00',1.15),('15844','2014-01-15','12:30:00',1.18),('15844','2014-01-15','12:35:00',1.61),('15844','2014-01-15','12:40:00',1.64),('15844','2014-01-15','12:45:00',1.46),('15844','2014-01-15','12:50:00',1.67),('15844','2014-01-15','12:55:00',1.67),('15844','2014-01-15','13:00:00',1.77),('15844','2014-01-15','13:05:00',1.75),('15844','2014-01-15','13:10:00',1.67),('15844','2014-01-15','13:15:00',1.57),('15844','2014-01-15','13:20:00',1.46),('15844','2014-01-15','13:25:00',1.33),('15844','2014-01-15','13:30:00',1.24),('15844','2014-01-15','13:35:00',1.21),('15844','2014-01-15','13:40:00',1.13),('15844','2014-01-15','13:45:00',1.14),('15844','2014-01-15','13:50:00',1.13),('15844','2014-01-15','14:05:00',1.05),('15844','2014-01-15','14:10:00',1.06),('15844','2014-01-14','10:25:00',1.2),('15844','2014-01-14','10:30:00',1.95),('15844','2014-01-14','10:35:00',1.6),('15844','2014-01-13','09:05:00',1.07),('15844','2014-01-13','09:10:00',1.12),('15844','2014-01-13','09:15:00',1.13),('15844','2014-01-13','09:20:00',1.15),('15844','2014-01-13','09:25:00',1.22),('15844','2014-01-13','09:30:00',1.27),('15844','2014-01-13','09:35:00',1.3),('15844','2014-01-13','09:40:00',1.33),('15844','2014-01-13','09:45:00',1.38),('15844','2014-01-13','09:50:00',1.42),('15844','2014-01-13','09:55:00',1.46),('15844','2014-01-13','10:00:00',1.49),('15844','2014-01-13','10:05:00',1.53),('15844','2014-01-13','10:10:00',1.56),('15844','2014-01-13','10:15:00',1.59),('15844','2014-01-13','10:20:00',1.64),('15844','2014-01-13','10:25:00',1.66),('15844','2014-01-13','10:30:00',1.7),('15844','2014-01-13','10:35:00',1.73),('15844','2014-01-13','10:40:00',1.76),('15844','2014-01-13','10:45:00',1.77),('15844','2014-01-13','10:50:00',1.8),('15844','2014-01-13','10:55:00',1.82),('15844','2014-01-13','11:00:00',1.85),('15844','2014-01-13','11:05:00',1.89),('15844','2014-01-13','11:10:00',1.91),('15844','2014-01-13','11:15:00',1.92),('15844','2014-01-13','11:20:00',1.89),('15844','2014-01-13','11:25:00',1.87),('15844','2014-01-13','11:30:00',1.89),('15844','2014-01-13','11:35:00',1.89),('15844','2014-01-13','11:40:00',1.88),('15844','2014-01-13','11:45:00',1.88),('15844','2014-01-13','11:50:00',1.83),('15844','2014-01-13','11:55:00',1.76),('15844','2014-01-13','12:00:00',1.78),('15844','2014-01-13','12:05:00',1.74),('15844','2014-01-13','12:10:00',1.77),('15844','2014-01-13','12:15:00',1.7),('15844','2014-01-13','12:20:00',1.69),('15844','2014-01-13','12:25:00',1.67),('15844','2014-01-13','12:30:00',1.64),('15844','2014-01-13','12:35:00',1.6),('15844','2014-01-13','12:40:00',1.54),('15844','2014-01-13','12:45:00',1.45),('15844','2014-01-13','12:50:00',1.43),('15844','2014-01-13','12:55:00',1.21),('15844','2014-01-13','13:00:00',1.25),('15844','2014-01-13','13:05:00',1.29),('15844','2014-01-13','13:10:00',1.28),('15844','2014-01-13','13:15:00',1.23),('15844','2014-01-13','13:20:00',1.17),('15844','2014-01-13','13:25:00',1.12),('15844','2014-01-13','13:30:00',1.1),('15844','2014-01-13','13:35:00',1.04),('15844','2014-01-12','10:35:00',1.03),('15844','2014-01-12','10:40:00',1.1),('15844','2014-01-12','10:45:00',1.06),('15844','2014-01-12','10:50:00',1.22),('15844','2014-01-12','10:55:00',1.31),('15844','2014-01-12','11:00:00',1.18),('15844','2014-01-12','11:05:00',1.6),('15844','2014-01-12','11:10:00',1.81),('15844','2014-01-12','11:15:00',1.48),('15844','2014-01-12','11:20:00',1.32),('15844','2014-01-12','11:25:00',1.33),('15844','2014-01-12','11:30:00',1.17),('15844','2014-01-12','11:35:00',1.16),('15844','2014-01-12','11:40:00',1.26),('15844','2014-01-12','11:45:00',1.42),('15844','2014-01-12','11:50:00',1.19),('15844','2014-01-12','11:55:00',1.25),('15844','2014-01-12','12:00:00',1.33),('15844','2014-01-12','12:05:00',1.08),('15844','2014-01-12','12:10:00',1.02),('15844','2014-01-11','09:50:00',1.01),('15844','2014-01-11','09:55:00',1.32),('15844','2014-01-11','10:00:00',1.05),('15844','2014-01-11','10:05:00',1.03),('15844','2014-01-11','10:10:00',1.18),('15844','2014-01-11','10:15:00',1.13),('15844','2014-01-11','10:20:00',1.4),('15844','2014-01-11','10:25:00',1.3),('15844','2014-01-11','10:30:00',1.41),('15844','2014-01-11','10:35:00',1.59),('15844','2014-01-11','10:40:00',1.82),('15844','2014-01-11','10:45:00',1.87),('15844','2014-01-11','10:50:00',1.86),('15844','2014-01-11','10:55:00',1.78),('15844','2014-01-11','11:00:00',1.67),('15844','2014-01-11','11:05:00',1.69),('15844','2014-01-11','11:10:00',1.72),('15844','2014-01-11','11:15:00',1.5),('15844','2014-01-11','11:20:00',1.35),('15844','2014-01-11','11:25:00',1.29),('15844','2014-01-11','11:30:00',1.38),('15844','2014-01-11','11:35:00',1.26),('15844','2014-01-11','11:40:00',1.3),('15844','2014-01-11','11:45:00',1.38),('15844','2014-01-11','11:50:00',1.43),('15844','2014-01-11','11:55:00',1.38),('15844','2014-01-11','12:00:00',1.41),('15844','2014-01-11','12:05:00',1.31),('15844','2014-01-11','12:10:00',1.43),('15844','2014-01-11','12:15:00',1.47),('15844','2014-01-11','12:20:00',1.09),('15844','2014-01-11','12:30:00',1.21),('15844','2014-01-11','12:35:00',1.09),('15844','2014-01-11','12:45:00',1.1),('15844','2014-01-11','12:50:00',1.32),('15844','2014-01-11','12:55:00',1.37),('15844','2014-01-11','13:00:00',1.33),('15844','2014-01-11','13:05:00',1.12),('15844','2014-01-11','13:15:00',1.18),('15844','2014-01-09','09:50:00',1.15),('15844','2014-01-09','10:35:00',1.03),('15844','2014-01-09','10:40:00',1.09),('15844','2014-01-09','10:45:00',1),('15844','2014-01-09','12:00:00',1.13),('15844','2014-01-09','12:05:00',1.08),('15844','2014-01-09','12:10:00',1.08),('15844','2014-01-09','12:15:00',1.29),('15844','2014-01-09','12:25:00',1.05),('15844','2014-01-09','12:30:00',1.23),('15844','2014-01-09','12:35:00',1.45),('15844','2014-01-09','12:40:00',1.4),('15844','2014-01-09','12:45:00',1.25),('15844','2014-01-09','12:50:00',1.18),('15844','2014-01-09','12:55:00',1.07),('15844','2014-01-09','13:00:00',1.27),('15844','2014-01-09','13:05:00',1.14),('15844','2014-01-09','13:10:00',1.06),('15844','2014-01-08','09:15:00',1.04),('15844','2014-01-08','09:20:00',1.14),('15844','2014-01-08','09:25:00',1.2),('15844','2014-01-08','09:30:00',1.16),('15844','2014-01-08','09:35:00',1.25),('15844','2014-01-08','09:40:00',1.3),('15844','2014-01-08','09:45:00',1.34),('15844','2014-01-08','09:50:00',1.32),('15844','2014-01-08','09:55:00',1.36),('15844','2014-01-08','10:00:00',1.24),('15844','2014-01-08','10:05:00',1.38),('15844','2014-01-08','10:10:00',1.47),('15844','2014-01-08','10:15:00',1.58),('15844','2014-01-08','10:20:00',1.62),('15844','2014-01-08','10:25:00',1.65),('15844','2014-01-08','10:30:00',1.66),('15844','2014-01-08','10:35:00',1.64),('15844','2014-01-08','10:40:00',1.66),('15844','2014-01-08','10:45:00',1.75),('15844','2014-01-08','10:50:00',1.79),('15844','2014-01-08','10:55:00',1.79),('15844','2014-01-08','11:00:00',1.81),('15844','2014-01-08','11:05:00',1.85),('15844','2014-01-08','11:10:00',1.86),('15844','2014-01-08','11:15:00',1.85),('15844','2014-01-08','11:20:00',1.81),('15844','2014-01-08','11:25:00',1.75),('15844','2014-01-08','11:30:00',1.85),('15844','2014-01-08','11:35:00',1.88),('15844','2014-01-08','11:40:00',1.83),('15844','2014-01-08','11:45:00',1.82),('15844','2014-01-08','11:50:00',1.82),('15844','2014-01-08','11:55:00',1.75),('15844','2014-01-08','12:00:00',1.69),('15844','2014-01-08','12:05:00',1.66),('15844','2014-01-08','12:10:00',1.69),('15844','2014-01-08','12:15:00',1.66),('15844','2014-01-08','12:20:00',1.7),('15844','2014-01-08','12:25:00',1.66),('15844','2014-01-08','12:30:00',1.59),('15844','2014-01-08','12:35:00',1.55),('15844','2014-01-08','12:40:00',1.44),('15844','2014-01-08','12:45:00',1.41),('15844','2014-01-08','12:50:00',1.41),('15844','2014-01-08','12:55:00',1.38),('15844','2014-01-08','13:00:00',1.35),('15844','2014-01-08','13:05:00',1.24),('15844','2014-01-08','13:10:00',1.25),('15844','2014-01-08','13:15:00',1.17),('15844','2014-01-08','13:20:00',1.09),('15844','2014-01-08','13:25:00',1.09),('15844','2014-01-08','13:30:00',1.04),('15844','2014-01-07','09:10:00',1.06),('15844','2014-01-07','09:15:00',1.14),('15844','2014-01-07','09:20:00',1.22),('15844','2014-01-07','09:25:00',1.28),('15844','2014-01-07','09:30:00',1.34),('15844','2014-01-07','09:35:00',1.39),('15844','2014-01-07','09:40:00',1.42),('15844','2014-01-07','09:45:00',1.47),('15844','2014-01-07','09:50:00',1.51),('15844','2014-01-07','09:55:00',1.55),('15844','2014-01-07','10:00:00',1.58),('15844','2014-01-07','10:05:00',1.61),('15844','2014-01-07','10:10:00',1.65),('15844','2014-01-07','10:15:00',1.69),('15844','2014-01-07','10:20:00',1.7),('15844','2014-01-07','10:25:00',1.73),('15844','2014-01-07','10:30:00',1.73),('15844','2014-01-07','10:35:00',1.78),('15844','2014-01-07','10:40:00',1.83),('15844','2014-01-07','10:45:00',1.86),('15844','2014-01-07','10:50:00',1.89),('15844','2014-01-07','10:55:00',1.9),('15844','2014-01-07','11:00:00',1.91),('15844','2014-01-07','11:05:00',1.95),('15844','2014-01-07','11:10:00',1.96),('15844','2014-01-07','11:15:00',1.95),('15844','2014-01-07','11:20:00',1.94),('15844','2014-01-07','11:25:00',1.93),('15844','2014-01-07','11:30:00',1.93),('15844','2014-01-07','11:35:00',1.9),('15844','2014-01-07','11:40:00',1.86),('15844','2014-01-07','11:45:00',1.83),('15844','2014-01-07','11:50:00',1.83),('15844','2014-01-07','11:55:00',1.83),('15844','2014-01-07','12:00:00',1.79),('15844','2014-01-07','12:05:00',1.75),('15844','2014-01-07','12:10:00',1.75),('15844','2014-01-07','12:15:00',1.73),('15844','2014-01-07','12:20:00',1.65),('15844','2014-01-07','12:25:00',1.63),('15844','2014-01-07','12:30:00',1.59),('15844','2014-01-07','12:35:00',1.6),('15844','2014-01-07','12:40:00',1.57),('15844','2014-01-07','12:45:00',1.51),('15844','2014-01-07','12:50:00',1.51),('15844','2014-01-07','12:55:00',1.45),('15844','2014-01-07','13:00:00',1.41),('15844','2014-01-07','13:05:00',1.33),('15844','2014-01-07','13:10:00',1.29),('15844','2014-01-07','13:15:00',1.15),('15844','2014-01-07','13:20:00',1.09),('15844','2014-01-07','13:25:00',1.06),('15844','2014-04-24','08:30:00',1.1),('15844','2014-04-24','08:35:00',1.19),('15844','2014-04-24','08:40:00',1.26),('15844','2014-04-24','08:45:00',1.32),('15844','2014-04-24','08:50:00',1.41),('15844','2014-04-24','08:55:00',1.47),('15844','2014-04-24','09:00:00',1.55),('15844','2014-04-24','09:05:00',1.58),('15844','2014-04-24','09:10:00',1.69),('15844','2014-04-24','09:15:00',1.81),('15844','2014-04-24','09:20:00',1.97),('15844','2014-04-24','09:25:00',2.09),('15844','2014-04-24','09:30:00',2.19),('15844','2014-04-24','09:35:00',2.29),('15844','2014-04-24','09:40:00',2.33),('15844','2014-04-24','09:45:00',2.37),('15844','2014-04-24','09:50:00',2.44),('15844','2014-04-24','09:55:00',2.63),('15844','2014-04-24','10:00:00',2.73),('15844','2014-04-24','10:05:00',2.8),('15844','2014-04-24','10:10:00',2.89),('15844','2014-04-24','10:15:00',3.01),('15844','2014-04-24','10:20:00',3.05),('15844','2014-04-24','10:25:00',3.2),('15844','2014-04-24','10:30:00',3.33),('15844','2014-04-24','10:35:00',3.31),('15844','2014-04-24','10:40:00',3.29),('15844','2014-04-24','10:45:00',3.5),('15844','2014-04-24','10:50:00',3.63),('15844','2014-04-24','10:55:00',3.68),('15844','2014-04-24','11:00:00',3.07),('15844','2014-04-24','11:05:00',3.9),('15844','2014-04-24','11:10:00',3.96),('15844','2014-04-24','11:15:00',3.88),('15844','2014-04-24','11:20:00',3.94),('15844','2014-04-24','11:25:00',3.92),('15844','2014-04-24','11:30:00',4.07),('15844','2014-04-24','11:35:00',4.15),('15844','2014-04-24','11:40:00',4.07),('15844','2014-04-24','11:45:00',4),('15844','2014-04-24','11:50:00',3.99),('15844','2014-04-24','11:55:00',4.04),('15844','2014-04-24','12:00:00',3.97),('15844','2014-04-24','12:05:00',3.21),('15844','2014-04-24','12:10:00',3.61),('15844','2014-04-24','12:15:00',4.12),('15844','2014-04-24','12:20:00',2.77),('15844','2014-04-24','12:25:00',2.5),('15844','2014-04-24','12:30:00',1.96),('15844','2014-04-24','12:35:00',3.53),('15844','2014-04-24','12:40:00',4.16),('15844','2014-04-24','12:45:00',4.09),('15844','2014-04-24','12:50:00',3.48),('15844','2014-04-24','12:55:00',4.09),('15844','2014-04-24','13:00:00',2.5),('15844','2014-04-24','13:05:00',3.83),('15844','2014-04-24','13:10:00',4.17),('15844','2014-04-24','13:15:00',4.23),('15844','2014-04-24','13:20:00',4.18),('15844','2014-04-24','13:25:00',1.21),('15844','2014-04-24','13:30:00',2.65),('15844','2014-04-24','13:35:00',4.24),('15844','2014-04-24','13:40:00',4.1),('15844','2014-04-24','13:45:00',4.03),('15844','2014-04-24','13:50:00',3.82),('15844','2014-04-24','13:55:00',3.73),('15844','2014-04-24','14:00:00',3.64),('15844','2014-04-24','14:05:00',3.51),('15844','2014-04-24','14:10:00',3.46),('15844','2014-04-24','14:15:00',3.41),('15844','2014-04-24','14:20:00',3.4),('15844','2014-04-24','14:25:00',3.4),('15844','2014-04-24','14:30:00',3.4),('15844','2014-04-24','14:35:00',3.56),('15844','2014-04-24','14:40:00',3.43),('15844','2014-04-24','14:45:00',3.06),('15844','2014-04-24','14:50:00',2.83),('15844','2014-04-24','14:55:00',2.74),('15844','2014-04-24','15:00:00',2.67),('15844','2014-04-24','15:05:00',2.78),('15844','2014-04-24','15:10:00',2.46),('15844','2014-04-24','15:15:00',2.34),('15844','2014-04-24','15:20:00',3.11),('15844','2014-04-24','15:25:00',2.5),('15844','2014-04-24','15:30:00',2.21),('15844','2014-04-24','15:35:00',2.33),('15844','2014-04-24','15:40:00',1.54),('15844','2014-04-24','15:45:00',1.91),('15844','2014-04-24','15:50:00',2.33),('15844','2014-04-24','15:55:00',1.85),('15844','2014-04-24','16:00:00',1.48),('15844','2014-04-24','16:05:00',1.49),('15844','2014-04-24','16:10:00',1.48),('15844','2014-04-24','16:15:00',1.62),('15844','2014-04-24','16:20:00',1.98),('15844','2014-04-24','16:25:00',1.66),('15844','2014-04-24','16:30:00',1.55),('15844','2014-04-24','16:35:00',1.56),('15844','2014-04-24','16:40:00',1.45),('15844','2014-04-24','16:45:00',1.01),('15844','2014-04-24','17:00:00',1.04),('15844','2014-04-24','17:05:00',1.01),('15844','2014-04-24','17:10:00',1.03),('15844','2014-01-06','11:15:00',1.18),('15844','2014-01-06','11:30:00',1.95),('15844','2014-01-06','11:35:00',2.36),('15844','2014-01-06','11:40:00',1.95),('15844','2014-01-06','11:45:00',1.96),('15844','2014-01-06','11:50:00',1.9),('15844','2014-01-06','11:55:00',1.89),('15844','2014-01-06','12:00:00',1.88),('15844','2014-01-06','12:05:00',1.85),('15844','2014-01-06','12:10:00',1.78),('15844','2014-01-06','12:15:00',1.74),('15844','2014-01-06','12:20:00',1.75),('15844','2014-01-06','12:25:00',1.69),('15844','2014-01-06','12:30:00',1.66),('15844','2014-01-06','12:35:00',1.59),('15844','2014-01-06','12:40:00',1.57),('15844','2014-01-06','12:45:00',1.53),('15844','2014-01-06','12:50:00',1.47),('15844','2014-01-06','12:55:00',1.42),('15844','2014-01-06','13:00:00',1.39),('15844','2014-01-06','13:05:00',1.34),('15844','2014-01-06','13:10:00',1.27),('15844','2014-01-06','13:15:00',1.2),('15844','2014-01-06','13:20:00',1.12),('15844','2014-01-06','13:25:00',1.05),('15844','2014-01-03','09:10:00',1.03),('15844','2014-01-03','09:15:00',1.11),('15844','2014-01-03','09:20:00',1.17),('15844','2014-01-03','09:25:00',1.35),('15844','2014-01-03','09:30:00',1.6),('15844','2014-01-03','09:35:00',1.68),('15844','2014-01-03','09:40:00',1.26),('15844','2014-01-03','09:50:00',1.13),('15844','2014-01-03','09:55:00',1.47),('15844','2014-01-03','10:00:00',1.63),('15844','2014-01-03','10:05:00',1.77),('15844','2014-01-03','10:10:00',1.52),('15844','2014-01-03','10:15:00',1.13),('15844','2014-01-03','10:40:00',1.13),('15844','2014-01-03','10:45:00',1.01),('15844','2014-01-03','11:10:00',1.02),('15844','2014-01-03','11:15:00',1.06),('15844','2014-01-03','11:40:00',1.31),('15844','2014-01-03','11:45:00',1.73),('15844','2014-01-03','11:50:00',1.98),('15844','2014-01-03','11:55:00',1.62),('15844','2014-01-03','12:00:00',1.24),('15844','2014-01-03','12:05:00',1.55),('15844','2014-01-03','12:10:00',1.92),('15844','2014-01-03','12:15:00',2.07),('15844','2014-01-03','12:20:00',2),('15844','2014-01-03','12:25:00',1.77),('15844','2014-01-03','12:30:00',1.24),('15844','2014-01-03','12:35:00',1.08),('15844','2014-01-03','12:40:00',1.39),('15844','2014-01-03','12:45:00',1.51),('15844','2014-01-03','12:50:00',1.52),('15844','2014-01-03','12:55:00',1.41),('15844','2014-01-03','13:00:00',1.53),('15844','2014-01-03','13:05:00',1.82),('15844','2014-01-03','13:10:00',1.35),('15844','2014-01-03','13:15:00',1.13),('15844','2014-01-03','13:20:00',1.04),('15844','2014-01-02','09:05:00',1.01),('15844','2014-01-02','09:10:00',1.06),('15844','2014-01-02','09:15:00',1.12),('15844','2014-01-02','09:20:00',1.18),('15844','2014-01-02','09:25:00',1.22),('15844','2014-01-02','09:30:00',1.28),('15844','2014-01-02','09:35:00',1.33),('15844','2014-01-02','09:40:00',1.37),('15844','2014-01-02','09:45:00',1.4),('15844','2014-01-02','09:50:00',1.45),('15844','2014-01-02','09:55:00',1.47),('15844','2014-01-02','10:00:00',1.51),('15844','2014-01-02','10:05:00',1.56),('15844','2014-01-02','10:10:00',1.59),('15844','2014-01-02','10:15:00',1.64),('15844','2014-01-02','10:20:00',1.66),('15844','2014-01-02','10:25:00',1.69),('15844','2014-01-02','10:30:00',1.72),('15844','2014-01-02','10:35:00',1.72),('15844','2014-01-02','10:40:00',1.79),('15844','2014-01-02','10:45:00',1.83),('15844','2014-01-02','10:50:00',1.73),('15844','2014-01-02','10:55:00',1.44),('15844','2014-01-02','11:00:00',1.37),('15844','2014-01-02','11:05:00',1.52),('15844','2014-01-02','11:10:00',1.34),('15844','2014-01-02','11:15:00',1.02),('15844','2014-01-02','11:20:00',1.13),('15844','2014-01-02','11:25:00',1.17),('15844','2014-01-02','11:30:00',1.26),('15844','2014-01-02','11:35:00',1.32),('15844','2014-01-02','11:40:00',1.38),('15844','2014-01-02','12:45:00',1.1),('15844','2014-01-02','12:50:00',1.82),('15844','2014-01-02','13:00:00',1.27),('15844','2014-01-02','13:05:00',1.4),('15844','2014-01-02','13:15:00',1.05),('15844','2014-01-02','13:25:00',1.15),('15844','2014-01-02','13:30:00',1.42),('15844','2014-01-01','12:05:00',1.02),('15844','2014-01-01','12:10:00',1.05),('15844','2014-01-01','12:15:00',1.03),('15844','2014-01-01','12:20:00',1.04),('15844','2014-01-01','12:25:00',1.05),('15844','2014-01-01','12:30:00',1.02),('15844','2014-01-01','12:50:00',1),('15844','2014-01-01','13:00:00',1.14),('15844','2014-01-01','13:25:00',1.02),('15844','2014-01-01','13:30:00',1.52),('15844','2014-01-01','13:40:00',1.11),('15844','2014-01-01','13:45:00',1.05),('15844','2013-12-31','09:00:00',1.08),('15844','2013-12-31','09:05:00',1.14),('15844','2013-12-31','09:10:00',1.16),('15844','2013-12-31','09:15:00',1.21),('15844','2013-12-31','09:20:00',1.26),('15844','2013-12-31','09:25:00',1.38),('15844','2013-12-31','09:30:00',1.54),('15844','2013-12-31','09:35:00',1.69),('15844','2013-12-31','09:40:00',1.52),('15844','2013-12-31','10:05:00',1.45),('15844','2013-12-31','10:10:00',1.98),('15844','2013-12-31','11:00:00',1),('15844','2013-12-31','11:05:00',1.09),('15844','2013-12-31','11:10:00',1.24),('15844','2013-12-31','11:15:00',1.22),('15844','2013-12-31','11:20:00',1.83),('15844','2013-12-31','11:25:00',1.06),('15844','2013-12-31','11:35:00',1.76),('15844','2013-12-31','11:40:00',1.77),('15844','2013-12-31','11:50:00',1.5),('15844','2013-12-31','11:55:00',1.27),('15844','2013-12-31','12:00:00',1.88),('15844','2013-12-31','12:05:00',1.79),('15844','2013-12-31','12:10:00',1.8),('15844','2013-12-31','12:15:00',1.78),('15844','2013-12-31','12:20:00',1.6),('15844','2013-12-31','12:25:00',1.68),('15844','2013-12-31','12:30:00',1.64),('15844','2013-12-31','12:35:00',1.57),('15844','2013-12-31','12:40:00',1.51),('15844','2013-12-31','12:45:00',1.48),('15844','2013-12-31','12:50:00',1.43),('15844','2013-12-31','12:55:00',1.38),('15844','2013-12-31','13:00:00',1.32),('15844','2013-12-31','13:05:00',1.27),('15844','2013-12-31','13:10:00',1.21),('15844','2013-12-31','13:15:00',1.15),('15844','2013-12-31','13:20:00',1.1),('15844','2013-12-31','13:25:00',1.03),('15844','2013-12-29','09:10:00',1.02),('15844','2013-12-29','09:15:00',1.09),('15844','2013-12-29','09:20:00',1.23),('15844','2013-12-29','09:25:00',1.32),('15844','2013-12-29','09:30:00',1.35),('15844','2013-12-29','09:35:00',1.4),('15844','2013-12-29','09:40:00',1.5),('15844','2013-12-29','09:45:00',1.51),('15844','2013-12-29','09:50:00',1.32),('15844','2013-12-29','09:55:00',1.38),('15844','2013-12-29','10:00:00',1.44),('15844','2013-12-29','10:05:00',1.5),('15844','2013-12-29','10:10:00',1.57),('15844','2013-12-29','10:15:00',1.61),('15844','2013-12-29','10:20:00',1.03),('15844','2013-12-29','10:25:00',1.18),('15844','2013-12-29','10:30:00',1.18),('15844','2013-12-29','10:35:00',1.06),('15844','2013-12-29','10:40:00',1.52),('15844','2013-12-29','10:45:00',1.41),('15844','2013-12-28','09:05:00',1.04),('15844','2013-12-28','09:10:00',1.11),('15844','2013-12-28','09:15:00',1.17),('15844','2013-12-28','09:20:00',1.22),('15844','2013-12-28','09:25:00',1.29),('15844','2013-12-28','09:30:00',1.34),('15844','2013-12-28','09:35:00',1.38),('15844','2013-12-28','09:40:00',1.41),('15844','2013-12-28','09:45:00',1.45),('15844','2013-12-28','09:50:00',1.49),('15844','2013-12-28','09:55:00',1.53),('15844','2013-12-28','10:00:00',1.58),('15844','2013-12-28','10:05:00',1.6),('15844','2013-12-28','10:10:00',1.63),('15844','2013-12-28','10:15:00',1.67),('15844','2013-12-28','10:20:00',1.69),('15844','2013-12-28','10:25:00',1.72),('15844','2013-12-28','10:30:00',1.76),('15844','2013-12-28','10:35:00',1.79),('15844','2013-12-28','10:40:00',1.83),('15844','2013-12-28','10:45:00',1.86),('15844','2013-12-28','10:50:00',1.86),('15844','2013-12-28','10:55:00',1.87),('15844','2013-12-28','11:00:00',1.88),('15844','2013-12-28','11:05:00',1.91),('15844','2013-12-28','11:10:00',1.91),('15844','2013-12-28','11:15:00',1.9),('15844','2013-12-28','11:20:00',1.88),('15844','2013-12-28','11:25:00',1.87),('15844','2013-12-28','11:30:00',1.87),('15844','2013-12-28','11:35:00',1.87),('15844','2013-12-28','11:40:00',1.84),('15844','2013-12-28','11:45:00',1.83),('15844','2013-12-28','11:50:00',1.79),('15844','2013-12-28','11:55:00',1.8),('15844','2013-12-28','12:00:00',1.79),('15844','2013-12-28','12:05:00',1.74),('15844','2013-12-28','12:10:00',1.73),('15844','2013-12-28','12:15:00',1.69),('15844','2013-12-28','12:20:00',1.67),('15844','2013-12-28','12:25:00',1.63),('15844','2013-12-28','12:30:00',1.6),('15844','2013-12-28','12:35:00',1.55),('15844','2013-12-28','12:40:00',1.48),('15844','2013-12-28','12:45:00',1.42),('15844','2013-12-28','12:50:00',1.36),('15844','2013-12-28','12:55:00',1.32),('15844','2013-12-28','13:00:00',1.25),('15844','2013-12-28','13:05:00',1.18),('15844','2013-12-28','13:10:00',1.11),('15844','2013-12-28','13:15:00',1.06),('15844','2014-04-23','13:30:00',1.07),('15844','2014-04-23','13:35:00',1.19),('15844','2014-04-23','13:40:00',1.3),('15844','2014-04-23','13:45:00',1.37),('15844','2014-04-23','13:50:00',1.38),('15844','2014-04-23','13:55:00',1.4),('15844','2014-04-23','14:00:00',1.39),('15844','2014-04-23','14:05:00',1.38),('15844','2014-04-23','14:10:00',1.37),('15844','2014-04-23','14:15:00',1.31),('15844','2014-04-23','14:20:00',1.21),('15844','2014-04-23','14:25:00',1.1),('15844','2014-04-23','15:10:00',1.05),('15844','2014-04-23','15:15:00',1.17),('15844','2014-04-23','15:20:00',1.21),('15844','2014-04-23','15:25:00',1.23),('15844','2014-04-23','15:30:00',1.15),('15844','2014-04-23','15:35:00',1.03),('15844','2013-12-27','12:00:00',1.05),('15844','2013-12-27','12:05:00',1.44),('15844','2013-12-27','12:10:00',1.46),('15844','2013-12-27','12:15:00',1.27),('15844','2013-12-27','12:45:00',1.25),('15844','2013-12-27','12:50:00',1.13),('15844','2013-12-27','12:55:00',1.34),('15844','2013-12-27','13:00:00',1.12),('15844','2013-12-27','13:05:00',1.16),('15844','2013-12-27','13:10:00',1.15),('15844','2013-12-27','13:15:00',1.15),('15844','2013-12-27','13:20:00',1.15),('15844','2013-12-27','13:25:00',1.15),('15844','2013-12-27','13:30:00',1.16),('15844','2013-12-25','11:40:00',1.11),('15844','2013-12-25','11:50:00',1.35),('15844','2013-12-25','11:55:00',1.91),('15844','2013-12-25','12:00:00',1.74),('15844','2013-12-25','12:05:00',1.59),('15844','2013-12-25','12:15:00',1.81),('15844','2013-12-25','12:20:00',1.87),('15844','2013-12-25','12:25:00',2.01),('15844','2013-12-25','12:30:00',1.62),('15844','2013-12-25','12:35:00',1.11),('15844','2013-12-25','12:45:00',1.02),('15844','2013-12-24','09:15:00',1.03),('15844','2013-12-24','09:20:00',1.09),('15844','2013-12-24','09:25:00',1.13),('15844','2013-12-24','09:30:00',1.17),('15844','2013-12-24','09:35:00',1.21),('15844','2013-12-24','09:40:00',1.25),('15844','2013-12-24','09:45:00',1.27),('15844','2013-12-24','09:50:00',1.3),('15844','2013-12-24','09:55:00',1.34),('15844','2013-12-24','10:00:00',1.38),('15844','2013-12-24','10:05:00',1.41),('15844','2013-12-24','10:10:00',1.42),('15844','2013-12-24','10:15:00',1.44),('15844','2013-12-24','10:20:00',1.5),('15844','2013-12-24','10:25:00',1.54),('15844','2013-12-24','10:30:00',1.59),('15844','2013-12-24','10:35:00',1.61),('15844','2013-12-24','10:40:00',1.65),('15844','2013-12-24','10:45:00',1.66),('15844','2013-12-24','10:50:00',1.65),('15844','2013-12-24','10:55:00',1.67),('15844','2013-12-24','11:00:00',1.69),('15844','2013-12-24','11:05:00',1.64),('15844','2013-12-24','11:10:00',1.59),('15844','2013-12-24','11:15:00',1.66),('15844','2013-12-24','11:20:00',1.67),('15844','2013-12-24','11:25:00',1.66),('15844','2013-12-24','11:30:00',1.65),('15844','2013-12-24','11:35:00',1.63),('15844','2013-12-24','11:40:00',1.64),('15844','2013-12-24','11:45:00',1.61),('15844','2013-12-24','11:50:00',1.6),('15844','2013-12-24','11:55:00',1.59),('15844','2013-12-24','12:00:00',1.56),('15844','2013-12-24','12:05:00',1.54),('15844','2013-12-24','12:10:00',1.53),('15844','2013-12-24','12:15:00',1.5),('15844','2013-12-24','12:20:00',1.47),('15844','2013-12-24','12:25:00',1.44),('15844','2013-12-24','12:30:00',1.4),('15844','2013-12-24','12:35:00',1.37),('15844','2013-12-24','12:40:00',1.34),('15844','2013-12-24','12:45:00',1.29),('15844','2013-12-24','12:50:00',1.21),('15844','2013-12-24','12:55:00',1.16),('15844','2013-12-24','13:00:00',1.11),('15844','2013-12-24','13:05:00',1.06),('15844','2013-12-24','13:10:00',1.01),('15844','2013-12-23','09:55:00',1.1),('15844','2013-12-23','10:00:00',1.3),('15844','2013-12-23','10:05:00',1.39),('15844','2013-12-23','10:10:00',1.35),('15844','2013-12-23','10:15:00',1.56),('15844','2013-12-23','10:20:00',1.52),('15844','2013-12-23','10:25:00',1.59),('15844','2013-12-23','10:30:00',1.48),('15844','2013-12-23','10:35:00',1.45),('15844','2013-12-23','10:40:00',1.45),('15844','2013-12-23','10:45:00',1.48),('15844','2013-12-23','10:50:00',1.57),('15844','2013-12-23','10:55:00',1.67),('15844','2013-12-23','11:00:00',1.74),('15844','2013-12-23','11:05:00',1.72),('15844','2013-12-23','11:10:00',1.79),('15844','2013-12-23','11:15:00',1.78),('15844','2013-12-23','11:20:00',1.77),('15844','2013-12-23','11:25:00',1.81),('15844','2013-12-23','11:30:00',1.79),('15844','2013-12-23','11:35:00',1.7),('15844','2013-12-23','11:40:00',1.51),('15844','2013-12-23','11:45:00',1.55),('15844','2013-12-23','11:50:00',1.63),('15844','2013-12-23','11:55:00',1.7),('15844','2013-12-23','12:00:00',1.67),('15844','2013-12-23','12:05:00',1.66),('15844','2013-12-23','12:10:00',1.62),('15844','2013-12-23','12:15:00',1.55),('15844','2013-12-23','12:20:00',1.51),('15844','2013-12-23','12:25:00',1.44),('15844','2013-12-23','12:30:00',1.41),('15844','2013-12-23','12:35:00',1.34),('15844','2013-12-23','12:40:00',1.29),('15844','2013-12-23','12:45:00',1.26),('15844','2013-12-23','12:50:00',1.22),('15844','2013-12-23','12:55:00',1.17),('15844','2013-12-23','13:00:00',1.11),('15844','2013-12-23','13:05:00',1.09),('15844','2013-12-23','13:10:00',1),('15844','2013-12-22','09:30:00',1.13),('15844','2013-12-22','09:35:00',1.39),('15844','2013-12-22','09:40:00',1.68),('15844','2013-12-22','09:45:00',1.72),('15844','2013-12-22','09:50:00',1.81),('15844','2013-12-22','09:55:00',1.81),('15844','2013-12-22','10:00:00',1.79),('15844','2013-12-22','10:05:00',1.72),('15844','2013-12-22','10:10:00',1.75),('15844','2013-12-22','10:15:00',1.72),('15844','2013-12-22','10:20:00',1.72),('15844','2013-12-22','10:25:00',1.69),('15844','2013-12-22','10:30:00',1.71),('15844','2013-12-22','10:35:00',1.64),('15844','2013-12-22','10:40:00',1.57),('15844','2013-12-22','10:45:00',1.59),('15844','2013-12-22','10:50:00',1.7),('15844','2013-12-22','10:55:00',1.71),('15844','2013-12-22','11:00:00',1.66),('15844','2013-12-22','11:05:00',1.57),('15844','2013-12-22','11:10:00',1.68),('15844','2013-12-22','11:15:00',1.61),('15844','2013-12-22','11:20:00',1.62),('15844','2013-12-22','11:25:00',1.61),('15844','2013-12-22','11:30:00',1.53),('15844','2013-12-22','11:35:00',1.58),('15844','2013-12-22','11:40:00',1.52),('15844','2013-12-22','11:45:00',1.41),('15844','2013-12-22','11:50:00',1.11),('15844','2013-12-22','12:35:00',1.12),('15844','2013-12-22','12:40:00',1.14),('15844','2013-12-22','12:45:00',1.09),('15844','2013-12-22','12:50:00',1.23),('15844','2013-12-22','12:55:00',1.38),('15844','2013-12-22','13:00:00',1.44),('15844','2013-12-22','13:05:00',1.56),('15844','2013-12-22','13:10:00',1.52),('15844','2013-12-22','13:15:00',1.34),('15844','2013-12-22','13:20:00',1.15),('15844','2013-12-22','13:25:00',1.08),('15844','2013-12-21','09:15:00',1.04),('15844','2013-12-21','09:20:00',1.11),('15844','2013-12-21','09:25:00',1.11),('15844','2013-12-21','09:30:00',1.2),('15844','2013-12-21','09:35:00',1.24),('15844','2013-12-21','09:40:00',1.27),('15844','2013-12-21','09:45:00',1.33),('15844','2013-12-21','09:50:00',1.35),('15844','2013-12-21','09:55:00',1.4),('15844','2013-12-21','10:00:00',1.45),('15844','2013-12-21','10:05:00',1.5),('15844','2013-12-21','10:10:00',1.53),('15844','2013-12-21','10:15:00',1.57),('15844','2013-12-21','10:20:00',1.6),('15844','2013-12-21','10:25:00',1.63),('15844','2013-12-21','10:30:00',1.66),('15844','2013-12-21','10:35:00',1.7),('15844','2013-12-21','10:40:00',1.73),('15844','2013-12-21','10:45:00',1.76),('15844','2013-12-21','10:50:00',1.78),('15844','2013-12-21','10:55:00',1.8),('15844','2013-12-21','11:00:00',1.82),('15844','2013-12-21','11:05:00',1.82),('15844','2013-12-21','11:10:00',1.82),('15844','2013-12-21','11:15:00',1.82),('15844','2013-12-21','11:20:00',1.82),('15844','2013-12-21','11:25:00',1.81),('15844','2013-12-21','11:30:00',1.82),('15844','2013-12-21','11:35:00',1.8),('15844','2013-12-21','11:40:00',1.8),('15844','2013-12-21','11:45:00',1.75),('15844','2013-12-21','11:50:00',1.75),('15844','2013-12-21','11:55:00',1.75),('15844','2013-12-21','12:00:00',1.73),('15844','2013-12-21','12:05:00',1.71),('15844','2013-12-21','12:10:00',1.67),('15844','2013-12-21','12:15:00',1.64),('15844','2013-12-21','12:20:00',1.6),('15844','2013-12-21','12:25:00',1.57),('15844','2013-12-21','12:30:00',1.53),('15844','2013-12-21','12:35:00',1.46),('15844','2013-12-21','12:40:00',1.42),('15844','2013-12-21','12:45:00',1.38),('15844','2013-12-21','12:50:00',1.34),('15844','2013-12-21','12:55:00',1.28),('15844','2013-12-21','13:00:00',1.23),('15844','2013-12-21','13:05:00',1.17),('15844','2013-12-21','13:10:00',1.11),('15844','2013-12-21','13:15:00',1.05),('15844','2013-12-20','09:15:00',1.02),('15844','2013-12-20','09:20:00',1.07),('15844','2013-12-20','09:25:00',1.11),('15844','2013-12-20','09:30:00',1.17),('15844','2013-12-20','09:35:00',1.21),('15844','2013-12-20','09:40:00',1.23),('15844','2013-12-20','09:45:00',1.3),('15844','2013-12-20','09:50:00',1.33),('15844','2013-12-20','09:55:00',1.38),('15844','2013-12-20','10:00:00',1.41),('15844','2013-12-20','10:05:00',1.43),('15844','2013-12-20','10:10:00',1.46),('15844','2013-12-20','10:15:00',1.47),('15844','2013-12-20','10:20:00',1.48),('15844','2013-12-20','10:25:00',1.53),('15844','2013-12-20','10:30:00',1.56),('15844','2013-12-20','10:35:00',1.61),('15844','2013-12-20','10:40:00',1.66),('15844','2013-12-20','10:45:00',1.67),('15844','2013-12-20','10:50:00',1.68),('15844','2013-12-20','10:55:00',1.71),('15844','2013-12-20','11:00:00',1.71),('15844','2013-12-20','11:05:00',1.69),('15844','2013-12-20','11:10:00',1.71),('15844','2013-12-20','11:15:00',1.7),('15844','2013-12-20','11:20:00',1.7),('15844','2013-12-20','11:25:00',1.69),('15844','2013-12-20','11:30:00',1.68),('15844','2013-12-20','11:35:00',1.67),('15844','2013-12-20','11:40:00',1.66),('15844','2013-12-20','11:45:00',1.64),('15844','2013-12-20','11:50:00',1.61),('15844','2013-12-20','11:55:00',1.6),('15844','2013-12-20','12:00:00',1.57),('15844','2013-12-20','12:05:00',1.52),('15844','2013-12-20','12:10:00',1.52),('15844','2013-12-20','12:15:00',1.51),('15844','2013-12-20','12:20:00',1.46),('15844','2013-12-20','12:35:00',1.37),('15844','2013-12-20','12:40:00',1.35),('15844','2013-12-20','12:45:00',1.32),('15844','2013-12-20','12:50:00',1.24),('15844','2013-12-20','12:55:00',1.18),('15844','2013-12-20','13:00:00',1.13),('15844','2013-12-20','13:05:00',1.06),('15844','2013-12-19','09:50:00',1.25),('15844','2013-12-18','09:10:00',1.01),('15844','2013-12-18','09:15:00',1.08),('15844','2013-12-18','09:20:00',1.13),('15844','2013-12-18','09:25:00',1.18),('15844','2013-12-18','09:30:00',1.24),('15844','2013-12-18','09:35:00',1.28),('15844','2013-12-18','09:40:00',1.33),('15844','2013-12-18','09:45:00',1.37),('15844','2013-12-18','09:50:00',1.4),('15844','2013-12-18','09:55:00',1.45),('15844','2013-12-18','10:00:00',1.48),('15844','2013-12-18','10:05:00',1.52),('15844','2013-12-18','10:10:00',1.56),('15844','2013-12-18','10:15:00',1.59),('15844','2013-12-18','10:20:00',1.6),('15844','2013-12-18','10:25:00',1.63),('15844','2013-12-18','10:30:00',1.66),('15844','2013-12-18','10:35:00',1.71),('15844','2013-12-18','10:40:00',1.72),('15844','2013-12-18','10:45:00',1.75),('15844','2013-12-18','10:50:00',1.76),('15844','2013-12-18','10:55:00',1.76),('15844','2013-12-18','11:00:00',1.76),('15844','2013-12-18','11:05:00',1.74),('15844','2013-12-18','11:10:00',1.76),('15844','2013-12-18','11:15:00',1.72),('15844','2013-12-18','11:20:00',1.72),('15844','2013-12-18','11:25:00',1.72),('15844','2013-12-18','11:30:00',1.72),('15844','2013-12-18','11:35:00',1.69),('15844','2013-12-18','11:40:00',1.69),('15844','2013-12-18','11:45:00',1.69),('15844','2013-12-18','11:50:00',1.68),('15844','2013-12-18','11:55:00',1.67),('15844','2013-12-18','12:00:00',1.65),('15844','2013-12-18','12:05:00',1.62),('15844','2013-12-18','12:10:00',1.58),('15844','2013-12-18','12:15:00',1.56),('15844','2013-12-18','12:20:00',1.54),('15844','2013-12-18','12:25:00',1.49),('15844','2013-12-18','12:30:00',1.43),('15844','2013-12-18','12:35:00',1.41),('15844','2013-12-18','12:40:00',1.33),('15844','2013-12-18','12:45:00',1.3),('15844','2013-12-18','12:50:00',1.22),('15844','2013-12-18','12:55:00',1.19),('15844','2013-12-18','13:00:00',1.11),('15844','2013-12-18','13:05:00',1.04),('15844','2013-12-18','13:10:00',1.01),('15844','2014-04-22','08:35:00',1.06),('15844','2014-04-22','08:40:00',1.21),('15844','2014-04-22','08:45:00',1.32),('15844','2014-04-22','08:50:00',1.34),('15844','2014-04-22','08:55:00',1.43),('15844','2014-04-22','09:00:00',1.55),('15844','2014-04-22','09:05:00',1.65),('15844','2014-04-22','09:10:00',1.18),('15844','2014-04-22','09:15:00',1.01),('15844','2014-04-22','09:20:00',2.05),('15844','2014-04-22','09:25:00',2.06),('15844','2014-04-22','09:30:00',1.41),('15844','2014-04-22','09:35:00',1.76),('15844','2014-04-22','09:40:00',2.2),('15844','2014-04-22','09:45:00',2.29),('15844','2014-04-22','09:50:00',1.36),('15844','2014-04-22','09:55:00',1.16),('15844','2014-04-22','10:00:00',1.39),('15844','2014-04-22','10:05:00',1.27),('15844','2014-04-22','10:10:00',1.78),('15844','2014-04-22','10:15:00',2.08),('15844','2014-04-22','10:20:00',2.66),('15844','2014-04-22','10:25:00',1.98),('15844','2014-04-22','10:30:00',3.11),('15844','2014-04-22','10:35:00',1.88),('15844','2014-04-22','10:40:00',2.47),('15844','2014-04-22','10:45:00',4.06),('15844','2014-04-22','10:50:00',3.19),('15844','2014-04-22','10:55:00',3.21),('15844','2014-04-22','11:00:00',2.21),('15844','2014-04-22','11:05:00',2.23),('15844','2014-04-22','11:10:00',1.48),('15844','2014-04-22','11:15:00',1.32),('15844','2014-04-22','11:20:00',1.03),('15844','2014-04-22','11:25:00',1.01),('15844','2014-04-22','12:05:00',1.04),('15844','2014-04-22','12:15:00',1.03),('15844','2014-04-22','12:20:00',1.05),('15844','2014-04-22','12:25:00',1.12),('15844','2014-04-22','12:30:00',1.1),('15844','2014-04-22','13:15:00',1.26),('15844','2014-04-22','13:20:00',1.57),('15844','2014-04-22','13:25:00',1.72),('15844','2014-04-22','13:30:00',2.15),('15844','2014-04-22','13:35:00',2.49),('15844','2014-04-22','13:40:00',2.29),('15844','2014-04-22','13:45:00',2.13),('15844','2014-04-22','13:50:00',1.41),('15844','2014-04-22','13:55:00',1.24),('15844','2014-04-22','14:00:00',1.29),('15844','2014-04-22','14:05:00',3.56),('15844','2014-04-22','14:10:00',2.88),('15844','2014-04-22','14:15:00',2.56),('15844','2014-04-22','14:20:00',1.94),('15844','2014-04-22','14:25:00',1.46),('15844','2014-04-22','14:30:00',2.02),('15844','2014-04-22','14:35:00',3.14),('15844','2014-04-22','14:40:00',2.73),('15844','2014-04-22','14:45:00',2.9),('15844','2014-04-22','14:50:00',2.7),('15844','2014-04-22','14:55:00',1.41),('15844','2014-04-22','15:05:00',1.02),('15844','2014-04-22','15:10:00',1.05),('15844','2014-04-22','15:15:00',1.06),('15844','2014-04-22','15:20:00',1.04),('15844','2014-04-22','15:25:00',1.24),('15844','2014-04-22','15:30:00',1.41),('15844','2014-04-22','15:35:00',1.49),('15844','2014-04-22','15:40:00',1.44),('15844','2014-04-22','15:45:00',1.62),('15844','2014-04-22','15:50:00',1.58),('15844','2014-04-22','15:55:00',1.49),('15844','2014-04-22','16:00:00',1.68),('15844','2014-04-22','16:05:00',1.39),('15844','2014-04-22','16:10:00',1.22),('15844','2014-04-22','16:15:00',1.16),('15844','2014-04-22','16:20:00',1.36),('15844','2014-04-22','16:25:00',1.23),('15844','2014-04-22','16:30:00',1.08),('15844','2014-04-22','16:35:00',1.15),('15844','2014-04-22','16:40:00',1.13),('15844','2014-04-22','16:45:00',1.05),('15844','2014-04-22','17:00:00',1.04),('15844','2013-12-17','08:55:00',1),('15844','2013-12-17','09:00:00',1.06),('15844','2013-12-17','09:05:00',1.11),('15844','2013-12-17','09:10:00',1.16),('15844','2013-12-17','09:15:00',1.18),('15844','2013-12-17','09:20:00',1.25),('15844','2013-12-17','09:25:00',1.27),('15844','2013-12-17','09:30:00',1.32),('15844','2013-12-17','09:35:00',1.35),('15844','2013-12-17','09:40:00',1.4),('15844','2013-12-17','09:45:00',1.44),('15844','2013-12-17','09:50:00',1.48),('15844','2013-12-17','09:55:00',1.51),('15844','2013-12-17','10:00:00',1.55),('15844','2013-12-17','10:05:00',1.58),('15844','2013-12-17','10:10:00',1.62),('15844','2013-12-17','10:15:00',1.64),('15844','2013-12-17','10:20:00',1.65),('15844','2013-12-17','10:25:00',1.68),('15844','2013-12-17','10:30:00',1.71),('15844','2013-12-17','10:35:00',1.75),('15844','2013-12-17','10:40:00',1.8),('15844','2013-12-17','10:45:00',1.82),('15844','2013-12-17','10:50:00',1.83),('15844','2013-12-17','10:55:00',1.84),('15844','2013-12-17','11:00:00',1.84),('15844','2013-12-17','11:05:00',1.84),('15844','2013-12-17','11:10:00',1.83),('15844','2013-12-17','11:15:00',1.85),('15844','2013-12-17','11:20:00',1.84),('15844','2013-12-17','11:25:00',1.85),('15844','2013-12-17','11:30:00',1.84),('15844','2013-12-17','11:35:00',1.82),('15844','2013-12-17','11:40:00',1.81),('15844','2013-12-17','11:45:00',1.75),('15844','2013-12-17','11:50:00',1.75),('15844','2013-12-17','11:55:00',1.69),('15844','2013-12-17','12:00:00',1.69),('15844','2013-12-17','12:05:00',1.68),('15844','2013-12-17','12:10:00',1.65),('15844','2013-12-17','12:15:00',1.65),('15844','2013-12-17','12:20:00',1.6),('15844','2013-12-17','12:25:00',1.57),('15844','2013-12-17','12:30:00',1.53),('15844','2013-12-17','12:35:00',1.5),('15844','2013-12-17','12:40:00',1.45),('15844','2013-12-17','12:45:00',1.41),('15844','2013-12-17','12:50:00',1.36),('15844','2013-12-17','13:05:00',1.16),('15844','2013-12-17','13:10:00',1.1),('15844','2013-12-17','13:15:00',1.03),('15844','2013-12-16','09:00:00',1.01),('15844','2013-12-16','09:05:00',1.07),('15844','2013-12-16','09:10:00',1.14),('15844','2013-12-16','09:15:00',1.19),('15844','2013-12-16','09:20:00',1.27),('15844','2013-12-16','09:25:00',1.31),('15844','2013-12-16','09:30:00',1.35),('15844','2013-12-16','09:35:00',1.39),('15844','2013-12-16','09:40:00',1.43),('15844','2013-12-16','09:45:00',1.46),('15844','2013-12-16','09:50:00',1.51),('15844','2013-12-16','09:55:00',1.55),('15844','2013-12-16','10:00:00',1.58),('15844','2013-12-16','10:05:00',1.59),('15844','2013-12-16','10:10:00',1.63),('15844','2013-12-16','10:15:00',1.64),('15844','2013-12-16','10:20:00',1.65),('15844','2013-12-16','10:25:00',1.69),('15844','2013-12-16','10:30:00',1.73),('15844','2013-12-16','10:35:00',1.75),('15844','2013-12-16','10:40:00',1.77),('15844','2013-12-16','10:45:00',1.82),('15844','2013-12-16','10:50:00',1.83),('15844','2013-12-16','10:55:00',1.86),('15844','2013-12-16','11:00:00',1.86),('15844','2013-12-16','11:05:00',1.88),('15844','2013-12-16','11:10:00',1.86),('15844','2013-12-16','11:15:00',1.86),('15844','2013-12-16','11:20:00',1.86),('15844','2013-12-16','11:25:00',1.84),('15844','2013-12-16','11:30:00',1.84),('15844','2013-12-16','11:35:00',1.83),('15844','2013-12-16','11:40:00',1.83),('15844','2013-12-16','11:45:00',1.82),('15844','2013-12-16','11:50:00',1.8),('15844','2013-12-16','11:55:00',1.78),('15844','2013-12-16','12:00:00',1.77),('15844','2013-12-16','12:05:00',1.75),('15844','2013-12-16','12:10:00',1.72),('15844','2013-12-16','12:15:00',1.68),('15844','2013-12-16','12:20:00',1.62),('15844','2013-12-16','12:25:00',1.58),('15844','2013-12-16','12:30:00',1.54),('15844','2013-12-16','12:35:00',1.49),('15844','2013-12-16','12:40:00',1.44),('15844','2013-12-16','12:45:00',1.4),('15844','2013-12-16','12:50:00',1.34),('15844','2013-12-16','12:55:00',1.28),('15844','2013-12-16','13:00:00',1.23),('15844','2013-12-16','13:05:00',1.17),('15844','2013-12-16','13:10:00',1.11),('15844','2013-12-16','13:15:00',1.03),('15844','2013-12-15','10:30:00',1.03),('15844','2013-12-14','09:10:00',1.03),('15844','2013-12-14','09:15:00',1.09),('15844','2013-12-14','09:20:00',1.15),('15844','2013-12-14','09:25:00',1.19),('15844','2013-12-14','09:30:00',1.24),('15844','2013-12-14','09:35:00',1.28),('15844','2013-12-14','09:40:00',1.32),('15844','2013-12-14','09:45:00',1.36),('15844','2013-12-14','09:50:00',1.39),('15844','2013-12-14','09:55:00',1.42),('15844','2013-12-14','10:00:00',1.46),('15844','2013-12-14','10:05:00',1.51),('15844','2013-12-14','10:10:00',1.53),('15844','2013-12-14','10:15:00',1.57),('15844','2013-12-14','10:20:00',1.6),('15844','2013-12-14','10:25:00',1.65),('15844','2013-12-14','10:30:00',1.68),('15844','2013-12-14','10:35:00',1.72),('15844','2013-12-14','10:40:00',1.76),('15844','2013-12-14','10:45:00',1.78),('15844','2013-12-14','10:50:00',1.81),('15844','2013-12-14','10:55:00',1.81),('15844','2013-12-14','11:00:00',1.8),('15844','2013-12-14','11:05:00',1.78),('15844','2013-12-14','11:10:00',1.77),('15844','2013-12-14','11:15:00',1.78),('15844','2013-12-14','11:20:00',1.78),('15844','2013-12-14','11:25:00',1.77),('15844','2013-12-14','11:30:00',1.77),('15844','2013-12-14','11:35:00',1.75),('15844','2013-12-14','11:40:00',1.74),('15844','2013-12-14','11:45:00',1.71),('15844','2013-12-14','11:50:00',1.67),('15844','2013-12-14','11:55:00',1.68),('15844','2013-12-14','12:00:00',1.67),('15844','2013-12-14','12:05:00',1.61),('15844','2013-12-14','12:10:00',1.57),('15844','2013-12-14','12:15:00',1.55),('15844','2013-12-14','12:20:00',1.46),('15844','2013-12-14','12:25:00',1.38),('15844','2013-12-14','12:30:00',1.34),('15844','2013-12-14','12:35:00',1.38),('15844','2013-12-14','12:40:00',1.32),('15844','2013-12-14','12:45:00',1.32),('15844','2013-12-14','12:50:00',1.26),('15844','2013-12-14','12:55:00',1.23),('15844','2013-12-14','13:00:00',1.2),('15844','2013-12-14','13:05:00',1.16),('15844','2013-12-14','13:10:00',1.09),('15844','2013-12-14','13:15:00',1.02),('15844','2013-12-13','09:15:00',1.03),('15844','2013-12-13','09:20:00',1.06),('15844','2013-12-13','09:25:00',1.09),('15844','2013-12-13','09:30:00',1.12),('15844','2013-12-13','09:35:00',1.18),('15844','2013-12-13','09:40:00',1.21),('15844','2013-12-13','09:45:00',1.25),('15844','2013-12-13','09:50:00',1.29),('15844','2013-12-13','09:55:00',1.34),('15844','2013-12-13','10:00:00',1.37),('15844','2013-12-13','10:05:00',1.39),('15844','2013-12-13','10:10:00',1.41),('15844','2013-12-13','10:15:00',1.44),('15844','2013-12-13','10:20:00',1.46),('15844','2013-12-13','10:25:00',1.49),('15844','2013-12-13','10:30:00',1.53),('15844','2013-12-13','10:35:00',1.58),('15844','2013-12-13','10:40:00',1.61),('15844','2013-12-13','10:45:00',1.65),('15844','2013-12-13','10:50:00',1.67),('15844','2013-12-13','10:55:00',1.69),('15844','2013-12-13','11:00:00',1.71),('15844','2013-12-13','11:05:00',1.68),('15844','2013-12-13','11:10:00',1.66),('15844','2013-12-13','11:15:00',1.67),('15844','2013-12-13','11:20:00',1.69),('15844','2013-12-13','11:25:00',1.73),('15844','2013-12-13','11:30:00',1.68),('15844','2013-12-13','11:35:00',1.68),('15844','2013-12-13','11:40:00',1.69),('15844','2013-12-13','11:45:00',1.65),('15844','2013-12-13','11:50:00',1.64),('15844','2013-12-13','11:55:00',1.59),('15844','2013-12-13','12:00:00',1.57),('15844','2013-12-13','12:05:00',1.55),('15844','2013-12-13','12:10:00',1.52),('15844','2013-12-13','12:15:00',1.55),('15844','2013-12-13','12:20:00',1.48),('15844','2013-12-13','12:25:00',1.37),('15844','2013-12-13','12:30:00',1.38),('15844','2013-12-13','12:35:00',1.36),('15844','2013-12-13','12:40:00',1.35),('15844','2013-12-13','12:45:00',1.33),('15844','2013-12-13','12:50:00',1.3),('15844','2013-12-13','12:55:00',1.24),('15844','2013-12-13','13:00:00',1.21),('15844','2013-12-13','13:05:00',1.16),('15844','2013-12-13','13:10:00',1.09),('15844','2013-12-13','13:15:00',1.04),('15844','2013-12-12','09:05:00',1.02),('15844','2013-12-12','09:10:00',1.08),('15844','2013-12-12','09:15:00',1.14),('15844','2013-12-12','09:20:00',1.19),('15844','2013-12-12','09:25:00',1.23),('15844','2013-12-12','09:30:00',1.26),('15844','2013-12-12','09:35:00',1.3),('15844','2013-12-12','09:40:00',1.34),('15844','2013-12-12','09:45:00',1.38),('15844','2013-12-12','09:50:00',1.43),('15844','2013-12-12','09:55:00',1.47),('15844','2013-12-12','10:00:00',1.5),('15844','2013-12-12','10:05:00',1.54),('15844','2013-12-12','10:10:00',1.57),('15844','2013-12-12','10:15:00',1.59),('15844','2013-12-12','10:20:00',1.62),('15844','2013-12-12','10:25:00',1.67),('15844','2013-12-12','10:30:00',1.69),('15844','2013-12-12','10:35:00',1.71),('15844','2013-12-12','10:40:00',1.74),('15844','2013-12-12','10:45:00',1.74),('15844','2013-12-12','10:50:00',1.76),('15844','2013-12-12','10:55:00',1.76),('15844','2013-12-12','11:00:00',1.78),('15844','2013-12-12','11:05:00',1.77),('15844','2013-12-12','11:10:00',1.78),('15844','2013-12-12','11:15:00',1.77),('15844','2013-12-12','11:20:00',1.77),('15844','2013-12-12','11:25:00',1.77),('15844','2013-12-12','11:30:00',1.76),('15844','2013-12-12','11:35:00',1.74),('15844','2013-12-12','11:40:00',1.72),('15844','2013-12-12','11:45:00',1.7),('15844','2013-12-12','11:50:00',1.67),('15844','2013-12-12','11:55:00',1.69),('15844','2013-12-12','12:00:00',1.67),('15844','2013-12-12','12:05:00',1.61),('15844','2013-12-12','12:10:00',1.56),('15844','2013-12-12','12:15:00',1.53),('15844','2013-12-12','12:20:00',1.5),('15844','2013-12-12','12:25:00',1.46),('15844','2013-12-12','12:30:00',1.42),('15844','2013-12-12','12:35:00',1.4),('15844','2013-12-12','12:40:00',1.37),('15844','2013-12-12','12:45:00',1.3),('15844','2013-12-12','12:50:00',1.24),('15844','2013-12-12','12:55:00',1.21),('15844','2013-12-12','13:00:00',1.17),('15844','2013-12-12','13:05:00',1.1),('15844','2013-12-12','13:10:00',1.03),('15844','2013-12-11','09:00:00',1.01),('15844','2013-12-11','09:05:00',1.08),('15844','2013-12-11','09:10:00',1.12),('15844','2013-12-11','09:15:00',1.16),('15844','2013-12-11','09:20:00',1.22),('15844','2013-12-11','09:25:00',1.26),('15844','2013-12-11','09:30:00',1.3),('15844','2013-12-11','09:35:00',1.36),('15844','2013-12-11','09:40:00',1.42),('15844','2013-12-11','09:45:00',1.47),('15844','2013-12-11','09:50:00',1.52),('15844','2013-12-11','09:55:00',1.57),('15844','2013-12-11','10:00:00',1.6),('15844','2013-12-11','10:05:00',1.62),('15844','2013-12-11','10:10:00',1.65),('15844','2013-12-11','10:15:00',1.67),('15844','2013-12-11','10:20:00',1.69),('15844','2013-12-11','10:25:00',1.71),('15844','2013-12-11','10:30:00',1.77),('15844','2013-12-11','10:35:00',1.79),('15844','2013-12-11','10:40:00',1.82),('15844','2013-12-11','10:45:00',1.86),('15844','2013-12-11','10:50:00',1.86),('15844','2013-12-11','10:55:00',1.88),('15844','2013-12-11','11:00:00',1.89),('15844','2013-12-11','11:05:00',1.89),('15844','2013-12-11','11:10:00',1.86),('15844','2013-12-11','11:15:00',1.85),('15844','2013-12-11','11:20:00',1.86),('15844','2013-12-11','11:25:00',1.84),('15844','2013-12-11','11:30:00',1.85),('15844','2013-12-11','11:35:00',1.84),('15844','2013-12-11','11:40:00',1.82),('15844','2013-12-11','11:45:00',1.8),('15844','2013-12-11','11:50:00',1.79),('15844','2013-12-11','11:55:00',1.76),('15844','2013-12-11','12:00:00',1.75),('15844','2013-12-11','12:05:00',1.73),('15844','2013-12-11','12:10:00',1.67),('15844','2013-12-11','12:15:00',1.66),('15844','2013-12-11','12:20:00',1.61),('15844','2013-12-11','12:25:00',1.56),('15844','2013-12-11','12:30:00',1.52),('15844','2013-12-11','12:35:00',1.47),('15844','2013-12-11','12:40:00',1.41),('15844','2013-12-11','12:45:00',1.38),('15844','2013-12-11','12:50:00',1.34),('15844','2013-12-11','12:55:00',1.28),('15844','2013-12-11','13:00:00',1.2),('15844','2013-12-11','13:05:00',1.14),('15844','2013-12-11','13:10:00',1.07),('15844','2013-12-11','13:15:00',1.02),('15844','2013-12-10','09:00:00',1.03),('15844','2013-12-10','09:05:00',1.1),('15844','2013-12-10','09:10:00',1.15),('15844','2013-12-10','09:15:00',1.23),('15844','2013-12-10','09:20:00',1.27),('15844','2013-12-10','09:25:00',1.29),('15844','2013-12-10','09:30:00',1.33),('15844','2013-12-10','09:35:00',1.38),('15844','2013-12-10','09:40:00',1.44),('15844','2013-12-10','09:45:00',1.47),('15844','2013-12-10','09:50:00',1.53),('15844','2013-12-10','09:55:00',1.55),('15844','2013-12-10','10:00:00',1.6),('15844','2013-12-10','10:05:00',1.64),('15844','2013-12-10','10:10:00',1.66),('15844','2013-12-10','10:15:00',1.71),('15844','2013-12-10','10:20:00',1.72),('15844','2013-12-10','10:25:00',1.77),('15844','2013-12-10','10:30:00',1.78),('15844','2013-12-10','10:35:00',1.82),('15844','2013-12-10','10:40:00',1.84),('15844','2013-12-10','10:45:00',1.84),('15844','2013-12-10','10:50:00',1.86),('15844','2013-12-10','10:55:00',1.88),('15844','2013-12-10','11:00:00',1.88),('15844','2013-12-10','11:05:00',1.89),('15844','2013-12-10','11:10:00',1.91),('15844','2013-12-10','11:15:00',1.9),('15844','2013-12-10','11:20:00',1.9),('15844','2013-12-10','11:25:00',1.89),('15844','2013-12-10','11:30:00',1.9),('15844','2013-12-10','11:35:00',1.88),('15844','2013-12-10','11:40:00',1.87),('15844','2013-12-10','11:45:00',1.86),('15844','2013-12-10','11:50:00',1.83),('15844','2013-12-10','11:55:00',1.8),('15844','2013-12-10','12:00:00',1.77),('15844','2013-12-10','12:05:00',1.74),('15844','2013-12-10','12:10:00',1.72),('15844','2013-12-10','12:15:00',1.67),('15844','2013-12-10','12:20:00',1.58),('15844','2013-12-10','12:25:00',1.52),('15844','2013-12-10','12:30:00',1.48),('15844','2013-12-10','12:35:00',1.46),('15844','2013-12-10','12:40:00',1.42),('15844','2013-12-10','12:45:00',1.37),('15844','2013-12-10','12:50:00',1.33),('15844','2013-12-10','12:55:00',1.27),('15844','2013-12-10','13:00:00',1.2),('15844','2013-12-10','13:05:00',1.13),('15844','2013-12-10','13:10:00',1.07),('15844','2013-12-10','13:15:00',1),('15844','2013-12-09','09:20:00',1.24),('15844','2013-12-09','09:25:00',1.36),('15844','2013-12-09','09:30:00',1.38),('15844','2013-12-09','09:35:00',1.4),('15844','2013-12-09','09:40:00',1.43),('15844','2013-12-09','09:45:00',1.49),('15844','2013-12-09','09:50:00',1.59),('15844','2013-12-09','09:55:00',1.48),('15844','2013-12-09','10:00:00',1.53),('15844','2013-12-09','10:05:00',2.08),('15844','2013-12-09','10:10:00',1.2),('15844','2013-12-09','12:25:00',1.11),('15844','2013-12-09','12:30:00',1.87),('15844','2013-12-09','12:35:00',1.12),('15844','2013-12-09','12:45:00',1.45),('15844','2013-12-09','12:50:00',1.71),('15844','2013-12-09','12:55:00',1.29),('15844','2013-12-09','13:00:00',1.29),('15844','2013-12-09','13:10:00',1.57),('15844','2013-12-09','13:15:00',1.16),('15844','2013-12-09','13:20:00',1.12),('15844','2013-12-08','11:25:00',1.13),('15844','2013-12-08','11:30:00',1.08),('15844','2013-12-08','11:35:00',1.07),('15844','2013-12-08','11:40:00',1.07),('15844','2013-12-08','12:00:00',1.02),('15844','2014-04-21','08:45:00',1.1),('15844','2014-04-21','08:50:00',1.05),('15844','2014-04-21','08:55:00',1.34),('15844','2014-04-21','09:00:00',1.32),('15844','2014-04-21','09:05:00',1.06),('15844','2014-04-21','09:10:00',1.1),('15844','2014-04-21','09:15:00',1.16),('15844','2014-04-21','09:20:00',1.44),('15844','2014-04-21','09:25:00',1.28),('15844','2014-04-21','09:35:00',1.12),('15844','2014-04-21','09:40:00',1.39),('15844','2014-04-21','09:50:00',1),('15844','2014-04-21','09:55:00',1.03),('15844','2014-04-21','10:00:00',1.14),('15844','2014-04-21','10:05:00',2.09),('15844','2014-04-21','10:10:00',3.28),('15844','2014-04-21','10:15:00',3.32),('15844','2014-04-21','10:20:00',3.24),('15844','2014-04-21','10:25:00',3.23),('15844','2014-04-21','10:30:00',3.26),('15844','2014-04-21','10:35:00',3.35),('15844','2014-04-21','10:40:00',3.43),('15844','2014-04-21','10:45:00',3.52),('15844','2014-04-21','10:50:00',3.62),('15844','2014-04-21','10:55:00',3.72),('15844','2014-04-21','11:00:00',3.77),('15844','2014-04-21','11:05:00',3.81),('15844','2014-04-21','11:10:00',3.83),('15844','2014-04-21','11:15:00',3.84),('15844','2014-04-21','11:20:00',3.84),('15844','2014-04-21','11:25:00',3.9),('15844','2014-04-21','11:30:00',3.92),('15844','2014-04-21','11:35:00',3.94),('15844','2014-04-21','11:40:00',3.98),('15844','2014-04-21','11:45:00',3.97),('15844','2014-04-21','11:50:00',4.01),('15844','2014-04-21','11:55:00',3.99),('15844','2014-04-21','12:00:00',3.99),('15844','2014-04-21','12:05:00',4.01),('15844','2014-04-21','12:10:00',4.02),('15844','2014-04-21','12:15:00',4.03),('15844','2014-04-21','12:20:00',4.02),('15844','2014-04-21','12:25:00',4.01),('15844','2014-04-21','12:30:00',3.99),('15844','2014-04-21','12:35:00',4),('15844','2014-04-21','12:40:00',3.96),('15844','2014-04-21','12:45:00',3.94),('15844','2014-04-21','12:50:00',3.93),('15844','2014-04-21','12:55:00',3.92),('15844','2014-04-21','13:00:00',3.9),('15844','2014-04-21','13:05:00',3.88),('15844','2014-04-21','13:10:00',3.84),('15844','2014-04-21','13:15:00',3.82),('15844','2014-04-21','13:20:00',3.81),('15844','2014-04-21','13:25:00',3.78),('15844','2014-04-21','13:30:00',3.76),('15844','2014-04-21','13:35:00',3.74),('15844','2014-04-21','13:40:00',3.7),('15844','2014-04-21','13:45:00',3.66),('15844','2014-04-21','13:50:00',3.57),('15844','2014-04-21','13:55:00',3.52),('15844','2014-04-21','14:00:00',3.44),('15844','2014-04-21','14:05:00',3.37),('15844','2014-04-21','14:10:00',3.32),('15844','2014-04-21','14:15:00',3.25),('15844','2014-04-21','14:20:00',3.17),('15844','2014-04-21','14:25:00',3.08),('15844','2014-04-21','14:30:00',2.97),('15844','2014-04-21','14:35:00',2.88),('15844','2014-04-21','14:40:00',2.8),('15844','2014-04-21','14:45:00',2.73),('15844','2014-04-21','14:50:00',2.63),('15844','2014-04-21','14:55:00',2.54),('15844','2014-04-21','15:00:00',2.46),('15844','2014-04-21','15:05:00',2.37),('15844','2014-04-21','15:10:00',2.3),('15844','2014-04-21','15:15:00',2.21),('15844','2014-04-21','15:20:00',2.11),('15844','2014-04-21','15:25:00',2.03),('15844','2014-04-21','15:30:00',1.93),('15844','2014-04-21','15:35:00',1.83),('15844','2014-04-21','15:40:00',1.73),('15844','2014-04-21','15:45:00',1.62),('15844','2014-04-21','15:50:00',1.51),('15844','2014-04-21','15:55:00',1.39),('15844','2014-04-21','16:00:00',1.34),('15844','2014-04-21','16:05:00',1.28),('15844','2014-04-21','16:10:00',1.25),('15844','2014-04-21','16:15:00',1.2),('15844','2014-04-21','16:20:00',1.13),('15844','2014-04-21','16:25:00',1.05),('15844','2013-12-07','09:00:00',1.01),('15844','2013-12-07','09:05:00',1.07),('15844','2013-12-07','09:10:00',1.13),('15844','2013-12-07','09:15:00',1.17),('15844','2013-12-07','09:20:00',1.22),('15844','2013-12-07','09:25:00',1.26),('15844','2013-12-07','09:30:00',1.3),('15844','2013-12-07','09:35:00',1.35),('15844','2013-12-07','09:40:00',1.38),('15844','2013-12-07','09:45:00',1.41),('15844','2013-12-07','09:50:00',1.46),('15844','2013-12-07','09:55:00',1.5),('15844','2013-12-07','10:00:00',1.53),('15844','2013-12-07','10:05:00',1.56),('15844','2013-12-07','10:10:00',1.6),('15844','2013-12-07','10:15:00',1.64),('15844','2013-12-07','10:20:00',1.66),('15844','2013-12-07','10:25:00',1.67),('15844','2013-12-07','10:30:00',1.72),('15844','2013-12-07','10:35:00',1.75),('15844','2013-12-07','10:40:00',1.78),('15844','2013-12-07','10:45:00',1.83),('15844','2013-12-07','10:50:00',1.81),('15844','2013-12-07','10:55:00',1.82),('15844','2013-12-07','11:00:00',1.82),('15844','2013-12-07','11:05:00',1.8),('15844','2013-12-07','11:10:00',1.79),('15844','2013-12-07','11:15:00',1.81),('15844','2013-12-07','11:20:00',1.8),('15844','2013-12-07','11:25:00',1.78),('15844','2013-12-07','11:30:00',1.77),('15844','2013-12-07','11:35:00',1.75),('15844','2013-12-07','11:40:00',1.74),('15844','2013-12-07','11:45:00',1.71),('15844','2013-12-07','11:50:00',1.69),('15844','2013-12-07','11:55:00',1.63),('15844','2013-12-07','12:00:00',1.62),('15844','2013-12-07','12:05:00',1.61),('15844','2013-12-07','12:10:00',1.58),('15844','2013-12-07','12:15:00',1.55),('15844','2013-12-07','12:20:00',1.51),('15844','2013-12-07','12:25:00',1.48),('15844','2013-12-07','12:30:00',1.43),('15844','2013-12-07','12:35:00',1.39),('15844','2013-12-07','12:40:00',1.35),('15844','2013-12-07','12:45:00',1.3),('15844','2013-12-07','12:50:00',1.26),('15844','2013-12-07','12:55:00',1.23),('15844','2013-12-07','13:00:00',1.18),('15844','2013-12-07','13:05:00',1.12),('15844','2013-12-07','13:10:00',1.05),('15844','2013-12-07','13:15:00',1),('15844','2013-12-06','11:35:00',1.08),('15844','2013-12-06','11:50:00',1.25),('15844','2013-12-06','11:55:00',1.66),('15844','2013-12-06','12:00:00',1.04),('15844','2013-12-06','12:05:00',1.2),('15844','2013-12-06','12:10:00',1.55),('15844','2013-12-06','12:15:00',1.08),('15844','2013-12-06','12:20:00',1.29),('15844','2013-12-06','12:25:00',1.63),('15844','2013-12-06','12:30:00',1.29),('15844','2013-12-06','12:35:00',1.02),('15844','2013-12-05','08:55:00',1.04),('15844','2013-12-05','09:00:00',1.08),('15844','2013-12-05','09:05:00',1.15),('15844','2013-12-05','09:10:00',1.21),('15844','2013-12-05','09:15:00',1.27),('15844','2013-12-05','09:20:00',1.32),('15844','2013-12-05','09:25:00',1.37),('15844','2013-12-05','09:30:00',1.41),('15844','2013-12-05','09:35:00',1.44),('15844','2013-12-05','09:40:00',1.49),('15844','2013-12-05','09:45:00',1.51),('15844','2013-12-05','09:50:00',1.55),('15844','2013-12-05','09:55:00',1.6),('15844','2013-12-05','10:00:00',1.63),('15844','2013-12-05','10:05:00',1.67),('15844','2013-12-05','10:10:00',1.72),('15844','2013-12-05','10:15:00',1.73),('15844','2013-12-05','10:20:00',1.74),('15844','2013-12-05','10:25:00',1.79),('15844','2013-12-05','10:30:00',1.81),('15844','2013-12-05','10:35:00',1.83),('15844','2013-12-05','10:40:00',1.87),('15844','2013-12-05','10:45:00',1.87),('15844','2013-12-05','10:50:00',1.89),('15844','2013-12-05','10:55:00',1.87),('15844','2013-12-05','11:00:00',1.89),('15844','2013-12-05','11:05:00',1.93),('15844','2013-12-05','11:10:00',1.88),('15844','2013-12-05','11:15:00',1.91),('15844','2013-12-05','11:20:00',1.85),('15844','2013-12-05','11:25:00',1.88),('15844','2013-12-05','11:30:00',1.85),('15844','2013-12-05','11:35:00',1.84),('15844','2013-12-05','11:40:00',1.79),('15844','2013-12-05','11:45:00',1.76),('15844','2013-12-05','11:50:00',1.78),('15844','2013-12-05','11:55:00',1.75),('15844','2013-12-05','12:00:00',1.73),('15844','2013-12-05','12:05:00',1.68),('15844','2013-12-05','12:10:00',1.66),('15844','2013-12-05','12:15:00',1.56),('15844','2013-12-05','12:20:00',1.6),('15844','2013-12-05','12:25:00',1.46),('15844','2013-12-05','12:30:00',1.52),('15844','2013-12-05','12:35:00',1.46),('15844','2013-12-05','12:40:00',1.17),('15844','2013-12-05','12:45:00',1.3),('15844','2013-12-05','12:50:00',1.31),('15844','2013-12-05','12:55:00',1.23),('15844','2013-12-05','13:00:00',1.17),('15844','2013-12-05','13:05:00',1.11),('15844','2013-12-05','13:10:00',1.08),('15844','2013-12-04','08:45:00',1.04),('15844','2013-12-04','08:50:00',1.09),('15844','2013-12-04','08:55:00',1.15),('15844','2013-12-04','09:00:00',1.22),('15844','2013-12-04','09:05:00',1.27),('15844','2013-12-04','09:10:00',1.32),('15844','2013-12-04','09:15:00',1.38),('15844','2013-12-04','09:20:00',1.43),('15844','2013-12-04','09:25:00',1.48),('15844','2013-12-04','09:30:00',1.51),('15844','2013-12-04','09:35:00',1.56),('15844','2013-12-04','09:40:00',1.6),('15844','2013-12-04','09:45:00',1.64),('15844','2013-12-04','09:50:00',1.69),('15844','2013-12-04','09:55:00',1.74),('15844','2013-12-04','10:00:00',1.78),('15844','2013-12-04','10:05:00',1.8),('15844','2013-12-04','10:10:00',1.84),('15844','2013-12-04','10:15:00',1.86),('15844','2013-12-04','10:20:00',1.88),('15844','2013-12-04','10:25:00',1.91),('15844','2013-12-04','10:30:00',1.96),('15844','2013-12-04','10:35:00',1.97),('15844','2013-12-04','10:40:00',2.01),('15844','2013-12-04','10:45:00',2.03),('15844','2013-12-04','10:50:00',2.03),('15844','2013-12-04','10:55:00',2.04),('15844','2013-12-04','11:00:00',2.04),('15844','2013-12-04','11:05:00',2.02),('15844','2013-12-04','11:10:00',2.02),('15844','2013-12-04','11:15:00',2.02),('15844','2013-12-04','11:20:00',2.02),('15844','2013-12-04','11:25:00',1.99),('15844','2013-12-04','11:30:00',1.98),('15844','2013-12-04','11:35:00',1.96),('15844','2013-12-04','11:40:00',1.93),('15844','2013-12-04','11:45:00',1.91),('15844','2013-12-04','11:50:00',1.89),('15844','2013-12-04','11:55:00',1.86),('15844','2013-12-04','12:00:00',1.83),('15844','2013-12-04','12:05:00',1.81),('15844','2013-12-04','12:10:00',1.78),('15844','2013-12-04','12:15:00',1.75),('15844','2013-12-04','12:20:00',1.7),('15844','2013-12-04','12:25:00',1.66),('15844','2013-12-04','12:30:00',1.61),('15844','2013-12-04','12:35:00',1.55),('15844','2013-12-04','12:40:00',1.48),('15844','2013-12-04','12:45:00',1.43),('15844','2013-12-04','12:50:00',1.38),('15844','2013-12-04','12:55:00',1.3),('15844','2013-12-04','13:00:00',1.24),('15844','2013-12-04','13:05:00',1.18),('15844','2013-12-04','13:10:00',1.12),('15844','2013-12-04','13:15:00',1.05),('15844','2013-12-04','13:20:00',1.01),('15844','2013-12-03','09:30:00',1.08),('15844','2013-12-03','09:35:00',1.27),('15844','2013-12-03','09:40:00',1.37),('15844','2013-12-03','09:45:00',1.34),('15844','2013-12-03','09:50:00',1.67),('15844','2013-12-03','09:55:00',1.7),('15844','2013-12-03','10:00:00',1.73),('15844','2013-12-03','10:05:00',1.74),('15844','2013-12-03','10:10:00',1.79),('15844','2013-12-03','10:15:00',1.82),('15844','2013-12-03','10:20:00',1.85),('15844','2013-12-03','10:25:00',1.9),('15844','2013-12-03','10:30:00',1.94),('15844','2013-12-03','10:35:00',1.97),('15844','2013-12-03','10:40:00',1.98),('15844','2013-12-03','10:45:00',2.01),('15844','2013-12-03','10:50:00',2.04),('15844','2013-12-03','10:55:00',2.04),('15844','2013-12-03','11:00:00',2.04),('15844','2013-12-03','11:05:00',2.06),('15844','2013-12-03','11:10:00',2.05),('15844','2013-12-03','11:15:00',2.04),('15844','2013-12-03','11:20:00',2.02),('15844','2013-12-03','11:25:00',2.03),('15844','2013-12-03','11:30:00',2.02),('15844','2013-12-03','11:35:00',2.01),('15844','2013-12-03','11:40:00',1.99),('15844','2013-12-03','11:45:00',1.97),('15844','2013-12-03','11:50:00',1.94),('15844','2013-12-03','11:55:00',1.93),('15844','2013-12-03','12:00:00',1.91),('15844','2013-12-03','12:05:00',1.9),('15844','2013-12-03','12:10:00',1.88),('15844','2013-12-03','12:15:00',1.86),('15844','2013-12-03','12:20:00',1.83),('15844','2013-12-03','12:25:00',1.8),('15844','2013-12-03','12:30:00',1.79),('15844','2013-12-03','12:35:00',1.78),('15844','2013-12-03','12:40:00',1.78),('15844','2013-12-03','12:45:00',1.78),('15844','2013-12-03','12:50:00',1.78),('15844','2013-12-03','12:55:00',1.82),('15844','2013-12-03','13:00:00',1.83),('15844','2013-12-03','13:05:00',1.81),('15844','2013-12-03','13:10:00',1.73),('15844','2013-12-03','13:15:00',1.64),('15844','2013-12-03','13:20:00',1.53),('15844','2013-12-03','13:25:00',1.32),('15844','2013-12-03','13:30:00',1.07),('15844','2013-12-01','11:35:00',1.23),('15844','2013-12-01','11:40:00',1.39),('15844','2013-12-01','11:45:00',1.16),('15844','2013-12-01','11:50:00',1.04),('15844','2013-12-01','11:55:00',1.33),('15844','2013-12-01','12:00:00',1.36),('15844','2013-12-01','12:05:00',1.29),('15844','2013-12-01','12:10:00',1.49),('15844','2013-12-01','12:15:00',1.08),('15844','2013-12-01','12:50:00',1.08),('15844','2013-11-30','09:10:00',1.22),('15844','2013-11-30','09:15:00',1.21),('15844','2013-11-30','09:20:00',1.4),('15844','2013-11-30','09:25:00',1.34),('15844','2013-11-30','09:30:00',1.49),('15844','2013-11-30','09:35:00',1.47),('15844','2013-11-30','09:40:00',1.39),('15844','2013-11-30','09:45:00',1.11),('15844','2013-11-30','09:50:00',1.06),('15844','2013-11-30','10:25:00',1),('15844','2013-11-30','10:40:00',1.19),('15844','2013-11-30','11:10:00',1.05),('15844','2013-11-30','11:15:00',1.05),('15844','2013-11-30','11:20:00',1.03),('15844','2013-11-30','11:25:00',1.07),('15844','2013-11-29','08:40:00',1.02),('15844','2013-11-29','08:45:00',1.07),('15844','2013-11-29','08:50:00',1.14),('15844','2013-11-29','08:55:00',1.18),('15844','2013-11-29','09:00:00',1.24),('15844','2013-11-29','09:05:00',1.31),('15844','2013-11-29','09:10:00',1.36),('15844','2013-11-29','09:15:00',1.42),('15844','2013-11-29','09:20:00',1.48),('15844','2013-11-29','09:25:00',1.53),('15844','2013-11-29','09:30:00',1.58),('15844','2013-11-29','09:35:00',1.62),('15844','2013-11-29','09:40:00',1.67),('15844','2013-11-29','09:45:00',1.72),('15844','2013-11-29','09:50:00',1.76),('15844','2013-11-29','09:55:00',1.79),('15844','2013-11-29','10:00:00',1.84),('15844','2013-11-29','10:05:00',1.87),('15844','2013-11-29','10:10:00',1.9),('15844','2013-11-29','10:15:00',1.93),('15844','2013-11-29','10:20:00',1.98),('15844','2013-11-29','10:25:00',2.01),('15844','2013-11-29','10:30:00',2.05),('15844','2013-11-29','10:35:00',2.07),('15844','2013-11-29','10:40:00',2.09),('15844','2013-11-29','10:45:00',2.11),('15844','2013-11-29','10:50:00',2.12),('15844','2013-11-29','10:55:00',2.11),('15844','2013-11-29','11:00:00',2.12),('15844','2013-11-29','11:05:00',2.12),('15844','2013-11-29','11:10:00',2.1),('15844','2013-11-29','11:15:00',2.09),('15844','2013-11-29','11:20:00',2.1),('15844','2013-11-29','11:25:00',2.08),('15844','2013-11-29','11:30:00',2.06),('15844','2013-11-29','11:35:00',2.05),('15844','2013-11-29','11:40:00',2.03),('15844','2013-11-29','11:45:00',2.02),('15844','2013-11-29','11:50:00',1.99),('15844','2013-11-29','11:55:00',1.96),('15844','2013-11-29','12:00:00',1.93),('15844','2013-11-29','12:05:00',1.9),('15844','2013-11-29','12:10:00',1.87),('15844','2013-11-29','12:15:00',1.81),('15844','2013-11-29','12:20:00',1.77),('15844','2013-11-29','12:25:00',1.71),('15844','2013-11-29','12:30:00',1.65),('15844','2013-11-29','12:35:00',1.61),('15844','2013-11-29','12:40:00',1.55),('15844','2013-11-29','12:45:00',1.48),('15844','2013-11-29','12:50:00',1.41),('15844','2013-11-29','12:55:00',1.35),('15844','2013-11-29','13:00:00',1.29),('15844','2013-11-29','13:05:00',1.24),('15844','2013-11-29','13:10:00',1.18),('15844','2013-11-29','13:15:00',1.11),('15844','2013-11-29','13:20:00',1.06),('15844','2014-04-20','08:20:00',1.2),('15844','2014-04-20','08:25:00',1.35),('15844','2014-04-20','08:30:00',1.43),('15844','2014-04-20','08:50:00',1.09),('15844','2014-04-20','08:55:00',1.56),('15844','2014-04-20','09:00:00',1.18),('15844','2014-04-20','09:10:00',1.92),('15844','2014-04-20','09:15:00',1.85),('15844','2014-04-20','09:20:00',1.81),('15844','2014-04-20','09:25:00',2.26),('15844','2014-04-20','09:30:00',2.42),('15844','2014-04-20','09:35:00',2.93),('15844','2014-04-20','09:40:00',2.21),('15844','2014-04-20','09:45:00',1.78),('15844','2014-04-20','09:50:00',1.53),('15844','2014-04-20','09:55:00',1.81),('15844','2014-04-20','10:00:00',1.94),('15844','2014-04-20','10:05:00',2.3),('15844','2014-04-20','10:10:00',1.7),('15844','2014-04-20','10:15:00',2.49),('15844','2014-04-20','10:20:00',3.03),('15844','2014-04-20','10:25:00',2.61),('15844','2014-04-20','10:30:00',2.34),('15844','2014-04-20','10:35:00',2.55),('15844','2014-04-20','10:40:00',2.37),('15844','2014-04-20','10:45:00',2.43),('15844','2014-04-20','10:50:00',2.66),('15844','2014-04-20','10:55:00',3.3),('15844','2014-04-20','11:00:00',3.14),('15844','2014-04-20','11:05:00',3.37),('15844','2014-04-20','11:10:00',3.82),('15844','2014-04-20','11:15:00',4.12),('15844','2014-04-20','11:20:00',4.26),('15844','2014-04-20','11:25:00',4.15),('15844','2014-04-20','11:30:00',4.42),('15844','2014-04-20','11:35:00',4.24),('15844','2014-04-20','11:40:00',4.24),('15844','2014-04-20','11:45:00',4.26),('15844','2014-04-20','11:50:00',4.15),('15844','2014-04-20','11:55:00',4.23),('15844','2014-04-20','12:00:00',4.2),('15844','2014-04-20','12:05:00',4.23),('15844','2014-04-20','12:10:00',4.18),('15844','2014-04-20','12:15:00',4.22),('15844','2014-04-20','12:20:00',4.21),('15844','2014-04-20','12:25:00',4.28),('15844','2014-04-20','12:30:00',4.21),('15844','2014-04-20','12:35:00',4.25),('15844','2014-04-20','12:40:00',2.69),('15844','2014-04-20','12:45:00',4.21),('15844','2014-04-20','12:50:00',4.18),('15844','2014-04-20','12:55:00',3.95),('15844','2014-04-20','13:00:00',4.04),('15844','2014-04-20','13:05:00',4.06),('15844','2014-04-20','13:10:00',3.46),('15844','2014-04-20','13:15:00',3.98),('15844','2014-04-20','13:20:00',3.94),('15844','2014-04-20','13:25:00',3.88),('15844','2014-04-20','13:30:00',3.86),('15844','2014-04-20','13:35:00',3.81),('15844','2014-04-20','13:40:00',3.78),('15844','2014-04-20','13:45:00',3.7),('15844','2014-04-20','13:50:00',3.6),('15844','2014-04-20','13:55:00',3.53),('15844','2014-04-20','14:00:00',3.48),('15844','2014-04-20','14:05:00',3.47),('15844','2014-04-20','14:10:00',3.47),('15844','2014-04-20','14:15:00',3.07),('15844','2014-04-20','14:20:00',2.15),('15844','2014-04-20','14:25:00',2.27),('15844','2014-04-20','14:30:00',2.07),('15844','2014-04-20','14:35:00',1.92),('15844','2014-04-20','14:40:00',1.96),('15844','2014-04-20','14:45:00',2.08),('15844','2014-04-20','14:50:00',2.22),('15844','2014-04-20','14:55:00',2.45),('15844','2014-04-20','15:00:00',3.26),('15844','2014-04-20','15:05:00',2.69),('15844','2014-04-20','15:10:00',1.93),('15844','2014-04-20','15:15:00',2.28),('15844','2014-04-20','15:20:00',2.15),('15844','2014-04-20','15:25:00',2.05),('15844','2014-04-20','15:30:00',1.97),('15844','2014-04-20','15:35:00',1.9),('15844','2014-04-20','15:40:00',1.82),('15844','2014-04-20','15:45:00',1.09),('15844','2014-04-20','15:50:00',1.67),('15844','2014-04-20','15:55:00',1.35),('15844','2014-04-20','16:00:00',1.25),('15844','2014-04-20','16:05:00',1.18),('15844','2014-04-20','16:10:00',1.21),('15844','2014-04-20','16:15:00',1.2),('15844','2014-04-20','16:20:00',1.09),('15844','2014-04-20','16:25:00',1.1),('15844','2013-11-27','09:55:00',1.03),('15844','2013-11-27','10:05:00',1.02),('15844','2013-11-27','10:15:00',1.02),('15844','2013-11-27','10:20:00',1.01),('15844','2013-11-27','10:35:00',1),('15844','2013-11-27','10:40:00',1.01),('15844','2013-11-27','10:45:00',1.01),('15844','2013-11-27','11:00:00',1.11),('15844','2013-11-27','11:05:00',1.14),('15844','2013-11-27','11:10:00',1.12),('15844','2013-11-27','11:15:00',1.14),('15844','2013-11-27','11:20:00',1.1),('15844','2013-11-27','11:25:00',1.19),('15844','2013-11-27','11:30:00',1.29),('15844','2013-11-27','11:35:00',1.48),('15844','2013-11-27','11:40:00',1.47),('15844','2013-11-27','11:45:00',2.34),('15844','2013-11-27','11:50:00',2.13),('15844','2013-11-27','11:55:00',2.13),('15844','2013-11-27','12:00:00',1.76),('15844','2013-11-27','12:05:00',1.43),('15844','2013-11-27','12:10:00',1.36),('15844','2013-11-27','12:15:00',1.22),('15844','2013-11-27','12:20:00',1.21),('15844','2013-11-27','12:25:00',1.17),('15844','2013-11-27','12:30:00',1.13),('15844','2013-11-23','10:20:00',1.06),('15844','2013-11-23','10:25:00',1.46),('15844','2013-11-23','10:30:00',2.09),('15844','2013-11-23','10:35:00',1.98),('15844','2013-11-21','08:10:00',1.03),('15844','2013-11-21','09:45:00',1.48),('15844','2013-11-21','09:50:00',1.24),('15844','2013-11-21','09:55:00',1.87),('15844','2013-11-21','10:00:00',1.02),('15844','2013-11-21','10:05:00',2.03),('15844','2013-11-21','10:10:00',1.77),('15844','2013-11-21','10:15:00',1.5),('15844','2013-11-21','10:20:00',1.16),('15844','2013-11-21','10:25:00',2.24),('15844','2013-11-21','10:30:00',2.27),('15844','2013-11-21','10:35:00',2.3),('15844','2013-11-21','10:40:00',1.15),('15844','2013-11-21','11:00:00',1.11),('15844','2013-11-21','11:15:00',1.8),('15844','2013-11-21','11:20:00',2.22),('15844','2013-11-21','11:25:00',1.83),('15844','2013-11-21','11:30:00',1),('15844','2013-11-21','11:35:00',2.07),('15844','2013-11-21','11:40:00',2.07),('15844','2013-11-21','11:45:00',2.05),('15844','2013-11-21','11:50:00',2.03),('15844','2013-11-21','11:55:00',1.99),('15844','2013-11-21','12:00:00',2),('15844','2013-11-21','12:05:00',1.98),('15844','2013-11-21','12:10:00',1.95),('15844','2013-11-21','12:15:00',1.88),('15844','2013-11-21','12:20:00',1.66),('15844','2013-11-21','12:25:00',1.89),('15844','2013-11-21','12:30:00',2.03),('15844','2013-11-21','12:35:00',1.65),('15844','2013-11-21','12:40:00',2.24),('15844','2013-11-21','12:45:00',1.98),('15844','2013-11-21','12:50:00',1.09),('15844','2013-11-21','12:55:00',1.46),('15844','2013-11-20','08:55:00',1.22),('15844','2013-11-20','09:00:00',1.44),('15844','2013-11-20','09:05:00',1.48),('15844','2013-11-20','09:10:00',1.32),('15844','2013-11-20','09:15:00',1.69),('15844','2013-11-20','09:20:00',1.07),('15844','2013-11-20','11:20:00',1.07),('15844','2013-11-20','11:25:00',1.7),('15844','2013-11-20','11:30:00',1.6),('15844','2013-11-20','12:15:00',1.69),('15844','2013-11-20','12:20:00',1.62),('15844','2013-11-20','12:40:00',1.35),('15844','2013-11-20','12:45:00',1.16),('15844','2013-11-20','12:55:00',1.05),('15844','2013-11-20','13:00:00',1.4),('15844','2013-11-20','13:20:00',1.14),('15844','2013-11-20','13:25:00',1.02),('15844','2013-11-20','13:30:00',1.1),('15844','2013-11-19','09:35:00',1.81),('15844','2013-11-19','09:40:00',1.7),('15844','2013-11-19','09:45:00',1.83),('15844','2013-11-19','09:50:00',1.54),('15844','2013-11-19','09:55:00',1.59),('15844','2013-11-19','10:00:00',1.86),('15844','2013-11-19','10:05:00',1.93),('15844','2013-11-19','10:10:00',1.72),('15844','2013-11-19','11:15:00',1.3),('15844','2013-11-19','11:20:00',1.22),('15844','2013-11-19','11:30:00',1.93),('15844','2013-11-19','11:35:00',1.67),('15844','2013-11-19','11:40:00',1.57),('15844','2013-11-19','11:45:00',2.02),('15844','2013-11-19','11:50:00',1.95),('15844','2013-11-19','11:55:00',1.88),('15844','2013-11-19','12:00:00',1.93),('15844','2013-11-19','12:05:00',1.86),('15844','2013-11-19','12:10:00',1.81),('15844','2013-11-19','12:15:00',1.82),('15844','2013-11-19','12:20:00',1.41),('15844','2013-11-19','12:35:00',1.62),('15844','2013-11-19','12:40:00',1.69),('15844','2013-11-19','12:50:00',1.63),('15844','2013-11-19','13:30:00',1.37),('15844','2013-11-18','09:15:00',1.08),('15844','2013-11-18','09:20:00',1.45),('15844','2013-11-18','09:25:00',1.33),('15844','2013-11-18','09:30:00',1.7),('15844','2013-11-18','09:35:00',1.63),('15844','2013-11-18','10:00:00',1.02),('15844','2013-11-18','10:05:00',1.34),('15844','2013-11-18','10:10:00',1.42),('15844','2013-11-18','10:15:00',1.38),('15844','2013-11-18','10:20:00',1.1),('15844','2013-11-18','10:35:00',1.02),('15844','2013-11-18','10:40:00',1.08),('15844','2013-11-18','10:45:00',1.11),('15844','2013-11-18','11:50:00',1.05),('15844','2013-11-18','11:55:00',1.13),('15844','2013-11-18','12:00:00',1.15),('15844','2013-11-18','12:05:00',1.14),('15844','2013-11-18','12:10:00',1.13),('15844','2013-11-18','12:15:00',1.21),('15844','2013-11-18','12:20:00',1.34),('15844','2013-11-18','12:25:00',1.33),('15844','2013-11-18','12:30:00',1.23),('15844','2013-11-18','12:35:00',1.07),('15844','2014-04-19','08:15:00',1.03),('15844','2014-04-19','08:20:00',1.17),('15844','2014-04-19','08:25:00',1.19),('15844','2014-04-19','08:30:00',1.02),('15844','2014-04-19','08:35:00',1.22),('15844','2014-04-19','08:40:00',1.3),('15844','2014-04-19','09:20:00',1.17),('15844','2014-04-19','09:25:00',1.4),('15844','2014-04-19','09:30:00',1.03),('15844','2014-04-19','10:30:00',1.11),('15844','2014-04-19','10:35:00',1.39),('15844','2014-04-19','10:40:00',1.43),('15844','2014-04-19','10:45:00',1.45),('15844','2014-04-19','10:50:00',1.8),('15844','2014-04-19','10:55:00',1.88),('15844','2014-04-19','11:00:00',1.15),('15844','2014-04-19','11:05:00',1.36),('15844','2014-04-19','11:10:00',1.9),('15844','2014-04-19','11:15:00',2.61),('15844','2014-04-19','11:20:00',4.1),('15844','2014-04-19','11:25:00',4.97),('15844','2014-04-19','11:30:00',2.31),('15844','2014-04-19','11:35:00',2.71),('15844','2014-04-19','11:40:00',2.1),('15844','2014-04-19','11:45:00',1.47),('15844','2014-04-19','13:10:00',1.2),('15844','2014-04-19','13:15:00',1.19),('15844','2014-04-19','14:30:00',1.29),('15844','2014-04-19','14:35:00',1.35),('15844','2014-04-19','14:40:00',1.7),('15844','2014-04-19','14:45:00',1.3),('15844','2014-04-19','15:00:00',1.82),('15844','2014-04-19','15:25:00',1.24),('15844','2014-04-19','15:40:00',1.62),('15844','2014-04-19','15:45:00',1.69),('15844','2014-04-19','15:50:00',1.62),('15844','2014-04-19','15:55:00',1.94),('15844','2014-04-19','16:00:00',1.45),('15844','2014-04-19','16:05:00',1.22),('15844','2014-04-19','16:10:00',1.36),('15844','2014-04-19','16:15:00',1.64),('15844','2014-04-19','16:20:00',1.59),('15844','2014-04-19','16:25:00',1.83),('15844','2014-04-19','16:30:00',1.32),('15844','2014-04-19','17:05:00',1.11),('15844','2014-04-19','17:15:00',1.12),('15844','2013-11-17','08:50:00',1.01),('15844','2013-11-17','09:00:00',1.19),('15844','2013-11-17','09:05:00',1.46),('15844','2013-11-17','09:10:00',1.8),('15844','2013-11-17','09:15:00',1.67),('15844','2013-11-17','09:30:00',1.06),('15844','2013-11-17','09:35:00',1.67),('15844','2013-11-17','09:40:00',2.03),('15844','2013-11-17','09:45:00',1.93),('15844','2013-11-17','09:50:00',1.92),('15844','2013-11-17','09:55:00',1.95),('15844','2013-11-17','10:00:00',1.99),('15844','2013-11-17','10:05:00',2.01),('15844','2013-11-17','10:10:00',2.02),('15844','2013-11-17','10:15:00',2.07),('15844','2013-11-17','10:20:00',2.11),('15844','2013-11-17','10:25:00',2.13),('15844','2013-11-17','10:30:00',2.15),('15844','2013-11-17','10:35:00',2.15),('15844','2013-11-17','10:40:00',2.17),('15844','2013-11-17','10:45:00',2.18),('15844','2013-11-17','10:50:00',2.18),('15844','2013-11-17','10:55:00',2.17),('15844','2013-11-17','11:00:00',2.18),('15844','2013-11-17','11:05:00',2.15),('15844','2013-11-17','11:10:00',2.15),('15844','2013-11-17','11:15:00',2.15),('15844','2013-11-17','11:20:00',2.14),('15844','2013-11-17','11:25:00',2.13),('15844','2013-11-17','11:30:00',2.1),('15844','2013-11-17','11:35:00',2.07),('15844','2013-11-17','11:40:00',2.06),('15844','2013-11-17','11:45:00',2.04),('15844','2013-11-17','11:50:00',2.02),('15844','2013-11-17','11:55:00',1.98),('15844','2013-11-17','12:00:00',1.94),('15844','2013-11-17','12:05:00',1.91),('15844','2013-11-17','12:10:00',1.88),('15844','2013-11-17','12:15:00',1.84),('15844','2013-11-17','12:20:00',1.8),('15844','2013-11-17','12:25:00',1.74),('15844','2013-11-17','12:30:00',1.67),('15844','2013-11-17','12:35:00',1.62),('15844','2013-11-17','12:40:00',1.54),('15844','2013-11-17','12:45:00',1.5),('15844','2013-11-17','12:50:00',1.42),('15844','2013-11-17','12:55:00',1.35),('15844','2013-11-17','13:00:00',1.28),('15844','2013-11-17','13:05:00',1.21),('15844','2013-11-17','13:10:00',1.15),('15844','2013-11-17','13:15:00',1.11),('15844','2013-11-17','13:20:00',1.1),('15844','2013-11-17','13:25:00',1.08),('15844','2013-11-17','13:30:00',1.02),('15844','2013-11-16','13:05:00',1.01),('15844','2013-11-15','09:10:00',1.08),('15844','2013-11-15','09:45:00',1.06),('15844','2013-11-15','10:15:00',1.22),('15844','2013-11-15','10:20:00',1.17),('15844','2013-11-15','11:05:00',1.04),('15844','2013-11-15','11:10:00',1.11),('15844','2013-11-15','11:15:00',1.11),('15844','2013-11-15','11:30:00',1.3),('15844','2013-11-15','11:35:00',1.36),('15844','2013-11-15','11:40:00',1.33),('15844','2013-11-15','11:45:00',1.33),('15844','2013-11-15','11:50:00',1.08),('15844','2013-11-15','12:00:00',1.03),('15844','2013-11-14','08:45:00',1.26),('15844','2013-11-14','08:50:00',1.05),('15844','2013-11-14','08:55:00',1.39),('15844','2013-11-14','09:00:00',1.46),('15844','2013-11-14','09:05:00',1.3),('15844','2013-11-14','09:10:00',1.35),('15844','2013-11-14','09:15:00',1.63),('15844','2013-11-14','09:20:00',1.7),('15844','2013-11-14','09:25:00',1.7),('15844','2013-11-14','09:30:00',1.76),('15844','2013-11-14','09:35:00',1.81),('15844','2013-11-14','09:40:00',1.82),('15844','2013-11-14','09:45:00',1.86),('15844','2013-11-14','09:50:00',1.89),('15844','2013-11-14','09:55:00',1.87),('15844','2013-11-14','10:00:00',1.9),('15844','2013-11-14','10:05:00',1.96),('15844','2013-11-14','10:10:00',2.01),('15844','2013-11-14','10:15:00',1.99),('15844','2013-11-14','10:20:00',2.01),('15844','2013-11-14','10:25:00',2.01),('15844','2013-11-14','10:30:00',1.86),('15844','2013-11-14','10:35:00',2.04),('15844','2013-11-14','10:40:00',2.14),('15844','2013-11-14','10:45:00',2.17),('15844','2013-11-14','10:50:00',2.17),('15844','2013-11-14','10:55:00',2.22),('15844','2013-11-14','11:00:00',2.2),('15844','2013-11-14','11:05:00',2.23),('15844','2013-11-14','11:10:00',2.31),('15844','2013-11-14','11:15:00',2.2),('15844','2013-11-14','11:20:00',1.78),('15844','2013-11-14','11:25:00',2.03),('15844','2013-11-14','11:30:00',2.29),('15844','2013-11-14','11:35:00',1.99),('15844','2013-11-14','11:40:00',1.78),('15844','2013-11-14','11:45:00',1.79),('15844','2013-11-14','11:50:00',2.17),('15844','2013-11-14','11:55:00',2.71),('15844','2013-11-14','12:00:00',2.67),('15844','2013-11-14','12:05:00',1.12),('15844','2013-11-14','12:10:00',1.03),('15844','2013-11-14','12:15:00',1.06),('15844','2013-11-14','12:20:00',1),('15844','2013-11-14','12:35:00',1.08),('15844','2013-11-14','12:40:00',1.07),('15844','2013-11-14','12:45:00',1.03),('15844','2013-11-14','13:20:00',1.3),('15844','2013-11-14','13:25:00',1.36),('15844','2013-11-14','13:30:00',1.61),('15844','2013-11-14','13:40:00',1.17),('15844','2013-11-14','13:55:00',1.12),('15844','2013-11-13','10:05:00',1.41),('15844','2013-11-13','10:10:00',1.77),('15844','2013-11-13','10:15:00',1.15),('15844','2013-11-13','10:25:00',1.1),('15844','2013-11-13','11:10:00',2.32),('15844','2013-11-13','11:15:00',3.03),('15844','2013-11-13','11:20:00',2.37),('15844','2013-11-13','11:25:00',1.21),('15844','2013-11-13','12:00:00',1.16),('15844','2013-11-13','12:05:00',1.02),('15844','2013-11-12','11:25:00',1),('15844','2013-11-12','11:40:00',1.99),('15844','2013-11-12','11:45:00',1.38),('15844','2013-11-12','11:50:00',1.34),('15844','2013-11-12','12:00:00',1.39),('15844','2013-11-12','12:05:00',1.79),('15844','2013-11-12','12:30:00',1.69),('15844','2013-11-12','12:35:00',2.22),('15844','2013-11-12','12:40:00',1.61),('15844','2013-11-12','12:45:00',1.6),('15844','2013-11-12','12:50:00',1.38),('15844','2013-11-12','12:55:00',1.38),('15844','2013-11-12','13:00:00',1.35),('15844','2013-11-12','13:05:00',1.23),('15844','2013-11-12','13:10:00',1.14),('15844','2013-11-12','13:15:00',1.18),('15844','2013-11-12','13:20:00',1.21),('15844','2013-11-12','13:25:00',1.24),('15844','2013-11-12','13:30:00',1.46),('15844','2013-11-12','13:35:00',1.71),('15844','2013-11-12','13:40:00',1.7),('15844','2013-11-12','13:45:00',1.75),('15844','2013-11-12','13:50:00',1.39),('15844','2013-11-12','13:55:00',1.18),('15844','2013-11-12','14:00:00',1.54),('15844','2013-11-12','14:05:00',1.36),('15844','2013-11-12','14:10:00',1.23),('15844','2013-11-11','10:35:00',1.24),('15844','2013-11-11','11:10:00',2.56),('15844','2013-11-11','11:15:00',2.17),('15844','2013-11-11','11:20:00',2.35),('15844','2013-11-11','11:25:00',2.38),('15844','2013-11-11','11:30:00',1.07),('15844','2013-11-11','11:35:00',1.3),('15844','2013-11-11','11:40:00',1.93),('15844','2013-11-11','11:45:00',2.66),('15844','2013-11-11','11:50:00',1.28),('15844','2013-11-11','11:55:00',1.3),('15844','2013-11-11','12:00:00',2.7),('15844','2013-11-11','12:05:00',2.55),('15844','2013-11-11','12:10:00',2.39),('15844','2013-11-11','12:15:00',2.2),('15844','2013-11-11','12:20:00',1.98),('15844','2013-11-11','12:25:00',2.18),('15844','2013-11-11','12:30:00',2.15),('15844','2013-11-11','12:35:00',2.06),('15844','2013-11-11','12:40:00',1.4),('15844','2013-11-11','12:45:00',1.15),('15844','2013-11-11','12:50:00',1.75),('15844','2013-11-11','12:55:00',1.65),('15844','2013-11-11','13:10:00',1.15),('15844','2013-11-11','13:15:00',1.07),('15844','2013-11-10','07:55:00',1.09),('15844','2013-11-10','08:35:00',1.31),('15844','2013-11-10','08:40:00',1.01),('15844','2013-11-10','08:45:00',1.29),('15844','2013-11-10','08:50:00',1.15),('15844','2013-11-10','08:55:00',1.61),('15844','2013-11-10','09:00:00',1.53),('15844','2013-11-10','09:05:00',1.16),('15844','2013-11-10','09:10:00',1.29),('15844','2013-11-10','09:15:00',1.55),('15844','2013-11-10','09:20:00',1.76),('15844','2013-11-10','09:25:00',1.89),('15844','2013-11-10','09:30:00',1.69),('15844','2013-11-10','09:35:00',1.79),('15844','2013-11-10','09:40:00',1.86),('15844','2013-11-10','09:45:00',1.97),('15844','2013-11-10','09:50:00',2.19),('15844','2013-11-10','09:55:00',1.86),('15844','2013-11-10','10:00:00',2.16),('15844','2013-11-10','10:05:00',2.23),('15844','2013-11-10','10:10:00',1.95),('15844','2013-11-10','10:15:00',1.54),('15844','2013-11-10','10:20:00',1.32),('15844','2013-11-10','10:25:00',1.86),('15844','2013-11-10','10:30:00',2.33),('15844','2013-11-10','10:35:00',2.3),('15844','2013-11-10','10:40:00',2.09),('15844','2013-11-10','10:45:00',1.07),('15844','2013-11-10','10:50:00',1.81),('15844','2013-11-10','10:55:00',1.47),('15844','2013-11-10','11:00:00',1.15),('15844','2013-11-10','11:15:00',1.47),('15844','2013-11-10','11:20:00',1.18),('15844','2013-11-10','11:25:00',1.38),('15844','2013-11-10','11:30:00',1.05),('15844','2013-11-10','11:35:00',1.78),('15844','2013-11-10','11:40:00',1),('15844','2013-11-10','11:50:00',1.14),('15844','2013-11-10','12:00:00',2.35),('15844','2013-11-10','12:05:00',2.17),('15844','2013-11-10','12:10:00',2.11),('15844','2013-11-10','12:15:00',2.13),('15844','2013-11-10','12:20:00',2.47),('15844','2013-11-10','12:25:00',1.21),('15844','2013-11-10','12:30:00',2.22),('15844','2013-11-10','12:35:00',2),('15844','2013-11-10','12:40:00',1.74),('15844','2013-11-10','12:45:00',1.54),('15844','2013-11-10','12:55:00',1.15),('15844','2013-11-10','13:00:00',1.3),('15844','2013-11-10','13:05:00',1.09),('15844','2013-11-10','13:40:00',1.03),('15844','2013-11-10','13:50:00',1.04),('15844','2013-11-09','09:35:00',1.43),('15844','2013-11-09','09:40:00',1.46),('15844','2013-11-09','09:45:00',1.7),('15844','2013-11-09','09:50:00',2.11),('15844','2013-11-09','09:55:00',2.55),('15844','2013-11-09','10:00:00',1.87),('15844','2013-11-09','10:05:00',1.2),('15844','2013-11-09','10:10:00',1.36),('15844','2013-11-09','10:15:00',1.56),('15844','2013-11-09','10:20:00',1.91),('15844','2013-11-09','10:35:00',1.15),('15844','2013-11-09','10:40:00',1.1),('15844','2013-11-09','10:45:00',1.1),('15844','2013-11-09','10:50:00',1.65),('15844','2013-11-09','10:55:00',2.19),('15844','2013-11-09','11:00:00',1.26),('15844','2013-11-09','11:05:00',1.04),('15844','2013-11-09','11:10:00',1.5),('15844','2013-11-09','11:15:00',1.09),('15844','2013-11-09','11:25:00',2.97),('15844','2013-11-09','11:30:00',2.61),('15844','2013-11-09','11:35:00',2.28),('15844','2013-11-09','11:40:00',2.53),('15844','2013-11-09','11:45:00',2.52),('15844','2013-11-09','11:50:00',2.42),('15844','2013-11-09','11:55:00',2.86),('15844','2013-11-09','12:00:00',2.93),('15844','2013-11-09','12:05:00',1.68),('15844','2013-11-09','12:25:00',1.07),('15844','2013-11-09','12:30:00',1.11),('15844','2013-11-09','12:35:00',1.22),('15844','2013-11-09','12:40:00',2.2),('15844','2013-11-09','12:45:00',2.26),('15844','2013-11-09','12:50:00',2.07),('15844','2013-11-09','12:55:00',1.74),('15844','2013-11-09','13:00:00',1.18),('15844','2013-11-09','13:10:00',1.41),('15844','2013-11-09','13:15:00',1.56),('15844','2013-11-09','13:20:00',1.2),('15844','2013-11-08','09:00:00',1.38),('15844','2013-11-08','09:05:00',1.75),('15844','2013-11-08','09:10:00',1.03),('15844','2013-11-08','09:15:00',1.13),('15844','2013-11-08','09:35:00',1.46),('15844','2013-11-08','09:40:00',1.97),('15844','2013-11-08','09:45:00',1.49),('15844','2013-11-08','09:50:00',1.45),('15844','2013-11-08','10:00:00',1.34),('15844','2013-11-08','10:05:00',2.18),('15844','2013-11-08','10:10:00',2.27),('15844','2013-11-08','10:15:00',2.29),('15844','2013-11-08','10:20:00',2.4),('15844','2013-11-08','10:25:00',2.69),('15844','2013-11-08','10:30:00',2.72),('15844','2013-11-08','10:35:00',2.72),('15844','2013-11-08','10:40:00',2.54),('15844','2013-11-08','10:45:00',2.55),('15844','2013-11-08','10:50:00',1.88),('15844','2013-11-08','11:00:00',2.05),('15844','2013-11-08','11:05:00',2.98),('15844','2013-11-08','11:10:00',3.09),('15844','2013-11-08','11:15:00',2.63),('15844','2013-11-08','11:20:00',2.79),('15844','2013-11-08','11:40:00',2.39),('15844','2013-11-08','11:45:00',2.36),('15844','2013-11-08','11:50:00',1.57),('15844','2013-11-08','11:55:00',2.26),('15844','2013-11-08','12:00:00',1.98),('15844','2013-11-08','12:05:00',2.19),('15844','2013-11-08','12:10:00',2.2),('15844','2013-11-08','12:15:00',2.08),('15844','2013-11-08','12:20:00',2.09),('15844','2013-11-08','12:25:00',2.05),('15844','2013-11-08','12:30:00',1.97),('15844','2013-11-08','12:35:00',1.52),('15844','2013-11-08','13:05:00',1.46),('15844','2013-11-08','13:10:00',1.02),('15844','2013-11-08','13:15:00',1.08),('15844','2013-11-08','13:20:00',1.09),('15844','2013-11-08','13:25:00',1.15),('15844','2013-11-08','13:30:00',1.07),('15844','2013-11-08','13:35:00',1.03),('15844','2013-11-08','13:40:00',1.13),('15844','2013-11-08','13:45:00',1.01),('15844','2014-04-18','08:10:00',1.07),('15844','2014-04-18','08:40:00',1.14),('15844','2014-04-18','08:45:00',1.18),('15844','2014-04-18','08:50:00',1.2),('15844','2014-04-18','09:05:00',1.2),('15844','2014-04-18','09:10:00',2.14),('15844','2014-04-18','09:15:00',2.38),('15844','2014-04-18','09:20:00',2.32),('15844','2014-04-18','09:25:00',1.66),('15844','2014-04-18','09:30:00',1.98),('15844','2014-04-18','09:35:00',1.21),('15844','2014-04-18','09:40:00',1.02),('15844','2014-04-18','09:45:00',2.49),('15844','2014-04-18','09:50:00',2.22),('15844','2014-04-18','09:55:00',2.67),('15844','2014-04-18','10:00:00',1.55),('15844','2014-04-18','10:05:00',1.2),('15844','2014-04-18','10:10:00',1.19),('15844','2014-04-18','10:15:00',1.11),('15844','2014-04-18','10:20:00',1.25),('15844','2014-04-18','10:25:00',1.28),('15844','2014-04-18','10:30:00',1.06),('15844','2014-04-18','10:35:00',1.09),('15844','2014-04-18','10:40:00',1.79),('15844','2014-04-18','10:45:00',2.69),('15844','2014-04-18','10:50:00',3.21),('15844','2014-04-18','10:55:00',3.02),('15844','2014-04-18','11:00:00',2.07),('15844','2014-04-18','11:05:00',1.9),('15844','2014-04-18','11:10:00',1.53),('15844','2014-04-18','11:15:00',1.96),('15844','2014-04-18','11:20:00',1.68),('15844','2014-04-18','11:25:00',1.37),('15844','2014-04-18','11:30:00',1.7),('15844','2014-04-18','11:35:00',1.85),('15844','2014-04-18','11:40:00',1.94),('15844','2014-04-18','11:45:00',2.24),('15844','2014-04-18','11:50:00',2.58),('15844','2014-04-18','11:55:00',2.18),('15844','2014-04-18','12:00:00',2.27),('15844','2014-04-18','12:05:00',2.03),('15844','2014-04-18','12:10:00',2.79),('15844','2014-04-18','12:15:00',2.97),('15844','2014-04-18','12:20:00',3.86),('15844','2014-04-18','12:25:00',3.24),('15844','2014-04-18','12:30:00',4.39),('15844','2014-04-18','12:35:00',4.45),('15844','2014-04-18','12:40:00',3.88),('15844','2014-04-18','12:45:00',3.82),('15844','2014-04-18','12:50:00',2.77),('15844','2014-04-18','12:55:00',3.16),('15844','2014-04-18','13:00:00',3.77),('15844','2014-04-18','13:05:00',4.04),('15844','2014-04-18','13:10:00',4.19),('15844','2014-04-18','13:15:00',3),('15844','2014-04-18','13:20:00',2.16),('15844','2014-04-18','13:25:00',1.49),('15844','2014-04-18','13:30:00',1.06),('15844','2014-04-18','13:35:00',1.15),('15844','2014-04-18','13:40:00',1.29),('15844','2014-04-18','13:45:00',1.25),('15844','2014-04-18','13:50:00',1.22),('15844','2014-04-18','13:55:00',1.38),('15844','2014-04-18','14:00:00',1.6),('15844','2014-04-18','14:05:00',1.55),('15844','2014-04-18','14:10:00',1.52),('15844','2014-04-18','14:15:00',1.6),('15844','2014-04-18','14:20:00',1.5),('15844','2014-04-18','14:25:00',1.85),('15844','2014-04-18','14:30:00',1.88),('15844','2014-04-18','14:35:00',1.88),('15844','2014-04-18','14:40:00',1.6),('15844','2014-04-18','14:45:00',1.51),('15844','2014-04-18','14:50:00',1.75),('15844','2014-04-18','14:55:00',2.89),('15844','2014-04-18','15:00:00',2.67),('15844','2014-04-18','15:05:00',2.51),('15844','2014-04-18','15:10:00',1.63),('15844','2014-04-18','15:15:00',2.49),('15844','2014-04-18','15:20:00',1.57),('15844','2014-04-18','15:25:00',1.36),('15844','2014-04-18','15:30:00',1.52),('15844','2014-04-18','15:35:00',2.04),('15844','2014-04-18','15:40:00',1.81),('15844','2014-04-18','15:45:00',2.15),('15844','2014-04-18','15:50:00',1.73),('15844','2014-04-18','15:55:00',2.32),('15844','2014-04-18','16:00:00',2.12),('15844','2014-04-18','16:05:00',2.19),('15844','2014-04-18','16:10:00',1.7),('15844','2014-04-18','16:15:00',1.54),('15844','2014-04-18','16:20:00',1.62),('15844','2014-04-18','16:25:00',1.2),('15844','2013-11-07','08:10:00',1.01),('15844','2013-11-07','08:15:00',1.08),('15844','2013-11-07','08:20:00',1.14),('15844','2013-11-07','08:25:00',1.22),('15844','2013-11-07','08:30:00',1.29),('15844','2013-11-07','08:35:00',1.38),('15844','2013-11-07','08:40:00',1.46),('15844','2013-11-07','08:45:00',1.52),('15844','2013-11-07','08:50:00',1.58),('15844','2013-11-07','08:55:00',1.63),('15844','2013-11-07','09:00:00',1.68),('15844','2013-11-07','09:05:00',1.73),('15844','2013-11-07','09:10:00',1.78),('15844','2013-11-07','09:15:00',1.82),('15844','2013-11-07','09:20:00',1.86),('15844','2013-11-07','09:25:00',1.9),('15844','2013-11-07','09:30:00',1.94),('15844','2013-11-07','09:35:00',1.97),('15844','2013-11-07','09:40:00',1.98),('15844','2013-11-07','09:45:00',2.04),('15844','2013-11-07','09:50:00',2.07),('15844','2013-11-07','09:55:00',2.1),('15844','2013-11-07','10:00:00',2.13),('15844','2013-11-07','10:05:00',2.17),('15844','2013-11-07','10:10:00',2.2),('15844','2013-11-07','10:15:00',2.21),('15844','2013-11-07','10:20:00',2.22),('15844','2013-11-07','10:25:00',2.23),('15844','2013-11-07','10:30:00',2.25),('15844','2013-11-07','10:35:00',2.25),('15844','2013-11-07','10:40:00',2.26),('15844','2013-11-07','10:45:00',2.24),('15844','2013-11-07','10:50:00',2.26),('15844','2013-11-07','10:55:00',2.25),('15844','2013-11-07','11:00:00',2.23),('15844','2013-11-07','11:05:00',2.23),('15844','2013-11-07','11:10:00',2.21),('15844','2013-11-07','11:15:00',2.22),('15844','2013-11-07','11:20:00',2.11),('15844','2013-11-07','11:25:00',2.07),('15844','2013-11-07','11:30:00',2.1),('15844','2013-11-07','11:35:00',2.05),('15844','2013-11-07','11:40:00',1.98),('15844','2013-11-07','11:45:00',2.16),('15844','2013-11-07','11:50:00',2.14),('15844','2013-11-07','11:55:00',2.05),('15844','2013-11-07','12:00:00',2.06),('15844','2013-11-07','12:05:00',2.01),('15844','2013-11-07','12:10:00',1.92),('15844','2013-11-07','12:15:00',1.8),('15844','2013-11-07','12:20:00',1.75),('15844','2013-11-07','12:25:00',1.16),('15844','2013-11-07','12:35:00',1.64),('15844','2013-11-07','12:40:00',1.4),('15844','2013-11-07','12:45:00',1.02),('15844','2013-11-07','12:50:00',1.31),('15844','2013-11-07','12:55:00',1.36),('15844','2013-11-07','13:00:00',1.37),('15844','2013-11-07','13:05:00',1.22),('15844','2013-11-07','13:10:00',1.51),('15844','2013-11-07','13:15:00',1.58),('15844','2013-11-07','13:20:00',1.24),('15844','2013-11-07','13:25:00',1.08),('15844','2013-11-07','13:30:00',1.03),('15844','2013-11-06','08:10:00',1.05),('15844','2013-11-06','08:15:00',1.23),('15844','2013-11-06','08:35:00',1.45),('15844','2013-11-06','08:40:00',1.53),('15844','2013-11-06','08:45:00',1.61),('15844','2013-11-06','08:50:00',1.73),('15844','2013-11-06','08:55:00',1.42),('15844','2013-11-06','09:00:00',1.12),('15844','2013-11-06','09:05:00',1.11),('15844','2013-11-06','09:10:00',1.49),('15844','2013-11-06','09:15:00',1.59),('15844','2013-11-06','09:20:00',1.92),('15844','2013-11-06','09:25:00',2.03),('15844','2013-11-06','09:30:00',2.05),('15844','2013-11-06','09:35:00',2.09),('15844','2013-11-06','09:40:00',2.12),('15844','2013-11-06','09:45:00',2.14),('15844','2013-11-06','09:50:00',2.16),('15844','2013-11-06','09:55:00',2.21),('15844','2013-11-06','10:00:00',2.25),('15844','2013-11-06','10:05:00',2.29),('15844','2013-11-06','10:10:00',2.32),('15844','2013-11-06','10:15:00',2.35),('15844','2013-11-06','10:20:00',2.36),('15844','2013-11-06','10:25:00',2.4),('15844','2013-11-06','10:30:00',2.41),('15844','2013-11-06','10:35:00',2.43),('15844','2013-11-06','10:40:00',2.44),('15844','2013-11-06','10:45:00',2.43),('15844','2013-11-06','10:50:00',2.43),('15844','2013-11-06','10:55:00',2.41),('15844','2013-11-06','11:00:00',2.41),('15844','2013-11-06','11:05:00',2.41),('15844','2013-11-06','11:10:00',2.4),('15844','2013-11-06','11:15:00',2.39),('15844','2013-11-06','11:20:00',2.37),('15844','2013-11-06','11:25:00',2.37),('15844','2013-11-06','11:30:00',2.34),('15844','2013-11-06','11:35:00',2.34),('15844','2013-11-06','11:40:00',2.32),('15844','2013-11-06','11:45:00',2.29),('15844','2013-11-06','11:50:00',2.26),('15844','2013-11-06','11:55:00',2.24),('15844','2013-11-06','12:00:00',2.21),('15844','2013-11-06','12:05:00',2.18),('15844','2013-11-06','12:10:00',2.13),('15844','2013-11-06','12:15:00',2.08),('15844','2013-11-06','12:20:00',2.04),('15844','2013-11-06','12:25:00',1.98),('15844','2013-11-06','12:30:00',1.92),('15844','2013-11-06','12:35:00',1.85),('15844','2013-11-06','12:40:00',1.79),('15844','2013-11-06','12:45:00',1.72),('15844','2013-11-06','12:50:00',1.64),('15844','2013-11-06','12:55:00',1.56),('15844','2013-11-06','13:00:00',1.5),('15844','2013-11-06','13:05:00',1.43),('15844','2013-11-06','13:10:00',1.35),('15844','2013-11-06','13:15:00',1.25),('15844','2013-11-06','13:20:00',1.18),('15844','2013-11-06','13:25:00',1.17),('15844','2013-11-06','13:30:00',1.09),('15844','2013-11-06','13:35:00',1.03),('15844','2013-11-05','08:35:00',1.13),('15844','2013-11-05','10:20:00',1.03),('15844','2013-11-05','10:25:00',1.12),('15844','2013-11-05','10:40:00',1.23),('15844','2013-11-05','10:45:00',1.23),('15844','2013-11-05','11:35:00',1.1),('15844','2013-11-05','11:40:00',1.24),('15844','2013-11-05','11:45:00',1.11),('15844','2013-11-05','11:50:00',1),('15844','2013-11-05','12:05:00',1.21),('15844','2013-11-05','12:10:00',1.13),('15844','2013-11-05','12:15:00',1.14),('15844','2013-11-05','12:20:00',1.62),('15844','2013-11-05','12:25:00',1.91),('15844','2013-11-05','12:30:00',1.55),('15844','2013-11-05','12:35:00',1.03),('15844','2013-11-05','13:20:00',1.06),('15844','2013-11-05','13:25:00',1.12),('15844','2013-11-05','13:30:00',1.28),('15844','2013-11-05','13:35:00',1.55),('15844','2013-11-05','13:40:00',1.41),('15844','2013-11-05','13:45:00',1.22),('15844','2013-11-05','13:50:00',1.05),('15844','2013-11-05','13:55:00',1.18),('15844','2013-11-05','14:00:00',1.27),('15844','2013-11-05','14:05:00',1.08),('15844','2013-11-05','14:10:00',1.02),('15844','2013-11-05','14:20:00',1.07),('15844','2013-11-04','08:10:00',1.02),('15844','2013-11-04','08:15:00',1.1),('15844','2013-11-04','08:20:00',1.17),('15844','2013-11-04','08:25:00',1.28),('15844','2013-11-04','08:30:00',1.35),('15844','2013-11-04','08:35:00',1.49),('15844','2013-11-04','08:40:00',1.11),('15844','2013-11-04','08:55:00',1.13),('15844','2013-11-04','09:00:00',1.72),('15844','2013-11-04','09:05:00',1.79),('15844','2013-11-04','09:10:00',1.85),('15844','2013-11-04','09:15:00',1.74),('15844','2013-11-04','09:20:00',1.07),('15844','2013-11-04','09:25:00',2.03),('15844','2013-11-04','09:30:00',2.02),('15844','2013-11-04','09:35:00',2.09),('15844','2013-11-04','09:40:00',2.08),('15844','2013-11-04','09:45:00',2.03),('15844','2013-11-04','09:50:00',1.93),('15844','2013-11-04','09:55:00',2.3),('15844','2013-11-04','10:00:00',2.38),('15844','2013-11-04','10:05:00',2.03),('15844','2013-11-04','10:10:00',1.92),('15844','2013-11-04','10:15:00',2.08),('15844','2013-11-04','10:20:00',1.8),('15844','2013-11-04','10:25:00',1.55),('15844','2013-11-04','10:30:00',1.76),('15844','2013-11-04','11:50:00',1.36),('15844','2013-11-04','11:55:00',2.72),('15844','2013-11-04','12:00:00',2.69),('15844','2013-11-04','12:05:00',2.23),('15844','2013-11-04','12:10:00',2.56),('15844','2013-11-04','12:15:00',2.37),('15844','2013-11-04','12:20:00',2.29),('15844','2013-11-04','12:25:00',2.23),('15844','2013-11-04','12:30:00',2.15),('15844','2013-11-04','12:35:00',2.06),('15844','2013-11-04','12:40:00',1.95),('15844','2013-11-04','12:45:00',1.99),('15844','2013-11-04','12:50:00',1.87),('15844','2013-11-04','12:55:00',1.76),('15844','2013-11-04','13:00:00',1.7),('15844','2013-11-04','13:05:00',1.63),('15844','2013-11-04','13:20:00',1.11),('15844','2013-11-04','13:25:00',1.01),('15844','2013-11-04','13:30:00',1.28),('15844','2013-11-04','13:35:00',1.25),('15844','2013-11-04','13:40:00',1.08),('15844','2013-11-04','13:45:00',1.17),('15844','2013-11-04','14:00:00',1.09),('15844','2013-11-03','08:30:00',1.27),('15844','2013-11-03','08:35:00',1.27),('15844','2013-11-03','08:40:00',1.4),('15844','2013-11-03','08:45:00',1.67),('15844','2013-11-03','08:55:00',1.75),('15844','2013-11-03','09:00:00',1.09),('15844','2013-11-03','09:30:00',1.88),('15844','2013-11-03','09:35:00',1.21),('15844','2013-11-03','10:10:00',1.03),('15844','2013-11-03','10:20:00',1.37),('15844','2013-11-03','10:25:00',2.25),('15844','2013-11-03','10:30:00',1.87),('15844','2013-11-03','11:05:00',1.58),('15844','2013-11-03','11:10:00',1.57),('15844','2013-11-03','11:15:00',1.34),('15844','2013-11-03','11:30:00',2.71),('15844','2013-11-03','11:35:00',2.31),('15844','2013-11-03','11:40:00',1.76),('15844','2013-11-03','11:45:00',1.82),('15844','2013-11-03','11:50:00',1.78),('15844','2013-11-03','11:55:00',2.32),('15844','2013-11-03','12:00:00',1.3),('15844','2013-11-03','12:05:00',1.74),('15844','2013-11-03','12:10:00',1.07),('15844','2013-11-03','12:15:00',2.39),('15844','2013-11-03','12:20:00',2.58),('15844','2013-11-03','12:25:00',1.11),('15844','2013-11-03','12:50:00',1.09),('15844','2013-11-03','12:55:00',1.04),('15844','2013-11-03','13:20:00',1.22),('15844','2013-11-03','13:25:00',1.48),('15844','2013-11-03','13:30:00',1.12),('15844','2013-11-03','13:45:00',1.28),('15844','2013-11-03','13:55:00',1.01),('15844','2013-11-03','14:00:00',1.29),('15844','2013-11-03','14:05:00',1.19),('15844','2013-11-03','14:10:00',1.19),('15844','2013-11-03','14:15:00',1.26),('15844','2013-11-02','08:15:00',1.01),('15844','2013-11-02','08:20:00',1.12),('15844','2013-11-02','08:25:00',1.2),('15844','2013-11-02','08:30:00',1.27),('15844','2013-11-02','08:35:00',1.34),('15844','2013-11-02','08:40:00',1.41),('15844','2013-11-02','08:45:00',1.5),('15844','2013-11-02','08:50:00',1.57),('15844','2013-11-02','08:55:00',1.7),('15844','2013-11-02','09:00:00',1.79),('15844','2013-11-02','09:15:00',1.96),('15844','2013-11-02','09:20:00',1.87),('15844','2013-11-02','09:25:00',1.46),('15844','2013-11-02','09:30:00',1.95),('15844','2013-11-02','09:35:00',1.98),('15844','2013-11-02','09:40:00',2.07),('15844','2013-11-02','09:45:00',2.32),('15844','2013-11-02','09:50:00',2.36),('15844','2013-11-02','09:55:00',2.06),('15844','2013-11-02','10:00:00',1.6),('15844','2013-11-02','10:05:00',1.56),('15844','2013-11-02','10:50:00',1.01),('15844','2013-11-02','10:55:00',1.17),('15844','2013-11-02','11:00:00',2.33),('15844','2013-11-02','11:05:00',2.66),('15844','2013-11-02','11:10:00',1.03),('15844','2013-11-02','11:15:00',1.04),('15844','2013-11-02','11:40:00',2.04),('15844','2013-11-02','11:45:00',2.31),('15844','2013-11-02','11:50:00',2.08),('15844','2013-11-02','11:55:00',2.37),('15844','2013-11-02','12:05:00',1.2),('15844','2013-11-02','12:10:00',2.22),('15844','2013-11-02','12:15:00',2.63),('15844','2013-11-02','12:20:00',1.16),('15844','2013-11-02','12:25:00',1.29),('15844','2013-11-02','12:30:00',2.17),('15844','2013-11-02','12:35:00',2.68),('15844','2013-11-02','12:40:00',2.22),('15844','2013-11-02','12:45:00',1.76),('15844','2013-11-02','12:50:00',1.87),('15844','2013-11-02','12:55:00',2.21),('15844','2013-11-02','13:00:00',1.61),('15844','2013-11-02','13:05:00',2.3),('15844','2013-11-02','13:10:00',2.02),('15844','2013-11-02','13:15:00',1.81),('15844','2013-11-02','13:20:00',1.22),('15844','2013-11-02','13:25:00',1.05),('15844','2013-11-02','13:30:00',1.72),('15844','2013-11-02','13:35:00',1.58),('15844','2013-11-02','13:40:00',1.79),('15844','2013-11-02','13:45:00',1.66),('15844','2013-11-02','13:50:00',1.4),('15844','2013-11-02','13:55:00',1),('15844','2013-11-01','08:25:00',1.09),('15844','2013-11-01','08:30:00',1.21),('15844','2013-11-01','08:35:00',1.31),('15844','2013-11-01','08:40:00',1.33),('15844','2013-11-01','08:45:00',1.23),('15844','2013-11-01','08:50:00',1.34),('15844','2013-11-01','08:55:00',1.45),('15844','2013-11-01','09:00:00',1.6),('15844','2013-11-01','09:05:00',1.57),('15844','2013-11-01','09:10:00',1.55),('15844','2013-11-01','09:15:00',1.76),('15844','2013-11-01','09:20:00',1.84),('15844','2013-11-01','09:25:00',1.87),('15844','2013-11-01','09:30:00',1.9),('15844','2013-11-01','09:35:00',1.95),('15844','2013-11-01','09:40:00',1.99),('15844','2013-11-01','09:45:00',2.03),('15844','2013-11-01','09:50:00',2.08),('15844','2013-11-01','09:55:00',2.12),('15844','2013-11-01','10:00:00',2.16),('15844','2013-11-01','10:05:00',2.24),('15844','2013-11-01','10:10:00',2.29),('15844','2013-11-01','10:15:00',2.3),('15844','2013-11-01','10:20:00',2.32),('15844','2013-11-01','10:25:00',2.34),('15844','2013-11-01','10:30:00',2.33),('15844','2013-11-01','10:35:00',2.31),('15844','2013-11-01','10:40:00',2.35),('15844','2013-11-01','10:45:00',2.37),('15844','2013-11-01','10:50:00',2.37),('15844','2013-11-01','10:55:00',2.31),('15844','2013-11-01','11:00:00',2.36),('15844','2013-11-01','11:05:00',2.13),('15844','2013-11-01','11:10:00',1.94),('15844','2013-11-01','11:15:00',1.98),('15844','2013-11-01','11:20:00',2.29),('15844','2013-11-01','11:25:00',2.25),('15844','2013-11-01','11:30:00',2.27),('15844','2013-11-01','11:35:00',2.42),('15844','2013-11-01','11:40:00',2.39),('15844','2013-11-01','11:45:00',2.24),('15844','2013-11-01','11:50:00',2.25),('15844','2013-11-01','11:55:00',2.39),('15844','2013-11-01','12:00:00',2.35),('15844','2013-11-01','12:05:00',2.3),('15844','2013-11-01','12:10:00',2.27),('15844','2013-11-01','12:15:00',1.65),('15844','2013-11-01','12:25:00',1.49),('15844','2013-11-01','12:50:00',1.39),('15844','2013-11-01','12:55:00',1.51),('15844','2013-11-01','13:00:00',1.59),('15844','2013-11-01','13:05:00',1.42),('15844','2013-11-01','13:10:00',1.23),('15844','2013-11-01','13:15:00',1),('15844','2013-10-31','08:20:00',1.02),('15844','2013-10-31','08:30:00',1.14),('15844','2013-10-31','08:35:00',1.29),('15844','2013-10-31','08:40:00',1.41),('15844','2013-10-31','08:45:00',1.49),('15844','2013-10-31','08:50:00',1.16),('15844','2013-10-31','08:55:00',1.24),('15844','2013-10-31','09:00:00',1.42),('15844','2013-10-31','09:05:00',1.45),('15844','2013-10-31','09:10:00',1.59),('15844','2013-10-31','09:15:00',1.62),('15844','2013-10-31','09:20:00',1.48),('15844','2013-10-31','09:25:00',1.03),('15844','2013-10-31','09:30:00',1.52),('15844','2013-10-31','09:35:00',1.64),('15844','2013-10-31','09:40:00',1.61),('15844','2013-10-31','09:45:00',1.69),('15844','2013-10-31','09:50:00',1.79),('15844','2013-10-31','09:55:00',1.88),('15844','2013-10-31','10:00:00',1.93),('15844','2013-10-31','10:05:00',2.02),('15844','2013-10-31','10:10:00',2),('15844','2013-10-31','10:15:00',2.09),('15844','2013-10-31','10:20:00',2.04),('15844','2013-10-31','10:25:00',2),('15844','2013-10-31','10:30:00',1.96),('15844','2013-10-31','10:35:00',2.03),('15844','2013-10-31','10:40:00',2.04),('15844','2013-10-31','10:45:00',1.99),('15844','2013-10-31','10:50:00',2.03),('15844','2013-10-31','10:55:00',2.03),('15844','2013-10-31','11:00:00',2.11),('15844','2013-10-31','11:05:00',2.22),('15844','2013-10-31','11:10:00',2.19),('15844','2013-10-31','11:15:00',2.07),('15844','2013-10-31','11:20:00',2.16),('15844','2013-10-31','11:25:00',2.04),('15844','2013-10-31','11:30:00',1.89),('15844','2013-10-31','11:35:00',1.84),('15844','2013-10-31','11:40:00',2.05),('15844','2013-10-31','11:45:00',2.25),('15844','2013-10-31','11:50:00',2.31),('15844','2013-10-31','11:55:00',2.23),('15844','2013-10-31','12:00:00',2.32),('15844','2013-10-31','12:05:00',2.32),('15844','2013-10-31','12:10:00',2.25),('15844','2013-10-31','12:15:00',2.11),('15844','2013-10-31','12:20:00',2.06),('15844','2013-10-31','12:25:00',2.04),('15844','2013-10-31','12:30:00',1.93),('15844','2013-10-31','12:35:00',1.87),('15844','2013-10-31','12:40:00',1.86),('15844','2013-10-31','12:45:00',1.8),('15844','2013-10-31','12:50:00',1.76),('15844','2013-10-31','12:55:00',1.72),('15844','2013-10-31','13:00:00',1.66),('15844','2013-10-31','13:05:00',1.55),('15844','2013-10-31','13:10:00',1.46),('15844','2013-10-31','13:15:00',1.36),('15844','2013-10-31','13:20:00',1.28),('15844','2013-10-31','13:25:00',1.18),('15844','2013-10-31','13:30:00',1.13),('15844','2013-10-31','13:35:00',1.08),('15844','2013-10-30','08:25:00',1.03),('15844','2013-10-30','08:30:00',1.14),('15844','2013-10-30','08:35:00',1.25),('15844','2013-10-30','08:40:00',1.3),('15844','2013-10-30','08:45:00',1.41),('15844','2013-10-30','08:50:00',1.37),('15844','2013-10-30','08:55:00',1.47),('15844','2013-10-30','09:00:00',1.58),('15844','2013-10-30','09:05:00',1.66),('15844','2013-10-30','09:10:00',1.67),('15844','2013-10-30','09:15:00',1.67),('15844','2013-10-30','09:20:00',1.76),('15844','2013-10-30','09:25:00',1.81),('15844','2013-10-30','09:30:00',1.85),('15844','2013-10-30','09:35:00',1.85),('15844','2013-10-30','09:40:00',1.67),('15844','2013-10-30','09:45:00',1.68),('15844','2013-10-30','09:50:00',1.72),('15844','2013-10-30','09:55:00',2),('15844','2013-10-30','10:00:00',1.9),('15844','2013-10-30','10:05:00',1.97),('15844','2013-10-30','10:10:00',1.76),('15844','2013-10-30','10:15:00',1.63),('15844','2013-10-30','10:20:00',1.71),('15844','2013-10-30','10:25:00',1.42),('15844','2013-10-30','10:30:00',1.85),('15844','2013-10-30','10:35:00',1.88),('15844','2013-10-30','10:40:00',1.51),('15844','2013-10-30','10:45:00',1.66),('15844','2013-10-30','10:50:00',1.24),('15844','2013-10-30','10:55:00',2.07),('15844','2013-10-30','11:00:00',2.13),('15844','2013-10-30','11:05:00',2.11),('15844','2013-10-30','11:10:00',2.19),('15844','2013-10-30','11:15:00',2.24),('15844','2013-10-30','11:20:00',2.2),('15844','2013-10-30','11:25:00',1.19),('15844','2013-10-30','11:30:00',1.76),('15844','2013-10-30','11:35:00',1.8),('15844','2013-10-30','11:40:00',1.42),('15844','2013-10-30','11:45:00',1.01),('15844','2013-10-30','12:00:00',1.66),('15844','2013-10-30','12:05:00',1.53),('15844','2013-10-30','12:10:00',1.95),('15844','2013-10-30','12:15:00',2.4),('15844','2013-10-30','12:20:00',2.45),('15844','2013-10-30','12:25:00',1.9),('15844','2013-10-30','12:35:00',1.24),('15844','2013-10-30','12:40:00',2.02),('15844','2013-10-30','12:45:00',1.84),('15844','2013-10-30','12:50:00',1.15),('15844','2013-10-30','13:20:00',1.14),('15844','2013-10-30','13:25:00',1.5),('15844','2013-10-30','13:30:00',1.04),('15844','2013-10-29','08:30:00',1.15),('15844','2013-10-29','08:35:00',1.35),('15844','2013-10-29','08:40:00',1.43),('15844','2013-10-29','08:45:00',1.47),('15844','2013-10-29','08:50:00',1.54),('15844','2013-10-29','08:55:00',1.61),('15844','2013-10-29','09:00:00',1.69),('15844','2013-10-29','09:05:00',1.72),('15844','2013-10-29','09:10:00',1.75),('15844','2013-10-29','09:15:00',1.82),('15844','2013-10-29','09:20:00',1.88),('15844','2013-10-29','09:25:00',1.9),('15844','2013-10-29','09:30:00',1.9),('15844','2013-10-29','09:35:00',2),('15844','2013-10-29','09:40:00',1.92),('15844','2013-10-29','09:45:00',1.99),('15844','2013-10-29','09:50:00',1.82),('15844','2013-10-29','09:55:00',2.02),('15844','2013-10-29','10:00:00',2.11),('15844','2013-10-29','10:05:00',1.47),('15844','2013-10-29','10:10:00',1.13),('15844','2013-10-29','10:15:00',1.23),('15844','2013-10-29','10:20:00',1.61),('15844','2013-10-29','10:25:00',1.84),('15844','2013-10-29','10:30:00',1.79),('15844','2013-10-29','10:35:00',2.35),('15844','2013-10-29','10:40:00',2.42),('15844','2013-10-29','10:45:00',1.95),('15844','2013-10-29','10:50:00',2.18),('15844','2013-10-29','10:55:00',2.58),('15844','2013-10-29','11:00:00',2.39),('15844','2013-10-29','11:05:00',2.57),('15844','2013-10-29','11:10:00',2.31),('15844','2013-10-29','11:15:00',2.13),('15844','2013-10-29','11:20:00',2.62),('15844','2013-10-29','11:25:00',2.5),('15844','2013-10-29','11:30:00',2.36),('15844','2013-10-29','11:35:00',2.46),('15844','2013-10-29','11:40:00',2.4),('15844','2013-10-29','11:45:00',2.07),('15844','2013-10-29','11:50:00',1.78),('15844','2013-10-29','11:55:00',2.19),('15844','2013-10-29','12:00:00',2.21),('15844','2013-10-29','12:05:00',2.19),('15844','2013-10-29','12:10:00',2.2),('15844','2013-10-29','12:15:00',1.97),('15844','2013-10-29','12:20:00',2.05),('15844','2013-10-29','12:25:00',2.02),('15844','2013-10-29','12:30:00',2),('15844','2013-10-29','12:35:00',1.94),('15844','2013-10-29','12:40:00',1.83),('15844','2013-10-29','12:45:00',1.76),('15844','2013-10-29','12:50:00',1.63),('15844','2013-10-29','12:55:00',1.58),('15844','2013-10-29','13:00:00',1.42),('15844','2013-10-29','13:05:00',1.25),('15844','2013-10-29','13:15:00',1.36),('15844','2013-10-29','13:20:00',1.3),('15844','2013-10-29','13:25:00',1.29),('15844','2013-10-29','13:30:00',1.23),('15844','2013-10-29','13:35:00',1.18),('15844','2013-10-29','13:40:00',1.07),('15844','2014-04-17','08:35:00',1.11),('15844','2014-04-17','08:40:00',1.23),('15844','2014-04-17','08:45:00',1.34),('15844','2014-04-17','08:50:00',1.47),('15844','2014-04-17','08:55:00',1.55),('15844','2014-04-17','09:00:00',1.67),('15844','2014-04-17','09:05:00',1.82),('15844','2014-04-17','09:10:00',1.89),('15844','2014-04-17','09:15:00',1.99),('15844','2014-04-17','09:20:00',2.12),('15844','2014-04-17','09:25:00',2.25),('15844','2014-04-17','09:30:00',2.36),('15844','2014-04-17','09:35:00',2.46),('15844','2014-04-17','09:40:00',2.53),('15844','2014-04-17','09:45:00',2.61),('15844','2014-04-17','09:50:00',2.66),('15844','2014-04-17','09:55:00',2.79),('15844','2014-04-17','10:00:00',2.98),('15844','2014-04-17','10:05:00',2.56),('15844','2014-04-17','10:10:00',1.92),('15844','2014-04-17','10:15:00',2.07),('15844','2014-04-17','10:20:00',2.58),('15844','2014-04-17','10:25:00',2.87),('15844','2014-04-17','10:30:00',3.05),('15844','2014-04-17','10:35:00',3.21),('15844','2014-04-17','10:40:00',2.51),('15844','2014-04-17','10:45:00',2.69),('15844','2014-04-17','10:50:00',2.55),('15844','2014-04-17','10:55:00',2.64),('15844','2014-04-17','11:00:00',2.68),('15844','2014-04-17','11:05:00',2.45),('15844','2014-04-17','11:10:00',2.98),('15844','2014-04-17','11:15:00',2.88),('15844','2014-04-17','11:20:00',3.83),('15844','2014-04-17','11:25:00',2.29),('15844','2014-04-17','11:30:00',3.18),('15844','2014-04-17','11:35:00',3.38),('15844','2014-04-17','11:40:00',2.62),('15844','2014-04-17','11:45:00',3.92),('15844','2014-04-17','11:50:00',3.38),('15844','2014-04-17','11:55:00',2.58),('15844','2014-04-17','12:00:00',2.51),('15844','2014-04-17','12:05:00',1.98),('15844','2014-04-17','12:10:00',1.89),('15844','2014-04-17','12:15:00',2.26),('15844','2014-04-17','12:20:00',2.19),('15844','2014-04-17','12:25:00',2.8),('15844','2014-04-17','12:30:00',3.97),('15844','2014-04-17','12:35:00',4.02),('15844','2014-04-17','12:40:00',4.01),('15844','2014-04-17','12:45:00',4.08),('15844','2014-04-17','12:50:00',4.14),('15844','2014-04-17','12:55:00',4.15),('15844','2014-04-17','13:00:00',4.11),('15844','2014-04-17','13:05:00',4.1),('15844','2014-04-17','13:10:00',4.12),('15844','2014-04-17','13:15:00',4.11),('15844','2014-04-17','13:20:00',4.15),('15844','2014-04-17','13:25:00',4.23),('15844','2014-04-17','13:30:00',4.18),('15844','2014-04-17','13:35:00',4.32),('15844','2014-04-17','13:40:00',2.79),('15844','2014-04-17','13:45:00',3.82),('15844','2014-04-17','13:50:00',1.4),('15844','2014-04-17','13:55:00',3.68),('15844','2014-04-17','14:00:00',1.71),('15844','2014-04-17','14:05:00',2.62),('15844','2014-04-17','14:10:00',2.67),('15844','2014-04-17','14:15:00',1.45),('15844','2014-04-17','14:20:00',4.1),('15844','2014-04-17','14:25:00',3.12),('15844','2014-04-17','14:30:00',1.83),('15844','2014-04-17','14:35:00',1.6),('15844','2014-04-17','14:40:00',2.36),('15844','2014-04-17','14:45:00',2.14),('15844','2014-04-17','15:25:00',1.05),('15844','2014-04-17','15:30:00',1.25),('15844','2014-04-17','15:35:00',1.28),('15844','2014-04-17','15:40:00',1.08),('15844','2014-04-17','16:25:00',1.03),('15844','2014-04-17','16:40:00',1.05),('15844','2014-04-17','16:45:00',1.16),('15844','2014-04-17','16:50:00',1.08),('15844','2013-10-28','08:45:00',1.38),('15844','2013-10-28','08:50:00',1.58),('15844','2013-10-28','08:55:00',1.74),('15844','2013-10-28','09:00:00',1.83),('15844','2013-10-28','09:05:00',1.89),('15844','2013-10-28','09:10:00',1.96),('15844','2013-10-28','09:15:00',1.72),('15844','2013-10-28','09:20:00',1.38),('15844','2013-10-28','09:25:00',1.35),('15844','2013-10-28','09:30:00',1.68),('15844','2013-10-28','09:35:00',1.78),('15844','2013-10-28','09:40:00',1.57),('15844','2013-10-28','10:40:00',2.36),('15844','2013-10-28','10:45:00',2.6),('15844','2013-10-28','10:50:00',2.55),('15844','2013-10-28','10:55:00',2.55),('15844','2013-10-28','11:00:00',2.52),('15844','2013-10-28','11:05:00',2.53),('15844','2013-10-28','11:10:00',2.51),('15844','2013-10-28','11:15:00',2.49),('15844','2013-10-28','11:20:00',2.49),('15844','2013-10-28','11:25:00',2.51),('15844','2013-10-28','11:30:00',2.46),('15844','2013-10-28','11:35:00',2.42),('15844','2013-10-28','11:40:00',2.39),('15844','2013-10-28','11:45:00',2.38),('15844','2013-10-28','11:50:00',2.43),('15844','2013-10-28','11:55:00',2.4),('15844','2013-10-28','12:00:00',2.37),('15844','2013-10-28','12:05:00',2.38),('15844','2013-10-28','12:10:00',2.19),('15844','2013-10-28','12:15:00',1.62),('15844','2013-10-28','12:20:00',1.48),('15844','2013-10-28','12:25:00',1.54),('15844','2013-10-28','12:30:00',1.54),('15844','2013-10-28','12:35:00',2.03),('15844','2013-10-28','12:40:00',1.97),('15844','2013-10-28','12:45:00',1.88),('15844','2013-10-28','12:50:00',1.8),('15844','2013-10-28','12:55:00',1.71),('15844','2013-10-28','13:00:00',1.65),('15844','2013-10-28','13:05:00',1.59),('15844','2013-10-28','13:10:00',1.5),('15844','2013-10-28','13:15:00',1.41),('15844','2013-10-28','13:20:00',1.33),('15844','2013-10-28','13:25:00',1.25),('15844','2013-10-28','13:30:00',1.18),('15844','2013-10-28','13:35:00',1.16),('15844','2013-10-28','13:40:00',1.12),('15844','2013-10-28','13:45:00',1.09),('15844','2013-10-27','10:05:00',1.12),('15844','2013-10-27','10:10:00',1.04),('15844','2013-10-27','10:30:00',1.1),('15844','2013-10-27','10:35:00',1.53),('15844','2013-10-27','10:40:00',1.59),('15844','2013-10-27','10:45:00',1.23),('15844','2013-10-27','10:50:00',1.21),('15844','2013-10-27','10:55:00',1.14),('15844','2013-10-27','11:00:00',1.02),('15844','2013-10-27','11:10:00',1.02),('15844','2013-10-27','11:15:00',1.29),('15844','2013-10-27','11:20:00',1.26),('15844','2013-10-27','11:25:00',1.4),('15844','2013-10-27','11:30:00',1.36),('15844','2013-10-27','11:35:00',1.41),('15844','2013-10-27','11:40:00',1.14),('15844','2013-10-27','11:45:00',1),('15844','2013-10-27','11:50:00',1.01),('15844','2013-10-27','12:00:00',1.2),('15844','2013-10-27','12:05:00',2.11),('15844','2013-10-27','12:10:00',1.13),('15844','2013-10-27','12:15:00',2.02),('15844','2013-10-27','12:20:00',1.66),('15844','2013-10-27','12:25:00',1.4),('15844','2013-10-27','12:50:00',1.23),('15844','2013-10-27','12:55:00',1.75),('15844','2013-10-27','13:00:00',1.15),('15844','2013-10-27','13:05:00',1.44),('15844','2013-10-27','13:15:00',1.38),('15844','2013-10-27','13:40:00',1.54),('15844','2013-10-27','13:45:00',1.51),('15844','2013-10-27','13:50:00',1.11),('15844','2013-10-27','13:55:00',1.19),('15844','2013-10-27','14:05:00',1.24),('15844','2013-10-27','14:10:00',1.16),('15844','2013-10-27','14:15:00',1.08),('15844','2013-10-27','14:30:00',1.05),('15844','2013-10-26','09:05:00',1.01),('15844','2013-10-26','09:10:00',1.07),('15844','2013-10-26','09:15:00',1.13),('15844','2013-10-26','09:20:00',1.18),('15844','2013-10-26','09:25:00',1.27),('15844','2013-10-26','09:30:00',1.34),('15844','2013-10-26','09:35:00',1.41),('15844','2013-10-26','09:40:00',1.48),('15844','2013-10-26','09:45:00',1.55),('15844','2013-10-26','09:50:00',1.64),('15844','2013-10-26','09:55:00',1.69),('15844','2013-10-26','10:00:00',1.75),('15844','2013-10-26','10:05:00',1.78),('15844','2013-10-26','10:10:00',1.82),('15844','2013-10-26','10:15:00',1.87),('15844','2013-10-26','10:20:00',1.91),('15844','2013-10-26','10:25:00',1.92),('15844','2013-10-26','10:30:00',1.96),('15844','2013-10-26','10:35:00',2.02),('15844','2013-10-26','10:40:00',2.05),('15844','2013-10-26','10:45:00',2.12),('15844','2013-10-26','10:50:00',2.14),('15844','2013-10-26','10:55:00',2.16),('15844','2013-10-26','11:00:00',2.16),('15844','2013-10-26','11:05:00',2.28),('15844','2013-10-26','11:10:00',2.34),('15844','2013-10-26','11:15:00',2.38),('15844','2013-10-26','11:20:00',2.41),('15844','2013-10-26','11:25:00',2.42),('15844','2013-10-26','11:30:00',2.43),('15844','2013-10-26','11:35:00',2.45),('15844','2013-10-26','11:40:00',2.4),('15844','2013-10-26','11:45:00',2.43),('15844','2013-10-26','11:50:00',2.44),('15844','2013-10-26','11:55:00',2.41),('15844','2013-10-26','12:00:00',2.39),('15844','2013-10-26','12:05:00',2.38),('15844','2013-10-26','12:10:00',2.35),('15844','2013-10-26','12:15:00',2.42),('15844','2013-10-26','12:20:00',2.33),('15844','2013-10-26','12:25:00',2.33),('15844','2013-10-26','12:30:00',2.11),('15844','2013-10-26','12:35:00',2.38),('15844','2013-10-26','12:40:00',2.33),('15844','2013-10-26','12:45:00',2.14),('15844','2013-10-26','12:50:00',2.1),('15844','2013-10-26','12:55:00',2.22),('15844','2013-10-26','13:00:00',2.28),('15844','2013-10-26','13:05:00',2.21),('15844','2013-10-26','13:10:00',2.11),('15844','2013-10-26','13:15:00',2.11),('15844','2013-10-26','13:20:00',2.16),('15844','2013-10-26','13:25:00',1.93),('15844','2013-10-26','13:30:00',1.9),('15844','2013-10-26','13:35:00',2.03),('15844','2013-10-26','13:40:00',1.87),('15844','2013-10-26','13:45:00',1.73),('15844','2013-10-26','13:50:00',1.72),('15844','2013-10-26','13:55:00',1.55),('15844','2013-10-26','14:00:00',1.64),('15844','2013-10-26','14:05:00',1.52),('15844','2013-10-26','14:10:00',1.5),('15844','2013-10-26','14:15:00',1.33),('15844','2013-10-26','14:20:00',1.33),('15844','2013-10-26','14:25:00',1.29),('15844','2013-10-26','14:30:00',1.2),('15844','2013-10-26','14:35:00',1.17),('15844','2013-10-26','14:40:00',1.23),('15844','2013-10-26','14:50:00',1.03),('15844','2013-10-25','09:10:00',1.06),('15844','2013-10-25','09:15:00',1.13),('15844','2013-10-25','09:20:00',1.21),('15844','2013-10-25','09:25:00',1.32),('15844','2013-10-25','09:30:00',1.4),('15844','2013-10-25','09:35:00',1.47),('15844','2013-10-25','09:40:00',1.54),('15844','2013-10-25','09:45:00',1.61),('15844','2013-10-25','09:50:00',1.68),('15844','2013-10-25','09:55:00',1.75),('15844','2013-10-25','10:00:00',1.84),('15844','2013-10-25','10:05:00',1.86),('15844','2013-10-25','10:10:00',1.92),('15844','2013-10-25','10:15:00',1.95),('15844','2013-10-25','10:20:00',1.99),('15844','2013-10-25','10:25:00',1.99),('15844','2013-10-25','10:30:00',2.02),('15844','2013-10-25','10:35:00',2.12),('15844','2013-10-25','10:40:00',2.14),('15844','2013-10-25','10:45:00',2.18),('15844','2013-10-25','10:50:00',2.2),('15844','2013-10-25','10:55:00',2.26),('15844','2013-10-25','11:00:00',2.24),('15844','2013-10-25','11:05:00',2.38),('15844','2013-10-25','11:10:00',2.42),('15844','2013-10-25','11:15:00',2.46),('15844','2013-10-25','11:20:00',2.47),('15844','2013-10-25','11:25:00',2.51),('15844','2013-10-25','11:30:00',2.53),('15844','2013-10-25','11:35:00',2.54),('15844','2013-10-25','11:40:00',2.54),('15844','2013-10-25','11:45:00',2.6),('15844','2013-10-25','11:50:00',2.59),('15844','2013-10-25','11:55:00',2.58),('15844','2013-10-25','12:00:00',2.57),('15844','2013-10-25','12:05:00',2.57),('15844','2013-10-25','12:10:00',2.58),('15844','2013-10-25','12:15:00',2.56),('15844','2013-10-25','12:20:00',2.55),('15844','2013-10-25','12:25:00',2.53),('15844','2013-10-25','12:30:00',2.49),('15844','2013-10-25','12:35:00',2.49),('15844','2013-10-25','12:40:00',2.46),('15844','2013-10-25','12:45:00',2.46),('15844','2013-10-25','12:50:00',2.43),('15844','2013-10-25','12:55:00',2.4),('15844','2013-10-25','13:00:00',2.35),('15844','2013-10-25','13:05:00',2.33),('15844','2013-10-25','13:10:00',2.29),('15844','2013-10-25','13:15:00',2.25),('15844','2013-10-25','13:20:00',2.21),('15844','2013-10-25','13:25:00',2.14),('15844','2013-10-25','13:30:00',2.03),('15844','2013-10-25','13:35:00',1.99),('15844','2013-10-25','13:40:00',1.93),('15844','2013-10-25','13:45:00',1.87),('15844','2013-10-25','13:50:00',1.81),('15844','2013-10-25','13:55:00',1.72),('15844','2013-10-25','14:00:00',1.68),('15844','2013-10-25','14:05:00',1.61),('15844','2013-10-25','14:10:00',1.55),('15844','2013-10-25','14:15:00',1.46),('15844','2013-10-25','14:20:00',1.38),('15844','2013-10-25','14:25:00',1.27),('15844','2013-10-25','14:30:00',1.19),('15844','2013-10-25','14:35:00',1.14),('15844','2013-10-25','14:40:00',1.09),('15844','2013-10-25','14:45:00',1.01),('15844','2013-10-24','09:00:00',1),('15844','2013-10-24','09:05:00',1.08),('15844','2013-10-24','09:10:00',1.19),('15844','2013-10-24','09:50:00',1.01),('15844','2013-10-24','10:30:00',1.31),('15844','2013-10-24','10:35:00',1.67),('15844','2013-10-24','10:40:00',1.26),('15844','2013-10-24','10:45:00',1.65),('15844','2013-10-24','10:50:00',2.19),('15844','2013-10-24','10:55:00',2.12),('15844','2013-10-24','11:00:00',1.87),('15844','2013-10-24','11:05:00',1.53),('15844','2013-10-24','11:10:00',1.2),('15844','2013-10-24','11:15:00',1.27),('15844','2013-10-24','11:35:00',1.1),('15844','2013-10-24','11:40:00',1.35),('15844','2013-10-24','11:45:00',2.72),('15844','2013-10-24','11:50:00',2.47),('15844','2013-10-24','11:55:00',1.31),('15844','2013-10-24','12:00:00',1.18),('15844','2013-10-24','12:05:00',1.15),('15844','2013-10-24','12:10:00',1.18),('15844','2013-10-24','12:15:00',1.28),('15844','2013-10-24','12:20:00',1.52),('15844','2013-10-24','12:25:00',1.45),('15844','2013-10-24','12:30:00',1.55),('15844','2013-10-24','12:35:00',1.44),('15844','2013-10-24','12:40:00',1.43),('15844','2013-10-24','12:45:00',1.89),('15844','2013-10-24','12:50:00',1.86),('15844','2013-10-24','12:55:00',2.41),('15844','2013-10-24','13:00:00',1.67),('15844','2013-10-24','13:05:00',1.33),('15844','2013-10-24','13:10:00',1.28),('15844','2013-10-24','13:15:00',1.19),('15844','2013-10-24','13:20:00',1.1),('15844','2013-10-24','13:25:00',1.04),('15844','2013-10-24','13:30:00',1.02),('15844','2013-10-24','13:35:00',1.02),('15844','2013-10-24','13:40:00',1.04),('15844','2013-10-24','13:45:00',1.26),('15844','2013-10-24','13:50:00',1.82),('15844','2013-10-24','13:55:00',1.09),('15844','2013-10-24','14:00:00',1.06),('15844','2013-10-24','14:05:00',1.06),('15844','2013-10-24','14:10:00',1.1),('15844','2013-10-24','14:15:00',1.19),('15844','2013-10-24','14:20:00',1.17),('15844','2013-10-24','14:25:00',1.19),('15844','2013-10-24','14:30:00',1.27),('15844','2013-10-24','14:35:00',1.56),('15844','2013-10-24','14:40:00',1.21),('15844','2013-10-24','15:35:00',1.06),('15844','2013-10-23','10:15:00',1.03),('15844','2013-10-23','10:30:00',1.4),('15844','2013-10-23','10:35:00',1.79),('15844','2013-10-23','10:40:00',1.68),('15844','2013-10-23','10:45:00',1.44),('15844','2013-10-23','10:50:00',1.65),('15844','2013-10-23','10:55:00',1.63),('15844','2013-10-23','11:00:00',2.23),('15844','2013-10-23','11:05:00',2.48),('15844','2013-10-23','11:10:00',2.42),('15844','2013-10-23','11:15:00',2.42),('15844','2013-10-23','11:20:00',2.4),('15844','2013-10-23','11:25:00',2.42),('15844','2013-10-23','11:30:00',2.43),('15844','2013-10-23','11:35:00',2.51),('15844','2013-10-23','11:40:00',2.41),('15844','2013-10-23','11:45:00',2.34),('15844','2013-10-23','11:50:00',2.38),('15844','2013-10-23','11:55:00',2.32),('15844','2013-10-23','12:00:00',2.17),('15844','2013-10-23','12:05:00',1.96),('15844','2013-10-23','12:10:00',1.23),('15844','2013-10-23','12:15:00',1.4),('15844','2013-10-23','12:20:00',2.01),('15844','2013-10-23','12:25:00',2.24),('15844','2013-10-23','12:30:00',2.26),('15844','2013-10-23','12:35:00',1.97),('15844','2013-10-23','12:40:00',1.55),('15844','2013-10-23','12:45:00',1.23),('15844','2013-10-23','12:50:00',1.75),('15844','2013-10-23','12:55:00',2.13),('15844','2013-10-23','13:00:00',2.29),('15844','2013-10-23','13:05:00',2.31),('15844','2013-10-23','13:10:00',2.26),('15844','2013-10-23','13:15:00',2.15),('15844','2013-10-23','13:20:00',2.09),('15844','2013-10-23','13:25:00',1.97),('15844','2013-10-23','13:30:00',2.03),('15844','2013-10-23','13:35:00',1.92),('15844','2013-10-23','13:40:00',1.93),('15844','2013-10-23','13:45:00',1.94),('15844','2013-10-23','13:50:00',1.84),('15844','2013-10-23','13:55:00',1.68),('15844','2013-10-23','14:00:00',1.63),('15844','2013-10-23','14:05:00',1.58),('15844','2013-10-23','14:10:00',1.52),('15844','2013-10-23','14:15:00',1.42),('15844','2013-10-23','14:20:00',1.35),('15844','2013-10-23','14:25:00',1.33),('15844','2013-10-23','14:30:00',1.3),('15844','2013-10-23','14:35:00',1.24),('15844','2013-10-23','14:40:00',1.22),('15844','2013-10-23','14:45:00',1.14),('15844','2013-10-23','14:50:00',1.03),('15844','2013-10-22','09:05:00',1.03),('15844','2013-10-22','09:10:00',1.1),('15844','2013-10-22','09:15:00',1.17),('15844','2013-10-22','09:20:00',1.23),('15844','2013-10-22','09:25:00',1.36),('15844','2013-10-22','09:30:00',1.45),('15844','2013-10-22','09:35:00',1.51),('15844','2013-10-22','09:40:00',1.58),('15844','2013-10-22','09:45:00',1.62),('15844','2013-10-22','09:50:00',1.67),('15844','2013-10-22','09:55:00',1.69),('15844','2013-10-22','10:00:00',1.77),('15844','2013-10-22','10:05:00',1.82),('15844','2013-10-22','10:10:00',1.87),('15844','2013-10-22','10:15:00',1.93),('15844','2013-10-22','10:20:00',1.97),('15844','2013-10-22','10:25:00',1.99),('15844','2013-10-22','10:30:00',2.03),('15844','2013-10-22','10:35:00',2.03),('15844','2013-10-22','10:40:00',2.01),('15844','2013-10-22','10:45:00',2.06),('15844','2013-10-22','10:50:00',2.06),('15844','2013-10-22','10:55:00',2.18),('15844','2013-10-22','11:00:00',2.19),('15844','2013-10-22','11:05:00',2.25),('15844','2013-10-22','11:10:00',2.26),('15844','2013-10-22','11:15:00',2.22),('15844','2013-10-22','11:20:00',2.29),('15844','2013-10-22','11:25:00',2.32),('15844','2013-10-22','11:30:00',2.35),('15844','2013-10-22','11:35:00',2.39),('15844','2013-10-22','11:40:00',2.4),('15844','2013-10-22','11:45:00',2.41),('15844','2013-10-22','11:50:00',2.41),('15844','2013-10-22','11:55:00',2.36),('15844','2013-10-22','12:00:00',2.39),('15844','2013-10-22','12:05:00',2.31),('15844','2013-10-22','12:10:00',2.34),('15844','2013-10-22','12:15:00',2.37),('15844','2013-10-22','12:20:00',2.3),('15844','2013-10-22','12:25:00',2.25),('15844','2013-10-22','12:30:00',2.33),('15844','2013-10-22','12:35:00',2.31),('15844','2013-10-22','12:40:00',2.2),('15844','2013-10-22','12:45:00',2.18),('15844','2013-10-22','12:50:00',2.29),('15844','2013-10-22','12:55:00',2.36),('15844','2013-10-22','13:00:00',2.24),('15844','2013-10-22','13:05:00',2.16),('15844','2013-10-22','13:10:00',1.98),('15844','2013-10-22','13:15:00',2.06),('15844','2013-10-22','13:20:00',2.14),('15844','2013-10-22','13:25:00',2.15),('15844','2013-10-22','13:30:00',2.18),('15844','2013-10-22','13:35:00',2.15),('15844','2013-10-22','13:40:00',1.86),('15844','2013-10-22','13:45:00',1.13),('15844','2013-10-22','13:50:00',1.77),('15844','2013-10-22','13:55:00',1.05),('15844','2013-10-22','14:00:00',1.18),('15844','2013-10-22','14:05:00',1.81),('15844','2013-10-22','14:10:00',1.89),('15844','2013-10-22','14:15:00',1.73),('15844','2013-10-22','14:20:00',1.57),('15844','2013-10-22','14:25:00',1.39),('15844','2013-10-22','14:30:00',1.35),('15844','2013-10-22','14:35:00',1.28),('15844','2013-10-22','14:40:00',1.22),('15844','2013-10-22','14:45:00',1.12),('15844','2013-10-22','14:50:00',1.04),('15844','2013-10-21','09:10:00',1.13),('15844','2013-10-21','09:15:00',1.31),('15844','2013-10-21','09:20:00',1.34),('15844','2013-10-21','09:25:00',1.34),('15844','2013-10-21','09:30:00',1.33),('15844','2013-10-21','09:35:00',1.36),('15844','2013-10-21','09:40:00',1.43),('15844','2013-10-21','09:45:00',1.29),('15844','2013-10-21','09:50:00',1.45),('15844','2013-10-21','09:55:00',1.65),('15844','2013-10-21','10:00:00',1.83),('15844','2013-10-21','10:05:00',1.93),('15844','2013-10-21','10:10:00',2.04),('15844','2013-10-21','10:15:00',2.05),('15844','2013-10-21','10:20:00',2.18),('15844','2013-10-21','10:25:00',2.11),('15844','2013-10-21','10:30:00',2.12),('15844','2013-10-21','10:35:00',2.06),('15844','2013-10-21','10:40:00',2.13),('15844','2013-10-21','10:45:00',2.2),('15844','2013-10-21','10:50:00',2.34),('15844','2013-10-21','10:55:00',2.45),('15844','2013-10-21','11:00:00',2.19),('15844','2013-10-21','11:05:00',2.21),('15844','2013-10-21','11:10:00',2.5),('15844','2013-10-21','11:15:00',2.49),('15844','2013-10-21','11:20:00',2.36),('15844','2013-10-21','11:25:00',2.6),('15844','2013-10-21','11:30:00',2.58),('15844','2013-10-21','11:35:00',2.49),('15844','2013-10-21','11:40:00',2.61),('15844','2013-10-21','11:45:00',2.61),('15844','2013-10-21','11:50:00',2.54),('15844','2013-10-21','11:55:00',2.65),('15844','2013-10-21','12:00:00',2.64),('15844','2013-10-21','12:05:00',2.61),('15844','2013-10-21','12:10:00',2.57),('15844','2013-10-21','12:15:00',2.6),('15844','2013-10-21','12:20:00',2.6),('15844','2013-10-21','12:25:00',2.49),('15844','2013-10-21','12:30:00',2.48),('15844','2013-10-21','12:35:00',2.48),('15844','2013-10-21','12:40:00',2.49),('15844','2013-10-21','12:45:00',2.46),('15844','2013-10-21','12:50:00',2.42),('15844','2013-10-21','12:55:00',2.36),('15844','2013-10-21','13:00:00',2.29),('15844','2013-10-21','13:05:00',2.26),('15844','2013-10-21','13:10:00',2.19),('15844','2013-10-21','13:15:00',2.1),('15844','2013-10-21','13:20:00',2.21),('15844','2013-10-21','13:25:00',2.19),('15844','2013-10-21','13:30:00',2.21),('15844','2013-10-21','13:35:00',2.15),('15844','2013-10-21','13:40:00',2.09),('15844','2013-10-21','13:45:00',2.01),('15844','2013-10-21','13:50:00',1.89),('15844','2013-10-21','13:55:00',1.81),('15844','2013-10-21','14:00:00',1.8),('15844','2013-10-21','14:05:00',1.67),('15844','2013-10-21','14:10:00',1.61),('15844','2013-10-21','14:15:00',1.52),('15844','2013-10-21','14:20:00',1.42),('15844','2013-10-21','14:25:00',1.37),('15844','2013-10-21','14:30:00',1.29),('15844','2013-10-21','14:35:00',1.25),('15844','2013-10-21','14:40:00',1.16),('15844','2013-10-21','14:45:00',1.11),('15844','2013-10-21','14:50:00',1.03),('15844','2013-10-20','09:00:00',1.02),('15844','2013-10-20','09:05:00',1.1),('15844','2013-10-20','09:10:00',1.19),('15844','2013-10-20','09:15:00',1.24),('15844','2013-10-20','09:20:00',1.3),('15844','2013-10-20','09:25:00',1.35),('15844','2013-10-20','09:30:00',1.42),('15844','2013-10-20','09:35:00',1.58),('15844','2013-10-20','09:40:00',1.66),('15844','2013-10-20','09:45:00',1.73),('15844','2013-10-20','09:50:00',1.82),('15844','2013-10-20','09:55:00',1.87),('15844','2013-10-20','10:00:00',1.93),('15844','2013-10-20','10:05:00',1.98),('15844','2013-10-20','10:10:00',2.05),('15844','2013-10-20','10:15:00',2.13),('15844','2013-10-20','10:20:00',2.18),('15844','2013-10-20','10:25:00',2.22),('15844','2013-10-20','10:30:00',2.26),('15844','2013-10-20','10:35:00',2.28),('15844','2013-10-20','10:40:00',2.32),('15844','2013-10-20','10:45:00',2.35),('15844','2013-10-20','10:50:00',2.37),('15844','2013-10-20','10:55:00',2.39),('15844','2013-10-20','11:00:00',2.43),('15844','2013-10-20','11:05:00',2.46),('15844','2013-10-20','11:10:00',2.54),('15844','2013-10-20','11:15:00',2.59),('15844','2013-10-20','11:20:00',2.61),('15844','2013-10-20','11:25:00',2.64),('15844','2013-10-20','11:30:00',2.65),('15844','2013-10-20','11:35:00',2.66),('15844','2013-10-20','11:40:00',2.65),('15844','2013-10-20','11:45:00',2.63),('15844','2013-10-20','11:50:00',2.63),('15844','2013-10-20','11:55:00',2.69),('15844','2013-10-20','12:00:00',2.69),('15844','2013-10-20','12:05:00',2.64),('15844','2013-10-20','12:10:00',2.39),('15844','2013-10-20','12:15:00',2.25),('15844','2013-10-20','12:25:00',1.45),('15844','2013-10-20','12:30:00',1.14),('15844','2013-10-20','12:35:00',1.6),('15844','2013-10-20','12:40:00',2.39),('15844','2013-10-20','12:45:00',1.94),('15844','2013-10-20','12:50:00',2.82),('15844','2013-10-20','12:55:00',1.89),('15844','2013-10-20','13:00:00',1.33),('15844','2013-10-20','13:05:00',2.72),('15844','2013-10-20','13:10:00',3.09),('15844','2013-10-20','13:15:00',2.33),('15844','2013-10-20','13:35:00',1.51),('15844','2013-10-20','13:40:00',2),('15844','2013-10-20','13:45:00',1.81),('15844','2013-10-20','15:50:00',1),('15844','2013-10-19','08:55:00',1.1),('15844','2013-10-19','09:00:00',1.02),('15844','2013-10-19','09:05:00',1.05),('15844','2013-10-19','09:10:00',1.52),('15844','2013-10-19','09:15:00',1.58),('15844','2013-10-19','09:20:00',1.63),('15844','2013-10-19','09:25:00',1.64),('15844','2013-10-19','09:30:00',1.71),('15844','2013-10-19','09:35:00',1.86),('15844','2013-10-19','09:40:00',1.94),('15844','2013-10-19','09:45:00',1.98),('15844','2013-10-19','09:50:00',2.12),('15844','2013-10-19','09:55:00',2.14),('15844','2013-10-19','10:00:00',2.09),('15844','2013-10-19','10:05:00',2.19),('15844','2013-10-19','10:10:00',2.3),('15844','2013-10-19','10:15:00',2.36),('15844','2013-10-19','10:20:00',2.43),('15844','2013-10-19','10:25:00',2.53),('15844','2013-10-19','10:30:00',2.53),('15844','2013-10-19','10:35:00',2.53),('15844','2013-10-19','10:40:00',2.46),('15844','2013-10-19','10:45:00',2.54),('15844','2013-10-19','10:50:00',2.57),('15844','2013-10-19','10:55:00',2.54),('15844','2013-10-19','11:00:00',2.29),('15844','2013-10-19','11:05:00',1.53),('15844','2013-10-19','11:10:00',1.29),('15844','2013-10-19','11:15:00',2.53),('15844','2013-10-19','11:20:00',2.99),('15844','2013-10-19','11:25:00',2.96),('15844','2013-10-19','11:30:00',2.89),('15844','2013-10-19','11:35:00',2.82),('15844','2013-10-19','11:40:00',2.74),('15844','2013-10-19','11:45:00',2.55),('15844','2013-10-19','11:50:00',3),('15844','2013-10-19','11:55:00',2.96),('15844','2013-10-19','12:00:00',2.91),('15844','2013-10-19','12:05:00',2.86),('15844','2013-10-19','12:10:00',2.87),('15844','2013-10-19','12:15:00',2.71),('15844','2013-10-19','12:20:00',2.79),('15844','2013-10-19','12:25:00',2.5),('15844','2013-10-19','12:30:00',2.79),('15844','2013-10-19','12:35:00',2.84),('15844','2013-10-19','12:40:00',2.93),('15844','2013-10-19','12:45:00',2.85),('15844','2013-10-19','12:50:00',3.09),('15844','2013-10-19','12:55:00',3.1),('15844','2013-10-19','13:00:00',2.78),('15844','2013-10-19','13:05:00',2.78),('15844','2013-10-19','13:10:00',2.48),('15844','2013-10-19','13:15:00',2.52),('15844','2013-10-19','13:20:00',2.9),('15844','2013-10-19','13:25:00',2.07),('15844','2013-10-19','13:30:00',1.88),('15844','2013-10-19','13:35:00',1.74),('15844','2013-10-19','13:40:00',2.07),('15844','2013-10-19','13:45:00',2.4),('15844','2013-10-19','13:50:00',2.35),('15844','2013-10-19','13:55:00',2.14),('15844','2013-10-19','14:00:00',1.94),('15844','2013-10-19','14:05:00',2),('15844','2013-10-19','14:10:00',1.59),('15844','2013-10-19','14:15:00',1.36),('15844','2013-10-19','14:20:00',1.64),('15844','2013-10-19','14:25:00',1.82),('15844','2013-10-19','14:30:00',1.78),('15844','2013-10-19','14:35:00',1.31),('15844','2013-10-19','14:40:00',1.55),('15844','2013-10-19','14:45:00',1.4),('15844','2013-10-19','14:50:00',1.24),('15844','2013-10-19','14:55:00',1.11),('15844','2013-10-19','15:00:00',1.04),('15844','2014-05-04','08:20:00',1.07),('15844','2014-05-04','08:25:00',1.24),('15844','2014-05-04','08:30:00',1.22),('15844','2014-05-04','08:40:00',1.61),('15844','2014-05-04','08:45:00',1.46),('15844','2014-05-04','09:05:00',1.09),('15844','2014-05-04','09:10:00',1.31),('15844','2014-05-04','09:15:00',1.26),('15844','2014-05-04','09:20:00',1.41),('15844','2014-05-04','09:25:00',1.29),('15844','2014-05-04','09:30:00',1.94),('15844','2014-05-04','09:35:00',2.69),('15844','2014-05-04','09:40:00',2.11),('15844','2014-05-04','09:45:00',2.06),('15844','2014-05-04','09:50:00',2.47),('15844','2014-05-04','09:55:00',3.64),('15844','2014-05-04','10:00:00',3.53),('15844','2014-05-04','10:05:00',3.8),('15844','2014-05-04','10:10:00',2.65),('15844','2014-05-04','10:15:00',2.86),('15844','2014-05-04','10:20:00',1.99),('15844','2014-05-04','10:25:00',1.56),('15844','2014-05-04','10:30:00',1.5),('15844','2014-05-04','10:35:00',1.44),('15844','2014-05-04','10:40:00',1.72),('15844','2014-05-04','10:45:00',1.69),('15844','2014-05-04','10:50:00',1.64),('15844','2014-05-04','10:55:00',1.56),('15844','2014-05-04','11:00:00',1.49),('15844','2014-05-04','11:05:00',1.64),('15844','2014-05-04','11:10:00',2.69),('15844','2014-05-04','11:15:00',2.16),('15844','2014-05-04','11:20:00',3.02),('15844','2014-05-04','11:25:00',4.43),('15844','2014-05-04','11:30:00',4.2),('15844','2014-05-04','11:35:00',4.77),('15844','2014-05-04','11:40:00',4.92),('15844','2014-05-04','11:45:00',3.87),('15844','2014-05-04','11:50:00',5.02),('15844','2014-05-04','11:55:00',1.56),('15844','2014-05-04','12:00:00',1.96),('15844','2014-05-04','12:05:00',1.27),('15844','2014-05-04','12:15:00',1.1),('15844','2014-05-04','12:20:00',4.11),('15844','2014-05-04','12:25:00',4.95),('15844','2014-05-04','12:30:00',4.75),('15844','2014-05-04','12:35:00',1.42),('15844','2014-05-04','12:40:00',1.09),('15844','2014-05-04','12:45:00',1.22),('15844','2014-05-04','12:50:00',1.31),('15844','2014-05-04','12:55:00',1.06),('15844','2014-05-04','13:35:00',1.02),('15844','2014-05-04','13:40:00',1.14),('15844','2014-05-04','13:45:00',1.16),('15844','2014-05-04','13:50:00',1.22),('15844','2014-05-04','13:55:00',1.26),('15844','2014-05-04','14:00:00',1.42),('15844','2014-05-04','14:05:00',1.48),('15844','2014-05-04','14:45:00',1.13),('15844','2014-05-04','14:50:00',1.58),('15844','2014-05-04','14:55:00',2.55),('15844','2014-05-04','15:00:00',2.96),('15844','2014-05-04','15:05:00',2.05),('15844','2014-05-04','15:10:00',2.83),('15844','2014-05-04','15:15:00',2.59),('15844','2014-05-04','15:20:00',3.06),('15844','2014-05-04','15:25:00',2.13),('15844','2014-05-04','15:30:00',1.98),('15844','2014-05-04','15:35:00',1.15),('15844','2014-05-04','15:40:00',1.02),('15844','2014-05-04','15:45:00',1.01),('15844','2014-05-04','15:50:00',1),('15844','2014-05-04','17:30:00',1.03),('15844','2014-04-16','08:40:00',1.05),('15844','2014-04-16','08:45:00',1.4),('15844','2014-04-16','08:50:00',1.51),('15844','2014-04-16','08:55:00',1.56),('15844','2014-04-16','09:00:00',1.68),('15844','2014-04-16','09:05:00',1.82),('15844','2014-04-16','09:10:00',1.91),('15844','2014-04-16','09:15:00',2.02),('15844','2014-04-16','09:20:00',2.15),('15844','2014-04-16','09:25:00',2.32),('15844','2014-04-16','09:30:00',2.45),('15844','2014-04-16','09:35:00',2.27),('15844','2014-04-16','09:50:00',1.75),('15844','2014-04-16','09:55:00',2.53),('15844','2014-04-16','10:00:00',2.91),('15844','2014-04-16','10:05:00',2.93),('15844','2014-04-16','10:10:00',3.01),('15844','2014-04-16','10:15:00',3.16),('15844','2014-04-16','10:20:00',3.29),('15844','2014-04-16','10:25:00',3.41),('15844','2014-04-16','10:30:00',3.54),('15844','2014-04-16','10:35:00',3.63),('15844','2014-04-16','10:40:00',3.78),('15844','2014-04-16','10:45:00',3.91),('15844','2014-04-16','10:50:00',4.16),('15844','2014-04-16','10:55:00',4.13),('15844','2014-04-16','11:00:00',4.15),('15844','2014-04-16','11:05:00',4.02),('15844','2014-04-16','11:10:00',3.99),('15844','2014-04-16','11:15:00',2.67),('15844','2014-04-16','11:20:00',2.05),('15844','2014-04-16','11:25:00',4.53),('15844','2014-04-16','11:30:00',4.02),('15844','2014-04-16','11:35:00',3.7),('15844','2014-04-16','11:40:00',3.16),('15844','2014-04-16','11:45:00',3.66),('15844','2014-04-16','11:50:00',3.53),('15844','2014-04-16','11:55:00',3.36),('15844','2014-04-16','12:00:00',4.33),('15844','2014-04-16','12:05:00',3.02),('15844','2014-04-16','12:10:00',3.54),('15844','2014-04-16','12:15:00',3.96),('15844','2014-04-16','12:20:00',4.72),('15844','2014-04-16','12:25:00',4.73),('15844','2014-04-16','12:30:00',2.4),('15844','2014-04-16','12:35:00',4.75),('15844','2014-04-16','12:40:00',2.16),('15844','2014-04-16','12:45:00',4.68),('15844','2014-04-16','12:50:00',4.58),('15844','2014-04-16','12:55:00',4.6),('15844','2014-04-16','13:00:00',4.31),('15844','2014-04-16','13:05:00',2.37),('15844','2014-04-16','13:20:00',1.48),('15844','2014-04-16','13:25:00',4.38),('15844','2014-04-16','13:30:00',2.85),('15844','2014-04-16','13:35:00',1.94),('15844','2014-04-16','13:40:00',2.61),('15844','2014-04-16','13:45:00',3.88),('15844','2014-04-16','13:50:00',3.26),('15844','2014-04-16','13:55:00',3.81),('15844','2014-04-16','14:00:00',1.63),('15844','2014-04-16','14:05:00',1.55),('15844','2014-04-16','14:10:00',2.48),('15844','2014-04-16','14:15:00',2.58),('15844','2014-04-16','14:20:00',2.48),('15844','2014-04-16','14:25:00',3.53),('15844','2014-04-16','14:30:00',3.27),('15844','2014-04-16','14:35:00',2.93),('15844','2014-04-16','14:40:00',2.7),('15844','2014-04-16','14:45:00',2.44),('15844','2014-04-16','14:50:00',2.5),('15844','2014-04-16','14:55:00',1.53),('15844','2014-04-16','15:00:00',3.27),('15844','2014-04-16','15:05:00',1.81),('15844','2014-04-16','15:10:00',1.93),('15844','2014-04-16','15:35:00',1.23),('15844','2014-04-16','15:40:00',1.39),('15844','2014-04-16','16:05:00',1.25),('15844','2014-04-16','16:10:00',1.19),('15844','2014-04-16','16:15:00',1.15),('15844','2014-04-16','16:20:00',1.1),('15844','2013-10-18','08:55:00',1.07),('15844','2013-10-18','09:00:00',1.24),('15844','2013-10-18','09:05:00',1.33),('15844','2013-10-18','09:10:00',1.42),('15844','2013-10-18','09:15:00',1.44),('15844','2013-10-18','09:20:00',1.52),('15844','2013-10-18','09:25:00',1.6),('15844','2013-10-18','09:30:00',1.68),('15844','2013-10-18','09:35:00',1.84),('15844','2013-10-18','09:40:00',1.93),('15844','2013-10-18','09:45:00',2.01),('15844','2013-10-18','09:50:00',2.08),('15844','2013-10-18','09:55:00',2.14),('15844','2013-10-18','10:00:00',2.19),('15844','2013-10-18','10:05:00',2.27),('15844','2013-10-18','10:10:00',2.32),('15844','2013-10-18','10:15:00',2.36),('15844','2013-10-18','10:20:00',2.37),('15844','2013-10-18','10:25:00',2.47),('15844','2013-10-18','10:30:00',2.53),('15844','2013-10-18','10:35:00',2.53),('15844','2013-10-18','10:40:00',2.57),('15844','2013-10-18','10:45:00',2.58),('15844','2013-10-18','10:50:00',2.53),('15844','2013-10-18','10:55:00',2.6),('15844','2013-10-18','11:00:00',2.54),('15844','2013-10-18','11:05:00',2.56),('15844','2013-10-18','11:10:00',2.62),('15844','2013-10-18','11:15:00',2.73),('15844','2013-10-18','11:20:00',2.81),('15844','2013-10-18','11:25:00',2.75),('15844','2013-10-18','11:30:00',2.78),('15844','2013-10-18','11:35:00',2.88),('15844','2013-10-18','11:40:00',2.87),('15844','2013-10-18','11:45:00',2.66),('15844','2013-10-18','11:50:00',2.85),('15844','2013-10-18','11:55:00',2.85),('15844','2013-10-18','12:00:00',2.83),('15844','2013-10-18','12:05:00',2.81),('15844','2013-10-18','12:10:00',2.78),('15844','2013-10-18','12:15:00',2.74),('15844','2013-10-18','12:20:00',2.7),('15844','2013-10-18','12:25:00',2.72),('15844','2013-10-18','12:30:00',2.71),('15844','2013-10-18','12:35:00',2.66),('15844','2013-10-18','12:40:00',2.64),('15844','2013-10-18','12:45:00',2.58),('15844','2013-10-18','12:50:00',2.58),('15844','2013-10-18','12:55:00',2.61),('15844','2013-10-18','13:00:00',2.54),('15844','2013-10-18','13:05:00',2.48),('15844','2013-10-18','13:10:00',2.37),('15844','2013-10-18','13:15:00',2.42),('15844','2013-10-18','13:20:00',2.48),('15844','2013-10-18','13:25:00',2.43),('15844','2013-10-18','13:30:00',2.36),('15844','2013-10-18','13:35:00',2.3),('15844','2013-10-18','13:40:00',2.22),('15844','2013-10-18','13:45:00',2.14),('15844','2013-10-18','13:50:00',2.12),('15844','2013-10-18','13:55:00',1.96),('15844','2013-10-18','14:00:00',1.78),('15844','2013-10-18','14:05:00',1.77),('15844','2013-10-18','14:10:00',1.72),('15844','2013-10-18','14:15:00',1.67),('15844','2013-10-18','14:20:00',1.59),('15844','2013-10-18','14:25:00',1.52),('15844','2013-10-18','14:30:00',1.41),('15844','2013-10-18','14:35:00',1.32),('15844','2013-10-18','14:40:00',1.24),('15844','2013-10-18','14:45:00',1.12),('15844','2013-10-18','14:50:00',1.11),('15844','2013-10-18','14:55:00',1.01),('15844','2013-10-17','08:45:00',1),('15844','2013-10-17','08:50:00',1.09),('15844','2013-10-17','08:55:00',1.17),('15844','2013-10-17','09:00:00',1.27),('15844','2013-10-17','09:05:00',1.36),('15844','2013-10-17','09:10:00',1.44),('15844','2013-10-17','09:15:00',1.51),('15844','2013-10-17','09:20:00',1.6),('15844','2013-10-17','09:25:00',1.68),('15844','2013-10-17','09:30:00',1.76),('15844','2013-10-17','09:35:00',1.85),('15844','2013-10-17','09:40:00',1.95),('15844','2013-10-17','09:45:00',2.01),('15844','2013-10-17','09:50:00',2.1),('15844','2013-10-17','09:55:00',2.16),('15844','2013-10-17','10:00:00',2.21),('15844','2013-10-17','10:05:00',2.28),('15844','2013-10-17','10:10:00',2.33),('15844','2013-10-17','10:15:00',2.39),('15844','2013-10-17','10:20:00',2.44),('15844','2013-10-17','10:25:00',2.48),('15844','2013-10-17','10:30:00',2.51),('15844','2013-10-17','10:35:00',2.55),('15844','2013-10-17','10:40:00',2.6),('15844','2013-10-17','10:45:00',2.61),('15844','2013-10-17','10:50:00',2.64),('15844','2013-10-17','10:55:00',2.67),('15844','2013-10-17','11:00:00',2.7),('15844','2013-10-17','11:05:00',2.72),('15844','2013-10-17','11:10:00',2.77),('15844','2013-10-17','11:15:00',2.82),('15844','2013-10-17','11:20:00',2.88),('15844','2013-10-17','11:25:00',2.92),('15844','2013-10-17','11:30:00',2.93),('15844','2013-10-17','11:35:00',2.94),('15844','2013-10-17','11:40:00',2.95),('15844','2013-10-17','11:45:00',2.96),('15844','2013-10-17','11:50:00',2.96),('15844','2013-10-17','11:55:00',2.96),('15844','2013-10-17','12:00:00',2.97),('15844','2013-10-17','12:05:00',2.95),('15844','2013-10-17','12:10:00',2.92),('15844','2013-10-17','12:15:00',2.91),('15844','2013-10-17','12:20:00',2.88),('15844','2013-10-17','12:25:00',2.84),('15844','2013-10-17','12:30:00',2.82),('15844','2013-10-17','12:35:00',2.8),('15844','2013-10-17','12:40:00',2.83),('15844','2013-10-17','12:45:00',2.79),('15844','2013-10-17','12:50:00',2.78),('15844','2013-10-17','12:55:00',2.75),('15844','2013-10-17','13:00:00',2.73),('15844','2013-10-17','13:05:00',2.7),('15844','2013-10-17','13:10:00',2.66),('15844','2013-10-17','13:15:00',2.59),('15844','2013-10-17','13:20:00',2.57),('15844','2013-10-17','13:25:00',2.51),('15844','2013-10-17','13:30:00',2.46),('15844','2013-10-17','13:35:00',2.37),('15844','2013-10-17','13:40:00',2.35),('15844','2013-10-17','13:45:00',2.27),('15844','2013-10-17','13:50:00',2.21),('15844','2013-10-17','13:55:00',2.11),('15844','2013-10-17','14:00:00',2),('15844','2013-10-17','14:05:00',1.91),('15844','2013-10-17','14:10:00',1.8),('15844','2013-10-17','14:15:00',1.69),('15844','2013-10-17','14:20:00',1.6),('15844','2013-10-17','14:25:00',1.59),('15844','2013-10-17','14:30:00',1.49),('15844','2013-10-17','14:35:00',1.39),('15844','2013-10-17','14:40:00',1.33),('15844','2013-10-17','14:45:00',1.24),('15844','2013-10-17','14:50:00',1.15),('15844','2013-10-17','14:55:00',1.08),('15844','2013-10-16','09:40:00',1.09),('15844','2013-10-16','09:45:00',1.03),('15844','2013-10-16','11:10:00',1.16),('15844','2013-10-16','11:50:00',1.3),('15844','2013-10-16','12:05:00',1.18),('15844','2013-10-16','12:10:00',1.41),('15844','2013-10-16','12:15:00',1.07),('15844','2013-10-16','12:25:00',1.19),('15844','2013-10-16','12:30:00',1.83),('15844','2013-10-16','12:35:00',1.47),('15844','2013-10-16','12:50:00',1.07),('15844','2013-10-16','12:55:00',1.12),('15844','2013-10-16','13:20:00',2.35),('15844','2013-10-16','13:25:00',2.67),('15844','2013-10-16','13:30:00',2.24),('15844','2013-10-16','13:35:00',2),('15844','2013-10-16','13:40:00',2.59),('15844','2013-10-16','13:45:00',2.32),('15844','2013-10-16','13:50:00',2.43),('15844','2013-10-16','13:55:00',1.91),('15844','2013-10-16','14:05:00',2.06),('15844','2013-10-16','14:10:00',1.92),('15844','2013-10-16','14:15:00',1.82),('15844','2013-10-16','14:20:00',1.73),('15844','2013-10-16','14:25:00',1.15),('15844','2013-10-16','14:30:00',1.37),('15844','2013-10-16','14:35:00',1.44),('15844','2013-10-16','14:40:00',1.33),('15844','2013-10-16','14:45:00',1.2),('15844','2013-10-16','14:50:00',1.27),('15844','2013-10-16','14:55:00',1.21),('15844','2013-10-16','15:00:00',1.07),('15844','2013-10-15','09:25:00',1.28),('15844','2013-10-15','09:35:00',1.22),('15844','2013-10-15','09:40:00',1.48),('15844','2013-10-15','09:45:00',1.98),('15844','2013-10-15','09:50:00',2.08),('15844','2013-10-15','09:55:00',2.07),('15844','2013-10-15','10:00:00',2.13),('15844','2013-10-15','10:05:00',2.04),('15844','2013-10-15','10:10:00',1.27),('15844','2013-10-15','10:15:00',1.02),('15844','2013-10-15','10:20:00',1.39),('15844','2013-10-15','10:25:00',1.96),('15844','2013-10-15','10:30:00',1.66),('15844','2013-10-15','10:35:00',1.79),('15844','2013-10-15','10:40:00',2.2),('15844','2013-10-15','10:45:00',2.07),('15844','2013-10-15','10:50:00',1.57),('15844','2013-10-15','10:55:00',1.67),('15844','2013-10-15','11:00:00',1.59),('15844','2013-10-15','11:05:00',2.26),('15844','2013-10-15','11:10:00',2.54),('15844','2013-10-15','11:15:00',2.55),('15844','2013-10-15','11:20:00',2.49),('15844','2013-10-15','11:25:00',2.41),('15844','2013-10-15','11:30:00',2.21),('15844','2013-10-15','11:35:00',1.69),('15844','2013-10-15','11:40:00',1.33),('15844','2013-10-15','11:45:00',1.28),('15844','2013-10-15','11:50:00',1.25),('15844','2013-10-15','11:55:00',1.21),('15844','2013-10-15','12:00:00',1.17),('15844','2013-10-15','12:05:00',1.21),('15844','2013-10-15','12:10:00',1.22),('15844','2013-10-15','12:15:00',1.29),('15844','2013-10-15','12:20:00',1.28),('15844','2013-10-15','12:25:00',1.13),('15844','2013-10-15','12:30:00',1.14),('15844','2013-10-15','12:35:00',1.15),('15844','2013-10-15','12:40:00',1.23),('15844','2013-10-15','12:45:00',1.22),('15844','2013-10-15','12:50:00',1.08),('15844','2013-10-15','12:55:00',1.04),('15844','2013-10-15','13:00:00',1.19),('15844','2013-10-15','13:05:00',1.56),('15844','2013-10-15','13:10:00',1.5),('15844','2013-10-15','13:15:00',1.99),('15844','2013-10-15','13:20:00',2.57),('15844','2013-10-15','13:25:00',1.64),('15844','2013-10-15','13:30:00',1.48),('15844','2013-10-15','13:35:00',1.3),('15844','2013-10-15','13:40:00',1.42),('15844','2013-10-15','13:45:00',1.31),('15844','2013-10-15','13:50:00',1.16),('15844','2013-10-15','13:55:00',1.02),('15844','2013-10-15','14:05:00',1.01),('15844','2013-10-15','14:10:00',1.24),('15844','2013-10-15','14:15:00',1.58),('15844','2013-10-15','14:20:00',1.58),('15844','2013-10-15','14:25:00',1.63),('15844','2013-10-15','14:30:00',1.1),('15844','2013-10-15','14:35:00',1.23),('15844','2013-10-15','14:40:00',1.48),('15844','2013-10-15','14:45:00',1.44),('15844','2013-10-15','14:50:00',1.45),('15844','2013-10-14','09:20:00',1.35),('15844','2013-10-14','09:25:00',1.53),('15844','2013-10-14','09:30:00',1.69),('15844','2013-10-14','09:35:00',1.31),('15844','2013-10-14','09:40:00',1.58),('15844','2013-10-14','09:45:00',1.69),('15844','2013-10-14','09:50:00',1.84),('15844','2013-10-14','09:55:00',1.73),('15844','2013-10-14','10:00:00',2.05),('15844','2013-10-14','10:05:00',2.16),('15844','2013-10-14','10:10:00',2.22),('15844','2013-10-14','10:15:00',2.28),('15844','2013-10-14','10:20:00',2.31),('15844','2013-10-14','10:25:00',2.36),('15844','2013-10-14','10:30:00',2.4),('15844','2013-10-14','10:35:00',2.38),('15844','2013-10-14','10:40:00',2.37),('15844','2013-10-14','10:45:00',2.52),('15844','2013-10-14','10:50:00',2.55),('15844','2013-10-14','10:55:00',2.58),('15844','2013-10-14','11:00:00',2.62),('15844','2013-10-14','11:05:00',2.64),('15844','2013-10-14','11:10:00',2.72),('15844','2013-10-14','11:15:00',2.69),('15844','2013-10-14','11:20:00',2.74),('15844','2013-10-14','11:25:00',2.82),('15844','2013-10-14','11:30:00',2.84),('15844','2013-10-14','11:35:00',2.8),('15844','2013-10-14','11:40:00',2.75),('15844','2013-10-14','11:45:00',2.81),('15844','2013-10-14','11:50:00',2.8),('15844','2013-10-14','11:55:00',2.83),('15844','2013-10-14','12:00:00',2.84),('15844','2013-10-14','12:05:00',2.83),('15844','2013-10-14','12:10:00',2.82),('15844','2013-10-14','12:15:00',2.67),('15844','2013-10-14','12:20:00',2.54),('15844','2013-10-14','12:25:00',2.76),('15844','2013-10-14','12:30:00',2.75),('15844','2013-10-14','12:35:00',2.73),('15844','2013-10-14','12:40:00',2.73),('15844','2013-10-14','12:45:00',2.72),('15844','2013-10-14','12:50:00',2.68),('15844','2013-10-14','12:55:00',2.65),('15844','2013-10-14','13:00:00',2.64),('15844','2013-10-14','13:05:00',2.6),('15844','2013-10-14','13:10:00',2.57),('15844','2013-10-14','13:15:00',2.54),('15844','2013-10-14','13:20:00',2.51),('15844','2013-10-14','13:25:00',2.46),('15844','2013-10-14','13:30:00',2.39),('15844','2013-10-14','13:35:00',2.34),('15844','2013-10-14','13:40:00',2.27),('15844','2013-10-14','13:45:00',2.22),('15844','2013-10-14','13:50:00',2.16),('15844','2013-10-14','13:55:00',2.08),('15844','2013-10-14','14:00:00',1.96),('15844','2013-10-14','14:05:00',1.91),('15844','2013-10-14','14:10:00',1.82),('15844','2013-10-14','14:15:00',1.73),('15844','2013-10-14','14:20:00',1.63),('15844','2013-10-14','14:25:00',1.55),('15844','2013-10-14','14:30:00',1.49),('15844','2013-10-14','14:35:00',1.42),('15844','2013-10-14','14:40:00',1.34),('15844','2013-10-14','14:45:00',1.26),('15844','2013-10-14','14:50:00',1.19),('15844','2013-10-14','14:55:00',1.11),('15844','2013-10-14','15:00:00',1.02),('15844','2013-10-13','09:10:00',1.35),('15844','2013-10-13','09:15:00',1.65),('15844','2013-10-13','09:20:00',1.71),('15844','2013-10-13','09:25:00',1.09),('15844','2013-10-13','09:30:00',1.05),('15844','2013-10-13','09:35:00',1.81),('15844','2013-10-13','09:40:00',2.29),('15844','2013-10-13','09:45:00',2.09),('15844','2013-10-13','09:50:00',2.4),('15844','2013-10-13','09:55:00',1.99),('15844','2013-10-13','10:00:00',1.45),('15844','2013-10-13','10:05:00',2.16),('15844','2013-10-13','10:10:00',1.98),('15844','2013-10-13','10:15:00',1.86),('15844','2013-10-13','10:20:00',1.59),('15844','2013-10-13','10:25:00',2.02),('15844','2013-10-13','10:30:00',2.9),('15844','2013-10-13','10:35:00',3.17),('15844','2013-10-13','10:40:00',3.14),('15844','2013-10-13','10:45:00',3.01),('15844','2013-10-13','10:50:00',3.16),('15844','2013-10-13','10:55:00',3.38),('15844','2013-10-13','11:00:00',2.03),('15844','2013-10-13','11:05:00',2.45),('15844','2013-10-13','11:10:00',2.91),('15844','2013-10-13','11:15:00',2.93),('15844','2013-10-13','11:20:00',2.91),('15844','2013-10-13','11:25:00',2.88),('15844','2013-10-13','11:30:00',2.91),('15844','2013-10-13','11:35:00',2.89),('15844','2013-10-13','11:40:00',2.83),('15844','2013-10-13','11:45:00',2.89),('15844','2013-10-13','11:50:00',2.9),('15844','2013-10-13','11:55:00',2.9),('15844','2013-10-13','12:00:00',2.91),('15844','2013-10-13','12:05:00',2.92),('15844','2013-10-13','12:10:00',2.88),('15844','2013-10-13','12:15:00',2.89),('15844','2013-10-13','12:20:00',2.79),('15844','2013-10-13','12:25:00',2.78),('15844','2013-10-13','12:30:00',2.83),('15844','2013-10-13','12:35:00',2.83),('15844','2013-10-13','12:40:00',2.77),('15844','2013-10-13','12:45:00',2.72),('15844','2013-10-13','12:50:00',2.7),('15844','2013-10-13','12:55:00',2.67),('15844','2013-10-13','13:00:00',2.63),('15844','2013-10-13','13:05:00',2.63),('15844','2013-10-13','13:10:00',2.64),('15844','2013-10-13','13:15:00',2.65),('15844','2013-10-13','13:20:00',2.6),('15844','2013-10-13','13:25:00',2.09),('15844','2013-10-13','13:30:00',2.38),('15844','2013-10-13','13:35:00',2.17),('15844','2013-10-13','13:40:00',2.09),('15844','2013-10-13','13:45:00',2.21),('15844','2013-10-13','13:50:00',2.33),('15844','2013-10-13','13:55:00',1.6),('15844','2013-10-13','14:00:00',2.2),('15844','2013-10-13','14:05:00',2.15),('15844','2013-10-13','14:10:00',2.06),('15844','2013-10-13','14:15:00',1.93),('15844','2013-10-13','14:20:00',1.91),('15844','2013-10-13','14:25:00',1.82),('15844','2013-10-13','14:30:00',1.43),('15844','2013-10-13','14:35:00',1.32),('15844','2013-10-13','14:40:00',1.49),('15844','2013-10-13','14:45:00',1.25),('15844','2013-10-13','14:50:00',1.23),('15844','2013-10-13','14:55:00',1.28),('15844','2013-10-13','15:00:00',1.53),('15844','2013-10-13','15:05:00',1.37),('15844','2013-10-13','15:10:00',1.2),('15844','2013-10-13','15:15:00',1.14),('15844','2013-10-13','15:20:00',1.24),('15844','2013-10-13','15:25:00',1.08),('15844','2013-10-13','15:30:00',1.05),('15844','2013-10-12','11:20:00',1.02),('15844','2013-10-12','11:25:00',1.05),('15844','2013-10-12','11:30:00',1.55),('15844','2013-10-12','11:35:00',2.29),('15844','2013-10-12','11:40:00',1.48),('15844','2013-10-12','11:45:00',1.2),('15844','2013-10-12','11:50:00',1.11),('15844','2013-10-12','12:15:00',1.27),('15844','2013-10-12','12:20:00',2.83),('15844','2013-10-12','12:25:00',1.94),('15844','2013-10-12','12:30:00',2.06),('15844','2013-10-12','12:35:00',2.8),('15844','2013-10-12','12:40:00',2.48),('15844','2013-10-12','12:45:00',2.63),('15844','2013-10-12','12:50:00',2.28),('15844','2013-10-12','12:55:00',2.1),('15844','2013-10-12','13:00:00',1.05),('15844','2013-10-12','13:15:00',1.02),('15844','2013-10-12','13:20:00',1.2),('15844','2013-10-12','13:25:00',2.33),('15844','2013-10-12','13:30:00',1.55),('15844','2013-10-12','16:15:00',1.02),('15844','2013-10-12','16:20:00',1.11),('15844','2013-10-11','08:40:00',1.08),('15844','2013-10-11','08:55:00',1.06),('15844','2013-10-11','09:00:00',1.32),('15844','2013-10-11','09:05:00',1.45),('15844','2013-10-11','09:10:00',1.52),('15844','2013-10-11','09:15:00',1.57),('15844','2013-10-11','09:20:00',1.65),('15844','2013-10-11','09:25:00',1.79),('15844','2013-10-11','09:30:00',1.94),('15844','2013-10-11','09:35:00',2.06),('15844','2013-10-11','09:40:00',2.15),('15844','2013-10-11','09:45:00',2.23),('15844','2013-10-11','09:50:00',2.31),('15844','2013-10-11','09:55:00',2.31),('15844','2013-10-11','10:00:00',2.37),('15844','2013-10-11','10:05:00',2.42),('15844','2013-10-11','10:10:00',2.57),('15844','2013-10-11','10:15:00',2.63),('15844','2013-10-11','10:20:00',2.78),('15844','2013-10-11','10:25:00',2.92),('15844','2013-10-11','10:30:00',3.04),('15844','2013-10-11','10:35:00',3.59),('15844','2013-10-11','10:40:00',2.16),('15844','2013-10-11','10:45:00',2.89),('15844','2013-10-11','10:50:00',1.5),('15844','2013-10-11','10:55:00',2.51),('15844','2013-10-11','11:00:00',1.14),('15844','2013-10-11','11:40:00',1.86),('15844','2013-10-11','12:10:00',2.95),('15844','2013-10-11','12:15:00',3.07),('15844','2013-10-11','13:40:00',1.95),('15844','2013-10-11','13:45:00',1.8),('15844','2013-10-11','13:50:00',1.34),('15844','2013-10-10','08:40:00',1.04),('15844','2013-10-10','08:45:00',1.06),('15844','2013-10-10','08:50:00',1.2),('15844','2013-10-10','08:55:00',1.33),('15844','2013-10-10','09:00:00',1.4),('15844','2013-10-10','09:05:00',1.44),('15844','2013-10-10','09:10:00',1.49),('15844','2013-10-10','09:15:00',1.57),('15844','2013-10-10','09:20:00',1.67),('15844','2013-10-10','09:25:00',1.73),('15844','2013-10-10','09:30:00',1.77),('15844','2013-10-10','09:35:00',2),('15844','2013-10-10','09:40:00',2.06),('15844','2013-10-10','09:45:00',2.12),('15844','2013-10-10','09:50:00',2.23),('15844','2013-10-10','09:55:00',2.22),('15844','2013-10-10','10:00:00',2.23),('15844','2013-10-10','10:05:00',2.52),('15844','2013-10-10','10:10:00',1.65),('15844','2013-10-10','10:25:00',1.47),('15844','2013-10-10','10:30:00',1.79),('15844','2013-10-10','10:35:00',3.14),('15844','2013-10-10','10:40:00',3.02),('15844','2013-10-10','10:45:00',2.7),('15844','2013-10-10','10:50:00',1.11),('15844','2013-10-10','11:00:00',1.39),('15844','2013-10-10','11:05:00',2.76),('15844','2013-10-10','11:10:00',3.11),('15844','2013-10-10','11:15:00',3.36),('15844','2013-10-10','11:20:00',2.2),('15844','2013-10-10','11:25:00',2.72),('15844','2013-10-10','11:35:00',1.41),('15844','2013-10-10','11:40:00',2.55),('15844','2013-10-10','11:45:00',3.64),('15844','2013-10-10','11:50:00',3.74),('15844','2013-10-10','11:55:00',3.54),('15844','2013-10-10','12:00:00',3.13),('15844','2013-10-10','12:05:00',1.6),('15844','2013-10-10','12:10:00',3.7),('15844','2013-10-10','12:15:00',3),('15844','2013-10-10','12:20:00',2.52),('15844','2013-10-10','12:25:00',1.31),('15844','2013-10-10','12:30:00',2.53),('15844','2013-10-10','12:35:00',1.74),('15844','2013-10-10','12:40:00',3.81),('15844','2013-10-10','12:45:00',1.73),('15844','2013-10-10','12:50:00',3.16),('15844','2013-10-10','12:55:00',3.51),('15844','2013-10-10','13:00:00',3.22),('15844','2013-10-10','13:05:00',3.19),('15844','2013-10-10','13:10:00',1.53),('15844','2013-10-10','13:15:00',2.13),('15844','2013-10-10','13:20:00',3.02),('15844','2013-10-10','13:25:00',2.57),('15844','2013-10-10','13:30:00',1.43),('15844','2013-10-10','13:35:00',2.95),('15844','2013-10-10','13:40:00',2.34),('15844','2013-10-10','13:45:00',2.72),('15844','2013-10-10','13:50:00',2.24),('15844','2013-10-10','13:55:00',2.58),('15844','2013-10-10','14:00:00',1.87),('15844','2013-10-10','14:05:00',2.28),('15844','2013-10-10','14:10:00',1.22),('15844','2013-10-10','14:20:00',1.14),('15844','2013-10-10','14:25:00',2.21),('15844','2013-10-10','14:30:00',1.54),('15844','2013-10-10','14:35:00',1.8),('15844','2013-10-10','14:40:00',1.4),('15844','2013-10-10','14:45:00',1.57),('15844','2013-10-10','14:50:00',1.2),('15844','2013-10-10','14:55:00',1.38),('15844','2013-10-10','15:25:00',1.04),('15844','2013-10-10','15:30:00',1.06),('15844','2013-10-10','15:35:00',1.09),('15844','2013-10-10','15:40:00',1.02),('15844','2013-10-09','08:40:00',1.11),('15844','2013-10-09','08:45:00',1.18),('15844','2013-10-09','08:50:00',1.25),('15844','2013-10-09','08:55:00',1.32),('15844','2013-10-09','09:00:00',1.4),('15844','2013-10-09','09:05:00',1.5),('15844','2013-10-09','09:10:00',1.61),('15844','2013-10-09','09:15:00',1.36),('15844','2013-10-09','09:20:00',1.74),('15844','2013-10-09','09:25:00',1.89),('15844','2013-10-09','09:30:00',2.18),('15844','2013-10-09','09:35:00',2.37),('15844','2013-10-09','09:40:00',2.53),('15844','2013-10-09','09:45:00',2.48),('15844','2013-10-09','09:50:00',2.48),('15844','2013-10-09','09:55:00',2.58),('15844','2013-10-09','10:00:00',2.18),('15844','2013-10-09','11:15:00',1),('15844','2013-10-09','11:20:00',1.16),('15844','2013-10-09','11:25:00',1.28),('15844','2013-10-09','11:30:00',3.97),('15844','2013-10-09','11:35:00',3.09),('15844','2013-10-09','11:40:00',2.7),('15844','2013-10-09','11:45:00',1.82),('15844','2013-10-09','11:50:00',1.87),('15844','2013-10-09','11:55:00',2.54),('15844','2013-10-09','12:00:00',2.46),('15844','2013-10-09','12:05:00',2.23),('15844','2013-10-09','12:10:00',2.93),('15844','2013-10-09','12:15:00',3.2),('15844','2013-10-09','12:20:00',1.47),('15844','2013-10-09','12:25:00',1.5),('15844','2013-10-09','13:00:00',1.13),('15844','2013-10-09','13:05:00',1.59),('15844','2013-10-09','13:20:00',1.09),('15844','2013-10-09','13:25:00',2.58),('15844','2013-10-09','13:30:00',1.57),('15844','2013-10-09','13:35:00',2.8),('15844','2013-10-09','13:40:00',1.12),('15844','2013-10-09','14:00:00',2.79),('15844','2013-10-09','14:05:00',2.33),('15844','2013-10-09','14:10:00',1.76),('15844','2013-10-09','14:15:00',1.58),('15844','2013-10-09','14:20:00',1.65),('15844','2013-10-09','14:25:00',1.74),('15844','2013-10-09','14:35:00',2.13),('15844','2013-10-09','14:40:00',1.67),('15844','2013-10-09','14:45:00',1.09),('15844','2013-10-09','15:00:00',1.42),('15844','2013-10-09','15:05:00',1.16),('15844','2013-10-09','15:15:00',1.08),('15844','2013-10-09','15:30:00',1.06),('15844','2014-04-15','09:00:00',1.66),('15844','2014-04-15','09:05:00',1.45),('15844','2014-04-15','09:10:00',1.48),('15844','2014-04-15','09:15:00',1.77),('15844','2014-04-15','09:20:00',1.52),('15844','2014-04-15','09:25:00',1.54),('15844','2014-04-15','09:30:00',1.19),('15844','2014-04-15','10:00:00',1.56),('15844','2014-04-15','10:05:00',1.51),('15844','2014-04-15','10:10:00',1.59),('15844','2014-04-15','10:15:00',2.77),('15844','2014-04-15','10:20:00',1.85),('15844','2014-04-15','10:25:00',2.12),('15844','2014-04-15','10:30:00',1.31),('15844','2014-04-15','10:35:00',1.87),('15844','2014-04-15','10:40:00',3.06),('15844','2014-04-15','10:45:00',3.78),('15844','2014-04-15','10:50:00',4.25),('15844','2014-04-15','10:55:00',3.85),('15844','2014-04-15','11:00:00',4.4),('15844','2014-04-15','11:05:00',3.22),('15844','2014-04-15','11:10:00',1.7),('15844','2014-04-15','11:20:00',1.51),('15844','2014-04-15','11:25:00',1.17),('15844','2014-04-15','11:40:00',1.06),('15844','2014-04-15','11:45:00',1.16),('15844','2014-04-15','12:10:00',2.44),('15844','2014-04-15','12:15:00',1.95),('15844','2014-04-15','13:00:00',1.08),('15844','2014-04-15','13:05:00',1.34),('15844','2014-04-15','13:10:00',1.08),('15844','2014-04-15','13:15:00',1.84),('15844','2014-04-15','13:20:00',2.5),('15844','2014-04-15','13:35:00',2.62),('15844','2014-04-15','13:40:00',2.31),('15844','2014-04-15','13:45:00',1.61),('15844','2014-04-15','13:50:00',3.51),('15844','2014-04-15','13:55:00',2.11),('15844','2014-04-15','14:00:00',3.26),('15844','2014-04-15','14:05:00',1.56),('15844','2014-04-15','14:10:00',2.76),('15844','2014-04-15','14:15:00',3.8),('15844','2014-04-15','14:20:00',2.31),('15844','2014-04-15','14:25:00',2.13),('15844','2014-04-15','14:30:00',3.01),('15844','2014-04-15','14:35:00',2.36),('15844','2014-04-15','14:40:00',2.04),('15844','2014-04-15','14:45:00',1.54),('15844','2014-04-15','14:50:00',2.72),('15844','2014-04-15','14:55:00',2.58),('15844','2014-04-15','15:00:00',2.38),('15844','2014-04-15','15:05:00',2.06),('15844','2014-04-15','15:10:00',1.31),('15844','2014-04-15','15:15:00',1.54),('15844','2014-04-15','15:20:00',2.03),('15844','2014-04-15','15:25:00',2.36),('15844','2014-04-15','15:30:00',1.78),('15844','2014-04-15','15:35:00',1.59),('15844','2014-04-15','15:40:00',1.66),('15844','2014-04-15','15:45:00',1.4),('15844','2014-04-15','15:50:00',1.22),('15844','2014-04-15','15:55:00',1.17),('15844','2014-04-15','16:00:00',1.04),('15844','2013-10-08','09:45:00',2.08),('15844','2013-10-08','09:55:00',2.69),('15844','2013-10-08','10:00:00',2.41),('15844','2013-10-08','10:05:00',3.02),('15844','2013-10-08','10:10:00',2.15),('15844','2013-10-08','11:20:00',2.39),('15844','2013-10-08','11:25:00',1.14),('15844','2013-10-08','12:25:00',1.11),('15844','2013-10-08','12:30:00',1.17),('15844','2013-10-08','12:35:00',1.3),('15844','2013-10-08','12:45:00',1.04),('15844','2013-10-08','12:50:00',2.83),('15844','2013-10-08','12:55:00',1.73),('15844','2013-10-08','13:00:00',1.88),('15844','2013-10-08','13:05:00',1.92),('15844','2013-10-08','13:10:00',1.06),('15844','2013-10-08','13:15:00',1.08),('15844','2013-10-08','13:20:00',1.82),('15844','2013-10-08','13:25:00',1.03),('15844','2013-10-08','13:30:00',1.08),('15844','2013-10-08','13:45:00',1.08),('15844','2013-10-08','14:20:00',1.21),('15844','2013-10-08','14:25:00',1.39),('15844','2013-10-08','14:30:00',2.35),('15844','2013-10-08','14:35:00',1.97),('15844','2013-10-08','14:40:00',1.63),('15844','2013-10-08','14:45:00',1.86),('15844','2013-10-08','14:50:00',1.59),('15844','2013-10-08','14:55:00',1.4),('15844','2013-10-08','15:00:00',1.28),('15844','2013-10-08','15:05:00',1.07),('15844','2013-10-07','09:05:00',1.87),('15844','2013-10-07','09:10:00',2),('15844','2013-10-07','09:15:00',1.77),('15844','2013-10-07','09:20:00',1.77),('15844','2013-10-07','09:25:00',1.86),('15844','2013-10-07','09:30:00',2.05),('15844','2013-10-07','09:35:00',2.13),('15844','2013-10-07','09:40:00',2.22),('15844','2013-10-07','09:45:00',2.25),('15844','2013-10-07','09:50:00',2.3),('15844','2013-10-07','09:55:00',2.35),('15844','2013-10-07','10:00:00',2.42),('15844','2013-10-07','10:05:00',2.51),('15844','2013-10-07','10:10:00',2.55),('15844','2013-10-07','10:15:00',2.59),('15844','2013-10-07','10:20:00',2.64),('15844','2013-10-07','10:25:00',2.69),('15844','2013-10-07','10:30:00',2.74),('15844','2013-10-07','10:35:00',2.71),('15844','2013-10-07','10:40:00',2.7),('15844','2013-10-07','10:45:00',2.72),('15844','2013-10-07','10:50:00',2.68),('15844','2013-10-07','10:55:00',2.51),('15844','2013-10-07','11:00:00',3.2),('15844','2013-10-07','11:05:00',3.17),('15844','2013-10-07','11:10:00',3.02),('15844','2013-10-07','11:15:00',3.05),('15844','2013-10-07','11:20:00',3.09),('15844','2013-10-07','11:25:00',3.09),('15844','2013-10-07','11:30:00',2.63),('15844','2013-10-07','11:35:00',3.1),('15844','2013-10-07','11:40:00',3.46),('15844','2013-10-07','11:45:00',3.26),('15844','2013-10-07','11:50:00',3.26),('15844','2013-10-07','11:55:00',3.24),('15844','2013-10-07','12:00:00',3.16),('15844','2013-10-07','12:05:00',3.34),('15844','2013-10-07','12:10:00',1.21),('15844','2013-10-07','12:15:00',1.44),('15844','2013-10-07','12:25:00',1.21),('15844','2013-10-07','12:35:00',1.49),('15844','2013-10-07','12:40:00',2.76),('15844','2013-10-07','12:45:00',2.14),('15844','2013-10-07','12:50:00',2.07),('15844','2013-10-07','12:55:00',1.77),('15844','2013-10-07','13:00:00',1.6),('15844','2013-10-07','13:05:00',2.35),('15844','2013-10-07','13:10:00',2.76),('15844','2013-10-07','13:15:00',1.81),('15844','2013-10-07','13:20:00',2.81),('15844','2013-10-07','13:30:00',2.41),('15844','2013-10-07','13:40:00',1.32),('15844','2013-10-07','13:45:00',1.91),('15844','2013-10-07','13:50:00',3.04),('15844','2013-10-07','13:55:00',2.6),('15844','2013-10-07','14:00:00',3.01),('15844','2013-10-07','14:05:00',2.38),('15844','2013-10-07','14:10:00',2.24),('15844','2013-10-07','14:15:00',1.72),('15844','2013-10-07','14:20:00',2.19),('15844','2013-10-07','14:25:00',2.35),('15844','2013-10-07','14:30:00',2.22),('15844','2013-10-07','14:35:00',1.69),('15844','2013-10-07','14:40:00',1.91),('15844','2013-10-07','14:45:00',1.66),('15844','2013-10-07','14:50:00',1.18),('15844','2013-10-07','14:55:00',1.56),('15844','2013-10-07','15:00:00',1.4),('15844','2013-10-07','15:10:00',1.26),('15844','2013-10-07','15:15:00',1.13),('15844','2013-10-07','15:20:00',1.19),('15844','2013-10-07','15:30:00',1.01),('15844','2013-10-07','15:35:00',1.3),('15844','2013-10-06','09:05:00',1.28),('15844','2013-10-06','09:30:00',1.34),('15844','2013-10-06','09:35:00',1.92),('15844','2013-10-06','09:40:00',1.84),('15844','2013-10-06','09:45:00',1.72),('15844','2013-10-06','09:50:00',2.27),('15844','2013-10-06','09:55:00',2.43),('15844','2013-10-06','10:00:00',2.69),('15844','2013-10-06','10:05:00',2.41),('15844','2013-10-06','10:10:00',2.49),('15844','2013-10-06','10:15:00',2.4),('15844','2013-10-06','10:20:00',2.43),('15844','2013-10-06','10:25:00',2.77),('15844','2013-10-06','10:30:00',2.62),('15844','2013-10-06','10:35:00',2.36),('15844','2013-10-06','10:40:00',2),('15844','2013-10-06','10:45:00',2.27),('15844','2013-10-06','10:50:00',2.36),('15844','2013-10-06','10:55:00',2.52),('15844','2013-10-06','11:00:00',2.67),('15844','2013-10-06','11:05:00',2.57),('15844','2013-10-06','11:10:00',2.82),('15844','2013-10-06','11:15:00',2.74),('15844','2013-10-06','11:20:00',2.66),('15844','2013-10-06','11:25:00',2.2),('15844','2013-10-06','11:30:00',2.75),('15844','2013-10-06','11:35:00',2.21),('15844','2013-10-06','11:40:00',1.86),('15844','2013-10-06','11:45:00',2.08),('15844','2013-10-06','11:50:00',1.95),('15844','2013-10-06','11:55:00',2.52),('15844','2013-10-06','12:00:00',2.32),('15844','2013-10-06','12:05:00',2.92),('15844','2013-10-06','12:10:00',3.34),('15844','2013-10-06','12:15:00',2.49),('15844','2013-10-06','12:20:00',1.42),('15844','2013-10-06','12:25:00',2.88),('15844','2013-10-06','12:30:00',1.48),('15844','2013-10-06','12:35:00',2.75),('15844','2013-10-06','12:40:00',2.49),('15844','2013-10-06','12:45:00',2.53),('15844','2013-10-06','12:50:00',2.52),('15844','2013-10-06','12:55:00',2.68),('15844','2013-10-06','13:00:00',2.38),('15844','2013-10-06','13:05:00',3.06),('15844','2013-10-06','13:10:00',2.22),('15844','2013-10-06','13:15:00',2.22),('15844','2013-10-06','13:40:00',1.1),('15844','2013-10-06','13:45:00',2.18),('15844','2013-10-06','13:50:00',2.95),('15844','2013-10-06','13:55:00',1.92),('15844','2013-10-06','14:00:00',1.97),('15844','2013-10-06','14:05:00',1.25),('15844','2013-10-06','14:10:00',1.26),('15844','2013-10-06','14:15:00',1.47),('15844','2013-10-06','14:20:00',1.6),('15844','2013-10-06','14:25:00',1.97),('15844','2013-10-06','14:30:00',1.57),('15844','2013-10-06','14:35:00',1.25),('15844','2013-10-06','14:40:00',1.37),('15844','2013-10-06','14:45:00',1.44),('15844','2013-10-06','14:50:00',1.42),('15844','2013-10-06','14:55:00',1.29),('15844','2013-10-06','15:00:00',1.41),('15844','2013-10-06','15:05:00',1.22),('15844','2013-10-06','15:10:00',1.05),('15844','2013-10-06','15:15:00',1.04),('15844','2013-10-04','09:10:00',1.04),('15844','2013-10-04','09:25:00',1.38),('15844','2013-10-04','09:35:00',1.07),('15844','2013-10-04','09:40:00',1.16),('15844','2013-10-04','09:45:00',1.15),('15844','2013-10-04','09:50:00',1.32),('15844','2013-10-04','09:55:00',1.45),('15844','2013-10-04','10:00:00',1.31),('15844','2013-10-04','10:05:00',1.33),('15844','2013-10-04','10:10:00',1.38),('15844','2013-10-04','10:15:00',1.42),('15844','2013-10-04','10:20:00',1.59),('15844','2013-10-04','10:25:00',1.81),('15844','2013-10-04','10:30:00',2.31),('15844','2013-10-04','10:35:00',2.65),('15844','2013-10-04','10:40:00',2.97),('15844','2013-10-04','10:45:00',2.91),('15844','2013-10-04','10:50:00',1.66),('15844','2013-10-04','10:55:00',2.23),('15844','2013-10-04','11:00:00',2.45),('15844','2013-10-04','11:05:00',1.51),('15844','2013-10-04','11:10:00',1.83),('15844','2013-10-04','11:15:00',2.59),('15844','2013-10-04','11:20:00',2.63),('15844','2013-10-04','11:25:00',2.59),('15844','2013-10-04','11:30:00',3.21),('15844','2013-10-04','11:35:00',2.71),('15844','2013-10-04','11:40:00',2.39),('15844','2013-10-04','11:45:00',3.24),('15844','2013-10-04','11:50:00',3.21),('15844','2013-10-04','11:55:00',3.21),('15844','2013-10-04','12:00:00',3.23),('15844','2013-10-04','12:05:00',3.22),('15844','2013-10-04','12:10:00',2.86),('15844','2013-10-04','12:15:00',3.27),('15844','2013-10-04','12:20:00',3.2),('15844','2013-10-04','12:25:00',3.21),('15844','2013-10-04','12:30:00',3.2),('15844','2013-10-04','12:35:00',3.09),('15844','2013-10-04','12:40:00',3),('15844','2013-10-04','12:45:00',3.05),('15844','2013-10-04','12:50:00',2.88),('15844','2013-10-04','12:55:00',2.95),('15844','2013-10-04','13:00:00',2.96),('15844','2013-10-04','13:05:00',2.92),('15844','2013-10-04','13:10:00',2.98),('15844','2013-10-04','13:15:00',2.96),('15844','2013-10-04','13:20:00',2.81),('15844','2013-10-04','13:25:00',2.79),('15844','2013-10-04','13:30:00',2.87),('15844','2013-10-04','13:35:00',2.75),('15844','2013-10-04','13:40:00',2.67),('15844','2013-10-04','13:45:00',2.54),('15844','2013-10-04','13:50:00',2.49),('15844','2013-10-04','13:55:00',2.45),('15844','2013-10-04','14:00:00',2.36),('15844','2013-10-04','14:05:00',2.16),('15844','2013-10-04','14:10:00',1.91),('15844','2013-10-04','14:15:00',1.93),('15844','2013-10-04','14:20:00',2.04),('15844','2013-10-04','14:25:00',1.71),('15844','2013-10-04','14:30:00',1.46),('15844','2013-10-04','14:35:00',1.07),('15844','2013-10-04','14:40:00',1.22),('15844','2013-10-04','14:45:00',1.39),('15844','2013-10-04','14:50:00',1.67),('15844','2013-10-04','14:55:00',1.36),('15844','2013-10-04','15:00:00',1.41),('15844','2013-10-04','15:05:00',1.09),('15844','2013-10-04','15:10:00',1.08),('15844','2013-10-04','15:25:00',1.06),('15844','2013-10-04','15:30:00',1.07),('15844','2013-10-03','08:50:00',1.06),('15844','2013-10-03','08:55:00',1.18),('15844','2013-10-03','09:00:00',1.35),('15844','2013-10-03','09:05:00',1.5),('15844','2013-10-03','09:10:00',1.61),('15844','2013-10-03','09:15:00',1.72),('15844','2013-10-03','09:20:00',1.82),('15844','2013-10-03','09:25:00',1.9),('15844','2013-10-03','09:30:00',2),('15844','2013-10-03','09:35:00',2.08),('15844','2013-10-03','09:40:00',2.16),('15844','2013-10-03','09:45:00',2.26),('15844','2013-10-03','09:50:00',2.36),('15844','2013-10-03','09:55:00',2.42),('15844','2013-10-03','10:00:00',2.52),('15844','2013-10-03','10:05:00',2.59),('15844','2013-10-03','10:10:00',2.65),('15844','2013-10-03','10:15:00',2.73),('15844','2013-10-03','10:20:00',2.84),('15844','2013-10-03','10:25:00',2.88),('15844','2013-10-03','10:30:00',2.92),('15844','2013-10-03','10:35:00',2.98),('15844','2013-10-03','10:40:00',3),('15844','2013-10-03','10:45:00',3.04),('15844','2013-10-03','10:50:00',3.08),('15844','2013-10-03','10:55:00',3.11),('15844','2013-10-03','11:00:00',3.13),('15844','2013-10-03','11:05:00',3.18),('15844','2013-10-03','11:10:00',3.2),('15844','2013-10-03','11:15:00',3.24),('15844','2013-10-03','11:20:00',3.27),('15844','2013-10-03','11:25:00',3.3),('15844','2013-10-03','11:30:00',3.33),('15844','2013-10-03','11:35:00',3.33),('15844','2013-10-03','11:40:00',3.36),('15844','2013-10-03','11:45:00',3.37),('15844','2013-10-03','11:50:00',3.38),('15844','2013-10-03','11:55:00',3.38),('15844','2013-10-03','12:00:00',3.38),('15844','2013-10-03','12:05:00',3.37),('15844','2013-10-03','12:10:00',3.38),('15844','2013-10-03','12:15:00',3.37),('15844','2013-10-03','12:20:00',3.39),('15844','2013-10-03','12:25:00',3.36),('15844','2013-10-03','12:30:00',3.34),('15844','2013-10-03','12:35:00',3.31),('15844','2013-10-03','12:40:00',3.29),('15844','2013-10-03','12:45:00',3.22),('15844','2013-10-03','12:50:00',3.24),('15844','2013-10-03','12:55:00',3.22),('15844','2013-10-03','13:00:00',3.15),('15844','2013-10-03','13:05:00',3.16),('15844','2013-10-03','13:10:00',3.12),('15844','2013-10-03','13:15:00',3.08),('15844','2013-10-03','13:20:00',3.05),('15844','2013-10-03','13:25:00',3),('15844','2013-10-03','13:30:00',2.96),('15844','2013-10-03','13:35:00',2.89),('15844','2013-10-03','13:40:00',2.83),('15844','2013-10-03','13:45:00',2.77),('15844','2013-10-03','13:50:00',2.7),('15844','2013-10-03','13:55:00',2.62),('15844','2013-10-03','14:00:00',2.55),('15844','2013-10-03','14:05:00',2.45),('15844','2013-10-03','14:10:00',2.39),('15844','2013-10-03','14:15:00',2.29),('15844','2013-10-03','14:20:00',2.19),('15844','2013-10-03','14:25:00',2.1),('15844','2013-10-03','14:30:00',2),('15844','2013-10-03','14:35:00',1.9),('15844','2013-10-03','14:40:00',1.8),('15844','2013-10-03','14:45:00',1.68),('15844','2013-10-03','14:50:00',1.57),('15844','2013-10-03','14:55:00',1.45),('15844','2013-10-03','15:00:00',1.36),('15844','2013-10-03','15:05:00',1.23),('15844','2013-10-03','15:10:00',1.14),('15844','2013-10-03','15:15:00',1.09),('15844','2013-10-03','15:20:00',1.03),('15844','2013-10-02','08:55:00',1.1),('15844','2013-10-02','09:00:00',1.27),('15844','2013-10-02','09:05:00',1.43),('15844','2013-10-02','09:10:00',1.53),('15844','2013-10-02','09:15:00',1.63),('15844','2013-10-02','09:20:00',1.71),('15844','2013-10-02','09:25:00',1.83),('15844','2013-10-02','09:30:00',1.93),('15844','2013-10-02','09:35:00',2.01),('15844','2013-10-02','09:40:00',2.12),('15844','2013-10-02','09:45:00',2.22),('15844','2013-10-02','09:50:00',2.33),('15844','2013-10-02','09:55:00',2.4),('15844','2013-10-02','10:00:00',2.46),('15844','2013-10-02','10:05:00',2.52),('15844','2013-10-02','10:10:00',2.59),('15844','2013-10-02','10:15:00',2.68),('15844','2013-10-02','10:20:00',2.78),('15844','2013-10-02','10:25:00',2.84),('15844','2013-10-02','10:30:00',2.9),('15844','2013-10-02','10:35:00',2.95),('15844','2013-10-02','10:40:00',3.01),('15844','2013-10-02','10:45:00',3.03),('15844','2013-10-02','10:50:00',3.07),('15844','2013-10-02','10:55:00',3.1),('15844','2013-10-02','11:00:00',3.12),('15844','2013-10-02','11:05:00',3.15),('15844','2013-10-02','11:10:00',3.19),('15844','2013-10-02','11:15:00',3.22),('15844','2013-10-02','11:20:00',3.23),('15844','2013-10-02','11:25:00',3.27),('15844','2013-10-02','11:30:00',3.29),('15844','2013-10-02','11:35:00',3.32),('15844','2013-10-02','11:40:00',3.32),('15844','2013-10-02','11:45:00',3.34),('15844','2013-10-02','11:50:00',3.35),('15844','2013-10-02','11:55:00',3.35),('15844','2013-10-02','12:00:00',3.35),('15844','2013-10-02','12:05:00',3.32),('15844','2013-10-02','12:10:00',3.33),('15844','2013-10-02','12:15:00',3.32),('15844','2013-10-02','12:20:00',3.32),('15844','2013-10-02','12:25:00',3.31),('15844','2013-10-02','12:30:00',3.29),('15844','2013-10-02','12:35:00',3.27),('15844','2013-10-02','12:40:00',3.24),('15844','2013-10-02','12:45:00',3.23),('15844','2013-10-02','12:50:00',3.2),('15844','2013-10-02','12:55:00',3.17),('15844','2013-10-02','13:00:00',3.15),('15844','2013-10-02','13:05:00',3.13),('15844','2013-10-02','13:10:00',3.1),('15844','2013-10-02','13:15:00',3.04),('15844','2013-10-02','13:20:00',3),('15844','2013-10-02','13:25:00',2.97),('15844','2013-10-02','13:30:00',2.93),('15844','2013-10-02','13:35:00',2.86),('15844','2013-10-02','13:40:00',2.8),('15844','2013-10-02','13:45:00',2.72),('15844','2013-10-02','13:50:00',2.65),('15844','2013-10-02','13:55:00',2.62),('15844','2013-10-02','14:00:00',2.53),('15844','2013-10-02','14:05:00',2.44),('15844','2013-10-02','14:10:00',2.34),('15844','2013-10-02','14:15:00',2.26),('15844','2013-10-02','14:20:00',2.17),('15844','2013-10-02','14:25:00',2.09),('15844','2013-10-02','14:30:00',1.98),('15844','2013-10-02','14:35:00',1.89),('15844','2013-10-02','14:40:00',1.8),('15844','2013-10-02','14:45:00',1.69),('15844','2013-10-02','14:50:00',1.56),('15844','2013-10-02','14:55:00',1.45),('15844','2013-10-02','15:00:00',1.35),('15844','2013-10-02','15:05:00',1.22),('15844','2013-10-02','15:10:00',1.15),('15844','2013-10-02','15:15:00',1.09),('15844','2013-10-02','15:20:00',1.02),('15844','2013-10-01','08:50:00',1.11),('15844','2013-10-01','08:55:00',1.24),('15844','2013-10-01','09:00:00',1.39),('15844','2013-10-01','09:05:00',1.54),('15844','2013-10-01','09:10:00',1.67),('15844','2013-10-01','09:15:00',1.74),('15844','2013-10-01','09:20:00',1.84),('15844','2013-10-01','09:25:00',1.92),('15844','2013-10-01','09:30:00',2.02),('15844','2013-10-01','09:35:00',2.13),('15844','2013-10-01','09:40:00',2.19),('15844','2013-10-01','09:45:00',2.32),('15844','2013-10-01','09:50:00',2.38),('15844','2013-10-01','09:55:00',2.42),('15844','2013-10-01','10:00:00',2.45),('15844','2013-10-01','10:05:00',2.51),('15844','2013-10-01','10:10:00',2.58),('15844','2013-10-01','10:15:00',2.57),('15844','2013-10-01','10:20:00',2.66),('15844','2013-10-01','10:25:00',2.89),('15844','2013-10-01','10:30:00',2.61),('15844','2013-10-01','10:35:00',2.24),('15844','2013-10-01','10:40:00',2.03),('15844','2013-10-01','10:45:00',2.06),('15844','2013-10-01','10:50:00',3.09),('15844','2013-10-01','10:55:00',3.14),('15844','2013-10-01','11:00:00',3.07),('15844','2013-10-01','11:05:00',1.96),('15844','2013-10-01','11:10:00',3.09),('15844','2013-10-01','11:15:00',1.17),('15844','2013-10-01','11:20:00',2.34),('15844','2013-10-01','11:25:00',2.14),('15844','2013-10-01','11:35:00',1.83),('15844','2013-10-01','11:40:00',1.66),('15844','2013-10-01','11:45:00',3.66),('15844','2013-10-01','11:50:00',3.76),('15844','2013-10-01','11:55:00',3.54),('15844','2013-10-01','12:00:00',3.21),('15844','2013-10-01','12:05:00',1.64),('15844','2013-10-01','12:10:00',2.41),('15844','2013-10-01','12:15:00',2.63),('15844','2013-10-01','12:20:00',2.16),('15844','2013-10-01','12:25:00',3.61),('15844','2013-10-01','12:30:00',3.49),('15844','2013-10-01','12:35:00',3.54),('15844','2013-10-01','12:40:00',3.55),('15844','2013-10-01','12:45:00',3.4),('15844','2013-10-01','12:50:00',3.44),('15844','2013-10-01','12:55:00',3.41),('15844','2013-10-01','13:00:00',2),('15844','2013-10-01','13:05:00',1.24),('15844','2013-10-01','13:10:00',3.4),('15844','2013-10-01','13:15:00',3.27),('15844','2013-10-01','13:20:00',3.22),('15844','2013-10-01','13:25:00',3.1),('15844','2013-10-01','13:30:00',2.99),('15844','2013-10-01','13:35:00',2.92),('15844','2013-10-01','13:40:00',2.84),('15844','2013-10-01','13:45:00',1.66),('15844','2013-10-01','13:50:00',2.68),('15844','2013-10-01','13:55:00',2.67),('15844','2013-10-01','14:00:00',2.58),('15844','2013-10-01','14:05:00',2.08),('15844','2013-10-01','14:10:00',2.35),('15844','2013-10-01','14:15:00',2.24),('15844','2013-10-01','14:20:00',2.16),('15844','2013-10-01','14:25:00',2.07),('15844','2013-10-01','14:30:00',2),('15844','2013-10-01','14:35:00',1.68),('15844','2013-10-01','14:40:00',1.87),('15844','2013-10-01','14:45:00',1.8),('15844','2013-10-01','14:50:00',1.67),('15844','2013-10-01','14:55:00',1.52),('15844','2013-10-01','15:00:00',1.41),('15844','2013-10-01','15:05:00',1.27),('15844','2013-10-01','15:10:00',1.18),('15844','2013-10-01','15:15:00',1.14),('15844','2013-10-01','15:20:00',1.05),('15844','2013-10-01','15:25:00',1.01),('15844','2013-09-30','09:40:00',1.09),('15844','2013-09-30','09:45:00',1.73),('15844','2013-09-30','09:50:00',1.29),('15844','2013-09-30','10:15:00',1.01),('15844','2013-09-30','10:20:00',1.11),('15844','2013-09-30','10:25:00',1.32),('15844','2013-09-30','10:30:00',1.63),('15844','2013-09-30','10:35:00',1.8),('15844','2013-09-30','10:40:00',2.54),('15844','2013-09-30','10:45:00',3.43),('15844','2013-09-30','10:50:00',3.04),('15844','2013-09-30','10:55:00',2.51),('15844','2013-09-30','11:00:00',2.59),('15844','2013-09-30','11:05:00',3.36),('15844','2013-09-30','11:10:00',3.34),('15844','2013-09-30','11:15:00',3.21),('15844','2013-09-30','11:20:00',2.97),('15844','2013-09-30','11:25:00',3.35),('15844','2013-09-30','11:30:00',3.21),('15844','2013-09-30','11:35:00',2.42),('15844','2013-09-30','11:40:00',1.35),('15844','2013-09-30','11:55:00',3.57),('15844','2013-09-30','12:00:00',3.63),('15844','2013-09-30','12:05:00',3.68),('15844','2013-09-30','12:10:00',3.58),('15844','2013-09-30','12:15:00',3.57),('15844','2013-09-30','12:20:00',3.29),('15844','2013-09-30','12:25:00',3.38),('15844','2013-09-30','12:30:00',3.38),('15844','2013-09-30','12:35:00',3.41),('15844','2013-09-30','12:40:00',3.43),('15844','2013-09-30','12:45:00',3.4),('15844','2013-09-30','12:50:00',3.37),('15844','2013-09-30','12:55:00',3.35),('15844','2013-09-30','13:00:00',3.26),('15844','2013-09-30','13:05:00',3.4),('15844','2013-09-30','13:10:00',1.51),('15844','2013-09-30','13:15:00',1.94),('15844','2013-09-30','13:20:00',3.53),('15844','2013-09-30','13:25:00',2.54),('15844','2013-09-30','13:30:00',2.86),('15844','2013-09-30','13:35:00',3.31),('15844','2013-09-30','13:40:00',3.31),('15844','2013-09-30','13:45:00',1.86),('15844','2013-09-30','13:50:00',1.29),('15844','2013-09-30','14:05:00',1.18),('15844','2013-09-30','14:10:00',1.11),('15844','2013-09-30','14:25:00',1.43),('15844','2013-09-30','14:30:00',2.69),('15844','2013-09-30','14:35:00',3),('15844','2013-09-30','14:40:00',2.8),('15844','2013-09-30','14:45:00',1.33),('15844','2013-09-30','14:50:00',1.84),('15844','2013-09-30','15:10:00',1.28),('15844','2013-09-30','15:15:00',1.13),('15844','2013-09-30','15:20:00',1.09),('15844','2013-09-30','15:25:00',1.34),('15844','2013-09-30','15:30:00',1.03),('15844','2013-09-30','15:35:00',1.31),('15844','2013-09-29','09:55:00',1.11),('15844','2013-09-29','10:00:00',1.69),('15844','2013-09-29','10:05:00',1.63),('15844','2013-09-29','10:10:00',2.23),('15844','2013-09-29','10:15:00',2.26),('15844','2013-09-29','10:20:00',1.97),('15844','2013-09-29','10:25:00',2.07),('15844','2013-09-29','10:30:00',2.46),('15844','2013-09-29','10:35:00',2.54),('15844','2013-09-29','10:40:00',2.6),('15844','2013-09-29','10:45:00',2.71),('15844','2013-09-29','10:50:00',2.76),('15844','2013-09-29','10:55:00',2.74),('15844','2013-09-29','11:00:00',2.7),('15844','2013-09-29','11:05:00',2.58),('15844','2013-09-29','11:10:00',2.68),('15844','2013-09-29','11:15:00',2.84),('15844','2013-09-29','11:20:00',2.67),('15844','2013-09-29','11:25:00',2.6),('15844','2013-09-29','11:30:00',2.9),('15844','2013-09-29','11:35:00',2.96),('15844','2013-09-29','11:40:00',2.99),('15844','2013-09-29','11:45:00',2.92),('15844','2013-09-29','11:50:00',3.04),('15844','2013-09-29','11:55:00',2.86),('15844','2013-09-29','12:00:00',3.13),('15844','2013-09-29','12:05:00',1.87),('15844','2013-09-29','12:10:00',2.85),('15844','2013-09-29','12:15:00',2.1),('15844','2013-09-29','12:30:00',1.18),('15844','2013-09-29','12:35:00',1.16),('15844','2013-09-29','13:30:00',1.89),('15844','2013-09-29','13:35:00',1.95),('15844','2013-09-29','13:40:00',1.73),('15844','2013-09-29','13:45:00',2.3),('15844','2013-09-29','13:50:00',1.66),('15844','2013-09-29','13:55:00',1.67),('15844','2013-09-29','14:15:00',1.12),('15844','2013-09-29','14:20:00',1.33),('15844','2013-09-29','16:30:00',1.09),('15844','2014-04-14','08:35:00',1.03),('15844','2014-04-14','08:40:00',1.17),('15844','2014-04-14','08:45:00',1.25),('15844','2014-04-14','08:50:00',1.38),('15844','2014-04-14','08:55:00',1.44),('15844','2014-04-14','09:00:00',1.57),('15844','2014-04-14','09:05:00',1.67),('15844','2014-04-14','09:10:00',1.75),('15844','2014-04-14','09:15:00',1.82),('15844','2014-04-14','09:20:00',2.05),('15844','2014-04-14','09:25:00',2.18),('15844','2014-04-14','09:30:00',2.3),('15844','2014-04-14','09:35:00',2.39),('15844','2014-04-14','09:40:00',2.45),('15844','2014-04-14','09:45:00',2.52),('15844','2014-04-14','09:50:00',2.54),('15844','2014-04-14','09:55:00',2.58),('15844','2014-04-14','10:00:00',2.73),('15844','2014-04-14','10:05:00',2.83),('15844','2014-04-14','10:10:00',2.9),('15844','2014-04-14','10:15:00',2.97),('15844','2014-04-14','10:20:00',3.06),('15844','2014-04-14','10:25:00',3.09),('15844','2014-04-14','10:30:00',3.2),('15844','2014-04-14','10:35:00',3.36),('15844','2014-04-14','10:40:00',3.45),('15844','2014-04-14','10:45:00',3.53),('15844','2014-04-14','10:50:00',3.63),('15844','2014-04-14','10:55:00',3.76),('15844','2014-04-14','11:00:00',3.82),('15844','2014-04-14','11:05:00',3.87),('15844','2014-04-14','11:10:00',3.89),('15844','2014-04-14','11:15:00',3.91),('15844','2014-04-14','11:20:00',3.96),('15844','2014-04-14','11:25:00',3.98),('15844','2014-04-14','11:30:00',4),('15844','2014-04-14','11:35:00',4.03),('15844','2014-04-14','11:40:00',4.05),('15844','2014-04-14','11:45:00',4.04),('15844','2014-04-14','11:50:00',4.04),('15844','2014-04-14','11:55:00',4.05),('15844','2014-04-14','12:00:00',4.04),('15844','2014-04-14','12:05:00',4.04),('15844','2014-04-14','12:10:00',4.03),('15844','2014-04-14','12:15:00',4.04),('15844','2014-04-14','12:20:00',4.05),('15844','2014-04-14','12:25:00',4.01),('15844','2014-04-14','12:30:00',4.02),('15844','2014-04-14','12:35:00',4),('15844','2014-04-14','12:40:00',4.01),('15844','2014-04-14','12:45:00',3.99),('15844','2014-04-14','12:50:00',3.93),('15844','2014-04-14','12:55:00',3.93),('15844','2014-04-14','13:00:00',3.92),('15844','2014-04-14','13:05:00',3.9),('15844','2014-04-14','13:10:00',3.89),('15844','2014-04-14','13:15:00',3.88),('15844','2014-04-14','13:20:00',3.85),('15844','2014-04-14','13:25:00',3.82),('15844','2014-04-14','13:30:00',3.8),('15844','2014-04-14','13:35:00',3.76),('15844','2014-04-14','13:40:00',3.71),('15844','2014-04-14','13:45:00',3.67),('15844','2014-04-14','13:50:00',3.6),('15844','2014-04-14','13:55:00',3.54),('15844','2014-04-14','14:00:00',3.47),('15844','2014-04-14','14:05:00',3.41),('15844','2014-04-14','14:10:00',3.33),('15844','2014-04-14','14:15:00',3.25),('15844','2014-04-14','14:20:00',3.19),('15844','2014-04-14','14:25:00',3.09),('15844','2014-04-14','14:30:00',2.93),('15844','2014-04-14','14:35:00',2.88),('15844','2014-04-14','14:40:00',2.76),('15844','2014-04-14','14:45:00',2.71),('15844','2014-04-14','14:50:00',2.62),('15844','2014-04-14','14:55:00',2.53),('15844','2014-04-14','15:00:00',2.43),('15844','2014-04-14','15:05:00',2.33),('15844','2014-04-14','15:10:00',2.23),('15844','2014-04-14','15:15:00',2.15),('15844','2014-04-14','15:20:00',2.05),('15844','2014-04-14','15:25:00',1.98),('15844','2014-04-14','15:30:00',1.89),('15844','2014-04-14','15:35:00',1.78),('15844','2014-04-14','15:40:00',1.67),('15844','2014-04-14','15:45:00',1.56),('15844','2014-04-14','15:50:00',1.42),('15844','2014-04-14','15:55:00',1.27),('15844','2014-04-14','16:00:00',1.19),('15844','2014-04-14','16:05:00',1.14),('15844','2014-04-14','16:10:00',1.08),('15844','2014-04-14','16:15:00',1.05),('15844','2014-04-14','16:20:00',1),('15844','2013-09-28','08:50:00',1.05),('15844','2013-09-28','08:55:00',1.19),('15844','2013-09-28','09:00:00',1.35),('15844','2013-09-28','09:05:00',1.42),('15844','2013-09-28','09:10:00',1.47),('15844','2013-09-28','09:15:00',1.61),('15844','2013-09-28','09:20:00',1.72),('15844','2013-09-28','09:25:00',1.71),('15844','2013-09-28','09:30:00',1.84),('15844','2013-09-28','09:35:00',1.83),('15844','2013-09-28','09:45:00',1.3),('15844','2013-09-28','10:15:00',1.59),('15844','2013-09-28','10:20:00',2.76),('15844','2013-09-28','10:25:00',3.13),('15844','2013-09-28','10:30:00',3.26),('15844','2013-09-28','10:35:00',2.91),('15844','2013-09-28','10:55:00',2.15),('15844','2013-09-28','11:00:00',3.17),('15844','2013-09-28','11:05:00',3.27),('15844','2013-09-28','11:10:00',3.36),('15844','2013-09-28','11:15:00',3.5),('15844','2013-09-28','11:20:00',2.43),('15844','2013-09-28','11:30:00',1.52),('15844','2013-09-28','11:35:00',1.32),('15844','2013-09-28','11:40:00',2.36),('15844','2013-09-28','11:45:00',3.47),('15844','2013-09-28','11:50:00',3.39),('15844','2013-09-28','11:55:00',3.19),('15844','2013-09-28','12:00:00',3.3),('15844','2013-09-28','12:05:00',1.55),('15844','2013-09-28','12:10:00',1.6),('15844','2013-09-28','12:15:00',3.49),('15844','2013-09-28','12:20:00',2.66),('15844','2013-09-28','12:25:00',3.38),('15844','2013-09-28','12:30:00',3.2),('15844','2013-09-28','12:35:00',2.18),('15844','2013-09-28','12:40:00',2.27),('15844','2013-09-28','12:45:00',2.43),('15844','2013-09-28','12:50:00',3.28),('15844','2013-09-28','12:55:00',3.4),('15844','2013-09-28','13:00:00',3.25),('15844','2013-09-28','13:05:00',1.14),('15844','2013-09-28','13:10:00',2.14),('15844','2013-09-28','13:15:00',2.79),('15844','2013-09-28','13:20:00',2.83),('15844','2013-09-28','13:25:00',3.13),('15844','2013-09-28','13:30:00',3.03),('15844','2013-09-28','13:35:00',3.03),('15844','2013-09-28','13:40:00',2.38),('15844','2013-09-28','13:45:00',1.34),('15844','2013-09-28','13:50:00',1.65),('15844','2013-09-28','13:55:00',2.55),('15844','2013-09-28','14:00:00',2.37),('15844','2013-09-28','14:05:00',1.89),('15844','2013-09-28','14:10:00',2.49),('15844','2013-09-28','14:15:00',1.26),('15844','2013-09-28','14:30:00',1.26),('15844','2013-09-28','14:35:00',1.2),('15844','2013-09-28','14:40:00',1.85),('15844','2013-09-28','14:45:00',1.78),('15844','2013-09-28','14:50:00',1.96),('15844','2013-09-28','14:55:00',1.48),('15844','2013-09-28','15:00:00',1.54),('15844','2013-09-28','15:05:00',1.56),('15844','2013-09-28','15:10:00',1.45),('15844','2013-09-28','15:15:00',1.31),('15844','2013-09-28','15:20:00',1.22),('15844','2013-09-28','15:25:00',1.17),('15844','2013-09-28','15:30:00',1.11),('15844','2013-09-28','15:35:00',1.08),('15844','2013-09-28','15:40:00',1.01),('15844','2013-09-27','10:10:00',1.22),('15844','2013-09-27','10:20:00',1.02),('15844','2013-09-27','10:25:00',1.14),('15844','2013-09-27','10:35:00',1.83),('15844','2013-09-27','10:40:00',1.64),('15844','2013-09-27','10:45:00',1.54),('15844','2013-09-27','10:50:00',2.94),('15844','2013-09-27','10:55:00',2.58),('15844','2013-09-27','11:00:00',2.93),('15844','2013-09-27','11:05:00',3.09),('15844','2013-09-27','11:10:00',3.1),('15844','2013-09-27','11:15:00',3.13),('15844','2013-09-27','11:20:00',2.98),('15844','2013-09-27','11:25:00',3.15),('15844','2013-09-27','11:30:00',2.54),('15844','2013-09-27','11:35:00',1.52),('15844','2013-09-27','11:40:00',1.26),('15844','2013-09-27','11:45:00',1.45),('15844','2013-09-27','12:25:00',1.02),('15844','2013-09-27','12:30:00',2.06),('15844','2013-09-27','12:35:00',3.41),('15844','2013-09-27','12:40:00',3.3),('15844','2013-09-27','12:45:00',3.38),('15844','2013-09-27','12:50:00',3.43),('15844','2013-09-27','12:55:00',3.41),('15844','2013-09-27','13:00:00',1.2),('15844','2013-09-27','13:15:00',1.45),('15844','2013-09-27','13:20:00',1.73),('15844','2013-09-27','13:25:00',3.14),('15844','2013-09-27','13:30:00',3.02),('15844','2013-09-27','13:35:00',2.37),('15844','2013-09-27','13:40:00',2.47),('15844','2013-09-27','13:45:00',2.13),('15844','2013-09-27','13:50:00',1.59),('15844','2013-09-27','13:55:00',2.77),('15844','2013-09-27','14:00:00',2.81),('15844','2013-09-27','14:05:00',2.53),('15844','2013-09-27','14:10:00',2.37),('15844','2013-09-27','14:15:00',2.58),('15844','2013-09-27','14:20:00',2.01),('15844','2013-09-27','14:25:00',1.77),('15844','2013-09-27','14:30:00',1.41),('15844','2013-09-27','14:35:00',2.28),('15844','2013-09-27','14:40:00',2.08),('15844','2013-09-27','14:45:00',1.54),('15844','2013-09-27','14:50:00',1.7),('15844','2013-09-27','14:55:00',1.54),('15844','2013-09-27','15:00:00',1.18),('15844','2013-09-27','15:15:00',1.05),('15844','2013-09-27','15:25:00',1.25),('15844','2013-09-27','15:30:00',1.11),('15844','2013-09-27','15:35:00',1.06),('15844','2013-09-26','08:55:00',1.09),('15844','2013-09-26','09:05:00',1.28),('15844','2013-09-26','09:10:00',1.45),('15844','2013-09-26','09:15:00',1.52),('15844','2013-09-26','09:20:00',1.61),('15844','2013-09-26','09:25:00',1.76),('15844','2013-09-26','09:30:00',1.92),('15844','2013-09-26','09:35:00',2.06),('15844','2013-09-26','09:40:00',2.18),('15844','2013-09-26','09:45:00',2.26),('15844','2013-09-26','09:50:00',2.3),('15844','2013-09-26','09:55:00',2.38),('15844','2013-09-26','10:00:00',2.46),('15844','2013-09-26','10:05:00',2.49),('15844','2013-09-26','10:10:00',2.55),('15844','2013-09-26','10:15:00',2.58),('15844','2013-09-26','10:20:00',2.63),('15844','2013-09-26','10:25:00',2.67),('15844','2013-09-26','10:30:00',2.68),('15844','2013-09-26','10:35:00',2.73),('15844','2013-09-26','10:40:00',2.82),('15844','2013-09-26','10:45:00',2.79),('15844','2013-09-26','10:50:00',2.82),('15844','2013-09-26','10:55:00',3.03),('15844','2013-09-26','11:00:00',3.01),('15844','2013-09-26','11:05:00',3.01),('15844','2013-09-26','11:10:00',3.1),('15844','2013-09-26','11:15:00',3.11),('15844','2013-09-26','11:20:00',3.26),('15844','2013-09-26','11:25:00',3.21),('15844','2013-09-26','11:30:00',3.26),('15844','2013-09-26','11:35:00',3),('15844','2013-09-26','11:40:00',2.15),('15844','2013-09-26','11:45:00',3.32),('15844','2013-09-26','11:50:00',3.21),('15844','2013-09-26','11:55:00',3.28),('15844','2013-09-26','12:00:00',3.59),('15844','2013-09-26','12:05:00',2.29),('15844','2013-09-26','12:10:00',1.51),('15844','2013-09-26','12:15:00',1.34),('15844','2013-09-26','12:20:00',1.29),('15844','2013-09-26','12:25:00',1.43),('15844','2013-09-26','12:30:00',1.43),('15844','2013-09-26','12:35:00',1.31),('15844','2013-09-26','12:40:00',1.41),('15844','2013-09-26','12:45:00',1.7),('15844','2013-09-26','12:50:00',2.84),('15844','2013-09-26','12:55:00',2.54),('15844','2013-09-26','13:00:00',2.9),('15844','2013-09-26','13:05:00',3.31),('15844','2013-09-26','13:10:00',1.97),('15844','2013-09-26','13:15:00',2.33),('15844','2013-09-26','13:20:00',1.13),('15844','2013-09-26','13:25:00',3.27),('15844','2013-09-26','13:30:00',2.72),('15844','2013-09-26','13:35:00',2.32),('15844','2013-09-26','13:40:00',3.17),('15844','2013-09-26','13:45:00',2.2),('15844','2013-09-26','13:50:00',2.45),('15844','2013-09-26','13:55:00',2.66),('15844','2013-09-26','14:00:00',2.32),('15844','2013-09-26','14:05:00',2.48),('15844','2013-09-26','14:10:00',2.56),('15844','2013-09-26','14:15:00',1.11),('15844','2013-09-26','14:20:00',2.65),('15844','2013-09-26','14:25:00',2.28),('15844','2013-09-26','14:30:00',2.26),('15844','2013-09-26','14:35:00',1.92),('15844','2013-09-26','14:40:00',1.33),('15844','2013-09-26','14:45:00',1.54),('15844','2013-09-26','14:55:00',1.42),('15844','2013-09-26','15:00:00',1.15),('15844','2013-09-26','15:05:00',1.84),('15844','2013-09-26','15:10:00',1.63),('15844','2013-09-26','15:15:00',1.13),('15844','2013-09-26','15:30:00',1.25),('15844','2013-09-25','08:50:00',1.19),('15844','2013-09-25','08:55:00',1.32),('15844','2013-09-25','09:00:00',1.43),('15844','2013-09-25','09:20:00',1.37),('15844','2013-09-25','09:25:00',2.27),('15844','2013-09-25','09:30:00',2.04),('15844','2013-09-25','09:35:00',2.21),('15844','2013-09-25','10:00:00',1.15),('15844','2013-09-25','10:05:00',1.17),('15844','2013-09-25','10:50:00',2.75),('15844','2013-09-25','10:55:00',3.34),('15844','2013-09-25','11:00:00',3.35),('15844','2013-09-25','11:05:00',3.37),('15844','2013-09-25','11:10:00',3.55),('15844','2013-09-25','11:15:00',2.23),('15844','2013-09-25','11:20:00',1.02),('15844','2013-09-25','11:30:00',2.39),('15844','2013-09-25','11:35:00',3.48),('15844','2013-09-25','11:40:00',3.5),('15844','2013-09-25','11:45:00',3.53),('15844','2013-09-25','11:50:00',3.47),('15844','2013-09-25','11:55:00',2.29),('15844','2013-09-25','12:00:00',3.9),('15844','2013-09-25','12:05:00',3.51),('15844','2013-09-25','12:10:00',1.21),('15844','2013-09-25','12:15:00',1.08),('15844','2013-09-25','12:20:00',2.5),('15844','2013-09-25','12:25:00',2.98),('15844','2013-09-25','12:30:00',3.44),('15844','2013-09-25','12:35:00',1.28),('15844','2013-09-25','12:40:00',1.85),('15844','2013-09-25','12:45:00',1.71),('15844','2013-09-25','13:10:00',2.52),('15844','2013-09-25','13:15:00',1.18),('15844','2013-09-25','13:20:00',2.61),('15844','2013-09-25','13:25:00',3.8),('15844','2013-09-25','13:30:00',3.66),('15844','2013-09-25','13:35:00',3.39),('15844','2013-09-25','13:40:00',3.03),('15844','2013-09-25','13:50:00',3.19),('15844','2013-09-25','13:55:00',3.23),('15844','2013-09-25','14:00:00',2.94),('15844','2013-09-25','14:05:00',2.4),('15844','2013-09-25','14:10:00',1.49),('15844','2013-09-25','14:15:00',2.8),('15844','2013-09-25','14:20:00',1.09),('15844','2013-09-25','14:25:00',1.51),('15844','2013-09-25','14:30:00',2.57),('15844','2013-09-25','14:35:00',1.2),('15844','2013-09-25','14:50:00',1.67),('15844','2013-09-25','14:55:00',1.53),('15844','2013-09-25','15:10:00',1.3),('15844','2013-09-25','15:15:00',1.42),('15844','2013-09-25','15:20:00',1.5),('15844','2013-09-25','15:25:00',1.02),('15844','2013-09-25','15:30:00',1.19),('15844','2013-09-25','15:35:00',1.33),('15844','2013-09-25','15:40:00',1.22),('15844','2013-09-25','15:45:00',1.03),('15844','2013-09-25','15:50:00',1.15),('15844','2013-09-24','08:50:00',1.03),('15844','2013-09-24','08:55:00',1.12),('15844','2013-09-24','09:00:00',1.25),('15844','2013-09-24','09:05:00',1.36),('15844','2013-09-24','09:10:00',1.49),('15844','2013-09-24','09:15:00',1.59),('15844','2013-09-24','09:20:00',1.72),('15844','2013-09-24','09:25:00',1.88),('15844','2013-09-24','09:30:00',2),('15844','2013-09-24','09:35:00',2.15),('15844','2013-09-24','09:40:00',2.26),('15844','2013-09-24','09:45:00',2.35),('15844','2013-09-24','09:50:00',2.44),('15844','2013-09-24','09:55:00',2.52),('15844','2013-09-24','10:00:00',2.56),('15844','2013-09-24','10:05:00',2.64),('15844','2013-09-24','10:10:00',2.71),('15844','2013-09-24','10:15:00',2.78),('15844','2013-09-24','10:20:00',2.86),('15844','2013-09-24','10:25:00',2.88),('15844','2013-09-24','10:30:00',2.92),('15844','2013-09-24','10:35:00',2.98),('15844','2013-09-24','10:40:00',3.02),('15844','2013-09-24','10:45:00',3.04),('15844','2013-09-24','10:50:00',3.12),('15844','2013-09-24','10:55:00',3.19),('15844','2013-09-24','11:00:00',3.25),('15844','2013-09-24','11:05:00',3.22),('15844','2013-09-24','11:10:00',3.29),('15844','2013-09-24','11:15:00',3.31),('15844','2013-09-24','11:20:00',3.29),('15844','2013-09-24','11:25:00',3.34),('15844','2013-09-24','11:30:00',3.36),('15844','2013-09-24','11:35:00',3.39),('15844','2013-09-24','11:40:00',3.39),('15844','2013-09-24','11:45:00',3.43),('15844','2013-09-24','11:50:00',3.44),('15844','2013-09-24','11:55:00',3.44),('15844','2013-09-24','12:00:00',3.48),('15844','2013-09-24','12:05:00',3.46),('15844','2013-09-24','12:10:00',3.44),('15844','2013-09-24','12:15:00',3.47),('15844','2013-09-24','12:20:00',3.46),('15844','2013-09-24','12:25:00',3.44),('15844','2013-09-24','12:30:00',3.41),('15844','2013-09-24','12:35:00',3.44),('15844','2013-09-24','12:40:00',3.39),('15844','2013-09-24','12:45:00',3.4),('15844','2013-09-24','12:50:00',3.37),('15844','2013-09-24','12:55:00',3.3),('15844','2013-09-24','13:00:00',3.3),('15844','2013-09-24','13:05:00',3.32),('15844','2013-09-24','13:10:00',3.26),('15844','2013-09-24','13:15:00',3.21),('15844','2013-09-24','13:20:00',3.22),('15844','2013-09-24','13:25:00',3.15),('15844','2013-09-24','13:30:00',3.06),('15844','2013-09-24','13:35:00',3.06),('15844','2013-09-24','13:40:00',3),('15844','2013-09-24','13:45:00',2.94),('15844','2013-09-24','13:50:00',2.9),('15844','2013-09-24','13:55:00',2.81),('15844','2013-09-24','14:00:00',2.72),('15844','2013-09-24','14:05:00',2.68),('15844','2013-09-24','14:10:00',2.59),('15844','2013-09-24','14:15:00',2.46),('15844','2013-09-24','14:20:00',2.37),('15844','2013-09-24','14:25:00',2.27),('15844','2013-09-24','14:30:00',2.16),('15844','2013-09-24','14:35:00',2.06),('15844','2013-09-24','14:40:00',1.94),('15844','2013-09-24','14:45:00',1.89),('15844','2013-09-24','14:50:00',1.82),('15844','2013-09-24','14:55:00',1.7),('15844','2013-09-24','15:00:00',1.61),('15844','2013-09-24','15:05:00',1.47),('15844','2013-09-24','15:10:00',1.36),('15844','2013-09-24','15:15:00',1.23),('15844','2013-09-24','15:20:00',1.22),('15844','2013-09-24','15:25:00',1.18),('15844','2013-09-24','15:30:00',1.12),('15844','2013-09-24','15:35:00',1.07),('15844','2013-09-24','15:40:00',1.01),('15844','2013-09-23','08:45:00',1.11),('15844','2013-09-23','08:50:00',1.31),('15844','2013-09-23','08:55:00',1.41),('15844','2013-09-23','09:00:00',1.51),('15844','2013-09-23','09:05:00',1.62),('15844','2013-09-23','09:10:00',1.76),('15844','2013-09-23','09:15:00',1.88),('15844','2013-09-23','09:20:00',1.98),('15844','2013-09-23','09:25:00',2.07),('15844','2013-09-23','09:30:00',2.21),('15844','2013-09-23','09:35:00',2.36),('15844','2013-09-23','09:40:00',2.44),('15844','2013-09-23','09:45:00',2.52),('15844','2013-09-23','09:50:00',2.57),('15844','2013-09-23','09:55:00',2.62),('15844','2013-09-23','10:00:00',2.66),('15844','2013-09-23','10:05:00',2.7),('15844','2013-09-23','10:10:00',2.76),('15844','2013-09-23','10:15:00',2.87),('15844','2013-09-23','10:20:00',2.93),('15844','2013-09-23','10:25:00',2.97),('15844','2013-09-23','10:30:00',3),('15844','2013-09-23','10:35:00',3.03),('15844','2013-09-23','10:40:00',3.06),('15844','2013-09-23','10:45:00',3.1),('15844','2013-09-23','10:50:00',3.25),('15844','2013-09-23','10:55:00',3.33),('15844','2013-09-23','11:00:00',3.37),('15844','2013-09-23','11:05:00',3.4),('15844','2013-09-23','11:10:00',3.4),('15844','2013-09-23','11:15:00',3.43),('15844','2013-09-23','11:20:00',3.48),('15844','2013-09-23','11:25:00',3.49),('15844','2013-09-23','11:30:00',3.53),('15844','2013-09-23','11:35:00',3.54),('15844','2013-09-23','11:40:00',3.53),('15844','2013-09-23','11:45:00',3.57),('15844','2013-09-23','11:50:00',3.61),('15844','2013-09-23','11:55:00',3.56),('15844','2013-09-23','12:00:00',3.59),('15844','2013-09-23','12:05:00',3.58),('15844','2013-09-23','12:10:00',3.54),('15844','2013-09-23','12:15:00',3.54),('15844','2013-09-23','12:20:00',3.55),('15844','2013-09-23','12:25:00',3.53),('15844','2013-09-23','12:30:00',3.51),('15844','2013-09-23','12:35:00',3.52),('15844','2013-09-23','12:40:00',3.47),('15844','2013-09-23','12:45:00',3.44),('15844','2013-09-23','12:50:00',3.41),('15844','2013-09-23','12:55:00',3.36),('15844','2013-09-23','13:00:00',3.33),('15844','2013-09-23','13:05:00',3.32),('15844','2013-09-23','13:10:00',3.26),('15844','2013-09-23','13:15:00',3.23),('15844','2013-09-23','13:20:00',3.2),('15844','2013-09-23','13:25:00',3.18),('15844','2013-09-23','13:30:00',3.12),('15844','2013-09-23','13:35:00',3.07),('15844','2013-09-23','13:40:00',3.05),('15844','2013-09-23','13:45:00',2.96),('15844','2013-09-23','13:50:00',2.9),('15844','2013-09-23','13:55:00',2.84),('15844','2013-09-23','14:00:00',2.79),('15844','2013-09-23','14:05:00',2.69),('15844','2013-09-23','14:10:00',2.58),('15844','2013-09-23','14:15:00',2.53),('15844','2013-09-23','14:20:00',2.44),('15844','2013-09-23','14:25:00',2.33),('15844','2013-09-23','14:30:00',2.21),('15844','2013-09-23','14:35:00',2.1),('15844','2013-09-23','14:40:00',2.01),('15844','2013-09-23','14:45:00',1.92),('15844','2013-09-23','14:50:00',1.83),('15844','2013-09-23','14:55:00',1.72),('15844','2013-09-23','15:00:00',1.62),('15844','2013-09-23','15:05:00',1.51),('15844','2013-09-23','15:10:00',1.48),('15844','2013-09-23','15:15:00',1.46),('15844','2013-09-23','15:20:00',1.31),('15844','2013-09-23','15:25:00',1.24),('15844','2013-09-23','15:30:00',1.28),('15844','2013-09-23','15:35:00',1.26),('15844','2013-09-23','15:40:00',1.16),('15844','2013-09-23','15:45:00',1.04),('15844','2013-09-22','08:45:00',1),('15844','2013-09-22','08:50:00',1.05),('15844','2013-09-22','08:55:00',1.12),('15844','2013-09-22','09:00:00',1.28),('15844','2013-09-22','09:05:00',1.43),('15844','2013-09-22','09:10:00',1.54),('15844','2013-09-22','09:15:00',1.65),('15844','2013-09-22','09:20:00',1.81),('15844','2013-09-22','09:25:00',1.99),('15844','2013-09-22','09:30:00',2.15),('15844','2013-09-22','09:35:00',2.27),('15844','2013-09-22','09:40:00',2.37),('15844','2013-09-22','09:45:00',2.43),('15844','2013-09-22','09:50:00',2.53),('15844','2013-09-22','09:55:00',2.6),('15844','2013-09-22','10:00:00',2.66),('15844','2013-09-22','10:05:00',2.71),('15844','2013-09-22','10:10:00',2.79),('15844','2013-09-22','10:15:00',2.88),('15844','2013-09-22','10:20:00',2.94),('15844','2013-09-22','10:25:00',2.97),('15844','2013-09-22','10:30:00',3),('15844','2013-09-22','10:35:00',3.05),('15844','2013-09-22','10:40:00',3.11),('15844','2013-09-22','10:45:00',3.21),('15844','2013-09-22','10:50:00',3.31),('15844','2013-09-22','10:55:00',3.36),('15844','2013-09-22','11:00:00',3.4),('15844','2013-09-22','11:05:00',3.48),('15844','2013-09-22','11:10:00',3.5),('15844','2013-09-22','11:15:00',3.53),('15844','2013-09-22','11:20:00',3.57),('15844','2013-09-22','11:25:00',3.59),('15844','2013-09-22','11:30:00',3.59),('15844','2013-09-22','11:35:00',3.6),('15844','2013-09-22','11:40:00',3.6),('15844','2013-09-22','11:45:00',3.61),('15844','2013-09-22','11:50:00',3.6),('15844','2013-09-22','11:55:00',3.61),('15844','2013-09-22','12:00:00',3.6),('15844','2013-09-22','12:05:00',3.6),('15844','2013-09-22','12:10:00',3.59),('15844','2013-09-22','12:15:00',3.59),('15844','2013-09-22','12:20:00',3.61),('15844','2013-09-22','12:25:00',3.58),('15844','2013-09-22','12:30:00',3.57),('15844','2013-09-22','12:35:00',3.56),('15844','2013-09-22','12:40:00',3.53),('15844','2013-09-22','12:45:00',3.53),('15844','2013-09-22','12:50:00',3.5),('15844','2013-09-22','12:55:00',3.43),('15844','2013-09-22','13:00:00',3.42),('15844','2013-09-22','13:05:00',3.41),('15844','2013-09-22','13:10:00',3.39),('15844','2013-09-22','13:15:00',3.33),('15844','2013-09-22','13:20:00',3.32),('15844','2013-09-22','13:25:00',3.28),('15844','2013-09-22','13:30:00',3.26),('15844','2013-09-22','13:35:00',3.21),('15844','2013-09-22','13:40:00',3.17),('15844','2013-09-22','13:45:00',3.13),('15844','2013-09-22','13:50:00',3.17),('15844','2013-09-22','13:55:00',3.13),('15844','2013-09-22','14:00:00',2.78),('15844','2013-09-22','14:05:00',2.9),('15844','2013-09-22','14:10:00',2.98),('15844','2013-09-22','14:15:00',2.97),('15844','2013-09-22','14:20:00',1.87),('15844','2013-09-22','14:25:00',1.18),('15844','2013-09-22','14:30:00',1.8),('15844','2013-09-22','14:35:00',1.87),('15844','2013-09-22','14:40:00',2.13),('15844','2013-09-22','14:45:00',2.05),('15844','2013-09-22','14:50:00',1.95),('15844','2013-09-22','14:55:00',1.85),('15844','2013-09-22','15:00:00',1.79),('15844','2013-09-22','15:05:00',1.25),('15844','2013-09-22','15:15:00',1.23),('15844','2013-09-22','15:20:00',1.99),('15844','2013-09-22','15:25:00',1.74),('15844','2013-09-22','15:40:00',1.23),('15844','2013-09-22','15:45:00',1.05),('15844','2013-09-22','16:00:00',1.08),('15844','2013-09-21','08:45:00',1.05),('15844','2013-09-21','08:50:00',1.16),('15844','2013-09-21','08:55:00',1.28),('15844','2013-09-21','09:00:00',1.39),('15844','2013-09-21','09:05:00',1.5),('15844','2013-09-21','09:10:00',1.63),('15844','2013-09-21','09:15:00',1.73),('15844','2013-09-21','09:20:00',1.81),('15844','2013-09-21','09:25:00',1.93),('15844','2013-09-21','09:30:00',2.13),('15844','2013-09-21','09:35:00',2.22),('15844','2013-09-21','09:40:00',2.31),('15844','2013-09-21','09:45:00',2.41),('15844','2013-09-21','09:50:00',2.5),('15844','2013-09-21','09:55:00',2.58),('15844','2013-09-21','10:00:00',2.65),('15844','2013-09-21','10:05:00',2.7),('15844','2013-09-21','10:10:00',2.75),('15844','2013-09-21','10:15:00',2.83),('15844','2013-09-21','10:20:00',2.89),('15844','2013-09-21','10:25:00',2.93),('15844','2013-09-21','10:30:00',2.93),('15844','2013-09-21','10:35:00',2.97),('15844','2013-09-21','10:40:00',3.03),('15844','2013-09-21','10:45:00',3.09),('15844','2013-09-21','10:50:00',3.25),('15844','2013-09-21','10:55:00',3.33),('15844','2013-09-21','11:00:00',3.38),('15844','2013-09-21','11:05:00',3.42),('15844','2013-09-21','11:10:00',3.43),('15844','2013-09-21','11:15:00',3.44),('15844','2013-09-21','11:20:00',3.47),('15844','2013-09-21','11:25:00',3.46),('15844','2013-09-21','11:30:00',3.48),('15844','2013-09-21','11:35:00',3.49),('15844','2013-09-21','11:40:00',3.51),('15844','2013-09-21','11:45:00',3.54),('15844','2013-09-21','11:50:00',3.48),('15844','2013-09-21','11:55:00',3.54),('15844','2013-09-21','12:00:00',3.62),('15844','2013-09-21','12:05:00',3.57),('15844','2013-09-21','12:10:00',3.56),('15844','2013-09-21','12:15:00',3.59),('15844','2013-09-21','12:20:00',3.13),('15844','2013-09-21','12:25:00',3.6),('15844','2013-09-21','12:30:00',3.59),('15844','2013-09-21','12:35:00',3.23),('15844','2013-09-21','12:40:00',3.16),('15844','2013-09-21','12:45:00',3.48),('15844','2013-09-21','12:50:00',3.49),('15844','2013-09-21','12:55:00',3.49),('15844','2013-09-21','13:00:00',3.33),('15844','2013-09-21','13:05:00',3.41),('15844','2013-09-21','13:10:00',3.43),('15844','2013-09-21','13:15:00',2.94),('15844','2013-09-21','13:20:00',2.93),('15844','2013-09-21','13:25:00',3.12),('15844','2013-09-21','13:30:00',3.13),('15844','2013-09-21','13:35:00',2.81),('15844','2013-09-21','13:40:00',2.58),('15844','2013-09-21','13:45:00',2.69),('15844','2013-09-21','13:50:00',2.79),('15844','2013-09-21','13:55:00',2.59),('15844','2013-09-21','14:00:00',2.8),('15844','2013-09-21','14:05:00',2.61),('15844','2013-09-21','14:10:00',2.64),('15844','2013-09-21','14:15:00',2.58),('15844','2013-09-21','14:20:00',2.46),('15844','2013-09-21','14:25:00',2.31),('15844','2013-09-21','14:30:00',2.26),('15844','2013-09-21','14:35:00',2.17),('15844','2013-09-21','14:40:00',2.03),('15844','2013-09-21','14:45:00',1.99),('15844','2013-09-21','14:50:00',1.9),('15844','2013-09-21','14:55:00',1.78),('15844','2013-09-21','15:00:00',1.65),('15844','2013-09-21','15:05:00',1.52),('15844','2013-09-21','15:10:00',1.42),('15844','2013-09-21','15:15:00',1.42),('15844','2013-09-21','15:20:00',1.34),('15844','2013-09-21','15:25:00',1.24),('15844','2013-09-21','15:30:00',1.14),('15844','2013-09-21','15:35:00',1.09),('15844','2013-09-21','15:45:00',1.01),('15844','2013-09-20','08:35:00',1.19),('15844','2013-09-20','08:40:00',1.35),('15844','2013-09-20','09:40:00',1.18),('15844','2013-09-20','09:45:00',1.08),('15844','2013-09-20','09:50:00',1.16),('15844','2013-09-20','09:55:00',1.17),('15844','2013-09-20','10:00:00',1.22),('15844','2013-09-20','10:05:00',1.43),('15844','2013-09-20','10:10:00',1.44),('15844','2013-09-20','10:15:00',1.52),('15844','2013-09-20','10:20:00',1.56),('15844','2013-09-20','10:25:00',1.63),('15844','2013-09-20','10:30:00',1.97),('15844','2013-09-20','10:35:00',1.97),('15844','2013-09-20','10:40:00',2.82),('15844','2013-09-20','10:45:00',2.29),('15844','2013-09-20','10:50:00',1.83),('15844','2013-09-20','10:55:00',1.95),('15844','2013-09-20','11:00:00',1.73),('15844','2013-09-20','11:05:00',1.77),('15844','2013-09-20','11:10:00',2.19),('15844','2013-09-20','11:15:00',2.88),('15844','2013-09-20','11:20:00',3.14),('15844','2013-09-20','11:25:00',2.52),('15844','2013-09-20','11:30:00',3.13),('15844','2013-09-20','11:35:00',4.64),('15844','2013-09-20','11:40:00',4.45),('15844','2013-09-20','11:45:00',4.22),('15844','2013-09-20','11:50:00',4.04),('15844','2013-09-20','11:55:00',3.85),('15844','2013-09-20','12:00:00',3.75),('15844','2013-09-20','12:05:00',3.68),('15844','2013-09-20','12:10:00',3.7),('15844','2013-09-20','12:15:00',3.77),('15844','2013-09-20','12:20:00',2.13),('15844','2013-09-20','12:25:00',3.39),('15844','2013-09-20','12:30:00',3.96),('15844','2013-09-20','12:35:00',1.08),('15844','2013-09-20','12:40:00',3.18),('15844','2013-09-20','12:45:00',3.59),('15844','2013-09-20','12:50:00',3.49),('15844','2013-09-20','12:55:00',3.42),('15844','2013-09-20','13:00:00',3.43),('15844','2013-09-20','13:05:00',3.39),('15844','2013-09-20','13:10:00',3.31),('15844','2013-09-20','13:15:00',3.3),('15844','2013-09-20','13:20:00',3.34),('15844','2013-09-20','13:25:00',3.29),('15844','2013-09-20','13:30:00',3.26),('15844','2013-09-20','13:35:00',3.25),('15844','2013-09-20','13:40:00',3.21),('15844','2013-09-20','13:45:00',2.92),('15844','2013-09-20','13:50:00',2.82),('15844','2013-09-20','13:55:00',1.72),('15844','2013-09-20','14:20:00',1.69),('15844','2013-09-20','14:25:00',2.56),('15844','2013-09-20','14:30:00',1.33),('15844','2013-09-20','14:35:00',2.16),('15844','2013-09-20','14:40:00',1.07),('15844','2013-09-20','14:45:00',1.19),('15844','2013-09-20','14:50:00',1.96),('15844','2013-09-20','14:55:00',1.14),('15844','2013-09-20','15:00:00',1.05),('15844','2013-09-20','15:05:00',1.11),('15844','2013-09-20','15:10:00',1.29),('15844','2013-09-20','15:15:00',1.57),('15844','2013-09-20','15:20:00',1.59),('15844','2013-09-20','15:25:00',1.16),('15844','2013-09-19','08:40:00',1.02),('15844','2013-09-19','08:45:00',1.04),('15844','2013-09-19','08:50:00',1.07),('15844','2013-09-19','08:55:00',1.16),('15844','2013-09-19','09:05:00',1.5),('15844','2013-09-19','09:15:00',1.36),('15844','2013-09-19','09:20:00',1.01),('15844','2013-09-19','09:25:00',1.11),('15844','2013-09-19','09:40:00',1.99),('15844','2013-09-19','09:45:00',2.39),('15844','2013-09-19','09:50:00',2.4),('15844','2013-09-19','09:55:00',2.69),('15844','2013-09-19','10:00:00',2.91),('15844','2013-09-19','10:05:00',3.3),('15844','2013-09-19','10:10:00',2.56),('15844','2013-09-19','10:30:00',1.12),('15844','2013-09-19','10:35:00',1.23),('15844','2013-09-19','10:40:00',2.16),('15844','2013-09-19','10:45:00',3.26),('15844','2013-09-19','10:50:00',1.88),('15844','2013-09-19','10:55:00',2.07),('15844','2013-09-19','11:00:00',3.15),('15844','2013-09-19','11:05:00',2.92),('15844','2013-09-19','11:10:00',2.01),('15844','2013-09-19','11:20:00',1.07),('15844','2013-09-19','11:30:00',2.58),('15844','2013-09-19','11:35:00',2.87),('15844','2013-09-19','11:40:00',3.08),('15844','2013-09-19','11:45:00',1.73),('15844','2013-09-19','11:50:00',1.39),('15844','2013-09-19','11:55:00',2.26),('15844','2013-09-19','12:00:00',1.98),('15844','2013-09-19','12:05:00',3.9),('15844','2013-09-19','12:10:00',1.62),('15844','2013-09-19','12:15:00',2.59),('15844','2013-09-19','12:20:00',3.61),('15844','2013-09-19','12:25:00',3.83),('15844','2013-09-19','12:30:00',3.75),('15844','2013-09-19','12:35:00',3.78),('15844','2013-09-19','12:40:00',4.16),('15844','2013-09-19','12:45:00',4.32),('15844','2013-09-19','12:50:00',2.08),('15844','2013-09-19','12:55:00',3.06),('15844','2013-09-19','13:00:00',3.48),('15844','2013-09-19','13:05:00',3.59),('15844','2013-09-19','13:10:00',1.86),('15844','2013-09-19','13:15:00',3.85),('15844','2013-09-19','13:20:00',3.85),('15844','2013-09-19','13:25:00',3.76),('15844','2013-09-19','13:30:00',2.62),('15844','2013-09-19','13:40:00',3.04),('15844','2013-09-19','13:45:00',3.43),('15844','2013-09-19','13:50:00',3.42),('15844','2013-09-19','13:55:00',3.23),('15844','2013-09-19','14:00:00',2.03),('15844','2013-09-19','14:05:00',2.66),('15844','2013-09-19','14:10:00',3.04),('15844','2013-09-19','14:15:00',2.38),('15844','2013-09-19','14:20:00',2.66),('15844','2013-09-19','14:25:00',2.56),('15844','2013-09-19','14:30:00',2.46),('15844','2013-09-19','14:35:00',2.33),('15844','2013-09-19','14:40:00',2.27),('15844','2013-09-19','14:45:00',1.9),('15844','2013-09-19','14:50:00',2.23),('15844','2013-09-19','14:55:00',2.08),('15844','2013-09-19','15:00:00',1.58),('15844','2013-09-19','15:05:00',1.38),('15844','2013-09-19','15:10:00',1.53),('15844','2013-09-19','15:15:00',1.73),('15844','2013-09-19','15:20:00',1.44),('15844','2013-09-19','15:25:00',1.5),('15844','2013-09-19','15:30:00',1.2),('15844','2013-09-19','15:35:00',1.45),('15844','2013-09-19','15:40:00',1.34),('15844','2013-09-19','15:50:00',1.21),('15844','2013-09-19','15:55:00',1.03),('15844','2014-04-13','09:30:00',1.09),('15844','2014-04-13','09:35:00',1.19),('15844','2014-04-13','09:40:00',1.29),('15844','2014-04-13','09:45:00',1.42),('15844','2014-04-13','09:50:00',1.59),('15844','2014-04-13','09:55:00',1.59),('15844','2014-04-13','10:00:00',1.65),('15844','2014-04-13','10:05:00',2.89),('15844','2014-04-13','10:10:00',2.5),('15844','2014-04-13','10:15:00',2.18),('15844','2014-04-13','10:20:00',2.02),('15844','2014-04-13','10:25:00',2.38),('15844','2014-04-13','10:30:00',2.37),('15844','2014-04-13','10:35:00',3.34),('15844','2014-04-13','10:40:00',2.64),('15844','2014-04-13','10:45:00',3.58),('15844','2014-04-13','10:50:00',3.94),('15844','2014-04-13','10:55:00',2.69),('15844','2014-04-13','11:00:00',3.73),('15844','2014-04-13','11:05:00',3.59),('15844','2014-04-13','11:10:00',1.7),('15844','2014-04-13','11:15:00',2.23),('15844','2014-04-13','11:20:00',2.01),('15844','2014-04-13','11:25:00',1.98),('15844','2014-04-13','11:30:00',4.02),('15844','2014-04-13','11:35:00',3.53),('15844','2014-04-13','11:40:00',2.81),('15844','2014-04-13','11:45:00',2.16),('15844','2014-04-13','11:50:00',4.56),('15844','2014-04-13','11:55:00',3.03),('15844','2014-04-13','12:00:00',1.77),('15844','2014-04-13','12:05:00',1.49),('15844','2014-04-13','12:10:00',1.16),('15844','2014-04-13','12:15:00',1.63),('15844','2014-04-13','12:20:00',1.54),('15844','2014-04-13','12:55:00',1.06),('15844','2014-04-13','13:00:00',1.34),('15844','2014-04-13','13:05:00',1.98),('15844','2014-04-13','13:10:00',2.46),('15844','2014-04-13','13:15:00',4.36),('15844','2014-04-13','13:20:00',3.91),('15844','2014-04-13','13:25:00',2.31),('15844','2014-04-13','13:30:00',3.38),('15844','2014-04-13','13:35:00',3.65),('15844','2014-04-13','13:40:00',2.69),('15844','2014-04-13','13:45:00',2.34),('15844','2014-04-13','13:50:00',2.07),('15844','2014-04-13','13:55:00',2.15),('15844','2014-04-13','14:00:00',2.66),('15844','2014-04-13','14:05:00',3.14),('15844','2014-04-13','14:10:00',2.73),('15844','2014-04-13','14:15:00',1.85),('15844','2014-04-13','14:20:00',1.52),('15844','2014-04-13','14:25:00',1.48),('15844','2014-04-13','14:30:00',1.47),('15844','2014-04-13','14:35:00',1.45),('15844','2014-04-13','14:40:00',1.37),('15844','2014-04-13','14:45:00',2.71),('15844','2014-04-13','14:50:00',2.87),('15844','2014-04-13','14:55:00',2.67),('15844','2014-04-13','15:00:00',2.49),('15844','2014-04-13','15:05:00',2.42),('15844','2014-04-13','15:10:00',2.06),('15844','2014-04-13','15:15:00',2.04),('15844','2014-04-13','15:20:00',2.16),('15844','2014-04-13','15:25:00',2.25),('15844','2014-04-13','15:30:00',1.52),('15844','2014-04-13','15:35:00',1.17),('15844','2014-04-13','15:40:00',1.35),('15844','2014-04-13','15:45:00',1.36),('15844','2014-04-13','15:50:00',1.08),('15844','2014-04-13','15:55:00',1.51),('15844','2014-04-13','16:00:00',1.39),('15844','2014-04-13','16:05:00',1.07),('15844','2014-04-13','16:20:00',1.2),('15844','2014-04-13','16:30:00',1.07),('15844','2014-04-13','16:35:00',1.25),('15844','2014-04-13','16:40:00',1.36),('15844','2014-04-13','16:45:00',1.35),('15844','2014-04-13','16:50:00',1.12),('15844','2013-09-18','09:05:00',1.21),('15844','2013-09-18','09:10:00',1.94),('15844','2013-09-18','09:15:00',1.45),('15844','2013-09-18','09:30:00',2),('15844','2013-09-18','09:35:00',1.31),('15844','2013-09-18','09:40:00',1.2),('15844','2013-09-18','09:45:00',1.06),('15844','2013-09-18','09:50:00',2),('15844','2013-09-18','09:55:00',2.74),('15844','2013-09-18','10:00:00',2.29),('15844','2013-09-18','10:05:00',1.83),('15844','2013-09-18','10:10:00',2.77),('15844','2013-09-18','10:15:00',2.84),('15844','2013-09-18','10:20:00',2.88),('15844','2013-09-18','10:25:00',2.95),('15844','2013-09-18','10:30:00',2.99),('15844','2013-09-18','10:35:00',3.03),('15844','2013-09-18','10:40:00',3.08),('15844','2013-09-18','10:45:00',3.09),('15844','2013-09-18','10:50:00',3.24),('15844','2013-09-18','10:55:00',3.37),('15844','2013-09-18','11:00:00',3.48),('15844','2013-09-18','11:05:00',3.58),('15844','2013-09-18','11:10:00',3.5),('15844','2013-09-18','11:15:00',3.5),('15844','2013-09-18','11:20:00',3.61),('15844','2013-09-18','11:25:00',3.65),('15844','2013-09-18','11:30:00',3.42),('15844','2013-09-18','11:35:00',3.37),('15844','2013-09-18','11:40:00',3.18),('15844','2013-09-18','11:45:00',3.72),('15844','2013-09-18','11:50:00',3.75),('15844','2013-09-18','11:55:00',3.77),('15844','2013-09-18','12:00:00',3.89),('15844','2013-09-18','12:05:00',3.86),('15844','2013-09-18','12:10:00',2),('15844','2013-09-18','12:15:00',3.25),('15844','2013-09-18','12:20:00',3.23),('15844','2013-09-18','12:25:00',2.93),('15844','2013-09-18','12:30:00',1.2),('15844','2013-09-18','12:35:00',4.01),('15844','2013-09-18','12:40:00',3.95),('15844','2013-09-18','12:45:00',4),('15844','2013-09-18','12:50:00',3.96),('15844','2013-09-18','12:55:00',3.92),('15844','2013-09-18','13:00:00',3.85),('15844','2013-09-18','13:05:00',3.62),('15844','2013-09-18','13:10:00',3.32),('15844','2013-09-18','13:15:00',3.58),('15844','2013-09-18','13:20:00',2.43),('15844','2013-09-18','13:25:00',2.03),('15844','2013-09-18','13:30:00',1.8),('15844','2013-09-18','13:35:00',1.41),('15844','2013-09-18','13:40:00',3.25),('15844','2013-09-18','13:45:00',2.68),('15844','2013-09-18','13:50:00',2.29),('15844','2013-09-18','13:55:00',3.19),('15844','2013-09-18','14:00:00',1.48),('15844','2013-09-18','14:05:00',1.1),('15844','2013-09-18','14:10:00',3.25),('15844','2013-09-18','14:15:00',3.11),('15844','2013-09-18','14:20:00',2.29),('15844','2013-09-18','14:25:00',2.62),('15844','2013-09-18','14:30:00',1.97),('15844','2013-09-18','14:35:00',1.58),('15844','2013-09-18','14:40:00',2.32),('15844','2013-09-18','14:45:00',2.27),('15844','2013-09-18','14:50:00',2.19),('15844','2013-09-18','14:55:00',2.11),('15844','2013-09-18','15:00:00',2.16),('15844','2013-09-18','15:05:00',1.99),('15844','2013-09-18','15:10:00',2.03),('15844','2013-09-18','15:15:00',1.05),('15844','2013-09-18','15:20:00',1.24),('15844','2013-09-18','15:25:00',1.81),('15844','2013-09-18','15:30:00',1.34),('15844','2013-09-18','15:35:00',1.21),('15844','2013-09-18','15:40:00',1.26),('15844','2013-09-18','15:45:00',1.13),('15844','2013-09-18','15:55:00',1.07),('15844','2013-09-17','09:40:00',1.7),('15844','2013-09-17','09:45:00',2.29),('15844','2013-09-17','09:50:00',1.17),('15844','2013-09-17','09:55:00',1.74),('15844','2013-09-17','10:00:00',1.85),('15844','2013-09-17','10:05:00',1.87),('15844','2013-09-17','10:20:00',1.37),('15844','2013-09-17','10:25:00',2.29),('15844','2013-09-17','10:30:00',1.42),('15844','2013-09-17','10:40:00',1.9),('15844','2013-09-17','10:45:00',3.82),('15844','2013-09-17','10:50:00',3.72),('15844','2013-09-17','10:55:00',2.38),('15844','2013-09-17','11:00:00',2.14),('15844','2013-09-17','11:05:00',3.02),('15844','2013-09-17','11:10:00',3.42),('15844','2013-09-17','11:15:00',2.14),('15844','2013-09-17','11:20:00',1.65),('15844','2013-09-17','11:25:00',1.34),('15844','2013-09-17','11:30:00',2.17),('15844','2013-09-17','11:35:00',2.62),('15844','2013-09-17','11:40:00',2.44),('15844','2013-09-17','11:45:00',2.56),('15844','2013-09-17','11:50:00',1.47),('15844','2013-09-17','11:55:00',3.8),('15844','2013-09-17','12:00:00',3.14),('15844','2013-09-17','12:05:00',1.39),('15844','2013-09-17','12:10:00',2.11),('15844','2013-09-17','12:15:00',3.91),('15844','2013-09-17','12:20:00',4.18),('15844','2013-09-17','12:25:00',1.96),('15844','2013-09-17','12:30:00',1.81),('15844','2013-09-17','12:35:00',1.93),('15844','2013-09-17','12:40:00',1.84),('15844','2013-09-17','12:45:00',2.46),('15844','2013-09-17','12:50:00',2.15),('15844','2013-09-17','12:55:00',3.59),('15844','2013-09-17','13:00:00',1.74),('15844','2013-09-17','13:05:00',2.29),('15844','2013-09-17','13:10:00',2.28),('15844','2013-09-17','13:15:00',1.87),('15844','2013-09-17','13:20:00',1.59),('15844','2013-09-17','13:25:00',1.92),('15844','2013-09-17','13:30:00',1.67),('15844','2013-09-17','13:35:00',1.73),('15844','2013-09-17','13:40:00',1.6),('15844','2013-09-17','13:45:00',1.02),('15844','2013-09-17','13:50:00',1.15),('15844','2013-09-17','13:55:00',1.01),('15844','2013-09-17','14:30:00',1.1),('15844','2013-09-17','14:50:00',1.34),('15844','2013-09-17','14:55:00',2.12),('15844','2013-09-17','15:00:00',2),('15844','2013-09-17','15:05:00',1.78),('15844','2013-09-17','15:10:00',1.57),('15844','2013-09-17','15:15:00',1.18),('15844','2013-09-17','15:20:00',1.44),('15844','2013-09-17','15:45:00',1.32),('15844','2013-09-17','15:50:00',1.06),('15844','2013-09-17','15:55:00',1.21),('15844','2013-09-17','16:00:00',1.45),('15844','2013-09-17','16:05:00',1.25),('15844','2013-09-17','16:10:00',1.18),('15844','2013-09-16','08:40:00',1.09),('15844','2013-09-16','08:45:00',1.06),('15844','2013-09-16','08:50:00',1.29),('15844','2013-09-16','08:55:00',1.46),('15844','2013-09-16','09:00:00',1.46),('15844','2013-09-16','09:10:00',1.08),('15844','2013-09-16','09:15:00',1.75),('15844','2013-09-16','09:20:00',1.87),('15844','2013-09-16','09:25:00',2.07),('15844','2013-09-16','09:30:00',2.08),('15844','2013-09-16','09:35:00',2.15),('15844','2013-09-16','09:40:00',2.24),('15844','2013-09-16','09:45:00',2.37),('15844','2013-09-16','09:50:00',2.49),('15844','2013-09-16','09:55:00',2.55),('15844','2013-09-16','10:00:00',2.79),('15844','2013-09-16','10:05:00',2.38),('15844','2013-09-16','10:10:00',2.58),('15844','2013-09-16','10:15:00',2.6),('15844','2013-09-16','10:20:00',3.22),('15844','2013-09-16','10:25:00',3.35),('15844','2013-09-16','10:30:00',3.48),('15844','2013-09-16','10:35:00',3.25),('15844','2013-09-16','10:40:00',2.63),('15844','2013-09-16','10:45:00',1.9),('15844','2013-09-16','10:55:00',1.15),('15844','2013-09-16','11:00:00',3.22),('15844','2013-09-16','11:05:00',3.96),('15844','2013-09-16','11:10:00',3.18),('15844','2013-09-16','11:15:00',2.67),('15844','2013-09-16','11:20:00',3.96),('15844','2013-09-16','11:25:00',1.99),('15844','2013-09-16','11:35:00',2.29),('15844','2013-09-16','11:40:00',3.91),('15844','2013-09-16','11:45:00',3.21),('15844','2013-09-16','11:50:00',4.11),('15844','2013-09-16','11:55:00',4.04),('15844','2013-09-16','12:00:00',1.34),('15844','2013-09-16','12:05:00',4.3),('15844','2013-09-16','12:10:00',4.12),('15844','2013-09-16','12:15:00',3.93),('15844','2013-09-16','12:20:00',3.84),('15844','2013-09-16','12:25:00',3.78),('15844','2013-09-16','12:30:00',3.83),('15844','2013-09-16','12:35:00',2.75),('15844','2013-09-16','12:40:00',2.62),('15844','2013-09-16','12:45:00',3.44),('15844','2013-09-16','12:50:00',2.3),('15844','2013-09-16','12:55:00',1.29),('15844','2013-09-16','13:00:00',3.03),('15844','2013-09-16','13:05:00',3.8),('15844','2013-09-16','13:10:00',3.68),('15844','2013-09-16','13:15:00',3.62),('15844','2013-09-16','13:20:00',3.63),('15844','2013-09-16','13:25:00',3.66),('15844','2013-09-16','13:30:00',3.46),('15844','2013-09-16','13:35:00',3.45),('15844','2013-09-16','13:40:00',3.56),('15844','2013-09-16','13:45:00',3.5),('15844','2013-09-16','13:50:00',3.53),('15844','2013-09-16','13:55:00',3.3),('15844','2013-09-16','14:00:00',3.14),('15844','2013-09-16','14:05:00',3.07),('15844','2013-09-16','14:10:00',2.99),('15844','2013-09-16','14:15:00',2.89),('15844','2013-09-16','14:20:00',2.78),('15844','2013-09-16','14:25:00',2.65),('15844','2013-09-16','14:30:00',2.55),('15844','2013-09-16','14:35:00',2.41),('15844','2013-09-16','14:40:00',2.31),('15844','2013-09-16','14:45:00',1.22),('15844','2013-09-16','14:50:00',2.15),('15844','2013-09-16','14:55:00',2.02),('15844','2013-09-16','15:00:00',1.92),('15844','2013-09-16','15:05:00',1.79),('15844','2013-09-16','15:10:00',1.66),('15844','2013-09-16','15:15:00',1.63),('15844','2013-09-16','15:20:00',1.55),('15844','2013-09-16','15:25:00',1.44),('15844','2013-09-16','15:30:00',1.32),('15844','2013-09-16','15:35:00',1.21),('15844','2013-09-16','15:40:00',1.15),('15844','2013-09-16','15:45:00',1.12),('15844','2013-09-16','15:50:00',1.06),('15844','2013-09-16','15:55:00',1.02),('15844','2013-09-15','08:40:00',1.04),('15844','2013-09-15','08:45:00',1.14),('15844','2013-09-15','08:50:00',1.14),('15844','2013-09-15','08:55:00',1.17),('15844','2013-09-15','09:00:00',1.34),('15844','2013-09-15','09:05:00',1.49),('15844','2013-09-15','09:10:00',1.63),('15844','2013-09-15','09:15:00',1.78),('15844','2013-09-15','09:20:00',1.84),('15844','2013-09-15','09:25:00',1.98),('15844','2013-09-15','09:30:00',2),('15844','2013-09-15','09:35:00',2.11),('15844','2013-09-15','09:40:00',2.2),('15844','2013-09-15','09:45:00',2.34),('15844','2013-09-15','09:50:00',2.39),('15844','2013-09-15','09:55:00',2.59),('15844','2013-09-15','10:00:00',2.66),('15844','2013-09-15','10:05:00',2.74),('15844','2013-09-15','10:10:00',2.58),('15844','2013-09-15','10:15:00',2.75),('15844','2013-09-15','10:20:00',2.84),('15844','2013-09-15','10:25:00',2.87),('15844','2013-09-15','10:30:00',2.68),('15844','2013-09-15','10:35:00',2.88),('15844','2013-09-15','10:40:00',3.21),('15844','2013-09-15','10:45:00',3.26),('15844','2013-09-15','10:50:00',1.36),('15844','2013-09-15','10:55:00',1.52),('15844','2013-09-15','11:00:00',3.01),('15844','2013-09-15','11:05:00',3.59),('15844','2013-09-15','11:10:00',4.04),('15844','2013-09-15','11:15:00',2.67),('15844','2013-09-15','11:25:00',1.19),('15844','2013-09-15','11:30:00',1.39),('15844','2013-09-15','11:35:00',3.87),('15844','2013-09-15','11:40:00',1.34),('15844','2013-09-15','11:45:00',1.24),('15844','2013-09-15','11:50:00',1.22),('15844','2013-09-15','11:55:00',1.88),('15844','2013-09-15','12:00:00',3.43),('15844','2013-09-15','12:05:00',3.1),('15844','2013-09-15','12:10:00',2.72),('15844','2013-09-15','12:15:00',2.6),('15844','2013-09-15','12:20:00',1.96),('15844','2013-09-15','12:25:00',1.85),('15844','2013-09-15','12:30:00',1.5),('15844','2013-09-15','12:35:00',1.82),('15844','2013-09-15','12:40:00',1.67),('15844','2013-09-15','12:45:00',1.15),('15844','2013-09-15','12:50:00',1.23),('15844','2013-09-15','12:55:00',1.13),('15844','2013-09-15','13:00:00',1.22),('15844','2013-09-15','13:05:00',1.51),('15844','2013-09-15','13:10:00',1.83),('15844','2013-09-15','13:15:00',3.11),('15844','2013-09-15','13:20:00',2.13),('15844','2013-09-15','13:25:00',1.27),('15844','2013-09-15','13:30:00',1.03),('15844','2013-09-15','13:40:00',1.2),('15844','2013-09-15','13:45:00',1.76),('15844','2013-09-15','13:50:00',1.63),('15844','2013-09-15','13:55:00',1.65),('15844','2013-09-15','14:00:00',2.09),('15844','2013-09-15','14:05:00',1.63),('15844','2013-09-15','14:10:00',1.71),('15844','2013-09-15','14:15:00',1.64),('15844','2013-09-15','14:20:00',1.38),('15844','2013-09-15','14:25:00',1.27),('15844','2013-09-15','14:30:00',1.14),('15844','2013-09-15','14:35:00',1.02),('15844','2013-09-15','14:45:00',1.03),('15844','2013-09-15','14:50:00',1.01),('15844','2013-09-15','15:00:00',1.04),('15844','2013-09-15','15:10:00',1.2),('15844','2013-09-15','15:15:00',1.57),('15844','2013-09-15','15:20:00',1.41),('15844','2013-09-15','15:25:00',1.02),('15844','2013-09-14','08:45:00',1.02),('15844','2013-09-14','08:50:00',1.12),('15844','2013-09-14','08:55:00',1.2),('15844','2013-09-14','09:00:00',1.28),('15844','2013-09-14','09:05:00',1.45),('15844','2013-09-14','09:10:00',1.6),('15844','2013-09-14','09:15:00',1.7),('15844','2013-09-14','09:20:00',1.8),('15844','2013-09-14','09:25:00',1.87),('15844','2013-09-14','09:30:00',1.96),('15844','2013-09-14','09:35:00',2.02),('15844','2013-09-14','09:40:00',2.13),('15844','2013-09-14','09:45:00',2.23),('15844','2013-09-14','09:50:00',2.31),('15844','2013-09-14','09:55:00',2.46),('15844','2013-09-14','10:00:00',2.59),('15844','2013-09-14','10:05:00',2.53),('15844','2013-09-14','10:10:00',2.45),('15844','2013-09-14','10:15:00',2.76),('15844','2013-09-14','10:20:00',2.71),('15844','2013-09-14','10:25:00',2.82),('15844','2013-09-14','10:30:00',2.99),('15844','2013-09-14','10:35:00',3.06),('15844','2013-09-14','10:40:00',3.15),('15844','2013-09-14','10:45:00',2.76),('15844','2013-09-14','10:50:00',2.84),('15844','2013-09-14','10:55:00',2),('15844','2013-09-14','11:00:00',3.81),('15844','2013-09-14','11:05:00',3.19),('15844','2013-09-14','11:10:00',2.19),('15844','2013-09-14','11:15:00',3.66),('15844','2013-09-14','11:20:00',3.79),('15844','2013-09-14','11:25:00',3.75),('15844','2013-09-14','11:30:00',3.1),('15844','2013-09-14','11:35:00',3.73),('15844','2013-09-14','11:40:00',3.67),('15844','2013-09-14','11:45:00',3.93),('15844','2013-09-14','11:50:00',3.28),('15844','2013-09-14','11:55:00',3.85),('15844','2013-09-14','12:00:00',2.44),('15844','2013-09-14','12:05:00',3.85),('15844','2013-09-14','12:10:00',2.2),('15844','2013-09-14','12:15:00',3.3),('15844','2013-09-14','12:20:00',3.91),('15844','2013-09-14','12:25:00',3.89),('15844','2013-09-14','12:30:00',3.8),('15844','2013-09-14','12:35:00',3.71),('15844','2013-09-14','12:40:00',3.69),('15844','2013-09-14','12:45:00',3.64),('15844','2013-09-14','12:50:00',3.59),('15844','2013-09-14','12:55:00',1.76),('15844','2013-09-14','13:00:00',2.39),('15844','2013-09-14','13:05:00',3.73),('15844','2013-09-14','13:10:00',3.66),('15844','2013-09-14','13:15:00',3.6),('15844','2013-09-14','13:20:00',3.51),('15844','2013-09-14','13:25:00',3.54),('15844','2013-09-14','13:30:00',3.46),('15844','2013-09-14','13:35:00',2.9),('15844','2013-09-14','13:40:00',1.32),('15844','2013-09-14','13:45:00',1.77),('15844','2013-09-14','13:50:00',2.92),('15844','2013-09-14','13:55:00',3.72),('15844','2013-09-14','14:00:00',3.31),('15844','2013-09-14','14:05:00',3.11),('15844','2013-09-14','14:10:00',3.03),('15844','2013-09-14','14:15:00',2.91),('15844','2013-09-14','14:20:00',2.81),('15844','2013-09-14','14:25:00',2.68),('15844','2013-09-14','14:30:00',2.57),('15844','2013-09-14','14:35:00',2.46),('15844','2013-09-14','14:40:00',2.33),('15844','2013-09-14','14:45:00',2.23),('15844','2013-09-14','14:50:00',2.12),('15844','2013-09-14','14:55:00',2.03),('15844','2013-09-14','15:00:00',1.96),('15844','2013-09-14','15:05:00',1.84),('15844','2013-09-14','15:10:00',1.72),('15844','2013-09-14','15:15:00',1.67),('15844','2013-09-14','15:20:00',1.59),('15844','2013-09-14','15:25:00',1.5),('15844','2013-09-14','15:30:00',1.4),('15844','2013-09-14','15:35:00',1.28),('15844','2013-09-14','15:40:00',1.2),('15844','2013-09-14','15:45:00',1.15),('15844','2013-09-14','15:50:00',1.08),('15844','2013-09-13','09:30:00',1.04),('15844','2013-09-13','09:35:00',1.02),('15844','2013-09-13','09:40:00',1.13),('15844','2013-09-13','09:45:00',1.19),('15844','2013-09-13','09:50:00',1.38),('15844','2013-09-13','09:55:00',1.11),('15844','2013-09-13','10:00:00',2.37),('15844','2013-09-13','10:05:00',3.33),('15844','2013-09-13','10:10:00',1.87),('15844','2013-09-13','10:15:00',2.43),('15844','2013-09-13','10:20:00',3.57),('15844','2013-09-13','10:25:00',3.14),('15844','2013-09-13','10:30:00',2.89),('15844','2013-09-13','10:35:00',3.05),('15844','2013-09-13','10:40:00',3.2),('15844','2013-09-13','10:45:00',3.29),('15844','2013-09-13','10:50:00',3.39),('15844','2013-09-13','10:55:00',3.47),('15844','2013-09-13','11:00:00',3.5),('15844','2013-09-13','11:05:00',3.56),('15844','2013-09-13','11:10:00',3.59),('15844','2013-09-13','11:15:00',3.64),('15844','2013-09-13','11:20:00',3.66),('15844','2013-09-13','11:25:00',3.7),('15844','2013-09-13','11:30:00',3.71),('15844','2013-09-13','11:35:00',3.73),('15844','2013-09-13','11:40:00',3.74),('15844','2013-09-13','11:45:00',3.73),('15844','2013-09-13','11:50:00',3.73),('15844','2013-09-13','11:55:00',3.76),('15844','2013-09-13','12:00:00',3.77),('15844','2013-09-13','12:05:00',3.75),('15844','2013-09-13','12:10:00',3.74),('15844','2013-09-13','12:15:00',3.02),('15844','2013-09-13','12:20:00',3.67),('15844','2013-09-13','12:25:00',3.37),('15844','2013-09-13','12:30:00',4.07),('15844','2013-09-13','12:35:00',3.97),('15844','2013-09-13','12:40:00',3.91),('15844','2013-09-13','12:45:00',3.89),('15844','2013-09-13','12:50:00',3.91),('15844','2013-09-13','12:55:00',3.79),('15844','2013-09-13','13:00:00',3.79),('15844','2013-09-13','13:05:00',3.69),('15844','2013-09-13','13:10:00',3.67),('15844','2013-09-13','13:15:00',3.6),('15844','2013-09-13','13:20:00',3.59),('15844','2013-09-13','13:25:00',3.42),('15844','2013-09-13','13:30:00',1.81),('15844','2013-09-13','13:35:00',3),('15844','2013-09-13','13:40:00',3.4),('15844','2013-09-13','13:45:00',2.96),('15844','2013-09-13','13:50:00',3.25),('15844','2013-09-13','13:55:00',3.2),('15844','2013-09-13','14:00:00',3.1),('15844','2013-09-13','14:05:00',3.09),('15844','2013-09-13','14:10:00',3.04),('15844','2013-09-13','14:15:00',2.95),('15844','2013-09-13','14:20:00',2.83),('15844','2013-09-13','14:25:00',2.71),('15844','2013-09-13','14:30:00',2.6),('15844','2013-09-13','14:35:00',2.53),('15844','2013-09-13','14:40:00',2.39),('15844','2013-09-13','14:45:00',2.27),('15844','2013-09-13','14:50:00',2.21),('15844','2013-09-13','14:55:00',2.13),('15844','2013-09-13','15:00:00',2.02),('15844','2013-09-13','15:05:00',1.91),('15844','2013-09-13','15:10:00',1.78),('15844','2013-09-13','15:15:00',1.69),('15844','2013-09-13','15:20:00',1.6),('15844','2013-09-13','15:25:00',1.52),('15844','2013-09-13','15:30:00',1.42),('15844','2013-09-13','15:35:00',1.31),('15844','2013-09-13','15:40:00',1.22),('15844','2013-09-13','15:45:00',1.16),('15844','2013-09-13','15:50:00',1.1),('15844','2013-09-13','15:55:00',1.03),('15844','2013-09-12','08:50:00',1.16),('15844','2013-09-12','08:55:00',1.24),('15844','2013-09-12','09:00:00',1.41),('15844','2013-09-12','09:05:00',1.12),('15844','2013-09-12','09:10:00',1.36),('15844','2013-09-12','09:15:00',1.43),('15844','2013-09-12','09:20:00',1.73),('15844','2013-09-12','09:25:00',2.12),('15844','2013-09-12','09:30:00',2.22),('15844','2013-09-12','09:35:00',1.78),('15844','2013-09-12','10:00:00',1.36),('15844','2013-09-12','10:05:00',2.41),('15844','2013-09-12','10:10:00',1.83),('15844','2013-09-12','10:15:00',1.36),('15844','2013-09-12','10:25:00',1.98),('15844','2013-09-12','10:30:00',1.82),('15844','2013-09-12','10:45:00',1.63),('15844','2013-09-12','10:50:00',1.54),('15844','2013-09-12','10:55:00',3.27),('15844','2013-09-12','11:00:00',4.27),('15844','2013-09-12','11:05:00',4.17),('15844','2013-09-12','11:10:00',3.42),('15844','2013-09-12','11:35:00',1.16),('15844','2013-09-12','11:40:00',1.27),('15844','2013-09-12','11:45:00',1.73),('15844','2013-09-12','11:50:00',4.06),('15844','2013-09-12','11:55:00',3.78),('15844','2013-09-12','12:00:00',3.88),('15844','2013-09-12','12:05:00',3.99),('15844','2013-09-12','12:10:00',3.93),('15844','2013-09-12','12:15:00',1.67),('15844','2013-09-12','12:20:00',2.24),('15844','2013-09-12','12:25:00',2.79),('15844','2013-09-12','12:30:00',3.76),('15844','2013-09-12','12:35:00',3.76),('15844','2013-09-12','12:40:00',1.64),('15844','2013-09-12','12:45:00',3.62),('15844','2013-09-12','12:50:00',3.46),('15844','2013-09-12','12:55:00',3.84),('15844','2013-09-12','13:00:00',3.03),('15844','2013-09-12','13:05:00',3.41),('15844','2013-09-12','13:10:00',3.72),('15844','2013-09-12','13:15:00',3.62),('15844','2013-09-12','13:20:00',4.01),('15844','2013-09-12','13:25:00',3.38),('15844','2013-09-12','13:30:00',3.11),('15844','2013-09-12','13:35:00',3.41),('15844','2013-09-12','13:40:00',3.6),('15844','2013-09-12','13:45:00',3.39),('15844','2013-09-12','13:50:00',3.26),('15844','2013-09-12','13:55:00',3.08),('15844','2013-09-12','14:00:00',3.07),('15844','2013-09-12','14:05:00',3.2),('15844','2013-09-12','14:10:00',3.22),('15844','2013-09-12','14:15:00',3.14),('15844','2013-09-12','14:20:00',2.9),('15844','2013-09-12','14:25:00',2.95),('15844','2013-09-12','14:30:00',2.07),('15844','2013-09-12','14:35:00',2.56),('15844','2013-09-12','14:40:00',2.47),('15844','2013-09-12','14:45:00',2.27),('15844','2013-09-12','14:50:00',1.96),('15844','2013-09-12','14:55:00',1.84),('15844','2013-09-12','15:00:00',1.69),('15844','2013-09-12','15:05:00',1.99),('15844','2013-09-12','15:10:00',1.88),('15844','2013-09-12','15:15:00',1.77),('15844','2013-09-12','15:20:00',1.69),('15844','2013-09-12','15:25:00',1.58),('15844','2013-09-12','15:30:00',1.47),('15844','2013-09-12','15:35:00',1.36),('15844','2013-09-12','15:40:00',1.27),('15844','2013-09-12','15:45:00',1.23),('15844','2013-09-12','15:50:00',1.23),('15844','2013-09-12','15:55:00',1.2),('15844','2013-09-11','09:05:00',1.4),('15844','2013-09-11','09:10:00',1.54),('15844','2013-09-11','09:15:00',2.08),('15844','2013-09-11','09:55:00',1.25),('15844','2013-09-11','10:00:00',2.73),('15844','2013-09-11','10:05:00',2.45),('15844','2013-09-11','10:10:00',2.78),('15844','2013-09-11','10:15:00',2.82),('15844','2013-09-11','10:20:00',2.94),('15844','2013-09-11','10:25:00',1.95),('15844','2013-09-11','10:30:00',2.42),('15844','2013-09-11','10:35:00',3.49),('15844','2013-09-11','10:40:00',3.49),('15844','2013-09-11','10:45:00',2.2),('15844','2013-09-11','10:50:00',1.29),('15844','2013-09-11','10:55:00',2.62),('15844','2013-09-11','11:00:00',2.31),('15844','2013-09-11','11:05:00',3.4),('15844','2013-09-11','11:10:00',3.32),('15844','2013-09-11','11:15:00',4.1),('15844','2013-09-11','11:20:00',3.38),('15844','2013-09-11','11:25:00',2.86),('15844','2013-09-11','11:30:00',3.28),('15844','2013-09-11','11:35:00',3.98),('15844','2013-09-11','11:40:00',3.96),('15844','2013-09-11','11:45:00',3.33),('15844','2013-09-11','11:50:00',3.1),('15844','2013-09-11','11:55:00',4.06),('15844','2013-09-11','12:00:00',4.02),('15844','2013-09-11','12:05:00',1.93),('15844','2013-09-11','12:10:00',4.12),('15844','2013-09-11','12:15:00',3.74),('15844','2013-09-11','12:20:00',2.92),('15844','2013-09-11','12:25:00',3.06),('15844','2013-09-11','12:30:00',2.99),('15844','2013-09-11','12:35:00',1.18),('15844','2013-09-11','12:40:00',2.44),('15844','2013-09-11','12:45:00',1.87),('15844','2013-09-11','12:50:00',3.44),('15844','2013-09-11','12:55:00',3.06),('15844','2013-09-11','13:00:00',3.47),('15844','2013-09-11','13:05:00',2.18),('15844','2013-09-11','13:10:00',1.25),('15844','2013-09-11','13:15:00',3.17),('15844','2013-09-11','13:20:00',3.83),('15844','2013-09-11','13:25:00',2.54),('15844','2013-09-11','13:30:00',3.8),('15844','2013-09-11','13:35:00',2.65),('15844','2013-09-11','13:40:00',4),('15844','2013-09-11','13:45:00',2.88),('15844','2013-09-11','13:50:00',2.07),('15844','2013-09-11','13:55:00',3.44),('15844','2013-09-11','14:00:00',3.05),('15844','2013-09-11','14:05:00',3.11),('15844','2013-09-11','14:10:00',3.29),('15844','2013-09-11','14:15:00',3.14),('15844','2013-09-11','14:20:00',1.5),('15844','2013-09-11','14:25:00',3),('15844','2013-09-11','14:30:00',1.09),('15844','2013-09-11','14:35:00',1.3),('15844','2013-09-11','14:40:00',1.26),('15844','2013-09-11','14:45:00',1.88),('15844','2013-09-11','14:50:00',2.23),('15844','2013-09-11','15:00:00',2.42),('15844','2013-09-11','15:05:00',1.86),('15844','2013-09-11','15:10:00',1.29),('15844','2013-09-11','15:15:00',1.62),('15844','2013-09-11','15:20:00',1.97),('15844','2013-09-11','15:25:00',1.75),('15844','2013-09-11','15:30:00',1.96),('15844','2013-09-11','15:45:00',1.34),('15844','2013-09-10','08:50:00',1.08),('15844','2013-09-10','08:55:00',1.27),('15844','2013-09-10','09:00:00',1.5),('15844','2013-09-10','09:05:00',1.82),('15844','2013-09-10','09:10:00',2.29),('15844','2013-09-10','09:15:00',1.24),('15844','2013-09-10','09:20:00',1.39),('15844','2013-09-10','09:25:00',1.89),('15844','2013-09-10','09:30:00',2.57),('15844','2013-09-10','09:35:00',1.37),('15844','2013-09-10','09:40:00',1.2),('15844','2013-09-10','09:45:00',1.11),('15844','2013-09-10','09:50:00',1.08),('15844','2013-09-10','10:40:00',1.39),('15844','2013-09-10','10:45:00',1.41),('15844','2013-09-10','10:50:00',1.01),('15844','2013-09-10','10:55:00',1.37),('15844','2013-09-10','11:00:00',1.73),('15844','2013-09-10','11:05:00',1.28),('15844','2013-09-10','11:15:00',1.04),('15844','2013-09-10','11:20:00',1.4),('15844','2013-09-10','11:25:00',1.59),('15844','2013-09-10','11:55:00',1.17),('15844','2013-09-10','12:00:00',1.14),('15844','2013-09-10','12:05:00',1.01),('15844','2013-09-10','12:10:00',1.18),('15844','2013-09-10','12:15:00',1.97),('15844','2013-09-10','12:20:00',1.53),('15844','2013-09-10','12:25:00',1.29),('15844','2013-09-10','12:30:00',1.16),('15844','2013-09-10','13:25:00',1.02),('15844','2013-09-10','13:35:00',1.17),('15844','2013-09-10','13:40:00',1.79),('15844','2013-09-10','13:45:00',1.89),('15844','2013-09-10','13:50:00',1.73),('15844','2013-09-10','13:55:00',1.2),('15844','2013-09-10','14:00:00',1.17),('15844','2013-09-10','14:05:00',1.11),('15844','2013-09-10','14:10:00',1.21),('15844','2013-09-10','14:15:00',1.4),('15844','2013-09-10','14:20:00',1.59),('15844','2013-09-10','14:25:00',1.95),('15844','2013-09-10','14:30:00',1.55),('15844','2013-09-10','14:35:00',1.21),('15844','2013-09-10','14:40:00',1.27),('15844','2013-09-10','14:45:00',1.78),('15844','2013-09-10','14:50:00',1.79),('15844','2013-09-10','14:55:00',1.69),('15844','2013-09-10','15:00:00',1.6),('15844','2013-09-10','15:05:00',1.73),('15844','2013-09-10','15:10:00',1.51),('15844','2013-09-10','15:15:00',1.01),('15844','2013-09-10','15:20:00',1.27),('15844','2013-09-10','15:25:00',1.29),('15844','2013-09-10','15:30:00',1.44),('15844','2013-09-10','15:35:00',1.21),('15844','2013-09-10','15:40:00',1.03),('15844','2013-09-10','16:15:00',1.01),('15844','2013-09-09','08:55:00',1.02),('15844','2013-09-09','09:50:00',1.06),('15844','2013-09-09','09:55:00',1.03),('15844','2013-09-09','10:00:00',1.22),('15844','2013-09-09','10:05:00',1.25),('15844','2013-09-09','10:10:00',1.34),('15844','2013-09-09','10:15:00',1.5),('15844','2013-09-09','10:20:00',1.5),('15844','2013-09-09','10:25:00',1.52),('15844','2013-09-09','10:30:00',1.58),('15844','2013-09-09','10:35:00',1.7),('15844','2013-09-09','10:40:00',1.71),('15844','2013-09-09','10:45:00',2.39),('15844','2013-09-09','10:50:00',2.57),('15844','2013-09-09','10:55:00',2.6),('15844','2013-09-09','11:00:00',2.27),('15844','2013-09-09','11:05:00',1.89),('15844','2013-09-09','11:10:00',1.69),('15844','2013-09-09','11:15:00',1.9),('15844','2013-09-09','11:20:00',2.5),('15844','2013-09-09','11:25:00',2.17),('15844','2013-09-09','11:30:00',2.05),('15844','2013-09-09','11:35:00',2.49),('15844','2013-09-09','11:40:00',3.31),('15844','2013-09-09','11:45:00',3.34),('15844','2013-09-09','11:50:00',1.99),('15844','2013-09-09','11:55:00',1.44),('15844','2013-09-09','12:00:00',1.29),('15844','2013-09-09','12:05:00',1.4),('15844','2013-09-09','12:10:00',1.33),('15844','2013-09-09','12:30:00',1.04),('15844','2013-09-09','12:40:00',1.39),('15844','2013-09-09','12:45:00',1.35),('15844','2013-09-09','12:50:00',1.74),('15844','2013-09-09','12:55:00',1.85),('15844','2013-09-09','13:00:00',2.03),('15844','2013-09-09','13:05:00',2.63),('15844','2013-09-09','13:10:00',3.37),('15844','2013-09-09','13:15:00',3.01),('15844','2013-09-09','13:20:00',2.65),('15844','2013-09-09','13:25:00',3),('15844','2013-09-09','13:30:00',3.21),('15844','2013-09-09','13:35:00',3.49),('15844','2013-09-09','13:40:00',2.58),('15844','2013-09-09','13:45:00',3.45),('15844','2013-09-09','13:50:00',3.43),('15844','2013-09-09','13:55:00',3.22),('15844','2013-09-09','14:00:00',3.02),('15844','2013-09-09','14:05:00',2.73),('15844','2013-09-09','14:10:00',2.61),('15844','2013-09-09','14:15:00',2.74),('15844','2013-09-09','14:20:00',1.18),('15844','2013-09-09','14:25:00',2.87),('15844','2013-09-09','14:30:00',2.73),('15844','2013-09-09','14:35:00',2.21),('15844','2013-09-09','14:40:00',2.34),('15844','2013-09-09','14:45:00',2.42),('15844','2013-09-09','14:50:00',2.39),('15844','2013-09-09','14:55:00',1.8),('15844','2013-09-09','15:00:00',1.7),('15844','2013-09-09','15:05:00',2.19),('15844','2013-09-09','15:10:00',2.28),('15844','2013-09-09','15:15:00',1.81),('15844','2013-09-09','15:20:00',1.96),('15844','2013-09-09','15:25:00',1.39),('15844','2013-09-09','15:30:00',1.54),('15844','2013-09-09','15:35:00',2.13),('15844','2013-09-09','15:40:00',1.53),('15844','2013-09-09','15:45:00',1.33),('15844','2013-09-09','15:50:00',1.44),('15844','2013-09-09','15:55:00',1.05),('15844','2013-09-09','16:05:00',1.02),('15844','2013-09-09','16:10:00',1.51),('15844','2013-09-09','16:15:00',1.46),('15844','2013-09-09','16:20:00',1.08),('15844','2014-04-12','09:05:00',1.33),('15844','2014-04-12','09:10:00',1.79),('15844','2014-04-12','09:15:00',1.44),('15844','2014-04-12','09:20:00',1.29),('15844','2014-04-12','09:25:00',1.44),('15844','2014-04-12','09:30:00',1.62),('15844','2014-04-12','09:35:00',1.56),('15844','2014-04-12','09:40:00',1.5),('15844','2014-04-12','09:45:00',1.49),('15844','2014-04-12','09:50:00',1.45),('15844','2014-04-12','09:55:00',1.49),('15844','2014-04-12','10:00:00',1.73),('15844','2014-04-12','10:05:00',1.79),('15844','2014-04-12','10:10:00',1.8),('15844','2014-04-12','10:15:00',1.67),('15844','2014-04-12','10:20:00',1.78),('15844','2014-04-12','10:25:00',1.8),('15844','2014-04-12','10:30:00',1.68),('15844','2014-04-12','10:35:00',1.71),('15844','2014-04-12','10:40:00',1.5),('15844','2014-04-12','10:45:00',1.42),('15844','2014-04-12','10:50:00',1.38),('15844','2014-04-12','10:55:00',1.28),('15844','2014-04-12','11:00:00',1.58),('15844','2014-04-12','11:05:00',1.5),('15844','2014-04-12','11:10:00',1.69),('15844','2014-04-12','11:15:00',2.08),('15844','2014-04-12','11:20:00',1.47),('15844','2014-04-12','11:25:00',1.5),('15844','2014-04-12','11:30:00',1.74),('15844','2014-04-12','11:35:00',3.24),('15844','2014-04-12','11:40:00',3.02),('15844','2014-04-12','11:45:00',3.07),('15844','2014-04-12','11:50:00',2.38),('15844','2014-04-12','11:55:00',1.47),('15844','2014-04-12','12:00:00',1.31),('15844','2014-04-12','12:05:00',1.6),('15844','2014-04-12','12:10:00',1.5),('15844','2014-04-12','12:15:00',2.52),('15844','2014-04-12','12:20:00',3.08),('15844','2014-04-12','12:25:00',2.32),('15844','2014-04-12','12:30:00',1.88),('15844','2014-04-12','12:35:00',1.35),('15844','2014-04-12','12:40:00',2.08),('15844','2014-04-12','12:45:00',2.72),('15844','2014-04-12','12:50:00',2.74),('15844','2014-04-12','12:55:00',2.31),('15844','2014-04-12','13:00:00',3.4),('15844','2014-04-12','13:05:00',3.64),('15844','2014-04-12','13:10:00',3.76),('15844','2014-04-12','13:15:00',3.98),('15844','2014-04-12','13:20:00',4),('15844','2014-04-12','13:25:00',4.05),('15844','2014-04-12','13:30:00',3.89),('15844','2014-04-12','13:35:00',3.2),('15844','2014-04-12','13:40:00',3.85),('15844','2014-04-12','13:45:00',1.82),('15844','2014-04-12','13:50:00',1.64),('15844','2014-04-12','13:55:00',2.79),('15844','2014-04-12','14:00:00',3.36),('15844','2014-04-12','14:05:00',3.32),('15844','2014-04-12','14:10:00',3.42),('15844','2014-04-12','14:15:00',2.33),('15844','2014-04-12','14:20:00',1.89),('15844','2014-04-12','14:25:00',1.79),('15844','2014-04-12','14:30:00',2.35),('15844','2014-04-12','14:35:00',2.44),('15844','2014-04-12','14:40:00',2.53),('15844','2014-04-12','14:45:00',2.67),('15844','2014-04-12','14:50:00',2.28),('15844','2014-04-12','14:55:00',2.18),('15844','2014-04-12','15:00:00',2.12),('15844','2014-04-12','15:05:00',2.26),('15844','2014-04-12','15:10:00',2.19),('15844','2014-04-12','15:15:00',1.73),('15844','2014-04-12','15:20:00',1.59),('15844','2014-04-12','15:25:00',1.51),('15844','2014-04-12','15:30:00',1.27),('15844','2014-04-12','15:35:00',1.18),('15844','2014-04-12','15:40:00',1.51),('15844','2014-04-12','15:45:00',1.65),('15844','2014-04-12','15:50:00',1.58),('15844','2014-04-12','15:55:00',1.49),('15844','2014-04-12','16:00:00',1.4),('15844','2014-04-12','16:05:00',1.37),('15844','2014-04-12','16:10:00',1.28),('15844','2014-04-12','16:15:00',1.33),('15844','2014-04-12','16:20:00',1.28),('15844','2014-04-12','16:25:00',1.1),('15844','2013-09-08','09:10:00',1.3),('15844','2013-09-08','09:15:00',1.49),('15844','2013-09-08','09:20:00',1.61),('15844','2013-09-08','09:25:00',1.65),('15844','2013-09-08','09:30:00',1.73),('15844','2013-09-08','09:35:00',1.79),('15844','2013-09-08','09:40:00',1.89),('15844','2013-09-08','09:45:00',1.99),('15844','2013-09-08','09:50:00',2.11),('15844','2013-09-08','09:55:00',2.2),('15844','2013-09-08','10:00:00',2.26),('15844','2013-09-08','10:05:00',2.34),('15844','2013-09-08','10:10:00',2.34),('15844','2013-09-08','10:15:00',2.44),('15844','2013-09-08','10:20:00',2.61),('15844','2013-09-08','10:25:00',2.67),('15844','2013-09-08','10:30:00',2.85),('15844','2013-09-08','10:35:00',2.9),('15844','2013-09-08','10:40:00',2.84),('15844','2013-09-08','10:45:00',3.04),('15844','2013-09-08','10:50:00',3.19),('15844','2013-09-08','10:55:00',3.2),('15844','2013-09-08','11:00:00',3.23),('15844','2013-09-08','11:05:00',3.23),('15844','2013-09-08','11:10:00',3.19),('15844','2013-09-08','11:15:00',3.38),('15844','2013-09-08','11:20:00',3.4),('15844','2013-09-08','11:25:00',3.35),('15844','2013-09-08','11:30:00',3.37),('15844','2013-09-08','11:35:00',3.35),('15844','2013-09-08','11:40:00',3.26),('15844','2013-09-08','11:45:00',3.1),('15844','2013-09-08','11:50:00',3.33),('15844','2013-09-08','11:55:00',3.39),('15844','2013-09-08','12:00:00',3.34),('15844','2013-09-08','12:05:00',3.05),('15844','2013-09-08','12:10:00',3.52),('15844','2013-09-08','12:15:00',3.49),('15844','2013-09-08','12:20:00',3.41),('15844','2013-09-08','12:25:00',3.4),('15844','2013-09-08','12:30:00',3.51),('15844','2013-09-08','12:35:00',3.4),('15844','2013-09-08','12:40:00',3.4),('15844','2013-09-08','12:45:00',3.37),('15844','2013-09-08','12:50:00',3.35),('15844','2013-09-08','12:55:00',3.3),('15844','2013-09-08','13:00:00',3.35),('15844','2013-09-08','13:05:00',3.33),('15844','2013-09-08','13:10:00',3.22),('15844','2013-09-08','13:15:00',3.12),('15844','2013-09-08','13:20:00',3.03),('15844','2013-09-08','13:25:00',2.75),('15844','2013-09-08','13:30:00',2.81),('15844','2013-09-08','13:35:00',2.15),('15844','2013-09-08','13:40:00',1.7),('15844','2013-09-08','13:45:00',2.35),('15844','2013-09-08','13:50:00',2.83),('15844','2013-09-08','13:55:00',2.83),('15844','2013-09-08','14:00:00',2.78),('15844','2013-09-08','14:05:00',3.08),('15844','2013-09-08','14:10:00',2.93),('15844','2013-09-08','14:15:00',3),('15844','2013-09-08','14:20:00',3.21),('15844','2013-09-08','14:25:00',2.75),('15844','2013-09-08','14:30:00',2.79),('15844','2013-09-08','14:35:00',2.61),('15844','2013-09-08','14:40:00',2.49),('15844','2013-09-08','14:45:00',2.43),('15844','2013-09-08','14:50:00',2.17),('15844','2013-09-08','14:55:00',2.11),('15844','2013-09-08','15:00:00',1.9),('15844','2013-09-08','15:05:00',1.06),('15844','2013-09-08','15:10:00',1.34),('15844','2013-09-08','15:15:00',1.86),('15844','2013-09-08','15:20:00',1.86),('15844','2013-09-08','15:25:00',1.79),('15844','2013-09-08','15:30:00',1.63),('15844','2013-09-08','15:35:00',1.44),('15844','2013-09-08','15:40:00',1.33),('15844','2013-09-08','15:45:00',1.32),('15844','2013-09-08','15:55:00',1.05),('15844','2013-09-08','16:00:00',1.01),('15844','2013-09-07','08:45:00',1.04),('15844','2013-09-07','08:50:00',1.13),('15844','2013-09-07','08:55:00',1.2),('15844','2013-09-07','09:00:00',1.32),('15844','2013-09-07','09:05:00',1.44),('15844','2013-09-07','09:10:00',1.54),('15844','2013-09-07','09:15:00',1.6),('15844','2013-09-07','09:20:00',1.65),('15844','2013-09-07','09:25:00',1.75),('15844','2013-09-07','09:30:00',1.99),('15844','2013-09-07','09:35:00',2.09),('15844','2013-09-07','09:40:00',2.18),('15844','2013-09-07','09:45:00',2.26),('15844','2013-09-07','09:50:00',2.33),('15844','2013-09-07','09:55:00',2.37),('15844','2013-09-07','10:00:00',2.47),('15844','2013-09-07','10:05:00',2.57),('15844','2013-09-07','10:10:00',2.64),('15844','2013-09-07','10:15:00',2.68),('15844','2013-09-07','10:20:00',2.73),('15844','2013-09-07','10:25:00',2.76),('15844','2013-09-07','10:30:00',2.77),('15844','2013-09-07','10:35:00',2.95),('15844','2013-09-07','10:40:00',3.02),('15844','2013-09-07','10:45:00',3.07),('15844','2013-09-07','10:50:00',3.15),('15844','2013-09-07','10:55:00',3.28),('15844','2013-09-07','11:00:00',3.35),('15844','2013-09-07','11:05:00',3.39),('15844','2013-09-07','11:10:00',3.49),('15844','2013-09-07','11:15:00',3.46),('15844','2013-09-07','11:20:00',3.48),('15844','2013-09-07','11:25:00',3.53),('15844','2013-09-07','11:30:00',3.57),('15844','2013-09-07','11:35:00',3.59),('15844','2013-09-07','11:40:00',3.6),('15844','2013-09-07','11:45:00',3.6),('15844','2013-09-07','11:50:00',3.62),('15844','2013-09-07','11:55:00',3.6),('15844','2013-09-07','12:00:00',3.6),('15844','2013-09-07','12:05:00',3.62),('15844','2013-09-07','12:10:00',3.62),('15844','2013-09-07','12:15:00',3.61),('15844','2013-09-07','12:20:00',3.56),('15844','2013-09-07','12:25:00',3.54),('15844','2013-09-07','12:30:00',3.53),('15844','2013-09-07','12:35:00',3.54),('15844','2013-09-07','12:40:00',3.56),('15844','2013-09-07','12:45:00',3.58),('15844','2013-09-07','12:50:00',3.51),('15844','2013-09-07','12:55:00',3.41),('15844','2013-09-07','13:00:00',3.43),('15844','2013-09-07','13:05:00',3.43),('15844','2013-09-07','13:10:00',3.44),('15844','2013-09-07','13:15:00',3.35),('15844','2013-09-07','13:20:00',3.36),('15844','2013-09-07','13:25:00',3.36),('15844','2013-09-07','13:30:00',3.29),('15844','2013-09-07','13:35:00',3.26),('15844','2013-09-07','13:40:00',3.21),('15844','2013-09-07','13:45:00',3.21),('15844','2013-09-07','13:50:00',3.17),('15844','2013-09-07','13:55:00',3.12),('15844','2013-09-07','14:00:00',3.09),('15844','2013-09-07','14:05:00',3.01),('15844','2013-09-07','14:10:00',2.97),('15844','2013-09-07','14:15:00',2.92),('15844','2013-09-07','14:20:00',2.85),('15844','2013-09-07','14:25:00',2.74),('15844','2013-09-07','14:30:00',2.64),('15844','2013-09-07','14:35:00',2.55),('15844','2013-09-07','14:40:00',2.43),('15844','2013-09-07','14:45:00',2.31),('15844','2013-09-07','14:50:00',2.28),('15844','2013-09-07','14:55:00',2.19),('15844','2013-09-07','15:00:00',2.1),('15844','2013-09-07','15:05:00',1.98),('15844','2013-09-07','15:10:00',1.84),('15844','2013-09-07','15:15:00',1.76),('15844','2013-09-07','15:20:00',1.68),('15844','2013-09-07','15:25:00',1.6),('15844','2013-09-07','15:30:00',1.49),('15844','2013-09-07','15:35:00',1.4),('15844','2013-09-07','15:40:00',1.28),('15844','2013-09-07','15:45:00',1.17),('15844','2013-09-07','15:50:00',1.1),('15844','2013-09-07','15:55:00',1.03),('15844','2013-09-06','08:45:00',1.04),('15844','2013-09-06','08:50:00',1.16),('15844','2013-09-06','08:55:00',1.22),('15844','2013-09-06','09:00:00',1.35),('15844','2013-09-06','09:05:00',1.47),('15844','2013-09-06','09:10:00',1.56),('15844','2013-09-06','09:15:00',1.64),('15844','2013-09-06','09:20:00',1.77),('15844','2013-09-06','09:25:00',1.89),('15844','2013-09-06','09:30:00',2.02),('15844','2013-09-06','09:35:00',2.13),('15844','2013-09-06','09:40:00',2.21),('15844','2013-09-06','09:45:00',2.28),('15844','2013-09-06','09:50:00',2.35),('15844','2013-09-06','09:55:00',2.43),('15844','2013-09-06','10:00:00',2.5),('15844','2013-09-06','10:05:00',2.61),('15844','2013-09-06','10:10:00',2.69),('15844','2013-09-06','10:15:00',2.71),('15844','2013-09-06','10:20:00',2.76),('15844','2013-09-06','10:25:00',2.81),('15844','2013-09-06','10:30:00',2.88),('15844','2013-09-06','10:35:00',3.06),('15844','2013-09-06','10:40:00',3.15),('15844','2013-09-06','10:45:00',3.17),('15844','2013-09-06','10:50:00',3.26),('15844','2013-09-06','10:55:00',3.4),('15844','2013-09-06','11:00:00',3.49),('15844','2013-09-06','11:05:00',3.52),('15844','2013-09-06','11:10:00',3.55),('15844','2013-09-06','11:15:00',3.54),('15844','2013-09-06','11:20:00',3.58),('15844','2013-09-06','11:25:00',3.63),('15844','2013-09-06','11:30:00',3.66),('15844','2013-09-06','11:35:00',3.68),('15844','2013-09-06','11:40:00',3.69),('15844','2013-09-06','11:45:00',3.66),('15844','2013-09-06','11:50:00',3.66),('15844','2013-09-06','11:55:00',3.62),('15844','2013-09-06','12:00:00',3.6),('15844','2013-09-06','12:05:00',3.67),('15844','2013-09-06','12:10:00',3.68),('15844','2013-09-06','12:15:00',3.7),('15844','2013-09-06','12:20:00',3.69),('15844','2013-09-06','12:25:00',3.64),('15844','2013-09-06','12:30:00',3.62),('15844','2013-09-06','12:35:00',3.66),('15844','2013-09-06','12:40:00',3.7),('15844','2013-09-06','12:45:00',3.65),('15844','2013-09-06','12:50:00',3.59),('15844','2013-09-06','12:55:00',3.58),('15844','2013-09-06','13:00:00',3.53),('15844','2013-09-06','13:05:00',3.51),('15844','2013-09-06','13:10:00',3.48),('15844','2013-09-06','13:15:00',3.45),('15844','2013-09-06','13:20:00',3.41),('15844','2013-09-06','13:25:00',3.36),('15844','2013-09-06','13:30:00',3.29),('15844','2013-09-06','13:35:00',3.23),('15844','2013-09-06','13:40:00',3.15),('15844','2013-09-06','13:45:00',3.12),('15844','2013-09-06','13:50:00',3.05),('15844','2013-09-06','13:55:00',3.03),('15844','2013-09-06','14:00:00',2.95),('15844','2013-09-06','14:05:00',2.93),('15844','2013-09-06','14:10:00',2.88),('15844','2013-09-06','14:15:00',2.77),('15844','2013-09-06','14:20:00',2.71),('15844','2013-09-06','14:25:00',2.61),('15844','2013-09-06','14:30:00',2.52),('15844','2013-09-06','14:35:00',2.4),('15844','2013-09-06','14:40:00',2.29),('15844','2013-09-06','14:45:00',2.23),('15844','2013-09-06','14:50:00',2.14),('15844','2013-09-06','14:55:00',2.05),('15844','2013-09-06','15:00:00',1.92),('15844','2013-09-06','15:05:00',1.94),('15844','2013-09-06','15:10:00',1.87),('15844','2013-09-06','15:15:00',1.77),('15844','2013-09-06','15:20:00',1.7),('15844','2013-09-06','15:25:00',1.61),('15844','2013-09-06','15:30:00',1.51),('15844','2013-09-06','15:35:00',1.42),('15844','2013-09-06','15:40:00',1.31),('15844','2013-09-06','15:45:00',1.19),('15844','2013-09-06','15:50:00',1.1),('15844','2013-09-06','15:55:00',1.05),('15844','2013-09-05','08:40:00',1.02),('15844','2013-09-05','08:45:00',1.14),('15844','2013-09-05','08:50:00',1.26),('15844','2013-09-05','08:55:00',1.33),('15844','2013-09-05','09:00:00',1.45),('15844','2013-09-05','09:05:00',1.59),('15844','2013-09-05','09:10:00',1.69),('15844','2013-09-05','09:15:00',1.74),('15844','2013-09-05','09:20:00',1.88),('15844','2013-09-05','09:25:00',2.05),('15844','2013-09-05','09:30:00',2.19),('15844','2013-09-05','09:35:00',2.3),('15844','2013-09-05','09:40:00',2.4),('15844','2013-09-05','09:45:00',2.46),('15844','2013-09-05','09:50:00',2.52),('15844','2013-09-05','09:55:00',2.58),('15844','2013-09-05','10:00:00',2.66),('15844','2013-09-05','10:05:00',2.76),('15844','2013-09-05','10:10:00',2.84),('15844','2013-09-05','10:15:00',2.88),('15844','2013-09-05','10:20:00',2.93),('15844','2013-09-05','10:25:00',2.96),('15844','2013-09-05','10:30:00',3.03),('15844','2013-09-05','10:35:00',3.19),('15844','2013-09-05','10:40:00',3.26),('15844','2013-09-05','10:45:00',3.3),('15844','2013-09-05','10:50:00',3.37),('15844','2013-09-05','10:55:00',3.51),('15844','2013-09-05','11:00:00',3.57),('15844','2013-09-05','11:05:00',3.59),('15844','2013-09-05','11:10:00',3.64),('15844','2013-09-05','11:15:00',3.66),('15844','2013-09-05','11:20:00',3.69),('15844','2013-09-05','11:25:00',3.69),('15844','2013-09-05','11:30:00',3.72),('15844','2013-09-05','11:35:00',3.71),('15844','2013-09-05','11:40:00',3.77),('15844','2013-09-05','11:45:00',3.78),('15844','2013-09-05','11:50:00',3.75),('15844','2013-09-05','11:55:00',3.72),('15844','2013-09-05','12:00:00',3.76),('15844','2013-09-05','12:05:00',3.79),('15844','2013-09-05','12:10:00',3.78),('15844','2013-09-05','12:15:00',3.79),('15844','2013-09-05','12:20:00',3.78),('15844','2013-09-05','12:25:00',3.78),('15844','2013-09-05','12:30:00',3.78),('15844','2013-09-05','12:35:00',3.76),('15844','2013-09-05','12:40:00',3.73),('15844','2013-09-05','12:45:00',3.71),('15844','2013-09-05','12:50:00',3.7),('15844','2013-09-05','12:55:00',3.67),('15844','2013-09-05','13:00:00',3.66),('15844','2013-09-05','13:05:00',3.62),('15844','2013-09-05','13:10:00',3.6),('15844','2013-09-05','13:15:00',3.56),('15844','2013-09-05','13:20:00',3.56),('15844','2013-09-05','13:25:00',3.52),('15844','2013-09-05','13:30:00',3.49),('15844','2013-09-05','13:35:00',3.43),('15844','2013-09-05','13:40:00',3.38),('15844','2013-09-05','13:45:00',3.31),('15844','2013-09-05','13:50:00',3.26),('15844','2013-09-05','13:55:00',3.22),('15844','2013-09-05','14:00:00',3.17),('15844','2013-09-05','14:05:00',3.1),('15844','2013-09-05','14:10:00',3.01),('15844','2013-09-05','14:15:00',2.96),('15844','2013-09-05','14:20:00',2.9),('15844','2013-09-05','14:25:00',2.78),('15844','2013-09-05','14:30:00',2.64),('15844','2013-09-05','14:35:00',2.54),('15844','2013-09-05','14:40:00',2.42),('15844','2013-09-05','14:45:00',2.3),('15844','2013-09-05','14:50:00',2.2),('15844','2013-09-05','14:55:00',2.15),('15844','2013-09-05','15:00:00',2.14),('15844','2013-09-05','15:05:00',2.04),('15844','2013-09-05','15:10:00',1.92),('15844','2013-09-05','15:15:00',1.81),('15844','2013-09-05','15:20:00',1.74),('15844','2013-09-05','15:25:00',1.67),('15844','2013-09-05','15:30:00',1.57),('15844','2013-09-05','15:35:00',1.46),('15844','2013-09-05','15:40:00',1.35),('15844','2013-09-05','15:45:00',1.22),('15844','2013-09-05','15:50:00',1.14),('15844','2013-09-05','15:55:00',1.07),('15844','2013-09-04','08:40:00',1.01),('15844','2013-09-04','08:45:00',1.13),('15844','2013-09-04','08:50:00',1.26),('15844','2013-09-04','08:55:00',1.33),('15844','2013-09-04','09:00:00',1.46),('15844','2013-09-04','09:05:00',1.59),('15844','2013-09-04','09:10:00',1.69),('15844','2013-09-04','09:15:00',1.78),('15844','2013-09-04','09:20:00',1.91),('15844','2013-09-04','09:25:00',2.04),('15844','2013-09-04','09:30:00',2.17),('15844','2013-09-04','09:35:00',2.29),('15844','2013-09-04','09:40:00',2.4),('15844','2013-09-04','09:45:00',2.48),('15844','2013-09-04','09:50:00',2.54),('15844','2013-09-04','09:55:00',2.61),('15844','2013-09-04','10:00:00',2.68),('15844','2013-09-04','10:05:00',2.8),('15844','2013-09-04','10:10:00',2.86),('15844','2013-09-04','10:15:00',2.89),('15844','2013-09-04','10:20:00',2.94),('15844','2013-09-04','10:25:00',2.99),('15844','2013-09-04','10:30:00',3.04),('15844','2013-09-04','10:35:00',3.22),('15844','2013-09-04','10:40:00',3.32),('15844','2013-09-04','10:45:00',3.4),('15844','2013-09-04','10:50:00',3.48),('15844','2013-09-04','10:55:00',3.6),('15844','2013-09-04','11:00:00',3.68),('15844','2013-09-04','11:05:00',3.74),('15844','2013-09-04','11:10:00',3.77),('15844','2013-09-04','11:15:00',3.8),('15844','2013-09-04','11:20:00',3.83),('15844','2013-09-04','11:25:00',3.85),('15844','2013-09-04','11:30:00',3.85),('15844','2013-09-04','11:35:00',3.88),('15844','2013-09-04','11:40:00',3.9),('15844','2013-09-04','11:45:00',3.91),('15844','2013-09-04','11:50:00',3.9),('15844','2013-09-04','11:55:00',3.91),('15844','2013-09-04','12:00:00',3.9),('15844','2013-09-04','12:05:00',3.9),('15844','2013-09-04','12:10:00',3.91),('15844','2013-09-04','12:15:00',3.88),('15844','2013-09-04','12:20:00',3.88),('15844','2013-09-04','12:25:00',3.87),('15844','2013-09-04','12:30:00',3.85),('15844','2013-09-04','12:35:00',3.83),('15844','2013-09-04','12:40:00',3.84),('15844','2013-09-04','12:45:00',3.81),('15844','2013-09-04','12:50:00',3.8),('15844','2013-09-04','12:55:00',3.78),('15844','2013-09-04','13:00:00',3.75),('15844','2013-09-04','13:05:00',3.69),('15844','2013-09-04','13:10:00',3.66),('15844','2013-09-04','13:15:00',3.65),('15844','2013-09-04','13:20:00',3.61),('15844','2013-09-04','13:25:00',3.59),('15844','2013-09-04','13:30:00',3.54),('15844','2013-09-04','13:35:00',3.48),('15844','2013-09-04','13:40:00',3.44),('15844','2013-09-04','13:45:00',3.36),('15844','2013-09-04','13:50:00',3.31),('15844','2013-09-04','13:55:00',3.25),('15844','2013-09-04','14:00:00',3.16),('15844','2013-09-04','14:05:00',3.1),('15844','2013-09-04','14:10:00',3.02),('15844','2013-09-04','14:15:00',2.96),('15844','2013-09-04','14:20:00',2.9),('15844','2013-09-04','14:25:00',2.81),('15844','2013-09-04','14:30:00',2.68),('15844','2013-09-04','14:35:00',2.57),('15844','2013-09-04','14:40:00',2.45),('15844','2013-09-04','14:45:00',2.34),('15844','2013-09-04','14:50:00',2.21),('15844','2013-09-04','14:55:00',2.1),('15844','2013-09-04','15:00:00',1.98),('15844','2013-09-04','15:05:00',2.01),('15844','2013-09-04','15:10:00',1.98),('15844','2013-09-04','15:15:00',1.89),('15844','2013-09-04','15:20:00',1.81),('15844','2013-09-04','15:25:00',1.71),('15844','2013-09-04','15:30:00',1.61),('15844','2013-09-04','15:35:00',1.51),('15844','2013-09-04','15:40:00',1.38),('15844','2013-09-04','15:45:00',1.25),('15844','2013-09-04','15:50:00',1.16),('15844','2013-09-04','15:55:00',1.08),('15844','2013-09-03','08:45:00',1.06),('15844','2013-09-03','08:50:00',1.17),('15844','2013-09-03','08:55:00',1.22),('15844','2013-09-03','09:00:00',1.32),('15844','2013-09-03','09:05:00',1.44),('15844','2013-09-03','09:10:00',1.53),('15844','2013-09-03','09:15:00',1.67),('15844','2013-09-03','09:20:00',1.79),('15844','2013-09-03','09:25:00',1.9),('15844','2013-09-03','09:30:00',1.99),('15844','2013-09-03','09:35:00',2.09),('15844','2013-09-03','09:40:00',2.2),('15844','2013-09-03','09:45:00',2.27),('15844','2013-09-03','09:50:00',2.35),('15844','2013-09-03','09:55:00',2.4),('15844','2013-09-03','10:00:00',2.45),('15844','2013-09-03','10:05:00',2.56),('15844','2013-09-03','10:10:00',2.63),('15844','2013-09-03','10:15:00',2.68),('15844','2013-09-03','10:20:00',2.76),('15844','2013-09-03','10:25:00',2.82),('15844','2013-09-03','10:30:00',2.92),('15844','2013-09-03','10:35:00',3.1),('15844','2013-09-03','10:40:00',3.19),('15844','2013-09-03','10:45:00',3.24),('15844','2013-09-03','10:50:00',3.29),('15844','2013-09-03','10:55:00',3.38),('15844','2013-09-03','11:00:00',3.46),('15844','2013-09-03','11:05:00',3.52),('15844','2013-09-03','11:10:00',3.57),('15844','2013-09-03','11:15:00',3.6),('15844','2013-09-03','11:20:00',3.64),('15844','2013-09-03','11:25:00',3.65),('15844','2013-09-03','11:30:00',3.65),('15844','2013-09-03','11:35:00',3.67),('15844','2013-09-03','11:40:00',3.68),('15844','2013-09-03','11:45:00',3.69),('15844','2013-09-03','11:50:00',3.69),('15844','2013-09-03','11:55:00',3.73),('15844','2013-09-03','12:00:00',3.76),('15844','2013-09-03','12:05:00',3.75),('15844','2013-09-03','12:10:00',3.75),('15844','2013-09-03','12:15:00',3.74),('15844','2013-09-03','12:20:00',3.75),('15844','2013-09-03','12:25:00',3.73),('15844','2013-09-03','12:30:00',3.75),('15844','2013-09-03','12:35:00',3.71),('15844','2013-09-03','12:40:00',3.74),('15844','2013-09-03','12:45:00',3.72),('15844','2013-09-03','12:50:00',3.71),('15844','2013-09-03','12:55:00',3.68),('15844','2013-09-03','13:00:00',3.67),('15844','2013-09-03','13:05:00',3.68),('15844','2013-09-03','13:10:00',3.64),('15844','2013-09-03','13:15:00',3.6),('15844','2013-09-03','13:20:00',3.58),('15844','2013-09-03','13:25:00',3.53),('15844','2013-09-03','13:30:00',3.53),('15844','2013-09-03','13:35:00',3.51),('15844','2013-09-03','13:40:00',3.41),('15844','2013-09-03','13:45:00',3.34),('15844','2013-09-03','13:50:00',3.26),('15844','2013-09-03','13:55:00',3.24),('15844','2013-09-03','14:00:00',3.19),('15844','2013-09-03','14:05:00',3.14),('15844','2013-09-03','14:10:00',3.08),('15844','2013-09-03','14:15:00',3),('15844','2013-09-03','14:20:00',2.89),('15844','2013-09-03','14:25:00',2.79),('15844','2013-09-03','14:30:00',2.67),('15844','2013-09-03','14:35:00',2.55),('15844','2013-09-03','14:40:00',2.45),('15844','2013-09-03','14:45:00',2.34),('15844','2013-09-03','14:50:00',2.28),('15844','2013-09-03','14:55:00',2.28),('15844','2013-09-03','15:00:00',2.18),('15844','2013-09-03','15:05:00',2.07),('15844','2013-09-03','15:10:00',1.99),('15844','2013-09-03','15:15:00',1.89),('15844','2013-09-03','15:20:00',1.82),('15844','2013-09-03','15:25:00',1.73),('15844','2013-09-03','15:30:00',1.62),('15844','2013-09-03','15:35:00',1.52),('15844','2013-09-03','15:40:00',1.4),('15844','2013-09-03','15:45:00',1.28),('15844','2013-09-03','15:50:00',1.18),('15844','2013-09-03','15:55:00',1.1),('15844','2013-09-03','16:00:00',1.03),('15844','2013-09-02','08:45:00',1.08),('15844','2013-09-02','08:50:00',1.19),('15844','2013-09-02','08:55:00',1.24),('15844','2013-09-02','09:00:00',1.35),('15844','2013-09-02','09:05:00',1.45),('15844','2013-09-02','09:10:00',1.53),('15844','2013-09-02','09:15:00',1.62),('15844','2013-09-02','09:20:00',1.74),('15844','2013-09-02','09:25:00',1.87),('15844','2013-09-02','09:30:00',1.99),('15844','2013-09-02','09:35:00',2.08),('15844','2013-09-02','09:40:00',2.15),('15844','2013-09-02','09:45:00',2.23),('15844','2013-09-02','09:50:00',2.28),('15844','2013-09-02','09:55:00',2.36),('15844','2013-09-02','10:00:00',2.47),('15844','2013-09-02','10:05:00',2.6),('15844','2013-09-02','10:10:00',2.69),('15844','2013-09-02','10:15:00',2.75),('15844','2013-09-02','10:20:00',2.8),('15844','2013-09-02','10:25:00',2.86),('15844','2013-09-02','10:30:00',2.98),('15844','2013-09-02','10:35:00',3.13),('15844','2013-09-02','10:40:00',3.21),('15844','2013-09-02','10:45:00',3.24),('15844','2013-09-02','10:50:00',3.35),('15844','2013-09-02','10:55:00',3.45),('15844','2013-09-02','11:00:00',3.51),('15844','2013-09-02','11:05:00',3.52),('15844','2013-09-02','11:10:00',3.64),('15844','2013-09-02','11:15:00',3.65),('15844','2013-09-02','11:20:00',3.67),('15844','2013-09-02','11:25:00',3.68),('15844','2013-09-02','11:30:00',3.72),('15844','2013-09-02','11:35:00',3.72),('15844','2013-09-02','11:40:00',3.73),('15844','2013-09-02','11:45:00',3.75),('15844','2013-09-02','11:50:00',3.74),('15844','2013-09-02','11:55:00',3.76),('15844','2013-09-02','12:00:00',3.79),('15844','2013-09-02','12:05:00',3.74),('15844','2013-09-02','12:10:00',3.78),('15844','2013-09-02','12:15:00',3.78),('15844','2013-09-02','12:20:00',3.77),('15844','2013-09-02','12:25:00',3.76),('15844','2013-09-02','12:30:00',3.75),('15844','2013-09-02','12:35:00',3.73),('15844','2013-09-02','12:40:00',3.71),('15844','2013-09-02','12:45:00',3.67),('15844','2013-09-02','12:50:00',3.64),('15844','2013-09-02','12:55:00',3.64),('15844','2013-09-02','13:00:00',3.59),('15844','2013-09-02','13:05:00',3.58),('15844','2013-09-02','13:10:00',3.58),('15844','2013-09-02','13:15:00',3.6),('15844','2013-09-02','13:20:00',3.51),('15844','2013-09-02','13:25:00',3.46),('15844','2013-09-02','13:30:00',3.46),('15844','2013-09-02','13:35:00',3.38),('15844','2013-09-02','13:40:00',3.39),('15844','2013-09-02','13:45:00',3.36),('15844','2013-09-02','13:50:00',3.23),('15844','2013-09-02','13:55:00',3.19),('15844','2013-09-02','14:00:00',3.19),('15844','2013-09-02','14:05:00',3.15),('15844','2013-09-02','14:10:00',3.01),('15844','2013-09-02','14:15:00',2.98),('15844','2013-09-02','14:20:00',2.9),('15844','2013-09-02','14:25:00',2.64),('15844','2013-09-02','14:30:00',2.73),('15844','2013-09-02','14:35:00',2.59),('15844','2013-09-02','14:40:00',2.46),('15844','2013-09-02','14:45:00',2.41),('15844','2013-09-02','14:50:00',2.38),('15844','2013-09-02','14:55:00',2.21),('15844','2013-09-02','15:00:00',2.07),('15844','2013-09-02','15:05:00',1.96),('15844','2013-09-02','15:10:00',1.95),('15844','2013-09-02','15:15:00',1.92),('15844','2013-09-02','15:20:00',1.89),('15844','2013-09-02','15:25:00',1.77),('15844','2013-09-02','15:30:00',1.7),('15844','2013-09-02','15:35:00',1.59),('15844','2013-09-02','15:40:00',1.46),('15844','2013-09-02','15:45:00',1.35),('15844','2013-09-02','15:50:00',1.24),('15844','2013-09-02','15:55:00',1.18),('15844','2013-09-02','16:00:00',1.12),('15844','2013-09-02','16:05:00',1.08),('15844','2013-09-02','16:10:00',1.03),('15844','2013-09-01','08:50:00',1.07),('15844','2013-09-01','08:55:00',1.29),('15844','2013-09-01','09:00:00',1.4),('15844','2013-09-01','09:05:00',1.52),('15844','2013-09-01','09:10:00',1.62),('15844','2013-09-01','09:15:00',1.71),('15844','2013-09-01','09:20:00',1.84),('15844','2013-09-01','09:25:00',1.96),('15844','2013-09-01','09:30:00',2.06),('15844','2013-09-01','09:35:00',2.18),('15844','2013-09-01','09:40:00',2.25),('15844','2013-09-01','09:45:00',2.3),('15844','2013-09-01','09:50:00',2.36),('15844','2013-09-01','09:55:00',2.42),('15844','2013-09-01','10:00:00',2.54),('15844','2013-09-01','10:05:00',2.66),('15844','2013-09-01','10:10:00',2.76),('15844','2013-09-01','10:15:00',2.8),('15844','2013-09-01','10:20:00',2.83),('15844','2013-09-01','10:25:00',2.89),('15844','2013-09-01','10:30:00',2.95),('15844','2013-09-01','10:35:00',3.17),('15844','2013-09-01','10:40:00',3.25),('15844','2013-09-01','10:45:00',3.32),('15844','2013-09-01','10:50:00',3.39),('15844','2013-09-01','10:55:00',3.54),('15844','2013-09-01','11:00:00',3.6),('15844','2013-09-01','11:05:00',3.65),('15844','2013-09-01','11:10:00',3.67),('15844','2013-09-01','11:15:00',3.71),('15844','2013-09-01','11:20:00',3.72),('15844','2013-09-01','11:25:00',3.75),('15844','2013-09-01','11:30:00',3.77),('15844','2013-09-01','11:35:00',3.8),('15844','2013-09-01','11:40:00',3.81),('15844','2013-09-01','11:45:00',3.81),('15844','2013-09-01','11:50:00',3.82),('15844','2013-09-01','11:55:00',3.81),('15844','2013-09-01','12:00:00',3.8),('15844','2013-09-01','12:05:00',3.71),('15844','2013-09-01','12:10:00',3.83),('15844','2013-09-01','12:15:00',3.81),('15844','2013-09-01','12:20:00',3.76),('15844','2013-09-01','12:25:00',3.78),('15844','2013-09-01','12:30:00',3.78),('15844','2013-09-01','12:35:00',3.76),('15844','2013-09-01','12:40:00',3.73),('15844','2013-09-01','12:45:00',3.7),('15844','2013-09-01','12:50:00',3.71),('15844','2013-09-01','12:55:00',3.69),('15844','2013-09-01','13:00:00',3.41),('15844','2013-09-01','13:05:00',3.49),('15844','2013-09-01','13:10:00',3.54),('15844','2013-09-01','13:15:00',3.63),('15844','2013-09-01','13:20:00',3.26),('15844','2013-09-01','13:25:00',3.43),('15844','2013-09-01','13:30:00',3.58),('15844','2013-09-01','13:35:00',3.59),('15844','2013-09-01','13:40:00',3.48),('15844','2013-09-01','13:45:00',3.45),('15844','2013-09-01','13:50:00',3.39),('15844','2013-09-01','13:55:00',3.32),('15844','2013-09-01','14:00:00',3.19),('15844','2013-09-01','14:05:00',2.66),('15844','2013-09-01','14:10:00',2.71),('15844','2013-09-01','14:15:00',2.55),('15844','2013-09-01','14:20:00',2.52),('15844','2013-09-01','14:25:00',2.5),('15844','2013-09-01','14:30:00',2.36),('15844','2013-09-01','14:35:00',2.2),('15844','2013-09-01','14:40:00',2.42),('15844','2013-09-01','14:45:00',2.34),('15844','2013-09-01','14:50:00',2.24),('15844','2013-09-01','14:55:00',2.19),('15844','2013-09-01','15:00:00',2.18),('15844','2013-09-01','15:05:00',2.06),('15844','2013-09-01','15:10:00',2.02),('15844','2013-09-01','15:15:00',1.98),('15844','2013-09-01','15:20:00',1.79),('15844','2013-09-01','15:25:00',1.59),('15844','2013-09-01','15:30:00',1.35),('15844','2013-09-01','15:35:00',1.48),('15844','2013-09-01','15:40:00',1.43),('15844','2013-09-01','15:45:00',1.37),('15844','2013-09-01','15:50:00',1.29),('15844','2013-09-01','15:55:00',1.2),('15844','2013-09-01','16:00:00',1.14),('15844','2013-09-01','16:05:00',1.15),('15844','2013-09-01','16:10:00',1.27),('15844','2013-09-01','16:15:00',1.22),('15844','2013-09-01','16:20:00',1.14),('15844','2013-09-01','16:25:00',1.03),('15844','2013-08-31','08:40:00',1.04),('15844','2013-08-31','08:45:00',1.24),('15844','2013-08-31','08:50:00',1.44),('15844','2013-08-31','08:55:00',1.56),('15844','2013-08-31','09:00:00',1.54),('15844','2013-08-31','09:05:00',1.4),('15844','2013-08-31','09:10:00',1.16),('15844','2013-08-31','09:15:00',1.74),('15844','2013-08-31','09:20:00',1.93),('15844','2013-08-31','09:25:00',2.15),('15844','2013-08-31','09:30:00',2.27),('15844','2013-08-31','09:35:00',2.42),('15844','2013-08-31','09:40:00',2.24),('15844','2013-08-31','09:45:00',2.24),('15844','2013-08-31','09:50:00',2.44),('15844','2013-08-31','09:55:00',2.49),('15844','2013-08-31','10:00:00',2.6),('15844','2013-08-31','10:05:00',2.74),('15844','2013-08-31','10:10:00',2.82),('15844','2013-08-31','10:15:00',2.87),('15844','2013-08-31','10:20:00',2.9),('15844','2013-08-31','10:25:00',2.94),('15844','2013-08-31','10:30:00',3.12),('15844','2013-08-31','10:35:00',3.19),('15844','2013-08-31','10:40:00',3.29),('15844','2013-08-31','10:45:00',3.39),('15844','2013-08-31','10:50:00',3.45),('15844','2013-08-31','10:55:00',3.61),('15844','2013-08-31','11:00:00',3.73),('15844','2013-08-31','11:05:00',3.74),('15844','2013-08-31','11:10:00',3.78),('15844','2013-08-31','11:15:00',3.82),('15844','2013-08-31','11:20:00',3.86),('15844','2013-08-31','11:25:00',3.88),('15844','2013-08-31','11:30:00',3.89),('15844','2013-08-31','11:35:00',3.93),('15844','2013-08-31','11:40:00',3.92),('15844','2013-08-31','11:45:00',3.96),('15844','2013-08-31','11:50:00',3.94),('15844','2013-08-31','11:55:00',3.96),('15844','2013-08-31','12:00:00',3.95),('15844','2013-08-31','12:05:00',3.95),('15844','2013-08-31','12:10:00',3.93),('15844','2013-08-31','12:15:00',3.95),('15844','2013-08-31','12:20:00',3.93),('15844','2013-08-31','12:25:00',3.93),('15844','2013-08-31','12:30:00',3.87),('15844','2013-08-31','12:35:00',3.88),('15844','2013-08-31','12:40:00',3.86),('15844','2013-08-31','12:45:00',3.83),('15844','2013-08-31','12:50:00',3.83),('15844','2013-08-31','12:55:00',3.82),('15844','2013-08-31','13:00:00',3.81),('15844','2013-08-31','13:05:00',3.74),('15844','2013-08-31','13:10:00',3.71),('15844','2013-08-31','13:15:00',3.73),('15844','2013-08-31','13:20:00',3.7),('15844','2013-08-31','13:25:00',3.61),('15844','2013-08-31','13:30:00',3.59),('15844','2013-08-31','13:35:00',3.47),('15844','2013-08-31','13:40:00',3.43),('15844','2013-08-31','13:45:00',3.43),('15844','2013-08-31','13:50:00',3.34),('15844','2013-08-31','13:55:00',3.28),('15844','2013-08-31','14:00:00',3.23),('15844','2013-08-31','14:05:00',3.17),('15844','2013-08-31','14:10:00',3.12),('15844','2013-08-31','14:15:00',3.03),('15844','2013-08-31','14:20:00',2.94),('15844','2013-08-31','14:25:00',2.88),('15844','2013-08-31','14:30:00',2.72),('15844','2013-08-31','14:35:00',2.6),('15844','2013-08-31','14:40:00',2.5),('15844','2013-08-31','14:45:00',2.42),('15844','2013-08-31','14:50:00',2.38),('15844','2013-08-31','14:55:00',2.24),('15844','2013-08-31','15:00:00',2.2),('15844','2013-08-31','15:05:00',2.09),('15844','2013-08-31','15:10:00',2.02),('15844','2013-08-31','15:15:00',1.94),('15844','2013-08-31','15:20:00',1.86),('15844','2013-08-31','15:25:00',1.78),('15844','2013-08-31','15:30:00',1.68),('15844','2013-08-31','15:35:00',1.61),('15844','2013-08-31','15:40:00',1.49),('15844','2013-08-31','15:45:00',1.38),('15844','2013-08-31','15:50:00',1.27),('15844','2013-08-31','15:55:00',1.2),('15844','2013-08-31','16:00:00',1.13),('15844','2013-08-31','16:05:00',1.08),('15844','2013-08-31','16:10:00',1.03),('15844','2013-08-30','08:30:00',1),('15844','2013-08-30','08:35:00',1.12),('15844','2013-08-30','08:40:00',1.1),('15844','2013-08-30','08:45:00',1.02),('15844','2013-08-30','08:50:00',1),('15844','2013-08-30','08:55:00',1.09),('15844','2013-08-30','09:00:00',1.26),('15844','2013-08-30','09:05:00',1.28),('15844','2013-08-30','09:10:00',1.16),('15844','2013-08-30','09:15:00',1.04),('15844','2013-08-30','09:25:00',1.19),('15844','2013-08-30','09:30:00',1.38),('15844','2013-08-30','09:35:00',1.48),('15844','2013-08-30','09:40:00',1.48),('15844','2013-08-30','09:45:00',1.5),('15844','2013-08-30','09:50:00',1.58),('15844','2013-08-30','09:55:00',1.65),('15844','2013-08-30','10:00:00',1.62),('15844','2013-08-30','10:05:00',1.65),('15844','2013-08-30','10:10:00',1.77),('15844','2013-08-30','10:15:00',1.9),('15844','2013-08-30','10:20:00',1.8),('15844','2013-08-30','10:25:00',1.89),('15844','2013-08-30','10:30:00',1.97),('15844','2013-08-30','10:35:00',1.92),('15844','2013-08-30','10:40:00',1.75),('15844','2013-08-30','10:45:00',1.85),('15844','2013-08-30','10:50:00',1.92),('15844','2013-08-30','10:55:00',1.82),('15844','2013-08-30','11:00:00',1.96),('15844','2013-08-30','11:05:00',2.08),('15844','2013-08-30','11:10:00',2.3),('15844','2013-08-30','11:15:00',2.19),('15844','2013-08-30','11:20:00',2.31),('15844','2013-08-30','11:25:00',2.37),('15844','2013-08-30','11:30:00',2.47),('15844','2013-08-30','11:35:00',2.41),('15844','2013-08-30','11:40:00',2.5),('15844','2013-08-30','11:45:00',2.7),('15844','2013-08-30','11:50:00',2.88),('15844','2013-08-30','11:55:00',2.39),('15844','2013-08-30','12:00:00',1.96),('15844','2013-08-30','12:05:00',1.94),('15844','2013-08-30','12:10:00',2.2),('15844','2013-08-30','12:15:00',2.26),('15844','2013-08-30','12:20:00',2.51),('15844','2013-08-30','12:25:00',2.97),('15844','2013-08-30','12:30:00',3.08),('15844','2013-08-30','12:35:00',2.85),('15844','2013-08-30','12:40:00',2.98),('15844','2013-08-30','12:45:00',2.83),('15844','2013-08-30','12:50:00',2.73),('15844','2013-08-30','12:55:00',2.46),('15844','2013-08-30','13:00:00',2.5),('15844','2013-08-30','13:05:00',2.42),('15844','2013-08-30','13:10:00',2.36),('15844','2013-08-30','13:15:00',2.35),('15844','2013-08-30','13:20:00',3.3),('15844','2013-08-30','13:25:00',3.74),('15844','2013-08-30','13:30:00',3.54),('15844','2013-08-30','13:35:00',3.34),('15844','2013-08-30','13:40:00',3.54),('15844','2013-08-30','13:45:00',3.28),('15844','2013-08-30','13:50:00',3.26),('15844','2013-08-30','13:55:00',3.33),('15844','2013-08-30','14:00:00',3.35),('15844','2013-08-30','14:05:00',3.17),('15844','2013-08-30','14:10:00',3.21),('15844','2013-08-30','14:15:00',3.06),('15844','2013-08-30','14:20:00',3.04),('15844','2013-08-30','14:25:00',2.92),('15844','2013-08-30','14:30:00',2.87),('15844','2013-08-30','14:35:00',2.73),('15844','2013-08-30','14:40:00',2.47),('15844','2013-08-30','14:45:00',2.21),('15844','2013-08-30','14:50:00',2.02),('15844','2013-08-30','14:55:00',1.95),('15844','2013-08-30','15:00:00',1.68),('15844','2013-08-30','15:05:00',1.68),('15844','2013-08-30','15:10:00',1.82),('15844','2013-08-30','15:15:00',1.78),('15844','2013-08-30','15:20:00',1.61),('15844','2013-08-30','15:25:00',1.6),('15844','2013-08-30','15:30:00',1.53),('15844','2013-08-30','15:35:00',1.42),('15844','2013-08-30','15:40:00',1.59),('15844','2013-08-30','15:45:00',1.55),('15844','2013-08-30','15:50:00',1.43),('15844','2013-08-30','15:55:00',1.4),('15844','2013-08-30','16:00:00',1.3),('15844','2013-08-30','16:05:00',1.15),('15844','2013-08-30','16:10:00',1.13),('15844','2013-08-30','16:15:00',1.17),('15844','2013-08-30','16:20:00',1.15),('15844','2013-08-30','16:25:00',1.11),('15844','2013-08-30','16:30:00',1.14),('15844','2013-08-30','16:35:00',1.13),('15844','2013-08-30','16:40:00',1.02),('15844','2014-04-11','08:45:00',1.09),('15844','2014-04-11','08:50:00',1.38),('15844','2014-04-11','08:55:00',1.48),('15844','2014-04-11','09:00:00',1.54),('15844','2014-04-11','09:05:00',1.67),('15844','2014-04-11','09:10:00',1.75),('15844','2014-04-11','09:15:00',1.88),('15844','2014-04-11','09:20:00',1.99),('15844','2014-04-11','09:25:00',2.1),('15844','2014-04-11','09:30:00',2.23),('15844','2014-04-11','09:35:00',2.34),('15844','2014-04-11','09:40:00',2.39),('15844','2014-04-11','09:45:00',2.45),('15844','2014-04-11','09:50:00',2.53),('15844','2014-04-11','09:55:00',2.58),('15844','2014-04-11','10:00:00',2.71),('15844','2014-04-11','10:05:00',2.82),('15844','2014-04-11','10:10:00',2.87),('15844','2014-04-11','10:15:00',2.97),('15844','2014-04-11','10:20:00',3.05),('15844','2014-04-11','10:25:00',3.09),('15844','2014-04-11','10:30:00',3.14),('15844','2014-04-11','10:35:00',3.24),('15844','2014-04-11','10:40:00',3.39),('15844','2014-04-11','10:45:00',3.52),('15844','2014-04-11','10:50:00',3.58),('15844','2014-04-11','10:55:00',3.66),('15844','2014-04-11','11:00:00',3.76),('15844','2014-04-11','11:05:00',3.88),('15844','2014-04-11','11:10:00',3.89),('15844','2014-04-11','11:15:00',3.92),('15844','2014-04-11','11:20:00',3.98),('15844','2014-04-11','11:25:00',4.02),('15844','2014-04-11','11:30:00',4.02),('15844','2014-04-11','11:35:00',4.1),('15844','2014-04-11','11:40:00',4.23),('15844','2014-04-11','11:45:00',4.3),('15844','2014-04-11','11:50:00',2.33),('15844','2014-04-11','11:55:00',3.7),('15844','2014-04-11','12:00:00',4.31),('15844','2014-04-11','12:05:00',4.17),('15844','2014-04-11','12:10:00',3.61),('15844','2014-04-11','12:15:00',2.77),('15844','2014-04-11','12:20:00',3.48),('15844','2014-04-11','12:25:00',3.33),('15844','2014-04-11','12:30:00',3.41),('15844','2014-04-11','12:35:00',4.13),('15844','2014-04-11','12:40:00',2.55),('15844','2014-04-11','12:45:00',3.14),('15844','2014-04-11','12:50:00',3.03),('15844','2014-04-11','12:55:00',3.49),('15844','2014-04-11','13:00:00',2.28),('15844','2014-04-11','13:05:00',4.02),('15844','2014-04-11','13:10:00',3.89),('15844','2014-04-11','13:15:00',3.8),('15844','2014-04-11','13:20:00',4.15),('15844','2014-04-11','13:25:00',3.54),('15844','2014-04-11','13:30:00',3.75),('15844','2014-04-11','13:35:00',4.27),('15844','2014-04-11','13:40:00',3.93),('15844','2014-04-11','13:45:00',3.95),('15844','2014-04-11','13:50:00',3.4),('15844','2014-04-11','13:55:00',3.29),('15844','2014-04-11','14:00:00',2.59),('15844','2014-04-11','14:05:00',2.55),('15844','2014-04-11','14:10:00',4.07),('15844','2014-04-11','14:15:00',1.44),('15844','2014-04-11','14:20:00',1.62),('15844','2014-04-11','14:25:00',1.85),('15844','2014-04-11','14:30:00',3.56),('15844','2014-04-11','14:35:00',3.11),('15844','2014-04-11','14:40:00',2.94),('15844','2014-04-11','14:45:00',1.87),('15844','2014-04-11','14:50:00',2.63),('15844','2014-04-11','14:55:00',1.84),('15844','2014-04-11','15:00:00',1.91),('15844','2014-04-11','15:05:00',2.45),('15844','2014-04-11','15:10:00',2.17),('15844','2014-04-11','15:15:00',2.15),('15844','2014-04-11','15:20:00',1.83),('15844','2014-04-11','15:25:00',1.98),('15844','2014-04-11','15:30:00',1.87),('15844','2014-04-11','15:35:00',1.74),('15844','2014-04-11','15:40:00',1.64),('15844','2014-04-11','15:45:00',1.55),('15844','2014-04-11','15:50:00',1.35),('15844','2014-04-11','15:55:00',1.04),('15844','2014-04-11','16:05:00',1.34),('15844','2014-04-11','16:10:00',1.28),('15844','2014-04-11','16:15:00',1.21),('15844','2014-04-11','16:25:00',1.12),('15844','2013-08-29','08:25:00',1.01),('15844','2013-08-29','08:30:00',1.23),('15844','2013-08-29','08:35:00',1.11),('15844','2013-08-29','08:50:00',1.09),('15844','2013-08-29','08:55:00',1.24),('15844','2013-08-29','09:00:00',1.25),('15844','2013-08-29','09:05:00',1.21),('15844','2013-08-29','09:10:00',1.28),('15844','2013-08-29','09:15:00',1.27),('15844','2013-08-29','09:20:00',1.31),('15844','2013-08-29','09:25:00',1.3),('15844','2013-08-29','09:30:00',1.37),('15844','2013-08-29','09:35:00',1.54),('15844','2013-08-29','09:40:00',1.42),('15844','2013-08-29','09:45:00',1.26),('15844','2013-08-29','09:50:00',1.24),('15844','2013-08-29','09:55:00',1.28),('15844','2013-08-29','10:00:00',1.27),('15844','2013-08-29','10:05:00',1.26),('15844','2013-08-29','10:10:00',1.27),('15844','2013-08-29','10:15:00',1.29),('15844','2013-08-29','10:20:00',1.31),('15844','2013-08-29','10:25:00',1.34),('15844','2013-08-29','10:30:00',1.37),('15844','2013-08-29','10:35:00',1.22),('15844','2013-08-29','10:40:00',1.1),('15844','2013-08-29','10:45:00',1.06),('15844','2013-08-29','10:50:00',1.13),('15844','2013-08-29','10:55:00',1.33),('15844','2013-08-29','11:00:00',1.34),('15844','2013-08-29','11:05:00',1.52),('15844','2013-08-29','11:10:00',1.78),('15844','2013-08-29','11:15:00',1.77),('15844','2013-08-29','11:20:00',1.61),('15844','2013-08-29','11:25:00',1.31),('15844','2013-08-29','11:30:00',1.13),('15844','2013-08-29','11:35:00',1.22),('15844','2013-08-29','11:40:00',1.47),('15844','2013-08-29','11:45:00',1.59),('15844','2013-08-29','11:50:00',1.64),('15844','2013-08-29','11:55:00',1.55),('15844','2013-08-29','12:00:00',1.58),('15844','2013-08-29','12:05:00',1.88),('15844','2013-08-29','12:10:00',2.56),('15844','2013-08-29','12:15:00',2.81),('15844','2013-08-29','12:20:00',2.87),('15844','2013-08-29','12:25:00',2.36),('15844','2013-08-29','12:30:00',2.77),('15844','2013-08-29','12:35:00',2.93),('15844','2013-08-29','12:40:00',3.49),('15844','2013-08-29','12:45:00',2.48),('15844','2013-08-29','12:50:00',2.4),('15844','2013-08-29','12:55:00',2.45),('15844','2013-08-29','13:00:00',2.27),('15844','2013-08-29','13:05:00',2.21),('15844','2013-08-29','13:10:00',1.96),('15844','2013-08-29','13:15:00',2.05),('15844','2013-08-29','13:20:00',1.93),('15844','2013-08-29','13:25:00',1.62),('15844','2013-08-29','13:30:00',1.54),('15844','2013-08-29','13:35:00',1.52),('15844','2013-08-29','13:40:00',1.39),('15844','2013-08-29','13:45:00',1.32),('15844','2013-08-29','13:50:00',1.43),('15844','2013-08-29','13:55:00',2.06),('15844','2013-08-29','14:00:00',1.64),('15844','2013-08-29','14:05:00',1.31),('15844','2013-08-29','14:10:00',1.12),('15844','2013-08-29','14:45:00',1.04),('15844','2013-08-29','14:50:00',1.16),('15844','2013-08-29','14:55:00',1.38),('15844','2013-08-29','15:00:00',1.57),('15844','2013-08-29','15:05:00',1.36),('15844','2013-08-29','15:15:00',1.09),('15844','2013-08-29','15:20:00',1.62),('15844','2013-08-29','15:25:00',1.89),('15844','2013-08-29','15:30:00',1.69),('15844','2013-08-29','15:35:00',1.57),('15844','2013-08-29','15:40:00',1.63),('15844','2013-08-29','15:45:00',1.45),('15844','2013-08-29','15:50:00',1.73),('15844','2013-08-29','15:55:00',1.52),('15844','2013-08-29','16:00:00',1.83),('15844','2013-08-29','16:05:00',1.58),('15844','2013-08-29','16:10:00',1.23),('15844','2013-08-29','16:15:00',1.06),('15844','2013-08-28','08:35:00',1.18),('15844','2013-08-28','08:55:00',1.12),('15844','2013-08-28','09:00:00',1.52),('15844','2013-08-28','09:05:00',1.61),('15844','2013-08-28','09:10:00',1.89),('15844','2013-08-28','09:15:00',1.6),('15844','2013-08-28','09:25:00',1.19),('15844','2013-08-28','09:30:00',1.84),('15844','2013-08-28','09:35:00',1.99),('15844','2013-08-28','09:40:00',1.96),('15844','2013-08-28','09:45:00',2.28),('15844','2013-08-28','09:50:00',2.44),('15844','2013-08-28','09:55:00',2.5),('15844','2013-08-28','10:00:00',1.39),('15844','2013-08-28','10:05:00',2.23),('15844','2013-08-28','10:10:00',2.67),('15844','2013-08-28','10:15:00',2.78),('15844','2013-08-28','10:20:00',2.79),('15844','2013-08-28','10:25:00',2.88),('15844','2013-08-28','10:30:00',2.43),('15844','2013-08-28','10:35:00',3.32),('15844','2013-08-28','10:40:00',3.55),('15844','2013-08-28','10:45:00',3.72),('15844','2013-08-28','10:50:00',3.11),('15844','2013-08-28','10:55:00',1.46),('15844','2013-08-28','11:00:00',3.88),('15844','2013-08-28','11:05:00',4.07),('15844','2013-08-28','11:10:00',2.12),('15844','2013-08-28','11:15:00',3.85),('15844','2013-08-28','11:20:00',4),('15844','2013-08-28','11:25:00',3.08),('15844','2013-08-28','11:30:00',3.31),('15844','2013-08-28','11:35:00',4.29),('15844','2013-08-28','11:40:00',2.81),('15844','2013-08-28','11:45:00',3.11),('15844','2013-08-28','11:50:00',2.53),('15844','2013-08-28','11:55:00',3.63),('15844','2013-08-28','12:00:00',4.5),('15844','2013-08-28','12:05:00',4.24),('15844','2013-08-28','12:10:00',4.13),('15844','2013-08-28','12:15:00',4.3),('15844','2013-08-28','12:20:00',3.31),('15844','2013-08-28','12:25:00',3.43),('15844','2013-08-28','12:30:00',4.23),('15844','2013-08-28','12:35:00',2.27),('15844','2013-08-28','12:40:00',4.19),('15844','2013-08-28','12:45:00',4.16),('15844','2013-08-28','12:50:00',4.12),('15844','2013-08-28','12:55:00',4.04),('15844','2013-08-28','13:00:00',4.02),('15844','2013-08-28','13:05:00',4.02),('15844','2013-08-28','13:10:00',3.96),('15844','2013-08-28','13:15:00',3.93),('15844','2013-08-28','13:20:00',3.78),('15844','2013-08-28','13:25:00',3.99),('15844','2013-08-28','13:30:00',2.34),('15844','2013-08-28','13:35:00',4.05),('15844','2013-08-28','13:40:00',2.77),('15844','2013-08-28','13:45:00',3.75),('15844','2013-08-28','13:50:00',3.62),('15844','2013-08-28','13:55:00',3.54),('15844','2013-08-28','14:00:00',3.51),('15844','2013-08-28','14:05:00',3.42),('15844','2013-08-28','14:10:00',2.92),('15844','2013-08-28','14:15:00',3.19),('15844','2013-08-28','14:20:00',2.76),('15844','2013-08-28','14:25:00',1.41),('15844','2013-08-28','14:30:00',2.13),('15844','2013-08-28','14:35:00',3.06),('15844','2013-08-28','14:40:00',2.82),('15844','2013-08-28','14:45:00',2.75),('15844','2013-08-28','14:50:00',2.63),('15844','2013-08-28','14:55:00',2.54),('15844','2013-08-28','15:00:00',2.49),('15844','2013-08-28','15:05:00',2.53),('15844','2013-08-28','15:10:00',2.29),('15844','2013-08-28','15:15:00',2.24),('15844','2013-08-28','15:20:00',1.24),('15844','2013-08-28','15:25:00',1.9),('15844','2013-08-28','15:30:00',1.88),('15844','2013-08-28','15:35:00',2.07),('15844','2013-08-28','15:40:00',1.82),('15844','2013-08-28','15:45:00',1.26),('15844','2013-08-28','15:50:00',1.5),('15844','2013-08-28','15:55:00',1.31),('15844','2013-08-28','16:00:00',1.13),('15844','2013-08-28','16:10:00',1.2),('15844','2013-08-28','16:15:00',1.12),('15844','2013-08-28','16:20:00',1.12),('15844','2013-08-27','09:10:00',1.21),('15844','2013-08-27','09:15:00',1.28),('15844','2013-08-27','09:20:00',1.52),('15844','2013-08-27','09:25:00',1.84),('15844','2013-08-27','09:30:00',1.84),('15844','2013-08-27','09:35:00',1.13),('15844','2013-08-27','09:40:00',1.08),('15844','2013-08-27','09:45:00',1.09),('15844','2013-08-27','09:50:00',1.31),('15844','2013-08-27','09:55:00',1.45),('15844','2013-08-27','10:00:00',1.96),('15844','2013-08-27','10:05:00',2.3),('15844','2013-08-27','10:10:00',2.71),('15844','2013-08-27','10:15:00',2.81),('15844','2013-08-27','10:20:00',2.8),('15844','2013-08-27','10:25:00',2.89),('15844','2013-08-27','10:30:00',2.95),('15844','2013-08-27','10:35:00',3.13),('15844','2013-08-27','10:40:00',3.25),('15844','2013-08-27','10:45:00',3.23),('15844','2013-08-27','10:50:00',3.27),('15844','2013-08-27','10:55:00',3.27),('15844','2013-08-27','11:00:00',3.28),('15844','2013-08-27','11:05:00',3.58),('15844','2013-08-27','11:10:00',3.62),('15844','2013-08-27','11:15:00',3.64),('15844','2013-08-27','11:20:00',3.69),('15844','2013-08-27','11:25:00',3.78),('15844','2013-08-27','11:30:00',3.7),('15844','2013-08-27','11:35:00',3.84),('15844','2013-08-27','11:40:00',3.13),('15844','2013-08-27','11:45:00',2.31),('15844','2013-08-27','11:50:00',2.2),('15844','2013-08-27','11:55:00',2.61),('15844','2013-08-27','12:00:00',2.26),('15844','2013-08-27','12:05:00',2.81),('15844','2013-08-27','12:10:00',2.17),('15844','2013-08-27','12:15:00',4.13),('15844','2013-08-27','12:20:00',4),('15844','2013-08-27','12:25:00',3.98),('15844','2013-08-27','12:30:00',3.82),('15844','2013-08-27','12:35:00',4.17),('15844','2013-08-27','12:40:00',3.89),('15844','2013-08-27','12:45:00',2.39),('15844','2013-08-27','12:50:00',2.17),('15844','2013-08-27','12:55:00',1.4),('15844','2013-08-27','13:00:00',1.09),('15844','2013-08-27','13:05:00',1.23),('15844','2013-08-27','13:10:00',1.15),('15844','2013-08-27','13:15:00',1.4),('15844','2013-08-27','13:20:00',1.59),('15844','2013-08-27','13:25:00',1.76),('15844','2013-08-27','13:30:00',1.54),('15844','2013-08-27','13:35:00',1.56),('15844','2013-08-27','13:40:00',1.87),('15844','2013-08-27','13:45:00',2.78),('15844','2013-08-27','13:50:00',2),('15844','2013-08-27','13:55:00',2.94),('15844','2013-08-27','14:00:00',2.56),('15844','2013-08-27','14:05:00',1.87),('15844','2013-08-27','14:10:00',2.28),('15844','2013-08-27','14:15:00',2.33),('15844','2013-08-27','14:20:00',1.81),('15844','2013-08-27','14:25:00',1.27),('15844','2013-08-27','14:30:00',1.13),('15844','2013-08-27','14:35:00',1.2),('15844','2013-08-27','14:40:00',1.3),('15844','2013-08-27','14:45:00',1.13),('15844','2013-08-27','15:55:00',1.07),('15844','2013-08-27','16:00:00',1.7),('15844','2013-08-27','16:05:00',1.75),('15844','2013-08-27','16:10:00',1.65),('15844','2013-08-27','16:15:00',1.51),('15844','2013-08-27','16:30:00',1.05),('15844','2013-08-27','16:45:00',1.08),('15844','2013-08-27','16:50:00',1.07),('15844','2013-08-27','17:05:00',1.22),('15844','2013-08-26','08:40:00',1.04),('15844','2013-08-26','08:45:00',1.18),('15844','2013-08-26','08:50:00',1.29),('15844','2013-08-26','08:55:00',1.37),('15844','2013-08-26','09:00:00',1.45),('15844','2013-08-26','09:05:00',1.57),('15844','2013-08-26','09:10:00',1.67),('15844','2013-08-26','09:15:00',1.75),('15844','2013-08-26','09:20:00',1.86),('15844','2013-08-26','09:25:00',1.99),('15844','2013-08-26','09:30:00',2.08),('15844','2013-08-26','09:35:00',2.17),('15844','2013-08-26','09:40:00',2.26),('15844','2013-08-26','09:45:00',2.3),('15844','2013-08-26','09:50:00',2.38),('15844','2013-08-26','09:55:00',2.45),('15844','2013-08-26','10:00:00',2.57),('15844','2013-08-26','10:05:00',2.69),('15844','2013-08-26','10:10:00',2.79),('15844','2013-08-26','10:15:00',2.84),('15844','2013-08-26','10:20:00',2.88),('15844','2013-08-26','10:25:00',2.99),('15844','2013-08-26','10:30:00',3.01),('15844','2013-08-26','10:35:00',3.27),('15844','2013-08-26','10:40:00',3.32),('15844','2013-08-26','10:45:00',3.38),('15844','2013-08-26','10:50:00',3.46),('15844','2013-08-26','10:55:00',3.51),('15844','2013-08-26','11:00:00',3.64),('15844','2013-08-26','11:05:00',3.72),('15844','2013-08-26','11:10:00',3.78),('15844','2013-08-26','11:15:00',3.83),('15844','2013-08-26','11:20:00',3.78),('15844','2013-08-26','11:25:00',3.82),('15844','2013-08-26','11:30:00',3.84),('15844','2013-08-26','11:35:00',3.88),('15844','2013-08-26','11:40:00',3.91),('15844','2013-08-26','11:45:00',3.93),('15844','2013-08-26','11:50:00',3.92),('15844','2013-08-26','11:55:00',3.91),('15844','2013-08-26','12:00:00',3.95),('15844','2013-08-26','12:05:00',3.92),('15844','2013-08-26','12:10:00',3.93),('15844','2013-08-26','12:15:00',3.89),('15844','2013-08-26','12:20:00',3.88),('15844','2013-08-26','12:25:00',3.86),('15844','2013-08-26','12:30:00',3.84),('15844','2013-08-26','12:35:00',3.79),('15844','2013-08-26','12:40:00',3.64),('15844','2013-08-26','12:45:00',3.98),('15844','2013-08-26','12:50:00',3.93),('15844','2013-08-26','12:55:00',3.67),('15844','2013-08-26','13:00:00',2.65),('15844','2013-08-26','13:05:00',2.52),('15844','2013-08-26','13:10:00',2.17),('15844','2013-08-26','13:15:00',2.11),('15844','2013-08-26','13:20:00',1.79),('15844','2013-08-26','13:25:00',2.41),('15844','2013-08-26','13:30:00',2.93),('15844','2013-08-26','13:35:00',3.18),('15844','2013-08-26','13:40:00',3.55),('15844','2013-08-26','13:45:00',3.52),('15844','2013-08-26','13:50:00',2.96),('15844','2013-08-26','13:55:00',2.33),('15844','2013-08-26','14:00:00',2.78),('15844','2013-08-26','14:05:00',2.82),('15844','2013-08-26','14:10:00',2.97),('15844','2013-08-26','14:15:00',3.28),('15844','2013-08-26','14:20:00',3.04),('15844','2013-08-26','14:25:00',2.92),('15844','2013-08-26','14:30:00',2.87),('15844','2013-08-26','14:35:00',2.76),('15844','2013-08-26','14:40:00',2.47),('15844','2013-08-26','14:45:00',1.68),('15844','2013-08-26','14:50:00',1.19),('15844','2013-08-26','14:55:00',1.19),('15844','2013-08-26','15:00:00',1.4),('15844','2013-08-26','15:40:00',1.31),('15844','2013-08-26','15:45:00',1.2),('15844','2013-08-26','15:50:00',1.32),('15844','2013-08-26','15:55:00',1.32),('15844','2013-08-26','16:00:00',1.94),('15844','2013-08-26','16:05:00',1.53),('15844','2013-08-26','16:10:00',1.13),('15844','2013-08-26','16:15:00',1.1),('15844','2013-08-26','16:20:00',1.01),('15844','2013-08-25','08:50:00',1.23),('15844','2013-08-25','08:55:00',1.35),('15844','2013-08-25','09:00:00',1.07),('15844','2013-08-25','09:05:00',1.61),('15844','2013-08-25','09:10:00',1.63),('15844','2013-08-25','09:15:00',1.66),('15844','2013-08-25','09:20:00',1.83),('15844','2013-08-25','09:25:00',1.97),('15844','2013-08-25','09:30:00',2.1),('15844','2013-08-25','09:35:00',2.17),('15844','2013-08-25','09:40:00',2.45),('15844','2013-08-25','09:45:00',2.51),('15844','2013-08-25','09:50:00',2.76),('15844','2013-08-25','09:55:00',1.97),('15844','2013-08-25','10:00:00',1.29),('15844','2013-08-25','15:15:00',1.12),('15844','2013-08-25','15:20:00',1.33),('15844','2013-08-25','15:25:00',1.4),('15844','2013-08-25','15:30:00',2.35),('15844','2013-08-25','15:35:00',2.16),('15844','2013-08-25','15:40:00',1.33),('15844','2013-08-25','15:45:00',1.67),('15844','2013-08-25','15:55:00',1.29),('15844','2013-08-25','16:00:00',1.51),('15844','2013-08-25','16:05:00',1.16),('15844','2013-08-25','16:10:00',1.24),('15844','2013-08-25','16:15:00',1.18),('15844','2013-08-25','16:20:00',1.12),('15844','2013-08-25','16:25:00',1.05),('15844','2013-08-24','08:50:00',1.2),('15844','2013-08-24','08:55:00',1.32),('15844','2013-08-24','09:00:00',1.4),('15844','2013-08-24','09:05:00',1.52),('15844','2013-08-24','09:10:00',1.57),('15844','2013-08-24','09:15:00',1.67),('15844','2013-08-24','09:20:00',1.72),('15844','2013-08-24','09:25:00',1.85),('15844','2013-08-24','09:30:00',1.94),('15844','2013-08-24','09:35:00',2.05),('15844','2013-08-24','09:40:00',2.04),('15844','2013-08-24','09:45:00',2.15),('15844','2013-08-24','09:50:00',2.21),('15844','2013-08-24','09:55:00',2.27),('15844','2013-08-24','10:00:00',2.41),('15844','2013-08-24','10:05:00',2.55),('15844','2013-08-24','10:10:00',2.65),('15844','2013-08-24','10:15:00',2.75),('15844','2013-08-24','10:20:00',2.83),('15844','2013-08-24','10:25:00',2.88),('15844','2013-08-24','10:30:00',2.95),('15844','2013-08-24','10:35:00',3.1),('15844','2013-08-24','10:40:00',3.19),('15844','2013-08-24','10:45:00',3.32),('15844','2013-08-24','10:50:00',3.35),('15844','2013-08-24','10:55:00',3.5),('15844','2013-08-24','11:00:00',3.56),('15844','2013-08-24','11:05:00',3.6),('15844','2013-08-24','11:10:00',3.65),('15844','2013-08-24','11:15:00',3.74),('15844','2013-08-24','11:20:00',3.78),('15844','2013-08-24','11:25:00',3.75),('15844','2013-08-24','11:30:00',3.82),('15844','2013-08-24','11:35:00',3.83),('15844','2013-08-24','11:40:00',3.83),('15844','2013-08-24','11:45:00',3.87),('15844','2013-08-24','11:50:00',3.83),('15844','2013-08-24','11:55:00',3.8),('15844','2013-08-24','12:00:00',3.89),('15844','2013-08-24','12:05:00',3.91),('15844','2013-08-24','12:10:00',3.87),('15844','2013-08-24','12:15:00',3.87),('15844','2013-08-24','12:20:00',3.82),('15844','2013-08-24','12:25:00',3.85),('15844','2013-08-24','12:30:00',3.79),('15844','2013-08-24','12:35:00',3.86),('15844','2013-08-24','12:40:00',3.82),('15844','2013-08-24','12:45:00',3.8),('15844','2013-08-24','12:50:00',3.82),('15844','2013-08-24','12:55:00',3.78),('15844','2013-08-24','13:00:00',3.77),('15844','2013-08-24','13:05:00',3.75),('15844','2013-08-24','13:10:00',3.7),('15844','2013-08-24','13:15:00',3.7),('15844','2013-08-24','13:20:00',3.65),('15844','2013-08-24','13:25:00',3.62),('15844','2013-08-24','13:30:00',3.59),('15844','2013-08-24','13:35:00',3.56),('15844','2013-08-24','13:40:00',3.52),('15844','2013-08-24','13:45:00',3.49),('15844','2013-08-24','13:50:00',3.44),('15844','2013-08-24','13:55:00',3.37),('15844','2013-08-24','14:00:00',3.29),('15844','2013-08-24','14:05:00',3.23),('15844','2013-08-24','14:10:00',3.17),('15844','2013-08-24','14:15:00',3.08),('15844','2013-08-24','14:20:00',3.01),('15844','2013-08-24','14:25:00',2.94),('15844','2013-08-24','14:30:00',2.85),('15844','2013-08-24','14:35:00',2.74),('15844','2013-08-24','14:40:00',2.61),('15844','2013-08-24','14:45:00',2.49),('15844','2013-08-24','14:50:00',2.4),('15844','2013-08-24','14:55:00',2.42),('15844','2013-08-24','15:00:00',2.34),('15844','2013-08-24','15:05:00',2.26),('15844','2013-08-24','15:10:00',2.19),('15844','2013-08-24','15:15:00',2.11),('15844','2013-08-24','15:20:00',2.01),('15844','2013-08-24','15:25:00',1.93),('15844','2013-08-24','15:30:00',1.85),('15844','2013-08-24','15:35:00',1.75),('15844','2013-08-24','15:40:00',1.66),('15844','2013-08-24','15:45:00',1.56),('15844','2013-08-24','15:50:00',1.44),('15844','2013-08-24','15:55:00',1.32),('15844','2013-08-24','16:00:00',1.21),('15844','2013-08-24','16:05:00',1.14),('15844','2013-08-24','16:10:00',1.1),('15844','2013-08-24','16:15:00',1.07),('15844','2013-08-24','16:20:00',1.03),('15844','2013-08-23','08:50:00',1.1),('15844','2013-08-23','08:55:00',1.02),('15844','2013-08-23','09:00:00',1.16),('15844','2013-08-23','09:05:00',1.38),('15844','2013-08-23','09:10:00',1.45),('15844','2013-08-23','09:15:00',1.52),('15844','2013-08-23','09:20:00',1.59),('15844','2013-08-23','09:25:00',1.63),('15844','2013-08-23','09:30:00',1.72),('15844','2013-08-23','09:35:00',1.8),('15844','2013-08-23','09:40:00',1.85),('15844','2013-08-23','09:45:00',1.92),('15844','2013-08-23','09:50:00',1.99),('15844','2013-08-23','09:55:00',2.07),('15844','2013-08-23','10:00:00',2.19),('15844','2013-08-23','10:05:00',2.3),('15844','2013-08-23','10:10:00',2.37),('15844','2013-08-23','10:15:00',2.45),('15844','2013-08-23','10:20:00',2.57),('15844','2013-08-23','10:25:00',2.65),('15844','2013-08-23','10:30:00',2.74),('15844','2013-08-23','10:35:00',2.89),('15844','2013-08-23','10:40:00',2.96),('15844','2013-08-23','10:45:00',2.86),('15844','2013-08-23','10:50:00',2.19),('15844','2013-08-23','10:55:00',1.35),('15844','2013-08-23','11:00:00',3.13),('15844','2013-08-23','11:05:00',3.42),('15844','2013-08-23','11:10:00',3.51),('15844','2013-08-23','11:15:00',3.57),('15844','2013-08-23','11:20:00',3.68),('15844','2013-08-23','11:25:00',2.77),('15844','2013-08-23','11:30:00',2.72),('15844','2013-08-23','11:35:00',1.23),('15844','2013-08-23','11:40:00',1.79),('15844','2013-08-23','11:45:00',1.78),('15844','2013-08-23','11:50:00',3.04),('15844','2013-08-23','11:55:00',2.48),('15844','2013-08-23','12:00:00',3.99),('15844','2013-08-23','12:05:00',3.91),('15844','2013-08-23','12:10:00',2.71),('15844','2013-08-23','12:15:00',2.19),('15844','2013-08-23','12:20:00',1.75),('15844','2013-08-23','12:30:00',1.12),('15844','2013-08-23','12:35:00',2.4),('15844','2013-08-23','12:40:00',3.62),('15844','2013-08-23','12:45:00',3.89),('15844','2013-08-23','12:50:00',3.88),('15844','2013-08-23','12:55:00',3.88),('15844','2013-08-23','13:00:00',3.71),('15844','2013-08-23','13:05:00',3.77),('15844','2013-08-23','13:10:00',3.72),('15844','2013-08-23','13:15:00',3.69),('15844','2013-08-23','13:20:00',3.69),('15844','2013-08-23','13:25:00',3.63),('15844','2013-08-23','13:30:00',3.66),('15844','2013-08-23','13:35:00',3.59),('15844','2013-08-23','13:40:00',3.55),('15844','2013-08-23','13:45:00',3.51),('15844','2013-08-23','13:50:00',3.46),('15844','2013-08-23','13:55:00',3.36),('15844','2013-08-23','14:00:00',3.29),('15844','2013-08-23','14:05:00',3.22),('15844','2013-08-23','14:10:00',3.16),('15844','2013-08-23','14:15:00',3.09),('15844','2013-08-23','14:20:00',3.02),('15844','2013-08-23','14:25:00',2.95),('15844','2013-08-23','14:30:00',2.84),('15844','2013-08-23','14:35:00',2.76),('15844','2013-08-23','14:40:00',2.65),('15844','2013-08-23','14:45:00',2.54),('15844','2013-08-23','14:50:00',2.4),('15844','2013-08-23','14:55:00',2.27),('15844','2013-08-23','15:00:00',2.16),('15844','2013-08-23','15:05:00',2.22),('15844','2013-08-23','15:10:00',2.13),('15844','2013-08-23','15:15:00',2.02),('15844','2013-08-23','15:20:00',2.01),('15844','2013-08-23','15:25:00',2.04),('15844','2013-08-23','15:30:00',1.84),('15844','2013-08-23','15:35:00',1.72),('15844','2013-08-23','15:40:00',1.67),('15844','2013-08-23','15:45:00',1.51),('15844','2013-08-23','15:50:00',1.47),('15844','2013-08-23','15:55:00',1.36),('15844','2013-08-23','16:00:00',1.18),('15844','2013-08-23','16:05:00',1.01),('15844','2013-08-23','16:10:00',1.08),('15844','2013-08-23','16:15:00',1.21),('15844','2013-08-23','16:20:00',1.11),('15844','2013-08-23','16:25:00',1.02),('15844','2013-08-23','16:30:00',1),('15844','2013-08-22','08:45:00',1.06),('15844','2013-08-22','08:50:00',1.2),('15844','2013-08-22','08:55:00',1.3),('15844','2013-08-22','09:00:00',1.42),('15844','2013-08-22','09:05:00',1.54),('15844','2013-08-22','09:10:00',1.43),('15844','2013-08-22','09:15:00',1.67),('15844','2013-08-22','09:20:00',1.84),('15844','2013-08-22','09:25:00',1.99),('15844','2013-08-22','09:30:00',1.68),('15844','2013-08-22','09:35:00',1.98),('15844','2013-08-22','09:40:00',2.17),('15844','2013-08-22','09:45:00',2.18),('15844','2013-08-22','09:50:00',2.25),('15844','2013-08-22','09:55:00',2.36),('15844','2013-08-22','10:00:00',2.6),('15844','2013-08-22','10:05:00',2.74),('15844','2013-08-22','10:10:00',2.75),('15844','2013-08-22','10:15:00',2.81),('15844','2013-08-22','10:20:00',2.84),('15844','2013-08-22','10:25:00',2.95),('15844','2013-08-22','10:30:00',3.03),('15844','2013-08-22','10:35:00',3.1),('15844','2013-08-22','10:40:00',3.17),('15844','2013-08-22','10:45:00',3.21),('15844','2013-08-22','10:50:00',3.25),('15844','2013-08-22','10:55:00',3.42),('15844','2013-08-22','11:00:00',3.48),('15844','2013-08-22','11:05:00',3.5),('15844','2013-08-22','11:10:00',3.57),('15844','2013-08-22','11:15:00',3.6),('15844','2013-08-22','11:20:00',3.65),('15844','2013-08-22','11:25:00',3.64),('15844','2013-08-22','11:30:00',3.68),('15844','2013-08-22','11:35:00',3.7),('15844','2013-08-22','11:40:00',3.71),('15844','2013-08-22','11:45:00',3.72),('15844','2013-08-22','11:50:00',3.7),('15844','2013-08-22','11:55:00',3.72),('15844','2013-08-22','12:00:00',3.74),('15844','2013-08-22','12:05:00',3.75),('15844','2013-08-22','12:10:00',3.73),('15844','2013-08-22','12:15:00',3.72),('15844','2013-08-22','12:20:00',3.72),('15844','2013-08-22','12:25:00',3.72),('15844','2013-08-22','12:30:00',3.7),('15844','2013-08-22','12:35:00',3.7),('15844','2013-08-22','12:40:00',3.68),('15844','2013-08-22','12:45:00',3.67),('15844','2013-08-22','12:50:00',3.64),('15844','2013-08-22','12:55:00',3.62),('15844','2013-08-22','13:00:00',3.62),('15844','2013-08-22','13:05:00',3.59),('15844','2013-08-22','13:10:00',3.56),('15844','2013-08-22','13:15:00',3.55),('15844','2013-08-22','13:20:00',3.51),('15844','2013-08-22','13:25:00',3.49),('15844','2013-08-22','13:30:00',3.47),('15844','2013-08-22','13:35:00',3.46),('15844','2013-08-22','13:40:00',3.44),('15844','2013-08-22','13:45:00',3.36),('15844','2013-08-22','13:50:00',3.31),('15844','2013-08-22','13:55:00',3.25),('15844','2013-08-22','14:00:00',3.18),('15844','2013-08-22','14:05:00',3.05),('15844','2013-08-22','14:10:00',3.08),('15844','2013-08-22','14:15:00',3.01),('15844','2013-08-22','14:20:00',2.78),('15844','2013-08-22','14:25:00',2.87),('15844','2013-08-22','14:30:00',2.31),('15844','2013-08-22','14:35:00',2.69),('15844','2013-08-22','14:40:00',2.35),('15844','2013-08-22','14:45:00',2.07),('15844','2013-08-22','14:50:00',2.53),('15844','2013-08-22','14:55:00',2.42),('15844','2013-08-22','15:00:00',2.33),('15844','2013-08-22','15:05:00',2.24),('15844','2013-08-22','15:10:00',2.14),('15844','2013-08-22','15:15:00',2.06),('15844','2013-08-22','15:20:00',1.97),('15844','2013-08-22','15:25:00',1.88),('15844','2013-08-22','15:30:00',1.83),('15844','2013-08-22','15:35:00',1.76),('15844','2013-08-22','15:40:00',1.68),('15844','2013-08-22','15:45:00',1.59),('15844','2013-08-22','15:50:00',1.49),('15844','2013-08-22','15:55:00',1.4),('15844','2013-08-22','16:00:00',1.32),('15844','2013-08-22','16:05:00',1.27),('15844','2013-08-22','16:10:00',1.21),('15844','2013-08-22','16:15:00',1.14),('15844','2013-08-22','16:20:00',1.12),('15844','2013-08-22','16:25:00',1.07),('15844','2013-08-21','09:10:00',1.38),('15844','2013-08-21','09:15:00',1.27),('15844','2013-08-21','09:20:00',1.65),('15844','2013-08-21','09:25:00',1.49),('15844','2013-08-21','09:50:00',1.04),('15844','2013-08-21','09:55:00',1.14),('15844','2013-08-21','10:00:00',1.3),('15844','2013-08-21','10:05:00',2.53),('15844','2013-08-21','10:10:00',2.57),('15844','2013-08-21','10:15:00',1.92),('15844','2013-08-21','10:20:00',2.69),('15844','2013-08-21','10:25:00',3.13),('15844','2013-08-21','10:30:00',3.13),('15844','2013-08-21','10:35:00',3.22),('15844','2013-08-21','10:40:00',3.22),('15844','2013-08-21','10:45:00',3.31),('15844','2013-08-21','10:50:00',3.4),('15844','2013-08-21','10:55:00',3.15),('15844','2013-08-21','11:00:00',3.57),('15844','2013-08-21','11:05:00',3.24),('15844','2013-08-21','11:10:00',1.55),('15844','2013-08-21','11:15:00',2.57),('15844','2013-08-21','11:20:00',2.16),('15844','2013-08-21','11:25:00',2.79),('15844','2013-08-21','11:30:00',2.57),('15844','2013-08-21','11:35:00',3.56),('15844','2013-08-21','11:40:00',3.99),('15844','2013-08-21','11:45:00',3.88),('15844','2013-08-21','11:50:00',4.05),('15844','2013-08-21','11:55:00',3.9),('15844','2013-08-21','12:00:00',3.97),('15844','2013-08-21','12:05:00',3.96),('15844','2013-08-21','12:10:00',3.91),('15844','2013-08-21','12:15:00',3.95),('15844','2013-08-21','12:20:00',3.91),('15844','2013-08-21','12:25:00',3.62),('15844','2013-08-21','12:30:00',3.15),('15844','2013-08-21','12:35:00',3.02),('15844','2013-08-21','12:40:00',1.82),('15844','2013-08-21','12:45:00',2.85),('15844','2013-08-21','12:50:00',3.6),('15844','2013-08-21','12:55:00',3.49),('15844','2013-08-21','13:00:00',3.48),('15844','2013-08-21','13:05:00',3.56),('15844','2013-08-21','13:10:00',3.58),('15844','2013-08-21','13:15:00',3.54),('15844','2013-08-21','13:20:00',3.51),('15844','2013-08-21','13:25:00',3.48),('15844','2013-08-21','13:30:00',3.52),('15844','2013-08-21','13:35:00',3.44),('15844','2013-08-21','13:40:00',3.33),('15844','2013-08-21','13:45:00',3.37),('15844','2013-08-21','13:50:00',3.33),('15844','2013-08-21','13:55:00',3.31),('15844','2013-08-21','14:00:00',3.28),('15844','2013-08-21','14:05:00',3.19),('15844','2013-08-21','14:10:00',2.99),('15844','2013-08-21','14:15:00',2.97),('15844','2013-08-21','14:20:00',2.87),('15844','2013-08-21','14:25:00',2.89),('15844','2013-08-21','14:30:00',2.86),('15844','2013-08-21','14:35:00',2.61),('15844','2013-08-21','14:40:00',2.46),('15844','2013-08-21','14:45:00',2.32),('15844','2013-08-21','14:50:00',2.36),('15844','2013-08-21','14:55:00',2.33),('15844','2013-08-21','15:00:00',2.26),('15844','2013-08-21','15:05:00',2.12),('15844','2013-08-21','15:10:00',2.03),('15844','2013-08-21','15:15:00',2.03),('15844','2013-08-21','15:20:00',1.86),('15844','2013-08-21','15:25:00',1.72),('15844','2013-08-21','15:30:00',1.58),('15844','2013-08-21','15:35:00',1.64),('15844','2013-08-21','15:40:00',1.62),('15844','2013-08-21','15:45:00',1.57),('15844','2013-08-21','15:50:00',1.46),('15844','2013-08-21','15:55:00',1.33),('15844','2013-08-21','16:00:00',1.28),('15844','2013-08-21','16:05:00',1.26),('15844','2013-08-21','16:10:00',1.25),('15844','2013-08-21','16:15:00',1.21),('15844','2013-08-21','16:20:00',1.22),('15844','2013-08-21','16:25:00',1.23),('15844','2013-08-21','16:30:00',1.16),('15844','2013-08-21','16:35:00',1.1),('15844','2013-08-21','16:40:00',1),('15844','2013-08-20','08:55:00',1.01),('15844','2013-08-20','09:20:00',1.33),('15844','2013-08-20','09:25:00',1.64),('15844','2013-08-20','09:30:00',2.09),('15844','2013-08-20','09:35:00',1.6),('15844','2013-08-20','09:40:00',1.03),('15844','2013-08-20','09:55:00',1.29),('15844','2013-08-20','10:00:00',2.22),('15844','2013-08-20','10:05:00',1.98),('15844','2013-08-20','10:10:00',1.24),('15844','2013-08-20','10:20:00',1.51),('15844','2013-08-20','10:25:00',2.43),('15844','2013-08-20','10:30:00',2),('15844','2013-08-20','10:35:00',3.55),('15844','2013-08-20','10:40:00',1.53),('15844','2013-08-20','10:55:00',1.45),('15844','2013-08-20','11:00:00',2.06),('15844','2013-08-20','11:05:00',3.18),('15844','2013-08-20','11:10:00',2.62),('15844','2013-08-20','11:15:00',1.07),('15844','2013-08-20','11:20:00',3.6),('15844','2013-08-20','11:25:00',4.47),('15844','2013-08-20','11:30:00',4.34),('15844','2013-08-20','11:35:00',4.56),('15844','2013-08-20','11:40:00',3.65),('15844','2013-08-20','11:45:00',3.22),('15844','2013-08-20','11:50:00',3.31),('15844','2013-08-20','11:55:00',4.18),('15844','2013-08-20','12:00:00',2.48),('15844','2013-08-20','12:05:00',1.99),('15844','2013-08-20','12:10:00',1.96),('15844','2013-08-20','12:15:00',1.49),('15844','2013-08-20','12:20:00',1.51),('15844','2013-08-20','12:25:00',1.59),('15844','2013-08-20','12:30:00',1.56),('15844','2013-08-20','12:35:00',1.78),('15844','2013-08-20','12:40:00',1.62),('15844','2013-08-20','12:45:00',1.85),('15844','2013-08-20','12:50:00',2.94),('15844','2013-08-20','12:55:00',1.95),('15844','2013-08-20','13:00:00',1.68),('15844','2013-08-20','13:05:00',1.46),('15844','2013-08-20','13:10:00',1.49),('15844','2013-08-20','13:15:00',1.6),('15844','2013-08-20','13:20:00',1.57),('15844','2013-08-20','13:25:00',1.64),('15844','2013-08-20','13:30:00',1.83),('15844','2013-08-20','13:35:00',1.93),('15844','2013-08-20','13:40:00',2.73),('15844','2013-08-20','13:45:00',3.4),('15844','2013-08-20','13:50:00',3.82),('15844','2013-08-20','13:55:00',3.64),('15844','2013-08-20','14:00:00',3.51),('15844','2013-08-20','14:05:00',3.42),('15844','2013-08-20','14:10:00',3.44),('15844','2013-08-20','14:15:00',3.39),('15844','2013-08-20','14:20:00',3.46),('15844','2013-08-20','14:25:00',3.58),('15844','2013-08-20','14:30:00',3.46),('15844','2013-08-20','14:35:00',3.26),('15844','2013-08-20','14:40:00',2.98),('15844','2013-08-20','14:45:00',2.99),('15844','2013-08-20','14:50:00',2.78),('15844','2013-08-20','14:55:00',2.21),('15844','2013-08-20','15:00:00',2.49),('15844','2013-08-20','15:05:00',2.43),('15844','2013-08-20','15:10:00',2.44),('15844','2013-08-20','15:15:00',2.37),('15844','2013-08-20','15:20:00',2.31),('15844','2013-08-20','15:25:00',2.2),('15844','2013-08-20','15:30:00',2.01),('15844','2013-08-20','15:35:00',2.03),('15844','2013-08-20','15:40:00',1.65),('15844','2013-08-20','15:45:00',1.72),('15844','2013-08-20','15:50:00',1.93),('15844','2013-08-20','15:55:00',1.86),('15844','2013-08-20','16:00:00',1.86),('15844','2013-08-20','16:05:00',1.83),('15844','2013-08-20','16:10:00',1.77),('15844','2013-08-20','16:15:00',1.74),('15844','2013-08-20','16:20:00',1.7),('15844','2013-08-20','16:25:00',1.63),('15844','2013-08-20','16:30:00',1.49),('15844','2013-08-20','16:35:00',1.24),('15844','2013-08-20','16:40:00',1.02),('15844','2014-04-10','08:40:00',1.08),('15844','2014-04-10','08:45:00',1.21),('15844','2014-04-10','08:50:00',1.36),('15844','2014-04-10','08:55:00',1.39),('15844','2014-04-10','09:00:00',1.49),('15844','2014-04-10','09:05:00',1.65),('15844','2014-04-10','09:10:00',1.76),('15844','2014-04-10','09:15:00',1.92),('15844','2014-04-10','09:20:00',2.03),('15844','2014-04-10','09:25:00',2.21),('15844','2014-04-10','09:30:00',2.33),('15844','2014-04-10','09:35:00',2.4),('15844','2014-04-10','09:40:00',2.47),('15844','2014-04-10','09:45:00',2.55),('15844','2014-04-10','09:50:00',2.61),('15844','2014-04-10','09:55:00',2.66),('15844','2014-04-10','10:00:00',2.74),('15844','2014-04-10','10:05:00',2.87),('15844','2014-04-10','10:10:00',2.99),('15844','2014-04-10','10:15:00',2.98),('15844','2014-04-10','10:20:00',3.05),('15844','2014-04-10','10:25:00',3.09),('15844','2014-04-10','10:30:00',3.15),('15844','2014-04-10','10:35:00',3.37),('15844','2014-04-10','10:40:00',3.49),('15844','2014-04-10','10:45:00',3.48),('15844','2014-04-10','10:50:00',3.53),('15844','2014-04-10','10:55:00',3.67),('15844','2014-04-10','11:00:00',3.77),('15844','2014-04-10','11:05:00',3.85),('15844','2014-04-10','11:10:00',3.85),('15844','2014-04-10','11:15:00',3.88),('15844','2014-04-10','11:20:00',4.08),('15844','2014-04-10','11:25:00',4.1),('15844','2014-04-10','11:30:00',4.11),('15844','2014-04-10','11:35:00',4),('15844','2014-04-10','11:40:00',3.99),('15844','2014-04-10','11:45:00',4.04),('15844','2014-04-10','11:50:00',3.98),('15844','2014-04-10','11:55:00',4.02),('15844','2014-04-10','12:00:00',3.84),('15844','2014-04-10','12:05:00',3.64),('15844','2014-04-10','12:10:00',3.95),('15844','2014-04-10','12:15:00',3.96),('15844','2014-04-10','12:20:00',3.89),('15844','2014-04-10','12:25:00',3.83),('15844','2014-04-10','12:30:00',3.7),('15844','2014-04-10','12:35:00',3.96),('15844','2014-04-10','12:40:00',3.67),('15844','2014-04-10','12:45:00',3.74),('15844','2014-04-10','12:50:00',3.86),('15844','2014-04-10','12:55:00',3.93),('15844','2014-04-10','13:00:00',3.6),('15844','2014-04-10','13:05:00',3.76),('15844','2014-04-10','13:10:00',3.8),('15844','2014-04-10','13:15:00',3.86),('15844','2014-04-10','13:20:00',3.53),('15844','2014-04-10','13:25:00',3.69),('15844','2014-04-10','13:30:00',3.75),('15844','2014-04-10','13:35:00',3.72),('15844','2014-04-10','13:40:00',3.52),('15844','2014-04-10','13:45:00',3.63),('15844','2014-04-10','13:50:00',3.56),('15844','2014-04-10','13:55:00',3.47),('15844','2014-04-10','14:00:00',3.4),('15844','2014-04-10','14:05:00',3.29),('15844','2014-04-10','14:10:00',3.12),('15844','2014-04-10','14:15:00',3.24),('15844','2014-04-10','14:20:00',3.14),('15844','2014-04-10','14:25:00',3.02),('15844','2014-04-10','14:30:00',2.89),('15844','2014-04-10','14:35:00',2.77),('15844','2014-04-10','14:40:00',2.7),('15844','2014-04-10','14:45:00',2.32),('15844','2014-04-10','14:50:00',2.54),('15844','2014-04-10','14:55:00',2.45),('15844','2014-04-10','15:00:00',2.36),('15844','2014-04-10','15:05:00',2.29),('15844','2014-04-10','15:10:00',2.16),('15844','2014-04-10','15:15:00',2.03),('15844','2014-04-10','15:20:00',1.89),('15844','2014-04-10','15:25:00',1.74),('15844','2014-04-10','15:30:00',1.66),('15844','2014-04-10','15:35:00',1.54),('15844','2014-04-10','15:40:00',1.53),('15844','2014-04-10','15:45:00',1.44),('15844','2014-04-10','15:50:00',1.3),('15844','2014-04-10','15:55:00',1.31),('15844','2014-04-10','16:00:00',1.31),('15844','2014-04-10','16:05:00',1.24),('15844','2014-04-10','16:10:00',1.23),('15844','2014-04-10','16:15:00',1.18),('15844','2014-04-10','16:20:00',1.11),('15844','2013-08-19','08:45:00',1.09),('15844','2013-08-19','08:50:00',1.21),('15844','2013-08-19','08:55:00',1.28),('15844','2013-08-19','09:00:00',1.36),('15844','2013-08-19','09:05:00',1.46),('15844','2013-08-19','09:10:00',1.54),('15844','2013-08-19','09:15:00',1.59),('15844','2013-08-19','09:20:00',1.69),('15844','2013-08-19','09:25:00',1.83),('15844','2013-08-19','09:30:00',1.94),('15844','2013-08-19','09:35:00',2.05),('15844','2013-08-19','09:40:00',2.13),('15844','2013-08-19','09:45:00',2.2),('15844','2013-08-19','09:50:00',2.21),('15844','2013-08-19','09:55:00',2.29),('15844','2013-08-19','10:00:00',2.45),('15844','2013-08-19','10:05:00',2.56),('15844','2013-08-19','10:10:00',2.66),('15844','2013-08-19','10:15:00',2.74),('15844','2013-08-19','10:20:00',2.84),('15844','2013-08-19','10:25:00',2.96),('15844','2013-08-19','10:30:00',3.04),('15844','2013-08-19','10:35:00',3.12),('15844','2013-08-19','10:40:00',3.22),('15844','2013-08-19','10:45:00',3.27),('15844','2013-08-19','10:50:00',3.3),('15844','2013-08-19','10:55:00',3.54),('15844','2013-08-19','11:00:00',3.69),('15844','2013-08-19','11:05:00',3.76),('15844','2013-08-19','11:10:00',3.79),('15844','2013-08-19','11:15:00',3.81),('15844','2013-08-19','11:20:00',3.84),('15844','2013-08-19','11:25:00',3.88),('15844','2013-08-19','11:30:00',3.92),('15844','2013-08-19','11:35:00',3.93),('15844','2013-08-19','11:40:00',3.94),('15844','2013-08-19','11:45:00',3.94),('15844','2013-08-19','11:50:00',3.97),('15844','2013-08-19','11:55:00',3.97),('15844','2013-08-19','12:00:00',3.98),('15844','2013-08-19','12:05:00',3.91),('15844','2013-08-19','12:10:00',3.94),('15844','2013-08-19','12:15:00',3.93),('15844','2013-08-19','12:20:00',3.94),('15844','2013-08-19','12:25:00',3.89),('15844','2013-08-19','12:30:00',3.92),('15844','2013-08-19','12:35:00',3.91),('15844','2013-08-19','12:40:00',3.92),('15844','2013-08-19','12:45:00',3.9),('15844','2013-08-19','12:50:00',3.89),('15844','2013-08-19','12:55:00',3.88),('15844','2013-08-19','13:00:00',3.87),('15844','2013-08-19','13:05:00',3.84),('15844','2013-08-19','13:10:00',3.84),('15844','2013-08-19','13:15:00',3.82),('15844','2013-08-19','13:20:00',3.78),('15844','2013-08-19','13:25:00',3.78),('15844','2013-08-19','13:30:00',3.77),('15844','2013-08-19','13:35:00',3.71),('15844','2013-08-19','13:40:00',3.68),('15844','2013-08-19','13:45:00',3.53),('15844','2013-08-19','13:50:00',3.56),('15844','2013-08-19','13:55:00',3.5),('15844','2013-08-19','14:00:00',3.44),('15844','2013-08-19','14:05:00',3.37),('15844','2013-08-19','14:10:00',3.29),('15844','2013-08-19','14:15:00',3.22),('15844','2013-08-19','14:20:00',3.16),('15844','2013-08-19','14:25:00',3.09),('15844','2013-08-19','14:30:00',3.02),('15844','2013-08-19','14:35:00',2.93),('15844','2013-08-19','14:40:00',2.83),('15844','2013-08-19','14:45:00',2.69),('15844','2013-08-19','14:50:00',2.57),('15844','2013-08-19','14:55:00',2.54),('15844','2013-08-19','15:00:00',2.46),('15844','2013-08-19','15:05:00',2.38),('15844','2013-08-19','15:10:00',2.3),('15844','2013-08-19','15:15:00',2.22),('15844','2013-08-19','15:20:00',2.14),('15844','2013-08-19','15:25:00',2.05),('15844','2013-08-19','15:30:00',1.95),('15844','2013-08-19','15:35:00',1.86),('15844','2013-08-19','15:40:00',1.77),('15844','2013-08-19','15:45:00',1.67),('15844','2013-08-19','15:50:00',1.56),('15844','2013-08-19','15:55:00',1.45),('15844','2013-08-19','16:00:00',1.35),('15844','2013-08-19','16:05:00',1.27),('15844','2013-08-19','16:10:00',1.21),('15844','2013-08-19','16:15:00',1.16),('15844','2013-08-19','16:20:00',1.11),('15844','2013-08-19','16:25:00',1.05),('15844','2013-08-18','08:35:00',1.03),('15844','2013-08-18','08:40:00',1.12),('15844','2013-08-18','08:45:00',1.19),('15844','2013-08-18','08:50:00',1.26),('15844','2013-08-18','08:55:00',1.33),('15844','2013-08-18','09:00:00',1.4),('15844','2013-08-18','09:05:00',1.46),('15844','2013-08-18','09:10:00',1.57),('15844','2013-08-18','09:15:00',1.64),('15844','2013-08-18','09:20:00',1.75),('15844','2013-08-18','09:25:00',1.86),('15844','2013-08-18','09:30:00',1.98),('15844','2013-08-18','09:35:00',2.06),('15844','2013-08-18','09:40:00',1.54),('15844','2013-08-18','09:45:00',1.95),('15844','2013-08-18','09:50:00',2.27),('15844','2013-08-18','09:55:00',2.11),('15844','2013-08-18','10:00:00',2.44),('15844','2013-08-18','10:05:00',2.6),('15844','2013-08-18','10:10:00',2.67),('15844','2013-08-18','10:15:00',2.77),('15844','2013-08-18','10:20:00',2.86),('15844','2013-08-18','10:25:00',2.95),('15844','2013-08-18','10:30:00',3.04),('15844','2013-08-18','10:35:00',3.12),('15844','2013-08-18','10:40:00',3.21),('15844','2013-08-18','10:45:00',3.25),('15844','2013-08-18','10:50:00',3.34),('15844','2013-08-18','10:55:00',3.49),('15844','2013-08-18','11:00:00',3.52),('15844','2013-08-18','11:05:00',3.58),('15844','2013-08-18','11:10:00',3.63),('15844','2013-08-18','11:15:00',3.67),('15844','2013-08-18','11:20:00',3.67),('15844','2013-08-18','11:25:00',3.69),('15844','2013-08-18','11:30:00',3.73),('15844','2013-08-18','11:35:00',3.73),('15844','2013-08-18','11:40:00',3.76),('15844','2013-08-18','11:45:00',3.84),('15844','2013-08-18','11:50:00',3.8),('15844','2013-08-18','11:55:00',3.29),('15844','2013-08-18','12:00:00',1.87),('15844','2013-08-18','12:05:00',3.91),('15844','2013-08-18','12:10:00',3.75),('15844','2013-08-18','12:15:00',3.91),('15844','2013-08-18','12:20:00',3.92),('15844','2013-08-18','12:25:00',3.83),('15844','2013-08-18','12:30:00',3.96),('15844','2013-08-18','12:35:00',4.02),('15844','2013-08-18','12:40:00',3.99),('15844','2013-08-18','12:45:00',3.96),('15844','2013-08-18','12:50:00',3.89),('15844','2013-08-18','12:55:00',3.85),('15844','2013-08-18','13:00:00',3.85),('15844','2013-08-18','13:05:00',3.83),('15844','2013-08-18','13:10:00',3.81),('15844','2013-08-18','13:15:00',3.76),('15844','2013-08-18','13:20:00',3.76),('15844','2013-08-18','13:25:00',3.72),('15844','2013-08-18','13:30:00',3.7),('15844','2013-08-18','13:35:00',3.67),('15844','2013-08-18','13:40:00',3.63),('15844','2013-08-18','13:45:00',3.6),('15844','2013-08-18','13:50:00',3.58),('15844','2013-08-18','13:55:00',3.53),('15844','2013-08-18','14:00:00',3.47),('15844','2013-08-18','14:05:00',3.4),('15844','2013-08-18','14:10:00',3.32),('15844','2013-08-18','14:15:00',3.19),('15844','2013-08-18','14:20:00',3.21),('15844','2013-08-18','14:25:00',3.14),('15844','2013-08-18','14:30:00',3.05),('15844','2013-08-18','14:35:00',2.94),('15844','2013-08-18','14:40:00',2.85),('15844','2013-08-18','14:45:00',2.75),('15844','2013-08-18','14:50:00',2.65),('15844','2013-08-18','14:55:00',2.57),('15844','2013-08-18','15:00:00',2.48),('15844','2013-08-18','15:05:00',2.38),('15844','2013-08-18','15:10:00',2.33),('15844','2013-08-18','15:15:00',2.25),('15844','2013-08-18','15:20:00',2.18),('15844','2013-08-18','15:25:00',2.07),('15844','2013-08-18','15:30:00',1.98),('15844','2013-08-18','15:35:00',1.88),('15844','2013-08-18','15:40:00',1.77),('15844','2013-08-18','15:45:00',1.69),('15844','2013-08-18','15:50:00',1.59),('15844','2013-08-18','15:55:00',1.48),('15844','2013-08-18','16:00:00',1.37),('15844','2013-08-18','16:05:00',1.3),('15844','2013-08-18','16:10:00',1.22),('15844','2013-08-18','16:15:00',1.17),('15844','2013-08-18','16:20:00',1.12),('15844','2013-08-18','16:25:00',1.06),('15844','2013-08-17','08:35:00',1.01),('15844','2013-08-17','08:40:00',1.12),('15844','2013-08-17','08:45:00',1.19),('15844','2013-08-17','08:50:00',1.24),('15844','2013-08-17','08:55:00',1.33),('15844','2013-08-17','09:00:00',1.42),('15844','2013-08-17','09:05:00',1.48),('15844','2013-08-17','09:10:00',1.58),('15844','2013-08-17','09:15:00',1.67),('15844','2013-08-17','09:20:00',1.78),('15844','2013-08-17','09:25:00',1.88),('15844','2013-08-17','09:30:00',2.01),('15844','2013-08-17','09:35:00',2.11),('15844','2013-08-17','09:40:00',2.2),('15844','2013-08-17','09:45:00',2.24),('15844','2013-08-17','09:50:00',2.3),('15844','2013-08-17','09:55:00',2.36),('15844','2013-08-17','10:00:00',2.56),('15844','2013-08-17','10:05:00',2.68),('15844','2013-08-17','10:10:00',2.78),('15844','2013-08-17','10:15:00',2.87),('15844','2013-08-17','10:20:00',2.96),('15844','2013-08-17','10:25:00',3.06),('15844','2013-08-17','10:30:00',3.17),('15844','2013-08-17','10:35:00',3.26),('15844','2013-08-17','10:40:00',3.33),('15844','2013-08-17','10:45:00',3.4),('15844','2013-08-17','10:50:00',3.46),('15844','2013-08-17','10:55:00',3.53),('15844','2013-08-17','11:00:00',3.66),('15844','2013-08-17','11:05:00',3.67),('15844','2013-08-17','11:10:00',3.68),('15844','2013-08-17','11:15:00',3.78),('15844','2013-08-17','11:20:00',3.83),('15844','2013-08-17','11:25:00',3.88),('15844','2013-08-17','11:30:00',3.9),('15844','2013-08-17','11:35:00',3.88),('15844','2013-08-17','11:40:00',3.87),('15844','2013-08-17','11:45:00',3.86),('15844','2013-08-17','11:50:00',3.93),('15844','2013-08-17','11:55:00',3.93),('15844','2013-08-17','12:00:00',3.85),('15844','2013-08-17','12:05:00',3.87),('15844','2013-08-17','12:10:00',3.7),('15844','2013-08-17','12:15:00',3.83),('15844','2013-08-17','12:20:00',3.83),('15844','2013-08-17','12:25:00',3.86),('15844','2013-08-17','12:30:00',3.92),('15844','2013-08-17','12:35:00',3.97),('15844','2013-08-17','12:40:00',3.91),('15844','2013-08-17','12:45:00',3.81),('15844','2013-08-17','12:50:00',3.79),('15844','2013-08-17','12:55:00',3.85),('15844','2013-08-17','13:00:00',3.84),('15844','2013-08-17','13:05:00',3.65),('15844','2013-08-17','13:10:00',3.85),('15844','2013-08-17','13:15:00',3.87),('15844','2013-08-17','13:20:00',3.83),('15844','2013-08-17','13:25:00',3.78),('15844','2013-08-17','13:30:00',3.73),('15844','2013-08-17','13:35:00',3.64),('15844','2013-08-17','13:40:00',3.74),('15844','2013-08-17','13:45:00',3.6),('15844','2013-08-17','13:50:00',3.56),('15844','2013-08-17','13:55:00',3.64),('15844','2013-08-17','14:00:00',3.47),('15844','2013-08-17','14:05:00',3.13),('15844','2013-08-17','14:10:00',3.4),('15844','2013-08-17','14:15:00',3.31),('15844','2013-08-17','14:20:00',3.19),('15844','2013-08-17','14:25:00',3.2),('15844','2013-08-17','14:30:00',3.07),('15844','2013-08-17','14:35:00',2.99),('15844','2013-08-17','14:40:00',2.87),('15844','2013-08-17','14:45:00',2.79),('15844','2013-08-17','14:50:00',2.65),('15844','2013-08-17','14:55:00',2.6),('15844','2013-08-17','15:00:00',2.53),('15844','2013-08-17','15:05:00',2.41),('15844','2013-08-17','15:10:00',2.35),('15844','2013-08-17','15:15:00',2.27),('15844','2013-08-17','15:20:00',2.19),('15844','2013-08-17','15:25:00',2.1),('15844','2013-08-17','15:30:00',2.02),('15844','2013-08-17','15:35:00',1.92),('15844','2013-08-17','15:40:00',1.82),('15844','2013-08-17','15:45:00',1.72),('15844','2013-08-17','15:50:00',1.62),('15844','2013-08-17','15:55:00',1.5),('15844','2013-08-17','16:00:00',1.38),('15844','2013-08-17','16:05:00',1.31),('15844','2013-08-17','16:10:00',1.23),('15844','2013-08-17','16:15:00',1.18),('15844','2013-08-17','16:20:00',1.13),('15844','2013-08-17','16:25:00',1.07),('15844','2013-08-17','16:30:00',1.02),('15844','2013-08-16','08:35:00',1.01),('15844','2013-08-16','08:40:00',1.14),('15844','2013-08-16','08:45:00',1.22),('15844','2013-08-16','08:50:00',1.28),('15844','2013-08-16','08:55:00',1.37),('15844','2013-08-16','09:00:00',1.45),('15844','2013-08-16','09:05:00',1.52),('15844','2013-08-16','09:10:00',1.62),('15844','2013-08-16','09:15:00',1.71),('15844','2013-08-16','09:20:00',1.8),('15844','2013-08-16','09:25:00',1.92),('15844','2013-08-16','09:30:00',2.05),('15844','2013-08-16','09:35:00',2.15),('15844','2013-08-16','09:40:00',2.24),('15844','2013-08-16','09:45:00',2.3),('15844','2013-08-16','09:50:00',2.36),('15844','2013-08-16','09:55:00',2.45),('15844','2013-08-16','10:00:00',2.65),('15844','2013-08-16','10:05:00',2.76),('15844','2013-08-16','10:10:00',2.82),('15844','2013-08-16','10:15:00',2.9),('15844','2013-08-16','10:20:00',3.05),('15844','2013-08-16','10:25:00',3.16),('15844','2013-08-16','10:30:00',3.28),('15844','2013-08-16','10:35:00',3.36),('15844','2013-08-16','10:40:00',3.45),('15844','2013-08-16','10:45:00',3.52),('15844','2013-08-16','10:50:00',3.59),('15844','2013-08-16','10:55:00',3.68),('15844','2013-08-16','11:00:00',3.87),('15844','2013-08-16','11:05:00',3.93),('15844','2013-08-16','11:10:00',3.96),('15844','2013-08-16','11:15:00',3.97),('15844','2013-08-16','11:20:00',4),('15844','2013-08-16','11:25:00',4.02),('15844','2013-08-16','11:30:00',4.03),('15844','2013-08-16','11:35:00',4.06),('15844','2013-08-16','11:40:00',4.08),('15844','2013-08-16','11:45:00',4.07),('15844','2013-08-16','11:50:00',4.11),('15844','2013-08-16','11:55:00',4.08),('15844','2013-08-16','12:00:00',4.08),('15844','2013-08-16','12:05:00',4.03),('15844','2013-08-16','12:10:00',4.02),('15844','2013-08-16','12:15:00',4),('15844','2013-08-16','12:20:00',4),('15844','2013-08-16','12:25:00',4.02),('15844','2013-08-16','12:30:00',3.99),('15844','2013-08-16','12:35:00',3.96),('15844','2013-08-16','12:40:00',3.96),('15844','2013-08-16','12:45:00',3.95),('15844','2013-08-16','12:50:00',3.94),('15844','2013-08-16','12:55:00',3.89),('15844','2013-08-16','13:00:00',3.88),('15844','2013-08-16','13:05:00',3.84),('15844','2013-08-16','13:10:00',3.82),('15844','2013-08-16','13:15:00',3.82),('15844','2013-08-16','13:20:00',3.79),('15844','2013-08-16','13:25:00',3.77),('15844','2013-08-16','13:30:00',3.73),('15844','2013-08-16','13:35:00',3.67),('15844','2013-08-16','13:40:00',3.65),('15844','2013-08-16','13:45:00',3.62),('15844','2013-08-16','13:50:00',3.58),('15844','2013-08-16','13:55:00',3.55),('15844','2013-08-16','14:00:00',3.48),('15844','2013-08-16','14:05:00',3.41),('15844','2013-08-16','14:10:00',3.35),('15844','2013-08-16','14:15:00',3.3),('15844','2013-08-16','14:20:00',3.23),('15844','2013-08-16','14:25:00',3.16),('15844','2013-08-16','14:30:00',3.06),('15844','2013-08-16','14:35:00',2.95),('15844','2013-08-16','14:40:00',2.84),('15844','2013-08-16','14:45:00',2.7),('15844','2013-08-16','14:50:00',2.64),('15844','2013-08-16','14:55:00',2.59),('15844','2013-08-16','15:00:00',2.5),('15844','2013-08-16','15:05:00',2.43),('15844','2013-08-16','15:10:00',2.36),('15844','2013-08-16','15:15:00',2.29),('15844','2013-08-16','15:20:00',2.2),('15844','2013-08-16','15:25:00',2.12),('15844','2013-08-16','15:30:00',2.04),('15844','2013-08-16','15:35:00',1.94),('15844','2013-08-16','15:40:00',1.82),('15844','2013-08-16','15:45:00',1.72),('15844','2013-08-16','15:50:00',1.62),('15844','2013-08-16','15:55:00',1.51),('15844','2013-08-16','16:00:00',1.39),('15844','2013-08-16','16:05:00',1.3),('15844','2013-08-16','16:10:00',1.22),('15844','2013-08-16','16:15:00',1.17),('15844','2013-08-16','16:20:00',1.12),('15844','2013-08-16','16:25:00',1.07),('15844','2013-08-16','16:30:00',1),('15844','2013-08-15','08:50:00',1.1),('15844','2013-08-15','08:55:00',1.39),('15844','2013-08-15','09:00:00',1.51),('15844','2013-08-15','09:05:00',1.6),('15844','2013-08-15','09:10:00',1.7),('15844','2013-08-15','09:15:00',1.8),('15844','2013-08-15','09:20:00',1.89),('15844','2013-08-15','09:25:00',1.95),('15844','2013-08-15','09:30:00',2.07),('15844','2013-08-15','09:35:00',2.17),('15844','2013-08-15','09:40:00',2.24),('15844','2013-08-15','09:45:00',2.32),('15844','2013-08-15','09:50:00',2.37),('15844','2013-08-15','09:55:00',2.42),('15844','2013-08-15','10:00:00',2.61),('15844','2013-08-15','10:05:00',2.76),('15844','2013-08-15','10:10:00',2.82),('15844','2013-08-15','10:15:00',2.94),('15844','2013-08-15','10:20:00',3.08),('15844','2013-08-15','10:25:00',3.2),('15844','2013-08-15','10:30:00',3.3),('15844','2013-08-15','10:35:00',3.42),('15844','2013-08-15','10:40:00',3.5),('15844','2013-08-15','10:45:00',3.6),('15844','2013-08-15','10:50:00',3.68),('15844','2013-08-15','10:55:00',3.77),('15844','2013-08-15','11:00:00',3.89),('15844','2013-08-15','11:05:00',4.01),('15844','2013-08-15','11:10:00',4.07),('15844','2013-08-15','11:15:00',4.12),('15844','2013-08-15','11:20:00',4),('15844','2013-08-15','11:25:00',4.19),('15844','2013-08-15','11:30:00',3.85),('15844','2013-08-15','11:35:00',2.63),('15844','2013-08-15','11:40:00',2.46),('15844','2013-08-15','11:45:00',2.39),('15844','2013-08-15','11:50:00',3.21),('15844','2013-08-15','11:55:00',3.64),('15844','2013-08-15','12:00:00',3.89),('15844','2013-08-15','12:05:00',4.08),('15844','2013-08-15','12:10:00',4.12),('15844','2013-08-15','12:15:00',3.96),('15844','2013-08-15','12:20:00',3.9),('15844','2013-08-15','12:25:00',4.04),('15844','2013-08-15','12:30:00',4.13),('15844','2013-08-15','12:35:00',4.14),('15844','2013-08-15','12:40:00',4.14),('15844','2013-08-15','12:45:00',4.09),('15844','2013-08-15','12:50:00',4.03),('15844','2013-08-15','12:55:00',3.98),('15844','2013-08-15','13:00:00',3.96),('15844','2013-08-15','13:05:00',4),('15844','2013-08-15','13:10:00',3.93),('15844','2013-08-15','13:15:00',3.87),('15844','2013-08-15','13:20:00',3.89),('15844','2013-08-15','13:25:00',3.76),('15844','2013-08-15','13:30:00',3.91),('15844','2013-08-15','13:35:00',3.88),('15844','2013-08-15','13:40:00',3.78),('15844','2013-08-15','13:45:00',3.7),('15844','2013-08-15','13:50:00',3.66),('15844','2013-08-15','13:55:00',3.62),('15844','2013-08-15','14:00:00',3.51),('15844','2013-08-15','14:05:00',3.45),('15844','2013-08-15','14:10:00',3.39),('15844','2013-08-15','14:15:00',3.3),('15844','2013-08-15','14:20:00',3.2),('15844','2013-08-15','14:25:00',3.18),('15844','2013-08-15','14:30:00',3.11),('15844','2013-08-15','14:35:00',3.01),('15844','2013-08-15','14:40:00',2.88),('15844','2013-08-15','14:45:00',2.77),('15844','2013-08-15','14:50:00',2.63),('15844','2013-08-15','14:55:00',2.53),('15844','2013-08-15','15:00:00',2.46),('15844','2013-08-15','15:05:00',2.39),('15844','2013-08-15','15:10:00',2.32),('15844','2013-08-15','15:15:00',2.27),('15844','2013-08-15','15:20:00',2.16),('15844','2013-08-15','15:25:00',2.08),('15844','2013-08-15','15:30:00',2.01),('15844','2013-08-15','15:35:00',1.93),('15844','2013-08-15','15:40:00',1.84),('15844','2013-08-15','15:45:00',1.73),('15844','2013-08-15','15:50:00',1.62),('15844','2013-08-15','15:55:00',1.51),('15844','2013-08-15','16:00:00',1.43),('15844','2013-08-15','16:05:00',1.34),('15844','2013-08-15','16:10:00',1.26),('15844','2013-08-15','16:15:00',1.16),('15844','2013-08-15','16:20:00',1.16),('15844','2013-08-15','16:25:00',1.11),('15844','2013-08-15','16:30:00',1.06),('15844','2013-08-15','16:35:00',1.01),('15844','2013-08-14','08:45:00',1.02),('15844','2013-08-14','08:50:00',1.15),('15844','2013-08-14','08:55:00',1.24),('15844','2013-08-14','09:00:00',1.5),('15844','2013-08-14','09:05:00',1.76),('15844','2013-08-14','09:10:00',1.72),('15844','2013-08-14','09:15:00',1.05),('15844','2013-08-14','09:35:00',1.24),('15844','2013-08-14','09:40:00',1.37),('15844','2013-08-14','09:45:00',1.69),('15844','2013-08-14','09:50:00',2.29),('15844','2013-08-14','09:55:00',2.38),('15844','2013-08-14','10:00:00',2.75),('15844','2013-08-14','10:05:00',2.09),('15844','2013-08-14','10:10:00',1.43),('15844','2013-08-14','10:15:00',1.84),('15844','2013-08-14','10:20:00',2.46),('15844','2013-08-14','10:25:00',2.73),('15844','2013-08-14','10:30:00',1.68),('15844','2013-08-14','10:35:00',1.1),('15844','2013-08-14','10:45:00',1.05),('15844','2013-08-14','10:50:00',1.94),('15844','2013-08-14','10:55:00',2.79),('15844','2013-08-14','11:00:00',4.1),('15844','2013-08-14','11:05:00',3.27),('15844','2013-08-14','11:10:00',1.79),('15844','2013-08-14','11:15:00',2.69),('15844','2013-08-14','11:20:00',2.97),('15844','2013-08-14','11:25:00',1.56),('15844','2013-08-14','11:30:00',1.56),('15844','2013-08-14','11:35:00',3.74),('15844','2013-08-14','11:40:00',3.78),('15844','2013-08-14','11:45:00',3.85),('15844','2013-08-14','11:50:00',3.46),('15844','2013-08-14','11:55:00',3),('15844','2013-08-14','12:00:00',3.84),('15844','2013-08-14','12:05:00',4.16),('15844','2013-08-14','12:10:00',3.63),('15844','2013-08-14','12:15:00',3),('15844','2013-08-14','12:20:00',4.18),('15844','2013-08-14','12:25:00',3.67),('15844','2013-08-14','12:30:00',4.34),('15844','2013-08-14','12:35:00',3.64),('15844','2013-08-14','12:40:00',1.47),('15844','2013-08-14','12:45:00',1.03),('15844','2013-08-14','12:50:00',1.34),('15844','2013-08-14','12:55:00',3.07),('15844','2013-08-14','13:00:00',2.93),('15844','2013-08-14','13:05:00',3.57),('15844','2013-08-14','13:10:00',3.81),('15844','2013-08-14','13:15:00',3.85),('15844','2013-08-14','13:20:00',3.34),('15844','2013-08-14','13:25:00',2.61),('15844','2013-08-14','13:30:00',3.47),('15844','2013-08-14','13:35:00',3.6),('15844','2013-08-14','13:40:00',3.52),('15844','2013-08-14','13:45:00',2.79),('15844','2013-08-14','13:50:00',3.95),('15844','2013-08-14','13:55:00',3.74),('15844','2013-08-14','14:00:00',3.52),('15844','2013-08-14','14:05:00',3.63),('15844','2013-08-14','14:10:00',3.76),('15844','2013-08-14','14:15:00',3.51),('15844','2013-08-14','14:20:00',3.42),('15844','2013-08-14','14:25:00',3.47),('15844','2013-08-14','14:30:00',3.37),('15844','2013-08-14','14:35:00',3.15),('15844','2013-08-14','14:40:00',2.97),('15844','2013-08-14','14:45:00',2.89),('15844','2013-08-14','14:50:00',2.79),('15844','2013-08-14','14:55:00',2.67),('15844','2013-08-14','15:00:00',2.57),('15844','2013-08-14','15:05:00',2.42),('15844','2013-08-14','15:10:00',2.36),('15844','2013-08-14','15:15:00',2.31),('15844','2013-08-14','15:20:00',2.24),('15844','2013-08-14','15:25:00',2.17),('15844','2013-08-14','15:30:00',2.08),('15844','2013-08-14','15:35:00',1.98),('15844','2013-08-14','15:40:00',1.88),('15844','2013-08-14','15:45:00',1.79),('15844','2013-08-14','15:50:00',1.68),('15844','2013-08-14','15:55:00',1.58),('15844','2013-08-14','16:00:00',1.49),('15844','2013-08-14','16:05:00',1.37),('15844','2013-08-14','16:10:00',1.28),('15844','2013-08-14','16:15:00',1.19),('15844','2013-08-14','16:20:00',1.19),('15844','2013-08-14','16:25:00',1.12),('15844','2013-08-14','16:30:00',1.07),('15844','2013-08-13','08:35:00',1.04),('15844','2013-08-13','08:40:00',1.16),('15844','2013-08-13','08:45:00',1.24),('15844','2013-08-13','08:50:00',1.3),('15844','2013-08-13','08:55:00',1.37),('15844','2013-08-13','09:00:00',1.44),('15844','2013-08-13','09:05:00',1.49),('15844','2013-08-13','09:10:00',1.56),('15844','2013-08-13','09:15:00',1.66),('15844','2013-08-13','09:20:00',1.79),('15844','2013-08-13','09:25:00',1.9),('15844','2013-08-13','09:30:00',2.03),('15844','2013-08-13','09:35:00',2.15),('15844','2013-08-13','09:40:00',2.19),('15844','2013-08-13','09:45:00',2.25),('15844','2013-08-13','09:50:00',2.19),('15844','2013-08-13','09:55:00',2.17),('15844','2013-08-13','10:00:00',2.18),('15844','2013-08-13','10:05:00',2.43),('15844','2013-08-13','10:10:00',2.77),('15844','2013-08-13','10:15:00',3.02),('15844','2013-08-13','10:20:00',3.1),('15844','2013-08-13','10:25:00',3.19),('15844','2013-08-13','10:30:00',3.2),('15844','2013-08-13','10:35:00',3.47),('15844','2013-08-13','10:40:00',3.51),('15844','2013-08-13','10:45:00',3.5),('15844','2013-08-13','10:50:00',3.54),('15844','2013-08-13','10:55:00',3.69),('15844','2013-08-13','11:00:00',3.7),('15844','2013-08-13','11:05:00',3.81),('15844','2013-08-13','11:10:00',3.62),('15844','2013-08-13','11:15:00',3.92),('15844','2013-08-13','11:20:00',3.93),('15844','2013-08-13','11:25:00',3.96),('15844','2013-08-13','11:30:00',4.06),('15844','2013-08-13','11:35:00',4.03),('15844','2013-08-13','11:40:00',4.02),('15844','2013-08-13','11:45:00',4.16),('15844','2013-08-13','11:50:00',4.18),('15844','2013-08-13','11:55:00',3.72),('15844','2013-08-13','12:00:00',1.11),('15844','2013-08-13','12:10:00',1.79),('15844','2013-08-13','12:15:00',2.22),('15844','2013-08-13','12:20:00',4.22),('15844','2013-08-13','12:25:00',3.02),('15844','2013-08-13','12:30:00',3.72),('15844','2013-08-13','12:35:00',4.38),('15844','2013-08-13','12:40:00',4.38),('15844','2013-08-13','12:45:00',4.39),('15844','2013-08-13','12:50:00',4.18),('15844','2013-08-13','12:55:00',3.94),('15844','2013-08-13','13:00:00',3.83),('15844','2013-08-13','13:05:00',3.94),('15844','2013-08-13','13:10:00',4.03),('15844','2013-08-13','13:15:00',3.86),('15844','2013-08-13','13:20:00',3.87),('15844','2013-08-13','13:25:00',3.78),('15844','2013-08-13','13:30:00',3.97),('15844','2013-08-13','13:35:00',3.86),('15844','2013-08-13','13:40:00',3.79),('15844','2013-08-13','13:45:00',3.84),('15844','2013-08-13','13:50:00',3.67),('15844','2013-08-13','13:55:00',3.66),('15844','2013-08-13','14:00:00',3.55),('15844','2013-08-13','14:05:00',3.46),('15844','2013-08-13','14:10:00',3.4),('15844','2013-08-13','14:15:00',3.36),('15844','2013-08-13','14:20:00',3.31),('15844','2013-08-13','14:25:00',3.21),('15844','2013-08-13','14:30:00',3.16),('15844','2013-08-13','14:35:00',3.13),('15844','2013-08-13','14:40:00',2.99),('15844','2013-08-13','14:45:00',2.87),('15844','2013-08-13','14:50:00',2.77),('15844','2013-08-13','14:55:00',2.65),('15844','2013-08-13','15:00:00',2.61),('15844','2013-08-13','15:05:00',2.53),('15844','2013-08-13','15:10:00',2.42),('15844','2013-08-13','15:15:00',2.32),('15844','2013-08-13','15:20:00',2.25),('15844','2013-08-13','15:25:00',2.17),('15844','2013-08-13','15:30:00',2.09),('15844','2013-08-13','15:35:00',2.01),('15844','2013-08-13','15:40:00',1.91),('15844','2013-08-13','15:45:00',1.82),('15844','2013-08-13','15:50:00',1.71),('15844','2013-08-13','15:55:00',1.59),('15844','2013-08-13','16:00:00',1.49),('15844','2013-08-13','16:05:00',1.38),('15844','2013-08-13','16:10:00',1.27),('15844','2013-08-13','16:15:00',1.19),('15844','2013-08-13','16:20:00',1.2),('15844','2013-08-13','16:25:00',1.13),('15844','2013-08-13','16:30:00',1.07),('15844','2013-08-12','08:35:00',1.04),('15844','2013-08-12','08:40:00',1.14),('15844','2013-08-12','08:45:00',1.21),('15844','2013-08-12','08:50:00',1.27),('15844','2013-08-12','08:55:00',1.34),('15844','2013-08-12','09:00:00',1.4),('15844','2013-08-12','09:05:00',1.49),('15844','2013-08-12','09:10:00',1.58),('15844','2013-08-12','09:15:00',1.67),('15844','2013-08-12','09:20:00',1.77),('15844','2013-08-12','09:25:00',1.89),('15844','2013-08-12','09:30:00',2),('15844','2013-08-12','09:35:00',2.09),('15844','2013-08-12','09:40:00',2.16),('15844','2013-08-12','09:45:00',2.21),('15844','2013-08-12','09:50:00',2.25),('15844','2013-08-12','09:55:00',2.31),('15844','2013-08-12','10:00:00',2.51),('15844','2013-08-12','10:05:00',2.62),('15844','2013-08-12','10:10:00',2.7),('15844','2013-08-12','10:15:00',2.82),('15844','2013-08-12','10:20:00',2.95),('15844','2013-08-12','10:25:00',3.06),('15844','2013-08-12','10:30:00',3.15),('15844','2013-08-12','10:35:00',3.24),('15844','2013-08-12','10:40:00',3.34),('15844','2013-08-12','10:45:00',3.42),('15844','2013-08-12','10:50:00',3.5),('15844','2013-08-12','10:55:00',3.62),('15844','2013-08-12','11:00:00',3.66),('15844','2013-08-12','11:05:00',3.7),('15844','2013-08-12','11:10:00',3.74),('15844','2013-08-12','11:15:00',3.75),('15844','2013-08-12','11:20:00',3.83),('15844','2013-08-12','11:25:00',3.86),('15844','2013-08-12','11:30:00',3.85),('15844','2013-08-12','11:35:00',3.96),('15844','2013-08-12','11:40:00',3.83),('15844','2013-08-12','11:45:00',4.12),('15844','2013-08-12','11:50:00',4.15),('15844','2013-08-12','11:55:00',3.95),('15844','2013-08-12','12:00:00',2.9),('15844','2013-08-12','12:05:00',2.16),('15844','2013-08-12','12:10:00',1.42),('15844','2013-08-12','12:15:00',1.24),('15844','2013-08-12','12:20:00',1.41),('15844','2013-08-12','12:25:00',2.06),('15844','2013-08-12','12:30:00',2.14),('15844','2013-08-12','12:35:00',2.1),('15844','2013-08-12','12:40:00',3.34),('15844','2013-08-12','12:55:00',1.11),('15844','2013-08-12','13:00:00',2.69),('15844','2013-08-12','13:10:00',1.52),('15844','2013-08-12','13:15:00',1.48),('15844','2013-08-12','13:20:00',2.63),('15844','2013-08-12','13:25:00',1.95),('15844','2013-08-12','13:30:00',2.64),('15844','2013-08-12','13:35:00',1.19),('15844','2013-08-12','13:40:00',2.29),('15844','2013-08-12','13:45:00',4.16),('15844','2013-08-12','13:50:00',1.58),('15844','2013-08-12','13:55:00',2.27),('15844','2013-08-12','14:00:00',1.77),('15844','2013-08-12','14:05:00',1.37),('15844','2013-08-12','14:10:00',1.47),('15844','2013-08-12','14:15:00',1.44),('15844','2013-08-12','14:20:00',2.26),('15844','2013-08-12','14:25:00',2.73),('15844','2013-08-12','14:30:00',3.39),('15844','2013-08-12','14:35:00',2.39),('15844','2013-08-12','14:40:00',2.57),('15844','2013-08-12','14:45:00',2.6),('15844','2013-08-12','14:50:00',3.07),('15844','2013-08-12','14:55:00',2.85),('15844','2013-08-12','15:00:00',2.78),('15844','2013-08-12','15:05:00',2.63),('15844','2013-08-12','15:10:00',2.48),('15844','2013-08-12','15:15:00',2.34),('15844','2013-08-12','15:20:00',2.28),('15844','2013-08-12','15:25:00',2.12),('15844','2013-08-12','15:30:00',2.14),('15844','2013-08-12','15:35:00',2.12),('15844','2013-08-12','15:40:00',1.76),('15844','2013-08-12','15:45:00',1.82),('15844','2013-08-12','15:50:00',1.73),('15844','2013-08-12','15:55:00',1.63),('15844','2013-08-12','16:00:00',1.54),('15844','2013-08-12','16:05:00',1.48),('15844','2013-08-12','16:10:00',1.33),('15844','2013-08-12','16:15:00',1.23),('15844','2013-08-12','16:20:00',1.2),('15844','2013-08-12','16:25:00',1.17),('15844','2013-08-12','16:30:00',1.08),('15844','2013-08-12','16:35:00',1.02),('15844','2013-08-11','08:45:00',1.07),('15844','2013-08-11','08:50:00',1.17),('15844','2013-08-11','08:55:00',1.22),('15844','2013-08-11','09:00:00',1.26),('15844','2013-08-11','09:05:00',1.37),('15844','2013-08-11','09:10:00',1.62),('15844','2013-08-11','09:15:00',1.72),('15844','2013-08-11','09:20:00',1.81),('15844','2013-08-11','09:25:00',1.94),('15844','2013-08-11','09:30:00',2.06),('15844','2013-08-11','09:35:00',2.15),('15844','2013-08-11','09:40:00',2.24),('15844','2013-08-11','09:45:00',2.29),('15844','2013-08-11','09:50:00',2.35),('15844','2013-08-11','09:55:00',2.39),('15844','2013-08-11','10:00:00',2.54),('15844','2013-08-11','10:05:00',2.71),('15844','2013-08-11','10:10:00',2.78),('15844','2013-08-11','10:15:00',2.91),('15844','2013-08-11','10:20:00',3.01),('15844','2013-08-11','10:25:00',3.13),('15844','2013-08-11','10:30:00',3.26),('15844','2013-08-11','10:35:00',3.35),('15844','2013-08-11','10:40:00',3.42),('15844','2013-08-11','10:45:00',3.5),('15844','2013-08-11','10:50:00',3.61),('15844','2013-08-11','10:55:00',3.8),('15844','2013-08-11','11:00:00',3.88),('15844','2013-08-11','11:05:00',3.91),('15844','2013-08-11','11:10:00',3.98),('15844','2013-08-11','11:15:00',4),('15844','2013-08-11','11:20:00',4.06),('15844','2013-08-11','11:25:00',4.05),('15844','2013-08-11','11:30:00',4.06),('15844','2013-08-11','11:35:00',4.07),('15844','2013-08-11','11:40:00',4.05),('15844','2013-08-11','11:45:00',4.09),('15844','2013-08-11','11:50:00',4.09),('15844','2013-08-11','11:55:00',4.09),('15844','2013-08-11','12:00:00',4.09),('15844','2013-08-11','12:05:00',4.11),('15844','2013-08-11','12:10:00',4.08),('15844','2013-08-11','12:15:00',4.08),('15844','2013-08-11','12:20:00',4.06),('15844','2013-08-11','12:25:00',4.05),('15844','2013-08-11','12:30:00',4.07),('15844','2013-08-11','12:35:00',4.02),('15844','2013-08-11','12:40:00',4),('15844','2013-08-11','12:45:00',4),('15844','2013-08-11','12:50:00',3.97),('15844','2013-08-11','12:55:00',3.95),('15844','2013-08-11','13:00:00',3.93),('15844','2013-08-11','13:05:00',3.93),('15844','2013-08-11','13:10:00',3.95),('15844','2013-08-11','13:15:00',3.94),('15844','2013-08-11','13:20:00',3.86),('15844','2013-08-11','13:25:00',3.82),('15844','2013-08-11','13:30:00',3.79),('15844','2013-08-11','13:35:00',3.76),('15844','2013-08-11','13:40:00',3.64),('15844','2013-08-11','13:45:00',3.68),('15844','2013-08-11','13:50:00',3.62),('15844','2013-08-11','13:55:00',3.58),('15844','2013-08-11','14:00:00',3.5),('15844','2013-08-11','14:05:00',3.45),('15844','2013-08-11','14:10:00',3.36),('15844','2013-08-11','14:15:00',3.25),('15844','2013-08-11','14:20:00',3.21),('15844','2013-08-11','14:25:00',3.21),('15844','2013-08-11','14:30:00',3.11),('15844','2013-08-11','14:35:00',2.99),('15844','2013-08-11','14:40:00',2.97),('15844','2013-08-11','14:45:00',2.71),('15844','2013-08-11','14:50:00',2.73),('15844','2013-08-11','14:55:00',2.62),('15844','2013-08-11','15:00:00',2.53),('15844','2013-08-11','15:05:00',2.5),('15844','2013-08-11','15:10:00',2.42),('15844','2013-08-11','15:15:00',2.32),('15844','2013-08-11','15:20:00',2.31),('15844','2013-08-11','15:25:00',2.19),('15844','2013-08-11','15:30:00',2.09),('15844','2013-08-11','15:35:00',2.01),('15844','2013-08-11','15:40:00',1.92),('15844','2013-08-11','15:45:00',1.82),('15844','2013-08-11','15:50:00',1.72),('15844','2013-08-11','15:55:00',1.62),('15844','2013-08-11','16:00:00',1.53),('15844','2013-08-11','16:05:00',1.44),('15844','2013-08-11','16:10:00',1.33),('15844','2013-08-11','16:15:00',1.22),('15844','2013-08-11','16:20:00',1.17),('15844','2013-08-11','16:25:00',1.15),('15844','2013-08-11','16:30:00',1.12),('15844','2013-08-11','16:35:00',1.09),('15844','2013-08-11','16:40:00',1.03),('15844','2013-08-10','08:35:00',1.07),('15844','2013-08-10','08:40:00',1.21),('15844','2013-08-10','08:45:00',1.29),('15844','2013-08-10','08:50:00',1.35),('15844','2013-08-10','08:55:00',1.43),('15844','2013-08-10','09:00:00',1.5),('15844','2013-08-10','09:05:00',1.56),('15844','2013-08-10','09:10:00',1.65),('15844','2013-08-10','09:15:00',1.74),('15844','2013-08-10','09:20:00',1.87),('15844','2013-08-10','09:25:00',1.96),('15844','2013-08-10','09:30:00',2.08),('15844','2013-08-10','09:35:00',2.18),('15844','2013-08-10','09:40:00',2.28),('15844','2013-08-10','09:45:00',2.36),('15844','2013-08-10','09:50:00',2.41),('15844','2013-08-10','09:55:00',2.46),('15844','2013-08-10','10:00:00',2.64),('15844','2013-08-10','10:05:00',2.76),('15844','2013-08-10','10:10:00',2.86),('15844','2013-08-10','10:15:00',2.96),('15844','2013-08-10','10:20:00',3.04),('15844','2013-08-10','10:25:00',3.14),('15844','2013-08-10','10:30:00',3.29),('15844','2013-08-10','10:35:00',3.38),('15844','2013-08-10','10:40:00',3.51),('15844','2013-08-10','10:45:00',3.56),('15844','2013-08-10','10:50:00',3.63),('15844','2013-08-10','10:55:00',3.69),('15844','2013-08-10','11:00:00',3.94),('15844','2013-08-10','11:05:00',3.39),('15844','2013-08-10','11:10:00',4.09),('15844','2013-08-10','11:15:00',4.14),('15844','2013-08-10','11:20:00',4.1),('15844','2013-08-10','11:25:00',4.1),('15844','2013-08-10','11:30:00',4.09),('15844','2013-08-10','11:35:00',4.06),('15844','2013-08-10','11:40:00',4.12),('15844','2013-08-10','11:45:00',4.11),('15844','2013-08-10','11:50:00',4.11),('15844','2013-08-10','11:55:00',4.17),('15844','2013-08-10','12:00:00',4.25),('15844','2013-08-10','12:05:00',4.16),('15844','2013-08-10','12:10:00',4.1),('15844','2013-08-10','12:15:00',4.14),('15844','2013-08-10','12:20:00',4.18),('15844','2013-08-10','12:25:00',4.19),('15844','2013-08-10','12:30:00',4.17),('15844','2013-08-10','12:35:00',4.17),('15844','2013-08-10','12:40:00',4.21),('15844','2013-08-10','12:45:00',4.36),('15844','2013-08-10','12:50:00',3.43),('15844','2013-08-10','12:55:00',2.39),('15844','2013-08-10','13:00:00',4.3),('15844','2013-08-10','13:05:00',4.09),('15844','2013-08-10','13:10:00',4.12),('15844','2013-08-10','13:15:00',4.23),('15844','2013-08-10','13:20:00',4.25),('15844','2013-08-10','13:25:00',4.28),('15844','2013-08-10','13:30:00',3.07),('15844','2013-08-10','13:35:00',2.31),('15844','2013-08-10','13:40:00',2.8),('15844','2013-08-10','13:45:00',3.17),('15844','2013-08-10','13:50:00',1.94),('15844','2013-08-10','14:00:00',1.29),('15844','2013-08-10','14:05:00',3.56),('15844','2013-08-10','14:10:00',3.78),('15844','2013-08-10','14:15:00',2.53),('15844','2013-08-10','15:40:00',1.12),('15844','2013-08-10','15:45:00',1.46),('15844','2013-08-10','15:50:00',1.36),('15844','2013-08-10','15:55:00',1.31),('15844','2013-08-10','16:00:00',1.36),('15844','2013-08-10','16:05:00',1.25),('15844','2013-08-10','16:10:00',1.21),('15844','2013-08-10','16:20:00',1.03),('15844','2013-08-10','16:25:00',1.3),('15844','2013-08-10','16:30:00',1.14),('15844','2013-08-10','17:15:00',1),('15844','2014-04-09','09:45:00',2.23),('15844','2014-04-09','09:50:00',2.42),('15844','2014-04-09','09:55:00',2.55),('15844','2014-04-09','10:00:00',2.1),('15844','2014-04-09','10:05:00',1.31),('15844','2014-04-09','10:10:00',1.62),('15844','2014-04-09','10:15:00',2.71),('15844','2014-04-09','10:20:00',3.3),('15844','2014-04-09','10:25:00',1.46),('15844','2014-04-09','10:40:00',2.7),('15844','2014-04-09','10:45:00',1.4),('15844','2014-04-09','10:55:00',1.21),('15844','2014-04-09','11:00:00',1.83),('15844','2014-04-09','11:10:00',1.06),('15844','2014-04-09','11:15:00',3.7),('15844','2014-04-09','11:20:00',4.33),('15844','2014-04-09','11:25:00',4.23),('15844','2014-04-09','11:30:00',4),('15844','2014-04-09','11:35:00',3.61),('15844','2014-04-09','11:40:00',1.27),('15844','2014-04-09','11:45:00',2.88),('15844','2014-04-09','11:50:00',3.93),('15844','2014-04-09','11:55:00',1.64),('15844','2014-04-09','12:00:00',1.89),('15844','2014-04-09','12:05:00',1.38),('15844','2014-04-09','12:10:00',1.1),('15844','2014-04-09','13:40:00',1.01),('15844','2014-04-09','13:45:00',1.01),('15844','2014-04-09','14:30:00',1.18),('15844','2014-04-09','14:35:00',1.86),('15844','2014-04-09','14:40:00',2.34),('15844','2014-04-09','14:45:00',1.08),('15844','2014-04-09','14:55:00',1.12),('15844','2014-04-09','15:00:00',1.31),('15844','2014-04-09','15:05:00',1.06),('15844','2014-04-09','15:10:00',1.13),('15844','2014-04-09','15:15:00',1.09),('15844','2014-04-09','15:40:00',1.03),('15844','2014-04-09','16:00:00',1.43),('15844','2014-04-09','16:05:00',1.5),('15844','2014-04-09','16:10:00',1.32),('15844','2014-04-09','16:15:00',1.25),('15844','2014-04-09','16:20:00',1.06),('15844','2014-04-09','16:35:00',1.02),('15844','2014-04-09','16:40:00',1.17),('15844','2014-04-09','16:45:00',1.02),('15844','2013-08-09','08:45:00',1.09),('15844','2013-08-09','08:50:00',1.21),('15844','2013-08-09','08:55:00',1.18),('15844','2013-08-09','09:00:00',1.21),('15844','2013-08-09','09:05:00',1.51),('15844','2013-08-09','09:10:00',1.76),('15844','2013-08-09','09:15:00',1.28),('15844','2013-08-09','09:20:00',1.19),('15844','2013-08-09','09:25:00',1.98),('15844','2013-08-09','09:30:00',1.84),('15844','2013-08-09','09:35:00',1.42),('15844','2013-08-09','09:40:00',1.34),('15844','2013-08-09','09:45:00',2.13),('15844','2013-08-09','09:50:00',2.3),('15844','2013-08-09','09:55:00',2.41),('15844','2013-08-09','10:00:00',2.33),('15844','2013-08-09','10:05:00',2.24),('15844','2013-08-09','10:10:00',2.53),('15844','2013-08-09','10:15:00',2.61),('15844','2013-08-09','10:20:00',2.72),('15844','2013-08-09','10:25:00',2.76),('15844','2013-08-09','10:30:00',2.91),('15844','2013-08-09','10:35:00',2.99),('15844','2013-08-09','10:40:00',2.99),('15844','2013-08-09','10:45:00',3.05),('15844','2013-08-09','10:50:00',3.23),('15844','2013-08-09','10:55:00',3.34),('15844','2013-08-09','11:00:00',3.36),('15844','2013-08-09','11:05:00',3.39),('15844','2013-08-09','11:10:00',3.35),('15844','2013-08-09','11:15:00',3.55),('15844','2013-08-09','11:20:00',3.58),('15844','2013-08-09','11:25:00',3.59),('15844','2013-08-09','11:30:00',3.61),('15844','2013-08-09','11:35:00',3.65),('15844','2013-08-09','11:40:00',3.58),('15844','2013-08-09','11:45:00',3.65),('15844','2013-08-09','11:50:00',3.62),('15844','2013-08-09','11:55:00',3.67),('15844','2013-08-09','12:00:00',3.7),('15844','2013-08-09','12:05:00',3.68),('15844','2013-08-09','12:10:00',3.72),('15844','2013-08-09','12:15:00',3.68),('15844','2013-08-09','12:20:00',3.89),('15844','2013-08-09','12:25:00',4.08),('15844','2013-08-09','12:30:00',3.24),('15844','2013-08-09','12:35:00',2.83),('15844','2013-08-09','12:40:00',2.76),('15844','2013-08-09','12:45:00',2.32),('15844','2013-08-09','12:50:00',1.79),('15844','2013-08-09','12:55:00',1.69),('15844','2013-08-09','13:15:00',1.05),('15844','2013-08-09','13:20:00',1.51),('15844','2013-08-09','13:25:00',1.57),('15844','2013-08-09','13:30:00',1.44),('15844','2013-08-09','13:35:00',1.31),('15844','2013-08-09','13:40:00',1.1),('15844','2013-08-09','13:50:00',1.06),('15844','2013-08-09','13:55:00',1.14),('15844','2013-08-09','14:00:00',1.08),('15844','2013-08-09','15:10:00',1.44),('15844','2013-08-09','15:15:00',2.33),('15844','2013-08-09','15:20:00',1.37),('15844','2013-08-09','15:30:00',1.08),('15844','2013-08-09','15:35:00',1.67),('15844','2013-08-09','15:40:00',2.13),('15844','2013-08-09','15:45:00',1.89),('15844','2013-08-09','15:50:00',1.34),('15844','2013-08-09','16:50:00',1.16),('15844','2013-08-09','16:55:00',1.07),('15844','2013-08-08','08:40:00',1.04),('15844','2013-08-08','08:45:00',1.14),('15844','2013-08-08','08:50:00',1.21),('15844','2013-08-08','08:55:00',1.27),('15844','2013-08-08','09:00:00',1.33),('15844','2013-08-08','09:05:00',1.38),('15844','2013-08-08','09:10:00',1.44),('15844','2013-08-08','09:15:00',1.57),('15844','2013-08-08','09:20:00',1.68),('15844','2013-08-08','09:25:00',1.78),('15844','2013-08-08','09:30:00',1.88),('15844','2013-08-08','09:35:00',1.99),('15844','2013-08-08','09:40:00',2.06),('15844','2013-08-08','09:45:00',2.1),('15844','2013-08-08','09:50:00',2.16),('15844','2013-08-08','09:55:00',2.22),('15844','2013-08-08','10:00:00',2.4),('15844','2013-08-08','10:05:00',2.49),('15844','2013-08-08','10:10:00',2.56),('15844','2013-08-08','10:15:00',2.65),('15844','2013-08-08','10:20:00',2.78),('15844','2013-08-08','10:25:00',2.86),('15844','2013-08-08','10:30:00',2.95),('15844','2013-08-08','10:35:00',3.04),('15844','2013-08-08','10:40:00',3.11),('15844','2013-08-08','10:45:00',3.2),('15844','2013-08-08','10:50:00',3.29),('15844','2013-08-08','10:55:00',3.36),('15844','2013-08-08','11:00:00',3.45),('15844','2013-08-08','11:05:00',3.52),('15844','2013-08-08','11:10:00',3.54),('15844','2013-08-08','11:15:00',3.56),('15844','2013-08-08','11:20:00',3.61),('15844','2013-08-08','11:25:00',3.65),('15844','2013-08-08','11:30:00',3.68),('15844','2013-08-08','11:35:00',3.7),('15844','2013-08-08','11:40:00',3.68),('15844','2013-08-08','11:45:00',3.7),('15844','2013-08-08','11:50:00',3.71),('15844','2013-08-08','11:55:00',3.72),('15844','2013-08-08','12:00:00',3.71),('15844','2013-08-08','12:05:00',3.68),('15844','2013-08-08','12:10:00',3.69),('15844','2013-08-08','12:15:00',3.76),('15844','2013-08-08','12:20:00',3.77),('15844','2013-08-08','12:25:00',3.77),('15844','2013-08-08','12:30:00',3.8),('15844','2013-08-08','12:35:00',3.78),('15844','2013-08-08','12:40:00',3.66),('15844','2013-08-08','12:45:00',3.75),('15844','2013-08-08','12:50:00',3.76),('15844','2013-08-08','12:55:00',3.75),('15844','2013-08-08','13:00:00',3.74),('15844','2013-08-08','13:05:00',3.68),('15844','2013-08-08','13:10:00',3.71),('15844','2013-08-08','13:15:00',3.68),('15844','2013-08-08','13:20:00',3.65),('15844','2013-08-08','13:25:00',3.62),('15844','2013-08-08','13:30:00',3.6),('15844','2013-08-08','13:35:00',3.56),('15844','2013-08-08','13:40:00',3.54),('15844','2013-08-08','13:45:00',3.51),('15844','2013-08-08','13:50:00',3.46),('15844','2013-08-08','13:55:00',3.42),('15844','2013-08-08','14:00:00',3.37),('15844','2013-08-08','14:05:00',3.32),('15844','2013-08-08','14:10:00',3.27),('15844','2013-08-08','14:15:00',3.24),('15844','2013-08-08','14:20:00',3.17),('15844','2013-08-08','14:25:00',3.09),('15844','2013-08-08','14:30:00',3.03),('15844','2013-08-08','14:35:00',2.94),('15844','2013-08-08','14:40:00',2.84),('15844','2013-08-08','14:45:00',2.74),('15844','2013-08-08','14:50:00',2.63),('15844','2013-08-08','14:55:00',2.53),('15844','2013-08-08','15:00:00',2.43),('15844','2013-08-08','15:05:00',2.38),('15844','2013-08-08','15:10:00',2.29),('15844','2013-08-08','15:15:00',2.2),('15844','2013-08-08','15:20:00',2.11),('15844','2013-08-08','15:25:00',2.04),('15844','2013-08-08','15:30:00',1.95),('15844','2013-08-08','15:35:00',1.91),('15844','2013-08-08','15:40:00',1.83),('15844','2013-08-08','15:45:00',1.73),('15844','2013-08-08','15:50:00',1.65),('15844','2013-08-08','15:55:00',1.55),('15844','2013-08-08','16:00:00',1.47),('15844','2013-08-08','16:05:00',1.4),('15844','2013-08-08','16:10:00',1.32),('15844','2013-08-08','16:15:00',1.25),('15844','2013-08-08','16:20:00',1.2),('15844','2013-08-08','16:25:00',1.17),('15844','2013-08-08','16:30:00',1.12),('15844','2013-08-08','16:35:00',1.05),('15844','2013-08-07','08:40:00',1.08),('15844','2013-08-07','08:45:00',1.15),('15844','2013-08-07','08:50:00',1.25),('15844','2013-08-07','08:55:00',1.33),('15844','2013-08-07','09:00:00',1.38),('15844','2013-08-07','09:05:00',1.42),('15844','2013-08-07','09:10:00',1.45),('15844','2013-08-07','09:15:00',1.54),('15844','2013-08-07','09:20:00',1.67),('15844','2013-08-07','09:25:00',1.78),('15844','2013-08-07','09:30:00',1.89),('15844','2013-08-07','09:35:00',1.98),('15844','2013-08-07','09:40:00',2.08),('15844','2013-08-07','09:45:00',2.13),('15844','2013-08-07','09:50:00',2.18),('15844','2013-08-07','09:55:00',2.24),('15844','2013-08-07','10:00:00',2.42),('15844','2013-08-07','10:05:00',2.53),('15844','2013-08-07','10:10:00',2.6),('15844','2013-08-07','10:15:00',2.73),('15844','2013-08-07','10:20:00',2.82),('15844','2013-08-07','10:25:00',2.94),('15844','2013-08-07','10:30:00',2.99),('15844','2013-08-07','10:35:00',3.1),('15844','2013-08-07','10:40:00',3.14),('15844','2013-08-07','10:45:00',3.2),('15844','2013-08-07','10:50:00',3.3),('15844','2013-08-07','10:55:00',3.37),('15844','2013-08-07','11:00:00',3.48),('15844','2013-08-07','11:05:00',3.55),('15844','2013-08-07','11:10:00',3.59),('15844','2013-08-07','11:15:00',3.61),('15844','2013-08-07','11:20:00',3.62),('15844','2013-08-07','11:25:00',3.64),('15844','2013-08-07','11:30:00',3.66),('15844','2013-08-07','11:35:00',3.71),('15844','2013-08-07','11:40:00',3.73),('15844','2013-08-07','11:45:00',3.72),('15844','2013-08-07','11:50:00',3.69),('15844','2013-08-07','11:55:00',3.64),('15844','2013-08-07','12:00:00',3.69),('15844','2013-08-07','12:05:00',3.7),('15844','2013-08-07','12:10:00',3.74),('15844','2013-08-07','12:15:00',3.74),('15844','2013-08-07','12:20:00',3.65),('15844','2013-08-07','12:25:00',3.72),('15844','2013-08-07','12:30:00',3.71),('15844','2013-08-07','12:35:00',3.66),('15844','2013-08-07','12:40:00',3.68),('15844','2013-08-07','12:45:00',3.59),('15844','2013-08-07','12:50:00',3.72),('15844','2013-08-07','12:55:00',3.76),('15844','2013-08-07','13:00:00',3.72),('15844','2013-08-07','13:05:00',3.51),('15844','2013-08-07','13:10:00',3.74),('15844','2013-08-07','13:15:00',3.67),('15844','2013-08-07','13:20:00',3.68),('15844','2013-08-07','13:25:00',3.59),('15844','2013-08-07','13:30:00',3.56),('15844','2013-08-07','13:35:00',3.61),('15844','2013-08-07','13:40:00',3.59),('15844','2013-08-07','13:45:00',3.55),('15844','2013-08-07','13:50:00',3.52),('15844','2013-08-07','13:55:00',3.48),('15844','2013-08-07','14:00:00',3.44),('15844','2013-08-07','14:05:00',3.38),('15844','2013-08-07','14:10:00',3.29),('15844','2013-08-07','14:15:00',3.24),('15844','2013-08-07','14:20:00',3.19),('15844','2013-08-07','14:25:00',3.14),('15844','2013-08-07','14:30:00',3.07),('15844','2013-08-07','14:35:00',2.96),('15844','2013-08-07','14:40:00',2.89),('15844','2013-08-07','14:45:00',2.72),('15844','2013-08-07','14:50:00',2.66),('15844','2013-08-07','14:55:00',2.56),('15844','2013-08-07','15:00:00',2.51),('15844','2013-08-07','15:05:00',2.44),('15844','2013-08-07','15:10:00',2.33),('15844','2013-08-07','15:15:00',2.24),('15844','2013-08-07','15:20:00',2.17),('15844','2013-08-07','15:25:00',2.08),('15844','2013-08-07','15:30:00',2.02),('15844','2013-08-07','15:35:00',1.94),('15844','2013-08-07','15:40:00',1.87),('15844','2013-08-07','15:45:00',1.79),('15844','2013-08-07','15:50:00',1.69),('15844','2013-08-07','15:55:00',1.6),('15844','2013-08-07','16:00:00',1.5),('15844','2013-08-07','16:05:00',1.43),('15844','2013-08-07','16:10:00',1.35),('15844','2013-08-07','16:15:00',1.29),('15844','2013-08-07','16:20:00',1.25),('15844','2013-08-07','16:25:00',1.2),('15844','2013-08-07','16:30:00',1.13),('15844','2013-08-07','16:35:00',1.07),('15844','2013-08-07','16:40:00',1),('15844','2013-08-06','08:45:00',1.02),('15844','2013-08-06','08:50:00',1.13),('15844','2013-08-06','08:55:00',1.19),('15844','2013-08-06','09:00:00',1.22),('15844','2013-08-06','09:05:00',1.26),('15844','2013-08-06','09:10:00',1.31),('15844','2013-08-06','09:15:00',1.41),('15844','2013-08-06','09:20:00',1.67),('15844','2013-08-06','09:25:00',1.77),('15844','2013-08-06','09:30:00',1.86),('15844','2013-08-06','09:35:00',1.95),('15844','2013-08-06','09:40:00',2.06),('15844','2013-08-06','09:45:00',2.14),('15844','2013-08-06','09:50:00',2.18),('15844','2013-08-06','09:55:00',2.21),('15844','2013-08-06','10:00:00',2.42),('15844','2013-08-06','10:05:00',2.51),('15844','2013-08-06','10:10:00',2.62),('15844','2013-08-06','10:15:00',2.7),('15844','2013-08-06','10:20:00',2.82),('15844','2013-08-06','10:25:00',2.91),('15844','2013-08-06','10:30:00',3),('15844','2013-08-06','10:35:00',3.06),('15844','2013-08-06','10:40:00',3.13),('15844','2013-08-06','10:45:00',3.21),('15844','2013-08-06','10:50:00',3.32),('15844','2013-08-06','10:55:00',3.43),('15844','2013-08-06','11:00:00',3.52),('15844','2013-08-06','11:05:00',3.57),('15844','2013-08-06','11:10:00',3.6),('15844','2013-08-06','11:15:00',3.66),('15844','2013-08-06','11:20:00',3.69),('15844','2013-08-06','11:25:00',3.68),('15844','2013-08-06','11:30:00',3.73),('15844','2013-08-06','11:35:00',3.68),('15844','2013-08-06','11:40:00',3.67),('15844','2013-08-06','11:45:00',3.68),('15844','2013-08-06','11:50:00',3.66),('15844','2013-08-06','11:55:00',3.69),('15844','2013-08-06','12:00:00',3.72),('15844','2013-08-06','12:05:00',3.77),('15844','2013-08-06','12:10:00',3.77),('15844','2013-08-06','12:15:00',3.8),('15844','2013-08-06','12:20:00',3.78),('15844','2013-08-06','12:25:00',3.83),('15844','2013-08-06','12:30:00',3.8),('15844','2013-08-06','12:35:00',3.8),('15844','2013-08-06','12:40:00',3.84),('15844','2013-08-06','12:45:00',3.81),('15844','2013-08-06','12:50:00',3.79),('15844','2013-08-06','12:55:00',3.79),('15844','2013-08-06','13:00:00',3.77),('15844','2013-08-06','13:05:00',3.77),('15844','2013-08-06','13:10:00',3.73),('15844','2013-08-06','13:15:00',3.75),('15844','2013-08-06','13:20:00',3.73),('15844','2013-08-06','13:25:00',3.71),('15844','2013-08-06','13:30:00',3.69),('15844','2013-08-06','13:35:00',3.66),('15844','2013-08-06','13:40:00',3.65),('15844','2013-08-06','13:45:00',3.61),('15844','2013-08-06','13:50:00',3.56),('15844','2013-08-06','13:55:00',3.53),('15844','2013-08-06','14:00:00',3.49),('15844','2013-08-06','14:05:00',3.42),('15844','2013-08-06','14:10:00',3.36),('15844','2013-08-06','14:15:00',3.3),('15844','2013-08-06','14:20:00',3.24),('15844','2013-08-06','14:25:00',3.18),('15844','2013-08-06','14:30:00',3.13),('15844','2013-08-06','14:35:00',3.04),('15844','2013-08-06','14:40:00',2.95),('15844','2013-08-06','14:45:00',2.85),('15844','2013-08-06','14:50:00',2.76),('15844','2013-08-06','14:55:00',2.64),('15844','2013-08-06','15:00:00',2.54),('15844','2013-08-06','15:05:00',2.49),('15844','2013-08-06','15:10:00',2.43),('15844','2013-08-06','15:15:00',2.33),('15844','2013-08-06','15:20:00',2.23),('15844','2013-08-06','15:25:00',2.15),('15844','2013-08-06','15:30:00',2.07),('15844','2013-08-06','15:35:00',2),('15844','2013-08-06','15:40:00',1.92),('15844','2013-08-06','15:45:00',1.83),('15844','2013-08-06','15:50:00',1.73),('15844','2013-08-06','15:55:00',1.63),('15844','2013-08-06','16:00:00',1.56),('15844','2013-08-06','16:05:00',1.49),('15844','2013-08-06','16:10:00',1.41),('15844','2013-08-06','16:15:00',1.34),('15844','2013-08-06','16:20:00',1.29),('15844','2013-08-06','16:25:00',1.22),('15844','2013-08-06','16:30:00',1.16),('15844','2013-08-06','16:35:00',1.11),('15844','2013-08-06','16:40:00',1.03),('15844','2013-08-05','08:45:00',1.05),('15844','2013-08-05','08:50:00',1.14),('15844','2013-08-05','08:55:00',1.19),('15844','2013-08-05','09:00:00',1.23),('15844','2013-08-05','09:05:00',1.27),('15844','2013-08-05','09:10:00',1.32),('15844','2013-08-05','09:15:00',1.46),('15844','2013-08-05','09:20:00',1.69),('15844','2013-08-05','09:25:00',1.81),('15844','2013-08-05','09:30:00',1.92),('15844','2013-08-05','09:35:00',2),('15844','2013-08-05','09:40:00',2.08),('15844','2013-08-05','09:45:00',2.16),('15844','2013-08-05','09:50:00',2.24),('15844','2013-08-05','09:55:00',2.3),('15844','2013-08-05','10:00:00',2.46),('15844','2013-08-05','10:05:00',2.59),('15844','2013-08-05','10:10:00',2.68),('15844','2013-08-05','10:15:00',2.77),('15844','2013-08-05','10:20:00',2.95),('15844','2013-08-05','10:25:00',3.02),('15844','2013-08-05','10:30:00',3.1),('15844','2013-08-05','10:35:00',3.21),('15844','2013-08-05','10:40:00',3.24),('15844','2013-08-05','10:45:00',3.33),('15844','2013-08-05','10:50:00',3.45),('15844','2013-08-05','10:55:00',3.55),('15844','2013-08-05','11:00:00',3.63),('15844','2013-08-05','11:05:00',3.67),('15844','2013-08-05','11:10:00',3.72),('15844','2013-08-05','11:15:00',3.76),('15844','2013-08-05','11:20:00',3.81),('15844','2013-08-05','11:25:00',3.8),('15844','2013-08-05','11:30:00',3.86),('15844','2013-08-05','11:35:00',3.88),('15844','2013-08-05','11:40:00',3.89),('15844','2013-08-05','11:45:00',3.88),('15844','2013-08-05','11:50:00',3.91),('15844','2013-08-05','11:55:00',3.9),('15844','2013-08-05','12:00:00',3.9),('15844','2013-08-05','12:05:00',3.91),('15844','2013-08-05','12:10:00',3.9),('15844','2013-08-05','12:15:00',3.89),('15844','2013-08-05','12:20:00',3.89),('15844','2013-08-05','12:25:00',3.9),('15844','2013-08-05','12:30:00',3.8),('15844','2013-08-05','12:35:00',3.84),('15844','2013-08-05','12:40:00',3.84),('15844','2013-08-05','12:45:00',3.81),('15844','2013-08-05','12:50:00',3.81),('15844','2013-08-05','12:55:00',3.79),('15844','2013-08-05','13:00:00',3.77),('15844','2013-08-05','13:05:00',3.79),('15844','2013-08-05','13:10:00',3.71),('15844','2013-08-05','13:15:00',3.74),('15844','2013-08-05','13:20:00',3.7),('15844','2013-08-05','13:25:00',3.67),('15844','2013-08-05','13:30:00',3.64),('15844','2013-08-05','13:35:00',3.57),('15844','2013-08-05','13:40:00',3.56),('15844','2013-08-05','13:45:00',3.53),('15844','2013-08-05','13:50:00',3.53),('15844','2013-08-05','13:55:00',3.48),('15844','2013-08-05','14:00:00',3.44),('15844','2013-08-05','14:05:00',3.39),('15844','2013-08-05','14:10:00',3.31),('15844','2013-08-05','14:15:00',3.27),('15844','2013-08-05','14:20:00',3.2),('15844','2013-08-05','14:25:00',3.13),('15844','2013-08-05','14:30:00',3.06),('15844','2013-08-05','14:35:00',2.99),('15844','2013-08-05','14:40:00',2.9),('15844','2013-08-05','14:45:00',2.82),('15844','2013-08-05','14:50:00',2.69),('15844','2013-08-05','14:55:00',2.58),('15844','2013-08-05','15:00:00',2.46),('15844','2013-08-05','15:05:00',2.35),('15844','2013-08-05','15:10:00',2.23),('15844','2013-08-05','15:15:00',2.12),('15844','2013-08-05','15:20:00',2.08),('15844','2013-08-05','15:25:00',2.13),('15844','2013-08-05','15:30:00',2.08),('15844','2013-08-05','15:35:00',2.01),('15844','2013-08-05','15:40:00',1.93),('15844','2013-08-05','15:45:00',1.84),('15844','2013-08-05','15:50:00',1.74),('15844','2013-08-05','15:55:00',1.63),('15844','2013-08-05','16:00:00',1.55),('15844','2013-08-05','16:05:00',1.47),('15844','2013-08-05','16:10:00',1.4),('15844','2013-08-05','16:15:00',1.33),('15844','2013-08-05','16:20:00',1.28),('15844','2013-08-05','16:25:00',1.21),('15844','2013-08-05','16:30:00',1.14),('15844','2013-08-05','16:35:00',1.11),('15844','2013-08-05','16:40:00',1.02),('15844','2013-08-04','08:35:00',1.08),('15844','2013-08-04','08:40:00',1.16),('15844','2013-08-04','08:45:00',1.21),('15844','2013-08-04','08:50:00',1.29),('15844','2013-08-04','08:55:00',1.39),('15844','2013-08-04','09:00:00',1.46),('15844','2013-08-04','09:05:00',1.5),('15844','2013-08-04','09:10:00',1.56),('15844','2013-08-04','09:15:00',1.62),('15844','2013-08-04','09:20:00',1.72),('15844','2013-08-04','09:25:00',1.86),('15844','2013-08-04','09:30:00',2),('15844','2013-08-04','09:35:00',2.08),('15844','2013-08-04','09:40:00',2.17),('15844','2013-08-04','09:45:00',2.27),('15844','2013-08-04','09:50:00',2.35),('15844','2013-08-04','09:55:00',2.38),('15844','2013-08-04','10:00:00',2.57),('15844','2013-08-04','10:05:00',2.68),('15844','2013-08-04','10:10:00',2.8),('15844','2013-08-04','10:15:00',2.93),('15844','2013-08-04','10:20:00',3.04),('15844','2013-08-04','10:25:00',3.13),('15844','2013-08-04','10:30:00',3.2),('15844','2013-08-04','10:35:00',3.27),('15844','2013-08-04','10:40:00',3.38),('15844','2013-08-04','10:45:00',3.47),('15844','2013-08-04','10:50:00',3.58),('15844','2013-08-04','10:55:00',3.72),('15844','2013-08-04','11:00:00',3.8),('15844','2013-08-04','11:05:00',3.86),('15844','2013-08-04','11:10:00',3.95),('15844','2013-08-04','11:15:00',3.98),('15844','2013-08-04','11:20:00',4.02),('15844','2013-08-04','11:25:00',4.03),('15844','2013-08-04','11:30:00',4.04),('15844','2013-08-04','11:35:00',4.02),('15844','2013-08-04','11:40:00',4.01),('15844','2013-08-04','11:45:00',4.07),('15844','2013-08-04','11:50:00',4.07),('15844','2013-08-04','11:55:00',4.06),('15844','2013-08-04','12:00:00',4.05),('15844','2013-08-04','12:05:00',4.08),('15844','2013-08-04','12:10:00',4.05),('15844','2013-08-04','12:15:00',4.03),('15844','2013-08-04','12:20:00',4.03),('15844','2013-08-04','12:25:00',3.98),('15844','2013-08-04','12:30:00',4.02),('15844','2013-08-04','12:35:00',4.02),('15844','2013-08-04','12:40:00',4.02),('15844','2013-08-04','12:45:00',3.98),('15844','2013-08-04','12:50:00',3.99),('15844','2013-08-04','12:55:00',3.95),('15844','2013-08-04','13:00:00',3.93),('15844','2013-08-04','13:05:00',3.91),('15844','2013-08-04','13:10:00',3.86),('15844','2013-08-04','13:15:00',3.85),('15844','2013-08-04','13:20:00',3.86),('15844','2013-08-04','13:25:00',3.84),('15844','2013-08-04','13:30:00',3.81),('15844','2013-08-04','13:35:00',3.79),('15844','2013-08-04','13:40:00',3.76),('15844','2013-08-04','13:45:00',3.76),('15844','2013-08-04','13:50:00',3.72),('15844','2013-08-04','13:55:00',3.67),('15844','2013-08-04','14:00:00',3.61),('15844','2013-08-04','14:05:00',3.54),('15844','2013-08-04','14:10:00',3.48),('15844','2013-08-04','14:15:00',3.41),('15844','2013-08-04','14:20:00',3.34),('15844','2013-08-04','14:25:00',3.28),('15844','2013-08-04','14:30:00',3.18),('15844','2013-08-04','14:35:00',3.07),('15844','2013-08-04','14:40:00',3.01),('15844','2013-08-04','14:45:00',2.91),('15844','2013-08-04','14:50:00',2.78),('15844','2013-08-04','14:55:00',2.66),('15844','2013-08-04','15:00:00',2.55),('15844','2013-08-04','15:05:00',2.42),('15844','2013-08-04','15:10:00',2.3),('15844','2013-08-04','15:15:00',2.22),('15844','2013-08-04','15:20:00',2.12),('15844','2013-08-04','15:25:00',2.03),('15844','2013-08-04','15:30:00',2.14),('15844','2013-08-04','15:35:00',2.08),('15844','2013-08-04','15:40:00',2.01),('15844','2013-08-04','15:45:00',1.93),('15844','2013-08-04','15:50:00',1.8),('15844','2013-08-04','15:55:00',1.69),('15844','2013-08-04','16:00:00',1.59),('15844','2013-08-04','16:05:00',1.51),('15844','2013-08-04','16:10:00',1.42),('15844','2013-08-04','16:15:00',1.36),('15844','2013-08-04','16:20:00',1.29),('15844','2013-08-04','16:25:00',1.2),('15844','2013-08-04','16:30:00',1.15),('15844','2013-08-04','16:35:00',1.1),('15844','2013-08-04','16:40:00',1.01),('15844','2013-08-03','08:35:00',1.08),('15844','2013-08-03','08:40:00',1.17),('15844','2013-08-03','08:45:00',1.22),('15844','2013-08-03','08:50:00',1.3),('15844','2013-08-03','08:55:00',1.38),('15844','2013-08-03','09:00:00',1.47),('15844','2013-08-03','09:05:00',1.53),('15844','2013-08-03','09:10:00',1.58),('15844','2013-08-03','09:15:00',1.65),('15844','2013-08-03','09:20:00',1.73),('15844','2013-08-03','09:25:00',1.85),('15844','2013-08-03','09:30:00',2),('15844','2013-08-03','09:35:00',2.1),('15844','2013-08-03','09:40:00',2.2),('15844','2013-08-03','09:45:00',2.27),('15844','2013-08-03','09:50:00',2.34),('15844','2013-08-03','09:55:00',2.4),('15844','2013-08-03','10:00:00',2.57),('15844','2013-08-03','10:05:00',2.67),('15844','2013-08-03','10:10:00',2.79),('15844','2013-08-03','10:15:00',2.93),('15844','2013-08-03','10:20:00',3.08),('15844','2013-08-03','10:25:00',3.19),('15844','2013-08-03','10:30:00',3.3),('15844','2013-08-03','10:35:00',3.33),('15844','2013-08-03','10:40:00',3.42),('15844','2013-08-03','10:45:00',3.51),('15844','2013-08-03','10:50:00',3.59),('15844','2013-08-03','10:55:00',3.67),('15844','2013-08-03','11:00:00',3.71),('15844','2013-08-03','11:05:00',3.78),('15844','2013-08-03','11:10:00',3.81),('15844','2013-08-03','11:15:00',3.85),('15844','2013-08-03','11:20:00',3.78),('15844','2013-08-03','11:25:00',3.77),('15844','2013-08-03','11:30:00',3.69),('15844','2013-08-03','11:35:00',3.75),('15844','2013-08-03','11:40:00',3.9),('15844','2013-08-03','11:45:00',3.85),('15844','2013-08-03','11:50:00',3.91),('15844','2013-08-03','11:55:00',3.9),('15844','2013-08-03','12:00:00',3.94),('15844','2013-08-03','12:05:00',3.95),('15844','2013-08-03','12:10:00',3.95),('15844','2013-08-03','12:15:00',3.94),('15844','2013-08-03','12:20:00',3.93),('15844','2013-08-03','12:25:00',3.94),('15844','2013-08-03','12:30:00',3.96),('15844','2013-08-03','12:35:00',3.9),('15844','2013-08-03','12:40:00',3.88),('15844','2013-08-03','12:45:00',3.85),('15844','2013-08-03','12:50:00',3.84),('15844','2013-08-03','12:55:00',3.81),('15844','2013-08-03','13:00:00',3.84),('15844','2013-08-03','13:05:00',3.84),('15844','2013-08-03','13:10:00',3.81),('15844','2013-08-03','13:15:00',3.8),('15844','2013-08-03','13:20:00',3.76),('15844','2013-08-03','13:25:00',3.73),('15844','2013-08-03','13:30:00',3.68),('15844','2013-08-03','13:35:00',3.61),('15844','2013-08-03','13:40:00',3.53),('15844','2013-08-03','13:45:00',3.43),('15844','2013-08-03','13:50:00',3.41),('15844','2013-08-03','13:55:00',3.47),('15844','2013-08-03','14:00:00',3.45),('15844','2013-08-03','14:05:00',3.45),('15844','2013-08-03','14:10:00',3.41),('15844','2013-08-03','14:15:00',3.3),('15844','2013-08-03','14:20:00',3.21),('15844','2013-08-03','14:25:00',3.15),('15844','2013-08-03','14:30:00',3.1),('15844','2013-08-03','14:35:00',3.05),('15844','2013-08-03','14:40:00',2.97),('15844','2013-08-03','14:45:00',2.88),('15844','2013-08-03','14:50:00',2.75),('15844','2013-08-03','14:55:00',2.64),('15844','2013-08-03','15:00:00',2.53),('15844','2013-08-03','15:05:00',2.4),('15844','2013-08-03','15:10:00',2.29),('15844','2013-08-03','15:15:00',2.18),('15844','2013-08-03','15:20:00',2.07),('15844','2013-08-03','15:25:00',2.01),('15844','2013-08-03','15:30:00',2.09),('15844','2013-08-03','15:35:00',2.04),('15844','2013-08-03','15:40:00',1.96),('15844','2013-08-03','15:45:00',1.86),('15844','2013-08-03','15:50:00',1.78),('15844','2013-08-03','15:55:00',1.67),('15844','2013-08-03','16:00:00',1.59),('15844','2013-08-03','16:05:00',1.51),('15844','2013-08-03','16:10:00',1.4),('15844','2013-08-03','16:15:00',1.34),('15844','2013-08-03','16:20:00',1.27),('15844','2013-08-03','16:25:00',1.19),('15844','2013-08-03','16:30:00',1.13),('15844','2013-08-03','16:35:00',1.07),('15844','2013-08-02','08:35:00',1.1),('15844','2013-08-02','08:40:00',1.21),('15844','2013-08-02','08:45:00',1.27),('15844','2013-08-02','08:50:00',1.35),('15844','2013-08-02','08:55:00',1.42),('15844','2013-08-02','09:00:00',1.51),('15844','2013-08-02','09:05:00',1.58),('15844','2013-08-02','09:10:00',1.64),('15844','2013-08-02','09:15:00',1.71),('15844','2013-08-02','09:20:00',1.8),('15844','2013-08-02','09:25:00',1.91),('15844','2013-08-02','09:30:00',2.02),('15844','2013-08-02','09:35:00',2.16),('15844','2013-08-02','09:40:00',2.25),('15844','2013-08-02','09:45:00',2.32),('15844','2013-08-02','09:50:00',2.38),('15844','2013-08-02','09:55:00',2.45),('15844','2013-08-02','10:00:00',2.63),('15844','2013-08-02','10:05:00',2.76),('15844','2013-08-02','10:10:00',2.83),('15844','2013-08-02','10:15:00',2.89),('15844','2013-08-02','10:20:00',3.03),('15844','2013-08-02','10:25:00',3.21),('15844','2013-08-02','10:30:00',3.33),('15844','2013-08-02','10:35:00',3.38),('15844','2013-08-02','10:40:00',3.49),('15844','2013-08-02','10:45:00',3.56),('15844','2013-08-02','10:50:00',3.63),('15844','2013-08-02','10:55:00',3.77),('15844','2013-08-02','11:00:00',3.87),('15844','2013-08-02','11:05:00',3.9),('15844','2013-08-02','11:10:00',3.92),('15844','2013-08-02','11:15:00',3.96),('15844','2013-08-02','11:20:00',4),('15844','2013-08-02','11:25:00',4.03),('15844','2013-08-02','11:30:00',4.02),('15844','2013-08-02','11:35:00',4.04),('15844','2013-08-02','11:40:00',4.05),('15844','2013-08-02','11:45:00',4.06),('15844','2013-08-02','11:50:00',4.07),('15844','2013-08-02','11:55:00',4.09),('15844','2013-08-02','12:00:00',4.07),('15844','2013-08-02','12:05:00',4.07),('15844','2013-08-02','12:10:00',4.08),('15844','2013-08-02','12:15:00',4.11),('15844','2013-08-02','12:20:00',4.15),('15844','2013-08-02','12:25:00',4.12),('15844','2013-08-02','12:30:00',4.08),('15844','2013-08-02','12:35:00',4.03),('15844','2013-08-02','12:40:00',4),('15844','2013-08-02','12:45:00',3.99),('15844','2013-08-02','12:50:00',3.95),('15844','2013-08-02','12:55:00',3.96),('15844','2013-08-02','13:00:00',3.95),('15844','2013-08-02','13:05:00',3.93),('15844','2013-08-02','13:10:00',3.9),('15844','2013-08-02','13:15:00',3.86),('15844','2013-08-02','13:20:00',3.85),('15844','2013-08-02','13:25:00',3.81),('15844','2013-08-02','13:30:00',3.74),('15844','2013-08-02','13:35:00',3.73),('15844','2013-08-02','13:40:00',3.77),('15844','2013-08-02','13:45:00',3.76),('15844','2013-08-02','13:50:00',3.69),('15844','2013-08-02','13:55:00',3.61),('15844','2013-08-02','14:00:00',3.55),('15844','2013-08-02','14:05:00',3.52),('15844','2013-08-02','14:10:00',3.51),('15844','2013-08-02','14:15:00',3.38),('15844','2013-08-02','14:20:00',3.34),('15844','2013-08-02','14:25:00',3.21),('15844','2013-08-02','14:30:00',3.2),('15844','2013-08-02','14:35:00',3.08),('15844','2013-08-02','14:40:00',2.99),('15844','2013-08-02','14:45:00',2.88),('15844','2013-08-02','14:50:00',2.73),('15844','2013-08-02','14:55:00',2.65),('15844','2013-08-02','15:00:00',2.55),('15844','2013-08-02','15:05:00',2.45),('15844','2013-08-02','15:10:00',2.33),('15844','2013-08-02','15:15:00',2.23),('15844','2013-08-02','15:20:00',2.14),('15844','2013-08-02','15:25:00',2.06),('15844','2013-08-02','15:30:00',1.99),('15844','2013-08-02','15:35:00',1.96),('15844','2013-08-02','15:40:00',1.93),('15844','2013-08-02','15:45:00',1.88),('15844','2013-08-02','15:50:00',1.82),('15844','2013-08-02','15:55:00',1.72),('15844','2013-08-02','16:00:00',1.62),('15844','2013-08-02','16:05:00',1.51),('15844','2013-08-02','16:10:00',1.42),('15844','2013-08-02','16:15:00',1.34),('15844','2013-08-02','16:20:00',1.28),('15844','2013-08-02','16:25:00',1.22),('15844','2013-08-02','16:30:00',1.16),('15844','2013-08-02','16:35:00',1.11),('15844','2013-08-02','16:40:00',1.04),('15844','2013-08-01','08:35:00',1.13),('15844','2013-08-01','08:40:00',1.24),('15844','2013-08-01','08:45:00',1.3),('15844','2013-08-01','08:50:00',1.37),('15844','2013-08-01','08:55:00',1.43),('15844','2013-08-01','09:00:00',1.5),('15844','2013-08-01','09:05:00',1.61),('15844','2013-08-01','09:10:00',1.69),('15844','2013-08-01','09:15:00',1.77),('15844','2013-08-01','09:20:00',1.86),('15844','2013-08-01','09:25:00',1.96),('15844','2013-08-01','09:30:00',2.06),('15844','2013-08-01','09:35:00',2.21),('15844','2013-08-01','09:40:00',2.34),('15844','2013-08-01','09:45:00',2.45),('15844','2013-08-01','09:50:00',2.53),('15844','2013-08-01','09:55:00',2.6),('15844','2013-08-01','10:00:00',2.8),('15844','2013-08-01','10:05:00',2.91),('15844','2013-08-01','10:10:00',3.01),('15844','2013-08-01','10:15:00',3.09),('15844','2013-08-01','10:20:00',3.2),('15844','2013-08-01','10:25:00',3.39),('15844','2013-08-01','10:30:00',3.57),('15844','2013-08-01','10:35:00',3.63),('15844','2013-08-01','10:40:00',3.72),('15844','2013-08-01','10:45:00',3.78),('15844','2013-08-01','10:50:00',3.86),('15844','2013-08-01','10:55:00',3.99),('15844','2013-08-01','11:00:00',4.08),('15844','2013-08-01','11:05:00',4.16),('15844','2013-08-01','11:10:00',4.21),('15844','2013-08-01','11:15:00',4.25),('15844','2013-08-01','11:20:00',4.27),('15844','2013-08-01','11:25:00',4.27),('15844','2013-08-01','11:30:00',4.3),('15844','2013-08-01','11:35:00',4.29),('15844','2013-08-01','11:40:00',4.28),('15844','2013-08-01','11:45:00',4.28),('15844','2013-08-01','11:50:00',4.29),('15844','2013-08-01','11:55:00',4.31),('15844','2013-08-01','12:00:00',4.3),('15844','2013-08-01','12:05:00',4.28),('15844','2013-08-01','12:10:00',4.29),('15844','2013-08-01','12:15:00',4.28),('15844','2013-08-01','12:20:00',4.28),('15844','2013-08-01','12:25:00',4.33),('15844','2013-08-01','12:30:00',4.3),('15844','2013-08-01','12:35:00',4.26),('15844','2013-08-01','12:40:00',4.24),('15844','2013-08-01','12:45:00',4.25),('15844','2013-08-01','12:50:00',4.25),('15844','2013-08-01','12:55:00',4.23),('15844','2013-08-01','13:00:00',3.85),('15844','2013-08-01','13:05:00',4.2),('15844','2013-08-01','13:10:00',4.18),('15844','2013-08-01','13:15:00',4.2),('15844','2013-08-01','13:20:00',4.12),('15844','2013-08-01','13:25:00',4.08),('15844','2013-08-01','13:30:00',4.04),('15844','2013-08-01','13:35:00',4),('15844','2013-08-01','13:40:00',3.96),('15844','2013-08-01','13:45:00',3.96),('15844','2013-08-01','13:50:00',3.94),('15844','2013-08-01','13:55:00',3.87),('15844','2013-08-01','14:00:00',3.78),('15844','2013-08-01','14:05:00',3.74),('15844','2013-08-01','14:10:00',3.65),('15844','2013-08-01','14:15:00',3.59),('15844','2013-08-01','14:20:00',3.5),('15844','2013-08-01','14:25:00',3.44),('15844','2013-08-01','14:30:00',3.33),('15844','2013-08-01','14:35:00',3.19),('15844','2013-08-01','14:40:00',3.1),('15844','2013-08-01','14:45:00',3.01),('15844','2013-08-01','14:50:00',2.89),('15844','2013-08-01','14:55:00',2.75),('15844','2013-08-01','15:00:00',2.6),('15844','2013-08-01','15:05:00',2.52),('15844','2013-08-01','15:10:00',2.4),('15844','2013-08-01','15:15:00',2.37),('15844','2013-08-01','15:20:00',2.4),('15844','2013-08-01','15:25:00',2.34),('15844','2013-08-01','15:30:00',2.25),('15844','2013-08-01','15:35:00',2.14),('15844','2013-08-01','15:40:00',2.11),('15844','2013-08-01','15:45:00',1.99),('15844','2013-08-01','15:50:00',1.87),('15844','2013-08-01','15:55:00',1.76),('15844','2013-08-01','16:00:00',1.66),('15844','2013-08-01','16:05:00',1.56),('15844','2013-08-01','16:10:00',1.47),('15844','2013-08-01','16:15:00',1.37),('15844','2013-08-01','16:20:00',1.28),('15844','2013-08-01','16:25:00',1.24),('15844','2013-08-01','16:30:00',1.18),('15844','2013-08-01','16:35:00',1.12),('15844','2013-08-01','16:40:00',1.03),('15844','2013-08-01','16:45:00',1.01),('15844','2013-07-31','08:35:00',1.12),('15844','2013-07-31','08:40:00',1.27),('15844','2013-07-31','08:45:00',1.32),('15844','2013-07-31','08:50:00',1.41),('15844','2013-07-31','08:55:00',1.47),('15844','2013-07-31','09:00:00',1.52),('15844','2013-07-31','09:05:00',1.6),('15844','2013-07-31','09:10:00',1.68),('15844','2013-07-31','09:15:00',1.75),('15844','2013-07-31','09:20:00',1.85),('15844','2013-07-31','09:25:00',1.96),('15844','2013-07-31','09:30:00',2.07),('15844','2013-07-31','09:35:00',2.15),('15844','2013-07-31','09:40:00',2.32),('15844','2013-07-31','09:45:00',2.42),('15844','2013-07-31','09:50:00',2.5),('15844','2013-07-31','09:55:00',2.55),('15844','2013-07-31','10:00:00',2.74),('15844','2013-07-31','10:05:00',2.85),('15844','2013-07-31','10:10:00',2.96),('15844','2013-07-31','10:15:00',3.03),('15844','2013-07-31','10:20:00',3.14),('15844','2013-07-31','10:25:00',3.28),('15844','2013-07-31','10:30:00',3.46),('15844','2013-07-31','10:35:00',3.55),('15844','2013-07-31','10:40:00',3.62),('15844','2013-07-31','10:45:00',3.75),('15844','2013-07-31','10:50:00',3.85),('15844','2013-07-31','10:55:00',3.96),('15844','2013-07-31','11:00:00',4),('15844','2013-07-31','11:05:00',4.05),('15844','2013-07-31','11:10:00',4.09),('15844','2013-07-31','11:15:00',4.14),('15844','2013-07-31','11:20:00',4.17),('15844','2013-07-31','11:25:00',4.18),('15844','2013-07-31','11:30:00',4.21),('15844','2013-07-31','11:35:00',4.24),('15844','2013-07-31','11:40:00',4.26),('15844','2013-07-31','11:45:00',4.26),('15844','2013-07-31','11:50:00',4.32),('15844','2013-07-31','11:55:00',4.28),('15844','2013-07-31','12:00:00',4.28),('15844','2013-07-31','12:05:00',4.27),('15844','2013-07-31','12:10:00',4.3),('15844','2013-07-31','12:15:00',4.36),('15844','2013-07-31','12:20:00',4.42),('15844','2013-07-31','12:25:00',4.36),('15844','2013-07-31','12:30:00',4.34),('15844','2013-07-31','12:35:00',4.35),('15844','2013-07-31','12:40:00',4.34),('15844','2013-07-31','12:45:00',4.06),('15844','2013-07-31','12:50:00',4.3),('15844','2013-07-31','12:55:00',4.25),('15844','2013-07-31','13:00:00',4.2),('15844','2013-07-31','13:05:00',4.16),('15844','2013-07-31','13:10:00',4.16),('15844','2013-07-31','13:15:00',4.12),('15844','2013-07-31','13:20:00',4.15),('15844','2013-07-31','13:25:00',4.12),('15844','2013-07-31','13:30:00',4.06),('15844','2013-07-31','13:35:00',4.02),('15844','2013-07-31','13:40:00',3.99),('15844','2013-07-31','13:45:00',3.94),('15844','2013-07-31','13:50:00',3.92),('15844','2013-07-31','13:55:00',3.91),('15844','2013-07-31','14:00:00',3.74),('15844','2013-07-31','14:05:00',3.79),('15844','2013-07-31','14:10:00',3.66),('15844','2013-07-31','14:15:00',3.66),('15844','2013-07-31','14:20:00',3.5),('15844','2013-07-31','14:25:00',3.43),('15844','2013-07-31','14:30:00',3.45),('15844','2013-07-31','14:35:00',1.61),('15844','2013-07-31','14:40:00',3.28),('15844','2013-07-31','14:45:00',3.14),('15844','2013-07-31','14:50:00',3.04),('15844','2013-07-31','14:55:00',2.95),('15844','2013-07-31','15:00:00',2.87),('15844','2013-07-31','15:05:00',2.76),('15844','2013-07-31','15:10:00',2.66),('15844','2013-07-31','15:15:00',2.56),('15844','2013-07-31','15:20:00',2.46),('15844','2013-07-31','15:25:00',2.33),('15844','2013-07-31','15:30:00',2.27),('15844','2013-07-31','15:35:00',1.84),('15844','2013-07-31','15:40:00',2.03),('15844','2013-07-31','15:45:00',1.98),('15844','2013-07-31','15:50:00',1.87),('15844','2013-07-31','15:55:00',1.78),('15844','2013-07-31','16:00:00',1.69),('15844','2013-07-31','16:05:00',1.57),('15844','2013-07-31','16:10:00',1.47),('15844','2013-07-31','16:15:00',1.26),('15844','2013-07-31','16:25:00',1.16),('15844','2013-07-31','16:30:00',1.25),('15844','2013-07-31','16:35:00',1.16),('15844','2013-07-31','16:40:00',1.07),('15844','2014-04-08','08:45:00',1.06),('15844','2014-04-08','08:50:00',1.19),('15844','2014-04-08','08:55:00',1.29),('15844','2014-04-08','09:00:00',1.37),('15844','2014-04-08','09:05:00',1.48),('15844','2014-04-08','09:10:00',1.58),('15844','2014-04-08','09:15:00',1.73),('15844','2014-04-08','09:20:00',1.82),('15844','2014-04-08','09:25:00',1.92),('15844','2014-04-08','09:30:00',1.98),('15844','2014-04-08','09:35:00',2.05),('15844','2014-04-08','09:40:00',2.12),('15844','2014-04-08','09:45:00',2.23),('15844','2014-04-08','09:50:00',2.26),('15844','2014-04-08','09:55:00',2.25),('15844','2014-04-08','10:00:00',2.38),('15844','2014-04-08','10:05:00',2.55),('15844','2014-04-08','10:10:00',2.66),('15844','2014-04-08','10:15:00',2.7),('15844','2014-04-08','10:20:00',2.78),('15844','2014-04-08','10:25:00',2.83),('15844','2014-04-08','10:30:00',2.85),('15844','2014-04-08','10:35:00',2.96),('15844','2014-04-08','10:40:00',3.1),('15844','2014-04-08','10:45:00',3.16),('15844','2014-04-08','10:50:00',3.25),('15844','2014-04-08','10:55:00',3.36),('15844','2014-04-08','11:00:00',3.47),('15844','2014-04-08','11:05:00',3.48),('15844','2014-04-08','11:10:00',3.57),('15844','2014-04-08','11:15:00',3.58),('15844','2014-04-08','11:20:00',3.52),('15844','2014-04-08','11:25:00',3.6),('15844','2014-04-08','11:30:00',3.48),('15844','2014-04-08','11:35:00',3.66),('15844','2014-04-08','11:40:00',3.71),('15844','2014-04-08','11:45:00',3.67),('15844','2014-04-08','11:50:00',3.71),('15844','2014-04-08','11:55:00',3.68),('15844','2014-04-08','12:00:00',3.57),('15844','2014-04-08','12:05:00',3.57),('15844','2014-04-08','12:10:00',3.43),('15844','2014-04-08','12:15:00',3.08),('15844','2014-04-08','12:20:00',3.27),('15844','2014-04-08','12:25:00',3.68),('15844','2014-04-08','12:30:00',2.85),('15844','2014-04-08','12:35:00',3.48),('15844','2014-04-08','12:40:00',3.27),('15844','2014-04-08','12:45:00',3.57),('15844','2014-04-08','12:50:00',3.54),('15844','2014-04-08','12:55:00',3.53),('15844','2014-04-08','13:00:00',3.57),('15844','2014-04-08','13:05:00',3.86),('15844','2014-04-08','13:10:00',3.67),('15844','2014-04-08','13:15:00',3.7),('15844','2014-04-08','13:20:00',3.71),('15844','2014-04-08','13:25:00',3.7),('15844','2014-04-08','13:30:00',3.63),('15844','2014-04-08','13:35:00',3.58),('15844','2014-04-08','13:40:00',3.51),('15844','2014-04-08','13:45:00',3.5),('15844','2014-04-08','13:50:00',3.39),('15844','2014-04-08','13:55:00',3.31),('15844','2014-04-08','14:00:00',3.26),('15844','2014-04-08','14:05:00',3.26),('15844','2014-04-08','14:10:00',3.27),('15844','2014-04-08','14:15:00',3.18),('15844','2014-04-08','14:20:00',2.85),('15844','2014-04-08','14:25:00',2.31),('15844','2014-04-08','14:30:00',2.8),('15844','2014-04-08','14:35:00',2.6),('15844','2014-04-08','14:40:00',2.14),('15844','2014-04-08','14:45:00',2.55),('15844','2014-04-08','14:50:00',2.56),('15844','2014-04-08','14:55:00',2.42),('15844','2014-04-08','15:00:00',2.31),('15844','2014-04-08','15:05:00',2.24),('15844','2014-04-08','15:10:00',2.12),('15844','2014-04-08','15:15:00',1.93),('15844','2014-04-08','15:20:00',1.93),('15844','2014-04-08','15:25:00',1.87),('15844','2014-04-08','15:30:00',1.76),('15844','2014-04-08','15:35:00',1.65),('15844','2014-04-08','15:40:00',1.48),('15844','2014-04-08','15:45:00',1.46),('15844','2014-04-08','15:50:00',1.35),('15844','2014-04-08','15:55:00',1.27),('15844','2014-04-08','16:00:00',1.21),('15844','2014-04-08','16:05:00',1.21),('15844','2014-04-08','16:10:00',1.14),('15844','2014-04-08','16:15:00',1.07),('15844','2014-04-08','16:20:00',1.02),('15844','2013-07-30','08:35:00',1.06),('15844','2013-07-30','08:40:00',1.12),('15844','2013-07-30','08:45:00',1.17),('15844','2013-07-30','09:10:00',1.37),('15844','2013-07-30','09:15:00',1.83),('15844','2013-07-30','09:20:00',1.89),('15844','2013-07-30','09:25:00',1.59),('15844','2013-07-30','09:30:00',1.59),('15844','2013-07-30','09:35:00',1.97),('15844','2013-07-30','09:40:00',1.03),('15844','2013-07-30','10:00:00',1.71),('15844','2013-07-30','10:10:00',3.18),('15844','2013-07-30','10:15:00',3.36),('15844','2013-07-30','10:20:00',3.54),('15844','2013-07-30','10:25:00',3.58),('15844','2013-07-30','10:30:00',3.54),('15844','2013-07-30','10:35:00',3.62),('15844','2013-07-30','10:40:00',3.77),('15844','2013-07-30','10:45:00',3.85),('15844','2013-07-30','10:50:00',3.88),('15844','2013-07-30','10:55:00',3.94),('15844','2013-07-30','11:00:00',4),('15844','2013-07-30','11:05:00',4.11),('15844','2013-07-30','11:10:00',4.17),('15844','2013-07-30','11:15:00',3.66),('15844','2013-07-30','11:25:00',1.16),('15844','2013-07-30','11:50:00',3.98),('15844','2013-07-30','11:55:00',3.7),('15844','2013-07-30','12:00:00',2.46),('15844','2013-07-30','12:05:00',4.21),('15844','2013-07-30','12:10:00',4.39),('15844','2013-07-30','12:15:00',4.22),('15844','2013-07-30','12:20:00',3.6),('15844','2013-07-30','12:25:00',3.67),('15844','2013-07-30','12:30:00',4.27),('15844','2013-07-30','12:35:00',4.3),('15844','2013-07-30','12:40:00',4.24),('15844','2013-07-30','12:45:00',4.28),('15844','2013-07-30','12:50:00',3.31),('15844','2013-07-30','12:55:00',4.47),('15844','2013-07-30','13:00:00',4.33),('15844','2013-07-30','13:05:00',4.09),('15844','2013-07-30','13:10:00',4.23),('15844','2013-07-30','13:15:00',4.16),('15844','2013-07-30','13:20:00',4.13),('15844','2013-07-30','13:25:00',4.09),('15844','2013-07-30','13:30:00',4.01),('15844','2013-07-30','13:35:00',4.02),('15844','2013-07-30','13:40:00',4.08),('15844','2013-07-30','13:45:00',3.92),('15844','2013-07-30','13:50:00',3.85),('15844','2013-07-30','13:55:00',3.77),('15844','2013-07-30','14:00:00',3.79),('15844','2013-07-30','14:05:00',3.61),('15844','2013-07-30','14:10:00',3.54),('15844','2013-07-30','14:15:00',3.52),('15844','2013-07-30','14:20:00',3.38),('15844','2013-07-30','14:25:00',3.36),('15844','2013-07-30','14:30:00',3.25),('15844','2013-07-30','14:35:00',3.14),('15844','2013-07-30','14:40:00',2.88),('15844','2013-07-30','14:45:00',3),('15844','2013-07-30','14:50:00',2.92),('15844','2013-07-30','14:55:00',2.81),('15844','2013-07-30','15:00:00',2.67),('15844','2013-07-30','15:05:00',2.55),('15844','2013-07-30','15:10:00',2.46),('15844','2013-07-30','15:15:00',2.37),('15844','2013-07-30','15:20:00',2.28),('15844','2013-07-30','15:25:00',2.2),('15844','2013-07-30','15:30:00',2.13),('15844','2013-07-30','15:35:00',2.07),('15844','2013-07-30','15:40:00',2.05),('15844','2013-07-30','15:45:00',1.99),('15844','2013-07-30','15:50:00',1.91),('15844','2013-07-30','15:55:00',1.8),('15844','2013-07-30','16:00:00',1.68),('15844','2013-07-30','16:05:00',1.56),('15844','2013-07-30','16:10:00',1.51),('15844','2013-07-30','16:15:00',1.43),('15844','2013-07-30','16:20:00',1.35),('15844','2013-07-30','16:25:00',1.29),('15844','2013-07-30','16:30:00',1.25),('15844','2013-07-30','16:35:00',1.19),('15844','2013-07-30','16:40:00',1.11),('15844','2013-07-30','16:45:00',1.03),('15844','2013-07-29','08:40:00',1.03),('15844','2013-07-29','08:45:00',1.16),('15844','2013-07-29','08:50:00',1.26),('15844','2013-07-29','08:55:00',1.39),('15844','2013-07-29','09:00:00',1.43),('15844','2013-07-29','09:05:00',1.46),('15844','2013-07-29','09:10:00',1.55),('15844','2013-07-29','09:15:00',1.64),('15844','2013-07-29','09:20:00',1.71),('15844','2013-07-29','09:25:00',1.82),('15844','2013-07-29','09:30:00',1.88),('15844','2013-07-29','09:35:00',1.97),('15844','2013-07-29','09:40:00',2.13),('15844','2013-07-29','09:45:00',2.22),('15844','2013-07-29','09:50:00',2.26),('15844','2013-07-29','09:55:00',2.39),('15844','2013-07-29','10:00:00',2.53),('15844','2013-07-29','10:05:00',2.64),('15844','2013-07-29','10:10:00',2.73),('15844','2013-07-29','10:15:00',2.88),('15844','2013-07-29','10:20:00',2.99),('15844','2013-07-29','10:25:00',3.09),('15844','2013-07-29','10:30:00',3.2),('15844','2013-07-29','10:35:00',3.27),('15844','2013-07-29','10:40:00',3.28),('15844','2013-07-29','10:45:00',3.34),('15844','2013-07-29','10:50:00',3.49),('15844','2013-07-29','10:55:00',3.62),('15844','2013-07-29','11:00:00',3.68),('15844','2013-07-29','11:05:00',3.78),('15844','2013-07-29','11:10:00',3.81),('15844','2013-07-29','11:15:00',3.82),('15844','2013-07-29','11:20:00',3.82),('15844','2013-07-29','11:25:00',3.86),('15844','2013-07-29','11:30:00',3.88),('15844','2013-07-29','11:35:00',3.9),('15844','2013-07-29','11:40:00',3.89),('15844','2013-07-29','11:45:00',3.9),('15844','2013-07-29','11:50:00',3.93),('15844','2013-07-29','11:55:00',3.96),('15844','2013-07-29','12:00:00',3.93),('15844','2013-07-29','12:05:00',3.96),('15844','2013-07-29','12:10:00',3.95),('15844','2013-07-29','12:15:00',3.98),('15844','2013-07-29','12:20:00',3.98),('15844','2013-07-29','12:25:00',3.94),('15844','2013-07-29','12:30:00',3.94),('15844','2013-07-29','12:35:00',3.92),('15844','2013-07-29','12:40:00',3.93),('15844','2013-07-29','12:45:00',3.86),('15844','2013-07-29','12:50:00',3.8),('15844','2013-07-29','12:55:00',3.87),('15844','2013-07-29','13:00:00',3.91),('15844','2013-07-29','13:05:00',3.89),('15844','2013-07-29','13:10:00',3.88),('15844','2013-07-29','13:15:00',3.85),('15844','2013-07-29','13:20:00',3.88),('15844','2013-07-29','13:25:00',3.85),('15844','2013-07-29','13:30:00',3.82),('15844','2013-07-29','13:35:00',3.79),('15844','2013-07-29','13:40:00',3.78),('15844','2013-07-29','13:45:00',3.76),('15844','2013-07-29','13:50:00',3.73),('15844','2013-07-29','13:55:00',3.67),('15844','2013-07-29','14:00:00',3.6),('15844','2013-07-29','14:05:00',3.53),('15844','2013-07-29','14:10:00',3.48),('15844','2013-07-29','14:15:00',3.42),('15844','2013-07-29','14:20:00',3.34),('15844','2013-07-29','14:25:00',3.27),('15844','2013-07-29','14:30:00',3.18),('15844','2013-07-29','14:35:00',3.12),('15844','2013-07-29','14:40:00',3.03),('15844','2013-07-29','14:45:00',2.9),('15844','2013-07-29','14:50:00',2.83),('15844','2013-07-29','14:55:00',2.73),('15844','2013-07-29','15:00:00',2.65),('15844','2013-07-29','15:05:00',2.57),('15844','2013-07-29','15:10:00',2.41),('15844','2013-07-29','15:15:00',2.4),('15844','2013-07-29','15:20:00',2.3),('15844','2013-07-29','15:25:00',2.23),('15844','2013-07-29','15:30:00',2.18),('15844','2013-07-29','15:35:00',2.16),('15844','2013-07-29','15:40:00',1.92),('15844','2013-07-29','15:45:00',1.57),('15844','2013-07-29','15:50:00',1.61),('15844','2013-07-29','15:55:00',1.4),('15844','2013-07-29','16:00:00',1.87),('15844','2013-07-29','16:05:00',2.05),('15844','2013-07-29','16:10:00',1.62),('15844','2013-07-29','16:15:00',1.46),('15844','2013-07-29','16:20:00',1.09),('15844','2013-07-29','16:25:00',1.53),('15844','2013-07-29','16:30:00',1.41),('15844','2013-07-29','16:35:00',1.31),('15844','2013-07-29','16:40:00',1.32),('15844','2013-07-29','16:45:00',1.21),('15844','2013-07-28','08:40:00',1.01),('15844','2013-07-28','08:45:00',1.12),('15844','2013-07-28','08:50:00',1.22),('15844','2013-07-28','08:55:00',1.24),('15844','2013-07-28','09:00:00',1.27),('15844','2013-07-28','09:05:00',1.3),('15844','2013-07-28','09:10:00',1.43),('15844','2013-07-28','09:15:00',1.62),('15844','2013-07-28','09:20:00',1.71),('15844','2013-07-28','09:25:00',1.79),('15844','2013-07-28','09:30:00',1.88),('15844','2013-07-28','09:35:00',1.97),('15844','2013-07-28','09:40:00',2.05),('15844','2013-07-28','09:45:00',2.17),('15844','2013-07-28','09:50:00',2.27),('15844','2013-07-28','09:55:00',2.37),('15844','2013-07-28','10:00:00',2.54),('15844','2013-07-28','10:05:00',2.64),('15844','2013-07-28','10:10:00',2.79),('15844','2013-07-28','10:15:00',2.91),('15844','2013-07-28','10:20:00',3.01),('15844','2013-07-28','10:25:00',3.08),('15844','2013-07-28','10:30:00',3.16),('15844','2013-07-28','10:35:00',3.27),('15844','2013-07-28','10:40:00',3.36),('15844','2013-07-28','10:45:00',3.46),('15844','2013-07-28','10:50:00',3.52),('15844','2013-07-28','10:55:00',3.53),('15844','2013-07-28','11:00:00',3.66),('15844','2013-07-28','11:05:00',3.65),('15844','2013-07-28','11:10:00',3.66),('15844','2013-07-28','11:15:00',3.73),('15844','2013-07-28','11:20:00',3.8),('15844','2013-07-28','11:25:00',3.8),('15844','2013-07-28','11:30:00',3.85),('15844','2013-07-28','11:35:00',3.86),('15844','2013-07-28','11:40:00',3.81),('15844','2013-07-28','11:45:00',3.87),('15844','2013-07-28','11:50:00',3.89),('15844','2013-07-28','11:55:00',4),('15844','2013-07-28','12:00:00',4.01),('15844','2013-07-28','12:05:00',4.01),('15844','2013-07-28','12:10:00',4.07),('15844','2013-07-28','12:15:00',4.04),('15844','2013-07-28','12:20:00',4.07),('15844','2013-07-28','12:25:00',4.07),('15844','2013-07-28','12:30:00',4.02),('15844','2013-07-28','12:35:00',4.02),('15844','2013-07-28','12:40:00',3.98),('15844','2013-07-28','12:45:00',3.98),('15844','2013-07-28','12:50:00',3.93),('15844','2013-07-28','12:55:00',4.03),('15844','2013-07-28','13:00:00',3.96),('15844','2013-07-28','13:05:00',3.95),('15844','2013-07-28','13:10:00',3.96),('15844','2013-07-28','13:15:00',3.93),('15844','2013-07-28','13:20:00',3.86),('15844','2013-07-28','13:25:00',3.89),('15844','2013-07-28','13:30:00',3.8),('15844','2013-07-28','13:35:00',3.8),('15844','2013-07-28','13:40:00',3.82),('15844','2013-07-28','13:45:00',3.77),('15844','2013-07-28','13:50:00',3.76),('15844','2013-07-28','13:55:00',3.7),('15844','2013-07-28','14:00:00',3.63),('15844','2013-07-28','14:05:00',3.57),('15844','2013-07-28','14:10:00',3.51),('15844','2013-07-28','14:15:00',3.43),('15844','2013-07-28','14:20:00',3.33),('15844','2013-07-28','14:25:00',3.24),('15844','2013-07-28','14:30:00',3.22),('15844','2013-07-28','14:35:00',3.11),('15844','2013-07-28','14:40:00',3.03),('15844','2013-07-28','14:45:00',2.93),('15844','2013-07-28','14:50:00',2.86),('15844','2013-07-28','14:55:00',2.74),('15844','2013-07-28','15:00:00',2.63),('15844','2013-07-28','15:05:00',2.53),('15844','2013-07-28','15:10:00',2.4),('15844','2013-07-28','15:15:00',2.33),('15844','2013-07-28','15:20:00',2.23),('15844','2013-07-28','15:25:00',2.15),('15844','2013-07-28','15:30:00',2.14),('15844','2013-07-28','15:35:00',2.09),('15844','2013-07-28','15:40:00',2.05),('15844','2013-07-28','15:45:00',1.98),('15844','2013-07-28','15:50:00',1.89),('15844','2013-07-28','15:55:00',1.8),('15844','2013-07-28','16:00:00',1.68),('15844','2013-07-28','16:05:00',1.58),('15844','2013-07-28','16:10:00',1.52),('15844','2013-07-28','16:15:00',1.43),('15844','2013-07-28','16:20:00',1.37),('15844','2013-07-28','16:25:00',1.31),('15844','2013-07-28','16:30:00',1.25),('15844','2013-07-28','16:35:00',1.2),('15844','2013-07-28','16:40:00',1.13),('15844','2013-07-28','16:45:00',1.08),('15844','2013-07-28','16:50:00',1.03),('15844','2013-07-27','08:40:00',1.03),('15844','2013-07-27','08:45:00',1.23),('15844','2013-07-27','08:50:00',1.33),('15844','2013-07-27','08:55:00',1.4),('15844','2013-07-27','09:00:00',1.42),('15844','2013-07-27','09:05:00',1.48),('15844','2013-07-27','09:10:00',1.54),('15844','2013-07-27','09:15:00',1.66),('15844','2013-07-27','09:20:00',1.77),('15844','2013-07-27','09:25:00',1.87),('15844','2013-07-27','09:30:00',1.94),('15844','2013-07-27','09:35:00',2.04),('15844','2013-07-27','09:40:00',2.17),('15844','2013-07-27','09:45:00',2.26),('15844','2013-07-27','09:50:00',2.35),('15844','2013-07-27','09:55:00',2.45),('15844','2013-07-27','10:00:00',2.62),('15844','2013-07-27','10:05:00',2.73),('15844','2013-07-27','10:10:00',2.81),('15844','2013-07-27','10:15:00',2.91),('15844','2013-07-27','10:20:00',2.99),('15844','2013-07-27','10:25:00',3.08),('15844','2013-07-27','10:30:00',3.21),('15844','2013-07-27','10:35:00',3.46),('15844','2013-07-27','10:40:00',3.55),('15844','2013-07-27','10:45:00',3.58),('15844','2013-07-27','10:50:00',3.64),('15844','2013-07-27','10:55:00',3.79),('15844','2013-07-27','11:00:00',3.85),('15844','2013-07-27','11:05:00',3.87),('15844','2013-07-27','11:10:00',3.89),('15844','2013-07-27','11:15:00',3.92),('15844','2013-07-27','11:20:00',3.96),('15844','2013-07-27','11:25:00',3.92),('15844','2013-07-27','11:30:00',3.98),('15844','2013-07-27','11:35:00',3.86),('15844','2013-07-27','11:40:00',3.96),('15844','2013-07-27','11:45:00',3.95),('15844','2013-07-27','11:50:00',3.99),('15844','2013-07-27','11:55:00',4.02),('15844','2013-07-27','12:00:00',4.03),('15844','2013-07-27','12:05:00',4.08),('15844','2013-07-27','12:10:00',4.04),('15844','2013-07-27','12:15:00',4.03),('15844','2013-07-27','12:20:00',4.06),('15844','2013-07-27','12:25:00',4.08),('15844','2013-07-27','12:30:00',3.92),('15844','2013-07-27','12:35:00',3.87),('15844','2013-07-27','12:40:00',3.95),('15844','2013-07-27','12:45:00',3.99),('15844','2013-07-27','12:50:00',3.93),('15844','2013-07-27','12:55:00',3.66),('15844','2013-07-27','13:00:00',3.94),('15844','2013-07-27','13:05:00',4.07),('15844','2013-07-27','13:10:00',3.95),('15844','2013-07-27','13:15:00',3.83),('15844','2013-07-27','13:20:00',3.87),('15844','2013-07-27','13:25:00',3.88),('15844','2013-07-27','13:30:00',3.9),('15844','2013-07-27','13:35:00',3.85),('15844','2013-07-27','13:40:00',3.85),('15844','2013-07-27','13:45:00',3.77),('15844','2013-07-27','13:50:00',3.69),('15844','2013-07-27','13:55:00',3.65),('15844','2013-07-27','14:00:00',3.6),('15844','2013-07-27','14:05:00',3.53),('15844','2013-07-27','14:10:00',3.48),('15844','2013-07-27','14:15:00',3.39),('15844','2013-07-27','14:20:00',3.34),('15844','2013-07-27','14:25:00',3.24),('15844','2013-07-27','14:30:00',3.14),('15844','2013-07-27','14:35:00',3.09),('15844','2013-07-27','14:40:00',2.99),('15844','2013-07-27','14:45:00',2.89),('15844','2013-07-27','14:50:00',2.79),('15844','2013-07-27','14:55:00',2.72),('15844','2013-07-27','15:00:00',2.66),('15844','2013-07-27','15:05:00',2.57),('15844','2013-07-27','15:10:00',2.49),('15844','2013-07-27','15:15:00',2.4),('15844','2013-07-27','15:20:00',2.31),('15844','2013-07-27','15:25:00',2.23),('15844','2013-07-27','15:30:00',2.17),('15844','2013-07-27','15:35:00',2.12),('15844','2013-07-27','15:40:00',2.07),('15844','2013-07-27','15:45:00',1.99),('15844','2013-07-27','15:50:00',1.9),('15844','2013-07-27','15:55:00',1.81),('15844','2013-07-27','16:00:00',1.69),('15844','2013-07-27','16:05:00',1.56),('15844','2013-07-27','16:10:00',1.49),('15844','2013-07-27','16:15:00',1.44),('15844','2013-07-27','16:20:00',1.38),('15844','2013-07-27','16:25:00',1.32),('15844','2013-07-27','16:30:00',1.26),('15844','2013-07-27','16:35:00',1.2),('15844','2013-07-27','16:40:00',1.14),('15844','2013-07-27','16:45:00',1.12),('15844','2013-07-27','16:50:00',1.05),('15844','2013-07-26','08:40:00',1.09),('15844','2013-07-26','08:45:00',1.36),('15844','2013-07-26','08:50:00',1.29),('15844','2013-07-26','08:55:00',1.36),('15844','2013-07-26','09:00:00',1.41),('15844','2013-07-26','09:05:00',1.43),('15844','2013-07-26','09:10:00',1.49),('15844','2013-07-26','09:15:00',1.58),('15844','2013-07-26','09:20:00',1.68),('15844','2013-07-26','09:25:00',1.74),('15844','2013-07-26','09:30:00',1.81),('15844','2013-07-26','09:35:00',2.02),('15844','2013-07-26','09:40:00',2.12),('15844','2013-07-26','09:45:00',2.2),('15844','2013-07-26','09:50:00',2.29),('15844','2013-07-26','09:55:00',2.41),('15844','2013-07-26','10:00:00',2.61),('15844','2013-07-26','10:05:00',2.67),('15844','2013-07-26','10:10:00',2.77),('15844','2013-07-26','10:15:00',2.88),('15844','2013-07-26','10:20:00',3.12),('15844','2013-07-26','10:25:00',3.19),('15844','2013-07-26','10:30:00',3.27),('15844','2013-07-26','10:35:00',3.36),('15844','2013-07-26','10:40:00',3.46),('15844','2013-07-26','10:45:00',3.54),('15844','2013-07-26','10:50:00',3.53),('15844','2013-07-26','10:55:00',3.57),('15844','2013-07-26','11:00:00',3.71),('15844','2013-07-26','11:05:00',3.76),('15844','2013-07-26','11:10:00',3.69),('15844','2013-07-26','11:15:00',3.59),('15844','2013-07-26','11:20:00',3.93),('15844','2013-07-26','11:25:00',3.73),('15844','2013-07-26','11:30:00',3.86),('15844','2013-07-26','11:35:00',4.04),('15844','2013-07-26','11:40:00',3.91),('15844','2013-07-26','11:45:00',4.06),('15844','2013-07-26','11:50:00',3.9),('15844','2013-07-26','11:55:00',1.35),('15844','2013-07-26','12:00:00',1.63),('15844','2013-07-26','12:05:00',3.54),('15844','2013-07-26','12:10:00',1.79),('15844','2013-07-26','12:15:00',3.83),('15844','2013-07-26','12:20:00',4.25),('15844','2013-07-26','12:25:00',3.68),('15844','2013-07-26','12:30:00',1.51),('15844','2013-07-26','12:35:00',2.03),('15844','2013-07-26','12:40:00',2.78),('15844','2013-07-26','12:45:00',1.89),('15844','2013-07-26','12:50:00',2.2),('15844','2013-07-26','12:55:00',1.28),('15844','2013-07-26','13:00:00',1.57),('15844','2013-07-26','13:05:00',2.94),('15844','2013-07-26','13:10:00',3.34),('15844','2013-07-26','13:15:00',4.3),('15844','2013-07-26','13:20:00',2.48),('15844','2013-07-26','13:25:00',3.87),('15844','2013-07-26','13:30:00',3.26),('15844','2013-07-26','13:35:00',3.56),('15844','2013-07-26','13:40:00',3.38),('15844','2013-07-26','13:45:00',3.84),('15844','2013-07-26','13:50:00',3.76),('15844','2013-07-26','13:55:00',2.96),('15844','2013-07-26','14:00:00',3.65),('15844','2013-07-26','14:05:00',3.47),('15844','2013-07-26','14:10:00',3.31),('15844','2013-07-26','14:15:00',3.51),('15844','2013-07-26','14:20:00',3.41),('15844','2013-07-26','14:25:00',3.3),('15844','2013-07-26','14:30:00',3.24),('15844','2013-07-26','14:35:00',3.15),('15844','2013-07-26','14:40:00',3.08),('15844','2013-07-26','14:45:00',3.01),('15844','2013-07-26','14:50:00',2.89),('15844','2013-07-26','14:55:00',2.78),('15844','2013-07-26','15:00:00',2.68),('15844','2013-07-26','15:05:00',2.6),('15844','2013-07-26','15:10:00',2.52),('15844','2013-07-26','15:15:00',2.45),('15844','2013-07-26','15:20:00',2.36),('15844','2013-07-26','15:25:00',2.27),('15844','2013-07-26','15:30:00',2.21),('15844','2013-07-26','15:35:00',2.17),('15844','2013-07-26','15:40:00',2.1),('15844','2013-07-26','15:45:00',2.03),('15844','2013-07-26','15:50:00',1.93),('15844','2013-07-26','15:55:00',1.83),('15844','2013-07-26','16:00:00',1.7),('15844','2013-07-26','16:05:00',1.59),('15844','2013-07-26','16:10:00',1.55),('15844','2013-07-26','16:15:00',1.46),('15844','2013-07-26','16:20:00',1.4),('15844','2013-07-26','16:25:00',1.35),('15844','2013-07-26','16:30:00',1.3),('15844','2013-07-26','16:35:00',1.24),('15844','2013-07-26','16:40:00',1.18),('15844','2013-07-26','16:45:00',1.16),('15844','2013-07-26','16:50:00',1.08),('15844','2013-07-25','08:40:00',1.06),('15844','2013-07-25','08:45:00',1.17),('15844','2013-07-25','08:50:00',1.26),('15844','2013-07-25','08:55:00',1.29),('15844','2013-07-25','09:00:00',1.32),('15844','2013-07-25','09:05:00',1.45),('15844','2013-07-25','09:10:00',1.39),('15844','2013-07-25','09:15:00',1.69),('15844','2013-07-25','09:20:00',1.57),('15844','2013-07-25','09:25:00',1.66),('15844','2013-07-25','09:30:00',1.21),('15844','2013-07-25','09:40:00',1.37),('15844','2013-07-25','09:45:00',2.14),('15844','2013-07-25','09:50:00',2.48),('15844','2013-07-25','09:55:00',2.67),('15844','2013-07-25','10:00:00',2.71),('15844','2013-07-25','10:05:00',1.6),('15844','2013-07-25','10:10:00',1.47),('15844','2013-07-25','10:15:00',1.37),('15844','2013-07-25','10:20:00',3.3),('15844','2013-07-25','10:25:00',3.36),('15844','2013-07-25','10:30:00',3.38),('15844','2013-07-25','10:35:00',3.64),('15844','2013-07-25','10:40:00',3.01),('15844','2013-07-25','10:45:00',3.29),('15844','2013-07-25','10:50:00',1.86),('15844','2013-07-25','10:55:00',2.27),('15844','2013-07-25','11:00:00',4.13),('15844','2013-07-25','11:05:00',3.66),('15844','2013-07-25','11:10:00',2.79),('15844','2013-07-25','11:15:00',3.15),('15844','2013-07-25','11:20:00',4.03),('15844','2013-07-25','11:25:00',3.91),('15844','2013-07-25','11:30:00',3.74),('15844','2013-07-25','11:35:00',4.13),('15844','2013-07-25','11:40:00',3.92),('15844','2013-07-25','11:45:00',3.6),('15844','2013-07-25','11:50:00',4),('15844','2013-07-25','11:55:00',3.79),('15844','2013-07-25','12:00:00',2.86),('15844','2013-07-25','12:05:00',1.04),('15844','2013-07-25','12:10:00',2.13),('15844','2013-07-25','12:15:00',3.29),('15844','2013-07-25','12:20:00',4.14),('15844','2013-07-25','12:25:00',4.26),('15844','2013-07-25','12:30:00',4.33),('15844','2013-07-25','12:35:00',4.3),('15844','2013-07-25','12:40:00',4.12),('15844','2013-07-25','12:45:00',4.09),('15844','2013-07-25','12:50:00',4.09),('15844','2013-07-25','12:55:00',4.01),('15844','2013-07-25','13:00:00',4.11),('15844','2013-07-25','13:05:00',4.06),('15844','2013-07-25','13:10:00',3.97),('15844','2013-07-25','13:15:00',4.08),('15844','2013-07-25','13:20:00',3.97),('15844','2013-07-25','13:25:00',4.03),('15844','2013-07-25','13:30:00',3.97),('15844','2013-07-25','13:35:00',3.95),('15844','2013-07-25','13:40:00',3.87),('15844','2013-07-25','13:45:00',3.88),('15844','2013-07-25','13:50:00',3.86),('15844','2013-07-25','13:55:00',3.83),('15844','2013-07-25','14:00:00',3.77),('15844','2013-07-25','14:05:00',3.7),('15844','2013-07-25','14:10:00',3.63),('15844','2013-07-25','14:15:00',3.55),('15844','2013-07-25','14:20:00',3.49),('15844','2013-07-25','14:25:00',3.41),('15844','2013-07-25','14:30:00',3.36),('15844','2013-07-25','14:35:00',3.28),('15844','2013-07-25','14:40:00',3.18),('15844','2013-07-25','14:45:00',3.09),('15844','2013-07-25','14:50:00',2.99),('15844','2013-07-25','14:55:00',2.92),('15844','2013-07-25','15:00:00',2.8),('15844','2013-07-25','15:05:00',2.7),('15844','2013-07-25','15:10:00',2.61),('15844','2013-07-25','15:15:00',2.55),('15844','2013-07-25','15:20:00',2.48),('15844','2013-07-25','15:25:00',2.4),('15844','2013-07-25','15:30:00',2.31),('15844','2013-07-25','15:35:00',2.22),('15844','2013-07-25','15:40:00',2.17),('15844','2013-07-25','15:45:00',2.09),('15844','2013-07-25','15:50:00',1.98),('15844','2013-07-25','15:55:00',1.89),('15844','2013-07-25','16:00:00',1.76),('15844','2013-07-25','16:05:00',1.65),('15844','2013-07-25','16:10:00',1.58),('15844','2013-07-25','16:15:00',1.51),('15844','2013-07-25','16:20:00',1.42),('15844','2013-07-25','16:25:00',1.37),('15844','2013-07-25','16:30:00',1.3),('15844','2013-07-25','16:35:00',1.25),('15844','2013-07-25','16:40:00',1.22),('15844','2013-07-25','16:45:00',1.18),('15844','2013-07-25','16:50:00',1.09),('15844','2013-07-24','08:30:00',1.25),('15844','2013-07-24','08:35:00',1.35),('15844','2013-07-24','08:40:00',1.21),('15844','2013-07-24','08:50:00',1.09),('15844','2013-07-24','08:55:00',1.16),('15844','2013-07-24','09:00:00',1.41),('15844','2013-07-24','09:05:00',1.47),('15844','2013-07-24','09:10:00',1.74),('15844','2013-07-24','09:15:00',1.63),('15844','2013-07-24','09:20:00',1.42),('15844','2013-07-24','09:45:00',1.12),('15844','2013-07-24','09:50:00',2.78),('15844','2013-07-24','09:55:00',1.72),('15844','2013-07-24','10:00:00',1.12),('15844','2013-07-24','10:05:00',1.62),('15844','2013-07-24','10:10:00',2.38),('15844','2013-07-24','10:15:00',2.12),('15844','2013-07-24','10:20:00',1.51),('15844','2013-07-24','10:25:00',3.4),('15844','2013-07-24','10:30:00',3.51),('15844','2013-07-24','10:35:00',3.68),('15844','2013-07-24','10:40:00',3.16),('15844','2013-07-24','10:45:00',3.12),('15844','2013-07-24','10:50:00',4.05),('15844','2013-07-24','10:55:00',3.7),('15844','2013-07-24','11:00:00',1.26),('15844','2013-07-24','11:05:00',3.73),('15844','2013-07-24','11:10:00',4.03),('15844','2013-07-24','11:15:00',3.71),('15844','2013-07-24','11:20:00',4.11),('15844','2013-07-24','11:25:00',4.26),('15844','2013-07-24','11:30:00',2.18),('15844','2013-07-24','11:35:00',2.55),('15844','2013-07-24','11:40:00',4.47),('15844','2013-07-24','11:45:00',4.31),('15844','2013-07-24','11:50:00',4.19),('15844','2013-07-24','11:55:00',4.31),('15844','2013-07-24','12:00:00',4.1),('15844','2013-07-24','12:05:00',2.99),('15844','2013-07-24','12:10:00',4.52),('15844','2013-07-24','12:15:00',4.1),('15844','2013-07-24','12:20:00',1.02),('15844','2013-07-24','12:25:00',1.12),('15844','2013-07-24','12:30:00',1.02),('15844','2013-07-24','12:35:00',1),('15844','2013-07-24','12:40:00',1.85),('15844','2013-07-24','12:45:00',1.61),('15844','2013-07-24','12:50:00',4.08),('15844','2013-07-24','12:55:00',4.32),('15844','2013-07-24','13:00:00',4.16),('15844','2013-07-24','13:05:00',4.2),('15844','2013-07-24','13:10:00',4.05),('15844','2013-07-24','13:15:00',4.03),('15844','2013-07-24','13:20:00',3.99),('15844','2013-07-24','13:25:00',3.81),('15844','2013-07-24','13:30:00',3.77),('15844','2013-07-24','13:35:00',3.92),('15844','2013-07-24','13:40:00',3.87),('15844','2013-07-24','13:45:00',3.96),('15844','2013-07-24','13:50:00',3.87),('15844','2013-07-24','13:55:00',3.79),('15844','2013-07-24','14:00:00',3.8),('15844','2013-07-24','14:05:00',3.74),('15844','2013-07-24','14:10:00',3.18),('15844','2013-07-24','14:15:00',3.57),('15844','2013-07-24','14:20:00',3.61),('15844','2013-07-24','14:25:00',3.41),('15844','2013-07-24','14:30:00',3.45),('15844','2013-07-24','14:35:00',3.38),('15844','2013-07-24','14:40:00',3.28),('15844','2013-07-24','14:45:00',3.21),('15844','2013-07-24','14:50:00',3.13),('15844','2013-07-24','14:55:00',3.03),('15844','2013-07-24','15:00:00',2.89),('15844','2013-07-24','15:05:00',2.8),('15844','2013-07-24','15:10:00',2.75),('15844','2013-07-24','15:15:00',2.6),('15844','2013-07-24','15:20:00',2.62),('15844','2013-07-24','15:25:00',2.48),('15844','2013-07-24','15:30:00',2.34),('15844','2013-07-24','15:35:00',2.41),('15844','2013-07-24','15:40:00',2.3),('15844','2013-07-24','15:45:00',2.14),('15844','2013-07-24','15:50:00',2.08),('15844','2013-07-24','15:55:00',2.04),('15844','2013-07-24','16:00:00',1.91),('15844','2013-07-24','16:05:00',1.75),('15844','2013-07-24','16:10:00',1.74),('15844','2013-07-24','16:15:00',1.66),('15844','2013-07-24','16:20:00',1.63),('15844','2013-07-24','16:25:00',1.58),('15844','2013-07-24','16:30:00',1.53),('15844','2013-07-24','16:35:00',1.52),('15844','2013-07-24','16:40:00',1.5),('15844','2013-07-24','16:45:00',1.52),('15844','2013-07-24','16:50:00',1.48),('15844','2013-07-24','16:55:00',1.34),('15844','2013-07-24','17:00:00',1.13),('15844','2013-07-23','08:40:00',1.07),('15844','2013-07-23','08:45:00',1.17),('15844','2013-07-23','08:50:00',1.37),('15844','2013-07-23','08:55:00',1.44),('15844','2013-07-23','09:00:00',1.47),('15844','2013-07-23','09:05:00',1.5),('15844','2013-07-23','09:10:00',1.54),('15844','2013-07-23','09:15:00',1.61),('15844','2013-07-23','09:20:00',1.77),('15844','2013-07-23','09:25:00',1.91),('15844','2013-07-23','09:30:00',2.01),('15844','2013-07-23','09:35:00',2.09),('15844','2013-07-23','09:40:00',2.2),('15844','2013-07-23','09:45:00',2.29),('15844','2013-07-23','09:50:00',2.34),('15844','2013-07-23','09:55:00',2.45),('15844','2013-07-23','10:00:00',2.6),('15844','2013-07-23','10:05:00',2.69),('15844','2013-07-23','10:10:00',2.75),('15844','2013-07-23','10:15:00',2.81),('15844','2013-07-23','10:20:00',2.9),('15844','2013-07-23','10:25:00',3.13),('15844','2013-07-23','10:30:00',3.22),('15844','2013-07-23','10:35:00',3.25),('15844','2013-07-23','10:40:00',3.34),('15844','2013-07-23','10:45:00',3.48),('15844','2013-07-23','10:50:00',3.56),('15844','2013-07-23','10:55:00',3.56),('15844','2013-07-23','11:00:00',3.81),('15844','2013-07-23','11:05:00',3.07),('15844','2013-07-23','11:15:00',2.14),('15844','2013-07-23','11:20:00',1.43),('15844','2013-07-23','11:30:00',1.88),('15844','2013-07-23','11:35:00',1.14),('15844','2013-07-23','11:40:00',2.14),('15844','2013-07-23','11:45:00',4.06),('15844','2013-07-23','11:50:00',4.04),('15844','2013-07-23','11:55:00',2.37),('15844','2013-07-23','12:00:00',1.3),('15844','2013-07-23','12:05:00',3.58),('15844','2013-07-23','12:10:00',1.52),('15844','2013-07-23','12:30:00',3.24),('15844','2013-07-23','12:35:00',4.24),('15844','2013-07-23','12:40:00',3.21),('15844','2013-07-23','12:45:00',2.78),('15844','2013-07-23','12:50:00',1.99),('15844','2013-07-23','12:55:00',1.01),('15844','2013-07-23','13:25:00',3.4),('15844','2013-07-23','13:30:00',4.28),('15844','2013-07-23','13:35:00',1.06),('15844','2013-07-23','13:40:00',2.85),('15844','2013-07-23','13:45:00',2.61),('15844','2013-07-23','13:50:00',4.04),('15844','2013-07-23','13:55:00',2.67),('15844','2013-07-23','14:00:00',2.2),('15844','2013-07-23','14:10:00',3.64),('15844','2013-07-23','14:15:00',2.75),('15844','2013-07-23','14:20:00',2.06),('15844','2013-07-23','14:25:00',2.97),('15844','2013-07-23','14:30:00',3.61),('15844','2013-07-23','14:35:00',3.52),('15844','2013-07-23','14:40:00',3.54),('15844','2013-07-23','14:45:00',3.4),('15844','2013-07-23','14:50:00',3.16),('15844','2013-07-23','14:55:00',3.08),('15844','2013-07-23','15:00:00',2.96),('15844','2013-07-23','15:05:00',2.85),('15844','2013-07-23','15:10:00',2.77),('15844','2013-07-23','15:15:00',2.65),('15844','2013-07-23','15:20:00',2.55),('15844','2013-07-23','15:25:00',2.44),('15844','2013-07-23','15:30:00',2.34),('15844','2013-07-23','15:35:00',2.23),('15844','2013-07-23','15:40:00',2.13),('15844','2013-07-23','15:45:00',2.06),('15844','2013-07-23','15:50:00',1.98),('15844','2013-07-23','15:55:00',1.91),('15844','2013-07-23','16:00:00',1.77),('15844','2013-07-23','16:05:00',1.63),('15844','2013-07-23','16:10:00',1.56),('15844','2013-07-23','16:15:00',1.51),('15844','2013-07-23','16:20:00',1.42),('15844','2013-07-23','16:25:00',1.38),('15844','2013-07-23','16:30:00',1.33),('15844','2013-07-23','16:35:00',1.29),('15844','2013-07-23','16:40:00',1.26),('15844','2013-07-23','16:45:00',1.21),('15844','2013-07-23','16:50:00',1.13),('15844','2013-07-22','08:40:00',1.07),('15844','2013-07-22','08:45:00',1.15),('15844','2013-07-22','08:50:00',1.31),('15844','2013-07-22','08:55:00',1.45),('15844','2013-07-22','09:00:00',1.48),('15844','2013-07-22','09:05:00',1.51),('15844','2013-07-22','09:10:00',1.57),('15844','2013-07-22','09:15:00',1.62),('15844','2013-07-22','09:20:00',1.74),('15844','2013-07-22','09:25:00',1.9),('15844','2013-07-22','09:30:00',2),('15844','2013-07-22','09:35:00',2.11),('15844','2013-07-22','09:40:00',2.21),('15844','2013-07-22','09:45:00',2.3),('15844','2013-07-22','09:50:00',2.41),('15844','2013-07-22','09:55:00',2.52),('15844','2013-07-22','10:00:00',2.63),('15844','2013-07-22','10:05:00',2.73),('15844','2013-07-22','10:10:00',2.83),('15844','2013-07-22','10:15:00',2.94),('15844','2013-07-22','10:20:00',3.01),('15844','2013-07-22','10:25:00',3.25),('15844','2013-07-22','10:30:00',3.41),('15844','2013-07-22','10:35:00',3.51),('15844','2013-07-22','10:40:00',3.6),('15844','2013-07-22','10:45:00',3.66),('15844','2013-07-22','10:50:00',3.78),('15844','2013-07-22','10:55:00',3.86),('15844','2013-07-22','11:00:00',3.9),('15844','2013-07-22','11:05:00',3.93),('15844','2013-07-22','11:10:00',3.98),('15844','2013-07-22','11:15:00',4.01),('15844','2013-07-22','11:20:00',4),('15844','2013-07-22','11:25:00',4.03),('15844','2013-07-22','11:30:00',4.07),('15844','2013-07-22','11:35:00',4.09),('15844','2013-07-22','11:40:00',4.11),('15844','2013-07-22','11:45:00',4.12),('15844','2013-07-22','11:50:00',4.09),('15844','2013-07-22','11:55:00',4.12),('15844','2013-07-22','12:00:00',4.12),('15844','2013-07-22','12:05:00',4.12),('15844','2013-07-22','12:10:00',4.13),('15844','2013-07-22','12:15:00',4.1),('15844','2013-07-22','12:20:00',4.12),('15844','2013-07-22','12:25:00',4.13),('15844','2013-07-22','12:30:00',4.14),('15844','2013-07-22','12:35:00',4.12),('15844','2013-07-22','12:40:00',4.11),('15844','2013-07-22','12:45:00',4.09),('15844','2013-07-22','12:50:00',4.07),('15844','2013-07-22','12:55:00',4.1),('15844','2013-07-22','13:00:00',4.07),('15844','2013-07-22','13:05:00',4.03),('15844','2013-07-22','13:10:00',4.03),('15844','2013-07-22','13:15:00',4),('15844','2013-07-22','13:20:00',3.96),('15844','2013-07-22','13:25:00',3.9),('15844','2013-07-22','13:30:00',3.88),('15844','2013-07-22','13:35:00',3.89),('15844','2013-07-22','13:40:00',3.83),('15844','2013-07-22','13:45:00',3.8),('15844','2013-07-22','13:50:00',3.74),('15844','2013-07-22','13:55:00',3.65),('15844','2013-07-22','14:00:00',3.61),('15844','2013-07-22','14:05:00',3.61),('15844','2013-07-22','14:10:00',3.55),('15844','2013-07-22','14:15:00',3.46),('15844','2013-07-22','14:20:00',3.41),('15844','2013-07-22','14:25:00',3.3),('15844','2013-07-22','14:30:00',3.25),('15844','2013-07-22','14:35:00',3.18),('15844','2013-07-22','14:40:00',3.18),('15844','2013-07-22','14:45:00',3.09),('15844','2013-07-22','14:50:00',2.99),('15844','2013-07-22','14:55:00',2.95),('15844','2013-07-22','15:00:00',2.29),('15844','2013-07-22','15:10:00',1.85),('15844','2013-07-22','15:15:00',2.85),('15844','2013-07-22','15:20:00',2.49),('15844','2013-07-22','15:25:00',1.83),('15844','2013-07-22','15:30:00',2.58),('15844','2013-07-22','15:35:00',2.59),('15844','2013-07-22','15:40:00',2.45),('15844','2013-07-22','15:45:00',1.77),('15844','2013-07-22','15:50:00',1.4),('15844','2013-07-22','15:55:00',2.16),('15844','2013-07-22','16:00:00',2.03),('15844','2013-07-22','16:05:00',1.88),('15844','2013-07-22','16:10:00',1.73),('15844','2013-07-22','16:15:00',1.63),('15844','2013-07-22','16:20:00',1.6),('15844','2013-07-22','16:25:00',1.58),('15844','2013-07-22','16:30:00',1.44),('15844','2013-07-22','16:35:00',1.39),('15844','2013-07-22','16:40:00',1.33),('15844','2013-07-22','16:45:00',1.28),('15844','2013-07-22','16:50:00',1.16),('15844','2013-07-22','16:55:00',1.05),('15844','2013-07-21','08:40:00',1.04),('15844','2013-07-21','08:45:00',1.13),('15844','2013-07-21','08:50:00',1.25),('15844','2013-07-21','08:55:00',1.34),('15844','2013-07-21','09:00:00',1.36),('15844','2013-07-21','09:05:00',1.39),('15844','2013-07-21','09:10:00',1.43),('15844','2013-07-21','09:15:00',1.5),('15844','2013-07-21','09:20:00',1.61),('15844','2013-07-21','09:25:00',1.83),('15844','2013-07-21','09:30:00',1.95),('15844','2013-07-21','09:35:00',2.06),('15844','2013-07-21','09:40:00',2.17),('15844','2013-07-21','09:45:00',2.25),('15844','2013-07-21','09:50:00',2.37),('15844','2013-07-21','09:55:00',2.51),('15844','2013-07-21','10:00:00',2.61),('15844','2013-07-21','10:05:00',2.71),('15844','2013-07-21','10:10:00',2.79),('15844','2013-07-21','10:15:00',2.88),('15844','2013-07-21','10:20:00',2.96),('15844','2013-07-21','10:25:00',3.22),('15844','2013-07-21','10:30:00',3.36),('15844','2013-07-21','10:35:00',3.47),('15844','2013-07-21','10:40:00',3.53),('15844','2013-07-21','10:45:00',3.61),('15844','2013-07-21','10:50:00',3.72),('15844','2013-07-21','10:55:00',3.84),('15844','2013-07-21','11:00:00',3.9),('15844','2013-07-21','11:05:00',3.93),('15844','2013-07-21','11:10:00',3.94),('15844','2013-07-21','11:15:00',4),('15844','2013-07-21','11:20:00',4.02),('15844','2013-07-21','11:25:00',4.07),('15844','2013-07-21','11:30:00',4),('15844','2013-07-21','11:35:00',3.99),('15844','2013-07-21','11:40:00',4.07),('15844','2013-07-21','11:45:00',4.07),('15844','2013-07-21','11:50:00',4.07),('15844','2013-07-21','11:55:00',4.09),('15844','2013-07-21','12:00:00',4.15),('15844','2013-07-21','12:05:00',4.21),('15844','2013-07-21','12:10:00',4.22),('15844','2013-07-21','12:15:00',4.34),('15844','2013-07-21','12:20:00',4.36),('15844','2013-07-21','12:25:00',2.99),('15844','2013-07-21','12:30:00',1.94),('15844','2013-07-21','12:35:00',2.13),('15844','2013-07-21','12:40:00',2.77),('15844','2013-07-21','12:45:00',2.03),('15844','2013-07-21','12:50:00',2.39),('15844','2013-07-21','12:55:00',2),('15844','2013-07-21','13:00:00',1.64),('15844','2013-07-21','13:05:00',1.65),('15844','2013-07-21','13:10:00',2.6),('15844','2013-07-21','13:15:00',2.52),('15844','2013-07-21','13:20:00',2.09),('15844','2013-07-21','13:25:00',3.35),('15844','2013-07-21','13:30:00',4.44),('15844','2013-07-21','13:35:00',4.29),('15844','2013-07-21','13:40:00',4.17),('15844','2013-07-21','13:45:00',3.24),('15844','2013-07-21','13:50:00',3.97),('15844','2013-07-21','13:55:00',3.14),('15844','2013-07-21','14:00:00',1.71),('15844','2013-07-21','14:05:00',2.07),('15844','2013-07-21','14:10:00',2.16),('15844','2013-07-21','14:15:00',2.29),('15844','2013-07-21','14:20:00',1.48),('15844','2013-07-21','14:25:00',1.44),('15844','2013-07-21','14:30:00',1.23),('15844','2013-07-21','14:35:00',1.03),('15844','2013-07-21','14:40:00',1.04),('15844','2013-07-21','14:45:00',1.16),('15844','2013-07-21','14:50:00',1.39),('15844','2013-07-21','14:55:00',1.58),('15844','2013-07-21','15:00:00',1.29),('15844','2013-07-21','15:05:00',1.24),('15844','2013-07-21','15:10:00',1.22),('15844','2013-07-21','15:15:00',1.68),('15844','2013-07-21','15:20:00',1.41),('15844','2013-07-21','15:25:00',1.34),('15844','2013-07-21','15:30:00',1.2),('15844','2013-07-21','15:35:00',1.26),('15844','2013-07-21','15:40:00',1.35),('15844','2013-07-21','15:45:00',1.48),('15844','2013-07-21','15:50:00',1.56),('15844','2013-07-21','15:55:00',1.73),('15844','2013-07-21','16:00:00',1.23),('15844','2013-07-21','17:05:00',1.05),('15844','2013-07-21','17:10:00',1.03),('15844','2014-04-07','08:30:00',1.02),('15844','2014-04-07','08:40:00',1.04),('15844','2014-04-07','08:45:00',1.03),('15844','2014-04-07','09:50:00',1.01),('15844','2014-04-07','09:55:00',1.01),('15844','2014-04-07','10:00:00',1.03),('15844','2014-04-07','10:05:00',1.02),('15844','2014-04-07','10:10:00',1.02),('15844','2014-04-07','10:15:00',1.03),('15844','2014-04-07','10:20:00',1.04),('15844','2014-04-07','10:25:00',1.03),('15844','2014-04-07','10:30:00',1.01),('15844','2014-04-07','10:35:00',1.03),('15844','2014-04-07','10:40:00',1.09),('15844','2014-04-07','10:45:00',1.18),('15844','2014-04-07','10:50:00',1.28),('15844','2014-04-07','10:55:00',1.29),('15844','2014-04-07','11:00:00',1.37),('15844','2014-04-07','11:05:00',1.41),('15844','2014-04-07','11:10:00',1.37),('15844','2014-04-07','11:15:00',1.41),('15844','2014-04-07','11:20:00',1.42),('15844','2014-04-07','11:25:00',1.4),('15844','2014-04-07','11:30:00',1.38),('15844','2014-04-07','11:35:00',1.39),('15844','2014-04-07','11:40:00',1.35),('15844','2014-04-07','11:45:00',1.34),('15844','2014-04-07','11:50:00',1.32),('15844','2014-04-07','11:55:00',1.36),('15844','2014-04-07','12:00:00',1.6),('15844','2014-04-07','12:05:00',2),('15844','2014-04-07','12:10:00',3.12),('15844','2014-04-07','12:15:00',3.71),('15844','2014-04-07','12:20:00',3.76),('15844','2014-04-07','12:25:00',2.63),('15844','2014-04-07','12:30:00',1.4),('15844','2014-04-07','12:35:00',2.51),('15844','2014-04-07','12:40:00',3.86),('15844','2014-04-07','12:45:00',3.77),('15844','2014-04-07','12:50:00',3.63),('15844','2014-04-07','12:55:00',3.56),('15844','2014-04-07','13:00:00',3.55),('15844','2014-04-07','13:05:00',3.6),('15844','2014-04-07','13:10:00',3.57),('15844','2014-04-07','13:15:00',3.53),('15844','2014-04-07','13:20:00',3.48),('15844','2014-04-07','13:25:00',3.39),('15844','2014-04-07','13:30:00',3.35),('15844','2014-04-07','13:35:00',3.38),('15844','2014-04-07','13:40:00',3.37),('15844','2014-04-07','13:45:00',3.3),('15844','2014-04-07','13:50:00',3.25),('15844','2014-04-07','13:55:00',3.15),('15844','2014-04-07','14:00:00',3.12),('15844','2014-04-07','14:05:00',3.07),('15844','2014-04-07','14:10:00',2.99),('15844','2014-04-07','14:15:00',2.99),('15844','2014-04-07','14:20:00',2.98),('15844','2014-04-07','14:25:00',2.88),('15844','2014-04-07','14:30:00',2.77),('15844','2014-04-07','14:35:00',2.71),('15844','2014-04-07','14:40:00',2.59),('15844','2014-04-07','14:45:00',2.47),('15844','2014-04-07','14:50:00',2.36),('15844','2014-04-07','14:55:00',2.32),('15844','2014-04-07','15:00:00',2.27),('15844','2014-04-07','15:05:00',2.15),('15844','2014-04-07','15:10:00',2.11),('15844','2014-04-07','15:15:00',2.02),('15844','2014-04-07','15:20:00',1.94),('15844','2014-04-07','15:25:00',1.84),('15844','2014-04-07','15:30:00',1.77),('15844','2014-04-07','15:35:00',1.67),('15844','2014-04-07','15:40:00',1.59),('15844','2014-04-07','15:45:00',1.5),('15844','2014-04-07','15:50:00',1.44),('15844','2014-04-07','15:55:00',1.43),('15844','2014-04-07','16:00:00',1.42),('15844','2014-04-07','16:05:00',1.32),('15844','2014-04-07','16:10:00',1.25),('15844','2014-04-07','16:15:00',1.2),('15844','2013-07-20','08:35:00',1.04),('15844','2013-07-20','08:40:00',1.11),('15844','2013-07-20','08:45:00',1.19),('15844','2013-07-20','08:50:00',1.32),('15844','2013-07-20','08:55:00',1.5),('15844','2013-07-20','09:00:00',1.56),('15844','2013-07-20','09:05:00',1.67),('15844','2013-07-20','09:10:00',1.74),('15844','2013-07-20','09:15:00',1.77),('15844','2013-07-20','09:20:00',1.77),('15844','2013-07-20','09:25:00',1.84),('15844','2013-07-20','09:30:00',1.88),('15844','2013-07-20','09:35:00',2.06),('15844','2013-07-20','09:40:00',2.31),('15844','2013-07-20','09:45:00',2.34),('15844','2013-07-20','09:50:00',2.38),('15844','2013-07-20','09:55:00',2.57),('15844','2013-07-20','10:00:00',2.66),('15844','2013-07-20','10:05:00',2.81),('15844','2013-07-20','10:10:00',2.89),('15844','2013-07-20','10:15:00',2.99),('15844','2013-07-20','10:20:00',3.06),('15844','2013-07-20','10:25:00',3.14),('15844','2013-07-20','10:30:00',3.43),('15844','2013-07-20','10:35:00',3.54),('15844','2013-07-20','10:40:00',3.64),('15844','2013-07-20','10:45:00',3.72),('15844','2013-07-20','10:50:00',3.82),('15844','2013-07-20','10:55:00',3.96),('15844','2013-07-20','11:00:00',3.99),('15844','2013-07-20','11:05:00',4.02),('15844','2013-07-20','11:10:00',4.04),('15844','2013-07-20','11:15:00',4.06),('15844','2013-07-20','11:20:00',4.1),('15844','2013-07-20','11:25:00',4.18),('15844','2013-07-20','11:30:00',4.11),('15844','2013-07-20','11:35:00',4.17),('15844','2013-07-20','11:40:00',4.19),('15844','2013-07-20','11:45:00',4.16),('15844','2013-07-20','11:50:00',4.1),('15844','2013-07-20','11:55:00',4.14),('15844','2013-07-20','12:00:00',4.14),('15844','2013-07-20','12:05:00',4.16),('15844','2013-07-20','12:10:00',4.17),('15844','2013-07-20','12:15:00',3.92),('15844','2013-07-20','12:20:00',4.19),('15844','2013-07-20','12:25:00',4.11),('15844','2013-07-20','12:30:00',4.25),('15844','2013-07-20','12:35:00',4.25),('15844','2013-07-20','12:40:00',4.25),('15844','2013-07-20','12:45:00',4.18),('15844','2013-07-20','12:50:00',4.14),('15844','2013-07-20','12:55:00',4.19),('15844','2013-07-20','13:00:00',4.22),('15844','2013-07-20','13:05:00',4.13),('15844','2013-07-20','13:10:00',4.23),('15844','2013-07-20','13:15:00',4.22),('15844','2013-07-20','13:20:00',4.13),('15844','2013-07-20','13:25:00',4.12),('15844','2013-07-20','13:30:00',4.12),('15844','2013-07-20','13:35:00',4.06),('15844','2013-07-20','13:40:00',4.02),('15844','2013-07-20','13:45:00',4.05),('15844','2013-07-20','13:50:00',4.01),('15844','2013-07-20','13:55:00',3.88),('15844','2013-07-20','14:00:00',3.74),('15844','2013-07-20','14:05:00',3.75),('15844','2013-07-20','14:10:00',3.65),('15844','2013-07-20','14:15:00',3.67),('15844','2013-07-20','14:20:00',3.53),('15844','2013-07-20','14:25:00',3.47),('15844','2013-07-20','14:30:00',3.41),('15844','2013-07-20','14:35:00',3.33),('15844','2013-07-20','14:40:00',3.22),('15844','2013-07-20','14:45:00',3.2),('15844','2013-07-20','14:50:00',3.15),('15844','2013-07-20','14:55:00',3.08),('15844','2013-07-20','15:00:00',3),('15844','2013-07-20','15:05:00',2.8),('15844','2013-07-20','15:10:00',2.85),('15844','2013-07-20','15:15:00',2.72),('15844','2013-07-20','15:20:00',2.62),('15844','2013-07-20','15:25:00',2.51),('15844','2013-07-20','15:30:00',2.37),('15844','2013-07-20','15:35:00',2.32),('15844','2013-07-20','15:40:00',2.25),('15844','2013-07-20','15:45:00',2.19),('15844','2013-07-20','15:50:00',2.09),('15844','2013-07-20','15:55:00',2),('15844','2013-07-20','16:00:00',1.88),('15844','2013-07-20','16:05:00',1.74),('15844','2013-07-20','16:10:00',1.65),('15844','2013-07-20','16:15:00',1.58),('15844','2013-07-20','16:20:00',1.51),('15844','2013-07-20','16:25:00',1.46),('15844','2013-07-20','16:30:00',1.43),('15844','2013-07-20','16:35:00',1.39),('15844','2013-07-20','16:40:00',1.34),('15844','2013-07-20','16:45:00',1.27),('15844','2013-07-20','16:50:00',1.18),('15844','2013-07-20','16:55:00',1.06),('15844','2013-07-19','08:35:00',1),('15844','2013-07-19','08:40:00',1.1),('15844','2013-07-19','08:45:00',1.16),('15844','2013-07-19','08:50:00',1.23),('15844','2013-07-19','08:55:00',1.33),('15844','2013-07-19','09:00:00',1.38),('15844','2013-07-19','09:05:00',1.39),('15844','2013-07-19','09:10:00',1.43),('15844','2013-07-19','09:15:00',1.53),('15844','2013-07-19','09:20:00',1.62),('15844','2013-07-19','09:25:00',1.72),('15844','2013-07-19','09:30:00',1.89),('15844','2013-07-19','09:35:00',2.02),('15844','2013-07-19','09:40:00',2.1),('15844','2013-07-19','09:45:00',2.18),('15844','2013-07-19','09:50:00',2.3),('15844','2013-07-19','09:55:00',2.43),('15844','2013-07-19','10:00:00',2.52),('15844','2013-07-19','10:05:00',2.64),('15844','2013-07-19','10:10:00',2.72),('15844','2013-07-19','10:15:00',2.88),('15844','2013-07-19','10:20:00',2.88),('15844','2013-07-19','10:25:00',3.16),('15844','2013-07-19','10:30:00',3.21),('15844','2013-07-19','10:35:00',3.25),('15844','2013-07-19','10:40:00',3.35),('15844','2013-07-19','10:45:00',3.4),('15844','2013-07-19','10:50:00',3.43),('15844','2013-07-19','10:55:00',3.57),('15844','2013-07-19','11:00:00',3.63),('15844','2013-07-19','11:05:00',3.64),('15844','2013-07-19','11:10:00',3.71),('15844','2013-07-19','11:15:00',3.73),('15844','2013-07-19','11:20:00',3.8),('15844','2013-07-19','11:25:00',3.79),('15844','2013-07-19','11:30:00',3.78),('15844','2013-07-19','11:35:00',3.88),('15844','2013-07-19','11:40:00',3.95),('15844','2013-07-19','11:45:00',3.52),('15844','2013-07-19','11:50:00',3.92),('15844','2013-07-19','11:55:00',4.06),('15844','2013-07-19','12:00:00',3.73),('15844','2013-07-19','12:05:00',4.11),('15844','2013-07-19','12:10:00',4.23),('15844','2013-07-19','12:15:00',4.17),('15844','2013-07-19','12:20:00',4.17),('15844','2013-07-19','12:25:00',4.07),('15844','2013-07-19','12:30:00',4.08),('15844','2013-07-19','12:35:00',4.05),('15844','2013-07-19','12:40:00',4.14),('15844','2013-07-19','12:45:00',4.09),('15844','2013-07-19','12:50:00',4.12),('15844','2013-07-19','12:55:00',4),('15844','2013-07-19','13:00:00',4.21),('15844','2013-07-19','13:05:00',4.09),('15844','2013-07-19','13:10:00',3.86),('15844','2013-07-19','13:15:00',3.93),('15844','2013-07-19','13:20:00',3.97),('15844','2013-07-19','13:25:00',4.06),('15844','2013-07-19','13:30:00',4.04),('15844','2013-07-19','13:35:00',3.98),('15844','2013-07-19','13:40:00',3.96),('15844','2013-07-19','13:45:00',3.64),('15844','2013-07-19','13:50:00',3.88),('15844','2013-07-19','13:55:00',3.82),('15844','2013-07-19','14:00:00',3.79),('15844','2013-07-19','14:05:00',3.74),('15844','2013-07-19','14:10:00',3.4),('15844','2013-07-19','14:15:00',3.64),('15844','2013-07-19','14:20:00',3.58),('15844','2013-07-19','14:25:00',3.52),('15844','2013-07-19','14:30:00',3.46),('15844','2013-07-19','14:35:00',3.39),('15844','2013-07-19','14:40:00',3.05),('15844','2013-07-19','14:45:00',3.25),('15844','2013-07-19','14:50:00',3.16),('15844','2013-07-19','14:55:00',2.91),('15844','2013-07-19','15:00:00',2.68),('15844','2013-07-19','15:05:00',3),('15844','2013-07-19','15:10:00',1.18),('15844','2013-07-19','15:15:00',2.72),('15844','2013-07-19','15:20:00',2.44),('15844','2013-07-19','15:25:00',1.96),('15844','2013-07-19','15:30:00',2.42),('15844','2013-07-19','15:35:00',2.54),('15844','2013-07-19','15:40:00',2.56),('15844','2013-07-19','15:45:00',2.33),('15844','2013-07-19','15:50:00',2.22),('15844','2013-07-19','15:55:00',2.1),('15844','2013-07-19','16:00:00',1.98),('15844','2013-07-19','16:05:00',1.84),('15844','2013-07-19','16:10:00',1.75),('15844','2013-07-19','16:15:00',1.58),('15844','2013-07-19','16:20:00',1.62),('15844','2013-07-19','16:25:00',1.6),('15844','2013-07-19','16:30:00',1.6),('15844','2013-07-19','16:35:00',1.56),('15844','2013-07-19','16:40:00',1.51),('15844','2013-07-19','16:45:00',1.49),('15844','2013-07-19','16:50:00',1.48),('15844','2013-07-19','16:55:00',1.36),('15844','2013-07-19','17:00:00',1.2),('15844','2013-07-19','17:05:00',1.05),('15844','2013-07-19','17:35:00',1.04),('15844','2013-07-18','08:35:00',1.02),('15844','2013-07-18','08:40:00',1.09),('15844','2013-07-18','08:45:00',1.16),('15844','2013-07-18','08:50:00',1.24),('15844','2013-07-18','08:55:00',1.35),('15844','2013-07-18','09:00:00',1.52),('15844','2013-07-18','09:05:00',1.57),('15844','2013-07-18','09:10:00',1.62),('15844','2013-07-18','09:15:00',1.65),('15844','2013-07-18','09:20:00',1.7),('15844','2013-07-18','09:25:00',1.85),('15844','2013-07-18','09:30:00',2.01),('15844','2013-07-18','09:35:00',2.15),('15844','2013-07-18','09:40:00',2.26),('15844','2013-07-18','09:45:00',2.33),('15844','2013-07-18','09:50:00',2.43),('15844','2013-07-18','09:55:00',2.58),('15844','2013-07-18','10:00:00',2.68),('15844','2013-07-18','10:05:00',2.8),('15844','2013-07-18','10:10:00',2.9),('15844','2013-07-18','10:15:00',2.97),('15844','2013-07-18','10:20:00',3.04),('15844','2013-07-18','10:25:00',3.25),('15844','2013-07-18','10:30:00',3.48),('15844','2013-07-18','10:35:00',3.57),('15844','2013-07-18','10:40:00',3.63),('15844','2013-07-18','10:45:00',3.69),('15844','2013-07-18','10:50:00',3.78),('15844','2013-07-18','10:55:00',3.88),('15844','2013-07-18','11:00:00',3.94),('15844','2013-07-18','11:05:00',3.95),('15844','2013-07-18','11:10:00',3.97),('15844','2013-07-18','11:15:00',4.02),('15844','2013-07-18','11:20:00',4.02),('15844','2013-07-18','11:25:00',4),('15844','2013-07-18','11:30:00',4.09),('15844','2013-07-18','11:35:00',4.14),('15844','2013-07-18','11:40:00',4.11),('15844','2013-07-18','11:45:00',4.11),('15844','2013-07-18','11:50:00',4.13),('15844','2013-07-18','11:55:00',4.13),('15844','2013-07-18','12:00:00',4.16),('15844','2013-07-18','12:05:00',4.17),('15844','2013-07-18','12:10:00',4.17),('15844','2013-07-18','12:15:00',4.14),('15844','2013-07-18','12:20:00',4.16),('15844','2013-07-18','12:25:00',4.16),('15844','2013-07-18','12:30:00',4.12),('15844','2013-07-18','12:35:00',4.13),('15844','2013-07-18','12:40:00',4.14),('15844','2013-07-18','12:45:00',4.09),('15844','2013-07-18','12:50:00',4.07),('15844','2013-07-18','12:55:00',4.12),('15844','2013-07-18','13:00:00',4.12),('15844','2013-07-18','13:05:00',4.05),('15844','2013-07-18','13:10:00',3.94),('15844','2013-07-18','13:15:00',3.99),('15844','2013-07-18','13:20:00',4.04),('15844','2013-07-18','13:25:00',4.12),('15844','2013-07-18','13:30:00',4.01),('15844','2013-07-18','13:35:00',3.93),('15844','2013-07-18','13:40:00',3.91),('15844','2013-07-18','13:45:00',3.99),('15844','2013-07-18','13:50:00',3.94),('15844','2013-07-18','13:55:00',3.84),('15844','2013-07-18','14:00:00',3.79),('15844','2013-07-18','14:05:00',3.72),('15844','2013-07-18','14:10:00',3.65),('15844','2013-07-18','14:15:00',3.63),('15844','2013-07-18','14:20:00',3.54),('15844','2013-07-18','14:25:00',3.44),('15844','2013-07-18','14:30:00',3.43),('15844','2013-07-18','14:35:00',3.38),('15844','2013-07-18','14:40:00',3.33),('15844','2013-07-18','14:45:00',3.24),('15844','2013-07-18','14:50:00',3.15),('15844','2013-07-18','14:55:00',3.08),('15844','2013-07-18','15:00:00',3.01),('15844','2013-07-18','15:05:00',2.92),('15844','2013-07-18','15:10:00',2.81),('15844','2013-07-18','15:15:00',2.7),('15844','2013-07-18','15:20:00',2.61),('15844','2013-07-18','15:25:00',2.47),('15844','2013-07-18','15:30:00',2.34),('15844','2013-07-18','15:35:00',2.26),('15844','2013-07-18','15:40:00',2.18),('15844','2013-07-18','15:45:00',2.13),('15844','2013-07-18','15:50:00',2.05),('15844','2013-07-18','15:55:00',1.97),('15844','2013-07-18','16:00:00',1.83),('15844','2013-07-18','16:05:00',1.71),('15844','2013-07-18','16:10:00',1.61),('15844','2013-07-18','16:15:00',1.56),('15844','2013-07-18','16:20:00',1.48),('15844','2013-07-18','16:25:00',1.45),('15844','2013-07-18','16:30:00',1.4),('15844','2013-07-18','16:35:00',1.37),('15844','2013-07-18','16:40:00',1.32),('15844','2013-07-18','16:45:00',1.26),('15844','2013-07-18','16:50:00',1.18),('15844','2013-07-18','16:55:00',1.08),('15844','2013-07-17','08:30:00',1.04),('15844','2013-07-17','08:35:00',1.12),('15844','2013-07-17','08:40:00',1.19),('15844','2013-07-17','08:45:00',1.25),('15844','2013-07-17','08:50:00',1.28),('15844','2013-07-17','08:55:00',1.4),('15844','2013-07-17','09:00:00',1.55),('15844','2013-07-17','09:05:00',1.62),('15844','2013-07-17','09:10:00',1.66),('15844','2013-07-17','09:15:00',1.7),('15844','2013-07-17','09:20:00',1.76),('15844','2013-07-17','09:25:00',1.86),('15844','2013-07-17','09:30:00',2.04),('15844','2013-07-17','09:35:00',2.22),('15844','2013-07-17','09:40:00',2.33),('15844','2013-07-17','09:45:00',2.42),('15844','2013-07-17','09:50:00',2.54),('15844','2013-07-17','09:55:00',2.7),('15844','2013-07-17','10:00:00',2.78),('15844','2013-07-17','10:05:00',2.85),('15844','2013-07-17','10:10:00',2.96),('15844','2013-07-17','10:15:00',3.13),('15844','2013-07-17','10:20:00',3.28),('15844','2013-07-17','10:25:00',3.4),('15844','2013-07-17','10:30:00',3.48),('15844','2013-07-17','10:35:00',3.6),('15844','2013-07-17','10:40:00',3.7),('15844','2013-07-17','10:45:00',3.78),('15844','2013-07-17','10:50:00',3.91),('15844','2013-07-17','10:55:00',4.02),('15844','2013-07-17','11:00:00',4.09),('15844','2013-07-17','11:05:00',4.14),('15844','2013-07-17','11:10:00',4.16),('15844','2013-07-17','11:15:00',4.17),('15844','2013-07-17','11:20:00',4.24),('15844','2013-07-17','11:25:00',4.22),('15844','2013-07-17','11:30:00',4.22),('15844','2013-07-17','11:35:00',4.27),('15844','2013-07-17','11:40:00',4.26),('15844','2013-07-17','11:45:00',4.26),('15844','2013-07-17','11:50:00',4.28),('15844','2013-07-17','11:55:00',4.26),('15844','2013-07-17','12:00:00',4.27),('15844','2013-07-17','12:05:00',4.29),('15844','2013-07-17','12:10:00',4.33),('15844','2013-07-17','12:15:00',4.31),('15844','2013-07-17','12:20:00',4.28),('15844','2013-07-17','12:25:00',4.25),('15844','2013-07-17','12:30:00',4.24),('15844','2013-07-17','12:35:00',4.27),('15844','2013-07-17','12:40:00',4.23),('15844','2013-07-17','12:45:00',4.25),('15844','2013-07-17','12:50:00',4.22),('15844','2013-07-17','12:55:00',4.19),('15844','2013-07-17','13:00:00',4.14),('15844','2013-07-17','13:05:00',4.13),('15844','2013-07-17','13:10:00',4.13),('15844','2013-07-17','13:15:00',4.03),('15844','2013-07-17','13:20:00',4.03),('15844','2013-07-17','13:25:00',3.99),('15844','2013-07-17','13:30:00',4.01),('15844','2013-07-17','13:35:00',3.95),('15844','2013-07-17','13:40:00',3.86),('15844','2013-07-17','13:45:00',3.92),('15844','2013-07-17','13:50:00',3.88),('15844','2013-07-17','13:55:00',3.88),('15844','2013-07-17','14:00:00',3.84),('15844','2013-07-17','14:05:00',3.8),('15844','2013-07-17','14:10:00',3.72),('15844','2013-07-17','14:15:00',3.68),('15844','2013-07-17','14:20:00',3.62),('15844','2013-07-17','14:25:00',3.6),('15844','2013-07-17','14:30:00',3.53),('15844','2013-07-17','14:35:00',3.37),('15844','2013-07-17','14:40:00',3.41),('15844','2013-07-17','14:45:00',3.35),('15844','2013-07-17','14:50:00',3.24),('15844','2013-07-17','14:55:00',3.15),('15844','2013-07-17','15:00:00',3.15),('15844','2013-07-17','15:05:00',3.08),('15844','2013-07-17','15:10:00',2.96),('15844','2013-07-17','15:15:00',2.84),('15844','2013-07-17','15:20:00',2.75),('15844','2013-07-17','15:25:00',2.57),('15844','2013-07-17','15:30:00',2.47),('15844','2013-07-17','15:35:00',2.7),('15844','2013-07-17','15:40:00',1.62),('15844','2013-07-17','15:45:00',1.22),('15844','2013-07-17','15:50:00',1.62),('15844','2013-07-17','15:55:00',2.17),('15844','2013-07-17','16:00:00',2.13),('15844','2013-07-17','16:05:00',2.1),('15844','2013-07-17','16:10:00',1.68),('15844','2013-07-17','16:15:00',1.04),('15844','2013-07-17','16:25:00',1.46),('15844','2013-07-17','16:30:00',1.46),('15844','2013-07-17','16:35:00',1.42),('15844','2013-07-17','16:40:00',1.36),('15844','2013-07-17','16:45:00',1.28),('15844','2013-07-17','16:50:00',1.2),('15844','2013-07-17','16:55:00',1.09),('15844','2013-07-16','08:35:00',1.06),('15844','2013-07-16','08:40:00',1.12),('15844','2013-07-16','08:45:00',1.19),('15844','2013-07-16','08:50:00',1.25),('15844','2013-07-16','08:55:00',1.34),('15844','2013-07-16','09:00:00',1.39),('15844','2013-07-16','09:05:00',1.43),('15844','2013-07-16','09:10:00',1.48),('15844','2013-07-16','09:15:00',1.57),('15844','2013-07-16','09:20:00',1.68),('15844','2013-07-16','09:25:00',1.8),('15844','2013-07-16','09:30:00',1.97),('15844','2013-07-16','09:35:00',2.15),('15844','2013-07-16','09:40:00',2.25),('15844','2013-07-16','09:45:00',2.35),('15844','2013-07-16','09:50:00',2.46),('15844','2013-07-16','09:55:00',2.62),('15844','2013-07-16','10:00:00',2.71),('15844','2013-07-16','10:05:00',2.8),('15844','2013-07-16','10:10:00',2.88),('15844','2013-07-16','10:15:00',2.94),('15844','2013-07-16','10:20:00',3.05),('15844','2013-07-16','10:25:00',3.29),('15844','2013-07-16','10:30:00',3.42),('15844','2013-07-16','10:35:00',3.52),('15844','2013-07-16','10:40:00',3.6),('15844','2013-07-16','10:45:00',3.73),('15844','2013-07-16','10:50:00',3.81),('15844','2013-07-16','10:55:00',3.93),('15844','2013-07-16','11:00:00',3.99),('15844','2013-07-16','11:05:00',4.03),('15844','2013-07-16','11:10:00',4.06),('15844','2013-07-16','11:15:00',4.06),('15844','2013-07-16','11:20:00',4.08),('15844','2013-07-16','11:25:00',4.13),('15844','2013-07-16','11:30:00',4.11),('15844','2013-07-16','11:35:00',4.13),('15844','2013-07-16','11:40:00',4.15),('15844','2013-07-16','11:45:00',4.2),('15844','2013-07-16','11:50:00',4.2),('15844','2013-07-16','11:55:00',4.21),('15844','2013-07-16','12:00:00',4.22),('15844','2013-07-16','12:05:00',4.24),('15844','2013-07-16','12:10:00',4.27),('15844','2013-07-16','12:15:00',4.28),('15844','2013-07-16','12:20:00',4.26),('15844','2013-07-16','12:25:00',4.25),('15844','2013-07-16','12:30:00',4.22),('15844','2013-07-16','12:35:00',4.26),('15844','2013-07-16','12:40:00',4.24),('15844','2013-07-16','12:45:00',4.22),('15844','2013-07-16','12:50:00',4.19),('15844','2013-07-16','12:55:00',4.18),('15844','2013-07-16','13:00:00',4.15),('15844','2013-07-16','13:05:00',4.11),('15844','2013-07-16','13:10:00',4.1),('15844','2013-07-16','13:15:00',4.08),('15844','2013-07-16','13:20:00',4.07),('15844','2013-07-16','13:25:00',4),('15844','2013-07-16','13:30:00',4.03),('15844','2013-07-16','13:35:00',4),('15844','2013-07-16','13:40:00',3.97),('15844','2013-07-16','13:45:00',3.95),('15844','2013-07-16','13:50:00',3.99),('15844','2013-07-16','13:55:00',3.86),('15844','2013-07-16','14:00:00',3.78),('15844','2013-07-16','14:05:00',3.65),('15844','2013-07-16','14:10:00',3.67),('15844','2013-07-16','14:15:00',3.61),('15844','2013-07-16','14:20:00',3.59),('15844','2013-07-16','14:25:00',3.54),('15844','2013-07-16','14:30:00',3.44),('15844','2013-07-16','14:35:00',3.35),('15844','2013-07-16','14:40:00',3.12),('15844','2013-07-16','14:45:00',3.29),('15844','2013-07-16','14:50:00',3.21),('15844','2013-07-16','14:55:00',3.09),('15844','2013-07-16','15:00:00',2.98),('15844','2013-07-16','15:05:00',1.78),('15844','2013-07-16','15:10:00',2.83),('15844','2013-07-16','15:15:00',2.53),('15844','2013-07-16','15:20:00',2.66),('15844','2013-07-16','15:25:00',2.55),('15844','2013-07-16','15:30:00',2.49),('15844','2013-07-16','15:35:00',2.44),('15844','2013-07-16','15:40:00',2.38),('15844','2013-07-16','15:45:00',2.23),('15844','2013-07-16','15:50:00',2.11),('15844','2013-07-16','15:55:00',2),('15844','2013-07-16','16:00:00',1.92),('15844','2013-07-16','16:05:00',1.84),('15844','2013-07-16','16:10:00',1.56),('15844','2013-07-16','16:20:00',1.07),('15844','2013-07-16','16:25:00',1.75),('15844','2013-07-16','16:30:00',1.78),('15844','2013-07-16','16:35:00',1.83),('15844','2013-07-16','16:40:00',1.84),('15844','2013-07-16','16:45:00',1.74),('15844','2013-07-16','16:50:00',1.61),('15844','2013-07-16','16:55:00',1.46),('15844','2013-07-16','17:00:00',1.25),('15844','2013-07-16','17:05:00',1),('15844','2013-07-15','08:30:00',1.06),('15844','2013-07-15','08:35:00',1.15),('15844','2013-07-15','08:40:00',1.22),('15844','2013-07-15','08:45:00',1.26),('15844','2013-07-15','08:50:00',1.29),('15844','2013-07-15','08:55:00',1.36),('15844','2013-07-15','09:00:00',1.46),('15844','2013-07-15','09:05:00',1.56),('15844','2013-07-15','09:10:00',1.68),('15844','2013-07-15','09:15:00',1.71),('15844','2013-07-15','09:20:00',1.76),('15844','2013-07-15','09:25:00',1.85),('15844','2013-07-15','09:30:00',1.99),('15844','2013-07-15','09:35:00',2.23),('15844','2013-07-15','09:40:00',2.35),('15844','2013-07-15','09:45:00',2.44),('15844','2013-07-15','09:50:00',2.56),('15844','2013-07-15','09:55:00',2.7),('15844','2013-07-15','10:00:00',2.81),('15844','2013-07-15','10:05:00',2.86),('15844','2013-07-15','10:10:00',2.95),('15844','2013-07-15','10:15:00',3.08),('15844','2013-07-15','10:20:00',3.28),('15844','2013-07-15','10:25:00',3.4),('15844','2013-07-15','10:30:00',3.53),('15844','2013-07-15','10:35:00',3.59),('15844','2013-07-15','10:40:00',3.66),('15844','2013-07-15','10:45:00',3.72),('15844','2013-07-15','10:50:00',3.83),('15844','2013-07-15','10:55:00',3.92),('15844','2013-07-15','11:00:00',4.02),('15844','2013-07-15','11:05:00',4.07),('15844','2013-07-15','11:10:00',4.12),('15844','2013-07-15','11:15:00',4.14),('15844','2013-07-15','11:20:00',4.16),('15844','2013-07-15','11:25:00',4.16),('15844','2013-07-15','11:30:00',4.19),('15844','2013-07-15','11:35:00',4.24),('15844','2013-07-15','11:40:00',4.25),('15844','2013-07-15','11:45:00',4.23),('15844','2013-07-15','11:50:00',4.23),('15844','2013-07-15','11:55:00',4.24),('15844','2013-07-15','12:00:00',4.25),('15844','2013-07-15','12:05:00',4.24),('15844','2013-07-15','12:10:00',4.27),('15844','2013-07-15','12:15:00',4.24),('15844','2013-07-15','12:20:00',4.19),('15844','2013-07-15','12:25:00',4.17),('15844','2013-07-15','12:30:00',4.1),('15844','2013-07-15','12:35:00',4.11),('15844','2013-07-15','12:40:00',4.13),('15844','2013-07-15','12:45:00',3.78),('15844','2013-07-15','12:50:00',4.06),('15844','2013-07-15','12:55:00',4.09),('15844','2013-07-15','13:00:00',4.14),('15844','2013-07-15','13:05:00',4.06),('15844','2013-07-15','13:10:00',3.98),('15844','2013-07-15','13:15:00',4.01),('15844','2013-07-15','13:20:00',2.81),('15844','2013-07-15','13:25:00',4.24),('15844','2013-07-15','13:30:00',4.16),('15844','2013-07-15','13:35:00',3.27),('15844','2013-07-15','13:40:00',3.59),('15844','2013-07-15','13:45:00',3.78),('15844','2013-07-15','13:50:00',4.08),('15844','2013-07-15','13:55:00',2.55),('15844','2013-07-15','14:00:00',1.34),('15844','2013-07-15','14:05:00',4.28),('15844','2013-07-15','14:10:00',2.81),('15844','2013-07-15','14:15:00',3.09),('15844','2013-07-15','14:20:00',3.55),('15844','2013-07-15','14:30:00',3.28),('15844','2013-07-15','14:35:00',3.7),('15844','2013-07-15','14:40:00',3.63),('15844','2013-07-15','14:50:00',1.35),('15844','2013-07-15','15:00:00',3.01),('15844','2013-07-15','15:05:00',3.22),('15844','2013-07-15','15:10:00',3.01),('15844','2013-07-15','15:15:00',2.87),('15844','2013-07-15','15:20:00',2.66),('15844','2013-07-15','15:25:00',2.62),('15844','2013-07-15','15:30:00',2.67),('15844','2013-07-15','15:35:00',2.48),('15844','2013-07-15','15:40:00',2.24),('15844','2013-07-15','15:45:00',2.17),('15844','2013-07-15','15:50:00',2.15),('15844','2013-07-15','15:55:00',2.07),('15844','2013-07-15','16:00:00',1.92),('15844','2013-07-15','16:05:00',1.78),('15844','2013-07-15','16:10:00',1.67),('15844','2013-07-15','16:15:00',1.57),('15844','2013-07-15','16:20:00',1.54),('15844','2013-07-15','16:25:00',1.5),('15844','2013-07-15','16:30:00',1.48),('15844','2013-07-15','16:35:00',1.44),('15844','2013-07-15','16:40:00',1.37),('15844','2013-07-15','16:45:00',1.31),('15844','2013-07-15','16:50:00',1.23),('15844','2013-07-15','16:55:00',1.11),('15844','2013-07-14','08:15:00',1.01),('15844','2013-07-14','08:30:00',1.01),('15844','2013-07-14','08:55:00',1.16),('15844','2013-07-14','09:10:00',1.19),('15844','2013-07-14','09:15:00',1.02),('15844','2013-07-14','09:20:00',1.06),('15844','2013-07-14','09:25:00',1.53),('15844','2013-07-14','09:30:00',1.82),('15844','2013-07-14','09:35:00',1.72),('15844','2013-07-14','09:40:00',1.47),('15844','2013-07-14','09:45:00',1.49),('15844','2013-07-14','09:50:00',1.39),('15844','2013-07-14','09:55:00',1.42),('15844','2013-07-14','10:00:00',1.55),('15844','2013-07-14','10:05:00',1.54),('15844','2013-07-14','10:10:00',1.46),('15844','2013-07-14','10:15:00',1.65),('15844','2013-07-14','10:20:00',2.36),('15844','2013-07-14','10:25:00',3.06),('15844','2013-07-14','10:30:00',2.32),('15844','2013-07-14','10:35:00',2.59),('15844','2013-07-14','10:40:00',3.16),('15844','2013-07-14','10:45:00',4.48),('15844','2013-07-14','10:50:00',3.48),('15844','2013-07-14','10:55:00',4.14),('15844','2013-07-14','11:00:00',4.07),('15844','2013-07-14','11:05:00',3.12),('15844','2013-07-14','11:10:00',4.18),('15844','2013-07-14','11:15:00',4.36),('15844','2013-07-14','11:20:00',4.61),('15844','2013-07-14','11:25:00',3.45),('15844','2013-07-14','11:30:00',4.18),('15844','2013-07-14','11:35:00',4.14),('15844','2013-07-14','11:40:00',3.55),('15844','2013-07-14','11:45:00',4.24),('15844','2013-07-14','11:50:00',2.29),('15844','2013-07-14','11:55:00',2.02),('15844','2013-07-14','12:00:00',1.23),('15844','2013-07-14','12:05:00',1.15),('15844','2013-07-14','12:10:00',1.88),('15844','2013-07-14','12:15:00',1.88),('15844','2013-07-14','12:20:00',1.57),('15844','2013-07-14','12:25:00',1.16),('15844','2013-07-14','12:30:00',1.35),('15844','2013-07-14','12:35:00',2.43),('15844','2013-07-14','12:40:00',3.07),('15844','2013-07-14','12:45:00',4.69),('15844','2013-07-14','12:50:00',4.67),('15844','2013-07-14','12:55:00',3.08),('15844','2013-07-14','13:00:00',1.9),('15844','2013-07-14','13:05:00',3.86),('15844','2013-07-14','13:10:00',4.24),('15844','2013-07-14','13:15:00',4.01),('15844','2013-07-14','13:20:00',4.05),('15844','2013-07-14','13:25:00',4.11),('15844','2013-07-14','13:30:00',4.12),('15844','2013-07-14','13:35:00',4.11),('15844','2013-07-14','13:40:00',4.08),('15844','2013-07-14','13:45:00',4.08),('15844','2013-07-14','13:50:00',4.08),('15844','2013-07-14','13:55:00',4.02),('15844','2013-07-14','14:00:00',3.98),('15844','2013-07-14','14:05:00',3.95),('15844','2013-07-14','14:10:00',3.9),('15844','2013-07-14','14:15:00',3.8),('15844','2013-07-14','14:20:00',3.74),('15844','2013-07-14','14:25:00',3.67),('15844','2013-07-14','14:30:00',3.63),('15844','2013-07-14','14:35:00',3.53),('15844','2013-07-14','14:40:00',3.47),('15844','2013-07-14','14:45:00',3.4),('15844','2013-07-14','14:50:00',3.32),('15844','2013-07-14','14:55:00',3.23),('15844','2013-07-14','15:00:00',3.09),('15844','2013-07-14','15:05:00',3),('15844','2013-07-14','15:10:00',2.87),('15844','2013-07-14','15:15:00',2.78),('15844','2013-07-14','15:20:00',2.69),('15844','2013-07-14','15:25:00',2.58),('15844','2013-07-14','15:30:00',2.47),('15844','2013-07-14','15:35:00',2.36),('15844','2013-07-14','15:40:00',2.3),('15844','2013-07-14','15:45:00',2.24),('15844','2013-07-14','15:50:00',2.15),('15844','2013-07-14','15:55:00',1.85),('15844','2013-07-14','16:00:00',1.73),('15844','2013-07-14','16:05:00',1.87),('15844','2013-07-14','16:10:00',1.72),('15844','2013-07-14','16:15:00',1.8),('15844','2013-07-14','16:20:00',1.86),('15844','2013-07-14','16:25:00',1.54),('15844','2013-07-14','16:30:00',1.47),('15844','2013-07-14','16:35:00',1.24),('15844','2013-07-14','16:40:00',1.09),('15844','2013-07-14','16:45:00',1.24),('15844','2013-07-14','16:50:00',1.25),('15844','2013-07-13','08:35:00',1.07),('15844','2013-07-13','08:40:00',1.13),('15844','2013-07-13','08:45:00',1.21),('15844','2013-07-13','08:50:00',1.27),('15844','2013-07-13','08:55:00',1.36),('15844','2013-07-13','09:00:00',1.44),('15844','2013-07-13','09:05:00',1.58),('15844','2013-07-13','09:10:00',1.65),('15844','2013-07-13','09:15:00',1.69),('15844','2013-07-13','09:20:00',1.69),('15844','2013-07-13','09:25:00',1.82),('15844','2013-07-13','09:30:00',1.92),('15844','2013-07-13','09:35:00',2.14),('15844','2013-07-13','09:40:00',2.29),('15844','2013-07-13','09:45:00',2.37),('15844','2013-07-13','09:50:00',2.5),('15844','2013-07-13','09:55:00',2.67),('15844','2013-07-13','10:00:00',2.79),('15844','2013-07-13','10:05:00',2.85),('15844','2013-07-13','10:10:00',2.95),('15844','2013-07-13','10:15:00',3.05),('15844','2013-07-13','10:20:00',3.26),('15844','2013-07-13','10:25:00',3.27),('15844','2013-07-13','10:30:00',3.29),('15844','2013-07-13','10:35:00',3.64),('15844','2013-07-13','10:40:00',3.67),('15844','2013-07-13','10:45:00',2.88),('15844','2013-07-13','10:50:00',4.02),('15844','2013-07-13','10:55:00',4.05),('15844','2013-07-13','11:00:00',1.09),('15844','2013-07-13','11:05:00',2.19),('15844','2013-07-13','11:10:00',2.56),('15844','2013-07-13','11:15:00',1.06),('15844','2013-07-13','11:20:00',1.22),('15844','2013-07-13','11:25:00',2.19),('15844','2013-07-13','11:30:00',4.55),('15844','2013-07-13','11:35:00',4.35),('15844','2013-07-13','11:40:00',4.44),('15844','2013-07-13','11:45:00',4.36),('15844','2013-07-13','11:50:00',1.55),('15844','2013-07-13','11:55:00',2.11),('15844','2013-07-13','12:00:00',4.24),('15844','2013-07-13','12:05:00',3.69),('15844','2013-07-13','12:10:00',1.2),('15844','2013-07-13','12:15:00',1.64),('15844','2013-07-13','12:20:00',1.66),('15844','2013-07-13','12:25:00',4.38),('15844','2013-07-13','12:30:00',4.46),('15844','2013-07-13','12:35:00',4.55),('15844','2013-07-13','12:40:00',3.53),('15844','2013-07-13','12:45:00',3.82),('15844','2013-07-13','12:50:00',1.56),('15844','2013-07-13','12:55:00',3.7),('15844','2013-07-13','13:00:00',4.41),('15844','2013-07-13','13:05:00',4.39),('15844','2013-07-13','13:10:00',4.19),('15844','2013-07-13','13:15:00',4.23),('15844','2013-07-13','13:20:00',3.82),('15844','2013-07-13','13:25:00',4.14),('15844','2013-07-13','13:30:00',4.15),('15844','2013-07-13','13:35:00',4.11),('15844','2013-07-13','13:40:00',4.04),('15844','2013-07-13','13:45:00',4.05),('15844','2013-07-13','13:50:00',3.98),('15844','2013-07-13','13:55:00',3.96),('15844','2013-07-13','14:00:00',3.89),('15844','2013-07-13','14:05:00',3.83),('15844','2013-07-13','14:10:00',3.82),('15844','2013-07-13','14:15:00',3.75),('15844','2013-07-13','14:20:00',3.7),('15844','2013-07-13','14:25:00',3.63),('15844','2013-07-13','14:30:00',3.57),('15844','2013-07-13','14:35:00',3.53),('15844','2013-07-13','14:40:00',3.47),('15844','2013-07-13','14:45:00',3.42),('15844','2013-07-13','14:50:00',3.33),('15844','2013-07-13','14:55:00',3.29),('15844','2013-07-13','15:00:00',3.14),('15844','2013-07-13','15:05:00',3.07),('15844','2013-07-13','15:10:00',2.96),('15844','2013-07-13','15:15:00',2.87),('15844','2013-07-13','15:20:00',2.6),('15844','2013-07-13','15:25:00',2.64),('15844','2013-07-13','15:30:00',2.42),('15844','2013-07-13','15:35:00',2.41),('15844','2013-07-13','15:40:00',2.33),('15844','2013-07-13','15:45:00',2.25),('15844','2013-07-13','15:50:00',2.16),('15844','2013-07-13','15:55:00',2.06),('15844','2013-07-13','16:00:00',1.92),('15844','2013-07-13','16:05:00',1.79),('15844','2013-07-13','16:10:00',1.67),('15844','2013-07-13','16:15:00',1.6),('15844','2013-07-13','16:20:00',1.58),('15844','2013-07-13','16:25:00',1.52),('15844','2013-07-13','16:30:00',1.47),('15844','2013-07-13','16:35:00',1.43),('15844','2013-07-13','16:40:00',1.37),('15844','2013-07-13','16:45:00',1.31),('15844','2013-07-13','16:50:00',1.22),('15844','2013-07-13','16:55:00',1.06),('15844','2013-07-12','08:30:00',1.51),('15844','2013-07-12','09:00:00',1.67),('15844','2013-07-12','09:05:00',1.89),('15844','2013-07-12','09:10:00',1.98),('15844','2013-07-12','09:15:00',1.02),('15844','2013-07-12','09:25:00',1.65),('15844','2013-07-12','09:30:00',1.16),('15844','2013-07-12','09:35:00',1.61),('15844','2013-07-12','09:40:00',1.98),('15844','2013-07-12','09:45:00',2.53),('15844','2013-07-12','09:50:00',2.59),('15844','2013-07-12','09:55:00',2.71),('15844','2013-07-12','10:00:00',2.13),('15844','2013-07-12','10:05:00',1.97),('15844','2013-07-12','10:10:00',2.52),('15844','2013-07-12','10:15:00',1.56),('15844','2013-07-12','10:20:00',2.82),('15844','2013-07-12','10:25:00',3.43),('15844','2013-07-12','10:30:00',2.58),('15844','2013-07-12','10:35:00',1.59),('15844','2013-07-12','10:40:00',3.71),('15844','2013-07-12','10:45:00',3.82),('15844','2013-07-12','10:50:00',1.53),('15844','2013-07-12','10:55:00',1.66),('15844','2013-07-12','11:00:00',3.63),('15844','2013-07-12','11:05:00',3.47),('15844','2013-07-12','11:10:00',2.01),('15844','2013-07-12','11:15:00',2.98),('15844','2013-07-12','11:25:00',1.23),('15844','2013-07-12','11:30:00',1.22),('15844','2013-07-12','11:35:00',3.66),('15844','2013-07-12','11:40:00',3.56),('15844','2013-07-12','11:45:00',3.39),('15844','2013-07-12','11:50:00',4.37),('15844','2013-07-12','11:55:00',4.64),('15844','2013-07-12','12:00:00',4.22),('15844','2013-07-12','12:05:00',4.47),('15844','2013-07-12','12:10:00',4.47),('15844','2013-07-12','12:15:00',4.56),('15844','2013-07-12','12:20:00',2.9),('15844','2013-07-12','12:25:00',3.71),('15844','2013-07-12','12:30:00',4.64),('15844','2013-07-12','12:35:00',3.85),('15844','2013-07-12','12:40:00',4.02),('15844','2013-07-12','12:45:00',2.92),('15844','2013-07-12','12:50:00',4.41),('15844','2013-07-12','12:55:00',4.41),('15844','2013-07-12','13:00:00',4.33),('15844','2013-07-12','13:05:00',4.25),('15844','2013-07-12','13:10:00',4.35),('15844','2013-07-12','13:15:00',4.21),('15844','2013-07-12','13:20:00',4.26),('15844','2013-07-12','13:25:00',4.19),('15844','2013-07-12','13:30:00',4.39),('15844','2013-07-12','13:35:00',4.2),('15844','2013-07-12','13:40:00',4.16),('15844','2013-07-12','13:45:00',4.21),('15844','2013-07-12','13:50:00',2.72),('15844','2013-07-12','13:55:00',3.28),('15844','2013-07-12','14:00:00',3.35),('15844','2013-07-12','14:05:00',3.39),('15844','2013-07-12','14:10:00',4.17),('15844','2013-07-12','14:15:00',4.13),('15844','2013-07-12','14:20:00',2.48),('15844','2013-07-12','14:25:00',2.39),('15844','2013-07-12','14:30:00',3.82),('15844','2013-07-12','14:35:00',3.66),('15844','2013-07-12','14:40:00',3.52),('15844','2013-07-12','14:45:00',3.4),('15844','2013-07-12','14:50:00',3.34),('15844','2013-07-12','14:55:00',3.19),('15844','2013-07-12','15:00:00',3.05),('15844','2013-07-12','15:05:00',2.97),('15844','2013-07-12','15:10:00',2.84),('15844','2013-07-12','15:15:00',2.75),('15844','2013-07-12','15:20:00',2.2),('15844','2013-07-12','15:25:00',2.48),('15844','2013-07-12','15:30:00',2.41),('15844','2013-07-12','15:35:00',1.96),('15844','2013-07-12','15:40:00',2.33),('15844','2013-07-12','15:45:00',2.23),('15844','2013-07-12','15:50:00',2.12),('15844','2013-07-12','15:55:00',2.01),('15844','2013-07-12','16:00:00',1.92),('15844','2013-07-12','16:05:00',1.79),('15844','2013-07-12','16:10:00',1.68),('15844','2013-07-12','16:15:00',1.63),('15844','2013-07-12','16:20:00',1.57),('15844','2013-07-12','16:25:00',1.52),('15844','2013-07-12','16:30:00',1.46),('15844','2013-07-12','16:35:00',1.43),('15844','2013-07-12','16:40:00',1.37),('15844','2013-07-12','16:45:00',1.32),('15844','2013-07-12','16:50:00',1.23),('15844','2013-07-12','16:55:00',1.07),('15844','2013-07-11','08:35:00',1.03),('15844','2013-07-11','08:40:00',1.12),('15844','2013-07-11','08:45:00',1.2),('15844','2013-07-11','08:50:00',1.33),('15844','2013-07-11','08:55:00',1.38),('15844','2013-07-11','09:00:00',1.45),('15844','2013-07-11','09:05:00',1.6),('15844','2013-07-11','09:10:00',1.62),('15844','2013-07-11','09:15:00',1.7),('15844','2013-07-11','09:20:00',1.78),('15844','2013-07-11','09:25:00',1.85),('15844','2013-07-11','09:30:00',1.08),('15844','2013-07-11','09:35:00',2.02),('15844','2013-07-11','09:40:00',2.47),('15844','2013-07-11','09:45:00',2.2),('15844','2013-07-11','09:50:00',1.27),('15844','2013-07-11','09:55:00',2.07),('15844','2013-07-11','10:00:00',2.28),('15844','2013-07-11','10:05:00',1.89),('15844','2013-07-11','10:10:00',1.65),('15844','2013-07-11','10:20:00',1.11),('15844','2013-07-11','10:25:00',2.92),('15844','2013-07-11','10:30:00',3.41),('15844','2013-07-11','10:45:00',2.59),('15844','2013-07-11','10:50:00',4),('15844','2013-07-11','10:55:00',3.49),('15844','2013-07-11','11:00:00',3.5),('15844','2013-07-11','11:05:00',4.13),('15844','2013-07-11','11:10:00',2.16),('15844','2013-07-11','11:15:00',3.6),('15844','2013-07-11','11:20:00',3.73),('15844','2013-07-11','11:25:00',2.79),('15844','2013-07-11','11:30:00',2.3),('15844','2013-07-11','11:35:00',1.06),('15844','2013-07-11','11:40:00',1.25),('15844','2013-07-11','11:45:00',3.03),('15844','2013-07-11','11:50:00',4.48),('15844','2013-07-11','11:55:00',4.07),('15844','2013-07-11','12:00:00',3.15),('15844','2013-07-11','12:05:00',3.27),('15844','2013-07-11','12:10:00',1.72),('15844','2013-07-11','12:15:00',4.24),('15844','2013-07-11','12:20:00',4.41),('15844','2013-07-11','12:25:00',4.6),('15844','2013-07-11','12:30:00',4.52),('15844','2013-07-11','12:35:00',4.49),('15844','2013-07-11','12:40:00',4.35),('15844','2013-07-11','12:45:00',4.38),('15844','2013-07-11','12:50:00',4.21),('15844','2013-07-11','12:55:00',1.62),('15844','2013-07-11','13:00:00',4.49),('15844','2013-07-11','13:05:00',4.01),('15844','2013-07-11','13:10:00',4.38),('15844','2013-07-11','13:15:00',2.28),('15844','2013-07-11','13:20:00',4.25),('15844','2013-07-11','13:25:00',4.4),('15844','2013-07-11','13:30:00',4.35),('15844','2013-07-11','13:35:00',4.16),('15844','2013-07-11','13:40:00',4.08),('15844','2013-07-11','13:45:00',4.09),('15844','2013-07-11','13:50:00',4.04),('15844','2013-07-11','13:55:00',3.97),('15844','2013-07-11','14:00:00',3.99),('15844','2013-07-11','14:05:00',3.87),('15844','2013-07-11','14:10:00',3.99),('15844','2013-07-11','14:15:00',3.81),('15844','2013-07-11','14:20:00',3.76),('15844','2013-07-11','14:25:00',3.68),('15844','2013-07-11','14:30:00',3.64),('15844','2013-07-11','14:35:00',3.56),('15844','2013-07-11','14:40:00',3.48),('15844','2013-07-11','14:45:00',3.44),('15844','2013-07-11','14:50:00',3.35),('15844','2013-07-11','14:55:00',3.24),('15844','2013-07-11','15:00:00',3.13),('15844','2013-07-11','15:05:00',3.06),('15844','2013-07-11','15:10:00',2.96),('15844','2013-07-11','15:15:00',2.86),('15844','2013-07-11','15:20:00',2.79),('15844','2013-07-11','15:25:00',2.65),('15844','2013-07-11','15:30:00',2.21),('15844','2013-07-11','15:35:00',2.21),('15844','2013-07-11','15:40:00',2.26),('15844','2013-07-11','15:45:00',2.4),('15844','2013-07-11','15:50:00',2.34),('15844','2013-07-11','15:55:00',1.73),('15844','2013-07-11','16:00:00',2.2),('15844','2013-07-11','16:05:00',1.96),('15844','2013-07-11','16:10:00',1.72),('15844','2013-07-11','16:15:00',1.63),('15844','2013-07-11','16:20:00',2.03),('15844','2013-07-11','16:25:00',1.85),('15844','2013-07-11','16:30:00',1.78),('15844','2013-07-11','16:35:00',1.62),('15844','2013-07-11','16:40:00',1.45),('15844','2013-07-11','16:45:00',1.48),('15844','2013-07-11','16:50:00',1.27),('15844','2013-07-11','16:55:00',1.17),('15844','2013-07-11','17:00:00',1.03),('15844','2013-07-11','17:10:00',1.11),('15844','2014-05-03','08:20:00',1.12),('15844','2014-05-03','08:30:00',1.05),('15844','2014-05-03','08:35:00',1.58),('15844','2014-05-03','08:40:00',1.7),('15844','2014-05-03','08:45:00',1.64),('15844','2014-05-03','08:55:00',1.14),('15844','2014-05-03','09:00:00',1.85),('15844','2014-05-03','09:05:00',1.67),('15844','2014-05-03','09:10:00',1.24),('15844','2014-05-03','09:15:00',1.64),('15844','2014-05-03','09:20:00',1.05),('15844','2014-05-03','09:35:00',1.47),('15844','2014-05-03','09:50:00',2.73),('15844','2014-05-03','09:55:00',3.37),('15844','2014-05-03','10:00:00',3.82),('15844','2014-05-03','10:05:00',3.63),('15844','2014-05-03','10:10:00',3.99),('15844','2014-05-03','10:15:00',3.25),('15844','2014-05-03','10:20:00',2.28),('15844','2014-05-03','10:25:00',3.36),('15844','2014-05-03','10:30:00',2.29),('15844','2014-05-03','10:35:00',4.39),('15844','2014-05-03','10:40:00',4.96),('15844','2014-05-03','10:45:00',3.56),('15844','2014-05-03','10:50:00',1.03),('15844','2014-05-03','11:00:00',1.11),('15844','2014-05-03','11:05:00',4.41),('15844','2014-05-03','11:10:00',2.94),('15844','2014-05-03','11:15:00',1.24),('15844','2014-05-03','11:30:00',1.13),('15844','2014-05-03','11:35:00',2.5),('15844','2014-05-03','11:40:00',2.52),('15844','2014-05-03','11:45:00',1.85),('15844','2014-05-03','11:50:00',1.53),('15844','2014-05-03','11:55:00',1.59),('15844','2014-05-03','12:00:00',1.69),('15844','2014-05-03','12:05:00',1.3),('15844','2014-05-03','12:20:00',1.03),('15844','2014-05-03','12:35:00',1.18),('15844','2014-05-03','12:40:00',1.57),('15844','2014-05-03','12:45:00',1.98),('15844','2014-05-03','12:50:00',1.8),('15844','2014-05-03','12:55:00',1.71),('15844','2014-05-03','13:00:00',2.3),('15844','2014-05-03','13:05:00',2.96),('15844','2014-05-03','13:10:00',2.9),('15844','2014-05-03','13:15:00',2.9),('15844','2014-05-03','13:20:00',2.26),('15844','2014-05-03','13:25:00',1.85),('15844','2014-05-03','13:30:00',1.77),('15844','2014-05-03','13:35:00',1.81),('15844','2014-05-03','13:40:00',2.13),('15844','2014-05-03','13:45:00',2.36),('15844','2014-05-03','13:50:00',1.99),('15844','2014-05-03','13:55:00',2.32),('15844','2014-05-03','14:00:00',2.4),('15844','2014-05-03','14:05:00',2.45),('15844','2014-05-03','14:10:00',2.34),('15844','2014-05-03','14:15:00',2.2),('15844','2014-05-03','14:20:00',2.36),('15844','2014-05-03','14:25:00',2.39),('15844','2014-05-03','14:30:00',2.49),('15844','2014-05-03','14:35:00',1.86),('15844','2014-04-06','08:45:00',1.11),('15844','2014-04-06','08:50:00',1.26),('15844','2014-04-06','08:55:00',1.37),('15844','2014-04-06','09:00:00',1.36),('15844','2014-04-06','09:05:00',1.4),('15844','2014-04-06','09:10:00',1.64),('15844','2014-04-06','09:15:00',1.91),('15844','2014-04-06','09:20:00',1.68),('15844','2014-04-06','09:25:00',1.77),('15844','2014-04-06','09:35:00',1.34),('15844','2014-04-06','09:40:00',1.34),('15844','2014-04-06','09:45:00',1.13),('15844','2014-04-06','09:50:00',1.61),('15844','2014-04-06','09:55:00',2.96),('15844','2014-04-06','10:00:00',2.98),('15844','2014-04-06','10:05:00',3.06),('15844','2014-04-06','10:10:00',3.42),('15844','2014-04-06','10:15:00',2.74),('15844','2014-04-06','10:20:00',3.46),('15844','2014-04-06','10:25:00',1.7),('15844','2014-04-06','10:30:00',1.54),('15844','2014-04-06','10:35:00',1.26),('15844','2014-04-06','10:40:00',1.34),('15844','2014-04-06','10:45:00',1.52),('15844','2014-04-06','10:50:00',1.57),('15844','2014-04-06','10:55:00',2.41),('15844','2014-04-06','11:00:00',2.02),('15844','2014-04-06','11:05:00',2.3),('15844','2014-04-06','11:10:00',4.16),('15844','2014-04-06','11:15:00',4.23),('15844','2014-04-06','11:20:00',4.22),('15844','2014-04-06','11:25:00',4.18),('15844','2014-04-06','11:30:00',4.27),('15844','2014-04-06','11:35:00',4.13),('15844','2014-04-06','11:40:00',4.09),('15844','2014-04-06','11:45:00',4.08),('15844','2014-04-06','11:50:00',4.12),('15844','2014-04-06','11:55:00',4.08),('15844','2014-04-06','12:00:00',4.11),('15844','2014-04-06','12:05:00',3.92),('15844','2014-04-06','12:10:00',4.19),('15844','2014-04-06','12:15:00',4.17),('15844','2014-04-06','12:20:00',4.13),('15844','2014-04-06','12:25:00',4.06),('15844','2014-04-06','12:30:00',4.36),('15844','2014-04-06','12:35:00',4.04),('15844','2014-04-06','12:40:00',3.47),('15844','2014-04-06','12:45:00',4.08),('15844','2014-04-06','12:50:00',4.14),('15844','2014-04-06','12:55:00',3.97),('15844','2014-04-06','13:00:00',3.93),('15844','2014-04-06','13:05:00',3.53),('15844','2014-04-06','13:10:00',4.27),('15844','2014-04-06','13:15:00',3.41),('15844','2014-04-06','13:20:00',3.14),('15844','2014-04-06','13:25:00',4.24),('15844','2014-04-06','13:30:00',3.77),('15844','2014-04-06','13:35:00',1.51),('15844','2014-04-06','13:40:00',2.97),('15844','2014-04-06','13:45:00',3.48),('15844','2014-04-06','13:50:00',2.56),('15844','2014-04-06','13:55:00',3.68),('15844','2014-04-06','14:00:00',3.38),('15844','2014-04-06','14:05:00',3.59),('15844','2014-04-06','14:10:00',3.52),('15844','2014-04-06','14:15:00',3.63),('15844','2014-04-06','14:20:00',3.33),('15844','2014-04-06','14:25:00',3.3),('15844','2014-04-06','14:30:00',3.23),('15844','2014-04-06','14:35:00',3.29),('15844','2014-04-06','14:45:00',1.21),('15844','2014-04-06','14:50:00',2.63),('15844','2014-04-06','14:55:00',2.51),('15844','2014-04-06','15:00:00',1.27),('15844','2014-04-06','16:00:00',1.36),('15844','2014-04-06','16:10:00',1.33),('15844','2013-07-10','08:15:00',1.05),('15844','2013-07-10','08:20:00',1.28),('15844','2013-07-10','08:25:00',1.43),('15844','2013-07-10','08:30:00',1.38),('15844','2013-07-10','08:35:00',1.25),('15844','2013-07-10','08:40:00',1.23),('15844','2013-07-10','08:45:00',1.2),('15844','2013-07-10','08:55:00',1.29),('15844','2013-07-10','09:00:00',1.49),('15844','2013-07-10','09:05:00',1.12),('15844','2013-07-10','09:10:00',1.76),('15844','2013-07-10','09:15:00',1.83),('15844','2013-07-10','09:20:00',1.84),('15844','2013-07-10','09:25:00',1.9),('15844','2013-07-10','09:30:00',2.01),('15844','2013-07-10','09:35:00',2.2),('15844','2013-07-10','09:40:00',2.34),('15844','2013-07-10','09:45:00',2.45),('15844','2013-07-10','09:50:00',2.57),('15844','2013-07-10','09:55:00',2.74),('15844','2013-07-10','10:00:00',2.85),('15844','2013-07-10','10:05:00',2.93),('15844','2013-07-10','10:10:00',2.99),('15844','2013-07-10','10:15:00',3.06),('15844','2013-07-10','10:20:00',3.11),('15844','2013-07-10','10:25:00',3.19),('15844','2013-07-10','10:30:00',3.5),('15844','2013-07-10','10:35:00',3.63),('15844','2013-07-10','10:40:00',3.72),('15844','2013-07-10','10:45:00',3.8),('15844','2013-07-10','10:50:00',3.93),('15844','2013-07-10','10:55:00',3.98),('15844','2013-07-10','11:00:00',4.04),('15844','2013-07-10','11:05:00',4.06),('15844','2013-07-10','11:10:00',4.08),('15844','2013-07-10','11:15:00',4.04),('15844','2013-07-10','11:20:00',4.12),('15844','2013-07-10','11:25:00',4.15),('15844','2013-07-10','11:30:00',4.02),('15844','2013-07-10','11:35:00',4.18),('15844','2013-07-10','11:40:00',4.21),('15844','2013-07-10','11:45:00',4.21),('15844','2013-07-10','11:50:00',4.25),('15844','2013-07-10','11:55:00',4.19),('15844','2013-07-10','12:00:00',4.25),('15844','2013-07-10','12:05:00',4.26),('15844','2013-07-10','12:10:00',4.26),('15844','2013-07-10','12:15:00',4.26),('15844','2013-07-10','12:20:00',4.27),('15844','2013-07-10','12:25:00',4.28),('15844','2013-07-10','12:30:00',4.22),('15844','2013-07-10','12:35:00',4.26),('15844','2013-07-10','12:40:00',4.3),('15844','2013-07-10','12:45:00',4.25),('15844','2013-07-10','12:50:00',4.27),('15844','2013-07-10','12:55:00',4.3),('15844','2013-07-10','13:00:00',4.27),('15844','2013-07-10','13:05:00',4.27),('15844','2013-07-10','13:10:00',4.25),('15844','2013-07-10','13:15:00',4.25),('15844','2013-07-10','13:20:00',4.22),('15844','2013-07-10','13:25:00',4.19),('15844','2013-07-10','13:30:00',4.16),('15844','2013-07-10','13:35:00',4.14),('15844','2013-07-10','13:40:00',4.13),('15844','2013-07-10','13:45:00',4.09),('15844','2013-07-10','13:50:00',4.07),('15844','2013-07-10','13:55:00',4.02),('15844','2013-07-10','14:00:00',3.98),('15844','2013-07-10','14:05:00',3.92),('15844','2013-07-10','14:10:00',3.88),('15844','2013-07-10','14:15:00',3.82),('15844','2013-07-10','14:20:00',3.74),('15844','2013-07-10','14:25:00',3.69),('15844','2013-07-10','14:30:00',3.65),('15844','2013-07-10','14:35:00',3.59),('15844','2013-07-10','14:40:00',3.52),('15844','2013-07-10','14:45:00',3.46),('15844','2013-07-10','14:50:00',3.38),('15844','2013-07-10','14:55:00',3.27),('15844','2013-07-10','15:00:00',3.16),('15844','2013-07-10','15:05:00',3.06),('15844','2013-07-10','15:10:00',2.96),('15844','2013-07-10','15:15:00',2.84),('15844','2013-07-10','15:20:00',2.75),('15844','2013-07-10','15:25:00',2.64),('15844','2013-07-10','15:30:00',2.51),('15844','2013-07-10','15:35:00',2.43),('15844','2013-07-10','15:40:00',2.33),('15844','2013-07-10','15:45:00',2.25),('15844','2013-07-10','15:50:00',2.18),('15844','2013-07-10','15:55:00',2.08),('15844','2013-07-10','16:00:00',1.96),('15844','2013-07-10','16:05:00',1.86),('15844','2013-07-10','16:10:00',1.76),('15844','2013-07-10','16:15:00',1.7),('15844','2013-07-10','16:20:00',1.62),('15844','2013-07-10','16:25:00',1.55),('15844','2013-07-10','16:30:00',1.5),('15844','2013-07-10','16:35:00',1.48),('15844','2013-07-10','16:40:00',1.4),('15844','2013-07-10','16:45:00',1.36),('15844','2013-07-10','16:50:00',1.3),('15844','2013-07-10','16:55:00',1.22),('15844','2013-07-10','17:00:00',1.2),('15844','2013-07-10','17:05:00',1.33),('15844','2013-07-10','17:10:00',1.29),('15844','2013-07-10','17:15:00',1.1),('15844','2013-07-09','08:30:00',1.03),('15844','2013-07-09','08:35:00',1.13),('15844','2013-07-09','08:40:00',1.19),('15844','2013-07-09','08:45:00',1.24),('15844','2013-07-09','08:50:00',1.26),('15844','2013-07-09','08:55:00',1.32),('15844','2013-07-09','09:00:00',1.42),('15844','2013-07-09','09:05:00',1.55),('15844','2013-07-09','09:10:00',1.67),('15844','2013-07-09','09:15:00',1.72),('15844','2013-07-09','09:20:00',1.77),('15844','2013-07-09','09:25:00',1.85),('15844','2013-07-09','09:30:00',1.94),('15844','2013-07-09','09:35:00',2.13),('15844','2013-07-09','09:40:00',2.3),('15844','2013-07-09','09:45:00',2.42),('15844','2013-07-09','09:50:00',2.56),('15844','2013-07-09','09:55:00',2.67),('15844','2013-07-09','10:00:00',2.75),('15844','2013-07-09','10:05:00',2.84),('15844','2013-07-09','10:10:00',2.91),('15844','2013-07-09','10:15:00',3.01),('15844','2013-07-09','10:20:00',3.09),('15844','2013-07-09','10:25:00',3.16),('15844','2013-07-09','10:30:00',3.43),('15844','2013-07-09','10:35:00',3.59),('15844','2013-07-09','10:40:00',3.73),('15844','2013-07-09','10:45:00',3.81),('15844','2013-07-09','10:50:00',3.88),('15844','2013-07-09','10:55:00',3.96),('15844','2013-07-09','11:00:00',4.01),('15844','2013-07-09','11:05:00',4.08),('15844','2013-07-09','11:10:00',4.08),('15844','2013-07-09','11:15:00',4.17),('15844','2013-07-09','11:20:00',4.25),('15844','2013-07-09','11:25:00',4.33),('15844','2013-07-09','11:30:00',3.55),('15844','2013-07-09','11:35:00',3.59),('15844','2013-07-09','11:40:00',4.38),('15844','2013-07-09','11:45:00',4.18),('15844','2013-07-09','11:50:00',4.24),('15844','2013-07-09','11:55:00',4.43),('15844','2013-07-09','12:00:00',4.41),('15844','2013-07-09','12:05:00',4.33),('15844','2013-07-09','12:10:00',4.27),('15844','2013-07-09','12:15:00',4.34),('15844','2013-07-09','12:20:00',4.3),('15844','2013-07-09','12:25:00',4.18),('15844','2013-07-09','12:30:00',4.2),('15844','2013-07-09','12:35:00',4.2),('15844','2013-07-09','12:40:00',4.16),('15844','2013-07-09','12:45:00',3.52),('15844','2013-07-09','12:50:00',2.62),('15844','2013-07-09','12:55:00',3.03),('15844','2013-07-09','13:00:00',4.33),('15844','2013-07-09','13:05:00',4.33),('15844','2013-07-09','13:10:00',4.28),('15844','2013-07-09','13:15:00',4.15),('15844','2013-07-09','13:20:00',4.19),('15844','2013-07-09','13:25:00',4.17),('15844','2013-07-09','13:30:00',4.15),('15844','2013-07-09','13:35:00',4.23),('15844','2013-07-09','13:40:00',4.21),('15844','2013-07-09','13:45:00',4.11),('15844','2013-07-09','13:50:00',3.13),('15844','2013-07-09','13:55:00',4.4),('15844','2013-07-09','14:00:00',3.77),('15844','2013-07-09','14:05:00',3.01),('15844','2013-07-09','14:10:00',3.26),('15844','2013-07-09','14:15:00',3.43),('15844','2013-07-09','14:20:00',3.85),('15844','2013-07-09','14:25:00',3.42),('15844','2013-07-09','14:30:00',1.12),('15844','2013-07-08','08:30:00',1.08),('15844','2013-07-08','08:35:00',1.18),('15844','2013-07-08','08:40:00',1.21),('15844','2013-07-08','08:45:00',1.24),('15844','2013-07-08','08:50:00',1.26),('15844','2013-07-08','08:55:00',1.35),('15844','2013-07-08','09:00:00',1.43),('15844','2013-07-08','09:05:00',1.55),('15844','2013-07-08','09:10:00',1.66),('15844','2013-07-08','09:15:00',1.72),('15844','2013-07-08','09:20:00',1.77),('15844','2013-07-08','09:25:00',1.84),('15844','2013-07-08','09:30:00',1.97),('15844','2013-07-08','09:35:00',2.15),('15844','2013-07-08','09:40:00',2.33),('15844','2013-07-08','09:45:00',2.44),('15844','2013-07-08','09:50:00',2.58),('15844','2013-07-08','09:55:00',2.68),('15844','2013-07-08','10:00:00',2.74),('15844','2013-07-08','10:05:00',2.8),('15844','2013-07-08','10:10:00',2.93),('15844','2013-07-08','10:15:00',3.05),('15844','2013-07-08','10:20:00',3.15),('15844','2013-07-08','10:25:00',3.27),('15844','2013-07-08','10:30:00',3.42),('15844','2013-07-08','10:35:00',3.42),('15844','2013-07-08','10:40:00',3.71),('15844','2013-07-08','10:45:00',3.78),('15844','2013-07-08','10:50:00',3.88),('15844','2013-07-08','10:55:00',3.94),('15844','2013-07-08','11:00:00',4.02),('15844','2013-07-08','11:05:00',4.06),('15844','2013-07-08','11:10:00',4.14),('15844','2013-07-08','11:15:00',4.13),('15844','2013-07-08','11:20:00',4.2),('15844','2013-07-08','11:25:00',4.22),('15844','2013-07-08','11:30:00',4.28),('15844','2013-07-08','11:35:00',4.29),('15844','2013-07-08','11:40:00',4.14),('15844','2013-07-08','11:45:00',3.12),('15844','2013-07-08','11:50:00',3.2),('15844','2013-07-08','11:55:00',4.51),('15844','2013-07-08','12:00:00',4.26),('15844','2013-07-08','12:05:00',4.42),('15844','2013-07-08','12:10:00',4.44),('15844','2013-07-08','12:15:00',4.36),('15844','2013-07-08','12:20:00',4.41),('15844','2013-07-08','12:25:00',4.54),('15844','2013-07-08','12:30:00',4.45),('15844','2013-07-08','12:35:00',4.24),('15844','2013-07-08','12:40:00',4.37),('15844','2013-07-08','12:45:00',4.34),('15844','2013-07-08','12:50:00',4.31),('15844','2013-07-08','12:55:00',4.31),('15844','2013-07-08','13:00:00',4.18),('15844','2013-07-08','13:05:00',4.44),('15844','2013-07-08','13:10:00',4.59),('15844','2013-07-08','13:15:00',4.48),('15844','2013-07-08','13:20:00',1.99),('15844','2013-07-08','14:30:00',1.01),('15844','2013-07-08','14:35:00',1.22),('15844','2013-07-08','14:40:00',1.48),('15844','2013-07-08','14:45:00',1.46),('15844','2013-07-08','14:50:00',1.35),('15844','2013-07-08','14:55:00',1.22),('15844','2013-07-08','15:00:00',1.12),('15844','2013-07-08','15:05:00',1.09),('15844','2013-07-08','15:10:00',1.01),('15844','2013-07-07','08:35:00',1.21),('15844','2013-07-07','08:55:00',1.35),('15844','2013-07-07','09:00:00',1.62),('15844','2013-07-07','09:05:00',1.75),('15844','2013-07-07','09:10:00',1.47),('15844','2013-07-07','09:15:00',1.15),('15844','2013-07-07','09:20:00',1.24),('15844','2013-07-07','09:25:00',1.18),('15844','2013-07-07','09:30:00',1.48),('15844','2013-07-07','09:35:00',2.09),('15844','2013-07-07','09:40:00',2.46),('15844','2013-07-07','09:45:00',2.58),('15844','2013-07-07','09:50:00',2.96),('15844','2013-07-07','09:55:00',3.03),('15844','2013-07-07','10:00:00',3.06),('15844','2013-07-07','10:05:00',3.02),('15844','2013-07-07','10:10:00',3.02),('15844','2013-07-07','10:15:00',2.58),('15844','2013-07-07','10:20:00',3.23),('15844','2013-07-07','10:25:00',3.63),('15844','2013-07-07','10:30:00',3.78),('15844','2013-07-07','10:35:00',2.96),('15844','2013-07-07','10:40:00',3.79),('15844','2013-07-07','10:45:00',4.02),('15844','2013-07-07','10:50:00',4.06),('15844','2013-07-07','10:55:00',4.14),('15844','2013-07-07','11:00:00',4.17),('15844','2013-07-07','11:05:00',4.21),('15844','2013-07-07','11:10:00',4.29),('15844','2013-07-07','11:15:00',4.29),('15844','2013-07-07','11:20:00',4.25),('15844','2013-07-07','11:25:00',3.7),('15844','2013-07-07','11:30:00',4.14),('15844','2013-07-07','11:35:00',3.89),('15844','2013-07-07','11:40:00',3.78),('15844','2013-07-07','11:45:00',4.06),('15844','2013-07-07','11:50:00',4.18),('15844','2013-07-07','11:55:00',3.73),('15844','2013-07-07','12:00:00',3.82),('15844','2013-07-07','12:05:00',2.8),('15844','2013-07-07','12:10:00',3.04),('15844','2013-07-07','12:15:00',3.35),('15844','2013-07-07','12:20:00',2.61),('15844','2013-07-07','12:25:00',3.26),('15844','2013-07-07','12:30:00',4.2),('15844','2013-07-07','12:35:00',3.96),('15844','2013-07-07','12:40:00',4.01),('15844','2013-07-07','12:45:00',4.19),('15844','2013-07-07','12:50:00',4.24),('15844','2013-07-07','12:55:00',4.3),('15844','2013-07-07','13:00:00',4.35),('15844','2013-07-07','13:05:00',4.13),('15844','2013-07-07','13:10:00',4.25),('15844','2013-07-07','13:15:00',4.26),('15844','2013-07-07','13:20:00',4.24),('15844','2013-07-07','13:25:00',4.19),('15844','2013-07-07','13:30:00',4.33),('15844','2013-07-07','13:35:00',4.3),('15844','2013-07-07','13:40:00',4.18),('15844','2013-07-07','13:45:00',4.36),('15844','2013-07-07','13:50:00',4.54),('15844','2013-07-07','13:55:00',3.53),('15844','2013-07-07','14:00:00',1.33),('15844','2013-07-07','14:05:00',1.28),('15844','2013-07-07','14:10:00',1.1),('15844','2013-07-07','14:15:00',1.22),('15844','2013-07-07','14:20:00',1.43),('15844','2013-07-07','14:25:00',2.12),('15844','2013-07-07','14:30:00',1.95),('15844','2013-07-07','14:35:00',1.42),('15844','2013-07-07','14:40:00',1.08),('15844','2013-07-07','15:05:00',1.11),('15844','2013-07-06','08:30:00',1.04),('15844','2013-07-06','08:35:00',1.14),('15844','2013-07-06','08:40:00',1.19),('15844','2013-07-06','08:45:00',1.25),('15844','2013-07-06','08:50:00',1.27),('15844','2013-07-06','08:55:00',1.33),('15844','2013-07-06','09:00:00',1.44),('15844','2013-07-06','09:05:00',1.54),('15844','2013-07-06','09:10:00',1.65),('15844','2013-07-06','09:15:00',1.71),('15844','2013-07-06','09:20:00',1.76),('15844','2013-07-06','09:25:00',1.86),('15844','2013-07-06','09:30:00',1.99),('15844','2013-07-06','09:35:00',2.16),('15844','2013-07-06','09:40:00',2.33),('15844','2013-07-06','09:45:00',2.47),('15844','2013-07-06','09:50:00',2.61),('15844','2013-07-06','09:55:00',2.74),('15844','2013-07-06','10:00:00',2.81),('15844','2013-07-06','10:05:00',2.91),('15844','2013-07-06','10:10:00',3),('15844','2013-07-06','10:15:00',3.09),('15844','2013-07-06','10:20:00',3.16),('15844','2013-07-06','10:25:00',3.25),('15844','2013-07-06','10:30:00',3.55),('15844','2013-07-06','10:35:00',3.65),('15844','2013-07-06','10:40:00',3.73),('15844','2013-07-06','10:45:00',3.79),('15844','2013-07-06','10:50:00',3.86),('15844','2013-07-06','10:55:00',4.02),('15844','2013-07-06','11:00:00',4.1),('15844','2013-07-06','11:05:00',4.17),('15844','2013-07-06','11:10:00',4.19),('15844','2013-07-06','11:15:00',4.23),('15844','2013-07-06','11:20:00',4.23),('15844','2013-07-06','11:25:00',4.24),('15844','2013-07-06','11:30:00',4.22),('15844','2013-07-06','11:35:00',4.24),('15844','2013-07-06','11:40:00',4.23),('15844','2013-07-06','11:45:00',4.26),('15844','2013-07-06','11:50:00',4.27),('15844','2013-07-06','11:55:00',4.29),('15844','2013-07-06','12:00:00',4.29),('15844','2013-07-06','12:05:00',4.3),('15844','2013-07-06','12:10:00',4.29),('15844','2013-07-06','12:15:00',4.27),('15844','2013-07-06','12:20:00',4.29),('15844','2013-07-06','12:25:00',4.33),('15844','2013-07-06','12:30:00',4.32),('15844','2013-07-06','12:35:00',4.32),('15844','2013-07-06','12:40:00',4.29),('15844','2013-07-06','12:45:00',4.26),('15844','2013-07-06','12:50:00',4.26),('15844','2013-07-06','12:55:00',4.26),('15844','2013-07-06','13:00:00',4.23),('15844','2013-07-06','13:05:00',4.23),('15844','2013-07-06','13:10:00',4.2),('15844','2013-07-06','13:15:00',4.13),('15844','2013-07-06','13:20:00',4.14),('15844','2013-07-06','13:25:00',4.15),('15844','2013-07-06','13:30:00',4.16),('15844','2013-07-06','13:35:00',4.14),('15844','2013-07-06','13:40:00',4.04),('15844','2013-07-06','13:45:00',4.07),('15844','2013-07-06','13:50:00',3.98),('15844','2013-07-06','13:55:00',3.93),('15844','2013-07-06','14:00:00',3.93),('15844','2013-07-06','14:05:00',3.87),('15844','2013-07-06','14:10:00',3.75),('15844','2013-07-06','14:15:00',3.7),('15844','2013-07-06','14:20:00',3.67),('15844','2013-07-06','14:25:00',3.6),('15844','2013-07-06','14:30:00',3.55),('15844','2013-07-06','14:35:00',3.48),('15844','2013-07-06','14:40:00',3.43),('15844','2013-07-06','14:45:00',3.37),('15844','2013-07-06','14:50:00',3.39),('15844','2013-07-06','14:55:00',3.34),('15844','2013-07-06','15:00:00',3.37),('15844','2013-07-06','15:05:00',3.35),('15844','2013-07-06','15:10:00',1.72),('15844','2013-07-06','15:15:00',1.31),('15844','2013-07-06','16:55:00',1.08),('15844','2013-07-06','17:00:00',1.09),('15844','2013-07-06','17:05:00',1.13),('15844','2013-07-06','17:10:00',1.35),('15844','2013-07-06','17:15:00',1.46),('15844','2013-07-06','17:20:00',1.12),('15844','2013-07-05','08:30:00',1.07),('15844','2013-07-05','08:35:00',1.16),('15844','2013-07-05','08:40:00',1.22),('15844','2013-07-05','08:45:00',1.27),('15844','2013-07-05','08:50:00',1.28),('15844','2013-07-05','08:55:00',1.36),('15844','2013-07-05','09:00:00',1.46),('15844','2013-07-05','09:05:00',1.55),('15844','2013-07-05','09:10:00',1.65),('15844','2013-07-05','09:15:00',1.74),('15844','2013-07-05','09:20:00',1.77),('15844','2013-07-05','09:25:00',1.87),('15844','2013-07-05','09:30:00',1.98),('15844','2013-07-05','09:35:00',2.14),('15844','2013-07-05','09:40:00',2.31),('15844','2013-07-05','09:45:00',2.45),('15844','2013-07-05','09:50:00',2.59),('15844','2013-07-05','09:55:00',2.72),('15844','2013-07-05','10:00:00',2.78),('15844','2013-07-05','10:05:00',2.88),('15844','2013-07-05','10:10:00',2.97),('15844','2013-07-05','10:15:00',3.06),('15844','2013-07-05','10:20:00',3.17),('15844','2013-07-05','10:25:00',3.25),('15844','2013-07-05','10:30:00',3.41),('15844','2013-07-05','10:35:00',3.58),('15844','2013-07-05','10:40:00',3.68),('15844','2013-07-05','10:45:00',3.74),('15844','2013-07-05','10:50:00',3.85),('15844','2013-07-05','10:55:00',3.93),('15844','2013-07-05','11:00:00',4),('15844','2013-07-05','11:05:00',4.03),('15844','2013-07-05','11:10:00',4.07),('15844','2013-07-05','11:15:00',4.15),('15844','2013-07-05','11:20:00',4.17),('15844','2013-07-05','11:25:00',4.2),('15844','2013-07-05','11:30:00',4.22),('15844','2013-07-05','11:35:00',4.16),('15844','2013-07-05','11:40:00',4.14),('15844','2013-07-05','11:45:00',4.16),('15844','2013-07-05','11:50:00',4.14),('15844','2013-07-05','11:55:00',4.14),('15844','2013-07-05','12:00:00',3.84),('15844','2013-07-05','12:05:00',3.1),('15844','2013-07-05','12:10:00',3.56),('15844','2013-07-05','12:15:00',3.88),('15844','2013-07-05','12:20:00',4),('15844','2013-07-05','12:25:00',4.38),('15844','2013-07-05','12:30:00',3.09),('15844','2013-07-05','12:35:00',3.76),('15844','2013-07-05','12:40:00',1.8),('15844','2013-07-05','12:45:00',2.48),('15844','2013-07-05','12:50:00',4.51),('15844','2013-07-05','12:55:00',1.95),('15844','2013-07-05','13:00:00',1.26),('15844','2013-07-05','13:05:00',3.91),('15844','2013-07-05','13:10:00',2.79),('15844','2013-07-05','13:15:00',2.93),('15844','2013-07-05','13:20:00',4.31),('15844','2013-07-05','13:25:00',4.28),('15844','2013-07-05','13:30:00',3.97),('15844','2013-07-05','13:35:00',4.2),('15844','2013-07-05','13:40:00',4.14),('15844','2013-07-05','13:45:00',4.1),('15844','2013-07-05','13:50:00',3.92),('15844','2013-07-05','13:55:00',3.94),('15844','2013-07-05','14:00:00',3.88),('15844','2013-07-05','14:05:00',3.85),('15844','2013-07-05','14:10:00',3.9),('15844','2013-07-05','14:15:00',3.8),('15844','2013-07-05','14:20:00',3.68),('15844','2013-07-05','14:25:00',3.59),('15844','2013-07-05','14:30:00',3.47),('15844','2013-07-05','14:35:00',3.44),('15844','2013-07-05','14:40:00',3.46),('15844','2013-07-05','14:45:00',3.42),('15844','2013-07-05','14:50:00',3.32),('15844','2013-07-05','14:55:00',3.24),('15844','2013-07-05','15:00:00',3.13),('15844','2013-07-05','15:05:00',3.08),('15844','2013-07-05','15:10:00',2.13),('15844','2013-07-05','15:15:00',2.03),('15844','2013-07-05','15:20:00',2.29),('15844','2013-07-05','15:25:00',2.57),('15844','2013-07-05','15:30:00',2.54),('15844','2013-07-05','15:35:00',2.31),('15844','2013-07-05','15:40:00',2.32),('15844','2013-07-05','15:45:00',2.25),('15844','2013-07-05','15:50:00',2.17),('15844','2013-07-05','15:55:00',2.03),('15844','2013-07-05','16:00:00',1.91),('15844','2013-07-05','16:05:00',1.85),('15844','2013-07-05','16:10:00',1.73),('15844','2013-07-05','16:15:00',1.67),('15844','2013-07-05','16:20:00',1.56),('15844','2013-07-05','16:25:00',1.51),('15844','2013-07-05','16:30:00',1.49),('15844','2013-07-05','16:35:00',1.44),('15844','2013-07-05','16:40:00',1.38),('15844','2013-07-05','16:45:00',1.3),('15844','2013-07-05','16:50:00',1.23),('15844','2013-07-05','16:55:00',1.11),('15844','2013-07-05','17:00:00',1),('15844','2013-07-04','11:20:00',1.11),('15844','2013-07-04','11:25:00',1.19),('15844','2013-07-04','11:30:00',1.27),('15844','2013-07-04','11:35:00',1.42),('15844','2013-07-04','11:40:00',1.43),('15844','2013-07-04','11:45:00',1.5),('15844','2013-07-04','11:50:00',1.48),('15844','2013-07-04','11:55:00',1.68),('15844','2013-07-04','12:00:00',1.81),('15844','2013-07-04','12:05:00',1.6),('15844','2013-07-04','12:10:00',1.27),('15844','2013-07-04','13:15:00',1.05),('15844','2013-07-04','13:20:00',1.33),('15844','2013-07-04','13:25:00',2.04),('15844','2013-07-04','13:30:00',2.14),('15844','2013-07-04','13:35:00',2.96),('15844','2013-07-04','13:40:00',3.58),('15844','2013-07-04','13:45:00',3.34),('15844','2013-07-04','13:50:00',2.09),('15844','2013-07-04','13:55:00',1.74),('15844','2013-07-04','14:00:00',3.5),('15844','2013-07-04','14:05:00',1.77),('15844','2013-07-04','14:10:00',1.51),('15844','2013-07-04','14:15:00',1.61),('15844','2013-07-04','14:20:00',1.88),('15844','2013-07-04','14:25:00',1.53),('15844','2013-07-04','14:30:00',1.46),('15844','2013-07-04','14:35:00',1.88),('15844','2013-07-04','14:40:00',1.82),('15844','2013-07-04','14:45:00',1.98),('15844','2013-07-04','14:50:00',1.53),('15844','2013-07-04','14:55:00',1.44),('15844','2013-07-04','15:00:00',1.64),('15844','2013-07-04','15:05:00',1.67),('15844','2013-07-04','15:10:00',2.35),('15844','2013-07-04','15:15:00',2.63),('15844','2013-07-04','15:20:00',2.19),('15844','2013-07-04','15:25:00',1.68),('15844','2013-07-04','15:30:00',2.41),('15844','2013-07-04','15:35:00',2.81),('15844','2013-07-04','15:40:00',1.89),('15844','2013-07-04','15:45:00',1.79),('15844','2013-07-04','15:50:00',2.19),('15844','2013-07-04','15:55:00',2.04),('15844','2013-07-04','16:00:00',1.59),('15844','2013-07-04','16:05:00',1.5),('15844','2013-07-04','16:10:00',1.61),('15844','2013-07-04','16:15:00',1.72),('15844','2013-07-04','16:20:00',1.7),('15844','2013-07-04','16:25:00',1.75),('15844','2013-07-04','16:30:00',1.66),('15844','2013-07-04','16:35:00',1.4),('15844','2013-07-04','16:40:00',1.22),('15844','2013-07-04','16:45:00',1.21),('15844','2013-07-04','16:50:00',1.13),('15844','2013-07-04','16:55:00',1.09),('15844','2013-07-04','17:00:00',1.15),('15844','2013-07-04','17:05:00',1.2),('15844','2013-07-04','17:10:00',1.07),('15844','2013-07-04','17:15:00',1.03),('15844','2013-07-04','17:20:00',1.12),('15844','2013-07-03','08:25:00',1.01),('15844','2013-07-03','08:30:00',1.11),('15844','2013-07-03','08:35:00',1.2),('15844','2013-07-03','08:40:00',1.26),('15844','2013-07-03','08:45:00',1.3),('15844','2013-07-03','08:50:00',1.33),('15844','2013-07-03','08:55:00',1.41),('15844','2013-07-03','09:00:00',1.49),('15844','2013-07-03','09:05:00',1.58),('15844','2013-07-03','09:10:00',1.68),('15844','2013-07-03','09:15:00',1.78),('15844','2013-07-03','09:20:00',1.84),('15844','2013-07-03','09:25:00',1.93),('15844','2013-07-03','09:30:00',2.05),('15844','2013-07-03','09:35:00',2.23),('15844','2013-07-03','09:40:00',2.35),('15844','2013-07-03','09:45:00',2.48),('15844','2013-07-03','09:50:00',2.62),('15844','2013-07-03','09:55:00',2.73),('15844','2013-07-03','10:00:00',2.9),('15844','2013-07-03','10:05:00',2.99),('15844','2013-07-03','10:10:00',3.05),('15844','2013-07-03','10:15:00',3.14),('15844','2013-07-03','10:20:00',3.25),('15844','2013-07-03','10:25:00',3.43),('15844','2013-07-03','10:30:00',3.66),('15844','2013-07-03','10:35:00',3.82),('15844','2013-07-03','10:40:00',3.91),('15844','2013-07-03','10:45:00',3.97),('15844','2013-07-03','10:50:00',4.01),('15844','2013-07-03','10:55:00',4.11),('15844','2013-07-03','11:00:00',4.13),('15844','2013-07-03','11:05:00',4.23),('15844','2013-07-03','11:10:00',4.23),('15844','2013-07-03','11:15:00',4.23),('15844','2013-07-03','11:20:00',4.33),('15844','2013-07-03','11:25:00',4.35),('15844','2013-07-03','11:30:00',4.38),('15844','2013-07-03','11:35:00',4.4),('15844','2013-07-03','11:40:00',4.44),('15844','2013-07-03','11:45:00',4.46),('15844','2013-07-03','11:50:00',4.46),('15844','2013-07-03','11:55:00',4.48),('15844','2013-07-03','12:00:00',4.48),('15844','2013-07-03','12:05:00',4.45),('15844','2013-07-03','12:10:00',4.47),('15844','2013-07-03','12:15:00',4.48),('15844','2013-07-03','12:20:00',4.46),('15844','2013-07-03','12:25:00',4.46),('15844','2013-07-03','12:30:00',4.47),('15844','2013-07-03','12:35:00',4.45),('15844','2013-07-03','12:40:00',4.44),('15844','2013-07-03','12:45:00',4.42),('15844','2013-07-03','12:50:00',4.38),('15844','2013-07-03','12:55:00',4.36),('15844','2013-07-03','13:00:00',4.36),('15844','2013-07-03','13:05:00',4.33),('15844','2013-07-03','13:10:00',4.32),('15844','2013-07-03','13:15:00',4.3),('15844','2013-07-03','13:20:00',4.29),('15844','2013-07-03','13:25:00',4.25),('15844','2013-07-03','13:30:00',4.21),('15844','2013-07-03','13:35:00',4.18),('15844','2013-07-03','13:40:00',4.15),('15844','2013-07-03','13:45:00',4.1),('15844','2013-07-03','13:50:00',4.07),('15844','2013-07-03','13:55:00',4.05),('15844','2013-07-03','14:00:00',4.02),('15844','2013-07-03','14:05:00',4),('15844','2013-07-03','14:10:00',3.94),('15844','2013-07-03','14:15:00',3.89),('15844','2013-07-03','14:20:00',3.85),('15844','2013-07-03','14:25:00',3.78),('15844','2013-07-03','14:30:00',3.68),('15844','2013-07-03','14:35:00',3.6),('15844','2013-07-03','14:40:00',3.55),('15844','2013-07-03','14:45:00',3.48),('15844','2013-07-03','14:50:00',3.38),('15844','2013-07-03','14:55:00',3.29),('15844','2013-07-03','15:00:00',3.18),('15844','2013-07-03','15:05:00',3.07),('15844','2013-07-03','15:10:00',2.97),('15844','2013-07-03','15:15:00',2.86),('15844','2013-07-03','15:20:00',2.75),('15844','2013-07-03','15:25:00',2.61),('15844','2013-07-03','15:30:00',2.5),('15844','2013-07-03','15:35:00',2.39),('15844','2013-07-03','15:40:00',2.27),('15844','2013-07-03','15:45:00',2.23),('15844','2013-07-03','15:50:00',2.16),('15844','2013-07-03','15:55:00',2.07),('15844','2013-07-03','16:00:00',1.97),('15844','2013-07-03','16:05:00',1.86),('15844','2013-07-03','16:10:00',1.77),('15844','2013-07-03','16:15:00',1.68),('15844','2013-07-03','16:20:00',1.59),('15844','2013-07-03','16:25:00',1.52),('15844','2013-07-03','16:30:00',1.48),('15844','2013-07-03','16:35:00',1.43),('15844','2013-07-03','16:40:00',1.37),('15844','2013-07-03','16:45:00',1.29),('15844','2013-07-03','16:50:00',1.19),('15844','2013-07-03','16:55:00',1.08),('15844','2013-07-02','08:30:00',1.09),('15844','2013-07-02','08:35:00',1.18),('15844','2013-07-02','08:40:00',1.26),('15844','2013-07-02','08:45:00',1.29),('15844','2013-07-02','08:50:00',1.3),('15844','2013-07-02','08:55:00',1.38),('15844','2013-07-02','09:00:00',1.49),('15844','2013-07-02','09:05:00',1.58),('15844','2013-07-02','09:10:00',1.66),('15844','2013-07-02','09:15:00',1.75),('15844','2013-07-02','09:20:00',1.82),('15844','2013-07-02','09:25:00',1.92),('15844','2013-07-02','09:30:00',2.06),('15844','2013-07-02','09:35:00',2.21),('15844','2013-07-02','09:40:00',2.35),('15844','2013-07-02','09:45:00',2.49),('15844','2013-07-02','09:50:00',2.63),('15844','2013-07-02','09:55:00',2.74),('15844','2013-07-02','10:00:00',2.82),('15844','2013-07-02','10:05:00',2.9),('15844','2013-07-02','10:10:00',2.98),('15844','2013-07-02','10:15:00',3.06),('15844','2013-07-02','10:20:00',3.13),('15844','2013-07-02','10:25:00',3.31),('15844','2013-07-02','10:30:00',3.43),('15844','2013-07-02','10:35:00',3.55),('15844','2013-07-02','10:40:00',3.69),('15844','2013-07-02','10:45:00',3.76),('15844','2013-07-02','10:50:00',3.81),('15844','2013-07-02','10:55:00',3.95),('15844','2013-07-02','11:00:00',4),('15844','2013-07-02','11:05:00',4.06),('15844','2013-07-02','11:10:00',4.11),('15844','2013-07-02','11:15:00',4.14),('15844','2013-07-02','11:20:00',4.14),('15844','2013-07-02','11:25:00',4.21),('15844','2013-07-02','11:30:00',4.21),('15844','2013-07-02','11:35:00',4.17),('15844','2013-07-02','11:40:00',4.24),('15844','2013-07-02','11:45:00',4.23),('15844','2013-07-02','11:50:00',4.22),('15844','2013-07-02','11:55:00',4.23),('15844','2013-07-02','12:00:00',4.25),('15844','2013-07-02','12:05:00',4.37),('15844','2013-07-02','12:10:00',4.39),('15844','2013-07-02','12:15:00',4.31),('15844','2013-07-02','12:20:00',4.31),('15844','2013-07-02','12:25:00',4.25),('15844','2013-07-02','12:30:00',4.24),('15844','2013-07-02','12:35:00',4.14),('15844','2013-07-02','12:40:00',4.34),('15844','2013-07-02','12:45:00',4.26),('15844','2013-07-02','12:50:00',4.17),('15844','2013-07-02','12:55:00',4.18),('15844','2013-07-02','13:00:00',4.16),('15844','2013-07-02','13:05:00',4.14),('15844','2013-07-02','13:10:00',4.12),('15844','2013-07-02','13:15:00',4.17),('15844','2013-07-02','13:20:00',4.15),('15844','2013-07-02','13:25:00',4.08),('15844','2013-07-02','13:30:00',4.05),('15844','2013-07-02','13:35:00',4),('15844','2013-07-02','13:40:00',4),('15844','2013-07-02','13:45:00',3.99),('15844','2013-07-02','13:50:00',3.95),('15844','2013-07-02','13:55:00',3.9),('15844','2013-07-02','14:00:00',3.89),('15844','2013-07-02','14:05:00',3.81),('15844','2013-07-02','14:10:00',3.74),('15844','2013-07-02','14:15:00',3.68),('15844','2013-07-02','14:20:00',3.69),('15844','2013-07-02','14:25:00',3.63),('15844','2013-07-02','14:30:00',3.55),('15844','2013-07-02','14:35:00',3.51),('15844','2013-07-02','14:40:00',3.46),('15844','2013-07-02','14:45:00',3.42),('15844','2013-07-02','14:50:00',3.33),('15844','2013-07-02','14:55:00',3.2),('15844','2013-07-02','15:00:00',3.11),('15844','2013-07-02','15:05:00',3.02),('15844','2013-07-02','15:10:00',2.91),('15844','2013-07-02','15:15:00',2.78),('15844','2013-07-02','15:20:00',2.68),('15844','2013-07-02','15:25:00',2.58),('15844','2013-07-02','15:30:00',2.46),('15844','2013-07-02','15:35:00',2.35),('15844','2013-07-02','15:40:00',2.27),('15844','2013-07-02','15:45:00',2.21),('15844','2013-07-02','15:50:00',2.12),('15844','2013-07-02','15:55:00',2.04),('15844','2013-07-02','16:00:00',1.94),('15844','2013-07-02','16:05:00',1.85),('15844','2013-07-02','16:10:00',1.76),('15844','2013-07-02','16:15:00',1.68),('15844','2013-07-02','16:20:00',1.58),('15844','2013-07-02','16:25:00',1.52),('15844','2013-07-02','16:30:00',1.48),('15844','2013-07-02','16:35:00',1.44),('15844','2013-07-02','16:40:00',1.37),('15844','2013-07-02','16:45:00',1.29),('15844','2013-07-02','16:50:00',1.2),('15844','2013-07-02','16:55:00',1.08),('15844','2013-07-01','08:25:00',1.03),('15844','2013-07-01','08:30:00',1.12),('15844','2013-07-01','08:35:00',1.2),('15844','2013-07-01','08:40:00',1.26),('15844','2013-07-01','08:45:00',1.31),('15844','2013-07-01','08:50:00',1.33),('15844','2013-07-01','08:55:00',1.41),('15844','2013-07-01','09:00:00',1.52),('15844','2013-07-01','09:05:00',1.6),('15844','2013-07-01','09:10:00',1.69),('15844','2013-07-01','09:15:00',1.8),('15844','2013-07-01','09:20:00',1.87),('15844','2013-07-01','09:25:00',1.98),('15844','2013-07-01','09:30:00',2.15),('15844','2013-07-01','09:35:00',2.3),('15844','2013-07-01','09:40:00',2.44),('15844','2013-07-01','09:45:00',2.57),('15844','2013-07-01','09:50:00',2.69),('15844','2013-07-01','09:55:00',2.82),('15844','2013-07-01','10:00:00',2.92),('15844','2013-07-01','10:05:00',3.01),('15844','2013-07-01','10:10:00',3.12),('15844','2013-07-01','10:15:00',3.19),('15844','2013-07-01','10:20:00',3.27),('15844','2013-07-01','10:25:00',3.34),('15844','2013-07-01','10:30:00',3.58),('15844','2013-07-01','10:35:00',3.79),('15844','2013-07-01','10:40:00',3.95),('15844','2013-07-01','10:45:00',3.98),('15844','2013-07-01','10:50:00',4.03),('15844','2013-07-01','10:55:00',4.15),('15844','2013-07-01','11:00:00',4.24),('15844','2013-07-01','11:05:00',4.29),('15844','2013-07-01','11:10:00',4.31),('15844','2013-07-01','11:15:00',4.33),('15844','2013-07-01','11:20:00',4.35),('15844','2013-07-01','11:25:00',4.36),('15844','2013-07-01','11:30:00',4.39),('15844','2013-07-01','11:35:00',4.4),('15844','2013-07-01','11:40:00',4.36),('15844','2013-07-01','11:45:00',4.33),('15844','2013-07-01','11:50:00',4.4),('15844','2013-07-01','11:55:00',4.43),('15844','2013-07-01','12:00:00',4.43),('15844','2013-07-01','12:05:00',4.42),('15844','2013-07-01','12:10:00',4.41),('15844','2013-07-01','12:15:00',4.44),('15844','2013-07-01','12:20:00',4.41),('15844','2013-07-01','12:25:00',4.4),('15844','2013-07-01','12:30:00',4.43),('15844','2013-07-01','12:35:00',4.42),('15844','2013-07-01','12:40:00',4.25),('15844','2013-07-01','12:45:00',4.14),('15844','2013-07-01','12:50:00',4.18),('15844','2013-07-01','12:55:00',4.3),('15844','2013-07-01','13:00:00',4.15),('15844','2013-07-01','13:05:00',4.21),('15844','2013-07-01','13:10:00',4.21),('15844','2013-07-01','13:15:00',3.84),('15844','2013-07-01','13:20:00',4.33),('15844','2013-07-01','13:25:00',4.29),('15844','2013-07-01','13:30:00',4.19),('15844','2013-07-01','13:35:00',4.03),('15844','2013-07-01','13:40:00',3.95),('15844','2013-07-01','13:45:00',3.99),('15844','2013-07-01','13:50:00',3.93),('15844','2013-07-01','13:55:00',3.9),('15844','2013-07-01','14:00:00',3.85),('15844','2013-07-01','14:05:00',3.85),('15844','2013-07-01','14:10:00',3.83),('15844','2013-07-01','14:15:00',3.83),('15844','2013-07-01','14:20:00',3.75),('15844','2013-07-01','14:25:00',3.65),('15844','2013-07-01','14:30:00',3.59),('15844','2013-07-01','14:35:00',3.58),('15844','2013-07-01','14:40:00',3.5),('15844','2013-07-01','14:45:00',3.43),('15844','2013-07-01','14:50:00',3.32),('15844','2013-07-01','14:55:00',3.24),('15844','2013-07-01','15:00:00',3.15),('15844','2013-07-01','15:05:00',2.94),('15844','2013-07-01','15:10:00',2.94),('15844','2013-07-01','15:15:00',2.83),('15844','2013-07-01','15:20:00',2.71),('15844','2013-07-01','15:25:00',2.57),('15844','2013-07-01','15:30:00',2.45),('15844','2013-07-01','15:35:00',2.35),('15844','2013-07-01','15:40:00',2.29),('15844','2013-07-01','15:45:00',2.24),('15844','2013-07-01','15:50:00',2.15),('15844','2013-07-01','15:55:00',2.05),('15844','2013-07-01','16:00:00',1.98),('15844','2013-07-01','16:05:00',1.85),('15844','2013-07-01','16:10:00',1.71),('15844','2013-07-01','16:15:00',1.68),('15844','2013-07-01','16:20:00',1.62),('15844','2013-07-01','16:25:00',1.54),('15844','2013-07-01','16:30:00',1.48),('15844','2013-07-01','16:35:00',1.46),('15844','2013-07-01','16:40:00',1.39),('15844','2013-07-01','16:45:00',1.31),('15844','2013-07-01','16:50:00',1.22),('15844','2013-07-01','16:55:00',1.1),('15844','2014-04-05','09:25:00',1.34),('15844','2014-04-05','09:30:00',1.46),('15844','2014-04-05','09:35:00',1.39),('15844','2014-04-05','09:40:00',1.54),('15844','2014-04-05','09:45:00',1.87),('15844','2014-04-05','09:50:00',3.08),('15844','2014-04-05','09:55:00',2.83),('15844','2014-04-05','10:00:00',2.27),('15844','2014-04-05','10:05:00',1.69),('15844','2014-04-05','10:10:00',1.8),('15844','2014-04-05','10:15:00',1.78),('15844','2014-04-05','10:20:00',1.92),('15844','2014-04-05','10:25:00',2.6),('15844','2014-04-05','10:30:00',3.16),('15844','2014-04-05','10:35:00',3.45),('15844','2014-04-05','10:40:00',3.11),('15844','2014-04-05','10:45:00',3.26),('15844','2014-04-05','10:50:00',3.3),('15844','2014-04-05','10:55:00',3.13),('15844','2014-04-05','11:00:00',3.28),('15844','2014-04-05','11:05:00',3.09),('15844','2014-04-05','11:10:00',2.43),('15844','2014-04-05','11:15:00',2.83),('15844','2014-04-05','11:20:00',3.25),('15844','2014-04-05','11:25:00',3.64),('15844','2014-04-05','11:30:00',3.84),('15844','2014-04-05','11:35:00',3.8),('15844','2014-04-05','11:40:00',3.3),('15844','2014-04-05','11:45:00',3.45),('15844','2014-04-05','11:50:00',2.83),('15844','2014-04-05','11:55:00',2.62),('15844','2014-04-05','12:00:00',2.29),('15844','2014-04-05','12:05:00',2.36),('15844','2014-04-05','12:10:00',2.8),('15844','2014-04-05','12:15:00',2.62),('15844','2014-04-05','12:20:00',2.45),('15844','2014-04-05','12:25:00',2.43),('15844','2014-04-05','12:30:00',2.92),('15844','2014-04-05','12:35:00',3.37),('15844','2014-04-05','12:40:00',3.48),('15844','2014-04-05','12:45:00',3.34),('15844','2014-04-05','12:50:00',2.19),('15844','2014-04-05','12:55:00',2.41),('15844','2014-04-05','13:00:00',2.5),('15844','2014-04-05','13:05:00',3.89),('15844','2014-04-05','13:10:00',4.57),('15844','2014-04-05','13:15:00',1.82),('15844','2014-04-05','13:20:00',1.99),('15844','2014-04-05','13:25:00',3.38),('15844','2014-04-05','13:30:00',3.04),('15844','2014-04-05','13:35:00',2.9),('15844','2014-04-05','13:40:00',1.69),('15844','2014-04-05','13:45:00',2.38),('15844','2014-04-05','13:50:00',3.45),('15844','2014-04-05','13:55:00',3.72),('15844','2014-04-05','14:00:00',4.06),('15844','2014-04-05','14:05:00',4.25),('15844','2014-04-05','14:10:00',1.72),('15844','2014-04-05','14:55:00',2.6),('15844','2014-04-05','15:00:00',2.03),('15844','2014-04-05','15:05:00',2.7),('15844','2014-04-05','15:10:00',2.59),('15844','2014-04-05','15:15:00',2.46),('15844','2014-04-05','15:20:00',2.36),('15844','2014-04-05','15:25:00',2.43),('15844','2014-04-05','15:30:00',1.56),('15844','2014-04-05','15:35:00',1.39),('15844','2014-04-05','15:40:00',1.91),('15844','2014-04-05','15:45:00',1.25),('15844','2014-04-05','16:05:00',1.02),('15844','2014-04-05','16:10:00',1.05),('15844','2014-04-05','16:15:00',1.08),('15844','2014-04-05','16:25:00',1.34),('15844','2014-04-05','16:30:00',1.48),('15844','2014-04-05','16:35:00',1.45),('15844','2014-04-05','16:40:00',1.38),('15844','2014-04-05','16:45:00',1.14),('15844','2013-06-30','08:25:00',1.06),('15844','2013-06-30','08:30:00',1.15),('15844','2013-06-30','08:35:00',1.24),('15844','2013-06-30','08:40:00',1.32),('15844','2013-06-30','08:45:00',1.35),('15844','2013-06-30','08:50:00',1.36),('15844','2013-06-30','08:55:00',1.44),('15844','2013-06-30','09:00:00',1.57),('15844','2013-06-30','09:05:00',1.66),('15844','2013-06-30','09:10:00',1.73),('15844','2013-06-30','09:15:00',1.84),('15844','2013-06-30','09:20:00',1.92),('15844','2013-06-30','09:25:00',2.01),('15844','2013-06-30','09:30:00',2.18),('15844','2013-06-30','09:35:00',2.34),('15844','2013-06-30','09:40:00',2.5),('15844','2013-06-30','09:45:00',2.62),('15844','2013-06-30','09:50:00',2.78),('15844','2013-06-30','09:55:00',2.88),('15844','2013-06-30','10:00:00',2.97),('15844','2013-06-30','10:05:00',3.05),('15844','2013-06-30','10:10:00',3.18),('15844','2013-06-30','10:15:00',3.3),('15844','2013-06-30','10:20:00',3.43),('15844','2013-06-30','10:25:00',3.57),('15844','2013-06-30','10:30:00',3.7),('15844','2013-06-30','10:35:00',3.85),('15844','2013-06-30','10:40:00',3.94),('15844','2013-06-30','10:45:00',4.01),('15844','2013-06-30','10:50:00',4.08),('15844','2013-06-30','10:55:00',4.18),('15844','2013-06-30','11:00:00',4.24),('15844','2013-06-30','11:05:00',4.28),('15844','2013-06-30','11:10:00',4.33),('15844','2013-06-30','11:15:00',4.35),('15844','2013-06-30','11:20:00',4.38),('15844','2013-06-30','11:25:00',4.43),('15844','2013-06-30','11:30:00',4.43),('15844','2013-06-30','11:35:00',4.46),('15844','2013-06-30','11:40:00',4.45),('15844','2013-06-30','11:45:00',4.47),('15844','2013-06-30','11:50:00',4.43),('15844','2013-06-30','11:55:00',4.42),('15844','2013-06-30','12:00:00',4.39),('15844','2013-06-30','12:05:00',4.42),('15844','2013-06-30','12:10:00',4.41),('15844','2013-06-30','12:15:00',4.41),('15844','2013-06-30','12:20:00',4.44),('15844','2013-06-30','12:25:00',4.41),('15844','2013-06-30','12:30:00',4.37),('15844','2013-06-30','12:35:00',4.39),('15844','2013-06-30','12:40:00',4.38),('15844','2013-06-30','12:45:00',3.61),('15844','2013-06-30','12:50:00',4.41),('15844','2013-06-30','12:55:00',3.09),('15844','2013-06-30','13:00:00',4.08),('15844','2013-06-30','13:05:00',3.42),('15844','2013-06-30','13:10:00',2.16),('15844','2013-06-30','13:15:00',2.37),('15844','2013-06-30','13:20:00',4.12),('15844','2013-06-30','13:25:00',2.55),('15844','2013-06-30','13:30:00',1.72),('15844','2013-06-30','13:35:00',1.77),('15844','2013-06-30','13:40:00',4.55),('15844','2013-06-30','13:45:00',4.43),('15844','2013-06-30','13:50:00',4.3),('15844','2013-06-30','13:55:00',4.1),('15844','2013-06-30','14:00:00',3.41),('15844','2013-06-30','14:05:00',2.76),('15844','2013-06-30','14:10:00',4),('15844','2013-06-30','14:15:00',3.93),('15844','2013-06-30','14:20:00',3.79),('15844','2013-06-30','14:25:00',3.73),('15844','2013-06-30','14:30:00',3.62),('15844','2013-06-30','14:35:00',3.53),('15844','2013-06-30','14:40:00',3.5),('15844','2013-06-30','14:45:00',3.43),('15844','2013-06-30','14:50:00',3.34),('15844','2013-06-30','14:55:00',3.28),('15844','2013-06-30','15:00:00',3.2),('15844','2013-06-30','15:05:00',3.1),('15844','2013-06-30','15:10:00',2.96),('15844','2013-06-30','15:15:00',2.89),('15844','2013-06-30','15:20:00',2.8),('15844','2013-06-30','15:25:00',2.67),('15844','2013-06-30','15:30:00',2.57),('15844','2013-06-30','15:35:00',2.45),('15844','2013-06-30','15:40:00',2.33),('15844','2013-06-30','15:45:00',2.26),('15844','2013-06-30','15:50:00',2.18),('15844','2013-06-30','15:55:00',2.11),('15844','2013-06-30','16:00:00',2.01),('15844','2013-06-30','16:05:00',1.93),('15844','2013-06-30','16:10:00',1.84),('15844','2013-06-30','16:15:00',1.77),('15844','2013-06-30','16:20:00',1.71),('15844','2013-06-30','16:25:00',1.65),('15844','2013-06-30','16:30:00',1.59),('15844','2013-06-30','16:35:00',1.49),('15844','2013-06-30','16:40:00',1.43),('15844','2013-06-30','16:45:00',1.34),('15844','2013-06-30','16:50:00',1.22),('15844','2013-06-30','16:55:00',1.1),('15844','2013-06-30','17:00:00',1.01),('15844','2013-06-29','07:50:00',1.09),('15844','2013-06-29','07:55:00',1.14),('15844','2013-06-29','08:35:00',1.09),('15844','2013-06-29','08:40:00',1.29),('15844','2013-06-29','08:45:00',1.37),('15844','2013-06-29','08:50:00',1.36),('15844','2013-06-29','08:55:00',1.44),('15844','2013-06-29','09:00:00',1.56),('15844','2013-06-29','09:05:00',1.65),('15844','2013-06-29','09:10:00',1.73),('15844','2013-06-29','09:15:00',1.83),('15844','2013-06-29','09:20:00',1.91),('15844','2013-06-29','09:25:00',2.01),('15844','2013-06-29','09:30:00',2.17),('15844','2013-06-29','09:35:00',2.33),('15844','2013-06-29','09:40:00',2.47),('15844','2013-06-29','09:45:00',2.59),('15844','2013-06-29','09:50:00',2.76),('15844','2013-06-29','09:55:00',2.87),('15844','2013-06-29','10:00:00',2.97),('15844','2013-06-29','10:05:00',3.07),('15844','2013-06-29','10:10:00',3.13),('15844','2013-06-29','10:15:00',3.22),('15844','2013-06-29','10:20:00',3.29),('15844','2013-06-29','10:25:00',3.39),('15844','2013-06-29','10:30:00',3.63),('15844','2013-06-29','10:35:00',3.87),('15844','2013-06-29','10:40:00',4),('15844','2013-06-29','10:45:00',4.05),('15844','2013-06-29','10:50:00',1.53),('15844','2013-06-29','10:55:00',2.4),('15844','2013-06-29','11:00:00',4.34),('15844','2013-06-29','11:05:00',1.42),('15844','2013-06-29','11:15:00',3.18),('15844','2013-06-29','11:20:00',4.26),('15844','2013-06-29','11:25:00',4.88),('15844','2013-06-29','11:30:00',3.18),('15844','2013-06-29','11:40:00',4.45),('15844','2013-06-29','11:45:00',3.95),('15844','2013-06-29','11:50:00',1.91),('15844','2013-06-29','11:55:00',4.88),('15844','2013-06-29','12:00:00',3.04),('15844','2013-06-29','12:05:00',4.75),('15844','2013-06-29','12:10:00',4.72),('15844','2013-06-29','12:15:00',4.74),('15844','2013-06-29','12:20:00',4.7),('15844','2013-06-29','12:25:00',4.71),('15844','2013-06-29','12:30:00',4.75),('15844','2013-06-29','12:35:00',4.84),('15844','2013-06-29','12:40:00',4.43),('15844','2013-06-29','12:45:00',4.49),('15844','2013-06-29','12:50:00',3.75),('15844','2013-06-29','12:55:00',4.54),('15844','2013-06-29','13:00:00',4.61),('15844','2013-06-29','13:05:00',4.73),('15844','2013-06-29','13:10:00',3.8),('15844','2013-06-29','13:15:00',2.61),('15844','2013-06-29','13:20:00',1.24),('15844','2013-06-29','13:25:00',1.19),('15844','2013-06-29','13:30:00',3.39),('15844','2013-06-29','13:35:00',4.59),('15844','2013-06-29','13:40:00',4.29),('15844','2013-06-29','13:45:00',4.42),('15844','2013-06-29','13:50:00',4.32),('15844','2013-06-29','13:55:00',4.11),('15844','2013-06-29','14:00:00',4.19),('15844','2013-06-29','14:05:00',4.07),('15844','2013-06-29','14:10:00',4.13),('15844','2013-06-29','14:15:00',4.27),('15844','2013-06-29','14:20:00',4.07),('15844','2013-06-29','14:25:00',3.91),('15844','2013-06-29','14:30:00',3.87),('15844','2013-06-29','14:35:00',3.86),('15844','2013-06-29','14:40:00',3.81),('15844','2013-06-29','14:45:00',3.83),('15844','2013-06-29','14:50:00',3.84),('15844','2013-06-29','14:55:00',4.04),('15844','2013-06-29','15:00:00',3.95),('15844','2013-06-29','15:05:00',4.17),('15844','2013-06-29','15:10:00',3.87),('15844','2013-06-29','15:15:00',4.06),('15844','2013-06-29','15:20:00',2.61),('15844','2013-06-29','15:25:00',1.57),('15844','2013-06-29','15:30:00',1.36),('15844','2013-06-29','16:30:00',1.06),('15844','2013-06-29','16:35:00',1.46),('15844','2013-06-29','16:40:00',2.11),('15844','2013-06-29','16:45:00',1.9),('15844','2013-06-29','16:50:00',1.13),('15844','2013-06-29','16:55:00',1.14),('15844','2013-06-29','17:00:00',1.19),('15844','2013-06-29','17:10:00',1.02),('15844','2013-06-29','17:15:00',1.21),('15844','2013-06-29','17:20:00',1.26),('15844','2013-06-29','17:25:00',1.14),('15844','2013-06-28','08:25:00',1.05),('15844','2013-06-28','08:30:00',1.13),('15844','2013-06-28','08:35:00',1.23),('15844','2013-06-28','08:40:00',1.33),('15844','2013-06-28','08:45:00',1.38),('15844','2013-06-28','08:50:00',1.32),('15844','2013-06-28','08:55:00',1.4),('15844','2013-06-28','09:00:00',1.63),('15844','2013-06-28','09:05:00',1.7),('15844','2013-06-28','09:10:00',1.87),('15844','2013-06-28','09:15:00',1.23),('15844','2013-06-28','09:20:00',2.08),('15844','2013-06-28','09:25:00',2.35),('15844','2013-06-28','09:30:00',2.34),('15844','2013-06-28','09:35:00',2.4),('15844','2013-06-28','09:40:00',1.71),('15844','2013-06-28','09:50:00',3.11),('15844','2013-06-28','09:55:00',3.36),('15844','2013-06-28','10:00:00',2.85),('15844','2013-06-28','10:05:00',2.85),('15844','2013-06-28','10:10:00',1.27),('15844','2013-06-28','10:20:00',2.2),('15844','2013-06-28','10:25:00',1.79),('15844','2013-06-28','10:30:00',1.07),('15844','2013-06-28','10:35:00',2.63),('15844','2013-06-28','10:40:00',2.95),('15844','2013-06-28','10:45:00',2.63),('15844','2013-06-28','10:50:00',4.37),('15844','2013-06-28','10:55:00',4.69),('15844','2013-06-28','11:00:00',4.14),('15844','2013-06-28','11:05:00',1.48),('15844','2013-06-28','11:10:00',1.74),('15844','2013-06-28','11:15:00',4.46),('15844','2013-06-28','11:20:00',4.35),('15844','2013-06-28','11:25:00',4.71),('15844','2013-06-28','11:30:00',4.63),('15844','2013-06-28','11:35:00',4.23),('15844','2013-06-28','11:40:00',3.87),('15844','2013-06-28','11:45:00',4.52),('15844','2013-06-28','11:50:00',4.67),('15844','2013-06-28','11:55:00',3.75),('15844','2013-06-28','12:00:00',3.04),('15844','2013-06-28','12:05:00',3.81),('15844','2013-06-28','12:10:00',4.46),('15844','2013-06-28','12:15:00',3.87),('15844','2013-06-28','12:20:00',4.02),('15844','2013-06-28','12:25:00',3.79),('15844','2013-06-28','12:30:00',4.67),('15844','2013-06-28','12:35:00',4.6),('15844','2013-06-28','12:40:00',4.6),('15844','2013-06-28','12:45:00',4.26),('15844','2013-06-28','12:50:00',4.63),('15844','2013-06-28','12:55:00',4.6),('15844','2013-06-28','13:00:00',4.51),('15844','2013-06-28','13:05:00',4.47),('15844','2013-06-28','13:10:00',4.46),('15844','2013-06-28','13:15:00',4.38),('15844','2013-06-28','13:20:00',4.4),('15844','2013-06-28','13:25:00',4.22),('15844','2013-06-28','13:30:00',4.29),('15844','2013-06-28','13:35:00',4.27),('15844','2013-06-28','13:40:00',4.4),('15844','2013-06-28','13:45:00',4.07),('15844','2013-06-28','13:50:00',4.25),('15844','2013-06-28','13:55:00',4.15),('15844','2013-06-28','14:00:00',4.34),('15844','2013-06-28','14:05:00',3.67),('15844','2013-06-28','14:10:00',2.39),('15844','2013-06-28','14:15:00',3.57),('15844','2013-06-28','14:20:00',4.05),('15844','2013-06-28','14:25:00',3.38),('15844','2013-06-28','14:30:00',1.9),('15844','2013-06-28','14:35:00',3.49),('15844','2013-06-28','14:40:00',2.74),('15844','2013-06-28','14:45:00',3.2),('15844','2013-06-28','14:50:00',1.01),('15844','2013-06-28','14:55:00',3.14),('15844','2013-06-28','15:00:00',2.17),('15844','2013-06-28','15:05:00',3.34),('15844','2013-06-28','15:10:00',1.12),('15844','2013-06-28','15:15:00',2.4),('15844','2013-06-28','15:20:00',2.1),('15844','2013-06-28','15:25:00',1.98),('15844','2013-06-28','15:30:00',2.37),('15844','2013-06-28','15:35:00',1.87),('15844','2013-06-28','15:40:00',1.36),('15844','2013-06-28','15:45:00',1.92),('15844','2013-06-28','15:50:00',2.48),('15844','2013-06-28','15:55:00',2.26),('15844','2013-06-28','16:00:00',1.81),('15844','2013-06-28','16:05:00',1.64),('15844','2013-06-28','16:10:00',1.95),('15844','2013-06-28','16:15:00',1.08),('15844','2013-06-28','16:20:00',1.96),('15844','2013-06-28','16:25:00',1.87),('15844','2013-06-28','16:30:00',1.14),('15844','2013-06-28','16:35:00',2.12),('15844','2013-06-28','16:40:00',2.03),('15844','2013-06-28','16:45:00',1.9),('15844','2013-06-28','16:50:00',1.73),('15844','2013-06-28','16:55:00',1.37),('15844','2013-06-28','17:00:00',1.14),('15844','2013-06-27','08:25:00',1.09),('15844','2013-06-27','08:30:00',1.16),('15844','2013-06-27','08:35:00',1.22),('15844','2013-06-27','08:40:00',1.3),('15844','2013-06-27','08:45:00',1.32),('15844','2013-06-27','08:55:00',1.02),('15844','2013-06-27','09:00:00',1.44),('15844','2013-06-27','09:05:00',1.71),('15844','2013-06-27','09:10:00',1.79),('15844','2013-06-27','09:15:00',1.9),('15844','2013-06-27','09:20:00',1.95),('15844','2013-06-27','09:25:00',2.06),('15844','2013-06-27','09:30:00',2.25),('15844','2013-06-27','09:35:00',2.38),('15844','2013-06-27','09:40:00',2.5),('15844','2013-06-27','09:45:00',2.63),('15844','2013-06-27','09:50:00',2.81),('15844','2013-06-27','09:55:00',2.9),('15844','2013-06-27','10:00:00',2.98),('15844','2013-06-27','10:05:00',3.07),('15844','2013-06-27','10:10:00',3.19),('15844','2013-06-27','10:15:00',3.29),('15844','2013-06-27','10:20:00',3.49),('15844','2013-06-27','10:25:00',3.69),('15844','2013-06-27','10:30:00',3.89),('15844','2013-06-27','10:35:00',3.66),('15844','2013-06-27','10:40:00',1.89),('15844','2013-06-27','10:45:00',1.58),('15844','2013-06-27','10:50:00',2.79),('15844','2013-06-27','10:55:00',4.54),('15844','2013-06-27','11:00:00',2.7),('15844','2013-06-27','11:05:00',4.11),('15844','2013-06-27','11:10:00',1.7),('15844','2013-06-27','11:15:00',4.46),('15844','2013-06-27','11:20:00',4.03),('15844','2013-06-27','11:25:00',4.55),('15844','2013-06-27','11:30:00',3.15),('15844','2013-06-27','11:35:00',1.43),('15844','2013-06-27','11:40:00',1.09),('15844','2013-06-27','11:45:00',1.19),('15844','2013-06-27','11:50:00',1.98),('15844','2013-06-27','11:55:00',2.91),('15844','2013-06-27','12:00:00',3.51),('15844','2013-06-27','12:05:00',1.19),('15844','2013-06-27','12:10:00',1.28),('15844','2013-06-27','12:15:00',1.39),('15844','2013-06-27','12:20:00',1.55),('15844','2013-06-27','12:25:00',1.17),('15844','2013-06-27','12:30:00',1.05),('15844','2013-06-27','12:35:00',1.11),('15844','2013-06-27','12:40:00',1.27),('15844','2013-06-27','12:45:00',1.84),('15844','2013-06-27','12:50:00',4.22),('15844','2013-06-27','12:55:00',1.73),('15844','2013-06-27','13:00:00',3),('15844','2013-06-27','13:05:00',3.76),('15844','2013-06-27','13:10:00',1.54),('15844','2013-06-27','13:15:00',1.41),('15844','2013-06-27','13:20:00',2.22),('15844','2013-06-27','13:25:00',4.04),('15844','2013-06-27','13:30:00',1.72),('15844','2013-06-27','13:35:00',2.13),('15844','2013-06-27','13:40:00',3.36),('15844','2013-06-27','13:45:00',3.62),('15844','2013-06-27','13:50:00',4.31),('15844','2013-06-27','13:55:00',4.24),('15844','2013-06-27','14:00:00',4.09),('15844','2013-06-27','14:05:00',3.94),('15844','2013-06-27','14:10:00',3.82),('15844','2013-06-27','14:15:00',3.74),('15844','2013-06-27','14:20:00',3.81),('15844','2013-06-27','14:25:00',3.94),('15844','2013-06-27','14:30:00',4),('15844','2013-06-27','14:35:00',3.61),('15844','2013-06-27','14:40:00',1.54),('15844','2013-06-27','14:45:00',2.57),('15844','2013-06-27','14:50:00',3.43),('15844','2013-06-27','14:55:00',3.22),('15844','2013-06-27','15:00:00',3.13),('15844','2013-06-27','15:05:00',3.02),('15844','2013-06-27','15:10:00',2.92),('15844','2013-06-27','15:15:00',2.81),('15844','2013-06-27','15:20:00',2.73),('15844','2013-06-27','15:25:00',2.6),('15844','2013-06-27','15:30:00',2.49),('15844','2013-06-27','15:35:00',2.36),('15844','2013-06-27','15:40:00',2.28),('15844','2013-06-27','15:45:00',2.22),('15844','2013-06-27','15:50:00',2.14),('15844','2013-06-27','15:55:00',2.03),('15844','2013-06-27','16:00:00',1.93),('15844','2013-06-27','16:05:00',1.86),('15844','2013-06-27','16:10:00',1.79),('15844','2013-06-27','16:15:00',1.7),('15844','2013-06-27','16:20:00',1.63),('15844','2013-06-27','16:25:00',1.57),('15844','2013-06-27','16:30:00',1.5),('15844','2013-06-27','16:35:00',1.45),('15844','2013-06-27','16:40:00',1.43),('15844','2013-06-27','16:45:00',1.34),('15844','2013-06-27','16:50:00',1.25),('15844','2013-06-27','16:55:00',1.14),('15844','2013-06-27','17:00:00',1.02),('15844','2013-06-26','08:25:00',1.09),('15844','2013-06-26','08:30:00',1.16),('15844','2013-06-26','08:35:00',1.22),('15844','2013-06-26','08:40:00',1.31),('15844','2013-06-26','08:45:00',1.34),('15844','2013-06-26','08:50:00',1.37),('15844','2013-06-26','08:55:00',1.47),('15844','2013-06-26','09:00:00',1.57),('15844','2013-06-26','09:05:00',1.64),('15844','2013-06-26','09:10:00',1.72),('15844','2013-06-26','09:15:00',1.81),('15844','2013-06-26','09:20:00',1.91),('15844','2013-06-26','09:25:00',2.01),('15844','2013-06-26','09:30:00',2.17),('15844','2013-06-26','09:35:00',2.3),('15844','2013-06-26','09:40:00',2.41),('15844','2013-06-26','09:45:00',2.53),('15844','2013-06-26','09:50:00',2.71),('15844','2013-06-26','09:55:00',2.84),('15844','2013-06-26','10:00:00',2.92),('15844','2013-06-26','10:05:00',3.03),('15844','2013-06-26','10:10:00',3.16),('15844','2013-06-26','10:15:00',3.32),('15844','2013-06-26','10:20:00',3.38),('15844','2013-06-26','10:25:00',3.48),('15844','2013-06-26','10:30:00',3.62),('15844','2013-06-26','10:35:00',3.7),('15844','2013-06-26','10:40:00',3.85),('15844','2013-06-26','10:45:00',3.94),('15844','2013-06-26','10:50:00',4.01),('15844','2013-06-26','10:55:00',4.1),('15844','2013-06-26','11:00:00',4.16),('15844','2013-06-26','11:05:00',4.19),('15844','2013-06-26','11:10:00',4.22),('15844','2013-06-26','11:15:00',4.22),('15844','2013-06-26','11:20:00',4.26),('15844','2013-06-26','11:25:00',4.31),('15844','2013-06-26','11:30:00',4.33),('15844','2013-06-26','11:35:00',4.3),('15844','2013-06-26','11:40:00',4.35),('15844','2013-06-26','11:45:00',4.41),('15844','2013-06-26','11:50:00',4.4),('15844','2013-06-26','11:55:00',4.42),('15844','2013-06-26','12:00:00',4.45),('15844','2013-06-26','12:05:00',4.44),('15844','2013-06-26','12:10:00',4.45),('15844','2013-06-26','12:15:00',4.43),('15844','2013-06-26','12:20:00',4.45),('15844','2013-06-26','12:25:00',4.44),('15844','2013-06-26','12:30:00',4.44),('15844','2013-06-26','12:35:00',4.46),('15844','2013-06-26','12:40:00',4.49),('15844','2013-06-26','12:45:00',4.5),('15844','2013-06-26','12:50:00',4.48),('15844','2013-06-26','12:55:00',4.47),('15844','2013-06-26','13:00:00',3.99),('15844','2013-06-26','13:10:00',3.72),('15844','2013-06-26','13:15:00',4.79),('15844','2013-06-26','13:20:00',4.62),('15844','2013-06-26','13:25:00',4.59),('15844','2013-06-26','13:30:00',4.49),('15844','2013-06-26','13:35:00',3.12),('15844','2013-06-26','13:45:00',1.69),('15844','2013-06-26','13:50:00',4.26),('15844','2013-06-26','13:55:00',4.23),('15844','2013-06-26','14:00:00',3.99),('15844','2013-06-26','14:05:00',3.9),('15844','2013-06-26','14:10:00',3.85),('15844','2013-06-26','14:15:00',3.8),('15844','2013-06-26','14:20:00',3.76),('15844','2013-06-26','14:25:00',3.73),('15844','2013-06-26','14:30:00',3.65),('15844','2013-06-26','14:35:00',3.61),('15844','2013-06-26','14:40:00',3.55),('15844','2013-06-26','14:45:00',3.46),('15844','2013-06-26','14:50:00',3.34),('15844','2013-06-26','14:55:00',3.25),('15844','2013-06-26','15:00:00',3.15),('15844','2013-06-26','15:05:00',3.02),('15844','2013-06-26','15:10:00',2.92),('15844','2013-06-26','15:15:00',2.81),('15844','2013-06-26','15:20:00',2.73),('15844','2013-06-26','15:25:00',2.59),('15844','2013-06-26','15:30:00',2.47),('15844','2013-06-26','15:35:00',2.39),('15844','2013-06-26','15:40:00',2.31),('15844','2013-06-26','15:45:00',2.23),('15844','2013-06-26','15:50:00',2.14),('15844','2013-06-26','15:55:00',2.05),('15844','2013-06-26','16:00:00',1.98),('15844','2013-06-26','16:05:00',1.89),('15844','2013-06-26','16:10:00',1.79),('15844','2013-06-26','16:15:00',1.68),('15844','2013-06-26','16:20:00',1.61),('15844','2013-06-26','16:25:00',1.55),('15844','2013-06-26','16:30:00',1.52),('15844','2013-06-26','16:35:00',1.46),('15844','2013-06-26','16:40:00',1.39),('15844','2013-06-26','16:45:00',1.31),('15844','2013-06-26','16:50:00',1.21),('15844','2013-06-26','16:55:00',1.07),('15844','2013-06-25','08:20:00',1.05),('15844','2013-06-25','08:35:00',1.15),('15844','2013-06-25','08:40:00',1.3),('15844','2013-06-25','08:45:00',1.37),('15844','2013-06-25','08:50:00',1.46),('15844','2013-06-25','08:55:00',1.5),('15844','2013-06-25','09:00:00',1.54),('15844','2013-06-25','09:05:00',1.66),('15844','2013-06-25','09:10:00',1.79),('15844','2013-06-25','09:15:00',1.92),('15844','2013-06-25','09:20:00',1.99),('15844','2013-06-25','09:25:00',2.14),('15844','2013-06-25','09:30:00',2.31),('15844','2013-06-25','09:35:00',2.45),('15844','2013-06-25','09:40:00',2.67),('15844','2013-06-25','09:45:00',2.76),('15844','2013-06-25','09:50:00',3),('15844','2013-06-25','09:55:00',3.16),('15844','2013-06-25','10:00:00',3.36),('15844','2013-06-25','10:05:00',3.53),('15844','2013-06-25','10:10:00',3.72),('15844','2013-06-25','10:15:00',2.95),('15844','2013-06-25','10:20:00',1.6),('15844','2013-06-25','10:25:00',2.81),('15844','2013-06-25','10:30:00',1.12),('15844','2013-06-25','10:35:00',2.54),('15844','2013-06-25','10:40:00',4.41),('15844','2013-06-25','10:45:00',4.39),('15844','2013-06-25','10:50:00',2.79),('15844','2013-06-25','10:55:00',4.42),('15844','2013-06-25','11:00:00',4.52),('15844','2013-06-25','11:05:00',4.6),('15844','2013-06-25','11:10:00',3.47),('15844','2013-06-25','11:15:00',2.05),('15844','2013-06-25','11:20:00',3.1),('15844','2013-06-25','11:25:00',5.1),('15844','2013-06-25','11:30:00',2.55),('15844','2013-06-25','11:35:00',1.4),('15844','2013-06-25','11:40:00',2.54),('15844','2013-06-25','11:45:00',1.06),('15844','2013-06-25','11:50:00',1.93),('15844','2013-06-25','11:55:00',3.25),('15844','2013-06-25','12:00:00',3.29),('15844','2013-06-25','12:05:00',3.22),('15844','2013-06-25','12:10:00',2.18),('15844','2013-06-25','12:15:00',3.09),('15844','2013-06-25','12:20:00',1.75),('15844','2013-06-25','12:25:00',3.05),('15844','2013-06-25','12:30:00',3.98),('15844','2013-06-25','12:35:00',3.04),('15844','2013-06-25','12:40:00',4.77),('15844','2013-06-25','12:45:00',3.09),('15844','2013-06-25','12:50:00',3.79),('15844','2013-06-25','12:55:00',4.81),('15844','2013-06-25','13:00:00',3.31),('15844','2013-06-25','13:05:00',4.6),('15844','2013-06-25','13:10:00',4.48),('15844','2013-06-25','13:15:00',4.39),('15844','2013-06-25','13:20:00',4.34),('15844','2013-06-25','13:25:00',4.31),('15844','2013-06-25','13:30:00',4.26),('15844','2013-06-25','13:35:00',4.25),('15844','2013-06-25','13:40:00',4.17),('15844','2013-06-25','13:45:00',4.18),('15844','2013-06-25','13:50:00',4.14),('15844','2013-06-25','13:55:00',4.09),('15844','2013-06-25','14:00:00',4.03),('15844','2013-06-25','14:05:00',3.95),('15844','2013-06-25','14:10:00',3.88),('15844','2013-06-25','14:15:00',3.83),('15844','2013-06-25','14:20:00',3.79),('15844','2013-06-25','14:25:00',3.71),('15844','2013-06-25','14:30:00',3.68),('15844','2013-06-25','14:35:00',3.59),('15844','2013-06-25','14:40:00',3.51),('15844','2013-06-25','14:45:00',3.46),('15844','2013-06-25','14:50:00',3.39),('15844','2013-06-25','14:55:00',3.25),('15844','2013-06-25','15:00:00',3.16),('15844','2013-06-25','15:05:00',3.06),('15844','2013-06-25','15:10:00',2.93),('15844','2013-06-25','15:15:00',2.84),('15844','2013-06-25','15:20:00',2.71),('15844','2013-06-25','15:25:00',2.59),('15844','2013-06-25','15:30:00',2.5),('15844','2013-06-25','15:35:00',2.41),('15844','2013-06-25','15:40:00',2.31),('15844','2013-06-25','15:45:00',2.24),('15844','2013-06-25','15:50:00',2.16),('15844','2013-06-25','15:55:00',2.07),('15844','2013-06-25','16:00:00',1.97),('15844','2013-06-25','16:05:00',1.87),('15844','2013-06-25','16:10:00',1.76),('15844','2013-06-25','16:15:00',1.67),('15844','2013-06-25','16:20:00',1.59),('15844','2013-06-25','16:25:00',1.52),('15844','2013-06-25','16:30:00',1.49),('15844','2013-06-25','16:35:00',1.44),('15844','2013-06-25','16:40:00',1.37),('15844','2013-06-25','16:45:00',1.28),('15844','2013-06-25','16:50:00',1.18),('15844','2013-06-25','16:55:00',1.06),('15844','2013-06-24','08:30:00',1.29),('15844','2013-06-24','08:40:00',1.21),('15844','2013-06-24','08:45:00',1.48),('15844','2013-06-24','08:50:00',1.54),('15844','2013-06-24','08:55:00',1.63),('15844','2013-06-24','09:00:00',2.2),('15844','2013-06-24','09:05:00',1.23),('15844','2013-06-24','09:10:00',1.51),('15844','2013-06-24','09:15:00',2.1),('15844','2013-06-24','09:20:00',1.47),('15844','2013-06-24','09:30:00',2.28),('15844','2013-06-24','09:35:00',2.34),('15844','2013-06-24','09:40:00',2.52),('15844','2013-06-24','09:45:00',2.88),('15844','2013-06-24','09:50:00',2.97),('15844','2013-06-24','09:55:00',3.06),('15844','2013-06-24','10:00:00',3.16),('15844','2013-06-24','10:05:00',3.25),('15844','2013-06-24','10:10:00',3.44),('15844','2013-06-24','10:15:00',2.46),('15844','2013-06-24','10:20:00',2.56),('15844','2013-06-24','10:25:00',2.67),('15844','2013-06-24','10:30:00',3.56),('15844','2013-06-24','10:35:00',2.93),('15844','2013-06-24','10:40:00',2.12),('15844','2013-06-24','10:45:00',4.08),('15844','2013-06-24','10:50:00',3.77),('15844','2013-06-24','10:55:00',1.88),('15844','2013-06-24','11:00:00',1.78),('15844','2013-06-24','11:05:00',4.68),('15844','2013-06-24','11:10:00',1.98),('15844','2013-06-24','11:15:00',1.69),('15844','2013-06-24','11:20:00',2.4),('15844','2013-06-24','11:25:00',1.01),('15844','2013-06-24','11:30:00',1.11),('15844','2013-06-24','11:35:00',1.42),('15844','2013-06-24','11:40:00',1.38),('15844','2013-06-24','11:45:00',2.29),('15844','2013-06-24','11:50:00',1.47),('15844','2013-06-24','11:55:00',2.49),('15844','2013-06-24','12:00:00',4.06),('15844','2013-06-24','12:05:00',3.06),('15844','2013-06-24','12:10:00',1.97),('15844','2013-06-24','12:15:00',2.44),('15844','2013-06-24','12:20:00',2.38),('15844','2013-06-24','12:25:00',2.58),('15844','2013-06-24','12:30:00',3.92),('15844','2013-06-24','12:35:00',3.31),('15844','2013-06-24','12:40:00',2.39),('15844','2013-06-24','12:45:00',2.13),('15844','2013-06-24','12:50:00',3.71),('15844','2013-06-24','12:55:00',2.81),('15844','2013-06-24','13:00:00',3.48),('15844','2013-06-24','13:05:00',3.69),('15844','2013-06-24','13:10:00',4.7),('15844','2013-06-24','13:15:00',4.5),('15844','2013-06-24','13:20:00',4.17),('15844','2013-06-24','13:25:00',4.02),('15844','2013-06-24','13:30:00',4.06),('15844','2013-06-24','13:35:00',3.89),('15844','2013-06-24','13:40:00',3.65),('15844','2013-06-24','13:45:00',4.52),('15844','2013-06-24','13:50:00',3.52),('15844','2013-06-24','13:55:00',4.09),('15844','2013-06-24','14:00:00',3.72),('15844','2013-06-24','14:05:00',4.09),('15844','2013-06-24','14:10:00',4),('15844','2013-06-24','14:15:00',3.93),('15844','2013-06-24','14:20:00',3.98),('15844','2013-06-24','14:25:00',3.96),('15844','2013-06-24','14:30:00',2.99),('15844','2013-06-24','14:35:00',3.59),('15844','2013-06-24','14:40:00',3.98),('15844','2013-06-24','14:45:00',3.07),('15844','2013-06-24','14:50:00',3.14),('15844','2013-06-24','14:55:00',2.54),('15844','2013-06-24','15:00:00',3.31),('15844','2013-06-24','15:05:00',3),('15844','2013-06-24','15:10:00',2.92),('15844','2013-06-24','15:15:00',2.16),('15844','2013-06-24','15:20:00',1.42),('15844','2013-06-24','15:25:00',2.75),('15844','2013-06-24','15:30:00',2.84),('15844','2013-06-24','15:35:00',1.88),('15844','2013-06-24','15:40:00',2.78),('15844','2013-06-24','15:45:00',2.14),('15844','2013-06-24','15:50:00',1.39),('15844','2013-06-24','15:55:00',2.08),('15844','2013-06-24','16:00:00',1.56),('15844','2013-06-24','16:05:00',2.01),('15844','2013-06-24','16:10:00',1.39),('15844','2013-06-24','16:15:00',1.96),('15844','2013-06-24','16:20:00',1.71),('15844','2013-06-24','16:30:00',1.6),('15844','2013-06-24','16:35:00',1.12),('15844','2013-06-24','16:40:00',1.4),('15844','2013-06-24','16:45:00',1.1),('15844','2013-06-24','16:50:00',1.35),('15844','2013-06-24','16:55:00',1.56),('15844','2013-06-24','17:00:00',1.36),('15844','2013-06-24','17:35:00',1.03),('15844','2013-06-23','08:50:00',1.09),('15844','2013-06-23','08:55:00',1.07),('15844','2013-06-23','09:00:00',1.02),('15844','2013-06-23','09:15:00',1.72),('15844','2013-06-23','09:20:00',2.07),('15844','2013-06-23','09:25:00',2.16),('15844','2013-06-23','09:30:00',2.3),('15844','2013-06-23','09:35:00',2.45),('15844','2013-06-23','09:40:00',1.75),('15844','2013-06-23','09:45:00',1.01),('15844','2013-06-23','09:50:00',2.75),('15844','2013-06-23','09:55:00',3.04),('15844','2013-06-23','10:00:00',2.66),('15844','2013-06-23','10:05:00',3.06),('15844','2013-06-23','10:10:00',3.24),('15844','2013-06-23','10:15:00',3.32),('15844','2013-06-23','10:20:00',3.37),('15844','2013-06-23','10:25:00',3.55),('15844','2013-06-23','10:30:00',3.73),('15844','2013-06-23','10:35:00',3.84),('15844','2013-06-23','10:40:00',3.93),('15844','2013-06-23','10:45:00',4.02),('15844','2013-06-23','10:50:00',4.04),('15844','2013-06-23','10:55:00',4.17),('15844','2013-06-23','11:00:00',4.27),('15844','2013-06-23','11:05:00',4.28),('15844','2013-06-23','11:10:00',4.31),('15844','2013-06-23','11:15:00',4.38),('15844','2013-06-23','11:20:00',4.36),('15844','2013-06-23','11:25:00',4.4),('15844','2013-06-23','11:30:00',4.38),('15844','2013-06-23','11:35:00',4.33),('15844','2013-06-23','11:40:00',4.37),('15844','2013-06-23','11:45:00',4.33),('15844','2013-06-23','11:50:00',4.42),('15844','2013-06-23','11:55:00',4.46),('15844','2013-06-23','12:00:00',4.47),('15844','2013-06-23','12:05:00',4.42),('15844','2013-06-23','12:10:00',4.44),('15844','2013-06-23','12:15:00',4.46),('15844','2013-06-23','12:20:00',4.5),('15844','2013-06-23','12:25:00',4.47),('15844','2013-06-23','12:30:00',4.48),('15844','2013-06-23','12:35:00',4.45),('15844','2013-06-23','12:40:00',4.45),('15844','2013-06-23','12:45:00',4.43),('15844','2013-06-23','12:50:00',4.42),('15844','2013-06-23','12:55:00',4.4),('15844','2013-06-23','13:00:00',4.35),('15844','2013-06-23','13:05:00',4.36),('15844','2013-06-23','13:10:00',4.34),('15844','2013-06-23','13:15:00',4.31),('15844','2013-06-23','13:20:00',4.32),('15844','2013-06-23','13:25:00',4.26),('15844','2013-06-23','13:30:00',4.27),('15844','2013-06-23','13:35:00',4.24),('15844','2013-06-23','13:40:00',4.2),('15844','2013-06-23','13:45:00',4.17),('15844','2013-06-23','13:50:00',4.13),('15844','2013-06-23','13:55:00',4.12),('15844','2013-06-23','14:00:00',4.07),('15844','2013-06-23','14:05:00',4.02),('15844','2013-06-23','14:10:00',3.98),('15844','2013-06-23','14:15:00',3.91),('15844','2013-06-23','14:20:00',3.84),('15844','2013-06-23','14:25:00',3.78),('15844','2013-06-23','14:30:00',3.71),('15844','2013-06-23','14:35:00',3.66),('15844','2013-06-23','14:40:00',3.6),('15844','2013-06-23','14:45:00',3.52),('15844','2013-06-23','14:50:00',3.43),('15844','2013-06-23','14:55:00',3.33),('15844','2013-06-23','15:00:00',3.19),('15844','2013-06-23','15:05:00',3.11),('15844','2013-06-23','15:10:00',3.02),('15844','2013-06-23','15:15:00',2.86),('15844','2013-06-23','15:20:00',2.72),('15844','2013-06-23','15:25:00',2.59),('15844','2013-06-23','15:30:00',2.48),('15844','2013-06-23','15:35:00',2.39),('15844','2013-06-23','15:40:00',2.27),('15844','2013-06-23','15:45:00',2.22),('15844','2013-06-23','15:50:00',2.14),('15844','2013-06-23','15:55:00',2.06),('15844','2013-06-23','16:00:00',1.95),('15844','2013-06-23','16:05:00',1.84),('15844','2013-06-23','16:10:00',1.75),('15844','2013-06-23','16:15:00',1.67),('15844','2013-06-23','16:20:00',1.57),('15844','2013-06-23','16:25:00',1.52),('15844','2013-06-23','16:30:00',1.48),('15844','2013-06-23','16:35:00',1.43),('15844','2013-06-23','16:40:00',1.35),('15844','2013-06-23','16:45:00',1.27),('15844','2013-06-23','16:50:00',1.15),('15844','2013-06-23','16:55:00',1.04),('15844','2013-06-22','08:25:00',1.07),('15844','2013-06-22','08:30:00',1.15),('15844','2013-06-22','08:35:00',1.19),('15844','2013-06-22','08:40:00',1.28),('15844','2013-06-22','08:45:00',1.33),('15844','2013-06-22','08:50:00',1.38),('15844','2013-06-22','08:55:00',1.47),('15844','2013-06-22','09:00:00',1.55),('15844','2013-06-22','09:05:00',1.63),('15844','2013-06-22','09:10:00',1.7),('15844','2013-06-22','09:15:00',1.79),('15844','2013-06-22','09:20:00',1.88),('15844','2013-06-22','09:25:00',2),('15844','2013-06-22','09:30:00',2.17),('15844','2013-06-22','09:35:00',2.29),('15844','2013-06-22','09:40:00',2.4),('15844','2013-06-22','09:45:00',2.55),('15844','2013-06-22','09:50:00',2.73),('15844','2013-06-22','09:55:00',2.85),('15844','2013-06-22','10:00:00',2.92),('15844','2013-06-22','10:05:00',3.01),('15844','2013-06-22','10:10:00',3.12),('15844','2013-06-22','10:15:00',3.26),('15844','2013-06-22','10:20:00',3.35),('15844','2013-06-22','10:25:00',3.44),('15844','2013-06-22','10:30:00',3.59),('15844','2013-06-22','10:35:00',3.73),('15844','2013-06-22','10:40:00',3.81),('15844','2013-06-22','10:45:00',3.9),('15844','2013-06-22','10:50:00',3.96),('15844','2013-06-22','10:55:00',4.06),('15844','2013-06-22','11:00:00',4.15),('15844','2013-06-22','11:05:00',4.15),('15844','2013-06-22','11:10:00',4.21),('15844','2013-06-22','11:15:00',4.26),('15844','2013-06-22','11:20:00',4.31),('15844','2013-06-22','11:25:00',4.28),('15844','2013-06-22','11:30:00',4.28),('15844','2013-06-22','11:35:00',4.27),('15844','2013-06-22','11:40:00',4.25),('15844','2013-06-22','11:45:00',4.26),('15844','2013-06-22','11:50:00',4.26),('15844','2013-06-22','11:55:00',4.29),('15844','2013-06-22','12:00:00',4.36),('15844','2013-06-22','12:05:00',4.26),('15844','2013-06-22','12:10:00',4.32),('15844','2013-06-22','12:15:00',4.32),('15844','2013-06-22','12:20:00',4.3),('15844','2013-06-22','12:25:00',4.29),('15844','2013-06-22','12:30:00',4.3),('15844','2013-06-22','12:35:00',4.3),('15844','2013-06-22','12:40:00',4.26),('15844','2013-06-22','12:45:00',4.2),('15844','2013-06-22','12:50:00',4.16),('15844','2013-06-22','12:55:00',4.15),('15844','2013-06-22','13:00:00',4.01),('15844','2013-06-22','13:05:00',4.04),('15844','2013-06-22','13:10:00',4.05),('15844','2013-06-22','13:15:00',4.24),('15844','2013-06-22','13:20:00',4.22),('15844','2013-06-22','13:25:00',4.15),('15844','2013-06-22','13:30:00',4.17),('15844','2013-06-22','13:35:00',3.88),('15844','2013-06-22','13:40:00',3.6),('15844','2013-06-22','13:45:00',4.34),('15844','2013-06-22','13:50:00',2.99),('15844','2013-06-22','13:55:00',2.75),('15844','2013-06-22','14:00:00',4.2),('15844','2013-06-22','14:05:00',4.22),('15844','2013-06-22','14:10:00',3.86),('15844','2013-06-22','14:15:00',2.94),('15844','2013-06-22','14:20:00',3.15),('15844','2013-06-22','14:25:00',2.63),('15844','2013-06-22','14:30:00',1.87),('15844','2013-06-22','14:35:00',1.54),('15844','2013-06-22','14:40:00',2.43),('15844','2013-06-22','14:45:00',2.84),('15844','2013-06-22','14:50:00',3.28),('15844','2013-06-22','14:55:00',3.48),('15844','2013-06-22','15:00:00',3.15),('15844','2013-06-22','15:05:00',2.78),('15844','2013-06-22','15:10:00',3.23),('15844','2013-06-22','15:15:00',3.02),('15844','2013-06-22','15:20:00',2.84),('15844','2013-06-22','15:25:00',2.46),('15844','2013-06-22','15:30:00',2.13),('15844','2013-06-22','15:35:00',1.98),('15844','2013-06-22','15:40:00',2.31),('15844','2013-06-22','15:45:00',1.76),('15844','2013-06-22','15:50:00',1.82),('15844','2013-06-22','15:55:00',1.84),('15844','2013-06-22','16:00:00',1.18),('15844','2013-06-22','16:05:00',1.04),('15844','2013-06-22','16:10:00',1.14),('15844','2013-06-22','16:15:00',1.46),('15844','2013-06-22','16:20:00',1.23),('15844','2013-06-22','16:25:00',1.04),('15844','2013-06-22','16:55:00',1.3),('15844','2013-06-22','17:00:00',1.41),('15844','2013-06-22','17:05:00',1.36),('15844','2013-06-22','17:10:00',1.6),('15844','2013-06-22','17:15:00',1.43),('15844','2013-06-22','17:20:00',1.27),('15844','2013-06-22','17:25:00',1.03),('15844','2013-06-21','08:30:00',1.14),('15844','2013-06-21','08:35:00',1.21),('15844','2013-06-21','08:40:00',1.25),('15844','2013-06-21','08:45:00',1.28),('15844','2013-06-21','08:50:00',1.33),('15844','2013-06-21','08:55:00',1.43),('15844','2013-06-21','09:00:00',1.52),('15844','2013-06-21','09:05:00',1.59),('15844','2013-06-21','09:10:00',1.67),('15844','2013-06-21','09:15:00',1.73),('15844','2013-06-21','09:20:00',1.81),('15844','2013-06-21','09:25:00',1.9),('15844','2013-06-21','09:30:00',2.02),('15844','2013-06-21','09:35:00',2.21),('15844','2013-06-21','09:40:00',2.34),('15844','2013-06-21','09:45:00',2.46),('15844','2013-06-21','09:50:00',2.61),('15844','2013-06-21','09:55:00',2.69),('15844','2013-06-21','10:00:00',2.8),('15844','2013-06-21','10:05:00',2.9),('15844','2013-06-21','10:10:00',2.96),('15844','2013-06-21','10:15:00',3.04),('15844','2013-06-21','10:20:00',3.21),('15844','2013-06-21','10:25:00',3.33),('15844','2013-06-21','10:30:00',3.35),('15844','2013-06-21','10:35:00',3.49),('15844','2013-06-21','10:40:00',3.56),('15844','2013-06-21','10:45:00',3.64),('15844','2013-06-21','10:50:00',3.76),('15844','2013-06-21','10:55:00',3.92),('15844','2013-06-21','11:00:00',3.98),('15844','2013-06-21','11:05:00',3.96),('15844','2013-06-21','11:10:00',3.99),('15844','2013-06-21','11:15:00',4.06),('15844','2013-06-21','11:20:00',4.07),('15844','2013-06-21','11:25:00',4.09),('15844','2013-06-21','11:30:00',4.08),('15844','2013-06-21','11:35:00',4.07),('15844','2013-06-21','11:40:00',4.13),('15844','2013-06-21','11:45:00',4.13),('15844','2013-06-21','11:50:00',4.21),('15844','2013-06-21','11:55:00',4.16),('15844','2013-06-21','12:00:00',4.2),('15844','2013-06-21','12:05:00',4.2),('15844','2013-06-21','12:10:00',4.09),('15844','2013-06-21','12:15:00',4.05),('15844','2013-06-21','12:20:00',4.14),('15844','2013-06-21','12:25:00',4.23),('15844','2013-06-21','12:30:00',4.12),('15844','2013-06-21','12:35:00',4.15),('15844','2013-06-21','12:40:00',4.09),('15844','2013-06-21','12:45:00',4.09),('15844','2013-06-21','12:50:00',4.09),('15844','2013-06-21','12:55:00',4.07),('15844','2013-06-21','13:00:00',4.05),('15844','2013-06-21','13:05:00',3.96),('15844','2013-06-21','13:10:00',4.04),('15844','2013-06-21','13:15:00',4),('15844','2013-06-21','13:20:00',3.9),('15844','2013-06-21','13:25:00',3.91),('15844','2013-06-21','13:30:00',3.91),('15844','2013-06-21','13:35:00',3.96),('15844','2013-06-21','13:40:00',3.95),('15844','2013-06-21','13:45:00',3.93),('15844','2013-06-21','13:50:00',3.89),('15844','2013-06-21','13:55:00',3.86),('15844','2013-06-21','14:00:00',3.83),('15844','2013-06-21','14:05:00',3.78),('15844','2013-06-21','14:10:00',3.75),('15844','2013-06-21','14:15:00',3.73),('15844','2013-06-21','14:20:00',3.64),('15844','2013-06-21','14:25:00',3.59),('15844','2013-06-21','14:30:00',3.52),('15844','2013-06-21','14:35:00',3.46),('15844','2013-06-21','14:40:00',3.41),('15844','2013-06-21','14:45:00',3.34),('15844','2013-06-21','14:50:00',3.26),('15844','2013-06-21','14:55:00',3.17),('15844','2013-06-21','15:00:00',3.05),('15844','2013-06-21','15:05:00',2.96),('15844','2013-06-21','15:10:00',2.85),('15844','2013-06-21','15:15:00',2.73),('15844','2013-06-21','15:20:00',2.61),('15844','2013-06-21','15:25:00',2.49),('15844','2013-06-21','15:30:00',2.39),('15844','2013-06-21','15:35:00',2.32),('15844','2013-06-21','15:40:00',2.22),('15844','2013-06-21','15:45:00',2.16),('15844','2013-06-21','15:50:00',2.09),('15844','2013-06-21','15:55:00',2),('15844','2013-06-21','16:00:00',1.91),('15844','2013-06-21','16:05:00',1.82),('15844','2013-06-21','16:10:00',1.71),('15844','2013-06-21','16:15:00',1.61),('15844','2013-06-21','16:20:00',1.54),('15844','2013-06-21','16:25:00',1.48),('15844','2013-06-21','16:30:00',1.44),('15844','2013-06-21','16:35:00',1.4),('15844','2013-06-21','16:40:00',1.3),('15844','2013-06-21','16:45:00',1.24),('15844','2013-06-21','16:50:00',1.12),('15844','2013-06-21','16:55:00',1.01),('15844','2014-04-04','08:50:00',1.04),('15844','2014-04-04','08:55:00',1.17),('15844','2014-04-04','09:00:00',1.41),('15844','2014-04-04','09:05:00',1.3),('15844','2014-04-04','09:10:00',1.26),('15844','2014-04-04','09:15:00',1.21),('15844','2014-04-04','13:00:00',1.21),('15844','2014-04-04','13:05:00',1.34),('15844','2014-04-04','13:10:00',1.28),('15844','2014-04-04','13:15:00',1.83),('15844','2014-04-04','13:20:00',1.64),('15844','2014-04-04','13:25:00',2.51),('15844','2014-04-04','13:30:00',2.57),('15844','2014-04-04','13:35:00',1.51),('15844','2014-04-04','13:40:00',2.33),('15844','2014-04-04','13:45:00',3.3),('15844','2014-04-04','13:50:00',1.52),('15844','2014-04-04','13:55:00',2.13),('15844','2014-04-04','14:00:00',3.89),('15844','2014-04-04','14:05:00',1.94),('15844','2014-04-04','14:10:00',1.85),('15844','2014-04-04','14:15:00',1.61),('15844','2014-04-04','14:20:00',1.13),('15844','2014-04-04','14:25:00',2.16),('15844','2014-04-04','14:30:00',3.37),('15844','2014-04-04','14:35:00',2.93),('15844','2014-04-04','14:40:00',1.78),('15844','2014-04-04','14:45:00',1.67),('15844','2014-04-04','14:55:00',1.58),('15844','2014-04-04','15:00:00',1.46),('15844','2014-04-04','15:05:00',1.94),('15844','2014-04-04','15:10:00',2.06),('15844','2014-04-04','15:15:00',1.39),('15844','2014-04-04','15:20:00',1.79),('15844','2014-04-04','15:25:00',1.49),('15844','2014-04-04','15:45:00',1.07),('15844','2014-04-04','15:50:00',1.21),('15844','2014-04-04','15:55:00',1.51),('15844','2014-04-04','16:00:00',1.83),('15844','2014-04-04','16:05:00',1.57),('15844','2014-04-04','16:10:00',1.39),('15844','2014-04-04','16:15:00',1.36),('15844','2014-04-04','16:20:00',1.34),('15844','2014-04-04','16:25:00',1.01),('15844','2014-04-04','16:35:00',1.1),('15844','2014-04-04','16:40:00',1.26),('15844','2014-04-04','16:45:00',1.03),('15844','2014-04-04','16:50:00',1.1),('15844','2014-04-04','16:55:00',1.18),('15844','2014-04-04','17:00:00',1.23),('15844','2014-04-04','17:05:00',1.02),('15844','2013-06-20','08:25:00',1.03),('15844','2013-06-20','08:30:00',1.12),('15844','2013-06-20','08:35:00',1.19),('15844','2013-06-20','08:40:00',1.24),('15844','2013-06-20','08:45:00',1.27),('15844','2013-06-20','08:50:00',1.3),('15844','2013-06-20','08:55:00',1.41),('15844','2013-06-20','09:00:00',1.5),('15844','2013-06-20','09:05:00',1.58),('15844','2013-06-20','09:10:00',1.65),('15844','2013-06-20','09:15:00',1.75),('15844','2013-06-20','09:20:00',1.82),('15844','2013-06-20','09:25:00',1.94),('15844','2013-06-20','09:30:00',2.12),('15844','2013-06-20','09:35:00',2.25),('15844','2013-06-20','09:40:00',2.37),('15844','2013-06-20','09:45:00',2.51),('15844','2013-06-20','09:50:00',2.66),('15844','2013-06-20','09:55:00',2.76),('15844','2013-06-20','10:00:00',2.85),('15844','2013-06-20','10:05:00',2.95),('15844','2013-06-20','10:10:00',3.01),('15844','2013-06-20','10:15:00',3.08),('15844','2013-06-20','10:20:00',3.23),('15844','2013-06-20','10:25:00',3.37),('15844','2013-06-20','10:30:00',3.5),('15844','2013-06-20','10:35:00',3.57),('15844','2013-06-20','10:40:00',3.71),('15844','2013-06-20','10:45:00',3.77),('15844','2013-06-20','10:50:00',3.76),('15844','2013-06-20','10:55:00',3.89),('15844','2013-06-20','11:00:00',4.04),('15844','2013-06-20','11:05:00',4.08),('15844','2013-06-20','11:10:00',4.1),('15844','2013-06-20','11:15:00',4.12),('15844','2013-06-20','11:20:00',4.09),('15844','2013-06-20','11:25:00',4.01),('15844','2013-06-20','11:30:00',3.97),('15844','2013-06-20','11:35:00',3.9),('15844','2013-06-20','11:40:00',3.9),('15844','2013-06-20','11:45:00',4.02),('15844','2013-06-20','11:50:00',4.1),('15844','2013-06-20','11:55:00',4.15),('15844','2013-06-20','12:00:00',4.09),('15844','2013-06-20','12:05:00',4.02),('15844','2013-06-20','12:10:00',4),('15844','2013-06-20','12:15:00',4.03),('15844','2013-06-20','12:20:00',3.99),('15844','2013-06-20','12:25:00',3.93),('15844','2013-06-20','12:30:00',3.86),('15844','2013-06-20','12:35:00',3.82),('15844','2013-06-20','12:40:00',3.91),('15844','2013-06-20','12:45:00',4.09),('15844','2013-06-20','12:50:00',4.11),('15844','2013-06-20','12:55:00',4.12),('15844','2013-06-20','13:00:00',4.07),('15844','2013-06-20','13:05:00',4.18),('15844','2013-06-20','13:10:00',4.08),('15844','2013-06-20','13:15:00',4.04),('15844','2013-06-20','13:20:00',4.12),('15844','2013-06-20','13:25:00',4.14),('15844','2013-06-20','13:30:00',4.1),('15844','2013-06-20','13:35:00',4.09),('15844','2013-06-20','13:40:00',4.06),('15844','2013-06-20','13:45:00',4.04),('15844','2013-06-20','13:50:00',4.02),('15844','2013-06-20','13:55:00',3.97),('15844','2013-06-20','14:00:00',3.92),('15844','2013-06-20','14:05:00',3.88),('15844','2013-06-20','14:10:00',3.84),('15844','2013-06-20','14:15:00',3.76),('15844','2013-06-20','14:20:00',3.71),('15844','2013-06-20','14:25:00',3.66),('15844','2013-06-20','14:30:00',3.59),('15844','2013-06-20','14:35:00',3.54),('15844','2013-06-20','14:40:00',3.48),('15844','2013-06-20','14:45:00',3.39),('15844','2013-06-20','14:50:00',3.29),('15844','2013-06-20','14:55:00',3.2),('15844','2013-06-20','15:00:00',3.07),('15844','2013-06-20','15:05:00',2.97),('15844','2013-06-20','15:10:00',2.86),('15844','2013-06-20','15:15:00',2.75),('15844','2013-06-20','15:20:00',2.61),('15844','2013-06-20','15:25:00',2.52),('15844','2013-06-20','15:30:00',2.4),('15844','2013-06-20','15:35:00',2.29),('15844','2013-06-20','15:40:00',2.2),('15844','2013-06-20','15:45:00',2.15),('15844','2013-06-20','15:50:00',2.08),('15844','2013-06-20','15:55:00',1.99),('15844','2013-06-20','16:00:00',1.89),('15844','2013-06-20','16:05:00',1.79),('15844','2013-06-20','16:10:00',1.68),('15844','2013-06-20','16:15:00',1.61),('15844','2013-06-20','16:20:00',1.52),('15844','2013-06-20','16:25:00',1.47),('15844','2013-06-20','16:30:00',1.43),('15844','2013-06-20','16:35:00',1.37),('15844','2013-06-20','16:40:00',1.29),('15844','2013-06-20','16:45:00',1.23),('15844','2013-06-20','16:50:00',1.11),('15844','2013-06-19','08:25:00',1.01),('15844','2013-06-19','08:30:00',1.08),('15844','2013-06-19','08:35:00',1.14),('15844','2013-06-19','08:40:00',1.2),('15844','2013-06-19','08:45:00',1.24),('15844','2013-06-19','08:50:00',1.27),('15844','2013-06-19','08:55:00',1.38),('15844','2013-06-19','09:00:00',1.46),('15844','2013-06-19','09:05:00',1.53),('15844','2013-06-19','09:10:00',1.6),('15844','2013-06-19','09:15:00',1.69),('15844','2013-06-19','09:20:00',1.75),('15844','2013-06-19','09:25:00',1.89),('15844','2013-06-19','09:30:00',2.02),('15844','2013-06-19','09:35:00',2.15),('15844','2013-06-19','09:40:00',2.27),('15844','2013-06-19','09:45:00',2.38),('15844','2013-06-19','09:50:00',2.55),('15844','2013-06-19','09:55:00',2.63),('15844','2013-06-19','10:00:00',2.7),('15844','2013-06-19','10:05:00',2.79),('15844','2013-06-19','10:10:00',2.89),('15844','2013-06-19','10:15:00',2.93),('15844','2013-06-19','10:20:00',2.97),('15844','2013-06-19','10:25:00',3.19),('15844','2013-06-19','10:30:00',3.32),('15844','2013-06-19','10:35:00',3.38),('15844','2013-06-19','10:40:00',3.48),('15844','2013-06-19','10:45:00',3.57),('15844','2013-06-19','10:50:00',3.63),('15844','2013-06-19','10:55:00',3.74),('15844','2013-06-19','11:00:00',3.82),('15844','2013-06-19','11:05:00',3.89),('15844','2013-06-19','11:10:00',3.87),('15844','2013-06-19','11:15:00',3.91),('15844','2013-06-19','11:20:00',3.99),('15844','2013-06-19','11:25:00',4),('15844','2013-06-19','11:30:00',3.91),('15844','2013-06-19','11:35:00',3.97),('15844','2013-06-19','11:40:00',4.03),('15844','2013-06-19','11:45:00',4.07),('15844','2013-06-19','11:50:00',4.07),('15844','2013-06-19','11:55:00',4.13),('15844','2013-06-19','12:00:00',4.08),('15844','2013-06-19','12:05:00',4.15),('15844','2013-06-19','12:10:00',4.12),('15844','2013-06-19','12:15:00',4.13),('15844','2013-06-19','12:20:00',4.12),('15844','2013-06-19','12:25:00',4.13),('15844','2013-06-19','12:30:00',4.14),('15844','2013-06-19','12:35:00',4.1),('15844','2013-06-19','12:40:00',4.04),('15844','2013-06-19','12:45:00',4.08),('15844','2013-06-19','12:50:00',4.05),('15844','2013-06-19','12:55:00',4.03),('15844','2013-06-19','13:00:00',3.99),('15844','2013-06-19','13:05:00',4.03),('15844','2013-06-19','13:10:00',4),('15844','2013-06-19','13:15:00',3.99),('15844','2013-06-19','13:20:00',3.96),('15844','2013-06-19','13:25:00',3.94),('15844','2013-06-19','13:30:00',3.89),('15844','2013-06-19','13:35:00',3.88),('15844','2013-06-19','13:40:00',3.85),('15844','2013-06-19','13:45:00',3.86),('15844','2013-06-19','13:50:00',3.85),('15844','2013-06-19','13:55:00',3.8),('15844','2013-06-19','14:00:00',3.76),('15844','2013-06-19','14:05:00',3.72),('15844','2013-06-19','14:10:00',3.67),('15844','2013-06-19','14:15:00',3.62),('15844','2013-06-19','14:20:00',3.57),('15844','2013-06-19','14:25:00',3.51),('15844','2013-06-19','14:30:00',3.46),('15844','2013-06-19','14:35:00',3.41),('15844','2013-06-19','14:40:00',3.37),('15844','2013-06-19','14:45:00',3.29),('15844','2013-06-19','14:50:00',3.2),('15844','2013-06-19','14:55:00',3.11),('15844','2013-06-19','15:00:00',3),('15844','2013-06-19','15:05:00',2.9),('15844','2013-06-19','15:10:00',2.77),('15844','2013-06-19','15:15:00',2.66),('15844','2013-06-19','15:20:00',2.56),('15844','2013-06-19','15:25:00',2.45),('15844','2013-06-19','15:30:00',2.32),('15844','2013-06-19','15:35:00',2.23),('15844','2013-06-19','15:40:00',2.15),('15844','2013-06-19','15:45:00',2.1),('15844','2013-06-19','15:50:00',2.05),('15844','2013-06-19','15:55:00',1.94),('15844','2013-06-19','16:00:00',1.86),('15844','2013-06-19','16:05:00',1.76),('15844','2013-06-19','16:10:00',1.67),('15844','2013-06-19','16:15:00',1.59),('15844','2013-06-19','16:20:00',1.51),('15844','2013-06-19','16:25:00',1.45),('15844','2013-06-19','16:30:00',1.43),('15844','2013-06-19','16:35:00',1.37),('15844','2013-06-19','16:40:00',1.29),('15844','2013-06-19','16:45:00',1.22),('15844','2013-06-19','16:50:00',1.11),('15844','2013-06-18','08:25:00',1.01),('15844','2013-06-18','08:30:00',1.09),('15844','2013-06-18','08:35:00',1.16),('15844','2013-06-18','08:40:00',1.2),('15844','2013-06-18','08:45:00',1.23),('15844','2013-06-18','08:50:00',1.28),('15844','2013-06-18','08:55:00',1.38),('15844','2013-06-18','09:00:00',1.49),('15844','2013-06-18','09:05:00',1.56),('15844','2013-06-18','09:10:00',1.63),('15844','2013-06-18','09:15:00',1.71),('15844','2013-06-18','09:20:00',1.79),('15844','2013-06-18','09:25:00',1.91),('15844','2013-06-18','09:30:00',2.06),('15844','2013-06-18','09:35:00',2.19),('15844','2013-06-18','09:40:00',2.31),('15844','2013-06-18','09:45:00',2.43),('15844','2013-06-18','09:50:00',2.6),('15844','2013-06-18','09:55:00',2.66),('15844','2013-06-18','10:00:00',2.74),('15844','2013-06-18','10:05:00',2.83),('15844','2013-06-18','10:10:00',2.89),('15844','2013-06-18','10:15:00',2.94),('15844','2013-06-18','10:20:00',3.08),('15844','2013-06-18','10:25:00',3.23),('15844','2013-06-18','10:30:00',3.4),('15844','2013-06-18','10:35:00',3.53),('15844','2013-06-18','10:40:00',3.62),('15844','2013-06-18','10:45:00',3.67),('15844','2013-06-18','10:50:00',3.71),('15844','2013-06-18','10:55:00',3.76),('15844','2013-06-18','11:00:00',3.87),('15844','2013-06-18','11:05:00',3.9),('15844','2013-06-18','11:10:00',3.91),('15844','2013-06-18','11:15:00',3.85),('15844','2013-06-18','11:20:00',3.92),('15844','2013-06-18','11:25:00',3.94),('15844','2013-06-18','11:30:00',3.96),('15844','2013-06-18','11:35:00',3.96),('15844','2013-06-18','11:40:00',3.99),('15844','2013-06-18','11:45:00',3.98),('15844','2013-06-18','11:50:00',3.97),('15844','2013-06-18','11:55:00',4.04),('15844','2013-06-18','12:00:00',4.07),('15844','2013-06-18','12:05:00',3.96),('15844','2013-06-18','12:10:00',3.93),('15844','2013-06-18','12:15:00',3.87),('15844','2013-06-18','12:20:00',3.78),('15844','2013-06-18','12:25:00',3.9),('15844','2013-06-18','12:30:00',3.85),('15844','2013-06-18','12:35:00',3.88),('15844','2013-06-18','12:40:00',3.94),('15844','2013-06-18','12:45:00',3.93),('15844','2013-06-18','12:50:00',4.01),('15844','2013-06-18','12:55:00',4.04),('15844','2013-06-18','13:00:00',3.9),('15844','2013-06-18','13:05:00',3.85),('15844','2013-06-18','13:10:00',3.63),('15844','2013-06-18','13:15:00',3.82),('15844','2013-06-18','13:20:00',3.68),('15844','2013-06-18','13:25:00',3.72),('15844','2013-06-18','13:30:00',3.72),('15844','2013-06-18','13:35:00',3.77),('15844','2013-06-18','13:40:00',3.73),('15844','2013-06-18','13:45:00',3.73),('15844','2013-06-18','13:50:00',3.69),('15844','2013-06-18','13:55:00',3.78),('15844','2013-06-18','14:00:00',3.84),('15844','2013-06-18','14:05:00',3.88),('15844','2013-06-18','14:10:00',3.82),('15844','2013-06-18','14:15:00',3.81),('15844','2013-06-18','14:20:00',3.71),('15844','2013-06-18','14:25:00',3.67),('15844','2013-06-18','14:30:00',3.61),('15844','2013-06-18','14:35:00',3.67),('15844','2013-06-18','14:40:00',3.61),('15844','2013-06-18','14:45:00',3.53),('15844','2013-06-18','14:50:00',3.39),('15844','2013-06-18','14:55:00',3.23),('15844','2013-06-18','15:00:00',3.11),('15844','2013-06-18','15:05:00',2.97),('15844','2013-06-18','15:10:00',2.83),('15844','2013-06-18','15:15:00',2.7),('15844','2013-06-18','15:20:00',2.58),('15844','2013-06-18','15:25:00',2.47),('15844','2013-06-18','15:30:00',2.37),('15844','2013-06-18','15:35:00',2.28),('15844','2013-06-18','15:40:00',2.19),('15844','2013-06-18','15:45:00',2.13),('15844','2013-06-18','15:50:00',2.08),('15844','2013-06-18','15:55:00',2.01),('15844','2013-06-18','16:00:00',1.96),('15844','2013-06-18','16:05:00',1.88),('15844','2013-06-18','16:10:00',1.81),('15844','2013-06-18','16:15:00',1.72),('15844','2013-06-18','16:20:00',1.66),('15844','2013-06-18','16:25:00',1.62),('15844','2013-06-18','16:30:00',1.57),('15844','2013-06-18','16:35:00',1.47),('15844','2013-06-18','16:40:00',1.37),('15844','2013-06-18','16:45:00',1.27),('15844','2013-06-18','16:50:00',1.16),('15844','2013-06-18','16:55:00',1.02),('15844','2013-06-17','08:25:00',1.05),('15844','2013-06-17','08:30:00',1.14),('15844','2013-06-17','08:35:00',1.21),('15844','2013-06-17','08:40:00',1.26),('15844','2013-06-17','08:45:00',1.28),('15844','2013-06-17','08:50:00',1.31),('15844','2013-06-17','08:55:00',1.43),('15844','2013-06-17','09:00:00',1.53),('15844','2013-06-17','09:05:00',1.61),('15844','2013-06-17','09:10:00',1.69),('15844','2013-06-17','09:15:00',1.78),('15844','2013-06-17','09:20:00',1.87),('15844','2013-06-17','09:25:00',2),('15844','2013-06-17','09:30:00',2.15),('15844','2013-06-17','09:35:00',2.27),('15844','2013-06-17','09:40:00',2.4),('15844','2013-06-17','09:45:00',2.53),('15844','2013-06-17','09:50:00',2.7),('15844','2013-06-17','09:55:00',2.81),('15844','2013-06-17','10:00:00',2.89),('15844','2013-06-17','10:05:00',2.98),('15844','2013-06-17','10:10:00',3.05),('15844','2013-06-17','10:15:00',3.11),('15844','2013-06-17','10:20:00',3.18),('15844','2013-06-17','10:25:00',3.39),('15844','2013-06-17','10:30:00',3.54),('15844','2013-06-17','10:35:00',3.66),('15844','2013-06-17','10:40:00',3.75),('15844','2013-06-17','10:45:00',3.77),('15844','2013-06-17','10:50:00',3.87),('15844','2013-06-17','10:55:00',3.96),('15844','2013-06-17','11:00:00',4.02),('15844','2013-06-17','11:05:00',4.05),('15844','2013-06-17','11:10:00',4.08),('15844','2013-06-17','11:15:00',4.1),('15844','2013-06-17','11:20:00',4.11),('15844','2013-06-17','11:25:00',4.1),('15844','2013-06-17','11:30:00',4.14),('15844','2013-06-17','11:35:00',4.12),('15844','2013-06-17','11:40:00',4.14),('15844','2013-06-17','11:45:00',4.13),('15844','2013-06-17','11:50:00',4.19),('15844','2013-06-17','11:55:00',4.18),('15844','2013-06-17','12:00:00',4.17),('15844','2013-06-17','12:05:00',4.21),('15844','2013-06-17','12:10:00',4.2),('15844','2013-06-17','12:15:00',4.22),('15844','2013-06-17','12:20:00',4.22),('15844','2013-06-17','12:25:00',4.22),('15844','2013-06-17','12:30:00',4.16),('15844','2013-06-17','12:35:00',4.19),('15844','2013-06-17','12:40:00',4.16),('15844','2013-06-17','12:45:00',4.2),('15844','2013-06-17','12:50:00',4.18),('15844','2013-06-17','12:55:00',4.16),('15844','2013-06-17','13:00:00',4.14),('15844','2013-06-17','13:05:00',4.12),('15844','2013-06-17','13:10:00',4.08),('15844','2013-06-17','13:15:00',4.08),('15844','2013-06-17','13:20:00',4.06),('15844','2013-06-17','13:25:00',4.03),('15844','2013-06-17','13:30:00',4),('15844','2013-06-17','13:35:00',3.97),('15844','2013-06-17','13:40:00',3.93),('15844','2013-06-17','13:45:00',3.9),('15844','2013-06-17','13:50:00',3.87),('15844','2013-06-17','13:55:00',3.85),('15844','2013-06-17','14:00:00',3.82),('15844','2013-06-17','14:05:00',3.78),('15844','2013-06-17','14:10:00',3.73),('15844','2013-06-17','14:15:00',3.68),('15844','2013-06-17','14:20:00',3.62),('15844','2013-06-17','14:25:00',3.56),('15844','2013-06-17','14:30:00',3.5),('15844','2013-06-17','14:35:00',3.43),('15844','2013-06-17','14:40:00',3.37),('15844','2013-06-17','14:45:00',3.28),('15844','2013-06-17','14:50:00',3.2),('15844','2013-06-17','14:55:00',3.11),('15844','2013-06-17','15:00:00',3.01),('15844','2013-06-17','15:05:00',2.89),('15844','2013-06-17','15:10:00',2.8),('15844','2013-06-17','15:15:00',2.69),('15844','2013-06-17','15:20:00',2.56),('15844','2013-06-17','15:25:00',2.44),('15844','2013-06-17','15:30:00',2.29),('15844','2013-06-17','15:35:00',2.27),('15844','2013-06-17','15:40:00',2.2),('15844','2013-06-17','15:45:00',2.14),('15844','2013-06-17','15:50:00',2.06),('15844','2013-06-17','15:55:00',1.96),('15844','2013-06-17','16:00:00',1.88),('15844','2013-06-17','16:05:00',1.79),('15844','2013-06-17','16:10:00',1.69),('15844','2013-06-17','16:15:00',1.6),('15844','2013-06-17','16:20:00',1.53),('15844','2013-06-17','16:25:00',1.49),('15844','2013-06-17','16:30:00',1.45),('15844','2013-06-17','16:35:00',1.4),('15844','2013-06-17','16:40:00',1.31),('15844','2013-06-17','16:45:00',1.24),('15844','2013-06-17','16:50:00',1.12),('15844','2013-06-17','16:55:00',1),('15844','2013-06-16','08:25:00',1.06),('15844','2013-06-16','08:30:00',1.14),('15844','2013-06-16','08:35:00',1.21),('15844','2013-06-16','08:40:00',1.27),('15844','2013-06-16','08:45:00',1.3),('15844','2013-06-16','08:50:00',1.32),('15844','2013-06-16','08:55:00',1.45),('15844','2013-06-16','09:00:00',1.55),('15844','2013-06-16','09:05:00',1.63),('15844','2013-06-16','09:10:00',1.7),('15844','2013-06-16','09:15:00',1.79),('15844','2013-06-16','09:20:00',1.88),('15844','2013-06-16','09:25:00',1.99),('15844','2013-06-16','09:30:00',2.19),('15844','2013-06-16','09:35:00',2.33),('15844','2013-06-16','09:40:00',2.46),('15844','2013-06-16','09:45:00',2.6),('15844','2013-06-16','09:50:00',2.71),('15844','2013-06-16','09:55:00',2.81),('15844','2013-06-16','10:00:00',2.92),('15844','2013-06-16','10:05:00',3.02),('15844','2013-06-16','10:10:00',3.08),('15844','2013-06-16','10:15:00',3.14),('15844','2013-06-16','10:20:00',3.2),('15844','2013-06-16','10:25:00',3.38),('15844','2013-06-16','10:30:00',3.57),('15844','2013-06-16','10:35:00',3.73),('15844','2013-06-16','10:40:00',3.82),('15844','2013-06-16','10:45:00',3.87),('15844','2013-06-16','10:50:00',3.98),('15844','2013-06-16','10:55:00',4.12),('15844','2013-06-16','11:00:00',4.18),('15844','2013-06-16','11:05:00',4.19),('15844','2013-06-16','11:10:00',4.23),('15844','2013-06-16','11:15:00',4.23),('15844','2013-06-16','11:20:00',4.29),('15844','2013-06-16','11:25:00',4.3),('15844','2013-06-16','11:30:00',4.31),('15844','2013-06-16','11:35:00',4.33),('15844','2013-06-16','11:40:00',4.33),('15844','2013-06-16','11:45:00',4.32),('15844','2013-06-16','11:50:00',4.34),('15844','2013-06-16','11:55:00',4.34),('15844','2013-06-16','12:00:00',4.32),('15844','2013-06-16','12:05:00',4.25),('15844','2013-06-16','12:10:00',4.29),('15844','2013-06-16','12:15:00',4.3),('15844','2013-06-16','12:20:00',4.3),('15844','2013-06-16','12:25:00',4.31),('15844','2013-06-16','12:30:00',4.31),('15844','2013-06-16','12:35:00',4.24),('15844','2013-06-16','12:40:00',4.23),('15844','2013-06-16','12:45:00',4.25),('15844','2013-06-16','12:50:00',4.22),('15844','2013-06-16','12:55:00',4.23),('15844','2013-06-16','13:00:00',4.23),('15844','2013-06-16','13:05:00',4.22),('15844','2013-06-16','13:10:00',4.19),('15844','2013-06-16','13:15:00',4.18),('15844','2013-06-16','13:20:00',4.14),('15844','2013-06-16','13:25:00',4.12),('15844','2013-06-16','13:30:00',4.09),('15844','2013-06-16','13:35:00',4.06),('15844','2013-06-16','13:40:00',4.05),('15844','2013-06-16','13:45:00',4.03),('15844','2013-06-16','13:50:00',3.99),('15844','2013-06-16','13:55:00',3.97),('15844','2013-06-16','14:00:00',3.94),('15844','2013-06-16','14:05:00',3.88),('15844','2013-06-16','14:10:00',3.81),('15844','2013-06-16','14:15:00',3.74),('15844','2013-06-16','14:20:00',3.7),('15844','2013-06-16','14:25:00',3.63),('15844','2013-06-16','14:30:00',3.57),('15844','2013-06-16','14:35:00',3.52),('15844','2013-06-16','14:40:00',3.46),('15844','2013-06-16','14:45:00',3.37),('15844','2013-06-16','14:50:00',3.29),('15844','2013-06-16','14:55:00',3.19),('15844','2013-06-16','15:00:00',3.07),('15844','2013-06-16','15:05:00',2.96),('15844','2013-06-16','15:10:00',2.84),('15844','2013-06-16','15:15:00',2.75),('15844','2013-06-16','15:20:00',2.65),('15844','2013-06-16','15:25:00',2.53),('15844','2013-06-16','15:30:00',2.43),('15844','2013-06-16','15:35:00',2.32),('15844','2013-06-16','15:40:00',2.25),('15844','2013-06-16','15:45:00',2.18),('15844','2013-06-16','15:50:00',2.09),('15844','2013-06-16','15:55:00',1.99),('15844','2013-06-16','16:00:00',1.91),('15844','2013-06-16','16:05:00',1.82),('15844','2013-06-16','16:10:00',1.72),('15844','2013-06-16','16:15:00',1.62),('15844','2013-06-16','16:20:00',1.54),('15844','2013-06-16','16:25:00',1.49),('15844','2013-06-16','16:30:00',1.45),('15844','2013-06-16','16:35:00',1.4),('15844','2013-06-16','16:40:00',1.32),('15844','2013-06-16','16:45:00',1.25),('15844','2013-06-16','16:50:00',1.13),('15844','2013-06-16','16:55:00',1.01),('15844','2013-06-15','08:15:00',1.04),('15844','2013-06-15','08:20:00',1.21),('15844','2013-06-15','08:25:00',1.22),('15844','2013-06-15','08:30:00',1.33),('15844','2013-06-15','08:35:00',1.48),('15844','2013-06-15','08:40:00',1.67),('15844','2013-06-15','08:45:00',1.63),('15844','2013-06-15','08:50:00',1.65),('15844','2013-06-15','08:55:00',1.92),('15844','2013-06-15','09:00:00',1.87),('15844','2013-06-15','09:05:00',1.27),('15844','2013-06-15','09:10:00',1.12),('15844','2013-06-15','09:15:00',1.88),('15844','2013-06-15','09:20:00',1.96),('15844','2013-06-15','09:25:00',2.04),('15844','2013-06-15','09:30:00',2.18),('15844','2013-06-15','09:35:00',2.27),('15844','2013-06-15','09:40:00',2.43),('15844','2013-06-15','09:45:00',2.55),('15844','2013-06-15','09:50:00',2.71),('15844','2013-06-15','09:55:00',2.83),('15844','2013-06-15','10:00:00',2.89),('15844','2013-06-15','10:05:00',3.01),('15844','2013-06-15','10:10:00',3.07),('15844','2013-06-15','10:15:00',3.05),('15844','2013-06-15','10:20:00',3.07),('15844','2013-06-15','10:25:00',3.3),('15844','2013-06-15','10:30:00',3.65),('15844','2013-06-15','10:35:00',3.79),('15844','2013-06-15','10:40:00',3.87),('15844','2013-06-15','10:45:00',3.87),('15844','2013-06-15','10:50:00',3.96),('15844','2013-06-15','10:55:00',4.09),('15844','2013-06-15','11:00:00',4.15),('15844','2013-06-15','11:05:00',4.14),('15844','2013-06-15','11:10:00',4.19),('15844','2013-06-15','11:15:00',4.25),('15844','2013-06-15','11:20:00',4.29),('15844','2013-06-15','11:25:00',4.36),('15844','2013-06-15','11:30:00',4.4),('15844','2013-06-15','11:35:00',4.35),('15844','2013-06-15','11:40:00',4.3),('15844','2013-06-15','11:45:00',4.38),('15844','2013-06-15','11:50:00',4.31),('15844','2013-06-15','11:55:00',4.37),('15844','2013-06-15','12:00:00',4.38),('15844','2013-06-15','12:05:00',4.37),('15844','2013-06-15','12:10:00',4.35),('15844','2013-06-15','12:15:00',4.42),('15844','2013-06-15','12:20:00',4.38),('15844','2013-06-15','12:25:00',4.35),('15844','2013-06-15','12:30:00',4.36),('15844','2013-06-15','12:35:00',4.39),('15844','2013-06-15','12:40:00',4.34),('15844','2013-06-15','12:45:00',4.32),('15844','2013-06-15','12:50:00',4.33),('15844','2013-06-15','12:55:00',4.31),('15844','2013-06-15','13:00:00',4.29),('15844','2013-06-15','13:05:00',4.24),('15844','2013-06-15','13:10:00',4.2),('15844','2013-06-15','13:15:00',4.17),('15844','2013-06-15','13:20:00',4.18),('15844','2013-06-15','13:25:00',4.11),('15844','2013-06-15','13:30:00',4.1),('15844','2013-06-15','13:35:00',4.03),('15844','2013-06-15','13:40:00',4.06),('15844','2013-06-15','13:45:00',3.98),('15844','2013-06-15','13:50:00',3.89),('15844','2013-06-15','13:55:00',3.92),('15844','2013-06-15','14:00:00',3.89),('15844','2013-06-15','14:05:00',3.86),('15844','2013-06-15','14:10:00',3.78),('15844','2013-06-15','14:15:00',3.69),('15844','2013-06-15','14:20:00',3.66),('15844','2013-06-15','14:25:00',3.61),('15844','2013-06-15','14:30:00',3.55),('15844','2013-06-15','14:35:00',3.51),('15844','2013-06-15','14:40:00',3.44),('15844','2013-06-15','14:45:00',3.36),('15844','2013-06-15','14:50:00',3.27),('15844','2013-06-15','14:55:00',3.17),('15844','2013-06-15','15:00:00',3.05),('15844','2013-06-15','15:05:00',2.94),('15844','2013-06-15','15:10:00',2.83),('15844','2013-06-15','15:15:00',2.72),('15844','2013-06-15','15:20:00',2.58),('15844','2013-06-15','15:25:00',2.48),('15844','2013-06-15','15:30:00',2.38),('15844','2013-06-15','15:35:00',2.31),('15844','2013-06-15','15:40:00',2.22),('15844','2013-06-15','15:45:00',2.16),('15844','2013-06-15','15:50:00',2.07),('15844','2013-06-15','15:55:00',1.98),('15844','2013-06-15','16:00:00',1.89),('15844','2013-06-15','16:05:00',1.79),('15844','2013-06-15','16:10:00',1.69),('15844','2013-06-15','16:15:00',1.6),('15844','2013-06-15','16:20:00',1.53),('15844','2013-06-15','16:25:00',1.49),('15844','2013-06-15','16:30:00',1.43),('15844','2013-06-15','16:35:00',1.38),('15844','2013-06-15','16:40:00',1.29),('15844','2013-06-15','16:45:00',1.22),('15844','2013-06-15','16:50:00',1.11),('15844','2013-06-14','08:20:00',1),('15844','2013-06-14','08:25:00',1.11),('15844','2013-06-14','08:30:00',1.21),('15844','2013-06-14','08:35:00',1.28),('15844','2013-06-14','08:40:00',1.33),('15844','2013-06-14','08:45:00',1.34),('15844','2013-06-14','08:50:00',1.39),('15844','2013-06-14','08:55:00',1.51),('15844','2013-06-14','09:00:00',1.6),('15844','2013-06-14','09:05:00',1.68),('15844','2013-06-14','09:10:00',1.77),('15844','2013-06-14','09:15:00',1.85),('15844','2013-06-14','09:20:00',1.94),('15844','2013-06-14','09:25:00',2.06),('15844','2013-06-14','09:30:00',2.25),('15844','2013-06-14','09:35:00',2.41),('15844','2013-06-14','09:40:00',2.54),('15844','2013-06-14','09:45:00',2.7),('15844','2013-06-14','09:50:00',2.85),('15844','2013-06-14','09:55:00',2.94),('15844','2013-06-14','10:00:00',3),('15844','2013-06-14','10:05:00',3.05),('15844','2013-06-14','10:10:00',3.17),('15844','2013-06-14','10:15:00',3.25),('15844','2013-06-14','10:20:00',3.43),('15844','2013-06-14','10:25:00',3.58),('15844','2013-06-14','10:30:00',3.68),('15844','2013-06-14','10:35:00',3.78),('15844','2013-06-14','10:40:00',3.94),('15844','2013-06-14','10:45:00',3.94),('15844','2013-06-14','10:50:00',4.01),('15844','2013-06-14','10:55:00',4.12),('15844','2013-06-14','11:00:00',4.19),('15844','2013-06-14','11:05:00',4.26),('15844','2013-06-14','11:10:00',4.25),('15844','2013-06-14','11:15:00',4.14),('15844','2013-06-14','11:20:00',4.31),('15844','2013-06-14','11:25:00',4.29),('15844','2013-06-14','11:30:00',4.33),('15844','2013-06-14','11:35:00',4.36),('15844','2013-06-14','11:40:00',4.37),('15844','2013-06-14','11:45:00',4.36),('15844','2013-06-14','11:50:00',4.35),('15844','2013-06-14','11:55:00',4.36),('15844','2013-06-14','12:00:00',4.39),('15844','2013-06-14','12:05:00',4.44),('15844','2013-06-14','12:10:00',4.44),('15844','2013-06-14','12:15:00',4.45),('15844','2013-06-14','12:20:00',4.44),('15844','2013-06-14','12:25:00',4.45),('15844','2013-06-14','12:30:00',4.39),('15844','2013-06-14','12:35:00',4.37),('15844','2013-06-14','12:40:00',4.36),('15844','2013-06-14','12:45:00',4.37),('15844','2013-06-14','12:50:00',4.35),('15844','2013-06-14','12:55:00',4.34),('15844','2013-06-14','13:00:00',4.27),('15844','2013-06-14','13:05:00',4.22),('15844','2013-06-14','13:10:00',4.24),('15844','2013-06-14','13:15:00',4.25),('15844','2013-06-14','13:20:00',4.24),('15844','2013-06-14','13:25:00',4.21),('15844','2013-06-14','13:30:00',4.16),('15844','2013-06-14','13:35:00',4.16),('15844','2013-06-14','13:40:00',4.14),('15844','2013-06-14','13:45:00',4.06),('15844','2013-06-14','13:50:00',4.04),('15844','2013-06-14','13:55:00',4.02),('15844','2013-06-14','14:00:00',3.94),('15844','2013-06-14','14:05:00',3.87),('15844','2013-06-14','14:10:00',3.81),('15844','2013-06-14','14:15:00',3.78),('15844','2013-06-14','14:20:00',3.74),('15844','2013-06-14','14:25:00',3.69),('15844','2013-06-14','14:30:00',3.64),('15844','2013-06-14','14:35:00',3.59),('15844','2013-06-14','14:40:00',3.52),('15844','2013-06-14','14:45:00',3.43),('15844','2013-06-14','14:50:00',3.33),('15844','2013-06-14','14:55:00',3.21),('15844','2013-06-14','15:00:00',3.08),('15844','2013-06-14','15:05:00',2.98),('15844','2013-06-14','15:10:00',2.84),('15844','2013-06-14','15:15:00',2.72),('15844','2013-06-14','15:20:00',2.63),('15844','2013-06-14','15:25:00',2.52),('15844','2013-06-14','15:30:00',2.39),('15844','2013-06-14','15:35:00',2.33),('15844','2013-06-14','15:40:00',2.24),('15844','2013-06-14','15:45:00',2.13),('15844','2013-06-14','15:50:00',2.05),('15844','2013-06-14','15:55:00',1.96),('15844','2013-06-14','16:00:00',1.9),('15844','2013-06-14','16:05:00',1.78),('15844','2013-06-14','16:10:00',1.65),('15844','2013-06-14','16:15:00',1.59),('15844','2013-06-14','16:20:00',1.51),('15844','2013-06-14','16:25:00',1.47),('15844','2013-06-14','16:30:00',1.42),('15844','2013-06-14','16:35:00',1.38),('15844','2013-06-14','16:40:00',1.29),('15844','2013-06-14','16:45:00',1.21),('15844','2013-06-14','16:50:00',1.09),('15844','2013-06-13','08:20:00',1.02),('15844','2013-06-13','08:25:00',1.12),('15844','2013-06-13','08:30:00',1.21),('15844','2013-06-13','08:35:00',1.29),('15844','2013-06-13','08:40:00',1.34),('15844','2013-06-13','08:45:00',1.35),('15844','2013-06-13','08:50:00',1.41),('15844','2013-06-13','08:55:00',1.53),('15844','2013-06-13','09:00:00',1.63),('15844','2013-06-13','09:05:00',1.72),('15844','2013-06-13','09:10:00',1.82),('15844','2013-06-13','09:15:00',1.9),('15844','2013-06-13','09:20:00',1.99),('15844','2013-06-13','09:25:00',2.14),('15844','2013-06-13','09:30:00',2.3),('15844','2013-06-13','09:35:00',2.46),('15844','2013-06-13','09:40:00',2.59),('15844','2013-06-13','09:45:00',2.77),('15844','2013-06-13','09:50:00',2.93),('15844','2013-06-13','09:55:00',3.03),('15844','2013-06-13','10:00:00',3.13),('15844','2013-06-13','10:05:00',3.24),('15844','2013-06-13','10:10:00',3.32),('15844','2013-06-13','10:15:00',3.38),('15844','2013-06-13','10:20:00',3.49),('15844','2013-06-13','10:25:00',3.69),('15844','2013-06-13','10:30:00',3.85),('15844','2013-06-13','10:35:00',3.97),('15844','2013-06-13','10:40:00',4.07),('15844','2013-06-13','10:45:00',4.1),('15844','2013-06-13','10:50:00',4.18),('15844','2013-06-13','10:55:00',4.29),('15844','2013-06-13','11:00:00',4.33),('15844','2013-06-13','11:05:00',4.36),('15844','2013-06-13','11:10:00',4.38),('15844','2013-06-13','11:15:00',4.42),('15844','2013-06-13','11:20:00',4.46),('15844','2013-06-13','11:25:00',4.5),('15844','2013-06-13','11:30:00',4.47),('15844','2013-06-13','11:35:00',4.44),('15844','2013-06-13','11:40:00',4.45),('15844','2013-06-13','11:45:00',4.49),('15844','2013-06-13','11:50:00',4.52),('15844','2013-06-13','11:55:00',4.48),('15844','2013-06-13','12:00:00',4.51),('15844','2013-06-13','12:05:00',4.53),('15844','2013-06-13','12:10:00',4.48),('15844','2013-06-13','12:15:00',4.47),('15844','2013-06-13','12:20:00',4.48),('15844','2013-06-13','12:25:00',4.46),('15844','2013-06-13','12:30:00',4.47),('15844','2013-06-13','12:35:00',4.48),('15844','2013-06-13','12:40:00',4.48),('15844','2013-06-13','12:45:00',4.44),('15844','2013-06-13','12:50:00',4.42),('15844','2013-06-13','12:55:00',4.42),('15844','2013-06-13','13:00:00',4.39),('15844','2013-06-13','13:05:00',4.34),('15844','2013-06-13','13:10:00',4.36),('15844','2013-06-13','13:15:00',4.31),('15844','2013-06-13','13:20:00',4.26),('15844','2013-06-13','13:25:00',4.24),('15844','2013-06-13','13:30:00',4.2),('15844','2013-06-13','13:35:00',4.12),('15844','2013-06-13','13:40:00',4.17),('15844','2013-06-13','13:45:00',4.13),('15844','2013-06-13','13:50:00',4.07),('15844','2013-06-13','13:55:00',3.99),('15844','2013-06-13','14:00:00',4.01),('15844','2013-06-13','14:05:00',3.96),('15844','2013-06-13','14:10:00',3.85),('15844','2013-06-13','14:15:00',2.9),('15844','2013-06-13','14:20:00',3.79),('15844','2013-06-13','14:25:00',3.73),('15844','2013-06-13','14:30:00',3.67),('15844','2013-06-13','14:35:00',3.61),('15844','2013-06-13','14:40:00',3.56),('15844','2013-06-13','14:45:00',3.47),('15844','2013-06-13','14:50:00',3.4),('15844','2013-06-13','14:55:00',3.25),('15844','2013-06-13','15:00:00',3.04),('15844','2013-06-13','15:05:00',2.94),('15844','2013-06-13','15:10:00',2.85),('15844','2013-06-13','15:15:00',2.71),('15844','2013-06-13','15:20:00',2.58),('15844','2013-06-13','15:25:00',2.45),('15844','2013-06-13','15:30:00',2.3),('15844','2013-06-13','15:35:00',2.27),('15844','2013-06-13','15:40:00',2.21),('15844','2013-06-13','15:45:00',2.16),('15844','2013-06-13','15:50:00',2.06),('15844','2013-06-13','15:55:00',1.94),('15844','2013-06-13','16:00:00',1.85),('15844','2013-06-13','16:05:00',1.76),('15844','2013-06-13','16:10:00',1.65),('15844','2013-06-13','16:15:00',1.58),('15844','2013-06-13','16:20:00',1.51),('15844','2013-06-13','16:25:00',1.46),('15844','2013-06-13','16:30:00',1.44),('15844','2013-06-13','16:35:00',1.37),('15844','2013-06-13','16:40:00',1.28),('15844','2013-06-13','16:45:00',1.22),('15844','2013-06-13','16:50:00',1.08),('15844','2013-06-12','08:20:00',1.03),('15844','2013-06-12','08:25:00',1.14),('15844','2013-06-12','08:30:00',1.23),('15844','2013-06-12','08:35:00',1.31),('15844','2013-06-12','08:40:00',1.35),('15844','2013-06-12','08:45:00',1.37),('15844','2013-06-12','08:50:00',1.43),('15844','2013-06-12','08:55:00',1.55),('15844','2013-06-12','09:00:00',1.63),('15844','2013-06-12','09:05:00',1.72),('15844','2013-06-12','09:10:00',1.83),('15844','2013-06-12','09:15:00',1.91),('15844','2013-06-12','09:20:00',1.99),('15844','2013-06-12','09:25:00',2.14),('15844','2013-06-12','09:30:00',2.32),('15844','2013-06-12','09:35:00',2.49),('15844','2013-06-12','09:40:00',2.64),('15844','2013-06-12','09:45:00',2.76),('15844','2013-06-12','09:50:00',2.9),('15844','2013-06-12','09:55:00',2.99),('15844','2013-06-12','10:00:00',3.11),('15844','2013-06-12','10:05:00',3.18),('15844','2013-06-12','10:10:00',3.29),('15844','2013-06-12','10:15:00',3.33),('15844','2013-06-12','10:20:00',3.42),('15844','2013-06-12','10:25:00',3.65),('15844','2013-06-12','10:30:00',3.81),('15844','2013-06-12','10:35:00',3.98),('15844','2013-06-12','10:40:00',4.05),('15844','2013-06-12','10:45:00',4.08),('15844','2013-06-12','10:50:00',4.18),('15844','2013-06-12','10:55:00',4.28),('15844','2013-06-12','11:00:00',4.33),('15844','2013-06-12','11:05:00',4.39),('15844','2013-06-12','11:10:00',4.4),('15844','2013-06-12','11:15:00',4.46),('15844','2013-06-12','11:20:00',4.47),('15844','2013-06-12','11:25:00',4.45),('15844','2013-06-12','11:30:00',4.46),('15844','2013-06-12','11:35:00',4.48),('15844','2013-06-12','11:40:00',4.51),('15844','2013-06-12','11:45:00',4.49),('15844','2013-06-12','11:50:00',4.45),('15844','2013-06-12','11:55:00',4.47),('15844','2013-06-12','12:00:00',4.51),('15844','2013-06-12','12:05:00',4.49),('15844','2013-06-12','12:10:00',4.48),('15844','2013-06-12','12:15:00',4.51),('15844','2013-06-12','12:20:00',4.44),('15844','2013-06-12','12:25:00',4.48),('15844','2013-06-12','12:30:00',3.97),('15844','2013-06-12','12:35:00',4.53),('15844','2013-06-12','12:40:00',4.28),('15844','2013-06-12','12:45:00',4.57),('15844','2013-06-12','12:50:00',4.42),('15844','2013-06-12','12:55:00',4.36),('15844','2013-06-12','13:00:00',3.7),('15844','2013-06-12','13:05:00',4.2),('15844','2013-06-12','13:10:00',4.35),('15844','2013-06-12','13:15:00',4.29),('15844','2013-06-12','13:20:00',4.29),('15844','2013-06-12','13:25:00',4.3),('15844','2013-06-12','13:30:00',4.32),('15844','2013-06-12','13:35:00',4.23),('15844','2013-06-12','13:40:00',4.23),('15844','2013-06-12','13:45:00',4.23),('15844','2013-06-12','13:50:00',3.34),('15844','2013-06-12','13:55:00',2.72),('15844','2013-06-12','14:00:00',4.26),('15844','2013-06-12','14:05:00',4.19),('15844','2013-06-12','14:10:00',4.08),('15844','2013-06-12','14:15:00',3.85),('15844','2013-06-12','14:20:00',3.84),('15844','2013-06-12','14:25:00',3.81),('15844','2013-06-12','14:30:00',3.67),('15844','2013-06-12','14:35:00',3.62),('15844','2013-06-12','14:40:00',3.53),('15844','2013-06-12','14:45:00',3.4),('15844','2013-06-12','14:50:00',3.29),('15844','2013-06-12','14:55:00',3.22),('15844','2013-06-12','15:00:00',3.13),('15844','2013-06-12','15:05:00',3.04),('15844','2013-06-12','15:10:00',2.79),('15844','2013-06-12','15:15:00',2.39),('15844','2013-06-12','15:20:00',2.6),('15844','2013-06-12','15:25:00',2.44),('15844','2013-06-12','15:30:00',2.52),('15844','2013-06-12','15:35:00',2.38),('15844','2013-06-12','15:40:00',2.27),('15844','2013-06-12','15:45:00',2.21),('15844','2013-06-12','15:50:00',2.14),('15844','2013-06-12','15:55:00',2.05),('15844','2013-06-12','16:00:00',2.01),('15844','2013-06-12','16:05:00',1.84),('15844','2013-06-12','16:10:00',1.75),('15844','2013-06-12','16:15:00',1.69),('15844','2013-06-12','16:20:00',1.59),('15844','2013-06-12','16:25:00',1.63),('15844','2013-06-12','16:30:00',1.66),('15844','2013-06-12','16:35:00',1.51),('15844','2013-06-12','16:40:00',1.46),('15844','2013-06-12','16:45:00',1.43),('15844','2013-06-12','16:50:00',1.18),('15844','2013-06-12','16:55:00',1.04),('15844','2013-06-11','08:20:00',1.04),('15844','2013-06-11','08:25:00',1.14),('15844','2013-06-11','08:30:00',1.22),('15844','2013-06-11','08:35:00',1.32),('15844','2013-06-11','08:40:00',1.38),('15844','2013-06-11','08:45:00',1.38),('15844','2013-06-11','08:50:00',1.44),('15844','2013-06-11','08:55:00',1.58),('15844','2013-06-11','09:00:00',1.14),('15844','2013-06-11','09:05:00',1.72),('15844','2013-06-11','09:10:00',1.73),('15844','2013-06-11','09:20:00',1.97),('15844','2013-06-11','09:25:00',2.2),('15844','2013-06-11','09:30:00',2.41),('15844','2013-06-11','09:35:00',2.5),('15844','2013-06-11','09:40:00',2.62),('15844','2013-06-11','09:45:00',2.84),('15844','2013-06-11','09:50:00',2.94),('15844','2013-06-11','09:55:00',3.04),('15844','2013-06-11','10:00:00',2.92),('15844','2013-06-11','10:05:00',3.24),('15844','2013-06-11','10:10:00',3.03),('15844','2013-06-11','10:15:00',3.37),('15844','2013-06-11','10:20:00',3.71),('15844','2013-06-11','10:25:00',3.89),('15844','2013-06-11','10:30:00',3.96),('15844','2013-06-11','10:35:00',4.05),('15844','2013-06-11','10:40:00',4.04),('15844','2013-06-11','10:45:00',2.39),('15844','2013-06-11','10:50:00',3.52),('15844','2013-06-11','10:55:00',3.45),('15844','2013-06-11','11:00:00',3.54),('15844','2013-06-11','11:05:00',4.59),('15844','2013-06-11','11:10:00',4.52),('15844','2013-06-11','11:15:00',4.54),('15844','2013-06-11','11:20:00',4.52),('15844','2013-06-11','11:25:00',4.54),('15844','2013-06-11','11:30:00',4.53),('15844','2013-06-11','11:35:00',4.16),('15844','2013-06-11','11:40:00',4.6),('15844','2013-06-11','11:45:00',4.63),('15844','2013-06-11','11:50:00',4.63),('15844','2013-06-11','11:55:00',4.63),('15844','2013-06-11','12:00:00',4.69),('15844','2013-06-11','12:05:00',4.57),('15844','2013-06-11','12:10:00',4.56),('15844','2013-06-11','12:15:00',4.59),('15844','2013-06-11','12:20:00',4.56),('15844','2013-06-11','12:25:00',4.58),('15844','2013-06-11','12:30:00',4.48),('15844','2013-06-11','12:35:00',4.58),('15844','2013-06-11','12:40:00',4.58),('15844','2013-06-11','12:45:00',4.56),('15844','2013-06-11','12:50:00',4.58),('15844','2013-06-11','12:55:00',4.53),('15844','2013-06-11','13:00:00',4.5),('15844','2013-06-11','13:05:00',4.25),('15844','2013-06-11','13:10:00',4.36),('15844','2013-06-11','13:15:00',4.3),('15844','2013-06-11','13:20:00',4.39),('15844','2013-06-11','13:25:00',4.43),('15844','2013-06-11','13:30:00',4.31),('15844','2013-06-11','13:35:00',4.3),('15844','2013-06-11','13:40:00',4.27),('15844','2013-06-11','13:45:00',4.26),('15844','2013-06-11','13:50:00',4.13),('15844','2013-06-11','13:55:00',4.09),('15844','2013-06-11','14:00:00',4.08),('15844','2013-06-11','14:05:00',4.04),('15844','2013-06-11','14:10:00',3.9),('15844','2013-06-11','14:15:00',3.88),('15844','2013-06-11','14:20:00',3.82),('15844','2013-06-11','14:25:00',3.77),('15844','2013-06-11','14:30:00',3.7),('15844','2013-06-11','14:35:00',3.62),('15844','2013-06-11','14:40:00',3.54),('15844','2013-06-11','14:45:00',3.48),('15844','2013-06-11','14:50:00',3.17),('15844','2013-06-11','14:55:00',3.28),('15844','2013-06-11','15:00:00',3.21),('15844','2013-06-11','15:05:00',3.06),('15844','2013-06-11','15:10:00',2.99),('15844','2013-06-11','15:15:00',2.82),('15844','2013-06-11','15:20:00',2.68),('15844','2013-06-11','15:25:00',2.61),('15844','2013-06-11','15:30:00',2.22),('15844','2013-06-11','15:35:00',2.15),('15844','2013-06-11','15:40:00',2.45),('15844','2013-06-11','15:45:00',2.03),('15844','2013-06-11','15:50:00',1.85),('15844','2013-06-11','15:55:00',2.11),('15844','2013-06-11','16:00:00',2.03),('15844','2013-06-11','16:05:00',1.87),('15844','2013-06-11','16:10:00',1.77),('15844','2013-06-11','16:15:00',1.68),('15844','2013-06-11','16:20:00',1.59),('15844','2013-06-11','16:25:00',1.57),('15844','2013-06-11','16:30:00',1.54),('15844','2013-06-11','16:35:00',1.5),('15844','2013-06-11','16:40:00',1.52),('15844','2013-06-11','16:45:00',1.57),('15844','2013-06-11','16:50:00',1.46),('15844','2013-06-11','16:55:00',1.16),('15844','2014-04-03','09:00:00',1.03),('15844','2014-04-03','09:05:00',1.12),('15844','2014-04-03','09:10:00',1.02),('15844','2014-04-03','09:20:00',1.01),('15844','2014-04-03','09:25:00',1.12),('15844','2014-04-03','09:30:00',1.34),('15844','2014-04-03','09:35:00',1.49),('15844','2014-04-03','09:40:00',1.49),('15844','2014-04-03','09:45:00',1.45),('15844','2014-04-03','09:50:00',1.47),('15844','2014-04-03','09:55:00',1.67),('15844','2014-04-03','10:00:00',2.01),('15844','2014-04-03','10:05:00',2.15),('15844','2014-04-03','10:10:00',2.41),('15844','2014-04-03','10:15:00',2.69),('15844','2014-04-03','10:20:00',2.3),('15844','2014-04-03','10:25:00',1.77),('15844','2014-04-03','10:30:00',2.61),('15844','2014-04-03','10:35:00',2.48),('15844','2014-04-03','10:40:00',2.32),('15844','2014-04-03','10:45:00',2.5),('15844','2014-04-03','10:50:00',2.2),('15844','2014-04-03','10:55:00',1.98),('15844','2014-04-03','11:00:00',1.61),('15844','2014-04-03','11:05:00',1.4),('15844','2014-04-03','11:10:00',1.32),('15844','2014-04-03','11:15:00',1.24),('15844','2014-04-03','11:20:00',1.14),('15844','2014-04-03','11:25:00',1.04),('15844','2014-04-03','11:30:00',1.07),('15844','2014-04-03','11:35:00',1.19),('15844','2014-04-03','11:40:00',1.29),('15844','2014-04-03','11:45:00',1.45),('15844','2014-04-03','11:50:00',1.73),('15844','2014-04-03','11:55:00',1.86),('15844','2014-04-03','12:00:00',1.98),('15844','2014-04-03','12:05:00',1.95),('15844','2014-04-03','12:10:00',1.76),('15844','2014-04-03','12:15:00',1.85),('15844','2014-04-03','12:20:00',2.24),('15844','2014-04-03','12:25:00',2.96),('15844','2014-04-03','12:30:00',3.7),('15844','2014-04-03','12:35:00',3.04),('15844','2014-04-03','12:40:00',2.59),('15844','2014-04-03','12:45:00',1.85),('15844','2014-04-03','12:50:00',2.54),('15844','2014-04-03','12:55:00',2.24),('15844','2014-04-03','13:00:00',1.81),('15844','2014-04-03','13:05:00',2.1),('15844','2014-04-03','13:10:00',2.32),('15844','2014-04-03','13:15:00',2.75),('15844','2014-04-03','13:20:00',1.91),('15844','2014-04-03','13:25:00',2.33),('15844','2014-04-03','13:30:00',3.15),('15844','2014-04-03','13:35:00',3.77),('15844','2014-04-03','13:40:00',2.3),('15844','2014-04-03','13:45:00',1.52),('15844','2014-04-03','13:50:00',1.88),('15844','2014-04-03','13:55:00',2.04),('15844','2014-04-03','14:00:00',2.58),('15844','2014-04-03','14:05:00',2.82),('15844','2014-04-03','14:10:00',2.32),('15844','2014-04-03','14:15:00',2.92),('15844','2014-04-03','14:20:00',2.71),('15844','2014-04-03','14:25:00',2.66),('15844','2014-04-03','14:30:00',3.06),('15844','2014-04-03','14:35:00',2.91),('15844','2014-04-03','14:40:00',2.73),('15844','2014-04-03','14:45:00',2.52),('15844','2014-04-03','14:50:00',2.46),('15844','2014-04-03','14:55:00',2.37),('15844','2014-04-03','15:00:00',2.26),('15844','2014-04-03','15:05:00',2.14),('15844','2014-04-03','15:10:00',2.04),('15844','2014-04-03','15:15:00',1.94),('15844','2014-04-03','15:20:00',1.81),('15844','2014-04-03','15:25:00',1.73),('15844','2014-04-03','15:30:00',1.67),('15844','2014-04-03','15:35:00',1.57),('15844','2014-04-03','15:40:00',1.47),('15844','2014-04-03','15:45:00',1.37),('15844','2014-04-03','15:50:00',1.26),('15844','2014-04-03','15:55:00',1.13),('15844','2014-04-03','16:00:00',1.15),('15844','2014-04-03','16:05:00',1.05),('15844','2014-04-03','16:10:00',1.04),('15844','2013-06-10','08:10:00',1.11),('15844','2013-06-10','08:25:00',1.41),('15844','2013-06-10','08:50:00',1.43),('15844','2013-06-10','08:55:00',1.58),('15844','2013-06-10','09:05:00',1.09),('15844','2013-06-10','09:10:00',1.05),('15844','2013-06-10','09:15:00',2.11),('15844','2013-06-10','09:20:00',1.98),('15844','2013-06-10','09:25:00',2.69),('15844','2013-06-10','09:30:00',2.49),('15844','2013-06-10','09:35:00',1.18),('15844','2013-06-10','09:40:00',1.33),('15844','2013-06-10','09:50:00',1.13),('15844','2013-06-10','10:00:00',1.67),('15844','2013-06-10','10:05:00',2.61),('15844','2013-06-10','10:10:00',3.44),('15844','2013-06-10','10:15:00',3.52),('15844','2013-06-10','10:20:00',3.3),('15844','2013-06-10','10:25:00',2.18),('15844','2013-06-10','10:30:00',1.11),('15844','2013-06-10','10:35:00',1.36),('15844','2013-06-10','10:40:00',2.17),('15844','2013-06-10','10:45:00',4.59),('15844','2013-06-10','10:50:00',3.86),('15844','2013-06-10','10:55:00',3.34),('15844','2013-06-10','11:00:00',1.15),('15844','2013-06-10','11:05:00',3.22),('15844','2013-06-10','11:10:00',2.99),('15844','2013-06-10','11:15:00',3.79),('15844','2013-06-10','11:20:00',4.33),('15844','2013-06-10','11:25:00',4.19),('15844','2013-06-10','11:30:00',1.39),('15844','2013-06-10','11:35:00',1.89),('15844','2013-06-10','11:40:00',1.69),('15844','2013-06-10','11:45:00',1.29),('15844','2013-06-10','11:50:00',4.18),('15844','2013-06-10','11:55:00',1.77),('15844','2013-06-10','12:05:00',4.11),('15844','2013-06-10','12:10:00',4.85),('15844','2013-06-10','12:15:00',3.22),('15844','2013-06-10','12:20:00',4.84),('15844','2013-06-10','12:25:00',3.87),('15844','2013-06-10','12:30:00',2.74),('15844','2013-06-10','12:35:00',2.8),('15844','2013-06-10','12:40:00',3.8),('15844','2013-06-10','12:45:00',4.24),('15844','2013-06-10','12:50:00',4.67),('15844','2013-06-10','12:55:00',3.68),('15844','2013-06-10','13:00:00',4.14),('15844','2013-06-10','13:05:00',3.29),('15844','2013-06-10','13:10:00',1.43),('15844','2013-06-10','13:15:00',1.86),('15844','2013-06-10','13:20:00',4.7),('15844','2013-06-10','13:25:00',2.48),('15844','2013-06-10','13:30:00',4.94),('15844','2013-06-10','13:35:00',3.86),('15844','2013-06-10','13:40:00',1.59),('15844','2013-06-10','13:45:00',2.07),('15844','2013-06-10','13:50:00',1.62),('15844','2013-06-10','13:55:00',2.6),('15844','2013-06-10','14:00:00',3.19),('15844','2013-06-10','14:05:00',3.06),('15844','2013-06-10','14:10:00',4.34),('15844','2013-06-10','14:15:00',3.28),('15844','2013-06-10','14:20:00',3.63),('15844','2013-06-10','14:25:00',3.61),('15844','2013-06-10','14:30:00',3.76),('15844','2013-06-10','14:35:00',3.65),('15844','2013-06-10','14:40:00',3.6),('15844','2013-06-10','14:45:00',3.5),('15844','2013-06-10','14:50:00',3.38),('15844','2013-06-10','14:55:00',3.28),('15844','2013-06-10','15:00:00',3.17),('15844','2013-06-10','15:05:00',3.07),('15844','2013-06-10','15:10:00',2.94),('15844','2013-06-10','15:15:00',2.86),('15844','2013-06-10','15:20:00',2.72),('15844','2013-06-10','15:25:00',2.59),('15844','2013-06-10','15:30:00',2.49),('15844','2013-06-10','15:35:00',2.37),('15844','2013-06-10','15:40:00',2.31),('15844','2013-06-10','15:45:00',2.22),('15844','2013-06-10','15:50:00',2.13),('15844','2013-06-10','15:55:00',2.03),('15844','2013-06-10','16:00:00',1.93),('15844','2013-06-10','16:05:00',1.82),('15844','2013-06-10','16:10:00',1.74),('15844','2013-06-10','16:15:00',1.64),('15844','2013-06-10','16:20:00',1.57),('15844','2013-06-10','16:25:00',1.53),('15844','2013-06-10','16:30:00',1.46),('15844','2013-06-10','16:35:00',1.41),('15844','2013-06-10','16:40:00',1.32),('15844','2013-06-10','16:45:00',1.23),('15844','2013-06-10','16:50:00',1.11),('15844','2013-06-09','08:20:00',1.02),('15844','2013-06-09','08:25:00',1.06),('15844','2013-06-09','08:30:00',1.14),('15844','2013-06-09','08:35:00',1.17),('15844','2013-06-09','08:40:00',1.29),('15844','2013-06-09','08:45:00',1.37),('15844','2013-06-09','08:50:00',1.38),('15844','2013-06-09','08:55:00',1.57),('15844','2013-06-09','09:00:00',1.63),('15844','2013-06-09','09:05:00',1.65),('15844','2013-06-09','09:10:00',1.7),('15844','2013-06-09','09:15:00',1.81),('15844','2013-06-09','09:20:00',1.95),('15844','2013-06-09','09:25:00',2.11),('15844','2013-06-09','09:30:00',2.23),('15844','2013-06-09','09:35:00',2.38),('15844','2013-06-09','09:40:00',2.52),('15844','2013-06-09','09:45:00',2.67),('15844','2013-06-09','09:50:00',2.79),('15844','2013-06-09','09:55:00',2.84),('15844','2013-06-09','10:00:00',2.97),('15844','2013-06-09','10:05:00',3.04),('15844','2013-06-09','10:10:00',3.13),('15844','2013-06-09','10:15:00',3.17),('15844','2013-06-09','10:20:00',3.36),('15844','2013-06-09','10:25:00',3.47),('15844','2013-06-09','10:30:00',3.61),('15844','2013-06-09','10:35:00',3.79),('15844','2013-06-09','10:40:00',3.83),('15844','2013-06-09','10:45:00',3.93),('15844','2013-06-09','10:50:00',3.99),('15844','2013-06-09','10:55:00',3.99),('15844','2013-06-09','11:00:00',3.95),('15844','2013-06-09','11:05:00',4.11),('15844','2013-06-09','11:10:00',4.16),('15844','2013-06-09','11:15:00',4.11),('15844','2013-06-09','11:20:00',4.1),('15844','2013-06-09','11:25:00',3.96),('15844','2013-06-09','11:30:00',3.65),('15844','2013-06-09','11:35:00',4.18),('15844','2013-06-09','11:40:00',4.28),('15844','2013-06-09','11:45:00',4.22),('15844','2013-06-09','11:50:00',4.29),('15844','2013-06-09','11:55:00',4.11),('15844','2013-06-09','12:00:00',4.1),('15844','2013-06-09','12:05:00',4.21),('15844','2013-06-09','12:10:00',4.1),('15844','2013-06-09','12:15:00',4.21),('15844','2013-06-09','12:20:00',4.07),('15844','2013-06-09','12:25:00',4.16),('15844','2013-06-09','12:30:00',4.24),('15844','2013-06-09','12:35:00',3.76),('15844','2013-06-09','12:40:00',3.45),('15844','2013-06-09','12:45:00',4.17),('15844','2013-06-09','12:50:00',3.95),('15844','2013-06-09','12:55:00',3.83),('15844','2013-06-09','13:00:00',3.57),('15844','2013-06-09','13:05:00',3.91),('15844','2013-06-09','13:10:00',4.24),('15844','2013-06-09','13:15:00',4.11),('15844','2013-06-09','13:20:00',4.02),('15844','2013-06-09','13:25:00',4.02),('15844','2013-06-09','13:30:00',4.12),('15844','2013-06-09','13:35:00',4.02),('15844','2013-06-09','13:40:00',3.11),('15844','2013-06-09','13:45:00',3.04),('15844','2013-06-09','13:50:00',2.3),('15844','2013-06-09','13:55:00',2.16),('15844','2013-06-09','14:00:00',4.04),('15844','2013-06-09','14:05:00',4.01),('15844','2013-06-09','14:10:00',3.99),('15844','2013-06-09','14:15:00',2.68),('15844','2013-06-09','14:20:00',1.01),('15844','2013-06-09','14:30:00',1.6),('15844','2013-06-09','14:35:00',3.01),('15844','2013-06-09','14:40:00',3.48),('15844','2013-06-09','14:45:00',3.76),('15844','2013-06-09','14:50:00',3.46),('15844','2013-06-09','14:55:00',3.32),('15844','2013-06-09','15:00:00',3.16),('15844','2013-06-09','15:05:00',3.05),('15844','2013-06-09','15:10:00',2.93),('15844','2013-06-09','15:15:00',2.76),('15844','2013-06-09','15:20:00',2.65),('15844','2013-06-09','15:25:00',2.54),('15844','2013-06-09','15:30:00',2.31),('15844','2013-06-09','15:35:00',2.36),('15844','2013-06-09','15:40:00',1.75),('15844','2013-06-09','15:45:00',1.65),('15844','2013-06-09','15:50:00',2.11),('15844','2013-06-09','15:55:00',2.05),('15844','2013-06-09','16:00:00',2.21),('15844','2013-06-09','16:05:00',1.56),('15844','2013-06-09','16:10:00',1.78),('15844','2013-06-09','16:15:00',1.46),('15844','2013-06-09','16:20:00',1.64),('15844','2013-06-09','16:25:00',1.66),('15844','2013-06-08','08:25:00',1.08),('15844','2013-06-08','08:30:00',1.18),('15844','2013-06-08','08:35:00',1.24),('15844','2013-06-08','08:40:00',1.3),('15844','2013-06-08','08:45:00',1.31),('15844','2013-06-08','08:50:00',1.36),('15844','2013-06-08','08:55:00',1.49),('15844','2013-06-08','09:00:00',1.57),('15844','2013-06-08','09:05:00',1.68),('15844','2013-06-08','09:10:00',1.77),('15844','2013-06-08','09:15:00',1.84),('15844','2013-06-08','09:20:00',2.03),('15844','2013-06-08','09:25:00',2.29),('15844','2013-06-08','09:30:00',2.5),('15844','2013-06-08','09:35:00',2.55),('15844','2013-06-08','09:40:00',2.8),('15844','2013-06-08','09:45:00',3.05),('15844','2013-06-08','09:50:00',3.01),('15844','2013-06-08','09:55:00',1.85),('15844','2013-06-08','10:00:00',1.01),('15844','2013-06-08','10:05:00',1.11),('15844','2013-06-08','10:15:00',1.63),('15844','2013-06-08','10:20:00',3.72),('15844','2013-06-08','10:25:00',3.79),('15844','2013-06-08','10:30:00',3.85),('15844','2013-06-08','10:35:00',4.05),('15844','2013-06-08','10:40:00',4.12),('15844','2013-06-08','10:45:00',4.15),('15844','2013-06-08','10:50:00',4.02),('15844','2013-06-08','10:55:00',4.44),('15844','2013-06-08','11:00:00',2.89),('15844','2013-06-08','11:05:00',1.95),('15844','2013-06-08','11:10:00',1.91),('15844','2013-06-08','11:15:00',4.46),('15844','2013-06-08','11:20:00',3.05),('15844','2013-06-08','11:30:00',2.17),('15844','2013-06-08','11:35:00',4.36),('15844','2013-06-08','11:40:00',5.03),('15844','2013-06-08','11:45:00',4.41),('15844','2013-06-08','11:50:00',4.57),('15844','2013-06-08','11:55:00',4.63),('15844','2013-06-08','12:00:00',4.62),('15844','2013-06-08','12:05:00',4.67),('15844','2013-06-08','12:10:00',4.71),('15844','2013-06-08','12:15:00',4.72),('15844','2013-06-08','12:20:00',4.62),('15844','2013-06-08','12:25:00',4.27),('15844','2013-06-08','12:30:00',4.39),('15844','2013-06-08','12:35:00',4.37),('15844','2013-06-08','12:40:00',3.43),('15844','2013-06-08','12:45:00',4.48),('15844','2013-06-08','12:50:00',4.36),('15844','2013-06-08','12:55:00',4.37),('15844','2013-06-08','13:00:00',4.33),('15844','2013-06-08','13:05:00',4.23),('15844','2013-06-08','13:10:00',4.29),('15844','2013-06-08','13:15:00',4.33),('15844','2013-06-08','13:20:00',4.32),('15844','2013-06-08','13:25:00',4.21),('15844','2013-06-08','13:30:00',4.23),('15844','2013-06-08','13:35:00',4.19),('15844','2013-06-08','13:40:00',4.16),('15844','2013-06-08','13:45:00',4.14),('15844','2013-06-08','13:50:00',4.1),('15844','2013-06-08','13:55:00',4.08),('15844','2013-06-08','14:00:00',3.99),('15844','2013-06-08','14:05:00',3.95),('15844','2013-06-08','14:10:00',3.93),('15844','2013-06-08','14:15:00',3.87),('15844','2013-06-08','14:20:00',3.82),('15844','2013-06-08','14:25:00',3.75),('15844','2013-06-08','14:30:00',3.68),('15844','2013-06-08','14:35:00',3.61),('15844','2013-06-08','14:40:00',3.55),('15844','2013-06-08','14:45:00',3.42),('15844','2013-06-08','14:50:00',3.34),('15844','2013-06-08','14:55:00',3.25),('15844','2013-06-08','15:00:00',3.09),('15844','2013-06-08','15:05:00',2.88),('15844','2013-06-08','15:10:00',2.7),('15844','2013-06-08','15:15:00',2.79),('15844','2013-06-08','15:20:00',2.71),('15844','2013-06-08','15:25:00',2.36),('15844','2013-06-08','15:30:00',2.38),('15844','2013-06-08','15:35:00',2.31),('15844','2013-06-08','15:40:00',2.38),('15844','2013-06-08','15:45:00',2.45),('15844','2013-06-08','15:50:00',2.24),('15844','2013-06-08','15:55:00',2.07),('15844','2013-06-08','16:00:00',1.99),('15844','2013-06-08','16:05:00',1.91),('15844','2013-06-08','16:10:00',1.93),('15844','2013-06-08','16:15:00',1.85),('15844','2013-06-08','16:20:00',1.72),('15844','2013-06-08','16:25:00',1.59),('15844','2013-06-08','16:30:00',1.47),('15844','2013-06-08','16:35:00',1.4),('15844','2013-06-08','16:40:00',1.31),('15844','2013-06-08','16:45:00',1.14),('15844','2013-06-08','16:55:00',1.02),('15844','2013-06-07','08:20:00',1.01),('15844','2013-06-07','08:25:00',1.11),('15844','2013-06-07','08:30:00',1.2),('15844','2013-06-07','08:35:00',1.28),('15844','2013-06-07','08:40:00',1.31),('15844','2013-06-07','08:45:00',1.33),('15844','2013-06-07','08:50:00',1.41),('15844','2013-06-07','08:55:00',1.51),('15844','2013-06-07','09:00:00',1.63),('15844','2013-06-07','09:05:00',1.75),('15844','2013-06-07','09:10:00',1.81),('15844','2013-06-07','09:15:00',1.89),('15844','2013-06-07','09:20:00',2),('15844','2013-06-07','09:25:00',2.14),('15844','2013-06-07','09:30:00',2.3),('15844','2013-06-07','09:35:00',2.5),('15844','2013-06-07','09:40:00',2.64),('15844','2013-06-07','09:45:00',2.78),('15844','2013-06-07','09:50:00',2.9),('15844','2013-06-07','09:55:00',3),('15844','2013-06-07','10:00:00',3.11),('15844','2013-06-07','10:05:00',3.19),('15844','2013-06-07','10:10:00',3.27),('15844','2013-06-07','10:15:00',3.33),('15844','2013-06-07','10:20:00',3.42),('15844','2013-06-07','10:25:00',3.72),('15844','2013-06-07','10:30:00',3.89),('15844','2013-06-07','10:35:00',3.98),('15844','2013-06-07','10:40:00',4.04),('15844','2013-06-07','10:45:00',4.11),('15844','2013-06-07','10:50:00',4.21),('15844','2013-06-07','10:55:00',4.28),('15844','2013-06-07','11:00:00',4.33),('15844','2013-06-07','11:05:00',4.36),('15844','2013-06-07','11:10:00',4.38),('15844','2013-06-07','11:15:00',4.42),('15844','2013-06-07','11:20:00',4.45),('15844','2013-06-07','11:25:00',4.46),('15844','2013-06-07','11:30:00',4.43),('15844','2013-06-07','11:35:00',4.45),('15844','2013-06-07','11:40:00',4.49),('15844','2013-06-07','11:45:00',4.52),('15844','2013-06-07','11:50:00',4.48),('15844','2013-06-07','11:55:00',4.48),('15844','2013-06-07','12:00:00',4.49),('15844','2013-06-07','12:05:00',4.48),('15844','2013-06-07','12:10:00',4.39),('15844','2013-06-07','12:15:00',4.43),('15844','2013-06-07','12:20:00',4.47),('15844','2013-06-07','12:25:00',4.47),('15844','2013-06-07','12:30:00',4.45),('15844','2013-06-07','12:35:00',4.43),('15844','2013-06-07','12:40:00',4.42),('15844','2013-06-07','12:45:00',4.43),('15844','2013-06-07','12:50:00',4.41),('15844','2013-06-07','12:55:00',4.38),('15844','2013-06-07','13:00:00',4.34),('15844','2013-06-07','13:05:00',4.32),('15844','2013-06-07','13:10:00',4.29),('15844','2013-06-07','13:15:00',4.24),('15844','2013-06-07','13:20:00',4.23),('15844','2013-06-07','13:25:00',4.17),('15844','2013-06-07','13:30:00',4.15),('15844','2013-06-07','13:35:00',4.12),('15844','2013-06-07','13:40:00',4.08),('15844','2013-06-07','13:45:00',4.04),('15844','2013-06-07','13:50:00',4),('15844','2013-06-07','13:55:00',3.96),('15844','2013-06-07','14:00:00',3.92),('15844','2013-06-07','14:05:00',3.87),('15844','2013-06-07','14:10:00',3.85),('15844','2013-06-07','14:15:00',3.79),('15844','2013-06-07','14:20:00',3.73),('15844','2013-06-07','14:25:00',3.66),('15844','2013-06-07','14:30:00',3.57),('15844','2013-06-07','14:35:00',3.5),('15844','2013-06-07','14:40:00',3.42),('15844','2013-06-07','14:45:00',3.3),('15844','2013-06-07','14:50:00',3.25),('15844','2013-06-07','14:55:00',3.15),('15844','2013-06-07','15:00:00',3.02),('15844','2013-06-07','15:05:00',2.93),('15844','2013-06-07','15:10:00',2.84),('15844','2013-06-07','15:15:00',2.76),('15844','2013-06-07','15:20:00',2.6),('15844','2013-06-07','15:25:00',2.49),('15844','2013-06-07','15:30:00',2.39),('15844','2013-06-07','15:35:00',2.3),('15844','2013-06-07','15:40:00',2.23),('15844','2013-06-07','15:45:00',2.18),('15844','2013-06-07','15:50:00',2.07),('15844','2013-06-07','15:55:00',1.95),('15844','2013-06-07','16:00:00',1.84),('15844','2013-06-07','16:05:00',1.7),('15844','2013-06-07','16:10:00',1.68),('15844','2013-06-07','16:15:00',1.6),('15844','2013-06-07','16:20:00',1.51),('15844','2013-06-07','16:25:00',1.47),('15844','2013-06-07','16:30:00',1.44),('15844','2013-06-07','16:35:00',1.42),('15844','2013-06-07','16:40:00',1.31),('15844','2013-06-07','16:45:00',1.2),('15844','2013-06-07','16:50:00',1.1),('15844','2013-06-06','08:20:00',1.08),('15844','2013-06-06','08:25:00',1.16),('15844','2013-06-06','08:30:00',1.23),('15844','2013-06-06','08:35:00',1.31),('15844','2013-06-06','08:40:00',1.34),('15844','2013-06-06','08:45:00',1.37),('15844','2013-06-06','08:50:00',1.42),('15844','2013-06-06','08:55:00',1.56),('15844','2013-06-06','09:00:00',1.66),('15844','2013-06-06','09:05:00',1.78),('15844','2013-06-06','09:10:00',1.85),('15844','2013-06-06','09:15:00',1.94),('15844','2013-06-06','09:20:00',2.05),('15844','2013-06-06','09:25:00',2.18),('15844','2013-06-06','09:30:00',2.32),('15844','2013-06-06','09:35:00',2.21),('15844','2013-06-06','09:40:00',2.54),('15844','2013-06-06','09:45:00',2.69),('15844','2013-06-06','09:50:00',2.84),('15844','2013-06-06','09:55:00',2.92),('15844','2013-06-06','10:00:00',3.08),('15844','2013-06-06','10:05:00',3.2),('15844','2013-06-06','10:10:00',3.26),('15844','2013-06-06','10:15:00',3.26),('15844','2013-06-06','10:20:00',3.29),('15844','2013-06-06','10:25:00',3.65),('15844','2013-06-06','10:30:00',3.76),('15844','2013-06-06','10:35:00',3.78),('15844','2013-06-06','10:40:00',3.89),('15844','2013-06-06','10:45:00',4.01),('15844','2013-06-06','10:50:00',4.05),('15844','2013-06-06','10:55:00',4.05),('15844','2013-06-06','11:00:00',4.02),('15844','2013-06-06','11:05:00',4.22),('15844','2013-06-06','11:10:00',4.25),('15844','2013-06-06','11:15:00',4.27),('15844','2013-06-06','11:20:00',4.37),('15844','2013-06-06','11:25:00',4.39),('15844','2013-06-06','11:30:00',4.38),('15844','2013-06-06','11:35:00',4.41),('15844','2013-06-06','11:40:00',4.35),('15844','2013-06-06','11:45:00',4.22),('15844','2013-06-06','11:50:00',3.55),('15844','2013-06-06','11:55:00',4.41),('15844','2013-06-06','12:00:00',4.46),('15844','2013-06-06','12:05:00',3.32),('15844','2013-06-06','12:10:00',3.04),('15844','2013-06-06','12:15:00',4.45),('15844','2013-06-06','12:20:00',4.41),('15844','2013-06-06','12:25:00',4.42),('15844','2013-06-06','12:30:00',4.38),('15844','2013-06-06','12:35:00',4.35),('15844','2013-06-06','12:40:00',4.36),('15844','2013-06-06','12:45:00',4.03),('15844','2013-06-06','12:50:00',4.2),('15844','2013-06-06','12:55:00',4.06),('15844','2013-06-06','13:00:00',2.44),('15844','2013-06-06','13:05:00',1.66),('15844','2013-06-06','13:10:00',1.76),('15844','2013-06-06','13:15:00',1.19),('15844','2013-06-06','13:20:00',3.14),('15844','2013-06-06','13:25:00',1.44),('15844','2013-06-06','13:30:00',3.29),('15844','2013-06-06','13:35:00',2.03),('15844','2013-06-06','13:40:00',4.5),('15844','2013-06-06','13:45:00',4.24),('15844','2013-06-06','13:50:00',3.97),('15844','2013-06-06','13:55:00',3.92),('15844','2013-06-06','14:00:00',3.83),('15844','2013-06-06','14:05:00',3.87),('15844','2013-06-06','14:10:00',3.79),('15844','2013-06-06','14:15:00',3.75),('15844','2013-06-06','14:20:00',3.71),('15844','2013-06-06','14:25:00',3.68),('15844','2013-06-06','14:30:00',3.61),('15844','2013-06-06','14:35:00',3.46),('15844','2013-06-06','14:40:00',3.39),('15844','2013-06-06','14:45:00',3.33),('15844','2013-06-06','14:50:00',3.23),('15844','2013-06-06','14:55:00',3.16),('15844','2013-06-06','15:00:00',3.03),('15844','2013-06-06','15:05:00',2.9),('15844','2013-06-06','15:10:00',2.8),('15844','2013-06-06','15:15:00',2.68),('15844','2013-06-06','15:20:00',2.6),('15844','2013-06-06','15:25:00',2.47),('15844','2013-06-06','15:30:00',2.39),('15844','2013-06-06','15:35:00',2.27),('15844','2013-06-06','15:40:00',2.19),('15844','2013-06-06','15:45:00',2.1),('15844','2013-06-06','15:50:00',2.01),('15844','2013-06-06','15:55:00',1.93),('15844','2013-06-06','16:00:00',1.86),('15844','2013-06-06','16:05:00',1.76),('15844','2013-06-06','16:10:00',1.69),('15844','2013-06-06','16:15:00',1.6),('15844','2013-06-06','16:20:00',1.54),('15844','2013-06-06','16:25:00',1.48),('15844','2013-06-06','16:30:00',1.43),('15844','2013-06-06','16:35:00',1.39),('15844','2013-06-06','16:40:00',1.28),('15844','2013-06-06','16:45:00',1.18),('15844','2013-06-06','16:50:00',1.07),('15844','2013-06-05','08:20:00',1.03),('15844','2013-06-05','08:25:00',1.14),('15844','2013-06-05','08:30:00',1.23),('15844','2013-06-05','08:35:00',1.28),('15844','2013-06-05','08:40:00',1.34),('15844','2013-06-05','08:45:00',1.38),('15844','2013-06-05','08:50:00',1.46),('15844','2013-06-05','08:55:00',1.51),('15844','2013-06-05','09:00:00',1.81),('15844','2013-06-05','09:05:00',1.67),('15844','2013-06-05','09:10:00',1.08),('15844','2013-06-05','09:20:00',1.64),('15844','2013-06-05','09:25:00',2.05),('15844','2013-06-05','09:30:00',1.54),('15844','2013-06-05','09:35:00',2.15),('15844','2013-06-05','09:40:00',2.17),('15844','2013-06-05','09:45:00',2.02),('15844','2013-06-05','09:50:00',2.92),('15844','2013-06-05','09:55:00',2.07),('15844','2013-06-05','10:00:00',1.88),('15844','2013-06-05','10:05:00',2.38),('15844','2013-06-05','10:10:00',2.35),('15844','2013-06-05','10:20:00',1.48),('15844','2013-06-05','10:25:00',3.63),('15844','2013-06-05','10:30:00',4.41),('15844','2013-06-05','10:35:00',3.59),('15844','2013-06-05','10:40:00',2.1),('15844','2013-06-05','10:45:00',2.25),('15844','2013-06-05','10:50:00',1.65),('15844','2013-06-05','10:55:00',3.37),('15844','2013-06-05','11:00:00',4.02),('15844','2013-06-05','11:05:00',1.07),('15844','2013-06-05','11:10:00',1.11),('15844','2013-06-05','11:15:00',3.07),('15844','2013-06-05','11:20:00',2.77),('15844','2013-06-05','11:25:00',3.85),('15844','2013-06-05','11:30:00',3.38),('15844','2013-06-05','11:35:00',2.14),('15844','2013-06-05','11:40:00',1.94),('15844','2013-06-05','11:45:00',4.35),('15844','2013-06-05','11:50:00',4.91),('15844','2013-06-05','11:55:00',4.74),('15844','2013-06-05','12:00:00',4.99),('15844','2013-06-05','12:05:00',4.97),('15844','2013-06-05','12:10:00',2.75),('15844','2013-06-05','12:15:00',4.75),('15844','2013-06-05','12:20:00',3.12),('15844','2013-06-05','12:25:00',2.5),('15844','2013-06-05','12:30:00',4.54),('15844','2013-06-05','12:35:00',4.23),('15844','2013-06-05','12:40:00',1.28),('15844','2013-06-05','12:45:00',1.3),('15844','2013-06-05','12:50:00',1.66),('15844','2013-06-05','12:55:00',1.39),('15844','2013-06-05','13:00:00',4.3),('15844','2013-06-05','13:05:00',4.07),('15844','2013-06-05','13:10:00',3.88),('15844','2013-06-05','13:15:00',4.82),('15844','2013-06-05','13:20:00',3.89),('15844','2013-06-05','13:25:00',4.68),('15844','2013-06-05','13:30:00',4.49),('15844','2013-06-05','13:35:00',4.35),('15844','2013-06-05','13:40:00',3.62),('15844','2013-06-05','13:45:00',3.06),('15844','2013-06-05','13:50:00',4.27),('15844','2013-06-05','13:55:00',4.22),('15844','2013-06-05','14:00:00',3.74),('15844','2013-06-05','14:05:00',4.09),('15844','2013-06-05','14:10:00',3.98),('15844','2013-06-05','14:15:00',3.74),('15844','2013-06-05','14:20:00',3.94),('15844','2013-06-05','14:25:00',3.48),('15844','2013-06-05','14:30:00',3.74),('15844','2013-06-05','14:35:00',3.08),('15844','2013-06-05','14:40:00',3.56),('15844','2013-06-05','14:45:00',3.56),('15844','2013-06-05','14:50:00',3.31),('15844','2013-06-05','14:55:00',3.28),('15844','2013-06-05','15:00:00',3.19),('15844','2013-06-05','15:05:00',3.01),('15844','2013-06-05','15:10:00',2.78),('15844','2013-06-05','15:15:00',2.67),('15844','2013-06-05','15:20:00',2.29),('15844','2013-06-05','15:25:00',2.5),('15844','2013-06-05','15:30:00',2.11),('15844','2013-06-05','15:35:00',2.79),('15844','2013-06-05','15:40:00',2.09),('15844','2013-06-05','15:45:00',2.15),('15844','2013-06-05','15:50:00',2.26),('15844','2013-06-05','15:55:00',1.78),('15844','2013-06-05','16:00:00',1.8),('15844','2013-06-05','16:05:00',1.7),('15844','2013-06-05','16:10:00',1.4),('15844','2013-06-05','16:15:00',1.32),('15844','2013-06-05','16:20:00',1.58),('15844','2013-06-05','16:25:00',1.67),('15844','2013-06-05','16:30:00',1.27),('15844','2013-06-05','16:35:00',1.44),('15844','2013-06-05','16:45:00',1.35),('15844','2013-06-05','16:50:00',1.16),('15844','2013-06-05','17:00:00',1.13),('15844','2013-06-04','07:50:00',1.04),('15844','2013-06-04','07:55:00',1.19),('15844','2013-06-04','08:00:00',1.22),('15844','2013-06-04','08:05:00',1.31),('15844','2013-06-04','08:10:00',1.42),('15844','2013-06-04','08:15:00',1.47),('15844','2013-06-04','08:20:00',1.52),('15844','2013-06-04','08:25:00',1.6),('15844','2013-06-04','08:30:00',1.68),('15844','2013-06-04','08:35:00',1.37),('15844','2013-06-04','08:40:00',1.34),('15844','2013-06-04','08:45:00',1.28),('15844','2013-06-04','08:50:00',1.09),('15844','2013-06-04','08:55:00',1.31),('15844','2013-06-04','09:00:00',1.6),('15844','2013-06-04','09:05:00',1.47),('15844','2013-06-04','09:10:00',1.5),('15844','2013-06-04','09:15:00',1.86),('15844','2013-06-04','09:20:00',2.25),('15844','2013-06-04','09:25:00',1.93),('15844','2013-06-04','09:30:00',1.77),('15844','2013-06-04','09:35:00',2.61),('15844','2013-06-04','09:40:00',1.94),('15844','2013-06-04','09:45:00',2.04),('15844','2013-06-04','09:50:00',1.63),('15844','2013-06-04','09:55:00',1.29),('15844','2013-06-04','10:00:00',1.08),('15844','2013-06-04','10:05:00',1.18),('15844','2013-06-04','10:10:00',1.49),('15844','2013-06-04','10:15:00',2.05),('15844','2013-06-04','10:20:00',1.61),('15844','2013-06-04','10:25:00',1.48),('15844','2013-06-04','10:30:00',1.71),('15844','2013-06-04','10:35:00',1.86),('15844','2013-06-04','10:40:00',2.01),('15844','2013-06-04','10:45:00',2.16),('15844','2013-06-04','10:50:00',2.42),('15844','2013-06-04','10:55:00',2.5),('15844','2013-06-04','11:00:00',2.61),('15844','2013-06-04','11:05:00',3.15),('15844','2013-06-04','11:10:00',2.97),('15844','2013-06-04','11:15:00',2.25),('15844','2013-06-04','11:20:00',2.6),('15844','2013-06-04','11:25:00',3.12),('15844','2013-06-04','11:30:00',3.53),('15844','2013-06-04','11:35:00',3.14),('15844','2013-06-04','11:40:00',3.21),('15844','2013-06-04','11:45:00',3.94),('15844','2013-06-04','11:50:00',4.77),('15844','2013-06-04','11:55:00',4.39),('15844','2013-06-04','12:00:00',5.11),('15844','2013-06-04','12:05:00',2.67),('15844','2013-06-04','12:10:00',3.18),('15844','2013-06-04','12:15:00',2.51),('15844','2013-06-04','12:20:00',2.76),('15844','2013-06-04','12:25:00',2.47),('15844','2013-06-04','12:30:00',3.22),('15844','2013-06-04','12:35:00',1.93),('15844','2013-06-04','12:40:00',2),('15844','2013-06-04','12:45:00',1.96),('15844','2013-06-04','12:50:00',1.7),('15844','2013-06-04','12:55:00',3.24),('15844','2013-06-04','13:00:00',1.06),('15844','2013-06-04','13:05:00',1.13),('15844','2013-06-04','13:10:00',1.11),('15844','2013-06-04','13:15:00',1.71),('15844','2013-06-04','13:20:00',2.04),('15844','2013-06-04','13:25:00',5.24),('15844','2013-06-04','13:30:00',4.9),('15844','2013-06-04','13:35:00',4.21),('15844','2013-06-04','13:40:00',2.41),('15844','2013-06-04','13:45:00',1.93),('15844','2013-06-04','13:50:00',3.11),('15844','2013-06-04','13:55:00',3.88),('15844','2013-06-04','14:00:00',2.85),('15844','2013-06-04','14:05:00',3.03),('15844','2013-06-04','14:10:00',2.75),('15844','2013-06-04','14:15:00',1.53),('15844','2013-06-04','14:30:00',1.11),('15844','2013-06-04','14:35:00',1.81),('15844','2013-06-04','14:40:00',3.2),('15844','2013-06-04','14:45:00',3.67),('15844','2013-06-04','14:50:00',3.88),('15844','2013-06-04','14:55:00',2.95),('15844','2013-06-04','15:00:00',2.58),('15844','2013-06-04','15:05:00',2.56),('15844','2013-06-04','15:10:00',2.79),('15844','2013-06-04','15:15:00',2.87),('15844','2013-06-04','15:20:00',2.77),('15844','2013-06-04','15:25:00',1.97),('15844','2013-06-04','15:30:00',1.12),('15844','2013-06-03','08:20:00',1.06),('15844','2013-06-03','08:25:00',1.13),('15844','2013-06-03','08:30:00',1.24),('15844','2013-06-03','08:35:00',1.28),('15844','2013-06-03','08:40:00',1.35),('15844','2013-06-03','08:45:00',1.41),('15844','2013-06-03','08:50:00',1.52),('15844','2013-06-03','08:55:00',1.62),('15844','2013-06-03','09:00:00',1.74),('15844','2013-06-03','09:05:00',1.83),('15844','2013-06-03','09:10:00',1.97),('15844','2013-06-03','09:15:00',2.54),('15844','2013-06-03','09:20:00',2.58),('15844','2013-06-03','09:25:00',1.6),('15844','2013-06-03','09:30:00',1),('15844','2013-06-03','09:35:00',1.05),('15844','2013-06-03','09:40:00',1.35),('15844','2013-06-03','09:45:00',1.3),('15844','2013-06-03','09:50:00',1.4),('15844','2013-06-03','10:05:00',1.34),('15844','2013-06-03','10:10:00',1.27),('15844','2013-06-03','10:15:00',1.18),('15844','2013-06-03','10:20:00',1.1),('15844','2013-06-03','10:25:00',1.18),('15844','2013-06-03','10:30:00',1.23),('15844','2013-06-03','10:35:00',1.41),('15844','2013-06-03','10:40:00',1.78),('15844','2013-06-03','10:45:00',4.23),('15844','2013-06-03','10:50:00',5.37),('15844','2013-06-03','10:55:00',4.19),('15844','2013-06-03','11:00:00',3.24),('15844','2013-06-03','11:05:00',3.81),('15844','2013-06-03','11:10:00',3.98),('15844','2013-06-03','11:15:00',3.09),('15844','2013-06-03','11:20:00',4.15),('15844','2013-06-03','11:25:00',4.99),('15844','2013-06-03','11:30:00',3.64),('15844','2013-06-03','11:35:00',1.32),('15844','2013-06-03','11:40:00',3.31),('15844','2013-06-03','11:45:00',1.7),('15844','2013-06-03','11:50:00',2.64),('15844','2013-06-03','11:55:00',4.16),('15844','2013-06-03','12:00:00',1.8),('15844','2013-06-03','12:05:00',2.05),('15844','2013-06-03','12:10:00',3.8),('15844','2013-06-03','12:15:00',2.97),('15844','2013-06-03','12:20:00',1.12),('15844','2013-06-03','12:30:00',1),('15844','2013-06-03','12:35:00',1.2),('15844','2013-06-03','12:40:00',2.59),('15844','2013-06-03','12:45:00',1.02),('15844','2013-06-03','12:55:00',1.27),('15844','2013-06-03','13:00:00',2.06),('15844','2013-06-03','13:05:00',3.46),('15844','2013-06-03','13:10:00',5.13),('15844','2013-06-03','13:15:00',5.16),('15844','2013-06-03','13:20:00',2.68),('15844','2013-06-03','13:25:00',3.67),('15844','2013-06-03','13:30:00',1.77),('15844','2013-06-03','13:35:00',3.07),('15844','2013-06-03','13:40:00',4.78),('15844','2013-06-03','13:45:00',4.22),('15844','2013-06-03','13:50:00',4.29),('15844','2013-06-03','13:55:00',4.43),('15844','2013-06-03','14:00:00',3.99),('15844','2013-06-03','14:05:00',4.12),('15844','2013-06-03','14:10:00',1.77),('15844','2013-06-03','14:15:00',2.02),('15844','2013-06-03','14:20:00',3.14),('15844','2013-06-03','14:25:00',2.26),('15844','2013-06-03','14:30:00',2.83),('15844','2013-06-03','14:35:00',3.52),('15844','2013-06-03','14:40:00',3.47),('15844','2013-06-03','14:45:00',3.63),('15844','2013-06-03','14:50:00',3.58),('15844','2013-06-03','14:55:00',3.1),('15844','2013-06-03','15:00:00',3.42),('15844','2013-06-03','15:05:00',3.44),('15844','2013-06-03','15:10:00',2.4),('15844','2013-06-03','15:15:00',1.91),('15844','2013-06-03','15:20:00',2.82),('15844','2013-06-03','15:25:00',2.84),('15844','2013-06-03','15:30:00',2.01),('15844','2013-06-03','15:35:00',2.49),('15844','2013-06-03','15:40:00',2.4),('15844','2013-06-03','15:45:00',2.29),('15844','2013-06-03','15:50:00',2.2),('15844','2013-06-03','15:55:00',2.08),('15844','2013-06-03','16:00:00',1.96),('15844','2013-06-03','16:05:00',1.91),('15844','2013-06-03','16:10:00',1.87),('15844','2013-06-03','16:15:00',1.6),('15844','2013-06-03','16:20:00',1.51),('15844','2013-06-03','16:25:00',1.71),('15844','2013-06-03','16:30:00',1.7),('15844','2013-06-03','16:35:00',1.57),('15844','2013-06-03','16:40:00',1.51),('15844','2013-06-03','16:45:00',1.28),('15844','2013-06-03','16:50:00',1.29),('15844','2013-06-03','16:55:00',1.43),('15844','2013-06-03','17:00:00',1.51),('15844','2013-06-03','17:05:00',1.48),('15844','2013-06-03','17:10:00',1.39),('15844','2013-06-03','17:15:00',1.18),('15844','2013-06-03','17:20:00',1.05),('15844','2013-06-03','17:25:00',1.1),('15844','2013-06-03','17:30:00',1.01),('15844','2013-06-02','09:15:00',1.63),('15844','2013-06-02','09:20:00',2.06),('15844','2013-06-02','09:25:00',2.28),('15844','2013-06-02','09:30:00',2.42),('15844','2013-06-02','09:35:00',2.57),('15844','2013-06-02','09:40:00',2.71),('15844','2013-06-02','09:45:00',2.87),('15844','2013-06-02','09:50:00',2.98),('15844','2013-06-02','09:55:00',3.02),('15844','2013-06-02','10:00:00',3.09),('15844','2013-06-02','10:05:00',3.23),('15844','2013-06-02','10:10:00',3.36),('15844','2013-06-02','10:15:00',3.56),('15844','2013-06-02','10:20:00',3.87),('15844','2013-06-02','10:25:00',4.05),('15844','2013-06-02','10:30:00',3.77),('15844','2013-06-02','10:35:00',4.3),('15844','2013-06-02','10:40:00',1.68),('15844','2013-06-02','10:45:00',1.38),('15844','2013-06-02','10:50:00',1.38),('15844','2013-06-02','10:55:00',2.86),('15844','2013-06-02','11:00:00',2),('15844','2013-06-02','11:05:00',1.5),('15844','2013-06-02','11:10:00',2.33),('15844','2013-06-02','11:15:00',5.26),('15844','2013-06-02','11:20:00',1.94),('15844','2013-06-02','11:25:00',1.33),('15844','2013-06-02','11:30:00',3.05),('15844','2013-06-02','11:35:00',5.36),('15844','2013-06-02','11:40:00',1.55),('15844','2013-06-02','11:45:00',3.69),('15844','2013-06-02','11:50:00',3.19),('15844','2013-06-02','11:55:00',1.44),('15844','2013-06-02','12:00:00',3.88),('15844','2013-06-02','12:05:00',5.36),('15844','2013-06-02','12:10:00',3.87),('15844','2013-06-02','12:15:00',4.45),('15844','2013-06-02','12:20:00',4.88),('15844','2013-06-02','12:25:00',4.67),('15844','2013-06-02','12:30:00',4.64),('15844','2013-06-02','12:35:00',4.56),('15844','2013-06-02','12:40:00',4.69),('15844','2013-06-02','12:45:00',2.89),('15844','2013-06-02','12:50:00',3.24),('15844','2013-06-02','12:55:00',4.74),('15844','2013-06-02','13:00:00',4.6),('15844','2013-06-02','13:05:00',4.51),('15844','2013-06-02','13:10:00',4.42),('15844','2013-06-02','13:15:00',4.39),('15844','2013-06-02','13:20:00',4.37),('15844','2013-06-02','13:25:00',4.35),('15844','2013-06-02','13:30:00',4.31),('15844','2013-06-02','13:35:00',4.26),('15844','2013-06-02','13:40:00',4.21),('15844','2013-06-02','13:45:00',4.17),('15844','2013-06-02','13:50:00',4.14),('15844','2013-06-02','13:55:00',4.08),('15844','2013-06-02','14:00:00',4.05),('15844','2013-06-02','14:05:00',3.98),('15844','2013-06-02','14:10:00',3.97),('15844','2013-06-02','14:15:00',3.97),('15844','2013-06-02','14:20:00',3.88),('15844','2013-06-02','14:25:00',2.88),('15844','2013-06-02','14:30:00',3.58),('15844','2013-06-02','14:35:00',3.69),('15844','2013-06-02','14:40:00',3.56),('15844','2013-06-02','14:45:00',3.39),('15844','2013-06-02','14:50:00',3.38),('15844','2013-06-02','14:55:00',3.28),('15844','2013-06-02','15:00:00',3.18),('15844','2013-06-02','15:05:00',3.02),('15844','2013-06-02','15:10:00',2.95),('15844','2013-06-02','15:15:00',2.81),('15844','2013-06-02','15:20:00',2.43),('15844','2013-06-02','15:25:00',2.68),('15844','2013-06-02','15:30:00',2.38),('15844','2013-06-02','15:35:00',2.47),('15844','2013-06-02','15:40:00',2.39),('15844','2013-06-02','15:45:00',2.56),('15844','2013-06-02','15:50:00',2.24),('15844','2013-06-02','15:55:00',2.25),('15844','2013-06-02','16:00:00',2.1),('15844','2013-06-02','16:05:00',1.77),('15844','2013-06-02','16:10:00',2.26),('15844','2013-06-02','16:15:00',1.17),('15844','2013-06-02','16:20:00',1.88),('15844','2013-06-02','16:25:00',1.61),('15844','2013-06-02','16:30:00',1.5),('15844','2013-06-02','16:35:00',1.44),('15844','2013-06-02','16:40:00',1.41),('15844','2013-06-02','16:45:00',1.34),('15844','2013-06-02','16:50:00',1.26),('15844','2013-06-01','07:50:00',1.04),('15844','2013-06-01','08:30:00',1.05),('15844','2013-06-01','08:55:00',1.21),('15844','2013-06-01','09:40:00',1.01),('15844','2013-06-01','10:25:00',1.2),('15844','2013-06-01','10:30:00',1.28),('15844','2013-06-01','10:35:00',1.72),('15844','2013-06-01','10:40:00',1.64),('15844','2013-06-01','10:45:00',4.25),('15844','2013-06-01','10:50:00',3.75),('15844','2013-06-01','11:45:00',1.35),('15844','2013-06-01','11:50:00',2.97),('15844','2013-06-01','11:55:00',3.39),('15844','2013-06-01','12:00:00',1.85),('15844','2013-06-01','12:35:00',1.02),('15844','2013-06-01','12:40:00',1.76),('15844','2013-06-01','12:45:00',1.31),('15844','2013-06-01','12:50:00',1.31),('15844','2013-06-01','12:55:00',1.28),('15844','2013-06-01','13:00:00',1.08),('15844','2013-06-01','13:05:00',1.02),('15844','2013-06-01','13:10:00',1.56),('15844','2013-06-01','13:15:00',1.77),('15844','2013-06-01','13:20:00',1.67),('15844','2013-06-01','13:25:00',1.5),('15844','2013-06-01','13:30:00',1.17),('15844','2013-06-01','13:35:00',1.14),('15844','2013-06-01','13:40:00',1.08),('15844','2013-06-01','13:55:00',1.81),('15844','2013-06-01','14:00:00',2.66),('15844','2013-06-01','14:05:00',2.01),('15844','2013-06-01','14:10:00',1.94),('15844','2013-06-01','14:15:00',1.78),('15844','2013-06-01','14:20:00',1.49),('15844','2013-06-01','14:25:00',1.17),('15844','2013-06-01','14:30:00',1.05),('15844','2013-06-01','14:50:00',1.03),('15844','2013-06-01','15:40:00',1.5),('15844','2013-06-01','15:45:00',1.63),('15844','2013-06-01','15:50:00',1.5),('15844','2013-06-01','15:55:00',1.53),('15844','2013-06-01','16:00:00',1.18),('15844','2013-06-01','18:20:00',1.01),('15844','2014-04-02','09:30:00',1.69),('15844','2014-04-02','09:35:00',2.05),('15844','2014-04-02','09:40:00',2.49),('15844','2014-04-02','09:45:00',2.46),('15844','2014-04-02','09:50:00',2.47),('15844','2014-04-02','09:55:00',2.52),('15844','2014-04-02','10:00:00',1.35),('15844','2014-04-02','10:30:00',1.25),('15844','2014-04-02','10:35:00',2.76),('15844','2014-04-02','10:40:00',1.75),('15844','2014-04-02','10:45:00',3.51),('15844','2014-04-02','10:50:00',2.37),('15844','2014-04-02','10:55:00',1.74),('15844','2014-04-02','11:00:00',3.42),('15844','2014-04-02','11:05:00',3.11),('15844','2014-04-02','11:10:00',1.41),('15844','2014-04-02','11:15:00',1.24),('15844','2014-04-02','11:20:00',1.08),('15844','2014-04-02','11:25:00',3.13),('15844','2014-04-02','11:30:00',4.12),('15844','2014-04-02','11:35:00',2.56),('15844','2014-04-02','11:40:00',2.71),('15844','2014-04-02','11:45:00',3.29),('15844','2014-04-02','11:50:00',4.02),('15844','2014-04-02','11:55:00',3.94),('15844','2014-04-02','12:00:00',3.13),('15844','2014-04-02','12:05:00',2.55),('15844','2014-04-02','12:10:00',3.68),('15844','2014-04-02','12:15:00',1.51),('15844','2014-04-02','12:20:00',1.57),('15844','2014-04-02','12:25:00',3.28),('15844','2014-04-02','12:30:00',4.28),('15844','2014-04-02','12:35:00',4.13),('15844','2014-04-02','12:40:00',3.95),('15844','2014-04-02','12:45:00',3.39),('15844','2014-04-02','12:50:00',1.67),('15844','2014-04-02','12:55:00',4.12),('15844','2014-04-02','13:00:00',3.14),('15844','2014-04-02','13:05:00',2.8),('15844','2014-04-02','13:10:00',1.87),('15844','2014-04-02','13:15:00',2.89),('15844','2014-04-02','13:20:00',2.98),('15844','2014-04-02','13:25:00',2.66),('15844','2014-04-02','13:30:00',3.02),('15844','2014-04-02','13:35:00',2.56),('15844','2014-04-02','13:40:00',1.88),('15844','2014-04-02','13:45:00',3.75),('15844','2014-04-02','13:50:00',3.62),('15844','2014-04-02','13:55:00',2.79),('15844','2014-04-02','14:00:00',3.76),('15844','2014-04-02','14:05:00',3.36),('15844','2014-04-02','14:10:00',3.39),('15844','2014-04-02','14:15:00',3.38),('15844','2014-04-02','14:20:00',3.21),('15844','2014-04-02','14:25:00',3.12),('15844','2014-04-02','14:30:00',3.02),('15844','2014-04-02','14:35:00',2.87),('15844','2014-04-02','14:40:00',2.76),('15844','2014-04-02','14:45:00',2.64),('15844','2014-04-02','14:50:00',2.27),('15844','2014-04-02','14:55:00',2.27),('15844','2014-04-02','15:00:00',2.31),('15844','2014-04-02','15:05:00',2.12),('15844','2014-04-02','15:10:00',2.01),('15844','2014-04-02','15:15:00',1.97),('15844','2014-04-02','15:20:00',1.91),('15844','2014-04-02','15:25:00',1.82),('15844','2014-04-02','15:30:00',1.66),('15844','2014-04-02','15:35:00',1.56),('15844','2014-04-02','15:40:00',1.54),('15844','2014-04-02','15:45:00',1.47),('15844','2014-04-02','15:50:00',1.35),('15844','2014-04-02','15:55:00',1.16),('15844','2014-04-02','16:00:00',1.17),('15844','2014-04-02','16:05:00',1.08),('15844','2014-04-02','16:10:00',1.02),('15844','2013-05-31','08:20:00',1.08),('15844','2013-05-31','08:25:00',1.2),('15844','2013-05-31','08:30:00',1.32),('15844','2013-05-31','08:35:00',1.7),('15844','2013-05-31','08:40:00',1.08),('15844','2013-05-31','08:45:00',1.48),('15844','2013-05-31','08:50:00',1.02),('15844','2013-05-31','08:55:00',1.49),('15844','2013-05-31','09:00:00',1.26),('15844','2013-05-31','09:05:00',1.66),('15844','2013-05-31','09:10:00',1.01),('15844','2013-05-31','09:20:00',1.71),('15844','2013-05-31','09:30:00',1.64),('15844','2013-05-31','09:35:00',2.95),('15844','2013-05-31','09:40:00',2.47),('15844','2013-05-31','09:45:00',2.98),('15844','2013-05-31','09:50:00',2.59),('15844','2013-05-31','09:55:00',1.95),('15844','2013-05-31','10:00:00',3.49),('15844','2013-05-31','10:05:00',2.44),('15844','2013-05-31','10:10:00',4.38),('15844','2013-05-31','10:15:00',1.44),('15844','2013-05-31','10:20:00',1.39),('15844','2013-05-31','10:25:00',3.1),('15844','2013-05-31','10:30:00',3.89),('15844','2013-05-31','10:35:00',3.16),('15844','2013-05-31','10:40:00',4.49),('15844','2013-05-31','10:45:00',2.49),('15844','2013-05-31','10:50:00',1.44),('15844','2013-05-31','10:55:00',1.75),('15844','2013-05-31','11:00:00',3.05),('15844','2013-05-31','11:05:00',3.58),('15844','2013-05-31','11:10:00',1.62),('15844','2013-05-31','11:15:00',2.4),('15844','2013-05-31','11:30:00',1.08),('15844','2013-05-31','11:35:00',2.19),('15844','2013-05-31','11:40:00',3.68),('15844','2013-05-31','11:45:00',5.65),('15844','2013-05-31','11:50:00',3.21),('15844','2013-05-31','11:55:00',4.95),('15844','2013-05-31','12:00:00',4.01),('15844','2013-05-31','12:05:00',4.67),('15844','2013-05-31','12:10:00',1.85),('15844','2013-05-31','12:15:00',1.83),('15844','2013-05-31','12:20:00',3.54),('15844','2013-05-31','12:25:00',2.07),('15844','2013-05-31','12:30:00',1.54),('15844','2013-05-31','12:35:00',2.54),('15844','2013-05-31','12:40:00',2.64),('15844','2013-05-31','12:50:00',2.22),('15844','2013-05-31','12:55:00',4.46),('15844','2013-05-31','13:00:00',1.87),('15844','2013-05-31','13:15:00',1.39),('15844','2013-05-31','13:20:00',2.21),('15844','2013-05-31','13:25:00',2.02),('15844','2013-05-31','13:30:00',2.06),('15844','2013-05-31','13:35:00',1.18),('15844','2013-05-31','13:40:00',2.37),('15844','2013-05-31','13:45:00',2.4),('15844','2013-05-31','13:50:00',1.85),('15844','2013-05-31','13:55:00',1.63),('15844','2013-05-31','14:25:00',1.13),('15844','2013-05-31','14:30:00',1.09),('15844','2013-05-31','14:55:00',1.31),('15844','2013-05-31','15:00:00',1.18),('15844','2013-05-31','15:05:00',1.3),('15844','2013-05-31','15:10:00',2.1),('15844','2013-05-31','15:15:00',2.36),('15844','2013-05-31','15:20:00',2.47),('15844','2013-05-31','15:25:00',1.61),('15844','2013-05-31','15:30:00',1.61),('15844','2013-05-31','15:35:00',1.48),('15844','2013-05-31','15:40:00',1.33),('15844','2013-05-31','15:45:00',2.11),('15844','2013-05-31','15:50:00',2.04),('15844','2013-05-31','15:55:00',1.38),('15844','2013-05-31','16:00:00',1.16),('15844','2013-05-31','16:20:00',1.2),('15844','2013-05-31','16:25:00',1.11),('15844','2013-05-31','16:40:00',1.07),('15844','2013-05-30','08:35:00',1.33),('15844','2013-05-30','08:40:00',1.36),('15844','2013-05-30','08:45:00',1.44),('15844','2013-05-30','08:50:00',1.53),('15844','2013-05-30','08:55:00',1.71),('15844','2013-05-30','09:00:00',1.85),('15844','2013-05-30','09:05:00',1.86),('15844','2013-05-30','09:10:00',2.01),('15844','2013-05-30','09:15:00',2.11),('15844','2013-05-30','09:20:00',2.22),('15844','2013-05-30','09:25:00',2.46),('15844','2013-05-30','09:30:00',2.29),('15844','2013-05-30','09:35:00',1.44),('15844','2013-05-30','09:40:00',1.58),('15844','2013-05-30','09:45:00',1.39),('15844','2013-05-30','09:50:00',1.29),('15844','2013-05-30','10:00:00',2.42),('15844','2013-05-30','10:05:00',2.36),('15844','2013-05-30','10:10:00',3.05),('15844','2013-05-30','10:15:00',2.87),('15844','2013-05-30','10:25:00',1.54),('15844','2013-05-30','10:30:00',1.49),('15844','2013-05-30','10:35:00',4),('15844','2013-05-30','10:40:00',4),('15844','2013-05-30','10:45:00',2.86),('15844','2013-05-30','10:50:00',3.67),('15844','2013-05-30','10:55:00',2.52),('15844','2013-05-30','11:00:00',2.46),('15844','2013-05-30','11:05:00',4.11),('15844','2013-05-30','11:10:00',3.56),('15844','2013-05-30','11:15:00',4.93),('15844','2013-05-30','11:20:00',1.14),('15844','2013-05-30','11:25:00',4.51),('15844','2013-05-30','11:30:00',5.19),('15844','2013-05-30','11:35:00',2.96),('15844','2013-05-30','11:40:00',3.52),('15844','2013-05-30','11:45:00',5.11),('15844','2013-05-30','11:50:00',4.64),('15844','2013-05-30','11:55:00',4.61),('15844','2013-05-30','12:00:00',4.54),('15844','2013-05-30','12:05:00',1.95),('15844','2013-05-30','12:10:00',1.13),('15844','2013-05-30','12:15:00',4.39),('15844','2013-05-30','12:20:00',3.35),('15844','2013-05-30','12:25:00',3.44),('15844','2013-05-30','12:30:00',4.82),('15844','2013-05-30','12:35:00',3.09),('15844','2013-05-30','12:40:00',4.73),('15844','2013-05-30','12:45:00',4.38),('15844','2013-05-30','12:50:00',5.21),('15844','2013-05-30','12:55:00',3.64),('15844','2013-05-30','13:00:00',3.23),('15844','2013-05-30','13:05:00',3.71),('15844','2013-05-30','13:10:00',3.16),('15844','2013-05-30','13:15:00',3.89),('15844','2013-05-30','13:20:00',1.22),('15844','2013-05-30','13:25:00',1.81),('15844','2013-05-30','13:30:00',1.73),('15844','2013-05-30','13:35:00',2.98),('15844','2013-05-30','13:40:00',1.92),('15844','2013-05-30','13:45:00',1.31),('15844','2013-05-30','13:50:00',3.26),('15844','2013-05-30','13:55:00',4.02),('15844','2013-05-30','14:00:00',1.67),('15844','2013-05-30','14:05:00',2.7),('15844','2013-05-30','14:10:00',4.41),('15844','2013-05-30','14:15:00',3.58),('15844','2013-05-30','14:20:00',4.34),('15844','2013-05-30','14:25:00',4.42),('15844','2013-05-30','14:30:00',3.15),('15844','2013-05-30','14:35:00',2.75),('15844','2013-05-30','14:40:00',2.6),('15844','2013-05-30','14:45:00',2.27),('15844','2013-05-30','14:50:00',1.99),('15844','2013-05-30','14:55:00',3.02),('15844','2013-05-30','15:00:00',3.77),('15844','2013-05-30','15:05:00',2.52),('15844','2013-05-30','15:10:00',2.92),('15844','2013-05-30','15:15:00',2.82),('15844','2013-05-30','15:20:00',3.14),('15844','2013-05-30','15:25:00',2.56),('15844','2013-05-30','15:30:00',2.92),('15844','2013-05-30','15:35:00',2.74),('15844','2013-05-30','15:40:00',1.74),('15844','2013-05-30','15:45:00',1.78),('15844','2013-05-30','15:50:00',2.66),('15844','2013-05-30','15:55:00',2.15),('15844','2013-05-30','16:00:00',2.19),('15844','2013-05-30','16:05:00',1.95),('15844','2013-05-30','16:10:00',1.77),('15844','2013-05-30','16:15:00',1.47),('15844','2013-05-30','16:35:00',1.02),('15844','2013-05-30','16:45:00',1.56),('15844','2013-05-30','16:55:00',1.04),('15844','2013-05-30','17:00:00',1.12),('15844','2013-05-29','08:20:00',1.05),('15844','2013-05-29','08:25:00',1.17),('15844','2013-05-29','08:30:00',1.25),('15844','2013-05-29','08:35:00',1.29),('15844','2013-05-29','08:40:00',1.32),('15844','2013-05-29','08:45:00',1.36),('15844','2013-05-29','08:50:00',1.5),('15844','2013-05-29','08:55:00',1.68),('15844','2013-05-29','09:00:00',1.77),('15844','2013-05-29','09:05:00',1.82),('15844','2013-05-29','09:10:00',1.85),('15844','2013-05-29','09:15:00',1.95),('15844','2013-05-29','09:20:00',2.05),('15844','2013-05-29','09:25:00',2.26),('15844','2013-05-29','09:30:00',2.49),('15844','2013-05-29','09:35:00',2.59),('15844','2013-05-29','09:40:00',2.7),('15844','2013-05-29','09:45:00',2.83),('15844','2013-05-29','09:50:00',2.93),('15844','2013-05-29','09:55:00',3.08),('15844','2013-05-29','10:00:00',3.17),('15844','2013-05-29','10:05:00',3.24),('15844','2013-05-29','10:10:00',3.33),('15844','2013-05-29','10:15:00',3.44),('15844','2013-05-29','10:20:00',3.77),('15844','2013-05-29','10:25:00',3.92),('15844','2013-05-29','10:30:00',4.03),('15844','2013-05-29','10:35:00',4.13),('15844','2013-05-29','10:40:00',4.18),('15844','2013-05-29','10:45:00',4.36),('15844','2013-05-29','10:50:00',4.53),('15844','2013-05-29','10:55:00',4.62),('15844','2013-05-29','11:00:00',4.45),('15844','2013-05-29','11:05:00',4.38),('15844','2013-05-29','11:10:00',3.01),('15844','2013-05-29','11:15:00',4.54),('15844','2013-05-29','11:20:00',1.81),('15844','2013-05-29','11:25:00',2.42),('15844','2013-05-29','11:30:00',3.17),('15844','2013-05-29','11:35:00',3.82),('15844','2013-05-29','11:40:00',4.55),('15844','2013-05-29','11:45:00',4.15),('15844','2013-05-29','11:50:00',4.7),('15844','2013-05-29','11:55:00',4.65),('15844','2013-05-29','12:00:00',3.43),('15844','2013-05-29','12:05:00',4.79),('15844','2013-05-29','12:10:00',4.77),('15844','2013-05-29','12:15:00',4.8),('15844','2013-05-29','12:20:00',4.68),('15844','2013-05-29','12:25:00',4.72),('15844','2013-05-29','12:30:00',4.59),('15844','2013-05-29','12:35:00',4.65),('15844','2013-05-29','12:40:00',4.45),('15844','2013-05-29','12:45:00',4.64),('15844','2013-05-29','12:50:00',4.6),('15844','2013-05-29','12:55:00',4.59),('15844','2013-05-29','13:00:00',4.35),('15844','2013-05-29','13:05:00',4.58),('15844','2013-05-29','13:10:00',4.52),('15844','2013-05-29','13:15:00',3.84),('15844','2013-05-29','13:20:00',4.49),('15844','2013-05-29','13:25:00',3.89),('15844','2013-05-29','13:30:00',2.95),('15844','2013-05-29','13:35:00',2.27),('15844','2013-05-29','13:40:00',2.08),('15844','2013-05-29','13:45:00',2.36),('15844','2013-05-29','13:50:00',4.52),('15844','2013-05-29','13:55:00',4.6),('15844','2013-05-29','14:00:00',4.43),('15844','2013-05-29','14:05:00',3.7),('15844','2013-05-29','14:10:00',3.51),('15844','2013-05-29','14:15:00',3.94),('15844','2013-05-29','14:20:00',3.18),('15844','2013-05-29','14:25:00',2.47),('15844','2013-05-29','14:30:00',2.85),('15844','2013-05-29','14:35:00',3.14),('15844','2013-05-29','14:40:00',2.89),('15844','2013-05-29','14:45:00',2.95),('15844','2013-05-29','14:50:00',2.9),('15844','2013-05-29','14:55:00',3.41),('15844','2013-05-29','15:00:00',1.97),('15844','2013-05-29','15:05:00',2.72),('15844','2013-05-29','15:10:00',1.85),('15844','2013-05-29','15:15:00',1.74),('15844','2013-05-29','15:20:00',1.58),('15844','2013-05-29','15:25:00',1.98),('15844','2013-05-29','15:30:00',2.19),('15844','2013-05-29','15:35:00',2.11),('15844','2013-05-29','15:40:00',1.98),('15844','2013-05-29','15:45:00',2.38),('15844','2013-05-29','15:50:00',2.23),('15844','2013-05-29','15:55:00',1.7),('15844','2013-05-29','16:00:00',1.89),('15844','2013-05-29','16:05:00',1.95),('15844','2013-05-29','16:10:00',1.8),('15844','2013-05-29','16:15:00',1.75),('15844','2013-05-29','16:20:00',1.78),('15844','2013-05-29','16:25:00',1.8),('15844','2013-05-29','16:30:00',1.87),('15844','2013-05-29','16:35:00',1.83),('15844','2013-05-29','16:40:00',1.55),('15844','2013-05-29','16:45:00',1.52),('15844','2013-05-29','16:50:00',1.34),('15844','2013-05-29','16:55:00',1.09),('15844','2013-05-29','17:35:00',1.16),('15844','2013-05-29','17:40:00',1.02),('15844','2013-05-28','08:15:00',1.14),('15844','2013-05-28','08:20:00',1.08),('15844','2013-05-28','08:25:00',1.09),('15844','2013-05-28','08:30:00',1.36),('15844','2013-05-28','08:35:00',1.32),('15844','2013-05-28','08:40:00',1.2),('15844','2013-05-28','08:45:00',1.26),('15844','2013-05-28','08:50:00',1.28),('15844','2013-05-28','08:55:00',1.22),('15844','2013-05-28','09:00:00',1.32),('15844','2013-05-28','09:05:00',1.53),('15844','2013-05-28','09:10:00',1.58),('15844','2013-05-28','09:15:00',1.63),('15844','2013-05-28','09:20:00',1.65),('15844','2013-05-28','09:25:00',1.75),('15844','2013-05-28','09:30:00',1.87),('15844','2013-05-28','09:35:00',2.17),('15844','2013-05-28','09:40:00',1.98),('15844','2013-05-28','09:45:00',2.02),('15844','2013-05-28','09:50:00',2.03),('15844','2013-05-28','09:55:00',2.01),('15844','2013-05-28','10:00:00',1.85),('15844','2013-05-28','10:05:00',2),('15844','2013-05-28','10:10:00',2.3),('15844','2013-05-28','10:15:00',2.38),('15844','2013-05-28','10:20:00',2.33),('15844','2013-05-28','10:25:00',2.34),('15844','2013-05-28','10:30:00',2.78),('15844','2013-05-28','10:35:00',2.93),('15844','2013-05-28','10:40:00',2.92),('15844','2013-05-28','10:45:00',2.5),('15844','2013-05-28','10:50:00',2.28),('15844','2013-05-28','10:55:00',2.58),('15844','2013-05-28','11:00:00',2.54),('15844','2013-05-28','11:05:00',2.77),('15844','2013-05-28','11:10:00',3.15),('15844','2013-05-28','11:15:00',2.63),('15844','2013-05-28','11:20:00',1.61),('15844','2013-05-28','11:25:00',3.57),('15844','2013-05-28','11:30:00',4.48),('15844','2013-05-28','11:35:00',4.12),('15844','2013-05-28','11:40:00',4.43),('15844','2013-05-28','11:45:00',1.91),('15844','2013-05-28','11:50:00',1),('15844','2013-05-28','12:00:00',1.76),('15844','2013-05-28','12:05:00',1.82),('15844','2013-05-28','12:10:00',2.12),('15844','2013-05-28','12:15:00',2.12),('15844','2013-05-28','12:20:00',2),('15844','2013-05-28','12:25:00',2.41),('15844','2013-05-28','12:30:00',2.76),('15844','2013-05-28','12:35:00',2.15),('15844','2013-05-28','12:40:00',2.23),('15844','2013-05-28','12:45:00',2.12),('15844','2013-05-28','12:50:00',2.16),('15844','2013-05-28','12:55:00',2.41),('15844','2013-05-28','13:00:00',2.49),('15844','2013-05-28','13:05:00',2.62),('15844','2013-05-28','13:10:00',2.32),('15844','2013-05-28','13:15:00',1.73),('15844','2013-05-28','13:20:00',2.13),('15844','2013-05-28','13:25:00',2.55),('15844','2013-05-28','13:30:00',3.16),('15844','2013-05-28','13:35:00',2.99),('15844','2013-05-28','13:40:00',2.15),('15844','2013-05-28','13:45:00',1.95),('15844','2013-05-28','13:50:00',1.63),('15844','2013-05-28','13:55:00',1.55),('15844','2013-05-28','14:00:00',1.72),('15844','2013-05-28','14:05:00',2.06),('15844','2013-05-28','14:10:00',2.13),('15844','2013-05-28','14:15:00',2.41),('15844','2013-05-28','14:20:00',2.95),('15844','2013-05-28','14:25:00',2.11),('15844','2013-05-28','14:30:00',2.99),('15844','2013-05-28','14:35:00',2.58),('15844','2013-05-28','14:40:00',2.22),('15844','2013-05-28','14:45:00',2.53),('15844','2013-05-28','14:50:00',2.82),('15844','2013-05-28','14:55:00',2.84),('15844','2013-05-28','15:00:00',2.5),('15844','2013-05-28','15:05:00',1.58),('15844','2013-05-28','15:10:00',1.47),('15844','2013-05-28','15:15:00',2.08),('15844','2013-05-28','15:20:00',2.02),('15844','2013-05-28','15:25:00',1.46),('15844','2013-05-28','15:30:00',1.44),('15844','2013-05-28','15:35:00',1.44),('15844','2013-05-28','15:40:00',1.7),('15844','2013-05-28','15:45:00',2.04),('15844','2013-05-28','15:50:00',1.61),('15844','2013-05-28','15:55:00',1.88),('15844','2013-05-28','16:00:00',1.52),('15844','2013-05-28','16:05:00',1.25),('15844','2013-05-28','16:10:00',1.42),('15844','2013-05-28','16:15:00',1.68),('15844','2013-05-28','16:20:00',1.7),('15844','2013-05-28','16:25:00',1.41),('15844','2013-05-28','16:30:00',1.05),('15844','2013-05-28','16:35:00',1.45),('15844','2013-05-28','16:40:00',1.33),('15844','2013-05-28','16:45:00',1.17),('15844','2013-05-27','08:05:00',1.19),('15844','2013-05-27','08:15:00',1.02),('15844','2013-05-27','08:20:00',1.06),('15844','2013-05-27','08:25:00',1.13),('15844','2013-05-27','08:30:00',1.27),('15844','2013-05-27','08:35:00',1.13),('15844','2013-05-27','08:40:00',1.23),('15844','2013-05-27','08:45:00',1.02),('15844','2013-05-27','08:50:00',1.22),('15844','2013-05-27','08:55:00',2.27),('15844','2013-05-27','09:00:00',1.49),('15844','2013-05-27','09:10:00',1.65),('15844','2013-05-27','09:15:00',1.23),('15844','2013-05-27','09:20:00',2.01),('15844','2013-05-27','09:25:00',2.51),('15844','2013-05-27','09:30:00',2.58),('15844','2013-05-27','09:35:00',2.66),('15844','2013-05-27','09:40:00',2.84),('15844','2013-05-27','09:45:00',3.13),('15844','2013-05-27','09:50:00',1.75),('15844','2013-05-27','09:55:00',3.2),('15844','2013-05-27','10:00:00',3.3),('15844','2013-05-27','10:05:00',3.43),('15844','2013-05-27','10:10:00',3.54),('15844','2013-05-27','10:15:00',3.73),('15844','2013-05-27','10:20:00',4.09),('15844','2013-05-27','10:25:00',2.98),('15844','2013-05-27','10:30:00',3.33),('15844','2013-05-27','10:35:00',4.15),('15844','2013-05-27','10:40:00',3.48),('15844','2013-05-27','10:45:00',3.38),('15844','2013-05-27','10:50:00',3.75),('15844','2013-05-27','10:55:00',5.16),('15844','2013-05-27','11:00:00',1.75),('15844','2013-05-27','11:05:00',3.79),('15844','2013-05-27','11:10:00',3.18),('15844','2013-05-27','11:15:00',1.56),('15844','2013-05-27','11:20:00',4.22),('15844','2013-05-27','11:25:00',3.88),('15844','2013-05-27','11:30:00',5.09),('15844','2013-05-27','11:35:00',2.37),('15844','2013-05-27','11:40:00',3.61),('15844','2013-05-27','11:45:00',4.84),('15844','2013-05-27','11:50:00',3.98),('15844','2013-05-27','11:55:00',4.59),('15844','2013-05-27','12:00:00',3.55),('15844','2013-05-27','12:05:00',4.43),('15844','2013-05-27','12:10:00',3.22),('15844','2013-05-27','12:15:00',5.21),('15844','2013-05-27','12:20:00',5.04),('15844','2013-05-27','12:25:00',4.99),('15844','2013-05-27','12:30:00',2.84),('15844','2013-05-27','12:35:00',4.84),('15844','2013-05-27','12:40:00',4.81),('15844','2013-05-27','12:45:00',4.76),('15844','2013-05-27','12:50:00',3.98),('15844','2013-05-27','12:55:00',1.38),('15844','2013-05-27','13:00:00',4.52),('15844','2013-05-27','13:05:00',3.19),('15844','2013-05-27','13:10:00',2.95),('15844','2013-05-27','13:15:00',4.06),('15844','2013-05-27','13:20:00',4.29),('15844','2013-05-27','13:25:00',4.34),('15844','2013-05-27','13:30:00',4.27),('15844','2013-05-27','13:35:00',4.03),('15844','2013-05-27','13:40:00',4.42),('15844','2013-05-27','13:45:00',4.3),('15844','2013-05-27','13:50:00',4.2),('15844','2013-05-27','13:55:00',4.05),('15844','2013-05-27','14:00:00',3.97),('15844','2013-05-27','14:05:00',3.98),('15844','2013-05-27','14:10:00',3.92),('15844','2013-05-27','14:15:00',3.81),('15844','2013-05-27','14:20:00',3.8),('15844','2013-05-27','14:25:00',3.77),('15844','2013-05-27','14:30:00',3.74),('15844','2013-05-27','14:35:00',3.7),('15844','2013-05-27','14:40:00',3.65),('15844','2013-05-27','14:45:00',3.52),('15844','2013-05-27','14:50:00',3.4),('15844','2013-05-27','14:55:00',2.81),('15844','2013-05-27','15:00:00',1.69),('15844','2013-05-27','15:05:00',2.2),('15844','2013-05-27','15:10:00',2.86),('15844','2013-05-27','15:15:00',2.28),('15844','2013-05-27','15:20:00',2.23),('15844','2013-05-27','15:25:00',2.3),('15844','2013-05-27','15:30:00',2.56),('15844','2013-05-27','15:35:00',2.61),('15844','2013-05-27','15:40:00',1.97),('15844','2013-05-27','15:45:00',2.4),('15844','2013-05-27','15:50:00',2.25),('15844','2013-05-27','15:55:00',1.54),('15844','2013-05-27','16:00:00',1.84),('15844','2013-05-27','16:05:00',1.64),('15844','2013-05-27','16:10:00',1.4),('15844','2013-05-27','16:15:00',1.67),('15844','2013-05-27','16:20:00',2.1),('15844','2013-05-27','16:25:00',1.69),('15844','2013-05-27','16:30:00',1.62),('15844','2013-05-27','16:35:00',1.2),('15844','2013-05-27','16:50:00',1.04),('15844','2013-05-27','16:55:00',1.08),('15844','2013-05-27','17:00:00',1.09),('15844','2013-05-27','17:05:00',1.16),('15844','2013-05-27','17:10:00',1.23),('15844','2013-05-27','17:15:00',1.06),('15844','2013-05-26','07:45:00',1.03),('15844','2013-05-26','08:00:00',1.17),('15844','2013-05-26','08:15:00',1.41),('15844','2013-05-26','08:20:00',1.21),('15844','2013-05-26','08:25:00',1.12),('15844','2013-05-26','08:30:00',1.02),('15844','2013-05-26','08:35:00',1.33),('15844','2013-05-26','08:40:00',1.25),('15844','2013-05-26','08:45:00',1.18),('15844','2013-05-26','08:50:00',1.26),('15844','2013-05-26','08:55:00',1.86),('15844','2013-05-26','09:05:00',1.02),('15844','2013-05-26','09:10:00',1.92),('15844','2013-05-26','09:25:00',1.73),('15844','2013-05-26','09:40:00',1.91),('15844','2013-05-26','09:50:00',1.22),('15844','2013-05-26','09:55:00',1.12),('15844','2013-05-26','10:00:00',3.55),('15844','2013-05-26','10:05:00',3.92),('15844','2013-05-26','10:10:00',3.16),('15844','2013-05-26','10:15:00',2.65),('15844','2013-05-26','10:20:00',4.14),('15844','2013-05-26','10:25:00',3.45),('15844','2013-05-26','10:30:00',2.66),('15844','2013-05-26','10:35:00',4.15),('15844','2013-05-26','10:40:00',4.41),('15844','2013-05-26','10:45:00',4.09),('15844','2013-05-26','10:50:00',4.48),('15844','2013-05-26','10:55:00',4.71),('15844','2013-05-26','11:00:00',4.68),('15844','2013-05-26','11:05:00',4.7),('15844','2013-05-26','11:10:00',4.71),('15844','2013-05-26','11:15:00',4.74),('15844','2013-05-26','11:20:00',4.76),('15844','2013-05-26','11:25:00',4.4),('15844','2013-05-26','11:30:00',4.81),('15844','2013-05-26','11:35:00',4.82),('15844','2013-05-26','11:40:00',4.81),('15844','2013-05-26','11:45:00',4.82),('15844','2013-05-26','11:50:00',4.79),('15844','2013-05-26','11:55:00',4.57),('15844','2013-05-26','12:00:00',4.86),('15844','2013-05-26','12:05:00',4.85),('15844','2013-05-26','12:10:00',4.88),('15844','2013-05-26','12:15:00',4.83),('15844','2013-05-26','12:20:00',4.93),('15844','2013-05-26','12:25:00',4.19),('15844','2013-05-26','12:30:00',4.07),('15844','2013-05-26','12:35:00',4.26),('15844','2013-05-26','12:40:00',3.57),('15844','2013-05-26','12:45:00',4.52),('15844','2013-05-26','12:50:00',4.8),('15844','2013-05-26','12:55:00',4.6),('15844','2013-05-26','13:00:00',4.37),('15844','2013-05-26','13:05:00',3.66),('15844','2013-05-26','13:10:00',4.68),('15844','2013-05-26','13:15:00',4.59),('15844','2013-05-26','13:20:00',4.52),('15844','2013-05-26','13:25:00',4.51),('15844','2013-05-26','13:30:00',4.44),('15844','2013-05-26','13:35:00',4.4),('15844','2013-05-26','13:40:00',4.37),('15844','2013-05-26','13:45:00',4.4),('15844','2013-05-26','13:50:00',4.27),('15844','2013-05-26','13:55:00',4.2),('15844','2013-05-26','14:00:00',4.13),('15844','2013-05-26','14:05:00',4.07),('15844','2013-05-26','14:10:00',3.99),('15844','2013-05-26','14:15:00',3.93),('15844','2013-05-26','14:20:00',3.87),('15844','2013-05-26','14:25:00',3.81),('15844','2013-05-26','14:30:00',3.72),('15844','2013-05-26','14:35:00',3.69),('15844','2013-05-26','14:40:00',3.62),('15844','2013-05-26','14:45:00',3.51),('15844','2013-05-26','14:50:00',3.41),('15844','2013-05-26','14:55:00',3.32),('15844','2013-05-26','15:00:00',3.2),('15844','2013-05-26','15:05:00',3.09),('15844','2013-05-26','15:10:00',2.97),('15844','2013-05-26','15:15:00',2.83),('15844','2013-05-26','15:20:00',2.68),('15844','2013-05-26','15:25:00',2.58),('15844','2013-05-26','15:30:00',2.49),('15844','2013-05-26','15:35:00',2.39),('15844','2013-05-26','15:40:00',2.31),('15844','2013-05-26','15:45:00',2.2),('15844','2013-05-26','15:50:00',2.08),('15844','2013-05-26','15:55:00',1.95),('15844','2013-05-26','16:00:00',1.84),('15844','2013-05-26','16:05:00',1.74),('15844','2013-05-26','16:10:00',1.65),('15844','2013-05-26','16:15:00',1.6),('15844','2013-05-26','16:20:00',1.55),('15844','2013-05-26','16:25:00',1.51),('15844','2013-05-26','16:30:00',1.45),('15844','2013-05-26','16:35:00',1.39),('15844','2013-05-26','16:40:00',1.3),('15844','2013-05-26','16:45:00',1.17),('15844','2013-05-25','07:55:00',1.11),('15844','2013-05-25','08:20:00',1.66),('15844','2013-05-25','08:25:00',1.3),('15844','2013-05-25','08:35:00',1.82),('15844','2013-05-25','08:40:00',1.44),('15844','2013-05-25','08:45:00',1.44),('15844','2013-05-25','08:50:00',1.78),('15844','2013-05-25','08:55:00',2.06),('15844','2013-05-25','09:00:00',2.12),('15844','2013-05-25','09:05:00',2.01),('15844','2013-05-25','09:10:00',1.22),('15844','2013-05-25','09:15:00',1.01),('15844','2013-05-25','09:20:00',1.28),('15844','2013-05-25','09:25:00',1.85),('15844','2013-05-25','09:30:00',1.39),('15844','2013-05-25','09:35:00',2.31),('15844','2013-05-25','09:40:00',2.08),('15844','2013-05-25','09:45:00',2.92),('15844','2013-05-25','09:50:00',1.83),('15844','2013-05-25','10:05:00',1.18),('15844','2013-05-25','10:35:00',1.02),('15844','2013-05-25','11:00:00',2.54),('15844','2013-05-25','11:05:00',4.52),('15844','2013-05-25','11:10:00',2.74),('15844','2013-05-25','11:15:00',2.25),('15844','2013-05-25','11:30:00',2.02),('15844','2013-05-25','11:35:00',1.79),('15844','2013-05-25','11:40:00',1.96),('15844','2013-05-25','11:45:00',1.54),('15844','2013-05-25','11:50:00',2.13),('15844','2013-05-25','11:55:00',1.41),('15844','2013-05-25','12:00:00',1.64),('15844','2013-05-25','12:05:00',1.45),('15844','2013-05-25','12:10:00',1.03),('15844','2013-05-25','12:15:00',2.35),('15844','2013-05-25','12:20:00',2.8),('15844','2013-05-25','12:25:00',1.85),('15844','2013-05-25','12:30:00',3.26),('15844','2013-05-25','12:50:00',1.32),('15844','2013-05-25','12:55:00',2.02),('15844','2013-05-25','13:00:00',2.3),('15844','2013-05-25','13:05:00',1.33),('15844','2013-05-25','13:10:00',2.45),('15844','2013-05-25','13:15:00',1.84),('15844','2013-05-25','13:20:00',1.93),('15844','2013-05-25','13:25:00',2.56),('15844','2013-05-25','13:30:00',1.62),('15844','2013-05-25','13:35:00',1.83),('15844','2013-05-25','13:40:00',2.54),('15844','2013-05-25','13:45:00',2.07),('15844','2013-05-25','13:50:00',3.87),('15844','2013-05-25','13:55:00',3.14),('15844','2013-05-25','14:00:00',2.74),('15844','2013-05-25','14:05:00',3.52),('15844','2013-05-25','14:10:00',3.61),('15844','2013-05-25','14:15:00',2.95),('15844','2013-05-25','14:20:00',2.65),('15844','2013-05-25','14:25:00',2.13),('15844','2013-05-25','14:30:00',3.98),('15844','2013-05-25','14:35:00',3.24),('15844','2013-05-25','14:40:00',1.76),('15844','2013-05-25','14:45:00',2.63),('15844','2013-05-25','14:50:00',3.01),('15844','2013-05-25','14:55:00',2.07),('15844','2013-05-25','15:00:00',2.15),('15844','2013-05-25','15:05:00',2.9),('15844','2013-05-25','15:10:00',2.36),('15844','2013-05-25','15:15:00',2.14),('15844','2013-05-25','15:20:00',2.8),('15844','2013-05-25','15:25:00',1.85),('15844','2013-05-25','15:30:00',2.42),('15844','2013-05-25','15:35:00',1.87),('15844','2013-05-25','15:40:00',1.21),('15844','2013-05-25','15:45:00',1.08),('15844','2013-05-25','15:50:00',2.01),('15844','2013-05-25','15:55:00',1.59),('15844','2013-05-25','16:00:00',2.42),('15844','2013-05-25','16:05:00',1.86),('15844','2013-05-25','16:10:00',1.28),('15844','2013-05-25','16:15:00',1.34),('15844','2013-05-25','16:20:00',1.57),('15844','2013-05-25','16:25:00',1.43),('15844','2013-05-25','16:30:00',1.63),('15844','2013-05-25','16:35:00',1.09),('15844','2013-05-25','16:45:00',1.38),('15844','2013-05-25','16:50:00',1.53),('15844','2013-05-25','16:55:00',1.19),('15844','2013-05-24','08:05:00',1.1),('15844','2013-05-24','08:25:00',1.28),('15844','2013-05-24','08:30:00',1.35),('15844','2013-05-24','08:35:00',1.37),('15844','2013-05-24','08:40:00',1.43),('15844','2013-05-24','08:45:00',1.53),('15844','2013-05-24','08:50:00',1.72),('15844','2013-05-24','08:55:00',1.8),('15844','2013-05-24','09:00:00',2.11),('15844','2013-05-24','09:25:00',1.92),('15844','2013-05-24','09:35:00',1.15),('15844','2013-05-24','09:45:00',1.07),('15844','2013-05-24','09:50:00',1.68),('15844','2013-05-24','09:55:00',3.4),('15844','2013-05-24','10:00:00',1.08),('15844','2013-05-24','10:20:00',1.36),('15844','2013-05-24','10:25:00',2.71),('15844','2013-05-24','10:30:00',4.32),('15844','2013-05-24','10:35:00',4.49),('15844','2013-05-24','10:40:00',4.56),('15844','2013-05-24','10:45:00',4.55),('15844','2013-05-24','10:50:00',2.49),('15844','2013-05-24','10:55:00',3.77),('15844','2013-05-24','11:00:00',4.51),('15844','2013-05-24','11:05:00',3.92),('15844','2013-05-24','11:10:00',3.83),('15844','2013-05-24','11:15:00',2.5),('15844','2013-05-24','11:20:00',4.11),('15844','2013-05-24','11:25:00',4.84),('15844','2013-05-24','11:30:00',3.56),('15844','2013-05-24','11:35:00',1),('15844','2013-05-24','11:40:00',1.02),('15844','2013-05-24','11:45:00',1.9),('15844','2013-05-24','11:50:00',1.98),('15844','2013-05-24','11:55:00',4.03),('15844','2013-05-24','12:00:00',5.62),('15844','2013-05-24','12:05:00',3.1),('15844','2013-05-24','12:10:00',1.7),('15844','2013-05-24','12:15:00',2.6),('15844','2013-05-24','12:20:00',3.8),('15844','2013-05-24','12:25:00',2.75),('15844','2013-05-24','12:30:00',2.06),('15844','2013-05-24','12:35:00',2.5),('15844','2013-05-24','12:40:00',1.75),('15844','2013-05-24','12:45:00',1.95),('15844','2013-05-24','12:50:00',1.83),('15844','2013-05-24','12:55:00',2.78),('15844','2013-05-24','13:00:00',4.19),('15844','2013-05-24','13:05:00',5.19),('15844','2013-05-24','13:10:00',3.78),('15844','2013-05-24','13:15:00',2.91),('15844','2013-05-24','13:20:00',4.78),('15844','2013-05-24','13:25:00',5.49),('15844','2013-05-24','13:30:00',5.27),('15844','2013-05-24','13:35:00',3.95),('15844','2013-05-24','13:40:00',1.34),('15844','2013-05-24','13:45:00',1.07),('15844','2013-05-24','13:50:00',3.51),('15844','2013-05-24','13:55:00',4.61),('15844','2013-05-24','14:00:00',3.24),('15844','2013-05-24','14:05:00',1.43),('15844','2013-05-24','14:10:00',3.05),('15844','2013-05-24','14:15:00',2.24),('15844','2013-05-24','14:20:00',3.26),('15844','2013-05-24','14:25:00',2.23),('15844','2013-05-24','14:30:00',3.69),('15844','2013-05-24','14:35:00',3.03),('15844','2013-05-24','14:40:00',2.58),('15844','2013-05-24','14:45:00',1.57),('15844','2013-05-24','14:50:00',3.02),('15844','2013-05-24','14:55:00',3.85),('15844','2013-05-24','15:00:00',3.59),('15844','2013-05-24','15:05:00',4.13),('15844','2013-05-24','15:10:00',3.18),('15844','2013-05-24','15:15:00',3.29),('15844','2013-05-24','15:20:00',3.16),('15844','2013-05-24','15:25:00',3.03),('15844','2013-05-24','15:30:00',2.53),('15844','2013-05-24','15:35:00',1.98),('15844','2013-05-24','15:40:00',2.09),('15844','2013-05-24','15:45:00',2.08),('15844','2013-05-24','15:50:00',1.66),('15844','2013-05-24','15:55:00',1.68),('15844','2013-05-24','16:00:00',1.56),('15844','2013-05-24','16:05:00',1.53),('15844','2013-05-24','16:10:00',1.41),('15844','2013-05-24','16:15:00',1.14),('15844','2013-05-24','16:20:00',1.35),('15844','2013-05-24','16:25:00',1.27),('15844','2013-05-24','16:45:00',1.16),('15844','2013-05-24','16:50:00',1.31),('15844','2013-05-24','16:55:00',1.06),('15844','2013-05-24','17:00:00',1.06),('15844','2013-05-23','08:25:00',1.35),('15844','2013-05-23','08:30:00',1.45),('15844','2013-05-23','08:35:00',1.74),('15844','2013-05-23','08:40:00',1.36),('15844','2013-05-23','09:15:00',2.24),('15844','2013-05-23','09:20:00',2),('15844','2013-05-23','09:40:00',1.97),('15844','2013-05-23','09:45:00',1.63),('15844','2013-05-23','09:50:00',1.85),('15844','2013-05-23','09:55:00',3.37),('15844','2013-05-23','10:00:00',2.26),('15844','2013-05-23','10:05:00',2.74),('15844','2013-05-23','10:10:00',3.75),('15844','2013-05-23','10:15:00',2.28),('15844','2013-05-23','10:20:00',3.52),('15844','2013-05-23','10:25:00',1.15),('15844','2013-05-23','10:30:00',1.51),('15844','2013-05-23','10:35:00',3.37),('15844','2013-05-23','10:40:00',2.82),('15844','2013-05-23','10:45:00',1.67),('15844','2013-05-23','10:50:00',2.36),('15844','2013-05-23','10:55:00',4.22),('15844','2013-05-23','11:00:00',2.45),('15844','2013-05-23','11:05:00',3.35),('15844','2013-05-23','11:10:00',1.21),('15844','2013-05-23','11:15:00',1.8),('15844','2013-05-23','11:20:00',1.76),('15844','2013-05-23','11:25:00',1.61),('15844','2013-05-23','11:30:00',2.72),('15844','2013-05-23','11:35:00',3.84),('15844','2013-05-23','11:40:00',3.99),('15844','2013-05-23','11:45:00',1.05),('15844','2013-05-23','11:50:00',2.59),('15844','2013-05-23','11:55:00',5.07),('15844','2013-05-23','12:00:00',3),('15844','2013-05-23','12:05:00',4.54),('15844','2013-05-23','12:10:00',3.35),('15844','2013-05-23','12:15:00',2.06),('15844','2013-05-23','12:20:00',1.87),('15844','2013-05-23','12:25:00',1.37),('15844','2013-05-23','12:35:00',2.85),('15844','2013-05-23','12:40:00',3.33),('15844','2013-05-23','12:45:00',3.13),('15844','2013-05-23','12:50:00',2.63),('15844','2013-05-23','12:55:00',3.11),('15844','2013-05-23','13:00:00',4.85),('15844','2013-05-23','13:05:00',4.66),('15844','2013-05-23','13:10:00',3.3),('15844','2013-05-23','13:15:00',3.93),('15844','2013-05-23','13:20:00',2.97),('15844','2013-05-23','13:25:00',4.78),('15844','2013-05-23','13:30:00',2.99),('15844','2013-05-23','13:35:00',3.6),('15844','2013-05-23','13:40:00',3.97),('15844','2013-05-23','13:45:00',3.58),('15844','2013-05-23','13:50:00',4.19),('15844','2013-05-23','13:55:00',3.8),('15844','2013-05-23','14:00:00',3.83),('15844','2013-05-23','14:05:00',2.54),('15844','2013-05-23','14:10:00',4.1),('15844','2013-05-23','14:15:00',2.93),('15844','2013-05-23','14:20:00',1.48),('15844','2013-05-23','14:25:00',2.11),('15844','2013-05-23','14:30:00',2.8),('15844','2013-05-23','14:35:00',2.89),('15844','2013-05-23','14:45:00',2.64),('15844','2013-05-23','14:50:00',2.2),('15844','2013-05-23','14:55:00',3.38),('15844','2013-05-23','15:00:00',2.75),('15844','2013-05-23','15:10:00',3.17),('15844','2013-05-23','15:15:00',2.3),('15844','2013-05-23','15:20:00',2.52),('15844','2013-05-23','15:25:00',2.07),('15844','2013-05-23','15:30:00',2.34),('15844','2013-05-23','15:35:00',2.99),('15844','2013-05-23','15:40:00',1.6),('15844','2013-05-23','15:45:00',1.2),('15844','2013-05-23','15:50:00',2.6),('15844','2013-05-23','15:55:00',1.87),('15844','2013-05-23','16:00:00',2.41),('15844','2013-05-23','16:05:00',2.05),('15844','2013-05-23','16:10:00',1.31),('15844','2013-05-23','16:15:00',1.86),('15844','2013-05-23','16:20:00',1.48),('15844','2013-05-23','16:30:00',1.16),('15844','2013-05-23','16:40:00',1.13),('15844','2013-05-23','17:00:00',1.41),('15844','2013-05-23','17:05:00',1.24),('15844','2013-05-23','17:55:00',1.09),('15844','2013-05-22','08:05:00',1.04),('15844','2013-05-22','08:10:00',1.17),('15844','2013-05-22','08:25:00',1.33),('15844','2013-05-22','08:30:00',1.82),('15844','2013-05-22','08:35:00',1.16),('15844','2013-05-22','09:20:00',1.4),('15844','2013-05-22','09:25:00',2.21),('15844','2013-05-22','09:30:00',2.5),('15844','2013-05-22','09:35:00',2.45),('15844','2013-05-22','09:40:00',2.6),('15844','2013-05-22','09:45:00',2.71),('15844','2013-05-22','09:50:00',2.79),('15844','2013-05-22','09:55:00',2.9),('15844','2013-05-22','10:00:00',3.04),('15844','2013-05-22','10:05:00',3.23),('15844','2013-05-22','10:10:00',3.33),('15844','2013-05-22','10:15:00',3.43),('15844','2013-05-22','10:20:00',3.59),('15844','2013-05-22','10:25:00',3.29),('15844','2013-05-22','10:30:00',3.66),('15844','2013-05-22','10:35:00',3.76),('15844','2013-05-22','10:40:00',3.79),('15844','2013-05-22','10:45:00',4.19),('15844','2013-05-22','10:50:00',4.02),('15844','2013-05-22','10:55:00',4.04),('15844','2013-05-22','11:00:00',4.1),('15844','2013-05-22','11:05:00',4.15),('15844','2013-05-22','11:10:00',4.16),('15844','2013-05-22','11:15:00',4.1),('15844','2013-05-22','11:20:00',4.21),('15844','2013-05-22','11:25:00',3.9),('15844','2013-05-22','11:30:00',3.02),('15844','2013-05-22','11:35:00',4.19),('15844','2013-05-22','11:40:00',3.66),('15844','2013-05-22','11:45:00',4.33),('15844','2013-05-22','11:50:00',4.09),('15844','2013-05-22','11:55:00',2.5),('15844','2013-05-22','12:00:00',1.95),('15844','2013-05-22','12:05:00',2.36),('15844','2013-05-22','12:10:00',2.3),('15844','2013-05-22','12:15:00',2.77),('15844','2013-05-22','12:20:00',4.87),('15844','2013-05-22','12:25:00',3.74),('15844','2013-05-22','12:30:00',1.97),('15844','2013-05-22','12:35:00',1.4),('15844','2013-05-22','12:40:00',1.16),('15844','2013-05-22','13:05:00',1.52),('15844','2013-05-22','13:10:00',1.9),('15844','2013-05-22','13:15:00',3.15),('15844','2013-05-22','13:20:00',2.23),('15844','2013-05-22','13:30:00',1.59),('15844','2013-05-22','13:35:00',1.56),('15844','2013-05-22','13:40:00',1.62),('15844','2013-05-22','13:45:00',2.98),('15844','2013-05-22','13:50:00',3.73),('15844','2013-05-22','13:55:00',3.2),('15844','2013-05-22','14:00:00',3.02),('15844','2013-05-22','14:05:00',3.23),('15844','2013-05-22','14:10:00',3.77),('15844','2013-05-22','14:15:00',3.6),('15844','2013-05-22','14:20:00',3.49),('15844','2013-05-22','14:25:00',3.39),('15844','2013-05-22','14:30:00',3.33),('15844','2013-05-22','14:35:00',3.26),('15844','2013-05-22','14:40:00',3.2),('15844','2013-05-22','14:45:00',3.11),('15844','2013-05-22','14:50:00',3.01),('15844','2013-05-22','14:55:00',2.92),('15844','2013-05-22','15:00:00',2.85),('15844','2013-05-22','15:05:00',2.74),('15844','2013-05-22','15:10:00',2.66),('15844','2013-05-22','15:15:00',2.62),('15844','2013-05-22','15:20:00',2.53),('15844','2013-05-22','15:25:00',2.63),('15844','2013-05-22','15:30:00',2.75),('15844','2013-05-22','15:35:00',2.62),('15844','2013-05-22','15:40:00',2.54),('15844','2013-05-22','15:45:00',2.2),('15844','2013-05-22','15:50:00',2.03),('15844','2013-05-22','15:55:00',1.83),('15844','2013-05-22','16:00:00',1.72),('15844','2013-05-22','16:05:00',1.63),('15844','2013-05-22','16:10:00',1.57),('15844','2013-05-22','16:15:00',1.33),('15844','2013-05-22','16:20:00',1.41),('15844','2013-05-22','16:25:00',1),('15844','2013-05-22','16:40:00',1.15),('15844','2013-05-22','16:45:00',1.13),('15844','2013-05-22','17:35:00',1.01),('15844','2014-04-01','08:45:00',1),('15844','2014-04-01','08:50:00',1.1),('15844','2014-04-01','08:55:00',1.21),('15844','2014-04-01','09:00:00',1.31),('15844','2014-04-01','09:05:00',1.4),('15844','2014-04-01','09:10:00',1.49),('15844','2014-04-01','09:15:00',1.62),('15844','2014-04-01','09:20:00',1.72),('15844','2014-04-01','09:25:00',1.83),('15844','2014-04-01','09:30:00',1.95),('15844','2014-04-01','09:35:00',2.03),('15844','2014-04-01','09:40:00',2.12),('15844','2014-04-01','09:45:00',2.18),('15844','2014-04-01','09:50:00',2.16),('15844','2014-04-01','09:55:00',1.53),('15844','2014-04-01','10:00:00',2.54),('15844','2014-04-01','10:05:00',2.55),('15844','2014-04-01','10:10:00',2.65),('15844','2014-04-01','10:15:00',2.77),('15844','2014-04-01','10:20:00',2.83),('15844','2014-04-01','10:25:00',2.91),('15844','2014-04-01','10:30:00',2.91),('15844','2014-04-01','10:35:00',3.04),('15844','2014-04-01','10:40:00',3.17),('15844','2014-04-01','10:45:00',3.38),('15844','2014-04-01','10:50:00',3.41),('15844','2014-04-01','10:55:00',3.42),('15844','2014-04-01','11:00:00',3.59),('15844','2014-04-01','11:05:00',3.62),('15844','2014-04-01','11:10:00',3.66),('15844','2014-04-01','11:15:00',3.68),('15844','2014-04-01','11:20:00',3.73),('15844','2014-04-01','11:25:00',3.8),('15844','2014-04-01','11:30:00',3.73),('15844','2014-04-01','11:35:00',3.79),('15844','2014-04-01','11:40:00',3.79),('15844','2014-04-01','11:45:00',3.89),('15844','2014-04-01','11:50:00',3.89),('15844','2014-04-01','11:55:00',3.88),('15844','2014-04-01','12:00:00',3.91),('15844','2014-04-01','12:05:00',3.9),('15844','2014-04-01','12:10:00',3.86),('15844','2014-04-01','12:15:00',3.9),('15844','2014-04-01','12:20:00',3.89),('15844','2014-04-01','12:25:00',3.9),('15844','2014-04-01','12:30:00',3.92),('15844','2014-04-01','12:35:00',3.91),('15844','2014-04-01','12:40:00',3.8),('15844','2014-04-01','12:45:00',4.05),('15844','2014-04-01','12:50:00',3.93),('15844','2014-04-01','12:55:00',3.94),('15844','2014-04-01','13:00:00',3.6),('15844','2014-04-01','13:05:00',3.6),('15844','2014-04-01','13:10:00',3.65),('15844','2014-04-01','13:15:00',3.55),('15844','2014-04-01','13:20:00',3.72),('15844','2014-04-01','13:25:00',3.68),('15844','2014-04-01','13:30:00',3.4),('15844','2014-04-01','13:35:00',3.77),('15844','2014-04-01','13:40:00',3.62),('15844','2014-04-01','13:45:00',2.3),('15844','2014-04-01','13:50:00',2.76),('15844','2014-04-01','13:55:00',3.29),('15844','2014-04-01','14:00:00',3.47),('15844','2014-04-01','14:05:00',3.01),('15844','2014-04-01','14:10:00',3.36),('15844','2014-04-01','14:15:00',2.8),('15844','2014-04-01','14:20:00',3.34),('15844','2014-04-01','14:25:00',2.72),('15844','2014-04-01','14:30:00',2.01),('15844','2014-04-01','14:35:00',2.31),('15844','2014-04-01','14:40:00',2.77),('15844','2014-04-01','14:45:00',2.38),('15844','2014-04-01','14:50:00',2.27),('15844','2014-04-01','14:55:00',2.5),('15844','2014-04-01','15:00:00',2.46),('15844','2014-04-01','15:05:00',2.43),('15844','2014-04-01','15:10:00',1.86),('15844','2014-04-01','15:15:00',2.13),('15844','2014-04-01','15:20:00',1.88),('15844','2014-04-01','15:25:00',1.66),('15844','2014-04-01','15:30:00',1.88),('15844','2014-04-01','15:35:00',1.28),('15844','2014-04-01','15:40:00',1.19),('15844','2014-04-01','15:45:00',1.44),('15844','2014-04-01','15:50:00',1.43),('15844','2014-04-01','15:55:00',1.22),('15844','2014-04-01','16:00:00',1.18),('15844','2014-04-01','16:05:00',1.25),('15844','2014-04-01','16:10:00',1.16),('15844','2014-04-01','16:15:00',1.04),('15844','2014-04-01','16:20:00',1.09),('15844','2014-04-01','16:25:00',1.04),('15844','2013-05-21','08:10:00',1.33),('15844','2013-05-21','08:15:00',1.19),('15844','2013-05-21','08:20:00',1.41),('15844','2013-05-21','08:25:00',1.28),('15844','2013-05-21','08:30:00',1.06),('15844','2013-05-21','08:35:00',1.28),('15844','2013-05-21','08:40:00',1.31),('15844','2013-05-21','08:45:00',1.07),('15844','2013-05-21','08:50:00',1.21),('15844','2013-05-21','08:55:00',1.29),('15844','2013-05-21','09:00:00',1.17),('15844','2013-05-21','09:05:00',1.18),('15844','2013-05-21','09:10:00',1.47),('15844','2013-05-21','09:15:00',1.53),('15844','2013-05-21','09:20:00',1.89),('15844','2013-05-21','09:25:00',2),('15844','2013-05-21','09:30:00',1.65),('15844','2013-05-21','09:35:00',1.64),('15844','2013-05-21','09:40:00',1.57),('15844','2013-05-21','09:45:00',1.49),('15844','2013-05-21','09:50:00',1.64),('15844','2013-05-21','09:55:00',1.64),('15844','2013-05-21','10:00:00',1.75),('15844','2013-05-21','10:05:00',1.98),('15844','2013-05-21','10:10:00',1.87),('15844','2013-05-21','10:15:00',1.63),('15844','2013-05-21','10:20:00',1.67),('15844','2013-05-21','10:25:00',2.04),('15844','2013-05-21','10:30:00',1.53),('15844','2013-05-21','10:35:00',1.86),('15844','2013-05-21','10:40:00',2.71),('15844','2013-05-21','10:45:00',2.96),('15844','2013-05-21','10:50:00',2.2),('15844','2013-05-21','10:55:00',1.74),('15844','2013-05-21','11:00:00',1.49),('15844','2013-05-21','11:05:00',1.83),('15844','2013-05-21','11:10:00',2.84),('15844','2013-05-21','11:15:00',3.92),('15844','2013-05-21','11:20:00',4.46),('15844','2013-05-21','11:25:00',3.91),('15844','2013-05-21','11:30:00',3.2),('15844','2013-05-21','11:35:00',2),('15844','2013-05-21','11:40:00',2.05),('15844','2013-05-21','11:45:00',3.06),('15844','2013-05-21','11:50:00',2.44),('15844','2013-05-21','11:55:00',2.56),('15844','2013-05-21','12:00:00',2.88),('15844','2013-05-21','12:05:00',3.6),('15844','2013-05-21','12:10:00',2.98),('15844','2013-05-21','12:15:00',2.61),('15844','2013-05-21','12:20:00',2.31),('15844','2013-05-21','12:25:00',2.62),('15844','2013-05-21','12:30:00',2.76),('15844','2013-05-21','12:35:00',2.81),('15844','2013-05-21','12:40:00',3.4),('15844','2013-05-21','12:45:00',3.27),('15844','2013-05-21','12:50:00',2.84),('15844','2013-05-21','12:55:00',3.17),('15844','2013-05-21','13:00:00',3.59),('15844','2013-05-21','13:05:00',3.15),('15844','2013-05-21','13:10:00',2.61),('15844','2013-05-21','13:15:00',3.55),('15844','2013-05-21','13:20:00',3.42),('15844','2013-05-21','13:25:00',2.29),('15844','2013-05-21','13:30:00',1.65),('15844','2013-05-21','13:35:00',1.08),('15844','2013-05-21','14:10:00',1.36),('15844','2013-05-21','14:15:00',1.53),('15844','2013-05-21','14:20:00',1.57),('15844','2013-05-21','14:25:00',2.1),('15844','2013-05-21','14:30:00',1.73),('15844','2013-05-21','14:35:00',1.84),('15844','2013-05-21','14:40:00',1.77),('15844','2013-05-21','14:45:00',1.16),('15844','2013-05-21','15:15:00',1.27),('15844','2013-05-21','15:20:00',1.5),('15844','2013-05-21','15:25:00',1.95),('15844','2013-05-21','15:30:00',1.96),('15844','2013-05-21','15:35:00',2.29),('15844','2013-05-21','15:40:00',2.48),('15844','2013-05-21','15:45:00',1.54),('15844','2013-05-21','16:05:00',1.03),('15844','2013-05-21','16:10:00',1.02),('15844','2013-05-21','16:25:00',1),('15844','2013-05-21','16:30:00',1.35),('15844','2013-05-21','16:35:00',1.42),('15844','2013-05-21','16:40:00',1.26),('15844','2013-05-20','08:15:00',1.1),('15844','2013-05-20','08:20:00',1.15),('15844','2013-05-20','08:25:00',1.39),('15844','2013-05-20','08:35:00',1.4),('15844','2013-05-20','08:40:00',1.83),('15844','2013-05-20','08:55:00',1.57),('15844','2013-05-20','09:00:00',1.05),('15844','2013-05-20','09:05:00',1.08),('15844','2013-05-20','09:10:00',1.21),('15844','2013-05-20','09:15:00',2.13),('15844','2013-05-20','09:20:00',2.26),('15844','2013-05-20','09:25:00',2.43),('15844','2013-05-20','09:30:00',1.92),('15844','2013-05-20','09:40:00',1.04),('15844','2013-05-20','09:45:00',3.19),('15844','2013-05-20','09:50:00',2.08),('15844','2013-05-20','10:00:00',1.6),('15844','2013-05-20','10:05:00',3.6),('15844','2013-05-20','10:10:00',3.74),('15844','2013-05-20','10:15:00',4.06),('15844','2013-05-20','10:20:00',4.3),('15844','2013-05-20','10:25:00',3.68),('15844','2013-05-20','10:30:00',2.49),('15844','2013-05-20','10:35:00',3.61),('15844','2013-05-20','10:40:00',4.15),('15844','2013-05-20','10:45:00',3.9),('15844','2013-05-20','10:50:00',4.07),('15844','2013-05-20','10:55:00',4.62),('15844','2013-05-20','11:00:00',3.86),('15844','2013-05-20','11:05:00',3.28),('15844','2013-05-20','11:10:00',3.47),('15844','2013-05-20','11:15:00',1.51),('15844','2013-05-20','11:20:00',3.33),('15844','2013-05-20','11:25:00',4.51),('15844','2013-05-20','11:30:00',2.88),('15844','2013-05-20','11:35:00',1.94),('15844','2013-05-20','11:40:00',2.98),('15844','2013-05-20','11:45:00',3.42),('15844','2013-05-20','11:50:00',4.99),('15844','2013-05-20','11:55:00',4.87),('15844','2013-05-20','12:00:00',4.88),('15844','2013-05-20','12:05:00',4.77),('15844','2013-05-20','12:10:00',4.34),('15844','2013-05-20','12:15:00',4.79),('15844','2013-05-20','12:20:00',4.77),('15844','2013-05-20','12:25:00',4.68),('15844','2013-05-20','12:30:00',4.8),('15844','2013-05-20','12:35:00',4.74),('15844','2013-05-20','12:40:00',4.71),('15844','2013-05-20','12:45:00',4.6),('15844','2013-05-20','12:50:00',4.61),('15844','2013-05-20','12:55:00',4.67),('15844','2013-05-20','13:00:00',4.63),('15844','2013-05-20','13:05:00',4.65),('15844','2013-05-20','13:10:00',4.58),('15844','2013-05-20','13:15:00',4.5),('15844','2013-05-20','13:20:00',4.48),('15844','2013-05-20','13:25:00',4.36),('15844','2013-05-20','13:30:00',4.35),('15844','2013-05-20','13:35:00',4.32),('15844','2013-05-20','13:40:00',4.29),('15844','2013-05-20','13:45:00',4.25),('15844','2013-05-20','13:50:00',4.15),('15844','2013-05-20','13:55:00',4.08),('15844','2013-05-20','14:00:00',3.97),('15844','2013-05-20','14:05:00',3.91),('15844','2013-05-20','14:10:00',3.84),('15844','2013-05-20','14:15:00',3.77),('15844','2013-05-20','14:20:00',3.7),('15844','2013-05-20','14:25:00',3.6),('15844','2013-05-20','14:30:00',3.5),('15844','2013-05-20','14:35:00',3.45),('15844','2013-05-20','14:40:00',3.35),('15844','2013-05-20','14:45:00',3.27),('15844','2013-05-20','14:50:00',3.17),('15844','2013-05-20','14:55:00',3.08),('15844','2013-05-20','15:00:00',3),('15844','2013-05-20','15:05:00',2.98),('15844','2013-05-20','15:10:00',3.01),('15844','2013-05-20','15:15:00',2.85),('15844','2013-05-20','15:20:00',2.66),('15844','2013-05-20','15:25:00',2.6),('15844','2013-05-20','15:30:00',2.48),('15844','2013-05-20','15:35:00',2.36),('15844','2013-05-20','15:40:00',2.22),('15844','2013-05-20','15:45:00',2.13),('15844','2013-05-20','15:50:00',2.09),('15844','2013-05-20','15:55:00',1.93),('15844','2013-05-20','16:00:00',1.76),('15844','2013-05-20','16:05:00',1.66),('15844','2013-05-20','16:10:00',1.56),('15844','2013-05-20','16:15:00',1.51),('15844','2013-05-20','16:20:00',1.44),('15844','2013-05-20','16:25:00',1.42),('15844','2013-05-20','16:30:00',1.39),('15844','2013-05-20','16:35:00',1.3),('15844','2013-05-20','16:40:00',1.22),('15844','2013-05-20','16:45:00',1.06),('15844','2013-05-19','08:30:00',1.01),('15844','2013-05-19','08:35:00',1.27),('15844','2013-05-19','08:45:00',1.01),('15844','2013-05-19','08:50:00',1.17),('15844','2013-05-19','08:55:00',1.29),('15844','2013-05-19','09:50:00',1.08),('15844','2013-05-19','09:55:00',1.26),('15844','2013-05-19','10:00:00',1.96),('15844','2013-05-19','10:05:00',1.47),('15844','2013-05-19','10:10:00',1.48),('15844','2013-05-19','10:15:00',1.53),('15844','2013-05-19','10:20:00',2.6),('15844','2013-05-19','10:25:00',2.87),('15844','2013-05-19','10:30:00',2.2),('15844','2013-05-19','10:35:00',2.03),('15844','2013-05-19','10:40:00',1.86),('15844','2013-05-19','10:45:00',1.93),('15844','2013-05-19','10:50:00',2.44),('15844','2013-05-19','10:55:00',2.78),('15844','2013-05-19','11:00:00',2.79),('15844','2013-05-19','11:05:00',3.2),('15844','2013-05-19','11:10:00',2.33),('15844','2013-05-19','11:15:00',2.32),('15844','2013-05-19','11:20:00',4.62),('15844','2013-05-19','11:25:00',4.7),('15844','2013-05-19','11:30:00',4.78),('15844','2013-05-19','11:35:00',4.68),('15844','2013-05-19','11:40:00',4.64),('15844','2013-05-19','11:45:00',4.6),('15844','2013-05-19','11:50:00',4.65),('15844','2013-05-19','11:55:00',4.69),('15844','2013-05-19','12:00:00',4.69),('15844','2013-05-19','12:05:00',4.66),('15844','2013-05-19','12:10:00',4.66),('15844','2013-05-19','12:15:00',4.7),('15844','2013-05-19','12:20:00',4.7),('15844','2013-05-19','12:25:00',5.04),('15844','2013-05-19','12:30:00',5.05),('15844','2013-05-19','12:35:00',4.83),('15844','2013-05-19','12:40:00',4.97),('15844','2013-05-19','12:45:00',4.94),('15844','2013-05-19','12:50:00',4.9),('15844','2013-05-19','12:55:00',4.69),('15844','2013-05-19','13:00:00',4.47),('15844','2013-05-19','13:05:00',4.49),('15844','2013-05-19','13:10:00',4.44),('15844','2013-05-19','13:15:00',4.4),('15844','2013-05-19','13:20:00',4.33),('15844','2013-05-19','13:25:00',4.3),('15844','2013-05-19','13:30:00',4.3),('15844','2013-05-19','13:35:00',4.28),('15844','2013-05-19','13:40:00',4.23),('15844','2013-05-19','13:45:00',4.17),('15844','2013-05-19','13:50:00',4.11),('15844','2013-05-19','13:55:00',4.04),('15844','2013-05-19','14:00:00',3.97),('15844','2013-05-19','14:05:00',3.92),('15844','2013-05-19','14:10:00',3.82),('15844','2013-05-19','14:15:00',3.75),('15844','2013-05-19','14:20:00',3.68),('15844','2013-05-19','14:25:00',3.59),('15844','2013-05-19','14:30:00',3.51),('15844','2013-05-19','14:35:00',3.44),('15844','2013-05-19','14:40:00',3.37),('15844','2013-05-19','14:45:00',3.23),('15844','2013-05-19','14:50:00',3.13),('15844','2013-05-19','14:55:00',3.05),('15844','2013-05-19','15:00:00',2.96),('15844','2013-05-19','15:05:00',2.86),('15844','2013-05-19','15:10:00',2.76),('15844','2013-05-19','15:15:00',2.67),('15844','2013-05-19','15:20:00',2.56),('15844','2013-05-19','15:25:00',2.46),('15844','2013-05-19','15:30:00',2.35),('15844','2013-05-19','15:35:00',2.26),('15844','2013-05-19','15:40:00',2.16),('15844','2013-05-19','15:45:00',2.06),('15844','2013-05-19','15:50:00',1.92),('15844','2013-05-19','15:55:00',1.8),('15844','2013-05-19','16:00:00',1.73),('15844','2013-05-19','16:05:00',1.63),('15844','2013-05-19','16:10:00',1.54),('15844','2013-05-19','16:15:00',1.49),('15844','2013-05-19','16:20:00',1.43),('15844','2013-05-19','16:25:00',1.39),('15844','2013-05-19','16:30:00',1.36),('15844','2013-05-19','16:35:00',1.3),('15844','2013-05-19','16:40:00',1.22),('15844','2013-05-19','16:45:00',1.05),('15844','2013-05-18','08:00:00',1.07),('15844','2013-05-18','08:20:00',1.15),('15844','2013-05-18','08:25:00',1.25),('15844','2013-05-18','08:30:00',1.24),('15844','2013-05-18','08:35:00',1.12),('15844','2013-05-18','08:40:00',1.2),('15844','2013-05-18','08:45:00',1.43),('15844','2013-05-18','08:50:00',1.66),('15844','2013-05-18','08:55:00',1.69),('15844','2013-05-18','09:00:00',1.71),('15844','2013-05-18','09:05:00',1.82),('15844','2013-05-18','09:10:00',1.97),('15844','2013-05-18','09:15:00',2.07),('15844','2013-05-18','09:20:00',2.17),('15844','2013-05-18','09:25:00',2.27),('15844','2013-05-18','09:30:00',2.4),('15844','2013-05-18','09:35:00',2.5),('15844','2013-05-18','09:40:00',2.59),('15844','2013-05-18','09:45:00',2.74),('15844','2013-05-18','09:50:00',2.87),('15844','2013-05-18','09:55:00',2.96),('15844','2013-05-18','10:00:00',3.12),('15844','2013-05-18','10:05:00',3.32),('15844','2013-05-18','10:10:00',3.43),('15844','2013-05-18','10:15:00',3.53),('15844','2013-05-18','10:20:00',3.63),('15844','2013-05-18','10:25:00',3.74),('15844','2013-05-18','10:30:00',3.82),('15844','2013-05-18','10:35:00',3.87),('15844','2013-05-18','10:40:00',3.96),('15844','2013-05-18','10:45:00',4.07),('15844','2013-05-18','10:50:00',4.16),('15844','2013-05-18','10:55:00',4.23),('15844','2013-05-18','11:00:00',4.29),('15844','2013-05-18','11:05:00',4.05),('15844','2013-05-18','11:10:00',3.59),('15844','2013-05-18','11:15:00',3.73),('15844','2013-05-18','11:20:00',3.51),('15844','2013-05-18','11:25:00',2.22),('15844','2013-05-18','11:30:00',4.4),('15844','2013-05-18','11:35:00',3.7),('15844','2013-05-18','11:40:00',4.48),('15844','2013-05-18','11:45:00',4.35),('15844','2013-05-18','11:50:00',4.38),('15844','2013-05-18','11:55:00',4.46),('15844','2013-05-18','12:00:00',4.34),('15844','2013-05-18','12:05:00',4.29),('15844','2013-05-18','12:10:00',4.25),('15844','2013-05-18','12:15:00',4.24),('15844','2013-05-18','12:20:00',4.27),('15844','2013-05-18','12:25:00',4.19),('15844','2013-05-18','12:30:00',4.37),('15844','2013-05-18','12:35:00',4.26),('15844','2013-05-18','12:40:00',4.23),('15844','2013-05-18','12:45:00',4.21),('15844','2013-05-18','12:50:00',4.21),('15844','2013-05-18','12:55:00',4.16),('15844','2013-05-18','13:00:00',4.14),('15844','2013-05-18','13:05:00',4.14),('15844','2013-05-18','13:10:00',4.1),('15844','2013-05-18','13:15:00',4.07),('15844','2013-05-18','13:20:00',4.04),('15844','2013-05-18','13:25:00',4),('15844','2013-05-18','13:30:00',3.98),('15844','2013-05-18','13:35:00',3.99),('15844','2013-05-18','13:40:00',3.96),('15844','2013-05-18','13:45:00',4.02),('15844','2013-05-18','13:50:00',4.09),('15844','2013-05-18','13:55:00',2.71),('15844','2013-05-18','14:00:00',2.08),('15844','2013-05-18','14:05:00',2.3),('15844','2013-05-18','14:10:00',2.29),('15844','2013-05-18','14:15:00',3),('15844','2013-05-18','14:20:00',2.87),('15844','2013-05-18','14:25:00',3.43),('15844','2013-05-18','14:30:00',2.55),('15844','2013-05-18','14:35:00',2.29),('15844','2013-05-18','14:40:00',2.22),('15844','2013-05-18','14:45:00',2.13),('15844','2013-05-18','14:50:00',3.22),('15844','2013-05-18','14:55:00',2.28),('15844','2013-05-18','15:00:00',2.77),('15844','2013-05-18','15:05:00',2.62),('15844','2013-05-18','15:10:00',2.51),('15844','2013-05-18','15:15:00',2.44),('15844','2013-05-18','15:20:00',2.34),('15844','2013-05-18','15:25:00',2.26),('15844','2013-05-18','15:30:00',2.19),('15844','2013-05-18','15:35:00',2.11),('15844','2013-05-18','15:40:00',2.02),('15844','2013-05-18','15:45:00',1.93),('15844','2013-05-18','15:50:00',1.85),('15844','2013-05-18','15:55:00',1.73),('15844','2013-05-18','16:00:00',1.64),('15844','2013-05-18','16:05:00',1.57),('15844','2013-05-18','16:10:00',1.54),('15844','2013-05-18','16:15:00',1.49),('15844','2013-05-18','16:20:00',1.44),('15844','2013-05-18','16:25:00',1.39),('15844','2013-05-18','16:30:00',1.35),('15844','2013-05-18','16:35:00',1.29),('15844','2013-05-18','16:40:00',1.22),('15844','2013-05-18','16:45:00',1.14),('15844','2013-05-18','16:50:00',1.01),('15844','2013-05-17','08:00:00',1.01),('15844','2013-05-17','08:05:00',1.19),('15844','2013-05-17','08:10:00',1.64),('15844','2013-05-17','08:15:00',1.92),('15844','2013-05-17','08:20:00',1.6),('15844','2013-05-17','08:25:00',1.08),('15844','2013-05-17','10:25:00',1.2),('15844','2013-05-17','10:30:00',1.36),('15844','2013-05-17','10:35:00',1.16),('15844','2013-05-17','10:40:00',1.37),('15844','2013-05-17','10:45:00',2.6),('15844','2013-05-17','10:50:00',2.86),('15844','2013-05-17','10:55:00',2.03),('15844','2013-05-17','11:00:00',1.74),('15844','2013-05-17','11:05:00',1.48),('15844','2013-05-17','11:10:00',1.31),('15844','2013-05-17','11:15:00',3.45),('15844','2013-05-17','11:20:00',1.99),('15844','2013-05-17','11:25:00',1.81),('15844','2013-05-17','11:30:00',2.17),('15844','2013-05-17','11:35:00',1.91),('15844','2013-05-17','11:40:00',3.53),('15844','2013-05-17','11:45:00',4.3),('15844','2013-05-17','11:50:00',4.81),('15844','2013-05-17','11:55:00',4.15),('15844','2013-05-17','12:00:00',4.4),('15844','2013-05-17','12:05:00',5.17),('15844','2013-05-17','12:10:00',4.78),('15844','2013-05-17','12:15:00',4.15),('15844','2013-05-17','12:20:00',4.32),('15844','2013-05-17','12:25:00',4.93),('15844','2013-05-17','12:30:00',4.14),('15844','2013-05-17','12:35:00',3.68),('15844','2013-05-17','12:40:00',4.47),('15844','2013-05-17','12:45:00',4.64),('15844','2013-05-17','12:50:00',4.77),('15844','2013-05-17','12:55:00',3.52),('15844','2013-05-17','13:00:00',2.08),('15844','2013-05-17','13:05:00',2.99),('15844','2013-05-17','13:10:00',3.73),('15844','2013-05-17','13:15:00',4.32),('15844','2013-05-17','13:20:00',4.42),('15844','2013-05-17','13:25:00',3.75),('15844','2013-05-17','13:30:00',3.97),('15844','2013-05-17','13:35:00',4.06),('15844','2013-05-17','13:40:00',3.58),('15844','2013-05-17','13:45:00',3.07),('15844','2013-05-17','13:50:00',1.55),('15844','2013-05-17','13:55:00',2.31),('15844','2013-05-17','14:00:00',1.59),('15844','2013-05-17','14:05:00',3.47),('15844','2013-05-17','14:10:00',3.45),('15844','2013-05-17','14:15:00',2.64),('15844','2013-05-17','14:20:00',2.39),('15844','2013-05-17','14:25:00',2.7),('15844','2013-05-17','14:30:00',2.38),('15844','2013-05-17','14:35:00',2.31),('15844','2013-05-17','14:40:00',2.65),('15844','2013-05-17','14:45:00',3.19),('15844','2013-05-17','14:50:00',2.62),('15844','2013-05-17','14:55:00',3.02),('15844','2013-05-17','15:00:00',1.93),('15844','2013-05-17','15:05:00',3.35),('15844','2013-05-17','15:10:00',3.19),('15844','2013-05-17','15:15:00',2.85),('15844','2013-05-17','15:20:00',2.74),('15844','2013-05-17','15:25:00',2.58),('15844','2013-05-17','15:30:00',2.44),('15844','2013-05-17','15:35:00',2.41),('15844','2013-05-17','15:40:00',2.13),('15844','2013-05-17','15:45:00',1.95),('15844','2013-05-17','15:50:00',1.94),('15844','2013-05-17','15:55:00',1.64),('15844','2013-05-17','16:00:00',1.74),('15844','2013-05-17','16:05:00',1.84),('15844','2013-05-17','16:10:00',1.81),('15844','2013-05-17','16:15:00',2.02),('15844','2013-05-17','16:20:00',1.9),('15844','2013-05-17','16:25:00',1.59),('15844','2013-05-17','16:30:00',1.72),('15844','2013-05-17','16:35:00',1.46),('15844','2013-05-17','16:40:00',1.11),('15844','2013-05-17','16:45:00',1.02),('15844','2013-05-16','09:20:00',1.04),('15844','2013-05-16','09:25:00',1.51),('15844','2013-05-16','09:30:00',1.27),('15844','2013-05-16','09:35:00',1.56),('15844','2013-05-16','09:40:00',1.7),('15844','2013-05-16','09:45:00',2.69),('15844','2013-05-16','09:50:00',1.81),('15844','2013-05-16','10:00:00',2.03),('15844','2013-05-16','10:05:00',1.21),('15844','2013-05-16','10:10:00',1.1),('15844','2013-05-16','10:15:00',1.39),('15844','2013-05-16','10:20:00',1.88),('15844','2013-05-16','10:25:00',1.16),('15844','2013-05-16','10:30:00',1.39),('15844','2013-05-16','10:35:00',1.33),('15844','2013-05-16','10:40:00',1.8),('15844','2013-05-16','10:45:00',3.99),('15844','2013-05-16','10:50:00',2.9),('15844','2013-05-16','10:55:00',2.23),('15844','2013-05-16','11:00:00',3.91),('15844','2013-05-16','11:05:00',4.27),('15844','2013-05-16','11:10:00',3.48),('15844','2013-05-16','11:15:00',4.25),('15844','2013-05-16','11:20:00',2.92),('15844','2013-05-16','11:25:00',1.58),('15844','2013-05-16','11:30:00',1.47),('15844','2013-05-16','11:35:00',2.73),('15844','2013-05-16','11:40:00',3.95),('15844','2013-05-16','11:45:00',3.44),('15844','2013-05-16','11:50:00',3.23),('15844','2013-05-16','11:55:00',4.37),('15844','2013-05-16','12:00:00',2.24),('15844','2013-05-16','12:05:00',1.73),('15844','2013-05-16','12:10:00',1.34),('15844','2013-05-16','12:15:00',1.71),('15844','2013-05-16','12:20:00',1.59),('15844','2013-05-16','12:25:00',1.75),('15844','2013-05-16','12:30:00',3.56),('15844','2013-05-16','12:35:00',4.22),('15844','2013-05-16','12:40:00',4.44),('15844','2013-05-16','12:45:00',3.2),('15844','2013-05-16','12:50:00',2.31),('15844','2013-05-16','12:55:00',3.17),('15844','2013-05-16','13:00:00',4.06),('15844','2013-05-16','13:05:00',4.11),('15844','2013-05-16','13:10:00',3.93),('15844','2013-05-16','13:15:00',3.94),('15844','2013-05-16','13:20:00',3.89),('15844','2013-05-16','13:25:00',3.9),('15844','2013-05-16','13:30:00',3.84),('15844','2013-05-16','13:35:00',3.83),('15844','2013-05-16','13:40:00',3.71),('15844','2013-05-16','13:45:00',3.67),('15844','2013-05-16','13:50:00',3.65),('15844','2013-05-16','13:55:00',3.6),('15844','2013-05-16','14:00:00',3.53),('15844','2013-05-16','14:05:00',3.49),('15844','2013-05-16','14:10:00',3.39),('15844','2013-05-16','14:15:00',3.32),('15844','2013-05-16','14:20:00',3.21),('15844','2013-05-16','14:25:00',3.16),('15844','2013-05-16','14:30:00',3.08),('15844','2013-05-16','14:35:00',2.96),('15844','2013-05-16','14:40:00',2.9),('15844','2013-05-16','14:45:00',2.83),('15844','2013-05-16','14:50:00',2.78),('15844','2013-05-16','14:55:00',2.7),('15844','2013-05-16','15:00:00',2.57),('15844','2013-05-16','15:05:00',2.57),('15844','2013-05-16','15:10:00',2.1),('15844','2013-05-16','15:15:00',1.97),('15844','2013-05-16','15:20:00',2.35),('15844','2013-05-16','15:25:00',2.25),('15844','2013-05-16','15:30:00',2.2),('15844','2013-05-16','15:35:00',2.12),('15844','2013-05-16','15:40:00',2.08),('15844','2013-05-16','15:45:00',1.97),('15844','2013-05-16','15:50:00',1.91),('15844','2013-05-16','15:55:00',1.78),('15844','2013-05-16','16:00:00',1.69),('15844','2013-05-16','16:05:00',1.6),('15844','2013-05-16','16:10:00',1.67),('15844','2013-05-16','16:15:00',1.44),('15844','2013-05-16','16:20:00',1.58),('15844','2013-05-16','16:25:00',1.61),('15844','2013-05-16','16:30:00',1.51),('15844','2013-05-16','16:35:00',1.5),('15844','2013-05-16','16:40:00',1.52),('15844','2013-05-16','16:45:00',1.19),('15844','2013-05-16','16:50:00',1.45),('15844','2013-05-16','16:55:00',1.11),('15844','2013-05-16','17:20:00',1.05),('15844','2013-05-16','17:25:00',1.1),('15844','2013-05-16','17:30:00',1.02),('15844','2013-05-15','08:25:00',1.03),('15844','2013-05-15','08:30:00',1.21),('15844','2013-05-15','08:35:00',1.38),('15844','2013-05-15','08:40:00',1.47),('15844','2013-05-15','08:45:00',1.53),('15844','2013-05-15','08:50:00',1.57),('15844','2013-05-15','08:55:00',1.57),('15844','2013-05-15','09:00:00',1.62),('15844','2013-05-15','09:05:00',1.73),('15844','2013-05-15','09:10:00',1.84),('15844','2013-05-15','09:15:00',1.93),('15844','2013-05-15','09:20:00',1.98),('15844','2013-05-15','09:25:00',2.17),('15844','2013-05-15','09:30:00',2.33),('15844','2013-05-15','09:35:00',2.41),('15844','2013-05-15','09:40:00',2.44),('15844','2013-05-15','09:45:00',2.56),('15844','2013-05-15','09:50:00',2.74),('15844','2013-05-15','09:55:00',2.84),('15844','2013-05-15','10:00:00',3.05),('15844','2013-05-15','10:05:00',3.12),('15844','2013-05-15','10:10:00',3.29),('15844','2013-05-15','10:15:00',3.38),('15844','2013-05-15','10:20:00',3.53),('15844','2013-05-15','10:25:00',3.71),('15844','2013-05-15','10:30:00',3.66),('15844','2013-05-15','10:35:00',3.64),('15844','2013-05-15','10:40:00',3.82),('15844','2013-05-15','10:45:00',3.97),('15844','2013-05-15','10:50:00',4.09),('15844','2013-05-15','10:55:00',3.95),('15844','2013-05-15','11:00:00',3.96),('15844','2013-05-15','11:05:00',4.06),('15844','2013-05-15','11:10:00',4.2),('15844','2013-05-15','11:15:00',4.18),('15844','2013-05-15','11:20:00',4.13),('15844','2013-05-15','11:25:00',4.21),('15844','2013-05-15','11:30:00',4.41),('15844','2013-05-15','11:35:00',3.93),('15844','2013-05-15','11:40:00',3.8),('15844','2013-05-15','11:45:00',3.24),('15844','2013-05-15','11:50:00',2.14),('15844','2013-05-15','11:55:00',1.91),('15844','2013-05-15','12:00:00',2.46),('15844','2013-05-15','12:05:00',4.03),('15844','2013-05-15','12:10:00',3.68),('15844','2013-05-15','12:15:00',5.26),('15844','2013-05-15','12:20:00',4.36),('15844','2013-05-15','12:25:00',3.32),('15844','2013-05-15','12:30:00',2.99),('15844','2013-05-15','12:35:00',5.1),('15844','2013-05-15','12:40:00',2.95),('15844','2013-05-15','12:45:00',2.3),('15844','2013-05-15','12:50:00',2.12),('15844','2013-05-15','12:55:00',2.23),('15844','2013-05-15','13:00:00',2.29),('15844','2013-05-15','13:05:00',2.5),('15844','2013-05-15','13:10:00',2.1),('15844','2013-05-15','13:15:00',2.36),('15844','2013-05-15','13:20:00',2.29),('15844','2013-05-15','13:25:00',2.46),('15844','2013-05-15','13:30:00',2.26),('15844','2013-05-15','13:35:00',2.23),('15844','2013-05-15','13:40:00',2.37),('15844','2013-05-15','13:45:00',2.03),('15844','2013-05-15','13:50:00',1.97),('15844','2013-05-15','13:55:00',1.91),('15844','2013-05-15','14:00:00',1.63),('15844','2013-05-15','14:05:00',1.7),('15844','2013-05-15','14:10:00',1.94),('15844','2013-05-15','14:15:00',1.78),('15844','2013-05-15','14:20:00',2.14),('15844','2013-05-15','14:25:00',1.56),('15844','2013-05-15','14:30:00',1.32),('15844','2013-05-15','14:35:00',1.27),('15844','2013-05-15','14:40:00',1.26),('15844','2013-05-15','14:45:00',1.22),('15844','2013-05-15','14:50:00',1.2),('15844','2013-05-15','14:55:00',1.25),('15844','2013-05-15','15:00:00',1.17),('15844','2013-05-15','15:45:00',1.21),('15844','2013-05-15','15:50:00',1.52),('15844','2013-05-15','15:55:00',1.68),('15844','2013-05-15','16:00:00',1.64),('15844','2013-05-15','16:05:00',1.59),('15844','2013-05-15','16:10:00',1.43),('15844','2013-05-15','16:15:00',1.39),('15844','2013-05-15','16:20:00',1.36),('15844','2013-05-15','16:25:00',1.21),('15844','2013-05-15','16:30:00',1.03),('15844','2013-05-15','16:35:00',1.14),('15844','2013-05-15','16:40:00',1.12),('15844','2013-05-15','16:45:00',1.05),('15844','2013-05-15','16:50:00',1.18),('15844','2013-05-15','16:55:00',1.2),('15844','2013-05-15','17:00:00',1.37),('15844','2013-05-15','17:05:00',1.32),('15844','2013-05-15','17:10:00',1.06),('15844','2013-05-14','08:25:00',1.12),('15844','2013-05-14','08:30:00',1.35),('15844','2013-05-14','08:35:00',1.42),('15844','2013-05-14','08:40:00',1.51),('15844','2013-05-14','08:45:00',1.56),('15844','2013-05-14','08:50:00',1.62),('15844','2013-05-14','08:55:00',1.66),('15844','2013-05-14','09:00:00',1.77),('15844','2013-05-14','09:05:00',1.89),('15844','2013-05-14','09:10:00',1.99),('15844','2013-05-14','09:15:00',2.1),('15844','2013-05-14','09:20:00',2.19),('15844','2013-05-14','09:25:00',2.28),('15844','2013-05-14','09:30:00',2.42),('15844','2013-05-14','09:35:00',2.56),('15844','2013-05-14','09:40:00',2.65),('15844','2013-05-14','09:45:00',2.71),('15844','2013-05-14','09:50:00',2.92),('15844','2013-05-14','09:55:00',3.01),('15844','2013-05-14','10:00:00',3.11),('15844','2013-05-14','10:05:00',3.24),('15844','2013-05-14','10:10:00',3.39),('15844','2013-05-14','10:15:00',3.63),('15844','2013-05-14','10:20:00',3.75),('15844','2013-05-14','10:25:00',3.84),('15844','2013-05-14','10:30:00',3.91),('15844','2013-05-14','10:35:00',3.98),('15844','2013-05-14','10:40:00',4.06),('15844','2013-05-14','10:45:00',4.18),('15844','2013-05-14','10:50:00',4.23),('15844','2013-05-14','10:55:00',4.29),('15844','2013-05-14','11:00:00',4.3),('15844','2013-05-14','11:05:00',4.34),('15844','2013-05-14','11:10:00',4.37),('15844','2013-05-14','11:15:00',4.39),('15844','2013-05-14','11:20:00',4.42),('15844','2013-05-14','11:25:00',4.43),('15844','2013-05-14','11:30:00',4.44),('15844','2013-05-14','11:35:00',4.43),('15844','2013-05-14','11:40:00',4.45),('15844','2013-05-14','11:45:00',4.44),('15844','2013-05-14','11:50:00',4.42),('15844','2013-05-14','11:55:00',4.42),('15844','2013-05-14','12:00:00',4.42),('15844','2013-05-14','12:05:00',4.42),('15844','2013-05-14','12:10:00',4.42),('15844','2013-05-14','12:15:00',4.41),('15844','2013-05-14','12:20:00',4.41),('15844','2013-05-14','12:25:00',4.39),('15844','2013-05-14','12:30:00',4.38),('15844','2013-05-14','12:35:00',4.37),('15844','2013-05-14','12:40:00',4.35),('15844','2013-05-14','12:45:00',4.32),('15844','2013-05-14','12:50:00',4.32),('15844','2013-05-14','12:55:00',4.3),('15844','2013-05-14','13:00:00',4.29),('15844','2013-05-14','13:05:00',4.26),('15844','2013-05-14','13:10:00',4.23),('15844','2013-05-14','13:15:00',4.2),('15844','2013-05-14','13:20:00',4.16),('15844','2013-05-14','13:25:00',4.13),('15844','2013-05-14','13:30:00',4.11),('15844','2013-05-14','13:35:00',4.06),('15844','2013-05-14','13:40:00',4.05),('15844','2013-05-14','13:45:00',4),('15844','2013-05-14','13:50:00',3.93),('15844','2013-05-14','13:55:00',3.84),('15844','2013-05-14','14:00:00',3.78),('15844','2013-05-14','14:05:00',3.7),('15844','2013-05-14','14:10:00',3.6),('15844','2013-05-14','14:15:00',3.54),('15844','2013-05-14','14:20:00',3.45),('15844','2013-05-14','14:25:00',3.38),('15844','2013-05-14','14:30:00',3.32),('15844','2013-05-14','14:35:00',3.2),('15844','2013-05-14','14:40:00',3.06),('15844','2013-05-14','14:45:00',2.97),('15844','2013-05-14','14:50:00',2.89),('15844','2013-05-14','14:55:00',2.8),('15844','2013-05-14','15:00:00',2.78),('15844','2013-05-14','15:05:00',2.7),('15844','2013-05-14','15:10:00',2.59),('15844','2013-05-14','15:15:00',2.5),('15844','2013-05-14','15:20:00',2.41),('15844','2013-05-14','15:25:00',2.32),('15844','2013-05-14','15:30:00',2.23),('15844','2013-05-14','15:35:00',2.15),('15844','2013-05-14','15:40:00',2.05),('15844','2013-05-14','15:45:00',1.94),('15844','2013-05-14','15:50:00',1.8),('15844','2013-05-14','15:55:00',1.71),('15844','2013-05-14','16:00:00',1.63),('15844','2013-05-14','16:05:00',1.52),('15844','2013-05-14','16:10:00',1.46),('15844','2013-05-14','16:15:00',1.4),('15844','2013-05-14','16:20:00',1.33),('15844','2013-05-14','16:25:00',1.27),('15844','2013-05-14','16:30:00',1.18),('15844','2013-05-14','16:35:00',1.14),('15844','2013-05-14','16:40:00',1.04),('15844','2013-05-13','07:50:00',1.04),('15844','2013-05-13','08:30:00',1.08),('15844','2013-05-13','08:35:00',1.23),('15844','2013-05-13','08:40:00',1.31),('15844','2013-05-13','08:45:00',1.49),('15844','2013-05-13','08:50:00',1.55),('15844','2013-05-13','08:55:00',1.6),('15844','2013-05-13','09:00:00',1.69),('15844','2013-05-13','09:05:00',1.8),('15844','2013-05-13','09:10:00',1.87),('15844','2013-05-13','09:15:00',2),('15844','2013-05-13','09:20:00',2.14),('15844','2013-05-13','09:25:00',2.24),('15844','2013-05-13','09:30:00',2.37),('15844','2013-05-13','09:35:00',2.49),('15844','2013-05-13','09:40:00',1.63),('15844','2013-05-13','09:45:00',2.34),('15844','2013-05-13','09:50:00',1.09),('15844','2013-05-13','09:55:00',3.36),('15844','2013-05-13','10:00:00',3.62),('15844','2013-05-13','10:05:00',3.24),('15844','2013-05-13','10:10:00',3.7),('15844','2013-05-13','10:15:00',3.93),('15844','2013-05-13','10:20:00',3.87),('15844','2013-05-13','10:25:00',3.95),('15844','2013-05-13','10:30:00',3.91),('15844','2013-05-13','10:35:00',3.98),('15844','2013-05-13','10:40:00',4.04),('15844','2013-05-13','10:45:00',3.47),('15844','2013-05-13','10:50:00',4.3),('15844','2013-05-13','10:55:00',4.36),('15844','2013-05-13','11:00:00',4.83),('15844','2013-05-13','11:05:00',3.2),('15844','2013-05-13','11:10:00',3.21),('15844','2013-05-13','11:15:00',3.31),('15844','2013-05-13','11:20:00',4.58),('15844','2013-05-13','11:25:00',5.07),('15844','2013-05-13','11:30:00',4.11),('15844','2013-05-13','11:35:00',4.66),('15844','2013-05-13','11:40:00',4.69),('15844','2013-05-13','11:45:00',3.85),('15844','2013-05-13','11:50:00',2.45),('15844','2013-05-13','11:55:00',2.47),('15844','2013-05-13','12:00:00',2.37),('15844','2013-05-13','12:05:00',2.62),('15844','2013-05-13','12:10:00',5.37),('15844','2013-05-13','12:15:00',4.68),('15844','2013-05-13','12:20:00',2.04),('15844','2013-05-13','12:35:00',1.24),('15844','2013-05-13','12:40:00',4.09),('15844','2013-05-13','12:45:00',2.67),('15844','2013-05-13','12:50:00',3.82),('15844','2013-05-13','12:55:00',4.23),('15844','2013-05-13','13:00:00',3.5),('15844','2013-05-13','13:05:00',3.65),('15844','2013-05-13','13:10:00',1.61),('15844','2013-05-13','13:15:00',1.12),('15844','2013-05-13','13:20:00',1.17),('15844','2013-05-13','13:25:00',1.34),('15844','2013-05-13','13:30:00',1.23),('15844','2013-05-13','13:35:00',1.16),('15844','2013-05-13','13:40:00',1.93),('15844','2013-05-13','13:45:00',3.54),('15844','2013-05-13','13:50:00',4.26),('15844','2013-05-13','14:05:00',2.87),('15844','2013-05-13','14:10:00',4.15),('15844','2013-05-13','14:15:00',4.26),('15844','2013-05-13','14:20:00',1.92),('15844','2013-05-13','14:25:00',2.03),('15844','2013-05-13','14:30:00',1.83),('15844','2013-05-13','14:50:00',2.21),('15844','2013-05-13','14:55:00',2.98),('15844','2013-05-13','15:00:00',2.2),('15844','2013-05-13','15:45:00',2.05),('15844','2013-05-13','16:05:00',1.13),('15844','2013-05-13','16:10:00',1.24),('15844','2013-05-13','16:15:00',1.39),('15844','2013-05-12','08:10:00',1.03),('15844','2013-05-12','08:15:00',1.33),('15844','2013-05-12','08:20:00',1.24),('15844','2013-05-12','08:30:00',1.39),('15844','2013-05-12','08:35:00',1.33),('15844','2013-05-12','08:40:00',1.09),('15844','2013-05-12','09:00:00',1.98),('15844','2013-05-12','09:05:00',1.57),('15844','2013-05-12','09:20:00',1.16),('15844','2013-05-12','09:25:00',1.38),('15844','2013-05-12','09:30:00',1.44),('15844','2013-05-12','09:35:00',2.2),('15844','2013-05-12','09:40:00',3.1),('15844','2013-05-12','09:45:00',3.19),('15844','2013-05-12','09:50:00',3.16),('15844','2013-05-12','09:55:00',3.11),('15844','2013-05-12','10:00:00',3.28),('15844','2013-05-12','10:05:00',3.52),('15844','2013-05-12','10:10:00',3.78),('15844','2013-05-12','10:15:00',1.65),('15844','2013-05-12','10:35:00',3.02),('15844','2013-05-12','10:40:00',3.45),('15844','2013-05-12','10:45:00',4.51),('15844','2013-05-12','10:50:00',4.47),('15844','2013-05-12','10:55:00',3.46),('15844','2013-05-12','11:00:00',1.99),('15844','2013-05-12','11:05:00',1.49),('15844','2013-05-12','11:10:00',4.41),('15844','2013-05-12','11:15:00',2.21),('15844','2013-05-12','11:20:00',2.22),('15844','2013-05-12','11:25:00',1.6),('15844','2013-05-12','11:30:00',1.14),('15844','2013-05-12','11:35:00',2.32),('15844','2013-05-12','11:40:00',4.96),('15844','2013-05-12','11:45:00',2.02),('15844','2013-05-12','12:05:00',4.29),('15844','2013-05-12','12:10:00',4.21),('15844','2013-05-12','12:15:00',4.83),('15844','2013-05-12','12:20:00',1.5),('15844','2013-05-12','12:25:00',1.39),('15844','2013-05-12','12:30:00',2.07),('15844','2013-05-12','12:35:00',1.67),('15844','2013-05-12','12:40:00',1.58),('15844','2013-05-12','12:45:00',2.87),('15844','2013-05-12','12:50:00',1.34),('15844','2013-05-12','12:55:00',3.55),('15844','2013-05-12','13:00:00',4.66),('15844','2013-05-12','13:05:00',3.47),('15844','2013-05-12','13:10:00',4.46),('15844','2013-05-12','13:15:00',4.41),('15844','2013-05-12','13:20:00',4.35),('15844','2013-05-12','13:25:00',3.87),('15844','2013-05-12','13:30:00',4.09),('15844','2013-05-12','13:35:00',3.72),('15844','2013-05-12','13:40:00',4),('15844','2013-05-12','13:45:00',4.07),('15844','2013-05-12','13:50:00',4.26),('15844','2013-05-12','13:55:00',4.06),('15844','2013-05-12','14:00:00',3.89),('15844','2013-05-12','14:05:00',3.66),('15844','2013-05-12','14:10:00',3.01),('15844','2013-05-12','14:15:00',3.29),('15844','2013-05-12','14:20:00',3.33),('15844','2013-05-12','14:25:00',2.12),('15844','2013-05-12','14:30:00',3.89),('15844','2013-05-12','14:35:00',2.5),('15844','2013-05-12','14:40:00',3.42),('15844','2013-05-12','14:45:00',3.21),('15844','2013-05-12','14:50:00',2.67),('15844','2013-05-12','14:55:00',2.1),('15844','2013-05-12','15:00:00',3.08),('15844','2013-05-12','15:05:00',2.76),('15844','2013-05-12','15:10:00',2.72),('15844','2013-05-12','15:15:00',2.02),('15844','2013-05-12','15:20:00',2.29),('15844','2013-05-12','15:25:00',2.36),('15844','2013-05-12','15:30:00',2.24),('15844','2013-05-12','15:35:00',2.2),('15844','2013-05-12','15:40:00',2.04),('15844','2013-05-12','15:45:00',1.94),('15844','2013-05-12','15:50:00',1.82),('15844','2013-05-12','15:55:00',1.73),('15844','2013-05-12','16:00:00',1.63),('15844','2013-05-12','16:05:00',1.55),('15844','2013-05-12','16:10:00',1.48),('15844','2013-05-12','16:15:00',1.45),('15844','2013-05-12','16:20:00',1.39),('15844','2013-05-12','16:25:00',1.36),('15844','2013-05-12','16:30:00',1.45),('15844','2013-05-12','16:35:00',1.41),('15844','2013-05-12','16:40:00',1.33),('15844','2013-05-12','16:45:00',1.58),('15844','2013-05-12','16:50:00',1.51),('15844','2013-05-12','16:55:00',1.51),('15844','2013-05-12','17:00:00',1.37),('15844','2013-05-12','17:05:00',1.12),('15844','2013-05-12','17:10:00',1.12),('15844','2013-05-12','17:35:00',1.05),('15844','2013-05-12','17:40:00',1.05),('15844','2013-05-12','17:55:00',1.08),('15844','2013-05-12','18:05:00',1.04),('15844','2013-05-12','18:10:00',1.2),('15844','2014-03-31','08:50:00',1.06),('15844','2014-03-31','08:55:00',1.15),('15844','2014-03-31','09:00:00',1.24),('15844','2014-03-31','09:05:00',1.31),('15844','2014-03-31','09:10:00',1.47),('15844','2014-03-31','09:15:00',1.66),('15844','2014-03-31','09:20:00',1.77),('15844','2014-03-31','09:25:00',1.85),('15844','2014-03-31','09:30:00',1.95),('15844','2014-03-31','09:35:00',2.07),('15844','2014-03-31','09:40:00',2.19),('15844','2014-03-31','09:45:00',2.3),('15844','2014-03-31','09:50:00',2.37),('15844','2014-03-31','09:55:00',2.4),('15844','2014-03-31','10:00:00',2.45),('15844','2014-03-31','10:05:00',2.53),('15844','2014-03-31','10:10:00',2.62),('15844','2014-03-31','10:15:00',2.69),('15844','2014-03-31','10:20:00',2.72),('15844','2014-03-31','10:25:00',2.78),('15844','2014-03-31','10:30:00',2.87),('15844','2014-03-31','10:35:00',3.01),('15844','2014-03-31','10:40:00',3.12),('15844','2014-03-31','10:45:00',3.16),('15844','2014-03-31','10:50:00',3.2),('15844','2014-03-31','10:55:00',3.27),('15844','2014-03-31','11:00:00',3.37),('15844','2014-03-31','11:05:00',3.46),('15844','2014-03-31','11:10:00',3.52),('15844','2014-03-31','11:15:00',3.54),('15844','2014-03-31','11:20:00',3.56),('15844','2014-03-31','11:25:00',3.62),('15844','2014-03-31','11:30:00',3.62),('15844','2014-03-31','11:35:00',3.65),('15844','2014-03-31','11:40:00',3.68),('15844','2014-03-31','11:45:00',3.69),('15844','2014-03-31','11:50:00',3.66),('15844','2014-03-31','11:55:00',3.67),('15844','2014-03-31','12:00:00',3.69),('15844','2014-03-31','12:05:00',3.68),('15844','2014-03-31','12:10:00',3.68),('15844','2014-03-31','12:15:00',3.65),('15844','2014-03-31','12:20:00',3.62),('15844','2014-03-31','12:25:00',3.61),('15844','2014-03-31','12:30:00',3.63),('15844','2014-03-31','12:35:00',3.69),('15844','2014-03-31','12:40:00',3.66),('15844','2014-03-31','12:45:00',3.66),('15844','2014-03-31','12:50:00',3.62),('15844','2014-03-31','12:55:00',3.63),('15844','2014-03-31','13:00:00',3.63),('15844','2014-03-31','13:05:00',3.61),('15844','2014-03-31','13:10:00',3.58),('15844','2014-03-31','13:15:00',3.59),('15844','2014-03-31','13:20:00',3.57),('15844','2014-03-31','13:25:00',3.53),('15844','2014-03-31','13:30:00',3.49),('15844','2014-03-31','13:35:00',3.48),('15844','2014-03-31','13:40:00',3.44),('15844','2014-03-31','13:45:00',3.38),('15844','2014-03-31','13:50:00',3.35),('15844','2014-03-31','13:55:00',3.31),('15844','2014-03-31','14:00:00',3.26),('15844','2014-03-31','14:05:00',3.22),('15844','2014-03-31','14:10:00',3.16),('15844','2014-03-31','14:15:00',3.1),('15844','2014-03-31','14:20:00',3.04),('15844','2014-03-31','14:25:00',2.96),('15844','2014-03-31','14:30:00',2.9),('15844','2014-03-31','14:35:00',2.77),('15844','2014-03-31','14:40:00',2.65),('15844','2014-03-31','14:45:00',2.52),('15844','2014-03-31','14:50:00',2.4),('15844','2014-03-31','14:55:00',2.26),('15844','2014-03-31','15:00:00',2.25),('15844','2014-03-31','15:05:00',2.15),('15844','2014-03-31','15:10:00',2.05),('15844','2014-03-31','15:15:00',1.93),('15844','2014-03-31','15:20:00',1.85),('15844','2014-03-31','15:25:00',1.76),('15844','2014-03-31','15:30:00',1.67),('15844','2014-03-31','15:35:00',1.57),('15844','2014-03-31','15:40:00',1.46),('15844','2014-03-31','15:45:00',1.34),('15844','2014-03-31','15:50:00',1.24),('15844','2014-03-31','15:55:00',1.19),('15844','2014-03-31','16:00:00',1.12),('15844','2014-03-31','16:05:00',1.05),('15844','2013-05-11','08:15:00',1.16),('15844','2013-05-11','08:20:00',1.03),('15844','2013-05-11','08:25:00',1.13),('15844','2013-05-11','08:35:00',1.02),('15844','2013-05-11','08:40:00',1.3),('15844','2013-05-11','08:50:00',1.06),('15844','2013-05-11','08:55:00',1.57),('15844','2013-05-11','09:00:00',1.76),('15844','2013-05-11','09:05:00',1.22),('15844','2013-05-11','09:10:00',2.45),('15844','2013-05-11','09:15:00',2.15),('15844','2013-05-11','09:20:00',2.14),('15844','2013-05-11','09:25:00',1.81),('15844','2013-05-11','09:30:00',1.57),('15844','2013-05-11','09:35:00',1.12),('15844','2013-05-11','09:40:00',1.4),('15844','2013-05-11','09:45:00',1.72),('15844','2013-05-11','09:50:00',1.33),('15844','2013-05-11','10:10:00',1.08),('15844','2013-05-11','10:15:00',2.2),('15844','2013-05-11','10:20:00',3.73),('15844','2013-05-11','10:25:00',4.29),('15844','2013-05-11','10:30:00',2.77),('15844','2013-05-11','10:35:00',4.17),('15844','2013-05-11','10:40:00',4.39),('15844','2013-05-11','10:45:00',3.2),('15844','2013-05-11','10:50:00',4.67),('15844','2013-05-11','10:55:00',4.58),('15844','2013-05-11','11:00:00',2.39),('15844','2013-05-11','11:05:00',1.3),('15844','2013-05-11','11:30:00',1.25),('15844','2013-05-11','11:35:00',2.84),('15844','2013-05-11','11:40:00',1.66),('15844','2013-05-11','11:45:00',2.33),('15844','2013-05-11','11:50:00',5.02),('15844','2013-05-11','11:55:00',4.61),('15844','2013-05-11','12:00:00',2.8),('15844','2013-05-11','12:05:00',2.53),('15844','2013-05-11','12:10:00',3.35),('15844','2013-05-11','12:15:00',3.66),('15844','2013-05-11','12:20:00',4.15),('15844','2013-05-11','12:25:00',5.07),('15844','2013-05-11','12:30:00',4.61),('15844','2013-05-11','12:35:00',2.67),('15844','2013-05-11','12:40:00',1.79),('15844','2013-05-11','12:45:00',3.23),('15844','2013-05-11','12:50:00',1.92),('15844','2013-05-11','12:55:00',1.67),('15844','2013-05-11','13:00:00',1.82),('15844','2013-05-11','13:05:00',2.96),('15844','2013-05-11','13:10:00',3.36),('15844','2013-05-11','13:15:00',1.56),('15844','2013-05-11','13:20:00',1.8),('15844','2013-05-11','13:30:00',1.24),('15844','2013-05-11','13:35:00',2.77),('15844','2013-05-11','13:40:00',2.62),('15844','2013-05-11','13:45:00',2.01),('15844','2013-05-11','13:50:00',2.6),('15844','2013-05-11','13:55:00',3.02),('15844','2013-05-11','14:00:00',3.78),('15844','2013-05-11','14:05:00',2.28),('15844','2013-05-11','14:10:00',2.3),('15844','2013-05-11','14:15:00',2.03),('15844','2013-05-11','14:20:00',2.57),('15844','2013-05-11','14:25:00',2.4),('15844','2013-05-11','14:30:00',3.19),('15844','2013-05-11','14:35:00',2.5),('15844','2013-05-11','14:40:00',2.08),('15844','2013-05-11','14:45:00',2.34),('15844','2013-05-11','14:50:00',1.7),('15844','2013-05-11','14:55:00',1.56),('15844','2013-05-11','15:00:00',1.19),('15844','2013-05-11','15:05:00',2.18),('15844','2013-05-11','15:10:00',2.31),('15844','2013-05-11','15:15:00',1.93),('15844','2013-05-11','15:20:00',2.09),('15844','2013-05-11','15:25:00',2.64),('15844','2013-05-11','15:30:00',1.83),('15844','2013-05-11','15:35:00',2.49),('15844','2013-05-11','15:40:00',2.8),('15844','2013-05-11','15:45:00',2.19),('15844','2013-05-11','15:50:00',1.67),('15844','2013-05-11','15:55:00',2.08),('15844','2013-05-11','16:00:00',1.74),('15844','2013-05-11','16:05:00',1.61),('15844','2013-05-11','16:10:00',1.54),('15844','2013-05-11','16:15:00',1.25),('15844','2013-05-11','16:20:00',1.36),('15844','2013-05-11','16:25:00',1.37),('15844','2013-05-11','16:30:00',1.27),('15844','2013-05-11','16:40:00',1.11),('15844','2013-05-11','16:55:00',1.09),('15844','2013-05-10','08:00:00',1.21),('15844','2013-05-10','08:05:00',1.31),('15844','2013-05-10','08:10:00',1.37),('15844','2013-05-10','08:15:00',1.26),('15844','2013-05-10','08:20:00',1.2),('15844','2013-05-10','08:25:00',1.04),('15844','2013-05-10','08:55:00',1.52),('15844','2013-05-10','09:00:00',1.79),('15844','2013-05-10','09:05:00',1.88),('15844','2013-05-10','09:10:00',1.86),('15844','2013-05-10','09:15:00',1.77),('15844','2013-05-10','09:20:00',1.97),('15844','2013-05-10','09:25:00',2.48),('15844','2013-05-10','09:30:00',2.2),('15844','2013-05-10','09:35:00',1.94),('15844','2013-05-10','09:40:00',2.53),('15844','2013-05-10','09:45:00',2.88),('15844','2013-05-10','09:50:00',3.07),('15844','2013-05-10','09:55:00',2.97),('15844','2013-05-10','10:00:00',3.06),('15844','2013-05-10','10:05:00',1.29),('15844','2013-05-10','10:10:00',1.3),('15844','2013-05-10','10:15:00',1.39),('15844','2013-05-10','10:20:00',1.09),('15844','2013-05-10','10:25:00',3.02),('15844','2013-05-10','10:30:00',3.85),('15844','2013-05-10','10:35:00',3.94),('15844','2013-05-10','10:40:00',3.98),('15844','2013-05-10','10:45:00',4.15),('15844','2013-05-10','10:50:00',4.36),('15844','2013-05-10','10:55:00',4.6),('15844','2013-05-10','11:00:00',3.37),('15844','2013-05-10','11:05:00',4.31),('15844','2013-05-10','11:10:00',4.37),('15844','2013-05-10','11:15:00',4.32),('15844','2013-05-10','11:20:00',3.33),('15844','2013-05-10','11:25:00',3.52),('15844','2013-05-10','11:30:00',2.43),('15844','2013-05-10','11:35:00',2.48),('15844','2013-05-10','11:40:00',2.7),('15844','2013-05-10','11:45:00',3.06),('15844','2013-05-10','11:50:00',3.42),('15844','2013-05-10','11:55:00',3.15),('15844','2013-05-10','12:00:00',3.29),('15844','2013-05-10','12:05:00',3.62),('15844','2013-05-10','12:10:00',3.51),('15844','2013-05-10','12:15:00',3.06),('15844','2013-05-10','12:20:00',3.27),('15844','2013-05-10','12:25:00',2.69),('15844','2013-05-10','12:30:00',4.33),('15844','2013-05-10','12:35:00',5.05),('15844','2013-05-10','12:40:00',4.41),('15844','2013-05-10','12:45:00',4.19),('15844','2013-05-10','12:50:00',4.03),('15844','2013-05-10','12:55:00',5.01),('15844','2013-05-10','13:00:00',4.04),('15844','2013-05-10','13:05:00',4.69),('15844','2013-05-10','13:10:00',3.93),('15844','2013-05-10','13:15:00',2.54),('15844','2013-05-10','13:20:00',4.28),('15844','2013-05-10','13:25:00',5.42),('15844','2013-05-10','13:30:00',4.72),('15844','2013-05-10','13:35:00',4.35),('15844','2013-05-10','13:40:00',2.18),('15844','2013-05-10','13:45:00',1.85),('15844','2013-05-10','13:50:00',1.68),('15844','2013-05-10','13:55:00',1.69),('15844','2013-05-10','14:00:00',2.04),('15844','2013-05-10','14:05:00',2.55),('15844','2013-05-10','14:10:00',2.55),('15844','2013-05-10','14:15:00',2.54),('15844','2013-05-10','14:20:00',2.13),('15844','2013-05-10','14:25:00',2.13),('15844','2013-05-10','14:30:00',2.62),('15844','2013-05-10','14:35:00',1.77),('15844','2013-05-10','14:40:00',1.41),('15844','2013-05-10','14:45:00',1.15),('15844','2013-05-10','14:50:00',1.02),('15844','2013-05-10','14:55:00',1.11),('15844','2013-05-10','15:00:00',1.58),('15844','2013-05-10','15:05:00',2.54),('15844','2013-05-10','15:10:00',2.05),('15844','2013-05-10','15:15:00',1.66),('15844','2013-05-10','15:20:00',1.63),('15844','2013-05-10','15:25:00',1.8),('15844','2013-05-10','15:30:00',1.93),('15844','2013-05-10','15:35:00',1.91),('15844','2013-05-10','15:40:00',1.75),('15844','2013-05-10','15:45:00',1.53),('15844','2013-05-10','15:50:00',1.48),('15844','2013-05-10','15:55:00',1.5),('15844','2013-05-10','16:00:00',1.44),('15844','2013-05-10','16:05:00',1.3),('15844','2013-05-10','16:10:00',1.23),('15844','2013-05-10','16:15:00',1.21),('15844','2013-05-10','16:20:00',1.33),('15844','2013-05-10','16:25:00',1.42),('15844','2013-05-10','16:30:00',1.38),('15844','2013-05-10','16:35:00',1.35),('15844','2013-05-10','16:40:00',1.33),('15844','2013-05-10','16:45:00',1.12),('15844','2013-05-10','17:05:00',1.18),('15844','2013-05-10','17:10:00',1.32),('15844','2013-05-10','17:15:00',1.43),('15844','2013-05-10','17:20:00',1.4),('15844','2013-05-10','17:25:00',1.31),('15844','2013-05-10','17:30:00',1.11),('15844','2013-05-09','08:20:00',1.02),('15844','2013-05-09','08:25:00',1.18),('15844','2013-05-09','08:30:00',1.28),('15844','2013-05-09','08:35:00',1.35),('15844','2013-05-09','08:40:00',1.43),('15844','2013-05-09','08:45:00',1.51),('15844','2013-05-09','08:50:00',1.64),('15844','2013-05-09','08:55:00',1.7),('15844','2013-05-09','09:00:00',1.76),('15844','2013-05-09','09:05:00',1.83),('15844','2013-05-09','09:10:00',1.91),('15844','2013-05-09','09:15:00',2.05),('15844','2013-05-09','09:20:00',2.2),('15844','2013-05-09','09:25:00',2.32),('15844','2013-05-09','09:30:00',2.41),('15844','2013-05-09','09:35:00',2.5),('15844','2013-05-09','09:40:00',2.58),('15844','2013-05-09','09:45:00',2.66),('15844','2013-05-09','09:50:00',2.84),('15844','2013-05-09','09:55:00',2.94),('15844','2013-05-09','10:00:00',3.03),('15844','2013-05-09','10:05:00',3.12),('15844','2013-05-09','10:10:00',3.25),('15844','2013-05-09','10:15:00',3.44),('15844','2013-05-09','10:20:00',3.58),('15844','2013-05-09','10:25:00',3.67),('15844','2013-05-09','10:30:00',3.76),('15844','2013-05-09','10:35:00',3.79),('15844','2013-05-09','10:40:00',3.87),('15844','2013-05-09','10:45:00',4.01),('15844','2013-05-09','10:50:00',4.12),('15844','2013-05-09','10:55:00',4.16),('15844','2013-05-09','11:00:00',4.21),('15844','2013-05-09','11:05:00',4.25),('15844','2013-05-09','11:10:00',4.27),('15844','2013-05-09','11:15:00',4.28),('15844','2013-05-09','11:20:00',4.25),('15844','2013-05-09','11:25:00',4.24),('15844','2013-05-09','11:30:00',4.29),('15844','2013-05-09','11:35:00',4.31),('15844','2013-05-09','11:40:00',4.35),('15844','2013-05-09','11:45:00',4.37),('15844','2013-05-09','11:50:00',4.4),('15844','2013-05-09','11:55:00',4.42),('15844','2013-05-09','12:00:00',4.44),('15844','2013-05-09','12:05:00',4.43),('15844','2013-05-09','12:10:00',4.43),('15844','2013-05-09','12:15:00',4.4),('15844','2013-05-09','12:20:00',4.37),('15844','2013-05-09','12:25:00',4.35),('15844','2013-05-09','12:30:00',4.37),('15844','2013-05-09','12:35:00',4.34),('15844','2013-05-09','12:40:00',4.33),('15844','2013-05-09','12:45:00',4.29),('15844','2013-05-09','12:50:00',4.34),('15844','2013-05-09','12:55:00',4.31),('15844','2013-05-09','13:00:00',4.27),('15844','2013-05-09','13:05:00',4.23),('15844','2013-05-09','13:10:00',4.18),('15844','2013-05-09','13:15:00',4.42),('15844','2013-05-09','13:20:00',2.54),('15844','2013-05-09','13:25:00',1.64),('15844','2013-05-09','13:30:00',2.41),('15844','2013-05-09','13:40:00',1.45),('15844','2013-05-09','13:45:00',3.1),('15844','2013-05-09','13:50:00',4.36),('15844','2013-05-09','13:55:00',4.26),('15844','2013-05-09','14:00:00',4.11),('15844','2013-05-09','14:05:00',3.94),('15844','2013-05-09','14:10:00',3.74),('15844','2013-05-09','14:15:00',3.6),('15844','2013-05-09','14:20:00',3.52),('15844','2013-05-09','14:25:00',3.43),('15844','2013-05-09','14:30:00',3.29),('15844','2013-05-09','14:35:00',3.18),('15844','2013-05-09','14:40:00',3.07),('15844','2013-05-09','14:45:00',2.98),('15844','2013-05-09','14:50:00',2.85),('15844','2013-05-09','14:55:00',2.7),('15844','2013-05-09','15:00:00',2.55),('15844','2013-05-09','15:05:00',2.46),('15844','2013-05-09','15:10:00',2.44),('15844','2013-05-09','15:15:00',2.43),('15844','2013-05-09','15:20:00',2.38),('15844','2013-05-09','15:25:00',2.29),('15844','2013-05-09','15:30:00',2.18),('15844','2013-05-09','15:35:00',2.06),('15844','2013-05-09','15:40:00',1.97),('15844','2013-05-09','15:45:00',1.88),('15844','2013-05-09','15:50:00',1.78),('15844','2013-05-09','15:55:00',1.68),('15844','2013-05-09','16:00:00',1.58),('15844','2013-05-09','16:05:00',1.48),('15844','2013-05-09','16:10:00',1.43),('15844','2013-05-09','16:15:00',1.35),('15844','2013-05-09','16:20:00',1.3),('15844','2013-05-09','16:25:00',1.23),('15844','2013-05-09','16:30:00',1.15),('15844','2013-05-09','16:35:00',1.06),('15844','2013-05-08','08:30:00',1.06),('15844','2013-05-08','08:35:00',1.23),('15844','2013-05-08','08:40:00',1.4),('15844','2013-05-08','08:45:00',1.79),('15844','2013-05-08','08:50:00',2.02),('15844','2013-05-08','08:55:00',1.93),('15844','2013-05-08','09:00:00',1.98),('15844','2013-05-08','09:05:00',1.55),('15844','2013-05-08','09:10:00',2.37),('15844','2013-05-08','09:15:00',2.6),('15844','2013-05-08','09:20:00',2.22),('15844','2013-05-08','09:55:00',1.04),('15844','2013-05-08','10:00:00',3.84),('15844','2013-05-08','10:05:00',2.53),('15844','2013-05-08','10:10:00',3.48),('15844','2013-05-08','10:15:00',2.19),('15844','2013-05-08','10:20:00',2.64),('15844','2013-05-08','10:25:00',2.88),('15844','2013-05-08','10:30:00',3.79),('15844','2013-05-08','10:35:00',2.45),('15844','2013-05-08','10:40:00',3.78),('15844','2013-05-08','10:45:00',4.22),('15844','2013-05-08','10:50:00',3.57),('15844','2013-05-08','10:55:00',1.36),('15844','2013-05-08','11:00:00',3.68),('15844','2013-05-08','11:05:00',4.84),('15844','2013-05-08','11:10:00',2.49),('15844','2013-05-08','11:15:00',1.48),('15844','2013-05-08','11:20:00',1.12),('15844','2013-05-08','11:30:00',1.13),('15844','2013-05-08','11:35:00',1.08),('15844','2013-05-08','11:40:00',1.22),('15844','2013-05-08','11:45:00',2.87),('15844','2013-05-08','11:50:00',3.95),('15844','2013-05-08','11:55:00',4.48),('15844','2013-05-08','12:00:00',5.05),('15844','2013-05-08','12:05:00',3.44),('15844','2013-05-08','12:35:00',1.72),('15844','2013-05-08','12:40:00',1.08),('15844','2013-05-08','12:45:00',2.39),('15844','2013-05-08','12:50:00',4.19),('15844','2013-05-08','12:55:00',2.37),('15844','2013-05-08','13:00:00',1.39),('15844','2013-05-08','13:05:00',2.62),('15844','2013-05-08','13:10:00',2.08),('15844','2013-05-08','13:15:00',1.71),('15844','2013-05-08','13:20:00',1.22),('15844','2013-05-08','13:25:00',1.29),('15844','2013-05-08','13:30:00',2.28),('15844','2013-05-08','13:35:00',4.93),('15844','2013-05-08','13:40:00',4.35),('15844','2013-05-08','13:45:00',3.75),('15844','2013-05-08','13:50:00',3.67),('15844','2013-05-08','13:55:00',3.46),('15844','2013-05-08','14:00:00',2.01),('15844','2013-05-08','14:05:00',3.53),('15844','2013-05-08','14:10:00',3.97),('15844','2013-05-08','14:15:00',3.94),('15844','2013-05-08','14:20:00',3.88),('15844','2013-05-08','14:25:00',3.7),('15844','2013-05-08','14:30:00',3.69),('15844','2013-05-08','14:35:00',3.48),('15844','2013-05-08','14:40:00',3.36),('15844','2013-05-08','14:45:00',3.18),('15844','2013-05-08','14:50:00',2.86),('15844','2013-05-08','14:55:00',2.95),('15844','2013-05-08','15:00:00',2.78),('15844','2013-05-08','15:05:00',2.69),('15844','2013-05-08','15:10:00',2.59),('15844','2013-05-08','15:15:00',2.5),('15844','2013-05-08','15:20:00',2.45),('15844','2013-05-08','15:25:00',2.39),('15844','2013-05-08','15:30:00',2.24),('15844','2013-05-08','15:35:00',1.97),('15844','2013-05-08','15:40:00',2.08),('15844','2013-05-08','15:45:00',1.97),('15844','2013-05-08','15:50:00',1.89),('15844','2013-05-08','15:55:00',1.79),('15844','2013-05-08','16:00:00',1.66),('15844','2013-05-08','16:05:00',1.58),('15844','2013-05-08','16:10:00',1.49),('15844','2013-05-08','16:15:00',1.39),('15844','2013-05-08','16:20:00',1.3),('15844','2013-05-08','16:25:00',1.26),('15844','2013-05-08','16:30:00',1.22),('15844','2013-05-08','16:35:00',1.19),('15844','2013-05-08','16:40:00',1),('15844','2013-05-07','08:20:00',1.05),('15844','2013-05-07','08:25:00',1.18),('15844','2013-05-07','08:30:00',1.27),('15844','2013-05-07','08:35:00',1.34),('15844','2013-05-07','08:40:00',1.44),('15844','2013-05-07','08:45:00',1.59),('15844','2013-05-07','08:50:00',1.49),('15844','2013-05-07','08:55:00',1.66),('15844','2013-05-07','09:00:00',1.77),('15844','2013-05-07','09:05:00',1.71),('15844','2013-05-07','09:10:00',2.39),('15844','2013-05-07','09:15:00',1.18),('15844','2013-05-07','09:45:00',1.63),('15844','2013-05-07','10:20:00',1.64),('15844','2013-05-07','10:25:00',1.29),('15844','2013-05-07','11:20:00',1.37),('15844','2013-05-07','11:25:00',2.29),('15844','2013-05-07','11:30:00',4.79),('15844','2013-05-07','11:35:00',4.9),('15844','2013-05-07','11:40:00',4.82),('15844','2013-05-07','11:45:00',5.13),('15844','2013-05-07','11:50:00',2.16),('15844','2013-05-07','11:55:00',1.11),('15844','2013-05-07','12:00:00',1.17),('15844','2013-05-07','12:05:00',1.33),('15844','2013-05-07','12:10:00',1.8),('15844','2013-05-07','12:15:00',2.37),('15844','2013-05-07','12:20:00',1.86),('15844','2013-05-07','12:25:00',2.21),('15844','2013-05-07','12:30:00',2.08),('15844','2013-05-07','12:35:00',1.99),('15844','2013-05-07','12:40:00',2.26),('15844','2013-05-07','12:45:00',2.79),('15844','2013-05-07','12:50:00',1.62),('15844','2013-05-07','12:55:00',1.23),('15844','2013-05-07','13:00:00',1.57),('15844','2013-05-07','13:05:00',2.2),('15844','2013-05-07','13:10:00',5.22),('15844','2013-05-07','13:15:00',4.53),('15844','2013-05-07','13:20:00',4.66),('15844','2013-05-07','13:25:00',4.25),('15844','2013-05-07','13:30:00',3.86),('15844','2013-05-07','13:35:00',4.35),('15844','2013-05-07','13:40:00',3.96),('15844','2013-05-07','13:45:00',4.37),('15844','2013-05-07','13:50:00',3.68),('15844','2013-05-07','13:55:00',4.02),('15844','2013-05-07','14:00:00',4.37),('15844','2013-05-07','14:05:00',4.55),('15844','2013-05-07','14:10:00',4.35),('15844','2013-05-07','14:15:00',4.37),('15844','2013-05-07','14:20:00',4.03),('15844','2013-05-07','14:25:00',3.57),('15844','2013-05-07','14:30:00',3.55),('15844','2013-05-07','14:35:00',3.11),('15844','2013-05-07','14:40:00',3.48),('15844','2013-05-07','14:45:00',3.18),('15844','2013-05-07','14:50:00',3.01),('15844','2013-05-07','14:55:00',2.94),('15844','2013-05-07','15:00:00',2.03),('15844','2013-05-07','15:05:00',2.97),('15844','2013-05-07','15:10:00',2.78),('15844','2013-05-07','15:15:00',2.77),('15844','2013-05-07','15:20:00',2.75),('15844','2013-05-07','15:25:00',2.15),('15844','2013-05-07','15:30:00',1.47),('15844','2013-05-07','15:35:00',1.07),('15844','2013-05-07','15:40:00',2),('15844','2013-05-07','15:45:00',1.16),('15844','2013-05-07','15:50:00',1.69),('15844','2013-05-07','15:55:00',2.28),('15844','2013-05-07','16:00:00',2.74),('15844','2013-05-07','16:05:00',2.34),('15844','2013-05-07','16:10:00',2.04),('15844','2013-05-07','16:15:00',1.85),('15844','2013-05-07','16:20:00',1.84),('15844','2013-05-07','16:25:00',1.63),('15844','2013-05-07','16:30:00',1.57),('15844','2013-05-07','16:35:00',1.59),('15844','2013-05-07','16:40:00',1.65),('15844','2013-05-07','16:45:00',1.29),('15844','2013-05-07','16:50:00',1.05),('15844','2013-05-07','16:55:00',1.33),('15844','2013-05-07','17:00:00',1.09),('15844','2013-05-06','08:20:00',1.35),('15844','2013-05-06','08:25:00',1.13),('15844','2013-05-06','08:35:00',1.09),('15844','2013-05-06','08:40:00',1.35),('15844','2013-05-06','08:45:00',1.26),('15844','2013-05-06','08:50:00',1.8),('15844','2013-05-06','08:55:00',1.45),('15844','2013-05-06','09:00:00',1.3),('15844','2013-05-06','09:05:00',1.04),('15844','2013-05-06','09:10:00',1.3),('15844','2013-05-06','09:15:00',2.04),('15844','2013-05-06','09:20:00',1.59),('15844','2013-05-06','09:40:00',1.42),('15844','2013-05-06','10:10:00',1.09),('15844','2013-05-06','10:15:00',1.56),('15844','2013-05-06','10:20:00',1.44),('15844','2013-05-06','10:25:00',1.69),('15844','2013-05-06','10:30:00',1.79),('15844','2013-05-06','10:35:00',2.2),('15844','2013-05-06','10:40:00',1.32),('15844','2013-05-06','10:50:00',1.74),('15844','2013-05-06','10:55:00',1.66),('15844','2013-05-06','11:00:00',1.26),('15844','2013-05-06','11:10:00',1.07),('15844','2013-05-06','11:15:00',1.92),('15844','2013-05-06','11:20:00',1.16),('15844','2013-05-06','11:30:00',1.77),('15844','2013-05-06','11:35:00',2.08),('15844','2013-05-06','11:40:00',1.09),('15844','2013-05-06','11:45:00',1.56),('15844','2013-05-06','11:50:00',1.87),('15844','2013-05-06','11:55:00',1.3),('15844','2013-05-06','12:00:00',1.36),('15844','2013-05-06','12:05:00',1.92),('15844','2013-05-06','12:10:00',3.01),('15844','2013-05-06','12:15:00',2.25),('15844','2013-05-06','12:20:00',3.07),('15844','2013-05-06','12:25:00',3.17),('15844','2013-05-06','12:30:00',3.14),('15844','2013-05-06','12:35:00',3.94),('15844','2013-05-06','12:40:00',4.69),('15844','2013-05-06','12:45:00',3.65),('15844','2013-05-06','12:50:00',3.41),('15844','2013-05-06','12:55:00',3.78),('15844','2013-05-06','13:00:00',3.22),('15844','2013-05-06','13:05:00',3.59),('15844','2013-05-06','13:10:00',4.43),('15844','2013-05-06','13:15:00',4.12),('15844','2013-05-06','13:20:00',3.75),('15844','2013-05-06','13:25:00',2.65),('15844','2013-05-06','13:30:00',2.95),('15844','2013-05-06','13:35:00',3.85),('15844','2013-05-06','13:40:00',4.41),('15844','2013-05-06','13:45:00',4.37),('15844','2013-05-06','13:50:00',2.63),('15844','2013-05-06','13:55:00',3.29),('15844','2013-05-06','14:00:00',3.4),('15844','2013-05-06','14:05:00',2.54),('15844','2013-05-06','14:10:00',2.64),('15844','2013-05-06','14:15:00',3),('15844','2013-05-06','14:20:00',4.13),('15844','2013-05-06','14:25:00',2.98),('15844','2013-05-06','14:30:00',3.71),('15844','2013-05-06','14:35:00',2.73),('15844','2013-05-06','14:40:00',2.81),('15844','2013-05-06','14:45:00',3.57),('15844','2013-05-06','14:50:00',3.17),('15844','2013-05-06','14:55:00',2.26),('15844','2013-05-06','15:00:00',2.97),('15844','2013-05-06','15:05:00',1.64),('15844','2013-05-06','15:10:00',2.39),('15844','2013-05-06','15:15:00',1.83),('15844','2013-05-06','15:20:00',2.59),('15844','2013-05-06','15:25:00',2.45),('15844','2013-05-06','15:30:00',2.08),('15844','2013-05-06','15:35:00',2.13),('15844','2013-05-06','15:40:00',2.34),('15844','2013-05-06','15:45:00',2.11),('15844','2013-05-06','15:50:00',1.41),('15844','2013-05-06','15:55:00',1.67),('15844','2013-05-06','16:00:00',2.07),('15844','2013-05-06','16:05:00',1.41),('15844','2013-05-06','16:10:00',1.65),('15844','2013-05-06','16:15:00',1.9),('15844','2013-05-06','16:20:00',1.39),('15844','2013-05-06','16:25:00',1.68),('15844','2013-05-06','16:30:00',1.53),('15844','2013-05-06','16:40:00',1.39),('15844','2013-05-06','16:45:00',1.14),('15844','2013-05-06','17:10:00',1.21),('15844','2013-05-06','17:25:00',1.06),('15844','2013-05-05','08:20:00',1.11),('15844','2013-05-05','08:25:00',1.07),('15844','2013-05-05','08:30:00',1.14),('15844','2013-05-05','08:35:00',1.38),('15844','2013-05-05','08:40:00',1.59),('15844','2013-05-05','08:45:00',1.46),('15844','2013-05-05','08:50:00',1.33),('15844','2013-05-05','08:55:00',1.37),('15844','2013-05-05','09:00:00',1.48),('15844','2013-05-05','09:05:00',1.21),('15844','2013-05-05','09:10:00',1.22),('15844','2013-05-05','09:15:00',1.34),('15844','2013-05-05','09:20:00',1.75),('15844','2013-05-05','09:25:00',2.23),('15844','2013-05-05','09:30:00',2.13),('15844','2013-05-05','09:35:00',2.85),('15844','2013-05-05','09:40:00',2.84),('15844','2013-05-05','09:45:00',3.12),('15844','2013-05-05','09:50:00',2.7),('15844','2013-05-05','09:55:00',1.83),('15844','2013-05-05','10:00:00',1.84),('15844','2013-05-05','10:05:00',2.22),('15844','2013-05-05','10:10:00',2.55),('15844','2013-05-05','10:15:00',2.88),('15844','2013-05-05','10:20:00',3.22),('15844','2013-05-05','10:25:00',3.5),('15844','2013-05-05','10:30:00',2.4),('15844','2013-05-05','10:35:00',1.44),('15844','2013-05-05','10:40:00',1.23),('15844','2013-05-05','10:45:00',1.02),('15844','2013-05-05','11:00:00',1.23),('15844','2013-05-05','11:05:00',1.42),('15844','2013-05-05','11:10:00',3.82),('15844','2013-05-05','11:15:00',3.2),('15844','2013-05-05','11:20:00',1.69),('15844','2013-05-05','11:25:00',2.63),('15844','2013-05-05','11:30:00',2.32),('15844','2013-05-05','11:35:00',3.03),('15844','2013-05-05','11:40:00',4.24),('15844','2013-05-05','11:45:00',4.41),('15844','2013-05-05','11:50:00',3.46),('15844','2013-05-05','11:55:00',4.28),('15844','2013-05-05','12:00:00',4.77),('15844','2013-05-05','12:05:00',3.65),('15844','2013-05-05','12:10:00',4.44),('15844','2013-05-05','12:15:00',4.25),('15844','2013-05-05','12:20:00',4.31),('15844','2013-05-05','12:25:00',4.22),('15844','2013-05-05','12:30:00',3.73),('15844','2013-05-05','12:35:00',3.68),('15844','2013-05-05','12:40:00',3.38),('15844','2013-05-05','12:45:00',1.87),('15844','2013-05-05','12:50:00',2.23),('15844','2013-05-05','12:55:00',2.34),('15844','2013-05-05','13:00:00',2.77),('15844','2013-05-05','13:05:00',2.66),('15844','2013-05-05','13:10:00',1.45),('15844','2013-05-05','13:15:00',2.98),('15844','2013-05-05','13:20:00',3.84),('15844','2013-05-05','13:25:00',4.08),('15844','2013-05-05','13:30:00',4.21),('15844','2013-05-05','13:35:00',4),('15844','2013-05-05','13:40:00',1.88),('15844','2013-05-05','13:45:00',1.91),('15844','2013-05-05','13:50:00',3.65),('15844','2013-05-05','13:55:00',3.71),('15844','2013-05-05','14:00:00',3.92),('15844','2013-05-05','14:05:00',3.81),('15844','2013-05-05','14:10:00',3.78),('15844','2013-05-05','14:15:00',3.41),('15844','2013-05-05','14:20:00',3.14),('15844','2013-05-05','14:25:00',3.24),('15844','2013-05-05','14:30:00',3.13),('15844','2013-05-05','14:35:00',3.01),('15844','2013-05-05','14:40:00',2.91),('15844','2013-05-05','14:45:00',2.78),('15844','2013-05-05','14:50:00',2.64),('15844','2013-05-05','14:55:00',2.63),('15844','2013-05-05','15:00:00',2.56),('15844','2013-05-05','15:05:00',2.47),('15844','2013-05-05','15:10:00',2.39),('15844','2013-05-05','15:15:00',2.32),('15844','2013-05-05','15:20:00',2.24),('15844','2013-05-05','15:25:00',2.16),('15844','2013-05-05','15:30:00',2.08),('15844','2013-05-05','15:35:00',1.98),('15844','2013-05-05','15:40:00',1.91),('15844','2013-05-05','15:45:00',1.8),('15844','2013-05-05','15:50:00',1.7),('15844','2013-05-05','15:55:00',1.64),('15844','2013-05-05','16:00:00',1.55),('15844','2013-05-05','16:05:00',1.48),('15844','2013-05-05','16:10:00',1.41),('15844','2013-05-05','16:15:00',1.34),('15844','2013-05-05','16:20:00',1.28),('15844','2013-05-05','16:25:00',1.22),('15844','2013-05-05','16:30:00',1.14),('15844','2013-05-05','16:35:00',1.04),('15844','2013-05-04','08:25:00',1.09),('15844','2013-05-04','08:30:00',1.18),('15844','2013-05-04','08:35:00',1.26),('15844','2013-05-04','08:40:00',1.36),('15844','2013-05-04','08:45:00',1.43),('15844','2013-05-04','08:50:00',1.5),('15844','2013-05-04','08:55:00',1.55),('15844','2013-05-04','09:00:00',1.58),('15844','2013-05-04','09:05:00',1.7),('15844','2013-05-04','09:10:00',1.8),('15844','2013-05-04','09:15:00',1.88),('15844','2013-05-04','09:20:00',2),('15844','2013-05-04','09:25:00',2.13),('15844','2013-05-04','09:30:00',2.18),('15844','2013-05-04','09:35:00',2.21),('15844','2013-05-04','09:40:00',2.33),('15844','2013-05-04','09:45:00',2.38),('15844','2013-05-04','09:50:00',2.6),('15844','2013-05-04','09:55:00',2.79),('15844','2013-05-04','10:00:00',2.92),('15844','2013-05-04','10:05:00',2.93),('15844','2013-05-04','10:10:00',3.1),('15844','2013-05-04','10:15:00',3.19),('15844','2013-05-04','10:20:00',3.3),('15844','2013-05-04','10:25:00',3.37),('15844','2013-05-04','10:30:00',3.48),('15844','2013-05-04','10:35:00',3.47),('15844','2013-05-04','10:40:00',3.42),('15844','2013-05-04','10:45:00',3.43),('15844','2013-05-04','10:50:00',3.61),('15844','2013-05-04','10:55:00',3.71),('15844','2013-05-04','11:00:00',3.79),('15844','2013-05-04','11:05:00',3.8),('15844','2013-05-04','11:10:00',3.63),('15844','2013-05-04','11:15:00',3.34),('15844','2013-05-04','11:20:00',3.59),('15844','2013-05-04','11:25:00',3.68),('15844','2013-05-04','11:30:00',3.5),('15844','2013-05-04','11:35:00',3.55),('15844','2013-05-04','11:40:00',3.49),('15844','2013-05-04','11:45:00',3.46),('15844','2013-05-04','11:50:00',3.43),('15844','2013-05-04','11:55:00',3.46),('15844','2013-05-04','12:00:00',3.52),('15844','2013-05-04','12:05:00',3.45),('15844','2013-05-04','12:10:00',3.61),('15844','2013-05-04','12:15:00',3.76),('15844','2013-05-04','12:20:00',3.88),('15844','2013-05-04','12:25:00',3.88),('15844','2013-05-04','12:30:00',3.95),('15844','2013-05-04','12:35:00',3.9),('15844','2013-05-04','12:40:00',3.85),('15844','2013-05-04','12:45:00',3.84),('15844','2013-05-04','12:50:00',3.85),('15844','2013-05-04','12:55:00',3.71),('15844','2013-05-04','13:00:00',3.6),('15844','2013-05-04','13:05:00',3.6),('15844','2013-05-04','13:10:00',3.52),('15844','2013-05-04','13:15:00',3.69),('15844','2013-05-04','13:20:00',3.81),('15844','2013-05-04','13:25:00',3.71),('15844','2013-05-04','13:30:00',3.37),('15844','2013-05-04','13:35:00',3.46),('15844','2013-05-04','13:40:00',3.42),('15844','2013-05-04','13:45:00',3.19),('15844','2013-05-04','13:50:00',2.82),('15844','2013-05-04','13:55:00',3.29),('15844','2013-05-04','14:00:00',3.25),('15844','2013-05-04','14:05:00',3.12),('15844','2013-05-04','14:10:00',3.11),('15844','2013-05-04','14:15:00',3.12),('15844','2013-05-04','14:20:00',2.84),('15844','2013-05-04','14:25:00',2.8),('15844','2013-05-04','14:30:00',2.79),('15844','2013-05-04','14:35:00',2.55),('15844','2013-05-04','14:40:00',2.7),('15844','2013-05-04','14:45:00',2.45),('15844','2013-05-04','14:50:00',2.35),('15844','2013-05-04','14:55:00',2.38),('15844','2013-05-04','15:00:00',2.35),('15844','2013-05-04','15:05:00',2.27),('15844','2013-05-04','15:10:00',2.19),('15844','2013-05-04','15:15:00',2.23),('15844','2013-05-04','15:20:00',2.14),('15844','2013-05-04','15:25:00',2.11),('15844','2013-05-04','15:30:00',2.03),('15844','2013-05-04','15:35:00',1.86),('15844','2013-05-04','15:40:00',1.86),('15844','2013-05-04','15:45:00',1.74),('15844','2013-05-04','15:50:00',1.62),('15844','2013-05-04','15:55:00',1.55),('15844','2013-05-04','16:00:00',1.47),('15844','2013-05-04','16:05:00',1.38),('15844','2013-05-04','16:10:00',1.32),('15844','2013-05-04','16:15:00',1.27),('15844','2013-05-04','16:20:00',1.22),('15844','2013-05-04','16:25:00',1.16),('15844','2013-05-04','16:30:00',1.08),('15844','2013-05-03','08:25:00',1.02),('15844','2013-05-03','08:40:00',1),('15844','2013-05-03','08:45:00',1.22),('15844','2013-05-03','08:50:00',1.22),('15844','2013-05-03','08:55:00',1.18),('15844','2013-05-03','09:00:00',1.37),('15844','2013-05-03','09:05:00',1.65),('15844','2013-05-03','09:10:00',1.83),('15844','2013-05-03','09:15:00',1.97),('15844','2013-05-03','09:20:00',2.11),('15844','2013-05-03','09:25:00',2.24),('15844','2013-05-03','09:30:00',2.32),('15844','2013-05-03','09:35:00',2.39),('15844','2013-05-03','09:40:00',2.45),('15844','2013-05-03','09:45:00',2.49),('15844','2013-05-03','09:50:00',2.64),('15844','2013-05-03','09:55:00',2.83),('15844','2013-05-03','10:00:00',2.9),('15844','2013-05-03','10:05:00',3),('15844','2013-05-03','10:10:00',3.14),('15844','2013-05-03','10:15:00',3.26),('15844','2013-05-03','10:20:00',3.38),('15844','2013-05-03','10:25:00',3.5),('15844','2013-05-03','10:30:00',3.58),('15844','2013-05-03','10:35:00',3.63),('15844','2013-05-03','10:40:00',3.66),('15844','2013-05-03','10:45:00',3.83),('15844','2013-05-03','10:50:00',3.91),('15844','2013-05-03','10:55:00',3.95),('15844','2013-05-03','11:00:00',3.96),('15844','2013-05-03','11:05:00',4.02),('15844','2013-05-03','11:10:00',4.07),('15844','2013-05-03','11:15:00',4.11),('15844','2013-05-03','11:20:00',4.11),('15844','2013-05-03','11:25:00',4.16),('15844','2013-05-03','11:30:00',4.2),('15844','2013-05-03','11:35:00',4.19),('15844','2013-05-03','11:40:00',4.15),('15844','2013-05-03','11:45:00',4.17),('15844','2013-05-03','11:50:00',4.19),('15844','2013-05-03','11:55:00',4.18),('15844','2013-05-03','12:00:00',4.18),('15844','2013-05-03','12:05:00',4.18),('15844','2013-05-03','12:10:00',4.2),('15844','2013-05-03','12:15:00',4.19),('15844','2013-05-03','12:20:00',4.13),('15844','2013-05-03','12:25:00',4.12),('15844','2013-05-03','12:30:00',4.11),('15844','2013-05-03','12:35:00',4.11),('15844','2013-05-03','12:40:00',4.08),('15844','2013-05-03','12:45:00',3.91),('15844','2013-05-03','12:50:00',4.04),('15844','2013-05-03','12:55:00',4),('15844','2013-05-03','13:00:00',4.01),('15844','2013-05-03','13:05:00',4),('15844','2013-05-03','13:10:00',3.97),('15844','2013-05-03','13:15:00',3.94),('15844','2013-05-03','13:20:00',3.91),('15844','2013-05-03','13:25:00',3.9),('15844','2013-05-03','13:30:00',3.76),('15844','2013-05-03','13:35:00',3.69),('15844','2013-05-03','13:40:00',3.75),('15844','2013-05-03','13:45:00',3.71),('15844','2013-05-03','13:50:00',3.66),('15844','2013-05-03','13:55:00',3.63),('15844','2013-05-03','14:00:00',3.34),('15844','2013-05-03','14:05:00',3.24),('15844','2013-05-03','14:10:00',3.41),('15844','2013-05-03','14:15:00',3.29),('15844','2013-05-03','14:20:00',3.24),('15844','2013-05-03','14:25:00',3.16),('15844','2013-05-03','14:30:00',3.03),('15844','2013-05-03','14:35:00',2.9),('15844','2013-05-03','14:40:00',2.79),('15844','2013-05-03','14:45:00',2.69),('15844','2013-05-03','14:50:00',2.6),('15844','2013-05-03','14:55:00',2.51),('15844','2013-05-03','15:00:00',2.42),('15844','2013-05-03','15:05:00',2.35),('15844','2013-05-03','15:10:00',2.28),('15844','2013-05-03','15:15:00',2.22),('15844','2013-05-03','15:20:00',2.13),('15844','2013-05-03','15:25:00',2.08),('15844','2013-05-03','15:30:00',2.01),('15844','2013-05-03','15:35:00',1.91),('15844','2013-05-03','15:40:00',1.82),('15844','2013-05-03','15:45:00',1.72),('15844','2013-05-03','15:50:00',1.62),('15844','2013-05-03','15:55:00',1.54),('15844','2013-05-03','16:00:00',1.46),('15844','2013-05-03','16:05:00',1.37),('15844','2013-05-03','16:10:00',1.3),('15844','2013-05-03','16:15:00',1.24),('15844','2013-05-03','16:20:00',1.21),('15844','2013-05-03','16:25:00',1.18),('15844','2013-05-03','16:30:00',1.1),('15844','2013-05-03','16:35:00',1.01),('15844','2013-05-02','08:55:00',1.04),('15844','2013-05-02','09:25:00',1.3),('15844','2013-05-02','09:30:00',1.58),('15844','2013-05-02','09:35:00',1.26),('15844','2013-05-02','09:40:00',1.49),('15844','2013-05-02','09:45:00',1.35),('15844','2013-05-02','09:50:00',1.71),('15844','2013-05-02','09:55:00',1.15),('15844','2013-05-02','10:05:00',1.3),('15844','2013-05-02','10:15:00',2.81),('15844','2013-05-02','10:20:00',1.31),('15844','2013-05-02','10:25:00',1.95),('15844','2013-05-02','10:30:00',3.12),('15844','2013-05-02','10:35:00',3.81),('15844','2013-05-02','10:40:00',3.12),('15844','2013-05-02','10:45:00',2.44),('15844','2013-05-02','10:50:00',2.63),('15844','2013-05-02','10:55:00',3.15),('15844','2013-05-02','11:00:00',3.46),('15844','2013-05-02','11:05:00',4.21),('15844','2013-05-02','11:10:00',3.1),('15844','2013-05-02','11:15:00',3.17),('15844','2013-05-02','11:20:00',3.33),('15844','2013-05-02','11:25:00',4.04),('15844','2013-05-02','11:30:00',4.49),('15844','2013-05-02','11:35:00',4.22),('15844','2013-05-02','11:40:00',4.15),('15844','2013-05-02','11:45:00',4.15),('15844','2013-05-02','11:50:00',4.09),('15844','2013-05-02','11:55:00',4.09),('15844','2013-05-02','12:00:00',4.1),('15844','2013-05-02','12:05:00',4.07),('15844','2013-05-02','12:10:00',4.07),('15844','2013-05-02','12:15:00',4.04),('15844','2013-05-02','12:20:00',4.02),('15844','2013-05-02','12:25:00',3.98),('15844','2013-05-02','12:30:00',4.01),('15844','2013-05-02','12:35:00',2.87),('15844','2013-05-02','12:40:00',3.76),('15844','2013-05-02','12:45:00',4.09),('15844','2013-05-02','12:50:00',4.03),('15844','2013-05-02','12:55:00',4.09),('15844','2013-05-02','13:00:00',4.05),('15844','2013-05-02','13:05:00',4.05),('15844','2013-05-02','13:10:00',4.03),('15844','2013-05-02','13:15:00',4.01),('15844','2013-05-02','13:20:00',3.97),('15844','2013-05-02','13:25:00',3.94),('15844','2013-05-02','13:30:00',3.92),('15844','2013-05-02','13:35:00',3.87),('15844','2013-05-02','13:40:00',3.81),('15844','2013-05-02','13:45:00',3.77),('15844','2013-05-02','13:50:00',3.68),('15844','2013-05-02','13:55:00',3.57),('15844','2013-05-02','14:00:00',3.51),('15844','2013-05-02','14:05:00',3.48),('15844','2013-05-02','14:10:00',3.44),('15844','2013-05-02','14:15:00',3.37),('15844','2013-05-02','14:20:00',3.3),('15844','2013-05-02','14:25:00',3.19),('15844','2013-05-02','14:30:00',3.08),('15844','2013-05-02','14:35:00',2.98),('15844','2013-05-02','14:40:00',2.86),('15844','2013-05-02','14:45:00',2.73),('15844','2013-05-02','14:50:00',2.6),('15844','2013-05-02','14:55:00',2.49),('15844','2013-05-02','15:00:00',2.38),('15844','2013-05-02','15:05:00',2.33),('15844','2013-05-02','15:10:00',2.33),('15844','2013-05-02','15:15:00',2.27),('15844','2013-05-02','15:20:00',2.2),('15844','2013-05-02','15:25:00',2.12),('15844','2013-05-02','15:30:00',2.03),('15844','2013-05-02','15:35:00',1.95),('15844','2013-05-02','15:40:00',1.85),('15844','2013-05-02','15:45:00',1.73),('15844','2013-05-02','15:50:00',1.63),('15844','2013-05-02','15:55:00',1.56),('15844','2013-05-02','16:00:00',1.46),('15844','2013-05-02','16:05:00',1.36),('15844','2013-05-02','16:10:00',1.28),('15844','2013-05-02','16:15:00',1.26),('15844','2013-05-02','16:20:00',1.23),('15844','2013-05-02','16:25:00',1.19),('15844','2013-05-02','16:30:00',1.1),('15844','2013-05-02','16:35:00',1),('15844','2014-03-30','08:50:00',1.01),('15844','2014-03-30','08:55:00',1.04),('15844','2014-03-30','09:00:00',1.08),('15844','2014-03-30','09:05:00',1.14),('15844','2014-03-30','09:10:00',1.28),('15844','2014-03-30','09:15:00',1.39),('15844','2014-03-30','09:20:00',1.44),('15844','2014-03-30','09:25:00',1.68),('15844','2014-03-30','09:30:00',1.69),('15844','2014-03-30','09:35:00',1.78),('15844','2014-03-30','09:40:00',1.83),('15844','2014-03-30','09:45:00',1.94),('15844','2014-03-30','09:50:00',1.99),('15844','2014-03-30','09:55:00',2.13),('15844','2014-03-30','10:00:00',2.26),('15844','2014-03-30','10:05:00',2.45),('15844','2014-03-30','10:10:00',2.53),('15844','2014-03-30','10:15:00',2.55),('15844','2014-03-30','10:20:00',2.59),('15844','2014-03-30','10:25:00',2.66),('15844','2014-03-30','10:30:00',2.79),('15844','2014-03-30','10:35:00',2.82),('15844','2014-03-30','10:40:00',2.94),('15844','2014-03-30','10:45:00',2.97),('15844','2014-03-30','10:50:00',3),('15844','2014-03-30','10:55:00',3.05),('15844','2014-03-30','11:00:00',3.13),('15844','2014-03-30','11:05:00',3.05),('15844','2014-03-30','11:10:00',2.9),('15844','2014-03-30','11:15:00',2.87),('15844','2014-03-30','11:20:00',3.2),('15844','2014-03-30','11:25:00',3.28),('15844','2014-03-30','11:30:00',3.5),('15844','2014-03-30','11:35:00',3.65),('15844','2014-03-30','11:40:00',3.71),('15844','2014-03-30','11:45:00',3.68),('15844','2014-03-30','11:50:00',3.67),('15844','2014-03-30','11:55:00',3.68),('15844','2014-03-30','12:00:00',3.8),('15844','2014-03-30','12:05:00',3.76),('15844','2014-03-30','12:10:00',3.87),('15844','2014-03-30','12:15:00',3.87),('15844','2014-03-30','12:20:00',3.69),('15844','2014-03-30','12:25:00',3.78),('15844','2014-03-30','12:30:00',3.79),('15844','2014-03-30','12:35:00',3.73),('15844','2014-03-30','12:40:00',3.69),('15844','2014-03-30','12:45:00',3.65),('15844','2014-03-30','12:50:00',3.66),('15844','2014-03-30','12:55:00',3.65),('15844','2014-03-30','13:00:00',3.66),('15844','2014-03-30','13:05:00',3.64),('15844','2014-03-30','13:10:00',3.7),('15844','2014-03-30','13:15:00',3.72),('15844','2014-03-30','13:20:00',3.68),('15844','2014-03-30','13:25:00',3.68),('15844','2014-03-30','13:30:00',3.6),('15844','2014-03-30','13:35:00',3.59),('15844','2014-03-30','13:40:00',3.56),('15844','2014-03-30','13:45:00',3.49),('15844','2014-03-30','13:50:00',3.4),('15844','2014-03-30','13:55:00',3.34),('15844','2014-03-30','14:00:00',3.29),('15844','2014-03-30','14:05:00',2.92),('15844','2014-03-30','14:10:00',2.71),('15844','2014-03-30','14:15:00',2.76),('15844','2014-03-30','14:20:00',2.58),('15844','2014-03-30','14:25:00',2.14),('15844','2014-03-30','14:30:00',1.67),('15844','2014-03-30','14:35:00',1.51),('15844','2014-03-30','14:40:00',1.59),('15844','2014-03-30','14:45:00',1.53),('15844','2014-03-30','14:50:00',1.88),('15844','2014-03-30','14:55:00',2.05),('15844','2014-03-30','15:00:00',1.97),('15844','2014-03-30','15:05:00',1.94),('15844','2014-03-30','15:10:00',1.94),('15844','2014-03-30','15:15:00',1.88),('15844','2014-03-30','15:20:00',1.82),('15844','2014-03-30','15:25:00',1.7),('15844','2014-03-30','15:30:00',1.64),('15844','2014-03-30','15:35:00',1.53),('15844','2014-03-30','15:40:00',1.51),('15844','2014-03-30','15:45:00',1.49),('15844','2014-03-30','15:50:00',1.43),('15844','2014-03-30','15:55:00',1.41),('15844','2014-03-30','16:00:00',1.36),('15844','2014-03-30','16:05:00',1.3),('15844','2014-03-30','16:10:00',1.17),('15844','2014-03-30','16:15:00',1.12),('15844','2014-03-30','16:20:00',1.09),('15844','2013-05-01','08:30:00',1.02),('15844','2013-05-01','08:35:00',1.07),('15844','2013-05-01','08:40:00',1.13),('15844','2013-05-01','08:45:00',1.21),('15844','2013-05-01','08:50:00',1.29),('15844','2013-05-01','08:55:00',1.4),('15844','2013-05-01','09:00:00',1.51),('15844','2013-05-01','09:05:00',1.57),('15844','2013-05-01','09:10:00',1.64),('15844','2013-05-01','09:15:00',1.75),('15844','2013-05-01','09:20:00',1.84),('15844','2013-05-01','09:25:00',1.86),('15844','2013-05-01','09:30:00',1.98),('15844','2013-05-01','09:35:00',2.06),('15844','2013-05-01','09:40:00',2.19),('15844','2013-05-01','09:45:00',2.33),('15844','2013-05-01','09:50:00',2.39),('15844','2013-05-01','09:55:00',2.5),('15844','2013-05-01','10:00:00',2.6);
INSERT INTO `solarlog` VALUES ('15844','2013-05-01','10:05:00',2.72),('15844','2013-05-01','10:10:00',2.83),('15844','2013-05-01','10:15:00',2.94),('15844','2013-05-01','10:20:00',3.05),('15844','2013-05-01','10:25:00',3.13),('15844','2013-05-01','10:30:00',3.29),('15844','2013-05-01','10:35:00',3.41),('15844','2013-05-01','10:40:00',3.51),('15844','2013-05-01','10:45:00',3.6),('15844','2013-05-01','10:50:00',3.68),('15844','2013-05-01','10:55:00',3.75),('15844','2013-05-01','11:00:00',3.77),('15844','2013-05-01','11:05:00',3.75),('15844','2013-05-01','11:10:00',3.53),('15844','2013-05-01','11:15:00',3.86),('15844','2013-05-01','11:20:00',3.49),('15844','2013-05-01','11:25:00',3.64),('15844','2013-05-01','11:30:00',3.48),('15844','2013-05-01','11:35:00',3.43),('15844','2013-05-01','11:40:00',2.29),('15844','2013-05-01','11:45:00',3.74),('15844','2013-05-01','11:50:00',4.02),('15844','2013-05-01','11:55:00',3.96),('15844','2013-05-01','12:00:00',3.91),('15844','2013-05-01','12:05:00',3.9),('15844','2013-05-01','12:10:00',3.82),('15844','2013-05-01','12:15:00',3.8),('15844','2013-05-01','12:20:00',3.76),('15844','2013-05-01','12:25:00',3.79),('15844','2013-05-01','12:30:00',3.82),('15844','2013-05-01','12:35:00',3.87),('15844','2013-05-01','12:40:00',3.44),('15844','2013-05-01','12:45:00',2.26),('15844','2013-05-01','12:50:00',1.31),('15844','2013-05-01','12:55:00',1.18),('15844','2013-05-01','13:00:00',1.35),('15844','2013-05-01','13:05:00',2.11),('15844','2013-05-01','13:10:00',4.06),('15844','2013-05-01','13:15:00',4.22),('15844','2013-05-01','13:20:00',4.14),('15844','2013-05-01','13:25:00',3.02),('15844','2013-05-01','13:30:00',2.48),('15844','2013-05-01','13:35:00',4.16),('15844','2013-05-01','13:40:00',3.97),('15844','2013-05-01','13:45:00',3.51),('15844','2013-05-01','13:50:00',3.61),('15844','2013-05-01','13:55:00',3.48),('15844','2013-05-01','14:00:00',3.41),('15844','2013-05-01','14:05:00',3.23),('15844','2013-05-01','14:10:00',3.28),('15844','2013-05-01','14:15:00',2.91),('15844','2013-05-01','14:20:00',3.26),('15844','2013-05-01','14:25:00',3.15),('15844','2013-05-01','14:30:00',3.18),('15844','2013-05-01','14:35:00',2.95),('15844','2013-05-01','14:40:00',2.64),('15844','2013-05-01','14:45:00',2.78),('15844','2013-05-01','14:50:00',2.64),('15844','2013-05-01','14:55:00',2.09),('15844','2013-05-01','15:00:00',1.84),('15844','2013-05-01','15:05:00',2.43),('15844','2013-05-01','15:10:00',2.5),('15844','2013-05-01','15:15:00',2.33),('15844','2013-05-01','15:20:00',2.12),('15844','2013-05-01','15:25:00',1.84),('15844','2013-05-01','15:30:00',1.56),('15844','2013-05-01','15:35:00',1.53),('15844','2013-05-01','15:40:00',1.6),('15844','2013-05-01','15:45:00',1.5),('15844','2013-05-01','15:50:00',1.33),('15844','2013-05-01','15:55:00',1.36),('15844','2013-05-01','16:00:00',1.48),('15844','2013-05-01','16:05:00',1.4),('15844','2013-05-01','16:10:00',1.29),('15844','2013-05-01','16:15:00',1.22),('15844','2013-05-01','16:20:00',1.11),('15844','2013-04-30','08:50:00',1.28),('15844','2013-04-30','08:55:00',1.42),('15844','2013-04-30','09:00:00',1.53),('15844','2013-04-30','09:05:00',1.17),('15844','2013-04-30','09:10:00',1.63),('15844','2013-04-30','09:15:00',1.85),('15844','2013-04-30','09:20:00',1.7),('15844','2013-04-30','09:25:00',1.8),('15844','2013-04-30','09:30:00',1.73),('15844','2013-04-30','09:35:00',1.95),('15844','2013-04-30','09:40:00',1.75),('15844','2013-04-30','09:45:00',1.88),('15844','2013-04-30','09:50:00',2.32),('15844','2013-04-30','09:55:00',2.74),('15844','2013-04-30','10:00:00',2.83),('15844','2013-04-30','10:05:00',2.13),('15844','2013-04-30','10:10:00',2.13),('15844','2013-04-30','10:15:00',1.99),('15844','2013-04-30','10:20:00',1.66),('15844','2013-04-30','10:25:00',2),('15844','2013-04-30','10:30:00',2.14),('15844','2013-04-30','10:35:00',1.55),('15844','2013-04-30','10:40:00',1.39),('15844','2013-04-30','10:45:00',1.4),('15844','2013-04-30','10:50:00',1.34),('15844','2013-04-30','10:55:00',1.68),('15844','2013-04-30','11:00:00',2.02),('15844','2013-04-30','11:05:00',1.98),('15844','2013-04-30','11:10:00',2.28),('15844','2013-04-30','11:15:00',2.26),('15844','2013-04-30','11:20:00',2.26),('15844','2013-04-30','11:25:00',2.07),('15844','2013-04-30','11:30:00',2.08),('15844','2013-04-30','11:35:00',2.02),('15844','2013-04-30','11:40:00',1.64),('15844','2013-04-30','11:45:00',1.29),('15844','2013-04-30','11:50:00',1.32),('15844','2013-04-30','11:55:00',1.36),('15844','2013-04-30','12:00:00',1.71),('15844','2013-04-30','12:05:00',1.49),('15844','2013-04-30','12:10:00',1.62),('15844','2013-04-30','12:15:00',1.77),('15844','2013-04-30','12:20:00',1.75),('15844','2013-04-30','12:25:00',1.35),('15844','2013-04-30','12:30:00',1.56),('15844','2013-04-30','12:35:00',2.97),('15844','2013-04-30','12:40:00',4.53),('15844','2013-04-30','12:45:00',4.04),('15844','2013-04-30','12:50:00',3.72),('15844','2013-04-30','12:55:00',3.69),('15844','2013-04-30','13:00:00',3.85),('15844','2013-04-30','13:05:00',3.89),('15844','2013-04-30','13:10:00',3.83),('15844','2013-04-30','13:15:00',3.76),('15844','2013-04-30','13:20:00',3.7),('15844','2013-04-30','13:25:00',3.65),('15844','2013-04-30','13:30:00',3.6),('15844','2013-04-30','13:35:00',3.58),('15844','2013-04-30','13:40:00',3.55),('15844','2013-04-30','13:45:00',3.48),('15844','2013-04-30','13:50:00',3.42),('15844','2013-04-30','13:55:00',3.35),('15844','2013-04-30','14:00:00',3.31),('15844','2013-04-30','14:05:00',3.25),('15844','2013-04-30','14:10:00',3.2),('15844','2013-04-30','14:15:00',3.13),('15844','2013-04-30','14:20:00',3.06),('15844','2013-04-30','14:25:00',3),('15844','2013-04-30','14:30:00',2.9),('15844','2013-04-30','14:35:00',2.8),('15844','2013-04-30','14:40:00',2.69),('15844','2013-04-30','14:45:00',2.59),('15844','2013-04-30','14:50:00',2.5),('15844','2013-04-30','14:55:00',2.39),('15844','2013-04-30','15:00:00',2.3),('15844','2013-04-30','15:05:00',2.19),('15844','2013-04-30','15:10:00',2.13),('15844','2013-04-30','15:15:00',2.05),('15844','2013-04-30','15:20:00',1.98),('15844','2013-04-30','15:25:00',1.93),('15844','2013-04-30','15:30:00',1.88),('15844','2013-04-30','15:35:00',1.8),('15844','2013-04-30','15:40:00',1.73),('15844','2013-04-30','15:45:00',1.67),('15844','2013-04-30','15:50:00',1.61),('15844','2013-04-30','15:55:00',1.54),('15844','2013-04-30','16:00:00',1.49),('15844','2013-04-30','16:05:00',1.41),('15844','2013-04-30','16:10:00',1.34),('15844','2013-04-30','16:15:00',1.29),('15844','2013-04-30','16:20:00',1.26),('15844','2013-04-30','16:25:00',1.22),('15844','2013-04-30','16:30:00',1.07),('15844','2013-04-30','16:35:00',1.12),('15844','2013-04-30','16:40:00',1.03),('15844','2013-04-29','08:20:00',1.04),('15844','2013-04-29','08:25:00',1.21),('15844','2013-04-29','08:30:00',1.37),('15844','2013-04-29','08:35:00',1.4),('15844','2013-04-29','08:40:00',1.34),('15844','2013-04-29','08:45:00',1.45),('15844','2013-04-29','08:50:00',1.55),('15844','2013-04-29','08:55:00',1.56),('15844','2013-04-29','09:00:00',1.58),('15844','2013-04-29','09:05:00',1.84),('15844','2013-04-29','09:10:00',1.9),('15844','2013-04-29','09:15:00',1.79),('15844','2013-04-29','09:20:00',1.88),('15844','2013-04-29','09:25:00',2),('15844','2013-04-29','09:30:00',1.94),('15844','2013-04-29','09:35:00',2.05),('15844','2013-04-29','09:40:00',2.04),('15844','2013-04-29','09:45:00',2.29),('15844','2013-04-29','09:50:00',2.21),('15844','2013-04-29','09:55:00',2.33),('15844','2013-04-29','10:00:00',2.58),('15844','2013-04-29','10:05:00',2.49),('15844','2013-04-29','10:10:00',2.24),('15844','2013-04-29','10:15:00',2.54),('15844','2013-04-29','10:20:00',3.18),('15844','2013-04-29','10:25:00',3.13),('15844','2013-04-29','10:30:00',3.11),('15844','2013-04-29','10:35:00',3.04),('15844','2013-04-29','10:40:00',2.98),('15844','2013-04-29','10:45:00',2.86),('15844','2013-04-29','10:50:00',3.14),('15844','2013-04-29','10:55:00',3.21),('15844','2013-04-29','11:00:00',3.14),('15844','2013-04-29','11:05:00',2.93),('15844','2013-04-29','11:10:00',3.34),('15844','2013-04-29','11:15:00',3.59),('15844','2013-04-29','11:20:00',3.9),('15844','2013-04-29','11:25:00',3.76),('15844','2013-04-29','11:30:00',3.69),('15844','2013-04-29','11:35:00',3.63),('15844','2013-04-29','11:40:00',3.24),('15844','2013-04-29','11:45:00',3.79),('15844','2013-04-29','11:50:00',3.75),('15844','2013-04-29','11:55:00',4.01),('15844','2013-04-29','12:00:00',3.96),('15844','2013-04-29','12:05:00',3.87),('15844','2013-04-29','12:10:00',3.89),('15844','2013-04-29','12:15:00',3.93),('15844','2013-04-29','12:20:00',3.94),('15844','2013-04-29','12:25:00',4.01),('15844','2013-04-29','12:30:00',3.97),('15844','2013-04-29','12:35:00',3.89),('15844','2013-04-29','12:40:00',3.82),('15844','2013-04-29','12:45:00',3.71),('15844','2013-04-29','12:50:00',3.62),('15844','2013-04-29','12:55:00',3.68),('15844','2013-04-29','13:00:00',3.68),('15844','2013-04-29','13:05:00',3.5),('15844','2013-04-29','13:10:00',3.33),('15844','2013-04-29','13:15:00',3.38),('15844','2013-04-29','13:20:00',3.82),('15844','2013-04-29','13:25:00',3.79),('15844','2013-04-29','13:30:00',3.69),('15844','2013-04-29','13:35:00',3.64),('15844','2013-04-29','13:40:00',3.46),('15844','2013-04-29','13:45:00',3.29),('15844','2013-04-29','13:50:00',3.3),('15844','2013-04-29','13:55:00',3.41),('15844','2013-04-29','14:00:00',3.17),('15844','2013-04-29','14:05:00',3.32),('15844','2013-04-29','14:10:00',3.32),('15844','2013-04-29','14:15:00',3.34),('15844','2013-04-29','14:20:00',3.16),('15844','2013-04-29','14:25:00',2.9),('15844','2013-04-29','14:30:00',2.8),('15844','2013-04-29','14:35:00',2.67),('15844','2013-04-29','14:40:00',2.66),('15844','2013-04-29','14:45:00',2.71),('15844','2013-04-29','14:50:00',2.53),('15844','2013-04-29','14:55:00',2.38),('15844','2013-04-29','15:00:00',2.24),('15844','2013-04-29','15:05:00',2.08),('15844','2013-04-29','15:10:00',2.34),('15844','2013-04-29','15:15:00',2.23),('15844','2013-04-29','15:20:00',2.17),('15844','2013-04-29','15:25:00',1.98),('15844','2013-04-29','15:30:00',1.77),('15844','2013-04-29','15:35:00',1.73),('15844','2013-04-29','15:40:00',1.59),('15844','2013-04-29','15:45:00',1.57),('15844','2013-04-29','15:50:00',1.63),('15844','2013-04-29','15:55:00',1.67),('15844','2013-04-29','16:00:00',1.69),('15844','2013-04-29','16:05:00',1.72),('15844','2013-04-29','16:10:00',1.7),('15844','2013-04-29','16:15:00',1.65),('15844','2013-04-29','16:20:00',1.38),('15844','2013-04-29','16:25:00',1.42),('15844','2013-04-29','16:30:00',1.36),('15844','2013-04-29','16:35:00',1.39),('15844','2013-04-29','16:40:00',1.21),('15844','2013-04-29','16:45:00',1.13),('15844','2013-04-29','16:50:00',1.04),('15844','2013-04-28','08:25:00',1.07),('15844','2013-04-28','08:30:00',1.19),('15844','2013-04-28','08:35:00',1.28),('15844','2013-04-28','08:40:00',1.34),('15844','2013-04-28','08:45:00',1.41),('15844','2013-04-28','08:50:00',1.5),('15844','2013-04-28','08:55:00',1.57),('15844','2013-04-28','09:00:00',1.65),('15844','2013-04-28','09:05:00',1.75),('15844','2013-04-28','09:10:00',1.84),('15844','2013-04-28','09:15:00',1.96),('15844','2013-04-28','09:20:00',2.09),('15844','2013-04-28','09:25:00',2.21),('15844','2013-04-28','09:30:00',2.3),('15844','2013-04-28','09:35:00',2.38),('15844','2013-04-28','09:40:00',2.45),('15844','2013-04-28','09:45:00',2.49),('15844','2013-04-28','09:50:00',2.6),('15844','2013-04-28','09:55:00',2.8),('15844','2013-04-28','10:00:00',2.9),('15844','2013-04-28','10:05:00',2.96),('15844','2013-04-28','10:10:00',3.07),('15844','2013-04-28','10:15:00',3.23),('15844','2013-04-28','10:20:00',3.33),('15844','2013-04-28','10:25:00',3.17),('15844','2013-04-28','10:30:00',3.24),('15844','2013-04-28','10:35:00',3.6),('15844','2013-04-28','10:40:00',3.23),('15844','2013-04-28','10:45:00',3.75),('15844','2013-04-28','10:50:00',3.9),('15844','2013-04-28','10:55:00',3.97),('15844','2013-04-28','11:00:00',4.02),('15844','2013-04-28','11:05:00',4.09),('15844','2013-04-28','11:10:00',4.02),('15844','2013-04-28','11:15:00',4.15),('15844','2013-04-28','11:20:00',4.07),('15844','2013-04-28','11:25:00',4.15),('15844','2013-04-28','11:30:00',4.13),('15844','2013-04-28','11:35:00',3.89),('15844','2013-04-28','11:40:00',3.9),('15844','2013-04-28','11:45:00',3.78),('15844','2013-04-28','11:50:00',3.91),('15844','2013-04-28','11:55:00',3.51),('15844','2013-04-28','12:00:00',3.34),('15844','2013-04-28','12:05:00',3.46),('15844','2013-04-28','12:10:00',3.69),('15844','2013-04-28','12:15:00',3.48),('15844','2013-04-28','12:20:00',3.69),('15844','2013-04-28','12:25:00',3.63),('15844','2013-04-28','12:30:00',3.44),('15844','2013-04-28','12:35:00',3.47),('15844','2013-04-28','12:40:00',2.87),('15844','2013-04-28','12:45:00',3.57),('15844','2013-04-28','12:50:00',3.84),('15844','2013-04-28','12:55:00',3.63),('15844','2013-04-28','13:00:00',3.73),('15844','2013-04-28','13:10:00',2.33),('15844','2013-04-28','13:15:00',3.38),('15844','2013-04-28','13:20:00',3.73),('15844','2013-04-28','13:25:00',3.36),('15844','2013-04-28','13:30:00',3.52),('15844','2013-04-28','13:35:00',3.94),('15844','2013-04-28','13:40:00',3.76),('15844','2013-04-28','13:45:00',3.64),('15844','2013-04-28','13:50:00',3.67),('15844','2013-04-28','13:55:00',3.66),('15844','2013-04-28','14:00:00',3.61),('15844','2013-04-28','14:05:00',3.49),('15844','2013-04-28','14:10:00',3.4),('15844','2013-04-28','14:15:00',3.32),('15844','2013-04-28','14:20:00',2.31),('15844','2013-04-28','14:25:00',3.03),('15844','2013-04-28','14:30:00',3.09),('15844','2013-04-28','14:35:00',2.99),('15844','2013-04-28','14:40:00',2.8),('15844','2013-04-28','14:45:00',2.33),('15844','2013-04-28','14:50:00',2.52),('15844','2013-04-28','14:55:00',2.56),('15844','2013-04-28','15:00:00',2.54),('15844','2013-04-28','15:05:00',2.42),('15844','2013-04-28','15:10:00',2.35),('15844','2013-04-28','15:15:00',2.26),('15844','2013-04-28','15:20:00',2.18),('15844','2013-04-28','15:25:00',2.09),('15844','2013-04-28','15:30:00',2),('15844','2013-04-28','15:35:00',1.9),('15844','2013-04-28','15:40:00',1.8),('15844','2013-04-28','15:45:00',1.7),('15844','2013-04-28','15:50:00',1.6),('15844','2013-04-28','15:55:00',1.5),('15844','2013-04-28','16:00:00',1.41),('15844','2013-04-28','16:05:00',1.3),('15844','2013-04-28','16:10:00',1.2),('15844','2013-04-28','16:15:00',1.21),('15844','2013-04-28','16:20:00',1.14),('15844','2013-04-28','16:25:00',1.07),('15844','2013-04-27','12:55:00',1.19),('15844','2013-04-27','13:10:00',1.02),('15844','2013-04-27','13:15:00',1.87),('15844','2013-04-27','13:20:00',1.61),('15844','2013-04-27','14:30:00',1.69),('15844','2013-04-27','14:35:00',1.38),('15844','2013-04-27','16:50:00',1.01),('15844','2013-04-27','16:55:00',1.09),('15844','2013-04-27','17:00:00',1.3),('15844','2013-04-26','08:35:00',1.03),('15844','2013-04-26','08:40:00',1.08),('15844','2013-04-26','08:45:00',1.3),('15844','2013-04-26','08:50:00',1.45),('15844','2013-04-26','08:55:00',1.32),('15844','2013-04-26','09:00:00',1.35),('15844','2013-04-26','09:05:00',1.17),('15844','2013-04-26','09:10:00',1.22),('15844','2013-04-26','09:15:00',1.49),('15844','2013-04-26','09:20:00',1.67),('15844','2013-04-26','09:25:00',1.95),('15844','2013-04-26','09:30:00',1.67),('15844','2013-04-26','09:35:00',2.13),('15844','2013-04-26','09:40:00',1.97),('15844','2013-04-26','09:45:00',1.19),('15844','2013-04-26','09:50:00',1.95),('15844','2013-04-26','09:55:00',1.63),('15844','2013-04-26','10:00:00',2.45),('15844','2013-04-26','10:05:00',2.77),('15844','2013-04-26','10:10:00',2.81),('15844','2013-04-26','10:15:00',2.95),('15844','2013-04-26','10:20:00',2.98),('15844','2013-04-26','10:25:00',3.23),('15844','2013-04-26','10:30:00',3.34),('15844','2013-04-26','10:35:00',3.43),('15844','2013-04-26','10:40:00',3.17),('15844','2013-04-26','10:45:00',2.44),('15844','2013-04-26','10:50:00',3.23),('15844','2013-04-26','10:55:00',3.73),('15844','2013-04-26','11:00:00',3.7),('15844','2013-04-26','11:05:00',3.7),('15844','2013-04-26','11:10:00',3.68),('15844','2013-04-26','11:15:00',3.83),('15844','2013-04-26','11:20:00',3.59),('15844','2013-04-26','11:25:00',2.93),('15844','2013-04-26','11:30:00',3.9),('15844','2013-04-26','11:35:00',3.39),('15844','2013-04-26','11:40:00',2.78),('15844','2013-04-26','11:45:00',2.98),('15844','2013-04-26','11:50:00',3.55),('15844','2013-04-26','11:55:00',3.06),('15844','2013-04-26','12:00:00',2.25),('15844','2013-04-26','12:05:00',2.57),('15844','2013-04-26','12:10:00',2.33),('15844','2013-04-26','12:15:00',1.84),('15844','2013-04-26','12:20:00',2.05),('15844','2013-04-26','12:25:00',1.42),('15844','2013-04-26','12:30:00',1.48),('15844','2013-04-26','12:35:00',1.79),('15844','2013-04-26','12:40:00',1.98),('15844','2013-04-26','12:45:00',2.38),('15844','2013-04-26','12:50:00',1.66),('15844','2013-04-26','12:55:00',1.08),('15844','2013-04-26','13:05:00',1.03),('15844','2013-04-26','13:10:00',1.66),('15844','2013-04-26','13:15:00',2.03),('15844','2013-04-26','13:20:00',2.78),('15844','2013-04-26','13:25:00',3.7),('15844','2013-04-26','13:30:00',2.67),('15844','2013-04-26','13:35:00',2.11),('15844','2013-04-26','13:40:00',1.98),('15844','2013-04-26','13:45:00',2.84),('15844','2013-04-26','13:50:00',2.91),('15844','2013-04-26','13:55:00',2.33),('15844','2013-04-26','14:00:00',1.97),('15844','2013-04-26','14:05:00',2.07),('15844','2013-04-26','14:10:00',2.36),('15844','2013-04-26','14:15:00',1.96),('15844','2013-04-26','14:20:00',2.08),('15844','2013-04-26','14:25:00',2.62),('15844','2013-04-26','14:30:00',1.84),('15844','2013-04-26','14:35:00',1.71),('15844','2013-04-26','14:40:00',1.23),('15844','2013-04-26','14:45:00',1.09),('15844','2013-04-26','14:50:00',1.11),('15844','2013-04-26','14:55:00',1.74),('15844','2013-04-26','15:00:00',2.4),('15844','2013-04-26','15:05:00',2.2),('15844','2013-04-26','15:10:00',2.63),('15844','2013-04-26','15:15:00',1.77),('15844','2013-04-26','15:20:00',1.27),('15844','2013-04-26','15:25:00',1.78),('15844','2013-04-26','15:30:00',2.74),('15844','2013-04-26','15:35:00',2.56),('15844','2013-04-26','15:40:00',1.94),('15844','2013-04-26','15:45:00',1.94),('15844','2013-04-26','15:50:00',1.34),('15844','2013-04-25','08:40:00',1.08),('15844','2013-04-25','08:45:00',1.47),('15844','2013-04-25','08:50:00',1.57),('15844','2013-04-25','08:55:00',1.32),('15844','2013-04-25','09:00:00',1.05),('15844','2013-04-25','09:05:00',1.14),('15844','2013-04-25','09:10:00',1.08),('15844','2013-04-25','09:15:00',1.1),('15844','2013-04-25','09:20:00',1.1),('15844','2013-04-25','09:25:00',1.12),('15844','2013-04-25','09:30:00',1.37),('15844','2013-04-25','09:35:00',1.74),('15844','2013-04-25','09:40:00',2.22),('15844','2013-04-25','09:45:00',2.49),('15844','2013-04-25','09:50:00',2.66),('15844','2013-04-25','09:55:00',2.67),('15844','2013-04-25','10:00:00',2.62),('15844','2013-04-25','10:05:00',2.49),('15844','2013-04-25','10:10:00',2.95),('15844','2013-04-25','10:15:00',3.09),('15844','2013-04-25','10:20:00',3.26),('15844','2013-04-25','10:25:00',3.26),('15844','2013-04-25','10:30:00',3.3),('15844','2013-04-25','10:35:00',3.38),('15844','2013-04-25','10:40:00',3.45),('15844','2013-04-25','10:45:00',3.57),('15844','2013-04-25','10:50:00',3.66),('15844','2013-04-25','10:55:00',3.75),('15844','2013-04-25','11:00:00',3.79),('15844','2013-04-25','11:05:00',3.81),('15844','2013-04-25','11:10:00',3.85),('15844','2013-04-25','11:15:00',3.89),('15844','2013-04-25','11:20:00',3.92),('15844','2013-04-25','11:25:00',3.9),('15844','2013-04-25','11:30:00',3.98),('15844','2013-04-25','11:35:00',4.01),('15844','2013-04-25','11:40:00',4.01),('15844','2013-04-25','11:45:00',4.02),('15844','2013-04-25','11:50:00',4.04),('15844','2013-04-25','11:55:00',4.01),('15844','2013-04-25','12:00:00',3.96),('15844','2013-04-25','12:05:00',3.91),('15844','2013-04-25','12:10:00',3.96),('15844','2013-04-25','12:15:00',3.97),('15844','2013-04-25','12:20:00',3.95),('15844','2013-04-25','12:25:00',3.88),('15844','2013-04-25','12:30:00',3.83),('15844','2013-04-25','12:35:00',3.91),('15844','2013-04-25','12:40:00',3.89),('15844','2013-04-25','12:45:00',3.88),('15844','2013-04-25','12:50:00',3.85),('15844','2013-04-25','12:55:00',3.83),('15844','2013-04-25','13:00:00',3.86),('15844','2013-04-25','13:05:00',3.87),('15844','2013-04-25','13:10:00',3.83),('15844','2013-04-25','13:15:00',3.02),('15844','2013-04-25','13:20:00',2.73),('15844','2013-04-25','13:25:00',2.85),('15844','2013-04-25','13:30:00',2.54),('15844','2013-04-25','13:35:00',2.06),('15844','2013-04-25','13:40:00',1.95),('15844','2013-04-25','13:45:00',1.88),('15844','2013-04-25','13:50:00',1.82),('15844','2013-04-25','13:55:00',2.02),('15844','2013-04-25','14:00:00',1.89),('15844','2013-04-25','14:05:00',1.86),('15844','2013-04-25','14:10:00',1.99),('15844','2013-04-25','14:15:00',2.18),('15844','2013-04-25','14:20:00',2.89),('15844','2013-04-25','14:25:00',2.64),('15844','2013-04-25','14:30:00',3.16),('15844','2013-04-25','14:35:00',3.03),('15844','2013-04-25','14:40:00',2.88),('15844','2013-04-25','14:45:00',2.61),('15844','2013-04-25','14:50:00',2.43),('15844','2013-04-25','14:55:00',2.19),('15844','2013-04-25','15:00:00',2.29),('15844','2013-04-25','15:05:00',1.84),('15844','2013-04-25','15:10:00',1.94),('15844','2013-04-25','15:15:00',2.17),('15844','2013-04-25','15:20:00',2.12),('15844','2013-04-25','15:25:00',2.16),('15844','2013-04-25','15:30:00',1.91),('15844','2013-04-25','15:35:00',1.79),('15844','2013-04-25','15:40:00',1.71),('15844','2013-04-25','15:45:00',1.62),('15844','2013-04-25','15:50:00',1.43),('15844','2013-04-25','15:55:00',1.43),('15844','2013-04-25','16:00:00',1.64),('15844','2013-04-25','16:05:00',1.78),('15844','2013-04-25','16:10:00',1.4),('15844','2013-04-25','16:15:00',1.22),('15844','2013-04-25','16:20:00',1.61),('15844','2013-04-25','16:25:00',1.56),('15844','2013-04-25','16:30:00',1.45),('15844','2013-04-25','16:35:00',1.28),('15844','2013-04-25','16:40:00',1.29),('15844','2013-04-25','16:45:00',1.16),('15844','2013-04-25','16:50:00',1.01),('15844','2013-04-25','16:55:00',1.11),('15844','2013-04-25','17:00:00',1.11),('15844','2013-04-25','17:05:00',1.01),('15844','2013-04-24','08:40:00',1.07),('15844','2013-04-24','08:45:00',1.26),('15844','2013-04-24','08:50:00',1.25),('15844','2013-04-24','08:55:00',1.4),('15844','2013-04-24','09:00:00',1.66),('15844','2013-04-24','09:05:00',1.8),('15844','2013-04-24','09:10:00',2.09),('15844','2013-04-24','09:15:00',1.92),('15844','2013-04-24','09:20:00',1.43),('15844','2013-04-24','09:25:00',1.68),('15844','2013-04-24','09:30:00',2.17),('15844','2013-04-24','09:35:00',2.04),('15844','2013-04-24','09:40:00',2.29),('15844','2013-04-24','09:45:00',2.36),('15844','2013-04-24','09:50:00',2.65),('15844','2013-04-24','09:55:00',2.95),('15844','2013-04-24','10:00:00',2.99),('15844','2013-04-24','10:05:00',2.94),('15844','2013-04-24','10:10:00',2.56),('15844','2013-04-24','10:15:00',2.99),('15844','2013-04-24','10:20:00',3.24),('15844','2013-04-24','10:25:00',3.22),('15844','2013-04-24','10:30:00',3.2),('15844','2013-04-24','10:35:00',3.25),('15844','2013-04-24','10:40:00',3.58),('15844','2013-04-24','10:45:00',3.66),('15844','2013-04-24','10:50:00',3.79),('15844','2013-04-24','10:55:00',3.89),('15844','2013-04-24','11:00:00',3.78),('15844','2013-04-24','11:05:00',3.95),('15844','2013-04-24','11:10:00',4.13),('15844','2013-04-24','11:15:00',4.14),('15844','2013-04-24','11:20:00',4.29),('15844','2013-04-24','11:25:00',4.27),('15844','2013-04-24','11:30:00',3.46),('15844','2013-04-24','11:35:00',2.78),('15844','2013-04-24','11:40:00',2.92),('15844','2013-04-24','11:45:00',2.12),('15844','2013-04-24','11:50:00',2.02),('15844','2013-04-24','11:55:00',2.52),('15844','2013-04-24','12:00:00',2.66),('15844','2013-04-24','12:05:00',3.03),('15844','2013-04-24','12:10:00',2.59),('15844','2013-04-24','12:15:00',3.77),('15844','2013-04-24','12:20:00',3.49),('15844','2013-04-24','12:25:00',3.3),('15844','2013-04-24','12:30:00',3.58),('15844','2013-04-24','12:35:00',3.35),('15844','2013-04-24','12:40:00',3.54),('15844','2013-04-24','12:45:00',3.86),('15844','2013-04-24','12:50:00',3.66),('15844','2013-04-24','12:55:00',3.63),('15844','2013-04-24','13:00:00',2.89),('15844','2013-04-24','13:05:00',3.82),('15844','2013-04-24','13:10:00',3.71),('15844','2013-04-24','13:15:00',3.44),('15844','2013-04-24','13:20:00',3.16),('15844','2013-04-24','13:25:00',3.45),('15844','2013-04-24','13:30:00',2.8),('15844','2013-04-24','13:35:00',3.51),('15844','2013-04-24','13:40:00',3.44),('15844','2013-04-24','13:45:00',1.99),('15844','2013-04-24','13:50:00',3.26),('15844','2013-04-24','13:55:00',3.52),('15844','2013-04-24','14:00:00',2.42),('15844','2013-04-24','14:05:00',2.16),('15844','2013-04-24','14:10:00',3.24),('15844','2013-04-24','14:15:00',2.95),('15844','2013-04-24','14:20:00',3.16),('15844','2013-04-24','14:25:00',3.07),('15844','2013-04-24','14:30:00',2.66),('15844','2013-04-24','14:35:00',2.44),('15844','2013-04-24','14:40:00',2.13),('15844','2013-04-24','14:45:00',2.05),('15844','2013-04-24','14:50:00',1.71),('15844','2013-04-24','14:55:00',1.86),('15844','2013-04-24','15:00:00',1.78),('15844','2013-04-24','15:05:00',1.72),('15844','2013-04-24','15:10:00',1.69),('15844','2013-04-24','15:15:00',1.76),('15844','2013-04-24','15:20:00',1.63),('15844','2013-04-24','15:25:00',1.41),('15844','2013-04-24','15:30:00',1.36),('15844','2013-04-24','15:35:00',1.33),('15844','2013-04-24','15:40:00',1.33),('15844','2013-04-24','15:45:00',1.37),('15844','2013-04-24','15:50:00',1.46),('15844','2013-04-24','15:55:00',1.59),('15844','2013-04-24','16:00:00',1.69),('15844','2013-04-24','16:05:00',1.65),('15844','2013-04-24','16:10:00',1.61),('15844','2013-04-24','16:15:00',1.92),('15844','2013-04-24','16:20:00',1.6),('15844','2013-04-24','16:25:00',1.36),('15844','2013-04-24','16:30:00',1),('15844','2013-04-24','16:35:00',1.23),('15844','2013-04-24','16:40:00',1.27),('15844','2013-04-24','16:45:00',1.18),('15844','2013-04-24','16:50:00',1.17),('15844','2013-04-24','16:55:00',1.09),('15844','2013-04-23','08:25:00',1.03),('15844','2013-04-23','08:30:00',1.17),('15844','2013-04-23','08:35:00',1.29),('15844','2013-04-23','08:40:00',1.36),('15844','2013-04-23','08:45:00',1.43),('15844','2013-04-23','08:50:00',1.51),('15844','2013-04-23','08:55:00',1.6),('15844','2013-04-23','09:00:00',1.66),('15844','2013-04-23','09:05:00',1.76),('15844','2013-04-23','09:10:00',1.85),('15844','2013-04-23','09:15:00',1.98),('15844','2013-04-23','09:20:00',2.13),('15844','2013-04-23','09:25:00',2.27),('15844','2013-04-23','09:30:00',2.36),('15844','2013-04-23','09:35:00',2.44),('15844','2013-04-23','09:40:00',2.51),('15844','2013-04-23','09:45:00',2.31),('15844','2013-04-23','09:50:00',2.37),('15844','2013-04-23','09:55:00',2.67),('15844','2013-04-23','10:00:00',2.94),('15844','2013-04-23','10:05:00',3.05),('15844','2013-04-23','10:10:00',3.17),('15844','2013-04-23','10:15:00',3.3),('15844','2013-04-23','10:20:00',3.4),('15844','2013-04-23','10:25:00',3.5),('15844','2013-04-23','10:30:00',3.59),('15844','2013-04-23','10:35:00',3.69),('15844','2013-04-23','10:40:00',3.8),('15844','2013-04-23','10:45:00',3.73),('15844','2013-04-23','10:50:00',4),('15844','2013-04-23','10:55:00',4.08),('15844','2013-04-23','11:00:00',4.13),('15844','2013-04-23','11:05:00',4.17),('15844','2013-04-23','11:10:00',4.18),('15844','2013-04-23','11:15:00',4.22),('15844','2013-04-23','11:20:00',4.22),('15844','2013-04-23','11:25:00',4.24),('15844','2013-04-23','11:30:00',4.24),('15844','2013-04-23','11:35:00',4.25),('15844','2013-04-23','11:40:00',4.25),('15844','2013-04-23','11:45:00',4.24),('15844','2013-04-23','11:50:00',4.22),('15844','2013-04-23','11:55:00',4.23),('15844','2013-04-23','12:00:00',4.21),('15844','2013-04-23','12:05:00',4.19),('15844','2013-04-23','12:10:00',4.2),('15844','2013-04-23','12:15:00',4.21),('15844','2013-04-23','12:20:00',4.17),('15844','2013-04-23','12:25:00',4.19),('15844','2013-04-23','12:30:00',3.89),('15844','2013-04-23','12:35:00',4.3),('15844','2013-04-23','12:40:00',3.96),('15844','2013-04-23','12:45:00',2.16),('15844','2013-04-23','12:50:00',2.7),('15844','2013-04-23','12:55:00',4.06),('15844','2013-04-23','13:00:00',1.2),('15844','2013-04-23','13:05:00',2.52),('15844','2013-04-23','13:10:00',3.32),('15844','2013-04-23','13:15:00',4.25),('15844','2013-04-23','13:20:00',4.57),('15844','2013-04-23','13:25:00',4.17),('15844','2013-04-23','13:30:00',3.92),('15844','2013-04-23','13:35:00',4.31),('15844','2013-04-23','13:40:00',4.09),('15844','2013-04-23','13:45:00',2.99),('15844','2013-04-23','13:50:00',3.34),('15844','2013-04-23','13:55:00',4.33),('15844','2013-04-23','14:00:00',3.93),('15844','2013-04-23','14:05:00',2.17),('15844','2013-04-23','14:10:00',3.51),('15844','2013-04-23','14:15:00',3.57),('15844','2013-04-23','14:20:00',3.13),('15844','2013-04-23','14:25:00',2.49),('15844','2013-04-23','14:30:00',3.23),('15844','2013-04-23','14:35:00',2.73),('15844','2013-04-23','14:40:00',2.9),('15844','2013-04-23','14:45:00',1.68),('15844','2013-04-23','14:50:00',1.37),('15844','2013-04-23','14:55:00',1.4),('15844','2013-04-23','15:00:00',1.68),('15844','2013-04-23','15:05:00',2.16),('15844','2013-04-23','15:10:00',2.3),('15844','2013-04-23','15:15:00',2.2),('15844','2013-04-23','15:20:00',2.23),('15844','2013-04-23','15:25:00',1.82),('15844','2013-04-23','15:30:00',1.88),('15844','2013-04-23','15:35:00',1.98),('15844','2013-04-23','15:40:00',1.76),('15844','2013-04-23','15:45:00',1.69),('15844','2013-04-23','15:50:00',1.53),('15844','2013-04-23','15:55:00',1.76),('15844','2013-04-23','16:00:00',1.83),('15844','2013-04-23','16:05:00',1.69),('15844','2013-04-23','16:10:00',1.54),('15844','2013-04-23','16:15:00',1.32),('15844','2013-04-23','16:20:00',1.36),('15844','2013-04-23','16:25:00',1.37),('15844','2013-04-23','16:30:00',1.26),('15844','2013-04-23','16:35:00',1.13),('15844','2013-04-23','17:00:00',1.04),('15844','2013-04-22','09:25:00',1.37),('15844','2013-04-22','09:30:00',1.11),('15844','2013-04-22','10:35:00',2.98),('15844','2013-04-22','10:40:00',1.68),('15844','2013-04-22','10:45:00',2.61),('15844','2013-04-22','10:50:00',3.03),('15844','2013-04-22','10:55:00',1.08),('15844','2013-04-22','11:00:00',1.03),('15844','2013-04-22','11:05:00',1.58),('15844','2013-04-22','11:10:00',1.31),('15844','2013-04-22','11:15:00',1.96),('15844','2013-04-22','11:20:00',1.21),('15844','2013-04-22','11:25:00',1.5),('15844','2013-04-22','11:30:00',1.92),('15844','2013-04-22','11:35:00',2.89),('15844','2013-04-22','11:40:00',3.77),('15844','2013-04-22','11:45:00',5.2),('15844','2013-04-22','11:50:00',4.19),('15844','2013-04-22','11:55:00',4.65),('15844','2013-04-22','12:00:00',4.69),('15844','2013-04-22','12:05:00',4.27),('15844','2013-04-22','12:10:00',4.56),('15844','2013-04-22','12:15:00',4.63),('15844','2013-04-22','12:20:00',3.99),('15844','2013-04-22','12:25:00',3.3),('15844','2013-04-22','12:30:00',4.18),('15844','2013-04-22','12:35:00',3.22),('15844','2013-04-22','12:40:00',3.77),('15844','2013-04-22','12:45:00',3.92),('15844','2013-04-22','12:50:00',4.33),('15844','2013-04-22','12:55:00',4.31),('15844','2013-04-22','13:00:00',4.56),('15844','2013-04-22','13:05:00',4.16),('15844','2013-04-22','13:10:00',2.74),('15844','2013-04-22','13:15:00',1.02),('15844','2013-04-22','13:20:00',1.1),('15844','2013-04-22','13:25:00',2.51),('15844','2013-04-22','13:30:00',1.78),('15844','2013-04-22','13:35:00',1.52),('15844','2013-04-22','13:40:00',1.12),('15844','2013-04-22','13:45:00',1.73),('15844','2013-04-22','13:50:00',2.02),('15844','2013-04-22','13:55:00',2.54),('15844','2013-04-22','14:00:00',1.12),('15844','2013-04-22','14:05:00',2.81),('15844','2013-04-22','14:10:00',3.53),('15844','2013-04-22','14:15:00',1.04),('15844','2013-04-22','14:20:00',1.48),('15844','2013-04-22','14:25:00',3.36),('15844','2013-04-22','14:30:00',2.37),('15844','2013-04-22','14:35:00',2.9),('15844','2013-04-22','14:40:00',2.8),('15844','2013-04-22','14:45:00',3.18),('15844','2013-04-22','14:50:00',3.09),('15844','2013-04-22','14:55:00',3.07),('15844','2013-04-22','15:00:00',2.94),('15844','2013-04-22','15:05:00',1.68),('15844','2013-04-22','15:10:00',1.91),('15844','2013-04-22','15:15:00',3.1),('15844','2013-04-22','15:20:00',2.86),('15844','2013-04-22','15:25:00',2.22),('15844','2013-04-22','15:30:00',1.72),('15844','2013-04-22','15:35:00',1.76),('15844','2013-04-22','15:40:00',2.38),('15844','2013-04-22','15:45:00',1.84),('15844','2013-04-22','15:50:00',1.61),('15844','2014-03-29','07:50:00',1.08),('15844','2014-03-29','07:55:00',1.17),('15844','2014-03-29','08:00:00',1.26),('15844','2014-03-29','08:05:00',1.36),('15844','2014-03-29','08:10:00',1.46),('15844','2014-03-29','08:15:00',1.68),('15844','2014-03-29','08:20:00',1.81),('15844','2014-03-29','08:25:00',1.88),('15844','2014-03-29','08:30:00',2),('15844','2014-03-29','08:35:00',2.06),('15844','2014-03-29','08:40:00',2.11),('15844','2014-03-29','08:45:00',2.24),('15844','2014-03-29','08:50:00',2.33),('15844','2014-03-29','08:55:00',2.36),('15844','2014-03-29','09:00:00',2.4),('15844','2014-03-29','09:05:00',2.46),('15844','2014-03-29','09:10:00',2.53),('15844','2014-03-29','09:15:00',2.66),('15844','2014-03-29','09:20:00',2.74),('15844','2014-03-29','09:25:00',2.86),('15844','2014-03-29','09:30:00',2.91),('15844','2014-03-29','09:35:00',2.97),('15844','2014-03-29','09:40:00',3.08),('15844','2014-03-29','09:45:00',3.16),('15844','2014-03-29','09:50:00',3.18),('15844','2014-03-29','09:55:00',3.28),('15844','2014-03-29','10:00:00',3.4),('15844','2014-03-29','10:05:00',3.47),('15844','2014-03-29','10:10:00',3.5),('15844','2014-03-29','10:15:00',3.56),('15844','2014-03-29','10:20:00',3.62),('15844','2014-03-29','10:25:00',3.66),('15844','2014-03-29','10:30:00',3.67),('15844','2014-03-29','10:35:00',3.68),('15844','2014-03-29','10:40:00',3.7),('15844','2014-03-29','10:45:00',3.71),('15844','2014-03-29','10:50:00',3.72),('15844','2014-03-29','10:55:00',3.75),('15844','2014-03-29','11:00:00',3.7),('15844','2014-03-29','11:05:00',3.67),('15844','2014-03-29','11:10:00',3.66),('15844','2014-03-29','11:15:00',3.71),('15844','2014-03-29','11:20:00',3.75),('15844','2014-03-29','11:25:00',3.63),('15844','2014-03-29','11:30:00',3.63),('15844','2014-03-29','11:35:00',3.54),('15844','2014-03-29','11:40:00',3.62),('15844','2014-03-29','11:45:00',3.6),('15844','2014-03-29','11:50:00',3.65),('15844','2014-03-29','11:55:00',3.61),('15844','2014-03-29','12:00:00',3.57),('15844','2014-03-29','12:05:00',3.52),('15844','2014-03-29','12:10:00',3.51),('15844','2014-03-29','12:15:00',3.52),('15844','2014-03-29','12:20:00',3.5),('15844','2014-03-29','12:25:00',3.47),('15844','2014-03-29','12:30:00',3.45),('15844','2014-03-29','12:35:00',3.37),('15844','2014-03-29','12:40:00',3.32),('15844','2014-03-29','12:45:00',3.21),('15844','2014-03-29','12:50:00',3.29),('15844','2014-03-29','12:55:00',3.27),('15844','2014-03-29','13:00:00',3.27),('15844','2014-03-29','13:05:00',3.09),('15844','2014-03-29','13:10:00',3.08),('15844','2014-03-29','13:15:00',3.17),('15844','2014-03-29','13:20:00',2.95),('15844','2014-03-29','13:25:00',2.7),('15844','2014-03-29','13:30:00',2.19),('15844','2014-03-29','13:35:00',2.65),('15844','2014-03-29','13:40:00',2.53),('15844','2014-03-29','13:45:00',2.45),('15844','2014-03-29','13:50:00',2.35),('15844','2014-03-29','13:55:00',2.24),('15844','2014-03-29','14:00:00',2.15),('15844','2014-03-29','14:05:00',1.99),('15844','2014-03-29','14:10:00',2.02),('15844','2014-03-29','14:15:00',1.87),('15844','2014-03-29','14:20:00',1.8),('15844','2014-03-29','14:25:00',1.78),('15844','2014-03-29','14:30:00',1.65),('15844','2014-03-29','14:35:00',1.46),('15844','2014-03-29','14:40:00',1.46),('15844','2014-03-29','14:45:00',1.34),('15844','2014-03-29','14:50:00',1.28),('15844','2014-03-29','14:55:00',1.22),('15844','2014-03-29','15:00:00',1.17),('15844','2014-03-29','15:05:00',1.09),('15844','2013-04-21','08:50:00',1.03),('15844','2013-04-21','08:55:00',1.27),('15844','2013-04-21','09:00:00',1.02),('15844','2013-04-21','09:15:00',1.02),('15844','2013-04-21','09:20:00',1.23),('15844','2013-04-21','09:25:00',1.37),('15844','2013-04-21','09:30:00',1.7),('15844','2013-04-21','09:35:00',2.88),('15844','2013-04-21','09:40:00',2.41),('15844','2013-04-21','09:45:00',2.28),('15844','2013-04-21','09:50:00',1.65),('15844','2013-04-21','09:55:00',1.42),('15844','2013-04-21','10:00:00',1.2),('15844','2013-04-21','10:05:00',1.36),('15844','2013-04-21','10:10:00',2.26),('15844','2013-04-21','10:15:00',2.53),('15844','2013-04-21','10:20:00',3.39),('15844','2013-04-21','10:25:00',3.49),('15844','2013-04-21','10:30:00',3.34),('15844','2013-04-21','10:35:00',3.73),('15844','2013-04-21','10:40:00',3.75),('15844','2013-04-21','10:45:00',3.31),('15844','2013-04-21','10:50:00',3.97),('15844','2013-04-21','10:55:00',3.78),('15844','2013-04-21','11:00:00',3.6),('15844','2013-04-21','11:05:00',3.07),('15844','2013-04-21','11:10:00',3.01),('15844','2013-04-21','11:15:00',3.26),('15844','2013-04-21','11:20:00',3.31),('15844','2013-04-21','11:25:00',2.79),('15844','2013-04-21','11:30:00',2.31),('15844','2013-04-21','11:35:00',2.83),('15844','2013-04-21','11:40:00',3.04),('15844','2013-04-21','11:45:00',2.51),('15844','2013-04-21','11:50:00',2.21),('15844','2013-04-21','11:55:00',2.38),('15844','2013-04-21','12:00:00',2.31),('15844','2013-04-21','12:05:00',2.25),('15844','2013-04-21','12:10:00',2.08),('15844','2013-04-21','12:15:00',1.78),('15844','2013-04-21','12:20:00',1.64),('15844','2013-04-21','12:25:00',1.87),('15844','2013-04-21','12:30:00',1.82),('15844','2013-04-21','12:35:00',1.98),('15844','2013-04-21','12:40:00',2.05),('15844','2013-04-21','12:45:00',1.89),('15844','2013-04-21','12:50:00',1.89),('15844','2013-04-21','12:55:00',1.96),('15844','2013-04-21','13:00:00',2.03),('15844','2013-04-21','13:05:00',2.44),('15844','2013-04-21','13:10:00',2.26),('15844','2013-04-21','13:15:00',2.13),('15844','2013-04-21','13:20:00',2.33),('15844','2013-04-21','13:25:00',2.17),('15844','2013-04-21','13:30:00',2.84),('15844','2013-04-21','13:35:00',3.36),('15844','2013-04-21','13:40:00',4.01),('15844','2013-04-21','13:45:00',4.12),('15844','2013-04-21','13:50:00',3.1),('15844','2013-04-21','13:55:00',2.16),('15844','2013-04-21','14:00:00',2.13),('15844','2013-04-21','14:05:00',2.13),('15844','2013-04-21','14:10:00',2.63),('15844','2013-04-21','14:15:00',1.61),('15844','2013-04-21','14:20:00',2.79),('15844','2013-04-21','14:25:00',3.04),('15844','2013-04-21','14:30:00',3.63),('15844','2013-04-21','14:35:00',3.37),('15844','2013-04-21','14:40:00',3.16),('15844','2013-04-21','14:45:00',2.61),('15844','2013-04-21','14:50:00',2.04),('15844','2013-04-21','14:55:00',2.87),('15844','2013-04-21','15:00:00',2.83),('15844','2013-04-21','15:05:00',2.53),('15844','2013-04-21','15:10:00',2.47),('15844','2013-04-21','15:15:00',2.35),('15844','2013-04-21','15:20:00',1.91),('15844','2013-04-21','15:25:00',2.13),('15844','2013-04-21','15:30:00',1.82),('15844','2013-04-21','15:35:00',1.68),('15844','2013-04-21','15:40:00',1.78),('15844','2013-04-21','15:45:00',1.08),('15844','2013-04-20','08:30:00',1),('15844','2013-04-20','08:45:00',1.37),('15844','2013-04-20','10:30:00',1.06),('15844','2013-04-20','10:35:00',1.52),('15844','2013-04-20','10:40:00',3.11),('15844','2013-04-20','10:45:00',2.5),('15844','2013-04-20','10:50:00',1.49),('15844','2013-04-20','10:55:00',1.88),('15844','2013-04-20','11:00:00',2.92),('15844','2013-04-20','11:05:00',2),('15844','2013-04-20','11:10:00',1.46),('15844','2013-04-20','11:15:00',1.57),('15844','2013-04-20','11:20:00',4.15),('15844','2013-04-20','11:25:00',2.44),('15844','2013-04-20','11:30:00',2.25),('15844','2013-04-20','11:35:00',3.92),('15844','2013-04-20','11:40:00',1.83),('15844','2013-04-20','11:45:00',1.48),('15844','2013-04-20','11:50:00',2.01),('15844','2013-04-20','11:55:00',3.27),('15844','2013-04-20','12:00:00',3.81),('15844','2013-04-20','12:05:00',3.84),('15844','2013-04-20','12:10:00',4.53),('15844','2013-04-20','12:15:00',3.42),('15844','2013-04-20','12:20:00',2.88),('15844','2013-04-20','12:25:00',3.97),('15844','2013-04-20','12:30:00',1.48),('15844','2013-04-20','12:35:00',3.59),('15844','2013-04-20','12:40:00',3.6),('15844','2013-04-20','12:45:00',4.16),('15844','2013-04-20','12:50:00',3.76),('15844','2013-04-20','12:55:00',4.06),('15844','2013-04-20','13:00:00',4.07),('15844','2013-04-20','13:05:00',2.49),('15844','2013-04-20','13:10:00',4.06),('15844','2013-04-20','13:15:00',4.13),('15844','2013-04-20','13:20:00',2.75),('15844','2013-04-20','13:25:00',3.88),('15844','2013-04-20','13:30:00',3.98),('15844','2013-04-20','13:35:00',3.08),('15844','2013-04-20','13:40:00',2.37),('15844','2013-04-20','13:45:00',1.89),('15844','2013-04-20','13:50:00',3.92),('15844','2013-04-20','13:55:00',3.9),('15844','2013-04-20','14:00:00',3.77),('15844','2013-04-20','14:05:00',3.43),('15844','2013-04-20','14:10:00',3.33),('15844','2013-04-20','14:15:00',3.23),('15844','2013-04-20','14:20:00',3.18),('15844','2013-04-20','14:25:00',3.08),('15844','2013-04-20','14:30:00',2.62),('15844','2013-04-20','14:35:00',2.85),('15844','2013-04-20','14:40:00',2.74),('15844','2013-04-20','14:45:00',2.61),('15844','2013-04-20','14:50:00',2.6),('15844','2013-04-20','14:55:00',2.53),('15844','2013-04-20','15:00:00',2.43),('15844','2013-04-20','15:05:00',2.01),('15844','2013-04-20','15:10:00',2.12),('15844','2013-04-20','15:15:00',1.19),('15844','2013-04-20','15:20:00',1.48),('15844','2013-04-20','15:25:00',1.2),('15844','2013-04-20','16:00:00',1.04),('15844','2013-04-20','16:05:00',1.71),('15844','2013-04-20','16:10:00',2.19),('15844','2013-04-20','16:15:00',2.01),('15844','2013-04-20','16:20:00',1.82),('15844','2013-04-20','16:25:00',1.77),('15844','2013-04-20','16:30:00',1.62),('15844','2013-04-20','16:35:00',1.34),('15844','2013-04-20','16:40:00',1),('15844','2013-04-19','08:30:00',1.15),('15844','2013-04-19','08:35:00',1.19),('15844','2013-04-19','08:40:00',1.4),('15844','2013-04-19','08:45:00',1.17),('15844','2013-04-19','08:50:00',1.36),('15844','2013-04-19','08:55:00',1.5),('15844','2013-04-19','09:00:00',1.49),('15844','2013-04-19','09:05:00',1.42),('15844','2013-04-19','09:10:00',1.7),('15844','2013-04-19','09:15:00',1.82),('15844','2013-04-19','09:20:00',1.93),('15844','2013-04-19','09:25:00',2),('15844','2013-04-19','09:30:00',1.85),('15844','2013-04-19','09:35:00',1.54),('15844','2013-04-19','09:40:00',2.11),('15844','2013-04-19','09:45:00',2.19),('15844','2013-04-19','09:50:00',2.26),('15844','2013-04-19','09:55:00',2.41),('15844','2013-04-19','10:00:00',2.52),('15844','2013-04-19','10:05:00',2.64),('15844','2013-04-19','10:10:00',2.73),('15844','2013-04-19','10:15:00',2.78),('15844','2013-04-19','10:20:00',2.85),('15844','2013-04-19','10:25:00',2.97),('15844','2013-04-19','10:30:00',3.14),('15844','2013-04-19','10:35:00',3.13),('15844','2013-04-19','10:40:00',3.09),('15844','2013-04-19','10:45:00',3.17),('15844','2013-04-19','10:50:00',3.6),('15844','2013-04-19','10:55:00',3.63),('15844','2013-04-19','11:00:00',3.64),('15844','2013-04-19','11:05:00',3.57),('15844','2013-04-19','11:10:00',3.58),('15844','2013-04-19','11:15:00',3.57),('15844','2013-04-19','11:20:00',3.61),('15844','2013-04-19','11:25:00',3.61),('15844','2013-04-19','11:30:00',3.71),('15844','2013-04-19','11:35:00',3.75),('15844','2013-04-19','11:40:00',3.72),('15844','2013-04-19','11:45:00',3.85),('15844','2013-04-19','11:50:00',3.92),('15844','2013-04-19','11:55:00',3.85),('15844','2013-04-19','12:00:00',3.88),('15844','2013-04-19','12:05:00',3.82),('15844','2013-04-19','12:10:00',3.81),('15844','2013-04-19','12:15:00',3.74),('15844','2013-04-19','12:20:00',3.9),('15844','2013-04-19','12:25:00',3.82),('15844','2013-04-19','12:30:00',3.57),('15844','2013-04-19','12:35:00',3.64),('15844','2013-04-19','12:40:00',3.83),('15844','2013-04-19','12:45:00',3.83),('15844','2013-04-19','12:50:00',3.79),('15844','2013-04-19','12:55:00',3.71),('15844','2013-04-19','13:00:00',3.82),('15844','2013-04-19','13:05:00',3.74),('15844','2013-04-19','13:10:00',3.77),('15844','2013-04-19','13:15:00',3.7),('15844','2013-04-19','13:20:00',3.63),('15844','2013-04-19','13:25:00',3.68),('15844','2013-04-19','13:30:00',3.62),('15844','2013-04-19','13:35:00',3.54),('15844','2013-04-19','13:40:00',3.53),('15844','2013-04-19','13:45:00',3.45),('15844','2013-04-19','13:50:00',3.4),('15844','2013-04-19','13:55:00',3.33),('15844','2013-04-19','14:00:00',3.25),('15844','2013-04-19','14:05:00',3.22),('15844','2013-04-19','14:10:00',3.15),('15844','2013-04-19','14:15:00',3.09),('15844','2013-04-19','14:20:00',3.01),('15844','2013-04-19','14:25:00',2.9),('15844','2013-04-19','14:30:00',2.76),('15844','2013-04-19','14:35:00',2.67),('15844','2013-04-19','14:40:00',2.57),('15844','2013-04-19','14:45:00',2.46),('15844','2013-04-19','14:50:00',2.34),('15844','2013-04-19','14:55:00',2.32),('15844','2013-04-19','15:00:00',2.32),('15844','2013-04-19','15:05:00',2.25),('15844','2013-04-19','15:10:00',2.19),('15844','2013-04-19','15:15:00',2.09),('15844','2013-04-19','15:20:00',1.99),('15844','2013-04-19','15:25:00',1.92),('15844','2013-04-19','15:30:00',1.83),('15844','2013-04-19','15:35:00',1.74),('15844','2013-04-19','15:40:00',1.64),('15844','2013-04-19','15:45:00',1.54),('15844','2013-04-19','15:50:00',1.43),('15844','2013-04-19','15:55:00',1.32),('15844','2013-04-19','16:00:00',1.25),('15844','2013-04-19','16:05:00',1.2),('15844','2013-04-19','16:10:00',1.18),('15844','2013-04-19','16:15:00',1.12),('15844','2013-04-19','16:20:00',1.07),('15844','2013-04-18','08:50:00',1.11),('15844','2013-04-18','08:55:00',1.23),('15844','2013-04-18','09:00:00',1.2),('15844','2013-04-18','09:05:00',1.14),('15844','2013-04-18','09:10:00',1.19),('15844','2013-04-18','09:15:00',1.49),('15844','2013-04-18','09:20:00',1.43),('15844','2013-04-18','09:25:00',1.51),('15844','2013-04-18','09:30:00',1.61),('15844','2013-04-18','09:35:00',1.57),('15844','2013-04-18','09:40:00',1.81),('15844','2013-04-18','09:45:00',1.88),('15844','2013-04-18','09:50:00',2.15),('15844','2013-04-18','09:55:00',2.15),('15844','2013-04-18','10:00:00',2.61),('15844','2013-04-18','10:05:00',2.6),('15844','2013-04-18','10:10:00',2.65),('15844','2013-04-18','10:15:00',2.76),('15844','2013-04-18','10:20:00',2.87),('15844','2013-04-18','10:25:00',3.12),('15844','2013-04-18','10:30:00',3.3),('15844','2013-04-18','10:35:00',3.38),('15844','2013-04-18','10:40:00',3.42),('15844','2013-04-18','10:45:00',3.5),('15844','2013-04-18','10:50:00',3.57),('15844','2013-04-18','10:55:00',3.69),('15844','2013-04-18','11:00:00',3.76),('15844','2013-04-18','11:05:00',3.76),('15844','2013-04-18','11:10:00',3.79),('15844','2013-04-18','11:15:00',3.8),('15844','2013-04-18','11:20:00',3.8),('15844','2013-04-18','11:25:00',3.86),('15844','2013-04-18','11:30:00',3.88),('15844','2013-04-18','11:35:00',3.88),('15844','2013-04-18','11:40:00',3.93),('15844','2013-04-18','11:45:00',3.93),('15844','2013-04-18','11:50:00',3.94),('15844','2013-04-18','11:55:00',4),('15844','2013-04-18','12:00:00',3.83),('15844','2013-04-18','12:05:00',4.03),('15844','2013-04-18','12:10:00',4.01),('15844','2013-04-18','12:15:00',3.95),('15844','2013-04-18','12:20:00',3.98),('15844','2013-04-18','12:25:00',4),('15844','2013-04-18','12:30:00',3.99),('15844','2013-04-18','12:35:00',3.95),('15844','2013-04-18','12:40:00',3.97),('15844','2013-04-18','12:45:00',3.96),('15844','2013-04-18','12:50:00',3.92),('15844','2013-04-18','12:55:00',3.92),('15844','2013-04-18','13:00:00',3.9),('15844','2013-04-18','13:05:00',3.86),('15844','2013-04-18','13:10:00',3.85),('15844','2013-04-18','13:15:00',3.82),('15844','2013-04-18','13:20:00',3.75),('15844','2013-04-18','13:25:00',3.72),('15844','2013-04-18','13:30:00',3.71),('15844','2013-04-18','13:35:00',3.68),('15844','2013-04-18','13:40:00',3.62),('15844','2013-04-18','13:45:00',3.55),('15844','2013-04-18','13:50:00',3.48),('15844','2013-04-18','13:55:00',3.43),('15844','2013-04-18','14:00:00',3.36),('15844','2013-04-18','14:05:00',3.3),('15844','2013-04-18','14:10:00',3.22),('15844','2013-04-18','14:15:00',3.14),('15844','2013-04-18','14:20:00',3.08),('15844','2013-04-18','14:25:00',2.98),('15844','2013-04-18','14:30:00',2.88),('15844','2013-04-18','14:35:00',2.76),('15844','2013-04-18','14:40:00',2.67),('15844','2013-04-18','14:45:00',2.62),('15844','2013-04-18','14:50:00',2.56),('15844','2013-04-18','14:55:00',2.47),('15844','2013-04-18','15:00:00',2.37),('15844','2013-04-18','15:05:00',2.28),('15844','2013-04-18','15:10:00',2.21),('15844','2013-04-18','15:15:00',2.12),('15844','2013-04-18','15:20:00',2),('15844','2013-04-18','15:25:00',1.93),('15844','2013-04-18','15:30:00',1.84),('15844','2013-04-18','15:35:00',1.75),('15844','2013-04-18','15:40:00',1.63),('15844','2013-04-18','15:45:00',1.53),('15844','2013-04-18','15:50:00',1.41),('15844','2013-04-18','15:55:00',1.29),('15844','2013-04-18','16:00:00',1.21),('15844','2013-04-18','16:05:00',1.16),('15844','2013-04-18','16:10:00',1.14),('15844','2013-04-18','16:15:00',1.1),('15844','2013-04-18','16:20:00',1.06),('15844','2013-04-17','08:40:00',1.03),('15844','2013-04-17','08:45:00',1.21),('15844','2013-04-17','08:50:00',1.36),('15844','2013-04-17','08:55:00',1.46),('15844','2013-04-17','09:00:00',1.59),('15844','2013-04-17','09:05:00',1.71),('15844','2013-04-17','09:10:00',1.8),('15844','2013-04-17','09:15:00',1.89),('15844','2013-04-17','09:20:00',2),('15844','2013-04-17','09:25:00',2.1),('15844','2013-04-17','09:30:00',2.18),('15844','2013-04-17','09:35:00',2.27),('15844','2013-04-17','09:40:00',2.36),('15844','2013-04-17','09:45:00',2.42),('15844','2013-04-17','09:50:00',2.49),('15844','2013-04-17','09:55:00',2.59),('15844','2013-04-17','10:00:00',2.76),('15844','2013-04-17','10:05:00',2.85),('15844','2013-04-17','10:10:00',2.94),('15844','2013-04-17','10:15:00',2.98),('15844','2013-04-17','10:20:00',3.07),('15844','2013-04-17','10:25:00',3.12),('15844','2013-04-17','10:30:00',3.28),('15844','2013-04-17','10:35:00',3.39),('15844','2013-04-17','10:40:00',3.47),('15844','2013-04-17','10:45:00',3.53),('15844','2013-04-17','10:50:00',3.6),('15844','2013-04-17','10:55:00',3.73),('15844','2013-04-17','11:00:00',3.82),('15844','2013-04-17','11:05:00',3.86),('15844','2013-04-17','11:10:00',3.91),('15844','2013-04-17','11:15:00',3.92),('15844','2013-04-17','11:20:00',3.95),('15844','2013-04-17','11:25:00',3.95),('15844','2013-04-17','11:30:00',3.96),('15844','2013-04-17','11:35:00',3.98),('15844','2013-04-17','11:40:00',3.97),('15844','2013-04-17','11:45:00',3.98),('15844','2013-04-17','11:50:00',4),('15844','2013-04-17','11:55:00',3.99),('15844','2013-04-17','12:00:00',4),('15844','2013-04-17','12:05:00',4.04),('15844','2013-04-17','12:10:00',4),('15844','2013-04-17','12:15:00',3.95),('15844','2013-04-17','12:20:00',3.94),('15844','2013-04-17','12:25:00',3.95),('15844','2013-04-17','12:30:00',3.97),('15844','2013-04-17','12:35:00',3.97),('15844','2013-04-17','12:40:00',3.94),('15844','2013-04-17','12:45:00',3.94),('15844','2013-04-17','12:50:00',3.94),('15844','2013-04-17','12:55:00',3.95),('15844','2013-04-17','13:00:00',3.92),('15844','2013-04-17','13:05:00',3.85),('15844','2013-04-17','13:10:00',3.81),('15844','2013-04-17','13:15:00',3.81),('15844','2013-04-17','13:20:00',3.76),('15844','2013-04-17','13:25:00',3.74),('15844','2013-04-17','13:30:00',3.78),('15844','2013-04-17','13:35:00',3.67),('15844','2013-04-17','13:40:00',3.75),('15844','2013-04-17','13:45:00',3.53),('15844','2013-04-17','13:50:00',3.34),('15844','2013-04-17','13:55:00',2.95),('15844','2013-04-17','14:00:00',3.21),('15844','2013-04-17','14:05:00',2.79),('15844','2013-04-17','14:10:00',3.48),('15844','2013-04-17','14:15:00',3.32),('15844','2013-04-17','14:20:00',3.24),('15844','2013-04-17','14:25:00',3.06),('15844','2013-04-17','14:30:00',2.41),('15844','2013-04-17','14:35:00',3.1),('15844','2013-04-17','14:40:00',3.03),('15844','2013-04-17','14:45:00',1.83),('15844','2013-04-17','14:50:00',1.93),('15844','2013-04-17','14:55:00',1.95),('15844','2013-04-17','15:00:00',2.27),('15844','2013-04-17','15:05:00',2.64),('15844','2013-04-17','15:10:00',2.69),('15844','2013-04-17','15:15:00',2.55),('15844','2013-04-17','15:20:00',1.85),('15844','2013-04-17','15:30:00',1.18),('15844','2013-04-17','15:35:00',1.41),('15844','2013-04-17','15:40:00',1.45),('15844','2013-04-17','15:45:00',1.31),('15844','2013-04-17','15:50:00',1.44),('15844','2013-04-17','15:55:00',1.2),('15844','2013-04-17','16:00:00',1.43),('15844','2013-04-17','16:05:00',1.28),('15844','2013-04-17','16:10:00',1.04),('15844','2013-04-17','16:15:00',1.16),('15844','2013-04-17','16:20:00',1.1),('15844','2013-04-16','09:05:00',1.27),('15844','2013-04-16','09:10:00',1.72),('15844','2013-04-16','09:15:00',1.95),('15844','2013-04-16','09:20:00',1.87),('15844','2013-04-16','09:25:00',1.37),('15844','2013-04-16','09:30:00',1.44),('15844','2013-04-16','09:35:00',1.67),('15844','2013-04-16','09:40:00',1.85),('15844','2013-04-16','09:45:00',1.78),('15844','2013-04-16','09:50:00',1.53),('15844','2013-04-16','09:55:00',1.42),('15844','2013-04-16','10:00:00',1.41),('15844','2013-04-16','10:05:00',1.26),('15844','2013-04-16','10:10:00',1.28),('15844','2013-04-16','10:15:00',1.31),('15844','2013-04-16','10:20:00',1.26),('15844','2013-04-16','10:25:00',1.25),('15844','2013-04-16','10:30:00',1.25),('15844','2013-04-16','10:35:00',1.27),('15844','2013-04-16','10:40:00',1.35),('15844','2013-04-16','10:45:00',1.42),('15844','2013-04-16','10:50:00',1.41),('15844','2013-04-16','10:55:00',1.46),('15844','2013-04-16','11:00:00',1.49),('15844','2013-04-16','11:05:00',1.53),('15844','2013-04-16','11:10:00',1.53),('15844','2013-04-16','11:15:00',1.59),('15844','2013-04-16','11:20:00',1.59),('15844','2013-04-16','11:25:00',1.65),('15844','2013-04-16','11:30:00',1.54),('15844','2013-04-16','11:35:00',1.38),('15844','2013-04-16','11:40:00',1.59),('15844','2013-04-16','11:45:00',1.87),('15844','2013-04-16','11:50:00',2.02),('15844','2013-04-16','11:55:00',2.39),('15844','2013-04-16','12:00:00',3.1),('15844','2013-04-16','12:05:00',3.25),('15844','2013-04-16','12:10:00',2.73),('15844','2013-04-16','12:15:00',2.7),('15844','2013-04-16','12:20:00',3.17),('15844','2013-04-16','12:25:00',2.92),('15844','2013-04-16','12:30:00',3.22),('15844','2013-04-16','12:35:00',3.07),('15844','2013-04-16','12:40:00',2.42),('15844','2013-04-16','12:45:00',2.26),('15844','2013-04-16','12:50:00',3.58),('15844','2013-04-16','12:55:00',3.63),('15844','2013-04-16','13:00:00',3.69),('15844','2013-04-16','13:05:00',3.68),('15844','2013-04-16','13:10:00',3.52),('15844','2013-04-16','13:15:00',3.61),('15844','2013-04-16','13:20:00',3.64),('15844','2013-04-16','13:25:00',3.64),('15844','2013-04-16','13:30:00',3.66),('15844','2013-04-16','13:35:00',3.61),('15844','2013-04-16','13:40:00',3.52),('15844','2013-04-16','13:45:00',3.45),('15844','2013-04-16','13:50:00',3.36),('15844','2013-04-16','13:55:00',3.35),('15844','2013-04-16','14:00:00',3.26),('15844','2013-04-16','14:05:00',3.22),('15844','2013-04-16','14:10:00',3.17),('15844','2013-04-16','14:15:00',3.19),('15844','2013-04-16','14:20:00',3.12),('15844','2013-04-16','14:25:00',2.75),('15844','2013-04-16','14:30:00',2.21),('15844','2013-04-16','14:35:00',1.9),('15844','2013-04-16','14:40:00',2.38),('15844','2013-04-16','14:45:00',2.63),('15844','2013-04-16','14:50:00',2.56),('15844','2013-04-16','14:55:00',2.43),('15844','2013-04-16','15:00:00',2.23),('15844','2013-04-16','15:05:00',2.31),('15844','2013-04-16','15:10:00',2.22),('15844','2013-04-16','15:15:00',2.09),('15844','2013-04-16','15:20:00',1.41),('15844','2013-04-16','15:25:00',1.66),('15844','2013-04-16','15:30:00',1.67),('15844','2013-04-16','15:35:00',1.69),('15844','2013-04-16','15:40:00',1.66),('15844','2013-04-16','15:45:00',1.51),('15844','2013-04-16','15:50:00',1.44),('15844','2013-04-16','15:55:00',1.3),('15844','2013-04-16','16:00:00',1.22),('15844','2013-04-16','16:05:00',1.17),('15844','2013-04-16','16:10:00',1.13),('15844','2013-04-16','16:15:00',1.09),('15844','2013-04-16','16:20:00',1.02),('15844','2013-04-15','08:40:00',1.16),('15844','2013-04-15','08:45:00',1.23),('15844','2013-04-15','08:50:00',1.4),('15844','2013-04-15','08:55:00',1.47),('15844','2013-04-15','09:00:00',1.61),('15844','2013-04-15','09:05:00',1.73),('15844','2013-04-15','09:10:00',1.81),('15844','2013-04-15','09:15:00',1.89),('15844','2013-04-15','09:20:00',2),('15844','2013-04-15','09:25:00',2.13),('15844','2013-04-15','09:30:00',2.24),('15844','2013-04-15','09:35:00',2.36),('15844','2013-04-15','09:40:00',2.45),('15844','2013-04-15','09:45:00',2.52),('15844','2013-04-15','09:50:00',2.58),('15844','2013-04-15','09:55:00',2.65),('15844','2013-04-15','10:00:00',2.8),('15844','2013-04-15','10:05:00',2.92),('15844','2013-04-15','10:10:00',2.98),('15844','2013-04-15','10:15:00',3.05),('15844','2013-04-15','10:20:00',3.1),('15844','2013-04-15','10:25:00',3.15),('15844','2013-04-15','10:30:00',3.24),('15844','2013-04-15','10:35:00',3.41),('15844','2013-04-15','10:40:00',3.46),('15844','2013-04-15','10:45:00',3.52),('15844','2013-04-15','10:50:00',3.58),('15844','2013-04-15','10:55:00',3.69),('15844','2013-04-15','11:00:00',3.84),('15844','2013-04-15','11:05:00',3.9),('15844','2013-04-15','11:10:00',3.91),('15844','2013-04-15','11:15:00',3.94),('15844','2013-04-15','11:20:00',3.96),('15844','2013-04-15','11:25:00',3.98),('15844','2013-04-15','11:30:00',3.99),('15844','2013-04-15','11:35:00',4),('15844','2013-04-15','11:40:00',4.04),('15844','2013-04-15','11:45:00',4.03),('15844','2013-04-15','11:50:00',4.02),('15844','2013-04-15','11:55:00',4.03),('15844','2013-04-15','12:00:00',4.02),('15844','2013-04-15','12:05:00',4.03),('15844','2013-04-15','12:10:00',4.01),('15844','2013-04-15','12:15:00',4.01),('15844','2013-04-15','12:20:00',4.01),('15844','2013-04-15','12:25:00',3.99),('15844','2013-04-15','12:30:00',3.99),('15844','2013-04-15','12:35:00',3.97),('15844','2013-04-15','12:40:00',3.96),('15844','2013-04-15','12:45:00',3.94),('15844','2013-04-15','12:50:00',3.91),('15844','2013-04-15','12:55:00',3.89),('15844','2013-04-15','13:00:00',3.87),('15844','2013-04-15','13:05:00',3.88),('15844','2013-04-15','13:10:00',3.86),('15844','2013-04-15','13:15:00',3.82),('15844','2013-04-15','13:20:00',3.78),('15844','2013-04-15','13:25:00',3.73),('15844','2013-04-15','13:30:00',3.71),('15844','2013-04-15','13:35:00',3.72),('15844','2013-04-15','13:40:00',3.69),('15844','2013-04-15','13:45:00',3.53),('15844','2013-04-15','13:50:00',3.56),('15844','2013-04-15','13:55:00',3.48),('15844','2013-04-15','14:00:00',3.41),('15844','2013-04-15','14:05:00',3.35),('15844','2013-04-15','14:10:00',3.28),('15844','2013-04-15','14:15:00',3.19),('15844','2013-04-15','14:20:00',3.11),('15844','2013-04-15','14:25:00',3),('15844','2013-04-15','14:30:00',2.88),('15844','2013-04-15','14:35:00',2.75),('15844','2013-04-15','14:40:00',2.61),('15844','2013-04-15','14:45:00',2.47),('15844','2013-04-15','14:50:00',2.46),('15844','2013-04-15','14:55:00',2.47),('15844','2013-04-15','15:00:00',2.37),('15844','2013-04-15','15:05:00',2.28),('15844','2013-04-15','15:10:00',2.2),('15844','2013-04-15','15:15:00',2.1),('15844','2013-04-15','15:20:00',2),('15844','2013-04-15','15:25:00',1.94),('15844','2013-04-15','15:30:00',1.84),('15844','2013-04-15','15:35:00',1.74),('15844','2013-04-15','15:40:00',1.63),('15844','2013-04-15','15:45:00',1.52),('15844','2013-04-15','15:50:00',1.37),('15844','2013-04-15','15:55:00',1.23),('15844','2013-04-15','16:00:00',1.17),('15844','2013-04-15','16:05:00',1.12),('15844','2013-04-15','16:10:00',1.06),('15844','2013-04-15','16:15:00',1.03),('15844','2013-04-14','08:40:00',1.03),('15844','2013-04-14','08:45:00',1.19),('15844','2013-04-14','08:50:00',1.32),('15844','2013-04-14','08:55:00',1.4),('15844','2013-04-14','09:00:00',1.5),('15844','2013-04-14','09:05:00',1.62),('15844','2013-04-14','09:10:00',1.7),('15844','2013-04-14','09:15:00',1.75),('15844','2013-04-14','09:20:00',1.86),('15844','2013-04-14','09:25:00',2),('15844','2013-04-14','09:30:00',2.12),('15844','2013-04-14','09:35:00',2.18),('15844','2013-04-14','09:40:00',2.29),('15844','2013-04-14','09:45:00',2.34),('15844','2013-04-14','09:50:00',2.41),('15844','2013-04-14','09:55:00',2.49),('15844','2013-04-14','10:00:00',2.61),('15844','2013-04-14','10:05:00',2.75),('15844','2013-04-14','10:10:00',2.83),('15844','2013-04-14','10:15:00',2.9),('15844','2013-04-14','10:20:00',2.97),('15844','2013-04-14','10:25:00',3.04),('15844','2013-04-14','10:30:00',3.15),('15844','2013-04-14','10:35:00',3.27),('15844','2013-04-14','10:40:00',3.37),('15844','2013-04-14','10:45:00',3.45),('15844','2013-04-14','10:50:00',3.51),('15844','2013-04-14','10:55:00',3.62),('15844','2013-04-14','11:00:00',3.75),('15844','2013-04-14','11:05:00',3.75),('15844','2013-04-14','11:10:00',3.8),('15844','2013-04-14','11:15:00',3.83),('15844','2013-04-14','11:20:00',3.9),('15844','2013-04-14','11:25:00',3.9),('15844','2013-04-14','11:30:00',3.93),('15844','2013-04-14','11:35:00',3.93),('15844','2013-04-14','11:40:00',3.9),('15844','2013-04-14','11:45:00',3.93),('15844','2013-04-14','11:50:00',3.89),('15844','2013-04-14','11:55:00',3.86),('15844','2013-04-14','12:00:00',3.91),('15844','2013-04-14','12:05:00',3.89),('15844','2013-04-14','12:10:00',3.89),('15844','2013-04-14','12:15:00',3.87),('15844','2013-04-14','12:20:00',3.84),('15844','2013-04-14','12:25:00',3.91),('15844','2013-04-14','12:30:00',3.91),('15844','2013-04-14','12:35:00',3.86),('15844','2013-04-14','12:40:00',3.88),('15844','2013-04-14','12:45:00',3.93),('15844','2013-04-14','12:50:00',3.88),('15844','2013-04-14','12:55:00',3.85),('15844','2013-04-14','13:00:00',3.88),('15844','2013-04-14','13:05:00',3.81),('15844','2013-04-14','13:10:00',3.82),('15844','2013-04-14','13:15:00',3.83),('15844','2013-04-14','13:20:00',3.9),('15844','2013-04-14','13:25:00',1.81),('15844','2013-04-14','13:35:00',3.08),('15844','2013-04-14','13:40:00',1.82),('15844','2013-04-14','13:45:00',3.2),('15844','2013-04-14','13:50:00',3.68),('15844','2013-04-14','13:55:00',3.48),('15844','2013-04-14','14:00:00',3.31),('15844','2013-04-14','14:05:00',2.81),('15844','2013-04-14','14:10:00',3.16),('15844','2013-04-14','14:15:00',3.01),('15844','2013-04-14','14:20:00',2.12),('15844','2013-04-14','14:25:00',2.88),('15844','2013-04-14','14:30:00',2.86),('15844','2013-04-14','14:35:00',2.74),('15844','2013-04-14','14:40:00',2.6),('15844','2013-04-14','14:45:00',2.49),('15844','2013-04-14','14:50:00',2.44),('15844','2013-04-14','14:55:00',2.48),('15844','2013-04-14','15:00:00',2.29),('15844','2013-04-14','15:05:00',2.28),('15844','2013-04-14','15:10:00',2.31),('15844','2013-04-14','15:15:00',1.89),('15844','2013-04-14','15:20:00',1.98),('15844','2013-04-14','15:25:00',1.89),('15844','2013-04-14','15:30:00',1.82),('15844','2013-04-14','15:35:00',1.74),('15844','2013-04-14','15:40:00',1.65),('15844','2013-04-14','15:45:00',1.55),('15844','2013-04-14','15:50:00',1.41),('15844','2013-04-14','15:55:00',1.27),('15844','2013-04-14','16:00:00',1.18),('15844','2013-04-14','16:05:00',1.13),('15844','2013-04-14','16:10:00',1.06),('15844','2013-04-14','16:15:00',1.01),('15844','2013-04-13','08:15:00',1.11),('15844','2013-04-13','09:00:00',1.64),('15844','2013-04-13','09:05:00',1.48),('15844','2013-04-13','09:10:00',1.69),('15844','2013-04-13','09:15:00',1.75),('15844','2013-04-13','09:20:00',1.96),('15844','2013-04-13','09:25:00',2.1),('15844','2013-04-13','09:30:00',2.24),('15844','2013-04-13','09:35:00',2),('15844','2013-04-13','09:40:00',2.34),('15844','2013-04-13','09:45:00',2.43),('15844','2013-04-13','09:50:00',2.59),('15844','2013-04-13','09:55:00',2.69),('15844','2013-04-13','10:00:00',2.74),('15844','2013-04-13','10:05:00',2.97),('15844','2013-04-13','10:10:00',2.81),('15844','2013-04-13','10:15:00',3.16),('15844','2013-04-13','10:20:00',3.3),('15844','2013-04-13','10:25:00',2.23),('15844','2013-04-13','10:30:00',2.42),('15844','2013-04-13','10:35:00',1.25),('15844','2013-04-13','10:40:00',1.64),('15844','2013-04-13','10:45:00',1.18),('15844','2013-04-13','10:50:00',3.44),('15844','2013-04-13','10:55:00',2.96),('15844','2013-04-13','11:05:00',2.83),('15844','2013-04-13','11:10:00',3.77),('15844','2013-04-13','11:15:00',3.29),('15844','2013-04-13','11:20:00',1.73),('15844','2013-04-13','11:25:00',4.07),('15844','2013-04-13','11:30:00',2.72),('15844','2013-04-13','11:40:00',3.45),('15844','2013-04-13','11:45:00',4.25),('15844','2013-04-13','11:50:00',3.65),('15844','2013-04-13','11:55:00',2.65),('15844','2013-04-13','12:00:00',4.36),('15844','2013-04-13','12:05:00',3.03),('15844','2013-04-13','12:10:00',4.04),('15844','2013-04-13','12:15:00',3.92),('15844','2013-04-13','12:20:00',4.28),('15844','2013-04-13','12:25:00',3.82),('15844','2013-04-13','12:30:00',4.18),('15844','2013-04-13','12:35:00',4.17),('15844','2013-04-13','12:40:00',4.05),('15844','2013-04-13','12:45:00',2.56),('15844','2013-04-13','12:50:00',3.81),('15844','2013-04-13','12:55:00',3.86),('15844','2013-04-13','13:00:00',3.81),('15844','2013-04-13','13:05:00',4),('15844','2013-04-13','13:10:00',3.89),('15844','2013-04-13','13:15:00',3.71),('15844','2013-04-13','13:20:00',3.63),('15844','2013-04-13','13:25:00',3.66),('15844','2013-04-13','13:30:00',3.28),('15844','2013-04-13','13:35:00',3.27),('15844','2013-04-13','13:40:00',3.21),('15844','2013-04-13','13:45:00',2.96),('15844','2013-04-13','13:50:00',2.78),('15844','2013-04-13','13:55:00',3),('15844','2013-04-13','14:00:00',2.82),('15844','2013-04-13','14:05:00',2.49),('15844','2013-04-13','14:10:00',2.47),('15844','2013-04-13','14:15:00',2.66),('15844','2013-04-13','14:20:00',2.63),('15844','2013-04-13','14:25:00',2.81),('15844','2013-04-13','14:30:00',2.89),('15844','2013-04-13','14:35:00',2.82),('15844','2013-04-13','14:40:00',2.67),('15844','2013-04-13','14:45:00',2.61),('15844','2013-04-13','14:50:00',2.46),('15844','2013-04-13','14:55:00',2.35),('15844','2013-04-13','15:00:00',2.17),('15844','2013-04-13','15:05:00',2.17),('15844','2013-04-13','15:10:00',2.01),('15844','2013-04-13','15:15:00',1.94),('15844','2013-04-13','15:20:00',1.85),('15844','2013-04-13','15:25:00',1.77),('15844','2013-04-13','15:30:00',1.74),('15844','2013-04-13','15:35:00',1.67),('15844','2013-04-13','15:40:00',1.68),('15844','2013-04-13','15:45:00',1.64),('15844','2013-04-13','15:50:00',1.56),('15844','2013-04-13','15:55:00',1.49),('15844','2013-04-13','16:00:00',1.49),('15844','2013-04-13','16:05:00',1.38),('15844','2013-04-13','16:10:00',1.35),('15844','2013-04-13','16:15:00',1.31),('15844','2013-04-13','16:20:00',1.3),('15844','2013-04-13','16:25:00',1.19),('15844','2013-04-13','16:30:00',1.15),('15844','2013-04-13','16:35:00',1.06),('15844','2013-04-12','08:45:00',1.07),('15844','2013-04-12','08:50:00',1.04),('15844','2013-04-12','09:40:00',1.08),('15844','2013-04-12','09:45:00',2.06),('15844','2013-04-12','09:50:00',1.32),('15844','2013-04-12','09:55:00',1.15),('15844','2013-04-12','10:00:00',1.18),('15844','2013-04-12','10:10:00',1.06),('15844','2013-04-12','10:15:00',1.32),('15844','2013-04-12','10:20:00',1.72),('15844','2013-04-12','10:30:00',1.15),('15844','2013-04-12','10:35:00',1.67),('15844','2013-04-12','10:40:00',1.41),('15844','2013-04-12','10:45:00',1.19),('15844','2013-04-12','10:50:00',1.27),('15844','2013-04-12','10:55:00',2.02),('15844','2013-04-12','11:00:00',1.72),('15844','2013-04-12','11:05:00',2.93),('15844','2013-04-12','11:10:00',2.86),('15844','2013-04-12','11:15:00',4.33),('15844','2013-04-12','11:20:00',3.78),('15844','2013-04-12','11:25:00',2.36),('15844','2013-04-12','11:30:00',2.65),('15844','2013-04-12','11:35:00',4.33),('15844','2013-04-12','11:40:00',4.53),('15844','2013-04-12','11:45:00',3.56),('15844','2013-04-12','11:50:00',4.13),('15844','2013-04-12','11:55:00',4.08),('15844','2013-04-12','12:00:00',3.64),('15844','2013-04-12','12:05:00',3.82),('15844','2013-04-12','12:10:00',3.77),('15844','2013-04-12','12:15:00',4.16),('15844','2013-04-12','12:20:00',4.14),('15844','2013-04-12','12:25:00',4.12),('15844','2013-04-12','12:30:00',4.07),('15844','2013-04-12','12:35:00',3.95),('15844','2013-04-12','12:40:00',3.93),('15844','2013-04-12','12:45:00',3.7),('15844','2013-04-12','12:50:00',3.78),('15844','2013-04-12','12:55:00',3.92),('15844','2013-04-12','13:00:00',3.93),('15844','2013-04-12','13:05:00',3.86),('15844','2013-04-12','13:10:00',3.88),('15844','2013-04-12','13:15:00',3.85),('15844','2013-04-12','13:20:00',3.87),('15844','2013-04-12','13:25:00',3.82),('15844','2013-04-12','13:30:00',3.76),('15844','2013-04-12','13:35:00',3.69),('15844','2013-04-12','13:40:00',3.64),('15844','2013-04-12','13:45:00',3.59),('15844','2013-04-12','13:50:00',3.54),('15844','2013-04-12','13:55:00',3.47),('15844','2013-04-12','14:00:00',3.42),('15844','2013-04-12','14:05:00',3.31),('15844','2013-04-12','14:10:00',3.26),('15844','2013-04-12','14:15:00',3.18),('15844','2013-04-12','14:20:00',3.07),('15844','2013-04-12','14:25:00',2.95),('15844','2013-04-12','14:30:00',2.89),('15844','2013-04-12','14:35:00',2.77),('15844','2013-04-12','14:40:00',2.65),('15844','2013-04-12','14:45:00',2.54),('15844','2013-04-12','14:50:00',2.48),('15844','2013-04-12','14:55:00',2.43),('15844','2013-04-12','15:00:00',2.33),('15844','2013-04-12','15:05:00',2.24),('15844','2013-04-12','15:10:00',2.14),('15844','2013-04-12','15:15:00',2.03),('15844','2013-04-12','15:20:00',1.96),('15844','2013-04-12','15:25:00',1.88),('15844','2013-04-12','15:30:00',1.79),('15844','2013-04-12','15:35:00',1.68),('15844','2013-04-12','15:40:00',1.57),('15844','2013-04-12','15:45:00',1.47),('15844','2013-04-12','15:50:00',1.35),('15844','2013-04-12','15:55:00',1.24),('15844','2013-04-12','16:00:00',1.16),('15844','2013-04-12','16:05:00',1.11),('15844','2013-04-12','16:10:00',1.02),('15844','2013-04-12','16:15:00',1.13),('15844','2014-03-28','07:40:00',1.03),('15844','2014-03-28','07:45:00',1.09),('15844','2014-03-28','07:50:00',1.14),('15844','2014-03-28','07:55:00',1.21),('15844','2014-03-28','08:00:00',1.29),('15844','2014-03-28','08:05:00',1.4),('15844','2014-03-28','08:10:00',1.52),('15844','2014-03-28','08:15:00',1.74),('15844','2014-03-28','08:20:00',1.85),('15844','2014-03-28','08:25:00',1.95),('15844','2014-03-28','08:30:00',2.09),('15844','2014-03-28','08:35:00',2.16),('15844','2014-03-28','08:40:00',2.22),('15844','2014-03-28','08:45:00',2.29),('15844','2014-03-28','08:50:00',2.4),('15844','2014-03-28','08:55:00',2.52),('15844','2014-03-28','09:00:00',2.64),('15844','2014-03-28','09:05:00',2.8),('15844','2014-03-28','09:10:00',2.92),('15844','2014-03-28','09:15:00',2.88),('15844','2014-03-28','09:20:00',3.21),('15844','2014-03-28','09:25:00',3.18),('15844','2014-03-28','09:30:00',3.2),('15844','2014-03-28','09:35:00',2.28),('15844','2014-03-28','09:40:00',1.81),('15844','2014-03-28','09:45:00',2.91),('15844','2014-03-28','09:50:00',3.12),('15844','2014-03-28','09:55:00',3.41),('15844','2014-03-28','10:00:00',3.42),('15844','2014-03-28','10:05:00',3.78),('15844','2014-03-28','10:10:00',3.39),('15844','2014-03-28','10:15:00',3.33),('15844','2014-03-28','10:20:00',2.94),('15844','2014-03-28','10:25:00',2.85),('15844','2014-03-28','10:30:00',3),('15844','2014-03-28','10:35:00',3.77),('15844','2014-03-28','10:40:00',3.91),('15844','2014-03-28','10:45:00',3.91),('15844','2014-03-28','10:50:00',3.86),('15844','2014-03-28','10:55:00',3.88),('15844','2014-03-28','11:00:00',3.85),('15844','2014-03-28','11:05:00',3.86),('15844','2014-03-28','11:10:00',3.89),('15844','2014-03-28','11:15:00',2.36),('15844','2014-03-28','11:20:00',4.25),('15844','2014-03-28','11:25:00',2.82),('15844','2014-03-28','11:30:00',3.82),('15844','2014-03-28','11:35:00',1.7),('15844','2014-03-28','11:40:00',2.33),('15844','2014-03-28','11:45:00',2.71),('15844','2014-03-28','11:50:00',2),('15844','2014-03-28','11:55:00',2.48),('15844','2014-03-28','12:00:00',1.48),('15844','2014-03-28','12:05:00',3.22),('15844','2014-03-28','12:10:00',3.58),('15844','2014-03-28','12:15:00',4.12),('15844','2014-03-28','12:20:00',2.44),('15844','2014-03-28','12:25:00',3.31),('15844','2014-03-28','12:30:00',3.79),('15844','2014-03-28','12:35:00',3.78),('15844','2014-03-28','12:40:00',3.73),('15844','2014-03-28','12:45:00',3.81),('15844','2014-03-28','12:50:00',3.9),('15844','2014-03-28','12:55:00',4.11),('15844','2014-03-28','13:00:00',3.59),('15844','2014-03-28','13:05:00',3.79),('15844','2014-03-28','13:10:00',4.07),('15844','2014-03-28','13:15:00',4.28),('15844','2014-03-28','13:20:00',4.05),('15844','2014-03-28','13:25:00',3.38),('15844','2014-03-28','13:30:00',3.48),('15844','2014-03-28','13:35:00',1.99),('15844','2014-03-28','13:40:00',2.47),('15844','2014-03-28','13:45:00',2.71),('15844','2014-03-28','13:50:00',2.53),('15844','2014-03-28','13:55:00',2.3),('15844','2014-03-28','14:00:00',2.27),('15844','2014-03-28','14:05:00',2.17),('15844','2014-03-28','14:10:00',2.04),('15844','2014-03-28','14:15:00',1.93),('15844','2014-03-28','14:20:00',1.8),('15844','2014-03-28','14:25:00',1.73),('15844','2014-03-28','14:30:00',1.65),('15844','2014-03-28','14:35:00',1.55),('15844','2014-03-28','14:40:00',1.44),('15844','2014-03-28','14:45:00',1.34),('15844','2014-03-28','14:50:00',1.26),('15844','2014-03-28','14:55:00',1.22),('15844','2014-03-28','15:00:00',1.14),('15844','2014-03-28','15:05:00',1.06),('15844','2013-04-11','08:40:00',1),('15844','2013-04-11','08:45:00',1.15),('15844','2013-04-11','08:50:00',1.3),('15844','2013-04-11','08:55:00',1.37),('15844','2013-04-11','09:00:00',1.44),('15844','2013-04-11','09:05:00',1.61),('15844','2013-04-11','09:10:00',1.74),('15844','2013-04-11','09:15:00',1.83),('15844','2013-04-11','09:20:00',1.94),('15844','2013-04-11','09:25:00',2.02),('15844','2013-04-11','09:30:00',2.19),('15844','2013-04-11','09:35:00',2.38),('15844','2013-04-11','09:40:00',2.48),('15844','2013-04-11','09:45:00',2.46),('15844','2013-04-11','09:50:00',2.61),('15844','2013-04-11','09:55:00',2.62),('15844','2013-04-11','10:00:00',1.46),('15844','2013-04-11','10:05:00',2.41),('15844','2013-04-11','10:10:00',2.38),('15844','2013-04-11','10:15:00',1.82),('15844','2013-04-11','10:20:00',3.11),('15844','2013-04-11','10:25:00',3.21),('15844','2013-04-11','10:30:00',3.31),('15844','2013-04-11','10:35:00',3.54),('15844','2013-04-11','10:40:00',2.46),('15844','2013-04-11','10:45:00',3.63),('15844','2013-04-11','10:50:00',3.83),('15844','2013-04-11','10:55:00',2.85),('15844','2013-04-11','11:00:00',2.27),('15844','2013-04-11','11:05:00',3.04),('15844','2013-04-11','11:10:00',4.48),('15844','2013-04-11','11:15:00',2.99),('15844','2013-04-11','11:30:00',2.17),('15844','2013-04-11','11:40:00',1.98),('15844','2013-04-11','11:45:00',4.7),('15844','2013-04-11','11:50:00',3.63),('15844','2013-04-11','11:55:00',4.39),('15844','2013-04-11','12:00:00',2.85),('15844','2013-04-11','12:05:00',4.42),('15844','2013-04-11','12:10:00',3.04),('15844','2013-04-11','12:15:00',4.32),('15844','2013-04-11','12:20:00',3.68),('15844','2013-04-11','12:25:00',3.39),('15844','2013-04-11','12:30:00',4.41),('15844','2013-04-11','12:35:00',3.63),('15844','2013-04-11','12:40:00',3.17),('15844','2013-04-11','12:45:00',4.26),('15844','2013-04-11','12:50:00',1.88),('15844','2013-04-11','12:55:00',4.46),('15844','2013-04-11','13:00:00',4.38),('15844','2013-04-11','13:05:00',4.22),('15844','2013-04-11','13:10:00',4.1),('15844','2013-04-11','13:15:00',4.12),('15844','2013-04-11','13:20:00',4.14),('15844','2013-04-11','13:25:00',3.91),('15844','2013-04-11','13:30:00',2.2),('15844','2013-04-11','13:35:00',3.14),('15844','2013-04-11','13:40:00',3.44),('15844','2013-04-11','13:45:00',3.39),('15844','2013-04-11','13:50:00',3.9),('15844','2013-04-11','13:55:00',3.65),('15844','2013-04-11','14:00:00',3.51),('15844','2013-04-11','14:05:00',3.51),('15844','2013-04-11','14:10:00',3.48),('15844','2013-04-11','14:15:00',3.42),('15844','2013-04-11','14:20:00',3.31),('15844','2013-04-11','14:25:00',2.77),('15844','2013-04-11','14:30:00',3.08),('15844','2013-04-11','14:35:00',2.87),('15844','2013-04-11','14:40:00',2.31),('15844','2013-04-11','14:45:00',1.79),('15844','2013-04-11','14:50:00',2.57),('15844','2013-04-11','14:55:00',2.51),('15844','2013-04-11','15:00:00',1.87),('15844','2013-04-11','15:05:00',1.95),('15844','2013-04-11','15:10:00',2.2),('15844','2013-04-11','15:15:00',2.12),('15844','2013-04-11','15:20:00',2),('15844','2013-04-11','15:25:00',1.92),('15844','2013-04-11','15:30:00',1.81),('15844','2013-04-11','15:35:00',1.69),('15844','2013-04-11','15:40:00',1.43),('15844','2013-04-11','15:45:00',1.47),('15844','2013-04-11','15:50:00',1.35),('15844','2013-04-11','15:55:00',1.24),('15844','2013-04-11','16:00:00',1.19),('15844','2013-04-11','16:05:00',1.14),('15844','2013-04-11','16:10:00',1.07),('15844','2013-04-10','08:40:00',1.56),('15844','2013-04-10','08:45:00',1.69),('15844','2013-04-10','08:50:00',1.67),('15844','2013-04-10','08:55:00',1.64),('15844','2013-04-10','09:00:00',1.73),('15844','2013-04-10','09:05:00',1.24),('15844','2013-04-10','09:10:00',1.03),('15844','2013-04-10','09:15:00',1.68),('15844','2013-04-10','09:20:00',1.82),('15844','2013-04-10','09:25:00',1.94),('15844','2013-04-10','09:30:00',2.1),('15844','2013-04-10','09:35:00',2.27),('15844','2013-04-10','09:40:00',2.36),('15844','2013-04-10','09:45:00',2.45),('15844','2013-04-10','09:50:00',2.01),('15844','2013-04-10','09:55:00',2.45),('15844','2013-04-10','10:00:00',2.66),('15844','2013-04-10','10:05:00',2.96),('15844','2013-04-10','10:10:00',3.06),('15844','2013-04-10','10:15:00',3.14),('15844','2013-04-10','10:20:00',3.23),('15844','2013-04-10','10:25:00',3.28),('15844','2013-04-10','10:30:00',3.29),('15844','2013-04-10','10:35:00',3.46),('15844','2013-04-10','10:40:00',3.6),('15844','2013-04-10','10:45:00',3.68),('15844','2013-04-10','10:50:00',3.5),('15844','2013-04-10','10:55:00',3.74),('15844','2013-04-10','11:00:00',2.98),('15844','2013-04-10','11:05:00',3.68),('15844','2013-04-10','11:10:00',2.53),('15844','2013-04-10','11:15:00',3.57),('15844','2013-04-10','11:20:00',4.19),('15844','2013-04-10','11:25:00',3.04),('15844','2013-04-10','11:30:00',4.24),('15844','2013-04-10','11:35:00',4.3),('15844','2013-04-10','11:40:00',2.55),('15844','2013-04-10','11:45:00',3.61),('15844','2013-04-10','11:50:00',3.3),('15844','2013-04-10','11:55:00',3.91),('15844','2013-04-10','12:00:00',3.65),('15844','2013-04-10','12:05:00',1.85),('15844','2013-04-10','12:10:00',1.93),('15844','2013-04-10','12:15:00',1.11),('15844','2013-04-10','12:20:00',3.47),('15844','2013-04-10','12:25:00',2.72),('15844','2013-04-10','12:30:00',4.32),('15844','2013-04-10','12:35:00',2.15),('15844','2013-04-10','12:40:00',4.32),('15844','2013-04-10','12:45:00',4.2),('15844','2013-04-10','12:50:00',4.22),('15844','2013-04-10','12:55:00',3.96),('15844','2013-04-10','13:00:00',4.22),('15844','2013-04-10','13:05:00',4.1),('15844','2013-04-10','13:10:00',3.77),('15844','2013-04-10','13:15:00',3.39),('15844','2013-04-10','13:20:00',4.11),('15844','2013-04-10','13:25:00',3.31),('15844','2013-04-10','13:30:00',3.35),('15844','2013-04-10','13:35:00',3.57),('15844','2013-04-10','13:40:00',3.89),('15844','2013-04-10','13:45:00',3.53),('15844','2013-04-10','13:50:00',3.45),('15844','2013-04-10','13:55:00',3.39),('15844','2013-04-10','14:00:00',3.51),('15844','2013-04-10','14:05:00',3.09),('15844','2013-04-10','14:10:00',3.24),('15844','2013-04-10','14:15:00',2.79),('15844','2013-04-10','14:20:00',3),('15844','2013-04-10','14:25:00',1.86),('15844','2013-04-10','14:30:00',2.84),('15844','2013-04-10','14:35:00',3.05),('15844','2013-04-10','14:40:00',2.53),('15844','2013-04-10','14:45:00',2.66),('15844','2013-04-10','14:50:00',2.57),('15844','2013-04-10','14:55:00',2.45),('15844','2013-04-10','15:00:00',2.13),('15844','2013-04-10','15:05:00',2.36),('15844','2013-04-10','15:10:00',2.31),('15844','2013-04-10','15:15:00',2.22),('15844','2013-04-10','15:20:00',1.76),('15844','2013-04-10','15:25:00',1.95),('15844','2013-04-10','15:30:00',1.82),('15844','2013-04-10','15:35:00',1.73),('15844','2013-04-10','15:40:00',1.69),('15844','2013-04-10','15:45:00',1.53),('15844','2013-04-10','15:50:00',1.44),('15844','2013-04-10','15:55:00',1.32),('15844','2013-04-10','16:00:00',1.21),('15844','2013-04-10','16:05:00',1.19),('15844','2013-04-10','16:10:00',1.14),('15844','2013-04-10','16:15:00',1.07),('15844','2013-04-10','16:20:00',1.08),('15844','2013-04-09','08:20:00',1.01),('15844','2013-04-09','08:35:00',1.24),('15844','2013-04-09','08:40:00',1.09),('15844','2013-04-09','08:50:00',1.21),('15844','2013-04-09','08:55:00',1.2),('15844','2013-04-09','09:00:00',1.11),('15844','2013-04-09','09:35:00',1.82),('15844','2013-04-09','09:40:00',2.37),('15844','2013-04-09','09:45:00',2.76),('15844','2013-04-09','09:50:00',1.46),('15844','2013-04-09','10:20:00',2.11),('15844','2013-04-09','10:25:00',2.94),('15844','2013-04-09','10:30:00',3.77),('15844','2013-04-09','10:35:00',1.14),('15844','2013-04-09','10:40:00',1.95),('15844','2013-04-09','10:45:00',2.03),('15844','2013-04-09','10:50:00',1.28),('15844','2013-04-09','10:55:00',4.46),('15844','2013-04-09','11:00:00',3.39),('15844','2013-04-09','11:05:00',3.37),('15844','2013-04-09','11:10:00',3.89),('15844','2013-04-09','11:15:00',1.89),('15844','2013-04-09','11:20:00',3.87),('15844','2013-04-09','11:25:00',3.47),('15844','2013-04-09','11:30:00',1.57),('15844','2013-04-09','11:35:00',4.52),('15844','2013-04-09','11:40:00',2.06),('15844','2013-04-09','11:45:00',1.06),('15844','2013-04-09','11:50:00',3.66),('15844','2013-04-09','11:55:00',4.15),('15844','2013-04-09','12:00:00',1.5),('15844','2013-04-09','12:05:00',3.49),('15844','2013-04-09','12:10:00',1.92),('15844','2013-04-09','12:15:00',3.74),('15844','2013-04-09','12:20:00',4.51),('15844','2013-04-09','12:25:00',4.27),('15844','2013-04-09','12:30:00',1.44),('15844','2013-04-09','12:35:00',3.03),('15844','2013-04-09','12:40:00',2.48),('15844','2013-04-09','12:45:00',1.25),('15844','2013-04-09','12:50:00',3.36),('15844','2013-04-09','12:55:00',3.41),('15844','2013-04-09','13:00:00',3.78),('15844','2013-04-09','13:05:00',3.77),('15844','2013-04-09','13:10:00',3.5),('15844','2013-04-09','13:15:00',2.85),('15844','2013-04-09','13:20:00',4.05),('15844','2013-04-09','13:25:00',1.55),('15844','2013-04-09','13:30:00',3.56),('15844','2013-04-09','13:35:00',1.24),('15844','2013-04-09','13:40:00',3.22),('15844','2013-04-09','13:45:00',3.8),('15844','2013-04-09','13:50:00',3.61),('15844','2013-04-09','13:55:00',3.07),('15844','2013-04-09','14:00:00',2.98),('15844','2013-04-09','14:05:00',3.28),('15844','2013-04-09','14:10:00',2.34),('15844','2013-04-09','14:15:00',3.08),('15844','2013-04-09','14:20:00',2.49),('15844','2013-04-09','14:25:00',2.75),('15844','2013-04-09','14:30:00',2.74),('15844','2013-04-09','14:35:00',2.78),('15844','2013-04-09','14:40:00',2.5),('15844','2013-04-09','14:45:00',1.95),('15844','2013-04-09','14:50:00',1.85),('15844','2013-04-09','14:55:00',2.67),('15844','2013-04-09','15:00:00',2.05),('15844','2013-04-09','15:05:00',2.1),('15844','2013-04-09','15:10:00',2.27),('15844','2013-04-09','15:15:00',2.15),('15844','2013-04-09','15:20:00',2.09),('15844','2013-04-09','15:25:00',2.02),('15844','2013-04-09','15:30:00',1.91),('15844','2013-04-09','15:35:00',1.75),('15844','2013-04-09','15:40:00',1.7),('15844','2013-04-09','15:45:00',1.53),('15844','2013-04-09','15:50:00',1.41),('15844','2013-04-09','15:55:00',1.05),('15844','2013-04-09','16:00:00',1.16),('15844','2013-04-09','16:05:00',1.3),('15844','2013-04-09','16:10:00',1.17),('15844','2013-04-09','16:15:00',1.06),('15844','2013-04-09','16:20:00',1.07),('15844','2013-04-09','16:25:00',1.09),('15844','2013-04-08','08:45:00',1.13),('15844','2013-04-08','08:50:00',1.19),('15844','2013-04-08','08:55:00',1.2),('15844','2013-04-08','09:00:00',1.35),('15844','2013-04-08','09:05:00',1.63),('15844','2013-04-08','09:10:00',1.57),('15844','2013-04-08','09:15:00',1.82),('15844','2013-04-08','09:20:00',2),('15844','2013-04-08','09:25:00',2.12),('15844','2013-04-08','09:30:00',2.28),('15844','2013-04-08','09:35:00',2.48),('15844','2013-04-08','09:40:00',2.39),('15844','2013-04-08','09:45:00',1.99),('15844','2013-04-08','09:50:00',1.15),('15844','2013-04-08','09:55:00',2.36),('15844','2013-04-08','10:00:00',2.76),('15844','2013-04-08','10:05:00',2.74),('15844','2013-04-08','10:10:00',2.88),('15844','2013-04-08','10:15:00',2.89),('15844','2013-04-08','10:20:00',2.9),('15844','2013-04-08','10:25:00',2.87),('15844','2013-04-08','10:30:00',2.72),('15844','2013-04-08','10:35:00',3.2),('15844','2013-04-08','10:40:00',3.39),('15844','2013-04-08','10:45:00',3.44),('15844','2013-04-08','10:50:00',3.35),('15844','2013-04-08','10:55:00',3.4),('15844','2013-04-08','11:00:00',3.16),('15844','2013-04-08','11:05:00',2.93),('15844','2013-04-08','11:10:00',2.7),('15844','2013-04-08','11:15:00',2.22),('15844','2013-04-08','11:20:00',1.76),('15844','2013-04-08','11:25:00',1.94),('15844','2013-04-08','11:30:00',2.73),('15844','2013-04-08','11:35:00',2.7),('15844','2013-04-08','11:40:00',2.67),('15844','2013-04-08','11:45:00',2.31),('15844','2013-04-08','11:50:00',2.21),('15844','2013-04-08','11:55:00',2.13),('15844','2013-04-08','12:00:00',1.92),('15844','2013-04-08','12:05:00',1.98),('15844','2013-04-08','12:10:00',2.43),('15844','2013-04-08','12:15:00',2.43),('15844','2013-04-08','12:20:00',2.47),('15844','2013-04-08','12:25:00',2.52),('15844','2013-04-08','12:30:00',2.59),('15844','2013-04-08','12:35:00',2.35),('15844','2013-04-08','12:40:00',2.9),('15844','2013-04-08','12:45:00',2.16),('15844','2013-04-08','12:50:00',2.82),('15844','2013-04-08','12:55:00',2.22),('15844','2013-04-08','13:00:00',2.51),('15844','2013-04-08','13:05:00',2.7),('15844','2013-04-08','13:10:00',2.61),('15844','2013-04-08','13:15:00',3.22),('15844','2013-04-08','13:20:00',2.82),('15844','2013-04-08','13:25:00',2.34),('15844','2013-04-08','13:30:00',1.41),('15844','2013-04-08','13:35:00',2.3),('15844','2013-04-08','13:40:00',2.36),('15844','2013-04-08','13:45:00',2.78),('15844','2013-04-08','13:50:00',3.19),('15844','2013-04-08','13:55:00',2.91),('15844','2013-04-08','14:00:00',2.32),('15844','2013-04-08','14:05:00',2.67),('15844','2013-04-08','14:10:00',3.18),('15844','2013-04-08','14:15:00',2.6),('15844','2013-04-08','14:20:00',2.85),('15844','2013-04-08','14:25:00',2.88),('15844','2013-04-08','14:30:00',2.73),('15844','2013-04-08','14:35:00',2.68),('15844','2013-04-08','14:40:00',2.68),('15844','2013-04-08','14:45:00',2.59),('15844','2013-04-08','14:50:00',2.54),('15844','2013-04-08','14:55:00',2.22),('15844','2013-04-08','15:00:00',2.12),('15844','2013-04-08','15:05:00',2.27),('15844','2013-04-08','15:10:00',1.85),('15844','2013-04-08','15:15:00',1.75),('15844','2013-04-08','15:20:00',2.07),('15844','2013-04-08','15:25:00',1.98),('15844','2013-04-08','15:30:00',1.83),('15844','2013-04-08','15:35:00',1.71),('15844','2013-04-08','15:40:00',1.57),('15844','2013-04-08','15:45:00',1.42),('15844','2013-04-08','15:50:00',1.31),('15844','2013-04-08','15:55:00',1.24),('15844','2013-04-08','16:00:00',1.16),('15844','2013-04-08','16:05:00',1.06),('15844','2013-04-08','16:10:00',1.1),('15844','2013-04-08','16:15:00',1.07),('15844','2013-04-07','08:50:00',1.05),('15844','2013-04-07','08:55:00',1.11),('15844','2013-04-07','09:00:00',1.15),('15844','2013-04-07','09:05:00',1.18),('15844','2013-04-07','09:10:00',1.31),('15844','2013-04-07','09:15:00',1.32),('15844','2013-04-07','09:20:00',1.24),('15844','2013-04-07','09:25:00',1.31),('15844','2013-04-07','09:30:00',1.37),('15844','2013-04-07','09:35:00',1.59),('15844','2013-04-07','09:40:00',1.81),('15844','2013-04-07','09:45:00',1.78),('15844','2013-04-07','09:50:00',1.72),('15844','2013-04-07','09:55:00',1.5),('15844','2013-04-07','10:00:00',1.31),('15844','2013-04-07','10:05:00',1.79),('15844','2013-04-07','10:10:00',1.89),('15844','2013-04-07','10:15:00',2.19),('15844','2013-04-07','10:20:00',2.48),('15844','2013-04-07','10:25:00',2.58),('15844','2013-04-07','10:30:00',2.83),('15844','2013-04-07','10:35:00',3.03),('15844','2013-04-07','10:40:00',2.83),('15844','2013-04-07','10:45:00',2.66),('15844','2013-04-07','10:50:00',2.72),('15844','2013-04-07','10:55:00',1.05),('15844','2013-04-07','11:00:00',1.41),('15844','2013-04-07','11:05:00',2.45),('15844','2013-04-07','11:10:00',2.09),('15844','2013-04-07','11:15:00',1.98),('15844','2013-04-07','11:20:00',1.91),('15844','2013-04-07','11:25:00',2.17),('15844','2013-04-07','11:30:00',3.04),('15844','2013-04-07','11:35:00',3.5),('15844','2013-04-07','11:40:00',3.79),('15844','2013-04-07','11:45:00',3.71),('15844','2013-04-07','11:50:00',3.48),('15844','2013-04-07','11:55:00',2.75),('15844','2013-04-07','12:00:00',2.29),('15844','2013-04-07','12:05:00',2.4),('15844','2013-04-07','12:10:00',2.52),('15844','2013-04-07','12:15:00',2.25),('15844','2013-04-07','12:20:00',2.52),('15844','2013-04-07','12:25:00',2.82),('15844','2013-04-07','12:30:00',2.78),('15844','2013-04-07','12:35:00',2.9),('15844','2013-04-07','12:40:00',2.69),('15844','2013-04-07','12:45:00',2.78),('15844','2013-04-07','12:50:00',2.68),('15844','2013-04-07','12:55:00',2.51),('15844','2013-04-07','13:00:00',2.31),('15844','2013-04-07','13:05:00',2.51),('15844','2013-04-07','13:10:00',2.74),('15844','2013-04-07','13:15:00',2.81),('15844','2013-04-07','13:20:00',2.54),('15844','2013-04-07','13:25:00',2.22),('15844','2013-04-07','13:30:00',2.59),('15844','2013-04-07','13:35:00',2.87),('15844','2013-04-07','13:40:00',2.85),('15844','2013-04-07','13:45:00',2.55),('15844','2013-04-07','13:50:00',2.35),('15844','2013-04-07','13:55:00',2.19),('15844','2013-04-07','14:00:00',2.26),('15844','2013-04-07','14:05:00',2.37),('15844','2013-04-07','14:10:00',2.35),('15844','2013-04-07','14:15:00',2.38),('15844','2013-04-07','14:20:00',2.3),('15844','2013-04-07','14:25:00',2.27),('15844','2013-04-07','14:30:00',2.11),('15844','2013-04-07','14:35:00',2),('15844','2013-04-07','14:40:00',1.91),('15844','2013-04-07','14:45:00',1.83),('15844','2013-04-07','14:50:00',1.66),('15844','2013-04-07','14:55:00',1.59),('15844','2013-04-07','15:00:00',1.24),('15844','2013-04-07','15:05:00',1.03),('15844','2013-04-07','15:10:00',1.33),('15844','2013-04-07','15:15:00',1.42),('15844','2013-04-07','15:20:00',1.42),('15844','2013-04-07','15:25:00',1.52),('15844','2013-04-07','15:30:00',1.42),('15844','2013-04-07','15:35:00',1.5),('15844','2013-04-07','15:40:00',1.42),('15844','2013-04-07','15:45:00',1.45),('15844','2013-04-07','15:50:00',1.43),('15844','2013-04-07','15:55:00',1.28),('15844','2013-04-07','16:00:00',1.14),('15844','2013-04-07','16:05:00',1.01),('15844','2013-04-07','16:25:00',1.02),('15844','2013-04-06','08:45:00',1.03),('15844','2013-04-06','08:50:00',1.21),('15844','2013-04-06','08:55:00',1.34),('15844','2013-04-06','09:00:00',1.39),('15844','2013-04-06','09:05:00',1.51),('15844','2013-04-06','09:10:00',1.67),('15844','2013-04-06','09:15:00',1.81),('15844','2013-04-06','09:20:00',1.94),('15844','2013-04-06','09:25:00',2.09),('15844','2013-04-06','09:30:00',2.21),('15844','2013-04-06','09:35:00',2.27),('15844','2013-04-06','09:40:00',2.43),('15844','2013-04-06','09:45:00',2.49),('15844','2013-04-06','09:50:00',2.55),('15844','2013-04-06','09:55:00',2.63),('15844','2013-04-06','10:00:00',2.69),('15844','2013-04-06','10:05:00',2.79),('15844','2013-04-06','10:10:00',2.9),('15844','2013-04-06','10:15:00',2.92),('15844','2013-04-06','10:20:00',2.95),('15844','2013-04-06','10:25:00',3.05),('15844','2013-04-06','10:30:00',3.1),('15844','2013-04-06','10:35:00',3.11),('15844','2013-04-06','10:40:00',3.25),('15844','2013-04-06','10:45:00',3.41),('15844','2013-04-06','10:50:00',3.49),('15844','2013-04-06','10:55:00',3.56),('15844','2013-04-06','11:00:00',3.69),('15844','2013-04-06','11:05:00',3.75),('15844','2013-04-06','11:10:00',3.8),('15844','2013-04-06','11:15:00',3.76),('15844','2013-04-06','11:20:00',3.84),('15844','2013-04-06','11:25:00',3.92),('15844','2013-04-06','11:30:00',4),('15844','2013-04-06','11:35:00',4.06),('15844','2013-04-06','11:40:00',4.04),('15844','2013-04-06','11:45:00',4.04),('15844','2013-04-06','11:50:00',4),('15844','2013-04-06','11:55:00',3.94),('15844','2013-04-06','12:00:00',3.96),('15844','2013-04-06','12:05:00',3.98),('15844','2013-04-06','12:10:00',3.96),('15844','2013-04-06','12:15:00',3.58),('15844','2013-04-06','12:20:00',4.04),('15844','2013-04-06','12:25:00',4.12),('15844','2013-04-06','12:30:00',3.87),('15844','2013-04-06','12:35:00',3.95),('15844','2013-04-06','12:40:00',3.8),('15844','2013-04-06','12:45:00',3.66),('15844','2013-04-06','12:50:00',3.92),('15844','2013-04-06','12:55:00',2.79),('15844','2013-04-06','13:00:00',3.8),('15844','2013-04-06','13:05:00',1.82),('15844','2013-04-06','13:10:00',1.18),('15844','2013-04-06','13:15:00',3.52),('15844','2013-04-06','13:20:00',3.92),('15844','2013-04-06','13:25:00',3.01),('15844','2013-04-06','13:30:00',3.78),('15844','2013-04-06','13:35:00',2.64),('15844','2013-04-06','13:40:00',3.61),('15844','2013-04-06','13:45:00',1.29),('15844','2013-04-06','13:50:00',4.01),('15844','2013-04-06','13:55:00',3.89),('15844','2013-04-06','14:00:00',3.81),('15844','2013-04-06','14:05:00',3.54),('15844','2013-04-06','14:10:00',2.45),('15844','2013-04-06','14:15:00',3.61),('15844','2013-04-06','14:20:00',3.07),('15844','2013-04-06','14:25:00',2.93),('15844','2013-04-06','14:30:00',2.88),('15844','2013-04-06','14:35:00',2.76),('15844','2013-04-06','14:40:00',2.64),('15844','2013-04-06','14:45:00',2.55),('15844','2013-04-06','14:50:00',2.43),('15844','2013-04-06','14:55:00',2.43),('15844','2013-04-06','15:00:00',2.32),('15844','2013-04-06','15:05:00',2.2),('15844','2013-04-06','15:10:00',2.07),('15844','2013-04-06','15:15:00',1.99),('15844','2013-04-06','15:20:00',1.89),('15844','2013-04-06','15:25:00',1.78),('15844','2013-04-06','15:30:00',1.65),('15844','2013-04-06','15:35:00',1.63),('15844','2013-04-06','15:40:00',1.52),('15844','2013-04-06','15:45:00',1.41),('15844','2013-04-06','15:50:00',1.3),('15844','2013-04-06','15:55:00',1.25),('15844','2013-04-06','16:00:00',1.09),('15844','2013-04-06','16:05:00',1.02),('15844','2013-04-06','16:10:00',1.08),('15844','2013-04-06','16:15:00',1.06),('15844','2013-04-05','08:45:00',1.06),('15844','2013-04-05','08:50:00',1.38),('15844','2013-04-05','08:55:00',1.13),('15844','2013-04-05','09:20:00',1.03),('15844','2013-04-05','09:25:00',1.1),('15844','2013-04-05','09:30:00',1.31),('15844','2013-04-05','09:40:00',1.44),('15844','2013-04-05','09:45:00',1.65),('15844','2013-04-05','09:50:00',1.01),('15844','2013-04-05','10:05:00',2.21),('15844','2013-04-05','10:10:00',2.41),('15844','2013-04-05','10:15:00',1.75),('15844','2013-04-05','10:20:00',1.86),('15844','2013-04-05','10:25:00',2.93),('15844','2013-04-05','10:30:00',2.81),('15844','2013-04-05','10:35:00',3.44),('15844','2013-04-05','10:40:00',3.07),('15844','2013-04-05','10:45:00',2.39),('15844','2013-04-05','10:50:00',2.32),('15844','2013-04-05','10:55:00',3.43),('15844','2013-04-05','11:00:00',3.34),('15844','2013-04-05','11:05:00',3.52),('15844','2013-04-05','11:10:00',2.81),('15844','2013-04-05','11:15:00',4.07),('15844','2013-04-05','11:20:00',4.05),('15844','2013-04-05','11:25:00',4.02),('15844','2013-04-05','11:30:00',4.08),('15844','2013-04-05','11:35:00',4.01),('15844','2013-04-05','11:40:00',4.11),('15844','2013-04-05','11:45:00',4.22),('15844','2013-04-05','11:50:00',3.78),('15844','2013-04-05','11:55:00',3.42),('15844','2013-04-05','12:00:00',3),('15844','2013-04-05','12:05:00',3.9),('15844','2013-04-05','12:10:00',4.39),('15844','2013-04-05','12:15:00',2.33),('15844','2013-04-05','12:20:00',1.41),('15844','2013-04-05','12:25:00',1.24),('15844','2013-04-05','12:30:00',2.78),('15844','2013-04-05','12:35:00',1.14),('15844','2013-04-05','12:40:00',2.12),('15844','2013-04-05','12:45:00',3.05),('15844','2013-04-05','12:50:00',3.47),('15844','2013-04-05','12:55:00',4.35),('15844','2013-04-05','13:00:00',4.18),('15844','2013-04-05','13:05:00',3.04),('15844','2013-04-05','13:10:00',2.7),('15844','2013-04-05','13:15:00',3.58),('15844','2013-04-05','13:20:00',2.77),('15844','2013-04-05','13:25:00',3.19),('15844','2013-04-05','13:30:00',3.77),('15844','2013-04-05','13:35:00',3.77),('15844','2013-04-05','13:40:00',3.05),('15844','2013-04-05','13:45:00',3.22),('15844','2013-04-05','13:50:00',3.39),('15844','2013-04-05','13:55:00',2.74),('15844','2013-04-05','14:00:00',2.83),('15844','2013-04-05','14:05:00',2.54),('15844','2013-04-05','14:10:00',2.6),('15844','2013-04-05','14:15:00',2.06),('15844','2013-04-05','14:20:00',2.56),('15844','2013-04-05','14:25:00',2.2),('15844','2013-04-05','14:30:00',2.94),('15844','2013-04-05','14:35:00',2.83),('15844','2013-04-05','14:40:00',3.47),('15844','2013-04-05','14:45:00',3.18),('15844','2013-04-05','14:50:00',1.72),('15844','2013-04-05','14:55:00',1.43),('15844','2013-04-05','15:00:00',2.2),('15844','2013-04-05','15:05:00',1.38),('15844','2013-04-05','15:10:00',1.39),('15844','2013-04-05','15:15:00',1.17),('15844','2013-04-05','15:20:00',1.08),('15844','2013-04-05','16:05:00',1.29),('15844','2013-04-05','16:10:00',1.14),('15844','2013-04-05','16:20:00',1.03),('15844','2013-04-05','16:25:00',1.03),('15844','2013-04-05','16:30:00',1.07),('15844','2013-04-05','16:35:00',1.11),('15844','2013-04-05','16:40:00',1.31),('15844','2013-04-05','16:45:00',1.04),('15844','2013-04-05','17:00:00',1.06),('15844','2013-04-04','08:55:00',1.28),('15844','2013-04-04','09:00:00',1.34),('15844','2013-04-04','09:10:00',1.07),('15844','2013-04-04','09:15:00',1.03),('15844','2013-04-04','09:30:00',1.6),('15844','2013-04-04','09:35:00',2.15),('15844','2013-04-04','09:40:00',1.6),('15844','2013-04-04','09:45:00',1.09),('15844','2013-04-04','09:55:00',1.22),('15844','2013-04-04','10:00:00',1.8),('15844','2013-04-04','10:05:00',2.01),('15844','2013-04-04','10:10:00',1.31),('15844','2013-04-04','10:15:00',1.29),('15844','2013-04-04','10:20:00',2.08),('15844','2013-04-04','10:25:00',2.88),('15844','2013-04-04','10:30:00',1.89),('15844','2013-04-04','10:35:00',2.9),('15844','2013-04-04','10:40:00',2.45),('15844','2013-04-04','10:45:00',1.7),('15844','2013-04-04','10:50:00',3.08),('15844','2013-04-04','10:55:00',2.74),('15844','2013-04-04','11:00:00',1.14),('15844','2013-04-04','11:10:00',1.01),('15844','2013-04-04','11:15:00',1.3),('15844','2013-04-04','11:30:00',1.04),('15844','2013-04-04','11:35:00',1.91),('15844','2013-04-04','11:40:00',2.97),('15844','2013-04-04','11:45:00',3.41),('15844','2013-04-04','11:50:00',2.78),('15844','2013-04-04','11:55:00',1.79),('15844','2013-04-04','12:00:00',1.77),('15844','2013-04-04','12:05:00',3.48),('15844','2013-04-04','12:10:00',3.65),('15844','2013-04-04','12:15:00',3.4),('15844','2013-04-04','12:20:00',2.72),('15844','2013-04-04','12:25:00',2.27),('15844','2013-04-04','12:30:00',3.09),('15844','2013-04-04','12:35:00',2.01),('15844','2013-04-04','12:40:00',1.9),('15844','2013-04-04','12:45:00',3.12),('15844','2013-04-04','12:50:00',2.46),('15844','2013-04-04','12:55:00',1.96),('15844','2013-04-04','13:00:00',2.49),('15844','2013-04-04','13:05:00',3.47),('15844','2013-04-04','13:10:00',3.67),('15844','2013-04-04','13:15:00',3.64),('15844','2013-04-04','13:20:00',3.62),('15844','2013-04-04','13:25:00',3.63),('15844','2013-04-04','13:30:00',3.34),('15844','2013-04-04','13:35:00',3.06),('15844','2013-04-04','13:40:00',2.75),('15844','2013-04-04','13:45:00',2.57),('15844','2013-04-04','13:50:00',2.31),('15844','2013-04-04','13:55:00',1.94),('15844','2013-04-04','14:00:00',2.39),('15844','2013-04-04','14:05:00',3.27),('15844','2013-04-04','14:10:00',3.28),('15844','2013-04-04','14:15:00',3.1),('15844','2013-04-04','14:20:00',2.99),('15844','2013-04-04','14:25:00',2.96),('15844','2013-04-04','14:30:00',2.94),('15844','2013-04-04','14:35:00',2.86),('15844','2013-04-04','14:40:00',2.66),('15844','2013-04-04','14:45:00',2.59),('15844','2013-04-04','14:50:00',2.41),('15844','2013-04-04','14:55:00',2.28),('15844','2013-04-04','15:00:00',2.2),('15844','2013-04-04','15:05:00',2.04),('15844','2013-04-04','15:10:00',1.85),('15844','2013-04-04','15:15:00',1.95),('15844','2013-04-04','15:20:00',1.83),('15844','2013-04-04','15:25:00',1.85),('15844','2013-04-04','15:30:00',1.74),('15844','2013-04-04','15:35:00',1.59),('15844','2013-04-04','15:40:00',1.51),('15844','2013-04-04','15:45:00',1.45),('15844','2013-04-04','15:50:00',1.39),('15844','2013-04-04','15:55:00',1.34),('15844','2013-04-04','16:00:00',1.26),('15844','2013-04-04','16:05:00',1.25),('15844','2013-04-04','16:10:00',1.18),('15844','2013-04-04','16:15:00',1.22),('15844','2013-04-04','16:20:00',1.22),('15844','2013-04-04','16:25:00',1.2),('15844','2013-04-03','08:20:00',1.01),('15844','2013-04-03','08:25:00',1.07),('15844','2013-04-03','08:30:00',1),('15844','2013-04-03','08:40:00',1.01),('15844','2013-04-03','08:45:00',1.08),('15844','2013-04-03','08:50:00',1.19),('15844','2013-04-03','08:55:00',1.28),('15844','2013-04-03','09:00:00',1.3),('15844','2013-04-03','09:05:00',1.4),('15844','2013-04-03','09:10:00',1.76),('15844','2013-04-03','09:15:00',1.18),('15844','2013-04-03','09:20:00',1.87),('15844','2013-04-03','09:25:00',2.11),('15844','2013-04-03','09:30:00',2.45),('15844','2013-04-03','09:35:00',2.28),('15844','2013-04-03','09:40:00',2.15),('15844','2013-04-03','09:45:00',2.74),('15844','2013-04-03','09:50:00',2.36),('15844','2013-04-03','09:55:00',1.14),('15844','2013-04-03','10:00:00',1.1),('15844','2013-04-03','10:05:00',2.47),('15844','2013-04-03','10:10:00',2.01),('15844','2013-04-03','10:15:00',2.93),('15844','2013-04-03','10:20:00',2.89),('15844','2013-04-03','10:25:00',1.79),('15844','2013-04-03','10:30:00',1.49),('15844','2013-04-03','10:35:00',1.51),('15844','2013-04-03','10:40:00',1.66),('15844','2013-04-03','10:45:00',3.08),('15844','2013-04-03','10:50:00',3.76),('15844','2013-04-03','10:55:00',2.14),('15844','2013-04-03','11:00:00',2.52),('15844','2013-04-03','11:05:00',3.52),('15844','2013-04-03','11:10:00',3.22),('15844','2013-04-03','11:15:00',1.95),('15844','2013-04-03','11:20:00',2.06),('15844','2013-04-03','11:30:00',1.06),('15844','2013-04-03','11:35:00',2.04),('15844','2013-04-03','11:40:00',2.58),('15844','2013-04-03','11:45:00',2.78),('15844','2013-04-03','11:50:00',1.79),('15844','2013-04-03','11:55:00',4.29),('15844','2013-04-03','12:00:00',2.56),('15844','2013-04-03','12:05:00',1.78),('15844','2013-04-03','12:10:00',4.1),('15844','2013-04-03','12:15:00',2.94),('15844','2013-04-03','12:20:00',3.96),('15844','2013-04-03','12:25:00',4.2),('15844','2013-04-03','12:30:00',4.55),('15844','2013-04-03','12:35:00',4.33),('15844','2013-04-03','12:40:00',4.02),('15844','2013-04-03','12:45:00',2.31),('15844','2013-04-03','12:50:00',4.21),('15844','2013-04-03','12:55:00',3.27),('15844','2013-04-03','13:00:00',1.83),('15844','2013-04-03','13:05:00',2.8),('15844','2013-04-03','13:10:00',2.66),('15844','2013-04-03','13:15:00',2.89),('15844','2013-04-03','13:20:00',4.01),('15844','2013-04-03','13:25:00',2.74),('15844','2013-04-03','13:30:00',4.09),('15844','2013-04-03','13:35:00',4.4),('15844','2013-04-03','13:40:00',4.36),('15844','2013-04-03','13:45:00',4.2),('15844','2013-04-03','13:50:00',3.85),('15844','2013-04-03','13:55:00',3.72),('15844','2013-04-03','14:00:00',3.9),('15844','2013-04-03','14:05:00',3.9),('15844','2013-04-03','14:10:00',3.18),('15844','2013-04-03','14:15:00',3.05),('15844','2013-04-03','14:20:00',3.01),('15844','2013-04-03','14:25:00',3.68),('15844','2013-04-03','14:30:00',2.69),('15844','2013-04-03','14:35:00',3.13),('15844','2013-04-03','14:40:00',2.88),('15844','2013-04-03','14:45:00',2.27),('15844','2013-04-03','14:50:00',2.71),('15844','2013-04-03','14:55:00',2.44),('15844','2013-04-03','15:00:00',2.59),('15844','2013-04-03','15:05:00',2.34),('15844','2013-04-03','15:10:00',2.09),('15844','2013-04-03','15:15:00',2.11),('15844','2013-04-03','15:20:00',1.83),('15844','2013-04-03','15:25:00',1.86),('15844','2013-04-03','15:30:00',1.48),('15844','2013-04-03','15:35:00',1.73),('15844','2013-04-03','15:40:00',1.08),('15844','2013-04-03','15:50:00',1.36),('15844','2013-04-03','15:55:00',1.19),('15844','2013-04-03','16:00:00',1.01),('15844','2013-04-03','16:05:00',1.19),('15844','2013-04-03','16:10:00',1.08),('15844','2013-04-02','08:40:00',1.49),('15844','2013-04-02','08:45:00',1.13),('15844','2013-04-02','09:00:00',1.5),('15844','2013-04-02','09:05:00',1.59),('15844','2013-04-02','09:10:00',1.72),('15844','2013-04-02','09:15:00',1.78),('15844','2013-04-02','09:20:00',1.84),('15844','2013-04-02','09:25:00',2.11),('15844','2013-04-02','09:30:00',2.25),('15844','2013-04-02','09:35:00',2.07),('15844','2013-04-02','09:40:00',2.27),('15844','2013-04-02','09:45:00',2.66),('15844','2013-04-02','09:50:00',2.81),('15844','2013-04-02','09:55:00',2.69),('15844','2013-04-02','10:00:00',2.89),('15844','2013-04-02','10:05:00',2.18),('15844','2013-04-02','10:10:00',2.16),('15844','2013-04-02','10:15:00',2.86),('15844','2013-04-02','10:20:00',3.19),('15844','2013-04-02','10:25:00',3.7),('15844','2013-04-02','10:30:00',3.99),('15844','2013-04-02','10:35:00',3.29),('15844','2013-04-02','10:40:00',1.31),('15844','2013-04-02','10:45:00',1.81),('15844','2013-04-02','10:50:00',3.79),('15844','2013-04-02','10:55:00',2.69),('15844','2013-04-02','11:00:00',3.44),('15844','2013-04-02','11:05:00',3.45),('15844','2013-04-02','11:10:00',3.77),('15844','2013-04-02','11:15:00',2.54),('15844','2013-04-02','11:20:00',3.15),('15844','2013-04-02','11:25:00',1.19),('15844','2013-04-02','11:30:00',2.18),('15844','2013-04-02','11:35:00',3.41),('15844','2013-04-02','11:40:00',2),('15844','2013-04-02','11:45:00',1.16),('15844','2013-04-02','11:50:00',1.3),('15844','2013-04-02','12:00:00',1.03),('15844','2013-04-02','12:05:00',2.86),('15844','2013-04-02','12:10:00',2.15),('15844','2013-04-02','12:15:00',1.38),('15844','2013-04-02','12:25:00',1.03),('15844','2013-04-02','12:30:00',3.61),('15844','2013-04-02','12:35:00',3.32),('15844','2013-04-02','12:40:00',2.8),('15844','2013-04-02','12:45:00',3.96),('15844','2013-04-02','12:50:00',2.3),('15844','2013-04-02','12:55:00',1.96),('15844','2013-04-02','13:00:00',2.36),('15844','2013-04-02','13:05:00',2.55),('15844','2013-04-02','13:10:00',1.26),('15844','2013-04-02','13:15:00',1.04),('15844','2013-04-02','13:20:00',1.36),('15844','2013-04-02','13:25:00',1.52),('15844','2013-04-02','13:30:00',1.47),('15844','2013-04-02','13:35:00',1.93),('15844','2013-04-02','13:40:00',2.1),('15844','2013-04-02','13:45:00',1.81),('15844','2013-04-02','13:55:00',1.78),('15844','2013-04-02','14:00:00',2.83),('15844','2013-04-02','14:05:00',2.61),('15844','2013-04-02','14:10:00',2.61),('15844','2013-04-02','14:15:00',2.68),('15844','2013-04-02','14:20:00',1.72),('15844','2013-04-02','14:25:00',1.24),('15844','2013-04-02','14:40:00',1.26),('15844','2013-04-02','15:15:00',1.28),('15844','2014-05-02','08:40:00',1.12),('15844','2014-05-02','08:50:00',1.01),('15844','2014-05-02','08:55:00',1.21),('15844','2014-05-02','09:00:00',1.33),('15844','2014-05-02','09:05:00',1.2),('15844','2014-05-02','09:10:00',1.49),('15844','2014-05-02','09:15:00',2.01),('15844','2014-05-02','09:20:00',2.1),('15844','2014-05-02','09:25:00',1.3),('15844','2014-05-02','09:30:00',1.42),('15844','2014-05-02','09:35:00',2.25),('15844','2014-05-02','09:40:00',2.28),('15844','2014-05-02','09:45:00',1.87),('15844','2014-05-02','09:50:00',1.76),('15844','2014-05-02','09:55:00',1.52),('15844','2014-05-02','10:00:00',1.14),('15844','2014-05-02','12:40:00',1.29),('15844','2014-05-02','12:45:00',1.69),('15844','2014-05-02','12:50:00',2.01),('15844','2014-05-02','12:55:00',2.31),('15844','2014-05-02','13:00:00',2.06),('15844','2014-05-02','13:05:00',2.15),('15844','2014-05-02','13:10:00',2.95),('15844','2014-05-02','13:15:00',2.56),('15844','2014-05-02','13:20:00',3.44),('15844','2014-05-02','13:25:00',3.68),('15844','2014-05-02','13:30:00',2.41),('15844','2014-05-02','13:35:00',2.38),('15844','2014-05-02','13:40:00',3.28),('15844','2014-05-02','13:45:00',2.62),('15844','2014-05-02','13:50:00',1.96),('15844','2014-05-02','13:55:00',3.36),('15844','2014-05-02','14:00:00',3.69),('15844','2014-05-02','14:05:00',2.91),('15844','2014-05-02','14:10:00',1.89),('15844','2014-05-02','14:15:00',2.2),('15844','2014-05-02','14:20:00',1.49),('15844','2014-05-02','14:25:00',1.51),('15844','2014-05-02','14:30:00',1.34),('15844','2014-05-02','14:50:00',1.27),('15844','2014-05-02','14:55:00',1.15),('15844','2014-05-02','15:00:00',1.05),('15844','2014-05-02','15:05:00',1.82),('15844','2014-05-02','15:10:00',1.54),('15844','2014-05-02','15:15:00',1.79),('15844','2014-05-02','15:20:00',1.7),('15844','2014-05-02','15:25:00',1.39),('15844','2014-05-02','15:30:00',1.88),('15844','2014-05-02','15:35:00',2.37),('15844','2014-05-02','15:50:00',1.04),('15844','2014-05-02','15:55:00',1.51),('15844','2014-05-02','16:00:00',1.48),('15844','2014-05-02','16:05:00',1.35),('15844','2014-05-02','16:10:00',1.1),('15844','2014-03-27','09:15:00',1.12),('15844','2014-03-27','09:20:00',1.04),('15844','2014-03-27','09:25:00',1.06),('15844','2014-03-27','10:05:00',1.18),('15844','2014-03-27','10:10:00',1.33),('15844','2014-03-27','10:15:00',1.46),('15844','2014-03-27','10:20:00',1.39),('15844','2014-03-27','10:25:00',1.28),('15844','2014-03-27','10:35:00',1.22),('15844','2014-03-27','10:40:00',1.89),('15844','2014-03-27','10:45:00',1.72),('15844','2014-03-27','11:05:00',1.2),('15844','2014-03-27','11:10:00',1.51),('15844','2014-03-27','11:50:00',1.42),('15844','2014-03-27','11:55:00',4.75),('15844','2014-03-27','12:00:00',3.26),('15844','2014-03-27','12:05:00',1),('15844','2014-03-27','13:00:00',1.03),('15844','2014-03-27','13:05:00',1.35),('15844','2014-03-27','13:10:00',2.15),('15844','2014-03-27','13:15:00',2.18),('15844','2014-03-27','13:20:00',2.1),('15844','2014-03-27','13:25:00',1.91),('15844','2014-03-27','13:30:00',1.69),('15844','2014-03-27','13:35:00',1.86),('15844','2014-03-27','13:40:00',1.72),('15844','2014-03-27','13:45:00',1.51),('15844','2014-03-27','13:50:00',1.54),('15844','2014-03-27','13:55:00',1.67),('15844','2014-03-27','14:00:00',2.23),('15844','2014-03-27','14:05:00',2.41),('15844','2014-03-27','14:20:00',2.26),('15844','2014-03-27','14:25:00',1.79),('15844','2014-03-27','14:30:00',1.74),('15844','2014-03-27','14:35:00',1.3),('15844','2014-03-27','14:40:00',1.53),('15844','2014-03-27','14:45:00',1.55),('15844','2014-03-27','14:50:00',1.66),('15844','2014-03-27','14:55:00',1.66),('15844','2014-03-27','15:35:00',1.17),('15844','2014-03-27','15:40:00',1.3),('15844','2014-03-27','15:45:00',1.16),('15844','2013-04-01','08:25:00',1.02),('15844','2013-04-01','08:30:00',1.33),('15844','2013-04-01','08:35:00',1.41),('15844','2013-04-01','08:55:00',1.38),('15844','2013-04-01','09:00:00',1.45),('15844','2013-04-01','09:05:00',1.56),('15844','2013-04-01','09:10:00',1.75),('15844','2013-04-01','09:15:00',1.77),('15844','2013-04-01','09:20:00',1.33),('15844','2013-04-01','09:25:00',1.86),('15844','2013-04-01','09:40:00',2.23),('15844','2013-04-01','09:45:00',2.26),('15844','2013-04-01','09:50:00',2.24),('15844','2013-04-01','09:55:00',2.16),('15844','2013-04-01','10:00:00',2.59),('15844','2013-04-01','10:05:00',2.12),('15844','2013-04-01','10:10:00',2.63),('15844','2013-04-01','10:15:00',2.73),('15844','2013-04-01','10:20:00',3.03),('15844','2013-04-01','10:25:00',3.29),('15844','2013-04-01','10:30:00',2.86),('15844','2013-04-01','10:35:00',3.32),('15844','2013-04-01','10:40:00',3.71),('15844','2013-04-01','10:45:00',3.95),('15844','2013-04-01','10:50:00',4.24),('15844','2013-04-01','10:55:00',3.68),('15844','2013-04-01','11:00:00',4.21),('15844','2013-04-01','11:05:00',3.41),('15844','2013-04-01','11:10:00',2.07),('15844','2013-04-01','11:15:00',1.51),('15844','2013-04-01','11:20:00',1.28),('15844','2013-04-01','11:25:00',2.15),('15844','2013-04-01','11:30:00',1.7),('15844','2013-04-01','11:35:00',2.45),('15844','2013-04-01','11:40:00',2.51),('15844','2013-04-01','11:45:00',1.82),('15844','2013-04-01','11:50:00',1.89),('15844','2013-04-01','11:55:00',2.13),('15844','2013-04-01','12:00:00',1.68),('15844','2013-04-01','12:05:00',1.7),('15844','2013-04-01','12:10:00',2.12),('15844','2013-04-01','12:15:00',1.8),('15844','2013-04-01','12:20:00',1.37),('15844','2013-04-01','12:25:00',1.39),('15844','2013-04-01','12:30:00',2.04),('15844','2013-04-01','12:35:00',1.67),('15844','2013-04-01','12:40:00',2.11),('15844','2013-04-01','12:45:00',2.26),('15844','2013-04-01','12:50:00',2.58),('15844','2013-04-01','12:55:00',2.54),('15844','2013-04-01','13:00:00',2.6),('15844','2013-04-01','13:05:00',2.89),('15844','2013-04-01','13:10:00',2.44),('15844','2013-04-01','13:15:00',2.24),('15844','2013-04-01','13:20:00',2.03),('15844','2013-04-01','13:25:00',1.9),('15844','2013-04-01','13:30:00',2.34),('15844','2013-04-01','13:35:00',2.1),('15844','2013-04-01','13:40:00',2.85),('15844','2013-04-01','13:45:00',2.83),('15844','2013-04-01','13:50:00',2.9),('15844','2013-04-01','13:55:00',2.59),('15844','2013-04-01','14:00:00',1.6),('15844','2013-04-01','14:05:00',1.61),('15844','2013-04-01','14:10:00',1.87),('15844','2013-04-01','14:15:00',1.93),('15844','2013-04-01','14:20:00',2.54),('15844','2013-04-01','14:25:00',2.34),('15844','2013-04-01','14:30:00',1.62),('15844','2013-04-01','14:35:00',1.82),('15844','2013-04-01','14:40:00',1.45),('15844','2013-04-01','14:45:00',1.75),('15844','2013-04-01','14:50:00',1.81),('15844','2013-04-01','14:55:00',1.66),('15844','2013-04-01','15:00:00',1.56),('15844','2013-04-01','15:05:00',1.55),('15844','2013-04-01','15:10:00',1.71),('15844','2013-04-01','15:15:00',1.68),('15844','2013-04-01','15:20:00',1.68),('15844','2013-04-01','15:25:00',1.61),('15844','2013-04-01','15:30:00',1.6),('15844','2013-04-01','15:35:00',1.61),('15844','2013-04-01','15:40:00',1.57),('15844','2013-04-01','15:45:00',1.93),('15844','2013-04-01','15:50:00',1.83),('15844','2013-04-01','15:55:00',1.39),('15844','2013-04-01','16:00:00',1.27),('15844','2013-04-01','16:05:00',1.14),('15844','2013-03-31','08:50:00',1.01),('15844','2013-03-31','09:15:00',1.17),('15844','2013-03-31','09:20:00',1.08),('15844','2013-03-31','09:25:00',1.73),('15844','2013-03-31','09:30:00',2.24),('15844','2013-03-31','09:35:00',1.63),('15844','2013-03-31','09:40:00',2.33),('15844','2013-03-31','09:45:00',1.3),('15844','2013-03-31','10:10:00',1.03),('15844','2013-03-31','10:15:00',1.45),('15844','2013-03-31','10:20:00',1.59),('15844','2013-03-31','10:25:00',1.75),('15844','2013-03-31','10:30:00',1.68),('15844','2013-03-31','10:35:00',1.08),('15844','2013-03-31','10:45:00',1.2),('15844','2013-03-31','10:50:00',1.35),('15844','2013-03-31','11:05:00',2.2),('15844','2013-03-31','11:20:00',1.06),('15844','2013-03-31','11:25:00',1.76),('15844','2013-03-31','11:30:00',1.51),('15844','2013-03-31','11:35:00',2.65),('15844','2013-03-31','11:40:00',3.49),('15844','2013-03-31','11:45:00',3.98),('15844','2013-03-31','11:50:00',1.57),('15844','2013-03-31','11:55:00',1.16),('15844','2013-03-31','12:25:00',1.07),('15844','2013-03-31','12:30:00',2.25),('15844','2013-03-31','12:35:00',4.08),('15844','2013-03-31','12:40:00',2.35),('15844','2013-03-31','12:45:00',2.7),('15844','2013-03-31','12:50:00',1.99),('15844','2013-03-31','12:55:00',2.45),('15844','2013-03-31','13:00:00',2.71),('15844','2013-03-31','13:05:00',2),('15844','2013-03-31','13:10:00',2.28),('15844','2013-03-31','13:15:00',2.85),('15844','2013-03-31','13:20:00',4.05),('15844','2013-03-31','13:25:00',1.82),('15844','2013-03-31','13:35:00',1.31),('15844','2013-03-31','13:40:00',4.02),('15844','2013-03-31','13:45:00',2.84),('15844','2013-03-31','13:50:00',3.38),('15844','2013-03-31','13:55:00',2.93),('15844','2013-03-31','14:00:00',2.28),('15844','2013-03-31','14:05:00',1.93),('15844','2013-03-31','14:10:00',1.4),('15844','2013-03-31','14:15:00',2.99),('15844','2013-03-31','14:20:00',2.35),('15844','2013-03-31','14:25:00',2.41),('15844','2013-03-31','14:30:00',3.33),('15844','2013-03-31','14:35:00',2.81),('15844','2013-03-31','14:40:00',2.3),('15844','2013-03-31','14:45:00',2.05),('15844','2013-03-31','14:50:00',2.66),('15844','2013-03-31','14:55:00',3.41),('15844','2013-03-31','15:00:00',2.22),('15844','2013-03-31','15:05:00',2.88),('15844','2013-03-31','15:10:00',2.2),('15844','2013-03-31','15:15:00',2.59),('15844','2013-03-31','15:20:00',2.06),('15844','2013-03-31','15:25:00',2.12),('15844','2013-03-31','15:30:00',1.99),('15844','2013-03-31','15:35:00',1.88),('15844','2013-03-31','15:40:00',1.73),('15844','2013-03-31','15:45:00',1.33),('15844','2013-03-31','16:15:00',1.68),('15844','2013-03-31','16:20:00',1.37),('15844','2013-03-31','16:35:00',1.06),('15844','2013-03-30','09:20:00',1.11),('15844','2013-03-30','09:25:00',1.38),('15844','2013-03-30','09:30:00',1.83),('15844','2013-03-30','09:35:00',1.5),('15844','2013-03-30','09:40:00',1.4),('15844','2013-03-30','09:45:00',1.45),('15844','2013-03-30','09:50:00',1.51),('15844','2013-03-30','09:55:00',1.64),('15844','2013-03-30','10:00:00',1.72),('15844','2013-03-30','10:05:00',1.86),('15844','2013-03-30','10:10:00',1.48),('15844','2013-03-30','10:15:00',1.19),('15844','2013-03-30','10:20:00',1.28),('15844','2013-03-30','10:25:00',1.39),('15844','2013-03-30','10:30:00',1.61),('15844','2013-03-30','10:35:00',1.78),('15844','2013-03-30','10:40:00',1.78),('15844','2013-03-30','10:45:00',1.59),('15844','2013-03-30','10:50:00',1.74),('15844','2013-03-30','10:55:00',2.28),('15844','2013-03-30','11:00:00',2.48),('15844','2013-03-30','11:05:00',2.49),('15844','2013-03-30','11:10:00',2.4),('15844','2013-03-30','11:15:00',2.43),('15844','2013-03-30','11:20:00',1.75),('15844','2013-03-30','11:25:00',1.75),('15844','2013-03-30','11:30:00',3.17),('15844','2013-03-30','11:35:00',2.25),('15844','2013-03-30','11:40:00',2.31),('15844','2013-03-30','11:45:00',1.46),('15844','2013-03-30','11:50:00',1.77),('15844','2013-03-30','11:55:00',1.61),('15844','2013-03-30','12:00:00',1.34),('15844','2013-03-30','12:05:00',1.12),('15844','2013-03-30','13:00:00',1.44),('15844','2013-03-30','13:05:00',1.57),('15844','2013-03-30','13:10:00',1.45),('15844','2013-03-30','13:15:00',2.26),('15844','2013-03-30','13:20:00',1.25),('15844','2013-03-30','13:35:00',1.2),('15844','2013-03-30','13:45:00',1.38),('15844','2013-03-30','13:50:00',1.64),('15844','2013-03-30','13:55:00',1.47),('15844','2013-03-30','14:00:00',1.19),('15844','2013-03-30','14:05:00',1.29),('15844','2013-03-30','14:10:00',1.13),('15844','2013-03-30','14:15:00',1.01),('15844','2013-03-30','14:20:00',2.02),('15844','2013-03-30','14:25:00',1.33),('15844','2013-03-30','14:40:00',1.14),('15844','2013-03-30','14:45:00',1.39),('15844','2013-03-30','14:50:00',1.08),('15844','2013-03-29','07:45:00',1.03),('15844','2013-03-29','07:50:00',1.35),('15844','2013-03-29','08:05:00',1.34),('15844','2013-03-29','08:10:00',1.64),('15844','2013-03-29','08:15:00',1.81),('15844','2013-03-29','08:20:00',1.89),('15844','2013-03-29','08:25:00',2.01),('15844','2013-03-29','08:30:00',2.11),('15844','2013-03-29','08:35:00',2.19),('15844','2013-03-29','08:40:00',2.2),('15844','2013-03-29','08:45:00',2.27),('15844','2013-03-29','08:50:00',1.87),('15844','2013-03-29','08:55:00',2.22),('15844','2013-03-29','09:00:00',2.43),('15844','2013-03-29','09:05:00',2.39),('15844','2013-03-29','09:10:00',2.58),('15844','2013-03-29','09:15:00',2.89),('15844','2013-03-29','09:20:00',2.81),('15844','2013-03-29','09:25:00',2.62),('15844','2013-03-29','09:30:00',3.03),('15844','2013-03-29','09:35:00',3.22),('15844','2013-03-29','09:40:00',2.94),('15844','2013-03-29','09:45:00',2.92),('15844','2013-03-29','09:50:00',3.03),('15844','2013-03-29','09:55:00',3.24),('15844','2013-03-29','10:00:00',3.18),('15844','2013-03-29','10:05:00',2.57),('15844','2013-03-29','10:10:00',2.94),('15844','2013-03-29','10:15:00',3.08),('15844','2013-03-29','10:20:00',3.04),('15844','2013-03-29','10:25:00',2.98),('15844','2013-03-29','10:30:00',3.2),('15844','2013-03-29','10:35:00',3.59),('15844','2013-03-29','10:40:00',3.52),('15844','2013-03-29','10:45:00',3.45),('15844','2013-03-29','10:50:00',3.35),('15844','2013-03-29','10:55:00',3.66),('15844','2013-03-29','11:00:00',3.49),('15844','2013-03-29','11:05:00',3.9),('15844','2013-03-29','11:10:00',4.04),('15844','2013-03-29','11:15:00',4.01),('15844','2013-03-29','11:20:00',4.04),('15844','2013-03-29','11:25:00',4.01),('15844','2013-03-29','11:30:00',3.85),('15844','2013-03-29','11:35:00',3.94),('15844','2013-03-29','11:40:00',3.98),('15844','2013-03-29','11:45:00',3.45),('15844','2013-03-29','11:50:00',3.99),('15844','2013-03-29','11:55:00',4),('15844','2013-03-29','12:00:00',3.94),('15844','2013-03-29','12:05:00',4),('15844','2013-03-29','12:10:00',3.86),('15844','2013-03-29','12:15:00',3.81),('15844','2013-03-29','12:20:00',3.79),('15844','2013-03-29','12:25:00',3.56),('15844','2013-03-29','12:30:00',3.75),('15844','2013-03-29','12:35:00',3.56),('15844','2013-03-29','12:40:00',3.52),('15844','2013-03-29','12:45:00',3.71),('15844','2013-03-29','12:50:00',3.61),('15844','2013-03-29','12:55:00',3.58),('15844','2013-03-29','13:00:00',3.35),('15844','2013-03-29','13:05:00',3.26),('15844','2013-03-29','13:10:00',3.12),('15844','2013-03-29','13:15:00',2.71),('15844','2013-03-29','13:20:00',3.3),('15844','2013-03-29','13:25:00',3.3),('15844','2013-03-29','13:30:00',2.71),('15844','2013-03-29','13:35:00',2.29),('15844','2013-03-29','13:40:00',2.59),('15844','2013-03-29','13:45:00',2.55),('15844','2013-03-29','13:50:00',2.56),('15844','2013-03-29','13:55:00',2.56),('15844','2013-03-29','14:00:00',2.31),('15844','2013-03-29','14:05:00',1.7),('15844','2013-03-29','14:10:00',1.68),('15844','2013-03-29','14:15:00',1.67),('15844','2013-03-29','14:20:00',1.75),('15844','2013-03-29','14:25:00',1.7),('15844','2013-03-29','14:30:00',1.53),('15844','2013-03-29','14:35:00',1.47),('15844','2013-03-29','14:40:00',1.47),('15844','2013-03-29','14:45:00',1.39),('15844','2013-03-29','14:50:00',1.4),('15844','2013-03-29','14:55:00',1.32),('15844','2013-03-29','15:00:00',1.24),('15844','2013-03-29','15:05:00',1.18),('15844','2013-03-29','15:10:00',1.12),('15844','2013-03-29','15:15:00',1.11),('15844','2013-03-29','15:20:00',1.04),('15844','2013-03-28','09:15:00',1.36),('15844','2013-03-28','09:20:00',1.28),('15844','2013-03-28','09:25:00',1.43),('15844','2013-03-28','12:55:00',1.12),('15844','2013-03-28','13:00:00',2.16),('15844','2013-03-28','13:05:00',2.07),('15844','2013-03-28','13:10:00',1.87),('15844','2013-03-28','13:15:00',2.26),('15844','2013-03-28','13:20:00',3.11),('15844','2013-03-28','13:25:00',2.93),('15844','2013-03-28','13:30:00',1.97),('15844','2013-03-28','13:35:00',1.17),('15844','2013-03-28','13:40:00',1.09),('15844','2013-03-28','13:45:00',1.02),('15844','2013-03-28','14:00:00',1.34),('15844','2013-03-28','14:05:00',2.11),('15844','2013-03-28','14:10:00',1.99),('15844','2013-03-28','14:15:00',1.74),('15844','2013-03-28','14:20:00',1.18),('15844','2013-03-28','14:30:00',1.22),('15844','2013-03-28','15:05:00',1.66),('15844','2013-03-28','15:10:00',2.23),('15844','2013-03-28','15:15:00',1.81),('15844','2013-03-28','15:20:00',1.2),('15844','2013-03-28','15:45:00',1.18),('15844','2013-03-28','15:50:00',1),('15844','2013-03-27','07:45:00',1.14),('15844','2013-03-27','07:50:00',1.42),('15844','2013-03-27','07:55:00',1.46),('15844','2013-03-27','08:00:00',1.15),('15844','2013-03-27','08:10:00',1.1),('15844','2013-03-27','08:15:00',1.12),('15844','2013-03-27','08:20:00',1.06),('15844','2013-03-27','08:25:00',1.43),('15844','2013-03-27','08:30:00',1.61),('15844','2013-03-27','08:35:00',1.55),('15844','2013-03-27','08:40:00',1.1),('15844','2013-03-27','08:45:00',1.51),('15844','2013-03-27','08:50:00',1.22),('15844','2013-03-27','08:55:00',1.1),('15844','2013-03-27','09:10:00',1.86),('15844','2013-03-27','09:15:00',1.88),('15844','2013-03-27','09:20:00',1.24),('15844','2013-03-27','09:50:00',2.77),('15844','2013-03-27','09:55:00',2.31),('15844','2013-03-27','10:00:00',1.39),('15844','2013-03-27','10:05:00',1.24),('15844','2013-03-27','10:10:00',1.93),('15844','2013-03-27','10:15:00',1.23),('15844','2013-03-27','10:25:00',1.13),('15844','2013-03-27','10:30:00',1.2),('15844','2013-03-27','10:35:00',1.14),('15844','2013-03-27','10:40:00',1.29),('15844','2013-03-27','10:45:00',1.71),('15844','2013-03-27','10:50:00',1.28),('15844','2013-03-27','11:15:00',1.12),('15844','2013-03-27','11:20:00',1.15),('15844','2013-03-27','11:25:00',1.81),('15844','2013-03-27','11:30:00',1.88),('15844','2013-03-27','11:35:00',1.6),('15844','2013-03-27','11:40:00',1.67),('15844','2013-03-27','11:45:00',1.66),('15844','2013-03-27','11:50:00',2.23),('15844','2013-03-27','11:55:00',2.55),('15844','2013-03-27','12:00:00',2.62),('15844','2013-03-27','12:05:00',2.65),('15844','2013-03-27','12:10:00',2.71),('15844','2013-03-27','12:15:00',2.16),('15844','2013-03-27','12:20:00',1.31),('15844','2013-03-27','12:25:00',1.75),('15844','2013-03-27','12:30:00',1.44),('15844','2013-03-27','12:35:00',1.47),('15844','2013-03-27','12:40:00',2.56),('15844','2013-03-27','12:45:00',1.92),('15844','2013-03-27','12:50:00',1.46),('15844','2013-03-27','12:55:00',1.34),('15844','2013-03-27','13:00:00',1.62),('15844','2013-03-27','13:05:00',1.78),('15844','2013-03-27','13:10:00',1.6),('15844','2013-03-27','13:15:00',1.38),('15844','2013-03-27','13:20:00',1.28),('15844','2013-03-27','13:25:00',1.23),('15844','2013-03-27','13:30:00',1.39),('15844','2013-03-27','13:35:00',1.68),('15844','2013-03-27','13:40:00',1.98),('15844','2013-03-27','13:45:00',1.91),('15844','2013-03-27','13:50:00',1.39),('15844','2013-03-27','13:55:00',1.32),('15844','2013-03-27','14:00:00',1.25),('15844','2013-03-27','14:05:00',1.24),('15844','2013-03-27','14:10:00',1.5),('15844','2013-03-27','14:15:00',1.55),('15844','2013-03-27','14:20:00',1.13),('15844','2013-03-27','14:35:00',1.15),('15844','2013-03-27','14:40:00',1.24),('15844','2013-03-26','07:50:00',1.03),('15844','2013-03-26','09:10:00',1.59),('15844','2013-03-26','09:45:00',1.42),('15844','2013-03-26','09:50:00',1.03),('15844','2013-03-26','09:55:00',1.6),('15844','2013-03-26','10:50:00',1.09),('15844','2013-03-26','11:00:00',1.47),('15844','2013-03-26','11:05:00',1.06),('15844','2013-03-26','11:10:00',2.04),('15844','2013-03-26','11:50:00',1.76),('15844','2013-03-26','11:55:00',2.23),('15844','2013-03-26','12:00:00',2.09),('15844','2013-03-26','12:05:00',1.28),('15844','2013-03-26','12:10:00',1.22),('15844','2013-03-26','12:15:00',1.24),('15844','2013-03-26','12:20:00',2.01),('15844','2013-03-26','12:25:00',2.92),('15844','2013-03-26','12:30:00',2.48),('15844','2013-03-26','12:35:00',1.57),('15844','2013-03-26','12:40:00',2.28),('15844','2013-03-26','12:45:00',1.43),('15844','2013-03-26','12:50:00',1.42),('15844','2013-03-26','12:55:00',1.23),('15844','2013-03-26','13:00:00',2.4),('15844','2013-03-26','13:05:00',1.68),('15844','2013-03-26','13:10:00',1.55),('15844','2013-03-26','13:15:00',1.12),('15844','2013-03-26','13:20:00',1.48),('15844','2013-03-26','13:25:00',1.44),('15844','2013-03-26','13:30:00',1.43),('15844','2013-03-26','13:35:00',1.87),('15844','2013-03-26','13:40:00',1.93),('15844','2013-03-26','13:45:00',1.43),('15844','2013-03-26','13:50:00',1.15),('15844','2013-03-26','13:55:00',1.26),('15844','2013-03-26','14:00:00',1.26),('15844','2013-03-26','14:05:00',1.51),('15844','2013-03-26','14:10:00',1.36),('15844','2013-03-26','14:15:00',1.19),('15844','2013-03-26','14:20:00',1.03),('15844','2013-03-26','14:25:00',1.1),('15844','2013-03-26','14:30:00',1.04),('15844','2013-03-25','08:20:00',1.45),('15844','2013-03-25','08:25:00',1.81),('15844','2013-03-25','08:50:00',1.15),('15844','2013-03-25','09:20:00',1.26),('15844','2013-03-25','09:25:00',2.01),('15844','2013-03-25','10:05:00',2.19),('15844','2013-03-25','10:10:00',1.26),('15844','2013-03-25','10:15:00',2.19),('15844','2013-03-25','10:20:00',1.85),('15844','2013-03-25','10:40:00',1.4),('15844','2013-03-25','10:45:00',1.13),('15844','2013-03-25','10:50:00',1.14),('15844','2013-03-25','10:55:00',1.3),('15844','2013-03-25','11:25:00',1.78),('15844','2013-03-25','11:30:00',1.09),('15844','2013-03-25','11:35:00',1.12),('15844','2013-03-25','11:40:00',1.25),('15844','2013-03-25','11:45:00',1.65),('15844','2013-03-25','11:50:00',3.41),('15844','2013-03-25','11:55:00',2.54),('15844','2013-03-25','12:00:00',4.11),('15844','2013-03-25','12:05:00',3.3),('15844','2013-03-25','12:10:00',2.09),('15844','2013-03-25','12:15:00',3.42),('15844','2013-03-25','12:20:00',3.04),('15844','2013-03-25','12:25:00',3.61),('15844','2013-03-25','12:30:00',2.2),('15844','2013-03-25','12:35:00',2.82),('15844','2013-03-25','12:40:00',3.13),('15844','2013-03-25','12:45:00',3.81),('15844','2013-03-25','12:50:00',4.34),('15844','2013-03-25','12:55:00',4.33),('15844','2013-03-25','13:00:00',3.59),('15844','2013-03-25','13:05:00',3.8),('15844','2013-03-25','13:10:00',1.59),('15844','2013-03-25','13:40:00',1.43),('15844','2013-03-25','13:45:00',1.06),('15844','2013-03-25','14:00:00',1.65),('15844','2013-03-25','14:05:00',2.35),('15844','2013-03-25','14:10:00',2.76),('15844','2013-03-25','14:15:00',1.75),('15844','2013-03-25','14:20:00',1.52),('15844','2013-03-25','14:25:00',2.2),('15844','2013-03-25','14:30:00',1.46),('15844','2013-03-25','14:35:00',1.53),('15844','2013-03-25','14:40:00',1.47),('15844','2013-03-25','14:45:00',1.26),('15844','2013-03-25','14:50:00',1.17),('15844','2013-03-25','14:55:00',1.59),('15844','2013-03-25','15:00:00',1.63),('15844','2013-03-25','15:05:00',1.3),('15844','2013-03-25','15:10:00',1.17),('15844','2013-03-25','15:15:00',1.27),('15844','2013-03-25','15:20:00',1.01),('15844','2013-03-25','15:25:00',1.15),('15844','2013-03-25','15:30:00',1.2),('15844','2013-03-24','08:00:00',1.13),('15844','2013-03-24','08:05:00',1.28),('15844','2013-03-24','08:10:00',1.34),('15844','2013-03-24','08:15:00',1.55),('15844','2013-03-24','08:20:00',1.67),('15844','2013-03-24','08:25:00',1.77),('15844','2013-03-24','08:30:00',1.88),('15844','2013-03-24','08:35:00',2.04),('15844','2013-03-24','08:40:00',2.15),('15844','2013-03-24','08:45:00',2.25),('15844','2013-03-24','08:50:00',2.31),('15844','2013-03-24','08:55:00',2.38),('15844','2013-03-24','09:00:00',2.46),('15844','2013-03-24','09:05:00',2.52),('15844','2013-03-24','09:10:00',2.61),('15844','2013-03-24','09:15:00',2.68),('15844','2013-03-24','09:20:00',2.72),('15844','2013-03-24','09:25:00',2.8),('15844','2013-03-24','09:30:00',2.87),('15844','2013-03-24','09:35:00',2.96),('15844','2013-03-24','09:40:00',2.99),('15844','2013-03-24','09:45:00',3.06),('15844','2013-03-24','09:50:00',3.13),('15844','2013-03-24','09:55:00',3.18),('15844','2013-03-24','10:00:00',3.24),('15844','2013-03-24','10:05:00',3.38),('15844','2013-03-24','10:10:00',3.43),('15844','2013-03-24','10:15:00',3.46),('15844','2013-03-24','10:20:00',3.47),('15844','2013-03-24','10:25:00',3.47),('15844','2013-03-24','10:30:00',3.51),('15844','2013-03-24','10:35:00',3.51),('15844','2013-03-24','10:40:00',3.51),('15844','2013-03-24','10:45:00',3.57),('15844','2013-03-24','10:50:00',3.56),('15844','2013-03-24','10:55:00',3.59),('15844','2013-03-24','11:00:00',3.58),('15844','2013-03-24','11:05:00',3.6),('15844','2013-03-24','11:10:00',3.57),('15844','2013-03-24','11:15:00',3.58),('15844','2013-03-24','11:20:00',3.58),('15844','2013-03-24','11:25:00',3.55),('15844','2013-03-24','11:30:00',3.55),('15844','2013-03-24','11:35:00',3.54),('15844','2013-03-24','11:40:00',3.5),('15844','2013-03-24','11:45:00',3.45),('15844','2013-03-24','11:50:00',3.44),('15844','2013-03-24','11:55:00',3.44),('15844','2013-03-24','12:00:00',3.43),('15844','2013-03-24','12:05:00',3.48),('15844','2013-03-24','12:10:00',3.5),('15844','2013-03-24','12:15:00',3.5),('15844','2013-03-24','12:20:00',3.49),('15844','2013-03-24','12:25:00',3.48),('15844','2013-03-24','12:30:00',3.46),('15844','2013-03-24','12:35:00',3.44),('15844','2013-03-24','12:40:00',3.41),('15844','2013-03-24','12:45:00',3.38),('15844','2013-03-24','12:50:00',3.35),('15844','2013-03-24','12:55:00',3.29),('15844','2013-03-24','13:00:00',3.21),('15844','2013-03-24','13:05:00',3.18),('15844','2013-03-24','13:10:00',3.11),('15844','2013-03-24','13:15:00',3.08),('15844','2013-03-24','13:20:00',2.99),('15844','2013-03-24','13:25:00',2.9),('15844','2013-03-24','13:30:00',2.82),('15844','2013-03-24','13:35:00',2.72),('15844','2013-03-24','13:40:00',2.61),('15844','2013-03-24','13:45:00',2.51),('15844','2013-03-24','13:50:00',2.4),('15844','2013-03-24','13:55:00',2.28),('15844','2013-03-24','14:00:00',2.17),('15844','2013-03-24','14:05:00',2.09),('15844','2013-03-24','14:10:00',1.98),('15844','2013-03-24','14:15:00',1.87),('15844','2013-03-24','14:20:00',1.74),('15844','2013-03-24','14:25:00',1.59),('15844','2013-03-24','14:30:00',1.47),('15844','2013-03-24','14:35:00',1.37),('15844','2013-03-24','14:40:00',1.31),('15844','2013-03-24','14:45:00',1.24),('15844','2013-03-24','14:50:00',1.17),('15844','2013-03-24','14:55:00',1.21),('15844','2013-03-24','15:00:00',1.16),('15844','2013-03-24','15:05:00',1.12),('15844','2013-03-24','15:15:00',1.04),('15844','2013-03-23','07:55:00',1.04),('15844','2013-03-23','08:00:00',1.2),('15844','2013-03-23','08:05:00',1.32),('15844','2013-03-23','08:10:00',1.39),('15844','2013-03-23','08:15:00',1.49),('15844','2013-03-23','08:20:00',1.6),('15844','2013-03-23','08:25:00',1.73),('15844','2013-03-23','08:30:00',1.83),('15844','2013-03-23','08:35:00',1.91),('15844','2013-03-23','08:40:00',2.21),('15844','2013-03-23','08:45:00',2.31),('15844','2013-03-23','08:50:00',2.45),('15844','2013-03-23','08:55:00',2.52),('15844','2013-03-23','09:00:00',2.6),('15844','2013-03-23','09:05:00',2.69),('15844','2013-03-23','09:10:00',2.75),('15844','2013-03-23','09:15:00',2.78),('15844','2013-03-23','09:20:00',2.87),('15844','2013-03-23','09:25:00',2.99),('15844','2013-03-23','09:30:00',3.1),('15844','2013-03-23','09:35:00',3.06),('15844','2013-03-23','09:40:00',3.07),('15844','2013-03-23','09:45:00',3.13),('15844','2013-03-23','09:50:00',3.22),('15844','2013-03-23','09:55:00',3.28),('15844','2013-03-23','10:00:00',3.29),('15844','2013-03-23','10:05:00',3.38),('15844','2013-03-23','10:10:00',3.49),('15844','2013-03-23','10:15:00',3.48),('15844','2013-03-23','10:20:00',3.32),('15844','2013-03-23','10:25:00',3.57),('15844','2013-03-23','10:30:00',3.66),('15844','2013-03-23','10:35:00',3.61),('15844','2013-03-23','10:40:00',3.6),('15844','2013-03-23','10:45:00',3.59),('15844','2013-03-23','10:50:00',3.45),('15844','2013-03-23','10:55:00',3.33),('15844','2013-03-23','11:00:00',3.22),('15844','2013-03-23','11:05:00',2.74),('15844','2013-03-23','11:10:00',2.49),('15844','2013-03-23','11:15:00',2.98),('15844','2013-03-23','11:20:00',3.4),('15844','2013-03-23','11:25:00',3.27),('15844','2013-03-23','11:30:00',3.44),('15844','2013-03-23','11:35:00',3.56),('15844','2013-03-23','11:40:00',3.45),('15844','2013-03-23','11:45:00',3.5),('15844','2013-03-23','11:50:00',2.94),('15844','2013-03-23','11:55:00',3.03),('15844','2013-03-23','12:00:00',3.36),('15844','2013-03-23','12:05:00',3.41),('15844','2013-03-23','12:10:00',3.47),('15844','2013-03-23','12:15:00',3.41),('15844','2013-03-23','12:20:00',3.4),('15844','2013-03-23','12:25:00',3.35),('15844','2013-03-23','12:30:00',3.37),('15844','2013-03-23','12:35:00',3.29),('15844','2013-03-23','12:40:00',3.19),('15844','2013-03-23','12:45:00',3.24),('15844','2013-03-23','12:50:00',3.15),('15844','2013-03-23','12:55:00',2.7),('15844','2013-03-23','13:00:00',2.73),('15844','2013-03-23','13:05:00',3.09),('15844','2013-03-23','13:10:00',2.99),('15844','2013-03-23','13:15:00',2.92),('15844','2013-03-23','13:20:00',2.96),('15844','2013-03-23','13:25:00',2.79),('15844','2013-03-23','13:30:00',2.77),('15844','2013-03-23','13:35:00',2.67),('15844','2013-03-23','13:40:00',2.52),('15844','2013-03-23','13:45:00',2.43),('15844','2013-03-23','13:50:00',2.3),('15844','2013-03-23','13:55:00',2.24),('15844','2013-03-23','14:00:00',2.16),('15844','2013-03-23','14:05:00',2.07),('15844','2013-03-23','14:10:00',1.91),('15844','2013-03-23','14:15:00',1.8),('15844','2013-03-23','14:20:00',1.71),('15844','2013-03-23','14:25:00',1.64),('15844','2013-03-23','14:30:00',1.59),('15844','2013-03-23','14:35:00',1.5),('15844','2013-03-23','14:40:00',1.35),('15844','2013-03-23','14:45:00',1.22),('15844','2013-03-23','14:50:00',1.23),('15844','2013-03-23','14:55:00',1.18),('15844','2013-03-23','15:00:00',1.14),('15844','2013-03-23','15:05:00',1.04),('15844','2014-03-26','07:40:00',1.09),('15844','2014-03-26','07:45:00',1.13),('15844','2014-03-26','07:50:00',1.15),('15844','2014-03-26','07:55:00',1.19),('15844','2014-03-26','08:00:00',1.28),('15844','2014-03-26','08:05:00',1.38),('15844','2014-03-26','08:10:00',1.51),('15844','2014-03-26','08:15:00',1.79),('15844','2014-03-26','08:20:00',1.11),('15844','2014-03-26','08:45:00',1.04),('15844','2014-03-26','08:50:00',1.1),('15844','2014-03-26','08:55:00',2.42),('15844','2014-03-26','09:00:00',3.24),('15844','2014-03-26','09:05:00',1.61),('15844','2014-03-26','09:10:00',1.63),('15844','2014-03-26','09:15:00',2.58),('15844','2014-03-26','09:20:00',2.81),('15844','2014-03-26','09:25:00',3),('15844','2014-03-26','09:30:00',3.04),('15844','2014-03-26','09:35:00',3.09),('15844','2014-03-26','09:40:00',3.14),('15844','2014-03-26','09:45:00',3.19),('15844','2014-03-26','09:50:00',3.23),('15844','2014-03-26','09:55:00',3.3),('15844','2014-03-26','10:00:00',3.35),('15844','2014-03-26','10:05:00',3.57),('15844','2014-03-26','10:10:00',2.66),('15844','2014-03-26','10:15:00',4),('15844','2014-03-26','10:20:00',3.9),('15844','2014-03-26','10:25:00',3.85),('15844','2014-03-26','10:30:00',3.59),('15844','2014-03-26','10:35:00',3.22),('15844','2014-03-26','10:40:00',1.99),('15844','2014-03-26','10:45:00',4.2),('15844','2014-03-26','10:50:00',2.51),('15844','2014-03-26','10:55:00',1.09),('15844','2014-03-26','11:10:00',1.14),('15844','2014-03-26','11:35:00',1.15),('15844','2014-03-26','11:40:00',1.62),('15844','2014-03-26','11:45:00',3.27),('15844','2014-03-26','11:50:00',2.64),('15844','2014-03-26','11:55:00',4.34),('15844','2014-03-26','12:00:00',4.58),('15844','2014-03-26','12:05:00',1.53),('15844','2014-03-26','12:10:00',1.28),('15844','2014-03-26','12:20:00',1.02),('15844','2014-03-26','12:25:00',1.36),('15844','2014-03-26','12:30:00',1.39),('15844','2014-03-26','12:35:00',2.03),('15844','2014-03-26','12:40:00',2.19),('15844','2014-03-26','12:45:00',3.2),('15844','2014-03-26','12:50:00',4.15),('15844','2014-03-26','12:55:00',3.7),('15844','2014-03-26','13:00:00',3.59),('15844','2014-03-26','13:05:00',3.66),('15844','2014-03-26','13:10:00',3.73),('15844','2014-03-26','13:15:00',2.84),('15844','2014-03-26','13:20:00',2.98),('15844','2014-03-26','13:25:00',2.67),('15844','2014-03-26','13:30:00',2.8),('15844','2014-03-26','13:35:00',2.22),('15844','2014-03-26','13:40:00',1.02),('15844','2014-03-26','13:50:00',1.03),('15844','2014-03-26','13:55:00',1.01),('15844','2014-03-26','14:00:00',1.6),('15844','2014-03-26','14:05:00',2.74),('15844','2014-03-26','14:10:00',1.51),('15844','2014-03-26','14:15:00',2.49),('15844','2014-03-26','14:20:00',1.26),('15844','2014-03-26','14:25:00',1.17),('15844','2014-03-26','14:30:00',1.47),('15844','2014-03-26','14:55:00',1.31),('15844','2014-03-26','15:00:00',1.47),('15844','2014-03-26','15:05:00',1.42),('15844','2014-03-26','15:10:00',1.09),('15844','2014-03-26','15:20:00',1.06),('15844','2013-03-22','07:55:00',1),('15844','2013-03-22','08:00:00',1.1),('15844','2013-03-22','08:05:00',1.2),('15844','2013-03-22','08:10:00',1.34),('15844','2013-03-22','08:15:00',1.45),('15844','2013-03-22','08:20:00',1.59),('15844','2013-03-22','08:25:00',1.73),('15844','2013-03-22','08:30:00',1.85),('15844','2013-03-22','08:35:00',1.95),('15844','2013-03-22','08:40:00',2.05),('15844','2013-03-22','08:45:00',2.21),('15844','2013-03-22','08:50:00',2.3),('15844','2013-03-22','08:55:00',2.41),('15844','2013-03-22','09:00:00',2.53),('15844','2013-03-22','09:05:00',2.58),('15844','2013-03-22','09:10:00',2.67),('15844','2013-03-22','09:15:00',2.71),('15844','2013-03-22','09:20:00',2.82),('15844','2013-03-22','09:25:00',2.92),('15844','2013-03-22','09:30:00',3.01),('15844','2013-03-22','09:35:00',3.03),('15844','2013-03-22','09:40:00',3.13),('15844','2013-03-22','09:45:00',3.13),('15844','2013-03-22','09:50:00',3.23),('15844','2013-03-22','09:55:00',3.25),('15844','2013-03-22','10:00:00',3.28),('15844','2013-03-22','10:05:00',3.48),('15844','2013-03-22','10:10:00',3.51),('15844','2013-03-22','10:15:00',3.55),('15844','2013-03-22','10:20:00',3.64),('15844','2013-03-22','10:25:00',3.65),('15844','2013-03-22','10:30:00',3.71),('15844','2013-03-22','10:35:00',3.72),('15844','2013-03-22','10:40:00',3.74),('15844','2013-03-22','10:45:00',3.75),('15844','2013-03-22','10:50:00',3.77),('15844','2013-03-22','10:55:00',3.78),('15844','2013-03-22','11:00:00',3.81),('15844','2013-03-22','11:05:00',3.78),('15844','2013-03-22','11:10:00',3.78),('15844','2013-03-22','11:15:00',3.8),('15844','2013-03-22','11:20:00',3.77),('15844','2013-03-22','11:25:00',3.73),('15844','2013-03-22','11:30:00',3.78),('15844','2013-03-22','11:35:00',3.76),('15844','2013-03-22','11:40:00',3.77),('15844','2013-03-22','11:45:00',3.77),('15844','2013-03-22','11:50:00',3.75),('15844','2013-03-22','11:55:00',3.76),('15844','2013-03-22','12:00:00',3.73),('15844','2013-03-22','12:05:00',3.69),('15844','2013-03-22','12:10:00',3.67),('15844','2013-03-22','12:15:00',3.64),('15844','2013-03-22','12:20:00',3.64),('15844','2013-03-22','12:25:00',3.62),('15844','2013-03-22','12:30:00',3.58),('15844','2013-03-22','12:35:00',3.55),('15844','2013-03-22','12:40:00',3.45),('15844','2013-03-22','12:45:00',3.47),('15844','2013-03-22','12:50:00',3.36),('15844','2013-03-22','12:55:00',3.39),('15844','2013-03-22','13:00:00',3.29),('15844','2013-03-22','13:05:00',3.28),('15844','2013-03-22','13:10:00',3.21),('15844','2013-03-22','13:15:00',3.09),('15844','2013-03-22','13:20:00',2.97),('15844','2013-03-22','13:25:00',2.51),('15844','2013-03-22','13:30:00',2.77),('15844','2013-03-22','13:35:00',2.72),('15844','2013-03-22','13:40:00',2.3),('15844','2013-03-22','13:45:00',2.61),('15844','2013-03-22','13:50:00',2.43),('15844','2013-03-22','13:55:00',2.3),('15844','2013-03-22','14:00:00',2.16),('15844','2013-03-22','14:05:00',2.07),('15844','2013-03-22','14:10:00',1.96),('15844','2013-03-22','14:15:00',1.83),('15844','2013-03-22','14:20:00',1.7),('15844','2013-03-22','14:25:00',1.62),('15844','2013-03-22','14:30:00',1.58),('15844','2013-03-22','14:35:00',1.49),('15844','2013-03-22','14:40:00',1.37),('15844','2013-03-22','14:45:00',1.25),('15844','2013-03-22','14:50:00',1.21),('15844','2013-03-22','14:55:00',1.17),('15844','2013-03-22','15:00:00',1.1),('15844','2013-03-21','07:35:00',1.07),('15844','2013-03-21','07:40:00',1.19),('15844','2013-03-21','08:05:00',1.35),('15844','2013-03-21','08:10:00',1.29),('15844','2013-03-21','08:15:00',1.48),('15844','2013-03-21','08:20:00',1.68),('15844','2013-03-21','08:25:00',1.73),('15844','2013-03-21','08:30:00',1.42),('15844','2013-03-21','08:35:00',2.23),('15844','2013-03-21','08:40:00',2.46),('15844','2013-03-21','08:45:00',1.13),('15844','2013-03-21','08:50:00',1.94),('15844','2013-03-21','08:55:00',2.08),('15844','2013-03-21','09:05:00',1.04),('15844','2013-03-21','09:10:00',2.14),('15844','2013-03-21','09:15:00',1.79),('15844','2013-03-21','09:20:00',2.66),('15844','2013-03-21','09:25:00',2.42),('15844','2013-03-21','09:30:00',3.25),('15844','2013-03-21','09:35:00',3.28),('15844','2013-03-21','09:40:00',3.3),('15844','2013-03-21','09:45:00',3.3),('15844','2013-03-21','09:50:00',3.4),('15844','2013-03-21','09:55:00',3.48),('15844','2013-03-21','10:00:00',3.52),('15844','2013-03-21','10:05:00',2.71),('15844','2013-03-21','10:10:00',3.75),('15844','2013-03-21','10:15:00',3.72),('15844','2013-03-21','10:20:00',3.73),('15844','2013-03-21','10:25:00',3.77),('15844','2013-03-21','10:30:00',3.77),('15844','2013-03-21','10:35:00',3.78),('15844','2013-03-21','10:40:00',3.77),('15844','2013-03-21','10:45:00',2.89),('15844','2013-03-21','10:50:00',1.96),('15844','2013-03-21','10:55:00',3.83),('15844','2013-03-21','11:00:00',3.82),('15844','2013-03-21','11:05:00',3.82),('15844','2013-03-21','11:10:00',3.82),('15844','2013-03-21','11:15:00',3.86),('15844','2013-03-21','11:20:00',3.88),('15844','2013-03-21','11:25:00',3.87),('15844','2013-03-21','11:30:00',3.87),('15844','2013-03-21','11:35:00',3.86),('15844','2013-03-21','11:40:00',3.86),('15844','2013-03-21','11:45:00',3.86),('15844','2013-03-21','11:50:00',3.86),('15844','2013-03-21','11:55:00',3.81),('15844','2013-03-21','12:00:00',3.8),('15844','2013-03-21','12:05:00',3.79),('15844','2013-03-21','12:10:00',3.77),('15844','2013-03-21','12:15:00',3.72),('15844','2013-03-21','12:20:00',3.69),('15844','2013-03-21','12:25:00',3.67),('15844','2013-03-21','12:30:00',3.65),('15844','2013-03-21','12:35:00',3.62),('15844','2013-03-21','12:40:00',3.57),('15844','2013-03-21','12:45:00',3.53),('15844','2013-03-21','12:50:00',3.48),('15844','2013-03-21','12:55:00',3.41),('15844','2013-03-21','13:00:00',3.29),('15844','2013-03-21','13:05:00',3.29),('15844','2013-03-21','13:10:00',3.21),('15844','2013-03-21','13:15:00',3.13),('15844','2013-03-21','13:20:00',3.06),('15844','2013-03-21','13:25:00',2.99),('15844','2013-03-21','13:30:00',2.88),('15844','2013-03-21','13:35:00',2.75),('15844','2013-03-21','13:40:00',2.63),('15844','2013-03-21','13:45:00',2.51),('15844','2013-03-21','13:50:00',2.4),('15844','2013-03-21','13:55:00',2.31),('15844','2013-03-21','14:00:00',2.18),('15844','2013-03-21','14:05:00',2.07),('15844','2013-03-21','14:10:00',1.95),('15844','2013-03-21','14:15:00',1.81),('15844','2013-03-21','14:20:00',1.68),('15844','2013-03-21','14:25:00',1.64),('15844','2013-03-21','14:30:00',1.56),('15844','2013-03-21','14:35:00',1.47),('15844','2013-03-21','14:40:00',1.35),('15844','2013-03-21','14:45:00',1.24),('15844','2013-03-21','14:50:00',1.19),('15844','2013-03-21','14:55:00',1.15),('15844','2013-03-21','15:00:00',1.08),('15844','2013-03-21','15:05:00',1),('15844','2013-03-20','07:50:00',1.11),('15844','2013-03-20','07:55:00',1.11),('15844','2013-03-20','08:05:00',1.26),('15844','2013-03-20','08:10:00',1.44),('15844','2013-03-20','08:15:00',1.55),('15844','2013-03-20','08:20:00',1.66),('15844','2013-03-20','08:25:00',1.72),('15844','2013-03-20','08:30:00',1.71),('15844','2013-03-20','08:35:00',1.49),('15844','2013-03-20','08:40:00',1.97),('15844','2013-03-20','08:45:00',2.18),('15844','2013-03-20','08:50:00',2.32),('15844','2013-03-20','08:55:00',2.3),('15844','2013-03-20','09:00:00',2.34),('15844','2013-03-20','09:05:00',1.53),('15844','2013-03-20','09:10:00',2.44),('15844','2013-03-20','09:15:00',2.38),('15844','2013-03-20','09:20:00',2.68),('15844','2013-03-20','09:25:00',2.78),('15844','2013-03-20','09:30:00',3.06),('15844','2013-03-20','09:35:00',2.9),('15844','2013-03-20','09:40:00',3.05),('15844','2013-03-20','09:45:00',2.95),('15844','2013-03-20','09:50:00',3.06),('15844','2013-03-20','09:55:00',3.27),('15844','2013-03-20','10:00:00',3.31),('15844','2013-03-20','10:05:00',3.15),('15844','2013-03-20','10:10:00',3.48),('15844','2013-03-20','10:15:00',2.56),('15844','2013-03-20','10:20:00',2.31),('15844','2013-03-20','10:25:00',3),('15844','2013-03-20','10:30:00',3.79),('15844','2013-03-20','10:35:00',3.65),('15844','2013-03-20','10:40:00',2.22),('15844','2013-03-20','10:45:00',3.39),('15844','2013-03-20','10:50:00',2.65),('15844','2013-03-20','10:55:00',2.69),('15844','2013-03-20','11:00:00',2.66),('15844','2013-03-20','11:05:00',2.89),('15844','2013-03-20','11:10:00',1.94),('15844','2013-03-20','11:15:00',1.96),('15844','2013-03-20','11:20:00',2.54),('15844','2013-03-20','11:25:00',2.09),('15844','2013-03-20','11:30:00',2.07),('15844','2013-03-20','11:35:00',2.35),('15844','2013-03-20','11:40:00',1.84),('15844','2013-03-20','11:45:00',1.71),('15844','2013-03-20','11:50:00',1.74),('15844','2013-03-20','11:55:00',1.74),('15844','2013-03-20','12:00:00',1.89),('15844','2013-03-20','12:05:00',1.83),('15844','2013-03-20','12:10:00',1.61),('15844','2013-03-20','12:15:00',1.32),('15844','2013-03-20','12:20:00',1.16),('15844','2013-03-20','12:30:00',1.02),('15844','2013-03-20','12:35:00',1.26),('15844','2013-03-20','12:50:00',1.28),('15844','2013-03-20','12:55:00',1.87),('15844','2013-03-20','13:00:00',1.31),('15844','2013-03-20','13:05:00',1.15),('15844','2013-03-20','13:10:00',1.11),('15844','2013-03-20','13:20:00',1.09),('15844','2013-03-20','13:25:00',1.16),('15844','2013-03-20','13:30:00',1.24),('15844','2013-03-20','13:35:00',1.2),('15844','2013-03-20','13:40:00',1.57),('15844','2013-03-20','13:45:00',1.58),('15844','2013-03-20','13:50:00',1.32),('15844','2013-03-20','13:55:00',1.35),('15844','2013-03-20','14:00:00',1.31),('15844','2013-03-20','14:05:00',1.04),('15844','2013-03-20','14:10:00',1.06),('15844','2013-03-20','14:15:00',1.51),('15844','2013-03-20','14:20:00',1.61),('15844','2013-03-20','14:25:00',1.62),('15844','2013-03-20','14:30:00',1.42),('15844','2013-03-20','14:35:00',1.09),('15844','2013-03-19','07:50:00',1.14),('15844','2013-03-19','08:05:00',1.25),('15844','2013-03-19','08:10:00',1.37),('15844','2013-03-19','08:15:00',1.5),('15844','2013-03-19','08:20:00',1.67),('15844','2013-03-19','08:25:00',1.83),('15844','2013-03-19','08:30:00',1.95),('15844','2013-03-19','08:35:00',1.95),('15844','2013-03-19','08:40:00',2.16),('15844','2013-03-19','08:45:00',2.23),('15844','2013-03-19','08:50:00',2.48),('15844','2013-03-19','08:55:00',2.58),('15844','2013-03-19','09:00:00',2.53),('15844','2013-03-19','09:05:00',2.73),('15844','2013-03-19','09:10:00',2.77),('15844','2013-03-19','09:15:00',2.85),('15844','2013-03-19','09:20:00',2.91),('15844','2013-03-19','09:25:00',2.96),('15844','2013-03-19','09:30:00',3.06),('15844','2013-03-19','09:35:00',3.05),('15844','2013-03-19','09:40:00',3.11),('15844','2013-03-19','09:45:00',2.91),('15844','2013-03-19','09:50:00',3.13),('15844','2013-03-19','09:55:00',3.2),('15844','2013-03-19','10:00:00',2.88),('15844','2013-03-19','10:05:00',3.53),('15844','2013-03-19','10:10:00',3.57),('15844','2013-03-19','10:15:00',3.65),('15844','2013-03-19','10:20:00',3.71),('15844','2013-03-19','10:25:00',3.7),('15844','2013-03-19','10:30:00',3.72),('15844','2013-03-19','10:35:00',3.75),('15844','2013-03-19','10:40:00',3.78),('15844','2013-03-19','10:45:00',3.78),('15844','2013-03-19','10:50:00',3.82),('15844','2013-03-19','10:55:00',3.83),('15844','2013-03-19','11:00:00',3.82),('15844','2013-03-19','11:05:00',3.82),('15844','2013-03-19','11:10:00',3.79),('15844','2013-03-19','11:15:00',3.87),('15844','2013-03-19','11:20:00',3.76),('15844','2013-03-19','11:25:00',3.9),('15844','2013-03-19','11:30:00',3.53),('15844','2013-03-19','11:35:00',2.36),('15844','2013-03-19','11:40:00',3.46),('15844','2013-03-19','11:45:00',3.29),('15844','2013-03-19','11:50:00',3.86),('15844','2013-03-19','11:55:00',3.84),('15844','2013-03-19','12:00:00',3.78),('15844','2013-03-19','12:05:00',3.66),('15844','2013-03-19','12:10:00',3.61),('15844','2013-03-19','12:15:00',3.6),('15844','2013-03-19','12:20:00',3.62),('15844','2013-03-19','12:25:00',3.55),('15844','2013-03-19','12:30:00',3.55),('15844','2013-03-19','12:35:00',3.54),('15844','2013-03-19','12:40:00',3.47),('15844','2013-03-19','12:45:00',3.49),('15844','2013-03-19','12:50:00',3.14),('15844','2013-03-19','12:55:00',3.32),('15844','2013-03-19','13:00:00',3.15),('15844','2013-03-19','13:05:00',3.16),('15844','2013-03-19','13:10:00',3.1),('15844','2013-03-19','13:15:00',3.02),('15844','2013-03-19','13:20:00',2.96),('15844','2013-03-19','13:25:00',2.86),('15844','2013-03-19','13:30:00',2.73),('15844','2013-03-19','13:35:00',2.59),('15844','2013-03-19','13:40:00',2.48),('15844','2013-03-19','13:45:00',2.44),('15844','2013-03-19','13:50:00',2.32),('15844','2013-03-19','13:55:00',2.24),('15844','2013-03-19','14:00:00',2.12),('15844','2013-03-19','14:05:00',2.02),('15844','2013-03-19','14:10:00',1.9),('15844','2013-03-19','14:15:00',1.78),('15844','2013-03-19','14:20:00',1.44),('15844','2013-03-19','14:25:00',1.5),('15844','2013-03-19','14:30:00',1.38),('15844','2013-03-19','14:35:00',1.41),('15844','2013-03-19','14:40:00',1.26),('15844','2013-03-19','14:45:00',1.13),('15844','2013-03-19','14:50:00',1.18),('15844','2013-03-19','14:55:00',1.09),('15844','2013-03-19','15:00:00',1.05),('15844','2013-03-18','09:55:00',1.1),('15844','2013-03-18','10:00:00',1.35),('15844','2013-03-18','10:05:00',1.51),('15844','2013-03-18','10:10:00',1.78),('15844','2013-03-18','10:15:00',1.79),('15844','2013-03-18','10:20:00',2.13),('15844','2013-03-18','10:25:00',2.08),('15844','2013-03-18','10:30:00',1.78),('15844','2013-03-18','10:35:00',1.46),('15844','2013-03-18','10:40:00',1.49),('15844','2013-03-18','10:45:00',1.53),('15844','2013-03-18','11:00:00',1.03),('15844','2013-03-18','11:05:00',1.17),('15844','2013-03-18','11:10:00',1.48),('15844','2013-03-18','11:15:00',1.71),('15844','2013-03-18','11:20:00',1.78),('15844','2013-03-18','11:25:00',2.02),('15844','2013-03-18','11:30:00',2.19),('15844','2013-03-18','11:35:00',1.69),('15844','2013-03-18','11:40:00',1.41),('15844','2013-03-18','11:45:00',1.09),('15844','2013-03-18','11:50:00',1.01),('15844','2013-03-18','11:55:00',1.14),('15844','2013-03-18','12:00:00',1.53),('15844','2013-03-18','12:05:00',2.01),('15844','2013-03-18','12:10:00',2.71),('15844','2013-03-18','12:15:00',3.69),('15844','2013-03-18','12:20:00',2.79),('15844','2013-03-18','12:25:00',2.9),('15844','2013-03-18','12:30:00',3.2),('15844','2013-03-18','12:35:00',2.49),('15844','2013-03-18','12:40:00',1.74),('15844','2013-03-18','12:45:00',2.61),('15844','2013-03-18','12:50:00',2.75),('15844','2013-03-18','12:55:00',2.58),('15844','2013-03-18','13:00:00',1.85),('15844','2013-03-18','13:05:00',2.12),('15844','2013-03-18','13:10:00',1.4),('15844','2013-03-18','13:20:00',1.77),('15844','2013-03-18','13:25:00',1.86),('15844','2013-03-18','13:35:00',1.21),('15844','2013-03-18','13:40:00',1.55),('15844','2013-03-18','13:45:00',1.36),('15844','2013-03-18','13:50:00',1.18),('15844','2013-03-18','14:00:00',1.41),('15844','2013-03-18','14:05:00',1.39),('15844','2013-03-18','14:10:00',1.5),('15844','2013-03-17','08:20:00',1.08),('15844','2013-03-17','08:25:00',1.29),('15844','2013-03-17','08:30:00',1.08),('15844','2013-03-17','08:40:00',1.12),('15844','2013-03-17','08:45:00',1.26),('15844','2013-03-17','08:50:00',1.11),('15844','2013-03-17','09:00:00',1.09),('15844','2013-03-17','09:05:00',1.42),('15844','2013-03-17','09:10:00',1.7),('15844','2013-03-17','09:15:00',1.45),('15844','2013-03-17','09:20:00',1.22),('15844','2013-03-17','09:25:00',1.01),('15844','2013-03-17','09:30:00',1.3),('15844','2013-03-17','09:35:00',1.25),('15844','2013-03-17','09:40:00',1.24),('15844','2013-03-17','09:45:00',1.38),('15844','2013-03-17','09:50:00',1.51),('15844','2013-03-17','09:55:00',1.65),('15844','2013-03-17','10:00:00',1.66),('15844','2013-03-17','10:05:00',1.39),('15844','2013-03-17','10:10:00',1.49),('15844','2013-03-17','10:15:00',1.55),('15844','2013-03-17','10:20:00',1.66),('15844','2013-03-17','10:25:00',1.65),('15844','2013-03-17','10:30:00',1.58),('15844','2013-03-17','10:35:00',1.55),('15844','2013-03-17','10:40:00',1.5),('15844','2013-03-17','10:45:00',1.54),('15844','2013-03-17','10:50:00',1.31),('15844','2013-03-17','10:55:00',1.15),('15844','2013-03-17','11:00:00',1.12),('15844','2013-03-17','11:05:00',1.23),('15844','2013-03-17','11:10:00',1.2),('15844','2013-03-17','11:15:00',1.45),('15844','2013-03-17','11:20:00',1.6),('15844','2013-03-17','11:25:00',1.39),('15844','2013-03-17','11:30:00',1.32),('15844','2013-03-17','11:35:00',1.32),('15844','2013-03-17','11:40:00',1.26),('15844','2013-03-17','11:45:00',1.15),('15844','2013-03-17','11:50:00',1.04),('15844','2013-03-17','12:10:00',1.37),('15844','2013-03-17','12:15:00',1.86),('15844','2013-03-17','12:20:00',2.06),('15844','2013-03-17','12:25:00',2.17),('15844','2013-03-17','12:30:00',2.09),('15844','2013-03-17','12:35:00',2.03),('15844','2013-03-17','12:40:00',2.01),('15844','2013-03-17','12:45:00',1.88),('15844','2013-03-17','12:50:00',1.54),('15844','2013-03-17','12:55:00',1.48),('15844','2013-03-17','13:00:00',1.73),('15844','2013-03-17','13:05:00',1.74),('15844','2013-03-17','13:10:00',1.96),('15844','2013-03-17','13:15:00',1.64),('15844','2013-03-17','13:20:00',1.42),('15844','2013-03-17','13:25:00',1.7),('15844','2013-03-17','13:30:00',2.34),('15844','2013-03-17','13:35:00',1.89),('15844','2013-03-17','13:40:00',1.63),('15844','2013-03-17','13:45:00',1.26),('15844','2013-03-17','13:50:00',1.47),('15844','2013-03-17','13:55:00',1.98),('15844','2013-03-17','14:00:00',1.67),('15844','2013-03-17','14:05:00',1.96),('15844','2013-03-17','14:10:00',1.99),('15844','2013-03-17','14:15:00',1.8),('15844','2013-03-17','14:20:00',1.74),('15844','2013-03-17','14:25:00',1.78),('15844','2013-03-17','14:30:00',1.57),('15844','2013-03-17','14:35:00',1.5),('15844','2013-03-17','14:40:00',1.19),('15844','2013-03-17','14:45:00',1.09),('15844','2013-03-17','14:55:00',1.11),('15844','2013-03-17','15:00:00',1.3),('15844','2013-03-17','15:05:00',1.75),('15844','2013-03-17','15:10:00',1.64),('15844','2013-03-17','15:15:00',1.26),('15844','2013-03-17','15:20:00',1.13),('15844','2013-03-17','15:30:00',1.01),('15844','2013-03-16','08:05:00',1.05),('15844','2013-03-16','08:20:00',1.2),('15844','2013-03-16','08:25:00',1.45),('15844','2013-03-16','08:30:00',1.9),('15844','2013-03-16','08:35:00',1.92),('15844','2013-03-16','08:40:00',1.97),('15844','2013-03-16','08:45:00',2.13),('15844','2013-03-16','08:50:00',2.65),('15844','2013-03-16','08:55:00',2.4),('15844','2013-03-16','09:00:00',2.56),('15844','2013-03-16','09:05:00',2.59),('15844','2013-03-16','09:10:00',2.75),('15844','2013-03-16','09:15:00',2.83),('15844','2013-03-16','09:20:00',2.59),('15844','2013-03-16','09:25:00',2.98),('15844','2013-03-16','09:30:00',3.04),('15844','2013-03-16','09:35:00',2.71),('15844','2013-03-16','09:40:00',2.3),('15844','2013-03-16','09:45:00',2.67),('15844','2013-03-16','09:50:00',3.42),('15844','2013-03-16','09:55:00',2.61),('15844','2013-03-16','10:00:00',2.45),('15844','2013-03-16','10:05:00',3.44),('15844','2013-03-16','10:10:00',2.92),('15844','2013-03-16','10:15:00',2.6),('15844','2013-03-16','10:20:00',2.04),('15844','2013-03-16','10:25:00',3.22),('15844','2013-03-16','10:30:00',3.43),('15844','2013-03-16','10:35:00',3.88),('15844','2013-03-16','10:40:00',3.82),('15844','2013-03-16','10:45:00',3.8),('15844','2013-03-16','10:50:00',3.74),('15844','2013-03-16','10:55:00',3.73),('15844','2013-03-16','11:00:00',3.71),('15844','2013-03-16','11:05:00',3.78),('15844','2013-03-16','11:10:00',3.77),('15844','2013-03-16','11:15:00',3.77),('15844','2013-03-16','11:20:00',3.75),('15844','2013-03-16','11:25:00',3.73),('15844','2013-03-16','11:30:00',3.75),('15844','2013-03-16','11:35:00',3.71),('15844','2013-03-16','11:40:00',3.7),('15844','2013-03-16','11:45:00',3.67),('15844','2013-03-16','11:50:00',3.65),('15844','2013-03-16','11:55:00',3.62),('15844','2013-03-16','12:00:00',3.57),('15844','2013-03-16','12:05:00',3.56),('15844','2013-03-16','12:10:00',3.55),('15844','2013-03-16','12:15:00',3.56),('15844','2013-03-16','12:20:00',3.54),('15844','2013-03-16','12:25:00',3.46),('15844','2013-03-16','12:30:00',3.43),('15844','2013-03-16','12:35:00',3.41),('15844','2013-03-16','12:40:00',3.41),('15844','2013-03-16','12:45:00',3.38),('15844','2013-03-16','12:50:00',3.3),('15844','2013-03-16','12:55:00',3.24),('15844','2013-03-16','13:00:00',3.19),('15844','2013-03-16','13:05:00',3.1),('15844','2013-03-16','13:10:00',3.03),('15844','2013-03-16','13:15:00',3.04),('15844','2013-03-16','13:20:00',2.95),('15844','2013-03-16','13:25:00',2.66),('15844','2013-03-16','13:30:00',2.85),('15844','2013-03-16','13:35:00',2.19),('15844','2013-03-16','13:40:00',2.19),('15844','2013-03-16','13:45:00',2.64),('15844','2013-03-16','13:50:00',2.5),('15844','2013-03-16','13:55:00',2.4),('15844','2013-03-16','14:00:00',1.96),('15844','2013-03-16','14:05:00',2.39),('15844','2013-03-16','14:10:00',2.32),('15844','2013-03-16','14:15:00',2.21),('15844','2013-03-16','14:20:00',1.99),('15844','2013-03-16','14:25:00',1.81),('15844','2013-03-16','14:30:00',1.67),('15844','2013-03-15','10:30:00',1),('15844','2013-03-15','10:35:00',1.12),('15844','2013-03-15','10:40:00',1.13),('15844','2013-03-15','10:45:00',1.12),('15844','2013-03-15','10:50:00',1.35),('15844','2013-03-15','10:55:00',1.36),('15844','2013-03-15','11:00:00',1.35),('15844','2013-03-15','11:05:00',1.18),('15844','2013-03-15','11:25:00',1.09),('15844','2013-03-15','11:30:00',1.38),('15844','2013-03-15','11:35:00',1.51),('15844','2013-03-15','11:40:00',1.63),('15844','2013-03-15','11:45:00',1.79),('15844','2013-03-15','11:50:00',1.68),('15844','2013-03-15','11:55:00',1.75),('15844','2013-03-15','12:00:00',1.65),('15844','2013-03-15','12:05:00',1.45),('15844','2013-03-15','12:10:00',1.64),('15844','2013-03-15','12:15:00',1.65),('15844','2013-03-15','12:20:00',1.64),('15844','2013-03-15','12:25:00',1.74),('15844','2013-03-15','12:30:00',1.86),('15844','2013-03-15','12:35:00',1.64),('15844','2013-03-15','12:40:00',1.22),('15844','2013-03-15','12:45:00',1.08),('15844','2013-03-15','12:50:00',1.09),('15844','2013-03-15','12:55:00',1.08),('15844','2013-03-15','13:00:00',1.01),('15844','2013-03-15','13:05:00',1.06),('15844','2013-03-15','13:10:00',1.15),('15844','2013-03-15','13:15:00',1.33),('15844','2013-03-15','13:20:00',1.57),('15844','2013-03-15','13:25:00',1.68),('15844','2013-03-15','13:30:00',1.33),('15844','2013-03-15','13:35:00',1.25),('15844','2013-03-15','13:40:00',1.17),('15844','2013-03-15','14:50:00',1.1),('15844','2013-03-15','14:55:00',1.08),('15844','2013-03-15','15:00:00',1.06),('15844','2013-03-15','15:05:00',1.05),('15844','2013-03-15','15:10:00',1.03),('15844','2013-03-15','15:15:00',1.13),('15844','2013-03-15','15:20:00',1.15),('15844','2013-03-14','13:00:00',1.11),('15844','2013-03-14','13:05:00',1.14),('15844','2013-03-14','13:10:00',1.17),('15844','2013-03-14','13:15:00',1.2),('15844','2013-03-14','13:20:00',1.26),('15844','2013-03-14','13:25:00',1.47),('15844','2013-03-14','13:30:00',1.75),('15844','2013-03-14','13:35:00',1.83),('15844','2013-03-14','13:40:00',1.51),('15844','2013-03-14','13:45:00',1.07),('15844','2013-03-14','13:50:00',1.23),('15844','2013-03-14','13:55:00',1.11),('15844','2013-03-14','14:00:00',1.03),('15844','2013-03-14','14:15:00',1.16),('15844','2013-03-14','14:20:00',1.16),('15844','2013-03-13','09:10:00',1.01),('15844','2013-03-13','10:10:00',1.56),('15844','2013-03-13','10:15:00',1.33),('15844','2013-03-13','10:30:00',1.37),('15844','2013-03-13','10:35:00',1.72),('15844','2013-03-13','10:40:00',2.15),('15844','2013-03-13','10:45:00',1.85),('15844','2013-03-13','10:50:00',1.77),('15844','2013-03-13','10:55:00',1.08),('15844','2013-03-13','11:00:00',1.21),('15844','2013-03-13','11:05:00',1.39),('15844','2013-03-13','11:10:00',1.55),('15844','2013-03-13','11:15:00',1.33),('15844','2013-03-13','11:20:00',1.2),('15844','2013-03-13','11:25:00',1.31),('15844','2013-03-13','11:30:00',1.32),('15844','2013-03-13','11:35:00',1.29),('15844','2013-03-13','11:40:00',1.38),('15844','2013-03-13','11:45:00',1.37),('15844','2013-03-13','11:50:00',1.2),('15844','2013-03-13','12:50:00',1.01),('15844','2013-03-13','13:35:00',1.13),('15844','2013-03-13','13:40:00',1.16),('15844','2014-03-25','08:05:00',1.02),('15844','2014-03-25','08:10:00',1.12),('15844','2014-03-25','08:15:00',1.09),('15844','2014-03-25','08:40:00',1.26),('15844','2014-03-25','08:45:00',1.55),('15844','2014-03-25','08:50:00',1.54),('15844','2014-03-25','08:55:00',1.54),('15844','2014-03-25','09:00:00',1.44),('15844','2014-03-25','09:05:00',1.54),('15844','2014-03-25','09:10:00',1.63),('15844','2014-03-25','09:15:00',2.06),('15844','2014-03-25','09:20:00',2.04),('15844','2014-03-25','09:25:00',1.73),('15844','2014-03-25','09:30:00',1.55),('15844','2014-03-25','09:35:00',1.58),('15844','2014-03-25','09:40:00',1.51),('15844','2014-03-25','09:45:00',1.52),('15844','2014-03-25','09:50:00',1.68),('15844','2014-03-25','09:55:00',1.97),('15844','2014-03-25','10:00:00',2.16),('15844','2014-03-25','10:05:00',2.41),('15844','2014-03-25','10:10:00',2.76),('15844','2014-03-25','10:15:00',2.69),('15844','2014-03-25','10:20:00',2.71),('15844','2014-03-25','10:25:00',2.7),('15844','2014-03-25','10:30:00',2.2),('15844','2014-03-25','10:35:00',1.88),('15844','2014-03-25','10:40:00',1.72),('15844','2014-03-25','10:45:00',1.56),('15844','2014-03-25','10:50:00',1.53),('15844','2014-03-25','10:55:00',1.7),('15844','2014-03-25','11:00:00',1.9),('15844','2014-03-25','11:05:00',2.19),('15844','2014-03-25','11:10:00',2.33),('15844','2014-03-25','11:15:00',2.39),('15844','2014-03-25','11:20:00',2.56),('15844','2014-03-25','11:25:00',2.79),('15844','2014-03-25','11:30:00',2.88),('15844','2014-03-25','11:35:00',2.57),('15844','2014-03-25','11:40:00',2.3),('15844','2014-03-25','11:45:00',1.76),('15844','2014-03-25','11:50:00',1.87),('15844','2014-03-25','11:55:00',1.22),('15844','2014-03-25','12:20:00',1.06),('15844','2014-03-25','12:25:00',1.31),('15844','2014-03-25','12:30:00',1.16),('15844','2014-03-25','12:35:00',1.05),('15844','2014-03-25','12:40:00',1.04),('15844','2014-03-25','12:45:00',1.02),('15844','2014-03-25','12:50:00',1),('15844','2013-03-12','08:15:00',1.07),('15844','2013-03-12','08:20:00',1.74),('15844','2013-03-12','08:25:00',1.45),('15844','2013-03-12','08:30:00',1.37),('15844','2013-03-12','08:35:00',1.28),('15844','2013-03-12','08:40:00',1.35),('15844','2013-03-12','08:45:00',1.29),('15844','2013-03-12','08:50:00',1.14),('15844','2013-03-12','08:55:00',2.23),('15844','2013-03-12','09:00:00',2.34),('15844','2013-03-12','09:05:00',2.38),('15844','2013-03-12','09:10:00',2.51),('15844','2013-03-12','09:15:00',2.58),('15844','2013-03-12','09:20:00',2.65),('15844','2013-03-12','09:25:00',2.76),('15844','2013-03-12','09:30:00',2.86),('15844','2013-03-12','09:35:00',2.95),('15844','2013-03-12','09:40:00',2.84),('15844','2013-03-12','09:45:00',2.56),('15844','2013-03-12','09:50:00',2.61),('15844','2013-03-12','09:55:00',3.37),('15844','2013-03-12','10:00:00',2.81),('15844','2013-03-12','10:05:00',3.45),('15844','2013-03-12','10:10:00',3.01),('15844','2013-03-12','10:15:00',2.78),('15844','2013-03-12','10:20:00',3.45),('15844','2013-03-12','10:25:00',3.91),('15844','2013-03-12','10:30:00',2.99),('15844','2013-03-12','10:35:00',3.87),('15844','2013-03-12','10:40:00',3.73),('15844','2013-03-12','10:45:00',3.7),('15844','2013-03-12','10:50:00',3.43),('15844','2013-03-12','10:55:00',3.74),('15844','2013-03-12','11:00:00',3.37),('15844','2013-03-12','11:05:00',1.45),('15844','2013-03-12','11:15:00',1.1),('15844','2013-03-12','11:20:00',1.62),('15844','2013-03-12','11:25:00',3.17),('15844','2013-03-12','11:30:00',1.51),('15844','2013-03-12','11:35:00',1.43),('15844','2013-03-12','11:40:00',1.62),('15844','2013-03-12','11:45:00',2.22),('15844','2013-03-12','11:50:00',3.06),('15844','2013-03-12','11:55:00',4.39),('15844','2013-03-12','12:00:00',4.08),('15844','2013-03-12','12:05:00',2.88),('15844','2013-03-12','12:10:00',2.96),('15844','2013-03-12','12:15:00',1.58),('15844','2013-03-12','12:20:00',1.78),('15844','2013-03-12','12:25:00',2.39),('15844','2013-03-12','12:30:00',4.22),('15844','2013-03-12','12:35:00',2.78),('15844','2013-03-12','12:40:00',2.12),('15844','2013-03-12','12:45:00',2.33),('15844','2013-03-12','12:50:00',2.53),('15844','2013-03-12','12:55:00',1.62),('15844','2013-03-12','13:00:00',2.19),('15844','2013-03-12','13:05:00',3.15),('15844','2013-03-12','13:10:00',3.07),('15844','2013-03-12','13:15:00',1.55),('15844','2013-03-12','13:20:00',1.76),('15844','2013-03-12','13:25:00',1.4),('15844','2013-03-12','13:30:00',1.62),('15844','2013-03-12','13:35:00',2.01),('15844','2013-03-12','13:40:00',2.83),('15844','2013-03-12','13:45:00',2.21),('15844','2013-03-12','13:50:00',1.8),('15844','2013-03-12','13:55:00',1.94),('15844','2013-03-12','14:05:00',1.25),('15844','2013-03-12','14:10:00',1.9),('15844','2013-03-12','14:15:00',1.94),('15844','2013-03-12','14:20:00',1.4),('15844','2013-03-12','14:55:00',1.74),('15844','2013-03-12','15:00:00',1.41),('15844','2013-03-12','15:05:00',1.05),('15844','2013-03-12','15:10:00',1.04),('15844','2013-03-12','15:15:00',1.32),('15844','2013-03-12','15:20:00',1.09),('15844','2013-03-11','08:00:00',1.01),('15844','2013-03-11','08:05:00',1.2),('15844','2013-03-11','08:10:00',1.3),('15844','2013-03-11','08:15:00',1.44),('15844','2013-03-11','08:20:00',1.56),('15844','2013-03-11','08:25:00',1.69),('15844','2013-03-11','08:30:00',1.83),('15844','2013-03-11','08:35:00',1.94),('15844','2013-03-11','08:40:00',1.56),('15844','2013-03-11','08:45:00',1.75),('15844','2013-03-11','08:50:00',2.01),('15844','2013-03-11','08:55:00',2.33),('15844','2013-03-11','09:00:00',2.44),('15844','2013-03-11','09:05:00',2.48),('15844','2013-03-11','09:10:00',2.59),('15844','2013-03-11','09:15:00',2.68),('15844','2013-03-11','09:20:00',1.42),('15844','2013-03-11','09:25:00',1.92),('15844','2013-03-11','09:30:00',2.16),('15844','2013-03-11','09:35:00',1.63),('15844','2013-03-11','10:00:00',1.02),('15844','2013-03-11','10:05:00',1.1),('15844','2013-03-11','10:10:00',1.09),('15844','2013-03-11','10:15:00',1.18),('15844','2013-03-11','10:20:00',1.21),('15844','2013-03-11','10:25:00',1.22),('15844','2013-03-11','10:30:00',1.18),('15844','2013-03-11','10:35:00',1.83),('15844','2013-03-11','10:40:00',2.93),('15844','2013-03-11','10:45:00',2.82),('15844','2013-03-11','10:50:00',3.63),('15844','2013-03-11','10:55:00',2.08),('15844','2013-03-11','11:00:00',3.03),('15844','2013-03-11','11:05:00',1.3),('15844','2013-03-11','11:10:00',1.05),('15844','2013-03-11','11:15:00',1.18),('15844','2013-03-11','11:20:00',1.31),('15844','2013-03-11','11:25:00',1.2),('15844','2013-03-11','11:30:00',1.55),('15844','2013-03-11','11:35:00',2.65),('15844','2013-03-11','11:40:00',2.34),('15844','2013-03-11','11:45:00',1.61),('15844','2013-03-11','11:50:00',1.86),('15844','2013-03-11','11:55:00',1.28),('15844','2013-03-11','12:00:00',1.05),('15844','2013-03-11','12:10:00',1.62),('15844','2013-03-11','12:15:00',1.7),('15844','2013-03-11','12:20:00',2.5),('15844','2013-03-11','12:25:00',1.03),('15844','2013-03-11','12:30:00',2.91),('15844','2013-03-11','12:35:00',1.63),('15844','2013-03-11','12:40:00',2.21),('15844','2013-03-11','12:45:00',1.28),('15844','2013-03-11','12:50:00',2.59),('15844','2013-03-11','12:55:00',3.59),('15844','2013-03-11','13:00:00',3.41),('15844','2013-03-11','13:05:00',2.94),('15844','2013-03-11','13:10:00',3.16),('15844','2013-03-11','13:15:00',2.25),('15844','2013-03-11','13:20:00',2.7),('15844','2013-03-11','13:25:00',2.79),('15844','2013-03-11','13:30:00',2.69),('15844','2013-03-11','13:35:00',2.67),('15844','2013-03-11','13:40:00',1.63),('15844','2013-03-11','13:45:00',2.67),('15844','2013-03-11','13:50:00',2.31),('15844','2013-03-11','13:55:00',1.6),('15844','2013-03-11','14:00:00',2.35),('15844','2013-03-11','14:05:00',2.29),('15844','2013-03-11','14:10:00',1.55),('15844','2013-03-11','14:15:00',1.66),('15844','2013-03-11','14:20:00',2.2),('15844','2013-03-11','14:25:00',1.77),('15844','2013-03-11','14:30:00',1.61),('15844','2013-03-11','14:35:00',1.81),('15844','2013-03-11','14:40:00',1.59),('15844','2013-03-11','14:45:00',1.39),('15844','2013-03-11','14:50:00',1.17),('15844','2013-03-11','14:55:00',1.08),('15844','2013-03-11','15:05:00',1.1),('15844','2013-03-10','07:55:00',1.01),('15844','2013-03-10','08:00:00',1.06),('15844','2013-03-10','08:05:00',1.19),('15844','2013-03-10','08:10:00',1.31),('15844','2013-03-10','08:15:00',1.43),('15844','2013-03-10','08:20:00',1.55),('15844','2013-03-10','08:25:00',1.68),('15844','2013-03-10','08:30:00',1.82),('15844','2013-03-10','08:35:00',1.92),('15844','2013-03-10','08:40:00',2.01),('15844','2013-03-10','08:45:00',2.13),('15844','2013-03-10','08:50:00',2.27),('15844','2013-03-10','08:55:00',2.32),('15844','2013-03-10','09:00:00',2.39),('15844','2013-03-10','09:05:00',2.48),('15844','2013-03-10','09:10:00',2.55),('15844','2013-03-10','09:15:00',2.58),('15844','2013-03-10','09:20:00',2.71),('15844','2013-03-10','09:25:00',2.82),('15844','2013-03-10','09:30:00',1.91),('15844','2013-03-10','09:35:00',2.44),('15844','2013-03-10','09:40:00',2.8),('15844','2013-03-10','09:45:00',3.3),('15844','2013-03-10','09:50:00',2.73),('15844','2013-03-10','09:55:00',2.6),('15844','2013-03-10','10:00:00',3.13),('15844','2013-03-10','10:05:00',3.46),('15844','2013-03-10','10:10:00',3.59),('15844','2013-03-10','10:15:00',3.5),('15844','2013-03-10','10:20:00',3.06),('15844','2013-03-10','10:25:00',3.55),('15844','2013-03-10','10:30:00',3.49),('15844','2013-03-10','10:35:00',3.52),('15844','2013-03-10','10:40:00',3.55),('15844','2013-03-10','10:45:00',2.89),('15844','2013-03-10','10:50:00',2.98),('15844','2013-03-10','10:55:00',3.66),('15844','2013-03-10','11:00:00',3.45),('15844','2013-03-10','11:05:00',3.64),('15844','2013-03-10','11:10:00',3.57),('15844','2013-03-10','11:15:00',3.05),('15844','2013-03-10','11:20:00',3.77),('15844','2013-03-10','11:25:00',3.62),('15844','2013-03-10','11:30:00',2.32),('15844','2013-03-10','11:35:00',3.63),('15844','2013-03-10','11:40:00',3.72),('15844','2013-03-10','11:45:00',3.73),('15844','2013-03-10','11:50:00',3.58),('15844','2013-03-10','11:55:00',3.47),('15844','2013-03-10','12:00:00',3.48),('15844','2013-03-10','12:05:00',3.45),('15844','2013-03-10','12:10:00',3.44),('15844','2013-03-10','12:15:00',3.43),('15844','2013-03-10','12:20:00',3.45),('15844','2013-03-10','12:25:00',3.37),('15844','2013-03-10','12:30:00',3.31),('15844','2013-03-10','12:35:00',1.98),('15844','2013-03-10','12:40:00',1.57),('15844','2013-03-10','12:45:00',3.14),('15844','2013-03-10','12:50:00',3.72),('15844','2013-03-10','12:55:00',3.27),('15844','2013-03-10','13:00:00',3.07),('15844','2013-03-10','13:05:00',3.01),('15844','2013-03-10','13:10:00',2.91),('15844','2013-03-10','13:15:00',2.93),('15844','2013-03-10','13:20:00',2.65),('15844','2013-03-10','13:25:00',2.46),('15844','2013-03-10','13:30:00',2.61),('15844','2013-03-10','13:35:00',1.53),('15844','2013-03-10','13:40:00',1.53),('15844','2013-03-10','13:45:00',1.35),('15844','2013-03-10','13:50:00',1.34),('15844','2013-03-10','13:55:00',1.43),('15844','2013-03-10','14:00:00',1.32),('15844','2013-03-10','14:05:00',1.46),('15844','2013-03-10','14:10:00',1.38),('15844','2013-03-10','14:15:00',1.37),('15844','2013-03-10','14:20:00',1.61),('15844','2013-03-10','14:25:00',1.3),('15844','2013-03-10','14:40:00',1.25),('15844','2013-03-10','14:45:00',1.25),('15844','2013-03-10','14:50:00',1.29),('15844','2013-03-10','15:05:00',1.09),('15844','2013-03-09','08:10:00',1.33),('15844','2013-03-09','08:15:00',1.45),('15844','2013-03-09','08:20:00',1.6),('15844','2013-03-09','08:25:00',1.73),('15844','2013-03-09','08:30:00',1.82),('15844','2013-03-09','08:35:00',1.92),('15844','2013-03-09','08:40:00',2),('15844','2013-03-09','08:45:00',2.09),('15844','2013-03-09','08:50:00',2.2),('15844','2013-03-09','08:55:00',1.94),('15844','2013-03-09','09:00:00',1.41),('15844','2013-03-09','09:05:00',1.04),('15844','2013-03-09','09:10:00',1.79),('15844','2013-03-09','09:20:00',1.03),('15844','2013-03-09','09:25:00',1.79),('15844','2013-03-09','09:30:00',2.64),('15844','2013-03-09','09:35:00',2.69),('15844','2013-03-09','09:40:00',3.06),('15844','2013-03-09','09:45:00',3.11),('15844','2013-03-09','09:50:00',3.31),('15844','2013-03-09','09:55:00',3.59),('15844','2013-03-09','10:00:00',3.68),('15844','2013-03-09','10:05:00',3.62),('15844','2013-03-09','10:10:00',3.56),('15844','2013-03-09','10:15:00',3.66),('15844','2013-03-09','10:20:00',3.25),('15844','2013-03-09','10:25:00',2.63),('15844','2013-03-09','10:30:00',2.82),('15844','2013-03-09','10:35:00',2.71),('15844','2013-03-09','10:40:00',3.99),('15844','2013-03-09','10:45:00',3.77),('15844','2013-03-09','10:50:00',3.67),('15844','2013-03-09','10:55:00',3.65),('15844','2013-03-09','11:00:00',3.61),('15844','2013-03-09','11:05:00',3.6),('15844','2013-03-09','11:10:00',3.61),('15844','2013-03-09','11:15:00',3.61),('15844','2013-03-09','11:20:00',3.6),('15844','2013-03-09','11:25:00',3.59),('15844','2013-03-09','11:30:00',3.57),('15844','2013-03-09','11:35:00',3.55),('15844','2013-03-09','11:40:00',3.52),('15844','2013-03-09','11:45:00',3.46),('15844','2013-03-09','11:50:00',3.48),('15844','2013-03-09','11:55:00',3.45),('15844','2013-03-09','12:00:00',3.45),('15844','2013-03-09','12:05:00',3.26),('15844','2013-03-09','12:10:00',3.11),('15844','2013-03-09','12:15:00',2.13),('15844','2013-03-09','12:20:00',2.09),('15844','2013-03-09','12:25:00',2.99),('15844','2013-03-09','12:30:00',2.21),('15844','2013-03-09','12:35:00',1.74),('15844','2013-03-09','12:40:00',3.83),('15844','2013-03-09','12:45:00',3.55),('15844','2013-03-09','12:50:00',3.22),('15844','2013-03-09','12:55:00',3.13),('15844','2013-03-09','13:00:00',3.06),('15844','2013-03-09','13:05:00',2.99),('15844','2013-03-09','13:10:00',2.68),('15844','2013-03-09','13:15:00',2.15),('15844','2013-03-09','13:20:00',2.64),('15844','2013-03-09','13:25:00',2.02),('15844','2013-03-09','13:30:00',2.51),('15844','2013-03-09','13:35:00',2.48),('15844','2013-03-09','13:40:00',2.37),('15844','2013-03-09','13:45:00',2.28),('15844','2013-03-09','13:50:00',2.18),('15844','2013-03-09','13:55:00',2.1),('15844','2013-03-09','14:00:00',1.48),('15844','2013-03-09','14:10:00',1.48),('15844','2013-03-09','14:15:00',1.23),('15844','2013-03-09','14:20:00',1.57),('15844','2013-03-09','14:25:00',1.41),('15844','2013-03-09','14:30:00',1.27),('15844','2013-03-09','14:35:00',1.19),('15844','2013-03-09','14:40:00',1.11),('15844','2013-03-09','14:45:00',1.07),('15844','2013-03-09','14:50:00',1.02),('15844','2013-03-08','09:05:00',1.25),('15844','2013-03-08','09:10:00',2.14),('15844','2013-03-08','09:15:00',2.22),('15844','2013-03-08','09:20:00',2.41),('15844','2013-03-08','09:25:00',2.5),('15844','2013-03-08','09:30:00',2.66),('15844','2013-03-08','09:35:00',1.45),('15844','2013-03-08','09:40:00',3.12),('15844','2013-03-08','09:45:00',2.89),('15844','2013-03-08','09:50:00',1.96),('15844','2013-03-08','09:55:00',3.27),('15844','2013-03-08','10:00:00',1.34),('15844','2013-03-08','10:05:00',1.94),('15844','2013-03-08','10:10:00',1.9),('15844','2013-03-08','10:15:00',2.05),('15844','2013-03-08','10:20:00',2.48),('15844','2013-03-08','10:25:00',1.71),('15844','2013-03-08','10:30:00',1.42),('15844','2013-03-08','11:50:00',1.11),('15844','2013-03-08','11:55:00',2.1),('15844','2013-03-08','12:05:00',1.15),('15844','2013-03-08','12:10:00',1.72),('15844','2013-03-08','12:15:00',1.63),('15844','2013-03-08','12:20:00',1.42),('15844','2013-03-08','12:25:00',1.14),('15844','2013-03-08','12:35:00',1.01),('15844','2013-03-08','12:40:00',1.45),('15844','2013-03-08','12:45:00',1.7),('15844','2013-03-08','12:50:00',1.82),('15844','2013-03-08','12:55:00',2.87),('15844','2013-03-08','13:00:00',3.23),('15844','2013-03-08','13:05:00',1.85),('15844','2013-03-08','13:10:00',1.12),('15844','2013-03-08','13:15:00',1.04),('15844','2013-03-08','13:30:00',1.03),('15844','2013-03-07','08:50:00',1.15),('15844','2013-03-07','08:55:00',1.04),('15844','2013-03-07','10:35:00',1.06),('15844','2013-03-07','10:45:00',1.01),('15844','2013-03-07','10:50:00',1.22),('15844','2013-03-07','10:55:00',1.15),('15844','2013-03-07','11:00:00',1.04),('15844','2013-03-07','11:05:00',1.14),('15844','2013-03-07','11:10:00',1.15),('15844','2013-03-07','11:35:00',1.93),('15844','2013-03-07','11:40:00',4.13),('15844','2013-03-07','11:45:00',2.37),('15844','2013-03-07','11:50:00',1.95),('15844','2013-03-07','11:55:00',2.07),('15844','2013-03-07','12:00:00',1.6),('15844','2013-03-07','12:20:00',1.33),('15844','2013-03-07','12:25:00',1.29),('15844','2013-03-07','13:00:00',1.14),('15844','2013-03-07','13:05:00',2.36),('15844','2013-03-07','13:10:00',2.73),('15844','2013-03-07','13:15:00',1.65),('15844','2013-03-07','13:20:00',1.04),('15844','2013-03-07','13:25:00',1.12),('15844','2013-03-07','13:30:00',1.58),('15844','2013-03-07','13:35:00',1.33),('15844','2013-03-07','15:35:00',1.17),('15844','2013-03-07','15:40:00',1.01),('15844','2013-03-05','08:25:00',1.44),('15844','2013-03-05','08:30:00',1.23),('15844','2013-03-05','08:35:00',1.35),('15844','2013-03-05','08:40:00',1.19),('15844','2013-03-05','08:45:00',1.28),('15844','2013-03-05','08:50:00',1.34),('15844','2013-03-05','08:55:00',1.3),('15844','2013-03-05','09:00:00',1.28),('15844','2013-03-05','09:05:00',1.26),('15844','2013-03-05','09:10:00',1.19),('15844','2013-03-05','09:15:00',1.19),('15844','2013-03-05','09:20:00',1.24),('15844','2013-03-05','09:25:00',1.24),('15844','2013-03-05','09:30:00',1.37),('15844','2013-03-05','09:35:00',1.44),('15844','2013-03-05','09:40:00',1.47),('15844','2013-03-05','09:45:00',1.45),('15844','2013-03-05','09:50:00',1.37),('15844','2013-03-05','09:55:00',1.45),('15844','2013-03-05','10:00:00',1.47),('15844','2013-03-05','10:05:00',1.4),('15844','2013-03-05','10:10:00',1.46),('15844','2013-03-05','10:15:00',1.59),('15844','2013-03-05','10:20:00',1.73),('15844','2013-03-05','10:25:00',1.57),('15844','2013-03-05','10:30:00',1.7),('15844','2013-03-05','10:35:00',1.89),('15844','2013-03-05','10:40:00',2.02),('15844','2013-03-05','10:45:00',2.11),('15844','2013-03-05','10:50:00',2.35),('15844','2013-03-05','10:55:00',2.23),('15844','2013-03-05','11:00:00',2.23),('15844','2013-03-05','11:05:00',2.34),('15844','2013-03-05','11:10:00',2.33),('15844','2013-03-05','11:15:00',2.21),('15844','2013-03-05','11:20:00',2.15),('15844','2013-03-05','11:25:00',2.14),('15844','2013-03-05','11:30:00',2.28),('15844','2013-03-05','11:35:00',2.51),('15844','2013-03-05','11:40:00',2.61),('15844','2013-03-05','11:45:00',2.5),('15844','2013-03-05','11:50:00',2.61),('15844','2013-03-05','11:55:00',2.61),('15844','2013-03-05','12:00:00',2.64),('15844','2013-03-05','12:05:00',2.69),('15844','2013-03-05','12:10:00',2.71),('15844','2013-03-05','12:15:00',2.11),('15844','2013-03-05','12:20:00',2.53),('15844','2013-03-05','12:25:00',2.34),('15844','2013-03-05','12:30:00',1.92),('15844','2013-03-05','12:35:00',1.94),('15844','2013-03-05','12:40:00',2),('15844','2013-03-05','12:45:00',1.99),('15844','2013-03-05','12:50:00',1.76),('15844','2013-03-05','12:55:00',1.5),('15844','2013-03-05','13:00:00',1.34),('15844','2013-03-05','13:05:00',1.33),('15844','2013-03-05','13:10:00',1.45),('15844','2013-03-05','13:15:00',1.46),('15844','2013-03-05','13:20:00',1.36),('15844','2013-03-05','13:25:00',1.25),('15844','2013-03-05','13:30:00',1.15),('15844','2013-03-05','13:35:00',1.08),('15844','2013-03-05','13:40:00',1),('15844','2013-03-04','08:20:00',1.16),('15844','2013-03-04','08:25:00',1.29),('15844','2013-03-04','08:30:00',1.4),('15844','2013-03-04','08:35:00',1.5),('15844','2013-03-04','08:40:00',1.62),('15844','2013-03-04','08:45:00',1.71),('15844','2013-03-04','08:50:00',1.8),('15844','2013-03-04','08:55:00',1.91),('15844','2013-03-04','09:00:00',2),('15844','2013-03-04','09:05:00',2.1),('15844','2013-03-04','09:10:00',2.19),('15844','2013-03-04','09:15:00',2.31),('15844','2013-03-04','09:20:00',2.4),('15844','2013-03-04','09:25:00',2.49),('15844','2013-03-04','09:30:00',2.55),('15844','2013-03-04','09:35:00',2.6),('15844','2013-03-04','09:40:00',2.65),('15844','2013-03-04','09:45:00',2.71),('15844','2013-03-04','09:50:00',2.78),('15844','2013-03-04','09:55:00',2.81),('15844','2013-03-04','10:00:00',2.88),('15844','2013-03-04','10:05:00',2.88),('15844','2013-03-04','10:10:00',2.92),('15844','2013-03-04','10:15:00',2.94),('15844','2013-03-04','10:20:00',3.04),('15844','2013-03-04','10:25:00',3),('15844','2013-03-04','10:30:00',3.06),('15844','2013-03-04','10:35:00',3.06),('15844','2013-03-04','10:40:00',3.05),('15844','2013-03-04','10:45:00',3.12),('15844','2013-03-04','10:50:00',3.13),('15844','2013-03-04','10:55:00',3.19),('15844','2013-03-04','11:00:00',3.21),('15844','2013-03-04','11:05:00',3.22),('15844','2013-03-04','11:10:00',3.22),('15844','2013-03-04','11:15:00',3.25),('15844','2013-03-04','11:20:00',3.22),('15844','2013-03-04','11:25:00',3.21),('15844','2013-03-04','11:30:00',3.16),('15844','2013-03-04','11:35:00',3.12),('15844','2013-03-04','11:40:00',3.14),('15844','2013-03-04','11:45:00',3.14),('15844','2013-03-04','11:50:00',3.1),('15844','2013-03-04','11:55:00',3.02),('15844','2013-03-04','12:00:00',3.02),('15844','2013-03-04','12:05:00',3.07),('15844','2013-03-04','12:10:00',3.07),('15844','2013-03-04','12:15:00',3.06),('15844','2013-03-04','12:20:00',3),('15844','2013-03-04','12:25:00',2.97),('15844','2013-03-04','12:30:00',2.91),('15844','2013-03-04','12:35:00',2.86),('15844','2013-03-04','12:40:00',2.87),('15844','2013-03-04','12:45:00',2.8),('15844','2013-03-04','12:50:00',2.68),('15844','2013-03-04','12:55:00',2.64),('15844','2013-03-04','13:00:00',2.6),('15844','2013-03-04','13:05:00',2.62),('15844','2013-03-04','13:10:00',2.47),('15844','2013-03-04','13:15:00',2.46),('15844','2013-03-04','13:20:00',2.41),('15844','2013-03-04','13:25:00',2.4),('15844','2013-03-04','13:30:00',2.44),('15844','2013-03-04','13:35:00',2.2),('15844','2013-03-04','13:40:00',2.04),('15844','2013-03-04','13:45:00',1.99),('15844','2013-03-04','13:50:00',1.88),('15844','2013-03-04','13:55:00',1.79),('15844','2013-03-04','14:00:00',1.7),('15844','2013-03-04','14:05:00',1.61),('15844','2013-03-04','14:10:00',1.53),('15844','2013-03-04','14:15:00',1.45),('15844','2013-03-04','14:20:00',1.37),('15844','2013-03-04','14:25:00',1.29),('15844','2013-03-04','14:30:00',1.19),('15844','2013-03-04','14:35:00',1.07),('15844','2013-03-03','08:00:00',1.03),('15844','2013-03-03','08:05:00',1.14),('15844','2013-03-03','08:10:00',1.23),('15844','2013-03-03','08:15:00',1.34),('15844','2013-03-03','08:20:00',1.44),('15844','2013-03-03','08:25:00',1.52),('15844','2013-03-03','08:30:00',1.59),('15844','2013-03-03','08:35:00',1.68),('15844','2013-03-03','08:40:00',1.75),('15844','2013-03-03','08:45:00',1.82),('15844','2013-03-03','08:50:00',1.89),('15844','2013-03-03','08:55:00',1.96),('15844','2013-03-03','09:00:00',2.03),('15844','2013-03-03','09:05:00',2.09),('15844','2013-03-03','09:10:00',2.15),('15844','2013-03-03','09:15:00',2.22),('15844','2013-03-03','09:20:00',2.38),('15844','2013-03-03','09:25:00',2.48),('15844','2013-03-03','09:30:00',2.56),('15844','2013-03-03','09:35:00',2.65),('15844','2013-03-03','09:40:00',2.73),('15844','2013-03-03','09:45:00',2.81),('15844','2013-03-03','09:50:00',2.84),('15844','2013-03-03','09:55:00',2.92),('15844','2013-03-03','10:00:00',2.96),('15844','2013-03-03','10:05:00',2.97),('15844','2013-03-03','10:10:00',3.03),('15844','2013-03-03','10:15:00',3.08),('15844','2013-03-03','10:20:00',3.1),('15844','2013-03-03','10:25:00',3.14),('15844','2013-03-03','10:30:00',3.18),('15844','2013-03-03','10:35:00',3.2),('15844','2013-03-03','10:40:00',3.24),('15844','2013-03-03','10:45:00',3.26),('15844','2013-03-03','10:50:00',3.29),('15844','2013-03-03','10:55:00',3.3),('15844','2013-03-03','11:00:00',3.32),('15844','2013-03-03','11:05:00',3.33),('15844','2013-03-03','11:10:00',3.33),('15844','2013-03-03','11:15:00',3.33),('15844','2013-03-03','11:20:00',3.33),('15844','2013-03-03','11:25:00',3.33),('15844','2013-03-03','11:30:00',3.31),('15844','2013-03-03','11:35:00',3.31),('15844','2013-03-03','11:40:00',3.29),('15844','2013-03-03','11:45:00',3.27),('15844','2013-03-03','11:50:00',3.25),('15844','2013-03-03','11:55:00',3.23),('15844','2013-03-03','12:00:00',3.23),('15844','2013-03-03','12:05:00',3.21),('15844','2013-03-03','12:10:00',3.2),('15844','2013-03-03','12:15:00',3.17),('15844','2013-03-03','12:20:00',3.14),('15844','2013-03-03','12:25:00',3.08),('15844','2013-03-03','12:30:00',3.04),('15844','2013-03-03','12:35:00',3.02),('15844','2013-03-03','12:40:00',2.99),('15844','2013-03-03','12:45:00',2.87),('15844','2013-03-03','12:50:00',2.91),('15844','2013-03-03','12:55:00',2.83),('15844','2013-03-03','13:00:00',2.78),('15844','2013-03-03','13:05:00',2.7),('15844','2013-03-03','13:10:00',2.66),('15844','2013-03-03','13:15:00',2.58),('15844','2013-03-03','13:20:00',2.5),('15844','2013-03-03','13:25:00',2.4),('15844','2013-03-03','13:30:00',2.28),('15844','2013-03-03','13:35:00',2.19),('15844','2013-03-03','13:40:00',2.09),('15844','2013-03-03','13:45:00',2.04),('15844','2013-03-03','13:50:00',1.94),('15844','2013-03-03','13:55:00',1.87),('15844','2013-03-03','14:00:00',1.75),('15844','2013-03-03','14:05:00',1.66),('15844','2013-03-03','14:10:00',1.56),('15844','2013-03-03','14:15:00',1.44),('15844','2013-03-03','14:20:00',1.32),('15844','2013-03-03','14:25:00',1.22),('15844','2013-03-03','14:30:00',1.13),('15844','2013-03-03','14:35:00',1.03),('15844','2014-03-24','08:50:00',1.17),('15844','2014-03-24','08:55:00',1.58),('15844','2014-03-24','09:15:00',1.14),('15844','2014-03-24','09:20:00',1.62),('15844','2014-03-24','09:25:00',1.66),('15844','2014-03-24','09:35:00',1.35),('15844','2014-03-24','09:40:00',1.78),('15844','2014-03-24','09:45:00',1.35),('15844','2014-03-24','09:55:00',2),('15844','2014-03-24','10:00:00',3.45),('15844','2014-03-24','10:05:00',3.54),('15844','2014-03-24','10:10:00',2.35),('15844','2014-03-24','10:30:00',1.08),('15844','2014-03-24','10:40:00',1.23),('15844','2014-03-24','10:45:00',2.73),('15844','2014-03-24','10:50:00',4.05),('15844','2014-03-24','10:55:00',3.01),('15844','2014-03-24','11:00:00',2.51),('15844','2014-03-24','11:05:00',2.53),('15844','2014-03-24','11:10:00',3.24),('15844','2014-03-24','11:15:00',3.34),('15844','2014-03-24','11:20:00',2.57),('15844','2014-03-24','11:25:00',2.36),('15844','2014-03-24','11:30:00',1.92),('15844','2014-03-24','12:25:00',1.08),('15844','2014-03-24','12:30:00',1.72),('15844','2014-03-24','12:35:00',1.79),('15844','2014-03-24','12:40:00',1.46),('15844','2014-03-24','12:45:00',1.25),('15844','2014-03-24','12:50:00',1.2),('15844','2014-03-24','12:55:00',1.15),('15844','2014-03-24','13:00:00',1.15),('15844','2014-03-24','13:05:00',1.02),('15844','2014-03-24','13:15:00',1.12),('15844','2014-03-24','13:20:00',1.08),('15844','2014-03-24','13:25:00',1.21),('15844','2014-03-24','13:30:00',1.18),('15844','2014-03-24','13:35:00',1.27),('15844','2014-03-24','13:40:00',1.26),('15844','2014-03-24','13:45:00',1.11),('15844','2014-03-24','13:50:00',1.08),('15844','2014-03-24','14:10:00',1.12),('15844','2014-03-24','14:15:00',1.53),('15844','2014-03-24','14:20:00',1.74),('15844','2014-03-24','14:25:00',1.59),('15844','2014-03-24','14:30:00',1.6),('15844','2014-03-24','14:35:00',1.92),('15844','2014-03-24','14:40:00',1.97),('15844','2014-03-24','14:45:00',1.9),('15844','2014-03-24','14:50:00',1.67),('15844','2014-03-24','14:55:00',1.42),('15844','2014-03-24','15:00:00',1.36),('15844','2014-03-24','15:05:00',1.29),('15844','2014-03-24','15:10:00',1.21),('15844','2014-03-24','15:15:00',1.25),('15844','2014-03-24','15:20:00',1.16),('15844','2014-03-24','15:25:00',1.15),('15844','2014-03-24','15:30:00',1.1),('15844','2013-03-02','11:05:00',1.02),('15844','2013-03-02','11:35:00',1.1),('15844','2013-03-02','11:40:00',1.42),('15844','2013-03-02','11:45:00',1.65),('15844','2013-03-02','11:50:00',1.45),('15844','2013-03-02','11:55:00',1.83),('15844','2013-03-02','12:00:00',1.54),('15844','2013-03-02','12:05:00',2.26),('15844','2013-03-02','12:10:00',2.48),('15844','2013-03-02','12:15:00',2.05),('15844','2013-03-02','12:20:00',2.64),('15844','2013-03-02','12:25:00',2.5),('15844','2013-03-02','12:30:00',1.94),('15844','2013-03-02','12:35:00',1.88),('15844','2013-03-02','12:40:00',1.79),('15844','2013-03-02','12:45:00',1.05),('15844','2013-03-02','12:55:00',1.02),('15844','2013-03-02','13:30:00',1.02),('15844','2013-03-02','13:35:00',1.01),('15844','2013-03-02','13:55:00',1.06),('15844','2013-03-02','14:00:00',1.13),('15844','2013-03-02','14:05:00',1.06),('15844','2013-03-01','08:30:00',1.02),('15844','2013-03-01','08:35:00',1.08),('15844','2013-03-01','08:40:00',1.24),('15844','2013-03-01','08:45:00',1.35),('15844','2013-03-01','08:50:00',1.43),('15844','2013-03-01','08:55:00',1.58),('15844','2013-03-01','09:00:00',1.71),('15844','2013-03-01','09:05:00',1.71),('15844','2013-03-01','09:10:00',1.74),('15844','2013-03-01','09:15:00',1.87),('15844','2013-03-01','09:20:00',1.93),('15844','2013-03-01','09:25:00',2.01),('15844','2013-03-01','09:30:00',2.05),('15844','2013-03-01','09:35:00',2.14),('15844','2013-03-01','09:40:00',2.2),('15844','2013-03-01','09:45:00',2.29),('15844','2013-03-01','09:50:00',2.34),('15844','2013-03-01','09:55:00',2.23),('15844','2013-03-01','10:00:00',2.05),('15844','2013-03-01','10:05:00',1.69),('15844','2013-03-01','10:10:00',1.7),('15844','2013-03-01','10:15:00',1.72),('15844','2013-03-01','10:20:00',1.69),('15844','2013-03-01','10:25:00',1.86),('15844','2013-03-01','10:30:00',2.3),('15844','2013-03-01','10:35:00',2.25),('15844','2013-03-01','10:40:00',1.99),('15844','2013-03-01','10:45:00',1.86),('15844','2013-03-01','10:50:00',1.81),('15844','2013-03-01','10:55:00',1.63),('15844','2013-03-01','11:00:00',1.47),('15844','2013-03-01','11:05:00',1.4),('15844','2013-03-01','11:10:00',1.43),('15844','2013-03-01','11:15:00',1.53),('15844','2013-03-01','11:20:00',1.55),('15844','2013-03-01','11:25:00',1.52),('15844','2013-03-01','11:30:00',1.51),('15844','2013-03-01','11:35:00',1.49),('15844','2013-03-01','11:40:00',1.4),('15844','2013-03-01','11:45:00',1.37),('15844','2013-03-01','11:50:00',1.3),('15844','2013-03-01','11:55:00',1.22),('15844','2013-03-01','12:00:00',1.13),('15844','2013-03-01','12:05:00',1.06),('15844','2013-03-01','12:50:00',1.04),('15844','2013-03-01','12:55:00',1.1),('15844','2013-03-01','13:00:00',1.11),('15844','2013-03-01','13:05:00',1.12),('15844','2013-03-01','13:10:00',1.17),('15844','2013-03-01','13:15:00',1.26),('15844','2013-03-01','13:20:00',1.4),('15844','2013-03-01','13:25:00',1.4),('15844','2013-03-01','13:30:00',1.32),('15844','2013-03-01','13:35:00',1.23),('15844','2013-03-01','13:40:00',1.18),('15844','2013-03-01','13:45:00',1.18),('15844','2013-03-01','13:50:00',1.18),('15844','2013-03-01','13:55:00',1.15),('15844','2013-03-01','14:00:00',1.09),('15844','2013-03-01','14:05:00',1.03),('15844','2013-02-28','08:20:00',1.01),('15844','2013-02-28','08:25:00',1.09),('15844','2013-02-28','08:30:00',1.18),('15844','2013-02-28','08:35:00',1.28),('15844','2013-02-28','08:40:00',1.37),('15844','2013-02-28','08:45:00',1.45),('15844','2013-02-28','08:50:00',1.55),('15844','2013-02-28','08:55:00',1.67),('15844','2013-02-28','09:00:00',1.77),('15844','2013-02-28','09:05:00',1.87),('15844','2013-02-28','09:10:00',1.91),('15844','2013-02-28','09:15:00',2.04),('15844','2013-02-28','09:20:00',2.11),('15844','2013-02-28','09:25:00',2.18),('15844','2013-02-28','09:30:00',2.27),('15844','2013-02-28','09:35:00',2.34),('15844','2013-02-28','09:40:00',2.41),('15844','2013-02-28','09:45:00',2.47),('15844','2013-02-28','09:50:00',2.34),('15844','2013-02-28','09:55:00',2.54),('15844','2013-02-28','10:00:00',2.6),('15844','2013-02-28','10:05:00',2.64),('15844','2013-02-28','10:10:00',2.66),('15844','2013-02-28','10:15:00',2.73),('15844','2013-02-28','10:20:00',2.77),('15844','2013-02-28','10:25:00',2.77),('15844','2013-02-28','10:30:00',2.84),('15844','2013-02-28','10:35:00',2.91),('15844','2013-02-28','10:40:00',2.92),('15844','2013-02-28','10:45:00',2.92),('15844','2013-02-28','10:50:00',2.91),('15844','2013-02-28','10:55:00',2.93),('15844','2013-02-28','11:00:00',2.98),('15844','2013-02-28','11:05:00',3.02),('15844','2013-02-28','11:10:00',3.02),('15844','2013-02-28','11:15:00',3.01),('15844','2013-02-28','11:20:00',2.97),('15844','2013-02-28','11:25:00',2.95),('15844','2013-02-28','11:30:00',2.91),('15844','2013-02-28','11:35:00',2.85),('15844','2013-02-28','11:40:00',2.94),('15844','2013-02-28','11:45:00',2.83),('15844','2013-02-28','11:50:00',2.76),('15844','2013-02-28','11:55:00',2.82),('15844','2013-02-28','12:00:00',2.84),('15844','2013-02-28','12:05:00',2.89),('15844','2013-02-28','12:10:00',2.95),('15844','2013-02-28','12:15:00',2.94),('15844','2013-02-28','12:20:00',2.9),('15844','2013-02-28','12:25:00',2.87),('15844','2013-02-28','12:30:00',2.9),('15844','2013-02-28','12:35:00',2.83),('15844','2013-02-28','12:40:00',2.75),('15844','2013-02-28','12:45:00',2.72),('15844','2013-02-28','12:50:00',2.74),('15844','2013-02-28','12:55:00',2.63),('15844','2013-02-28','13:00:00',2.47),('15844','2013-02-28','13:05:00',2.5),('15844','2013-02-28','13:10:00',2.3),('15844','2013-02-28','13:15:00',2.26),('15844','2013-02-28','13:20:00',2.27),('15844','2013-02-28','13:25:00',2.14),('15844','2013-02-28','13:30:00',2.2),('15844','2013-02-28','13:35:00',2.13),('15844','2013-02-28','13:40:00',1.29),('15844','2013-02-28','13:50:00',1.87),('15844','2013-02-28','13:55:00',1.8),('15844','2013-02-28','14:00:00',1.72),('15844','2013-02-28','14:05:00',1.63),('15844','2013-02-28','14:10:00',1.56),('15844','2013-02-28','14:15:00',1.46),('15844','2013-02-28','14:20:00',1.35),('15844','2013-02-28','14:25:00',1.27),('15844','2013-02-28','14:45:00',1.03),('15844','2013-02-27','08:25:00',1.09),('15844','2013-02-27','08:30:00',1.17),('15844','2013-02-27','08:35:00',1.26),('15844','2013-02-27','08:40:00',1.33),('15844','2013-02-27','08:45:00',1.45),('15844','2013-02-27','08:50:00',1.58),('15844','2013-02-27','08:55:00',1.65),('15844','2013-02-27','09:00:00',1.71),('15844','2013-02-27','09:05:00',1.82),('15844','2013-02-27','09:10:00',1.94),('15844','2013-02-27','09:15:00',2.04),('15844','2013-02-27','09:20:00',2.12),('15844','2013-02-27','09:25:00',2.18),('15844','2013-02-27','09:30:00',2.24),('15844','2013-02-27','09:35:00',2.31),('15844','2013-02-27','09:40:00',2.38),('15844','2013-02-27','09:45:00',2.44),('15844','2013-02-27','09:50:00',2.49),('15844','2013-02-27','09:55:00',2.53),('15844','2013-02-27','10:00:00',2.58),('15844','2013-02-27','10:05:00',2.63),('15844','2013-02-27','10:10:00',2.66),('15844','2013-02-27','10:15:00',2.71),('15844','2013-02-27','10:20:00',2.8),('15844','2013-02-27','10:25:00',2.84),('15844','2013-02-27','10:30:00',2.9),('15844','2013-02-27','10:35:00',2.91),('15844','2013-02-27','10:40:00',2.99),('15844','2013-02-27','10:45:00',3),('15844','2013-02-27','10:50:00',2.96),('15844','2013-02-27','10:55:00',3.03),('15844','2013-02-27','11:00:00',3.01),('15844','2013-02-27','11:05:00',2.99),('15844','2013-02-27','11:10:00',2.96),('15844','2013-02-27','11:15:00',2.96),('15844','2013-02-27','11:20:00',3.04),('15844','2013-02-27','11:25:00',3.11),('15844','2013-02-27','11:30:00',3.09),('15844','2013-02-27','11:35:00',3.04),('15844','2013-02-27','11:40:00',2.91),('15844','2013-02-27','11:45:00',2.52),('15844','2013-02-27','11:50:00',3.16),('15844','2013-02-27','11:55:00',3.14),('15844','2013-02-27','12:00:00',3.1),('15844','2013-02-27','12:05:00',3.19),('15844','2013-02-27','12:10:00',3.18),('15844','2013-02-27','12:15:00',3.05),('15844','2013-02-27','12:20:00',3.02),('15844','2013-02-27','12:25:00',2.95),('15844','2013-02-27','12:30:00',2.89),('15844','2013-02-27','12:35:00',2.82),('15844','2013-02-27','12:40:00',2.75),('15844','2013-02-27','12:45:00',2.94),('15844','2013-02-27','12:50:00',2.81),('15844','2013-02-27','12:55:00',2.77),('15844','2013-02-27','13:00:00',2.68),('15844','2013-02-27','13:05:00',2.6),('15844','2013-02-27','13:10:00',2.52),('15844','2013-02-27','13:15:00',2.49),('15844','2013-02-27','13:20:00',2.47),('15844','2013-02-27','13:25:00',2.33),('15844','2013-02-27','13:30:00',2.21),('15844','2013-02-27','13:35:00',2.16),('15844','2013-02-27','13:40:00',2.11),('15844','2013-02-27','13:45:00',2.06),('15844','2013-02-27','13:50:00',1.94),('15844','2013-02-27','14:05:00',1.18),('15844','2013-02-27','14:10:00',1.45),('15844','2013-02-27','14:15:00',1.4),('15844','2013-02-27','14:20:00',1.37),('15844','2013-02-27','14:25:00',1.34),('15844','2013-02-27','14:30:00',1.29),('15844','2013-02-27','14:35:00',1.24),('15844','2013-02-27','14:40:00',1.14),('15844','2013-02-27','14:45:00',1.25),('15844','2013-02-27','14:50:00',1.28),('15844','2013-02-27','14:55:00',1.15),('15844','2013-02-27','15:00:00',1.13),('15844','2013-02-27','15:05:00',1.03),('15844','2013-02-26','09:25:00',1.02),('15844','2013-02-26','09:30:00',1.17),('15844','2013-02-26','09:35:00',1.36),('15844','2013-02-26','09:40:00',1.46),('15844','2013-02-26','09:45:00',1.71),('15844','2013-02-26','09:50:00',2.11),('15844','2013-02-26','09:55:00',2.38),('15844','2013-02-26','10:00:00',2.56),('15844','2013-02-26','10:05:00',2.46),('15844','2013-02-26','10:10:00',2.24),('15844','2013-02-26','10:15:00',2.48),('15844','2013-02-26','10:20:00',2.54),('15844','2013-02-26','10:25:00',1.59),('15844','2013-02-26','10:30:00',1.77),('15844','2013-02-26','10:35:00',2.8),('15844','2013-02-26','10:40:00',2.16),('15844','2013-02-26','10:45:00',2.02),('15844','2013-02-26','10:50:00',1.69),('15844','2013-02-26','10:55:00',1.97),('15844','2013-02-26','11:00:00',1.85),('15844','2013-02-26','11:05:00',2.07),('15844','2013-02-26','11:10:00',1.49),('15844','2013-02-26','11:15:00',1.74),('15844','2013-02-26','11:20:00',1.81),('15844','2013-02-26','11:25:00',1.66),('15844','2013-02-26','11:30:00',1.7),('15844','2013-02-26','11:35:00',1.79),('15844','2013-02-26','11:40:00',1.6),('15844','2013-02-26','11:45:00',2.63),('15844','2013-02-26','11:50:00',2.65),('15844','2013-02-26','11:55:00',2.18),('15844','2013-02-26','12:00:00',1.8),('15844','2013-02-26','12:05:00',1.69),('15844','2013-02-26','12:10:00',2.11),('15844','2013-02-26','12:15:00',1.81),('15844','2013-02-26','12:20:00',1.48),('15844','2013-02-26','12:25:00',1.4),('15844','2013-02-26','12:30:00',1.27),('15844','2013-02-26','12:35:00',1),('15844','2013-02-26','13:15:00',1.02),('15844','2013-02-25','10:40:00',1.1),('15844','2013-02-25','10:45:00',1.89),('15844','2013-02-25','10:50:00',3.46),('15844','2013-02-25','10:55:00',3.4),('15844','2013-02-25','11:00:00',2.05),('15844','2013-02-25','11:05:00',3.91),('15844','2013-02-25','11:10:00',3.53),('15844','2013-02-25','11:15:00',3.45),('15844','2013-02-25','11:20:00',3.7),('15844','2013-02-25','11:25:00',3.28),('15844','2013-02-25','11:30:00',1.44),('15844','2013-02-25','11:35:00',1.15),('15844','2013-02-25','11:40:00',1.06),('15844','2013-02-25','11:45:00',1.1),('15844','2013-02-25','11:50:00',1.04),('15844','2013-02-25','11:55:00',1.12),('15844','2013-02-25','12:00:00',1.24),('15844','2013-02-25','12:05:00',1.54),('15844','2013-02-25','12:10:00',1.75),('15844','2013-02-25','12:15:00',1.86),('15844','2013-02-25','12:20:00',3.2),('15844','2013-02-25','12:25:00',1.4),('15844','2013-02-25','12:30:00',1.47),('15844','2013-02-25','12:35:00',2.08),('15844','2013-02-25','12:40:00',1.5),('15844','2013-02-25','12:45:00',2.07),('15844','2013-02-25','12:50:00',3.36),('15844','2013-02-25','12:55:00',2.03),('15844','2013-02-25','13:00:00',2.54),('15844','2013-02-25','13:05:00',1.86),('15844','2013-02-25','13:15:00',1.41),('15844','2013-02-25','13:20:00',1.33),('15844','2013-02-25','13:25:00',1.17),('15844','2013-02-25','13:55:00',1.03),('15844','2013-02-24','10:45:00',1.45),('15844','2013-02-24','10:50:00',2.65),('15844','2013-02-24','10:55:00',1.81),('15844','2013-02-24','11:00:00',1.47),('15844','2013-02-24','11:05:00',1.26),('15844','2013-02-24','12:35:00',1.22),('15844','2013-02-24','12:45:00',1.01),('15844','2013-02-24','12:50:00',1.63),('15844','2013-02-24','12:55:00',1.45),('15844','2013-02-24','13:00:00',1.39),('15844','2013-02-24','13:05:00',1.24),('15844','2013-02-24','13:10:00',1.15),('15844','2013-02-24','13:25:00',1.1),('15844','2013-02-24','14:00:00',1.52),('15844','2013-02-24','14:05:00',1.35),('15844','2013-02-24','14:10:00',1.03),('15844','2013-02-24','14:55:00',1.06),('15844','2013-02-24','15:00:00',1.2),('15844','2013-02-24','15:05:00',1.19),('15844','2013-02-23','08:05:00',1.07),('15844','2013-02-23','08:10:00',1.34),('15844','2013-02-23','08:15:00',1.25),('15844','2013-02-23','09:00:00',1.22),('15844','2013-02-23','09:05:00',1.16),('15844','2013-02-23','09:50:00',1.01),('15844','2013-02-23','10:40:00',1.01),('15844','2013-02-23','10:45:00',1.03),('15844','2013-02-23','10:50:00',1.1),('15844','2013-02-23','11:35:00',1.04),('15844','2013-02-23','14:00:00',1.12),('15844','2013-02-23','14:05:00',1.22),('15844','2013-02-22','14:00:00',1.02),('15844','2013-02-22','14:25:00',1.03),('15844','2013-02-21','12:05:00',1.02),('15844','2013-02-21','12:35:00',1),('15844','2013-02-21','12:40:00',1.05),('15844','2013-02-21','13:15:00',1.02),('15844','2013-02-21','13:20:00',1.09),('15844','2013-02-21','13:25:00',1.04),('15844','2014-03-23','08:30:00',1.1),('15844','2014-03-23','08:50:00',1.41),('15844','2014-03-23','08:55:00',1.31),('15844','2014-03-23','09:00:00',1.59),('15844','2014-03-23','09:05:00',2.35),('15844','2014-03-23','09:10:00',2.48),('15844','2014-03-23','09:15:00',1.89),('15844','2014-03-23','09:20:00',1.05),('15844','2014-03-23','09:30:00',1.25),('15844','2014-03-23','10:25:00',1.45),('15844','2014-03-23','10:40:00',1.39),('15844','2014-03-23','10:50:00',1.61),('15844','2014-03-23','10:55:00',1.35),('15844','2014-03-23','11:05:00',1.12),('15844','2014-03-23','11:20:00',1.07),('15844','2014-03-23','11:35:00',1.51),('15844','2014-03-23','11:40:00',1.67),('15844','2014-03-23','13:35:00',1.03),('15844','2014-03-23','13:40:00',2.03),('15844','2014-03-23','13:45:00',1.31),('15844','2014-03-23','13:50:00',1.06),('15844','2014-03-23','14:55:00',1.17),('15844','2014-03-23','15:00:00',1.02),('15844','2014-03-23','15:05:00',1.17),('15844','2014-03-23','15:10:00',1.31),('15844','2014-03-23','15:15:00',1.01),('15844','2013-02-20','08:25:00',1.05),('15844','2013-02-20','08:30:00',1.13),('15844','2013-02-20','08:35:00',1.24),('15844','2013-02-20','08:40:00',1.34),('15844','2013-02-20','08:45:00',1.42),('15844','2013-02-20','08:50:00',1.51),('15844','2013-02-20','08:55:00',1.59),('15844','2013-02-20','09:00:00',1.62),('15844','2013-02-20','09:05:00',1.29),('15844','2013-02-20','09:10:00',1.67),('15844','2013-02-20','09:20:00',1.87),('15844','2013-02-20','09:25:00',1.2),('15844','2013-02-20','09:30:00',1.94),('15844','2013-02-20','09:35:00',1.24),('15844','2013-02-20','09:40:00',1.76),('15844','2013-02-20','09:45:00',1.92),('15844','2013-02-20','10:10:00',1.02),('15844','2013-02-20','10:15:00',1.33),('15844','2013-02-20','10:20:00',1.29),('15844','2013-02-20','10:35:00',2.28),('15844','2013-02-20','10:40:00',2.46),('15844','2013-02-20','10:45:00',3.27),('15844','2013-02-20','10:50:00',3.26),('15844','2013-02-20','10:55:00',3.33),('15844','2013-02-20','11:00:00',3.62),('15844','2013-02-20','11:05:00',1.72),('15844','2013-02-20','11:15:00',1.38),('15844','2013-02-20','11:20:00',1.23),('15844','2013-02-20','11:25:00',1.01),('15844','2013-02-20','11:30:00',1.35),('15844','2013-02-20','11:35:00',1.27),('15844','2013-02-20','11:40:00',1.62),('15844','2013-02-20','11:45:00',1.17),('15844','2013-02-20','11:50:00',2.31),('15844','2013-02-20','11:55:00',3.9),('15844','2013-02-20','12:00:00',1.87),('15844','2013-02-20','12:05:00',1.57),('15844','2013-02-20','12:10:00',1.19),('15844','2013-02-20','12:25:00',1.49),('15844','2013-02-20','12:30:00',1.26),('15844','2013-02-20','12:35:00',2.49),('15844','2013-02-20','12:40:00',1.52),('15844','2013-02-20','12:45:00',2.68),('15844','2013-02-20','12:50:00',3.37),('15844','2013-02-20','12:55:00',2.83),('15844','2013-02-20','13:00:00',2.08),('15844','2013-02-20','13:05:00',1.59),('15844','2013-02-20','13:10:00',1.82),('15844','2013-02-20','13:15:00',2.36),('15844','2013-02-20','13:20:00',3),('15844','2013-02-20','13:25:00',2.79),('15844','2013-02-20','13:30:00',2.69),('15844','2013-02-20','13:35:00',1.69),('15844','2013-02-20','13:40:00',1.15),('15844','2013-02-20','13:45:00',1.04),('15844','2013-02-20','14:15:00',1.49),('15844','2013-02-20','14:20:00',1.27),('15844','2013-02-20','14:55:00',1.03),('15844','2013-02-20','15:05:00',1.02),('15844','2013-02-20','15:20:00',1),('15844','2013-02-19','08:25:00',1.08),('15844','2013-02-19','08:30:00',1.17),('15844','2013-02-19','08:35:00',1.25),('15844','2013-02-19','08:40:00',1.31),('15844','2013-02-19','08:45:00',1.39),('15844','2013-02-19','08:50:00',1.46),('15844','2013-02-19','08:55:00',1.52),('15844','2013-02-19','09:00:00',1.58),('15844','2013-02-19','09:05:00',1.71),('15844','2013-02-19','09:10:00',1.81),('15844','2013-02-19','09:15:00',1.9),('15844','2013-02-19','09:20:00',2),('15844','2013-02-19','09:25:00',2.09),('15844','2013-02-19','09:30:00',2.16),('15844','2013-02-19','09:35:00',2.22),('15844','2013-02-19','09:40:00',2.27),('15844','2013-02-19','09:45:00',2.33),('15844','2013-02-19','09:50:00',2.41),('15844','2013-02-19','09:55:00',2.48),('15844','2013-02-19','10:00:00',2.51),('15844','2013-02-19','10:05:00',2.53),('15844','2013-02-19','10:10:00',2.58),('15844','2013-02-19','10:15:00',2.62),('15844','2013-02-19','10:20:00',2.65),('15844','2013-02-19','10:25:00',2.72),('15844','2013-02-19','10:30:00',2.72),('15844','2013-02-19','10:35:00',2.74),('15844','2013-02-19','10:40:00',2.8),('15844','2013-02-19','10:45:00',2.84),('15844','2013-02-19','10:50:00',2.87),('15844','2013-02-19','10:55:00',2.94),('15844','2013-02-19','11:00:00',2.94),('15844','2013-02-19','11:05:00',2.94),('15844','2013-02-19','11:10:00',2.94),('15844','2013-02-19','11:15:00',2.93),('15844','2013-02-19','11:20:00',2.94),('15844','2013-02-19','11:25:00',2.95),('15844','2013-02-19','11:30:00',2.93),('15844','2013-02-19','11:35:00',2.9),('15844','2013-02-19','11:40:00',2.89),('15844','2013-02-19','11:45:00',2.91),('15844','2013-02-19','11:50:00',2.92),('15844','2013-02-19','11:55:00',2.91),('15844','2013-02-19','12:00:00',2.92),('15844','2013-02-19','12:05:00',2.87),('15844','2013-02-19','12:10:00',2.84),('15844','2013-02-19','12:15:00',2.82),('15844','2013-02-19','12:20:00',2.79),('15844','2013-02-19','12:25:00',2.79),('15844','2013-02-19','12:30:00',2.73),('15844','2013-02-19','12:35:00',2.65),('15844','2013-02-19','12:40:00',2.65),('15844','2013-02-19','12:45:00',2.6),('15844','2013-02-19','12:50:00',2.53),('15844','2013-02-19','12:55:00',2.51),('15844','2013-02-19','13:00:00',2.41),('15844','2013-02-19','13:05:00',2.35),('15844','2013-02-19','13:10:00',2.32),('15844','2013-02-19','13:15:00',2.22),('15844','2013-02-19','13:20:00',2.1),('15844','2013-02-19','13:25:00',2),('15844','2013-02-19','13:30:00',1.93),('15844','2013-02-19','13:35:00',1.78),('15844','2013-02-19','13:40:00',1.62),('15844','2013-02-19','13:45:00',1.58),('15844','2013-02-19','13:50:00',1.52),('15844','2013-02-19','13:55:00',1.55),('15844','2013-02-19','14:00:00',1.44),('15844','2013-02-19','14:05:00',1.38),('15844','2013-02-19','14:10:00',1.31),('15844','2013-02-19','14:15:00',1.24),('15844','2013-02-19','14:20:00',1.16),('15844','2013-02-19','14:25:00',1.06),('15844','2013-02-18','08:30:00',1.07),('15844','2013-02-18','08:35:00',1.15),('15844','2013-02-18','08:40:00',1.22),('15844','2013-02-18','08:45:00',1.3),('15844','2013-02-18','08:50:00',1.37),('15844','2013-02-18','08:55:00',1.44),('15844','2013-02-18','09:00:00',1.55),('15844','2013-02-18','09:05:00',1.66),('15844','2013-02-18','09:10:00',1.48),('15844','2013-02-18','09:15:00',1.55),('15844','2013-02-18','09:20:00',1.62),('15844','2013-02-18','09:25:00',1.32),('15844','2013-02-18','09:35:00',1.3),('15844','2013-02-18','10:00:00',1.42),('15844','2013-02-18','10:05:00',2.2),('15844','2013-02-18','11:05:00',1.2),('15844','2013-02-18','11:10:00',1.48),('15844','2013-02-18','11:15:00',1.5),('15844','2013-02-18','11:20:00',1.66),('15844','2013-02-18','11:25:00',1.39),('15844','2013-02-18','11:30:00',1.47),('15844','2013-02-18','11:35:00',1.53),('15844','2013-02-18','11:40:00',1.55),('15844','2013-02-18','11:45:00',1.62),('15844','2013-02-18','11:50:00',1.83),('15844','2013-02-18','11:55:00',1.73),('15844','2013-02-18','12:00:00',1.46),('15844','2013-02-18','12:05:00',1.23),('15844','2013-02-18','12:10:00',1.15),('15844','2013-02-18','12:15:00',1.16),('15844','2013-02-18','12:20:00',1.1),('15844','2013-02-18','12:25:00',1.2),('15844','2013-02-18','12:30:00',1.09),('15844','2013-02-18','12:35:00',1.01),('15844','2013-02-18','12:40:00',1.18),('15844','2013-02-18','12:45:00',1.31),('15844','2013-02-18','12:50:00',1.22),('15844','2013-02-18','12:55:00',1.29),('15844','2013-02-18','13:00:00',1.29),('15844','2013-02-18','13:05:00',1.51),('15844','2013-02-18','13:10:00',1.63),('15844','2013-02-18','13:15:00',1.64),('15844','2013-02-18','13:20:00',1.58),('15844','2013-02-18','13:25:00',1.27),('15844','2013-02-18','13:30:00',1.09),('15844','2013-02-18','13:35:00',1.03),('15844','2013-02-18','13:40:00',1.15),('15844','2013-02-18','13:45:00',1.17),('15844','2013-02-18','13:50:00',1.23),('15844','2013-02-18','13:55:00',1.45),('15844','2013-02-18','14:00:00',1.44),('15844','2013-02-18','14:05:00',1.33),('15844','2013-02-18','14:10:00',1.04),('15844','2013-02-18','14:15:00',1.32),('15844','2013-02-18','14:20:00',1.08),('15844','2013-02-18','14:55:00',1),('15844','2013-02-17','08:30:00',1.09),('15844','2013-02-17','08:35:00',1.19),('15844','2013-02-17','08:40:00',1.24),('15844','2013-02-17','08:45:00',1.16),('15844','2013-02-17','08:50:00',1.28),('15844','2013-02-17','08:55:00',1.43),('15844','2013-02-17','09:00:00',1.32),('15844','2013-02-17','09:05:00',1.55),('15844','2013-02-17','09:10:00',1.7),('15844','2013-02-17','09:15:00',1.81),('15844','2013-02-17','09:20:00',1.89),('15844','2013-02-17','09:25:00',1.96),('15844','2013-02-17','09:30:00',1.98),('15844','2013-02-17','09:35:00',2.04),('15844','2013-02-17','09:40:00',2.09),('15844','2013-02-17','09:45:00',2.17),('15844','2013-02-17','09:50:00',2.23),('15844','2013-02-17','09:55:00',2.28),('15844','2013-02-17','10:00:00',2.34),('15844','2013-02-17','10:05:00',2.38),('15844','2013-02-17','10:10:00',2.44),('15844','2013-02-17','10:15:00',2.44),('15844','2013-02-17','10:20:00',2.52),('15844','2013-02-17','10:25:00',2.55),('15844','2013-02-17','10:30:00',2.6),('15844','2013-02-17','10:35:00',2.64),('15844','2013-02-17','10:40:00',2.71),('15844','2013-02-17','10:45:00',2.74),('15844','2013-02-17','10:50:00',2.75),('15844','2013-02-17','10:55:00',2.79),('15844','2013-02-17','11:00:00',2.82),('15844','2013-02-17','11:05:00',2.82),('15844','2013-02-17','11:10:00',2.83),('15844','2013-02-17','11:15:00',2.82),('15844','2013-02-17','11:20:00',2.83),('15844','2013-02-17','11:25:00',2.84),('15844','2013-02-17','11:30:00',2.84),('15844','2013-02-17','11:35:00',2.82),('15844','2013-02-17','11:40:00',2.75),('15844','2013-02-17','11:45:00',2.79),('15844','2013-02-17','11:50:00',2.76),('15844','2013-02-17','11:55:00',2.76),('15844','2013-02-17','12:00:00',2.75),('15844','2013-02-17','12:05:00',2.76),('15844','2013-02-17','12:10:00',2.72),('15844','2013-02-17','12:15:00',2.7),('15844','2013-02-17','12:20:00',2.7),('15844','2013-02-17','12:25:00',2.67),('15844','2013-02-17','12:30:00',2.62),('15844','2013-02-17','12:35:00',2.57),('15844','2013-02-17','12:40:00',2.54),('15844','2013-02-17','12:45:00',2.48),('15844','2013-02-17','12:50:00',2.42),('15844','2013-02-17','12:55:00',2.34),('15844','2013-02-17','13:00:00',2.27),('15844','2013-02-17','13:05:00',2.19),('15844','2013-02-17','13:10:00',2.13),('15844','2013-02-17','13:15:00',2.04),('15844','2013-02-17','13:20:00',1.27),('15844','2013-02-17','13:25:00',1.46),('15844','2013-02-17','13:30:00',1.87),('15844','2013-02-17','13:35:00',1.87),('15844','2013-02-17','13:40:00',1.76),('15844','2013-02-17','13:45:00',1.66),('15844','2013-02-17','13:50:00',1.54),('15844','2013-02-17','13:55:00',1.46),('15844','2013-02-17','14:00:00',1.53),('15844','2013-02-17','14:05:00',1.72),('15844','2013-02-17','14:10:00',1.75),('15844','2013-02-17','14:25:00',1.22),('15844','2013-02-17','14:30:00',1.11),('15844','2013-02-17','14:35:00',1.01),('15844','2013-02-17','14:45:00',1.04),('15844','2013-02-17','14:50:00',1.01),('15844','2013-02-16','08:30:00',1.01),('15844','2013-02-16','08:35:00',1.09),('15844','2013-02-16','08:40:00',1.17),('15844','2013-02-16','08:45:00',1.24),('15844','2013-02-16','08:50:00',1.34),('15844','2013-02-16','08:55:00',1.42),('15844','2013-02-16','09:00:00',1.57),('15844','2013-02-16','09:05:00',1.25),('15844','2013-02-16','09:10:00',1.65),('15844','2013-02-16','09:15:00',1.74),('15844','2013-02-16','09:25:00',1.81),('15844','2013-02-16','09:30:00',1.69),('15844','2013-02-16','09:35:00',2.25),('15844','2013-02-16','09:40:00',2.26),('15844','2013-02-16','09:45:00',2.27),('15844','2013-02-16','09:50:00',2.34),('15844','2013-02-16','09:55:00',2.37),('15844','2013-02-16','10:00:00',2.37),('15844','2013-02-16','10:05:00',2.44),('15844','2013-02-16','10:10:00',2.44),('15844','2013-02-16','10:15:00',2.47),('15844','2013-02-16','10:20:00',2.57),('15844','2013-02-16','10:25:00',2.6),('15844','2013-02-16','10:30:00',2.66),('15844','2013-02-16','10:35:00',2.69),('15844','2013-02-16','10:40:00',2.73),('15844','2013-02-16','10:45:00',2.79),('15844','2013-02-16','10:50:00',2.81),('15844','2013-02-16','10:55:00',2.84),('15844','2013-02-16','11:00:00',2.86),('15844','2013-02-16','11:05:00',2.88),('15844','2013-02-16','11:10:00',2.88),('15844','2013-02-16','11:15:00',2.91),('15844','2013-02-16','11:20:00',2.9),('15844','2013-02-16','11:25:00',2.91),('15844','2013-02-16','11:30:00',2.91),('15844','2013-02-16','11:35:00',2.88),('15844','2013-02-16','11:40:00',2.9),('15844','2013-02-16','11:45:00',2.89),('15844','2013-02-16','11:50:00',2.88),('15844','2013-02-16','11:55:00',2.84),('15844','2013-02-16','12:00:00',2.81),('15844','2013-02-16','12:05:00',2.79),('15844','2013-02-16','12:10:00',2.78),('15844','2013-02-16','12:15:00',2.78),('15844','2013-02-16','12:20:00',2.73),('15844','2013-02-16','12:25:00',2.71),('15844','2013-02-16','12:30:00',2.7),('15844','2013-02-16','12:35:00',2.63),('15844','2013-02-16','12:40:00',2.61),('15844','2013-02-16','12:45:00',2.56),('15844','2013-02-16','12:50:00',2.52),('15844','2013-02-16','12:55:00',2.46),('15844','2013-02-16','13:00:00',2.38),('15844','2013-02-16','13:05:00',2.27),('15844','2013-02-16','13:10:00',2.24),('15844','2013-02-16','13:15:00',2.16),('15844','2013-02-16','13:20:00',2.08),('15844','2013-02-16','13:25:00',1.97),('15844','2013-02-16','13:30:00',1.9),('15844','2013-02-16','13:35:00',1.76),('15844','2013-02-16','13:40:00',1.68),('15844','2013-02-16','13:45:00',1.61),('15844','2013-02-16','13:50:00',1.57),('15844','2013-02-16','13:55:00',1.49),('15844','2013-02-16','14:00:00',1.42),('15844','2013-02-16','14:05:00',1.36),('15844','2013-02-16','14:10:00',1.25),('15844','2013-02-16','14:15:00',1.2),('15844','2013-02-16','14:25:00',1.07),('15844','2013-02-15','09:25:00',1.33),('15844','2013-02-15','09:30:00',1.52),('15844','2013-02-15','09:35:00',1.27),('15844','2013-02-15','09:40:00',1.22),('15844','2013-02-15','09:55:00',1.47),('15844','2013-02-15','10:00:00',2.38),('15844','2013-02-15','10:05:00',1.62),('15844','2013-02-15','10:10:00',2),('15844','2013-02-15','10:15:00',1.56),('15844','2013-02-15','10:20:00',1.59),('15844','2013-02-15','10:25:00',2.04),('15844','2013-02-15','10:30:00',2.38),('15844','2013-02-15','10:35:00',2.6),('15844','2013-02-15','10:40:00',2.5),('15844','2013-02-15','10:45:00',1.79),('15844','2013-02-15','10:50:00',1.35),('15844','2013-02-15','10:55:00',1.67),('15844','2013-02-15','11:00:00',1.83),('15844','2013-02-15','11:05:00',1.7),('15844','2013-02-15','11:10:00',3.03),('15844','2013-02-15','11:15:00',3.06),('15844','2013-02-15','11:20:00',2.87),('15844','2013-02-15','11:25:00',2.9),('15844','2013-02-15','11:30:00',3),('15844','2013-02-15','11:35:00',2.83),('15844','2013-02-15','11:40:00',3.02),('15844','2013-02-15','11:45:00',2.32),('15844','2013-02-15','11:50:00',1.68),('15844','2013-02-15','11:55:00',2.58),('15844','2013-02-15','12:00:00',2.07),('15844','2013-02-15','12:05:00',2.96),('15844','2013-02-15','12:10:00',2.67),('15844','2013-02-15','12:15:00',3.08),('15844','2013-02-15','12:20:00',3.01),('15844','2013-02-15','12:25:00',2.84),('15844','2013-02-15','12:30:00',2.7),('15844','2013-02-15','12:35:00',2.62),('15844','2013-02-15','12:40:00',2.55),('15844','2013-02-15','12:45:00',2.61),('15844','2013-02-15','12:50:00',2.53),('15844','2013-02-15','12:55:00',2.47),('15844','2013-02-15','13:00:00',2.36),('15844','2013-02-15','13:05:00',2.28),('15844','2013-02-15','13:10:00',1.75),('15844','2013-02-15','13:20:00',1.7),('15844','2013-02-15','13:25:00',2.12),('15844','2013-02-15','13:30:00',2.38),('15844','2013-02-15','13:35:00',2.13),('15844','2013-02-15','13:40:00',1.54),('15844','2013-02-15','13:45:00',1.61),('15844','2013-02-15','13:50:00',1.46),('15844','2013-02-15','13:55:00',1.5),('15844','2013-02-15','14:00:00',1.88),('15844','2013-02-15','14:05:00',1.74),('15844','2013-02-15','14:10:00',1.3),('15844','2013-02-15','14:15:00',1.26),('15844','2013-02-15','14:20:00',1.11),('15844','2013-02-15','14:35:00',1.08),('15844','2013-02-14','08:20:00',1.04),('15844','2013-02-14','08:25:00',1.16),('15844','2013-02-14','08:30:00',1.25),('15844','2013-02-14','08:35:00',1.31),('15844','2013-02-14','08:40:00',1.38),('15844','2013-02-14','08:45:00',1.44),('15844','2013-02-14','08:50:00',1.49),('15844','2013-02-14','08:55:00',1.56),('15844','2013-02-14','09:00:00',1.64),('15844','2013-02-14','09:05:00',1.74),('15844','2013-02-14','09:10:00',1.86),('15844','2013-02-14','09:15:00',1.96),('15844','2013-02-14','09:20:00',2.04),('15844','2013-02-14','09:25:00',2.11),('15844','2013-02-14','09:30:00',2.17),('15844','2013-02-14','09:35:00',2.22),('15844','2013-02-14','09:40:00',2.28),('15844','2013-02-14','09:45:00',2.37),('15844','2013-02-14','09:50:00',2.44),('15844','2013-02-14','09:55:00',2.51),('15844','2013-02-14','10:00:00',2.56),('15844','2013-02-14','10:05:00',2.6),('15844','2013-02-14','10:10:00',2.63),('15844','2013-02-14','10:15:00',2.67),('15844','2013-02-14','10:20:00',2.69),('15844','2013-02-14','10:25:00',2.73),('15844','2013-02-14','10:30:00',2.77),('15844','2013-02-14','10:35:00',2.82),('15844','2013-02-14','10:40:00',2.86),('15844','2013-02-14','10:45:00',2.91),('15844','2013-02-14','10:50:00',2.94),('15844','2013-02-14','10:55:00',2.96),('15844','2013-02-14','11:00:00',2.97),('15844','2013-02-14','11:05:00',2.99),('15844','2013-02-14','11:10:00',2.99),('15844','2013-02-14','11:15:00',2.98),('15844','2013-02-14','11:20:00',2.99),('15844','2013-02-14','11:25:00',3),('15844','2013-02-14','11:30:00',2.97),('15844','2013-02-14','11:35:00',2.97),('15844','2013-02-14','11:40:00',2.96),('15844','2013-02-14','11:45:00',2.95),('15844','2013-02-14','11:50:00',2.95),('15844','2013-02-14','11:55:00',2.91),('15844','2013-02-14','12:00:00',2.88),('15844','2013-02-14','12:05:00',2.88),('15844','2013-02-14','12:10:00',2.86),('15844','2013-02-14','12:15:00',2.83),('15844','2013-02-14','12:20:00',2.79),('15844','2013-02-14','12:25:00',2.77),('15844','2013-02-14','12:30:00',2.74),('15844','2013-02-14','12:35:00',2.71),('15844','2013-02-14','12:40:00',2.68),('15844','2013-02-14','12:45:00',2.63),('15844','2013-02-14','12:50:00',2.58),('15844','2013-02-14','12:55:00',2.51),('15844','2013-02-14','13:00:00',2.39),('15844','2013-02-14','13:05:00',2.31),('15844','2013-02-14','13:10:00',2.26),('15844','2013-02-14','13:15:00',2.18),('15844','2013-02-14','13:20:00',2.07),('15844','2013-02-14','13:25:00',1.97),('15844','2013-02-14','13:30:00',1.91),('15844','2013-02-14','13:35:00',1.85),('15844','2013-02-14','13:40:00',1.77),('15844','2013-02-14','13:45:00',1.68),('15844','2013-02-14','13:50:00',1.58),('15844','2013-02-14','13:55:00',1.46),('15844','2013-02-14','14:00:00',1.37),('15844','2013-02-14','14:05:00',1.29),('15844','2013-02-14','14:10:00',1.22),('15844','2013-02-14','14:15:00',1.14),('15844','2013-02-14','14:20:00',1.04),('15844','2013-02-13','09:20:00',1.24),('15844','2013-02-13','09:25:00',1.14),('15844','2013-02-13','09:30:00',1.67),('15844','2013-02-13','09:35:00',1.83),('15844','2013-02-13','09:40:00',1.86),('15844','2013-02-13','09:45:00',1.65),('15844','2013-02-13','09:50:00',1.56),('15844','2013-02-13','09:55:00',1.8),('15844','2013-02-13','10:00:00',2.11),('15844','2013-02-13','10:05:00',2.35),('15844','2013-02-13','10:10:00',2.51),('15844','2013-02-13','10:15:00',2.53),('15844','2013-02-13','10:20:00',2.59),('15844','2013-02-13','10:25:00',2.66),('15844','2013-02-13','10:30:00',2.79),('15844','2013-02-13','10:35:00',2.79),('15844','2013-02-13','10:40:00',2.8),('15844','2013-02-13','10:45:00',2.92),('15844','2013-02-13','10:50:00',2.82),('15844','2013-02-13','10:55:00',2.75),('15844','2013-02-13','11:00:00',2.76),('15844','2013-02-13','11:05:00',2.54),('15844','2013-02-13','11:10:00',2.42),('15844','2013-02-13','11:15:00',2.26),('15844','2013-02-13','11:20:00',2.35),('15844','2013-02-13','11:25:00',2.62),('15844','2013-02-13','11:30:00',2.72),('15844','2013-02-13','11:35:00',2.98),('15844','2013-02-13','11:40:00',3.09),('15844','2013-02-13','11:45:00',2.78),('15844','2013-02-13','11:50:00',3.13),('15844','2013-02-13','11:55:00',2.85),('15844','2013-02-13','12:00:00',2.71),('15844','2013-02-13','12:05:00',3.2),('15844','2013-02-13','12:10:00',2.78),('15844','2013-02-13','12:15:00',2.76),('15844','2013-02-13','12:20:00',2.19),('15844','2013-02-13','12:25:00',1.34),('15844','2013-02-13','12:30:00',2.26),('15844','2013-02-13','12:35:00',2.57),('15844','2013-02-13','12:40:00',2.54),('15844','2013-02-13','12:45:00',2.61),('15844','2013-02-13','12:50:00',2.52),('15844','2013-02-13','12:55:00',2.38),('15844','2013-02-13','13:00:00',2.01),('15844','2013-02-13','13:05:00',1.76),('15844','2013-02-13','13:10:00',1.79),('15844','2013-02-13','13:15:00',1.73),('15844','2013-02-13','13:20:00',1.91),('15844','2013-02-13','13:25:00',2.06),('15844','2013-02-13','13:30:00',2.1),('15844','2013-02-13','13:35:00',2.08),('15844','2013-02-13','13:40:00',2.15),('15844','2013-02-13','13:45:00',2.14),('15844','2013-02-13','13:50:00',1.88),('15844','2013-02-13','13:55:00',1.6),('15844','2013-02-13','14:00:00',1.41),('15844','2013-02-13','14:05:00',1.1),('15844','2013-02-13','14:10:00',1.07),('15844','2013-02-13','14:15:00',1.1),('15844','2013-02-13','14:20:00',1.03),('15844','2014-03-22','08:10:00',1.18),('15844','2014-03-22','08:15:00',1.31),('15844','2014-03-22','08:20:00',1.21),('15844','2014-03-22','08:25:00',1.4),('15844','2014-03-22','08:30:00',1.67),('15844','2014-03-22','08:35:00',1.72),('15844','2014-03-22','08:40:00',1.88),('15844','2014-03-22','08:45:00',2.11),('15844','2014-03-22','08:50:00',1.73),('15844','2014-03-22','08:55:00',1.84),('15844','2014-03-22','09:00:00',1.78),('15844','2014-03-22','09:05:00',1.93),('15844','2014-03-22','09:10:00',1.23),('15844','2014-03-22','09:15:00',1.13),('15844','2014-03-22','09:20:00',1.41),('15844','2014-03-22','09:25:00',2.16),('15844','2014-03-22','09:30:00',1.35),('15844','2014-03-22','09:35:00',2.3),('15844','2014-03-22','09:40:00',2.45),('15844','2014-03-22','09:45:00',2.98),('15844','2014-03-22','09:50:00',3.17),('15844','2014-03-22','09:55:00',3.14),('15844','2014-03-22','10:00:00',2.54),('15844','2014-03-22','10:05:00',3.32),('15844','2014-03-22','10:10:00',1.5),('15844','2014-03-22','10:15:00',1.1),('15844','2014-03-22','10:20:00',1.29),('15844','2014-03-22','10:25:00',1.64),('15844','2014-03-22','10:30:00',1.64),('15844','2014-03-22','10:35:00',1.51),('15844','2014-03-22','10:40:00',1.68),('15844','2014-03-22','10:45:00',1.97),('15844','2014-03-22','10:50:00',1.29),('15844','2014-03-22','10:55:00',1.16),('15844','2014-03-22','11:00:00',1.05),('15844','2014-03-22','11:05:00',2.13),('15844','2014-03-22','11:10:00',3.57),('15844','2014-03-22','11:15:00',1.72),('15844','2014-03-22','11:20:00',2.85),('15844','2014-03-22','11:25:00',2.54),('15844','2014-03-22','11:30:00',2.28),('15844','2014-03-22','11:35:00',2.36),('15844','2014-03-22','11:40:00',3.11),('15844','2014-03-22','11:45:00',2.43),('15844','2014-03-22','11:50:00',1.67),('15844','2014-03-22','11:55:00',1.29),('15844','2014-03-22','12:00:00',2.36),('15844','2014-03-22','12:05:00',2.02),('15844','2014-03-22','12:10:00',1.13),('15844','2014-03-22','12:15:00',1.89),('15844','2014-03-22','12:20:00',3.99),('15844','2014-03-22','12:25:00',3.67),('15844','2014-03-22','12:30:00',3.54),('15844','2014-03-22','12:35:00',3.05),('15844','2014-03-22','12:40:00',2.66),('15844','2014-03-22','12:45:00',3.62),('15844','2014-03-22','12:50:00',3.33),('15844','2014-03-22','12:55:00',2.82),('15844','2014-03-22','13:00:00',3.11),('15844','2014-03-22','13:05:00',2.13),('15844','2014-03-22','13:10:00',3.3),('15844','2014-03-22','13:15:00',2.89),('15844','2014-03-22','13:20:00',3.03),('15844','2014-03-22','13:25:00',2.86),('15844','2014-03-22','13:30:00',2.71),('15844','2014-03-22','13:35:00',2.75),('15844','2014-03-22','13:40:00',2.77),('15844','2014-03-22','13:45:00',2.53),('15844','2014-03-22','13:50:00',2.21),('15844','2014-03-22','13:55:00',2.04),('15844','2014-03-22','14:00:00',2.2),('15844','2014-03-22','14:05:00',2.14),('15844','2014-03-22','14:10:00',1.87),('15844','2014-03-22','14:15:00',1.77),('15844','2014-03-22','14:20:00',1.64),('15844','2014-03-22','14:25:00',1.41),('15844','2014-03-22','14:30:00',1.4),('15844','2014-03-22','14:35:00',1.15),('15844','2014-03-22','14:40:00',1.17),('15844','2014-03-22','14:50:00',1.17),('15844','2014-03-22','14:55:00',1.16),('15844','2014-03-22','15:00:00',1.06),('15844','2014-03-22','15:05:00',1),('15844','2014-03-21','07:55:00',1.01),('15844','2014-03-21','08:00:00',1.08),('15844','2014-03-21','08:05:00',1.17),('15844','2014-03-21','08:10:00',1.26),('15844','2014-03-21','08:15:00',1.36),('15844','2014-03-21','08:20:00',1.46),('15844','2014-03-21','08:25:00',1.59),('15844','2014-03-21','08:30:00',1.7),('15844','2014-03-21','08:35:00',1.74),('15844','2014-03-21','08:40:00',1.85),('15844','2014-03-21','08:45:00',1.99),('15844','2014-03-21','08:50:00',2.09),('15844','2014-03-21','08:55:00',2.15),('15844','2014-03-21','09:00:00',2.27),('15844','2014-03-21','09:05:00',2.31),('15844','2014-03-21','09:10:00',2.45),('15844','2014-03-21','09:15:00',2.47),('15844','2014-03-21','09:20:00',2.53),('15844','2014-03-21','09:25:00',2.51),('15844','2014-03-21','09:30:00',2.54),('15844','2014-03-21','09:35:00',2.72),('15844','2014-03-21','09:40:00',2.78),('15844','2014-03-21','09:45:00',2.78),('15844','2014-03-21','09:50:00',2.7),('15844','2014-03-21','09:55:00',2.63),('15844','2014-03-21','10:00:00',2.94),('15844','2014-03-21','10:05:00',3.05),('15844','2014-03-21','10:10:00',3.18),('15844','2014-03-21','10:15:00',3.17),('15844','2014-03-21','10:20:00',3.04),('15844','2014-03-21','10:25:00',3.03),('15844','2014-03-21','10:30:00',3.05),('15844','2014-03-21','10:35:00',3.07),('15844','2014-03-21','10:40:00',3.14),('15844','2014-03-21','10:45:00',3.11),('15844','2014-03-21','10:50:00',3.16),('15844','2014-03-21','10:55:00',3.26),('15844','2014-03-21','11:00:00',3.24),('15844','2014-03-21','11:05:00',3.17),('15844','2014-03-21','11:10:00',3.18),('15844','2014-03-21','11:15:00',3.17),('15844','2014-03-21','11:20:00',3.23),('15844','2014-03-21','11:25:00',3.24),('15844','2014-03-21','11:30:00',3.25),('15844','2014-03-21','11:35:00',3.12),('15844','2014-03-21','11:40:00',3.19),('15844','2014-03-21','11:45:00',3.21),('15844','2014-03-21','11:50:00',3.08),('15844','2014-03-21','11:55:00',3.23),('15844','2014-03-21','12:00:00',3.29),('15844','2014-03-21','12:05:00',3.27),('15844','2014-03-21','12:10:00',3.16),('15844','2014-03-21','12:15:00',3.16),('15844','2014-03-21','12:20:00',3.21),('15844','2014-03-21','12:25:00',3.2),('15844','2014-03-21','12:30:00',3.17),('15844','2014-03-21','12:35:00',3.17),('15844','2014-03-21','12:40:00',3.1),('15844','2014-03-21','12:45:00',3.04),('15844','2014-03-21','12:50:00',3.02),('15844','2014-03-21','12:55:00',3),('15844','2014-03-21','13:00:00',2.95),('15844','2014-03-21','13:05:00',2.89),('15844','2014-03-21','13:10:00',2.84),('15844','2014-03-21','13:15:00',2.79),('15844','2014-03-21','13:20:00',2.75),('15844','2014-03-21','13:25:00',2.66),('15844','2014-03-21','13:30:00',2.58),('15844','2014-03-21','13:35:00',2.47),('15844','2014-03-21','13:40:00',2.38),('15844','2014-03-21','13:45:00',2.27),('15844','2014-03-21','13:50:00',2.18),('15844','2014-03-21','13:55:00',2.07),('15844','2014-03-21','14:00:00',2.01),('15844','2014-03-21','14:05:00',1.91),('15844','2014-03-21','14:10:00',1.79),('15844','2014-03-21','14:15:00',1.68),('15844','2014-03-21','14:20:00',1.56),('15844','2014-03-21','14:25:00',1.49),('15844','2014-03-21','14:30:00',1.41),('15844','2014-03-21','14:35:00',1.31),('15844','2014-03-21','14:40:00',1.16),('15844','2014-03-21','15:05:00',1.16),('15844','2014-03-21','15:10:00',1.29),('15844','2014-03-21','15:15:00',1.25),('15844','2014-03-21','15:25:00',1.08),('15844','2014-03-21','15:30:00',1.02),('15844','2014-03-20','08:00:00',1.06),('15844','2014-03-20','08:05:00',1.11),('15844','2014-03-20','08:10:00',1.13),('15844','2014-03-20','08:15:00',1.26),('15844','2014-03-20','08:20:00',1.39),('15844','2014-03-20','08:25:00',1.5),('15844','2014-03-20','08:30:00',1.58),('15844','2014-03-20','08:35:00',1.75),('15844','2014-03-20','08:40:00',1.93),('15844','2014-03-20','08:45:00',2.03),('15844','2014-03-20','08:50:00',2.15),('15844','2014-03-20','08:55:00',2.18),('15844','2014-03-20','09:00:00',2.26),('15844','2014-03-20','09:05:00',2.37),('15844','2014-03-20','09:10:00',2.41),('15844','2014-03-20','09:15:00',2.46),('15844','2014-03-20','09:20:00',2.47),('15844','2014-03-20','09:25:00',2.55),('15844','2014-03-20','09:30:00',2.62),('15844','2014-03-20','09:35:00',2.7),('15844','2014-03-20','09:40:00',2.68),('15844','2014-03-20','09:45:00',2.71),('15844','2014-03-20','09:50:00',2.83),('15844','2014-03-20','09:55:00',2.92),('15844','2014-03-20','10:00:00',2.97),('15844','2014-03-20','10:05:00',3.09),('15844','2014-03-20','10:10:00',3.17),('15844','2014-03-20','10:15:00',3.1),('15844','2014-03-20','10:20:00',3.17),('15844','2014-03-20','10:25:00',3.19),('15844','2014-03-20','10:30:00',3.24),('15844','2014-03-20','10:35:00',3.13),('15844','2014-03-20','10:40:00',3.04),('15844','2014-03-20','10:45:00',3.18),('15844','2014-03-20','10:50:00',3.27),('15844','2014-03-20','10:55:00',3.32),('15844','2014-03-20','11:00:00',3.33),('15844','2014-03-20','11:05:00',3.32),('15844','2014-03-20','11:10:00',3.12),('15844','2014-03-20','11:15:00',3.02),('15844','2014-03-20','11:20:00',3.2),('15844','2014-03-20','11:25:00',3.21),('15844','2014-03-20','11:30:00',3.15),('15844','2014-03-20','11:35:00',3.22),('15844','2014-03-20','11:40:00',3.29),('15844','2014-03-20','11:45:00',3.14),('15844','2014-03-20','11:50:00',3),('15844','2014-03-20','11:55:00',2.97),('15844','2014-03-20','12:00:00',2.68),('15844','2014-03-20','12:05:00',3.01),('15844','2014-03-20','12:10:00',3.11),('15844','2014-03-20','12:15:00',3.3),('15844','2014-03-20','12:20:00',3.12),('15844','2014-03-20','12:25:00',2.91),('15844','2014-03-20','12:30:00',3.09),('15844','2014-03-20','12:35:00',3.18),('15844','2014-03-20','12:40:00',3.2),('15844','2014-03-20','12:45:00',3.12),('15844','2014-03-20','12:50:00',3.08),('15844','2014-03-20','12:55:00',2.97),('15844','2014-03-20','13:00:00',2.93),('15844','2014-03-20','13:05:00',2.79),('15844','2014-03-20','13:10:00',2.7),('15844','2014-03-20','13:15:00',2.69),('15844','2014-03-20','13:20:00',2.59),('15844','2014-03-20','13:25:00',2.52),('15844','2014-03-20','13:30:00',2.37),('15844','2014-03-20','13:35:00',2.26),('15844','2014-03-20','13:40:00',2.08),('15844','2014-03-20','13:45:00',1.97),('15844','2014-03-20','13:50:00',1.84),('15844','2014-03-20','13:55:00',1.74),('15844','2014-03-20','14:00:00',1.78),('15844','2014-03-20','14:05:00',1.74),('15844','2014-03-20','14:10:00',1.66),('15844','2014-03-20','14:15:00',1.67),('15844','2014-03-20','14:20:00',1.4),('15844','2014-03-20','14:25:00',1.26),('15844','2014-03-20','14:30:00',1.18),('15844','2014-03-20','14:35:00',1.2),('15844','2014-03-20','14:40:00',1.11),('15844','2014-03-20','14:45:00',1.05),('15844','2014-03-20','14:50:00',1.04),('15844','2014-03-20','14:55:00',1.01),('15844','2014-03-19','09:10:00',1.01),('15844','2014-03-19','09:15:00',1.08),('15844','2014-03-19','09:20:00',1.3),('15844','2014-03-19','09:25:00',1.56),('15844','2014-03-19','09:30:00',1.72),('15844','2014-03-19','09:35:00',1.64),('15844','2014-03-19','09:40:00',2.26),('15844','2014-03-19','09:45:00',1.56),('15844','2014-03-19','09:50:00',1.12),('15844','2014-03-19','10:05:00',1.74),('15844','2014-03-19','10:10:00',1.79),('15844','2014-03-19','10:15:00',1.27),('15844','2014-03-19','10:20:00',1.17),('15844','2014-03-19','10:25:00',1.3),('15844','2014-03-19','10:30:00',1.38),('15844','2014-03-19','10:35:00',1.18),('15844','2014-03-19','10:40:00',1.68),('15844','2014-03-19','10:45:00',2.04),('15844','2014-03-19','10:50:00',1.87),('15844','2014-03-19','10:55:00',2.08),('15844','2014-03-19','11:00:00',1.55),('15844','2014-03-19','11:05:00',3.32),('15844','2014-03-19','11:10:00',3.18),('15844','2014-03-19','11:15:00',2.52),('15844','2014-03-19','11:20:00',2.75),('15844','2014-03-19','11:25:00',3.38),('15844','2014-03-19','11:30:00',2.91),('15844','2014-03-19','11:35:00',2.09),('15844','2014-03-19','11:40:00',1.93),('15844','2014-03-19','11:45:00',1.72),('15844','2014-03-19','11:50:00',1.22),('15844','2014-03-19','11:55:00',1.22),('15844','2014-03-19','12:00:00',1.3),('15844','2014-03-19','12:05:00',2.52),('15844','2014-03-19','12:10:00',1.79),('15844','2014-03-19','12:15:00',3.62),('15844','2014-03-19','12:20:00',3.59),('15844','2014-03-19','12:25:00',3.02),('15844','2014-03-19','12:30:00',3.04),('15844','2014-03-19','12:35:00',2.96),('15844','2014-03-19','12:40:00',3.14),('15844','2014-03-19','12:45:00',2.54),('15844','2014-03-19','12:50:00',2.28),('15844','2014-03-19','12:55:00',2.95),('15844','2014-03-19','13:00:00',2.87),('15844','2014-03-19','13:05:00',2.91),('15844','2014-03-19','13:10:00',2.82),('15844','2014-03-19','13:15:00',2.61),('15844','2014-03-19','13:20:00',2.3),('15844','2014-03-19','13:25:00',2.62),('15844','2014-03-19','13:30:00',2.52),('15844','2014-03-19','13:35:00',2.48),('15844','2014-03-19','13:40:00',2.32),('15844','2014-03-19','13:45:00',2.21),('15844','2014-03-19','13:50:00',2.13),('15844','2014-03-19','13:55:00',1.98),('15844','2014-03-19','14:00:00',1.96),('15844','2014-03-19','14:05:00',1.89),('15844','2014-03-19','14:10:00',1.78),('15844','2014-03-19','14:15:00',1.69),('15844','2014-03-19','14:20:00',1.55),('15844','2014-03-19','14:25:00',1.45),('15844','2014-03-19','14:30:00',1.38),('15844','2014-03-19','14:35:00',1.34),('15844','2014-03-19','14:40:00',1.25),('15844','2014-03-19','14:45:00',1.18),('15844','2014-03-19','14:50:00',1.14),('15844','2014-03-19','14:55:00',1.07),('15844','2014-03-19','15:00:00',1.01),('15844','2014-03-18','08:10:00',1.03),('15844','2014-03-18','08:15:00',1.4),('15844','2014-03-18','08:20:00',1.07),('15844','2014-03-18','08:25:00',1.02),('15844','2014-03-18','09:05:00',1.21),('15844','2014-03-18','09:10:00',2.47),('15844','2014-03-18','09:15:00',1.33),('15844','2014-03-18','09:20:00',1.35),('15844','2014-03-18','09:25:00',1.24),('15844','2014-03-18','09:30:00',1.75),('15844','2014-03-18','09:35:00',2.47),('15844','2014-03-18','09:40:00',3.09),('15844','2014-03-18','09:45:00',3.15),('15844','2014-03-18','09:50:00',3.03),('15844','2014-03-18','09:55:00',1.36),('15844','2014-03-18','10:00:00',1.25),('15844','2014-03-18','10:05:00',1.01),('15844','2014-03-18','10:10:00',1.24),('15844','2014-03-18','10:15:00',1.19),('15844','2014-03-18','10:20:00',1.08),('15844','2014-03-18','10:25:00',1.61),('15844','2014-03-18','10:30:00',3.17),('15844','2014-03-18','10:35:00',2.09),('15844','2014-03-18','10:40:00',2.46),('15844','2014-03-18','10:45:00',3.83),('15844','2014-03-18','10:50:00',2.74),('15844','2014-03-18','10:55:00',2.42),('15844','2014-03-18','11:00:00',1.66),('15844','2014-03-18','11:05:00',2.14),('15844','2014-03-18','11:10:00',2.33),('15844','2014-03-18','11:15:00',1.3),('15844','2014-03-18','11:20:00',1.46),('15844','2014-03-18','11:25:00',2.53),('15844','2014-03-18','11:30:00',2.23),('15844','2014-03-18','11:35:00',2.12),('15844','2014-03-18','11:40:00',2.19),('15844','2014-03-18','11:45:00',2.99),('15844','2014-03-18','11:50:00',3.61),('15844','2014-03-18','11:55:00',3.65),('15844','2014-03-18','12:00:00',2.26),('15844','2014-03-18','12:05:00',3.29),('15844','2014-03-18','12:10:00',3.61),('15844','2014-03-18','12:15:00',2.64),('15844','2014-03-18','12:20:00',3.54),('15844','2014-03-18','12:25:00',3.63),('15844','2014-03-18','12:30:00',3.49),('15844','2014-03-18','12:35:00',3.23),('15844','2014-03-18','12:40:00',3.33),('15844','2014-03-18','12:45:00',2.98),('15844','2014-03-18','12:50:00',3.07),('15844','2014-03-18','12:55:00',2.84),('15844','2014-03-18','13:00:00',2.92),('15844','2014-03-18','13:05:00',2.91),('15844','2014-03-18','13:10:00',2.83),('15844','2014-03-18','13:15:00',2.77),('15844','2014-03-18','13:20:00',2.7),('15844','2014-03-18','13:25:00',2.57),('15844','2014-03-18','13:30:00',2.52),('15844','2014-03-18','13:35:00',2.41),('15844','2014-03-18','13:40:00',2.32),('15844','2014-03-18','13:45:00',2.22),('15844','2014-03-18','13:50:00',2.14),('15844','2014-03-18','13:55:00',2.04),('15844','2014-03-18','14:00:00',1.96),('15844','2014-03-18','14:05:00',1.86),('15844','2014-03-18','14:10:00',1.76),('15844','2014-03-18','14:15:00',1.67),('15844','2014-03-18','14:20:00',1.56),('15844','2014-03-18','14:25:00',1.41),('15844','2014-03-18','14:30:00',1.31),('15844','2014-03-18','14:35:00',1.3),('15844','2014-03-18','14:40:00',1.23),('15844','2014-03-18','14:45:00',1.15),('15844','2014-03-18','14:50:00',1.1),('15844','2014-03-18','14:55:00',1.03),('15844','2014-05-01','08:25:00',1.12),('15844','2014-05-01','08:30:00',1.27),('15844','2014-05-01','08:35:00',1.35),('15844','2014-05-01','08:40:00',1.47),('15844','2014-05-01','08:45:00',1.5),('15844','2014-05-01','08:50:00',1.32),('15844','2014-05-01','08:55:00',1.22),('15844','2014-05-01','09:00:00',1.16),('15844','2014-05-01','09:05:00',1.24),('15844','2014-05-01','09:10:00',1.43),('15844','2014-05-01','09:15:00',2.02),('15844','2014-05-01','09:20:00',2.3),('15844','2014-05-01','09:25:00',2.27),('15844','2014-05-01','09:30:00',2.48),('15844','2014-05-01','09:35:00',1.49),('15844','2014-05-01','09:40:00',1.53),('15844','2014-05-01','09:45:00',1.22),('15844','2014-05-01','10:00:00',1.7),('15844','2014-05-01','10:05:00',1.07),('15844','2014-05-01','10:10:00',3.05),('15844','2014-05-01','10:15:00',2.21),('15844','2014-05-01','10:20:00',3.96),('15844','2014-05-01','10:25:00',2.05),('15844','2014-05-01','10:30:00',1.46),('15844','2014-05-01','10:35:00',1.11),('15844','2014-05-01','10:40:00',2.89),('15844','2014-05-01','10:45:00',2.37),('15844','2014-05-01','10:50:00',2.95),('15844','2014-05-01','10:55:00',1.7),('15844','2014-05-01','11:05:00',4.28),('15844','2014-05-01','11:10:00',4.68),('15844','2014-05-01','11:15:00',4.58),('15844','2014-05-01','11:20:00',4.63),('15844','2014-05-01','11:25:00',3.05),('15844','2014-05-01','11:30:00',4.71),('15844','2014-05-01','11:35:00',3.94),('15844','2014-05-01','11:40:00',4.83),('15844','2014-05-01','11:45:00',4.92),('15844','2014-05-01','11:50:00',4.86),('15844','2014-05-01','11:55:00',1.4),('15844','2014-05-01','12:05:00',1.05),('15844','2014-05-01','12:10:00',4.92),('15844','2014-05-01','12:15:00',4.99),('15844','2014-05-01','12:20:00',4.73),('15844','2014-05-01','12:25:00',4.4),('15844','2014-05-01','12:30:00',2.16),('15844','2014-05-01','12:35:00',4.69),('15844','2014-05-01','12:40:00',4.85),('15844','2014-05-01','12:45:00',4.44),('15844','2014-05-01','12:55:00',1.03),('15844','2014-05-01','13:00:00',4.27),('15844','2014-05-01','13:05:00',4.51),('15844','2014-05-01','13:10:00',4.19),('15844','2014-05-01','13:15:00',4.55),('15844','2014-05-01','13:20:00',4.32),('15844','2014-05-01','13:25:00',2.88),('15844','2014-05-01','13:30:00',1.28),('15844','2014-05-01','13:35:00',1.9),('15844','2014-05-01','13:40:00',3.98),('15844','2014-05-01','13:45:00',4.52),('15844','2014-05-01','13:50:00',4.06),('15844','2014-05-01','13:55:00',3.9),('15844','2014-05-01','14:00:00',3.75),('15844','2014-05-01','14:05:00',3.68),('15844','2014-05-01','14:10:00',3.64),('15844','2014-05-01','14:15:00',3.56),('15844','2014-05-01','14:20:00',3.44),('15844','2014-05-01','14:25:00',3.3),('15844','2014-05-01','14:30:00',3.06),('15844','2014-05-01','14:35:00',3.08),('15844','2014-05-01','14:40:00',3.07),('15844','2014-05-01','14:45:00',3.02),('15844','2014-05-01','14:50:00',2.9),('15844','2014-05-01','14:55:00',2.57),('15844','2014-05-01','15:00:00',2.77),('15844','2014-05-01','15:05:00',2.72),('15844','2014-05-01','15:10:00',2.61),('15844','2014-05-01','15:15:00',2.12),('15844','2014-05-01','15:20:00',2.5),('15844','2014-05-01','15:25:00',2.28),('15844','2014-05-01','15:30:00',2.16),('15844','2014-05-01','15:35:00',2.05),('15844','2014-05-01','15:40:00',1.93),('15844','2014-05-01','15:45:00',1.76),('15844','2014-05-01','15:50:00',1.71),('15844','2014-05-01','15:55:00',1.53),('15844','2014-05-01','16:00:00',1.54),('15844','2014-05-01','16:05:00',1.39),('15844','2014-05-01','16:10:00',1.34),('15844','2014-05-01','16:15:00',1.31),('15844','2014-05-01','16:20:00',1.19),('15844','2014-05-01','16:25:00',1.28),('15844','2014-05-01','16:30:00',1.2),('15844','2014-05-01','16:35:00',1.08),('15844','2014-03-17','09:15:00',1.07),('15844','2014-03-17','09:50:00',1.07),('15844','2014-03-17','10:45:00',1.29),('15844','2014-03-17','10:50:00',1.14),('15844','2014-03-17','11:00:00',1.15),('15844','2014-03-17','11:05:00',1.38),('15844','2014-03-17','11:10:00',1.42),('15844','2014-03-17','11:15:00',1.11),('15844','2014-03-17','11:20:00',1.28),('15844','2014-03-17','11:25:00',1.22),('15844','2014-03-17','11:30:00',1.46),('15844','2014-03-17','11:35:00',1.22),('15844','2014-03-17','11:40:00',1.03),('15844','2014-03-17','11:50:00',1.4),('15844','2014-03-17','11:55:00',1.64),('15844','2014-03-17','12:00:00',1.51),('15844','2014-03-17','12:05:00',1.56),('15844','2014-03-17','12:10:00',3.1),('15844','2014-03-17','12:15:00',2.15),('15844','2014-03-17','12:20:00',3.19),('15844','2014-03-17','12:25:00',2.94),('15844','2014-03-17','12:30:00',3.58),('15844','2014-03-17','12:35:00',3.4),('15844','2014-03-17','12:40:00',2.27),('15844','2014-03-17','12:45:00',2.93),('15844','2014-03-17','12:50:00',3.06),('15844','2014-03-17','12:55:00',3.13),('15844','2014-03-17','13:00:00',3.03),('15844','2014-03-17','13:05:00',2.69),('15844','2014-03-17','13:10:00',2.81),('15844','2014-03-17','13:15:00',2.77),('15844','2014-03-17','13:20:00',2.8),('15844','2014-03-17','13:25:00',2.29),('15844','2014-03-17','13:30:00',1.59),('15844','2014-03-17','13:35:00',2.58),('15844','2014-03-17','13:40:00',1.71),('15844','2014-03-17','13:45:00',2.26),('15844','2014-03-17','13:50:00',2.4),('15844','2014-03-17','13:55:00',1.9),('15844','2014-03-17','14:00:00',1.04),('15844','2014-03-17','14:05:00',1.47),('15844','2014-03-17','14:10:00',1.27),('15844','2014-03-17','14:15:00',1.21),('15844','2014-03-17','14:20:00',1.66),('15844','2014-03-17','14:25:00',1.53),('15844','2014-03-17','14:30:00',1.73),('15844','2014-03-17','14:35:00',1.46),('15844','2014-03-17','14:40:00',1.08),('15844','2014-03-17','14:45:00',1.3),('15844','2014-03-17','14:50:00',1.27),('15844','2014-03-17','14:55:00',1.31),('15844','2014-03-16','08:10:00',1.06),('15844','2014-03-16','08:15:00',1.08),('15844','2014-03-16','08:20:00',1.15),('15844','2014-03-16','08:25:00',1.31),('15844','2014-03-16','08:30:00',1.39),('15844','2014-03-16','08:35:00',1.45),('15844','2014-03-16','08:40:00',1.51),('15844','2014-03-16','08:45:00',1.62),('15844','2014-03-16','08:50:00',1.7),('15844','2014-03-16','08:55:00',1.77),('15844','2014-03-16','09:00:00',1.76),('15844','2014-03-16','09:05:00',1.84),('15844','2014-03-16','09:10:00',1.94),('15844','2014-03-16','09:15:00',2.11),('15844','2014-03-16','09:20:00',2.11),('15844','2014-03-16','09:25:00',2.12),('15844','2014-03-16','09:30:00',2.18),('15844','2014-03-16','09:35:00',2.19),('15844','2014-03-16','09:40:00',2.36),('15844','2014-03-16','09:45:00',2.36),('15844','2014-03-16','09:50:00',2.57),('15844','2014-03-16','09:55:00',2.61),('15844','2014-03-16','10:00:00',2.66),('15844','2014-03-16','10:05:00',2.74),('15844','2014-03-16','10:10:00',2.78),('15844','2014-03-16','10:15:00',2.91),('15844','2014-03-16','10:20:00',2.92),('15844','2014-03-16','10:25:00',2.86),('15844','2014-03-16','10:30:00',2.86),('15844','2014-03-16','10:35:00',2.8),('15844','2014-03-16','10:40:00',2.86),('15844','2014-03-16','10:45:00',2.92),('15844','2014-03-16','10:50:00',3),('15844','2014-03-16','10:55:00',3.16),('15844','2014-03-16','11:00:00',3.07),('15844','2014-03-16','11:05:00',3.04),('15844','2014-03-16','11:10:00',2.86),('15844','2014-03-16','11:15:00',2.79),('15844','2014-03-16','11:20:00',2.93),('15844','2014-03-16','11:25:00',3.06),('15844','2014-03-16','11:30:00',3.1),('15844','2014-03-16','11:35:00',3.12),('15844','2014-03-16','11:40:00',3.01),('15844','2014-03-16','11:45:00',2.97),('15844','2014-03-16','11:50:00',2.96),('15844','2014-03-16','11:55:00',2.97),('15844','2014-03-16','12:00:00',2.97),('15844','2014-03-16','12:05:00',2.99),('15844','2014-03-16','12:10:00',2.98),('15844','2014-03-16','12:15:00',2.96),('15844','2014-03-16','12:20:00',2.95),('15844','2014-03-16','12:25:00',2.92),('15844','2014-03-16','12:30:00',2.91),('15844','2014-03-16','12:35:00',2.9),('15844','2014-03-16','12:40:00',2.84),('15844','2014-03-16','12:45:00',2.48),('15844','2014-03-16','12:50:00',1.86),('15844','2014-03-16','12:55:00',2.72),('15844','2014-03-16','13:00:00',2.68),('15844','2014-03-16','13:05:00',2.64),('15844','2014-03-16','13:10:00',2.59),('15844','2014-03-16','13:15:00',2.53),('15844','2014-03-16','13:20:00',2.46),('15844','2014-03-16','13:25:00',2.41),('15844','2014-03-16','13:30:00',2.33),('15844','2014-03-16','13:35:00',2.23),('15844','2014-03-16','13:40:00',2.23),('15844','2014-03-16','13:45:00',2.14),('15844','2014-03-16','13:50:00',2.02),('15844','2014-03-16','13:55:00',1.95),('15844','2014-03-16','14:00:00',1.84),('15844','2014-03-16','14:05:00',1.77),('15844','2014-03-16','14:10:00',1.69),('15844','2014-03-16','14:15:00',1.61),('15844','2014-03-16','14:20:00',1.52),('15844','2014-03-16','14:25:00',1.43),('15844','2014-03-16','14:30:00',1.31),('15844','2014-03-16','14:35:00',1.18),('15844','2014-03-16','14:40:00',1.17),('15844','2014-03-16','14:45:00',1.12),('15844','2014-03-16','14:50:00',1.03),('15844','2014-03-16','14:55:00',1.09),('15844','2014-03-15','08:15:00',1.06),('15844','2014-03-15','08:20:00',1.13),('15844','2014-03-15','08:25:00',1.22),('15844','2014-03-15','08:30:00',1.3),('15844','2014-03-15','08:35:00',1.38),('15844','2014-03-15','08:40:00',1.47),('15844','2014-03-15','08:45:00',1.54),('15844','2014-03-15','08:50:00',1.62),('15844','2014-03-15','08:55:00',1.72),('15844','2014-03-15','09:00:00',1.78),('15844','2014-03-15','09:05:00',1.87),('15844','2014-03-15','09:10:00',1.93),('15844','2014-03-15','09:15:00',2.02),('15844','2014-03-15','09:20:00',2.08),('15844','2014-03-15','09:25:00',2.1),('15844','2014-03-15','09:30:00',2.15),('15844','2014-03-15','09:35:00',2.24),('15844','2014-03-15','09:40:00',2.32),('15844','2014-03-15','09:45:00',2.38),('15844','2014-03-15','09:50:00',2.48),('15844','2014-03-15','09:55:00',2.56),('15844','2014-03-15','10:00:00',2.56),('15844','2014-03-15','10:05:00',2.59),('15844','2014-03-15','10:10:00',2.66),('15844','2014-03-15','10:15:00',2.62),('15844','2014-03-15','10:20:00',2.61),('15844','2014-03-15','10:25:00',2.7),('15844','2014-03-15','10:30:00',2.74),('15844','2014-03-15','10:35:00',2.73),('15844','2014-03-15','10:40:00',2.81),('15844','2014-03-15','10:45:00',2.95),('15844','2014-03-15','10:50:00',2.93),('15844','2014-03-15','10:55:00',2.95),('15844','2014-03-15','11:00:00',2.99),('15844','2014-03-15','11:05:00',3.01),('15844','2014-03-15','11:10:00',2.95),('15844','2014-03-15','11:15:00',2.95),('15844','2014-03-15','11:20:00',3.07),('15844','2014-03-15','11:25:00',3.08),('15844','2014-03-15','11:30:00',3.12),('15844','2014-03-15','11:35:00',3.1),('15844','2014-03-15','11:40:00',2.96),('15844','2014-03-15','11:45:00',3.03),('15844','2014-03-15','11:50:00',3.06),('15844','2014-03-15','11:55:00',3),('15844','2014-03-15','12:00:00',2.99),('15844','2014-03-15','12:05:00',2.88),('15844','2014-03-15','12:10:00',2.95),('15844','2014-03-15','12:15:00',2.89),('15844','2014-03-15','12:20:00',2.95),('15844','2014-03-15','12:25:00',2.89),('15844','2014-03-15','12:30:00',2.98),('15844','2014-03-15','12:35:00',2.91),('15844','2014-03-15','12:40:00',2.87),('15844','2014-03-15','12:45:00',2.82),('15844','2014-03-15','12:50:00',2.78),('15844','2014-03-15','12:55:00',2.73),('15844','2014-03-15','13:00:00',2.71),('15844','2014-03-15','13:05:00',2.64),('15844','2014-03-15','13:10:00',2.58),('15844','2014-03-15','13:15:00',2.56),('15844','2014-03-15','13:20:00',2.47),('15844','2014-03-15','13:25:00',2.46),('15844','2014-03-15','13:30:00',2.35),('15844','2014-03-15','13:35:00',2.26),('15844','2014-03-15','13:40:00',2.19),('15844','2014-03-15','13:45:00',2.1),('15844','2014-03-15','13:50:00',2.02),('15844','2014-03-15','13:55:00',1.93),('15844','2014-03-15','14:00:00',1.86),('15844','2014-03-15','14:05:00',1.77),('15844','2014-03-15','14:10:00',1.7),('15844','2014-03-15','14:15:00',1.6),('15844','2014-03-15','14:20:00',1.51),('15844','2014-03-15','14:25:00',1.42),('15844','2014-03-15','14:30:00',1.32),('15844','2014-03-15','14:35:00',1.21),('15844','2014-03-15','14:40:00',1.12),('15844','2014-03-15','14:45:00',1.05),('15844','2014-03-14','09:05:00',1.05),('15844','2014-03-14','09:10:00',1.34),('15844','2014-03-14','09:15:00',1.52),('15844','2014-03-14','09:20:00',1.53),('15844','2014-03-14','09:25:00',1.39),('15844','2014-03-14','09:30:00',1.43),('15844','2014-03-14','09:35:00',1.45),('15844','2014-03-14','09:40:00',1.67),('15844','2014-03-14','09:45:00',2.02),('15844','2014-03-14','09:50:00',2.27),('15844','2014-03-14','09:55:00',2.68),('15844','2014-03-14','10:00:00',2.95),('15844','2014-03-14','10:05:00',3.14),('15844','2014-03-14','10:10:00',2.95),('15844','2014-03-14','10:15:00',2.94),('15844','2014-03-14','10:20:00',3.16),('15844','2014-03-14','10:25:00',3.09),('15844','2014-03-14','10:30:00',2.87),('15844','2014-03-14','10:35:00',3.02),('15844','2014-03-14','10:40:00',3.05),('15844','2014-03-14','10:45:00',2.91),('15844','2014-03-14','10:50:00',2.47),('15844','2014-03-14','10:55:00',1.96),('15844','2014-03-14','11:00:00',2.79),('15844','2014-03-14','11:05:00',2.89),('15844','2014-03-14','11:10:00',2.95),('15844','2014-03-14','11:15:00',3.24),('15844','2014-03-14','11:20:00',3.23),('15844','2014-03-14','11:25:00',3.02),('15844','2014-03-14','11:30:00',2.8),('15844','2014-03-14','11:35:00',2.9),('15844','2014-03-14','11:40:00',2.94),('15844','2014-03-14','11:45:00',2.91),('15844','2014-03-14','11:50:00',2.93),('15844','2014-03-14','11:55:00',3.05),('15844','2014-03-14','12:00:00',3.04),('15844','2014-03-14','12:05:00',3.09),('15844','2014-03-14','12:10:00',3.04),('15844','2014-03-14','12:15:00',2.92),('15844','2014-03-14','12:20:00',2.63),('15844','2014-03-14','12:25:00',2.48),('15844','2014-03-14','12:30:00',1.97),('15844','2014-03-14','12:35:00',1.73),('15844','2014-03-14','12:40:00',1.44),('15844','2014-03-14','12:45:00',1.43),('15844','2014-03-14','12:50:00',1.84),('15844','2014-03-14','12:55:00',1.89),('15844','2014-03-14','13:00:00',1.88),('15844','2014-03-14','13:05:00',1.4),('15844','2014-03-14','13:10:00',1.64),('15844','2014-03-14','13:15:00',1.93),('15844','2014-03-14','13:20:00',1.74),('15844','2014-03-14','13:25:00',1.76),('15844','2014-03-14','13:30:00',1.7),('15844','2014-03-14','13:35:00',1.55),('15844','2014-03-14','13:40:00',1.38),('15844','2014-03-14','13:45:00',1.48),('15844','2014-03-14','13:50:00',1.56),('15844','2014-03-14','13:55:00',1.58),('15844','2014-03-14','14:00:00',1.46),('15844','2014-03-14','14:05:00',1.61),('15844','2014-03-14','14:10:00',1.77),('15844','2014-03-14','14:15:00',1.44),('15844','2014-03-14','14:20:00',1.49),('15844','2014-03-14','14:25:00',1.76),('15844','2014-03-14','14:30:00',1.51),('15844','2014-03-14','14:35:00',1.39),('15844','2014-03-14','14:40:00',1.3),('15844','2014-03-14','14:45:00',1.13),('15844','2014-03-14','14:50:00',1.05),('15844','2014-03-14','14:55:00',1.01),('15844','2014-03-13','08:00:00',1.04),('15844','2014-03-13','08:05:00',1.15),('15844','2014-03-13','08:10:00',1.22),('15844','2014-03-13','08:15:00',1.33),('15844','2014-03-13','08:20:00',1.47),('15844','2014-03-13','08:25:00',1.6),('15844','2014-03-13','08:30:00',1.7),('15844','2014-03-13','08:35:00',1.77),('15844','2014-03-13','08:40:00',1.86),('15844','2014-03-13','08:45:00',1.93),('15844','2014-03-13','08:50:00',2.04),('15844','2014-03-13','08:55:00',2.16),('15844','2014-03-13','09:00:00',2.22),('15844','2014-03-13','09:05:00',2.33),('15844','2014-03-13','09:10:00',2.38),('15844','2014-03-13','09:15:00',2.44),('15844','2014-03-13','09:20:00',2.48),('15844','2014-03-13','09:25:00',2.55),('15844','2014-03-13','09:30:00',2.63),('15844','2014-03-13','09:35:00',2.67),('15844','2014-03-13','09:40:00',2.71),('15844','2014-03-13','09:45:00',2.78),('15844','2014-03-13','09:50:00',2.81),('15844','2014-03-13','09:55:00',2.91),('15844','2014-03-13','10:00:00',3),('15844','2014-03-13','10:05:00',3.04),('15844','2014-03-13','10:10:00',3.11),('15844','2014-03-13','10:15:00',3.18),('15844','2014-03-13','10:20:00',3.24),('15844','2014-03-13','10:25:00',3.25),('15844','2014-03-13','10:30:00',3.28),('15844','2014-03-13','10:35:00',3.3),('15844','2014-03-13','10:40:00',3.32),('15844','2014-03-13','10:45:00',3.34),('15844','2014-03-13','10:50:00',3.34),('15844','2014-03-13','10:55:00',3.35),('15844','2014-03-13','11:00:00',3.36),('15844','2014-03-13','11:05:00',3.34),('15844','2014-03-13','11:10:00',3.36),('15844','2014-03-13','11:15:00',3.35),('15844','2014-03-13','11:20:00',3.33),('15844','2014-03-13','11:25:00',3.33),('15844','2014-03-13','11:30:00',3.32),('15844','2014-03-13','11:35:00',3.34),('15844','2014-03-13','11:40:00',3.29),('15844','2014-03-13','11:45:00',3.28),('15844','2014-03-13','11:50:00',3.24),('15844','2014-03-13','11:55:00',3.21),('15844','2014-03-13','12:00:00',3.2),('15844','2014-03-13','12:05:00',3.17),('15844','2014-03-13','12:10:00',3.13),('15844','2014-03-13','12:15:00',3.12),('15844','2014-03-13','12:20:00',3.06),('15844','2014-03-13','12:25:00',3.02),('15844','2014-03-13','12:30:00',2.98),('15844','2014-03-13','12:35:00',2.95),('15844','2014-03-13','12:40:00',2.92),('15844','2014-03-13','12:45:00',2.83),('15844','2014-03-13','12:50:00',2.8),('15844','2014-03-13','12:55:00',2.78),('15844','2014-03-13','13:00:00',2.71),('15844','2014-03-13','13:05:00',2.66),('15844','2014-03-13','13:10:00',2.6),('15844','2014-03-13','13:15:00',2.54),('15844','2014-03-13','13:20:00',2.47),('15844','2014-03-13','13:25:00',2.41),('15844','2014-03-13','13:30:00',2.33),('15844','2014-03-13','13:35:00',2.25),('15844','2014-03-13','13:40:00',2.18),('15844','2014-03-13','13:45:00',2.08),('15844','2014-03-13','13:50:00',2),('15844','2014-03-13','13:55:00',1.91),('15844','2014-03-13','14:00:00',1.82),('15844','2014-03-13','14:05:00',1.72),('15844','2014-03-13','14:10:00',1.61),('15844','2014-03-13','14:15:00',1.53),('15844','2014-03-13','14:20:00',1.44),('15844','2014-03-13','14:25:00',1.35),('15844','2014-03-13','14:30:00',1.23),('15844','2014-03-13','14:35:00',1.11),('15844','2014-03-13','14:40:00',1.09),('15844','2014-03-13','14:45:00',1.04),('15844','2014-03-13','14:50:00',1.01),('15844','2014-03-12','08:00:00',1.01),('15844','2014-03-12','08:05:00',1.1),('15844','2014-03-12','08:10:00',1.18),('15844','2014-03-12','08:15:00',1.31),('15844','2014-03-12','08:20:00',1.44),('15844','2014-03-12','08:25:00',1.58),('15844','2014-03-12','08:30:00',1.68),('15844','2014-03-12','08:35:00',1.77),('15844','2014-03-12','08:40:00',1.82),('15844','2014-03-12','08:45:00',1.91),('15844','2014-03-12','08:50:00',2.02),('15844','2014-03-12','08:55:00',2.13),('15844','2014-03-12','09:00:00',2.22),('15844','2014-03-12','09:05:00',2.29),('15844','2014-03-12','09:10:00',2.34),('15844','2014-03-12','09:15:00',2.4),('15844','2014-03-12','09:20:00',2.45),('15844','2014-03-12','09:25:00',2.51),('15844','2014-03-12','09:30:00',2.55),('15844','2014-03-12','09:35:00',2.62),('15844','2014-03-12','09:40:00',2.66),('15844','2014-03-12','09:45:00',2.71),('15844','2014-03-12','09:50:00',2.74),('15844','2014-03-12','09:55:00',2.82),('15844','2014-03-12','10:00:00',2.9),('15844','2014-03-12','10:05:00',3),('15844','2014-03-12','10:10:00',3.05),('15844','2014-03-12','10:15:00',3.1),('15844','2014-03-12','10:20:00',3.12),('15844','2014-03-12','10:25:00',3.14),('15844','2014-03-12','10:30:00',3.15),('15844','2014-03-12','10:35:00',3.17),('15844','2014-03-12','10:40:00',3.18),('15844','2014-03-12','10:45:00',3.21),('15844','2014-03-12','10:50:00',3.26),('15844','2014-03-12','10:55:00',3.25),('15844','2014-03-12','11:00:00',3.27),('15844','2014-03-12','11:05:00',3.28),('15844','2014-03-12','11:10:00',3.3),('15844','2014-03-12','11:15:00',3.31),('15844','2014-03-12','11:20:00',3.29),('15844','2014-03-12','11:25:00',3.28),('15844','2014-03-12','11:30:00',3.3),('15844','2014-03-12','11:35:00',3.27),('15844','2014-03-12','11:40:00',3.27),('15844','2014-03-12','11:45:00',3.26),('15844','2014-03-12','11:50:00',3.23),('15844','2014-03-12','11:55:00',3.23),('15844','2014-03-12','12:00:00',3.2),('15844','2014-03-12','12:05:00',3.2),('15844','2014-03-12','12:10:00',3.2),('15844','2014-03-12','12:15:00',3.16),('15844','2014-03-12','12:20:00',3.14),('15844','2014-03-12','12:25:00',3.13),('15844','2014-03-12','12:30:00',3.1),('15844','2014-03-12','12:35:00',3.07),('15844','2014-03-12','12:40:00',3.01),('15844','2014-03-12','12:45:00',2.98),('15844','2014-03-12','12:50:00',2.93),('15844','2014-03-12','12:55:00',2.88),('15844','2014-03-12','13:00:00',2.82),('15844','2014-03-12','13:05:00',2.74),('15844','2014-03-12','13:10:00',2.7),('15844','2014-03-12','13:15:00',2.63),('15844','2014-03-12','13:20:00',2.56),('15844','2014-03-12','13:25:00',2.49),('15844','2014-03-12','13:30:00',2.36),('15844','2014-03-12','13:35:00',2.32),('15844','2014-03-12','13:40:00',2.21),('15844','2014-03-12','13:45:00',2.13),('15844','2014-03-12','13:50:00',2.06),('15844','2014-03-12','13:55:00',1.98),('15844','2014-03-12','14:00:00',1.88),('15844','2014-03-12','14:05:00',1.76),('15844','2014-03-12','14:10:00',1.64),('15844','2014-03-12','14:15:00',1.55),('15844','2014-03-12','14:20:00',1.5),('15844','2014-03-12','14:25:00',1.39),('15844','2014-03-12','14:30:00',1.27),('15844','2014-03-12','14:35:00',1.21),('15844','2014-03-12','14:40:00',1.14),('15844','2014-03-12','14:45:00',1.07),('15844','2014-03-12','14:50:00',1.05),('15844','2014-03-12','14:55:00',1.02),('15844','2014-03-11','11:15:00',1.04),('15844','2014-03-11','11:20:00',1.06),('15844','2014-03-11','12:15:00',1.06),('15844','2014-03-11','12:20:00',1.3),('15844','2014-03-11','12:25:00',1.23),('15844','2014-03-11','12:30:00',1.16),('15844','2014-03-11','12:35:00',1.24),('15844','2014-03-11','12:40:00',1.21),('15844','2014-03-11','12:45:00',1.34),('15844','2014-03-11','12:50:00',1.43),('15844','2014-03-11','12:55:00',1.37),('15844','2014-03-11','13:00:00',1.3),('15844','2014-03-11','13:05:00',1.14),('15844','2014-03-11','13:10:00',1.32),('15844','2014-03-11','13:15:00',1.25),('15844','2014-03-11','13:20:00',1.28),('15844','2014-03-11','13:25:00',1.22),('15844','2014-03-11','13:45:00',1.01),('15844','2014-03-11','13:50:00',1.1),('15844','2014-03-11','13:55:00',1.19),('15844','2014-03-11','14:00:00',1.34),('15844','2014-03-11','14:05:00',1.45),('15844','2014-03-11','14:10:00',1.52),('15844','2014-03-11','14:15:00',1.92),('15844','2014-03-11','14:20:00',1.64),('15844','2014-03-11','14:25:00',1.37),('15844','2014-03-11','14:30:00',1.31),('15844','2014-03-11','14:35:00',1.36),('15844','2014-03-11','14:40:00',1.28),('15844','2014-03-11','14:45:00',1.25),('15844','2014-03-11','14:50:00',1.09),('15844','2014-03-11','14:55:00',1.09),('15844','2014-03-11','15:00:00',1.14),('15844','2014-03-11','15:05:00',1.19),('15844','2014-03-11','15:10:00',1.16),('15844','2014-03-11','15:15:00',1.2),('15844','2014-03-11','15:20:00',1.14),('15844','2014-03-11','15:25:00',1.05),('15844','2014-03-10','09:40:00',1.04),('15844','2014-03-10','09:45:00',1.1),('15844','2014-03-10','09:50:00',1.14),('15844','2014-03-10','10:20:00',1.07),('15844','2014-03-10','14:55:00',1.02),('15844','2014-03-10','15:00:00',1.31),('15844','2014-03-10','15:05:00',1.63),('15844','2014-03-10','15:10:00',1.27),('15844','2014-03-10','15:15:00',1.07),('15844','2014-03-09','08:05:00',1.02),('15844','2014-03-09','08:10:00',1.18),('15844','2014-03-09','08:15:00',1.29),('15844','2014-03-09','08:20:00',1.41),('15844','2014-03-09','08:25:00',1.52),('15844','2014-03-09','08:30:00',1.62),('15844','2014-03-09','08:35:00',1.7),('15844','2014-03-09','08:40:00',1.78),('15844','2014-03-09','08:45:00',1.92),('15844','2014-03-09','08:50:00',2.04),('15844','2014-03-09','08:55:00',2.13),('15844','2014-03-09','09:00:00',2.22),('15844','2014-03-09','09:05:00',2.28),('15844','2014-03-09','09:10:00',2.35),('15844','2014-03-09','09:15:00',2.4),('15844','2014-03-09','09:20:00',1.79),('15844','2014-03-09','09:25:00',2.59),('15844','2014-03-09','09:30:00',2.74),('15844','2014-03-09','09:35:00',2.81),('15844','2014-03-09','09:40:00',2.78),('15844','2014-03-09','09:45:00',2.86),('15844','2014-03-09','09:50:00',2.88),('15844','2014-03-09','09:55:00',2.74),('15844','2014-03-09','10:00:00',2.98),('15844','2014-03-09','10:05:00',2.99),('15844','2014-03-09','10:10:00',3.03),('15844','2014-03-09','10:15:00',3.09),('15844','2014-03-09','10:20:00',3.09),('15844','2014-03-09','10:25:00',3.17),('15844','2014-03-09','10:30:00',3.16),('15844','2014-03-09','10:35:00',3.3),('15844','2014-03-09','10:40:00',3.36),('15844','2014-03-09','10:45:00',3.36),('15844','2014-03-09','10:50:00',3.33),('15844','2014-03-09','10:55:00',3.46),('15844','2014-03-09','11:00:00',3.53),('15844','2014-03-09','11:05:00',3.53),('15844','2014-03-09','11:10:00',3.61),('15844','2014-03-09','11:15:00',1.86),('15844','2014-03-09','11:20:00',1.33),('15844','2014-03-09','11:35:00',1.07),('15844','2014-03-09','11:40:00',1.53),('15844','2014-03-09','11:45:00',1.97),('15844','2014-03-09','11:50:00',1.03),('15844','2014-03-09','11:55:00',1.06),('15844','2014-03-09','12:00:00',1.19),('15844','2014-03-09','12:05:00',1.11),('15844','2014-03-09','12:15:00',1.1),('15844','2014-03-09','12:20:00',3),('15844','2014-03-09','12:25:00',3.34),('15844','2014-03-09','12:30:00',3.39),('15844','2014-03-09','12:35:00',3.4),('15844','2014-03-09','12:40:00',3.32),('15844','2014-03-09','12:45:00',2.98),('15844','2014-03-09','12:50:00',3.02),('15844','2014-03-09','12:55:00',3.03),('15844','2014-03-09','13:00:00',3.02),('15844','2014-03-09','13:05:00',3.08),('15844','2014-03-09','13:10:00',3.1),('15844','2014-03-09','13:15:00',2.96),('15844','2014-03-09','13:20:00',2.89),('15844','2014-03-09','13:25:00',2.8),('15844','2014-03-09','13:30:00',2.68),('15844','2014-03-09','13:35:00',2.58),('15844','2014-03-09','13:40:00',2.46),('15844','2014-03-09','13:45:00',2.35),('15844','2014-03-09','13:50:00',1.9),('15844','2014-03-09','14:15:00',1.57),('15844','2014-03-09','14:20:00',1.53),('15844','2014-03-09','14:25:00',1.5),('15844','2014-03-09','14:30:00',1.42),('15844','2014-03-09','14:35:00',1.4),('15844','2014-03-09','14:40:00',1.29),('15844','2014-03-09','14:45:00',1.28),('15844','2014-03-09','14:50:00',1.07),('15844','2014-03-09','14:55:00',1.01),('15844','2014-03-08','08:00:00',1.06),('15844','2014-03-08','08:05:00',1.12),('15844','2014-03-08','08:10:00',1.17),('15844','2014-03-08','08:15:00',1.26),('15844','2014-03-08','08:20:00',1.36),('15844','2014-03-08','08:25:00',1.5),('15844','2014-03-08','08:30:00',1.58),('15844','2014-03-08','08:35:00',1.68),('15844','2014-03-08','08:40:00',1.77),('15844','2014-03-08','08:45:00',1.83),('15844','2014-03-08','08:50:00',1.96),('15844','2014-03-08','08:55:00',2.08),('15844','2014-03-08','09:00:00',2.15),('15844','2014-03-08','09:05:00',2.23),('15844','2014-03-08','09:10:00',2.34),('15844','2014-03-08','09:15:00',2.43),('15844','2014-03-08','09:20:00',2.52),('15844','2014-03-08','09:25:00',2.59),('15844','2014-03-08','09:30:00',2.65),('15844','2014-03-08','09:35:00',2.7),('15844','2014-03-08','09:40:00',2.77),('15844','2014-03-08','09:45:00',2.8),('15844','2014-03-08','09:50:00',2.85),('15844','2014-03-08','09:55:00',2.93),('15844','2014-03-08','10:00:00',2.98),('15844','2014-03-08','10:05:00',2.98),('15844','2014-03-08','10:10:00',3.03),('15844','2014-03-08','10:15:00',3.07),('15844','2014-03-08','10:20:00',3.08),('15844','2014-03-08','10:25:00',3.13),('15844','2014-03-08','10:30:00',3.14),('15844','2014-03-08','10:35:00',3.18),('15844','2014-03-08','10:40:00',3.21),('15844','2014-03-08','10:45:00',3.25),('15844','2014-03-08','10:50:00',3.27),('15844','2014-03-08','10:55:00',3.3),('15844','2014-03-08','11:00:00',3.33),('15844','2014-03-08','11:05:00',3.35),('15844','2014-03-08','11:10:00',3.37),('15844','2014-03-08','11:15:00',3.39),('15844','2014-03-08','11:20:00',3.4),('15844','2014-03-08','11:25:00',3.39),('15844','2014-03-08','11:30:00',3.55),('15844','2014-03-08','11:35:00',3.7),('15844','2014-03-08','11:40:00',3.67),('15844','2014-03-08','11:45:00',2.72),('15844','2014-03-08','11:50:00',3.65),('15844','2014-03-08','11:55:00',3.19),('15844','2014-03-08','12:00:00',2.35),('15844','2014-03-08','12:05:00',2.65),('15844','2014-03-08','12:10:00',1.65),('15844','2014-03-08','12:15:00',1.4),('15844','2014-03-08','12:20:00',1.29),('15844','2014-03-08','12:25:00',1.18),('15844','2014-03-08','12:30:00',1.2),('15844','2014-03-08','12:35:00',1.22),('15844','2014-03-08','12:40:00',1.34),('15844','2014-03-08','12:45:00',1.47),('15844','2014-03-08','12:50:00',1.49),('15844','2014-03-08','12:55:00',1.38),('15844','2014-03-08','13:00:00',1.89),('15844','2014-03-08','13:05:00',2.47),('15844','2014-03-08','13:10:00',1.42),('15844','2014-03-08','13:15:00',1.2),('15844','2014-03-08','13:35:00',1.49),('15844','2014-03-08','13:40:00',2.3),('15844','2014-03-08','13:45:00',1.39),('15844','2014-03-08','13:50:00',2.15),('15844','2014-03-08','13:55:00',1.45),('15844','2014-03-08','14:00:00',1.07),('15844','2014-03-08','14:05:00',1.02),('15844','2014-03-08','15:25:00',1.21),('15844','2014-04-30','08:25:00',1.09),('15844','2014-04-30','08:30:00',1.22),('15844','2014-04-30','08:35:00',1.29),('15844','2014-04-30','08:40:00',1.36),('15844','2014-04-30','08:45:00',1.44),('15844','2014-04-30','08:50:00',1.49),('15844','2014-04-30','08:55:00',1.57),('15844','2014-04-30','09:00:00',1.49),('15844','2014-04-30','09:05:00',1.17),('15844','2014-04-30','09:10:00',1.65),('15844','2014-04-30','09:15:00',2.11),('15844','2014-04-30','09:20:00',2.21),('15844','2014-04-30','09:25:00',2.45),('15844','2014-04-30','09:30:00',2.59),('15844','2014-04-30','09:35:00',2.55),('15844','2014-04-30','09:40:00',1.47),('15844','2014-04-30','09:45:00',2.39),('15844','2014-04-30','09:50:00',1.32),('15844','2014-04-30','09:55:00',3.06),('15844','2014-04-30','10:00:00',2.55),('15844','2014-04-30','10:05:00',2.41),('15844','2014-04-30','10:10:00',2.68),('15844','2014-04-30','10:15:00',1.7),('15844','2014-04-30','10:20:00',2.44),('15844','2014-04-30','10:25:00',1.82),('15844','2014-04-30','10:30:00',1.65),('15844','2014-04-30','10:35:00',2.07),('15844','2014-04-30','10:40:00',2.83),('15844','2014-04-30','10:45:00',1.35),('15844','2014-04-30','10:50:00',4.12),('15844','2014-04-30','10:55:00',3.53),('15844','2014-04-30','11:00:00',2.06),('15844','2014-04-30','11:05:00',2.18),('15844','2014-04-30','11:10:00',3.03),('15844','2014-04-30','11:15:00',3.32),('15844','2014-04-30','11:20:00',3.04),('15844','2014-04-30','11:25:00',1.91),('15844','2014-04-30','11:30:00',2.47),('15844','2014-04-30','11:35:00',1.47),('15844','2014-04-30','11:40:00',2.15),('15844','2014-04-30','11:45:00',1.39),('15844','2014-04-30','11:50:00',3.6),('15844','2014-04-30','11:55:00',4.16),('15844','2014-04-30','12:00:00',1.91),('15844','2014-04-30','12:05:00',1.6),('15844','2014-04-30','12:10:00',1.11),('15844','2014-04-30','12:20:00',1.3),('15844','2014-04-30','12:25:00',2.46),('15844','2014-04-30','12:30:00',3.81),('15844','2014-04-30','12:35:00',4.22),('15844','2014-04-30','12:40:00',2.74),('15844','2014-04-30','12:45:00',3.51),('15844','2014-04-30','12:50:00',3.81),('15844','2014-04-30','12:55:00',2.95),('15844','2014-04-30','13:00:00',4.05),('15844','2014-04-30','13:05:00',1.33),('15844','2014-04-30','13:10:00',3.03),('15844','2014-04-30','13:15:00',3.6),('15844','2014-04-30','13:20:00',1.44),('15844','2014-04-30','13:25:00',3.62),('15844','2014-04-30','13:30:00',3.38),('15844','2014-04-30','13:35:00',3.48),('15844','2014-04-30','13:40:00',4.38),('15844','2014-04-30','13:45:00',2.93),('15844','2014-04-30','13:50:00',1.58),('15844','2014-04-30','13:55:00',1.55),('15844','2014-04-30','14:00:00',1.57),('15844','2014-04-30','14:05:00',1.47),('15844','2014-04-30','14:10:00',2.29),('15844','2014-04-30','14:15:00',2.68),('15844','2014-04-30','14:20:00',1.85),('15844','2014-04-30','14:25:00',1.39),('15844','2014-04-30','14:30:00',2.05),('15844','2014-04-30','14:35:00',1.41),('15844','2014-04-30','14:40:00',1.09),('15844','2014-04-30','14:45:00',1.04),('15844','2014-04-30','14:50:00',1.23),('15844','2014-04-30','14:55:00',1.58),('15844','2014-04-30','15:00:00',1.37),('15844','2014-04-30','15:05:00',1.49),('15844','2014-04-30','15:10:00',1.46),('15844','2014-04-30','15:15:00',1.41),('15844','2014-04-30','15:20:00',1.22),('15844','2014-04-30','15:25:00',1.34),('15844','2014-04-30','15:30:00',1.33),('15844','2014-04-30','15:35:00',2.18),('15844','2014-04-30','15:40:00',1.74),('15844','2014-04-30','15:45:00',2.54),('15844','2014-04-30','15:50:00',1.87),('15844','2014-04-30','15:55:00',1.41),('15844','2014-04-30','16:00:00',1.51),('15844','2014-04-30','16:05:00',1.25),('15844','2014-04-30','16:10:00',1.08),('15844','2014-04-30','16:15:00',1.34),('15844','2014-04-30','16:20:00',1.79),('15844','2014-04-30','16:25:00',1.36),('15844','2014-04-30','16:30:00',1.47),('15844','2014-04-30','16:35:00',1.42),('15844','2014-04-30','16:40:00',1.18),('15844','2014-04-30','16:45:00',1.05),('15844','2014-04-30','16:55:00',1.02),('15844','2014-03-07','10:00:00',1.92),('15844','2014-03-07','10:10:00',1.08),('15844','2014-03-07','10:20:00',2.31),('15844','2014-03-07','10:25:00',3.59),('15844','2014-03-07','10:30:00',2.77),('15844','2014-03-07','10:35:00',3.77),('15844','2014-03-07','10:40:00',2.81),('15844','2014-03-07','10:45:00',1.84),('15844','2014-03-07','10:50:00',2.66),('15844','2014-03-07','10:55:00',3.43),('15844','2014-03-07','11:00:00',3.27),('15844','2014-03-07','11:05:00',1.66),('15844','2014-03-07','11:10:00',1.79),('15844','2014-03-07','11:15:00',1.09),('15844','2014-03-07','11:20:00',2.59),('15844','2014-03-07','11:25:00',3.13),('15844','2014-03-07','11:30:00',1.77),('15844','2014-03-07','11:35:00',1.72),('15844','2014-03-07','11:40:00',1.48),('15844','2014-03-07','11:55:00',1.31),('15844','2014-03-07','12:00:00',1.71),('15844','2014-03-07','12:05:00',2.25),('15844','2014-03-07','12:10:00',1.41),('15844','2014-03-07','12:15:00',2.35),('15844','2014-03-07','12:20:00',3.26),('15844','2014-03-07','12:25:00',1.73),('15844','2014-03-07','12:45:00',2.12),('15844','2014-03-07','12:50:00',3.21),('15844','2014-03-07','12:55:00',3.06),('15844','2014-03-07','13:00:00',2.63),('15844','2014-03-07','13:05:00',1.85),('15844','2014-03-07','13:10:00',2.39),('15844','2014-03-07','13:15:00',3.22),('15844','2014-03-07','13:20:00',2.78),('15844','2014-03-07','13:25:00',1.81),('15844','2014-03-07','13:30:00',1.64),('15844','2014-03-07','13:35:00',1.77),('15844','2014-03-07','13:40:00',1.61),('15844','2014-03-07','13:45:00',1.4),('15844','2014-03-07','13:50:00',1.31),('15844','2014-03-07','13:55:00',1.21),('15844','2014-03-07','14:00:00',1.1),('15844','2014-03-07','14:05:00',1),('15844','2014-03-07','14:35:00',1.06),('15844','2014-03-07','14:40:00',1.14),('15844','2014-03-07','14:45:00',1.27),('15844','2014-03-07','14:50:00',1.43),('15844','2014-03-07','14:55:00',1.61),('15844','2014-03-07','15:00:00',1.61),('15844','2014-03-07','15:05:00',1.49),('15844','2014-03-07','15:10:00',1.34),('15844','2014-03-07','15:15:00',1.25),('15844','2014-03-07','15:20:00',1.12),('15844','2014-03-06','08:15:00',1.14),('15844','2014-03-06','08:50:00',1.47),('15844','2014-03-06','09:05:00',1.34),('15844','2014-03-06','09:25:00',1.17),('15844','2014-03-06','09:30:00',2.5),('15844','2014-03-06','09:35:00',1.99),('15844','2014-03-06','09:40:00',1.47),('15844','2014-03-06','09:45:00',1.56),('15844','2014-03-06','09:50:00',1.62),('15844','2014-03-06','09:55:00',1.75),('15844','2014-03-06','10:00:00',1.69),('15844','2014-03-06','10:05:00',1.94),('15844','2014-03-06','10:10:00',2.43),('15844','2014-03-06','10:15:00',2.53),('15844','2014-03-06','10:20:00',2.72),('15844','2014-03-06','10:25:00',3.22),('15844','2014-03-06','10:30:00',2.76),('15844','2014-03-06','10:35:00',3.48),('15844','2014-03-06','10:40:00',3.48),('15844','2014-03-06','10:45:00',3.4),('15844','2014-03-06','10:50:00',3.39),('15844','2014-03-06','10:55:00',3.4),('15844','2014-03-06','11:00:00',3.43),('15844','2014-03-06','11:05:00',3.56),('15844','2014-03-06','11:10:00',1.81),('15844','2014-03-06','11:15:00',2.24),('15844','2014-03-06','11:25:00',1.26),('15844','2014-03-06','11:30:00',1.21),('15844','2014-03-06','11:35:00',2.63),('15844','2014-03-06','11:40:00',1.36),('15844','2014-03-06','11:45:00',1.03),('15844','2014-03-06','11:50:00',1.13),('15844','2014-03-06','11:55:00',1.43),('15844','2014-03-06','12:00:00',1.7),('15844','2014-03-06','12:05:00',1.83),('15844','2014-03-06','12:10:00',1.58),('15844','2014-03-06','12:15:00',2.57),('15844','2014-03-06','12:20:00',2.13),('15844','2014-03-06','12:35:00',1.97),('15844','2014-03-06','12:50:00',1.17),('15844','2014-03-06','12:55:00',1.22),('15844','2014-03-06','13:00:00',1.51),('15844','2014-03-06','13:05:00',1.32),('15844','2014-03-06','13:10:00',1.1),('15844','2014-03-06','13:15:00',1.08),('15844','2014-03-06','14:10:00',1.03),('15844','2014-03-06','14:15:00',1.03),('15844','2014-03-06','14:20:00',1.05),('15844','2014-03-05','07:50:00',1.06),('15844','2014-03-05','07:55:00',1.13),('15844','2014-03-05','08:00:00',1.22),('15844','2014-03-05','08:05:00',1.3),('15844','2014-03-05','08:10:00',1.43),('15844','2014-03-05','08:15:00',1.38),('15844','2014-03-05','08:20:00',1.2),('15844','2014-03-05','08:25:00',1.84),('15844','2014-03-05','08:30:00',1.9),('15844','2014-03-05','08:35:00',1.58),('15844','2014-03-05','08:45:00',1.38),('15844','2014-03-05','08:50:00',1.28),('15844','2014-03-05','08:55:00',2.44),('15844','2014-03-05','09:00:00',2.55),('15844','2014-03-05','09:05:00',2.27),('15844','2014-03-05','09:10:00',2.32),('15844','2014-03-05','09:15:00',2.54),('15844','2014-03-05','09:20:00',2.6),('15844','2014-03-05','09:25:00',2.65),('15844','2014-03-05','09:30:00',2.71),('15844','2014-03-05','09:35:00',2.7),('15844','2014-03-05','09:40:00',2.78),('15844','2014-03-05','09:45:00',2.84),('15844','2014-03-05','09:50:00',2.87),('15844','2014-03-05','09:55:00',2.9),('15844','2014-03-05','10:00:00',2.95),('15844','2014-03-05','10:05:00',2.99),('15844','2014-03-05','10:10:00',3.01),('15844','2014-03-05','10:15:00',3.04),('15844','2014-03-05','10:20:00',3.07),('15844','2014-03-05','10:25:00',3.11),('15844','2014-03-05','10:30:00',3.16),('15844','2014-03-05','10:35:00',3.26),('15844','2014-03-05','10:40:00',3.24),('15844','2014-03-05','10:45:00',3.25),('15844','2014-03-05','10:50:00',3.26),('15844','2014-03-05','10:55:00',3.28),('15844','2014-03-05','11:00:00',3.31),('15844','2014-03-05','11:05:00',3.36),('15844','2014-03-05','11:10:00',3.39),('15844','2014-03-05','11:15:00',3.05),('15844','2014-03-05','11:20:00',3.26),('15844','2014-03-05','11:30:00',1.03),('15844','2014-03-05','11:35:00',1.16),('15844','2014-03-05','11:40:00',3.22),('15844','2014-03-05','11:45:00',2.39),('15844','2014-03-05','11:50:00',3.55),('15844','2014-03-05','11:55:00',3.44),('15844','2014-03-05','12:00:00',2.75),('15844','2014-03-05','12:05:00',2.73),('15844','2014-03-05','12:10:00',1.96),('15844','2014-03-05','12:15:00',2.59),('15844','2014-03-05','12:20:00',2.43),('15844','2014-03-05','12:25:00',2.59),('15844','2014-03-05','12:30:00',1.68),('15844','2014-03-05','12:35:00',2.58),('15844','2014-03-05','12:40:00',1.61),('15844','2014-03-05','12:45:00',1.75),('15844','2014-03-05','12:50:00',2),('15844','2014-03-05','12:55:00',1.39),('15844','2014-03-05','13:00:00',1.91),('15844','2014-03-05','13:05:00',2.06),('15844','2014-03-05','13:10:00',2.07),('15844','2014-03-05','13:15:00',2.26),('15844','2014-03-05','13:20:00',1.2),('15844','2014-03-05','13:25:00',1.76),('15844','2014-03-05','13:30:00',2.13),('15844','2014-03-05','13:35:00',2.43),('15844','2014-03-05','13:40:00',2.25),('15844','2014-03-05','13:45:00',2.75),('15844','2014-03-05','13:50:00',1.72),('15844','2014-03-05','13:55:00',1.44),('15844','2014-03-05','14:00:00',1.04),('15844','2014-03-05','14:05:00',1.03),('15844','2014-03-05','14:10:00',1.01),('15844','2014-03-05','14:20:00',1.13),('15844','2014-03-05','14:25:00',1.12),('15844','2014-03-05','14:30:00',1.09),('15844','2014-03-05','14:35:00',1.02),('15844','2014-03-05','14:55:00',1.08),('15844','2014-03-04','09:10:00',2.81),('15844','2014-03-04','09:20:00',1.01),('15844','2014-03-04','09:55:00',1.65),('15844','2014-03-04','10:00:00',1.39),('15844','2014-03-04','10:30:00',3.38),('15844','2014-03-04','10:35:00',2.02),('15844','2014-03-04','10:40:00',2.74),('15844','2014-03-04','10:45:00',2.58),('15844','2014-03-04','10:50:00',4.06),('15844','2014-03-04','10:55:00',4.15),('15844','2014-03-04','11:00:00',3.52),('15844','2014-03-04','11:05:00',3.33),('15844','2014-03-04','11:10:00',2.09),('15844','2014-03-04','11:25:00',1.32),('15844','2014-03-04','11:45:00',1.32),('15844','2014-03-04','11:50:00',3.23),('15844','2014-03-04','11:55:00',3.78),('15844','2014-03-04','12:00:00',2.71),('15844','2014-03-04','12:05:00',3.55),('15844','2014-03-04','12:10:00',3.15),('15844','2014-03-04','12:15:00',3.09),('15844','2014-03-04','12:20:00',2.87),('15844','2014-03-04','12:25:00',3.27),('15844','2014-03-04','12:30:00',3.13),('15844','2014-03-04','12:35:00',3.08),('15844','2014-03-04','12:40:00',3.13),('15844','2014-03-04','12:45:00',2.85),('15844','2014-03-04','12:50:00',3),('15844','2014-03-04','12:55:00',2.91),('15844','2014-03-04','13:00:00',2.91),('15844','2014-03-04','13:05:00',2.86),('15844','2014-03-04','13:10:00',2.78),('15844','2014-03-04','13:15:00',2.44),('15844','2014-03-04','13:20:00',2.42),('15844','2014-03-04','13:25:00',1.02),('15844','2014-03-04','13:40:00',1.06),('15844','2014-03-04','13:55:00',1.27),('15844','2014-03-04','14:00:00',1.33),('15844','2014-03-04','14:05:00',1.69),('15844','2014-03-04','14:10:00',1.82),('15844','2014-03-04','14:15:00',1.86),('15844','2014-03-04','14:20:00',1.65),('15844','2014-03-04','14:25:00',1.42),('15844','2014-03-04','14:30:00',1.22),('15844','2014-03-04','14:35:00',1.09),('15844','2014-03-04','14:40:00',1.02),('15844','2014-03-03','08:00:00',1.05),('15844','2014-03-03','08:05:00',1.2),('15844','2014-03-03','08:10:00',1.29),('15844','2014-03-03','08:15:00',1.38),('15844','2014-03-03','08:20:00',1.46),('15844','2014-03-03','08:25:00',1.54),('15844','2014-03-03','08:30:00',1.63),('15844','2014-03-03','08:35:00',1.7),('15844','2014-03-03','08:40:00',1.79),('15844','2014-03-03','08:45:00',1.85),('15844','2014-03-03','08:50:00',1.87),('15844','2014-03-03','08:55:00',1.97),('15844','2014-03-03','09:00:00',1.85),('15844','2014-03-03','09:05:00',1.72),('15844','2014-03-03','09:10:00',2.34),('15844','2014-03-03','09:15:00',2.46),('15844','2014-03-03','09:20:00',2.55),('15844','2014-03-03','09:25:00',2.57),('15844','2014-03-03','09:30:00',2.55),('15844','2014-03-03','09:35:00',2.58),('15844','2014-03-03','09:40:00',2.4),('15844','2014-03-03','09:45:00',2.67),('15844','2014-03-03','09:50:00',2.74),('15844','2014-03-03','09:55:00',2.85),('15844','2014-03-03','10:00:00',2.92),('15844','2014-03-03','10:05:00',2.9),('15844','2014-03-03','10:10:00',2.97),('15844','2014-03-03','10:15:00',3.02),('15844','2014-03-03','10:20:00',3.05),('15844','2014-03-03','10:25:00',3.06),('15844','2014-03-03','10:30:00',3.12),('15844','2014-03-03','10:35:00',3.17),('15844','2014-03-03','10:40:00',3.17),('15844','2014-03-03','10:45:00',3.2),('15844','2014-03-03','10:50:00',3.16),('15844','2014-03-03','10:55:00',3.23),('15844','2014-03-03','11:00:00',3.25),('15844','2014-03-03','11:05:00',3.24),('15844','2014-03-03','11:10:00',3.24),('15844','2014-03-03','11:15:00',3.26),('15844','2014-03-03','11:20:00',3.28),('15844','2014-03-03','11:25:00',3.27),('15844','2014-03-03','11:30:00',3.24),('15844','2014-03-03','11:35:00',3.23),('15844','2014-03-03','11:40:00',3.24),('15844','2014-03-03','11:45:00',3.25),('15844','2014-03-03','11:50:00',3.22),('15844','2014-03-03','11:55:00',3.22),('15844','2014-03-03','12:00:00',3.19),('15844','2014-03-03','12:05:00',3.17),('15844','2014-03-03','12:10:00',3.17),('15844','2014-03-03','12:15:00',3.15),('15844','2014-03-03','12:20:00',3.11),('15844','2014-03-03','12:25:00',3.09),('15844','2014-03-03','12:30:00',3.04),('15844','2014-03-03','12:35:00',3.02),('15844','2014-03-03','12:40:00',3.03),('15844','2014-03-03','12:45:00',2.96),('15844','2014-03-03','12:50:00',2.89),('15844','2014-03-03','12:55:00',2.84),('15844','2014-03-03','13:00:00',2.79),('15844','2014-03-03','13:05:00',2.71),('15844','2014-03-03','13:10:00',2.64),('15844','2014-03-03','13:15:00',2.58),('15844','2014-03-03','13:20:00',2.49),('15844','2014-03-03','13:25:00',2.39),('15844','2014-03-03','13:30:00',2.32),('15844','2014-03-03','13:35:00',2.25),('15844','2014-03-03','13:40:00',1.81),('15844','2014-03-03','13:45:00',1.97),('15844','2014-03-03','13:50:00',1.82),('15844','2014-03-03','13:55:00',1.88),('15844','2014-03-03','14:00:00',1.77),('15844','2014-03-03','14:05:00',1.6),('15844','2014-03-03','14:10:00',1.59),('15844','2014-03-03','14:15:00',1.5),('15844','2014-03-03','14:20:00',1.28),('15844','2014-03-03','14:30:00',1.21),('15844','2014-03-03','14:35:00',1.05),('15844','2014-03-02','08:25:00',1.62),('15844','2014-03-02','08:30:00',1.62),('15844','2014-03-02','08:35:00',1.71),('15844','2014-03-02','08:40:00',1.82),('15844','2014-03-02','08:45:00',1.93),('15844','2014-03-02','08:50:00',2.03),('15844','2014-03-02','08:55:00',2.14),('15844','2014-03-02','09:00:00',2.22),('15844','2014-03-02','09:05:00',2.35),('15844','2014-03-02','09:10:00',2.33),('15844','2014-03-02','09:15:00',2.44),('15844','2014-03-02','09:20:00',2.64),('15844','2014-03-02','09:25:00',2.37),('15844','2014-03-02','09:30:00',2.02),('15844','2014-03-02','09:35:00',2.52),('15844','2014-03-02','10:15:00',1.16),('15844','2014-03-02','10:20:00',1.89),('15844','2014-03-02','10:25:00',2.78),('15844','2014-03-02','10:30:00',3.76),('15844','2014-03-02','10:35:00',3.92),('15844','2014-03-02','10:40:00',3.72),('15844','2014-03-02','10:45:00',3.2),('15844','2014-03-02','10:50:00',2.5),('15844','2014-03-02','10:55:00',1.33),('15844','2014-03-02','11:00:00',1.89),('15844','2014-03-02','11:05:00',4.27),('15844','2014-03-02','11:10:00',3.11),('15844','2014-03-02','11:15:00',3.42),('15844','2014-03-02','11:20:00',2.7),('15844','2014-03-02','11:25:00',1.64),('15844','2014-03-02','11:30:00',1.52),('15844','2014-03-02','11:35:00',1.48),('15844','2014-03-02','11:40:00',1.81),('15844','2014-03-02','11:45:00',2.84),('15844','2014-03-02','11:50:00',2.71),('15844','2014-03-02','11:55:00',3.93),('15844','2014-03-02','12:00:00',3.1),('15844','2014-03-02','12:05:00',3.41),('15844','2014-03-02','12:10:00',1.89),('15844','2014-03-02','12:15:00',1.6),('15844','2014-03-02','12:20:00',1.8),('15844','2014-03-02','12:25:00',1.19),('15844','2014-02-28','08:15:00',1.09),('15844','2014-02-28','08:30:00',1.3),('15844','2014-02-28','09:20:00',1.86),('15844','2014-02-28','09:25:00',1.82),('15844','2014-02-28','09:30:00',1.2),('15844','2014-02-28','09:35:00',2.84),('15844','2014-02-28','09:40:00',2.43),('15844','2014-02-28','09:45:00',1.32),('15844','2014-02-28','09:50:00',1.23),('15844','2014-02-28','09:55:00',1.1),('15844','2014-02-28','10:10:00',1.06),('15844','2014-02-28','10:15:00',3.21),('15844','2014-02-28','10:20:00',3.41),('15844','2014-02-28','10:25:00',2.1),('15844','2014-02-28','10:35:00',1.1),('15844','2014-02-28','11:05:00',1.3),('15844','2014-02-28','11:10:00',1.2),('15844','2014-02-28','11:15:00',1.28),('15844','2014-02-28','11:20:00',1.55),('15844','2014-02-28','11:25:00',1.32),('15844','2014-02-28','11:50:00',1.05),('15844','2014-02-28','11:55:00',1.23),('15844','2014-02-28','12:00:00',1.68),('15844','2014-02-28','12:05:00',1.08),('15844','2014-02-28','12:20:00',1.49),('15844','2014-02-28','12:25:00',1.95),('15844','2014-02-28','12:30:00',2.81),('15844','2014-02-28','12:35:00',1.91),('15844','2014-02-28','12:40:00',1.34),('15844','2014-02-28','12:45:00',2.19),('15844','2014-02-28','12:50:00',1.51),('15844','2014-02-28','12:55:00',2.45),('15844','2014-02-28','13:00:00',1.17),('15844','2014-02-28','13:05:00',1.27),('15844','2014-02-28','13:10:00',1.04),('15844','2014-02-28','14:15:00',1.15),('15844','2014-02-28','14:20:00',1.1),('15844','2014-02-28','14:25:00',1.13),('15844','2014-02-28','14:30:00',1.18),('15844','2014-02-28','14:35:00',1.04),('15844','2014-02-28','14:50:00',1.08),('15844','2014-02-28','15:20:00',1.02),('15844','2014-02-27','10:40:00',1.06),('15844','2014-02-27','10:45:00',1.07),('15844','2014-02-27','10:50:00',1.1),('15844','2014-02-27','10:55:00',1.29),('15844','2014-02-27','11:00:00',1.49),('15844','2014-02-27','11:05:00',1.42),('15844','2014-02-27','11:10:00',1.32),('15844','2014-02-27','11:15:00',1.11),('15844','2014-02-27','11:20:00',1.16),('15844','2014-02-27','11:25:00',1.48),('15844','2014-02-27','11:30:00',1.32),('15844','2014-02-27','11:35:00',1.1),('15844','2014-02-27','11:50:00',1.1),('15844','2014-02-27','11:55:00',1.1),('15844','2014-02-27','12:00:00',1),('15844','2014-02-27','12:05:00',1.1),('15844','2014-02-27','12:10:00',1.12),('15844','2014-02-27','12:15:00',1.13),('15844','2014-02-27','12:20:00',1.11),('15844','2014-02-27','12:25:00',1.08),('15844','2014-02-27','12:30:00',1.06),('15844','2014-02-27','12:35:00',1.01),('15844','2014-02-27','12:50:00',1.01),('15844','2014-02-27','12:55:00',1.01),('15844','2014-02-27','13:25:00',1.09),('15844','2014-02-27','13:30:00',1.25),('15844','2014-02-27','13:35:00',1.4),('15844','2014-02-27','13:40:00',1.37),('15844','2014-02-27','13:45:00',1.27),('15844','2014-02-27','13:50:00',1.42),('15844','2014-02-27','13:55:00',1.7),('15844','2014-02-27','14:00:00',1.64),('15844','2014-02-27','14:05:00',1.23),('15844','2014-02-27','14:10:00',1.11),('15844','2014-02-27','14:15:00',1.01),('15844','2014-02-27','14:45:00',1.04),('15844','2014-02-27','14:50:00',1.01),('15844','2014-02-27','14:55:00',1.02),('15844','2014-02-27','15:00:00',1.08),('15844','2014-02-27','15:05:00',1.12),('15844','2014-02-27','15:10:00',1.17),('15844','2014-02-27','15:15:00',1.14),('15844','2014-02-27','15:20:00',1.08),('15844','2014-02-26','08:10:00',1.06),('15844','2014-02-26','08:15:00',1.14),('15844','2014-02-26','08:20:00',1.19),('15844','2014-02-26','08:25:00',1.3),('15844','2014-02-26','08:30:00',1.39),('15844','2014-02-26','08:35:00',1.49),('15844','2014-02-26','08:40:00',1.54),('15844','2014-02-26','08:45:00',1.34),('15844','2014-02-26','08:50:00',1.71),('15844','2014-02-26','08:55:00',1.76),('15844','2014-02-26','09:00:00',1.89),('15844','2014-02-26','09:05:00',1.91),('15844','2014-02-26','09:10:00',1.87),('15844','2014-02-26','09:15:00',2.11),('15844','2014-02-26','09:20:00',1.93),('15844','2014-02-26','09:25:00',1.39),('15844','2014-02-26','09:30:00',2.16),('15844','2014-02-26','09:35:00',1.78),('15844','2014-02-26','09:40:00',1.49),('15844','2014-02-26','09:45:00',1.67),('15844','2014-02-26','09:50:00',1.3),('15844','2014-02-26','09:55:00',1.03),('15844','2014-02-26','12:15:00',1.08),('15844','2014-02-26','12:20:00',1.1),('15844','2014-02-26','12:25:00',1.21),('15844','2014-02-26','12:30:00',1.62),('15844','2014-02-26','12:35:00',3.31),('15844','2014-02-26','12:40:00',3.04),('15844','2014-02-26','12:45:00',2.95),('15844','2014-02-26','12:50:00',2.69),('15844','2014-02-26','12:55:00',2.6),('15844','2014-02-26','13:00:00',2.1),('15844','2014-02-26','13:05:00',1.43),('15844','2014-02-26','13:20:00',2.41),('15844','2014-02-26','13:25:00',2.5),('15844','2014-02-26','13:30:00',2.02),('15844','2014-02-26','13:35:00',2.32),('15844','2014-02-26','13:40:00',1.99),('15844','2014-02-26','13:45:00',1.78),('15844','2014-02-26','13:50:00',1.14),('15844','2014-02-26','13:55:00',1.96),('15844','2014-02-26','14:00:00',1.68),('15844','2014-02-26','14:05:00',1.38),('15844','2014-02-26','14:10:00',1.78),('15844','2014-02-26','14:15:00',1.97),('15844','2014-02-26','14:20:00',1.58),('15844','2014-02-26','14:25:00',1.03),('15844','2014-02-26','14:35:00',1.12),('15844','2014-02-26','14:40:00',1.01),('15844','2014-02-26','14:45:00',1.12),('15844','2014-04-29','09:50:00',1.12),('15844','2014-04-29','09:55:00',2.16),('15844','2014-04-29','10:00:00',3.21),('15844','2014-04-29','10:05:00',3.23),('15844','2014-04-29','10:10:00',2.95),('15844','2014-04-29','10:15:00',2.33),('15844','2014-04-29','10:20:00',3.22),('15844','2014-04-29','10:25:00',3.79),('15844','2014-04-29','10:30:00',3.85),('15844','2014-04-29','10:35:00',3.97),('15844','2014-04-29','10:40:00',4.04),('15844','2014-04-29','10:45:00',3.58),('15844','2014-04-29','10:50:00',3.64),('15844','2014-04-29','10:55:00',4.36),('15844','2014-04-29','11:00:00',4.11),('15844','2014-04-29','11:05:00',4.47),('15844','2014-04-29','11:10:00',3.29),('15844','2014-04-29','11:15:00',4.54),('15844','2014-04-29','11:20:00',4.5),('15844','2014-04-29','11:25:00',4.18),('15844','2014-04-29','11:30:00',3.92),('15844','2014-04-29','11:35:00',1.62),('15844','2014-04-29','11:40:00',1.58),('15844','2014-04-29','11:45:00',2.51),('15844','2014-04-29','12:00:00',1.03),('15844','2014-04-29','12:05:00',2.11),('15844','2014-04-29','12:10:00',4.13),('15844','2014-04-29','12:15:00',2.88),('15844','2014-04-29','12:20:00',2.41),('15844','2014-04-29','12:25:00',3.16),('15844','2014-04-29','12:30:00',2.5),('15844','2014-04-29','12:35:00',2.08),('15844','2014-04-29','12:40:00',1.93),('15844','2014-04-29','12:45:00',1.78),('15844','2014-04-29','12:50:00',4.18),('15844','2014-04-29','12:55:00',1.65),('15844','2014-04-29','13:00:00',1.86),('15844','2014-04-29','13:05:00',4.03),('15844','2014-04-29','13:10:00',3.72),('15844','2014-04-29','13:15:00',1.59),('15844','2014-04-29','13:20:00',3.95),('15844','2014-04-29','13:25:00',4.55),('15844','2014-04-29','13:30:00',1.43),('15844','2014-04-29','13:35:00',2.65),('15844','2014-04-29','13:40:00',1.44),('15844','2014-04-29','13:45:00',1.41),('15844','2014-04-29','13:50:00',1.2),('15844','2014-04-29','15:05:00',1.08),('15844','2014-04-29','15:10:00',1.28),('15844','2014-04-29','15:15:00',1.74),('15844','2014-04-29','15:40:00',1.17),('15844','2014-02-25','08:15:00',1.09),('15844','2014-02-25','08:20:00',1.18),('15844','2014-02-25','08:25:00',1.25),('15844','2014-02-25','08:30:00',1.31),('15844','2014-02-25','08:35:00',1.39),('15844','2014-02-25','08:40:00',1.47),('15844','2014-02-25','08:45:00',1.58),('15844','2014-02-25','08:50:00',1.7),('15844','2014-02-25','08:55:00',1.8),('15844','2014-02-25','09:00:00',1.87),('15844','2014-02-25','09:05:00',1.93),('15844','2014-02-25','09:10:00',2),('15844','2014-02-25','09:15:00',2.08),('15844','2014-02-25','09:20:00',2.17),('15844','2014-02-25','09:25:00',2.24),('15844','2014-02-25','09:30:00',2.32),('15844','2014-02-25','09:35:00',2.38),('15844','2014-02-25','09:40:00',2.43),('15844','2014-02-25','09:45:00',2.47),('15844','2014-02-25','09:50:00',2.52),('15844','2014-02-25','09:55:00',2.54),('15844','2014-02-25','10:00:00',2.56),('15844','2014-02-25','10:05:00',2.61),('15844','2014-02-25','10:10:00',2.65),('15844','2014-02-25','10:15:00',2.71),('15844','2014-02-25','10:20:00',2.74),('15844','2014-02-25','10:25:00',2.75),('15844','2014-02-25','10:30:00',2.78),('15844','2014-02-25','10:35:00',2.85),('15844','2014-02-25','10:40:00',2.91),('15844','2014-02-25','10:45:00',2.93),('15844','2014-02-25','10:50:00',2.94),('15844','2014-02-25','10:55:00',2.98),('15844','2014-02-25','11:00:00',3.01),('15844','2014-02-25','11:05:00',3.02),('15844','2014-02-25','11:10:00',3),('15844','2014-02-25','11:15:00',2.97),('15844','2014-02-25','11:20:00',2.95),('15844','2014-02-25','11:25:00',2.95),('15844','2014-02-25','11:30:00',2.94),('15844','2014-02-25','11:35:00',2.87),('15844','2014-02-25','11:40:00',2.91),('15844','2014-02-25','11:45:00',2.97),('15844','2014-02-25','11:50:00',2.96),('15844','2014-02-25','11:55:00',2.91),('15844','2014-02-25','12:00:00',2.89),('15844','2014-02-25','12:05:00',2.91),('15844','2014-02-25','12:10:00',2.86),('15844','2014-02-25','12:15:00',2.79),('15844','2014-02-25','12:20:00',2.74),('15844','2014-02-25','12:25:00',2.7),('15844','2014-02-25','12:30:00',2.69),('15844','2014-02-25','12:35:00',2.66),('15844','2014-02-25','12:40:00',2.69),('15844','2014-02-25','12:45:00',2.67),('15844','2014-02-25','12:50:00',2.6),('15844','2014-02-25','12:55:00',2.54),('15844','2014-02-25','13:00:00',2.54),('15844','2014-02-25','13:05:00',2.46),('15844','2014-02-25','13:10:00',2.4),('15844','2014-02-25','13:15:00',2.26),('15844','2014-02-25','13:20:00',1.76),('15844','2014-02-25','13:25:00',1.9),('15844','2014-02-25','13:30:00',2.49),('15844','2014-02-25','13:35:00',2.24),('15844','2014-02-25','13:40:00',2.08),('15844','2014-02-25','13:45:00',1.4),('15844','2014-02-25','13:50:00',1.46),('15844','2014-02-25','13:55:00',1.14),('15844','2014-02-25','14:05:00',1.62),('15844','2014-02-25','14:10:00',1.65),('15844','2014-02-25','14:15:00',1.41),('15844','2014-02-25','14:20:00',1.19),('15844','2014-02-25','14:25:00',1.12),('15844','2014-02-25','14:30:00',1.02),('15844','2014-02-25','14:35:00',1.07),('15844','2014-02-25','14:40:00',1.05),('15844','2014-02-25','14:45:00',1.03),('15844','2014-02-25','14:50:00',1),('15844','2014-02-24','08:05:00',1.14),('15844','2014-02-24','08:10:00',1.25),('15844','2014-02-24','08:15:00',1.15),('15844','2014-02-24','08:50:00',1.14),('15844','2014-02-24','08:55:00',2.01),('15844','2014-02-24','09:00:00',2),('15844','2014-02-24','09:05:00',2.02),('15844','2014-02-24','09:10:00',2.07),('15844','2014-02-24','09:15:00',2.14),('15844','2014-02-24','09:20:00',2.21),('15844','2014-02-24','09:25:00',2.29),('15844','2014-02-24','09:30:00',2.36),('15844','2014-02-24','09:35:00',2.41),('15844','2014-02-24','09:40:00',2.45),('15844','2014-02-24','09:45:00',2.54),('15844','2014-02-24','09:50:00',2.59),('15844','2014-02-24','09:55:00',2.65),('15844','2014-02-24','10:00:00',2.69),('15844','2014-02-24','10:05:00',2.73),('15844','2014-02-24','10:10:00',2.77),('15844','2014-02-24','10:15:00',2.78),('15844','2014-02-24','10:20:00',2.81),('15844','2014-02-24','10:25:00',2.84),('15844','2014-02-24','10:30:00',2.88),('15844','2014-02-24','10:35:00',2.91),('15844','2014-02-24','10:40:00',2.94),('15844','2014-02-24','10:45:00',2.96),('15844','2014-02-24','10:50:00',2.99),('15844','2014-02-24','10:55:00',2.99),('15844','2014-02-24','11:00:00',3.03),('15844','2014-02-24','11:05:00',3.02),('15844','2014-02-24','11:10:00',3.03),('15844','2014-02-24','11:15:00',3.04),('15844','2014-02-24','11:20:00',3.06),('15844','2014-02-24','11:25:00',3.16),('15844','2014-02-24','11:30:00',3.33),('15844','2014-02-24','11:35:00',2.97),('15844','2014-02-24','11:40:00',2.56),('15844','2014-02-24','11:45:00',1.64),('15844','2014-02-24','11:50:00',2.51),('15844','2014-02-24','11:55:00',2.96),('15844','2014-02-24','12:00:00',3.04),('15844','2014-02-24','12:05:00',2.99),('15844','2014-02-24','12:10:00',2.99),('15844','2014-02-24','12:15:00',2.92),('15844','2014-02-24','12:20:00',2.9),('15844','2014-02-24','12:25:00',2.89),('15844','2014-02-24','12:30:00',2.89),('15844','2014-02-24','12:35:00',2.84),('15844','2014-02-24','12:40:00',2.79),('15844','2014-02-24','12:45:00',2.81),('15844','2014-02-24','12:50:00',2.77),('15844','2014-02-24','12:55:00',2.81),('15844','2014-02-24','13:00:00',2.96),('15844','2014-02-24','13:05:00',3.18),('15844','2014-02-24','13:10:00',2.38),('15844','2014-02-24','13:15:00',1.02),('15844','2014-02-24','14:05:00',1.01),('15844','2014-02-24','14:10:00',1.13),('15844','2014-02-24','14:15:00',1.09),('15844','2014-02-24','14:20:00',1.07),('15844','2014-02-24','14:25:00',1.09),('15844','2014-02-24','15:15:00',1.14),('15844','2014-02-24','15:20:00',1.02),('15844','2014-02-23','08:10:00',1.01),('15844','2014-02-23','08:15:00',1.1),('15844','2014-02-23','08:20:00',1.18),('15844','2014-02-23','08:25:00',1.27),('15844','2014-02-23','08:30:00',1.32),('15844','2014-02-23','08:35:00',1.4),('15844','2014-02-23','08:40:00',1.46),('15844','2014-02-23','08:45:00',1.55),('15844','2014-02-23','08:50:00',1.66),('15844','2014-02-23','08:55:00',1.78),('15844','2014-02-23','09:00:00',1.86),('15844','2014-02-23','09:05:00',1.93),('15844','2014-02-23','09:10:00',2.03),('15844','2014-02-23','09:15:00',2.12),('15844','2014-02-23','09:20:00',2.12),('15844','2014-02-23','09:25:00',1.9),('15844','2014-02-23','09:30:00',2.21),('15844','2014-02-23','09:35:00',2.37),('15844','2014-02-23','09:40:00',2.42),('15844','2014-02-23','09:45:00',2.45),('15844','2014-02-23','09:50:00',2.53),('15844','2014-02-23','09:55:00',2.56),('15844','2014-02-23','10:00:00',2.58),('15844','2014-02-23','10:05:00',2.62),('15844','2014-02-23','10:10:00',2.68),('15844','2014-02-23','10:15:00',2.71),('15844','2014-02-23','10:20:00',2.74),('15844','2014-02-23','10:25:00',2.78),('15844','2014-02-23','10:30:00',2.83),('15844','2014-02-23','10:35:00',2.88),('15844','2014-02-23','10:40:00',2.91),('15844','2014-02-23','10:45:00',2.95),('15844','2014-02-23','10:50:00',2.97),('15844','2014-02-23','10:55:00',2.95),('15844','2014-02-23','11:00:00',2.92),('15844','2014-02-23','11:05:00',2.96),('15844','2014-02-23','11:10:00',2.94),('15844','2014-02-23','11:15:00',2.8),('15844','2014-02-23','11:20:00',3.05),('15844','2014-02-23','11:25:00',2.35),('15844','2014-02-23','11:30:00',2.91),('15844','2014-02-23','11:35:00',3.1),('15844','2014-02-23','11:40:00',3.09),('15844','2014-02-23','11:45:00',3.12),('15844','2014-02-23','11:50:00',2.16),('15844','2014-02-23','11:55:00',3.04),('15844','2014-02-23','12:00:00',3),('15844','2014-02-23','12:05:00',2.99),('15844','2014-02-23','12:10:00',3.17),('15844','2014-02-23','12:15:00',2.81),('15844','2014-02-23','12:20:00',1.75),('15844','2014-02-23','12:25:00',1.82),('15844','2014-02-23','12:30:00',2.11),('15844','2014-02-23','12:35:00',1.76),('15844','2014-02-23','12:40:00',1.94),('15844','2014-02-23','12:45:00',1.74),('15844','2014-02-23','12:50:00',1.81),('15844','2014-02-23','12:55:00',2.27),('15844','2014-02-23','13:00:00',2.73),('15844','2014-02-23','13:05:00',2.57),('15844','2014-02-23','13:10:00',2.47),('15844','2014-02-23','13:15:00',2.43),('15844','2014-02-23','13:20:00',2.41),('15844','2014-02-23','13:25:00',2.05),('15844','2014-02-23','13:30:00',1.84),('15844','2014-02-23','13:35:00',1.01),('15844','2014-02-23','13:40:00',1.49),('15844','2014-02-23','13:45:00',1.82),('15844','2014-02-23','13:50:00',1.46),('15844','2014-02-23','13:55:00',1.42),('15844','2014-02-23','14:00:00',1.33),('15844','2014-02-23','14:05:00',1.76),('15844','2014-02-23','14:10:00',1.13),('15844','2014-02-23','14:15:00',1.09),('15844','2014-02-23','14:20:00',1.32),('15844','2014-02-23','14:25:00',1.06),('15844','2014-02-23','14:30:00',1.21),('15844','2014-02-23','14:35:00',1.65),('15844','2014-02-23','14:40:00',1.72),('15844','2014-02-23','14:45:00',1.61),('15844','2014-02-23','14:50:00',1.28),('15844','2014-02-23','15:20:00',1.07),('15844','2014-02-23','15:25:00',1.04),('15844','2014-02-23','15:35:00',1.05),('15844','2014-02-22','09:40:00',2.26),('15844','2014-02-22','09:45:00',1.55),('15844','2014-02-22','09:50:00',1.18),('15844','2014-02-22','09:55:00',1.08),('15844','2014-02-22','10:00:00',1.2),('15844','2014-02-22','10:05:00',1.75),('15844','2014-02-22','10:10:00',1.03),('15844','2014-02-22','10:20:00',1),('15844','2014-02-22','10:25:00',1.56),('15844','2014-02-22','10:30:00',1.77),('15844','2014-02-22','10:35:00',2.58),('15844','2014-02-22','10:40:00',2.78),('15844','2014-02-22','10:45:00',1.87),('15844','2014-02-22','12:00:00',1.01),('15844','2014-02-22','12:05:00',1.2),('15844','2014-02-22','12:10:00',1.2),('15844','2014-02-22','12:15:00',1.69),('15844','2014-02-22','12:20:00',1.42),('15844','2014-02-22','12:30:00',1.14),('15844','2014-02-22','12:35:00',1.64),('15844','2014-02-22','12:40:00',2.71),('15844','2014-02-22','12:45:00',2.99),('15844','2014-02-22','12:50:00',2.59),('15844','2014-02-22','12:55:00',1.35),('15844','2014-02-22','13:00:00',1.65),('15844','2014-02-22','13:05:00',2.61),('15844','2014-02-22','13:15:00',1.25),('15844','2014-02-22','13:20:00',1.87),('15844','2014-02-22','13:25:00',1),('15844','2014-02-22','13:30:00',1.43),('15844','2014-02-22','13:35:00',2.18),('15844','2014-02-22','13:40:00',2.33),('15844','2014-02-22','13:45:00',1.06),('15844','2014-02-22','13:50:00',1.67),('15844','2014-02-22','13:55:00',1.49),('15844','2014-02-22','14:00:00',1.81),('15844','2014-02-22','14:10:00',1.51),('15844','2014-02-22','14:15:00',1.73),('15844','2014-02-22','14:20:00',1.3),('15844','2014-02-22','14:25:00',1.69),('15844','2014-02-22','14:30:00',1.11),('15844','2014-02-22','15:00:00',1.02),('15844','2014-02-22','15:05:00',1),('15844','2014-02-21','09:45:00',1.06),('15844','2014-02-21','09:50:00',1.22),('15844','2014-02-21','09:55:00',1.29),('15844','2014-02-21','10:00:00',1.19),('15844','2014-02-21','10:05:00',1.34),('15844','2014-02-21','10:10:00',1.63),('15844','2014-02-21','10:15:00',1.63),('15844','2014-02-21','10:20:00',1.71),('15844','2014-02-21','10:25:00',1.83),('15844','2014-02-21','10:30:00',1.43),('15844','2014-02-21','10:35:00',1.25),('15844','2014-02-21','10:40:00',1.69),('15844','2014-02-21','10:45:00',1.79),('15844','2014-02-21','10:50:00',3.02),('15844','2014-02-21','10:55:00',3.02),('15844','2014-02-21','11:00:00',3.29),('15844','2014-02-21','11:05:00',1.85),('15844','2014-02-21','11:10:00',1.41),('15844','2014-02-21','11:15:00',2.19),('15844','2014-02-21','11:20:00',2.14),('15844','2014-02-21','11:25:00',1.87),('15844','2014-02-21','11:30:00',2.98),('15844','2014-02-21','11:35:00',2.63),('15844','2014-02-21','11:40:00',1.6),('15844','2014-02-21','11:45:00',2.56),('15844','2014-02-21','11:50:00',1.62),('15844','2014-02-21','11:55:00',1.11),('15844','2014-02-21','12:00:00',1.17),('15844','2014-02-21','12:05:00',1.17),('15844','2014-02-21','12:10:00',1.06),('15844','2014-02-21','12:15:00',1.04),('15844','2014-02-21','14:35:00',1.1),('15844','2014-02-21','14:40:00',1.03),('15844','2014-02-20','13:15:00',1.26),('15844','2014-02-20','13:30:00',1.06),('15844','2014-02-19','09:40:00',1.02),('15844','2014-02-19','09:45:00',1.23),('15844','2014-02-19','09:50:00',1.16),('15844','2014-02-19','09:55:00',1.05),('15844','2014-02-19','10:00:00',1.07),('15844','2014-02-19','10:05:00',1.08),('15844','2014-02-19','10:10:00',1.21),('15844','2014-02-19','10:15:00',1.31),('15844','2014-02-19','10:20:00',1.19),('15844','2014-02-19','10:25:00',1.17),('15844','2014-02-19','10:30:00',1.05),('15844','2014-02-19','10:35:00',1.12),('15844','2014-02-19','10:40:00',1.32),('15844','2014-02-19','10:45:00',1.3),('15844','2014-02-19','10:50:00',1.49),('15844','2014-02-19','10:55:00',1.3),('15844','2014-02-19','12:05:00',1.1),('15844','2014-02-19','12:10:00',1.02),('15844','2014-02-19','12:40:00',1.06),('15844','2014-02-19','12:45:00',1.24),('15844','2014-02-19','12:50:00',1.37),('15844','2014-02-19','12:55:00',1.14),('15844','2014-02-19','13:00:00',1.36),('15844','2014-02-19','13:05:00',1.38),('15844','2014-02-19','13:10:00',1.25),('15844','2014-02-19','13:15:00',1.44),('15844','2014-02-19','13:20:00',1.25),('15844','2014-02-19','13:25:00',1.36),('15844','2014-02-19','13:30:00',1.23),('15844','2014-02-19','13:35:00',1.33),('15844','2014-02-19','13:40:00',1.41),('15844','2014-02-19','13:45:00',1.48),('15844','2014-02-19','13:50:00',1.4),('15844','2014-02-19','13:55:00',1.4),('15844','2014-02-19','14:00:00',1.21),('15844','2014-02-19','14:20:00',1.12),('15844','2014-02-18','08:20:00',1.06),('15844','2014-02-18','08:25:00',1.15),('15844','2014-02-18','08:30:00',1.22),('15844','2014-02-18','08:35:00',1.28),('15844','2014-02-18','08:40:00',1.36),('15844','2014-02-18','08:45:00',1.43),('15844','2014-02-18','08:50:00',1.52),('15844','2014-02-18','08:55:00',1.61),('15844','2014-02-18','09:00:00',1.69),('15844','2014-02-18','09:05:00',1.75),('15844','2014-02-18','09:10:00',1.81),('15844','2014-02-18','09:15:00',1.88),('15844','2014-02-18','09:20:00',1.95),('15844','2014-02-18','09:25:00',2.06),('15844','2014-02-18','09:30:00',2.14),('15844','2014-02-18','09:35:00',2.2),('15844','2014-02-18','09:40:00',2.25),('15844','2014-02-18','09:45:00',2.28),('15844','2014-02-18','09:50:00',2.32),('15844','2014-02-18','09:55:00',2.36),('15844','2014-02-18','10:00:00',2.41),('15844','2014-02-18','10:05:00',2.44),('15844','2014-02-18','10:10:00',2.46),('15844','2014-02-18','10:15:00',2.49),('15844','2014-02-18','10:20:00',2.49),('15844','2014-02-18','10:25:00',2.49),('15844','2014-02-18','10:30:00',2.55),('15844','2014-02-18','10:35:00',2.61),('15844','2014-02-18','10:40:00',2.68),('15844','2014-02-18','10:45:00',2.71),('15844','2014-02-18','10:50:00',2.73),('15844','2014-02-18','10:55:00',2.79),('15844','2014-02-18','11:00:00',2.82),('15844','2014-02-18','11:05:00',2.5),('15844','2014-02-18','11:10:00',2.42),('15844','2014-02-18','11:15:00',2.35),('15844','2014-02-18','11:20:00',2.68),('15844','2014-02-18','11:25:00',2.85),('15844','2014-02-18','11:30:00',2.8),('15844','2014-02-18','11:35:00',2.01),('15844','2014-02-18','11:40:00',1.38),('15844','2014-02-18','11:45:00',1.42),('15844','2014-02-18','11:50:00',1.22),('15844','2014-02-18','11:55:00',1.22),('15844','2014-02-18','12:00:00',1.22),('15844','2014-02-18','12:05:00',1.19),('15844','2014-02-18','12:10:00',1.28),('15844','2014-02-18','12:15:00',1.41),('15844','2014-02-18','12:20:00',1.46),('15844','2014-02-18','12:25:00',1.61),('15844','2014-02-18','12:30:00',1.48),('15844','2014-02-18','12:35:00',1.3),('15844','2014-02-18','12:40:00',1.21),('15844','2014-02-18','12:45:00',1.18),('15844','2014-02-18','12:50:00',1.17),('15844','2014-02-18','12:55:00',1.22),('15844','2014-02-18','13:00:00',1.1),('15844','2014-02-18','13:05:00',1.02),('15844','2014-02-18','13:10:00',1.04),('15844','2014-02-18','13:15:00',1.35),('15844','2014-02-18','13:20:00',1.68),('15844','2014-02-18','13:25:00',2.09),('15844','2014-02-18','13:30:00',1.41),('15844','2014-02-18','13:35:00',1.3),('15844','2014-02-18','13:40:00',1.54),('15844','2014-02-18','13:45:00',1.48),('15844','2014-02-18','13:50:00',1.18),('15844','2014-02-18','13:55:00',1.17),('15844','2014-02-18','14:00:00',1.21),('15844','2014-02-18','14:05:00',1.4),('15844','2014-02-18','14:10:00',1.17),('15844','2014-02-17','08:30:00',1.05),('15844','2014-02-17','08:35:00',1.13),('15844','2014-02-17','08:40:00',1.2),('15844','2014-02-17','08:45:00',1.26),('15844','2014-02-17','08:50:00',1.34),('15844','2014-02-17','08:55:00',1.41),('15844','2014-02-17','09:00:00',1.49),('15844','2014-02-17','09:05:00',1.53),('15844','2014-02-17','09:10:00',1.62),('15844','2014-02-17','09:15:00',1.7),('15844','2014-02-17','09:20:00',1.78),('15844','2014-02-17','09:25:00',1.87),('15844','2014-02-17','09:30:00',1.93),('15844','2014-02-17','09:35:00',1.98),('15844','2014-02-17','09:40:00',2.03),('15844','2014-02-17','09:45:00',2.04),('15844','2014-02-17','09:50:00',2.09),('15844','2014-02-17','09:55:00',2.13),('15844','2014-02-17','10:00:00',2.18),('15844','2014-02-17','10:05:00',2.2),('15844','2014-02-17','10:10:00',2.22),('15844','2014-02-17','10:15:00',2.23),('15844','2014-02-17','10:20:00',2.28),('15844','2014-02-17','10:25:00',2.32),('15844','2014-02-17','10:30:00',2.34),('15844','2014-02-17','10:35:00',2.34),('15844','2014-02-17','10:40:00',2.34),('15844','2014-02-17','10:45:00',2.36),('15844','2014-02-17','10:50:00',2.39),('15844','2014-02-17','10:55:00',2.38),('15844','2014-02-17','11:00:00',2.43),('15844','2014-02-17','11:05:00',2.43),('15844','2014-02-17','11:10:00',2.44),('15844','2014-02-17','11:15:00',2.45),('15844','2014-02-17','11:20:00',2.46),('15844','2014-02-17','11:25:00',2.48),('15844','2014-02-17','11:30:00',2.49),('15844','2014-02-17','11:35:00',2.54),('15844','2014-02-17','11:40:00',2.54),('15844','2014-02-17','11:45:00',2.54),('15844','2014-02-17','11:50:00',2.54),('15844','2014-02-17','11:55:00',2.52),('15844','2014-02-17','12:00:00',2.5),('15844','2014-02-17','12:05:00',2.48),('15844','2014-02-17','12:10:00',2.45),('15844','2014-02-17','12:15:00',2.44),('15844','2014-02-17','12:20:00',2.45),('15844','2014-02-17','12:25:00',2.43),('15844','2014-02-17','12:30:00',2.39),('15844','2014-02-17','12:35:00',2.37),('15844','2014-02-17','12:40:00',2.33),('15844','2014-02-17','12:45:00',2.3),('15844','2014-02-17','12:50:00',2.25),('15844','2014-02-17','12:55:00',2.21),('15844','2014-02-17','13:00:00',2.16),('15844','2014-02-17','13:05:00',2.09),('15844','2014-02-17','13:10:00',2.02),('15844','2014-02-17','13:15:00',1.97),('15844','2014-02-17','13:20:00',1.91),('15844','2014-02-17','13:25:00',1.85),('15844','2014-02-17','13:30:00',1.79),('15844','2014-02-17','13:35:00',1.69),('15844','2014-02-17','13:40:00',1.61),('15844','2014-02-17','13:45:00',1.5),('15844','2014-02-17','13:50:00',1.47),('15844','2014-02-17','13:55:00',1.4),('15844','2014-02-17','14:00:00',1.36),('15844','2014-02-17','14:05:00',1.29),('15844','2014-02-17','14:10:00',1.18),('15844','2014-02-17','14:15:00',1.18),('15844','2014-02-17','14:20:00',1.09),('15844','2014-02-17','14:25:00',1.01),('15844','2014-02-16','08:20:00',1.05),('15844','2014-02-16','08:25:00',1.1),('15844','2014-02-16','08:30:00',1.18),('15844','2014-02-16','08:35:00',1.24),('15844','2014-02-16','08:40:00',1.19),('15844','2014-02-16','08:45:00',1.32),('15844','2014-02-16','08:50:00',1.56),('15844','2014-02-16','08:55:00',1.61),('15844','2014-02-16','09:00:00',1.76),('15844','2014-02-16','09:05:00',1.82),('15844','2014-02-16','09:10:00',1.62),('15844','2014-02-16','09:15:00',1.72),('15844','2014-02-16','09:20:00',1.85),('15844','2014-02-16','09:25:00',1.96),('15844','2014-02-16','09:30:00',1.75),('15844','2014-02-16','09:35:00',2.02),('15844','2014-02-16','09:40:00',2.22),('15844','2014-02-16','09:45:00',2.28),('15844','2014-02-16','09:50:00',2.29),('15844','2014-02-16','09:55:00',2.2),('15844','2014-02-16','10:00:00',2.32),('15844','2014-02-16','10:05:00',2.47),('15844','2014-02-16','10:10:00',2.48),('15844','2014-02-16','10:15:00',2.49),('15844','2014-02-16','10:20:00',2.48),('15844','2014-02-16','10:25:00',2.53),('15844','2014-02-16','10:30:00',2.59),('15844','2014-02-16','10:35:00',2.53),('15844','2014-02-16','10:40:00',2.71),('15844','2014-02-16','10:45:00',2.56),('15844','2014-02-16','10:50:00',2.17),('15844','2014-02-16','10:55:00',2.58),('15844','2014-02-16','11:00:00',2.65),('15844','2014-02-16','11:05:00',2.59),('15844','2014-02-16','11:10:00',2.69),('15844','2014-02-16','11:15:00',2.48),('15844','2014-02-16','11:20:00',2.43),('15844','2014-02-16','11:25:00',2.4),('15844','2014-02-16','11:30:00',2.61),('15844','2014-02-16','11:35:00',2.58),('15844','2014-02-16','11:40:00',2.26),('15844','2014-02-16','11:45:00',2.58),('15844','2014-02-16','11:50:00',2.28),('15844','2014-02-16','11:55:00',2.63),('15844','2014-02-16','12:00:00',2.58),('15844','2014-02-16','12:05:00',2.59),('15844','2014-02-16','12:10:00',2.55),('15844','2014-02-16','12:15:00',2.53),('15844','2014-02-16','12:20:00',2.49),('15844','2014-02-16','12:25:00',2.46),('15844','2014-02-16','12:30:00',2.42),('15844','2014-02-16','12:35:00',2.38),('15844','2014-02-16','12:40:00',2.38),('15844','2014-02-16','12:45:00',2.34),('15844','2014-02-16','12:50:00',2.32),('15844','2014-02-16','12:55:00',2.25),('15844','2014-02-16','13:00:00',2.2),('15844','2014-02-16','13:05:00',2.14),('15844','2014-02-16','13:10:00',2.07),('15844','2014-02-16','13:15:00',2.06),('15844','2014-02-16','13:20:00',1.97),('15844','2014-02-16','13:25:00',1.92),('15844','2014-02-16','13:30:00',1.89),('15844','2014-02-16','13:35:00',1.81),('15844','2014-02-16','13:40:00',1.74),('15844','2014-02-16','13:45:00',1.59),('15844','2014-02-16','13:50:00',1.53),('15844','2014-02-16','13:55:00',1.45),('15844','2014-02-16','14:00:00',1.4),('15844','2014-02-16','14:05:00',1.3),('15844','2014-02-16','14:10:00',1.22),('15844','2014-02-16','14:15:00',1.14),('15844','2014-02-16','14:20:00',1.05),('15844','2014-04-28','08:15:00',1.07),('15844','2014-04-28','08:20:00',1.11),('15844','2014-04-28','08:25:00',1.03),('15844','2014-04-28','08:35:00',1.01),('15844','2014-04-28','08:40:00',1.11),('15844','2014-04-28','09:05:00',1.91),('15844','2014-04-28','09:10:00',1.48),('15844','2014-04-28','09:15:00',2.2),('15844','2014-04-28','09:20:00',1.79),('15844','2014-04-28','09:25:00',2.5),('15844','2014-04-28','09:30:00',2.31),('15844','2014-04-28','09:35:00',1.64),('15844','2014-04-28','09:40:00',1.17),('15844','2014-04-28','09:45:00',1.97),('15844','2014-04-28','09:50:00',1.35),('15844','2014-04-28','09:55:00',1.64),('15844','2014-04-28','10:00:00',1.72),('15844','2014-04-28','10:05:00',1.67),('15844','2014-04-28','10:10:00',1.18),('15844','2014-04-28','10:30:00',1.07),('15844','2014-04-28','10:35:00',1.38),('15844','2014-04-28','10:40:00',1.16),('15844','2014-04-28','10:45:00',1.28),('15844','2014-04-28','10:50:00',3.03),('15844','2014-04-28','10:55:00',2.89),('15844','2014-04-28','11:00:00',2.25),('15844','2014-04-28','11:05:00',2.36),('15844','2014-04-28','11:10:00',2.26),('15844','2014-04-28','11:15:00',1.52),('15844','2014-04-28','11:20:00',1.38),('15844','2014-04-28','11:25:00',1.24),('15844','2014-04-28','11:30:00',1.27),('15844','2014-04-28','11:35:00',1.3),('15844','2014-04-28','11:40:00',1.25),('15844','2014-04-28','11:45:00',1.43),('15844','2014-04-28','11:50:00',1.47),('15844','2014-04-28','11:55:00',1.56),('15844','2014-04-28','12:00:00',1.59),('15844','2014-04-28','12:05:00',1.44),('15844','2014-04-28','12:10:00',1.73),('15844','2014-04-28','12:15:00',1.75),('15844','2014-04-28','12:20:00',2.01),('15844','2014-04-28','12:25:00',2.13),('15844','2014-04-28','12:30:00',2.04),('15844','2014-04-28','12:35:00',2.12),('15844','2014-04-28','12:40:00',1.97),('15844','2014-04-28','12:45:00',1.97),('15844','2014-04-28','12:50:00',1.97),('15844','2014-04-28','12:55:00',2.07),('15844','2014-04-28','13:00:00',1.89),('15844','2014-04-28','13:05:00',1.9),('15844','2014-04-28','13:10:00',2.86),('15844','2014-04-28','13:15:00',4.29),('15844','2014-04-28','13:20:00',3.7),('15844','2014-04-28','13:25:00',2.38),('15844','2014-04-28','13:30:00',5.07),('15844','2014-04-28','13:35:00',3.71),('15844','2014-04-28','13:40:00',3.04),('15844','2014-04-28','13:45:00',2.72),('15844','2014-04-28','13:50:00',2.21),('15844','2014-04-28','13:55:00',3.13),('15844','2014-04-28','14:00:00',4.32),('15844','2014-04-28','14:05:00',3.47),('15844','2014-04-28','14:10:00',1.5),('15844','2014-04-28','14:15:00',3.2),('15844','2014-04-28','14:20:00',2.76),('15844','2014-04-28','14:25:00',3.98),('15844','2014-04-28','14:30:00',3.19),('15844','2014-04-28','14:35:00',1.5),('15844','2014-04-28','14:40:00',2.2),('15844','2014-04-28','14:45:00',1.5),('15844','2014-04-28','14:50:00',2.71),('15844','2014-04-28','14:55:00',2.56),('15844','2014-04-28','15:00:00',3.26),('15844','2014-04-28','15:05:00',2.31),('15844','2014-04-28','15:10:00',2.07),('15844','2014-04-28','15:15:00',1.45),('15844','2014-04-28','15:20:00',1.93),('15844','2014-04-28','15:25:00',1.11),('15844','2014-04-28','15:30:00',1.19),('15844','2014-04-28','15:35:00',1.29),('15844','2014-04-28','15:40:00',1.51),('15844','2014-04-28','15:45:00',1.77),('15844','2014-04-28','15:50:00',2.53),('15844','2014-04-28','15:55:00',1.73),('15844','2014-04-28','16:00:00',1.57),('15844','2014-04-28','16:10:00',1.19),('15844','2014-04-28','16:15:00',1.76),('15844','2014-04-28','16:20:00',1.58),('15844','2014-04-28','16:25:00',1.38),('15844','2014-04-28','16:50:00',1.4),('15844','2014-02-15','08:25:00',1.05),('15844','2014-02-15','08:30:00',1.11),('15844','2014-02-15','08:35:00',1.16),('15844','2014-02-15','08:40:00',1.24),('15844','2014-02-15','08:45:00',1.31),('15844','2014-02-15','08:50:00',1.26),('15844','2014-02-15','08:55:00',1.44),('15844','2014-02-15','09:00:00',1.52),('15844','2014-02-15','09:05:00',1.59),('15844','2014-02-15','09:10:00',1.67),('15844','2014-02-15','09:15:00',1.75),('15844','2014-02-15','09:20:00',1.84),('15844','2014-02-15','09:25:00',1.93),('15844','2014-02-15','09:30:00',1.99),('15844','2014-02-15','09:35:00',2.04),('15844','2014-02-15','09:40:00',2.15),('15844','2014-02-15','09:45:00',2.2),('15844','2014-02-15','09:50:00',2.23),('15844','2014-02-15','09:55:00',2.23),('15844','2014-02-15','10:00:00',2.24),('15844','2014-02-15','10:05:00',2.25),('15844','2014-02-15','10:10:00',2.27),('15844','2014-02-15','10:15:00',2.26),('15844','2014-02-15','10:20:00',2.26),('15844','2014-02-15','10:25:00',2.26),('15844','2014-02-15','10:30:00',2.36),('15844','2014-02-15','10:35:00',2.45),('15844','2014-02-15','10:40:00',2.47),('15844','2014-02-15','10:45:00',2.47),('15844','2014-02-15','10:50:00',2.49),('15844','2014-02-15','10:55:00',2.52),('15844','2014-02-15','11:00:00',2.51),('15844','2014-02-15','11:05:00',2.5),('15844','2014-02-15','11:10:00',2.5),('15844','2014-02-15','11:15:00',2.51),('15844','2014-02-15','11:20:00',2.52),('15844','2014-02-15','11:25:00',2.51),('15844','2014-02-15','11:30:00',2.65),('15844','2014-02-15','11:35:00',2.6),('15844','2014-02-15','11:40:00',2.12),('15844','2014-02-15','11:45:00',1.43),('15844','2014-02-15','11:50:00',2.99),('15844','2014-02-15','11:55:00',2.12),('15844','2014-02-15','12:00:00',2.64),('15844','2014-02-15','12:05:00',2.68),('15844','2014-02-15','12:10:00',2.66),('15844','2014-02-15','12:15:00',2.63),('15844','2014-02-15','12:20:00',2.64),('15844','2014-02-15','12:25:00',2.61),('15844','2014-02-15','12:30:00',2.56),('15844','2014-02-15','12:35:00',2.56),('15844','2014-02-15','12:40:00',2.5),('15844','2014-02-15','12:45:00',2.44),('15844','2014-02-15','12:50:00',2.38),('15844','2014-02-15','12:55:00',2.35),('15844','2014-02-15','13:00:00',2.25),('15844','2014-02-15','13:05:00',2.2),('15844','2014-02-15','13:10:00',2.16),('15844','2014-02-15','13:15:00',2.07),('15844','2014-02-15','13:20:00',1.98),('15844','2014-02-15','13:25:00',1.89),('15844','2014-02-15','13:30:00',1.74),('15844','2014-02-15','13:35:00',1.68),('15844','2014-02-15','13:40:00',1.59),('15844','2014-02-15','13:45:00',1.49),('15844','2014-02-15','13:50:00',1.44),('15844','2014-02-15','13:55:00',1.35),('15844','2014-02-15','14:00:00',1.29),('15844','2014-02-15','14:05:00',1.24),('15844','2014-02-15','14:10:00',1.13),('15844','2014-02-15','14:15:00',1.09),('15844','2014-02-15','14:20:00',1.01),('15844','2014-02-14','08:35:00',1.12),('15844','2014-02-14','08:40:00',1.3),('15844','2014-02-14','08:45:00',1.39),('15844','2014-02-14','08:50:00',1.45),('15844','2014-02-14','08:55:00',1.53),('15844','2014-02-14','09:00:00',1.61),('15844','2014-02-14','09:05:00',1.68),('15844','2014-02-14','09:10:00',1.63),('15844','2014-02-14','09:20:00',1.5),('15844','2014-02-14','09:25:00',2.23),('15844','2014-02-14','09:30:00',1.75),('15844','2014-02-14','09:35:00',2.01),('15844','2014-02-14','09:40:00',2.11),('15844','2014-02-14','09:45:00',2.23),('15844','2014-02-14','09:50:00',2.25),('15844','2014-02-14','09:55:00',2.05),('15844','2014-02-14','10:00:00',2.45),('15844','2014-02-14','10:05:00',2.45),('15844','2014-02-14','10:10:00',2.39),('15844','2014-02-14','10:15:00',2.01),('15844','2014-02-14','10:20:00',2.2),('15844','2014-02-14','10:25:00',2.37),('15844','2014-02-14','10:30:00',2.51),('15844','2014-02-14','10:35:00',2.69),('15844','2014-02-14','10:40:00',2.73),('15844','2014-02-14','10:45:00',2.68),('15844','2014-02-14','10:50:00',2.73),('15844','2014-02-14','10:55:00',2.78),('15844','2014-02-14','11:00:00',2.78),('15844','2014-02-14','11:05:00',2.8),('15844','2014-02-14','11:10:00',2.75),('15844','2014-02-14','11:15:00',2.8),('15844','2014-02-14','11:20:00',2.79),('15844','2014-02-14','11:25:00',2.8),('15844','2014-02-14','11:30:00',2.78),('15844','2014-02-14','11:35:00',2.79),('15844','2014-02-14','11:40:00',2.68),('15844','2014-02-14','11:45:00',2.78),('15844','2014-02-14','11:50:00',2.77),('15844','2014-02-14','11:55:00',2.74),('15844','2014-02-14','12:00:00',2.73),('15844','2014-02-14','12:05:00',2.69),('15844','2014-02-14','12:10:00',2.67),('15844','2014-02-14','12:15:00',2.64),('15844','2014-02-14','12:20:00',2.63),('15844','2014-02-14','12:25:00',2.61),('15844','2014-02-14','12:30:00',2.57),('15844','2014-02-14','12:35:00',2.53),('15844','2014-02-14','12:40:00',2.5),('15844','2014-02-14','12:45:00',2.44),('15844','2014-02-14','12:50:00',2.4),('15844','2014-02-14','12:55:00',2.33),('15844','2014-02-14','13:00:00',2.28),('15844','2014-02-14','13:05:00',2.22),('15844','2014-02-14','13:10:00',2.16),('15844','2014-02-14','13:15:00',2.08),('15844','2014-02-14','13:20:00',2.01),('15844','2014-02-14','13:25:00',1.9),('15844','2014-02-14','13:30:00',1.77),('15844','2014-02-14','13:35:00',1.71),('15844','2014-02-14','13:40:00',1.63),('15844','2014-02-14','13:45:00',1.59),('15844','2014-02-14','13:50:00',1.51),('15844','2014-02-14','13:55:00',1.41),('15844','2014-02-14','14:00:00',1.31),('15844','2014-02-14','14:05:00',1.24),('15844','2014-02-14','14:10:00',1.17),('15844','2014-02-14','14:15:00',1.09),('15844','2014-02-14','14:20:00',1.01),('15844','2014-02-13','08:30:00',1.07),('15844','2014-02-13','08:35:00',1.13),('15844','2014-02-13','08:40:00',1.23),('15844','2014-02-13','08:45:00',1.29),('15844','2014-02-13','08:50:00',1.4),('15844','2014-02-13','08:55:00',1.48),('15844','2014-02-13','09:00:00',1.55),('15844','2014-02-13','09:05:00',1.64),('15844','2014-02-13','09:10:00',1.74),('15844','2014-02-13','09:15:00',1.83),('15844','2014-02-13','09:20:00',1.87),('15844','2014-02-13','09:25:00',1.95),('15844','2014-02-13','09:30:00',2.01),('15844','2014-02-13','09:35:00',2.05),('15844','2014-02-13','09:40:00',2.11),('15844','2014-02-13','09:45:00',2.15),('15844','2014-02-13','09:50:00',2.2),('15844','2014-02-13','09:55:00',2.23),('15844','2014-02-13','10:00:00',2.27),('15844','2014-02-13','10:05:00',2.27),('15844','2014-02-13','10:10:00',2.3),('15844','2014-02-13','10:15:00',2.36),('15844','2014-02-13','10:20:00',2.39),('15844','2014-02-13','10:25:00',2.43),('15844','2014-02-13','10:30:00',2.47),('15844','2014-02-13','10:35:00',2.49),('15844','2014-02-13','10:40:00',2.5),('15844','2014-02-13','10:45:00',2.52),('15844','2014-02-13','10:50:00',2.6),('15844','2014-02-13','10:55:00',2.62),('15844','2014-02-13','11:00:00',2.26),('15844','2014-02-13','11:05:00',2.74),('15844','2014-02-13','11:10:00',2.73),('15844','2014-02-13','11:15:00',2.65),('15844','2014-02-13','11:20:00',2.67),('15844','2014-02-13','11:25:00',1.63),('15844','2014-02-13','11:45:00',1.07),('15844','2014-02-13','11:50:00',2.75),('15844','2014-02-13','11:55:00',2.35),('15844','2014-02-13','12:00:00',2.57),('15844','2014-02-13','12:05:00',2.3),('15844','2014-02-13','12:10:00',2.8),('15844','2014-02-13','12:15:00',1.73),('15844','2014-02-13','12:25:00',1.77),('15844','2014-02-13','12:30:00',1.64),('15844','2014-02-13','12:35:00',2.14),('15844','2014-02-13','12:40:00',2.76),('15844','2014-02-13','12:45:00',2.59),('15844','2014-02-13','12:50:00',2.45),('15844','2014-02-13','12:55:00',2.38),('15844','2014-02-13','13:00:00',2.39),('15844','2014-02-13','13:05:00',2.27),('15844','2014-02-13','13:10:00',2.18),('15844','2014-02-13','13:15:00',2.09),('15844','2014-02-13','13:20:00',1.98),('15844','2014-02-13','13:25:00',1.89),('15844','2014-02-13','13:30:00',1.85),('15844','2014-02-13','13:35:00',1.76),('15844','2014-02-13','13:40:00',1.67),('15844','2014-02-13','13:45:00',1.59),('15844','2014-02-13','13:50:00',1.5),('15844','2014-02-13','13:55:00',1.4),('15844','2014-02-13','14:00:00',1.32),('15844','2014-02-13','14:05:00',1.25),('15844','2014-02-13','14:10:00',1.21),('15844','2014-02-13','14:15:00',1.11),('15844','2014-02-13','14:20:00',1.02),('15844','2014-02-12','08:25:00',1.03),('15844','2014-02-12','08:40:00',1.28),('15844','2014-02-12','08:45:00',1.37),('15844','2014-02-12','08:50:00',1.47),('15844','2014-02-12','08:55:00',1.59),('15844','2014-02-12','09:00:00',1.53),('15844','2014-02-12','09:05:00',1.74),('15844','2014-02-12','09:10:00',1.83),('15844','2014-02-12','09:15:00',1.94),('15844','2014-02-12','09:20:00',2.02),('15844','2014-02-12','09:25:00',2.02),('15844','2014-02-12','09:30:00',1.03),('15844','2014-02-12','09:35:00',1.1),('15844','2014-02-12','09:40:00',1.15),('15844','2014-02-12','09:45:00',1.65),('15844','2014-02-12','10:00:00',1.17),('15844','2014-02-12','10:05:00',1.14),('15844','2014-02-12','10:40:00',1.07),('15844','2014-02-12','10:45:00',1.09),('15844','2014-02-12','10:50:00',1.05),('15844','2014-02-12','10:55:00',1.03),('15844','2014-02-12','11:00:00',1.06),('15844','2014-02-12','11:05:00',1.02),('15844','2014-02-12','11:10:00',1.01),('15844','2014-02-12','11:15:00',1.05),('15844','2014-02-12','11:35:00',1.46),('15844','2014-02-12','11:40:00',1.89),('15844','2014-02-12','11:45:00',2.46),('15844','2014-02-12','11:50:00',1.11),('15844','2014-02-12','12:10:00',1.02),('15844','2014-02-12','12:15:00',1.09),('15844','2014-02-12','12:20:00',1.09),('15844','2014-02-12','12:25:00',1.07),('15844','2014-02-12','12:30:00',1.13),('15844','2014-02-12','12:35:00',1.15),('15844','2014-02-12','12:40:00',1.17),('15844','2014-02-12','12:45:00',1.31),('15844','2014-02-12','12:50:00',1.47),('15844','2014-02-12','12:55:00',1.53),('15844','2014-02-12','13:00:00',1.24),('15844','2014-02-12','13:05:00',1.29),('15844','2014-02-12','13:10:00',1.35),('15844','2014-02-12','13:15:00',1.22),('15844','2014-02-12','13:20:00',1.23),('15844','2014-02-12','13:25:00',1.18),('15844','2014-02-12','13:30:00',1.06),('15844','2014-02-12','13:35:00',1.1),('15844','2014-02-12','13:40:00',1.05),('15844','2014-02-12','13:50:00',1.03),('15844','2014-02-12','13:55:00',1.21),('15844','2014-02-12','14:00:00',1.63),('15844','2014-02-12','14:05:00',1.67),('15844','2014-02-12','14:30:00',1.05),('15844','2014-02-11','09:30:00',1.02),('15844','2014-02-11','09:45:00',1.03),('15844','2014-02-11','09:50:00',1.04),('15844','2014-02-11','10:10:00',1.03),('15844','2014-02-11','10:15:00',1.29),('15844','2014-02-11','10:20:00',1.52),('15844','2014-02-11','10:25:00',1.74),('15844','2014-02-11','10:30:00',1.83),('15844','2014-02-11','10:35:00',1.81),('15844','2014-02-11','10:40:00',1.57),('15844','2014-02-11','10:45:00',1.69),('15844','2014-02-11','10:50:00',1.91),('15844','2014-02-11','10:55:00',1.67),('15844','2014-02-11','11:00:00',1.82),('15844','2014-02-11','11:05:00',2.1),('15844','2014-02-11','11:10:00',1.97),('15844','2014-02-11','11:15:00',2.07),('15844','2014-02-11','11:20:00',2.11),('15844','2014-02-11','11:25:00',1.75),('15844','2014-02-11','11:30:00',2.11),('15844','2014-02-11','11:35:00',2.06),('15844','2014-02-11','11:40:00',2.09),('15844','2014-02-11','11:45:00',1.86),('15844','2014-02-11','11:50:00',1.76),('15844','2014-02-11','11:55:00',1.48),('15844','2014-02-11','12:00:00',1.38),('15844','2014-02-11','12:05:00',1.4),('15844','2014-02-11','12:10:00',1.83),('15844','2014-02-11','12:15:00',1.43),('15844','2014-02-11','12:20:00',1.23),('15844','2014-02-11','12:25:00',1.53),('15844','2014-02-11','12:30:00',1.74),('15844','2014-02-11','12:35:00',1.79),('15844','2014-02-11','12:40:00',1.16),('15844','2014-02-11','12:45:00',1.48),('15844','2014-02-11','12:50:00',1.26),('15844','2014-02-11','12:55:00',1.28),('15844','2014-02-11','13:00:00',1.63),('15844','2014-02-11','13:05:00',1.58),('15844','2014-02-11','13:10:00',2.27),('15844','2014-02-11','13:15:00',2.15),('15844','2014-02-11','13:20:00',2.04),('15844','2014-02-11','13:25:00',1.74),('15844','2014-02-11','13:30:00',1.61),('15844','2014-02-11','13:35:00',1.57),('15844','2014-02-11','13:40:00',1.64),('15844','2014-02-11','13:45:00',1.37),('15844','2014-02-11','13:50:00',1.3),('15844','2014-02-11','13:55:00',1.01),('15844','2014-02-11','14:05:00',1.13),('15844','2014-02-11','14:10:00',1.13),('15844','2014-02-11','14:15:00',1.08),('15844','2014-02-11','14:20:00',1.05),('15844','2014-02-09','12:05:00',1.17),('15844','2014-02-09','12:10:00',2.23),('15844','2014-02-09','12:20:00',1.18),('15844','2014-02-09','12:25:00',1.86),('15844','2014-02-09','12:30:00',1.2),('15844','2014-02-09','12:40:00',1.43),('15844','2014-02-09','12:55:00',2.19),('15844','2014-02-09','13:10:00',1.01),('15844','2014-02-09','13:40:00',1.72),('15844','2014-02-09','13:45:00',1.08),('15844','2014-02-09','13:50:00',1.16),('15844','2014-02-09','13:55:00',1.19),('15844','2014-02-09','14:00:00',1.34),('15844','2014-02-08','09:40:00',1.02),('15844','2014-02-08','09:50:00',1.65),('15844','2014-02-08','09:55:00',2.27),('15844','2014-02-08','10:00:00',1.52),('15844','2014-02-08','10:05:00',1.49),('15844','2014-02-08','10:10:00',2.39),('15844','2014-02-08','10:15:00',1.89),('15844','2014-02-08','10:20:00',1.41),('15844','2014-02-08','10:30:00',1.29),('15844','2014-02-08','10:40:00',1.57),('15844','2014-02-08','10:45:00',1.63),('15844','2014-02-08','10:50:00',1.27),('15844','2014-02-08','10:55:00',2.4),('15844','2014-02-08','11:00:00',1.98),('15844','2014-02-08','11:05:00',1.65),('15844','2014-02-08','11:10:00',2.69),('15844','2014-02-08','11:15:00',3.12),('15844','2014-02-08','11:20:00',1.64),('15844','2014-02-08','11:25:00',1.4),('15844','2014-02-08','11:30:00',1.14),('15844','2014-02-08','11:40:00',1.11),('15844','2014-02-08','11:45:00',1.31),('15844','2014-02-08','11:55:00',1.73),('15844','2014-02-08','12:00:00',2.15),('15844','2014-02-08','12:15:00',1.94),('15844','2014-02-08','12:20:00',1.78),('15844','2014-02-08','12:30:00',1.01),('15844','2014-02-08','12:35:00',1.12),('15844','2014-02-08','12:40:00',1.22),('15844','2014-02-08','12:45:00',2.82),('15844','2014-02-08','12:50:00',2.62),('15844','2014-02-08','12:55:00',1.91),('15844','2014-02-08','13:00:00',2.08),('15844','2014-02-08','13:05:00',1.52),('15844','2014-02-08','13:10:00',1.23),('15844','2014-02-08','13:15:00',2.54),('15844','2014-02-08','13:20:00',1.07),('15844','2014-02-08','13:30:00',1.82),('15844','2014-02-08','13:35:00',1.1),('15844','2014-02-08','13:40:00',1.79),('15844','2014-02-08','13:45:00',1.25),('15844','2014-02-08','13:50:00',1.19),('15844','2014-02-08','13:55:00',1.59),('15844','2014-02-08','14:00:00',1.21),('15844','2014-02-08','14:10:00',1.17),('15844','2014-02-08','14:15:00',1.06),('15844','2014-02-08','14:30:00',1.23),('15844','2014-02-07','08:35:00',1.05),('15844','2014-02-07','08:40:00',1.15),('15844','2014-02-07','08:45:00',1.24),('15844','2014-02-07','08:50:00',1.31),('15844','2014-02-07','08:55:00',1.38),('15844','2014-02-07','09:00:00',1.45),('15844','2014-02-07','09:05:00',1.52),('15844','2014-02-07','09:10:00',1.6),('15844','2014-02-07','09:15:00',1.67),('15844','2014-02-07','09:20:00',1.73),('15844','2014-02-07','09:25:00',1.79),('15844','2014-02-07','09:30:00',1.84),('15844','2014-02-07','09:35:00',1.89),('15844','2014-02-07','09:40:00',1.93),('15844','2014-02-07','09:45:00',1.95),('15844','2014-02-07','09:50:00',1.96),('15844','2014-02-07','09:55:00',1.84),('15844','2014-02-07','10:20:00',1.31),('15844','2014-02-07','10:25:00',1.54),('15844','2014-02-07','10:30:00',1.35),('15844','2014-02-07','10:55:00',2.27),('15844','2014-02-07','11:00:00',1.83),('15844','2014-02-07','11:05:00',2.51),('15844','2014-02-07','11:10:00',3.22),('15844','2014-02-07','11:15:00',2.76),('15844','2014-02-07','11:20:00',2.28),('15844','2014-02-07','11:25:00',2.18),('15844','2014-02-07','11:30:00',2.12),('15844','2014-02-07','11:35:00',2.64),('15844','2014-02-07','11:40:00',1.05),('15844','2014-02-07','11:45:00',2.56),('15844','2014-02-07','11:50:00',1.43),('15844','2014-02-07','12:00:00',1.92),('15844','2014-02-07','12:05:00',2.37),('15844','2014-02-07','12:10:00',1.44),('15844','2014-02-07','12:15:00',2.17),('15844','2014-02-07','12:20:00',2.62),('15844','2014-02-07','12:25:00',2.75),('15844','2014-02-07','12:30:00',2.06),('15844','2014-02-07','12:35:00',2.32),('15844','2014-02-07','12:40:00',2.36),('15844','2014-02-07','12:45:00',2.51),('15844','2014-02-07','12:50:00',2.63),('15844','2014-02-07','12:55:00',2.21),('15844','2014-02-07','13:00:00',1.69),('15844','2014-02-07','13:05:00',2.24),('15844','2014-02-07','13:10:00',2.03),('15844','2014-02-07','13:15:00',2.08),('15844','2014-02-07','13:20:00',1.28),('15844','2014-02-07','13:25:00',1.81),('15844','2014-02-07','13:30:00',1.87),('15844','2014-02-07','13:35:00',1.52),('15844','2014-02-07','13:40:00',1.59),('15844','2014-02-07','13:45:00',1.5),('15844','2014-02-07','13:50:00',1.39),('15844','2014-02-07','13:55:00',1.3),('15844','2014-02-07','14:10:00',1.16),('15844','2014-02-06','08:45:00',1.22),('15844','2014-02-06','08:50:00',1.38),('15844','2014-02-06','08:55:00',1.56),('15844','2014-02-06','09:00:00',1.74),('15844','2014-02-06','09:05:00',1.8),('15844','2014-02-06','09:10:00',1.49),('15844','2014-02-06','09:20:00',2.02),('15844','2014-02-06','09:25:00',1.41),('15844','2014-02-06','09:30:00',1.52),('15844','2014-02-06','09:35:00',1.99),('15844','2014-02-06','09:40:00',1.75),('15844','2014-02-06','09:45:00',1.79),('15844','2014-02-06','09:50:00',2.13),('15844','2014-02-06','09:55:00',2.16),('15844','2014-02-06','10:00:00',2.19),('15844','2014-02-06','10:05:00',2.23),('15844','2014-02-06','10:10:00',2.26),('15844','2014-02-06','10:15:00',1.96),('15844','2014-02-06','10:20:00',2.24),('15844','2014-02-06','10:25:00',2.37),('15844','2014-02-06','10:30:00',2.6),('15844','2014-02-06','10:35:00',1.82),('15844','2014-02-06','10:40:00',2.4),('15844','2014-02-06','10:45:00',2.36),('15844','2014-02-06','10:50:00',1.21),('15844','2014-02-06','10:55:00',2.86),('15844','2014-02-06','11:00:00',2.02),('15844','2014-02-06','11:05:00',2.77),('15844','2014-02-06','11:10:00',2.82),('15844','2014-02-06','11:15:00',2.21),('15844','2014-02-06','11:20:00',2.73),('15844','2014-02-06','11:25:00',2.7),('15844','2014-02-06','11:30:00',2.68),('15844','2014-02-06','11:35:00',2.65),('15844','2014-02-06','11:40:00',2.64),('15844','2014-02-06','11:45:00',2.62),('15844','2014-02-06','11:50:00',2.62),('15844','2014-02-06','11:55:00',2.59),('15844','2014-02-06','12:00:00',2.58),('15844','2014-02-06','12:05:00',2.6),('15844','2014-02-06','12:10:00',2.54),('15844','2014-02-06','12:15:00',2.54),('15844','2014-02-06','12:20:00',2.41),('15844','2014-02-06','12:25:00',2.47),('15844','2014-02-06','12:30:00',2.44),('15844','2014-02-06','12:35:00',2.4),('15844','2014-02-06','12:40:00',2.36),('15844','2014-02-06','12:45:00',2.3),('15844','2014-02-06','12:50:00',2.25),('15844','2014-02-06','12:55:00',2.22),('15844','2014-02-06','13:00:00',2.14),('15844','2014-02-06','13:05:00',2.06),('15844','2014-02-06','13:10:00',2),('15844','2014-02-06','13:15:00',1.92),('15844','2014-02-06','13:20:00',1.86),('15844','2014-02-06','13:25:00',1.9),('15844','2014-02-06','13:30:00',1.76),('15844','2014-02-06','13:35:00',1.64),('15844','2014-02-06','13:40:00',1.54),('15844','2014-02-06','13:45:00',1.46),('15844','2014-02-06','13:50:00',1.37),('15844','2014-02-06','13:55:00',1.29),('15844','2014-02-06','14:00:00',1.2),('15844','2014-02-06','14:10:00',1.04),('15844','2014-02-06','14:15:00',1.01),('15844','2014-04-27','08:45:00',1.01),('15844','2014-04-27','09:10:00',1),('15844','2014-04-27','10:15:00',1.24),('15844','2014-04-27','10:20:00',1.35),('15844','2014-04-27','10:35:00',1.1),('15844','2014-04-27','10:40:00',1.15),('15844','2014-04-27','10:45:00',1.02),('15844','2014-04-27','10:50:00',1.11),('15844','2014-04-27','11:25:00',1.71),('15844','2014-04-27','11:30:00',1.63),('15844','2014-04-27','11:40:00',1.13),('15844','2014-04-27','11:45:00',2.16),('15844','2014-04-27','11:50:00',1.57),('15844','2014-04-27','11:55:00',1.34),('15844','2014-04-27','12:10:00',1.24),('15844','2014-04-27','12:15:00',2.21),('15844','2014-04-27','12:20:00',2.58),('15844','2014-04-27','12:25:00',2.31),('15844','2014-04-27','12:30:00',2.32),('15844','2014-04-27','12:35:00',2.26),('15844','2014-04-27','12:40:00',2.31),('15844','2014-04-27','12:45:00',2.74),('15844','2014-04-27','12:50:00',2.22),('15844','2014-04-27','12:55:00',2.1),('15844','2014-04-27','13:00:00',1.92),('15844','2014-04-27','13:05:00',1.95),('15844','2014-04-27','13:10:00',1.81),('15844','2014-04-27','13:15:00',1.97),('15844','2014-04-27','13:20:00',1.95),('15844','2014-04-27','13:25:00',1.55),('15844','2014-04-27','13:30:00',1.63),('15844','2014-04-27','13:35:00',1.47),('15844','2014-04-27','13:40:00',1.56),('15844','2014-04-27','13:45:00',1.67),('15844','2014-04-27','13:50:00',1.62),('15844','2014-04-27','13:55:00',2.17),('15844','2014-04-27','14:00:00',2.58),('15844','2014-04-27','14:05:00',1.8),('15844','2014-04-27','14:10:00',1.21),('15844','2014-04-27','14:15:00',1.54),('15844','2014-04-27','14:20:00',1.93),('15844','2014-04-27','14:25:00',2.14),('15844','2014-04-27','14:30:00',1.99),('15844','2014-04-27','14:35:00',2.57),('15844','2014-04-27','14:40:00',2.45),('15844','2014-04-27','14:45:00',1.84),('15844','2014-04-27','14:50:00',1.58),('15844','2014-04-27','14:55:00',1.67),('15844','2014-04-27','15:00:00',2.1),('15844','2014-04-27','15:05:00',2.46),('15844','2014-04-27','15:10:00',2.3),('15844','2014-04-27','15:15:00',1.87),('15844','2014-04-27','15:20:00',1.08),('15844','2014-02-05','10:15:00',1.41),('15844','2014-02-05','10:20:00',2.43),('15844','2014-02-05','10:25:00',2.19),('15844','2014-02-05','10:30:00',2.46),('15844','2014-02-05','10:35:00',2.51),('15844','2014-02-05','10:40:00',2.23),('15844','2014-02-05','10:45:00',1.7),('15844','2014-02-05','10:50:00',1.46),('15844','2014-02-05','11:00:00',1.96),('15844','2014-02-05','11:05:00',1.38),('15844','2014-02-05','11:10:00',1.08),('15844','2014-02-05','11:20:00',1.48),('15844','2014-02-05','12:40:00',1.05),('15844','2014-02-05','12:45:00',1.83),('15844','2014-02-05','12:50:00',1.65),('15844','2014-02-05','12:55:00',1.58),('15844','2014-02-05','13:00:00',1.62),('15844','2014-02-05','13:05:00',1.62),('15844','2014-02-05','13:10:00',1.27),('15844','2014-02-05','13:15:00',1.06),('15844','2014-02-05','13:25:00',1.04),('15844','2014-02-05','13:30:00',1.2),('15844','2014-02-05','13:35:00',1.25),('15844','2014-02-05','13:40:00',1.41),('15844','2014-02-05','13:45:00',1.46),('15844','2014-02-05','13:50:00',1.07),('15844','2014-02-05','14:20:00',1.15),('15844','2014-02-05','14:25:00',1.26),('15844','2014-02-04','09:35:00',1.65),('15844','2014-02-04','09:40:00',2.14),('15844','2014-02-04','09:45:00',2.07),('15844','2014-02-04','09:50:00',2.05),('15844','2014-02-04','09:55:00',1.7),('15844','2014-02-04','10:00:00',2.07),('15844','2014-02-04','10:05:00',1.52),('15844','2014-02-04','10:10:00',1.6),('15844','2014-02-04','10:15:00',1.98),('15844','2014-02-04','10:20:00',2.63),('15844','2014-02-04','10:25:00',2.28),('15844','2014-02-04','10:30:00',1.01),('15844','2014-02-04','10:35:00',1.26),('15844','2014-02-04','10:40:00',2.09),('15844','2014-02-04','10:45:00',1.76),('15844','2014-02-04','10:50:00',1.46),('15844','2014-02-04','10:55:00',1.5),('15844','2014-02-04','11:00:00',1.11),('15844','2014-02-04','11:05:00',2.05),('15844','2014-02-04','11:10:00',3.01),('15844','2014-02-04','11:15:00',3.1),('15844','2014-02-04','11:20:00',2.01),('15844','2014-02-04','11:25:00',2.26),('15844','2014-02-04','11:30:00',1.37),('15844','2014-02-04','11:35:00',1.09),('15844','2014-02-04','11:50:00',1.11),('15844','2014-02-04','11:55:00',1.21),('15844','2014-02-04','12:00:00',1.3),('15844','2014-02-04','12:05:00',1.38),('15844','2014-02-04','12:10:00',1.08),('15844','2014-02-04','12:55:00',1.23),('15844','2014-02-04','13:00:00',1.22),('15844','2014-02-04','13:05:00',1.09),('15844','2014-02-04','13:10:00',1.24),('15844','2014-02-04','13:15:00',1.12),('15844','2014-02-03','11:40:00',1.03),('15844','2014-02-03','11:45:00',1.15),('15844','2014-02-03','11:50:00',1.18),('15844','2014-02-03','11:55:00',1.15),('15844','2014-02-03','12:00:00',1.08),('15844','2014-02-03','12:05:00',1.08),('15844','2014-02-03','12:10:00',1),('15844','2014-02-01','11:10:00',1.07),('15844','2014-02-01','11:15:00',1.58),('15844','2014-02-01','11:20:00',1.7),('15844','2014-02-01','11:25:00',1.59),('15844','2014-02-01','11:30:00',1.66),('15844','2014-02-01','11:35:00',1.72),('15844','2014-02-01','11:40:00',1.54),('15844','2014-02-01','11:45:00',1.33),('15844','2014-02-01','12:05:00',1.2),('15844','2014-02-01','12:10:00',1.17),('15844','2014-02-01','12:25:00',1.34),('15844','2014-02-01','12:30:00',1.62),('15844','2014-02-01','12:35:00',1.6),('15844','2014-02-01','12:40:00',1.59),('15844','2014-02-01','12:45:00',1.69),('15844','2014-02-01','12:50:00',1.62),('15844','2014-02-01','12:55:00',1.34),('15844','2014-01-30','09:55:00',1.48),('15844','2014-01-30','10:00:00',1.38),('15844','2014-01-30','10:05:00',1.01),('15844','2014-01-30','10:10:00',1.34),('15844','2014-01-30','10:15:00',1.42),('15844','2014-01-30','10:20:00',1.3),('15844','2014-01-30','10:25:00',1.18),('15844','2014-01-30','10:30:00',1.78),('15844','2014-01-30','10:35:00',2.19),('15844','2014-01-30','10:40:00',2.05),('15844','2014-01-30','10:45:00',1.78),('15844','2014-01-30','10:50:00',1.67),('15844','2014-01-30','10:55:00',1.01),('15844','2014-01-30','11:00:00',1.5),('15844','2014-01-30','11:05:00',2.22),('15844','2014-01-30','11:10:00',2.69),('15844','2014-01-30','11:15:00',2.3),('15844','2014-01-30','11:20:00',2.39),('15844','2014-01-30','11:25:00',2.41),('15844','2014-01-30','11:30:00',2.04),('15844','2014-01-30','11:35:00',2.37),('15844','2014-01-30','11:40:00',2.47),('15844','2014-01-30','11:45:00',2.44),('15844','2014-01-30','11:50:00',2.35),('15844','2014-01-30','11:55:00',1.98),('15844','2014-01-30','12:00:00',2.24),('15844','2014-01-30','12:05:00',2.39),('15844','2014-01-30','12:10:00',2.54),('15844','2014-01-30','12:15:00',2.44),('15844','2014-01-30','12:20:00',1.94),('15844','2014-01-30','12:25:00',1.83),('15844','2014-01-30','12:30:00',1.87),('15844','2014-01-30','12:35:00',2.08),('15844','2014-01-30','12:40:00',2.01),('15844','2014-01-30','12:45:00',2.02),('15844','2014-01-30','12:50:00',2),('15844','2014-01-30','12:55:00',2),('15844','2014-01-30','13:00:00',1.9),('15844','2014-01-30','13:05:00',1.85),('15844','2014-01-30','13:10:00',1.79),('15844','2014-01-30','13:15:00',1.72),('15844','2014-01-30','13:20:00',1.66),('15844','2014-01-30','13:25:00',1.42),('15844','2014-01-30','13:30:00',1.23),('15844','2014-01-30','13:35:00',1.21),('15844','2014-01-30','13:40:00',1.4),('15844','2014-01-30','13:45:00',1.48),('15844','2014-01-30','13:50:00',1.31),('15844','2014-01-30','13:55:00',1.05),('15844','2014-01-29','09:15:00',1.13),('15844','2014-01-29','09:20:00',1.23),('15844','2014-01-29','09:25:00',1.01),('15844','2014-01-29','09:30:00',1.27),('15844','2014-01-29','09:35:00',1.18),('15844','2014-01-29','09:40:00',1.3),('15844','2014-01-29','09:45:00',1.22),('15844','2014-01-29','10:00:00',1.3),('15844','2014-01-29','10:05:00',2.09),('15844','2014-01-29','10:10:00',1.44),('15844','2014-01-29','10:15:00',1.69),('15844','2014-01-29','10:20:00',2.01),('15844','2014-01-29','10:25:00',2.34),('15844','2014-01-29','10:30:00',2.7),('15844','2014-01-29','10:35:00',2.18),('15844','2014-01-29','10:40:00',1.71),('15844','2014-01-29','10:45:00',1.52),('15844','2014-01-29','10:50:00',1.46),('15844','2014-01-29','10:55:00',1.45),('15844','2014-01-29','11:00:00',1.89),('15844','2014-01-29','11:05:00',1.73),('15844','2014-01-29','11:10:00',1.59),('15844','2014-01-29','11:15:00',1.82),('15844','2014-01-29','11:20:00',1.81),('15844','2014-01-29','11:25:00',2.41),('15844','2014-01-29','11:30:00',1.49),('15844','2014-01-29','11:35:00',1.08),('15844','2014-01-29','12:40:00',1.62),('15844','2014-01-29','12:45:00',2.38),('15844','2014-01-29','12:50:00',1.87),('15844','2014-01-29','12:55:00',1.96),('15844','2014-01-29','13:00:00',1.55),('15844','2014-01-29','13:30:00',1.01),('15844','2014-01-29','13:35:00',1.68),('15844','2014-01-29','13:40:00',1.71),('15844','2014-01-29','13:45:00',1.44),('15844','2014-01-29','13:50:00',1.1),('15844','2014-01-29','13:55:00',1.05),('15844','2014-01-28','09:05:00',1.12),('15844','2014-01-28','09:20:00',1.07),('15844','2014-01-28','09:25:00',1.24),('15844','2014-01-28','09:30:00',1.21),('15844','2014-01-28','09:35:00',1.12),('15844','2014-01-28','09:40:00',1.24),('15844','2014-01-28','09:45:00',1.44),('15844','2014-01-28','09:50:00',1.69),('15844','2014-01-28','09:55:00',1.62),('15844','2014-01-28','10:00:00',1.67),('15844','2014-01-28','10:05:00',1.9),('15844','2014-01-28','10:10:00',2.01),('15844','2014-01-28','10:15:00',2.1),('15844','2014-01-28','10:20:00',2.13),('15844','2014-01-28','10:25:00',2.16),('15844','2014-01-28','10:30:00',2.16),('15844','2014-01-28','10:35:00',2.19),('15844','2014-01-28','10:40:00',2.28),('15844','2014-01-28','10:45:00',2.4),('15844','2014-01-28','10:50:00',2.29),('15844','2014-01-28','10:55:00',2.44),('15844','2014-01-28','11:00:00',1.18),('15844','2014-01-28','11:05:00',2.19),('15844','2014-01-28','11:10:00',1.59),('15844','2014-01-28','11:20:00',1.75),('15844','2014-01-28','11:25:00',1.45),('15844','2014-01-28','11:35:00',1.71),('15844','2014-01-28','11:40:00',1.55),('15844','2014-01-28','11:45:00',1.94),('15844','2014-01-28','11:50:00',1.98),('15844','2014-01-28','11:55:00',2.33),('15844','2014-01-28','12:00:00',1.73),('15844','2014-01-28','12:05:00',1.47),('15844','2014-01-28','12:10:00',1.33),('15844','2014-01-28','12:15:00',1.33),('15844','2014-01-28','12:30:00',1.06),('15844','2014-01-28','12:35:00',1.09),('15844','2014-01-28','12:40:00',1.88),('15844','2014-01-28','12:45:00',2.51),('15844','2014-01-28','12:50:00',1.53),('15844','2014-01-28','12:55:00',1.93),('15844','2014-01-28','13:00:00',2.26),('15844','2014-01-28','13:05:00',1.64),('15844','2014-01-28','13:10:00',1.72),('15844','2014-01-28','13:15:00',1.75),('15844','2014-01-28','13:20:00',1.82),('15844','2014-01-28','13:25:00',1.3),('15844','2014-01-28','13:30:00',1.59),('15844','2014-01-28','13:35:00',1.56),('15844','2014-01-28','13:40:00',1.41),('15844','2014-01-28','13:45:00',1.31),('15844','2014-01-28','13:50:00',1.21),('15844','2014-01-28','13:55:00',1.12),('15844','2014-01-28','14:00:00',1.04),('16100','2014-05-04','07:50:00',1.03),('16100','2014-05-04','07:55:00',1.18),('16100','2014-05-04','08:00:00',1.34),('16100','2014-05-04','08:05:00',1.51),('16100','2014-05-04','08:10:00',1.69),('16100','2014-05-04','08:15:00',1.9),('16100','2014-05-04','08:20:00',2.06),('16100','2014-05-04','08:25:00',2.27),('16100','2014-05-04','08:30:00',2.5),('16100','2014-05-04','08:35:00',2.82),('16100','2014-05-04','08:40:00',3.09),('16100','2014-05-04','08:45:00',3.25),('16100','2014-05-04','08:50:00',3.4),('16100','2014-05-04','08:55:00',3.59),('16100','2014-05-04','09:00:00',3.78),('16100','2014-05-04','09:05:00',3.93),('16100','2014-05-04','09:10:00',4.08),('16100','2014-05-04','09:15:00',4.23),('16100','2014-05-04','09:20:00',4.37),('16100','2014-05-04','09:25:00',4.54),('16100','2014-05-04','09:30:00',4.71),('16100','2014-05-04','09:35:00',4.85),('16100','2014-05-04','09:40:00',4.96),('16100','2014-05-04','09:45:00',5.08),('16100','2014-05-04','09:50:00',5.17),('16100','2014-05-04','09:55:00',5.27),('16100','2014-05-04','10:00:00',5.42),('16100','2014-05-04','10:05:00',5.56),('16100','2014-05-04','10:10:00',5.78),('16100','2014-05-04','10:15:00',5.83),('16100','2014-05-04','10:20:00',5.94),('16100','2014-05-04','10:25:00',6.06),('16100','2014-05-04','10:30:00',6.19),('16100','2014-05-04','10:35:00',6.34),('16100','2014-05-04','10:40:00',6.39),('16100','2014-05-04','10:45:00',6.43),('16100','2014-05-04','10:50:00',6.5),('16100','2014-05-04','10:55:00',6.56),('16100','2014-05-04','11:00:00',6.68),('16100','2014-05-04','11:05:00',6.75),('16100','2014-05-04','11:10:00',6.88),('16100','2014-05-04','11:15:00',7.01),('16100','2014-05-04','11:20:00',5.16),('16100','2014-05-04','11:25:00',3.69),('16100','2014-05-04','11:30:00',6.77),('16100','2014-05-04','11:35:00',7.05),('16100','2014-05-04','11:40:00',6.31),('16100','2014-05-04','11:45:00',7.36),('16100','2014-05-04','11:50:00',7.82),('16100','2014-05-04','11:55:00',5.61),('16100','2014-05-04','12:00:00',5.21),('16100','2014-05-04','12:05:00',5.92),('16100','2014-05-04','12:10:00',8.04),('16100','2014-05-04','12:15:00',5),('16100','2014-05-04','12:20:00',2.53),('16100','2014-05-04','12:25:00',2.67),('16100','2014-05-04','12:30:00',4.55),('16100','2014-05-04','12:35:00',4.13),('16100','2014-05-04','12:40:00',7.5),('16100','2014-05-04','12:45:00',8.26),('16100','2014-05-04','12:50:00',7.92),('16100','2014-05-04','12:55:00',7.9),('16100','2014-05-04','13:00:00',7.35),('16100','2014-05-04','13:05:00',7.01),('16100','2014-05-04','13:10:00',7.81),('16100','2014-05-04','13:15:00',7.78),('16100','2014-05-04','13:20:00',7.73),('16100','2014-05-04','13:25:00',7.7),('16100','2014-05-04','13:30:00',7.83),('16100','2014-05-04','13:35:00',8.02),('16100','2014-05-04','13:40:00',8.14),('16100','2014-05-04','13:45:00',8.36),('16100','2014-05-04','13:50:00',3.02),('16100','2014-05-04','13:55:00',2.17),('16100','2014-05-04','14:00:00',2.17),('16100','2014-05-04','14:05:00',1.95),('16100','2014-05-04','14:10:00',8.29),('16100','2014-05-04','14:15:00',8.37),('16100','2014-05-04','14:20:00',8.28),('16100','2014-05-04','14:25:00',4.5),('16100','2014-05-04','14:30:00',8.07),('16100','2014-05-04','14:35:00',7.9),('16100','2014-05-04','14:40:00',7.79),('16100','2014-05-04','14:45:00',7.64),('16100','2014-05-04','14:50:00',7.57),('16100','2014-05-04','14:55:00',7.65),('16100','2014-05-04','15:00:00',7.3),('16100','2014-05-04','15:05:00',7.04),('16100','2014-05-04','15:10:00',6.89),('16100','2014-05-04','15:15:00',6.84),('16100','2014-05-04','15:20:00',6.64),('16100','2014-05-04','15:25:00',6.52),('16100','2014-05-04','15:30:00',6.52),('16100','2014-05-04','15:35:00',6.43),('16100','2014-05-04','15:40:00',6.34),('16100','2014-05-04','15:45:00',6.28),('16100','2014-05-04','15:50:00',6.13),('16100','2014-05-04','15:55:00',6.04),('16100','2014-05-04','16:00:00',5.94),('16100','2014-05-04','16:05:00',5.82),('16100','2014-05-04','16:10:00',5.78),('16100','2014-05-04','16:15:00',5.62),('16100','2014-05-04','16:20:00',5.46),('16100','2014-05-04','16:25:00',5.28),('16100','2014-05-04','16:30:00',5.11),('16100','2014-05-04','16:35:00',4.94),('16100','2014-05-04','16:40:00',4.84),('16100','2014-05-04','16:45:00',4.7),('16100','2014-05-04','16:50:00',4.63),('16100','2014-05-04','16:55:00',4.49),('16100','2014-05-04','17:00:00',4.25),('16100','2014-05-04','17:05:00',4.02),('16100','2014-05-04','17:10:00',3.89),('16100','2014-05-04','17:15:00',3.77),('16100','2014-05-04','17:20:00',3.6),('16100','2014-05-04','17:25:00',3.16),('16100','2014-05-04','17:30:00',2.16),('16100','2014-05-04','17:35:00',2.27),('16100','2014-05-04','17:40:00',2.97),('16100','2014-05-04','17:45:00',2.74),('16100','2014-05-04','17:50:00',2.14),('16100','2014-05-04','17:55:00',2.42),('16100','2014-05-04','18:00:00',2.25),('16100','2014-05-04','18:05:00',2.07),('16100','2014-05-04','18:10:00',1.95),('16100','2014-05-04','18:15:00',1.8),('16100','2014-05-04','18:20:00',1.65),('16100','2014-05-04','18:25:00',1.48),('16100','2014-05-04','18:30:00',1.33),('16100','2014-05-04','18:35:00',1.16),('16100','2014-04-25','08:15:00',1.04),('16100','2014-04-25','08:20:00',1.12),('16100','2014-04-25','08:25:00',1.07),('16100','2014-04-25','08:30:00',1.08),('16100','2014-04-25','08:35:00',1.06),('16100','2014-04-25','08:40:00',1.08),('16100','2014-04-25','08:45:00',1.11),('16100','2014-04-25','08:50:00',1.2),('16100','2014-04-25','08:55:00',1.39),('16100','2014-04-25','09:00:00',1.54),('16100','2014-04-25','09:05:00',1.69),('16100','2014-04-25','09:10:00',1.69),('16100','2014-04-25','09:15:00',1.68),('16100','2014-04-25','09:20:00',1.55),('16100','2014-04-25','09:25:00',1.24),('16100','2014-04-25','09:30:00',1.03),('16100','2014-04-25','09:35:00',1.14),('16100','2014-04-25','09:40:00',1.32),('16100','2014-04-25','09:45:00',1.69),('16100','2014-04-25','09:50:00',1.8),('16100','2014-04-25','09:55:00',2.28),('16100','2014-04-25','10:00:00',2.57),('16100','2014-04-25','10:05:00',2.9),('16100','2014-04-25','10:10:00',2.86),('16100','2014-04-25','10:15:00',3.21),('16100','2014-04-25','10:20:00',2.98),('16100','2014-04-25','10:25:00',2.62),('16100','2014-04-25','10:30:00',3.01),('16100','2014-04-25','10:35:00',2.72),('16100','2014-04-25','10:40:00',2.59),('16100','2014-04-25','10:45:00',3),('16100','2014-04-25','10:50:00',3.12),('16100','2014-04-25','10:55:00',3.82),('16100','2014-04-25','11:00:00',3.67),('16100','2014-04-25','11:05:00',5.03),('16100','2014-04-25','11:10:00',6.38),('16100','2014-04-25','11:15:00',6.19),('16100','2014-04-25','11:20:00',6.31),('16100','2014-04-25','11:25:00',5.6),('16100','2014-04-25','11:30:00',5.88),('16100','2014-04-25','11:35:00',5.41),('16100','2014-04-25','11:40:00',5.06),('16100','2014-04-25','11:45:00',5.39),('16100','2014-04-25','11:50:00',5.54),('16100','2014-04-25','11:55:00',3.47),('16100','2014-04-25','12:00:00',4.35),('16100','2014-04-25','12:05:00',5.84),('16100','2014-04-25','12:10:00',3.88),('16100','2014-04-25','12:15:00',3.01),('16100','2014-04-25','12:20:00',4.65),('16100','2014-04-25','12:25:00',5.17),('16100','2014-04-25','12:30:00',3.46),('16100','2014-04-25','12:35:00',3.62),('16100','2014-04-25','12:40:00',4.35),('16100','2014-04-25','12:45:00',4.24),('16100','2014-04-25','12:50:00',3.51),('16100','2014-04-25','12:55:00',6.52),('16100','2014-04-25','13:00:00',5.39),('16100','2014-04-25','13:05:00',5.98),('16100','2014-04-25','13:10:00',7.38),('16100','2014-04-25','13:15:00',7.61),('16100','2014-04-25','13:20:00',6),('16100','2014-04-25','13:25:00',3.38),('16100','2014-04-25','13:30:00',3.5),('16100','2014-04-25','13:35:00',6.52),('16100','2014-04-25','13:40:00',7.4),('16100','2014-04-25','13:45:00',4.14),('16100','2014-04-25','13:50:00',2.93),('16100','2014-04-25','13:55:00',4.33),('16100','2014-04-25','14:00:00',4.05),('16100','2014-04-25','14:05:00',3.85),('16100','2014-04-25','14:10:00',1.49),('16100','2014-04-25','14:15:00',1.46),('16100','2014-04-25','14:20:00',1.63),('16100','2014-04-25','14:25:00',1.62),('16100','2014-04-25','14:30:00',1.62),('16100','2014-04-25','14:45:00',1.36),('16100','2014-04-25','18:35:00',1.21),('16100','2014-04-25','18:40:00',1.48),('16100','2014-04-25','18:45:00',1.24),('16100','2014-01-25','08:10:00',1.01),('16100','2014-01-25','08:55:00',1.13),('16100','2014-01-25','09:00:00',1.69),('16100','2014-01-25','09:05:00',2.22),('16100','2014-01-25','09:10:00',1.01),('16100','2014-01-25','09:20:00',1.14),('16100','2014-01-25','09:25:00',2.6),('16100','2014-01-25','09:30:00',2.94),('16100','2014-01-25','09:35:00',2.34),('16100','2014-01-25','09:40:00',1.79),('16100','2014-01-25','09:45:00',1.95),('16100','2014-01-25','09:50:00',2.32),('16100','2014-01-25','09:55:00',1.59),('16100','2014-01-25','10:00:00',1.21),('16100','2014-01-25','10:05:00',1.83),('16100','2014-01-25','10:10:00',2.41),('16100','2014-01-25','10:15:00',2.93),('16100','2014-01-25','10:20:00',1.57),('16100','2014-01-25','10:25:00',1.43),('16100','2014-01-25','10:30:00',1.49),('16100','2014-01-25','10:35:00',1.06),('16100','2014-01-25','10:40:00',1.08),('16100','2014-01-25','10:45:00',1.32),('16100','2014-01-25','10:50:00',1.46),('16100','2014-01-25','10:55:00',1.44),('16100','2014-01-25','11:00:00',1.47),('16100','2014-01-25','11:05:00',1.57),('16100','2014-01-25','11:10:00',1.25),('16100','2014-01-25','11:15:00',1.21),('16100','2014-01-25','11:20:00',1.72),('16100','2014-01-25','11:25:00',2.21),('16100','2014-01-25','11:30:00',1.35),('16100','2014-01-25','11:35:00',1.18),('16100','2014-01-25','11:40:00',1.01),('16100','2014-01-25','12:05:00',1.17),('16100','2014-01-25','12:10:00',1.77),('16100','2014-01-25','12:15:00',2.26),('16100','2014-01-25','12:20:00',2.49),('16100','2014-01-25','12:25:00',3.99),('16100','2014-01-25','12:30:00',4.38),('16100','2014-01-25','12:35:00',2.06),('16100','2014-01-25','12:40:00',1.76),('16100','2014-01-25','12:45:00',1.52),('16100','2014-01-25','12:50:00',1.36),('16100','2014-01-25','12:55:00',1.49),('16100','2014-01-25','13:00:00',1.73),('16100','2014-01-25','13:05:00',1.96),('16100','2014-01-25','13:10:00',2.31),('16100','2014-01-25','13:15:00',2.41),('16100','2014-01-25','13:20:00',2.45),('16100','2014-01-25','13:25:00',1.78),('16100','2014-01-25','13:30:00',1.39),('16100','2014-01-25','13:35:00',1.25),('16100','2014-01-25','13:40:00',1.04),('16100','2014-01-25','13:45:00',2.3),('16100','2014-01-25','13:50:00',1.53),('16100','2014-01-25','14:10:00',1.02),('16100','2014-01-25','15:20:00',1.05),('16100','2014-01-25','15:40:00',2.8),('16100','2014-01-25','15:45:00',1.43),('16100','2014-01-24','09:40:00',1.24),('16100','2014-01-24','09:45:00',1.57),('16100','2014-01-24','09:50:00',3.01),('16100','2014-01-24','09:55:00',2.27),('16100','2014-01-24','10:00:00',2.95),('16100','2014-01-24','10:05:00',5.08),('16100','2014-01-24','10:10:00',5.05),('16100','2014-01-24','10:15:00',4.48),('16100','2014-01-24','10:20:00',4.05),('16100','2014-01-24','10:25:00',3.37),('16100','2014-01-24','10:30:00',4.32),('16100','2014-01-24','10:35:00',3.95),('16100','2014-01-24','10:40:00',2.94),('16100','2014-01-24','10:45:00',4.79),('16100','2014-01-24','10:50:00',5.94),('16100','2014-01-24','10:55:00',5.42),('16100','2014-01-24','11:00:00',5.07),('16100','2014-01-24','11:05:00',5.09),('16100','2014-01-24','11:10:00',6.23),('16100','2014-01-24','11:15:00',6.39),('16100','2014-01-24','11:20:00',6.92),('16100','2014-01-24','11:25:00',6.75),('16100','2014-01-24','11:30:00',3.23),('16100','2014-01-24','11:35:00',4.86),('16100','2014-01-24','11:40:00',3.48),('16100','2014-01-24','11:45:00',3.39),('16100','2014-01-24','11:50:00',3.43),('16100','2014-01-24','11:55:00',3.38),('16100','2014-01-24','12:00:00',3.23),('16100','2014-01-24','12:05:00',3.38),('16100','2014-01-24','12:10:00',3.48),('16100','2014-01-24','12:15:00',3.33),('16100','2014-01-24','12:20:00',3.16),('16100','2014-01-24','12:25:00',2.98),('16100','2014-01-24','12:30:00',2.93),('16100','2014-01-24','12:35:00',3.17),('16100','2014-01-24','12:40:00',2.69),('16100','2014-01-24','12:45:00',3.25),('16100','2014-01-24','12:50:00',4.48),('16100','2014-01-24','12:55:00',4.99),('16100','2014-01-24','13:00:00',5.26),('16100','2014-01-24','13:05:00',5.53),('16100','2014-01-24','13:10:00',6.07),('16100','2014-01-24','13:15:00',6.29),('16100','2014-01-24','13:20:00',6.15),('16100','2014-01-24','13:25:00',6.06),('16100','2014-01-24','13:30:00',6.28),('16100','2014-01-24','13:35:00',5.24),('16100','2014-01-24','13:40:00',5.32),('16100','2014-01-24','13:45:00',5.42),('16100','2014-01-24','13:50:00',3.14),('16100','2014-01-24','13:55:00',5.98),('16100','2014-01-24','14:00:00',4.38),('16100','2014-01-24','14:05:00',5.45),('16100','2014-01-24','14:10:00',5.32),('16100','2014-01-24','14:15:00',5.22),('16100','2014-01-24','14:20:00',5.15),('16100','2014-01-24','14:25:00',5.51),('16100','2014-01-24','14:30:00',5.89),('16100','2014-01-24','14:35:00',4.9),('16100','2014-01-24','14:40:00',2.73),('16100','2014-01-24','14:45:00',2.73),('16100','2014-01-24','14:50:00',2.39),('16100','2014-01-24','14:55:00',1.18),('16100','2014-01-24','15:00:00',2.69),('16100','2014-01-24','15:05:00',4.11),('16100','2014-01-24','15:10:00',3.95),('16100','2014-01-24','15:15:00',3.89),('16100','2014-01-24','15:20:00',3.6),('16100','2014-01-24','15:25:00',3.4),('16100','2014-01-24','15:30:00',3.2),('16100','2014-01-24','15:35:00',3.05),('16100','2014-01-24','15:40:00',2.89),('16100','2014-01-24','15:45:00',2.74),('16100','2014-01-24','15:50:00',2.53),('16100','2014-01-24','15:55:00',2.37),('16100','2014-01-24','16:00:00',2.22),('16100','2014-01-24','16:05:00',2.04),('16100','2014-01-24','16:10:00',1.88),('16100','2014-01-24','16:15:00',1.67),('16100','2014-01-24','16:20:00',1.47),('16100','2014-01-24','16:25:00',1.3),('16100','2014-01-24','16:30:00',1.11),('16100','2014-01-23','10:00:00',1.43),('16100','2014-01-23','10:05:00',2.55),('16100','2014-01-23','10:10:00',3.25),('16100','2014-01-23','10:15:00',3.81),('16100','2014-01-23','10:20:00',4.61),('16100','2014-01-23','10:25:00',2.95),('16100','2014-01-23','10:30:00',4.67),('16100','2014-01-23','10:35:00',2.99),('16100','2014-01-23','10:40:00',4.54),('16100','2014-01-23','10:45:00',3.31),('16100','2014-01-23','10:50:00',5.25),('16100','2014-01-23','10:55:00',3.01),('16100','2014-01-23','11:00:00',1.78),('16100','2014-01-23','11:05:00',1.17),('16100','2014-01-23','11:15:00',1.58),('16100','2014-01-23','11:20:00',1.75),('16100','2014-01-23','11:25:00',1.49),('16100','2014-01-23','11:30:00',4.01),('16100','2014-01-23','11:35:00',1.14),('16100','2014-01-23','11:40:00',2.93),('16100','2014-01-23','11:45:00',6.54),('16100','2014-01-23','11:50:00',2),('16100','2014-01-23','11:55:00',1.56),('16100','2014-01-23','12:00:00',4.75),('16100','2014-01-23','12:05:00',3.38),('16100','2014-01-23','12:10:00',3.84),('16100','2014-01-23','12:15:00',2.68),('16100','2014-01-23','12:20:00',4.2),('16100','2014-01-23','12:25:00',4.14),('16100','2014-01-23','12:30:00',2.22),('16100','2014-01-23','12:35:00',2.07),('16100','2014-01-23','12:40:00',4.21),('16100','2014-01-23','12:45:00',6.24),('16100','2014-01-23','12:50:00',3.91),('16100','2014-01-23','12:55:00',1.81),('16100','2014-01-23','13:00:00',1.96),('16100','2014-01-23','13:05:00',1.88),('16100','2014-01-23','13:10:00',1.67),('16100','2014-01-23','13:15:00',4.06),('16100','2014-01-23','13:20:00',6.49),('16100','2014-01-23','13:25:00',3.67),('16100','2014-01-23','13:30:00',4.97),('16100','2014-01-23','13:35:00',1.02),('16100','2014-01-23','13:40:00',3.69),('16100','2014-01-23','13:45:00',4.04),('16100','2014-01-23','13:50:00',4.85),('16100','2014-01-23','13:55:00',6.07),('16100','2014-01-23','14:00:00',4.38),('16100','2014-01-23','14:05:00',4.73),('16100','2014-01-23','14:10:00',4.17),('16100','2014-01-23','14:15:00',3.67),('16100','2014-01-23','14:20:00',5.73),('16100','2014-01-23','14:25:00',6.02),('16100','2014-01-23','14:30:00',4.52),('16100','2014-01-23','14:35:00',2.45),('16100','2014-01-23','14:40:00',2.07),('16100','2014-01-23','14:45:00',4.44),('16100','2014-01-23','14:50:00',2.5),('16100','2014-01-22','10:20:00',1.12),('16100','2014-01-22','10:45:00',1.37),('16100','2014-01-22','10:50:00',1.46),('16100','2014-01-22','10:55:00',1.49),('16100','2014-01-22','11:00:00',1.52),('16100','2014-01-22','11:05:00',1.66),('16100','2014-01-22','11:10:00',1.75),('16100','2014-01-22','11:15:00',1.52),('16100','2014-01-22','11:20:00',1.44),('16100','2014-01-22','11:25:00',1.25),('16100','2014-01-22','12:05:00',1.33),('16100','2014-01-22','12:10:00',1.37),('16100','2014-01-22','12:25:00',1.5),('16100','2014-01-22','12:30:00',1.99),('16100','2014-01-22','12:35:00',2.09),('16100','2014-01-22','12:40:00',1.73),('16100','2014-01-22','12:45:00',1.08),('16100','2014-01-22','14:00:00',1.01),('16100','2014-01-22','14:05:00',1.1),('16100','2014-01-22','14:10:00',1.19),('16100','2014-01-22','14:15:00',1.18),('16100','2014-01-21','11:00:00',1.14),('16100','2014-01-21','11:05:00',1.31),('16100','2014-01-21','11:10:00',1.53),('16100','2014-01-21','11:15:00',1.58),('16100','2014-01-21','11:20:00',1.57),('16100','2014-01-21','11:25:00',1.47),('16100','2014-01-21','11:30:00',1.24),('16100','2014-01-21','11:35:00',1.31),('16100','2014-01-21','11:40:00',1.39),('16100','2014-01-21','12:00:00',1.26),('16100','2014-01-21','12:05:00',1.25),('16100','2014-01-21','12:10:00',1.23),('16100','2014-01-21','12:15:00',1),('16100','2014-01-21','12:35:00',1.08),('16100','2014-01-21','12:40:00',1.32),('16100','2014-01-21','12:45:00',1.86),('16100','2014-01-21','12:50:00',1.88),('16100','2014-01-21','12:55:00',2.03),('16100','2014-01-21','13:00:00',1.53),('16100','2014-01-21','13:05:00',1.2),('16100','2014-01-21','13:15:00',1.02),('16100','2014-01-21','13:20:00',1.02),('16100','2014-01-21','13:25:00',1.03),('16100','2014-01-21','13:30:00',1.07),('16100','2014-01-21','13:40:00',1.06),('16100','2014-01-21','13:45:00',1.1),('16100','2014-01-21','13:50:00',1.07),('16100','2014-01-21','13:55:00',1.03),('16100','2014-01-21','16:05:00',2),('16100','2014-01-21','16:10:00',2.3),('16100','2014-01-21','16:15:00',2.02),('16100','2014-01-21','16:25:00',1.24),('16100','2014-01-21','16:30:00',1.05),('16100','2014-01-20','09:40:00',1.28),('16100','2014-01-20','09:45:00',1.11),('16100','2014-01-20','09:50:00',1.58),('16100','2014-01-20','09:55:00',3.21),('16100','2014-01-20','10:00:00',1.22),('16100','2014-01-20','10:25:00',1.11),('16100','2014-01-20','10:30:00',1.35),('16100','2014-01-20','10:55:00',1.18),('16100','2014-01-20','11:00:00',1.09),('16100','2014-01-20','11:05:00',1.14),('16100','2014-01-20','11:10:00',1.23),('16100','2014-01-20','11:15:00',1.18),('16100','2014-01-20','11:20:00',1.12),('16100','2014-01-20','11:30:00',1),('16100','2014-01-20','11:35:00',3.37),('16100','2014-01-20','11:40:00',5.14),('16100','2014-01-20','11:45:00',4.46),('16100','2014-01-20','11:50:00',1.99),('16100','2014-01-20','11:55:00',2.61),('16100','2014-01-20','12:00:00',2.63),('16100','2014-01-20','12:05:00',2.59),('16100','2014-01-20','12:10:00',2.13),('16100','2014-01-20','12:15:00',2.18),('16100','2014-01-20','12:20:00',3.37),('16100','2014-01-20','12:25:00',2.59),('16100','2014-01-20','12:30:00',2.42),('16100','2014-01-20','12:35:00',2.27),('16100','2014-01-20','12:40:00',1.5),('16100','2014-01-20','12:45:00',1.44),('16100','2014-01-20','12:50:00',1.37),('16100','2014-01-20','12:55:00',1.27),('16100','2014-01-20','13:00:00',1.3),('16100','2014-01-20','13:05:00',1.25),('16100','2014-01-20','13:10:00',1.23),('16100','2014-01-20','13:15:00',1.55),('16100','2014-01-20','13:20:00',1.33),('16100','2014-01-20','13:50:00',1.06),('16100','2014-01-20','13:55:00',1.21),('16100','2014-01-20','14:00:00',1.21),('16100','2014-01-20','15:00:00',1.02),('16100','2014-01-20','15:05:00',1.7),('16100','2014-01-20','15:10:00',1.4),('16100','2014-01-20','15:20:00',2.12),('16100','2014-01-20','15:25:00',1.49),('16100','2014-01-20','15:30:00',1.37),('16100','2014-01-20','15:35:00',1.88),('16100','2014-01-20','15:40:00',2.15),('16100','2014-01-19','10:35:00',1),('16100','2014-01-19','11:50:00',1.14),('16100','2014-01-19','11:55:00',2.79),('16100','2014-01-19','12:00:00',2.2),('16100','2014-01-19','12:05:00',3.12),('16100','2014-01-19','12:10:00',2.67),('16100','2014-01-19','12:15:00',2.06),('16100','2014-01-19','12:20:00',1.42),('16100','2014-01-19','12:25:00',1.45),('16100','2014-01-19','12:30:00',3.06),('16100','2014-01-19','12:35:00',2.42),('16100','2014-01-19','12:40:00',3.46),('16100','2014-01-19','12:45:00',7),('16100','2014-01-19','12:50:00',1.8),('16100','2014-01-19','12:55:00',4.88),('16100','2014-01-19','13:00:00',4.3),('16100','2014-01-19','13:05:00',1.97),('16100','2014-01-19','13:25:00',1.34),('16100','2014-01-19','13:30:00',1.78),('16100','2014-01-19','13:35:00',1.93),('16100','2014-01-19','13:40:00',1.57),('16100','2014-01-19','13:45:00',1.15),('16100','2014-01-19','14:10:00',1.19),('16100','2014-01-19','14:15:00',1.75),('16100','2014-01-19','14:20:00',1.91),('16100','2014-01-19','14:25:00',1.11),('16100','2014-01-18','11:45:00',1.16),('16100','2014-01-18','11:50:00',1.66),('16100','2014-01-18','11:55:00',2),('16100','2014-01-18','12:00:00',1.66),('16100','2014-01-18','12:05:00',1.62),('16100','2014-01-18','12:10:00',1.48),('16100','2014-01-18','12:15:00',1.34),('16100','2014-01-18','12:20:00',1.49),('16100','2014-01-18','12:25:00',1.61),('16100','2014-01-18','12:30:00',1.45),('16100','2014-01-18','13:00:00',1.06),('16100','2014-01-18','13:05:00',1.65),('16100','2014-01-18','13:10:00',1.89),('16100','2014-01-18','13:15:00',1.44),('16100','2014-01-18','13:20:00',1.14),('16100','2014-01-18','13:25:00',1.02),('16100','2014-01-18','13:30:00',1.06),('16100','2014-01-18','13:35:00',1.03),('16100','2014-01-18','13:55:00',1.21),('16100','2014-01-18','14:00:00',1.05),('16100','2014-01-18','14:15:00',1.82),('16100','2014-01-18','14:20:00',2.56),('16100','2014-01-18','14:25:00',2.26),('16100','2014-01-18','14:30:00',1.99),('16100','2014-01-18','14:35:00',1.56),('16100','2014-01-18','14:40:00',1.16),('16100','2014-01-17','09:35:00',1.3),('16100','2014-01-17','09:40:00',1.43),('16100','2014-01-17','09:45:00',1.92),('16100','2014-01-17','09:50:00',2.09),('16100','2014-01-17','09:55:00',2.02),('16100','2014-01-17','10:00:00',3.67),('16100','2014-01-17','10:05:00',2.8),('16100','2014-01-17','10:10:00',3.14),('16100','2014-01-17','10:15:00',5.23),('16100','2014-01-17','10:20:00',4.3),('16100','2014-01-17','10:25:00',3.51),('16100','2014-01-17','10:30:00',3.57),('16100','2014-01-17','10:35:00',2.77),('16100','2014-01-17','10:40:00',3.29),('16100','2014-01-17','10:45:00',2.54),('16100','2014-01-17','10:50:00',2.04),('16100','2014-01-17','10:55:00',1.62),('16100','2014-01-17','11:00:00',1.49),('16100','2014-01-17','11:05:00',4.43),('16100','2014-01-17','11:10:00',5.54),('16100','2014-01-17','11:15:00',3.35),('16100','2014-01-17','11:20:00',5.1),('16100','2014-01-17','11:25:00',5.68),('16100','2014-01-17','11:30:00',5.69),('16100','2014-01-17','11:35:00',5.7),('16100','2014-01-17','11:40:00',4.07),('16100','2014-01-17','11:45:00',2),('16100','2014-01-17','11:50:00',1.91),('16100','2014-01-17','11:55:00',2.93),('16100','2014-01-17','12:00:00',5.13),('16100','2014-01-17','12:05:00',2.65),('16100','2014-01-17','12:10:00',6.03),('16100','2014-01-17','12:15:00',5.68),('16100','2014-01-17','12:20:00',5.8),('16100','2014-01-17','12:25:00',5.69),('16100','2014-01-17','12:30:00',5.88),('16100','2014-01-17','12:35:00',5.85),('16100','2014-01-17','12:40:00',5.54),('16100','2014-01-17','12:45:00',5.65),('16100','2014-01-17','12:50:00',5.31),('16100','2014-01-17','12:55:00',4.98),('16100','2014-01-17','13:00:00',4.69),('16100','2014-01-17','13:05:00',3.63),('16100','2014-01-17','13:10:00',4.47),('16100','2014-01-17','13:15:00',5.87),('16100','2014-01-17','13:20:00',5.74),('16100','2014-01-17','13:25:00',3.38),('16100','2014-01-17','13:30:00',4.62),('16100','2014-01-17','13:35:00',5.74),('16100','2014-01-17','13:40:00',4.63),('16100','2014-01-17','13:45:00',5.46),('16100','2014-01-17','13:50:00',5.29),('16100','2014-01-17','13:55:00',3.84),('16100','2014-01-17','14:00:00',5.12),('16100','2014-01-17','14:05:00',4.83),('16100','2014-01-17','14:10:00',4.65),('16100','2014-01-17','14:15:00',4.38),('16100','2014-01-17','14:20:00',4.55),('16100','2014-01-17','14:25:00',4.4),('16100','2014-01-17','14:30:00',4.25),('16100','2014-01-17','14:35:00',4.1),('16100','2014-01-17','14:40:00',3.88),('16100','2014-01-17','14:45:00',3.8),('16100','2014-01-17','14:50:00',3.45),('16100','2014-01-17','14:55:00',2.1),('16100','2014-01-17','15:05:00',1.07),('16100','2014-01-17','15:10:00',1.11),('16100','2014-01-17','15:15:00',1.03),('16100','2014-01-17','15:20:00',1.09),('16100','2014-01-17','15:25:00',1.06),('16100','2014-01-17','15:30:00',2.01),('16100','2014-01-17','15:35:00',1.01),('16100','2014-01-17','15:50:00',1.58),('16100','2014-01-17','15:55:00',1.89),('16100','2014-01-17','16:00:00',1.2),('16100','2014-01-17','16:05:00',1.57),('16100','2014-01-16','08:55:00',1.9),('16100','2014-01-16','09:00:00',2.05),('16100','2014-01-16','09:05:00',2.08),('16100','2014-01-16','09:10:00',2.28),('16100','2014-01-16','09:15:00',2.33),('16100','2014-01-16','09:20:00',2.13),('16100','2014-01-16','09:25:00',2.83),('16100','2014-01-16','09:30:00',2.83),('16100','2014-01-16','09:35:00',2.9),('16100','2014-01-16','09:40:00',2.2),('16100','2014-01-16','09:45:00',1.32),('16100','2014-01-16','09:55:00',1.26),('16100','2014-04-24','07:55:00',1.08),('16100','2014-04-24','08:00:00',1.17),('16100','2014-04-24','08:05:00',1.34),('16100','2014-04-24','08:10:00',1.16),('16100','2014-04-24','08:15:00',1.06),('16100','2014-04-24','08:20:00',1.88),('16100','2014-04-24','08:25:00',2.08),('16100','2014-04-24','08:30:00',2.25),('16100','2014-04-24','08:35:00',2.37),('16100','2014-04-24','08:40:00',2.54),('16100','2014-04-24','08:45:00',2.69),('16100','2014-04-24','08:50:00',2.88),('16100','2014-04-24','08:55:00',3.13),('16100','2014-04-24','09:00:00',3.48),('16100','2014-04-24','09:05:00',3.4),('16100','2014-04-24','09:10:00',2.96),('16100','2014-04-24','09:15:00',3.1),('16100','2014-04-24','09:20:00',1.83),('16100','2014-04-24','09:25:00',1.48),('16100','2014-04-24','09:30:00',1.44),('16100','2014-04-24','09:35:00',1.35),('16100','2014-04-24','09:40:00',1.3),('16100','2014-04-24','09:45:00',1.17),('16100','2014-04-24','09:50:00',1.2),('16100','2014-04-24','09:55:00',1.55),('16100','2014-04-24','10:00:00',2.1),('16100','2014-04-24','10:05:00',2.53),('16100','2014-04-24','10:10:00',2.63),('16100','2014-04-24','10:15:00',3.45),('16100','2014-04-24','10:20:00',3.72),('16100','2014-04-24','10:25:00',2.34),('16100','2014-04-24','10:30:00',1.18),('16100','2014-04-24','10:35:00',1.07),('16100','2014-04-24','10:40:00',1.49),('16100','2014-04-24','10:45:00',2.07),('16100','2014-04-24','10:50:00',3.67),('16100','2014-04-24','10:55:00',7.14),('16100','2014-04-24','11:00:00',2.76),('16100','2014-04-24','11:05:00',3.83),('16100','2014-04-24','11:10:00',6.9),('16100','2014-04-24','11:15:00',7.22),('16100','2014-04-24','11:20:00',4.37),('16100','2014-04-24','11:25:00',2.06),('16100','2014-04-24','11:30:00',1.91),('16100','2014-04-24','11:35:00',2.09),('16100','2014-04-24','11:40:00',4.01),('16100','2014-04-24','11:45:00',7.51),('16100','2014-04-24','11:50:00',7.95),('16100','2014-04-24','11:55:00',4.9),('16100','2014-04-24','12:00:00',3.89),('16100','2014-04-24','12:05:00',6.8),('16100','2014-04-24','12:10:00',7.41),('16100','2014-04-24','12:15:00',6.5),('16100','2014-04-24','12:20:00',6.32),('16100','2014-04-24','12:25:00',7.93),('16100','2014-04-24','12:30:00',7.81),('16100','2014-04-24','12:35:00',4.28),('16100','2014-04-24','12:40:00',7.98),('16100','2014-04-24','12:45:00',5.11),('16100','2014-04-24','12:50:00',2.97),('16100','2014-04-24','12:55:00',8.73),('16100','2014-04-24','13:00:00',4.39),('16100','2014-04-24','13:05:00',7.5),('16100','2014-04-24','13:10:00',7.32),('16100','2014-04-24','13:15:00',7.12),('16100','2014-04-24','13:20:00',7.23),('16100','2014-04-24','13:25:00',4.5),('16100','2014-04-24','13:30:00',7.08),('16100','2014-04-24','13:35:00',7.48),('16100','2014-04-24','13:40:00',5.66),('16100','2014-04-24','13:45:00',2.94),('16100','2014-04-24','13:50:00',3.23),('16100','2014-04-24','13:55:00',5.05),('16100','2014-04-24','14:00:00',4.97),('16100','2014-04-24','14:05:00',6.7),('16100','2014-04-24','14:10:00',6.36),('16100','2014-04-24','14:15:00',7.3),('16100','2014-04-24','14:20:00',7.12),('16100','2014-04-24','14:25:00',7.07),('16100','2014-04-24','14:30:00',7.04),('16100','2014-04-24','14:35:00',6.95),('16100','2014-04-24','14:40:00',6.9),('16100','2014-04-24','14:45:00',6.84),('16100','2014-04-24','14:50:00',6.8),('16100','2014-04-24','14:55:00',6.76),('16100','2014-04-24','15:00:00',6.71),('16100','2014-04-24','15:05:00',6.51),('16100','2014-04-24','15:10:00',6.4),('16100','2014-04-24','15:15:00',6.34),('16100','2014-04-24','15:20:00',6.27),('16100','2014-04-24','15:25:00',6.06),('16100','2014-04-24','15:30:00',6.05),('16100','2014-04-24','15:35:00',6.08),('16100','2014-04-24','15:40:00',5.91),('16100','2014-04-24','15:45:00',5.7),('16100','2014-04-24','15:50:00',5.69),('16100','2014-04-24','15:55:00',5.66),('16100','2014-04-24','16:00:00',5.43),('16100','2014-04-24','16:05:00',5.13),('16100','2014-04-24','16:10:00',5.19),('16100','2014-04-24','16:15:00',4.58),('16100','2014-04-24','16:20:00',4.57),('16100','2014-04-24','16:25:00',4.51),('16100','2014-04-24','16:30:00',4.34),('16100','2014-04-24','16:35:00',4.61),('16100','2014-04-24','16:40:00',4.66),('16100','2014-04-24','16:45:00',4.42),('16100','2014-04-24','16:50:00',3.89),('16100','2014-04-24','16:55:00',2.75),('16100','2014-04-24','17:00:00',3),('16100','2014-04-24','17:05:00',2.77),('16100','2014-04-24','17:10:00',1.49),('16100','2014-04-24','17:15:00',2.17),('16100','2014-04-24','17:20:00',2.58),('16100','2014-04-24','17:25:00',2.3),('16100','2014-04-24','17:30:00',2.55),('16100','2014-04-24','17:35:00',1.78),('16100','2014-04-24','17:40:00',1.59),('16100','2014-04-24','17:45:00',1.58),('16100','2014-04-24','17:50:00',1.3),('16100','2014-04-24','17:55:00',1.25),('16100','2014-04-24','18:00:00',1.22),('16100','2014-04-24','18:05:00',1.14),('16100','2014-04-24','18:10:00',1.06),('16100','2014-01-15','08:15:00',1.04),('16100','2014-01-15','08:20:00',1.36),('16100','2014-01-15','08:25:00',1.26),('16100','2014-01-15','08:30:00',1.25),('16100','2014-01-15','08:35:00',1.43),('16100','2014-01-15','08:40:00',1.4),('16100','2014-01-15','08:45:00',1.24),('16100','2014-01-15','08:50:00',1.25),('16100','2014-01-15','08:55:00',1.44),('16100','2014-01-15','09:00:00',1.62),('16100','2014-01-15','09:05:00',1.85),('16100','2014-01-15','09:10:00',2.03),('16100','2014-01-15','09:15:00',2.52),('16100','2014-01-15','09:20:00',3.22),('16100','2014-01-15','09:25:00',3.35),('16100','2014-01-15','09:30:00',3.34),('16100','2014-01-15','09:35:00',3.52),('16100','2014-01-15','09:40:00',3.36),('16100','2014-01-15','09:45:00',2.45),('16100','2014-01-15','09:50:00',1.86),('16100','2014-01-15','09:55:00',1.54),('16100','2014-01-15','10:00:00',1.58),('16100','2014-01-15','10:05:00',1.81),('16100','2014-01-15','10:10:00',2.31),('16100','2014-01-15','10:15:00',2.34),('16100','2014-01-15','10:20:00',2.45),('16100','2014-01-15','10:25:00',3.56),('16100','2014-01-15','10:30:00',4.69),('16100','2014-01-15','10:35:00',4.68),('16100','2014-01-15','10:40:00',3.08),('16100','2014-01-15','10:45:00',3.57),('16100','2014-01-15','10:50:00',4.03),('16100','2014-01-15','10:55:00',3.83),('16100','2014-01-15','11:00:00',4.14),('16100','2014-01-15','11:05:00',4.3),('16100','2014-01-15','11:10:00',4.44),('16100','2014-01-15','11:15:00',3.93),('16100','2014-01-15','11:20:00',3.91),('16100','2014-01-15','11:25:00',3.71),('16100','2014-01-15','11:30:00',3.39),('16100','2014-01-15','11:35:00',3.49),('16100','2014-01-15','11:40:00',3.57),('16100','2014-01-15','11:45:00',3.71),('16100','2014-01-15','11:50:00',3.77),('16100','2014-01-15','11:55:00',3.9),('16100','2014-01-15','12:00:00',3.82),('16100','2014-01-15','12:05:00',3.71),('16100','2014-01-15','12:10:00',3.66),('16100','2014-01-15','12:15:00',3.28),('16100','2014-01-15','12:20:00',3),('16100','2014-01-15','12:25:00',2.98),('16100','2014-01-15','12:30:00',3.38),('16100','2014-01-15','12:35:00',3.85),('16100','2014-01-15','12:40:00',3.93),('16100','2014-01-15','12:45:00',4.08),('16100','2014-01-15','12:50:00',4.27),('16100','2014-01-15','12:55:00',4.4),('16100','2014-01-15','13:00:00',4.56),('16100','2014-01-15','13:05:00',4.55),('16100','2014-01-15','13:10:00',4.53),('16100','2014-01-15','13:15:00',4.61),('16100','2014-01-15','13:20:00',4.75),('16100','2014-01-15','13:25:00',4.79),('16100','2014-01-15','13:30:00',4.87),('16100','2014-01-15','13:35:00',4.73),('16100','2014-01-15','13:40:00',4.99),('16100','2014-01-15','13:45:00',5.12),('16100','2014-01-15','13:50:00',2.37),('16100','2014-01-15','13:55:00',1.47),('16100','2014-01-15','14:00:00',1.57),('16100','2014-01-15','14:05:00',1.69),('16100','2014-01-15','14:10:00',1.66),('16100','2014-01-15','14:15:00',1.59),('16100','2014-01-15','14:20:00',1.57),('16100','2014-01-15','14:25:00',1.57),('16100','2014-01-15','14:30:00',1.57),('16100','2014-01-15','14:35:00',1.49),('16100','2014-01-15','14:40:00',1.4),('16100','2014-01-15','14:45:00',1.37),('16100','2014-01-15','14:50:00',1.39),('16100','2014-01-15','14:55:00',1.38),('16100','2014-01-15','15:00:00',1.81),('16100','2014-01-15','15:05:00',1.4),('16100','2014-01-15','15:10:00',1.44),('16100','2014-01-15','15:15:00',1.09),('16100','2014-01-14','09:30:00',1.33),('16100','2014-01-14','09:35:00',1.81),('16100','2014-01-14','09:40:00',1.39),('16100','2014-01-14','09:55:00',1.03),('16100','2014-01-14','10:00:00',1.99),('16100','2014-01-14','10:05:00',3.07),('16100','2014-01-14','10:10:00',3.93),('16100','2014-01-14','10:15:00',4.52),('16100','2014-01-14','10:20:00',4.69),('16100','2014-01-14','10:25:00',4.82),('16100','2014-01-14','10:30:00',5),('16100','2014-01-14','10:35:00',4.81),('16100','2014-01-14','10:40:00',4.71),('16100','2014-01-14','10:45:00',4.65),('16100','2014-01-14','10:50:00',4.5),('16100','2014-01-14','10:55:00',4.67),('16100','2014-01-14','11:00:00',5.45),('16100','2014-01-14','11:05:00',5.7),('16100','2014-01-14','11:10:00',5.57),('16100','2014-01-14','11:15:00',5.8),('16100','2014-01-14','11:20:00',5.93),('16100','2014-01-14','11:25:00',5.91),('16100','2014-01-14','11:30:00',4.3),('16100','2014-01-14','11:35:00',4.06),('16100','2014-01-14','11:40:00',3.3),('16100','2014-01-14','11:45:00',3.11),('16100','2014-01-14','11:50:00',2.86),('16100','2014-01-14','11:55:00',2.68),('16100','2014-01-14','12:00:00',2.86),('16100','2014-01-14','12:05:00',3.24),('16100','2014-01-14','12:10:00',3.05),('16100','2014-01-14','12:15:00',3.35),('16100','2014-01-14','12:20:00',2.73),('16100','2014-01-14','12:25:00',2.35),('16100','2014-01-14','12:30:00',2.83),('16100','2014-01-14','12:35:00',4.24),('16100','2014-01-14','12:40:00',4.6),('16100','2014-01-14','12:45:00',4.33),('16100','2014-01-14','12:50:00',5.2),('16100','2014-01-14','12:55:00',5.2),('16100','2014-01-14','13:00:00',6.01),('16100','2014-01-14','13:05:00',4.97),('16100','2014-01-14','13:10:00',4.85),('16100','2014-01-14','13:15:00',5.86),('16100','2014-01-14','13:20:00',5.74),('16100','2014-01-14','13:25:00',5.59),('16100','2014-01-14','13:30:00',5.49),('16100','2014-01-14','13:35:00',5.52),('16100','2014-01-14','13:40:00',5.32),('16100','2014-01-14','13:45:00',2.98),('16100','2014-01-14','13:55:00',4.2),('16100','2014-01-14','14:10:00',3.2),('16100','2014-01-14','14:15:00',4.24),('16100','2014-01-14','14:20:00',4.15),('16100','2014-01-14','14:25:00',3.89),('16100','2014-01-14','14:30:00',2.14),('16100','2014-01-14','14:35:00',4.23),('16100','2014-01-14','14:40:00',4.12),('16100','2014-01-14','14:45:00',3.97),('16100','2014-01-14','14:50:00',3.85),('16100','2014-01-14','14:55:00',3.76),('16100','2014-01-14','15:00:00',3.64),('16100','2014-01-14','15:05:00',3.5),('16100','2014-01-14','15:10:00',3.34),('16100','2014-01-14','15:15:00',3.21),('16100','2014-01-14','15:20:00',3.05),('16100','2014-01-14','15:25:00',2.9),('16100','2014-01-14','15:30:00',2.71),('16100','2014-01-14','15:35:00',2.57),('16100','2014-01-14','15:40:00',2.42),('16100','2014-01-14','15:45:00',2.22),('16100','2014-01-14','15:50:00',2.04),('16100','2014-01-14','15:55:00',1.87),('16100','2014-01-14','16:00:00',1.7),('16100','2014-01-14','16:05:00',1.52),('16100','2014-01-14','16:10:00',1.34),('16100','2014-01-14','16:15:00',1.16),('16100','2014-01-13','10:20:00',1.04),('16100','2014-01-13','10:25:00',3.36),('16100','2014-01-13','10:30:00',5.09),('16100','2014-01-13','10:35:00',3.86),('16100','2014-01-13','10:40:00',1.79),('16100','2014-01-13','10:45:00',1.89),('16100','2014-01-13','10:50:00',1.69),('16100','2014-01-13','10:55:00',1.99),('16100','2014-01-13','11:00:00',2.01),('16100','2014-01-13','11:05:00',1.38),('16100','2014-01-13','11:30:00',1.15),('16100','2014-01-12','08:55:00',1.28),('16100','2014-01-12','09:00:00',1.71),('16100','2014-01-12','09:05:00',1.37),('16100','2014-01-12','09:10:00',2.37),('16100','2014-01-12','09:15:00',2.76),('16100','2014-01-12','09:20:00',2.8),('16100','2014-01-12','09:25:00',2.88),('16100','2014-01-12','09:30:00',3.02),('16100','2014-01-12','09:35:00',3.13),('16100','2014-01-12','09:40:00',3.22),('16100','2014-01-12','09:45:00',3.33),('16100','2014-01-12','09:50:00',3.46),('16100','2014-01-12','09:55:00',3.57),('16100','2014-01-12','10:00:00',3.7),('16100','2014-01-12','10:05:00',3.83),('16100','2014-01-12','10:10:00',3.92),('16100','2014-01-12','10:15:00',4.04),('16100','2014-01-12','10:20:00',4.15),('16100','2014-01-12','10:25:00',4.23),('16100','2014-01-12','10:30:00',4.32),('16100','2014-01-12','10:35:00',4.44),('16100','2014-01-12','10:40:00',4.55),('16100','2014-01-12','10:45:00',4.69),('16100','2014-01-12','10:50:00',4.79),('16100','2014-01-12','10:55:00',4.84),('16100','2014-01-12','11:00:00',4.81),('16100','2014-01-12','11:05:00',4.96),('16100','2014-01-12','11:10:00',4.98),('16100','2014-01-12','11:15:00',5.05),('16100','2014-01-12','11:20:00',5.12),('16100','2014-01-12','11:25:00',5.15),('16100','2014-01-12','11:30:00',5.13),('16100','2014-01-12','11:35:00',5.12),('16100','2014-01-12','11:40:00',5.18),('16100','2014-01-12','11:45:00',5.18),('16100','2014-01-12','11:50:00',5.15),('16100','2014-01-12','11:55:00',5.15),('16100','2014-01-12','12:00:00',5.13),('16100','2014-01-12','12:05:00',5.13),('16100','2014-01-12','12:10:00',5.09),('16100','2014-01-12','12:15:00',5.09),('16100','2014-01-12','12:20:00',5.18),('16100','2014-01-12','12:25:00',5.13),('16100','2014-01-12','12:30:00',5.15),('16100','2014-01-12','12:35:00',5.14),('16100','2014-01-12','12:40:00',5.17),('16100','2014-01-12','12:45:00',5.19),('16100','2014-01-12','12:50:00',5.14),('16100','2014-01-12','12:55:00',4.96),('16100','2014-01-12','13:00:00',4.91),('16100','2014-01-12','13:05:00',4.78),('16100','2014-01-12','13:10:00',4.51),('16100','2014-01-12','13:15:00',4.55),('16100','2014-01-12','13:20:00',4.73),('16100','2014-01-12','13:25:00',4.28),('16100','2014-01-12','13:30:00',4.19),('16100','2014-01-12','13:35:00',4.67),('16100','2014-01-12','13:40:00',4.59),('16100','2014-01-12','13:45:00',4.58),('16100','2014-01-12','13:50:00',4.43),('16100','2014-01-12','13:55:00',4.43),('16100','2014-01-12','14:00:00',4.21),('16100','2014-01-12','14:05:00',4.17),('16100','2014-01-12','14:10:00',4.17),('16100','2014-01-12','14:15:00',4.06),('16100','2014-01-12','14:20:00',3.84),('16100','2014-01-12','14:25:00',3.58),('16100','2014-01-12','14:30:00',3.5),('16100','2014-01-12','14:35:00',3.45),('16100','2014-01-12','14:40:00',3.32),('16100','2014-01-12','14:45:00',3.21),('16100','2014-01-12','14:50:00',3.13),('16100','2014-01-12','14:55:00',3.08),('16100','2014-01-12','15:00:00',3.02),('16100','2014-01-12','15:05:00',2.94),('16100','2014-01-12','15:10:00',2.83),('16100','2014-01-12','15:15:00',2.67),('16100','2014-01-12','15:20:00',2.51),('16100','2014-01-12','15:25:00',2.35),('16100','2014-01-12','15:30:00',2.24),('16100','2014-01-12','15:35:00',2.1),('16100','2014-01-12','15:40:00',1.96),('16100','2014-01-12','15:45:00',1.8),('16100','2014-01-12','15:50:00',1.64),('16100','2014-01-12','15:55:00',1.52),('16100','2014-01-12','16:00:00',1.36),('16100','2014-01-12','16:05:00',1.19),('16100','2014-01-12','16:10:00',1.03),('16100','2014-01-11','09:20:00',1.02),('16100','2014-01-11','09:25:00',1.09),('16100','2014-01-11','09:35:00',1.12),('16100','2014-01-11','09:40:00',1.34),('16100','2014-01-11','09:45:00',1.39),('16100','2014-01-11','09:50:00',1.4),('16100','2014-01-11','09:55:00',1.38),('16100','2014-01-11','10:00:00',1.31),('16100','2014-01-11','10:05:00',1.29),('16100','2014-01-11','10:10:00',1.32),('16100','2014-01-11','10:15:00',1.41),('16100','2014-01-11','10:20:00',1.49),('16100','2014-01-11','10:25:00',1.57),('16100','2014-01-11','10:30:00',1.82),('16100','2014-01-11','10:35:00',1.98),('16100','2014-01-11','10:40:00',2.52),('16100','2014-01-11','10:45:00',2.4),('16100','2014-01-11','10:50:00',2.26),('16100','2014-01-11','10:55:00',2.42),('16100','2014-01-11','11:00:00',2.87),('16100','2014-01-11','11:05:00',2.83),('16100','2014-01-11','11:10:00',3.76),('16100','2014-01-11','11:15:00',3.15),('16100','2014-01-11','11:20:00',2.81),('16100','2014-01-11','11:25:00',2.81),('16100','2014-01-11','11:30:00',2.73),('16100','2014-01-11','11:35:00',3.36),('16100','2014-01-11','11:40:00',3.38),('16100','2014-01-11','11:45:00',3.78),('16100','2014-01-11','11:50:00',4.21),('16100','2014-01-11','11:55:00',2.8),('16100','2014-01-11','12:00:00',2.91),('16100','2014-01-11','12:05:00',2.49),('16100','2014-01-11','12:10:00',2.23),('16100','2014-01-11','12:15:00',2.04),('16100','2014-01-11','12:20:00',1.92),('16100','2014-01-11','12:25:00',1.87),('16100','2014-01-11','12:30:00',2.01),('16100','2014-01-11','12:35:00',1.96),('16100','2014-01-11','12:40:00',1.76),('16100','2014-01-11','12:45:00',1.66),('16100','2014-01-11','12:50:00',1.74),('16100','2014-01-11','12:55:00',1.79),('16100','2014-01-11','13:00:00',1.7),('16100','2014-01-11','13:05:00',1.71),('16100','2014-01-11','13:10:00',1.72),('16100','2014-01-11','13:15:00',1.72),('16100','2014-01-11','13:20:00',1.77),('16100','2014-01-11','13:25:00',1.92),('16100','2014-01-11','13:30:00',2.11),('16100','2014-01-11','13:35:00',2.11),('16100','2014-01-11','13:40:00',1.98),('16100','2014-01-11','13:45:00',1.85),('16100','2014-01-11','13:50:00',1.83),('16100','2014-01-11','13:55:00',1.73),('16100','2014-01-11','14:00:00',1.46),('16100','2014-01-11','14:05:00',1.3),('16100','2014-01-11','14:10:00',1.23),('16100','2014-01-11','14:15:00',1.11),('16100','2014-01-11','14:20:00',1),('16100','2014-01-10','09:20:00',1.33),('16100','2014-01-10','09:25:00',1.1),('16100','2014-01-10','09:45:00',1.72),('16100','2014-01-10','09:50:00',2.6),('16100','2014-01-10','09:55:00',2.95),('16100','2014-01-10','10:00:00',2.57),('16100','2014-01-10','10:05:00',2.35),('16100','2014-01-10','10:10:00',2.91),('16100','2014-01-10','10:15:00',2.9),('16100','2014-01-10','10:20:00',3.71),('16100','2014-01-10','10:25:00',3.29),('16100','2014-01-10','10:30:00',3.55),('16100','2014-01-10','10:35:00',3.92),('16100','2014-01-10','10:40:00',4.51),('16100','2014-01-10','10:45:00',4.8),('16100','2014-01-10','10:50:00',4.81),('16100','2014-01-10','10:55:00',4.83),('16100','2014-01-10','11:00:00',4.84),('16100','2014-01-10','11:05:00',4.31),('16100','2014-01-10','11:10:00',3.97),('16100','2014-01-10','11:15:00',3.91),('16100','2014-01-10','11:20:00',3.64),('16100','2014-01-10','11:25:00',3.32),('16100','2014-01-10','11:30:00',3.45),('16100','2014-01-10','11:35:00',4.15),('16100','2014-01-10','11:40:00',3.87),('16100','2014-01-10','11:45:00',3.93),('16100','2014-01-10','11:50:00',4.04),('16100','2014-01-10','11:55:00',4.15),('16100','2014-01-10','12:00:00',4.02),('16100','2014-01-10','12:05:00',3.86),('16100','2014-01-10','12:10:00',4.61),('16100','2014-01-10','12:15:00',5.17),('16100','2014-01-10','12:20:00',3.32),('16100','2014-01-10','12:25:00',3.13),('16100','2014-01-10','12:30:00',3.1),('16100','2014-01-10','12:35:00',2.54),('16100','2014-01-10','12:40:00',3.69),('16100','2014-01-10','12:45:00',3.52),('16100','2014-01-10','12:50:00',4.22),('16100','2014-01-10','12:55:00',4.44),('16100','2014-01-10','13:00:00',4.52),('16100','2014-01-10','13:05:00',4.89),('16100','2014-01-10','13:10:00',3.55),('16100','2014-01-10','13:15:00',3.67),('16100','2014-01-10','13:20:00',3.42),('16100','2014-01-10','13:25:00',2.69),('16100','2014-01-10','13:30:00',2.61),('16100','2014-01-10','13:35:00',2.4),('16100','2014-01-10','13:40:00',2.29),('16100','2014-01-10','13:45:00',1.74),('16100','2014-01-10','13:50:00',1.79),('16100','2014-01-10','13:55:00',2.32),('16100','2014-01-10','14:00:00',2.68),('16100','2014-01-10','14:05:00',2.65),('16100','2014-01-10','14:10:00',1.4),('16100','2014-01-10','14:15:00',1.08),('16100','2014-01-10','14:30:00',1.1),('16100','2014-01-10','14:35:00',1.21),('16100','2014-01-10','14:40:00',1.27),('16100','2014-01-10','14:45:00',1.21),('16100','2014-01-10','14:50:00',1.06),('16100','2014-01-10','14:55:00',1),('16100','2014-01-09','10:40:00',1.02),('16100','2014-01-09','10:45:00',1.07),('16100','2014-01-09','10:50:00',1.06),('16100','2014-01-09','10:55:00',1.13),('16100','2014-01-09','11:00:00',1.22),('16100','2014-01-09','11:05:00',1.15),('16100','2014-01-09','11:10:00',1.06),('16100','2014-01-09','11:25:00',1.02),('16100','2014-01-09','11:30:00',1.21),('16100','2014-01-09','11:35:00',1.28),('16100','2014-01-09','11:40:00',1.25),('16100','2014-01-09','11:45:00',1.47),('16100','2014-01-09','11:50:00',1.76),('16100','2014-01-09','11:55:00',1.68),('16100','2014-01-09','12:00:00',1.3),('16100','2014-01-09','12:10:00',1),('16100','2014-01-09','12:15:00',1.12),('16100','2014-01-09','12:20:00',1.23),('16100','2014-01-09','12:25:00',1.2),('16100','2014-01-09','12:30:00',1.28),('16100','2014-01-09','12:35:00',1.23),('16100','2014-01-09','12:40:00',1.19),('16100','2014-01-09','12:45:00',1.25),('16100','2014-01-09','12:50:00',1.33),('16100','2014-01-09','12:55:00',1.26),('16100','2014-01-09','13:00:00',1.26),('16100','2014-01-09','13:05:00',1.2),('16100','2014-01-09','13:10:00',1.01),('16100','2014-01-09','13:35:00',1.01),('16100','2014-01-09','13:45:00',1.05),('16100','2014-01-09','13:50:00',1.05),('16100','2014-01-08','09:20:00',1.07),('16100','2014-01-08','09:25:00',1.12),('16100','2014-01-08','09:30:00',1.14),('16100','2014-01-08','09:35:00',1.12),('16100','2014-01-08','09:40:00',1.26),('16100','2014-01-08','09:45:00',1.61),('16100','2014-01-08','09:50:00',1.76),('16100','2014-01-08','09:55:00',1.77),('16100','2014-01-08','10:00:00',1.62),('16100','2014-01-08','10:05:00',1.52),('16100','2014-01-08','10:10:00',1.64),('16100','2014-01-08','10:15:00',1.7),('16100','2014-01-08','10:20:00',1.64),('16100','2014-01-08','10:25:00',1.61),('16100','2014-01-08','10:30:00',1.79),('16100','2014-01-08','10:35:00',1.93),('16100','2014-01-08','10:40:00',2.28),('16100','2014-01-08','10:45:00',2.06),('16100','2014-01-08','10:50:00',1.87),('16100','2014-01-08','10:55:00',1.73),('16100','2014-01-08','11:00:00',1.69),('16100','2014-01-08','11:05:00',1.73),('16100','2014-01-08','11:10:00',1.96),('16100','2014-01-08','11:15:00',2.06),('16100','2014-01-08','11:20:00',2.5),('16100','2014-01-08','11:25:00',2.58),('16100','2014-01-08','11:30:00',1.98),('16100','2014-01-08','11:35:00',2.08),('16100','2014-01-08','11:40:00',2.12),('16100','2014-01-08','11:45:00',2.68),('16100','2014-01-08','11:50:00',2.7),('16100','2014-01-08','11:55:00',2.84),('16100','2014-01-08','12:00:00',2.57),('16100','2014-01-08','12:05:00',2.67),('16100','2014-01-08','12:10:00',3.19),('16100','2014-01-08','12:15:00',2.52),('16100','2014-01-08','12:20:00',3.69),('16100','2014-01-08','12:25:00',2.89),('16100','2014-01-08','12:30:00',1.88),('16100','2014-01-08','12:35:00',2.54),('16100','2014-01-08','12:40:00',3.57),('16100','2014-01-08','12:45:00',3.21),('16100','2014-01-08','12:50:00',3.36),('16100','2014-01-08','12:55:00',2.8),('16100','2014-01-08','13:00:00',2.96),('16100','2014-01-08','13:05:00',2.72),('16100','2014-01-08','13:10:00',2.8),('16100','2014-01-08','13:15:00',2.84),('16100','2014-01-08','13:20:00',2.18),('16100','2014-01-08','13:25:00',2),('16100','2014-01-08','13:30:00',1.99),('16100','2014-01-08','13:35:00',2.12),('16100','2014-01-08','13:40:00',1.8),('16100','2014-01-08','13:45:00',1.67),('16100','2014-01-08','13:50:00',1.8),('16100','2014-01-08','13:55:00',2.05),('16100','2014-01-08','14:00:00',1.91),('16100','2014-01-08','14:05:00',1.5),('16100','2014-01-08','14:10:00',1.51),('16100','2014-01-08','14:15:00',1.48),('16100','2014-01-08','14:20:00',1.41),('16100','2014-01-08','14:25:00',1.69),('16100','2014-01-08','14:30:00',1.76),('16100','2014-01-08','14:35:00',1.49),('16100','2014-01-08','14:40:00',1.45),('16100','2014-01-08','14:45:00',1.72),('16100','2014-01-08','14:50:00',1.72),('16100','2014-01-08','14:55:00',1.69),('16100','2014-01-08','15:00:00',1.63),('16100','2014-01-08','15:05:00',1.34),('16100','2014-01-08','15:10:00',1.13),('16100','2014-01-08','15:15:00',1.06),('16100','2014-01-07','08:25:00',1.03),('16100','2014-01-07','08:30:00',1.19),('16100','2014-01-07','08:35:00',1.34),('16100','2014-01-07','08:40:00',1.39),('16100','2014-01-07','08:45:00',1.34),('16100','2014-01-07','08:50:00',1.55),('16100','2014-01-07','08:55:00',1.98),('16100','2014-01-07','09:00:00',2.12),('16100','2014-01-07','09:05:00',2.32),('16100','2014-01-07','09:10:00',2.51),('16100','2014-01-07','09:15:00',2.62),('16100','2014-01-07','09:20:00',2.77),('16100','2014-01-07','09:25:00',2.93),('16100','2014-01-07','09:30:00',2.82),('16100','2014-01-07','09:35:00',3.09),('16100','2014-01-07','09:40:00',3.25),('16100','2014-01-07','09:45:00',3.33),('16100','2014-01-07','09:50:00',3.57),('16100','2014-01-07','09:55:00',3.7),('16100','2014-01-07','10:00:00',3.52),('16100','2014-01-07','10:05:00',3.66),('16100','2014-01-07','10:10:00',3.85),('16100','2014-01-07','10:15:00',4.18),('16100','2014-01-07','10:20:00',4.36),('16100','2014-01-07','10:25:00',4.43),('16100','2014-01-07','10:30:00',4.39),('16100','2014-01-07','10:35:00',4.12),('16100','2014-01-07','10:40:00',4.49),('16100','2014-01-07','10:45:00',4.67),('16100','2014-01-07','10:50:00',4.73),('16100','2014-01-07','10:55:00',4.81),('16100','2014-01-07','11:00:00',4.82),('16100','2014-01-07','11:05:00',4.92),('16100','2014-01-07','11:10:00',4.93),('16100','2014-01-07','11:15:00',4.94),('16100','2014-01-07','11:20:00',4.93),('16100','2014-01-07','11:25:00',4.92),('16100','2014-01-07','11:30:00',5.16),('16100','2014-01-07','11:35:00',5.21),('16100','2014-01-07','11:40:00',5.17),('16100','2014-01-07','11:45:00',5.15),('16100','2014-01-07','11:50:00',5.15),('16100','2014-01-07','11:55:00',5.02),('16100','2014-01-07','12:00:00',5.01),('16100','2014-01-07','12:05:00',5.12),('16100','2014-01-07','12:10:00',5.25),('16100','2014-01-07','12:15:00',5.28),('16100','2014-01-07','12:20:00',5.29),('16100','2014-01-07','12:25:00',5.18),('16100','2014-01-07','12:30:00',5.2),('16100','2014-01-07','12:35:00',5.06),('16100','2014-01-07','12:40:00',4.91),('16100','2014-01-07','12:45:00',4.79),('16100','2014-01-07','12:50:00',4.8),('16100','2014-01-07','12:55:00',4.71),('16100','2014-01-07','13:00:00',4.79),('16100','2014-01-07','13:05:00',4.65),('16100','2014-01-07','13:10:00',4.79),('16100','2014-01-07','13:15:00',4.91),('16100','2014-01-07','13:20:00',4.7),('16100','2014-01-07','13:25:00',4.64),('16100','2014-01-07','13:30:00',4.46),('16100','2014-01-07','13:35:00',4.67),('16100','2014-01-07','13:40:00',4.7),('16100','2014-01-07','13:45:00',4.62),('16100','2014-01-07','13:50:00',4.42),('16100','2014-01-07','13:55:00',4.44),('16100','2014-01-07','14:00:00',4.3),('16100','2014-01-07','14:05:00',4.19),('16100','2014-01-07','14:10:00',3.92),('16100','2014-01-07','14:15:00',3.75),('16100','2014-01-07','14:20:00',3.31),('16100','2014-01-07','14:25:00',3.48),('16100','2014-01-07','14:30:00',3.89),('16100','2014-01-07','14:35:00',3.51),('16100','2014-01-07','14:40:00',3.16),('16100','2014-01-07','14:45:00',3.27),('16100','2014-01-07','14:50:00',3.15),('16100','2014-01-07','14:55:00',2.61),('16100','2014-01-07','15:00:00',2.49),('16100','2014-01-07','15:05:00',2.24),('16100','2014-01-07','15:10:00',2.08),('16100','2014-01-07','15:15:00',2.01),('16100','2014-01-07','15:20:00',2.28),('16100','2014-01-07','15:25:00',2),('16100','2014-01-07','15:30:00',1.83),('16100','2014-01-07','15:35:00',1.87),('16100','2014-01-07','15:40:00',1.75),('16100','2014-01-07','15:45:00',1.59),('16100','2014-01-07','15:50:00',1.31),('16100','2014-01-07','15:55:00',1.11),('16100','2014-01-06','08:25:00',1.11),('16100','2014-01-06','08:30:00',1.27),('16100','2014-01-06','08:35:00',1.43),('16100','2014-01-06','08:40:00',1.59),('16100','2014-01-06','08:45:00',1.76),('16100','2014-01-06','08:50:00',1.92),('16100','2014-01-06','08:55:00',2.09),('16100','2014-01-06','09:00:00',2.29),('16100','2014-01-06','09:05:00',2.44),('16100','2014-01-06','09:10:00',2.56),('16100','2014-01-06','09:15:00',2.71),('16100','2014-01-06','09:20:00',2.88),('16100','2014-01-06','09:25:00',3.03),('16100','2014-01-06','09:30:00',3.19),('16100','2014-01-06','09:35:00',3.35),('16100','2014-01-06','09:40:00',3.49),('16100','2014-01-06','09:45:00',3.62),('16100','2014-01-06','09:50:00',3.81),('16100','2014-01-06','09:55:00',3.9),('16100','2014-01-06','10:00:00',3.97),('16100','2014-01-06','10:05:00',4.09),('16100','2014-01-06','10:10:00',4.18),('16100','2014-01-06','10:15:00',4.31),('16100','2014-01-06','10:20:00',4.44),('16100','2014-01-06','10:25:00',4.52),('16100','2014-01-06','10:30:00',4.62),('16100','2014-01-06','10:35:00',4.7),('16100','2014-01-06','10:40:00',4.76),('16100','2014-01-06','10:45:00',4.83),('16100','2014-01-06','10:50:00',4.9),('16100','2014-01-06','10:55:00',4.94),('16100','2014-01-06','11:00:00',4.94),('16100','2014-01-06','11:05:00',5.02),('16100','2014-01-06','11:10:00',5.05),('16100','2014-01-06','11:15:00',5.08),('16100','2014-01-06','11:20:00',5.22),('16100','2014-01-06','11:25:00',5.24),('16100','2014-01-06','11:30:00',5.27),('16100','2014-01-06','11:35:00',5.28),('16100','2014-01-06','11:40:00',5.26),('16100','2014-01-06','11:45:00',5.29),('16100','2014-01-06','11:50:00',5.24),('16100','2014-01-06','11:55:00',5.26),('16100','2014-01-06','12:00:00',5.29),('16100','2014-01-06','12:05:00',5.34),('16100','2014-01-06','12:10:00',5.41),('16100','2014-01-06','12:15:00',5.44),('16100','2014-01-06','12:20:00',5.51),('16100','2014-01-06','12:25:00',5.59),('16100','2014-01-06','12:30:00',5.55),('16100','2014-01-06','12:35:00',5.59),('16100','2014-01-06','12:40:00',5.47),('16100','2014-01-06','12:45:00',5.48),('16100','2014-01-06','12:50:00',5.36),('16100','2014-01-06','12:55:00',5.49),('16100','2014-01-06','13:00:00',5.41),('16100','2014-01-06','13:05:00',5.29),('16100','2014-01-06','13:10:00',5.3),('16100','2014-01-06','13:15:00',5.13),('16100','2014-01-06','13:20:00',4.88),('16100','2014-01-06','13:25:00',4.72),('16100','2014-01-06','13:30:00',4.81),('16100','2014-01-06','13:35:00',4.8),('16100','2014-01-06','13:40:00',4.87),('16100','2014-01-06','13:45:00',4.88),('16100','2014-01-06','13:50:00',4.71),('16100','2014-01-06','13:55:00',4.58),('16100','2014-01-06','14:00:00',4.4),('16100','2014-01-06','14:05:00',4.07),('16100','2014-01-06','14:10:00',4.2),('16100','2014-01-06','14:15:00',4.17),('16100','2014-01-06','14:20:00',4),('16100','2014-01-06','14:25:00',3.99),('16100','2014-01-06','14:30:00',3.74),('16100','2014-01-06','14:35:00',3.79),('16100','2014-01-06','14:40:00',3.63),('16100','2014-01-06','14:45:00',3.66),('16100','2014-01-06','14:50:00',3.41),('16100','2014-01-06','14:55:00',3.34),('16100','2014-01-06','15:00:00',3.29),('16100','2014-01-06','15:05:00',3.25),('16100','2014-01-06','15:10:00',3),('16100','2014-01-06','15:15:00',2.85),('16100','2014-01-06','15:20:00',2.7),('16100','2014-01-06','15:25:00',2.39),('16100','2014-01-06','15:30:00',2.15),('16100','2014-01-06','15:35:00',1.72),('16100','2014-01-06','15:40:00',1.52),('16100','2014-01-06','15:45:00',1.47),('16100','2014-01-06','15:50:00',1.49),('16100','2014-01-06','15:55:00',1.15),('16100','2014-01-06','16:00:00',1.09),('16100','2014-01-06','16:05:00',1.13),('16100','2014-01-06','16:10:00',1.09),('16100','2014-04-23','08:00:00',1.07),('16100','2014-04-23','08:05:00',1.23),('16100','2014-04-23','08:10:00',1.38),('16100','2014-04-23','08:15:00',1.62),('16100','2014-04-23','08:20:00',1.85),('16100','2014-04-23','08:25:00',2.06),('16100','2014-04-23','08:30:00',2.28),('16100','2014-04-23','08:35:00',2.46),('16100','2014-04-23','08:40:00',2.62),('16100','2014-04-23','08:45:00',2.8),('16100','2014-04-23','08:50:00',2.94),('16100','2014-04-23','08:55:00',3.11),('16100','2014-04-23','09:00:00',3.26),('16100','2014-04-23','09:05:00',3.44),('16100','2014-04-23','09:10:00',3.56),('16100','2014-04-23','09:15:00',3.73),('16100','2014-04-23','09:20:00',3.89),('16100','2014-04-23','09:25:00',4.01),('16100','2014-04-23','09:30:00',4.14),('16100','2014-04-23','09:35:00',4.31),('16100','2014-04-23','09:40:00',4.46),('16100','2014-04-23','09:45:00',4.58),('16100','2014-04-23','09:50:00',4.71),('16100','2014-04-23','09:55:00',4.83),('16100','2014-04-23','10:00:00',4.92),('16100','2014-04-23','10:05:00',5.03),('16100','2014-04-23','10:10:00',5.19),('16100','2014-04-23','10:15:00',5.32),('16100','2014-04-23','10:20:00',5.48),('16100','2014-04-23','10:25:00',5.56),('16100','2014-04-23','10:30:00',5.66),('16100','2014-04-23','10:35:00',5.8),('16100','2014-04-23','10:40:00',5.87),('16100','2014-04-23','10:45:00',5.93),('16100','2014-04-23','10:50:00',6.04),('16100','2014-04-23','10:55:00',6.15),('16100','2014-04-23','11:00:00',6.16),('16100','2014-04-23','11:05:00',6.31),('16100','2014-04-23','11:10:00',6.53),('16100','2014-04-23','11:15:00',6.52),('16100','2014-04-23','11:20:00',3.47),('16100','2014-04-23','11:25:00',3.82),('16100','2014-04-23','11:30:00',5.23),('16100','2014-04-23','11:35:00',6.02),('16100','2014-04-23','11:40:00',3.76),('16100','2014-04-23','11:45:00',6.15),('16100','2014-04-23','11:50:00',7.08),('16100','2014-04-23','11:55:00',7.17),('16100','2014-04-23','12:00:00',7.05),('16100','2014-04-23','12:05:00',6.96),('16100','2014-04-23','12:10:00',6.9),('16100','2014-04-23','12:15:00',7.05),('16100','2014-04-23','12:20:00',7.25),('16100','2014-04-23','12:25:00',7.18),('16100','2014-04-23','12:30:00',7.19),('16100','2014-04-23','12:35:00',7.18),('16100','2014-04-23','12:40:00',7.1),('16100','2014-04-23','12:45:00',7.33),('16100','2014-04-23','12:50:00',7.41),('16100','2014-04-23','12:55:00',7.49),('16100','2014-04-23','13:00:00',3.85),('16100','2014-04-23','13:05:00',4.99),('16100','2014-04-23','13:10:00',7.79),('16100','2014-04-23','13:15:00',7.57),('16100','2014-04-23','13:20:00',7.62),('16100','2014-04-23','13:25:00',7.46),('16100','2014-04-23','13:30:00',7.41),('16100','2014-04-23','13:35:00',7.57),('16100','2014-04-23','13:40:00',7.86),('16100','2014-04-23','13:45:00',7.69),('16100','2014-04-23','13:50:00',7.8),('16100','2014-04-23','13:55:00',7.62),('16100','2014-04-23','14:00:00',7.64),('16100','2014-04-23','14:05:00',7.75),('16100','2014-04-23','14:10:00',7.55),('16100','2014-04-23','14:15:00',7.54),('16100','2014-04-23','14:20:00',7.79),('16100','2014-04-23','14:25:00',7.9),('16100','2014-04-23','14:30:00',8.05),('16100','2014-04-23','14:35:00',5.86),('16100','2014-04-23','14:40:00',7.02),('16100','2014-04-23','14:45:00',7.65),('16100','2014-04-23','14:50:00',7.33),('16100','2014-04-23','14:55:00',7.18),('16100','2014-04-23','15:00:00',6.54),('16100','2014-04-23','15:05:00',4.76),('16100','2014-04-23','15:10:00',7.28),('16100','2014-04-23','15:15:00',3.33),('16100','2014-04-23','15:20:00',4.04),('16100','2014-04-23','15:25:00',6.08),('16100','2014-04-23','15:30:00',6.28),('16100','2014-04-23','15:35:00',7.35),('16100','2014-04-23','15:40:00',4.98),('16100','2014-04-23','15:45:00',4.4),('16100','2014-04-23','15:50:00',4.95),('16100','2014-04-23','15:55:00',6.64),('16100','2014-04-23','16:00:00',5.93),('16100','2014-04-23','16:05:00',6.33),('16100','2014-04-23','16:10:00',6.31),('16100','2014-04-23','16:15:00',6.14),('16100','2014-04-23','16:20:00',4.38),('16100','2014-04-23','16:25:00',6.58),('16100','2014-04-23','16:30:00',6.29),('16100','2014-04-23','16:35:00',6.42),('16100','2014-04-23','16:40:00',4.96),('16100','2014-04-23','16:45:00',5.35),('16100','2014-04-23','16:50:00',3.89),('16100','2014-04-23','16:55:00',2.95),('16100','2014-04-23','17:00:00',2.53),('16100','2014-04-23','17:05:00',2.01),('16100','2014-04-23','17:10:00',2.29),('16100','2014-04-23','17:15:00',2.11),('16100','2014-04-23','17:20:00',1.92),('16100','2014-04-23','17:25:00',2.16),('16100','2014-04-23','17:30:00',1.6),('16100','2014-04-23','17:35:00',1.27),('16100','2014-01-05','10:25:00',1.49),('16100','2014-01-05','10:30:00',1.44),('16100','2014-01-05','10:35:00',1.4),('16100','2014-01-05','10:40:00',1.34),('16100','2014-01-05','10:45:00',1.35),('16100','2014-01-05','13:55:00',4.29),('16100','2014-01-05','14:00:00',4.51),('16100','2014-01-05','14:05:00',4.51),('16100','2014-01-05','14:10:00',2.64),('16100','2014-01-05','14:15:00',3.64),('16100','2014-01-05','14:20:00',4.11),('16100','2014-01-05','14:25:00',3.36),('16100','2014-01-05','14:30:00',1.14),('16100','2014-01-05','14:35:00',1.09),('16100','2014-01-05','14:40:00',3.59),('16100','2014-01-05','14:45:00',3.95),('16100','2014-01-05','14:50:00',3.58),('16100','2014-01-05','14:55:00',3.39),('16100','2014-01-05','15:00:00',3.35),('16100','2014-01-05','15:05:00',3.24),('16100','2014-01-05','15:10:00',1.08),('16100','2014-01-05','15:20:00',2.89),('16100','2014-01-05','15:25:00',2.73),('16100','2014-01-05','15:30:00',2.07),('16100','2014-01-05','15:50:00',1.47),('16100','2014-01-05','15:55:00',1.39),('16100','2014-01-05','16:00:00',1.2),('16100','2014-01-05','16:05:00',1.26),('16100','2014-01-05','16:10:00',1.05),('16100','2014-01-03','14:40:00',1.19),('16100','2014-01-03','14:55:00',1.09),('16100','2014-01-03','15:00:00',1.13),('16100','2014-01-02','08:45:00',1.77),('16100','2014-01-02','08:50:00',1.85),('16100','2014-01-02','08:55:00',2.01),('16100','2014-01-02','09:00:00',2.2),('16100','2014-01-02','09:05:00',2.39),('16100','2014-01-02','09:10:00',2.56),('16100','2014-01-02','09:15:00',2.74),('16100','2014-01-02','09:20:00',2.99),('16100','2014-01-02','09:25:00',3.28),('16100','2014-01-02','09:30:00',3.56),('16100','2014-01-02','09:35:00',3.82),('16100','2014-01-02','09:40:00',3.44),('16100','2014-01-02','09:45:00',1.03),('16100','2014-01-02','09:55:00',2.06),('16100','2014-01-02','10:00:00',3.87),('16100','2014-01-02','10:05:00',4.44),('16100','2014-01-02','10:10:00',3.4),('16100','2014-01-02','10:15:00',2.39),('16100','2014-01-02','10:20:00',2.18),('16100','2014-01-02','10:25:00',1.96),('16100','2014-01-02','10:30:00',2.27),('16100','2014-01-02','10:35:00',2.44),('16100','2014-01-02','10:40:00',2.17),('16100','2014-01-02','10:45:00',1.73),('16100','2014-01-02','10:50:00',2.04),('16100','2014-01-02','10:55:00',1.65),('16100','2014-01-02','11:00:00',1.54),('16100','2014-01-02','11:05:00',1.7),('16100','2014-01-02','11:10:00',1.72),('16100','2014-01-02','11:15:00',1.86),('16100','2014-01-02','11:20:00',1.58),('16100','2014-01-02','11:25:00',1.5),('16100','2014-01-02','11:30:00',1.33),('16100','2014-01-02','11:35:00',1.22),('16100','2014-01-02','11:40:00',1.55),('16100','2014-01-02','11:45:00',1.66),('16100','2014-01-02','11:50:00',1.64),('16100','2014-01-02','11:55:00',1.89),('16100','2014-01-02','12:00:00',2.31),('16100','2014-01-02','12:05:00',3.49),('16100','2014-01-02','12:10:00',4.64),('16100','2014-01-02','12:15:00',4.58),('16100','2014-01-02','12:20:00',3.96),('16100','2014-01-02','12:25:00',3.75),('16100','2014-01-02','12:30:00',4.02),('16100','2014-01-02','12:35:00',3.84),('16100','2014-01-02','12:40:00',3.76),('16100','2014-01-02','12:45:00',3.69),('16100','2014-01-02','12:50:00',3.72),('16100','2014-01-02','12:55:00',4.17),('16100','2014-01-02','13:00:00',4.02),('16100','2014-01-02','13:05:00',4.02),('16100','2014-01-02','13:10:00',3.85),('16100','2014-01-02','13:15:00',3.56),('16100','2014-01-02','13:20:00',2.95),('16100','2014-01-02','13:25:00',3.52),('16100','2014-01-02','13:30:00',2.98),('16100','2014-01-02','13:35:00',2.49),('16100','2014-01-02','13:40:00',2.59),('16100','2014-01-02','13:45:00',2.56),('16100','2014-01-02','13:50:00',1.95),('16100','2014-01-02','13:55:00',1.77),('16100','2014-01-02','14:00:00',1.48),('16100','2014-01-02','14:05:00',1.15),('16100','2014-01-01','08:35:00',1.29),('16100','2014-01-01','08:40:00',1.58),('16100','2014-01-01','08:45:00',1.18),('16100','2014-01-01','08:50:00',1.92),('16100','2014-01-01','08:55:00',2.11),('16100','2014-01-01','09:00:00',2.24),('16100','2014-01-01','09:05:00',2.42),('16100','2014-01-01','09:10:00',2.57),('16100','2014-01-01','09:15:00',2.74),('16100','2014-01-01','09:20:00',2.87),('16100','2014-01-01','09:25:00',3.01),('16100','2014-01-01','09:30:00',3.16),('16100','2014-01-01','09:35:00',3.28),('16100','2014-01-01','09:40:00',3.41),('16100','2014-01-01','09:45:00',3.54),('16100','2014-01-01','09:50:00',3.67),('16100','2014-01-01','09:55:00',3.78),('16100','2014-01-01','10:00:00',3.91),('16100','2014-01-01','10:05:00',4.02),('16100','2014-01-01','10:10:00',4.16),('16100','2014-01-01','10:15:00',4.29),('16100','2014-01-01','10:20:00',4.39),('16100','2014-01-01','10:25:00',4.5),('16100','2014-01-01','10:30:00',4.6),('16100','2014-01-01','10:35:00',4.69),('16100','2014-01-01','10:40:00',4.81),('16100','2014-01-01','10:45:00',4.91),('16100','2014-01-01','10:50:00',5.08),('16100','2014-01-01','10:55:00',4.45),('16100','2014-01-01','11:00:00',3.96),('16100','2014-01-01','11:05:00',4.93),('16100','2014-01-01','11:10:00',4.23),('16100','2014-01-01','11:15:00',2.86),('16100','2014-01-01','11:20:00',2.45),('16100','2014-01-01','11:25:00',2.58),('16100','2014-01-01','11:30:00',2.8),('16100','2014-01-01','11:35:00',3.36),('16100','2014-01-01','11:40:00',2.85),('16100','2014-01-01','11:45:00',2.38),('16100','2014-01-01','11:50:00',2.14),('16100','2014-01-01','11:55:00',2.13),('16100','2014-01-01','12:00:00',1.89),('16100','2014-01-01','12:05:00',1.54),('16100','2014-01-01','12:10:00',1.17),('16100','2014-01-01','12:15:00',1.2),('16100','2014-01-01','12:20:00',1.5),('16100','2014-01-01','12:25:00',1.47),('16100','2014-01-01','12:30:00',1.46),('16100','2014-01-01','12:35:00',1.68),('16100','2014-01-01','12:40:00',1.9),('16100','2014-01-01','12:45:00',2.45),('16100','2014-01-01','12:50:00',3.94),('16100','2014-01-01','12:55:00',5.75),('16100','2014-01-01','13:00:00',4.98),('16100','2014-01-01','13:05:00',1.17),('16100','2014-01-01','13:10:00',1.25),('16100','2014-01-01','13:15:00',1.24),('16100','2014-01-01','13:20:00',1.36),('16100','2014-01-01','13:25:00',1.76),('16100','2014-01-01','13:30:00',2.24),('16100','2014-01-01','13:35:00',1.32),('16100','2014-01-01','13:40:00',1.01),('16100','2013-12-31','08:25:00',1.12),('16100','2013-12-31','08:30:00',1.33),('16100','2013-12-31','08:35:00',1.54),('16100','2013-12-31','08:40:00',1.73),('16100','2013-12-31','08:45:00',2.01),('16100','2013-12-31','08:50:00',2.34),('16100','2013-12-31','08:55:00',1.86),('16100','2013-12-31','09:05:00',1.15),('16100','2013-12-31','09:10:00',1.09),('16100','2013-12-31','09:25:00',1.03),('16100','2013-12-31','09:30:00',1.12),('16100','2013-12-31','09:35:00',1.46),('16100','2013-12-31','09:40:00',1.68),('16100','2013-12-31','09:45:00',1.73),('16100','2013-12-31','09:50:00',1.65),('16100','2013-12-31','09:55:00',1.82),('16100','2013-12-31','10:00:00',1.88),('16100','2013-12-31','10:05:00',1.73),('16100','2013-12-31','10:10:00',1.39),('16100','2013-12-31','10:15:00',1.27),('16100','2013-12-31','10:20:00',1.24),('16100','2013-12-31','10:25:00',1.25),('16100','2013-12-31','10:30:00',1.19),('16100','2013-12-31','10:35:00',1.17),('16100','2013-12-31','10:40:00',1.1),('16100','2013-12-31','10:45:00',1.23),('16100','2013-12-31','10:50:00',1.44),('16100','2013-12-31','10:55:00',1.5),('16100','2013-12-31','11:00:00',1.48),('16100','2013-12-31','11:05:00',1.47),('16100','2013-12-31','11:10:00',1.54),('16100','2013-12-31','11:15:00',1.56),('16100','2013-12-31','11:20:00',1.67),('16100','2013-12-31','11:25:00',1.65),('16100','2013-12-31','11:30:00',1.66),('16100','2013-12-31','11:35:00',1.86),('16100','2013-12-31','11:40:00',1.89),('16100','2013-12-31','11:45:00',1.79),('16100','2013-12-31','11:50:00',1.74),('16100','2013-12-31','11:55:00',1.79),('16100','2013-12-31','12:00:00',1.84),('16100','2013-12-31','12:05:00',2.03),('16100','2013-12-31','12:10:00',2.33),('16100','2013-12-31','12:15:00',2.32),('16100','2013-12-31','12:20:00',2.32),('16100','2013-12-31','12:25:00',2.35),('16100','2013-12-31','12:30:00',2.3),('16100','2013-12-31','12:35:00',2.12),('16100','2013-12-31','12:40:00',2.14),('16100','2013-12-31','12:45:00',2.55),('16100','2013-12-31','12:50:00',2.54),('16100','2013-12-31','12:55:00',2.65),('16100','2013-12-31','13:00:00',2.18),('16100','2013-12-31','13:05:00',1.99),('16100','2013-12-31','13:10:00',1.87),('16100','2013-12-31','13:15:00',2.16),('16100','2013-12-31','13:25:00',2.17),('16100','2013-12-31','13:30:00',3.49),('16100','2013-12-31','13:35:00',6.04),('16100','2013-12-31','13:40:00',4.64),('16100','2013-12-31','13:45:00',3.53),('16100','2013-12-31','13:50:00',2.73),('16100','2013-12-31','13:55:00',2.65),('16100','2013-12-31','14:00:00',1.81),('16100','2013-12-31','14:05:00',2.01),('16100','2013-12-31','14:10:00',2.19),('16100','2013-12-31','14:15:00',2.91),('16100','2013-12-31','14:20:00',1.57),('16100','2013-12-31','14:25:00',1.43),('16100','2013-12-31','14:30:00',1.38),('16100','2013-12-31','14:35:00',1.51),('16100','2013-12-31','14:40:00',1.89),('16100','2013-12-31','14:45:00',1.88),('16100','2013-12-31','14:50:00',2.14),('16100','2013-12-31','14:55:00',2.99),('16100','2013-12-31','15:00:00',2.82),('16100','2013-12-31','15:05:00',2.46),('16100','2013-12-31','15:10:00',2.75),('16100','2013-12-31','15:15:00',2.66),('16100','2013-12-31','15:20:00',2.43),('16100','2013-12-31','15:25:00',2.24),('16100','2013-12-31','15:30:00',2.09),('16100','2013-12-31','15:35:00',1.9),('16100','2013-12-31','15:40:00',1.76),('16100','2013-12-31','15:45:00',1.57),('16100','2013-12-31','15:50:00',1.39),('16100','2013-12-31','15:55:00',1.2),('16100','2013-12-31','16:00:00',1.02),('16100','2013-12-30','08:45:00',1.5),('16100','2013-12-30','08:50:00',2.25),('16100','2013-12-30','08:55:00',2.46),('16100','2013-12-30','09:00:00',2.62),('16100','2013-12-30','09:05:00',2.77),('16100','2013-12-30','09:10:00',2.84),('16100','2013-12-30','09:15:00',3.01),('16100','2013-12-30','09:20:00',3.13),('16100','2013-12-30','09:25:00',3.5),('16100','2013-12-30','09:30:00',3.78),('16100','2013-12-30','09:35:00',3.82),('16100','2013-12-30','09:40:00',4.1),('16100','2013-12-30','09:45:00',4.08),('16100','2013-12-30','09:50:00',2.89),('16100','2013-12-30','09:55:00',2.26),('16100','2013-12-30','10:00:00',3.89),('16100','2013-12-30','10:05:00',3.09),('16100','2013-12-30','10:10:00',3.34),('16100','2013-12-30','10:15:00',4.73),('16100','2013-12-30','10:20:00',2.72),('16100','2013-12-30','10:25:00',1.99),('16100','2013-12-30','10:30:00',1.77),('16100','2013-12-30','10:35:00',1.75),('16100','2013-12-30','10:40:00',1.83),('16100','2013-12-30','10:45:00',2.2),('16100','2013-12-30','10:50:00',1.82),('16100','2013-12-30','10:55:00',1.66),('16100','2013-12-30','11:00:00',2.18),('16100','2013-12-30','11:05:00',2.27),('16100','2013-12-30','11:10:00',3.71),('16100','2013-12-30','11:15:00',2.12),('16100','2013-12-30','11:20:00',2.63),('16100','2013-12-30','11:25:00',2.9),('16100','2013-12-30','11:30:00',6.21),('16100','2013-12-30','11:35:00',5.88),('16100','2013-12-30','11:40:00',6.06),('16100','2013-12-30','11:45:00',5.84),('16100','2013-12-30','11:50:00',5.82),('16100','2013-12-30','11:55:00',5.84),('16100','2013-12-30','12:00:00',5.79),('16100','2013-12-30','12:05:00',5.65),('16100','2013-12-30','12:10:00',5.67),('16100','2013-12-30','12:15:00',5.64),('16100','2013-12-30','12:20:00',5.58),('16100','2013-12-30','12:25:00',5.53),('16100','2013-12-30','12:30:00',5.47),('16100','2013-12-30','12:35:00',5.47),('16100','2013-12-30','12:40:00',5.42),('16100','2013-12-30','12:45:00',5.32),('16100','2013-12-30','12:50:00',5.33),('16100','2013-12-30','12:55:00',5.29),('16100','2013-12-30','13:00:00',5.28),('16100','2013-12-30','13:05:00',5.2),('16100','2013-12-30','13:10:00',5.22),('16100','2013-12-30','13:15:00',5.15),('16100','2013-12-30','13:20:00',5.1),('16100','2013-12-30','13:25:00',5.04),('16100','2013-12-30','13:30:00',4.95),('16100','2013-12-30','13:35:00',4.92),('16100','2013-12-30','13:40:00',4.84),('16100','2013-12-30','13:45:00',4.78),('16100','2013-12-30','13:50:00',4.7),('16100','2013-12-30','13:55:00',4.58),('16100','2013-12-30','14:00:00',4.5),('16100','2013-12-30','14:05:00',4.41),('16100','2013-12-30','14:10:00',4.3),('16100','2013-12-30','14:15:00',4.2),('16100','2013-12-30','14:20:00',4.12),('16100','2013-12-30','14:25:00',3.99),('16100','2013-12-30','14:30:00',3.85),('16100','2013-12-30','14:35:00',3.71),('16100','2013-12-30','14:40:00',3.56),('16100','2013-12-30','14:45:00',3.43),('16100','2013-12-30','14:50:00',3.31),('16100','2013-12-30','14:55:00',3.2),('16100','2013-12-30','15:00:00',3.06),('16100','2013-12-30','15:05:00',2.93),('16100','2013-12-30','15:10:00',2.78),('16100','2013-12-30','15:15:00',2.64),('16100','2013-12-30','15:20:00',2.5),('16100','2013-12-30','15:25:00',2.36),('16100','2013-12-30','15:30:00',2.2),('16100','2013-12-30','15:35:00',2),('16100','2013-12-30','15:40:00',1.83),('16100','2013-12-30','15:45:00',1.66),('16100','2013-12-30','15:50:00',1.48),('16100','2013-12-30','15:55:00',1.3),('16100','2013-12-30','16:00:00',1.13),('16100','2013-12-29','11:20:00',1.04),('16100','2013-12-29','11:25:00',1.29),('16100','2013-12-29','11:30:00',1.38),('16100','2013-12-29','11:35:00',1.42),('16100','2013-12-29','11:40:00',1.3),('16100','2013-12-29','11:45:00',1.28),('16100','2013-12-29','11:50:00',1.13),('16100','2013-12-29','11:55:00',1.01),('16100','2013-12-29','12:05:00',1.04),('16100','2013-12-29','12:10:00',1.07),('16100','2013-12-29','12:15:00',1.04),('16100','2013-12-29','12:40:00',1.05),('16100','2013-12-29','12:45:00',1.11),('16100','2013-12-29','12:50:00',1.13),('16100','2013-12-29','12:55:00',1.08),('16100','2013-12-29','13:00:00',1.05),('16100','2013-12-29','13:05:00',1.09),('16100','2013-12-29','13:10:00',1.05),('16100','2013-12-29','13:15:00',1.03),('16100','2013-12-29','13:20:00',1.03),('16100','2013-12-29','13:25:00',1.03),('16100','2013-12-28','08:15:00',1.16),('16100','2013-12-28','09:10:00',1.61),('16100','2013-12-28','09:15:00',2.42),('16100','2013-12-28','09:20:00',2.84),('16100','2013-12-28','09:25:00',2.6),('16100','2013-12-28','09:30:00',2.21),('16100','2013-12-28','09:35:00',3.15),('16100','2013-12-28','09:40:00',3.9),('16100','2013-12-28','09:45:00',4.14),('16100','2013-12-28','09:50:00',3.9),('16100','2013-12-28','09:55:00',3.31),('16100','2013-12-28','10:00:00',2.15),('16100','2013-12-28','10:05:00',2.3),('16100','2013-12-28','10:10:00',3.51),('16100','2013-12-28','10:15:00',4.46),('16100','2013-12-28','10:20:00',4.93),('16100','2013-12-28','10:25:00',5.25),('16100','2013-12-28','10:30:00',2.55),('16100','2013-12-28','10:35:00',2.61),('16100','2013-12-28','10:40:00',2.73),('16100','2013-12-28','10:45:00',2.99),('16100','2013-12-28','10:50:00',4.73),('16100','2013-12-28','10:55:00',1.25),('16100','2013-12-28','11:25:00',1.43),('16100','2013-12-28','11:30:00',1.88),('16100','2013-12-28','11:35:00',2.06),('16100','2013-12-28','11:40:00',2.66),('16100','2013-12-28','11:45:00',1.4),('16100','2013-12-28','11:55:00',1),('16100','2013-12-27','08:20:00',1.06),('16100','2013-12-27','08:25:00',1.24),('16100','2013-12-27','08:30:00',1.41),('16100','2013-12-27','08:35:00',1.57),('16100','2013-12-27','08:40:00',1.73),('16100','2013-12-27','08:45:00',1.9),('16100','2013-12-27','08:50:00',2.07),('16100','2013-12-27','08:55:00',2.22),('16100','2013-12-27','09:00:00',2.38),('16100','2013-12-27','09:05:00',2.57),('16100','2013-12-27','09:10:00',2.72),('16100','2013-12-27','09:15:00',2.91),('16100','2013-12-27','09:20:00',3.08),('16100','2013-12-27','09:25:00',3.21),('16100','2013-12-27','09:30:00',3.33),('16100','2013-12-27','09:35:00',3.46),('16100','2013-12-27','09:40:00',3.6),('16100','2013-12-27','09:45:00',3.76),('16100','2013-12-27','09:50:00',3.89),('16100','2013-12-27','09:55:00',4.01),('16100','2013-12-27','10:00:00',4.13),('16100','2013-12-27','10:05:00',4.25),('16100','2013-12-27','10:10:00',4.36),('16100','2013-12-27','10:15:00',4.47),('16100','2013-12-27','10:20:00',4.58),('16100','2013-12-27','10:25:00',4.69),('16100','2013-12-27','10:30:00',4.78),('16100','2013-12-27','10:35:00',4.85),('16100','2013-12-27','10:40:00',4.91),('16100','2013-12-27','10:45:00',4.96),('16100','2013-12-27','10:50:00',5.01),('16100','2013-12-27','10:55:00',5.05),('16100','2013-12-27','11:00:00',5.12),('16100','2013-12-27','11:05:00',5.17),('16100','2013-12-27','11:10:00',5.23),('16100','2013-12-27','11:15:00',5.31),('16100','2013-12-27','11:20:00',5.33),('16100','2013-12-27','11:25:00',5.33),('16100','2013-12-27','11:30:00',5.35),('16100','2013-12-27','11:35:00',5.4),('16100','2013-12-27','11:40:00',5.43),('16100','2013-12-27','11:45:00',5.45),('16100','2013-12-27','11:50:00',5.49),('16100','2013-12-27','11:55:00',5.51),('16100','2013-12-27','12:00:00',5.51),('16100','2013-12-27','12:05:00',5.53),('16100','2013-12-27','12:10:00',5.53),('16100','2013-12-27','12:15:00',5.52),('16100','2013-12-27','12:20:00',5.54),('16100','2013-12-27','12:25:00',5.49),('16100','2013-12-27','12:30:00',5.58),('16100','2013-12-27','12:35:00',5.5),('16100','2013-12-27','12:40:00',5.39),('16100','2013-12-27','12:45:00',5.32),('16100','2013-12-27','12:50:00',5.31),('16100','2013-12-27','12:55:00',5.21),('16100','2013-12-27','13:00:00',5.19),('16100','2013-12-27','13:05:00',5.17),('16100','2013-12-27','13:10:00',5.11),('16100','2013-12-27','13:15:00',4.98),('16100','2013-12-27','13:20:00',4.98),('16100','2013-12-27','13:25:00',4.84),('16100','2013-12-27','13:30:00',4.71),('16100','2013-12-27','13:35:00',4.67),('16100','2013-12-27','13:40:00',4.59),('16100','2013-12-27','13:45:00',4.48),('16100','2013-12-27','13:50:00',4.44),('16100','2013-12-27','13:55:00',4.37),('16100','2013-12-27','14:00:00',4.26),('16100','2013-12-27','14:05:00',4.22),('16100','2013-12-27','14:10:00',4.06),('16100','2013-12-27','14:15:00',4.04),('16100','2013-12-27','14:20:00',4),('16100','2013-12-27','14:25:00',3.92),('16100','2013-12-27','14:30:00',3.81),('16100','2013-12-27','14:35:00',3.74),('16100','2013-12-27','14:40:00',3.19),('16100','2013-12-27','14:45:00',1.75),('16100','2013-12-27','14:50:00',1.8),('16100','2013-12-27','14:55:00',2.35),('16100','2013-12-27','15:00:00',3.2),('16100','2013-12-27','15:05:00',2.96),('16100','2013-12-27','15:10:00',2.81),('16100','2013-12-27','15:15:00',2.64),('16100','2013-12-27','15:20:00',2.49),('16100','2013-12-27','15:25:00',2.22),('16100','2013-12-27','15:30:00',2.13),('16100','2013-12-27','15:35:00',1.98),('16100','2013-12-27','15:40:00',1.73),('16100','2013-12-27','15:45:00',1.68),('16100','2013-12-27','15:50:00',1.52),('16100','2013-12-27','15:55:00',1.28),('16100','2014-04-22','10:45:00',1.2),('16100','2014-04-22','10:50:00',1.45),('16100','2014-04-22','10:55:00',1.47),('16100','2014-04-22','11:00:00',1.36),('16100','2014-04-22','11:05:00',1.23),('16100','2014-04-22','11:10:00',1.14),('16100','2014-04-22','11:15:00',1.04),('16100','2014-04-22','11:20:00',1.05),('16100','2014-04-22','12:45:00',1.01),('16100','2014-04-22','13:15:00',1.1),('16100','2014-04-22','13:20:00',1.23),('16100','2014-04-22','13:25:00',1.37),('16100','2014-04-22','13:30:00',1.57),('16100','2014-04-22','13:35:00',1.81),('16100','2014-04-22','13:40:00',2.02),('16100','2014-04-22','13:45:00',2.2),('16100','2014-04-22','13:50:00',2.26),('16100','2014-04-22','13:55:00',2.43),('16100','2014-04-22','14:00:00',2.5),('16100','2014-04-22','14:05:00',2.51),('16100','2014-04-22','14:10:00',2.45),('16100','2014-04-22','14:15:00',2.33),('16100','2014-04-22','14:20:00',2.18),('16100','2014-04-22','14:25:00',2),('16100','2014-04-22','14:30:00',1.8),('16100','2014-04-22','14:35:00',1.56),('16100','2014-04-22','14:40:00',1.46),('16100','2014-04-22','14:45:00',1.48),('16100','2014-04-22','14:50:00',1.46),('16100','2014-04-22','14:55:00',1.4),('16100','2014-04-22','15:00:00',1.43),('16100','2014-04-22','15:05:00',1.58),('16100','2014-04-22','15:10:00',1.82),('16100','2014-04-22','15:15:00',2.1),('16100','2014-04-22','15:20:00',2.15),('16100','2014-04-22','15:25:00',2.26),('16100','2014-04-22','15:30:00',2.1),('16100','2014-04-22','15:35:00',1.84),('16100','2014-04-22','15:40:00',1.71),('16100','2014-04-22','15:45:00',1.33),('16100','2014-04-22','15:50:00',1.23),('16100','2014-04-22','15:55:00',1.2),('16100','2014-04-22','16:00:00',1.14),('16100','2013-12-26','10:25:00',1.1),('16100','2013-12-26','10:30:00',1.13),('16100','2013-12-26','10:35:00',1.12),('16100','2013-12-26','10:40:00',1.03),('16100','2013-12-26','11:20:00',1.08),('16100','2013-12-26','11:25:00',1.23),('16100','2013-12-26','11:30:00',1.18),('16100','2013-12-26','11:35:00',1.09),('16100','2013-12-26','11:40:00',1.1),('16100','2013-12-26','11:45:00',1.39),('16100','2013-12-26','11:50:00',1.84),('16100','2013-12-26','11:55:00',2.17),('16100','2013-12-26','12:00:00',3.78),('16100','2013-12-26','12:05:00',4.04),('16100','2013-12-26','12:10:00',4.86),('16100','2013-12-26','12:15:00',2.65),('16100','2013-12-26','12:20:00',1.65),('16100','2013-12-26','12:25:00',1.86),('16100','2013-12-26','12:30:00',2.23),('16100','2013-12-26','12:35:00',2.38),('16100','2013-12-26','12:40:00',3.78),('16100','2013-12-26','12:45:00',4.93),('16100','2013-12-26','12:50:00',4.5),('16100','2013-12-26','12:55:00',4.55),('16100','2013-12-26','13:00:00',4.95),('16100','2013-12-26','13:05:00',5.13),('16100','2013-12-26','13:10:00',5.12),('16100','2013-12-26','13:15:00',5.23),('16100','2013-12-26','13:20:00',5.13),('16100','2013-12-26','13:25:00',5.36),('16100','2013-12-26','13:30:00',4.59),('16100','2013-12-26','13:35:00',2.54),('16100','2013-12-26','13:40:00',2.28),('16100','2013-12-26','13:45:00',2.16),('16100','2013-12-26','13:50:00',2.06),('16100','2013-12-26','13:55:00',2.16),('16100','2013-12-26','14:00:00',2.51),('16100','2013-12-26','14:05:00',2.7),('16100','2013-12-26','14:10:00',4.16),('16100','2013-12-26','14:15:00',3.08),('16100','2013-12-26','14:20:00',2.2),('16100','2013-12-26','14:25:00',2.08),('16100','2013-12-26','14:30:00',2.24),('16100','2013-12-26','14:35:00',2.76),('16100','2013-12-26','14:40:00',1.98),('16100','2013-12-26','14:45:00',1.17),('16100','2013-12-25','10:00:00',1.03),('16100','2013-12-24','09:10:00',1.17),('16100','2013-12-24','09:15:00',1.27),('16100','2013-12-24','09:20:00',1.17),('16100','2013-12-24','09:25:00',1.25),('16100','2013-12-24','09:30:00',1.16),('16100','2013-12-24','10:35:00',1.56),('16100','2013-12-24','10:40:00',1.92),('16100','2013-12-24','10:45:00',1.96),('16100','2013-12-24','10:50:00',1.67),('16100','2013-12-24','10:55:00',1.41),('16100','2013-12-24','11:00:00',1.24),('16100','2013-12-24','11:05:00',1.45),('16100','2013-12-24','11:10:00',1.8),('16100','2013-12-24','11:15:00',1.71),('16100','2013-12-24','11:20:00',2.14),('16100','2013-12-24','11:25:00',2.5),('16100','2013-12-24','11:30:00',1.92),('16100','2013-12-24','11:35:00',1.23),('16100','2013-12-24','11:40:00',2.15),('16100','2013-12-24','11:45:00',3.71),('16100','2013-12-24','11:50:00',5.06),('16100','2013-12-24','11:55:00',5.47),('16100','2013-12-24','12:00:00',1.67),('16100','2013-12-24','12:05:00',2.09),('16100','2013-12-24','12:10:00',3.01),('16100','2013-12-24','12:15:00',1.79),('16100','2013-12-24','12:20:00',4.21),('16100','2013-12-24','12:25:00',4.49),('16100','2013-12-24','12:30:00',5.09),('16100','2013-12-24','12:35:00',3.4),('16100','2013-12-24','12:40:00',3.3),('16100','2013-12-24','12:45:00',2.72),('16100','2013-12-24','12:50:00',2.05),('16100','2013-12-24','12:55:00',2.14),('16100','2013-12-24','13:00:00',1.87),('16100','2013-12-24','13:05:00',1.87),('16100','2013-12-24','13:10:00',1.1),('16100','2013-12-24','13:25:00',1.02),('16100','2013-12-24','13:40:00',1.2),('16100','2013-12-24','13:45:00',1.39),('16100','2013-12-24','13:50:00',1.39),('16100','2013-12-24','13:55:00',1.3),('16100','2013-12-24','14:05:00',1.08),('16100','2013-12-24','14:10:00',1.12),('16100','2013-12-24','15:10:00',1.46),('16100','2013-12-24','15:15:00',2.03),('16100','2013-12-24','15:20:00',1.96),('16100','2013-12-23','08:40:00',1.16),('16100','2013-12-23','08:45:00',1.67),('16100','2013-12-23','08:50:00',1.88),('16100','2013-12-23','08:55:00',1.96),('16100','2013-12-23','09:00:00',2.12),('16100','2013-12-23','09:05:00',2.34),('16100','2013-12-23','09:10:00',2.49),('16100','2013-12-23','09:15:00',2.67),('16100','2013-12-23','09:20:00',2.83),('16100','2013-12-23','09:25:00',2.97),('16100','2013-12-23','09:30:00',3.07),('16100','2013-12-23','09:35:00',3.17),('16100','2013-12-23','09:40:00',3.27),('16100','2013-12-23','09:45:00',3.4),('16100','2013-12-23','09:50:00',3.49),('16100','2013-12-23','09:55:00',3.6),('16100','2013-12-23','10:00:00',3.69),('16100','2013-12-23','10:05:00',3.77),('16100','2013-12-23','10:10:00',3.82),('16100','2013-12-23','10:15:00',3.83),('16100','2013-12-23','10:20:00',3.98),('16100','2013-12-23','10:25:00',4.14),('16100','2013-12-23','10:30:00',4.16),('16100','2013-12-23','10:35:00',4.19),('16100','2013-12-23','10:40:00',4.34),('16100','2013-12-23','10:45:00',4.49),('16100','2013-12-23','10:50:00',4.49),('16100','2013-12-23','10:55:00',4.56),('16100','2013-12-23','11:00:00',4.65),('16100','2013-12-23','11:05:00',4.77),('16100','2013-12-23','11:10:00',4.83),('16100','2013-12-23','11:15:00',4.58),('16100','2013-12-23','11:20:00',4.74),('16100','2013-12-23','11:25:00',4.91),('16100','2013-12-23','11:30:00',4.96),('16100','2013-12-23','11:35:00',4.96),('16100','2013-12-23','11:40:00',5.03),('16100','2013-12-23','11:45:00',5.02),('16100','2013-12-23','11:50:00',5.02),('16100','2013-12-23','11:55:00',5.03),('16100','2013-12-23','12:00:00',5),('16100','2013-12-23','12:05:00',5.03),('16100','2013-12-23','12:10:00',4.96),('16100','2013-12-23','12:15:00',4.95),('16100','2013-12-23','12:20:00',4.94),('16100','2013-12-23','12:25:00',4.93),('16100','2013-12-23','12:30:00',4.92),('16100','2013-12-23','12:35:00',4.93),('16100','2013-12-23','12:40:00',4.93),('16100','2013-12-23','12:45:00',4.92),('16100','2013-12-23','12:50:00',4.78),('16100','2013-12-23','12:55:00',4.73),('16100','2013-12-23','13:00:00',4.72),('16100','2013-12-23','13:05:00',4.69),('16100','2013-12-23','13:10:00',4.54),('16100','2013-12-23','13:15:00',4.36),('16100','2013-12-23','13:20:00',4.36),('16100','2013-12-23','13:25:00',4.2),('16100','2013-12-23','13:30:00',4.09),('16100','2013-12-23','13:35:00',3.92),('16100','2013-12-23','13:40:00',3.92),('16100','2013-12-23','13:45:00',3.84),('16100','2013-12-23','13:50:00',3.78),('16100','2013-12-23','13:55:00',3.66),('16100','2013-12-23','14:00:00',3.38),('16100','2013-12-23','14:05:00',3.27),('16100','2013-12-23','14:10:00',3.09),('16100','2013-12-23','14:15:00',3.1),('16100','2013-12-23','14:20:00',3.04),('16100','2013-12-23','14:25:00',2.92),('16100','2013-12-23','14:30:00',2.76),('16100','2013-12-23','14:35:00',2.62),('16100','2013-12-23','14:40:00',2.47),('16100','2013-12-23','14:45:00',2.37),('16100','2013-12-23','14:50:00',2.21),('16100','2013-12-23','14:55:00',2.11),('16100','2013-12-23','15:00:00',1.99),('16100','2013-12-23','15:05:00',1.94),('16100','2013-12-23','15:10:00',1.81),('16100','2013-12-23','15:15:00',1.74),('16100','2013-12-23','15:20:00',1.63),('16100','2013-12-23','15:25:00',1.55),('16100','2013-12-23','15:30:00',1.47),('16100','2013-12-23','15:35:00',1.33),('16100','2013-12-23','15:40:00',1.16),('16100','2013-12-23','15:45:00',1.01),('16100','2013-12-22','08:50:00',1.08),('16100','2013-12-22','08:55:00',1.17),('16100','2013-12-22','09:00:00',1.43),('16100','2013-12-22','09:05:00',1.29),('16100','2013-12-22','09:10:00',1.16),('16100','2013-12-22','09:15:00',1.52),('16100','2013-12-22','09:20:00',1.83),('16100','2013-12-22','09:25:00',1.75),('16100','2013-12-22','09:30:00',1.82),('16100','2013-12-22','09:35:00',2.01),('16100','2013-12-22','09:40:00',1.92),('16100','2013-12-22','09:45:00',1.93),('16100','2013-12-22','09:50:00',1.68),('16100','2013-12-22','09:55:00',1.96),('16100','2013-12-22','10:00:00',2.17),('16100','2013-12-22','10:05:00',2.66),('16100','2013-12-22','10:10:00',3.41),('16100','2013-12-22','10:15:00',3.71),('16100','2013-12-22','10:20:00',3.67),('16100','2013-12-22','10:25:00',4.15),('16100','2013-12-22','10:30:00',4.21),('16100','2013-12-22','10:35:00',4.19),('16100','2013-12-22','10:40:00',4.09),('16100','2013-12-22','10:45:00',4.08),('16100','2013-12-22','10:50:00',4.33),('16100','2013-12-22','10:55:00',4.65),('16100','2013-12-22','11:00:00',5.07),('16100','2013-12-22','11:05:00',5.05),('16100','2013-12-22','11:10:00',5.09),('16100','2013-12-22','11:15:00',5.05),('16100','2013-12-22','11:20:00',5.2),('16100','2013-12-22','11:25:00',4.97),('16100','2013-12-22','11:30:00',5.18),('16100','2013-12-22','11:35:00',5.42),('16100','2013-12-22','11:40:00',5.27),('16100','2013-12-22','11:45:00',4.71),('16100','2013-12-22','11:50:00',4.93),('16100','2013-12-22','11:55:00',5.23),('16100','2013-12-22','12:00:00',5.35),('16100','2013-12-22','12:05:00',5.22),('16100','2013-12-22','12:10:00',5.14),('16100','2013-12-22','12:15:00',5.07),('16100','2013-12-22','12:20:00',4.98),('16100','2013-12-22','12:25:00',4.92),('16100','2013-12-22','12:30:00',4.95),('16100','2013-12-22','12:35:00',4.81),('16100','2013-12-22','12:40:00',4.8),('16100','2013-12-22','12:45:00',4.81),('16100','2013-12-22','12:50:00',4.75),('16100','2013-12-22','12:55:00',4.65),('16100','2013-12-22','13:00:00',4.67),('16100','2013-12-22','13:05:00',4.62),('16100','2013-12-22','13:10:00',4.61),('16100','2013-12-22','13:15:00',4.64),('16100','2013-12-22','13:20:00',4.53),('16100','2013-12-22','13:25:00',4.59),('16100','2013-12-22','13:30:00',4.57),('16100','2013-12-22','13:35:00',4.51),('16100','2013-12-22','13:40:00',4.42),('16100','2013-12-22','13:45:00',4.41),('16100','2013-12-22','13:50:00',4.05),('16100','2013-12-22','13:55:00',4.15),('16100','2013-12-22','14:00:00',3.74),('16100','2013-12-22','14:05:00',3.65),('16100','2013-12-22','14:10:00',3.66),('16100','2013-12-22','14:15:00',3.72),('16100','2013-12-22','14:20:00',3.63),('16100','2013-12-22','14:25:00',3.55),('16100','2013-12-22','14:30:00',3.38),('16100','2013-12-22','14:35:00',3.28),('16100','2013-12-22','14:40:00',3.12),('16100','2013-12-22','14:45:00',3),('16100','2013-12-22','14:50:00',2.85),('16100','2013-12-22','14:55:00',2.73),('16100','2013-12-22','15:00:00',2.56),('16100','2013-12-22','15:05:00',2.4),('16100','2013-12-22','15:10:00',2.24),('16100','2013-12-22','15:15:00',2.06),('16100','2013-12-22','15:20:00',1.89),('16100','2013-12-22','15:25:00',1.67),('16100','2013-12-22','15:30:00',1.53),('16100','2013-12-22','15:35:00',1.38),('16100','2013-12-22','15:40:00',1.21),('16100','2013-12-22','15:45:00',1.09),('16100','2013-12-21','08:40:00',1.28),('16100','2013-12-21','08:45:00',1.38),('16100','2013-12-21','08:50:00',1.31),('16100','2013-12-21','08:55:00',1.16),('16100','2013-12-21','09:00:00',1.15),('16100','2013-12-21','09:05:00',1.38),('16100','2013-12-21','09:10:00',1.78),('16100','2013-12-21','09:15:00',2.2),('16100','2013-12-21','09:20:00',2.1),('16100','2013-12-21','09:25:00',2.18),('16100','2013-12-21','09:30:00',2.57),('16100','2013-12-21','09:35:00',3.23),('16100','2013-12-21','09:40:00',4.05),('16100','2013-12-21','09:45:00',4.18),('16100','2013-12-21','09:50:00',4.47),('16100','2013-12-21','09:55:00',4.68),('16100','2013-12-21','10:00:00',4.68),('16100','2013-12-21','10:05:00',4.54),('16100','2013-12-21','10:10:00',4.34),('16100','2013-12-21','10:15:00',4.56),('16100','2013-12-21','10:20:00',4.52),('16100','2013-12-21','10:25:00',4.44),('16100','2013-12-21','10:30:00',4.31),('16100','2013-12-21','10:35:00',4.43),('16100','2013-12-21','10:40:00',4.43),('16100','2013-12-21','10:45:00',4.08),('16100','2013-12-21','10:50:00',4.38),('16100','2013-12-21','10:55:00',4.73),('16100','2013-12-21','11:00:00',4.59),('16100','2013-12-21','11:05:00',4.86),('16100','2013-12-21','11:10:00',4.24),('16100','2013-12-21','11:15:00',4.23),('16100','2013-12-21','11:20:00',4.88),('16100','2013-12-21','11:25:00',4.72),('16100','2013-12-21','11:30:00',4.55),('16100','2013-12-21','11:35:00',4.9),('16100','2013-12-21','11:40:00',4.74),('16100','2013-12-21','11:45:00',4.52),('16100','2013-12-21','11:50:00',3.53),('16100','2013-12-21','11:55:00',2.59),('16100','2013-12-21','12:00:00',2.18),('16100','2013-12-21','12:05:00',1.79),('16100','2013-12-21','12:10:00',1.58),('16100','2013-12-21','12:15:00',1.69),('16100','2013-12-21','12:20:00',1.84),('16100','2013-12-21','12:25:00',2.17),('16100','2013-12-21','12:30:00',2.21),('16100','2013-12-21','12:35:00',2.67),('16100','2013-12-21','12:40:00',2.91),('16100','2013-12-21','12:45:00',2.98),('16100','2013-12-21','12:50:00',2.84),('16100','2013-12-21','12:55:00',3.14),('16100','2013-12-21','13:00:00',4.42),('16100','2013-12-21','13:05:00',4.8),('16100','2013-12-21','13:10:00',5.2),('16100','2013-12-21','13:15:00',5.01),('16100','2013-12-21','13:20:00',4.14),('16100','2013-12-21','13:25:00',4.2),('16100','2013-12-21','13:30:00',4.69),('16100','2013-12-21','13:35:00',3.9),('16100','2013-12-21','13:40:00',3.89),('16100','2013-12-21','13:45:00',3.87),('16100','2013-12-21','13:50:00',2.44),('16100','2013-12-21','13:55:00',2.44),('16100','2013-12-21','14:00:00',3.03),('16100','2013-12-21','14:05:00',2.78),('16100','2013-12-21','14:10:00',3.12),('16100','2013-12-21','14:15:00',2.75),('16100','2013-12-21','14:20:00',2.07),('16100','2013-12-21','14:25:00',1.9),('16100','2013-12-21','14:30:00',1.63),('16100','2013-12-21','14:35:00',2.89),('16100','2013-12-21','14:40:00',3.13),('16100','2013-12-21','14:45:00',3.01),('16100','2013-12-21','14:50:00',1.91),('16100','2013-12-21','14:55:00',1.39),('16100','2013-12-21','15:00:00',1.22),('16100','2013-12-21','15:05:00',1.48),('16100','2013-12-21','15:10:00',2.19),('16100','2013-12-21','15:15:00',1.82),('16100','2013-12-21','15:20:00',1.11),('16100','2013-12-20','08:20:00',1.01),('16100','2013-12-20','08:25:00',1.16),('16100','2013-12-20','08:30:00',1.32),('16100','2013-12-20','08:35:00',1.48),('16100','2013-12-20','08:40:00',1.6),('16100','2013-12-20','08:45:00',1.75),('16100','2013-12-20','08:50:00',1.95),('16100','2013-12-20','08:55:00',2.09),('16100','2013-12-20','09:00:00',2.25),('16100','2013-12-20','09:05:00',2.4),('16100','2013-12-20','09:10:00',2.54),('16100','2013-12-20','09:15:00',2.71),('16100','2013-12-20','09:20:00',2.8),('16100','2013-12-20','09:25:00',2.82),('16100','2013-12-20','09:30:00',3.11),('16100','2013-12-20','09:35:00',3.21),('16100','2013-12-20','09:40:00',3.36),('16100','2013-12-20','09:45:00',3.51),('16100','2013-12-20','09:50:00',3.64),('16100','2013-12-20','09:55:00',3.76),('16100','2013-12-20','10:00:00',3.89),('16100','2013-12-20','10:05:00',3.98),('16100','2013-12-20','10:10:00',4.1),('16100','2013-12-20','10:15:00',4.21),('16100','2013-12-20','10:20:00',4.35),('16100','2013-12-20','10:25:00',4.47),('16100','2013-12-20','10:30:00',4.58),('16100','2013-12-20','10:35:00',4.66),('16100','2013-12-20','10:40:00',4.75),('16100','2013-12-20','10:45:00',4.82),('16100','2013-12-20','10:50:00',4.9),('16100','2013-12-20','10:55:00',4.97),('16100','2013-12-20','11:00:00',5.03),('16100','2013-12-20','11:05:00',5.09),('16100','2013-12-20','11:10:00',5.16),('16100','2013-12-20','11:15:00',5.22),('16100','2013-12-20','11:20:00',5.27),('16100','2013-12-20','11:25:00',5.33),('16100','2013-12-20','11:30:00',5.38),('16100','2013-12-20','11:35:00',5.41),('16100','2013-12-20','11:40:00',5.42),('16100','2013-12-20','11:45:00',5.43),('16100','2013-12-20','11:50:00',5.45),('16100','2013-12-20','11:55:00',5.44),('16100','2013-12-20','12:00:00',5.47),('16100','2013-12-20','12:05:00',5.41),('16100','2013-12-20','12:10:00',5.4),('16100','2013-12-20','12:15:00',5.39),('16100','2013-12-20','12:20:00',5.4),('16100','2013-12-20','12:25:00',5.35),('16100','2013-12-20','12:30:00',5.36),('16100','2013-12-20','12:35:00',5.38),('16100','2013-12-20','12:40:00',5.31),('16100','2013-12-20','12:45:00',5.26),('16100','2013-12-20','12:50:00',5.23),('16100','2013-12-20','12:55:00',5.23),('16100','2013-12-20','13:00:00',5.17),('16100','2013-12-20','13:05:00',5.18),('16100','2013-12-20','13:10:00',5.16),('16100','2013-12-20','13:15:00',5.13),('16100','2013-12-20','13:20:00',5.08),('16100','2013-12-20','13:25:00',5.01),('16100','2013-12-20','13:30:00',4.94),('16100','2013-12-20','13:35:00',4.9),('16100','2013-12-20','13:40:00',4.77),('16100','2013-12-20','13:45:00',4.7),('16100','2013-12-20','13:50:00',4.62),('16100','2013-12-20','13:55:00',4.51),('16100','2013-12-20','14:00:00',4.38),('16100','2013-12-20','14:05:00',4.27),('16100','2013-12-20','14:10:00',4.17),('16100','2013-12-20','14:15:00',4.03),('16100','2013-12-20','14:20:00',3.93),('16100','2013-12-20','14:25:00',3.77),('16100','2013-12-20','14:30:00',3.65),('16100','2013-12-20','14:35:00',3.51),('16100','2013-12-20','14:40:00',3.35),('16100','2013-12-20','14:45:00',3.24),('16100','2013-12-20','14:50:00',3.11),('16100','2013-12-20','14:55:00',2.97),('16100','2013-12-20','15:00:00',2.85),('16100','2013-12-20','15:05:00',2.72),('16100','2013-12-20','15:10:00',2.59),('16100','2013-12-20','15:15:00',2.45),('16100','2013-12-20','15:20:00',2.29),('16100','2013-12-20','15:25:00',2.1),('16100','2013-12-20','15:30:00',1.91),('16100','2013-12-20','15:35:00',1.78),('16100','2013-12-20','15:40:00',1.6),('16100','2013-12-20','15:45:00',1.45),('16100','2013-12-20','15:50:00',1.27),('16100','2013-12-20','15:55:00',1.1),('16100','2013-12-19','08:30:00',1.29),('16100','2013-12-19','08:35:00',1.41),('16100','2013-12-19','08:40:00',1.5),('16100','2013-12-19','08:45:00',1.69),('16100','2013-12-19','08:50:00',1.67),('16100','2013-12-19','08:55:00',1.94),('16100','2013-12-19','09:00:00',2.18),('16100','2013-12-19','09:05:00',2.33),('16100','2013-12-19','09:10:00',2.47),('16100','2013-12-19','09:15:00',2.63),('16100','2013-12-19','09:20:00',2.79),('16100','2013-12-19','09:25:00',2.92),('16100','2013-12-19','09:30:00',3.02),('16100','2013-12-19','09:35:00',3.16),('16100','2013-12-19','09:40:00',3.28),('16100','2013-12-19','09:45:00',3.42),('16100','2013-12-19','09:50:00',3.51),('16100','2013-12-19','09:55:00',3.64),('16100','2013-12-19','10:00:00',3.71),('16100','2013-12-19','10:05:00',3.81),('16100','2013-12-19','10:10:00',3.92),('16100','2013-12-19','10:15:00',4.02),('16100','2013-12-19','10:20:00',4.07),('16100','2013-12-19','10:25:00',4.17),('16100','2013-12-19','10:30:00',4.25),('16100','2013-12-19','10:35:00',4.31),('16100','2013-12-19','10:40:00',4.44),('16100','2013-12-19','10:45:00',4.51),('16100','2013-12-19','10:50:00',4.53),('16100','2013-12-19','10:55:00',4.55),('16100','2013-12-19','11:00:00',4.58),('16100','2013-12-19','11:05:00',4.7),('16100','2013-12-19','11:10:00',4.81),('16100','2013-12-19','11:15:00',4.87),('16100','2013-12-19','11:20:00',4.88),('16100','2013-12-19','11:25:00',4.89),('16100','2013-12-19','11:30:00',4.95),('16100','2013-12-19','11:35:00',5.03),('16100','2013-12-19','11:40:00',5.07),('16100','2013-12-19','11:45:00',5.04),('16100','2013-12-19','11:50:00',5.08),('16100','2013-12-19','11:55:00',5.12),('16100','2013-12-19','12:00:00',5.08),('16100','2013-12-19','12:05:00',5.09),('16100','2013-12-19','12:10:00',5.1),('16100','2013-12-19','12:15:00',5.11),('16100','2013-12-19','12:20:00',5.09),('16100','2013-12-19','12:25:00',5.03),('16100','2013-12-19','12:30:00',5),('16100','2013-12-19','12:35:00',4.95),('16100','2013-12-19','12:40:00',4.94),('16100','2013-12-19','12:45:00',4.9),('16100','2013-12-19','12:50:00',4.83),('16100','2013-12-19','12:55:00',4.81),('16100','2013-12-19','13:00:00',4.71),('16100','2013-12-19','13:05:00',4.6),('16100','2013-12-19','13:10:00',4.4),('16100','2013-12-19','13:15:00',4.22),('16100','2013-12-19','13:20:00',4.28),('16100','2013-12-19','13:25:00',4.25),('16100','2013-12-19','13:30:00',4.21),('16100','2013-12-19','13:35:00',3.95),('16100','2013-12-19','13:40:00',3.84),('16100','2013-12-19','13:45:00',3.97),('16100','2013-12-19','13:50:00',3.79),('16100','2013-12-19','13:55:00',3.67),('16100','2013-12-19','14:00:00',2.9),('16100','2013-12-19','14:05:00',1.28),('16100','2013-12-19','14:10:00',2.92),('16100','2013-12-19','14:15:00',1.99),('16100','2013-12-19','14:20:00',1.41),('16100','2013-12-19','14:25:00',2.31),('16100','2013-12-19','14:30:00',1.4),('16100','2013-12-19','14:40:00',1.65),('16100','2013-12-19','14:45:00',2.02),('16100','2013-12-19','14:55:00',1.37),('16100','2013-12-18','08:30:00',1.11),('16100','2013-12-18','08:35:00',1.29),('16100','2013-12-18','08:40:00',1.39),('16100','2013-12-18','08:45:00',1.58),('16100','2013-12-18','08:50:00',1.65),('16100','2013-12-18','08:55:00',1.37),('16100','2013-12-18','09:00:00',1.02),('16100','2013-12-18','09:05:00',1.52),('16100','2013-12-18','09:10:00',1.06),('16100','2013-12-18','09:15:00',1.09),('16100','2013-12-18','09:20:00',1),('16100','2013-12-18','09:25:00',1.14),('16100','2013-12-18','09:45:00',1.27),('16100','2013-12-18','09:50:00',1.96),('16100','2013-12-18','09:55:00',1.95),('16100','2013-12-18','10:00:00',1.21),('16100','2013-12-18','10:05:00',1.12),('16100','2013-12-18','10:10:00',1.18),('16100','2013-12-18','10:15:00',1.05),('16100','2013-12-18','10:30:00',1.15),('16100','2013-12-18','10:35:00',2.5),('16100','2013-12-18','10:40:00',3.98),('16100','2013-12-18','10:45:00',2.94),('16100','2013-12-18','10:50:00',1.56),('16100','2013-12-18','10:55:00',1.31),('16100','2013-12-18','11:00:00',1.07),('16100','2013-12-18','11:05:00',1.12),('16100','2013-12-18','11:10:00',1.2),('16100','2013-12-18','11:15:00',1.26),('16100','2013-12-18','11:20:00',1.19),('16100','2013-12-18','11:25:00',1.13),('16100','2013-12-18','12:30:00',1.38),('16100','2013-12-18','12:35:00',1.59),('16100','2013-12-18','12:40:00',1.53),('16100','2013-12-18','12:45:00',1.33),('16100','2013-12-18','12:50:00',1.31),('16100','2013-12-18','12:55:00',1.32),('16100','2013-12-18','13:00:00',1.22),('16100','2013-12-18','13:05:00',1.19),('16100','2013-12-18','13:10:00',1.07),('16100','2013-12-18','13:15:00',1.04),('16100','2013-12-18','13:20:00',1.06),('16100','2013-12-18','13:25:00',1.07),('16100','2013-12-18','13:30:00',1.09),('16100','2013-12-18','13:35:00',1.02),('16100','2013-12-18','13:40:00',1.11),('16100','2013-12-18','13:45:00',1.43),('16100','2013-12-18','13:50:00',1.91),('16100','2013-12-18','13:55:00',1.78),('16100','2013-12-18','14:00:00',1.21),('16100','2013-12-18','14:05:00',1.05),('16100','2013-12-18','14:10:00',1.16),('16100','2013-12-18','14:15:00',1.21),('16100','2013-12-18','14:20:00',1.31),('16100','2013-12-18','14:25:00',2.98),('16100','2013-12-18','14:30:00',2.87),('16100','2013-12-18','14:35:00',3.57),('16100','2013-12-18','14:40:00',3.48),('16100','2013-12-18','14:45:00',3.03),('16100','2013-12-18','14:50:00',1.74),('16100','2013-12-18','14:55:00',2.18),('16100','2013-12-18','15:00:00',1.5),('16100','2013-12-18','15:05:00',1.13),('16100','2013-12-17','08:20:00',1.07),('16100','2013-12-17','08:25:00',1.23),('16100','2013-12-17','08:30:00',1.37),('16100','2013-12-17','08:35:00',1.52),('16100','2013-12-17','08:40:00',1.71),('16100','2013-12-17','08:45:00',1.86),('16100','2013-12-17','08:50:00',2.05),('16100','2013-12-17','08:55:00',2.2),('16100','2013-12-17','09:00:00',2.39),('16100','2013-12-17','09:05:00',2.55),('16100','2013-12-17','09:10:00',2.73),('16100','2013-12-17','09:15:00',2.88),('16100','2013-12-17','09:20:00',3.04),('16100','2013-12-17','09:25:00',3.18),('16100','2013-12-17','09:30:00',3.3),('16100','2013-12-17','09:35:00',3.45),('16100','2013-12-17','09:40:00',3.58),('16100','2013-12-17','09:45:00',3.73),('16100','2013-12-17','09:50:00',3.87),('16100','2013-12-17','09:55:00',3.98),('16100','2013-12-17','10:00:00',4.09),('16100','2013-12-17','10:05:00',4.18),('16100','2013-12-17','10:10:00',4.27),('16100','2013-12-17','10:15:00',4.34),('16100','2013-12-17','10:20:00',4.41),('16100','2013-12-17','10:25:00',4.56),('16100','2013-12-17','10:30:00',4.64),('16100','2013-12-17','10:35:00',4.72),('16100','2013-12-17','10:40:00',4.8),('16100','2013-12-17','10:45:00',4.81),('16100','2013-12-17','10:50:00',4.9),('16100','2013-12-17','10:55:00',4.98),('16100','2013-12-17','11:00:00',4.96),('16100','2013-12-17','11:05:00',4.99),('16100','2013-12-17','11:10:00',5.05),('16100','2013-12-17','11:15:00',5.05),('16100','2013-12-17','11:20:00',5.11),('16100','2013-12-17','11:25:00',5.11),('16100','2013-12-17','11:30:00',5.07),('16100','2013-12-17','11:35:00',5.07),('16100','2013-12-17','11:40:00',5.08),('16100','2013-12-17','11:45:00',5.18),('16100','2013-12-17','11:50:00',5.18),('16100','2013-12-17','11:55:00',5.13),('16100','2013-12-17','12:00:00',5.13),('16100','2013-12-17','12:05:00',5.17),('16100','2013-12-17','12:10:00',5.16),('16100','2013-12-17','12:15:00',5.17),('16100','2013-12-17','12:20:00',5.21),('16100','2013-12-17','12:25:00',5.18),('16100','2013-12-17','12:30:00',5.25),('16100','2013-12-17','12:35:00',5.17),('16100','2013-12-17','12:40:00',5.05),('16100','2013-12-17','12:45:00',4.98),('16100','2013-12-17','12:50:00',4.96),('16100','2013-12-17','12:55:00',5.04),('16100','2013-12-17','13:00:00',5.05),('16100','2013-12-17','13:05:00',4.95),('16100','2013-12-17','13:10:00',4.89),('16100','2013-12-17','13:15:00',4.84),('16100','2013-12-17','13:20:00',4.79),('16100','2013-12-17','13:25:00',4.72),('16100','2013-12-17','13:30:00',4.69),('16100','2013-12-17','13:35:00',4.62),('16100','2013-12-17','13:40:00',4.51),('16100','2013-12-17','13:45:00',4.52),('16100','2013-12-17','13:50:00',4.42),('16100','2013-12-17','13:55:00',4.29),('16100','2013-12-17','14:00:00',4.22),('16100','2013-12-17','14:05:00',4.11),('16100','2013-12-17','14:10:00',3.96),('16100','2013-12-17','14:15:00',3.89),('16100','2013-12-17','14:20:00',3.8),('16100','2013-12-17','14:25:00',3.64),('16100','2013-12-17','14:30:00',3.5),('16100','2013-12-17','14:35:00',3.34),('16100','2013-12-17','14:40:00',3.25),('16100','2013-12-17','14:45:00',3.11),('16100','2013-12-17','14:50:00',2.97),('16100','2013-12-17','14:55:00',2.78),('16100','2013-12-17','15:00:00',2.68),('16100','2013-12-17','15:05:00',2.54),('16100','2013-12-17','15:10:00',2.4),('16100','2013-12-17','15:15:00',2.27),('16100','2013-12-17','15:20:00',2.09),('16100','2013-12-17','15:25:00',1.97),('16100','2013-12-17','15:30:00',1.77),('16100','2013-12-17','15:35:00',1.57),('16100','2013-12-17','15:40:00',1.28),('16100','2013-12-17','15:45:00',1.18),('16100','2013-12-17','15:50:00',1.05),('16100','2014-04-21','08:00:00',1.06),('16100','2014-04-21','08:05:00',1.23),('16100','2014-04-21','08:10:00',1.42),('16100','2014-04-21','08:15:00',1.67),('16100','2014-04-21','08:20:00',1.88),('16100','2014-04-21','08:25:00',2.11),('16100','2014-04-21','08:30:00',2.28),('16100','2014-04-21','08:35:00',2.32),('16100','2014-04-21','08:40:00',2.43),('16100','2014-04-21','08:45:00',2.68),('16100','2014-04-21','08:50:00',2.81),('16100','2014-04-21','08:55:00',2.99),('16100','2014-04-21','09:00:00',3.23),('16100','2014-04-21','09:05:00',3.49),('16100','2014-04-21','09:10:00',3.13),('16100','2014-04-21','09:15:00',2.43),('16100','2014-04-21','09:20:00',2.09),('16100','2014-04-21','09:25:00',4.39),('16100','2014-04-21','09:30:00',4.12),('16100','2014-04-21','09:35:00',4.32),('16100','2014-04-21','09:40:00',4.37),('16100','2014-04-21','09:45:00',4.86),('16100','2014-04-21','09:50:00',2.21),('16100','2014-04-21','09:55:00',2.28),('16100','2014-04-21','10:00:00',2.81),('16100','2014-04-21','10:05:00',2.44),('16100','2014-04-21','10:10:00',2.79),('16100','2014-04-21','10:15:00',2.78),('16100','2014-04-21','10:20:00',5.53),('16100','2014-04-21','10:25:00',3.07),('16100','2014-04-21','10:30:00',4.29),('16100','2014-04-21','10:35:00',2.94),('16100','2014-04-21','10:40:00',3.67),('16100','2014-04-21','10:45:00',6.09),('16100','2014-04-21','10:50:00',5.21),('16100','2014-04-21','10:55:00',5.12),('16100','2014-04-21','11:00:00',5.8),('16100','2014-04-21','11:05:00',3.78),('16100','2014-04-21','11:10:00',2.82),('16100','2014-04-21','11:15:00',2.42),('16100','2014-04-21','11:20:00',1.99),('16100','2014-04-21','11:25:00',1.69),('16100','2014-04-21','11:30:00',1.58),('16100','2014-04-21','11:35:00',1.42),('16100','2014-04-21','11:40:00',1.41),('16100','2014-04-21','11:45:00',1.45),('16100','2014-04-21','11:50:00',1.68),('16100','2014-04-21','11:55:00',1.5),('16100','2014-04-21','12:00:00',1.67),('16100','2014-04-21','12:05:00',1.86),('16100','2014-04-21','12:10:00',1.7),('16100','2014-04-21','12:15:00',1.8),('16100','2014-04-21','12:20:00',1.87),('16100','2014-04-21','12:25:00',1.93),('16100','2014-04-21','12:30:00',1.85),('16100','2014-04-21','12:35:00',1.43),('16100','2014-04-21','12:40:00',1.22),('16100','2014-04-21','12:45:00',1.19),('16100','2014-04-21','12:50:00',1.16),('16100','2014-04-21','12:55:00',1.22),('16100','2014-04-21','13:00:00',1.34),('16100','2014-04-21','13:05:00',1.51),('16100','2014-04-21','13:10:00',1.87),('16100','2014-04-21','13:15:00',2.15),('16100','2014-04-21','13:20:00',2.39),('16100','2014-04-21','13:25:00',3.06),('16100','2014-04-21','13:30:00',4.34),('16100','2014-04-21','13:35:00',4.93),('16100','2014-04-21','13:40:00',4.94),('16100','2014-04-21','13:45:00',4.68),('16100','2014-04-21','13:50:00',3.02),('16100','2014-04-21','13:55:00',2.53),('16100','2014-04-21','14:00:00',2.62),('16100','2014-04-21','14:05:00',5.38),('16100','2014-04-21','14:10:00',8.44),('16100','2014-04-21','14:15:00',6.23),('16100','2014-04-21','14:20:00',4.61),('16100','2014-04-21','14:25:00',2.86),('16100','2014-04-21','14:30:00',3.67),('16100','2014-04-21','14:35:00',4.8),('16100','2014-04-21','14:40:00',3.84),('16100','2014-04-21','14:45:00',3.41),('16100','2014-04-21','14:50:00',5.25),('16100','2014-04-21','14:55:00',3.57),('16100','2014-04-21','15:00:00',2.05),('16100','2014-04-21','15:05:00',2.24),('16100','2014-04-21','15:10:00',2.13),('16100','2014-04-21','15:15:00',2.03),('16100','2014-04-21','15:20:00',2.1),('16100','2014-04-21','15:25:00',2.93),('16100','2014-04-21','15:30:00',3.31),('16100','2014-04-21','15:35:00',3.27),('16100','2014-04-21','15:40:00',3.52),('16100','2014-04-21','15:45:00',4.39),('16100','2014-04-21','15:50:00',3.99),('16100','2014-04-21','15:55:00',3.5),('16100','2014-04-21','16:00:00',4.66),('16100','2014-04-21','16:05:00',3.35),('16100','2014-04-21','16:10:00',2.9),('16100','2014-04-21','16:15:00',2.26),('16100','2014-04-21','16:20:00',2.61),('16100','2014-04-21','16:25:00',2.51),('16100','2014-04-21','16:30:00',2.13),('16100','2014-04-21','16:35:00',2.29),('16100','2014-04-21','16:40:00',2.25),('16100','2014-04-21','16:45:00',2.18),('16100','2014-04-21','16:50:00',1.98),('16100','2014-04-21','16:55:00',2.08),('16100','2014-04-21','17:00:00',2.61),('16100','2014-04-21','17:05:00',2.11),('16100','2014-04-21','17:10:00',1.62),('16100','2014-04-21','17:15:00',1.4),('16100','2014-04-21','17:20:00',1.14),('16100','2014-04-21','17:25:00',1.04),('16100','2014-04-21','17:35:00',1.14),('16100','2014-04-21','17:40:00',1.23),('16100','2014-04-21','17:45:00',1.06),('16100','2013-12-16','08:10:00',1.03),('16100','2013-12-16','08:15:00',1.19),('16100','2013-12-16','08:20:00',1.37),('16100','2013-12-16','08:25:00',1.54),('16100','2013-12-16','08:30:00',1.72),('16100','2013-12-16','08:35:00',1.88),('16100','2013-12-16','08:40:00',2.04),('16100','2013-12-16','08:45:00',2.18),('16100','2013-12-16','08:50:00',2.36),('16100','2013-12-16','08:55:00',2.51),('16100','2013-12-16','09:00:00',2.66),('16100','2013-12-16','09:05:00',2.84),('16100','2013-12-16','09:10:00',3),('16100','2013-12-16','09:15:00',3.13),('16100','2013-12-16','09:20:00',3.26),('16100','2013-12-16','09:25:00',3.41),('16100','2013-12-16','09:30:00',3.55),('16100','2013-12-16','09:35:00',3.66),('16100','2013-12-16','09:40:00',3.79),('16100','2013-12-16','09:45:00',3.97),('16100','2013-12-16','09:50:00',4.07),('16100','2013-12-16','09:55:00',4.16),('16100','2013-12-16','10:00:00',4.27),('16100','2013-12-16','10:05:00',4.37),('16100','2013-12-16','10:10:00',4.49),('16100','2013-12-16','10:15:00',4.53),('16100','2013-12-16','10:20:00',4.6),('16100','2013-12-16','10:25:00',4.71),('16100','2013-12-16','10:30:00',4.78),('16100','2013-12-16','10:35:00',4.84),('16100','2013-12-16','10:40:00',4.92),('16100','2013-12-16','10:45:00',5.01),('16100','2013-12-16','10:50:00',5.09),('16100','2013-12-16','10:55:00',5.14),('16100','2013-12-16','11:00:00',5.2),('16100','2013-12-16','11:05:00',5.24),('16100','2013-12-16','11:10:00',5.29),('16100','2013-12-16','11:15:00',5.32),('16100','2013-12-16','11:20:00',5.36),('16100','2013-12-16','11:25:00',5.45),('16100','2013-12-16','11:30:00',5.45),('16100','2013-12-16','11:35:00',5.5),('16100','2013-12-16','11:40:00',5.57),('16100','2013-12-16','11:45:00',5.56),('16100','2013-12-16','11:50:00',5.59),('16100','2013-12-16','11:55:00',5.58),('16100','2013-12-16','12:00:00',5.6),('16100','2013-12-16','12:05:00',5.65),('16100','2013-12-16','12:10:00',5.65),('16100','2013-12-16','12:15:00',5.64),('16100','2013-12-16','12:20:00',5.65),('16100','2013-12-16','12:25:00',5.63),('16100','2013-12-16','12:30:00',5.58),('16100','2013-12-16','12:35:00',5.52),('16100','2013-12-16','12:40:00',5.46),('16100','2013-12-16','12:45:00',5.43),('16100','2013-12-16','12:50:00',5.4),('16100','2013-12-16','12:55:00',5.38),('16100','2013-12-16','13:00:00',5.33),('16100','2013-12-16','13:05:00',5.26),('16100','2013-12-16','13:10:00',5.16),('16100','2013-12-16','13:15:00',5.11),('16100','2013-12-16','13:20:00',5.08),('16100','2013-12-16','13:25:00',5.03),('16100','2013-12-16','13:30:00',4.98),('16100','2013-12-16','13:35:00',4.92),('16100','2013-12-16','13:40:00',4.8),('16100','2013-12-16','13:45:00',4.72),('16100','2013-12-16','13:50:00',4.56),('16100','2013-12-16','13:55:00',4.5),('16100','2013-12-16','14:00:00',4.4),('16100','2013-12-16','14:05:00',4.24),('16100','2013-12-16','14:10:00',4.13),('16100','2013-12-16','14:15:00',3.99),('16100','2013-12-16','14:20:00',3.88),('16100','2013-12-16','14:25:00',3.74),('16100','2013-12-16','14:30:00',3.61),('16100','2013-12-16','14:35:00',3.46),('16100','2013-12-16','14:40:00',3.34),('16100','2013-12-16','14:45:00',3.18),('16100','2013-12-16','14:50:00',3.07),('16100','2013-12-16','14:55:00',2.94),('16100','2013-12-16','15:00:00',2.82),('16100','2013-12-16','15:05:00',2.67),('16100','2013-12-16','15:10:00',2.56),('16100','2013-12-16','15:15:00',2.42),('16100','2013-12-16','15:20:00',2.23),('16100','2013-12-16','15:25:00',2.06),('16100','2013-12-16','15:30:00',1.87),('16100','2013-12-16','15:35:00',1.75),('16100','2013-12-16','15:40:00',1.59),('16100','2013-12-16','15:45:00',1.42),('16100','2013-12-16','15:50:00',1.24),('16100','2013-12-16','15:55:00',1.1),('16100','2013-12-15','08:15:00',1.14),('16100','2013-12-15','08:20:00',1.31),('16100','2013-12-15','08:25:00',1.46),('16100','2013-12-15','08:30:00',1.61),('16100','2013-12-15','08:35:00',1.78),('16100','2013-12-15','08:40:00',1.95),('16100','2013-12-15','08:45:00',2.11),('16100','2013-12-15','08:50:00',2.3),('16100','2013-12-15','08:55:00',2.44),('16100','2013-12-15','09:00:00',2.58),('16100','2013-12-15','09:05:00',2.73),('16100','2013-12-15','09:10:00',2.89),('16100','2013-12-15','09:15:00',3.02),('16100','2013-12-15','09:20:00',3.2),('16100','2013-12-15','09:25:00',3.35),('16100','2013-12-15','09:30:00',3.5),('16100','2013-12-15','09:35:00',3.63),('16100','2013-12-15','09:40:00',3.77),('16100','2013-12-15','09:45:00',3.89),('16100','2013-12-15','09:50:00',4),('16100','2013-12-15','09:55:00',4.1),('16100','2013-12-15','10:00:00',4.17),('16100','2013-12-15','10:05:00',4.27),('16100','2013-12-15','10:10:00',4.4),('16100','2013-12-15','10:15:00',4.52),('16100','2013-12-15','10:20:00',4.64),('16100','2013-12-15','10:25:00',4.73),('16100','2013-12-15','10:30:00',4.82),('16100','2013-12-15','10:35:00',4.88),('16100','2013-12-15','10:40:00',4.92),('16100','2013-12-15','10:45:00',4.97),('16100','2013-12-15','10:50:00',5.06),('16100','2013-12-15','10:55:00',5.13),('16100','2013-12-15','11:00:00',5.15),('16100','2013-12-15','11:05:00',5.22),('16100','2013-12-15','11:10:00',5.3),('16100','2013-12-15','11:15:00',5.4),('16100','2013-12-15','11:20:00',5.5),('16100','2013-12-15','11:25:00',5.48),('16100','2013-12-15','11:30:00',5.51),('16100','2013-12-15','11:35:00',5.52),('16100','2013-12-15','11:40:00',5.55),('16100','2013-12-15','11:45:00',5.55),('16100','2013-12-15','11:50:00',5.6),('16100','2013-12-15','11:55:00',5.61),('16100','2013-12-15','12:00:00',5.59),('16100','2013-12-15','12:05:00',5.55),('16100','2013-12-15','12:10:00',5.56),('16100','2013-12-15','12:15:00',5.48),('16100','2013-12-15','12:20:00',5.4),('16100','2013-12-15','12:25:00',5.39),('16100','2013-12-15','12:30:00',5.36),('16100','2013-12-15','12:35:00',5.33),('16100','2013-12-15','12:40:00',5.33),('16100','2013-12-15','12:45:00',5.34),('16100','2013-12-15','12:50:00',5.3),('16100','2013-12-15','12:55:00',5.2),('16100','2013-12-15','13:00:00',5.19),('16100','2013-12-15','13:05:00',5.1),('16100','2013-12-15','13:10:00',5.04),('16100','2013-12-15','13:15:00',5.02),('16100','2013-12-15','13:20:00',5),('16100','2013-12-15','13:25:00',5.03),('16100','2013-12-15','13:30:00',4.95),('16100','2013-12-15','13:35:00',4.84),('16100','2013-12-15','13:40:00',4.74),('16100','2013-12-15','13:45:00',4.68),('16100','2013-12-15','13:50:00',4.55),('16100','2013-12-15','13:55:00',4.45),('16100','2013-12-15','14:00:00',4.33),('16100','2013-12-15','14:05:00',4.23),('16100','2013-12-15','14:10:00',4.11),('16100','2013-12-15','14:15:00',4.02),('16100','2013-12-15','14:20:00',3.91),('16100','2013-12-15','14:25:00',3.73),('16100','2013-12-15','14:30:00',3.58),('16100','2013-12-15','14:35:00',3.5),('16100','2013-12-15','14:40:00',3.32),('16100','2013-12-15','14:45:00',3.14),('16100','2013-12-15','14:50:00',3.15),('16100','2013-12-15','14:55:00',3.02),('16100','2013-12-15','15:00:00',2.92),('16100','2013-12-15','15:05:00',2.79),('16100','2013-12-15','15:10:00',2.67),('16100','2013-12-15','15:15:00',2.45),('16100','2013-12-15','15:20:00',2.28),('16100','2013-12-15','15:25:00',2.09),('16100','2013-12-15','15:30:00',1.93),('16100','2013-12-15','15:35:00',1.77),('16100','2013-12-15','15:40:00',1.61),('16100','2013-12-15','15:45:00',1.42),('16100','2013-12-15','15:50:00',1.28),('16100','2013-12-15','15:55:00',1.11),('16100','2013-12-14','09:45:00',1.03),('16100','2013-12-14','09:50:00',1.04),('16100','2013-12-14','10:10:00',1.01),('16100','2013-12-14','10:15:00',1.01),('16100','2013-12-14','10:20:00',1.34),('16100','2013-12-14','10:25:00',1.73),('16100','2013-12-14','10:30:00',2.88),('16100','2013-12-14','10:35:00',1.85),('16100','2013-12-14','10:40:00',1.8),('16100','2013-12-14','10:45:00',1.66),('16100','2013-12-14','10:50:00',1.36),('16100','2013-12-14','10:55:00',1.13),('16100','2013-12-14','11:00:00',1.17),('16100','2013-12-14','11:05:00',1.26),('16100','2013-12-14','11:10:00',1.47),('16100','2013-12-14','11:15:00',1.67),('16100','2013-12-14','11:20:00',1.64),('16100','2013-12-14','11:25:00',1.49),('16100','2013-12-14','11:30:00',1.6),('16100','2013-12-14','11:35:00',1.56),('16100','2013-12-14','11:40:00',1.46),('16100','2013-12-14','11:45:00',1.39),('16100','2013-12-14','11:50:00',1.37),('16100','2013-12-14','11:55:00',1.55),('16100','2013-12-14','12:00:00',1.72),('16100','2013-12-14','12:05:00',1.39),('16100','2013-12-14','12:10:00',1.09),('16100','2013-12-14','12:15:00',1.01),('16100','2013-12-13','08:20:00',1.07),('16100','2013-12-13','08:25:00',1.22),('16100','2013-12-13','08:30:00',1.38),('16100','2013-12-13','08:35:00',1.55),('16100','2013-12-13','08:40:00',1.7),('16100','2013-12-13','08:45:00',1.85),('16100','2013-12-13','08:50:00',2),('16100','2013-12-13','08:55:00',2.16),('16100','2013-12-13','09:00:00',2.33),('16100','2013-12-13','09:05:00',2.52),('16100','2013-12-13','09:10:00',2.69),('16100','2013-12-13','09:15:00',2.79),('16100','2013-12-13','09:20:00',2.96),('16100','2013-12-13','09:25:00',3.1),('16100','2013-12-13','09:30:00',3.25),('16100','2013-12-13','09:35:00',3.42),('16100','2013-12-13','09:40:00',3.55),('16100','2013-12-13','09:45:00',3.59),('16100','2013-12-13','09:50:00',3.65),('16100','2013-12-13','09:55:00',3.77),('16100','2013-12-13','10:00:00',3.88),('16100','2013-12-13','10:05:00',4.01),('16100','2013-12-13','10:10:00',4.08),('16100','2013-12-13','10:15:00',4.19),('16100','2013-12-13','10:20:00',4.3),('16100','2013-12-13','10:25:00',4.41),('16100','2013-12-13','10:30:00',4.52),('16100','2013-12-13','10:35:00',4.57),('16100','2013-12-13','10:40:00',4.66),('16100','2013-12-13','10:45:00',4.77),('16100','2013-12-13','10:50:00',4.67),('16100','2013-12-13','10:55:00',4.84),('16100','2013-12-13','11:00:00',4.87),('16100','2013-12-13','11:05:00',4.92),('16100','2013-12-13','11:10:00',5.01),('16100','2013-12-13','11:15:00',5.06),('16100','2013-12-13','11:20:00',5.09),('16100','2013-12-13','11:25:00',5.11),('16100','2013-12-13','11:30:00',5.07),('16100','2013-12-13','11:35:00',5.11),('16100','2013-12-13','11:40:00',5.06),('16100','2013-12-13','11:45:00',5.04),('16100','2013-12-13','11:50:00',5),('16100','2013-12-13','11:55:00',4.97),('16100','2013-12-13','12:00:00',5.02),('16100','2013-12-13','12:05:00',5.05),('16100','2013-12-13','12:10:00',4.97),('16100','2013-12-13','12:15:00',4.98),('16100','2013-12-13','12:20:00',4.95),('16100','2013-12-13','12:25:00',5.04),('16100','2013-12-13','12:30:00',4.91),('16100','2013-12-13','12:35:00',4.82),('16100','2013-12-13','12:40:00',4.91),('16100','2013-12-13','12:45:00',4.86),('16100','2013-12-13','12:50:00',4.83),('16100','2013-12-13','12:55:00',4.89),('16100','2013-12-13','13:00:00',4.88),('16100','2013-12-13','13:05:00',4.89),('16100','2013-12-13','13:10:00',4.83),('16100','2013-12-13','13:15:00',4.86),('16100','2013-12-13','13:20:00',4.66),('16100','2013-12-13','13:25:00',4.64),('16100','2013-12-13','13:30:00',4.57),('16100','2013-12-13','13:35:00',4.46),('16100','2013-12-13','13:40:00',4.38),('16100','2013-12-13','13:45:00',4.29),('16100','2013-12-13','13:50:00',4.17),('16100','2013-12-13','13:55:00',4.15),('16100','2013-12-13','14:00:00',4.06),('16100','2013-12-13','14:05:00',4.02),('16100','2013-12-13','14:10:00',3.92),('16100','2013-12-13','14:15:00',3.82),('16100','2013-12-13','14:20:00',3.75),('16100','2013-12-13','14:25:00',3.6),('16100','2013-12-13','14:30:00',3.49),('16100','2013-12-13','14:35:00',3.36),('16100','2013-12-13','14:40:00',3.24),('16100','2013-12-13','14:45:00',3.09),('16100','2013-12-13','14:50:00',2.96),('16100','2013-12-13','14:55:00',2.83),('16100','2013-12-13','15:00:00',2.64),('16100','2013-12-13','15:05:00',2.51),('16100','2013-12-13','15:10:00',2.28),('16100','2013-12-13','15:15:00',2.17),('16100','2013-12-13','15:20:00',2.01),('16100','2013-12-13','15:25:00',1.8),('16100','2013-12-13','15:30:00',1.71),('16100','2013-12-13','15:35:00',1.56),('16100','2013-12-13','15:40:00',1.38),('16100','2013-12-13','15:45:00',1.22),('16100','2013-12-13','15:50:00',1.08),('16100','2013-12-12','08:25:00',1.15),('16100','2013-12-12','08:30:00',1.31),('16100','2013-12-12','08:35:00',1.47),('16100','2013-12-12','08:40:00',1.62),('16100','2013-12-12','08:45:00',1.75),('16100','2013-12-12','08:50:00',1.88),('16100','2013-12-12','08:55:00',1.99),('16100','2013-12-12','09:00:00',2.08),('16100','2013-12-12','09:05:00',2.21),('16100','2013-12-12','09:10:00',2.38),('16100','2013-12-12','09:15:00',2.55),('16100','2013-12-12','09:20:00',2.69),('16100','2013-12-12','09:25:00',2.79),('16100','2013-12-12','09:30:00',2.87),('16100','2013-12-12','09:35:00',3.03),('16100','2013-12-12','09:40:00',3.22),('16100','2013-12-12','09:45:00',3.33),('16100','2013-12-12','09:50:00',3.49),('16100','2013-12-12','09:55:00',3.56),('16100','2013-12-12','10:00:00',3.66),('16100','2013-12-12','10:05:00',3.77),('16100','2013-12-12','10:10:00',3.84),('16100','2013-12-12','10:15:00',3.95),('16100','2013-12-12','10:20:00',4.07),('16100','2013-12-12','10:25:00',4.15),('16100','2013-12-12','10:30:00',4.23),('16100','2013-12-12','10:35:00',4.34),('16100','2013-12-12','10:40:00',4.43),('16100','2013-12-12','10:45:00',4.5),('16100','2013-12-12','10:50:00',4.56),('16100','2013-12-12','10:55:00',4.58),('16100','2013-12-12','11:00:00',4.66),('16100','2013-12-12','11:05:00',4.69),('16100','2013-12-12','11:10:00',4.74),('16100','2013-12-12','11:15:00',4.79),('16100','2013-12-12','11:20:00',4.92),('16100','2013-12-12','11:25:00',4.98),('16100','2013-12-12','11:30:00',4.99),('16100','2013-12-12','11:35:00',4.97),('16100','2013-12-12','11:40:00',5.06),('16100','2013-12-12','11:45:00',5.06),('16100','2013-12-12','11:50:00',5.07),('16100','2013-12-12','11:55:00',5.03),('16100','2013-12-12','12:00:00',5.03),('16100','2013-12-12','12:05:00',5.04),('16100','2013-12-12','12:10:00',5.02),('16100','2013-12-12','12:15:00',4.93),('16100','2013-12-12','12:20:00',4.94),('16100','2013-12-12','12:25:00',4.94),('16100','2013-12-12','12:30:00',5.32),('16100','2013-12-12','12:35:00',4.87),('16100','2013-12-12','12:40:00',4.78),('16100','2013-12-12','12:45:00',4.85),('16100','2013-12-12','12:50:00',4.79),('16100','2013-12-12','12:55:00',4.86),('16100','2013-12-12','13:00:00',4.78),('16100','2013-12-12','13:05:00',4.88),('16100','2013-12-12','13:10:00',4.66),('16100','2013-12-12','13:15:00',4.63),('16100','2013-12-12','13:20:00',4.5),('16100','2013-12-12','13:25:00',4.46),('16100','2013-12-12','13:30:00',4.51),('16100','2013-12-12','13:35:00',4.5),('16100','2013-12-12','13:40:00',4.49),('16100','2013-12-12','13:45:00',4.46),('16100','2013-12-12','13:50:00',4.25),('16100','2013-12-12','13:55:00',4.1),('16100','2013-12-12','14:00:00',3.99),('16100','2013-12-12','14:05:00',3.95),('16100','2013-12-12','14:10:00',3.77),('16100','2013-12-12','14:15:00',3.66),('16100','2013-12-12','14:20:00',3.59),('16100','2013-12-12','14:25:00',3.44),('16100','2013-12-12','14:30:00',3.24),('16100','2013-12-12','14:35:00',3.18),('16100','2013-12-12','14:40:00',3.18),('16100','2013-12-12','14:45:00',3.01),('16100','2013-12-12','14:50:00',2.89),('16100','2013-12-12','14:55:00',2.73),('16100','2013-12-12','15:00:00',2.65),('16100','2013-12-12','15:05:00',2.51),('16100','2013-12-12','15:10:00',2.37),('16100','2013-12-12','15:15:00',2.22),('16100','2013-12-12','15:20:00',2.08),('16100','2013-12-12','15:25:00',1.92),('16100','2013-12-12','15:30:00',1.75),('16100','2013-12-12','15:35:00',1.57),('16100','2013-12-12','15:40:00',1.41),('16100','2013-12-12','15:45:00',1.24),('16100','2013-12-12','15:50:00',1.06),('16100','2013-12-11','08:20:00',1.12),('16100','2013-12-11','08:25:00',1.27),('16100','2013-12-11','08:30:00',1.43),('16100','2013-12-11','08:35:00',1.6),('16100','2013-12-11','08:40:00',1.72),('16100','2013-12-11','08:45:00',1.87),('16100','2013-12-11','08:50:00',2.05),('16100','2013-12-11','08:55:00',2.19),('16100','2013-12-11','09:00:00',2.32),('16100','2013-12-11','09:05:00',2.49),('16100','2013-12-11','09:10:00',2.63),('16100','2013-12-11','09:15:00',2.74),('16100','2013-12-11','09:20:00',2.89),('16100','2013-12-11','09:25:00',3.09),('16100','2013-12-11','09:30:00',3.22),('16100','2013-12-11','09:35:00',3.37),('16100','2013-12-11','09:40:00',3.53),('16100','2013-12-11','09:45:00',3.64),('16100','2013-12-11','09:50:00',3.75),('16100','2013-12-11','09:55:00',3.83),('16100','2013-12-11','10:00:00',3.95),('16100','2013-12-11','10:05:00',4.08),('16100','2013-12-11','10:10:00',4.18),('16100','2013-12-11','10:15:00',4.3),('16100','2013-12-11','10:20:00',4.39),('16100','2013-12-11','10:25:00',4.48),('16100','2013-12-11','10:30:00',4.54),('16100','2013-12-11','10:35:00',4.62),('16100','2013-12-11','10:40:00',4.69),('16100','2013-12-11','10:45:00',4.73),('16100','2013-12-11','10:50:00',4.77),('16100','2013-12-11','10:55:00',4.82),('16100','2013-12-11','11:00:00',4.86),('16100','2013-12-11','11:05:00',4.92),('16100','2013-12-11','11:10:00',4.97),('16100','2013-12-11','11:15:00',4.99),('16100','2013-12-11','11:20:00',5.06),('16100','2013-12-11','11:25:00',5.05),('16100','2013-12-11','11:30:00',5.07),('16100','2013-12-11','11:35:00',5.09),('16100','2013-12-11','11:40:00',5.13),('16100','2013-12-11','11:45:00',5.12),('16100','2013-12-11','11:50:00',5.16),('16100','2013-12-11','11:55:00',5.19),('16100','2013-12-11','12:00:00',5.19),('16100','2013-12-11','12:05:00',5.2),('16100','2013-12-11','12:10:00',5.17),('16100','2013-12-11','12:15:00',5.18),('16100','2013-12-11','12:20:00',5.17),('16100','2013-12-11','12:25:00',5.2),('16100','2013-12-11','12:30:00',5.15),('16100','2013-12-11','12:35:00',5.17),('16100','2013-12-11','12:40:00',5.02),('16100','2013-12-11','12:45:00',4.9),('16100','2013-12-11','12:50:00',5.07),('16100','2013-12-11','12:55:00',5),('16100','2013-12-11','13:00:00',5.02),('16100','2013-12-11','13:05:00',5),('16100','2013-12-11','13:10:00',4.94),('16100','2013-12-11','13:15:00',4.89),('16100','2013-12-11','13:20:00',4.83),('16100','2013-12-11','13:25:00',4.7),('16100','2013-12-11','13:30:00',4.66),('16100','2013-12-11','13:35:00',4.54),('16100','2013-12-11','13:40:00',4.44),('16100','2013-12-11','13:45:00',4.39),('16100','2013-12-11','13:50:00',4.28),('16100','2013-12-11','13:55:00',4.16),('16100','2013-12-11','14:00:00',4.06),('16100','2013-12-11','14:05:00',3.96),('16100','2013-12-11','14:10:00',3.83),('16100','2013-12-11','14:15:00',3.7),('16100','2013-12-11','14:20:00',3.54),('16100','2013-12-11','14:25:00',3.43),('16100','2013-12-11','14:30:00',3.36),('16100','2013-12-11','14:35:00',3.24),('16100','2013-12-11','14:40:00',3.11),('16100','2013-12-11','14:45:00',2.95),('16100','2013-12-11','14:50:00',2.75),('16100','2013-12-11','14:55:00',2.63),('16100','2013-12-11','15:00:00',2.47),('16100','2013-12-11','15:05:00',2.31),('16100','2013-12-11','15:10:00',2.19),('16100','2013-12-11','15:15:00',2.04),('16100','2013-12-11','15:20:00',1.88),('16100','2013-12-11','15:25:00',1.72),('16100','2013-12-11','15:30:00',1.55),('16100','2013-12-11','15:35:00',1.4),('16100','2013-12-11','15:40:00',1.21),('16100','2013-12-11','15:45:00',1.04),('16100','2013-12-10','08:15:00',1.09),('16100','2013-12-10','08:20:00',1.28),('16100','2013-12-10','08:25:00',1.43),('16100','2013-12-10','08:30:00',1.62),('16100','2013-12-10','08:35:00',1.76),('16100','2013-12-10','08:40:00',1.95),('16100','2013-12-10','08:45:00',2.13),('16100','2013-12-10','08:50:00',2.31),('16100','2013-12-10','08:55:00',2.48),('16100','2013-12-10','09:00:00',2.61),('16100','2013-12-10','09:05:00',2.77),('16100','2013-12-10','09:10:00',2.95),('16100','2013-12-10','09:15:00',3.07),('16100','2013-12-10','09:20:00',3.17),('16100','2013-12-10','09:25:00',3.28),('16100','2013-12-10','09:30:00',3.41),('16100','2013-12-10','09:35:00',3.57),('16100','2013-12-10','09:40:00',3.72),('16100','2013-12-10','09:45:00',3.8),('16100','2013-12-10','09:50:00',3.88),('16100','2013-12-10','09:55:00',3.99),('16100','2013-12-10','10:00:00',4.11),('16100','2013-12-10','10:05:00',4.27),('16100','2013-12-10','10:10:00',4.45),('16100','2013-12-10','10:15:00',4.6),('16100','2013-12-10','10:20:00',4.67),('16100','2013-12-10','10:25:00',4.71),('16100','2013-12-10','10:30:00',4.7),('16100','2013-12-10','10:35:00',4.76),('16100','2013-12-10','10:40:00',4.85),('16100','2013-12-10','10:45:00',4.85),('16100','2013-12-10','10:50:00',4.89),('16100','2013-12-10','10:55:00',4.95),('16100','2013-12-10','11:00:00',5.06),('16100','2013-12-10','11:05:00',5.21),('16100','2013-12-10','11:10:00',5.21),('16100','2013-12-10','11:15:00',5.2),('16100','2013-12-10','11:20:00',5.26),('16100','2013-12-10','11:25:00',5.36),('16100','2013-12-10','11:30:00',5.44),('16100','2013-12-10','11:35:00',5.51),('16100','2013-12-10','11:40:00',5.51),('16100','2013-12-10','11:45:00',5.57),('16100','2013-12-10','11:50:00',5.59),('16100','2013-12-10','11:55:00',5.62),('16100','2013-12-10','12:00:00',5.59),('16100','2013-12-10','12:05:00',5.59),('16100','2013-12-10','12:10:00',5.59),('16100','2013-12-10','12:15:00',5.52),('16100','2013-12-10','12:20:00',5.54),('16100','2013-12-10','12:25:00',5.54),('16100','2013-12-10','12:30:00',5.53),('16100','2013-12-10','12:35:00',5.5),('16100','2013-12-10','12:40:00',5.42),('16100','2013-12-10','12:45:00',5.37),('16100','2013-12-10','12:50:00',5.3),('16100','2013-12-10','12:55:00',5.28),('16100','2013-12-10','13:00:00',5.28),('16100','2013-12-10','13:05:00',5.26),('16100','2013-12-10','13:10:00',5.2),('16100','2013-12-10','13:15:00',5.15),('16100','2013-12-10','13:20:00',5.08),('16100','2013-12-10','13:25:00',5.02),('16100','2013-12-10','13:30:00',4.9),('16100','2013-12-10','13:35:00',4.76),('16100','2013-12-10','13:40:00',4.66),('16100','2013-12-10','13:45:00',4.53),('16100','2013-12-10','13:50:00',4.45),('16100','2013-12-10','13:55:00',4.38),('16100','2013-12-10','14:00:00',4.31),('16100','2013-12-10','14:05:00',4.24),('16100','2013-12-10','14:10:00',4.17),('16100','2013-12-10','14:15:00',4.03),('16100','2013-12-10','14:20:00',3.85),('16100','2013-12-10','14:25:00',3.74),('16100','2013-12-10','14:30:00',3.68),('16100','2013-12-10','14:35:00',3.54),('16100','2013-12-10','14:40:00',3.41),('16100','2013-12-10','14:45:00',3.26),('16100','2013-12-10','14:50:00',3.06),('16100','2013-12-10','14:55:00',2.9),('16100','2013-12-10','15:00:00',2.74),('16100','2013-12-10','15:05:00',2.61),('16100','2013-12-10','15:10:00',2.45),('16100','2013-12-10','15:15:00',2.27),('16100','2013-12-10','15:20:00',2.09),('16100','2013-12-10','15:25:00',1.87),('16100','2013-12-10','15:30:00',1.71),('16100','2013-12-10','15:35:00',1.57),('16100','2013-12-10','15:40:00',1.41),('16100','2013-12-10','15:45:00',1.23),('16100','2013-12-10','15:50:00',1.03),('16100','2013-12-09','08:15:00',1.15),('16100','2013-12-09','08:20:00',1.32),('16100','2013-12-09','08:25:00',1.48),('16100','2013-12-09','08:30:00',1.64),('16100','2013-12-09','08:35:00',1.8),('16100','2013-12-09','08:40:00',1.98),('16100','2013-12-09','08:45:00',2.18),('16100','2013-12-09','08:50:00',2.33),('16100','2013-12-09','08:55:00',2.5),('16100','2013-12-09','09:00:00',2.66),('16100','2013-12-09','09:05:00',2.86),('16100','2013-12-09','09:10:00',3.01),('16100','2013-12-09','09:15:00',3.13),('16100','2013-12-09','09:20:00',3.24),('16100','2013-12-09','09:25:00',3.35),('16100','2013-12-09','09:30:00',3.52),('16100','2013-12-09','09:35:00',3.68),('16100','2013-12-09','09:40:00',3.83),('16100','2013-12-09','09:45:00',3.94),('16100','2013-12-09','09:50:00',4.05),('16100','2013-12-09','09:55:00',4.15),('16100','2013-12-09','10:00:00',4.23),('16100','2013-12-09','10:05:00',4.35),('16100','2013-12-09','10:10:00',4.38),('16100','2013-12-09','10:15:00',4.5),('16100','2013-12-09','10:20:00',4.61),('16100','2013-12-09','10:25:00',4.69),('16100','2013-12-09','10:30:00',4.76),('16100','2013-12-09','10:35:00',4.85),('16100','2013-12-09','10:40:00',4.9),('16100','2013-12-09','10:45:00',4.96),('16100','2013-12-09','10:50:00',5.02),('16100','2013-12-09','10:55:00',5.09),('16100','2013-12-09','11:00:00',5.14),('16100','2013-12-09','11:05:00',5.2),('16100','2013-12-09','11:10:00',5.28),('16100','2013-12-09','11:15:00',5.38),('16100','2013-12-09','11:20:00',5.44),('16100','2013-12-09','11:25:00',5.49),('16100','2013-12-09','11:30:00',5.52),('16100','2013-12-09','11:35:00',5.57),('16100','2013-12-09','11:40:00',5.59),('16100','2013-12-09','11:45:00',5.56),('16100','2013-12-09','11:50:00',5.54),('16100','2013-12-09','11:55:00',5.51),('16100','2013-12-09','12:00:00',5.47),('16100','2013-12-09','12:05:00',5.43),('16100','2013-12-09','12:10:00',5.42),('16100','2013-12-09','12:15:00',5.43),('16100','2013-12-09','12:20:00',5.4),('16100','2013-12-09','12:25:00',5.41),('16100','2013-12-09','12:30:00',5.47),('16100','2013-12-09','12:35:00',5.4),('16100','2013-12-09','12:40:00',5.35),('16100','2013-12-09','12:45:00',5.31),('16100','2013-12-09','12:50:00',5.23),('16100','2013-12-09','12:55:00',5.2),('16100','2013-12-09','13:00:00',5.17),('16100','2013-12-09','13:05:00',5.17),('16100','2013-12-09','13:10:00',5.09),('16100','2013-12-09','13:15:00',5.02),('16100','2013-12-09','13:20:00',4.94),('16100','2013-12-09','13:25:00',4.89),('16100','2013-12-09','13:30:00',4.85),('16100','2013-12-09','13:35:00',4.75),('16100','2013-12-09','13:40:00',4.6),('16100','2013-12-09','13:45:00',4.49),('16100','2013-12-09','13:50:00',4.41),('16100','2013-12-09','13:55:00',4.33),('16100','2013-12-09','14:00:00',4.26),('16100','2013-12-09','14:05:00',4.19),('16100','2013-12-09','14:10:00',4.09),('16100','2013-12-09','14:15:00',4.02),('16100','2013-12-09','14:20:00',3.93),('16100','2013-12-09','14:25:00',3.78),('16100','2013-12-09','14:30:00',3.67),('16100','2013-12-09','14:35:00',3.54),('16100','2013-12-09','14:40:00',3.35),('16100','2013-12-09','14:45:00',3.21),('16100','2013-12-09','14:50:00',3.13),('16100','2013-12-09','14:55:00',3.01),('16100','2013-12-09','15:00:00',2.9),('16100','2013-12-09','15:05:00',2.76),('16100','2013-12-09','15:10:00',2.6),('16100','2013-12-09','15:15:00',2.4),('16100','2013-12-09','15:20:00',2.24),('16100','2013-12-09','15:25:00',2.03),('16100','2013-12-09','15:30:00',1.87),('16100','2013-12-09','15:35:00',1.71),('16100','2013-12-09','15:40:00',1.54),('16100','2013-12-09','15:45:00',1.36),('16100','2013-12-09','15:50:00',1.18),('16100','2013-12-09','15:55:00',1.01),('16100','2013-12-08','09:15:00',1.98),('16100','2013-12-08','09:20:00',3.48),('16100','2013-12-08','09:25:00',3.43),('16100','2013-12-08','09:30:00',3.43),('16100','2013-12-08','09:35:00',3.58),('16100','2013-12-08','09:40:00',3.71),('16100','2013-12-08','09:45:00',3.89),('16100','2013-12-08','09:50:00',4.21),('16100','2013-12-08','09:55:00',4.77),('16100','2013-12-08','10:00:00',4.94),('16100','2013-12-08','10:05:00',4.34),('16100','2013-12-08','10:10:00',1.67),('16100','2013-12-08','10:15:00',1.15),('16100','2013-12-08','12:00:00',1.16),('16100','2013-12-08','12:05:00',1.34),('16100','2013-12-08','12:10:00',1.28),('16100','2013-12-08','12:15:00',1.18),('16100','2013-12-08','12:20:00',1.44),('16100','2013-12-08','12:25:00',2),('16100','2013-12-08','12:30:00',5.51),('16100','2013-12-08','12:35:00',3.09),('16100','2013-12-08','12:40:00',1.83),('16100','2013-12-08','12:45:00',3.04),('16100','2013-12-08','12:50:00',4.19),('16100','2013-12-08','12:55:00',5.53),('16100','2013-12-08','13:00:00',5.23),('16100','2013-12-08','13:05:00',4.39),('16100','2013-12-08','13:10:00',3.56),('16100','2013-12-08','13:15:00',2.56),('16100','2013-12-08','13:20:00',5),('16100','2013-12-08','13:25:00',4.57),('16100','2013-12-08','13:30:00',2.27),('16100','2013-12-08','13:35:00',2.8),('16100','2013-12-08','13:40:00',2.5),('16100','2013-12-08','13:45:00',2.24),('16100','2013-12-08','13:50:00',2.48),('16100','2013-12-08','13:55:00',1.66),('16100','2013-12-08','14:00:00',1.07),('16100','2013-12-07','08:55:00',1.22),('16100','2013-12-07','09:00:00',1.37),('16100','2013-12-07','09:05:00',1.94),('16100','2013-12-07','09:10:00',1.76),('16100','2013-12-07','09:15:00',2.39),('16100','2013-12-07','09:20:00',1.07),('16100','2013-12-07','09:25:00',1.01),('16100','2013-12-07','09:35:00',1.07),('16100','2013-12-07','10:05:00',1.02),('16100','2013-12-07','10:10:00',1.11),('16100','2013-12-07','10:15:00',1.07),('16100','2013-12-07','10:20:00',1.15),('16100','2013-12-07','10:25:00',1.08),('16100','2013-12-07','10:30:00',1.09),('16100','2013-12-07','10:35:00',1.31),('16100','2013-12-07','10:40:00',1.07),('16100','2013-12-07','10:45:00',1.06),('16100','2013-12-07','10:50:00',1.02),('16100','2013-12-07','11:00:00',1.09),('16100','2013-12-07','11:05:00',1.12),('16100','2013-12-07','11:10:00',1.04),('16100','2013-12-07','11:15:00',1.2),('16100','2013-12-07','11:20:00',2.64),('16100','2013-12-07','11:25:00',1.87),('16100','2013-12-07','11:30:00',2.04),('16100','2013-12-07','11:35:00',1.96),('16100','2013-12-07','11:40:00',1.83),('16100','2013-12-07','11:45:00',1.8),('16100','2013-12-07','11:50:00',2.36),('16100','2013-12-07','11:55:00',2.02),('16100','2013-12-07','12:00:00',1.78),('16100','2013-12-07','12:05:00',1.55),('16100','2013-12-07','12:10:00',1.52),('16100','2013-12-07','12:15:00',1.56),('16100','2013-12-07','12:20:00',1.65),('16100','2013-12-07','12:25:00',1.48),('16100','2013-12-07','12:30:00',1.44),('16100','2013-12-07','12:35:00',1.55),('16100','2013-12-07','12:40:00',1.51),('16100','2013-12-07','12:45:00',2.81),('16100','2013-12-07','12:50:00',2.74),('16100','2013-12-07','12:55:00',2.46),('16100','2013-12-07','13:00:00',1.54),('16100','2013-12-07','13:05:00',1.43),('16100','2014-04-20','08:35:00',1.06),('16100','2014-04-20','08:40:00',1.51),('16100','2014-04-20','08:45:00',1.71),('16100','2014-04-20','08:50:00',2.48),('16100','2014-04-20','08:55:00',2.57),('16100','2014-04-20','09:00:00',2.61),('16100','2014-04-20','09:05:00',2.36),('16100','2014-04-20','09:10:00',2.2),('16100','2014-04-20','09:15:00',2.42),('16100','2014-04-20','09:20:00',1.79),('16100','2014-04-20','09:25:00',3),('16100','2014-04-20','09:30:00',3.04),('16100','2014-04-20','09:35:00',3.13),('16100','2014-04-20','09:40:00',2.61),('16100','2014-04-20','09:45:00',1.4),('16100','2014-04-20','09:50:00',1.84),('16100','2014-04-20','09:55:00',2.12),('16100','2014-04-20','10:00:00',2.28),('16100','2014-04-20','10:05:00',2.36),('16100','2014-04-20','10:10:00',5.82),('16100','2014-04-20','10:15:00',5.84),('16100','2014-04-20','10:20:00',5.84),('16100','2014-04-20','10:25:00',5.67),('16100','2014-04-20','10:30:00',5.59),('16100','2014-04-20','10:35:00',5.65),('16100','2014-04-20','10:40:00',5.74),('16100','2014-04-20','10:45:00',5.84),('16100','2014-04-20','10:50:00',5.91),('16100','2014-04-20','10:55:00',5.98),('16100','2014-04-20','11:00:00',6.05),('16100','2014-04-20','11:05:00',6.17),('16100','2014-04-20','11:10:00',6.28),('16100','2014-04-20','11:15:00',6.33),('16100','2014-04-20','11:20:00',6.4),('16100','2014-04-20','11:25:00',6.48),('16100','2014-04-20','11:30:00',6.62),('16100','2014-04-20','11:35:00',6.68),('16100','2014-04-20','11:40:00',6.8),('16100','2014-04-20','11:45:00',6.85),('16100','2014-04-20','11:50:00',6.94),('16100','2014-04-20','11:55:00',7),('16100','2014-04-20','12:00:00',7.06),('16100','2014-04-20','12:05:00',7.13),('16100','2014-04-20','12:10:00',7.17),('16100','2014-04-20','12:15:00',7.23),('16100','2014-04-20','12:20:00',7.3),('16100','2014-04-20','12:25:00',7.29),('16100','2014-04-20','12:30:00',7.36),('16100','2014-04-20','12:35:00',7.4),('16100','2014-04-20','12:40:00',7.36),('16100','2014-04-20','12:45:00',7.41),('16100','2014-04-20','12:50:00',7.45),('16100','2014-04-20','12:55:00',7.49),('16100','2014-04-20','13:00:00',7.48),('16100','2014-04-20','13:05:00',7.45),('16100','2014-04-20','13:10:00',7.48),('16100','2014-04-20','13:15:00',7.46),('16100','2014-04-20','13:20:00',7.48),('16100','2014-04-20','13:25:00',7.47),('16100','2014-04-20','13:30:00',7.49),('16100','2014-04-20','13:35:00',7.5),('16100','2014-04-20','13:40:00',7.49),('16100','2014-04-20','13:45:00',7.51),('16100','2014-04-20','13:50:00',7.5),('16100','2014-04-20','13:55:00',7.49),('16100','2014-04-20','14:00:00',7.49),('16100','2014-04-20','14:05:00',7.41),('16100','2014-04-20','14:10:00',7.32),('16100','2014-04-20','14:15:00',7.28),('16100','2014-04-20','14:20:00',7.24),('16100','2014-04-20','14:25:00',7.18),('16100','2014-04-20','14:30:00',7.1),('16100','2014-04-20','14:35:00',7.05),('16100','2014-04-20','14:40:00',7.04),('16100','2014-04-20','14:45:00',7.01),('16100','2014-04-20','14:50:00',6.94),('16100','2014-04-20','14:55:00',6.86),('16100','2014-04-20','15:00:00',6.77),('16100','2014-04-20','15:05:00',6.71),('16100','2014-04-20','15:10:00',6.63),('16100','2014-04-20','15:15:00',6.55),('16100','2014-04-20','15:20:00',6.41),('16100','2014-04-20','15:25:00',6.3),('16100','2014-04-20','15:30:00',6.22),('16100','2014-04-20','15:35:00',6.11),('16100','2014-04-20','15:40:00',5.98),('16100','2014-04-20','15:45:00',5.9),('16100','2014-04-20','15:50:00',5.79),('16100','2014-04-20','15:55:00',5.69),('16100','2014-04-20','16:00:00',5.7),('16100','2014-04-20','16:05:00',5.82),('16100','2014-04-20','16:10:00',5.51),('16100','2014-04-20','16:15:00',5.28),('16100','2014-04-20','16:20:00',5.16),('16100','2014-04-20','16:25:00',5.13),('16100','2014-04-20','16:30:00',5.01),('16100','2014-04-20','16:35:00',4.76),('16100','2014-04-20','16:40:00',4.66),('16100','2014-04-20','16:45:00',4.51),('16100','2014-04-20','16:50:00',4.38),('16100','2014-04-20','16:55:00',4.24),('16100','2014-04-20','17:00:00',4.08),('16100','2014-04-20','17:05:00',3.96),('16100','2014-04-20','17:10:00',3.81),('16100','2014-04-20','17:15:00',3.65),('16100','2014-04-20','17:20:00',3.51),('16100','2014-04-20','17:25:00',3.33),('16100','2014-04-20','17:30:00',3.18),('16100','2014-04-20','17:35:00',3.03),('16100','2014-04-20','17:40:00',2.86),('16100','2014-04-20','17:45:00',2.7),('16100','2014-04-20','17:50:00',2.53),('16100','2014-04-20','17:55:00',2.35),('16100','2014-04-20','18:00:00',2.18),('16100','2014-04-20','18:05:00',2),('16100','2014-04-20','18:10:00',1.81),('16100','2014-04-20','18:15:00',1.59),('16100','2014-04-20','18:20:00',1.46),('16100','2014-04-20','18:25:00',1.3),('16100','2014-04-20','18:30:00',1.14),('16100','2013-12-06','08:10:00',1.07),('16100','2013-12-06','08:15:00',1.22),('16100','2013-12-06','08:20:00',1.36),('16100','2013-12-06','08:25:00',1.5),('16100','2013-12-06','08:30:00',1.66),('16100','2013-12-06','08:35:00',1.81),('16100','2013-12-06','08:40:00',1.96),('16100','2013-12-06','08:45:00',2.09),('16100','2013-12-06','08:50:00',2.22),('16100','2013-12-06','08:55:00',2.38),('16100','2013-12-06','09:00:00',2.52),('16100','2013-12-06','09:05:00',2.71),('16100','2013-12-06','09:10:00',2.86),('16100','2013-12-06','09:15:00',2.99),('16100','2013-12-06','09:20:00',3.14),('16100','2013-12-06','09:25:00',3.29),('16100','2013-12-06','09:30:00',3.45),('16100','2013-12-06','09:35:00',3.62),('16100','2013-12-06','09:40:00',3.73),('16100','2013-12-06','09:45:00',3.84),('16100','2013-12-06','09:50:00',3.96),('16100','2013-12-06','09:55:00',4.07),('16100','2013-12-06','10:00:00',4.18),('16100','2013-12-06','10:05:00',4.33),('16100','2013-12-06','10:10:00',4.43),('16100','2013-12-06','10:15:00',4.53),('16100','2013-12-06','10:20:00',4.6),('16100','2013-12-06','10:25:00',4.63),('16100','2013-12-06','10:30:00',4.72),('16100','2013-12-06','10:35:00',4.81),('16100','2013-12-06','10:40:00',4.89),('16100','2013-12-06','10:45:00',4.99),('16100','2013-12-06','10:50:00',4.97),('16100','2013-12-06','10:55:00',5.03),('16100','2013-12-06','11:00:00',5.06),('16100','2013-12-06','11:05:00',5.11),('16100','2013-12-06','11:10:00',5.08),('16100','2013-12-06','11:15:00',5.08),('16100','2013-12-06','11:20:00',5.1),('16100','2013-12-06','11:25:00',5.15),('16100','2013-12-06','11:30:00',5.21),('16100','2013-12-06','11:35:00',5.33),('16100','2013-12-06','11:40:00',5.32),('16100','2013-12-06','11:45:00',5.28),('16100','2013-12-06','11:50:00',5.24),('16100','2013-12-06','11:55:00',5.22),('16100','2013-12-06','12:00:00',5.26),('16100','2013-12-06','12:05:00',5.27),('16100','2013-12-06','12:10:00',5.23),('16100','2013-12-06','12:15:00',5.26),('16100','2013-12-06','12:20:00',5.18),('16100','2013-12-06','12:25:00',5.12),('16100','2013-12-06','12:30:00',5.15),('16100','2013-12-06','12:35:00',5),('16100','2013-12-06','12:40:00',4.93),('16100','2013-12-06','12:45:00',5.05),('16100','2013-12-06','12:50:00',5.04),('16100','2013-12-06','12:55:00',5.01),('16100','2013-12-06','13:00:00',4.95),('16100','2013-12-06','13:05:00',4.81),('16100','2013-12-06','13:10:00',4.71),('16100','2013-12-06','13:15:00',4.68),('16100','2013-12-06','13:20:00',4.61),('16100','2013-12-06','13:25:00',4.46),('16100','2013-12-06','13:30:00',4.46),('16100','2013-12-06','13:35:00',4.33),('16100','2013-12-06','13:40:00',4.28),('16100','2013-12-06','13:45:00',4.17),('16100','2013-12-06','13:50:00',4.13),('16100','2013-12-06','13:55:00',4.11),('16100','2013-12-06','14:00:00',4.07),('16100','2013-12-06','14:05:00',3.99),('16100','2013-12-06','14:10:00',3.89),('16100','2013-12-06','14:15:00',3.77),('16100','2013-12-06','14:20:00',3.61),('16100','2013-12-06','14:25:00',3.51),('16100','2013-12-06','14:30:00',3.4),('16100','2013-12-06','14:35:00',3.29),('16100','2013-12-06','14:40:00',3.14),('16100','2013-12-06','14:45:00',3),('16100','2013-12-06','14:50:00',2.88),('16100','2013-12-06','14:55:00',2.75),('16100','2013-12-06','15:00:00',2.58),('16100','2013-12-06','15:05:00',2.44),('16100','2013-12-06','15:10:00',2.26),('16100','2013-12-06','15:15:00',2.09),('16100','2013-12-06','15:20:00',1.94),('16100','2013-12-06','15:25:00',1.77),('16100','2013-12-06','15:30:00',1.61),('16100','2013-12-06','15:35:00',1.44),('16100','2013-12-06','15:40:00',1.29),('16100','2013-12-06','15:45:00',1.12),('16100','2013-12-05','09:55:00',1.04),('16100','2013-12-05','10:00:00',1.44),('16100','2013-12-05','10:05:00',1.28),('16100','2013-12-05','10:10:00',1.37),('16100','2013-12-05','10:15:00',1.69),('16100','2013-12-05','10:20:00',1.68),('16100','2013-12-05','10:25:00',1.52),('16100','2013-12-05','10:30:00',1.42),('16100','2013-12-05','10:35:00',1.38),('16100','2013-12-05','10:40:00',1.81),('16100','2013-12-05','10:45:00',1.77),('16100','2013-12-05','10:50:00',1.7),('16100','2013-12-05','10:55:00',1.56),('16100','2013-12-05','11:00:00',1.44),('16100','2013-12-05','11:05:00',1.66),('16100','2013-12-05','11:10:00',1.57),('16100','2013-12-05','11:15:00',1.68),('16100','2013-12-05','11:20:00',2.09),('16100','2013-12-05','11:25:00',2.5),('16100','2013-12-05','11:30:00',2.89),('16100','2013-12-05','11:35:00',3.67),('16100','2013-12-05','11:40:00',3.45),('16100','2013-12-05','11:45:00',3.19),('16100','2013-12-05','11:50:00',4.03),('16100','2013-12-05','11:55:00',4.34),('16100','2013-12-05','12:00:00',3.78),('16100','2013-12-05','12:05:00',5.07),('16100','2013-12-05','12:10:00',3.4),('16100','2013-12-05','12:15:00',4.99),('16100','2013-12-05','12:20:00',6.53),('16100','2013-12-05','12:25:00',5.12),('16100','2013-12-05','12:30:00',2.59),('16100','2013-12-05','12:35:00',2.14),('16100','2013-12-05','12:40:00',1.83),('16100','2013-12-05','12:45:00',1.58),('16100','2013-12-05','12:50:00',1.42),('16100','2013-12-05','12:55:00',1.41),('16100','2013-12-05','13:00:00',1.49),('16100','2013-12-05','13:05:00',1.18),('16100','2013-12-05','13:10:00',1.07),('16100','2013-12-05','13:15:00',1.05),('16100','2013-12-05','13:20:00',1.2),('16100','2013-12-05','13:25:00',1.44),('16100','2013-12-05','13:30:00',1.46),('16100','2013-12-05','13:35:00',1.48),('16100','2013-12-05','13:40:00',1.56),('16100','2013-12-05','13:45:00',1.5),('16100','2013-12-05','13:50:00',1.59),('16100','2013-12-05','13:55:00',1.42),('16100','2013-12-05','14:00:00',1.19),('16100','2013-12-05','14:05:00',1.16),('16100','2013-12-05','14:10:00',1.2),('16100','2013-12-05','14:15:00',1.2),('16100','2013-12-05','14:20:00',1.27),('16100','2013-12-05','14:25:00',1.24),('16100','2013-12-05','14:30:00',1.11),('16100','2013-12-05','14:35:00',1.07),('16100','2013-12-05','14:40:00',1.56),('16100','2013-12-05','14:45:00',1.49),('16100','2013-12-05','14:50:00',1.64),('16100','2013-12-05','14:55:00',2.33),('16100','2013-12-05','15:00:00',2.91),('16100','2013-12-05','15:05:00',2.82),('16100','2013-12-05','15:10:00',2.51),('16100','2013-12-05','15:15:00',2.75),('16100','2013-12-05','15:20:00',1.73),('16100','2013-12-05','15:25:00',1.57),('16100','2013-12-05','15:30:00',1.58),('16100','2013-12-05','15:35:00',1.18),('16100','2013-12-05','15:40:00',1.04),('16100','2013-12-05','15:45:00',1.39),('16100','2013-12-05','15:50:00',1.14),('16100','2013-12-04','08:10:00',1.1),('16100','2013-12-04','08:15:00',1.26),('16100','2013-12-04','08:20:00',1.43),('16100','2013-12-04','08:25:00',1.59),('16100','2013-12-04','08:30:00',1.76),('16100','2013-12-04','08:35:00',1.91),('16100','2013-12-04','08:40:00',2.09),('16100','2013-12-04','08:45:00',2.26),('16100','2013-12-04','08:50:00',2.44),('16100','2013-12-04','08:55:00',2.6),('16100','2013-12-04','09:00:00',2.77),('16100','2013-12-04','09:05:00',2.95),('16100','2013-12-04','09:10:00',3.08),('16100','2013-12-04','09:15:00',3.2),('16100','2013-12-04','09:20:00',3.35),('16100','2013-12-04','09:25:00',3.47),('16100','2013-12-04','09:30:00',3.61),('16100','2013-12-04','09:35:00',3.77),('16100','2013-12-04','09:40:00',3.89),('16100','2013-12-04','09:45:00',3.99),('16100','2013-12-04','09:50:00',4.11),('16100','2013-12-04','09:55:00',4.18),('16100','2013-12-04','10:00:00',4.29),('16100','2013-12-04','10:05:00',4.39),('16100','2013-12-04','10:10:00',4.51),('16100','2013-12-04','10:15:00',4.61),('16100','2013-12-04','10:20:00',4.68),('16100','2013-12-04','10:25:00',4.75),('16100','2013-12-04','10:30:00',4.87),('16100','2013-12-04','10:35:00',4.94),('16100','2013-12-04','10:40:00',4.97),('16100','2013-12-04','10:45:00',4.98),('16100','2013-12-04','10:50:00',5.02),('16100','2013-12-04','10:55:00',5.05),('16100','2013-12-04','11:00:00',5.1),('16100','2013-12-04','11:05:00',5.25),('16100','2013-12-04','11:10:00',5.28),('16100','2013-12-04','11:15:00',5.28),('16100','2013-12-04','11:20:00',5.33),('16100','2013-12-04','11:25:00',5.43),('16100','2013-12-04','11:30:00',5.42),('16100','2013-12-04','11:35:00',5.33),('16100','2013-12-04','11:40:00',5.36),('16100','2013-12-04','11:45:00',5.35),('16100','2013-12-04','11:50:00',5.37),('16100','2013-12-04','11:55:00',5.38),('16100','2013-12-04','12:00:00',5.35),('16100','2013-12-04','12:05:00',5.43),('16100','2013-12-04','12:10:00',5.29),('16100','2013-12-04','12:15:00',5.39),('16100','2013-12-04','12:20:00',5.25),('16100','2013-12-04','12:25:00',5.39),('16100','2013-12-04','12:30:00',5.3),('16100','2013-12-04','12:35:00',5.37),('16100','2013-12-04','12:40:00',5.31),('16100','2013-12-04','12:45:00',5.41),('16100','2013-12-04','12:50:00',5.34),('16100','2013-12-04','12:55:00',5.23),('16100','2013-12-04','13:00:00',5.32),('16100','2013-12-04','13:05:00',5.28),('16100','2013-12-04','13:10:00',5.14),('16100','2013-12-04','13:15:00',4.86),('16100','2013-12-04','13:20:00',5.02),('16100','2013-12-04','13:25:00',4.88),('16100','2013-12-04','13:30:00',4.9),('16100','2013-12-04','13:35:00',4.59),('16100','2013-12-04','13:40:00',4.55),('16100','2013-12-04','13:45:00',4.36),('16100','2013-12-04','13:50:00',4),('16100','2013-12-04','13:55:00',4.4),('16100','2013-12-04','14:00:00',4.21),('16100','2013-12-04','14:05:00',4.25),('16100','2013-12-04','14:10:00',4.14),('16100','2013-12-04','14:15:00',3.91),('16100','2013-12-04','14:20:00',3.59),('16100','2013-12-04','14:25:00',3.49),('16100','2013-12-04','14:30:00',3.48),('16100','2013-12-04','14:35:00',3.41),('16100','2013-12-04','14:40:00',3.23),('16100','2013-12-04','14:45:00',3.06),('16100','2013-12-04','14:50:00',2.92),('16100','2013-12-04','14:55:00',2.76),('16100','2013-12-04','15:00:00',2.58),('16100','2013-12-04','15:05:00',2.44),('16100','2013-12-04','15:10:00',2.35),('16100','2013-12-04','15:15:00',2.07),('16100','2013-12-04','15:20:00',1.85),('16100','2013-12-04','15:25:00',1.7),('16100','2013-12-04','15:30:00',1.55),('16100','2013-12-04','15:35:00',1.41),('16100','2013-12-04','15:40:00',1.18),('16100','2013-12-03','08:00:00',1.05),('16100','2013-12-03','08:05:00',1.23),('16100','2013-12-03','08:10:00',1.41),('16100','2013-12-03','08:15:00',1.59),('16100','2013-12-03','08:20:00',1.76),('16100','2013-12-03','08:25:00',1.94),('16100','2013-12-03','08:30:00',2.1),('16100','2013-12-03','08:35:00',2.26),('16100','2013-12-03','08:40:00',2.47),('16100','2013-12-03','08:45:00',2.64),('16100','2013-12-03','08:50:00',2.83),('16100','2013-12-03','08:55:00',2.98),('16100','2013-12-03','09:00:00',3.12),('16100','2013-12-03','09:05:00',3.28),('16100','2013-12-03','09:10:00',3.42),('16100','2013-12-03','09:15:00',3.55),('16100','2013-12-03','09:20:00',3.68),('16100','2013-12-03','09:25:00',3.8),('16100','2013-12-03','09:30:00',3.94),('16100','2013-12-03','09:35:00',4.1),('16100','2013-12-03','09:40:00',4.22),('16100','2013-12-03','09:45:00',4.32),('16100','2013-12-03','09:50:00',4.42),('16100','2013-12-03','09:55:00',4.52),('16100','2013-12-03','10:00:00',4.66),('16100','2013-12-03','10:05:00',4.77),('16100','2013-12-03','10:10:00',4.87),('16100','2013-12-03','10:15:00',4.97),('16100','2013-12-03','10:20:00',5.05),('16100','2013-12-03','10:25:00',5.16),('16100','2013-12-03','10:30:00',5.25),('16100','2013-12-03','10:35:00',5.29),('16100','2013-12-03','10:40:00',5.32),('16100','2013-12-03','10:45:00',5.38),('16100','2013-12-03','10:50:00',5.44),('16100','2013-12-03','10:55:00',5.51),('16100','2013-12-03','11:00:00',5.58),('16100','2013-12-03','11:05:00',5.63),('16100','2013-12-03','11:10:00',5.64),('16100','2013-12-03','11:15:00',5.67),('16100','2013-12-03','11:20:00',5.71),('16100','2013-12-03','11:25:00',5.73),('16100','2013-12-03','11:30:00',5.75),('16100','2013-12-03','11:35:00',5.77),('16100','2013-12-03','11:40:00',5.8),('16100','2013-12-03','11:45:00',5.83),('16100','2013-12-03','11:50:00',5.84),('16100','2013-12-03','11:55:00',5.84),('16100','2013-12-03','12:00:00',5.85),('16100','2013-12-03','12:05:00',5.84),('16100','2013-12-03','12:10:00',5.81),('16100','2013-12-03','12:15:00',5.83),('16100','2013-12-03','12:20:00',5.75),('16100','2013-12-03','12:25:00',5.75),('16100','2013-12-03','12:30:00',5.7),('16100','2013-12-03','12:35:00',5.62),('16100','2013-12-03','12:40:00',5.6),('16100','2013-12-03','12:45:00',5.55),('16100','2013-12-03','12:50:00',5.52),('16100','2013-12-03','12:55:00',5.47),('16100','2013-12-03','13:00:00',5.46),('16100','2013-12-03','13:05:00',5.39),('16100','2013-12-03','13:10:00',5.36),('16100','2013-12-03','13:15:00',5.31),('16100','2013-12-03','13:20:00',5.22),('16100','2013-12-03','13:25:00',5.13),('16100','2013-12-03','13:30:00',5.08),('16100','2013-12-03','13:35:00',4.97),('16100','2013-12-03','13:40:00',4.87),('16100','2013-12-03','13:45:00',4.72),('16100','2013-12-03','13:50:00',4.53),('16100','2013-12-03','13:55:00',4.58),('16100','2013-12-03','14:00:00',4.53),('16100','2013-12-03','14:05:00',4.42),('16100','2013-12-03','14:10:00',4.33),('16100','2013-12-03','14:15:00',4.21),('16100','2013-12-03','14:20:00',4.04),('16100','2013-12-03','14:25:00',3.96),('16100','2013-12-03','14:30:00',3.82),('16100','2013-12-03','14:35:00',3.73),('16100','2013-12-03','14:40:00',3.63),('16100','2013-12-03','14:45:00',3.49),('16100','2013-12-03','14:50:00',3.37),('16100','2013-12-03','14:55:00',3.24),('16100','2013-12-03','15:00:00',3.08),('16100','2013-12-03','15:05:00',2.91),('16100','2013-12-03','15:10:00',2.75),('16100','2013-12-03','15:15:00',2.59),('16100','2013-12-03','15:20:00',2.43),('16100','2013-12-03','15:25:00',2.25),('16100','2013-12-03','15:30:00',2.08),('16100','2013-12-03','15:35:00',1.9),('16100','2013-12-03','15:40:00',1.72),('16100','2013-12-03','15:45:00',1.54),('16100','2013-12-03','15:50:00',1.36),('16100','2013-12-03','15:55:00',1.15),('16100','2013-12-02','08:50:00',1.07),('16100','2013-12-02','08:55:00',2.03),('16100','2013-12-02','09:00:00',1.69),('16100','2013-12-02','09:10:00',1.1),('16100','2013-12-02','09:15:00',1.07),('16100','2013-12-02','09:20:00',1.3),('16100','2013-12-02','09:25:00',1.89),('16100','2013-12-02','09:30:00',2.51),('16100','2013-12-02','09:35:00',2.92),('16100','2013-12-02','09:40:00',3.36),('16100','2013-12-02','09:45:00',4.42),('16100','2013-12-02','09:50:00',4.28),('16100','2013-12-02','09:55:00',4.03),('16100','2013-12-02','10:00:00',4.42),('16100','2013-12-02','10:05:00',4.73),('16100','2013-12-02','10:10:00',4.83),('16100','2013-12-02','10:15:00',4.94),('16100','2013-12-02','10:20:00',5.02),('16100','2013-12-02','10:25:00',5.1),('16100','2013-12-02','10:30:00',5.16),('16100','2013-12-02','10:35:00',5.21),('16100','2013-12-02','10:40:00',5.26),('16100','2013-12-02','10:45:00',5.32),('16100','2013-12-02','10:50:00',5.4),('16100','2013-12-02','10:55:00',5.46),('16100','2013-12-02','11:00:00',5.58),('16100','2013-12-02','11:05:00',5.65),('16100','2013-12-02','11:10:00',5.71),('16100','2013-12-02','11:15:00',5.75),('16100','2013-12-02','11:20:00',5.8),('16100','2013-12-02','11:25:00',5.85),('16100','2013-12-02','11:30:00',5.86),('16100','2013-12-02','11:35:00',5.88),('16100','2013-12-02','11:40:00',5.94),('16100','2013-12-02','11:45:00',5.95),('16100','2013-12-02','11:50:00',5.96),('16100','2013-12-02','11:55:00',5.98),('16100','2013-12-02','12:00:00',5.97),('16100','2013-12-02','12:05:00',5.98),('16100','2013-12-02','12:10:00',6.04),('16100','2013-12-02','12:15:00',6.12),('16100','2013-12-02','12:20:00',6.11),('16100','2013-12-02','12:25:00',6.16),('16100','2013-12-02','12:30:00',6.18),('16100','2013-12-02','12:35:00',6.22),('16100','2013-12-02','12:40:00',6.31),('16100','2013-12-02','12:45:00',6.4),('16100','2013-12-02','12:50:00',6.51),('16100','2013-12-02','12:55:00',6.67),('16100','2013-12-02','13:00:00',6.79),('16100','2013-12-02','13:05:00',6.69),('16100','2013-12-02','13:10:00',6.73),('16100','2013-12-02','13:15:00',6.57),('16100','2013-12-02','13:20:00',5.85),('16100','2013-12-02','13:25:00',4.26),('16100','2013-12-02','13:30:00',3.68),('16100','2013-12-02','13:35:00',3.87),('16100','2013-12-02','13:40:00',3.99),('16100','2013-12-02','13:45:00',3.86),('16100','2013-12-02','13:50:00',2.66),('16100','2013-12-02','13:55:00',1.89),('16100','2013-12-02','14:00:00',1.95),('16100','2013-12-02','14:05:00',2.49),('16100','2013-12-02','14:10:00',3.38),('16100','2013-12-02','14:15:00',3.93),('16100','2013-12-02','14:20:00',3.67),('16100','2013-12-02','14:25:00',3.89),('16100','2013-12-02','14:30:00',3.88),('16100','2013-12-02','14:35:00',3.74),('16100','2013-12-02','14:40:00',3.59),('16100','2013-12-02','14:45:00',3.43),('16100','2013-12-02','14:50:00',3.27),('16100','2013-12-02','14:55:00',3.14),('16100','2013-12-02','15:00:00',2.99),('16100','2013-12-02','15:05:00',2.83),('16100','2013-12-02','15:10:00',2.65),('16100','2013-12-02','15:15:00',2.46),('16100','2013-12-02','15:20:00',2.29),('16100','2013-12-02','15:25:00',2.09),('16100','2013-12-02','15:30:00',1.91),('16100','2013-12-02','15:35:00',1.74),('16100','2013-12-02','15:40:00',1.54),('16100','2013-12-02','15:45:00',1.38),('16100','2013-12-02','15:50:00',1.19),('16100','2013-12-02','15:55:00',1.02),('16100','2013-11-30','11:25:00',1.08),('16100','2013-11-30','11:30:00',1.38),('16100','2013-11-30','11:35:00',2.26),('16100','2013-11-30','11:40:00',3.19),('16100','2013-11-30','11:45:00',2.48),('16100','2013-11-30','11:50:00',2.06),('16100','2013-11-30','11:55:00',3.06),('16100','2013-11-30','12:00:00',3.81),('16100','2013-11-30','12:05:00',2.9),('16100','2013-11-30','12:10:00',4.37),('16100','2013-11-30','12:15:00',3.5),('16100','2013-11-30','12:20:00',2.12),('16100','2013-11-30','12:25:00',1.29),('16100','2013-11-30','12:45:00',2.85),('16100','2013-11-30','12:50:00',4.25),('16100','2013-11-30','12:55:00',1.79),('16100','2013-11-30','13:00:00',1.94),('16100','2013-11-30','13:05:00',1.54),('16100','2013-11-30','13:20:00',1.07),('16100','2013-11-30','14:05:00',1.09),('16100','2013-11-29','08:55:00',1.02),('16100','2013-11-29','09:00:00',1.02),('16100','2013-11-29','09:05:00',1.18),('16100','2013-11-29','09:10:00',2.87),('16100','2013-11-29','09:15:00',3.06),('16100','2013-11-29','09:20:00',3.24),('16100','2013-11-29','09:25:00',3.17),('16100','2013-11-29','09:30:00',3.48),('16100','2013-11-29','09:35:00',3.15),('16100','2013-11-29','09:40:00',3.39),('16100','2013-11-29','09:45:00',2.14),('16100','2013-11-29','09:50:00',1.89),('16100','2013-11-29','09:55:00',1.63),('16100','2013-11-29','10:00:00',1.57),('16100','2013-11-29','10:05:00',1.68),('16100','2013-11-29','10:10:00',1.74),('16100','2013-11-29','10:15:00',1.58),('16100','2013-11-29','10:20:00',1.78),('16100','2013-11-29','10:25:00',1.85),('16100','2013-11-29','10:30:00',1.89),('16100','2013-11-29','10:35:00',1.97),('16100','2013-11-29','10:40:00',2.03),('16100','2013-11-29','10:45:00',2.47),('16100','2013-11-29','10:50:00',2.27),('16100','2013-11-29','10:55:00',1.93),('16100','2013-11-29','11:00:00',1.66),('16100','2013-11-29','11:05:00',1.82),('16100','2013-11-29','11:10:00',2.18),('16100','2013-11-29','11:15:00',2.19),('16100','2013-11-29','11:20:00',2.31),('16100','2013-11-29','11:25:00',2.22),('16100','2013-11-29','11:30:00',2.17),('16100','2013-11-29','11:35:00',1.89),('16100','2013-11-29','11:40:00',1.5),('16100','2013-11-29','11:45:00',1.38),('16100','2013-11-29','11:50:00',1.53),('16100','2013-11-29','11:55:00',1.41),('16100','2013-11-29','12:00:00',1.21),('16100','2013-11-29','12:05:00',1),('16100','2013-11-28','08:00:00',1.1),('16100','2013-11-28','08:05:00',1.25),('16100','2013-11-28','08:10:00',1.43),('16100','2013-11-28','08:15:00',1.61),('16100','2013-11-28','08:20:00',1.77),('16100','2013-11-28','08:25:00',1.96),('16100','2013-11-28','08:30:00',2.11),('16100','2013-11-28','08:35:00',2.26),('16100','2013-11-28','08:40:00',2.43),('16100','2013-11-28','08:45:00',2.59),('16100','2013-11-28','08:50:00',2.74),('16100','2013-11-28','08:55:00',2.87),('16100','2013-11-28','09:00:00',3.04),('16100','2013-11-28','09:05:00',3.18),('16100','2013-11-28','09:10:00',3.31),('16100','2013-11-28','09:15:00',3.45),('16100','2013-11-28','09:20:00',3.6),('16100','2013-11-28','09:25:00',3.71),('16100','2013-11-28','09:30:00',3.89),('16100','2013-11-28','09:35:00',4.07),('16100','2013-11-28','09:40:00',4.18),('16100','2013-11-28','09:45:00',4.29),('16100','2013-11-28','09:50:00',4.42),('16100','2013-11-28','09:55:00',4.54),('16100','2013-11-28','10:00:00',4.69),('16100','2013-11-28','10:05:00',4.81),('16100','2013-11-28','10:10:00',4.95),('16100','2013-11-28','10:15:00',5.05),('16100','2013-11-28','10:20:00',5.14),('16100','2013-11-28','10:25:00',5.24),('16100','2013-11-28','10:30:00',5.32),('16100','2013-11-28','10:35:00',5.39),('16100','2013-11-28','10:40:00',5.45),('16100','2013-11-28','10:45:00',5.5),('16100','2013-11-28','10:50:00',5.55),('16100','2013-11-28','10:55:00',5.6),('16100','2013-11-28','11:00:00',5.65),('16100','2013-11-28','11:05:00',5.68),('16100','2013-11-28','11:10:00',5.74),('16100','2013-11-28','11:15:00',5.76),('16100','2013-11-28','11:20:00',5.78),('16100','2013-11-28','11:25:00',5.8),('16100','2013-11-28','11:30:00',5.82),('16100','2013-11-28','11:35:00',5.88),('16100','2013-11-28','11:40:00',5.88),('16100','2013-11-28','11:45:00',5.9),('16100','2013-11-28','11:50:00',5.91),('16100','2013-11-28','11:55:00',5.91),('16100','2013-11-28','12:00:00',5.92),('16100','2013-11-28','12:05:00',5.91),('16100','2013-11-28','12:10:00',5.89),('16100','2013-11-28','12:15:00',5.87),('16100','2013-11-28','12:20:00',5.86),('16100','2013-11-28','12:25:00',5.84),('16100','2013-11-28','12:30:00',5.78),('16100','2013-11-28','12:35:00',5.73),('16100','2013-11-28','12:40:00',5.68),('16100','2013-11-28','12:45:00',5.65),('16100','2013-11-28','12:50:00',5.65),('16100','2013-11-28','12:55:00',5.57),('16100','2013-11-28','13:00:00',5.53),('16100','2013-11-28','13:05:00',5.5),('16100','2013-11-28','13:10:00',5.47),('16100','2013-11-28','13:15:00',5.44),('16100','2013-11-28','13:20:00',5.41),('16100','2013-11-28','13:25:00',5.34),('16100','2013-11-28','13:30:00',5.21),('16100','2013-11-28','13:35:00',5.12),('16100','2013-11-28','13:40:00',4.99),('16100','2013-11-28','13:45:00',4.9),('16100','2013-11-28','13:50:00',4.8),('16100','2013-11-28','13:55:00',4.69),('16100','2013-11-28','14:00:00',4.6),('16100','2013-11-28','14:05:00',4.49),('16100','2013-11-28','14:10:00',4.39),('16100','2013-11-28','14:15:00',4.24),('16100','2013-11-28','14:20:00',4.11),('16100','2013-11-28','14:25:00',3.98),('16100','2013-11-28','14:30:00',3.84),('16100','2013-11-28','14:35:00',3.71),('16100','2013-11-28','14:40:00',3.59),('16100','2013-11-28','14:45:00',3.45),('16100','2013-11-28','14:50:00',3.3),('16100','2013-11-28','14:55:00',3.18),('16100','2013-11-28','15:00:00',3),('16100','2013-11-28','15:05:00',2.85),('16100','2013-11-28','15:10:00',2.68),('16100','2013-11-28','15:15:00',2.51),('16100','2013-11-28','15:20:00',2.33),('16100','2013-11-28','15:25:00',2.16),('16100','2013-11-28','15:30:00',1.99),('16100','2013-11-28','15:35:00',1.81),('16100','2013-11-28','15:40:00',1.61),('16100','2013-11-28','15:45:00',1.43),('16100','2013-11-28','15:50:00',1.23),('16100','2013-11-28','15:55:00',1.05),('16100','2013-11-27','12:50:00',1.04),('16100','2013-11-27','13:30:00',1.08),('16100','2013-11-27','13:40:00',1.22),('16100','2013-11-27','13:45:00',1.52),('16100','2013-11-27','13:50:00',1.09),('16100','2014-04-19','08:00:00',1.08),('16100','2014-04-19','08:05:00',1.33),('16100','2014-04-19','08:10:00',1.31),('16100','2014-04-19','08:15:00',1.43),('16100','2014-04-19','08:20:00',2.43),('16100','2014-04-19','08:25:00',3.02),('16100','2014-04-19','08:30:00',3.3),('16100','2014-04-19','08:35:00',2.23),('16100','2014-04-19','08:40:00',1.31),('16100','2014-04-19','08:45:00',1.51),('16100','2014-04-19','08:50:00',2.21),('16100','2014-04-19','08:55:00',3.32),('16100','2014-04-19','09:00:00',3.69),('16100','2014-04-19','09:05:00',2.94),('16100','2014-04-19','09:10:00',1.75),('16100','2014-04-19','09:15:00',4.1),('16100','2014-04-19','09:20:00',4.17),('16100','2014-04-19','09:25:00',4.54),('16100','2014-04-19','09:30:00',4.99),('16100','2014-04-19','09:35:00',5.3),('16100','2014-04-19','09:40:00',5.93),('16100','2014-04-19','09:45:00',4.8),('16100','2014-04-19','09:50:00',3.01),('16100','2014-04-19','09:55:00',3.03),('16100','2014-04-19','10:00:00',3.86),('16100','2014-04-19','10:05:00',4.59),('16100','2014-04-19','10:10:00',4.46),('16100','2014-04-19','10:15:00',4.33),('16100','2014-04-19','10:20:00',4.51),('16100','2014-04-19','10:25:00',4.39),('16100','2014-04-19','10:30:00',3.76),('16100','2014-04-19','10:35:00',3.74),('16100','2014-04-19','10:40:00',3.76),('16100','2014-04-19','10:45:00',4.36),('16100','2014-04-19','10:50:00',4.85),('16100','2014-04-19','10:55:00',5.95),('16100','2014-04-19','11:00:00',4.37),('16100','2014-04-19','11:05:00',6.03),('16100','2014-04-19','11:10:00',5.5),('16100','2014-04-19','11:15:00',6.14),('16100','2014-04-19','11:20:00',7.74),('16100','2014-04-19','11:25:00',7.46),('16100','2014-04-19','11:30:00',7.36),('16100','2014-04-19','11:35:00',7.51),('16100','2014-04-19','11:40:00',7.38),('16100','2014-04-19','11:45:00',6.42),('16100','2014-04-19','11:50:00',7.44),('16100','2014-04-19','11:55:00',7.35),('16100','2014-04-19','12:00:00',7.38),('16100','2014-04-19','12:05:00',7.46),('16100','2014-04-19','12:10:00',7.41),('16100','2014-04-19','12:15:00',7.41),('16100','2014-04-19','12:20:00',7.53),('16100','2014-04-19','12:25:00',7.43),('16100','2014-04-19','12:30:00',6.4),('16100','2014-04-19','12:35:00',7.81),('16100','2014-04-19','12:40:00',8.15),('16100','2014-04-19','12:45:00',7.72),('16100','2014-04-19','12:50:00',6.81),('16100','2014-04-19','12:55:00',7.55),('16100','2014-04-19','13:00:00',8.1),('16100','2014-04-19','13:05:00',8.11),('16100','2014-04-19','13:10:00',8.09),('16100','2014-04-19','13:15:00',7.86),('16100','2014-04-19','13:20:00',7.56),('16100','2014-04-19','13:25:00',7.53),('16100','2014-04-19','13:30:00',7.61),('16100','2014-04-19','13:35:00',7.65),('16100','2014-04-19','13:40:00',7.62),('16100','2014-04-19','13:45:00',7.68),('16100','2014-04-19','13:50:00',7.65),('16100','2014-04-19','13:55:00',7.54),('16100','2014-04-19','14:00:00',7.53),('16100','2014-04-19','14:05:00',7.55),('16100','2014-04-19','14:10:00',7.56),('16100','2014-04-19','14:15:00',6.95),('16100','2014-04-19','14:20:00',6.37),('16100','2014-04-19','14:25:00',4.68),('16100','2014-04-19','14:30:00',4.62),('16100','2014-04-19','14:35:00',3.97),('16100','2014-04-19','14:40:00',3.76),('16100','2014-04-19','14:45:00',4.01),('16100','2014-04-19','14:50:00',4.34),('16100','2014-04-19','14:55:00',4.58),('16100','2014-04-19','15:00:00',7.02),('16100','2014-04-19','15:05:00',7.47),('16100','2014-04-19','15:10:00',6.91),('16100','2014-04-19','15:15:00',6.59),('16100','2014-04-19','15:20:00',6.41),('16100','2014-04-19','15:25:00',6.4),('16100','2014-04-19','15:30:00',6.37),('16100','2014-04-19','15:35:00',6.32),('16100','2014-04-19','15:40:00',6.32),('16100','2014-04-19','15:45:00',5.47),('16100','2014-04-19','15:50:00',5.22),('16100','2014-04-19','15:55:00',5.9),('16100','2014-04-19','16:00:00',5.76),('16100','2014-04-19','16:05:00',5.68),('16100','2014-04-19','16:10:00',5.56),('16100','2014-04-19','16:15:00',5.41),('16100','2014-04-19','16:20:00',5.39),('16100','2014-04-19','16:25:00',5.37),('16100','2014-04-19','16:30:00',5.02),('16100','2014-04-19','16:35:00',5.27),('16100','2014-04-19','16:40:00',5.05),('16100','2014-04-19','16:45:00',3.46),('16100','2014-04-19','16:50:00',4.43),('16100','2014-04-19','16:55:00',4.48),('16100','2014-04-19','17:00:00',4.19),('16100','2014-04-19','17:05:00',3.99),('16100','2014-04-19','17:10:00',3.79),('16100','2014-04-19','17:15:00',3.62),('16100','2014-04-19','17:20:00',3.44),('16100','2014-04-19','17:25:00',3.27),('16100','2014-04-19','17:30:00',3.13),('16100','2014-04-19','17:35:00',2.99),('16100','2014-04-19','17:40:00',2.8),('16100','2014-04-19','17:45:00',2.61),('16100','2014-04-19','17:50:00',2.43),('16100','2014-04-19','17:55:00',2.28),('16100','2014-04-19','18:00:00',2.11),('16100','2014-04-19','18:05:00',1.96),('16100','2014-04-19','18:10:00',1.75),('16100','2014-04-19','18:15:00',1.47),('16100','2014-04-19','18:20:00',1.16),('16100','2014-04-19','18:25:00',1.03),('16100','2014-04-19','18:30:00',1.21),('16100','2014-04-19','18:35:00',1.15),('16100','2013-11-26','08:50:00',2.02),('16100','2013-11-26','08:55:00',1.74),('16100','2013-11-26','09:00:00',1.57),('16100','2013-11-26','09:05:00',1.43),('16100','2013-11-26','09:10:00',1.17),('16100','2013-11-26','09:15:00',1.1),('16100','2013-11-26','09:20:00',1.17),('16100','2013-11-26','09:25:00',1.69),('16100','2013-11-26','09:30:00',1.87),('16100','2013-11-26','09:35:00',1.87),('16100','2013-11-26','09:40:00',1.72),('16100','2013-11-26','09:45:00',1.47),('16100','2013-11-26','09:50:00',1.42),('16100','2013-11-26','09:55:00',1.47),('16100','2013-11-26','10:00:00',1.74),('16100','2013-11-26','10:05:00',2.05),('16100','2013-11-26','10:10:00',1.91),('16100','2013-11-26','10:15:00',2.15),('16100','2013-11-26','10:20:00',2.19),('16100','2013-11-26','10:25:00',2.1),('16100','2013-11-26','10:30:00',2.03),('16100','2013-11-26','10:35:00',2.11),('16100','2013-11-26','10:40:00',2.06),('16100','2013-11-26','10:45:00',2.09),('16100','2013-11-26','10:50:00',2.45),('16100','2013-11-26','10:55:00',2.14),('16100','2013-11-26','11:00:00',2.39),('16100','2013-11-26','11:05:00',2.53),('16100','2013-11-26','11:10:00',2.91),('16100','2013-11-26','11:15:00',2.57),('16100','2013-11-26','11:20:00',2.48),('16100','2013-11-26','11:25:00',2.97),('16100','2013-11-26','11:30:00',3.01),('16100','2013-11-26','11:35:00',2.88),('16100','2013-11-26','11:40:00',3.06),('16100','2013-11-26','11:45:00',3.62),('16100','2013-11-26','11:50:00',5.5),('16100','2013-11-26','11:55:00',6.9),('16100','2013-11-26','12:00:00',5.06),('16100','2013-11-26','12:05:00',3.36),('16100','2013-11-26','12:10:00',3.54),('16100','2013-11-26','12:15:00',2.93),('16100','2013-11-26','12:20:00',4.2),('16100','2013-11-26','12:25:00',4.81),('16100','2013-11-26','12:30:00',5.2),('16100','2013-11-26','12:35:00',3.81),('16100','2013-11-26','12:40:00',2.19),('16100','2013-11-26','12:45:00',1.82),('16100','2013-11-26','12:50:00',1.47),('16100','2013-11-26','12:55:00',1.42),('16100','2013-11-26','13:00:00',1.66),('16100','2013-11-26','13:05:00',1.75),('16100','2013-11-26','13:10:00',1.9),('16100','2013-11-26','13:15:00',1.85),('16100','2013-11-26','13:20:00',1.66),('16100','2013-11-26','13:25:00',1.82),('16100','2013-11-26','13:30:00',1.83),('16100','2013-11-26','13:35:00',1.73),('16100','2013-11-26','13:40:00',1.6),('16100','2013-11-26','13:45:00',1.24),('16100','2013-11-25','08:00:00',1.43),('16100','2013-11-25','08:05:00',1.61),('16100','2013-11-25','08:10:00',1.47),('16100','2013-11-25','08:40:00',1.97),('16100','2013-11-25','08:45:00',1.5),('16100','2013-11-25','08:55:00',1.15),('16100','2013-11-25','09:00:00',1.6),('16100','2013-11-25','09:05:00',2.47),('16100','2013-11-25','09:10:00',1.96),('16100','2013-11-25','09:15:00',1.78),('16100','2013-11-25','09:20:00',1.81),('16100','2013-11-25','09:25:00',2.05),('16100','2013-11-25','09:30:00',2.37),('16100','2013-11-25','09:35:00',3.41),('16100','2013-11-25','09:40:00',2.35),('16100','2013-11-25','09:45:00',2.28),('16100','2013-11-25','09:50:00',2.8),('16100','2013-11-25','09:55:00',4.25),('16100','2013-11-25','10:00:00',2.78),('16100','2013-11-25','10:05:00',2.38),('16100','2013-11-25','10:10:00',6.17),('16100','2013-11-25','10:15:00',3.34),('16100','2013-11-25','10:20:00',4.16),('16100','2013-11-25','10:25:00',3.68),('16100','2013-11-25','10:30:00',6.08),('16100','2013-11-25','10:35:00',5.97),('16100','2013-11-25','10:40:00',6.01),('16100','2013-11-25','10:45:00',6.08),('16100','2013-11-25','10:50:00',6.05),('16100','2013-11-25','10:55:00',6.22),('16100','2013-11-25','11:00:00',6.21),('16100','2013-11-25','11:05:00',6.77),('16100','2013-11-25','11:10:00',6.02),('16100','2013-11-25','11:15:00',6.48),('16100','2013-11-25','11:20:00',6.89),('16100','2013-11-25','11:25:00',3.25),('16100','2013-11-25','11:30:00',4.73),('16100','2013-11-25','11:35:00',2.32),('16100','2013-11-25','11:40:00',2.81),('16100','2013-11-25','11:45:00',7.22),('16100','2013-11-25','11:50:00',3.93),('16100','2013-11-25','11:55:00',4.8),('16100','2013-11-25','12:00:00',5.54),('16100','2013-11-25','12:05:00',4.42),('16100','2013-11-25','12:10:00',4.53),('16100','2013-11-25','12:15:00',5.73),('16100','2013-11-25','12:20:00',6.57),('16100','2013-11-25','12:25:00',6.51),('16100','2013-11-25','12:30:00',6.53),('16100','2013-11-25','12:35:00',6.38),('16100','2013-11-25','12:40:00',6.22),('16100','2013-11-25','12:45:00',6.27),('16100','2013-11-25','12:50:00',6.22),('16100','2013-11-25','12:55:00',6.17),('16100','2013-11-25','13:00:00',6.11),('16100','2013-11-25','13:05:00',6.05),('16100','2013-11-25','13:10:00',5.98),('16100','2013-11-25','13:15:00',5.95),('16100','2013-11-25','13:20:00',5.85),('16100','2013-11-25','13:25:00',5.8),('16100','2013-11-25','13:30:00',5.69),('16100','2013-11-25','13:35:00',5.6),('16100','2013-11-25','13:40:00',5.5),('16100','2013-11-25','13:45:00',5.41),('16100','2013-11-25','13:50:00',4.95),('16100','2013-11-25','13:55:00',3.89),('16100','2013-11-25','14:00:00',5.04),('16100','2013-11-25','14:05:00',5.19),('16100','2013-11-25','14:10:00',4.9),('16100','2013-11-25','14:15:00',5.94),('16100','2013-11-25','14:20:00',5.62),('16100','2013-11-25','14:25:00',4.71),('16100','2013-11-25','14:30:00',4.34),('16100','2013-11-25','14:35:00',3.94),('16100','2013-11-25','14:40:00',3.98),('16100','2013-11-25','14:45:00',3.81),('16100','2013-11-25','14:50:00',3.94),('16100','2013-11-25','14:55:00',3.34),('16100','2013-11-25','15:00:00',3.74),('16100','2013-11-25','15:05:00',3.43),('16100','2013-11-25','15:10:00',3.22),('16100','2013-11-25','15:15:00',2.99),('16100','2013-11-25','15:20:00',2.78),('16100','2013-11-25','15:25:00',2.58),('16100','2013-11-25','15:30:00',2.38),('16100','2013-11-25','15:35:00',2.19),('16100','2013-11-25','15:40:00',1.99),('16100','2013-11-25','15:45:00',1.82),('16100','2013-11-25','15:50:00',1.53),('16100','2013-11-24','07:50:00',1.01),('16100','2013-11-24','07:55:00',1.18),('16100','2013-11-24','08:00:00',1.35),('16100','2013-11-24','08:05:00',1.53),('16100','2013-11-24','08:10:00',1.75),('16100','2013-11-24','08:15:00',1.98),('16100','2013-11-24','08:20:00',2.4),('16100','2013-11-24','08:25:00',2.6),('16100','2013-11-24','08:30:00',2.4),('16100','2013-11-24','08:35:00',2.2),('16100','2013-11-24','08:40:00',2.63),('16100','2013-11-24','08:45:00',3.67),('16100','2013-11-24','08:50:00',3.92),('16100','2013-11-24','08:55:00',3.62),('16100','2013-11-24','09:00:00',1.42),('16100','2013-11-24','09:05:00',1.81),('16100','2013-11-24','09:10:00',2.94),('16100','2013-11-24','09:15:00',3.62),('16100','2013-11-24','09:20:00',1.43),('16100','2013-11-24','09:25:00',1.32),('16100','2013-11-24','09:30:00',2.38),('16100','2013-11-24','09:35:00',2.06),('16100','2013-11-24','09:40:00',1.77),('16100','2013-11-24','09:45:00',1.64),('16100','2013-11-24','09:50:00',4.15),('16100','2013-11-24','09:55:00',2.48),('16100','2013-11-24','10:00:00',2.9),('16100','2013-11-24','10:05:00',2.03),('16100','2013-11-24','10:10:00',5.75),('16100','2013-11-24','10:15:00',5.83),('16100','2013-11-24','10:20:00',5.58),('16100','2013-11-24','10:25:00',5.4),('16100','2013-11-24','10:30:00',3.35),('16100','2013-11-24','10:35:00',4.57),('16100','2013-11-24','10:40:00',5.12),('16100','2013-11-24','10:45:00',6.08),('16100','2013-11-24','10:50:00',5.51),('16100','2013-11-24','10:55:00',5.85),('16100','2013-11-24','11:00:00',6.09),('16100','2013-11-24','11:05:00',6.03),('16100','2013-11-24','11:10:00',2.63),('16100','2013-11-24','11:15:00',2.34),('16100','2013-11-24','11:20:00',2.31),('16100','2013-11-24','11:25:00',2.21),('16100','2013-11-24','11:30:00',1.84),('16100','2013-11-24','11:35:00',1.9),('16100','2013-11-24','11:40:00',1.7),('16100','2013-11-24','11:45:00',6.16),('16100','2013-11-24','11:50:00',5.66),('16100','2013-11-24','11:55:00',4.13),('16100','2013-11-24','12:00:00',3.71),('16100','2013-11-24','12:05:00',3.2),('16100','2013-11-24','12:10:00',3.06),('16100','2013-11-24','12:15:00',2.6),('16100','2013-11-24','12:20:00',3.22),('16100','2013-11-24','12:25:00',3.68),('16100','2013-11-24','12:30:00',3.53),('16100','2013-11-24','12:35:00',3.06),('16100','2013-11-24','12:40:00',2.55),('16100','2013-11-24','12:45:00',4.7),('16100','2013-11-24','12:50:00',6.03),('16100','2013-11-24','12:55:00',6.52),('16100','2013-11-24','13:00:00',5.05),('16100','2013-11-24','13:05:00',2.87),('16100','2013-11-24','13:10:00',2.97),('16100','2013-11-24','13:15:00',3.96),('16100','2013-11-24','13:20:00',6.64),('16100','2013-11-24','13:25:00',4.34),('16100','2013-11-24','13:30:00',3.8),('16100','2013-11-24','13:35:00',1.71),('16100','2013-11-24','13:40:00',1.67),('16100','2013-11-24','13:45:00',2.04),('16100','2013-11-24','13:50:00',2.58),('16100','2013-11-24','13:55:00',1.49),('16100','2013-11-23','09:55:00',1.53),('16100','2013-11-23','10:00:00',2.46),('16100','2013-11-23','10:05:00',2.46),('16100','2013-11-23','10:10:00',2.11),('16100','2013-11-23','10:15:00',2.33),('16100','2013-11-23','10:20:00',2.47),('16100','2013-11-23','10:25:00',3.42),('16100','2013-11-23','10:30:00',4.37),('16100','2013-11-23','10:35:00',4.27),('16100','2013-11-23','10:40:00',2.26),('16100','2013-11-23','10:45:00',1.38),('16100','2013-11-23','10:50:00',1.6),('16100','2013-11-23','10:55:00',2.1),('16100','2013-11-23','11:00:00',2.17),('16100','2013-11-23','11:05:00',2.22),('16100','2013-11-23','11:10:00',2.54),('16100','2013-11-23','11:15:00',2.97),('16100','2013-11-23','11:20:00',2.41),('16100','2013-11-23','11:25:00',2.38),('16100','2013-11-23','11:30:00',2.19),('16100','2013-11-23','11:35:00',2.03),('16100','2013-11-23','11:40:00',1.5),('16100','2013-11-23','11:45:00',1.02),('16100','2013-11-23','11:50:00',1.01),('16100','2013-11-23','11:55:00',1.19),('16100','2013-11-23','12:00:00',1.17),('16100','2013-11-23','12:05:00',1.04),('16100','2013-11-23','12:15:00',1.1),('16100','2013-11-23','12:20:00',1.17),('16100','2013-11-23','12:25:00',1.3),('16100','2013-11-23','12:30:00',1.45),('16100','2013-11-23','12:35:00',1.64),('16100','2013-11-23','12:40:00',1.77),('16100','2013-11-23','12:45:00',2.09),('16100','2013-11-23','12:50:00',2.83),('16100','2013-11-23','12:55:00',3.45),('16100','2013-11-23','13:00:00',2.38),('16100','2013-11-23','13:05:00',1.3),('16100','2013-11-23','13:10:00',1.53),('16100','2013-11-23','13:15:00',1.82),('16100','2013-11-23','13:20:00',1.88),('16100','2013-11-23','13:25:00',1.8),('16100','2013-11-23','13:30:00',1.7),('16100','2013-11-23','13:35:00',1.7),('16100','2013-11-23','13:40:00',1.63),('16100','2013-11-23','13:45:00',1.46),('16100','2013-11-23','13:50:00',1.36),('16100','2013-11-23','13:55:00',1.23),('16100','2013-11-23','14:00:00',1.18),('16100','2013-11-23','14:05:00',1.11),('16100','2013-11-23','14:10:00',1.05),('16100','2013-11-22','08:15:00',1.06),('16100','2013-11-22','08:20:00',1.17),('16100','2013-11-22','08:40:00',1.78),('16100','2013-11-22','08:45:00',1.79),('16100','2013-11-22','10:05:00',1),('16100','2013-11-22','10:15:00',1.7),('16100','2013-11-22','10:20:00',2.13),('16100','2013-11-22','10:25:00',2.42),('16100','2013-11-22','10:30:00',4.41),('16100','2013-11-22','10:35:00',3.95),('16100','2013-11-22','13:35:00',1.14),('16100','2013-11-22','14:00:00',1.34),('16100','2013-11-22','14:05:00',1.11),('16100','2013-11-22','16:05:00',1.18),('16100','2013-11-22','16:10:00',1.24),('16100','2013-11-21','12:15:00',1.09),('16100','2013-11-21','12:20:00',1.29),('16100','2013-11-21','12:25:00',1.19),('16100','2013-11-20','08:00:00',1.14),('16100','2013-11-20','08:05:00',1.81),('16100','2013-11-20','08:10:00',1.88),('16100','2013-11-20','08:15:00',1.23),('16100','2013-11-20','09:05:00',1.04),('16100','2013-11-20','09:10:00',1.18),('16100','2013-11-20','09:15:00',1.39),('16100','2013-11-20','09:20:00',1.7),('16100','2013-11-20','09:25:00',1.39),('16100','2013-11-20','09:35:00',1.07),('16100','2013-11-20','09:40:00',2.02),('16100','2013-11-20','09:45:00',2.43),('16100','2013-11-20','09:50:00',3.99),('16100','2013-11-20','09:55:00',4.84),('16100','2013-11-20','10:00:00',4.82),('16100','2013-11-20','10:05:00',4.93),('16100','2013-11-20','10:10:00',4.88),('16100','2013-11-20','10:15:00',5.07),('16100','2013-11-20','10:20:00',5.42),('16100','2013-11-20','10:25:00',5.72),('16100','2013-11-20','10:30:00',5.88),('16100','2013-11-20','10:35:00',5.48),('16100','2013-11-20','10:40:00',4.18),('16100','2013-11-20','10:45:00',3.83),('16100','2013-11-20','10:50:00',5.96),('16100','2013-11-20','10:55:00',4.94),('16100','2013-11-20','11:00:00',4.32),('16100','2013-11-20','11:05:00',2.76),('16100','2013-11-20','11:10:00',4.76),('16100','2013-11-20','11:15:00',5.94),('16100','2013-11-20','11:20:00',6.05),('16100','2013-11-20','11:25:00',6.23),('16100','2013-11-20','11:30:00',6.2),('16100','2013-11-20','11:35:00',6.13),('16100','2013-11-20','11:40:00',6.13),('16100','2013-11-20','11:45:00',6.18),('16100','2013-11-20','11:50:00',6.17),('16100','2013-11-20','11:55:00',6.17),('16100','2013-11-20','12:00:00',6.18),('16100','2013-11-20','12:05:00',6.59),('16100','2013-11-20','12:10:00',6.55),('16100','2013-11-20','12:15:00',6.97),('16100','2013-11-20','12:20:00',6.26),('16100','2013-11-20','12:25:00',7.28),('16100','2013-11-20','12:30:00',4.41),('16100','2013-11-20','12:35:00',6.8),('16100','2013-11-20','12:40:00',5.42),('16100','2013-11-20','12:45:00',2.15),('16100','2013-11-20','12:55:00',1.66),('16100','2013-11-20','13:00:00',3.42),('16100','2013-11-20','13:05:00',3.89),('16100','2013-11-20','13:10:00',5.79),('16100','2013-11-20','13:15:00',5.63),('16100','2013-11-20','13:20:00',5.81),('16100','2013-11-20','13:25:00',6.02),('16100','2013-11-20','13:30:00',5.81),('16100','2013-11-20','13:35:00',2.6),('16100','2013-11-20','13:40:00',3.51),('16100','2013-11-20','13:45:00',4.76),('16100','2013-11-20','13:50:00',1.33),('16100','2013-11-20','13:55:00',5.59),('16100','2013-11-20','14:00:00',4.84),('16100','2013-11-20','14:05:00',3.8),('16100','2013-11-20','14:10:00',5.08),('16100','2013-11-20','14:15:00',4.55),('16100','2013-11-20','14:20:00',2.96),('16100','2013-11-20','14:25:00',4.2),('16100','2013-11-20','14:30:00',4.04),('16100','2013-11-20','14:35:00',3.88),('16100','2013-11-20','14:40:00',3.77),('16100','2013-11-20','14:45:00',3.69),('16100','2013-11-20','14:50:00',2.34),('16100','2013-11-20','14:55:00',3.35),('16100','2013-11-20','15:00:00',3.17),('16100','2013-11-20','15:05:00',2.98),('16100','2013-11-20','15:10:00',2.03),('16100','2013-11-20','15:35:00',2.01),('16100','2013-11-20','15:40:00',1.1),('16100','2013-11-20','15:50:00',1.28),('16100','2013-11-19','08:00:00',1.07),('16100','2013-11-19','08:05:00',1.17),('16100','2013-11-19','08:10:00',1.29),('16100','2013-11-19','08:15:00',1.82),('16100','2013-11-19','08:50:00',1.6),('16100','2013-11-19','08:55:00',3.54),('16100','2013-11-19','09:00:00',3.36),('16100','2013-11-19','09:05:00',3.36),('16100','2013-11-19','09:10:00',3.55),('16100','2013-11-19','09:15:00',3.82),('16100','2013-11-19','09:20:00',4.14),('16100','2013-11-19','09:25:00',3.94),('16100','2013-11-19','09:30:00',1.37),('16100','2013-11-19','09:55:00',1.8),('16100','2013-11-19','10:20:00',1.11),('16100','2013-11-19','10:45:00',1.63),('16100','2013-11-19','10:50:00',1.14),('16100','2013-11-19','11:20:00',1.51),('16100','2013-11-19','11:25:00',3.05),('16100','2013-11-19','11:30:00',2.3),('16100','2013-11-19','11:35:00',2.35),('16100','2013-11-19','11:55:00',1.78),('16100','2013-11-19','12:00:00',2.2),('16100','2013-11-19','12:15:00',3.06),('16100','2013-11-19','12:20:00',3.56),('16100','2013-11-19','12:25:00',2.98),('16100','2013-11-19','12:30:00',1.14),('16100','2013-11-19','12:35:00',1.27),('16100','2013-11-19','12:40:00',2.29),('16100','2013-11-19','12:45:00',1.95),('16100','2013-11-19','12:50:00',1.39),('16100','2013-11-19','12:55:00',2.28),('16100','2013-11-19','13:00:00',2.69),('16100','2013-11-19','13:05:00',3.85),('16100','2013-11-19','13:10:00',2.48),('16100','2013-11-19','13:15:00',3.41),('16100','2013-11-19','13:20:00',1.74),('16100','2013-11-19','13:25:00',3.68),('16100','2013-11-19','13:30:00',1.79),('16100','2013-11-19','13:35:00',1.87),('16100','2013-11-19','13:40:00',1.49),('16100','2013-11-19','13:45:00',1.62),('16100','2013-11-19','13:50:00',3.45),('16100','2013-11-19','13:55:00',2.05),('16100','2013-11-19','14:00:00',1.15),('16100','2013-11-19','14:05:00',1.03),('16100','2013-11-19','14:15:00',1.56),('16100','2013-11-19','14:20:00',2.71),('16100','2013-11-19','14:25:00',1.87),('16100','2013-11-19','14:30:00',1.05),('16100','2013-11-19','14:35:00',2.25),('16100','2013-11-19','14:40:00',2.98),('16100','2013-11-19','14:50:00',1.64),('16100','2013-11-19','14:55:00',3.28),('16100','2013-11-19','15:00:00',2.99),('16100','2013-11-19','15:05:00',1.99),('16100','2013-11-19','15:10:00',1.32),('16100','2013-11-19','15:15:00',2.39),('16100','2013-11-19','15:20:00',1.29),('16100','2013-11-19','15:35:00',1.41),('16100','2013-11-19','15:40:00',1.43),('16100','2013-11-19','15:45:00',1.22),('16100','2013-11-18','08:10:00',1.18),('16100','2013-11-18','08:15:00',1.06),('16100','2013-11-18','09:35:00',3.86),('16100','2013-11-18','09:40:00',4.12),('16100','2013-11-18','09:45:00',4.25),('16100','2013-11-18','09:50:00',3.77),('16100','2013-11-18','09:55:00',3.45),('16100','2013-11-18','10:00:00',3.71),('16100','2013-11-18','10:05:00',5.13),('16100','2013-11-18','10:10:00',4.93),('16100','2013-11-18','10:15:00',3.78),('16100','2013-11-18','10:20:00',2.33),('16100','2013-11-18','10:55:00',1.03),('16100','2013-11-18','11:00:00',1.09),('16100','2013-11-18','11:05:00',1.32),('16100','2013-11-18','11:10:00',1.33),('16100','2013-11-18','11:15:00',2.65),('16100','2013-11-18','11:20:00',3.58),('16100','2013-11-18','11:25:00',2.83),('16100','2013-11-18','11:30:00',1.69),('16100','2013-11-18','11:35:00',5.03),('16100','2013-11-18','11:40:00',4.94),('16100','2013-11-18','11:45:00',5.43),('16100','2013-11-18','11:50:00',5.67),('16100','2013-11-18','11:55:00',5.52),('16100','2013-11-18','12:00:00',5.09),('16100','2013-11-18','12:05:00',5.58),('16100','2013-11-18','12:10:00',5.53),('16100','2013-11-18','12:15:00',5.58),('16100','2013-11-18','12:20:00',5.58),('16100','2013-11-18','12:25:00',4.2),('16100','2013-11-18','12:30:00',3.02),('16100','2013-11-18','12:35:00',2.38),('16100','2013-11-18','12:40:00',5.36),('16100','2013-11-18','12:45:00',3.37),('16100','2013-11-18','12:50:00',5.39),('16100','2013-11-18','12:55:00',5.65),('16100','2013-11-18','13:10:00',1.04),('16100','2013-11-18','13:15:00',1.11),('16100','2013-11-18','13:30:00',1.47),('16100','2013-11-18','13:35:00',1.33),('16100','2013-11-18','14:35:00',1.17),('16100','2013-11-18','14:40:00',1.26),('16100','2013-11-18','14:45:00',1.07),('16100','2013-11-18','15:20:00',1.37),('16100','2013-11-18','15:25:00',2.74),('16100','2013-11-18','15:30:00',3.24),('16100','2013-11-18','15:35:00',2.49),('16100','2013-11-18','15:40:00',1.92),('16100','2013-11-18','15:45:00',1.7),('16100','2013-11-18','15:50:00',1.44),('16100','2013-11-18','15:55:00',1.14),('16100','2013-11-17','07:55:00',1.12),('16100','2013-11-17','08:00:00',1.54),('16100','2013-11-17','08:05:00',1.78),('16100','2013-11-17','08:10:00',1.35),('16100','2013-11-17','08:15:00',1.41),('16100','2013-11-17','08:20:00',1.55),('16100','2013-11-17','08:25:00',1.59),('16100','2013-11-17','08:30:00',1.5),('16100','2013-11-17','08:35:00',1.73),('16100','2013-11-17','08:40:00',1.92),('16100','2013-11-17','08:45:00',1.67),('16100','2013-11-17','08:50:00',1.8),('16100','2013-11-17','08:55:00',1.88),('16100','2013-11-17','09:00:00',1.69),('16100','2013-11-17','09:05:00',1.48),('16100','2013-11-17','09:10:00',1.4),('16100','2013-11-17','09:15:00',1.96),('16100','2013-11-17','09:20:00',2.69),('16100','2013-11-17','09:25:00',2.82),('16100','2013-11-17','09:30:00',3.46),('16100','2013-11-17','09:35:00',4.03),('16100','2013-11-17','09:40:00',2.65),('16100','2013-11-17','09:45:00',1.83),('16100','2013-11-17','09:50:00',1.63),('16100','2013-11-17','09:55:00',1.7),('16100','2013-11-17','10:00:00',1.93),('16100','2013-11-17','10:05:00',2.69),('16100','2013-11-17','10:10:00',2.91),('16100','2013-11-17','10:15:00',3.17),('16100','2013-11-17','10:20:00',2.54),('16100','2013-11-17','10:25:00',2.06),('16100','2013-11-17','10:30:00',1.88),('16100','2013-11-17','10:35:00',2),('16100','2013-11-17','10:40:00',2.25),('16100','2013-11-17','10:45:00',2.42),('16100','2013-11-17','10:50:00',2.18),('16100','2013-11-17','10:55:00',1.7),('16100','2013-11-17','11:00:00',1.47),('16100','2013-11-17','11:05:00',1.33),('16100','2013-11-17','11:10:00',1.19),('16100','2013-11-17','11:15:00',1.16),('16100','2013-11-17','11:20:00',1.33),('16100','2013-11-17','11:25:00',1.68),('16100','2013-11-17','11:30:00',1.85),('16100','2013-11-17','11:35:00',1.98),('16100','2013-11-17','11:40:00',2),('16100','2013-11-17','11:45:00',2.01),('16100','2013-11-17','11:50:00',2.16),('16100','2013-11-17','11:55:00',2.4),('16100','2013-11-17','12:00:00',2.56),('16100','2013-11-17','12:05:00',2.49),('16100','2013-11-17','12:10:00',2.44),('16100','2013-11-17','12:15:00',2.58),('16100','2013-11-17','12:20:00',2.91),('16100','2013-11-17','12:25:00',3.4),('16100','2013-11-17','12:30:00',3.16),('16100','2013-11-17','12:35:00',2.67),('16100','2013-11-17','12:40:00',2.12),('16100','2013-11-17','12:45:00',1.73),('16100','2013-11-17','12:50:00',1.53),('16100','2013-11-17','12:55:00',1.42),('16100','2013-11-17','13:00:00',1.38),('16100','2013-11-17','13:05:00',1.42),('16100','2013-11-17','13:10:00',1.87),('16100','2013-11-17','13:15:00',1.56),('16100','2013-11-17','13:20:00',1.52),('16100','2013-11-17','13:25:00',1.28),('16100','2013-11-17','13:30:00',1.37),('16100','2013-11-17','13:35:00',1.59),('16100','2013-11-17','13:40:00',1.73),('16100','2013-11-17','13:45:00',1.99),('16100','2013-11-17','13:50:00',1.75),('16100','2013-11-17','13:55:00',1.4),('16100','2013-11-17','14:00:00',1.21),('16100','2014-04-18','07:40:00',1.06),('16100','2014-04-18','07:45:00',1.05),('16100','2014-04-18','07:50:00',1.76),('16100','2014-04-18','07:55:00',1.62),('16100','2014-04-18','08:00:00',1.13),('16100','2014-04-18','08:05:00',1.22),('16100','2014-04-18','08:10:00',1.55),('16100','2014-04-18','08:15:00',2.02),('16100','2014-04-18','08:20:00',2.19),('16100','2014-04-18','08:25:00',2.11),('16100','2014-04-18','08:30:00',1.98),('16100','2014-04-18','08:35:00',2.26),('16100','2014-04-18','08:40:00',1.84),('16100','2014-04-18','08:45:00',1.64),('16100','2014-04-18','08:50:00',1.19),('16100','2014-04-18','09:10:00',1.1),('16100','2014-04-18','09:15:00',1.55),('16100','2014-04-18','09:20:00',2.03),('16100','2014-04-18','09:25:00',2.65),('16100','2014-04-18','09:30:00',2.16),('16100','2014-04-18','09:35:00',1.35),('16100','2014-04-18','09:40:00',1.09),('16100','2014-04-18','10:25:00',1.24),('16100','2014-04-18','10:30:00',1.62),('16100','2014-04-18','10:35:00',2.2),('16100','2014-04-18','10:40:00',2.46),('16100','2014-04-18','10:45:00',2.38),('16100','2014-04-18','10:50:00',3.06),('16100','2014-04-18','10:55:00',2.85),('16100','2014-04-18','11:00:00',1.79),('16100','2014-04-18','11:05:00',2.28),('16100','2014-04-18','11:10:00',3.22),('16100','2014-04-18','11:15:00',4.44),('16100','2014-04-18','11:20:00',5.37),('16100','2014-04-18','11:25:00',7.49),('16100','2014-04-18','11:30:00',6.37),('16100','2014-04-18','11:35:00',4.56),('16100','2014-04-18','11:40:00',3.62),('16100','2014-04-18','11:45:00',2.75),('16100','2014-04-18','11:50:00',1.65),('16100','2014-04-18','11:55:00',1.32),('16100','2014-04-18','13:10:00',1.45),('16100','2014-04-18','13:15:00',1.85),('16100','2014-04-18','14:25:00',1.08),('16100','2014-04-18','14:30:00',1.54),('16100','2014-04-18','14:35:00',2.15),('16100','2014-04-18','14:40:00',2.81),('16100','2014-04-18','14:45:00',2.08),('16100','2014-04-18','14:55:00',1.07),('16100','2014-04-18','15:00:00',2.3),('16100','2014-04-18','15:05:00',2.07),('16100','2014-04-18','15:25:00',1.61),('16100','2014-04-18','15:30:00',1.16),('16100','2014-04-18','15:40:00',2.87),('16100','2014-04-18','15:45:00',5.05),('16100','2014-04-18','15:50:00',4.27),('16100','2014-04-18','15:55:00',3.68),('16100','2014-04-18','16:00:00',2.79),('16100','2014-04-18','16:05:00',2.55),('16100','2014-04-18','16:10:00',2.7),('16100','2014-04-18','16:15:00',3.13),('16100','2014-04-18','16:20:00',2.63),('16100','2014-04-18','16:25:00',3.05),('16100','2014-04-18','16:30:00',2.84),('16100','2014-04-18','16:35:00',1.96),('16100','2014-04-18','16:40:00',2.46),('16100','2014-04-18','16:45:00',1.8),('16100','2014-04-18','16:50:00',1.11),('16100','2014-04-18','16:55:00',1.07),('16100','2014-04-18','17:00:00',1.77),('16100','2014-04-18','17:05:00',2.13),('16100','2014-04-18','17:10:00',1.63),('16100','2014-04-18','17:15:00',2.25),('16100','2014-04-18','17:20:00',2.3),('16100','2014-04-18','17:25:00',1.58),('16100','2014-04-18','17:30:00',1.28),('16100','2014-04-18','17:35:00',1.18),('16100','2014-04-18','17:40:00',1.08),('16100','2013-11-16','08:40:00',1.19),('16100','2013-11-16','08:45:00',1.19),('16100','2013-11-16','08:50:00',1.11),('16100','2013-11-16','08:55:00',3.44),('16100','2013-11-16','09:00:00',4.06),('16100','2013-11-16','09:05:00',3.87),('16100','2013-11-16','09:10:00',3.86),('16100','2013-11-16','09:15:00',3.82),('16100','2013-11-16','09:20:00',4.01),('16100','2013-11-16','09:25:00',3.84),('16100','2013-11-16','09:30:00',3.62),('16100','2013-11-16','09:35:00',4.27),('16100','2013-11-16','09:40:00',4.46),('16100','2013-11-16','09:45:00',4.53),('16100','2013-11-16','09:50:00',4.56),('16100','2013-11-16','09:55:00',4.65),('16100','2013-11-16','10:00:00',4.77),('16100','2013-11-16','10:05:00',4.85),('16100','2013-11-16','10:10:00',4.92),('16100','2013-11-16','10:15:00',4.99),('16100','2013-11-16','10:20:00',5.06),('16100','2013-11-16','10:25:00',5.14),('16100','2013-11-16','10:30:00',5.2),('16100','2013-11-16','10:35:00',5.25),('16100','2013-11-16','10:40:00',5.3),('16100','2013-11-16','10:45:00',5.4),('16100','2013-11-16','10:50:00',5.5),('16100','2013-11-16','10:55:00',5.53),('16100','2013-11-16','11:00:00',5.55),('16100','2013-11-16','11:05:00',5.62),('16100','2013-11-16','11:10:00',5.66),('16100','2013-11-16','11:15:00',5.68),('16100','2013-11-16','11:20:00',5.7),('16100','2013-11-16','11:25:00',5.72),('16100','2013-11-16','11:30:00',5.74),('16100','2013-11-16','11:35:00',5.74),('16100','2013-11-16','11:40:00',5.73),('16100','2013-11-16','11:45:00',5.73),('16100','2013-11-16','11:50:00',5.75),('16100','2013-11-16','11:55:00',5.79),('16100','2013-11-16','12:00:00',5.74),('16100','2013-11-16','12:05:00',5.75),('16100','2013-11-16','12:10:00',5.77),('16100','2013-11-16','12:15:00',5.63),('16100','2013-11-16','12:20:00',5.66),('16100','2013-11-16','12:25:00',5.58),('16100','2013-11-16','12:30:00',5.56),('16100','2013-11-16','12:35:00',5.55),('16100','2013-11-16','12:40:00',5.56),('16100','2013-11-16','12:45:00',5.51),('16100','2013-11-16','12:50:00',5.47),('16100','2013-11-16','12:55:00',5.44),('16100','2013-11-16','13:00:00',5.39),('16100','2013-11-16','13:05:00',5.34),('16100','2013-11-16','13:10:00',5.29),('16100','2013-11-16','13:15:00',5.24),('16100','2013-11-16','13:20:00',5.16),('16100','2013-11-16','13:25:00',5.13),('16100','2013-11-16','13:30:00',4.35),('16100','2013-11-16','13:35:00',2.75),('16100','2013-11-16','13:40:00',4.96),('16100','2013-11-16','13:45:00',4.67),('16100','2013-11-16','13:50:00',4.57),('16100','2013-11-16','13:55:00',3.92),('16100','2013-11-16','14:15:00',2.78),('16100','2013-11-16','14:20:00',4.06),('16100','2013-11-16','14:25:00',3.9),('16100','2013-11-16','14:30:00',3.77),('16100','2013-11-16','14:35:00',3.19),('16100','2013-11-16','14:55:00',2.11),('16100','2013-11-16','15:00:00',2.31),('16100','2013-11-16','15:05:00',2.01),('16100','2013-11-16','15:10:00',2.44),('16100','2013-11-16','15:15:00',2.32),('16100','2013-11-16','15:20:00',2.64),('16100','2013-11-16','15:25:00',2.43),('16100','2013-11-16','15:30:00',2.18),('16100','2013-11-16','15:35:00',1.94),('16100','2013-11-16','15:40:00',1.73),('16100','2013-11-16','15:45:00',1.55),('16100','2013-11-16','15:50:00',1.35),('16100','2013-11-16','15:55:00',1.21),('16100','2013-11-15','12:50:00',1.3),('16100','2013-11-15','12:55:00',1.88),('16100','2013-11-15','13:00:00',1.94),('16100','2013-11-15','13:05:00',1.9),('16100','2013-11-15','13:10:00',1.62),('16100','2013-11-15','13:15:00',1.45),('16100','2013-11-15','13:20:00',1.18),('16100','2013-11-14','09:05:00',1.01),('16100','2013-11-14','09:10:00',1.88),('16100','2013-11-14','09:15:00',2.7),('16100','2013-11-14','09:20:00',2.15),('16100','2013-11-14','09:25:00',1.75),('16100','2013-11-14','09:30:00',1.33),('16100','2013-11-14','09:35:00',1.16),('16100','2013-11-14','09:40:00',1.01),('16100','2013-11-14','09:45:00',1.83),('16100','2013-11-14','09:50:00',2.21),('16100','2013-11-14','09:55:00',1.87),('16100','2013-11-14','10:00:00',1.83),('16100','2013-11-14','10:05:00',1.73),('16100','2013-11-14','10:10:00',1.81),('16100','2013-11-14','10:15:00',1.99),('16100','2013-11-14','10:20:00',1.96),('16100','2013-11-14','10:25:00',2.33),('16100','2013-11-14','10:30:00',2.18),('16100','2013-11-14','10:35:00',2.65),('16100','2013-11-14','10:40:00',1.66),('16100','2013-11-14','10:45:00',1.42),('16100','2013-11-14','10:50:00',1.52),('16100','2013-11-14','10:55:00',1.5),('16100','2013-11-14','11:00:00',1.82),('16100','2013-11-14','11:05:00',2.08),('16100','2013-11-14','11:10:00',2.24),('16100','2013-11-14','11:15:00',2.52),('16100','2013-11-14','11:20:00',2.1),('16100','2013-11-14','11:25:00',1.92),('16100','2013-11-14','11:30:00',2.45),('16100','2013-11-14','11:35:00',4.64),('16100','2013-11-14','11:40:00',2.74),('16100','2013-11-14','11:45:00',2.71),('16100','2013-11-14','11:50:00',2.48),('16100','2013-11-14','11:55:00',2.15),('16100','2013-11-14','12:00:00',1.98),('16100','2013-11-14','12:05:00',1.68),('16100','2013-11-14','12:10:00',1.4),('16100','2013-11-14','12:15:00',1.43),('16100','2013-11-14','12:20:00',1.44),('16100','2013-11-14','12:25:00',1.64),('16100','2013-11-14','12:30:00',2.06),('16100','2013-11-14','12:35:00',1.72),('16100','2013-11-14','12:40:00',1.64),('16100','2013-11-14','12:45:00',1.64),('16100','2013-11-14','12:50:00',1.68),('16100','2013-11-14','12:55:00',1.77),('16100','2013-11-14','13:00:00',1.94),('16100','2013-11-14','13:05:00',1.93),('16100','2013-11-14','13:10:00',1.9),('16100','2013-11-14','13:15:00',1.67),('16100','2013-11-14','13:20:00',1.59),('16100','2013-11-14','13:25:00',1.44),('16100','2013-11-14','13:30:00',1.39),('16100','2013-11-14','13:35:00',1.39),('16100','2013-11-14','13:40:00',1.41),('16100','2013-11-14','13:45:00',1.46),('16100','2013-11-14','13:50:00',1.47),('16100','2013-11-14','13:55:00',1.51),('16100','2013-11-14','14:00:00',1.49),('16100','2013-11-14','14:05:00',1.53),('16100','2013-11-14','14:10:00',1.31),('16100','2013-11-14','14:15:00',1.1),('16100','2013-11-13','08:15:00',1.37),('16100','2013-11-13','08:50:00',2.29),('16100','2013-11-13','08:55:00',2.15),('16100','2013-11-13','09:05:00',1.4),('16100','2013-11-13','09:15:00',1.94),('16100','2013-11-13','09:20:00',3.48),('16100','2013-11-13','09:25:00',3.68),('16100','2013-11-13','09:30:00',4.08),('16100','2013-11-13','09:35:00',4.2),('16100','2013-11-13','09:40:00',4.29),('16100','2013-11-13','09:45:00',4.42),('16100','2013-11-13','09:50:00',4.52),('16100','2013-11-13','09:55:00',4.53),('16100','2013-11-13','10:00:00',4.66),('16100','2013-11-13','10:05:00',4.67),('16100','2013-11-13','10:10:00',4.77),('16100','2013-11-13','10:15:00',4.86),('16100','2013-11-13','10:20:00',4.98),('16100','2013-11-13','10:25:00',4.56),('16100','2013-11-13','10:30:00',4.56),('16100','2013-11-13','10:35:00',5.02),('16100','2013-11-13','10:40:00',5.3),('16100','2013-11-13','10:45:00',5.48),('16100','2013-11-13','10:50:00',5.53),('16100','2013-11-13','10:55:00',5.55),('16100','2013-11-13','11:00:00',5.62),('16100','2013-11-13','11:05:00',5.66),('16100','2013-11-13','11:10:00',5.98),('16100','2013-11-13','11:15:00',5.55),('16100','2013-11-13','11:20:00',5.98),('16100','2013-11-13','11:25:00',6.07),('16100','2013-11-13','11:30:00',5.22),('16100','2013-11-13','11:35:00',5.07),('16100','2013-11-13','11:40:00',5.24),('16100','2013-11-13','11:45:00',5.5),('16100','2013-11-13','11:50:00',5.31),('16100','2013-11-13','11:55:00',3.65),('16100','2013-11-13','12:00:00',2.14),('16100','2013-11-13','12:05:00',1.97),('16100','2013-11-13','12:10:00',1.93),('16100','2013-11-13','12:15:00',1.95),('16100','2013-11-13','12:20:00',2),('16100','2013-11-13','12:25:00',2.27),('16100','2013-11-13','12:30:00',2.55),('16100','2013-11-13','12:35:00',2.92),('16100','2013-11-13','12:40:00',3.37),('16100','2013-11-13','12:45:00',2.6),('16100','2013-11-13','12:50:00',2.33),('16100','2013-11-13','12:55:00',2.34),('16100','2013-11-13','13:00:00',2.05),('16100','2013-11-13','13:05:00',2),('16100','2013-11-13','13:10:00',2.59),('16100','2013-11-13','13:15:00',2.09),('16100','2013-11-13','13:20:00',2.08),('16100','2013-11-13','13:25:00',2.72),('16100','2013-11-13','13:30:00',5.55),('16100','2013-11-13','13:35:00',5.73),('16100','2013-11-13','13:40:00',3.88),('16100','2013-11-13','13:45:00',5.37),('16100','2013-11-13','13:50:00',5.4),('16100','2013-11-13','13:55:00',3.29),('16100','2013-11-13','14:00:00',5.3),('16100','2013-11-13','14:05:00',2.65),('16100','2013-11-13','14:10:00',2.23),('16100','2013-11-13','14:15:00',1.68),('16100','2013-11-13','14:20:00',1.45),('16100','2013-11-13','14:25:00',1.36),('16100','2013-11-13','14:30:00',1.26),('16100','2013-11-13','14:35:00',1.27),('16100','2013-11-13','14:40:00',1.21),('16100','2013-11-13','14:45:00',1.23),('16100','2013-11-13','14:50:00',1.21),('16100','2013-11-13','14:55:00',1.02),('16100','2013-11-12','10:00:00',1.01),('16100','2013-11-12','10:05:00',2.39),('16100','2013-11-12','10:10:00',2.44),('16100','2013-11-12','10:15:00',1.73),('16100','2013-11-12','10:20:00',1.91),('16100','2013-11-12','10:25:00',3.11),('16100','2013-11-12','10:30:00',1.81),('16100','2013-11-12','10:35:00',2.09),('16100','2013-11-12','10:40:00',2.18),('16100','2013-11-12','10:45:00',1.94),('16100','2013-11-12','10:50:00',1.82),('16100','2013-11-12','10:55:00',1.5),('16100','2013-11-12','11:00:00',1.36),('16100','2013-11-12','11:05:00',1.56),('16100','2013-11-12','11:10:00',1.92),('16100','2013-11-12','11:15:00',2.18),('16100','2013-11-12','11:20:00',3.16),('16100','2013-11-12','11:25:00',3.32),('16100','2013-11-12','11:30:00',1.89),('16100','2013-11-12','11:35:00',1.53),('16100','2013-11-12','11:40:00',1.39),('16100','2013-11-12','11:45:00',1.49),('16100','2013-11-12','11:50:00',1.7),('16100','2013-11-12','11:55:00',1.99),('16100','2013-11-12','12:00:00',2.77),('16100','2013-11-12','12:05:00',2.09),('16100','2013-11-12','12:10:00',1.98),('16100','2013-11-12','12:15:00',1.65),('16100','2013-11-12','12:20:00',1.8),('16100','2013-11-12','12:25:00',1.52),('16100','2013-11-12','12:30:00',1.19),('16100','2013-11-12','12:45:00',1.41),('16100','2013-11-12','12:50:00',1.56),('16100','2013-11-12','12:55:00',1.68),('16100','2013-11-12','13:00:00',1.73),('16100','2013-11-12','13:05:00',1.88),('16100','2013-11-12','13:10:00',1.95),('16100','2013-11-12','13:15:00',1.98),('16100','2013-11-12','13:20:00',2.1),('16100','2013-11-12','13:25:00',1.73),('16100','2013-11-12','13:30:00',1.49),('16100','2013-11-12','13:35:00',1.38),('16100','2013-11-12','13:40:00',1.56),('16100','2013-11-12','13:45:00',2.45),('16100','2013-11-12','13:50:00',1.74),('16100','2013-11-12','13:55:00',2.46),('16100','2013-11-12','14:00:00',3.25),('16100','2013-11-12','14:05:00',3.7),('16100','2013-11-12','14:10:00',4),('16100','2013-11-12','14:15:00',3.41),('16100','2013-11-12','14:20:00',3.09),('16100','2013-11-12','14:25:00',2.94),('16100','2013-11-12','14:30:00',3.42),('16100','2013-11-12','14:35:00',2.69),('16100','2013-11-12','14:40:00',1.85),('16100','2013-11-12','14:45:00',1.2),('16100','2013-11-12','15:30:00',1),('16100','2013-11-11','11:00:00',1.07),('16100','2013-11-11','11:05:00',1.06),('16100','2013-11-11','11:10:00',1.16),('16100','2013-11-11','11:15:00',1.17),('16100','2013-11-11','11:20:00',1.18),('16100','2013-11-11','11:25:00',1.38),('16100','2013-11-11','11:30:00',1.41),('16100','2013-11-11','11:35:00',1.47),('16100','2013-11-11','11:40:00',5.27),('16100','2013-11-11','11:45:00',2.03),('16100','2013-11-11','11:50:00',1.37),('16100','2013-11-11','11:55:00',1.42),('16100','2013-11-11','12:00:00',4.58),('16100','2013-11-11','12:05:00',4.02),('16100','2013-11-11','12:10:00',1.79),('16100','2013-11-11','12:15:00',1.18),('16100','2013-11-11','12:20:00',1.34),('16100','2013-11-11','12:25:00',1.2),('16100','2013-11-11','12:30:00',2.01),('16100','2013-11-11','12:35:00',8.05),('16100','2013-11-11','12:40:00',5.7),('16100','2013-11-11','12:45:00',4.96),('16100','2013-11-11','12:50:00',3.89),('16100','2013-11-11','12:55:00',2.94),('16100','2013-11-11','13:00:00',3.21),('16100','2013-11-11','13:05:00',2.88),('16100','2013-11-11','13:10:00',2.57),('16100','2013-11-11','13:15:00',3.68),('16100','2013-11-11','13:20:00',3.31),('16100','2013-11-11','13:25:00',2.84),('16100','2013-11-11','13:30:00',2.9),('16100','2013-11-11','13:35:00',3.13),('16100','2013-11-11','13:40:00',3.19),('16100','2013-11-11','13:45:00',4.32),('16100','2013-11-11','13:50:00',6.14),('16100','2013-11-11','13:55:00',3.52),('16100','2013-11-11','14:00:00',3.82),('16100','2013-11-11','14:05:00',2.34),('16100','2013-11-11','14:10:00',3.97),('16100','2013-11-11','14:15:00',4.7),('16100','2013-11-11','14:20:00',4.27),('16100','2013-11-11','14:25:00',3.51),('16100','2013-11-11','14:30:00',1.85),('16100','2013-11-11','14:35:00',4.73),('16100','2013-11-11','14:40:00',2.51),('16100','2013-11-11','14:45:00',2.28),('16100','2013-11-11','14:50:00',2.83),('16100','2013-11-11','14:55:00',3.03),('16100','2013-11-11','15:00:00',2.95),('16100','2013-11-11','15:05:00',2.53),('16100','2013-11-11','15:10:00',1.55),('16100','2013-11-11','15:15:00',1.4),('16100','2013-11-11','15:20:00',1.63),('16100','2013-11-11','15:25:00',1.56),('16100','2013-11-11','15:30:00',1.67),('16100','2013-11-10','09:55:00',1.01),('16100','2013-11-10','10:30:00',1.7),('16100','2013-11-10','10:35:00',2.01),('16100','2013-11-10','10:40:00',1.74),('16100','2013-11-10','10:45:00',1.49),('16100','2013-11-10','10:50:00',1.26),('16100','2013-11-10','10:55:00',1.51),('16100','2013-11-10','11:00:00',1.74),('16100','2013-11-10','11:05:00',1.11),('16100','2013-11-10','11:10:00',1.74),('16100','2013-11-10','11:15:00',3.39),('16100','2013-11-10','11:20:00',5.49),('16100','2013-11-10','11:25:00',7.86),('16100','2013-11-10','11:30:00',3.41),('16100','2013-11-10','11:35:00',1.88),('16100','2013-11-10','11:40:00',2.86),('16100','2013-11-10','11:45:00',3.4),('16100','2013-11-10','11:50:00',3.51),('16100','2013-11-10','11:55:00',2.65),('16100','2013-11-10','12:00:00',4.7),('16100','2013-11-10','12:05:00',5.5),('16100','2013-11-10','12:10:00',4.62),('16100','2013-11-10','12:15:00',7.04),('16100','2013-11-10','12:20:00',7.28),('16100','2013-11-10','12:25:00',5.45),('16100','2013-11-10','12:30:00',6.79),('16100','2013-11-10','12:35:00',6.82),('16100','2013-11-10','12:40:00',4.28),('16100','2013-11-10','12:45:00',2.96),('16100','2013-11-10','12:50:00',4.28),('16100','2013-11-10','12:55:00',4.13),('16100','2013-11-10','13:00:00',5.9),('16100','2013-11-10','13:05:00',5.27),('16100','2013-11-10','13:10:00',5.01),('16100','2013-11-10','13:15:00',5.17),('16100','2013-11-10','13:20:00',6.01),('16100','2013-11-10','13:25:00',3.95),('16100','2013-11-10','13:40:00',1.57),('16100','2013-11-10','13:45:00',2.3),('16100','2013-11-10','13:50:00',4.95),('16100','2013-11-10','13:55:00',1.84),('16100','2013-11-10','14:00:00',1.09),('16100','2013-11-10','14:05:00',2.05),('16100','2013-11-10','14:10:00',5.4),('16100','2013-11-10','14:15:00',5.27),('16100','2013-11-10','14:20:00',4.94),('16100','2013-11-10','14:25:00',4.83),('16100','2013-11-10','14:30:00',4.51),('16100','2013-11-10','14:35:00',4.2),('16100','2013-11-10','14:40:00',4.15),('16100','2013-11-10','14:45:00',3.78),('16100','2013-11-10','14:50:00',2.82),('16100','2013-11-10','14:55:00',2.31),('16100','2013-11-10','15:00:00',2),('16100','2013-11-10','15:05:00',1.67),('16100','2013-11-09','07:35:00',1.06),('16100','2013-11-09','07:40:00',1.05),('16100','2013-11-09','07:45:00',1.69),('16100','2013-11-09','07:50:00',1.89),('16100','2013-11-09','07:55:00',1.45),('16100','2013-11-09','08:00:00',1.76),('16100','2013-11-09','08:05:00',1.16),('16100','2013-11-09','08:10:00',1.33),('16100','2013-11-09','08:15:00',1.6),('16100','2013-11-09','08:20:00',2),('16100','2013-11-09','08:25:00',2.45),('16100','2013-11-09','08:30:00',1.72),('16100','2013-11-09','08:35:00',2.6),('16100','2013-11-09','08:40:00',3.25),('16100','2013-11-09','08:45:00',3.11),('16100','2013-11-09','08:50:00',3),('16100','2013-11-09','08:55:00',3.26),('16100','2013-11-09','09:00:00',3.08),('16100','2013-11-09','09:05:00',2.38),('16100','2013-11-09','09:10:00',2.66),('16100','2013-11-09','09:15:00',3.46),('16100','2013-11-09','09:20:00',3.67),('16100','2013-11-09','09:25:00',4.08),('16100','2013-11-09','09:30:00',3.07),('16100','2013-11-09','09:35:00',3.69),('16100','2013-11-09','09:40:00',4.31),('16100','2013-11-09','09:45:00',3.66),('16100','2013-11-09','09:50:00',4.12),('16100','2013-11-09','09:55:00',4.18),('16100','2013-11-09','10:00:00',4.68),('16100','2013-11-09','10:05:00',3.25),('16100','2013-11-09','10:10:00',3.15),('16100','2013-11-09','10:15:00',2.63),('16100','2013-11-09','10:20:00',2.87),('16100','2013-11-09','10:25:00',3.77),('16100','2013-11-09','10:30:00',4.33),('16100','2013-11-09','10:35:00',2.37),('16100','2013-11-09','10:40:00',5.62),('16100','2013-11-09','10:45:00',6.69),('16100','2013-11-09','10:50:00',7.04),('16100','2013-11-09','10:55:00',4.43),('16100','2013-11-09','11:00:00',1.5),('16100','2013-11-09','11:10:00',1.14),('16100','2013-11-09','11:15:00',2.11),('16100','2013-11-09','11:20:00',2.69),('16100','2013-11-09','11:25:00',3.31),('16100','2013-11-09','11:30:00',2.68),('16100','2013-11-09','11:35:00',4.77),('16100','2013-11-09','11:40:00',3.08),('16100','2013-11-09','11:45:00',1.81),('16100','2013-11-09','11:50:00',2.04),('16100','2013-11-09','11:55:00',3.73),('16100','2013-11-09','12:00:00',7.53),('16100','2013-11-09','12:05:00',7.09),('16100','2013-11-09','12:10:00',6.41),('16100','2013-11-09','12:15:00',4.63),('16100','2013-11-09','12:20:00',1.67),('16100','2013-11-09','12:25:00',1.99),('16100','2013-11-09','12:30:00',2.75),('16100','2013-11-09','12:35:00',4.56),('16100','2013-11-09','12:40:00',5.37),('16100','2013-11-09','12:45:00',2),('16100','2013-11-09','12:50:00',1.72),('16100','2013-11-09','12:55:00',2.27),('16100','2013-11-09','13:00:00',3.46),('16100','2013-11-09','13:05:00',2.63),('16100','2013-11-09','13:10:00',2.6),('16100','2013-11-09','13:15:00',1.19),('16100','2013-11-09','13:25:00',1.91),('16100','2013-11-09','13:30:00',4.58),('16100','2013-11-09','13:35:00',4.66),('16100','2013-11-09','13:40:00',3.77),('16100','2013-11-09','13:45:00',1.32),('16100','2013-11-09','14:25:00',1.3),('16100','2013-11-08','09:10:00',1.21),('16100','2013-11-08','09:30:00',3.16),('16100','2013-11-08','09:35:00',1.43),('16100','2013-11-08','09:40:00',3.15),('16100','2013-11-08','09:45:00',3.79),('16100','2013-11-08','09:50:00',5.54),('16100','2013-11-08','09:55:00',5.74),('16100','2013-11-08','10:00:00',4.11),('16100','2013-11-08','10:05:00',2.38),('16100','2013-11-08','10:10:00',2.51),('16100','2013-11-08','10:15:00',2.95),('16100','2013-11-08','10:20:00',5.33),('16100','2013-11-08','10:25:00',2.28),('16100','2013-11-08','10:30:00',1.49),('16100','2013-11-08','10:35:00',3.92),('16100','2013-11-08','10:40:00',6.05),('16100','2013-11-08','10:45:00',4.38),('16100','2013-11-08','10:50:00',3.16),('16100','2013-11-08','10:55:00',4.79),('16100','2013-11-08','11:00:00',7.51),('16100','2013-11-08','11:05:00',5.06),('16100','2013-11-08','11:10:00',4.91),('16100','2013-11-08','11:15:00',2.22),('16100','2013-11-08','11:20:00',1.82),('16100','2013-11-08','11:25:00',1.26),('16100','2013-11-08','11:30:00',2.83),('16100','2013-11-08','11:35:00',6.93),('16100','2013-11-08','11:40:00',4.43),('16100','2013-11-08','11:45:00',7.22),('16100','2013-11-08','11:50:00',6.87),('16100','2013-11-08','11:55:00',7.03),('16100','2013-11-08','12:00:00',7.74),('16100','2013-11-08','12:05:00',7),('16100','2013-11-08','12:10:00',1.74),('16100','2013-11-08','12:15:00',1.41),('16100','2013-11-08','12:20:00',1.3),('16100','2013-11-08','12:25:00',1.63),('16100','2013-11-08','12:30:00',2.22),('16100','2013-11-08','12:35:00',2.21),('16100','2013-11-08','12:40:00',3.06),('16100','2013-11-08','12:45:00',4.45),('16100','2013-11-08','12:50:00',7.03),('16100','2013-11-08','12:55:00',6.64),('16100','2013-11-08','13:00:00',5.56),('16100','2013-11-08','13:05:00',6.32),('16100','2013-11-08','13:10:00',2.51),('16100','2013-11-08','13:15:00',2.43),('16100','2013-11-08','13:20:00',3.99),('16100','2013-11-08','13:25:00',4.79),('16100','2013-11-08','13:30:00',2.85),('16100','2013-11-08','13:35:00',2.15),('16100','2013-11-08','13:40:00',3.38),('16100','2013-11-08','13:45:00',4.69),('16100','2013-11-08','13:50:00',5.46),('16100','2013-11-08','13:55:00',5.35),('16100','2013-11-08','14:00:00',2.67),('16100','2013-11-08','14:05:00',1.38),('16100','2013-11-08','14:10:00',1.42),('16100','2013-11-08','14:15:00',2.46),('16100','2013-11-08','14:20:00',2.73),('16100','2013-11-08','14:25:00',1.74),('16100','2013-11-08','14:30:00',2.71),('16100','2013-11-08','14:35:00',3.77),('16100','2013-11-08','14:40:00',3.08),('16100','2013-11-08','14:45:00',2.65),('16100','2013-11-08','14:50:00',1.84),('16100','2013-11-08','15:10:00',1.23),('16100','2013-11-08','15:15:00',2.16),('16100','2013-11-08','15:20:00',2.14),('16100','2013-11-08','15:25:00',2.13),('16100','2013-11-08','15:30:00',2.31),('16100','2013-11-08','15:40:00',1.66),('16100','2013-11-08','15:45:00',1.37),('16100','2013-11-08','15:50:00',1.41),('16100','2013-11-07','08:50:00',1.04),('16100','2013-11-07','08:55:00',1.26),('16100','2013-11-07','09:00:00',1.74),('16100','2013-11-07','09:05:00',1.78),('16100','2013-11-07','09:10:00',1.25),('16100','2013-11-07','09:15:00',1.51),('16100','2013-11-07','09:20:00',2.11),('16100','2013-11-07','09:25:00',1.27),('16100','2013-11-07','09:35:00',1.79),('16100','2013-11-07','09:40:00',4.31),('16100','2013-11-07','09:45:00',3.08),('16100','2013-11-07','09:50:00',3.39),('16100','2013-11-07','09:55:00',4.1),('16100','2013-11-07','10:00:00',1.45),('16100','2013-11-07','10:05:00',1.56),('16100','2013-11-07','10:10:00',1.46),('16100','2013-11-07','10:15:00',3.96),('16100','2013-11-07','10:20:00',5.95),('16100','2013-11-07','10:25:00',6.23),('16100','2013-11-07','10:30:00',4.59),('16100','2013-11-07','10:35:00',4.74),('16100','2013-11-07','10:40:00',1.38),('16100','2013-11-07','10:45:00',1.09),('16100','2013-11-07','10:50:00',3.76),('16100','2013-11-07','10:55:00',1.61),('16100','2013-11-07','11:00:00',1.67),('16100','2013-11-07','11:05:00',1.22),('16100','2013-11-07','11:20:00',3.19),('16100','2013-11-07','11:25:00',2.88),('16100','2013-11-07','11:30:00',6.74),('16100','2013-11-07','11:35:00',6.87),('16100','2013-11-07','11:40:00',6.85),('16100','2013-11-07','11:45:00',6.69),('16100','2013-11-07','11:50:00',6.78),('16100','2013-11-07','11:55:00',6.56),('16100','2013-11-07','12:00:00',6.22),('16100','2013-11-07','12:05:00',6.07),('16100','2013-11-07','12:10:00',6.05),('16100','2013-11-07','12:15:00',6.01),('16100','2013-11-07','12:20:00',6.03),('16100','2013-11-07','12:25:00',6.11),('16100','2013-11-07','12:30:00',5.62),('16100','2013-11-07','12:35:00',3.52),('16100','2013-11-07','12:40:00',2.83),('16100','2013-11-07','12:45:00',3.62),('16100','2013-11-07','12:50:00',4.09),('16100','2013-11-07','12:55:00',1.56),('16100','2013-11-07','13:00:00',3.51),('16100','2013-11-07','13:05:00',6.16),('16100','2013-11-07','13:10:00',6.25),('16100','2013-11-07','13:15:00',5.97),('16100','2013-11-07','13:20:00',5.84),('16100','2013-11-07','13:25:00',5.89),('16100','2013-11-07','13:30:00',5.62),('16100','2013-11-07','13:35:00',3.38),('16100','2013-11-07','13:40:00',3.47),('16100','2013-11-07','13:45:00',5.27),('16100','2013-11-07','13:50:00',5.37),('16100','2013-11-07','13:55:00',5.26),('16100','2013-11-07','14:00:00',4.99),('16100','2013-11-07','14:05:00',4.89),('16100','2013-11-07','14:10:00',1.68),('16100','2013-11-07','14:15:00',1.28),('16100','2013-11-07','14:20:00',3.14),('16100','2013-11-07','14:25:00',4.31),('16100','2013-11-07','14:30:00',4.14),('16100','2013-11-07','14:35:00',3.29),('16100','2013-11-07','14:45:00',3.11),('16100','2013-11-07','14:50:00',3.62),('16100','2013-11-07','14:55:00',3.42),('16100','2013-11-07','15:00:00',2.71),('16100','2013-11-07','15:05:00',3.09),('16100','2013-11-07','15:10:00',2.97),('16100','2013-11-07','15:15:00',2.86),('16100','2013-11-07','15:20:00',2.63),('16100','2013-11-07','15:25:00',2.51),('16100','2013-11-07','15:30:00',2.37),('16100','2013-11-07','15:35:00',2.2),('16100','2013-11-07','15:40:00',2.03),('16100','2013-11-07','15:45:00',1.83),('16100','2013-11-07','15:50:00',1.33),('16100','2013-11-07','15:55:00',1.23),('16100','2013-11-07','16:00:00',1.3),('16100','2013-11-07','16:05:00',1.14),('16100','2014-04-17','08:05:00',1.05),('16100','2014-04-17','08:10:00',1.59),('16100','2014-04-17','08:15:00',1.37),('16100','2014-04-17','08:20:00',1.59),('16100','2014-04-17','08:30:00',1.08),('16100','2014-04-17','08:35:00',1.89),('16100','2014-04-17','08:40:00',1.74),('16100','2014-04-17','08:45:00',2.84),('16100','2014-04-17','08:50:00',2.19),('16100','2014-04-17','08:55:00',1.64),('16100','2014-04-17','09:00:00',1.56),('16100','2014-04-17','09:05:00',2.36),('16100','2014-04-17','09:10:00',4.81),('16100','2014-04-17','09:15:00',4.52),('16100','2014-04-17','09:20:00',4.64),('16100','2014-04-17','09:25:00',3.25),('16100','2014-04-17','09:30:00',4.14),('16100','2014-04-17','09:35:00',1.75),('16100','2014-04-17','09:40:00',2.99),('16100','2014-04-17','09:45:00',3.97),('16100','2014-04-17','09:50:00',3.64),('16100','2014-04-17','09:55:00',3.91),('16100','2014-04-17','10:00:00',2.47),('16100','2014-04-17','10:05:00',2.18),('16100','2014-04-17','10:10:00',2.22),('16100','2014-04-17','10:15:00',2.04),('16100','2014-04-17','10:20:00',2.64),('16100','2014-04-17','10:25:00',2.31),('16100','2014-04-17','10:30:00',2),('16100','2014-04-17','10:35:00',2.12),('16100','2014-04-17','10:40:00',3.3),('16100','2014-04-17','10:45:00',4.36),('16100','2014-04-17','10:50:00',5.87),('16100','2014-04-17','10:55:00',4.24),('16100','2014-04-17','11:00:00',4),('16100','2014-04-17','11:05:00',3.31),('16100','2014-04-17','11:10:00',2.97),('16100','2014-04-17','11:15:00',3.52),('16100','2014-04-17','11:20:00',3.05),('16100','2014-04-17','11:25:00',3.14),('16100','2014-04-17','11:30:00',3.17),('16100','2014-04-17','11:35:00',3.7),('16100','2014-04-17','11:40:00',3.79),('16100','2014-04-17','11:45:00',4.98),('16100','2014-04-17','11:50:00',4.36),('16100','2014-04-17','11:55:00',3.48),('16100','2014-04-17','12:00:00',3.31),('16100','2014-04-17','12:05:00',4.94),('16100','2014-04-17','12:10:00',5.97),('16100','2014-04-17','12:15:00',7.37),('16100','2014-04-17','12:20:00',7.45),('16100','2014-04-17','12:25:00',5.92),('16100','2014-04-17','12:30:00',8.42),('16100','2014-04-17','12:35:00',8.13),('16100','2014-04-17','12:40:00',7.32),('16100','2014-04-17','12:45:00',6.74),('16100','2014-04-17','12:50:00',5.49),('16100','2014-04-17','12:55:00',7.76),('16100','2014-04-17','13:00:00',7.59),('16100','2014-04-17','13:05:00',4.77),('16100','2014-04-17','13:10:00',5.38),('16100','2014-04-17','13:15:00',4.77),('16100','2014-04-17','13:20:00',3.95),('16100','2014-04-17','13:25:00',2.92),('16100','2014-04-17','13:30:00',1.97),('16100','2014-04-17','13:35:00',2.27),('16100','2014-04-17','13:40:00',2.37),('16100','2014-04-17','13:45:00',2.42),('16100','2014-04-17','13:50:00',2.29),('16100','2014-04-17','13:55:00',2.57),('16100','2014-04-17','14:00:00',2.77),('16100','2014-04-17','14:05:00',2.78),('16100','2014-04-17','14:10:00',2.85),('16100','2014-04-17','14:15:00',3.15),('16100','2014-04-17','14:20:00',2.74),('16100','2014-04-17','14:25:00',3.35),('16100','2014-04-17','14:30:00',3.55),('16100','2014-04-17','14:35:00',3.93),('16100','2014-04-17','14:40:00',4.35),('16100','2014-04-17','14:45:00',5.83),('16100','2014-04-17','14:50:00',6.78),('16100','2014-04-17','14:55:00',8.05),('16100','2014-04-17','15:00:00',6.95),('16100','2014-04-17','15:05:00',7.2),('16100','2014-04-17','15:10:00',5.99),('16100','2014-04-17','15:15:00',7.77),('16100','2014-04-17','15:20:00',7.6),('16100','2014-04-17','15:25:00',7.52),('16100','2014-04-17','15:30:00',7.47),('16100','2014-04-17','15:35:00',6.98),('16100','2014-04-17','15:40:00',6.8),('16100','2014-04-17','15:45:00',5.27),('16100','2014-04-17','15:50:00',4.98),('16100','2014-04-17','15:55:00',4.07),('16100','2014-04-17','16:00:00',5.1),('16100','2014-04-17','16:05:00',5.97),('16100','2014-04-17','16:10:00',4.35),('16100','2014-04-17','16:15:00',5.95),('16100','2014-04-17','16:20:00',6.23),('16100','2014-04-17','16:25:00',5.89),('16100','2014-04-17','16:30:00',5.48),('16100','2014-04-17','16:35:00',5.36),('16100','2014-04-17','16:40:00',4.63),('16100','2014-04-17','16:45:00',3.11),('16100','2014-04-17','16:50:00',3.3),('16100','2014-04-17','16:55:00',5.16),('16100','2014-04-17','17:00:00',4.45),('16100','2014-04-17','17:05:00',4.16),('16100','2014-04-17','17:10:00',3.94),('16100','2014-04-17','17:15:00',3.55),('16100','2014-04-17','17:20:00',3.31),('16100','2014-04-17','17:25:00',3.21),('16100','2014-04-17','17:30:00',1.47),('16100','2014-04-17','17:35:00',2.88),('16100','2014-04-17','17:40:00',2.8),('16100','2014-04-17','17:45:00',2.6),('16100','2014-04-17','17:50:00',2.52),('16100','2014-04-17','17:55:00',2.39),('16100','2014-04-17','18:00:00',2.25),('16100','2014-04-17','18:05:00',1.96),('16100','2014-04-17','18:10:00',1.77),('16100','2014-04-17','18:15:00',1.6),('16100','2014-04-17','18:20:00',1.4),('16100','2014-04-17','18:25:00',1.18),('16100','2014-04-17','18:30:00',1.03),('16100','2013-11-06','07:40:00',1.13),('16100','2013-11-06','07:45:00',1.3),('16100','2013-11-06','07:50:00',1.46),('16100','2013-11-06','07:55:00',1.66),('16100','2013-11-06','08:00:00',1.83),('16100','2013-11-06','08:05:00',1.97),('16100','2013-11-06','08:10:00',2.15),('16100','2013-11-06','08:15:00',2.32),('16100','2013-11-06','08:20:00',2.48),('16100','2013-11-06','08:25:00',2.65),('16100','2013-11-06','08:30:00',2.78),('16100','2013-11-06','08:35:00',2.94),('16100','2013-11-06','08:40:00',3.1),('16100','2013-11-06','08:45:00',3.24),('16100','2013-11-06','08:50:00',3.36),('16100','2013-11-06','08:55:00',3.49),('16100','2013-11-06','09:00:00',3.63),('16100','2013-11-06','09:05:00',3.74),('16100','2013-11-06','09:10:00',3.88),('16100','2013-11-06','09:15:00',4),('16100','2013-11-06','09:20:00',4.11),('16100','2013-11-06','09:25:00',4.2),('16100','2013-11-06','09:30:00',4.32),('16100','2013-11-06','09:35:00',4.42),('16100','2013-11-06','09:40:00',4.54),('16100','2013-11-06','09:45:00',4.67),('16100','2013-11-06','09:50:00',4.77),('16100','2013-11-06','09:55:00',4.89),('16100','2013-11-06','10:00:00',4.98),('16100','2013-11-06','10:05:00',5.09),('16100','2013-11-06','10:10:00',5.14),('16100','2013-11-06','10:15:00',5.22),('16100','2013-11-06','10:20:00',5.29),('16100','2013-11-06','10:25:00',5.37),('16100','2013-11-06','10:30:00',5.44),('16100','2013-11-06','10:35:00',5.46),('16100','2013-11-06','10:40:00',5.51),('16100','2013-11-06','10:45:00',5.55),('16100','2013-11-06','10:50:00',5.57),('16100','2013-11-06','10:55:00',5.58),('16100','2013-11-06','11:00:00',5.6),('16100','2013-11-06','11:05:00',5.62),('16100','2013-11-06','11:10:00',5.65),('16100','2013-11-06','11:15:00',5.66),('16100','2013-11-06','11:20:00',5.68),('16100','2013-11-06','11:25:00',5.67),('16100','2013-11-06','11:30:00',5.66),('16100','2013-11-06','11:35:00',5.69),('16100','2013-11-06','11:40:00',5.72),('16100','2013-11-06','11:45:00',5.68),('16100','2013-11-06','11:50:00',5.69),('16100','2013-11-06','11:55:00',5.61),('16100','2013-11-06','12:00:00',5.63),('16100','2013-11-06','12:05:00',5.64),('16100','2013-11-06','12:10:00',5.7),('16100','2013-11-06','12:15:00',5.76),('16100','2013-11-06','12:20:00',4.99),('16100','2013-11-06','12:25:00',1.99),('16100','2013-11-06','12:30:00',2.34),('16100','2013-11-06','12:35:00',3.85),('16100','2013-11-06','12:40:00',6.12),('16100','2013-11-06','12:45:00',4.5),('16100','2013-11-06','12:50:00',2.15),('16100','2013-11-06','12:55:00',4.03),('16100','2013-11-06','13:00:00',4.3),('16100','2013-11-06','13:05:00',4.1),('16100','2013-11-06','13:10:00',1.68),('16100','2013-11-06','13:15:00',2.99),('16100','2013-11-06','13:20:00',5.53),('16100','2013-11-06','13:25:00',5.42),('16100','2013-11-06','13:30:00',5.32),('16100','2013-11-06','13:35:00',5.09),('16100','2013-11-06','13:40:00',4.56),('16100','2013-11-06','13:45:00',4.82),('16100','2013-11-06','13:50:00',4.75),('16100','2013-11-06','13:55:00',4.84),('16100','2013-11-06','14:00:00',4.72),('16100','2013-11-06','14:05:00',4.39),('16100','2013-11-06','14:10:00',5.11),('16100','2013-11-06','14:15:00',4.69),('16100','2013-11-06','14:20:00',4.29),('16100','2013-11-06','14:25:00',4.16),('16100','2013-11-06','14:30:00',4.04),('16100','2013-11-06','14:35:00',4.01),('16100','2013-11-06','14:40:00',3.93),('16100','2013-11-06','14:45:00',3.79),('16100','2013-11-06','14:50:00',3.63),('16100','2013-11-06','14:55:00',3.48),('16100','2013-11-06','15:00:00',3.27),('16100','2013-11-06','15:05:00',3.13),('16100','2013-11-06','15:10:00',2.96),('16100','2013-11-06','15:15:00',2.84),('16100','2013-11-06','15:20:00',2.68),('16100','2013-11-06','15:25:00',2.49),('16100','2013-11-06','15:30:00',2.34),('16100','2013-11-06','15:35:00',2.18),('16100','2013-11-06','15:40:00',2.02),('16100','2013-11-06','15:45:00',1.85),('16100','2013-11-06','15:50:00',1.65),('16100','2013-11-06','15:55:00',1.47),('16100','2013-11-06','16:00:00',1.3),('16100','2013-11-06','16:05:00',1.13),('16100','2013-11-05','08:00:00',1.64),('16100','2013-11-05','08:05:00',1.28),('16100','2013-11-05','08:10:00',2.28),('16100','2013-11-05','08:15:00',2.58),('16100','2013-11-05','08:20:00',1.63),('16100','2013-11-05','08:30:00',1.74),('16100','2013-11-05','08:35:00',3.15),('16100','2013-11-05','08:40:00',3.28),('16100','2013-11-05','08:45:00',3.42),('16100','2013-11-05','08:50:00',3.67),('16100','2013-11-05','08:55:00',2.7),('16100','2013-11-05','09:00:00',2.6),('16100','2013-11-05','09:05:00',2.79),('16100','2013-11-05','09:10:00',3.61),('16100','2013-11-05','09:15:00',3.93),('16100','2013-11-05','09:20:00',4.16),('16100','2013-11-05','09:25:00',4.44),('16100','2013-11-05','09:30:00',4.49),('16100','2013-11-05','09:35:00',4.59),('16100','2013-11-05','09:40:00',4.7),('16100','2013-11-05','09:45:00',4.83),('16100','2013-11-05','09:50:00',4.94),('16100','2013-11-05','09:55:00',5.04),('16100','2013-11-05','10:00:00',5.09),('16100','2013-11-05','10:05:00',5.16),('16100','2013-11-05','10:10:00',5.23),('16100','2013-11-05','10:15:00',5.32),('16100','2013-11-05','10:20:00',5.36),('16100','2013-11-05','10:25:00',5.39),('16100','2013-11-05','10:30:00',5.48),('16100','2013-11-05','10:35:00',5.63),('16100','2013-11-05','10:40:00',5.7),('16100','2013-11-05','10:45:00',5.75),('16100','2013-11-05','10:50:00',5.8),('16100','2013-11-05','10:55:00',5.86),('16100','2013-11-05','11:00:00',5.86),('16100','2013-11-05','11:05:00',5.89),('16100','2013-11-05','11:10:00',5.92),('16100','2013-11-05','11:15:00',5.92),('16100','2013-11-05','11:20:00',5.96),('16100','2013-11-05','11:25:00',6.01),('16100','2013-11-05','11:30:00',6.05),('16100','2013-11-05','11:35:00',6.07),('16100','2013-11-05','11:40:00',6.08),('16100','2013-11-05','11:45:00',6.11),('16100','2013-11-05','11:50:00',6.1),('16100','2013-11-05','11:55:00',6.13),('16100','2013-11-05','12:00:00',6.12),('16100','2013-11-05','12:05:00',6.07),('16100','2013-11-05','12:10:00',6.03),('16100','2013-11-05','12:15:00',6.03),('16100','2013-11-05','12:20:00',6.03),('16100','2013-11-05','12:25:00',6.02),('16100','2013-11-05','12:30:00',5.98),('16100','2013-11-05','12:35:00',6.02),('16100','2013-11-05','12:40:00',5.89),('16100','2013-11-05','12:45:00',5.83),('16100','2013-11-05','12:50:00',5.87),('16100','2013-11-05','12:55:00',5.78),('16100','2013-11-05','13:00:00',5.73),('16100','2013-11-05','13:05:00',5.75),('16100','2013-11-05','13:10:00',5.68),('16100','2013-11-05','13:15:00',5.55),('16100','2013-11-05','13:20:00',5.49),('16100','2013-11-05','13:25:00',5.43),('16100','2013-11-05','13:30:00',5.38),('16100','2013-11-05','13:35:00',5.26),('16100','2013-11-05','13:40:00',5.14),('16100','2013-11-05','13:45:00',5.06),('16100','2013-11-05','13:50:00',4.99),('16100','2013-11-05','13:55:00',4.91),('16100','2013-11-05','14:00:00',4.84),('16100','2013-11-05','14:05:00',4.71),('16100','2013-11-05','14:10:00',4.61),('16100','2013-11-05','14:15:00',4.53),('16100','2013-11-05','14:20:00',4.4),('16100','2013-11-05','14:25:00',4.31),('16100','2013-11-05','14:30:00',4.2),('16100','2013-11-05','14:35:00',4.09),('16100','2013-11-05','14:40:00',3.98),('16100','2013-11-05','14:45:00',3.82),('16100','2013-11-05','14:50:00',3.68),('16100','2013-11-05','14:55:00',3.55),('16100','2013-11-05','15:00:00',3.38),('16100','2013-11-05','15:05:00',3.2),('16100','2013-11-05','15:10:00',3.06),('16100','2013-11-05','15:15:00',2.9),('16100','2013-11-05','15:20:00',2.73),('16100','2013-11-05','15:25:00',2.57),('16100','2013-11-05','15:30:00',2.44),('16100','2013-11-05','15:35:00',2.28),('16100','2013-11-05','15:40:00',2.11),('16100','2013-11-05','15:45:00',1.94),('16100','2013-11-05','15:50:00',1.77),('16100','2013-11-05','15:55:00',1.6),('16100','2013-11-05','16:00:00',1.45),('16100','2013-11-05','16:05:00',1.28),('16100','2013-11-05','16:10:00',1.1),('16100','2013-11-04','08:30:00',1.31),('16100','2013-11-04','08:35:00',1.45),('16100','2013-11-04','08:40:00',1.13),('16100','2013-11-04','08:45:00',1.06),('16100','2013-11-04','08:50:00',1.1),('16100','2013-11-04','08:55:00',1.3),('16100','2013-11-04','10:10:00',1.06),('16100','2013-11-04','10:15:00',1.35),('16100','2013-11-04','10:20:00',1.73),('16100','2013-11-04','10:25:00',2),('16100','2013-11-04','10:30:00',1.99),('16100','2013-11-04','10:35:00',1.84),('16100','2013-11-04','10:40:00',2.44),('16100','2013-11-04','10:45:00',2.54),('16100','2013-11-04','10:50:00',2.14),('16100','2013-11-04','10:55:00',1.34),('16100','2013-11-04','11:25:00',1.12),('16100','2013-11-04','11:30:00',1.4),('16100','2013-11-04','11:35:00',1.94),('16100','2013-11-04','11:40:00',2.62),('16100','2013-11-04','11:45:00',2.28),('16100','2013-11-04','11:50:00',1.76),('16100','2013-11-04','11:55:00',1.68),('16100','2013-11-04','12:00:00',1.77),('16100','2013-11-04','12:05:00',2.02),('16100','2013-11-04','12:10:00',1.53),('16100','2013-11-04','12:15:00',1.34),('16100','2013-11-04','12:20:00',1.62),('16100','2013-11-04','12:25:00',2.38),('16100','2013-11-04','12:30:00',1.96),('16100','2013-11-04','12:35:00',1.1),('16100','2013-11-04','12:40:00',1.06),('16100','2013-11-04','12:45:00',1.26),('16100','2013-11-04','13:15:00',1.31),('16100','2013-11-04','13:20:00',2.23),('16100','2013-11-04','13:25:00',2.53),('16100','2013-11-04','13:30:00',2.62),('16100','2013-11-04','13:35:00',4.24),('16100','2013-11-04','13:40:00',4.42),('16100','2013-11-04','13:45:00',3.8),('16100','2013-11-04','13:50:00',5.11),('16100','2013-11-04','13:55:00',5.35),('16100','2013-11-04','14:00:00',5.61),('16100','2013-11-04','14:05:00',5.19),('16100','2013-11-04','14:10:00',5.17),('16100','2013-11-04','14:15:00',1.79),('16100','2013-11-04','14:20:00',2.74),('16100','2013-11-04','14:25:00',4.77),('16100','2013-11-04','14:30:00',5.14),('16100','2013-11-04','14:35:00',3.65),('16100','2013-11-04','14:40:00',3.98),('16100','2013-11-04','14:45:00',4.02),('16100','2013-11-04','14:50:00',3.08),('16100','2013-11-04','14:55:00',3.09),('16100','2013-11-04','15:05:00',1.52),('16100','2013-11-04','15:30:00',1.7),('16100','2013-11-04','15:35:00',1.94),('16100','2013-11-04','15:40:00',2.31),('16100','2013-11-04','15:45:00',2.31),('16100','2013-11-04','15:50:00',1.91),('16100','2013-11-04','15:55:00',1.58),('16100','2013-11-04','16:00:00',1.9),('16100','2013-11-04','16:05:00',1.71),('16100','2013-11-04','16:15:00',1.05),('16100','2013-11-03','07:50:00',1.36),('16100','2013-11-03','07:55:00',1.59),('16100','2013-11-03','08:00:00',1.76),('16100','2013-11-03','08:05:00',1.93),('16100','2013-11-03','08:10:00',2.06),('16100','2013-11-03','08:15:00',2.22),('16100','2013-11-03','08:20:00',2.38),('16100','2013-11-03','08:25:00',2.59),('16100','2013-11-03','08:30:00',2.78),('16100','2013-11-03','08:35:00',3.04),('16100','2013-11-03','08:40:00',1.44),('16100','2013-11-03','08:45:00',1.08),('16100','2013-11-03','08:50:00',2.67),('16100','2013-11-03','08:55:00',3.63),('16100','2013-11-03','09:00:00',3.61),('16100','2013-11-03','09:05:00',3.9),('16100','2013-11-03','09:10:00',3.95),('16100','2013-11-03','09:15:00',4.39),('16100','2013-11-03','09:20:00',3.95),('16100','2013-11-03','09:25:00',3.85),('16100','2013-11-03','09:30:00',4.51),('16100','2013-11-03','09:35:00',4.57),('16100','2013-11-03','09:40:00',4.69),('16100','2013-11-03','09:45:00',4.7),('16100','2013-11-03','09:50:00',4.94),('16100','2013-11-03','09:55:00',3.17),('16100','2013-11-03','10:15:00',1.22),('16100','2013-11-03','10:20:00',1.68),('16100','2013-11-03','10:55:00',1.62),('16100','2013-11-03','11:10:00',1.14),('16100','2013-11-03','11:50:00',1.53),('16100','2013-11-03','11:55:00',2.71),('16100','2013-11-03','12:00:00',1.09),('16100','2013-11-03','12:05:00',3.2),('16100','2013-11-03','12:10:00',1.74),('16100','2013-11-03','12:15:00',3.48),('16100','2013-11-03','12:20:00',5.61),('16100','2013-11-03','12:25:00',6.33),('16100','2013-11-03','12:30:00',6.41),('16100','2013-11-03','12:35:00',6.23),('16100','2013-11-03','12:40:00',6.37),('16100','2013-11-03','12:45:00',4.61),('16100','2013-11-03','12:50:00',4.9),('16100','2013-11-03','12:55:00',4.29),('16100','2013-11-03','13:00:00',5.16),('16100','2013-11-03','13:05:00',5.07),('16100','2013-11-03','13:10:00',3.19),('16100','2013-11-03','13:15:00',4.55),('16100','2013-11-03','13:20:00',5.81),('16100','2013-11-03','13:25:00',2.67),('16100','2013-11-03','13:30:00',3.31),('16100','2013-11-03','13:35:00',2.55),('16100','2013-11-03','13:40:00',2.44),('16100','2013-11-03','13:45:00',1.87),('16100','2013-11-03','13:50:00',3.77),('16100','2013-11-03','13:55:00',1.08),('16100','2013-11-03','14:00:00',1.25),('16100','2013-11-03','14:05:00',1.71),('16100','2013-11-03','14:10:00',3),('16100','2013-11-03','14:15:00',2.11),('16100','2013-11-03','14:20:00',2.58),('16100','2013-11-03','14:25:00',3.94),('16100','2013-11-03','14:30:00',3.27),('16100','2013-11-03','14:35:00',1.11),('16100','2013-11-03','14:40:00',2.07),('16100','2013-11-03','14:45:00',4.15),('16100','2013-11-03','14:50:00',3.12),('16100','2013-11-03','14:55:00',3.88),('16100','2013-11-03','15:00:00',3.4),('16100','2013-11-03','15:05:00',2.18),('16100','2013-11-03','15:10:00',2.88),('16100','2013-11-03','15:15:00',3.14),('16100','2013-11-03','15:20:00',2.85),('16100','2013-11-03','15:25:00',2.62),('16100','2013-11-03','15:30:00',2.46),('16100','2013-11-03','15:35:00',1.16),('16100','2013-11-02','07:30:00',1.16),('16100','2013-11-02','07:35:00',1.35),('16100','2013-11-02','07:40:00',1.52),('16100','2013-11-02','07:45:00',1.66),('16100','2013-11-02','07:50:00',1.47),('16100','2013-11-02','07:55:00',1.37),('16100','2013-11-02','08:05:00',1.61),('16100','2013-11-02','08:10:00',1.39),('16100','2013-11-02','08:15:00',1.97),('16100','2013-11-02','08:20:00',1.61),('16100','2013-11-02','08:25:00',1.95),('16100','2013-11-02','08:30:00',2.4),('16100','2013-11-02','08:35:00',2.88),('16100','2013-11-02','08:40:00',3.26),('16100','2013-11-02','08:50:00',3.52),('16100','2013-11-02','08:55:00',1.93),('16100','2013-11-02','09:00:00',3.31),('16100','2013-11-02','09:05:00',2.49),('16100','2013-11-02','09:10:00',2.29),('16100','2013-11-02','09:15:00',2.77),('16100','2013-11-02','09:20:00',2.53),('16100','2013-11-02','09:25:00',2.63),('16100','2013-11-02','09:30:00',3.95),('16100','2013-11-02','09:35:00',4.61),('16100','2013-11-02','09:40:00',1.63),('16100','2013-11-02','09:50:00',1.11),('16100','2013-11-02','10:00:00',2.18),('16100','2013-11-02','10:05:00',1.39),('16100','2013-11-02','10:10:00',3.18),('16100','2013-11-02','10:15:00',5.21),('16100','2013-11-02','10:20:00',5.42),('16100','2013-11-02','10:25:00',5.68),('16100','2013-11-02','10:30:00',5.43),('16100','2013-11-02','10:35:00',6.06),('16100','2013-11-02','10:40:00',5.73),('16100','2013-11-02','10:45:00',4.34),('16100','2013-11-02','11:05:00',1.73),('16100','2013-11-02','11:10:00',4.68),('16100','2013-11-02','11:15:00',6.35),('16100','2013-11-02','11:20:00',5.77),('16100','2013-11-02','11:25:00',3.79),('16100','2013-11-02','11:30:00',4.76),('16100','2013-11-02','11:35:00',6.76),('16100','2013-11-02','11:40:00',6.64),('16100','2013-11-02','11:45:00',5.18),('16100','2013-11-02','11:50:00',5.09),('16100','2013-11-02','11:55:00',4.25),('16100','2013-11-02','12:00:00',3.63),('16100','2013-11-02','12:05:00',3.22),('16100','2013-11-02','12:10:00',1.43),('16100','2013-11-02','12:15:00',3.32),('16100','2013-11-02','12:20:00',4.67),('16100','2013-11-02','12:25:00',2.75),('16100','2013-11-02','12:30:00',1.37),('16100','2013-11-02','12:40:00',1.51),('16100','2013-11-02','12:45:00',1.73),('16100','2013-11-02','12:50:00',1.85),('16100','2013-11-02','12:55:00',1.78),('16100','2013-11-02','13:00:00',1.72),('16100','2013-11-02','13:05:00',1.7),('16100','2013-11-02','13:10:00',1.78),('16100','2013-11-02','13:15:00',1.74),('16100','2013-11-02','13:20:00',1.81),('16100','2013-11-02','13:25:00',2.63),('16100','2013-11-02','13:30:00',1.5),('16100','2013-11-02','13:35:00',1.32),('16100','2013-11-02','13:40:00',1.55),('16100','2013-11-02','13:45:00',2.05),('16100','2013-11-02','13:50:00',2.14),('16100','2013-11-02','13:55:00',2.14),('16100','2013-11-02','14:00:00',2.6),('16100','2013-11-02','14:05:00',4.14),('16100','2013-11-02','14:10:00',2.23),('16100','2013-11-02','14:15:00',3.01),('16100','2013-11-02','14:20:00',2.82),('16100','2013-11-02','14:25:00',3.69),('16100','2013-11-02','14:30:00',3.3),('16100','2013-11-02','14:35:00',1.72),('16100','2013-11-02','14:40:00',2.13),('16100','2013-11-02','14:45:00',1.32),('16100','2013-11-02','14:50:00',1.07),('16100','2013-11-02','14:55:00',2.2),('16100','2013-11-02','15:10:00',1.06),('16100','2013-11-02','15:15:00',1.54),('16100','2013-11-02','15:25:00',1.89),('16100','2013-11-02','15:30:00',1.82),('16100','2013-11-02','15:35:00',1.66),('16100','2013-11-02','15:40:00',1.08),('16100','2013-11-02','15:50:00',1.04),('16100','2013-11-01','07:45:00',1.07),('16100','2013-11-01','07:50:00',1.24),('16100','2013-11-01','07:55:00',1.43),('16100','2013-11-01','08:00:00',1.6),('16100','2013-11-01','08:05:00',1.79),('16100','2013-11-01','08:10:00',1.97),('16100','2013-11-01','08:15:00',2.12),('16100','2013-11-01','08:20:00',2.32),('16100','2013-11-01','08:25:00',2.47),('16100','2013-11-01','08:30:00',2.64),('16100','2013-11-01','08:35:00',2.83),('16100','2013-11-01','08:40:00',2.97),('16100','2013-11-01','08:45:00',3.15),('16100','2013-11-01','08:50:00',3.3),('16100','2013-11-01','08:55:00',3.54),('16100','2013-11-01','09:00:00',3.74),('16100','2013-11-01','09:05:00',3.14),('16100','2013-11-01','09:10:00',2.53),('16100','2013-11-01','09:15:00',4.12),('16100','2013-11-01','09:20:00',3.36),('16100','2013-11-01','09:25:00',4.03),('16100','2013-11-01','09:30:00',4.28),('16100','2013-11-01','09:35:00',4.35),('16100','2013-11-01','09:40:00',4.42),('16100','2013-11-01','09:45:00',4.69),('16100','2013-11-01','09:50:00',4.08),('16100','2013-11-01','09:55:00',4.5),('16100','2013-11-01','10:00:00',2.87),('16100','2013-11-01','10:05:00',3.01),('16100','2013-11-01','10:10:00',2.07),('16100','2013-11-01','10:15:00',1.47),('16100','2013-11-01','10:20:00',1.29),('16100','2013-11-01','10:25:00',1.08),('16100','2013-11-01','10:50:00',1.16),('16100','2013-11-01','10:55:00',1.67),('16100','2013-11-01','11:00:00',2.21),('16100','2013-11-01','11:05:00',2.79),('16100','2013-11-01','11:10:00',3.96),('16100','2013-11-01','11:15:00',1.59),('16100','2013-11-01','11:20:00',3.39),('16100','2013-11-01','11:25:00',7.13),('16100','2013-11-01','11:30:00',7.22),('16100','2013-11-01','11:35:00',6.49),('16100','2013-11-01','11:40:00',6.7),('16100','2013-11-01','11:45:00',6.68),('16100','2013-11-01','11:50:00',6.65),('16100','2013-11-01','11:55:00',6.53),('16100','2013-11-01','12:00:00',6.35),('16100','2013-11-01','12:05:00',5.22),('16100','2013-11-01','12:10:00',7.11),('16100','2013-11-01','12:15:00',4.52),('16100','2013-11-01','12:20:00',2.22),('16100','2013-11-01','12:25:00',1.97),('16100','2013-11-01','12:30:00',2.84),('16100','2013-11-01','12:35:00',2.83),('16100','2013-11-01','12:40:00',6.14),('16100','2013-11-01','12:45:00',2.7),('16100','2013-11-01','12:50:00',2.27),('16100','2013-11-01','12:55:00',4.59),('16100','2013-11-01','13:00:00',2.74),('16100','2013-11-01','13:05:00',3.61),('16100','2013-11-01','13:10:00',4.23),('16100','2013-11-01','13:15:00',6.9),('16100','2013-11-01','13:20:00',4.62),('16100','2013-11-01','13:25:00',1.75),('16100','2013-11-01','13:30:00',1.62),('16100','2013-11-01','13:35:00',2.2),('16100','2013-11-01','13:40:00',2.52),('16100','2013-11-01','13:45:00',5.34),('16100','2013-11-01','13:50:00',6.35),('16100','2013-11-01','13:55:00',5.72),('16100','2013-11-01','14:00:00',5.36),('16100','2013-11-01','14:05:00',4.9),('16100','2013-11-01','14:10:00',4.66),('16100','2013-11-01','14:15:00',4.59),('16100','2013-11-01','14:20:00',4.45),('16100','2013-11-01','14:25:00',4.51),('16100','2013-11-01','14:30:00',3.89),('16100','2013-11-01','14:35:00',4.18),('16100','2013-11-01','14:40:00',4.13),('16100','2013-11-01','14:45:00',3.53),('16100','2013-11-01','14:50:00',3.83),('16100','2013-11-01','14:55:00',3.07),('16100','2013-11-01','15:00:00',4.07),('16100','2013-11-01','15:05:00',3.09),('16100','2013-11-01','15:10:00',2.73),('16100','2013-11-01','15:15:00',1.4),('16100','2013-11-01','15:20:00',2.41),('16100','2013-11-01','15:25:00',2.26),('16100','2013-11-01','15:45:00',1.74),('16100','2013-11-01','15:50:00',2.03),('16100','2013-11-01','15:55:00',1.48),('16100','2013-11-01','16:00:00',1.09),('16100','2013-11-01','16:10:00',1.07),('16100','2013-11-01','16:15:00',1.01),('16100','2013-10-31','07:40:00',1.12),('16100','2013-10-31','07:45:00',1.28),('16100','2013-10-31','07:50:00',1.39),('16100','2013-10-31','07:55:00',1.51),('16100','2013-10-31','08:00:00',1.64),('16100','2013-10-31','08:05:00',1.62),('16100','2013-10-31','08:10:00',1.23),('16100','2013-10-31','08:15:00',1.43),('16100','2013-10-31','08:20:00',1.73),('16100','2013-10-31','08:25:00',2.1),('16100','2013-10-31','08:30:00',2.5),('16100','2013-10-31','08:35:00',2.72),('16100','2013-10-31','08:40:00',2.71),('16100','2013-10-31','08:45:00',2.49),('16100','2013-10-31','08:50:00',2.52),('16100','2013-10-31','08:55:00',2.74),('16100','2013-10-31','09:00:00',2.75),('16100','2013-10-31','09:05:00',3.5),('16100','2013-10-31','09:10:00',3.76),('16100','2013-10-31','09:15:00',3.86),('16100','2013-10-31','09:20:00',3.95),('16100','2013-10-31','09:25:00',4.07),('16100','2013-10-31','09:30:00',4.23),('16100','2013-10-31','09:35:00',4.37),('16100','2013-10-31','09:40:00',4.51),('16100','2013-10-31','09:45:00',4.64),('16100','2013-10-31','09:50:00',4.75),('16100','2013-10-31','09:55:00',4.91),('16100','2013-10-31','10:00:00',5.06),('16100','2013-10-31','10:05:00',5.19),('16100','2013-10-31','10:10:00',5.32),('16100','2013-10-31','10:15:00',5.38),('16100','2013-10-31','10:20:00',5.45),('16100','2013-10-31','10:25:00',5.53),('16100','2013-10-31','10:30:00',5.57),('16100','2013-10-31','10:35:00',5.69),('16100','2013-10-31','10:40:00',5.73),('16100','2013-10-31','10:45:00',5.73),('16100','2013-10-31','10:50:00',5.59),('16100','2013-10-31','10:55:00',5.74),('16100','2013-10-31','11:00:00',5.76),('16100','2013-10-31','11:05:00',5.83),('16100','2013-10-31','11:10:00',5.34),('16100','2013-10-31','11:15:00',4.76),('16100','2013-10-31','11:20:00',4.92),('16100','2013-10-31','11:25:00',4.72),('16100','2013-10-31','11:30:00',5.46),('16100','2013-10-31','11:35:00',6.09),('16100','2013-10-31','11:40:00',5.92),('16100','2013-10-31','11:45:00',5.52),('16100','2013-10-31','11:50:00',5.6),('16100','2013-10-31','11:55:00',6.06),('16100','2013-10-31','12:00:00',6.17),('16100','2013-10-31','12:05:00',6.05),('16100','2013-10-31','12:10:00',6.09),('16100','2013-10-31','12:15:00',5.22),('16100','2013-10-31','12:20:00',4.3),('16100','2013-10-31','12:25:00',4.99),('16100','2013-10-31','12:30:00',4.25),('16100','2013-10-31','12:35:00',3.6),('16100','2013-10-31','12:40:00',1.77),('16100','2013-10-31','12:45:00',1.84),('16100','2013-10-31','12:50:00',1.88),('16100','2013-10-31','12:55:00',2.71),('16100','2013-10-31','13:00:00',3.73),('16100','2013-10-31','13:05:00',4.78),('16100','2013-10-31','13:10:00',4.71),('16100','2013-10-31','13:15:00',4.03),('16100','2013-10-31','13:20:00',3.27),('16100','2013-10-31','13:25:00',1.84),('16100','2013-10-31','13:30:00',1.53),('16100','2013-10-31','13:35:00',1.69),('16100','2013-10-31','13:40:00',1.81),('16100','2013-10-31','13:45:00',1.25),('16100','2013-10-31','13:50:00',1.06),('16100','2013-10-31','13:55:00',1.21),('16100','2013-10-31','14:00:00',1.32),('16100','2013-10-31','14:05:00',1.65),('16100','2013-10-31','14:10:00',1.64),('16100','2013-10-31','14:15:00',1.52),('16100','2013-10-31','14:20:00',1.37),('16100','2013-10-31','14:25:00',1.15),('16100','2013-10-30','08:20:00',2.29),('16100','2013-10-30','08:25:00',1.82),('16100','2013-10-30','08:30:00',2.6),('16100','2013-10-30','08:35:00',2.67),('16100','2013-10-30','08:40:00',1.94),('16100','2013-10-30','08:45:00',1.75),('16100','2013-10-30','08:50:00',1.39),('16100','2013-10-30','08:55:00',1.87),('16100','2013-10-30','09:00:00',2.6),('16100','2013-10-30','09:05:00',3.04),('16100','2013-10-30','09:10:00',3.6),('16100','2013-10-30','09:15:00',3.92),('16100','2013-10-30','09:20:00',3.65),('16100','2013-10-30','09:25:00',2.98),('16100','2013-10-30','09:30:00',2.96),('16100','2013-10-30','09:35:00',3.63),('16100','2013-10-30','09:40:00',3.55),('16100','2013-10-30','09:45:00',3.65),('16100','2013-10-30','09:50:00',3.81),('16100','2013-10-30','09:55:00',4.16),('16100','2013-10-30','10:00:00',4.32),('16100','2013-10-30','10:05:00',4.52),('16100','2013-10-30','10:10:00',4.49),('16100','2013-10-30','10:15:00',4.61),('16100','2013-10-30','10:20:00',4.83),('16100','2013-10-30','10:25:00',4.76),('16100','2013-10-30','10:30:00',4.61),('16100','2013-10-30','10:35:00',4.43),('16100','2013-10-30','10:40:00',4.5),('16100','2013-10-30','10:45:00',4.17),('16100','2013-10-30','10:50:00',4.88),('16100','2013-10-30','10:55:00',4.67),('16100','2013-10-30','11:00:00',4.71),('16100','2013-10-30','11:05:00',4.59),('16100','2013-10-30','11:10:00',5.02),('16100','2013-10-30','11:15:00',4.72),('16100','2013-10-30','11:20:00',5.16),('16100','2013-10-30','11:25:00',5.33),('16100','2013-10-30','11:30:00',4.88),('16100','2013-10-30','11:35:00',4.42),('16100','2013-10-30','11:40:00',3.1),('16100','2013-10-30','11:45:00',4.43),('16100','2013-10-30','11:50:00',5.48),('16100','2013-10-30','11:55:00',5.8),('16100','2013-10-30','12:00:00',5.8),('16100','2013-10-30','12:05:00',5.82),('16100','2013-10-30','12:10:00',5.81),('16100','2013-10-30','12:15:00',5.76),('16100','2013-10-30','12:20:00',5.51),('16100','2013-10-30','12:25:00',5.52),('16100','2013-10-30','12:30:00',5.48),('16100','2013-10-30','12:35:00',5.32),('16100','2013-10-30','12:40:00',5.22),('16100','2013-10-30','12:45:00',5.43),('16100','2013-10-30','12:50:00',5.54),('16100','2013-10-30','12:55:00',5.62),('16100','2013-10-30','13:00:00',5.57),('16100','2013-10-30','13:05:00',5.6),('16100','2013-10-30','13:10:00',5.47),('16100','2013-10-30','13:15:00',5.32),('16100','2013-10-30','13:20:00',5.13),('16100','2013-10-30','13:25:00',5.09),('16100','2013-10-30','13:30:00',5.04),('16100','2013-10-30','13:35:00',4.89),('16100','2013-10-30','13:40:00',4.75),('16100','2013-10-30','13:45:00',4.54),('16100','2013-10-30','13:50:00',4.59),('16100','2013-10-30','13:55:00',4.51),('16100','2013-10-30','14:00:00',4.19),('16100','2013-10-30','14:05:00',3.7),('16100','2013-10-30','14:10:00',3.41),('16100','2013-10-30','14:15:00',1.99),('16100','2013-10-30','14:20:00',4.07),('16100','2013-10-30','14:25:00',2.14),('16100','2013-10-30','14:30:00',2.32),('16100','2013-10-30','14:35:00',1.93),('16100','2013-10-30','14:40:00',3.11),('16100','2013-10-30','14:45:00',3.02),('16100','2013-10-30','14:50:00',2.91),('16100','2013-10-30','14:55:00',2.94),('16100','2013-10-30','15:00:00',2.47),('16100','2013-10-30','15:05:00',2.48),('16100','2013-10-30','15:10:00',2.36),('16100','2013-10-30','15:15:00',2.17),('16100','2013-10-30','15:20:00',2.14),('16100','2013-10-30','15:25:00',1.93),('16100','2013-10-30','15:30:00',1.79),('16100','2013-10-30','15:35:00',1.67),('16100','2013-10-30','15:40:00',1.54),('16100','2013-10-30','15:45:00',1.37),('16100','2013-10-30','15:50:00',1.39),('16100','2013-10-30','15:55:00',1.17),('16100','2013-10-29','07:50:00',1.16),('16100','2013-10-29','07:55:00',1.31),('16100','2013-10-29','08:00:00',1.45),('16100','2013-10-29','08:05:00',1.62),('16100','2013-10-29','08:10:00',1.78),('16100','2013-10-29','08:15:00',1.89),('16100','2013-10-29','08:20:00',2.06),('16100','2013-10-29','08:25:00',2.18),('16100','2013-10-29','08:30:00',2.38),('16100','2013-10-29','08:35:00',2.55),('16100','2013-10-29','08:40:00',2.68),('16100','2013-10-29','08:45:00',2.91),('16100','2013-10-29','08:50:00',2.93),('16100','2013-10-29','08:55:00',2.98),('16100','2013-10-29','09:00:00',3.18),('16100','2013-10-29','09:05:00',3.47),('16100','2013-10-29','09:10:00',3.62),('16100','2013-10-29','09:15:00',3.7),('16100','2013-10-29','09:20:00',3.76),('16100','2013-10-29','09:25:00',3.96),('16100','2013-10-29','09:30:00',4.11),('16100','2013-10-29','09:35:00',4.11),('16100','2013-10-29','09:40:00',3.91),('16100','2013-10-29','09:45:00',3.84),('16100','2013-10-29','09:50:00',3.93),('16100','2013-10-29','09:55:00',4.45),('16100','2013-10-29','10:00:00',4.14),('16100','2013-10-29','10:05:00',4.58),('16100','2013-10-29','10:10:00',4.24),('16100','2013-10-29','10:15:00',3.87),('16100','2013-10-29','10:20:00',4.31),('16100','2013-10-29','10:25:00',4.67),('16100','2013-10-29','10:30:00',4.88),('16100','2013-10-29','10:35:00',4.88),('16100','2013-10-29','10:40:00',4.74),('16100','2013-10-29','10:45:00',4.12),('16100','2013-10-29','10:50:00',4.82),('16100','2013-10-29','10:55:00',5.27),('16100','2013-10-29','11:00:00',5.23),('16100','2013-10-29','11:05:00',4.98),('16100','2013-10-29','11:10:00',5.42),('16100','2013-10-29','11:15:00',5.23),('16100','2013-10-29','11:20:00',5.1),('16100','2013-10-29','11:25:00',5.24),('16100','2013-10-29','11:30:00',3.6),('16100','2013-10-29','11:35:00',3.84),('16100','2013-10-29','11:40:00',3.42),('16100','2013-10-29','11:45:00',4.31),('16100','2013-10-29','11:50:00',3.8),('16100','2013-10-29','11:55:00',2.62),('16100','2013-10-29','12:00:00',4.49),('16100','2013-10-29','12:05:00',4.67),('16100','2013-10-29','12:10:00',4.95),('16100','2013-10-29','12:15:00',5.37),('16100','2013-10-29','12:20:00',4.31),('16100','2013-10-29','12:25:00',1.83),('16100','2013-10-29','12:30:00',1.29),('16100','2013-10-29','12:35:00',1.21),('16100','2013-10-29','12:40:00',1.69),('16100','2013-10-29','12:45:00',4.29),('16100','2013-10-29','12:50:00',4.69),('16100','2013-10-29','12:55:00',3.1),('16100','2013-10-29','13:00:00',2.95),('16100','2013-10-29','13:05:00',3.03),('16100','2013-10-29','13:10:00',1.33),('16100','2013-10-29','13:15:00',1.2),('16100','2013-10-29','13:20:00',1.44),('16100','2013-10-29','13:25:00',4.49),('16100','2013-10-29','13:30:00',3.13),('16100','2013-10-29','13:35:00',4.5),('16100','2013-10-29','13:40:00',4.84),('16100','2013-10-29','13:45:00',3.61),('16100','2013-10-29','13:50:00',1.42),('16100','2013-10-29','13:55:00',1.07),('16100','2013-10-29','14:00:00',1.25),('16100','2013-10-29','14:05:00',3.27),('16100','2013-10-29','14:10:00',2.77),('16100','2013-10-29','14:15:00',3.05),('16100','2013-10-29','14:20:00',3.15),('16100','2013-10-29','14:25:00',4.13),('16100','2013-10-29','14:30:00',1.02),('16100','2013-10-29','14:35:00',1.15),('16100','2013-10-29','14:40:00',1.35),('16100','2013-10-29','15:05:00',2.33),('16100','2013-10-29','15:10:00',1.75),('16100','2013-10-29','15:15:00',2.43),('16100','2013-10-29','15:25:00',2.05),('16100','2013-10-29','15:30:00',1.31),('16100','2013-10-29','15:50:00',1.39),('16100','2013-10-29','15:55:00',1.24),('16100','2013-10-28','08:10:00',1.2),('16100','2013-10-28','08:15:00',1.08),('16100','2013-10-28','08:20:00',1.37),('16100','2013-10-28','08:25:00',2.25),('16100','2013-10-28','08:30:00',2.14),('16100','2013-10-28','08:35:00',2.34),('16100','2013-10-28','08:40:00',2.92),('16100','2013-10-28','08:45:00',3.08),('16100','2013-10-28','08:50:00',3.25),('16100','2013-10-28','08:55:00',3.4),('16100','2013-10-28','09:00:00',3.51),('16100','2013-10-28','09:05:00',3.61),('16100','2013-10-28','09:10:00',3.75),('16100','2013-10-28','09:15:00',3.89),('16100','2013-10-28','09:20:00',4.01),('16100','2013-10-28','09:25:00',4.05),('16100','2013-10-28','09:30:00',4.19),('16100','2013-10-28','09:35:00',4.32),('16100','2013-10-28','09:40:00',4.51),('16100','2013-10-28','09:45:00',4.67),('16100','2013-10-28','09:50:00',4.56),('16100','2013-10-28','09:55:00',4.18),('16100','2013-10-28','10:00:00',4.77),('16100','2013-10-28','10:05:00',4.88),('16100','2013-10-28','10:10:00',4.68),('16100','2013-10-28','10:15:00',3.99),('16100','2013-10-28','10:20:00',2.98),('16100','2013-10-28','10:25:00',3.24),('16100','2013-10-28','10:30:00',3.4),('16100','2013-10-28','10:35:00',4.58),('16100','2013-10-28','10:40:00',3.42),('16100','2013-10-28','10:45:00',3.86),('16100','2013-10-28','10:50:00',6.09),('16100','2013-10-28','10:55:00',6.16),('16100','2013-10-28','11:00:00',5.24),('16100','2013-10-28','11:05:00',3.54),('16100','2013-10-28','11:10:00',2.36),('16100','2013-10-28','11:15:00',2.03),('16100','2013-10-28','11:20:00',2.11),('16100','2013-10-28','11:25:00',4.27),('16100','2013-10-28','11:30:00',3.91),('16100','2013-10-28','11:35:00',2.95),('16100','2013-10-28','11:40:00',4.61),('16100','2013-10-28','11:45:00',4.21),('16100','2013-10-28','11:50:00',6.5),('16100','2013-10-28','11:55:00',5.89),('16100','2013-10-28','12:00:00',3.3),('16100','2013-10-28','12:05:00',6.01),('16100','2013-10-28','12:10:00',5.98),('16100','2013-10-28','12:15:00',5.93),('16100','2013-10-28','12:20:00',5.82),('16100','2013-10-28','12:25:00',5.78),('16100','2013-10-28','12:30:00',5.8),('16100','2013-10-28','12:35:00',5.74),('16100','2013-10-28','12:40:00',5.72),('16100','2013-10-28','12:45:00',5.67),('16100','2013-10-28','12:50:00',5.68),('16100','2013-10-28','12:55:00',5.66),('16100','2013-10-28','13:00:00',5.58),('16100','2013-10-28','13:05:00',5.17),('16100','2013-10-28','13:10:00',5.1),('16100','2013-10-28','13:15:00',5.12),('16100','2013-10-28','13:20:00',3.99),('16100','2013-10-28','13:25:00',5.05),('16100','2013-10-28','13:30:00',4.32),('16100','2013-10-28','13:35:00',5.09),('16100','2013-10-28','13:40:00',5.09),('16100','2013-10-28','13:45:00',3.91),('16100','2013-10-28','13:50:00',2.37),('16100','2013-10-28','13:55:00',4.47),('16100','2013-10-28','14:00:00',4.35),('16100','2013-10-28','14:05:00',3.95),('16100','2013-10-28','14:10:00',2.91),('16100','2013-10-28','14:15:00',4.38),('16100','2013-10-28','14:20:00',4.16),('16100','2013-10-28','14:25:00',3.75),('16100','2013-10-28','14:30:00',2.5),('16100','2013-10-28','14:35:00',3.62),('16100','2013-10-28','14:40:00',3.72),('16100','2013-10-28','14:45:00',3.65),('16100','2013-10-28','14:50:00',3.47),('16100','2013-10-28','14:55:00',3.28),('16100','2013-10-28','15:00:00',3.13),('16100','2013-10-28','15:05:00',2.95),('16100','2013-10-28','15:10:00',2.78),('16100','2013-10-28','15:15:00',2.61),('16100','2013-10-28','15:20:00',2.5),('16100','2013-10-28','15:25:00',2.34),('16100','2013-10-28','15:30:00',2.15),('16100','2013-10-28','15:35:00',2.01),('16100','2013-10-28','15:40:00',1.83),('16100','2013-10-28','15:45:00',1.66),('16100','2013-10-28','15:50:00',1.49),('16100','2013-10-28','15:55:00',1.33),('16100','2013-10-28','16:00:00',1.19),('16100','2013-10-28','16:05:00',1.04),('16100','2014-04-16','08:00:00',1.06),('16100','2014-04-16','08:05:00',1.18),('16100','2014-04-16','08:10:00',1.46),('16100','2014-04-16','08:15:00',1.6),('16100','2014-04-16','08:20:00',2.01),('16100','2014-04-16','08:25:00',2.17),('16100','2014-04-16','08:30:00',2.35),('16100','2014-04-16','08:35:00',2.56),('16100','2014-04-16','08:40:00',2.74),('16100','2014-04-16','08:45:00',2.9),('16100','2014-04-16','08:50:00',3.12),('16100','2014-04-16','08:55:00',3.33),('16100','2014-04-16','09:00:00',3.45),('16100','2014-04-16','09:05:00',3.69),('16100','2014-04-16','09:10:00',3.9),('16100','2014-04-16','09:15:00',4.05),('16100','2014-04-16','09:20:00',4.21),('16100','2014-04-16','09:25:00',4.37),('16100','2014-04-16','09:30:00',4.5),('16100','2014-04-16','09:35:00',4.65),('16100','2014-04-16','09:40:00',4.84),('16100','2014-04-16','09:45:00',4.97),('16100','2014-04-16','09:50:00',5.13),('16100','2014-04-16','09:55:00',5.27),('16100','2014-04-16','10:00:00',5.5),('16100','2014-04-16','10:05:00',4.01),('16100','2014-04-16','10:10:00',3.61),('16100','2014-04-16','10:15:00',3.55),('16100','2014-04-16','10:20:00',5.16),('16100','2014-04-16','10:25:00',6.39),('16100','2014-04-16','10:30:00',6.07),('16100','2014-04-16','10:35:00',5.58),('16100','2014-04-16','10:40:00',4.74),('16100','2014-04-16','10:45:00',4.3),('16100','2014-04-16','10:50:00',4.27),('16100','2014-04-16','10:55:00',5.32),('16100','2014-04-16','11:00:00',4.15),('16100','2014-04-16','11:05:00',5.68),('16100','2014-04-16','11:10:00',5.04),('16100','2014-04-16','11:15:00',6.53),('16100','2014-04-16','11:20:00',6.4),('16100','2014-04-16','11:25:00',4.1),('16100','2014-04-16','11:30:00',4.32),('16100','2014-04-16','11:35:00',3.89),('16100','2014-04-16','11:40:00',6.52),('16100','2014-04-16','11:45:00',6.58),('16100','2014-04-16','11:50:00',6.93),('16100','2014-04-16','11:55:00',6.34),('16100','2014-04-16','12:00:00',5.32),('16100','2014-04-16','12:05:00',3.8),('16100','2014-04-16','12:10:00',3.74),('16100','2014-04-16','12:15:00',4.41),('16100','2014-04-16','12:20:00',4.79),('16100','2014-04-16','12:25:00',6.52),('16100','2014-04-16','12:30:00',6.67),('16100','2014-04-16','12:35:00',7.67),('16100','2014-04-16','12:40:00',7.74),('16100','2014-04-16','12:45:00',7.95),('16100','2014-04-16','12:50:00',8.07),('16100','2014-04-16','12:55:00',8.05),('16100','2014-04-16','13:00:00',8),('16100','2014-04-16','13:05:00',7.95),('16100','2014-04-16','13:10:00',7.99),('16100','2014-04-16','13:15:00',8.06),('16100','2014-04-16','13:20:00',7.54),('16100','2014-04-16','13:25:00',5.81),('16100','2014-04-16','13:30:00',1.95),('16100','2014-04-16','13:35:00',2.2),('16100','2014-04-16','13:40:00',6.45),('16100','2014-04-16','13:45:00',5.47),('16100','2014-04-16','13:50:00',8.84),('16100','2014-04-16','13:55:00',9.09),('16100','2014-04-16','14:00:00',8.63),('16100','2014-04-16','14:05:00',8.61),('16100','2014-04-16','14:10:00',8.62),('16100','2014-04-16','14:15:00',8.72),('16100','2014-04-16','14:20:00',6.8),('16100','2014-04-16','14:25:00',8.11),('16100','2014-04-16','14:30:00',7.63),('16100','2014-04-16','14:35:00',6.15),('16100','2014-04-16','14:40:00',4.2),('16100','2014-04-16','14:45:00',1.97),('16100','2014-04-16','14:50:00',1.26),('16100','2014-04-16','14:55:00',1.01),('16100','2014-04-16','15:05:00',1.03),('16100','2014-04-16','15:10:00',1.28),('16100','2014-04-16','15:15:00',1.95),('16100','2014-04-16','15:20:00',2.53),('16100','2014-04-16','15:25:00',2.58),('16100','2014-04-16','15:30:00',2.68),('16100','2014-04-16','15:35:00',2.35),('16100','2014-04-16','15:40:00',1.81),('16100','2014-04-16','15:45:00',1.95),('16100','2014-04-16','15:50:00',2.04),('16100','2014-04-16','15:55:00',1.79),('16100','2014-04-16','16:00:00',1.34),('16100','2014-04-16','16:05:00',1.13),('16100','2014-04-16','16:10:00',1.12),('16100','2014-04-16','16:15:00',1.39),('16100','2014-04-16','16:20:00',1.82),('16100','2014-04-16','16:25:00',1.68),('16100','2014-04-16','16:30:00',1.69),('16100','2014-04-16','16:35:00',1.88),('16100','2014-04-16','16:40:00',2.02),('16100','2014-04-16','16:45:00',2.46),('16100','2014-04-16','16:50:00',1.99),('16100','2014-04-16','16:55:00',1.82),('16100','2014-04-16','17:00:00',1.71),('16100','2014-04-16','17:05:00',1.56),('16100','2014-04-16','17:10:00',1.57),('16100','2014-04-16','17:15:00',1.67),('16100','2014-04-16','17:20:00',1.66),('16100','2014-04-16','17:25:00',2.2),('16100','2014-04-16','17:30:00',2.39),('16100','2014-04-16','17:35:00',2.12),('16100','2014-04-16','17:40:00',1.69),('16100','2014-04-16','17:45:00',1.74),('16100','2014-04-16','17:50:00',1.07),('16100','2013-10-27','07:55:00',1.06),('16100','2013-10-27','08:00:00',1.18),('16100','2013-10-27','08:05:00',1.15),('16100','2013-10-27','08:20:00',1.04),('16100','2013-10-27','08:25:00',1.26),('16100','2013-10-27','08:30:00',1.89),('16100','2013-10-27','08:35:00',1.55),('16100','2013-10-27','08:40:00',2.7),('16100','2013-10-27','08:45:00',3.11),('16100','2013-10-27','08:50:00',2.94),('16100','2013-10-27','08:55:00',2.47),('16100','2013-10-27','09:00:00',1.19),('16100','2013-10-27','09:05:00',1.84),('16100','2013-10-27','09:10:00',2.9),('16100','2013-10-27','09:15:00',3.84),('16100','2013-10-27','09:20:00',3.71),('16100','2013-10-27','09:25:00',4.05),('16100','2013-10-27','09:30:00',4.23),('16100','2013-10-27','09:35:00',4.59),('16100','2013-10-27','09:40:00',5),('16100','2013-10-27','09:45:00',3.97),('16100','2013-10-27','09:50:00',1.59),('16100','2013-10-27','09:55:00',1.36),('16100','2013-10-27','10:00:00',1.33),('16100','2013-10-27','10:05:00',1.38),('16100','2013-10-27','10:10:00',1.51),('16100','2013-10-27','10:15:00',1.39),('16100','2013-10-27','10:20:00',1.29),('16100','2013-10-27','10:25:00',1.25),('16100','2013-10-27','10:35:00',4.96),('16100','2013-10-27','10:40:00',5.79),('16100','2013-10-27','10:45:00',5.71),('16100','2013-10-27','10:50:00',5.75),('16100','2013-10-27','10:55:00',5.77),('16100','2013-10-27','11:00:00',5.79),('16100','2013-10-27','11:05:00',5.82),('16100','2013-10-27','11:10:00',5.78),('16100','2013-10-27','11:15:00',5.84),('16100','2013-10-27','11:20:00',5.93),('16100','2013-10-27','11:25:00',5.21),('16100','2013-10-27','11:30:00',5.11),('16100','2013-10-27','11:35:00',5.83),('16100','2013-10-27','11:40:00',6),('16100','2013-10-27','11:45:00',5.97),('16100','2013-10-27','11:50:00',5.97),('16100','2013-10-27','11:55:00',6.04),('16100','2013-10-27','12:00:00',6.02),('16100','2013-10-27','12:05:00',6.07),('16100','2013-10-27','12:10:00',5.53),('16100','2013-10-27','12:15:00',4.36),('16100','2013-10-27','12:20:00',6.81),('16100','2013-10-27','12:25:00',6.3),('16100','2013-10-27','12:30:00',6.12),('16100','2013-10-27','12:35:00',5.91),('16100','2013-10-27','12:40:00',6.17),('16100','2013-10-27','12:45:00',6.11),('16100','2013-10-27','12:50:00',6),('16100','2013-10-27','12:55:00',5.93),('16100','2013-10-27','13:00:00',5.89),('16100','2013-10-27','13:05:00',5.8),('16100','2013-10-27','13:10:00',5.68),('16100','2013-10-27','13:15:00',5.66),('16100','2013-10-27','13:20:00',5.56),('16100','2013-10-27','13:25:00',5.26),('16100','2013-10-27','13:30:00',4.83),('16100','2013-10-27','13:35:00',5.45),('16100','2013-10-27','13:40:00',5.34),('16100','2013-10-27','13:45:00',5.26),('16100','2013-10-27','13:50:00',3.63),('16100','2013-10-27','13:55:00',3.97),('16100','2013-10-27','14:00:00',3.58),('16100','2013-10-27','14:05:00',4.91),('16100','2013-10-27','14:10:00',4.48),('16100','2013-10-27','14:15:00',4.92),('16100','2013-10-27','14:20:00',4.29),('16100','2013-10-27','14:25:00',4.19),('16100','2013-10-27','14:30:00',3.64),('16100','2013-10-27','14:35:00',4.01),('16100','2013-10-27','14:40:00',2.47),('16100','2013-10-27','14:45:00',3.7),('16100','2013-10-27','14:50:00',3.76),('16100','2013-10-27','14:55:00',3.64),('16100','2013-10-27','15:00:00',2.36),('16100','2013-10-27','15:05:00',1.66),('16100','2013-10-27','15:10:00',3.39),('16100','2013-10-27','15:15:00',1.7),('16100','2013-10-27','15:20:00',2.4),('16100','2013-10-27','15:25:00',1.31),('16100','2013-10-27','15:30:00',1.73),('16100','2013-10-27','15:35:00',1.63),('16100','2013-10-27','15:40:00',1.49),('16100','2013-10-27','16:05:00',1.18),('16100','2013-10-26','09:25:00',1.08),('16100','2013-10-26','09:30:00',1.36),('16100','2013-10-26','09:35:00',1.52),('16100','2013-10-26','09:40:00',1.49),('16100','2013-10-26','09:45:00',1.63),('16100','2013-10-26','09:50:00',1.58),('16100','2013-10-26','09:55:00',1.53),('16100','2013-10-26','10:00:00',1.53),('16100','2013-10-26','10:05:00',1.56),('16100','2013-10-26','10:10:00',1.6),('16100','2013-10-26','10:15:00',1.69),('16100','2013-10-26','10:20:00',1.99),('16100','2013-10-26','10:25:00',2.13),('16100','2013-10-26','10:30:00',2.25),('16100','2013-10-26','10:35:00',2.91),('16100','2013-10-26','10:40:00',2.67),('16100','2013-10-26','10:45:00',2.64),('16100','2013-10-26','10:50:00',2.15),('16100','2013-10-26','10:55:00',1.74),('16100','2013-10-26','11:00:00',1.53),('16100','2013-10-26','11:05:00',1.96),('16100','2013-10-26','11:10:00',2.27),('16100','2013-10-26','11:15:00',2.52),('16100','2013-10-26','11:20:00',2.65),('16100','2013-10-26','11:25:00',2.58),('16100','2013-10-26','11:30:00',2.46),('16100','2013-10-26','11:35:00',2.24),('16100','2013-10-26','11:40:00',2.27),('16100','2013-10-26','11:45:00',2.51),('16100','2013-10-26','11:50:00',2.33),('16100','2013-10-26','11:55:00',3.94),('16100','2013-10-26','12:00:00',5.16),('16100','2013-10-26','12:05:00',7.01),('16100','2013-10-26','12:10:00',3.74),('16100','2013-10-26','12:15:00',4.9),('16100','2013-10-26','12:20:00',3.33),('16100','2013-10-26','12:25:00',1.87),('16100','2013-10-26','12:30:00',2.8),('16100','2013-10-26','12:35:00',5.72),('16100','2013-10-26','12:40:00',6.38),('16100','2013-10-26','12:45:00',3.66),('16100','2013-10-26','12:50:00',4.11),('16100','2013-10-26','12:55:00',2.45),('16100','2013-10-26','13:00:00',1.61),('16100','2013-10-26','13:05:00',1.79),('16100','2013-10-26','13:10:00',2.41),('16100','2013-10-26','13:15:00',2.09),('16100','2013-10-26','13:20:00',3.99),('16100','2013-10-26','13:25:00',3.33),('16100','2013-10-26','13:40:00',1.26),('16100','2013-10-26','13:45:00',2.39),('16100','2013-10-26','13:50:00',2.24),('16100','2013-10-26','13:55:00',1.35),('16100','2013-10-26','14:00:00',1.39),('16100','2013-10-26','14:05:00',1.52),('16100','2013-10-26','14:10:00',1.75),('16100','2013-10-26','14:15:00',3.2),('16100','2013-10-26','14:20:00',4.25),('16100','2013-10-26','14:25:00',4.15),('16100','2013-10-26','14:30:00',3.96),('16100','2013-10-26','14:35:00',3.17),('16100','2013-10-26','14:40:00',4.11),('16100','2013-10-26','14:45:00',4.03),('16100','2013-10-26','14:50:00',2.68),('16100','2013-10-26','14:55:00',2.57),('16100','2013-10-26','15:00:00',3.05),('16100','2013-10-26','15:05:00',3.14),('16100','2013-10-26','15:10:00',2.94),('16100','2013-10-26','15:15:00',3.11),('16100','2013-10-26','15:20:00',3.12),('16100','2013-10-26','15:25:00',2.94),('16100','2013-10-26','15:30:00',2.54),('16100','2013-10-26','15:35:00',2.16),('16100','2013-10-26','15:45:00',1.63),('16100','2013-10-26','15:50:00',1.66),('16100','2013-10-26','15:55:00',1.32),('16100','2013-10-26','16:00:00',1.14),('16100','2013-10-26','16:05:00',1.06),('16100','2013-10-25','08:35:00',1.05),('16100','2013-10-25','08:40:00',1.23),('16100','2013-10-25','08:45:00',1.4),('16100','2013-10-25','08:50:00',1.57),('16100','2013-10-25','08:55:00',1.74),('16100','2013-10-25','09:00:00',1.91),('16100','2013-10-25','09:05:00',2.06),('16100','2013-10-25','09:10:00',2.22),('16100','2013-10-25','09:15:00',2.37),('16100','2013-10-25','09:20:00',2.51),('16100','2013-10-25','09:25:00',2.69),('16100','2013-10-25','09:30:00',2.82),('16100','2013-10-25','09:35:00',2.98),('16100','2013-10-25','09:40:00',3.13),('16100','2013-10-25','09:45:00',3.28),('16100','2013-10-25','09:50:00',3.37),('16100','2013-10-25','09:55:00',3.53),('16100','2013-10-25','10:00:00',3.66),('16100','2013-10-25','10:05:00',3.75),('16100','2013-10-25','10:10:00',3.9),('16100','2013-10-25','10:15:00',4.01),('16100','2013-10-25','10:20:00',4.11),('16100','2013-10-25','10:25:00',4.22),('16100','2013-10-25','10:30:00',4.35),('16100','2013-10-25','10:35:00',4.46),('16100','2013-10-25','10:40:00',4.65),('16100','2013-10-25','10:45:00',4.77),('16100','2013-10-25','10:50:00',4.82),('16100','2013-10-25','10:55:00',4.91),('16100','2013-10-25','11:00:00',5.02),('16100','2013-10-25','11:05:00',5.11),('16100','2013-10-25','11:10:00',5.18),('16100','2013-10-25','11:15:00',5.22),('16100','2013-10-25','11:20:00',5.28),('16100','2013-10-25','11:25:00',5.36),('16100','2013-10-25','11:30:00',5.41),('16100','2013-10-25','11:35:00',5.48),('16100','2013-10-25','11:40:00',5.53),('16100','2013-10-25','11:45:00',5.55),('16100','2013-10-25','11:50:00',5.6),('16100','2013-10-25','11:55:00',5.67),('16100','2013-10-25','12:00:00',5.7),('16100','2013-10-25','12:05:00',5.7),('16100','2013-10-25','12:10:00',5.69),('16100','2013-10-25','12:15:00',5.78),('16100','2013-10-25','12:20:00',5.88),('16100','2013-10-25','12:25:00',5.76),('16100','2013-10-25','12:30:00',5.71),('16100','2013-10-25','12:35:00',5.72),('16100','2013-10-25','12:40:00',5.63),('16100','2013-10-25','12:45:00',5.92),('16100','2013-10-25','12:50:00',5.79),('16100','2013-10-25','12:55:00',5.89),('16100','2013-10-25','13:00:00',5.73),('16100','2013-10-25','13:05:00',5.83),('16100','2013-10-25','13:10:00',5.72),('16100','2013-10-25','13:15:00',5.73),('16100','2013-10-25','13:20:00',5.59),('16100','2013-10-25','13:25:00',5.75),('16100','2013-10-25','13:30:00',5.65),('16100','2013-10-25','13:35:00',5.34),('16100','2013-10-25','13:40:00',5.55),('16100','2013-10-25','13:45:00',5.59),('16100','2013-10-25','13:50:00',5.49),('16100','2013-10-25','13:55:00',5.47),('16100','2013-10-25','14:00:00',5.27),('16100','2013-10-25','14:05:00',5.22),('16100','2013-10-25','14:10:00',5.38),('16100','2013-10-25','14:15:00',5.19),('16100','2013-10-25','14:20:00',5.24),('16100','2013-10-25','14:25:00',5.07),('16100','2013-10-25','14:30:00',4.92),('16100','2013-10-25','14:35:00',5),('16100','2013-10-25','14:40:00',4.74),('16100','2013-10-25','14:45:00',4.6),('16100','2013-10-25','14:50:00',4.59),('16100','2013-10-25','14:55:00',3.54),('16100','2013-10-25','15:00:00',4.13),('16100','2013-10-25','15:05:00',3.91),('16100','2013-10-25','15:10:00',3.31),('16100','2013-10-25','15:15:00',4.1),('16100','2013-10-25','15:20:00',3.97),('16100','2013-10-25','15:25:00',3.86),('16100','2013-10-25','15:30:00',3.54),('16100','2013-10-25','15:35:00',3.52),('16100','2013-10-25','15:40:00',3.46),('16100','2013-10-25','15:45:00',3.35),('16100','2013-10-25','15:50:00',3.32),('16100','2013-10-25','15:55:00',3.14),('16100','2013-10-25','16:00:00',2.91),('16100','2013-10-25','16:05:00',2.82),('16100','2013-10-25','16:10:00',2.64),('16100','2013-10-25','16:15:00',2.58),('16100','2013-10-25','16:20:00',2.45),('16100','2013-10-25','16:25:00',2.33),('16100','2013-10-25','16:30:00',2.1),('16100','2013-10-25','16:35:00',1.89),('16100','2013-10-25','16:40:00',1.73),('16100','2013-10-25','16:45:00',1.56),('16100','2013-10-25','16:50:00',1.43),('16100','2013-10-25','16:55:00',1.32),('16100','2013-10-25','17:00:00',1.18),('16100','2013-10-25','17:05:00',1.05),('16100','2013-10-24','08:35:00',1.04),('16100','2013-10-24','08:40:00',1.19),('16100','2013-10-24','08:45:00',1.36),('16100','2013-10-24','08:50:00',1.53),('16100','2013-10-24','08:55:00',1.69),('16100','2013-10-24','09:00:00',1.85),('16100','2013-10-24','09:05:00',2.05),('16100','2013-10-24','09:10:00',2.22),('16100','2013-10-24','09:15:00',2.32),('16100','2013-10-24','09:20:00',2.38),('16100','2013-10-24','09:25:00',2.64),('16100','2013-10-24','09:30:00',2.83),('16100','2013-10-24','09:35:00',3),('16100','2013-10-24','09:40:00',3.08),('16100','2013-10-24','09:45:00',3.17),('16100','2013-10-24','09:50:00',3.37),('16100','2013-10-24','09:55:00',3.49),('16100','2013-10-24','10:00:00',3.62),('16100','2013-10-24','10:05:00',3.71),('16100','2013-10-24','10:10:00',3.91),('16100','2013-10-24','10:15:00',4.02),('16100','2013-10-24','10:20:00',4.18),('16100','2013-10-24','10:25:00',4.28),('16100','2013-10-24','10:30:00',4.38),('16100','2013-10-24','10:35:00',4.55),('16100','2013-10-24','10:40:00',4.69),('16100','2013-10-24','10:45:00',4.76),('16100','2013-10-24','10:50:00',4.82),('16100','2013-10-24','10:55:00',4.99),('16100','2013-10-24','11:00:00',5.08),('16100','2013-10-24','11:05:00',5.22),('16100','2013-10-24','11:10:00',5.37),('16100','2013-10-24','11:15:00',5.38),('16100','2013-10-24','11:20:00',5.43),('16100','2013-10-24','11:25:00',5.49),('16100','2013-10-24','11:30:00',5.59),('16100','2013-10-24','11:35:00',5.67),('16100','2013-10-24','11:40:00',5.69),('16100','2013-10-24','11:45:00',5.78),('16100','2013-10-24','11:50:00',5.77),('16100','2013-10-24','11:55:00',5.88),('16100','2013-10-24','12:00:00',5.86),('16100','2013-10-24','12:05:00',5.9),('16100','2013-10-24','12:10:00',6),('16100','2013-10-24','12:15:00',5.99),('16100','2013-10-24','12:20:00',5.98),('16100','2013-10-24','12:25:00',5.97),('16100','2013-10-24','12:30:00',6.02),('16100','2013-10-24','12:35:00',6.03),('16100','2013-10-24','12:40:00',6.07),('16100','2013-10-24','12:45:00',6.08),('16100','2013-10-24','12:50:00',6.11),('16100','2013-10-24','12:55:00',6.15),('16100','2013-10-24','13:00:00',6.13),('16100','2013-10-24','13:05:00',6.07),('16100','2013-10-24','13:10:00',6.05),('16100','2013-10-24','13:15:00',6.02),('16100','2013-10-24','13:20:00',6.04),('16100','2013-10-24','13:25:00',6.02),('16100','2013-10-24','13:30:00',6.01),('16100','2013-10-24','13:35:00',6.02),('16100','2013-10-24','13:40:00',5.92),('16100','2013-10-24','13:45:00',5.91),('16100','2013-10-24','13:50:00',5.84),('16100','2013-10-24','13:55:00',5.76),('16100','2013-10-24','14:00:00',5.74),('16100','2013-10-24','14:05:00',5.69),('16100','2013-10-24','14:10:00',5.58),('16100','2013-10-24','14:15:00',5.51),('16100','2013-10-24','14:20:00',4.62),('16100','2013-10-24','14:25:00',5.15),('16100','2013-10-24','14:30:00',5.25),('16100','2013-10-24','14:35:00',5.11),('16100','2013-10-24','14:40:00',5.07),('16100','2013-10-24','14:45:00',5.01),('16100','2013-10-24','14:50:00',4.96),('16100','2013-10-24','14:55:00',4.81),('16100','2013-10-24','15:00:00',4.74),('16100','2013-10-24','15:05:00',4.65),('16100','2013-10-24','15:10:00',4.57),('16100','2013-10-24','15:15:00',4.44),('16100','2013-10-24','15:20:00',4.2),('16100','2013-10-24','15:25:00',4.1),('16100','2013-10-24','15:30:00',4.04),('16100','2013-10-24','15:35:00',3.92),('16100','2013-10-24','15:40:00',3.86),('16100','2013-10-24','15:45:00',3.77),('16100','2013-10-24','15:50:00',3.66),('16100','2013-10-24','15:55:00',3.54),('16100','2013-10-24','16:00:00',3.41),('16100','2013-10-24','16:05:00',3.24),('16100','2013-10-24','16:10:00',3.1),('16100','2013-10-24','16:15:00',3.02),('16100','2013-10-24','16:20:00',2.87),('16100','2013-10-24','16:25:00',2.73),('16100','2013-10-24','16:30:00',2.55),('16100','2013-10-24','16:35:00',2.36),('16100','2013-10-24','16:40:00',2.19),('16100','2013-10-24','16:45:00',2.04),('16100','2013-10-24','16:50:00',1.87),('16100','2013-10-24','16:55:00',1.7),('16100','2013-10-24','17:00:00',1.54),('16100','2013-10-24','17:05:00',1.38),('16100','2013-10-24','17:10:00',1.21),('16100','2013-10-24','17:15:00',1.04),('16100','2013-10-23','08:50:00',1.12),('16100','2013-10-23','09:00:00',2.16),('16100','2013-10-23','09:05:00',2.45),('16100','2013-10-23','09:10:00',2.49),('16100','2013-10-23','09:15:00',1.41),('16100','2013-10-23','09:20:00',1.42),('16100','2013-10-23','09:25:00',1.57),('16100','2013-10-23','09:30:00',1.79),('16100','2013-10-23','09:35:00',1.71),('16100','2013-10-23','09:40:00',1.72),('16100','2013-10-23','09:45:00',1.8),('16100','2013-10-23','09:50:00',1.74),('16100','2013-10-23','09:55:00',1.63),('16100','2013-10-23','10:00:00',1.49),('16100','2013-10-23','10:05:00',1.38),('16100','2013-10-23','10:10:00',1.44),('16100','2013-10-23','10:15:00',1.1),('16100','2013-10-23','10:20:00',1.11),('16100','2013-10-23','10:25:00',1.31),('16100','2013-10-23','10:30:00',3.09),('16100','2013-10-23','10:35:00',4.65),('16100','2013-10-23','10:40:00',6.21),('16100','2013-10-23','10:45:00',5.22),('16100','2013-10-23','10:50:00',5.5),('16100','2013-10-23','10:55:00',3.63),('16100','2013-10-23','11:00:00',4.66),('16100','2013-10-23','11:05:00',2.38),('16100','2013-10-23','11:10:00',2.88),('16100','2013-10-23','11:15:00',2.47),('16100','2013-10-23','11:20:00',3.81),('16100','2013-10-23','11:25:00',1.92),('16100','2013-10-23','11:30:00',2.12),('16100','2013-10-23','11:35:00',4.62),('16100','2013-10-23','11:40:00',6.28),('16100','2013-10-23','11:45:00',5.72),('16100','2013-10-23','11:50:00',6.6),('16100','2013-10-23','11:55:00',4.55),('16100','2013-10-23','12:00:00',2.23),('16100','2013-10-23','12:05:00',2.26),('16100','2013-10-23','12:10:00',2.4),('16100','2013-10-23','12:15:00',2.69),('16100','2013-10-23','12:20:00',3.53),('16100','2013-10-23','12:25:00',3.38),('16100','2013-10-23','12:30:00',3.35),('16100','2013-10-23','12:35:00',3.47),('16100','2013-10-23','12:40:00',2.98),('16100','2013-10-23','12:45:00',3.07),('16100','2013-10-23','12:50:00',3.05),('16100','2013-10-23','12:55:00',3.25),('16100','2013-10-23','13:00:00',2.72),('16100','2013-10-23','13:05:00',2.44),('16100','2013-10-23','13:10:00',2.29),('16100','2013-10-23','13:15:00',2.33),('16100','2013-10-23','13:20:00',2.18),('16100','2013-10-23','13:25:00',2.09),('16100','2013-10-23','13:30:00',2.08),('16100','2013-10-23','13:35:00',2.07),('16100','2013-10-23','13:40:00',2.09),('16100','2013-10-23','13:45:00',2.26),('16100','2013-10-23','13:50:00',3.37),('16100','2013-10-23','13:55:00',2.58),('16100','2013-10-23','14:00:00',2.22),('16100','2013-10-23','14:05:00',2.5),('16100','2013-10-23','14:10:00',2.43),('16100','2013-10-23','14:15:00',2.52),('16100','2013-10-23','14:20:00',2.48),('16100','2013-10-23','14:25:00',2.62),('16100','2013-10-23','14:30:00',3.24),('16100','2013-10-23','14:35:00',4.12),('16100','2013-10-23','14:40:00',3.36),('16100','2013-10-23','14:45:00',2.95),('16100','2013-10-23','14:50:00',1.37),('16100','2013-10-23','14:55:00',1.55),('16100','2013-10-23','15:00:00',2.26),('16100','2013-10-23','15:05:00',3),('16100','2013-10-23','15:10:00',2.05),('16100','2013-10-23','15:15:00',2.6),('16100','2013-10-23','15:20:00',1.81),('16100','2013-10-23','15:25:00',2.58),('16100','2013-10-23','15:30:00',3.14),('16100','2013-10-23','15:35:00',4.86),('16100','2013-10-23','15:40:00',4.76),('16100','2013-10-23','15:45:00',4.02),('16100','2013-10-23','15:50:00',1.75),('16100','2013-10-23','15:55:00',1.42),('16100','2013-10-23','16:00:00',1.24),('16100','2013-10-23','16:05:00',1.18),('16100','2013-10-23','16:10:00',1.15),('16100','2013-10-23','16:15:00',1.09),('16100','2013-10-22','09:45:00',1.24),('16100','2013-10-22','09:50:00',1.44),('16100','2013-10-22','09:55:00',1.31),('16100','2013-10-22','10:00:00',1.07),('16100','2013-10-22','10:05:00',1.12),('16100','2013-10-22','10:10:00',1.17),('16100','2013-10-22','10:15:00',1.24),('16100','2013-10-22','10:20:00',1.31),('16100','2013-10-22','10:25:00',1.59),('16100','2013-10-22','10:30:00',1.63),('16100','2013-10-22','10:35:00',2.28),('16100','2013-10-22','10:40:00',1.97),('16100','2013-10-22','10:45:00',2.39),('16100','2013-10-22','10:50:00',2.23),('16100','2013-10-22','10:55:00',3.49),('16100','2013-10-22','11:00:00',5.4),('16100','2013-10-22','11:05:00',5.16),('16100','2013-10-22','11:10:00',5.35),('16100','2013-10-22','11:15:00',5.35),('16100','2013-10-22','11:20:00',5.25),('16100','2013-10-22','11:25:00',5.42),('16100','2013-10-22','11:30:00',5.48),('16100','2013-10-22','11:35:00',5.58),('16100','2013-10-22','11:40:00',5.5),('16100','2013-10-22','11:45:00',5.56),('16100','2013-10-22','11:50:00',5.53),('16100','2013-10-22','11:55:00',5.3),('16100','2013-10-22','12:00:00',5.81),('16100','2013-10-22','12:05:00',5.76),('16100','2013-10-22','12:10:00',5.69),('16100','2013-10-22','12:15:00',5.71),('16100','2013-10-22','12:20:00',4.51),('16100','2013-10-22','12:25:00',5.72),('16100','2013-10-22','12:30:00',5.79),('16100','2013-10-22','12:35:00',5.66),('16100','2013-10-22','12:40:00',5.11),('16100','2013-10-22','12:45:00',5.93),('16100','2013-10-22','12:50:00',5.9),('16100','2013-10-22','12:55:00',5.8),('16100','2013-10-22','13:00:00',5.89),('16100','2013-10-22','13:05:00',5.65),('16100','2013-10-22','13:10:00',5.7),('16100','2013-10-22','13:15:00',5.76),('16100','2013-10-22','13:20:00',5.77),('16100','2013-10-22','13:25:00',5.71),('16100','2013-10-22','13:30:00',5.68),('16100','2013-10-22','13:35:00',5.49),('16100','2013-10-22','13:40:00',5.56),('16100','2013-10-22','13:45:00',5.69),('16100','2013-10-22','13:50:00',5.63),('16100','2013-10-22','13:55:00',5.56),('16100','2013-10-22','14:00:00',5.51),('16100','2013-10-22','14:05:00',5.36),('16100','2013-10-22','14:10:00',5.31),('16100','2013-10-22','14:15:00',5.25),('16100','2013-10-22','14:20:00',5.07),('16100','2013-10-22','14:25:00',5),('16100','2013-10-22','14:30:00',4.87),('16100','2013-10-22','14:35:00',4.68),('16100','2013-10-22','14:40:00',4.42),('16100','2013-10-22','14:45:00',4.15),('16100','2013-10-22','14:50:00',4.21),('16100','2013-10-22','14:55:00',4.4),('16100','2013-10-22','15:00:00',4.25),('16100','2013-10-22','15:05:00',4.04),('16100','2013-10-22','15:10:00',3.69),('16100','2013-10-22','15:15:00',3.76),('16100','2013-10-22','15:20:00',3.88),('16100','2013-10-22','15:25:00',3.57),('16100','2013-10-22','15:30:00',3.11),('16100','2013-10-22','15:35:00',3.42),('16100','2013-10-22','15:40:00',3.89),('16100','2013-10-22','15:45:00',3.82),('16100','2013-10-22','15:50:00',3.46),('16100','2013-10-22','15:55:00',2.4),('16100','2013-10-22','16:00:00',1.79),('16100','2013-10-22','16:05:00',1.66),('16100','2013-10-22','16:10:00',1.67),('16100','2013-10-22','16:15:00',1.8),('16100','2013-10-22','16:20:00',2.06),('16100','2013-10-22','16:25:00',1.93),('16100','2013-10-22','16:30:00',2.2),('16100','2013-10-22','16:35:00',2.3),('16100','2013-10-22','16:40:00',2.03),('16100','2013-10-22','16:45:00',1.65),('16100','2013-10-22','16:50:00',1.44),('16100','2013-10-22','16:55:00',1.43),('16100','2013-10-22','17:00:00',1.23),('16100','2013-10-21','08:35:00',1.06),('16100','2013-10-21','08:40:00',1.21),('16100','2013-10-21','08:45:00',1.38),('16100','2013-10-21','08:50:00',1.57),('16100','2013-10-21','08:55:00',1.72),('16100','2013-10-21','09:00:00',1.87),('16100','2013-10-21','09:05:00',2.02),('16100','2013-10-21','09:10:00',2.18),('16100','2013-10-21','09:15:00',2.34),('16100','2013-10-21','09:20:00',2.5),('16100','2013-10-21','09:25:00',2.68),('16100','2013-10-21','09:30:00',2.83),('16100','2013-10-21','09:35:00',2.98),('16100','2013-10-21','09:40:00',3.15),('16100','2013-10-21','09:45:00',3.29),('16100','2013-10-21','09:50:00',3.43),('16100','2013-10-21','09:55:00',3.52),('16100','2013-10-21','10:00:00',3.67),('16100','2013-10-21','10:05:00',3.75),('16100','2013-10-21','10:10:00',3.85),('16100','2013-10-21','10:15:00',3.99),('16100','2013-10-21','10:20:00',4.07),('16100','2013-10-21','10:25:00',4.21),('16100','2013-10-21','10:30:00',4.3),('16100','2013-10-21','10:35:00',4.4),('16100','2013-10-21','10:40:00',4.5),('16100','2013-10-21','10:45:00',4.61),('16100','2013-10-21','10:50:00',4.59),('16100','2013-10-21','10:55:00',4.67),('16100','2013-10-21','11:00:00',4.79),('16100','2013-10-21','11:05:00',4.96),('16100','2013-10-21','11:10:00',5.07),('16100','2013-10-21','11:15:00',5.11),('16100','2013-10-21','11:20:00',5.16),('16100','2013-10-21','11:25:00',5.21),('16100','2013-10-21','11:30:00',5.25),('16100','2013-10-21','11:35:00',5.29),('16100','2013-10-21','11:40:00',5.3),('16100','2013-10-21','11:45:00',5.45),('16100','2013-10-21','11:50:00',5.59),('16100','2013-10-21','11:55:00',5.56),('16100','2013-10-21','12:00:00',5.61),('16100','2013-10-21','12:05:00',5.61),('16100','2013-10-21','12:10:00',5.6),('16100','2013-10-21','12:15:00',5.5),('16100','2013-10-21','12:20:00',5.57),('16100','2013-10-21','12:25:00',5.77),('16100','2013-10-21','12:30:00',5.6),('16100','2013-10-21','12:35:00',5.63),('16100','2013-10-21','12:40:00',5.72),('16100','2013-10-21','12:45:00',5.76),('16100','2013-10-21','12:50:00',5.77),('16100','2013-10-21','12:55:00',5.82),('16100','2013-10-21','13:00:00',5.64),('16100','2013-10-21','13:05:00',5.48),('16100','2013-10-21','13:10:00',5.68),('16100','2013-10-21','13:15:00',5.78),('16100','2013-10-21','13:20:00',5.8),('16100','2013-10-21','13:25:00',5.48),('16100','2013-10-21','13:30:00',5.63),('16100','2013-10-21','13:35:00',5.6),('16100','2013-10-21','13:40:00',5.58),('16100','2013-10-21','13:45:00',5.52),('16100','2013-10-21','13:50:00',5.53),('16100','2013-10-21','13:55:00',5.54),('16100','2013-10-21','14:00:00',5.37),('16100','2013-10-21','14:05:00',5.53),('16100','2013-10-21','14:10:00',5.66),('16100','2013-10-21','14:15:00',4.32),('16100','2013-10-21','14:20:00',2.92),('16100','2013-10-21','14:25:00',5.06),('16100','2013-10-21','14:30:00',5.07),('16100','2013-10-21','14:35:00',5.1),('16100','2013-10-21','14:40:00',5.2),('16100','2013-10-21','14:45:00',5.03),('16100','2013-10-21','14:50:00',4.75),('16100','2013-10-21','14:55:00',4.61),('16100','2013-10-21','15:00:00',4.51),('16100','2013-10-21','15:05:00',4.42),('16100','2013-10-21','15:10:00',4.29),('16100','2013-10-21','15:15:00',4.09),('16100','2013-10-21','15:20:00',4.04),('16100','2013-10-21','15:25:00',3.29),('16100','2013-10-21','15:30:00',3.9),('16100','2013-10-21','15:35:00',3.13),('16100','2013-10-21','15:40:00',3.19),('16100','2013-10-21','15:45:00',3.52),('16100','2013-10-21','15:50:00',3.4),('16100','2013-10-21','15:55:00',3.34),('16100','2013-10-21','16:00:00',3.13),('16100','2013-10-21','16:05:00',2.97),('16100','2013-10-21','16:10:00',2.83),('16100','2013-10-21','16:15:00',2.69),('16100','2013-10-21','16:20:00',2.61),('16100','2013-10-21','16:25:00',2.42),('16100','2013-10-21','16:30:00',2.29),('16100','2013-10-21','16:35:00',2.14),('16100','2013-10-21','16:40:00',1.99),('16100','2013-10-21','16:45:00',1.83),('16100','2013-10-21','16:50:00',1.69),('16100','2013-10-21','16:55:00',1.53),('16100','2013-10-21','17:00:00',1.36),('16100','2013-10-21','17:05:00',1.21),('16100','2013-10-21','17:10:00',1.09),('16100','2013-10-20','08:40:00',1.15),('16100','2013-10-20','08:45:00',1.25),('16100','2013-10-20','08:50:00',1.16),('16100','2013-10-20','08:55:00',1.26),('16100','2013-10-20','09:00:00',1.1),('16100','2013-10-20','09:05:00',1.69),('16100','2013-10-20','09:10:00',2.14),('16100','2013-10-20','09:15:00',2.62),('16100','2013-10-20','09:20:00',2.69),('16100','2013-10-20','09:25:00',2.74),('16100','2013-10-20','09:30:00',2.6),('16100','2013-10-20','09:35:00',2.67),('16100','2013-10-20','09:40:00',2.97),('16100','2013-10-20','09:45:00',2.86),('16100','2013-10-20','09:50:00',3.06),('16100','2013-10-20','09:55:00',3.51),('16100','2013-10-20','10:00:00',3.75),('16100','2013-10-20','10:05:00',3.72),('16100','2013-10-20','10:10:00',3.96),('16100','2013-10-20','10:15:00',4.22),('16100','2013-10-20','10:20:00',4.32),('16100','2013-10-20','10:25:00',4.52),('16100','2013-10-20','10:30:00',4.35),('16100','2013-10-20','10:35:00',4.56),('16100','2013-10-20','10:40:00',4.64),('16100','2013-10-20','10:45:00',4.74),('16100','2013-10-20','10:50:00',5),('16100','2013-10-20','10:55:00',5.09),('16100','2013-10-20','11:00:00',4.92),('16100','2013-10-20','11:05:00',5.26),('16100','2013-10-20','11:10:00',5.37),('16100','2013-10-20','11:15:00',5.39),('16100','2013-10-20','11:20:00',5.37),('16100','2013-10-20','11:25:00',5.47),('16100','2013-10-20','11:30:00',5.65),('16100','2013-10-20','11:35:00',5.6),('16100','2013-10-20','11:40:00',5.66),('16100','2013-10-20','11:45:00',5.74),('16100','2013-10-20','11:50:00',5.68),('16100','2013-10-20','11:55:00',5.84),('16100','2013-10-20','12:00:00',5.88),('16100','2013-10-20','12:05:00',5.87),('16100','2013-10-20','12:10:00',5.88),('16100','2013-10-20','12:15:00',5.94),('16100','2013-10-20','12:20:00',5.98),('16100','2013-10-20','12:25:00',5.9),('16100','2013-10-20','12:30:00',6.01),('16100','2013-10-20','12:35:00',6.03),('16100','2013-10-20','12:40:00',5.9),('16100','2013-10-20','12:45:00',5.88),('16100','2013-10-20','12:50:00',5.98),('16100','2013-10-20','12:55:00',5.85),('16100','2013-10-20','13:00:00',5.86),('16100','2013-10-20','13:05:00',5.54),('16100','2013-10-20','13:10:00',5.82),('16100','2013-10-20','13:15:00',5.71),('16100','2013-10-20','13:20:00',5.6),('16100','2013-10-20','13:25:00',5.86),('16100','2013-10-20','13:30:00',5.83),('16100','2013-10-20','13:35:00',5.81),('16100','2013-10-20','13:40:00',5.98),('16100','2013-10-20','13:45:00',5.96),('16100','2013-10-20','13:50:00',5.63),('16100','2013-10-20','13:55:00',5.45),('16100','2013-10-20','14:00:00',5.79),('16100','2013-10-20','14:05:00',5.69),('16100','2013-10-20','14:10:00',5.63),('16100','2013-10-20','14:15:00',5.56),('16100','2013-10-20','14:20:00',5.54),('16100','2013-10-20','14:25:00',5.46),('16100','2013-10-20','14:30:00',5.4),('16100','2013-10-20','14:35:00',5.26),('16100','2013-10-20','14:40:00',5.17),('16100','2013-10-20','14:45:00',5.08),('16100','2013-10-20','14:50:00',4.95),('16100','2013-10-20','14:55:00',4.78),('16100','2013-10-20','15:00:00',4.73),('16100','2013-10-20','15:05:00',4.64),('16100','2013-10-20','15:10:00',4.53),('16100','2013-10-20','15:15:00',4.28),('16100','2013-10-20','15:20:00',4.33),('16100','2013-10-20','15:25:00',4.28),('16100','2013-10-20','15:30:00',4.16),('16100','2013-10-20','15:35:00',4.04),('16100','2013-10-20','15:40:00',3.88),('16100','2013-10-20','15:45:00',3.75),('16100','2013-10-20','15:50:00',3.65),('16100','2013-10-20','15:55:00',3.47),('16100','2013-10-20','16:00:00',3.36),('16100','2013-10-20','16:05:00',3.29),('16100','2013-10-20','16:10:00',3.19),('16100','2013-10-20','16:15:00',3.04),('16100','2013-10-20','16:20:00',2.74),('16100','2013-10-20','16:25:00',2.58),('16100','2013-10-20','16:30:00',2.44),('16100','2013-10-20','16:35:00',2.33),('16100','2013-10-20','16:40:00',2.23),('16100','2013-10-20','16:45:00',2.09),('16100','2013-10-20','16:50:00',1.69),('16100','2013-10-20','16:55:00',1.49),('16100','2013-10-20','17:00:00',1.5),('16100','2013-10-20','17:05:00',1.47),('16100','2013-10-20','17:10:00',1.38),('16100','2013-10-20','17:15:00',1.2),('16100','2013-10-19','08:25:00',1.15),('16100','2013-10-19','08:30:00',1.25),('16100','2013-10-19','08:35:00',1),('16100','2013-10-19','08:45:00',1.86),('16100','2013-10-19','08:50:00',1.99),('16100','2013-10-19','08:55:00',1.97),('16100','2013-10-19','09:00:00',2.12),('16100','2013-10-19','09:05:00',2.25),('16100','2013-10-19','09:10:00',2.45),('16100','2013-10-19','09:15:00',2.64),('16100','2013-10-19','09:20:00',2.78),('16100','2013-10-19','09:25:00',2.95),('16100','2013-10-19','09:30:00',3.12),('16100','2013-10-19','09:35:00',3.21),('16100','2013-10-19','09:40:00',3.37),('16100','2013-10-19','09:45:00',3.53),('16100','2013-10-19','09:50:00',3.67),('16100','2013-10-19','09:55:00',3.85),('16100','2013-10-19','10:00:00',3.97),('16100','2013-10-19','10:05:00',4.12),('16100','2013-10-19','10:10:00',4.24),('16100','2013-10-19','10:15:00',4.38),('16100','2013-10-19','10:20:00',4.51),('16100','2013-10-19','10:25:00',4.59),('16100','2013-10-19','10:30:00',4.67),('16100','2013-10-19','10:35:00',4.82),('16100','2013-10-19','10:40:00',4.93),('16100','2013-10-19','10:45:00',5),('16100','2013-10-19','10:50:00',5.11),('16100','2013-10-19','10:55:00',5.19),('16100','2013-10-19','11:00:00',5.28),('16100','2013-10-19','11:05:00',5.39),('16100','2013-10-19','11:10:00',5.47),('16100','2013-10-19','11:15:00',5.57),('16100','2013-10-19','11:20:00',5.66),('16100','2013-10-19','11:25:00',5.68),('16100','2013-10-19','11:30:00',5.79),('16100','2013-10-19','11:35:00',5.78),('16100','2013-10-19','11:40:00',5.88),('16100','2013-10-19','11:45:00',5.94),('16100','2013-10-19','11:50:00',5.93),('16100','2013-10-19','11:55:00',5.94),('16100','2013-10-19','12:00:00',6.11),('16100','2013-10-19','12:05:00',6.09),('16100','2013-10-19','12:10:00',6.07),('16100','2013-10-19','12:15:00',6.22),('16100','2013-10-19','12:20:00',5.98),('16100','2013-10-19','12:25:00',3.46),('16100','2013-10-19','12:30:00',4.65),('16100','2013-10-19','12:35:00',2.65),('16100','2013-10-19','12:40:00',4.28),('16100','2013-10-19','12:45:00',3.38),('16100','2013-10-19','12:50:00',4.12),('16100','2013-10-19','12:55:00',2.25),('16100','2013-10-19','13:00:00',3.54),('16100','2013-10-19','13:05:00',3.12),('16100','2013-10-19','13:10:00',3.15),('16100','2013-10-19','13:15:00',2.49),('16100','2013-10-19','13:20:00',3.26),('16100','2013-10-19','13:25:00',4.97),('16100','2013-10-19','13:30:00',6.49),('16100','2013-10-19','13:35:00',1.95),('16100','2013-10-19','13:40:00',6.39),('16100','2013-10-19','13:45:00',6.36),('16100','2013-10-19','13:50:00',6.37),('16100','2013-10-19','13:55:00',2.07),('16100','2013-10-19','14:00:00',5.93),('16100','2013-10-19','14:05:00',6.18),('16100','2013-10-19','14:10:00',6.09),('16100','2013-10-19','14:15:00',5.98),('16100','2013-10-19','14:20:00',5.39),('16100','2013-10-19','14:25:00',6.07),('16100','2013-10-19','14:30:00',5.88),('16100','2013-10-19','14:35:00',5.6),('16100','2013-10-19','14:40:00',5.58),('16100','2013-10-19','14:45:00',5.5),('16100','2013-10-19','15:20:00',1.03),('16100','2013-10-19','15:25:00',3.51),('16100','2013-10-19','15:30:00',1.33),('16100','2013-10-19','15:55:00',1.19),('16100','2013-10-19','16:00:00',1.93),('16100','2013-10-19','16:05:00',3.65),('16100','2013-10-19','16:10:00',3.53),('16100','2013-10-19','16:15:00',3.58),('16100','2013-10-19','16:20:00',3.61),('16100','2013-10-19','16:25:00',3.53),('16100','2013-10-19','16:30:00',3.55),('16100','2013-10-19','16:35:00',3.4),('16100','2013-10-19','16:40:00',3.08),('16100','2013-10-19','16:45:00',2.6),('16100','2013-10-19','16:50:00',2.34),('16100','2013-10-19','16:55:00',2.07),('16100','2013-10-19','17:00:00',1.87),('16100','2013-10-19','17:05:00',1.67),('16100','2013-10-19','17:10:00',1.48),('16100','2013-10-19','17:15:00',1.3),('16100','2013-10-19','17:20:00',1.11),('16100','2013-10-18','08:20:00',1.01),('16100','2013-10-18','08:30:00',1.32),('16100','2013-10-18','08:35:00',1.58),('16100','2013-10-18','08:40:00',1.74),('16100','2013-10-18','08:45:00',1.96),('16100','2013-10-18','08:50:00',2.22),('16100','2013-10-18','08:55:00',2.49),('16100','2013-10-18','09:00:00',2.66),('16100','2013-10-18','09:05:00',2.47),('16100','2013-10-18','09:10:00',3.18),('16100','2013-10-18','09:15:00',3.38),('16100','2013-10-18','09:20:00',3.51),('16100','2013-10-18','09:25:00',3.64),('16100','2013-10-18','09:30:00',3.79),('16100','2013-10-18','09:35:00',3.9),('16100','2013-10-18','09:40:00',4.05),('16100','2013-10-18','09:45:00',3.97),('16100','2013-10-18','09:50:00',4.24),('16100','2013-10-18','09:55:00',4.51),('16100','2013-10-18','10:00:00',4.47),('16100','2013-10-18','10:05:00',4.55),('16100','2013-10-18','10:10:00',4.63),('16100','2013-10-18','10:15:00',4.89),('16100','2013-10-18','10:20:00',5),('16100','2013-10-18','10:25:00',5.24),('16100','2013-10-18','10:30:00',5.3),('16100','2013-10-18','10:35:00',5.35),('16100','2013-10-18','10:40:00',5.39),('16100','2013-10-18','10:45:00',5.54),('16100','2013-10-18','10:50:00',5.56),('16100','2013-10-18','10:55:00',5.71),('16100','2013-10-18','11:00:00',4.03),('16100','2013-10-18','11:05:00',3.55),('16100','2013-10-18','11:10:00',5.31),('16100','2013-10-18','11:15:00',5.74),('16100','2013-10-18','11:20:00',6.37),('16100','2013-10-18','11:25:00',6.28),('16100','2013-10-18','11:30:00',6.31),('16100','2013-10-18','11:35:00',6.28),('16100','2013-10-18','11:40:00',6.39),('16100','2013-10-18','11:45:00',5.41),('16100','2013-10-18','11:50:00',6.2),('16100','2013-10-18','11:55:00',6.53),('16100','2013-10-18','12:00:00',6.5),('16100','2013-10-18','12:05:00',6.46),('16100','2013-10-18','12:10:00',6.5),('16100','2013-10-18','12:15:00',6.48),('16100','2013-10-18','12:20:00',6.38),('16100','2013-10-18','12:25:00',6.81),('16100','2013-10-18','12:30:00',6.7),('16100','2013-10-18','12:35:00',6.76),('16100','2013-10-18','12:40:00',7.15),('16100','2013-10-18','12:45:00',7.27),('16100','2013-10-18','12:50:00',7.47),('16100','2013-10-18','12:55:00',5.27),('16100','2013-10-18','13:00:00',5.57),('16100','2013-10-18','13:05:00',7.46),('16100','2013-10-18','13:10:00',5.64),('16100','2013-10-18','13:15:00',6.14),('16100','2013-10-18','13:20:00',5.38),('16100','2013-10-18','13:25:00',5.17),('16100','2013-10-18','13:30:00',5.3),('16100','2013-10-18','13:35:00',5.52),('16100','2013-10-18','13:40:00',6.37),('16100','2013-10-18','13:45:00',6.72),('16100','2013-10-18','13:50:00',6.49),('16100','2013-10-18','13:55:00',5),('16100','2013-10-18','14:00:00',4.93),('16100','2013-10-18','14:05:00',5.96),('16100','2013-10-18','14:10:00',6.03),('16100','2013-10-18','14:15:00',4.5),('16100','2013-10-18','14:20:00',4.75),('16100','2013-10-18','14:25:00',5.83),('16100','2013-10-18','14:30:00',6.55),('16100','2013-10-18','14:35:00',6.38),('16100','2013-10-18','14:40:00',6.08),('16100','2013-10-18','14:45:00',5.78),('16100','2013-10-18','14:50:00',5.57),('16100','2013-10-18','14:55:00',5.41),('16100','2013-10-18','15:00:00',5.25),('16100','2013-10-18','15:05:00',5.3),('16100','2013-10-18','15:10:00',4.92),('16100','2013-10-18','15:15:00',4.84),('16100','2013-10-18','15:20:00',4.68),('16100','2013-10-18','15:25:00',4.67),('16100','2013-10-18','15:30:00',4.39),('16100','2013-10-18','15:35:00',4),('16100','2013-10-18','15:40:00',3.55),('16100','2013-10-18','15:45:00',4.33),('16100','2013-10-18','15:50:00',4.38),('16100','2013-10-18','15:55:00',4.11),('16100','2013-10-18','16:00:00',3.72),('16100','2013-10-18','16:05:00',3.94),('16100','2013-10-18','16:10:00',3.89),('16100','2013-10-18','16:15:00',2.28),('16100','2013-10-18','16:20:00',2.86),('16100','2013-10-18','16:25:00',3.32),('16100','2013-10-18','16:30:00',3.41),('16100','2013-10-18','16:35:00',3.09),('16100','2013-10-18','16:40:00',2.98),('16100','2013-10-18','16:45:00',2.33),('16100','2013-10-18','16:50:00',1.71),('16100','2013-10-18','16:55:00',1.9),('16100','2013-10-18','17:00:00',1.19),('16100','2013-10-18','17:05:00',1.58),('16100','2013-10-18','17:10:00',1.5),('16100','2013-10-18','17:15:00',1.78),('16100','2013-10-18','17:20:00',1.19),('16100','2014-05-03','07:45:00',1.08),('16100','2014-05-03','07:50:00',1.05),('16100','2014-05-03','07:55:00',1.27),('16100','2014-05-03','08:00:00',1.13),('16100','2014-05-03','08:05:00',1.62),('16100','2014-05-03','08:10:00',1.74),('16100','2014-05-03','08:15:00',1.53),('16100','2014-05-03','08:20:00',2.14),('16100','2014-05-03','08:25:00',1.91),('16100','2014-05-03','08:30:00',2.62),('16100','2014-05-03','08:35:00',1.44),('16100','2014-05-03','08:40:00',1.42),('16100','2014-05-03','08:45:00',1.47),('16100','2014-05-03','08:50:00',1.45),('16100','2014-05-03','08:55:00',1.3),('16100','2014-05-03','09:00:00',1.44),('16100','2014-05-03','09:05:00',1.85),('16100','2014-05-03','09:10:00',2.34),('16100','2014-05-03','09:15:00',2.15),('16100','2014-05-03','09:20:00',2.12),('16100','2014-05-03','09:25:00',5.02),('16100','2014-05-03','09:30:00',5.08),('16100','2014-05-03','09:35:00',2.82),('16100','2014-05-03','09:40:00',2.36),('16100','2014-05-03','09:45:00',4.07),('16100','2014-05-03','09:50:00',5.3),('16100','2014-05-03','09:55:00',6.27),('16100','2014-05-03','10:00:00',5.14),('16100','2014-05-03','10:05:00',5.22),('16100','2014-05-03','10:10:00',4.3),('16100','2014-05-03','10:15:00',2.88),('16100','2014-05-03','10:20:00',2.56),('16100','2014-05-03','10:25:00',2.62),('16100','2014-05-03','10:30:00',2.76),('16100','2014-05-03','10:35:00',2.94),('16100','2014-05-03','10:40:00',3.2),('16100','2014-05-03','10:45:00',3.59),('16100','2014-05-03','10:50:00',4.06),('16100','2014-05-03','10:55:00',2.76),('16100','2014-05-03','11:00:00',3.08),('16100','2014-05-03','11:05:00',3.72),('16100','2014-05-03','11:10:00',5.14),('16100','2014-05-03','11:15:00',6.36),('16100','2014-05-03','11:20:00',7.2),('16100','2014-05-03','11:25:00',6.18),('16100','2014-05-03','11:30:00',6.66),('16100','2014-05-03','11:35:00',5.27),('16100','2014-05-03','11:40:00',3.49),('16100','2014-05-03','11:45:00',3.14),('16100','2014-05-03','11:50:00',2.75),('16100','2014-05-03','11:55:00',2.89),('16100','2014-05-03','12:00:00',2.23),('16100','2014-05-03','12:05:00',1.67),('16100','2014-05-03','12:10:00',1.92),('16100','2014-05-03','12:15:00',7.18),('16100','2014-05-03','12:20:00',8.63),('16100','2014-05-03','12:25:00',5.1),('16100','2014-05-03','12:30:00',2.99),('16100','2014-05-03','12:35:00',1.95),('16100','2014-05-03','12:40:00',2.12),('16100','2014-05-03','12:45:00',2.28),('16100','2014-05-03','12:50:00',2.19),('16100','2014-05-03','12:55:00',1.68),('16100','2014-05-03','13:00:00',1.45),('16100','2014-05-03','13:05:00',1.45),('16100','2014-05-03','13:10:00',1.55),('16100','2014-05-03','13:15:00',1.53),('16100','2014-05-03','13:20:00',1.53),('16100','2014-05-03','13:25:00',1.66),('16100','2014-05-03','13:30:00',1.88),('16100','2014-05-03','13:35:00',2.12),('16100','2014-05-03','13:40:00',2.3),('16100','2014-05-03','13:45:00',2.5),('16100','2014-05-03','13:50:00',2.72),('16100','2014-05-03','13:55:00',3.71),('16100','2014-05-03','14:00:00',2.48),('16100','2014-05-03','14:05:00',1.48),('16100','2014-05-03','14:20:00',1.19),('16100','2014-05-03','14:25:00',1.7),('16100','2014-05-03','14:30:00',1.58),('16100','2014-05-03','14:35:00',1.46),('16100','2014-05-03','14:40:00',1.85),('16100','2014-05-03','14:45:00',2.61),('16100','2014-05-03','14:50:00',4.66),('16100','2014-05-03','14:55:00',5.57),('16100','2014-05-03','15:00:00',3.35),('16100','2014-05-03','15:05:00',4.19),('16100','2014-05-03','15:10:00',5.19),('16100','2014-05-03','15:15:00',7.75),('16100','2014-05-03','15:20:00',6.59),('16100','2014-05-03','15:25:00',3.62),('16100','2014-05-03','15:30:00',2.25),('16100','2014-05-03','15:35:00',1.75),('16100','2014-05-03','15:40:00',1.64),('16100','2014-05-03','15:45:00',1.57),('16100','2014-05-03','15:50:00',1.51),('16100','2014-05-03','15:55:00',1.37),('16100','2014-05-03','16:00:00',1.29),('16100','2014-05-03','16:05:00',1.2),('16100','2014-05-03','16:10:00',1.08),('16100','2014-05-03','17:25:00',1.26),('16100','2014-05-03','17:30:00',1.7),('16100','2014-05-03','17:35:00',1.86),('16100','2014-05-03','17:40:00',1.29),('16100','2014-04-15','08:00:00',1.02),('16100','2014-04-15','08:05:00',1.23),('16100','2014-04-15','08:10:00',1.48),('16100','2014-04-15','08:15:00',1.75),('16100','2014-04-15','08:20:00',1.95),('16100','2014-04-15','08:25:00',1.34),('16100','2014-04-15','08:35:00',1.69),('16100','2014-04-15','08:40:00',2.28),('16100','2014-04-15','08:45:00',2.96),('16100','2014-04-15','08:50:00',3.17),('16100','2014-04-15','08:55:00',3.32),('16100','2014-04-15','09:00:00',3.48),('16100','2014-04-15','09:05:00',3.66),('16100','2014-04-15','09:10:00',3.88),('16100','2014-04-15','09:15:00',4),('16100','2014-04-15','09:20:00',4.2),('16100','2014-04-15','09:25:00',4.38),('16100','2014-04-15','09:30:00',4.57),('16100','2014-04-15','09:35:00',1.75),('16100','2014-04-15','09:40:00',1.67),('16100','2014-04-15','09:45:00',3.29),('16100','2014-04-15','09:50:00',5.09),('16100','2014-04-15','09:55:00',4.43),('16100','2014-04-15','10:00:00',5.42),('16100','2014-04-15','10:05:00',5.55),('16100','2014-04-15','10:10:00',5.64),('16100','2014-04-15','10:15:00',5.73),('16100','2014-04-15','10:20:00',5.92),('16100','2014-04-15','10:25:00',6.15),('16100','2014-04-15','10:30:00',6.32),('16100','2014-04-15','10:35:00',6.45),('16100','2014-04-15','11:30:00',3.71),('16100','2014-04-15','11:35:00',6.85),('16100','2014-04-15','11:40:00',9.07),('16100','2014-04-15','11:45:00',8.52),('16100','2014-04-15','11:50:00',6.91),('16100','2014-04-15','11:55:00',7.45),('16100','2014-04-15','12:00:00',6.29),('16100','2014-04-15','12:05:00',5.95),('16100','2014-04-15','12:10:00',6.3),('16100','2014-04-15','12:15:00',8.7),('16100','2014-04-15','12:20:00',8.27),('16100','2014-04-15','12:25:00',9.28),('16100','2014-04-15','12:30:00',9.13),('16100','2014-04-15','12:35:00',3.8),('16100','2014-04-15','12:40:00',4.86),('16100','2014-04-15','12:45:00',8.59),('16100','2014-04-15','12:50:00',7.15),('16100','2014-04-15','12:55:00',9.35),('16100','2014-04-15','13:00:00',4.75),('16100','2014-04-15','13:05:00',2.67),('16100','2014-04-15','13:10:00',1.79),('16100','2014-04-15','13:15:00',1.65),('16100','2014-04-15','13:20:00',4.52),('16100','2014-04-15','13:25:00',5.59),('16100','2014-04-15','13:30:00',2.72),('16100','2014-04-15','13:35:00',3.73),('16100','2014-04-15','13:40:00',7.12),('16100','2014-04-15','13:45:00',6.8),('16100','2014-04-15','13:50:00',8.84),('16100','2014-04-15','13:55:00',7.7),('16100','2014-04-15','14:00:00',3.78),('16100','2014-04-15','14:05:00',5.95),('16100','2014-04-15','14:10:00',5.82),('16100','2014-04-15','14:15:00',3.6),('16100','2014-04-15','14:20:00',9),('16100','2014-04-15','14:25:00',8.14),('16100','2014-04-15','14:30:00',7.9),('16100','2014-04-15','14:35:00',5.05),('16100','2014-04-15','14:40:00',6.85),('16100','2014-04-15','14:45:00',4.8),('16100','2014-04-15','14:50:00',3.25),('16100','2014-04-15','14:55:00',5.06),('16100','2014-04-15','15:00:00',4.39),('16100','2014-04-15','15:05:00',2.98),('16100','2014-04-15','15:10:00',1.97),('16100','2014-04-15','15:15:00',1.1),('16100','2014-04-15','15:20:00',1.57),('16100','2014-04-15','15:25:00',1.84),('16100','2014-04-15','15:30:00',4.88),('16100','2014-04-15','15:35:00',2.37),('16100','2014-04-15','15:40:00',4.25),('16100','2014-04-15','15:45:00',4.95),('16100','2014-04-15','15:50:00',1.11),('16100','2014-04-15','15:55:00',1.05),('16100','2014-04-15','16:00:00',4.83),('16100','2014-04-15','16:05:00',6.23),('16100','2014-04-15','16:10:00',5.88),('16100','2014-04-15','16:15:00',5.68),('16100','2014-04-15','16:20:00',5.57),('16100','2014-04-15','16:25:00',4.7),('16100','2014-04-15','16:30:00',3.83),('16100','2014-04-15','16:35:00',4.9),('16100','2014-04-15','16:40:00',5.05),('16100','2014-04-15','16:45:00',4.88),('16100','2014-04-15','16:50:00',4.75),('16100','2014-04-15','16:55:00',4.56),('16100','2014-04-15','17:00:00',4.4),('16100','2014-04-15','17:05:00',4.23),('16100','2014-04-15','17:10:00',4.1),('16100','2014-04-15','17:15:00',3.91),('16100','2014-04-15','17:20:00',3.73),('16100','2014-04-15','17:25:00',3.53),('16100','2014-04-15','17:30:00',3.35),('16100','2014-04-15','17:35:00',3.17),('16100','2014-04-15','17:40:00',3),('16100','2014-04-15','17:45:00',2.83),('16100','2014-04-15','17:50:00',2.64),('16100','2014-04-15','17:55:00',2.49),('16100','2014-04-15','18:00:00',2.36),('16100','2014-04-15','18:05:00',1.8),('16100','2014-04-15','18:10:00',2.03),('16100','2014-04-15','18:15:00',1.79),('16100','2014-04-15','18:20:00',1.62),('16100','2014-04-15','18:25:00',1.06),('16100','2014-04-15','18:30:00',1.25),('16100','2014-04-15','18:35:00',1.07),('16100','2013-10-17','08:25:00',1.09),('16100','2013-10-17','08:30:00',1.07),('16100','2013-10-17','08:35:00',1.31),('16100','2013-10-17','08:40:00',1.61),('16100','2013-10-17','08:45:00',1.79),('16100','2013-10-17','08:50:00',1.94),('16100','2013-10-17','08:55:00',2.06),('16100','2013-10-17','09:00:00',2.43),('16100','2013-10-17','09:05:00',2.61),('16100','2013-10-17','09:10:00',2.79),('16100','2013-10-17','09:15:00',2.93),('16100','2013-10-17','09:20:00',3.18),('16100','2013-10-17','09:25:00',3.34),('16100','2013-10-17','09:30:00',3.59),('16100','2013-10-17','09:35:00',3.74),('16100','2013-10-17','09:40:00',3.87),('16100','2013-10-17','09:45:00',4.05),('16100','2013-10-17','09:50:00',4.17),('16100','2013-10-17','09:55:00',4.29),('16100','2013-10-17','10:00:00',4.44),('16100','2013-10-17','10:05:00',4.6),('16100','2013-10-17','10:10:00',4.69),('16100','2013-10-17','10:15:00',4.86),('16100','2013-10-17','10:20:00',4.92),('16100','2013-10-17','10:25:00',5.06),('16100','2013-10-17','10:30:00',5.19),('16100','2013-10-17','10:35:00',5.32),('16100','2013-10-17','10:40:00',5.36),('16100','2013-10-17','10:45:00',5.51),('16100','2013-10-17','10:50:00',5.6),('16100','2013-10-17','10:55:00',5.65),('16100','2013-10-17','11:00:00',5.5),('16100','2013-10-17','11:05:00',5.78),('16100','2013-10-17','11:10:00',5.18),('16100','2013-10-17','11:15:00',5.36),('16100','2013-10-17','11:20:00',4.77),('16100','2013-10-17','11:25:00',6.12),('16100','2013-10-17','11:30:00',6.04),('16100','2013-10-17','11:35:00',6.31),('16100','2013-10-17','11:40:00',6.11),('16100','2013-10-17','11:45:00',6.26),('16100','2013-10-17','11:50:00',6.4),('16100','2013-10-17','11:55:00',6.2),('16100','2013-10-17','12:00:00',6.37),('16100','2013-10-17','12:05:00',6.35),('16100','2013-10-17','12:10:00',6.37),('16100','2013-10-17','12:15:00',6.25),('16100','2013-10-17','12:20:00',6.33),('16100','2013-10-17','12:25:00',6.54),('16100','2013-10-17','12:30:00',6.51),('16100','2013-10-17','12:35:00',6.42),('16100','2013-10-17','12:40:00',6.5),('16100','2013-10-17','12:45:00',6.39),('16100','2013-10-17','12:50:00',6.33),('16100','2013-10-17','12:55:00',6.3),('16100','2013-10-17','13:00:00',6.15),('16100','2013-10-17','13:05:00',6.19),('16100','2013-10-17','13:10:00',6.42),('16100','2013-10-17','13:15:00',6.44),('16100','2013-10-17','13:20:00',6.36),('16100','2013-10-17','13:25:00',6.49),('16100','2013-10-17','13:30:00',6.48),('16100','2013-10-17','13:35:00',6.4),('16100','2013-10-17','13:40:00',6.36),('16100','2013-10-17','13:45:00',6.05),('16100','2013-10-17','13:50:00',6.17),('16100','2013-10-17','13:55:00',5.99),('16100','2013-10-17','14:00:00',5.92),('16100','2013-10-17','14:05:00',6.05),('16100','2013-10-17','14:10:00',6.02),('16100','2013-10-17','14:15:00',6),('16100','2013-10-17','14:20:00',5.97),('16100','2013-10-17','14:25:00',5.93),('16100','2013-10-17','14:30:00',5.76),('16100','2013-10-17','14:35:00',5.82),('16100','2013-10-17','14:40:00',5.65),('16100','2013-10-17','14:45:00',5.56),('16100','2013-10-17','14:50:00',5.53),('16100','2013-10-17','14:55:00',5.39),('16100','2013-10-17','15:00:00',4.75),('16100','2013-10-17','15:05:00',4.86),('16100','2013-10-17','15:10:00',4.72),('16100','2013-10-17','15:15:00',5.17),('16100','2013-10-17','15:20:00',4.85),('16100','2013-10-17','15:25:00',4.74),('16100','2013-10-17','15:30:00',4.77),('16100','2013-10-17','15:35:00',4.47),('16100','2013-10-17','15:40:00',4.15),('16100','2013-10-17','15:45:00',3.95),('16100','2013-10-17','15:50:00',3.92),('16100','2013-10-17','15:55:00',3.87),('16100','2013-10-17','16:00:00',3.72),('16100','2013-10-17','16:05:00',3.62),('16100','2013-10-17','16:10:00',3.37),('16100','2013-10-17','16:15:00',3.21),('16100','2013-10-17','16:20:00',2.62),('16100','2013-10-17','16:25:00',2.37),('16100','2013-10-17','16:30:00',2.26),('16100','2013-10-17','16:35:00',1.77),('16100','2013-10-17','16:40:00',1.45),('16100','2013-10-17','16:45:00',1.59),('16100','2013-10-17','16:50:00',1.82),('16100','2013-10-17','16:55:00',1.6),('16100','2013-10-17','17:00:00',1.39),('16100','2013-10-17','17:05:00',1.29),('16100','2013-10-17','17:10:00',1.09),('16100','2013-10-17','17:15:00',1.02),('16100','2013-10-16','08:20:00',1.01),('16100','2013-10-16','08:25:00',1.2),('16100','2013-10-16','08:30:00',1.4),('16100','2013-10-16','08:35:00',1.59),('16100','2013-10-16','08:40:00',1.79),('16100','2013-10-16','08:45:00',1.98),('16100','2013-10-16','08:50:00',2.18),('16100','2013-10-16','08:55:00',2.35),('16100','2013-10-16','09:00:00',2.51),('16100','2013-10-16','09:05:00',2.68),('16100','2013-10-16','09:10:00',2.85),('16100','2013-10-16','09:15:00',3.05),('16100','2013-10-16','09:20:00',3.22),('16100','2013-10-16','09:25:00',3.38),('16100','2013-10-16','09:30:00',3.55),('16100','2013-10-16','09:35:00',3.7),('16100','2013-10-16','09:40:00',3.85),('16100','2013-10-16','09:45:00',4.01),('16100','2013-10-16','09:50:00',4.17),('16100','2013-10-16','09:55:00',4.3),('16100','2013-10-16','10:00:00',4.43),('16100','2013-10-16','10:05:00',4.56),('16100','2013-10-16','10:10:00',4.68),('16100','2013-10-16','10:15:00',4.8),('16100','2013-10-16','10:20:00',5),('16100','2013-10-16','10:25:00',5.1),('16100','2013-10-16','10:30:00',5.21),('16100','2013-10-16','10:35:00',5.33),('16100','2013-10-16','10:40:00',5.45),('16100','2013-10-16','10:45:00',5.52),('16100','2013-10-16','10:50:00',5.61),('16100','2013-10-16','10:55:00',5.69),('16100','2013-10-16','11:00:00',5.76),('16100','2013-10-16','11:05:00',5.88),('16100','2013-10-16','11:10:00',5.97),('16100','2013-10-16','11:15:00',6.05),('16100','2013-10-16','11:20:00',6.12),('16100','2013-10-16','11:25:00',6.19),('16100','2013-10-16','11:30:00',6.22),('16100','2013-10-16','11:35:00',6.22),('16100','2013-10-16','11:40:00',6.34),('16100','2013-10-16','11:45:00',6.42),('16100','2013-10-16','11:50:00',6.48),('16100','2013-10-16','11:55:00',6.49),('16100','2013-10-16','12:00:00',6.54),('16100','2013-10-16','12:05:00',6.56),('16100','2013-10-16','12:10:00',6.6),('16100','2013-10-16','12:15:00',6.64),('16100','2013-10-16','12:20:00',6.65),('16100','2013-10-16','12:25:00',6.68),('16100','2013-10-16','12:30:00',6.72),('16100','2013-10-16','12:35:00',6.69),('16100','2013-10-16','12:40:00',6.71),('16100','2013-10-16','12:45:00',6.72),('16100','2013-10-16','12:50:00',6.71),('16100','2013-10-16','12:55:00',6.71),('16100','2013-10-16','13:00:00',6.76),('16100','2013-10-16','13:05:00',6.78),('16100','2013-10-16','13:10:00',6.77),('16100','2013-10-16','13:15:00',6.77),('16100','2013-10-16','13:20:00',6.73),('16100','2013-10-16','13:25:00',6.73),('16100','2013-10-16','13:30:00',6.7),('16100','2013-10-16','13:35:00',6.69),('16100','2013-10-16','13:40:00',6.64),('16100','2013-10-16','13:45:00',6.61),('16100','2013-10-16','13:50:00',6.55),('16100','2013-10-16','13:55:00',6.51),('16100','2013-10-16','14:00:00',6.44),('16100','2013-10-16','14:05:00',6.36),('16100','2013-10-16','14:10:00',6.32),('16100','2013-10-16','14:15:00',6.24),('16100','2013-10-16','14:20:00',6.16),('16100','2013-10-16','14:25:00',6.15),('16100','2013-10-16','14:30:00',6.11),('16100','2013-10-16','14:35:00',6.02),('16100','2013-10-16','14:40:00',5.93),('16100','2013-10-16','14:45:00',5.82),('16100','2013-10-16','14:50:00',5.77),('16100','2013-10-16','14:55:00',5.65),('16100','2013-10-16','15:00:00',5.55),('16100','2013-10-16','15:05:00',5.48),('16100','2013-10-16','15:10:00',5.39),('16100','2013-10-16','15:15:00',5.26),('16100','2013-10-16','15:20:00',5.14),('16100','2013-10-16','15:25:00',5.02),('16100','2013-10-16','15:30:00',4.88),('16100','2013-10-16','15:35:00',4.77),('16100','2013-10-16','15:40:00',4.66),('16100','2013-10-16','15:45:00',4.52),('16100','2013-10-16','15:50:00',4.33),('16100','2013-10-16','15:55:00',4.18),('16100','2013-10-16','16:00:00',4.05),('16100','2013-10-16','16:05:00',3.94),('16100','2013-10-16','16:10:00',3.84),('16100','2013-10-16','16:15:00',3.67),('16100','2013-10-16','16:20:00',3.53),('16100','2013-10-16','16:25:00',3.36),('16100','2013-10-16','16:30:00',3.2),('16100','2013-10-16','16:35:00',3.04),('16100','2013-10-16','16:40:00',2.85),('16100','2013-10-16','16:45:00',2.7),('16100','2013-10-16','16:50:00',2.56),('16100','2013-10-16','16:55:00',2.37),('16100','2013-10-16','17:00:00',1.8),('16100','2013-10-16','17:05:00',1.23),('16100','2013-10-16','17:10:00',1.87),('16100','2013-10-16','17:15:00',1.33),('16100','2013-10-16','17:20:00',1.5),('16100','2013-10-16','17:25:00',1.35),('16100','2013-10-16','17:30:00',1.18),('16100','2013-10-16','17:35:00',1.01),('16100','2013-10-15','09:40:00',2.73),('16100','2013-10-15','09:45:00',1.66),('16100','2013-10-15','09:50:00',1.19),('16100','2013-10-15','09:55:00',1.59),('16100','2013-10-15','10:00:00',1.48),('16100','2013-10-15','11:05:00',1.19),('16100','2013-10-15','11:10:00',1.86),('16100','2013-10-15','11:45:00',2.2),('16100','2013-10-15','11:50:00',1.42),('16100','2013-10-15','12:00:00',1.23),('16100','2013-10-15','12:05:00',2),('16100','2013-10-15','12:10:00',2.04),('16100','2013-10-15','12:15:00',3.04),('16100','2013-10-15','12:20:00',1.49),('16100','2013-10-15','12:25:00',1.02),('16100','2013-10-15','12:30:00',2.2),('16100','2013-10-15','12:35:00',2.77),('16100','2013-10-15','12:40:00',1.7),('16100','2013-10-15','12:45:00',2.16),('16100','2013-10-15','12:50:00',2.57),('16100','2013-10-15','12:55:00',2.41),('16100','2013-10-15','13:00:00',3.48),('16100','2013-10-15','13:05:00',4.08),('16100','2013-10-15','13:10:00',4.55),('16100','2013-10-15','13:15:00',6.31),('16100','2013-10-15','13:20:00',7.15),('16100','2013-10-15','13:25:00',7),('16100','2013-10-15','13:30:00',4.15),('16100','2013-10-15','13:35:00',2.41),('16100','2013-10-15','13:40:00',5.86),('16100','2013-10-15','13:45:00',6.12),('16100','2013-10-15','13:50:00',6.63),('16100','2013-10-15','13:55:00',3.14),('16100','2013-10-15','14:00:00',6.19),('16100','2013-10-15','14:05:00',6.71),('16100','2013-10-15','14:10:00',6.44),('16100','2013-10-15','14:15:00',6.13),('16100','2013-10-15','14:20:00',6.35),('16100','2013-10-15','14:25:00',6.29),('16100','2013-10-15','14:30:00',6.48),('16100','2013-10-15','14:35:00',4.23),('16100','2013-10-15','14:40:00',6.18),('16100','2013-10-15','14:45:00',5.98),('16100','2013-10-15','14:50:00',4.36),('16100','2013-10-15','14:55:00',4.39),('16100','2013-10-15','15:00:00',5.64),('16100','2013-10-15','15:05:00',5.32),('16100','2013-10-15','15:10:00',5.47),('16100','2013-10-15','15:15:00',5.38),('16100','2013-10-15','15:20:00',5.21),('16100','2013-10-15','15:25:00',5.15),('16100','2013-10-15','15:30:00',5.16),('16100','2013-10-15','15:35:00',4.06),('16100','2013-10-15','15:40:00',4.51),('16100','2013-10-15','15:45:00',4.49),('16100','2013-10-15','15:50:00',4.32),('16100','2013-10-15','15:55:00',4.19),('16100','2013-10-15','16:00:00',3.61),('16100','2013-10-15','16:05:00',3.83),('16100','2013-10-15','16:10:00',3.76),('16100','2013-10-15','16:15:00',3.64),('16100','2013-10-15','16:20:00',3.42),('16100','2013-10-15','16:25:00',3.19),('16100','2013-10-15','16:30:00',3.09),('16100','2013-10-15','16:35:00',3),('16100','2013-10-15','16:40:00',2.8),('16100','2013-10-15','16:45:00',2.65),('16100','2013-10-15','16:50:00',2.5),('16100','2013-10-15','16:55:00',2.33),('16100','2013-10-15','17:00:00',2.16),('16100','2013-10-15','17:05:00',2),('16100','2013-10-15','17:10:00',1.79),('16100','2013-10-15','17:15:00',1.59),('16100','2013-10-15','17:20:00',1.45),('16100','2013-10-15','17:25:00',1.28),('16100','2013-10-15','17:30:00',1.12),('16100','2013-10-14','09:00:00',1.09),('16100','2013-10-14','09:05:00',1.32),('16100','2013-10-14','09:10:00',1.27),('16100','2013-10-14','09:15:00',1.42),('16100','2013-10-14','09:20:00',1.62),('16100','2013-10-14','09:25:00',2.29),('16100','2013-10-14','09:30:00',1.31),('16100','2013-10-14','09:35:00',2.46),('16100','2013-10-14','09:40:00',2.61),('16100','2013-10-14','09:45:00',3.84),('16100','2013-10-14','09:50:00',4.33),('16100','2013-10-14','09:55:00',4.6),('16100','2013-10-14','10:00:00',3.95),('16100','2013-10-14','10:05:00',3.99),('16100','2013-10-14','10:10:00',2.61),('16100','2013-10-14','10:15:00',2.14),('16100','2013-10-14','10:20:00',2.94),('16100','2013-10-14','10:25:00',4.72),('16100','2013-10-14','10:30:00',3.94),('16100','2013-10-14','10:35:00',4.32),('16100','2013-10-14','10:40:00',5.06),('16100','2013-10-14','10:45:00',3.61),('16100','2013-10-14','10:50:00',3.22),('16100','2013-10-14','10:55:00',3.4),('16100','2013-10-14','11:00:00',3.46),('16100','2013-10-14','11:05:00',4.93),('16100','2013-10-14','11:10:00',5.57),('16100','2013-10-14','11:15:00',5.01),('16100','2013-10-14','11:20:00',4.92),('16100','2013-10-14','11:25:00',4.72),('16100','2013-10-14','11:30:00',4.44),('16100','2013-10-14','11:35:00',3.2),('16100','2013-10-14','11:40:00',2.74),('16100','2013-10-14','11:45:00',2.82),('16100','2013-10-14','11:50:00',2.87),('16100','2013-10-14','11:55:00',2.55),('16100','2013-10-14','12:00:00',2.51),('16100','2013-10-14','12:05:00',2.46),('16100','2013-10-14','12:10:00',2.43),('16100','2013-10-14','12:15:00',2.44),('16100','2013-10-14','12:20:00',2.49),('16100','2013-10-14','12:25:00',2.13),('16100','2013-10-14','12:30:00',2.17),('16100','2013-10-14','12:35:00',2.21),('16100','2013-10-14','12:40:00',2.42),('16100','2013-10-14','12:45:00',2.32),('16100','2013-10-14','12:50:00',1.98),('16100','2013-10-14','12:55:00',1.91),('16100','2013-10-14','13:00:00',2.22),('16100','2013-10-14','13:05:00',2.95),('16100','2013-10-14','13:10:00',3.02),('16100','2013-10-14','13:15:00',4.64),('16100','2013-10-14','13:20:00',5.35),('16100','2013-10-14','13:25:00',3.87),('16100','2013-10-14','13:30:00',3.32),('16100','2013-10-14','13:35:00',2.8),('16100','2013-10-14','13:40:00',3.03),('16100','2013-10-14','13:45:00',2.6),('16100','2013-10-14','13:50:00',2.19),('16100','2013-10-14','13:55:00',1.91),('16100','2013-10-14','14:00:00',1.84),('16100','2013-10-14','14:05:00',1.97),('16100','2013-10-14','14:10:00',2.58),('16100','2013-10-14','14:15:00',3.63),('16100','2013-10-14','14:20:00',4.18),('16100','2013-10-14','14:25:00',4.41),('16100','2013-10-14','14:30:00',2.69),('16100','2013-10-14','14:35:00',3.43),('16100','2013-10-14','14:40:00',4.14),('16100','2013-10-14','14:45:00',5.17),('16100','2013-10-14','14:50:00',4.11),('16100','2013-10-14','14:55:00',2.62),('16100','2013-10-14','15:00:00',2.89),('16100','2013-10-14','15:05:00',2.81),('16100','2013-10-14','15:10:00',2.35),('16100','2013-10-14','15:15:00',1.92),('16100','2013-10-14','15:20:00',1.7),('16100','2013-10-14','15:25:00',1.61),('16100','2013-10-14','15:30:00',1.64),('16100','2013-10-14','15:35:00',1.79),('16100','2013-10-14','15:40:00',1.79),('16100','2013-10-14','15:45:00',1.57),('16100','2013-10-14','15:50:00',1.34),('16100','2013-10-14','15:55:00',1.17),('16100','2013-10-14','16:00:00',1.14),('16100','2013-10-14','16:05:00',1.18),('16100','2013-10-14','16:10:00',1.16),('16100','2013-10-14','16:15:00',1.16),('16100','2013-10-14','16:20:00',1.55),('16100','2013-10-14','16:25:00',1.99),('16100','2013-10-14','16:30:00',2.22),('16100','2013-10-14','16:35:00',1.85),('16100','2013-10-14','16:40:00',1.42),('16100','2013-10-14','16:45:00',1.3),('16100','2013-10-14','16:50:00',1.44),('16100','2013-10-14','16:55:00',1.38),('16100','2013-10-14','17:00:00',1.06),('16100','2013-10-13','08:20:00',1.18),('16100','2013-10-13','08:25:00',1.32),('16100','2013-10-13','08:30:00',1.48),('16100','2013-10-13','08:35:00',1.56),('16100','2013-10-13','08:40:00',1.59),('16100','2013-10-13','08:45:00',1.68),('16100','2013-10-13','08:50:00',1.94),('16100','2013-10-13','08:55:00',1.9),('16100','2013-10-13','09:00:00',1.82),('16100','2013-10-13','09:05:00',1.64),('16100','2013-10-13','09:10:00',1.41),('16100','2013-10-13','09:15:00',2.12),('16100','2013-10-13','09:20:00',2.82),('16100','2013-10-13','09:25:00',3.02),('16100','2013-10-13','09:30:00',3.39),('16100','2013-10-13','09:35:00',2.33),('16100','2013-10-13','09:40:00',2.61),('16100','2013-10-13','09:45:00',3.21),('16100','2013-10-13','09:50:00',3.63),('16100','2013-10-13','09:55:00',3.65),('16100','2013-10-13','10:00:00',4.23),('16100','2013-10-13','10:05:00',4.29),('16100','2013-10-13','10:10:00',4.45),('16100','2013-10-13','10:15:00',4.55),('16100','2013-10-13','10:20:00',4.67),('16100','2013-10-13','10:25:00',4.8),('16100','2013-10-13','10:30:00',4.92),('16100','2013-10-13','10:35:00',4.92),('16100','2013-10-13','10:40:00',4.93),('16100','2013-10-13','10:45:00',5.03),('16100','2013-10-13','10:50:00',5.3),('16100','2013-10-13','10:55:00',5.37),('16100','2013-10-13','11:00:00',5.37),('16100','2013-10-13','11:05:00',5.23),('16100','2013-10-13','11:10:00',5.64),('16100','2013-10-13','11:15:00',5.54),('16100','2013-10-13','11:20:00',5.71),('16100','2013-10-13','11:25:00',5.9),('16100','2013-10-13','11:30:00',5.94),('16100','2013-10-13','11:35:00',5.9),('16100','2013-10-13','11:40:00',5.96),('16100','2013-10-13','11:45:00',5.89),('16100','2013-10-13','11:50:00',5.99),('16100','2013-10-13','11:55:00',6.08),('16100','2013-10-13','12:00:00',6.14),('16100','2013-10-13','12:05:00',6.17),('16100','2013-10-13','12:10:00',6.27),('16100','2013-10-13','12:15:00',5.98),('16100','2013-10-13','12:20:00',5.8),('16100','2013-10-13','12:25:00',6.37),('16100','2013-10-13','12:30:00',6.38),('16100','2013-10-13','12:35:00',6.36),('16100','2013-10-13','12:40:00',6.36),('16100','2013-10-13','12:45:00',6.36),('16100','2013-10-13','12:50:00',6.33),('16100','2013-10-13','12:55:00',6.29),('16100','2013-10-13','13:00:00',6.33),('16100','2013-10-13','13:05:00',6.31),('16100','2013-10-13','13:10:00',6.29),('16100','2013-10-13','13:15:00',6.28),('16100','2013-10-13','13:20:00',6.26),('16100','2013-10-13','13:25:00',6.23),('16100','2013-10-13','13:30:00',6.2),('16100','2013-10-13','13:35:00',6.18),('16100','2013-10-13','13:40:00',6.1),('16100','2013-10-13','13:45:00',6.04),('16100','2013-10-13','13:50:00',6.01),('16100','2013-10-13','13:55:00',5.96),('16100','2013-10-13','14:00:00',5.9),('16100','2013-10-13','14:05:00',5.8),('16100','2013-10-13','14:10:00',5.76),('16100','2013-10-13','14:15:00',4.85),('16100','2013-10-13','14:20:00',5.36),('16100','2013-10-13','14:25:00',5.59),('16100','2013-10-13','14:30:00',5.56),('16100','2013-10-13','14:35:00',5.51),('16100','2013-10-13','14:40:00',5.42),('16100','2013-10-13','14:45:00',5.35),('16100','2013-10-13','14:50:00',5.28),('16100','2013-10-13','14:55:00',5.23),('16100','2013-10-13','15:00:00',5.16),('16100','2013-10-13','15:05:00',5.07),('16100','2013-10-13','15:10:00',4.98),('16100','2013-10-13','15:15:00',4.86),('16100','2013-10-13','15:20:00',4.73),('16100','2013-10-13','15:25:00',4.62),('16100','2013-10-13','15:30:00',4.48),('16100','2013-10-13','15:35:00',4.38),('16100','2013-10-13','15:40:00',4.25),('16100','2013-10-13','15:45:00',2.88),('16100','2013-10-13','15:50:00',1.57),('16100','2013-10-13','15:55:00',2.34),('16100','2013-10-13','16:00:00',2.04),('16100','2013-10-13','16:05:00',1.58),('16100','2013-10-13','16:10:00',2.06),('16100','2013-10-13','16:15:00',2.46),('16100','2013-10-13','16:20:00',2.41),('16100','2013-10-13','16:25:00',2.49),('16100','2013-10-13','16:30:00',1.76),('16100','2013-10-13','16:35:00',1.25),('16100','2013-10-13','16:40:00',2.7),('16100','2013-10-13','16:45:00',1.88),('16100','2013-10-13','16:50:00',1.52),('16100','2013-10-13','17:15:00',1.29),('16100','2013-10-12','08:35:00',1.12),('16100','2013-10-12','08:40:00',1.13),('16100','2013-10-12','08:45:00',1.21),('16100','2013-10-12','08:50:00',1.46),('16100','2013-10-12','08:55:00',1.88),('16100','2013-10-12','09:00:00',1.92),('16100','2013-10-12','09:05:00',1.94),('16100','2013-10-12','09:10:00',2.38),('16100','2013-10-12','09:15:00',3),('16100','2013-10-12','09:20:00',3.21),('16100','2013-10-12','09:25:00',2.41),('16100','2013-10-12','09:30:00',1.96),('16100','2013-10-12','09:35:00',2.23),('16100','2013-10-12','09:40:00',4.74),('16100','2013-10-12','09:45:00',4.39),('16100','2013-10-12','09:50:00',3.84),('16100','2013-10-12','09:55:00',4.33),('16100','2013-10-12','10:00:00',3.48),('16100','2013-10-12','10:05:00',3.63),('16100','2013-10-12','10:10:00',4.56),('16100','2013-10-12','10:15:00',3.84),('16100','2013-10-12','10:20:00',2.78),('16100','2013-10-12','10:25:00',3.31),('16100','2013-10-12','10:30:00',4.73),('16100','2013-10-12','10:35:00',6.28),('16100','2013-10-12','10:40:00',6.19),('16100','2013-10-12','10:45:00',5.96),('16100','2013-10-12','10:50:00',6.23),('16100','2013-10-12','10:55:00',5.57),('16100','2013-10-12','11:00:00',3.94),('16100','2013-10-12','11:05:00',4.96),('16100','2013-10-12','11:10:00',5.52),('16100','2013-10-12','11:15:00',5.9),('16100','2013-10-12','11:20:00',5.64),('16100','2013-10-12','11:25:00',5.29),('16100','2013-10-12','11:30:00',5.94),('16100','2013-10-12','11:35:00',6.01),('16100','2013-10-12','11:40:00',5.96),('16100','2013-10-12','11:45:00',5.86),('16100','2013-10-12','11:50:00',5.99),('16100','2013-10-12','11:55:00',6.19),('16100','2013-10-12','12:00:00',6.24),('16100','2013-10-12','12:05:00',6.3),('16100','2013-10-12','12:10:00',6.26),('16100','2013-10-12','12:15:00',6.31),('16100','2013-10-12','12:20:00',6.31),('16100','2013-10-12','12:25:00',6.3),('16100','2013-10-12','12:30:00',6.24),('16100','2013-10-12','12:35:00',6.45),('16100','2013-10-12','12:40:00',6.34),('16100','2013-10-12','12:45:00',6.32),('16100','2013-10-12','12:50:00',6.33),('16100','2013-10-12','12:55:00',4.63),('16100','2013-10-12','13:00:00',6.23),('16100','2013-10-12','13:05:00',6.32),('16100','2013-10-12','13:10:00',6.46),('16100','2013-10-12','13:15:00',6.49),('16100','2013-10-12','13:20:00',6.45),('16100','2013-10-12','13:25:00',5.8),('16100','2013-10-12','13:30:00',6.2),('16100','2013-10-12','13:35:00',5.92),('16100','2013-10-12','13:40:00',6.52),('16100','2013-10-12','13:45:00',6.27),('16100','2013-10-12','13:50:00',6.25),('16100','2013-10-12','13:55:00',5.91),('16100','2013-10-12','14:00:00',4.35),('16100','2013-10-12','14:05:00',6.65),('16100','2013-10-12','14:10:00',5.7),('16100','2013-10-12','14:15:00',6.2),('16100','2013-10-12','14:20:00',6.3),('16100','2013-10-12','14:25:00',6.22),('16100','2013-10-12','14:30:00',5.34),('16100','2013-10-12','14:35:00',4.02),('16100','2013-10-12','14:40:00',4.94),('16100','2013-10-12','14:45:00',4.99),('16100','2013-10-12','14:50:00',4.47),('16100','2013-10-12','14:55:00',4.76),('16100','2013-10-12','15:00:00',4.43),('16100','2013-10-12','15:05:00',5.25),('16100','2013-10-12','15:10:00',5.12),('16100','2013-10-12','15:15:00',4.38),('16100','2013-10-12','15:20:00',4.36),('16100','2013-10-12','15:25:00',3.26),('16100','2013-10-12','15:30:00',3.5),('16100','2013-10-12','15:35:00',3.12),('16100','2013-10-12','15:40:00',2.54),('16100','2013-10-12','15:45:00',2.71),('16100','2013-10-12','15:50:00',2.78),('16100','2013-10-12','15:55:00',3.56),('16100','2013-10-12','16:00:00',3.36),('16100','2013-10-12','16:05:00',3.3),('16100','2013-10-12','16:10:00',3.6),('16100','2013-10-12','16:15:00',3.81),('16100','2013-10-12','16:20:00',3.39),('16100','2013-10-12','16:25:00',2.42),('16100','2013-10-12','16:30:00',2.46),('16100','2013-10-12','16:35:00',3.05),('16100','2013-10-12','16:40:00',1.75),('16100','2013-10-12','16:45:00',1.49),('16100','2013-10-12','16:50:00',1.41),('16100','2013-10-12','16:55:00',1.03),('16100','2013-10-12','17:20:00',1.55),('16100','2013-10-12','17:25:00',1.24),('16100','2013-10-12','17:30:00',1.32),('16100','2013-10-12','17:35:00',1.18),('16100','2013-10-11','11:00:00',1.14),('16100','2013-10-11','11:05:00',1.2),('16100','2013-10-11','11:10:00',1.32),('16100','2013-10-11','11:15:00',1.56),('16100','2013-10-11','11:20:00',1.94),('16100','2013-10-11','11:25:00',2.01),('16100','2013-10-11','11:30:00',2.98),('16100','2013-10-11','11:35:00',4.32),('16100','2013-10-11','11:40:00',2.7),('16100','2013-10-11','11:45:00',2.17),('16100','2013-10-11','11:50:00',2),('16100','2013-10-11','11:55:00',1.4),('16100','2013-10-11','12:00:00',1.06),('16100','2013-10-11','12:05:00',1.19),('16100','2013-10-11','12:10:00',1.62),('16100','2013-10-11','12:15:00',2.21),('16100','2013-10-11','12:20:00',5.23),('16100','2013-10-11','12:25:00',4.93),('16100','2013-10-11','12:30:00',4.79),('16100','2013-10-11','12:35:00',6.47),('16100','2013-10-11','12:40:00',6.96),('16100','2013-10-11','12:45:00',5.22),('16100','2013-10-11','12:50:00',5.8),('16100','2013-10-11','12:55:00',5.32),('16100','2013-10-11','13:00:00',4.72),('16100','2013-10-11','13:05:00',1.37),('16100','2013-10-11','13:10:00',1),('16100','2013-10-11','13:15:00',1.49),('16100','2013-10-11','13:20:00',2.14),('16100','2013-10-11','13:25:00',3.17),('16100','2013-10-11','13:30:00',2.35),('16100','2013-10-11','13:55:00',1.23),('16100','2013-10-11','15:15:00',1.09),('16100','2013-10-11','15:20:00',1.22),('16100','2013-10-11','15:25:00',1.32),('16100','2013-10-11','15:30:00',1.31),('16100','2013-10-11','15:40:00',1.04),('16100','2013-10-11','15:45:00',1.09),('16100','2013-10-11','15:50:00',1.31),('16100','2013-10-11','15:55:00',1.44),('16100','2013-10-11','16:00:00',1.57),('16100','2013-10-11','16:05:00',1.48),('16100','2013-10-11','16:10:00',1.58),('16100','2013-10-11','16:15:00',3.59),('16100','2013-10-11','16:20:00',3.57),('16100','2013-10-11','16:25:00',2.45),('16100','2013-10-11','16:30:00',1.6),('16100','2013-10-11','16:35:00',1.86),('16100','2013-10-11','16:40:00',1.35),('16100','2013-10-10','08:20:00',1.12),('16100','2013-10-10','08:25:00',1.3),('16100','2013-10-10','08:30:00',1.51),('16100','2013-10-10','08:35:00',1.78),('16100','2013-10-10','08:40:00',1.99),('16100','2013-10-10','08:45:00',2.14),('16100','2013-10-10','08:50:00',1.85),('16100','2013-10-10','08:55:00',2.19),('16100','2013-10-10','09:00:00',2.51),('16100','2013-10-10','09:05:00',2.69),('16100','2013-10-10','09:10:00',2.86),('16100','2013-10-10','09:15:00',3.05),('16100','2013-10-10','09:20:00',3.23),('16100','2013-10-10','09:25:00',3.41),('16100','2013-10-10','09:30:00',3.57),('16100','2013-10-10','09:35:00',3.76),('16100','2013-10-10','09:40:00',3.92),('16100','2013-10-10','09:45:00',4.04),('16100','2013-10-10','09:50:00',4.2),('16100','2013-10-10','09:55:00',4.35),('16100','2013-10-10','10:00:00',4.41),('16100','2013-10-10','10:05:00',4.63),('16100','2013-10-10','10:10:00',4.94),('16100','2013-10-10','10:15:00',5.32),('16100','2013-10-10','10:20:00',5.7),('16100','2013-10-10','10:25:00',6.13),('16100','2013-10-10','10:30:00',4.35),('16100','2013-10-10','10:35:00',6.21),('16100','2013-10-10','10:40:00',4.14),('16100','2013-10-10','10:45:00',5.53),('16100','2013-10-10','10:50:00',5.14),('16100','2013-10-10','10:55:00',2.86),('16100','2013-10-10','11:00:00',2.28),('16100','2013-10-10','11:05:00',2.29),('16100','2013-10-10','11:10:00',2.08),('16100','2013-10-10','11:15:00',1.65),('16100','2013-10-10','11:20:00',1.42),('16100','2013-10-10','11:25:00',1.47),('16100','2013-10-10','11:30:00',1.58),('16100','2013-10-10','11:35:00',1.67),('16100','2013-10-10','11:40:00',2.15),('16100','2013-10-10','11:45:00',4.19),('16100','2013-10-10','11:50:00',1.13),('16100','2013-10-10','12:15:00',3.73),('16100','2013-10-10','12:20:00',7.19),('16100','2013-10-10','12:25:00',2),('16100','2013-10-10','12:30:00',1.31),('16100','2013-10-10','13:00:00',1.44),('16100','2013-10-10','13:30:00',1.97),('16100','2013-10-10','13:35:00',1.51),('16100','2013-10-10','13:40:00',1.9),('16100','2013-10-10','13:45:00',3.42),('16100','2013-10-10','13:50:00',3.55),('16100','2013-10-10','13:55:00',1.29),('16100','2013-10-10','14:35:00',1.37),('16100','2013-10-10','15:45:00',1.01),('16100','2013-10-10','16:15:00',1.31),('16100','2013-10-10','16:20:00',2.09),('16100','2013-10-10','16:25:00',1),('16100','2013-10-10','16:30:00',2.54),('16100','2013-10-10','16:35:00',3.71),('16100','2013-10-10','16:40:00',3.38),('16100','2013-10-10','16:45:00',1.84),('16100','2013-10-10','16:50:00',1.57),('16100','2013-10-10','17:00:00',1.63),('16100','2013-10-10','17:05:00',1.6),('16100','2013-10-10','17:10:00',2.03),('16100','2013-10-10','17:15:00',1.36),('16100','2013-10-10','17:25:00',1.3),('16100','2013-10-09','08:20:00',1.07),('16100','2013-10-09','08:25:00',1.27),('16100','2013-10-09','08:30:00',1.48),('16100','2013-10-09','08:35:00',1.67),('16100','2013-10-09','08:40:00',1.9),('16100','2013-10-09','08:45:00',2.1),('16100','2013-10-09','08:50:00',2.32),('16100','2013-10-09','08:55:00',2.57),('16100','2013-10-09','09:00:00',2.8),('16100','2013-10-09','09:05:00',2.9),('16100','2013-10-09','09:10:00',3),('16100','2013-10-09','09:15:00',3.08),('16100','2013-10-09','09:20:00',3.28),('16100','2013-10-09','09:25:00',3.46),('16100','2013-10-09','09:30:00',3.61),('16100','2013-10-09','09:35:00',3.78),('16100','2013-10-09','09:40:00',3.96),('16100','2013-10-09','09:45:00',3.96),('16100','2013-10-09','09:50:00',4.09),('16100','2013-10-09','09:55:00',4.23),('16100','2013-10-09','10:00:00',3.85),('16100','2013-10-09','10:05:00',4.57),('16100','2013-10-09','10:10:00',5.05),('16100','2013-10-09','10:15:00',5.44),('16100','2013-10-09','10:20:00',3.57),('16100','2013-10-09','10:40:00',1.16),('16100','2013-10-09','10:45:00',1.01),('16100','2013-10-09','10:50:00',1.37),('16100','2013-10-09','10:55:00',3.1),('16100','2013-10-09','11:00:00',1.51),('16100','2013-10-09','11:10:00',2.95),('16100','2013-10-09','11:15:00',4.27),('16100','2013-10-09','11:20:00',6.01),('16100','2013-10-09','11:25:00',6.13),('16100','2013-10-09','11:30:00',4.37),('16100','2013-10-09','11:35:00',4.31),('16100','2013-10-09','11:40:00',6.6),('16100','2013-10-09','11:45:00',2.48),('16100','2013-10-09','11:50:00',4.91),('16100','2013-10-09','11:55:00',7.29),('16100','2013-10-09','12:00:00',7.98),('16100','2013-10-09','12:05:00',7.57),('16100','2013-10-09','12:10:00',3.47),('16100','2013-10-09','12:15:00',1.76),('16100','2013-10-09','12:20:00',3.78),('16100','2013-10-09','12:25:00',7.98),('16100','2013-10-09','12:30:00',1.85),('16100','2013-10-09','12:35:00',7.44),('16100','2013-10-09','12:40:00',2.5),('16100','2013-10-09','12:45:00',3.53),('16100','2013-10-09','12:50:00',3.82),('16100','2013-10-09','12:55:00',6.08),('16100','2013-10-09','13:00:00',8.17),('16100','2013-10-09','13:05:00',7.69),('16100','2013-10-09','13:10:00',6.2),('16100','2013-10-09','13:15:00',2.36),('16100','2013-10-09','13:20:00',3.69),('16100','2013-10-09','13:25:00',4.34),('16100','2013-10-09','13:30:00',6.54),('16100','2013-10-09','13:35:00',4.19),('16100','2013-10-09','13:40:00',7.53),('16100','2013-10-09','13:45:00',6.42),('16100','2013-10-09','13:50:00',7.57),('16100','2013-10-09','13:55:00',7.25),('16100','2013-10-09','14:00:00',7.21),('16100','2013-10-09','14:05:00',7.08),('16100','2013-10-09','14:10:00',7.37),('16100','2013-10-09','14:15:00',1.63),('16100','2013-10-09','14:20:00',2.36),('16100','2013-10-09','14:25:00',1.94),('16100','2013-10-09','14:30:00',3.93),('16100','2013-10-09','14:35:00',1.95),('16100','2013-10-09','14:40:00',4.11),('16100','2013-10-09','14:45:00',3.97),('16100','2013-10-09','14:50:00',6.96),('16100','2013-10-09','14:55:00',3.29),('16100','2013-10-09','15:00:00',6.23),('16100','2013-10-09','15:05:00',4.79),('16100','2013-10-09','15:10:00',4.65),('16100','2013-10-09','15:15:00',2.81),('16100','2013-10-09','15:20:00',2.31),('16100','2013-10-09','15:25:00',3.01),('16100','2013-10-09','15:30:00',3.31),('16100','2013-10-09','15:35:00',2.77),('16100','2013-10-09','15:40:00',1.83),('16100','2013-10-09','15:45:00',2.75),('16100','2013-10-09','15:50:00',1.64),('16100','2013-10-09','15:55:00',3.68),('16100','2013-10-09','16:00:00',4.16),('16100','2013-10-09','16:05:00',5.64),('16100','2013-10-09','16:10:00',4.69),('16100','2013-10-09','16:15:00',2.62),('16100','2013-10-09','16:20:00',4.13),('16100','2013-10-09','16:25:00',4.17),('16100','2013-10-09','16:30:00',4.32),('16100','2013-10-09','16:35:00',4.08),('16100','2013-10-09','16:40:00',2.3),('16100','2013-10-09','16:55:00',3.19),('16100','2013-10-09','17:00:00',2.67),('16100','2013-10-09','17:05:00',2.14),('16100','2013-10-09','17:10:00',2.47),('16100','2013-10-09','17:15:00',2.48),('16100','2013-10-09','17:20:00',1.76),('16100','2013-10-08','08:25:00',1.16),('16100','2013-10-08','08:35:00',1.76),('16100','2013-10-08','08:40:00',1.93),('16100','2013-10-08','08:45:00',2.09),('16100','2013-10-08','08:50:00',2.32),('16100','2013-10-08','08:55:00',2.52),('16100','2013-10-08','09:00:00',2.68),('16100','2013-10-08','09:05:00',2.91),('16100','2013-10-08','09:10:00',3.09),('16100','2013-10-08','09:15:00',2.87),('16100','2013-10-08','09:20:00',3.45),('16100','2013-10-08','09:25:00',3.66),('16100','2013-10-08','09:30:00',4.02),('16100','2013-10-08','09:35:00',4.55),('16100','2013-10-08','09:40:00',4.85),('16100','2013-10-08','09:45:00',5.09),('16100','2013-10-08','09:50:00',4.92),('16100','2013-10-08','09:55:00',5.06),('16100','2013-10-08','10:00:00',4.41),('16100','2013-10-08','10:05:00',2.04),('16100','2013-10-08','10:10:00',1.18),('16100','2013-10-08','10:15:00',1.12),('16100','2013-10-08','10:20:00',2.13),('16100','2013-10-08','10:25:00',3.8),('16100','2013-10-08','10:30:00',5.63),('16100','2013-10-08','10:35:00',3.31),('16100','2013-10-08','10:40:00',2.97),('16100','2013-10-08','11:10:00',1.11),('16100','2013-10-08','11:15:00',1.36),('16100','2013-10-08','11:20:00',2.74),('16100','2013-10-08','11:25:00',4.05),('16100','2013-10-08','11:30:00',2.04),('16100','2013-10-08','11:35:00',5.4),('16100','2013-10-08','11:40:00',2.68),('16100','2013-10-08','11:45:00',3.47),('16100','2013-10-08','11:50:00',2.55),('16100','2013-10-08','11:55:00',4.13),('16100','2013-10-08','12:00:00',4.14),('16100','2013-10-08','12:05:00',3.09),('16100','2013-10-08','12:10:00',1.71),('16100','2013-10-08','12:25:00',1.31),('16100','2013-10-08','12:30:00',2.76),('16100','2013-10-08','12:35:00',1.84),('16100','2013-10-08','12:40:00',1.58),('16100','2013-10-08','12:45:00',1.42),('16100','2013-10-08','12:50:00',1.85),('16100','2013-10-08','12:55:00',2.15),('16100','2013-10-08','13:00:00',2.88),('16100','2013-10-08','13:05:00',4.08),('16100','2013-10-08','13:10:00',5.95),('16100','2013-10-08','13:15:00',5.45),('16100','2013-10-08','13:20:00',5.3),('16100','2013-10-08','13:25:00',3.33),('16100','2013-10-08','13:30:00',2.14),('16100','2013-10-08','13:35:00',2.42),('16100','2013-10-08','13:40:00',3.93),('16100','2013-10-08','13:45:00',2.87),('16100','2013-10-08','13:50:00',5.72),('16100','2013-10-08','13:55:00',7.26),('16100','2013-10-08','14:00:00',7.36),('16100','2013-10-08','14:05:00',7.05),('16100','2013-10-08','14:10:00',7.15),('16100','2013-10-08','14:15:00',5.03),('16100','2013-10-08','14:20:00',5.22),('16100','2013-10-08','14:25:00',2.32),('16100','2013-10-08','14:30:00',1.32),('16100','2013-10-08','14:35:00',2.28),('16100','2013-10-08','14:40:00',6.01),('16100','2013-10-08','14:45:00',4.64),('16100','2013-10-08','14:50:00',2.55),('16100','2013-10-08','14:55:00',4.25),('16100','2013-10-08','15:00:00',5.34),('16100','2013-10-08','15:05:00',5.82),('16100','2013-10-08','15:10:00',3.48),('16100','2013-10-08','15:15:00',1.68),('16100','2013-10-08','15:20:00',3.99),('16100','2013-10-08','15:25:00',4.4),('16100','2013-10-08','15:30:00',2.56),('16100','2013-10-08','15:35:00',2.42),('16100','2013-10-08','15:40:00',1.92),('16100','2013-10-08','15:45:00',4.53),('16100','2013-10-08','15:50:00',2.85),('16100','2013-10-08','15:55:00',3.97),('16100','2013-10-08','16:00:00',2.61),('16100','2013-10-08','16:05:00',1.35),('16100','2013-10-08','16:10:00',2.81),('16100','2013-10-08','16:15:00',3.48),('16100','2013-10-08','16:20:00',2.78),('16100','2013-10-08','16:25:00',3.82),('16100','2013-10-08','16:30:00',4.13),('16100','2013-10-08','16:35:00',2.88),('16100','2013-10-08','16:40:00',1.31),('16100','2013-10-08','16:45:00',1.12),('16100','2013-10-08','16:55:00',2.17),('16100','2013-10-08','17:30:00',1.14),('16100','2013-10-08','17:35:00',2.03),('16100','2013-10-08','17:40:00',1.28),('16100','2014-04-14','07:55:00',1.14),('16100','2014-04-14','08:55:00',2.75),('16100','2014-04-14','09:00:00',3.31),('16100','2014-04-14','09:05:00',2.67),('16100','2014-04-14','09:10:00',3.94),('16100','2014-04-14','09:15:00',3.48),('16100','2014-04-14','09:20:00',2.43),('16100','2014-04-14','09:25:00',1.69),('16100','2014-04-14','09:30:00',3.49),('16100','2014-04-14','09:35:00',3.28),('16100','2014-04-14','09:40:00',1.97),('16100','2014-04-14','09:45:00',3.58),('16100','2014-04-14','09:50:00',1.34),('16100','2014-04-14','10:00:00',1.04),('16100','2014-04-14','10:05:00',2.28),('16100','2014-04-14','10:10:00',2.44),('16100','2014-04-14','10:15:00',2.89),('16100','2014-04-14','10:20:00',3),('16100','2014-04-14','10:25:00',6.61),('16100','2014-04-14','10:30:00',5.4),('16100','2014-04-14','10:35:00',6.86),('16100','2014-04-14','10:40:00',6.17),('16100','2014-04-14','10:45:00',4.78),('16100','2014-04-14','10:50:00',6.53),('16100','2014-04-14','10:55:00',3.24),('16100','2014-04-14','11:00:00',4.4),('16100','2014-04-14','11:05:00',5.57),('16100','2014-04-14','11:10:00',4.2),('16100','2014-04-14','11:15:00',4.66),('16100','2014-04-14','11:20:00',1.54),('16100','2014-04-14','11:25:00',2.33),('16100','2014-04-14','11:30:00',2.29),('16100','2014-04-14','11:35:00',1.5),('16100','2014-04-14','11:40:00',1.69),('16100','2014-04-14','11:45:00',2.14),('16100','2014-04-14','11:50:00',1.92),('16100','2014-04-14','11:55:00',1.65),('16100','2014-04-14','12:00:00',1.07),('16100','2014-04-14','12:10:00',2.5),('16100','2014-04-14','12:15:00',3.73),('16100','2014-04-14','12:20:00',4.07),('16100','2014-04-14','12:25:00',1.55),('16100','2014-04-14','12:35:00',1.01),('16100','2014-04-14','12:40:00',1.01),('16100','2014-04-14','13:05:00',2.37),('16100','2014-04-14','13:10:00',3.62),('16100','2014-04-14','13:15:00',3.66),('16100','2014-04-14','13:20:00',2.91),('16100','2014-04-14','13:25:00',3.56),('16100','2014-04-14','13:30:00',2.72),('16100','2014-04-14','13:35:00',1.81),('16100','2014-04-14','13:40:00',3.57),('16100','2014-04-14','13:45:00',4.04),('16100','2014-04-14','13:50:00',4.45),('16100','2014-04-14','13:55:00',5.81),('16100','2014-04-14','14:00:00',5.22),('16100','2014-04-14','14:05:00',6.63),('16100','2014-04-14','14:10:00',8.3),('16100','2014-04-14','14:15:00',5.68),('16100','2014-04-14','14:20:00',6.22),('16100','2014-04-14','14:25:00',3.94),('16100','2014-04-14','14:30:00',3.09),('16100','2014-04-14','14:35:00',6.4),('16100','2014-04-14','14:40:00',8.13),('16100','2014-04-14','14:45:00',6.91),('16100','2014-04-14','14:50:00',6.49),('16100','2014-04-14','14:55:00',4.78),('16100','2014-04-14','15:00:00',3.24),('16100','2014-04-14','15:05:00',2.65),('16100','2014-04-14','15:10:00',2.8),('16100','2014-04-14','15:15:00',5.58),('16100','2014-04-14','15:20:00',7.75),('16100','2014-04-14','15:25:00',5.93),('16100','2014-04-14','15:30:00',3.99),('16100','2014-04-14','15:35:00',3.3),('16100','2014-04-14','15:40:00',3.53),('16100','2014-04-14','15:45:00',2.78),('16100','2014-04-14','15:50:00',2.37),('16100','2014-04-14','15:55:00',1.81),('16100','2014-04-14','16:00:00',1.81),('16100','2014-04-14','16:05:00',1.63),('16100','2014-04-14','16:10:00',1.4),('16100','2014-04-14','16:15:00',1.26),('16100','2013-10-07','08:05:00',1.02),('16100','2013-10-07','08:10:00',1.42),('16100','2013-10-07','08:15:00',1.77),('16100','2013-10-07','08:20:00',1.07),('16100','2013-10-07','09:50:00',3.75),('16100','2013-10-07','09:55:00',1.44),('16100','2013-10-07','10:00:00',5.3),('16100','2013-10-07','10:05:00',6.01),('16100','2013-10-07','10:10:00',5.76),('16100','2013-10-07','10:15:00',3.39),('16100','2013-10-07','10:20:00',1.11),('16100','2013-10-07','10:55:00',1.1),('16100','2013-10-07','11:00:00',1.38),('16100','2013-10-07','11:05:00',1.34),('16100','2013-10-07','11:10:00',1.24),('16100','2013-10-07','11:15:00',1.25),('16100','2013-10-07','11:20:00',2.47),('16100','2013-10-07','11:25:00',4.07),('16100','2013-10-07','11:30:00',1.55),('16100','2013-10-07','11:35:00',1.16),('16100','2013-10-07','12:25:00',1.92),('16100','2013-10-07','12:30:00',1.84),('16100','2013-10-07','12:35:00',4.43),('16100','2013-10-07','12:40:00',2.92),('16100','2013-10-07','12:45:00',1.76),('16100','2013-10-07','12:50:00',2.02),('16100','2013-10-07','12:55:00',4.46),('16100','2013-10-07','13:00:00',3.58),('16100','2013-10-07','13:05:00',6.15),('16100','2013-10-07','13:10:00',4.15),('16100','2013-10-07','13:15:00',1.97),('16100','2013-10-07','13:20:00',4.42),('16100','2013-10-07','13:25:00',4.2),('16100','2013-10-07','13:30:00',1.79),('16100','2013-10-07','13:35:00',1.77),('16100','2013-10-07','13:40:00',1.35),('16100','2013-10-07','13:45:00',1.8),('16100','2013-10-07','13:50:00',2.08),('16100','2013-10-07','13:55:00',1.41),('16100','2013-10-07','14:00:00',1.1),('16100','2013-10-07','14:20:00',1.92),('16100','2013-10-07','14:25:00',2.6),('16100','2013-10-07','14:30:00',5.1),('16100','2013-10-07','14:35:00',7.83),('16100','2013-10-07','14:40:00',6.38),('16100','2013-10-07','14:45:00',5.56),('16100','2013-10-07','14:50:00',6.32),('16100','2013-10-07','14:55:00',6.16),('16100','2013-10-07','15:00:00',6.06),('16100','2013-10-07','15:05:00',5.96),('16100','2013-10-07','15:10:00',6),('16100','2013-10-07','15:15:00',4.47),('16100','2013-10-07','15:20:00',4.99),('16100','2013-10-07','15:25:00',2.33),('16100','2013-10-07','15:30:00',1.45),('16100','2013-10-07','15:35:00',1.01),('16100','2013-10-07','15:45:00',1.28),('16100','2013-10-07','15:55:00',1.05),('16100','2013-10-06','08:20:00',1.16),('16100','2013-10-06','08:25:00',1.35),('16100','2013-10-06','08:30:00',1.42),('16100','2013-10-06','08:35:00',1.66),('16100','2013-10-06','08:40:00',1.96),('16100','2013-10-06','08:45:00',1.26),('16100','2013-10-06','09:00:00',1.05),('16100','2013-10-06','09:05:00',1.47),('16100','2013-10-06','09:10:00',3.1),('16100','2013-10-06','09:15:00',3.84),('16100','2013-10-06','09:20:00',3.5),('16100','2013-10-06','09:25:00',3.55),('16100','2013-10-06','09:30:00',3.7),('16100','2013-10-06','09:35:00',3.85),('16100','2013-10-06','09:40:00',3.95),('16100','2013-10-06','09:45:00',4.1),('16100','2013-10-06','09:50:00',4.22),('16100','2013-10-06','09:55:00',4.35),('16100','2013-10-06','10:00:00',4.52),('16100','2013-10-06','10:05:00',4.59),('16100','2013-10-06','10:10:00',4.72),('16100','2013-10-06','10:15:00',4.85),('16100','2013-10-06','10:20:00',4.96),('16100','2013-10-06','10:25:00',5.11),('16100','2013-10-06','10:30:00',5.28),('16100','2013-10-06','10:35:00',5.43),('16100','2013-10-06','10:40:00',5.52),('16100','2013-10-06','10:45:00',5.43),('16100','2013-10-06','10:50:00',4.99),('16100','2013-10-06','10:55:00',5.47),('16100','2013-10-06','11:00:00',4.78),('16100','2013-10-06','11:05:00',6.08),('16100','2013-10-06','11:10:00',6.07),('16100','2013-10-06','11:15:00',6.07),('16100','2013-10-06','11:20:00',6.12),('16100','2013-10-06','11:25:00',6.18),('16100','2013-10-06','11:30:00',6.26),('16100','2013-10-06','11:35:00',6.51),('16100','2013-10-06','11:40:00',6.49),('16100','2013-10-06','11:45:00',6.63),('16100','2013-10-06','11:50:00',3.46),('16100','2013-10-06','11:55:00',6.36),('16100','2013-10-06','12:00:00',6.86),('16100','2013-10-06','12:05:00',6.71),('16100','2013-10-06','12:10:00',2.2),('16100','2013-10-06','12:15:00',5.89),('16100','2013-10-06','12:20:00',7.18),('16100','2013-10-06','12:25:00',3.65),('16100','2013-10-06','12:30:00',5.11),('16100','2013-10-06','12:35:00',3.13),('16100','2013-10-06','12:40:00',1.35),('16100','2013-10-06','12:45:00',4.05),('16100','2013-10-06','12:50:00',2.58),('16100','2013-10-06','12:55:00',3.94),('16100','2013-10-06','13:00:00',2.76),('16100','2013-10-06','13:05:00',7.77),('16100','2013-10-06','13:10:00',5.01),('16100','2013-10-06','13:15:00',7.48),('16100','2013-10-06','13:20:00',4.8),('16100','2013-10-06','13:25:00',5.71),('16100','2013-10-06','13:30:00',1.49),('16100','2013-10-06','13:35:00',3.38),('16100','2013-10-06','13:40:00',1.22),('16100','2013-10-06','13:45:00',1.4),('16100','2013-10-06','13:50:00',4.4),('16100','2013-10-06','13:55:00',2.34),('16100','2013-10-06','14:00:00',2.95),('16100','2013-10-06','14:05:00',7.43),('16100','2013-10-06','14:10:00',8.33),('16100','2013-10-06','14:15:00',6.25),('16100','2013-10-06','14:20:00',4.93),('16100','2013-10-06','14:25:00',3.86),('16100','2013-10-06','14:30:00',6.35),('16100','2013-10-06','14:35:00',3.55),('16100','2013-10-06','14:40:00',4.22),('16100','2013-10-06','14:45:00',4.05),('16100','2013-10-06','14:50:00',6.4),('16100','2013-10-06','14:55:00',4.44),('16100','2013-10-06','15:00:00',2.2),('16100','2013-10-06','15:05:00',6),('16100','2013-10-06','15:10:00',3.92),('16100','2013-10-06','15:15:00',4.53),('16100','2013-10-06','15:20:00',2.47),('16100','2013-10-06','15:25:00',1.52),('16100','2013-10-06','15:30:00',2.48),('16100','2013-10-06','15:35:00',6.49),('16100','2013-10-06','15:40:00',3.14),('16100','2013-10-06','15:45:00',3.7),('16100','2013-10-06','15:50:00',3.19),('16100','2013-10-06','15:55:00',5.37),('16100','2013-10-06','16:00:00',4.81),('16100','2013-10-06','16:05:00',1.61),('16100','2013-10-06','16:10:00',1.85),('16100','2013-10-06','16:15:00',3.53),('16100','2013-10-06','16:20:00',4.51),('16100','2013-10-06','16:25:00',4.16),('16100','2013-10-06','16:30:00',3.16),('16100','2013-10-06','16:35:00',3.7),('16100','2013-10-06','16:40:00',3.49),('16100','2013-10-06','16:45:00',3.27),('16100','2013-10-06','16:50:00',3.03),('16100','2013-10-06','16:55:00',2.8),('16100','2013-10-06','17:00:00',2.6),('16100','2013-10-06','17:05:00',2.46),('16100','2013-10-06','17:10:00',2.28),('16100','2013-10-06','17:15:00',2.12),('16100','2013-10-06','17:20:00',1.95),('16100','2013-10-06','17:25:00',1.76),('16100','2013-10-06','17:30:00',1.59),('16100','2013-10-06','17:35:00',1.43),('16100','2013-10-06','17:40:00',1.26),('16100','2013-10-06','17:45:00',1.1),('16100','2013-10-05','08:55:00',1.33),('16100','2013-10-05','09:00:00',1.29),('16100','2013-10-05','09:05:00',2.12),('16100','2013-10-05','09:10:00',1.22),('16100','2013-10-05','09:20:00',1.51),('16100','2013-10-05','09:25:00',2.2),('16100','2013-10-05','09:30:00',3.84),('16100','2013-10-05','09:35:00',3.9),('16100','2013-10-05','09:40:00',3.53),('16100','2013-10-05','09:45:00',3.1),('16100','2013-10-05','09:50:00',4.21),('16100','2013-10-05','09:55:00',4.5),('16100','2013-10-05','10:00:00',4.82),('16100','2013-10-05','10:05:00',4.35),('16100','2013-10-05','10:10:00',4.42),('16100','2013-10-05','10:15:00',4.32),('16100','2013-10-05','10:20:00',4.28),('16100','2013-10-05','10:25:00',4.88),('16100','2013-10-05','10:30:00',4.78),('16100','2013-10-05','10:35:00',4.38),('16100','2013-10-05','10:40:00',3.65),('16100','2013-10-05','10:45:00',4.13),('16100','2013-10-05','10:50:00',4.48),('16100','2013-10-05','10:55:00',4.8),('16100','2013-10-05','11:00:00',5.57),('16100','2013-10-05','11:05:00',4.84),('16100','2013-10-05','11:10:00',5.6),('16100','2013-10-05','11:15:00',5.62),('16100','2013-10-05','11:20:00',5.4),('16100','2013-10-05','11:25:00',5.06),('16100','2013-10-05','11:30:00',5.17),('16100','2013-10-05','11:35:00',4.45),('16100','2013-10-05','11:40:00',4.11),('16100','2013-10-05','11:45:00',2.94),('16100','2013-10-05','11:50:00',4.84),('16100','2013-10-05','11:55:00',4.33),('16100','2013-10-05','12:00:00',6.18),('16100','2013-10-05','12:05:00',6.11),('16100','2013-10-05','12:10:00',6.73),('16100','2013-10-05','12:15:00',5.18),('16100','2013-10-05','12:20:00',5.31),('16100','2013-10-05','12:25:00',4.8),('16100','2013-10-05','12:30:00',3.16),('16100','2013-10-05','12:35:00',6.33),('16100','2013-10-05','12:40:00',5.46),('16100','2013-10-05','12:45:00',6.14),('16100','2013-10-05','12:50:00',6.9),('16100','2013-10-05','12:55:00',6.31),('16100','2013-10-05','13:00:00',6.61),('16100','2013-10-05','13:05:00',6.91),('16100','2013-10-05','13:10:00',5.44),('16100','2013-10-05','13:15:00',6.15),('16100','2013-10-05','13:20:00',5.8),('16100','2013-10-05','13:25:00',3.23),('16100','2013-10-05','13:30:00',1.86),('16100','2013-10-05','13:35:00',1.47),('16100','2013-10-05','13:40:00',1.39),('16100','2013-10-05','13:45:00',1.54),('16100','2013-10-05','13:50:00',2.6),('16100','2013-10-05','13:55:00',4.27),('16100','2013-10-05','14:00:00',4.03),('16100','2013-10-05','14:05:00',5.5),('16100','2013-10-05','14:10:00',4.12),('16100','2013-10-05','14:15:00',4.61),('16100','2013-10-05','14:20:00',3.71),('16100','2013-10-05','14:25:00',3.59),('16100','2013-10-05','14:30:00',4.83),('16100','2013-10-05','14:35:00',4.69),('16100','2013-10-05','14:40:00',5),('16100','2013-10-05','14:45:00',2.94),('16100','2013-10-05','14:50:00',2.05),('16100','2013-10-05','14:55:00',3.03),('16100','2013-10-05','15:00:00',3.29),('16100','2013-10-05','15:05:00',3.86),('16100','2013-10-05','15:10:00',3.1),('16100','2013-10-05','15:15:00',2.75),('16100','2013-10-05','15:20:00',1.76),('16100','2013-10-05','15:25:00',1.57),('16100','2013-10-05','15:30:00',1.52),('16100','2013-10-05','15:35:00',1.43),('16100','2013-10-05','15:40:00',1.24),('16100','2013-10-05','15:45:00',1.09),('16100','2013-10-05','15:55:00',2.16),('16100','2013-10-05','16:00:00',1.6),('16100','2013-10-05','16:05:00',1.01),('16100','2013-10-05','17:10:00',1.74),('16100','2013-10-05','17:15:00',1.48),('16100','2013-10-05','17:20:00',1.25),('16100','2013-10-04','15:35:00',1.05),('16100','2013-10-04','15:40:00',1.07),('16100','2013-10-04','15:45:00',1.15),('16100','2013-10-04','15:50:00',1.29),('16100','2013-10-04','15:55:00',1.51),('16100','2013-10-04','16:00:00',2),('16100','2013-10-04','16:05:00',2.14),('16100','2013-10-04','16:10:00',1.9),('16100','2013-10-04','16:15:00',1.88),('16100','2013-10-04','16:20:00',1.79),('16100','2013-10-04','16:25:00',1.52),('16100','2013-10-04','16:30:00',1.38),('16100','2013-10-04','16:35:00',1.54),('16100','2013-10-04','16:40:00',1.36),('16100','2013-10-04','16:45:00',1.83),('16100','2013-10-04','16:50:00',1.75),('16100','2013-10-04','16:55:00',1.86),('16100','2013-10-04','17:00:00',1.13),('16100','2013-10-04','17:05:00',1.15),('16100','2013-10-04','17:10:00',1.2),('16100','2013-10-04','17:15:00',1.12),('16100','2013-10-03','08:45:00',1.09),('16100','2013-10-03','08:55:00',1.03),('16100','2013-10-03','09:05:00',1.14),('16100','2013-10-03','09:10:00',1.08),('16100','2013-10-03','09:15:00',1),('16100','2013-10-03','09:20:00',1.5),('16100','2013-10-03','09:25:00',1.69),('16100','2013-10-03','09:30:00',1.86),('16100','2013-10-03','09:35:00',1.76),('16100','2013-10-03','09:40:00',1.72),('16100','2013-10-03','09:45:00',2.06),('16100','2013-10-03','09:50:00',2.95),('16100','2013-10-03','09:55:00',3.62),('16100','2013-10-03','10:00:00',2.36),('16100','2013-10-03','10:05:00',2.31),('16100','2013-10-03','10:10:00',2.65),('16100','2013-10-03','10:15:00',2.41),('16100','2013-10-03','10:20:00',2.74),('16100','2013-10-03','10:25:00',3.53),('16100','2013-10-03','10:30:00',4.39),('16100','2013-10-03','10:35:00',2.78),('16100','2013-10-03','10:40:00',6.98),('16100','2013-10-03','10:45:00',5.02),('16100','2013-10-03','10:50:00',4.79),('16100','2013-10-03','10:55:00',4.5),('16100','2013-10-03','11:00:00',2.89),('16100','2013-10-03','11:05:00',2.67),('16100','2013-10-03','11:10:00',3.59),('16100','2013-10-03','11:15:00',4.23),('16100','2013-10-03','11:20:00',4.26),('16100','2013-10-03','11:25:00',7.33),('16100','2013-10-03','11:30:00',6.37),('16100','2013-10-03','11:35:00',6.31),('16100','2013-10-03','11:40:00',6.76),('16100','2013-10-03','11:45:00',6.63),('16100','2013-10-03','11:50:00',6.64),('16100','2013-10-03','11:55:00',6.73),('16100','2013-10-03','12:00:00',6.85),('16100','2013-10-03','12:05:00',6.9),('16100','2013-10-03','12:10:00',6.79),('16100','2013-10-03','12:15:00',6.94),('16100','2013-10-03','12:20:00',6.98),('16100','2013-10-03','12:25:00',7.15),('16100','2013-10-03','12:30:00',6.89),('16100','2013-10-03','12:35:00',6.96),('16100','2013-10-03','12:40:00',6.83),('16100','2013-10-03','12:45:00',6.92),('16100','2013-10-03','12:50:00',6.62),('16100','2013-10-03','12:55:00',6.74),('16100','2013-10-03','13:00:00',6.79),('16100','2013-10-03','13:05:00',6.76),('16100','2013-10-03','13:10:00',6.95),('16100','2013-10-03','13:15:00',7.05),('16100','2013-10-03','13:20:00',6.58),('16100','2013-10-03','13:25:00',6.8),('16100','2013-10-03','13:30:00',7.08),('16100','2013-10-03','13:35:00',6.8),('16100','2013-10-03','13:40:00',6.76),('16100','2013-10-03','13:45:00',6.65),('16100','2013-10-03','13:50:00',6.71),('16100','2013-10-03','13:55:00',6.78),('16100','2013-10-03','14:00:00',6.71),('16100','2013-10-03','14:05:00',6.26),('16100','2013-10-03','14:10:00',5.38),('16100','2013-10-03','14:15:00',5.61),('16100','2013-10-03','14:20:00',6.54),('16100','2013-10-03','14:25:00',5.69),('16100','2013-10-03','14:30:00',4.58),('16100','2013-10-03','14:35:00',3.24),('16100','2013-10-03','14:40:00',3.34),('16100','2013-10-03','14:45:00',4.43),('16100','2013-10-03','14:50:00',5.12),('16100','2013-10-03','14:55:00',4.06),('16100','2013-10-03','15:00:00',4.73),('16100','2013-10-03','15:05:00',4.37),('16100','2013-10-03','15:10:00',3.42),('16100','2013-10-03','15:15:00',2.74),('16100','2013-10-03','15:20:00',4.11),('16100','2013-10-03','15:25:00',3.59),('16100','2013-10-03','15:30:00',2.61),('16100','2013-10-03','15:35:00',1.96),('16100','2013-10-03','15:40:00',1.5),('16100','2013-10-03','15:45:00',1.33),('16100','2013-10-03','15:50:00',1.33),('16100','2013-10-03','15:55:00',1.61),('16100','2013-10-03','16:00:00',1.9),('16100','2013-10-03','16:05:00',1.81),('16100','2013-10-03','16:10:00',1.5),('16100','2013-10-03','16:15:00',1.29),('16100','2013-10-02','08:15:00',1.16),('16100','2013-10-02','08:20:00',1.35),('16100','2013-10-02','08:25:00',1.54),('16100','2013-10-02','08:30:00',1.74),('16100','2013-10-02','08:35:00',1.95),('16100','2013-10-02','08:40:00',2.14),('16100','2013-10-02','08:45:00',2.33),('16100','2013-10-02','08:50:00',2.54),('16100','2013-10-02','08:55:00',2.74),('16100','2013-10-02','09:00:00',2.92),('16100','2013-10-02','09:05:00',3.1),('16100','2013-10-02','09:10:00',3.26),('16100','2013-10-02','09:15:00',3.42),('16100','2013-10-02','09:20:00',3.66),('16100','2013-10-02','09:25:00',3.85),('16100','2013-10-02','09:30:00',4.01),('16100','2013-10-02','09:35:00',4.15),('16100','2013-10-02','09:40:00',4.31),('16100','2013-10-02','09:45:00',4.42),('16100','2013-10-02','09:50:00',4.6),('16100','2013-10-02','09:55:00',4.77),('16100','2013-10-02','10:00:00',4.9),('16100','2013-10-02','10:05:00',5.06),('16100','2013-10-02','10:10:00',5.17),('16100','2013-10-02','10:15:00',5.31),('16100','2013-10-02','10:20:00',5.47),('16100','2013-10-02','10:25:00',5.59),('16100','2013-10-02','10:30:00',5.72),('16100','2013-10-02','10:35:00',5.89),('16100','2013-10-02','10:40:00',5.99),('16100','2013-10-02','10:45:00',6.05),('16100','2013-10-02','10:50:00',6.16),('16100','2013-10-02','10:55:00',6.26),('16100','2013-10-02','11:00:00',6.32),('16100','2013-10-02','11:05:00',6.4),('16100','2013-10-02','11:10:00',6.5),('16100','2013-10-02','11:15:00',6.64),('16100','2013-10-02','11:20:00',6.74),('16100','2013-10-02','11:25:00',6.79),('16100','2013-10-02','11:30:00',6.84),('16100','2013-10-02','11:35:00',6.91),('16100','2013-10-02','11:40:00',7.01),('16100','2013-10-02','11:45:00',7.08),('16100','2013-10-02','11:50:00',7.15),('16100','2013-10-02','11:55:00',7.1),('16100','2013-10-02','12:00:00',7.14),('16100','2013-10-02','12:05:00',7.19),('16100','2013-10-02','12:10:00',7.24),('16100','2013-10-02','12:15:00',7.29),('16100','2013-10-02','12:20:00',7.32),('16100','2013-10-02','12:25:00',7.36),('16100','2013-10-02','12:30:00',7.35),('16100','2013-10-02','12:35:00',7.35),('16100','2013-10-02','12:40:00',7.41),('16100','2013-10-02','12:45:00',7.45),('16100','2013-10-02','12:50:00',7.44),('16100','2013-10-02','12:55:00',7.47),('16100','2013-10-02','13:00:00',7.46),('16100','2013-10-02','13:05:00',7.47),('16100','2013-10-02','13:10:00',7.51),('16100','2013-10-02','13:15:00',7.44),('16100','2013-10-02','13:20:00',7.47),('16100','2013-10-02','13:25:00',7.46),('16100','2013-10-02','13:30:00',7.44),('16100','2013-10-02','13:35:00',7.37),('16100','2013-10-02','13:40:00',7.32),('16100','2013-10-02','13:45:00',7.27),('16100','2013-10-02','13:50:00',7.27),('16100','2013-10-02','13:55:00',7.23),('16100','2013-10-02','14:00:00',7.11),('16100','2013-10-02','14:05:00',7.07),('16100','2013-10-02','14:10:00',6.99),('16100','2013-10-02','14:15:00',6.92),('16100','2013-10-02','14:20:00',6.88),('16100','2013-10-02','14:25:00',6.8),('16100','2013-10-02','14:30:00',6.75),('16100','2013-10-02','14:35:00',6.66),('16100','2013-10-02','14:40:00',6.59),('16100','2013-10-02','14:45:00',6.51),('16100','2013-10-02','14:50:00',6.41),('16100','2013-10-02','14:55:00',6.3),('16100','2013-10-02','15:00:00',6.19),('16100','2013-10-02','15:05:00',6.14),('16100','2013-10-02','15:10:00',5.95),('16100','2013-10-02','15:15:00',5.87),('16100','2013-10-02','15:20:00',5.76),('16100','2013-10-02','15:25:00',5.68),('16100','2013-10-02','15:30:00',5.56),('16100','2013-10-02','15:35:00',5.4),('16100','2013-10-02','15:40:00',5.32),('16100','2013-10-02','15:45:00',5.27),('16100','2013-10-02','15:50:00',5.13),('16100','2013-10-02','15:55:00',5),('16100','2013-10-02','16:00:00',4.82),('16100','2013-10-02','16:05:00',4.69),('16100','2013-10-02','16:10:00',4.55),('16100','2013-10-02','16:15:00',4.4),('16100','2013-10-02','16:20:00',4.26),('16100','2013-10-02','16:25:00',4.11),('16100','2013-10-02','16:30:00',3.96),('16100','2013-10-02','16:35:00',3.79),('16100','2013-10-02','16:40:00',3.63),('16100','2013-10-02','16:45:00',3.45),('16100','2013-10-02','16:50:00',3.28),('16100','2013-10-02','16:55:00',3.1),('16100','2013-10-02','17:00:00',2.91),('16100','2013-10-02','17:05:00',2.72),('16100','2013-10-02','17:10:00',2.53),('16100','2013-10-02','17:15:00',2.33),('16100','2013-10-02','17:20:00',2.12),('16100','2013-10-02','17:25:00',1.95),('16100','2013-10-02','17:30:00',1.78),('16100','2013-10-02','17:35:00',1.6),('16100','2013-10-02','17:40:00',1.4),('16100','2013-10-02','17:45:00',1.24),('16100','2013-10-02','17:50:00',1.07),('16100','2013-10-01','08:20:00',1.16),('16100','2013-10-01','08:25:00',1.4),('16100','2013-10-01','08:30:00',1.63),('16100','2013-10-01','08:35:00',1.81),('16100','2013-10-01','08:40:00',2),('16100','2013-10-01','08:45:00',2.19),('16100','2013-10-01','08:50:00',2.39),('16100','2013-10-01','08:55:00',2.58),('16100','2013-10-01','09:00:00',2.76),('16100','2013-10-01','09:05:00',2.91),('16100','2013-10-01','09:10:00',3.07),('16100','2013-10-01','09:15:00',3.24),('16100','2013-10-01','09:20:00',3.47),('16100','2013-10-01','09:25:00',3.65),('16100','2013-10-01','09:30:00',3.8),('16100','2013-10-01','09:35:00',3.93),('16100','2013-10-01','09:40:00',4.06),('16100','2013-10-01','09:45:00',4.21),('16100','2013-10-01','09:50:00',4.38),('16100','2013-10-01','09:55:00',4.53),('16100','2013-10-01','10:00:00',4.69),('16100','2013-10-01','10:05:00',4.8),('16100','2013-10-01','10:10:00',4.92),('16100','2013-10-01','10:15:00',5.03),('16100','2013-10-01','10:20:00',5.14),('16100','2013-10-01','10:25:00',5.29),('16100','2013-10-01','10:30:00',5.46),('16100','2013-10-01','10:35:00',5.57),('16100','2013-10-01','10:40:00',5.64),('16100','2013-10-01','10:45:00',5.72),('16100','2013-10-01','10:50:00',5.83),('16100','2013-10-01','10:55:00',5.89),('16100','2013-10-01','11:00:00',5.99),('16100','2013-10-01','11:05:00',6.09),('16100','2013-10-01','11:10:00',6.18),('16100','2013-10-01','11:15:00',6.3),('16100','2013-10-01','11:20:00',6.42),('16100','2013-10-01','11:25:00',6.48),('16100','2013-10-01','11:30:00',6.56),('16100','2013-10-01','11:35:00',6.61),('16100','2013-10-01','11:40:00',6.67),('16100','2013-10-01','11:45:00',6.7),('16100','2013-10-01','11:50:00',6.73),('16100','2013-10-01','11:55:00',6.84),('16100','2013-10-01','12:00:00',6.87),('16100','2013-10-01','12:05:00',6.9),('16100','2013-10-01','12:10:00',6.94),('16100','2013-10-01','12:15:00',6.95),('16100','2013-10-01','12:20:00',7.02),('16100','2013-10-01','12:25:00',7.08),('16100','2013-10-01','12:30:00',7.12),('16100','2013-10-01','12:35:00',7.17),('16100','2013-10-01','12:40:00',7.14),('16100','2013-10-01','12:45:00',7.15),('16100','2013-10-01','12:50:00',7.15),('16100','2013-10-01','12:55:00',7.19),('16100','2013-10-01','13:00:00',7.23),('16100','2013-10-01','13:05:00',7.19),('16100','2013-10-01','13:10:00',7.17),('16100','2013-10-01','13:15:00',7.15),('16100','2013-10-01','13:20:00',7.13),('16100','2013-10-01','13:25:00',7.09),('16100','2013-10-01','13:30:00',7.02),('16100','2013-10-01','13:35:00',7.03),('16100','2013-10-01','13:40:00',6.95),('16100','2013-10-01','13:45:00',6.92),('16100','2013-10-01','13:50:00',6.88),('16100','2013-10-01','13:55:00',6.9),('16100','2013-10-01','14:00:00',6.78),('16100','2013-10-01','14:05:00',6.73),('16100','2013-10-01','14:10:00',6.68),('16100','2013-10-01','14:15:00',6.64),('16100','2013-10-01','14:20:00',6.58),('16100','2013-10-01','14:25:00',6.49),('16100','2013-10-01','14:30:00',6.46),('16100','2013-10-01','14:35:00',6.48),('16100','2013-10-01','14:40:00',6.36),('16100','2013-10-01','14:45:00',6.27),('16100','2013-10-01','14:50:00',6.22),('16100','2013-10-01','14:55:00',6.14),('16100','2013-10-01','15:00:00',6.06),('16100','2013-10-01','15:05:00',5.96),('16100','2013-10-01','15:10:00',5.83),('16100','2013-10-01','15:15:00',5.71),('16100','2013-10-01','15:20:00',5.59),('16100','2013-10-01','15:25:00',5.54),('16100','2013-10-01','15:30:00',5.41),('16100','2013-10-01','15:35:00',5.3),('16100','2013-10-01','15:40:00',5.21),('16100','2013-10-01','15:45:00',5.07),('16100','2013-10-01','15:50:00',4.92),('16100','2013-10-01','15:55:00',4.83),('16100','2013-10-01','16:00:00',4.67),('16100','2013-10-01','16:05:00',4.54),('16100','2013-10-01','16:10:00',4.39),('16100','2013-10-01','16:15:00',4.22),('16100','2013-10-01','16:20:00',4.07),('16100','2013-10-01','16:25:00',3.94),('16100','2013-10-01','16:30:00',3.81),('16100','2013-10-01','16:35:00',3.63),('16100','2013-10-01','16:40:00',3.49),('16100','2013-10-01','16:45:00',3.29),('16100','2013-10-01','16:50:00',3.14),('16100','2013-10-01','16:55:00',2.96),('16100','2013-10-01','17:00:00',2.76),('16100','2013-10-01','17:05:00',2.54),('16100','2013-10-01','17:10:00',2.37),('16100','2013-10-01','17:15:00',2.18),('16100','2013-10-01','17:20:00',1.97),('16100','2013-10-01','17:25:00',1.77),('16100','2013-10-01','17:30:00',1.6),('16100','2013-10-01','17:35:00',1.46),('16100','2013-10-01','17:40:00',1.28),('16100','2013-10-01','17:45:00',1.1),('16100','2013-09-30','08:15:00',1.09),('16100','2013-09-30','08:20:00',1.19),('16100','2013-09-30','08:25:00',1.45),('16100','2013-09-30','08:30:00',1.66),('16100','2013-09-30','08:35:00',1.85),('16100','2013-09-30','08:40:00',2.03),('16100','2013-09-30','08:45:00',2.23),('16100','2013-09-30','08:50:00',2.4),('16100','2013-09-30','08:55:00',2.53),('16100','2013-09-30','09:00:00',2.75),('16100','2013-09-30','09:05:00',2.92),('16100','2013-09-30','09:10:00',3.05),('16100','2013-09-30','09:15:00',3.2),('16100','2013-09-30','09:20:00',3.41),('16100','2013-09-30','09:25:00',3.53),('16100','2013-09-30','09:30:00',3.71),('16100','2013-09-30','09:35:00',3.87),('16100','2013-09-30','09:40:00',3.96),('16100','2013-09-30','09:45:00',4.1),('16100','2013-09-30','09:50:00',4.31),('16100','2013-09-30','09:55:00',4.39),('16100','2013-09-30','10:00:00',4.45),('16100','2013-09-30','10:05:00',4.59),('16100','2013-09-30','10:10:00',4.69),('16100','2013-09-30','10:15:00',4.81),('16100','2013-09-30','10:20:00',5.01),('16100','2013-09-30','10:25:00',5.17),('16100','2013-09-30','10:30:00',5.34),('16100','2013-09-30','10:35:00',5.06),('16100','2013-09-30','10:40:00',4.81),('16100','2013-09-30','10:45:00',5.7),('16100','2013-09-30','10:50:00',5.81),('16100','2013-09-30','10:55:00',5.73),('16100','2013-09-30','11:00:00',5.86),('16100','2013-09-30','11:05:00',6.09),('16100','2013-09-30','11:10:00',6.2),('16100','2013-09-30','11:15:00',6.4),('16100','2013-09-30','11:20:00',6.62),('16100','2013-09-30','11:25:00',6.71),('16100','2013-09-30','11:30:00',6.54),('16100','2013-09-30','11:35:00',6.5),('16100','2013-09-30','11:40:00',6.63),('16100','2013-09-30','11:45:00',6.93),('16100','2013-09-30','11:50:00',7.09),('16100','2013-09-30','11:55:00',5.77),('16100','2013-09-30','12:00:00',7.34),('16100','2013-09-30','12:05:00',1.51),('16100','2013-09-30','12:10:00',4.15),('16100','2013-09-30','12:15:00',4.88),('16100','2013-09-30','12:20:00',4.04),('16100','2013-09-30','12:25:00',6.59),('16100','2013-09-30','12:30:00',7.42),('16100','2013-09-30','12:35:00',6.68),('16100','2013-09-30','12:40:00',2.9),('16100','2013-09-30','12:45:00',7.53),('16100','2013-09-30','12:50:00',5.54),('16100','2013-09-30','12:55:00',4.04),('16100','2013-09-30','13:00:00',2.08),('16100','2013-09-30','13:05:00',4.52),('16100','2013-09-30','13:10:00',6.95),('16100','2013-09-30','13:15:00',4.71),('16100','2013-09-30','13:20:00',3.49),('16100','2013-09-30','13:25:00',7.6),('16100','2013-09-30','13:30:00',7.42),('16100','2013-09-30','13:35:00',7.52),('16100','2013-09-30','13:40:00',7.29),('16100','2013-09-30','13:45:00',6.95),('16100','2013-09-30','13:50:00',6.87),('16100','2013-09-30','13:55:00',6.84),('16100','2013-09-30','14:00:00',6.76),('16100','2013-09-30','14:05:00',6.64),('16100','2013-09-30','14:10:00',6.59),('16100','2013-09-30','14:15:00',6.57),('16100','2013-09-30','14:20:00',6.5),('16100','2013-09-30','14:25:00',6.41),('16100','2013-09-30','14:30:00',6.2),('16100','2013-09-30','14:35:00',5.67),('16100','2013-09-30','14:40:00',5.25),('16100','2013-09-30','14:45:00',6.15),('16100','2013-09-30','14:50:00',6.44),('16100','2013-09-30','14:55:00',6.21),('16100','2013-09-30','15:00:00',6.08),('16100','2013-09-30','15:05:00',5.95),('16100','2013-09-30','15:10:00',5.79),('16100','2013-09-30','15:15:00',5.69),('16100','2013-09-30','15:20:00',5.59),('16100','2013-09-30','15:25:00',5.55),('16100','2013-09-30','15:30:00',5.42),('16100','2013-09-30','15:35:00',5.28),('16100','2013-09-30','15:40:00',5.14),('16100','2013-09-30','15:45:00',5.02),('16100','2013-09-30','15:50:00',4.9),('16100','2013-09-30','15:55:00',4.76),('16100','2013-09-30','16:00:00',4.61),('16100','2013-09-30','16:05:00',4.51),('16100','2013-09-30','16:10:00',4.4),('16100','2013-09-30','16:15:00',4.28),('16100','2013-09-30','16:20:00',4.14),('16100','2013-09-30','16:25:00',4),('16100','2013-09-30','16:30:00',3.87),('16100','2013-09-30','16:35:00',3.72),('16100','2013-09-30','16:40:00',3.54),('16100','2013-09-30','16:45:00',3.36),('16100','2013-09-30','16:50:00',3.21),('16100','2013-09-30','16:55:00',3.05),('16100','2013-09-30','17:00:00',2.81),('16100','2013-09-30','17:05:00',2.67),('16100','2013-09-30','17:10:00',2.51),('16100','2013-09-30','17:15:00',2.32),('16100','2013-09-30','17:20:00',2.11),('16100','2013-09-30','17:25:00',1.94),('16100','2013-09-30','17:30:00',1.77),('16100','2013-09-30','17:35:00',1.58),('16100','2013-09-30','17:40:00',1.44),('16100','2013-09-30','17:45:00',1.24),('16100','2013-09-30','17:50:00',1.09),('16100','2013-09-29','09:25:00',1.08),('16100','2013-09-29','09:30:00',1.23),('16100','2013-09-29','09:35:00',1.58),('16100','2013-09-29','09:40:00',1.92),('16100','2013-09-29','09:45:00',3.35),('16100','2013-09-29','09:50:00',2.88),('16100','2013-09-29','09:55:00',1.51),('16100','2013-09-29','10:00:00',1.43),('16100','2013-09-29','10:05:00',1.6),('16100','2013-09-29','10:10:00',1.85),('16100','2013-09-29','10:15:00',1.86),('16100','2013-09-29','10:20:00',1.91),('16100','2013-09-29','10:25:00',2.33),('16100','2013-09-29','10:30:00',2.73),('16100','2013-09-29','10:35:00',3.54),('16100','2013-09-29','10:40:00',4.28),('16100','2013-09-29','10:45:00',5.78),('16100','2013-09-29','10:50:00',5.76),('16100','2013-09-29','10:55:00',4.9),('16100','2013-09-29','11:00:00',5.2),('16100','2013-09-29','11:05:00',4.69),('16100','2013-09-29','11:10:00',6.4),('16100','2013-09-29','11:15:00',5.08),('16100','2013-09-29','11:20:00',4.92),('16100','2013-09-29','11:25:00',4.82),('16100','2013-09-29','11:30:00',6.26),('16100','2013-09-29','11:35:00',6.77),('16100','2013-09-29','11:40:00',3.85),('16100','2013-09-29','11:45:00',1.95),('16100','2013-09-29','11:50:00',3.86),('16100','2013-09-29','11:55:00',3.75),('16100','2013-09-29','12:00:00',4.83),('16100','2013-09-29','12:05:00',6.88),('16100','2013-09-29','12:10:00',3.78),('16100','2013-09-29','12:15:00',4.69),('16100','2013-09-29','12:20:00',7.35),('16100','2013-09-29','12:25:00',7.2),('16100','2013-09-29','12:30:00',7.18),('16100','2013-09-29','12:35:00',6.96),('16100','2013-09-29','12:40:00',5.87),('16100','2013-09-29','12:45:00',3.33),('16100','2013-09-29','12:50:00',7.46),('16100','2013-09-29','12:55:00',6.96),('16100','2013-09-29','13:00:00',7.42),('16100','2013-09-29','13:05:00',7.49),('16100','2013-09-29','13:10:00',4.75),('16100','2013-09-29','13:15:00',7.45),('16100','2013-09-29','13:20:00',5.67),('16100','2013-09-29','13:25:00',4.45),('16100','2013-09-29','13:30:00',6.16),('16100','2013-09-29','13:35:00',4),('16100','2013-09-29','13:40:00',8.35),('16100','2013-09-29','13:45:00',3.78),('16100','2013-09-29','13:50:00',1.47),('16100','2013-09-29','13:55:00',1.51),('16100','2013-09-29','14:00:00',1.8),('16100','2013-09-29','14:05:00',2.22),('16100','2013-09-29','14:10:00',2.08),('16100','2013-09-29','14:15:00',1.72),('16100','2013-09-29','14:20:00',1.56),('16100','2013-09-29','14:25:00',2.62),('16100','2013-09-29','14:30:00',6.48),('16100','2013-09-29','14:35:00',7.97),('16100','2013-09-29','14:40:00',7.09),('16100','2013-09-29','14:45:00',6.57),('16100','2013-09-29','14:50:00',2.53),('16100','2013-09-29','14:55:00',3.4),('16100','2013-09-29','15:00:00',2.91),('16100','2013-09-29','15:05:00',5.52),('16100','2013-09-29','15:10:00',4.33),('16100','2013-09-29','15:15:00',1.66),('16100','2013-09-29','15:20:00',4.05),('16100','2013-09-29','15:25:00',5.76),('16100','2013-09-29','15:30:00',2),('16100','2013-09-29','15:35:00',1.23),('16100','2013-09-29','15:55:00',3.19),('16100','2013-09-29','16:00:00',5.44),('16100','2013-09-29','16:05:00',5.44),('16100','2013-09-29','16:10:00',4.46),('16100','2013-09-29','16:15:00',4.67),('16100','2013-09-29','16:20:00',3.58),('16100','2013-09-29','16:25:00',1.43),('16100','2013-09-29','16:30:00',4.45),('16100','2013-09-29','16:35:00',2.25),('16100','2013-09-29','16:40:00',1.98),('16100','2013-09-29','16:45:00',3.85),('16100','2013-09-29','16:50:00',1.79),('16100','2013-09-29','16:55:00',2.72),('16100','2013-09-29','17:00:00',3.27),('16100','2013-09-29','17:05:00',3.4),('16100','2013-09-29','17:10:00',2.18),('16100','2013-09-29','17:30:00',1.53),('16100','2013-09-29','17:35:00',1.27),('16100','2013-09-29','17:40:00',1.13),('16100','2013-09-28','08:40:00',1.43),('16100','2013-09-28','08:45:00',1.76),('16100','2013-09-28','08:50:00',1.64),('16100','2013-09-28','08:55:00',1.43),('16100','2013-09-28','09:00:00',1.31),('16100','2013-09-28','09:05:00',1.09),('16100','2013-09-28','09:10:00',1.16),('16100','2013-09-28','09:15:00',1.23),('16100','2013-09-28','09:20:00',1.35),('16100','2013-09-28','09:25:00',1.46),('16100','2013-09-28','09:30:00',1.34),('16100','2013-09-28','09:35:00',1.23),('16100','2013-09-28','09:40:00',1.3),('16100','2013-09-28','09:45:00',1.54),('16100','2013-09-28','09:50:00',1.79),('16100','2013-09-28','09:55:00',2.34),('16100','2013-09-28','10:00:00',3.64),('16100','2013-09-28','10:05:00',3.41),('16100','2013-09-28','10:10:00',4.24),('16100','2013-09-28','10:15:00',3.78),('16100','2013-09-28','10:20:00',4.01),('16100','2013-09-28','10:25:00',4.27),('16100','2013-09-28','10:30:00',4.56),('16100','2013-09-28','10:35:00',4.66),('16100','2013-09-28','10:40:00',4.88),('16100','2013-09-28','10:45:00',5.09),('16100','2013-09-28','10:50:00',5.2),('16100','2013-09-28','10:55:00',4.94),('16100','2013-09-28','11:00:00',5.25),('16100','2013-09-28','11:05:00',4.96),('16100','2013-09-28','11:10:00',4.99),('16100','2013-09-28','11:15:00',5.43),('16100','2013-09-28','11:20:00',5.4),('16100','2013-09-28','11:25:00',5.26),('16100','2013-09-28','11:30:00',5.63),('16100','2013-09-28','11:35:00',5.52),('16100','2013-09-28','11:40:00',5.93),('16100','2013-09-28','11:45:00',6.08),('16100','2013-09-28','11:50:00',6.35),('16100','2013-09-28','11:55:00',6.2),('16100','2013-09-28','12:00:00',6.43),('16100','2013-09-28','12:05:00',6.29),('16100','2013-09-28','12:10:00',6.7),('16100','2013-09-28','12:15:00',4.15),('16100','2013-09-28','12:20:00',2.9),('16100','2013-09-28','12:25:00',2.21),('16100','2013-09-28','12:30:00',2.5),('16100','2013-09-28','12:35:00',2.35),('16100','2013-09-28','12:40:00',2.29),('16100','2013-09-28','12:45:00',1.89),('16100','2013-09-28','12:50:00',2.02),('16100','2013-09-28','12:55:00',1.8),('16100','2013-09-28','13:00:00',1.62),('16100','2013-09-28','13:05:00',1.19),('16100','2013-09-28','13:25:00',1.88),('16100','2013-09-28','13:30:00',3.05),('16100','2013-09-28','13:35:00',5.92),('16100','2013-09-28','13:40:00',3.33),('16100','2013-09-28','13:45:00',5.13),('16100','2013-09-28','13:50:00',4.86),('16100','2013-09-28','13:55:00',2.86),('16100','2013-09-28','14:00:00',3.37),('16100','2013-09-28','14:05:00',1.87),('16100','2013-09-28','14:10:00',1.77),('16100','2013-09-28','14:15:00',1.94),('16100','2013-09-28','14:20:00',2.05),('16100','2013-09-28','14:25:00',1.65),('16100','2013-09-28','14:30:00',1.41),('16100','2013-09-28','14:50:00',2.13),('16100','2013-09-28','14:55:00',1.42),('16100','2013-09-28','15:15:00',2.04),('16100','2013-09-28','15:20:00',1.25),('16100','2013-09-28','15:25:00',1.65),('16100','2013-09-28','15:30:00',1.18),('16100','2013-09-28','15:55:00',1.73),('16100','2013-09-28','16:00:00',1.71),('16100','2013-09-28','16:05:00',1.24),('16100','2013-09-28','16:20:00',1.32),('16100','2013-09-28','16:25:00',2.52),('16100','2013-09-28','16:30:00',3.29),('16100','2013-09-28','16:35:00',1.65),('16100','2013-09-28','16:40:00',1.1),('16100','2013-09-28','16:45:00',1.08),('16100','2014-04-13','08:05:00',1.16),('16100','2014-04-13','08:10:00',1.38),('16100','2014-04-13','08:15:00',1.64),('16100','2014-04-13','08:20:00',1.82),('16100','2014-04-13','08:25:00',2.01),('16100','2014-04-13','08:30:00',2.18),('16100','2014-04-13','08:35:00',2.36),('16100','2014-04-13','08:40:00',2.54),('16100','2014-04-13','08:45:00',2.71),('16100','2014-04-13','08:50:00',2.89),('16100','2014-04-13','08:55:00',3.06),('16100','2014-04-13','09:00:00',3.22),('16100','2014-04-13','09:05:00',3.38),('16100','2014-04-13','09:10:00',3.58),('16100','2014-04-13','09:15:00',3.73),('16100','2014-04-13','09:20:00',3.89),('16100','2014-04-13','09:25:00',4.04),('16100','2014-04-13','09:30:00',4.2),('16100','2014-04-13','09:35:00',4.33),('16100','2014-04-13','09:40:00',4.48),('16100','2014-04-13','09:45:00',4.64),('16100','2014-04-13','09:50:00',4.77),('16100','2014-04-13','09:55:00',4.91),('16100','2014-04-13','10:00:00',5.05),('16100','2014-04-13','10:05:00',5.17),('16100','2014-04-13','10:10:00',5.29),('16100','2014-04-13','10:15:00',5.39),('16100','2014-04-13','10:20:00',5.54),('16100','2014-04-13','10:25:00',5.69),('16100','2014-04-13','10:30:00',5.81),('16100','2014-04-13','10:35:00',5.9),('16100','2014-04-13','10:40:00',6),('16100','2014-04-13','10:45:00',6.12),('16100','2014-04-13','10:50:00',6.24),('16100','2014-04-13','10:55:00',6.33),('16100','2014-04-13','11:00:00',6.42),('16100','2014-04-13','11:05:00',6.49),('16100','2014-04-13','11:10:00',6.68),('16100','2014-04-13','11:15:00',6.75),('16100','2014-04-13','11:20:00',6.83),('16100','2014-04-13','11:25:00',6.87),('16100','2014-04-13','11:30:00',6.9),('16100','2014-04-13','11:35:00',6.99),('16100','2014-04-13','11:40:00',7.05),('16100','2014-04-13','11:45:00',7.06),('16100','2014-04-13','11:50:00',7.12),('16100','2014-04-13','11:55:00',7.21),('16100','2014-04-13','12:00:00',7.26),('16100','2014-04-13','12:05:00',7.34),('16100','2014-04-13','12:10:00',7.39),('16100','2014-04-13','12:15:00',7.41),('16100','2014-04-13','12:20:00',7.35),('16100','2014-04-13','12:25:00',7.41),('16100','2014-04-13','12:30:00',7.44),('16100','2014-04-13','12:35:00',7.43),('16100','2014-04-13','12:40:00',7.51),('16100','2014-04-13','12:45:00',7.58),('16100','2014-04-13','12:50:00',7.63),('16100','2014-04-13','12:55:00',7.7),('16100','2014-04-13','13:00:00',7.7),('16100','2014-04-13','13:05:00',7.73),('16100','2014-04-13','13:10:00',7.75),('16100','2014-04-13','13:15:00',7.69),('16100','2014-04-13','13:20:00',7.75),('16100','2014-04-13','13:25:00',7.73),('16100','2014-04-13','13:30:00',7.72),('16100','2014-04-13','13:35:00',7.69),('16100','2014-04-13','13:40:00',7.68),('16100','2014-04-13','13:45:00',7.65),('16100','2014-04-13','13:50:00',7.68),('16100','2014-04-13','13:55:00',7.66),('16100','2014-04-13','14:00:00',7.66),('16100','2014-04-13','14:05:00',7.6),('16100','2014-04-13','14:10:00',7.51),('16100','2014-04-13','14:15:00',7.48),('16100','2014-04-13','14:20:00',7.43),('16100','2014-04-13','14:25:00',7.4),('16100','2014-04-13','14:30:00',7.34),('16100','2014-04-13','14:35:00',7.26),('16100','2014-04-13','14:40:00',7.22),('16100','2014-04-13','14:45:00',7.17),('16100','2014-04-13','14:50:00',7.13),('16100','2014-04-13','14:55:00',7.05),('16100','2014-04-13','15:00:00',6.99),('16100','2014-04-13','15:05:00',6.93),('16100','2014-04-13','15:10:00',6.85),('16100','2014-04-13','15:15:00',6.74),('16100','2014-04-13','15:20:00',6.61),('16100','2014-04-13','15:25:00',6.52),('16100','2014-04-13','15:30:00',6.39),('16100','2014-04-13','15:35:00',6.3),('16100','2014-04-13','15:40:00',6.22),('16100','2014-04-13','15:45:00',6.12),('16100','2014-04-13','15:50:00',6.01),('16100','2014-04-13','15:55:00',5.89),('16100','2014-04-13','16:00:00',5.76),('16100','2014-04-13','16:05:00',5.66),('16100','2014-04-13','16:10:00',5.47),('16100','2014-04-13','16:15:00',5.35),('16100','2014-04-13','16:20:00',5.26),('16100','2014-04-13','16:25:00',5.09),('16100','2014-04-13','16:30:00',4.97),('16100','2014-04-13','16:35:00',4.84),('16100','2014-04-13','16:40:00',4.7),('16100','2014-04-13','16:45:00',4.57),('16100','2014-04-13','16:50:00',4.42),('16100','2014-04-13','16:55:00',4.25),('16100','2014-04-13','17:00:00',4.11),('16100','2014-04-13','17:05:00',3.94),('16100','2014-04-13','17:10:00',3.77),('16100','2014-04-13','17:15:00',3.64),('16100','2014-04-13','17:20:00',3.47),('16100','2014-04-13','17:25:00',3.27),('16100','2014-04-13','17:30:00',3.11),('16100','2014-04-13','17:35:00',2.94),('16100','2014-04-13','17:40:00',2.76),('16100','2014-04-13','17:45:00',2.57),('16100','2014-04-13','17:50:00',2.38),('16100','2014-04-13','17:55:00',2.23),('16100','2014-04-13','18:00:00',2.04),('16100','2014-04-13','18:05:00',1.86),('16100','2014-04-13','18:10:00',1.71),('16100','2014-04-13','18:15:00',1.57),('16100','2014-04-13','18:20:00',1.41),('16100','2014-04-13','18:25:00',1.23),('16100','2014-04-13','18:30:00',1.08),('16100','2013-09-27','08:20:00',1.13),('16100','2013-09-27','08:25:00',1.34),('16100','2013-09-27','08:30:00',1.55),('16100','2013-09-27','08:35:00',1.7),('16100','2013-09-27','08:40:00',1.86),('16100','2013-09-27','08:45:00',2.08),('16100','2013-09-27','08:50:00',2.26),('16100','2013-09-27','08:55:00',2.44),('16100','2013-09-27','09:00:00',2.62),('16100','2013-09-27','09:05:00',2.78),('16100','2013-09-27','09:10:00',2.88),('16100','2013-09-27','09:15:00',3.11),('16100','2013-09-27','09:20:00',3.3),('16100','2013-09-27','09:25:00',3.39),('16100','2013-09-27','09:30:00',3.57),('16100','2013-09-27','09:35:00',3.7),('16100','2013-09-27','09:40:00',3.86),('16100','2013-09-27','09:45:00',4.08),('16100','2013-09-27','09:50:00',4.39),('16100','2013-09-27','09:55:00',4),('16100','2013-09-27','10:00:00',3.76),('16100','2013-09-27','10:05:00',4.43),('16100','2013-09-27','10:10:00',4.87),('16100','2013-09-27','10:15:00',5.03),('16100','2013-09-27','10:20:00',5.15),('16100','2013-09-27','10:25:00',5.24),('16100','2013-09-27','10:30:00',5.58),('16100','2013-09-27','10:35:00',3.16),('16100','2013-09-27','10:40:00',4.23),('16100','2013-09-27','10:45:00',3.6),('16100','2013-09-27','10:50:00',3.02),('16100','2013-09-27','10:55:00',6.06),('16100','2013-09-27','11:00:00',6),('16100','2013-09-27','11:05:00',6.21),('16100','2013-09-27','11:10:00',6.47),('16100','2013-09-27','11:15:00',6.75),('16100','2013-09-27','11:20:00',3.68),('16100','2013-09-27','11:25:00',2.18),('16100','2013-09-27','11:30:00',7.06),('16100','2013-09-27','11:35:00',6.7),('16100','2013-09-27','11:40:00',6.12),('16100','2013-09-27','11:45:00',6.79),('16100','2013-09-27','11:50:00',6.27),('16100','2013-09-27','11:55:00',7.06),('16100','2013-09-27','12:00:00',6.22),('16100','2013-09-27','12:05:00',4.5),('16100','2013-09-27','12:10:00',7.11),('16100','2013-09-27','12:15:00',3.57),('16100','2013-09-27','12:20:00',6.83),('16100','2013-09-27','12:25:00',6.96),('16100','2013-09-27','12:30:00',7.02),('16100','2013-09-27','12:35:00',7.2),('16100','2013-09-27','12:40:00',7.05),('16100','2013-09-27','12:45:00',7.13),('16100','2013-09-27','12:50:00',7.09),('16100','2013-09-27','12:55:00',7.16),('16100','2013-09-27','13:00:00',5.28),('16100','2013-09-27','13:05:00',7.17),('16100','2013-09-27','13:10:00',4.92),('16100','2013-09-27','13:15:00',2.27),('16100','2013-09-27','13:20:00',5.42),('16100','2013-09-27','13:25:00',7.37),('16100','2013-09-27','13:30:00',4.32),('16100','2013-09-27','13:35:00',5.94),('16100','2013-09-27','13:40:00',5.17),('16100','2013-09-27','13:45:00',3.28),('16100','2013-09-27','13:50:00',7.27),('16100','2013-09-27','13:55:00',6.94),('16100','2013-09-27','14:00:00',5.89),('16100','2013-09-27','14:05:00',6.52),('16100','2013-09-27','14:10:00',4.55),('16100','2013-09-27','14:15:00',6.34),('16100','2013-09-27','14:20:00',6.6),('16100','2013-09-27','14:25:00',6.52),('16100','2013-09-27','14:30:00',6.06),('16100','2013-09-27','14:35:00',6.58),('16100','2013-09-27','14:40:00',6.48),('16100','2013-09-27','14:45:00',5.81),('16100','2013-09-27','14:50:00',6.24),('16100','2013-09-27','14:55:00',6.19),('16100','2013-09-27','15:00:00',5.78),('16100','2013-09-27','15:05:00',5.91),('16100','2013-09-27','15:10:00',4.59),('16100','2013-09-27','15:15:00',5.36),('16100','2013-09-27','15:20:00',4.52),('16100','2013-09-27','15:25:00',5.16),('16100','2013-09-27','15:30:00',4.35),('16100','2013-09-27','15:35:00',4.3),('16100','2013-09-27','15:40:00',2.41),('16100','2013-09-27','15:45:00',3.15),('16100','2013-09-27','15:50:00',3.01),('16100','2013-09-27','15:55:00',3.86),('16100','2013-09-27','16:00:00',4.59),('16100','2013-09-27','16:05:00',4.38),('16100','2013-09-27','16:10:00',4.3),('16100','2013-09-27','16:15:00',4.17),('16100','2013-09-27','16:20:00',3.89),('16100','2013-09-27','16:25:00',3.23),('16100','2013-09-27','16:30:00',3.61),('16100','2013-09-27','16:35:00',3.58),('16100','2013-09-27','16:40:00',3.34),('16100','2013-09-27','16:45:00',3.18),('16100','2013-09-27','16:50:00',3.07),('16100','2013-09-27','16:55:00',2.94),('16100','2013-09-27','17:00:00',2.72),('16100','2013-09-27','17:05:00',2.57),('16100','2013-09-27','17:10:00',2.38),('16100','2013-09-27','17:15:00',2.24),('16100','2013-09-27','17:20:00',2.09),('16100','2013-09-27','17:25:00',1.95),('16100','2013-09-27','17:30:00',1.76),('16100','2013-09-27','17:35:00',1.51),('16100','2013-09-27','17:40:00',1.22),('16100','2013-09-26','08:20:00',1.26),('16100','2013-09-26','08:25:00',1.35),('16100','2013-09-26','08:30:00',1.83),('16100','2013-09-26','08:35:00',1.15),('16100','2013-09-26','08:45:00',1.03),('16100','2013-09-26','08:50:00',1.61),('16100','2013-09-26','08:55:00',2.13),('16100','2013-09-26','09:00:00',1.53),('16100','2013-09-26','09:05:00',1.05),('16100','2013-09-26','09:10:00',1.29),('16100','2013-09-26','09:15:00',1.29),('16100','2013-09-26','09:20:00',1.91),('16100','2013-09-26','09:25:00',2.72),('16100','2013-09-26','09:30:00',1.5),('16100','2013-09-26','09:35:00',1.52),('16100','2013-09-26','09:40:00',1.79),('16100','2013-09-26','09:45:00',1.96),('16100','2013-09-26','09:50:00',1.45),('16100','2013-09-26','09:55:00',1.36),('16100','2013-09-26','10:00:00',1.42),('16100','2013-09-26','10:05:00',1.46),('16100','2013-09-26','10:10:00',2.65),('16100','2013-09-26','10:15:00',4.7),('16100','2013-09-26','10:20:00',3.75),('16100','2013-09-26','10:25:00',2.36),('16100','2013-09-26','10:30:00',2.87),('16100','2013-09-26','10:35:00',5.2),('16100','2013-09-26','10:40:00',5.32),('16100','2013-09-26','10:45:00',5.57),('16100','2013-09-26','10:50:00',5.55),('16100','2013-09-26','10:55:00',5.5),('16100','2013-09-26','11:00:00',5.63),('16100','2013-09-26','11:05:00',5.83),('16100','2013-09-26','11:10:00',5.92),('16100','2013-09-26','11:15:00',6.05),('16100','2013-09-26','11:20:00',6.17),('16100','2013-09-26','11:25:00',4.42),('16100','2013-09-26','11:30:00',3.79),('16100','2013-09-26','11:35:00',3.74),('16100','2013-09-26','11:40:00',3.19),('16100','2013-09-26','11:45:00',6.23),('16100','2013-09-26','11:50:00',3.97),('16100','2013-09-26','11:55:00',2.11),('16100','2013-09-26','12:00:00',2.42),('16100','2013-09-26','12:05:00',1.51),('16100','2013-09-26','12:10:00',2.27),('16100','2013-09-26','12:15:00',1.63),('16100','2013-09-26','12:20:00',1.71),('16100','2013-09-26','12:25:00',2.73),('16100','2013-09-26','12:30:00',5.36),('16100','2013-09-26','12:35:00',7.35),('16100','2013-09-26','12:40:00',7.53),('16100','2013-09-26','12:45:00',5.06),('16100','2013-09-26','12:50:00',2.97),('16100','2013-09-26','12:55:00',2.91),('16100','2013-09-26','13:00:00',1.5),('16100','2013-09-26','13:05:00',3.18),('16100','2013-09-26','13:10:00',8.13),('16100','2013-09-26','13:15:00',7.63),('16100','2013-09-26','13:20:00',7.39),('16100','2013-09-26','13:25:00',7.56),('16100','2013-09-26','13:30:00',5.45),('16100','2013-09-26','13:35:00',6.92),('16100','2013-09-26','13:40:00',7.25),('16100','2013-09-26','13:45:00',5.04),('16100','2013-09-26','13:50:00',6.28),('16100','2013-09-26','13:55:00',6.98),('16100','2013-09-26','14:00:00',6.96),('16100','2013-09-26','14:05:00',6.9),('16100','2013-09-26','14:10:00',5.96),('16100','2013-09-26','14:15:00',4.75),('16100','2013-09-26','14:20:00',6.77),('16100','2013-09-26','14:25:00',6.63),('16100','2013-09-26','14:30:00',6.48),('16100','2013-09-26','14:35:00',6.34),('16100','2013-09-26','14:40:00',6.54),('16100','2013-09-26','14:45:00',6.65),('16100','2013-09-26','14:50:00',6.46),('16100','2013-09-26','14:55:00',6.2),('16100','2013-09-26','15:00:00',4.18),('16100','2013-09-26','15:05:00',5.37),('16100','2013-09-26','15:10:00',5.66),('16100','2013-09-26','15:15:00',5.74),('16100','2013-09-26','15:20:00',5.66),('16100','2013-09-26','15:25:00',5.02),('16100','2013-09-26','15:30:00',4.61),('16100','2013-09-26','15:35:00',4.81),('16100','2013-09-26','15:40:00',5.33),('16100','2013-09-26','15:45:00',5.14),('16100','2013-09-26','15:50:00',4.53),('16100','2013-09-26','15:55:00',4.8),('16100','2013-09-26','16:00:00',4.64),('16100','2013-09-26','16:05:00',4.55),('16100','2013-09-26','16:10:00',4.32),('16100','2013-09-26','16:15:00',4.3),('16100','2013-09-26','16:20:00',4.15),('16100','2013-09-26','16:25:00',3.95),('16100','2013-09-26','16:30:00',3.89),('16100','2013-09-26','16:35:00',3.7),('16100','2013-09-26','16:40:00',3.44),('16100','2013-09-26','16:45:00',3.31),('16100','2013-09-26','16:50:00',3.11),('16100','2013-09-26','16:55:00',2.84),('16100','2013-09-26','17:00:00',2.81),('16100','2013-09-26','17:05:00',2.37),('16100','2013-09-26','17:10:00',2.45),('16100','2013-09-26','17:15:00',2.38),('16100','2013-09-26','17:20:00',2.05),('16100','2013-09-26','17:25:00',1.25),('16100','2013-09-26','17:35:00',1.31),('16100','2013-09-26','17:40:00',1.11),('16100','2013-09-25','08:15:00',1.14),('16100','2013-09-25','08:20:00',1.3),('16100','2013-09-25','08:25:00',1.52),('16100','2013-09-25','08:30:00',1.7),('16100','2013-09-25','08:35:00',1.85),('16100','2013-09-25','08:40:00',2.06),('16100','2013-09-25','08:45:00',2.26),('16100','2013-09-25','08:50:00',2.42),('16100','2013-09-25','08:55:00',2.59),('16100','2013-09-25','09:00:00',2.8),('16100','2013-09-25','09:05:00',2.97),('16100','2013-09-25','09:10:00',3.1),('16100','2013-09-25','09:15:00',3.27),('16100','2013-09-25','09:20:00',3.51),('16100','2013-09-25','09:25:00',3.64),('16100','2013-09-25','09:30:00',3.77),('16100','2013-09-25','09:35:00',3.89),('16100','2013-09-25','09:40:00',4.02),('16100','2013-09-25','09:45:00',4.18),('16100','2013-09-25','09:50:00',4.35),('16100','2013-09-25','09:55:00',4.45),('16100','2013-09-25','10:00:00',4.6),('16100','2013-09-25','10:05:00',4.7),('16100','2013-09-25','10:10:00',4.82),('16100','2013-09-25','10:15:00',4.97),('16100','2013-09-25','10:20:00',5.08),('16100','2013-09-25','10:25:00',5.2),('16100','2013-09-25','10:30:00',5.29),('16100','2013-09-25','10:35:00',5.42),('16100','2013-09-25','10:40:00',5.4),('16100','2013-09-25','10:45:00',5.51),('16100','2013-09-25','10:50:00',5.49),('16100','2013-09-25','10:55:00',5.7),('16100','2013-09-25','11:00:00',5.77),('16100','2013-09-25','11:05:00',5.85),('16100','2013-09-25','11:10:00',5.96),('16100','2013-09-25','11:15:00',6.09),('16100','2013-09-25','11:20:00',6.69),('16100','2013-09-25','11:25:00',6.23),('16100','2013-09-25','11:30:00',6.45),('16100','2013-09-25','11:35:00',6.56),('16100','2013-09-25','11:40:00',6.66),('16100','2013-09-25','11:45:00',5.57),('16100','2013-09-25','11:50:00',6.08),('16100','2013-09-25','11:55:00',6.3),('16100','2013-09-25','12:00:00',5.19),('16100','2013-09-25','12:05:00',5.86),('16100','2013-09-25','12:10:00',4.85),('16100','2013-09-25','12:15:00',2.61),('16100','2013-09-25','12:20:00',4.88),('16100','2013-09-25','12:25:00',5.56),('16100','2013-09-25','12:30:00',3.18),('16100','2013-09-25','12:35:00',3.29),('16100','2013-09-25','12:40:00',3.56),('16100','2013-09-25','12:45:00',3.25),('16100','2013-09-25','12:50:00',4.02),('16100','2013-09-25','12:55:00',5.17),('16100','2013-09-25','13:00:00',4.51),('16100','2013-09-25','13:05:00',4.77),('16100','2013-09-25','13:10:00',7.26),('16100','2013-09-25','13:15:00',5.64),('16100','2013-09-25','13:20:00',5.33),('16100','2013-09-25','13:25:00',4.19),('16100','2013-09-25','13:30:00',3.26),('16100','2013-09-25','13:35:00',3.33),('16100','2013-09-25','13:40:00',3.56),('16100','2013-09-25','13:45:00',2.15),('16100','2013-09-25','13:50:00',3.79),('16100','2013-09-25','13:55:00',8.23),('16100','2013-09-25','14:00:00',6.79),('16100','2013-09-25','14:05:00',4.1),('16100','2013-09-25','14:10:00',6.75),('16100','2013-09-25','14:15:00',6.01),('16100','2013-09-25','14:20:00',3.83),('16100','2013-09-25','14:25:00',4.89),('16100','2013-09-25','14:30:00',5.54),('16100','2013-09-25','14:35:00',6.38),('16100','2013-09-25','14:40:00',6.45),('16100','2013-09-25','14:45:00',6.6),('16100','2013-09-25','14:50:00',6.47),('16100','2013-09-25','14:55:00',6.34),('16100','2013-09-25','15:00:00',5.8),('16100','2013-09-25','15:05:00',6.22),('16100','2013-09-25','15:10:00',2.77),('16100','2013-09-25','15:15:00',5.04),('16100','2013-09-25','15:20:00',2.59),('16100','2013-09-25','15:25:00',5.3),('16100','2013-09-25','15:30:00',5.77),('16100','2013-09-25','15:35:00',5.36),('16100','2013-09-25','15:40:00',4.75),('16100','2013-09-25','15:45:00',5.4),('16100','2013-09-25','15:50:00',4.73),('16100','2013-09-25','15:55:00',4.88),('16100','2013-09-25','16:00:00',4.19),('16100','2013-09-25','16:05:00',4.64),('16100','2013-09-25','16:10:00',4.61),('16100','2013-09-25','16:15:00',4.41),('16100','2013-09-25','16:20:00',4.46),('16100','2013-09-25','16:25:00',4.04),('16100','2013-09-25','16:30:00',3.99),('16100','2013-09-25','16:35:00',3.81),('16100','2013-09-25','16:40:00',3.51),('16100','2013-09-25','16:45:00',3.42),('16100','2013-09-25','16:50:00',3.3),('16100','2013-09-25','16:55:00',3.09),('16100','2013-09-25','17:00:00',2.43),('16100','2013-09-25','17:10:00',1.87),('16100','2013-09-25','17:15:00',1.66),('16100','2013-09-25','17:20:00',2.44),('16100','2013-09-25','17:25:00',2.6),('16100','2013-09-25','17:30:00',2.47),('16100','2013-09-25','17:35:00',2.06),('16100','2013-09-25','17:40:00',1.71),('16100','2013-09-25','17:45:00',1.48),('16100','2013-09-25','17:50:00',1.31),('16100','2013-09-25','17:55:00',1.04),('16100','2013-09-24','08:10:00',1.31),('16100','2013-09-24','08:30:00',1.77),('16100','2013-09-24','08:35:00',1.95),('16100','2013-09-24','08:40:00',1.82),('16100','2013-09-24','08:45:00',2.03),('16100','2013-09-24','08:50:00',2.39),('16100','2013-09-24','08:55:00',2.91),('16100','2013-09-24','09:00:00',2.55),('16100','2013-09-24','09:05:00',2.66),('16100','2013-09-24','09:10:00',1.65),('16100','2013-09-24','09:15:00',1.78),('16100','2013-09-24','09:20:00',3.48),('16100','2013-09-24','09:25:00',2.18),('16100','2013-09-24','09:30:00',1.89),('16100','2013-09-24','09:35:00',3.46),('16100','2013-09-24','09:40:00',2.11),('16100','2013-09-24','09:45:00',1.17),('16100','2013-09-24','10:15:00',1.25),('16100','2013-09-24','10:20:00',2.02),('16100','2013-09-24','10:25:00',4.6),('16100','2013-09-24','10:30:00',5.54),('16100','2013-09-24','10:35:00',5.25),('16100','2013-09-24','10:40:00',3.86),('16100','2013-09-24','10:45:00',4.42),('16100','2013-09-24','10:50:00',5.59),('16100','2013-09-24','10:55:00',5.99),('16100','2013-09-24','11:00:00',6.36),('16100','2013-09-24','11:05:00',6.67),('16100','2013-09-24','11:10:00',6.96),('16100','2013-09-24','11:15:00',5.87),('16100','2013-09-24','11:20:00',1.92),('16100','2013-09-24','11:25:00',1.65),('16100','2013-09-24','11:30:00',1.51),('16100','2013-09-24','11:35:00',2.24),('16100','2013-09-24','11:40:00',7.28),('16100','2013-09-24','11:45:00',7.19),('16100','2013-09-24','11:50:00',7.22),('16100','2013-09-24','11:55:00',7.81),('16100','2013-09-24','12:00:00',5.18),('16100','2013-09-24','12:05:00',3.31),('16100','2013-09-24','12:10:00',2.03),('16100','2013-09-24','12:15:00',2),('16100','2013-09-24','12:20:00',3.01),('16100','2013-09-24','12:25:00',6.46),('16100','2013-09-24','12:30:00',7.64),('16100','2013-09-24','12:35:00',7.78),('16100','2013-09-24','12:40:00',7.81),('16100','2013-09-24','12:45:00',7.73),('16100','2013-09-24','12:50:00',7.75),('16100','2013-09-24','12:55:00',7.61),('16100','2013-09-24','13:00:00',7.54),('16100','2013-09-24','13:05:00',7.7),('16100','2013-09-24','13:10:00',7.89),('16100','2013-09-24','13:15:00',7.72),('16100','2013-09-24','13:20:00',4.6),('16100','2013-09-24','13:25:00',3.91),('16100','2013-09-24','13:30:00',1.78),('16100','2013-09-24','13:35:00',7.02),('16100','2013-09-24','13:40:00',1.72),('16100','2013-09-24','13:45:00',4.09),('16100','2013-09-24','13:50:00',8),('16100','2013-09-24','13:55:00',5.92),('16100','2013-09-24','14:00:00',2.77),('16100','2013-09-24','14:05:00',7.35),('16100','2013-09-24','14:10:00',2.64),('16100','2013-09-24','14:15:00',2.02),('16100','2013-09-24','14:20:00',3.24),('16100','2013-09-24','14:25:00',6.55),('16100','2013-09-24','14:30:00',6.97),('16100','2013-09-24','14:35:00',4.39),('16100','2013-09-24','14:40:00',3.51),('16100','2013-09-24','14:45:00',4.54),('16100','2013-09-24','14:50:00',7.4),('16100','2013-09-24','14:55:00',5.8),('16100','2013-09-24','15:00:00',3.8),('16100','2013-09-24','15:05:00',6.55),('16100','2013-09-24','15:10:00',5.6),('16100','2013-09-24','15:15:00',6.28),('16100','2013-09-24','15:20:00',6.23),('16100','2013-09-24','15:25:00',6.16),('16100','2013-09-24','15:30:00',5.13),('16100','2013-09-24','15:35:00',5.54),('16100','2013-09-24','15:40:00',5.5),('16100','2013-09-24','15:45:00',5.38),('16100','2013-09-24','15:50:00',3.81),('16100','2013-09-24','15:55:00',3.74),('16100','2013-09-24','16:00:00',5.26),('16100','2013-09-24','16:05:00',1.14),('16100','2013-09-24','16:10:00',4.75),('16100','2013-09-24','16:15:00',4.84),('16100','2013-09-24','16:20:00',3.97),('16100','2013-09-24','16:25:00',4.5),('16100','2013-09-24','16:30:00',3.02),('16100','2013-09-24','16:35:00',4.07),('16100','2013-09-24','16:40:00',3.84),('16100','2013-09-24','16:45:00',3.68),('16100','2013-09-24','16:50:00',3.51),('16100','2013-09-24','16:55:00',3.37),('16100','2013-09-24','17:00:00',3.22),('16100','2013-09-24','17:05:00',3.02),('16100','2013-09-24','17:10:00',2.82),('16100','2013-09-24','17:15:00',2.64),('16100','2013-09-24','17:20:00',2.47),('16100','2013-09-24','17:25:00',2.29),('16100','2013-09-24','17:30:00',2.1),('16100','2013-09-24','17:35:00',1.93),('16100','2013-09-24','17:40:00',1.76),('16100','2013-09-24','17:45:00',1.59),('16100','2013-09-24','17:50:00',1.41),('16100','2013-09-24','17:55:00',1.24),('16100','2013-09-24','18:00:00',1.07),('16100','2013-09-23','08:10:00',1.07),('16100','2013-09-23','08:15:00',1.25),('16100','2013-09-23','08:20:00',1.44),('16100','2013-09-23','08:25:00',1.64),('16100','2013-09-23','08:30:00',1.83),('16100','2013-09-23','08:35:00',2.03),('16100','2013-09-23','08:40:00',2.21),('16100','2013-09-23','08:45:00',2.42),('16100','2013-09-23','08:50:00',2.61),('16100','2013-09-23','08:55:00',2.79),('16100','2013-09-23','09:00:00',2.98),('16100','2013-09-23','09:05:00',3.15),('16100','2013-09-23','09:10:00',3.3),('16100','2013-09-23','09:15:00',3.47),('16100','2013-09-23','09:20:00',3.67),('16100','2013-09-23','09:25:00',3.84),('16100','2013-09-23','09:30:00',3.99),('16100','2013-09-23','09:35:00',4.09),('16100','2013-09-23','09:40:00',4.2),('16100','2013-09-23','09:45:00',4.36),('16100','2013-09-23','09:50:00',4.49),('16100','2013-09-23','09:55:00',4.59),('16100','2013-09-23','10:00:00',4.74),('16100','2013-09-23','10:05:00',4.84),('16100','2013-09-23','10:10:00',4.96),('16100','2013-09-23','10:15:00',5.1),('16100','2013-09-23','10:20:00',5.25),('16100','2013-09-23','10:25:00',5.43),('16100','2013-09-23','10:30:00',5.56),('16100','2013-09-23','10:35:00',5.65),('16100','2013-09-23','10:40:00',5.76),('16100','2013-09-23','10:45:00',5.83),('16100','2013-09-23','10:50:00',5.9),('16100','2013-09-23','10:55:00',6.02),('16100','2013-09-23','11:00:00',6.1),('16100','2013-09-23','11:05:00',6.18),('16100','2013-09-23','11:10:00',6.26),('16100','2013-09-23','11:15:00',6.34),('16100','2013-09-23','11:20:00',6.47),('16100','2013-09-23','11:25:00',6.51),('16100','2013-09-23','11:30:00',6.61),('16100','2013-09-23','11:35:00',6.67),('16100','2013-09-23','11:40:00',6.68),('16100','2013-09-23','11:45:00',6.75),('16100','2013-09-23','11:50:00',6.8),('16100','2013-09-23','11:55:00',6.85),('16100','2013-09-23','12:00:00',6.87),('16100','2013-09-23','12:05:00',6.94),('16100','2013-09-23','12:10:00',7),('16100','2013-09-23','12:15:00',7.01),('16100','2013-09-23','12:20:00',7.01),('16100','2013-09-23','12:25:00',7.07),('16100','2013-09-23','12:30:00',7.12),('16100','2013-09-23','12:35:00',7.13),('16100','2013-09-23','12:40:00',7.16),('16100','2013-09-23','12:45:00',7.2),('16100','2013-09-23','12:50:00',7.16),('16100','2013-09-23','12:55:00',7.16),('16100','2013-09-23','13:00:00',7.21),('16100','2013-09-23','13:05:00',7.19),('16100','2013-09-23','13:10:00',7.23),('16100','2013-09-23','13:15:00',7.24),('16100','2013-09-23','13:20:00',7.18),('16100','2013-09-23','13:25:00',7.17),('16100','2013-09-23','13:30:00',7.14),('16100','2013-09-23','13:35:00',7.13),('16100','2013-09-23','13:40:00',7.1),('16100','2013-09-23','13:45:00',7.15),('16100','2013-09-23','13:50:00',7.13),('16100','2013-09-23','13:55:00',7.06),('16100','2013-09-23','14:00:00',6.95),('16100','2013-09-23','14:05:00',6.96),('16100','2013-09-23','14:10:00',6.89),('16100','2013-09-23','14:15:00',6.89),('16100','2013-09-23','14:20:00',6.81),('16100','2013-09-23','14:25:00',6.79),('16100','2013-09-23','14:30:00',6.72),('16100','2013-09-23','14:35:00',6.64),('16100','2013-09-23','14:40:00',6.56),('16100','2013-09-23','14:45:00',6.52),('16100','2013-09-23','14:50:00',6.43),('16100','2013-09-23','14:55:00',6.36),('16100','2013-09-23','15:00:00',6.27),('16100','2013-09-23','15:05:00',6.15),('16100','2013-09-23','15:10:00',6.04),('16100','2013-09-23','15:15:00',5.97),('16100','2013-09-23','15:20:00',5.87),('16100','2013-09-23','15:25:00',5.8),('16100','2013-09-23','15:30:00',5.68),('16100','2013-09-23','15:35:00',5.64),('16100','2013-09-23','15:40:00',5.53),('16100','2013-09-23','15:45:00',5.43),('16100','2013-09-23','15:50:00',5.33),('16100','2013-09-23','15:55:00',5.04),('16100','2013-09-23','16:00:00',4.99),('16100','2013-09-23','16:05:00',4.87),('16100','2013-09-23','16:10:00',4.82),('16100','2013-09-23','16:15:00',4.66),('16100','2013-09-23','16:20:00',4.57),('16100','2013-09-23','16:25:00',4.41),('16100','2013-09-23','16:30:00',4.27),('16100','2013-09-23','16:35:00',4.12),('16100','2013-09-23','16:40:00',3.93),('16100','2013-09-23','16:45:00',3.76),('16100','2013-09-23','16:50:00',3.61),('16100','2013-09-23','16:55:00',3.44),('16100','2013-09-23','17:00:00',3.27),('16100','2013-09-23','17:05:00',3.1),('16100','2013-09-23','17:10:00',2.92),('16100','2013-09-23','17:15:00',2.74),('16100','2013-09-23','17:20:00',2.59),('16100','2013-09-23','17:25:00',2.41),('16100','2013-09-23','17:30:00',2.21),('16100','2013-09-23','17:35:00',2.03),('16100','2013-09-23','17:40:00',1.87),('16100','2013-09-23','17:45:00',1.69),('16100','2013-09-23','17:50:00',1.52),('16100','2013-09-23','17:55:00',1.34),('16100','2013-09-23','18:00:00',1.16),('16100','2013-09-22','08:10:00',1.14),('16100','2013-09-22','08:15:00',1.32),('16100','2013-09-22','08:20:00',1.51),('16100','2013-09-22','08:25:00',1.72),('16100','2013-09-22','08:30:00',1.91),('16100','2013-09-22','08:35:00',2.11),('16100','2013-09-22','08:40:00',2.29),('16100','2013-09-22','08:45:00',2.51),('16100','2013-09-22','08:50:00',2.69),('16100','2013-09-22','08:55:00',2.86),('16100','2013-09-22','09:00:00',3.05),('16100','2013-09-22','09:05:00',3.21),('16100','2013-09-22','09:10:00',3.37),('16100','2013-09-22','09:15:00',3.55),('16100','2013-09-22','09:20:00',3.76),('16100','2013-09-22','09:25:00',3.9),('16100','2013-09-22','09:30:00',4.04),('16100','2013-09-22','09:35:00',4.18),('16100','2013-09-22','09:40:00',4.31),('16100','2013-09-22','09:45:00',4.44),('16100','2013-09-22','09:50:00',4.56),('16100','2013-09-22','09:55:00',4.69),('16100','2013-09-22','10:00:00',4.83),('16100','2013-09-22','10:05:00',4.95),('16100','2013-09-22','10:10:00',5.08),('16100','2013-09-22','10:15:00',5.19),('16100','2013-09-22','10:20:00',5.33),('16100','2013-09-22','10:25:00',5.48),('16100','2013-09-22','10:30:00',5.61),('16100','2013-09-22','10:35:00',5.73),('16100','2013-09-22','10:40:00',5.84),('16100','2013-09-22','10:45:00',5.96),('16100','2013-09-22','10:50:00',6.06),('16100','2013-09-22','10:55:00',6.15),('16100','2013-09-22','11:00:00',6.24),('16100','2013-09-22','11:05:00',6.32),('16100','2013-09-22','11:10:00',6.4),('16100','2013-09-22','11:15:00',6.51),('16100','2013-09-22','11:20:00',6.64),('16100','2013-09-22','11:25:00',6.75),('16100','2013-09-22','11:30:00',6.8),('16100','2013-09-22','11:35:00',6.87),('16100','2013-09-22','11:40:00',6.92),('16100','2013-09-22','11:45:00',6.96),('16100','2013-09-22','11:50:00',7.01),('16100','2013-09-22','11:55:00',7.11),('16100','2013-09-22','12:00:00',7.12),('16100','2013-09-22','12:05:00',7.11),('16100','2013-09-22','12:10:00',7.12),('16100','2013-09-22','12:15:00',7.17),('16100','2013-09-22','12:20:00',7.17),('16100','2013-09-22','12:25:00',7.31),('16100','2013-09-22','12:30:00',7.25),('16100','2013-09-22','12:35:00',7.24),('16100','2013-09-22','12:40:00',7.25),('16100','2013-09-22','12:45:00',7.27),('16100','2013-09-22','12:50:00',7.28),('16100','2013-09-22','12:55:00',7.29),('16100','2013-09-22','13:00:00',7.29),('16100','2013-09-22','13:05:00',7.29),('16100','2013-09-22','13:10:00',7.29),('16100','2013-09-22','13:15:00',7.21),('16100','2013-09-22','13:20:00',7.17),('16100','2013-09-22','13:25:00',7.15),('16100','2013-09-22','13:30:00',7.2),('16100','2013-09-22','13:35:00',7.14),('16100','2013-09-22','13:40:00',7.12),('16100','2013-09-22','13:45:00',7.07),('16100','2013-09-22','13:50:00',6.96),('16100','2013-09-22','13:55:00',6.89),('16100','2013-09-22','14:00:00',6.8),('16100','2013-09-22','14:05:00',6.81),('16100','2013-09-22','14:10:00',6.8),('16100','2013-09-22','14:15:00',6.86),('16100','2013-09-22','14:20:00',6.86),('16100','2013-09-22','14:25:00',6.8),('16100','2013-09-22','14:30:00',6.56),('16100','2013-09-22','14:35:00',6.42),('16100','2013-09-22','14:40:00',6.36),('16100','2013-09-22','14:45:00',6.32),('16100','2013-09-22','14:50:00',6.23),('16100','2013-09-22','14:55:00',6.13),('16100','2013-09-22','15:00:00',6.06),('16100','2013-09-22','15:05:00',6.02),('16100','2013-09-22','15:10:00',5.99),('16100','2013-09-22','15:15:00',5.93),('16100','2013-09-22','15:20:00',5.78),('16100','2013-09-22','15:25:00',5.71),('16100','2013-09-22','15:30:00',5.78),('16100','2013-09-22','15:35:00',3.99),('16100','2013-09-22','15:40:00',1.89),('16100','2013-09-22','15:45:00',5.52),('16100','2013-09-22','15:50:00',5.3),('16100','2013-09-22','15:55:00',4.74),('16100','2013-09-22','16:00:00',4.79),('16100','2013-09-22','16:05:00',4.71),('16100','2013-09-22','16:10:00',4.53),('16100','2013-09-22','16:15:00',4.44),('16100','2013-09-22','16:20:00',4.25),('16100','2013-09-22','16:25:00',4.23),('16100','2013-09-22','16:30:00',4.16),('16100','2013-09-22','16:35:00',3.98),('16100','2013-09-22','16:40:00',3.81),('16100','2013-09-22','16:45:00',3.68),('16100','2013-09-22','16:50:00',3.5),('16100','2013-09-22','16:55:00',3.34),('16100','2013-09-22','17:00:00',3.2),('16100','2013-09-22','17:05:00',3.02),('16100','2013-09-22','17:10:00',2.83),('16100','2013-09-22','17:15:00',2.63),('16100','2013-09-22','17:20:00',2.46),('16100','2013-09-22','17:25:00',2.28),('16100','2013-09-22','17:30:00',2.11),('16100','2013-09-22','17:35:00',1.95),('16100','2013-09-22','17:40:00',1.77),('16100','2013-09-22','17:45:00',1.6),('16100','2013-09-22','17:50:00',1.4),('16100','2013-09-22','17:55:00',1.26),('16100','2013-09-22','18:00:00',1.1),('16100','2013-09-21','08:05:00',1.01),('16100','2013-09-21','08:10:00',1.21),('16100','2013-09-21','08:15:00',1.31),('16100','2013-09-21','08:20:00',1.48),('16100','2013-09-21','08:25:00',1.65),('16100','2013-09-21','08:30:00',1.84),('16100','2013-09-21','08:35:00',2.03),('16100','2013-09-21','08:40:00',2.21),('16100','2013-09-21','08:45:00',2.43),('16100','2013-09-21','08:50:00',2.64),('16100','2013-09-21','08:55:00',2.82),('16100','2013-09-21','09:00:00',3),('16100','2013-09-21','09:05:00',3.16),('16100','2013-09-21','09:10:00',3.31),('16100','2013-09-21','09:15:00',3.48),('16100','2013-09-21','09:20:00',3.7),('16100','2013-09-21','09:25:00',3.87),('16100','2013-09-21','09:30:00',4.02),('16100','2013-09-21','09:35:00',4.17),('16100','2013-09-21','09:40:00',4.33),('16100','2013-09-21','09:45:00',4.47),('16100','2013-09-21','09:50:00',4.64),('16100','2013-09-21','09:55:00',4.77),('16100','2013-09-21','10:00:00',4.92),('16100','2013-09-21','10:05:00',5.06),('16100','2013-09-21','10:10:00',5.18),('16100','2013-09-21','10:15:00',5.29),('16100','2013-09-21','10:20:00',5.43),('16100','2013-09-21','10:25:00',5.63),('16100','2013-09-21','10:30:00',5.78),('16100','2013-09-21','10:35:00',5.88),('16100','2013-09-21','10:40:00',5.98),('16100','2013-09-21','10:45:00',6.1),('16100','2013-09-21','10:50:00',6.24),('16100','2013-09-21','10:55:00',6.36),('16100','2013-09-21','11:00:00',6.42),('16100','2013-09-21','11:05:00',6.49),('16100','2013-09-21','11:10:00',6.6),('16100','2013-09-21','11:15:00',6.71),('16100','2013-09-21','11:20:00',6.77),('16100','2013-09-21','11:25:00',6.86),('16100','2013-09-21','11:30:00',6.92),('16100','2013-09-21','11:35:00',6.93),('16100','2013-09-21','11:40:00',7),('16100','2013-09-21','11:45:00',7.06),('16100','2013-09-21','11:50:00',7.13),('16100','2013-09-21','11:55:00',7.19),('16100','2013-09-21','12:00:00',7.22),('16100','2013-09-21','12:05:00',7.26),('16100','2013-09-21','12:10:00',7.23),('16100','2013-09-21','12:15:00',7.28),('16100','2013-09-21','12:20:00',7.37),('16100','2013-09-21','12:25:00',7.4),('16100','2013-09-21','12:30:00',7.41),('16100','2013-09-21','12:35:00',7.43),('16100','2013-09-21','12:40:00',7.46),('16100','2013-09-21','12:45:00',7.46),('16100','2013-09-21','12:50:00',7.51),('16100','2013-09-21','12:55:00',7.48),('16100','2013-09-21','13:00:00',7.48),('16100','2013-09-21','13:05:00',7.44),('16100','2013-09-21','13:10:00',7.45),('16100','2013-09-21','13:15:00',7.43),('16100','2013-09-21','13:20:00',7.43),('16100','2013-09-21','13:25:00',7.42),('16100','2013-09-21','13:30:00',7.39),('16100','2013-09-21','13:35:00',7.43),('16100','2013-09-21','13:40:00',7.47),('16100','2013-09-21','13:45:00',7.64),('16100','2013-09-21','13:50:00',7.47),('16100','2013-09-21','13:55:00',5.55),('16100','2013-09-21','14:00:00',6.49),('16100','2013-09-21','14:05:00',6.52),('16100','2013-09-21','14:10:00',6.2),('16100','2013-09-21','14:15:00',6.47),('16100','2013-09-21','14:20:00',6.22),('16100','2013-09-21','14:25:00',3.74),('16100','2013-09-21','14:30:00',2.4),('16100','2013-09-21','14:35:00',6.28),('16100','2013-09-21','14:40:00',7.06),('16100','2013-09-21','14:45:00',6.83),('16100','2013-09-21','14:50:00',6.67),('16100','2013-09-21','14:55:00',6.69),('16100','2013-09-21','15:00:00',6.94),('16100','2013-09-21','15:05:00',4.57),('16100','2013-09-21','15:10:00',6.18),('16100','2013-09-21','15:15:00',7.52),('16100','2013-09-21','15:20:00',3.49),('16100','2013-09-21','15:25:00',3),('16100','2013-09-21','15:30:00',5.1),('16100','2013-09-21','15:35:00',6.92),('16100','2013-09-21','15:40:00',6.02),('16100','2013-09-21','15:45:00',5.65),('16100','2013-09-21','15:50:00',5.71),('16100','2013-09-21','15:55:00',5.77),('16100','2013-09-21','16:00:00',6.04),('16100','2013-09-21','16:05:00',3.74),('16100','2013-09-21','16:10:00',4),('16100','2013-09-21','16:15:00',2.65),('16100','2013-09-21','16:20:00',2.33),('16100','2013-09-21','16:25:00',2.26),('16100','2013-09-21','16:30:00',1.78),('16100','2013-09-21','16:35:00',2.31),('16100','2013-09-21','16:40:00',2.09),('16100','2013-09-21','16:45:00',1.88),('16100','2013-09-21','16:50:00',3.1),('16100','2013-09-21','16:55:00',3.55),('16100','2013-09-21','17:00:00',3.99),('16100','2013-09-21','17:05:00',3.54),('16100','2013-09-21','17:10:00',3.22),('16100','2013-09-21','17:15:00',2.88),('16100','2013-09-21','17:20:00',2.79),('16100','2013-09-21','17:25:00',2.51),('16100','2013-09-21','17:30:00',2.26),('16100','2013-09-21','17:35:00',1.15),('16100','2013-09-21','17:40:00',1.24),('16100','2013-09-21','17:55:00',1.27),('16100','2013-09-20','08:10:00',1.09),('16100','2013-09-20','08:15:00',1.28),('16100','2013-09-20','08:20:00',1.48),('16100','2013-09-20','08:25:00',1.65),('16100','2013-09-20','08:30:00',1.85),('16100','2013-09-20','08:35:00',2.03),('16100','2013-09-20','08:40:00',2.22),('16100','2013-09-20','08:45:00',2.44),('16100','2013-09-20','08:50:00',2.62),('16100','2013-09-20','08:55:00',2.78),('16100','2013-09-20','09:00:00',2.96),('16100','2013-09-20','09:05:00',3.12),('16100','2013-09-20','09:10:00',3.27),('16100','2013-09-20','09:15:00',3.45),('16100','2013-09-20','09:20:00',3.65),('16100','2013-09-20','09:25:00',3.77),('16100','2013-09-20','09:30:00',3.91),('16100','2013-09-20','09:35:00',4.07),('16100','2013-09-20','09:40:00',4.22),('16100','2013-09-20','09:45:00',4.36),('16100','2013-09-20','09:50:00',4.47),('16100','2013-09-20','09:55:00',4.53),('16100','2013-09-20','10:00:00',4.8),('16100','2013-09-20','10:05:00',4.91),('16100','2013-09-20','10:10:00',5),('16100','2013-09-20','10:15:00',5.09),('16100','2013-09-20','10:20:00',5.22),('16100','2013-09-20','10:25:00',5.42),('16100','2013-09-20','10:30:00',5.52),('16100','2013-09-20','10:35:00',5.62),('16100','2013-09-20','10:40:00',5.72),('16100','2013-09-20','10:45:00',5.82),('16100','2013-09-20','10:50:00',5.91),('16100','2013-09-20','10:55:00',5.98),('16100','2013-09-20','11:00:00',6.06),('16100','2013-09-20','11:05:00',6.18),('16100','2013-09-20','11:10:00',6.24),('16100','2013-09-20','11:15:00',6.34),('16100','2013-09-20','11:20:00',6.41),('16100','2013-09-20','11:25:00',6.48),('16100','2013-09-20','11:30:00',6.55),('16100','2013-09-20','11:35:00',6.59),('16100','2013-09-20','11:40:00',6.64),('16100','2013-09-20','11:45:00',6.62),('16100','2013-09-20','11:50:00',6.57),('16100','2013-09-20','11:55:00',6.93),('16100','2013-09-20','12:00:00',6.99),('16100','2013-09-20','12:05:00',7),('16100','2013-09-20','12:10:00',7.05),('16100','2013-09-20','12:15:00',6.55),('16100','2013-09-20','12:20:00',5.59),('16100','2013-09-20','12:25:00',6.51),('16100','2013-09-20','12:30:00',7.1),('16100','2013-09-20','12:35:00',6.91),('16100','2013-09-20','12:40:00',5.97),('16100','2013-09-20','12:45:00',6.38),('16100','2013-09-20','12:50:00',7.26),('16100','2013-09-20','12:55:00',5.44),('16100','2013-09-20','13:00:00',5.75),('16100','2013-09-20','13:05:00',7.24),('16100','2013-09-20','13:10:00',7.03),('16100','2013-09-20','13:15:00',7.49),('16100','2013-09-20','13:20:00',4.46),('16100','2013-09-20','13:25:00',6.69),('16100','2013-09-20','13:30:00',5.79),('16100','2013-09-20','13:35:00',5.2),('16100','2013-09-20','13:40:00',6.77),('16100','2013-09-20','13:45:00',7.1),('16100','2013-09-20','13:50:00',7.11),('16100','2013-09-20','13:55:00',7.01),('16100','2013-09-20','14:00:00',6.58),('16100','2013-09-20','14:05:00',6.7),('16100','2013-09-20','14:10:00',6.71),('16100','2013-09-20','14:15:00',6.37),('16100','2013-09-20','14:20:00',6.69),('16100','2013-09-20','14:25:00',6.63),('16100','2013-09-20','14:30:00',6.59),('16100','2013-09-20','14:35:00',6.47),('16100','2013-09-20','14:40:00',6.46),('16100','2013-09-20','14:45:00',6.35),('16100','2013-09-20','14:50:00',6.25),('16100','2013-09-20','14:55:00',6.2),('16100','2013-09-20','15:00:00',6.06),('16100','2013-09-20','15:05:00',5.75),('16100','2013-09-20','15:10:00',5.99),('16100','2013-09-20','15:15:00',5.9),('16100','2013-09-20','15:20:00',5.79),('16100','2013-09-20','15:25:00',5.67),('16100','2013-09-20','15:30:00',5.58),('16100','2013-09-20','15:35:00',5.54),('16100','2013-09-20','15:40:00',5.44),('16100','2013-09-20','15:45:00',5.24),('16100','2013-09-20','15:50:00',5.26),('16100','2013-09-20','15:55:00',4.47),('16100','2013-09-20','16:00:00',3.24),('16100','2013-09-20','16:05:00',3.43),('16100','2013-09-20','16:10:00',2.85),('16100','2013-09-20','16:15:00',3.85),('16100','2013-09-20','16:20:00',1.74),('16100','2013-09-20','16:25:00',2.66),('16100','2013-09-20','16:30:00',3.85),('16100','2013-09-20','16:35:00',1.83),('16100','2013-09-20','16:40:00',1.87),('16100','2013-09-20','16:45:00',2.12),('16100','2013-09-20','16:50:00',1.41),('16100','2013-09-20','16:55:00',1.67),('16100','2013-09-20','17:00:00',2.27),('16100','2013-09-20','17:05:00',1.73),('16100','2013-09-20','17:10:00',2.49),('16100','2013-09-20','17:15:00',1.9),('16100','2013-09-20','17:20:00',1.12),('16100','2013-09-20','17:25:00',1.19),('16100','2013-09-20','17:30:00',1.82),('16100','2013-09-20','17:35:00',1.69),('16100','2013-09-20','17:40:00',1.86),('16100','2013-09-20','17:45:00',1.65),('16100','2013-09-20','17:50:00',1.29),('16100','2013-09-20','17:55:00',1.21),('16100','2013-09-20','18:00:00',1.08),('16100','2013-09-19','08:30:00',1.07),('16100','2013-09-19','08:35:00',1.21),('16100','2013-09-19','08:40:00',2.45),('16100','2013-09-19','08:45:00',2.41),('16100','2013-09-19','08:50:00',1.51),('16100','2013-09-19','08:55:00',1.5),('16100','2013-09-19','09:00:00',1.52),('16100','2013-09-19','09:05:00',1.45),('16100','2013-09-19','09:10:00',1.42),('16100','2013-09-19','09:15:00',1.51),('16100','2013-09-19','09:20:00',1.56),('16100','2013-09-19','09:25:00',1.59),('16100','2013-09-19','09:30:00',1.61),('16100','2013-09-19','09:35:00',1.78),('16100','2013-09-19','09:40:00',1.87),('16100','2013-09-19','09:45:00',2.04),('16100','2013-09-19','09:50:00',2.21),('16100','2013-09-19','09:55:00',2.56),('16100','2013-09-19','10:00:00',2.54),('16100','2013-09-19','10:05:00',3.35),('16100','2013-09-19','10:10:00',4.33),('16100','2013-09-19','10:15:00',5.91),('16100','2013-09-19','10:20:00',6.29),('16100','2013-09-19','10:25:00',5.25),('16100','2013-09-19','10:30:00',4.59),('16100','2013-09-19','10:35:00',3.82),('16100','2013-09-19','10:40:00',4.53),('16100','2013-09-19','10:45:00',5.17),('16100','2013-09-19','10:50:00',7.27),('16100','2013-09-19','10:55:00',4.36),('16100','2013-09-19','11:00:00',3.91),('16100','2013-09-19','11:05:00',3.92),('16100','2013-09-19','11:10:00',3.92),('16100','2013-09-19','11:15:00',4.21),('16100','2013-09-19','11:20:00',4.7),('16100','2013-09-19','11:25:00',4.09),('16100','2013-09-19','11:30:00',4.31),('16100','2013-09-19','11:35:00',4.57),('16100','2013-09-19','11:40:00',4.31),('16100','2013-09-19','11:45:00',6.49),('16100','2013-09-19','11:50:00',6.1),('16100','2013-09-19','11:55:00',7.25),('16100','2013-09-19','12:00:00',7.82),('16100','2013-09-19','12:05:00',7.45),('16100','2013-09-19','12:10:00',7.21),('16100','2013-09-19','12:15:00',7.23),('16100','2013-09-19','12:20:00',7.4),('16100','2013-09-19','12:25:00',7.62),('16100','2013-09-19','12:30:00',4.89),('16100','2013-09-19','12:35:00',7.44),('16100','2013-09-19','12:40:00',5.54),('16100','2013-09-19','12:45:00',7.41),('16100','2013-09-19','12:50:00',7.51),('16100','2013-09-19','12:55:00',6.81),('16100','2013-09-19','13:00:00',6.48),('16100','2013-09-19','13:05:00',7.22),('16100','2013-09-19','13:10:00',7.14),('16100','2013-09-19','13:15:00',7.11),('16100','2013-09-19','13:20:00',7.13),('16100','2013-09-19','13:25:00',7.1),('16100','2013-09-19','13:30:00',6.89),('16100','2013-09-19','13:35:00',7.15),('16100','2013-09-19','13:40:00',7.14),('16100','2013-09-19','13:45:00',7.09),('16100','2013-09-19','13:50:00',6.64),('16100','2013-09-19','13:55:00',6.94),('16100','2013-09-19','14:00:00',6.28),('16100','2013-09-19','14:05:00',7.17),('16100','2013-09-19','14:10:00',7.2),('16100','2013-09-19','14:15:00',2.33),('16100','2013-09-19','14:20:00',3.01),('16100','2013-09-19','14:25:00',1.74),('16100','2013-09-19','14:30:00',1.65),('16100','2013-09-19','14:35:00',2.16),('16100','2013-09-19','14:40:00',5.69),('16100','2013-09-19','14:45:00',2.16),('16100','2013-09-19','14:50:00',2.2),('16100','2013-09-19','14:55:00',2.59),('16100','2013-09-19','15:00:00',4.53),('16100','2013-09-19','15:05:00',6.59),('16100','2013-09-19','15:10:00',2.61),('16100','2013-09-19','15:15:00',4.63),('16100','2013-09-19','15:20:00',3.41),('16100','2013-09-19','15:25:00',6.67),('16100','2013-09-19','15:30:00',6.5),('16100','2013-09-19','15:35:00',6.06),('16100','2013-09-19','15:40:00',5.42),('16100','2013-09-19','15:45:00',5.33),('16100','2013-09-19','15:50:00',3.83),('16100','2013-09-19','15:55:00',5.64),('16100','2013-09-19','16:00:00',5.58),('16100','2013-09-19','16:05:00',5.65),('16100','2013-09-19','16:10:00',5.64),('16100','2013-09-19','16:15:00',5.64),('16100','2013-09-19','16:20:00',5.28),('16100','2013-09-19','16:25:00',4.84),('16100','2013-09-19','16:30:00',3.41),('16100','2013-09-19','16:35:00',1.76),('16100','2013-09-19','16:40:00',1.35),('16100','2013-09-19','16:45:00',1.85),('16100','2013-09-19','16:50:00',3.04),('16100','2013-09-19','16:55:00',4.03),('16100','2013-09-19','17:00:00',3.86),('16100','2013-09-19','17:05:00',3.95),('16100','2013-09-19','17:10:00',4.07),('16100','2013-09-19','17:15:00',4.06),('16100','2013-09-19','17:20:00',3.86),('16100','2013-09-19','17:25:00',3.5),('16100','2013-09-19','17:30:00',3.44),('16100','2013-09-19','17:35:00',3.34),('16100','2013-09-19','17:40:00',3.06),('16100','2013-09-19','17:45:00',2.78),('16100','2013-09-19','17:50:00',2.06),('16100','2013-09-19','17:55:00',1.45),('16100','2013-09-19','18:00:00',1.51),('16100','2013-09-19','18:05:00',1.39),('16100','2013-09-19','18:10:00',1.37),('16100','2013-09-19','18:15:00',1.06),('16100','2013-09-18','08:15:00',1.29),('16100','2013-09-18','08:20:00',1.43),('16100','2013-09-18','08:25:00',1.35),('16100','2013-09-18','08:30:00',1.88),('16100','2013-09-18','08:35:00',1.67),('16100','2013-09-18','08:40:00',1.51),('16100','2013-09-18','08:45:00',1.69),('16100','2013-09-18','08:50:00',1.1),('16100','2013-09-18','08:55:00',1.55),('16100','2013-09-18','09:00:00',2.73),('16100','2013-09-18','09:05:00',3.04),('16100','2013-09-18','09:10:00',3.69),('16100','2013-09-18','09:15:00',2.36),('16100','2013-09-18','09:20:00',1.62),('16100','2013-09-18','09:25:00',2.35),('16100','2013-09-18','09:30:00',3.68),('16100','2013-09-18','09:35:00',1.33),('16100','2013-09-18','09:40:00',3.95),('16100','2013-09-18','09:45:00',4.47),('16100','2013-09-18','09:50:00',3.62),('16100','2013-09-18','09:55:00',2.53),('16100','2013-09-18','10:00:00',4.63),('16100','2013-09-18','10:05:00',3.79),('16100','2013-09-18','10:10:00',2.63),('16100','2013-09-18','10:15:00',4.25),('16100','2013-09-18','10:20:00',4.97),('16100','2013-09-18','10:25:00',6.03),('16100','2013-09-18','10:30:00',4.2),('16100','2013-09-18','10:35:00',3.34),('16100','2013-09-18','10:40:00',1.92),('16100','2013-09-18','10:45:00',2.18),('16100','2013-09-18','10:50:00',2.04),('16100','2013-09-18','10:55:00',1.49),('16100','2013-09-18','11:00:00',4.34),('16100','2013-09-18','11:05:00',7.05),('16100','2013-09-18','11:10:00',4.78),('16100','2013-09-18','11:15:00',2.44),('16100','2013-09-18','11:20:00',1.33),('16100','2013-09-18','11:25:00',3.14),('16100','2013-09-18','11:30:00',6.78),('16100','2013-09-18','11:35:00',7.14),('16100','2013-09-18','11:40:00',7.82),('16100','2013-09-18','11:45:00',8),('16100','2013-09-18','11:50:00',4.67),('16100','2013-09-18','11:55:00',7.52),('16100','2013-09-18','12:00:00',6.97),('16100','2013-09-18','12:05:00',3.54),('16100','2013-09-18','12:10:00',3.48),('16100','2013-09-18','12:15:00',8.29),('16100','2013-09-18','12:20:00',6.43),('16100','2013-09-18','12:25:00',5.69),('16100','2013-09-18','12:30:00',7.92),('16100','2013-09-18','12:35:00',7.83),('16100','2013-09-18','12:40:00',6.28),('16100','2013-09-18','12:45:00',1.01),('16100','2013-09-18','12:50:00',3.21),('16100','2013-09-18','12:55:00',8.42),('16100','2013-09-18','13:00:00',4.93),('16100','2013-09-18','13:05:00',8.2),('16100','2013-09-18','13:10:00',7.94),('16100','2013-09-18','13:15:00',7.12),('16100','2013-09-18','13:20:00',2.02),('16100','2013-09-18','13:25:00',8.2),('16100','2013-09-18','13:30:00',8),('16100','2013-09-18','13:35:00',7.94),('16100','2013-09-18','13:40:00',8.08),('16100','2013-09-18','13:45:00',6.19),('16100','2013-09-18','13:50:00',5.84),('16100','2013-09-18','13:55:00',6.14),('16100','2013-09-18','14:00:00',6.45),('16100','2013-09-18','14:05:00',7.4),('16100','2013-09-18','14:10:00',7.28),('16100','2013-09-18','14:15:00',7.2),('16100','2013-09-18','14:20:00',7.09),('16100','2013-09-18','14:25:00',7.08),('16100','2013-09-18','14:30:00',6.95),('16100','2013-09-18','14:35:00',6.59),('16100','2013-09-18','14:40:00',6.83),('16100','2013-09-18','14:45:00',6.81),('16100','2013-09-18','14:50:00',6.81),('16100','2013-09-18','14:55:00',6.9),('16100','2013-09-18','15:00:00',6.29),('16100','2013-09-18','15:05:00',5.41),('16100','2013-09-18','15:10:00',6.5),('16100','2013-09-18','15:15:00',3.24),('16100','2013-09-18','15:20:00',3.99),('16100','2013-09-18','15:25:00',5.01),('16100','2013-09-18','15:30:00',4.48),('16100','2013-09-18','15:35:00',5.26),('16100','2013-09-18','15:40:00',6.06),('16100','2013-09-18','15:45:00',4.63),('16100','2013-09-18','15:50:00',5.07),('16100','2013-09-18','15:55:00',4.83),('16100','2013-09-18','16:00:00',4),('16100','2013-09-18','16:05:00',4.24),('16100','2013-09-18','16:10:00',4.53),('16100','2013-09-18','16:15:00',4.84),('16100','2013-09-18','16:20:00',3.79),('16100','2013-09-18','16:25:00',4.39),('16100','2013-09-18','16:30:00',4.22),('16100','2013-09-18','16:35:00',3.98),('16100','2013-09-18','16:40:00',4.05),('16100','2013-09-18','16:45:00',4.23),('16100','2013-09-18','16:50:00',3.86),('16100','2013-09-18','16:55:00',3.44),('16100','2013-09-18','17:00:00',3.47),('16100','2013-09-18','17:05:00',2.96),('16100','2013-09-18','17:10:00',3.08),('16100','2013-09-18','17:15:00',2.43),('16100','2013-09-18','17:20:00',2.48),('16100','2013-09-18','17:25:00',2.53),('16100','2013-09-18','17:30:00',1.7),('16100','2013-09-18','17:35:00',1.23),('16100','2013-09-18','17:40:00',1.49),('16100','2013-09-18','17:45:00',1.15),('16100','2013-09-18','17:50:00',1.36),('16100','2014-04-12','08:35:00',1.11),('16100','2014-04-12','08:40:00',1.21),('16100','2014-04-12','08:45:00',1.21),('16100','2014-04-12','08:50:00',1.26),('16100','2014-04-12','08:55:00',1.24),('16100','2014-04-12','09:00:00',2.11),('16100','2014-04-12','09:05:00',2.13),('16100','2014-04-12','09:10:00',1.82),('16100','2014-04-12','09:15:00',1.88),('16100','2014-04-12','09:20:00',2.16),('16100','2014-04-12','09:25:00',2.36),('16100','2014-04-12','09:30:00',2.16),('16100','2014-04-12','09:35:00',2.22),('16100','2014-04-12','09:40:00',2.34),('16100','2014-04-12','09:45:00',2.56),('16100','2014-04-12','09:50:00',2.74),('16100','2014-04-12','09:55:00',4.58),('16100','2014-04-12','10:00:00',5.55),('16100','2014-04-12','10:05:00',4.75),('16100','2014-04-12','10:10:00',2.65),('16100','2014-04-12','10:15:00',3.28),('16100','2014-04-12','10:20:00',3.21),('16100','2014-04-12','10:25:00',4.41),('16100','2014-04-12','10:30:00',5.25),('16100','2014-04-12','10:35:00',5.93),('16100','2014-04-12','10:40:00',5.94),('16100','2014-04-12','10:45:00',6.18),('16100','2014-04-12','10:50:00',6.29),('16100','2014-04-12','10:55:00',6.34),('16100','2014-04-12','11:00:00',6.63),('16100','2014-04-12','11:05:00',7.02),('16100','2014-04-12','11:10:00',7.85),('16100','2014-04-12','11:15:00',5.92),('16100','2014-04-12','11:20:00',3.63),('16100','2014-04-12','11:25:00',5.63),('16100','2014-04-12','11:30:00',6.39),('16100','2014-04-12','11:35:00',5.27),('16100','2014-04-12','11:40:00',5.79),('16100','2014-04-12','11:45:00',7.33),('16100','2014-04-12','11:50:00',7.69),('16100','2014-04-12','11:55:00',5.1),('16100','2014-04-12','12:00:00',2.38),('16100','2014-04-12','12:05:00',2.21),('16100','2014-04-12','12:10:00',1.96),('16100','2014-04-12','12:15:00',1.91),('16100','2014-04-12','12:20:00',1.47),('16100','2014-04-12','12:45:00',1.04),('16100','2014-04-12','12:50:00',1.56),('16100','2014-04-12','12:55:00',2.06),('16100','2014-04-12','13:00:00',2.49),('16100','2014-04-12','13:05:00',3.07),('16100','2014-04-12','13:10:00',4.74),('16100','2014-04-12','13:15:00',7.72),('16100','2014-04-12','13:20:00',8.1),('16100','2014-04-12','13:25:00',7.13),('16100','2014-04-12','13:30:00',7.42),('16100','2014-04-12','13:35:00',3.87),('16100','2014-04-12','13:40:00',4.13),('16100','2014-04-12','13:45:00',4.7),('16100','2014-04-12','13:50:00',5.74),('16100','2014-04-12','13:55:00',5.26),('16100','2014-04-12','14:00:00',6.99),('16100','2014-04-12','14:05:00',6.93),('16100','2014-04-12','14:10:00',6.55),('16100','2014-04-12','14:15:00',3.64),('16100','2014-04-12','14:20:00',3.08),('16100','2014-04-12','14:25:00',2.87),('16100','2014-04-12','14:30:00',2.98),('16100','2014-04-12','14:35:00',2.95),('16100','2014-04-12','14:40:00',5.47),('16100','2014-04-12','14:45:00',7.7),('16100','2014-04-12','14:50:00',7.31),('16100','2014-04-12','14:55:00',7.15),('16100','2014-04-12','15:00:00',7.02),('16100','2014-04-12','15:05:00',6.96),('16100','2014-04-12','15:10:00',5.74),('16100','2014-04-12','15:15:00',5.77),('16100','2014-04-12','15:20:00',6.62),('16100','2014-04-12','15:25:00',6.28),('16100','2014-04-12','15:30:00',3.28),('16100','2014-04-12','15:35:00',3.93),('16100','2014-04-12','15:40:00',3.83),('16100','2014-04-12','15:45:00',3.58),('16100','2014-04-12','15:50:00',3.69),('16100','2014-04-12','15:55:00',4.59),('16100','2014-04-12','16:00:00',2.46),('16100','2014-04-12','16:05:00',2.03),('16100','2014-04-12','16:10:00',1.93),('16100','2014-04-12','16:15:00',2.16),('16100','2014-04-12','16:20:00',2.2),('16100','2014-04-12','16:25:00',1.88),('16100','2014-04-12','16:30:00',2.95),('16100','2014-04-12','16:35:00',4.68),('16100','2014-04-12','16:40:00',4.6),('16100','2014-04-12','16:45:00',3.65),('16100','2014-04-12','16:50:00',3.78),('16100','2014-04-12','16:55:00',2.12),('16100','2014-04-12','17:00:00',2.34),('16100','2014-04-12','17:05:00',2.26),('16100','2014-04-12','17:10:00',1.71),('16100','2014-04-12','17:15:00',1.72),('16100','2014-04-12','17:20:00',1.64),('16100','2014-04-12','17:25:00',1.13),('16100','2014-04-12','17:30:00',1.76),('16100','2014-04-12','17:35:00',2.07),('16100','2014-04-12','17:40:00',2.07),('16100','2014-04-12','17:45:00',1.89),('16100','2014-04-12','17:50:00',2.02),('16100','2014-04-12','17:55:00',1.89),('16100','2014-04-12','18:00:00',2.05),('16100','2014-04-12','18:05:00',1.91),('16100','2014-04-12','18:10:00',1.44),('16100','2014-04-12','18:15:00',1.15),('16100','2013-09-17','08:10:00',1.06),('16100','2013-09-17','08:15:00',1.21),('16100','2013-09-17','08:20:00',1.4),('16100','2013-09-17','08:25:00',1.49),('16100','2013-09-17','08:30:00',1.4),('16100','2013-09-17','08:35:00',1.87),('16100','2013-09-17','08:40:00',2.21),('16100','2013-09-17','09:00:00',1.72),('16100','2013-09-17','09:05:00',3.2),('16100','2013-09-17','09:10:00',3.53),('16100','2013-09-17','09:15:00',2.89),('16100','2013-09-17','09:20:00',1.46),('16100','2013-09-17','09:25:00',1.8),('16100','2013-09-17','09:30:00',2.81),('16100','2013-09-17','09:35:00',4.69),('16100','2013-09-17','09:40:00',4.6),('16100','2013-09-17','09:45:00',1.19),('16100','2013-09-17','09:55:00',1.13),('16100','2013-09-17','10:00:00',3.51),('16100','2013-09-17','10:05:00',5.1),('16100','2013-09-17','10:10:00',4.79),('16100','2013-09-17','10:15:00',4.41),('16100','2013-09-17','10:20:00',5.15),('16100','2013-09-17','10:25:00',5.37),('16100','2013-09-17','10:30:00',5.52),('16100','2013-09-17','10:35:00',5.59),('16100','2013-09-17','10:40:00',5.68),('16100','2013-09-17','10:45:00',5.85),('16100','2013-09-17','10:50:00',5.93),('16100','2013-09-17','10:55:00',5.96),('16100','2013-09-17','11:00:00',6.08),('16100','2013-09-17','11:05:00',5.45),('16100','2013-09-17','11:10:00',6.51),('16100','2013-09-17','11:15:00',6.38),('16100','2013-09-17','11:20:00',6.56),('16100','2013-09-17','11:25:00',7.02),('16100','2013-09-17','11:30:00',7.04),('16100','2013-09-17','11:35:00',7.09),('16100','2013-09-17','11:40:00',6.24),('16100','2013-09-17','11:45:00',6.17),('16100','2013-09-17','11:50:00',5.82),('16100','2013-09-17','11:55:00',7.28),('16100','2013-09-17','12:00:00',6.9),('16100','2013-09-17','12:05:00',7.35),('16100','2013-09-17','12:10:00',7.42),('16100','2013-09-17','12:15:00',6.7),('16100','2013-09-17','12:20:00',8.05),('16100','2013-09-17','12:25:00',8.22),('16100','2013-09-17','12:30:00',8.28),('16100','2013-09-17','12:35:00',8.02),('16100','2013-09-17','12:40:00',7.86),('16100','2013-09-17','12:45:00',8.11),('16100','2013-09-17','12:50:00',6.91),('16100','2013-09-17','12:55:00',2.65),('16100','2013-09-17','13:00:00',3.63),('16100','2013-09-17','13:05:00',8.41),('16100','2013-09-17','13:10:00',8.43),('16100','2013-09-17','13:15:00',2.88),('16100','2013-09-17','13:20:00',2.94),('16100','2013-09-17','13:25:00',6.56),('16100','2013-09-17','13:30:00',8.3),('16100','2013-09-17','13:35:00',8.26),('16100','2013-09-17','13:40:00',7.68),('16100','2013-09-17','13:45:00',4.19),('16100','2013-09-17','13:50:00',8.08),('16100','2013-09-17','13:55:00',7.53),('16100','2013-09-17','14:00:00',6.26),('16100','2013-09-17','14:05:00',7.11),('16100','2013-09-17','14:10:00',7.37),('16100','2013-09-17','14:15:00',3.52),('16100','2013-09-17','14:20:00',7.23),('16100','2013-09-17','14:25:00',7.41),('16100','2013-09-17','14:30:00',7.23),('16100','2013-09-17','14:35:00',7.15),('16100','2013-09-17','14:40:00',6.12),('16100','2013-09-17','14:45:00',3.92),('16100','2013-09-17','14:50:00',4.35),('16100','2013-09-17','14:55:00',7.34),('16100','2013-09-17','15:00:00',5.93),('16100','2013-09-17','15:05:00',2.32),('16100','2013-09-17','15:10:00',5.07),('16100','2013-09-17','15:15:00',1.91),('16100','2013-09-17','15:20:00',2.52),('16100','2013-09-17','15:25:00',5.25),('16100','2013-09-17','15:30:00',6.42),('16100','2013-09-17','15:35:00',4.73),('16100','2013-09-17','15:40:00',6.07),('16100','2013-09-17','15:45:00',3.66),('16100','2013-09-17','15:50:00',5.57),('16100','2013-09-17','15:55:00',5.63),('16100','2013-09-17','16:00:00',5.52),('16100','2013-09-17','16:05:00',4.82),('16100','2013-09-17','16:10:00',5.35),('16100','2013-09-17','16:15:00',3.71),('16100','2013-09-17','16:20:00',4.61),('16100','2013-09-17','16:25:00',4.5),('16100','2013-09-17','16:30:00',4.13),('16100','2013-09-17','16:35:00',4.05),('16100','2013-09-17','16:40:00',3.6),('16100','2013-09-17','16:45:00',3.39),('16100','2013-09-17','16:50:00',3.56),('16100','2013-09-17','16:55:00',3.63),('16100','2013-09-17','17:00:00',3.3),('16100','2013-09-17','17:05:00',3.38),('16100','2013-09-17','17:10:00',2.83),('16100','2013-09-17','17:15:00',3.23),('16100','2013-09-17','17:20:00',2.92),('16100','2013-09-17','17:25:00',1.56),('16100','2013-09-17','17:30:00',2.53),('16100','2013-09-17','17:35:00',2.2),('16100','2013-09-17','17:40:00',1.98),('16100','2013-09-17','17:45:00',1.83),('16100','2013-09-17','17:50:00',1.68),('16100','2013-09-17','17:55:00',1.47),('16100','2013-09-17','18:00:00',1.25),('16100','2013-09-17','18:05:00',1.14),('16100','2013-09-16','09:00:00',1.03),('16100','2013-09-16','09:05:00',1.13),('16100','2013-09-16','09:10:00',1.54),('16100','2013-09-16','09:15:00',1.18),('16100','2013-09-16','09:20:00',1.37),('16100','2013-09-16','09:25:00',1.74),('16100','2013-09-16','09:30:00',1.53),('16100','2013-09-16','09:35:00',1.3),('16100','2013-09-16','09:40:00',3.91),('16100','2013-09-16','09:45:00',2.43),('16100','2013-09-16','09:50:00',2.6),('16100','2013-09-16','09:55:00',3.07),('16100','2013-09-16','10:00:00',4.03),('16100','2013-09-16','10:05:00',4.17),('16100','2013-09-16','10:10:00',2.36),('16100','2013-09-16','10:15:00',3.5),('16100','2013-09-16','10:20:00',5.61),('16100','2013-09-16','10:25:00',3.84),('16100','2013-09-16','10:30:00',3.94),('16100','2013-09-16','10:35:00',4.5),('16100','2013-09-16','10:40:00',6.6),('16100','2013-09-16','10:45:00',5.36),('16100','2013-09-16','10:50:00',5.26),('16100','2013-09-16','10:55:00',3.22),('16100','2013-09-16','11:00:00',3.42),('16100','2013-09-16','11:05:00',5.83),('16100','2013-09-16','11:10:00',6.21),('16100','2013-09-16','11:15:00',2.96),('16100','2013-09-16','11:20:00',2.16),('16100','2013-09-16','11:25:00',4.3),('16100','2013-09-16','11:30:00',2.54),('16100','2013-09-16','11:35:00',4.32),('16100','2013-09-16','11:40:00',4.05),('16100','2013-09-16','11:45:00',6.95),('16100','2013-09-16','11:50:00',2.45),('16100','2013-09-16','11:55:00',6.83),('16100','2013-09-16','12:00:00',3.71),('16100','2013-09-16','12:05:00',1.64),('16100','2013-09-16','12:10:00',1.8),('16100','2013-09-16','12:15:00',2.91),('16100','2013-09-16','12:20:00',4.75),('16100','2013-09-16','12:25:00',2.66),('16100','2013-09-16','12:30:00',2.57),('16100','2013-09-16','12:35:00',2.56),('16100','2013-09-16','12:40:00',1.61),('16100','2013-09-16','12:45:00',2.41),('16100','2013-09-16','12:50:00',5.05),('16100','2013-09-16','12:55:00',5.1),('16100','2013-09-16','13:00:00',5.8),('16100','2013-09-16','13:05:00',5.94),('16100','2013-09-16','13:10:00',4.04),('16100','2013-09-16','13:15:00',2.51),('16100','2013-09-16','13:20:00',2.62),('16100','2013-09-16','13:25:00',3.38),('16100','2013-09-16','13:30:00',2.28),('16100','2013-09-16','13:35:00',2.52),('16100','2013-09-16','13:40:00',2.44),('16100','2013-09-16','13:45:00',2.12),('16100','2013-09-16','13:50:00',1.95),('16100','2013-09-16','13:55:00',2.31),('16100','2013-09-16','14:00:00',1.68),('16100','2013-09-16','14:05:00',2.9),('16100','2013-09-16','14:10:00',3.48),('16100','2013-09-16','14:15:00',1.96),('16100','2013-09-16','14:20:00',1.07),('16100','2013-09-16','14:30:00',2.85),('16100','2013-09-16','14:35:00',1.95),('16100','2013-09-16','14:40:00',1.42),('16100','2013-09-16','14:45:00',1.59),('16100','2013-09-16','14:50:00',2.55),('16100','2013-09-16','14:55:00',6.26),('16100','2013-09-16','15:00:00',6.34),('16100','2013-09-16','15:05:00',5.25),('16100','2013-09-16','15:10:00',4.96),('16100','2013-09-16','15:15:00',3.32),('16100','2013-09-16','15:20:00',1.35),('16100','2013-09-16','15:25:00',1.37),('16100','2013-09-16','15:30:00',1.24),('16100','2013-09-16','15:35:00',1.88),('16100','2013-09-16','15:40:00',2.08),('16100','2013-09-16','15:45:00',4.35),('16100','2013-09-16','15:50:00',2.69),('16100','2013-09-16','15:55:00',4.04),('16100','2013-09-16','16:00:00',4.14),('16100','2013-09-16','16:05:00',3.63),('16100','2013-09-16','16:10:00',3.98),('16100','2013-09-16','16:15:00',2.75),('16100','2013-09-16','16:20:00',1.33),('16100','2013-09-16','16:35:00',1.64),('16100','2013-09-16','16:40:00',2.62),('16100','2013-09-16','16:45:00',2.66),('16100','2013-09-16','16:50:00',1.82),('16100','2013-09-16','16:55:00',2.06),('16100','2013-09-16','17:00:00',2.95),('16100','2013-09-16','17:05:00',2.9),('16100','2013-09-16','17:10:00',3.05),('16100','2013-09-16','17:15:00',2.81),('16100','2013-09-16','17:20:00',2.46),('16100','2013-09-16','17:25:00',2.43),('16100','2013-09-16','17:30:00',2.33),('16100','2013-09-16','17:35:00',2.2),('16100','2013-09-16','17:40:00',1.67),('16100','2013-09-16','17:45:00',1.42),('16100','2013-09-16','17:50:00',1.15),('16100','2013-09-16','17:55:00',1.13),('16100','2013-09-16','18:00:00',1.1),('16100','2013-09-16','18:05:00',1.15),('16100','2013-09-15','08:05:00',1.01),('16100','2013-09-15','08:10:00',1.2),('16100','2013-09-15','08:15:00',1.36),('16100','2013-09-15','08:20:00',1.54),('16100','2013-09-15','08:25:00',1.72),('16100','2013-09-15','08:30:00',2),('16100','2013-09-15','08:35:00',2.05),('16100','2013-09-15','08:40:00',2.17),('16100','2013-09-15','08:45:00',2.5),('16100','2013-09-15','08:50:00',2.6),('16100','2013-09-15','08:55:00',1.24),('16100','2013-09-15','09:00:00',1.4),('16100','2013-09-15','09:05:00',1.79),('16100','2013-09-15','09:10:00',1.64),('16100','2013-09-15','09:15:00',2.42),('16100','2013-09-15','09:20:00',3.02),('16100','2013-09-15','09:25:00',3.89),('16100','2013-09-15','09:30:00',3.99),('16100','2013-09-15','09:35:00',4.13),('16100','2013-09-15','09:40:00',4.29),('16100','2013-09-15','09:45:00',4.42),('16100','2013-09-15','09:50:00',4.64),('16100','2013-09-15','09:55:00',4.73),('16100','2013-09-15','10:00:00',4.9),('16100','2013-09-15','10:05:00',5.02),('16100','2013-09-15','10:10:00',5.33),('16100','2013-09-15','10:15:00',3.46),('16100','2013-09-15','10:20:00',4.04),('16100','2013-09-15','10:25:00',1.34),('16100','2013-09-15','10:30:00',1.36),('16100','2013-09-15','10:45:00',6.06),('16100','2013-09-15','10:50:00',5.87),('16100','2013-09-15','10:55:00',7.14),('16100','2013-09-15','11:00:00',3.11),('16100','2013-09-15','11:05:00',4.19),('16100','2013-09-15','11:10:00',7.38),('16100','2013-09-15','11:15:00',6.72),('16100','2013-09-15','11:20:00',7.28),('16100','2013-09-15','11:25:00',6.17),('16100','2013-09-15','11:30:00',5.66),('16100','2013-09-15','11:35:00',7.34),('16100','2013-09-15','11:40:00',5.24),('16100','2013-09-15','11:45:00',4.41),('16100','2013-09-15','11:50:00',5.37),('16100','2013-09-15','11:55:00',6.9),('16100','2013-09-15','12:00:00',8.15),('16100','2013-09-15','12:05:00',6.99),('16100','2013-09-15','12:10:00',1.5),('16100','2013-09-15','12:15:00',6.36),('16100','2013-09-15','12:20:00',7.88),('16100','2013-09-15','12:25:00',7.67),('16100','2013-09-15','12:30:00',6.1),('16100','2013-09-15','12:35:00',4.5),('16100','2013-09-15','12:40:00',7.13),('16100','2013-09-15','12:45:00',2.84),('16100','2013-09-15','12:50:00',4.8),('16100','2013-09-15','12:55:00',1.78),('16100','2013-09-15','13:00:00',4.23),('16100','2013-09-15','13:05:00',7.02),('16100','2013-09-15','13:10:00',7.39),('16100','2013-09-15','13:15:00',7.85),('16100','2013-09-15','13:20:00',7.8),('16100','2013-09-15','13:25:00',7.72),('16100','2013-09-15','13:30:00',7.65),('16100','2013-09-15','13:35:00',7.62),('16100','2013-09-15','13:40:00',7.78),('16100','2013-09-15','13:45:00',7.4),('16100','2013-09-15','13:50:00',3.65),('16100','2013-09-15','13:55:00',6.42),('16100','2013-09-15','14:00:00',7.71),('16100','2013-09-15','14:05:00',7.34),('16100','2013-09-15','14:10:00',7.2),('16100','2013-09-15','14:15:00',7.16),('16100','2013-09-15','14:20:00',7.09),('16100','2013-09-15','14:25:00',7),('16100','2013-09-15','14:30:00',7),('16100','2013-09-15','14:35:00',6.89),('16100','2013-09-15','14:40:00',6.82),('16100','2013-09-15','14:45:00',6.84),('16100','2013-09-15','14:50:00',6.75),('16100','2013-09-15','14:55:00',6.71),('16100','2013-09-15','15:00:00',6.63),('16100','2013-09-15','15:05:00',6.54),('16100','2013-09-15','15:10:00',6.42),('16100','2013-09-15','15:15:00',6.32),('16100','2013-09-15','15:20:00',6.22),('16100','2013-09-15','15:25:00',6.15),('16100','2013-09-15','15:30:00',6.02),('16100','2013-09-15','15:35:00',5.94),('16100','2013-09-15','15:40:00',5.86),('16100','2013-09-15','15:45:00',5.78),('16100','2013-09-15','15:50:00',5.66),('16100','2013-09-15','15:55:00',4.32),('16100','2013-09-15','16:00:00',4.85),('16100','2013-09-15','16:05:00',5.44),('16100','2013-09-15','16:10:00',5.14),('16100','2013-09-15','16:15:00',5),('16100','2013-09-15','16:20:00',4.87),('16100','2013-09-15','16:25:00',4.74),('16100','2013-09-15','16:30:00',4.6),('16100','2013-09-15','16:35:00',4.48),('16100','2013-09-15','16:40:00',4.32),('16100','2013-09-15','16:45:00',4.16),('16100','2013-09-15','16:50:00',4.01),('16100','2013-09-15','16:55:00',3.81),('16100','2013-09-15','17:00:00',3.69),('16100','2013-09-15','17:05:00',3.46),('16100','2013-09-15','17:10:00',3.34),('16100','2013-09-15','17:15:00',2.88),('16100','2013-09-15','17:20:00',2.8),('16100','2013-09-15','17:25:00',2.51),('16100','2013-09-15','17:30:00',1.62),('16100','2013-09-15','17:35:00',2.04),('16100','2013-09-15','17:40:00',2.3),('16100','2013-09-15','17:45:00',2.07),('16100','2013-09-15','17:50:00',1.84),('16100','2013-09-15','17:55:00',1.68),('16100','2013-09-15','18:00:00',1.47),('16100','2013-09-15','18:05:00',1.32),('16100','2013-09-15','18:10:00',1.14),('16100','2013-09-14','08:05:00',1.05),('16100','2013-09-14','08:10:00',1.23),('16100','2013-09-14','08:15:00',1.43),('16100','2013-09-14','08:20:00',1.63),('16100','2013-09-14','08:25:00',1.82),('16100','2013-09-14','08:30:00',2.03),('16100','2013-09-14','08:35:00',2.27),('16100','2013-09-14','08:40:00',2.49),('16100','2013-09-14','08:45:00',2.69),('16100','2013-09-14','08:50:00',2.69),('16100','2013-09-14','08:55:00',2.84),('16100','2013-09-14','09:00:00',2.98),('16100','2013-09-14','09:05:00',3.2),('16100','2013-09-14','09:10:00',3.36),('16100','2013-09-14','09:15:00',3.69),('16100','2013-09-14','09:20:00',3.66),('16100','2013-09-14','09:25:00',3.82),('16100','2013-09-14','09:30:00',3.88),('16100','2013-09-14','09:35:00',4.11),('16100','2013-09-14','09:40:00',4.28),('16100','2013-09-14','09:45:00',4.46),('16100','2013-09-14','09:50:00',4.53),('16100','2013-09-14','09:55:00',4.83),('16100','2013-09-14','10:00:00',4.89),('16100','2013-09-14','10:05:00',4.92),('16100','2013-09-14','10:10:00',4.61),('16100','2013-09-14','10:15:00',4.86),('16100','2013-09-14','10:20:00',5.04),('16100','2013-09-14','10:25:00',5.23),('16100','2013-09-14','10:30:00',5.24),('16100','2013-09-14','10:35:00',5.74),('16100','2013-09-14','10:40:00',5.81),('16100','2013-09-14','10:45:00',5.54),('16100','2013-09-14','10:50:00',5.91),('16100','2013-09-14','10:55:00',5.41),('16100','2013-09-14','11:00:00',4.68),('16100','2013-09-14','11:05:00',6.97),('16100','2013-09-14','11:10:00',7.14),('16100','2013-09-14','11:15:00',3.51),('16100','2013-09-14','11:20:00',1.47),('16100','2013-09-14','11:25:00',1.51),('16100','2013-09-14','11:30:00',2.28),('16100','2013-09-14','11:35:00',5.06),('16100','2013-09-14','11:40:00',2.09),('16100','2013-09-14','11:45:00',1.87),('16100','2013-09-14','11:50:00',2.11),('16100','2013-09-14','11:55:00',3.05),('16100','2013-09-14','12:00:00',3.72),('16100','2013-09-14','12:05:00',3.07),('16100','2013-09-14','12:10:00',3.61),('16100','2013-09-14','12:15:00',2.86),('16100','2013-09-14','12:20:00',2.62),('16100','2013-09-14','12:25:00',3.2),('16100','2013-09-14','12:30:00',5.83),('16100','2013-09-14','12:35:00',3.37),('16100','2013-09-14','12:40:00',2.92),('16100','2013-09-14','12:45:00',2.18),('16100','2013-09-14','12:50:00',2.07),('16100','2013-09-14','12:55:00',1.99),('16100','2013-09-14','13:00:00',2.15),('16100','2013-09-14','13:05:00',2.31),('16100','2013-09-14','13:10:00',3.49),('16100','2013-09-14','13:15:00',2.89),('16100','2013-09-14','13:20:00',2.52),('16100','2013-09-14','13:25:00',2.3),('16100','2013-09-14','13:30:00',2.3),('16100','2013-09-14','13:35:00',2.43),('16100','2013-09-14','13:40:00',3.01),('16100','2013-09-14','13:45:00',4.92),('16100','2013-09-14','13:50:00',2.97),('16100','2013-09-14','13:55:00',3.39),('16100','2013-09-14','14:00:00',5.04),('16100','2013-09-14','14:05:00',3.05),('16100','2013-09-14','14:10:00',3.3),('16100','2013-09-14','14:15:00',3.03),('16100','2013-09-14','14:20:00',2.58),('16100','2013-09-14','14:25:00',2.29),('16100','2013-09-14','14:30:00',2.02),('16100','2013-09-14','14:35:00',1.62),('16100','2013-09-14','14:40:00',1.56),('16100','2013-09-14','14:45:00',1.56),('16100','2013-09-14','14:50:00',1.7),('16100','2013-09-14','14:55:00',1.76),('16100','2013-09-14','15:00:00',1.89),('16100','2013-09-14','15:05:00',1.84),('16100','2013-09-14','15:10:00',2.51),('16100','2013-09-14','15:15:00',3.22),('16100','2013-09-14','15:20:00',3.07),('16100','2013-09-14','15:25:00',1.95),('16100','2013-09-14','15:30:00',1.48),('16100','2013-09-14','15:35:00',1.6),('16100','2013-09-14','15:40:00',1.46),('16100','2013-09-14','15:45:00',1.21),('16100','2013-09-14','15:50:00',1.15),('16100','2013-09-14','16:00:00',1.09),('16100','2013-09-14','16:05:00',1.45),('16100','2013-09-14','16:10:00',1.16),('16100','2013-09-14','16:35:00',1.24),('16100','2013-09-14','16:40:00',1.57),('16100','2013-09-14','16:45:00',1.4),('16100','2013-09-14','16:50:00',1.06),('16100','2013-09-14','17:00:00',1.25),('16100','2013-09-14','17:05:00',1.16),('16100','2013-09-14','17:10:00',1.03),('16100','2013-09-14','17:15:00',1.08),('16100','2013-09-14','17:20:00',1.12),('16100','2013-09-13','08:05:00',1.03),('16100','2013-09-13','08:10:00',1.19),('16100','2013-09-13','08:15:00',1.37),('16100','2013-09-13','08:20:00',1.56),('16100','2013-09-13','08:25:00',1.74),('16100','2013-09-13','08:30:00',1.94),('16100','2013-09-13','08:35:00',2.13),('16100','2013-09-13','08:40:00',2.31),('16100','2013-09-13','08:45:00',2.51),('16100','2013-09-13','08:50:00',2.66),('16100','2013-09-13','08:55:00',2.81),('16100','2013-09-13','09:00:00',3.02),('16100','2013-09-13','09:05:00',3.19),('16100','2013-09-13','09:10:00',3.35),('16100','2013-09-13','09:15:00',3.55),('16100','2013-09-13','09:20:00',3.72),('16100','2013-09-13','09:25:00',3.89),('16100','2013-09-13','09:30:00',4.07),('16100','2013-09-13','09:35:00',4.21),('16100','2013-09-13','09:40:00',4.33),('16100','2013-09-13','09:45:00',4.47),('16100','2013-09-13','09:50:00',4.62),('16100','2013-09-13','09:55:00',4.8),('16100','2013-09-13','10:00:00',4.92),('16100','2013-09-13','10:05:00',5.05),('16100','2013-09-13','10:10:00',5.12),('16100','2013-09-13','10:15:00',4.9),('16100','2013-09-13','10:20:00',5.43),('16100','2013-09-13','10:25:00',5.26),('16100','2013-09-13','10:30:00',5.63),('16100','2013-09-13','10:35:00',5.75),('16100','2013-09-13','10:40:00',5.65),('16100','2013-09-13','10:45:00',5.95),('16100','2013-09-13','10:50:00',6.07),('16100','2013-09-13','10:55:00',5.93),('16100','2013-09-13','11:00:00',3.06),('16100','2013-09-13','11:05:00',1.65),('16100','2013-09-13','11:10:00',2.11),('16100','2013-09-13','11:15:00',2.58),('16100','2013-09-13','11:20:00',7.16),('16100','2013-09-13','11:25:00',6.44),('16100','2013-09-13','11:30:00',7.04),('16100','2013-09-13','11:35:00',6.95),('16100','2013-09-13','11:40:00',7.13),('16100','2013-09-13','11:45:00',7.15),('16100','2013-09-13','11:50:00',5.69),('16100','2013-09-13','11:55:00',6.75),('16100','2013-09-13','12:00:00',6.79),('16100','2013-09-13','12:05:00',7.08),('16100','2013-09-13','12:10:00',5.78),('16100','2013-09-13','12:15:00',6.34),('16100','2013-09-13','12:20:00',7.07),('16100','2013-09-13','12:25:00',7.35),('16100','2013-09-13','12:30:00',7.34),('16100','2013-09-13','12:35:00',7.62),('16100','2013-09-13','12:40:00',7.52),('16100','2013-09-13','12:45:00',7.59),('16100','2013-09-13','12:50:00',7.64),('16100','2013-09-13','12:55:00',7.7),('16100','2013-09-13','13:00:00',7.69),('16100','2013-09-13','13:05:00',7.69),('16100','2013-09-13','13:10:00',7.72),('16100','2013-09-13','13:15:00',7.63),('16100','2013-09-13','13:20:00',7.53),('16100','2013-09-13','13:25:00',7.51),('16100','2013-09-13','13:30:00',7.5),('16100','2013-09-13','13:35:00',7.61),('16100','2013-09-13','13:40:00',7.62),('16100','2013-09-13','13:45:00',5.24),('16100','2013-09-13','13:50:00',5.72),('16100','2013-09-13','13:55:00',6.68),('16100','2013-09-13','14:00:00',7.8),('16100','2013-09-13','14:05:00',7.53),('16100','2013-09-13','14:10:00',7.39),('16100','2013-09-13','14:15:00',7.18),('16100','2013-09-13','14:20:00',7.01),('16100','2013-09-13','14:25:00',6.99),('16100','2013-09-13','14:30:00',6.9),('16100','2013-09-13','14:35:00',6.88),('16100','2013-09-13','14:40:00',6.85),('16100','2013-09-13','14:45:00',6.76),('16100','2013-09-13','14:50:00',6.68),('16100','2013-09-13','14:55:00',6.67),('16100','2013-09-13','15:00:00',6.58),('16100','2013-09-13','15:05:00',6.42),('16100','2013-09-13','15:10:00',6.32),('16100','2013-09-13','15:15:00',6.11),('16100','2013-09-13','15:20:00',6.09),('16100','2013-09-13','15:25:00',6.05),('16100','2013-09-13','15:30:00',5.94),('16100','2013-09-13','15:35:00',5.85),('16100','2013-09-13','15:40:00',5.8),('16100','2013-09-13','15:45:00',5.7),('16100','2013-09-13','15:50:00',5.55),('16100','2013-09-13','15:55:00',5.49),('16100','2013-09-13','16:00:00',5.28),('16100','2013-09-13','16:05:00',5.18),('16100','2013-09-13','16:10:00',5.06),('16100','2013-09-13','16:15:00',4.96),('16100','2013-09-13','16:20:00',4.84),('16100','2013-09-13','16:25:00',4.71),('16100','2013-09-13','16:30:00',4.54),('16100','2013-09-13','16:35:00',4.44),('16100','2013-09-13','16:40:00',4.23),('16100','2013-09-13','16:45:00',4),('16100','2013-09-13','16:50:00',3.97),('16100','2013-09-13','16:55:00',3.87),('16100','2013-09-13','17:00:00',3.64),('16100','2013-09-13','17:05:00',3.42),('16100','2013-09-13','17:10:00',3.31),('16100','2013-09-13','17:15:00',3.11),('16100','2013-09-13','17:20:00',2.91),('16100','2013-09-13','17:25:00',2.29),('16100','2013-09-13','17:30:00',2.55),('16100','2013-09-13','17:35:00',2.37),('16100','2013-09-13','17:40:00',2.25),('16100','2013-09-13','17:45:00',2.03),('16100','2013-09-13','17:50:00',1.85),('16100','2013-09-13','17:55:00',1.68),('16100','2013-09-13','18:00:00',1.49),('16100','2013-09-13','18:05:00',1.37),('16100','2013-09-13','18:10:00',1.17),('16100','2013-09-12','08:45:00',1.02),('16100','2013-09-12','08:50:00',1.07),('16100','2013-09-12','08:55:00',1.07),('16100','2013-09-12','09:00:00',1.08),('16100','2013-09-12','09:05:00',1.08),('16100','2013-09-12','09:10:00',1.13),('16100','2013-09-12','09:15:00',1.24),('16100','2013-09-12','09:20:00',1.45),('16100','2013-09-12','09:25:00',1.57),('16100','2013-09-12','09:30:00',1.61),('16100','2013-09-12','09:35:00',1.72),('16100','2013-09-12','09:40:00',1.85),('16100','2013-09-12','09:45:00',1.95),('16100','2013-09-12','09:50:00',1.95),('16100','2013-09-12','09:55:00',1.95),('16100','2013-09-12','10:00:00',2.52),('16100','2013-09-12','10:05:00',6.69),('16100','2013-09-12','10:10:00',3.83),('16100','2013-09-12','10:15:00',3.62),('16100','2013-09-12','10:20:00',3.03),('16100','2013-09-12','10:25:00',5),('16100','2013-09-12','10:30:00',5.26),('16100','2013-09-12','10:35:00',5.99),('16100','2013-09-12','10:40:00',5.96),('16100','2013-09-12','10:45:00',6.02),('16100','2013-09-12','10:50:00',6.1),('16100','2013-09-12','10:55:00',6.16),('16100','2013-09-12','11:00:00',6.28),('16100','2013-09-12','11:05:00',6.37),('16100','2013-09-12','11:10:00',6.42),('16100','2013-09-12','11:15:00',6.53),('16100','2013-09-12','11:20:00',6.59),('16100','2013-09-12','11:25:00',6.66),('16100','2013-09-12','11:30:00',6.71),('16100','2013-09-12','11:35:00',6.77),('16100','2013-09-12','11:40:00',6.8),('16100','2013-09-12','11:45:00',6.89),('16100','2013-09-12','11:50:00',7.02),('16100','2013-09-12','11:55:00',7.04),('16100','2013-09-12','12:00:00',7.13),('16100','2013-09-12','12:05:00',7.09),('16100','2013-09-12','12:10:00',5.23),('16100','2013-09-12','12:15:00',6.76),('16100','2013-09-12','12:20:00',7.39),('16100','2013-09-12','12:25:00',7.48),('16100','2013-09-12','12:30:00',6.2),('16100','2013-09-12','12:35:00',7.7),('16100','2013-09-12','12:40:00',7.61),('16100','2013-09-12','12:45:00',6.31),('16100','2013-09-12','12:50:00',3.61),('16100','2013-09-12','12:55:00',1.51),('16100','2013-09-12','13:00:00',5.47),('16100','2013-09-12','13:05:00',7.79),('16100','2013-09-12','13:10:00',7.62),('16100','2013-09-12','13:15:00',7.51),('16100','2013-09-12','13:20:00',7.44),('16100','2013-09-12','13:25:00',7.38),('16100','2013-09-12','13:30:00',7.34),('16100','2013-09-12','13:35:00',7.33),('16100','2013-09-12','13:40:00',7.3),('16100','2013-09-12','13:45:00',7.24),('16100','2013-09-12','13:50:00',7.18),('16100','2013-09-12','13:55:00',7.19),('16100','2013-09-12','14:00:00',7.19),('16100','2013-09-12','14:05:00',7.09),('16100','2013-09-12','14:10:00',7.16),('16100','2013-09-12','14:15:00',7.19),('16100','2013-09-12','14:20:00',7.14),('16100','2013-09-12','14:25:00',6.97),('16100','2013-09-12','14:30:00',7),('16100','2013-09-12','14:35:00',7.06),('16100','2013-09-12','14:40:00',6.78),('16100','2013-09-12','14:45:00',6.82),('16100','2013-09-12','14:50:00',6.82),('16100','2013-09-12','14:55:00',6.79),('16100','2013-09-12','15:00:00',6.64),('16100','2013-09-12','15:05:00',6.63),('16100','2013-09-12','15:10:00',6.45),('16100','2013-09-12','15:15:00',6.37),('16100','2013-09-12','15:20:00',6.25),('16100','2013-09-12','15:25:00',6.16),('16100','2013-09-12','15:30:00',6.04),('16100','2013-09-12','15:35:00',5.96),('16100','2013-09-12','15:40:00',5.91),('16100','2013-09-12','15:45:00',5.8),('16100','2013-09-12','15:50:00',5.68),('16100','2013-09-12','15:55:00',5.61),('16100','2013-09-12','16:00:00',5.42),('16100','2013-09-12','16:05:00',5.29),('16100','2013-09-12','16:10:00',5.16),('16100','2013-09-12','16:15:00',5.03),('16100','2013-09-12','16:20:00',4.86),('16100','2013-09-12','16:25:00',4.75),('16100','2013-09-12','16:30:00',4.61),('16100','2013-09-12','16:35:00',4.45),('16100','2013-09-12','16:40:00',4.31),('16100','2013-09-12','16:45:00',4.12),('16100','2013-09-12','16:50:00',3.95),('16100','2013-09-12','16:55:00',3.82),('16100','2013-09-12','17:00:00',3.69),('16100','2013-09-12','17:05:00',3.5),('16100','2013-09-12','17:10:00',3.29),('16100','2013-09-12','17:15:00',3.13),('16100','2013-09-12','17:20:00',2.97),('16100','2013-09-12','17:25:00',2.78),('16100','2013-09-12','17:30:00',2.6),('16100','2013-09-12','17:35:00',2.44),('16100','2013-09-12','17:40:00',2.28),('16100','2013-09-12','17:45:00',2.1),('16100','2013-09-12','17:50:00',1.92),('16100','2013-09-12','17:55:00',1.75),('16100','2013-09-12','18:00:00',1.57),('16100','2013-09-12','18:05:00',1.39),('16100','2013-09-12','18:10:00',1.22),('16100','2013-09-12','18:15:00',1.05),('16100','2013-09-11','07:50:00',1.03),('16100','2013-09-11','07:55:00',1.09),('16100','2013-09-11','08:00:00',1.01),('16100','2013-09-11','08:20:00',1.83),('16100','2013-09-11','08:25:00',1.31),('16100','2013-09-11','08:40:00',1.14),('16100','2013-09-11','08:45:00',1.3),('16100','2013-09-11','08:50:00',1.86),('16100','2013-09-11','08:55:00',2.9),('16100','2013-09-11','09:00:00',3.06),('16100','2013-09-11','09:05:00',2.62),('16100','2013-09-11','09:10:00',2.46),('16100','2013-09-11','09:15:00',2.34),('16100','2013-09-11','09:20:00',2.47),('16100','2013-09-11','09:25:00',4.08),('16100','2013-09-11','09:30:00',4.08),('16100','2013-09-11','09:35:00',2.6),('16100','2013-09-11','09:40:00',2.59),('16100','2013-09-11','09:45:00',1.1),('16100','2013-09-11','09:50:00',2.18),('16100','2013-09-11','09:55:00',2.05),('16100','2013-09-11','10:00:00',2.24),('16100','2013-09-11','10:05:00',3.62),('16100','2013-09-11','10:10:00',3.05),('16100','2013-09-11','10:15:00',1.94),('16100','2013-09-11','10:20:00',1.38),('16100','2013-09-11','10:25:00',2.48),('16100','2013-09-11','10:30:00',2.21),('16100','2013-09-11','10:35:00',1.05),('16100','2013-09-11','10:40:00',2.45),('16100','2013-09-11','10:45:00',2.43),('16100','2013-09-11','10:50:00',4.49),('16100','2013-09-11','10:55:00',7.02),('16100','2013-09-11','11:00:00',4.97),('16100','2013-09-11','11:05:00',4.92),('16100','2013-09-11','11:10:00',2.08),('16100','2013-09-11','11:35:00',1.99),('16100','2013-09-11','11:40:00',2.46),('16100','2013-09-11','11:45:00',3.62),('16100','2013-09-11','11:50:00',4.06),('16100','2013-09-11','11:55:00',6.89),('16100','2013-09-11','12:00:00',7.65),('16100','2013-09-11','12:05:00',7.46),('16100','2013-09-11','12:10:00',6.72),('16100','2013-09-11','12:15:00',5),('16100','2013-09-11','12:20:00',5.81),('16100','2013-09-11','12:25:00',7.56),('16100','2013-09-11','12:30:00',4.71),('16100','2013-09-11','12:35:00',3.15),('16100','2013-09-11','12:40:00',6.26),('16100','2013-09-11','12:45:00',4.74),('16100','2013-09-11','12:50:00',5.57),('16100','2013-09-11','12:55:00',6.64),('16100','2013-09-11','13:00:00',8.34),('16100','2013-09-11','13:05:00',6.6),('16100','2013-09-11','13:10:00',8.16),('16100','2013-09-11','13:15:00',6.37),('16100','2013-09-11','13:20:00',3.5),('16100','2013-09-11','13:25:00',5.09),('16100','2013-09-11','13:30:00',6.03),('16100','2013-09-11','13:35:00',5.85),('16100','2013-09-11','13:40:00',1.91),('16100','2013-09-11','13:45:00',7.41),('16100','2013-09-11','13:50:00',7.61),('16100','2013-09-11','13:55:00',3.92),('16100','2013-09-11','14:00:00',4.61),('16100','2013-09-11','14:05:00',5.74),('16100','2013-09-11','14:10:00',7.59),('16100','2013-09-11','14:15:00',7.5),('16100','2013-09-11','14:20:00',7.04),('16100','2013-09-11','14:25:00',6.11),('16100','2013-09-11','14:30:00',5.42),('16100','2013-09-11','14:35:00',7.68),('16100','2013-09-11','14:40:00',7.52),('16100','2013-09-11','14:45:00',7.31),('16100','2013-09-11','14:50:00',7.12),('16100','2013-09-11','14:55:00',5),('16100','2013-09-11','15:00:00',7.11),('16100','2013-09-11','15:05:00',6.8),('16100','2013-09-11','15:10:00',6.69),('16100','2013-09-11','15:15:00',6.56),('16100','2013-09-11','15:20:00',6.45),('16100','2013-09-11','15:25:00',6.32),('16100','2013-09-11','15:30:00',6.28),('16100','2013-09-11','15:35:00',6.14),('16100','2013-09-11','15:40:00',6.06),('16100','2013-09-11','15:45:00',5.97),('16100','2013-09-11','15:50:00',5.99),('16100','2013-09-11','15:55:00',5.44),('16100','2013-09-11','16:00:00',5.75),('16100','2013-09-11','16:05:00',5.71),('16100','2013-09-11','16:10:00',5.48),('16100','2013-09-11','16:15:00',4.28),('16100','2013-09-11','16:20:00',5.27),('16100','2013-09-11','16:25:00',4.99),('16100','2013-09-11','16:30:00',4.9),('16100','2013-09-11','16:35:00',4.92),('16100','2013-09-11','16:40:00',3.4),('16100','2013-09-11','16:45:00',4.58),('16100','2013-09-11','16:50:00',4.3),('16100','2013-09-11','16:55:00',3.44),('16100','2013-09-11','17:00:00',4.02),('16100','2013-09-11','17:05:00',3.13),('16100','2013-09-11','17:10:00',3.7),('16100','2013-09-11','17:15:00',3.38),('16100','2013-09-11','17:20:00',3.17),('16100','2013-09-11','17:25:00',2.97),('16100','2013-09-11','17:30:00',2.8),('16100','2013-09-11','17:35:00',2.58),('16100','2013-09-11','17:40:00',2.39),('16100','2013-09-11','17:45:00',2.21),('16100','2013-09-11','17:50:00',2.01),('16100','2013-09-11','17:55:00',1.29),('16100','2013-09-11','18:00:00',1.04),('16100','2013-09-11','18:05:00',1.54),('16100','2013-09-11','18:10:00',1.43),('16100','2013-09-10','08:05:00',1.72),('16100','2013-09-10','08:25:00',1.02),('16100','2013-09-10','08:30:00',1.02),('16100','2013-09-10','08:50:00',1.24),('16100','2013-09-10','08:55:00',1.19),('16100','2013-09-10','09:00:00',1.14),('16100','2013-09-10','09:05:00',1.13),('16100','2013-09-10','09:10:00',1.31),('16100','2013-09-10','09:15:00',1.57),('16100','2013-09-10','09:20:00',1.65),('16100','2013-09-10','09:25:00',1.41),('16100','2013-09-10','09:30:00',1.29),('16100','2013-09-10','09:45:00',1.05),('16100','2013-09-10','09:50:00',1.55),('16100','2013-09-10','09:55:00',1.82),('16100','2013-09-10','10:00:00',1.9),('16100','2013-09-10','10:05:00',2.62),('16100','2013-09-10','10:10:00',5.27),('16100','2013-09-10','10:15:00',5.29),('16100','2013-09-10','10:20:00',5.36),('16100','2013-09-10','10:25:00',5.57),('16100','2013-09-10','10:30:00',6),('16100','2013-09-10','10:35:00',5.99),('16100','2013-09-10','10:40:00',3.59),('16100','2013-09-10','10:45:00',2.33),('16100','2013-09-10','10:50:00',3.18),('16100','2013-09-10','10:55:00',3.96),('16100','2013-09-10','11:00:00',5.31),('16100','2013-09-10','11:05:00',3.75),('16100','2013-09-10','11:10:00',6.24),('16100','2013-09-10','11:15:00',6.44),('16100','2013-09-10','11:20:00',3.29),('16100','2013-09-10','11:25:00',6),('16100','2013-09-10','11:30:00',4.2),('16100','2013-09-10','11:35:00',7.73),('16100','2013-09-10','11:40:00',5.57),('16100','2013-09-10','11:45:00',7.48),('16100','2013-09-10','11:50:00',7.39),('16100','2013-09-10','11:55:00',7.48),('16100','2013-09-10','12:00:00',7.74),('16100','2013-09-10','12:05:00',6.09),('16100','2013-09-10','12:10:00',5.33),('16100','2013-09-10','12:15:00',7.29),('16100','2013-09-10','12:20:00',4.02),('16100','2013-09-10','12:25:00',6.57),('16100','2013-09-10','12:30:00',7.12),('16100','2013-09-10','12:35:00',5.86),('16100','2013-09-10','12:40:00',6.73),('16100','2013-09-10','12:45:00',5.84),('16100','2013-09-10','12:50:00',8.18),('16100','2013-09-10','12:55:00',8.09),('16100','2013-09-10','13:00:00',6.79),('16100','2013-09-10','13:05:00',5.5),('16100','2013-09-10','13:10:00',3.15),('16100','2013-09-10','13:15:00',5.32),('16100','2013-09-10','13:20:00',7.18),('16100','2013-09-10','13:25:00',2.78),('16100','2013-09-10','13:30:00',7.63),('16100','2013-09-10','13:35:00',5.48),('16100','2013-09-10','13:40:00',3.56),('16100','2013-09-10','13:45:00',2.78),('16100','2013-09-10','13:50:00',3.27),('16100','2013-09-10','13:55:00',7.02),('16100','2013-09-10','14:00:00',4.87),('16100','2013-09-10','14:05:00',6.23),('16100','2013-09-10','14:10:00',7.74),('16100','2013-09-10','14:15:00',7.46),('16100','2013-09-10','14:20:00',7.36),('16100','2013-09-10','14:25:00',5.34),('16100','2013-09-10','14:30:00',6.73),('16100','2013-09-10','14:35:00',6.12),('16100','2013-09-10','14:40:00',7.87),('16100','2013-09-10','14:45:00',4.94),('16100','2013-09-10','14:50:00',5.22),('16100','2013-09-10','14:55:00',6.27),('16100','2013-09-10','15:00:00',6.33),('16100','2013-09-10','15:05:00',2.54),('16100','2013-09-10','15:10:00',4.54),('16100','2013-09-10','15:15:00',3.02),('16100','2013-09-10','15:20:00',2.13),('16100','2013-09-10','15:25:00',1.42),('16100','2013-09-10','15:30:00',2.08),('16100','2013-09-10','15:35:00',2.17),('16100','2013-09-10','15:40:00',2.34),('16100','2013-09-10','15:45:00',2.07),('16100','2013-09-10','15:50:00',2.56),('16100','2013-09-10','15:55:00',1.65),('16100','2013-09-10','16:00:00',2.85),('16100','2013-09-10','16:05:00',5.29),('16100','2013-09-10','16:10:00',4.55),('16100','2013-09-10','16:15:00',5.31),('16100','2013-09-10','16:20:00',4.61),('16100','2013-09-10','16:25:00',4.43),('16100','2013-09-10','16:30:00',1.72),('16100','2013-09-10','16:35:00',4.28),('16100','2013-09-10','16:40:00',3.57),('16100','2013-09-10','16:45:00',4.52),('16100','2013-09-10','16:50:00',4.23),('16100','2013-09-10','16:55:00',4.13),('16100','2013-09-10','17:00:00',3.16),('16100','2013-09-10','17:05:00',3.47),('16100','2013-09-10','17:10:00',3.43),('16100','2013-09-10','17:15:00',3.25),('16100','2013-09-10','17:20:00',3.05),('16100','2013-09-10','17:25:00',3.01),('16100','2013-09-10','17:30:00',2.78),('16100','2013-09-10','17:35:00',1.88),('16100','2013-09-10','17:40:00',2.42),('16100','2013-09-10','17:45:00',2.26),('16100','2013-09-10','17:50:00',1.99),('16100','2013-09-10','17:55:00',1.34),('16100','2013-09-10','18:00:00',1.71),('16100','2013-09-10','18:05:00',1.49),('16100','2013-09-10','18:10:00',1.34),('16100','2013-09-10','18:15:00',1.13),('16100','2013-09-09','08:10:00',1.12),('16100','2013-09-09','08:15:00',1.13),('16100','2013-09-09','08:20:00',1.04),('16100','2013-09-09','08:50:00',1.93),('16100','2013-09-09','08:55:00',2.81),('16100','2013-09-09','09:00:00',3.26),('16100','2013-09-09','09:05:00',4),('16100','2013-09-09','09:10:00',3.72),('16100','2013-09-09','09:15:00',2.05),('16100','2013-09-09','09:20:00',2.84),('16100','2013-09-09','09:25:00',3.28),('16100','2013-09-09','09:30:00',4.37),('16100','2013-09-09','09:35:00',2.52),('16100','2013-09-09','09:40:00',2.09),('16100','2013-09-09','09:45:00',1.95),('16100','2013-09-09','09:50:00',2.01),('16100','2013-09-09','09:55:00',1.62),('16100','2013-09-09','10:00:00',1.25),('16100','2013-09-09','10:05:00',1.06),('16100','2013-09-09','10:15:00',1.18),('16100','2013-09-09','10:20:00',1.55),('16100','2013-09-09','10:25:00',1.56),('16100','2013-09-09','10:30:00',1.42),('16100','2013-09-09','10:35:00',1.73),('16100','2013-09-09','10:40:00',2.32),('16100','2013-09-09','10:45:00',2.57),('16100','2013-09-09','10:50:00',2),('16100','2013-09-09','10:55:00',2.5),('16100','2013-09-09','11:00:00',4.15),('16100','2013-09-09','11:05:00',2.99),('16100','2013-09-09','11:10:00',1.9),('16100','2013-09-09','11:15:00',1.59),('16100','2013-09-09','11:20:00',2.49),('16100','2013-09-09','11:25:00',3.1),('16100','2013-09-09','11:30:00',1.58),('16100','2013-09-09','11:35:00',1.17),('16100','2013-09-09','11:40:00',1.79),('16100','2013-09-09','11:45:00',2.42),('16100','2013-09-09','11:50:00',1.92),('16100','2013-09-09','11:55:00',1.98),('16100','2013-09-09','12:00:00',1.64),('16100','2013-09-09','12:05:00',1.43),('16100','2013-09-09','12:10:00',1.58),('16100','2013-09-09','12:15:00',3.4),('16100','2013-09-09','12:20:00',2.39),('16100','2013-09-09','12:25:00',1.71),('16100','2013-09-09','12:30:00',1.2),('16100','2013-09-09','12:45:00',1.01),('16100','2013-09-09','12:50:00',1.2),('16100','2013-09-09','12:55:00',1.31),('16100','2013-09-09','13:00:00',1.35),('16100','2013-09-09','13:05:00',1.29),('16100','2013-09-09','13:10:00',1.2),('16100','2013-09-09','13:15:00',1.71),('16100','2013-09-09','13:20:00',1.59),('16100','2013-09-09','13:25:00',1.85),('16100','2013-09-09','13:30:00',1.6),('16100','2013-09-09','13:35:00',2.26),('16100','2013-09-09','13:40:00',3.21),('16100','2013-09-09','13:45:00',3.96),('16100','2013-09-09','13:50:00',3.9),('16100','2013-09-09','13:55:00',3.37),('16100','2013-09-09','14:00:00',2.65),('16100','2013-09-09','14:05:00',2.2),('16100','2013-09-09','14:10:00',2.41),('16100','2013-09-09','14:15:00',3.13),('16100','2013-09-09','14:20:00',3.49),('16100','2013-09-09','14:25:00',4.17),('16100','2013-09-09','14:30:00',3.69),('16100','2013-09-09','14:35:00',2.44),('16100','2013-09-09','14:40:00',2.74),('16100','2013-09-09','14:45:00',3.49),('16100','2013-09-09','14:50:00',4.16),('16100','2013-09-09','14:55:00',4.04),('16100','2013-09-09','15:00:00',4.67),('16100','2013-09-09','15:05:00',4.45),('16100','2013-09-09','15:10:00',4.28),('16100','2013-09-09','15:15:00',3.5),('16100','2013-09-09','15:20:00',2.28),('16100','2013-09-09','15:25:00',3.29),('16100','2013-09-09','15:30:00',2.86),('16100','2013-09-09','15:35:00',2.54),('16100','2013-09-09','15:40:00',2.21),('16100','2013-09-09','15:45:00',1.91),('16100','2013-09-09','15:50:00',1.83),('16100','2013-09-09','15:55:00',1.56),('16100','2013-09-09','16:00:00',1.47),('16100','2013-09-09','16:05:00',1.54),('16100','2013-09-09','16:10:00',1.43),('16100','2013-09-09','16:15:00',1.88),('16100','2013-09-09','16:20:00',1.34),('16100','2013-09-09','16:25:00',1.3),('16100','2013-09-09','16:30:00',1.07),('16100','2013-09-09','16:45:00',1.72),('16100','2013-09-09','16:50:00',1.51),('16100','2013-09-09','16:55:00',1.47),('16100','2013-09-09','17:00:00',1.13),('16100','2013-09-09','17:15:00',1.17),('16100','2013-09-09','17:20:00',1.09),('16100','2013-09-09','17:25:00',1.03),('16100','2013-09-09','17:45:00',1.09),('16100','2013-09-09','17:50:00',1.11),('16100','2013-09-08','07:40:00',1.16),('16100','2013-09-08','07:45:00',1.06),('16100','2013-09-08','07:50:00',1.15),('16100','2013-09-08','07:55:00',1.03),('16100','2013-09-08','08:40:00',1.09),('16100','2013-09-08','08:45:00',1.33),('16100','2013-09-08','08:50:00',1.68),('16100','2013-09-08','08:55:00',1.88),('16100','2013-09-08','09:00:00',1.94),('16100','2013-09-08','09:05:00',1.63),('16100','2013-09-08','09:10:00',1.53),('16100','2013-09-08','09:15:00',1.62),('16100','2013-09-08','09:20:00',1.37),('16100','2013-09-08','09:35:00',1.07),('16100','2013-09-08','09:40:00',1.82),('16100','2013-09-08','09:45:00',2.04),('16100','2013-09-08','09:50:00',2.02),('16100','2013-09-08','09:55:00',2.09),('16100','2013-09-08','10:00:00',2.2),('16100','2013-09-08','10:05:00',2.32),('16100','2013-09-08','10:10:00',2.17),('16100','2013-09-08','10:15:00',2.4),('16100','2013-09-08','10:20:00',2.26),('16100','2013-09-08','10:25:00',2.19),('16100','2013-09-08','10:30:00',2.4),('16100','2013-09-08','10:35:00',3.04),('16100','2013-09-08','10:40:00',3.37),('16100','2013-09-08','10:45:00',4.21),('16100','2013-09-08','10:50:00',4.94),('16100','2013-09-08','10:55:00',4.75),('16100','2013-09-08','11:00:00',4.53),('16100','2013-09-08','11:05:00',3.45),('16100','2013-09-08','11:10:00',2.65),('16100','2013-09-08','11:15:00',2.52),('16100','2013-09-08','11:20:00',3.23),('16100','2013-09-08','11:25:00',3.98),('16100','2013-09-08','11:30:00',2.43),('16100','2013-09-08','11:35:00',2.52),('16100','2013-09-08','11:40:00',4.35),('16100','2013-09-08','11:45:00',3.36),('16100','2013-09-08','11:50:00',4.17),('16100','2013-09-08','11:55:00',3.51),('16100','2013-09-08','12:00:00',2.63),('16100','2013-09-08','12:05:00',3.2),('16100','2013-09-08','12:10:00',2),('16100','2013-09-08','12:15:00',2.22),('16100','2013-09-08','12:20:00',1.83),('16100','2013-09-08','12:25:00',1.87),('16100','2013-09-08','12:30:00',1.87),('16100','2013-09-08','12:35:00',1.75),('16100','2013-09-08','12:40:00',2.04),('16100','2013-09-08','12:45:00',1.89),('16100','2013-09-08','12:50:00',2.1),('16100','2013-09-08','12:55:00',2.13),('16100','2013-09-08','13:00:00',2.83),('16100','2013-09-08','13:05:00',4.02),('16100','2013-09-08','13:10:00',6.55),('16100','2013-09-08','13:15:00',6.18),('16100','2013-09-08','13:20:00',5.37),('16100','2013-09-08','13:25:00',4.06),('16100','2013-09-08','13:30:00',6.83),('16100','2013-09-08','13:35:00',7.05),('16100','2013-09-08','13:40:00',6.77),('16100','2013-09-08','13:45:00',7.05),('16100','2013-09-08','13:50:00',7.61),('16100','2013-09-08','13:55:00',5.72),('16100','2013-09-08','14:00:00',7.04),('16100','2013-09-08','14:05:00',4.22),('16100','2013-09-08','14:10:00',5.38),('16100','2013-09-08','14:15:00',5.12),('16100','2013-09-08','14:20:00',6.67),('16100','2013-09-08','14:25:00',3.25),('16100','2013-09-08','14:30:00',4.29),('16100','2013-09-08','14:35:00',5.12),('16100','2013-09-08','14:40:00',5.1),('16100','2013-09-08','14:45:00',5.09),('16100','2013-09-08','14:50:00',4.85),('16100','2013-09-08','14:55:00',4.17),('16100','2013-09-08','15:00:00',4.39),('16100','2013-09-08','15:05:00',6),('16100','2013-09-08','15:10:00',4.86),('16100','2013-09-08','15:15:00',3.86),('16100','2013-09-08','15:20:00',6.33),('16100','2013-09-08','15:25:00',4.93),('16100','2013-09-08','15:30:00',4.58),('16100','2013-09-08','15:35:00',5.64),('16100','2013-09-08','15:40:00',4.31),('16100','2013-09-08','15:45:00',3.43),('16100','2013-09-08','15:50:00',2.18),('16100','2013-09-08','15:55:00',2.62),('16100','2013-09-08','16:00:00',2.16),('16100','2013-09-08','16:05:00',2.32),('16100','2013-09-08','16:10:00',2.82),('16100','2013-09-08','16:15:00',2.24),('16100','2013-09-08','16:20:00',2.12),('16100','2013-09-08','16:25:00',1.74),('16100','2013-09-08','16:30:00',1.66),('16100','2013-09-08','16:35:00',1.69),('16100','2013-09-08','16:40:00',2.15),('16100','2013-09-08','16:45:00',1.95),('16100','2013-09-08','16:50:00',1.64),('16100','2013-09-08','16:55:00',1.14),('16100','2013-09-08','17:00:00',1.25),('16100','2013-09-08','17:05:00',1.06),('16100','2013-09-08','17:10:00',1.14),('16100','2013-09-08','18:05:00',1.38),('16100','2013-09-08','18:10:00',1.7),('16100','2013-09-08','18:15:00',1.06),('16100','2013-09-08','18:25:00',1.15),('16100','2014-04-11','08:30:00',1.01),('16100','2014-04-11','08:35:00',1.29),('16100','2014-04-11','08:40:00',1.89),('16100','2014-04-11','08:45:00',1.66),('16100','2014-04-11','08:50:00',1.09),('16100','2014-04-11','08:55:00',1.03),('16100','2014-04-11','09:00:00',1.23),('16100','2014-04-11','09:05:00',2.07),('16100','2014-04-11','09:10:00',3.33),('16100','2014-04-11','09:15:00',2.68),('16100','2014-04-11','09:20:00',2.46),('16100','2014-04-11','09:25:00',2.77),('16100','2014-04-11','09:30:00',3.47),('16100','2014-04-11','09:35:00',2.84),('16100','2014-04-11','09:40:00',2.61),('16100','2014-04-11','09:45:00',2.59),('16100','2014-04-11','09:50:00',2.79),('16100','2014-04-11','09:55:00',2.76),('16100','2014-04-11','10:00:00',2.86),('16100','2014-04-11','10:05:00',3.08),('16100','2014-04-11','10:10:00',3.13),('16100','2014-04-11','10:15:00',3.15),('16100','2014-04-11','10:20:00',3.21),('16100','2014-04-11','10:25:00',3.84),('16100','2014-04-11','10:30:00',3.95),('16100','2014-04-11','10:35:00',3.17),('16100','2014-04-11','10:40:00',2.84),('16100','2014-04-11','10:45:00',3.31),('16100','2014-04-11','10:50:00',3.52),('16100','2014-04-11','10:55:00',6.35),('16100','2014-04-11','11:00:00',4.95),('16100','2014-04-11','11:05:00',5.86),('16100','2014-04-11','11:10:00',5.07),('16100','2014-04-11','11:15:00',4.7),('16100','2014-04-11','11:20:00',5.83),('16100','2014-04-11','11:25:00',5.31),('16100','2014-04-11','11:30:00',6.36),('16100','2014-04-11','11:35:00',5.74),('16100','2014-04-11','11:40:00',6.76),('16100','2014-04-11','11:45:00',7.04),('16100','2014-04-11','11:50:00',6.69),('16100','2014-04-11','11:55:00',6.98),('16100','2014-04-11','12:00:00',3.88),('16100','2014-04-11','12:05:00',2.46),('16100','2014-04-11','12:10:00',2.64),('16100','2014-04-11','12:15:00',5.11),('16100','2014-04-11','12:20:00',5.69),('16100','2014-04-11','12:25:00',3.12),('16100','2014-04-11','12:30:00',2.04),('16100','2014-04-11','12:35:00',1.99),('16100','2014-04-11','12:40:00',2.22),('16100','2014-04-11','12:45:00',2.38),('16100','2014-04-11','12:50:00',2.41),('16100','2014-04-11','12:55:00',2.46),('16100','2014-04-11','13:00:00',3.78),('16100','2014-04-11','13:05:00',4.28),('16100','2014-04-11','13:10:00',6.74),('16100','2014-04-11','13:15:00',6.68),('16100','2014-04-11','13:20:00',3.62),('16100','2014-04-11','13:25:00',3.08),('16100','2014-04-11','13:30:00',7.58),('16100','2014-04-11','13:35:00',4.86),('16100','2014-04-11','13:40:00',6.83),('16100','2014-04-11','13:45:00',6.5),('16100','2014-04-11','13:50:00',7.94),('16100','2014-04-11','13:55:00',6.84),('16100','2014-04-11','14:00:00',7.56),('16100','2014-04-11','14:05:00',7.48),('16100','2014-04-11','14:10:00',7.61),('16100','2014-04-11','14:15:00',3.93),('16100','2014-04-11','14:20:00',3.57),('16100','2014-04-11','14:25:00',6.05),('16100','2014-04-11','14:30:00',3.24),('16100','2014-04-11','14:35:00',4.09),('16100','2014-04-11','14:40:00',5.47),('16100','2014-04-11','14:45:00',6.42),('16100','2014-04-11','14:50:00',5.98),('16100','2014-04-11','14:55:00',6.74),('16100','2014-04-11','15:00:00',6.23),('16100','2014-04-11','15:05:00',6.28),('16100','2014-04-11','15:10:00',5.77),('16100','2014-04-11','15:15:00',5.69),('16100','2014-04-11','15:20:00',5.01),('16100','2014-04-11','15:25:00',4.88),('16100','2014-04-11','15:30:00',5.32),('16100','2014-04-11','15:35:00',5.56),('16100','2014-04-11','15:40:00',5.82),('16100','2014-04-11','15:45:00',6.11),('16100','2014-04-11','15:50:00',5.6),('16100','2014-04-11','15:55:00',5.89),('16100','2014-04-11','16:00:00',5.95),('16100','2014-04-11','16:05:00',5.83),('16100','2014-04-11','16:10:00',5.33),('16100','2014-04-11','16:15:00',4.63),('16100','2014-04-11','16:20:00',5.13),('16100','2014-04-11','16:25:00',4.39),('16100','2014-04-11','16:30:00',4.15),('16100','2014-04-11','16:35:00',3.05),('16100','2014-04-11','16:40:00',2.49),('16100','2014-04-11','16:45:00',2.33),('16100','2014-04-11','16:50:00',2.62),('16100','2014-04-11','16:55:00',3.75),('16100','2014-04-11','17:00:00',4.09),('16100','2014-04-11','17:05:00',3.88),('16100','2014-04-11','17:10:00',3.56),('16100','2014-04-11','17:15:00',2.98),('16100','2014-04-11','17:20:00',3.34),('16100','2014-04-11','17:25:00',3.34),('16100','2014-04-11','17:30:00',3.22),('16100','2014-04-11','17:35:00',2.38),('16100','2014-04-11','17:40:00',2.72),('16100','2014-04-11','17:45:00',3.22),('16100','2014-04-11','17:50:00',2.22),('16100','2014-04-11','17:55:00',1.45),('16100','2014-04-11','18:00:00',1.26),('16100','2014-04-11','18:05:00',1.09),('16100','2014-04-11','18:10:00',1.11),('16100','2014-04-11','18:15:00',1.04),('16100','2014-04-11','18:25:00',1.07),('16100','2014-04-11','18:30:00',1.1),('16100','2013-09-07','08:35:00',1.04),('16100','2013-09-07','08:40:00',1.04),('16100','2013-09-07','08:45:00',1.08),('16100','2013-09-07','08:50:00',1.25),('16100','2013-09-07','08:55:00',1.38),('16100','2013-09-07','09:00:00',1.64),('16100','2013-09-07','09:05:00',1.58),('16100','2013-09-07','09:10:00',2.39),('16100','2013-09-07','09:15:00',3.1),('16100','2013-09-07','09:20:00',3.34),('16100','2013-09-07','09:25:00',3.46),('16100','2013-09-07','09:30:00',3.61),('16100','2013-09-07','09:35:00',3.75),('16100','2013-09-07','09:40:00',3.92),('16100','2013-09-07','09:45:00',4.06),('16100','2013-09-07','09:50:00',4.2),('16100','2013-09-07','09:55:00',4.33),('16100','2013-09-07','10:00:00',4.42),('16100','2013-09-07','10:05:00',4.52),('16100','2013-09-07','10:10:00',4.61),('16100','2013-09-07','10:15:00',4.78),('16100','2013-09-07','10:20:00',4.94),('16100','2013-09-07','10:25:00',5.01),('16100','2013-09-07','10:30:00',5.16),('16100','2013-09-07','10:35:00',5.39),('16100','2013-09-07','10:40:00',5.49),('16100','2013-09-07','10:45:00',5.54),('16100','2013-09-07','10:50:00',5.62),('16100','2013-09-07','10:55:00',5.55),('16100','2013-09-07','11:00:00',5.63),('16100','2013-09-07','11:05:00',5.76),('16100','2013-09-07','11:10:00',5.86),('16100','2013-09-07','11:15:00',5.91),('16100','2013-09-07','11:20:00',5.78),('16100','2013-09-07','11:25:00',5.97),('16100','2013-09-07','11:30:00',6.13),('16100','2013-09-07','11:35:00',6.17),('16100','2013-09-07','11:40:00',6.25),('16100','2013-09-07','11:45:00',6.18),('16100','2013-09-07','11:50:00',6.16),('16100','2013-09-07','11:55:00',6.11),('16100','2013-09-07','12:00:00',6.12),('16100','2013-09-07','12:05:00',6.12),('16100','2013-09-07','12:10:00',6.27),('16100','2013-09-07','12:15:00',6.56),('16100','2013-09-07','12:20:00',6.51),('16100','2013-09-07','12:25:00',6.56),('16100','2013-09-07','12:30:00',6.8),('16100','2013-09-07','12:35:00',6.79),('16100','2013-09-07','12:40:00',6.66),('16100','2013-09-07','12:45:00',6.81),('16100','2013-09-07','12:50:00',6.78),('16100','2013-09-07','12:55:00',6.69),('16100','2013-09-07','13:00:00',6.53),('16100','2013-09-07','13:05:00',6.83),('16100','2013-09-07','13:10:00',6.49),('16100','2013-09-07','13:15:00',6.36),('16100','2013-09-07','13:20:00',6.53),('16100','2013-09-07','13:25:00',5.85),('16100','2013-09-07','13:30:00',6.05),('16100','2013-09-07','13:35:00',5.32),('16100','2013-09-07','13:40:00',3.87),('16100','2013-09-07','13:45:00',4.31),('16100','2013-09-07','13:50:00',4.97),('16100','2013-09-07','13:55:00',6.73),('16100','2013-09-07','14:00:00',5.62),('16100','2013-09-07','14:05:00',5.43),('16100','2013-09-07','14:10:00',5.41),('16100','2013-09-07','14:15:00',5.25),('16100','2013-09-07','14:20:00',6.18),('16100','2013-09-07','14:25:00',5.87),('16100','2013-09-07','14:30:00',6.81),('16100','2013-09-07','14:35:00',6.69),('16100','2013-09-07','14:40:00',6.59),('16100','2013-09-07','14:45:00',6.91),('16100','2013-09-07','14:50:00',6.11),('16100','2013-09-07','14:55:00',6.4),('16100','2013-09-07','15:00:00',6.41),('16100','2013-09-07','15:05:00',3.96),('16100','2013-09-07','15:10:00',4.23),('16100','2013-09-07','15:15:00',5.69),('16100','2013-09-07','15:20:00',6.33),('16100','2013-09-07','15:25:00',6.23),('16100','2013-09-07','15:30:00',5.98),('16100','2013-09-07','15:35:00',5.35),('16100','2013-09-07','15:40:00',5.58),('16100','2013-09-07','15:45:00',5.69),('16100','2013-09-07','15:50:00',4.66),('16100','2013-09-07','15:55:00',4.53),('16100','2013-09-07','16:00:00',4.41),('16100','2013-09-07','16:05:00',4),('16100','2013-09-07','16:10:00',4.47),('16100','2013-09-07','16:15:00',4.43),('16100','2013-09-07','16:20:00',4.44),('16100','2013-09-07','16:25:00',3.46),('16100','2013-09-07','16:30:00',4.21),('16100','2013-09-07','16:35:00',3.48),('16100','2013-09-07','16:40:00',2.81),('16100','2013-09-07','16:45:00',2.75),('16100','2013-09-07','16:50:00',1.53),('16100','2013-09-07','16:55:00',2.15),('16100','2013-09-07','17:00:00',3.69),('16100','2013-09-07','17:05:00',3.63),('16100','2013-09-07','17:10:00',3.29),('16100','2013-09-07','17:15:00',3.03),('16100','2013-09-07','17:20:00',2.73),('16100','2013-09-07','17:25:00',2.59),('16100','2013-09-07','17:30:00',1.2),('16100','2013-09-07','17:35:00',1.43),('16100','2013-09-07','17:40:00',1.93),('16100','2013-09-07','17:45:00',1.9),('16100','2013-09-07','17:50:00',1.75),('16100','2013-09-07','17:55:00',1.62),('16100','2013-09-07','18:00:00',1.38),('16100','2013-09-07','18:05:00',1.18),('16100','2013-09-07','18:10:00',1.03),('16100','2013-09-06','08:05:00',1.03),('16100','2013-09-06','08:10:00',1.19),('16100','2013-09-06','08:15:00',1.36),('16100','2013-09-06','08:20:00',1.53),('16100','2013-09-06','08:25:00',1.68),('16100','2013-09-06','08:30:00',1.85),('16100','2013-09-06','08:35:00',2),('16100','2013-09-06','08:40:00',2.18),('16100','2013-09-06','08:45:00',2.36),('16100','2013-09-06','08:50:00',2.52),('16100','2013-09-06','08:55:00',2.71),('16100','2013-09-06','09:00:00',2.88),('16100','2013-09-06','09:05:00',3.03),('16100','2013-09-06','09:10:00',3.2),('16100','2013-09-06','09:15:00',3.36),('16100','2013-09-06','09:20:00',3.51),('16100','2013-09-06','09:25:00',3.62),('16100','2013-09-06','09:30:00',3.76),('16100','2013-09-06','09:35:00',3.92),('16100','2013-09-06','09:40:00',4.05),('16100','2013-09-06','09:45:00',4.22),('16100','2013-09-06','09:50:00',4.33),('16100','2013-09-06','09:55:00',4.46),('16100','2013-09-06','10:00:00',4.56),('16100','2013-09-06','10:05:00',4.69),('16100','2013-09-06','10:10:00',4.77),('16100','2013-09-06','10:15:00',4.88),('16100','2013-09-06','10:20:00',5.02),('16100','2013-09-06','10:25:00',5.18),('16100','2013-09-06','10:30:00',5.3),('16100','2013-09-06','10:35:00',5.39),('16100','2013-09-06','10:40:00',5.46),('16100','2013-09-06','10:45:00',5.55),('16100','2013-09-06','10:50:00',5.63),('16100','2013-09-06','10:55:00',5.74),('16100','2013-09-06','11:00:00',5.78),('16100','2013-09-06','11:05:00',5.82),('16100','2013-09-06','11:10:00',5.93),('16100','2013-09-06','11:15:00',6.05),('16100','2013-09-06','11:20:00',6.06),('16100','2013-09-06','11:25:00',6.12),('16100','2013-09-06','11:30:00',6.23),('16100','2013-09-06','11:35:00',6.33),('16100','2013-09-06','11:40:00',6.42),('16100','2013-09-06','11:45:00',6.51),('16100','2013-09-06','11:50:00',6.51),('16100','2013-09-06','11:55:00',6.52),('16100','2013-09-06','12:00:00',6.67),('16100','2013-09-06','12:05:00',6.76),('16100','2013-09-06','12:10:00',6.86),('16100','2013-09-06','12:15:00',6.9),('16100','2013-09-06','12:20:00',6.84),('16100','2013-09-06','12:25:00',6.85),('16100','2013-09-06','12:30:00',6.83),('16100','2013-09-06','12:35:00',6.83),('16100','2013-09-06','12:40:00',6.59),('16100','2013-09-06','12:45:00',6.36),('16100','2013-09-06','12:50:00',6.99),('16100','2013-09-06','12:55:00',6.98),('16100','2013-09-06','13:00:00',6.94),('16100','2013-09-06','13:05:00',7.04),('16100','2013-09-06','13:10:00',6.96),('16100','2013-09-06','13:15:00',6.96),('16100','2013-09-06','13:20:00',6.99),('16100','2013-09-06','13:25:00',6.8),('16100','2013-09-06','13:30:00',6.81),('16100','2013-09-06','13:35:00',6.98),('16100','2013-09-06','13:40:00',6.94),('16100','2013-09-06','13:45:00',7),('16100','2013-09-06','13:50:00',7.02),('16100','2013-09-06','13:55:00',6.98),('16100','2013-09-06','14:00:00',6.94),('16100','2013-09-06','14:05:00',6.86),('16100','2013-09-06','14:10:00',6.84),('16100','2013-09-06','14:15:00',6.86),('16100','2013-09-06','14:20:00',6.83),('16100','2013-09-06','14:25:00',6.7),('16100','2013-09-06','14:30:00',6.69),('16100','2013-09-06','14:35:00',6.67),('16100','2013-09-06','14:40:00',6.65),('16100','2013-09-06','14:45:00',6.53),('16100','2013-09-06','14:50:00',6.47),('16100','2013-09-06','14:55:00',6.49),('16100','2013-09-06','15:00:00',6.39),('16100','2013-09-06','15:05:00',6.3),('16100','2013-09-06','15:10:00',6.23),('16100','2013-09-06','15:15:00',6.13),('16100','2013-09-06','15:20:00',6.03),('16100','2013-09-06','15:25:00',5.93),('16100','2013-09-06','15:30:00',5.81),('16100','2013-09-06','15:35:00',5.74),('16100','2013-09-06','15:40:00',5.65),('16100','2013-09-06','15:45:00',5.56),('16100','2013-09-06','15:50:00',5.45),('16100','2013-09-06','15:55:00',5.34),('16100','2013-09-06','16:00:00',5.22),('16100','2013-09-06','16:05:00',5.07),('16100','2013-09-06','16:10:00',4.94),('16100','2013-09-06','16:15:00',4.75),('16100','2013-09-06','16:20:00',4.62),('16100','2013-09-06','16:25:00',4.54),('16100','2013-09-06','16:30:00',4.4),('16100','2013-09-06','16:35:00',4.26),('16100','2013-09-06','16:40:00',4.13),('16100','2013-09-06','16:45:00',3.97),('16100','2013-09-06','16:50:00',3.83),('16100','2013-09-06','16:55:00',3.68),('16100','2013-09-06','17:00:00',3.52),('16100','2013-09-06','17:05:00',3.41),('16100','2013-09-06','17:10:00',3.22),('16100','2013-09-06','17:15:00',3.03),('16100','2013-09-06','17:20:00',2.86),('16100','2013-09-06','17:25:00',2.65),('16100','2013-09-06','17:30:00',2.5),('16100','2013-09-06','17:35:00',2.37),('16100','2013-09-06','17:40:00',2.22),('16100','2013-09-06','17:45:00',2.07),('16100','2013-09-06','17:50:00',1.9),('16100','2013-09-06','17:55:00',1.75),('16100','2013-09-06','18:00:00',1.57),('16100','2013-09-06','18:05:00',1.41),('16100','2013-09-06','18:10:00',1.26),('16100','2013-09-06','18:15:00',1.11),('16100','2013-09-05','08:05:00',1.04),('16100','2013-09-05','08:10:00',1.2),('16100','2013-09-05','08:15:00',1.36),('16100','2013-09-05','08:20:00',1.54),('16100','2013-09-05','08:25:00',1.71),('16100','2013-09-05','08:30:00',1.9),('16100','2013-09-05','08:35:00',2.06),('16100','2013-09-05','08:40:00',2.24),('16100','2013-09-05','08:45:00',2.4),('16100','2013-09-05','08:50:00',2.57),('16100','2013-09-05','08:55:00',2.76),('16100','2013-09-05','09:00:00',2.89),('16100','2013-09-05','09:05:00',3.09),('16100','2013-09-05','09:10:00',3.25),('16100','2013-09-05','09:15:00',3.46),('16100','2013-09-05','09:20:00',3.6),('16100','2013-09-05','09:25:00',3.72),('16100','2013-09-05','09:30:00',3.85),('16100','2013-09-05','09:35:00',3.98),('16100','2013-09-05','09:40:00',4.14),('16100','2013-09-05','09:45:00',4.32),('16100','2013-09-05','09:50:00',4.43),('16100','2013-09-05','09:55:00',4.51),('16100','2013-09-05','10:00:00',4.66),('16100','2013-09-05','10:05:00',4.81),('16100','2013-09-05','10:10:00',4.92),('16100','2013-09-05','10:15:00',4.99),('16100','2013-09-05','10:20:00',5.14),('16100','2013-09-05','10:25:00',5.27),('16100','2013-09-05','10:30:00',5.43),('16100','2013-09-05','10:35:00',5.54),('16100','2013-09-05','10:40:00',5.63),('16100','2013-09-05','10:45:00',5.74),('16100','2013-09-05','10:50:00',5.85),('16100','2013-09-05','10:55:00',5.94),('16100','2013-09-05','11:00:00',6),('16100','2013-09-05','11:05:00',6.07),('16100','2013-09-05','11:10:00',6.08),('16100','2013-09-05','11:15:00',6.23),('16100','2013-09-05','11:20:00',6.3),('16100','2013-09-05','11:25:00',6.38),('16100','2013-09-05','11:30:00',6.44),('16100','2013-09-05','11:35:00',6.5),('16100','2013-09-05','11:40:00',6.59),('16100','2013-09-05','11:45:00',6.68),('16100','2013-09-05','11:50:00',6.7),('16100','2013-09-05','11:55:00',6.74),('16100','2013-09-05','12:00:00',6.76),('16100','2013-09-05','12:05:00',6.77),('16100','2013-09-05','12:10:00',6.73),('16100','2013-09-05','12:15:00',6.8),('16100','2013-09-05','12:20:00',6.89),('16100','2013-09-05','12:25:00',6.92),('16100','2013-09-05','12:30:00',6.99),('16100','2013-09-05','12:35:00',6.99),('16100','2013-09-05','12:40:00',7.04),('16100','2013-09-05','12:45:00',7.04),('16100','2013-09-05','12:50:00',7.06),('16100','2013-09-05','12:55:00',7.07),('16100','2013-09-05','13:00:00',7.03),('16100','2013-09-05','13:05:00',7.05),('16100','2013-09-05','13:10:00',7.03),('16100','2013-09-05','13:15:00',6.97),('16100','2013-09-05','13:20:00',6.97),('16100','2013-09-05','13:25:00',6.99),('16100','2013-09-05','13:30:00',6.99),('16100','2013-09-05','13:35:00',6.96),('16100','2013-09-05','13:40:00',6.89),('16100','2013-09-05','13:45:00',6.86),('16100','2013-09-05','13:50:00',6.87),('16100','2013-09-05','13:55:00',6.86),('16100','2013-09-05','14:00:00',6.78),('16100','2013-09-05','14:05:00',6.75),('16100','2013-09-05','14:10:00',6.62),('16100','2013-09-05','14:15:00',6.62),('16100','2013-09-05','14:20:00',6.56),('16100','2013-09-05','14:25:00',6.44),('16100','2013-09-05','14:30:00',6.4),('16100','2013-09-05','14:35:00',6.35),('16100','2013-09-05','14:40:00',6.49),('16100','2013-09-05','14:45:00',6.4),('16100','2013-09-05','14:50:00',6.22),('16100','2013-09-05','14:55:00',6.24),('16100','2013-09-05','15:00:00',6.27),('16100','2013-09-05','15:05:00',6.17),('16100','2013-09-05','15:10:00',6.11),('16100','2013-09-05','15:15:00',6.01),('16100','2013-09-05','15:20:00',5.91),('16100','2013-09-05','15:25:00',5.84),('16100','2013-09-05','15:30:00',5.72),('16100','2013-09-05','15:35:00',5.6),('16100','2013-09-05','15:40:00',5.58),('16100','2013-09-05','15:45:00',5.49),('16100','2013-09-05','15:50:00',5.4),('16100','2013-09-05','15:55:00',5.34),('16100','2013-09-05','16:00:00',5.24),('16100','2013-09-05','16:05:00',5.12),('16100','2013-09-05','16:10:00',5),('16100','2013-09-05','16:15:00',4.85),('16100','2013-09-05','16:20:00',4.71),('16100','2013-09-05','16:25:00',4.64),('16100','2013-09-05','16:30:00',4.49),('16100','2013-09-05','16:35:00',4.33),('16100','2013-09-05','16:40:00',4.22),('16100','2013-09-05','16:45:00',4.06),('16100','2013-09-05','16:50:00',3.8),('16100','2013-09-05','16:55:00',3.64),('16100','2013-09-05','17:00:00',3.54),('16100','2013-09-05','17:05:00',3.36),('16100','2013-09-05','17:10:00',3.18),('16100','2013-09-05','17:15:00',2.99),('16100','2013-09-05','17:20:00',2.84),('16100','2013-09-05','17:25:00',2.67),('16100','2013-09-05','17:30:00',2.56),('16100','2013-09-05','17:35:00',2.4),('16100','2013-09-05','17:40:00',2.17),('16100','2013-09-05','17:45:00',2.02),('16100','2013-09-05','17:50:00',1.88),('16100','2013-09-05','17:55:00',1.7),('16100','2013-09-05','18:00:00',1.5),('16100','2013-09-05','18:05:00',1.36),('16100','2013-09-05','18:10:00',1.23),('16100','2013-09-05','18:15:00',1.11),('16100','2013-09-04','08:05:00',1.17),('16100','2013-09-04','08:10:00',1.34),('16100','2013-09-04','08:15:00',1.53),('16100','2013-09-04','08:20:00',1.71),('16100','2013-09-04','08:25:00',1.9),('16100','2013-09-04','08:30:00',2.08),('16100','2013-09-04','08:35:00',2.26),('16100','2013-09-04','08:40:00',2.46),('16100','2013-09-04','08:45:00',2.63),('16100','2013-09-04','08:50:00',2.8),('16100','2013-09-04','08:55:00',3),('16100','2013-09-04','09:00:00',3.14),('16100','2013-09-04','09:05:00',3.29),('16100','2013-09-04','09:10:00',3.46),('16100','2013-09-04','09:15:00',3.65),('16100','2013-09-04','09:20:00',3.8),('16100','2013-09-04','09:25:00',3.94),('16100','2013-09-04','09:30:00',4.09),('16100','2013-09-04','09:35:00',4.22),('16100','2013-09-04','09:40:00',4.33),('16100','2013-09-04','09:45:00',4.49),('16100','2013-09-04','09:50:00',4.61),('16100','2013-09-04','09:55:00',4.76),('16100','2013-09-04','10:00:00',4.9),('16100','2013-09-04','10:05:00',5.02),('16100','2013-09-04','10:10:00',5.11),('16100','2013-09-04','10:15:00',5.19),('16100','2013-09-04','10:20:00',5.34),('16100','2013-09-04','10:25:00',5.45),('16100','2013-09-04','10:30:00',5.58),('16100','2013-09-04','10:35:00',5.64),('16100','2013-09-04','10:40:00',5.72),('16100','2013-09-04','10:45:00',5.86),('16100','2013-09-04','10:50:00',5.94),('16100','2013-09-04','10:55:00',6.02),('16100','2013-09-04','11:00:00',6.08),('16100','2013-09-04','11:05:00',6.16),('16100','2013-09-04','11:10:00',6.22),('16100','2013-09-04','11:15:00',6.34),('16100','2013-09-04','11:20:00',6.44),('16100','2013-09-04','11:25:00',6.49),('16100','2013-09-04','11:30:00',6.57),('16100','2013-09-04','11:35:00',6.59),('16100','2013-09-04','11:40:00',6.6),('16100','2013-09-04','11:45:00',6.64),('16100','2013-09-04','11:50:00',6.77),('16100','2013-09-04','11:55:00',6.76),('16100','2013-09-04','12:00:00',6.83),('16100','2013-09-04','12:05:00',6.89),('16100','2013-09-04','12:10:00',6.98),('16100','2013-09-04','12:15:00',7),('16100','2013-09-04','12:20:00',7.01),('16100','2013-09-04','12:25:00',7.08),('16100','2013-09-04','12:30:00',7.14),('16100','2013-09-04','12:35:00',7.12),('16100','2013-09-04','12:40:00',7.17),('16100','2013-09-04','12:45:00',7.2),('16100','2013-09-04','12:50:00',7.16),('16100','2013-09-04','12:55:00',7.13),('16100','2013-09-04','13:00:00',7.08),('16100','2013-09-04','13:05:00',7.16),('16100','2013-09-04','13:10:00',7.21),('16100','2013-09-04','13:15:00',7.2),('16100','2013-09-04','13:20:00',7.17),('16100','2013-09-04','13:25:00',7.17),('16100','2013-09-04','13:30:00',7.09),('16100','2013-09-04','13:35:00',7.08),('16100','2013-09-04','13:40:00',7.15),('16100','2013-09-04','13:45:00',7.13),('16100','2013-09-04','13:50:00',7.09),('16100','2013-09-04','13:55:00',7.04),('16100','2013-09-04','14:00:00',6.96),('16100','2013-09-04','14:05:00',6.87),('16100','2013-09-04','14:10:00',6.8),('16100','2013-09-04','14:15:00',6.84),('16100','2013-09-04','14:20:00',6.81),('16100','2013-09-04','14:25:00',6.74),('16100','2013-09-04','14:30:00',6.69),('16100','2013-09-04','14:35:00',6.68),('16100','2013-09-04','14:40:00',6.67),('16100','2013-09-04','14:45:00',6.65),('16100','2013-09-04','14:50:00',6.61),('16100','2013-09-04','14:55:00',6.56),('16100','2013-09-04','15:00:00',6.49),('16100','2013-09-04','15:05:00',6.4),('16100','2013-09-04','15:10:00',6.33),('16100','2013-09-04','15:15:00',6.23),('16100','2013-09-04','15:20:00',6.03),('16100','2013-09-04','15:25:00',6.02),('16100','2013-09-04','15:30:00',5.92),('16100','2013-09-04','15:35:00',5.84),('16100','2013-09-04','15:40:00',5.74),('16100','2013-09-04','15:45:00',5.62),('16100','2013-09-04','15:50:00',5.53),('16100','2013-09-04','15:55:00',5.46),('16100','2013-09-04','16:00:00',5.36),('16100','2013-09-04','16:05:00',5.26),('16100','2013-09-04','16:10:00',5.09),('16100','2013-09-04','16:15:00',5.03),('16100','2013-09-04','16:20:00',4.91),('16100','2013-09-04','16:25:00',4.8),('16100','2013-09-04','16:30:00',4.71),('16100','2013-09-04','16:35:00',4.6),('16100','2013-09-04','16:40:00',4.51),('16100','2013-09-04','16:45:00',4.44),('16100','2013-09-04','16:50:00',4.27),('16100','2013-09-04','16:55:00',3.78),('16100','2013-09-04','17:00:00',2.69),('16100','2013-09-04','17:05:00',2.37),('16100','2013-09-04','17:10:00',2.45),('16100','2013-09-04','17:15:00',2.35),('16100','2013-09-04','17:20:00',2.24),('16100','2013-09-04','17:25:00',2.53),('16100','2013-09-04','17:30:00',2.25),('16100','2013-09-04','17:35:00',2.53),('16100','2013-09-04','17:40:00',2.68),('16100','2013-09-04','17:45:00',2.65),('16100','2013-09-04','17:50:00',2.28),('16100','2013-09-04','17:55:00',2.24),('16100','2013-09-04','18:00:00',1.72),('16100','2013-09-04','18:05:00',1.55),('16100','2013-09-04','18:10:00',1.36),('16100','2013-09-04','18:15:00',1.28),('16100','2013-09-04','18:20:00',1.11),('16100','2013-09-04','18:25:00',1.01),('16100','2013-09-03','08:05:00',1.17),('16100','2013-09-03','08:10:00',1.36),('16100','2013-09-03','08:15:00',1.54),('16100','2013-09-03','08:20:00',1.72),('16100','2013-09-03','08:25:00',1.91),('16100','2013-09-03','08:30:00',2.08),('16100','2013-09-03','08:35:00',2.26),('16100','2013-09-03','08:40:00',2.46),('16100','2013-09-03','08:45:00',2.62),('16100','2013-09-03','08:50:00',2.79),('16100','2013-09-03','08:55:00',2.99),('16100','2013-09-03','09:00:00',3.15),('16100','2013-09-03','09:05:00',3.31),('16100','2013-09-03','09:10:00',3.47),('16100','2013-09-03','09:15:00',3.64),('16100','2013-09-03','09:20:00',3.79),('16100','2013-09-03','09:25:00',3.92),('16100','2013-09-03','09:30:00',4.07),('16100','2013-09-03','09:35:00',4.22),('16100','2013-09-03','09:40:00',4.35),('16100','2013-09-03','09:45:00',4.52),('16100','2013-09-03','09:50:00',4.66),('16100','2013-09-03','09:55:00',4.78),('16100','2013-09-03','10:00:00',4.89),('16100','2013-09-03','10:05:00',5.01),('16100','2013-09-03','10:10:00',5.12),('16100','2013-09-03','10:15:00',5.21),('16100','2013-09-03','10:20:00',5.34),('16100','2013-09-03','10:25:00',5.44),('16100','2013-09-03','10:30:00',5.59),('16100','2013-09-03','10:35:00',5.7),('16100','2013-09-03','10:40:00',5.79),('16100','2013-09-03','10:45:00',5.91),('16100','2013-09-03','10:50:00',6.02),('16100','2013-09-03','10:55:00',6.12),('16100','2013-09-03','11:00:00',6.27),('16100','2013-09-03','11:05:00',6.37),('16100','2013-09-03','11:10:00',6.44),('16100','2013-09-03','11:15:00',6.55),('16100','2013-09-03','11:20:00',6.62),('16100','2013-09-03','11:25:00',6.69),('16100','2013-09-03','11:30:00',6.76),('16100','2013-09-03','11:35:00',6.84),('16100','2013-09-03','11:40:00',6.85),('16100','2013-09-03','11:45:00',6.91),('16100','2013-09-03','11:50:00',6.97),('16100','2013-09-03','11:55:00',7.05),('16100','2013-09-03','12:00:00',7.12),('16100','2013-09-03','12:05:00',7.16),('16100','2013-09-03','12:10:00',7.19),('16100','2013-09-03','12:15:00',7.26),('16100','2013-09-03','12:20:00',7.31),('16100','2013-09-03','12:25:00',7.32),('16100','2013-09-03','12:30:00',7.36),('16100','2013-09-03','12:35:00',7.34),('16100','2013-09-03','12:40:00',7.33),('16100','2013-09-03','12:45:00',7.31),('16100','2013-09-03','12:50:00',7.33),('16100','2013-09-03','12:55:00',7.35),('16100','2013-09-03','13:00:00',7.39),('16100','2013-09-03','13:05:00',7.4),('16100','2013-09-03','13:10:00',7.41),('16100','2013-09-03','13:15:00',7.38),('16100','2013-09-03','13:20:00',7.35),('16100','2013-09-03','13:25:00',7.38),('16100','2013-09-03','13:30:00',7.34),('16100','2013-09-03','13:35:00',7.27),('16100','2013-09-03','13:40:00',7.27),('16100','2013-09-03','13:45:00',7.25),('16100','2013-09-03','13:50:00',7.24),('16100','2013-09-03','13:55:00',7.26),('16100','2013-09-03','14:00:00',7.21),('16100','2013-09-03','14:05:00',7.14),('16100','2013-09-03','14:10:00',7.05),('16100','2013-09-03','14:15:00',7.03),('16100','2013-09-03','14:20:00',6.91),('16100','2013-09-03','14:25:00',6.87),('16100','2013-09-03','14:30:00',6.83),('16100','2013-09-03','14:35:00',6.81),('16100','2013-09-03','14:40:00',6.73),('16100','2013-09-03','14:45:00',6.65),('16100','2013-09-03','14:50:00',6.61),('16100','2013-09-03','14:55:00',6.53),('16100','2013-09-03','15:00:00',6.48),('16100','2013-09-03','15:05:00',6.42),('16100','2013-09-03','15:10:00',6.36),('16100','2013-09-03','15:15:00',6.25),('16100','2013-09-03','15:20:00',6.17),('16100','2013-09-03','15:25:00',6.08),('16100','2013-09-03','15:30:00',5.98),('16100','2013-09-03','15:35:00',5.93),('16100','2013-09-03','15:40:00',5.81),('16100','2013-09-03','15:45:00',5.71),('16100','2013-09-03','15:50:00',5.6),('16100','2013-09-03','15:55:00',5.52),('16100','2013-09-03','16:00:00',5.4),('16100','2013-09-03','16:05:00',5.23),('16100','2013-09-03','16:10:00',5.1),('16100','2013-09-03','16:15:00',5),('16100','2013-09-03','16:20:00',4.93),('16100','2013-09-03','16:25:00',4.74),('16100','2013-09-03','16:30:00',4.57),('16100','2013-09-03','16:35:00',3.27),('16100','2013-09-03','16:40:00',4.4),('16100','2013-09-03','16:45:00',4.26),('16100','2013-09-03','16:50:00',4.07),('16100','2013-09-03','16:55:00',3.93),('16100','2013-09-03','17:00:00',3.79),('16100','2013-09-03','17:05:00',3.35),('16100','2013-09-03','17:10:00',3.44),('16100','2013-09-03','17:15:00',3.23),('16100','2013-09-03','17:20:00',3),('16100','2013-09-03','17:25:00',2.83),('16100','2013-09-03','17:30:00',2.7),('16100','2013-09-03','17:35:00',2.52),('16100','2013-09-03','17:40:00',2.39),('16100','2013-09-03','17:45:00',2.22),('16100','2013-09-03','17:50:00',2.06),('16100','2013-09-03','17:55:00',1.93),('16100','2013-09-03','18:00:00',1.77),('16100','2013-09-03','18:05:00',1.61),('16100','2013-09-03','18:10:00',1.44),('16100','2013-09-03','18:15:00',1.27),('16100','2013-09-03','18:20:00',1.12),('16100','2013-09-02','08:05:00',1.06),('16100','2013-09-02','08:10:00',1.24),('16100','2013-09-02','08:15:00',1.4),('16100','2013-09-02','08:20:00',1.56),('16100','2013-09-02','08:25:00',1.73),('16100','2013-09-02','08:30:00',1.89),('16100','2013-09-02','08:35:00',2.05),('16100','2013-09-02','08:40:00',2.24),('16100','2013-09-02','08:45:00',2.4),('16100','2013-09-02','08:50:00',2.55),('16100','2013-09-02','08:55:00',2.74),('16100','2013-09-02','09:00:00',2.89),('16100','2013-09-02','09:05:00',3.03),('16100','2013-09-02','09:10:00',3.23),('16100','2013-09-02','09:15:00',3.42),('16100','2013-09-02','09:20:00',3.54),('16100','2013-09-02','09:25:00',3.68),('16100','2013-09-02','09:30:00',3.83),('16100','2013-09-02','09:35:00',3.97),('16100','2013-09-02','09:40:00',4.12),('16100','2013-09-02','09:45:00',4.27),('16100','2013-09-02','09:50:00',4.39),('16100','2013-09-02','09:55:00',4.51),('16100','2013-09-02','10:00:00',4.63),('16100','2013-09-02','10:05:00',4.78),('16100','2013-09-02','10:10:00',4.95),('16100','2013-09-02','10:15:00',5.07),('16100','2013-09-02','10:20:00',5.18),('16100','2013-09-02','10:25:00',5.33),('16100','2013-09-02','10:30:00',5.47),('16100','2013-09-02','10:35:00',5.57),('16100','2013-09-02','10:40:00',5.65),('16100','2013-09-02','10:45:00',5.73),('16100','2013-09-02','10:50:00',5.78),('16100','2013-09-02','10:55:00',5.87),('16100','2013-09-02','11:00:00',5.94),('16100','2013-09-02','11:05:00',6),('16100','2013-09-02','11:10:00',6.1),('16100','2013-09-02','11:15:00',6.21),('16100','2013-09-02','11:20:00',6.29),('16100','2013-09-02','11:25:00',6.38),('16100','2013-09-02','11:30:00',6.5),('16100','2013-09-02','11:35:00',6.54),('16100','2013-09-02','11:40:00',6.63),('16100','2013-09-02','11:45:00',6.69),('16100','2013-09-02','11:50:00',6.75),('16100','2013-09-02','11:55:00',6.82),('16100','2013-09-02','12:00:00',6.81),('16100','2013-09-02','12:05:00',6.87),('16100','2013-09-02','12:10:00',6.98),('16100','2013-09-02','12:15:00',6.97),('16100','2013-09-02','12:20:00',7.05),('16100','2013-09-02','12:25:00',7.08),('16100','2013-09-02','12:30:00',7.16),('16100','2013-09-02','12:35:00',7.16),('16100','2013-09-02','12:40:00',7.14),('16100','2013-09-02','12:45:00',7.18),('16100','2013-09-02','12:50:00',7.21),('16100','2013-09-02','12:55:00',7.24),('16100','2013-09-02','13:00:00',7.31),('16100','2013-09-02','13:05:00',7.25),('16100','2013-09-02','13:10:00',7.21),('16100','2013-09-02','13:15:00',7.15),('16100','2013-09-02','13:20:00',7.26),('16100','2013-09-02','13:25:00',7.27),('16100','2013-09-02','13:30:00',7.18),('16100','2013-09-02','13:35:00',7.16),('16100','2013-09-02','13:40:00',7.16),('16100','2013-09-02','13:45:00',7.19),('16100','2013-09-02','13:50:00',7.16),('16100','2013-09-02','13:55:00',7.15),('16100','2013-09-02','14:00:00',7.03),('16100','2013-09-02','14:05:00',6.95),('16100','2013-09-02','14:10:00',6.89),('16100','2013-09-02','14:15:00',6.85),('16100','2013-09-02','14:20:00',6.78),('16100','2013-09-02','14:25:00',6.8),('16100','2013-09-02','14:30:00',6.81),('16100','2013-09-02','14:35:00',6.84),('16100','2013-09-02','14:40:00',6.75),('16100','2013-09-02','14:45:00',6.68),('16100','2013-09-02','14:50:00',6.54),('16100','2013-09-02','14:55:00',6.52),('16100','2013-09-02','15:00:00',6.55),('16100','2013-09-02','15:05:00',6.43),('16100','2013-09-02','15:10:00',6.35),('16100','2013-09-02','15:15:00',6.19),('16100','2013-09-02','15:20:00',6.12),('16100','2013-09-02','15:25:00',6.09),('16100','2013-09-02','15:30:00',6.02),('16100','2013-09-02','15:35:00',5.93),('16100','2013-09-02','15:40:00',5.79),('16100','2013-09-02','15:45:00',5.62),('16100','2013-09-02','15:50:00',5.54),('16100','2013-09-02','15:55:00',5.46),('16100','2013-09-02','16:00:00',5.35),('16100','2013-09-02','16:05:00',5.18),('16100','2013-09-02','16:10:00',4.9),('16100','2013-09-02','16:15:00',4.93),('16100','2013-09-02','16:20:00',4.8),('16100','2013-09-02','16:25:00',4.7),('16100','2013-09-02','16:30:00',4.6),('16100','2013-09-02','16:35:00',4.51),('16100','2013-09-02','16:40:00',4.35),('16100','2013-09-02','16:45:00',4.21),('16100','2013-09-02','16:50:00',4.03),('16100','2013-09-02','16:55:00',3.91),('16100','2013-09-02','17:00:00',3.77),('16100','2013-09-02','17:05:00',3.62),('16100','2013-09-02','17:10:00',3.46),('16100','2013-09-02','17:15:00',3.3),('16100','2013-09-02','17:20:00',3.15),('16100','2013-09-02','17:25:00',2.95),('16100','2013-09-02','17:30:00',2.72),('16100','2013-09-02','17:35:00',2.47),('16100','2013-09-02','17:40:00',2.31),('16100','2013-09-02','17:45:00',2.15),('16100','2013-09-02','17:50:00',1.99),('16100','2013-09-02','17:55:00',1.83),('16100','2013-09-02','18:00:00',1.67),('16100','2013-09-02','18:05:00',1.57),('16100','2013-09-02','18:10:00',1.4),('16100','2013-09-02','18:15:00',1.25),('16100','2013-09-02','18:20:00',1.13),('16100','2013-09-01','08:05:00',1.09),('16100','2013-09-01','08:10:00',1.28),('16100','2013-09-01','08:15:00',1.45),('16100','2013-09-01','08:20:00',1.62),('16100','2013-09-01','08:25:00',1.8),('16100','2013-09-01','08:30:00',1.97),('16100','2013-09-01','08:35:00',2.14),('16100','2013-09-01','08:40:00',2.31),('16100','2013-09-01','08:45:00',2.48),('16100','2013-09-01','08:50:00',2.66),('16100','2013-09-01','08:55:00',2.85),('16100','2013-09-01','09:00:00',3.01),('16100','2013-09-01','09:05:00',3.15),('16100','2013-09-01','09:10:00',3.33),('16100','2013-09-01','09:15:00',3.51),('16100','2013-09-01','09:20:00',3.64),('16100','2013-09-01','09:25:00',3.79),('16100','2013-09-01','09:30:00',3.93),('16100','2013-09-01','09:35:00',4.04),('16100','2013-09-01','09:40:00',4.2),('16100','2013-09-01','09:45:00',4.38),('16100','2013-09-01','09:50:00',4.51),('16100','2013-09-01','09:55:00',4.62),('16100','2013-09-01','10:00:00',4.78),('16100','2013-09-01','10:05:00',4.87),('16100','2013-09-01','10:10:00',5.01),('16100','2013-09-01','10:15:00',5.13),('16100','2013-09-01','10:20:00',5.25),('16100','2013-09-01','10:25:00',5.4),('16100','2013-09-01','10:30:00',5.54),('16100','2013-09-01','10:35:00',5.65),('16100','2013-09-01','10:40:00',5.73),('16100','2013-09-01','10:45:00',5.81),('16100','2013-09-01','10:50:00',5.91),('16100','2013-09-01','10:55:00',6),('16100','2013-09-01','11:00:00',6.1),('16100','2013-09-01','11:05:00',6.19),('16100','2013-09-01','11:10:00',6.27),('16100','2013-09-01','11:15:00',6.35),('16100','2013-09-01','11:20:00',6.41),('16100','2013-09-01','11:25:00',6.51),('16100','2013-09-01','11:30:00',6.55),('16100','2013-09-01','11:35:00',6.62),('16100','2013-09-01','11:40:00',6.68),('16100','2013-09-01','11:45:00',6.69),('16100','2013-09-01','11:50:00',6.74),('16100','2013-09-01','11:55:00',6.78),('16100','2013-09-01','12:00:00',6.85),('16100','2013-09-01','12:05:00',6.93),('16100','2013-09-01','12:10:00',6.97),('16100','2013-09-01','12:15:00',6.97),('16100','2013-09-01','12:20:00',6.98),('16100','2013-09-01','12:25:00',7.01),('16100','2013-09-01','12:30:00',7.11),('16100','2013-09-01','12:35:00',7.11),('16100','2013-09-01','12:40:00',7.1),('16100','2013-09-01','12:45:00',7.15),('16100','2013-09-01','12:50:00',7.19),('16100','2013-09-01','12:55:00',7.19),('16100','2013-09-01','13:00:00',7.18),('16100','2013-09-01','13:05:00',7.2),('16100','2013-09-01','13:10:00',7.16),('16100','2013-09-01','13:15:00',7.13),('16100','2013-09-01','13:20:00',7.11),('16100','2013-09-01','13:25:00',7.14),('16100','2013-09-01','13:30:00',7.18),('16100','2013-09-01','13:35:00',7.17),('16100','2013-09-01','13:40:00',7.19),('16100','2013-09-01','13:45:00',7.18),('16100','2013-09-01','13:50:00',7.21),('16100','2013-09-01','13:55:00',7.11),('16100','2013-09-01','14:00:00',7.06),('16100','2013-09-01','14:05:00',6.96),('16100','2013-09-01','14:10:00',6.88),('16100','2013-09-01','14:15:00',6.96),('16100','2013-09-01','14:20:00',6.95),('16100','2013-09-01','14:25:00',4.74),('16100','2013-09-01','14:30:00',6.89),('16100','2013-09-01','14:35:00',3.54),('16100','2013-09-01','14:40:00',5.26),('16100','2013-09-01','14:45:00',6.82),('16100','2013-09-01','14:50:00',6.57),('16100','2013-09-01','14:55:00',6.58),('16100','2013-09-01','15:00:00',6.49),('16100','2013-09-01','15:05:00',6.45),('16100','2013-09-01','15:10:00',6.27),('16100','2013-09-01','15:15:00',6.04),('16100','2013-09-01','15:20:00',5.86),('16100','2013-09-01','15:25:00',5.93),('16100','2013-09-01','15:30:00',5.93),('16100','2013-09-01','15:35:00',5.88),('16100','2013-09-01','15:40:00',5.76),('16100','2013-09-01','15:45:00',5.73),('16100','2013-09-01','15:50:00',5.64),('16100','2013-09-01','15:55:00',5.49),('16100','2013-09-01','16:00:00',5.4),('16100','2013-09-01','16:05:00',5.31),('16100','2013-09-01','16:10:00',5.07),('16100','2013-09-01','16:15:00',4.99),('16100','2013-09-01','16:20:00',4.87),('16100','2013-09-01','16:25:00',4.7),('16100','2013-09-01','16:30:00',4.6),('16100','2013-09-01','16:35:00',4.47),('16100','2013-09-01','16:40:00',4.36),('16100','2013-09-01','16:45:00',4.22),('16100','2013-09-01','16:50:00',4.05),('16100','2013-09-01','16:55:00',3.91),('16100','2013-09-01','17:00:00',3.75),('16100','2013-09-01','17:05:00',3.55),('16100','2013-09-01','17:10:00',3.4),('16100','2013-09-01','17:15:00',3.29),('16100','2013-09-01','17:20:00',3.07),('16100','2013-09-01','17:25:00',2.88),('16100','2013-09-01','17:30:00',2.75),('16100','2013-09-01','17:35:00',2.58),('16100','2013-09-01','17:40:00',2.4),('16100','2013-09-01','17:45:00',2.25),('16100','2013-09-01','17:50:00',2.09),('16100','2013-09-01','17:55:00',1.92),('16100','2013-09-01','18:00:00',1.78),('16100','2013-09-01','18:05:00',1.63),('16100','2013-09-01','18:10:00',1.45),('16100','2013-09-01','18:15:00',1.28),('16100','2013-09-01','18:20:00',1.12),('16100','2013-08-31','08:05:00',1.12),('16100','2013-08-31','08:10:00',1.35),('16100','2013-08-31','08:15:00',1.54),('16100','2013-08-31','08:20:00',1.72),('16100','2013-08-31','08:25:00',1.91),('16100','2013-08-31','08:30:00',2.08),('16100','2013-08-31','08:35:00',2.25),('16100','2013-08-31','08:40:00',2.42),('16100','2013-08-31','08:45:00',2.58),('16100','2013-08-31','08:50:00',2.74),('16100','2013-08-31','08:55:00',2.93),('16100','2013-08-31','09:00:00',3.08),('16100','2013-08-31','09:05:00',3.24),('16100','2013-08-31','09:10:00',3.43),('16100','2013-08-31','09:15:00',3.61),('16100','2013-08-31','09:20:00',3.76),('16100','2013-08-31','09:25:00',3.89),('16100','2013-08-31','09:30:00',4.04),('16100','2013-08-31','09:35:00',4.16),('16100','2013-08-31','09:40:00',4.31),('16100','2013-08-31','09:45:00',4.48),('16100','2013-08-31','09:50:00',4.58),('16100','2013-08-31','09:55:00',4.7),('16100','2013-08-31','10:00:00',4.82),('16100','2013-08-31','10:05:00',4.95),('16100','2013-08-31','10:10:00',5.04),('16100','2013-08-31','10:15:00',5.18),('16100','2013-08-31','10:20:00',5.3),('16100','2013-08-31','10:25:00',5.39),('16100','2013-08-31','10:30:00',5.61),('16100','2013-08-31','10:35:00',5.71),('16100','2013-08-31','10:40:00',5.83),('16100','2013-08-31','10:45:00',5.92),('16100','2013-08-31','10:50:00',6.02),('16100','2013-08-31','10:55:00',6.12),('16100','2013-08-31','11:00:00',6.19),('16100','2013-08-31','11:05:00',6.34),('16100','2013-08-31','11:10:00',6.45),('16100','2013-08-31','11:15:00',6.6),('16100','2013-08-31','11:20:00',6.64),('16100','2013-08-31','11:25:00',6.71),('16100','2013-08-31','11:30:00',6.78),('16100','2013-08-31','11:35:00',6.85),('16100','2013-08-31','11:40:00',6.87),('16100','2013-08-31','11:45:00',6.91),('16100','2013-08-31','11:50:00',6.97),('16100','2013-08-31','11:55:00',6.96),('16100','2013-08-31','12:00:00',7),('16100','2013-08-31','12:05:00',7.03),('16100','2013-08-31','12:10:00',7.07),('16100','2013-08-31','12:15:00',7.1),('16100','2013-08-31','12:20:00',7.04),('16100','2013-08-31','12:25:00',7.05),('16100','2013-08-31','12:30:00',7.19),('16100','2013-08-31','12:35:00',7.16),('16100','2013-08-31','12:40:00',7.22),('16100','2013-08-31','12:45:00',7.21),('16100','2013-08-31','12:50:00',7.26),('16100','2013-08-31','12:55:00',7.25),('16100','2013-08-31','13:00:00',7.17),('16100','2013-08-31','13:05:00',6.97),('16100','2013-08-31','13:10:00',7.09),('16100','2013-08-31','13:15:00',7.07),('16100','2013-08-31','13:20:00',6.95),('16100','2013-08-31','13:25:00',6.2),('16100','2013-08-31','13:30:00',6.77),('16100','2013-08-31','13:35:00',7.44),('16100','2013-08-31','13:40:00',7.42),('16100','2013-08-31','13:45:00',7.44),('16100','2013-08-31','13:50:00',7.43),('16100','2013-08-31','13:55:00',7.26),('16100','2013-08-31','14:00:00',7.12),('16100','2013-08-31','14:05:00',6.92),('16100','2013-08-31','14:10:00',6.44),('16100','2013-08-31','14:15:00',6.7),('16100','2013-08-31','14:20:00',6.06),('16100','2013-08-31','14:25:00',5.85),('16100','2013-08-31','14:30:00',5.89),('16100','2013-08-31','14:35:00',5.55),('16100','2013-08-31','14:40:00',5.7),('16100','2013-08-31','14:45:00',6.47),('16100','2013-08-31','14:50:00',6.33),('16100','2013-08-31','14:55:00',6.19),('16100','2013-08-31','15:00:00',6.16),('16100','2013-08-31','15:05:00',6.09),('16100','2013-08-31','15:10:00',6.08),('16100','2013-08-31','15:15:00',5.78),('16100','2013-08-31','15:20:00',5.81),('16100','2013-08-31','15:25:00',5.65),('16100','2013-08-31','15:30:00',4.75),('16100','2013-08-31','15:35:00',4.71),('16100','2013-08-31','15:40:00',4.67),('16100','2013-08-31','15:45:00',4.67),('16100','2013-08-31','15:50:00',4.56),('16100','2013-08-31','15:55:00',4.62),('16100','2013-08-31','16:00:00',4.69),('16100','2013-08-31','16:05:00',3.88),('16100','2013-08-31','16:10:00',4.83),('16100','2013-08-31','16:15:00',4.95),('16100','2013-08-31','16:20:00',4.56),('16100','2013-08-31','16:25:00',4.82),('16100','2013-08-31','16:30:00',4.07),('16100','2013-08-31','16:35:00',4.4),('16100','2013-08-31','16:40:00',4.24),('16100','2013-08-31','16:45:00',3.88),('16100','2013-08-31','16:50:00',3.51),('16100','2013-08-31','16:55:00',3.12),('16100','2013-08-31','17:00:00',3.37),('16100','2013-08-31','17:05:00',3.39),('16100','2013-08-31','17:10:00',3.26),('16100','2013-08-31','17:15:00',3.41),('16100','2013-08-31','17:20:00',3.17),('16100','2013-08-31','17:25:00',2.84),('16100','2013-08-31','17:30:00',2.83),('16100','2013-08-31','17:35:00',2.76),('16100','2013-08-31','17:40:00',2.24),('16100','2013-08-31','17:45:00',2.33),('16100','2013-08-31','17:50:00',2.48),('16100','2013-08-31','17:55:00',2.22),('16100','2013-08-31','18:00:00',1.93),('16100','2013-08-31','18:05:00',1.81),('16100','2013-08-31','18:10:00',1.78),('16100','2013-08-31','18:15:00',1.45),('16100','2013-08-31','18:20:00',1.36),('16100','2013-08-31','18:25:00',1.4),('16100','2013-08-31','18:30:00',1.15),('16100','2013-08-31','18:35:00',1.09),('16100','2013-08-31','18:40:00',1.07),('16100','2013-08-30','08:15:00',1.3),('16100','2013-08-30','08:20:00',1.6),('16100','2013-08-30','08:25:00',1.96),('16100','2013-08-30','08:30:00',2.16),('16100','2013-08-30','08:35:00',2.28),('16100','2013-08-30','08:40:00',2.49),('16100','2013-08-30','08:45:00',2.77),('16100','2013-08-30','08:50:00',3.09),('16100','2013-08-30','08:55:00',3.44),('16100','2013-08-30','09:00:00',3.12),('16100','2013-08-30','09:05:00',2.51),('16100','2013-08-30','09:10:00',2.25),('16100','2013-08-30','09:15:00',3.96),('16100','2013-08-30','09:20:00',3.91),('16100','2013-08-30','09:25:00',4.24),('16100','2013-08-30','09:30:00',4.43),('16100','2013-08-30','09:35:00',4.49),('16100','2013-08-30','09:40:00',4.18),('16100','2013-08-30','09:45:00',4.49),('16100','2013-08-30','09:50:00',5.01),('16100','2013-08-30','09:55:00',4.89),('16100','2013-08-30','10:00:00',5.22),('16100','2013-08-30','10:05:00',5.15),('16100','2013-08-30','10:10:00',5.3),('16100','2013-08-30','10:15:00',5.32),('16100','2013-08-30','10:20:00',5.39),('16100','2013-08-30','10:25:00',5.57),('16100','2013-08-30','10:30:00',5.69),('16100','2013-08-30','10:35:00',5.72),('16100','2013-08-30','10:40:00',5.86),('16100','2013-08-30','10:45:00',6.04),('16100','2013-08-30','10:50:00',6.17),('16100','2013-08-30','10:55:00',6.32),('16100','2013-08-30','11:00:00',6.41),('16100','2013-08-30','11:05:00',6.52),('16100','2013-08-30','11:10:00',6.59),('16100','2013-08-30','11:15:00',6.68),('16100','2013-08-30','11:20:00',6.75),('16100','2013-08-30','11:25:00',6.8),('16100','2013-08-30','11:30:00',6.88),('16100','2013-08-30','11:35:00',6.95),('16100','2013-08-30','11:40:00',7.04),('16100','2013-08-30','11:45:00',7.12),('16100','2013-08-30','11:50:00',7.15),('16100','2013-08-30','11:55:00',7.19),('16100','2013-08-30','12:00:00',7.22),('16100','2013-08-30','12:05:00',7.26),('16100','2013-08-30','12:10:00',7.3),('16100','2013-08-30','12:15:00',7.36),('16100','2013-08-30','12:20:00',7.32),('16100','2013-08-30','12:25:00',7.32),('16100','2013-08-30','12:30:00',7.31),('16100','2013-08-30','12:35:00',7.43),('16100','2013-08-30','12:40:00',7.49),('16100','2013-08-30','12:45:00',7.48),('16100','2013-08-30','12:50:00',7.47),('16100','2013-08-30','12:55:00',7.46),('16100','2013-08-30','13:00:00',7.48),('16100','2013-08-30','13:05:00',7.44),('16100','2013-08-30','13:10:00',7.48),('16100','2013-08-30','13:15:00',7.48),('16100','2013-08-30','13:20:00',7.41),('16100','2013-08-30','13:25:00',7.36),('16100','2013-08-30','13:30:00',7.28),('16100','2013-08-30','13:35:00',7.33),('16100','2013-08-30','13:40:00',7.36),('16100','2013-08-30','13:45:00',7.3),('16100','2013-08-30','13:50:00',7.24),('16100','2013-08-30','13:55:00',7.16),('16100','2013-08-30','14:00:00',7.24),('16100','2013-08-30','14:05:00',7.13),('16100','2013-08-30','14:10:00',7),('16100','2013-08-30','14:15:00',6.91),('16100','2013-08-30','14:20:00',6.81),('16100','2013-08-30','14:25:00',6.8),('16100','2013-08-30','14:30:00',6.74),('16100','2013-08-30','14:35:00',6.68),('16100','2013-08-30','14:40:00',6.71),('16100','2013-08-30','14:45:00',6.57),('16100','2013-08-30','14:50:00',6.46),('16100','2013-08-30','14:55:00',6.39),('16100','2013-08-30','15:00:00',6.28),('16100','2013-08-30','15:05:00',6.24),('16100','2013-08-30','15:10:00',6.09),('16100','2013-08-30','15:15:00',6.02),('16100','2013-08-30','15:20:00',5.93),('16100','2013-08-30','15:25:00',5.88),('16100','2013-08-30','15:30:00',5.77),('16100','2013-08-30','15:35:00',5.71),('16100','2013-08-30','15:40:00',5.56),('16100','2013-08-30','15:45:00',5.43),('16100','2013-08-30','15:50:00',5.41),('16100','2013-08-30','15:55:00',5.37),('16100','2013-08-30','16:00:00',5.3),('16100','2013-08-30','16:05:00',5.13),('16100','2013-08-30','16:10:00',4.93),('16100','2013-08-30','16:15:00',4.76),('16100','2013-08-30','16:20:00',4.76),('16100','2013-08-30','16:25:00',4.43),('16100','2013-08-30','16:30:00',4.59),('16100','2013-08-30','16:35:00',4.42),('16100','2013-08-30','16:40:00',4.08),('16100','2013-08-30','16:45:00',3.98),('16100','2013-08-30','16:50:00',3.92),('16100','2013-08-30','16:55:00',3.9),('16100','2013-08-30','17:00:00',3.76),('16100','2013-08-30','17:05:00',3.66),('16100','2013-08-30','17:10:00',3.56),('16100','2013-08-30','17:15:00',3.34),('16100','2013-08-30','17:20:00',3.11),('16100','2013-08-30','17:25:00',2.87),('16100','2013-08-30','17:30:00',2.7),('16100','2013-08-30','17:35:00',2.69),('16100','2013-08-30','17:40:00',2.52),('16100','2013-08-30','17:45:00',2.28),('16100','2013-08-30','17:50:00',1.85),('16100','2013-08-30','17:55:00',1.41),('16100','2013-08-30','18:00:00',1.1),('16100','2013-08-30','18:05:00',1.19),('16100','2013-08-30','18:10:00',1.14),('16100','2013-08-29','08:00:00',1.15),('16100','2013-08-29','08:05:00',1.43),('16100','2013-08-29','08:10:00',1.58),('16100','2013-08-29','08:15:00',1.62),('16100','2013-08-29','08:20:00',1.88),('16100','2013-08-29','08:25:00',1.93),('16100','2013-08-29','08:30:00',2.03),('16100','2013-08-29','08:35:00',2.13),('16100','2013-08-29','08:40:00',2.16),('16100','2013-08-29','08:45:00',1.91),('16100','2013-08-29','08:50:00',1.88),('16100','2013-08-29','08:55:00',2.19),('16100','2013-08-29','09:00:00',2.42),('16100','2013-08-29','09:05:00',2.41),('16100','2013-08-29','09:10:00',2.14),('16100','2013-08-29','09:15:00',1.9),('16100','2013-08-29','09:20:00',1.85),('16100','2013-08-29','09:25:00',2.35),('16100','2013-08-29','09:30:00',2.61),('16100','2013-08-29','09:35:00',2.75),('16100','2013-08-29','09:40:00',2.94),('16100','2013-08-29','09:45:00',3),('16100','2013-08-29','09:50:00',3.23),('16100','2013-08-29','09:55:00',3.33),('16100','2013-08-29','10:00:00',2.99),('16100','2013-08-29','10:05:00',3.02),('16100','2013-08-29','10:10:00',3.39),('16100','2013-08-29','10:15:00',3.43),('16100','2013-08-29','10:20:00',3.29),('16100','2013-08-29','10:25:00',3.59),('16100','2013-08-29','10:30:00',3.77),('16100','2013-08-29','10:35:00',3.64),('16100','2013-08-29','10:40:00',3.39),('16100','2013-08-29','10:45:00',3.61),('16100','2013-08-29','10:50:00',3.57),('16100','2013-08-29','10:55:00',3.5),('16100','2013-08-29','11:00:00',3.67),('16100','2013-08-29','11:05:00',3.98),('16100','2013-08-29','11:10:00',4.34),('16100','2013-08-29','11:15:00',4.15),('16100','2013-08-29','11:20:00',4.46),('16100','2013-08-29','11:25:00',4.44),('16100','2013-08-29','11:30:00',4.74),('16100','2013-08-29','11:35:00',4.58),('16100','2013-08-29','11:40:00',5.12),('16100','2013-08-29','11:45:00',5.33),('16100','2013-08-29','11:50:00',5.41),('16100','2013-08-29','11:55:00',5.05),('16100','2013-08-29','12:00:00',4.02),('16100','2013-08-29','12:05:00',4.24),('16100','2013-08-29','12:10:00',4.56),('16100','2013-08-29','12:15:00',4.32),('16100','2013-08-29','12:20:00',5.04),('16100','2013-08-29','12:25:00',5.68),('16100','2013-08-29','12:30:00',6.21),('16100','2013-08-29','12:35:00',5.69),('16100','2013-08-29','12:40:00',6.03),('16100','2013-08-29','12:45:00',5.76),('16100','2013-08-29','12:50:00',5.55),('16100','2013-08-29','12:55:00',5.15),('16100','2013-08-29','13:00:00',5.09),('16100','2013-08-29','13:05:00',4.68),('16100','2013-08-29','13:10:00',4.69),('16100','2013-08-29','13:15:00',5.11),('16100','2013-08-29','13:20:00',5.82),('16100','2013-08-29','13:25:00',7.45),('16100','2013-08-29','13:30:00',7.4),('16100','2013-08-29','13:35:00',6.78),('16100','2013-08-29','13:40:00',7.35),('16100','2013-08-29','13:45:00',7.19),('16100','2013-08-29','13:50:00',6.93),('16100','2013-08-29','13:55:00',7.05),('16100','2013-08-29','14:00:00',7.24),('16100','2013-08-29','14:05:00',7.21),('16100','2013-08-29','14:10:00',7.26),('16100','2013-08-29','14:15:00',6.93),('16100','2013-08-29','14:20:00',6.91),('16100','2013-08-29','14:25:00',7.06),('16100','2013-08-29','14:30:00',7.04),('16100','2013-08-29','14:35:00',7.03),('16100','2013-08-29','14:40:00',6.21),('16100','2013-08-29','14:45:00',6.31),('16100','2013-08-29','14:50:00',4.96),('16100','2013-08-29','14:55:00',6.27),('16100','2013-08-29','15:00:00',4.75),('16100','2013-08-29','15:05:00',4.92),('16100','2013-08-29','15:10:00',5.11),('16100','2013-08-29','15:15:00',4.8),('16100','2013-08-29','15:20:00',4.76),('16100','2013-08-29','15:25:00',4.64),('16100','2013-08-29','15:30:00',4.42),('16100','2013-08-29','15:35:00',4.08),('16100','2013-08-29','15:40:00',4.83),('16100','2013-08-29','15:45:00',4.69),('16100','2013-08-29','15:50:00',4.12),('16100','2013-08-29','15:55:00',3.86),('16100','2013-08-29','16:00:00',3.44),('16100','2013-08-29','16:05:00',3.02),('16100','2013-08-29','16:10:00',3.34),('16100','2013-08-29','16:15:00',3.68),('16100','2013-08-29','16:20:00',3.62),('16100','2013-08-29','16:25:00',3.41),('16100','2013-08-29','16:30:00',3.73),('16100','2013-08-29','16:35:00',4.18),('16100','2013-08-29','16:40:00',4.26),('16100','2013-08-29','16:45:00',4.22),('16100','2013-08-29','16:50:00',4.01),('16100','2013-08-29','16:55:00',2.68),('16100','2013-08-29','17:00:00',3.23),('16100','2013-08-29','17:05:00',2.11),('16100','2013-08-29','17:10:00',2.15),('16100','2013-08-29','17:15:00',2.08),('16100','2013-08-29','17:20:00',2.83),('16100','2013-08-29','17:25:00',2.52),('16100','2013-08-29','17:30:00',2.47),('16100','2013-08-29','17:35:00',2.18),('16100','2013-08-29','17:40:00',2.33),('16100','2013-08-29','17:45:00',1.65),('16100','2013-08-29','17:50:00',2.18),('16100','2013-08-29','17:55:00',2.19),('16100','2013-08-29','18:00:00',1.61),('16100','2013-08-29','18:05:00',1.03),('16100','2014-04-10','08:25:00',1.48),('16100','2014-04-10','08:30:00',2.08),('16100','2014-04-10','08:35:00',2.38),('16100','2014-04-10','08:40:00',2.57),('16100','2014-04-10','08:45:00',2.73),('16100','2014-04-10','08:50:00',2.91),('16100','2014-04-10','08:55:00',3.07),('16100','2014-04-10','09:00:00',3.18),('16100','2014-04-10','09:05:00',3.3),('16100','2014-04-10','09:10:00',3.46),('16100','2014-04-10','09:15:00',3.62),('16100','2014-04-10','09:20:00',3.71),('16100','2014-04-10','09:25:00',3.81),('16100','2014-04-10','09:30:00',4.03),('16100','2014-04-10','09:35:00',4.18),('16100','2014-04-10','09:40:00',4.35),('16100','2014-04-10','09:45:00',4.54),('16100','2014-04-10','09:50:00',4.68),('16100','2014-04-10','09:55:00',4.79),('16100','2014-04-10','10:00:00',4.9),('16100','2014-04-10','10:05:00',5.07),('16100','2014-04-10','10:10:00',5.24),('16100','2014-04-10','10:15:00',5.37),('16100','2014-04-10','10:20:00',5.49),('16100','2014-04-10','10:25:00',5.62),('16100','2014-04-10','10:30:00',5.71),('16100','2014-04-10','10:35:00',5.87),('16100','2014-04-10','10:40:00',5.99),('16100','2014-04-10','10:45:00',6.11),('16100','2014-04-10','10:50:00',6.2),('16100','2014-04-10','10:55:00',6.27),('16100','2014-04-10','11:00:00',6.39),('16100','2014-04-10','11:05:00',6.47),('16100','2014-04-10','11:10:00',6.64),('16100','2014-04-10','11:15:00',6.73),('16100','2014-04-10','11:20:00',6.83),('16100','2014-04-10','11:25:00',6.95),('16100','2014-04-10','11:30:00',7.05),('16100','2014-04-10','11:35:00',7.06),('16100','2014-04-10','11:40:00',6.76),('16100','2014-04-10','11:45:00',7.39),('16100','2014-04-10','11:50:00',7.36),('16100','2014-04-10','11:55:00',6.07),('16100','2014-04-10','12:00:00',6.05),('16100','2014-04-10','12:05:00',7.49),('16100','2014-04-10','12:10:00',7.72),('16100','2014-04-10','12:15:00',5.44),('16100','2014-04-10','12:20:00',5.68),('16100','2014-04-10','12:25:00',8.23),('16100','2014-04-10','12:30:00',6.95),('16100','2014-04-10','12:35:00',8.28),('16100','2014-04-10','12:40:00',7.76),('16100','2014-04-10','12:45:00',6.4),('16100','2014-04-10','12:50:00',2.32),('16100','2014-04-10','12:55:00',5.41),('16100','2014-04-10','13:00:00',8.27),('16100','2014-04-10','13:05:00',8.26),('16100','2014-04-10','13:10:00',5.72),('16100','2014-04-10','13:15:00',5.47),('16100','2014-04-10','13:20:00',7.73),('16100','2014-04-10','13:25:00',6.44),('16100','2014-04-10','13:30:00',8.37),('16100','2014-04-10','13:35:00',4.99),('16100','2014-04-10','13:40:00',6.06),('16100','2014-04-10','13:45:00',6.12),('16100','2014-04-10','13:50:00',4.29),('16100','2014-04-10','13:55:00',5.03),('16100','2014-04-10','14:00:00',5.65),('16100','2014-04-10','14:05:00',2.96),('16100','2014-04-10','14:10:00',4.52),('16100','2014-04-10','14:15:00',4.37),('16100','2014-04-10','14:20:00',5.19),('16100','2014-04-10','14:25:00',3.08),('16100','2014-04-10','14:30:00',3.98),('16100','2014-04-10','14:35:00',4.39),('16100','2014-04-10','14:40:00',6.15),('16100','2014-04-10','14:45:00',8.42),('16100','2014-04-10','14:50:00',7.73),('16100','2014-04-10','14:55:00',7.55),('16100','2014-04-10','15:00:00',7.58),('16100','2014-04-10','15:05:00',7.23),('16100','2014-04-10','15:10:00',6.86),('16100','2014-04-10','15:15:00',6.55),('16100','2014-04-10','15:20:00',6.63),('16100','2014-04-10','15:25:00',6.45),('16100','2014-04-10','15:30:00',6.38),('16100','2014-04-10','15:35:00',6.23),('16100','2014-04-10','15:40:00',6.15),('16100','2014-04-10','15:45:00',6),('16100','2014-04-10','15:50:00',6.06),('16100','2014-04-10','15:55:00',5.69),('16100','2014-04-10','16:00:00',5.23),('16100','2014-04-10','16:05:00',5.59),('16100','2014-04-10','16:10:00',5.44),('16100','2014-04-10','16:15:00',3.09),('16100','2014-04-10','16:20:00',5.34),('16100','2014-04-10','16:25:00',5.34),('16100','2014-04-10','16:30:00',4.64),('16100','2014-04-10','16:35:00',5.05),('16100','2014-04-10','16:40:00',2.99),('16100','2014-04-10','16:45:00',4.46),('16100','2014-04-10','16:50:00',3.99),('16100','2014-04-10','16:55:00',4.42),('16100','2014-04-10','17:00:00',4.13),('16100','2014-04-10','17:05:00',4.27),('16100','2014-04-10','17:10:00',3.89),('16100','2014-04-10','17:15:00',3.27),('16100','2014-04-10','17:20:00',3.15),('16100','2014-04-10','17:25:00',2.51),('16100','2014-04-10','17:30:00',3.15),('16100','2014-04-10','17:35:00',3.22),('16100','2014-04-10','17:40:00',2.82),('16100','2014-04-10','17:45:00',2.26),('16100','2014-04-10','17:50:00',1.3),('16100','2014-04-10','17:55:00',1.52),('16100','2014-04-10','18:00:00',1.36),('16100','2014-04-10','18:05:00',1.65),('16100','2014-04-10','18:10:00',1.55),('16100','2014-04-10','18:15:00',1.36),('16100','2013-08-28','08:05:00',1.13),('16100','2013-08-28','08:10:00',1.41),('16100','2013-08-28','08:15:00',1.73),('16100','2013-08-28','08:20:00',2),('16100','2013-08-28','08:25:00',2.4),('16100','2013-08-28','08:30:00',2.82),('16100','2013-08-28','08:35:00',2.83),('16100','2013-08-28','08:40:00',1.98),('16100','2013-08-28','08:45:00',1.66),('16100','2013-08-28','08:50:00',1.79),('16100','2013-08-28','08:55:00',2.22),('16100','2013-08-28','09:00:00',2.2),('16100','2013-08-28','09:05:00',2.1),('16100','2013-08-28','09:10:00',2.28),('16100','2013-08-28','09:15:00',2.24),('16100','2013-08-28','09:20:00',2.34),('16100','2013-08-28','09:25:00',2.55),('16100','2013-08-28','09:30:00',2.54),('16100','2013-08-28','09:35:00',2.94),('16100','2013-08-28','09:40:00',2.69),('16100','2013-08-28','09:45:00',2.29),('16100','2013-08-28','09:50:00',2.24),('16100','2013-08-28','09:55:00',2.32),('16100','2013-08-28','10:00:00',2.36),('16100','2013-08-28','10:05:00',2.32),('16100','2013-08-28','10:10:00',2.27),('16100','2013-08-28','10:15:00',2.29),('16100','2013-08-28','10:20:00',2.35),('16100','2013-08-28','10:25:00',2.4),('16100','2013-08-28','10:30:00',2.42),('16100','2013-08-28','10:35:00',2.17),('16100','2013-08-28','10:40:00',1.95),('16100','2013-08-28','10:45:00',1.9),('16100','2013-08-28','10:50:00',2.05),('16100','2013-08-28','10:55:00',2.39),('16100','2013-08-28','11:00:00',2.44),('16100','2013-08-28','11:05:00',2.72),('16100','2013-08-28','11:10:00',3.16),('16100','2013-08-28','11:15:00',3.31),('16100','2013-08-28','11:20:00',2.96),('16100','2013-08-28','11:25:00',2.32),('16100','2013-08-28','11:30:00',2.02),('16100','2013-08-28','11:35:00',2.24),('16100','2013-08-28','11:40:00',2.73),('16100','2013-08-28','11:45:00',2.95),('16100','2013-08-28','11:50:00',3.11),('16100','2013-08-28','11:55:00',3.12),('16100','2013-08-28','12:00:00',3.16),('16100','2013-08-28','12:05:00',3.81),('16100','2013-08-28','12:10:00',5.65),('16100','2013-08-28','12:15:00',5.47),('16100','2013-08-28','12:20:00',5.58),('16100','2013-08-28','12:25:00',5.06),('16100','2013-08-28','12:30:00',4.5),('16100','2013-08-28','12:35:00',5.61),('16100','2013-08-28','12:40:00',6.63),('16100','2013-08-28','12:45:00',7.47),('16100','2013-08-28','12:50:00',5.8),('16100','2013-08-28','12:55:00',4.66),('16100','2013-08-28','13:00:00',4.68),('16100','2013-08-28','13:05:00',4.19),('16100','2013-08-28','13:10:00',3.63),('16100','2013-08-28','13:15:00',3.9),('16100','2013-08-28','13:20:00',3.7),('16100','2013-08-28','13:25:00',3.08),('16100','2013-08-28','13:30:00',3.07),('16100','2013-08-28','13:35:00',3.16),('16100','2013-08-28','13:40:00',2.65),('16100','2013-08-28','13:45:00',2.53),('16100','2013-08-28','13:50:00',2.98),('16100','2013-08-28','13:55:00',4.84),('16100','2013-08-28','14:00:00',3.44),('16100','2013-08-28','14:05:00',2.47),('16100','2013-08-28','14:10:00',2.06),('16100','2013-08-28','14:15:00',1.73),('16100','2013-08-28','14:20:00',1.56),('16100','2013-08-28','14:25:00',1.5),('16100','2013-08-28','14:30:00',1.51),('16100','2013-08-28','14:35:00',1.63),('16100','2013-08-28','14:40:00',1.81),('16100','2013-08-28','14:45:00',2.01),('16100','2013-08-28','14:50:00',2.2),('16100','2013-08-28','14:55:00',2.98),('16100','2013-08-28','15:00:00',3.53),('16100','2013-08-28','15:05:00',3.69),('16100','2013-08-28','15:10:00',2.1),('16100','2013-08-28','15:15:00',2.22),('16100','2013-08-28','15:20:00',3.6),('16100','2013-08-28','15:25:00',4.38),('16100','2013-08-28','15:30:00',4.1),('16100','2013-08-28','15:35:00',3.83),('16100','2013-08-28','15:40:00',4.13),('16100','2013-08-28','15:45:00',3.28),('16100','2013-08-28','15:50:00',3.61),('16100','2013-08-28','15:55:00',4.85),('16100','2013-08-28','16:00:00',6.72),('16100','2013-08-28','16:05:00',6.37),('16100','2013-08-28','16:10:00',5.6),('16100','2013-08-28','16:15:00',5.33),('16100','2013-08-28','16:20:00',5.19),('16100','2013-08-28','16:25:00',4.53),('16100','2013-08-28','16:30:00',4.99),('16100','2013-08-28','16:35:00',4.84),('16100','2013-08-28','16:40:00',4.69),('16100','2013-08-28','16:45:00',4.5),('16100','2013-08-28','16:50:00',4.39),('16100','2013-08-28','16:55:00',4.17),('16100','2013-08-28','17:00:00',4.04),('16100','2013-08-28','17:05:00',3.9),('16100','2013-08-28','17:10:00',3.73),('16100','2013-08-28','17:15:00',3.56),('16100','2013-08-28','17:20:00',3.39),('16100','2013-08-28','17:25:00',3.22),('16100','2013-08-28','17:30:00',3.04),('16100','2013-08-28','17:35:00',2.87),('16100','2013-08-28','17:40:00',2.67),('16100','2013-08-28','17:45:00',2.5),('16100','2013-08-28','17:50:00',2.35),('16100','2013-08-28','17:55:00',2.2),('16100','2013-08-28','18:00:00',2.03),('16100','2013-08-28','18:05:00',1.87),('16100','2013-08-28','18:10:00',1.71),('16100','2013-08-28','18:15:00',1.54),('16100','2013-08-28','18:20:00',1.36),('16100','2013-08-28','18:25:00',1.21),('16100','2013-08-28','18:30:00',1.06),('16100','2013-08-27','07:55:00',1),('16100','2013-08-27','08:00:00',1.01),('16100','2013-08-27','08:05:00',1.16),('16100','2013-08-27','08:10:00',1.48),('16100','2013-08-27','08:15:00',1.82),('16100','2013-08-27','08:20:00',1.74),('16100','2013-08-27','08:25:00',1.39),('16100','2013-08-27','08:30:00',1.86),('16100','2013-08-27','08:35:00',2.68),('16100','2013-08-27','08:40:00',2.02),('16100','2013-08-27','08:50:00',1.23),('16100','2013-08-27','08:55:00',2),('16100','2013-08-27','09:00:00',3.08),('16100','2013-08-27','09:05:00',2.73),('16100','2013-08-27','09:10:00',1.69),('16100','2013-08-27','09:15:00',1.91),('16100','2013-08-27','09:20:00',2.55),('16100','2013-08-27','09:25:00',2.23),('16100','2013-08-27','09:30:00',2.16),('16100','2013-08-27','09:35:00',2.67),('16100','2013-08-27','09:40:00',4.85),('16100','2013-08-27','09:45:00',4.68),('16100','2013-08-27','09:50:00',4.66),('16100','2013-08-27','09:55:00',4.75),('16100','2013-08-27','10:00:00',4.89),('16100','2013-08-27','10:05:00',5.01),('16100','2013-08-27','10:10:00',4.88),('16100','2013-08-27','10:15:00',5.28),('16100','2013-08-27','10:20:00',5.47),('16100','2013-08-27','10:25:00',5.58),('16100','2013-08-27','10:30:00',3.08),('16100','2013-08-27','10:35:00',5.99),('16100','2013-08-27','10:40:00',6.16),('16100','2013-08-27','10:45:00',5.22),('16100','2013-08-27','10:50:00',3.64),('16100','2013-08-27','10:55:00',4.29),('16100','2013-08-27','11:00:00',6.39),('16100','2013-08-27','11:05:00',5.69),('16100','2013-08-27','11:10:00',2.97),('16100','2013-08-27','11:15:00',3.5),('16100','2013-08-27','11:20:00',3.06),('16100','2013-08-27','11:25:00',7.57),('16100','2013-08-27','11:30:00',7.69),('16100','2013-08-27','11:35:00',5.1),('16100','2013-08-27','11:40:00',6.5),('16100','2013-08-27','11:45:00',7.17),('16100','2013-08-27','11:50:00',7.94),('16100','2013-08-27','11:55:00',7.76),('16100','2013-08-27','12:00:00',2.96),('16100','2013-08-27','12:05:00',6.77),('16100','2013-08-27','12:10:00',5.08),('16100','2013-08-27','12:15:00',5.56),('16100','2013-08-27','12:20:00',6.45),('16100','2013-08-27','12:25:00',7.32),('16100','2013-08-27','12:30:00',7.67),('16100','2013-08-27','12:35:00',7.9),('16100','2013-08-27','12:40:00',3.73),('16100','2013-08-27','12:45:00',7.88),('16100','2013-08-27','12:50:00',7.82),('16100','2013-08-27','12:55:00',7.77),('16100','2013-08-27','13:00:00',7.74),('16100','2013-08-27','13:05:00',7.71),('16100','2013-08-27','13:10:00',7.61),('16100','2013-08-27','13:15:00',5.78),('16100','2013-08-27','13:20:00',7.84),('16100','2013-08-27','13:25:00',7.76),('16100','2013-08-27','13:30:00',6.4),('16100','2013-08-27','13:35:00',7.42),('16100','2013-08-27','13:40:00',5.17),('16100','2013-08-27','13:45:00',7.52),('16100','2013-08-27','13:50:00',7.63),('16100','2013-08-27','13:55:00',7.03),('16100','2013-08-27','14:00:00',7.69),('16100','2013-08-27','14:05:00',7.61),('16100','2013-08-27','14:10:00',7.49),('16100','2013-08-27','14:15:00',7.49),('16100','2013-08-27','14:20:00',7.48),('16100','2013-08-27','14:25:00',7.44),('16100','2013-08-27','14:30:00',7.42),('16100','2013-08-27','14:35:00',7.33),('16100','2013-08-27','14:40:00',7.26),('16100','2013-08-27','14:45:00',7.22),('16100','2013-08-27','14:50:00',7.11),('16100','2013-08-27','14:55:00',5.87),('16100','2013-08-27','15:00:00',7.15),('16100','2013-08-27','15:05:00',7.08),('16100','2013-08-27','15:10:00',5.88),('16100','2013-08-27','15:15:00',7),('16100','2013-08-27','15:20:00',6.68),('16100','2013-08-27','15:25:00',6.71),('16100','2013-08-27','15:30:00',6.71),('16100','2013-08-27','15:35:00',6.78),('16100','2013-08-27','15:40:00',5.02),('16100','2013-08-27','15:45:00',5.74),('16100','2013-08-27','15:50:00',4.81),('16100','2013-08-27','15:55:00',6.11),('16100','2013-08-27','16:00:00',6.05),('16100','2013-08-27','16:05:00',5.97),('16100','2013-08-27','16:10:00',5.76),('16100','2013-08-27','16:15:00',5.44),('16100','2013-08-27','16:20:00',5.43),('16100','2013-08-27','16:25:00',5.27),('16100','2013-08-27','16:30:00',5.09),('16100','2013-08-27','16:35:00',4.96),('16100','2013-08-27','16:40:00',4.84),('16100','2013-08-27','16:45:00',4.65),('16100','2013-08-27','16:50:00',3.08),('16100','2013-08-27','16:55:00',4.45),('16100','2013-08-27','17:00:00',4.21),('16100','2013-08-27','17:05:00',2.41),('16100','2013-08-27','17:10:00',3.01),('16100','2013-08-27','17:15:00',3.77),('16100','2013-08-27','17:20:00',1.89),('16100','2013-08-27','17:25:00',3.29),('16100','2013-08-27','17:30:00',3.63),('16100','2013-08-27','17:35:00',1.43),('16100','2013-08-27','17:40:00',1.85),('16100','2013-08-27','17:45:00',1.26),('16100','2013-08-27','17:50:00',1.36),('16100','2013-08-27','17:55:00',2.54),('16100','2013-08-27','18:00:00',1.38),('16100','2013-08-27','18:05:00',1.27),('16100','2013-08-27','18:10:00',1.61),('16100','2013-08-26','08:15:00',1.22),('16100','2013-08-26','08:20:00',1.58),('16100','2013-08-26','08:25:00',1.71),('16100','2013-08-26','08:30:00',1.57),('16100','2013-08-26','08:35:00',1.34),('16100','2013-08-26','08:40:00',1.51),('16100','2013-08-26','08:45:00',1.44),('16100','2013-08-26','08:50:00',2.03),('16100','2013-08-26','08:55:00',1.61),('16100','2013-08-26','09:00:00',1.54),('16100','2013-08-26','09:05:00',1.71),('16100','2013-08-26','09:10:00',2.96),('16100','2013-08-26','09:15:00',2.82),('16100','2013-08-26','09:20:00',3.06),('16100','2013-08-26','09:25:00',3.78),('16100','2013-08-26','09:30:00',4.12),('16100','2013-08-26','09:35:00',3.02),('16100','2013-08-26','09:40:00',2.52),('16100','2013-08-26','09:45:00',2.47),('16100','2013-08-26','09:50:00',3.04),('16100','2013-08-26','09:55:00',2.97),('16100','2013-08-26','10:00:00',3.88),('16100','2013-08-26','10:05:00',4.05),('16100','2013-08-26','10:10:00',5.19),('16100','2013-08-26','10:15:00',5.21),('16100','2013-08-26','10:20:00',5.26),('16100','2013-08-26','10:25:00',5.37),('16100','2013-08-26','10:30:00',5.46),('16100','2013-08-26','10:35:00',5.57),('16100','2013-08-26','10:40:00',5.7),('16100','2013-08-26','10:45:00',5.7),('16100','2013-08-26','10:50:00',5.91),('16100','2013-08-26','10:55:00',6.05),('16100','2013-08-26','11:00:00',6.04),('16100','2013-08-26','11:05:00',6.16),('16100','2013-08-26','11:10:00',6.14),('16100','2013-08-26','11:15:00',6.21),('16100','2013-08-26','11:20:00',6.28),('16100','2013-08-26','11:25:00',6.33),('16100','2013-08-26','11:30:00',5.89),('16100','2013-08-26','11:35:00',6.4),('16100','2013-08-26','11:40:00',5.87),('16100','2013-08-26','11:45:00',2.69),('16100','2013-08-26','11:50:00',4.13),('16100','2013-08-26','11:55:00',5.9),('16100','2013-08-26','12:00:00',3.16),('16100','2013-08-26','12:05:00',3.31),('16100','2013-08-26','12:10:00',5.05),('16100','2013-08-26','12:15:00',5.34),('16100','2013-08-26','12:20:00',6.91),('16100','2013-08-26','12:25:00',7.48),('16100','2013-08-26','12:30:00',7.27),('16100','2013-08-26','12:35:00',7.38),('16100','2013-08-26','12:40:00',7.77),('16100','2013-08-26','12:45:00',5.41),('16100','2013-08-26','12:50:00',5.15),('16100','2013-08-26','12:55:00',2.74),('16100','2013-08-26','13:00:00',2.45),('16100','2013-08-26','13:05:00',2.77),('16100','2013-08-26','13:10:00',3.3),('16100','2013-08-26','13:15:00',2.95),('16100','2013-08-26','13:20:00',4.25),('16100','2013-08-26','13:25:00',4.68),('16100','2013-08-26','13:30:00',4.19),('16100','2013-08-26','13:35:00',3.72),('16100','2013-08-26','13:40:00',3.46),('16100','2013-08-26','13:45:00',4.9),('16100','2013-08-26','13:50:00',4.52),('16100','2013-08-26','13:55:00',5.31),('16100','2013-08-26','14:00:00',4.93),('16100','2013-08-26','14:05:00',3.83),('16100','2013-08-26','14:10:00',5.79),('16100','2013-08-26','14:15:00',5.34),('16100','2013-08-26','14:20:00',4.15),('16100','2013-08-26','14:25:00',2.8),('16100','2013-08-26','14:30:00',2.02),('16100','2013-08-26','14:35:00',2.09),('16100','2013-08-26','14:40:00',2.27),('16100','2013-08-26','14:45:00',1.95),('16100','2013-08-26','14:50:00',1.51),('16100','2013-08-26','14:55:00',1.34),('16100','2013-08-26','15:00:00',1.47),('16100','2013-08-26','15:05:00',1.49),('16100','2013-08-26','15:10:00',1.34),('16100','2013-08-26','15:15:00',1.16),('16100','2013-08-26','16:00:00',1.19),('16100','2013-08-26','16:05:00',2.53),('16100','2013-08-26','16:10:00',5.28),('16100','2013-08-26','16:15:00',5.12),('16100','2013-08-26','16:20:00',2.73),('16100','2013-08-26','16:25:00',1.21),('16100','2013-08-26','16:30:00',2.89),('16100','2013-08-26','16:35:00',1.33),('16100','2013-08-26','16:40:00',1.56),('16100','2013-08-26','16:45:00',1.77),('16100','2013-08-26','16:50:00',1.84),('16100','2013-08-26','16:55:00',1.78),('16100','2013-08-26','17:00:00',1.7),('16100','2013-08-26','17:05:00',2.97),('16100','2013-08-26','17:10:00',1.84),('16100','2013-08-26','17:20:00',1.22),('16100','2013-08-26','17:25:00',1.1),('16100','2013-08-26','17:35:00',1.57),('16100','2013-08-26','17:40:00',1.23),('16100','2013-08-26','17:45:00',1.52),('16100','2013-08-26','17:50:00',1.27),('16100','2013-08-26','17:55:00',1.97),('16100','2013-08-26','18:00:00',1.68),('16100','2013-08-25','08:00:00',1.25),('16100','2013-08-25','08:05:00',1.12),('16100','2013-08-25','08:15:00',1.32),('16100','2013-08-25','08:20:00',1.34),('16100','2013-08-25','08:25:00',2.1),('16100','2013-08-25','08:30:00',2.07),('16100','2013-08-25','08:35:00',2.2),('16100','2013-08-25','08:40:00',2.44),('16100','2013-08-25','08:45:00',2.59),('16100','2013-08-25','08:50:00',2.78),('16100','2013-08-25','08:55:00',2.96),('16100','2013-08-25','09:00:00',3.11),('16100','2013-08-25','09:05:00',3.27),('16100','2013-08-25','09:10:00',3.47),('16100','2013-08-25','09:15:00',3.65),('16100','2013-08-25','09:20:00',3.77),('16100','2013-08-25','09:25:00',3.89),('16100','2013-08-25','09:30:00',4.03),('16100','2013-08-25','09:35:00',4.15),('16100','2013-08-25','09:40:00',4.35),('16100','2013-08-25','09:45:00',4.49),('16100','2013-08-25','09:50:00',4.54),('16100','2013-08-25','09:55:00',4.7),('16100','2013-08-25','10:00:00',4.85),('16100','2013-08-25','10:05:00',4.98),('16100','2013-08-25','10:10:00',5.08),('16100','2013-08-25','10:15:00',5.15),('16100','2013-08-25','10:20:00',5.35),('16100','2013-08-25','10:25:00',5.65),('16100','2013-08-25','10:30:00',5.57),('16100','2013-08-25','10:35:00',5.7),('16100','2013-08-25','10:40:00',5.83),('16100','2013-08-25','10:45:00',5.88),('16100','2013-08-25','10:50:00',5.96),('16100','2013-08-25','10:55:00',6.02),('16100','2013-08-25','11:00:00',6.12),('16100','2013-08-25','11:05:00',6.2),('16100','2013-08-25','11:10:00',6.35),('16100','2013-08-25','11:15:00',6.46),('16100','2013-08-25','11:20:00',6.54),('16100','2013-08-25','11:25:00',6.54),('16100','2013-08-25','11:30:00',6.64),('16100','2013-08-25','11:35:00',6.69),('16100','2013-08-25','11:40:00',6.78),('16100','2013-08-25','11:45:00',6.86),('16100','2013-08-25','11:50:00',6.92),('16100','2013-08-25','11:55:00',6.91),('16100','2013-08-25','12:00:00',6.92),('16100','2013-08-25','12:05:00',6.89),('16100','2013-08-25','12:10:00',6.95),('16100','2013-08-25','12:15:00',7.04),('16100','2013-08-25','12:20:00',7.1),('16100','2013-08-25','12:25:00',7.06),('16100','2013-08-25','12:30:00',7.11),('16100','2013-08-25','12:35:00',7.25),('16100','2013-08-25','12:40:00',6.76),('16100','2013-08-25','12:45:00',7.59),('16100','2013-08-25','12:50:00',7.52),('16100','2013-08-25','12:55:00',7.55),('16100','2013-08-25','13:00:00',5.62),('16100','2013-08-25','13:05:00',4.64),('16100','2013-08-25','13:10:00',3.17),('16100','2013-08-25','13:15:00',2.93),('16100','2013-08-25','13:20:00',4.12),('16100','2013-08-25','13:25:00',3.15),('16100','2013-08-25','13:30:00',4.55),('16100','2013-08-25','13:35:00',5.05),('16100','2013-08-25','13:40:00',6.84),('16100','2013-08-25','13:45:00',7.45),('16100','2013-08-25','13:50:00',4.3),('16100','2013-08-25','13:55:00',5.45),('16100','2013-08-25','14:00:00',5.49),('16100','2013-08-25','14:05:00',6.79),('16100','2013-08-25','14:10:00',4.83),('16100','2013-08-25','14:15:00',4.85),('16100','2013-08-25','14:20:00',7.02),('16100','2013-08-25','14:25:00',6.86),('16100','2013-08-25','14:30:00',6.95),('16100','2013-08-25','14:35:00',6.88),('16100','2013-08-25','14:40:00',6.92),('16100','2013-08-25','14:45:00',4.78),('16100','2013-08-25','14:50:00',4.55),('16100','2013-08-25','14:55:00',3.22),('16100','2013-08-25','15:00:00',3.46),('16100','2013-08-25','15:05:00',2.17),('16100','2013-08-25','15:10:00',1.83),('16100','2013-08-25','15:15:00',1.49),('16100','2013-08-25','15:20:00',1.3),('16100','2013-08-25','15:25:00',1.34),('16100','2013-08-25','15:30:00',1.44),('16100','2013-08-25','15:35:00',1.79),('16100','2013-08-25','15:40:00',3.28),('16100','2013-08-25','15:45:00',2.57),('16100','2013-08-25','15:50:00',2.53),('16100','2013-08-25','15:55:00',3.31),('16100','2013-08-25','16:00:00',5.06),('16100','2013-08-25','16:05:00',5.8),('16100','2013-08-25','16:10:00',4.96),('16100','2013-08-25','16:15:00',5.03),('16100','2013-08-25','16:20:00',4.9),('16100','2013-08-25','16:25:00',4.74),('16100','2013-08-25','16:30:00',4.63),('16100','2013-08-25','16:35:00',4.52),('16100','2013-08-25','16:40:00',4.41),('16100','2013-08-25','16:45:00',4.17),('16100','2013-08-25','16:50:00',4.11),('16100','2013-08-25','16:55:00',3.94),('16100','2013-08-25','17:00:00',3.34),('16100','2013-08-25','17:05:00',3.6),('16100','2013-08-25','17:10:00',3.47),('16100','2013-08-25','17:15:00',3.29),('16100','2013-08-25','17:20:00',2.3),('16100','2013-08-25','17:25:00',1.79),('16100','2013-08-25','17:30:00',2.26),('16100','2013-08-25','17:35:00',1.65),('16100','2013-08-25','17:40:00',1.48),('16100','2013-08-25','17:45:00',2.47),('16100','2013-08-25','17:50:00',2.53),('16100','2013-08-25','17:55:00',2.3),('16100','2013-08-25','18:00:00',1.95),('16100','2013-08-25','18:05:00',1.71),('16100','2013-08-25','18:10:00',1.54),('16100','2013-08-25','18:15:00',1.36),('16100','2013-08-25','18:20:00',1.22),('16100','2013-08-25','18:25:00',1.07),('16100','2013-08-24','08:00:00',1.11),('16100','2013-08-24','08:05:00',1.35),('16100','2013-08-24','08:10:00',1.45),('16100','2013-08-24','08:15:00',1.37),('16100','2013-08-24','08:20:00',1.6),('16100','2013-08-24','08:25:00',1.65),('16100','2013-08-24','08:30:00',1.89),('16100','2013-08-24','08:35:00',2.21),('16100','2013-08-24','08:40:00',1.93),('16100','2013-08-24','08:45:00',1.61),('16100','2013-08-24','08:50:00',1.65),('16100','2013-08-24','08:55:00',2.59),('16100','2013-08-24','09:00:00',3.15),('16100','2013-08-24','09:05:00',2.76),('16100','2013-08-24','09:10:00',2.91),('16100','2013-08-24','09:15:00',3.41),('16100','2013-08-24','09:20:00',3.23),('16100','2013-08-24','09:25:00',4.07),('16100','2013-08-24','09:30:00',4.34),('16100','2013-08-24','09:35:00',4.75),('16100','2013-08-24','09:40:00',5.19),('16100','2013-08-24','09:45:00',4.71),('16100','2013-08-24','09:50:00',5.34),('16100','2013-08-24','09:55:00',3.37),('16100','2013-08-24','10:00:00',2.01),('16100','2013-08-24','10:05:00',1.2),('16100','2013-08-24','15:00:00',1.31),('16100','2013-08-24','15:05:00',1.63),('16100','2013-08-24','15:10:00',1.76),('16100','2013-08-24','15:15:00',2.07),('16100','2013-08-24','15:20:00',2.72),('16100','2013-08-24','15:25:00',2.79),('16100','2013-08-24','15:30:00',6.22),('16100','2013-08-24','15:35:00',6.71),('16100','2013-08-24','15:40:00',4.87),('16100','2013-08-24','15:45:00',3.94),('16100','2013-08-24','15:50:00',5.76),('16100','2013-08-24','15:55:00',6.63),('16100','2013-08-24','16:00:00',6.18),('16100','2013-08-24','16:05:00',5.34),('16100','2013-08-24','16:10:00',5.35),('16100','2013-08-24','16:15:00',5.12),('16100','2013-08-24','16:20:00',5.11),('16100','2013-08-24','16:25:00',4.98),('16100','2013-08-24','16:30:00',4.81),('16100','2013-08-24','16:35:00',4.68),('16100','2013-08-24','16:40:00',3.45),('16100','2013-08-24','16:45:00',2.64),('16100','2013-08-24','16:50:00',4.86),('16100','2013-08-24','16:55:00',4.42),('16100','2013-08-24','17:00:00',4.22),('16100','2013-08-24','17:05:00',4.07),('16100','2013-08-24','17:10:00',3.18),('16100','2013-08-24','17:15:00',3.52),('16100','2013-08-24','17:20:00',3.31),('16100','2013-08-24','17:25:00',3.14),('16100','2013-08-24','17:30:00',2.77),('16100','2013-08-24','17:35:00',2.4),('16100','2013-08-24','17:40:00',2.59),('16100','2013-08-24','17:45:00',2.46),('16100','2013-08-24','17:50:00',2.23),('16100','2013-08-24','17:55:00',1.34),('16100','2013-08-24','18:00:00',1.65),('16100','2013-08-24','18:05:00',1.59),('16100','2013-08-24','18:10:00',1.78),('16100','2013-08-24','18:15:00',1.69),('16100','2013-08-24','18:20:00',1.47),('16100','2013-08-24','18:25:00',1.13),('16100','2013-08-23','08:10:00',1.14),('16100','2013-08-23','08:15:00',1.35),('16100','2013-08-23','08:20:00',1.54),('16100','2013-08-23','08:25:00',1.75),('16100','2013-08-23','08:30:00',1.91),('16100','2013-08-23','08:35:00',2.06),('16100','2013-08-23','08:40:00',2.22),('16100','2013-08-23','08:45:00',2.41),('16100','2013-08-23','08:50:00',2.61),('16100','2013-08-23','08:55:00',2.72),('16100','2013-08-23','09:00:00',2.92),('16100','2013-08-23','09:05:00',3.06),('16100','2013-08-23','09:10:00',3.21),('16100','2013-08-23','09:15:00',3.34),('16100','2013-08-23','09:20:00',3.53),('16100','2013-08-23','09:25:00',3.7),('16100','2013-08-23','09:30:00',3.85),('16100','2013-08-23','09:35:00',3.99),('16100','2013-08-23','09:40:00',4.15),('16100','2013-08-23','09:45:00',4.33),('16100','2013-08-23','09:50:00',4.46),('16100','2013-08-23','09:55:00',4.6),('16100','2013-08-23','10:00:00',4.73),('16100','2013-08-23','10:05:00',4.88),('16100','2013-08-23','10:10:00',4.98),('16100','2013-08-23','10:15:00',5.05),('16100','2013-08-23','10:20:00',5.2),('16100','2013-08-23','10:25:00',5.29),('16100','2013-08-23','10:30:00',5.47),('16100','2013-08-23','10:35:00',5.57),('16100','2013-08-23','10:40:00',5.69),('16100','2013-08-23','10:45:00',5.78),('16100','2013-08-23','10:50:00',5.91),('16100','2013-08-23','10:55:00',5.99),('16100','2013-08-23','11:00:00',6.03),('16100','2013-08-23','11:05:00',6.11),('16100','2013-08-23','11:10:00',6.3),('16100','2013-08-23','11:15:00',6.31),('16100','2013-08-23','11:20:00',6.35),('16100','2013-08-23','11:25:00',6.36),('16100','2013-08-23','11:30:00',6.51),('16100','2013-08-23','11:35:00',6.61),('16100','2013-08-23','11:40:00',6.67),('16100','2013-08-23','11:45:00',6.74),('16100','2013-08-23','11:50:00',6.77),('16100','2013-08-23','11:55:00',6.88),('16100','2013-08-23','12:00:00',6.83),('16100','2013-08-23','12:05:00',7),('16100','2013-08-23','12:10:00',6.9),('16100','2013-08-23','12:15:00',6.97),('16100','2013-08-23','12:20:00',7.08),('16100','2013-08-23','12:25:00',7.12),('16100','2013-08-23','12:30:00',7.15),('16100','2013-08-23','12:35:00',7.12),('16100','2013-08-23','12:40:00',7.08),('16100','2013-08-23','12:45:00',7.12),('16100','2013-08-23','12:50:00',7.15),('16100','2013-08-23','12:55:00',7.19),('16100','2013-08-23','13:00:00',7.15),('16100','2013-08-23','13:05:00',7.21),('16100','2013-08-23','13:10:00',7.21),('16100','2013-08-23','13:15:00',7.2),('16100','2013-08-23','13:20:00',7.28),('16100','2013-08-23','13:25:00',7.3),('16100','2013-08-23','13:30:00',7.32),('16100','2013-08-23','13:35:00',7.32),('16100','2013-08-23','13:40:00',7.27),('16100','2013-08-23','13:45:00',7.26),('16100','2013-08-23','13:50:00',7.26),('16100','2013-08-23','13:55:00',7.19),('16100','2013-08-23','14:00:00',7.16),('16100','2013-08-23','14:05:00',7.1),('16100','2013-08-23','14:10:00',7),('16100','2013-08-23','14:15:00',7),('16100','2013-08-23','14:20:00',6.95),('16100','2013-08-23','14:25:00',6.95),('16100','2013-08-23','14:30:00',6.9),('16100','2013-08-23','14:35:00',6.83),('16100','2013-08-23','14:40:00',6.77),('16100','2013-08-23','14:45:00',6.75),('16100','2013-08-23','14:50:00',6.69),('16100','2013-08-23','14:55:00',6.67),('16100','2013-08-23','15:00:00',6.61),('16100','2013-08-23','15:05:00',6.55),('16100','2013-08-23','15:10:00',6.46),('16100','2013-08-23','15:15:00',6.36),('16100','2013-08-23','15:20:00',6.24),('16100','2013-08-23','15:25:00',6.17),('16100','2013-08-23','15:30:00',6.03),('16100','2013-08-23','15:35:00',5.95),('16100','2013-08-23','15:40:00',5.84),('16100','2013-08-23','15:45:00',5.73),('16100','2013-08-23','15:50:00',5.68),('16100','2013-08-23','15:55:00',5.58),('16100','2013-08-23','16:00:00',5.49),('16100','2013-08-23','16:05:00',5.4),('16100','2013-08-23','16:10:00',5.28),('16100','2013-08-23','16:15:00',4.99),('16100','2013-08-23','16:20:00',5.01),('16100','2013-08-23','16:25:00',4.88),('16100','2013-08-23','16:30:00',4.76),('16100','2013-08-23','16:35:00',4.64),('16100','2013-08-23','16:40:00',4.52),('16100','2013-08-23','16:45:00',4.37),('16100','2013-08-23','16:50:00',4.25),('16100','2013-08-23','16:55:00',4.1),('16100','2013-08-23','17:00:00',3.93),('16100','2013-08-23','17:05:00',3.79),('16100','2013-08-23','17:10:00',3.65),('16100','2013-08-23','17:15:00',3.49),('16100','2013-08-23','17:20:00',3.33),('16100','2013-08-23','17:25:00',3.15),('16100','2013-08-23','17:30:00',3),('16100','2013-08-23','17:35:00',2.86),('16100','2013-08-23','17:40:00',2.69),('16100','2013-08-23','17:45:00',2.5),('16100','2013-08-23','17:50:00',2.35),('16100','2013-08-23','17:55:00',2.18),('16100','2013-08-23','18:00:00',2.02),('16100','2013-08-23','18:05:00',1.86),('16100','2013-08-23','18:10:00',1.72),('16100','2013-08-23','18:15:00',1.57),('16100','2013-08-23','18:20:00',1.41),('16100','2013-08-23','18:25:00',1.26),('16100','2013-08-23','18:30:00',1.11),('16100','2013-08-22','08:10:00',1.12),('16100','2013-08-22','08:15:00',1.28),('16100','2013-08-22','08:20:00',1.46),('16100','2013-08-22','08:25:00',1.66),('16100','2013-08-22','08:30:00',1.79),('16100','2013-08-22','08:35:00',1.96),('16100','2013-08-22','08:40:00',2.1),('16100','2013-08-22','08:45:00',2.28),('16100','2013-08-22','08:50:00',2.4),('16100','2013-08-22','08:55:00',2.61),('16100','2013-08-22','09:00:00',2.69),('16100','2013-08-22','09:05:00',2.83),('16100','2013-08-22','09:10:00',3.06),('16100','2013-08-22','09:15:00',3.14),('16100','2013-08-22','09:20:00',3.29),('16100','2013-08-22','09:25:00',3.44),('16100','2013-08-22','09:30:00',3.55),('16100','2013-08-22','09:35:00',3.68),('16100','2013-08-22','09:40:00',3.85),('16100','2013-08-22','09:45:00',3.98),('16100','2013-08-22','09:50:00',4.06),('16100','2013-08-22','09:55:00',4.17),('16100','2013-08-22','10:00:00',4.32),('16100','2013-08-22','10:05:00',4.48),('16100','2013-08-22','10:10:00',4.59),('16100','2013-08-22','10:15:00',4.68),('16100','2013-08-22','10:20:00',4.81),('16100','2013-08-22','10:25:00',4.95),('16100','2013-08-22','10:30:00',5.03),('16100','2013-08-22','10:35:00',5.09),('16100','2013-08-22','10:40:00',4.15),('16100','2013-08-22','10:45:00',5.21),('16100','2013-08-22','10:50:00',5.3),('16100','2013-08-22','10:55:00',5.27),('16100','2013-08-22','11:00:00',5.32),('16100','2013-08-22','11:05:00',5.02),('16100','2013-08-22','11:10:00',6.08),('16100','2013-08-22','11:15:00',6.06),('16100','2013-08-22','11:20:00',6.3),('16100','2013-08-22','11:25:00',6.4),('16100','2013-08-22','11:30:00',6.48),('16100','2013-08-22','11:35:00',3.86),('16100','2013-08-22','11:40:00',6.33),('16100','2013-08-22','11:45:00',6.42),('16100','2013-08-22','11:50:00',6.7),('16100','2013-08-22','11:55:00',6.94),('16100','2013-08-22','12:00:00',7.14),('16100','2013-08-22','12:05:00',5.18),('16100','2013-08-22','12:10:00',3.21),('16100','2013-08-22','12:15:00',2.09),('16100','2013-08-22','12:20:00',3.25),('16100','2013-08-22','12:25:00',7.67),('16100','2013-08-22','12:30:00',3.29),('16100','2013-08-22','12:35:00',3.68),('16100','2013-08-22','12:40:00',7.11),('16100','2013-08-22','12:45:00',7.37),('16100','2013-08-22','12:50:00',7.53),('16100','2013-08-22','12:55:00',7.28),('16100','2013-08-22','13:00:00',7.22),('16100','2013-08-22','13:05:00',7.28),('16100','2013-08-22','13:10:00',7.33),('16100','2013-08-22','13:15:00',7.24),('16100','2013-08-22','13:20:00',7.29),('16100','2013-08-22','13:25:00',7.22),('16100','2013-08-22','13:30:00',7.29),('16100','2013-08-22','13:35:00',7.3),('16100','2013-08-22','13:40:00',7.23),('16100','2013-08-22','13:45:00',7.21),('16100','2013-08-22','13:50:00',7.22),('16100','2013-08-22','13:55:00',7.22),('16100','2013-08-22','14:00:00',7.17),('16100','2013-08-22','14:05:00',7.08),('16100','2013-08-22','14:10:00',6.99),('16100','2013-08-22','14:15:00',7.01),('16100','2013-08-22','14:20:00',6.95),('16100','2013-08-22','14:25:00',6.92),('16100','2013-08-22','14:30:00',6.86),('16100','2013-08-22','14:35:00',6.82),('16100','2013-08-22','14:40:00',6.77),('16100','2013-08-22','14:45:00',6.72),('16100','2013-08-22','14:50:00',6.65),('16100','2013-08-22','14:55:00',6.25),('16100','2013-08-22','15:00:00',6.33),('16100','2013-08-22','15:05:00',6.29),('16100','2013-08-22','15:10:00',6.1),('16100','2013-08-22','15:15:00',5.22),('16100','2013-08-22','15:20:00',5.25),('16100','2013-08-22','15:25:00',6.01),('16100','2013-08-22','15:30:00',5.71),('16100','2013-08-22','15:35:00',5.96),('16100','2013-08-22','15:40:00',5.66),('16100','2013-08-22','15:45:00',5.18),('16100','2013-08-22','15:50:00',5.1),('16100','2013-08-22','15:55:00',5.02),('16100','2013-08-22','16:00:00',4.88),('16100','2013-08-22','16:05:00',4.88),('16100','2013-08-22','16:10:00',4.48),('16100','2013-08-22','16:15:00',4.32),('16100','2013-08-22','16:20:00',4.69),('16100','2013-08-22','16:25:00',4.44),('16100','2013-08-22','16:30:00',4.2),('16100','2013-08-22','16:35:00',4.58),('16100','2013-08-22','16:40:00',4.6),('16100','2013-08-22','16:45:00',4.47),('16100','2013-08-22','16:50:00',4.25),('16100','2013-08-22','16:55:00',4.03),('16100','2013-08-22','17:00:00',3.83),('16100','2013-08-22','17:05:00',3.7),('16100','2013-08-22','17:10:00',3.54),('16100','2013-08-22','17:15:00',3.42),('16100','2013-08-22','17:20:00',3.26),('16100','2013-08-22','17:25:00',3.06),('16100','2013-08-22','17:30:00',2.9),('16100','2013-08-22','17:35:00',2.75),('16100','2013-08-22','17:40:00',2.55),('16100','2013-08-22','17:45:00',2.44),('16100','2013-08-22','17:50:00',2.31),('16100','2013-08-22','17:55:00',1.54),('16100','2013-08-22','18:00:00',1.5),('16100','2013-08-22','18:05:00',1.85),('16100','2013-08-22','18:10:00',1.73),('16100','2013-08-22','18:15:00',1.55),('16100','2013-08-22','18:20:00',1.44),('16100','2013-08-22','18:25:00',1.31),('16100','2013-08-22','18:30:00',1.15),('16100','2013-08-22','18:35:00',1.02),('16100','2013-08-21','08:05:00',1.02),('16100','2013-08-21','08:10:00',1.16),('16100','2013-08-21','08:15:00',1.35),('16100','2013-08-21','08:20:00',1.54),('16100','2013-08-21','08:25:00',1.74),('16100','2013-08-21','08:30:00',1.87),('16100','2013-08-21','08:35:00',2.06),('16100','2013-08-21','08:40:00',2.25),('16100','2013-08-21','08:45:00',2.44),('16100','2013-08-21','08:50:00',2.65),('16100','2013-08-21','08:55:00',2.83),('16100','2013-08-21','09:00:00',2.92),('16100','2013-08-21','09:05:00',3.16),('16100','2013-08-21','09:10:00',3.29),('16100','2013-08-21','09:15:00',3.5),('16100','2013-08-21','09:20:00',3.69),('16100','2013-08-21','09:25:00',3.93),('16100','2013-08-21','09:30:00',4.08),('16100','2013-08-21','09:35:00',4.15),('16100','2013-08-21','09:40:00',4.22),('16100','2013-08-21','09:45:00',4.31),('16100','2013-08-21','09:50:00',4.45),('16100','2013-08-21','09:55:00',3.67),('16100','2013-08-21','10:00:00',2.75),('16100','2013-08-21','10:05:00',3.81),('16100','2013-08-21','10:10:00',4.33),('16100','2013-08-21','10:15:00',5.23),('16100','2013-08-21','10:20:00',5.04),('16100','2013-08-21','10:25:00',5.55),('16100','2013-08-21','10:30:00',5.68),('16100','2013-08-21','10:35:00',5.74),('16100','2013-08-21','10:40:00',5.76),('16100','2013-08-21','10:45:00',5.75),('16100','2013-08-21','10:50:00',5.83),('16100','2013-08-21','10:55:00',5.91),('16100','2013-08-21','11:00:00',5.95),('16100','2013-08-21','11:05:00',6.02),('16100','2013-08-21','11:10:00',6.16),('16100','2013-08-21','11:15:00',6.24),('16100','2013-08-21','11:20:00',6.34),('16100','2013-08-21','11:25:00',6.38),('16100','2013-08-21','11:30:00',6.44),('16100','2013-08-21','11:35:00',6.5),('16100','2013-08-21','11:40:00',6.53),('16100','2013-08-21','11:45:00',6.6),('16100','2013-08-21','11:50:00',6.61),('16100','2013-08-21','11:55:00',6.65),('16100','2013-08-21','12:00:00',6.68),('16100','2013-08-21','12:05:00',6.73),('16100','2013-08-21','12:10:00',6.77),('16100','2013-08-21','12:15:00',6.77),('16100','2013-08-21','12:20:00',6.77),('16100','2013-08-21','12:25:00',6.84),('16100','2013-08-21','12:30:00',6.84),('16100','2013-08-21','12:35:00',6.84),('16100','2013-08-21','12:40:00',6.87),('16100','2013-08-21','12:45:00',6.83),('16100','2013-08-21','12:50:00',6.84),('16100','2013-08-21','12:55:00',6.91),('16100','2013-08-21','13:00:00',6.88),('16100','2013-08-21','13:05:00',6.86),('16100','2013-08-21','13:10:00',6.87),('16100','2013-08-21','13:15:00',6.87),('16100','2013-08-21','13:20:00',6.84),('16100','2013-08-21','13:25:00',6.78),('16100','2013-08-21','13:30:00',6.76),('16100','2013-08-21','13:35:00',6.76),('16100','2013-08-21','13:40:00',6.77),('16100','2013-08-21','13:45:00',6.64),('16100','2013-08-21','13:50:00',6.68),('16100','2013-08-21','13:55:00',6.69),('16100','2013-08-21','14:00:00',6.75),('16100','2013-08-21','14:05:00',6.79),('16100','2013-08-21','14:10:00',6.66),('16100','2013-08-21','14:15:00',6.67),('16100','2013-08-21','14:20:00',6.67),('16100','2013-08-21','14:25:00',6.57),('16100','2013-08-21','14:30:00',6.56),('16100','2013-08-21','14:35:00',6.55),('16100','2013-08-21','14:40:00',6.47),('16100','2013-08-21','14:45:00',6.21),('16100','2013-08-21','14:50:00',4.59),('16100','2013-08-21','14:55:00',6.27),('16100','2013-08-21','15:00:00',4.18),('16100','2013-08-21','15:05:00',5.71),('16100','2013-08-21','15:10:00',6.13),('16100','2013-08-21','15:15:00',6.11),('16100','2013-08-21','15:20:00',6.01),('16100','2013-08-21','15:25:00',5.93),('16100','2013-08-21','15:30:00',5.81),('16100','2013-08-21','15:35:00',5.72),('16100','2013-08-21','15:40:00',5.64),('16100','2013-08-21','15:45:00',5.52),('16100','2013-08-21','15:50:00',5.46),('16100','2013-08-21','15:55:00',5.35),('16100','2013-08-21','16:00:00',5.26),('16100','2013-08-21','16:05:00',5.15),('16100','2013-08-21','16:10:00',5.02),('16100','2013-08-21','16:15:00',4.81),('16100','2013-08-21','16:20:00',4.73),('16100','2013-08-21','16:25:00',4.64),('16100','2013-08-21','16:30:00',4.55),('16100','2013-08-21','16:35:00',4.36),('16100','2013-08-21','16:40:00',4.18),('16100','2013-08-21','16:45:00',4.03),('16100','2013-08-21','16:50:00',3.94),('16100','2013-08-21','16:55:00',3.84),('16100','2013-08-21','17:00:00',3.65),('16100','2013-08-21','17:05:00',3.5),('16100','2013-08-21','17:10:00',3.34),('16100','2013-08-21','17:15:00',3.25),('16100','2013-08-21','17:20:00',3.09),('16100','2013-08-21','17:25:00',2.91),('16100','2013-08-21','17:30:00',2.75),('16100','2013-08-21','17:35:00',2.61),('16100','2013-08-21','17:40:00',2.45),('16100','2013-08-21','17:45:00',2.27),('16100','2013-08-21','17:50:00',2.14),('16100','2013-08-21','17:55:00',2.03),('16100','2013-08-21','18:00:00',1.88),('16100','2013-08-21','18:05:00',1.74),('16100','2013-08-21','18:10:00',1.63),('16100','2013-08-21','18:15:00',1.55),('16100','2013-08-21','18:20:00',1.39),('16100','2013-08-21','18:25:00',1.22),('16100','2013-08-21','18:30:00',1),('16100','2013-08-20','08:30:00',1.18),('16100','2013-08-20','08:35:00',1.25),('16100','2013-08-20','08:40:00',1.37),('16100','2013-08-20','08:45:00',1.13),('16100','2013-08-20','08:50:00',1.08),('16100','2013-08-20','08:55:00',1.08),('16100','2013-08-20','09:00:00',1.19),('16100','2013-08-20','09:05:00',1.37),('16100','2013-08-20','09:10:00',1.91),('16100','2013-08-20','09:15:00',2.18),('16100','2013-08-20','09:20:00',3.28),('16100','2013-08-20','09:25:00',3.42),('16100','2013-08-20','09:30:00',1.67),('16100','2013-08-20','09:35:00',1.14),('16100','2013-08-20','09:40:00',1.15),('16100','2013-08-20','09:45:00',1.48),('16100','2013-08-20','09:50:00',1.66),('16100','2013-08-20','09:55:00',2.2),('16100','2013-08-20','10:00:00',3.46),('16100','2013-08-20','10:05:00',5.45),('16100','2013-08-20','10:10:00',5.24),('16100','2013-08-20','10:15:00',5.03),('16100','2013-08-20','10:20:00',5.24),('16100','2013-08-20','10:25:00',5.52),('16100','2013-08-20','10:30:00',4.61),('16100','2013-08-20','10:35:00',5.55),('16100','2013-08-20','10:40:00',5.64),('16100','2013-08-20','10:45:00',6.03),('16100','2013-08-20','10:50:00',5.65),('16100','2013-08-20','10:55:00',6.4),('16100','2013-08-20','11:00:00',5.35),('16100','2013-08-20','11:05:00',4.07),('16100','2013-08-20','11:10:00',4.31),('16100','2013-08-20','11:15:00',2.75),('16100','2013-08-20','11:20:00',3.03),('16100','2013-08-20','11:25:00',5.3),('16100','2013-08-20','11:30:00',8.27),('16100','2013-08-20','11:35:00',6.01),('16100','2013-08-20','11:40:00',7.5),('16100','2013-08-20','11:45:00',7.13),('16100','2013-08-20','11:50:00',6.81),('16100','2013-08-20','11:55:00',7.12),('16100','2013-08-20','12:00:00',6.77),('16100','2013-08-20','12:05:00',7.1),('16100','2013-08-20','12:10:00',7.12),('16100','2013-08-20','12:15:00',7.15),('16100','2013-08-20','12:20:00',7.19),('16100','2013-08-20','12:25:00',7.02),('16100','2013-08-20','12:30:00',7.27),('16100','2013-08-20','12:35:00',6.95),('16100','2013-08-20','12:40:00',6.54),('16100','2013-08-20','12:45:00',5.5),('16100','2013-08-20','12:50:00',6.58),('16100','2013-08-20','12:55:00',6.94),('16100','2013-08-20','13:00:00',6.7),('16100','2013-08-20','13:05:00',6.63),('16100','2013-08-20','13:10:00',6.77),('16100','2013-08-20','13:15:00',7.09),('16100','2013-08-20','13:20:00',7.21),('16100','2013-08-20','13:25:00',7.09),('16100','2013-08-20','13:30:00',7),('16100','2013-08-20','13:35:00',6.98),('16100','2013-08-20','13:40:00',6.93),('16100','2013-08-20','13:45:00',7.08),('16100','2013-08-20','13:50:00',7.04),('16100','2013-08-20','13:55:00',7.12),('16100','2013-08-20','14:00:00',7.18),('16100','2013-08-20','14:05:00',7.11),('16100','2013-08-20','14:10:00',6.88),('16100','2013-08-20','14:15:00',5.91),('16100','2013-08-20','14:20:00',4.03),('16100','2013-08-20','14:25:00',5.58),('16100','2013-08-20','14:30:00',4.28),('16100','2013-08-20','14:35:00',5.95),('16100','2013-08-20','14:40:00',6.31),('16100','2013-08-20','14:45:00',6.18),('16100','2013-08-20','14:50:00',6.18),('16100','2013-08-20','14:55:00',5.89),('16100','2013-08-20','15:00:00',6.23),('16100','2013-08-20','15:05:00',6.32),('16100','2013-08-20','15:10:00',6.27),('16100','2013-08-20','15:15:00',6.19),('16100','2013-08-20','15:20:00',5.84),('16100','2013-08-20','15:25:00',5.6),('16100','2013-08-20','15:30:00',5.24),('16100','2013-08-20','15:35:00',5.19),('16100','2013-08-20','15:40:00',5.28),('16100','2013-08-20','15:45:00',5.01),('16100','2013-08-20','15:50:00',5.04),('16100','2013-08-20','15:55:00',4.88),('16100','2013-08-20','16:00:00',4.72),('16100','2013-08-20','16:05:00',4.51),('16100','2013-08-20','16:10:00',4.63),('16100','2013-08-20','16:15:00',4.93),('16100','2013-08-20','16:20:00',4.77),('16100','2013-08-20','16:25:00',4.83),('16100','2013-08-20','16:30:00',4.74),('16100','2013-08-20','16:35:00',4.66),('16100','2013-08-20','16:40:00',4.51),('16100','2013-08-20','16:45:00',4.33),('16100','2013-08-20','16:50:00',4.27),('16100','2013-08-20','16:55:00',4.17),('16100','2013-08-20','17:00:00',4.08),('16100','2013-08-20','17:05:00',3.88),('16100','2013-08-20','17:10:00',3.81),('16100','2013-08-20','17:15:00',3.67),('16100','2013-08-20','17:20:00',3.51),('16100','2013-08-20','17:25:00',3.39),('16100','2013-08-20','17:30:00',3.25),('16100','2013-08-20','17:35:00',3.1),('16100','2013-08-20','17:40:00',3.02),('16100','2013-08-20','17:45:00',2.89),('16100','2013-08-20','17:50:00',2.71),('16100','2013-08-20','17:55:00',2.54),('16100','2013-08-20','18:00:00',2.35),('16100','2013-08-20','18:05:00',2.21),('16100','2013-08-20','18:10:00',2.04),('16100','2013-08-20','18:15:00',1.91),('16100','2013-08-20','18:20:00',1.75),('16100','2013-08-20','18:25:00',1.44),('16100','2013-08-20','18:30:00',1.29),('16100','2013-08-20','18:35:00',1.18),('16100','2013-08-20','18:40:00',1.04),('16100','2013-08-19','07:50:00',1.19),('16100','2013-08-19','07:55:00',1.24),('16100','2013-08-19','08:00:00',1.1),('16100','2013-08-19','08:30:00',1.05),('16100','2013-08-19','08:35:00',1.1),('16100','2013-08-19','08:40:00',1.15),('16100','2013-08-19','08:45:00',1.3),('16100','2013-08-19','08:50:00',1.6),('16100','2013-08-19','08:55:00',1.69),('16100','2013-08-19','09:00:00',1.26),('16100','2013-08-19','09:10:00',1.19),('16100','2013-08-19','09:15:00',1.4),('16100','2013-08-19','09:20:00',2.75),('16100','2013-08-19','09:25:00',2.48),('16100','2013-08-19','09:30:00',4.32),('16100','2013-08-19','09:35:00',4.7),('16100','2013-08-19','09:40:00',3.62),('16100','2013-08-19','09:45:00',1.83),('16100','2013-08-19','09:50:00',1.1),('16100','2013-08-19','09:55:00',1.2),('16100','2013-08-19','10:00:00',2.48),('16100','2013-08-19','10:05:00',4),('16100','2013-08-19','10:10:00',2.13),('16100','2013-08-19','10:15:00',1.36),('16100','2013-08-19','10:20:00',1.65),('16100','2013-08-19','10:25:00',2.87),('16100','2013-08-19','10:30:00',3.04),('16100','2013-08-19','10:35:00',4.88),('16100','2013-08-19','10:40:00',6.77),('16100','2013-08-19','10:45:00',4.45),('16100','2013-08-19','11:00:00',1.64),('16100','2013-08-19','11:05:00',6.98),('16100','2013-08-19','11:10:00',7.06),('16100','2013-08-19','11:15:00',3.25),('16100','2013-08-19','11:20:00',5.33),('16100','2013-08-19','11:25:00',7.62),('16100','2013-08-19','11:30:00',6.07),('16100','2013-08-19','11:35:00',8.05),('16100','2013-08-19','11:40:00',7.16),('16100','2013-08-19','11:45:00',4.4),('16100','2013-08-19','11:50:00',3.51),('16100','2013-08-19','11:55:00',3.35),('16100','2013-08-19','12:00:00',3.07),('16100','2013-08-19','12:05:00',2.39),('16100','2013-08-19','12:10:00',2.41),('16100','2013-08-19','12:15:00',2.43),('16100','2013-08-19','12:20:00',2.43),('16100','2013-08-19','12:25:00',2.7),('16100','2013-08-19','12:30:00',3.02),('16100','2013-08-19','12:35:00',3.4),('16100','2013-08-19','12:40:00',6.42),('16100','2013-08-19','12:45:00',3.2),('16100','2013-08-19','12:50:00',4.64),('16100','2013-08-19','12:55:00',6.75),('16100','2013-08-19','13:00:00',3.14),('16100','2013-08-19','13:05:00',2.46),('16100','2013-08-19','13:10:00',2.58),('16100','2013-08-19','13:15:00',3.01),('16100','2013-08-19','13:20:00',2.87),('16100','2013-08-19','13:25:00',2.9),('16100','2013-08-19','13:30:00',3.38),('16100','2013-08-19','13:35:00',3.71),('16100','2013-08-19','13:40:00',3.91),('16100','2013-08-19','13:45:00',6.54),('16100','2013-08-19','13:50:00',7.68),('16100','2013-08-19','13:55:00',7.58),('16100','2013-08-19','14:00:00',7.51),('16100','2013-08-19','14:05:00',7.6),('16100','2013-08-19','14:10:00',7.21),('16100','2013-08-19','14:15:00',7.37),('16100','2013-08-19','14:20:00',3.8),('16100','2013-08-19','14:25:00',4.54),('16100','2013-08-19','14:30:00',5.8),('16100','2013-08-19','14:35:00',7.28),('16100','2013-08-19','14:40:00',7.71),('16100','2013-08-19','14:45:00',7.42),('16100','2013-08-19','14:50:00',5.26),('16100','2013-08-19','14:55:00',3.59),('16100','2013-08-19','15:00:00',7.31),('16100','2013-08-19','15:05:00',6.95),('16100','2013-08-19','15:10:00',6.9),('16100','2013-08-19','15:15:00',6.99),('16100','2013-08-19','15:20:00',7.07),('16100','2013-08-19','15:25:00',6.35),('16100','2013-08-19','15:30:00',5.81),('16100','2013-08-19','15:35:00',1.97),('16100','2013-08-19','15:40:00',4),('16100','2013-08-19','15:45:00',6.48),('16100','2013-08-19','15:50:00',6.44),('16100','2013-08-19','15:55:00',6.55),('16100','2013-08-19','16:00:00',6.42),('16100','2013-08-19','16:05:00',6.31),('16100','2013-08-19','16:10:00',6.36),('16100','2013-08-19','16:15:00',6.38),('16100','2013-08-19','16:20:00',6.27),('16100','2013-08-19','16:25:00',5.86),('16100','2013-08-19','16:30:00',5.5),('16100','2013-08-19','16:35:00',3.54),('16100','2013-08-19','16:40:00',4.81),('16100','2013-08-19','16:45:00',4.4),('16100','2013-08-19','16:50:00',4.17),('16100','2013-08-19','16:55:00',4.39),('16100','2013-08-19','17:00:00',4.28),('16100','2013-08-19','17:05:00',4.05),('16100','2013-08-19','17:10:00',3.88),('16100','2013-08-19','17:15:00',3.71),('16100','2013-08-19','17:20:00',3.56),('16100','2013-08-19','17:25:00',2.79),('16100','2013-08-19','17:30:00',3.24),('16100','2013-08-19','17:35:00',3.2),('16100','2013-08-19','17:40:00',3.05),('16100','2013-08-19','17:45:00',2.71),('16100','2013-08-19','17:50:00',2.44),('16100','2013-08-19','17:55:00',2.28),('16100','2013-08-19','18:00:00',2.17),('16100','2013-08-19','18:05:00',2.05),('16100','2013-08-19','18:10:00',1.96),('16100','2013-08-19','18:15:00',1.79),('16100','2013-08-19','18:20:00',1.67),('16100','2013-08-19','18:25:00',1.63),('16100','2013-08-19','18:30:00',1.54),('16100','2013-08-19','18:35:00',1.36),('16100','2013-08-19','18:40:00',1.29),('16100','2013-08-19','18:45:00',1.18),('16100','2013-08-19','18:50:00',1.06),('16100','2013-08-19','18:55:00',1.03),('16100','2014-04-09','08:05:00',1.12),('16100','2014-04-09','08:10:00',1.37),('16100','2014-04-09','08:15:00',1.56),('16100','2014-04-09','08:20:00',1.76),('16100','2014-04-09','08:25:00',1.95),('16100','2014-04-09','08:30:00',2.13),('16100','2014-04-09','08:35:00',2.32),('16100','2014-04-09','08:40:00',2.53),('16100','2014-04-09','08:45:00',2.71),('16100','2014-04-09','08:50:00',2.88),('16100','2014-04-09','08:55:00',3.04),('16100','2014-04-09','09:00:00',3.25),('16100','2014-04-09','09:05:00',3.43),('16100','2014-04-09','09:10:00',3.57),('16100','2014-04-09','09:15:00',3.66),('16100','2014-04-09','09:20:00',3.88),('16100','2014-04-09','09:25:00',4.12),('16100','2014-04-09','09:30:00',4.25),('16100','2014-04-09','09:35:00',4.38),('16100','2014-04-09','09:40:00',4.46),('16100','2014-04-09','09:45:00',4.67),('16100','2014-04-09','09:50:00',4.83),('16100','2014-04-09','09:55:00',4.96),('16100','2014-04-09','10:00:00',5.07),('16100','2014-04-09','10:05:00',5.18),('16100','2014-04-09','10:10:00',5.28),('16100','2014-04-09','10:15:00',5.32),('16100','2014-04-09','10:20:00',5.54),('16100','2014-04-09','10:25:00',5.69),('16100','2014-04-09','10:30:00',5.88),('16100','2014-04-09','10:35:00',6.12),('16100','2014-04-09','10:40:00',6.11),('16100','2014-04-09','10:45:00',6.16),('16100','2014-04-09','10:50:00',6.13),('16100','2014-04-09','10:55:00',6.29),('16100','2014-04-09','11:00:00',6.58),('16100','2014-04-09','11:05:00',6.44),('16100','2014-04-09','11:10:00',6.67),('16100','2014-04-09','11:15:00',6.75),('16100','2014-04-09','11:20:00',7.11),('16100','2014-04-09','11:25:00',7.17),('16100','2014-04-09','11:30:00',7.18),('16100','2014-04-09','11:35:00',7.14),('16100','2014-04-09','11:40:00',7.22),('16100','2014-04-09','11:45:00',7.22),('16100','2014-04-09','11:50:00',7.17),('16100','2014-04-09','11:55:00',7.26),('16100','2014-04-09','12:00:00',6.96),('16100','2014-04-09','12:05:00',6.87),('16100','2014-04-09','12:10:00',7.33),('16100','2014-04-09','12:15:00',7.31),('16100','2014-04-09','12:20:00',7.12),('16100','2014-04-09','12:25:00',6.86),('16100','2014-04-09','12:30:00',7.27),('16100','2014-04-09','12:35:00',7.43),('16100','2014-04-09','12:40:00',7.09),('16100','2014-04-09','12:45:00',7.22),('16100','2014-04-09','12:50:00',7.25),('16100','2014-04-09','12:55:00',7.42),('16100','2014-04-09','13:00:00',6.86),('16100','2014-04-09','13:05:00',7.1),('16100','2014-04-09','13:10:00',7.66),('16100','2014-04-09','13:15:00',7.24),('16100','2014-04-09','13:20:00',7),('16100','2014-04-09','13:25:00',7.37),('16100','2014-04-09','13:30:00',7.67),('16100','2014-04-09','13:35:00',7.61),('16100','2014-04-09','13:40:00',7.29),('16100','2014-04-09','13:45:00',7.59),('16100','2014-04-09','13:50:00',7.5),('16100','2014-04-09','13:55:00',7.45),('16100','2014-04-09','14:00:00',7.4),('16100','2014-04-09','14:05:00',7.15),('16100','2014-04-09','14:10:00',7.2),('16100','2014-04-09','14:15:00',7.29),('16100','2014-04-09','14:20:00',7.26),('16100','2014-04-09','14:25:00',7.15),('16100','2014-04-09','14:30:00',7.09),('16100','2014-04-09','14:35:00',7.06),('16100','2014-04-09','14:40:00',6.87),('16100','2014-04-09','14:45:00',6.27),('16100','2014-04-09','14:50:00',6.99),('16100','2014-04-09','14:55:00',6.84),('16100','2014-04-09','15:00:00',6.75),('16100','2014-04-09','15:05:00',6.72),('16100','2014-04-09','15:10:00',6.47),('16100','2014-04-09','15:15:00',6.48),('16100','2014-04-09','15:20:00',6.31),('16100','2014-04-09','15:25:00',6.18),('16100','2014-04-09','15:30:00',5.71),('16100','2014-04-09','15:35:00',5.4),('16100','2014-04-09','15:40:00',5.77),('16100','2014-04-09','15:45:00',5.69),('16100','2014-04-09','15:50:00',5.55),('16100','2014-04-09','15:55:00',5.76),('16100','2014-04-09','16:00:00',5.75),('16100','2014-04-09','16:05:00',5.77),('16100','2014-04-09','16:10:00',5.74),('16100','2014-04-09','16:15:00',5.58),('16100','2014-04-09','16:20:00',5.14),('16100','2014-04-09','16:25:00',5.26),('16100','2014-04-09','16:30:00',5.22),('16100','2014-04-09','16:35:00',4.91),('16100','2014-04-09','16:40:00',4.93),('16100','2014-04-09','16:45:00',4.61),('16100','2014-04-09','16:50:00',4.6),('16100','2014-04-09','16:55:00',4.36),('16100','2014-04-09','17:00:00',4.15),('16100','2014-04-09','17:05:00',4.11),('16100','2014-04-09','17:10:00',3.87),('16100','2014-04-09','17:15:00',3.72),('16100','2014-04-09','17:20:00',3.53),('16100','2014-04-09','17:25:00',3.32),('16100','2014-04-09','17:30:00',3.13),('16100','2014-04-09','17:35:00',2.94),('16100','2014-04-09','17:40:00',2.74),('16100','2014-04-09','17:45:00',2.57),('16100','2014-04-09','17:50:00',2.39),('16100','2014-04-09','17:55:00',2.22),('16100','2014-04-09','18:00:00',2.05),('16100','2014-04-09','18:05:00',1.88),('16100','2014-04-09','18:10:00',1.7),('16100','2014-04-09','18:15:00',1.53),('16100','2014-04-09','18:20:00',1.36),('16100','2014-04-09','18:25:00',1.19),('16100','2014-04-09','18:30:00',1.02),('16100','2013-08-18','07:55:00',1.02),('16100','2013-08-18','08:00:00',1.24),('16100','2013-08-18','08:05:00',1.27),('16100','2013-08-18','08:10:00',1.14),('16100','2013-08-18','08:15:00',1.26),('16100','2013-08-18','08:20:00',1.59),('16100','2013-08-18','08:25:00',1.78),('16100','2013-08-18','08:30:00',2.03),('16100','2013-08-18','08:35:00',2.24),('16100','2013-08-18','08:40:00',2.36),('16100','2013-08-18','08:45:00',2.55),('16100','2013-08-18','08:50:00',2.74),('16100','2013-08-18','08:55:00',2.9),('16100','2013-08-18','09:00:00',3.08),('16100','2013-08-18','09:05:00',3.21),('16100','2013-08-18','09:10:00',3.36),('16100','2013-08-18','09:15:00',3.53),('16100','2013-08-18','09:20:00',3.7),('16100','2013-08-18','09:25:00',3.83),('16100','2013-08-18','09:30:00',3.97),('16100','2013-08-18','09:35:00',4.13),('16100','2013-08-18','09:40:00',4.27),('16100','2013-08-18','09:45:00',4.38),('16100','2013-08-18','09:50:00',4.49),('16100','2013-08-18','09:55:00',4.62),('16100','2013-08-18','10:00:00',4.74),('16100','2013-08-18','10:05:00',4.82),('16100','2013-08-18','10:10:00',4.95),('16100','2013-08-18','10:15:00',5.05),('16100','2013-08-18','10:20:00',5.14),('16100','2013-08-18','10:25:00',5.29),('16100','2013-08-18','10:30:00',5.45),('16100','2013-08-18','10:35:00',5.55),('16100','2013-08-18','10:40:00',5.67),('16100','2013-08-18','10:45:00',5.75),('16100','2013-08-18','10:50:00',5.84),('16100','2013-08-18','10:55:00',5.88),('16100','2013-08-18','11:00:00',6),('16100','2013-08-18','11:05:00',6.1),('16100','2013-08-18','11:10:00',6.19),('16100','2013-08-18','11:15:00',5.09),('16100','2013-08-18','11:20:00',6.23),('16100','2013-08-18','11:25:00',6.42),('16100','2013-08-18','11:30:00',6.49),('16100','2013-08-18','11:35:00',6.55),('16100','2013-08-18','11:40:00',6.52),('16100','2013-08-18','11:45:00',6.56),('16100','2013-08-18','11:50:00',6.62),('16100','2013-08-18','11:55:00',6.7),('16100','2013-08-18','12:00:00',6.71),('16100','2013-08-18','12:05:00',6.74),('16100','2013-08-18','12:10:00',6.92),('16100','2013-08-18','12:15:00',7.05),('16100','2013-08-18','12:20:00',7.04),('16100','2013-08-18','12:25:00',6.95),('16100','2013-08-18','12:30:00',6.93),('16100','2013-08-18','12:35:00',7.1),('16100','2013-08-18','12:40:00',7.2),('16100','2013-08-18','12:45:00',7.19),('16100','2013-08-18','12:50:00',7.25),('16100','2013-08-18','12:55:00',7.23),('16100','2013-08-18','13:00:00',7.26),('16100','2013-08-18','13:05:00',7.31),('16100','2013-08-18','13:10:00',7.33),('16100','2013-08-18','13:15:00',7.38),('16100','2013-08-18','13:20:00',7.4),('16100','2013-08-18','13:25:00',7.42),('16100','2013-08-18','13:30:00',7.38),('16100','2013-08-18','13:35:00',7.31),('16100','2013-08-18','13:40:00',7.33),('16100','2013-08-18','13:45:00',7.33),('16100','2013-08-18','13:50:00',7.27),('16100','2013-08-18','13:55:00',7.25),('16100','2013-08-18','14:00:00',7.22),('16100','2013-08-18','14:05:00',7.19),('16100','2013-08-18','14:10:00',7.07),('16100','2013-08-18','14:15:00',7.09),('16100','2013-08-18','14:20:00',7.11),('16100','2013-08-18','14:25:00',7),('16100','2013-08-18','14:30:00',6.85),('16100','2013-08-18','14:35:00',6.93),('16100','2013-08-18','14:40:00',6.85),('16100','2013-08-18','14:45:00',6.8),('16100','2013-08-18','14:50:00',6.83),('16100','2013-08-18','14:55:00',6.74),('16100','2013-08-18','15:00:00',6.68),('16100','2013-08-18','15:05:00',6.63),('16100','2013-08-18','15:10:00',6.59),('16100','2013-08-18','15:15:00',6.54),('16100','2013-08-18','15:20:00',6.4),('16100','2013-08-18','15:25:00',6.28),('16100','2013-08-18','15:30:00',6.2),('16100','2013-08-18','15:35:00',6.14),('16100','2013-08-18','15:40:00',6.06),('16100','2013-08-18','15:45:00',5.98),('16100','2013-08-18','15:50:00',5.89),('16100','2013-08-18','15:55:00',5.78),('16100','2013-08-18','16:00:00',5.64),('16100','2013-08-18','16:05:00',5.54),('16100','2013-08-18','16:10:00',5.41),('16100','2013-08-18','16:15:00',5.26),('16100','2013-08-18','16:20:00',5.09),('16100','2013-08-18','16:25:00',5.06),('16100','2013-08-18','16:30:00',4.92),('16100','2013-08-18','16:35:00',4.81),('16100','2013-08-18','16:40:00',4.7),('16100','2013-08-18','16:45:00',4.56),('16100','2013-08-18','16:50:00',4.42),('16100','2013-08-18','16:55:00',4.29),('16100','2013-08-18','17:00:00',4.13),('16100','2013-08-18','17:05:00',3.96),('16100','2013-08-18','17:10:00',3.81),('16100','2013-08-18','17:15:00',3.67),('16100','2013-08-18','17:20:00',3.52),('16100','2013-08-18','17:25:00',3.36),('16100','2013-08-18','17:30:00',3.21),('16100','2013-08-18','17:35:00',3.05),('16100','2013-08-18','17:40:00',2.89),('16100','2013-08-18','17:45:00',2.74),('16100','2013-08-18','17:50:00',2.58),('16100','2013-08-18','17:55:00',2.41),('16100','2013-08-18','18:00:00',2.26),('16100','2013-08-18','18:05:00',2.11),('16100','2013-08-18','18:10:00',1.94),('16100','2013-08-18','18:15:00',1.78),('16100','2013-08-18','18:20:00',1.62),('16100','2013-08-18','18:25:00',1.46),('16100','2013-08-18','18:30:00',1.31),('16100','2013-08-18','18:35:00',1.15),('16100','2013-08-17','08:05:00',1.07),('16100','2013-08-17','08:10:00',1.24),('16100','2013-08-17','08:15:00',1.39),('16100','2013-08-17','08:20:00',1.6),('16100','2013-08-17','08:25:00',1.83),('16100','2013-08-17','08:30:00',2.06),('16100','2013-08-17','08:35:00',2.3),('16100','2013-08-17','08:40:00',2.46),('16100','2013-08-17','08:45:00',2.62),('16100','2013-08-17','08:50:00',2.81),('16100','2013-08-17','08:55:00',2.95),('16100','2013-08-17','09:00:00',3.1),('16100','2013-08-17','09:05:00',3.27),('16100','2013-08-17','09:10:00',3.47),('16100','2013-08-17','09:15:00',3.63),('16100','2013-08-17','09:20:00',3.78),('16100','2013-08-17','09:25:00',3.91),('16100','2013-08-17','09:30:00',4.03),('16100','2013-08-17','09:35:00',4.17),('16100','2013-08-17','09:40:00',4.1),('16100','2013-08-17','09:45:00',3.57),('16100','2013-08-17','09:50:00',4.53),('16100','2013-08-17','09:55:00',4.4),('16100','2013-08-17','10:00:00',4.71),('16100','2013-08-17','10:05:00',4.92),('16100','2013-08-17','10:10:00',4.99),('16100','2013-08-17','10:15:00',5.14),('16100','2013-08-17','10:20:00',5.25),('16100','2013-08-17','10:25:00',5.37),('16100','2013-08-17','10:30:00',5.49),('16100','2013-08-17','10:35:00',5.59),('16100','2013-08-17','10:40:00',5.64),('16100','2013-08-17','10:45:00',5.69),('16100','2013-08-17','10:50:00',5.75),('16100','2013-08-17','10:55:00',5.82),('16100','2013-08-17','11:00:00',5.89),('16100','2013-08-17','11:05:00',5.96),('16100','2013-08-17','11:10:00',6.05),('16100','2013-08-17','11:15:00',6.15),('16100','2013-08-17','11:20:00',6.31),('16100','2013-08-17','11:25:00',6.34),('16100','2013-08-17','11:30:00',6.41),('16100','2013-08-17','11:35:00',6.45),('16100','2013-08-17','11:40:00',6.55),('16100','2013-08-17','11:45:00',6.57),('16100','2013-08-17','11:50:00',6.6),('16100','2013-08-17','11:55:00',6.61),('16100','2013-08-17','12:00:00',6.66),('16100','2013-08-17','12:05:00',6.78),('16100','2013-08-17','12:10:00',6.83),('16100','2013-08-17','12:15:00',6.91),('16100','2013-08-17','12:20:00',6.63),('16100','2013-08-17','12:25:00',6.97),('16100','2013-08-17','12:30:00',7.07),('16100','2013-08-17','12:35:00',7.04),('16100','2013-08-17','12:40:00',7.36),('16100','2013-08-17','12:45:00',6.54),('16100','2013-08-17','12:50:00',7.26),('16100','2013-08-17','12:55:00',7.18),('16100','2013-08-17','13:00:00',7.22),('16100','2013-08-17','13:05:00',7.15),('16100','2013-08-17','13:10:00',7.28),('16100','2013-08-17','13:15:00',7.24),('16100','2013-08-17','13:20:00',7.16),('16100','2013-08-17','13:25:00',7.26),('16100','2013-08-17','13:30:00',7.18),('16100','2013-08-17','13:35:00',7.2),('16100','2013-08-17','13:40:00',7.2),('16100','2013-08-17','13:45:00',7.18),('16100','2013-08-17','13:50:00',7.21),('16100','2013-08-17','13:55:00',7.21),('16100','2013-08-17','14:00:00',7.19),('16100','2013-08-17','14:05:00',7.17),('16100','2013-08-17','14:10:00',7.1),('16100','2013-08-17','14:15:00',7.07),('16100','2013-08-17','14:20:00',7.05),('16100','2013-08-17','14:25:00',7.05),('16100','2013-08-17','14:30:00',7.06),('16100','2013-08-17','14:35:00',6.98),('16100','2013-08-17','14:40:00',6.97),('16100','2013-08-17','14:45:00',6.87),('16100','2013-08-17','14:50:00',6.76),('16100','2013-08-17','14:55:00',6.69),('16100','2013-08-17','15:00:00',6.66),('16100','2013-08-17','15:05:00',6.62),('16100','2013-08-17','15:10:00',6.55),('16100','2013-08-17','15:15:00',6.52),('16100','2013-08-17','15:20:00',6.39),('16100','2013-08-17','15:25:00',6.28),('16100','2013-08-17','15:30:00',6.16),('16100','2013-08-17','15:35:00',6.06),('16100','2013-08-17','15:40:00',6),('16100','2013-08-17','15:45:00',5.89),('16100','2013-08-17','15:50:00',5.81),('16100','2013-08-17','15:55:00',5.75),('16100','2013-08-17','16:00:00',5.62),('16100','2013-08-17','16:05:00',5.54),('16100','2013-08-17','16:10:00',5.45),('16100','2013-08-17','16:15:00',5.33),('16100','2013-08-17','16:20:00',5.12),('16100','2013-08-17','16:25:00',5.03),('16100','2013-08-17','16:30:00',4.92),('16100','2013-08-17','16:35:00',4.81),('16100','2013-08-17','16:40:00',4.7),('16100','2013-08-17','16:45:00',4.59),('16100','2013-08-17','16:50:00',4.45),('16100','2013-08-17','16:55:00',4.32),('16100','2013-08-17','17:00:00',4.15),('16100','2013-08-17','17:05:00',4.01),('16100','2013-08-17','17:10:00',3.86),('16100','2013-08-17','17:15:00',3.71),('16100','2013-08-17','17:20:00',3.57),('16100','2013-08-17','17:25:00',3.41),('16100','2013-08-17','17:30:00',3.24),('16100','2013-08-17','17:35:00',3.09),('16100','2013-08-17','17:40:00',2.93),('16100','2013-08-17','17:45:00',2.77),('16100','2013-08-17','17:50:00',2.59),('16100','2013-08-17','17:55:00',2.44),('16100','2013-08-17','18:00:00',2.26),('16100','2013-08-17','18:05:00',2.11),('16100','2013-08-17','18:10:00',1.95),('16100','2013-08-17','18:15:00',1.79),('16100','2013-08-17','18:20:00',1.63),('16100','2013-08-17','18:25:00',1.48),('16100','2013-08-17','18:30:00',1.32),('16100','2013-08-17','18:35:00',1.17),('16100','2013-08-17','18:40:00',1.01),('16100','2013-08-16','08:05:00',1.06),('16100','2013-08-16','08:10:00',1.21),('16100','2013-08-16','08:15:00',1.35),('16100','2013-08-16','08:20:00',1.53),('16100','2013-08-16','08:25:00',1.77),('16100','2013-08-16','08:30:00',1.98),('16100','2013-08-16','08:35:00',2.27),('16100','2013-08-16','08:40:00',2.45),('16100','2013-08-16','08:45:00',2.63),('16100','2013-08-16','08:50:00',2.81),('16100','2013-08-16','08:55:00',2.97),('16100','2013-08-16','09:00:00',3.12),('16100','2013-08-16','09:05:00',3.28),('16100','2013-08-16','09:10:00',3.47),('16100','2013-08-16','09:15:00',3.63),('16100','2013-08-16','09:20:00',3.76),('16100','2013-08-16','09:25:00',3.9),('16100','2013-08-16','09:30:00',4.04),('16100','2013-08-16','09:35:00',4.17),('16100','2013-08-16','09:40:00',4.33),('16100','2013-08-16','09:45:00',4.46),('16100','2013-08-16','09:50:00',4.57),('16100','2013-08-16','09:55:00',4.68),('16100','2013-08-16','10:00:00',4.79),('16100','2013-08-16','10:05:00',4.9),('16100','2013-08-16','10:10:00',5.01),('16100','2013-08-16','10:15:00',5.15),('16100','2013-08-16','10:20:00',5.28),('16100','2013-08-16','10:25:00',5.4),('16100','2013-08-16','10:30:00',5.51),('16100','2013-08-16','10:35:00',5.62),('16100','2013-08-16','10:40:00',5.73),('16100','2013-08-16','10:45:00',5.83),('16100','2013-08-16','10:50:00',5.88),('16100','2013-08-16','10:55:00',5.97),('16100','2013-08-16','11:00:00',6.07),('16100','2013-08-16','11:05:00',6.1),('16100','2013-08-16','11:10:00',6.21),('16100','2013-08-16','11:15:00',6.32),('16100','2013-08-16','11:20:00',6.42),('16100','2013-08-16','11:25:00',6.45),('16100','2013-08-16','11:30:00',6.5),('16100','2013-08-16','11:35:00',6.59),('16100','2013-08-16','11:40:00',6.53),('16100','2013-08-16','11:45:00',6.58),('16100','2013-08-16','11:50:00',6.66),('16100','2013-08-16','11:55:00',6.76),('16100','2013-08-16','12:00:00',6.91),('16100','2013-08-16','12:05:00',6.87),('16100','2013-08-16','12:10:00',6.99),('16100','2013-08-16','12:15:00',6.87),('16100','2013-08-16','12:20:00',6.55),('16100','2013-08-16','12:25:00',6.38),('16100','2013-08-16','12:30:00',6.71),('16100','2013-08-16','12:35:00',6.96),('16100','2013-08-16','12:40:00',7.24),('16100','2013-08-16','12:45:00',7.08),('16100','2013-08-16','12:50:00',7.01),('16100','2013-08-16','12:55:00',7.06),('16100','2013-08-16','13:00:00',7.05),('16100','2013-08-16','13:05:00',7.25),('16100','2013-08-16','13:10:00',7.29),('16100','2013-08-16','13:15:00',7.21),('16100','2013-08-16','13:20:00',7.15),('16100','2013-08-16','13:25:00',7.25),('16100','2013-08-16','13:30:00',7.26),('16100','2013-08-16','13:35:00',6.9),('16100','2013-08-16','13:40:00',7.13),('16100','2013-08-16','13:45:00',7.12),('16100','2013-08-16','13:50:00',7.33),('16100','2013-08-16','13:55:00',7.29),('16100','2013-08-16','14:00:00',7.19),('16100','2013-08-16','14:05:00',7.02),('16100','2013-08-16','14:10:00',7.06),('16100','2013-08-16','14:15:00',7.08),('16100','2013-08-16','14:20:00',7.1),('16100','2013-08-16','14:25:00',7.1),('16100','2013-08-16','14:30:00',6.98),('16100','2013-08-16','14:35:00',6.89),('16100','2013-08-16','14:40:00',6.89),('16100','2013-08-16','14:45:00',6.84),('16100','2013-08-16','14:50:00',6.76),('16100','2013-08-16','14:55:00',6.72),('16100','2013-08-16','15:00:00',6.66),('16100','2013-08-16','15:05:00',6.61),('16100','2013-08-16','15:10:00',6.5),('16100','2013-08-16','15:15:00',6.48),('16100','2013-08-16','15:20:00',6.35),('16100','2013-08-16','15:25:00',6.32),('16100','2013-08-16','15:30:00',6.24),('16100','2013-08-16','15:35:00',6.16),('16100','2013-08-16','15:40:00',6.05),('16100','2013-08-16','15:45:00',5.95),('16100','2013-08-16','15:50:00',5.86),('16100','2013-08-16','15:55:00',5.77),('16100','2013-08-16','16:00:00',5.69),('16100','2013-08-16','16:05:00',5.61),('16100','2013-08-16','16:10:00',5.51),('16100','2013-08-16','16:15:00',5.41),('16100','2013-08-16','16:20:00',5.18),('16100','2013-08-16','16:25:00',5.11),('16100','2013-08-16','16:30:00',5.01),('16100','2013-08-16','16:35:00',4.9),('16100','2013-08-16','16:40:00',4.81),('16100','2013-08-16','16:45:00',4.66),('16100','2013-08-16','16:50:00',4.55),('16100','2013-08-16','16:55:00',4.39),('16100','2013-08-16','17:00:00',4.26),('16100','2013-08-16','17:05:00',4.04),('16100','2013-08-16','17:10:00',3.95),('16100','2013-08-16','17:15:00',3.67),('16100','2013-08-16','17:20:00',3.74),('16100','2013-08-16','17:25:00',3.45),('16100','2013-08-16','17:30:00',3.38),('16100','2013-08-16','17:35:00',3.25),('16100','2013-08-16','17:40:00',3.09),('16100','2013-08-16','17:45:00',2.9),('16100','2013-08-16','17:50:00',2.71),('16100','2013-08-16','17:55:00',2.56),('16100','2013-08-16','18:00:00',2.38),('16100','2013-08-16','18:05:00',2.22),('16100','2013-08-16','18:10:00',2.07),('16100','2013-08-16','18:15:00',1.9),('16100','2013-08-16','18:20:00',1.7),('16100','2013-08-16','18:25:00',1.55),('16100','2013-08-16','18:30:00',1.39),('16100','2013-08-16','18:35:00',1.22),('16100','2013-08-16','18:40:00',1.07),('16100','2013-08-15','08:05:00',1.08),('16100','2013-08-15','08:10:00',1.24),('16100','2013-08-15','08:15:00',1.39),('16100','2013-08-15','08:20:00',1.57),('16100','2013-08-15','08:25:00',1.8),('16100','2013-08-15','08:30:00',2),('16100','2013-08-15','08:35:00',2.28),('16100','2013-08-15','08:40:00',2.47),('16100','2013-08-15','08:45:00',2.65),('16100','2013-08-15','08:50:00',2.84),('16100','2013-08-15','08:55:00',3),('16100','2013-08-15','09:00:00',3.17),('16100','2013-08-15','09:05:00',3.35),('16100','2013-08-15','09:10:00',3.54),('16100','2013-08-15','09:15:00',3.68),('16100','2013-08-15','09:20:00',3.83),('16100','2013-08-15','09:25:00',3.98),('16100','2013-08-15','09:30:00',4.13),('16100','2013-08-15','09:35:00',4.26),('16100','2013-08-15','09:40:00',4.43),('16100','2013-08-15','09:45:00',4.56),('16100','2013-08-15','09:50:00',4.7),('16100','2013-08-15','09:55:00',4.83),('16100','2013-08-15','10:00:00',4.93),('16100','2013-08-15','10:05:00',5.05),('16100','2013-08-15','10:10:00',5.16),('16100','2013-08-15','10:15:00',5.29),('16100','2013-08-15','10:20:00',5.41),('16100','2013-08-15','10:25:00',5.51),('16100','2013-08-15','10:30:00',5.61),('16100','2013-08-15','10:35:00',5.72),('16100','2013-08-15','10:40:00',5.83),('16100','2013-08-15','10:45:00',5.93),('16100','2013-08-15','10:50:00',6.03),('16100','2013-08-15','10:55:00',6.13),('16100','2013-08-15','11:00:00',6.21),('16100','2013-08-15','11:05:00',6.33),('16100','2013-08-15','11:10:00',6.46),('16100','2013-08-15','11:15:00',6.55),('16100','2013-08-15','11:20:00',6.61),('16100','2013-08-15','11:25:00',6.66),('16100','2013-08-15','11:30:00',6.71),('16100','2013-08-15','11:35:00',6.78),('16100','2013-08-15','11:40:00',6.84),('16100','2013-08-15','11:45:00',6.86),('16100','2013-08-15','11:50:00',6.9),('16100','2013-08-15','11:55:00',6.94),('16100','2013-08-15','12:00:00',6.98),('16100','2013-08-15','12:05:00',7),('16100','2013-08-15','12:10:00',7.05),('16100','2013-08-15','12:15:00',7.05),('16100','2013-08-15','12:20:00',7.1),('16100','2013-08-15','12:25:00',7.1),('16100','2013-08-15','12:30:00',7.07),('16100','2013-08-15','12:35:00',7.14),('16100','2013-08-15','12:40:00',7.19),('16100','2013-08-15','12:45:00',7.16),('16100','2013-08-15','12:50:00',7.16),('16100','2013-08-15','12:55:00',7.2),('16100','2013-08-15','13:00:00',7.2),('16100','2013-08-15','13:05:00',7.19),('16100','2013-08-15','13:10:00',7.17),('16100','2013-08-15','13:15:00',7.18),('16100','2013-08-15','13:20:00',7.15),('16100','2013-08-15','13:25:00',7.11),('16100','2013-08-15','13:30:00',7.13),('16100','2013-08-15','13:35:00',7.14),('16100','2013-08-15','13:40:00',7.11),('16100','2013-08-15','13:45:00',7.08),('16100','2013-08-15','13:50:00',7.1),('16100','2013-08-15','13:55:00',7.06),('16100','2013-08-15','14:00:00',7.02),('16100','2013-08-15','14:05:00',7.03),('16100','2013-08-15','14:10:00',6.97),('16100','2013-08-15','14:15:00',6.91),('16100','2013-08-15','14:20:00',6.93),('16100','2013-08-15','14:25:00',6.9),('16100','2013-08-15','14:30:00',6.85),('16100','2013-08-15','14:35:00',6.75),('16100','2013-08-15','14:40:00',6.75),('16100','2013-08-15','14:45:00',6.73),('16100','2013-08-15','14:50:00',6.65),('16100','2013-08-15','14:55:00',6.57),('16100','2013-08-15','15:00:00',6.54),('16100','2013-08-15','15:05:00',6.59),('16100','2013-08-15','15:10:00',6.52),('16100','2013-08-15','15:15:00',6.45),('16100','2013-08-15','15:20:00',6.42),('16100','2013-08-15','15:25:00',6.32),('16100','2013-08-15','15:30:00',6.2),('16100','2013-08-15','15:35:00',6.13),('16100','2013-08-15','15:40:00',6.05),('16100','2013-08-15','15:45:00',5.95),('16100','2013-08-15','15:50:00',5.87),('16100','2013-08-15','15:55:00',5.75),('16100','2013-08-15','16:00:00',5.65),('16100','2013-08-15','16:05:00',5.57),('16100','2013-08-15','16:10:00',5.44),('16100','2013-08-15','16:15:00',5.32),('16100','2013-08-15','16:20:00',5.08),('16100','2013-08-15','16:25:00',5.06),('16100','2013-08-15','16:30:00',4.94),('16100','2013-08-15','16:35:00',4.84),('16100','2013-08-15','16:40:00',4.71),('16100','2013-08-15','16:45:00',4.57),('16100','2013-08-15','16:50:00',4.45),('16100','2013-08-15','16:55:00',4.31),('16100','2013-08-15','17:00:00',4.17),('16100','2013-08-15','17:05:00',4.01),('16100','2013-08-15','17:10:00',3.87),('16100','2013-08-15','17:15:00',3.73),('16100','2013-08-15','17:20:00',3.58),('16100','2013-08-15','17:25:00',3.45),('16100','2013-08-15','17:30:00',3.28),('16100','2013-08-15','17:35:00',3.1),('16100','2013-08-15','17:40:00',2.94),('16100','2013-08-15','17:45:00',2.78),('16100','2013-08-15','17:50:00',2.6),('16100','2013-08-15','17:55:00',2.45),('16100','2013-08-15','18:00:00',2.29),('16100','2013-08-15','18:05:00',2.14),('16100','2013-08-15','18:10:00',1.99),('16100','2013-08-15','18:15:00',1.83),('16100','2013-08-15','18:20:00',1.66),('16100','2013-08-15','18:25:00',1.29),('16100','2013-08-14','08:10:00',1.4),('16100','2013-08-14','08:15:00',1.67),('16100','2013-08-14','08:20:00',1.8),('16100','2013-08-14','08:25:00',2),('16100','2013-08-14','08:30:00',2.11),('16100','2013-08-14','08:35:00',2.32),('16100','2013-08-14','08:40:00',2.53),('16100','2013-08-14','08:45:00',2.74),('16100','2013-08-14','08:50:00',2.94),('16100','2013-08-14','08:55:00',3.05),('16100','2013-08-14','09:00:00',3.25),('16100','2013-08-14','09:05:00',3.46),('16100','2013-08-14','09:10:00',3.68),('16100','2013-08-14','09:15:00',3.85),('16100','2013-08-14','09:20:00',3.95),('16100','2013-08-14','09:25:00',4.03),('16100','2013-08-14','09:30:00',4.16),('16100','2013-08-14','09:35:00',4.32),('16100','2013-08-14','09:40:00',4.52),('16100','2013-08-14','09:45:00',4.65),('16100','2013-08-14','09:50:00',4.74),('16100','2013-08-14','09:55:00',4.89),('16100','2013-08-14','10:00:00',5.01),('16100','2013-08-14','10:05:00',5.11),('16100','2013-08-14','10:10:00',5.24),('16100','2013-08-14','10:15:00',5.39),('16100','2013-08-14','10:20:00',5.51),('16100','2013-08-14','10:25:00',5.66),('16100','2013-08-14','10:30:00',5.78),('16100','2013-08-14','10:35:00',5.89),('16100','2013-08-14','10:40:00',6.01),('16100','2013-08-14','10:45:00',6.13),('16100','2013-08-14','10:50:00',6.25),('16100','2013-08-14','10:55:00',6.38),('16100','2013-08-14','11:00:00',6.46),('16100','2013-08-14','11:05:00',6.56),('16100','2013-08-14','11:10:00',5.96),('16100','2013-08-14','11:15:00',6.57),('16100','2013-08-14','11:20:00',6.47),('16100','2013-08-14','11:25:00',6.76),('16100','2013-08-14','11:30:00',6.65),('16100','2013-08-14','11:35:00',5.6),('16100','2013-08-14','11:40:00',4.21),('16100','2013-08-14','11:45:00',4.85),('16100','2013-08-14','11:50:00',4.95),('16100','2013-08-14','11:55:00',5.89),('16100','2013-08-14','12:00:00',6.55),('16100','2013-08-14','12:05:00',6.31),('16100','2013-08-14','12:10:00',6.9),('16100','2013-08-14','12:15:00',7.33),('16100','2013-08-14','12:20:00',7.45),('16100','2013-08-14','12:25:00',7.34),('16100','2013-08-14','12:30:00',7.55),('16100','2013-08-14','12:35:00',7.6),('16100','2013-08-14','12:40:00',7.57),('16100','2013-08-14','12:45:00',7.57),('16100','2013-08-14','12:50:00',7.55),('16100','2013-08-14','12:55:00',7.47),('16100','2013-08-14','13:00:00',7.32),('16100','2013-08-14','13:05:00',7.35),('16100','2013-08-14','13:10:00',7.26),('16100','2013-08-14','13:15:00',7.35),('16100','2013-08-14','13:20:00',7.32),('16100','2013-08-14','13:25:00',7.37),('16100','2013-08-14','13:30:00',7.55),('16100','2013-08-14','13:35:00',7.51),('16100','2013-08-14','13:40:00',7.3),('16100','2013-08-14','13:45:00',7.19),('16100','2013-08-14','13:50:00',7.21),('16100','2013-08-14','13:55:00',7.23),('16100','2013-08-14','14:00:00',7.28),('16100','2013-08-14','14:05:00',7.2),('16100','2013-08-14','14:10:00',7.19),('16100','2013-08-14','14:15:00',6.98),('16100','2013-08-14','14:20:00',7.08),('16100','2013-08-14','14:25:00',7.03),('16100','2013-08-14','14:30:00',6.97),('16100','2013-08-14','14:35:00',6.83),('16100','2013-08-14','14:40:00',6.77),('16100','2013-08-14','14:45:00',6.56),('16100','2013-08-14','14:50:00',5.67),('16100','2013-08-14','14:55:00',6.58),('16100','2013-08-14','15:00:00',6.5),('16100','2013-08-14','15:05:00',6.44),('16100','2013-08-14','15:10:00',6.38),('16100','2013-08-14','15:15:00',6.29),('16100','2013-08-14','15:20:00',6.18),('16100','2013-08-14','15:25:00',6.05),('16100','2013-08-14','15:30:00',5.99),('16100','2013-08-14','15:35:00',5.92),('16100','2013-08-14','15:40:00',5.83),('16100','2013-08-14','15:45:00',5.73),('16100','2013-08-14','15:50:00',5.65),('16100','2013-08-14','15:55:00',5.47),('16100','2013-08-14','16:00:00',5.4),('16100','2013-08-14','16:05:00',5.37),('16100','2013-08-14','16:10:00',5.24),('16100','2013-08-14','16:15:00',5.11),('16100','2013-08-14','16:20:00',5.02),('16100','2013-08-14','16:25:00',4.99),('16100','2013-08-14','16:30:00',4.89),('16100','2013-08-14','16:35:00',4.73),('16100','2013-08-14','16:40:00',3.11),('16100','2013-08-14','16:45:00',4.51),('16100','2013-08-14','16:50:00',4.26),('16100','2013-08-14','16:55:00',4.21),('16100','2013-08-14','17:00:00',4.09),('16100','2013-08-14','17:05:00',3.79),('16100','2013-08-14','17:10:00',3.72),('16100','2013-08-14','17:15:00',3.62),('16100','2013-08-14','17:20:00',3.4),('16100','2013-08-14','17:25:00',3.33),('16100','2013-08-14','17:30:00',3.18),('16100','2013-08-14','17:35:00',3.03),('16100','2013-08-14','17:40:00',2.85),('16100','2013-08-14','17:45:00',2.72),('16100','2013-08-14','17:50:00',2.53),('16100','2013-08-14','17:55:00',2.32),('16100','2013-08-14','18:00:00',2.25),('16100','2013-08-14','18:05:00',2.09),('16100','2013-08-14','18:10:00',1.91),('16100','2013-08-14','18:15:00',1.78),('16100','2013-08-14','18:20:00',1.64),('16100','2013-08-14','18:25:00',1.47),('16100','2013-08-14','18:30:00',1.33),('16100','2013-08-14','18:35:00',1.16),('16100','2013-08-13','08:05:00',1.11),('16100','2013-08-13','08:10:00',1.23),('16100','2013-08-13','08:15:00',1.38),('16100','2013-08-13','08:20:00',1.59),('16100','2013-08-13','08:25:00',1.89),('16100','2013-08-13','08:30:00',2.23),('16100','2013-08-13','08:35:00',1.92),('16100','2013-08-13','08:40:00',1.91),('16100','2013-08-13','08:45:00',2.29),('16100','2013-08-13','08:50:00',2.76),('16100','2013-08-13','08:55:00',2.9),('16100','2013-08-13','09:00:00',3.1),('16100','2013-08-13','09:05:00',3.25),('16100','2013-08-13','09:10:00',3.44),('16100','2013-08-13','09:15:00',3.63),('16100','2013-08-13','09:20:00',3.9),('16100','2013-08-13','09:25:00',4.04),('16100','2013-08-13','09:30:00',3.98),('16100','2013-08-13','09:35:00',4.18),('16100','2013-08-13','09:40:00',2.44),('16100','2013-08-13','09:45:00',1.6),('16100','2013-08-13','09:50:00',1.54),('16100','2013-08-13','09:55:00',2.88),('16100','2013-08-13','10:00:00',4.94),('16100','2013-08-13','10:05:00',4.58),('16100','2013-08-13','10:10:00',5.32),('16100','2013-08-13','10:15:00',4.15),('16100','2013-08-13','10:20:00',3.31),('16100','2013-08-13','10:25:00',2.37),('16100','2013-08-13','10:30:00',4.35),('16100','2013-08-13','10:35:00',6.18),('16100','2013-08-13','10:40:00',6.1),('16100','2013-08-13','10:45:00',3.68),('16100','2013-08-13','10:50:00',2.71),('16100','2013-08-13','10:55:00',5.95),('16100','2013-08-13','11:00:00',3.05),('16100','2013-08-13','11:05:00',2.42),('16100','2013-08-13','11:10:00',5.53),('16100','2013-08-13','11:15:00',5.93),('16100','2013-08-13','11:20:00',5.72),('16100','2013-08-13','11:25:00',5.91),('16100','2013-08-13','11:30:00',6.46),('16100','2013-08-13','11:35:00',6.85),('16100','2013-08-13','11:40:00',4.62),('16100','2013-08-13','11:45:00',2.47),('16100','2013-08-13','11:50:00',3.14),('16100','2013-08-13','11:55:00',4.76),('16100','2013-08-13','12:00:00',5.76),('16100','2013-08-13','12:05:00',5.39),('16100','2013-08-13','12:10:00',2.74),('16100','2013-08-13','12:15:00',2.43),('16100','2013-08-13','12:20:00',5.87),('16100','2013-08-13','12:25:00',7.73),('16100','2013-08-13','12:30:00',7.48),('16100','2013-08-13','12:35:00',6.68),('16100','2013-08-13','12:40:00',2.09),('16100','2013-08-13','12:45:00',2.35),('16100','2013-08-13','12:50:00',3.31),('16100','2013-08-13','12:55:00',1.92),('16100','2013-08-13','13:00:00',2.79),('16100','2013-08-13','13:05:00',6.05),('16100','2013-08-13','13:10:00',6.19),('16100','2013-08-13','13:15:00',4.39),('16100','2013-08-13','13:20:00',3.05),('16100','2013-08-13','13:25:00',7.61),('16100','2013-08-13','13:30:00',7.47),('16100','2013-08-13','13:35:00',7.63),('16100','2013-08-13','13:40:00',7.48),('16100','2013-08-13','13:45:00',7.57),('16100','2013-08-13','13:50:00',7.93),('16100','2013-08-13','13:55:00',5.66),('16100','2013-08-13','14:00:00',6.11),('16100','2013-08-13','14:05:00',6.68),('16100','2013-08-13','14:10:00',7.36),('16100','2013-08-13','14:15:00',5.51),('16100','2013-08-13','14:20:00',5.94),('16100','2013-08-13','14:25:00',6.04),('16100','2013-08-13','14:30:00',7.87),('16100','2013-08-13','14:35:00',5.4),('16100','2013-08-13','14:40:00',7.14),('16100','2013-08-13','14:45:00',6.97),('16100','2013-08-13','14:50:00',6.97),('16100','2013-08-13','14:55:00',6.77),('16100','2013-08-13','15:00:00',6.79),('16100','2013-08-13','15:05:00',6.67),('16100','2013-08-13','15:10:00',6.61),('16100','2013-08-13','15:15:00',6.55),('16100','2013-08-13','15:20:00',6.48),('16100','2013-08-13','15:25:00',6.29),('16100','2013-08-13','15:30:00',6.19),('16100','2013-08-13','15:35:00',6.14),('16100','2013-08-13','15:40:00',6.01),('16100','2013-08-13','15:45:00',5.95),('16100','2013-08-13','15:50:00',5.84),('16100','2013-08-13','15:55:00',5.78),('16100','2013-08-13','16:00:00',5.66),('16100','2013-08-13','16:05:00',5.57),('16100','2013-08-13','16:10:00',5.51),('16100','2013-08-13','16:15:00',5.41),('16100','2013-08-13','16:20:00',5.24),('16100','2013-08-13','16:25:00',5.14),('16100','2013-08-13','16:30:00',5.04),('16100','2013-08-13','16:35:00',4.92),('16100','2013-08-13','16:40:00',4.81),('16100','2013-08-13','16:45:00',4.67),('16100','2013-08-13','16:50:00',4.4),('16100','2013-08-13','16:55:00',4.07),('16100','2013-08-13','17:00:00',4.08),('16100','2013-08-13','17:05:00',3.91),('16100','2013-08-13','17:10:00',3.87),('16100','2013-08-13','17:15:00',3.68),('16100','2013-08-13','17:20:00',3.59),('16100','2013-08-13','17:25:00',3.45),('16100','2013-08-13','17:30:00',3.31),('16100','2013-08-13','17:35:00',3.17),('16100','2013-08-13','17:40:00',3.01),('16100','2013-08-13','17:45:00',2.84),('16100','2013-08-13','17:50:00',2.67),('16100','2013-08-13','17:55:00',2.49),('16100','2013-08-13','18:00:00',2.33),('16100','2013-08-13','18:05:00',2.18),('16100','2013-08-13','18:10:00',2.04),('16100','2013-08-13','18:15:00',1.88),('16100','2013-08-13','18:20:00',1.75),('16100','2013-08-13','18:25:00',1.68),('16100','2013-08-13','18:30:00',1.59),('16100','2013-08-13','18:35:00',1.4),('16100','2013-08-13','18:40:00',1.17),('16100','2013-08-13','18:45:00',1.05),('16100','2013-08-12','08:05:00',1.1),('16100','2013-08-12','08:10:00',1.29),('16100','2013-08-12','08:15:00',1.45),('16100','2013-08-12','08:20:00',1.61),('16100','2013-08-12','08:25:00',1.79),('16100','2013-08-12','08:30:00',2),('16100','2013-08-12','08:35:00',2.23),('16100','2013-08-12','08:40:00',2.5),('16100','2013-08-12','08:45:00',2.69),('16100','2013-08-12','08:50:00',2.88),('16100','2013-08-12','08:55:00',3.04),('16100','2013-08-12','09:00:00',3.18),('16100','2013-08-12','09:05:00',3.38),('16100','2013-08-12','09:10:00',3.54),('16100','2013-08-12','09:15:00',3.67),('16100','2013-08-12','09:20:00',3.82),('16100','2013-08-12','09:25:00',3.97),('16100','2013-08-12','09:30:00',4.08),('16100','2013-08-12','09:35:00',4.24),('16100','2013-08-12','09:40:00',4.42),('16100','2013-08-12','09:45:00',4.53),('16100','2013-08-12','09:50:00',4.65),('16100','2013-08-12','09:55:00',4.77),('16100','2013-08-12','10:00:00',4.92),('16100','2013-08-12','10:05:00',5.07),('16100','2013-08-12','10:10:00',5.24),('16100','2013-08-12','10:15:00',5.4),('16100','2013-08-12','10:20:00',5.51),('16100','2013-08-12','10:25:00',5.78),('16100','2013-08-12','10:30:00',6.04),('16100','2013-08-12','10:35:00',6.23),('16100','2013-08-12','10:40:00',6.2),('16100','2013-08-12','10:45:00',2.97),('16100','2013-08-12','10:50:00',5.43),('16100','2013-08-12','10:55:00',6.27),('16100','2013-08-12','11:00:00',6.39),('16100','2013-08-12','11:05:00',6.32),('16100','2013-08-12','11:10:00',6.3),('16100','2013-08-12','11:15:00',6.45),('16100','2013-08-12','11:20:00',6.53),('16100','2013-08-12','11:25:00',6.54),('16100','2013-08-12','11:30:00',6.58),('16100','2013-08-12','11:35:00',6.59),('16100','2013-08-12','11:40:00',6.65),('16100','2013-08-12','11:45:00',6.66),('16100','2013-08-12','11:50:00',5.02),('16100','2013-08-12','11:55:00',7.15),('16100','2013-08-12','12:00:00',7.12),('16100','2013-08-12','12:05:00',7.28),('16100','2013-08-12','12:10:00',7.46),('16100','2013-08-12','12:15:00',7.54),('16100','2013-08-12','12:20:00',7.39),('16100','2013-08-12','12:25:00',7.5),('16100','2013-08-12','12:30:00',7.5),('16100','2013-08-12','12:35:00',4.78),('16100','2013-08-12','12:40:00',4.71),('16100','2013-08-12','12:45:00',7.93),('16100','2013-08-12','12:50:00',7.56),('16100','2013-08-12','12:55:00',7.05),('16100','2013-08-12','13:00:00',4.89),('16100','2013-08-12','13:05:00',6.82),('16100','2013-08-12','13:10:00',7.73),('16100','2013-08-12','13:15:00',7.39),('16100','2013-08-12','13:20:00',7.46),('16100','2013-08-12','13:25:00',7.48),('16100','2013-08-12','13:30:00',7.42),('16100','2013-08-12','13:35:00',7.28),('16100','2013-08-12','13:40:00',7.29),('16100','2013-08-12','13:45:00',7.41),('16100','2013-08-12','13:50:00',7.23),('16100','2013-08-12','13:55:00',7.44),('16100','2013-08-12','14:00:00',7.57),('16100','2013-08-12','14:05:00',7.37),('16100','2013-08-12','14:10:00',7.24),('16100','2013-08-12','14:15:00',7.02),('16100','2013-08-12','14:20:00',7.06),('16100','2013-08-12','14:25:00',7.24),('16100','2013-08-12','14:30:00',7.15),('16100','2013-08-12','14:35:00',7.1),('16100','2013-08-12','14:40:00',6.98),('16100','2013-08-12','14:45:00',7.01),('16100','2013-08-12','14:50:00',6.88),('16100','2013-08-12','14:55:00',6.79),('16100','2013-08-12','15:00:00',6.7),('16100','2013-08-12','15:05:00',6.66),('16100','2013-08-12','15:10:00',6.54),('16100','2013-08-12','15:15:00',6.44),('16100','2013-08-12','15:20:00',6.45),('16100','2013-08-12','15:25:00',6.26),('16100','2013-08-12','15:30:00',6.21),('16100','2013-08-12','15:35:00',6.16),('16100','2013-08-12','15:40:00',6.04),('16100','2013-08-12','15:45:00',5.97),('16100','2013-08-12','15:50:00',5.89),('16100','2013-08-12','15:55:00',5.76),('16100','2013-08-12','16:00:00',5.66),('16100','2013-08-12','16:05:00',5.6),('16100','2013-08-12','16:10:00',5.49),('16100','2013-08-12','16:15:00',5.42),('16100','2013-08-12','16:20:00',5.23),('16100','2013-08-12','16:25:00',5.14),('16100','2013-08-12','16:30:00',5),('16100','2013-08-12','16:35:00',4.9),('16100','2013-08-12','16:40:00',4.79),('16100','2013-08-12','16:45:00',4.67),('16100','2013-08-12','16:50:00',4.52),('16100','2013-08-12','16:55:00',4.38),('16100','2013-08-12','17:00:00',4.24),('16100','2013-08-12','17:05:00',4.08),('16100','2013-08-12','17:10:00',3.96),('16100','2013-08-12','17:15:00',3.83),('16100','2013-08-12','17:20:00',3.69),('16100','2013-08-12','17:25:00',3.54),('16100','2013-08-12','17:30:00',3.36),('16100','2013-08-12','17:35:00',3.19),('16100','2013-08-12','17:40:00',3.03),('16100','2013-08-12','17:45:00',2.9),('16100','2013-08-12','17:50:00',2.71),('16100','2013-08-12','17:55:00',2.55),('16100','2013-08-12','18:00:00',2.38),('16100','2013-08-12','18:05:00',2.22),('16100','2013-08-12','18:10:00',2.06),('16100','2013-08-12','18:15:00',1.9),('16100','2013-08-12','18:20:00',1.74),('16100','2013-08-12','18:25:00',1.59),('16100','2013-08-12','18:30:00',1.43),('16100','2013-08-12','18:35:00',1.28),('16100','2013-08-12','18:40:00',1.15),('16100','2013-08-11','08:05:00',1.11),('16100','2013-08-11','08:10:00',1.26),('16100','2013-08-11','08:15:00',1.41),('16100','2013-08-11','08:20:00',1.56),('16100','2013-08-11','08:25:00',1.74),('16100','2013-08-11','08:30:00',1.94),('16100','2013-08-11','08:35:00',2.16),('16100','2013-08-11','08:40:00',2.4),('16100','2013-08-11','08:45:00',2.64),('16100','2013-08-11','08:50:00',2.82),('16100','2013-08-11','08:55:00',2.97),('16100','2013-08-11','09:00:00',3.12),('16100','2013-08-11','09:05:00',3.32),('16100','2013-08-11','09:10:00',3.47),('16100','2013-08-11','09:15:00',3.61),('16100','2013-08-11','09:20:00',3.73),('16100','2013-08-11','09:25:00',3.87),('16100','2013-08-11','09:30:00',4.02),('16100','2013-08-11','09:35:00',4.15),('16100','2013-08-11','09:40:00',4.27),('16100','2013-08-11','09:45:00',4.41),('16100','2013-08-11','09:50:00',4.49),('16100','2013-08-11','09:55:00',4.6),('16100','2013-08-11','10:00:00',4.7),('16100','2013-08-11','10:05:00',4.82),('16100','2013-08-11','10:10:00',4.93),('16100','2013-08-11','10:15:00',5.06),('16100','2013-08-11','10:20:00',5.18),('16100','2013-08-11','10:25:00',5.3),('16100','2013-08-11','10:30:00',5.42),('16100','2013-08-11','10:35:00',5.47),('16100','2013-08-11','10:40:00',5.6),('16100','2013-08-11','10:45:00',5.69),('16100','2013-08-11','10:50:00',5.79),('16100','2013-08-11','10:55:00',5.91),('16100','2013-08-11','11:00:00',5.99),('16100','2013-08-11','11:05:00',6.04),('16100','2013-08-11','11:10:00',6.14),('16100','2013-08-11','11:15:00',6.26),('16100','2013-08-11','11:20:00',6.36),('16100','2013-08-11','11:25:00',6.4),('16100','2013-08-11','11:30:00',6.41),('16100','2013-08-11','11:35:00',6.6),('16100','2013-08-11','11:40:00',6.78),('16100','2013-08-11','11:45:00',4.6),('16100','2013-08-11','11:50:00',7.21),('16100','2013-08-11','11:55:00',7.25),('16100','2013-08-11','12:00:00',7.28),('16100','2013-08-11','12:05:00',5.05),('16100','2013-08-11','12:10:00',4.63),('16100','2013-08-11','12:15:00',6.64),('16100','2013-08-11','12:20:00',7.38),('16100','2013-08-11','12:25:00',7.55),('16100','2013-08-11','12:30:00',7.37),('16100','2013-08-11','12:35:00',7.54),('16100','2013-08-11','12:40:00',6.74),('16100','2013-08-11','12:45:00',4.98),('16100','2013-08-11','12:50:00',5.23),('16100','2013-08-11','12:55:00',5.16),('16100','2013-08-11','13:00:00',7.71),('16100','2013-08-11','13:05:00',5.26),('16100','2013-08-11','13:10:00',2.41),('16100','2013-08-11','13:15:00',2.58),('16100','2013-08-11','13:20:00',3.28),('16100','2013-08-11','13:25:00',3.08),('16100','2013-08-11','13:30:00',4.36),('16100','2013-08-11','13:35:00',5.74),('16100','2013-08-11','13:40:00',3.23),('16100','2013-08-11','13:45:00',2.02),('16100','2013-08-11','13:50:00',2.51),('16100','2013-08-11','13:55:00',5.03),('16100','2013-08-11','14:00:00',4.32),('16100','2013-08-11','14:05:00',3.59),('16100','2013-08-11','14:10:00',6.57),('16100','2013-08-11','14:15:00',5.58),('16100','2013-08-11','14:20:00',6.34),('16100','2013-08-11','14:25:00',2.19),('16100','2013-08-11','14:30:00',6.26),('16100','2013-08-11','14:35:00',6.47),('16100','2013-08-11','14:40:00',7.25),('16100','2013-08-11','14:45:00',7.48),('16100','2013-08-11','14:50:00',7.05),('16100','2013-08-11','14:55:00',7.11),('16100','2013-08-11','15:00:00',7.16),('16100','2013-08-11','15:05:00',5.1),('16100','2013-08-11','15:10:00',6.69),('16100','2013-08-11','15:15:00',6.62),('16100','2013-08-11','15:20:00',6.6),('16100','2013-08-11','15:25:00',6.44),('16100','2013-08-11','15:30:00',5.95),('16100','2013-08-11','15:35:00',6.23),('16100','2013-08-11','15:40:00',6.28),('16100','2013-08-11','15:45:00',6.03),('16100','2013-08-11','15:50:00',5.87),('16100','2013-08-11','15:55:00',5.79),('16100','2013-08-11','16:00:00',5.68),('16100','2013-08-11','16:05:00',5.61),('16100','2013-08-11','16:10:00',5.37),('16100','2013-08-11','16:15:00',5.31),('16100','2013-08-11','16:20:00',5.12),('16100','2013-08-11','16:25:00',5.03),('16100','2013-08-11','16:30:00',4.94),('16100','2013-08-11','16:35:00',4.84),('16100','2013-08-11','16:40:00',4.73),('16100','2013-08-11','16:45:00',4.64),('16100','2013-08-11','16:50:00',4.5),('16100','2013-08-11','16:55:00',4.33),('16100','2013-08-11','17:00:00',4.24),('16100','2013-08-11','17:05:00',4.05),('16100','2013-08-11','17:10:00',3.83),('16100','2013-08-11','17:15:00',3.79),('16100','2013-08-11','17:20:00',3.63),('16100','2013-08-11','17:25:00',3.47),('16100','2013-08-11','17:30:00',3.27),('16100','2013-08-11','17:35:00',3.13),('16100','2013-08-11','17:40:00',2.98),('16100','2013-08-11','17:45:00',2.85),('16100','2013-08-11','17:50:00',2.72),('16100','2013-08-11','17:55:00',2.57),('16100','2013-08-11','18:00:00',2.42),('16100','2013-08-11','18:05:00',2.22),('16100','2013-08-11','18:10:00',2.09),('16100','2013-08-11','18:15:00',1.93),('16100','2013-08-11','18:20:00',1.78),('16100','2013-08-11','18:25:00',1.63),('16100','2013-08-11','18:30:00',1.49),('16100','2013-08-11','18:35:00',1.35),('16100','2013-08-11','18:40:00',1.21),('16100','2013-08-11','18:45:00',1.06),('16100','2013-08-10','08:00:00',1.03),('16100','2013-08-10','08:05:00',1.16),('16100','2013-08-10','08:10:00',1.31),('16100','2013-08-10','08:15:00',1.46),('16100','2013-08-10','08:20:00',1.6),('16100','2013-08-10','08:25:00',1.79),('16100','2013-08-10','08:30:00',1.99),('16100','2013-08-10','08:35:00',2.21),('16100','2013-08-10','08:40:00',2.44),('16100','2013-08-10','08:45:00',2.7),('16100','2013-08-10','08:50:00',2.88),('16100','2013-08-10','08:55:00',3.05),('16100','2013-08-10','09:00:00',3.21),('16100','2013-08-10','09:05:00',3.4),('16100','2013-08-10','09:10:00',3.57),('16100','2013-08-10','09:15:00',3.7),('16100','2013-08-10','09:20:00',3.83),('16100','2013-08-10','09:25:00',3.96),('16100','2013-08-10','09:30:00',4.11),('16100','2013-08-10','09:35:00',4.23),('16100','2013-08-10','09:40:00',4.39),('16100','2013-08-10','09:45:00',4.52),('16100','2013-08-10','09:50:00',4.64),('16100','2013-08-10','09:55:00',4.75),('16100','2013-08-10','10:00:00',4.86),('16100','2013-08-10','10:05:00',4.96),('16100','2013-08-10','10:10:00',5.07),('16100','2013-08-10','10:15:00',5.22),('16100','2013-08-10','10:20:00',5.35),('16100','2013-08-10','10:25:00',5.48),('16100','2013-08-10','10:30:00',5.55),('16100','2013-08-10','10:35:00',5.68),('16100','2013-08-10','10:40:00',5.81),('16100','2013-08-10','10:45:00',5.89),('16100','2013-08-10','10:50:00',6.01),('16100','2013-08-10','10:55:00',6.08),('16100','2013-08-10','11:00:00',6.18),('16100','2013-08-10','11:05:00',6.27),('16100','2013-08-10','11:10:00',6.39),('16100','2013-08-10','11:15:00',6.45),('16100','2013-08-10','11:20:00',6.5),('16100','2013-08-10','11:25:00',6.52),('16100','2013-08-10','11:30:00',6.55),('16100','2013-08-10','11:35:00',6.63),('16100','2013-08-10','11:40:00',6.73),('16100','2013-08-10','11:45:00',6.8),('16100','2013-08-10','11:50:00',6.83),('16100','2013-08-10','11:55:00',6.88),('16100','2013-08-10','12:00:00',6.92),('16100','2013-08-10','12:05:00',6.98),('16100','2013-08-10','12:10:00',6.99),('16100','2013-08-10','12:15:00',6.97),('16100','2013-08-10','12:20:00',6.98),('16100','2013-08-10','12:25:00',7.05),('16100','2013-08-10','12:30:00',7.03),('16100','2013-08-10','12:35:00',7.06),('16100','2013-08-10','12:40:00',7.09),('16100','2013-08-10','12:45:00',7.1),('16100','2013-08-10','12:50:00',7.15),('16100','2013-08-10','12:55:00',7.14),('16100','2013-08-10','13:00:00',7.18),('16100','2013-08-10','13:05:00',7.17),('16100','2013-08-10','13:10:00',7.19),('16100','2013-08-10','13:15:00',7.13),('16100','2013-08-10','13:20:00',7.14),('16100','2013-08-10','13:25:00',7.09),('16100','2013-08-10','13:30:00',7.04),('16100','2013-08-10','13:35:00',7.03),('16100','2013-08-10','13:40:00',7.05),('16100','2013-08-10','13:45:00',7.04),('16100','2013-08-10','13:50:00',7.05),('16100','2013-08-10','13:55:00',7.02),('16100','2013-08-10','14:00:00',6.98),('16100','2013-08-10','14:05:00',7.03),('16100','2013-08-10','14:10:00',6.97),('16100','2013-08-10','14:15:00',6.74),('16100','2013-08-10','14:20:00',6.93),('16100','2013-08-10','14:25:00',6.95),('16100','2013-08-10','14:30:00',6.87),('16100','2013-08-10','14:35:00',6.87),('16100','2013-08-10','14:40:00',6.79),('16100','2013-08-10','14:45:00',6.67),('16100','2013-08-10','14:50:00',6.63),('16100','2013-08-10','14:55:00',6.56),('16100','2013-08-10','15:00:00',6.49),('16100','2013-08-10','15:05:00',6.4),('16100','2013-08-10','15:10:00',6.44),('16100','2013-08-10','15:15:00',4.81),('16100','2013-08-10','15:20:00',5.62),('16100','2013-08-10','15:25:00',6.15),('16100','2013-08-10','15:30:00',5.97),('16100','2013-08-10','15:35:00',5.97),('16100','2013-08-10','15:40:00',5.96),('16100','2013-08-10','15:45:00',5.92),('16100','2013-08-10','15:50:00',5.87),('16100','2013-08-10','15:55:00',5.77),('16100','2013-08-10','16:00:00',5.65),('16100','2013-08-10','16:05:00',5.56),('16100','2013-08-10','16:10:00',5.47),('16100','2013-08-10','16:15:00',5.39),('16100','2013-08-10','16:20:00',5.17),('16100','2013-08-10','16:25:00',5.09),('16100','2013-08-10','16:30:00',4.97),('16100','2013-08-10','16:35:00',4.85),('16100','2013-08-10','16:40:00',4.72),('16100','2013-08-10','16:45:00',4.59),('16100','2013-08-10','16:50:00',4.47),('16100','2013-08-10','16:55:00',4.32),('16100','2013-08-10','17:00:00',4.18),('16100','2013-08-10','17:05:00',4.02),('16100','2013-08-10','17:10:00',3.89),('16100','2013-08-10','17:15:00',3.75),('16100','2013-08-10','17:20:00',3.61),('16100','2013-08-10','17:25:00',3.44),('16100','2013-08-10','17:30:00',3.31),('16100','2013-08-10','17:35:00',3.15),('16100','2013-08-10','17:40:00',2.99),('16100','2013-08-10','17:45:00',2.83),('16100','2013-08-10','17:50:00',2.67),('16100','2013-08-10','17:55:00',2.49),('16100','2013-08-10','18:00:00',2.34),('16100','2013-08-10','18:05:00',2.2),('16100','2013-08-10','18:10:00',2.05),('16100','2013-08-10','18:15:00',1.89),('16100','2013-08-10','18:20:00',1.73),('16100','2013-08-10','18:25:00',1.59),('16100','2013-08-10','18:30:00',1.44),('16100','2013-08-10','18:35:00',1.29),('16100','2013-08-10','18:40:00',1.15),('16100','2013-08-10','18:45:00',1.01),('16100','2013-08-09','08:00:00',1.03),('16100','2013-08-09','08:05:00',1.17),('16100','2013-08-09','08:10:00',1.31),('16100','2013-08-09','08:15:00',1.47),('16100','2013-08-09','08:20:00',1.64),('16100','2013-08-09','08:25:00',1.81),('16100','2013-08-09','08:30:00',1.97),('16100','2013-08-09','08:35:00',2.16),('16100','2013-08-09','08:40:00',2.46),('16100','2013-08-09','08:45:00',2.76),('16100','2013-08-09','08:50:00',2.93),('16100','2013-08-09','08:55:00',3.09),('16100','2013-08-09','09:00:00',3.23),('16100','2013-08-09','09:05:00',3.43),('16100','2013-08-09','09:10:00',3.58),('16100','2013-08-09','09:15:00',3.71),('16100','2013-08-09','09:20:00',3.85),('16100','2013-08-09','09:25:00',4),('16100','2013-08-09','09:30:00',4.12),('16100','2013-08-09','09:35:00',4.29),('16100','2013-08-09','09:40:00',4.43),('16100','2013-08-09','09:45:00',4.57),('16100','2013-08-09','09:50:00',4.71),('16100','2013-08-09','09:55:00',4.81),('16100','2013-08-09','10:00:00',4.91),('16100','2013-08-09','10:05:00',5.01),('16100','2013-08-09','10:10:00',5.11),('16100','2013-08-09','10:15:00',5.23),('16100','2013-08-09','10:20:00',5.39),('16100','2013-08-09','10:25:00',5.49),('16100','2013-08-09','10:30:00',5.57),('16100','2013-08-09','10:35:00',5.7),('16100','2013-08-09','10:40:00',5.79),('16100','2013-08-09','10:45:00',5.86),('16100','2013-08-09','10:50:00',5.97),('16100','2013-08-09','10:55:00',6.1),('16100','2013-08-09','11:00:00',6.29),('16100','2013-08-09','11:05:00',6.4),('16100','2013-08-09','11:10:00',5.78),('16100','2013-08-09','11:15:00',6.55),('16100','2013-08-09','11:20:00',6.55),('16100','2013-08-09','11:25:00',6.63),('16100','2013-08-09','11:30:00',6.68),('16100','2013-08-09','11:35:00',6.63),('16100','2013-08-09','11:40:00',6.79),('16100','2013-08-09','11:45:00',6.78),('16100','2013-08-09','11:50:00',6.87),('16100','2013-08-09','11:55:00',7.04),('16100','2013-08-09','12:00:00',7.21),('16100','2013-08-09','12:05:00',7.1),('16100','2013-08-09','12:10:00',7.12),('16100','2013-08-09','12:15:00',7.18),('16100','2013-08-09','12:20:00',7.19),('16100','2013-08-09','12:25:00',7.22),('16100','2013-08-09','12:30:00',7.19),('16100','2013-08-09','12:35:00',7.41),('16100','2013-08-09','12:40:00',7.49),('16100','2013-08-09','12:45:00',4.13),('16100','2013-08-09','12:50:00',7.66),('16100','2013-08-09','12:55:00',7.33),('16100','2013-08-09','13:00:00',6.71),('16100','2013-08-09','13:05:00',7.39),('16100','2013-08-09','13:10:00',7.64),('16100','2013-08-09','13:15:00',7.09),('16100','2013-08-09','13:20:00',1.6),('16100','2013-08-09','13:25:00',6.75),('16100','2013-08-09','13:30:00',2.43),('16100','2013-08-09','13:35:00',1.78),('16100','2013-08-09','13:40:00',7.18),('16100','2013-08-09','13:45:00',2.7),('16100','2013-08-09','13:50:00',3.68),('16100','2013-08-09','13:55:00',4.54),('16100','2013-08-09','14:00:00',6.84),('16100','2013-08-09','14:05:00',8.19),('16100','2013-08-09','14:10:00',5.69),('16100','2013-08-09','14:15:00',2.8),('16100','2013-08-09','14:20:00',1.49),('16100','2013-08-09','14:25:00',1.53),('16100','2013-08-09','14:30:00',1.33),('16100','2013-08-09','14:35:00',1.19),('16100','2013-08-09','14:40:00',1.09),('16100','2013-08-09','14:45:00',1.06),('16100','2013-08-09','14:50:00',1.12),('16100','2013-08-09','14:55:00',1.47),('16100','2013-08-09','15:00:00',1.4),('16100','2013-08-09','15:05:00',1.21),('16100','2013-08-09','15:10:00',1.28),('16100','2013-08-09','15:15:00',1.44),('16100','2013-08-09','15:20:00',1.33),('16100','2013-08-09','15:25:00',1.39),('16100','2013-08-09','15:30:00',1.68),('16100','2013-08-09','15:35:00',1.65),('16100','2013-08-09','15:40:00',2.18),('16100','2013-08-09','15:45:00',2.46),('16100','2013-08-09','15:50:00',2.39),('16100','2013-08-09','15:55:00',2.55),('16100','2013-08-09','16:00:00',2.89),('16100','2013-08-09','16:05:00',2.25),('16100','2013-08-09','16:10:00',2.05),('16100','2013-08-09','16:15:00',1.96),('16100','2013-08-09','16:20:00',2.85),('16100','2013-08-09','16:25:00',3.97),('16100','2013-08-09','16:30:00',3.98),('16100','2013-08-09','16:35:00',2.64),('16100','2013-08-09','16:40:00',1.52),('16100','2013-08-09','16:45:00',3.1),('16100','2013-08-09','16:50:00',4.19),('16100','2013-08-09','16:55:00',1.76),('16100','2013-08-09','17:00:00',1.28),('16100','2013-08-09','17:05:00',1.7),('16100','2013-08-09','17:10:00',1.99),('16100','2013-08-09','17:15:00',2.01),('16100','2013-08-09','17:20:00',1.65),('16100','2013-08-09','17:25:00',1.71),('16100','2013-08-09','17:30:00',1.72),('16100','2013-08-09','17:35:00',1.05),('16100','2013-08-09','17:45:00',1.38),('16100','2013-08-09','17:50:00',1.09),('16100','2014-04-08','08:00:00',1.19),('16100','2014-04-08','08:05:00',1.31),('16100','2014-04-08','08:10:00',1.22),('16100','2014-04-08','08:15:00',1.22),('16100','2014-04-08','08:50:00',1.19),('16100','2014-04-08','08:55:00',1.09),('16100','2014-04-08','09:00:00',1.13),('16100','2014-04-08','09:05:00',1.08),('16100','2014-04-08','09:10:00',1.06),('16100','2014-04-08','09:15:00',1.17),('16100','2014-04-08','09:20:00',1.17),('16100','2014-04-08','09:50:00',1.36),('16100','2014-04-08','09:55:00',2.1),('16100','2014-04-08','10:00:00',3.79),('16100','2014-04-08','10:05:00',3.06),('16100','2014-04-08','10:10:00',2.54),('16100','2014-04-08','10:15:00',1.84),('16100','2014-04-08','10:20:00',1.48),('16100','2014-04-08','10:25:00',1.8),('16100','2014-04-08','10:30:00',1.63),('16100','2014-04-08','10:35:00',1.11),('16100','2014-04-08','10:45:00',3.26),('16100','2014-04-08','10:50:00',5.36),('16100','2014-04-08','10:55:00',6.62),('16100','2014-04-08','11:00:00',4.83),('16100','2014-04-08','11:05:00',2.09),('16100','2014-04-08','11:10:00',2.88),('16100','2014-04-08','11:15:00',2.03),('16100','2014-04-08','11:20:00',1.93),('16100','2014-04-08','11:25:00',2.53),('16100','2014-04-08','11:30:00',6.98),('16100','2014-04-08','11:35:00',7.6),('16100','2014-04-08','11:40:00',6.06),('16100','2014-04-08','11:45:00',5.1),('16100','2014-04-08','11:50:00',2.22),('16100','2014-04-08','11:55:00',2),('16100','2014-04-08','12:00:00',1.96),('16100','2014-04-08','12:05:00',1.82),('16100','2014-04-08','12:10:00',1.72),('16100','2014-04-08','12:15:00',1.86),('16100','2014-04-08','12:20:00',1.81),('16100','2014-04-08','12:25:00',1.79),('16100','2014-04-08','12:30:00',1.44),('16100','2014-04-08','12:35:00',1.32),('16100','2014-04-08','12:40:00',1.42),('16100','2014-04-08','12:45:00',1.66),('16100','2014-04-08','12:50:00',1.75),('16100','2014-04-08','12:55:00',1.96),('16100','2014-04-08','13:00:00',1.97),('16100','2014-04-08','13:05:00',1.87),('16100','2014-04-08','13:10:00',2.05),('16100','2014-04-08','13:15:00',1.96),('16100','2014-04-08','13:20:00',1.97),('16100','2014-04-08','13:25:00',1.99),('16100','2014-04-08','13:30:00',2.4),('16100','2014-04-08','13:35:00',2.86),('16100','2014-04-08','13:40:00',2.84),('16100','2014-04-08','13:45:00',2.63),('16100','2014-04-08','13:50:00',2.5),('16100','2014-04-08','13:55:00',2.08),('16100','2014-04-08','14:00:00',2.56),('16100','2014-04-08','14:05:00',2.38),('16100','2014-04-08','14:10:00',2.25),('16100','2014-04-08','14:15:00',2.33),('16100','2014-04-08','14:20:00',2.54),('16100','2014-04-08','14:25:00',6.62),('16100','2014-04-08','14:30:00',5.88),('16100','2014-04-08','14:35:00',7.45),('16100','2014-04-08','14:40:00',7.28),('16100','2014-04-08','14:45:00',7.18),('16100','2014-04-08','14:50:00',7.42),('16100','2014-04-08','14:55:00',3.5),('16100','2014-04-08','15:00:00',2.77),('16100','2014-04-08','15:05:00',1.85),('16100','2014-04-08','15:10:00',1.74),('16100','2014-04-08','15:15:00',1.93),('16100','2014-04-08','15:20:00',1.6),('16100','2014-04-08','15:25:00',1.22),('16100','2014-04-08','15:30:00',1.19),('16100','2014-04-08','15:35:00',1.24),('16100','2014-04-08','15:40:00',1.89),('16100','2014-04-08','15:45:00',2.5),('16100','2014-04-08','15:50:00',4.79),('16100','2014-04-08','15:55:00',5.46),('16100','2014-04-08','16:00:00',5.87),('16100','2014-04-08','16:05:00',5.53),('16100','2014-04-08','16:10:00',5.39),('16100','2014-04-08','16:15:00',5.28),('16100','2014-04-08','16:20:00',4.37),('16100','2014-04-08','16:25:00',4.94),('16100','2014-04-08','16:30:00',4.94),('16100','2014-04-08','16:35:00',4.8),('16100','2014-04-08','16:40:00',4.87),('16100','2014-04-08','16:45:00',4.48),('16100','2014-04-08','16:50:00',3.89),('16100','2014-04-08','16:55:00',3.61),('16100','2014-04-08','17:00:00',2.86),('16100','2014-04-08','17:05:00',3.6),('16100','2014-04-08','17:10:00',3.51),('16100','2014-04-08','17:15:00',3.28),('16100','2014-04-08','17:20:00',3.04),('16100','2014-04-08','17:25:00',2.16),('16100','2014-04-08','17:30:00',1.99),('16100','2014-04-08','17:35:00',2.53),('16100','2014-04-08','17:40:00',2.55),('16100','2014-04-08','17:45:00',2.66),('16100','2014-04-08','17:50:00',2.44),('16100','2014-04-08','17:55:00',2.29),('16100','2014-04-08','18:00:00',1.43),('16100','2014-04-08','18:05:00',1.52),('16100','2014-04-08','18:10:00',1.51),('16100','2014-04-08','18:15:00',1.3),('16100','2013-08-08','08:00:00',1.2),('16100','2013-08-08','08:05:00',1.09),('16100','2013-08-08','08:10:00',1.03),('16100','2013-08-08','08:15:00',1.05),('16100','2013-08-08','08:20:00',1.02),('16100','2013-08-08','08:30:00',1.09),('16100','2013-08-08','08:35:00',1.68),('16100','2013-08-08','08:40:00',1.81),('16100','2013-08-08','08:45:00',2.28),('16100','2013-08-08','08:50:00',2.66),('16100','2013-08-08','08:55:00',2.9),('16100','2013-08-08','09:00:00',3.12),('16100','2013-08-08','09:05:00',3),('16100','2013-08-08','09:10:00',2.71),('16100','2013-08-08','09:15:00',2.78),('16100','2013-08-08','09:20:00',3.42),('16100','2013-08-08','09:25:00',1.95),('16100','2013-08-08','09:30:00',3.02),('16100','2013-08-08','09:35:00',4.34),('16100','2013-08-08','09:40:00',3.87),('16100','2013-08-08','09:45:00',3.87),('16100','2013-08-08','09:50:00',2.47),('16100','2013-08-08','09:55:00',3.38),('16100','2013-08-08','10:00:00',4.48),('16100','2013-08-08','10:05:00',3.97),('16100','2013-08-08','10:10:00',4.58),('16100','2013-08-08','10:15:00',4.62),('16100','2013-08-08','10:20:00',4.77),('16100','2013-08-08','10:25:00',4.82),('16100','2013-08-08','10:30:00',4.96),('16100','2013-08-08','10:35:00',5.15),('16100','2013-08-08','10:40:00',5.18),('16100','2013-08-08','10:45:00',5.32),('16100','2013-08-08','10:50:00',5.46),('16100','2013-08-08','10:55:00',5.48),('16100','2013-08-08','11:00:00',5.54),('16100','2013-08-08','11:05:00',5.61),('16100','2013-08-08','11:10:00',5.8),('16100','2013-08-08','11:15:00',5.89),('16100','2013-08-08','11:20:00',6),('16100','2013-08-08','11:25:00',6.03),('16100','2013-08-08','11:30:00',6),('16100','2013-08-08','11:35:00',6.05),('16100','2013-08-08','11:40:00',6.1),('16100','2013-08-08','11:45:00',6.14),('16100','2013-08-08','11:50:00',6.08),('16100','2013-08-08','11:55:00',6.14),('16100','2013-08-08','12:00:00',6.39),('16100','2013-08-08','12:05:00',6.5),('16100','2013-08-08','12:10:00',6.56),('16100','2013-08-08','12:15:00',6.69),('16100','2013-08-08','12:20:00',6.96),('16100','2013-08-08','12:25:00',7.21),('16100','2013-08-08','12:30:00',7.4),('16100','2013-08-08','12:35:00',5.05),('16100','2013-08-08','12:40:00',5.28),('16100','2013-08-08','12:45:00',4.9),('16100','2013-08-08','12:50:00',5.4),('16100','2013-08-08','12:55:00',4.36),('16100','2013-08-08','13:00:00',1.9),('16100','2013-08-08','13:05:00',1.34),('16100','2013-08-08','13:10:00',1.23),('16100','2013-08-08','13:15:00',1.62),('16100','2013-08-08','13:20:00',2.39),('16100','2013-08-08','13:25:00',3.29),('16100','2013-08-08','13:30:00',2.83),('16100','2013-08-08','13:35:00',2.64),('16100','2013-08-08','13:40:00',2.15),('16100','2013-08-08','13:45:00',1.78),('16100','2013-08-08','13:50:00',1.82),('16100','2013-08-08','13:55:00',2.08),('16100','2013-08-08','14:00:00',2.07),('16100','2013-08-08','14:05:00',1.79),('16100','2013-08-08','14:10:00',1.52),('16100','2013-08-08','14:15:00',1.3),('16100','2013-08-08','14:20:00',1.07),('16100','2013-08-08','14:30:00',1.08),('16100','2013-08-08','14:35:00',1.19),('16100','2013-08-08','14:40:00',1),('16100','2013-08-08','15:10:00',2.14),('16100','2013-08-08','15:15:00',5.35),('16100','2013-08-08','15:20:00',4.35),('16100','2013-08-08','15:25:00',1.6),('16100','2013-08-08','15:30:00',2),('16100','2013-08-08','15:35:00',2.92),('16100','2013-08-08','15:40:00',5.47),('16100','2013-08-08','15:45:00',4.19),('16100','2013-08-08','15:50:00',2.65),('16100','2013-08-08','15:55:00',2.44),('16100','2013-08-08','16:00:00',1.47),('16100','2013-08-08','16:05:00',1.1),('16100','2013-08-08','16:35:00',1.16),('16100','2013-08-08','16:40:00',1.18),('16100','2013-08-08','16:45:00',2.26),('16100','2013-08-08','16:50:00',3.03),('16100','2013-08-08','16:55:00',2.73),('16100','2013-08-08','17:00:00',1.44),('16100','2013-08-08','17:05:00',1.39),('16100','2013-08-08','17:10:00',1.47),('16100','2013-08-08','17:15:00',1.11),('16100','2013-08-08','17:30:00',1),('16100','2013-08-08','17:35:00',1.07),('16100','2013-08-08','17:40:00',1.08),('16100','2013-08-08','17:45:00',1.03),('16100','2013-08-08','19:00:00',1.14),('16100','2013-08-08','19:05:00',1.28),('16100','2013-08-08','19:10:00',1.28),('16100','2013-08-08','19:15:00',1.3),('16100','2013-08-08','19:20:00',1.32),('16100','2013-08-08','19:25:00',1.35),('16100','2013-08-07','08:05:00',1.04),('16100','2013-08-07','08:10:00',1.17),('16100','2013-08-07','08:15:00',1.31),('16100','2013-08-07','08:20:00',1.46),('16100','2013-08-07','08:25:00',1.6),('16100','2013-08-07','08:30:00',1.74),('16100','2013-08-07','08:35:00',1.92),('16100','2013-08-07','08:40:00',2.1),('16100','2013-08-07','08:45:00',2.38),('16100','2013-08-07','08:50:00',2.58),('16100','2013-08-07','08:55:00',2.71),('16100','2013-08-07','09:00:00',2.85),('16100','2013-08-07','09:05:00',3.01),('16100','2013-08-07','09:10:00',3.14),('16100','2013-08-07','09:15:00',3.29),('16100','2013-08-07','09:20:00',3.43),('16100','2013-08-07','09:25:00',3.56),('16100','2013-08-07','09:30:00',3.7),('16100','2013-08-07','09:35:00',3.84),('16100','2013-08-07','09:40:00',3.99),('16100','2013-08-07','09:45:00',4.11),('16100','2013-08-07','09:50:00',4.22),('16100','2013-08-07','09:55:00',4.32),('16100','2013-08-07','10:00:00',4.46),('16100','2013-08-07','10:05:00',4.59),('16100','2013-08-07','10:10:00',4.69),('16100','2013-08-07','10:15:00',4.79),('16100','2013-08-07','10:20:00',4.97),('16100','2013-08-07','10:25:00',5.06),('16100','2013-08-07','10:30:00',5.13),('16100','2013-08-07','10:35:00',5.22),('16100','2013-08-07','10:40:00',5.31),('16100','2013-08-07','10:45:00',5.37),('16100','2013-08-07','10:50:00',5.48),('16100','2013-08-07','11:00:00',5.68),('16100','2013-08-07','11:05:00',5.72),('16100','2013-08-07','11:10:00',5.85),('16100','2013-08-07','11:15:00',5.88),('16100','2013-08-07','11:20:00',5.95),('16100','2013-08-07','11:25:00',5.94),('16100','2013-08-07','11:30:00',6.01),('16100','2013-08-07','11:35:00',6.16),('16100','2013-08-07','11:40:00',6.29),('16100','2013-08-07','11:45:00',6.25),('16100','2013-08-07','11:50:00',6.29),('16100','2013-08-07','11:55:00',6.4),('16100','2013-08-07','12:00:00',6.46),('16100','2013-08-07','12:05:00',6.38),('16100','2013-08-07','12:10:00',6.52),('16100','2013-08-07','12:15:00',6.5),('16100','2013-08-07','12:20:00',6.65),('16100','2013-08-07','12:25:00',6.64),('16100','2013-08-07','12:30:00',6.73),('16100','2013-08-07','12:35:00',6.78),('16100','2013-08-07','12:40:00',6.82),('16100','2013-08-07','12:45:00',6.9),('16100','2013-08-07','12:50:00',6.95),('16100','2013-08-07','12:55:00',6.97),('16100','2013-08-07','13:00:00',6.99),('16100','2013-08-07','13:05:00',7),('16100','2013-08-07','13:10:00',6.96),('16100','2013-08-07','13:15:00',7),('16100','2013-08-07','13:20:00',7.02),('16100','2013-08-07','13:25:00',7.01),('16100','2013-08-07','13:30:00',6.94),('16100','2013-08-07','13:35:00',6.99),('16100','2013-08-07','13:40:00',6.95),('16100','2013-08-07','13:45:00',6.9),('16100','2013-08-07','13:50:00',6.89),('16100','2013-08-07','13:55:00',6.83),('16100','2013-08-07','14:00:00',6.86),('16100','2013-08-07','14:05:00',6.82),('16100','2013-08-07','14:10:00',6.75),('16100','2013-08-07','14:15:00',6.63),('16100','2013-08-07','14:20:00',6.65),('16100','2013-08-07','14:25:00',6.64),('16100','2013-08-07','14:30:00',6.55),('16100','2013-08-07','14:35:00',6.53),('16100','2013-08-07','14:40:00',6.5),('16100','2013-08-07','14:45:00',6.48),('16100','2013-08-07','14:50:00',6.43),('16100','2013-08-07','14:55:00',6.33),('16100','2013-08-07','15:00:00',6.24),('16100','2013-08-07','15:05:00',6.16),('16100','2013-08-07','15:10:00',6.1),('16100','2013-08-07','15:15:00',6.03),('16100','2013-08-07','15:20:00',5.97),('16100','2013-08-07','15:25:00',5.89),('16100','2013-08-07','15:30:00',5.8),('16100','2013-08-07','15:35:00',5.7),('16100','2013-08-07','15:40:00',5.59),('16100','2013-08-07','15:45:00',5.56),('16100','2013-08-07','15:50:00',5.47),('16100','2013-08-07','15:55:00',5.37),('16100','2013-08-07','16:00:00',5.33),('16100','2013-08-07','16:05:00',5.23),('16100','2013-08-07','16:10:00',5.15),('16100','2013-08-07','16:15:00',5.02),('16100','2013-08-07','16:20:00',4.85),('16100','2013-08-07','16:25:00',3.85),('16100','2013-08-07','16:30:00',4.63),('16100','2013-08-07','16:35:00',4.5),('16100','2013-08-07','16:40:00',4.41),('16100','2013-08-07','16:45:00',4.29),('16100','2013-08-07','16:50:00',4.16),('16100','2013-08-07','16:55:00',3.74),('16100','2013-08-07','17:00:00',3.2),('16100','2013-08-07','17:05:00',3.02),('16100','2013-08-07','17:10:00',3.61),('16100','2013-08-07','17:15:00',3.49),('16100','2013-08-07','17:20:00',2.66),('16100','2013-08-07','17:25:00',3.24),('16100','2013-08-07','17:30:00',2.6),('16100','2013-08-07','17:35:00',2.64),('16100','2013-08-07','17:40:00',1.9),('16100','2013-08-07','17:45:00',2.09),('16100','2013-08-07','17:50:00',1.46),('16100','2013-08-07','17:55:00',2.32),('16100','2013-08-07','18:00:00',2.17),('16100','2013-08-07','18:05:00',2.03),('16100','2013-08-07','18:10:00',1.89),('16100','2013-08-07','18:15:00',1.76),('16100','2013-08-07','18:20:00',1.61),('16100','2013-08-07','18:25:00',1.47),('16100','2013-08-07','18:30:00',1.35),('16100','2013-08-07','18:35:00',1.23),('16100','2013-08-07','18:40:00',1.09),('16100','2013-08-06','08:05:00',1.09),('16100','2013-08-06','08:10:00',1.21),('16100','2013-08-06','08:15:00',1.34),('16100','2013-08-06','08:20:00',1.5),('16100','2013-08-06','08:25:00',1.65),('16100','2013-08-06','08:30:00',1.79),('16100','2013-08-06','08:35:00',1.95),('16100','2013-08-06','08:40:00',2.13),('16100','2013-08-06','08:45:00',2.45),('16100','2013-08-06','08:50:00',2.67),('16100','2013-08-06','08:55:00',2.82),('16100','2013-08-06','09:00:00',2.97),('16100','2013-08-06','09:05:00',3.13),('16100','2013-08-06','09:10:00',3.28),('16100','2013-08-06','09:15:00',3.39),('16100','2013-08-06','09:20:00',3.51),('16100','2013-08-06','09:25:00',3.61),('16100','2013-08-06','09:30:00',3.73),('16100','2013-08-06','09:35:00',3.87),('16100','2013-08-06','09:40:00',3.92),('16100','2013-08-06','09:45:00',4.08),('16100','2013-08-06','09:50:00',4.19),('16100','2013-08-06','09:55:00',4.38),('16100','2013-08-06','10:00:00',4.5),('16100','2013-08-06','10:05:00',4.62),('16100','2013-08-06','10:10:00',4.7),('16100','2013-08-06','10:15:00',4.83),('16100','2013-08-06','10:20:00',4.93),('16100','2013-08-06','10:25:00',5.08),('16100','2013-08-06','10:30:00',5.18),('16100','2013-08-06','10:35:00',5.31),('16100','2013-08-06','10:40:00',5.38),('16100','2013-08-06','10:45:00',5.44),('16100','2013-08-06','10:50:00',5.51),('16100','2013-08-06','10:55:00',5.61),('16100','2013-08-06','11:00:00',5.68),('16100','2013-08-06','11:05:00',5.75),('16100','2013-08-06','11:10:00',5.82),('16100','2013-08-06','11:15:00',5.87),('16100','2013-08-06','11:20:00',5.95),('16100','2013-08-06','11:25:00',6.05),('16100','2013-08-06','11:30:00',6.12),('16100','2013-08-06','11:35:00',6.2),('16100','2013-08-06','11:40:00',6.27),('16100','2013-08-06','11:45:00',6.3),('16100','2013-08-06','11:50:00',6.37),('16100','2013-08-06','11:55:00',6.42),('16100','2013-08-06','12:00:00',6.42),('16100','2013-08-06','12:05:00',6.4),('16100','2013-08-06','12:10:00',6.41),('16100','2013-08-06','12:15:00',6.5),('16100','2013-08-06','12:20:00',6.56),('16100','2013-08-06','12:25:00',6.46),('16100','2013-08-06','12:30:00',6.6),('16100','2013-08-06','12:35:00',6.5),('16100','2013-08-06','12:40:00',6.62),('16100','2013-08-06','12:45:00',6.75),('16100','2013-08-06','12:50:00',6.73),('16100','2013-08-06','12:55:00',6.86),('16100','2013-08-06','13:00:00',6.86),('16100','2013-08-06','13:05:00',7.01),('16100','2013-08-06','13:10:00',6.89),('16100','2013-08-06','13:15:00',6.87),('16100','2013-08-06','13:20:00',6.96),('16100','2013-08-06','13:25:00',6.99),('16100','2013-08-06','13:30:00',6.97),('16100','2013-08-06','13:35:00',6.9),('16100','2013-08-06','13:40:00',6.99),('16100','2013-08-06','13:45:00',6.97),('16100','2013-08-06','13:50:00',6.95),('16100','2013-08-06','13:55:00',6.9),('16100','2013-08-06','14:00:00',6.88),('16100','2013-08-06','14:05:00',6.9),('16100','2013-08-06','14:10:00',6.87),('16100','2013-08-06','14:15:00',6.79),('16100','2013-08-06','14:20:00',6.76),('16100','2013-08-06','14:25:00',6.75),('16100','2013-08-06','14:30:00',6.71),('16100','2013-08-06','14:35:00',6.67),('16100','2013-08-06','14:40:00',6.66),('16100','2013-08-06','14:45:00',6.63),('16100','2013-08-06','14:50:00',6.59),('16100','2013-08-06','14:55:00',6.54),('16100','2013-08-06','15:00:00',6.5),('16100','2013-08-06','15:05:00',6.43),('16100','2013-08-06','15:10:00',6.35),('16100','2013-08-06','15:15:00',6.28),('16100','2013-08-06','15:20:00',6.15),('16100','2013-08-06','15:25:00',6.08),('16100','2013-08-06','15:30:00',5.97),('16100','2013-08-06','15:35:00',5.91),('16100','2013-08-06','15:40:00',5.81),('16100','2013-08-06','15:45:00',5.71),('16100','2013-08-06','15:50:00',5.62),('16100','2013-08-06','15:55:00',5.53),('16100','2013-08-06','16:00:00',5.46),('16100','2013-08-06','16:05:00',5.36),('16100','2013-08-06','16:10:00',5.26),('16100','2013-08-06','16:15:00',5.16),('16100','2013-08-06','16:20:00',4.99),('16100','2013-08-06','16:25:00',4.88),('16100','2013-08-06','16:30:00',4.76),('16100','2013-08-06','16:35:00',4.63),('16100','2013-08-06','16:40:00',4.51),('16100','2013-08-06','16:45:00',4.41),('16100','2013-08-06','16:50:00',4.3),('16100','2013-08-06','16:55:00',4.18),('16100','2013-08-06','17:00:00',4.05),('16100','2013-08-06','17:05:00',3.9),('16100','2013-08-06','17:10:00',3.73),('16100','2013-08-06','17:15:00',3.59),('16100','2013-08-06','17:20:00',3.46),('16100','2013-08-06','17:25:00',3.31),('16100','2013-08-06','17:30:00',3.17),('16100','2013-08-06','17:35:00',3),('16100','2013-08-06','17:40:00',2.88),('16100','2013-08-06','17:45:00',2.75),('16100','2013-08-06','17:50:00',2.61),('16100','2013-08-06','17:55:00',2.43),('16100','2013-08-06','18:00:00',2.27),('16100','2013-08-06','18:05:00',2.12),('16100','2013-08-06','18:10:00',1.98),('16100','2013-08-06','18:15:00',1.81),('16100','2013-08-06','18:20:00',1.68),('16100','2013-08-06','18:25:00',1.53),('16100','2013-08-06','18:30:00',1.4),('16100','2013-08-06','18:35:00',1.27),('16100','2013-08-05','08:05:00',1.07),('16100','2013-08-05','08:10:00',1.19),('16100','2013-08-05','08:15:00',1.31),('16100','2013-08-05','08:20:00',1.47),('16100','2013-08-05','08:25:00',1.61),('16100','2013-08-05','08:30:00',1.76),('16100','2013-08-05','08:35:00',1.92),('16100','2013-08-05','08:40:00',2.06),('16100','2013-08-05','08:45:00',2.35),('16100','2013-08-05','08:50:00',2.59),('16100','2013-08-05','08:55:00',2.75),('16100','2013-08-05','09:00:00',2.93),('16100','2013-08-05','09:05:00',3.09),('16100','2013-08-05','09:10:00',3.19),('16100','2013-08-05','09:15:00',3.28),('16100','2013-08-05','09:20:00',3.44),('16100','2013-08-05','09:25:00',3.61),('16100','2013-08-05','09:30:00',3.73),('16100','2013-08-05','09:35:00',3.88),('16100','2013-08-05','09:40:00',3.98),('16100','2013-08-05','09:45:00',4.08),('16100','2013-08-05','09:50:00',4.22),('16100','2013-08-05','09:55:00',4.35),('16100','2013-08-05','10:00:00',4.47),('16100','2013-08-05','10:05:00',4.63),('16100','2013-08-05','10:10:00',4.73),('16100','2013-08-05','10:15:00',4.89),('16100','2013-08-05','10:20:00',5.06),('16100','2013-08-05','10:25:00',5.19),('16100','2013-08-05','10:30:00',5.25),('16100','2013-08-05','10:35:00',5.32),('16100','2013-08-05','10:40:00',5.39),('16100','2013-08-05','10:45:00',5.47),('16100','2013-08-05','10:50:00',5.57),('16100','2013-08-05','10:55:00',5.65),('16100','2013-08-05','11:00:00',5.73),('16100','2013-08-05','11:05:00',5.78),('16100','2013-08-05','11:10:00',5.86),('16100','2013-08-05','11:15:00',5.98),('16100','2013-08-05','11:20:00',6.01),('16100','2013-08-05','11:25:00',6.09),('16100','2013-08-05','11:30:00',6.22),('16100','2013-08-05','11:35:00',6.22),('16100','2013-08-05','11:40:00',6.2),('16100','2013-08-05','11:45:00',6.3),('16100','2013-08-05','11:50:00',6.3),('16100','2013-08-05','11:55:00',6.36),('16100','2013-08-05','12:00:00',6.37),('16100','2013-08-05','12:05:00',6.31),('16100','2013-08-05','12:10:00',6.41),('16100','2013-08-05','12:15:00',6.46),('16100','2013-08-05','12:20:00',6.67),('16100','2013-08-05','12:25:00',6.52),('16100','2013-08-05','12:30:00',6.52),('16100','2013-08-05','12:35:00',6.6),('16100','2013-08-05','12:40:00',6.69),('16100','2013-08-05','12:45:00',6.77),('16100','2013-08-05','12:50:00',6.84),('16100','2013-08-05','12:55:00',6.83),('16100','2013-08-05','13:00:00',6.45),('16100','2013-08-05','13:05:00',6.88),('16100','2013-08-05','13:10:00',6.95),('16100','2013-08-05','13:15:00',7.03),('16100','2013-08-05','13:20:00',7.05),('16100','2013-08-05','13:25:00',7.07),('16100','2013-08-05','13:30:00',7.03),('16100','2013-08-05','13:35:00',6.9),('16100','2013-08-05','13:40:00',6.72),('16100','2013-08-05','13:45:00',7.09),('16100','2013-08-05','13:50:00',7.1),('16100','2013-08-05','13:55:00',7.08),('16100','2013-08-05','14:00:00',7.08),('16100','2013-08-05','14:05:00',7.03),('16100','2013-08-05','14:10:00',7.03),('16100','2013-08-05','14:15:00',6.95),('16100','2013-08-05','14:20:00',6.71),('16100','2013-08-05','14:25:00',6.78),('16100','2013-08-05','14:30:00',6.76),('16100','2013-08-05','14:35:00',6.73),('16100','2013-08-05','14:40:00',6.69),('16100','2013-08-05','14:45:00',6.65),('16100','2013-08-05','14:50:00',6.6),('16100','2013-08-05','14:55:00',6.55),('16100','2013-08-05','15:00:00',6.47),('16100','2013-08-05','15:05:00',6.46),('16100','2013-08-05','15:10:00',6.44),('16100','2013-08-05','15:15:00',6.36),('16100','2013-08-05','15:20:00',6.29),('16100','2013-08-05','15:25:00',6.16),('16100','2013-08-05','15:30:00',6.04),('16100','2013-08-05','15:35:00',5.96),('16100','2013-08-05','15:40:00',5.86),('16100','2013-08-05','15:45:00',5.77),('16100','2013-08-05','15:50:00',5.68),('16100','2013-08-05','15:55:00',5.58),('16100','2013-08-05','16:00:00',5.49),('16100','2013-08-05','16:05:00',5.43),('16100','2013-08-05','16:10:00',5.32),('16100','2013-08-05','16:15:00',5.2),('16100','2013-08-05','16:20:00',5.05),('16100','2013-08-05','16:25:00',4.92),('16100','2013-08-05','16:30:00',4.82),('16100','2013-08-05','16:35:00',4.7),('16100','2013-08-05','16:40:00',4.61),('16100','2013-08-05','16:45:00',4.48),('16100','2013-08-05','16:50:00',4.35),('16100','2013-08-05','16:55:00',4.23),('16100','2013-08-05','17:00:00',4.1),('16100','2013-08-05','17:05:00',3.96),('16100','2013-08-05','17:10:00',3.8),('16100','2013-08-05','17:15:00',3.68),('16100','2013-08-05','17:20:00',3.53),('16100','2013-08-05','17:25:00',3.4),('16100','2013-08-05','17:30:00',3.26),('16100','2013-08-05','17:35:00',3.07),('16100','2013-08-05','17:40:00',2.91),('16100','2013-08-05','17:45:00',2.77),('16100','2013-08-05','17:50:00',2.63),('16100','2013-08-05','17:55:00',2.46),('16100','2013-08-05','18:00:00',2.31),('16100','2013-08-05','18:05:00',2.17),('16100','2013-08-05','18:10:00',2.03),('16100','2013-08-05','18:15:00',1.9),('16100','2013-08-05','18:20:00',1.76),('16100','2013-08-05','18:25:00',1.61),('16100','2013-08-05','18:30:00',1.44),('16100','2013-08-05','18:35:00',1.29),('16100','2013-08-05','18:40:00',1.14),('16100','2013-08-04','08:05:00',1.12),('16100','2013-08-04','08:10:00',1.24),('16100','2013-08-04','08:15:00',1.37),('16100','2013-08-04','08:20:00',1.53),('16100','2013-08-04','08:25:00',1.68),('16100','2013-08-04','08:30:00',1.83),('16100','2013-08-04','08:35:00',1.98),('16100','2013-08-04','08:40:00',2.18),('16100','2013-08-04','08:45:00',2.4),('16100','2013-08-04','08:50:00',2.66),('16100','2013-08-04','08:55:00',2.83),('16100','2013-08-04','09:00:00',2.99),('16100','2013-08-04','09:05:00',3.19),('16100','2013-08-04','09:10:00',3.34),('16100','2013-08-04','09:15:00',3.47),('16100','2013-08-04','09:20:00',3.54),('16100','2013-08-04','09:25:00',3.68),('16100','2013-08-04','09:30:00',3.83),('16100','2013-08-04','09:35:00',3.95),('16100','2013-08-04','09:40:00',4.09),('16100','2013-08-04','09:45:00',4.21),('16100','2013-08-04','09:50:00',4.33),('16100','2013-08-04','09:55:00',4.43),('16100','2013-08-04','10:00:00',4.54),('16100','2013-08-04','10:05:00',4.66),('16100','2013-08-04','10:10:00',4.79),('16100','2013-08-04','10:15:00',4.95),('16100','2013-08-04','10:20:00',5.12),('16100','2013-08-04','10:25:00',5.24),('16100','2013-08-04','10:30:00',5.32),('16100','2013-08-04','10:35:00',5.41),('16100','2013-08-04','10:40:00',5.49),('16100','2013-08-04','10:45:00',5.55),('16100','2013-08-04','10:50:00',5.62),('16100','2013-08-04','10:55:00',5.7),('16100','2013-08-04','11:00:00',5.8),('16100','2013-08-04','11:05:00',5.89),('16100','2013-08-04','11:10:00',5.98),('16100','2013-08-04','11:15:00',6.13),('16100','2013-08-04','11:20:00',6.21),('16100','2013-08-04','11:25:00',6.24),('16100','2013-08-04','11:30:00',6.35),('16100','2013-08-04','11:35:00',6.39),('16100','2013-08-04','11:40:00',6.46),('16100','2013-08-04','11:45:00',6.54),('16100','2013-08-04','11:50:00',6.57),('16100','2013-08-04','11:55:00',6.65),('16100','2013-08-04','12:00:00',6.69),('16100','2013-08-04','12:05:00',6.76),('16100','2013-08-04','12:10:00',6.77),('16100','2013-08-04','12:15:00',6.82),('16100','2013-08-04','12:20:00',6.91),('16100','2013-08-04','12:25:00',6.84),('16100','2013-08-04','12:30:00',6.84),('16100','2013-08-04','12:35:00',6.87),('16100','2013-08-04','12:40:00',6.87),('16100','2013-08-04','12:45:00',6.96),('16100','2013-08-04','12:50:00',6.95),('16100','2013-08-04','12:55:00',6.99),('16100','2013-08-04','13:00:00',7),('16100','2013-08-04','13:05:00',6.98),('16100','2013-08-04','13:10:00',7),('16100','2013-08-04','13:15:00',7.03),('16100','2013-08-04','13:20:00',7.06),('16100','2013-08-04','13:25:00',7.01),('16100','2013-08-04','13:30:00',6.99),('16100','2013-08-04','13:35:00',6.98),('16100','2013-08-04','13:40:00',6.97),('16100','2013-08-04','13:45:00',6.95),('16100','2013-08-04','13:50:00',6.94),('16100','2013-08-04','13:55:00',6.89),('16100','2013-08-04','14:00:00',6.86),('16100','2013-08-04','14:05:00',6.8),('16100','2013-08-04','14:10:00',6.83),('16100','2013-08-04','14:15:00',6.75),('16100','2013-08-04','14:20:00',6.79),('16100','2013-08-04','14:25:00',6.76),('16100','2013-08-04','14:30:00',6.71),('16100','2013-08-04','14:35:00',6.61),('16100','2013-08-04','14:40:00',6.56),('16100','2013-08-04','14:45:00',6.53),('16100','2013-08-04','14:50:00',6.46),('16100','2013-08-04','14:55:00',6.43),('16100','2013-08-04','15:00:00',6.4),('16100','2013-08-04','15:05:00',6.36),('16100','2013-08-04','15:10:00',6.28),('16100','2013-08-04','15:15:00',6.18),('16100','2013-08-04','15:20:00',6.15),('16100','2013-08-04','15:25:00',6.1),('16100','2013-08-04','15:30:00',5.99),('16100','2013-08-04','15:35:00',5.92),('16100','2013-08-04','15:40:00',5.85),('16100','2013-08-04','15:45:00',5.76),('16100','2013-08-04','15:50:00',5.68),('16100','2013-08-04','15:55:00',5.58),('16100','2013-08-04','16:00:00',5.45),('16100','2013-08-04','16:05:00',5.37),('16100','2013-08-04','16:10:00',5.29),('16100','2013-08-04','16:15:00',5.19),('16100','2013-08-04','16:20:00',5.02),('16100','2013-08-04','16:25:00',4.9),('16100','2013-08-04','16:30:00',4.81),('16100','2013-08-04','16:35:00',4.68),('16100','2013-08-04','16:40:00',4.54),('16100','2013-08-04','16:45:00',4.43),('16100','2013-08-04','16:50:00',4.3),('16100','2013-08-04','16:55:00',4.19),('16100','2013-08-04','17:00:00',4.05),('16100','2013-08-04','17:05:00',3.9),('16100','2013-08-04','17:10:00',3.71),('16100','2013-08-04','17:15:00',3.62),('16100','2013-08-04','17:20:00',3.49),('16100','2013-08-04','17:25:00',3.36),('16100','2013-08-04','17:30:00',3.23),('16100','2013-08-04','17:35:00',3.06),('16100','2013-08-04','17:40:00',2.92),('16100','2013-08-04','17:45:00',2.75),('16100','2013-08-04','17:50:00',2.59),('16100','2013-08-04','17:55:00',2.43),('16100','2013-08-04','18:00:00',2.27),('16100','2013-08-04','18:05:00',2.12),('16100','2013-08-04','18:10:00',1.97),('16100','2013-08-04','18:15:00',1.86),('16100','2013-08-04','18:20:00',1.73),('16100','2013-08-04','18:25:00',1.59),('16100','2013-08-04','18:30:00',1.44),('16100','2013-08-04','18:35:00',1.32),('16100','2013-08-04','18:40:00',1.16),('16100','2013-08-04','18:45:00',1),('16100','2013-08-03','08:00:00',1.02);
INSERT INTO `solarlog` VALUES ('16100','2013-08-03','08:05:00',1.15),('16100','2013-08-03','08:10:00',1.27),('16100','2013-08-03','08:15:00',1.42),('16100','2013-08-03','08:20:00',1.59),('16100','2013-08-03','08:25:00',1.75),('16100','2013-08-03','08:30:00',1.91),('16100','2013-08-03','08:35:00',2.07),('16100','2013-08-03','08:40:00',2.18),('16100','2013-08-03','08:45:00',2.42),('16100','2013-08-03','08:50:00',2.73),('16100','2013-08-03','08:55:00',2.97),('16100','2013-08-03','09:00:00',3.14),('16100','2013-08-03','09:05:00',3.31),('16100','2013-08-03','09:10:00',3.46),('16100','2013-08-03','09:15:00',3.59),('16100','2013-08-03','09:20:00',3.73),('16100','2013-08-03','09:25:00',3.86),('16100','2013-08-03','09:30:00',3.96),('16100','2013-08-03','09:35:00',4.1),('16100','2013-08-03','09:40:00',4.23),('16100','2013-08-03','09:45:00',4.36),('16100','2013-08-03','09:50:00',4.51),('16100','2013-08-03','09:55:00',4.65),('16100','2013-08-03','10:00:00',4.73),('16100','2013-08-03','10:05:00',4.83),('16100','2013-08-03','10:10:00',4.92),('16100','2013-08-03','10:15:00',5.08),('16100','2013-08-03','10:20:00',5.25),('16100','2013-08-03','10:25:00',5.39),('16100','2013-08-03','10:30:00',5.44),('16100','2013-08-03','10:35:00',5.52),('16100','2013-08-03','10:40:00',5.61),('16100','2013-08-03','10:45:00',5.7),('16100','2013-08-03','10:50:00',5.78),('16100','2013-08-03','10:55:00',5.89),('16100','2013-08-03','11:00:00',6.03),('16100','2013-08-03','11:05:00',6.16),('16100','2013-08-03','11:10:00',6.27),('16100','2013-08-03','11:15:00',6.31),('16100','2013-08-03','11:20:00',6.4),('16100','2013-08-03','11:25:00',6.47),('16100','2013-08-03','11:30:00',6.49),('16100','2013-08-03','11:35:00',6.5),('16100','2013-08-03','11:40:00',6.59),('16100','2013-08-03','11:45:00',6.76),('16100','2013-08-03','11:50:00',6.72),('16100','2013-08-03','11:55:00',6.81),('16100','2013-08-03','12:00:00',6.91),('16100','2013-08-03','12:05:00',6.85),('16100','2013-08-03','12:10:00',6.88),('16100','2013-08-03','12:15:00',6.89),('16100','2013-08-03','12:20:00',6.88),('16100','2013-08-03','12:25:00',6.9),('16100','2013-08-03','12:30:00',6.95),('16100','2013-08-03','12:35:00',7.01),('16100','2013-08-03','12:40:00',7.05),('16100','2013-08-03','12:45:00',7.06),('16100','2013-08-03','12:50:00',7.06),('16100','2013-08-03','12:55:00',7.11),('16100','2013-08-03','13:00:00',7.17),('16100','2013-08-03','13:05:00',7.14),('16100','2013-08-03','13:10:00',7.11),('16100','2013-08-03','13:15:00',7.17),('16100','2013-08-03','13:20:00',7.21),('16100','2013-08-03','13:25:00',7.25),('16100','2013-08-03','13:30:00',7.24),('16100','2013-08-03','13:35:00',7.23),('16100','2013-08-03','13:40:00',7.22),('16100','2013-08-03','13:45:00',7.21),('16100','2013-08-03','13:50:00',7.18),('16100','2013-08-03','13:55:00',7.18),('16100','2013-08-03','14:00:00',7.14),('16100','2013-08-03','14:05:00',7.14),('16100','2013-08-03','14:10:00',7.13),('16100','2013-08-03','14:15:00',7.02),('16100','2013-08-03','14:20:00',6.97),('16100','2013-08-03','14:25:00',6.91),('16100','2013-08-03','14:30:00',6.9),('16100','2013-08-03','14:35:00',6.86),('16100','2013-08-03','14:40:00',6.83),('16100','2013-08-03','14:45:00',6.81),('16100','2013-08-03','14:50:00',6.74),('16100','2013-08-03','14:55:00',5.31),('16100','2013-08-03','15:00:00',5.33),('16100','2013-08-03','15:05:00',6.55),('16100','2013-08-03','15:10:00',6.5),('16100','2013-08-03','15:15:00',6.4),('16100','2013-08-03','15:20:00',6.3),('16100','2013-08-03','15:25:00',6.26),('16100','2013-08-03','15:30:00',6.18),('16100','2013-08-03','15:35:00',6.11),('16100','2013-08-03','15:40:00',6.03),('16100','2013-08-03','15:45:00',5.89),('16100','2013-08-03','15:50:00',5.93),('16100','2013-08-03','15:55:00',5.82),('16100','2013-08-03','16:00:00',5.66),('16100','2013-08-03','16:05:00',5.52),('16100','2013-08-03','16:10:00',5.46),('16100','2013-08-03','16:15:00',5.32),('16100','2013-08-03','16:20:00',5.07),('16100','2013-08-03','16:25:00',5.02),('16100','2013-08-03','16:30:00',4.9),('16100','2013-08-03','16:35:00',4.81),('16100','2013-08-03','16:40:00',4.69),('16100','2013-08-03','16:45:00',4.66),('16100','2013-08-03','16:50:00',4.46),('16100','2013-08-03','16:55:00',4.3),('16100','2013-08-03','17:00:00',4.17),('16100','2013-08-03','17:05:00',4.06),('16100','2013-08-03','17:10:00',3.91),('16100','2013-08-03','17:15:00',3.75),('16100','2013-08-03','17:20:00',3.62),('16100','2013-08-03','17:25:00',3.46),('16100','2013-08-03','17:30:00',3.31),('16100','2013-08-03','17:35:00',3.14),('16100','2013-08-03','17:40:00',2.98),('16100','2013-08-03','17:45:00',2.82),('16100','2013-08-03','17:50:00',2.62),('16100','2013-08-03','17:55:00',2.47),('16100','2013-08-03','18:00:00',2.33),('16100','2013-08-03','18:05:00',2.14),('16100','2013-08-03','18:10:00',2.01),('16100','2013-08-03','18:15:00',1.88),('16100','2013-08-03','18:20:00',1.73),('16100','2013-08-03','18:25:00',1.59),('16100','2013-08-03','18:30:00',1.44),('16100','2013-08-03','18:35:00',1.3),('16100','2013-08-03','18:40:00',1.14),('16100','2013-08-02','08:00:00',1.03),('16100','2013-08-02','08:05:00',1.16),('16100','2013-08-02','08:10:00',1.28),('16100','2013-08-02','08:15:00',1.44),('16100','2013-08-02','08:20:00',1.61),('16100','2013-08-02','08:25:00',1.78),('16100','2013-08-02','08:30:00',1.96),('16100','2013-08-02','08:35:00',2.11),('16100','2013-08-02','08:40:00',2.28),('16100','2013-08-02','08:45:00',2.49),('16100','2013-08-02','08:50:00',2.73),('16100','2013-08-02','08:55:00',2.99),('16100','2013-08-02','09:00:00',3.16),('16100','2013-08-02','09:05:00',3.36),('16100','2013-08-02','09:10:00',3.49),('16100','2013-08-02','09:15:00',3.62),('16100','2013-08-02','09:20:00',3.74),('16100','2013-08-02','09:25:00',3.87),('16100','2013-08-02','09:30:00',3.96),('16100','2013-08-02','09:35:00',4.14),('16100','2013-08-02','09:40:00',4.29),('16100','2013-08-02','09:45:00',4.42),('16100','2013-08-02','09:50:00',4.54),('16100','2013-08-02','09:55:00',4.66),('16100','2013-08-02','10:00:00',4.75),('16100','2013-08-02','10:05:00',4.87),('16100','2013-08-02','10:10:00',4.97),('16100','2013-08-02','10:15:00',5.11),('16100','2013-08-02','10:20:00',5.24),('16100','2013-08-02','10:25:00',5.33),('16100','2013-08-02','10:30:00',5.42),('16100','2013-08-02','10:35:00',5.5),('16100','2013-08-02','10:40:00',5.56),('16100','2013-08-02','10:45:00',5.65),('16100','2013-08-02','10:50:00',5.82),('16100','2013-08-02','10:55:00',5.91),('16100','2013-08-02','11:00:00',5.95),('16100','2013-08-02','11:05:00',6.07),('16100','2013-08-02','11:10:00',6.18),('16100','2013-08-02','11:15:00',6.24),('16100','2013-08-02','11:20:00',6.3),('16100','2013-08-02','11:25:00',6.4),('16100','2013-08-02','11:30:00',6.39),('16100','2013-08-02','11:35:00',6.46),('16100','2013-08-02','11:40:00',6.55),('16100','2013-08-02','11:45:00',6.61),('16100','2013-08-02','11:50:00',6.71),('16100','2013-08-02','11:55:00',6.78),('16100','2013-08-02','12:00:00',6.82),('16100','2013-08-02','12:05:00',6.83),('16100','2013-08-02','12:10:00',6.8),('16100','2013-08-02','12:15:00',6.76),('16100','2013-08-02','12:20:00',6.71),('16100','2013-08-02','12:25:00',6.88),('16100','2013-08-02','12:30:00',6.9),('16100','2013-08-02','12:35:00',6.85),('16100','2013-08-02','12:40:00',6.8),('16100','2013-08-02','12:45:00',6.89),('16100','2013-08-02','12:50:00',7.01),('16100','2013-08-02','12:55:00',7.06),('16100','2013-08-02','13:00:00',6.95),('16100','2013-08-02','13:05:00',6.88),('16100','2013-08-02','13:10:00',6.89),('16100','2013-08-02','13:15:00',6.92),('16100','2013-08-02','13:20:00',7.01),('16100','2013-08-02','13:25:00',7.04),('16100','2013-08-02','13:30:00',6.94),('16100','2013-08-02','13:35:00',6.88),('16100','2013-08-02','13:40:00',6.91),('16100','2013-08-02','13:45:00',6.68),('16100','2013-08-02','13:50:00',6.97),('16100','2013-08-02','13:55:00',6.58),('16100','2013-08-02','14:00:00',6.6),('16100','2013-08-02','14:05:00',6.83),('16100','2013-08-02','14:10:00',6.88),('16100','2013-08-02','14:15:00',6.9),('16100','2013-08-02','14:20:00',6.87),('16100','2013-08-02','14:25:00',6.85),('16100','2013-08-02','14:30:00',6.79),('16100','2013-08-02','14:35:00',6.76),('16100','2013-08-02','14:40:00',6.79),('16100','2013-08-02','14:45:00',6.8),('16100','2013-08-02','14:50:00',6.73),('16100','2013-08-02','14:55:00',6.65),('16100','2013-08-02','15:00:00',6.61),('16100','2013-08-02','15:05:00',6.54),('16100','2013-08-02','15:10:00',6.45),('16100','2013-08-02','15:15:00',6.36),('16100','2013-08-02','15:20:00',6.31),('16100','2013-08-02','15:25:00',6.23),('16100','2013-08-02','15:30:00',6.14),('16100','2013-08-02','15:35:00',6.03),('16100','2013-08-02','15:40:00',5.99),('16100','2013-08-02','15:45:00',5.95),('16100','2013-08-02','15:50:00',5.87),('16100','2013-08-02','15:55:00',5.77),('16100','2013-08-02','16:00:00',5.67),('16100','2013-08-02','16:05:00',5.59),('16100','2013-08-02','16:10:00',5.45),('16100','2013-08-02','16:15:00',5.31),('16100','2013-08-02','16:20:00',5.17),('16100','2013-08-02','16:25:00',5.04),('16100','2013-08-02','16:30:00',4.91),('16100','2013-08-02','16:35:00',4.81),('16100','2013-08-02','16:40:00',4.7),('16100','2013-08-02','16:45:00',4.57),('16100','2013-08-02','16:50:00',4.45),('16100','2013-08-02','16:55:00',4.34),('16100','2013-08-02','17:00:00',4.22),('16100','2013-08-02','17:05:00',4.09),('16100','2013-08-02','17:10:00',3.92),('16100','2013-08-02','17:15:00',3.79),('16100','2013-08-02','17:20:00',3.65),('16100','2013-08-02','17:25:00',3.51),('16100','2013-08-02','17:30:00',3.38),('16100','2013-08-02','17:35:00',3.22),('16100','2013-08-02','17:40:00',3.06),('16100','2013-08-02','17:45:00',2.9),('16100','2013-08-02','17:50:00',2.74),('16100','2013-08-02','17:55:00',2.59),('16100','2013-08-02','18:00:00',2.43),('16100','2013-08-02','18:05:00',2.29),('16100','2013-08-02','18:10:00',2.15),('16100','2013-08-02','18:15:00',1.99),('16100','2013-08-02','18:20:00',1.84),('16100','2013-08-02','18:25:00',1.69),('16100','2013-08-02','18:30:00',1.55),('16100','2013-08-02','18:35:00',1.4),('16100','2013-08-02','18:40:00',1.22),('16100','2013-08-02','18:45:00',1.05),('16100','2013-08-01','08:00:00',1.06),('16100','2013-08-01','08:05:00',1.21),('16100','2013-08-01','08:10:00',1.34),('16100','2013-08-01','08:15:00',1.52),('16100','2013-08-01','08:20:00',1.68),('16100','2013-08-01','08:25:00',1.85),('16100','2013-08-01','08:30:00',2.04),('16100','2013-08-01','08:35:00',2.2),('16100','2013-08-01','08:40:00',2.34),('16100','2013-08-01','08:45:00',2.53),('16100','2013-08-01','08:50:00',2.76),('16100','2013-08-01','08:55:00',3.08),('16100','2013-08-01','09:00:00',3.29),('16100','2013-08-01','09:05:00',3.48),('16100','2013-08-01','09:10:00',3.61),('16100','2013-08-01','09:15:00',3.76),('16100','2013-08-01','09:20:00',3.89),('16100','2013-08-01','09:25:00',4.03),('16100','2013-08-01','09:30:00',4.16),('16100','2013-08-01','09:35:00',4.31),('16100','2013-08-01','09:40:00',4.4),('16100','2013-08-01','09:45:00',4.52),('16100','2013-08-01','09:50:00',4.65),('16100','2013-08-01','09:55:00',4.77),('16100','2013-08-01','10:00:00',4.88),('16100','2013-08-01','10:05:00',4.97),('16100','2013-08-01','10:10:00',5.06),('16100','2013-08-01','10:15:00',5.24),('16100','2013-08-01','10:20:00',5.35),('16100','2013-08-01','10:25:00',5.44),('16100','2013-08-01','10:30:00',5.54),('16100','2013-08-01','10:35:00',5.65),('16100','2013-08-01','10:40:00',5.77),('16100','2013-08-01','10:45:00',5.89),('16100','2013-08-01','10:50:00',5.95),('16100','2013-08-01','10:55:00',6.03),('16100','2013-08-01','11:00:00',6.08),('16100','2013-08-01','11:05:00',6.2),('16100','2013-08-01','11:10:00',6.29),('16100','2013-08-01','11:15:00',6.37),('16100','2013-08-01','11:20:00',6.38),('16100','2013-08-01','11:25:00',6.44),('16100','2013-08-01','11:30:00',6.5),('16100','2013-08-01','11:35:00',6.6),('16100','2013-08-01','11:40:00',6.66),('16100','2013-08-01','11:45:00',6.7),('16100','2013-08-01','11:50:00',6.79),('16100','2013-08-01','11:55:00',6.83),('16100','2013-08-01','12:00:00',6.86),('16100','2013-08-01','12:05:00',6.89),('16100','2013-08-01','12:10:00',6.95),('16100','2013-08-01','12:15:00',7),('16100','2013-08-01','12:20:00',7),('16100','2013-08-01','12:25:00',6.99),('16100','2013-08-01','12:30:00',7.02),('16100','2013-08-01','12:35:00',7.09),('16100','2013-08-01','12:40:00',7.11),('16100','2013-08-01','12:45:00',7.17),('16100','2013-08-01','12:50:00',7.23),('16100','2013-08-01','12:55:00',7.23),('16100','2013-08-01','13:00:00',7.22),('16100','2013-08-01','13:05:00',7.17),('16100','2013-08-01','13:10:00',7.18),('16100','2013-08-01','13:15:00',7.16),('16100','2013-08-01','13:20:00',7.15),('16100','2013-08-01','13:25:00',7.08),('16100','2013-08-01','13:30:00',7.08),('16100','2013-08-01','13:35:00',7.08),('16100','2013-08-01','13:40:00',7.03),('16100','2013-08-01','13:45:00',7.06),('16100','2013-08-01','13:50:00',7.03),('16100','2013-08-01','13:55:00',6.93),('16100','2013-08-01','14:00:00',6.84),('16100','2013-08-01','14:05:00',7.07),('16100','2013-08-01','14:10:00',6.98),('16100','2013-08-01','14:15:00',6.77),('16100','2013-08-01','14:20:00',6.66),('16100','2013-08-01','14:25:00',6.75),('16100','2013-08-01','14:30:00',6.8),('16100','2013-08-01','14:35:00',6.79),('16100','2013-08-01','14:40:00',6.79),('16100','2013-08-01','14:45:00',6.79),('16100','2013-08-01','14:50:00',6.74),('16100','2013-08-01','14:55:00',6.67),('16100','2013-08-01','15:00:00',6.58),('16100','2013-08-01','15:05:00',6.57),('16100','2013-08-01','15:10:00',6.51),('16100','2013-08-01','15:15:00',6.46),('16100','2013-08-01','15:20:00',6.39),('16100','2013-08-01','15:25:00',6.33),('16100','2013-08-01','15:30:00',6.19),('16100','2013-08-01','15:35:00',6.11),('16100','2013-08-01','15:40:00',6.05),('16100','2013-08-01','15:45:00',5.98),('16100','2013-08-01','15:50:00',5.9),('16100','2013-08-01','15:55:00',5.83),('16100','2013-08-01','16:00:00',5.78),('16100','2013-08-01','16:05:00',5.68),('16100','2013-08-01','16:10:00',5.55),('16100','2013-08-01','16:15:00',5.41),('16100','2013-08-01','16:20:00',5.25),('16100','2013-08-01','16:25:00',5.06),('16100','2013-08-01','16:30:00',4.98),('16100','2013-08-01','16:35:00',4.86),('16100','2013-08-01','16:40:00',4.76),('16100','2013-08-01','16:45:00',4.65),('16100','2013-08-01','16:50:00',4.45),('16100','2013-08-01','16:55:00',4.34),('16100','2013-08-01','17:00:00',4.28),('16100','2013-08-01','17:05:00',4.18),('16100','2013-08-01','17:10:00',3.99),('16100','2013-08-01','17:15:00',3.86),('16100','2013-08-01','17:20:00',3.73),('16100','2013-08-01','17:25:00',3.57),('16100','2013-08-01','17:30:00',3.41),('16100','2013-08-01','17:35:00',3.27),('16100','2013-08-01','17:40:00',3.12),('16100','2013-08-01','17:45:00',2.93),('16100','2013-08-01','17:50:00',2.8),('16100','2013-08-01','17:55:00',2.65),('16100','2013-08-01','18:00:00',2.5),('16100','2013-08-01','18:05:00',2.35),('16100','2013-08-01','18:10:00',2.2),('16100','2013-08-01','18:15:00',2.04),('16100','2013-08-01','18:20:00',1.88),('16100','2013-08-01','18:25:00',1.73),('16100','2013-08-01','18:30:00',1.58),('16100','2013-08-01','18:35:00',1.42),('16100','2013-08-01','18:40:00',1.25),('16100','2013-08-01','18:45:00',1.09),('16100','2013-07-31','08:00:00',1.09),('16100','2013-07-31','08:05:00',1.24),('16100','2013-07-31','08:10:00',1.39),('16100','2013-07-31','08:15:00',1.54),('16100','2013-07-31','08:20:00',1.69),('16100','2013-07-31','08:25:00',1.87),('16100','2013-07-31','08:30:00',2.05),('16100','2013-07-31','08:35:00',2.2),('16100','2013-07-31','08:40:00',2.36),('16100','2013-07-31','08:45:00',2.59),('16100','2013-07-31','08:50:00',2.8),('16100','2013-07-31','08:55:00',3.13),('16100','2013-07-31','09:00:00',3.33),('16100','2013-07-31','09:05:00',3.53),('16100','2013-07-31','09:10:00',3.7),('16100','2013-07-31','09:15:00',3.85),('16100','2013-07-31','09:20:00',4.01),('16100','2013-07-31','09:25:00',4.15),('16100','2013-07-31','09:30:00',4.31),('16100','2013-07-31','09:35:00',4.5),('16100','2013-07-31','09:40:00',4.65),('16100','2013-07-31','09:45:00',4.76),('16100','2013-07-31','09:50:00',4.89),('16100','2013-07-31','09:55:00',5.02),('16100','2013-07-31','10:00:00',5.16),('16100','2013-07-31','10:05:00',5.25),('16100','2013-07-31','10:10:00',5.38),('16100','2013-07-31','10:15:00',5.6),('16100','2013-07-31','10:20:00',5.74),('16100','2013-07-31','10:25:00',5.85),('16100','2013-07-31','10:30:00',5.96),('16100','2013-07-31','10:35:00',6.11),('16100','2013-07-31','10:40:00',6.18),('16100','2013-07-31','10:45:00',6.27),('16100','2013-07-31','10:50:00',6.36),('16100','2013-07-31','10:55:00',6.44),('16100','2013-07-31','11:00:00',6.53),('16100','2013-07-31','11:05:00',6.64),('16100','2013-07-31','11:10:00',6.75),('16100','2013-07-31','11:15:00',6.85),('16100','2013-07-31','11:20:00',6.87),('16100','2013-07-31','11:25:00',6.9),('16100','2013-07-31','11:30:00',6.97),('16100','2013-07-31','11:35:00',7.05),('16100','2013-07-31','11:40:00',7.06),('16100','2013-07-31','11:45:00',7.09),('16100','2013-07-31','11:50:00',7.21),('16100','2013-07-31','11:55:00',7.28),('16100','2013-07-31','12:00:00',7.35),('16100','2013-07-31','12:05:00',7.42),('16100','2013-07-31','12:10:00',7.49),('16100','2013-07-31','12:15:00',7.49),('16100','2013-07-31','12:20:00',7.53),('16100','2013-07-31','12:25:00',7.52),('16100','2013-07-31','12:30:00',7.51),('16100','2013-07-31','12:35:00',7.57),('16100','2013-07-31','12:40:00',7.59),('16100','2013-07-31','12:45:00',7.61),('16100','2013-07-31','12:50:00',7.62),('16100','2013-07-31','12:55:00',7.64),('16100','2013-07-31','13:00:00',7.69),('16100','2013-07-31','13:05:00',7.69),('16100','2013-07-31','13:10:00',7.68),('16100','2013-07-31','13:15:00',7.67),('16100','2013-07-31','13:20:00',7.68),('16100','2013-07-31','13:25:00',7.71),('16100','2013-07-31','13:30:00',7.72),('16100','2013-07-31','13:35:00',7.68),('16100','2013-07-31','13:40:00',7.65),('16100','2013-07-31','13:45:00',7.61),('16100','2013-07-31','13:50:00',7.6),('16100','2013-07-31','13:55:00',7.6),('16100','2013-07-31','14:00:00',7.58),('16100','2013-07-31','14:05:00',7.54),('16100','2013-07-31','14:10:00',7.45),('16100','2013-07-31','14:15:00',7.29),('16100','2013-07-31','14:20:00',7.27),('16100','2013-07-31','14:25:00',7.25),('16100','2013-07-31','14:30:00',7.21),('16100','2013-07-31','14:35:00',7.16),('16100','2013-07-31','14:40:00',7.08),('16100','2013-07-31','14:45:00',7.02),('16100','2013-07-31','14:50:00',6.98),('16100','2013-07-31','14:55:00',6.97),('16100','2013-07-31','15:00:00',6.92),('16100','2013-07-31','15:05:00',6.82),('16100','2013-07-31','15:10:00',6.72),('16100','2013-07-31','15:15:00',6.68),('16100','2013-07-31','15:20:00',6.56),('16100','2013-07-31','15:25:00',6.45),('16100','2013-07-31','15:30:00',6.38),('16100','2013-07-31','15:35:00',6.31),('16100','2013-07-31','15:40:00',6.29),('16100','2013-07-31','15:45:00',6.14),('16100','2013-07-31','15:50:00',6.05),('16100','2013-07-31','15:55:00',5.93),('16100','2013-07-31','16:00:00',5.81),('16100','2013-07-31','16:05:00',5.74),('16100','2013-07-31','16:10:00',5.66),('16100','2013-07-31','16:15:00',5.52),('16100','2013-07-31','16:20:00',5.38),('16100','2013-07-31','16:25:00',5.16),('16100','2013-07-31','16:30:00',5.06),('16100','2013-07-31','16:35:00',4.98),('16100','2013-07-31','16:40:00',4.88),('16100','2013-07-31','16:45:00',4.74),('16100','2013-07-31','16:50:00',4.62),('16100','2013-07-31','16:55:00',4.51),('16100','2013-07-31','17:00:00',4.39),('16100','2013-07-31','17:05:00',4.26),('16100','2013-07-31','17:10:00',4.06),('16100','2013-07-31','17:15:00',3.92),('16100','2013-07-31','17:20:00',3.8),('16100','2013-07-31','17:25:00',3.61),('16100','2013-07-31','17:30:00',3.48),('16100','2013-07-31','17:35:00',3.34),('16100','2013-07-31','17:40:00',3.2),('16100','2013-07-31','17:45:00',3),('16100','2013-07-31','17:50:00',2.86),('16100','2013-07-31','17:55:00',2.66),('16100','2013-07-31','18:00:00',2.55),('16100','2013-07-31','18:05:00',2.41),('16100','2013-07-31','18:10:00',2.25),('16100','2013-07-31','18:15:00',2.09),('16100','2013-07-31','18:20:00',1.94),('16100','2013-07-31','18:25:00',1.78),('16100','2013-07-31','18:30:00',1.63),('16100','2013-07-31','18:35:00',1.47),('16100','2013-07-31','18:40:00',1.27),('16100','2013-07-31','18:45:00',1.13),('16100','2013-07-30','08:00:00',1.11),('16100','2013-07-30','08:05:00',1.24),('16100','2013-07-30','08:10:00',1.38),('16100','2013-07-30','08:15:00',1.54),('16100','2013-07-30','08:20:00',1.71),('16100','2013-07-30','08:25:00',1.88),('16100','2013-07-30','08:30:00',2.04),('16100','2013-07-30','08:35:00',2.2),('16100','2013-07-30','08:40:00',2.36),('16100','2013-07-30','08:45:00',2.56),('16100','2013-07-30','08:50:00',2.73),('16100','2013-07-30','08:55:00',3.07),('16100','2013-07-30','09:00:00',3.34),('16100','2013-07-30','09:05:00',3.49),('16100','2013-07-30','09:10:00',3.65),('16100','2013-07-30','09:15:00',3.78),('16100','2013-07-30','09:20:00',3.96),('16100','2013-07-30','09:25:00',4.07),('16100','2013-07-30','09:30:00',4.23),('16100','2013-07-30','09:35:00',4.39),('16100','2013-07-30','09:40:00',4.5),('16100','2013-07-30','09:45:00',4.61),('16100','2013-07-30','09:50:00',4.75),('16100','2013-07-30','09:55:00',4.9),('16100','2013-07-30','10:00:00',5.02),('16100','2013-07-30','10:05:00',5.12),('16100','2013-07-30','10:10:00',5.25),('16100','2013-07-30','10:15:00',5.42),('16100','2013-07-30','10:20:00',5.5),('16100','2013-07-30','10:25:00',5.6),('16100','2013-07-30','10:30:00',5.8),('16100','2013-07-30','10:35:00',5.9),('16100','2013-07-30','10:40:00',6.01),('16100','2013-07-30','10:45:00',6.11),('16100','2013-07-30','10:50:00',6.17),('16100','2013-07-30','10:55:00',6.29),('16100','2013-07-30','11:00:00',6.35),('16100','2013-07-30','11:05:00',6.49),('16100','2013-07-30','11:10:00',6.6),('16100','2013-07-30','11:15:00',6.67),('16100','2013-07-30','11:20:00',6.71),('16100','2013-07-30','11:25:00',6.79),('16100','2013-07-30','11:30:00',6.83),('16100','2013-07-30','11:35:00',6.91),('16100','2013-07-30','11:40:00',6.96),('16100','2013-07-30','11:45:00',7.08),('16100','2013-07-30','11:50:00',7.12),('16100','2013-07-30','11:55:00',7.24),('16100','2013-07-30','12:00:00',7.27),('16100','2013-07-30','12:05:00',7.35),('16100','2013-07-30','12:10:00',7.39),('16100','2013-07-30','12:15:00',7.39),('16100','2013-07-30','12:20:00',7.46),('16100','2013-07-30','12:25:00',7.52),('16100','2013-07-30','12:30:00',7.49),('16100','2013-07-30','12:35:00',7.52),('16100','2013-07-30','12:40:00',7.56),('16100','2013-07-30','12:45:00',7.54),('16100','2013-07-30','12:50:00',7.55),('16100','2013-07-30','12:55:00',7.6),('16100','2013-07-30','13:00:00',7.63),('16100','2013-07-30','13:05:00',7.64),('16100','2013-07-30','13:10:00',7.65),('16100','2013-07-30','13:15:00',7.64),('16100','2013-07-30','13:20:00',7.64),('16100','2013-07-30','13:25:00',7.55),('16100','2013-07-30','13:30:00',7.56),('16100','2013-07-30','13:35:00',7.57),('16100','2013-07-30','13:40:00',7.29),('16100','2013-07-30','13:45:00',7.58),('16100','2013-07-30','13:50:00',7.16),('16100','2013-07-30','13:55:00',3.33),('16100','2013-07-30','14:00:00',7.7),('16100','2013-07-30','14:05:00',7.5),('16100','2013-07-30','14:10:00',7.2),('16100','2013-07-30','14:15:00',4.83),('16100','2013-07-30','14:20:00',7.45),('16100','2013-07-30','14:25:00',7.32),('16100','2013-07-30','14:30:00',7.25),('16100','2013-07-30','14:35:00',7.16),('16100','2013-07-30','14:40:00',7.14),('16100','2013-07-30','14:45:00',6.99),('16100','2013-07-30','14:50:00',6.97),('16100','2013-07-30','14:55:00',7.07),('16100','2013-07-30','15:00:00',6.9),('16100','2013-07-30','15:05:00',6.84),('16100','2013-07-30','15:10:00',6.86),('16100','2013-07-30','15:15:00',6.72),('16100','2013-07-30','15:20:00',6.6),('16100','2013-07-30','15:25:00',6.46),('16100','2013-07-30','15:30:00',6.37),('16100','2013-07-30','15:35:00',6.25),('16100','2013-07-30','15:40:00',6.04),('16100','2013-07-30','15:45:00',3.42),('16100','2013-07-30','15:50:00',5.36),('16100','2013-07-30','15:55:00',1.73),('16100','2013-07-30','16:00:00',5.63),('16100','2013-07-30','16:05:00',5.71),('16100','2013-07-30','16:10:00',4.97),('16100','2013-07-30','16:15:00',2.29),('16100','2013-07-30','16:20:00',5.52),('16100','2013-07-30','16:25:00',5.21),('16100','2013-07-30','16:30:00',5.14),('16100','2013-07-30','16:35:00',5.01),('16100','2013-07-30','16:40:00',4.87),('16100','2013-07-30','16:45:00',4.83),('16100','2013-07-30','16:50:00',4.75),('16100','2013-07-30','16:55:00',4.56),('16100','2013-07-30','17:00:00',4.47),('16100','2013-07-30','17:05:00',4.37),('16100','2013-07-30','17:10:00',4.22),('16100','2013-07-30','17:15:00',4.01),('16100','2013-07-30','17:20:00',3.79),('16100','2013-07-30','17:25:00',3.58),('16100','2013-07-30','17:30:00',3.44),('16100','2013-07-30','17:35:00',3.31),('16100','2013-07-30','17:40:00',3.13),('16100','2013-07-30','17:45:00',3.02),('16100','2013-07-30','17:50:00',2.89),('16100','2013-07-30','17:55:00',2.75),('16100','2013-07-30','18:00:00',2.59),('16100','2013-07-30','18:05:00',2.44),('16100','2013-07-30','18:10:00',2.28),('16100','2013-07-30','18:15:00',2.15),('16100','2013-07-30','18:20:00',2.02),('16100','2013-07-30','18:25:00',1.87),('16100','2013-07-30','18:30:00',1.72),('16100','2013-07-30','18:35:00',1.53),('16100','2013-07-30','18:40:00',1.33),('16100','2013-07-30','18:45:00',1.16),('16100','2013-07-30','18:50:00',1.01),('16100','2014-04-07','08:20:00',1.06),('16100','2014-04-07','08:30:00',1.41),('16100','2014-04-07','08:35:00',1.81),('16100','2014-04-07','08:40:00',2.02),('16100','2014-04-07','08:45:00',2.3),('16100','2014-04-07','08:50:00',2.5),('16100','2014-04-07','08:55:00',2.7),('16100','2014-04-07','09:00:00',2.92),('16100','2014-04-07','09:05:00',3.07),('16100','2014-04-07','09:10:00',3.21),('16100','2014-04-07','09:15:00',3.41),('16100','2014-04-07','09:20:00',3.59),('16100','2014-04-07','09:25:00',3.73),('16100','2014-04-07','09:30:00',3.8),('16100','2014-04-07','09:35:00',3.83),('16100','2014-04-07','09:40:00',4),('16100','2014-04-07','09:45:00',4.17),('16100','2014-04-07','09:50:00',4.26),('16100','2014-04-07','09:55:00',4.27),('16100','2014-04-07','10:00:00',4.51),('16100','2014-04-07','10:05:00',4.83),('16100','2014-04-07','10:10:00',4.92),('16100','2014-04-07','10:15:00',4.99),('16100','2014-04-07','10:20:00',5.12),('16100','2014-04-07','10:25:00',5.25),('16100','2014-04-07','10:30:00',5.37),('16100','2014-04-07','10:35:00',5.5),('16100','2014-04-07','10:40:00',5.62),('16100','2014-04-07','10:45:00',5.74),('16100','2014-04-07','10:50:00',5.8),('16100','2014-04-07','10:55:00',5.91),('16100','2014-04-07','11:00:00',6),('16100','2014-04-07','11:05:00',6.11),('16100','2014-04-07','11:10:00',6.17),('16100','2014-04-07','11:15:00',6.22),('16100','2014-04-07','11:20:00',6.34),('16100','2014-04-07','11:25:00',6.41),('16100','2014-04-07','11:30:00',6.33),('16100','2014-04-07','11:35:00',6.65),('16100','2014-04-07','11:40:00',6.63),('16100','2014-04-07','11:45:00',6.5),('16100','2014-04-07','11:50:00',6.65),('16100','2014-04-07','11:55:00',6.81),('16100','2014-04-07','12:00:00',6.63),('16100','2014-04-07','12:05:00',6.36),('16100','2014-04-07','12:10:00',6.04),('16100','2014-04-07','12:15:00',5.62),('16100','2014-04-07','12:20:00',6.18),('16100','2014-04-07','12:25:00',6.62),('16100','2014-04-07','12:30:00',6.08),('16100','2014-04-07','12:35:00',6.3),('16100','2014-04-07','12:40:00',6.12),('16100','2014-04-07','12:45:00',6.31),('16100','2014-04-07','12:50:00',6.94),('16100','2014-04-07','12:55:00',6.84),('16100','2014-04-07','13:00:00',7.21),('16100','2014-04-07','13:05:00',7.46),('16100','2014-04-07','13:10:00',7.34),('16100','2014-04-07','13:15:00',7.3),('16100','2014-04-07','13:20:00',7.38),('16100','2014-04-07','13:25:00',7.46),('16100','2014-04-07','13:30:00',7.49),('16100','2014-04-07','13:35:00',7.47),('16100','2014-04-07','13:40:00',7.38),('16100','2014-04-07','13:45:00',7.35),('16100','2014-04-07','13:50:00',7.27),('16100','2014-04-07','13:55:00',7.28),('16100','2014-04-07','14:00:00',7.31),('16100','2014-04-07','14:05:00',7.32),('16100','2014-04-07','14:10:00',7.32),('16100','2014-04-07','14:15:00',7.04),('16100','2014-04-07','14:20:00',6.32),('16100','2014-04-07','14:25:00',6.84),('16100','2014-04-07','14:30:00',7.02),('16100','2014-04-07','14:35:00',6.02),('16100','2014-04-07','14:40:00',6.28),('16100','2014-04-07','14:45:00',6.55),('16100','2014-04-07','14:50:00',6.97),('16100','2014-04-07','14:55:00',6.75),('16100','2014-04-07','15:00:00',6.53),('16100','2014-04-07','15:05:00',6.56),('16100','2014-04-07','15:10:00',6.35),('16100','2014-04-07','15:15:00',6.36),('16100','2014-04-07','15:20:00',6.41),('16100','2014-04-07','15:25:00',6.23),('16100','2014-04-07','15:30:00',6.07),('16100','2014-04-07','15:35:00',5.89),('16100','2014-04-07','15:40:00',5.56),('16100','2014-04-07','15:45:00',5.75),('16100','2014-04-07','15:50:00',5.66),('16100','2014-04-07','15:55:00',5.48),('16100','2014-04-07','16:00:00',5.44),('16100','2014-04-07','16:05:00',5.26),('16100','2014-04-07','16:10:00',4.97),('16100','2014-04-07','16:15:00',4.78),('16100','2014-04-07','16:20:00',4.51),('16100','2014-04-07','16:25:00',4.93),('16100','2014-04-07','16:30:00',4.6),('16100','2014-04-07','16:35:00',4.53),('16100','2014-04-07','16:40:00',4.32),('16100','2014-04-07','16:45:00',4.17),('16100','2014-04-07','16:50:00',4.06),('16100','2014-04-07','16:55:00',3.67),('16100','2014-04-07','17:00:00',3.73),('16100','2014-04-07','17:05:00',3.62),('16100','2014-04-07','17:10:00',3.45),('16100','2014-04-07','17:15:00',3.26),('16100','2014-04-07','17:20:00',2.98),('16100','2014-04-07','17:25:00',2.74),('16100','2014-04-07','17:30:00',2.46),('16100','2014-04-07','17:35:00',2.57),('16100','2014-04-07','17:40:00',2.33),('16100','2014-04-07','17:45:00',2.26),('16100','2014-04-07','17:50:00',2.05),('16100','2014-04-07','17:55:00',1.82),('16100','2014-04-07','18:00:00',1.83),('16100','2014-04-07','18:05:00',1.6),('16100','2014-04-07','18:10:00',1.51),('16100','2014-04-07','18:15:00',1.36),('16100','2014-04-07','18:20:00',1.19),('16100','2013-07-29','08:00:00',1.29),('16100','2013-07-29','08:05:00',1.32),('16100','2013-07-29','08:10:00',1.39),('16100','2013-07-29','08:15:00',1.54),('16100','2013-07-29','08:20:00',1.7),('16100','2013-07-29','08:25:00',1.88),('16100','2013-07-29','08:30:00',2.05),('16100','2013-07-29','08:35:00',2.19),('16100','2013-07-29','08:40:00',2.38),('16100','2013-07-29','08:45:00',2.58),('16100','2013-07-29','08:50:00',1.12),('16100','2013-07-29','08:55:00',2.51),('16100','2013-07-29','09:00:00',2.77),('16100','2013-07-29','09:05:00',3.03),('16100','2013-07-29','09:10:00',2.3),('16100','2013-07-29','09:15:00',1.01),('16100','2013-07-29','09:30:00',1.42),('16100','2013-07-29','09:35:00',4.49),('16100','2013-07-29','09:40:00',4.93),('16100','2013-07-29','09:45:00',4.98),('16100','2013-07-29','09:50:00',4.91),('16100','2013-07-29','10:00:00',4.52),('16100','2013-07-29','10:05:00',2.06),('16100','2013-07-29','10:10:00',1.2),('16100','2013-07-29','10:15:00',5.31),('16100','2013-07-29','10:20:00',6.15),('16100','2013-07-29','10:25:00',6.08),('16100','2013-07-29','10:30:00',6.14),('16100','2013-07-29','10:35:00',6.11),('16100','2013-07-29','10:40:00',6.06),('16100','2013-07-29','10:45:00',6.13),('16100','2013-07-29','10:50:00',6.19),('16100','2013-07-29','10:55:00',6.19),('16100','2013-07-29','11:00:00',6.21),('16100','2013-07-29','11:05:00',5.69),('16100','2013-07-29','11:10:00',6.46),('16100','2013-07-29','11:15:00',6.74),('16100','2013-07-29','11:20:00',6.62),('16100','2013-07-29','11:25:00',6.71),('16100','2013-07-29','11:30:00',6.72),('16100','2013-07-29','11:35:00',6.7),('16100','2013-07-29','11:40:00',6.68),('16100','2013-07-29','11:45:00',5.85),('16100','2013-07-29','11:50:00',4.85),('16100','2013-07-29','11:55:00',7.18),('16100','2013-07-29','12:00:00',7.13),('16100','2013-07-29','12:05:00',7.28),('16100','2013-07-29','12:10:00',7.33),('16100','2013-07-29','12:15:00',7.21),('16100','2013-07-29','12:20:00',7.22),('16100','2013-07-29','12:25:00',7.19),('16100','2013-07-29','12:30:00',7.29),('16100','2013-07-29','12:35:00',6.51),('16100','2013-07-29','12:40:00',5.77),('16100','2013-07-29','12:45:00',7.42),('16100','2013-07-29','12:50:00',6.95),('16100','2013-07-29','12:55:00',4.03),('16100','2013-07-29','13:00:00',6.21),('16100','2013-07-29','13:05:00',8.06),('16100','2013-07-29','13:10:00',6.7),('16100','2013-07-29','13:15:00',3.35),('16100','2013-07-29','13:20:00',1.97),('16100','2013-07-29','13:25:00',4.5),('16100','2013-07-29','13:30:00',3.48),('16100','2013-07-29','13:35:00',7.88),('16100','2013-07-29','13:40:00',7.37),('16100','2013-07-29','13:45:00',7.87),('16100','2013-07-29','13:50:00',7.86),('16100','2013-07-29','13:55:00',7.79),('16100','2013-07-29','14:00:00',5.98),('16100','2013-07-29','14:05:00',5.24),('16100','2013-07-29','14:10:00',7.55),('16100','2013-07-29','14:15:00',7.28),('16100','2013-07-29','14:20:00',7.27),('16100','2013-07-29','14:25:00',7.26),('16100','2013-07-29','14:30:00',7.13),('16100','2013-07-29','14:35:00',7.15),('16100','2013-07-29','14:40:00',6.98),('16100','2013-07-29','14:45:00',6.86),('16100','2013-07-29','14:50:00',6.79),('16100','2013-07-29','14:55:00',6.82),('16100','2013-07-29','15:00:00',6.75),('16100','2013-07-29','15:05:00',6.67),('16100','2013-07-29','15:10:00',6.67),('16100','2013-07-29','15:15:00',6.55),('16100','2013-07-29','15:20:00',6.44),('16100','2013-07-29','15:25:00',6.32),('16100','2013-07-29','15:30:00',6.24),('16100','2013-07-29','15:35:00',6.2),('16100','2013-07-29','15:40:00',6.07),('16100','2013-07-29','15:45:00',6.02),('16100','2013-07-29','15:50:00',5.89),('16100','2013-07-29','15:55:00',5.78),('16100','2013-07-29','16:00:00',5.73),('16100','2013-07-29','16:05:00',5.57),('16100','2013-07-29','16:10:00',5.42),('16100','2013-07-29','16:15:00',5.32),('16100','2013-07-29','16:20:00',5.23),('16100','2013-07-29','16:25:00',5.01),('16100','2013-07-29','16:30:00',4.91),('16100','2013-07-29','16:35:00',4.91),('16100','2013-07-29','16:40:00',4.77),('16100','2013-07-29','16:45:00',4.63),('16100','2013-07-29','16:50:00',4.5),('16100','2013-07-29','16:55:00',4.44),('16100','2013-07-29','17:00:00',4.25),('16100','2013-07-29','17:05:00',4.09),('16100','2013-07-29','17:10:00',3.96),('16100','2013-07-29','17:15:00',3.83),('16100','2013-07-29','17:20:00',3.69),('16100','2013-07-29','17:25:00',3.51),('16100','2013-07-29','17:30:00',3.36),('16100','2013-07-29','17:35:00',3.22),('16100','2013-07-29','17:40:00',3.05),('16100','2013-07-29','17:45:00',2.93),('16100','2013-07-29','17:50:00',2.79),('16100','2013-07-29','17:55:00',2.63),('16100','2013-07-29','18:00:00',2.47),('16100','2013-07-29','18:05:00',2.32),('16100','2013-07-29','18:10:00',2.19),('16100','2013-07-29','18:15:00',2.03),('16100','2013-07-29','18:20:00',1.87),('16100','2013-07-29','18:25:00',1.7),('16100','2013-07-29','18:30:00',1.57),('16100','2013-07-29','18:35:00',1.41),('16100','2013-07-29','18:40:00',1.24),('16100','2013-07-29','18:45:00',1.1),('16100','2013-07-28','08:00:00',1.06),('16100','2013-07-28','08:05:00',1.19),('16100','2013-07-28','08:10:00',1.3),('16100','2013-07-28','08:15:00',1.45),('16100','2013-07-28','08:20:00',1.59),('16100','2013-07-28','08:25:00',1.74),('16100','2013-07-28','08:30:00',1.9),('16100','2013-07-28','08:35:00',2.04),('16100','2013-07-28','08:40:00',2.22),('16100','2013-07-28','08:45:00',2.36),('16100','2013-07-28','08:50:00',2.5),('16100','2013-07-28','08:55:00',2.73),('16100','2013-07-28','09:00:00',3.02),('16100','2013-07-28','09:05:00',3.2),('16100','2013-07-28','09:10:00',3.36),('16100','2013-07-28','09:15:00',3.48),('16100','2013-07-28','09:20:00',3.62),('16100','2013-07-28','09:25:00',3.79),('16100','2013-07-28','09:30:00',3.88),('16100','2013-07-28','09:35:00',4),('16100','2013-07-28','09:40:00',4.12),('16100','2013-07-28','09:45:00',4.28),('16100','2013-07-28','09:50:00',4.4),('16100','2013-07-28','09:55:00',4.47),('16100','2013-07-28','10:00:00',4.59),('16100','2013-07-28','10:05:00',4.72),('16100','2013-07-28','10:10:00',4.84),('16100','2013-07-28','10:15:00',4.96),('16100','2013-07-28','10:20:00',5.04),('16100','2013-07-28','10:25:00',5.22),('16100','2013-07-28','10:30:00',5.35),('16100','2013-07-28','10:35:00',5.4),('16100','2013-07-28','10:40:00',5.45),('16100','2013-07-28','10:45:00',5.55),('16100','2013-07-28','10:50:00',5.61),('16100','2013-07-28','10:55:00',5.61),('16100','2013-07-28','11:00:00',5.68),('16100','2013-07-28','11:05:00',5.8),('16100','2013-07-28','11:10:00',5.89),('16100','2013-07-28','11:15:00',5.9),('16100','2013-07-28','11:20:00',6.02),('16100','2013-07-28','11:25:00',6.12),('16100','2013-07-28','11:30:00',6.26),('16100','2013-07-28','11:35:00',6.35),('16100','2013-07-28','11:40:00',6.38),('16100','2013-07-28','11:45:00',6.42),('16100','2013-07-28','11:50:00',6.47),('16100','2013-07-28','11:55:00',6.52),('16100','2013-07-28','12:00:00',6.58),('16100','2013-07-28','12:05:00',6.7),('16100','2013-07-28','12:10:00',6.77),('16100','2013-07-28','12:15:00',6.8),('16100','2013-07-28','12:20:00',6.82),('16100','2013-07-28','12:25:00',6.8),('16100','2013-07-28','12:30:00',6.77),('16100','2013-07-28','12:35:00',6.88),('16100','2013-07-28','12:40:00',6.93),('16100','2013-07-28','12:45:00',6.92),('16100','2013-07-28','12:50:00',6.92),('16100','2013-07-28','12:55:00',7.06),('16100','2013-07-28','13:00:00',7.24),('16100','2013-07-28','13:05:00',7.25),('16100','2013-07-28','13:10:00',7.2),('16100','2013-07-28','13:15:00',7.28),('16100','2013-07-28','13:20:00',7.3),('16100','2013-07-28','13:25:00',7.27),('16100','2013-07-28','13:30:00',7.3),('16100','2013-07-28','13:35:00',7.29),('16100','2013-07-28','13:40:00',7.29),('16100','2013-07-28','13:45:00',7.3),('16100','2013-07-28','13:50:00',7.3),('16100','2013-07-28','13:55:00',7.27),('16100','2013-07-28','14:00:00',7.27),('16100','2013-07-28','14:05:00',7.25),('16100','2013-07-28','14:10:00',7.16),('16100','2013-07-28','14:15:00',7.03),('16100','2013-07-28','14:20:00',6.94),('16100','2013-07-28','14:25:00',6.95),('16100','2013-07-28','14:30:00',6.88),('16100','2013-07-28','14:35:00',6.87),('16100','2013-07-28','14:40:00',6.79),('16100','2013-07-28','14:45:00',6.73),('16100','2013-07-28','14:50:00',6.72),('16100','2013-07-28','14:55:00',6.68),('16100','2013-07-28','15:00:00',6.61),('16100','2013-07-28','15:05:00',6.54),('16100','2013-07-28','15:10:00',6.48),('16100','2013-07-28','15:15:00',6.41),('16100','2013-07-28','15:20:00',6.33),('16100','2013-07-28','15:25:00',6.27),('16100','2013-07-28','15:30:00',6.2),('16100','2013-07-28','15:35:00',6.25),('16100','2013-07-28','15:40:00',5.58),('16100','2013-07-28','15:45:00',4.01),('16100','2013-07-28','15:50:00',4.32),('16100','2013-07-28','15:55:00',3.42),('16100','2013-07-28','16:00:00',4.07),('16100','2013-07-28','16:05:00',5.6),('16100','2013-07-28','16:10:00',4.39),('16100','2013-07-28','16:15:00',5.4),('16100','2013-07-28','16:20:00',4.06),('16100','2013-07-28','16:25:00',4.81),('16100','2013-07-28','16:30:00',5.31),('16100','2013-07-28','16:35:00',5.05),('16100','2013-07-28','16:40:00',4.96),('16100','2013-07-28','16:45:00',4.02),('16100','2013-07-28','16:50:00',3),('16100','2013-07-28','16:55:00',2.32),('16100','2013-07-28','17:00:00',2.24),('16100','2013-07-28','17:05:00',3.36),('16100','2013-07-28','17:10:00',4.02),('16100','2013-07-28','17:15:00',3.6),('16100','2013-07-28','17:20:00',3.61),('16100','2013-07-28','17:25:00',3.2),('16100','2013-07-28','17:30:00',1.75),('16100','2013-07-28','17:35:00',1.45),('16100','2013-07-28','17:40:00',3.58),('16100','2013-07-28','17:45:00',3.19),('16100','2013-07-28','17:50:00',2.75),('16100','2013-07-28','17:55:00',1.8),('16100','2013-07-28','18:00:00',1.87),('16100','2013-07-28','18:05:00',2.02),('16100','2013-07-28','18:10:00',1.83),('16100','2013-07-28','18:15:00',2.03),('16100','2013-07-28','18:20:00',2.03),('16100','2013-07-28','18:25:00',1.84),('16100','2013-07-28','18:30:00',1.62),('16100','2013-07-28','18:35:00',1.32),('16100','2013-07-28','18:55:00',1.13),('16100','2013-07-28','19:00:00',1.06),('16100','2013-07-27','08:00:00',1.03),('16100','2013-07-27','08:05:00',1.18),('16100','2013-07-27','08:10:00',1.31),('16100','2013-07-27','08:15:00',1.45),('16100','2013-07-27','08:20:00',1.59),('16100','2013-07-27','08:25:00',1.77),('16100','2013-07-27','08:30:00',1.91),('16100','2013-07-27','08:35:00',2.07),('16100','2013-07-27','08:40:00',2.24),('16100','2013-07-27','08:45:00',2.4),('16100','2013-07-27','08:50:00',2.58),('16100','2013-07-27','08:55:00',2.81),('16100','2013-07-27','09:00:00',3.13),('16100','2013-07-27','09:05:00',3.31),('16100','2013-07-27','09:10:00',3.43),('16100','2013-07-27','09:15:00',3.54),('16100','2013-07-27','09:20:00',3.68),('16100','2013-07-27','09:25:00',3.82),('16100','2013-07-27','09:30:00',3.96),('16100','2013-07-27','09:35:00',4.11),('16100','2013-07-27','09:40:00',4.22),('16100','2013-07-27','09:45:00',4.33),('16100','2013-07-27','09:50:00',4.44),('16100','2013-07-27','09:55:00',4.53),('16100','2013-07-27','10:00:00',4.66),('16100','2013-07-27','10:05:00',4.77),('16100','2013-07-27','10:10:00',4.88),('16100','2013-07-27','10:15:00',4.99),('16100','2013-07-27','10:20:00',5.1),('16100','2013-07-27','10:25:00',5.26),('16100','2013-07-27','10:30:00',5.4),('16100','2013-07-27','10:35:00',5.48),('16100','2013-07-27','10:40:00',5.52),('16100','2013-07-27','10:45:00',5.61),('16100','2013-07-27','10:50:00',5.64),('16100','2013-07-27','10:55:00',5.73),('16100','2013-07-27','11:00:00',5.81),('16100','2013-07-27','11:05:00',5.88),('16100','2013-07-27','11:10:00',5.96),('16100','2013-07-27','11:15:00',6.06),('16100','2013-07-27','11:20:00',6.12),('16100','2013-07-27','11:25:00',5.97),('16100','2013-07-27','11:30:00',5.9),('16100','2013-07-27','11:35:00',6.07),('16100','2013-07-27','11:40:00',6.19),('16100','2013-07-27','11:45:00',6.3),('16100','2013-07-27','11:50:00',6.44),('16100','2013-07-27','11:55:00',6.49),('16100','2013-07-27','12:00:00',6.53),('16100','2013-07-27','12:05:00',6.61),('16100','2013-07-27','12:10:00',6.64),('16100','2013-07-27','12:15:00',6.64),('16100','2013-07-27','12:20:00',6.81),('16100','2013-07-27','12:25:00',6.82),('16100','2013-07-27','12:30:00',6.89),('16100','2013-07-27','12:35:00',6.92),('16100','2013-07-27','12:40:00',6.3),('16100','2013-07-27','12:45:00',6.93),('16100','2013-07-27','12:50:00',6.98),('16100','2013-07-27','12:55:00',5.55),('16100','2013-07-27','13:00:00',6.84),('16100','2013-07-27','13:05:00',7.19),('16100','2013-07-27','13:10:00',7.24),('16100','2013-07-27','13:15:00',6.67),('16100','2013-07-27','13:20:00',7.28),('16100','2013-07-27','13:25:00',7.25),('16100','2013-07-27','13:30:00',7.2),('16100','2013-07-27','13:35:00',7.17),('16100','2013-07-27','13:40:00',7.21),('16100','2013-07-27','13:45:00',7.21),('16100','2013-07-27','13:50:00',7.14),('16100','2013-07-27','13:55:00',7.18),('16100','2013-07-27','14:00:00',7.1),('16100','2013-07-27','14:05:00',7.13),('16100','2013-07-27','14:10:00',7.07),('16100','2013-07-27','14:15:00',6.99),('16100','2013-07-27','14:20:00',6.95),('16100','2013-07-27','14:25:00',6.88),('16100','2013-07-27','14:30:00',6.91),('16100','2013-07-27','14:35:00',6.87),('16100','2013-07-27','14:40:00',6.86),('16100','2013-07-27','14:45:00',6.76),('16100','2013-07-27','14:50:00',6.72),('16100','2013-07-27','14:55:00',6.65),('16100','2013-07-27','15:00:00',6.55),('16100','2013-07-27','15:05:00',6.48),('16100','2013-07-27','15:10:00',6.39),('16100','2013-07-27','15:15:00',6.28),('16100','2013-07-27','15:20:00',6.25),('16100','2013-07-27','15:25:00',6.2),('16100','2013-07-27','15:30:00',6.13),('16100','2013-07-27','15:35:00',6.06),('16100','2013-07-27','15:40:00',5.98),('16100','2013-07-27','15:45:00',5.92),('16100','2013-07-27','15:50:00',5.88),('16100','2013-07-27','15:55:00',5.82),('16100','2013-07-27','16:00:00',5.73),('16100','2013-07-27','16:05:00',5.63),('16100','2013-07-27','16:10:00',5.57),('16100','2013-07-27','16:15:00',5.47),('16100','2013-07-27','16:20:00',5.36),('16100','2013-07-27','16:25:00',5.17),('16100','2013-07-27','16:30:00',5.06),('16100','2013-07-27','16:35:00',4.95),('16100','2013-07-27','16:40:00',4.85),('16100','2013-07-27','16:45:00',4.74),('16100','2013-07-27','16:50:00',4.58),('16100','2013-07-27','16:55:00',4.47),('16100','2013-07-27','17:00:00',4.36),('16100','2013-07-27','17:05:00',4.22),('16100','2013-07-27','17:10:00',4.05),('16100','2013-07-27','17:15:00',3.91),('16100','2013-07-27','17:20:00',3.78),('16100','2013-07-27','17:25:00',3.64),('16100','2013-07-27','17:30:00',3.51),('16100','2013-07-27','17:35:00',3.35),('16100','2013-07-27','17:40:00',3.17),('16100','2013-07-27','17:45:00',3.01),('16100','2013-07-27','17:50:00',2.85),('16100','2013-07-27','17:55:00',2.68),('16100','2013-07-27','18:00:00',2.52),('16100','2013-07-27','18:05:00',2.38),('16100','2013-07-27','18:10:00',2.24),('16100','2013-07-27','18:15:00',2.1),('16100','2013-07-27','18:20:00',1.95),('16100','2013-07-27','18:25:00',1.8),('16100','2013-07-27','18:30:00',1.62),('16100','2013-07-27','18:35:00',1.43),('16100','2013-07-27','18:40:00',1.28),('16100','2013-07-27','18:45:00',1.15),('16100','2013-07-27','18:50:00',1.01),('16100','2013-07-26','08:00:00',1.07),('16100','2013-07-26','08:05:00',1.2),('16100','2013-07-26','08:10:00',1.35),('16100','2013-07-26','08:15:00',1.49),('16100','2013-07-26','08:20:00',1.63),('16100','2013-07-26','08:25:00',1.8),('16100','2013-07-26','08:30:00',1.94),('16100','2013-07-26','08:35:00',2.1),('16100','2013-07-26','08:40:00',2.29),('16100','2013-07-26','08:45:00',2.43),('16100','2013-07-26','08:50:00',2.61),('16100','2013-07-26','08:55:00',2.86),('16100','2013-07-26','09:00:00',3.16),('16100','2013-07-26','09:05:00',3.35),('16100','2013-07-26','09:10:00',3.5),('16100','2013-07-26','09:15:00',3.64),('16100','2013-07-26','09:20:00',3.77),('16100','2013-07-26','09:25:00',3.88),('16100','2013-07-26','09:30:00',4.02),('16100','2013-07-26','09:35:00',4.18),('16100','2013-07-26','09:40:00',4.29),('16100','2013-07-26','09:45:00',4.41),('16100','2013-07-26','09:50:00',4.52),('16100','2013-07-26','09:55:00',4.65),('16100','2013-07-26','10:00:00',4.75),('16100','2013-07-26','10:05:00',4.88),('16100','2013-07-26','10:10:00',4.98),('16100','2013-07-26','10:15:00',5.15),('16100','2013-07-26','10:20:00',5.3),('16100','2013-07-26','10:25:00',5.38),('16100','2013-07-26','10:30:00',5.46),('16100','2013-07-26','10:35:00',5.56),('16100','2013-07-26','10:40:00',5.68),('16100','2013-07-26','10:45:00',5.78),('16100','2013-07-26','10:50:00',5.86),('16100','2013-07-26','10:55:00',5.94),('16100','2013-07-26','11:00:00',5.97),('16100','2013-07-26','11:05:00',6.04),('16100','2013-07-26','11:10:00',6.13),('16100','2013-07-26','11:15:00',6.22),('16100','2013-07-26','11:20:00',6.22),('16100','2013-07-26','11:25:00',6.25),('16100','2013-07-26','11:30:00',6.39),('16100','2013-07-26','11:35:00',6.38),('16100','2013-07-26','11:40:00',6.41),('16100','2013-07-26','11:45:00',6.55),('16100','2013-07-26','11:50:00',6.54),('16100','2013-07-26','11:55:00',6.58),('16100','2013-07-26','12:00:00',6.66),('16100','2013-07-26','12:05:00',6.66),('16100','2013-07-26','12:10:00',6.59),('16100','2013-07-26','12:15:00',6.68),('16100','2013-07-26','12:20:00',6.66),('16100','2013-07-26','12:25:00',6.84),('16100','2013-07-26','12:30:00',5.89),('16100','2013-07-26','12:35:00',6.41),('16100','2013-07-26','12:40:00',7.12),('16100','2013-07-26','12:45:00',7.06),('16100','2013-07-26','12:50:00',7.3),('16100','2013-07-26','12:55:00',7.15),('16100','2013-07-26','13:00:00',6.99),('16100','2013-07-26','13:05:00',7.21),('16100','2013-07-26','13:10:00',7.27),('16100','2013-07-26','13:15:00',7.17),('16100','2013-07-26','13:20:00',7.23),('16100','2013-07-26','13:25:00',7.17),('16100','2013-07-26','13:30:00',7.26),('16100','2013-07-26','13:35:00',7.18),('16100','2013-07-26','13:40:00',7.11),('16100','2013-07-26','13:45:00',7.21),('16100','2013-07-26','13:50:00',7.2),('16100','2013-07-26','13:55:00',7.18),('16100','2013-07-26','14:00:00',7.18),('16100','2013-07-26','14:05:00',7.12),('16100','2013-07-26','14:10:00',7.06),('16100','2013-07-26','14:15:00',6.98),('16100','2013-07-26','14:20:00',6.94),('16100','2013-07-26','14:25:00',6.84),('16100','2013-07-26','14:30:00',6.88),('16100','2013-07-26','14:35:00',6.78),('16100','2013-07-26','14:40:00',6.75),('16100','2013-07-26','14:45:00',6.74),('16100','2013-07-26','14:50:00',6.69),('16100','2013-07-26','14:55:00',6.66),('16100','2013-07-26','15:00:00',6.59),('16100','2013-07-26','15:05:00',6.51),('16100','2013-07-26','15:10:00',6.47),('16100','2013-07-26','15:15:00',6.41),('16100','2013-07-26','15:20:00',6.36),('16100','2013-07-26','15:25:00',6.2),('16100','2013-07-26','15:30:00',6.08),('16100','2013-07-26','15:35:00',6.08),('16100','2013-07-26','15:40:00',6.05),('16100','2013-07-26','15:45:00',5.97),('16100','2013-07-26','15:50:00',5.87),('16100','2013-07-26','15:55:00',5.75),('16100','2013-07-26','16:00:00',5.66),('16100','2013-07-26','16:05:00',5.58),('16100','2013-07-26','16:10:00',5.45),('16100','2013-07-26','16:15:00',5.36),('16100','2013-07-26','16:20:00',5.22),('16100','2013-07-26','16:25:00',5.11),('16100','2013-07-26','16:30:00',5.02),('16100','2013-07-26','16:35:00',4.93),('16100','2013-07-26','16:40:00',4.8),('16100','2013-07-26','16:45:00',4.7),('16100','2013-07-26','16:50:00',4.59),('16100','2013-07-26','16:55:00',4.46),('16100','2013-07-26','17:00:00',4.33),('16100','2013-07-26','17:05:00',4.22),('16100','2013-07-26','17:10:00',4.06),('16100','2013-07-26','17:15:00',3.9),('16100','2013-07-26','17:20:00',3.78),('16100','2013-07-26','17:25:00',3.63),('16100','2013-07-26','17:30:00',3.48),('16100','2013-07-26','17:35:00',3.34),('16100','2013-07-26','17:40:00',3.16),('16100','2013-07-26','17:45:00',3),('16100','2013-07-26','17:50:00',2.85),('16100','2013-07-26','17:55:00',2.69),('16100','2013-07-26','18:00:00',2.54),('16100','2013-07-26','18:05:00',2.4),('16100','2013-07-26','18:10:00',2.25),('16100','2013-07-26','18:15:00',2.1),('16100','2013-07-26','18:20:00',1.96),('16100','2013-07-26','18:25:00',1.82),('16100','2013-07-26','18:30:00',1.67),('16100','2013-07-26','18:35:00',1.47),('16100','2013-07-26','18:40:00',1.32),('16100','2013-07-26','18:45:00',1.17),('16100','2013-07-26','18:50:00',1.04),('16100','2013-07-25','07:55:00',1.04),('16100','2013-07-25','08:00:00',1.18),('16100','2013-07-25','08:05:00',1.21),('16100','2013-07-25','08:10:00',1.3),('16100','2013-07-25','08:15:00',1.48),('16100','2013-07-25','08:20:00',1.67),('16100','2013-07-25','08:25:00',1.83),('16100','2013-07-25','08:30:00',1.94),('16100','2013-07-25','08:35:00',2.03),('16100','2013-07-25','08:40:00',2.28),('16100','2013-07-25','08:45:00',2.42),('16100','2013-07-25','08:50:00',2.54),('16100','2013-07-25','08:55:00',2.81),('16100','2013-07-25','09:00:00',2.98),('16100','2013-07-25','09:05:00',3.32),('16100','2013-07-25','09:10:00',3.44),('16100','2013-07-25','09:15:00',3.47),('16100','2013-07-25','09:20:00',3.71),('16100','2013-07-25','09:25:00',3.85),('16100','2013-07-25','09:30:00',3.98),('16100','2013-07-25','09:35:00',4.14),('16100','2013-07-25','09:40:00',4.28),('16100','2013-07-25','09:45:00',4.41),('16100','2013-07-25','09:50:00',4.49),('16100','2013-07-25','09:55:00',4.61),('16100','2013-07-25','10:00:00',4.76),('16100','2013-07-25','10:05:00',4.88),('16100','2013-07-25','10:10:00',4.99),('16100','2013-07-25','10:15:00',5.07),('16100','2013-07-25','10:20:00',5.22),('16100','2013-07-25','10:25:00',5.32),('16100','2013-07-25','10:30:00',5.49),('16100','2013-07-25','10:35:00',5.51),('16100','2013-07-25','10:40:00',5.5),('16100','2013-07-25','10:45:00',5.55),('16100','2013-07-25','10:50:00',5.75),('16100','2013-07-25','10:55:00',5.94),('16100','2013-07-25','11:00:00',6.1),('16100','2013-07-25','11:05:00',6.09),('16100','2013-07-25','11:10:00',6.12),('16100','2013-07-25','11:15:00',6.32),('16100','2013-07-25','11:20:00',6.37),('16100','2013-07-25','11:25:00',6.43),('16100','2013-07-25','11:30:00',6.5),('16100','2013-07-25','11:35:00',6.48),('16100','2013-07-25','11:40:00',6.67),('16100','2013-07-25','11:45:00',6.76),('16100','2013-07-25','11:50:00',6.99),('16100','2013-07-25','11:55:00',6.86),('16100','2013-07-25','12:00:00',6.97),('16100','2013-07-25','12:05:00',7.05),('16100','2013-07-25','12:10:00',7.12),('16100','2013-07-25','12:15:00',6.57),('16100','2013-07-25','12:20:00',5.8),('16100','2013-07-25','12:25:00',7.46),('16100','2013-07-25','12:30:00',6.66),('16100','2013-07-25','12:35:00',2.52),('16100','2013-07-25','12:40:00',2.42),('16100','2013-07-25','12:45:00',7.19),('16100','2013-07-25','12:50:00',7.97),('16100','2013-07-25','12:55:00',4.25),('16100','2013-07-25','13:00:00',5.12),('16100','2013-07-25','13:05:00',5.94),('16100','2013-07-25','13:10:00',4.48),('16100','2013-07-25','13:15:00',4.43),('16100','2013-07-25','13:20:00',7.84),('16100','2013-07-25','13:25:00',7.71),('16100','2013-07-25','13:30:00',7.81),('16100','2013-07-25','13:35:00',7.55),('16100','2013-07-25','13:40:00',7.38),('16100','2013-07-25','13:45:00',6.93),('16100','2013-07-25','13:50:00',6.93),('16100','2013-07-25','13:55:00',7.62),('16100','2013-07-25','14:00:00',7.29),('16100','2013-07-25','14:05:00',7.71),('16100','2013-07-25','14:10:00',7.34),('16100','2013-07-25','14:15:00',7.22),('16100','2013-07-25','14:20:00',7.11),('16100','2013-07-25','14:25:00',7.09),('16100','2013-07-25','14:30:00',7.03),('16100','2013-07-25','14:35:00',6.98),('16100','2013-07-25','14:40:00',6.93),('16100','2013-07-25','14:45:00',6.88),('16100','2013-07-25','14:50:00',6.8),('16100','2013-07-25','14:55:00',6.72),('16100','2013-07-25','15:00:00',6.66),('16100','2013-07-25','15:05:00',6.6),('16100','2013-07-25','15:10:00',6.59),('16100','2013-07-25','15:15:00',6.47),('16100','2013-07-25','15:20:00',6.37),('16100','2013-07-25','15:25:00',6.33),('16100','2013-07-25','15:30:00',6.2),('16100','2013-07-25','15:35:00',6.15),('16100','2013-07-25','15:40:00',6.04),('16100','2013-07-25','15:45:00',5.96),('16100','2013-07-25','15:50:00',5.89),('16100','2013-07-25','15:55:00',5.85),('16100','2013-07-25','16:00:00',5.76),('16100','2013-07-25','16:05:00',5.68),('16100','2013-07-25','16:10:00',5.56),('16100','2013-07-25','16:15:00',5.43),('16100','2013-07-25','16:20:00',5.29),('16100','2013-07-25','16:25:00',5.17),('16100','2013-07-25','16:30:00',5.02),('16100','2013-07-25','16:35:00',4.95),('16100','2013-07-25','16:40:00',4.82),('16100','2013-07-25','16:45:00',4.67),('16100','2013-07-25','16:50:00',4.58),('16100','2013-07-25','16:55:00',4.46),('16100','2013-07-25','17:00:00',4.34),('16100','2013-07-25','17:05:00',4.2),('16100','2013-07-25','17:10:00',4.07),('16100','2013-07-25','17:15:00',3.9),('16100','2013-07-25','17:20:00',3.78),('16100','2013-07-25','17:25:00',3.6),('16100','2013-07-25','17:30:00',3.46),('16100','2013-07-25','17:35:00',3.28),('16100','2013-07-25','17:40:00',3.12),('16100','2013-07-25','17:45:00',2.94),('16100','2013-07-25','17:50:00',2.77),('16100','2013-07-25','17:55:00',2.66),('16100','2013-07-25','18:00:00',2.5),('16100','2013-07-25','18:05:00',2.35),('16100','2013-07-25','18:10:00',2.23),('16100','2013-07-25','18:15:00',2.07),('16100','2013-07-25','18:20:00',1.9),('16100','2013-07-25','18:25:00',1.75),('16100','2013-07-25','18:30:00',1.58),('16100','2013-07-25','18:35:00',1.39),('16100','2013-07-25','18:40:00',1.24),('16100','2013-07-25','18:45:00',1.13),('16100','2013-07-24','08:00:00',1.09),('16100','2013-07-24','08:05:00',1.23),('16100','2013-07-24','08:10:00',1.37),('16100','2013-07-24','08:15:00',1.49),('16100','2013-07-24','08:20:00',1.61),('16100','2013-07-24','08:25:00',1.79),('16100','2013-07-24','08:30:00',1.94),('16100','2013-07-24','08:35:00',2.09),('16100','2013-07-24','08:40:00',2.26),('16100','2013-07-24','08:45:00',2.36),('16100','2013-07-24','08:50:00',2.55),('16100','2013-07-24','08:55:00',2.73),('16100','2013-07-24','09:00:00',3.07),('16100','2013-07-24','09:05:00',3.31),('16100','2013-07-24','09:10:00',3.37),('16100','2013-07-24','09:15:00',3.64),('16100','2013-07-24','09:20:00',3.96),('16100','2013-07-24','09:25:00',4.13),('16100','2013-07-24','09:30:00',4.49),('16100','2013-07-24','09:35:00',3.03),('16100','2013-07-24','09:40:00',4.49),('16100','2013-07-24','09:45:00',4.07),('16100','2013-07-24','09:50:00',3.3),('16100','2013-07-24','09:55:00',2.62),('16100','2013-07-24','10:00:00',3.94),('16100','2013-07-24','10:05:00',5.1),('16100','2013-07-24','10:10:00',5.33),('16100','2013-07-24','10:15:00',5.39),('16100','2013-07-24','10:20:00',5.41),('16100','2013-07-24','10:25:00',5.59),('16100','2013-07-24','10:30:00',5.55),('16100','2013-07-24','10:35:00',3.28),('16100','2013-07-24','10:40:00',5.07),('16100','2013-07-24','10:45:00',6.09),('16100','2013-07-24','10:50:00',6.24),('16100','2013-07-24','10:55:00',6.28),('16100','2013-07-24','11:00:00',5.37),('16100','2013-07-24','11:05:00',2.72),('16100','2013-07-24','11:10:00',6.07),('16100','2013-07-24','11:15:00',6.8),('16100','2013-07-24','11:20:00',6.62),('16100','2013-07-24','11:25:00',6.53),('16100','2013-07-24','11:30:00',6.68),('16100','2013-07-24','11:35:00',6.05),('16100','2013-07-24','11:40:00',6.06),('16100','2013-07-24','11:45:00',6.95),('16100','2013-07-24','11:50:00',6.96),('16100','2013-07-24','11:55:00',6.96),('16100','2013-07-24','12:00:00',6.92),('16100','2013-07-24','12:05:00',6.4),('16100','2013-07-24','12:10:00',4.82),('16100','2013-07-24','12:15:00',3.13),('16100','2013-07-24','12:20:00',7.95),('16100','2013-07-24','12:25:00',7.67),('16100','2013-07-24','12:30:00',2.87),('16100','2013-07-24','12:35:00',7.59),('16100','2013-07-24','12:40:00',7.53),('16100','2013-07-24','12:45:00',7.29),('16100','2013-07-24','12:50:00',6.42),('16100','2013-07-24','12:55:00',5.21),('16100','2013-07-24','13:00:00',7.56),('16100','2013-07-24','13:05:00',7.42),('16100','2013-07-24','13:10:00',7.41),('16100','2013-07-24','13:15:00',7.46),('16100','2013-07-24','13:20:00',7.49),('16100','2013-07-24','13:25:00',7.41),('16100','2013-07-24','13:30:00',7.43),('16100','2013-07-24','13:35:00',7.49),('16100','2013-07-24','13:40:00',7.59),('16100','2013-07-24','13:45:00',7.53),('16100','2013-07-24','13:50:00',7.5),('16100','2013-07-24','13:55:00',7.5),('16100','2013-07-24','14:00:00',7.43),('16100','2013-07-24','14:05:00',7.44),('16100','2013-07-24','14:10:00',7.41),('16100','2013-07-24','14:15:00',7.36),('16100','2013-07-24','14:20:00',7.36),('16100','2013-07-24','14:25:00',7.28),('16100','2013-07-24','14:30:00',7.25),('16100','2013-07-24','14:35:00',7.22),('16100','2013-07-24','14:40:00',7.15),('16100','2013-07-24','14:45:00',7.11),('16100','2013-07-24','14:50:00',7.07),('16100','2013-07-24','14:55:00',7.02),('16100','2013-07-24','15:00:00',6.98),('16100','2013-07-24','15:05:00',6.94),('16100','2013-07-24','15:10:00',6.81),('16100','2013-07-24','15:15:00',6.78),('16100','2013-07-24','15:20:00',6.71),('16100','2013-07-24','15:25:00',6.58),('16100','2013-07-24','15:30:00',6.46),('16100','2013-07-24','15:35:00',6.43),('16100','2013-07-24','15:40:00',6.31),('16100','2013-07-24','15:45:00',6.23),('16100','2013-07-24','15:50:00',6.16),('16100','2013-07-24','15:55:00',6.05),('16100','2013-07-24','16:00:00',5.99),('16100','2013-07-24','16:05:00',5.87),('16100','2013-07-24','16:10:00',5.77),('16100','2013-07-24','16:15:00',5.65),('16100','2013-07-24','16:20:00',5.57),('16100','2013-07-24','16:25:00',5.42),('16100','2013-07-24','16:30:00',5.27),('16100','2013-07-24','16:35:00',5.1),('16100','2013-07-24','16:40:00',5),('16100','2013-07-24','16:45:00',4.86),('16100','2013-07-24','16:50:00',4.74),('16100','2013-07-24','16:55:00',4.64),('16100','2013-07-24','17:00:00',4.59),('16100','2013-07-24','17:05:00',4.37),('16100','2013-07-24','17:10:00',4.18),('16100','2013-07-24','17:15:00',4.05),('16100','2013-07-24','17:20:00',3.97),('16100','2013-07-24','17:25:00',3.81),('16100','2013-07-24','17:30:00',3.65),('16100','2013-07-24','17:35:00',3.52),('16100','2013-07-24','17:40:00',3.31),('16100','2013-07-24','17:45:00',3.16),('16100','2013-07-24','17:50:00',2.99),('16100','2013-07-24','17:55:00',2.85),('16100','2013-07-24','18:00:00',2.68),('16100','2013-07-24','18:05:00',2.51),('16100','2013-07-24','18:10:00',2.31),('16100','2013-07-24','18:15:00',2.2),('16100','2013-07-24','18:20:00',2.06),('16100','2013-07-24','18:25:00',1.88),('16100','2013-07-24','18:30:00',1.72),('16100','2013-07-24','18:35:00',1.5),('16100','2013-07-24','18:40:00',1.36),('16100','2013-07-24','18:45:00',1.22),('16100','2013-07-24','18:50:00',1.08),('16100','2013-07-23','07:50:00',1.08),('16100','2013-07-23','07:55:00',1.17),('16100','2013-07-23','08:00:00',1.34),('16100','2013-07-23','08:05:00',1.49),('16100','2013-07-23','08:10:00',1.63),('16100','2013-07-23','08:15:00',1.75),('16100','2013-07-23','08:20:00',1.96),('16100','2013-07-23','08:25:00',2.14),('16100','2013-07-23','08:30:00',1.57),('16100','2013-07-23','08:35:00',1.64),('16100','2013-07-23','08:40:00',2),('16100','2013-07-23','08:45:00',1.98),('16100','2013-07-23','08:50:00',2.03),('16100','2013-07-23','08:55:00',1.74),('16100','2013-07-23','09:00:00',2.11),('16100','2013-07-23','09:05:00',3.29),('16100','2013-07-23','09:10:00',3.56),('16100','2013-07-23','09:15:00',3.69),('16100','2013-07-23','09:20:00',4.04),('16100','2013-07-23','09:25:00',3.88),('16100','2013-07-23','09:30:00',2.42),('16100','2013-07-23','09:35:00',1.65),('16100','2013-07-23','09:40:00',1.44),('16100','2013-07-23','09:45:00',1.57),('16100','2013-07-23','09:50:00',2.5),('16100','2013-07-23','09:55:00',4.86),('16100','2013-07-23','10:00:00',5.16),('16100','2013-07-23','10:05:00',5.4),('16100','2013-07-23','10:10:00',5.76),('16100','2013-07-23','10:15:00',5.46),('16100','2013-07-23','10:20:00',2.44),('16100','2013-07-23','10:25:00',1.62),('16100','2013-07-23','10:30:00',1.41),('16100','2013-07-23','10:35:00',1.96),('16100','2013-07-23','10:40:00',5.46),('16100','2013-07-23','10:45:00',6.2),('16100','2013-07-23','10:50:00',6.42),('16100','2013-07-23','10:55:00',5.32),('16100','2013-07-23','11:00:00',3.96),('16100','2013-07-23','11:05:00',6.02),('16100','2013-07-23','11:10:00',3.55),('16100','2013-07-23','11:15:00',5.18),('16100','2013-07-23','11:20:00',5.74),('16100','2013-07-23','11:25:00',4.3),('16100','2013-07-23','11:30:00',5.14),('16100','2013-07-23','11:35:00',5.56),('16100','2013-07-23','11:40:00',6.73),('16100','2013-07-23','11:45:00',7.04),('16100','2013-07-23','11:50:00',6.22),('16100','2013-07-23','11:55:00',6.46),('16100','2013-07-23','12:00:00',7.13),('16100','2013-07-23','12:05:00',5.92),('16100','2013-07-23','12:10:00',3.61),('16100','2013-07-23','12:15:00',4.56),('16100','2013-07-23','12:20:00',7.85),('16100','2013-07-23','12:25:00',7.8),('16100','2013-07-23','12:30:00',7.62),('16100','2013-07-23','12:35:00',7.4),('16100','2013-07-23','12:40:00',7.52),('16100','2013-07-23','12:45:00',7.73),('16100','2013-07-23','12:50:00',7.42),('16100','2013-07-23','12:55:00',7.36),('16100','2013-07-23','13:00:00',7.23),('16100','2013-07-23','13:05:00',7.35),('16100','2013-07-23','13:10:00',7.58),('16100','2013-07-23','13:15:00',7.29),('16100','2013-07-23','13:20:00',7.44),('16100','2013-07-23','13:25:00',7.52),('16100','2013-07-23','13:30:00',7.43),('16100','2013-07-23','13:35:00',7.51),('16100','2013-07-23','13:40:00',7.44),('16100','2013-07-23','13:45:00',7.58),('16100','2013-07-23','13:50:00',7.44),('16100','2013-07-23','13:55:00',7.39),('16100','2013-07-23','14:00:00',7.44),('16100','2013-07-23','14:05:00',7.49),('16100','2013-07-23','14:10:00',7.43),('16100','2013-07-23','14:15:00',7.37),('16100','2013-07-23','14:20:00',7.31),('16100','2013-07-23','14:25:00',7.37),('16100','2013-07-23','14:30:00',7.34),('16100','2013-07-23','14:35:00',7.24),('16100','2013-07-23','14:40:00',7.21),('16100','2013-07-23','14:45:00',7.19),('16100','2013-07-23','14:50:00',7.12),('16100','2013-07-23','14:55:00',7.06),('16100','2013-07-23','15:00:00',7.03),('16100','2013-07-23','15:05:00',6.94),('16100','2013-07-23','15:10:00',6.74),('16100','2013-07-23','15:15:00',6.77),('16100','2013-07-23','15:20:00',6.5),('16100','2013-07-23','15:25:00',6.19),('16100','2013-07-23','15:30:00',6.59),('16100','2013-07-23','15:35:00',6.29),('16100','2013-07-23','15:40:00',6.25),('16100','2013-07-23','15:45:00',6.11),('16100','2013-07-23','15:50:00',5.94),('16100','2013-07-23','15:55:00',5.66),('16100','2013-07-23','16:00:00',5.45),('16100','2013-07-23','16:05:00',5.99),('16100','2013-07-23','16:10:00',5.93),('16100','2013-07-23','16:15:00',5.68),('16100','2013-07-23','16:20:00',5.61),('16100','2013-07-23','16:25:00',5.29),('16100','2013-07-23','16:30:00',5.28),('16100','2013-07-23','16:35:00',4.5),('16100','2013-07-23','16:40:00',5.02),('16100','2013-07-23','16:45:00',5.25),('16100','2013-07-23','16:50:00',5.05),('16100','2013-07-23','16:55:00',3.92),('16100','2013-07-23','17:00:00',3.92),('16100','2013-07-23','17:05:00',4.78),('16100','2013-07-23','17:10:00',4.53),('16100','2013-07-23','17:15:00',4.25),('16100','2013-07-23','17:20:00',4.04),('16100','2013-07-23','17:25:00',3.85),('16100','2013-07-23','17:30:00',3.55),('16100','2013-07-23','17:35:00',3.49),('16100','2013-07-23','17:40:00',3.35),('16100','2013-07-23','17:45:00',3.18),('16100','2013-07-23','17:50:00',2.94),('16100','2013-07-23','17:55:00',2.74),('16100','2013-07-23','18:00:00',2.68),('16100','2013-07-23','18:05:00',2.44),('16100','2013-07-23','18:10:00',2.24),('16100','2013-07-23','18:15:00',2.16),('16100','2013-07-23','18:20:00',2.08),('16100','2013-07-23','18:25:00',1.85),('16100','2013-07-23','18:30:00',1.72),('16100','2013-07-23','18:35:00',1.52),('16100','2013-07-23','18:40:00',1.41),('16100','2013-07-23','18:45:00',1.09),('16100','2013-07-22','08:00:00',1.17),('16100','2013-07-22','08:05:00',1.32),('16100','2013-07-22','08:15:00',1.24),('16100','2013-07-22','08:20:00',1.37),('16100','2013-07-22','08:25:00',1.99),('16100','2013-07-22','08:30:00',2.16),('16100','2013-07-22','08:35:00',2.32),('16100','2013-07-22','08:40:00',2.52),('16100','2013-07-22','08:45:00',2.65),('16100','2013-07-22','08:50:00',2.79),('16100','2013-07-22','08:55:00',2.95),('16100','2013-07-22','09:00:00',3.2),('16100','2013-07-22','09:05:00',3.47),('16100','2013-07-22','09:10:00',3.63),('16100','2013-07-22','09:15:00',3.78),('16100','2013-07-22','09:20:00',3.88),('16100','2013-07-22','09:25:00',4.03),('16100','2013-07-22','09:30:00',4.21),('16100','2013-07-22','09:35:00',4.34),('16100','2013-07-22','09:40:00',4.45),('16100','2013-07-22','09:45:00',4.59),('16100','2013-07-22','09:50:00',4.65),('16100','2013-07-22','09:55:00',4.76),('16100','2013-07-22','10:00:00',4.88),('16100','2013-07-22','10:05:00',5),('16100','2013-07-22','10:10:00',5.14),('16100','2013-07-22','10:15:00',5.3),('16100','2013-07-22','10:20:00',5.37),('16100','2013-07-22','10:25:00',5.05),('16100','2013-07-22','10:30:00',5.53),('16100','2013-07-22','10:35:00',5.58),('16100','2013-07-22','10:40:00',5.57),('16100','2013-07-22','10:45:00',5.69),('16100','2013-07-22','10:50:00',5.81),('16100','2013-07-22','10:55:00',5.93),('16100','2013-07-22','11:00:00',6.05),('16100','2013-07-22','11:05:00',6.18),('16100','2013-07-22','11:10:00',6.15),('16100','2013-07-22','11:15:00',6.01),('16100','2013-07-22','11:20:00',3.77),('16100','2013-07-22','11:25:00',3.95),('16100','2013-07-22','11:30:00',2.66),('16100','2013-07-22','11:35:00',1.81),('16100','2013-07-22','11:40:00',1.69),('16100','2013-07-22','11:45:00',2.07),('16100','2013-07-22','11:50:00',2.75),('16100','2013-07-22','11:55:00',7.78),('16100','2013-07-22','12:00:00',6.66),('16100','2013-07-22','12:05:00',6.75),('16100','2013-07-22','12:10:00',3.63),('16100','2013-07-22','12:15:00',2.4),('16100','2013-07-22','12:20:00',4.33),('16100','2013-07-22','12:25:00',7.56),('16100','2013-07-22','12:30:00',7.84),('16100','2013-07-22','12:35:00',7.33),('16100','2013-07-22','12:40:00',3.66),('16100','2013-07-22','12:45:00',6.43),('16100','2013-07-22','12:50:00',5.04),('16100','2013-07-22','12:55:00',4.69),('16100','2013-07-22','13:00:00',2.8),('16100','2013-07-22','13:05:00',7.83),('16100','2013-07-22','13:10:00',7.89),('16100','2013-07-22','13:15:00',7.42),('16100','2013-07-22','13:20:00',7.47),('16100','2013-07-22','13:25:00',7.22),('16100','2013-07-22','13:30:00',6.54),('16100','2013-07-22','13:35:00',7.63),('16100','2013-07-22','13:40:00',7.59),('16100','2013-07-22','13:45:00',7.51),('16100','2013-07-22','13:50:00',7.55),('16100','2013-07-22','13:55:00',7.95),('16100','2013-07-22','14:00:00',4.88),('16100','2013-07-22','14:05:00',7.96),('16100','2013-07-22','14:10:00',3.68),('16100','2013-07-22','14:15:00',5.39),('16100','2013-07-22','14:20:00',7.67),('16100','2013-07-22','14:25:00',7.48),('16100','2013-07-22','14:30:00',7.44),('16100','2013-07-22','14:35:00',7.45),('16100','2013-07-22','14:40:00',7.37),('16100','2013-07-22','14:45:00',7.23),('16100','2013-07-22','14:50:00',7.17),('16100','2013-07-22','14:55:00',6.92),('16100','2013-07-22','15:00:00',6.88),('16100','2013-07-22','15:05:00',6.9),('16100','2013-07-22','15:10:00',6.82),('16100','2013-07-22','15:15:00',6.66),('16100','2013-07-22','15:20:00',6.56),('16100','2013-07-22','15:25:00',6.51),('16100','2013-07-22','15:30:00',6.32),('16100','2013-07-22','15:35:00',6.26),('16100','2013-07-22','15:40:00',6.22),('16100','2013-07-22','15:45:00',6.12),('16100','2013-07-22','15:50:00',5.61),('16100','2013-07-22','15:55:00',5.94),('16100','2013-07-22','16:00:00',5.84),('16100','2013-07-22','16:05:00',5.73),('16100','2013-07-22','16:10:00',5.65),('16100','2013-07-22','16:15:00',5.57),('16100','2013-07-22','16:20:00',5.49),('16100','2013-07-22','16:25:00',5.36),('16100','2013-07-22','16:30:00',5.18),('16100','2013-07-22','16:35:00',5.06),('16100','2013-07-22','16:40:00',4.95),('16100','2013-07-22','16:45:00',4.85),('16100','2013-07-22','16:50:00',4.71),('16100','2013-07-22','16:55:00',4.59),('16100','2013-07-22','17:00:00',4.45),('16100','2013-07-22','17:05:00',4.3),('16100','2013-07-22','17:10:00',4.15),('16100','2013-07-22','17:15:00',4.01),('16100','2013-07-22','17:20:00',3.88),('16100','2013-07-22','17:25:00',3.74),('16100','2013-07-22','17:30:00',3.59),('16100','2013-07-22','17:35:00',3.49),('16100','2013-07-22','17:40:00',3.31),('16100','2013-07-22','17:45:00',3.17),('16100','2013-07-22','17:50:00',3.01),('16100','2013-07-22','17:55:00',2.83),('16100','2013-07-22','18:00:00',2.64),('16100','2013-07-22','18:05:00',2.49),('16100','2013-07-22','18:10:00',2.36),('16100','2013-07-22','18:15:00',2.21),('16100','2013-07-22','18:20:00',2.06),('16100','2013-07-22','18:25:00',1.92),('16100','2013-07-22','18:30:00',1.73),('16100','2013-07-22','18:35:00',1.47),('16100','2013-07-22','18:40:00',1.05),('16100','2013-07-22','18:50:00',1.03),('16100','2013-07-21','08:00:00',1.18),('16100','2013-07-21','08:05:00',1.33),('16100','2013-07-21','08:10:00',1.48),('16100','2013-07-21','08:15:00',1.63),('16100','2013-07-21','08:20:00',1.8),('16100','2013-07-21','08:25:00',1.98),('16100','2013-07-21','08:30:00',2.12),('16100','2013-07-21','08:35:00',2.27),('16100','2013-07-21','08:40:00',2.46),('16100','2013-07-21','08:45:00',2.61),('16100','2013-07-21','08:50:00',2.77),('16100','2013-07-21','08:55:00',2.97),('16100','2013-07-21','09:00:00',3.14),('16100','2013-07-21','09:05:00',3.47),('16100','2013-07-21','09:10:00',3.64),('16100','2013-07-21','09:15:00',3.77),('16100','2013-07-21','09:20:00',3.9),('16100','2013-07-21','09:25:00',4.05),('16100','2013-07-21','09:30:00',4.21),('16100','2013-07-21','09:35:00',4.31),('16100','2013-07-21','09:40:00',4.46),('16100','2013-07-21','09:45:00',4.59),('16100','2013-07-21','09:50:00',4.71),('16100','2013-07-21','09:55:00',4.83),('16100','2013-07-21','10:00:00',4.95),('16100','2013-07-21','10:05:00',5.07),('16100','2013-07-21','10:10:00',5.21),('16100','2013-07-21','10:15:00',5.35),('16100','2013-07-21','10:20:00',5.45),('16100','2013-07-21','10:25:00',5.58),('16100','2013-07-21','10:30:00',5.68),('16100','2013-07-21','10:35:00',5.75),('16100','2013-07-21','10:40:00',5.8),('16100','2013-07-21','10:45:00',5.91),('16100','2013-07-21','10:50:00',6.01),('16100','2013-07-21','10:55:00',6.04),('16100','2013-07-21','11:00:00',6.16),('16100','2013-07-21','11:05:00',6.29),('16100','2013-07-21','11:10:00',6.38),('16100','2013-07-21','11:15:00',6.44),('16100','2013-07-21','11:20:00',6.49),('16100','2013-07-21','11:25:00',6.52),('16100','2013-07-21','11:30:00',6.6),('16100','2013-07-21','11:35:00',6.65),('16100','2013-07-21','11:40:00',6.73),('16100','2013-07-21','11:45:00',6.8),('16100','2013-07-21','11:50:00',6.86),('16100','2013-07-21','11:55:00',6.92),('16100','2013-07-21','12:00:00',6.98),('16100','2013-07-21','12:05:00',7.02),('16100','2013-07-21','12:10:00',7.09),('16100','2013-07-21','12:15:00',7.07),('16100','2013-07-21','12:20:00',7.13),('16100','2013-07-21','12:25:00',7.16),('16100','2013-07-21','12:30:00',7.13),('16100','2013-07-21','12:35:00',7.17),('16100','2013-07-21','12:40:00',7.15),('16100','2013-07-21','12:45:00',7.21),('16100','2013-07-21','12:50:00',7.25),('16100','2013-07-21','12:55:00',7.24),('16100','2013-07-21','13:00:00',7.25),('16100','2013-07-21','13:05:00',7.28),('16100','2013-07-21','13:10:00',7.22),('16100','2013-07-21','13:15:00',7.19),('16100','2013-07-21','13:20:00',7.24),('16100','2013-07-21','13:25:00',7.17),('16100','2013-07-21','13:30:00',7.19),('16100','2013-07-21','13:35:00',7.24),('16100','2013-07-21','13:40:00',7.2),('16100','2013-07-21','13:45:00',7.25),('16100','2013-07-21','13:50:00',7.26),('16100','2013-07-21','13:55:00',7.18),('16100','2013-07-21','14:00:00',7.11),('16100','2013-07-21','14:05:00',7.07),('16100','2013-07-21','14:10:00',7.11),('16100','2013-07-21','14:15:00',6.96),('16100','2013-07-21','14:20:00',6.97),('16100','2013-07-21','14:25:00',6.87),('16100','2013-07-21','14:30:00',6.86),('16100','2013-07-21','14:35:00',6.86),('16100','2013-07-21','14:40:00',6.95),('16100','2013-07-21','14:45:00',6.73),('16100','2013-07-21','14:50:00',5.18),('16100','2013-07-21','14:55:00',6.51),('16100','2013-07-21','15:00:00',6.75),('16100','2013-07-21','15:05:00',6.58),('16100','2013-07-21','15:10:00',6.66),('16100','2013-07-21','15:15:00',6.42),('16100','2013-07-21','15:20:00',1.65),('16100','2013-07-21','15:25:00',1.63),('16100','2013-07-21','15:30:00',2.52),('16100','2013-07-21','15:35:00',1.98),('16100','2013-07-21','15:40:00',1.61),('16100','2013-07-21','15:45:00',1.89),('16100','2013-07-21','15:50:00',4.26),('16100','2013-07-21','15:55:00',3.19),('16100','2013-07-21','16:00:00',5.29),('16100','2013-07-21','16:05:00',5.09),('16100','2013-07-21','16:10:00',5.89),('16100','2013-07-21','16:15:00',5.83),('16100','2013-07-21','16:20:00',5.66),('16100','2013-07-21','16:25:00',5.59),('16100','2013-07-21','16:30:00',5.18),('16100','2013-07-21','16:35:00',4.95),('16100','2013-07-21','16:40:00',4.81),('16100','2013-07-21','16:45:00',4.48),('16100','2013-07-21','16:50:00',3.33),('16100','2013-07-21','16:55:00',4.55),('16100','2013-07-21','17:00:00',4.4),('16100','2013-07-21','17:05:00',4.24),('16100','2013-07-21','17:10:00',4.11),('16100','2013-07-21','17:15:00',3.95),('16100','2013-07-21','17:20:00',3.83),('16100','2013-07-21','17:25:00',3.68),('16100','2013-07-21','17:30:00',3.6),('16100','2013-07-21','17:35:00',3.48),('16100','2013-07-21','17:40:00',3.32),('16100','2013-07-21','17:45:00',3.14),('16100','2013-07-21','17:50:00',3.03),('16100','2013-07-21','17:55:00',2.89),('16100','2013-07-21','18:00:00',2.68),('16100','2013-07-21','18:05:00',2.44),('16100','2013-07-21','18:10:00',2.02),('16100','2013-07-21','18:15:00',1.57),('16100','2013-07-21','18:20:00',1.95),('16100','2013-07-21','18:25:00',1.73),('16100','2013-07-21','18:30:00',1.71),('16100','2013-07-21','18:35:00',1.59),('16100','2013-07-21','18:40:00',1.3),('16100','2013-07-21','18:45:00',1.17),('16100','2013-07-21','18:50:00',1.02),('16100','2013-07-20','07:55:00',1.02),('16100','2013-07-20','08:00:00',1.16),('16100','2013-07-20','08:05:00',1.29),('16100','2013-07-20','08:10:00',1.43),('16100','2013-07-20','08:15:00',1.56),('16100','2013-07-20','08:20:00',1.71),('16100','2013-07-20','08:25:00',1.9),('16100','2013-07-20','08:30:00',2.05),('16100','2013-07-20','08:35:00',2.21),('16100','2013-07-20','08:40:00',2.38),('16100','2013-07-20','08:45:00',2.51),('16100','2013-07-20','08:50:00',2.67),('16100','2013-07-20','08:55:00',2.85),('16100','2013-07-20','09:00:00',2.99),('16100','2013-07-20','09:05:00',3.34),('16100','2013-07-20','09:10:00',3.54),('16100','2013-07-20','09:15:00',3.69),('16100','2013-07-20','09:20:00',3.81),('16100','2013-07-20','09:25:00',3.93),('16100','2013-07-20','09:30:00',4.08),('16100','2013-07-20','09:35:00',4.21),('16100','2013-07-20','09:40:00',4.35),('16100','2013-07-20','09:45:00',4.46),('16100','2013-07-20','09:50:00',4.52),('16100','2013-07-20','09:55:00',4.67),('16100','2013-07-20','10:00:00',4.76),('16100','2013-07-20','10:05:00',4.88),('16100','2013-07-20','10:10:00',5.02),('16100','2013-07-20','10:15:00',5.17),('16100','2013-07-20','10:20:00',5.31),('16100','2013-07-20','10:25:00',5.44),('16100','2013-07-20','10:30:00',5.48),('16100','2013-07-20','10:35:00',5.56),('16100','2013-07-20','10:40:00',5.76),('16100','2013-07-20','10:45:00',5.82),('16100','2013-07-20','10:50:00',5.93),('16100','2013-07-20','10:55:00',6.01),('16100','2013-07-20','11:00:00',6.05),('16100','2013-07-20','11:05:00',6.19),('16100','2013-07-20','11:10:00',6.29),('16100','2013-07-20','11:15:00',6.36),('16100','2013-07-20','11:20:00',6.44),('16100','2013-07-20','11:25:00',6.48),('16100','2013-07-20','11:30:00',6.54),('16100','2013-07-20','11:35:00',6.6),('16100','2013-07-20','11:40:00',6.66),('16100','2013-07-20','11:45:00',6.78),('16100','2013-07-20','11:50:00',6.78),('16100','2013-07-20','11:55:00',6.84),('16100','2013-07-20','12:00:00',6.75),('16100','2013-07-20','12:05:00',6.84),('16100','2013-07-20','12:10:00',7.12),('16100','2013-07-20','12:15:00',7.74),('16100','2013-07-20','12:20:00',4.7),('16100','2013-07-20','12:25:00',3.66),('16100','2013-07-20','12:30:00',3.79),('16100','2013-07-20','12:35:00',4.78),('16100','2013-07-20','12:40:00',5.61),('16100','2013-07-20','12:45:00',6.23),('16100','2013-07-20','12:50:00',3.7),('16100','2013-07-20','12:55:00',3.24),('16100','2013-07-20','13:00:00',3.21),('16100','2013-07-20','13:05:00',3.37),('16100','2013-07-20','13:10:00',3.3),('16100','2013-07-20','13:15:00',3.4),('16100','2013-07-20','13:20:00',8.03),('16100','2013-07-20','13:25:00',6.62),('16100','2013-07-20','13:30:00',6.46),('16100','2013-07-20','13:35:00',6.03),('16100','2013-07-20','13:40:00',7.16),('16100','2013-07-20','13:45:00',7.69),('16100','2013-07-20','13:50:00',7.93),('16100','2013-07-20','13:55:00',5.21),('16100','2013-07-20','14:00:00',3.39),('16100','2013-07-20','14:05:00',4.82),('16100','2013-07-20','14:10:00',4.31),('16100','2013-07-20','14:15:00',4.07),('16100','2013-07-20','14:20:00',2.92),('16100','2013-07-20','14:25:00',2.9),('16100','2013-07-20','14:30:00',2.48),('16100','2013-07-20','14:35:00',2.21),('16100','2013-07-20','14:40:00',2.21),('16100','2013-07-20','14:45:00',2.45),('16100','2013-07-20','14:50:00',3.23),('16100','2013-07-20','14:55:00',3.71),('16100','2013-07-20','15:00:00',2.21),('16100','2013-07-20','15:05:00',2.12),('16100','2013-07-20','15:10:00',2.06),('16100','2013-07-20','15:15:00',2.15),('16100','2013-07-20','15:20:00',2.44),('16100','2013-07-20','15:25:00',2.31),('16100','2013-07-20','15:30:00',2.34),('16100','2013-07-20','15:35:00',2.75),('16100','2013-07-20','15:40:00',3.53),('16100','2013-07-20','15:45:00',3.08),('16100','2013-07-20','15:50:00',4.84),('16100','2013-07-20','15:55:00',3.58),('16100','2013-07-20','16:00:00',2.24),('16100','2013-07-20','16:05:00',1.66),('16100','2013-07-20','16:10:00',1.43),('16100','2013-07-20','16:15:00',1.23),('16100','2013-07-20','16:20:00',1.12),('16100','2013-07-20','16:25:00',1.12),('16100','2013-07-20','16:30:00',1.25),('16100','2013-07-20','16:35:00',1.5),('16100','2013-07-20','16:40:00',1.69),('16100','2013-07-20','16:45:00',1.68),('16100','2013-07-20','16:50:00',1.66),('16100','2013-07-20','16:55:00',1.63),('16100','2013-07-20','17:00:00',1.82),('16100','2013-07-20','17:05:00',2.43),('16100','2013-07-20','17:10:00',1.96),('16100','2013-07-20','17:15:00',1.58),('16100','2013-07-20','17:20:00',1.35),('16100','2013-07-20','17:25:00',1.22),('16100','2013-07-20','17:30:00',1.14),('16100','2013-07-20','17:35:00',1.08),('16100','2013-07-20','17:40:00',1.07),('16100','2013-07-20','17:45:00',1.08),('16100','2013-07-20','17:50:00',1.09),('16100','2013-07-20','17:55:00',1.12),('16100','2013-07-20','18:00:00',1.12),('16100','2013-07-20','18:05:00',1.03),('16100','2014-04-06','08:10:00',1.05),('16100','2014-04-06','08:15:00',1.26),('16100','2014-04-06','08:20:00',1.35),('16100','2014-04-06','08:25:00',1.57),('16100','2014-04-06','08:30:00',1.57),('16100','2014-04-06','08:35:00',1.71),('16100','2014-04-06','08:40:00',1.58),('16100','2014-04-06','08:45:00',1.54),('16100','2014-04-06','08:50:00',1.53),('16100','2014-04-06','08:55:00',1.52),('16100','2014-04-06','09:00:00',1.55),('16100','2014-04-06','09:05:00',1.64),('16100','2014-04-06','09:10:00',1.61),('16100','2014-04-06','09:15:00',1.57),('16100','2014-04-06','09:20:00',1.57),('16100','2014-04-06','09:25:00',1.59),('16100','2014-04-06','09:30:00',1.64),('16100','2014-04-06','09:35:00',1.7),('16100','2014-04-06','09:40:00',1.78),('16100','2014-04-06','09:45:00',1.84),('16100','2014-04-06','09:50:00',1.84),('16100','2014-04-06','09:55:00',1.86),('16100','2014-04-06','10:00:00',1.87),('16100','2014-04-06','10:05:00',1.87),('16100','2014-04-06','10:10:00',1.87),('16100','2014-04-06','10:15:00',1.91),('16100','2014-04-06','10:20:00',1.94),('16100','2014-04-06','10:25:00',1.91),('16100','2014-04-06','10:30:00',1.91),('16100','2014-04-06','10:35:00',1.98),('16100','2014-04-06','10:40:00',2.11),('16100','2014-04-06','10:45:00',2.25),('16100','2014-04-06','10:50:00',2.39),('16100','2014-04-06','10:55:00',2.44),('16100','2014-04-06','11:00:00',2.54),('16100','2014-04-06','11:05:00',2.57),('16100','2014-04-06','11:10:00',2.63),('16100','2014-04-06','11:15:00',2.72),('16100','2014-04-06','11:20:00',2.75),('16100','2014-04-06','11:25:00',2.68),('16100','2014-04-06','11:30:00',2.72),('16100','2014-04-06','11:35:00',2.6),('16100','2014-04-06','11:40:00',2.58),('16100','2014-04-06','11:45:00',2.62),('16100','2014-04-06','11:50:00',2.61),('16100','2014-04-06','11:55:00',3.08),('16100','2014-04-06','12:00:00',3.77),('16100','2014-04-06','12:05:00',5.38),('16100','2014-04-06','12:10:00',6.07),('16100','2014-04-06','12:15:00',6.39),('16100','2014-04-06','12:20:00',5.49),('16100','2014-04-06','12:25:00',3.65),('16100','2014-04-06','12:30:00',3.41),('16100','2014-04-06','12:35:00',6.53),('16100','2014-04-06','12:40:00',7.46),('16100','2014-04-06','12:45:00',7.19),('16100','2014-04-06','12:50:00',7.01),('16100','2014-04-06','12:55:00',7.03),('16100','2014-04-06','13:00:00',7.05),('16100','2014-04-06','13:05:00',7.04),('16100','2014-04-06','13:10:00',7.04),('16100','2014-04-06','13:15:00',7.03),('16100','2014-04-06','13:20:00',7.04),('16100','2014-04-06','13:25:00',7.03),('16100','2014-04-06','13:30:00',7.02),('16100','2014-04-06','13:35:00',6.99),('16100','2014-04-06','13:40:00',6.98),('16100','2014-04-06','13:45:00',6.94),('16100','2014-04-06','13:50:00',6.91),('16100','2014-04-06','13:55:00',6.9),('16100','2014-04-06','14:00:00',6.8),('16100','2014-04-06','14:05:00',6.8),('16100','2014-04-06','14:10:00',6.76),('16100','2014-04-06','14:15:00',6.7),('16100','2014-04-06','14:20:00',6.72),('16100','2014-04-06','14:25:00',6.64),('16100','2014-04-06','14:30:00',6.63),('16100','2014-04-06','14:35:00',6.56),('16100','2014-04-06','14:40:00',6.57),('16100','2014-04-06','14:45:00',6.69),('16100','2014-04-06','14:50:00',6.56),('16100','2014-04-06','14:55:00',6.37),('16100','2014-04-06','15:00:00',6.34),('16100','2014-04-06','15:05:00',5.51),('16100','2014-04-06','15:10:00',6.32),('16100','2014-04-06','15:15:00',6.26),('16100','2014-04-06','15:20:00',6.15),('16100','2014-04-06','15:25:00',6.04),('16100','2014-04-06','15:30:00',5.94),('16100','2014-04-06','15:35:00',5.9),('16100','2014-04-06','15:40:00',5.85),('16100','2014-04-06','15:45:00',5.78),('16100','2014-04-06','15:50:00',5.76),('16100','2014-04-06','15:55:00',5.69),('16100','2014-04-06','16:00:00',5.6),('16100','2014-04-06','16:05:00',5.49),('16100','2014-04-06','16:10:00',5.23),('16100','2014-04-06','16:15:00',3.4),('16100','2014-04-06','16:20:00',1.52),('16100','2014-04-06','16:25:00',1.12),('16100','2014-04-06','16:30:00',1.98),('16100','2014-04-06','16:35:00',2.61),('16100','2014-04-06','16:40:00',1.33),('16100','2014-04-06','16:45:00',2.78),('16100','2014-04-06','16:50:00',4.48),('16100','2014-04-06','16:55:00',4.5),('16100','2014-04-06','17:00:00',4.55),('16100','2014-04-06','17:05:00',4.02),('16100','2014-04-06','17:10:00',3.18),('16100','2014-04-06','17:15:00',2.9),('16100','2014-04-06','17:20:00',2.84),('16100','2014-04-06','17:25:00',2.7),('16100','2014-04-06','17:30:00',2.37),('16100','2014-04-06','17:35:00',2.76),('16100','2014-04-06','17:40:00',2.77),('16100','2014-04-06','17:45:00',2.52),('16100','2014-04-06','17:50:00',2.1),('16100','2014-04-06','17:55:00',1.77),('16100','2014-04-06','18:00:00',1.55),('16100','2014-04-06','18:05:00',1.53),('16100','2014-04-06','18:10:00',1.49),('16100','2014-04-06','18:15:00',1.48),('16100','2014-04-06','18:20:00',1.22),('16100','2014-04-06','18:25:00',1.02),('16100','2013-07-19','08:00:00',1.19),('16100','2013-07-19','08:05:00',1.36),('16100','2013-07-19','08:10:00',1.51),('16100','2013-07-19','08:15:00',1.68),('16100','2013-07-19','08:20:00',1.86),('16100','2013-07-19','08:25:00',2.03),('16100','2013-07-19','08:30:00',2.18),('16100','2013-07-19','08:35:00',2.35),('16100','2013-07-19','08:40:00',2.55),('16100','2013-07-19','08:45:00',2.7),('16100','2013-07-19','08:50:00',2.89),('16100','2013-07-19','08:55:00',3.09),('16100','2013-07-19','09:00:00',3.21),('16100','2013-07-19','09:05:00',3.61),('16100','2013-07-19','09:10:00',3.87),('16100','2013-07-19','09:15:00',4.03),('16100','2013-07-19','09:20:00',4.06),('16100','2013-07-19','09:25:00',4.04),('16100','2013-07-19','09:30:00',4.26),('16100','2013-07-19','09:35:00',4.29),('16100','2013-07-19','09:40:00',4.24),('16100','2013-07-19','09:45:00',4.04),('16100','2013-07-19','09:50:00',4.35),('16100','2013-07-19','09:55:00',4.67),('16100','2013-07-19','10:00:00',4.98),('16100','2013-07-19','10:05:00',5.1),('16100','2013-07-19','10:10:00',5.26),('16100','2013-07-19','10:15:00',5.38),('16100','2013-07-19','10:20:00',5.49),('16100','2013-07-19','10:25:00',5.62),('16100','2013-07-19','10:30:00',5.71),('16100','2013-07-19','10:35:00',5.78),('16100','2013-07-19','10:40:00',5.84),('16100','2013-07-19','10:45:00',5.95),('16100','2013-07-19','10:50:00',5.98),('16100','2013-07-19','10:55:00',6.11),('16100','2013-07-19','11:00:00',6.22),('16100','2013-07-19','11:05:00',6.35),('16100','2013-07-19','11:10:00',6.39),('16100','2013-07-19','11:15:00',6.47),('16100','2013-07-19','11:20:00',6.57),('16100','2013-07-19','11:25:00',6.63),('16100','2013-07-19','11:30:00',6.72),('16100','2013-07-19','11:35:00',6.8),('16100','2013-07-19','11:40:00',6.83),('16100','2013-07-19','11:45:00',6.86),('16100','2013-07-19','11:50:00',6.95),('16100','2013-07-19','11:55:00',6.98),('16100','2013-07-19','12:00:00',7.1),('16100','2013-07-19','12:05:00',7.16),('16100','2013-07-19','12:10:00',7.17),('16100','2013-07-19','12:15:00',7.23),('16100','2013-07-19','12:20:00',7.26),('16100','2013-07-19','12:25:00',7.23),('16100','2013-07-19','12:30:00',7.37),('16100','2013-07-19','12:35:00',7.34),('16100','2013-07-19','12:40:00',7.35),('16100','2013-07-19','12:45:00',7.4),('16100','2013-07-19','12:50:00',7.44),('16100','2013-07-19','12:55:00',4.03),('16100','2013-07-19','13:00:00',7.15),('16100','2013-07-19','13:05:00',7.6),('16100','2013-07-19','13:10:00',7.63),('16100','2013-07-19','13:15:00',7.48),('16100','2013-07-19','13:20:00',7.52),('16100','2013-07-19','13:25:00',7.37),('16100','2013-07-19','13:30:00',7.27),('16100','2013-07-19','13:35:00',2.3),('16100','2013-07-19','13:40:00',5.47),('16100','2013-07-19','13:45:00',3.93),('16100','2013-07-19','13:50:00',7.81),('16100','2013-07-19','13:55:00',6.82),('16100','2013-07-19','14:00:00',6.3),('16100','2013-07-19','14:05:00',7.78),('16100','2013-07-19','14:10:00',6.6),('16100','2013-07-19','14:15:00',4.98),('16100','2013-07-19','14:20:00',7.55),('16100','2013-07-19','14:25:00',7.32),('16100','2013-07-19','14:30:00',7.36),('16100','2013-07-19','14:35:00',7.1),('16100','2013-07-19','14:40:00',7.13),('16100','2013-07-19','14:45:00',7.11),('16100','2013-07-19','14:50:00',7.08),('16100','2013-07-19','14:55:00',6.95),('16100','2013-07-19','15:00:00',6.8),('16100','2013-07-19','15:05:00',6.84),('16100','2013-07-19','15:10:00',6.72),('16100','2013-07-19','15:15:00',6.7),('16100','2013-07-19','15:20:00',6.63),('16100','2013-07-19','15:25:00',6.5),('16100','2013-07-19','15:30:00',6.39),('16100','2013-07-19','15:35:00',6.29),('16100','2013-07-19','15:40:00',6.25),('16100','2013-07-19','15:45:00',6.21),('16100','2013-07-19','15:50:00',6.13),('16100','2013-07-19','15:55:00',5.98),('16100','2013-07-19','16:00:00',5.86),('16100','2013-07-19','16:05:00',5.79),('16100','2013-07-19','16:10:00',5.66),('16100','2013-07-19','16:15:00',5.52),('16100','2013-07-19','16:20:00',5.47),('16100','2013-07-19','16:25:00',5.33),('16100','2013-07-19','16:30:00',5.19),('16100','2013-07-19','16:35:00',5.05),('16100','2013-07-19','16:40:00',4.99),('16100','2013-07-19','16:45:00',4.88),('16100','2013-07-19','16:50:00',4.77),('16100','2013-07-19','16:55:00',4.62),('16100','2013-07-19','17:00:00',4.5),('16100','2013-07-19','17:05:00',4.38),('16100','2013-07-19','17:10:00',4.24),('16100','2013-07-19','17:15:00',4.04),('16100','2013-07-19','17:20:00',3.94),('16100','2013-07-19','17:25:00',3.78),('16100','2013-07-19','17:30:00',3.63),('16100','2013-07-19','17:35:00',3.48),('16100','2013-07-19','17:40:00',3.34),('16100','2013-07-19','17:45:00',3.15),('16100','2013-07-19','17:50:00',3.01),('16100','2013-07-19','17:55:00',2.88),('16100','2013-07-19','18:00:00',2.7),('16100','2013-07-19','18:05:00',2.52),('16100','2013-07-19','18:10:00',2.37),('16100','2013-07-19','18:15:00',2.22),('16100','2013-07-19','18:20:00',2.06),('16100','2013-07-19','18:25:00',1.87),('16100','2013-07-19','18:30:00',1.67),('16100','2013-07-19','18:35:00',1.53),('16100','2013-07-19','18:40:00',1.37),('16100','2013-07-19','18:45:00',1.23),('16100','2013-07-19','18:50:00',1.08),('16100','2014-05-02','07:50:00',1.03),('16100','2014-05-02','07:55:00',1.19),('16100','2014-05-02','08:00:00',1.45),('16100','2014-05-02','08:05:00',1.7),('16100','2014-05-02','08:10:00',1.94),('16100','2014-05-02','08:15:00',1.07),('16100','2014-05-02','08:20:00',1.01),('16100','2014-05-02','08:25:00',1.55),('16100','2014-05-02','08:30:00',2.86),('16100','2014-05-02','08:35:00',3.19),('16100','2014-05-02','08:40:00',3.62),('16100','2014-05-02','08:45:00',3.88),('16100','2014-05-02','08:50:00',3.54),('16100','2014-05-02','08:55:00',1.66),('16100','2014-05-02','09:00:00',3.49),('16100','2014-05-02','09:05:00',4.4),('16100','2014-05-02','09:10:00',4.13),('16100','2014-05-02','09:15:00',2.33),('16100','2014-05-02','09:20:00',3.78),('16100','2014-05-02','09:25:00',3.01),('16100','2014-05-02','09:30:00',1.76),('16100','2014-05-02','09:35:00',2.39),('16100','2014-05-02','09:40:00',5.55),('16100','2014-05-02','09:45:00',4.2),('16100','2014-05-02','09:50:00',2.95),('16100','2014-05-02','09:55:00',5.83),('16100','2014-05-02','10:00:00',3.39),('16100','2014-05-02','10:05:00',4.73),('16100','2014-05-02','10:10:00',3.72),('16100','2014-05-02','10:15:00',3.38),('16100','2014-05-02','10:20:00',3.23),('16100','2014-05-02','10:25:00',2.09),('16100','2014-05-02','10:30:00',2.92),('16100','2014-05-02','10:35:00',2.58),('16100','2014-05-02','10:40:00',4.07),('16100','2014-05-02','10:45:00',2.62),('16100','2014-05-02','10:50:00',3.66),('16100','2014-05-02','10:55:00',3.87),('16100','2014-05-02','11:00:00',1.41),('16100','2014-05-02','11:05:00',1.6),('16100','2014-05-02','11:10:00',2.04),('16100','2014-05-02','11:15:00',3.65),('16100','2014-05-02','11:20:00',1.17),('16100','2014-05-02','11:35:00',1.09),('16100','2014-05-02','11:40:00',2.48),('16100','2014-05-02','11:45:00',6.81),('16100','2014-05-02','11:50:00',5.27),('16100','2014-05-02','11:55:00',4.73),('16100','2014-05-02','12:00:00',4.65),('16100','2014-05-02','12:05:00',4.65),('16100','2014-05-02','12:10:00',3.23),('16100','2014-05-02','12:15:00',2.32),('16100','2014-05-02','12:20:00',2.45),('16100','2014-05-02','12:25:00',2.39),('16100','2014-05-02','12:30:00',1.96),('16100','2014-05-02','12:35:00',1.98),('16100','2014-05-02','12:40:00',2.37),('16100','2014-05-02','12:45:00',2.84),('16100','2014-05-02','12:50:00',4.2),('16100','2014-05-02','12:55:00',4.14),('16100','2014-05-02','13:00:00',4.5),('16100','2014-05-02','13:05:00',4.55),('16100','2014-05-02','13:10:00',3.96),('16100','2014-05-02','13:15:00',7.16),('16100','2014-05-02','13:20:00',7.04),('16100','2014-05-02','13:25:00',4.06),('16100','2014-05-02','13:30:00',2.12),('16100','2014-05-02','13:35:00',3.84),('16100','2014-05-02','13:40:00',4),('16100','2014-05-02','13:45:00',3.38),('16100','2014-05-02','13:50:00',3.14),('16100','2014-05-02','13:55:00',3.51),('16100','2014-05-02','14:00:00',4.6),('16100','2014-05-02','14:05:00',5.37),('16100','2014-05-02','14:10:00',4.53),('16100','2014-05-02','14:15:00',4),('16100','2014-05-02','14:20:00',4.08),('16100','2014-05-02','14:25:00',4.1),('16100','2014-05-02','14:30:00',4.11),('16100','2014-05-02','14:35:00',4.42),('16100','2014-05-02','14:40:00',4.59),('16100','2014-05-02','14:45:00',2.03),('16100','2014-05-02','16:45:00',1.02),('16100','2014-05-02','16:50:00',1.1),('16100','2014-05-02','16:55:00',1.16),('16100','2014-05-02','17:00:00',1.22),('16100','2014-05-02','17:05:00',1.26),('16100','2014-05-02','17:10:00',1.3),('16100','2014-05-02','17:15:00',1.35),('16100','2014-05-02','17:20:00',1.41),('16100','2014-05-02','17:25:00',1.44),('16100','2014-05-02','17:30:00',1.55),('16100','2014-05-02','17:35:00',2.15),('16100','2014-05-02','17:40:00',1.87),('16100','2014-05-02','17:45:00',1.93),('16100','2014-05-02','17:50:00',1.85),('16100','2014-05-02','17:55:00',1.87),('16100','2014-05-02','18:00:00',1.78),('16100','2014-05-02','18:05:00',1.83),('16100','2014-05-02','18:10:00',1.41),('16100','2014-05-02','18:15:00',1.05),('16100','2014-05-02','18:20:00',1.05),('16100','2014-05-02','18:30:00',1.01),('16100','2014-05-02','18:35:00',1.04),('16100','2014-05-02','18:40:00',1.07),('16100','2014-04-05','08:15:00',1.19),('16100','2014-04-05','08:20:00',1.29),('16100','2014-04-05','08:25:00',1.61),('16100','2014-04-05','08:30:00',1.91),('16100','2014-04-05','08:35:00',2.09),('16100','2014-04-05','08:40:00',2.28),('16100','2014-04-05','08:45:00',2.48),('16100','2014-04-05','08:50:00',2.65),('16100','2014-04-05','08:55:00',2.84),('16100','2014-04-05','09:00:00',3.06),('16100','2014-04-05','09:05:00',3.24),('16100','2014-04-05','09:10:00',3.45),('16100','2014-04-05','09:15:00',3.63),('16100','2014-04-05','09:20:00',3.5),('16100','2014-04-05','09:25:00',1.91),('16100','2014-04-05','09:30:00',2.03),('16100','2014-04-05','09:35:00',3.1),('16100','2014-04-05','09:40:00',2.94),('16100','2014-04-05','09:45:00',2.63),('16100','2014-04-05','09:50:00',4.43),('16100','2014-04-05','09:55:00',5.24),('16100','2014-04-05','10:00:00',2.9),('16100','2014-04-05','10:05:00',2.57),('16100','2014-04-05','10:10:00',2.15),('16100','2014-04-05','10:15:00',2.65),('16100','2014-04-05','10:20:00',4.05),('16100','2014-04-05','10:25:00',6.65),('16100','2014-04-05','10:30:00',6.34),('16100','2014-04-05','10:35:00',7.44),('16100','2014-04-05','10:40:00',4.27),('16100','2014-04-05','10:45:00',2.33),('16100','2014-04-05','10:50:00',3.78),('16100','2014-04-05','10:55:00',6.06),('16100','2014-04-05','11:00:00',7.22),('16100','2014-04-05','11:05:00',7.37),('16100','2014-04-05','11:10:00',7.28),('16100','2014-04-05','11:15:00',7.32),('16100','2014-04-05','11:20:00',6.86),('16100','2014-04-05','11:25:00',7.46),('16100','2014-04-05','11:30:00',7.63),('16100','2014-04-05','11:35:00',7.28),('16100','2014-04-05','11:40:00',7.16),('16100','2014-04-05','11:45:00',7.08),('16100','2014-04-05','11:50:00',7.08),('16100','2014-04-05','11:55:00',7.11),('16100','2014-04-05','12:00:00',7.25),('16100','2014-04-05','12:05:00',7.5),('16100','2014-04-05','12:10:00',7.53),('16100','2014-04-05','12:15:00',7.52),('16100','2014-04-05','12:20:00',7.48),('16100','2014-04-05','12:25:00',6.96),('16100','2014-04-05','12:30:00',7.59),('16100','2014-04-05','12:35:00',7.6),('16100','2014-04-05','12:40:00',7.62),('16100','2014-04-05','12:45:00',7.63),('16100','2014-04-05','12:50:00',7.72),('16100','2014-04-05','12:55:00',7.6),('16100','2014-04-05','13:00:00',7.48),('16100','2014-04-05','13:05:00',8.16),('16100','2014-04-05','13:10:00',7.17),('16100','2014-04-05','13:15:00',6.49),('16100','2014-04-05','13:20:00',5.91),('16100','2014-04-05','13:25:00',1.96),('16100','2014-04-05','13:30:00',4.68),('16100','2014-04-05','13:35:00',7.96),('16100','2014-04-05','13:40:00',7.83),('16100','2014-04-05','13:45:00',7.17),('16100','2014-04-05','13:50:00',3.21),('16100','2014-04-05','13:55:00',4.31),('16100','2014-04-05','14:00:00',6.07),('16100','2014-04-05','14:05:00',4.8),('16100','2014-04-05','14:10:00',7.59),('16100','2014-04-05','14:15:00',2.45),('16100','2014-04-05','14:20:00',4.53),('16100','2014-04-05','14:25:00',7.76),('16100','2014-04-05','14:30:00',7.67),('16100','2014-04-05','14:35:00',3.5),('16100','2014-04-05','14:40:00',4.29),('16100','2014-04-05','14:45:00',7.73),('16100','2014-04-05','14:50:00',7.78),('16100','2014-04-05','14:55:00',3.46),('16100','2014-04-05','15:00:00',2.13),('16100','2014-04-05','15:05:00',1.1),('16100','2014-04-05','15:20:00',1.1),('16100','2014-04-05','15:25:00',1.2),('16100','2014-04-05','15:30:00',1.15),('16100','2014-04-05','15:40:00',1.03),('16100','2014-04-05','15:45:00',1.16),('16100','2014-04-05','15:50:00',1.44),('16100','2014-04-05','15:55:00',1.99),('16100','2014-04-05','16:00:00',4.9),('16100','2014-04-05','16:05:00',6.79),('16100','2014-04-05','16:10:00',3.97),('16100','2014-04-05','16:15:00',1.56),('16100','2014-04-05','16:20:00',1.33),('16100','2014-04-05','16:25:00',1.14),('16100','2014-04-05','16:30:00',1.12),('16100','2014-04-05','16:40:00',2.65),('16100','2014-04-05','16:45:00',3.36),('16100','2014-04-05','16:50:00',2.47),('16100','2014-04-05','16:55:00',1.98),('16100','2014-04-05','17:00:00',1.6),('16100','2014-04-05','17:05:00',1.12),('16100','2014-04-05','17:20:00',1.38),('16100','2014-04-05','17:25:00',3.48),('16100','2014-04-05','17:30:00',3.44),('16100','2014-04-05','17:35:00',3),('16100','2014-04-05','17:40:00',2.98),('16100','2014-04-05','17:45:00',2.81),('16100','2014-04-05','17:50:00',2.6),('16100','2014-04-05','17:55:00',2.28),('16100','2014-04-05','18:00:00',2.06),('16100','2014-04-05','18:05:00',1.86),('16100','2014-04-05','18:10:00',1.78),('16100','2014-04-05','18:15:00',1.69),('16100','2014-04-05','18:20:00',1.59),('16100','2014-04-05','18:25:00',1.35),('16100','2014-04-05','18:30:00',1.1),('16100','2013-07-09','07:35:00',1.1),('16100','2013-07-09','07:40:00',1.26),('16100','2013-07-09','07:45:00',1.44),('16100','2013-07-09','07:50:00',1.55),('16100','2013-07-09','07:55:00',1.72),('16100','2013-07-09','08:00:00',1.32),('16100','2013-07-09','08:05:00',1.36),('16100','2013-07-09','08:10:00',1.47),('16100','2013-07-09','08:15:00',1.67),('16100','2013-07-09','08:20:00',1.73),('16100','2013-07-09','08:25:00',1.59),('16100','2013-07-09','08:30:00',1.49),('16100','2013-07-09','08:35:00',1.5),('16100','2013-07-09','08:40:00',1.56),('16100','2013-07-09','08:45:00',1.99),('16100','2013-07-09','08:50:00',3.27),('16100','2013-07-09','08:55:00',3.28),('16100','2013-07-09','09:00:00',3.37),('16100','2013-07-09','09:05:00',3.57),('16100','2013-07-09','09:10:00',3.76),('16100','2013-07-09','09:15:00',4),('16100','2013-07-09','09:20:00',4.18),('16100','2013-07-09','09:25:00',4.31),('16100','2013-07-09','09:30:00',4.43),('16100','2013-07-09','09:35:00',4.52),('16100','2013-07-09','09:40:00',4.64),('16100','2013-07-09','09:45:00',4.72),('16100','2013-07-09','09:50:00',4.85),('16100','2013-07-09','09:55:00',4.99),('16100','2013-07-09','10:00:00',5.12),('16100','2013-07-09','10:05:00',5.23),('16100','2013-07-09','10:10:00',5.35),('16100','2013-07-09','10:15:00',5.47),('16100','2013-07-09','10:20:00',5.61),('16100','2013-07-09','10:25:00',5.68),('16100','2013-07-09','10:30:00',5.79),('16100','2013-07-09','10:35:00',5.87),('16100','2013-07-09','10:40:00',5.92),('16100','2013-07-09','10:45:00',6),('16100','2013-07-09','10:50:00',6.07),('16100','2013-07-09','10:55:00',6.17),('16100','2013-07-09','11:00:00',6.26),('16100','2013-07-09','11:05:00',6.43),('16100','2013-07-09','11:10:00',6.47),('16100','2013-07-09','11:15:00',6.54),('16100','2013-07-09','11:20:00',6.58),('16100','2013-07-09','11:25:00',6.65),('16100','2013-07-09','11:30:00',6.73),('16100','2013-07-09','11:35:00',6.84),('16100','2013-07-09','11:40:00',6.95),('16100','2013-07-09','11:45:00',6.99),('16100','2013-07-09','11:50:00',6.97),('16100','2013-07-09','11:55:00',7.07),('16100','2013-07-09','12:00:00',6.95),('16100','2013-07-09','12:05:00',6.71),('16100','2013-07-09','12:10:00',7.04),('16100','2013-07-09','12:15:00',6.88),('16100','2013-07-09','12:20:00',7.29),('16100','2013-07-09','12:25:00',7.42),('16100','2013-07-09','12:30:00',7.38),('16100','2013-07-09','12:35:00',7.48),('16100','2013-07-09','12:40:00',7.43),('16100','2013-07-09','12:45:00',7.51),('16100','2013-07-09','12:50:00',7.6),('16100','2013-07-09','12:55:00',7.55),('16100','2013-07-09','13:00:00',7.59),('16100','2013-07-09','13:05:00',7.51),('16100','2013-07-09','13:10:00',7.61),('16100','2013-07-09','13:15:00',7.64),('16100','2013-07-09','13:20:00',7.6),('16100','2013-07-09','13:25:00',7.6),('16100','2013-07-09','13:30:00',7.64),('16100','2013-07-09','13:35:00',7.67),('16100','2013-07-09','13:40:00',7.68),('16100','2013-07-09','13:45:00',7.64),('16100','2013-07-09','13:50:00',7.68),('16100','2013-07-09','13:55:00',7.67),('16100','2013-07-09','14:00:00',7.71),('16100','2013-07-09','14:05:00',7.66),('16100','2013-07-09','14:10:00',7.56),('16100','2013-07-09','14:15:00',7.5),('16100','2013-07-09','14:20:00',7.48),('16100','2013-07-09','14:25:00',7.43),('16100','2013-07-09','14:30:00',7.42),('16100','2013-07-09','14:35:00',7.4),('16100','2013-07-09','14:40:00',7.32),('16100','2013-07-09','14:45:00',7.25),('16100','2013-07-09','14:50:00',7.21),('16100','2013-07-09','14:55:00',7.17),('16100','2013-07-09','15:00:00',7.17),('16100','2013-07-09','15:05:00',7.1),('16100','2013-07-09','15:10:00',7),('16100','2013-07-09','15:15:00',6.91),('16100','2013-07-09','15:20:00',6.84),('16100','2013-07-09','15:25:00',6.77),('16100','2013-07-09','15:30:00',6.65),('16100','2013-07-09','15:35:00',6.55),('16100','2013-07-09','15:40:00',6.47),('16100','2013-07-09','15:45:00',5.66),('16100','2013-07-09','15:50:00',6.26),('16100','2013-07-09','15:55:00',6.14),('16100','2013-07-09','16:00:00',6.1),('16100','2013-07-09','16:05:00',5.96),('16100','2013-07-09','16:10:00',5.87),('16100','2013-07-09','16:15:00',5.72),('16100','2013-07-09','16:20:00',5.6),('16100','2013-07-09','16:25:00',5.5),('16100','2013-07-09','16:30:00',5.35),('16100','2013-07-09','16:35:00',5.25),('16100','2013-07-09','16:40:00',5.12),('16100','2013-07-09','16:45:00',5.02),('16100','2013-07-09','16:50:00',5),('16100','2013-07-09','17:00:00',4.82),('16100','2013-07-09','17:05:00',2.24),('16100','2013-07-09','17:10:00',2.09),('16100','2013-07-09','17:15:00',1.67),('16100','2013-07-09','17:20:00',1.5),('16100','2013-07-09','17:25:00',1.46),('16100','2013-07-09','17:30:00',2.73),('16100','2013-07-09','17:35:00',3.64),('16100','2013-07-09','17:40:00',3.94),('16100','2013-07-09','17:45:00',3.49),('16100','2013-07-09','17:50:00',2.66),('16100','2013-07-09','17:55:00',1.99),('16100','2013-07-09','18:00:00',1.29),('16100','2013-07-09','18:05:00',1.19),('16100','2013-07-09','19:05:00',1.05),('16100','2013-07-08','07:45:00',1.05),('16100','2013-07-08','07:50:00',1.1),('16100','2013-07-08','07:55:00',1.22),('16100','2013-07-08','08:00:00',1.37),('16100','2013-07-08','08:05:00',1.28),('16100','2013-07-08','08:10:00',1.65),('16100','2013-07-08','08:15:00',1.82),('16100','2013-07-08','08:20:00',1.98),('16100','2013-07-08','08:25:00',2.13),('16100','2013-07-08','08:30:00',2.27),('16100','2013-07-08','08:35:00',2.46),('16100','2013-07-08','08:40:00',2.58),('16100','2013-07-08','08:45:00',2.7),('16100','2013-07-08','08:50:00',2.92),('16100','2013-07-08','08:55:00',3.08),('16100','2013-07-08','09:00:00',3.25),('16100','2013-07-08','09:05:00',3.35),('16100','2013-07-08','09:10:00',3.6),('16100','2013-07-08','09:15:00',3.91),('16100','2013-07-08','09:20:00',4.06),('16100','2013-07-08','09:25:00',4.2),('16100','2013-07-08','09:30:00',4.35),('16100','2013-07-08','09:35:00',4.4),('16100','2013-07-08','09:40:00',4.5),('16100','2013-07-08','09:45:00',4.67),('16100','2013-07-08','09:50:00',4.81),('16100','2013-07-08','09:55:00',4.89),('16100','2013-07-08','10:00:00',5.02),('16100','2013-07-08','10:05:00',5.2),('16100','2013-07-08','10:10:00',5.33),('16100','2013-07-08','10:15:00',5.46),('16100','2013-07-08','10:20:00',5.57),('16100','2013-07-08','10:25:00',5.64),('16100','2013-07-08','10:30:00',5.72),('16100','2013-07-08','10:35:00',5.84),('16100','2013-07-08','10:40:00',5.95),('16100','2013-07-08','10:45:00',6.04),('16100','2013-07-08','10:50:00',6.12),('16100','2013-07-08','10:55:00',6.2),('16100','2013-07-08','11:00:00',6.33),('16100','2013-07-08','11:05:00',6.34),('16100','2013-07-08','11:10:00',6.48),('16100','2013-07-08','11:15:00',6.53),('16100','2013-07-08','11:20:00',6.63),('16100','2013-07-08','11:25:00',6.73),('16100','2013-07-08','11:30:00',6.87),('16100','2013-07-08','11:35:00',6.74),('16100','2013-07-08','11:40:00',6.85),('16100','2013-07-08','11:45:00',7.2),('16100','2013-07-08','11:50:00',7),('16100','2013-07-08','11:55:00',7.34),('16100','2013-07-08','12:00:00',7.35),('16100','2013-07-08','12:05:00',7.31),('16100','2013-07-08','12:10:00',6.94),('16100','2013-07-08','12:15:00',6.53),('16100','2013-07-08','12:20:00',5.33),('16100','2013-07-08','12:25:00',7.22),('16100','2013-07-08','12:30:00',7.15),('16100','2013-07-08','12:35:00',7.21),('16100','2013-07-08','12:40:00',7.34),('16100','2013-07-08','12:45:00',7.52),('16100','2013-07-08','12:50:00',7.67),('16100','2013-07-08','12:55:00',7.62),('16100','2013-07-08','13:00:00',7.61),('16100','2013-07-08','13:05:00',7.72),('16100','2013-07-08','13:10:00',7.93),('16100','2013-07-08','13:15:00',7.65),('16100','2013-07-08','13:20:00',7.73),('16100','2013-07-08','13:25:00',7.76),('16100','2013-07-08','13:30:00',7.92),('16100','2013-07-08','13:35:00',7.66),('16100','2013-07-08','13:40:00',7.59),('16100','2013-07-08','13:45:00',6.27),('16100','2013-07-08','13:50:00',7.48),('16100','2013-07-08','13:55:00',7.54),('16100','2013-07-08','14:00:00',5.82),('16100','2013-07-08','14:05:00',6.26),('16100','2013-07-08','14:10:00',7.2),('16100','2013-07-08','14:15:00',7.54),('16100','2013-07-08','14:20:00',7.94),('16100','2013-07-08','14:25:00',4.9),('16100','2013-07-08','14:30:00',1.84),('16100','2013-07-08','14:35:00',1.45),('16100','2013-07-08','14:40:00',1.28),('16100','2013-07-07','07:40:00',1.05),('16100','2013-07-07','07:45:00',1.13),('16100','2013-07-07','07:50:00',1.08),('16100','2013-07-07','07:55:00',1.18),('16100','2013-07-07','08:00:00',1.38),('16100','2013-07-07','08:05:00',1.46),('16100','2013-07-07','08:10:00',1.68),('16100','2013-07-07','08:15:00',1.88),('16100','2013-07-07','08:20:00',2.04),('16100','2013-07-07','08:25:00',2.11),('16100','2013-07-07','08:30:00',2.26),('16100','2013-07-07','08:35:00',2.44),('16100','2013-07-07','08:40:00',2.58),('16100','2013-07-07','08:45:00',2.72),('16100','2013-07-07','08:50:00',2.88),('16100','2013-07-07','08:55:00',2.95),('16100','2013-07-07','09:00:00',3.16),('16100','2013-07-07','09:05:00',3.34),('16100','2013-07-07','09:10:00',3.54),('16100','2013-07-07','09:15:00',3.85),('16100','2013-07-07','09:20:00',4.01),('16100','2013-07-07','09:25:00',4.15),('16100','2013-07-07','09:30:00',4.28),('16100','2013-07-07','09:35:00',4.4),('16100','2013-07-07','09:40:00',4.53),('16100','2013-07-07','09:45:00',4.65),('16100','2013-07-07','10:20:00',5.52),('16100','2013-07-07','10:25:00',5.3),('16100','2013-07-07','10:30:00',5.46),('16100','2013-07-07','10:35:00',5.01),('16100','2013-07-07','10:40:00',5.83),('16100','2013-07-07','10:45:00',6),('16100','2013-07-07','10:50:00',6.03),('16100','2013-07-07','10:55:00',6.08),('16100','2013-07-07','11:00:00',6.22),('16100','2013-07-07','11:05:00',6.41),('16100','2013-07-07','11:10:00',6.52),('16100','2013-07-07','11:15:00',6.64),('16100','2013-07-07','11:20:00',6.41),('16100','2013-07-07','11:25:00',6.47),('16100','2013-07-07','11:30:00',6.64),('16100','2013-07-07','11:35:00',6.42),('16100','2013-07-07','11:40:00',6.37),('16100','2013-07-07','11:45:00',7.11),('16100','2013-07-07','11:50:00',7.11),('16100','2013-07-07','11:55:00',6.8),('16100','2013-07-07','12:00:00',7.15),('16100','2013-07-07','12:05:00',7.19),('16100','2013-07-07','12:10:00',6.25),('16100','2013-07-07','12:15:00',7.17),('16100','2013-07-07','12:20:00',6.74),('16100','2013-07-07','12:25:00',7.56),('16100','2013-07-07','12:30:00',7.52),('16100','2013-07-07','12:35:00',7.49),('16100','2013-07-07','12:40:00',7.47),('16100','2013-07-07','12:45:00',7.27),('16100','2013-07-07','12:50:00',7.5),('16100','2013-07-07','12:55:00',7.56),('16100','2013-07-07','13:00:00',4.81),('16100','2013-07-07','13:05:00',8.1),('16100','2013-07-07','13:10:00',3.01),('16100','2013-07-07','13:15:00',4.26),('16100','2013-07-07','13:20:00',4.09),('16100','2013-07-07','13:25:00',1.24),('16100','2013-07-07','14:01:00',1.1),('16100','2013-07-07','14:05:00',1.52),('16100','2013-07-07','14:10:00',1.75),('16100','2013-07-07','14:15:00',1.8),('16100','2013-07-07','14:20:00',1.76),('16100','2013-07-07','14:25:00',1.79),('16100','2013-07-07','14:30:00',1.89),('16100','2013-07-07','14:35:00',2.5),('16100','2013-07-07','14:40:00',3.59),('16100','2013-07-07','14:45:00',3.03),('16100','2013-07-07','14:50:00',2.67),('16100','2013-07-07','14:55:00',2.2),('16100','2013-07-07','15:00:00',2),('16100','2013-07-07','15:05:00',2.01),('16100','2013-07-07','15:10:00',1.9),('16100','2013-07-07','15:15:00',1.65),('16100','2013-07-07','15:20:00',1.25),('16100','2013-07-07','17:35:00',1.14),('16100','2013-07-07','17:40:00',1.31),('16100','2013-07-07','17:45:00',1.42),('16100','2013-07-07','17:50:00',1.49),('16100','2013-07-07','17:55:00',1.45),('16100','2013-07-07','18:00:00',1.33),('16100','2013-07-07','18:05:00',1.24),('16100','2013-07-07','18:10:00',1.18),('16100','2013-07-07','18:15:00',1.18),('16100','2013-07-07','18:20:00',1.26),('16100','2013-07-07','18:25:00',1.56),('16100','2013-07-07','18:30:00',1.83),('16100','2013-07-07','18:35:00',1.93),('16100','2013-07-07','18:40:00',1.74),('16100','2013-07-07','18:45:00',1.39),('16100','2013-07-07','18:50:00',1.23),('16100','2013-07-07','18:55:00',1.04),('16100','2013-07-06','07:55:00',1.14),('16100','2013-07-06','08:00:00',1.36),('16100','2013-07-06','08:05:00',1.56),('16100','2013-07-06','08:10:00',1.74),('16100','2013-07-06','08:15:00',1.95),('16100','2013-07-06','08:20:00',2.12),('16100','2013-07-06','08:25:00',2.3),('16100','2013-07-06','08:30:00',2.25),('16100','2013-07-06','08:35:00',1.17),('16100','2013-07-06','08:40:00',2.01),('16100','2013-07-06','08:45:00',2.66),('16100','2013-07-06','08:50:00',3.22),('16100','2013-07-06','08:55:00',3.42),('16100','2013-07-06','09:00:00',3.6),('16100','2013-07-06','09:05:00',3.51),('16100','2013-07-06','09:10:00',2.36),('16100','2013-07-06','09:15:00',1.98),('16100','2013-07-06','09:20:00',2.19),('16100','2013-07-06','09:25:00',2.76),('16100','2013-07-06','09:30:00',4.06),('16100','2013-07-06','09:36:00',4.76),('16100','2013-07-06','09:40:00',4.25),('16100','2013-07-06','09:45:00',5.24),('16100','2013-07-06','09:50:00',5.4),('16100','2013-07-06','09:55:00',5.43),('16100','2013-07-06','10:00:00',5.39),('16100','2013-07-06','10:05:00',5.31),('16100','2013-07-06','10:10:00',5.06),('16100','2013-07-06','10:15:00',4.83),('16100','2013-07-06','10:20:00',6.09),('16100','2013-07-06','10:25:00',6.13),('16100','2013-07-06','10:30:00',5.75),('16100','2013-07-06','10:35:00',5.42),('16100','2013-07-06','10:40:00',6.08),('16100','2013-07-06','10:45:00',6.41),('16100','2013-07-06','10:50:00',6.41),('16100','2013-07-06','10:55:00',6.43),('16100','2013-07-06','11:00:00',6.48),('16100','2013-07-06','11:05:00',6.56),('16100','2013-07-06','11:10:00',6.72),('16100','2013-07-06','11:15:00',6.71),('16100','2013-07-06','11:20:00',6),('16100','2013-07-06','11:25:00',6.63),('16100','2013-07-06','11:30:00',6.33),('16100','2013-07-06','11:35:00',6.31),('16100','2013-07-06','11:40:00',6.39),('16100','2013-07-06','11:45:00',6.78),('16100','2013-07-06','11:50:00',6.93),('16100','2013-07-06','11:55:00',6.56),('16100','2013-07-06','12:00:00',4.29),('16100','2013-07-06','12:05:00',5.24),('16100','2013-07-06','12:10:00',5.55),('16100','2013-07-06','12:15:00',4.69),('16100','2013-07-06','12:20:00',6.05),('16100','2013-07-06','12:25:00',7.23),('16100','2013-07-06','12:30:00',7.3),('16100','2013-07-06','12:35:00',7.39),('16100','2013-07-06','12:40:00',7.25),('16100','2013-07-06','12:45:00',7.49),('16100','2013-07-06','12:50:00',7.72),('16100','2013-07-06','12:55:00',7.78),('16100','2013-07-06','13:00:00',7.44),('16100','2013-07-06','13:05:00',7.49),('16100','2013-07-06','13:10:00',7.53),('16100','2013-07-06','13:15:00',7.67),('16100','2013-07-06','13:20:00',7.64),('16100','2013-07-06','13:25:00',7.62),('16100','2013-07-06','13:30:00',7.75),('16100','2013-07-06','13:35:00',7.53),('16100','2013-07-06','13:40:00',5.52),('16100','2013-07-06','13:45:00',7.53),('16100','2013-07-06','13:50:00',7.61),('16100','2013-07-06','13:55:00',3.56),('16100','2013-07-06','14:00:00',1.29),('16100','2013-07-06','14:05:00',1.26),('16100','2013-07-06','14:10:00',1.66),('16100','2013-07-06','14:15:00',2.16),('16100','2013-07-06','14:20:00',3.58),('16100','2013-07-06','14:25:00',4.18),('16100','2013-07-06','14:30:00',3.19),('16100','2013-07-06','14:35:00',2.51),('16100','2013-07-06','14:40:00',1.96),('16100','2013-07-06','14:45:00',1.71),('16100','2013-07-06','14:50:00',1.6),('16100','2013-07-06','14:55:00',1.65),('16100','2013-07-06','15:00:00',1.91),('16100','2013-07-06','15:05:00',2.32),('16100','2013-07-06','15:10:00',1.92),('16100','2013-07-06','15:15:00',1.08),('16100','2013-07-06','16:55:00',1.15),('16100','2013-07-06','17:00:00',1.32),('16100','2013-07-06','17:05:00',1.54),('16100','2013-07-06','17:10:00',1.67),('16100','2013-07-06','17:15:00',1.8),('16100','2013-07-06','17:20:00',1.86),('16100','2013-07-06','17:25:00',1.94),('16100','2013-07-06','17:30:00',2.05),('16100','2013-07-06','17:35:00',2.03),('16100','2013-07-06','17:40:00',2.03),('16100','2013-07-06','17:45:00',1.83),('16100','2013-07-06','17:50:00',1.74),('16100','2013-07-06','17:55:00',1.69),('16100','2013-07-06','18:00:00',1.56),('16100','2013-07-06','18:05:00',1.46),('16100','2013-07-06','18:10:00',1.36),('16100','2013-07-06','18:15:00',1.36),('16100','2013-07-06','18:20:00',1.35),('16100','2013-07-06','18:25:00',1.24),('16100','2013-07-06','18:30:00',1.14),('16100','2013-07-05','07:55:00',1.14),('16100','2013-07-05','08:00:00',1.32),('16100','2013-07-05','08:05:00',1.51),('16100','2013-07-05','08:10:00',1.66),('16100','2013-07-05','08:15:00',1.86),('16100','2013-07-05','08:20:00',2.01),('16100','2013-07-05','08:25:00',2.17),('16100','2013-07-05','08:30:00',2.31),('16100','2013-07-05','08:35:00',2.47),('16100','2013-07-05','08:40:00',2.63),('16100','2013-07-05','08:45:00',2.77),('16100','2013-07-05','08:50:00',2.98),('16100','2013-07-05','08:55:00',3.11),('16100','2013-07-05','09:00:00',3.26),('16100','2013-07-05','09:05:00',3.39),('16100','2013-07-05','09:10:00',3.6),('16100','2013-07-05','09:15:00',3.9),('16100','2013-07-05','09:20:00',4.1),('16100','2013-07-05','09:25:00',4.28),('16100','2013-07-05','09:30:00',4.39),('16100','2013-07-05','09:35:00',4.52),('16100','2013-07-05','09:40:00',4.68),('16100','2013-07-05','09:45:00',4.8),('16100','2013-07-05','09:50:00',4.9),('16100','2013-07-05','09:55:00',4.99),('16100','2013-07-05','10:00:00',5.12),('16100','2013-07-05','10:05:00',5.29),('16100','2013-07-05','10:10:00',5.41),('16100','2013-07-05','10:15:00',5.54),('16100','2013-07-05','10:20:00',5.67),('16100','2013-07-05','10:25:00',5.74),('16100','2013-07-05','10:30:00',5.87),('16100','2013-07-05','10:35:00',5.96),('16100','2013-07-05','10:40:00',6.02),('16100','2013-07-05','10:45:00',6.11),('16100','2013-07-05','10:50:00',6.17),('16100','2013-07-05','10:55:00',6.23),('16100','2013-07-05','11:00:00',6.36),('16100','2013-07-05','11:05:00',6.48),('16100','2013-07-05','11:10:00',6.5),('16100','2013-07-05','11:15:00',6.56),('16100','2013-07-05','11:20:00',6.62),('16100','2013-07-05','11:25:00',6.77),('16100','2013-07-05','11:30:00',6.8),('16100','2013-07-05','11:35:00',6.89),('16100','2013-07-05','11:40:00',6.96),('16100','2013-07-05','11:45:00',6.97),('16100','2013-07-05','11:50:00',7.02),('16100','2013-07-05','11:55:00',7.08),('16100','2013-07-05','12:00:00',7.07),('16100','2013-07-05','12:05:00',7.18),('16100','2013-07-05','12:10:00',7.27),('16100','2013-07-05','12:15:00',7.33),('16100','2013-07-05','12:20:00',7.3),('16100','2013-07-05','12:25:00',7.42),('16100','2013-07-05','12:30:00',7.49),('16100','2013-07-05','12:35:00',7.54),('16100','2013-07-05','12:40:00',7.5),('16100','2013-07-05','12:45:00',7.44),('16100','2013-07-05','12:50:00',7.44),('16100','2013-07-05','12:55:00',7.43),('16100','2013-07-05','13:00:00',7.47),('16100','2013-07-05','13:05:00',7.48),('16100','2013-07-05','13:10:00',7.44),('16100','2013-07-05','13:15:00',7.42),('16100','2013-07-05','13:20:00',7.51),('16100','2013-07-05','13:25:00',7.55),('16100','2013-07-05','13:30:00',7.66),('16100','2013-07-05','13:35:00',7.72),('16100','2013-07-05','13:40:00',7.62),('16100','2013-07-05','13:45:00',7.49),('16100','2013-07-05','13:50:00',7.53),('16100','2013-07-05','13:55:00',7.44),('16100','2013-07-05','14:00:00',7.52),('16100','2013-07-05','14:05:00',7.5),('16100','2013-07-05','14:10:00',7.34),('16100','2013-07-05','14:15:00',7.27),('16100','2013-07-05','14:20:00',7.32),('16100','2013-07-05','14:25:00',7.19),('16100','2013-07-05','14:30:00',7.1),('16100','2013-07-05','14:35:00',7.1),('16100','2013-07-05','14:40:00',6.05),('16100','2013-07-05','14:45:00',7.1),('16100','2013-07-05','14:50:00',4.14),('16100','2013-07-05','14:55:00',7.61),('16100','2013-07-05','15:00:00',7.43),('16100','2013-07-05','15:05:00',6.73),('16100','2013-07-05','15:10:00',6.75),('16100','2013-07-05','15:15:00',6.81),('16100','2013-07-05','15:20:00',6.95),('16100','2013-07-05','15:25:00',3.58),('16100','2013-07-05','15:30:00',1.39),('16100','2013-07-05','16:10:00',1.11),('16100','2013-07-05','16:15:00',1.61),('16100','2013-07-05','16:20:00',1.45),('16100','2013-07-05','16:25:00',1.18),('16100','2013-07-05','16:30:00',1.26),('16100','2013-07-05','16:35:00',1.8),('16100','2013-07-05','16:40:00',1.44),('16100','2013-07-05','16:45:00',1.77),('16100','2013-07-05','16:50:00',3.58),('16100','2013-07-05','16:55:00',5.11),('16100','2013-07-05','17:00:00',3.48),('16100','2013-07-05','17:05:00',4.01),('16100','2013-07-05','17:10:00',2.25),('16100','2013-07-05','17:15:00',2.02),('16100','2013-07-05','17:20:00',1.9),('16100','2013-07-05','17:25:00',1.7),('16100','2013-07-05','17:30:00',1.59),('16100','2013-07-05','17:35:00',1.47),('16100','2013-07-05','17:40:00',1.38),('16100','2013-07-05','17:45:00',1.37),('16100','2013-07-05','17:50:00',1.21),('16100','2013-07-05','17:55:00',1.05),('16100','2013-07-04','07:55:00',1.17),('16100','2013-07-04','08:00:00',1.33),('16100','2013-07-04','08:05:00',1.52),('16100','2013-07-04','08:10:00',1.71),('16100','2013-07-04','08:15:00',1.91),('16100','2013-07-04','08:20:00',2.08),('16100','2013-07-04','08:25:00',2.2),('16100','2013-07-04','08:30:00',2.36),('16100','2013-07-04','08:35:00',2.52),('16100','2013-07-04','08:40:00',2.65),('16100','2013-07-04','08:45:00',2.82),('16100','2013-07-04','08:50:00',3.02),('16100','2013-07-04','08:55:00',3.17),('16100','2013-07-04','09:00:00',3.33),('16100','2013-07-04','09:05:00',3.44),('16100','2013-07-04','09:10:00',3.61),('16100','2013-07-04','09:15:00',3.87),('16100','2013-07-04','09:20:00',4.1),('16100','2013-07-04','09:25:00',4.26),('16100','2013-07-04','09:30:00',4.35),('16100','2013-07-04','09:35:00',4.48),('16100','2013-07-04','09:40:00',4.61),('16100','2013-07-04','09:45:00',4.72),('16100','2013-07-04','09:50:00',4.83),('16100','2013-07-04','09:55:00',4.91),('16100','2013-07-04','10:00:00',5.05),('16100','2013-07-04','10:05:00',5.19),('16100','2013-07-04','10:10:00',5.29),('16100','2013-07-04','10:15:00',5.4),('16100','2013-07-04','10:20:00',5.48),('16100','2013-07-04','10:25:00',5.64),('16100','2013-07-04','10:30:00',5.78),('16100','2013-07-04','10:35:00',5.87),('16100','2013-07-04','10:40:00',5.97),('16100','2013-07-04','10:45:00',6.09),('16100','2013-07-04','10:50:00',6.16),('16100','2013-07-04','10:55:00',6.25),('16100','2013-07-04','11:00:00',6.38),('16100','2013-07-04','11:05:00',6.46),('16100','2013-07-04','11:10:00',6.55),('16100','2013-07-04','11:15:00',6.61),('16100','2013-07-04','11:20:00',6.68),('16100','2013-07-04','11:25:00',6.74),('16100','2013-07-04','11:30:00',6.79),('16100','2013-07-04','11:35:00',6.85),('16100','2013-07-04','11:40:00',6.92),('16100','2013-07-04','11:45:00',6.95),('16100','2013-07-04','11:50:00',7.01),('16100','2013-07-04','11:55:00',6.84),('16100','2013-07-04','12:00:00',5.29),('16100','2013-07-04','12:05:00',6.32),('16100','2013-07-04','12:10:00',4.32),('16100','2013-07-04','12:15:00',7.49),('16100','2013-07-04','12:20:00',7.51),('16100','2013-07-04','12:25:00',5.84),('16100','2013-07-04','12:30:00',2.55),('16100','2013-07-04','12:35:00',3.23),('16100','2013-07-04','12:40:00',3.26),('16100','2013-07-04','12:45:00',6.47),('16100','2013-07-04','12:50:00',3.8),('16100','2013-07-04','12:55:00',1.31),('16100','2013-07-04','13:00:00',4.2),('16100','2013-07-04','13:05:00',5.07),('16100','2013-07-04','13:10:00',7.12),('16100','2013-07-04','13:15:00',8),('16100','2013-07-04','13:20:00',7.88),('16100','2013-07-04','13:25:00',7.93),('16100','2013-07-04','13:30:00',8),('16100','2013-07-04','13:35:00',7.91),('16100','2013-07-04','13:40:00',7.8),('16100','2013-07-04','13:45:00',7.75),('16100','2013-07-04','13:50:00',7.69),('16100','2013-07-04','13:55:00',7.66),('16100','2013-07-04','14:00:00',7.74),('16100','2013-07-04','14:05:00',7.69),('16100','2013-07-04','14:10:00',7.78),('16100','2013-07-04','14:15:00',7.54),('16100','2013-07-04','14:20:00',7.03),('16100','2013-07-04','14:25:00',7.49),('16100','2013-07-04','14:30:00',7.22),('16100','2013-07-04','14:35:00',7.34),('16100','2013-07-04','14:40:00',7.27),('16100','2013-07-04','14:45:00',7.19),('16100','2013-07-04','14:50:00',7.15),('16100','2013-07-04','14:55:00',7.06),('16100','2013-07-04','15:00:00',6.78),('16100','2013-07-04','15:05:00',4.9),('16100','2013-07-04','15:10:00',2.96),('16100','2013-07-04','15:15:00',6.37),('16100','2013-07-04','15:20:00',6.9),('16100','2013-07-04','15:25:00',6.83),('16100','2013-07-04','15:30:00',4.71),('16100','2013-07-04','15:35:00',6.63),('16100','2013-07-04','15:40:00',6.5),('16100','2013-07-04','15:45:00',6.38),('16100','2013-07-04','15:50:00',6.24),('16100','2013-07-04','15:55:00',6.11),('16100','2013-07-04','16:00:00',6.03),('16100','2013-07-04','16:05:00',5.87),('16100','2013-07-04','16:10:00',5.86),('16100','2013-07-04','16:15:00',5.72),('16100','2013-07-04','16:20:00',5.63),('16100','2013-07-04','16:25:00',5.45),('16100','2013-07-04','16:30:00',5.26),('16100','2013-07-04','16:35:00',5.09),('16100','2013-07-04','16:40:00',5.04),('16100','2013-07-04','16:45:00',4.95),('16100','2013-07-04','16:50:00',4.81),('16100','2013-07-04','16:55:00',4.63),('16100','2013-07-04','17:00:00',4.54),('16100','2013-07-04','17:05:00',4.34),('16100','2013-07-04','17:10:00',4.42),('16100','2013-07-04','17:15:00',3.91),('16100','2013-07-04','17:20:00',1.61),('16100','2013-07-04','17:25:00',3.89),('16100','2013-07-04','17:30:00',3.72),('16100','2013-07-04','17:35:00',3.6),('16100','2013-07-04','17:40:00',3.38),('16100','2013-07-04','17:45:00',3.24),('16100','2013-07-04','17:50:00',3.1),('16100','2013-07-04','17:55:00',3),('16100','2013-07-04','18:00:00',2.99),('16100','2013-07-04','18:05:00',3.04),('16100','2013-07-04','18:10:00',2.99),('16100','2013-07-04','18:15:00',2.76),('16100','2013-07-04','18:20:00',2.38),('16100','2013-07-04','18:25:00',2.1),('16100','2013-07-04','18:30:00',1.92),('16100','2013-07-04','18:35:00',1.71),('16100','2013-07-04','18:40:00',1.52),('16100','2013-07-04','18:45:00',1.35),('16100','2013-07-04','18:50:00',1.22),('16100','2013-07-04','18:55:00',1.07),('16100','2013-07-03','08:50:00',1.12),('16100','2013-07-03','08:55:00',1.09),('16100','2013-07-03','09:10:00',1.09),('16100','2013-07-03','09:15:00',1.1),('16100','2013-07-03','09:20:00',1.1),('16100','2013-07-03','09:25:00',1.03),('16100','2013-07-03','10:30:00',1.07),('16100','2013-07-03','10:35:00',1.03),('16100','2013-07-03','10:50:00',1.03),('16100','2013-07-03','10:55:00',1.24),('16100','2013-07-03','11:00:00',1.36),('16100','2013-07-03','11:05:00',1.66),('16100','2013-07-03','11:10:00',1.68),('16100','2013-07-03','11:15:00',1.59),('16100','2013-07-03','11:20:00',1.66),('16100','2013-07-03','11:25:00',1.71),('16100','2013-07-03','11:30:00',1.9),('16100','2013-07-03','11:35:00',2.11),('16100','2013-07-03','11:40:00',2.45),('16100','2013-07-03','11:45:00',2.78),('16100','2013-07-03','11:50:00',2.67),('16100','2013-07-03','11:55:00',2.44),('16100','2013-07-03','12:00:00',2.31),('16100','2013-07-03','12:05:00',2.19),('16100','2013-07-03','12:10:00',1.87),('16100','2013-07-03','12:15:00',1.75),('16100','2013-07-03','12:20:00',1.53),('16100','2013-07-03','12:25:00',1.52),('16100','2013-07-03','12:30:00',1.12),('16100','2013-07-03','13:00:00',1.31),('16100','2013-07-03','13:05:00',1.38),('16100','2013-07-03','13:10:00',1.26),('16100','2013-07-03','13:15:00',1.46),('16100','2013-07-03','13:20:00',1.44),('16100','2013-07-03','13:25:00',1.83),('16100','2013-07-03','13:30:00',2.63),('16100','2013-07-03','13:35:00',2.98),('16100','2013-07-03','13:45:00',3.23),('16100','2013-07-03','13:50:00',3.33),('16100','2013-07-03','13:55:00',3.44),('16100','2013-07-03','14:00:00',4.24),('16100','2013-07-03','14:05:00',4.7),('16100','2013-07-03','14:10:00',3.45),('16100','2013-07-03','14:15:00',3.57),('16100','2013-07-03','14:20:00',3.58),('16100','2013-07-03','14:25:00',3.09),('16100','2013-07-03','14:30:00',3),('16100','2013-07-03','14:35:00',3.19),('16100','2013-07-03','14:40:00',3.83),('16100','2013-07-03','14:45:00',2.89),('16100','2013-07-03','14:50:00',3.09),('16100','2013-07-03','14:55:00',3.74),('16100','2013-07-03','15:00:00',6.16),('16100','2013-07-03','15:05:00',6.59),('16100','2013-07-03','15:10:00',4.46),('16100','2013-07-03','15:15:00',6.96),('16100','2013-07-03','15:20:00',5.85),('16100','2013-07-03','15:25:00',3.7),('16100','2013-07-03','15:30:00',4.51),('16100','2013-07-03','15:35:00',4.85),('16100','2013-07-03','15:40:00',4.78),('16100','2013-07-03','15:45:00',3.93),('16100','2013-07-03','15:50:00',6.47),('16100','2013-07-03','15:55:00',6.01),('16100','2013-07-03','16:00:00',4.98),('16100','2013-07-03','16:05:00',3.25),('16100','2013-07-03','16:10:00',3.78),('16100','2013-07-03','16:15:00',3.83),('16100','2013-07-03','16:20:00',4.1),('16100','2013-07-03','16:25:00',3.68),('16100','2013-07-03','16:30:00',3.32),('16100','2013-07-03','16:35:00',2.69),('16100','2013-07-03','16:40:00',2.32),('16100','2013-07-03','16:45:00',2.36),('16100','2013-07-03','16:50:00',2.2),('16100','2013-07-03','16:55:00',2.52),('16100','2013-07-03','17:00:00',3.12),('16100','2013-07-03','17:05:00',3.34),('16100','2013-07-03','17:10:00',2.84),('16100','2013-07-03','17:15:00',4.19),('16100','2013-07-03','17:20:00',4.84),('16100','2013-07-03','17:25:00',4.15),('16100','2013-07-03','17:30:00',3.45),('16100','2013-07-03','17:35:00',4.22),('16100','2013-07-03','17:40:00',3.69),('16100','2013-07-03','17:45:00',3.5),('16100','2013-07-03','17:50:00',3.41),('16100','2013-07-03','17:55:00',3.34),('16100','2013-07-03','18:00:00',2.97),('16100','2013-07-03','18:05:00',2.8),('16100','2013-07-03','18:10:00',2.69),('16100','2013-07-03','18:15:00',2.07),('16100','2013-07-03','18:20:00',1.93),('16100','2013-07-03','18:25:00',1.45),('16100','2013-07-03','18:30:00',1.08),('16100','2013-07-03','18:35:00',1.13),('16100','2013-07-03','18:40:00',1.2),('16100','2013-07-03','18:45:00',1.22),('16100','2013-07-02','07:55:00',1.2),('16100','2013-07-02','08:00:00',1.41),('16100','2013-07-02','08:05:00',1.61),('16100','2013-07-02','08:10:00',1.78),('16100','2013-07-02','08:15:00',2),('16100','2013-07-02','08:20:00',2.17),('16100','2013-07-02','08:25:00',2.31),('16100','2013-07-02','08:30:00',2.49),('16100','2013-07-02','08:35:00',2.62),('16100','2013-07-02','08:40:00',2.77),('16100','2013-07-02','08:45:00',2.96),('16100','2013-07-02','08:50:00',3.17),('16100','2013-07-02','08:55:00',3.35),('16100','2013-07-02','09:00:00',3.47),('16100','2013-07-02','09:05:00',3.55),('16100','2013-07-02','09:10:00',3.73),('16100','2013-07-02','09:15:00',4.06),('16100','2013-07-02','09:20:00',4.3),('16100','2013-07-02','09:25:00',4.46),('16100','2013-07-02','09:30:00',4.55),('16100','2013-07-02','09:35:00',4.69),('16100','2013-07-02','09:40:00',4.81),('16100','2013-07-02','09:45:00',4.95),('16100','2013-07-02','09:50:00',5.08),('16100','2013-07-02','09:55:00',5.17),('16100','2013-07-02','10:00:00',5.27),('16100','2013-07-02','10:05:00',5.39),('16100','2013-07-02','10:10:00',5.53),('16100','2013-07-02','10:15:00',5.64),('16100','2013-07-02','10:20:00',5.74),('16100','2013-07-02','10:25:00',5.79),('16100','2013-07-02','10:30:00',5.91),('16100','2013-07-02','10:35:00',6.08),('16100','2013-07-02','10:40:00',6.22),('16100','2013-07-02','10:45:00',6.34),('16100','2013-07-02','10:50:00',6.38),('16100','2013-07-02','10:55:00',6.42),('16100','2013-07-02','11:00:00',6.5),('16100','2013-07-02','11:05:00',6.63),('16100','2013-07-02','11:10:00',6.79),('16100','2013-07-02','11:15:00',6.87),('16100','2013-07-02','11:20:00',6.94),('16100','2013-07-02','11:25:00',7.02),('16100','2013-07-02','11:30:00',7.1),('16100','2013-07-02','11:35:00',7.19),('16100','2013-07-02','11:40:00',7.28),('16100','2013-07-02','11:45:00',7.34),('16100','2013-07-02','11:50:00',7.37),('16100','2013-07-02','11:55:00',7.46),('16100','2013-07-02','12:00:00',7.52),('16100','2013-07-02','12:05:00',7.58),('16100','2013-07-02','12:10:00',7.6),('16100','2013-07-02','12:15:00',7.62),('16100','2013-07-02','12:20:00',7.65),('16100','2013-07-02','12:25:00',7.67),('16100','2013-07-02','12:30:00',7.67),('16100','2013-07-02','12:35:00',7.68),('16100','2013-07-02','12:40:00',7.71),('16100','2013-07-02','12:45:00',7.74),('16100','2013-07-02','12:50:00',7.74),('16100','2013-07-02','12:55:00',7.8),('16100','2013-07-02','13:00:00',7.83),('16100','2013-07-02','13:05:00',7.86),('16100','2013-07-02','13:10:00',7.86),('16100','2013-07-02','13:15:00',7.81),('16100','2013-07-02','13:20:00',7.83),('16100','2013-07-02','13:25:00',7.82),('16100','2013-07-02','13:30:00',7.82),('16100','2013-07-02','13:35:00',7.86),('16100','2013-07-02','13:40:00',7.79),('16100','2013-07-02','13:45:00',7.83),('16100','2013-07-02','13:50:00',7.81),('16100','2013-07-02','13:55:00',7.77),('16100','2013-07-02','14:00:00',7.78),('16100','2013-07-02','14:05:00',7.75),('16100','2013-07-02','14:10:00',7.66),('16100','2013-07-02','14:15:00',7.6),('16100','2013-07-02','14:20:00',7.56),('16100','2013-07-02','14:25:00',7.56),('16100','2013-07-02','14:30:00',7.52),('16100','2013-07-02','14:35:00',7.49),('16100','2013-07-02','14:40:00',7.43),('16100','2013-07-02','14:45:00',7.39),('16100','2013-07-02','14:50:00',7.36),('16100','2013-07-02','14:55:00',7.32),('16100','2013-07-02','15:00:00',7.28),('16100','2013-07-02','15:05:00',7.24),('16100','2013-07-02','15:10:00',7.16),('16100','2013-07-02','15:15:00',7.1),('16100','2013-07-02','15:20:00',6.99),('16100','2013-07-02','15:25:00',6.91),('16100','2013-07-02','15:30:00',6.78),('16100','2013-07-02','15:35:00',6.69),('16100','2013-07-02','15:40:00',6.61),('16100','2013-07-02','15:45:00',6.53),('16100','2013-07-02','15:50:00',6.46),('16100','2013-07-02','15:55:00',6.33),('16100','2013-07-02','16:00:00',6.23),('16100','2013-07-02','16:05:00',6.15),('16100','2013-07-02','16:10:00',6.04),('16100','2013-07-02','16:15:00',5.89),('16100','2013-07-02','16:20:00',5.82),('16100','2013-07-02','16:25:00',5.65),('16100','2013-07-02','16:30:00',5.54),('16100','2013-07-02','16:35:00',5.44),('16100','2013-07-02','16:40:00',5.35),('16100','2013-07-02','16:45:00',5.22),('16100','2013-07-02','16:50:00',5.11),('16100','2013-07-02','16:55:00',4.99),('16100','2013-07-02','17:00:00',4.84),('16100','2013-07-02','17:05:00',4.7),('16100','2013-07-02','17:10:00',4.57),('16100','2013-07-02','17:15:00',4.39),('16100','2013-07-02','17:20:00',4.26),('16100','2013-07-02','17:25:00',4.11),('16100','2013-07-02','17:30:00',3.97),('16100','2013-07-02','17:35:00',3.82),('16100','2013-07-02','17:40:00',3.63),('16100','2013-07-02','17:45:00',3.48),('16100','2013-07-02','17:50:00',3.33),('16100','2013-07-02','17:55:00',3.21),('16100','2013-07-02','18:00:00',3.04),('16100','2013-07-02','18:05:00',2.85),('16100','2013-07-02','18:10:00',2.68),('16100','2013-07-02','18:15:00',2.46),('16100','2013-07-02','18:20:00',2.28),('16100','2013-07-02','18:25:00',2.12),('16100','2013-07-02','18:30:00',1.95),('16100','2013-07-02','18:35:00',1.8),('16100','2013-07-02','18:40:00',1.63),('16100','2013-07-02','18:45:00',1.48),('16100','2013-07-02','18:50:00',1.32),('16100','2013-07-02','18:55:00',1.17),('16100','2013-07-02','19:00:00',1.02),('16100','2013-07-01','07:50:00',1.01),('16100','2013-07-01','07:55:00',1.2),('16100','2013-07-01','08:00:00',1.38),('16100','2013-07-01','08:05:00',1.58),('16100','2013-07-01','08:10:00',1.76),('16100','2013-07-01','08:15:00',1.95),('16100','2013-07-01','08:20:00',2.14),('16100','2013-07-01','08:25:00',2.27),('16100','2013-07-01','08:30:00',2.46),('16100','2013-07-01','08:35:00',2.62),('16100','2013-07-01','08:40:00',2.77),('16100','2013-07-01','08:45:00',2.93),('16100','2013-07-01','08:50:00',3.13),('16100','2013-07-01','08:55:00',3.27),('16100','2013-07-01','09:00:00',3.42),('16100','2013-07-01','09:05:00',3.55),('16100','2013-07-01','09:10:00',3.71),('16100','2013-07-01','09:15:00',3.96),('16100','2013-07-01','09:20:00',4.23),('16100','2013-07-01','09:25:00',4.4),('16100','2013-07-01','09:30:00',4.52),('16100','2013-07-01','09:35:00',4.63),('16100','2013-07-01','09:40:00',4.76),('16100','2013-07-01','09:45:00',4.89),('16100','2013-07-01','09:50:00',5),('16100','2013-07-01','09:55:00',5.08),('16100','2013-07-01','10:00:00',5.19),('16100','2013-07-01','10:05:00',5.33),('16100','2013-07-01','10:10:00',5.48),('16100','2013-07-01','10:15:00',5.61),('16100','2013-07-01','10:20:00',5.68),('16100','2013-07-01','10:25:00',5.77),('16100','2013-07-01','10:30:00',5.84),('16100','2013-07-01','10:35:00',5.93),('16100','2013-07-01','10:40:00',6.06),('16100','2013-07-01','10:45:00',6.13),('16100','2013-07-01','10:50:00',6.18),('16100','2013-07-01','10:55:00',6.24),('16100','2013-07-01','11:00:00',6.36),('16100','2013-07-01','11:05:00',6.46),('16100','2013-07-01','11:10:00',6.52),('16100','2013-07-01','11:15:00',6.51),('16100','2013-07-01','11:20:00',6.59),('16100','2013-07-01','11:25:00',6.67),('16100','2013-07-01','11:30:00',6.67),('16100','2013-07-01','11:35:00',6.71),('16100','2013-07-01','11:40:00',6.82),('16100','2013-07-01','11:45:00',6.92),('16100','2013-07-01','11:50:00',7.04),('16100','2013-07-01','11:55:00',6.98),('16100','2013-07-01','12:00:00',7.06),('16100','2013-07-01','12:05:00',7.24),('16100','2013-07-01','12:10:00',7.27),('16100','2013-07-01','12:15:00',7.29),('16100','2013-07-01','12:20:00',7.6),('16100','2013-07-01','12:25:00',7.58),('16100','2013-07-01','12:30:00',7.39),('16100','2013-07-01','12:35:00',7.27),('16100','2013-07-01','12:40:00',5.56),('16100','2013-07-01','12:45:00',5.35),('16100','2013-07-01','12:50:00',6.85),('16100','2013-07-01','12:55:00',7.66),('16100','2013-07-01','13:00:00',7.77),('16100','2013-07-01','13:05:00',7.68),('16100','2013-07-01','13:10:00',7.69),('16100','2013-07-01','13:15:00',7.52),('16100','2013-07-01','13:20:00',7.38),('16100','2013-07-01','13:25:00',7.48),('16100','2013-07-01','13:30:00',7.58),('16100','2013-07-01','13:35:00',7.58),('16100','2013-07-01','13:40:00',7.54),('16100','2013-07-01','13:45:00',7.53),('16100','2013-07-01','13:50:00',7.48),('16100','2013-07-01','13:55:00',7.47),('16100','2013-07-01','14:00:00',7.42),('16100','2013-07-01','14:05:00',7.47),('16100','2013-07-01','14:10:00',7.49),('16100','2013-07-01','14:15:00',7.47),('16100','2013-07-01','14:20:00',7.38),('16100','2013-07-01','14:25:00',7.27),('16100','2013-07-01','14:30:00',7.21),('16100','2013-07-01','14:35:00',7.33),('16100','2013-07-01','14:40:00',7.23),('16100','2013-07-01','14:45:00',7.18),('16100','2013-07-01','14:50:00',7.16),('16100','2013-07-01','14:55:00',7.08),('16100','2013-07-01','15:00:00',7.01),('16100','2013-07-01','15:05:00',6.92),('16100','2013-07-01','15:10:00',6.86),('16100','2013-07-01','15:15:00',6.78),('16100','2013-07-01','15:20:00',6.72),('16100','2013-07-01','15:25:00',6.7),('16100','2013-07-01','15:30:00',6.59),('16100','2013-07-01','15:35:00',6.49),('16100','2013-07-01','15:40:00',6.45),('16100','2013-07-01','15:45:00',6.38),('16100','2013-07-01','15:50:00',6.27),('16100','2013-07-01','15:55:00',6.15),('16100','2013-07-01','16:00:00',6.07),('16100','2013-07-01','16:05:00',6),('16100','2013-07-01','16:10:00',5.89),('16100','2013-07-01','16:15:00',5.78),('16100','2013-07-01','16:20:00',5.67),('16100','2013-07-01','16:25:00',5.5),('16100','2013-07-01','16:30:00',5.38),('16100','2013-07-01','16:35:00',5.27),('16100','2013-07-01','16:40:00',5.13),('16100','2013-07-01','16:45:00',5.04),('16100','2013-07-01','16:50:00',4.93),('16100','2013-07-01','16:55:00',4.79),('16100','2013-07-01','17:00:00',4.67),('16100','2013-07-01','17:05:00',4.52),('16100','2013-07-01','17:10:00',4.35),('16100','2013-07-01','17:15:00',4.16),('16100','2013-07-01','17:20:00',4.1),('16100','2013-07-01','17:26:00',3.97),('16100','2013-07-01','17:30:00',3.78),('16100','2013-07-01','17:35:00',3.65),('16100','2013-07-01','17:40:00',3.49),('16100','2013-07-01','17:45:00',3.31),('16100','2013-07-01','17:50:00',3.18),('16100','2013-07-01','17:55:00',3.04),('16100','2013-07-01','18:00:00',2.87),('16100','2013-07-01','18:05:00',2.7),('16100','2013-07-01','18:10:00',2.52),('16100','2013-07-01','18:15:00',2.3),('16100','2013-07-01','18:20:00',2.09),('16100','2013-07-01','18:25:00',1.99),('16100','2013-07-01','18:30:00',1.82),('16100','2013-07-01','18:35:00',1.68),('16100','2013-07-01','18:41:00',1.53),('16100','2013-07-01','18:45:00',1.36),('16100','2013-07-01','18:50:00',1.24),('16100','2013-07-01','18:55:00',1.1),('16100','2013-06-30','07:50:00',1.04),('16100','2013-06-30','07:55:00',1.25),('16100','2013-06-30','08:00:00',1.45),('16100','2013-06-30','08:05:00',1.65),('16100','2013-06-30','08:10:00',1.84),('16100','2013-06-30','08:15:00',2.04),('16100','2013-06-30','08:20:00',2.21),('16100','2013-06-30','08:25:00',2.34),('16100','2013-06-30','08:30:00',2.52),('16100','2013-06-30','08:35:00',2.66),('16100','2013-06-30','08:40:00',2.82),('16100','2013-06-30','08:45:00',3.01),('16100','2013-06-30','08:50:00',3.19),('16100','2013-06-30','08:55:00',3.33),('16100','2013-06-30','09:00:00',3.49),('16100','2013-06-30','09:05:00',3.61),('16100','2013-06-30','09:10:00',3.82),('16100','2013-06-30','09:15:00',4.1),('16100','2013-06-30','09:20:00',4.41),('16100','2013-06-30','09:25:00',4.56),('16100','2013-06-30','09:30:00',4.69),('16100','2013-06-30','09:35:00',4.84),('16100','2013-06-30','09:40:00',4.98),('16100','2013-06-30','09:45:00',5.08),('16100','2013-06-30','09:50:00',5.18),('16100','2013-06-30','09:55:00',5.28),('16100','2013-06-30','10:00:00',5.38),('16100','2013-06-30','10:05:00',5.49),('16100','2013-06-30','10:10:00',5.62),('16100','2013-06-30','10:15:00',5.76),('16100','2013-06-30','10:20:00',5.88),('16100','2013-06-30','10:25:00',5.97),('16100','2013-06-30','10:30:00',6.03),('16100','2013-06-30','10:35:00',6.13),('16100','2013-06-30','10:40:00',6.21),('16100','2013-06-30','10:45:00',6.29),('16100','2013-06-30','10:50:00',6.32),('16100','2013-06-30','10:55:00',6.41),('16100','2013-06-30','11:00:00',6.6),('16100','2013-06-30','11:05:00',6.68),('16100','2013-06-30','11:10:00',6.73),('16100','2013-06-30','11:15:00',6.79),('16100','2013-06-30','11:20:00',6.89),('16100','2013-06-30','11:25:00',7),('16100','2013-06-30','11:30:00',7.1),('16100','2013-06-30','11:35:00',7.18),('16100','2013-06-30','11:40:00',7.24),('16100','2013-06-30','11:45:00',7.24),('16100','2013-06-30','11:50:00',7.31),('16100','2013-06-30','11:55:00',7.33),('16100','2013-06-30','12:00:00',7.41),('16100','2013-06-30','12:05:00',7.36),('16100','2013-06-30','12:10:00',7.3),('16100','2013-06-30','12:15:00',7.31),('16100','2013-06-30','12:20:00',7.32),('16100','2013-06-30','12:25:00',7.35),('16100','2013-06-30','12:30:00',7.39),('16100','2013-06-30','12:35:00',7.44),('16100','2013-06-30','12:40:00',7.45),('16100','2013-06-30','12:45:00',7.54),('16100','2013-06-30','12:50:00',7.56),('16100','2013-06-30','12:55:00',7.52),('16100','2013-06-30','13:00:00',7.47),('16100','2013-06-30','13:05:00',7.58),('16100','2013-06-30','13:10:00',4.73),('16100','2013-06-30','13:15:00',4.25),('16100','2013-06-30','13:20:00',8.03),('16100','2013-06-30','13:25:00',7.88),('16100','2013-06-30','13:30:00',7.82),('16100','2013-06-30','13:35:00',7.95),('16100','2013-06-30','13:40:00',7.91),('16100','2013-06-30','13:45:00',7.73),('16100','2013-06-30','13:50:00',7.73),('16100','2013-06-30','13:55:00',7.45),('16100','2013-06-30','14:00:00',7.6),('16100','2013-06-30','14:05:00',7.47),('16100','2013-06-30','14:10:00',7.45),('16100','2013-06-30','14:15:00',7.49),('16100','2013-06-30','14:20:00',7.47),('16100','2013-06-30','14:25:00',7.35),('16100','2013-06-30','14:30:00',7.32),('16100','2013-06-30','14:35:00',7.31),('16100','2013-06-30','14:40:00',7.28),('16100','2013-06-30','14:45:00',7.24),('16100','2013-06-30','14:50:00',7.2),('16100','2013-06-30','14:55:00',7.12),('16100','2013-06-30','15:00:00',7.07),('16100','2013-06-30','15:05:00',7.03),('16100','2013-06-30','15:10:00',6.97),('16100','2013-06-30','15:15:00',6.86),('16100','2013-06-30','15:20:00',6.79),('16100','2013-06-30','15:25:00',6.69),('16100','2013-06-30','15:30:00',6.53),('16100','2013-06-30','15:35:00',6.43),('16100','2013-06-30','15:40:00',6.32),('16100','2013-06-30','15:45:00',6.3),('16100','2013-06-30','15:50:00',6.21),('16100','2013-06-30','15:55:00',6.1),('16100','2013-06-30','16:00:00',6),('16100','2013-06-30','16:05:00',5.68),('16100','2013-06-30','16:10:00',5.52),('16100','2013-06-30','16:15:00',5.68),('16100','2013-06-30','16:20:00',5.6),('16100','2013-06-30','16:25:00',5.45),('16100','2013-06-30','16:30:00',5.37),('16100','2013-06-30','16:35:00',5.28),('16100','2013-06-30','16:40:00',5.19),('16100','2013-06-30','16:45:00',5.03),('16100','2013-06-30','16:50:00',4.91),('16100','2013-06-30','16:55:00',4.78),('16100','2013-06-30','17:00:00',4.65),('16100','2013-06-30','17:05:00',4.5),('16100','2013-06-30','17:10:00',4.37),('16100','2013-06-30','17:15:00',4.19),('16100','2013-06-30','17:20:00',4.06),('16100','2013-06-30','17:25:00',3.92),('16100','2013-06-30','17:30:00',3.79),('16100','2013-06-30','17:35:00',3.62),('16100','2013-06-30','17:40:00',3.45),('16100','2013-06-30','17:45:00',3.3),('16100','2013-06-30','17:50:00',3.13),('16100','2013-06-30','17:55:00',3.03),('16100','2013-06-30','18:00:00',2.87),('16100','2013-06-30','18:05:00',2.47),('16100','2013-06-30','18:10:00',2.35),('16100','2013-06-30','18:15:00',2.22),('16100','2013-06-30','18:20:00',2.13),('16100','2013-06-30','18:25:00',2.06),('16100','2013-06-30','18:30:00',1.87),('16100','2013-06-30','18:35:00',1.55),('16100','2013-06-30','18:40:00',1.52),('16100','2013-06-30','18:45:00',1.36),('16100','2013-06-30','18:50:00',1.16),('16100','2013-06-30','18:55:00',1.02),('16100','2014-04-04','08:35:00',1.23),('16100','2014-04-04','08:40:00',1.31),('16100','2014-04-04','08:45:00',1.43),('16100','2014-04-04','08:50:00',1.18),('16100','2014-04-04','09:10:00',1.08),('16100','2014-04-04','09:15:00',1.21),('16100','2014-04-04','09:20:00',1.7),('16100','2014-04-04','09:25:00',2.39),('16100','2014-04-04','09:30:00',2.86),('16100','2014-04-04','09:35:00',3.26),('16100','2014-04-04','09:40:00',3.44),('16100','2014-04-04','09:45:00',3.53),('16100','2014-04-04','09:50:00',3.73),('16100','2014-04-04','09:55:00',4.32),('16100','2014-04-04','10:00:00',4.26),('16100','2014-04-04','10:05:00',3.61),('16100','2014-04-04','10:10:00',3.22),('16100','2014-04-04','10:15:00',3.54),('16100','2014-04-04','10:20:00',3.15),('16100','2014-04-04','10:25:00',4.58),('16100','2014-04-04','10:30:00',5.53),('16100','2014-04-04','10:35:00',2.47),('16100','2014-04-04','10:40:00',2.55),('16100','2014-04-04','10:45:00',3.32),('16100','2014-04-04','10:50:00',5.31),('16100','2014-04-04','10:55:00',4.88),('16100','2014-04-04','11:00:00',5.03),('16100','2014-04-04','11:05:00',4.87),('16100','2014-04-04','11:10:00',4.39),('16100','2014-04-04','11:15:00',4.98),('16100','2014-04-04','11:20:00',6.05),('16100','2014-04-04','11:25:00',6.33),('16100','2014-04-04','11:30:00',6.58),('16100','2014-04-04','11:35:00',6.49),('16100','2014-04-04','11:40:00',5.81),('16100','2014-04-04','11:45:00',4.88),('16100','2014-04-04','11:50:00',5.12),('16100','2014-04-04','11:55:00',4.72),('16100','2014-04-04','12:00:00',4.8),('16100','2014-04-04','12:05:00',4.6),('16100','2014-04-04','12:10:00',4.43),('16100','2014-04-04','12:15:00',4.21),('16100','2014-04-04','12:20:00',5.65),('16100','2014-04-04','12:25:00',6.98),('16100','2014-04-04','12:30:00',5.59),('16100','2014-04-04','12:35:00',6.93),('16100','2014-04-04','12:40:00',5.84),('16100','2014-04-04','12:45:00',5.68),('16100','2014-04-04','12:50:00',4.67),('16100','2014-04-04','12:55:00',5.59),('16100','2014-04-04','13:00:00',7.16),('16100','2014-04-04','13:05:00',7.37),('16100','2014-04-04','13:10:00',7.72),('16100','2014-04-04','13:15:00',6.82),('16100','2014-04-04','13:20:00',5.18),('16100','2014-04-04','13:25:00',4.83),('16100','2014-04-04','13:30:00',5.13),('16100','2014-04-04','13:35:00',4.3),('16100','2014-04-04','13:40:00',5.69),('16100','2014-04-04','13:45:00',8.22),('16100','2014-04-04','13:50:00',5.49),('16100','2014-04-04','13:55:00',7.89),('16100','2014-04-04','14:00:00',2.8),('16100','2014-04-04','14:05:00',2.34),('16100','2014-04-04','14:10:00',2.76),('16100','2014-04-04','14:15:00',1.58),('16100','2014-04-04','14:30:00',1.14),('16100','2014-04-04','14:35:00',1.26),('16100','2014-04-04','14:40:00',1.21),('16100','2014-04-04','14:45:00',1.47),('16100','2014-04-04','14:50:00',7.81),('16100','2014-04-04','14:55:00',7.97),('16100','2014-04-04','15:00:00',6.7),('16100','2014-04-04','15:05:00',5.85),('16100','2014-04-04','15:10:00',6.53),('16100','2014-04-04','15:15:00',7.87),('16100','2014-04-04','15:20:00',7.12),('16100','2014-04-04','15:25:00',4.52),('16100','2014-04-04','15:30:00',3.66),('16100','2014-04-04','15:35:00',5.56),('16100','2014-04-04','15:40:00',7.44),('16100','2014-04-04','15:45:00',2.94),('16100','2014-04-04','15:50:00',1.43),('16100','2014-04-04','15:55:00',1.52),('16100','2014-04-04','16:00:00',1.84),('16100','2014-04-04','16:05:00',2.16),('16100','2014-04-04','16:10:00',2.92),('16100','2014-04-04','16:15:00',2.35),('16100','2014-04-04','16:20:00',1.89),('16100','2014-04-04','16:25:00',4.93),('16100','2014-04-04','16:30:00',4.31),('16100','2014-04-04','16:35:00',2.43),('16100','2014-04-04','16:40:00',2.81),('16100','2014-04-04','16:45:00',4.33),('16100','2014-04-04','16:50:00',5.33),('16100','2014-04-04','16:55:00',4.48),('16100','2014-04-04','17:00:00',2.37),('16100','2014-04-04','17:05:00',3.75),('16100','2014-04-04','17:10:00',3.94),('16100','2014-04-04','17:15:00',3.31),('16100','2014-04-04','17:20:00',3.09),('16100','2014-04-04','17:25:00',1.31),('16100','2014-04-04','17:30:00',1.82),('16100','2014-04-04','17:45:00',1.75),('16100','2014-04-04','17:50:00',1.66),('16100','2014-04-04','17:55:00',1.06),('16100','2014-04-04','18:00:00',1.2),('16100','2014-04-04','18:05:00',1.2),('16100','2014-04-04','18:10:00',1.18),('16100','2014-04-04','18:15:00',1.12),('16100','2014-04-04','18:20:00',1.15),('16100','2013-06-29','07:50:00',1.09),('16100','2013-06-29','07:55:00',1.3),('16100','2013-06-29','08:00:00',1.51),('16100','2013-06-29','08:05:00',1.7),('16100','2013-06-29','08:10:00',1.9),('16100','2013-06-29','08:15:00',2.1),('16100','2013-06-29','08:20:00',2.28),('16100','2013-06-29','08:25:00',2.41),('16100','2013-06-29','08:30:00',2.6),('16100','2013-06-29','08:35:00',2.77),('16100','2013-06-29','08:40:00',2.92),('16100','2013-06-29','08:45:00',3.11),('16100','2013-06-29','08:50:00',3.29),('16100','2013-06-29','08:55:00',3.45),('16100','2013-06-29','09:00:00',3.58),('16100','2013-06-29','09:05:00',3.7),('16100','2013-06-29','09:10:00',3.88),('16100','2013-06-29','09:15:00',4.14),('16100','2013-06-29','09:20:00',4.42),('16100','2013-06-29','09:25:00',4.57),('16100','2013-06-29','09:30:00',4.71),('16100','2013-06-29','09:35:00',4.86),('16100','2013-06-29','09:40:00',5.03),('16100','2013-06-29','09:45:00',5.16),('16100','2013-06-29','09:50:00',5.28),('16100','2013-06-29','09:55:00',5.4),('16100','2013-06-29','10:00:00',5.5),('16100','2013-06-29','10:05:00',5.62),('16100','2013-06-29','10:10:00',5.73),('16100','2013-06-29','10:15:00',5.88),('16100','2013-06-29','10:20:00',5.99),('16100','2013-06-29','10:25:00',6.08),('16100','2013-06-29','10:30:00',6.14),('16100','2013-06-29','10:35:00',6.26),('16100','2013-06-29','10:40:00',6.37),('16100','2013-06-29','10:45:00',6.44),('16100','2013-06-29','10:50:00',6.52),('16100','2013-06-29','10:55:00',6.6),('16100','2013-06-29','11:00:00',6.74),('16100','2013-06-29','11:05:00',6.85),('16100','2013-06-29','11:10:00',6.92),('16100','2013-06-29','11:15:00',6.97),('16100','2013-06-29','11:20:00',7.04),('16100','2013-06-29','11:25:00',7.12),('16100','2013-06-29','11:30:00',7.18),('16100','2013-06-29','11:35:00',7.24),('16100','2013-06-29','11:40:00',7.33),('16100','2013-06-29','11:45:00',7.33),('16100','2013-06-29','11:50:00',7.34),('16100','2013-06-29','11:55:00',7.39),('16100','2013-06-29','12:00:00',7.45),('16100','2013-06-29','12:05:00',7.48),('16100','2013-06-29','12:10:00',7.55),('16100','2013-06-29','12:15:00',7.55),('16100','2013-06-29','12:20:00',7.55),('16100','2013-06-29','12:25:00',7.59),('16100','2013-06-29','12:30:00',7.68),('16100','2013-06-29','12:35:00',7.66),('16100','2013-06-29','12:40:00',7.74),('16100','2013-06-29','12:45:00',7.44),('16100','2013-06-29','12:50:00',7.81),('16100','2013-06-29','12:55:00',7.88),('16100','2013-06-29','13:00:00',7.62),('16100','2013-06-29','13:05:00',4.45),('16100','2013-06-29','13:10:00',7.49),('16100','2013-06-29','13:15:00',5.1),('16100','2013-06-29','13:20:00',8.07),('16100','2013-06-29','13:25:00',3.79),('16100','2013-06-29','13:30:00',6.46),('16100','2013-06-29','13:35:00',6.73),('16100','2013-06-29','13:40:00',5.22),('16100','2013-06-29','13:45:00',4.91),('16100','2013-06-29','13:50:00',8.52),('16100','2013-06-29','13:55:00',8.19),('16100','2013-06-29','14:00:00',6.77),('16100','2013-06-29','14:05:00',6.67),('16100','2013-06-29','14:10:00',7.73),('16100','2013-06-29','14:15:00',6.44),('16100','2013-06-29','14:20:00',6.36),('16100','2013-06-29','14:25:00',7.69),('16100','2013-06-29','14:30:00',7.55),('16100','2013-06-29','14:35:00',7.47),('16100','2013-06-29','14:40:00',7.42),('16100','2013-06-29','14:45:00',7.4),('16100','2013-06-29','14:50:00',7.32),('16100','2013-06-29','14:55:00',7.21),('16100','2013-06-29','15:00:00',7.16),('16100','2013-06-29','15:05:00',7.23),('16100','2013-06-29','15:10:00',7.17),('16100','2013-06-29','15:15:00',7.06),('16100','2013-06-29','15:20:00',7),('16100','2013-06-29','15:25:00',6.9),('16100','2013-06-29','15:30:00',6.93),('16100','2013-06-29','15:35:00',6.78),('16100','2013-06-29','15:40:00',5.69),('16100','2013-06-29','15:45:00',6.53),('16100','2013-06-29','15:50:00',6.5),('16100','2013-06-29','15:55:00',6.5),('16100','2013-06-29','16:00:00',6.29),('16100','2013-06-29','16:05:00',6.15),('16100','2013-06-29','16:10:00',6.14),('16100','2013-06-29','16:15:00',6.05),('16100','2013-06-29','16:20:00',5.94),('16100','2013-06-29','16:25:00',5.72),('16100','2013-06-29','16:30:00',5.67),('16100','2013-06-29','16:35:00',5.54),('16100','2013-06-29','16:40:00',5.28),('16100','2013-06-29','16:45:00',5.1),('16100','2013-06-29','16:50:00',5.03),('16100','2013-06-29','16:55:00',4.85),('16100','2013-06-29','17:00:00',4.71),('16100','2013-06-29','17:05:00',4.57),('16100','2013-06-29','17:10:00',4.39),('16100','2013-06-29','17:15:00',4.23),('16100','2013-06-29','17:20:00',4.11),('16100','2013-06-29','17:25:00',3.99),('16100','2013-06-29','17:30:00',3.81),('16100','2013-06-29','17:35:00',2.92),('16100','2013-06-29','17:40:00',2.92),('16100','2013-06-29','17:45:00',3.39),('16100','2013-06-29','17:50:00',3.3),('16100','2013-06-29','17:55:00',2.94),('16100','2013-06-29','18:00:00',2.78),('16100','2013-06-29','18:05:00',2.56),('16100','2013-06-29','18:10:00',2.4),('16100','2013-06-29','18:15:00',2.24),('16100','2013-06-29','18:20:00',2.04),('16100','2013-06-29','18:25:00',1.94),('16100','2013-06-29','18:30:00',1.75),('16100','2013-06-29','18:35:00',1.67),('16100','2013-06-29','18:40:00',1.55),('16100','2013-06-29','18:45:00',1.4),('16100','2013-06-29','18:50:00',1.29),('16100','2013-06-29','18:55:00',1.15),('16100','2013-06-29','19:00:00',1.02),('16100','2013-06-28','07:25:00',1.02),('16100','2013-06-28','07:30:00',1.27),('16100','2013-06-28','07:35:00',1.3),('16100','2013-06-28','07:40:00',1.32),('16100','2013-06-28','07:45:00',1.24),('16100','2013-06-28','07:50:00',1.62),('16100','2013-06-28','07:55:00',1.65),('16100','2013-06-28','08:00:00',2.03),('16100','2013-06-28','08:05:00',1.59),('16100','2013-06-28','08:20:00',2.02),('16100','2013-06-28','08:25:00',2.52),('16100','2013-06-28','08:30:00',2.61),('16100','2013-06-28','08:35:00',2.74),('16100','2013-06-28','08:40:00',2.89),('16100','2013-06-28','08:45:00',3.05),('16100','2013-06-28','08:50:00',3.21),('16100','2013-06-28','08:55:00',3.36),('16100','2013-06-28','09:00:00',3.51),('16100','2013-06-28','09:05:00',3.65),('16100','2013-06-28','09:10:00',3.83),('16100','2013-06-28','09:15:00',4.08),('16100','2013-06-28','09:20:00',4.37),('16100','2013-06-28','09:25:00',4.52),('16100','2013-06-28','09:30:00',4.67),('16100','2013-06-28','09:35:00',4.77),('16100','2013-06-28','09:40:00',4.92),('16100','2013-06-28','09:45:00',5.05),('16100','2013-06-28','09:50:00',5.16),('16100','2013-06-28','09:55:00',5.27),('16100','2013-06-28','10:00:00',5.4),('16100','2013-06-28','10:05:00',5.52),('16100','2013-06-28','10:10:00',5.64),('16100','2013-06-28','10:15:00',5.75),('16100','2013-06-28','10:20:00',5.87),('16100','2013-06-28','10:25:00',5.97),('16100','2013-06-28','10:30:00',6.1),('16100','2013-06-28','10:35:00',6.23),('16100','2013-06-28','10:40:00',6.11),('16100','2013-06-28','10:45:00',4.19),('16100','2013-06-28','10:50:00',5.97),('16100','2013-06-28','10:55:00',6.78),('16100','2013-06-28','11:00:00',2.93),('16100','2013-06-28','11:05:00',6.82),('16100','2013-06-28','11:10:00',5.29),('16100','2013-06-28','11:15:00',3.81),('16100','2013-06-28','11:20:00',7.56),('16100','2013-06-28','11:25:00',5.89),('16100','2013-06-28','11:30:00',6.65),('16100','2013-06-28','11:35:00',7.82),('16100','2013-06-28','11:40:00',2.24),('16100','2013-06-28','11:45:00',5.05),('16100','2013-06-28','11:50:00',7.24),('16100','2013-06-28','11:55:00',7.81),('16100','2013-06-28','12:00:00',7.92),('16100','2013-06-28','12:05:00',3.65),('16100','2013-06-28','12:10:00',8.11),('16100','2013-06-28','12:15:00',8.03),('16100','2013-06-28','12:20:00',7.97),('16100','2013-06-28','12:25:00',8),('16100','2013-06-28','12:30:00',6.96),('16100','2013-06-28','12:35:00',2.48),('16100','2013-06-28','12:40:00',4.65),('16100','2013-06-28','12:45:00',5.01),('16100','2013-06-28','12:50:00',2.63),('16100','2013-06-28','12:55:00',4.94),('16100','2013-06-28','13:00:00',8.17),('16100','2013-06-28','13:05:00',3.2),('16100','2013-06-28','13:10:00',6.68),('16100','2013-06-28','13:15:00',2.8),('16100','2013-06-28','13:20:00',2.35),('16100','2013-06-28','13:25:00',5.29),('16100','2013-06-28','13:30:00',3.92),('16100','2013-06-28','13:35:00',4.6),('16100','2013-06-28','13:40:00',6.72),('16100','2013-06-28','13:45:00',2.24),('16100','2013-06-28','13:50:00',6.9),('16100','2013-06-28','13:55:00',7.23),('16100','2013-06-28','14:00:00',8.21),('16100','2013-06-28','14:05:00',8.2),('16100','2013-06-28','14:10:00',8.47),('16100','2013-06-28','14:15:00',7.23),('16100','2013-06-28','14:20:00',6.11),('16100','2013-06-28','14:25:00',8.05),('16100','2013-06-28','14:30:00',8.01),('16100','2013-06-28','14:35:00',7.95),('16100','2013-06-28','14:40:00',8.06),('16100','2013-06-28','14:45:00',7.7),('16100','2013-06-28','14:50:00',8.2),('16100','2013-06-28','14:55:00',8.18),('16100','2013-06-28','15:00:00',8.49),('16100','2013-06-28','15:05:00',4.57),('16100','2013-06-28','15:10:00',5.65),('16100','2013-06-28','15:15:00',6.48),('16100','2013-06-28','15:20:00',3.9),('16100','2013-06-28','15:25:00',2.6),('16100','2013-06-28','15:30:00',2.05),('16100','2013-06-28','15:35:00',1.34),('16100','2013-06-28','16:15:00',1.09),('16100','2013-06-28','16:20:00',1.5),('16100','2013-06-28','16:25:00',1.89),('16100','2013-06-28','16:30:00',2.77),('16100','2013-06-28','16:35:00',4.6),('16100','2013-06-28','16:40:00',5.84),('16100','2013-06-28','16:45:00',5.17),('16100','2013-06-28','16:50:00',2.96),('16100','2013-06-28','16:55:00',2.12),('16100','2013-06-28','17:00:00',2.04),('16100','2013-06-28','17:05:00',1.95),('16100','2013-06-28','17:10:00',1.95),('16100','2013-06-28','17:15:00',2.08),('16100','2013-06-28','17:20:00',2.58),('16100','2013-06-28','17:25:00',3.75),('16100','2013-06-28','17:30:00',4.52),('16100','2013-06-28','17:35:00',3.41),('16100','2013-06-28','17:40:00',4.1),('16100','2013-06-28','17:45:00',3.81),('16100','2013-06-28','17:50:00',1.33),('16100','2013-06-28','17:55:00',1.29),('16100','2013-06-28','18:00:00',1.61),('16100','2013-06-28','18:05:00',1.25),('16100','2013-06-28','18:15:00',2.03),('16100','2013-06-28','18:20:00',2.04),('16100','2013-06-28','18:30:00',1.23),('16100','2013-06-28','18:35:00',1.37),('16100','2013-06-28','18:40:00',1.13),('16100','2013-06-28','18:55:00',1.18),('16100','2013-06-28','19:00:00',1.33),('16100','2013-06-27','07:50:00',1.13),('16100','2013-06-27','07:55:00',1.3),('16100','2013-06-27','08:00:00',1.31),('16100','2013-06-27','08:05:00',1.54),('16100','2013-06-27','08:10:00',1.55),('16100','2013-06-27','08:15:00',1.97),('16100','2013-06-27','08:20:00',2.01),('16100','2013-06-27','08:25:00',2.3),('16100','2013-06-27','08:30:00',2.49),('16100','2013-06-27','08:35:00',2.69),('16100','2013-06-27','08:40:00',2.82),('16100','2013-06-27','08:45:00',3.01),('16100','2013-06-27','08:50:00',3.14),('16100','2013-06-27','08:55:00',3.33),('16100','2013-06-27','09:00:00',3.48),('16100','2013-06-27','09:05:00',3.68),('16100','2013-06-27','09:10:00',4.05),('16100','2013-06-27','09:15:00',4.54),('16100','2013-06-27','09:20:00',4.01),('16100','2013-06-27','09:25:00',3.59),('16100','2013-06-27','09:30:00',4.49),('16100','2013-06-27','09:35:00',4.18),('16100','2013-06-27','09:40:00',3.46),('16100','2013-06-27','09:45:00',4.91),('16100','2013-06-27','09:50:00',3.85),('16100','2013-06-27','09:55:00',1.59),('16100','2013-06-27','10:00:00',1.75),('16100','2013-06-27','10:05:00',4.48),('16100','2013-06-27','10:10:00',6.44),('16100','2013-06-27','10:15:00',4.05),('16100','2013-06-27','10:20:00',3.42),('16100','2013-06-27','10:25:00',1.86),('16100','2013-06-27','10:30:00',7.15),('16100','2013-06-27','10:35:00',7.05),('16100','2013-06-27','10:40:00',3.62),('16100','2013-06-27','10:45:00',6.31),('16100','2013-06-27','10:50:00',1.69),('16100','2013-06-27','10:55:00',2.09),('16100','2013-06-27','11:00:00',2.5),('16100','2013-06-27','11:05:00',2.7),('16100','2013-06-27','11:10:00',4.54),('16100','2013-06-27','11:15:00',6.16),('16100','2013-06-27','11:20:00',5.18),('16100','2013-06-27','11:25:00',7.24),('16100','2013-06-27','11:30:00',6.37),('16100','2013-06-27','11:35:00',7),('16100','2013-06-27','11:40:00',6.29),('16100','2013-06-27','11:45:00',7.35),('16100','2013-06-27','11:50:00',5.13),('16100','2013-06-27','11:55:00',7.67),('16100','2013-06-27','12:00:00',4.54),('16100','2013-06-27','12:05:00',8.62),('16100','2013-06-27','12:10:00',7.86),('16100','2013-06-27','12:15:00',7.3),('16100','2013-06-27','12:20:00',7.79),('16100','2013-06-27','12:25:00',8.13),('16100','2013-06-27','12:30:00',6.58),('16100','2013-06-27','12:35:00',6.65),('16100','2013-06-27','12:40:00',8.11),('16100','2013-06-27','12:45:00',7.05),('16100','2013-06-27','12:50:00',8.27),('16100','2013-06-27','12:55:00',4.65),('16100','2013-06-27','13:00:00',7.62),('16100','2013-06-27','13:05:00',2.72),('16100','2013-06-27','13:10:00',8.3),('16100','2013-06-27','13:15:00',6.54),('16100','2013-06-27','13:20:00',5.9),('16100','2013-06-27','13:25:00',8.17),('16100','2013-06-27','13:30:00',8.04),('16100','2013-06-27','13:35:00',7.94),('16100','2013-06-27','13:40:00',8.01),('16100','2013-06-27','13:45:00',8.67),('16100','2013-06-27','13:50:00',6.23),('16100','2013-06-27','13:55:00',6.92),('16100','2013-06-27','14:00:00',7.96),('16100','2013-06-27','14:05:00',6.9),('16100','2013-06-27','14:10:00',5.75),('16100','2013-06-27','14:15:00',3.91),('16100','2013-06-27','14:20:00',6.29),('16100','2013-06-27','14:25:00',4.81),('16100','2013-06-27','14:30:00',7.29),('16100','2013-06-27','14:35:00',8.15),('16100','2013-06-27','14:40:00',7.08),('16100','2013-06-27','14:45:00',3.59),('16100','2013-06-27','14:50:00',3.69),('16100','2013-06-27','14:55:00',7.26),('16100','2013-06-27','15:00:00',6.82),('16100','2013-06-27','15:05:00',6.75),('16100','2013-06-27','15:10:00',2.46),('16100','2013-06-27','15:15:00',5.6),('16100','2013-06-27','15:20:00',5.51),('16100','2013-06-27','15:25:00',2.47),('16100','2013-06-27','15:30:00',6.88),('16100','2013-06-27','15:35:00',3.64),('16100','2013-06-27','15:40:00',3.06),('16100','2013-06-27','15:45:00',4.66),('16100','2013-06-27','15:50:00',6.72),('16100','2013-06-27','15:55:00',6.51),('16100','2013-06-27','16:00:00',6.84),('16100','2013-06-27','16:05:00',6.1),('16100','2013-06-27','16:10:00',5.59),('16100','2013-06-27','16:15:00',6.32),('16100','2013-06-27','16:20:00',3.51),('16100','2013-06-27','16:25:00',6.19),('16100','2013-06-27','16:30:00',6.16),('16100','2013-06-27','16:35:00',3.99),('16100','2013-06-27','16:40:00',5.74),('16100','2013-06-27','16:45:00',6.09),('16100','2013-06-27','16:50:00',4.56),('16100','2013-06-27','16:55:00',4.83),('16100','2013-06-27','17:00:00',5.42),('16100','2013-06-27','17:05:00',5.15),('16100','2013-06-27','17:10:00',4.65),('16100','2013-06-27','17:15:00',4.38),('16100','2013-06-27','17:20:00',4.18),('16100','2013-06-27','17:25:00',4),('16100','2013-06-27','17:30:00',3.82),('16100','2013-06-27','17:35:00',3.71),('16100','2013-06-27','17:40:00',3.58),('16100','2013-06-27','17:45:00',3.39),('16100','2013-06-27','17:50:00',3.23),('16100','2013-06-27','17:55:00',3.04),('16100','2013-06-27','18:00:00',2.89),('16100','2013-06-27','18:05:00',2.41),('16100','2013-06-27','18:10:00',1.54),('16100','2013-06-27','18:15:00',2.31),('16100','2013-06-27','18:20:00',2.14),('16100','2013-06-27','18:25:00',2.01),('16100','2013-06-27','18:30:00',1.87),('16100','2013-06-27','18:35:00',1.78),('16100','2013-06-27','18:40:00',1.61),('16100','2013-06-27','18:45:00',1.31),('16100','2013-06-27','18:50:00',1.29),('16100','2013-06-27','18:55:00',1.06),('16100','2013-06-26','07:50:00',1.02),('16100','2013-06-26','07:55:00',1.29),('16100','2013-06-26','08:00:00',1.51),('16100','2013-06-26','08:05:00',1.73),('16100','2013-06-26','08:10:00',1.9),('16100','2013-06-26','08:15:00',2.09),('16100','2013-06-26','08:20:00',2.25),('16100','2013-06-26','08:25:00',2.39),('16100','2013-06-26','08:30:00',2.53),('16100','2013-06-26','08:35:00',2.65),('16100','2013-06-26','08:40:00',2.85),('16100','2013-06-26','08:45:00',3.03),('16100','2013-06-26','08:50:00',3.24),('16100','2013-06-26','08:55:00',3.49),('16100','2013-06-26','09:00:00',3.55),('16100','2013-06-26','09:05:00',3.64),('16100','2013-06-26','09:10:00',3.84),('16100','2013-06-26','09:15:00',4.13),('16100','2013-06-26','09:20:00',4.43),('16100','2013-06-26','09:25:00',4.57),('16100','2013-06-26','09:30:00',4.71),('16100','2013-06-26','09:35:00',4.87),('16100','2013-06-26','09:40:00',4.96),('16100','2013-06-26','09:45:00',5.08),('16100','2013-06-26','09:50:00',5.2),('16100','2013-06-26','09:55:00',5.37),('16100','2013-06-26','10:00:00',5.51),('16100','2013-06-26','10:05:00',5.6),('16100','2013-06-26','10:10:00',5.75),('16100','2013-06-26','10:15:00',5.86),('16100','2013-06-26','10:20:00',6.03),('16100','2013-06-26','10:25:00',6.1),('16100','2013-06-26','10:30:00',6.28),('16100','2013-06-26','10:35:00',5.71),('16100','2013-06-26','10:40:00',4.73),('16100','2013-06-26','10:45:00',2.1),('16100','2013-06-26','10:50:00',2.07),('16100','2013-06-26','10:55:00',6.54),('16100','2013-06-26','11:00:00',7.44),('16100','2013-06-26','11:05:00',7.51),('16100','2013-06-26','11:10:00',6.36),('16100','2013-06-26','11:15:00',7.42),('16100','2013-06-26','11:20:00',7.3),('16100','2013-06-26','11:25:00',7.41),('16100','2013-06-26','11:30:00',7.63),('16100','2013-06-26','11:35:00',4.4),('16100','2013-06-26','11:40:00',7.71),('16100','2013-06-26','11:45:00',7.87),('16100','2013-06-26','11:50:00',7.86),('16100','2013-06-26','11:55:00',7.94),('16100','2013-06-26','12:00:00',6.38),('16100','2013-06-26','12:05:00',2.66),('16100','2013-06-26','12:10:00',1.73),('16100','2013-06-26','12:15:00',1.77),('16100','2013-06-26','12:20:00',1.51),('16100','2013-06-26','12:25:00',1.33),('16100','2013-06-26','12:30:00',1.58),('16100','2013-06-26','12:35:00',2.01),('16100','2013-06-26','12:40:00',4.02),('16100','2013-06-26','12:45:00',3.97),('16100','2013-06-26','12:50:00',2.48),('16100','2013-06-26','12:55:00',3.85),('16100','2013-06-26','13:00:00',2.82),('16100','2013-06-26','13:05:00',4.21),('16100','2013-06-26','13:10:00',7.32),('16100','2013-06-26','13:15:00',8.38),('16100','2013-06-26','13:20:00',7.66),('16100','2013-06-26','13:25:00',8.1),('16100','2013-06-26','13:30:00',6.72),('16100','2013-06-26','13:35:00',3.22),('16100','2013-06-26','13:40:00',3.62),('16100','2013-06-26','13:45:00',3.18),('16100','2013-06-26','13:50:00',4.32),('16100','2013-06-26','13:55:00',6.52),('16100','2013-06-26','14:00:00',7.79),('16100','2013-06-26','14:05:00',8.01),('16100','2013-06-26','14:10:00',7.74),('16100','2013-06-26','14:15:00',7.4),('16100','2013-06-26','14:20:00',6.17),('16100','2013-06-26','14:25:00',3.96),('16100','2013-06-26','14:30:00',3.47),('16100','2013-06-26','14:35:00',3.38),('16100','2013-06-26','14:40:00',5.9),('16100','2013-06-26','14:45:00',7.48),('16100','2013-06-26','14:50:00',7.19),('16100','2013-06-26','14:55:00',7.01),('16100','2013-06-26','15:00:00',6.96),('16100','2013-06-26','15:05:00',6.95),('16100','2013-06-26','15:10:00',6.92),('16100','2013-06-26','15:15:00',6.89),('16100','2013-06-26','15:20:00',6.84),('16100','2013-06-26','15:25:00',6.73),('16100','2013-06-26','15:30:00',6.6),('16100','2013-06-26','15:35:00',6.49),('16100','2013-06-26','15:40:00',6.33),('16100','2013-06-26','15:45:00',6.28),('16100','2013-06-26','15:50:00',6.14),('16100','2013-06-26','15:55:00',6.01),('16100','2013-06-26','16:00:00',5.9),('16100','2013-06-26','16:05:00',5.83),('16100','2013-06-26','16:10:00',5.79),('16100','2013-06-26','16:15:00',5.68),('16100','2013-06-26','16:20:00',5.59),('16100','2013-06-26','16:25:00',5.43),('16100','2013-06-26','16:30:00',5.25),('16100','2013-06-26','16:35:00',4.86),('16100','2013-06-26','16:40:00',5.02),('16100','2013-06-26','16:45:00',4.95),('16100','2013-06-26','16:50:00',4.74),('16100','2013-06-26','16:55:00',4.67),('16100','2013-06-26','17:00:00',4.51),('16100','2013-06-26','17:05:00',4.31),('16100','2013-06-26','17:10:00',4.06),('16100','2013-06-26','17:15:00',4.05),('16100','2013-06-26','17:20:00',4.02),('16100','2013-06-26','17:25:00',3.95),('16100','2013-06-26','17:30:00',3.84),('16100','2013-06-26','17:35:00',3.81),('16100','2013-06-26','17:40:00',3.18),('16100','2013-06-26','17:45:00',3.37),('16100','2013-06-26','17:50:00',3.24),('16100','2013-06-26','17:55:00',3.13),('16100','2013-06-26','18:00:00',2.9),('16100','2013-06-26','18:05:00',2.71),('16100','2013-06-26','18:10:00',2.56),('16100','2013-06-26','18:15:00',2.25),('16100','2013-06-26','18:20:00',2.07),('16100','2013-06-26','18:25:00',1.92),('16100','2013-06-26','18:30:00',1.72),('16100','2013-06-26','18:35:00',1.58),('16100','2013-06-26','18:40:00',1.46),('16100','2013-06-26','18:45:00',1.35),('16100','2013-06-26','18:50:00',1.24),('16100','2013-06-26','18:55:00',1.12),('16100','2013-06-25','07:50:00',1.11),('16100','2013-06-25','07:55:00',1.3),('16100','2013-06-25','08:00:00',1.5),('16100','2013-06-25','08:05:00',1.7),('16100','2013-06-25','08:10:00',1.89),('16100','2013-06-25','08:15:00',2.08),('16100','2013-06-25','08:20:00',2.23),('16100','2013-06-25','08:25:00',2.37),('16100','2013-06-25','08:30:00',2.55),('16100','2013-06-25','08:35:00',2.69),('16100','2013-06-25','08:40:00',2.86),('16100','2013-06-25','08:45:00',3.03),('16100','2013-06-25','08:50:00',3.22),('16100','2013-06-25','08:55:00',3.37),('16100','2013-06-25','09:00:00',3.51),('16100','2013-06-25','09:05:00',3.63),('16100','2013-06-25','09:10:00',3.75),('16100','2013-06-25','09:15:00',4),('16100','2013-06-25','09:20:00',4.36),('16100','2013-06-25','09:25:00',4.49),('16100','2013-06-25','09:30:00',4.59),('16100','2013-06-25','09:35:00',4.71),('16100','2013-06-25','09:40:00',4.88),('16100','2013-06-25','09:45:00',5.02),('16100','2013-06-25','09:50:00',5.11),('16100','2013-06-25','09:55:00',5.24),('16100','2013-06-25','10:00:00',5.38),('16100','2013-06-25','10:05:00',5.53),('16100','2013-06-25','10:10:00',5.66),('16100','2013-06-25','10:15:00',5.8),('16100','2013-06-25','10:20:00',5.85),('16100','2013-06-25','10:25:00',5.98),('16100','2013-06-25','10:30:00',6.01),('16100','2013-06-25','10:35:00',6.05),('16100','2013-06-25','10:40:00',6.17),('16100','2013-06-25','10:45:00',6.37),('16100','2013-06-25','10:50:00',6.45),('16100','2013-06-25','10:55:00',6.48),('16100','2013-06-25','11:00:00',6.6),('16100','2013-06-25','11:05:00',6.65),('16100','2013-06-25','11:10:00',6.7),('16100','2013-06-25','11:15:00',6.8),('16100','2013-06-25','11:20:00',6.89),('16100','2013-06-25','11:25:00',6.93),('16100','2013-06-25','11:30:00',6.96),('16100','2013-06-25','11:35:00',7.06),('16100','2013-06-25','11:40:00',7.1),('16100','2013-06-25','11:45:00',7.18),('16100','2013-06-25','11:50:00',7.28),('16100','2013-06-25','11:55:00',7.31),('16100','2013-06-25','12:00:00',7.3),('16100','2013-06-25','12:05:00',7.3),('16100','2013-06-25','12:10:00',7.3),('16100','2013-06-25','12:15:00',7.38),('16100','2013-06-25','12:20:00',7.37),('16100','2013-06-25','12:25:00',7.45),('16100','2013-06-25','12:30:00',7.6),('16100','2013-06-25','12:35:00',7.73),('16100','2013-06-25','12:40:00',7.78),('16100','2013-06-25','12:45:00',7.86),('16100','2013-06-25','12:50:00',7.97),('16100','2013-06-25','12:55:00',7.99),('16100','2013-06-25','13:00:00',8.08),('16100','2013-06-25','13:05:00',8.12),('16100','2013-06-25','13:10:00',8.09),('16100','2013-06-25','13:15:00',5.37),('16100','2013-06-25','13:20:00',4.11),('16100','2013-06-25','13:25:00',6.47),('16100','2013-06-25','13:30:00',2.04),('16100','2013-06-25','13:35:00',4.62),('16100','2013-06-25','13:40:00',1.72),('16100','2013-06-25','13:45:00',1.44),('16100','2013-06-25','13:50:00',1.2),('16100','2013-06-25','13:55:00',1.71),('16100','2013-06-25','14:00:00',7.16),('16100','2013-06-25','14:05:00',7.89),('16100','2013-06-25','14:10:00',7.64),('16100','2013-06-25','14:15:00',7.6),('16100','2013-06-25','14:20:00',7.46),('16100','2013-06-25','14:25:00',7.37),('16100','2013-06-25','14:30:00',7.32),('16100','2013-06-25','14:35:00',7.36),('16100','2013-06-25','14:40:00',7.35),('16100','2013-06-25','14:45:00',7.3),('16100','2013-06-25','14:50:00',7.26),('16100','2013-06-25','14:55:00',7.22),('16100','2013-06-25','15:00:00',7.15),('16100','2013-06-25','15:05:00',7.08),('16100','2013-06-25','15:10:00',7.03),('16100','2013-06-25','15:15:00',6.9),('16100','2013-06-25','15:20:00',6.86),('16100','2013-06-25','15:25:00',6.7),('16100','2013-06-25','15:30:00',6.62),('16100','2013-06-25','15:35:00',6.55),('16100','2013-06-25','15:40:00',6.45),('16100','2013-06-25','15:45:00',6.35),('16100','2013-06-25','15:50:00',6.3),('16100','2013-06-25','15:55:00',6.2),('16100','2013-06-25','16:00:00',6.11),('16100','2013-06-25','16:05:00',5.97),('16100','2013-06-25','16:10:00',5.85),('16100','2013-06-25','16:15:00',5.76),('16100','2013-06-25','16:20:00',5.67),('16100','2013-06-25','16:25:00',5.49),('16100','2013-06-25','16:30:00',5.4),('16100','2013-06-25','16:35:00',5.25),('16100','2013-06-25','16:40:00',5.16),('16100','2013-06-25','16:45:00',5.06),('16100','2013-06-25','16:50:00',4.91),('16100','2013-06-25','16:55:00',4.78),('16100','2013-06-25','17:00:00',4.65),('16100','2013-06-25','17:05:00',4.53),('16100','2013-06-25','17:10:00',4.38),('16100','2013-06-25','17:15:00',4.18),('16100','2013-06-25','17:20:00',4.05),('16100','2013-06-25','17:25:00',3.94),('16100','2013-06-25','17:30:00',3.79),('16100','2013-06-25','17:35:00',3.65),('16100','2013-06-25','17:40:00',3.5),('16100','2013-06-25','17:45:00',3.31),('16100','2013-06-25','17:50:00',3.18),('16100','2013-06-25','17:55:00',2.97),('16100','2013-06-25','18:00:00',2.78),('16100','2013-06-25','18:05:00',2.65),('16100','2013-06-25','18:10:00',2.46),('16100','2013-06-25','18:15:00',2.16),('16100','2013-06-25','18:20:00',2.41),('16100','2013-06-25','18:25:00',1.75),('16100','2013-06-25','18:30:00',1.17),('16100','2013-06-25','19:05:00',1.02),('16100','2013-06-25','19:10:00',1),('16100','2013-06-24','08:00:00',1.7),('16100','2013-06-24','08:05:00',1.73),('16100','2013-06-24','08:10:00',1.79),('16100','2013-06-24','08:15:00',1.19),('16100','2013-06-24','08:40:00',2.46),('16100','2013-06-24','08:45:00',3.21),('16100','2013-06-24','08:50:00',3.32),('16100','2013-06-24','08:55:00',3.43),('16100','2013-06-24','09:00:00',3.55),('16100','2013-06-24','09:05:00',3.74),('16100','2013-06-24','09:10:00',3.9),('16100','2013-06-24','09:15:00',4.12),('16100','2013-06-24','09:20:00',4.48),('16100','2013-06-24','09:25:00',4.9),('16100','2013-06-24','09:30:00',5.05),('16100','2013-06-24','09:35:00',5.08),('16100','2013-06-24','09:40:00',5.2),('16100','2013-06-24','09:45:00',5.29),('16100','2013-06-24','09:50:00',5.5),('16100','2013-06-24','09:55:00',5.81),('16100','2013-06-24','10:00:00',6.17),('16100','2013-06-24','10:05:00',6.24),('16100','2013-06-24','10:10:00',6.35),('16100','2013-06-24','10:15:00',4.14),('16100','2013-06-24','10:20:00',5.18),('16100','2013-06-24','10:25:00',1.56),('16100','2013-06-24','10:30:00',1.55),('16100','2013-06-24','10:35:00',1.44),('16100','2013-06-24','10:40:00',4.08),('16100','2013-06-24','10:45:00',6.57),('16100','2013-06-24','10:50:00',6.9),('16100','2013-06-24','10:55:00',2.1),('16100','2013-06-24','11:00:00',6.5),('16100','2013-06-24','11:05:00',7.31),('16100','2013-06-24','11:10:00',7.2),('16100','2013-06-24','11:15:00',7.27),('16100','2013-06-24','11:20:00',7.55),('16100','2013-06-24','11:25:00',7.72),('16100','2013-06-24','11:30:00',7.92),('16100','2013-06-24','11:35:00',6.55),('16100','2013-06-24','11:40:00',2.7),('16100','2013-06-24','11:45:00',6.22),('16100','2013-06-24','11:50:00',4.6),('16100','2013-06-24','11:55:00',2.92),('16100','2013-06-24','12:00:00',2.9),('16100','2013-06-24','12:05:00',8.49),('16100','2013-06-24','12:10:00',9.09),('16100','2013-06-24','12:15:00',8.51),('16100','2013-06-24','12:20:00',8.25),('16100','2013-06-24','12:25:00',3.54),('16100','2013-06-24','12:30:00',8.23),('16100','2013-06-24','12:35:00',8.17),('16100','2013-06-24','12:40:00',8.32),('16100','2013-06-24','12:45:00',5.39),('16100','2013-06-24','12:50:00',6.95),('16100','2013-06-24','12:55:00',3.46),('16100','2013-06-24','13:00:00',7.31),('16100','2013-06-24','13:05:00',8.34),('16100','2013-06-24','13:10:00',7.93),('16100','2013-06-24','13:15:00',8.06),('16100','2013-06-24','13:20:00',8.23),('16100','2013-06-24','13:25:00',8.04),('16100','2013-06-24','13:30:00',7.93),('16100','2013-06-24','13:35:00',7.86),('16100','2013-06-24','13:40:00',7.88),('16100','2013-06-24','13:45:00',7.92),('16100','2013-06-24','13:50:00',7.82),('16100','2013-06-24','13:55:00',7.79),('16100','2013-06-24','14:00:00',7.79),('16100','2013-06-24','14:05:00',7.58),('16100','2013-06-24','14:10:00',7.61),('16100','2013-06-24','14:15:00',7.57),('16100','2013-06-24','14:20:00',7.6),('16100','2013-06-24','14:25:00',7.58),('16100','2013-06-24','14:30:00',7.54),('16100','2013-06-24','14:35:00',7.43),('16100','2013-06-24','14:40:00',7.44),('16100','2013-06-24','14:45:00',7.37),('16100','2013-06-24','14:50:00',7.32),('16100','2013-06-24','14:55:00',7.23),('16100','2013-06-24','15:00:00',7.14),('16100','2013-06-24','15:05:00',7.1),('16100','2013-06-24','15:10:00',7.05),('16100','2013-06-24','15:15:00',6.93),('16100','2013-06-24','15:20:00',6.88),('16100','2013-06-24','15:25:00',6.79),('16100','2013-06-24','15:30:00',6.64),('16100','2013-06-24','15:35:00',6.5),('16100','2013-06-24','15:40:00',6.44),('16100','2013-06-24','15:45:00',6.36),('16100','2013-06-24','15:50:00',6.23),('16100','2013-06-24','15:55:00',6.14),('16100','2013-06-24','16:00:00',6.06),('16100','2013-06-24','16:05:00',5.96),('16100','2013-06-24','16:10:00',5.83),('16100','2013-06-24','16:15:00',5.73),('16100','2013-06-24','16:20:00',5.65),('16100','2013-06-24','16:25:00',5.47),('16100','2013-06-24','16:30:00',5.35),('16100','2013-06-24','16:35:00',5.24),('16100','2013-06-24','16:40:00',5.09),('16100','2013-06-24','16:45:00',4.98),('16100','2013-06-24','16:50:00',4.84),('16100','2013-06-24','16:55:00',4.75),('16100','2013-06-24','17:02:00',4.62),('16100','2013-06-24','17:05:00',4.46),('16100','2013-06-24','17:10:00',4.34),('16100','2013-06-24','17:15:00',4.19),('16100','2013-06-24','17:20:00',4.06),('16100','2013-06-24','17:25:00',3.89),('16100','2013-06-24','17:30:00',3.75),('16100','2013-06-24','17:35:00',3.59),('16100','2013-06-24','17:40:00',3.45),('16100','2013-06-24','17:45:00',3.28),('16100','2013-06-24','17:50:00',3.14),('16100','2013-06-24','17:55:00',3),('16100','2013-06-24','18:00:00',2.84),('16100','2013-06-24','18:05:00',2.64),('16100','2013-06-24','18:10:00',2.42),('16100','2013-06-24','18:15:00',2.21),('16100','2013-06-24','18:20:00',2.09),('16100','2013-06-24','18:25:00',1.96),('16100','2013-06-24','18:30:00',1.81),('16100','2013-06-24','18:35:00',1.65),('16100','2013-06-24','18:40:00',1.51),('16100','2013-06-24','18:45:00',1.35),('16100','2013-06-24','18:50:00',1.21),('16100','2013-06-24','18:55:00',1.09),('16100','2013-06-23','08:30:00',1.04),('16100','2013-06-23','08:35:00',1.44),('16100','2013-06-23','08:40:00',1.65),('16100','2013-06-23','08:45:00',3.29),('16100','2013-06-23','08:50:00',3.48),('16100','2013-06-23','08:55:00',3.18),('16100','2013-06-23','09:00:00',1.73),('16100','2013-06-23','09:05:00',4.53),('16100','2013-06-23','09:10:00',3.54),('16100','2013-06-23','09:15:00',2.49),('16100','2013-06-23','09:20:00',4.08),('16100','2013-06-23','09:25:00',4.63),('16100','2013-06-23','09:35:00',2.74),('16100','2013-06-23','09:40:00',5.66),('16100','2013-06-23','09:45:00',5.67),('16100','2013-06-23','09:50:00',5.72),('16100','2013-06-23','09:55:00',6.1),('16100','2013-06-23','10:00:00',3.44),('16100','2013-06-23','10:05:00',4.94),('16100','2013-06-23','10:10:00',3.67),('16100','2013-06-23','10:15:00',4.87),('16100','2013-06-23','10:20:00',5.58),('16100','2013-06-23','10:25:00',6.26),('16100','2013-06-23','10:30:00',4.02),('16100','2013-06-23','10:35:00',6.83),('16100','2013-06-23','10:40:00',4.12),('16100','2013-06-23','10:45:00',7.19),('16100','2013-06-23','10:50:00',6.79),('16100','2013-06-23','10:55:00',7.4),('16100','2013-06-23','11:00:00',3.18),('16100','2013-06-23','11:05:00',5.12),('16100','2013-06-23','11:10:00',3.04),('16100','2013-06-23','11:15:00',6.42),('16100','2013-06-23','11:20:00',3.89),('16100','2013-06-23','11:25:00',3.18),('16100','2013-06-23','11:30:00',3.71),('16100','2013-06-23','11:35:00',2.34),('16100','2013-06-23','11:40:00',3.33),('16100','2013-06-23','11:45:00',3.77),('16100','2013-06-23','11:50:00',4.45),('16100','2013-06-23','11:55:00',8.84),('16100','2013-06-23','12:00:00',8.07),('16100','2013-06-23','12:05:00',3.45),('16100','2013-06-23','12:10:00',7.61),('16100','2013-06-23','12:15:00',5.45),('16100','2013-06-23','12:20:00',6.62),('16100','2013-06-23','12:25:00',3.34),('16100','2013-06-23','12:30:00',2.1),('16100','2013-06-23','12:35:00',2.41),('16100','2013-06-23','12:40:00',8.87),('16100','2013-06-23','12:45:00',2.94),('16100','2013-06-23','12:50:00',4.75),('16100','2013-06-23','12:55:00',5.63),('16100','2013-06-23','13:00:00',5.19),('16100','2013-06-23','13:05:00',3.75),('16100','2013-06-23','13:10:00',4.95),('16100','2013-06-23','13:15:00',6.38),('16100','2013-06-23','13:20:00',7.11),('16100','2013-06-23','13:25:00',8.95),('16100','2013-06-23','13:30:00',8.66),('16100','2013-06-23','13:35:00',8.83),('16100','2013-06-23','13:40:00',8.33),('16100','2013-06-23','13:45:00',8.46),('16100','2013-06-23','13:50:00',8.27),('16100','2013-06-23','13:55:00',6.79),('16100','2013-06-23','14:00:00',8.22),('16100','2013-06-23','14:05:00',8.08),('16100','2013-06-23','14:10:00',8.05),('16100','2013-06-23','14:15:00',8.09),('16100','2013-06-23','14:20:00',7.29),('16100','2013-06-23','14:25:00',6.43),('16100','2013-06-23','14:30:00',7.33),('16100','2013-06-23','14:35:00',6.76),('16100','2013-06-23','14:40:00',7.45),('16100','2013-06-23','14:45:00',8.5),('16100','2013-06-23','14:50:00',4.77),('16100','2013-06-23','14:55:00',3.66),('16100','2013-06-23','15:00:00',3.77),('16100','2013-06-23','15:05:00',2.53),('16100','2013-06-23','15:10:00',5.74),('16100','2013-06-23','15:15:00',7.6),('16100','2013-06-23','15:20:00',3.91),('16100','2013-06-23','15:25:00',2.05),('16100','2013-06-23','15:30:00',6.47),('16100','2013-06-23','15:35:00',6.02),('16100','2013-06-23','15:40:00',6.16),('16100','2013-06-23','15:45:00',4.15),('16100','2013-06-23','15:50:00',4.63),('16100','2013-06-23','15:55:00',3.22),('16100','2013-06-23','16:00:00',6.46),('16100','2013-06-23','16:05:00',2.97),('16100','2013-06-23','16:10:00',5.74),('16100','2013-06-23','16:15:00',7.08),('16100','2013-06-23','16:20:00',5.4),('16100','2013-06-23','16:25:00',4.92),('16100','2013-06-23','16:30:00',3.74),('16100','2013-06-23','16:35:00',5.01),('16100','2013-06-23','16:40:00',4.29),('16100','2013-06-23','16:45:00',2.09),('16100','2013-06-23','16:50:00',1.9),('16100','2013-06-23','16:55:00',1.74),('16100','2013-06-23','17:00:00',2.02),('16100','2013-06-23','17:05:00',4.67),('16100','2013-06-23','17:10:00',3.47),('16100','2013-06-23','17:15:00',2.73),('16100','2013-06-23','17:20:00',2.37),('16100','2013-06-23','17:25:00',3.24),('16100','2013-06-23','17:30:00',1.93),('16100','2013-06-23','17:35:00',2),('16100','2013-06-23','17:40:00',1.68),('16100','2013-06-23','17:45:00',2.77),('16100','2013-06-23','17:50:00',1.48),('16100','2013-06-23','17:55:00',1.63),('16100','2013-06-23','18:00:00',3.1),('16100','2013-06-23','18:05:00',2.42),('16100','2013-06-23','18:10:00',1.77),('16100','2013-06-23','18:15:00',1.15),('16100','2013-06-23','18:20:00',2.69),('16100','2013-06-23','18:25:00',2.25),('16100','2013-06-23','18:30:00',2),('16100','2013-06-23','18:35:00',1.68),('16100','2013-06-23','18:40:00',1.7),('16100','2013-06-23','18:45:00',1.49),('16100','2013-06-23','18:50:00',1.34),('16100','2013-06-23','18:55:00',1.23),('16100','2013-06-23','19:00:00',1.04),('16100','2013-06-22','08:35:00',1.04),('16100','2013-06-22','08:40:00',1.27),('16100','2013-06-22','08:45:00',1.34),('16100','2013-06-22','08:50:00',1.9),('16100','2013-06-22','08:55:00',1.87),('16100','2013-06-22','09:00:00',1.52),('16100','2013-06-22','09:05:00',1.1),('16100','2013-06-22','09:10:00',1.93),('16100','2013-06-22','09:15:00',3.44),('16100','2013-06-22','09:20:00',4.51),('16100','2013-06-22','09:25:00',4.64),('16100','2013-06-22','09:30:00',4.72),('16100','2013-06-22','09:35:00',3.1),('16100','2013-06-22','09:40:00',2.23),('16100','2013-06-22','09:45:00',2.97),('16100','2013-06-22','09:50:00',5.45),('16100','2013-06-22','09:55:00',5.39),('16100','2013-06-22','10:00:00',5.42),('16100','2013-06-22','10:05:00',5.6),('16100','2013-06-22','10:10:00',2.49),('16100','2013-06-22','10:15:00',5.86),('16100','2013-06-22','10:20:00',6.11),('16100','2013-06-22','10:25:00',6.02),('16100','2013-06-22','10:30:00',6.13),('16100','2013-06-22','10:35:00',6.19),('16100','2013-06-22','10:40:00',6.22),('16100','2013-06-22','10:45:00',6.33),('16100','2013-06-22','10:50:00',6.37),('16100','2013-06-22','10:55:00',6.48),('16100','2013-06-22','11:00:00',6.62),('16100','2013-06-22','11:05:00',6.62),('16100','2013-06-22','11:10:00',6.74),('16100','2013-06-22','11:15:00',6.74),('16100','2013-06-22','11:20:00',6.7),('16100','2013-06-22','11:25:00',6.86),('16100','2013-06-22','11:30:00',6.98),('16100','2013-06-22','11:35:00',7.1),('16100','2013-06-22','11:40:00',7.17),('16100','2013-06-22','11:45:00',7.17),('16100','2013-06-22','11:50:00',7.21),('16100','2013-06-22','11:55:00',7.2),('16100','2013-06-22','12:00:00',7.28),('16100','2013-06-22','12:05:00',7.28),('16100','2013-06-22','12:10:00',7.52),('16100','2013-06-22','12:15:00',7.56),('16100','2013-06-22','12:20:00',7.57),('16100','2013-06-22','12:25:00',7.61),('16100','2013-06-22','12:30:00',7.61),('16100','2013-06-22','12:35:00',7.62),('16100','2013-06-22','12:40:00',7.72),('16100','2013-06-22','12:45:00',7.74),('16100','2013-06-22','12:50:00',7.73),('16100','2013-06-22','12:55:00',7.76),('16100','2013-06-22','13:00:00',7.8),('16100','2013-06-22','13:05:00',7.81),('16100','2013-06-22','13:10:00',7.78),('16100','2013-06-22','13:15:00',7.76),('16100','2013-06-22','13:20:00',7.78),('16100','2013-06-22','13:25:00',7.77),('16100','2013-06-22','13:30:00',7.79),('16100','2013-06-22','13:35:00',7.84),('16100','2013-06-22','13:40:00',7.84),('16100','2013-06-22','13:45:00',7.83),('16100','2013-06-22','13:50:00',7.84),('16100','2013-06-22','13:55:00',7.88),('16100','2013-06-22','14:00:00',7.86),('16100','2013-06-22','14:05:00',7.77),('16100','2013-06-22','14:10:00',7.64),('16100','2013-06-22','14:15:00',7.72),('16100','2013-06-22','14:20:00',7.65),('16100','2013-06-22','14:25:00',7.62),('16100','2013-06-22','14:30:00',7.63),('16100','2013-06-22','14:35:00',7.6),('16100','2013-06-22','14:40:00',7.52),('16100','2013-06-22','14:45:00',7.5),('16100','2013-06-22','14:50:00',7.44),('16100','2013-06-22','14:55:00',7.42),('16100','2013-06-22','15:00:00',7.31),('16100','2013-06-22','15:05:00',7.2),('16100','2013-06-22','15:10:00',7.11),('16100','2013-06-22','15:15:00',7.05),('16100','2013-06-22','15:20:00',6.87),('16100','2013-06-22','15:25:00',6.85),('16100','2013-06-22','15:30:00',6.8),('16100','2013-06-22','15:35:00',6.64),('16100','2013-06-22','15:40:00',6.59),('16100','2013-06-22','15:45:00',6.49),('16100','2013-06-22','15:50:00',6.4),('16100','2013-06-22','15:55:00',6.29),('16100','2013-06-22','16:00:00',6.21),('16100','2013-06-22','16:05:00',6.12),('16100','2013-06-22','16:10:00',5.99),('16100','2013-06-22','16:15:00',5.9),('16100','2013-06-22','16:20:00',5.73),('16100','2013-06-22','16:25:00',5.6),('16100','2013-06-22','16:30:00',5.47),('16100','2013-06-22','16:35:00',5.35),('16100','2013-06-22','16:40:00',5.24),('16100','2013-06-22','16:45:00',5.11),('16100','2013-06-22','16:50:00',5.03),('16100','2013-06-22','16:55:00',4.9),('16100','2013-06-22','17:00:00',4.8),('16100','2013-06-22','17:05:00',4.69),('16100','2013-06-22','17:10:00',3.79),('16100','2013-06-22','17:15:00',4.45),('16100','2013-06-22','17:20:00',4.25),('16100','2013-06-22','17:25:00',4.1),('16100','2013-06-22','17:30:00',3.95),('16100','2013-06-22','17:35:00',3.77),('16100','2013-06-22','17:40:00',3.62),('16100','2013-06-22','17:45:00',3.36),('16100','2013-06-22','17:50:00',3.33),('16100','2013-06-22','17:55:00',3.14),('16100','2013-06-22','18:00:00',2.93),('16100','2013-06-22','18:05:00',2.77),('16100','2013-06-22','18:10:00',2.58),('16100','2013-06-22','18:15:00',2.29),('16100','2013-06-22','18:20:00',2.19),('16100','2013-06-22','18:25:00',2.06),('16100','2013-06-22','18:30:00',1.89),('16100','2013-06-22','18:35:00',1.73),('16100','2013-06-22','18:40:00',1.55),('16100','2013-06-22','18:45:00',1.41),('16100','2013-06-22','18:50:00',1.28),('16100','2013-06-22','18:55:00',1.16),('16100','2013-06-22','19:00:00',1.12),('16100','2013-06-21','07:50:00',1.02),('16100','2013-06-21','07:55:00',1.22),('16100','2013-06-21','08:00:00',1.41),('16100','2013-06-21','08:05:00',1.53),('16100','2013-06-21','08:10:00',1.72),('16100','2013-06-21','08:15:00',1.95),('16100','2013-06-21','08:20:00',2.09),('16100','2013-06-21','08:25:00',2.23),('16100','2013-06-21','08:30:00',2.43),('16100','2013-06-21','08:35:00',2.59),('16100','2013-06-21','08:40:00',2.74),('16100','2013-06-21','08:45:00',2.95),('16100','2013-06-21','08:50:00',3.09),('16100','2013-06-21','08:55:00',3.18),('16100','2013-06-21','09:00:00',3.21),('16100','2013-06-21','09:05:00',3.42),('16100','2013-06-21','09:10:00',3.59),('16100','2013-06-21','09:15:00',3.85),('16100','2013-06-21','09:20:00',4.19),('16100','2013-06-21','09:25:00',4.31),('16100','2013-06-21','09:30:00',4.43),('16100','2013-06-21','09:35:00',4.57),('16100','2013-06-21','09:40:00',4.69),('16100','2013-06-21','09:45:00',4.82),('16100','2013-06-21','09:50:00',4.95),('16100','2013-06-21','09:55:00',5.06),('16100','2013-06-21','10:00:00',5.23),('16100','2013-06-21','10:05:00',5.39),('16100','2013-06-21','10:10:00',5.56),('16100','2013-06-21','10:15:00',5.68),('16100','2013-06-21','10:20:00',5.84),('16100','2013-06-21','10:25:00',5.87),('16100','2013-06-21','10:30:00',5.95),('16100','2013-06-21','10:35:00',6.01),('16100','2013-06-21','10:40:00',6.14),('16100','2013-06-21','10:45:00',6.22),('16100','2013-06-21','10:50:00',6.31),('16100','2013-06-21','10:55:00',6.46),('16100','2013-06-21','11:00:00',6.56),('16100','2013-06-21','11:05:00',6.6),('16100','2013-06-21','11:10:00',6.65),('16100','2013-06-21','11:15:00',6.76),('16100','2013-06-21','11:20:00',6.82),('16100','2013-06-21','11:25:00',6.87),('16100','2013-06-21','11:30:00',6.93),('16100','2013-06-21','11:35:00',6.97),('16100','2013-06-21','11:40:00',7.06),('16100','2013-06-21','11:45:00',7.05),('16100','2013-06-21','11:50:00',7.13),('16100','2013-06-21','11:55:00',7.03),('16100','2013-06-21','12:00:00',7.22),('16100','2013-06-21','12:05:00',7.25),('16100','2013-06-21','12:10:00',7.28),('16100','2013-06-21','12:15:00',7.37),('16100','2013-06-21','12:20:00',7.38),('16100','2013-06-21','12:25:00',7.46),('16100','2013-06-21','12:30:00',7.44),('16100','2013-06-21','12:35:00',6.79),('16100','2013-06-21','12:40:00',7.09),('16100','2013-06-21','12:45:00',7.34),('16100','2013-06-21','12:50:00',7.36),('16100','2013-06-21','12:55:00',7.31),('16100','2013-06-21','13:00:00',7.16),('16100','2013-06-21','13:05:00',7.37),('16100','2013-06-21','13:10:00',7.24),('16100','2013-06-21','13:15:00',7.64),('16100','2013-06-21','13:20:00',7.61),('16100','2013-06-21','13:25:00',7.68),('16100','2013-06-21','13:30:00',7.76),('16100','2013-06-21','13:35:00',7.47),('16100','2013-06-21','13:40:00',6.86),('16100','2013-06-21','13:45:00',7.69),('16100','2013-06-21','13:50:00',6.94),('16100','2013-06-21','13:55:00',5.94),('16100','2013-06-21','14:00:00',7.96),('16100','2013-06-21','14:05:00',8.03),('16100','2013-06-21','14:10:00',7.82),('16100','2013-06-21','14:15:00',6.05),('16100','2013-06-21','14:20:00',4.25),('16100','2013-06-21','14:25:00',6.35),('16100','2013-06-21','14:30:00',4.28),('16100','2013-06-21','14:35:00',3.21),('16100','2013-06-21','14:40:00',4.39),('16100','2013-06-21','14:45:00',5.66),('16100','2013-06-21','14:50:00',7.12),('16100','2013-06-21','14:55:00',6.85),('16100','2013-06-21','15:00:00',7.25),('16100','2013-06-21','15:05:00',6.45),('16100','2013-06-21','15:10:00',7.22),('16100','2013-06-21','15:15:00',7.07),('16100','2013-06-21','15:20:00',7.12),('16100','2013-06-21','15:25:00',6.57),('16100','2013-06-21','15:30:00',6.17),('16100','2013-06-21','15:35:00',4.99),('16100','2013-06-21','15:40:00',4.12),('16100','2013-06-21','15:45:00',3.27),('16100','2013-06-21','15:50:00',3.14),('16100','2013-06-21','15:55:00',3.92),('16100','2013-06-21','16:00:00',2.52),('16100','2013-06-21','16:05:00',2),('16100','2013-06-21','16:10:00',2.18),('16100','2013-06-21','16:15:00',2.78),('16100','2013-06-21','16:20:00',2.32),('16100','2013-06-21','16:25:00',2.06),('16100','2013-06-21','16:30:00',1.81),('16100','2013-06-21','16:35:00',1.58),('16100','2013-06-21','16:40:00',1.42),('16100','2013-06-21','16:45:00',1.39),('16100','2013-06-21','16:50:00',1.68),('16100','2013-06-21','16:55:00',2.51),('16100','2013-06-21','17:00:00',3.74),('16100','2013-06-21','17:05:00',4.18),('16100','2013-06-21','17:10:00',4.76),('16100','2013-06-21','17:15:00',3.87),('16100','2013-06-21','17:20:00',4.23),('16100','2013-06-21','17:25:00',4.41),('16100','2013-06-21','17:30:00',3.89),('16100','2013-06-21','17:35:00',3.76),('16100','2013-06-21','17:40:00',3.44),('16100','2013-06-21','17:45:00',3.34),('16100','2013-06-21','17:50:00',2.81),('16100','2013-06-21','17:55:00',2.71),('16100','2013-06-21','18:00:00',2.51),('16100','2013-06-21','18:05:00',1.91),('16100','2013-06-21','18:10:00',1.2),('16100','2013-06-21','18:15:00',1.23),('16100','2013-06-21','18:20:00',1.07),('16100','2013-06-20','07:50:00',1.06),('16100','2013-06-20','08:00:00',1.43),('16100','2013-06-20','08:05:00',1.59),('16100','2013-06-20','08:10:00',1.76),('16100','2013-06-20','08:15:00',1.93),('16100','2013-06-20','08:20:00',2.06),('16100','2013-06-20','08:25:00',2.2),('16100','2013-06-20','08:30:00',2.35),('16100','2013-06-20','08:35:00',2.49),('16100','2013-06-20','08:40:00',2.63),('16100','2013-06-20','08:45:00',2.81),('16100','2013-06-20','08:50:00',2.37),('16100','2013-06-20','08:55:00',2.46),('16100','2013-06-20','09:00:00',3.18),('16100','2013-06-20','09:05:00',3.37),('16100','2013-06-20','09:10:00',3.49),('16100','2013-06-20','09:15:00',3.77),('16100','2013-06-20','09:20:00',4.05),('16100','2013-06-20','09:25:00',4.21),('16100','2013-06-20','09:30:00',4.33),('16100','2013-06-20','09:35:00',4.43),('16100','2013-06-20','09:40:00',3.61),('16100','2013-06-20','09:45:00',4.63),('16100','2013-06-20','09:50:00',4.72),('16100','2013-06-20','09:55:00',4.85),('16100','2013-06-20','10:00:00',4.99),('16100','2013-06-20','10:05:00',5.11),('16100','2013-06-20','10:10:00',5.28),('16100','2013-06-20','10:15:00',5.33),('16100','2013-06-20','10:20:00',5.32),('16100','2013-06-20','10:25:00',5.42),('16100','2013-06-20','10:30:00',5.5),('16100','2013-06-20','10:35:00',5.53),('16100','2013-06-20','10:40:00',5.62),('16100','2013-06-20','10:45:00',5.61),('16100','2013-06-20','10:50:00',5.78),('16100','2013-06-20','10:55:00',6.02),('16100','2013-06-20','11:00:00',6.07),('16100','2013-06-20','11:05:00',5.98),('16100','2013-06-20','11:10:00',6.06),('16100','2013-06-20','11:15:00',6.14),('16100','2013-06-20','11:20:00',6.27),('16100','2013-06-20','11:25:00',6.38),('16100','2013-06-20','11:30:00',6.49),('16100','2013-06-20','11:35:00',6.58),('16100','2013-06-20','11:40:00',6.65),('16100','2013-06-20','11:45:00',6.77),('16100','2013-06-20','11:50:00',6.82),('16100','2013-06-20','11:55:00',6.81),('16100','2013-06-20','12:00:00',6.79),('16100','2013-06-20','12:05:00',6.84),('16100','2013-06-20','12:10:00',6.92),('16100','2013-06-20','12:15:00',7.02),('16100','2013-06-20','12:20:00',7.05),('16100','2013-06-20','12:25:00',7.04),('16100','2013-06-20','12:30:00',7.17),('16100','2013-06-20','12:35:00',7.15),('16100','2013-06-20','12:40:00',7.22),('16100','2013-06-20','12:45:00',7.23),('16100','2013-06-20','12:50:00',7.19),('16100','2013-06-20','12:55:00',7.21),('16100','2013-06-20','13:00:00',7.31),('16100','2013-06-20','13:05:00',7.31),('16100','2013-06-20','13:10:00',7.23),('16100','2013-06-20','13:15:00',7.29),('16100','2013-06-20','13:20:00',7.32),('16100','2013-06-20','13:25:00',7.33),('16100','2013-06-20','13:30:00',7.34),('16100','2013-06-20','13:35:00',7.37),('16100','2013-06-20','13:40:00',7.39),('16100','2013-06-20','13:45:00',7.37),('16100','2013-06-20','13:50:00',7.42),('16100','2013-06-20','13:55:00',7.46),('16100','2013-06-20','14:00:00',7.4),('16100','2013-06-20','14:05:00',7.33),('16100','2013-06-20','14:10:00',7.22),('16100','2013-06-20','14:15:00',7.28),('16100','2013-06-20','14:20:00',7.3),('16100','2013-06-20','14:25:00',7.25),('16100','2013-06-20','14:30:00',7.23),('16100','2013-06-20','14:35:00',7.15),('16100','2013-06-20','14:40:00',7.09),('16100','2013-06-20','14:45:00',7.05),('16100','2013-06-20','14:50:00',6.95),('16100','2013-06-20','14:55:00',6.91),('16100','2013-06-20','15:00:00',6.9),('16100','2013-06-20','15:05:00',6.86),('16100','2013-06-20','15:10:00',6.81),('16100','2013-06-20','15:15:00',6.74),('16100','2013-06-20','15:20:00',6.64),('16100','2013-06-20','15:25:00',6.54),('16100','2013-06-20','15:30:00',6.44),('16100','2013-06-20','15:35:00',6.39),('16100','2013-06-20','15:40:00',6.29),('16100','2013-06-20','15:45:00',6.23),('16100','2013-06-20','15:50:00',6.15),('16100','2013-06-20','15:55:00',6.01),('16100','2013-06-20','16:00:00',5.91),('16100','2013-06-20','16:05:00',5.82),('16100','2013-06-20','16:10:00',5.71),('16100','2013-06-20','16:15:00',5.59),('16100','2013-06-20','16:20:00',5.46),('16100','2013-06-20','16:25:00',5.31),('16100','2013-06-20','16:30:00',5.24),('16100','2013-06-20','16:35:00',5.12),('16100','2013-06-20','16:40:00',5),('16100','2013-06-20','16:45:00',4.86),('16100','2013-06-20','16:50:00',4.74),('16100','2013-06-20','16:55:00',4.59),('16100','2013-06-20','17:00:00',4.46),('16100','2013-06-20','17:05:00',4.37),('16100','2013-06-20','17:10:00',4.25),('16100','2013-06-20','17:15:00',4.06),('16100','2013-06-20','17:20:00',3.95),('16100','2013-06-20','17:25:00',3.79),('16100','2013-06-20','17:30:00',3.64),('16100','2013-06-20','17:35:00',3.49),('16100','2013-06-20','17:40:00',3.33),('16100','2013-06-20','17:45:00',3.17),('16100','2013-06-20','17:50:00',3.04),('16100','2013-06-20','17:55:00',2.9),('16100','2013-06-20','18:00:00',2.72),('16100','2013-06-20','18:05:00',2.55),('16100','2013-06-20','18:10:00',2.32),('16100','2013-06-20','18:15:00',2.13),('16100','2013-06-20','18:20:00',2.02),('16100','2013-06-20','18:25:00',1.86),('16100','2013-06-20','18:30:00',1.71),('16100','2013-06-20','18:35:00',1.56),('16100','2013-06-20','18:40:00',1.41),('16100','2013-06-20','18:45:00',1.29),('16100','2013-06-20','18:50:00',1.15),('16100','2013-06-20','18:55:00',1.02),('16100','2014-04-03','08:50:00',1.02),('16100','2014-04-03','08:55:00',1.23),('16100','2014-04-03','09:00:00',1.51),('16100','2014-04-03','09:05:00',1.69),('16100','2014-04-03','09:10:00',2.03),('16100','2014-04-03','09:15:00',1.51),('16100','2014-04-03','10:25:00',1.02),('16100','2014-04-03','10:55:00',1.02),('16100','2014-04-03','11:00:00',1.8),('16100','2014-04-03','11:05:00',1.82),('16100','2014-04-03','12:35:00',1.14),('16100','2014-04-03','12:50:00',1.38),('16100','2014-04-03','12:55:00',1.38),('16100','2014-04-03','13:00:00',1.67),('16100','2014-04-03','13:05:00',4.64),('16100','2014-04-03','13:10:00',3.16),('16100','2014-04-03','13:15:00',2.38),('16100','2014-04-03','13:20:00',4.43),('16100','2014-04-03','13:25:00',3.75),('16100','2014-04-03','13:30:00',4.6),('16100','2014-04-03','13:35:00',5.71),('16100','2014-04-03','13:40:00',5.31),('16100','2014-04-03','13:45:00',6.39),('16100','2014-04-03','13:50:00',6.27),('16100','2014-04-03','13:55:00',3.29),('16100','2014-04-03','14:00:00',2.88),('16100','2014-04-03','14:05:00',8.2),('16100','2014-04-03','14:10:00',5.73),('16100','2014-04-03','14:15:00',5.72),('16100','2014-04-03','14:20:00',3.44),('16100','2014-04-03','14:25:00',2.41),('16100','2014-04-03','14:30:00',4.25),('16100','2014-04-03','14:35:00',3.96),('16100','2014-04-03','14:40:00',6.7),('16100','2014-04-03','14:45:00',1.96),('16100','2014-04-03','14:50:00',2.52),('16100','2014-04-03','14:55:00',4.9),('16100','2014-04-03','15:00:00',5.87),('16100','2014-04-03','15:05:00',3.03),('16100','2014-04-03','15:10:00',2.48),('16100','2014-04-03','15:15:00',2.27),('16100','2014-04-03','15:20:00',4.5),('16100','2014-04-03','15:25:00',4.16),('16100','2014-04-03','15:30:00',1.7),('16100','2014-04-03','15:35:00',1.74),('16100','2014-04-03','15:40:00',1.98),('16100','2014-04-03','15:45:00',2.29),('16100','2014-04-03','15:50:00',2.46),('16100','2014-04-03','15:55:00',3.67),('16100','2014-04-03','16:00:00',6.12),('16100','2014-04-03','16:05:00',5.64),('16100','2014-04-03','16:10:00',4.39),('16100','2014-04-03','16:15:00',6.74),('16100','2014-04-03','16:20:00',6.06),('16100','2014-04-03','16:25:00',2.6),('16100','2014-04-03','16:30:00',2.89),('16100','2014-04-03','16:35:00',4.87),('16100','2014-04-03','16:40:00',4.62),('16100','2014-04-03','16:45:00',2.6),('16100','2014-04-03','16:50:00',2.8),('16100','2014-04-03','16:55:00',3.74),('16100','2014-04-03','17:00:00',2.27),('16100','2014-04-03','17:05:00',1.84),('16100','2014-04-03','17:10:00',1.72),('16100','2014-04-03','17:15:00',2.55),('16100','2014-04-03','17:20:00',2.07),('16100','2014-04-03','17:25:00',3.75),('16100','2014-04-03','17:30:00',3.11),('16100','2014-04-03','17:35:00',2.8),('16100','2014-04-03','17:40:00',2.13),('16100','2014-04-03','17:45:00',1.25),('16100','2014-04-03','17:50:00',2.5),('16100','2014-04-03','17:55:00',2.07),('16100','2014-04-03','18:05:00',1.37),('16100','2014-04-03','18:10:00',1.26),('16100','2013-06-19','07:50:00',1.05),('16100','2013-06-19','07:55:00',1.23),('16100','2013-06-19','08:00:00',1.4),('16100','2013-06-19','08:05:00',1.58),('16100','2013-06-19','08:10:00',1.74),('16100','2013-06-19','08:15:00',1.89),('16100','2013-06-19','08:20:00',2.02),('16100','2013-06-19','08:25:00',2.2),('16100','2013-06-19','08:30:00',2.38),('16100','2013-06-19','08:35:00',2.52),('16100','2013-06-19','08:40:00',2.66),('16100','2013-06-19','08:45:00',2.9),('16100','2013-06-19','08:50:00',3.06),('16100','2013-06-19','08:55:00',3.2),('16100','2013-06-19','09:00:00',3.32),('16100','2013-06-19','09:05:00',3.49),('16100','2013-06-19','09:10:00',3.62),('16100','2013-06-19','09:15:00',3.89),('16100','2013-06-19','09:20:00',4.13),('16100','2013-06-19','09:25:00',4.24),('16100','2013-06-19','09:30:00',4.36),('16100','2013-06-19','09:35:00',4.54),('16100','2013-06-19','09:40:00',4.65),('16100','2013-06-19','09:45:00',4.8),('16100','2013-06-19','09:50:00',4.89),('16100','2013-06-19','09:55:00',5.01),('16100','2013-06-19','10:00:00',5.09),('16100','2013-06-19','10:05:00',5.22),('16100','2013-06-19','10:10:00',5.35),('16100','2013-06-19','10:15:00',5.43),('16100','2013-06-19','10:20:00',5.53),('16100','2013-06-19','10:25:00',5.64),('16100','2013-06-19','10:30:00',5.76),('16100','2013-06-19','10:35:00',5.88),('16100','2013-06-19','10:40:00',5.94),('16100','2013-06-19','10:45:00',6),('16100','2013-06-19','10:50:00',6.09),('16100','2013-06-19','10:55:00',6.16),('16100','2013-06-19','11:00:00',6.23),('16100','2013-06-19','11:05:00',6.29),('16100','2013-06-19','11:10:00',6.32),('16100','2013-06-19','11:15:00',6.37),('16100','2013-06-19','11:20:00',6.42),('16100','2013-06-19','11:25:00',5.23),('16100','2013-06-19','11:30:00',6.5),('16100','2013-06-19','11:35:00',6.59),('16100','2013-06-19','11:40:00',6.71),('16100','2013-06-19','11:45:00',6.76),('16100','2013-06-19','11:50:00',6.78),('16100','2013-06-19','11:55:00',6.72),('16100','2013-06-19','12:00:00',6.74),('16100','2013-06-19','12:05:00',6.8),('16100','2013-06-19','12:10:00',6.92),('16100','2013-06-19','12:15:00',7.03),('16100','2013-06-19','12:20:00',6.91),('16100','2013-06-19','12:25:00',6.97),('16100','2013-06-19','12:30:00',7.06),('16100','2013-06-19','12:35:00',7.13),('16100','2013-06-19','12:40:00',7.14),('16100','2013-06-19','12:45:00',7.05),('16100','2013-06-19','12:50:00',6.93),('16100','2013-06-19','12:55:00',6.96),('16100','2013-06-19','13:00:00',6.89),('16100','2013-06-19','13:05:00',7.1),('16100','2013-06-19','13:10:00',7.03),('16100','2013-06-19','13:15:00',7.34),('16100','2013-06-19','13:20:00',7.32),('16100','2013-06-19','13:25:00',7.26),('16100','2013-06-19','13:30:00',7.24),('16100','2013-06-19','13:35:00',7.44),('16100','2013-06-19','13:40:00',7.47),('16100','2013-06-19','13:45:00',7.53),('16100','2013-06-19','13:50:00',7.55),('16100','2013-06-19','13:55:00',7.56),('16100','2013-06-19','14:00:00',7.54),('16100','2013-06-19','14:05:00',7.51),('16100','2013-06-19','14:10:00',7.39),('16100','2013-06-19','14:15:00',7.42),('16100','2013-06-19','14:20:00',7.42),('16100','2013-06-19','14:25:00',7.37),('16100','2013-06-19','14:30:00',7.37),('16100','2013-06-19','14:35:00',7.33),('16100','2013-06-19','14:40:00',7.3),('16100','2013-06-19','14:45:00',7.22),('16100','2013-06-19','14:50:00',7.16),('16100','2013-06-19','14:55:00',7.12),('16100','2013-06-19','15:00:00',7),('16100','2013-06-19','15:05:00',6.91),('16100','2013-06-19','15:10:00',6.82),('16100','2013-06-19','15:15:00',6.78),('16100','2013-06-19','15:20:00',6.75),('16100','2013-06-19','15:25:00',6.64),('16100','2013-06-19','15:30:00',6.5),('16100','2013-06-19','15:35:00',6.41),('16100','2013-06-19','15:40:00',6.36),('16100','2013-06-19','15:45:00',6.25),('16100','2013-06-19','15:50:00',6.17),('16100','2013-06-19','15:55:00',6.06),('16100','2013-06-19','16:00:00',5.95),('16100','2013-06-19','16:05:00',5.84),('16100','2013-06-19','16:10:00',5.82),('16100','2013-06-19','16:15:00',5.68),('16100','2013-06-19','16:20:00',5.58),('16100','2013-06-19','16:25:00',5.41),('16100','2013-06-19','16:30:00',5.31),('16100','2013-06-19','16:35:00',5.19),('16100','2013-06-19','16:40:00',5.08),('16100','2013-06-19','16:45:00',4.95),('16100','2013-06-19','16:50:00',4.82),('16100','2013-06-19','16:55:00',4.7),('16100','2013-06-19','17:00:00',4.59),('16100','2013-06-19','17:05:00',4.46),('16100','2013-06-19','17:10:00',4.31),('16100','2013-06-19','17:15:00',4.14),('16100','2013-06-19','17:20:00',3.99),('16100','2013-06-19','17:25:00',3.85),('16100','2013-06-19','17:30:00',3.72),('16100','2013-06-19','17:35:00',3.57),('16100','2013-06-19','17:40:00',3.4),('16100','2013-06-19','17:45:00',3.25),('16100','2013-06-19','17:50:00',3.13),('16100','2013-06-19','17:55:00',2.98),('16100','2013-06-19','18:00:00',2.8),('16100','2013-06-19','18:05:00',2.63),('16100','2013-06-19','18:10:00',2.41),('16100','2013-06-19','18:15:00',2.19),('16100','2013-06-19','18:20:00',2.07),('16100','2013-06-19','18:25:00',1.91),('16100','2013-06-19','18:30:00',1.75),('16100','2013-06-19','18:35:00',1.6),('16100','2013-06-19','18:40:00',1.44),('16100','2013-06-19','18:45:00',1.3),('16100','2013-06-19','18:50:00',1.17),('16100','2013-06-19','18:55:00',1.02),('16100','2013-06-18','07:50:00',1.03),('16100','2013-06-18','07:55:00',1.24),('16100','2013-06-18','08:00:00',1.41),('16100','2013-06-18','08:05:00',1.59),('16100','2013-06-18','08:10:00',1.77),('16100','2013-06-18','08:15:00',1.95),('16100','2013-06-18','08:20:00',2.08),('16100','2013-06-18','08:25:00',2.22),('16100','2013-06-18','08:30:00',2.37),('16100','2013-06-18','08:35:00',2.5),('16100','2013-06-18','08:40:00',2.64),('16100','2013-06-18','08:45:00',2.84),('16100','2013-06-18','08:50:00',2.97),('16100','2013-06-18','08:55:00',3.12),('16100','2013-06-18','09:00:00',3.25),('16100','2013-06-18','09:05:00',3.39),('16100','2013-06-18','09:10:00',3.55),('16100','2013-06-18','09:15:00',3.8),('16100','2013-06-18','09:20:00',4.04),('16100','2013-06-18','09:25:00',4.16),('16100','2013-06-18','09:30:00',4.28),('16100','2013-06-18','09:35:00',4.39),('16100','2013-06-18','09:40:00',4.52),('16100','2013-06-18','09:45:00',4.63),('16100','2013-06-18','09:50:00',4.72),('16100','2013-06-18','09:55:00',4.82),('16100','2013-06-18','10:00:00',4.98),('16100','2013-06-18','10:05:00',5.1),('16100','2013-06-18','10:10:00',5.22),('16100','2013-06-18','10:15:00',5.32),('16100','2013-06-18','10:20:00',5.41),('16100','2013-06-18','10:25:00',5.48),('16100','2013-06-18','10:30:00',5.56),('16100','2013-06-18','10:35:00',5.63),('16100','2013-06-18','10:40:00',5.67),('16100','2013-06-18','10:45:00',5.76),('16100','2013-06-18','10:50:00',5.84),('16100','2013-06-18','10:55:00',5.91),('16100','2013-06-18','11:00:00',5.97),('16100','2013-06-18','11:05:00',6.03),('16100','2013-06-18','11:10:00',6.07),('16100','2013-06-18','11:15:00',6.17),('16100','2013-06-18','11:20:00',6.15),('16100','2013-06-18','11:25:00',6.32),('16100','2013-06-18','11:30:00',6.38),('16100','2013-06-18','11:35:00',6.52),('16100','2013-06-18','11:40:00',6.45),('16100','2013-06-18','11:45:00',6.47),('16100','2013-06-18','11:50:00',6.65),('16100','2013-06-18','11:55:00',6.71),('16100','2013-06-18','12:00:00',6.75),('16100','2013-06-18','12:05:00',6.96),('16100','2013-06-18','12:10:00',6.91),('16100','2013-06-18','12:15:00',6.88),('16100','2013-06-18','12:20:00',7.08),('16100','2013-06-18','12:25:00',7.1),('16100','2013-06-18','12:30:00',7.05),('16100','2013-06-18','12:35:00',7.22),('16100','2013-06-18','12:40:00',7.16),('16100','2013-06-18','12:45:00',7.2),('16100','2013-06-18','12:50:00',7.22),('16100','2013-06-18','12:55:00',7.23),('16100','2013-06-18','13:00:00',7.2),('16100','2013-06-18','13:05:00',7.25),('16100','2013-06-18','13:10:00',7.3),('16100','2013-06-18','13:15:00',7.34),('16100','2013-06-18','13:20:00',7.36),('16100','2013-06-18','13:25:00',7.38),('16100','2013-06-18','13:30:00',7.38),('16100','2013-06-18','13:35:00',7.37),('16100','2013-06-18','13:40:00',7.34),('16100','2013-06-18','13:45:00',7.36),('16100','2013-06-18','13:50:00',7.41),('16100','2013-06-18','13:55:00',7.4),('16100','2013-06-18','14:00:00',7.37),('16100','2013-06-18','14:05:00',7.32),('16100','2013-06-18','14:10:00',7.18),('16100','2013-06-18','14:15:00',7.27),('16100','2013-06-18','14:20:00',7.25),('16100','2013-06-18','14:25:00',7.15),('16100','2013-06-18','14:30:00',7.1),('16100','2013-06-18','14:35:00',7.03),('16100','2013-06-18','14:40:00',6.99),('16100','2013-06-18','14:45:00',6.93),('16100','2013-06-18','14:50:00',6.88),('16100','2013-06-18','14:55:00',6.84),('16100','2013-06-18','15:00:00',6.73),('16100','2013-06-18','15:05:00',6.64),('16100','2013-06-18','15:10:00',6.59),('16100','2013-06-18','15:15:00',6.5),('16100','2013-06-18','15:20:00',6.43),('16100','2013-06-18','15:25:00',6.36),('16100','2013-06-18','15:30:00',6.23),('16100','2013-06-18','15:35:00',6.14),('16100','2013-06-18','15:40:00',6.08),('16100','2013-06-18','15:45:00',6.01),('16100','2013-06-18','15:50:00',5.95),('16100','2013-06-18','15:55:00',5.83),('16100','2013-06-18','16:00:00',5.71),('16100','2013-06-18','16:05:00',5.62),('16100','2013-06-18','16:10:00',5.54),('16100','2013-06-18','16:15:00',5.45),('16100','2013-06-18','16:20:00',5.32),('16100','2013-06-18','16:25:00',5.16),('16100','2013-06-18','16:30:00',5.05),('16100','2013-06-18','16:35:00',4.98),('16100','2013-06-18','16:40:00',4.87),('16100','2013-06-18','16:45:00',4.76),('16100','2013-06-18','16:50:00',4.65),('16100','2013-06-18','16:55:00',4.53),('16100','2013-06-18','17:00:00',4.43),('16100','2013-06-18','17:05:00',4.28),('16100','2013-06-18','17:10:00',4.12),('16100','2013-06-18','17:15:00',3.92),('16100','2013-06-18','17:20:00',3.83),('16100','2013-06-18','17:25:00',3.7),('16100','2013-06-18','17:30:00',3.55),('16100','2013-06-18','17:35:00',3.41),('16100','2013-06-18','17:40:00',3.29),('16100','2013-06-18','17:45:00',3.12),('16100','2013-06-18','17:50:00',2.97),('16100','2013-06-18','17:55:00',2.85),('16100','2013-06-18','18:00:00',2.68),('16100','2013-06-18','18:05:00',2.49),('16100','2013-06-18','18:10:00',2.26),('16100','2013-06-18','18:15:00',2.09),('16100','2013-06-18','18:20:00',1.99),('16100','2013-06-18','18:25:00',1.85),('16100','2013-06-18','18:30:00',1.7),('16100','2013-06-18','18:35:00',1.55),('16100','2013-06-18','18:40:00',1.41),('16100','2013-06-18','18:45:00',1.27),('16100','2013-06-18','18:50:00',1.12),('16100','2013-06-17','07:55:00',1.21),('16100','2013-06-17','08:00:00',1.37),('16100','2013-06-17','08:05:00',1.54),('16100','2013-06-17','08:10:00',1.72),('16100','2013-06-17','08:15:00',1.88),('16100','2013-06-17','08:20:00',2.01),('16100','2013-06-17','08:25:00',2.16),('16100','2013-06-17','08:30:00',2.33),('16100','2013-06-17','08:35:00',2.47),('16100','2013-06-17','08:40:00',2.62),('16100','2013-06-17','08:45:00',2.82),('16100','2013-06-17','08:50:00',2.96),('16100','2013-06-17','08:55:00',3.1),('16100','2013-06-17','09:00:00',3.23),('16100','2013-06-17','09:05:00',3.4),('16100','2013-06-17','09:10:00',3.55),('16100','2013-06-17','09:15:00',3.82),('16100','2013-06-17','09:20:00',4.05),('16100','2013-06-17','09:25:00',4.16),('16100','2013-06-17','09:30:00',4.25),('16100','2013-06-17','09:35:00',4.4),('16100','2013-06-17','09:40:00',4.49),('16100','2013-06-17','09:45:00',4.61),('16100','2013-06-17','09:50:00',4.7),('16100','2013-06-17','09:55:00',4.8),('16100','2013-06-17','10:00:00',4.93),('16100','2013-06-17','10:05:00',5.06),('16100','2013-06-17','10:10:00',5.17),('16100','2013-06-17','10:15:00',5.27),('16100','2013-06-17','10:20:00',5.37),('16100','2013-06-17','10:25:00',5.51),('16100','2013-06-17','10:30:00',5.57),('16100','2013-06-17','10:35:00',5.66),('16100','2013-06-17','10:40:00',5.77),('16100','2013-06-17','10:45:00',5.86),('16100','2013-06-17','10:50:00',5.94),('16100','2013-06-17','10:55:00',6.01),('16100','2013-06-17','11:00:00',6.12),('16100','2013-06-17','11:05:00',6.14),('16100','2013-06-17','11:10:00',6.19),('16100','2013-06-17','11:15:00',6.29),('16100','2013-06-17','11:20:00',6.33),('16100','2013-06-17','11:25:00',6.37),('16100','2013-06-17','11:30:00',6.45),('16100','2013-06-17','11:35:00',6.47),('16100','2013-06-17','11:40:00',6.49),('16100','2013-06-17','11:45:00',6.58),('16100','2013-06-17','11:50:00',6.54),('16100','2013-06-17','11:55:00',6.52),('16100','2013-06-17','12:00:00',6.59),('16100','2013-06-17','12:05:00',6.56),('16100','2013-06-17','12:10:00',6.58),('16100','2013-06-17','12:15:00',6.54),('16100','2013-06-17','12:20:00',6.5),('16100','2013-06-17','12:25:00',6.66),('16100','2013-06-17','12:30:00',6.83),('16100','2013-06-17','12:35:00',6.84),('16100','2013-06-17','12:40:00',6.9),('16100','2013-06-17','12:45:00',6.77),('16100','2013-06-17','12:50:00',6.94),('16100','2013-06-17','12:55:00',6.79),('16100','2013-06-17','13:00:00',6.55),('16100','2013-06-17','13:05:00',6.4),('16100','2013-06-17','13:10:00',7.13),('16100','2013-06-17','13:15:00',7.19),('16100','2013-06-17','13:20:00',5.5),('16100','2013-06-17','13:25:00',7.21),('16100','2013-06-17','13:30:00',6.36),('16100','2013-06-17','13:35:00',6.04),('16100','2013-06-17','13:40:00',7.11),('16100','2013-06-17','13:45:00',7.21),('16100','2013-06-17','13:50:00',7.15),('16100','2013-06-17','13:55:00',7.28),('16100','2013-06-17','14:00:00',7.21),('16100','2013-06-17','14:05:00',7.27),('16100','2013-06-17','14:10:00',7.21),('16100','2013-06-17','14:15:00',7.17),('16100','2013-06-17','14:20:00',7.25),('16100','2013-06-17','14:25:00',7.01),('16100','2013-06-17','14:30:00',7.14),('16100','2013-06-17','14:35:00',7.04),('16100','2013-06-17','14:40:00',4.46),('16100','2013-06-17','14:45:00',6.67),('16100','2013-06-17','14:50:00',7.08),('16100','2013-06-17','14:55:00',7),('16100','2013-06-17','15:00:00',6.87),('16100','2013-06-17','15:05:00',6.71),('16100','2013-06-17','15:10:00',6.67),('16100','2013-06-17','15:15:00',6.6),('16100','2013-06-17','15:20:00',6.43),('16100','2013-06-17','15:25:00',6.32),('16100','2013-06-17','15:30:00',6.19),('16100','2013-06-17','15:35:00',6.14),('16100','2013-06-17','15:40:00',6.09),('16100','2013-06-17','15:45:00',6.02),('16100','2013-06-17','15:50:00',5.96),('16100','2013-06-17','15:55:00',5.86),('16100','2013-06-17','16:00:00',5.81),('16100','2013-06-17','16:05:00',5.81),('16100','2013-06-17','16:10:00',5.73),('16100','2013-06-17','16:15:00',5.17),('16100','2013-06-17','16:20:00',5.62),('16100','2013-06-17','16:25:00',5.38),('16100','2013-06-17','16:30:00',5.08),('16100','2013-06-17','16:35:00',3.67),('16100','2013-06-17','16:40:00',3.63),('16100','2013-06-17','16:45:00',4.83),('16100','2013-06-17','16:50:00',4.74),('16100','2013-06-17','16:55:00',4.5),('16100','2013-06-17','17:00:00',4.48),('16100','2013-06-17','17:05:00',4.34),('16100','2013-06-17','17:10:00',4.17),('16100','2013-06-17','17:15:00',4.01),('16100','2013-06-17','17:20:00',3.89),('16100','2013-06-17','17:25:00',3.75),('16100','2013-06-17','17:30:00',3.59),('16100','2013-06-17','17:35:00',3.44),('16100','2013-06-17','17:40:00',3.26),('16100','2013-06-17','17:45:00',3.1),('16100','2013-06-17','17:50:00',2.97),('16100','2013-06-17','17:55:00',2.82),('16100','2013-06-17','18:00:00',2.68),('16100','2013-06-17','18:05:00',2.52),('16100','2013-06-17','18:10:00',2.31),('16100','2013-06-17','18:15:00',2.09),('16100','2013-06-17','18:20:00',2.03),('16100','2013-06-17','18:25:00',1.9),('16100','2013-06-17','18:30:00',1.75),('16100','2013-06-17','18:35:00',1.59),('16100','2013-06-17','18:40:00',1.45),('16100','2013-06-17','18:45:00',1.31),('16100','2013-06-17','18:50:00',1.17),('16100','2013-06-17','18:55:00',1.04),('16100','2013-06-16','07:50:00',1.09),('16100','2013-06-16','07:55:00',1.29),('16100','2013-06-16','08:00:00',1.48),('16100','2013-06-16','08:05:00',1.66),('16100','2013-06-16','08:10:00',1.84),('16100','2013-06-16','08:15:00',2.01),('16100','2013-06-16','08:20:00',2.15),('16100','2013-06-16','08:25:00',2.31),('16100','2013-06-16','08:30:00',2.49),('16100','2013-06-16','08:35:00',2.64),('16100','2013-06-16','08:40:00',2.81),('16100','2013-06-16','08:45:00',2.99),('16100','2013-06-16','08:50:00',3.13),('16100','2013-06-16','08:55:00',3.25),('16100','2013-06-16','09:00:00',3.36),('16100','2013-06-16','09:05:00',3.52),('16100','2013-06-16','09:10:00',3.71),('16100','2013-06-16','09:15:00',4.01),('16100','2013-06-16','09:20:00',4.25),('16100','2013-06-16','09:25:00',4.38),('16100','2013-06-16','09:30:00',4.52),('16100','2013-06-16','09:35:00',4.64),('16100','2013-06-16','09:40:00',4.75),('16100','2013-06-16','09:45:00',4.88),('16100','2013-06-16','09:50:00',4.98),('16100','2013-06-16','09:55:00',5.08),('16100','2013-06-16','10:00:00',5.22),('16100','2013-06-16','10:05:00',5.34),('16100','2013-06-16','10:10:00',5.48),('16100','2013-06-16','10:15:00',5.57),('16100','2013-06-16','10:20:00',5.67),('16100','2013-06-16','10:25:00',5.76),('16100','2013-06-16','10:30:00',5.85),('16100','2013-06-16','10:35:00',5.93),('16100','2013-06-16','10:40:00',5.98),('16100','2013-06-16','10:45:00',6.05),('16100','2013-06-16','10:50:00',6.17),('16100','2013-06-16','10:55:00',6.25),('16100','2013-06-16','11:00:00',6.35),('16100','2013-06-16','11:05:00',6.39),('16100','2013-06-16','11:10:00',6.48),('16100','2013-06-16','11:15:00',6.5),('16100','2013-06-16','11:20:00',6.58),('16100','2013-06-16','11:25:00',6.63),('16100','2013-06-16','11:30:00',6.69),('16100','2013-06-16','11:35:00',6.74),('16100','2013-06-16','11:40:00',6.78),('16100','2013-06-16','11:45:00',6.77),('16100','2013-06-16','11:50:00',6.8),('16100','2013-06-16','11:55:00',6.77),('16100','2013-06-16','12:00:00',6.93),('16100','2013-06-16','12:05:00',6.94),('16100','2013-06-16','12:10:00',7.11),('16100','2013-06-16','12:15:00',7.13),('16100','2013-06-16','12:20:00',7.24),('16100','2013-06-16','12:25:00',7.36),('16100','2013-06-16','12:30:00',7.3),('16100','2013-06-16','12:35:00',7.31),('16100','2013-06-16','12:40:00',7.37),('16100','2013-06-16','12:45:00',7.38),('16100','2013-06-16','12:50:00',7.44),('16100','2013-06-16','12:55:00',7.45),('16100','2013-06-16','13:00:00',7.47),('16100','2013-06-16','13:05:00',7.47),('16100','2013-06-16','13:10:00',7.51),('16100','2013-06-16','13:15:00',7.44),('16100','2013-06-16','13:20:00',7.43),('16100','2013-06-16','13:25:00',7.39),('16100','2013-06-16','13:30:00',7.4),('16100','2013-06-16','13:35:00',7.36),('16100','2013-06-16','13:40:00',7.36),('16100','2013-06-16','13:45:00',7.34),('16100','2013-06-16','13:50:00',7.28),('16100','2013-06-16','13:55:00',7.3),('16100','2013-06-16','14:00:00',7.31),('16100','2013-06-16','14:05:00',7.24),('16100','2013-06-16','14:10:00',7.13),('16100','2013-06-16','14:15:00',7.22),('16100','2013-06-16','14:20:00',7.2),('16100','2013-06-16','14:25:00',7.19),('16100','2013-06-16','14:30:00',7.12),('16100','2013-06-16','14:35:00',7.04),('16100','2013-06-16','14:40:00',7.02),('16100','2013-06-16','14:45:00',6.94),('16100','2013-06-16','14:50:00',6.88),('16100','2013-06-16','14:55:00',6.86),('16100','2013-06-16','15:00:00',6.78),('16100','2013-06-16','15:05:00',6.71),('16100','2013-06-16','15:10:00',6.65),('16100','2013-06-16','15:15:00',6.6),('16100','2013-06-16','15:20:00',6.52),('16100','2013-06-16','15:25:00',6.44),('16100','2013-06-16','15:30:00',6.37),('16100','2013-06-16','15:35:00',6.32),('16100','2013-06-16','15:40:00',6.22),('16100','2013-06-16','15:45:00',6.15),('16100','2013-06-16','15:50:00',6.07),('16100','2013-06-16','15:55:00',5.99),('16100','2013-06-16','16:00:00',5.87),('16100','2013-06-16','16:05:00',5.75),('16100','2013-06-16','16:10:00',5.65),('16100','2013-06-16','16:15:00',5.56),('16100','2013-06-16','16:20:00',5.44),('16100','2013-06-16','16:25:00',5.26),('16100','2013-06-16','16:30:00',5.24),('16100','2013-06-16','16:35:00',5.11),('16100','2013-06-16','16:40:00',4.98),('16100','2013-06-16','16:45:00',4.86),('16100','2013-06-16','16:50:00',4.75),('16100','2013-06-16','16:55:00',4.65),('16100','2013-06-16','17:00:00',4.53),('16100','2013-06-16','17:05:00',4.4),('16100','2013-06-16','17:10:00',4.24),('16100','2013-06-16','17:15:00',4.08),('16100','2013-06-16','17:20:00',3.97),('16100','2013-06-16','17:25:00',3.87),('16100','2013-06-16','17:30:00',3.73),('16100','2013-06-16','17:35:00',3.6),('16100','2013-06-16','17:40:00',3.44),('16100','2013-06-16','17:45:00',3.29),('16100','2013-06-16','17:50:00',3.17),('16100','2013-06-16','17:55:00',3.02),('16100','2013-06-16','18:00:00',2.84),('16100','2013-06-16','18:05:00',2.67),('16100','2013-06-16','18:10:00',2.44),('16100','2013-06-16','18:15:00',2.21),('16100','2013-06-16','18:20:00',2.13),('16100','2013-06-16','18:25:00',2),('16100','2013-06-16','18:30:00',1.85),('16100','2013-06-16','18:35:00',1.62),('16100','2013-06-16','18:40:00',1.54),('16100','2013-06-16','18:45:00',1.41),('16100','2013-06-16','18:50:00',1.3),('16100','2013-06-16','18:55:00',1.2),('16100','2013-06-16','19:00:00',1.06),('16100','2013-06-15','07:50:00',1.08),('16100','2013-06-15','07:55:00',1.31),('16100','2013-06-15','08:00:00',1.49),('16100','2013-06-15','08:05:00',1.69),('16100','2013-06-15','08:10:00',1.89),('16100','2013-06-15','08:15:00',2.06),('16100','2013-06-15','08:20:00',2.19),('16100','2013-06-15','08:25:00',2.36),('16100','2013-06-15','08:30:00',2.55),('16100','2013-06-15','08:35:00',2.69),('16100','2013-06-15','08:40:00',2.83),('16100','2013-06-15','08:45:00',3),('16100','2013-06-15','08:50:00',3.17),('16100','2013-06-15','08:55:00',3.32),('16100','2013-06-15','09:00:00',3.45),('16100','2013-06-15','09:05:00',3.58),('16100','2013-06-15','09:10:00',3.77),('16100','2013-06-15','09:15:00',4.07),('16100','2013-06-15','09:20:00',4.29),('16100','2013-06-15','09:25:00',4.41),('16100','2013-06-15','09:30:00',4.57),('16100','2013-06-15','09:35:00',4.69),('16100','2013-06-15','09:40:00',4.8),('16100','2013-06-15','09:45:00',4.92),('16100','2013-06-15','09:50:00',4.98),('16100','2013-06-15','09:55:00',5.08),('16100','2013-06-15','10:00:00',5.21),('16100','2013-06-15','10:05:00',5.39),('16100','2013-06-15','10:10:00',5.5),('16100','2013-06-15','10:15:00',5.58),('16100','2013-06-15','10:20:00',5.67),('16100','2013-06-15','10:25:00',5.78),('16100','2013-06-15','10:30:00',5.9),('16100','2013-06-15','10:35:00',5.98),('16100','2013-06-15','10:40:00',6.06),('16100','2013-06-15','10:45:00',6.19),('16100','2013-06-15','10:50:00',6.24),('16100','2013-06-15','10:55:00',6.34),('16100','2013-06-15','11:00:00',6.47),('16100','2013-06-15','11:05:00',6.56),('16100','2013-06-15','11:10:00',6.72),('16100','2013-06-15','11:15:00',6.78),('16100','2013-06-15','11:20:00',6.82),('16100','2013-06-15','11:25:00',6.9),('16100','2013-06-15','11:30:00',6.95),('16100','2013-06-15','11:35:00',6.95),('16100','2013-06-15','11:40:00',7),('16100','2013-06-15','11:45:00',7.05),('16100','2013-06-15','11:50:00',7.06),('16100','2013-06-15','11:55:00',7.18),('16100','2013-06-15','12:00:00',7.18),('16100','2013-06-15','12:05:00',7.17),('16100','2013-06-15','12:10:00',7.23),('16100','2013-06-15','12:15:00',7.19),('16100','2013-06-15','12:20:00',7.3),('16100','2013-06-15','12:25:00',7.41),('16100','2013-06-15','12:30:00',7.44),('16100','2013-06-15','12:35:00',7.44),('16100','2013-06-15','12:40:00',7.52),('16100','2013-06-15','12:45:00',7.62),('16100','2013-06-15','12:50:00',7.6),('16100','2013-06-15','12:55:00',7.65),('16100','2013-06-15','13:00:00',7.7),('16100','2013-06-15','13:05:00',7.72),('16100','2013-06-15','13:10:00',7.63),('16100','2013-06-15','13:15:00',7.67),('16100','2013-06-15','13:20:00',7.71),('16100','2013-06-15','13:25:00',7.74),('16100','2013-06-15','13:30:00',7.73),('16100','2013-06-15','13:35:00',7.73),('16100','2013-06-15','13:40:00',7.71),('16100','2013-06-15','13:45:00',7.68),('16100','2013-06-15','13:50:00',7.64),('16100','2013-06-15','13:55:00',7.65),('16100','2013-06-15','14:00:00',7.64),('16100','2013-06-15','14:05:00',7.55),('16100','2013-06-15','14:10:00',7.38),('16100','2013-06-15','14:15:00',7.43),('16100','2013-06-15','14:20:00',7.38),('16100','2013-06-15','14:25:00',7.35),('16100','2013-06-15','14:30:00',7.31),('16100','2013-06-15','14:35:00',7.25),('16100','2013-06-15','14:40:00',7.19),('16100','2013-06-15','14:45:00',7.15),('16100','2013-06-15','14:50:00',7.12),('16100','2013-06-15','14:55:00',7.05),('16100','2013-06-15','15:00:00',7),('16100','2013-06-15','15:05:00',6.95),('16100','2013-06-15','15:10:00',6.91),('16100','2013-06-15','15:15:00',6.85),('16100','2013-06-15','15:20:00',6.74),('16100','2013-06-15','15:25:00',6.64),('16100','2013-06-15','15:30:00',6.55),('16100','2013-06-15','15:35:00',6.44),('16100','2013-06-15','15:40:00',6.35),('16100','2013-06-15','15:45:00',6.23),('16100','2013-06-15','15:50:00',6.14),('16100','2013-06-15','15:55:00',6.04),('16100','2013-06-15','16:00:00',6),('16100','2013-06-15','16:05:00',5.88),('16100','2013-06-15','16:10:00',5.75),('16100','2013-06-15','16:15:00',5.63),('16100','2013-06-15','16:20:00',5.5),('16100','2013-06-15','16:25:00',5.38),('16100','2013-06-15','16:30:00',5.28),('16100','2013-06-15','16:35:00',5.17),('16100','2013-06-15','16:40:00',5.05),('16100','2013-06-15','16:45:00',4.92),('16100','2013-06-15','16:50:00',4.8),('16100','2013-06-15','16:55:00',4.67),('16100','2013-06-15','17:00:00',4.53),('16100','2013-06-15','17:05:00',4.42),('16100','2013-06-15','17:10:00',4.28),('16100','2013-06-15','17:15:00',4.11),('16100','2013-06-15','17:20:00',3.97),('16100','2013-06-15','17:25:00',3.83),('16100','2013-06-15','17:30:00',3.69),('16100','2013-06-15','17:35:00',3.53),('16100','2013-06-15','17:40:00',3.36),('16100','2013-06-15','17:45:00',3.22),('16100','2013-06-15','17:50:00',3.08),('16100','2013-06-15','17:55:00',2.92),('16100','2013-06-15','18:00:00',2.75),('16100','2013-06-15','18:05:00',2.55),('16100','2013-06-15','18:10:00',2.34),('16100','2013-06-15','18:15:00',2.13),('16100','2013-06-15','18:20:00',2.03),('16100','2013-06-15','18:25:00',1.89),('16100','2013-06-15','18:30:00',1.73),('16100','2013-06-15','18:35:00',1.59),('16100','2013-06-15','18:40:00',1.43),('16100','2013-06-15','18:45:00',1.29),('16100','2013-06-15','18:50:00',1.17),('16100','2013-06-15','18:55:00',1.02),('16100','2013-06-14','07:50:00',1.12),('16100','2013-06-14','07:55:00',1.33),('16100','2013-06-14','08:00:00',1.47),('16100','2013-06-14','08:05:00',1.68),('16100','2013-06-14','08:10:00',1.86),('16100','2013-06-14','08:15:00',2.05),('16100','2013-06-14','08:20:00',2.18),('16100','2013-06-14','08:25:00',2.37),('16100','2013-06-14','08:30:00',2.52),('16100','2013-06-14','08:35:00',2.69),('16100','2013-06-14','08:40:00',2.91),('16100','2013-06-14','08:45:00',3.12),('16100','2013-06-14','08:50:00',3.41),('16100','2013-06-14','08:55:00',3.9),('16100','2013-06-14','09:00:00',4.14),('16100','2013-06-14','09:05:00',4.13),('16100','2013-06-14','09:10:00',4.52),('16100','2013-06-14','09:15:00',3.88),('16100','2013-06-14','09:20:00',3.05),('16100','2013-06-14','09:25:00',2.02),('16100','2013-06-14','09:30:00',4.3),('16100','2013-06-14','09:35:00',4.71),('16100','2013-06-14','09:40:00',4.85),('16100','2013-06-14','09:45:00',4.97),('16100','2013-06-14','09:50:00',5.07),('16100','2013-06-14','09:55:00',5.15),('16100','2013-06-14','10:00:00',5.34),('16100','2013-06-14','10:05:00',5.45),('16100','2013-06-14','10:10:00',5.55),('16100','2013-06-14','10:15:00',5.66),('16100','2013-06-14','10:20:00',5.74),('16100','2013-06-14','10:25:00',5.91),('16100','2013-06-14','10:30:00',6.01),('16100','2013-06-14','10:35:00',6.03),('16100','2013-06-14','10:40:00',6.11),('16100','2013-06-14','10:45:00',6.22),('16100','2013-06-14','10:50:00',6.37),('16100','2013-06-14','10:55:00',6.29),('16100','2013-06-14','11:00:00',6.45),('16100','2013-06-14','11:05:00',6.21),('16100','2013-06-14','11:10:00',6.73),('16100','2013-06-14','11:15:00',6.68),('16100','2013-06-14','11:20:00',6.93),('16100','2013-06-14','11:25:00',7),('16100','2013-06-14','11:30:00',7.04),('16100','2013-06-14','11:35:00',7.08),('16100','2013-06-14','11:40:00',7.17),('16100','2013-06-14','11:45:00',6.94),('16100','2013-06-14','11:50:00',7.12),('16100','2013-06-14','11:55:00',7.35),('16100','2013-06-14','12:00:00',7.23),('16100','2013-06-14','12:05:00',7.39),('16100','2013-06-14','12:10:00',7.46),('16100','2013-06-14','12:15:00',7.48),('16100','2013-06-14','12:20:00',7.48),('16100','2013-06-14','12:25:00',7.59),('16100','2013-06-14','12:30:00',7.58),('16100','2013-06-14','12:35:00',7.63),('16100','2013-06-14','12:40:00',7.63),('16100','2013-06-14','12:45:00',7.67),('16100','2013-06-14','12:50:00',7.69),('16100','2013-06-14','12:55:00',7.69),('16100','2013-06-14','13:00:00',7.65),('16100','2013-06-14','13:05:00',7.71),('16100','2013-06-14','13:10:00',7.71),('16100','2013-06-14','13:15:00',7.65),('16100','2013-06-14','13:20:00',7.68),('16100','2013-06-14','13:25:00',7.64),('16100','2013-06-14','13:30:00',7.63),('16100','2013-06-14','13:35:00',7.58),('16100','2013-06-14','13:40:00',7.52),('16100','2013-06-14','13:45:00',7.62),('16100','2013-06-14','13:50:00',7.53),('16100','2013-06-14','13:55:00',7.52),('16100','2013-06-14','14:00:00',7.5),('16100','2013-06-14','14:05:00',7.51),('16100','2013-06-14','14:10:00',7.31),('16100','2013-06-14','14:15:00',7.43),('16100','2013-06-14','14:20:00',7.41),('16100','2013-06-14','14:25:00',7.35),('16100','2013-06-14','14:30:00',7.34),('16100','2013-06-14','14:35:00',7.29),('16100','2013-06-14','14:40:00',7.24),('16100','2013-06-14','14:45:00',7.18),('16100','2013-06-14','14:50:00',7.16),('16100','2013-06-14','14:55:00',7.08),('16100','2013-06-14','15:00:00',7.01),('16100','2013-06-14','15:05:00',6.92),('16100','2013-06-14','15:10:00',6.85),('16100','2013-06-14','15:15:00',6.82),('16100','2013-06-14','15:20:00',6.75),('16100','2013-06-14','15:25:00',6.63),('16100','2013-06-14','15:30:00',6.52),('16100','2013-06-14','15:35:00',6.43),('16100','2013-06-14','15:40:00',6.34),('16100','2013-06-14','15:45:00',6.26),('16100','2013-06-14','15:50:00',6.16),('16100','2013-06-14','15:55:00',6.04),('16100','2013-06-14','16:00:00',5.96),('16100','2013-06-14','16:05:00',5.81),('16100','2013-06-14','16:10:00',5.73),('16100','2013-06-14','16:15:00',5.65),('16100','2013-06-14','16:20:00',5.53),('16100','2013-06-14','16:25:00',5.35),('16100','2013-06-14','16:30:00',5.25),('16100','2013-06-14','16:35:00',5.12),('16100','2013-06-14','16:40:00',4.99),('16100','2013-06-14','16:45:00',4.88),('16100','2013-06-14','16:50:00',4.74),('16100','2013-06-14','16:55:00',4.63),('16100','2013-06-14','17:00:00',4.5),('16100','2013-06-14','17:05:00',4.35),('16100','2013-06-14','17:10:00',4.23),('16100','2013-06-14','17:15:00',4.04),('16100','2013-06-14','17:20:00',3.89),('16100','2013-06-14','17:25:00',3.7),('16100','2013-06-14','17:30:00',3.61),('16100','2013-06-14','17:35:00',3.43),('16100','2013-06-14','17:40:00',3.28),('16100','2013-06-14','17:45:00',3.15),('16100','2013-06-14','17:50:00',3.01),('16100','2013-06-14','17:55:00',2.87),('16100','2013-06-14','18:00:00',2.67),('16100','2013-06-14','18:05:00',2.52),('16100','2013-06-14','18:10:00',2.29),('16100','2013-06-14','18:15:00',2.12),('16100','2013-06-14','18:20:00',2),('16100','2013-06-14','18:25:00',1.84),('16100','2013-06-14','18:30:00',1.7),('16100','2013-06-14','18:35:00',1.55),('16100','2013-06-14','18:40:00',1.42),('16100','2013-06-14','18:45:00',1.29),('16100','2013-06-14','18:50:00',1.16),('16100','2013-06-14','18:55:00',1.01),('16100','2013-06-13','07:45:00',1.02),('16100','2013-06-13','07:50:00',1.22),('16100','2013-06-13','07:55:00',1.41),('16100','2013-06-13','08:00:00',1.63),('16100','2013-06-13','08:05:00',1.83),('16100','2013-06-13','08:10:00',2.02),('16100','2013-06-13','08:15:00',2.22),('16100','2013-06-13','08:20:00',2.35),('16100','2013-06-13','08:25:00',2.53),('16100','2013-06-13','08:30:00',2.71),('16100','2013-06-13','08:35:00',2.86),('16100','2013-06-13','08:40:00',3.02),('16100','2013-06-13','08:45:00',3.24),('16100','2013-06-13','08:50:00',3.37),('16100','2013-06-13','08:55:00',3.52),('16100','2013-06-13','09:00:00',3.66),('16100','2013-06-13','09:05:00',3.79),('16100','2013-06-13','09:10:00',3.96),('16100','2013-06-13','09:15:00',4.27),('16100','2013-06-13','09:20:00',4.46),('16100','2013-06-13','09:25:00',4.56),('16100','2013-06-13','09:30:00',4.69),('16100','2013-06-13','09:35:00',4.88),('16100','2013-06-13','09:40:00',5.04),('16100','2013-06-13','09:45:00',5.17),('16100','2013-06-13','09:50:00',5.28),('16100','2013-06-13','09:55:00',5.37),('16100','2013-06-13','10:00:00',5.41),('16100','2013-06-13','10:05:00',5.6),('16100','2013-06-13','10:10:00',5.77),('16100','2013-06-13','10:15:00',5.88),('16100','2013-06-13','10:20:00',6.01),('16100','2013-06-13','10:25:00',6.17),('16100','2013-06-13','10:30:00',6.03),('16100','2013-06-13','10:35:00',6.35),('16100','2013-06-13','10:40:00',6.35),('16100','2013-06-13','10:45:00',6.37),('16100','2013-06-13','10:50:00',6.39),('16100','2013-06-13','10:55:00',6.51),('16100','2013-06-13','11:00:00',6.68),('16100','2013-06-13','11:05:00',6.81),('16100','2013-06-13','11:10:00',6.7),('16100','2013-06-13','11:15:00',6.79),('16100','2013-06-13','11:20:00',6.97),('16100','2013-06-13','11:25:00',7),('16100','2013-06-13','11:30:00',7.05),('16100','2013-06-13','11:35:00',7.1),('16100','2013-06-13','11:40:00',7.19),('16100','2013-06-13','11:45:00',7.22),('16100','2013-06-13','11:50:00',7.23),('16100','2013-06-13','11:55:00',7.18),('16100','2013-06-13','12:00:00',7.21),('16100','2013-06-13','12:05:00',7.33),('16100','2013-06-13','12:10:00',7.41),('16100','2013-06-13','12:15:00',7.41),('16100','2013-06-13','12:20:00',7.51),('16100','2013-06-13','12:25:00',7.45),('16100','2013-06-13','12:30:00',7.53),('16100','2013-06-13','12:35:00',7.59),('16100','2013-06-13','12:40:00',7.58),('16100','2013-06-13','12:45:00',7.55),('16100','2013-06-13','12:50:00',7.67),('16100','2013-06-13','12:55:00',7.68),('16100','2013-06-13','13:00:00',7.61),('16100','2013-06-13','13:05:00',7.59),('16100','2013-06-13','13:10:00',7.58),('16100','2013-06-13','13:15:00',7.62),('16100','2013-06-13','13:20:00',7.67),('16100','2013-06-13','13:25:00',7.68),('16100','2013-06-13','13:30:00',7.69),('16100','2013-06-13','13:35:00',7.67),('16100','2013-06-13','13:40:00',7.57),('16100','2013-06-13','13:45:00',7.62),('16100','2013-06-13','13:50:00',7.66),('16100','2013-06-13','13:55:00',7.67),('16100','2013-06-13','14:00:00',7.61),('16100','2013-06-13','14:05:00',7.45),('16100','2013-06-13','14:10:00',7.28),('16100','2013-06-13','14:15:00',7.48),('16100','2013-06-13','14:20:00',7.4),('16100','2013-06-13','14:25:00',7.34),('16100','2013-06-13','14:30:00',7.39),('16100','2013-06-13','14:35:00',7.38),('16100','2013-06-13','14:40:00',7.31),('16100','2013-06-13','14:45:00',7.24),('16100','2013-06-13','14:50:00',7.2),('16100','2013-06-13','14:55:00',7.1),('16100','2013-06-13','15:00:00',7.01),('16100','2013-06-13','15:05:00',6.97),('16100','2013-06-13','15:10:00',6.9),('16100','2013-06-13','15:15:00',6.83),('16100','2013-06-13','15:20:00',6.76),('16100','2013-06-13','15:25:00',6.77),('16100','2013-06-13','15:30:00',6.64),('16100','2013-06-13','15:35:00',6.59),('16100','2013-06-13','15:40:00',6.45),('16100','2013-06-13','15:45:00',6.35),('16100','2013-06-13','15:50:00',6.26),('16100','2013-06-13','15:55:00',6.22),('16100','2013-06-13','16:00:00',6.14),('16100','2013-06-13','16:05:00',5.97),('16100','2013-06-13','16:10:00',5.92),('16100','2013-06-13','16:15:00',5.82),('16100','2013-06-13','16:20:00',5.67),('16100','2013-06-13','16:25:00',5.57),('16100','2013-06-13','16:30:00',5.42),('16100','2013-06-13','16:35:00',5.3),('16100','2013-06-13','16:40:00',5.22),('16100','2013-06-13','16:45:00',5.1),('16100','2013-06-13','16:50:00',4.93),('16100','2013-06-13','16:55:00',4.78),('16100','2013-06-13','17:00:00',4.69),('16100','2013-06-13','17:05:00',4.38),('16100','2013-06-13','17:10:00',4.29),('16100','2013-06-13','17:15:00',4.14),('16100','2013-06-13','17:20:00',4),('16100','2013-06-13','17:25:00',3.78),('16100','2013-06-13','17:30:00',3.67),('16100','2013-06-13','17:35:00',3.65),('16100','2013-06-13','17:40:00',3.5),('16100','2013-06-13','17:45:00',3.34),('16100','2013-06-13','17:50:00',3.2),('16100','2013-06-13','17:55:00',3.04),('16100','2013-06-13','18:00:00',2.81),('16100','2013-06-13','18:05:00',2.68),('16100','2013-06-13','18:10:00',2.42),('16100','2013-06-13','18:15:00',2.21),('16100','2013-06-13','18:20:00',2.1),('16100','2013-06-13','18:25:00',1.97),('16100','2013-06-13','18:30:00',1.81),('16100','2013-06-13','18:35:00',1.64),('16100','2013-06-13','18:40:00',1.5),('16100','2013-06-13','18:45:00',1.36),('16100','2013-06-13','18:50:00',1.21),('16100','2013-06-13','18:55:00',1.06),('16100','2013-06-12','07:45:00',1.05),('16100','2013-06-12','07:50:00',1.26),('16100','2013-06-12','07:55:00',1.44),('16100','2013-06-12','08:00:00',1.66),('16100','2013-06-12','08:05:00',1.84),('16100','2013-06-12','08:10:00',2.05),('16100','2013-06-12','08:15:00',2.25),('16100','2013-06-12','08:20:00',2.39),('16100','2013-06-12','08:25:00',2.57),('16100','2013-06-12','08:30:00',2.74),('16100','2013-06-12','08:35:00',2.9),('16100','2013-06-12','08:40:00',3.07),('16100','2013-06-12','08:45:00',3.27),('16100','2013-06-12','08:50:00',3.44),('16100','2013-06-12','08:55:00',3.59),('16100','2013-06-12','09:00:00',3.73),('16100','2013-06-12','09:05:00',3.88),('16100','2013-06-12','09:10:00',4.1),('16100','2013-06-12','09:15:00',4.42),('16100','2013-06-12','09:20:00',4.61),('16100','2013-06-12','09:25:00',4.78),('16100','2013-06-12','09:30:00',4.9),('16100','2013-06-12','09:35:00',5.03),('16100','2013-06-12','09:40:00',5.11),('16100','2013-06-12','09:45:00',5.24),('16100','2013-06-12','09:50:00',5.38),('16100','2013-06-12','09:55:00',5.48),('16100','2013-06-12','10:00:00',5.64),('16100','2013-06-12','10:05:00',5.77),('16100','2013-06-12','10:10:00',5.93),('16100','2013-06-12','10:15:00',6.05),('16100','2013-06-12','10:20:00',6.15),('16100','2013-06-12','10:25:00',6.28),('16100','2013-06-12','10:30:00',6.34),('16100','2013-06-12','10:35:00',6.42),('16100','2013-06-12','10:40:00',6.49),('16100','2013-06-12','10:45:00',6.6),('16100','2013-06-12','10:50:00',6.7),('16100','2013-06-12','10:55:00',6.79),('16100','2013-06-12','11:00:00',6.87),('16100','2013-06-12','11:05:00',6.94),('16100','2013-06-12','11:10:00',7.02),('16100','2013-06-12','11:15:00',7.12),('16100','2013-06-12','11:20:00',7.19),('16100','2013-06-12','11:25:00',7.21),('16100','2013-06-12','11:30:00',7.33),('16100','2013-06-12','11:35:00',7.41),('16100','2013-06-12','11:40:00',7.46),('16100','2013-06-12','11:45:00',7.5),('16100','2013-06-12','11:50:00',7.56),('16100','2013-06-12','11:55:00',7.59),('16100','2013-06-12','12:00:00',7.59),('16100','2013-06-12','12:05:00',7.62),('16100','2013-06-12','12:10:00',7.72),('16100','2013-06-12','12:15:00',7.7),('16100','2013-06-12','12:20:00',7.72),('16100','2013-06-12','12:25:00',7.78),('16100','2013-06-12','12:30:00',7.83),('16100','2013-06-12','12:35:00',7.84),('16100','2013-06-12','12:40:00',7.83),('16100','2013-06-12','12:45:00',7.83),('16100','2013-06-12','12:50:00',7.93),('16100','2013-06-12','12:55:00',7.88),('16100','2013-06-12','13:00:00',7.85),('16100','2013-06-12','13:05:00',7.82),('16100','2013-06-12','13:10:00',7.86),('16100','2013-06-12','13:15:00',7.84),('16100','2013-06-12','13:20:00',7.88),('16100','2013-06-12','13:25:00',7.81),('16100','2013-06-12','13:30:00',7.78),('16100','2013-06-12','13:35:00',7.75),('16100','2013-06-12','13:40:00',7.81),('16100','2013-06-12','13:45:00',7.74),('16100','2013-06-12','13:50:00',7.7),('16100','2013-06-12','13:55:00',7.7),('16100','2013-06-12','14:00:00',7.67),('16100','2013-06-12','14:05:00',7.5),('16100','2013-06-12','14:10:00',7.27),('16100','2013-06-12','14:15:00',7.52),('16100','2013-06-12','14:20:00',7.45),('16100','2013-06-12','14:25:00',7.46),('16100','2013-06-12','14:30:00',5.6),('16100','2013-06-12','14:35:00',3.75),('16100','2013-06-12','14:40:00',7.83),('16100','2013-06-12','14:45:00',7.58),('16100','2013-06-12','14:50:00',6.94),('16100','2013-06-12','14:55:00',7.29),('16100','2013-06-12','15:00:00',7.06),('16100','2013-06-12','15:05:00',6.98),('16100','2013-06-12','15:10:00',6.91),('16100','2013-06-12','15:15:00',6.78),('16100','2013-06-12','15:20:00',6.74),('16100','2013-06-12','15:25:00',6.56),('16100','2013-06-12','15:30:00',6.48),('16100','2013-06-12','15:35:00',6.44),('16100','2013-06-12','15:40:00',6.38),('16100','2013-06-12','15:45:00',6.36),('16100','2013-06-12','15:50:00',6.18),('16100','2013-06-12','15:55:00',6.05),('16100','2013-06-12','16:00:00',5.95),('16100','2013-06-12','16:05:00',5.85),('16100','2013-06-12','16:10:00',5.74),('16100','2013-06-12','16:15:00',5.63),('16100','2013-06-12','16:20:00',5.57),('16100','2013-06-12','16:25:00',5.43),('16100','2013-06-12','16:30:00',5.44),('16100','2013-06-12','16:35:00',5.08),('16100','2013-06-12','16:40:00',4.99),('16100','2013-06-12','16:45:00',4.9),('16100','2013-06-12','16:50:00',4.87),('16100','2013-06-12','16:55:00',4.74),('16100','2013-06-12','17:00:00',4.56),('16100','2013-06-12','17:05:00',4.45),('16100','2013-06-12','17:10:00',4.33),('16100','2013-06-12','17:15:00',4.21),('16100','2013-06-12','17:20:00',4.04),('16100','2013-06-12','17:25:00',3.88),('16100','2013-06-12','17:30:00',3.71),('16100','2013-06-12','17:35:00',3.53),('16100','2013-06-12','17:40:00',3.34),('16100','2013-06-12','17:45:00',3.18),('16100','2013-06-12','17:50:00',3.07),('16100','2013-06-12','17:55:00',2.93),('16100','2013-06-12','18:00:00',2.76),('16100','2013-06-12','18:05:00',2.61),('16100','2013-06-12','18:10:00',2.37),('16100','2013-06-12','18:15:00',2.17),('16100','2013-06-12','18:20:00',2.06),('16100','2013-06-12','18:25:00',1.92),('16100','2013-06-12','18:30:00',1.75),('16100','2013-06-12','18:35:00',1.6),('16100','2013-06-12','18:40:00',1.45),('16100','2013-06-12','18:45:00',1.3),('16100','2013-06-12','18:50:00',1.16),('16100','2013-06-12','18:55:00',1.02),('16100','2013-06-11','07:45:00',1.05),('16100','2013-06-11','07:50:00',1.26),('16100','2013-06-11','07:55:00',1.47),('16100','2013-06-11','08:00:00',1.69),('16100','2013-06-11','08:05:00',1.89),('16100','2013-06-11','08:10:00',2.07),('16100','2013-06-11','08:15:00',1.61),('16100','2013-06-11','08:20:00',2.35),('16100','2013-06-11','08:25:00',2.58),('16100','2013-06-11','08:30:00',2.74),('16100','2013-06-11','08:35:00',2.89),('16100','2013-06-11','08:40:00',3.06),('16100','2013-06-11','08:45:00',3.26),('16100','2013-06-11','08:50:00',3.41),('16100','2013-06-11','08:55:00',3.59),('16100','2013-06-11','09:00:00',3.7),('16100','2013-06-11','09:05:00',3.87),('16100','2013-06-11','09:10:00',4.11),('16100','2013-06-11','09:15:00',4.42),('16100','2013-06-11','09:20:00',4.6),('16100','2013-06-11','09:25:00',4.74),('16100','2013-06-11','09:30:00',4.88),('16100','2013-06-11','09:35:00',5.01),('16100','2013-06-11','09:40:00',5.14),('16100','2013-06-11','09:45:00',5.23),('16100','2013-06-11','09:50:00',5.32),('16100','2013-06-11','09:55:00',5.45),('16100','2013-06-11','10:00:00',5.61),('16100','2013-06-11','10:05:00',5.75),('16100','2013-06-11','10:10:00',5.89),('16100','2013-06-11','10:15:00',6.02),('16100','2013-06-11','10:20:00',6.08),('16100','2013-06-11','10:25:00',6.16),('16100','2013-06-11','10:30:00',6.29),('16100','2013-06-11','10:35:00',6.42),('16100','2013-06-11','10:40:00',6.55),('16100','2013-06-11','10:45:00',6.64),('16100','2013-06-11','10:50:00',6.75),('16100','2013-06-11','10:55:00',6.79),('16100','2013-06-11','11:00:00',6.83),('16100','2013-06-11','11:05:00',6.96),('16100','2013-06-11','11:10:00',7.07),('16100','2013-06-11','11:15:00',7.14),('16100','2013-06-11','11:20:00',7.12),('16100','2013-06-11','11:25:00',7.22),('16100','2013-06-11','11:30:00',7.23),('16100','2013-06-11','11:35:00',7.34),('16100','2013-06-11','11:40:00',7.49),('16100','2013-06-11','11:45:00',7.53),('16100','2013-06-11','11:50:00',7.53),('16100','2013-06-11','11:55:00',7.57),('16100','2013-06-11','12:00:00',7.6),('16100','2013-06-11','12:05:00',7.65),('16100','2013-06-11','12:10:00',7.6),('16100','2013-06-11','12:15:00',7.64),('16100','2013-06-11','12:20:00',7.7),('16100','2013-06-11','12:25:00',7.73),('16100','2013-06-11','12:30:00',7.86),('16100','2013-06-11','12:35:00',6.31),('16100','2013-06-11','12:40:00',7.82),('16100','2013-06-11','12:45:00',8.01),('16100','2013-06-11','12:50:00',8.05),('16100','2013-06-11','12:55:00',8.06),('16100','2013-06-11','13:00:00',7.99),('16100','2013-06-11','13:05:00',7.89),('16100','2013-06-11','13:10:00',7.96),('16100','2013-06-11','13:15:00',7.91),('16100','2013-06-11','13:20:00',7.84),('16100','2013-06-11','13:25:00',7.88),('16100','2013-06-11','13:30:00',7.83),('16100','2013-06-11','13:35:00',7.75),('16100','2013-06-11','13:40:00',7.8),('16100','2013-06-11','13:45:00',7.77),('16100','2013-06-11','13:50:00',5.81),('16100','2013-06-11','13:55:00',3.16),('16100','2013-06-11','14:00:00',7),('16100','2013-06-11','14:05:00',8.27),('16100','2013-06-11','14:10:00',8.04),('16100','2013-06-11','14:15:00',7.82),('16100','2013-06-11','14:20:00',7.79),('16100','2013-06-11','14:25:00',7.76),('16100','2013-06-11','14:30:00',7.67),('16100','2013-06-11','14:35:00',7.58),('16100','2013-06-11','14:40:00',7.47),('16100','2013-06-11','14:45:00',7.34),('16100','2013-06-11','14:50:00',7.33),('16100','2013-06-11','14:55:00',7.34),('16100','2013-06-11','15:00:00',6.86),('16100','2013-06-11','15:05:00',6.72),('16100','2013-06-11','15:10:00',7.1),('16100','2013-06-11','15:15:00',7.24),('16100','2013-06-11','15:20:00',6.92),('16100','2013-06-11','15:25:00',6.77),('16100','2013-06-11','15:30:00',6.78),('16100','2013-06-11','15:35:00',6.77),('16100','2013-06-11','15:40:00',6.67),('16100','2013-06-11','15:45:00',6.53),('16100','2013-06-11','15:50:00',6.46),('16100','2013-06-11','15:55:00',6.44),('16100','2013-06-11','16:00:00',6.34),('16100','2013-06-11','16:05:00',6.15),('16100','2013-06-11','16:10:00',5.94),('16100','2013-06-11','16:15:00',5.98),('16100','2013-06-11','16:20:00',5.81),('16100','2013-06-11','16:25:00',5.94),('16100','2013-06-11','16:30:00',5.71),('16100','2013-06-11','16:35:00',5.48),('16100','2013-06-11','16:40:00',5.69),('16100','2013-06-11','16:45:00',5.51),('16100','2013-06-11','16:50:00',5.19),('16100','2013-06-11','16:55:00',4.97),('16100','2013-06-11','17:00:00',4.84),('16100','2013-06-11','17:05:00',4.67),('16100','2013-06-11','17:10:00',4.44),('16100','2013-06-11','17:15:00',4.32),('16100','2013-06-11','17:20:00',4.21),('16100','2013-06-11','17:25:00',4.06),('16100','2013-06-11','17:30:00',3.44),('16100','2013-06-11','17:35:00',3.45),('16100','2013-06-11','17:40:00',3.96),('16100','2013-06-11','17:45:00',3.85),('16100','2013-06-11','17:50:00',3.74),('16100','2013-06-11','17:55:00',3.71),('16100','2013-06-11','18:00:00',3.08),('16100','2013-06-11','18:05:00',1.22),('16100','2013-06-11','18:10:00',2.4),('16100','2013-06-11','18:15:00',2.32),('16100','2013-06-11','18:20:00',2.21),('16100','2013-06-11','18:25:00',2.02),('16100','2013-06-11','18:30:00',1.85),('16100','2013-06-11','18:35:00',1.64),('16100','2013-06-11','18:40:00',1.46),('16100','2013-06-11','18:45:00',1.33),('16100','2013-06-11','18:50:00',1.17),('16100','2013-06-11','18:55:00',1.02),('16100','2013-06-10','07:45:00',1.01),('16100','2013-06-10','07:50:00',1.22),('16100','2013-06-10','07:55:00',1.39),('16100','2013-06-10','08:00:00',1.59),('16100','2013-06-10','08:05:00',1.81),('16100','2013-06-10','08:10:00',2.01),('16100','2013-06-10','08:15:00',2.2),('16100','2013-06-10','08:20:00',2.35),('16100','2013-06-10','08:25:00',2.51),('16100','2013-06-10','08:30:00',2.7),('16100','2013-06-10','08:35:00',2.82),('16100','2013-06-10','08:40:00',3.05),('16100','2013-06-10','08:45:00',3.23),('16100','2013-06-10','08:50:00',3.43),('16100','2013-06-10','08:55:00',3.61),('16100','2013-06-10','09:00:00',3.77),('16100','2013-06-10','09:05:00',4.02),('16100','2013-06-10','09:10:00',4.14),('16100','2013-06-10','09:15:00',4.42),('16100','2013-06-10','09:20:00',4.73),('16100','2013-06-10','09:25:00',4.81),('16100','2013-06-10','09:30:00',4.9),('16100','2013-06-10','09:35:00',5.08),('16100','2013-06-10','09:40:00',5.16),('16100','2013-06-10','09:45:00',5.31),('16100','2013-06-10','09:50:00',5.44),('16100','2013-06-10','09:55:00',5.24),('16100','2013-06-10','10:00:00',5.63),('16100','2013-06-10','10:05:00',5.76),('16100','2013-06-10','10:10:00',6.1),('16100','2013-06-10','10:15:00',6.11),('16100','2013-06-10','10:20:00',5.5),('16100','2013-06-10','10:25:00',6.66),('16100','2013-06-10','10:30:00',6.45),('16100','2013-06-10','10:35:00',5.9),('16100','2013-06-10','10:40:00',6.84),('16100','2013-06-10','10:45:00',5.19),('16100','2013-06-10','10:50:00',4.87),('16100','2013-06-10','10:55:00',6.98),('16100','2013-06-10','11:00:00',5.37),('16100','2013-06-10','11:05:00',2.11),('16100','2013-06-10','11:10:00',7.21),('16100','2013-06-10','11:15:00',7.39),('16100','2013-06-10','11:20:00',7.39),('16100','2013-06-10','11:25:00',7.42),('16100','2013-06-10','11:30:00',7.52),('16100','2013-06-10','11:35:00',7.52),('16100','2013-06-10','11:40:00',7.58),('16100','2013-06-10','11:45:00',7.68),('16100','2013-06-10','11:50:00',7.69),('16100','2013-06-10','11:55:00',7.8),('16100','2013-06-10','12:00:00',7.93),('16100','2013-06-10','12:05:00',6.76),('16100','2013-06-10','12:10:00',8.05),('16100','2013-06-10','12:15:00',8.02),('16100','2013-06-10','12:20:00',7.97),('16100','2013-06-10','12:25:00',8.06),('16100','2013-06-10','12:30:00',8.06),('16100','2013-06-10','12:35:00',8.21),('16100','2013-06-10','12:40:00',8.11),('16100','2013-06-10','12:45:00',8.14),('16100','2013-06-10','12:50:00',8.2),('16100','2013-06-10','12:55:00',8.16),('16100','2013-06-10','13:00:00',6.76),('16100','2013-06-10','13:05:00',7.65),('16100','2013-06-10','13:10:00',8.28),('16100','2013-06-10','13:15:00',8.27),('16100','2013-06-10','13:20:00',8.26),('16100','2013-06-10','13:25:00',8.28),('16100','2013-06-10','13:30:00',8.28),('16100','2013-06-10','13:35:00',8.37),('16100','2013-06-10','13:40:00',5.66),('16100','2013-06-10','13:45:00',8.32),('16100','2013-06-10','13:50:00',8.25),('16100','2013-06-10','13:55:00',8.23),('16100','2013-06-10','14:00:00',8.11),('16100','2013-06-10','14:05:00',7.94),('16100','2013-06-10','14:10:00',7.95),('16100','2013-06-10','14:15:00',7.92),('16100','2013-06-10','14:20:00',7.88),('16100','2013-06-10','14:25:00',7.83),('16100','2013-06-10','14:30:00',7.73),('16100','2013-06-10','14:35:00',7.7),('16100','2013-06-10','14:40:00',7.68),('16100','2013-06-10','14:45:00',7.6),('16100','2013-06-10','14:50:00',7.55),('16100','2013-06-10','14:55:00',7.4),('16100','2013-06-10','15:00:00',7.14),('16100','2013-06-10','15:05:00',7.35),('16100','2013-06-10','15:10:00',7.25),('16100','2013-06-10','15:15:00',7.12),('16100','2013-06-10','15:20:00',7.06),('16100','2013-06-10','15:25:00',7.1),('16100','2013-06-10','15:30:00',7.09),('16100','2013-06-10','15:35:00',5.5),('16100','2013-06-10','15:40:00',6.27),('16100','2013-06-10','15:45:00',6.7),('16100','2013-06-10','15:50:00',6.66),('16100','2013-06-10','15:55:00',5.07),('16100','2013-06-10','16:00:00',6.44),('16100','2013-06-10','16:05:00',6.29),('16100','2013-06-10','16:10:00',6.13),('16100','2013-06-10','16:15:00',6),('16100','2013-06-10','16:20:00',5.83),('16100','2013-06-10','16:25:00',5.74),('16100','2013-06-10','16:30:00',5.6),('16100','2013-06-10','16:35:00',5.48),('16100','2013-06-10','16:40:00',5.6),('16100','2013-06-10','16:45:00',5.72),('16100','2013-06-10','16:50:00',5.61),('16100','2013-06-10','16:55:00',4.41),('16100','2013-06-10','17:00:00',3.36),('16100','2013-06-10','17:05:00',2.03),('16100','2013-06-10','17:10:00',1.17),('16100','2013-06-10','17:15:00',1.04),('16100','2014-04-02','08:35:00',1.03),('16100','2014-04-02','08:40:00',1.23),('16100','2014-04-02','08:45:00',1.35),('16100','2014-04-02','08:50:00',1.5),('16100','2014-04-02','08:55:00',1.66),('16100','2014-04-02','09:00:00',1.9),('16100','2014-04-02','09:05:00',2.11),('16100','2014-04-02','09:10:00',1.97),('16100','2014-04-02','09:15:00',1.81),('16100','2014-04-02','09:20:00',1.94),('16100','2014-04-02','09:25:00',2.11),('16100','2014-04-02','09:30:00',2.32),('16100','2014-04-02','09:35:00',2.64),('16100','2014-04-02','09:40:00',2.68),('16100','2014-04-02','09:45:00',2.68),('16100','2014-04-02','09:50:00',2.66),('16100','2014-04-02','09:55:00',3.01),('16100','2014-04-02','10:00:00',3.69),('16100','2014-04-02','10:05:00',4.05),('16100','2014-04-02','10:10:00',4.22),('16100','2014-04-02','10:15:00',4.87),('16100','2014-04-02','10:20:00',4.65),('16100','2014-04-02','10:25:00',3.33),('16100','2014-04-02','10:30:00',4.78),('16100','2014-04-02','10:35:00',4.56),('16100','2014-04-02','10:40:00',4.17),('16100','2014-04-02','10:45:00',5),('16100','2014-04-02','10:50:00',4.29),('16100','2014-04-02','10:55:00',3.53),('16100','2014-04-02','11:00:00',3.16),('16100','2014-04-02','11:05:00',2.79),('16100','2014-04-02','11:10:00',2.59),('16100','2014-04-02','11:15:00',2.39),('16100','2014-04-02','11:20:00',2.16),('16100','2014-04-02','11:25:00',1.96),('16100','2014-04-02','11:30:00',2),('16100','2014-04-02','11:35:00',2.25),('16100','2014-04-02','11:40:00',2.46),('16100','2014-04-02','11:45:00',2.63),('16100','2014-04-02','11:50:00',3.12),('16100','2014-04-02','11:55:00',3.53),('16100','2014-04-02','12:00:00',3.98),('16100','2014-04-02','12:05:00',4.01),('16100','2014-04-02','12:10:00',3.56),('16100','2014-04-02','12:15:00',3.66),('16100','2014-04-02','12:20:00',4.02),('16100','2014-04-02','12:25:00',5.2),('16100','2014-04-02','12:30:00',6.94),('16100','2014-04-02','12:35:00',7.34),('16100','2014-04-02','12:40:00',4.9),('16100','2014-04-02','12:45:00',3.94),('16100','2014-04-02','12:50:00',4.67),('16100','2014-04-02','12:55:00',4.56),('16100','2014-04-02','13:00:00',3.55),('16100','2014-04-02','13:05:00',3.77),('16100','2014-04-02','13:10:00',4.3),('16100','2014-04-02','13:15:00',5.77),('16100','2014-04-02','13:20:00',4.1),('16100','2014-04-02','13:25:00',5.74),('16100','2014-04-02','13:30:00',6.22),('16100','2014-04-02','13:35:00',7.12),('16100','2014-04-02','13:40:00',5.16),('16100','2014-04-02','13:45:00',2.92),('16100','2014-04-02','13:50:00',4.14),('16100','2014-04-02','13:55:00',4.79),('16100','2014-04-02','14:00:00',4.86),('16100','2014-04-02','14:05:00',6.98),('16100','2014-04-02','14:10:00',5.67),('16100','2014-04-02','14:15:00',6.51),('16100','2014-04-02','14:20:00',6.29),('16100','2014-04-02','14:25:00',5.77),('16100','2014-04-02','14:30:00',6.81),('16100','2014-04-02','14:35:00',6.89),('16100','2014-04-02','14:40:00',6.72),('16100','2014-04-02','14:45:00',6.15),('16100','2014-04-02','14:50:00',6.42),('16100','2014-04-02','14:55:00',6.26),('16100','2014-04-02','15:00:00',6.28),('16100','2014-04-02','15:05:00',6.3),('16100','2014-04-02','15:10:00',6.26),('16100','2014-04-02','15:15:00',6.21),('16100','2014-04-02','15:20:00',6.09),('16100','2014-04-02','15:25:00',5.99),('16100','2014-04-02','15:30:00',5.84),('16100','2014-04-02','15:35:00',5.76),('16100','2014-04-02','15:40:00',5.7),('16100','2014-04-02','15:45:00',5.69),('16100','2014-04-02','15:50:00',5.63),('16100','2014-04-02','15:55:00',5.53),('16100','2014-04-02','16:00:00',5.59),('16100','2014-04-02','16:05:00',5.39),('16100','2014-04-02','16:10:00',5.31),('16100','2014-04-02','16:15:00',5.14),('16100','2014-04-02','16:20:00',5.06),('16100','2014-04-02','16:25:00',4.95),('16100','2014-04-02','16:30:00',4.73),('16100','2014-04-02','16:35:00',4.6),('16100','2014-04-02','16:40:00',4.54),('16100','2014-04-02','16:45:00',4.42),('16100','2014-04-02','16:50:00',4.32),('16100','2014-04-02','16:55:00',3.77),('16100','2014-04-02','17:00:00',3.13),('16100','2014-04-02','17:05:00',2.08),('16100','2014-04-02','17:10:00',2.19),('16100','2014-04-02','17:15:00',2.12),('16100','2014-04-02','17:20:00',1.93),('16100','2014-04-02','17:25:00',2.15),('16100','2014-04-02','17:30:00',1.6),('16100','2014-04-02','17:35:00',1.08),('16100','2014-04-02','17:40:00',1.09),('16100','2014-04-02','17:45:00',1.43),('16100','2014-04-02','17:50:00',2.45),('16100','2014-04-02','17:55:00',2.12),('16100','2014-04-02','18:00:00',1.91),('16100','2014-04-02','18:05:00',1.71),('16100','2014-04-02','18:10:00',1.54),('16100','2014-04-02','18:15:00',1.37),('16100','2014-04-02','18:20:00',1.19),('16100','2013-06-09','07:25:00',1.02),('16100','2013-06-09','07:30:00',1.26),('16100','2013-06-09','07:35:00',1.33),('16100','2013-06-09','07:50:00',1.02),('16100','2013-06-09','07:55:00',1.24),('16100','2013-06-09','08:00:00',1.57),('16100','2013-06-09','08:05:00',1.46),('16100','2013-06-09','08:10:00',1.65),('16100','2013-06-09','08:15:00',1.75),('16100','2013-06-09','08:20:00',1.73),('16100','2013-06-09','08:25:00',1.95),('16100','2013-06-09','08:30:00',1.24),('16100','2013-06-09','08:35:00',1.25),('16100','2013-06-09','08:45:00',1.86),('16100','2013-06-09','08:50:00',2.91),('16100','2013-06-09','08:55:00',2.52),('16100','2013-06-09','09:00:00',1.42),('16100','2013-06-09','09:05:00',2.08),('16100','2013-06-09','09:10:00',1.63),('16100','2013-06-09','09:15:00',4.75),('16100','2013-06-09','09:20:00',4.96),('16100','2013-06-09','09:25:00',4.76),('16100','2013-06-09','09:30:00',3.58),('16100','2013-06-09','09:35:00',3.09),('16100','2013-06-09','09:40:00',1.61),('16100','2013-06-09','09:45:00',3.31),('16100','2013-06-09','09:50:00',2.86),('16100','2013-06-09','09:55:00',2.51),('16100','2013-06-09','10:00:00',3.19),('16100','2013-06-09','10:05:00',2.73),('16100','2013-06-09','10:10:00',4.48),('16100','2013-06-09','10:15:00',4.52),('16100','2013-06-09','10:20:00',3.43),('16100','2013-06-09','10:25:00',2.1),('16100','2013-06-09','10:30:00',2.05),('16100','2013-06-09','10:35:00',2.15),('16100','2013-06-09','10:40:00',4.96),('16100','2013-06-09','10:45:00',6.66),('16100','2013-06-09','10:50:00',6.33),('16100','2013-06-09','10:55:00',5.74),('16100','2013-06-09','11:00:00',7.28),('16100','2013-06-09','11:05:00',7.4),('16100','2013-06-09','11:10:00',7.28),('16100','2013-06-09','11:15:00',3.98),('16100','2013-06-09','11:20:00',7.09),('16100','2013-06-09','11:25:00',6.66),('16100','2013-06-09','11:30:00',5.43),('16100','2013-06-09','11:35:00',4.21),('16100','2013-06-09','11:40:00',4.8),('16100','2013-06-09','11:45:00',2.88),('16100','2013-06-09','11:50:00',9.09),('16100','2013-06-09','11:55:00',4.64),('16100','2013-06-09','12:00:00',1.73),('16100','2013-06-09','12:05:00',2.99),('16100','2013-06-09','12:10:00',2.95),('16100','2013-06-09','12:15:00',5.7),('16100','2013-06-09','12:20:00',7.08),('16100','2013-06-09','12:25:00',8.03),('16100','2013-06-09','12:30:00',7.4),('16100','2013-06-09','12:35:00',9.12),('16100','2013-06-09','12:40:00',6.57),('16100','2013-06-09','12:45:00',8.65),('16100','2013-06-09','12:50:00',5.73),('16100','2013-06-09','12:55:00',9.05),('16100','2013-06-09','13:00:00',6.2),('16100','2013-06-09','13:05:00',6.58),('16100','2013-06-09','13:10:00',5.43),('16100','2013-06-09','13:15:00',5.71),('16100','2013-06-09','13:20:00',9.14),('16100','2013-06-09','13:25:00',6.85),('16100','2013-06-09','13:30:00',8.05),('16100','2013-06-09','13:35:00',3.51),('16100','2013-06-09','13:40:00',1.62),('16100','2013-06-09','13:45:00',6.46),('16100','2013-06-09','13:50:00',3.2),('16100','2013-06-09','13:55:00',2.69),('16100','2013-06-09','14:00:00',3.75),('16100','2013-06-09','14:05:00',7.41),('16100','2013-06-09','14:10:00',4.75),('16100','2013-06-09','14:15:00',7.69),('16100','2013-06-09','14:20:00',8.16),('16100','2013-06-09','14:25:00',6.85),('16100','2013-06-09','14:30:00',6.34),('16100','2013-06-09','14:35:00',7.82),('16100','2013-06-09','14:40:00',7.66),('16100','2013-06-09','14:45:00',7.56),('16100','2013-06-09','14:50:00',7.57),('16100','2013-06-09','14:55:00',7.52),('16100','2013-06-09','15:00:00',7.48),('16100','2013-06-09','15:05:00',7.44),('16100','2013-06-09','15:10:00',7.35),('16100','2013-06-09','15:15:00',7.27),('16100','2013-06-09','15:20:00',7.18),('16100','2013-06-09','15:25:00',7.08),('16100','2013-06-09','15:30:00',6.96),('16100','2013-06-09','15:35:00',6.89),('16100','2013-06-09','15:40:00',6.78),('16100','2013-06-09','15:45:00',6.69),('16100','2013-06-09','15:50:00',6.6),('16100','2013-06-09','15:55:00',6.51),('16100','2013-06-09','16:00:00',6.38),('16100','2013-06-09','16:05:00',6.28),('16100','2013-06-09','16:10:00',6.16),('16100','2013-06-09','16:15:00',6.1),('16100','2013-06-09','16:20:00',5.95),('16100','2013-06-09','16:25:00',5.82),('16100','2013-06-09','16:30:00',5.68),('16100','2013-06-09','16:35:00',5.56),('16100','2013-06-09','16:40:00',5.4),('16100','2013-06-09','16:45:00',5.3),('16100','2013-06-09','16:50:00',5.18),('16100','2013-06-09','16:55:00',5.06),('16100','2013-06-09','17:00:00',4.92),('16100','2013-06-09','17:05:00',4.78),('16100','2013-06-09','17:10:00',4.6),('16100','2013-06-09','17:15:00',4.47),('16100','2013-06-09','17:20:00',4.31),('16100','2013-06-09','17:25:00',4.11),('16100','2013-06-09','17:30:00',3.99),('16100','2013-06-09','17:35:00',3.81),('16100','2013-06-09','17:40:00',3.6),('16100','2013-06-09','17:45:00',3.44),('16100','2013-06-09','17:50:00',3.32),('16100','2013-06-09','17:55:00',3.15),('16100','2013-06-09','18:00:00',2.96),('16100','2013-06-09','18:05:00',2.78),('16100','2013-06-09','18:10:00',2.53),('16100','2013-06-09','18:15:00',2.32),('16100','2013-06-09','18:20:00',2.18),('16100','2013-06-09','18:25:00',2.02),('16100','2013-06-09','18:30:00',1.85),('16100','2013-06-09','18:35:00',1.67),('16100','2013-06-09','18:40:00',1.52),('16100','2013-06-09','18:45:00',1.38),('16100','2013-06-09','18:50:00',1.21),('16100','2013-06-09','18:55:00',1.04),('16100','2013-06-08','07:30:00',1.16),('16100','2013-06-08','07:35:00',1.39),('16100','2013-06-08','07:50:00',1.28),('16100','2013-06-08','07:55:00',1.36),('16100','2013-06-08','08:00:00',1.54),('16100','2013-06-08','08:05:00',1.51),('16100','2013-06-08','08:10:00',1.8),('16100','2013-06-08','08:15:00',2.18),('16100','2013-06-08','08:20:00',2.42),('16100','2013-06-08','08:25:00',2.5),('16100','2013-06-08','08:30:00',2.63),('16100','2013-06-08','08:35:00',2.75),('16100','2013-06-08','08:40:00',2.94),('16100','2013-06-08','08:45:00',3.11),('16100','2013-06-08','08:50:00',3.22),('16100','2013-06-08','08:55:00',3.39),('16100','2013-06-08','09:00:00',3.51),('16100','2013-06-08','09:05:00',3.68),('16100','2013-06-08','09:10:00',4.05),('16100','2013-06-08','09:15:00',4.27),('16100','2013-06-08','09:20:00',4.39),('16100','2013-06-08','09:25:00',4.34),('16100','2013-06-08','09:30:00',4.49),('16100','2013-06-08','09:35:00',4.67),('16100','2013-06-08','09:40:00',4.9),('16100','2013-06-08','09:45:00',5.05),('16100','2013-06-08','09:50:00',5.2),('16100','2013-06-08','09:55:00',5.29),('16100','2013-06-08','10:00:00',5.38),('16100','2013-06-08','10:05:00',5.52),('16100','2013-06-08','10:10:00',5.59),('16100','2013-06-08','10:15:00',5.82),('16100','2013-06-08','10:20:00',5.87),('16100','2013-06-08','10:25:00',6.02),('16100','2013-06-08','10:30:00',6.08),('16100','2013-06-08','10:35:00',6.15),('16100','2013-06-08','10:40:00',6.24),('16100','2013-06-08','10:45:00',6.33),('16100','2013-06-08','10:50:00',6.39),('16100','2013-06-08','10:55:00',6.54),('16100','2013-06-08','11:00:00',6.54),('16100','2013-06-08','11:05:00',6.63),('16100','2013-06-08','11:10:00',6.68),('16100','2013-06-08','11:15:00',6.71),('16100','2013-06-08','11:20:00',6.53),('16100','2013-06-08','11:25:00',6.72),('16100','2013-06-08','11:30:00',6.87),('16100','2013-06-08','11:35:00',6.89),('16100','2013-06-08','11:40:00',7.04),('16100','2013-06-08','11:45:00',6.95),('16100','2013-06-08','11:50:00',7.13),('16100','2013-06-08','11:55:00',7.04),('16100','2013-06-08','12:00:00',7.09),('16100','2013-06-08','12:05:00',6.93),('16100','2013-06-08','12:10:00',6.36),('16100','2013-06-08','12:15:00',7.48),('16100','2013-06-08','12:20:00',7.37),('16100','2013-06-08','12:25:00',7.38),('16100','2013-06-08','12:30:00',7.35),('16100','2013-06-08','12:35:00',7.57),('16100','2013-06-08','12:40:00',6.81),('16100','2013-06-08','12:45:00',7.1),('16100','2013-06-08','12:50:00',7.38),('16100','2013-06-08','12:55:00',6.54),('16100','2013-06-08','13:00:00',7.2),('16100','2013-06-08','13:05:00',7.56),('16100','2013-06-08','13:10:00',7.28),('16100','2013-06-08','13:15:00',7.44),('16100','2013-06-08','13:20:00',7.88),('16100','2013-06-08','13:25:00',7.92),('16100','2013-06-08','13:30:00',8.02),('16100','2013-06-08','13:35:00',8.26),('16100','2013-06-08','13:40:00',7.14),('16100','2013-06-08','13:45:00',6.6),('16100','2013-06-08','13:50:00',6.36),('16100','2013-06-08','13:55:00',5.44),('16100','2013-06-08','14:00:00',8.13),('16100','2013-06-08','14:05:00',8.12),('16100','2013-06-08','14:10:00',8.09),('16100','2013-06-08','14:15:00',7.18),('16100','2013-06-08','14:20:00',2.32),('16100','2013-06-08','14:25:00',1.73),('16100','2013-06-08','14:30:00',2.4),('16100','2013-06-08','14:35:00',6.04),('16100','2013-06-08','14:40:00',7.93),('16100','2013-06-08','14:45:00',5.57),('16100','2013-06-08','14:50:00',7.23),('16100','2013-06-08','14:55:00',7.45),('16100','2013-06-08','15:00:00',6.72),('16100','2013-06-08','15:05:00',7.33),('16100','2013-06-08','15:10:00',7.11),('16100','2013-06-08','15:15:00',6.93),('16100','2013-06-08','15:20:00',6.84),('16100','2013-06-08','15:25:00',6.86),('16100','2013-06-08','15:30:00',6.6),('16100','2013-06-08','15:35:00',6.68),('16100','2013-06-08','15:40:00',5.65),('16100','2013-06-08','15:45:00',4.6),('16100','2013-06-08','15:50:00',5.62),('16100','2013-06-08','15:55:00',6.54),('16100','2013-06-08','16:00:00',6.26),('16100','2013-06-08','16:05:00',5.48),('16100','2013-06-08','16:10:00',5.14),('16100','2013-06-08','16:15:00',5.81),('16100','2013-06-08','16:20:00',3.4),('16100','2013-06-08','16:25:00',5.2),('16100','2013-06-08','16:30:00',1.95),('16100','2013-06-08','16:35:00',1.61),('16100','2013-06-08','16:40:00',1.43),('16100','2013-06-08','16:45:00',1.46),('16100','2013-06-08','16:50:00',1.38),('16100','2013-06-08','16:55:00',1.31),('16100','2013-06-08','17:00:00',1.49),('16100','2013-06-08','17:05:00',1.49),('16100','2013-06-08','17:10:00',1.52),('16100','2013-06-08','17:15:00',1.02),('16100','2013-06-08','17:20:00',1.07),('16100','2013-06-08','17:40:00',1.09),('16100','2013-06-08','17:45:00',1.17),('16100','2013-06-08','18:00:00',1.53),('16100','2013-06-08','18:05:00',2.42),('16100','2013-06-08','18:10:00',1.76),('16100','2013-06-08','18:45:00',1.04),('16100','2013-06-07','07:50:00',1.2),('16100','2013-06-07','07:55:00',1.41),('16100','2013-06-07','08:00:00',1.61),('16100','2013-06-07','08:05:00',1.78),('16100','2013-06-07','08:10:00',1.97),('16100','2013-06-07','08:15:00',2.14),('16100','2013-06-07','08:20:00',2.28),('16100','2013-06-07','08:25:00',2.45),('16100','2013-06-07','08:30:00',2.62),('16100','2013-06-07','08:35:00',2.8),('16100','2013-06-07','08:40:00',2.93),('16100','2013-06-07','08:45:00',3.13),('16100','2013-06-07','08:50:00',3.28),('16100','2013-06-07','08:55:00',3.44),('16100','2013-06-07','09:00:00',3.53),('16100','2013-06-07','09:05:00',3.69),('16100','2013-06-07','09:10:00',4.02),('16100','2013-06-07','09:15:00',4.32),('16100','2013-06-07','09:20:00',4.46),('16100','2013-06-07','09:25:00',4.54),('16100','2013-06-07','09:30:00',4.77),('16100','2013-06-07','09:35:00',4.91),('16100','2013-06-07','09:40:00',5.07),('16100','2013-06-07','09:45:00',5.2),('16100','2013-06-07','09:50:00',5.34),('16100','2013-06-07','09:55:00',5.56),('16100','2013-06-07','10:00:00',5.51),('16100','2013-06-07','10:05:00',5.67),('16100','2013-06-07','10:10:00',5.69),('16100','2013-06-07','10:15:00',2.16),('16100','2013-06-07','10:20:00',3.09),('16100','2013-06-07','10:25:00',6.18),('16100','2013-06-07','10:30:00',6.38),('16100','2013-06-07','10:35:00',6.6),('16100','2013-06-07','10:40:00',6.48),('16100','2013-06-07','10:45:00',6.86),('16100','2013-06-07','10:50:00',4.5),('16100','2013-06-07','10:55:00',6.82),('16100','2013-06-07','11:00:00',7.86),('16100','2013-06-07','11:05:00',7.08),('16100','2013-06-07','11:10:00',6.44),('16100','2013-06-07','11:15:00',6.12),('16100','2013-06-07','11:20:00',2.51),('16100','2013-06-07','11:25:00',8.02),('16100','2013-06-07','11:30:00',7.61),('16100','2013-06-07','11:35:00',6.63),('16100','2013-06-07','11:40:00',7.77),('16100','2013-06-07','11:45:00',7.93),('16100','2013-06-07','11:50:00',2.71),('16100','2013-06-07','11:55:00',7.9),('16100','2013-06-07','12:00:00',8.28),('16100','2013-06-07','12:05:00',6.19),('16100','2013-06-07','12:10:00',6.29),('16100','2013-06-07','12:15:00',5.74),('16100','2013-06-07','12:20:00',8.25),('16100','2013-06-07','12:25:00',7.76),('16100','2013-06-07','12:30:00',6.03),('16100','2013-06-07','12:35:00',6.2),('16100','2013-06-07','12:40:00',7.64),('16100','2013-06-07','12:45:00',7.82),('16100','2013-06-07','12:50:00',7.97),('16100','2013-06-07','12:55:00',7.91),('16100','2013-06-07','13:00:00',7.92),('16100','2013-06-07','13:05:00',8.04),('16100','2013-06-07','13:10:00',7.83),('16100','2013-06-07','13:15:00',7.91),('16100','2013-06-07','13:20:00',7.94),('16100','2013-06-07','13:25:00',7.92),('16100','2013-06-07','13:30:00',7.91),('16100','2013-06-07','13:35:00',7.86),('16100','2013-06-07','13:40:00',7.84),('16100','2013-06-07','13:45:00',7.87),('16100','2013-06-07','13:50:00',7.84),('16100','2013-06-07','13:55:00',8.02),('16100','2013-06-07','14:00:00',7.94),('16100','2013-06-07','14:05:00',7.76),('16100','2013-06-07','14:10:00',7.77),('16100','2013-06-07','14:15:00',7.74),('16100','2013-06-07','14:20:00',7.7),('16100','2013-06-07','14:25:00',7.67),('16100','2013-06-07','14:30:00',7.69),('16100','2013-06-07','14:35:00',7.6),('16100','2013-06-07','14:40:00',7.55),('16100','2013-06-07','14:45:00',7.49),('16100','2013-06-07','14:50:00',7.39),('16100','2013-06-07','14:55:00',7.29),('16100','2013-06-07','15:00:00',7.19),('16100','2013-06-07','15:05:00',7.05),('16100','2013-06-07','15:10:00',7.09),('16100','2013-06-07','15:15:00',7.2),('16100','2013-06-07','15:20:00',7.14),('16100','2013-06-07','15:25:00',6.96),('16100','2013-06-07','15:30:00',7.18),('16100','2013-06-07','15:35:00',7.13),('16100','2013-06-07','15:40:00',6.82),('16100','2013-06-07','15:45:00',6.99),('16100','2013-06-07','15:50:00',6.79),('16100','2013-06-07','15:55:00',6.52),('16100','2013-06-07','16:00:00',6.45),('16100','2013-06-07','16:05:00',5.74),('16100','2013-06-07','16:10:00',6.44),('16100','2013-06-07','16:15:00',6.25),('16100','2013-06-07','16:20:00',5.9),('16100','2013-06-07','16:25:00',5.68),('16100','2013-06-07','16:30:00',5.53),('16100','2013-06-07','16:35:00',5.41),('16100','2013-06-07','16:40:00',5.3),('16100','2013-06-07','16:45:00',4.91),('16100','2013-06-07','16:50:00',4.57),('16100','2013-06-07','16:55:00',4.7),('16100','2013-06-07','17:00:00',2.38),('16100','2013-06-07','17:05:00',4.4),('16100','2013-06-07','17:10:00',5.05),('16100','2013-06-07','17:15:00',4.79),('16100','2013-06-07','17:20:00',4.37),('16100','2013-06-07','17:25:00',2.28),('16100','2013-06-07','17:35:00',2.07),('16100','2013-06-07','17:40:00',3.73),('16100','2013-06-07','17:45:00',3.19),('16100','2013-06-07','17:50:00',3.35),('16100','2013-06-07','17:55:00',2.79),('16100','2013-06-07','18:00:00',2.29),('16100','2013-06-07','18:05:00',1.86),('16100','2013-06-07','18:10:00',1.72),('16100','2013-06-07','18:15:00',1.75),('16100','2013-06-07','18:20:00',1.51),('16100','2013-06-06','07:45:00',1.06),('16100','2013-06-06','07:50:00',1.25),('16100','2013-06-06','07:55:00',1.46),('16100','2013-06-06','08:00:00',1.69),('16100','2013-06-06','08:06:00',1.89),('16100','2013-06-06','08:10:00',2.1),('16100','2013-06-06','08:15:00',2.27),('16100','2013-06-06','08:20:00',2.41),('16100','2013-06-06','08:25:00',2.6),('16100','2013-06-06','08:30:00',2.78),('16100','2013-06-06','08:35:00',2.94),('16100','2013-06-06','08:40:00',3.13),('16100','2013-06-06','08:45:00',3.34),('16100','2013-06-06','08:50:00',3.47),('16100','2013-06-06','08:55:00',3.62),('16100','2013-06-06','09:00:00',3.76),('16100','2013-06-06','09:05:00',3.96),('16100','2013-06-06','09:10:00',4.28),('16100','2013-06-06','09:15:00',4.48),('16100','2013-06-06','09:20:00',4.63),('16100','2013-06-06','09:25:00',4.7),('16100','2013-06-06','09:30:00',4.87),('16100','2013-06-06','09:35:00',5.06),('16100','2013-06-06','09:40:00',5.21),('16100','2013-06-06','09:45:00',5.32),('16100','2013-06-06','09:50:00',5.45),('16100','2013-06-06','09:55:00',5.54),('16100','2013-06-06','10:00:00',5.67),('16100','2013-06-06','10:05:00',5.82),('16100','2013-06-06','10:10:00',5.99),('16100','2013-06-06','10:15:00',6.09),('16100','2013-06-06','10:20:00',6.21),('16100','2013-06-06','10:25:00',6.31),('16100','2013-06-06','10:30:00',6.4),('16100','2013-06-06','10:35:00',6.5),('16100','2013-06-06','10:40:00',6.59),('16100','2013-06-06','10:45:00',6.68),('16100','2013-06-06','10:50:00',6.75),('16100','2013-06-06','10:55:00',6.92),('16100','2013-06-06','11:00:00',7.03),('16100','2013-06-06','11:05:00',7.09),('16100','2013-06-06','11:10:00',7.15),('16100','2013-06-06','11:15:00',7.22),('16100','2013-06-06','11:20:00',7.28),('16100','2013-06-06','11:25:00',7.31),('16100','2013-06-06','11:30:00',7.36),('16100','2013-06-06','11:35:00',7.42),('16100','2013-06-06','11:40:00',7.47),('16100','2013-06-06','11:45:00',7.53),('16100','2013-06-06','11:50:00',7.56),('16100','2013-06-06','11:55:00',7.58),('16100','2013-06-06','12:00:00',7.67),('16100','2013-06-06','12:05:00',7.75),('16100','2013-06-06','12:10:00',7.78),('16100','2013-06-06','12:15:00',7.74),('16100','2013-06-06','12:20:00',7.72),('16100','2013-06-06','12:25:00',7.82),('16100','2013-06-06','12:30:00',7.81),('16100','2013-06-06','12:35:00',7.81),('16100','2013-06-06','12:40:00',7.76),('16100','2013-06-06','12:45:00',7.82),('16100','2013-06-06','12:50:00',7.83),('16100','2013-06-06','12:55:00',7.79),('16100','2013-06-06','13:00:00',7.84),('16100','2013-06-06','13:05:00',7.79),('16100','2013-06-06','13:10:00',7.75),('16100','2013-06-06','13:15:00',7.79),('16100','2013-06-06','13:20:00',7.82),('16100','2013-06-06','13:25:00',7.84),('16100','2013-06-06','13:30:00',7.82),('16100','2013-06-06','13:35:00',7.79),('16100','2013-06-06','13:40:00',7.78),('16100','2013-06-06','13:45:00',7.72),('16100','2013-06-06','13:50:00',7.67),('16100','2013-06-06','13:55:00',7.72),('16100','2013-06-06','14:00:00',7.61),('16100','2013-06-06','14:05:00',7.47),('16100','2013-06-06','14:10:00',7.33),('16100','2013-06-06','14:15:00',7.44),('16100','2013-06-06','14:20:00',7.38),('16100','2013-06-06','14:25:00',7.31),('16100','2013-06-06','14:30:00',7.3),('16100','2013-06-06','14:35:00',7.32),('16100','2013-06-06','14:40:00',7.27),('16100','2013-06-06','14:45:00',7.22),('16100','2013-06-06','14:50:00',7.17),('16100','2013-06-06','14:55:00',7.21),('16100','2013-06-06','15:00:00',7.18),('16100','2013-06-06','15:05:00',7.13),('16100','2013-06-06','15:10:00',7.07),('16100','2013-06-06','15:15:00',6.97),('16100','2013-06-06','15:20:00',6.91),('16100','2013-06-06','15:25:00',6.83),('16100','2013-06-06','15:30:00',6.82),('16100','2013-06-06','15:35:00',6.73),('16100','2013-06-06','15:40:00',6.68),('16100','2013-06-06','15:45:00',6.56),('16100','2013-06-06','15:50:00',6.47),('16100','2013-06-06','15:55:00',6.37),('16100','2013-06-06','16:00:00',6.24),('16100','2013-06-06','16:05:00',6.16),('16100','2013-06-06','16:10:00',6.05),('16100','2013-06-06','16:15:00',5.96),('16100','2013-06-06','16:20:00',5.79),('16100','2013-06-06','16:25:00',5.66),('16100','2013-06-06','16:30:00',5.52),('16100','2013-06-06','16:35:00',5.39),('16100','2013-06-06','16:40:00',5.27),('16100','2013-06-06','16:45:00',5.14),('16100','2013-06-06','16:50:00',5.02),('16100','2013-06-06','16:55:00',4.87),('16100','2013-06-06','17:00:00',4.73),('16100','2013-06-06','17:05:00',4.57),('16100','2013-06-06','17:10:00',4.39),('16100','2013-06-06','17:15:00',4.22),('16100','2013-06-06','17:20:00',4.08),('16100','2013-06-06','17:25:00',3.99),('16100','2013-06-06','17:30:00',3.9),('16100','2013-06-06','17:35:00',3.78),('16100','2013-06-06','17:40:00',3.72),('16100','2013-06-06','17:45:00',3.73),('16100','2013-06-06','17:50:00',3.42),('16100','2013-06-06','17:55:00',2.88),('16100','2013-06-06','18:00:00',2.96),('16100','2013-06-06','18:05:00',2.72),('16100','2013-06-06','18:10:00',1.98),('16100','2013-06-06','18:15:00',2.07),('16100','2013-06-06','18:20:00',2.09),('16100','2013-06-06','18:25:00',1.87),('16100','2013-06-06','18:30:00',1.7),('16100','2013-06-06','18:35:00',1.55),('16100','2013-06-06','18:40:00',1.4),('16100','2013-06-06','18:45:00',1.27),('16100','2013-06-06','18:50:00',1.15),('16100','2013-06-06','18:55:00',1.02),('16100','2013-06-05','07:45:00',1.12),('16100','2013-06-05','07:50:00',1.47),('16100','2013-06-05','07:55:00',1.56),('16100','2013-06-05','08:00:00',1.46),('16100','2013-06-05','08:05:00',1.67),('16100','2013-06-05','08:10:00',1.86),('16100','2013-06-05','08:15:00',1.84),('16100','2013-06-05','08:20:00',2.35),('16100','2013-06-05','08:25:00',2.55),('16100','2013-06-05','08:30:00',2.71),('16100','2013-06-05','08:35:00',2.81),('16100','2013-06-05','08:40:00',2.97),('16100','2013-06-05','08:45:00',3.15),('16100','2013-06-05','08:50:00',3.35),('16100','2013-06-05','08:55:00',3.56),('16100','2013-06-05','09:00:00',3.67),('16100','2013-06-05','09:05:00',3.81),('16100','2013-06-05','09:10:00',4.24),('16100','2013-06-05','09:15:00',4.46),('16100','2013-06-05','09:20:00',4.4),('16100','2013-06-05','09:25:00',4.63),('16100','2013-06-05','09:30:00',4.83),('16100','2013-06-05','09:35:00',4.94),('16100','2013-06-05','09:40:00',5.11),('16100','2013-06-05','09:45:00',5.21),('16100','2013-06-05','09:50:00',5.26),('16100','2013-06-05','09:55:00',5.33),('16100','2013-06-05','10:00:00',5.51),('16100','2013-06-05','10:05:00',5.47),('16100','2013-06-05','10:10:00',5.27),('16100','2013-06-05','10:15:00',5.86),('16100','2013-06-05','10:20:00',6.08),('16100','2013-06-05','10:25:00',6.17),('16100','2013-06-05','10:30:00',6.29),('16100','2013-06-05','10:35:00',6.55),('16100','2013-06-05','10:40:00',6.51),('16100','2013-06-05','10:45:00',6.64),('16100','2013-06-05','10:50:00',6.61),('16100','2013-06-05','10:55:00',6.62),('16100','2013-06-05','11:00:00',6.67),('16100','2013-06-05','11:05:00',6.84),('16100','2013-06-05','11:10:00',6.53),('16100','2013-06-05','11:15:00',6.98),('16100','2013-06-05','11:20:00',6.9),('16100','2013-06-05','11:25:00',7.17),('16100','2013-06-05','11:30:00',7.25),('16100','2013-06-05','11:35:00',7.29),('16100','2013-06-05','11:40:00',7.47),('16100','2013-06-05','11:45:00',7.37),('16100','2013-06-05','11:50:00',7.43),('16100','2013-06-05','11:55:00',7.49),('16100','2013-06-05','12:00:00',7.6),('16100','2013-06-05','12:05:00',7.6),('16100','2013-06-05','12:10:00',7.61),('16100','2013-06-05','12:15:00',7.56),('16100','2013-06-05','12:20:00',7.44),('16100','2013-06-05','12:25:00',7.75),('16100','2013-06-05','12:30:00',7.71),('16100','2013-06-05','12:35:00',7.67),('16100','2013-06-05','12:40:00',7.6),('16100','2013-06-05','12:45:00',7.74),('16100','2013-06-05','12:50:00',7.89),('16100','2013-06-05','12:55:00',8.07),('16100','2013-06-05','13:00:00',8.12),('16100','2013-06-05','13:05:00',7.93),('16100','2013-06-05','13:10:00',7.74),('16100','2013-06-05','13:15:00',7.95),('16100','2013-06-05','13:20:00',7.87),('16100','2013-06-05','13:25:00',5.96),('16100','2013-06-05','13:30:00',1.76),('16100','2013-06-05','13:35:00',2),('16100','2013-06-05','13:40:00',1.81),('16100','2013-06-05','13:45:00',5.8),('16100','2013-06-05','13:50:00',8.32),('16100','2013-06-05','13:55:00',8.11),('16100','2013-06-05','14:00:00',7.37),('16100','2013-06-05','14:05:00',7.86),('16100','2013-06-05','14:10:00',5.79),('16100','2013-06-05','14:15:00',6.03),('16100','2013-06-05','14:20:00',7.94),('16100','2013-06-05','14:25:00',7.84),('16100','2013-06-05','14:30:00',7.65),('16100','2013-06-05','14:35:00',7.33),('16100','2013-06-05','14:40:00',7.36),('16100','2013-06-05','14:45:00',7.38),('16100','2013-06-05','14:50:00',7.39),('16100','2013-06-05','14:55:00',7.26),('16100','2013-06-05','15:00:00',7.14),('16100','2013-06-05','15:05:00',7.06),('16100','2013-06-05','15:10:00',6.97),('16100','2013-06-05','15:15:00',6.94),('16100','2013-06-05','15:20:00',6.85),('16100','2013-06-05','15:25:00',6.75),('16100','2013-06-05','15:30:00',6.69),('16100','2013-06-05','15:35:00',6.5),('16100','2013-06-05','15:40:00',6.44),('16100','2013-06-05','15:45:00',6.33),('16100','2013-06-05','15:50:00',6.16),('16100','2013-06-05','15:55:00',6.16),('16100','2013-06-05','16:00:00',6.01),('16100','2013-06-05','16:05:00',5.92),('16100','2013-06-05','16:10:00',5.88),('16100','2013-06-05','16:15:00',5.65),('16100','2013-06-05','16:20:00',5.54),('16100','2013-06-05','16:25:00',5.45),('16100','2013-06-05','16:30:00',5.37),('16100','2013-06-05','16:35:00',5.24),('16100','2013-06-05','16:40:00',5.11),('16100','2013-06-05','16:45:00',5),('16100','2013-06-05','16:50:00',4.85),('16100','2013-06-05','16:55:00',4.73),('16100','2013-06-05','17:00:00',4.55),('16100','2013-06-05','17:05:00',4.38),('16100','2013-06-05','17:10:00',4.18),('16100','2013-06-05','17:15:00',4.13),('16100','2013-06-05','17:20:00',3.94),('16100','2013-06-05','17:25:00',3.76),('16100','2013-06-05','17:30:00',3.62),('16100','2013-06-05','17:35:00',3.47),('16100','2013-06-05','17:40:00',3.33),('16100','2013-06-05','17:45:00',3.21),('16100','2013-06-05','17:50:00',3.07),('16100','2013-06-05','17:55:00',2.88),('16100','2013-06-05','18:00:00',2.72),('16100','2013-06-05','18:05:00',2.54),('16100','2013-06-05','18:10:00',2.32),('16100','2013-06-05','18:15:00',2.1),('16100','2013-06-05','18:20:00',1.99),('16100','2013-06-05','18:25:00',1.81),('16100','2013-06-05','18:30:00',1.69),('16100','2013-06-05','18:35:00',1.55),('16100','2013-06-05','18:40:00',1.4),('16100','2013-06-05','18:45:00',1.27),('16100','2013-06-05','18:50:00',1.11),('16100','2013-06-04','07:40:00',1.07),('16100','2013-06-04','07:45:00',1.18),('16100','2013-06-04','07:50:00',1.16),('16100','2013-06-04','07:55:00',1.43),('16100','2013-06-04','08:00:00',1.65),('16100','2013-06-04','08:05:00',1.73),('16100','2013-06-04','08:10:00',2.03),('16100','2013-06-04','08:15:00',2.27),('16100','2013-06-04','08:20:00',2.4),('16100','2013-06-04','08:25:00',2.57),('16100','2013-06-04','08:30:00',2.74),('16100','2013-06-04','08:35:00',2.91),('16100','2013-06-04','08:40:00',3.09),('16100','2013-06-04','08:45:00',3.3),('16100','2013-06-04','08:50:00',3.38),('16100','2013-06-04','08:55:00',3.59),('16100','2013-06-04','09:00:00',3.68),('16100','2013-06-04','09:05:00',4.15),('16100','2013-06-04','09:10:00',4.77),('16100','2013-06-04','09:15:00',4.43),('16100','2013-06-04','09:20:00',5.48),('16100','2013-06-04','09:25:00',5.17),('16100','2013-06-04','09:30:00',2.56),('16100','2013-06-04','09:35:00',3.84),('16100','2013-06-04','09:40:00',2.31),('16100','2013-06-04','09:45:00',1.84),('16100','2013-06-04','09:50:00',2.82),('16100','2013-06-04','09:55:00',4.39),('16100','2013-06-04','10:00:00',4.26),('16100','2013-06-04','10:05:00',2.66),('16100','2013-06-04','10:10:00',2.04),('16100','2013-06-04','10:15:00',6.45),('16100','2013-06-04','10:20:00',7.09),('16100','2013-06-04','10:25:00',7.32),('16100','2013-06-04','10:30:00',7.13),('16100','2013-06-04','10:35:00',7.11),('16100','2013-06-04','10:40:00',7.31),('16100','2013-06-04','10:45:00',3.51),('16100','2013-06-04','10:50:00',2.08),('16100','2013-06-04','10:55:00',1.96),('16100','2013-06-04','11:00:00',2.04),('16100','2013-06-04','11:05:00',3.12),('16100','2013-06-04','11:10:00',7.78),('16100','2013-06-04','11:15:00',8.34),('16100','2013-06-04','11:20:00',7.64),('16100','2013-06-04','11:25:00',3.66),('16100','2013-06-04','11:30:00',1.75),('16100','2013-06-04','11:35:00',1.66),('16100','2013-06-04','11:40:00',2.5),('16100','2013-06-04','11:45:00',7.12),('16100','2013-06-04','11:50:00',6.65),('16100','2013-06-04','11:55:00',2.81),('16100','2013-06-04','12:00:00',3.05),('16100','2013-06-04','12:05:00',2.66),('16100','2013-06-04','12:10:00',2.3),('16100','2013-06-04','12:15:00',2.51),('16100','2013-06-04','12:20:00',4.59),('16100','2013-06-04','12:25:00',2.8),('16100','2013-06-04','12:30:00',3.06),('16100','2013-06-04','12:35:00',3.55),('16100','2013-06-04','12:40:00',3.64),('16100','2013-06-04','12:45:00',5.17),('16100','2013-06-04','12:50:00',3.5),('16100','2013-06-04','12:55:00',6.32),('16100','2013-06-04','13:00:00',8.93),('16100','2013-06-04','13:05:00',8.7),('16100','2013-06-04','13:10:00',7.94),('16100','2013-06-04','13:15:00',6.8),('16100','2013-06-04','13:20:00',8.03),('16100','2013-06-04','13:25:00',8.79),('16100','2013-06-04','13:30:00',8.36),('16100','2013-06-04','13:35:00',8.13),('16100','2013-06-04','13:40:00',4.53),('16100','2013-06-04','13:45:00',6.41),('16100','2013-06-04','13:50:00',6.98),('16100','2013-06-04','13:55:00',7.65),('16100','2013-06-04','14:00:00',8.14),('16100','2013-06-04','14:05:00',8.04),('16100','2013-06-04','14:10:00',8.02),('16100','2013-06-04','14:15:00',8.02),('16100','2013-06-04','14:20:00',7.98),('16100','2013-06-04','14:25:00',5.81),('16100','2013-06-04','14:30:00',5.95),('16100','2013-06-04','14:35:00',8.05),('16100','2013-06-04','14:40:00',4.67),('16100','2013-06-04','14:45:00',7.43),('16100','2013-06-04','14:50:00',7.71),('16100','2013-06-04','14:55:00',7.55),('16100','2013-06-04','15:00:00',7.54),('16100','2013-06-04','15:05:00',6.52),('16100','2013-06-04','15:10:00',7.53),('16100','2013-06-04','15:15:00',7.49),('16100','2013-06-04','15:20:00',7.53),('16100','2013-06-04','15:25:00',7.36),('16100','2013-06-04','15:30:00',5.41),('16100','2013-06-04','15:35:00',4.4),('16100','2013-06-04','15:40:00',4.58),('16100','2013-06-04','15:45:00',5.46),('16100','2013-06-04','15:50:00',3.65),('16100','2013-06-04','15:55:00',6.04),('16100','2013-06-04','16:00:00',5.58),('16100','2013-06-04','16:05:00',5.01),('16100','2013-06-04','16:10:00',4.49),('16100','2013-06-04','16:15:00',4.62),('16100','2013-06-04','16:20:00',5.48),('16100','2013-06-04','16:25:00',3.18),('16100','2013-06-04','16:30:00',4.8),('16100','2013-06-04','16:35:00',5.97),('16100','2013-06-04','16:40:00',5.42),('16100','2013-06-04','16:45:00',3.54),('16100','2013-06-04','16:50:00',3.22),('16100','2013-06-04','16:55:00',2.42),('16100','2013-06-04','17:00:00',3.32),('16100','2013-06-04','17:05:00',5.31),('16100','2013-06-04','17:10:00',4.75),('16100','2013-06-04','17:15:00',3.45),('16100','2013-06-04','17:20:00',2.62),('16100','2013-06-04','17:25:00',4),('16100','2013-06-04','17:30:00',3.66),('16100','2013-06-04','17:35:00',3.77),('16100','2013-06-04','17:40:00',3.43),('16100','2013-06-04','17:45:00',3.28),('16100','2013-06-04','17:50:00',2.02),('16100','2013-06-04','17:55:00',1.94),('16100','2013-06-04','18:00:00',3.02),('16100','2013-06-04','18:05:00',1.26),('16100','2013-06-04','18:10:00',1.46),('16100','2013-06-04','18:15:00',2.44),('16100','2013-06-04','18:20:00',2.06),('16100','2013-06-04','18:30:00',1.46),('16100','2013-06-04','18:35:00',1.5),('16100','2013-06-04','18:40:00',1.32),('16100','2013-06-03','07:35:00',1.06),('16100','2013-06-03','07:40:00',1.34),('16100','2013-06-03','07:45:00',1.61),('16100','2013-06-03','07:50:00',1.95),('16100','2013-06-03','07:55:00',2.27),('16100','2013-06-03','08:00:00',2.46),('16100','2013-06-03','08:05:00',2.58),('16100','2013-06-03','08:10:00',2.63),('16100','2013-06-03','08:15:00',2.66),('16100','2013-06-03','08:20:00',2.69),('16100','2013-06-03','08:25:00',2.84),('16100','2013-06-03','08:30:00',2.55),('16100','2013-06-03','08:35:00',2.95),('16100','2013-06-03','08:40:00',2.38),('16100','2013-06-03','08:45:00',2.11),('16100','2013-06-03','08:50:00',2.22),('16100','2013-06-03','08:55:00',2.59),('16100','2013-06-03','09:00:00',3.8),('16100','2013-06-03','09:05:00',3.41),('16100','2013-06-03','09:10:00',3.79),('16100','2013-06-03','09:15:00',3.72),('16100','2013-06-03','09:20:00',3.47),('16100','2013-06-03','09:25:00',2.68),('16100','2013-06-03','09:30:00',2.57),('16100','2013-06-03','09:35:00',2.36),('16100','2013-06-03','09:40:00',2.31),('16100','2013-06-03','09:45:00',2.46),('16100','2013-06-03','09:50:00',2.74),('16100','2013-06-03','09:55:00',4.04),('16100','2013-06-03','10:00:00',6.5),('16100','2013-06-03','10:05:00',3.64),('16100','2013-06-03','10:10:00',3.06),('16100','2013-06-03','10:15:00',3.57),('16100','2013-06-03','10:20:00',2.81),('16100','2013-06-03','10:25:00',2.59),('16100','2013-06-03','10:30:00',2.62),('16100','2013-06-03','10:35:00',2.9),('16100','2013-06-03','10:40:00',3.21),('16100','2013-06-03','10:45:00',3.72),('16100','2013-06-03','10:50:00',4.75),('16100','2013-06-03','10:55:00',3.72),('16100','2013-06-03','11:00:00',5.75),('16100','2013-06-03','11:05:00',3.5),('16100','2013-06-03','11:10:00',2.85),('16100','2013-06-03','11:15:00',3.48),('16100','2013-06-03','11:20:00',5.68),('16100','2013-06-03','11:25:00',4.37),('16100','2013-06-03','11:30:00',4.5),('16100','2013-06-03','11:35:00',6.28),('16100','2013-06-03','11:40:00',7.4),('16100','2013-06-03','11:45:00',8.24),('16100','2013-06-03','11:50:00',5.75),('16100','2013-06-03','11:55:00',5.01),('16100','2013-06-03','12:00:00',4.46),('16100','2013-06-03','12:05:00',4.9),('16100','2013-06-03','12:10:00',4.39),('16100','2013-06-03','12:15:00',4.95),('16100','2013-06-03','12:20:00',3.32),('16100','2013-06-03','12:25:00',4.55),('16100','2013-06-03','12:30:00',6.73),('16100','2013-06-03','12:35:00',4.37),('16100','2013-06-03','12:40:00',4.81),('16100','2013-06-03','12:45:00',4.71),('16100','2013-06-03','12:50:00',2.71),('16100','2013-06-03','12:55:00',2.49),('16100','2013-06-03','13:00:00',2.01),('16100','2013-06-03','13:05:00',1.74),('16100','2013-06-03','13:10:00',1.66),('16100','2013-06-03','13:15:00',2.29),('16100','2013-06-03','13:20:00',3.57),('16100','2013-06-03','13:25:00',9.11),('16100','2013-06-03','13:30:00',9.84),('16100','2013-06-03','13:35:00',9.86),('16100','2013-06-03','13:40:00',6.97),('16100','2013-06-03','13:45:00',4.5),('16100','2013-06-03','13:50:00',6.17),('16100','2013-06-03','13:55:00',6.87),('16100','2013-06-03','14:00:00',5.22),('16100','2013-06-03','14:05:00',4.67),('16100','2013-06-03','14:10:00',9.2),('16100','2013-06-03','14:15:00',6.14),('16100','2013-06-03','14:20:00',1.55),('16100','2013-06-03','14:25:00',1.36),('16100','2013-06-03','14:30:00',1.74),('16100','2013-06-03','14:35:00',2.77),('16100','2013-06-03','14:40:00',2.6),('16100','2013-06-03','14:45:00',3.07),('16100','2013-06-03','14:50:00',8.37),('16100','2013-06-03','14:55:00',9.52),('16100','2013-06-03','15:00:00',8.96),('16100','2013-06-03','15:05:00',6.51),('16100','2013-06-03','15:10:00',5.33),('16100','2013-06-03','15:15:00',2.85),('16100','2013-06-03','15:20:00',2.13),('16100','2013-06-03','15:25:00',1.56),('16100','2013-06-03','15:30:00',1.09),('16100','2013-06-03','15:50:00',1.25),('16100','2013-06-03','15:55:00',1.15),('16100','2013-06-03','16:00:00',1.08),('16100','2013-06-03','17:10:00',1.06),('16100','2013-06-03','17:15:00',1.11),('16100','2013-06-03','18:00:00',1.05),('16100','2013-06-03','18:35:00',1.22),('16100','2013-06-03','18:40:00',1.39),('16100','2013-06-03','18:45:00',1.59),('16100','2013-06-03','18:50:00',1.23),('16100','2013-06-02','07:45:00',1.11),('16100','2013-06-02','07:50:00',1.36),('16100','2013-06-02','08:00:00',1.32),('16100','2013-06-02','08:05:00',1.92),('16100','2013-06-02','08:10:00',2.07),('16100','2013-06-02','08:15:00',2.22),('16100','2013-06-02','08:20:00',2.4),('16100','2013-06-02','08:25:00',2.55),('16100','2013-06-02','08:30:00',2.72),('16100','2013-06-02','08:35:00',2.84),('16100','2013-06-02','08:40:00',3.11),('16100','2013-06-02','08:45:00',3.36),('16100','2013-06-02','08:50:00',3.57),('16100','2013-06-02','08:55:00',2.5),('16100','2013-06-02','09:00:00',1.9),('16100','2013-06-02','09:05:00',2.5),('16100','2013-06-02','09:10:00',2.24),('16100','2013-06-02','09:15:00',3.15),('16100','2013-06-02','09:20:00',4.89),('16100','2013-06-02','09:25:00',5.38),('16100','2013-06-02','09:30:00',6.12),('16100','2013-06-02','09:35:00',3.26),('16100','2013-06-02','09:40:00',3.27),('16100','2013-06-02','09:45:00',3.53),('16100','2013-06-02','09:50:00',3.6),('16100','2013-06-02','09:55:00',3.78),('16100','2013-06-02','10:00:00',3.1),('16100','2013-06-02','10:05:00',2.84),('16100','2013-06-02','10:10:00',2.33),('16100','2013-06-02','10:15:00',3.07),('16100','2013-06-02','10:20:00',3),('16100','2013-06-02','10:25:00',2.38),('16100','2013-06-02','10:30:00',2.39),('16100','2013-06-02','10:35:00',2.08),('16100','2013-06-02','10:40:00',1.99),('16100','2013-06-02','10:45:00',2.21),('16100','2013-06-02','10:50:00',2.46),('16100','2013-06-02','10:55:00',2.86),('16100','2013-06-02','11:00:00',2.81),('16100','2013-06-02','11:05:00',2.88),('16100','2013-06-02','11:10:00',3.32),('16100','2013-06-02','11:15:00',5.71),('16100','2013-06-02','11:20:00',7),('16100','2013-06-02','11:25:00',7.96),('16100','2013-06-02','11:30:00',4.19),('16100','2013-06-02','11:35:00',7.2),('16100','2013-06-02','11:40:00',7.95),('16100','2013-06-02','11:45:00',5.7),('16100','2013-06-02','11:50:00',8.94),('16100','2013-06-02','11:55:00',4.56),('16100','2013-06-02','12:00:00',2.3),('16100','2013-06-02','12:05:00',2.5),('16100','2013-06-02','12:10:00',4.77),('16100','2013-06-02','12:15:00',5.91),('16100','2013-06-02','12:20:00',3.05),('16100','2013-06-02','12:25:00',2.41),('16100','2013-06-02','12:30:00',2.22),('16100','2013-06-02','12:35:00',2.73),('16100','2013-06-02','12:40:00',2.74),('16100','2013-06-02','12:45:00',1.79),('16100','2013-06-02','12:50:00',1.82),('16100','2013-06-02','12:55:00',2.21),('16100','2013-06-02','13:00:00',3.27),('16100','2013-06-02','13:05:00',5.06),('16100','2013-06-02','13:10:00',4.16),('16100','2013-06-02','13:15:00',2.83),('16100','2013-06-02','13:20:00',2.69),('16100','2013-06-02','13:25:00',3.69),('16100','2013-06-02','13:30:00',3.36),('16100','2013-06-02','13:35:00',4.2),('16100','2013-06-02','13:40:00',2.99),('16100','2013-06-02','13:45:00',2.27),('16100','2013-06-02','13:50:00',6.31),('16100','2013-06-02','13:55:00',6.12),('16100','2013-06-02','14:00:00',5.66),('16100','2013-06-02','14:05:00',5.99),('16100','2013-06-02','14:10:00',7.01),('16100','2013-06-02','14:15:00',9.1),('16100','2013-06-02','14:20:00',7.64),('16100','2013-06-02','14:25:00',8.52),('16100','2013-06-02','14:30:00',8.4),('16100','2013-06-02','14:35:00',4.37),('16100','2013-06-02','14:40:00',5.38),('16100','2013-06-02','14:45:00',8.09),('16100','2013-06-02','14:50:00',7.92),('16100','2013-06-02','14:55:00',7.21),('16100','2013-06-02','15:00:00',7.69),('16100','2013-06-02','15:05:00',5.87),('16100','2013-06-02','15:10:00',5.53),('16100','2013-06-02','15:15:00',7.39),('16100','2013-06-02','15:20:00',7.48),('16100','2013-06-02','15:25:00',6.86),('16100','2013-06-02','15:30:00',7.22),('16100','2013-06-02','15:35:00',5.55),('16100','2013-06-02','15:40:00',6.79),('16100','2013-06-02','15:45:00',6.6),('16100','2013-06-02','15:50:00',6.54),('16100','2013-06-02','15:55:00',6.42),('16100','2013-06-02','16:00:00',6.38),('16100','2013-06-02','16:05:00',6.31),('16100','2013-06-02','16:10:00',5.88),('16100','2013-06-02','16:15:00',5.01),('16100','2013-06-02','16:20:00',5.43),('16100','2013-06-02','16:25:00',5.58),('16100','2013-06-02','16:30:00',4.91),('16100','2013-06-02','16:35:00',4.4),('16100','2013-06-02','16:40:00',3.32),('16100','2013-06-02','16:45:00',3.35),('16100','2013-06-02','16:50:00',4),('16100','2013-06-02','16:55:00',4.34),('16100','2013-06-02','17:00:00',3.92),('16100','2013-06-02','17:05:00',4.79),('16100','2013-06-02','17:10:00',4.44),('16100','2013-06-02','17:15:00',3.64),('16100','2013-06-02','17:20:00',3.21),('16100','2013-06-02','17:25:00',2.35),('16100','2013-06-02','17:30:00',2.22),('16100','2013-06-02','17:35:00',1.48),('16100','2013-06-02','17:40:00',1.38),('16100','2013-06-02','17:45:00',1.5),('16100','2013-06-02','17:50:00',1.44),('16100','2013-06-02','17:55:00',1.41),('16100','2013-06-02','18:00:00',1.2),('16100','2013-06-01','08:20:00',1.02),('16100','2013-06-01','08:25:00',1.04),('16100','2013-06-01','08:30:00',1.1),('16100','2013-06-01','08:35:00',1.03),('16100','2013-06-01','08:40:00',1.53),('16100','2013-06-01','08:45:00',1.85),('16100','2013-06-01','08:50:00',1.31),('16100','2013-06-01','08:55:00',1.28),('16100','2013-06-01','09:00:00',1.39),('16100','2013-06-01','09:05:00',1.93),('16100','2013-06-01','09:10:00',2.19),('16100','2013-06-01','09:15:00',5.34),('16100','2013-06-01','09:20:00',4.03),('16100','2013-06-01','09:25:00',5.14),('16100','2013-06-01','09:30:00',5.17),('16100','2013-06-01','09:35:00',5.25),('16100','2013-06-01','09:40:00',5.33),('16100','2013-06-01','09:45:00',5.44),('16100','2013-06-01','09:50:00',5.55),('16100','2013-06-01','09:55:00',5.64),('16100','2013-06-01','10:00:00',5.82),('16100','2013-06-01','10:05:00',5.94),('16100','2013-06-01','10:10:00',6.07),('16100','2013-06-01','10:15:00',6.12),('16100','2013-06-01','10:20:00',6.44),('16100','2013-06-01','10:25:00',6.43),('16100','2013-06-01','10:30:00',6.64),('16100','2013-06-01','10:35:00',6.79),('16100','2013-06-01','10:40:00',7.17),('16100','2013-06-01','10:45:00',5.93),('16100','2013-06-01','10:50:00',5.78),('16100','2013-06-01','10:55:00',5.89),('16100','2013-06-01','11:00:00',8.35),('16100','2013-06-01','11:05:00',8.09),('16100','2013-06-01','11:10:00',4.97),('16100','2013-06-01','11:15:00',5.33),('16100','2013-06-01','11:20:00',2.18),('16100','2013-06-01','11:25:00',4.03),('16100','2013-06-01','11:30:00',5.79),('16100','2013-06-01','11:35:00',6.54),('16100','2013-06-01','11:40:00',4.62),('16100','2013-06-01','11:45:00',4.12),('16100','2013-06-01','11:50:00',2.24),('16100','2013-06-01','11:55:00',3.8),('16100','2013-06-01','12:00:00',3.98),('16100','2013-06-01','12:05:00',3.15),('16100','2013-06-01','12:10:00',4.92),('16100','2013-06-01','12:15:00',4.37),('16100','2013-06-01','12:20:00',9.05),('16100','2013-06-01','12:25:00',8.63),('16100','2013-06-01','12:30:00',8.26),('16100','2013-06-01','12:35:00',8.21),('16100','2013-06-01','12:40:00',8.35),('16100','2013-06-01','12:45:00',8.15),('16100','2013-06-01','12:50:00',8.39),('16100','2013-06-01','12:55:00',8.52),('16100','2013-06-01','13:00:00',8.31),('16100','2013-06-01','13:05:00',8.37),('16100','2013-06-01','13:10:00',8.49),('16100','2013-06-01','13:15:00',8.04),('16100','2013-06-01','13:20:00',8.3),('16100','2013-06-01','13:25:00',8.26),('16100','2013-06-01','13:30:00',8.2),('16100','2013-06-01','13:35:00',8.24),('16100','2013-06-01','13:40:00',8.25),('16100','2013-06-01','13:45:00',8.22),('16100','2013-06-01','13:50:00',8.21),('16100','2013-06-01','13:55:00',8.23),('16100','2013-06-01','14:00:00',8.09),('16100','2013-06-01','14:05:00',8.15),('16100','2013-06-01','14:10:00',7.87),('16100','2013-06-01','14:15:00',6.3),('16100','2013-06-01','14:20:00',8.05),('16100','2013-06-01','14:25:00',7.99),('16100','2013-06-01','14:30:00',8),('16100','2013-06-01','14:35:00',7.85),('16100','2013-06-01','14:40:00',7.62),('16100','2013-06-01','14:45:00',7.72),('16100','2013-06-01','14:50:00',7.67),('16100','2013-06-01','14:55:00',7.57),('16100','2013-06-01','15:00:00',6.41),('16100','2013-06-01','15:05:00',7.24),('16100','2013-06-01','15:10:00',7.42),('16100','2013-06-01','15:15:00',6.19),('16100','2013-06-01','15:20:00',7.26),('16100','2013-06-01','15:25:00',5.63),('16100','2013-06-01','15:30:00',5.67),('16100','2013-06-01','15:35:00',3.7),('16100','2013-06-01','15:40:00',5.76),('16100','2013-06-01','15:45:00',6.83),('16100','2013-06-01','15:50:00',7.05),('16100','2013-06-01','15:55:00',6.14),('16100','2013-06-01','16:00:00',4.88),('16100','2013-06-01','16:05:00',5.56),('16100','2013-06-01','16:10:00',7.09),('16100','2013-06-01','16:15:00',4.12),('16100','2013-06-01','16:20:00',3.43),('16100','2013-06-01','16:25:00',4.54),('16100','2013-06-01','16:30:00',5.99),('16100','2013-06-01','16:35:00',4.83),('16100','2013-06-01','16:40:00',5.63),('16100','2013-06-01','16:45:00',4.89),('16100','2013-06-01','16:50:00',2.71),('16100','2013-06-01','16:55:00',4.37),('16100','2013-06-01','17:00:00',4.8),('16100','2013-06-01','17:05:00',4.66),('16100','2013-06-01','17:10:00',4.51),('16100','2013-06-01','17:15:00',3.35),('16100','2013-06-01','17:20:00',3.14),('16100','2013-06-01','17:25:00',3.91),('16100','2013-06-01','17:30:00',4.28),('16100','2013-06-01','17:35:00',3.16),('16100','2013-06-01','17:40:00',2.06),('16100','2013-06-01','17:45:00',2.29),('16100','2013-06-01','17:50:00',1.2),('16100','2013-06-01','17:55:00',1.65),('16100','2013-06-01','18:00:00',1.41),('16100','2013-06-01','18:05:00',1.34),('16100','2013-06-01','18:10:00',1.8),('16100','2013-06-01','18:15:00',1.12),('16100','2013-06-01','18:20:00',1.32),('16100','2013-06-01','18:25:00',1.3),('16100','2013-06-01','18:30:00',1.3),('16100','2013-06-01','18:35:00',1.2),('16100','2013-06-01','18:40:00',1.18),('16100','2013-06-01','18:45:00',1.08),('16100','2013-05-31','07:40:00',1.02),('16100','2013-05-31','07:45:00',1.13),('16100','2013-05-31','07:50:00',1.92),('16100','2013-05-31','07:55:00',1.45),('16100','2013-05-31','08:00:00',1.02),('16100','2013-05-31','08:05:00',1.26),('16100','2013-05-31','08:10:00',1.5),('16100','2013-05-31','08:30:00',1.41),('16100','2013-05-31','08:35:00',1.43),('16100','2013-05-31','08:40:00',1.07),('16100','2013-05-31','08:45:00',2.75),('16100','2013-05-31','08:50:00',1.29),('16100','2013-05-31','09:00:00',1.04),('16100','2013-05-31','09:45:00',1.05),('16100','2013-05-31','10:25:00',1.21),('16100','2013-05-31','10:30:00',1.57),('16100','2013-05-31','10:35:00',2.24),('16100','2013-05-31','10:40:00',2.09),('16100','2013-05-31','10:45:00',2.41),('16100','2013-05-31','10:50:00',3.87),('16100','2013-05-31','10:55:00',4.16),('16100','2013-05-31','11:00:00',1.51),('16100','2013-05-31','11:05:00',1.71),('16100','2013-05-31','11:10:00',1.48),('16100','2013-05-31','11:15:00',1.16),('16100','2013-05-31','11:20:00',1.71),('16100','2013-05-31','11:25:00',1.51),('16100','2013-05-31','11:30:00',1.29),('16100','2013-05-31','11:35:00',1.14),('16100','2013-05-31','11:40:00',1.16),('16100','2013-05-31','11:45:00',1.72),('16100','2013-05-31','11:50:00',2.73),('16100','2013-05-31','11:55:00',3.73),('16100','2013-05-31','12:00:00',1.27),('16100','2013-05-31','12:05:00',1.22),('16100','2013-05-31','12:10:00',1.57),('16100','2013-05-31','12:15:00',1.43),('16100','2013-05-31','12:20:00',1.65),('16100','2013-05-31','12:25:00',1.63),('16100','2013-05-31','12:30:00',1.68),('16100','2013-05-31','12:35:00',1.64),('16100','2013-05-31','12:40:00',2.78),('16100','2013-05-31','12:45:00',2.76),('16100','2013-05-31','12:50:00',2.48),('16100','2013-05-31','12:55:00',2.95),('16100','2013-05-31','13:00:00',2.73),('16100','2013-05-31','13:05:00',2.4),('16100','2013-05-31','13:10:00',2.46),('16100','2013-05-31','13:15:00',3.24),('16100','2013-05-31','13:20:00',3.46),('16100','2013-05-31','13:25:00',3.75),('16100','2013-05-31','13:30:00',3.22),('16100','2013-05-31','13:35:00',2.71),('16100','2013-05-31','13:40:00',2.95),('16100','2013-05-31','13:45:00',1.95),('16100','2013-05-31','13:50:00',2.1),('16100','2013-05-31','13:55:00',2.51),('16100','2013-05-31','14:00:00',4.2),('16100','2013-05-31','14:05:00',6.07),('16100','2013-05-31','14:10:00',4.59),('16100','2013-05-31','14:15:00',3.25),('16100','2013-05-31','14:20:00',3.51),('16100','2013-05-31','14:25:00',3.16),('16100','2013-05-31','14:30:00',2.12),('16100','2013-05-31','14:35:00',1.76),('16100','2013-05-31','14:40:00',1.32),('16100','2013-05-31','14:45:00',1.49),('16100','2013-05-31','14:50:00',1.78),('16100','2013-05-31','14:55:00',1.82),('16100','2013-05-31','15:00:00',1.45),('16100','2013-05-31','15:05:00',1.29),('16100','2013-05-31','15:10:00',1.14),('16100','2013-05-31','15:30:00',1.13),('16100','2013-05-31','15:35:00',1.45),('16100','2013-05-31','15:40:00',1.98),('16100','2013-05-31','15:45:00',2.36),('16100','2013-05-31','15:50:00',3.22),('16100','2013-05-31','15:55:00',2.88),('16100','2013-05-31','16:00:00',2.17),('16100','2013-05-31','16:05:00',1.8),('16100','2013-05-31','16:10:00',1.22),('16100','2013-05-31','16:15:00',1.74),('16100','2013-05-31','16:20:00',1.83),('16100','2013-05-31','16:25:00',1.73),('16100','2013-05-31','16:30:00',1.54),('16100','2013-05-31','16:35:00',1.37),('16100','2013-05-31','16:40:00',1.52),('16100','2013-05-31','16:45:00',1.57),('16100','2013-05-31','16:50:00',1.68),('16100','2013-05-31','16:55:00',1.66),('16100','2013-05-31','18:15:00',1.33),('16100','2013-05-31','18:20:00',1.29),('16100','2013-05-31','18:35:00',1.1),('16100','2013-05-31','18:40:00',1.2),('16100','2013-05-31','18:45:00',1.45),('16100','2013-05-31','18:50:00',1.69),('16100','2013-05-31','18:55:00',1.74),('16100','2013-05-31','19:00:00',1.17),('16100','2014-04-01','08:20:00',1.49),('16100','2014-04-01','08:25:00',1.51),('16100','2014-04-01','08:30:00',1.74),('16100','2014-04-01','08:35:00',1.36),('16100','2014-04-01','08:40:00',1.45),('16100','2014-04-01','09:10:00',1.38),('16100','2014-04-01','09:15:00',2.23),('16100','2014-04-01','09:20:00',2.56),('16100','2014-04-01','09:25:00',4.21),('16100','2014-04-01','09:30:00',4.86),('16100','2014-04-01','09:35:00',3.91),('16100','2014-04-01','09:40:00',2.42),('16100','2014-04-01','10:05:00',1.25),('16100','2014-04-01','10:10:00',1.74),('16100','2014-04-01','10:15:00',4.2),('16100','2014-04-01','10:20:00',6.29),('16100','2014-04-01','10:25:00',5.85),('16100','2014-04-01','10:30:00',3.79),('16100','2014-04-01','10:35:00',6.47),('16100','2014-04-01','10:40:00',5.64),('16100','2014-04-01','10:45:00',4.27),('16100','2014-04-01','10:50:00',2.05),('16100','2014-04-01','10:55:00',2.59),('16100','2014-04-01','11:00:00',2.96),('16100','2014-04-01','11:05:00',1.93),('16100','2014-04-01','11:10:00',1.64),('16100','2014-04-01','11:15:00',1.79),('16100','2014-04-01','11:20:00',1.73),('16100','2014-04-01','11:25:00',2.84),('16100','2014-04-01','11:30:00',7.96),('16100','2014-04-01','11:35:00',3.19),('16100','2014-04-01','11:40:00',1.94),('16100','2014-04-01','11:45:00',3.75),('16100','2014-04-01','11:50:00',4.51),('16100','2014-04-01','11:55:00',3.3),('16100','2014-04-01','12:00:00',6.94),('16100','2014-04-01','12:05:00',6.8),('16100','2014-04-01','12:10:00',7.47),('16100','2014-04-01','12:15:00',1.75),('16100','2014-04-01','12:20:00',4),('16100','2014-04-01','12:25:00',6.79),('16100','2014-04-01','12:30:00',6.37),('16100','2014-04-01','12:35:00',8.12),('16100','2014-04-01','12:40:00',5.87),('16100','2014-04-01','12:45:00',6.97),('16100','2014-04-01','12:50:00',8.32),('16100','2014-04-01','12:55:00',4.36),('16100','2014-04-01','13:00:00',3.96),('16100','2014-04-01','13:05:00',4.21),('16100','2014-04-01','13:10:00',4.08),('16100','2014-04-01','13:15:00',5.86),('16100','2014-04-01','13:20:00',6.1),('16100','2014-04-01','13:25:00',8.45),('16100','2014-04-01','13:30:00',7.11),('16100','2014-04-01','13:35:00',8.17),('16100','2014-04-01','13:40:00',7.91),('16100','2014-04-01','13:45:00',8.15),('16100','2014-04-01','13:50:00',8),('16100','2014-04-01','13:55:00',7.68),('16100','2014-04-01','14:00:00',7.91),('16100','2014-04-01','14:05:00',7.61),('16100','2014-04-01','14:10:00',7.56),('16100','2014-04-01','14:15:00',7.48),('16100','2014-04-01','14:20:00',7.46),('16100','2014-04-01','14:25:00',7.35),('16100','2014-04-01','14:30:00',7.26),('16100','2014-04-01','14:35:00',7.11),('16100','2014-04-01','14:40:00',7.2),('16100','2014-04-01','14:45:00',6.96),('16100','2014-04-01','14:50:00',6.3),('16100','2014-04-01','14:55:00',6.6),('16100','2014-04-01','15:00:00',6.71),('16100','2014-04-01','15:05:00',6.69),('16100','2014-04-01','15:10:00',6.09),('16100','2014-04-01','15:15:00',6.22),('16100','2014-04-01','15:20:00',6.19),('16100','2014-04-01','15:25:00',5.89),('16100','2014-04-01','15:30:00',5.58),('16100','2014-04-01','15:35:00',6.11),('16100','2014-04-01','15:40:00',6.1),('16100','2014-04-01','15:45:00',5.9),('16100','2014-04-01','15:50:00',5.43),('16100','2014-04-01','15:55:00',5.4),('16100','2014-04-01','16:00:00',5.49),('16100','2014-04-01','16:05:00',5.34),('16100','2014-04-01','16:10:00',5.24),('16100','2014-04-01','16:15:00',5.02),('16100','2014-04-01','16:20:00',4.85),('16100','2014-04-01','16:25:00',4.73),('16100','2014-04-01','16:30:00',4.69),('16100','2014-04-01','16:35:00',4.47),('16100','2014-04-01','16:40:00',4.43),('16100','2014-04-01','16:45:00',4.15),('16100','2014-04-01','16:50:00',3.88),('16100','2014-04-01','16:55:00',4.08),('16100','2014-04-01','17:00:00',3.99),('16100','2014-04-01','17:05:00',3.61),('16100','2014-04-01','17:10:00',3.52),('16100','2014-04-01','17:15:00',3.19),('16100','2014-04-01','17:20:00',3.12),('16100','2014-04-01','17:25:00',2.92),('16100','2014-04-01','17:30:00',2.55),('16100','2014-04-01','17:35:00',2.42),('16100','2014-04-01','17:40:00',1.96),('16100','2014-04-01','17:45:00',2.07),('16100','2014-04-01','17:50:00',2.27),('16100','2014-04-01','17:55:00',1.76),('16100','2014-04-01','18:00:00',1.3),('16100','2014-04-01','18:05:00',1.01),('16100','2014-04-01','18:15:00',1.03),('16100','2013-05-30','07:45:00',1.16),('16100','2013-05-30','07:50:00',1.4),('16100','2013-05-30','07:55:00',1.7),('16100','2013-05-30','08:00:00',1.59),('16100','2013-05-30','08:10:00',1.54),('16100','2013-05-30','08:15:00',2.13),('16100','2013-05-30','08:20:00',2.41),('16100','2013-05-30','08:25:00',2.67),('16100','2013-05-30','08:30:00',2.9),('16100','2013-05-30','08:35:00',3.26),('16100','2013-05-30','08:40:00',3.33),('16100','2013-05-30','08:45:00',2.49),('16100','2013-05-30','08:50:00',1.68),('16100','2013-05-30','08:55:00',1.32),('16100','2013-05-30','09:00:00',1.9),('16100','2013-05-30','09:05:00',4.2),('16100','2013-05-30','09:10:00',2.68),('16100','2013-05-30','09:15:00',3.55),('16100','2013-05-30','09:20:00',2.14),('16100','2013-05-30','09:25:00',4.14),('16100','2013-05-30','09:30:00',4.96),('16100','2013-05-30','09:35:00',4.4),('16100','2013-05-30','09:40:00',5.62),('16100','2013-05-30','09:45:00',5.88),('16100','2013-05-30','09:50:00',4.66),('16100','2013-05-30','09:55:00',5.66),('16100','2013-05-30','10:00:00',5.35),('16100','2013-05-30','10:05:00',5.16),('16100','2013-05-30','10:10:00',5.56),('16100','2013-05-30','10:15:00',3.35),('16100','2013-05-30','10:20:00',2),('16100','2013-05-30','10:25:00',1.97),('16100','2013-05-30','10:30:00',4.61),('16100','2013-05-30','10:35:00',7.37),('16100','2013-05-30','10:40:00',6.56),('16100','2013-05-30','10:45:00',7.98),('16100','2013-05-30','10:50:00',3.52),('16100','2013-05-30','10:55:00',4.06),('16100','2013-05-30','11:00:00',3.54),('16100','2013-05-30','11:05:00',4.27),('16100','2013-05-30','11:10:00',4.55),('16100','2013-05-30','11:15:00',8.44),('16100','2013-05-30','11:20:00',1.49),('16100','2013-05-30','11:25:00',7.8),('16100','2013-05-30','11:30:00',4.76),('16100','2013-05-30','11:35:00',1.65),('16100','2013-05-30','11:40:00',7.24),('16100','2013-05-30','11:45:00',1.81),('16100','2013-05-30','11:50:00',2.61),('16100','2013-05-30','11:55:00',3.83),('16100','2013-05-30','12:00:00',9.51),('16100','2013-05-30','12:05:00',5.47),('16100','2013-05-30','12:10:00',3.4),('16100','2013-05-30','12:15:00',5.05),('16100','2013-05-30','12:20:00',4.88),('16100','2013-05-30','12:25:00',6.11),('16100','2013-05-30','12:30:00',2.49),('16100','2013-05-30','12:35:00',3.14),('16100','2013-05-30','12:40:00',2.34),('16100','2013-05-30','12:50:00',4.15),('16100','2013-05-30','12:55:00',9.12),('16100','2013-05-30','13:00:00',5.11),('16100','2013-05-30','13:05:00',1.82),('16100','2013-05-30','13:10:00',1.57),('16100','2013-05-30','13:15:00',4.47),('16100','2013-05-30','13:20:00',6.99),('16100','2013-05-30','13:25:00',6.08),('16100','2013-05-30','13:30:00',3.34),('16100','2013-05-30','13:35:00',1.76),('16100','2013-05-30','13:40:00',2.27),('16100','2013-05-30','13:45:00',7.23),('16100','2013-05-30','13:50:00',7.82),('16100','2013-05-30','13:55:00',4.05),('16100','2013-05-30','14:00:00',1.52),('16100','2013-05-30','14:20:00',1.03),('16100','2013-05-30','14:25:00',1.97),('16100','2013-05-30','14:30:00',3.07),('16100','2013-05-30','14:35:00',1.41),('16100','2013-05-30','14:45:00',1.22),('16100','2013-05-30','14:55:00',2.12),('16100','2013-05-30','15:00:00',2.47),('16100','2013-05-30','15:05:00',2.21),('16100','2013-05-30','15:10:00',3.8),('16100','2013-05-30','15:15:00',5.05),('16100','2013-05-30','15:20:00',6.08),('16100','2013-05-30','15:25:00',4.17),('16100','2013-05-30','15:30:00',4.19),('16100','2013-05-30','15:35:00',3.35),('16100','2013-05-30','15:40:00',3),('16100','2013-05-30','15:45:00',4.68),('16100','2013-05-30','15:50:00',6.33),('16100','2013-05-30','15:55:00',4.26),('16100','2013-05-30','16:00:00',2.5),('16100','2013-05-30','16:05:00',1.7),('16100','2013-05-30','16:10:00',1.31),('16100','2013-05-30','16:15:00',1.19),('16100','2013-05-30','16:20:00',2.05),('16100','2013-05-30','16:25:00',1.99),('16100','2013-05-30','16:30:00',1.41),('16100','2013-05-30','16:35:00',1.35),('16100','2013-05-30','16:40:00',1.69),('16100','2013-05-30','16:45:00',1.41),('16100','2013-05-30','17:20:00',1.1),('16100','2013-05-30','17:25:00',1.22),('16100','2013-05-30','17:30:00',1.2),('16100','2013-05-30','17:35:00',1.14),('16100','2013-05-29','07:40:00',1.08),('16100','2013-05-29','07:45:00',1.77),('16100','2013-05-29','07:50:00',1.22),('16100','2013-05-29','07:55:00',1.28),('16100','2013-05-29','08:00:00',1.15),('16100','2013-05-29','08:05:00',1.07),('16100','2013-05-29','08:10:00',1.37),('16100','2013-05-29','08:15:00',1.36),('16100','2013-05-29','08:20:00',1.02),('16100','2013-05-29','08:25:00',1.09),('16100','2013-05-29','08:30:00',2.8),('16100','2013-05-29','08:35:00',3.2),('16100','2013-05-29','08:40:00',3.36),('16100','2013-05-29','08:45:00',3.53),('16100','2013-05-29','08:50:00',3.65),('16100','2013-05-29','08:55:00',3.89),('16100','2013-05-29','09:00:00',4.17),('16100','2013-05-29','09:05:00',4.44),('16100','2013-05-29','09:10:00',4.66),('16100','2013-05-29','09:15:00',5),('16100','2013-05-29','09:20:00',5.39),('16100','2013-05-29','09:25:00',5.53),('16100','2013-05-29','09:30:00',4.6),('16100','2013-05-29','09:35:00',5.22),('16100','2013-05-29','09:40:00',4.32),('16100','2013-05-29','09:45:00',4.4),('16100','2013-05-29','09:50:00',2.54),('16100','2013-05-29','09:55:00',3.67),('16100','2013-05-29','10:00:00',2.8),('16100','2013-05-29','10:05:00',4.45),('16100','2013-05-29','10:10:00',4.17),('16100','2013-05-29','10:15:00',5.35),('16100','2013-05-29','10:20:00',4.58),('16100','2013-05-29','10:25:00',3.73),('16100','2013-05-29','10:30:00',1.51),('16100','2013-05-29','10:35:00',1.05),('16100','2013-05-29','10:40:00',6.84),('16100','2013-05-29','10:45:00',8.23),('16100','2013-05-29','10:50:00',8.02),('16100','2013-05-29','10:55:00',7.15),('16100','2013-05-29','11:00:00',8.12),('16100','2013-05-29','11:05:00',5.42),('16100','2013-05-29','11:10:00',7.17),('16100','2013-05-29','11:15:00',3.79),('16100','2013-05-29','11:20:00',6.22),('16100','2013-05-29','11:25:00',8.05),('16100','2013-05-29','11:30:00',2.77),('16100','2013-05-29','11:35:00',6.83),('16100','2013-05-29','11:40:00',8.81),('16100','2013-05-29','11:45:00',5.71),('16100','2013-05-29','11:50:00',3.88),('16100','2013-05-29','11:55:00',8.94),('16100','2013-05-29','12:00:00',2.81),('16100','2013-05-29','12:05:00',1.68),('16100','2013-05-29','12:10:00',7.79),('16100','2013-05-29','12:15:00',8.44),('16100','2013-05-29','12:20:00',6.06),('16100','2013-05-29','12:25:00',5.88),('16100','2013-05-29','12:30:00',8.28),('16100','2013-05-29','12:35:00',9.32),('16100','2013-05-29','12:40:00',6.5),('16100','2013-05-29','12:45:00',4.42),('16100','2013-05-29','12:50:00',8.21),('16100','2013-05-29','12:55:00',5.2),('16100','2013-05-29','13:00:00',7.86),('16100','2013-05-29','13:05:00',9.48),('16100','2013-05-29','13:10:00',3.35),('16100','2013-05-29','13:15:00',3.56),('16100','2013-05-29','13:20:00',5.55),('16100','2013-05-29','13:25:00',4.87),('16100','2013-05-29','13:30:00',6.8),('16100','2013-05-29','13:35:00',3.93),('16100','2013-05-29','13:40:00',3.32),('16100','2013-05-29','13:45:00',4.42),('16100','2013-05-29','13:50:00',8.42),('16100','2013-05-29','13:55:00',8.46),('16100','2013-05-29','14:00:00',8.21),('16100','2013-05-29','14:05:00',3.59),('16100','2013-05-29','14:10:00',5.01),('16100','2013-05-29','14:15:00',4.74),('16100','2013-05-29','14:20:00',6.39),('16100','2013-05-29','14:25:00',2.89),('16100','2013-05-29','14:30:00',4.03),('16100','2013-05-29','14:35:00',2.57),('16100','2013-05-29','14:40:00',7.11),('16100','2013-05-29','14:45:00',2.84),('16100','2013-05-29','14:50:00',3.26),('16100','2013-05-29','14:55:00',3.96),('16100','2013-05-29','15:00:00',3.27),('16100','2013-05-29','15:05:00',4.99),('16100','2013-05-29','15:10:00',6.09),('16100','2013-05-29','15:15:00',2.46),('16100','2013-05-29','15:20:00',6.01),('16100','2013-05-29','15:25:00',2.69),('16100','2013-05-29','15:30:00',4.73),('16100','2013-05-29','15:35:00',3.17),('16100','2013-05-29','15:40:00',8.68),('16100','2013-05-29','15:45:00',7.46),('16100','2013-05-29','15:50:00',2.56),('16100','2013-05-29','15:55:00',1.78),('16100','2013-05-29','16:00:00',6.49),('16100','2013-05-29','16:05:00',7.13),('16100','2013-05-29','16:10:00',7),('16100','2013-05-29','16:15:00',4.73),('16100','2013-05-29','16:20:00',1.25),('16100','2013-05-29','16:25:00',1.75),('16100','2013-05-29','16:30:00',1.7),('16100','2013-05-29','16:35:00',1.75),('16100','2013-05-29','16:40:00',4.49),('16100','2013-05-29','16:45:00',5.3),('16100','2013-05-29','16:50:00',1.97),('16100','2013-05-29','16:55:00',2.22),('16100','2013-05-29','17:00:00',4.02),('16100','2013-05-29','17:05:00',2.06),('16100','2013-05-29','17:10:00',2.41),('16100','2013-05-29','17:15:00',1.32),('16100','2013-05-29','17:55:00',1.5),('16100','2013-05-29','18:00:00',1.7),('16100','2013-05-29','18:05:00',2.47),('16100','2013-05-29','18:10:00',1.99),('16100','2013-05-29','18:15:00',1.14),('16100','2013-05-29','18:20:00',1.23),('16100','2013-05-29','18:25:00',2.25),('16100','2013-05-29','18:30:00',2.57),('16100','2013-05-29','18:35:00',2.59),('16100','2013-05-29','18:40:00',2.19),('16100','2013-05-29','18:45:00',1.75),('16100','2013-05-29','18:50:00',1.01),('16100','2013-05-28','07:45:00',1.08),('16100','2013-05-28','07:50:00',1.31),('16100','2013-05-28','07:55:00',1.52),('16100','2013-05-28','08:00:00',1.72),('16100','2013-05-28','08:05:00',1.9),('16100','2013-05-28','08:10:00',2.1),('16100','2013-05-28','08:15:00',2.29),('16100','2013-05-28','08:20:00',2.44),('16100','2013-05-28','08:25:00',2.61),('16100','2013-05-28','08:30:00',2.8),('16100','2013-05-28','08:35:00',2.98),('16100','2013-05-28','08:40:00',3.15),('16100','2013-05-28','08:45:00',3.38),('16100','2013-05-28','08:50:00',3.52),('16100','2013-05-28','08:55:00',3.71),('16100','2013-05-28','09:00:00',3.96),('16100','2013-05-28','09:05:00',4.31),('16100','2013-05-28','09:10:00',4.47),('16100','2013-05-28','09:15:00',4.63),('16100','2013-05-28','09:20:00',4.77),('16100','2013-05-28','09:25:00',4.93),('16100','2013-05-28','09:30:00',5.07),('16100','2013-05-28','09:35:00',5.2),('16100','2013-05-28','09:40:00',5.37),('16100','2013-05-28','09:45:00',5.5),('16100','2013-05-28','09:50:00',5.64),('16100','2013-05-28','09:55:00',5.75),('16100','2013-05-28','10:00:00',5.94),('16100','2013-05-28','10:05:00',6.08),('16100','2013-05-28','10:10:00',6.22),('16100','2013-05-28','10:15:00',6.34),('16100','2013-05-28','10:20:00',6.52),('16100','2013-05-28','10:25:00',6.66),('16100','2013-05-28','10:30:00',6.79),('16100','2013-05-28','10:35:00',6.9),('16100','2013-05-28','10:40:00',6.99),('16100','2013-05-28','10:45:00',7.12),('16100','2013-05-28','10:50:00',7.28),('16100','2013-05-28','10:55:00',7.55),('16100','2013-05-28','11:00:00',7.36),('16100','2013-05-28','11:05:00',7.86),('16100','2013-05-28','11:10:00',8.01),('16100','2013-05-28','11:15:00',8.31),('16100','2013-05-28','11:20:00',8.53),('16100','2013-05-28','11:25:00',5.17),('16100','2013-05-28','11:30:00',4.6),('16100','2013-05-28','11:35:00',5.88),('16100','2013-05-28','11:40:00',6.91),('16100','2013-05-28','11:45:00',8.01),('16100','2013-05-28','11:50:00',7.66),('16100','2013-05-28','11:55:00',8.79),('16100','2013-05-28','12:00:00',8.36),('16100','2013-05-28','12:05:00',3.64),('16100','2013-05-28','12:10:00',8.47),('16100','2013-05-28','12:15:00',8.49),('16100','2013-05-28','12:20:00',8.49),('16100','2013-05-28','12:25:00',8.42),('16100','2013-05-28','12:30:00',6.78),('16100','2013-05-28','12:35:00',8.5),('16100','2013-05-28','12:40:00',8.62),('16100','2013-05-28','12:45:00',8.45),('16100','2013-05-28','12:50:00',8.47),('16100','2013-05-28','12:55:00',8.59),('16100','2013-05-28','13:00:00',8.64),('16100','2013-05-28','13:05:00',8.63),('16100','2013-05-28','13:10:00',8.88),('16100','2013-05-28','13:15:00',6.69),('16100','2013-05-28','13:20:00',3.95),('16100','2013-05-28','13:25:00',9.39),('16100','2013-05-28','13:30:00',6.86),('16100','2013-05-28','13:35:00',4.27),('16100','2013-05-28','13:40:00',5.43),('16100','2013-05-28','13:45:00',3.71),('16100','2013-05-28','13:50:00',6.56),('16100','2013-05-28','13:55:00',8.46),('16100','2013-05-28','14:00:00',7.06),('16100','2013-05-28','14:05:00',4.81),('16100','2013-05-28','14:10:00',5.95),('16100','2013-05-28','14:15:00',8.52),('16100','2013-05-28','14:20:00',8.24),('16100','2013-05-28','14:25:00',8.35),('16100','2013-05-28','14:30:00',8.21),('16100','2013-05-28','14:35:00',7.42),('16100','2013-05-28','14:40:00',3.48),('16100','2013-05-28','14:45:00',5.23),('16100','2013-05-28','14:50:00',5.31),('16100','2013-05-28','14:55:00',4.94),('16100','2013-05-28','15:00:00',8.1),('16100','2013-05-28','15:05:00',5.17),('16100','2013-05-28','15:10:00',6.48),('16100','2013-05-28','15:15:00',6.26),('16100','2013-05-28','15:20:00',5.45),('16100','2013-05-28','15:25:00',6.55),('16100','2013-05-28','15:30:00',6.59),('16100','2013-05-28','15:35:00',6.44),('16100','2013-05-28','15:40:00',6.16),('16100','2013-05-28','15:45:00',5.78),('16100','2013-05-28','15:50:00',5.08),('16100','2013-05-28','15:55:00',5.16),('16100','2013-05-28','16:00:00',4.41),('16100','2013-05-28','16:05:00',4.22),('16100','2013-05-28','16:10:00',4.29),('16100','2013-05-28','16:15:00',4.12),('16100','2013-05-28','16:20:00',4.24),('16100','2013-05-28','16:25:00',4.25),('16100','2013-05-28','16:30:00',4.69),('16100','2013-05-28','16:35:00',4.24),('16100','2013-05-28','16:40:00',3.18),('16100','2013-05-28','16:45:00',2.96),('16100','2013-05-28','16:50:00',2.27),('16100','2013-05-28','16:55:00',1.88),('16100','2013-05-28','17:00:00',1.35),('16100','2013-05-28','17:25:00',1.05),('16100','2013-05-28','17:30:00',1.83),('16100','2013-05-28','17:35:00',2.63),('16100','2013-05-28','17:40:00',2.63),('16100','2013-05-28','17:45:00',1.78),('16100','2013-05-28','17:50:00',1.34),('16100','2013-05-28','17:55:00',1.88),('16100','2013-05-28','18:00:00',1.95),('16100','2013-05-28','18:05:00',1.66),('16100','2013-05-28','18:10:00',2.5),('16100','2013-05-28','18:15:00',3.25),('16100','2013-05-28','18:20:00',1.8),('16100','2013-05-28','18:55:00',1.22),('16100','2013-05-28','19:00:00',1.08),('16100','2013-05-27','07:30:00',1.18),('16100','2013-05-27','07:35:00',1.16),('16100','2013-05-27','07:40:00',1.16),('16100','2013-05-27','07:45:00',1.4),('16100','2013-05-27','07:50:00',1.52),('16100','2013-05-27','07:55:00',1.49),('16100','2013-05-27','08:00:00',1.37),('16100','2013-05-27','08:05:00',1.71),('16100','2013-05-27','08:10:00',1.77),('16100','2013-05-27','08:15:00',2.13),('16100','2013-05-27','08:20:00',2.25),('16100','2013-05-27','08:25:00',1.99),('16100','2013-05-27','08:30:00',2.52),('16100','2013-05-27','08:35:00',2.66),('16100','2013-05-27','08:40:00',2.47),('16100','2013-05-27','08:45:00',2.11),('16100','2013-05-27','08:50:00',2.43),('16100','2013-05-27','08:55:00',2.48),('16100','2013-05-27','09:00:00',2.33),('16100','2013-05-27','09:05:00',2.88),('16100','2013-05-27','09:10:00',3.01),('16100','2013-05-27','09:15:00',3.35),('16100','2013-05-27','09:20:00',3.34),('16100','2013-05-27','09:25:00',3.47),('16100','2013-05-27','09:30:00',3.84),('16100','2013-05-27','09:35:00',4.32),('16100','2013-05-27','09:40:00',4.18),('16100','2013-05-27','09:45:00',4.29),('16100','2013-05-27','09:50:00',4.01),('16100','2013-05-27','09:55:00',4.16),('16100','2013-05-27','10:00:00',3.51),('16100','2013-05-27','10:05:00',3.44),('16100','2013-05-27','10:10:00',3.89),('16100','2013-05-27','10:15:00',4.16),('16100','2013-05-27','10:20:00',4.13),('16100','2013-05-27','10:25:00',4.07),('16100','2013-05-27','10:30:00',4.51),('16100','2013-05-27','10:35:00',5.11),('16100','2013-05-27','10:40:00',5.13),('16100','2013-05-27','10:45:00',4.69),('16100','2013-05-27','10:50:00',4.14),('16100','2013-05-27','10:55:00',4.88),('16100','2013-05-27','11:00:00',4.98),('16100','2013-05-27','11:05:00',5.13),('16100','2013-05-27','11:10:00',5.31),('16100','2013-05-27','11:15:00',5.51),('16100','2013-05-27','11:20:00',3.22),('16100','2013-05-27','11:25:00',4.96),('16100','2013-05-27','11:30:00',6.89),('16100','2013-05-27','11:35:00',6.8),('16100','2013-05-27','11:40:00',6.95),('16100','2013-05-27','11:45:00',4.83),('16100','2013-05-27','11:50:00',1.84),('16100','2013-05-27','11:55:00',1.95),('16100','2013-05-27','12:00:00',3.11),('16100','2013-05-27','12:05:00',3.69),('16100','2013-05-27','12:10:00',3.76),('16100','2013-05-27','12:15:00',4.29),('16100','2013-05-27','12:20:00',3.88),('16100','2013-05-27','12:25:00',4.09),('16100','2013-05-27','12:30:00',5.44),('16100','2013-05-27','12:35:00',3.95),('16100','2013-05-27','12:40:00',4.06),('16100','2013-05-27','12:45:00',3.92),('16100','2013-05-27','12:50:00',4),('16100','2013-05-27','12:55:00',4.54),('16100','2013-05-27','13:00:00',4.73),('16100','2013-05-27','13:05:00',4.87),('16100','2013-05-27','13:10:00',4.5),('16100','2013-05-27','13:15:00',3.19),('16100','2013-05-27','13:20:00',3.65),('16100','2013-05-27','13:25:00',6.36),('16100','2013-05-27','13:30:00',6.35),('16100','2013-05-27','13:35:00',6.98),('16100','2013-05-27','13:40:00',4.94),('16100','2013-05-27','13:45:00',4.17),('16100','2013-05-27','13:50:00',3.18),('16100','2013-05-27','13:55:00',3.06),('16100','2013-05-27','14:00:00',3.09),('16100','2013-05-27','14:05:00',4.04),('16100','2013-05-27','14:10:00',4.22),('16100','2013-05-27','14:15:00',5.36),('16100','2013-05-27','14:20:00',5.9),('16100','2013-05-27','14:25:00',5.22),('16100','2013-05-27','14:30:00',5.44),('16100','2013-05-27','14:35:00',6.47),('16100','2013-05-27','14:40:00',5.18),('16100','2013-05-27','14:45:00',5.14),('16100','2013-05-27','14:50:00',6.24),('16100','2013-05-27','14:55:00',6.09),('16100','2013-05-27','15:00:00',6.53),('16100','2013-05-27','15:05:00',4.4),('16100','2013-05-27','15:10:00',3.01),('16100','2013-05-27','15:15:00',3.8),('16100','2013-05-27','15:20:00',4.46),('16100','2013-05-27','15:25:00',2.98),('16100','2013-05-27','15:30:00',2.91),('16100','2013-05-27','15:35:00',3.4),('16100','2013-05-27','15:40:00',2.76),('16100','2013-05-27','15:45:00',3.72),('16100','2013-05-27','15:50:00',3.77),('16100','2013-05-27','15:55:00',5.08),('16100','2013-05-27','16:00:00',5.81),('16100','2013-05-27','16:05:00',3.49),('16100','2013-05-27','16:10:00',2.9),('16100','2013-05-27','16:15:00',3.05),('16100','2013-05-27','16:20:00',5.4),('16100','2013-05-27','16:25:00',4.64),('16100','2013-05-27','16:30:00',2.18),('16100','2013-05-27','16:35:00',2.3),('16100','2013-05-27','16:40:00',4.82),('16100','2013-05-27','16:45:00',4.97),('16100','2013-05-27','16:50:00',4.77),('16100','2013-05-27','16:55:00',4.61),('16100','2013-05-27','17:00:00',4.47),('16100','2013-05-27','17:05:00',4.32),('16100','2013-05-27','17:10:00',4.21),('16100','2013-05-27','17:15:00',4.04),('16100','2013-05-27','17:20:00',3.88),('16100','2013-05-27','17:25:00',3.76),('16100','2013-05-27','17:30:00',3.61),('16100','2013-05-27','17:35:00',3.42),('16100','2013-05-27','17:40:00',3.2),('16100','2013-05-27','17:45:00',3.08),('16100','2013-05-27','17:50:00',2.93),('16100','2013-05-27','17:55:00',2.74),('16100','2013-05-27','18:00:00',2.43),('16100','2013-05-27','18:05:00',1.55),('16100','2013-05-27','18:10:00',1.52),('16100','2013-05-27','18:15:00',2.11),('16100','2013-05-27','18:20:00',2.17),('16100','2013-05-27','18:25:00',1.91),('16100','2013-05-27','18:30:00',1.65),('16100','2013-05-27','18:35:00',1.41),('16100','2013-05-27','18:40:00',1.29),('16100','2013-05-27','18:45:00',1.16),('16100','2013-05-27','18:50:00',1.02),('16100','2013-05-26','07:45:00',1.02),('16100','2013-05-26','07:50:00',1.51),('16100','2013-05-26','07:55:00',1.56),('16100','2013-05-26','08:00:00',1.34),('16100','2013-05-26','08:05:00',2.46),('16100','2013-05-26','08:10:00',1.6),('16100','2013-05-26','08:15:00',1.31),('16100','2013-05-26','08:20:00',1.28),('16100','2013-05-26','08:25:00',2.29),('16100','2013-05-26','08:30:00',2.96),('16100','2013-05-26','08:35:00',3.28),('16100','2013-05-26','08:40:00',3.41),('16100','2013-05-26','08:45:00',3.8),('16100','2013-05-26','08:50:00',3.3),('16100','2013-05-26','08:55:00',3.68),('16100','2013-05-26','09:00:00',4.87),('16100','2013-05-26','09:05:00',3.45),('16100','2013-05-26','09:10:00',2.31),('16100','2013-05-26','09:15:00',5.31),('16100','2013-05-26','09:20:00',5.56),('16100','2013-05-26','09:25:00',5.36),('16100','2013-05-26','09:30:00',4.03),('16100','2013-05-26','09:35:00',5.55),('16100','2013-05-26','09:40:00',5.61),('16100','2013-05-26','09:45:00',5.43),('16100','2013-05-26','09:50:00',5.94),('16100','2013-05-26','09:55:00',6.07),('16100','2013-05-26','10:00:00',4.62),('16100','2013-05-26','10:05:00',6.56),('16100','2013-05-26','10:10:00',6.9),('16100','2013-05-26','10:15:00',6.79),('16100','2013-05-26','10:20:00',7.12),('16100','2013-05-26','10:25:00',5.82),('16100','2013-05-26','10:30:00',6.51),('16100','2013-05-26','10:35:00',7.77),('16100','2013-05-26','10:40:00',3.77),('16100','2013-05-26','10:45:00',4.6),('16100','2013-05-26','10:50:00',5.18),('16100','2013-05-26','10:55:00',5.37),('16100','2013-05-26','11:00:00',5.8),('16100','2013-05-26','11:05:00',7.01),('16100','2013-05-26','11:10:00',7.72),('16100','2013-05-26','11:15:00',2.94),('16100','2013-05-26','11:20:00',5.75),('16100','2013-05-26','11:25:00',8.29),('16100','2013-05-26','11:30:00',6.07),('16100','2013-05-26','11:35:00',5.72),('16100','2013-05-26','11:40:00',3.9),('16100','2013-05-26','11:45:00',7.81),('16100','2013-05-26','11:50:00',5.51),('16100','2013-05-26','11:55:00',4.01),('16100','2013-05-26','12:00:00',9.18),('16100','2013-05-26','12:05:00',7.21),('16100','2013-05-26','12:10:00',9.09),('16100','2013-05-26','12:15:00',4.68),('16100','2013-05-26','12:20:00',6.71),('16100','2013-05-26','12:25:00',9),('16100','2013-05-26','12:30:00',8.77),('16100','2013-05-26','12:35:00',8.59),('16100','2013-05-26','12:40:00',8.64),('16100','2013-05-26','12:45:00',8.7),('16100','2013-05-26','12:50:00',8.83),('16100','2013-05-26','12:55:00',8.75),('16100','2013-05-26','13:00:00',8.87),('16100','2013-05-26','13:05:00',8.6),('16100','2013-05-26','13:10:00',8.16),('16100','2013-05-26','13:15:00',8.13),('16100','2013-05-26','13:20:00',8.17),('16100','2013-05-26','13:25:00',8.5),('16100','2013-05-26','13:30:00',7.87),('16100','2013-05-26','13:35:00',8.24),('16100','2013-05-26','13:40:00',8.66),('16100','2013-05-26','13:45:00',7.31),('16100','2013-05-26','13:50:00',8.56),('16100','2013-05-26','13:55:00',8.36),('16100','2013-05-26','14:00:00',8.13),('16100','2013-05-26','14:05:00',8.38),('16100','2013-05-26','14:10:00',8.27),('16100','2013-05-26','14:15:00',8.01),('16100','2013-05-26','14:20:00',8.15),('16100','2013-05-26','14:25:00',8.13),('16100','2013-05-26','14:30:00',8.16),('16100','2013-05-26','14:35:00',8.17),('16100','2013-05-26','14:40:00',8.07),('16100','2013-05-26','14:45:00',8.1),('16100','2013-05-26','14:50:00',7.73),('16100','2013-05-26','14:55:00',6.56),('16100','2013-05-26','15:00:00',3.85),('16100','2013-05-26','15:05:00',7.74),('16100','2013-05-26','15:10:00',7.56),('16100','2013-05-26','15:15:00',5.2),('16100','2013-05-26','15:20:00',5.7),('16100','2013-05-26','15:25:00',7.29),('16100','2013-05-26','15:30:00',7.12),('16100','2013-05-26','15:35:00',6.84),('16100','2013-05-26','15:40:00',4.52),('16100','2013-05-26','15:45:00',6.33),('16100','2013-05-26','15:50:00',6.43),('16100','2013-05-26','15:55:00',5.69),('16100','2013-05-26','16:00:00',6.25),('16100','2013-05-26','16:05:00',5.08),('16100','2013-05-26','16:10:00',3.83),('16100','2013-05-26','16:15:00',4.58),('16100','2013-05-26','16:20:00',6.68),('16100','2013-05-26','16:25:00',6.07),('16100','2013-05-26','16:30:00',5.49),('16100','2013-05-26','16:35:00',5.7),('16100','2013-05-26','16:40:00',2.82),('16100','2013-05-26','16:45:00',2.12),('16100','2013-05-26','16:50:00',2.15),('16100','2013-05-26','16:55:00',2.31),('16100','2013-05-26','17:00:00',2.44),('16100','2013-05-26','17:05:00',2.65),('16100','2013-05-26','17:10:00',2.85),('16100','2013-05-26','17:15:00',2.16),('16100','2013-05-26','17:20:00',1.94),('16100','2013-05-26','17:25:00',1.88),('16100','2013-05-26','17:30:00',1.79),('16100','2013-05-26','17:35:00',1.62),('16100','2013-05-26','17:40:00',1.5),('16100','2013-05-26','17:45:00',1.43),('16100','2013-05-26','17:50:00',1.38),('16100','2013-05-26','17:55:00',1.42),('16100','2013-05-26','18:00:00',1.33),('16100','2013-05-26','18:05:00',1.26),('16100','2013-05-26','18:10:00',1.45),('16100','2013-05-26','18:15:00',1.47),('16100','2013-05-26','18:20:00',2.15),('16100','2013-05-26','18:25:00',2.67),('16100','2013-05-26','18:30:00',2.32),('16100','2013-05-26','18:35:00',1.24),('16100','2013-05-26','18:55:00',1.26),('16100','2013-05-26','19:00:00',1.32),('16100','2013-05-26','19:05:00',1.2),('16100','2013-05-25','07:40:00',1.11),('16100','2013-05-25','07:45:00',2.02),('16100','2013-05-25','07:50:00',1.11),('16100','2013-05-25','07:55:00',1.21),('16100','2013-05-25','08:00:00',1.65),('16100','2013-05-25','08:05:00',2.02),('16100','2013-05-25','08:10:00',1.88),('16100','2013-05-25','08:15:00',3.26),('16100','2013-05-25','08:20:00',2.22),('16100','2013-05-25','08:25:00',2.08),('16100','2013-05-25','08:30:00',1.8),('16100','2013-05-25','08:35:00',2.25),('16100','2013-05-25','08:40:00',3.62),('16100','2013-05-25','08:45:00',2.53),('16100','2013-05-25','08:50:00',1.64),('16100','2013-05-25','08:55:00',1.82),('16100','2013-05-25','09:00:00',3),('16100','2013-05-25','09:05:00',1.98),('16100','2013-05-25','09:10:00',3.06),('16100','2013-05-25','09:15:00',1.69),('16100','2013-05-25','09:20:00',1.41),('16100','2013-05-25','09:25:00',2.39),('16100','2013-05-25','09:30:00',3.55),('16100','2013-05-25','09:40:00',4.17),('16100','2013-05-25','09:50:00',1.02),('16100','2013-05-25','09:55:00',4.45),('16100','2013-05-25','10:00:00',6.02),('16100','2013-05-25','10:05:00',1.58),('16100','2013-05-25','10:10:00',5.35),('16100','2013-05-25','10:15:00',6.08),('16100','2013-05-25','10:20:00',7.13),('16100','2013-05-25','10:25:00',5.79),('16100','2013-05-25','10:30:00',7.38),('16100','2013-05-25','10:35:00',7.29),('16100','2013-05-25','10:40:00',7.37),('16100','2013-05-25','10:45:00',7.46),('16100','2013-05-25','10:50:00',7.53),('16100','2013-05-25','10:55:00',7.65),('16100','2013-05-25','11:00:00',7.77),('16100','2013-05-25','11:05:00',7.97),('16100','2013-05-25','11:10:00',7.98),('16100','2013-05-25','11:15:00',8.04),('16100','2013-05-25','11:20:00',6.94),('16100','2013-05-25','11:25:00',8.22),('16100','2013-05-25','11:30:00',8.28),('16100','2013-05-25','11:35:00',8.39),('16100','2013-05-25','11:40:00',8.34),('16100','2013-05-25','11:45:00',8.44),('16100','2013-05-25','11:50:00',8.51),('16100','2013-05-25','11:55:00',8.59),('16100','2013-05-25','12:00:00',8.68),('16100','2013-05-25','12:05:00',8.87),('16100','2013-05-25','12:10:00',8.96),('16100','2013-05-25','12:15:00',8.1),('16100','2013-05-25','12:20:00',9.06),('16100','2013-05-25','12:25:00',9.15),('16100','2013-05-25','12:30:00',6),('16100','2013-05-25','12:35:00',2.96),('16100','2013-05-25','12:40:00',5.06),('16100','2013-05-25','12:45:00',6.15),('16100','2013-05-25','12:50:00',5.17),('16100','2013-05-25','12:55:00',6.85),('16100','2013-05-25','13:00:00',9.28),('16100','2013-05-25','13:05:00',8.83),('16100','2013-05-25','13:10:00',8.94),('16100','2013-05-25','13:15:00',8.9),('16100','2013-05-25','13:20:00',8.99),('16100','2013-05-25','13:25:00',6.91),('16100','2013-05-25','13:30:00',8.86),('16100','2013-05-25','13:35:00',8.85),('16100','2013-05-25','13:40:00',8.8),('16100','2013-05-25','13:45:00',8.83),('16100','2013-05-25','13:50:00',8.73),('16100','2013-05-25','13:55:00',8.67),('16100','2013-05-25','14:00:00',8.58),('16100','2013-05-25','14:05:00',8.49),('16100','2013-05-25','14:10:00',8.48),('16100','2013-05-25','14:15:00',8.46),('16100','2013-05-25','14:20:00',8.38),('16100','2013-05-25','14:25:00',8.34),('16100','2013-05-25','14:30:00',8.28),('16100','2013-05-25','14:35:00',8.24),('16100','2013-05-25','14:40:00',8.16),('16100','2013-05-25','14:45:00',8.12),('16100','2013-05-25','14:50:00',8.07),('16100','2013-05-25','14:55:00',7.96),('16100','2013-05-25','15:00:00',7.89),('16100','2013-05-25','15:05:00',7.81),('16100','2013-05-25','15:10:00',7.79),('16100','2013-05-25','15:15:00',7.65),('16100','2013-05-25','15:20:00',7.48),('16100','2013-05-25','15:25:00',7.38),('16100','2013-05-25','15:30:00',7.31),('16100','2013-05-25','15:35:00',7.2),('16100','2013-05-25','15:40:00',7.15),('16100','2013-05-25','15:45:00',7.08),('16100','2013-05-25','15:50:00',6.93),('16100','2013-05-25','15:55:00',6.83),('16100','2013-05-25','16:00:00',6.74),('16100','2013-05-25','16:05:00',6.62),('16100','2013-05-25','16:10:00',6.49),('16100','2013-05-25','16:15:00',6.31),('16100','2013-05-25','16:20:00',6.15),('16100','2013-05-25','16:25:00',6.02),('16100','2013-05-25','16:30:00',5.91),('16100','2013-05-25','16:35:00',5.76),('16100','2013-05-25','16:40:00',5.62),('16100','2013-05-25','16:45:00',5.46),('16100','2013-05-25','16:50:00',5.34),('16100','2013-05-25','16:55:00',5.22),('16100','2013-05-25','17:00:00',5.04),('16100','2013-05-25','17:05:00',4.84),('16100','2013-05-25','17:10:00',4.7),('16100','2013-05-25','17:15:00',4.56),('16100','2013-05-25','17:20:00',4.4),('16100','2013-05-25','17:25:00',4.23),('16100','2013-05-25','17:30:00',4.02),('16100','2013-05-25','17:35:00',3.83),('16100','2013-05-25','17:40:00',3.67),('16100','2013-05-25','17:45:00',3.51),('16100','2013-05-25','17:50:00',3.35),('16100','2013-05-25','17:55:00',3.14),('16100','2013-05-25','18:00:00',2.99),('16100','2013-05-25','18:05:00',2.81),('16100','2013-05-25','18:10:00',2.61),('16100','2013-05-25','18:15:00',2.35),('16100','2013-05-25','18:20:00',2.05),('16100','2013-05-25','18:25:00',1.94),('16100','2013-05-25','18:30:00',1.79),('16100','2013-05-25','18:35:00',1.62),('16100','2013-05-25','18:40:00',1.46),('16100','2013-05-25','18:45:00',1.29),('16100','2013-05-25','18:50:00',1.11),('16100','2013-05-24','07:35:00',1.22),('16100','2013-05-24','07:40:00',1.44),('16100','2013-05-24','07:45:00',1.57),('16100','2013-05-24','07:50:00',1.96),('16100','2013-05-24','07:55:00',1.96),('16100','2013-05-24','08:00:00',1.01),('16100','2013-05-24','08:15:00',1.26),('16100','2013-05-24','08:20:00',2.69),('16100','2013-05-24','08:25:00',2.89),('16100','2013-05-24','08:30:00',1.41),('16100','2013-05-24','08:35:00',2.87),('16100','2013-05-24','08:40:00',2.41),('16100','2013-05-24','08:45:00',2.45),('16100','2013-05-24','08:50:00',3.29),('16100','2013-05-24','08:55:00',4.48),('16100','2013-05-24','09:00:00',3.6),('16100','2013-05-24','09:05:00',4.03),('16100','2013-05-24','09:10:00',1.79),('16100','2013-05-24','09:15:00',1.62),('16100','2013-05-24','09:20:00',2.04),('16100','2013-05-24','09:25:00',4.16),('16100','2013-05-24','09:30:00',4.12),('16100','2013-05-24','09:35:00',2.34),('16100','2013-05-24','09:40:00',2.78),('16100','2013-05-24','09:45:00',3.17),('16100','2013-05-24','09:50:00',2.64),('16100','2013-05-24','09:55:00',1.33),('16100','2013-05-24','10:05:00',1.73),('16100','2013-05-24','10:10:00',2.11),('16100','2013-05-24','10:20:00',1.19),('16100','2013-05-24','10:30:00',1.82),('16100','2013-05-24','10:35:00',2.37),('16100','2013-05-24','10:40:00',1.17),('16100','2013-05-24','10:50:00',1.76),('16100','2013-05-24','10:55:00',1.75),('16100','2013-05-24','11:00:00',3.9),('16100','2013-05-24','11:05:00',7.53),('16100','2013-05-24','11:10:00',2.7),('16100','2013-05-24','11:15:00',3.65),('16100','2013-05-24','11:20:00',1.05),('16100','2013-05-24','11:25:00',1.57),('16100','2013-05-24','11:30:00',3.56),('16100','2013-05-24','11:35:00',2.63),('16100','2013-05-24','11:40:00',4.62),('16100','2013-05-24','11:45:00',4.28),('16100','2013-05-24','11:50:00',3.5),('16100','2013-05-24','11:55:00',4.71),('16100','2013-05-24','12:00:00',3.33),('16100','2013-05-24','12:05:00',2.55),('16100','2013-05-24','12:10:00',2.25),('16100','2013-05-24','12:15:00',3.02),('16100','2013-05-24','12:20:00',3.56),('16100','2013-05-24','12:25:00',2.13),('16100','2013-05-24','12:30:00',3.78),('16100','2013-05-24','12:35:00',1.38),('16100','2013-05-24','12:40:00',1.91),('16100','2013-05-24','12:45:00',3.08),('16100','2013-05-24','12:50:00',4.24),('16100','2013-05-24','12:55:00',3.2),('16100','2013-05-24','13:00:00',5.75),('16100','2013-05-24','13:05:00',2.82),('16100','2013-05-24','13:10:00',3.94),('16100','2013-05-24','13:15:00',3.69),('16100','2013-05-24','13:20:00',4.61),('16100','2013-05-24','13:25:00',3.42),('16100','2013-05-24','13:30:00',5.69),('16100','2013-05-24','13:35:00',3.68),('16100','2013-05-24','13:40:00',3.49),('16100','2013-05-24','13:45:00',3.94),('16100','2013-05-24','13:50:00',4.33),('16100','2013-05-24','13:55:00',7.57),('16100','2013-05-24','14:00:00',9.43),('16100','2013-05-24','14:05:00',8.04),('16100','2013-05-24','14:10:00',8.57),('16100','2013-05-24','14:15:00',3.04),('16100','2013-05-24','14:20:00',3.49),('16100','2013-05-24','14:25:00',7.9),('16100','2013-05-24','14:30:00',6.17),('16100','2013-05-24','14:35:00',5.85),('16100','2013-05-24','14:40:00',6.52),('16100','2013-05-24','14:45:00',4.28),('16100','2013-05-24','14:50:00',5.53),('16100','2013-05-24','14:55:00',5.58),('16100','2013-05-24','15:00:00',2.8),('16100','2013-05-24','15:05:00',4.13),('16100','2013-05-24','15:10:00',5.35),('16100','2013-05-24','15:15:00',2.13),('16100','2013-05-24','15:20:00',4.12),('16100','2013-05-24','15:25:00',4.6),('16100','2013-05-24','15:30:00',2.16),('16100','2013-05-24','15:35:00',3.67),('16100','2013-05-24','15:40:00',1.97),('16100','2013-05-24','15:45:00',6.05),('16100','2013-05-24','15:50:00',4.92),('16100','2013-05-24','15:55:00',5.1),('16100','2013-05-24','16:00:00',6.38),('16100','2013-05-24','16:05:00',3.89),('16100','2013-05-24','16:10:00',6.78),('16100','2013-05-24','16:15:00',3.95),('16100','2013-05-24','16:20:00',3.9),('16100','2013-05-24','16:25:00',4.79),('16100','2013-05-24','16:30:00',4.11),('16100','2013-05-24','16:35:00',2.76),('16100','2013-05-24','16:40:00',2.71),('16100','2013-05-24','16:45:00',3.59),('16100','2013-05-24','16:50:00',2.81),('16100','2013-05-24','16:55:00',5.46),('16100','2013-05-24','17:00:00',4.26),('16100','2013-05-24','17:05:00',1.68),('16100','2013-05-24','17:10:00',4.72),('16100','2013-05-24','17:15:00',2.36),('16100','2013-05-24','17:20:00',2.64),('16100','2013-05-24','17:25:00',1.65),('16100','2013-05-24','17:30:00',2.09),('16100','2013-05-24','17:35:00',4),('16100','2013-05-24','17:40:00',4.45),('16100','2013-05-24','17:45:00',3.92),('16100','2013-05-24','17:50:00',4.14),('16100','2013-05-24','17:55:00',3.76),('16100','2013-05-24','18:00:00',3.74),('16100','2013-05-24','18:05:00',1.65),('16100','2013-05-24','18:15:00',1.16),('16100','2013-05-23','07:55:00',1.13),('16100','2013-05-23','08:00:00',1.21),('16100','2013-05-23','08:05:00',1.92),('16100','2013-05-23','08:10:00',1.48),('16100','2013-05-23','08:15:00',2.35),('16100','2013-05-23','08:20:00',2.67),('16100','2013-05-23','08:25:00',2.82),('16100','2013-05-23','08:30:00',2.92),('16100','2013-05-23','08:35:00',1.3),('16100','2013-05-23','08:40:00',3.18),('16100','2013-05-23','08:45:00',3.56),('16100','2013-05-23','08:50:00',3.58),('16100','2013-05-23','08:55:00',3.96),('16100','2013-05-23','09:00:00',4.1),('16100','2013-05-23','09:05:00',3.69),('16100','2013-05-23','09:10:00',1.59),('16100','2013-05-23','09:15:00',3.52),('16100','2013-05-23','09:20:00',4.52),('16100','2013-05-23','09:25:00',1.14),('16100','2013-05-23','09:30:00',4.15),('16100','2013-05-23','09:35:00',2.75),('16100','2013-05-23','09:40:00',1.24),('16100','2013-05-23','09:45:00',1.04),('16100','2013-05-23','09:50:00',1.86),('16100','2013-05-23','09:55:00',5.33),('16100','2013-05-23','10:00:00',6.69),('16100','2013-05-23','10:05:00',2.37),('16100','2013-05-23','10:20:00',1.29),('16100','2013-05-23','10:25:00',2.55),('16100','2013-05-23','10:30:00',3.93),('16100','2013-05-23','10:35:00',4.23),('16100','2013-05-23','10:40:00',6.86),('16100','2013-05-23','10:45:00',3.19),('16100','2013-05-23','10:50:00',4.78),('16100','2013-05-23','10:55:00',3.95),('16100','2013-05-23','11:00:00',5.79),('16100','2013-05-23','11:05:00',7.9),('16100','2013-05-23','11:10:00',6.05),('16100','2013-05-23','11:15:00',4.67),('16100','2013-05-23','11:20:00',2.58),('16100','2013-05-23','11:25:00',6.41),('16100','2013-05-23','11:30:00',4.61),('16100','2013-05-23','11:35:00',8.86),('16100','2013-05-23','11:40:00',2.02),('16100','2013-05-23','11:45:00',1.49),('16100','2013-05-23','11:50:00',1.68),('16100','2013-05-23','11:55:00',2.52),('16100','2013-05-23','12:00:00',5.96),('16100','2013-05-23','12:05:00',6.42),('16100','2013-05-23','12:10:00',4.32),('16100','2013-05-23','12:15:00',3.36),('16100','2013-05-23','12:20:00',3.39),('16100','2013-05-23','12:25:00',4.53),('16100','2013-05-23','12:30:00',3.41),('16100','2013-05-23','12:35:00',4.08),('16100','2013-05-23','12:40:00',5.37),('16100','2013-05-23','12:45:00',3.17),('16100','2013-05-23','12:50:00',4.93),('16100','2013-05-23','12:55:00',6.27),('16100','2013-05-23','13:00:00',4.08),('16100','2013-05-23','13:05:00',4.18),('16100','2013-05-23','13:10:00',6.87),('16100','2013-05-23','13:15:00',4.89),('16100','2013-05-23','13:20:00',4.6),('16100','2013-05-23','13:25:00',5.38),('16100','2013-05-23','13:30:00',7.85),('16100','2013-05-23','13:35:00',4.82),('16100','2013-05-23','13:40:00',4.91),('16100','2013-05-23','13:45:00',1.96),('16100','2013-05-23','13:50:00',4.92),('16100','2013-05-23','13:55:00',5.75),('16100','2013-05-23','14:00:00',6.05),('16100','2013-05-23','14:05:00',4.67),('16100','2013-05-23','14:10:00',6.51),('16100','2013-05-23','14:15:00',2.45),('16100','2013-05-23','14:20:00',5.81),('16100','2013-05-23','14:25:00',5.45),('16100','2013-05-23','14:30:00',6.12),('16100','2013-05-23','14:35:00',7.34),('16100','2013-05-23','14:40:00',6.61),('16100','2013-05-23','14:45:00',2.8),('16100','2013-05-23','14:50:00',3.19),('16100','2013-05-23','14:55:00',3.18),('16100','2013-05-23','15:00:00',3.14),('16100','2013-05-23','15:05:00',2.96),('16100','2013-05-23','15:10:00',4.33),('16100','2013-05-23','15:15:00',5.36),('16100','2013-05-23','15:20:00',8.15),('16100','2013-05-23','15:25:00',5.63),('16100','2013-05-23','15:30:00',3.5),('16100','2013-05-23','15:35:00',4.51),('16100','2013-05-23','15:40:00',4.81),('16100','2013-05-23','15:45:00',6.63),('16100','2013-05-23','15:50:00',4.5),('16100','2013-05-23','15:55:00',3.29),('16100','2013-05-23','16:00:00',2.92),('16100','2013-05-23','16:05:00',2.89),('16100','2013-05-23','16:10:00',2.9),('16100','2013-05-23','16:15:00',2.38),('16100','2013-05-23','16:20:00',2.56),('16100','2013-05-23','16:25:00',2.79),('16100','2013-05-23','16:30:00',1.78),('16100','2013-05-23','16:35:00',1.55),('16100','2013-05-23','16:40:00',1.73),('16100','2013-05-23','16:45:00',2.44),('16100','2013-05-23','16:50:00',2.83),('16100','2013-05-23','16:55:00',1.96),('16100','2013-05-23','17:00:00',1.85),('16100','2013-05-23','17:05:00',1.75),('16100','2013-05-23','17:10:00',1.79),('16100','2013-05-23','17:15:00',1.82),('16100','2013-05-23','17:20:00',2.23),('16100','2013-05-23','17:25:00',2.18),('16100','2013-05-23','17:30:00',1.86),('16100','2013-05-23','17:35:00',1.99),('16100','2013-05-23','17:40:00',1.5),('16100','2013-05-23','17:45:00',1.34),('16100','2013-05-23','17:50:00',1.1),('16100','2013-05-22','07:00:00',1.37),('16100','2013-05-22','07:05:00',1.42),('16100','2013-05-22','07:45:00',1.5),('16100','2013-05-22','07:50:00',1.75),('16100','2013-05-22','07:55:00',1.4),('16100','2013-05-22','08:00:00',1.46),('16100','2013-05-22','08:05:00',1.57),('16100','2013-05-22','08:10:00',1.44),('16100','2013-05-22','08:15:00',1.15),('16100','2013-05-22','08:20:00',1.54),('16100','2013-05-22','08:25:00',1.6),('16100','2013-05-22','08:30:00',2.38),('16100','2013-05-22','08:35:00',3.51),('16100','2013-05-22','08:40:00',4.22),('16100','2013-05-22','08:45:00',2.85),('16100','2013-05-22','08:50:00',2.16),('16100','2013-05-22','09:15:00',3.03),('16100','2013-05-22','09:20:00',4.95),('16100','2013-05-22','09:25:00',1.4),('16100','2013-05-22','09:30:00',3.39),('16100','2013-05-22','09:35:00',1.92),('16100','2013-05-22','09:40:00',3.97),('16100','2013-05-22','09:45:00',2.98),('16100','2013-05-22','09:50:00',4.03),('16100','2013-05-22','09:55:00',3.97),('16100','2013-05-22','10:00:00',3.88),('16100','2013-05-22','10:05:00',3.25),('16100','2013-05-22','10:10:00',4.25),('16100','2013-05-22','10:15:00',4.63),('16100','2013-05-22','10:20:00',3.54),('16100','2013-05-22','10:25:00',5.03),('16100','2013-05-22','10:30:00',5.5),('16100','2013-05-22','10:35:00',6.9),('16100','2013-05-22','10:40:00',5.92),('16100','2013-05-22','10:45:00',2.56),('16100','2013-05-22','10:50:00',3.84),('16100','2013-05-22','10:55:00',2.45),('16100','2013-05-22','11:00:00',3.24),('16100','2013-05-22','11:05:00',3.92),('16100','2013-05-22','11:10:00',7.84),('16100','2013-05-22','11:15:00',7.59),('16100','2013-05-22','11:20:00',1.86),('16100','2013-05-22','11:25:00',6.12),('16100','2013-05-22','11:30:00',4.8),('16100','2013-05-22','11:35:00',2.57),('16100','2013-05-22','11:40:00',3.68),('16100','2013-05-22','11:45:00',2.84),('16100','2013-05-22','11:50:00',4.59),('16100','2013-05-22','11:55:00',2.03),('16100','2013-05-22','12:00:00',6.89),('16100','2013-05-22','12:05:00',4.29),('16100','2013-05-22','12:10:00',3.46),('16100','2013-05-22','12:15:00',4.36),('16100','2013-05-22','12:20:00',5.2),('16100','2013-05-22','12:25:00',2.52),('16100','2013-05-22','12:30:00',2.09),('16100','2013-05-22','12:35:00',2.1),('16100','2013-05-22','12:40:00',6.32),('16100','2013-05-22','12:45:00',9.44),('16100','2013-05-22','12:50:00',3.37),('16100','2013-05-22','12:55:00',6.47),('16100','2013-05-22','13:00:00',8.5),('16100','2013-05-22','13:05:00',8.08),('16100','2013-05-22','13:10:00',7.23),('16100','2013-05-22','13:15:00',3.38),('16100','2013-05-22','13:20:00',5.78),('16100','2013-05-22','13:25:00',2.85),('16100','2013-05-22','13:30:00',3.62),('16100','2013-05-22','13:35:00',4.23),('16100','2013-05-22','13:40:00',2.59),('16100','2013-05-22','13:45:00',5.64),('16100','2013-05-22','13:50:00',6.49),('16100','2013-05-22','13:55:00',8.43),('16100','2013-05-22','14:00:00',4.63),('16100','2013-05-22','14:05:00',3.02),('16100','2013-05-22','14:10:00',6),('16100','2013-05-22','14:15:00',2.72),('16100','2013-05-22','14:20:00',5.38),('16100','2013-05-22','14:25:00',5.81),('16100','2013-05-22','14:30:00',8.8),('16100','2013-05-22','14:35:00',3.47),('16100','2013-05-22','14:40:00',6.78),('16100','2013-05-22','14:45:00',3.29),('16100','2013-05-22','14:50:00',6.74),('16100','2013-05-22','14:55:00',7.25),('16100','2013-05-22','15:00:00',5.58),('16100','2013-05-22','15:05:00',4.88),('16100','2013-05-22','15:10:00',5.47),('16100','2013-05-22','15:15:00',1.55),('16100','2013-05-22','15:20:00',2.51),('16100','2013-05-22','15:25:00',3.98),('16100','2013-05-22','15:30:00',3.9),('16100','2013-05-22','15:35:00',4.52),('16100','2013-05-22','15:40:00',3.75),('16100','2013-05-22','15:45:00',1.78),('16100','2013-05-22','15:50:00',4.25),('16100','2013-05-22','15:55:00',7.82),('16100','2013-05-22','16:00:00',5.93),('16100','2013-05-22','16:05:00',3.05),('16100','2013-05-22','16:10:00',4.37),('16100','2013-05-22','16:15:00',4.92),('16100','2013-05-22','16:20:00',5.21),('16100','2013-05-22','16:25:00',5.65),('16100','2013-05-22','16:30:00',4.11),('16100','2013-05-22','16:35:00',3.13),('16100','2013-05-22','16:40:00',1.9),('16100','2013-05-22','16:45:00',2.01),('16100','2013-05-22','16:50:00',2.12),('16100','2013-05-22','16:55:00',5.4),('16100','2013-05-22','17:00:00',3.32),('16100','2013-05-22','17:05:00',3.5),('16100','2013-05-22','17:10:00',1.32),('16100','2013-05-22','17:15:00',1.75),('16100','2013-05-22','17:20:00',1.3),('16100','2013-05-22','17:25:00',1.33),('16100','2013-05-22','17:30:00',1.48),('16100','2013-05-22','17:35:00',1.32),('16100','2013-05-22','17:40:00',1.39),('16100','2013-05-22','17:45:00',2.57),('16100','2013-05-22','17:50:00',1.69),('16100','2013-05-22','17:55:00',2.37),('16100','2013-05-22','18:00:00',2.43),('16100','2013-05-22','18:40:00',1.28),('16100','2013-05-22','18:45:00',1.6),('16100','2013-05-22','18:50:00',1.4),('16100','2013-05-22','18:55:00',1.06),('16100','2013-05-21','07:45:00',1.08),('16100','2013-05-21','07:50:00',1.28),('16100','2013-05-21','07:55:00',1.28),('16100','2013-05-21','08:00:00',1.31),('16100','2013-05-21','08:05:00',1.61),('16100','2013-05-21','08:10:00',2.38),('16100','2013-05-21','08:15:00',1.92),('16100','2013-05-21','08:20:00',1.53),('16100','2013-05-21','08:25:00',2),('16100','2013-05-21','08:30:00',3.17),('16100','2013-05-21','08:35:00',1.79),('16100','2013-05-21','08:40:00',1.13),('16100','2013-05-21','09:15:00',1.03),('16100','2013-05-21','09:20:00',1.64),('16100','2013-05-21','09:25:00',3.29),('16100','2013-05-21','09:30:00',5.17),('16100','2013-05-21','09:35:00',4.97),('16100','2013-05-21','09:40:00',5.04),('16100','2013-05-21','09:45:00',5.16),('16100','2013-05-21','09:50:00',5.24),('16100','2013-05-21','09:55:00',5.38),('16100','2013-05-21','10:00:00',5.58),('16100','2013-05-21','10:05:00',5.73),('16100','2013-05-21','10:10:00',5.82),('16100','2013-05-21','10:15:00',5.89),('16100','2013-05-21','10:20:00',6.1),('16100','2013-05-21','10:25:00',6.02),('16100','2013-05-21','10:30:00',6.23),('16100','2013-05-21','10:35:00',6.59),('16100','2013-05-21','10:40:00',5.73),('16100','2013-05-21','10:45:00',6.28),('16100','2013-05-21','10:50:00',6.71),('16100','2013-05-21','10:55:00',6.69),('16100','2013-05-21','11:00:00',6.81),('16100','2013-05-21','11:05:00',6.87),('16100','2013-05-21','11:10:00',7),('16100','2013-05-21','11:15:00',7.05),('16100','2013-05-21','11:20:00',7.1),('16100','2013-05-21','11:25:00',7.28),('16100','2013-05-21','11:30:00',4.63),('16100','2013-05-21','11:35:00',6.92),('16100','2013-05-21','11:40:00',6.8),('16100','2013-05-21','11:45:00',8.24),('16100','2013-05-21','11:50:00',7.17),('16100','2013-05-21','11:55:00',6.58),('16100','2013-05-21','12:00:00',3.46),('16100','2013-05-21','12:05:00',4.52),('16100','2013-05-21','12:10:00',4.3),('16100','2013-05-21','12:15:00',3.98),('16100','2013-05-21','12:20:00',8.44),('16100','2013-05-21','12:25:00',8.08),('16100','2013-05-21','12:30:00',4.47),('16100','2013-05-21','12:35:00',2.67),('16100','2013-05-21','12:40:00',2.27),('16100','2013-05-21','12:45:00',1.39),('16100','2013-05-21','13:05:00',1.71),('16100','2013-05-21','13:10:00',4.13),('16100','2013-05-21','13:15:00',4.79),('16100','2013-05-21','13:20:00',3.68),('16100','2013-05-21','13:25:00',2.16),('16100','2013-05-21','13:30:00',2.46),('16100','2013-05-21','13:35:00',3.2),('16100','2013-05-21','13:40:00',2.9),('16100','2013-05-21','13:45:00',4.53),('16100','2013-05-21','13:50:00',4.72),('16100','2013-05-21','13:55:00',4.78),('16100','2013-05-21','14:00:00',4.58),('16100','2013-05-21','14:05:00',4.13),('16100','2013-05-21','14:10:00',5.98),('16100','2013-05-21','14:15:00',7.74),('16100','2013-05-21','14:20:00',7.57),('16100','2013-05-21','14:25:00',7.47),('16100','2013-05-21','14:30:00',7.39),('16100','2013-05-21','14:35:00',6.89),('16100','2013-05-21','14:40:00',6.16),('16100','2013-05-21','14:45:00',7.2),('16100','2013-05-21','14:50:00',7.11),('16100','2013-05-21','14:55:00',7.08),('16100','2013-05-21','15:00:00',7.02),('16100','2013-05-21','15:05:00',6.91),('16100','2013-05-21','15:10:00',6.37),('16100','2013-05-21','15:15:00',6.54),('16100','2013-05-21','15:20:00',6.69),('16100','2013-05-21','15:25:00',5.09),('16100','2013-05-21','15:30:00',6.16),('16100','2013-05-21','15:35:00',5.14),('16100','2013-05-21','15:40:00',4.3),('16100','2013-05-21','15:45:00',6.96),('16100','2013-05-21','15:50:00',6.29),('16100','2013-05-21','15:55:00',5.96),('16100','2013-05-21','16:00:00',5.85),('16100','2013-05-21','16:05:00',5.74),('16100','2013-05-21','16:10:00',5.56),('16100','2013-05-21','16:15:00',5.43),('16100','2013-05-21','16:20:00',5.28),('16100','2013-05-21','16:25:00',5.15),('16100','2013-05-21','16:30:00',4.19),('16100','2013-05-21','16:35:00',2.3),('16100','2013-05-21','16:40:00',4.08),('16100','2013-05-21','16:45:00',4.66),('16100','2013-05-21','16:50:00',4.57),('16100','2013-05-21','16:55:00',2.52),('16100','2013-05-21','17:00:00',1.06),('16100','2013-05-21','17:15:00',1.19),('16100','2013-05-21','17:20:00',2.13),('16100','2013-05-21','17:25:00',2.54),('16100','2013-05-21','17:30:00',3.19),('16100','2013-05-21','17:35:00',2.77),('16100','2013-05-21','17:40:00',2.74),('16100','2013-05-21','18:00:00',1.8),('16100','2013-05-21','18:05:00',2.32),('16100','2013-05-21','18:10:00',1.72),('16100','2013-05-21','18:15:00',1.4),('16100','2013-05-21','18:20:00',1.04),('16100','2013-05-21','18:25:00',1.11),('16100','2013-05-21','18:35:00',1.25),('16100','2013-05-21','18:40:00',1.21),('16100','2013-05-21','18:45:00',1.17),('16100','2014-03-31','08:15:00',1.11),('16100','2014-03-31','08:20:00',1.28),('16100','2014-03-31','08:25:00',1.46),('16100','2014-03-31','08:30:00',1.65),('16100','2014-03-31','08:35:00',1.85),('16100','2014-03-31','08:40:00',2.04),('16100','2014-03-31','08:45:00',2.23),('16100','2014-03-31','08:50:00',2.45),('16100','2014-03-31','08:55:00',2.62),('16100','2014-03-31','09:00:00',2.81),('16100','2014-03-31','09:05:00',2.99),('16100','2014-03-31','09:10:00',3.16),('16100','2014-03-31','09:15:00',3.3),('16100','2014-03-31','09:20:00',3.49),('16100','2014-03-31','09:25:00',3.68),('16100','2014-03-31','09:30:00',3.8),('16100','2014-03-31','09:35:00',3.91),('16100','2014-03-31','09:40:00',4.08),('16100','2014-03-31','09:45:00',4.19),('16100','2014-03-31','09:50:00',4.31),('16100','2014-03-31','09:55:00',4.49),('16100','2014-03-31','10:00:00',4.51),('16100','2014-03-31','10:05:00',4.6),('16100','2014-03-31','10:10:00',3.2),('16100','2014-03-31','10:15:00',5.01),('16100','2014-03-31','10:20:00',5.36),('16100','2014-03-31','10:25:00',5.46),('16100','2014-03-31','10:30:00',5.62),('16100','2014-03-31','10:35:00',5.69),('16100','2014-03-31','10:40:00',5.7),('16100','2014-03-31','10:45:00',6.01),('16100','2014-03-31','10:50:00',4.54),('16100','2014-03-31','10:55:00',3.56),('16100','2014-03-31','11:00:00',6.16),('16100','2014-03-31','11:05:00',6.04),('16100','2014-03-31','11:10:00',6.58),('16100','2014-03-31','11:15:00',5.03),('16100','2014-03-31','11:20:00',5.54),('16100','2014-03-31','11:25:00',6.78),('16100','2014-03-31','11:30:00',6.92),('16100','2014-03-31','11:35:00',6.97),('16100','2014-03-31','11:40:00',6.99),('16100','2014-03-31','11:45:00',6.92),('16100','2014-03-31','11:50:00',7),('16100','2014-03-31','11:55:00',7.12),('16100','2014-03-31','12:00:00',7.15),('16100','2014-03-31','12:05:00',7.22),('16100','2014-03-31','12:10:00',7.34),('16100','2014-03-31','12:15:00',7.38),('16100','2014-03-31','12:20:00',7.47),('16100','2014-03-31','12:25:00',7.57),('16100','2014-03-31','12:30:00',7.66),('16100','2014-03-31','12:35:00',7.69),('16100','2014-03-31','12:40:00',7.76),('16100','2014-03-31','12:45:00',7.82),('16100','2014-03-31','12:50:00',7.96),('16100','2014-03-31','12:55:00',6.72),('16100','2014-03-31','13:00:00',7.87),('16100','2014-03-31','13:05:00',7.84),('16100','2014-03-31','13:10:00',7.81),('16100','2014-03-31','13:15:00',6.66),('16100','2014-03-31','13:20:00',6.7),('16100','2014-03-31','13:25:00',5.34),('16100','2014-03-31','13:30:00',8.01),('16100','2014-03-31','13:35:00',6.28),('16100','2014-03-31','13:40:00',5.73),('16100','2014-03-31','13:45:00',5.9),('16100','2014-03-31','13:50:00',6.05),('16100','2014-03-31','13:55:00',8),('16100','2014-03-31','14:00:00',7.86),('16100','2014-03-31','14:05:00',7.69),('16100','2014-03-31','14:10:00',5.79),('16100','2014-03-31','14:15:00',5.26),('16100','2014-03-31','14:20:00',5.63),('16100','2014-03-31','14:25:00',7.64),('16100','2014-03-31','14:30:00',7.72),('16100','2014-03-31','14:35:00',7.59),('16100','2014-03-31','14:40:00',3.5),('16100','2014-03-31','14:45:00',5.48),('16100','2014-03-31','14:50:00',7.76),('16100','2014-03-31','14:55:00',5.5),('16100','2014-03-31','15:00:00',5.81),('16100','2014-03-31','15:05:00',7.12),('16100','2014-03-31','15:10:00',6.01),('16100','2014-03-31','15:15:00',6.58),('16100','2014-03-31','15:20:00',6.89),('16100','2014-03-31','15:25:00',5.26),('16100','2014-03-31','15:30:00',3.11),('16100','2014-03-31','15:35:00',3.37),('16100','2014-03-31','15:40:00',4.17),('16100','2014-03-31','15:45:00',6.05),('16100','2014-03-31','15:50:00',4.58),('16100','2014-03-31','15:55:00',4.94),('16100','2014-03-31','16:00:00',5.05),('16100','2014-03-31','16:05:00',5.66),('16100','2014-03-31','16:10:00',4.29),('16100','2014-03-31','16:15:00',4.99),('16100','2014-03-31','16:20:00',5.52),('16100','2014-03-31','16:25:00',5.39),('16100','2014-03-31','16:30:00',3.86),('16100','2014-03-31','16:35:00',4.83),('16100','2014-03-31','16:40:00',2.99),('16100','2014-03-31','16:45:00',3.02),('16100','2014-03-31','16:50:00',2.68),('16100','2014-03-31','16:55:00',3.07),('16100','2014-03-31','17:00:00',2.47),('16100','2014-03-31','17:05:00',4.26),('16100','2014-03-31','17:10:00',2.19),('16100','2014-03-31','17:15:00',2.8),('16100','2014-03-31','17:20:00',2.25),('16100','2014-03-31','17:25:00',3.24),('16100','2014-03-31','17:30:00',2.97),('16100','2014-03-31','17:35:00',2.85),('16100','2014-03-31','17:40:00',2.18),('16100','2014-03-31','17:45:00',2.27),('16100','2014-03-31','17:50:00',2.28),('16100','2014-03-31','17:55:00',2.08),('16100','2014-03-31','18:00:00',1.89),('16100','2014-03-31','18:05:00',1.75),('16100','2014-03-31','18:10:00',1.47),('16100','2014-03-31','18:15:00',1.3),('16100','2014-03-31','18:20:00',1.1),('16100','2013-05-20','07:35:00',1.41),('16100','2013-05-20','07:40:00',1.55),('16100','2013-05-20','07:45:00',1.4),('16100','2013-05-20','07:50:00',1.3),('16100','2013-05-20','07:55:00',1.28),('16100','2013-05-20','08:00:00',1.14),('16100','2013-05-20','08:05:00',1.66),('16100','2013-05-20','08:10:00',2.6),('16100','2013-05-20','08:15:00',2.1),('16100','2013-05-20','08:20:00',2.14),('16100','2013-05-20','08:25:00',2.29),('16100','2013-05-20','08:30:00',1.87),('16100','2013-05-20','08:35:00',2.19),('16100','2013-05-20','08:40:00',2.53),('16100','2013-05-20','08:45:00',1.96),('16100','2013-05-20','08:50:00',2.04),('16100','2013-05-20','08:55:00',2.28),('16100','2013-05-20','09:00:00',2.18),('16100','2013-05-20','09:05:00',2.05),('16100','2013-05-20','09:10:00',2.4),('16100','2013-05-20','09:15:00',2.92),('16100','2013-05-20','09:20:00',3.2),('16100','2013-05-20','09:25:00',3.39),('16100','2013-05-20','09:30:00',3.02),('16100','2013-05-20','09:35:00',3.06),('16100','2013-05-20','09:40:00',3.08),('16100','2013-05-20','09:45:00',2.77),('16100','2013-05-20','09:50:00',2.96),('16100','2013-05-20','09:55:00',2.86),('16100','2013-05-20','10:00:00',3.45),('16100','2013-05-20','10:05:00',3.35),('16100','2013-05-20','10:10:00',3.32),('16100','2013-05-20','10:15:00',3.5),('16100','2013-05-20','10:20:00',2.98),('16100','2013-05-20','10:25:00',4.47),('16100','2013-05-20','10:30:00',3.36),('16100','2013-05-20','10:35:00',3.06),('16100','2013-05-20','10:40:00',4.33),('16100','2013-05-20','10:45:00',5.41),('16100','2013-05-20','10:50:00',4.88),('16100','2013-05-20','10:55:00',3.29),('16100','2013-05-20','11:00:00',2.81),('16100','2013-05-20','11:05:00',2.64),('16100','2013-05-20','11:10:00',4.09),('16100','2013-05-20','11:15:00',6.6),('16100','2013-05-20','11:20:00',6.34),('16100','2013-05-20','11:25:00',7.24),('16100','2013-05-20','11:30:00',6.92),('16100','2013-05-20','11:35:00',4.76),('16100','2013-05-20','11:40:00',3.61),('16100','2013-05-20','11:45:00',5.63),('16100','2013-05-20','11:50:00',5.54),('16100','2013-05-20','11:55:00',4.79),('16100','2013-05-20','12:00:00',4.33),('16100','2013-05-20','12:05:00',6.03),('16100','2013-05-20','12:10:00',7.65),('16100','2013-05-20','12:15:00',5.5),('16100','2013-05-20','12:20:00',4.5),('16100','2013-05-20','12:25:00',3.9),('16100','2013-05-20','12:30:00',5.42),('16100','2013-05-20','12:35:00',4.76),('16100','2013-05-20','12:40:00',4.68),('16100','2013-05-20','12:45:00',4.51),('16100','2013-05-20','12:50:00',6.3),('16100','2013-05-20','12:55:00',6.63),('16100','2013-05-20','13:00:00',5.31),('16100','2013-05-20','13:05:00',5.47),('16100','2013-05-20','13:10:00',5.08),('16100','2013-05-20','13:15:00',7),('16100','2013-05-20','13:20:00',7.93),('16100','2013-05-20','13:25:00',4.6),('16100','2013-05-20','13:30:00',2.89),('16100','2013-05-20','13:35:00',2.15),('16100','2013-05-20','13:40:00',1.51),('16100','2013-05-20','14:05:00',1.43),('16100','2013-05-20','14:10:00',2.49),('16100','2013-05-20','14:15:00',3.04),('16100','2013-05-20','14:20:00',3.43),('16100','2013-05-20','14:25:00',4.15),('16100','2013-05-20','14:30:00',3.88),('16100','2013-05-20','14:35:00',4.29),('16100','2013-05-20','14:40:00',3.85),('16100','2013-05-20','14:45:00',2.23),('16100','2013-05-20','14:50:00',1.06),('16100','2013-05-20','15:15:00',1.97),('16100','2013-05-20','15:20:00',2.67),('16100','2013-05-20','15:25:00',3.68),('16100','2013-05-20','15:30:00',5.23),('16100','2013-05-20','15:35:00',4.61),('16100','2013-05-20','15:40:00',5.6),('16100','2013-05-20','15:45:00',4.8),('16100','2013-05-20','15:50:00',1.97),('16100','2013-05-20','15:55:00',1.66),('16100','2013-05-20','16:00:00',1.46),('16100','2013-05-20','16:05:00',1.89),('16100','2013-05-20','16:10:00',2.04),('16100','2013-05-20','16:15:00',1.29),('16100','2013-05-20','16:20:00',1.38),('16100','2013-05-20','16:25:00',1.85),('16100','2013-05-20','16:30:00',2.64),('16100','2013-05-20','16:35:00',3.13),('16100','2013-05-20','16:40:00',2.61),('16100','2013-05-20','16:45:00',1.97),('16100','2013-05-20','16:50:00',1.53),('16100','2013-05-19','07:20:00',1.08),('16100','2013-05-19','07:25:00',1.17),('16100','2013-05-19','07:35:00',1.16),('16100','2013-05-19','07:40:00',1.29),('16100','2013-05-19','07:50:00',1.51),('16100','2013-05-19','07:55:00',1.01),('16100','2013-05-19','08:00:00',1.74),('16100','2013-05-19','08:05:00',1.73),('16100','2013-05-19','08:10:00',1.87),('16100','2013-05-19','08:15:00',2.05),('16100','2013-05-19','08:20:00',1.74),('16100','2013-05-19','08:25:00',2.76),('16100','2013-05-19','08:30:00',2.57),('16100','2013-05-19','08:35:00',1.45),('16100','2013-05-19','08:40:00',3.11),('16100','2013-05-19','08:45:00',3.42),('16100','2013-05-19','08:55:00',1.04),('16100','2013-05-19','09:05:00',3.88),('16100','2013-05-19','09:10:00',4.06),('16100','2013-05-19','09:15:00',4.88),('16100','2013-05-19','09:20:00',5.29),('16100','2013-05-19','09:25:00',5.21),('16100','2013-05-19','09:30:00',4.81),('16100','2013-05-19','09:35:00',4.59),('16100','2013-05-19','09:40:00',3.4),('16100','2013-05-19','09:45:00',5.92),('16100','2013-05-19','09:50:00',6.7),('16100','2013-05-19','09:55:00',5.02),('16100','2013-05-19','10:00:00',2.25),('16100','2013-05-19','10:05:00',4.83),('16100','2013-05-19','10:10:00',6.36),('16100','2013-05-19','10:15:00',3.57),('16100','2013-05-19','10:20:00',5.68),('16100','2013-05-19','10:25:00',2.93),('16100','2013-05-19','10:30:00',1.83),('16100','2013-05-19','10:35:00',6.81),('16100','2013-05-19','10:40:00',7),('16100','2013-05-19','10:45:00',7.03),('16100','2013-05-19','10:50:00',7.24),('16100','2013-05-19','10:55:00',4.75),('16100','2013-05-19','11:00:00',5.26),('16100','2013-05-19','11:05:00',4.35),('16100','2013-05-19','11:10:00',2.94),('16100','2013-05-19','11:15:00',2.33),('16100','2013-05-19','11:20:00',6.9),('16100','2013-05-19','11:25:00',7.73),('16100','2013-05-19','11:30:00',5.85),('16100','2013-05-19','11:35:00',7.99),('16100','2013-05-19','11:40:00',8.85),('16100','2013-05-19','11:45:00',7.95),('16100','2013-05-19','11:50:00',6.16),('16100','2013-05-19','11:55:00',6.76),('16100','2013-05-19','12:00:00',8.38),('16100','2013-05-19','12:05:00',8.42),('16100','2013-05-19','12:10:00',8.37),('16100','2013-05-19','12:15:00',8.42),('16100','2013-05-19','12:20:00',8.49),('16100','2013-05-19','12:25:00',8.39),('16100','2013-05-19','12:30:00',8.53),('16100','2013-05-19','12:35:00',8.63),('16100','2013-05-19','12:40:00',8.67),('16100','2013-05-19','12:45:00',8.58),('16100','2013-05-19','12:50:00',8.51),('16100','2013-05-19','12:55:00',8.5),('16100','2013-05-19','13:00:00',8.53),('16100','2013-05-19','13:05:00',8.59),('16100','2013-05-19','13:10:00',8.58),('16100','2013-05-19','13:15:00',8.49),('16100','2013-05-19','13:20:00',8.49),('16100','2013-05-19','13:25:00',8.51),('16100','2013-05-19','13:30:00',8.47),('16100','2013-05-19','13:35:00',8.42),('16100','2013-05-19','13:40:00',8.42),('16100','2013-05-19','13:45:00',8.3),('16100','2013-05-19','13:50:00',8.32),('16100','2013-05-19','13:55:00',8.26),('16100','2013-05-19','14:00:00',8.18),('16100','2013-05-19','14:05:00',8.14),('16100','2013-05-19','14:10:00',8.19),('16100','2013-05-19','14:15:00',8.11),('16100','2013-05-19','14:20:00',8),('16100','2013-05-19','14:25:00',7.91),('16100','2013-05-19','14:30:00',7.81),('16100','2013-05-19','14:35:00',7.79),('16100','2013-05-19','14:40:00',7.79),('16100','2013-05-19','14:45:00',7.71),('16100','2013-05-19','14:50:00',7.64),('16100','2013-05-19','14:55:00',7.64),('16100','2013-05-19','15:00:00',7.56),('16100','2013-05-19','15:05:00',7.53),('16100','2013-05-19','15:10:00',7.46),('16100','2013-05-19','15:15:00',7.36),('16100','2013-05-19','15:20:00',7.28),('16100','2013-05-19','15:25:00',7.21),('16100','2013-05-19','15:30:00',7.08),('16100','2013-05-19','15:35:00',7),('16100','2013-05-19','15:40:00',6.89),('16100','2013-05-19','15:45:00',6.8),('16100','2013-05-19','15:50:00',6.73),('16100','2013-05-19','15:55:00',6.63),('16100','2013-05-19','16:00:00',6.47),('16100','2013-05-19','16:05:00',6.34),('16100','2013-05-19','16:10:00',6.2),('16100','2013-05-19','16:15:00',6.02),('16100','2013-05-19','16:20:00',5.83),('16100','2013-05-19','16:25:00',5.74),('16100','2013-05-19','16:30:00',5.65),('16100','2013-05-19','16:35:00',5.42),('16100','2013-05-19','16:40:00',5.16),('16100','2013-05-19','16:45:00',4.79),('16100','2013-05-19','16:50:00',5.11),('16100','2013-05-19','16:55:00',4.75),('16100','2013-05-19','17:00:00',3.37),('16100','2013-05-19','17:05:00',4.28),('16100','2013-05-19','17:10:00',4.23),('16100','2013-05-19','17:15:00',2.86),('16100','2013-05-19','17:20:00',5.13),('16100','2013-05-19','17:25:00',4.41),('16100','2013-05-19','17:30:00',3.87),('16100','2013-05-19','17:35:00',3.63),('16100','2013-05-19','17:40:00',3.42),('16100','2013-05-19','17:45:00',3.27),('16100','2013-05-19','17:50:00',3.06),('16100','2013-05-19','17:55:00',2.89),('16100','2013-05-19','18:00:00',2.56),('16100','2013-05-19','18:05:00',1.72),('16100','2013-05-19','18:10:00',2.13),('16100','2013-05-19','18:15:00',2.34),('16100','2013-05-19','18:20:00',1.98),('16100','2013-05-19','18:25:00',1.79),('16100','2013-05-19','18:30:00',1.59),('16100','2013-05-19','18:35:00',1.4),('16100','2013-05-19','18:45:00',1.03),('16100','2013-05-18','08:25:00',1.19),('16100','2013-05-18','08:30:00',1.58),('16100','2013-05-18','08:35:00',2.05),('16100','2013-05-18','08:40:00',2.22),('16100','2013-05-18','08:45:00',1.61),('16100','2013-05-18','08:50:00',1.62),('16100','2013-05-18','08:55:00',2.07),('16100','2013-05-18','09:00:00',1.59),('16100','2013-05-18','09:05:00',1.26),('16100','2013-05-18','09:10:00',1.24),('16100','2013-05-18','09:30:00',1.47),('16100','2013-05-18','09:35:00',1.79),('16100','2013-05-18','09:40:00',1.33),('16100','2013-05-18','09:45:00',1.59),('16100','2013-05-18','09:50:00',2.02),('16100','2013-05-18','09:55:00',2.2),('16100','2013-05-18','10:00:00',2.69),('16100','2013-05-18','10:05:00',3.46),('16100','2013-05-18','10:10:00',3.98),('16100','2013-05-18','10:15:00',3.46),('16100','2013-05-18','10:20:00',3.83),('16100','2013-05-18','10:25:00',4.94),('16100','2013-05-18','10:30:00',6.75),('16100','2013-05-18','10:35:00',6.69),('16100','2013-05-18','10:40:00',4.46),('16100','2013-05-18','10:45:00',4.68),('16100','2013-05-18','10:50:00',4.59),('16100','2013-05-18','10:55:00',6.5),('16100','2013-05-18','11:00:00',7.06),('16100','2013-05-18','11:05:00',4.31),('16100','2013-05-18','11:10:00',5.33),('16100','2013-05-18','11:15:00',4.27),('16100','2013-05-18','11:20:00',6.87),('16100','2013-05-18','11:25:00',6.08),('16100','2013-05-18','11:30:00',8.45),('16100','2013-05-18','11:35:00',6.76),('16100','2013-05-18','11:40:00',8.3),('16100','2013-05-18','11:45:00',8.15),('16100','2013-05-18','11:50:00',8.19),('16100','2013-05-18','11:55:00',8.28),('16100','2013-05-18','12:00:00',8.31),('16100','2013-05-18','12:05:00',8.3),('16100','2013-05-18','12:10:00',8.38),('16100','2013-05-18','12:15:00',8.48),('16100','2013-05-18','12:20:00',8.59),('16100','2013-05-18','12:25:00',8.81),('16100','2013-05-18','12:30:00',8.96),('16100','2013-05-18','12:35:00',8.95),('16100','2013-05-18','12:40:00',9.19),('16100','2013-05-18','12:45:00',9.04),('16100','2013-05-18','12:50:00',8.12),('16100','2013-05-18','12:55:00',8.86),('16100','2013-05-18','13:00:00',8.8),('16100','2013-05-18','13:05:00',8.84),('16100','2013-05-18','13:10:00',8.73),('16100','2013-05-18','13:15:00',8.65),('16100','2013-05-18','13:20:00',8.57),('16100','2013-05-18','13:25:00',8.48),('16100','2013-05-18','13:30:00',8.55),('16100','2013-05-18','13:35:00',8.54),('16100','2013-05-18','13:40:00',8.5),('16100','2013-05-18','13:45:00',8.53),('16100','2013-05-18','13:50:00',8.48),('16100','2013-05-18','13:55:00',8.41),('16100','2013-05-18','14:00:00',8.33),('16100','2013-05-18','14:05:00',8.2),('16100','2013-05-18','14:10:00',8.23),('16100','2013-05-18','14:15:00',8.29),('16100','2013-05-18','14:20:00',8.21),('16100','2013-05-18','14:25:00',8.12),('16100','2013-05-18','14:30:00',8.07),('16100','2013-05-18','14:35:00',8.04),('16100','2013-05-18','14:40:00',8.04),('16100','2013-05-18','14:45:00',7.96),('16100','2013-05-18','14:50:00',7.92),('16100','2013-05-18','14:55:00',7.85),('16100','2013-05-18','15:00:00',7.75),('16100','2013-05-18','15:05:00',7.67),('16100','2013-05-18','15:10:00',7.51),('16100','2013-05-18','15:15:00',7.47),('16100','2013-05-18','15:20:00',7.34),('16100','2013-05-18','15:25:00',7.27),('16100','2013-05-18','15:30:00',7.18),('16100','2013-05-18','15:35:00',7.09),('16100','2013-05-18','15:40:00',6.96),('16100','2013-05-18','15:45:00',6.89),('16100','2013-05-18','15:50:00',6.8),('16100','2013-05-18','15:55:00',6.65),('16100','2013-05-18','16:00:00',6.55),('16100','2013-05-18','16:05:00',6.48),('16100','2013-05-18','16:10:00',6.38),('16100','2013-05-18','16:15:00',6.17),('16100','2013-05-18','16:20:00',6),('16100','2013-05-18','16:25:00',5.89),('16100','2013-05-18','16:30:00',5.74),('16100','2013-05-18','16:35:00',5.59),('16100','2013-05-18','16:40:00',5.49),('16100','2013-05-18','16:45:00',5.36),('16100','2013-05-18','16:50:00',5.21),('16100','2013-05-18','16:55:00',5.1),('16100','2013-05-18','17:00:00',4.88),('16100','2013-05-18','17:05:00',4.77),('16100','2013-05-18','17:10:00',4.62),('16100','2013-05-18','17:15:00',4.44),('16100','2013-05-18','17:20:00',4.27),('16100','2013-05-18','17:25:00',4.13),('16100','2013-05-18','17:30:00',3.97),('16100','2013-05-18','17:35:00',3.78),('16100','2013-05-18','17:40:00',3.64),('16100','2013-05-18','17:45:00',3.48),('16100','2013-05-18','17:50:00',3.28),('16100','2013-05-18','17:55:00',3.11),('16100','2013-05-18','18:00:00',2.91),('16100','2013-05-18','18:05:00',2.73),('16100','2013-05-18','18:10:00',2.55),('16100','2013-05-18','18:15:00',2.36),('16100','2013-05-18','18:20:00',2.1),('16100','2013-05-18','18:25:00',1.84),('16100','2013-05-18','18:30:00',1.73),('16100','2013-05-18','18:35:00',1.55),('16100','2013-05-18','18:40:00',1.38),('16100','2013-05-18','18:45:00',1.2),('16100','2013-05-18','18:50:00',1.03),('16100','2013-05-17','07:45:00',1.06),('16100','2013-05-17','07:50:00',1.52),('16100','2013-05-17','07:55:00',1.26),('16100','2013-05-17','08:00:00',1.78),('16100','2013-05-17','08:05:00',1.6),('16100','2013-05-17','08:10:00',1.4),('16100','2013-05-17','08:15:00',1.57),('16100','2013-05-17','08:20:00',1.8),('16100','2013-05-17','08:25:00',2.07),('16100','2013-05-17','08:30:00',3.09),('16100','2013-05-17','08:35:00',2.24),('16100','2013-05-17','08:40:00',3.05),('16100','2013-05-17','08:45:00',3.04),('16100','2013-05-17','08:50:00',3.7),('16100','2013-05-17','08:55:00',4),('16100','2013-05-17','09:00:00',4.1),('16100','2013-05-17','09:05:00',4.25),('16100','2013-05-17','09:10:00',4.41),('16100','2013-05-17','09:15:00',4.51),('16100','2013-05-17','09:20:00',4.66),('16100','2013-05-17','09:25:00',4.85),('16100','2013-05-17','09:30:00',5),('16100','2013-05-17','09:35:00',5.12),('16100','2013-05-17','09:40:00',5.24),('16100','2013-05-17','09:45:00',5.35),('16100','2013-05-17','09:50:00',5.48),('16100','2013-05-17','09:55:00',5.57),('16100','2013-05-17','10:00:00',5.71),('16100','2013-05-17','10:05:00',5.87),('16100','2013-05-17','10:10:00',6.05),('16100','2013-05-17','10:15:00',6.16),('16100','2013-05-17','10:20:00',6.23),('16100','2013-05-17','10:25:00',6.31),('16100','2013-05-17','10:30:00',6.41),('16100','2013-05-17','10:35:00',6.46),('16100','2013-05-17','10:40:00',6.58),('16100','2013-05-17','10:45:00',6.68),('16100','2013-05-17','10:50:00',6.8),('16100','2013-05-17','10:55:00',7.05),('16100','2013-05-17','11:00:00',7.25),('16100','2013-05-17','11:05:00',7.44),('16100','2013-05-17','11:10:00',6.6),('16100','2013-05-17','11:15:00',6.9),('16100','2013-05-17','11:20:00',7.11),('16100','2013-05-17','11:25:00',4.35),('16100','2013-05-17','11:30:00',7.1),('16100','2013-05-17','11:35:00',5.42),('16100','2013-05-17','11:40:00',6.4),('16100','2013-05-17','11:45:00',7.47),('16100','2013-05-17','11:50:00',7.51),('16100','2013-05-17','11:55:00',7.08),('16100','2013-05-17','12:00:00',7.55),('16100','2013-05-17','12:05:00',7.47),('16100','2013-05-17','12:10:00',7.47),('16100','2013-05-17','12:15:00',7.54),('16100','2013-05-17','12:20:00',7.59),('16100','2013-05-17','12:25:00',7.65),('16100','2013-05-17','12:30:00',7.71),('16100','2013-05-17','12:35:00',7.67),('16100','2013-05-17','12:40:00',7.65),('16100','2013-05-17','12:45:00',7.49),('16100','2013-05-17','12:50:00',5.9),('16100','2013-05-17','12:55:00',7.64),('16100','2013-05-17','13:00:00',7.65),('16100','2013-05-17','13:05:00',7.66),('16100','2013-05-17','13:10:00',7.2),('16100','2013-05-17','13:15:00',7.62),('16100','2013-05-17','13:20:00',7.62),('16100','2013-05-17','13:25:00',7.6),('16100','2013-05-17','13:30:00',7.67),('16100','2013-05-17','13:35:00',7.74),('16100','2013-05-17','13:40:00',7.59),('16100','2013-05-17','13:45:00',7.74),('16100','2013-05-17','13:50:00',7.65),('16100','2013-05-17','13:55:00',6.86),('16100','2013-05-17','14:00:00',7.38),('16100','2013-05-17','14:05:00',5.35),('16100','2013-05-17','14:10:00',5.44),('16100','2013-05-17','14:15:00',5.65),('16100','2013-05-17','14:20:00',6.04),('16100','2013-05-17','14:25:00',6.27),('16100','2013-05-17','14:30:00',7.01),('16100','2013-05-17','14:35:00',6.54),('16100','2013-05-17','14:40:00',7.77),('16100','2013-05-17','14:45:00',6.49),('16100','2013-05-17','14:50:00',5.9),('16100','2013-05-17','14:55:00',6.93),('16100','2013-05-17','15:00:00',6.6),('16100','2013-05-17','15:05:00',6.55),('16100','2013-05-17','15:10:00',6.58),('16100','2013-05-17','15:15:00',6.45),('16100','2013-05-17','15:20:00',6.28),('16100','2013-05-17','15:25:00',6.2),('16100','2013-05-17','15:30:00',6.1),('16100','2013-05-17','15:35:00',6.02),('16100','2013-05-17','15:40:00',6),('16100','2013-05-17','15:45:00',5.83),('16100','2013-05-17','15:50:00',5.75),('16100','2013-05-17','15:55:00',5.62),('16100','2013-05-17','16:00:00',5.52),('16100','2013-05-17','16:05:00',5.41),('16100','2013-05-17','16:10:00',5.24),('16100','2013-05-17','16:15:00',5.06),('16100','2013-05-17','16:20:00',4.99),('16100','2013-05-17','16:25:00',4.88),('16100','2013-05-17','16:30:00',4.75),('16100','2013-05-17','16:35:00',4.61),('16100','2013-05-17','16:40:00',4.52),('16100','2013-05-17','16:45:00',4.39),('16100','2013-05-17','16:50:00',4.23),('16100','2013-05-17','16:55:00',4.11),('16100','2013-05-17','17:00:00',3.92),('16100','2013-05-17','17:05:00',3.79),('16100','2013-05-17','17:10:00',3.68),('16100','2013-05-17','17:15:00',3.54),('16100','2013-05-17','17:20:00',3.42),('16100','2013-05-17','17:25:00',3.28),('16100','2013-05-17','17:30:00',3.11),('16100','2013-05-17','17:35:00',2.97),('16100','2013-05-17','17:40:00',2.83),('16100','2013-05-17','17:45:00',2.69),('16100','2013-05-17','17:50:00',2.53),('16100','2013-05-17','17:55:00',2.39),('16100','2013-05-17','18:00:00',2.25),('16100','2013-05-17','18:05:00',2.1),('16100','2013-05-17','18:10:00',1.95),('16100','2013-05-17','18:15:00',1.8),('16100','2013-05-17','18:20:00',1.63),('16100','2013-05-17','18:25:00',1.47),('16100','2013-05-17','18:30:00',1.32),('16100','2013-05-17','18:35:00',1.19),('16100','2013-05-17','18:40:00',1.08),('16100','2013-05-16','07:40:00',1.1),('16100','2013-05-16','07:45:00',1.36),('16100','2013-05-16','07:50:00',1.56),('16100','2013-05-16','07:55:00',1.44),('16100','2013-05-16','08:00:00',1.68),('16100','2013-05-16','08:05:00',1.86),('16100','2013-05-16','08:10:00',2.49),('16100','2013-05-16','08:15:00',3.35),('16100','2013-05-16','08:20:00',3.51),('16100','2013-05-16','08:25:00',2.67),('16100','2013-05-16','08:30:00',1.23),('16100','2013-05-16','09:10:00',1.23),('16100','2013-05-16','09:15:00',1.14),('16100','2013-05-16','10:15:00',1.29),('16100','2013-05-16','10:20:00',1.75),('16100','2013-05-16','10:25:00',1.95),('16100','2013-05-16','10:30:00',2.56),('16100','2013-05-16','10:35:00',2.08),('16100','2013-05-16','10:40:00',2.13),('16100','2013-05-16','10:45:00',3.92),('16100','2013-05-16','10:50:00',4.31),('16100','2013-05-16','10:55:00',4.36),('16100','2013-05-16','11:00:00',3.32),('16100','2013-05-16','11:05:00',2.59),('16100','2013-05-16','11:10:00',2.21),('16100','2013-05-16','11:15:00',6.39),('16100','2013-05-16','11:20:00',4.19),('16100','2013-05-16','11:25:00',4.25),('16100','2013-05-16','11:30:00',2.89),('16100','2013-05-16','11:35:00',3.35),('16100','2013-05-16','11:40:00',2.7),('16100','2013-05-16','11:45:00',3.2),('16100','2013-05-16','11:50:00',3.32),('16100','2013-05-16','11:55:00',4.68),('16100','2013-05-16','12:00:00',3.04),('16100','2013-05-16','12:05:00',4.09),('16100','2013-05-16','12:10:00',5.32),('16100','2013-05-16','12:15:00',4.81),('16100','2013-05-16','12:20:00',2.47),('16100','2013-05-16','12:25:00',3.35),('16100','2013-05-16','12:30:00',4.66),('16100','2013-05-16','12:35:00',3.3),('16100','2013-05-16','12:40:00',2.31),('16100','2013-05-16','12:45:00',3.89),('16100','2013-05-16','12:50:00',7.5),('16100','2013-05-16','12:55:00',4.89),('16100','2013-05-16','13:00:00',4.44),('16100','2013-05-16','13:05:00',2.77),('16100','2013-05-16','13:10:00',2.61),('16100','2013-05-16','13:15:00',2.39),('16100','2013-05-16','13:20:00',2.09),('16100','2013-05-16','13:25:00',5.75),('16100','2013-05-16','13:30:00',8.19),('16100','2013-05-16','13:35:00',5.06),('16100','2013-05-16','13:40:00',4.91),('16100','2013-05-16','13:45:00',4.14),('16100','2013-05-16','13:50:00',6.43),('16100','2013-05-16','13:55:00',3.14),('16100','2013-05-16','14:00:00',2.94),('16100','2013-05-16','14:05:00',5.18),('16100','2013-05-16','14:10:00',8.11),('16100','2013-05-16','14:15:00',6.83),('16100','2013-05-16','14:20:00',5.82),('16100','2013-05-16','14:25:00',5.74),('16100','2013-05-16','14:30:00',8.04),('16100','2013-05-16','14:35:00',8.88),('16100','2013-05-16','14:40:00',6.32),('16100','2013-05-16','14:45:00',4.01),('16100','2013-05-16','14:50:00',2.17),('16100','2013-05-16','14:55:00',3.29),('16100','2013-05-16','15:00:00',6.37),('16100','2013-05-16','15:05:00',5),('16100','2013-05-16','15:10:00',6.8),('16100','2013-05-16','15:15:00',7.86),('16100','2013-05-16','15:20:00',7.49),('16100','2013-05-16','15:25:00',7.07),('16100','2013-05-16','15:30:00',7.21),('16100','2013-05-16','15:35:00',7.2),('16100','2013-05-16','15:40:00',6.5),('16100','2013-05-16','15:45:00',5.71),('16100','2013-05-16','15:50:00',5.01),('16100','2013-05-16','15:55:00',6.64),('16100','2013-05-16','16:00:00',6.64),('16100','2013-05-16','16:05:00',6.68),('16100','2013-05-16','16:10:00',6.38),('16100','2013-05-16','16:15:00',6.5),('16100','2013-05-16','16:20:00',6.67),('16100','2013-05-16','16:25:00',6.33),('16100','2013-05-16','16:30:00',4.95),('16100','2013-05-16','16:35:00',6.37),('16100','2013-05-16','16:40:00',5.3),('16100','2013-05-16','16:45:00',5.91),('16100','2013-05-16','16:50:00',5.87),('16100','2013-05-16','16:55:00',5.19),('16100','2013-05-16','17:00:00',4.45),('16100','2013-05-16','17:05:00',1.08),('16100','2013-05-16','17:10:00',3.58),('16100','2013-05-16','17:15:00',1.34),('16100','2013-05-16','17:20:00',3.13),('16100','2013-05-16','17:25:00',3.53),('16100','2013-05-16','17:30:00',3.99),('16100','2013-05-16','17:35:00',3.52),('16100','2013-05-16','17:40:00',3.65),('16100','2013-05-16','17:45:00',3.3),('16100','2013-05-16','17:50:00',3.2),('16100','2013-05-16','17:55:00',3.07),('16100','2013-05-16','18:00:00',2.81),('16100','2013-05-16','18:05:00',2.67),('16100','2013-05-16','18:10:00',2.56),('16100','2013-05-16','18:15:00',2.4),('16100','2013-05-16','18:20:00',2.17),('16100','2013-05-16','18:25:00',1.98),('16100','2013-05-16','18:30:00',1.91),('16100','2013-05-16','18:35:00',1.83),('16100','2013-05-16','18:40:00',1.67),('16100','2013-05-16','18:45:00',1.44),('16100','2013-05-16','18:50:00',1.24),('16100','2013-05-16','18:55:00',1.07),('16100','2013-05-15','09:15:00',1.34),('16100','2013-05-15','09:20:00',1.77),('16100','2013-05-15','09:25:00',2.52),('16100','2013-05-15','09:30:00',2.29),('16100','2013-05-15','09:35:00',2.54),('16100','2013-05-15','09:40:00',3.2),('16100','2013-05-15','09:45:00',4.68),('16100','2013-05-15','09:50:00',4.42),('16100','2013-05-15','09:55:00',1.7),('16100','2013-05-15','10:00:00',3.2),('16100','2013-05-15','10:05:00',2.18),('16100','2013-05-15','10:10:00',1.75),('16100','2013-05-15','10:15:00',2.06),('16100','2013-05-15','10:20:00',3.28),('16100','2013-05-15','10:25:00',2.47),('16100','2013-05-15','10:30:00',2.51),('16100','2013-05-15','10:35:00',2.24),('16100','2013-05-15','10:40:00',2.92),('16100','2013-05-15','10:45:00',3.48),('16100','2013-05-15','10:50:00',3.14),('16100','2013-05-15','10:55:00',6.99),('16100','2013-05-15','11:00:00',7.52),('16100','2013-05-15','11:05:00',6.9),('16100','2013-05-15','11:10:00',6.43),('16100','2013-05-15','11:15:00',4.29),('16100','2013-05-15','11:20:00',4.45),('16100','2013-05-15','11:25:00',2.8),('16100','2013-05-15','11:30:00',3.54),('16100','2013-05-15','11:35:00',5.55),('16100','2013-05-15','11:40:00',7.79),('16100','2013-05-15','11:45:00',7.74),('16100','2013-05-15','11:50:00',8.44),('16100','2013-05-15','11:55:00',5.99),('16100','2013-05-15','12:00:00',2.38),('16100','2013-05-15','12:05:00',1.73),('16100','2013-05-15','12:10:00',1.75),('16100','2013-05-15','12:15:00',2.32),('16100','2013-05-15','12:20:00',2.92),('16100','2013-05-15','12:25:00',4.12),('16100','2013-05-15','12:30:00',5.59),('16100','2013-05-15','12:35:00',5.47),('16100','2013-05-15','12:40:00',4.42),('16100','2013-05-15','12:45:00',6.18),('16100','2013-05-15','12:50:00',4.26),('16100','2013-05-15','12:55:00',7.23),('16100','2013-05-15','13:00:00',7.77),('16100','2013-05-15','13:05:00',7.79),('16100','2013-05-15','13:10:00',7.62),('16100','2013-05-15','13:15:00',7.53),('16100','2013-05-15','13:20:00',7.58),('16100','2013-05-15','13:25:00',7.6),('16100','2013-05-15','13:30:00',7.44),('16100','2013-05-15','13:35:00',7.43),('16100','2013-05-15','13:40:00',7.38),('16100','2013-05-15','13:45:00',7.35),('16100','2013-05-15','13:50:00',7.43),('16100','2013-05-15','13:55:00',7.42),('16100','2013-05-15','14:00:00',7.33),('16100','2013-05-15','14:05:00',7.15),('16100','2013-05-15','14:10:00',7.08),('16100','2013-05-15','14:15:00',7.17),('16100','2013-05-15','14:20:00',7.09),('16100','2013-05-15','14:25:00',7.05),('16100','2013-05-15','14:30:00',6.85),('16100','2013-05-15','14:35:00',6.75),('16100','2013-05-15','14:40:00',6.74),('16100','2013-05-15','14:45:00',6.54),('16100','2013-05-15','14:50:00',6.74),('16100','2013-05-15','14:55:00',6.77),('16100','2013-05-15','15:00:00',6.57),('16100','2013-05-15','15:05:00',6.61),('16100','2013-05-15','15:10:00',6.39),('16100','2013-05-15','15:15:00',4.53),('16100','2013-05-15','15:20:00',6.37),('16100','2013-05-15','15:25:00',6.16),('16100','2013-05-15','15:30:00',6.07),('16100','2013-05-15','15:35:00',5.89),('16100','2013-05-15','15:40:00',5.88),('16100','2013-05-15','15:45:00',5.69),('16100','2013-05-15','15:50:00',5.65),('16100','2013-05-15','15:55:00',5.47),('16100','2013-05-15','16:00:00',5.43),('16100','2013-05-15','16:05:00',5.09),('16100','2013-05-15','16:10:00',5.33),('16100','2013-05-15','16:15:00',4.47),('16100','2013-05-15','16:20:00',4.85),('16100','2013-05-15','16:25:00',4.85),('16100','2013-05-15','16:30:00',4.47),('16100','2013-05-15','16:35:00',4.52),('16100','2013-05-15','16:40:00',4.73),('16100','2013-05-15','16:45:00',3.24),('16100','2013-05-15','16:50:00',3.81),('16100','2013-05-15','16:55:00',3.06),('16100','2013-05-15','17:00:00',2.16),('16100','2013-05-15','17:05:00',2),('16100','2013-05-15','17:10:00',1.46),('16100','2013-05-15','17:15:00',1.97),('16100','2013-05-15','17:20:00',2.18),('16100','2013-05-15','17:25:00',2.96),('16100','2013-05-15','17:30:00',3),('16100','2013-05-15','17:35:00',2.01),('16100','2013-05-15','17:40:00',1.2),('16100','2013-05-15','17:45:00',1.24),('16100','2013-05-15','17:50:00',1),('16100','2013-05-15','18:20:00',1.13),('16100','2013-05-15','18:25:00',1.18),('16100','2013-05-15','18:30:00',1.33),('16100','2013-05-15','18:35:00',1.56),('16100','2013-05-15','18:40:00',1.62),('16100','2013-05-15','18:45:00',1.68),('16100','2013-05-15','18:50:00',1.59),('16100','2013-05-15','18:55:00',1.49),('16100','2013-05-15','19:00:00',1.33),('16100','2013-05-15','19:05:00',1.09),('16100','2013-05-14','07:45:00',1.17),('16100','2013-05-14','07:50:00',1.48),('16100','2013-05-14','07:55:00',1.61),('16100','2013-05-14','08:00:00',1.55),('16100','2013-05-14','08:05:00',1.56),('16100','2013-05-14','08:10:00',1.87),('16100','2013-05-14','08:15:00',2.11),('16100','2013-05-14','08:20:00',2.28),('16100','2013-05-14','08:25:00',2.34),('16100','2013-05-14','08:30:00',2.52),('16100','2013-05-14','08:35:00',2.83),('16100','2013-05-14','08:40:00',3.02),('16100','2013-05-14','08:45:00',3.27),('16100','2013-05-14','08:50:00',3.66),('16100','2013-05-14','08:55:00',3.83),('16100','2013-05-14','09:00:00',3.85),('16100','2013-05-14','09:05:00',3.96),('16100','2013-05-14','09:10:00',4.13),('16100','2013-05-14','09:15:00',4.26),('16100','2013-05-14','09:20:00',4.31),('16100','2013-05-14','09:25:00',4.62),('16100','2013-05-14','09:30:00',4.88),('16100','2013-05-14','09:35:00',4.84),('16100','2013-05-14','09:40:00',4.92),('16100','2013-05-14','09:45:00',5.18),('16100','2013-05-14','09:50:00',5.34),('16100','2013-05-14','09:55:00',5.44),('16100','2013-05-14','10:00:00',5.52),('16100','2013-05-14','10:05:00',5.75),('16100','2013-05-14','10:10:00',5.83),('16100','2013-05-14','10:15:00',5.93),('16100','2013-05-14','10:20:00',6.09),('16100','2013-05-14','10:25:00',6.22),('16100','2013-05-14','10:30:00',6.12),('16100','2013-05-14','10:35:00',6.19),('16100','2013-05-14','10:40:00',6.34),('16100','2013-05-14','10:45:00',6.53),('16100','2013-05-14','10:50:00',6.66),('16100','2013-05-14','10:55:00',6.7),('16100','2013-05-14','11:00:00',6.57),('16100','2013-05-14','11:05:00',6.8),('16100','2013-05-14','11:10:00',6.7),('16100','2013-05-14','11:15:00',6.75),('16100','2013-05-14','11:20:00',6.79),('16100','2013-05-14','11:25:00',7.19),('16100','2013-05-14','11:30:00',7.52),('16100','2013-05-14','11:35:00',7.54),('16100','2013-05-14','11:40:00',7.25),('16100','2013-05-14','11:45:00',6.69),('16100','2013-05-14','11:50:00',4.54),('16100','2013-05-14','11:55:00',4.16),('16100','2013-05-14','12:00:00',6.5),('16100','2013-05-14','12:05:00',6.88),('16100','2013-05-14','12:10:00',7.7),('16100','2013-05-14','12:15:00',7.92),('16100','2013-05-14','12:20:00',8.74),('16100','2013-05-14','12:25:00',6.18),('16100','2013-05-14','12:30:00',7.25),('16100','2013-05-14','12:35:00',5.6),('16100','2013-05-14','12:40:00',4.85),('16100','2013-05-14','12:45:00',4.15),('16100','2013-05-14','12:50:00',3.94),('16100','2013-05-14','12:55:00',3.96),('16100','2013-05-14','13:00:00',4.07),('16100','2013-05-14','13:05:00',4.36),('16100','2013-05-14','13:10:00',4.11),('16100','2013-05-14','13:15:00',4.29),('16100','2013-05-14','13:20:00',4.12),('16100','2013-05-14','13:25:00',4.81),('16100','2013-05-14','13:30:00',4.34),('16100','2013-05-14','13:35:00',4.64),('16100','2013-05-14','13:40:00',4.96),('16100','2013-05-14','13:45:00',3.6),('16100','2013-05-14','13:50:00',3.68),('16100','2013-05-14','13:55:00',4.32),('16100','2013-05-14','14:00:00',3.19),('16100','2013-05-14','14:05:00',3.53),('16100','2013-05-14','14:10:00',3.89),('16100','2013-05-14','14:15:00',3.74),('16100','2013-05-14','14:20:00',3.74),('16100','2013-05-14','14:25:00',3.18),('16100','2013-05-14','14:30:00',2.61),('16100','2013-05-14','14:35:00',2.25),('16100','2013-05-14','14:40:00',2.2),('16100','2013-05-14','14:45:00',2.13),('16100','2013-05-14','14:50:00',2.11),('16100','2013-05-14','14:55:00',2.21),('16100','2013-05-14','15:00:00',2.12),('16100','2013-05-14','15:05:00',1.68),('16100','2013-05-14','15:10:00',1.39),('16100','2013-05-14','15:15:00',1.29),('16100','2013-05-14','15:20:00',1.24),('16100','2013-05-14','15:25:00',1.32),('16100','2013-05-14','15:30:00',1.4),('16100','2013-05-14','15:35:00',1.41),('16100','2013-05-14','15:40:00',1.54),('16100','2013-05-14','15:45:00',1.99),('16100','2013-05-14','15:50:00',2.74),('16100','2013-05-14','15:55:00',3.1),('16100','2013-05-14','16:00:00',2.94),('16100','2013-05-14','16:05:00',3.01),('16100','2013-05-14','16:10:00',2.86),('16100','2013-05-14','16:15:00',2.91),('16100','2013-05-14','16:20:00',2.89),('16100','2013-05-14','16:25:00',2.56),('16100','2013-05-14','16:30:00',2.17),('16100','2013-05-14','16:35:00',2.36),('16100','2013-05-14','16:40:00',2.13),('16100','2013-05-14','16:45:00',1.94),('16100','2013-05-14','16:50:00',2.04),('16100','2013-05-14','16:55:00',2.19),('16100','2013-05-14','17:00:00',2.47),('16100','2013-05-14','17:05:00',2.91),('16100','2013-05-14','17:10:00',2.92),('16100','2013-05-14','17:15:00',4.11),('16100','2013-05-14','17:20:00',3.92),('16100','2013-05-14','17:25:00',2.24),('16100','2013-05-14','17:30:00',1.89),('16100','2013-05-14','17:35:00',1.49),('16100','2013-05-14','17:40:00',1.39),('16100','2013-05-14','17:45:00',1.39),('16100','2013-05-14','17:50:00',1.3),('16100','2013-05-14','17:55:00',1.2),('16100','2013-05-13','07:45:00',1.09),('16100','2013-05-13','07:50:00',1.31),('16100','2013-05-13','07:55:00',1.49),('16100','2013-05-13','08:00:00',1.68),('16100','2013-05-13','08:05:00',1.87),('16100','2013-05-13','08:10:00',2.07),('16100','2013-05-13','08:15:00',2.26),('16100','2013-05-13','08:20:00',2.46),('16100','2013-05-13','08:25:00',2.64),('16100','2013-05-13','08:30:00',2.84),('16100','2013-05-13','08:35:00',3.02),('16100','2013-05-13','08:40:00',3.18),('16100','2013-05-13','08:45:00',3.47),('16100','2013-05-13','08:50:00',3.86),('16100','2013-05-13','08:55:00',4.06),('16100','2013-05-13','09:00:00',4.23),('16100','2013-05-13','09:05:00',4.37),('16100','2013-05-13','09:10:00',4.52),('16100','2013-05-13','09:15:00',4.66),('16100','2013-05-13','09:20:00',4.81),('16100','2013-05-13','09:25:00',4.95),('16100','2013-05-13','09:30:00',5.06),('16100','2013-05-13','09:35:00',5.19),('16100','2013-05-13','09:40:00',5.36),('16100','2013-05-13','09:45:00',5.51),('16100','2013-05-13','09:50:00',5.61),('16100','2013-05-13','09:55:00',5.75),('16100','2013-05-13','10:00:00',5.89),('16100','2013-05-13','10:05:00',6.05),('16100','2013-05-13','10:10:00',6.12),('16100','2013-05-13','10:15:00',6.22),('16100','2013-05-13','10:20:00',6.44),('16100','2013-05-13','10:25:00',6.55),('16100','2013-05-13','10:30:00',6.65),('16100','2013-05-13','10:35:00',6.73),('16100','2013-05-13','10:40:00',6.84),('16100','2013-05-13','10:45:00',6.88),('16100','2013-05-13','10:50:00',6.93),('16100','2013-05-13','10:55:00',7.01),('16100','2013-05-13','11:00:00',7.18),('16100','2013-05-13','11:05:00',7.26),('16100','2013-05-13','11:10:00',7.33),('16100','2013-05-13','11:15:00',7.35),('16100','2013-05-13','11:20:00',7.44),('16100','2013-05-13','11:25:00',6.17),('16100','2013-05-13','11:30:00',7.47),('16100','2013-05-13','11:35:00',7.53),('16100','2013-05-13','11:40:00',7.61),('16100','2013-05-13','11:45:00',7.65),('16100','2013-05-13','11:50:00',7.73),('16100','2013-05-13','11:55:00',7.75),('16100','2013-05-13','12:00:00',7.79),('16100','2013-05-13','12:05:00',6.23),('16100','2013-05-13','12:10:00',7.85),('16100','2013-05-13','12:15:00',7.87),('16100','2013-05-13','12:20:00',7.87),('16100','2013-05-13','12:25:00',7.83),('16100','2013-05-13','12:30:00',7.93),('16100','2013-05-13','12:35:00',7.91),('16100','2013-05-13','12:40:00',7.93),('16100','2013-05-13','12:45:00',7.95),('16100','2013-05-13','12:50:00',7.95),('16100','2013-05-13','12:55:00',8),('16100','2013-05-13','13:00:00',7.98),('16100','2013-05-13','13:05:00',7.97),('16100','2013-05-13','13:10:00',7.94),('16100','2013-05-13','13:15:00',7.91),('16100','2013-05-13','13:20:00',7.93),('16100','2013-05-13','13:25:00',7.92),('16100','2013-05-13','13:30:00',7.96),('16100','2013-05-13','13:35:00',8),('16100','2013-05-13','13:40:00',7.95),('16100','2013-05-13','13:45:00',7.96),('16100','2013-05-13','13:50:00',7.95),('16100','2013-05-13','13:55:00',7.89),('16100','2013-05-13','14:00:00',7.81),('16100','2013-05-13','14:05:00',7.59),('16100','2013-05-13','14:10:00',7.59),('16100','2013-05-13','14:15:00',7.57),('16100','2013-05-13','14:20:00',7.56),('16100','2013-05-13','14:25:00',7.54),('16100','2013-05-13','14:30:00',7.53),('16100','2013-05-13','14:35:00',7.57),('16100','2013-05-13','14:40:00',7.6),('16100','2013-05-13','14:45:00',7.6),('16100','2013-05-13','14:50:00',7.56),('16100','2013-05-13','14:55:00',7.53),('16100','2013-05-13','15:00:00',7.48),('16100','2013-05-13','15:05:00',7.4),('16100','2013-05-13','15:10:00',7.33),('16100','2013-05-13','15:15:00',7.23),('16100','2013-05-13','15:20:00',7.12),('16100','2013-05-13','15:25:00',7.07),('16100','2013-05-13','15:30:00',6.97),('16100','2013-05-13','15:35:00',6.86),('16100','2013-05-13','15:40:00',6.75),('16100','2013-05-13','15:45:00',6.65),('16100','2013-05-13','15:50:00',6.56),('16100','2013-05-13','15:55:00',6.46),('16100','2013-05-13','16:00:00',6.33),('16100','2013-05-13','16:05:00',6.22),('16100','2013-05-13','16:10:00',6.1),('16100','2013-05-13','16:15:00',5.91),('16100','2013-05-13','16:20:00',5.8),('16100','2013-05-13','16:25:00',5.67),('16100','2013-05-13','16:30:00',5.57),('16100','2013-05-13','16:35:00',5.44),('16100','2013-05-13','16:40:00',5.29),('16100','2013-05-13','16:45:00',5.13),('16100','2013-05-13','16:50:00',5.01),('16100','2013-05-13','16:55:00',4.86),('16100','2013-05-13','17:00:00',4.68),('16100','2013-05-13','17:05:00',4.52),('16100','2013-05-13','17:10:00',4.36),('16100','2013-05-13','17:15:00',4.21),('16100','2013-05-13','17:20:00',4.05),('16100','2013-05-13','17:25:00',3.88),('16100','2013-05-13','17:30:00',3.68),('16100','2013-05-13','17:35:00',3.51),('16100','2013-05-13','17:40:00',3.36),('16100','2013-05-13','17:45:00',3.19),('16100','2013-05-13','17:50:00',3),('16100','2013-05-13','17:55:00',2.83),('16100','2013-05-13','18:00:00',2.66),('16100','2013-05-13','18:05:00',2.49),('16100','2013-05-13','18:10:00',2.32),('16100','2013-05-13','18:15:00',2.14),('16100','2013-05-13','18:20:00',1.95),('16100','2013-05-13','18:25:00',1.73),('16100','2013-05-13','18:30:00',1.56),('16100','2013-05-13','18:35:00',1.38),('16100','2013-05-13','18:40:00',1.2),('16100','2013-05-13','18:45:00',1.04),('16100','2013-05-12','07:45:00',1.2),('16100','2013-05-12','07:50:00',1.42),('16100','2013-05-12','07:55:00',1.48),('16100','2013-05-12','08:00:00',1.57),('16100','2013-05-12','08:05:00',1.73),('16100','2013-05-12','08:10:00',1.88),('16100','2013-05-12','08:15:00',2.06),('16100','2013-05-12','08:20:00',2.27),('16100','2013-05-12','08:25:00',2.42),('16100','2013-05-12','08:30:00',2.61),('16100','2013-05-12','08:35:00',2.79),('16100','2013-05-12','08:40:00',2.96),('16100','2013-05-12','08:45:00',3.3),('16100','2013-05-12','08:50:00',3.6),('16100','2013-05-12','08:55:00',3.78),('16100','2013-05-12','09:00:00',3.95),('16100','2013-05-12','09:05:00',4.03),('16100','2013-05-12','09:10:00',4.18),('16100','2013-05-12','09:15:00',4.35),('16100','2013-05-12','09:20:00',4.54),('16100','2013-05-12','09:25:00',4.74),('16100','2013-05-12','09:30:00',4.89),('16100','2013-05-12','09:35:00',5.06),('16100','2013-05-12','09:40:00',4.53),('16100','2013-05-12','09:45:00',5.85),('16100','2013-05-12','09:50:00',4.94),('16100','2013-05-12','09:55:00',1.86),('16100','2013-05-12','10:00:00',2.15),('16100','2013-05-12','10:05:00',4.17),('16100','2013-05-12','10:10:00',3.43),('16100','2013-05-12','10:15:00',4.03),('16100','2013-05-12','10:20:00',6.91),('16100','2013-05-12','10:25:00',3.37),('16100','2013-05-12','10:30:00',2.4),('16100','2013-05-12','10:35:00',4.91),('16100','2013-05-12','10:40:00',7.1),('16100','2013-05-12','10:45:00',7.18),('16100','2013-05-12','10:50:00',4.59),('16100','2013-05-12','10:55:00',7.16),('16100','2013-05-12','11:00:00',7.84),('16100','2013-05-12','11:05:00',5.19),('16100','2013-05-12','11:10:00',6.41),('16100','2013-05-12','11:15:00',6.18),('16100','2013-05-12','11:20:00',5.93),('16100','2013-05-12','11:25:00',4.02),('16100','2013-05-12','11:30:00',3.79),('16100','2013-05-12','11:35:00',8.49),('16100','2013-05-12','11:40:00',8.1),('16100','2013-05-12','11:45:00',8.06),('16100','2013-05-12','11:50:00',6.03),('16100','2013-05-12','11:55:00',5.4),('16100','2013-05-12','12:00:00',3.07),('16100','2013-05-12','12:05:00',3.89),('16100','2013-05-12','12:10:00',2.48),('16100','2013-05-12','12:15:00',6.28),('16100','2013-05-12','12:20:00',5.53),('16100','2013-05-12','12:25:00',7.5),('16100','2013-05-12','12:30:00',6.11),('16100','2013-05-12','12:35:00',8.68),('16100','2013-05-12','12:40:00',8.9),('16100','2013-05-12','12:45:00',8.5),('16100','2013-05-12','12:50:00',8.51),('16100','2013-05-12','12:55:00',8.03),('16100','2013-05-12','13:00:00',8.75),('16100','2013-05-12','13:05:00',8.88),('16100','2013-05-12','13:10:00',8.96),('16100','2013-05-12','13:15:00',2.74),('16100','2013-05-12','13:20:00',1.68),('16100','2013-05-12','13:25:00',4.24),('16100','2013-05-12','13:30:00',3.73),('16100','2013-05-12','13:35:00',2.02),('16100','2013-05-12','13:40:00',5.43),('16100','2013-05-12','13:45:00',7.97),('16100','2013-05-12','13:50:00',8.96),('16100','2013-05-12','13:55:00',8.64),('16100','2013-05-12','14:00:00',8.37),('16100','2013-05-12','14:05:00',5.18),('16100','2013-05-12','14:10:00',2.56),('16100','2013-05-12','14:15:00',6.25),('16100','2013-05-12','14:20:00',2),('16100','2013-05-12','14:25:00',1.21),('16100','2013-05-12','14:35:00',1.35),('16100','2013-05-12','14:40:00',7.55),('16100','2013-05-12','14:45:00',6.88),('16100','2013-05-12','14:50:00',7.03),('16100','2013-05-12','14:55:00',2.83),('16100','2013-05-12','15:00:00',1.76),('16100','2013-05-12','15:05:00',1.5),('16100','2013-05-12','15:10:00',1.33),('16100','2013-05-12','15:15:00',1.23),('16100','2013-05-12','15:20:00',1.13),('16100','2013-05-12','15:25:00',1.24),('16100','2013-05-12','15:30:00',1.29),('16100','2013-05-12','15:35:00',1.63),('16100','2013-05-12','15:40:00',3.51),('16100','2013-05-12','15:45:00',1.84),('16100','2013-05-12','15:50:00',1.15),('16100','2013-05-12','15:55:00',1.75),('16100','2013-05-12','16:00:00',2.41),('16100','2013-05-12','16:05:00',2.81),('16100','2013-05-12','16:10:00',2.41),('16100','2013-05-12','16:15:00',2.1),('16100','2013-05-12','16:20:00',1.94),('16100','2013-05-12','16:25:00',1.72),('16100','2013-05-12','16:30:00',1.56),('16100','2013-05-12','16:35:00',1.54),('16100','2013-05-12','16:40:00',1.55),('16100','2013-05-12','16:45:00',1.58),('16100','2013-05-12','16:50:00',3.18),('16100','2013-05-12','16:55:00',4.96),('16100','2013-05-12','17:00:00',2.25),('16100','2013-05-12','17:05:00',1.27),('16100','2013-05-12','17:10:00',1.19),('16100','2013-05-12','17:15:00',1.73),('16100','2013-05-12','17:25:00',2.85),('16100','2013-05-12','17:30:00',2.98),('16100','2013-05-12','17:35:00',3.77),('16100','2013-05-12','17:40:00',3.65),('16100','2013-05-12','17:45:00',3.5),('16100','2013-05-12','17:50:00',3.51),('16100','2013-05-12','17:55:00',3.26),('16100','2013-05-12','18:00:00',2.35),('16100','2013-05-12','18:05:00',1.5),('16100','2013-05-12','18:10:00',2.18),('16100','2013-05-12','18:15:00',2.43),('16100','2013-05-12','18:20:00',2.48),('16100','2013-05-12','18:25:00',1.94),('16100','2013-05-12','18:30:00',1.77),('16100','2013-05-12','18:35:00',1.58),('16100','2013-05-12','18:40:00',1.16),('16100','2013-05-11','07:40:00',1.08),('16100','2013-05-11','07:45:00',1.45),('16100','2013-05-11','07:50:00',1.58),('16100','2013-05-11','07:55:00',1.36),('16100','2013-05-11','08:00:00',1.49),('16100','2013-05-11','08:05:00',1.47),('16100','2013-05-11','08:10:00',1.11),('16100','2013-05-11','08:15:00',1.26),('16100','2013-05-11','08:20:00',1.36),('16100','2013-05-11','08:25:00',1.27),('16100','2013-05-11','08:30:00',1.39),('16100','2013-05-11','08:35:00',1.52),('16100','2013-05-11','08:40:00',1.72),('16100','2013-05-11','08:45:00',1.77),('16100','2013-05-11','08:50:00',2.3),('16100','2013-05-11','08:55:00',1.75),('16100','2013-05-11','09:00:00',2.24),('16100','2013-05-11','09:05:00',2.63),('16100','2013-05-11','09:10:00',4.87),('16100','2013-05-11','09:15:00',3.04),('16100','2013-05-11','09:20:00',2.68),('16100','2013-05-11','09:25:00',5.71),('16100','2013-05-11','09:30:00',3.13),('16100','2013-05-11','09:35:00',2.91),('16100','2013-05-11','09:40:00',4.95),('16100','2013-05-11','09:45:00',3.11),('16100','2013-05-11','09:50:00',4.9),('16100','2013-05-11','09:55:00',6),('16100','2013-05-11','10:00:00',6.15),('16100','2013-05-11','10:05:00',6.44),('16100','2013-05-11','10:10:00',6.8),('16100','2013-05-11','10:15:00',6.99),('16100','2013-05-11','10:20:00',6.16),('16100','2013-05-11','10:25:00',2.82),('16100','2013-05-11','10:30:00',3.82),('16100','2013-05-11','10:35:00',3.51),('16100','2013-05-11','10:40:00',1.87),('16100','2013-05-11','10:45:00',6.21),('16100','2013-05-11','10:50:00',8.04),('16100','2013-05-11','10:55:00',7.77),('16100','2013-05-11','11:00:00',7.74),('16100','2013-05-11','11:05:00',7.97),('16100','2013-05-11','11:10:00',8.26),('16100','2013-05-11','11:15:00',8.54),('16100','2013-05-11','11:20:00',5.35),('16100','2013-05-11','11:25:00',4.24),('16100','2013-05-11','11:30:00',2.9),('16100','2013-05-11','11:35:00',2.02),('16100','2013-05-11','11:40:00',1.91),('16100','2013-05-11','11:45:00',6.13),('16100','2013-05-11','11:50:00',3.98),('16100','2013-05-11','11:55:00',1.68),('16100','2013-05-11','12:00:00',4.56),('16100','2013-05-11','12:05:00',7.4),('16100','2013-05-11','12:10:00',4.1),('16100','2013-05-11','12:15:00',2.11),('16100','2013-05-11','12:20:00',1.82),('16100','2013-05-11','12:25:00',2.02),('16100','2013-05-11','12:30:00',2.26),('16100','2013-05-11','12:35:00',2.52),('16100','2013-05-11','12:40:00',8.07),('16100','2013-05-11','12:45:00',8.3),('16100','2013-05-11','12:50:00',9.13),('16100','2013-05-11','12:55:00',8.73),('16100','2013-05-11','13:00:00',8.4),('16100','2013-05-11','13:05:00',8.11),('16100','2013-05-11','13:10:00',5.49),('16100','2013-05-11','13:15:00',8.6),('16100','2013-05-11','13:20:00',7.99),('16100','2013-05-11','13:25:00',8.51),('16100','2013-05-11','13:30:00',5.17),('16100','2013-05-11','13:35:00',9.07),('16100','2013-05-11','13:40:00',8.88),('16100','2013-05-11','13:45:00',6.16),('16100','2013-05-11','13:50:00',6.24),('16100','2013-05-11','13:55:00',8.6),('16100','2013-05-11','14:00:00',3.9),('16100','2013-05-11','14:05:00',4.82),('16100','2013-05-11','14:10:00',5.87),('16100','2013-05-11','14:15:00',7.17),('16100','2013-05-11','14:20:00',7.45),('16100','2013-05-11','14:25:00',8.54),('16100','2013-05-11','14:30:00',8.67),('16100','2013-05-11','14:35:00',8.43),('16100','2013-05-11','14:40:00',5.5),('16100','2013-05-11','14:45:00',6.94),('16100','2013-05-11','14:50:00',7.51),('16100','2013-05-11','14:55:00',7.05),('16100','2013-05-11','15:00:00',6.8),('16100','2013-05-11','15:05:00',6.2),('16100','2013-05-11','15:10:00',5.97),('16100','2013-05-11','15:15:00',6.77),('16100','2013-05-11','15:20:00',7.17),('16100','2013-05-11','15:25:00',7.13),('16100','2013-05-11','15:30:00',6.39),('16100','2013-05-11','15:35:00',6.87),('16100','2013-05-11','15:40:00',6.63),('16100','2013-05-11','15:45:00',6.54),('16100','2013-05-11','15:50:00',6.45),('16100','2013-05-11','15:55:00',6.33),('16100','2013-05-11','16:00:00',6.2),('16100','2013-05-11','16:05:00',6.07),('16100','2013-05-11','16:10:00',5.96),('16100','2013-05-11','16:15:00',5.8),('16100','2013-05-11','16:20:00',4.88),('16100','2013-05-11','16:25:00',5.75),('16100','2013-05-11','16:30:00',5.4),('16100','2013-05-11','16:35:00',5.72),('16100','2013-05-11','16:40:00',5.71),('16100','2013-05-11','16:45:00',5.76),('16100','2013-05-11','16:50:00',6.12),('16100','2013-05-11','16:55:00',6),('16100','2013-05-11','17:00:00',5.62),('16100','2013-05-11','17:05:00',3.77),('16100','2013-05-11','17:10:00',5.54),('16100','2013-05-11','17:15:00',4.4),('16100','2013-05-11','17:20:00',3.71),('16100','2013-05-11','17:25:00',3.04),('16100','2013-05-11','17:30:00',2.51),('16100','2013-05-11','17:35:00',3.83),('16100','2013-05-11','17:40:00',3.57),('16100','2013-05-11','17:45:00',2.36),('16100','2013-05-11','17:50:00',2.65),('16100','2013-05-11','17:55:00',2.1),('16100','2013-05-11','18:00:00',2.42),('16100','2013-05-11','18:05:00',2.13),('16100','2013-05-11','18:10:00',2.86),('16100','2013-05-11','18:15:00',2.4),('16100','2013-05-11','18:20:00',2.1),('16100','2013-05-11','18:25:00',1.98),('16100','2013-05-11','18:30:00',1.78),('16100','2013-05-11','18:35:00',2.02),('16100','2013-05-11','18:40:00',1.64),('16100','2013-05-11','18:45:00',1.11),('16100','2013-05-11','18:55:00',1.01),('16100','2013-05-11','19:00:00',1.03),('16100','2013-05-11','19:05:00',1.25),('16100','2013-05-11','19:15:00',1.06),('16100','2014-03-30','08:15:00',1.12),('16100','2014-03-30','08:20:00',1.29),('16100','2014-03-30','08:25:00',1.46),('16100','2014-03-30','08:30:00',1.64),('16100','2014-03-30','08:35:00',1.84),('16100','2014-03-30','08:40:00',2.02),('16100','2014-03-30','08:45:00',2.22),('16100','2014-03-30','08:50:00',2.42),('16100','2014-03-30','08:55:00',2.6),('16100','2014-03-30','09:00:00',2.77),('16100','2014-03-30','09:05:00',2.96),('16100','2014-03-30','09:10:00',3.12),('16100','2014-03-30','09:15:00',3.28),('16100','2014-03-30','09:20:00',3.46),('16100','2014-03-30','09:25:00',3.67),('16100','2014-03-30','09:30:00',3.81),('16100','2014-03-30','09:35:00',3.95),('16100','2014-03-30','09:40:00',4.08),('16100','2014-03-30','09:45:00',4.23),('16100','2014-03-30','09:50:00',4.38),('16100','2014-03-30','09:55:00',4.54),('16100','2014-03-30','10:00:00',4.65),('16100','2014-03-30','10:05:00',4.77),('16100','2014-03-30','10:10:00',4.91),('16100','2014-03-30','10:15:00',5.02),('16100','2014-03-30','10:20:00',5.09),('16100','2014-03-30','10:25:00',5.21),('16100','2014-03-30','10:30:00',5.34),('16100','2014-03-30','10:35:00',5.51),('16100','2014-03-30','10:40:00',5.61),('16100','2014-03-30','10:45:00',5.71),('16100','2014-03-30','10:50:00',5.78),('16100','2014-03-30','10:55:00',5.91),('16100','2014-03-30','11:00:00',6.03),('16100','2014-03-30','11:05:00',6.11),('16100','2014-03-30','11:10:00',6.21),('16100','2014-03-30','11:15:00',6.25),('16100','2014-03-30','11:20:00',6.36),('16100','2014-03-30','11:25:00',6.44),('16100','2014-03-30','11:30:00',6.47),('16100','2014-03-30','11:35:00',6.62),('16100','2014-03-30','11:40:00',6.72),('16100','2014-03-30','11:45:00',6.71),('16100','2014-03-30','11:50:00',6.77),('16100','2014-03-30','11:55:00',6.84),('16100','2014-03-30','12:00:00',6.91),('16100','2014-03-30','12:05:00',7.01),('16100','2014-03-30','12:10:00',7.13),('16100','2014-03-30','12:15:00',7.17),('16100','2014-03-30','12:20:00',7.15),('16100','2014-03-30','12:25:00',7.19),('16100','2014-03-30','12:30:00',7.17),('16100','2014-03-30','12:35:00',7.21),('16100','2014-03-30','12:40:00',7.23),('16100','2014-03-30','12:45:00',7.29),('16100','2014-03-30','12:50:00',7.37),('16100','2014-03-30','12:55:00',7.37),('16100','2014-03-30','13:00:00',7.36),('16100','2014-03-30','13:05:00',7.4),('16100','2014-03-30','13:10:00',7.4),('16100','2014-03-30','13:15:00',7.39),('16100','2014-03-30','13:20:00',7.42),('16100','2014-03-30','13:25:00',7.36),('16100','2014-03-30','13:30:00',7.39),('16100','2014-03-30','13:35:00',7.4),('16100','2014-03-30','13:40:00',7.39),('16100','2014-03-30','13:45:00',7.41),('16100','2014-03-30','13:50:00',7.36),('16100','2014-03-30','13:55:00',7.39),('16100','2014-03-30','14:00:00',7.36),('16100','2014-03-30','14:05:00',7.33),('16100','2014-03-30','14:10:00',7.3),('16100','2014-03-30','14:15:00',7.19),('16100','2014-03-30','14:20:00',7.18),('16100','2014-03-30','14:25:00',7.13),('16100','2014-03-30','14:30:00',7.09),('16100','2014-03-30','14:35:00',7.04),('16100','2014-03-30','14:40:00',7.02),('16100','2014-03-30','14:45:00',6.96),('16100','2014-03-30','14:50:00',6.9),('16100','2014-03-30','14:55:00',6.84),('16100','2014-03-30','15:00:00',6.75),('16100','2014-03-30','15:05:00',6.7),('16100','2014-03-30','15:10:00',6.62),('16100','2014-03-30','15:15:00',6.57),('16100','2014-03-30','15:20:00',6.42),('16100','2014-03-30','15:25:00',6.29),('16100','2014-03-30','15:30:00',6.2),('16100','2014-03-30','15:35:00',6.15),('16100','2014-03-30','15:40:00',6.01),('16100','2014-03-30','15:45:00',5.87),('16100','2014-03-30','15:50:00',5.69),('16100','2014-03-30','15:55:00',5.59),('16100','2014-03-30','16:00:00',5.46),('16100','2014-03-30','16:05:00',5.36),('16100','2014-03-30','16:10:00',5.18),('16100','2014-03-30','16:15:00',5.09),('16100','2014-03-30','16:20:00',4.93),('16100','2014-03-30','16:25:00',4.82),('16100','2014-03-30','16:30:00',4.71),('16100','2014-03-30','16:35:00',4.59),('16100','2014-03-30','16:40:00',4.46),('16100','2014-03-30','16:45:00',4.28),('16100','2014-03-30','16:50:00',4.13),('16100','2014-03-30','16:55:00',3.97),('16100','2014-03-30','17:00:00',3.83),('16100','2014-03-30','17:05:00',3.67),('16100','2014-03-30','17:10:00',3.44),('16100','2014-03-30','17:15:00',3.3),('16100','2014-03-30','17:20:00',3.11),('16100','2014-03-30','17:25:00',2.91),('16100','2014-03-30','17:30:00',2.75),('16100','2014-03-30','17:35:00',2.58),('16100','2014-03-30','17:40:00',2.42),('16100','2014-03-30','17:45:00',2.27),('16100','2014-03-30','17:50:00',2.08),('16100','2014-03-30','17:55:00',1.91),('16100','2014-03-30','18:00:00',1.76),('16100','2014-03-30','18:05:00',1.61),('16100','2014-03-30','18:10:00',1.48),('16100','2014-03-30','18:15:00',1.35),('16100','2014-03-30','18:20:00',1.25),('16100','2014-03-30','18:25:00',1.15),('16100','2014-03-30','18:30:00',1.03),('16100','2013-05-10','07:40:00',1.06),('16100','2013-05-10','07:45:00',1.58),('16100','2013-05-10','07:50:00',1.47),('16100','2013-05-10','07:55:00',1.02),('16100','2013-05-10','08:00:00',1.82),('16100','2013-05-10','08:05:00',2.24),('16100','2013-05-10','08:10:00',2.23),('16100','2013-05-10','08:15:00',1.44),('16100','2013-05-10','08:20:00',1.03),('16100','2013-05-10','08:40:00',1.38),('16100','2013-05-10','08:45:00',1.48),('16100','2013-05-10','08:50:00',1.48),('16100','2013-05-10','08:55:00',3.12),('16100','2013-05-10','09:00:00',3.34),('16100','2013-05-10','09:05:00',3.74),('16100','2013-05-10','09:10:00',2.74),('16100','2013-05-10','09:15:00',2.48),('16100','2013-05-10','09:20:00',5.26),('16100','2013-05-10','09:25:00',3.11),('16100','2013-05-10','09:30:00',1.72),('16100','2013-05-10','09:35:00',1.49),('16100','2013-05-10','09:40:00',2.88),('16100','2013-05-10','09:45:00',1.81),('16100','2013-05-10','09:50:00',1.84),('16100','2013-05-10','09:55:00',1.93),('16100','2013-05-10','10:00:00',2.48),('16100','2013-05-10','10:05:00',2.88),('16100','2013-05-10','10:10:00',2.05),('16100','2013-05-10','10:15:00',2.47),('16100','2013-05-10','10:20:00',2.35),('16100','2013-05-10','10:25:00',5.91),('16100','2013-05-10','10:30:00',1.71),('16100','2013-05-10','10:35:00',1.24),('16100','2013-05-10','10:40:00',1.24),('16100','2013-05-10','10:45:00',4.19),('16100','2013-05-10','10:50:00',1.34),('16100','2013-05-10','10:55:00',2.02),('16100','2013-05-10','11:00:00',5.2),('16100','2013-05-10','11:05:00',2.63),('16100','2013-05-10','11:10:00',2.07),('16100','2013-05-10','11:15:00',2.25),('16100','2013-05-10','11:20:00',1.71),('16100','2013-05-10','11:25:00',4.05),('16100','2013-05-10','11:30:00',8.74),('16100','2013-05-10','11:35:00',5.26),('16100','2013-05-10','11:40:00',7.64),('16100','2013-05-10','11:45:00',3.23),('16100','2013-05-10','11:50:00',3.16),('16100','2013-05-10','11:55:00',6.44),('16100','2013-05-10','12:00:00',6.76),('16100','2013-05-10','12:05:00',5.34),('16100','2013-05-10','12:10:00',6.37),('16100','2013-05-10','12:15:00',5.01),('16100','2013-05-10','12:20:00',2.9),('16100','2013-05-10','12:25:00',1.97),('16100','2013-05-10','12:30:00',3.08),('16100','2013-05-10','12:35:00',2.53),('16100','2013-05-10','12:40:00',3.09),('16100','2013-05-10','12:45:00',2.22),('16100','2013-05-10','12:50:00',2.59),('16100','2013-05-10','12:55:00',2.9),('16100','2013-05-10','13:00:00',5.74),('16100','2013-05-10','13:05:00',7.22),('16100','2013-05-10','13:10:00',7.7),('16100','2013-05-10','13:15:00',8.57),('16100','2013-05-10','13:20:00',6.5),('16100','2013-05-10','13:25:00',6.44),('16100','2013-05-10','13:30:00',3.72),('16100','2013-05-10','13:35:00',3.54),('16100','2013-05-10','13:40:00',5.73),('16100','2013-05-10','13:45:00',7.22),('16100','2013-05-10','13:50:00',6.75),('16100','2013-05-10','13:55:00',7.74),('16100','2013-05-10','14:00:00',3.28),('16100','2013-05-10','14:05:00',4.41),('16100','2013-05-10','14:10:00',5.81),('16100','2013-05-10','14:15:00',5.12),('16100','2013-05-10','14:20:00',2.79),('16100','2013-05-10','14:25:00',4.66),('16100','2013-05-10','14:30:00',7.36),('16100','2013-05-10','14:35:00',6.53),('16100','2013-05-10','14:40:00',4.88),('16100','2013-05-10','14:45:00',2.85),('16100','2013-05-10','14:50:00',3.64),('16100','2013-05-10','14:55:00',6.95),('16100','2013-05-10','15:00:00',3.7),('16100','2013-05-10','15:05:00',3.59),('16100','2013-05-10','15:10:00',6.26),('16100','2013-05-10','15:15:00',4.9),('16100','2013-05-10','15:20:00',3.14),('16100','2013-05-10','15:25:00',3.52),('16100','2013-05-10','15:30:00',5.05),('16100','2013-05-10','15:35:00',5.18),('16100','2013-05-10','15:40:00',5.06),('16100','2013-05-10','15:45:00',4.31),('16100','2013-05-10','15:50:00',4.84),('16100','2013-05-10','15:55:00',5.86),('16100','2013-05-10','16:00:00',4.78),('16100','2013-05-10','16:05:00',5.61),('16100','2013-05-10','16:10:00',5.92),('16100','2013-05-10','16:15:00',6.19),('16100','2013-05-10','16:20:00',4.29),('16100','2013-05-10','16:25:00',6.12),('16100','2013-05-10','16:30:00',5.25),('16100','2013-05-10','16:35:00',5.6),('16100','2013-05-10','16:40:00',5.38),('16100','2013-05-10','16:45:00',5.07),('16100','2013-05-10','16:50:00',5.11),('16100','2013-05-10','16:55:00',3.16),('16100','2013-05-10','17:00:00',1.99),('16100','2013-05-10','17:05:00',3.14),('16100','2013-05-10','17:10:00',3.16),('16100','2013-05-10','17:15:00',4.53),('16100','2013-05-10','17:20:00',3.9),('16100','2013-05-10','17:25:00',4.26),('16100','2013-05-10','17:30:00',2.59),('16100','2013-05-10','17:35:00',2.86),('16100','2013-05-10','17:40:00',1.19),('16100','2013-05-10','17:45:00',1.62),('16100','2013-05-10','17:50:00',3.7),('16100','2013-05-10','17:55:00',2.88),('16100','2013-05-10','18:00:00',2.96),('16100','2013-05-10','18:05:00',1.64),('16100','2013-05-10','18:10:00',2.78),('16100','2013-05-10','18:15:00',2.05),('16100','2013-05-10','18:20:00',2.72),('16100','2013-05-10','18:25:00',1.56),('16100','2013-05-10','18:30:00',1.54),('16100','2013-05-10','18:35:00',1.2),('16100','2013-05-10','18:40:00',1.13),('16100','2013-05-09','07:20:00',1.14),('16100','2013-05-09','07:25:00',1.28),('16100','2013-05-09','07:30:00',1.59),('16100','2013-05-09','07:35:00',1.51),('16100','2013-05-09','07:40:00',1.41),('16100','2013-05-09','07:45:00',1.5),('16100','2013-05-09','07:50:00',1.77),('16100','2013-05-09','07:55:00',1.87),('16100','2013-05-09','08:00:00',2.26),('16100','2013-05-09','08:05:00',2.02),('16100','2013-05-09','08:10:00',2),('16100','2013-05-09','08:15:00',1.74),('16100','2013-05-09','08:20:00',2),('16100','2013-05-09','08:25:00',2.26),('16100','2013-05-09','08:30:00',1.98),('16100','2013-05-09','08:35:00',1.18),('16100','2013-05-09','08:45:00',1.22),('16100','2013-05-09','08:50:00',2.32),('16100','2013-05-09','08:55:00',3.89),('16100','2013-05-09','09:00:00',4.01),('16100','2013-05-09','09:05:00',4.08),('16100','2013-05-09','09:10:00',4.36),('16100','2013-05-09','09:15:00',4.58),('16100','2013-05-09','09:20:00',4.16),('16100','2013-05-09','09:25:00',4.86),('16100','2013-05-09','09:30:00',4.92),('16100','2013-05-09','09:35:00',4.75),('16100','2013-05-09','09:40:00',5.08),('16100','2013-05-09','09:45:00',5.13),('16100','2013-05-09','09:50:00',4.37),('16100','2013-05-09','09:55:00',4.96),('16100','2013-05-09','10:00:00',6.28),('16100','2013-05-09','10:05:00',4.89),('16100','2013-05-09','10:10:00',2.37),('16100','2013-05-09','10:15:00',1.86),('16100','2013-05-09','10:20:00',1.52),('16100','2013-05-09','10:25:00',3.87),('16100','2013-05-09','10:30:00',6.73),('16100','2013-05-09','10:35:00',6.4),('16100','2013-05-09','10:40:00',6.63),('16100','2013-05-09','10:45:00',6.73),('16100','2013-05-09','10:50:00',7.07),('16100','2013-05-09','10:55:00',7.07),('16100','2013-05-09','11:00:00',7.5),('16100','2013-05-09','11:05:00',7.7),('16100','2013-05-09','11:10:00',7.85),('16100','2013-05-09','11:15:00',7.39),('16100','2013-05-09','11:20:00',7.24),('16100','2013-05-09','11:25:00',6.03),('16100','2013-05-09','11:30:00',8.04),('16100','2013-05-09','11:35:00',6.36),('16100','2013-05-09','11:40:00',3.11),('16100','2013-05-09','11:45:00',8.09),('16100','2013-05-09','11:50:00',6.26),('16100','2013-05-09','11:55:00',4.05),('16100','2013-05-09','12:00:00',7.6),('16100','2013-05-09','12:05:00',6.03),('16100','2013-05-09','12:10:00',5.35),('16100','2013-05-09','12:15:00',4.97),('16100','2013-05-09','12:20:00',4.9),('16100','2013-05-09','12:25:00',4.81),('16100','2013-05-09','12:30:00',7.02),('16100','2013-05-09','12:35:00',9.38),('16100','2013-05-09','12:40:00',9.05),('16100','2013-05-09','12:45:00',7.45),('16100','2013-05-09','12:50:00',7.72),('16100','2013-05-09','12:55:00',8.78),('16100','2013-05-09','13:00:00',6.5),('16100','2013-05-09','13:05:00',6.54),('16100','2013-05-09','13:10:00',7.96),('16100','2013-05-09','13:15:00',6.5),('16100','2013-05-09','13:20:00',5.94),('16100','2013-05-09','13:25:00',8.1),('16100','2013-05-09','13:30:00',9),('16100','2013-05-09','13:35:00',9.37),('16100','2013-05-09','13:40:00',6.68),('16100','2013-05-09','13:45:00',3.98),('16100','2013-05-09','13:50:00',3.35),('16100','2013-05-09','13:55:00',3.28),('16100','2013-05-09','14:00:00',3.9),('16100','2013-05-09','14:05:00',4.88),('16100','2013-05-09','14:10:00',4.91),('16100','2013-05-09','14:15:00',4.9),('16100','2013-05-09','14:20:00',4.19),('16100','2013-05-09','14:25:00',4.24),('16100','2013-05-09','14:30:00',4.59),('16100','2013-05-09','14:35:00',3.75),('16100','2013-05-09','14:40:00',2.99),('16100','2013-05-09','14:45:00',2.46),('16100','2013-05-09','14:50:00',2.27),('16100','2013-05-09','14:55:00',2.7),('16100','2013-05-09','15:00:00',4.43),('16100','2013-05-09','15:05:00',7.26),('16100','2013-05-09','15:10:00',5.34),('16100','2013-05-09','15:15:00',3.7),('16100','2013-05-09','15:20:00',3.47),('16100','2013-05-09','15:25:00',3.59),('16100','2013-05-09','15:30:00',4.19),('16100','2013-05-09','15:35:00',3.88),('16100','2013-05-09','15:40:00',3.44),('16100','2013-05-09','15:45:00',3.08),('16100','2013-05-09','15:50:00',2.91),('16100','2013-05-09','15:55:00',2.91),('16100','2013-05-09','16:00:00',2.88),('16100','2013-05-09','16:05:00',2.64),('16100','2013-05-09','16:10:00',2.41),('16100','2013-05-09','16:15:00',2.39),('16100','2013-05-09','16:20:00',2.44),('16100','2013-05-09','16:25:00',2.66),('16100','2013-05-09','16:30:00',2.87),('16100','2013-05-09','16:35:00',2.55),('16100','2013-05-09','16:40:00',2.41),('16100','2013-05-09','16:45:00',2.18),('16100','2013-05-09','16:50:00',1.78),('16100','2013-05-09','16:55:00',1.79),('16100','2013-05-09','17:00:00',2.04),('16100','2013-05-09','17:05:00',2.58),('16100','2013-05-09','17:10:00',2.85),('16100','2013-05-09','17:15:00',3.28),('16100','2013-05-09','17:20:00',4.4),('16100','2013-05-09','17:25:00',5.54),('16100','2013-05-09','17:30:00',4.37),('16100','2013-05-09','17:35:00',2.17),('16100','2013-05-09','17:40:00',2.4),('16100','2013-05-09','17:45:00',1.68),('16100','2013-05-09','17:50:00',1.54),('16100','2013-05-09','17:55:00',1.46),('16100','2013-05-09','18:00:00',1.37),('16100','2013-05-09','18:05:00',1.28),('16100','2013-05-09','18:10:00',1.16),('16100','2013-05-09','18:15:00',1.11),('16100','2013-05-08','07:45:00',1.01),('16100','2013-05-08','07:50:00',1.21),('16100','2013-05-08','07:55:00',1.38),('16100','2013-05-08','08:00:00',1.52),('16100','2013-05-08','08:05:00',1.7),('16100','2013-05-08','08:10:00',1.88),('16100','2013-05-08','08:15:00',2.08),('16100','2013-05-08','08:20:00',2.26),('16100','2013-05-08','08:25:00',2.44),('16100','2013-05-08','08:30:00',2.62),('16100','2013-05-08','08:35:00',2.89),('16100','2013-05-08','08:40:00',3.13),('16100','2013-05-08','08:45:00',3.44),('16100','2013-05-08','08:50:00',3.64),('16100','2013-05-08','08:55:00',3.86),('16100','2013-05-08','09:00:00',4.01),('16100','2013-05-08','09:05:00',4.16),('16100','2013-05-08','09:10:00',4.33),('16100','2013-05-08','09:15:00',4.49),('16100','2013-05-08','09:20:00',4.59),('16100','2013-05-08','09:25:00',4.75),('16100','2013-05-08','09:30:00',4.93),('16100','2013-05-08','09:35:00',5.02),('16100','2013-05-08','09:40:00',5.15),('16100','2013-05-08','09:45:00',5.31),('16100','2013-05-08','09:50:00',5.44),('16100','2013-05-08','09:55:00',5.56),('16100','2013-05-08','10:00:00',5.73),('16100','2013-05-08','10:05:00',5.88),('16100','2013-05-08','10:10:00',5.98),('16100','2013-05-08','10:15:00',6.09),('16100','2013-05-08','10:20:00',6.18),('16100','2013-05-08','10:25:00',6.29),('16100','2013-05-08','10:30:00',6.35),('16100','2013-05-08','10:35:00',6.42),('16100','2013-05-08','10:40:00',6.56),('16100','2013-05-08','10:45:00',6.62),('16100','2013-05-08','10:50:00',6.7),('16100','2013-05-08','10:55:00',6.77),('16100','2013-05-08','11:00:00',6.85),('16100','2013-05-08','11:05:00',6.9),('16100','2013-05-08','11:10:00',7.06),('16100','2013-05-08','11:15:00',7.14),('16100','2013-05-08','11:20:00',7.08),('16100','2013-05-08','11:25:00',7.25),('16100','2013-05-08','11:30:00',7.38),('16100','2013-05-08','11:35:00',7.47),('16100','2013-05-08','11:40:00',7.48),('16100','2013-05-08','11:45:00',7.47),('16100','2013-05-08','11:50:00',7.55),('16100','2013-05-08','11:55:00',7.58),('16100','2013-05-08','12:00:00',7.68),('16100','2013-05-08','12:05:00',7.61),('16100','2013-05-08','12:10:00',7.67),('16100','2013-05-08','12:15:00',7.79),('16100','2013-05-08','12:20:00',7.81),('16100','2013-05-08','12:25:00',7.82),('16100','2013-05-08','12:30:00',7.85),('16100','2013-05-08','12:35:00',7.95),('16100','2013-05-08','12:40:00',7.07),('16100','2013-05-08','12:45:00',1.19),('16100','2013-05-08','12:50:00',3.24),('16100','2013-05-08','12:55:00',8.46),('16100','2013-05-08','13:00:00',8.24),('16100','2013-05-08','13:05:00',6.97),('16100','2013-05-08','13:10:00',6.49),('16100','2013-05-08','13:15:00',5.48),('16100','2013-05-08','13:20:00',7.44),('16100','2013-05-08','13:25:00',8.41),('16100','2013-05-08','13:30:00',8.23),('16100','2013-05-08','13:35:00',8.31),('16100','2013-05-08','13:40:00',8.34),('16100','2013-05-08','13:45:00',8.39),('16100','2013-05-08','13:50:00',8.46),('16100','2013-05-08','13:55:00',5.42),('16100','2013-05-08','14:00:00',4.56),('16100','2013-05-08','14:05:00',7.26),('16100','2013-05-08','14:10:00',8.26),('16100','2013-05-08','14:15:00',8.1),('16100','2013-05-08','14:20:00',7.92),('16100','2013-05-08','14:25:00',7.99),('16100','2013-05-08','14:30:00',7.92),('16100','2013-05-08','14:35:00',7.99),('16100','2013-05-08','14:40:00',7.73),('16100','2013-05-08','14:45:00',7.54),('16100','2013-05-08','14:50:00',7.34),('16100','2013-05-08','14:55:00',7.32),('16100','2013-05-08','15:00:00',7.24),('16100','2013-05-08','15:05:00',7.2),('16100','2013-05-08','15:10:00',7.16),('16100','2013-05-08','15:15:00',7.02),('16100','2013-05-08','15:20:00',6.88),('16100','2013-05-08','15:25:00',6.9),('16100','2013-05-08','15:30:00',6.8),('16100','2013-05-08','15:35:00',6.65),('16100','2013-05-08','15:40:00',6.55),('16100','2013-05-08','15:45:00',6.48),('16100','2013-05-08','15:50:00',6.35),('16100','2013-05-08','15:55:00',6.26),('16100','2013-05-08','16:00:00',6.2),('16100','2013-05-08','16:05:00',6.05),('16100','2013-05-08','16:10:00',5.87),('16100','2013-05-08','16:15:00',5.7),('16100','2013-05-08','16:20:00',5.59),('16100','2013-05-08','16:25:00',5.5),('16100','2013-05-08','16:30:00',5.38),('16100','2013-05-08','16:35:00',5.23),('16100','2013-05-08','16:40:00',5.12),('16100','2013-05-08','16:45:00',5),('16100','2013-05-08','16:50:00',4.86),('16100','2013-05-08','16:55:00',4.71),('16100','2013-05-08','17:00:00',4.51),('16100','2013-05-08','17:05:00',4.38),('16100','2013-05-08','17:10:00',4.23),('16100','2013-05-08','17:15:00',4.08),('16100','2013-05-08','17:20:00',3.94),('16100','2013-05-08','17:25:00',3.75),('16100','2013-05-08','17:30:00',3.55),('16100','2013-05-08','17:35:00',3.39),('16100','2013-05-08','17:40:00',3.23),('16100','2013-05-08','17:45:00',3.05),('16100','2013-05-08','17:50:00',2.86),('16100','2013-05-08','17:55:00',2.69),('16100','2013-05-08','18:00:00',2.53),('16100','2013-05-08','18:05:00',2.37),('16100','2013-05-08','18:10:00',2.18),('16100','2013-05-08','18:15:00',1.99),('16100','2013-05-08','18:20:00',1.84),('16100','2013-05-08','18:25:00',1.67),('16100','2013-05-08','18:30:00',1.47),('16100','2013-05-08','18:35:00',1.27),('16100','2013-05-08','18:40:00',1.12),('16100','2013-05-07','07:55:00',1.42),('16100','2013-05-07','08:00:00',1.55),('16100','2013-05-07','08:05:00',1.71),('16100','2013-05-07','08:10:00',1.87),('16100','2013-05-07','08:15:00',2.05),('16100','2013-05-07','08:20:00',2.23),('16100','2013-05-07','08:25:00',2.42),('16100','2013-05-07','08:30:00',2.59),('16100','2013-05-07','08:35:00',2.9),('16100','2013-05-07','08:40:00',3.48),('16100','2013-05-07','08:45:00',3.82),('16100','2013-05-07','08:50:00',4.11),('16100','2013-05-07','08:55:00',4.54),('16100','2013-05-07','09:00:00',4.85),('16100','2013-05-07','09:05:00',2.89),('16100','2013-05-07','09:10:00',5.24),('16100','2013-05-07','09:15:00',5.43),('16100','2013-05-07','09:20:00',5.66),('16100','2013-05-07','09:25:00',6.08),('16100','2013-05-07','09:30:00',5.75),('16100','2013-05-07','09:35:00',3.18),('16100','2013-05-07','09:55:00',1.21),('16100','2013-05-07','10:00:00',4.47),('16100','2013-05-07','10:05:00',6.04),('16100','2013-05-07','10:10:00',4.93),('16100','2013-05-07','10:15:00',6.33),('16100','2013-05-07','10:20:00',3.39),('16100','2013-05-07','10:25:00',3.25),('16100','2013-05-07','10:30:00',4.89),('16100','2013-05-07','10:35:00',1.9),('16100','2013-05-07','10:40:00',7.06),('16100','2013-05-07','10:45:00',7.16),('16100','2013-05-07','10:50:00',7.44),('16100','2013-05-07','10:55:00',7.56),('16100','2013-05-07','11:00:00',6.57),('16100','2013-05-07','11:05:00',6.95),('16100','2013-05-07','11:10:00',1.93),('16100','2013-05-07','11:15:00',1.93),('16100','2013-05-07','11:20:00',1.9),('16100','2013-05-07','11:25:00',1.83),('16100','2013-05-07','11:30:00',2.58),('16100','2013-05-07','11:35:00',5.79),('16100','2013-05-07','11:40:00',4.67),('16100','2013-05-07','11:45:00',8.74),('16100','2013-05-07','11:50:00',3.87),('16100','2013-05-07','11:55:00',8.36),('16100','2013-05-07','12:00:00',4.69),('16100','2013-05-07','12:05:00',3.63),('16100','2013-05-07','12:10:00',2.6),('16100','2013-05-07','12:15:00',1.33),('16100','2013-05-07','12:20:00',1.45),('16100','2013-05-07','12:25:00',1.82),('16100','2013-05-07','12:30:00',7.21),('16100','2013-05-07','12:35:00',8.95),('16100','2013-05-07','12:40:00',8.99),('16100','2013-05-07','12:45:00',8.84),('16100','2013-05-07','12:50:00',5.78),('16100','2013-05-07','12:55:00',7.49),('16100','2013-05-07','13:00:00',2.66),('16100','2013-05-07','13:05:00',6.12),('16100','2013-05-07','13:10:00',3.42),('16100','2013-05-07','13:15:00',3.5),('16100','2013-05-07','13:20:00',6.91),('16100','2013-05-07','13:25:00',3.18),('16100','2013-05-07','13:30:00',2.6),('16100','2013-05-07','13:35:00',2.78),('16100','2013-05-07','13:40:00',5.68),('16100','2013-05-07','13:45:00',2.47),('16100','2013-05-07','13:50:00',2.63),('16100','2013-05-07','13:55:00',8.68),('16100','2013-05-07','14:00:00',4.31),('16100','2013-05-07','14:05:00',7.14),('16100','2013-05-07','14:10:00',8.71),('16100','2013-05-07','14:15:00',5.04),('16100','2013-05-07','14:20:00',2.61),('16100','2013-05-07','14:25:00',3.02),('16100','2013-05-07','14:30:00',2.95),('16100','2013-05-07','14:35:00',4.61),('16100','2013-05-07','14:40:00',6.17),('16100','2013-05-07','14:45:00',6.44),('16100','2013-05-07','14:50:00',8.68),('16100','2013-05-07','14:55:00',6.41),('16100','2013-05-07','15:00:00',3.76),('16100','2013-05-07','15:05:00',3.64),('16100','2013-05-07','15:10:00',8.08),('16100','2013-05-07','15:15:00',7.25),('16100','2013-05-07','15:20:00',7.72),('16100','2013-05-07','15:25:00',7.14),('16100','2013-05-07','15:30:00',6.58),('16100','2013-05-07','15:35:00',6.89),('16100','2013-05-07','15:40:00',6.85),('16100','2013-05-07','15:45:00',6.75),('16100','2013-05-07','15:50:00',6.56),('16100','2013-05-07','15:55:00',6.42),('16100','2013-05-07','16:00:00',6.28),('16100','2013-05-07','16:05:00',6.12),('16100','2013-05-07','16:10:00',6),('16100','2013-05-07','16:15:00',5.83),('16100','2013-05-07','16:20:00',5.72),('16100','2013-05-07','16:25:00',5.59),('16100','2013-05-07','16:30:00',5.45),('16100','2013-05-07','16:35:00',5.32),('16100','2013-05-07','16:40:00',5.29),('16100','2013-05-07','16:45:00',4.93),('16100','2013-05-07','16:50:00',4.59),('16100','2013-05-07','16:55:00',4.35),('16100','2013-05-07','17:00:00',3.87),('16100','2013-05-07','17:05:00',4.15),('16100','2013-05-07','17:10:00',3.47),('16100','2013-05-07','17:15:00',2.85),('16100','2013-05-07','17:20:00',1.16),('16100','2013-05-07','17:25:00',3.15),('16100','2013-05-07','17:30:00',3.86),('16100','2013-05-07','17:35:00',3.86),('16100','2013-05-07','17:40:00',3.91),('16100','2013-05-07','17:45:00',3.87),('16100','2013-05-07','17:50:00',3.76),('16100','2013-05-07','17:55:00',3.62),('16100','2013-05-07','18:00:00',3.38),('16100','2013-05-07','18:05:00',3.24),('16100','2013-05-07','18:10:00',2.92),('16100','2013-05-07','18:15:00',2.58),('16100','2013-05-07','18:20:00',2.28),('16100','2013-05-07','18:25:00',1.97),('16100','2013-05-07','18:30:00',1.42),('16100','2013-05-06','07:45:00',1.04),('16100','2013-05-06','07:50:00',1.21),('16100','2013-05-06','07:55:00',1.36),('16100','2013-05-06','08:00:00',1.52),('16100','2013-05-06','08:05:00',1.68),('16100','2013-05-06','08:10:00',1.85),('16100','2013-05-06','08:15:00',2.06),('16100','2013-05-06','08:20:00',2.27),('16100','2013-05-06','08:25:00',2.45),('16100','2013-05-06','08:30:00',2.63),('16100','2013-05-06','08:35:00',2.94),('16100','2013-05-06','08:40:00',3.3),('16100','2013-05-06','08:45:00',3.68),('16100','2013-05-06','08:50:00',4.03),('16100','2013-05-06','08:55:00',4.01),('16100','2013-05-06','09:00:00',4.65),('16100','2013-05-06','09:05:00',4.82),('16100','2013-05-06','09:10:00',3.19),('16100','2013-05-06','09:15:00',3.38),('16100','2013-05-06','09:20:00',5.01),('16100','2013-05-06','09:25:00',5.91),('16100','2013-05-06','09:30:00',1.83),('16100','2013-05-06','09:35:00',1.31),('16100','2013-05-06','09:40:00',1.04),('16100','2013-05-06','10:25:00',1.25),('16100','2013-05-06','10:30:00',2.9),('16100','2013-05-06','10:35:00',8.1),('16100','2013-05-06','10:40:00',7.06),('16100','2013-05-06','10:45:00',2.53),('16100','2013-05-06','10:50:00',1.89),('16100','2013-05-06','10:55:00',1.51),('16100','2013-05-06','11:00:00',1.36),('16100','2013-05-06','11:05:00',1.42),('16100','2013-05-06','11:10:00',2.23),('16100','2013-05-06','11:15:00',7.2),('16100','2013-05-06','11:20:00',8.72),('16100','2013-05-06','11:25:00',8.37),('16100','2013-05-06','11:30:00',8.33),('16100','2013-05-06','11:35:00',6.13),('16100','2013-05-06','11:40:00',6.23),('16100','2013-05-06','11:45:00',9.18),('16100','2013-05-06','11:50:00',5.78),('16100','2013-05-06','11:55:00',3.44),('16100','2013-05-06','12:00:00',2.49),('16100','2013-05-06','12:05:00',2.3),('16100','2013-05-06','12:10:00',2.27),('16100','2013-05-06','12:15:00',3.41),('16100','2013-05-06','12:20:00',1.97),('16100','2013-05-06','12:25:00',1.85),('16100','2013-05-06','12:30:00',1.34),('16100','2013-05-06','12:35:00',1.36),('16100','2013-05-06','12:40:00',1.56),('16100','2013-05-06','12:45:00',1.99),('16100','2013-05-06','12:50:00',2.82),('16100','2013-05-06','12:55:00',2.71),('16100','2013-05-06','13:00:00',2.97),('16100','2013-05-06','13:05:00',2.95),('16100','2013-05-06','13:10:00',3.3),('16100','2013-05-06','13:15:00',4.5),('16100','2013-05-06','13:20:00',9.19),('16100','2013-05-06','13:25:00',9.64),('16100','2013-05-06','13:30:00',9.25),('16100','2013-05-06','13:35:00',8.62),('16100','2013-05-06','13:40:00',8.58),('16100','2013-05-06','13:45:00',8.75),('16100','2013-05-06','13:50:00',7.57),('16100','2013-05-06','13:55:00',7.21),('16100','2013-05-06','14:00:00',6.63),('16100','2013-05-06','14:05:00',7.16),('16100','2013-05-06','14:10:00',8.25),('16100','2013-05-06','14:15:00',8.81),('16100','2013-05-06','14:20:00',3.9),('16100','2013-05-06','14:25:00',7.59),('16100','2013-05-06','14:30:00',8.5),('16100','2013-05-06','14:35:00',8.44),('16100','2013-05-06','14:40:00',8.5),('16100','2013-05-06','14:45:00',7.82),('16100','2013-05-06','14:50:00',8.18),('16100','2013-05-06','14:55:00',7.89),('16100','2013-05-06','15:00:00',7.78),('16100','2013-05-06','15:05:00',6.26),('16100','2013-05-06','15:10:00',7.54),('16100','2013-05-06','15:15:00',4.63),('16100','2013-05-06','15:20:00',6.14),('16100','2013-05-06','15:25:00',5.06),('16100','2013-05-06','15:30:00',7.44),('16100','2013-05-06','15:35:00',4.36),('16100','2013-05-06','15:40:00',7.34),('16100','2013-05-06','15:45:00',7.78),('16100','2013-05-06','15:50:00',4.65),('16100','2013-05-06','15:55:00',4.5),('16100','2013-05-06','16:00:00',7.23),('16100','2013-05-06','16:05:00',6.98),('16100','2013-05-06','16:10:00',5.39),('16100','2013-05-06','16:15:00',6.48),('16100','2013-05-06','16:20:00',6.86),('16100','2013-05-06','16:25:00',6.81),('16100','2013-05-06','16:30:00',6.7),('16100','2013-05-06','16:35:00',5.52),('16100','2013-05-06','16:40:00',3.45),('16100','2013-05-06','16:45:00',2.11),('16100','2013-05-06','16:50:00',2.89),('16100','2013-05-06','16:55:00',3.35),('16100','2013-05-06','17:00:00',3.41),('16100','2013-05-06','17:05:00',3.49),('16100','2013-05-06','17:10:00',1.91),('16100','2013-05-06','17:15:00',1.95),('16100','2013-05-06','17:20:00',1.92),('16100','2013-05-06','17:25:00',2.3),('16100','2013-05-06','17:30:00',1.87),('16100','2013-05-06','17:35:00',1.58),('16100','2013-05-06','17:40:00',1.3),('16100','2013-05-05','08:15:00',1.12),('16100','2013-05-05','08:20:00',1.98),('16100','2013-05-05','08:25:00',2.51),('16100','2013-05-05','08:30:00',1.64),('16100','2013-05-05','08:35:00',1.64),('16100','2013-05-05','08:40:00',2.39),('16100','2013-05-05','08:45:00',2.48),('16100','2013-05-05','08:50:00',2.49),('16100','2013-05-05','08:55:00',2.35),('16100','2013-05-05','09:00:00',2.49),('16100','2013-05-05','09:05:00',2.19),('16100','2013-05-05','09:10:00',2.26),('16100','2013-05-05','09:15:00',3.11),('16100','2013-05-05','09:20:00',3.15),('16100','2013-05-05','09:25:00',3.62),('16100','2013-05-05','09:30:00',2.72),('16100','2013-05-05','09:45:00',1.53),('16100','2013-05-05','09:50:00',1.06),('16100','2013-05-05','09:55:00',1.09),('16100','2013-05-05','10:00:00',1.64),('16100','2013-05-05','10:05:00',1.8),('16100','2013-05-05','10:10:00',1.8),('16100','2013-05-05','10:15:00',2.56),('16100','2013-05-05','10:20:00',2.74),('16100','2013-05-05','10:25:00',2.67),('16100','2013-05-05','10:30:00',2.32),('16100','2013-05-05','10:35:00',2.44),('16100','2013-05-05','10:40:00',3.83),('16100','2013-05-05','10:45:00',2.69),('16100','2013-05-05','10:50:00',2.26),('16100','2013-05-05','10:55:00',3.36),('16100','2013-05-05','11:00:00',2.92),('16100','2013-05-05','11:05:00',2.09),('16100','2013-05-05','11:10:00',1.71),('16100','2013-05-05','11:15:00',2.7),('16100','2013-05-05','11:20:00',3.22),('16100','2013-05-05','11:25:00',1.43),('16100','2013-05-05','11:30:00',1.91),('16100','2013-05-05','11:35:00',4.36),('16100','2013-05-05','11:40:00',3.48),('16100','2013-05-05','11:45:00',3.48),('16100','2013-05-05','11:50:00',2.53),('16100','2013-05-05','11:55:00',2.07),('16100','2013-05-05','12:00:00',2.58),('16100','2013-05-05','12:05:00',2.91),('16100','2013-05-05','12:10:00',2.75),('16100','2013-05-05','12:15:00',8.25),('16100','2013-05-05','12:20:00',9.54),('16100','2013-05-05','12:25:00',9.17),('16100','2013-05-05','12:30:00',6.75),('16100','2013-05-05','12:35:00',4.63),('16100','2013-05-05','12:40:00',4.29),('16100','2013-05-05','12:45:00',5.6),('16100','2013-05-05','12:50:00',6.2),('16100','2013-05-05','12:55:00',5.4),('16100','2013-05-05','13:00:00',7.14),('16100','2013-05-05','13:05:00',8.49),('16100','2013-05-05','13:10:00',4.46),('16100','2013-05-05','13:15:00',7.09),('16100','2013-05-05','13:20:00',6.92),('16100','2013-05-05','13:25:00',5.85),('16100','2013-05-05','13:30:00',3.72),('16100','2013-05-05','13:35:00',3.26),('16100','2013-05-05','13:40:00',7.6),('16100','2013-05-05','13:49:00',4.83),('16100','2013-05-05','13:50:00',8.87),('16100','2013-05-05','13:55:00',4.75),('16100','2013-05-05','14:00:00',3.23),('16100','2013-05-05','14:05:00',4.5),('16100','2013-05-05','14:10:00',7.61),('16100','2013-05-05','14:15:00',2.96),('16100','2013-05-05','14:20:00',3.28),('16100','2013-05-05','14:25:00',3.39),('16100','2013-05-05','14:30:00',5.22),('16100','2013-05-05','14:35:00',3.27),('16100','2013-05-05','14:40:00',3.39),('16100','2013-05-05','14:45:00',2.59),('16100','2013-05-05','14:50:00',2.12),('16100','2013-05-05','14:55:00',2.3),('16100','2013-05-05','15:00:00',3.43),('16100','2013-05-05','15:05:00',3.4),('16100','2013-05-05','15:10:00',2.73),('16100','2013-05-05','15:15:00',2.57),('16100','2013-05-05','15:20:00',4.45),('16100','2013-05-05','15:25:00',5.52),('16100','2013-05-05','15:30:00',3),('16100','2013-05-05','15:35:00',3.92),('16100','2013-05-05','15:40:00',5.3),('16100','2013-05-05','15:45:00',3),('16100','2013-05-05','15:50:00',3.43),('16100','2013-05-05','15:55:00',2.05),('16100','2013-05-05','16:00:00',3.51),('16100','2013-05-05','16:05:00',2.57),('16100','2013-05-05','16:10:00',1.98),('16100','2013-05-05','16:15:00',2),('16100','2013-05-05','16:20:00',2.87),('16100','2013-05-05','16:25:00',5.31),('16100','2013-05-05','16:30:00',5.37),('16100','2013-05-05','16:35:00',3.29),('16100','2013-05-05','16:40:00',3.8),('16100','2013-05-05','16:45:00',2.84),('16100','2013-05-05','16:50:00',3.77),('16100','2013-05-05','16:55:00',1.89),('16100','2013-05-05','17:10:00',4.03),('16100','2013-05-05','17:15:00',4.13),('16100','2013-05-05','17:20:00',2.81),('16100','2013-05-05','17:25:00',2.42),('16100','2013-05-05','17:30:00',1.97),('16100','2013-05-05','17:35:00',2.26),('16100','2013-05-05','17:40:00',3.32),('16100','2013-05-05','17:45:00',3.45),('16100','2013-05-05','17:50:00',2.4),('16100','2013-05-05','17:55:00',3.25),('16100','2013-05-05','18:00:00',3.02),('16100','2013-05-05','18:05:00',2.64),('16100','2013-05-05','18:10:00',1.68),('16100','2013-05-05','18:15:00',1.83),('16100','2013-05-05','18:20:00',2.36),('16100','2013-05-05','18:25:00',1.42),('16100','2014-03-29','08:10:00',1),('16100','2014-03-29','08:15:00',1.07),('16100','2014-03-29','08:20:00',1.27),('16100','2014-03-29','08:25:00',1.48),('16100','2014-03-29','08:30:00',1.71),('16100','2014-03-29','08:35:00',1.89),('16100','2014-03-29','08:40:00',1.98),('16100','2014-03-29','08:45:00',2.03),('16100','2014-03-29','08:50:00',2.09),('16100','2014-03-29','08:55:00',2.13),('16100','2014-03-29','09:00:00',2.15),('16100','2014-03-29','09:05:00',2.3),('16100','2014-03-29','09:10:00',2.42),('16100','2014-03-29','09:15:00',2.5),('16100','2014-03-29','09:20:00',2.84),('16100','2014-03-29','09:25:00',3.13),('16100','2014-03-29','09:30:00',3.16),('16100','2014-03-29','09:35:00',3.41),('16100','2014-03-29','09:40:00',3.59),('16100','2014-03-29','09:45:00',3.74),('16100','2014-03-29','09:50:00',3.92),('16100','2014-03-29','09:55:00',4.02),('16100','2014-03-29','10:00:00',4.03),('16100','2014-03-29','10:05:00',4.19),('16100','2014-03-29','10:10:00',4.53),('16100','2014-03-29','10:15:00',4.64),('16100','2014-03-29','10:20:00',4.84),('16100','2014-03-29','10:25:00',5.19),('16100','2014-03-29','10:30:00',5.33),('16100','2014-03-29','10:35:00',5.44),('16100','2014-03-29','10:40:00',5.44),('16100','2014-03-29','10:45:00',5.5),('16100','2014-03-29','10:50:00',5.75),('16100','2014-03-29','10:55:00',5.77),('16100','2014-03-29','11:00:00',5.66),('16100','2014-03-29','11:05:00',5.71),('16100','2014-03-29','11:10:00',5.84),('16100','2014-03-29','11:15:00',5.95),('16100','2014-03-29','11:20:00',5.93),('16100','2014-03-29','11:25:00',5.6),('16100','2014-03-29','11:30:00',5.72),('16100','2014-03-29','11:35:00',6.09),('16100','2014-03-29','11:40:00',6.26),('16100','2014-03-29','11:45:00',6.5),('16100','2014-03-29','11:50:00',6.5),('16100','2014-03-29','11:55:00',6.8),('16100','2014-03-29','12:00:00',6.69),('16100','2014-03-29','12:05:00',6.9),('16100','2014-03-29','12:10:00',6.97),('16100','2014-03-29','12:15:00',7.04),('16100','2014-03-29','12:20:00',7.19),('16100','2014-03-29','12:25:00',7.28),('16100','2014-03-29','12:30:00',7.02),('16100','2014-03-29','12:35:00',7.25),('16100','2014-03-29','12:40:00',7.3),('16100','2014-03-29','12:45:00',7.36),('16100','2014-03-29','12:50:00',7.41),('16100','2014-03-29','12:55:00',7.31),('16100','2014-03-29','13:00:00',7.27),('16100','2014-03-29','13:05:00',7.36),('16100','2014-03-29','13:10:00',7.4),('16100','2014-03-29','13:15:00',7.4),('16100','2014-03-29','13:20:00',7.47),('16100','2014-03-29','13:25:00',7.64),('16100','2014-03-29','13:30:00',7.68),('16100','2014-03-29','13:35:00',7.62),('16100','2014-03-29','13:40:00',7.66),('16100','2014-03-29','13:45:00',7.71),('16100','2014-03-29','13:50:00',7.7),('16100','2014-03-29','13:55:00',7.67),('16100','2014-03-29','14:00:00',7.56),('16100','2014-03-29','14:05:00',7.57),('16100','2014-03-29','14:10:00',7.31),('16100','2014-03-29','14:15:00',6.79),('16100','2014-03-29','14:20:00',6.29),('16100','2014-03-29','14:25:00',6.31),('16100','2014-03-29','14:30:00',6.3),('16100','2014-03-29','14:35:00',5.81),('16100','2014-03-29','14:40:00',3.89),('16100','2014-03-29','14:45:00',2.6),('16100','2014-03-29','14:50:00',2.38),('16100','2014-03-29','14:55:00',2.89),('16100','2014-03-29','15:00:00',3.49),('16100','2014-03-29','15:05:00',4.32),('16100','2014-03-29','15:10:00',4.93),('16100','2014-03-29','15:15:00',5.45),('16100','2014-03-29','15:20:00',5.34),('16100','2014-03-29','15:25:00',5.41),('16100','2014-03-29','15:30:00',5.58),('16100','2014-03-29','15:35:00',5.5),('16100','2014-03-29','15:40:00',5.4),('16100','2014-03-29','15:45:00',5.44),('16100','2014-03-29','15:50:00',4.98),('16100','2014-03-29','15:55:00',5.14),('16100','2014-03-29','16:00:00',5.37),('16100','2014-03-29','16:05:00',5.47),('16100','2014-03-29','16:10:00',5.46),('16100','2014-03-29','16:15:00',5.22),('16100','2014-03-29','16:20:00',4.73),('16100','2014-03-29','16:25:00',5.1),('16100','2014-03-29','16:30:00',4.72),('16100','2014-03-29','16:35:00',3.99),('16100','2014-03-29','16:40:00',4.28),('16100','2014-03-29','16:45:00',3.91),('16100','2014-03-29','16:50:00',3.9),('16100','2014-03-29','16:55:00',3.34),('16100','2014-03-29','17:00:00',3.1),('16100','2014-03-29','17:05:00',3.2),('16100','2014-03-29','17:10:00',3.04),('16100','2014-03-29','17:15:00',2.85),('16100','2014-03-29','17:20:00',2.89),('16100','2014-03-29','17:25:00',2.93),('16100','2014-03-29','17:30:00',2.8),('16100','2014-03-29','17:35:00',2.62),('16100','2014-03-29','17:40:00',2.5),('16100','2014-03-29','17:45:00',2.52),('16100','2014-03-29','17:50:00',2.29),('16100','2014-03-29','17:55:00',2.05),('16100','2014-03-29','18:00:00',1.89),('16100','2014-03-29','18:05:00',1.56),('16100','2014-03-29','18:10:00',1.34),('16100','2014-03-29','18:15:00',1.49),('16100','2014-03-29','18:20:00',1.23),('16100','2014-03-29','18:25:00',1.15),('16100','2014-03-28','07:15:00',1),('16100','2014-03-28','07:20:00',1.18),('16100','2014-03-28','07:25:00',1.36),('16100','2014-03-28','07:30:00',1.55),('16100','2014-03-28','07:35:00',1.78),('16100','2014-03-28','07:40:00',2),('16100','2014-03-28','07:45:00',2.2),('16100','2014-03-28','07:50:00',2.37),('16100','2014-03-28','07:55:00',2.52),('16100','2014-03-28','08:00:00',2.66),('16100','2014-03-28','08:05:00',2.89),('16100','2014-03-28','08:10:00',3.07),('16100','2014-03-28','08:15:00',3.27),('16100','2014-03-28','08:20:00',3.45),('16100','2014-03-28','08:25:00',3.68),('16100','2014-03-28','08:30:00',3.83),('16100','2014-03-28','08:35:00',3.93),('16100','2014-03-28','08:40:00',4.05),('16100','2014-03-28','08:45:00',4.17),('16100','2014-03-28','08:50:00',4.32),('16100','2014-03-28','08:55:00',4.49),('16100','2014-03-28','09:00:00',4.65),('16100','2014-03-28','09:05:00',4.74),('16100','2014-03-28','09:10:00',4.86),('16100','2014-03-28','09:15:00',4.98),('16100','2014-03-28','09:20:00',5.13),('16100','2014-03-28','09:25:00',5.23),('16100','2014-03-28','09:30:00',5.34),('16100','2014-03-28','09:35:00',5.56),('16100','2014-03-28','09:40:00',5.7),('16100','2014-03-28','09:45:00',5.76),('16100','2014-03-28','09:50:00',5.9),('16100','2014-03-28','09:55:00',6),('16100','2014-03-28','10:00:00',6.08),('16100','2014-03-28','10:05:00',6.09),('16100','2014-03-28','10:10:00',6.14),('16100','2014-03-28','10:15:00',6.22),('16100','2014-03-28','10:20:00',6.4),('16100','2014-03-28','10:25:00',6.55),('16100','2014-03-28','10:30:00',6.68),('16100','2014-03-28','10:35:00',6.73),('16100','2014-03-28','10:40:00',6.83),('16100','2014-03-28','10:45:00',6.87),('16100','2014-03-28','10:50:00',6.94),('16100','2014-03-28','10:55:00',7.03),('16100','2014-03-28','11:00:00',7.11),('16100','2014-03-28','11:05:00',7.2),('16100','2014-03-28','11:10:00',7.2),('16100','2014-03-28','11:15:00',7.14),('16100','2014-03-28','11:20:00',7.14),('16100','2014-03-28','11:25:00',7.18),('16100','2014-03-28','11:30:00',7.16),('16100','2014-03-28','11:35:00',7.08),('16100','2014-03-28','11:40:00',7.31),('16100','2014-03-28','11:45:00',7.38),('16100','2014-03-28','11:50:00',7.36),('16100','2014-03-28','11:55:00',7.34),('16100','2014-03-28','12:00:00',7.31),('16100','2014-03-28','12:05:00',7.28),('16100','2014-03-28','12:10:00',7.32),('16100','2014-03-28','12:15:00',7.4),('16100','2014-03-28','12:20:00',7.47),('16100','2014-03-28','12:25:00',7.46),('16100','2014-03-28','12:30:00',7.55),('16100','2014-03-28','12:35:00',7.48),('16100','2014-03-28','12:40:00',7.29),('16100','2014-03-28','12:45:00',7.22),('16100','2014-03-28','12:50:00',7.24),('16100','2014-03-28','12:55:00',4.68),('16100','2014-03-28','13:00:00',7.41),('16100','2014-03-28','13:05:00',7.35),('16100','2014-03-28','13:10:00',6.12),('16100','2014-03-28','13:15:00',3.15),('16100','2014-03-28','13:20:00',5.71),('16100','2014-03-28','13:25:00',6.94),('16100','2014-03-28','13:30:00',7.19),('16100','2014-03-28','13:35:00',7.15),('16100','2014-03-28','13:40:00',6.95),('16100','2014-03-28','13:45:00',6.77),('16100','2014-03-28','13:50:00',6.68),('16100','2014-03-28','13:55:00',6.62),('16100','2014-03-28','14:00:00',6.5),('16100','2014-03-28','14:05:00',6.24),('16100','2014-03-28','14:10:00',6.29),('16100','2014-03-28','14:15:00',6.04),('16100','2014-03-28','14:20:00',5.99),('16100','2014-03-28','14:25:00',6.01),('16100','2014-03-28','14:30:00',6.14),('16100','2014-03-28','14:35:00',6.03),('16100','2014-03-28','14:40:00',5.59),('16100','2014-03-28','14:45:00',5.49),('16100','2014-03-28','14:50:00',5.36),('16100','2014-03-28','14:55:00',5.47),('16100','2014-03-28','15:00:00',5.4),('16100','2014-03-28','15:05:00',5.24),('16100','2014-03-28','15:10:00',4.96),('16100','2014-03-28','15:15:00',4.91),('16100','2014-03-28','15:20:00',4.79),('16100','2014-03-28','15:25:00',4.66),('16100','2014-03-28','15:30:00',4.54),('16100','2014-03-28','15:35:00',4.4),('16100','2014-03-28','15:40:00',4.29),('16100','2014-03-28','15:45:00',4.11),('16100','2014-03-28','15:50:00',3.98),('16100','2014-03-28','15:55:00',3.82),('16100','2014-03-28','16:00:00',3.64),('16100','2014-03-28','16:05:00',3.46),('16100','2014-03-28','16:10:00',3.27),('16100','2014-03-28','16:15:00',3.07),('16100','2014-03-28','16:20:00',2.83),('16100','2014-03-28','16:25:00',2.83),('16100','2014-03-28','16:30:00',2.65),('16100','2014-03-28','16:35:00',2.26),('16100','2014-03-28','16:40:00',1.69),('16100','2014-03-28','16:45:00',1.84),('16100','2014-03-28','16:50:00',1.91),('16100','2014-03-28','16:55:00',1.79),('16100','2014-03-28','17:00:00',1.62),('16100','2014-03-28','17:05:00',1.46),('16100','2014-03-28','17:10:00',1.32),('16100','2014-03-28','17:15:00',1.18),('16100','2013-04-20','08:05:00',1.14),('16100','2013-04-20','08:10:00',1.14),('16100','2013-04-20','08:15:00',1.34),('16100','2013-04-20','08:20:00',1.41),('16100','2013-04-20','08:25:00',1.43),('16100','2013-04-20','08:30:00',1.39),('16100','2013-04-20','08:35:00',1.47),('16100','2013-04-20','08:40:00',1.6),('16100','2013-04-20','08:45:00',1.78),('16100','2013-04-20','08:50:00',1.87),('16100','2013-04-20','08:55:00',1.8),('16100','2013-04-20','09:00:00',1.89),('16100','2013-04-20','09:05:00',1.94),('16100','2013-04-20','09:10:00',2.04),('16100','2013-04-20','09:15:00',2.09),('16100','2013-04-20','09:20:00',2.21),('16100','2013-04-20','09:25:00',3),('16100','2013-04-20','09:30:00',4.44),('16100','2013-04-20','09:35:00',4.04),('16100','2013-04-20','09:40:00',5.76),('16100','2013-04-20','09:45:00',5.11),('16100','2013-04-20','09:50:00',3.65),('16100','2013-04-20','09:55:00',2.62),('16100','2013-04-20','10:00:00',2.29),('16100','2013-04-20','10:05:00',1.76),('16100','2013-04-20','10:10:00',2.27),('16100','2013-04-20','10:15:00',5.77),('16100','2013-04-20','10:20:00',3.92),('16100','2013-04-20','10:25:00',6.21),('16100','2013-04-20','10:30:00',6.95),('16100','2013-04-20','10:35:00',6.7),('16100','2013-04-20','10:40:00',6.57),('16100','2013-04-20','10:45:00',6.7),('16100','2013-04-20','10:50:00',6.95),('16100','2013-04-20','10:55:00',7.1),('16100','2013-04-20','11:00:00',4.92),('16100','2013-04-20','11:05:00',5.63),('16100','2013-04-20','11:10:00',7.45),('16100','2013-04-20','11:15:00',6.96),('16100','2013-04-20','11:20:00',5.91),('16100','2013-04-20','11:25:00',5.46),('16100','2013-04-20','11:30:00',4.14),('16100','2013-04-20','11:35:00',5.18),('16100','2013-04-20','11:40:00',5.05),('16100','2013-04-20','11:45:00',4.93),('16100','2013-04-20','11:50:00',5.12),('16100','2013-04-20','11:55:00',4.63),('16100','2013-04-20','12:00:00',4.37),('16100','2013-04-20','12:05:00',4.18),('16100','2013-04-20','12:10:00',4.23),('16100','2013-04-20','12:15:00',3.73),('16100','2013-04-20','12:20:00',3.23),('16100','2013-04-20','12:25:00',3.42),('16100','2013-04-20','12:30:00',3.62),('16100','2013-04-20','12:35:00',3.65),('16100','2013-04-20','12:40:00',4.05),('16100','2013-04-20','12:45:00',3.69),('16100','2013-04-20','12:50:00',3.64),('16100','2013-04-20','12:55:00',3.77),('16100','2013-04-20','13:00:00',3.89),('16100','2013-04-20','13:05:00',4.85),('16100','2013-04-20','13:10:00',5.11),('16100','2013-04-20','13:15:00',4.46),('16100','2013-04-20','13:20:00',4.31),('16100','2013-04-20','13:25:00',4.38),('16100','2013-04-20','13:30:00',4.7),('16100','2013-04-20','13:35:00',5.74),('16100','2013-04-20','13:40:00',7.09),('16100','2013-04-20','13:45:00',7.34),('16100','2013-04-20','13:50:00',6.55),('16100','2013-04-20','13:55:00',6.33),('16100','2013-04-20','14:00:00',4.66),('16100','2013-04-20','14:05:00',4.69),('16100','2013-04-20','14:10:00',5.62),('16100','2013-04-20','14:15:00',4.1),('16100','2013-04-20','14:20:00',4.75),('16100','2013-04-20','14:25:00',5.26),('16100','2013-04-20','14:30:00',8.29),('16100','2013-04-20','14:35:00',8.57),('16100','2013-04-20','14:40:00',8.49),('16100','2013-04-20','14:45:00',7.2),('16100','2013-04-20','14:50:00',5.6),('16100','2013-04-20','14:55:00',5.16),('16100','2013-04-20','15:00:00',7.17),('16100','2013-04-20','15:05:00',7.47),('16100','2013-04-20','15:10:00',7),('16100','2013-04-20','15:15:00',7.54),('16100','2013-04-20','15:20:00',5.79),('16100','2013-04-20','15:25:00',5.41),('16100','2013-04-20','15:30:00',4.51),('16100','2013-04-20','15:35:00',4.09),('16100','2013-04-20','15:40:00',4.35),('16100','2013-04-20','15:45:00',2.34),('16100','2013-04-20','15:50:00',1.85),('16100','2013-04-20','15:55:00',1.32),('16100','2013-04-20','16:00:00',1.17),('16100','2013-04-20','16:05:00',1.05),('16100','2013-04-20','16:10:00',1.07),('16100','2013-04-19','07:30:00',1.06),('16100','2013-04-19','07:35:00',1.02),('16100','2013-04-19','08:05:00',1.38),('16100','2013-04-19','08:10:00',1.34),('16100','2013-04-19','08:15:00',1.25),('16100','2013-04-19','08:20:00',1.75),('16100','2013-04-19','08:25:00',2.03),('16100','2013-04-19','08:30:00',2.31),('16100','2013-04-19','08:35:00',2.04),('16100','2013-04-19','08:40:00',2.88),('16100','2013-04-19','08:45:00',3.1),('16100','2013-04-19','08:50:00',3.34),('16100','2013-04-19','08:55:00',3.46),('16100','2013-04-19','09:00:00',3.6),('16100','2013-04-19','09:05:00',3.67),('16100','2013-04-19','09:10:00',2.07),('16100','2013-04-19','09:15:00',1.35),('16100','2013-04-19','09:20:00',1.26),('16100','2013-04-19','09:25:00',1.25),('16100','2013-04-19','09:30:00',1.22),('16100','2013-04-19','10:15:00',1.12),('16100','2013-04-19','10:20:00',1.27),('16100','2013-04-19','10:25:00',1.31),('16100','2013-04-19','10:30:00',1.66),('16100','2013-04-19','10:35:00',1.96),('16100','2013-04-19','10:40:00',2.01),('16100','2013-04-19','10:45:00',2.49),('16100','2013-04-19','10:50:00',4.94),('16100','2013-04-19','10:55:00',7.16),('16100','2013-04-19','11:00:00',5.7),('16100','2013-04-19','11:05:00',6.22),('16100','2013-04-19','11:10:00',5.56),('16100','2013-04-19','11:15:00',3.41),('16100','2013-04-19','11:20:00',2.78),('16100','2013-04-19','11:25:00',2.8),('16100','2013-04-19','11:30:00',3.68),('16100','2013-04-19','11:35:00',5.7),('16100','2013-04-19','11:40:00',8.21),('16100','2013-04-19','11:45:00',4.72),('16100','2013-04-19','11:50:00',8.98),('16100','2013-04-19','11:55:00',3.75),('16100','2013-04-19','12:00:00',2.93),('16100','2013-04-19','12:05:00',3.44),('16100','2013-04-19','12:10:00',4.31),('16100','2013-04-19','12:15:00',4.45),('16100','2013-04-19','12:20:00',8.82),('16100','2013-04-19','12:25:00',8.86),('16100','2013-04-19','12:30:00',7.08),('16100','2013-04-19','12:35:00',7.62),('16100','2013-04-19','12:40:00',8.7),('16100','2013-04-19','12:45:00',8.74),('16100','2013-04-19','12:50:00',8.32),('16100','2013-04-19','12:55:00',8.26),('16100','2013-04-19','13:00:00',8.09),('16100','2013-04-19','13:05:00',4.76),('16100','2013-04-19','13:10:00',8.44),('16100','2013-04-19','13:15:00',8.39),('16100','2013-04-19','13:20:00',8.81),('16100','2013-04-19','13:25:00',8.45),('16100','2013-04-19','13:30:00',8.56),('16100','2013-04-19','13:35:00',8.55),('16100','2013-04-19','13:40:00',3.19),('16100','2013-04-19','13:45:00',8.37),('16100','2013-04-19','13:50:00',6.99),('16100','2013-04-19','13:55:00',5.48),('16100','2013-04-19','14:00:00',7.15),('16100','2013-04-19','14:05:00',8.19),('16100','2013-04-19','14:10:00',7.49),('16100','2013-04-19','14:15:00',7.63),('16100','2013-04-19','14:20:00',6.89),('16100','2013-04-19','14:25:00',5.92),('16100','2013-04-19','14:30:00',7.29),('16100','2013-04-19','14:35:00',7.02),('16100','2013-04-19','14:40:00',7.02),('16100','2013-04-19','14:45:00',7.31),('16100','2013-04-19','14:50:00',7.28),('16100','2013-04-19','14:55:00',7.28),('16100','2013-04-19','15:00:00',7.29),('16100','2013-04-19','15:05:00',7.12),('16100','2013-04-19','15:10:00',7.22),('16100','2013-04-19','15:15:00',5.1),('16100','2013-04-19','15:20:00',3.82),('16100','2013-04-19','15:25:00',5.69),('16100','2013-04-19','15:30:00',3.29),('16100','2013-04-19','15:35:00',1.97),('16100','2013-04-19','15:40:00',1.44),('16100','2013-04-19','15:45:00',1.29),('16100','2013-04-19','15:50:00',1.22),('16100','2013-04-19','15:55:00',1.35),('16100','2013-04-19','16:00:00',1.74),('16100','2013-04-19','16:05:00',2.72),('16100','2013-04-19','16:10:00',4.92),('16100','2013-04-19','16:15:00',6.32),('16100','2013-04-19','16:20:00',5.55),('16100','2013-04-19','16:25:00',5.19),('16100','2013-04-19','16:30:00',6.04),('16100','2013-04-19','16:35:00',5.73),('16100','2013-04-19','16:40:00',5.46),('16100','2013-04-19','16:45:00',5.08),('16100','2013-04-19','16:50:00',4.77),('16100','2013-04-19','16:55:00',3.93),('16100','2013-04-19','17:00:00',4.4),('16100','2013-04-19','17:05:00',4.13),('16100','2013-04-19','17:10:00',3.91),('16100','2013-04-19','17:15:00',3.17),('16100','2013-04-19','17:20:00',2.61),('16100','2013-04-19','17:25:00',3.67),('16100','2013-04-19','17:30:00',3.7),('16100','2013-04-19','17:35:00',3.55),('16100','2013-04-19','17:40:00',1.58),('16100','2013-04-19','17:45:00',1.21),('16100','2013-04-19','17:50:00',2.24),('16100','2013-04-19','17:55:00',2.31),('16100','2013-04-19','18:00:00',1.5),('16100','2013-04-19','18:05:00',2.55),('16100','2013-04-19','18:10:00',2.33),('16100','2013-04-19','18:15:00',1.36),('16100','2013-04-19','18:35:00',1.09),('16100','2013-04-18','08:00:00',1.09),('16100','2013-04-18','08:05:00',1.4),('16100','2013-04-18','08:10:00',1.75),('16100','2013-04-18','08:15:00',1.88),('16100','2013-04-18','08:20:00',2.08),('16100','2013-04-18','08:25:00',1.92),('16100','2013-04-18','08:30:00',2.41),('16100','2013-04-18','08:35:00',2.81),('16100','2013-04-18','08:40:00',3.02),('16100','2013-04-18','08:45:00',1.64),('16100','2013-04-18','08:50:00',2.62),('16100','2013-04-18','08:55:00',2.97),('16100','2013-04-18','09:00:00',2.54),('16100','2013-04-18','09:05:00',3.56),('16100','2013-04-18','09:10:00',3.69),('16100','2013-04-18','09:15:00',3.88),('16100','2013-04-18','09:20:00',4.17),('16100','2013-04-18','09:25:00',4.07),('16100','2013-04-18','09:30:00',4.31),('16100','2013-04-18','09:35:00',4.49),('16100','2013-04-18','09:40:00',3.77),('16100','2013-04-18','09:45:00',4.71),('16100','2013-04-18','09:50:00',4.8),('16100','2013-04-18','09:55:00',4.91),('16100','2013-04-18','10:00:00',5.1),('16100','2013-04-18','10:05:00',5.2),('16100','2013-04-18','10:10:00',5.35),('16100','2013-04-18','10:15:00',5.5),('16100','2013-04-18','10:20:00',5.61),('16100','2013-04-18','10:25:00',5.73),('16100','2013-04-18','10:30:00',5.94),('16100','2013-04-18','10:35:00',6.02),('16100','2013-04-18','10:40:00',5.71),('16100','2013-04-18','10:45:00',6.09),('16100','2013-04-18','10:50:00',6.13),('16100','2013-04-18','10:55:00',6.28),('16100','2013-04-18','11:00:00',6.39),('16100','2013-04-18','11:05:00',6.45),('16100','2013-04-18','11:10:00',6.66),('16100','2013-04-18','11:15:00',6.69),('16100','2013-04-18','11:20:00',6.69),('16100','2013-04-18','11:25:00',6.72),('16100','2013-04-18','11:30:00',6.78),('16100','2013-04-18','11:35:00',6.71),('16100','2013-04-18','11:40:00',6.83),('16100','2013-04-18','11:45:00',6.88),('16100','2013-04-18','11:50:00',7.07),('16100','2013-04-18','11:55:00',7.14),('16100','2013-04-18','12:00:00',7.2),('16100','2013-04-18','12:05:00',7.28),('16100','2013-04-18','12:10:00',7.34),('16100','2013-04-18','12:15:00',7.36),('16100','2013-04-18','12:20:00',7.38),('16100','2013-04-18','12:25:00',7.39),('16100','2013-04-18','12:30:00',7.37),('16100','2013-04-18','12:35:00',7.33),('16100','2013-04-18','12:40:00',7.32),('16100','2013-04-18','12:45:00',7.5),('16100','2013-04-18','12:50:00',7.72),('16100','2013-04-18','12:55:00',7.58),('16100','2013-04-18','13:00:00',7.65),('16100','2013-04-18','13:05:00',7.67),('16100','2013-04-18','13:10:00',7.66),('16100','2013-04-18','13:15:00',7.73),('16100','2013-04-18','13:20:00',7.66),('16100','2013-04-18','13:25:00',7.66),('16100','2013-04-18','13:30:00',7.68),('16100','2013-04-18','13:35:00',7.64),('16100','2013-04-18','13:40:00',7.62),('16100','2013-04-18','13:45:00',7.55),('16100','2013-04-18','13:50:00',7.56),('16100','2013-04-18','13:55:00',7.49),('16100','2013-04-18','14:00:00',7.55),('16100','2013-04-18','14:05:00',7.44),('16100','2013-04-18','14:10:00',7.33),('16100','2013-04-18','14:15:00',7.35),('16100','2013-04-18','14:20:00',7.28),('16100','2013-04-18','14:25:00',7.24),('16100','2013-04-18','14:30:00',7.2),('16100','2013-04-18','14:35:00',7.16),('16100','2013-04-18','14:40:00',7.18),('16100','2013-04-18','14:45:00',7.14),('16100','2013-04-18','14:50:00',7.03),('16100','2013-04-18','14:55:00',6.94),('16100','2013-04-18','15:00:00',6.9),('16100','2013-04-18','15:05:00',6.82),('16100','2013-04-18','15:10:00',6.71),('16100','2013-04-18','15:15:00',6.62),('16100','2013-04-18','15:20:00',6.49),('16100','2013-04-18','15:25:00',6.42),('16100','2013-04-18','15:30:00',6.38),('16100','2013-04-18','15:35:00',6.29),('16100','2013-04-18','15:40:00',6.19),('16100','2013-04-18','15:45:00',6.07),('16100','2013-04-18','15:50:00',5.99),('16100','2013-04-18','15:55:00',5.86),('16100','2013-04-18','16:00:00',5.73),('16100','2013-04-18','16:05:00',5.62),('16100','2013-04-18','16:10:00',5.41),('16100','2013-04-18','16:15:00',5.28),('16100','2013-04-18','16:20:00',5.13),('16100','2013-04-18','16:25:00',5.02),('16100','2013-04-18','16:30:00',4.89),('16100','2013-04-18','16:35:00',4.74),('16100','2013-04-18','16:40:00',4.54),('16100','2013-04-18','16:45:00',4.41),('16100','2013-04-18','16:50:00',4.22),('16100','2013-04-18','16:55:00',4.05),('16100','2013-04-18','17:00:00',3.92),('16100','2013-04-18','17:05:00',3.72),('16100','2013-04-18','17:10:00',3.58),('16100','2013-04-18','17:15:00',3.46),('16100','2013-04-18','17:20:00',3.28),('16100','2013-04-18','17:25:00',3.08),('16100','2013-04-18','17:30:00',2.89),('16100','2013-04-18','17:35:00',2.74),('16100','2013-04-18','17:40:00',2.55),('16100','2013-04-18','17:45:00',2.38),('16100','2013-04-18','17:50:00',2.22),('16100','2013-04-18','17:55:00',2.09),('16100','2013-04-18','18:00:00',1.92),('16100','2013-04-18','18:05:00',1.79),('16100','2013-04-18','18:10:00',1.63),('16100','2013-04-18','18:15:00',1.49),('16100','2013-04-18','18:20:00',1.33),('16100','2013-04-18','18:25:00',1.18),('16100','2013-04-18','18:30:00',1.04),('16100','2013-04-17','08:00:00',1.09),('16100','2013-04-17','08:05:00',1.21),('16100','2013-04-17','08:10:00',1.5),('16100','2013-04-17','08:15:00',1.65),('16100','2013-04-17','08:20:00',1.71),('16100','2013-04-17','08:25:00',1.76),('16100','2013-04-17','08:30:00',1.8),('16100','2013-04-17','08:35:00',1.92),('16100','2013-04-17','08:40:00',1.88),('16100','2013-04-17','08:45:00',2.08),('16100','2013-04-17','08:50:00',2.29),('16100','2013-04-17','08:55:00',2.58),('16100','2013-04-17','09:00:00',2.52),('16100','2013-04-17','09:05:00',2.41),('16100','2013-04-17','09:10:00',2.66),('16100','2013-04-17','09:15:00',2.97),('16100','2013-04-17','09:20:00',2.97),('16100','2013-04-17','09:25:00',3.18),('16100','2013-04-17','09:30:00',3.14),('16100','2013-04-17','09:35:00',3.28),('16100','2013-04-17','09:40:00',4.4),('16100','2013-04-17','09:45:00',4.46),('16100','2013-04-17','09:50:00',4.54),('16100','2013-04-17','09:55:00',4.79),('16100','2013-04-17','10:00:00',5.06),('16100','2013-04-17','10:05:00',5.01),('16100','2013-04-17','10:10:00',5.06),('16100','2013-04-17','10:15:00',5.16),('16100','2013-04-17','10:20:00',5.57),('16100','2013-04-17','10:25:00',6),('16100','2013-04-17','10:30:00',6.14),('16100','2013-04-17','10:35:00',6.24),('16100','2013-04-17','10:40:00',6.25),('16100','2013-04-17','10:45:00',6.35),('16100','2013-04-17','10:50:00',6.44),('16100','2013-04-17','10:55:00',6.52),('16100','2013-04-17','11:00:00',6.6),('16100','2013-04-17','11:05:00',6.73),('16100','2013-04-17','11:10:00',6.86),('16100','2013-04-17','11:15:00',6.94),('16100','2013-04-17','11:20:00',6.99),('16100','2013-04-17','11:25:00',7.03),('16100','2013-04-17','11:30:00',7.06),('16100','2013-04-17','11:35:00',7.16),('16100','2013-04-17','11:40:00',7.3),('16100','2013-04-17','11:45:00',7.28),('16100','2013-04-17','11:50:00',7.46),('16100','2013-04-17','11:55:00',7.58),('16100','2013-04-17','12:00:00',7.33),('16100','2013-04-17','12:05:00',7.67),('16100','2013-04-17','12:10:00',7.68),('16100','2013-04-17','12:15:00',7.64),('16100','2013-04-17','12:20:00',7.73),('16100','2013-04-17','12:25:00',7.79),('16100','2013-04-17','12:30:00',7.73),('16100','2013-04-17','12:35:00',7.81),('16100','2013-04-17','12:40:00',7.83),('16100','2013-04-17','12:45:00',7.88),('16100','2013-04-17','12:50:00',7.84),('16100','2013-04-17','12:55:00',7.88),('16100','2013-04-17','13:00:00',7.92),('16100','2013-04-17','13:05:00',7.9),('16100','2013-04-17','13:10:00',7.91),('16100','2013-04-17','13:15:00',7.89),('16100','2013-04-17','13:20:00',7.87),('16100','2013-04-17','13:25:00',7.9),('16100','2013-04-17','13:30:00',7.96),('16100','2013-04-17','13:35:00',7.9),('16100','2013-04-17','13:40:00',7.87),('16100','2013-04-17','13:45:00',7.82),('16100','2013-04-17','13:50:00',7.77),('16100','2013-04-17','13:55:00',7.83),('16100','2013-04-17','14:00:00',7.85),('16100','2013-04-17','14:05:00',7.68),('16100','2013-04-17','14:10:00',7.7),('16100','2013-04-17','14:15:00',7.7),('16100','2013-04-17','14:20:00',7.65),('16100','2013-04-17','14:25:00',7.6),('16100','2013-04-17','14:30:00',7.56),('16100','2013-04-17','14:35:00',7.48),('16100','2013-04-17','14:40:00',7.4),('16100','2013-04-17','14:45:00',7.35),('16100','2013-04-17','14:50:00',7.28),('16100','2013-04-17','14:55:00',7.22),('16100','2013-04-17','15:00:00',7.18),('16100','2013-04-17','15:05:00',7.09),('16100','2013-04-17','15:10:00',6.98),('16100','2013-04-17','15:15:00',6.88),('16100','2013-04-17','15:20:00',6.72),('16100','2013-04-17','15:25:00',6.61),('16100','2013-04-17','15:30:00',6.49),('16100','2013-04-17','15:35:00',6.43),('16100','2013-04-17','15:40:00',6.32),('16100','2013-04-17','15:45:00',6.19),('16100','2013-04-17','15:50:00',6.07),('16100','2013-04-17','15:55:00',5.94),('16100','2013-04-17','16:00:00',5.83),('16100','2013-04-17','16:05:00',5.74),('16100','2013-04-17','16:10:00',5.54),('16100','2013-04-17','16:15:00',5.38),('16100','2013-04-17','16:20:00',5.25),('16100','2013-04-17','16:25:00',5.12),('16100','2013-04-17','16:30:00',4.95),('16100','2013-04-17','16:35:00',4.83),('16100','2013-04-17','16:40:00',4.71),('16100','2013-04-17','16:45:00',4.6),('16100','2013-04-17','16:50:00',4.43),('16100','2013-04-17','16:55:00',4.24),('16100','2013-04-17','17:00:00',4.04),('16100','2013-04-17','17:05:00',3.85),('16100','2013-04-17','17:10:00',3.66),('16100','2013-04-17','17:15:00',3.53),('16100','2013-04-17','17:20:00',3.36),('16100','2013-04-17','17:25:00',3.2),('16100','2013-04-17','17:30:00',3.05),('16100','2013-04-17','17:35:00',2.88),('16100','2013-04-17','17:40:00',2.67),('16100','2013-04-17','17:45:00',2.49),('16100','2013-04-17','17:50:00',2.28),('16100','2013-04-17','17:55:00',2.13),('16100','2013-04-17','18:00:00',2.01),('16100','2013-04-17','18:05:00',1.87),('16100','2013-04-17','18:10:00',1.7),('16100','2013-04-17','18:15:00',1.52),('16100','2013-04-17','18:20:00',1.37),('16100','2013-04-17','18:25:00',1.18),('16100','2013-04-17','18:30:00',1.02),('16100','2013-04-16','08:00:00',1.11),('16100','2013-04-16','08:05:00',1.29),('16100','2013-04-16','08:10:00',1.54),('16100','2013-04-16','08:15:00',1.78),('16100','2013-04-16','08:20:00',2.04),('16100','2013-04-16','08:25:00',2.23),('16100','2013-04-16','08:30:00',2.43),('16100','2013-04-16','08:35:00',2.62),('16100','2013-04-16','08:40:00',2.78),('16100','2013-04-16','08:45:00',2.96),('16100','2013-04-16','08:50:00',3.17),('16100','2013-04-16','08:55:00',3.33),('16100','2013-04-16','09:00:00',3.49),('16100','2013-04-16','09:05:00',3.68),('16100','2013-04-16','09:10:00',3.87),('16100','2013-04-16','09:15:00',4.01),('16100','2013-04-16','09:20:00',4.16),('16100','2013-04-16','09:25:00',4.3),('16100','2013-04-16','09:30:00',4.44),('16100','2013-04-16','09:35:00',4.6),('16100','2013-04-16','09:40:00',4.78),('16100','2013-04-16','09:45:00',4.89),('16100','2013-04-16','09:50:00',5.03),('16100','2013-04-16','09:55:00',5.17),('16100','2013-04-16','10:00:00',5.32),('16100','2013-04-16','10:05:00',5.44),('16100','2013-04-16','10:10:00',5.57),('16100','2013-04-16','10:15:00',5.7),('16100','2013-04-16','10:20:00',5.84),('16100','2013-04-16','10:25:00',5.93),('16100','2013-04-16','10:30:00',6.05),('16100','2013-04-16','10:35:00',6.17),('16100','2013-04-16','10:40:00',6.28),('16100','2013-04-16','10:45:00',6.39),('16100','2013-04-16','10:50:00',6.5),('16100','2013-04-16','10:55:00',6.59),('16100','2013-04-16','11:00:00',6.73),('16100','2013-04-16','11:05:00',6.83),('16100','2013-04-16','11:10:00',6.98),('16100','2013-04-16','11:15:00',7.04),('16100','2013-04-16','11:20:00',7.09),('16100','2013-04-16','11:25:00',7.15),('16100','2013-04-16','11:30:00',7.22),('16100','2013-04-16','11:35:00',7.27),('16100','2013-04-16','11:40:00',7.32),('16100','2013-04-16','11:45:00',7.39),('16100','2013-04-16','11:50:00',7.45),('16100','2013-04-16','11:55:00',7.49),('16100','2013-04-16','12:00:00',7.52),('16100','2013-04-16','12:05:00',7.57),('16100','2013-04-16','12:10:00',7.64),('16100','2013-04-16','12:15:00',7.66),('16100','2013-04-16','12:20:00',7.73),('16100','2013-04-16','12:25:00',7.73),('16100','2013-04-16','12:30:00',7.81),('16100','2013-04-16','12:35:00',7.88),('16100','2013-04-16','12:40:00',7.87),('16100','2013-04-16','12:45:00',7.9),('16100','2013-04-16','12:50:00',7.89),('16100','2013-04-16','12:55:00',7.94),('16100','2013-04-16','13:00:00',8.01),('16100','2013-04-16','13:05:00',7.98),('16100','2013-04-16','13:10:00',8.02),('16100','2013-04-16','13:15:00',8.04),('16100','2013-04-16','13:20:00',8.1),('16100','2013-04-16','13:25:00',8.13),('16100','2013-04-16','13:30:00',7.98),('16100','2013-04-16','13:35:00',8.22),('16100','2013-04-16','13:40:00',8.19),('16100','2013-04-16','13:45:00',7.62),('16100','2013-04-16','13:50:00',7.6),('16100','2013-04-16','13:55:00',6.78),('16100','2013-04-16','14:00:00',7.79),('16100','2013-04-16','14:05:00',7.74),('16100','2013-04-16','14:10:00',8.36),('16100','2013-04-16','14:15:00',7.9),('16100','2013-04-16','14:20:00',8.32),('16100','2013-04-16','14:25:00',6.32),('16100','2013-04-16','14:30:00',6.93),('16100','2013-04-16','14:35:00',7.75),('16100','2013-04-16','14:40:00',7.52),('16100','2013-04-16','14:45:00',4.94),('16100','2013-04-16','14:50:00',6.73),('16100','2013-04-16','14:55:00',7.64),('16100','2013-04-16','15:00:00',8),('16100','2013-04-16','15:05:00',7.98),('16100','2013-04-16','15:10:00',8.15),('16100','2013-04-16','15:15:00',7.63),('16100','2013-04-16','15:20:00',3.98),('16100','2013-04-16','15:25:00',3.24),('16100','2013-04-16','15:30:00',5.45),('16100','2013-04-16','15:35:00',5.22),('16100','2013-04-16','15:40:00',5.49),('16100','2013-04-16','15:45:00',5.58),('16100','2013-04-16','15:50:00',6.44),('16100','2013-04-16','15:55:00',6.46),('16100','2013-04-16','16:00:00',6.39),('16100','2013-04-16','16:05:00',4.64),('16100','2013-04-16','16:10:00',5.74),('16100','2013-04-16','16:15:00',5.76),('16100','2013-04-16','16:20:00',5.58),('16100','2013-04-16','16:25:00',5.39),('16100','2013-04-16','16:30:00',5.26),('16100','2013-04-16','16:35:00',4.67),('16100','2013-04-16','16:40:00',3.94),('16100','2013-04-16','16:45:00',4.67),('16100','2013-04-16','16:50:00',4.59),('16100','2013-04-16','16:55:00',4.36),('16100','2013-04-16','17:00:00',4.16),('16100','2013-04-16','17:05:00',3.99),('16100','2013-04-16','17:10:00',3.84),('16100','2013-04-16','17:15:00',3.68),('16100','2013-04-16','17:20:00',3.5),('16100','2013-04-16','17:25:00',3.32),('16100','2013-04-16','17:30:00',3.15),('16100','2013-04-16','17:35:00',2.98),('16100','2013-04-16','17:40:00',2.78),('16100','2013-04-16','17:45:00',2.59),('16100','2013-04-16','17:50:00',2.42),('16100','2013-04-16','17:55:00',2.24),('16100','2013-04-16','18:00:00',2.09),('16100','2013-04-16','18:05:00',1.93),('16100','2013-04-16','18:10:00',1.76),('16100','2013-04-16','18:15:00',1.58),('16100','2013-04-16','18:20:00',1.42),('16100','2013-04-16','18:25:00',1.26),('16100','2013-04-16','18:30:00',1.09),('16100','2013-04-15','08:00:00',1.02),('16100','2013-04-15','08:05:00',1.36),('16100','2013-04-15','08:10:00',1.75),('16100','2013-04-15','08:15:00',1.21),('16100','2013-04-15','08:40:00',1.16),('16100','2013-04-15','08:45:00',1.54),('16100','2013-04-15','08:50:00',1.68),('16100','2013-04-15','09:05:00',2.8),('16100','2013-04-15','09:10:00',3.88),('16100','2013-04-15','09:15:00',4.14),('16100','2013-04-15','09:20:00',3.97),('16100','2013-04-15','09:25:00',2.49),('16100','2013-04-15','09:30:00',2.42),('16100','2013-04-15','09:35:00',2.91),('16100','2013-04-15','09:40:00',3.76),('16100','2013-04-15','09:45:00',2.99),('16100','2013-04-15','09:50:00',2.54),('16100','2013-04-15','09:55:00',2.33),('16100','2013-04-15','10:00:00',2.26),('16100','2013-04-15','10:05:00',2.24),('16100','2013-04-15','10:10:00',2.31),('16100','2013-04-15','10:15:00',2.41),('16100','2013-04-15','10:20:00',2.34),('16100','2013-04-15','10:25:00',2.36),('16100','2013-04-15','10:30:00',2.38),('16100','2013-04-15','10:35:00',2.47),('16100','2013-04-15','10:40:00',2.63),('16100','2013-04-15','10:45:00',2.75),('16100','2013-04-15','10:50:00',2.69),('16100','2013-04-15','10:55:00',2.69),('16100','2013-04-15','11:00:00',2.74),('16100','2013-04-15','11:05:00',2.8),('16100','2013-04-15','11:10:00',2.84),('16100','2013-04-15','11:15:00',2.9),('16100','2013-04-15','11:20:00',2.94),('16100','2013-04-15','11:25:00',2.97),('16100','2013-04-15','11:30:00',2.73),('16100','2013-04-15','11:35:00',2.64),('16100','2013-04-15','11:40:00',3.24),('16100','2013-04-15','11:45:00',3.67),('16100','2013-04-15','11:50:00',3.93),('16100','2013-04-15','11:55:00',4.51),('16100','2013-04-15','12:00:00',5.4),('16100','2013-04-15','12:05:00',5.74),('16100','2013-04-15','12:10:00',5.96),('16100','2013-04-15','12:15:00',5.03),('16100','2013-04-15','12:20:00',4.97),('16100','2013-04-15','12:25:00',5.94),('16100','2013-04-15','12:30:00',6.25),('16100','2013-04-15','12:35:00',4.77),('16100','2013-04-15','12:40:00',5.59),('16100','2013-04-15','12:45:00',6.26),('16100','2013-04-15','12:50:00',6.66),('16100','2013-04-15','12:55:00',7.53),('16100','2013-04-15','13:00:00',7.52),('16100','2013-04-15','13:05:00',7.28),('16100','2013-04-15','13:10:00',7.32),('16100','2013-04-15','13:15:00',7.33),('16100','2013-04-15','13:20:00',7.34),('16100','2013-04-15','13:25:00',7.49),('16100','2013-04-15','13:30:00',7.51),('16100','2013-04-15','13:35:00',7.62),('16100','2013-04-15','13:40:00',7.56),('16100','2013-04-15','13:45:00',7.67),('16100','2013-04-15','13:50:00',7.39),('16100','2013-04-15','13:55:00',7.62),('16100','2013-04-15','14:00:00',7.61),('16100','2013-04-15','14:05:00',7.5),('16100','2013-04-15','14:10:00',7.64),('16100','2013-04-15','14:15:00',7.65),('16100','2013-04-15','14:20:00',7.66),('16100','2013-04-15','14:25:00',6.95),('16100','2013-04-15','14:30:00',6.05),('16100','2013-04-15','14:35:00',6.01),('16100','2013-04-15','14:40:00',7.24),('16100','2013-04-15','14:45:00',7.06),('16100','2013-04-15','14:50:00',7.2),('16100','2013-04-15','14:55:00',7.02),('16100','2013-04-15','15:00:00',7.2),('16100','2013-04-15','15:05:00',7.16),('16100','2013-04-15','15:10:00',7.05),('16100','2013-04-15','15:15:00',5.8),('16100','2013-04-15','15:20:00',5.62),('16100','2013-04-15','15:25:00',5.66),('16100','2013-04-15','15:30:00',6.02),('16100','2013-04-15','15:35:00',6.25),('16100','2013-04-15','15:40:00',6.23),('16100','2013-04-15','15:45:00',5.95),('16100','2013-04-15','15:50:00',5.98),('16100','2013-04-15','15:55:00',5.83),('16100','2013-04-15','16:00:00',5.7),('16100','2013-04-15','16:05:00',5.54),('16100','2013-04-15','16:10:00',5.35),('16100','2013-04-15','16:15:00',5.3),('16100','2013-04-15','16:20:00',5.1),('16100','2013-04-15','16:25:00',5.03),('16100','2013-04-15','16:30:00',4.9),('16100','2013-04-15','16:35:00',4.88),('16100','2013-04-15','16:40:00',4.89),('16100','2013-04-15','16:45:00',4.47),('16100','2013-04-15','16:50:00',3.83),('16100','2013-04-15','16:55:00',4.09),('16100','2013-04-15','17:00:00',4.09),('16100','2013-04-15','17:05:00',3.97),('16100','2013-04-15','17:10:00',3.8),('16100','2013-04-15','17:15:00',3.72),('16100','2013-04-15','17:20:00',3.64),('16100','2013-04-15','17:25:00',3.34),('16100','2013-04-15','17:30:00',3.19),('16100','2013-04-15','17:35:00',3),('16100','2013-04-15','17:40:00',2.74),('16100','2013-04-15','17:45:00',2.54),('16100','2013-04-15','17:50:00',2.39),('16100','2013-04-15','17:55:00',2.39),('16100','2013-04-15','18:00:00',2.4),('16100','2013-04-15','18:05:00',2.22),('16100','2013-04-15','18:10:00',1.7),('16100','2013-04-15','18:15:00',1.17),('16100','2013-04-15','18:20:00',1.26),('16100','2013-04-15','18:25:00',1.13),('16100','2013-04-15','18:30:00',1.01),('16100','2013-04-14','08:00:00',1.08),('16100','2013-04-14','08:05:00',1.27),('16100','2013-04-14','08:10:00',1.52),('16100','2013-04-14','08:15:00',1.8),('16100','2013-04-14','08:20:00',2.02),('16100','2013-04-14','08:25:00',2.21),('16100','2013-04-14','08:30:00',2.33),('16100','2013-04-14','08:35:00',2.58),('16100','2013-04-14','08:40:00',2.79),('16100','2013-04-14','08:45:00',2.96),('16100','2013-04-14','08:50:00',3.18),('16100','2013-04-14','08:55:00',3.35),('16100','2013-04-14','09:00:00',3.52),('16100','2013-04-14','09:05:00',3.69),('16100','2013-04-14','09:10:00',3.92),('16100','2013-04-14','09:15:00',4.1),('16100','2013-04-14','09:20:00',4.25),('16100','2013-04-14','09:25:00',4.4),('16100','2013-04-14','09:30:00',4.53),('16100','2013-04-14','09:35:00',4.67),('16100','2013-04-14','09:40:00',4.85),('16100','2013-04-14','09:45:00',5),('16100','2013-04-14','09:50:00',5.12),('16100','2013-04-14','09:55:00',5.24),('16100','2013-04-14','10:00:00',5.35),('16100','2013-04-14','10:05:00',5.45),('16100','2013-04-14','10:10:00',5.58),('16100','2013-04-14','10:15:00',5.69),('16100','2013-04-14','10:20:00',5.85),('16100','2013-04-14','10:25:00',5.99),('16100','2013-04-14','10:30:00',6.16),('16100','2013-04-14','10:35:00',6.31),('16100','2013-04-14','10:40:00',6.38),('16100','2013-04-14','10:45:00',6.47),('16100','2013-04-14','10:50:00',6.55),('16100','2013-04-14','10:55:00',6.66),('16100','2013-04-14','11:00:00',6.74),('16100','2013-04-14','11:05:00',6.83),('16100','2013-04-14','11:10:00',6.98),('16100','2013-04-14','11:15:00',7.02),('16100','2013-04-14','11:20:00',7.09),('16100','2013-04-14','11:25:00',7.12),('16100','2013-04-14','11:30:00',7.22),('16100','2013-04-14','11:35:00',7.29),('16100','2013-04-14','11:40:00',7.32),('16100','2013-04-14','11:45:00',7.4),('16100','2013-04-14','11:50:00',7.49),('16100','2013-04-14','11:55:00',7.5),('16100','2013-04-14','12:00:00',7.56),('16100','2013-04-14','12:05:00',7.58),('16100','2013-04-14','12:10:00',7.62),('16100','2013-04-14','12:15:00',7.68),('16100','2013-04-14','12:20:00',7.68),('16100','2013-04-14','12:25:00',7.69),('16100','2013-04-14','12:30:00',7.67),('16100','2013-04-14','12:35:00',7.73),('16100','2013-04-14','12:40:00',7.76),('16100','2013-04-14','12:45:00',7.77),('16100','2013-04-14','12:50:00',7.8),('16100','2013-04-14','12:55:00',7.79),('16100','2013-04-14','13:00:00',7.78),('16100','2013-04-14','13:05:00',7.84),('16100','2013-04-14','13:10:00',7.87),('16100','2013-04-14','13:15:00',7.82),('16100','2013-04-14','13:20:00',7.88),('16100','2013-04-14','13:25:00',7.87),('16100','2013-04-14','13:30:00',7.79),('16100','2013-04-14','13:35:00',7.72),('16100','2013-04-14','13:40:00',7.77),('16100','2013-04-14','13:45:00',7.88),('16100','2013-04-14','13:50:00',7.95),('16100','2013-04-14','13:55:00',7.94),('16100','2013-04-14','14:00:00',7.95),('16100','2013-04-14','14:05:00',7.84),('16100','2013-04-14','14:10:00',7.82),('16100','2013-04-14','14:15:00',7.79),('16100','2013-04-14','14:20:00',7.75),('16100','2013-04-14','14:25:00',7.68),('16100','2013-04-14','14:30:00',7.59),('16100','2013-04-14','14:35:00',7.5),('16100','2013-04-14','14:40:00',7.43),('16100','2013-04-14','14:45:00',7.36),('16100','2013-04-14','14:50:00',7.33),('16100','2013-04-14','14:55:00',7.29),('16100','2013-04-14','15:00:00',7.2),('16100','2013-04-14','15:05:00',7.12),('16100','2013-04-14','15:10:00',7.03),('16100','2013-04-14','15:15:00',6.9),('16100','2013-04-14','15:20:00',6.83),('16100','2013-04-14','15:25:00',6.72),('16100','2013-04-14','15:30:00',6.62),('16100','2013-04-14','15:35:00',6.54),('16100','2013-04-14','15:40:00',6.4),('16100','2013-04-14','15:45:00',6.31),('16100','2013-04-14','15:50:00',6.19),('16100','2013-04-14','15:55:00',6.07),('16100','2013-04-14','16:00:00',5.92),('16100','2013-04-14','16:05:00',5.81),('16100','2013-04-14','16:10:00',5.58),('16100','2013-04-14','16:15:00',5.55),('16100','2013-04-14','16:20:00',5.42),('16100','2013-04-14','16:25:00',5.27),('16100','2013-04-14','16:30:00',5.12),('16100','2013-04-14','16:35:00',4.96),('16100','2013-04-14','16:40:00',4.81),('16100','2013-04-14','16:45:00',4.65),('16100','2013-04-14','16:50:00',4.5),('16100','2013-04-14','16:55:00',4.32),('16100','2013-04-14','17:00:00',4.15),('16100','2013-04-14','17:05:00',4),('16100','2013-04-14','17:10:00',3.84),('16100','2013-04-14','17:15:00',3.67),('16100','2013-04-14','17:20:00',3.48),('16100','2013-04-14','17:25:00',3.29),('16100','2013-04-14','17:30:00',3.15),('16100','2013-04-14','17:35:00',2.98),('16100','2013-04-14','17:40:00',2.79),('16100','2013-04-14','17:45:00',2.61),('16100','2013-04-14','17:50:00',2.43),('16100','2013-04-14','17:55:00',2.25),('16100','2013-04-14','18:00:00',2.08),('16100','2013-04-14','18:05:00',1.92),('16100','2013-04-14','18:10:00',1.74),('16100','2013-04-14','18:15:00',1.58),('16100','2013-04-14','18:20:00',1.42),('16100','2013-04-14','18:25:00',1.26),('16100','2013-04-14','18:30:00',1.11),('16100','2013-04-13','08:00:00',1.04),('16100','2013-04-13','08:05:00',1.24),('16100','2013-04-13','08:10:00',1.48),('16100','2013-04-13','08:15:00',1.72),('16100','2013-04-13','08:20:00',1.88),('16100','2013-04-13','08:25:00',2.06),('16100','2013-04-13','08:30:00',2.26),('16100','2013-04-13','08:35:00',2.41),('16100','2013-04-13','08:40:00',2.61),('16100','2013-04-13','08:45:00',2.77),('16100','2013-04-13','08:50:00',2.97),('16100','2013-04-13','08:55:00',3.14),('16100','2013-04-13','09:00:00',3.27),('16100','2013-04-13','09:05:00',3.36),('16100','2013-04-13','09:10:00',3.55),('16100','2013-04-13','09:15:00',3.77),('16100','2013-04-13','09:20:00',3.95),('16100','2013-04-13','09:25:00',4.1),('16100','2013-04-13','09:30:00',4.28),('16100','2013-04-13','09:35:00',4.41),('16100','2013-04-13','09:40:00',4.55),('16100','2013-04-13','09:45:00',4.72),('16100','2013-04-13','09:50:00',4.86),('16100','2013-04-13','09:55:00',4.98),('16100','2013-04-13','10:00:00',5.14),('16100','2013-04-13','10:05:00',5.28),('16100','2013-04-13','10:10:00',5.4),('16100','2013-04-13','10:15:00',5.52),('16100','2013-04-13','10:20:00',5.66),('16100','2013-04-13','10:25:00',5.8),('16100','2013-04-13','10:30:00',5.94),('16100','2013-04-13','10:35:00',6.03),('16100','2013-04-13','10:40:00',6.15),('16100','2013-04-13','10:45:00',6.28),('16100','2013-04-13','10:50:00',6.35),('16100','2013-04-13','10:55:00',6.47),('16100','2013-04-13','11:00:00',6.56),('16100','2013-04-13','11:05:00',6.65),('16100','2013-04-13','11:10:00',6.77),('16100','2013-04-13','11:15:00',6.87),('16100','2013-04-13','11:20:00',6.95),('16100','2013-04-13','11:25:00',6.96),('16100','2013-04-13','11:30:00',7.02),('16100','2013-04-13','11:35:00',7.06),('16100','2013-04-13','11:40:00',7.15),('16100','2013-04-13','11:45:00',7.21),('16100','2013-04-13','11:50:00',7.32),('16100','2013-04-13','11:55:00',7.29),('16100','2013-04-13','12:00:00',7.37),('16100','2013-04-13','12:05:00',7.4),('16100','2013-04-13','12:10:00',7.41),('16100','2013-04-13','12:15:00',7.37),('16100','2013-04-13','12:20:00',7.41),('16100','2013-04-13','12:25:00',7.52),('16100','2013-04-13','12:30:00',7.53),('16100','2013-04-13','12:35:00',7.65),('16100','2013-04-13','12:40:00',7.68),('16100','2013-04-13','12:45:00',7.55),('16100','2013-04-13','12:50:00',7.62),('16100','2013-04-13','12:55:00',7.68),('16100','2013-04-13','13:00:00',7.8),('16100','2013-04-13','13:05:00',7.83),('16100','2013-04-13','13:10:00',6.79),('16100','2013-04-13','13:15:00',7.72),('16100','2013-04-13','13:20:00',4.08),('16100','2013-04-13','13:25:00',7.8),('16100','2013-04-13','13:30:00',7.52),('16100','2013-04-13','13:35:00',7.87),('16100','2013-04-13','13:40:00',8.05),('16100','2013-04-13','13:45:00',5.4),('16100','2013-04-13','13:50:00',6.36),('16100','2013-04-13','13:55:00',6.88),('16100','2013-04-13','14:00:00',7.67),('16100','2013-04-13','14:05:00',7.58),('16100','2013-04-13','14:10:00',7.34),('16100','2013-04-13','14:15:00',7.26),('16100','2013-04-13','14:20:00',7.44),('16100','2013-04-13','14:25:00',7.19),('16100','2013-04-13','14:30:00',7.47),('16100','2013-04-13','14:35:00',7.34),('16100','2013-04-13','14:40:00',7.22),('16100','2013-04-13','14:45:00',7.2),('16100','2013-04-13','14:50:00',7.33),('16100','2013-04-13','14:55:00',7.28),('16100','2013-04-13','15:00:00',7.34),('16100','2013-04-13','15:05:00',7.04),('16100','2013-04-13','15:10:00',7.37),('16100','2013-04-13','15:15:00',6.62),('16100','2013-04-13','15:20:00',6.66),('16100','2013-04-13','15:25:00',6.58),('16100','2013-04-13','15:30:00',6.39),('16100','2013-04-13','15:35:00',6.43),('16100','2013-04-13','15:40:00',6.18),('16100','2013-04-13','15:45:00',6.22),('16100','2013-04-13','15:50:00',6.04),('16100','2013-04-13','15:55:00',5.77),('16100','2013-04-13','16:00:00',5.61),('16100','2013-04-13','16:05:00',5.56),('16100','2013-04-13','16:10:00',5.3),('16100','2013-04-13','16:15:00',5.24),('16100','2013-04-13','16:20:00',5.16),('16100','2013-04-13','16:25:00',5.06),('16100','2013-04-13','16:30:00',4.89),('16100','2013-04-13','16:35:00',4.71),('16100','2013-04-13','16:40:00',4.61),('16100','2013-04-13','16:45:00',4.48),('16100','2013-04-13','16:50:00',4.28),('16100','2013-04-13','16:55:00',4.11),('16100','2013-04-13','17:00:00',4.01),('16100','2013-04-13','17:05:00',3.87),('16100','2013-04-13','17:10:00',3.69),('16100','2013-04-13','17:15:00',3.51),('16100','2013-04-13','17:20:00',3.4),('16100','2013-04-13','17:25:00',3.17),('16100','2013-04-13','17:30:00',2.99),('16100','2013-04-13','17:35:00',2.84),('16100','2013-04-13','17:40:00',2.67),('16100','2013-04-13','17:45:00',2.52),('16100','2013-04-13','17:50:00',2.32),('16100','2013-04-13','17:55:00',2.16),('16100','2013-04-13','18:00:00',1.99),('16100','2013-04-13','18:05:00',1.81),('16100','2013-04-13','18:10:00',1.64),('16100','2013-04-13','18:15:00',1.49),('16100','2013-04-13','18:20:00',1.34),('16100','2013-04-13','18:25:00',1.18),('16100','2013-04-13','18:30:00',1.04),('16100','2013-04-12','08:00:00',1.03),('16100','2013-04-12','08:05:00',1.27),('16100','2013-04-12','08:10:00',1.69),('16100','2013-04-12','08:15:00',1.02),('16100','2013-04-12','08:45:00',1.75),('16100','2013-04-12','08:50:00',3.08),('16100','2013-04-12','08:55:00',3.21),('16100','2013-04-12','09:00:00',3.19),('16100','2013-04-12','09:05:00',3.46),('16100','2013-04-12','09:10:00',3.73),('16100','2013-04-12','09:15:00',3.76),('16100','2013-04-12','09:20:00',3.97),('16100','2013-04-12','09:25:00',4.13),('16100','2013-04-12','09:30:00',4.33),('16100','2013-04-12','09:35:00',3.91),('16100','2013-04-12','09:40:00',4.79),('16100','2013-04-12','09:45:00',4.91),('16100','2013-04-12','09:50:00',5.04),('16100','2013-04-12','09:55:00',5.01),('16100','2013-04-12','10:00:00',2.66),('16100','2013-04-12','10:05:00',3.6),('16100','2013-04-12','10:10:00',4.78),('16100','2013-04-12','10:15:00',4.92),('16100','2013-04-12','10:20:00',5.99),('16100','2013-04-12','10:25:00',6.58),('16100','2013-04-12','10:30:00',6.81),('16100','2013-04-12','10:35:00',6.67),('16100','2013-04-12','10:40:00',5.94),('16100','2013-04-12','10:45:00',2.44),('16100','2013-04-12','10:50:00',3.5),('16100','2013-04-12','10:55:00',3.72),('16100','2013-04-12','11:00:00',6.67),('16100','2013-04-12','11:05:00',4.83),('16100','2013-04-12','11:10:00',3.54),('16100','2013-04-12','11:15:00',4.29),('16100','2013-04-12','11:20:00',6.23),('16100','2013-04-12','11:25:00',7.27),('16100','2013-04-12','11:30:00',7.21),('16100','2013-04-12','11:35:00',4.72),('16100','2013-04-12','11:40:00',6.37),('16100','2013-04-12','11:45:00',2.86),('16100','2013-04-12','11:50:00',7.86),('16100','2013-04-12','11:55:00',5.28),('16100','2013-04-12','12:00:00',8.1),('16100','2013-04-12','12:05:00',8.1),('16100','2013-04-12','12:10:00',6.4),('16100','2013-04-12','12:15:00',6.1),('16100','2013-04-12','12:20:00',5.36),('16100','2013-04-12','12:25:00',7.4),('16100','2013-04-12','12:30:00',6.69),('16100','2013-04-12','12:35:00',7.76),('16100','2013-04-12','12:40:00',8.24),('16100','2013-04-12','12:45:00',8.15),('16100','2013-04-12','12:50:00',7.94),('16100','2013-04-12','12:55:00',7.98),('16100','2013-04-12','13:00:00',7.88),('16100','2013-04-12','13:05:00',7.86),('16100','2013-04-12','13:10:00',7.81),('16100','2013-04-12','13:15:00',7.58),('16100','2013-04-12','13:20:00',7.6),('16100','2013-04-12','13:25:00',7.76),('16100','2013-04-12','13:30:00',7.26),('16100','2013-04-12','13:35:00',7.09),('16100','2013-04-12','13:40:00',6.65),('16100','2013-04-12','13:45:00',6.46),('16100','2013-04-12','13:50:00',4.39),('16100','2013-04-12','13:55:00',6.3),('16100','2013-04-12','14:00:00',6.44),('16100','2013-04-12','14:05:00',6.51),('16100','2013-04-12','14:10:00',6.31),('16100','2013-04-12','14:15:00',6.46),('16100','2013-04-12','14:20:00',6.33),('16100','2013-04-12','14:25:00',6.68),('16100','2013-04-12','14:30:00',7.15),('16100','2013-04-12','14:35:00',7.07),('16100','2013-04-12','14:40:00',7),('16100','2013-04-12','14:45:00',6.81),('16100','2013-04-12','14:50:00',6.52),('16100','2013-04-12','14:55:00',6.17),('16100','2013-04-12','15:00:00',6.07),('16100','2013-04-12','15:05:00',6.11),('16100','2013-04-12','15:10:00',5.85),('16100','2013-04-12','15:15:00',5.41),('16100','2013-04-12','15:20:00',5.13),('16100','2013-04-12','15:25:00',5.25),('16100','2013-04-12','15:30:00',5.03),('16100','2013-04-12','15:35:00',5.2),('16100','2013-04-12','15:40:00',5.28),('16100','2013-04-12','15:45:00',5.3),('16100','2013-04-12','15:50:00',5.49),('16100','2013-04-12','15:55:00',4.77),('16100','2013-04-12','16:00:00',4.87),('16100','2013-04-12','16:05:00',4.5),('16100','2013-04-12','16:10:00',4.54),('16100','2013-04-12','16:15:00',4.37),('16100','2013-04-12','16:20:00',4.09),('16100','2013-04-12','16:25:00',3.55),('16100','2013-04-12','16:30:00',3.64),('16100','2013-04-12','16:35:00',3.13),('16100','2013-04-12','16:40:00',3.14),('16100','2013-04-12','16:45:00',3.34),('16100','2013-04-12','16:50:00',2.98),('16100','2013-04-12','16:55:00',2.44),('16100','2013-04-12','17:00:00',2.66),('16100','2013-04-12','17:05:00',3.92),('16100','2013-04-12','17:10:00',3.89),('16100','2013-04-12','17:15:00',3.24),('16100','2013-04-12','17:20:00',3.29),('16100','2013-04-12','17:25:00',3.31),('16100','2013-04-12','17:30:00',3.05),('16100','2013-04-12','17:35:00',3.02),('16100','2013-04-12','17:40:00',2.71),('16100','2013-04-12','17:45:00',2.42),('16100','2013-04-12','17:50:00',2.21),('16100','2013-04-12','17:55:00',2.31),('16100','2013-04-12','18:00:00',1.77),('16100','2013-04-12','18:05:00',1.73),('16100','2013-04-12','18:10:00',1.68),('16100','2013-04-12','18:15:00',1.63),('16100','2013-04-12','18:20:00',1.51),('16100','2013-04-12','18:25:00',1.36),('16100','2013-04-12','18:30:00',1.14),('16100','2013-04-11','08:00:00',1.11),('16100','2013-04-11','08:05:00',1.48),('16100','2013-04-11','08:10:00',1.34),('16100','2013-04-11','08:15:00',1.49),('16100','2013-04-11','08:35:00',1.12),('16100','2013-04-11','08:40:00',2.33),('16100','2013-04-11','08:45:00',1.98),('16100','2013-04-11','08:50:00',1.74),('16100','2013-04-11','08:55:00',1.62),('16100','2013-04-11','09:00:00',1.91),('16100','2013-04-11','09:05:00',1.24),('16100','2013-04-11','09:10:00',1.2),('16100','2013-04-11','09:15:00',1.49),('16100','2013-04-11','09:20:00',1.77),('16100','2013-04-11','09:25:00',1.73),('16100','2013-04-11','09:30:00',1.65),('16100','2013-04-11','09:35:00',1.52),('16100','2013-04-11','09:40:00',1.59),('16100','2013-04-11','09:45:00',1.55),('16100','2013-04-11','09:50:00',2.47),('16100','2013-04-11','09:55:00',3.1),('16100','2013-04-11','10:00:00',2.13),('16100','2013-04-11','10:05:00',2.39),('16100','2013-04-11','10:10:00',2.56),('16100','2013-04-11','10:15:00',2.4),('16100','2013-04-11','10:20:00',2.01),('16100','2013-04-11','10:25:00',1.54),('16100','2013-04-11','10:30:00',2.19),('16100','2013-04-11','10:35:00',2.5),('16100','2013-04-11','10:40:00',2.77),('16100','2013-04-11','10:45:00',2.46),('16100','2013-04-11','10:50:00',1.82),('16100','2013-04-11','10:55:00',1.87),('16100','2013-04-11','11:00:00',2.39),('16100','2013-04-11','11:05:00',3.04),('16100','2013-04-11','11:10:00',4.05),('16100','2013-04-11','11:15:00',4.72),('16100','2013-04-11','11:20:00',4.24),('16100','2013-04-11','11:25:00',7.83),('16100','2013-04-11','11:30:00',6.12),('16100','2013-04-11','11:35:00',5.73),('16100','2013-04-11','11:40:00',4.11),('16100','2013-04-11','11:45:00',7.68),('16100','2013-04-11','11:50:00',7.63),('16100','2013-04-11','11:55:00',6.16),('16100','2013-04-11','12:00:00',5.77),('16100','2013-04-11','12:05:00',7.67),('16100','2013-04-11','12:10:00',7.72),('16100','2013-04-11','12:15:00',8.32),('16100','2013-04-11','12:20:00',8.19),('16100','2013-04-11','12:25:00',8.14),('16100','2013-04-11','12:30:00',8.08),('16100','2013-04-11','12:35:00',7.93),('16100','2013-04-11','12:40:00',7.94),('16100','2013-04-11','12:45:00',7.62),('16100','2013-04-11','12:50:00',8.07),('16100','2013-04-11','12:55:00',8.18),('16100','2013-04-11','13:00:00',8.2),('16100','2013-04-11','13:05:00',8.21),('16100','2013-04-11','13:10:00',8.14),('16100','2013-04-11','13:15:00',8.09),('16100','2013-04-11','13:20:00',8.08),('16100','2013-04-11','13:25:00',8.09),('16100','2013-04-11','13:30:00',8.01),('16100','2013-04-11','13:35:00',8),('16100','2013-04-11','13:40:00',8.01),('16100','2013-04-11','13:45:00',7.97),('16100','2013-04-11','13:50:00',7.91),('16100','2013-04-11','13:55:00',7.93),('16100','2013-04-11','14:00:00',7.93),('16100','2013-04-11','14:05:00',7.82),('16100','2013-04-11','14:10:00',7.73),('16100','2013-04-11','14:15:00',7.7),('16100','2013-04-11','14:20:00',7.63),('16100','2013-04-11','14:25:00',7.53),('16100','2013-04-11','14:30:00',7.46),('16100','2013-04-11','14:35:00',7.38),('16100','2013-04-11','14:40:00',7.32),('16100','2013-04-11','14:45:00',7.29),('16100','2013-04-11','14:50:00',7.27),('16100','2013-04-11','14:55:00',7.17),('16100','2013-04-11','15:00:00',7.09),('16100','2013-04-11','15:05:00',7.06),('16100','2013-04-11','15:10:00',6.92),('16100','2013-04-11','15:15:00',6.83),('16100','2013-04-11','15:20:00',6.76),('16100','2013-04-11','15:25:00',6.65),('16100','2013-04-11','15:30:00',6.54),('16100','2013-04-11','15:35:00',6.43),('16100','2013-04-11','15:40:00',6.31),('16100','2013-04-11','15:45:00',6.2),('16100','2013-04-11','15:50:00',6.1),('16100','2013-04-11','15:55:00',6),('16100','2013-04-11','16:00:00',5.87),('16100','2013-04-11','16:05:00',5.72),('16100','2013-04-11','16:10:00',4.76),('16100','2013-04-11','16:15:00',4.95),('16100','2013-04-11','16:20:00',5.37),('16100','2013-04-11','16:25:00',5.29),('16100','2013-04-11','16:30:00',5.01),('16100','2013-04-11','16:35:00',5.07),('16100','2013-04-11','16:40:00',5.02),('16100','2013-04-11','16:45:00',4.08),('16100','2013-04-11','16:50:00',4.38),('16100','2013-04-11','16:55:00',4.35),('16100','2013-04-11','17:00:00',3.82),('16100','2013-04-11','17:05:00',3.19),('16100','2013-04-11','17:10:00',2.72),('16100','2013-04-11','17:15:00',4.3),('16100','2013-04-11','17:20:00',4.01),('16100','2013-04-11','17:25:00',2.91),('16100','2013-04-11','17:30:00',4.03),('16100','2013-04-11','17:35:00',3.25),('16100','2013-04-11','17:40:00',2.58),('16100','2013-04-11','17:45:00',2.94),('16100','2013-04-11','17:50:00',2.63),('16100','2013-04-11','17:55:00',2.25),('16100','2013-04-11','18:00:00',1.82),('16100','2014-03-27','07:15:00',1.08),('16100','2014-03-27','07:20:00',1.26),('16100','2014-03-27','07:25:00',1.42),('16100','2014-03-27','07:30:00',1.54),('16100','2014-03-27','07:35:00',1.84),('16100','2014-03-27','07:40:00',2.05),('16100','2014-03-27','07:45:00',2.2),('16100','2014-03-27','07:50:00',2.38),('16100','2014-03-27','07:55:00',2.57),('16100','2014-03-27','08:00:00',2.78),('16100','2014-03-27','08:05:00',2.99),('16100','2014-03-27','08:10:00',3.14),('16100','2014-03-27','08:15:00',3.32),('16100','2014-03-27','08:20:00',3.47),('16100','2014-03-27','08:25:00',3.68),('16100','2014-03-27','08:30:00',3.85),('16100','2014-03-27','08:35:00',3.97),('16100','2014-03-27','08:40:00',4.14),('16100','2014-03-27','08:45:00',4.34),('16100','2014-03-27','08:50:00',4.35),('16100','2014-03-27','08:55:00',4.73),('16100','2014-03-27','09:00:00',5.01),('16100','2014-03-27','09:05:00',5.24),('16100','2014-03-27','09:10:00',4.42),('16100','2014-03-27','09:15:00',4.83),('16100','2014-03-27','09:20:00',5.37),('16100','2014-03-27','09:25:00',5.05),('16100','2014-03-27','09:30:00',3.59),('16100','2014-03-27','09:35:00',2.76),('16100','2014-03-27','09:40:00',4.13),('16100','2014-03-27','09:45:00',5.76),('16100','2014-03-27','09:50:00',6.11),('16100','2014-03-27','09:55:00',6.3),('16100','2014-03-27','10:00:00',6.2),('16100','2014-03-27','10:05:00',4.52),('16100','2014-03-27','10:10:00',3.85),('16100','2014-03-27','10:15:00',6.31),('16100','2014-03-27','10:20:00',6.33),('16100','2014-03-27','10:25:00',6.14),('16100','2014-03-27','10:30:00',5.36),('16100','2014-03-27','10:35:00',5.59),('16100','2014-03-27','10:40:00',7.1),('16100','2014-03-27','10:45:00',7.13),('16100','2014-03-27','10:50:00',7.12),('16100','2014-03-27','10:55:00',7.15),('16100','2014-03-27','11:00:00',7.15),('16100','2014-03-27','11:05:00',7.29),('16100','2014-03-27','11:10:00',6.6),('16100','2014-03-27','11:15:00',1.79),('16100','2014-03-27','11:20:00',2.65),('16100','2014-03-27','11:25:00',5.3),('16100','2014-03-27','11:30:00',7.9),('16100','2014-03-27','11:35:00',7.78),('16100','2014-03-27','11:40:00',7.78),('16100','2014-03-27','11:45:00',5.91),('16100','2014-03-27','11:50:00',8.07),('16100','2014-03-27','11:55:00',8.18),('16100','2014-03-27','12:00:00',7.92),('16100','2014-03-27','12:05:00',3.97),('16100','2014-03-27','12:10:00',4.85),('16100','2014-03-27','12:15:00',6.64),('16100','2014-03-27','12:20:00',3.78),('16100','2014-03-27','12:25:00',8.58),('16100','2014-03-27','12:30:00',6.45),('16100','2014-03-27','12:35:00',2.76),('16100','2014-03-27','12:40:00',4.79),('16100','2014-03-27','12:45:00',1.83),('16100','2014-03-27','12:50:00',5.3),('16100','2014-03-27','12:55:00',6.47),('16100','2014-03-27','13:00:00',6.58),('16100','2014-03-27','13:05:00',9.45),('16100','2014-03-27','13:10:00',8.1),('16100','2014-03-27','13:15:00',4.8),('16100','2014-03-27','13:20:00',4.4),('16100','2014-03-27','13:25:00',3.41),('16100','2014-03-27','13:30:00',3.65),('16100','2014-03-27','13:35:00',8.12),('16100','2014-03-27','13:40:00',7.51),('16100','2014-03-27','13:45:00',7.34),('16100','2014-03-27','13:50:00',6.96),('16100','2014-03-27','13:55:00',7),('16100','2014-03-27','14:00:00',7.09),('16100','2014-03-27','14:05:00',6.86),('16100','2014-03-27','14:10:00',6.79),('16100','2014-03-27','14:15:00',6.73),('16100','2014-03-27','14:20:00',6.61),('16100','2014-03-27','14:25:00',6.47),('16100','2014-03-27','14:30:00',6.41),('16100','2014-03-27','14:35:00',6.32),('16100','2014-03-27','14:40:00',6.25),('16100','2014-03-27','14:45:00',6.12),('16100','2014-03-27','14:50:00',6.01),('16100','2014-03-27','14:55:00',5.97),('16100','2014-03-27','15:00:00',5.85),('16100','2014-03-27','15:05:00',5.68),('16100','2014-03-27','15:10:00',5.44),('16100','2014-03-27','15:15:00',5.34),('16100','2014-03-27','15:20:00',5.25),('16100','2014-03-27','15:25:00',5.11),('16100','2014-03-27','15:30:00',4.99),('16100','2014-03-27','15:35:00',4.98),('16100','2014-03-27','15:40:00',4.77),('16100','2014-03-27','15:45:00',4.7),('16100','2014-03-27','15:50:00',4.17),('16100','2014-03-27','15:55:00',4.72),('16100','2014-03-27','16:00:00',4.85),('16100','2014-03-27','16:05:00',4.77),('16100','2014-03-27','16:10:00',4.29),('16100','2014-03-27','16:15:00',3.79),('16100','2014-03-27','16:20:00',3.03),('16100','2014-03-27','16:25:00',2.55),('16100','2014-03-27','16:30:00',1.41),('16100','2014-03-27','16:35:00',1.85),('16100','2014-03-27','16:40:00',1.1),('16100','2014-03-27','16:45:00',2.06),('16100','2014-03-27','16:50:00',1.43),('16100','2014-03-27','16:55:00',2.21),('16100','2014-03-27','17:00:00',1.96),('16100','2014-03-27','17:05:00',1.74),('16100','2014-03-27','17:10:00',1.65),('16100','2014-03-27','17:15:00',1.11),('16100','2014-03-27','17:25:00',1.33),('16100','2014-03-27','17:30:00',1.06),('16100','2013-04-10','08:05:00',1.21),('16100','2013-04-10','08:10:00',1.45),('16100','2013-04-10','08:15:00',1.65),('16100','2013-04-10','08:20:00',1.83),('16100','2013-04-10','08:25:00',2.02),('16100','2013-04-10','08:30:00',2.2),('16100','2013-04-10','08:35:00',2.38),('16100','2013-04-10','08:40:00',2.6),('16100','2013-04-10','08:45:00',2.77),('16100','2013-04-10','08:50:00',2.96),('16100','2013-04-10','08:55:00',3.16),('16100','2013-04-10','09:00:00',3.33),('16100','2013-04-10','09:05:00',3.48),('16100','2013-04-10','09:10:00',3.67),('16100','2013-04-10','09:15:00',3.86),('16100','2013-04-10','09:20:00',4),('16100','2013-04-10','09:25:00',4.15),('16100','2013-04-10','09:30:00',4.33),('16100','2013-04-10','09:35:00',4.55),('16100','2013-04-10','09:40:00',4.66),('16100','2013-04-10','09:45:00',4.95),('16100','2013-04-10','09:50:00',5.12),('16100','2013-04-10','09:55:00',4.63),('16100','2013-04-10','10:00:00',5.84),('16100','2013-04-10','10:05:00',6.19),('16100','2013-04-10','10:10:00',6.12),('16100','2013-04-10','10:15:00',5.88),('16100','2013-04-10','10:20:00',3.49),('16100','2013-04-10','10:25:00',2.21),('16100','2013-04-10','10:30:00',1.8),('16100','2013-04-10','10:35:00',1.72),('16100','2013-04-10','10:40:00',4.35),('16100','2013-04-10','10:45:00',2.27),('16100','2013-04-10','10:50:00',2.81),('16100','2013-04-10','10:55:00',4.11),('16100','2013-04-10','11:00:00',6.01),('16100','2013-04-10','11:05:00',2.66),('16100','2013-04-10','11:10:00',1.51),('16100','2013-04-10','11:15:00',1.54),('16100','2013-04-10','11:20:00',8.11),('16100','2013-04-10','11:25:00',6.25),('16100','2013-04-10','11:30:00',5.9),('16100','2013-04-10','11:35:00',4.69),('16100','2013-04-10','11:40:00',2.19),('16100','2013-04-10','11:45:00',1.57),('16100','2013-04-10','11:50:00',1.88),('16100','2013-04-10','11:55:00',2.2),('16100','2013-04-10','12:00:00',3.22),('16100','2013-04-10','12:05:00',3.17),('16100','2013-04-10','12:10:00',1.81),('16100','2013-04-10','12:15:00',1.63),('16100','2013-04-10','12:20:00',7.22),('16100','2013-04-10','12:25:00',7.41),('16100','2013-04-10','12:30:00',7.86),('16100','2013-04-10','12:35:00',5.54),('16100','2013-04-10','12:40:00',6.16),('16100','2013-04-10','12:45:00',8.07),('16100','2013-04-10','12:50:00',5.25),('16100','2013-04-10','12:55:00',4.5),('16100','2013-04-10','13:00:00',8.62),('16100','2013-04-10','13:05:00',8.64),('16100','2013-04-10','13:10:00',7.78),('16100','2013-04-10','13:15:00',2.8),('16100','2013-04-10','13:20:00',8.92),('16100','2013-04-10','13:25:00',8.61),('16100','2013-04-10','13:30:00',7.16),('16100','2013-04-10','13:35:00',3.71),('16100','2013-04-10','13:40:00',8.75),('16100','2013-04-10','13:45:00',7.63),('16100','2013-04-10','13:50:00',7.26),('16100','2013-04-10','13:55:00',8.44),('16100','2013-04-10','14:00:00',8.04),('16100','2013-04-10','14:05:00',7.61),('16100','2013-04-10','14:10:00',3.21),('16100','2013-04-10','14:15:00',1.77),('16100','2013-04-10','14:20:00',1.82),('16100','2013-04-10','14:25:00',7.13),('16100','2013-04-10','14:30:00',8.14),('16100','2013-04-10','14:35:00',7.26),('16100','2013-04-10','14:40:00',7.9),('16100','2013-04-10','14:45:00',4),('16100','2013-04-10','14:50:00',7.74),('16100','2013-04-10','14:55:00',7.47),('16100','2013-04-10','15:00:00',7.35),('16100','2013-04-10','15:05:00',7.19),('16100','2013-04-10','15:10:00',7.12),('16100','2013-04-10','15:15:00',6.96),('16100','2013-04-10','15:20:00',6.84),('16100','2013-04-10','15:25:00',6.75),('16100','2013-04-10','15:30:00',6.61),('16100','2013-04-10','15:35:00',6.57),('16100','2013-04-10','15:40:00',6.49),('16100','2013-04-10','15:45:00',6.35),('16100','2013-04-10','15:50:00',6.26),('16100','2013-04-10','15:55:00',5.72),('16100','2013-04-10','16:00:00',5.89),('16100','2013-04-10','16:05:00',5.87),('16100','2013-04-10','16:10:00',5.64),('16100','2013-04-10','16:15:00',5.56),('16100','2013-04-10','16:20:00',5.43),('16100','2013-04-10','16:25:00',5.34),('16100','2013-04-10','16:30:00',5.21),('16100','2013-04-10','16:35:00',5.09),('16100','2013-04-10','16:40:00',4.94),('16100','2013-04-10','16:45:00',4.77),('16100','2013-04-10','16:50:00',4.58),('16100','2013-04-10','16:55:00',4.35),('16100','2013-04-10','17:00:00',4.18),('16100','2013-04-10','17:05:00',4.04),('16100','2013-04-10','17:10:00',3.89),('16100','2013-04-10','17:15:00',3.72),('16100','2013-04-10','17:20:00',3.54),('16100','2013-04-10','17:25:00',3.36),('16100','2013-04-10','17:30:00',3.19),('16100','2013-04-10','17:35:00',3.03),('16100','2013-04-10','17:40:00',2.82),('16100','2013-04-10','17:45:00',2.65),('16100','2013-04-10','17:50:00',2.47),('16100','2013-04-10','17:55:00',2.25),('16100','2013-04-10','18:00:00',1.92),('16100','2013-04-10','18:05:00',1.76),('16100','2013-04-10','18:10:00',1.56),('16100','2013-04-10','18:15:00',1.57),('16100','2013-04-10','18:20:00',1.46),('16100','2013-04-10','18:25:00',1.31),('16100','2013-04-10','18:30:00',1.07),('16100','2013-04-09','08:35:00',1.36),('16100','2013-04-09','08:40:00',3.17),('16100','2013-04-09','08:45:00',3.43),('16100','2013-04-09','08:50:00',3.16),('16100','2013-04-09','08:55:00',3.35),('16100','2013-04-09','09:00:00',3.61),('16100','2013-04-09','09:05:00',3.03),('16100','2013-04-09','09:10:00',2.88),('16100','2013-04-09','09:15:00',3.5),('16100','2013-04-09','09:20:00',4.24),('16100','2013-04-09','09:25:00',4.32),('16100','2013-04-09','09:30:00',4.51),('16100','2013-04-09','09:35:00',4.7),('16100','2013-04-09','09:40:00',4.34),('16100','2013-04-09','09:45:00',4.98),('16100','2013-04-09','09:50:00',5.47),('16100','2013-04-09','09:55:00',5.62),('16100','2013-04-09','10:00:00',5.73),('16100','2013-04-09','10:05:00',5.78),('16100','2013-04-09','10:10:00',5.86),('16100','2013-04-09','10:15:00',5.98),('16100','2013-04-09','10:20:00',6.17),('16100','2013-04-09','10:25:00',6.31),('16100','2013-04-09','10:30:00',6.41),('16100','2013-04-09','10:35:00',6.5),('16100','2013-04-09','10:40:00',6.8),('16100','2013-04-09','10:45:00',5.97),('16100','2013-04-09','10:50:00',6.85),('16100','2013-04-09','10:55:00',7.09),('16100','2013-04-09','11:00:00',7.37),('16100','2013-04-09','11:05:00',5.88),('16100','2013-04-09','11:10:00',5.49),('16100','2013-04-09','11:15:00',6.44),('16100','2013-04-09','11:20:00',4.66),('16100','2013-04-09','11:25:00',7.55),('16100','2013-04-09','11:30:00',7.35),('16100','2013-04-09','11:35:00',8.14),('16100','2013-04-09','11:40:00',7.95),('16100','2013-04-09','11:45:00',5.77),('16100','2013-04-09','11:50:00',4.33),('16100','2013-04-09','11:55:00',5.26),('16100','2013-04-09','12:00:00',6.14),('16100','2013-04-09','12:05:00',3.72),('16100','2013-04-09','12:10:00',2.26),('16100','2013-04-09','12:15:00',1.63),('16100','2013-04-09','12:20:00',3.01),('16100','2013-04-09','12:25:00',9.39),('16100','2013-04-09','12:30:00',5.37),('16100','2013-04-09','12:35:00',9.08),('16100','2013-04-09','12:40:00',7.74),('16100','2013-04-09','12:45:00',8.79),('16100','2013-04-09','12:50:00',8.57),('16100','2013-04-09','12:55:00',5.74),('16100','2013-04-09','13:00:00',2.87),('16100','2013-04-09','13:05:00',2.14),('16100','2013-04-09','13:10:00',6.42),('16100','2013-04-09','13:15:00',8.77),('16100','2013-04-09','13:20:00',7.68),('16100','2013-04-09','13:25:00',8.3),('16100','2013-04-09','13:30:00',8.94),('16100','2013-04-09','13:35:00',9.08),('16100','2013-04-09','13:40:00',8.71),('16100','2013-04-09','13:45:00',6.54),('16100','2013-04-09','13:50:00',8.75),('16100','2013-04-09','13:55:00',3.91),('16100','2013-04-09','14:00:00',9.3),('16100','2013-04-09','14:05:00',5.43),('16100','2013-04-09','14:10:00',8.65),('16100','2013-04-09','14:15:00',7.76),('16100','2013-04-09','14:20:00',7),('16100','2013-04-09','14:25:00',7.62),('16100','2013-04-09','14:30:00',6.17),('16100','2013-04-09','14:35:00',4.41),('16100','2013-04-09','14:40:00',6.26),('16100','2013-04-09','14:45:00',5.9),('16100','2013-04-09','14:50:00',6.88),('16100','2013-04-09','14:55:00',3.97),('16100','2013-04-09','15:00:00',3.25),('16100','2013-04-09','15:05:00',7.1),('16100','2013-04-09','15:10:00',5.3),('16100','2013-04-09','15:15:00',7.18),('16100','2013-04-09','15:20:00',5.71),('16100','2013-04-09','15:25:00',6.91),('16100','2013-04-09','15:30:00',6.81),('16100','2013-04-09','15:35:00',6.59),('16100','2013-04-09','15:40:00',6.57),('16100','2013-04-09','15:45:00',6.63),('16100','2013-04-09','15:50:00',6.37),('16100','2013-04-09','15:55:00',6.15),('16100','2013-04-09','16:00:00',5.99),('16100','2013-04-09','16:05:00',5.9),('16100','2013-04-09','16:10:00',5.66),('16100','2013-04-09','16:15:00',5.31),('16100','2013-04-09','16:20:00',4.7),('16100','2013-04-09','16:25:00',4.98),('16100','2013-04-09','16:30:00',5.21),('16100','2013-04-09','16:35:00',4.64),('16100','2013-04-09','16:40:00',2.71),('16100','2013-04-09','16:45:00',4.26),('16100','2013-04-09','16:50:00',4.66),('16100','2013-04-09','16:55:00',4.28),('16100','2013-04-09','17:00:00',2.97),('16100','2013-04-09','17:05:00',1.39),('16100','2013-04-09','17:10:00',1.36),('16100','2013-04-09','17:15:00',1),('16100','2013-04-08','08:05:00',1.17),('16100','2013-04-08','08:10:00',1.42),('16100','2013-04-08','08:15:00',1.84),('16100','2013-04-08','08:20:00',2.49),('16100','2013-04-08','08:25:00',1.9),('16100','2013-04-08','08:30:00',1.26),('16100','2013-04-08','08:35:00',1.29),('16100','2013-04-08','08:40:00',1.15),('16100','2013-04-08','08:45:00',1.82),('16100','2013-04-08','08:50:00',3.03),('16100','2013-04-08','08:55:00',2.86),('16100','2013-04-08','09:00:00',2.23),('16100','2013-04-08','09:05:00',1.49),('16100','2013-04-08','09:10:00',1.59),('16100','2013-04-08','09:15:00',1.48),('16100','2013-04-08','09:20:00',1.47),('16100','2013-04-08','09:25:00',2.29),('16100','2013-04-08','09:30:00',3.49),('16100','2013-04-08','09:35:00',2.68),('16100','2013-04-08','09:40:00',1.74),('16100','2013-04-08','09:45:00',1.72),('16100','2013-04-08','09:50:00',3.13),('16100','2013-04-08','09:55:00',3.42),('16100','2013-04-08','10:00:00',3.78),('16100','2013-04-08','10:05:00',2.17),('16100','2013-04-08','10:10:00',1.74),('16100','2013-04-08','10:15:00',1.97),('16100','2013-04-08','10:20:00',4.31),('16100','2013-04-08','10:25:00',7.44),('16100','2013-04-08','10:30:00',3.95),('16100','2013-04-08','10:35:00',6),('16100','2013-04-08','10:40:00',6.29),('16100','2013-04-08','10:45:00',3.75),('16100','2013-04-08','10:50:00',7.77),('16100','2013-04-08','10:55:00',7.52),('16100','2013-04-08','11:00:00',4.57),('16100','2013-04-08','11:05:00',3.75),('16100','2013-04-08','11:10:00',6.09),('16100','2013-04-08','11:15:00',6.45),('16100','2013-04-08','11:20:00',6.7),('16100','2013-04-08','11:25:00',6.66),('16100','2013-04-08','11:30:00',8.33),('16100','2013-04-08','11:35:00',4.7),('16100','2013-04-08','11:40:00',8.65),('16100','2013-04-08','11:45:00',4.02),('16100','2013-04-08','11:50:00',6.89),('16100','2013-04-08','11:55:00',6.44),('16100','2013-04-08','12:00:00',8.81),('16100','2013-04-08','12:05:00',8.8),('16100','2013-04-08','12:10:00',8.58),('16100','2013-04-08','12:15:00',5.17),('16100','2013-04-08','12:20:00',6.32),('16100','2013-04-08','12:25:00',7.7),('16100','2013-04-08','12:30:00',9.25),('16100','2013-04-08','12:35:00',8.19),('16100','2013-04-08','12:40:00',8.51),('16100','2013-04-08','12:45:00',6.99),('16100','2013-04-08','12:50:00',7.08),('16100','2013-04-08','12:55:00',9.27),('16100','2013-04-08','13:00:00',2.49),('16100','2013-04-08','13:05:00',5.89),('16100','2013-04-08','13:10:00',5.13),('16100','2013-04-08','13:15:00',4.11),('16100','2013-04-08','13:20:00',4.6),('16100','2013-04-08','13:25:00',2.66),('16100','2013-04-08','13:30:00',3.47),('16100','2013-04-08','13:35:00',7.81),('16100','2013-04-08','13:40:00',6.99),('16100','2013-04-08','13:45:00',7.12),('16100','2013-04-08','13:50:00',7.17),('16100','2013-04-08','13:55:00',8.13),('16100','2013-04-08','14:00:00',7.71),('16100','2013-04-08','14:05:00',7.82),('16100','2013-04-08','14:10:00',7.74),('16100','2013-04-08','14:15:00',7.18),('16100','2013-04-08','14:20:00',6.54),('16100','2013-04-08','14:25:00',6.73),('16100','2013-04-08','14:30:00',7.1),('16100','2013-04-08','14:35:00',7.14),('16100','2013-04-08','14:40:00',7.11),('16100','2013-04-08','14:45:00',6.53),('16100','2013-04-08','14:50:00',5.58),('16100','2013-04-08','14:55:00',6.7),('16100','2013-04-08','15:00:00',7.75),('16100','2013-04-08','15:05:00',6.99),('16100','2013-04-08','15:10:00',7.27),('16100','2013-04-08','15:15:00',7.07),('16100','2013-04-08','15:20:00',7.04),('16100','2013-04-08','15:25:00',7.07),('16100','2013-04-08','15:30:00',5.75),('16100','2013-04-08','15:35:00',6.69),('16100','2013-04-08','15:40:00',6.82),('16100','2013-04-08','15:45:00',6.64),('16100','2013-04-08','15:50:00',6.27),('16100','2013-04-08','15:55:00',5.29),('16100','2013-04-08','16:00:00',5.53),('16100','2013-04-08','16:05:00',6.29),('16100','2013-04-08','16:10:00',5.89),('16100','2013-04-08','16:15:00',5.33),('16100','2013-04-08','16:20:00',5.3),('16100','2013-04-08','16:25:00',5.32),('16100','2013-04-08','16:30:00',4.72),('16100','2013-04-08','16:35:00',4.59),('16100','2013-04-08','16:40:00',4.17),('16100','2013-04-08','16:45:00',4.5),('16100','2013-04-08','16:50:00',3.61),('16100','2013-04-08','16:55:00',3.62),('16100','2013-04-08','17:00:00',4.85),('16100','2013-04-08','17:05:00',5.18),('16100','2013-04-08','17:10:00',4.63),('16100','2013-04-08','17:15:00',4.21),('16100','2013-04-08','17:20:00',4.04),('16100','2013-04-08','17:25:00',3.46),('16100','2013-04-08','17:30:00',2.96),('16100','2013-04-08','17:35:00',2.44),('16100','2013-04-08','17:40:00',1.84),('16100','2013-04-08','17:45:00',1.34),('16100','2013-04-08','17:50:00',1.12),('16100','2013-04-08','17:55:00',1.32),('16100','2013-04-08','18:00:00',1.58),('16100','2013-04-08','18:05:00',1.4),('16100','2013-04-08','18:10:00',1.3),('16100','2013-04-08','18:15:00',1.88),('16100','2013-04-07','08:10:00',1.02),('16100','2013-04-07','08:20:00',1.41),('16100','2013-04-07','08:25:00',1.35),('16100','2013-04-07','08:30:00',1.43),('16100','2013-04-07','08:40:00',1.61),('16100','2013-04-07','08:45:00',1.72),('16100','2013-04-07','08:50:00',1.97),('16100','2013-04-07','08:55:00',2.9),('16100','2013-04-07','09:00:00',1.65),('16100','2013-04-07','09:05:00',2.74),('16100','2013-04-07','09:10:00',2.09),('16100','2013-04-07','09:15:00',3.26),('16100','2013-04-07','09:20:00',2.59),('16100','2013-04-07','09:25:00',3.01),('16100','2013-04-07','09:30:00',4.71),('16100','2013-04-07','09:35:00',5.06),('16100','2013-04-07','09:40:00',5.03),('16100','2013-04-07','09:45:00',5.09),('16100','2013-04-07','09:50:00',2.41),('16100','2013-04-07','09:55:00',4.02),('16100','2013-04-07','10:00:00',5.38),('16100','2013-04-07','10:05:00',4.52),('16100','2013-04-07','10:10:00',4.86),('16100','2013-04-07','10:15:00',5.81),('16100','2013-04-07','10:20:00',5.91),('16100','2013-04-07','10:25:00',5.75),('16100','2013-04-07','10:30:00',5.88),('16100','2013-04-07','10:35:00',6.12),('16100','2013-04-07','10:40:00',6.57),('16100','2013-04-07','10:45:00',6.61),('16100','2013-04-07','10:50:00',6.5),('16100','2013-04-07','10:55:00',6.49),('16100','2013-04-07','11:00:00',5.7),('16100','2013-04-07','11:05:00',5.47),('16100','2013-04-07','11:10:00',5.39),('16100','2013-04-07','11:15:00',4.79),('16100','2013-04-07','11:20:00',3.8),('16100','2013-04-07','11:25:00',3.82),('16100','2013-04-07','11:30:00',4.36),('16100','2013-04-07','11:35:00',5.45),('16100','2013-04-07','11:40:00',4.65),('16100','2013-04-07','11:45:00',4.5),('16100','2013-04-07','11:50:00',4.4),('16100','2013-04-07','11:55:00',4.63),('16100','2013-04-07','12:00:00',3.98),('16100','2013-04-07','12:05:00',4.01),('16100','2013-04-07','12:10:00',4.76),('16100','2013-04-07','12:15:00',5.21),('16100','2013-04-07','12:20:00',5.15),('16100','2013-04-07','12:25:00',5.39),('16100','2013-04-07','12:30:00',5.5),('16100','2013-04-07','12:35:00',5.94),('16100','2013-04-07','12:40:00',5.36),('16100','2013-04-07','12:45:00',5.12),('16100','2013-04-07','12:50:00',4.95),('16100','2013-04-07','12:55:00',5.04),('16100','2013-04-07','13:00:00',6.19),('16100','2013-04-07','13:05:00',5.77),('16100','2013-04-07','13:10:00',6.35),('16100','2013-04-07','13:15:00',4.93),('16100','2013-04-07','13:20:00',6.85),('16100','2013-04-07','13:25:00',6.64),('16100','2013-04-07','13:30:00',4.37),('16100','2013-04-07','13:35:00',7.27),('16100','2013-04-07','13:40:00',5.18),('16100','2013-04-07','13:45:00',7.37),('16100','2013-04-07','13:50:00',5.73),('16100','2013-04-07','13:55:00',6.75),('16100','2013-04-07','14:00:00',6.72),('16100','2013-04-07','14:05:00',6.84),('16100','2013-04-07','14:10:00',7.8),('16100','2013-04-07','14:15:00',5.87),('16100','2013-04-07','14:20:00',6.57),('16100','2013-04-07','14:25:00',6.97),('16100','2013-04-07','14:30:00',6.92),('16100','2013-04-07','14:35:00',6.95),('16100','2013-04-07','14:40:00',6.81),('16100','2013-04-07','14:45:00',7.32),('16100','2013-04-07','14:50:00',7.41),('16100','2013-04-07','14:55:00',6.9),('16100','2013-04-07','15:00:00',6.12),('16100','2013-04-07','15:05:00',7.04),('16100','2013-04-07','15:10:00',6.28),('16100','2013-04-07','15:15:00',5.91),('16100','2013-04-07','15:20:00',6.71),('16100','2013-04-07','15:25:00',6.92),('16100','2013-04-07','15:30:00',6.76),('16100','2013-04-07','15:35:00',6.64),('16100','2013-04-07','15:40:00',6.51),('16100','2013-04-07','15:45:00',6.35),('16100','2013-04-07','15:50:00',6.29),('16100','2013-04-07','15:55:00',6.04),('16100','2013-04-07','16:00:00',6.04),('16100','2013-04-07','16:05:00',5.56),('16100','2013-04-07','16:10:00',5.48),('16100','2013-04-07','16:15:00',5.72),('16100','2013-04-07','16:20:00',5.51),('16100','2013-04-07','16:25:00',5.29),('16100','2013-04-07','16:30:00',5.26),('16100','2013-04-07','16:35:00',5.09),('16100','2013-04-07','16:40:00',4.95),('16100','2013-04-07','16:45:00',4.82),('16100','2013-04-07','16:50:00',4.64),('16100','2013-04-07','16:55:00',4.42),('16100','2013-04-07','17:00:00',4.3),('16100','2013-04-07','17:05:00',4.16),('16100','2013-04-07','17:10:00',4.01),('16100','2013-04-07','17:15:00',3.8),('16100','2013-04-07','17:20:00',3.58),('16100','2013-04-07','17:25:00',3.56),('16100','2013-04-07','17:30:00',3.23),('16100','2013-04-07','17:35:00',3.04),('16100','2013-04-07','17:40:00',2.49),('16100','2013-04-07','17:45:00',2.49),('16100','2013-04-07','17:50:00',1.83),('16100','2013-04-07','17:55:00',1.78),('16100','2013-04-07','18:00:00',1.87),('16100','2013-04-07','18:10:00',1.08),('16100','2013-04-07','18:15:00',1.73),('16100','2013-04-07','18:20:00',2.1),('16100','2013-04-07','18:25:00',1.58),('16100','2013-04-06','08:20:00',1.1),('16100','2013-04-06','08:25:00',1.27),('16100','2013-04-06','08:30:00',1.47),('16100','2013-04-06','08:35:00',1.61),('16100','2013-04-06','08:40:00',1.86),('16100','2013-04-06','08:45:00',2.11),('16100','2013-04-06','08:50:00',2.23),('16100','2013-04-06','08:55:00',2.35),('16100','2013-04-06','09:00:00',2.34),('16100','2013-04-06','09:05:00',2.34),('16100','2013-04-06','09:10:00',2.24),('16100','2013-04-06','09:15:00',2.36),('16100','2013-04-06','09:20:00',2.5),('16100','2013-04-06','09:25:00',2.9),('16100','2013-04-06','09:30:00',3.16),('16100','2013-04-06','09:35:00',3.4),('16100','2013-04-06','09:40:00',3.33),('16100','2013-04-06','09:45:00',3.44),('16100','2013-04-06','09:50:00',3.16),('16100','2013-04-06','09:55:00',2.96),('16100','2013-04-06','10:00:00',3.58),('16100','2013-04-06','10:05:00',3.91),('16100','2013-04-06','10:10:00',4.17),('16100','2013-04-06','10:15:00',4.94),('16100','2013-04-06','10:20:00',5.2),('16100','2013-04-06','10:25:00',5.2),('16100','2013-04-06','10:30:00',5.36),('16100','2013-04-06','10:35:00',5.63),('16100','2013-04-06','10:40:00',5.15),('16100','2013-04-06','10:45:00',4.96),('16100','2013-04-06','10:50:00',4.97),('16100','2013-04-06','10:55:00',3.84),('16100','2013-04-06','11:00:00',4.6),('16100','2013-04-06','11:05:00',4.49),('16100','2013-04-06','11:10:00',4),('16100','2013-04-06','11:15:00',3.64),('16100','2013-04-06','11:20:00',3.65),('16100','2013-04-06','11:25:00',4.28),('16100','2013-04-06','11:30:00',5.97),('16100','2013-04-06','11:35:00',7.19),('16100','2013-04-06','11:40:00',7.47),('16100','2013-04-06','11:45:00',7.15),('16100','2013-04-06','11:50:00',6.79),('16100','2013-04-06','11:55:00',5.63),('16100','2013-04-06','12:00:00',4.7),('16100','2013-04-06','12:05:00',4.84),('16100','2013-04-06','12:10:00',4.8),('16100','2013-04-06','12:15:00',4.79),('16100','2013-04-06','12:20:00',5.63),('16100','2013-04-06','12:25:00',5.17),('16100','2013-04-06','12:30:00',5.92),('16100','2013-04-06','12:35:00',6.01),('16100','2013-04-06','12:40:00',5.78),('16100','2013-04-06','12:45:00',5.79),('16100','2013-04-06','12:50:00',5.63),('16100','2013-04-06','12:55:00',4.74),('16100','2013-04-06','13:00:00',5.37),('16100','2013-04-06','13:05:00',5.3),('16100','2013-04-06','13:10:00',6.02),('16100','2013-04-06','13:15:00',5.96),('16100','2013-04-06','13:20:00',5.92),('16100','2013-04-06','13:25:00',5.5),('16100','2013-04-06','13:30:00',5.63),('16100','2013-04-06','13:35:00',5.91),('16100','2013-04-06','13:40:00',6.56),('16100','2013-04-06','13:45:00',6.46),('16100','2013-04-06','13:50:00',5.92),('16100','2013-04-06','13:55:00',5.24),('16100','2013-04-06','14:00:00',4.92),('16100','2013-04-06','14:05:00',5.04),('16100','2013-04-06','14:10:00',5.73),('16100','2013-04-06','14:15:00',6.46),('16100','2013-04-06','14:20:00',6.12),('16100','2013-04-06','14:25:00',5.58),('16100','2013-04-06','14:30:00',4.83),('16100','2013-04-06','14:35:00',4.41),('16100','2013-04-06','14:40:00',4.06),('16100','2013-04-06','14:45:00',3.37),('16100','2013-04-06','14:50:00',2.63),('16100','2013-04-06','14:55:00',2.92),('16100','2013-04-06','15:00:00',3.53),('16100','2013-04-06','15:05:00',3.23),('16100','2013-04-06','15:10:00',3.74),('16100','2013-04-06','15:15:00',3.72),('16100','2013-04-06','15:20:00',4.44),('16100','2013-04-06','15:25:00',4.83),('16100','2013-04-06','15:30:00',4.94),('16100','2013-04-06','15:35:00',4.81),('16100','2013-04-06','15:40:00',4.76),('16100','2013-04-06','15:45:00',4.57),('16100','2013-04-06','15:50:00',3.52),('16100','2013-04-06','15:55:00',3.31),('16100','2013-04-06','16:00:00',2.54),('16100','2013-04-06','16:05:00',2.39),('16100','2013-04-06','16:10:00',2.15),('16100','2013-04-06','16:15:00',2.41),('16100','2013-04-06','16:20:00',2.14),('16100','2013-04-06','16:25:00',2.41),('16100','2013-04-06','16:30:00',2.01),('16100','2013-04-06','16:35:00',1.97),('16100','2013-04-06','16:40:00',2.13),('16100','2013-04-06','16:45:00',2.24),('16100','2013-04-06','16:50:00',3.08),('16100','2013-04-06','16:55:00',2.58),('16100','2013-04-06','17:00:00',2),('16100','2013-04-06','17:05:00',1.74),('16100','2013-04-06','17:10:00',2.4),('16100','2013-04-06','17:15:00',3.33),('16100','2013-04-06','17:20:00',3.97),('16100','2013-04-06','17:25:00',3.65),('16100','2013-04-06','17:30:00',3.36),('16100','2013-04-06','17:35:00',3.13),('16100','2013-04-06','17:40:00',2.77),('16100','2013-04-06','17:45:00',2.6),('16100','2013-04-06','17:50:00',2.1),('16100','2013-04-06','18:05:00',1.03),('16100','2013-04-05','08:05:00',1.14),('16100','2013-04-05','08:10:00',1.33),('16100','2013-04-05','08:15:00',1.51),('16100','2013-04-05','08:20:00',1.61),('16100','2013-04-05','08:25:00',1.9),('16100','2013-04-05','08:30:00',2.07),('16100','2013-04-05','08:35:00',2.27),('16100','2013-04-05','08:40:00',2.47),('16100','2013-04-05','08:45:00',2.69),('16100','2013-04-05','08:50:00',2.86),('16100','2013-04-05','08:55:00',3.03),('16100','2013-04-05','09:00:00',3.25),('16100','2013-04-05','09:05:00',3.44),('16100','2013-04-05','09:10:00',3.59),('16100','2013-04-05','09:15:00',3.75),('16100','2013-04-05','09:20:00',3.9),('16100','2013-04-05','09:25:00',4.12),('16100','2013-04-05','09:30:00',4.27),('16100','2013-04-05','09:35:00',4.42),('16100','2013-04-05','09:40:00',4.44),('16100','2013-04-05','09:45:00',4.72),('16100','2013-04-05','09:50:00',4.89),('16100','2013-04-05','09:55:00',5.03),('16100','2013-04-05','10:00:00',5.21),('16100','2013-04-05','10:05:00',5.38),('16100','2013-04-05','10:10:00',5.51),('16100','2013-04-05','10:15:00',4.69),('16100','2013-04-05','10:20:00',1.61),('16100','2013-04-05','10:25:00',6.16),('16100','2013-04-05','10:30:00',6.11),('16100','2013-04-05','10:35:00',6.13),('16100','2013-04-05','10:40:00',6.28),('16100','2013-04-05','10:45:00',6.4),('16100','2013-04-05','10:50:00',6.45),('16100','2013-04-05','10:55:00',6.52),('16100','2013-04-05','11:00:00',6.64),('16100','2013-04-05','11:05:00',6.74),('16100','2013-04-05','11:10:00',6.87),('16100','2013-04-05','11:15:00',6.93),('16100','2013-04-05','11:20:00',7.03),('16100','2013-04-05','11:25:00',7.16),('16100','2013-04-05','11:30:00',7.33),('16100','2013-04-05','11:35:00',7.4),('16100','2013-04-05','11:40:00',7.43),('16100','2013-04-05','11:45:00',6.94),('16100','2013-04-05','11:50:00',7.53),('16100','2013-04-05','11:55:00',7.58),('16100','2013-04-05','12:00:00',7.54),('16100','2013-04-05','12:05:00',7.59),('16100','2013-04-05','12:10:00',7.66),('16100','2013-04-05','12:15:00',7.74),('16100','2013-04-05','12:20:00',7.81),('16100','2013-04-05','12:25:00',7.25),('16100','2013-04-05','12:30:00',7.88),('16100','2013-04-05','12:35:00',7.97),('16100','2013-04-05','12:40:00',7.93),('16100','2013-04-05','12:45:00',7.79),('16100','2013-04-05','12:50:00',5.53),('16100','2013-04-05','12:55:00',8.2),('16100','2013-04-05','13:00:00',8.36),('16100','2013-04-05','13:05:00',8.06),('16100','2013-04-05','13:10:00',4.47),('16100','2013-04-05','13:15:00',1.3),('16100','2013-04-05','13:20:00',2.99),('16100','2013-04-05','13:25:00',2.13),('16100','2013-04-05','13:30:00',1.63),('16100','2013-04-05','13:35:00',8.94),('16100','2013-04-05','13:40:00',8.83),('16100','2013-04-05','13:45:00',8.69),('16100','2013-04-05','13:50:00',8.39),('16100','2013-04-05','13:55:00',7.85),('16100','2013-04-05','14:00:00',8.8),('16100','2013-04-05','14:05:00',8.54),('16100','2013-04-05','14:10:00',8.48),('16100','2013-04-05','14:15:00',8.1),('16100','2013-04-05','14:20:00',7.94),('16100','2013-04-05','14:25:00',7.56),('16100','2013-04-05','14:30:00',7.5),('16100','2013-04-05','14:35:00',7.51),('16100','2013-04-05','14:40:00',7.38),('16100','2013-04-05','14:45:00',7.38),('16100','2013-04-05','14:50:00',7.37),('16100','2013-04-05','14:55:00',7.4),('16100','2013-04-05','15:00:00',7.4),('16100','2013-04-05','15:05:00',7.27),('16100','2013-04-05','15:10:00',6.96),('16100','2013-04-05','15:15:00',6.89),('16100','2013-04-05','15:20:00',6.78),('16100','2013-04-05','15:25:00',6.74),('16100','2013-04-05','15:30:00',6.53),('16100','2013-04-05','15:35:00',6.49),('16100','2013-04-05','15:40:00',6.25),('16100','2013-04-05','15:45:00',6.32),('16100','2013-04-05','15:50:00',6.37),('16100','2013-04-05','15:55:00',5.94),('16100','2013-04-05','16:00:00',5.01),('16100','2013-04-05','16:05:00',4.89),('16100','2013-04-05','16:10:00',4.45),('16100','2013-04-05','16:15:00',4.09),('16100','2013-04-05','16:20:00',4.43),('16100','2013-04-05','16:25:00',3.85),('16100','2013-04-05','16:30:00',2.83),('16100','2013-04-05','16:35:00',4.57),('16100','2013-04-05','16:40:00',4.18),('16100','2013-04-05','16:45:00',4.3),('16100','2013-04-05','16:50:00',4.47),('16100','2013-04-05','16:55:00',3.56),('16100','2013-04-05','17:00:00',3.16),('16100','2013-04-05','17:05:00',2.49),('16100','2013-04-05','17:10:00',2.68),('16100','2013-04-05','17:15:00',2.44),('16100','2013-04-05','17:20:00',1.87),('16100','2013-04-05','17:25:00',1.87),('16100','2013-04-05','17:30:00',1.66),('16100','2013-04-05','17:35:00',1.6),('16100','2013-04-05','17:40:00',1.35),('16100','2013-04-05','17:45:00',1.19),('16100','2013-04-05','17:50:00',1.1),('16100','2013-04-05','17:55:00',1.04),('16100','2013-04-04','08:00:00',1.18),('16100','2013-04-04','08:05:00',1.28),('16100','2013-04-04','08:10:00',1.1),('16100','2013-04-04','08:45:00',2.14),('16100','2013-04-04','08:50:00',3.1),('16100','2013-04-04','08:55:00',2.32),('16100','2013-04-04','09:00:00',2.22),('16100','2013-04-04','09:05:00',1.09),('16100','2013-04-04','09:10:00',1.15),('16100','2013-04-04','09:15:00',1.46),('16100','2013-04-04','09:20:00',1.33),('16100','2013-04-04','09:25:00',2.66),('16100','2013-04-04','09:30:00',1.67),('16100','2013-04-04','09:35:00',1.67),('16100','2013-04-04','09:40:00',1.48),('16100','2013-04-04','09:45:00',1.89),('16100','2013-04-04','09:50:00',3.18),('16100','2013-04-04','09:55:00',1.92),('16100','2013-04-04','10:00:00',2.79),('16100','2013-04-04','10:05:00',3.68),('16100','2013-04-04','10:10:00',4.2),('16100','2013-04-04','10:15:00',4.42),('16100','2013-04-04','10:20:00',6.39),('16100','2013-04-04','10:25:00',6.71),('16100','2013-04-04','10:30:00',6.06),('16100','2013-04-04','10:35:00',6.88),('16100','2013-04-04','10:40:00',7.14),('16100','2013-04-04','10:45:00',3.21),('16100','2013-04-04','10:50:00',4.34),('16100','2013-04-04','10:55:00',3.84),('16100','2013-04-04','11:00:00',6.76),('16100','2013-04-04','11:05:00',7.41),('16100','2013-04-04','11:10:00',5.51),('16100','2013-04-04','11:15:00',7.23),('16100','2013-04-04','11:20:00',7.65),('16100','2013-04-04','11:25:00',6.04),('16100','2013-04-04','11:30:00',7.57),('16100','2013-04-04','11:35:00',3.22),('16100','2013-04-04','11:40:00',7.47),('16100','2013-04-04','11:45:00',4.34),('16100','2013-04-04','11:50:00',6.42),('16100','2013-04-04','11:55:00',4.66),('16100','2013-04-04','12:00:00',6.29),('16100','2013-04-04','12:05:00',4.66),('16100','2013-04-04','12:10:00',2.74),('16100','2013-04-04','12:15:00',2.59),('16100','2013-04-04','12:20:00',2.25),('16100','2013-04-04','12:25:00',1.63),('16100','2013-04-04','12:30:00',2.93),('16100','2013-04-04','12:35:00',1.86),('16100','2013-04-04','12:40:00',2.3),('16100','2013-04-04','12:45:00',5.26),('16100','2013-04-04','12:50:00',3.4),('16100','2013-04-04','12:55:00',7.28),('16100','2013-04-04','13:00:00',7.23),('16100','2013-04-04','13:05:00',7.24),('16100','2013-04-04','13:10:00',7.35),('16100','2013-04-04','13:15:00',7.39),('16100','2013-04-04','13:20:00',8.68),('16100','2013-04-04','13:25:00',8.66),('16100','2013-04-04','13:30:00',5.93),('16100','2013-04-04','13:35:00',7.03),('16100','2013-04-04','13:40:00',8.6),('16100','2013-04-04','13:45:00',8.19),('16100','2013-04-04','13:50:00',2.62),('16100','2013-04-04','13:55:00',6.93),('16100','2013-04-04','14:00:00',8.97),('16100','2013-04-04','14:05:00',4.76),('16100','2013-04-04','14:10:00',7.08),('16100','2013-04-04','14:15:00',3.78),('16100','2013-04-04','14:20:00',4.72),('16100','2013-04-04','14:25:00',3.16),('16100','2013-04-04','14:30:00',6.02),('16100','2013-04-04','14:35:00',6.81),('16100','2013-04-04','14:40:00',4.51),('16100','2013-04-04','14:45:00',7.32),('16100','2013-04-04','14:50:00',3.14),('16100','2013-04-04','14:55:00',3.08),('16100','2013-04-04','15:00:00',3.88),('16100','2013-04-04','15:05:00',2.98),('16100','2013-04-04','15:10:00',2.74),('16100','2013-04-04','15:15:00',2.04),('16100','2013-04-04','15:20:00',1.83),('16100','2013-04-04','15:25:00',1.62),('16100','2013-04-04','15:30:00',1.26),('16100','2013-04-04','15:35:00',1.25),('16100','2013-04-04','15:40:00',1.37),('16100','2013-04-04','15:45:00',1.39),('16100','2013-04-04','15:50:00',1.5),('16100','2013-04-04','15:55:00',1.45),('16100','2013-04-04','16:00:00',1.96),('16100','2013-04-04','16:05:00',2.88),('16100','2013-04-04','16:10:00',2.76),('16100','2013-04-04','16:15:00',2.07),('16100','2013-04-04','16:20:00',3.1),('16100','2013-04-04','16:25:00',2.24),('16100','2013-04-04','16:30:00',2.41),('16100','2013-04-04','16:35:00',2.09),('16100','2013-04-04','16:40:00',3.31),('16100','2013-04-04','16:45:00',2.84),('16100','2013-04-04','16:50:00',1.94),('16100','2013-04-04','16:55:00',3.06),('16100','2013-04-04','17:00:00',2.58),('16100','2013-04-04','17:05:00',2.82),('16100','2013-04-04','17:10:00',2.19),('16100','2013-04-04','17:15:00',4.25),('16100','2013-04-04','17:20:00',2.79),('16100','2013-04-04','17:25:00',3.07),('16100','2013-04-04','17:30:00',2.88),('16100','2013-04-04','17:35:00',1.08),('16100','2013-04-04','17:40:00',1.2),('16100','2013-04-04','17:45:00',3.63),('16100','2013-04-04','17:55:00',2.18),('16100','2013-04-04','18:00:00',2.34),('16100','2013-04-04','18:05:00',1.19),('16100','2013-04-04','18:15:00',1.13),('16100','2013-04-04','18:20:00',1.2),('16100','2013-04-03','08:45:00',1.13),('16100','2013-04-03','08:50:00',1.51),('16100','2013-04-03','08:55:00',2.59),('16100','2013-04-03','09:00:00',2.57),('16100','2013-04-03','09:05:00',1.63),('16100','2013-04-03','09:10:00',1.75),('16100','2013-04-03','09:15:00',1.83),('16100','2013-04-03','09:20:00',1.59),('16100','2013-04-03','09:25:00',1.72),('16100','2013-04-03','09:30:00',2.96),('16100','2013-04-03','09:35:00',4.96),('16100','2013-04-03','09:40:00',2.92),('16100','2013-04-03','09:45:00',2.37),('16100','2013-04-03','09:50:00',1.77),('16100','2013-04-03','09:55:00',2.31),('16100','2013-04-03','10:00:00',3.41),('16100','2013-04-03','10:05:00',4.57),('16100','2013-04-03','10:10:00',3.55),('16100','2013-04-03','10:15:00',2.51),('16100','2013-04-03','10:50:00',4.86),('16100','2013-04-03','10:55:00',4.13),('16100','2013-04-03','11:00:00',2.32),('16100','2013-04-03','11:05:00',1.7),('16100','2013-04-03','11:10:00',2.18),('16100','2013-04-03','11:15:00',2.49),('16100','2013-04-03','11:20:00',1.88),('16100','2013-04-03','11:25:00',1.83),('16100','2013-04-03','11:30:00',2.03),('16100','2013-04-03','11:35:00',2.94),('16100','2013-04-03','11:40:00',4.58),('16100','2013-04-03','11:45:00',4.6),('16100','2013-04-03','11:50:00',6.63),('16100','2013-04-03','12:25:00',4.97),('16100','2013-04-03','12:30:00',4.93),('16100','2013-04-03','12:35:00',7.91),('16100','2013-04-03','12:40:00',7.9),('16100','2013-04-03','12:45:00',7.97),('16100','2013-04-03','12:50:00',6.53),('16100','2013-04-03','12:55:00',5.95),('16100','2013-04-03','13:00:00',3.27),('16100','2013-04-03','13:05:00',2.85),('16100','2013-04-03','13:10:00',3.09),('16100','2013-04-03','13:15:00',6.31),('16100','2013-04-03','13:20:00',5.26),('16100','2013-04-03','13:25:00',4.1),('16100','2013-04-03','13:30:00',7.69),('16100','2013-04-03','13:35:00',7.49),('16100','2013-04-03','13:40:00',6.61),('16100','2013-04-03','13:45:00',6.31),('16100','2013-04-03','13:50:00',5.66),('16100','2013-04-03','13:55:00',4.06),('16100','2013-04-03','14:00:00',4.8),('16100','2013-04-03','14:05:00',6.25),('16100','2013-04-03','14:10:00',7.36),('16100','2013-04-03','14:15:00',7.01),('16100','2013-04-03','14:20:00',7.12),('16100','2013-04-03','14:25:00',7.03),('16100','2013-04-03','14:30:00',7.12),('16100','2013-04-03','14:35:00',7.06),('16100','2013-04-03','14:40:00',7.11),('16100','2013-04-03','14:45:00',5.59),('16100','2013-04-03','14:50:00',6.81),('16100','2013-04-03','14:55:00',6.79),('16100','2013-04-03','15:00:00',6.71),('16100','2013-04-03','15:05:00',6.69),('16100','2013-04-03','15:10:00',6.39),('16100','2013-04-03','15:15:00',6.21),('16100','2013-04-03','15:20:00',5.83),('16100','2013-04-03','15:25:00',5.78),('16100','2013-04-03','15:30:00',6.13),('16100','2013-04-03','15:35:00',6.02),('16100','2013-04-03','15:40:00',5.79),('16100','2013-04-03','15:45:00',5.62),('16100','2013-04-03','15:50:00',5.55),('16100','2013-04-03','15:55:00',5.52),('16100','2013-04-03','16:00:00',5.22),('16100','2013-04-03','16:05:00',5.3),('16100','2013-04-03','16:10:00',4.57),('16100','2013-04-03','16:15:00',4.45),('16100','2013-04-03','16:20:00',3.97),('16100','2013-04-03','16:25:00',5.02),('16100','2013-04-03','16:30:00',4.62),('16100','2013-04-03','16:35:00',3.52),('16100','2013-04-03','16:40:00',4.13),('16100','2013-04-03','16:45:00',3.03),('16100','2013-04-03','16:50:00',3.15),('16100','2013-04-03','16:55:00',3.24),('16100','2013-04-03','17:00:00',3.08),('16100','2013-04-03','17:05:00',3.34),('16100','2013-04-03','17:10:00',2.44),('16100','2013-04-03','17:15:00',2.5),('16100','2013-04-03','17:20:00',2.08),('16100','2013-04-03','17:25:00',1.86),('16100','2013-04-03','17:30:00',1.21),('16100','2013-04-03','17:35:00',1.19),('16100','2013-04-03','17:40:00',1.38),('16100','2013-04-03','17:45:00',1.26),('16100','2013-04-03','17:50:00',1.72),('16100','2013-04-03','17:55:00',2.18),('16100','2013-04-03','18:00:00',1.9),('16100','2013-04-03','18:05:00',1.34),('16100','2013-04-02','08:05:00',1.12),('16100','2013-04-02','08:10:00',1.4),('16100','2013-04-02','08:15:00',1.83),('16100','2013-04-02','08:20:00',2.14),('16100','2013-04-02','08:25:00',1.68),('16100','2013-04-02','08:30:00',2.09),('16100','2013-04-02','08:35:00',2.31),('16100','2013-04-02','08:40:00',2.52),('16100','2013-04-02','09:15:00',2.93),('16100','2013-04-02','09:20:00',2.09),('16100','2013-04-02','09:25:00',3.04),('16100','2013-04-02','09:30:00',2.86),('16100','2013-04-02','09:35:00',4.81),('16100','2013-04-02','09:40:00',4.64),('16100','2013-04-02','09:45:00',4.22),('16100','2013-04-02','09:50:00',4.29),('16100','2013-04-02','09:55:00',4.36),('16100','2013-04-02','10:00:00',2.63),('16100','2013-04-02','10:05:00',4.58),('16100','2013-04-02','10:10:00',6.17),('16100','2013-04-02','10:15:00',5.98),('16100','2013-04-02','10:50:00',3.54),('16100','2013-04-02','10:55:00',3.83),('16100','2013-04-02','11:00:00',6.48),('16100','2013-04-02','11:05:00',4.01),('16100','2013-04-02','11:10:00',6.13),('16100','2013-04-02','11:15:00',3.83),('16100','2013-04-02','11:55:00',4.14),('16100','2013-04-02','12:00:00',4.16),('16100','2013-04-02','12:05:00',5.82),('16100','2013-04-02','12:10:00',5.34),('16100','2013-04-02','12:15:00',6.9),('16100','2013-04-02','12:20:00',5.61),('16100','2013-04-02','12:25:00',7.24),('16100','2013-04-02','12:30:00',8.15),('16100','2013-04-02','12:35:00',6.95),('16100','2013-04-02','12:40:00',7.51),('16100','2013-04-02','12:45:00',5.93),('16100','2013-04-02','12:50:00',6.92),('16100','2013-04-02','12:55:00',5.06),('16100','2013-04-02','13:00:00',9.5),('16100','2013-04-02','13:05:00',7.51),('16100','2013-04-02','13:10:00',8.33),('16100','2013-04-02','13:15:00',6.03),('16100','2013-04-02','13:20:00',6.23),('16100','2013-04-02','13:25:00',4.73),('16100','2013-04-02','13:30:00',6.45),('16100','2013-04-02','13:35:00',6.93),('16100','2013-04-02','13:40:00',8.94),('16100','2013-04-02','13:45:00',6.36),('16100','2013-04-02','13:50:00',6.27),('16100','2013-04-02','13:55:00',5.01),('16100','2013-04-02','14:00:00',4.63),('16100','2013-04-02','14:05:00',3.93),('16100','2013-04-02','14:10:00',5.79),('16100','2013-04-02','14:15:00',6.3),('16100','2013-04-02','14:20:00',7.4),('16100','2013-04-02','14:25:00',7.29),('16100','2013-04-02','14:30:00',6.42),('16100','2013-04-02','14:35:00',8.96),('16100','2013-04-02','14:40:00',7.82),('16100','2013-04-02','14:45:00',8.48),('16100','2013-04-02','14:50:00',6.61),('16100','2013-04-02','14:55:00',7.13),('16100','2013-04-02','15:00:00',7.4),('16100','2013-04-02','15:05:00',4.87),('16100','2013-04-02','15:10:00',6.38),('16100','2013-04-02','15:15:00',4.59),('16100','2013-04-02','15:20:00',6.52),('16100','2013-04-02','15:25:00',6.06),('16100','2013-04-02','15:30:00',1.93),('16100','2013-04-02','15:35:00',3.34),('16100','2013-04-02','15:40:00',5.87),('16100','2013-04-02','15:45:00',4.62),('16100','2013-04-02','15:50:00',2.59),('16100','2013-04-02','15:55:00',6.14),('16100','2013-04-02','16:00:00',5.44),('16100','2013-04-02','16:05:00',6.39),('16100','2013-04-02','16:10:00',6.2),('16100','2013-04-02','16:15:00',5.99),('16100','2013-04-02','16:20:00',5.81),('16100','2013-04-02','16:25:00',5.68),('16100','2013-04-02','16:30:00',5.53),('16100','2013-04-02','16:35:00',5.36),('16100','2013-04-02','16:40:00',5.09),('16100','2013-04-02','16:45:00',4.81),('16100','2013-04-02','16:50:00',4.51),('16100','2013-04-02','16:55:00',4.68),('16100','2013-04-02','17:00:00',4.55),('16100','2013-04-02','17:05:00',4.34),('16100','2013-04-02','17:10:00',4.18),('16100','2013-04-02','17:15:00',4.01),('16100','2013-04-02','17:20:00',3.78),('16100','2013-04-02','17:25:00',3.6),('16100','2013-04-02','17:30:00',3.41),('16100','2013-04-02','17:35:00',3.19),('16100','2013-04-02','17:40:00',2.98),('16100','2013-04-02','17:45:00',2.79),('16100','2013-04-02','17:50:00',2.6),('16100','2013-04-02','17:55:00',1.25),('16100','2013-04-02','18:00:00',1.87),('16100','2013-04-02','18:05:00',1.96),('16100','2013-04-02','18:10:00',1.82),('16100','2013-04-02','18:15:00',1.66),('16100','2013-04-02','18:20:00',1.47),('16100','2013-04-02','18:25:00',1.24),('16100','2013-04-02','18:30:00',1.08),('16100','2013-04-01','08:30:00',1.21),('16100','2013-04-01','08:40:00',2.62),('16100','2013-04-01','08:45:00',2.49),('16100','2013-04-01','08:50:00',1.69),('16100','2013-04-01','08:55:00',1.61),('16100','2013-04-01','09:00:00',3.28),('16100','2013-04-01','09:05:00',3.46),('16100','2013-04-01','09:10:00',3.66),('16100','2013-04-01','09:15:00',3.87),('16100','2013-04-01','09:20:00',3.94),('16100','2013-04-01','09:25:00',4.2),('16100','2013-04-01','09:30:00',4.87),('16100','2013-04-01','09:35:00',4.87),('16100','2013-04-01','09:40:00',5.52),('16100','2013-04-01','09:45:00',5.22),('16100','2013-04-01','09:50:00',6.14),('16100','2013-04-01','09:55:00',6.02),('16100','2013-04-01','10:00:00',4.61),('16100','2013-04-01','10:05:00',5.08),('16100','2013-04-01','10:10:00',4.33),('16100','2013-04-01','10:15:00',3.42),('16100','2013-04-01','10:20:00',5.31),('16100','2013-04-01','10:25:00',6.54),('16100','2013-04-01','10:30:00',6.29),('16100','2013-04-01','10:35:00',6.37),('16100','2013-04-01','10:40:00',5.14),('16100','2013-04-01','10:45:00',4.46),('16100','2013-04-01','10:50:00',7.18),('16100','2013-04-01','10:55:00',6.05),('16100','2013-04-01','11:00:00',7.37),('16100','2013-04-01','11:05:00',5.45),('16100','2013-04-01','11:10:00',2.8),('16100','2013-04-01','11:15:00',4.69),('16100','2013-04-01','11:20:00',6.6),('16100','2013-04-01','11:25:00',3.71),('16100','2013-04-01','11:30:00',3.77),('16100','2013-04-01','11:35:00',5.54),('16100','2013-04-01','11:40:00',8.27),('16100','2013-04-01','11:45:00',1.29),('16100','2013-04-01','11:50:00',4.77),('16100','2013-04-01','11:55:00',1.73),('16100','2013-04-01','12:00:00',1.57),('16100','2013-04-01','12:05:00',2.91),('16100','2013-04-01','12:10:00',4.26),('16100','2013-04-01','12:15:00',3.39),('16100','2013-04-01','12:20:00',1.5),('16100','2013-04-01','12:25:00',1.2),('16100','2013-04-01','12:30:00',4.65),('16100','2013-04-01','12:35:00',6.59),('16100','2013-04-01','12:40:00',6.59),('16100','2013-04-01','12:45:00',5.88),('16100','2013-04-01','12:50:00',3.72),('16100','2013-04-01','12:55:00',2.56),('16100','2013-04-01','13:00:00',2.47),('16100','2013-04-01','13:05:00',3.88),('16100','2013-04-01','13:10:00',2.63),('16100','2013-04-01','13:15:00',1.68),('16100','2013-04-01','13:20:00',2.69),('16100','2013-04-01','13:25:00',2.92),('16100','2013-04-01','13:30:00',2.87),('16100','2013-04-01','13:35:00',3.02),('16100','2013-04-01','13:40:00',4.05),('16100','2013-04-01','13:45:00',4),('16100','2013-04-01','13:50:00',1.67),('16100','2013-04-01','13:55:00',3.68),('16100','2013-04-01','14:00:00',5.11),('16100','2013-04-01','14:05:00',4.1),('16100','2013-04-01','14:10:00',5.97),('16100','2013-04-01','14:15:00',5.5),('16100','2013-04-01','14:20:00',3.47),('16100','2013-04-01','14:25:00',2.57),('16100','2013-04-01','14:30:00',2.48),('16100','2013-04-01','14:35:00',1.11),('16100','2013-04-01','14:40:00',1.77),('16100','2013-04-01','14:45:00',1.36),('16100','2013-04-01','14:55:00',1.68),('16100','2013-04-01','15:00:00',1.32),('16100','2013-04-01','15:15:00',1.28),('16100','2013-04-01','15:20:00',1.98),('16100','2013-04-01','15:35:00',1.17),('16100','2013-04-01','15:40:00',1.29),('16100','2013-04-01','15:45:00',1.06),('16100','2013-04-01','15:50:00',1.1),('16100','2013-04-01','15:55:00',2.13),('16100','2013-04-01','16:00:00',1.3),('16100','2013-04-01','16:05:00',1.45),('16100','2013-04-01','16:10:00',1.43),('16100','2013-04-01','16:15:00',1.4),('16100','2013-04-01','16:20:00',1.28),('16100','2013-04-01','16:25:00',1.19),('16100','2013-04-01','16:30:00',1.38),('16100','2013-04-01','16:35:00',1.3),('16100','2013-04-01','16:40:00',1.17),('16100','2013-04-01','17:05:00',1.13),('16100','2013-04-01','17:40:00',1.18),('16100','2013-04-01','17:45:00',2.13),('16100','2014-05-01','07:50:00',1.48),('16100','2014-05-01','07:55:00',1.8),('16100','2014-05-01','08:00:00',1.01),('16100','2014-05-01','08:05:00',1.23),('16100','2014-05-01','08:10:00',1.35),('16100','2014-05-01','08:15:00',1.16),('16100','2014-05-01','08:20:00',1.2),('16100','2014-05-01','08:35:00',1.42),('16100','2014-05-01','08:40:00',1.85),('16100','2014-05-01','08:45:00',1.73),('16100','2014-05-01','08:50:00',1.49),('16100','2014-05-01','08:55:00',1.59),('16100','2014-05-01','09:00:00',1.61),('16100','2014-05-01','09:05:00',1.59),('16100','2014-05-01','09:10:00',1.71),('16100','2014-05-01','09:15:00',2.74),('16100','2014-05-01','09:20:00',2.62),('16100','2014-05-01','09:25:00',2.15),('16100','2014-05-01','09:30:00',2.32),('16100','2014-05-01','09:35:00',3.34),('16100','2014-05-01','09:40:00',3.45),('16100','2014-05-01','09:45:00',2.63),('16100','2014-05-01','09:50:00',2.74),('16100','2014-05-01','09:55:00',2.27),('16100','2014-05-01','10:00:00',1.84),('16100','2014-05-01','10:05:00',1.35),('16100','2014-05-01','10:25:00',1.11),('16100','2014-05-01','10:30:00',1.28),('16100','2014-05-01','10:35:00',1.06),('16100','2014-05-01','10:40:00',1.06),('16100','2014-05-01','10:45:00',1.25),('16100','2014-05-01','10:50:00',1.21),('16100','2014-05-01','10:55:00',1.48),('16100','2014-05-01','11:00:00',1.66),('16100','2014-05-01','11:05:00',1.52),('16100','2014-05-01','11:10:00',1.37),('16100','2014-05-01','11:15:00',1.05),('16100','2014-05-01','12:35:00',1.35),('16100','2014-05-01','12:40:00',1.75),('16100','2014-05-01','12:45:00',2.62),('16100','2014-05-01','12:50:00',2.83),('16100','2014-05-01','12:55:00',3.94),('16100','2014-05-01','13:00:00',4.15),('16100','2014-05-01','13:05:00',3.28),('16100','2014-05-01','13:10:00',4.79),('16100','2014-05-01','13:15:00',4.76),('16100','2014-05-01','13:20:00',3.17),('16100','2014-05-01','13:25:00',3.6),('16100','2014-05-01','13:30:00',6.47),('16100','2014-05-01','13:35:00',5.95),('16100','2014-05-01','13:40:00',4.15),('16100','2014-05-01','13:45:00',4.61),('16100','2014-05-01','13:50:00',4.84),('16100','2014-05-01','13:55:00',2.57),('16100','2014-05-01','14:00:00',3.49),('16100','2014-05-01','14:05:00',5.77),('16100','2014-05-01','14:10:00',7.03),('16100','2014-05-01','14:15:00',4.86),('16100','2014-05-01','14:20:00',5.23),('16100','2014-05-01','14:25:00',4.78),('16100','2014-05-01','14:30:00',5.96),('16100','2014-05-01','14:35:00',2.06),('16100','2014-05-01','14:40:00',1.27),('16100','2014-05-01','14:45:00',1.86),('16100','2014-05-01','14:50:00',1.2),('16100','2014-05-01','14:55:00',1.87),('16100','2014-05-01','15:00:00',1.61),('16100','2014-05-01','15:05:00',2.14),('16100','2014-05-01','15:10:00',2.47),('16100','2014-05-01','15:15:00',2.45),('16100','2014-05-01','15:20:00',3.05),('16100','2014-05-01','15:25:00',3.99),('16100','2014-05-01','15:30:00',2.81),('16100','2014-05-01','15:35:00',4.5),('16100','2014-05-01','15:40:00',3.3),('16100','2014-05-01','15:45:00',1.48),('16100','2014-05-01','15:50:00',1.54),('16100','2014-05-01','15:55:00',3.72),('16100','2014-05-01','16:00:00',2.87),('16100','2014-05-01','16:05:00',1.79),('16100','2014-05-01','16:10:00',2.73),('16100','2014-05-01','16:15:00',2.58),('16100','2014-05-01','16:20:00',1.48),('16100','2014-05-01','16:25:00',1.71),('16100','2014-05-01','16:30:00',1.64),('16100','2014-05-01','16:35:00',1.06),('16100','2014-05-01','16:45:00',1.66),('16100','2014-05-01','16:50:00',1.52),('16100','2014-05-01','16:55:00',1.54),('16100','2014-05-01','17:00:00',1.36),('16100','2014-05-01','17:05:00',1.17),('16100','2014-05-01','17:10:00',1.16),('16100','2014-05-01','17:15:00',1.1),('16100','2014-03-26','07:55:00',1.25),('16100','2014-03-26','08:00:00',1.49),('16100','2014-03-26','08:05:00',1.58),('16100','2014-03-26','08:10:00',1.06),('16100','2014-03-26','09:10:00',1.28),('16100','2014-03-26','09:15:00',1.47),('16100','2014-03-26','09:20:00',1.39),('16100','2014-03-26','09:25:00',1.76),('16100','2014-03-26','09:30:00',1.68),('16100','2014-03-26','09:35:00',1.23),('16100','2014-03-26','10:00:00',1.2),('16100','2014-03-26','10:05:00',1.91),('16100','2014-03-26','10:10:00',2.32),('16100','2014-03-26','10:15:00',2.42),('16100','2014-03-26','10:20:00',2.47),('16100','2014-03-26','10:25:00',2.1),('16100','2014-03-26','10:30:00',1.66),('16100','2014-03-26','10:35:00',2.27),('16100','2014-03-26','10:40:00',2.55),('16100','2014-03-26','10:45:00',4.7),('16100','2014-03-26','10:50:00',4.38),('16100','2014-03-26','10:55:00',1.89),('16100','2014-03-26','11:00:00',1.05),('16100','2014-03-26','11:05:00',1.92),('16100','2014-03-26','11:10:00',6.14),('16100','2014-03-26','11:15:00',2.77),('16100','2014-03-26','11:20:00',1.28),('16100','2014-03-26','11:50:00',1.77),('16100','2014-03-26','11:55:00',6.28),('16100','2014-03-26','12:00:00',6.83),('16100','2014-03-26','12:05:00',1.88),('16100','2014-03-26','12:10:00',1.04),('16100','2014-03-26','12:45:00',1.15),('16100','2014-03-26','12:50:00',1.31),('16100','2014-03-26','12:55:00',1.68),('16100','2014-03-26','13:00:00',1.93),('16100','2014-03-26','13:05:00',2.26),('16100','2014-03-26','13:10:00',3.08),('16100','2014-03-26','13:15:00',4.67),('16100','2014-03-26','13:20:00',4.32),('16100','2014-03-26','13:25:00',4.76),('16100','2014-03-26','13:30:00',4.13),('16100','2014-03-26','13:35:00',4.56),('16100','2014-03-26','13:40:00',4.38),('16100','2014-03-26','13:45:00',4.03),('16100','2014-03-26','13:50:00',3.52),('16100','2014-03-26','13:55:00',2.96),('16100','2014-03-26','14:00:00',2.84),('16100','2014-03-26','14:05:00',4.04),('16100','2014-03-26','14:10:00',4.41),('16100','2014-03-26','14:15:00',1.4),('16100','2014-03-26','14:20:00',2.16),('16100','2014-03-26','14:25:00',5.64),('16100','2014-03-26','14:30:00',3.78),('16100','2014-03-26','14:35:00',2.15),('16100','2014-03-26','14:40:00',1.8),('16100','2014-03-26','14:45:00',2.63),('16100','2014-03-26','14:50:00',2.9),('16100','2014-03-26','14:55:00',2.97),('16100','2014-03-26','15:00:00',2.46),('16100','2014-03-26','15:05:00',1.04),('16100','2014-03-26','15:35:00',2.25),('16100','2014-03-26','15:40:00',5.29),('16100','2014-03-26','15:45:00',6),('16100','2014-03-26','15:50:00',1.85),('16100','2014-03-26','16:20:00',1.15),('16100','2014-03-26','16:25:00',2.29),('16100','2014-03-26','16:30:00',1.23),('16100','2014-03-26','16:40:00',1.03),('16100','2014-03-26','16:45:00',2.63),('16100','2014-03-26','16:50:00',2.84),('16100','2014-03-26','16:55:00',1.29),('16100','2013-03-31','08:15:00',1.34),('16100','2013-03-31','08:20:00',1.62),('16100','2013-03-31','08:25:00',1.99),('16100','2013-03-31','08:30:00',2.69),('16100','2013-03-31','08:35:00',3.26),('16100','2013-03-31','08:40:00',2.47),('16100','2013-03-31','08:45:00',1.16),('16100','2013-03-31','08:55:00',2.63),('16100','2013-03-31','09:00:00',3.27),('16100','2013-03-31','09:05:00',3.49),('16100','2013-03-31','09:10:00',3.73),('16100','2013-03-31','09:15:00',3.79),('16100','2013-03-31','09:20:00',3.59),('16100','2013-03-31','09:25:00',3.89),('16100','2013-03-31','09:30:00',2.33),('16100','2013-03-31','09:35:00',2.32),('16100','2013-03-31','09:40:00',5.08),('16100','2013-03-31','09:45:00',5.36),('16100','2013-03-31','09:50:00',4.87),('16100','2013-03-31','09:55:00',4.93),('16100','2013-03-31','10:00:00',3.57),('16100','2013-03-31','10:05:00',5.99),('16100','2013-03-31','10:10:00',4.26),('16100','2013-03-31','10:15:00',4.64),('16100','2013-03-31','10:20:00',5.3),('16100','2013-03-31','10:25:00',6.2),('16100','2013-03-31','10:30:00',5.12),('16100','2013-03-31','10:35:00',5.61),('16100','2013-03-31','10:40:00',6.89),('16100','2013-03-31','10:45:00',4.14),('16100','2013-03-31','10:50:00',4.74),('16100','2013-03-31','10:55:00',8.39),('16100','2013-03-31','11:00:00',3.89),('16100','2013-03-31','11:05:00',5.64),('16100','2013-03-31','11:10:00',6.56),('16100','2013-03-31','11:15:00',4.26),('16100','2013-03-31','11:20:00',2.47),('16100','2013-03-31','11:25:00',2.44),('16100','2013-03-31','11:30:00',2.41),('16100','2013-03-31','11:35:00',2.55),('16100','2013-03-31','11:40:00',3.15),('16100','2013-03-31','11:45:00',2.56),('16100','2013-03-31','11:50:00',2.99),('16100','2013-03-31','11:55:00',3.96),('16100','2013-03-31','12:00:00',4.19),('16100','2013-03-31','12:05:00',4.14),('16100','2013-03-31','12:10:00',3.95),('16100','2013-03-31','12:15:00',3.53),('16100','2013-03-31','12:20:00',3.37),('16100','2013-03-31','12:55:00',5.01),('16100','2013-03-31','13:00:00',4.69),('16100','2013-03-31','13:05:00',5.28),('16100','2013-03-31','13:10:00',5.16),('16100','2013-03-31','13:15:00',5.11),('16100','2013-03-31','13:20:00',4.86),('16100','2013-03-31','13:25:00',3.93),('16100','2013-03-31','13:30:00',4.04),('16100','2013-03-31','13:35:00',3.87),('16100','2013-03-31','13:40:00',4.28),('16100','2013-03-31','13:45:00',5.27),('16100','2013-03-31','13:50:00',6.83),('16100','2013-03-31','13:55:00',6.06),('16100','2013-03-31','14:00:00',3.86),('16100','2013-03-31','14:05:00',3.03),('16100','2013-03-31','14:10:00',3.38),('16100','2013-03-31','14:15:00',4.26),('16100','2013-03-31','14:20:00',5.16),('16100','2013-03-31','14:25:00',7.26),('16100','2013-03-31','14:30:00',7.16),('16100','2013-03-31','14:35:00',2.52),('16100','2013-03-31','14:40:00',2.71),('16100','2013-03-31','14:45:00',4.84),('16100','2013-03-31','14:50:00',5.08),('16100','2013-03-31','14:55:00',3.69),('16100','2013-03-31','15:00:00',3.35),('16100','2013-03-31','15:05:00',3.03),('16100','2013-03-31','15:10:00',3.51),('16100','2013-03-31','15:15:00',3.71),('16100','2013-03-31','15:20:00',4.01),('16100','2013-03-31','15:25:00',4.8),('16100','2013-03-31','15:30:00',3.93),('16100','2013-03-31','15:35:00',4.63),('16100','2013-03-31','15:40:00',3.33),('16100','2013-03-31','15:45:00',4.35),('16100','2013-03-31','15:50:00',5.2),('16100','2013-03-31','15:55:00',3.97),('16100','2013-03-31','16:00:00',3.39),('16100','2013-03-31','16:05:00',2.7),('16100','2013-03-31','16:10:00',2.24),('16100','2013-03-31','16:15:00',1.44),('16100','2013-03-31','16:20:00',1.48),('16100','2013-03-31','16:25:00',1.39),('16100','2013-03-30','08:10:00',1.02),('16100','2013-03-30','08:20:00',1.01),('16100','2013-03-30','08:25:00',1.18),('16100','2013-03-30','08:40:00',1.09),('16100','2013-03-30','08:45:00',1.36),('16100','2013-03-30','08:50:00',1.74),('16100','2013-03-30','08:55:00',1.22),('16100','2013-03-30','09:00:00',1.63),('16100','2013-03-30','09:05:00',2.06),('16100','2013-03-30','09:10:00',2.83),('16100','2013-03-30','09:15:00',1.71),('16100','2013-03-30','09:20:00',1.62),('16100','2013-03-30','09:25:00',2.68),('16100','2013-03-30','09:30:00',2.46),('16100','2013-03-30','09:35:00',1.39),('16100','2013-03-30','09:40:00',1.89),('16100','2013-03-30','09:45:00',3.84),('16100','2013-03-30','09:50:00',2.38),('16100','2013-03-30','10:00:00',1.06),('16100','2013-03-30','10:05:00',1.22),('16100','2013-03-30','10:10:00',2.51),('16100','2013-03-30','10:15:00',3.71),('16100','2013-03-30','10:20:00',5.18),('16100','2013-03-30','10:25:00',3.56),('16100','2013-03-30','10:30:00',3.09),('16100','2013-03-30','10:35:00',3.53),('16100','2013-03-30','10:40:00',1.03),('16100','2013-03-30','10:45:00',1.02),('16100','2013-03-30','10:50:00',3.74),('16100','2013-03-30','10:55:00',4.01),('16100','2013-03-30','11:00:00',4.05),('16100','2013-03-30','11:05:00',6.76),('16100','2013-03-30','11:10:00',2.26),('16100','2013-03-30','11:15:00',1.69),('16100','2013-03-30','11:20:00',1.76),('16100','2013-03-30','11:25:00',2.44),('16100','2013-03-30','11:30:00',3.68),('16100','2013-03-30','11:35:00',5.04),('16100','2013-03-30','11:40:00',3.97),('16100','2013-03-30','11:45:00',5.02),('16100','2013-03-30','11:50:00',2.63),('16100','2013-03-30','11:55:00',2.14),('16100','2013-03-30','12:00:00',1.77),('16100','2013-03-30','12:05:00',1.33),('16100','2013-03-30','12:10:00',1.25),('16100','2013-03-30','12:15:00',1),('16100','2013-03-30','12:25:00',1.6),('16100','2013-03-30','12:30:00',2.95),('16100','2013-03-30','12:35:00',5.21),('16100','2013-03-30','12:40:00',5.35),('16100','2013-03-30','12:45:00',5.46),('16100','2013-03-30','12:50:00',2.66),('16100','2013-03-30','12:55:00',4.14),('16100','2013-03-30','13:00:00',5.11),('16100','2013-03-30','13:05:00',3.64),('16100','2013-03-30','13:10:00',2.66),('16100','2013-03-30','13:15:00',5.96),('16100','2013-03-30','13:20:00',7.55),('16100','2013-03-30','13:25:00',3.86),('16100','2013-03-30','13:30:00',2.58),('16100','2013-03-30','13:35:00',3),('16100','2013-03-30','13:40:00',3.02),('16100','2013-03-30','13:45:00',3.64),('16100','2013-03-30','13:50:00',4.38),('16100','2013-03-30','13:55:00',5.64),('16100','2013-03-30','14:00:00',4.06),('16100','2013-03-30','14:05:00',2.8),('16100','2013-03-30','14:10:00',5.77),('16100','2013-03-30','14:15:00',5.86),('16100','2013-03-30','14:20:00',3.78),('16100','2013-03-30','14:25:00',4.44),('16100','2013-03-30','14:30:00',4.33),('16100','2013-03-30','14:35:00',3.64),('16100','2013-03-30','14:40:00',6.1),('16100','2013-03-30','14:45:00',6.29),('16100','2013-03-30','14:50:00',5.26),('16100','2013-03-30','14:55:00',4.06),('16100','2013-03-30','15:00:00',5.78),('16100','2013-03-30','15:05:00',5.33),('16100','2013-03-30','15:10:00',6.18),('16100','2013-03-30','15:15:00',6.98),('16100','2013-03-30','15:20:00',8.58),('16100','2013-03-30','15:25:00',4.93),('16100','2013-03-30','15:30:00',4.86),('16100','2013-03-30','15:35:00',5.05),('16100','2013-03-30','15:40:00',3.86),('16100','2013-03-30','15:45:00',3.86),('16100','2013-03-30','15:50:00',1.52),('16100','2013-03-30','15:55:00',1.19),('16100','2013-03-30','16:00:00',1.61),('16100','2013-03-30','16:15:00',1.65),('16100','2013-03-30','16:20:00',3.45),('16100','2013-03-30','16:25:00',1.86),('16100','2013-03-30','16:30:00',1.82),('16100','2013-03-30','16:35:00',2.74),('16100','2013-03-30','16:40:00',1.94),('16100','2013-03-30','16:45:00',1.49),('16100','2013-03-30','16:50:00',1.29),('16100','2013-03-30','16:55:00',1.91),('16100','2013-03-30','17:00:00',3),('16100','2013-03-30','17:05:00',2.26),('16100','2013-03-30','17:10:00',1.04),('16100','2013-03-30','17:25:00',1.14),('16100','2013-03-30','17:30:00',1.8),('16100','2013-03-30','17:35:00',1.65),('16100','2013-03-30','17:40:00',1.28),('16100','2013-03-30','17:45:00',2.67),('16100','2013-03-30','17:50:00',3.02),('16100','2013-03-30','17:55:00',2.29),('16100','2013-03-30','18:10:00',1.32),('16100','2013-03-30','18:15:00',2.05),('16100','2013-03-30','18:25:00',1.21),('16100','2013-03-29','08:10:00',1.16),('16100','2013-03-29','08:15:00',1.2),('16100','2013-03-29','08:20:00',1.27),('16100','2013-03-29','08:25:00',1.42),('16100','2013-03-29','08:30:00',1.36),('16100','2013-03-29','08:35:00',1.59),('16100','2013-03-29','08:40:00',1.49),('16100','2013-03-29','09:00:00',1.68),('16100','2013-03-29','09:05:00',2.32),('16100','2013-03-29','09:10:00',3.53),('16100','2013-03-29','09:15:00',2.74),('16100','2013-03-29','09:20:00',3.15),('16100','2013-03-29','09:25:00',3.19),('16100','2013-03-29','09:30:00',3.44),('16100','2013-03-29','09:35:00',1.9),('16100','2013-03-29','09:40:00',1.63),('16100','2013-03-29','09:45:00',2.26),('16100','2013-03-29','09:50:00',2.33),('16100','2013-03-29','09:55:00',3.7),('16100','2013-03-29','10:00:00',3.39),('16100','2013-03-29','10:05:00',2.96),('16100','2013-03-29','10:10:00',2.87),('16100','2013-03-29','10:15:00',2.07),('16100','2013-03-29','10:50:00',3.48),('16100','2013-03-29','10:55:00',4.12),('16100','2013-03-29','11:00:00',4.7),('16100','2013-03-29','11:05:00',4.69),('16100','2013-03-29','11:10:00',4.06),('16100','2013-03-29','11:15:00',3.24),('16100','2013-03-29','11:20:00',6.2),('16100','2013-03-29','11:25:00',6.28),('16100','2013-03-29','11:30:00',5.2),('16100','2013-03-29','11:35:00',4.67),('16100','2013-03-29','11:40:00',5.89),('16100','2013-03-29','11:45:00',5.43),('16100','2013-03-29','11:50:00',5.53),('16100','2013-03-29','11:55:00',5.05),('16100','2013-03-29','12:00:00',4.16),('16100','2013-03-29','12:05:00',3.09),('16100','2013-03-29','12:10:00',3.02),('16100','2013-03-29','12:15:00',2.06),('16100','2013-03-29','12:20:00',1.83),('16100','2013-03-29','12:25:00',1.96),('16100','2013-03-29','12:30:00',1.91),('16100','2013-03-29','12:35:00',1.82),('16100','2013-03-29','13:05:00',6.68),('16100','2013-03-29','13:10:00',3.34),('16100','2013-03-29','13:15:00',3.26),('16100','2013-03-29','13:20:00',5.45),('16100','2013-03-29','13:55:00',3.85),('16100','2013-03-29','14:00:00',3.94),('16100','2013-03-29','14:05:00',2.78),('16100','2013-03-29','14:10:00',3.98),('16100','2013-03-29','14:15:00',4.06),('16100','2013-03-29','14:20:00',2.97),('16100','2013-03-29','14:25:00',2.99),('16100','2013-03-29','14:30:00',2.09),('16100','2013-03-29','14:35:00',1.55),('16100','2013-03-29','14:40:00',1.18),('16100','2013-03-29','14:45:00',1.76),('16100','2013-03-29','14:50:00',1.83),('16100','2013-03-29','14:55:00',1.53),('16100','2013-03-29','15:00:00',1.36),('16100','2013-03-29','15:05:00',1.03),('16100','2013-03-29','15:15:00',1.03),('16100','2013-03-28','07:10:00',1),('16100','2013-03-28','07:15:00',1.17),('16100','2013-03-28','07:20:00',1.55),('16100','2013-03-28','07:35:00',1.5),('16100','2013-03-28','07:40:00',2.13),('16100','2013-03-28','07:46:00',1.94),('16100','2013-03-28','07:50:00',2.82),('16100','2013-03-28','07:55:00',1.79),('16100','2013-03-28','08:05:00',1.54),('16100','2013-03-28','08:10:00',3.62),('16100','2013-03-28','08:15:00',3.88),('16100','2013-03-28','08:20:00',3.77),('16100','2013-03-28','08:25:00',3.98),('16100','2013-03-28','08:30:00',4.15),('16100','2013-03-28','08:35:00',4.31),('16100','2013-03-28','08:40:00',4.26),('16100','2013-03-28','08:45:00',4.4),('16100','2013-03-28','08:50:00',4.18),('16100','2013-03-28','08:55:00',4.48),('16100','2013-03-28','09:00:00',4.55),('16100','2013-03-28','09:05:00',4.7),('16100','2013-03-28','09:10:00',5.37),('16100','2013-03-28','09:15:00',5.59),('16100','2013-03-28','09:20:00',4.84),('16100','2013-03-28','09:25:00',5.57),('16100','2013-03-28','09:30:00',5.76),('16100','2013-03-28','09:35:00',5.57),('16100','2013-03-28','09:40:00',5.04),('16100','2013-03-28','09:45:00',5.34),('16100','2013-03-28','09:50:00',5.42),('16100','2013-03-28','09:55:00',5.68),('16100','2013-03-28','10:00:00',5.52),('16100','2013-03-28','10:05:00',4.56),('16100','2013-03-28','10:10:00',5.65),('16100','2013-03-28','10:15:00',5.64),('16100','2013-03-28','10:20:00',5.7),('16100','2013-03-28','10:25:00',5.41),('16100','2013-03-28','10:30:00',5.84),('16100','2013-03-28','10:35:00',6.42),('16100','2013-03-28','10:40:00',6.15),('16100','2013-03-28','10:45:00',5.89),('16100','2013-03-28','10:50:00',6.06),('16100','2013-03-28','10:55:00',7.44),('16100','2013-03-28','11:00:00',7.35),('16100','2013-03-28','11:05:00',7.53),('16100','2013-03-28','11:10:00',8.5),('16100','2013-03-28','11:15:00',8.14),('16100','2013-03-28','11:20:00',8.05),('16100','2013-03-28','11:25:00',8.17),('16100','2013-03-28','11:30:00',8.08),('16100','2013-03-28','11:35:00',7.97),('16100','2013-03-28','11:40:00',7.93),('16100','2013-03-28','11:45:00',8.13),('16100','2013-03-28','11:50:00',8.05),('16100','2013-03-28','11:55:00',8.12),('16100','2013-03-28','12:00:00',8.24),('16100','2013-03-28','12:05:00',8.33),('16100','2013-03-28','12:10:00',7.48),('16100','2013-03-28','12:15:00',8.03),('16100','2013-03-28','12:20:00',7.82),('16100','2013-03-28','12:25:00',7.57),('16100','2013-03-28','12:30:00',7.85),('16100','2013-03-28','12:35:00',8.08),('16100','2013-03-28','12:40:00',7.44),('16100','2013-03-28','12:45:00',8.15),('16100','2013-03-28','12:50:00',7.66),('16100','2013-03-28','12:55:00',7.59),('16100','2013-03-28','13:00:00',6.99),('16100','2013-03-28','13:05:00',5.15),('16100','2013-03-28','13:10:00',5.65),('16100','2013-03-28','13:15:00',7.27),('16100','2013-03-28','13:20:00',8.47),('16100','2013-03-28','13:25:00',8.06),('16100','2013-03-28','13:30:00',6.58),('16100','2013-03-28','13:35:00',6.37),('16100','2013-03-28','13:40:00',6.11),('16100','2013-03-28','13:45:00',6.55),('16100','2013-03-28','13:50:00',6.06),('16100','2013-03-28','13:55:00',6.66),('16100','2013-03-28','14:00:00',6.43),('16100','2013-03-28','14:05:00',4.97),('16100','2013-03-28','14:10:00',4.51),('16100','2013-03-28','14:15:00',4.24),('16100','2013-03-28','14:20:00',4.26),('16100','2013-03-28','14:25:00',3.82),('16100','2013-03-28','14:30:00',3.51),('16100','2013-03-28','14:35:00',3.3),('16100','2013-03-28','14:40:00',3.37),('16100','2013-03-28','14:45:00',3.09),('16100','2013-03-28','14:50:00',2.96),('16100','2013-03-28','14:55:00',2.74),('16100','2013-03-28','15:00:00',2.51),('16100','2013-03-28','15:05:00',2.58),('16100','2013-03-28','15:10:00',2.43),('16100','2013-03-28','15:15:00',2.41),('16100','2013-03-28','15:20:00',2.13),('16100','2013-03-28','15:25:00',1.91),('16100','2013-03-28','15:30:00',1.8),('16100','2013-03-28','15:35:00',1.7),('16100','2013-03-28','15:40:00',1.63),('16100','2013-03-28','15:45:00',1.71),('16100','2013-03-28','15:50:00',1.97),('16100','2013-03-28','15:55:00',2.16),('16100','2013-03-28','16:00:00',2.16),('16100','2013-03-28','16:05:00',1.98),('16100','2013-03-28','16:10:00',1.74),('16100','2013-03-28','16:15:00',1.55),('16100','2013-03-28','16:20:00',1.5),('16100','2013-03-28','16:25:00',2.25),('16100','2013-03-28','16:30:00',1.71),('16100','2013-03-28','16:35:00',2.65),('16100','2013-03-28','16:40:00',3.38),('16100','2013-03-28','16:45:00',2.43),('16100','2013-03-28','16:50:00',1.74),('16100','2013-03-28','16:55:00',1.86),('16100','2013-03-28','17:00:00',2.65),('16100','2013-03-28','17:05:00',1.77),('16100','2013-03-28','17:10:00',1.12),('16100','2013-03-28','17:15:00',1.29),('16100','2013-03-28','17:20:00',1.81),('16100','2013-03-28','17:25:00',1.47),('16100','2013-03-28','17:30:00',1.5),('16100','2013-03-27','09:10:00',1.66),('16100','2013-03-27','09:15:00',1.96),('16100','2013-03-27','09:20:00',2.51),('16100','2013-03-27','09:25:00',2.89),('16100','2013-03-27','09:30:00',2.24),('16100','2013-03-27','09:45:00',1.05),('16100','2013-03-27','09:55:00',1.28),('16100','2013-03-27','10:00:00',1.62),('16100','2013-03-27','10:15:00',1.01),('16100','2013-03-27','11:00:00',1.22),('16100','2013-03-27','11:05:00',1.4),('16100','2013-03-27','12:05:00',1.01),('16100','2013-03-27','13:00:00',1.13),('16100','2013-03-27','13:05:00',1.77),('16100','2013-03-27','13:10:00',1.57),('16100','2013-03-27','13:15:00',1.83),('16100','2013-03-27','13:20:00',1.82),('16100','2013-03-27','13:25:00',3.27),('16100','2013-03-27','13:30:00',2.52),('16100','2013-03-27','13:35:00',4),('16100','2013-03-27','13:40:00',1.52),('16100','2013-03-27','13:45:00',1.66),('16100','2013-03-27','13:50:00',1.67),('16100','2013-03-27','13:55:00',1.23),('16100','2013-03-27','14:00:00',1),('16100','2013-03-27','14:05:00',3.79),('16100','2013-03-27','14:10:00',4.74),('16100','2013-03-27','14:15:00',4.34),('16100','2013-03-27','14:20:00',3.72),('16100','2013-03-27','14:25:00',2.21),('16100','2013-03-27','14:30:00',2.01),('16100','2013-03-27','14:35:00',2.27),('16100','2013-03-27','14:40:00',2.01),('16100','2013-03-27','14:45:00',1.85),('16100','2013-03-27','14:55:00',1.14),('16100','2013-03-27','15:00:00',1.55),('16100','2013-03-27','15:05:00',2.16),('16100','2013-03-27','15:10:00',3.31),('16100','2013-03-27','15:15:00',6.09),('16100','2013-03-27','15:20:00',6.6),('16100','2013-03-27','15:25:00',4.49),('16100','2013-03-27','15:30:00',2.33),('16100','2013-03-27','15:35:00',1.15),('16100','2013-03-27','15:40:00',1.09),('16100','2013-03-27','15:45:00',2.67),('16100','2013-03-27','15:50:00',2.03),('16100','2013-03-27','15:55:00',1.79),('16100','2013-03-27','16:00:00',1.34),('16100','2013-03-27','16:05:00',1.8),('16100','2013-03-27','16:10:00',1.54),('16100','2013-03-27','16:15:00',1.22),('16100','2013-03-27','16:25:00',1.24),('16100','2013-03-27','16:40:00',2.36),('16100','2013-03-27','16:45:00',2.22),('16100','2013-03-27','16:50:00',1.26),('16100','2013-03-27','16:55:00',1.52),('16100','2013-03-27','17:00:00',1.95),('16100','2013-03-27','17:05:00',2.32),('16100','2013-03-27','17:10:00',1.23),('16100','2013-03-27','17:15:00',1.57),('16100','2013-03-27','17:20:00',1.19),('16100','2013-03-26','07:00:00',1.13),('16100','2013-03-26','07:15:00',1.41),('16100','2013-03-26','07:20:00',1.35),('16100','2013-03-26','07:25:00',1.49),('16100','2013-03-26','07:30:00',1.72),('16100','2013-03-26','07:35:00',1.91),('16100','2013-03-26','07:40:00',2.14),('16100','2013-03-26','07:45:00',2.4),('16100','2013-03-26','07:50:00',3.33),('16100','2013-03-26','07:55:00',3.33),('16100','2013-03-26','08:00:00',2.06),('16100','2013-03-26','08:05:00',1.75),('16100','2013-03-26','08:10:00',1.81),('16100','2013-03-26','08:15:00',1.98),('16100','2013-03-26','08:20:00',1.92),('16100','2013-03-26','08:25:00',3.08),('16100','2013-03-26','08:30:00',3.05),('16100','2013-03-26','08:35:00',3.84),('16100','2013-03-26','08:40:00',2.89),('16100','2013-03-26','08:45:00',5.15),('16100','2013-03-26','08:50:00',3.16),('16100','2013-03-26','08:55:00',4.71),('16100','2013-03-26','09:00:00',2.47),('16100','2013-03-26','09:05:00',2.22),('16100','2013-03-26','09:10:00',3.03),('16100','2013-03-26','09:15:00',2.95),('16100','2013-03-26','09:20:00',1.72),('16100','2013-03-26','09:25:00',1.82),('16100','2013-03-26','09:30:00',2.85),('16100','2013-03-26','09:35:00',3.05),('16100','2013-03-26','09:40:00',2.08),('16100','2013-03-26','09:45:00',1.67),('16100','2013-03-26','09:50:00',3.12),('16100','2013-03-26','09:55:00',3.87),('16100','2013-03-26','10:00:00',4.63),('16100','2013-03-26','10:05:00',2.3),('16100','2013-03-26','10:10:00',3.34),('16100','2013-03-26','10:15:00',4.86),('16100','2013-03-26','10:20:00',8.76),('16100','2013-03-26','10:25:00',6.19),('16100','2013-03-26','10:30:00',3.77),('16100','2013-03-26','10:35:00',4.45),('16100','2013-03-26','10:40:00',3.2),('16100','2013-03-26','10:45:00',2.79),('16100','2013-03-26','10:50:00',3.07),('16100','2013-03-26','10:55:00',2.65),('16100','2013-03-26','11:00:00',2.45),('16100','2013-03-26','11:05:00',2.52),('16100','2013-03-26','11:10:00',2.05),('16100','2013-03-26','11:15:00',1.91),('16100','2013-03-26','11:20:00',1.97),('16100','2013-03-26','11:25:00',4.65),('16100','2013-03-26','11:30:00',5.82),('16100','2013-03-26','11:35:00',4.01),('16100','2013-03-26','11:40:00',2.85),('16100','2013-03-26','11:45:00',2.76),('16100','2013-03-26','11:50:00',3.83),('16100','2013-03-26','11:55:00',4.27),('16100','2013-03-26','12:00:00',4.04),('16100','2013-03-26','12:05:00',4.74),('16100','2013-03-26','12:10:00',4.47),('16100','2013-03-26','12:15:00',4.1),('16100','2013-03-26','12:20:00',2.48),('16100','2013-03-26','12:25:00',3.24),('16100','2013-03-26','12:30:00',3.17),('16100','2013-03-26','12:35:00',2.44),('16100','2013-03-26','12:40:00',2.82),('16100','2013-03-26','12:45:00',3.22),('16100','2013-03-26','12:50:00',4.07),('16100','2013-03-26','12:55:00',4.11),('16100','2013-03-26','13:00:00',4.34),('16100','2013-03-26','13:05:00',3.29),('16100','2013-03-26','13:10:00',3.31),('16100','2013-03-26','13:15:00',3.22),('16100','2013-03-26','13:20:00',2.67),('16100','2013-03-26','13:25:00',2.54),('16100','2013-03-26','13:30:00',2.75),('16100','2013-03-26','13:35:00',3.33),('16100','2013-03-26','13:40:00',3.53),('16100','2013-03-26','13:45:00',3.6),('16100','2013-03-26','13:50:00',2.81),('16100','2013-03-26','13:55:00',2.42),('16100','2013-03-26','14:00:00',2.32),('16100','2013-03-26','14:05:00',2.6),('16100','2013-03-26','14:10:00',2.78),('16100','2013-03-26','14:15:00',3.15),('16100','2013-03-26','14:20:00',2.75),('16100','2013-03-26','14:25:00',2.65),('16100','2013-03-26','14:30:00',2.11),('16100','2013-03-26','14:35:00',1.97),('16100','2013-03-26','14:40:00',2.24),('16100','2013-03-26','14:45:00',2.13),('16100','2013-03-26','14:50:00',2.5),('16100','2013-03-26','14:55:00',2.15),('16100','2013-03-26','15:00:00',1.51),('16100','2013-03-26','15:05:00',1.24),('16100','2013-03-26','15:10:00',1.31),('16100','2013-03-26','15:15:00',1.44),('16100','2013-03-26','15:20:00',1.86),('16100','2013-03-26','15:25:00',1.91),('16100','2013-03-26','15:30:00',1.32),('16100','2013-03-26','15:35:00',1.12),('16100','2013-03-26','15:40:00',1.55),('16100','2013-03-26','15:45:00',1.17),('16100','2013-03-26','16:05:00',1.28),('16100','2013-03-26','16:10:00',1.46),('16100','2013-03-26','16:15:00',1.47),('16100','2013-03-26','16:20:00',2.09),('16100','2013-03-26','16:25:00',1.86),('16100','2013-03-26','16:30:00',1.98),('16100','2013-03-26','16:35:00',1.82),('16100','2013-03-26','16:40:00',2.57),('16100','2013-03-26','16:45:00',1.57),('16100','2013-03-26','16:50:00',1.56),('16100','2013-03-26','16:55:00',1.82),('16100','2013-03-26','17:00:00',2.28),('16100','2013-03-26','17:05:00',2.38),('16100','2013-03-26','17:10:00',1.11),('16100','2013-03-25','07:40:00',1.25),('16100','2013-03-25','07:45:00',1.77),('16100','2013-03-25','07:50:00',2.2),('16100','2013-03-25','07:55:00',1.33),('16100','2013-03-25','08:00:00',1.09),('16100','2013-03-25','08:10:00',1.12),('16100','2013-03-25','08:15:00',1.25),('16100','2013-03-25','08:20:00',1.23),('16100','2013-03-25','08:25:00',1.2),('16100','2013-03-25','08:30:00',1.57),('16100','2013-03-25','08:35:00',1.59),('16100','2013-03-25','08:40:00',1.56),('16100','2013-03-25','08:45:00',1.18),('16100','2013-03-25','08:50:00',1.25),('16100','2013-03-25','08:55:00',1.19),('16100','2013-03-25','09:00:00',1.48),('16100','2013-03-25','09:05:00',1.52),('16100','2013-03-25','09:10:00',2.44),('16100','2013-03-25','09:15:00',2.32),('16100','2013-03-25','09:20:00',1.14),('16100','2013-03-25','09:50:00',1.53),('16100','2013-03-25','09:55:00',1.18),('16100','2013-03-25','10:00:00',1.18),('16100','2013-03-25','10:05:00',2.18),('16100','2013-03-25','10:10:00',1.6),('16100','2013-03-25','10:30:00',1.34),('16100','2013-03-25','10:35:00',1.6),('16100','2013-03-25','10:40:00',1.51),('16100','2013-03-25','10:45:00',1.74),('16100','2013-03-25','10:50:00',2.13),('16100','2013-03-25','10:55:00',3.06),('16100','2013-03-25','11:00:00',3.66),('16100','2013-03-25','11:05:00',2.07),('16100','2013-03-25','11:40:00',1.43),('16100','2013-03-25','11:45:00',3.13),('16100','2013-03-25','11:50:00',4.39),('16100','2013-03-25','11:55:00',7.9),('16100','2013-03-25','12:00:00',3.44),('16100','2013-03-25','12:05:00',2.11),('16100','2013-03-25','12:10:00',2.11),('16100','2013-03-25','12:15:00',2.38),('16100','2013-03-25','12:20:00',4.05),('16100','2013-03-25','12:25:00',6.61),('16100','2013-03-25','12:30:00',5.72),('16100','2013-03-25','12:35:00',4.73),('16100','2013-03-25','12:40:00',2.15),('16100','2013-03-25','12:45:00',2.27),('16100','2013-03-25','12:50:00',3.11),('16100','2013-03-25','12:55:00',2.43),('16100','2013-03-25','13:00:00',2.31),('16100','2013-03-25','13:05:00',3.43),('16100','2013-03-25','13:10:00',2.98),('16100','2013-03-25','13:15:00',2.04),('16100','2013-03-25','13:20:00',3.25),('16100','2013-03-25','13:25:00',3.09),('16100','2013-03-25','13:30:00',2.44),('16100','2013-03-25','13:35:00',2.36),('16100','2013-03-25','13:40:00',3.59),('16100','2013-03-25','13:45:00',4.35),('16100','2013-03-25','13:50:00',2.66),('16100','2013-03-25','13:55:00',2.03),('16100','2013-03-25','14:00:00',2.19),('16100','2013-03-25','14:05:00',2.38),('16100','2013-03-25','14:10:00',2.83),('16100','2013-03-25','14:15:00',2.13),('16100','2013-03-25','14:20:00',1.93),('16100','2013-03-25','14:25:00',1.82),('16100','2013-03-25','14:30:00',1.86),('16100','2013-03-25','14:35:00',1.87),('16100','2013-03-25','14:40:00',1.86),('16100','2013-03-25','14:45:00',1.6),('16100','2013-03-25','14:50:00',1.32),('16100','2013-03-25','14:55:00',1.16),('16100','2013-03-25','15:00:00',1.29),('16100','2013-03-25','15:05:00',1.49),('16100','2013-03-25','15:10:00',1.31),('16100','2013-03-25','15:15:00',1.15),('16100','2013-03-25','15:20:00',1.19),('16100','2013-03-25','15:25:00',1.26),('16100','2013-03-25','15:30:00',1.52),('16100','2013-03-25','15:35:00',1.36),('16100','2013-03-24','08:15:00',1.07),('16100','2013-03-24','08:50:00',1.82),('16100','2013-03-24','08:55:00',1.5),('16100','2013-03-24','09:20:00',1.21),('16100','2013-03-24','09:25:00',2.19),('16100','2013-03-24','09:30:00',3.73),('16100','2013-03-24','09:35:00',2.12),('16100','2013-03-24','09:40:00',1.9),('16100','2013-03-24','09:45:00',1.74),('16100','2013-03-24','09:50:00',1.64),('16100','2013-03-24','09:55:00',1.86),('16100','2013-03-24','10:00:00',1.53),('16100','2013-03-24','10:05:00',1.58),('16100','2013-03-24','10:10:00',2.86),('16100','2013-03-24','10:15:00',3.58),('16100','2013-03-24','10:20:00',2.23),('16100','2013-03-24','10:40:00',2),('16100','2013-03-24','10:45:00',2.63),('16100','2013-03-24','10:50:00',2.18),('16100','2013-03-24','10:55:00',2.07),('16100','2013-03-24','11:00:00',1.79),('16100','2013-03-24','11:05:00',1.07),('16100','2013-03-24','11:15:00',1.02),('16100','2013-03-24','11:20:00',1.16),('16100','2013-03-24','11:25:00',1.76),('16100','2013-03-24','11:30:00',2.21),('16100','2013-03-24','11:35:00',1.55),('16100','2013-03-24','11:40:00',2.73),('16100','2013-03-24','11:45:00',7.16),('16100','2013-03-24','11:50:00',9.24),('16100','2013-03-24','11:55:00',9.38),('16100','2013-03-24','12:00:00',9.55),('16100','2013-03-24','12:05:00',6.06),('16100','2013-03-24','12:10:00',4.69),('16100','2013-03-24','12:15:00',3.39),('16100','2013-03-24','12:20:00',6.23),('16100','2013-03-24','12:25:00',6.62),('16100','2013-03-24','12:30:00',6.09),('16100','2013-03-24','12:35:00',6.08),('16100','2013-03-24','12:40:00',6.34),('16100','2013-03-24','12:45:00',7.49),('16100','2013-03-24','12:50:00',8.66),('16100','2013-03-24','12:55:00',9.36),('16100','2013-03-24','13:00:00',3.29),('16100','2013-03-24','13:05:00',8.49),('16100','2013-03-24','13:10:00',2.77),('16100','2013-03-24','13:15:00',1.38),('16100','2013-03-24','13:20:00',1.29),('16100','2013-03-24','13:25:00',1.42),('16100','2013-03-24','13:30:00',2.23),('16100','2013-03-24','13:35:00',4.29),('16100','2013-03-24','13:40:00',1.84),('16100','2013-03-24','13:45:00',1.69),('16100','2013-03-24','13:50:00',3.38),('16100','2013-03-24','13:55:00',2.66),('16100','2013-03-24','14:00:00',3.98),('16100','2013-03-24','14:05:00',3.63),('16100','2013-03-24','14:10:00',4.75),('16100','2013-03-24','14:15:00',7.38),('16100','2013-03-24','14:20:00',6.14),('16100','2013-03-24','14:25:00',6.69),('16100','2013-03-24','14:30:00',8.47),('16100','2013-03-24','14:35:00',6.98),('16100','2013-03-24','14:40:00',5.89),('16100','2013-03-24','14:45:00',3.92),('16100','2013-03-24','14:50:00',4.31),('16100','2013-03-24','14:55:00',3.65),('16100','2013-03-24','15:00:00',3.91),('16100','2013-03-24','15:05:00',4.09),('16100','2013-03-24','15:10:00',4.98),('16100','2013-03-24','15:15:00',4.42),('16100','2013-03-24','15:20:00',5.35),('16100','2013-03-24','15:25:00',5.77),('16100','2013-03-24','15:30:00',4.3),('16100','2013-03-24','15:35:00',5.17),('16100','2013-03-24','15:40:00',3.46),('16100','2013-03-24','15:45:00',5.52),('16100','2013-03-24','15:50:00',5.25),('16100','2013-03-24','15:55:00',3.45),('16100','2013-03-24','16:00:00',1.87),('16100','2013-03-24','16:05:00',1.43),('16100','2013-03-24','16:10:00',2.29),('16100','2013-03-24','16:15:00',1.6),('16100','2013-03-24','16:20:00',1.17),('16100','2013-03-24','16:25:00',1.99),('16100','2013-03-24','16:30:00',4.12),('16100','2013-03-24','16:35:00',3.75),('16100','2013-03-24','16:40:00',2.67),('16100','2013-03-24','16:45:00',1.37),('16100','2013-03-24','16:55:00',1.04),('16100','2013-03-23','07:25:00',1.21),('16100','2013-03-23','07:30:00',1.25),('16100','2013-03-23','07:35:00',1.16),('16100','2013-03-23','07:40:00',1.43),('16100','2013-03-23','07:45:00',1.53),('16100','2013-03-23','07:50:00',1.78),('16100','2013-03-23','07:55:00',2.01),('16100','2013-03-23','08:00:00',2.38),('16100','2013-03-23','08:05:00',2.92),('16100','2013-03-23','08:10:00',3.01),('16100','2013-03-23','08:15:00',3.28),('16100','2013-03-23','08:20:00',3.47),('16100','2013-03-23','08:25:00',3.63),('16100','2013-03-23','08:30:00',3.85),('16100','2013-03-23','08:35:00',4.04),('16100','2013-03-23','08:40:00',4.2),('16100','2013-03-23','08:45:00',4.35),('16100','2013-03-23','08:50:00',4.46),('16100','2013-03-23','08:55:00',4.49),('16100','2013-03-23','09:00:00',4.7),('16100','2013-03-23','09:05:00',4.79),('16100','2013-03-23','09:10:00',4.98),('16100','2013-03-23','09:15:00',5.11),('16100','2013-03-23','09:20:00',5.28),('16100','2013-03-23','09:25:00',5.37),('16100','2013-03-23','09:30:00',5.49),('16100','2013-03-23','09:35:00',5.63),('16100','2013-03-23','09:40:00',5.77),('16100','2013-03-23','09:45:00',5.9),('16100','2013-03-23','09:50:00',6.03),('16100','2013-03-23','09:55:00',6.12),('16100','2013-03-23','10:00:00',6.21),('16100','2013-03-23','10:05:00',6.31),('16100','2013-03-23','10:10:00',6.43),('16100','2013-03-23','10:15:00',6.56),('16100','2013-03-23','10:20:00',6.61),('16100','2013-03-23','10:25:00',6.74),('16100','2013-03-23','10:30:00',6.79),('16100','2013-03-23','10:35:00',6.82),('16100','2013-03-23','10:40:00',6.9),('16100','2013-03-23','10:45:00',7),('16100','2013-03-23','10:50:00',7.04),('16100','2013-03-23','10:55:00',7.12),('16100','2013-03-23','11:00:00',7.16),('16100','2013-03-23','11:05:00',7.2),('16100','2013-03-23','11:10:00',7.23),('16100','2013-03-23','11:15:00',7.25),('16100','2013-03-23','11:20:00',7.29),('16100','2013-03-23','11:25:00',7.34),('16100','2013-03-23','11:30:00',7.39),('16100','2013-03-23','11:35:00',7.4),('16100','2013-03-23','11:40:00',7.38),('16100','2013-03-23','11:45:00',7.42),('16100','2013-03-23','11:50:00',7.4),('16100','2013-03-23','11:55:00',7.41),('16100','2013-03-23','12:00:00',7.39),('16100','2013-03-23','12:05:00',7.4),('16100','2013-03-23','12:10:00',7.4),('16100','2013-03-23','12:15:00',7.48),('16100','2013-03-23','12:20:00',7.7),('16100','2013-03-23','12:25:00',7.81),('16100','2013-03-23','12:30:00',7.82),('16100','2013-03-23','12:35:00',7.86),('16100','2013-03-23','12:40:00',7.87),('16100','2013-03-23','12:45:00',7.86),('16100','2013-03-23','12:50:00',7.83),('16100','2013-03-23','12:55:00',7.84),('16100','2013-03-23','13:00:00',7.84),('16100','2013-03-23','13:05:00',7.81),('16100','2013-03-23','13:10:00',7.71),('16100','2013-03-23','13:15:00',7.68),('16100','2013-03-23','13:20:00',7.6),('16100','2013-03-23','13:25:00',7.54),('16100','2013-03-23','13:30:00',7.42),('16100','2013-03-23','13:35:00',7.39),('16100','2013-03-23','13:40:00',7.32),('16100','2013-03-23','13:45:00',7.27),('16100','2013-03-23','13:50:00',7.26),('16100','2013-03-23','13:55:00',7.13),('16100','2013-03-23','14:00:00',7.08),('16100','2013-03-23','14:05:00',7),('16100','2013-03-23','14:10:00',6.91),('16100','2013-03-23','14:15:00',6.78),('16100','2013-03-23','14:20:00',6.64),('16100','2013-03-23','14:25:00',6.48),('16100','2013-03-23','14:30:00',6.25),('16100','2013-03-23','14:35:00',6.03),('16100','2013-03-23','14:40:00',6.02),('16100','2013-03-23','14:45:00',6.03),('16100','2013-03-23','14:50:00',5.78),('16100','2013-03-23','14:55:00',5.64),('16100','2013-03-23','15:00:00',5.55),('16100','2013-03-23','15:05:00',5.49),('16100','2013-03-23','15:10:00',5.22),('16100','2013-03-23','15:15:00',5.24),('16100','2013-03-23','15:20:00',5.2),('16100','2013-03-23','15:25:00',4.94),('16100','2013-03-23','15:30:00',4.68),('16100','2013-03-23','15:35:00',4.73),('16100','2013-03-23','15:40:00',4.42),('16100','2013-03-23','15:45:00',3.7),('16100','2013-03-23','15:50:00',2.31),('16100','2013-03-23','15:55:00',2.24),('16100','2013-03-23','16:00:00',2.1),('16100','2013-03-23','16:05:00',2.25),('16100','2013-03-23','16:10:00',1.83),('16100','2013-03-23','16:15:00',3.17),('16100','2013-03-23','16:20:00',2.7),('16100','2013-03-23','16:25:00',1.57),('16100','2013-03-23','16:30:00',1.82),('16100','2013-03-23','16:35:00',1.81),('16100','2013-03-23','16:40:00',1.17),('16100','2013-03-23','16:45:00',1.4),('16100','2013-03-23','16:50:00',1.13),('16100','2013-03-22','07:20:00',1.14),('16100','2013-03-22','07:25:00',1.16),('16100','2013-03-22','07:30:00',1.45),('16100','2013-03-22','07:35:00',1.5),('16100','2013-03-22','07:40:00',1.84),('16100','2013-03-22','07:45:00',1.85),('16100','2013-03-22','07:50:00',2.23),('16100','2013-03-22','07:55:00',2.48),('16100','2013-03-22','08:00:00',2.8),('16100','2013-03-22','08:05:00',3.07),('16100','2013-03-22','08:10:00',3.21),('16100','2013-03-22','08:15:00',3.4),('16100','2013-03-22','08:20:00',3.57),('16100','2013-03-22','08:25:00',3.69),('16100','2013-03-22','08:30:00',3.92),('16100','2013-03-22','08:35:00',4.02),('16100','2013-03-22','08:40:00',4.25),('16100','2013-03-22','08:45:00',4.44),('16100','2013-03-22','08:50:00',4.6),('16100','2013-03-22','08:55:00',4.75),('16100','2013-03-22','09:00:00',4.98),('16100','2013-03-22','09:05:00',5.09),('16100','2013-03-22','09:10:00',5.21),('16100','2013-03-22','09:15:00',5.33),('16100','2013-03-22','09:20:00',5.34),('16100','2013-03-22','09:25:00',5.64),('16100','2013-03-22','09:30:00',5.7),('16100','2013-03-22','09:35:00',5.79),('16100','2013-03-22','09:40:00',5.78),('16100','2013-03-22','09:45:00',6.17),('16100','2013-03-22','09:50:00',6.21),('16100','2013-03-22','09:55:00',6.34),('16100','2013-03-22','10:00:00',6.37),('16100','2013-03-22','10:05:00',6.44),('16100','2013-03-22','10:10:00',6.42),('16100','2013-03-22','10:15:00',6.42),('16100','2013-03-22','10:20:00',6.57),('16100','2013-03-22','10:25:00',6.64),('16100','2013-03-22','10:30:00',6.77),('16100','2013-03-22','10:35:00',6.76),('16100','2013-03-22','10:40:00',6.91),('16100','2013-03-22','10:45:00',7.11),('16100','2013-03-22','10:50:00',6.82),('16100','2013-03-22','10:55:00',6.8),('16100','2013-03-22','11:00:00',5.93),('16100','2013-03-22','11:05:00',5.62),('16100','2013-03-22','11:10:00',6.18),('16100','2013-03-22','11:15:00',7.11),('16100','2013-03-22','11:20:00',6.45),('16100','2013-03-22','11:25:00',6.94),('16100','2013-03-22','11:30:00',7.17),('16100','2013-03-22','11:35:00',7.65),('16100','2013-03-22','11:40:00',7.35),('16100','2013-03-22','11:45:00',7.03),('16100','2013-03-22','11:50:00',7.14),('16100','2013-03-22','11:55:00',7.42),('16100','2013-03-22','12:00:00',7.47),('16100','2013-03-22','12:05:00',7.38),('16100','2013-03-22','12:10:00',7.35),('16100','2013-03-22','12:15:00',7.14),('16100','2013-03-22','12:20:00',7.58),('16100','2013-03-22','12:25:00',7.34),('16100','2013-03-22','12:30:00',7.58),('16100','2013-03-22','12:35:00',7.47),('16100','2013-03-22','12:40:00',7.47),('16100','2013-03-22','12:45:00',7.67),('16100','2013-03-22','12:50:00',7.65),('16100','2013-03-22','12:55:00',7.23),('16100','2013-03-22','13:00:00',6.79),('16100','2013-03-22','13:05:00',7.38),('16100','2013-03-22','13:10:00',7.36),('16100','2013-03-22','13:15:00',7.46),('16100','2013-03-22','13:20:00',7.57),('16100','2013-03-22','13:25:00',7.41),('16100','2013-03-22','13:30:00',7.11),('16100','2013-03-22','13:35:00',6.32),('16100','2013-03-22','13:40:00',6.85),('16100','2013-03-22','13:45:00',7.18),('16100','2013-03-22','13:50:00',6.97),('16100','2013-03-22','13:55:00',7.16),('16100','2013-03-22','14:00:00',7.24),('16100','2013-03-22','14:05:00',7.07),('16100','2013-03-22','14:10:00',6.77),('16100','2013-03-22','14:15:00',6.65),('16100','2013-03-22','14:20:00',6.49),('16100','2013-03-22','14:25:00',6.61),('16100','2013-03-22','14:30:00',6.48),('16100','2013-03-22','14:35:00',6.3),('16100','2013-03-22','14:40:00',6.02),('16100','2013-03-22','14:45:00',5.66),('16100','2013-03-22','14:50:00',5.84),('16100','2013-03-22','14:55:00',5.69),('16100','2013-03-22','15:00:00',5.47),('16100','2013-03-22','15:05:00',5.65),('16100','2013-03-22','15:10:00',4.92),('16100','2013-03-22','15:15:00',4.8),('16100','2013-03-22','15:20:00',5.06),('16100','2013-03-22','15:25:00',4.95),('16100','2013-03-22','15:30:00',4.39),('16100','2013-03-22','15:35:00',4.47),('16100','2013-03-22','15:40:00',4.31),('16100','2013-03-22','15:45:00',3.65),('16100','2013-03-22','15:50:00',3.18),('16100','2013-03-22','15:55:00',3.26),('16100','2013-03-22','16:00:00',2.88),('16100','2013-03-22','16:05:00',3.29),('16100','2013-03-22','16:10:00',3.72),('16100','2013-03-22','16:15:00',3.54),('16100','2013-03-22','16:20:00',3.04),('16100','2013-03-22','16:25:00',2.79),('16100','2013-03-22','16:30:00',2.4),('16100','2013-03-22','16:35:00',2.45),('16100','2013-03-22','16:40:00',1.95),('16100','2013-03-22','16:45:00',1.81),('16100','2013-03-22','16:50:00',1.74),('16100','2013-03-22','16:55:00',1.67),('16100','2013-03-22','17:00:00',2.04),('16100','2013-03-22','17:05:00',2.06),('16100','2013-03-22','17:10:00',1.72),('16100','2013-03-22','17:15:00',1.43),('16100','2013-03-22','17:20:00',1.21),('16100','2013-03-22','17:25:00',1.05),('16100','2014-03-25','07:15:00',1.05),('16100','2014-03-25','07:20:00',1.2),('16100','2014-03-25','07:25:00',1.33),('16100','2014-03-25','07:30:00',1.76),('16100','2014-03-25','07:35:00',2.01),('16100','2014-03-25','07:40:00',1.42),('16100','2014-03-25','07:45:00',1.45),('16100','2014-03-25','07:50:00',2.68),('16100','2014-03-25','07:55:00',2.9),('16100','2014-03-25','08:00:00',2.81),('16100','2014-03-25','08:05:00',2.95),('16100','2014-03-25','08:10:00',3.17),('16100','2014-03-25','08:15:00',3.51),('16100','2014-03-25','08:20:00',4.52),('16100','2014-03-25','08:25:00',3.22),('16100','2014-03-25','08:30:00',1.65),('16100','2014-03-25','08:35:00',1.41),('16100','2014-03-25','08:40:00',1.54),('16100','2014-03-25','08:45:00',2.06),('16100','2014-03-25','08:50:00',1.87),('16100','2014-03-25','08:55:00',2.16),('16100','2014-03-25','09:00:00',2.6),('16100','2014-03-25','09:05:00',3.24),('16100','2014-03-25','09:10:00',5.42),('16100','2014-03-25','09:15:00',5.37),('16100','2014-03-25','09:20:00',6.33),('16100','2014-03-25','09:25:00',5.64),('16100','2014-03-25','09:30:00',5.57),('16100','2014-03-25','09:35:00',5.69),('16100','2014-03-25','09:40:00',5.82),('16100','2014-03-25','09:45:00',5.97),('16100','2014-03-25','09:50:00',6.07),('16100','2014-03-25','09:55:00',6.3),('16100','2014-03-25','10:00:00',5.06),('16100','2014-03-25','10:05:00',6.45),('16100','2014-03-25','10:10:00',6.5),('16100','2014-03-25','10:15:00',4.53),('16100','2014-03-25','10:20:00',6.07),('16100','2014-03-25','10:25:00',5.04),('16100','2014-03-25','10:30:00',3.01),('16100','2014-03-25','10:35:00',5.81),('16100','2014-03-25','10:40:00',6.43),('16100','2014-03-25','10:45:00',3.88),('16100','2014-03-25','10:50:00',7.63),('16100','2014-03-25','10:55:00',8.39),('16100','2014-03-25','11:00:00',2.5),('16100','2014-03-25','11:05:00',2.31),('16100','2014-03-25','11:10:00',1.57),('16100','2014-03-25','11:15:00',2.54),('16100','2014-03-25','11:20:00',1.63),('16100','2014-03-25','11:25:00',1.27),('16100','2014-03-25','11:30:00',1.26),('16100','2014-03-25','11:35:00',1.25),('16100','2014-03-25','11:40:00',1.16),('16100','2014-03-25','11:45:00',2.82),('16100','2014-03-25','11:50:00',8.01),('16100','2014-03-25','11:55:00',5.71),('16100','2014-03-25','12:00:00',5.16),('16100','2014-03-25','12:05:00',5.08),('16100','2014-03-25','12:10:00',3.13),('16100','2014-03-25','12:15:00',2.47),('16100','2014-03-25','12:20:00',1.69),('16100','2014-03-25','12:25:00',2.44),('16100','2014-03-25','12:30:00',2.89),('16100','2014-03-25','12:35:00',2.97),('16100','2014-03-25','12:40:00',4.46),('16100','2014-03-25','12:45:00',5.17),('16100','2014-03-25','12:50:00',7.13),('16100','2014-03-25','12:55:00',4.96),('16100','2014-03-25','13:00:00',7.87),('16100','2014-03-25','13:05:00',7.22),('16100','2014-03-25','13:10:00',2.83),('16100','2014-03-25','13:15:00',1.73),('16100','2014-03-25','13:20:00',1.67),('16100','2014-03-25','13:25:00',1.67),('16100','2014-03-25','13:30:00',5.35),('16100','2014-03-25','13:35:00',5.55),('16100','2014-03-25','13:40:00',6.54),('16100','2014-03-25','13:45:00',5.16),('16100','2014-03-25','13:50:00',3.72),('16100','2014-03-25','13:55:00',7.43),('16100','2014-03-25','14:00:00',7.23),('16100','2014-03-25','14:05:00',5.44),('16100','2014-03-25','14:10:00',5.58),('16100','2014-03-25','14:15:00',2.63),('16100','2014-03-25','14:20:00',2.76),('16100','2014-03-25','14:25:00',2.09),('16100','2014-03-25','14:30:00',1.4),('16100','2014-03-25','14:35:00',1.09),('16100','2014-03-25','14:55:00',1.02),('16100','2014-03-25','15:00:00',1.21),('16100','2014-03-25','15:05:00',1.78),('16100','2014-03-25','15:10:00',4.41),('16100','2014-03-25','15:15:00',4.87),('16100','2014-03-25','15:20:00',5.6),('16100','2014-03-25','15:25:00',5.01),('16100','2014-03-25','15:30:00',5.25),('16100','2014-03-25','15:35:00',5.1),('16100','2014-03-25','15:40:00',4.67),('16100','2014-03-25','15:45:00',4.34),('16100','2014-03-25','15:50:00',3.59),('16100','2014-03-25','15:55:00',1.42),('16100','2014-03-25','16:00:00',1.04),('16100','2014-03-25','16:15:00',1.87),('16100','2014-03-25','16:20:00',3.46),('16100','2014-03-25','16:25:00',3.34),('16100','2014-03-25','16:30:00',1.83),('16100','2014-03-25','16:35:00',2.11),('16100','2014-03-25','16:40:00',1.01),('16100','2013-03-21','07:20:00',1.1),('16100','2013-03-21','07:25:00',1.28),('16100','2013-03-21','07:30:00',1.49),('16100','2013-03-21','07:35:00',1.7),('16100','2013-03-21','07:40:00',1.9),('16100','2013-03-21','07:45:00',2.1),('16100','2013-03-21','07:50:00',2.28),('16100','2013-03-21','07:55:00',2.51),('16100','2013-03-21','08:00:00',2.75),('16100','2013-03-21','08:05:00',2.95),('16100','2013-03-21','08:10:00',3.13),('16100','2013-03-21','08:15:00',3.34),('16100','2013-03-21','08:20:00',3.52),('16100','2013-03-21','08:25:00',3.71),('16100','2013-03-21','08:30:00',3.93),('16100','2013-03-21','08:35:00',4.14),('16100','2013-03-21','08:40:00',4.3),('16100','2013-03-21','08:45:00',4.44),('16100','2013-03-21','08:50:00',4.6),('16100','2013-03-21','08:55:00',4.77),('16100','2013-03-21','09:00:00',4.93),('16100','2013-03-21','09:05:00',5.06),('16100','2013-03-21','09:10:00',5.21),('16100','2013-03-21','09:15:00',5.32),('16100','2013-03-21','09:20:00',5.39),('16100','2013-03-21','09:25:00',5.52),('16100','2013-03-21','09:30:00',5.64),('16100','2013-03-21','09:35:00',5.8),('16100','2013-03-21','09:40:00',6.05),('16100','2013-03-21','09:45:00',6.08),('16100','2013-03-21','09:50:00',6.29),('16100','2013-03-21','09:55:00',6.47),('16100','2013-03-21','10:00:00',6.44),('16100','2013-03-21','10:05:00',6.55),('16100','2013-03-21','10:10:00',6.72),('16100','2013-03-21','10:15:00',6.78),('16100','2013-03-21','10:20:00',6.92),('16100','2013-03-21','10:25:00',7.04),('16100','2013-03-21','10:30:00',7.1),('16100','2013-03-21','10:35:00',7.19),('16100','2013-03-21','10:40:00',7.18),('16100','2013-03-21','10:45:00',7.27),('16100','2013-03-21','10:50:00',7.38),('16100','2013-03-21','10:55:00',7.46),('16100','2013-03-21','11:00:00',7.57),('16100','2013-03-21','11:05:00',7.63),('16100','2013-03-21','11:10:00',7.75),('16100','2013-03-21','11:15:00',7.79),('16100','2013-03-21','11:20:00',7.87),('16100','2013-03-21','11:25:00',7.86),('16100','2013-03-21','11:30:00',7.91),('16100','2013-03-21','11:35:00',7.92),('16100','2013-03-21','11:40:00',8),('16100','2013-03-21','11:45:00',7.99),('16100','2013-03-21','11:50:00',7.97),('16100','2013-03-21','11:55:00',8.1),('16100','2013-03-21','12:00:00',8.21),('16100','2013-03-21','12:05:00',8.21),('16100','2013-03-21','12:10:00',8.2),('16100','2013-03-21','12:15:00',8.19),('16100','2013-03-21','12:20:00',8.23),('16100','2013-03-21','12:25:00',8.24),('16100','2013-03-21','12:30:00',8.27),('16100','2013-03-21','12:35:00',8.25),('16100','2013-03-21','12:40:00',8.29),('16100','2013-03-21','12:45:00',8.27),('16100','2013-03-21','12:50:00',7.39),('16100','2013-03-21','12:55:00',7.77),('16100','2013-03-21','13:00:00',8.06),('16100','2013-03-21','13:05:00',8.17),('16100','2013-03-21','13:10:00',8.1),('16100','2013-03-21','13:15:00',8),('16100','2013-03-21','13:20:00',7.73),('16100','2013-03-21','13:25:00',7.43),('16100','2013-03-21','13:30:00',7.8),('16100','2013-03-21','13:35:00',7.03),('16100','2013-03-21','13:40:00',6.11),('16100','2013-03-21','13:45:00',7.48),('16100','2013-03-21','13:50:00',7.61),('16100','2013-03-21','13:55:00',7.47),('16100','2013-03-21','14:00:00',7.38),('16100','2013-03-21','14:05:00',7.3),('16100','2013-03-21','14:10:00',7.28),('16100','2013-03-21','14:15:00',7.13),('16100','2013-03-21','14:20:00',6.98),('16100','2013-03-21','14:25:00',6.93),('16100','2013-03-21','14:30:00',6.84),('16100','2013-03-21','14:35:00',6.76),('16100','2013-03-21','14:40:00',6.61),('16100','2013-03-21','14:45:00',6.31),('16100','2013-03-21','14:50:00',6.45),('16100','2013-03-21','14:55:00',6.39),('16100','2013-03-21','15:00:00',6.24),('16100','2013-03-21','15:05:00',6.07),('16100','2013-03-21','15:10:00',5.46),('16100','2013-03-21','15:15:00',4.34),('16100','2013-03-21','15:20:00',4.8),('16100','2013-03-21','15:25:00',4.55),('16100','2013-03-21','15:30:00',4.91),('16100','2013-03-21','15:35:00',4.94),('16100','2013-03-21','15:40:00',4.57),('16100','2013-03-21','15:45:00',4.46),('16100','2013-03-21','15:50:00',4.46),('16100','2013-03-21','15:55:00',3.16),('16100','2013-03-21','16:00:00',2.37),('16100','2013-03-21','16:05:00',2.7),('16100','2013-03-21','16:10:00',3.56),('16100','2013-03-21','16:15:00',3.57),('16100','2013-03-21','16:20:00',2.03),('16100','2013-03-21','16:25:00',2.76),('16100','2013-03-21','16:30:00',3.1),('16100','2013-03-21','16:35:00',3.21),('16100','2013-03-21','16:40:00',2.97),('16100','2013-03-21','16:45:00',2.83),('16100','2013-03-21','16:50:00',2.76),('16100','2013-03-21','16:55:00',2.55),('16100','2013-03-21','17:00:00',2.22),('16100','2013-03-21','17:05:00',1.86),('16100','2013-03-21','17:10:00',1.57),('16100','2013-03-21','17:15:00',1.61),('16100','2013-03-20','07:15:00',1.06),('16100','2013-03-20','07:20:00',1.66),('16100','2013-03-20','07:25:00',1.78),('16100','2013-03-20','07:30:00',1.82),('16100','2013-03-20','07:35:00',2.04),('16100','2013-03-20','07:40:00',2.42),('16100','2013-03-20','07:45:00',3.1),('16100','2013-03-20','07:50:00',3.07),('16100','2013-03-20','08:00:00',2.11),('16100','2013-03-20','08:05:00',2.61),('16100','2013-03-20','08:10:00',3.35),('16100','2013-03-20','08:15:00',3.53),('16100','2013-03-20','08:20:00',3.74),('16100','2013-03-20','08:25:00',3.94),('16100','2013-03-20','08:30:00',4.12),('16100','2013-03-20','08:35:00',4.35),('16100','2013-03-20','08:40:00',4.59),('16100','2013-03-20','08:45:00',4.89),('16100','2013-03-20','08:50:00',5.66),('16100','2013-03-20','08:55:00',2.53),('16100','2013-03-20','09:00:00',3.5),('16100','2013-03-20','09:05:00',4.86),('16100','2013-03-20','09:10:00',5.69),('16100','2013-03-20','09:15:00',5.78),('16100','2013-03-20','09:20:00',5.92),('16100','2013-03-20','09:25:00',6.02),('16100','2013-03-20','09:30:00',6.15),('16100','2013-03-20','09:35:00',6.31),('16100','2013-03-20','09:40:00',6.45),('16100','2013-03-20','09:45:00',6.59),('16100','2013-03-20','09:50:00',6.71),('16100','2013-03-20','09:55:00',6.78),('16100','2013-03-20','10:00:00',6.83),('16100','2013-03-20','10:05:00',6.98),('16100','2013-03-20','10:10:00',7.22),('16100','2013-03-20','10:15:00',6.73),('16100','2013-03-20','10:20:00',7.58),('16100','2013-03-20','10:25:00',7.26),('16100','2013-03-20','10:30:00',7.29),('16100','2013-03-20','10:35:00',7.39),('16100','2013-03-20','10:40:00',7.5),('16100','2013-03-20','10:45:00',7.65),('16100','2013-03-20','10:50:00',7.79),('16100','2013-03-20','10:55:00',7.88),('16100','2013-03-20','11:00:00',7.96),('16100','2013-03-20','11:05:00',8.08),('16100','2013-03-20','11:10:00',8.1),('16100','2013-03-20','11:15:00',8.12),('16100','2013-03-20','11:20:00',8.18),('16100','2013-03-20','11:25:00',8.22),('16100','2013-03-20','11:30:00',8.31),('16100','2013-03-20','11:35:00',8.41),('16100','2013-03-20','11:40:00',8.46),('16100','2013-03-20','11:45:00',8.5),('16100','2013-03-20','11:50:00',8.56),('16100','2013-03-20','11:55:00',8.55),('16100','2013-03-20','12:00:00',8.5),('16100','2013-03-20','12:05:00',8.54),('16100','2013-03-20','12:10:00',8.53),('16100','2013-03-20','12:15:00',8.55),('16100','2013-03-20','12:20:00',8.59),('16100','2013-03-20','12:25:00',8.62),('16100','2013-03-20','12:30:00',8.61),('16100','2013-03-20','12:35:00',8.63),('16100','2013-03-20','12:40:00',8.63),('16100','2013-03-20','12:45:00',8.57),('16100','2013-03-20','12:50:00',8.5),('16100','2013-03-20','12:55:00',8.46),('16100','2013-03-20','13:00:00',8.4),('16100','2013-03-20','13:05:00',8.41),('16100','2013-03-20','13:10:00',8.33),('16100','2013-03-20','13:15:00',8.25),('16100','2013-03-20','13:20:00',8.23),('16100','2013-03-20','13:25:00',8.15),('16100','2013-03-20','13:30:00',8.11),('16100','2013-03-20','13:35:00',8.04),('16100','2013-03-20','13:40:00',7.99),('16100','2013-03-20','13:45:00',7.9),('16100','2013-03-20','13:50:00',7.84),('16100','2013-03-20','13:55:00',7.76),('16100','2013-03-20','14:00:00',7.63),('16100','2013-03-20','14:05:00',7.54),('16100','2013-03-20','14:10:00',7.45),('16100','2013-03-20','14:15:00',7.36),('16100','2013-03-20','14:20:00',7.22),('16100','2013-03-20','14:25:00',7.08),('16100','2013-03-20','14:30:00',6.95),('16100','2013-03-20','14:35:00',6.85),('16100','2013-03-20','14:40:00',6.73),('16100','2013-03-20','14:45:00',6.62),('16100','2013-03-20','14:50:00',6.47),('16100','2013-03-20','14:55:00',6.33),('16100','2013-03-20','15:00:00',6.28),('16100','2013-03-20','15:05:00',6.14),('16100','2013-03-20','15:10:00',5.92),('16100','2013-03-20','15:15:00',5.79),('16100','2013-03-20','15:20:00',5.62),('16100','2013-03-20','15:25:00',5.49),('16100','2013-03-20','15:30:00',5.36),('16100','2013-03-20','15:35:00',5.22),('16100','2013-03-20','15:40:00',5.07),('16100','2013-03-20','15:45:00',4.89),('16100','2013-03-20','15:50:00',4.68),('16100','2013-03-20','15:55:00',4.46),('16100','2013-03-20','16:00:00',4.32),('16100','2013-03-20','16:05:00',4.17),('16100','2013-03-20','16:10:00',3.99),('16100','2013-03-20','16:15:00',3.81),('16100','2013-03-20','16:20:00',3.61),('16100','2013-03-20','16:25:00',3.41),('16100','2013-03-20','16:30:00',3.21),('16100','2013-03-20','16:35:00',3.01),('16100','2013-03-20','16:40:00',2.79),('16100','2013-03-20','16:45:00',2.62),('16100','2013-03-20','16:50:00',2.42),('16100','2013-03-20','16:55:00',2.22),('16100','2013-03-20','17:00:00',2.03),('16100','2013-03-20','17:05:00',1.83),('16100','2013-03-20','17:10:00',1.64),('16100','2013-03-20','17:15:00',1.42),('16100','2013-03-20','17:20:00',1.22),('16100','2013-03-20','17:25:00',1.03),('16100','2013-03-19','07:20:00',1.02),('16100','2013-03-19','07:25:00',1.24),('16100','2013-03-19','07:30:00',1.48),('16100','2013-03-19','07:35:00',1.71),('16100','2013-03-19','07:40:00',1.88),('16100','2013-03-19','07:45:00',2.03),('16100','2013-03-19','07:50:00',2.26),('16100','2013-03-19','07:55:00',2.7),('16100','2013-03-19','08:00:00',1.71),('16100','2013-03-19','08:05:00',2.05),('16100','2013-03-19','08:10:00',3),('16100','2013-03-19','08:15:00',3.29),('16100','2013-03-19','08:20:00',3.46),('16100','2013-03-19','08:25:00',3.66),('16100','2013-03-19','08:30:00',3.89),('16100','2013-03-19','08:35:00',3.58),('16100','2013-03-19','08:40:00',4.03),('16100','2013-03-19','08:45:00',4.23),('16100','2013-03-19','08:50:00',4.21),('16100','2013-03-19','08:55:00',4.19),('16100','2013-03-19','09:00:00',4.71),('16100','2013-03-19','09:05:00',4.03),('16100','2013-03-19','09:10:00',3.06),('16100','2013-03-19','09:15:00',4.53),('16100','2013-03-19','09:20:00',3.66),('16100','2013-03-19','09:25:00',5.92),('16100','2013-03-19','09:30:00',4.37),('16100','2013-03-19','09:35:00',5.15),('16100','2013-03-19','09:40:00',5.71),('16100','2013-03-19','09:45:00',6.1),('16100','2013-03-19','09:50:00',6.26),('16100','2013-03-19','09:55:00',6.24),('16100','2013-03-19','10:00:00',6.81),('16100','2013-03-19','10:05:00',6.71),('16100','2013-03-19','10:10:00',6.74),('16100','2013-03-19','10:15:00',4.98),('16100','2013-03-19','10:20:00',4.23),('16100','2013-03-19','10:25:00',5.1),('16100','2013-03-19','10:30:00',5.63),('16100','2013-03-19','10:35:00',6.15),('16100','2013-03-19','10:40:00',4.24),('16100','2013-03-19','10:45:00',3.75),('16100','2013-03-19','10:50:00',5.8),('16100','2013-03-19','10:55:00',5.41),('16100','2013-03-19','11:00:00',4.63),('16100','2013-03-19','11:05:00',5.56),('16100','2013-03-19','11:10:00',4.14),('16100','2013-03-19','11:15:00',4.59),('16100','2013-03-19','11:20:00',4.77),('16100','2013-03-19','11:25:00',4.36),('16100','2013-03-19','11:30:00',4.47),('16100','2013-03-19','11:35:00',5.01),('16100','2013-03-19','11:40:00',4.13),('16100','2013-03-19','11:45:00',3.68),('16100','2013-03-19','11:50:00',3.56),('16100','2013-03-19','11:55:00',3.7),('16100','2013-03-19','12:00:00',3.82),('16100','2013-03-19','12:05:00',3.72),('16100','2013-03-19','12:10:00',3.3),('16100','2013-03-19','12:15:00',2.72),('16100','2013-03-19','12:20:00',2.34),('16100','2013-03-19','12:25:00',1.84),('16100','2013-03-19','12:30:00',1.68),('16100','2013-03-19','12:35:00',1.87),('16100','2013-03-19','12:40:00',1.45),('16100','2013-03-19','12:45:00',1.38),('16100','2013-03-19','12:50:00',1.98),('16100','2013-03-19','12:55:00',2.85),('16100','2013-03-19','13:00:00',2.13),('16100','2013-03-19','13:05:00',1.68),('16100','2013-03-19','13:10:00',1.81),('16100','2013-03-19','13:15:00',1.59),('16100','2013-03-19','13:20:00',1.8),('16100','2013-03-19','13:25:00',2.16),('16100','2013-03-19','13:30:00',2.42),('16100','2013-03-19','13:35:00',2.32),('16100','2013-03-19','13:40:00',3.2),('16100','2013-03-19','13:45:00',3.25),('16100','2013-03-19','13:50:00',2.62),('16100','2013-03-19','13:55:00',2.74),('16100','2013-03-19','14:00:00',2.58),('16100','2013-03-19','14:05:00',2.04),('16100','2013-03-19','14:10:00',2.03),('16100','2013-03-19','14:15:00',2.85),('16100','2013-03-19','14:20:00',3.48),('16100','2013-03-19','14:25:00',3.61),('16100','2013-03-19','14:30:00',3.34),('16100','2013-03-19','14:35:00',2.28),('16100','2013-03-19','14:40:00',1.74),('16100','2013-03-19','14:45:00',1.7),('16100','2013-03-19','14:50:00',1.24),('16100','2013-03-19','15:10:00',1.03),('16100','2013-03-18','07:25:00',1.16),('16100','2013-03-18','07:30:00',1.35),('16100','2013-03-18','07:35:00',1.56),('16100','2013-03-18','07:40:00',1.8),('16100','2013-03-18','07:45:00',2.01),('16100','2013-03-18','07:50:00',2.26),('16100','2013-03-18','07:55:00',2.22),('16100','2013-03-18','08:00:00',2.05),('16100','2013-03-18','08:05:00',2.76),('16100','2013-03-18','08:10:00',2.82),('16100','2013-03-18','08:15:00',2.95),('16100','2013-03-18','08:20:00',3.27),('16100','2013-03-18','08:25:00',3.53),('16100','2013-03-18','08:30:00',3.82),('16100','2013-03-18','08:35:00',4.1),('16100','2013-03-18','08:40:00',4.27),('16100','2013-03-18','08:45:00',4.42),('16100','2013-03-18','08:50:00',4.6),('16100','2013-03-18','08:55:00',4.74),('16100','2013-03-18','09:00:00',4.92),('16100','2013-03-18','09:05:00',5.12),('16100','2013-03-18','09:10:00',5.27),('16100','2013-03-18','09:15:00',5.42),('16100','2013-03-18','09:20:00',5.57),('16100','2013-03-18','09:25:00',5.71),('16100','2013-03-18','09:30:00',5.9),('16100','2013-03-18','09:35:00',6.04),('16100','2013-03-18','09:40:00',6.24),('16100','2013-03-18','09:45:00',6.4),('16100','2013-03-18','09:50:00',6.61),('16100','2013-03-18','09:55:00',5.44),('16100','2013-03-18','10:00:00',5.34),('16100','2013-03-18','10:05:00',6.94),('16100','2013-03-18','10:10:00',7.01),('16100','2013-03-18','10:15:00',7.07),('16100','2013-03-18','10:20:00',7.21),('16100','2013-03-18','10:25:00',7.36),('16100','2013-03-18','10:30:00',7.53),('16100','2013-03-18','10:35:00',7.64),('16100','2013-03-18','10:40:00',7.7),('16100','2013-03-18','10:45:00',7.77),('16100','2013-03-18','10:50:00',7.91),('16100','2013-03-18','10:55:00',8),('16100','2013-03-18','11:00:00',8.1),('16100','2013-03-18','11:05:00',8.15),('16100','2013-03-18','11:10:00',8.2),('16100','2013-03-18','11:15:00',8.28),('16100','2013-03-18','11:20:00',8.28),('16100','2013-03-18','11:25:00',8.39),('16100','2013-03-18','11:30:00',8.16),('16100','2013-03-18','11:35:00',6.23),('16100','2013-03-18','11:40:00',6.36),('16100','2013-03-18','11:45:00',7.02),('16100','2013-03-18','11:50:00',8.24),('16100','2013-03-18','11:55:00',8.58),('16100','2013-03-18','12:00:00',8.57),('16100','2013-03-18','12:05:00',8.62),('16100','2013-03-18','12:10:00',8.52),('16100','2013-03-18','12:15:00',8.55),('16100','2013-03-18','12:20:00',8.42),('16100','2013-03-18','12:25:00',8.2),('16100','2013-03-18','12:30:00',8.4),('16100','2013-03-18','12:35:00',8.41),('16100','2013-03-18','12:40:00',8.46),('16100','2013-03-18','12:45:00',8.14),('16100','2013-03-18','12:50:00',8.23),('16100','2013-03-18','12:55:00',8.18),('16100','2013-03-18','13:00:00',8.3),('16100','2013-03-18','13:05:00',8.11),('16100','2013-03-18','13:10:00',8.17),('16100','2013-03-18','13:15:00',8.06),('16100','2013-03-18','13:20:00',8.03),('16100','2013-03-18','13:25:00',8.02),('16100','2013-03-18','13:30:00',7.87),('16100','2013-03-18','13:35:00',7.77),('16100','2013-03-18','13:40:00',7.66),('16100','2013-03-18','13:45:00',7.43),('16100','2013-03-18','13:50:00',7.64),('16100','2013-03-18','13:55:00',7.53),('16100','2013-03-18','14:00:00',7.43),('16100','2013-03-18','14:05:00',7.38),('16100','2013-03-18','14:10:00',7.31),('16100','2013-03-18','14:15:00',7.19),('16100','2013-03-18','14:20:00',7.01),('16100','2013-03-18','14:25:00',6.92),('16100','2013-03-18','14:30:00',6.87),('16100','2013-03-18','14:35:00',6.77),('16100','2013-03-18','14:40:00',6.66),('16100','2013-03-18','14:45:00',6.55),('16100','2013-03-18','14:50:00',6.41),('16100','2013-03-18','14:55:00',6.24),('16100','2013-03-18','15:00:00',6.13),('16100','2013-03-18','15:05:00',5.94),('16100','2013-03-18','15:10:00',5.78),('16100','2013-03-18','15:15:00',5.66),('16100','2013-03-18','15:20:00',5.54),('16100','2013-03-18','15:25:00',5.41),('16100','2013-03-18','15:30:00',5.28),('16100','2013-03-18','15:35:00',5.11),('16100','2013-03-18','15:40:00',4.93),('16100','2013-03-18','15:45:00',4.8),('16100','2013-03-18','15:50:00',4.61),('16100','2013-03-18','15:55:00',4.4),('16100','2013-03-18','16:00:00',4.28),('16100','2013-03-18','16:05:00',4.06),('16100','2013-03-18','16:10:00',3.91),('16100','2013-03-18','16:15:00',3.76),('16100','2013-03-18','16:20:00',3.54),('16100','2013-03-18','16:25:00',3.37),('16100','2013-03-18','16:30:00',3.21),('16100','2013-03-18','16:35:00',2.75),('16100','2013-03-18','16:40:00',2.77),('16100','2013-03-18','16:45:00',2.43),('16100','2013-03-18','16:50:00',1.73),('16100','2013-03-18','16:55:00',1.99),('16100','2013-03-18','17:00:00',1.26),('16100','2013-03-18','17:10:00',1.2),('16100','2013-03-18','17:15:00',1.53),('16100','2013-03-18','17:20:00',1.31),('16100','2013-03-18','17:25:00',1.13),('16100','2013-03-17','08:20:00',1.17),('16100','2013-03-17','08:25:00',1.18),('16100','2013-03-17','08:35:00',1.39),('16100','2013-03-17','08:40:00',1.95),('16100','2013-03-17','08:45:00',1.86),('16100','2013-03-17','08:50:00',1.59),('16100','2013-03-17','09:40:00',1.18),('16100','2013-03-17','09:45:00',1.16),('16100','2013-03-17','09:50:00',1.5),('16100','2013-03-17','09:55:00',1.97),('16100','2013-03-17','10:00:00',2.37),('16100','2013-03-17','10:05:00',3.19),('16100','2013-03-17','10:10:00',3.52),('16100','2013-03-17','10:15:00',3.68),('16100','2013-03-17','10:20:00',4.72),('16100','2013-03-17','10:25:00',6.06),('16100','2013-03-17','10:30:00',3.72),('16100','2013-03-17','10:35:00',2.99),('16100','2013-03-17','10:40:00',2.65),('16100','2013-03-17','10:45:00',3.23),('16100','2013-03-17','10:50:00',1.81),('16100','2013-03-17','10:55:00',1.65),('16100','2013-03-17','11:00:00',1.89),('16100','2013-03-17','11:05:00',2.2),('16100','2013-03-17','11:10:00',2.67),('16100','2013-03-17','11:15:00',3.34),('16100','2013-03-17','11:20:00',3.52),('16100','2013-03-17','11:25:00',3.65),('16100','2013-03-17','11:30:00',4.08),('16100','2013-03-17','11:35:00',3.28),('16100','2013-03-17','11:40:00',2.42),('16100','2013-03-17','11:45:00',1.97),('16100','2013-03-17','11:50:00',1.82),('16100','2013-03-17','11:55:00',2.07),('16100','2013-03-17','12:00:00',2.41),('16100','2013-03-17','12:05:00',3.48),('16100','2013-03-17','12:10:00',4.53),('16100','2013-03-17','12:15:00',7.1),('16100','2013-03-17','12:20:00',7.18),('16100','2013-03-17','12:25:00',7.69),('16100','2013-03-17','12:30:00',7.01),('16100','2013-03-17','12:35:00',4.53),('16100','2013-03-17','12:40:00',3.42),('16100','2013-03-17','12:45:00',5.46),('16100','2013-03-17','12:50:00',6.44),('16100','2013-03-17','12:55:00',5.26),('16100','2013-03-17','13:00:00',2.79),('16100','2013-03-17','13:05:00',3.82),('16100','2013-03-17','13:10:00',2.3),('16100','2013-03-17','13:15:00',1.41),('16100','2013-03-17','13:20:00',3.27),('16100','2013-03-17','13:25:00',3.83),('16100','2013-03-17','13:30:00',1.78),('16100','2013-03-17','13:35:00',2.13),('16100','2013-03-17','13:40:00',2.56),('16100','2013-03-17','13:45:00',2.23),('16100','2013-03-17','13:50:00',1.85),('16100','2013-03-17','13:55:00',1.59),('16100','2013-03-17','14:00:00',3.15),('16100','2013-03-17','14:05:00',2.64),('16100','2013-03-17','14:10:00',3.41),('16100','2013-03-17','14:15:00',1.6),('16100','2013-03-17','14:20:00',1.5),('16100','2013-03-17','14:25:00',1.34),('16100','2013-03-17','14:30:00',1.06),('16100','2013-03-17','14:35:00',1.6),('16100','2013-03-17','14:40:00',1.55),('16100','2013-03-17','14:55:00',1.44),('16100','2013-03-17','15:00:00',1.27),('16100','2013-03-17','15:05:00',1.24),('16100','2013-03-17','15:15:00',1.06),('16100','2013-03-16','08:05:00',1.22),('16100','2013-03-16','08:10:00',1.31),('16100','2013-03-16','08:15:00',1.48),('16100','2013-03-16','08:20:00',2.1),('16100','2013-03-16','08:25:00',2.52),('16100','2013-03-16','08:30:00',2.17),('16100','2013-03-16','08:35:00',1.94),('16100','2013-03-16','08:40:00',2.09),('16100','2013-03-16','08:45:00',2.47),('16100','2013-03-16','08:50:00',2.22),('16100','2013-03-16','08:55:00',1.93),('16100','2013-03-16','09:00:00',2.22),('16100','2013-03-16','09:05:00',2.85),('16100','2013-03-16','09:10:00',2.94),('16100','2013-03-16','09:15:00',2.83),('16100','2013-03-16','09:20:00',2.5),('16100','2013-03-16','09:25:00',2.02),('16100','2013-03-16','09:30:00',2.47),('16100','2013-03-16','09:35:00',2.53),('16100','2013-03-16','09:40:00',2.41),('16100','2013-03-16','09:45:00',2.61),('16100','2013-03-16','09:50:00',2.87),('16100','2013-03-16','09:55:00',3),('16100','2013-03-16','10:00:00',3.2),('16100','2013-03-16','10:05:00',2.68),('16100','2013-03-16','10:10:00',2.86),('16100','2013-03-16','10:15:00',2.97),('16100','2013-03-16','10:20:00',3.06),('16100','2013-03-16','10:25:00',3.25),('16100','2013-03-16','10:30:00',3.1),('16100','2013-03-16','10:35:00',3.02),('16100','2013-03-16','10:40:00',2.99),('16100','2013-03-16','10:45:00',3.1),('16100','2013-03-16','10:50:00',2.45),('16100','2013-03-16','10:55:00',2.19),('16100','2013-03-16','11:00:00',2.01),('16100','2013-03-16','11:05:00',2.19),('16100','2013-03-16','11:10:00',2.45),('16100','2013-03-16','11:15:00',2.95),('16100','2013-03-16','11:20:00',3.51),('16100','2013-03-16','11:25:00',2.98),('16100','2013-03-16','11:30:00',2.72),('16100','2013-03-16','11:35:00',2.53),('16100','2013-03-16','11:40:00',2.35),('16100','2013-03-16','11:45:00',2.11),('16100','2013-03-16','11:50:00',1.93),('16100','2013-03-16','11:55:00',1.82),('16100','2013-03-16','12:00:00',1.68),('16100','2013-03-16','12:05:00',1.9),('16100','2013-03-16','12:10:00',2.54),('16100','2013-03-16','12:15:00',3.56),('16100','2013-03-16','12:20:00',4.03),('16100','2013-03-16','12:25:00',4.83),('16100','2013-03-16','12:30:00',4.25),('16100','2013-03-16','12:35:00',3.9),('16100','2013-03-16','12:40:00',4.18),('16100','2013-03-16','12:45:00',3.81),('16100','2013-03-16','12:50:00',3.01),('16100','2013-03-16','12:55:00',2.73),('16100','2013-03-16','13:00:00',2.91),('16100','2013-03-16','13:05:00',3.1),('16100','2013-03-16','13:10:00',3.39),('16100','2013-03-16','13:15:00',2.94),('16100','2013-03-16','13:20:00',2.49),('16100','2013-03-16','13:25:00',3.11),('16100','2013-03-16','13:30:00',4.95),('16100','2013-03-16','13:35:00',4.69),('16100','2013-03-16','13:40:00',2.97),('16100','2013-03-16','13:45:00',2.37),('16100','2013-03-16','13:50:00',2.65),('16100','2013-03-16','13:55:00',3.45),('16100','2013-03-16','14:00:00',3.18),('16100','2013-03-16','14:05:00',3.79),('16100','2013-03-16','14:10:00',4.9),('16100','2013-03-16','14:15:00',4.59),('16100','2013-03-16','14:20:00',4.62),('16100','2013-03-16','14:25:00',3.92),('16100','2013-03-16','14:30:00',3.92),('16100','2013-03-16','14:35:00',4.81),('16100','2013-03-16','14:40:00',3.09),('16100','2013-03-16','14:45:00',2.4),('16100','2013-03-16','14:50:00',1.95),('16100','2013-03-16','14:55:00',2.37),('16100','2013-03-16','15:00:00',2.75),('16100','2013-03-16','15:05:00',4.05),('16100','2013-03-16','15:10:00',5.99),('16100','2013-03-16','15:15:00',3.5),('16100','2013-03-16','15:20:00',4.91),('16100','2013-03-16','15:25:00',4.71),('16100','2013-03-16','15:30:00',2.74),('16100','2013-03-16','15:35:00',2.44),('16100','2013-03-16','15:40:00',1.73),('16100','2013-03-16','15:45:00',1.51),('16100','2013-03-16','15:50:00',1.08),('16100','2013-03-16','15:55:00',1.23),('16100','2013-03-16','16:40:00',1.35),('16100','2013-03-16','16:45:00',1.61),('16100','2013-03-15','07:45:00',1.02),('16100','2013-03-15','07:50:00',1.44),('16100','2013-03-15','07:55:00',2.51),('16100','2013-03-15','08:00:00',1.83),('16100','2013-03-15','08:05:00',2.43),('16100','2013-03-15','08:10:00',3.24),('16100','2013-03-15','08:15:00',2.41),('16100','2013-03-15','08:20:00',2.71),('16100','2013-03-15','08:25:00',3.82),('16100','2013-03-15','08:30:00',4.08),('16100','2013-03-15','08:35:00',4.49),('16100','2013-03-15','08:40:00',4.86),('16100','2013-03-15','08:45:00',4.82),('16100','2013-03-15','08:50:00',5.25),('16100','2013-03-15','08:55:00',2.49),('16100','2013-03-15','09:00:00',4.57),('16100','2013-03-15','09:05:00',5.23),('16100','2013-03-15','09:10:00',5.39),('16100','2013-03-15','09:15:00',5.6),('16100','2013-03-15','09:20:00',5.74),('16100','2013-03-15','09:25:00',5.42),('16100','2013-03-15','09:30:00',6.01),('16100','2013-03-15','09:35:00',6.04),('16100','2013-03-15','09:40:00',4.28),('16100','2013-03-15','09:45:00',4.26),('16100','2013-03-15','09:50:00',6.6),('16100','2013-03-15','09:55:00',4.05),('16100','2013-03-15','10:00:00',4.51),('16100','2013-03-15','10:05:00',4.21),('16100','2013-03-15','10:10:00',3.78),('16100','2013-03-15','10:15:00',3.38),('16100','2013-03-15','10:20:00',3.53),('16100','2013-03-15','10:25:00',3.77),('16100','2013-03-15','10:30:00',6.97),('16100','2013-03-15','10:35:00',7.82),('16100','2013-03-15','10:40:00',7.64),('16100','2013-03-15','10:45:00',7.66),('16100','2013-03-15','10:50:00',7.76),('16100','2013-03-15','10:55:00',7.84),('16100','2013-03-15','11:00:00',7.92),('16100','2013-03-15','11:05:00',7.86),('16100','2013-03-15','11:10:00',7.91),('16100','2013-03-15','11:15:00',7.93),('16100','2013-03-15','11:20:00',8.03),('16100','2013-03-15','11:25:00',8.08),('16100','2013-03-15','11:30:00',8.07),('16100','2013-03-15','11:35:00',8.1),('16100','2013-03-15','11:40:00',8.19),('16100','2013-03-15','11:45:00',8.22),('16100','2013-03-15','11:50:00',8.18),('16100','2013-03-15','11:55:00',8.16),('16100','2013-03-15','12:00:00',8.16),('16100','2013-03-15','12:05:00',8.2),('16100','2013-03-15','12:10:00',8.2),('16100','2013-03-15','12:15:00',8.29),('16100','2013-03-15','12:20:00',8.42),('16100','2013-03-15','12:25:00',8.3),('16100','2013-03-15','12:30:00',8.35),('16100','2013-03-15','12:35:00',8.13),('16100','2013-03-15','12:40:00',7.58),('16100','2013-03-15','12:45:00',5.12),('16100','2013-03-15','12:50:00',8.55),('16100','2013-03-15','12:55:00',8.43),('16100','2013-03-15','13:00:00',8.34),('16100','2013-03-15','13:05:00',8.26),('16100','2013-03-15','13:10:00',8.21),('16100','2013-03-15','13:15:00',8.21),('16100','2013-03-15','13:20:00',8.17),('16100','2013-03-15','13:25:00',7.47),('16100','2013-03-15','13:30:00',3.22),('16100','2013-03-15','13:35:00',7.25),('16100','2013-03-15','13:40:00',4.37),('16100','2013-03-15','13:45:00',3.41),('16100','2013-03-15','13:50:00',6.22),('16100','2013-03-15','13:55:00',4.51),('16100','2013-03-15','14:00:00',6.33),('16100','2013-03-15','14:05:00',4.78),('16100','2013-03-15','14:10:00',6.43),('16100','2013-03-15','14:15:00',1.61),('16100','2013-03-15','14:20:00',5.18),('16100','2013-03-15','14:25:00',5),('16100','2013-03-15','14:30:00',2.71),('16100','2013-03-15','14:35:00',1.4),('16100','2013-03-15','14:40:00',2.41),('16100','2013-03-15','14:45:00',1.09),('16100','2013-03-15','14:50:00',1.4),('16100','2013-03-15','14:55:00',1.09),('16100','2013-03-15','15:10:00',1.27),('16100','2013-03-15','15:15:00',5.05),('16100','2013-03-15','15:20:00',5.82),('16100','2013-03-15','15:25:00',5.65),('16100','2013-03-15','15:30:00',5.49),('16100','2013-03-15','15:35:00',5.25),('16100','2013-03-15','15:40:00',5.11),('16100','2013-03-15','15:45:00',3.56),('16100','2013-03-15','15:50:00',2.17),('16100','2013-03-15','15:55:00',4.51),('16100','2013-03-15','16:00:00',4.34),('16100','2013-03-15','16:05:00',4.22),('16100','2013-03-15','16:10:00',2.69),('16100','2013-03-15','16:15:00',1.27),('16100','2013-03-15','16:20:00',2.28),('16100','2013-03-15','16:25:00',3.77),('16100','2013-03-15','16:30:00',3.55),('16100','2013-03-15','16:35:00',3.46),('16100','2013-03-15','16:40:00',3.18),('16100','2013-03-15','16:45:00',2.95),('16100','2013-03-15','16:50:00',2.74),('16100','2013-03-15','16:55:00',1.45),('16100','2013-03-15','17:00:00',1.16),('16100','2013-03-15','17:15:00',1.47),('16100','2013-03-15','17:20:00',1.33),('16100','2013-03-15','17:25:00',1.08),('16100','2013-03-14','10:05:00',1.07),('16100','2013-03-14','10:10:00',1.03),('16100','2013-03-14','10:15:00',1.05),('16100','2013-03-14','10:20:00',1.17),('16100','2013-03-14','10:25:00',1.43),('16100','2013-03-14','10:30:00',1.76),('16100','2013-03-14','10:35:00',2.1),('16100','2013-03-14','10:40:00',2.24),('16100','2013-03-14','10:45:00',2.04),('16100','2013-03-14','10:50:00',2.23),('16100','2013-03-14','10:55:00',2.59),('16100','2013-03-14','11:00:00',2.71),('16100','2013-03-14','11:05:00',2.21),('16100','2013-03-14','11:10:00',1.62),('16100','2013-03-14','11:15:00',1.59),('16100','2013-03-14','11:20:00',1.53),('16100','2013-03-14','11:25:00',1.72),('16100','2013-03-14','11:30:00',2.17),('16100','2013-03-14','11:35:00',2.46),('16100','2013-03-14','11:40:00',2.96),('16100','2013-03-14','11:45:00',2.95),('16100','2013-03-14','11:50:00',2.64),('16100','2013-03-14','11:55:00',2.94),('16100','2013-03-14','12:00:00',2.84),('16100','2013-03-14','12:05:00',2.79),('16100','2013-03-14','12:10:00',2.67),('16100','2013-03-14','12:15:00',3.26),('16100','2013-03-14','12:20:00',3.39),('16100','2013-03-14','12:25:00',3.38),('16100','2013-03-14','12:30:00',3.09),('16100','2013-03-14','12:35:00',2.63),('16100','2013-03-14','12:40:00',2.18),('16100','2013-03-14','12:45:00',2.22),('16100','2013-03-14','12:50:00',2.23),('16100','2013-03-14','12:55:00',2.05),('16100','2013-03-14','13:00:00',1.93),('16100','2013-03-14','13:05:00',2.18),('16100','2013-03-14','13:10:00',2.68),('16100','2013-03-14','13:15:00',3.25),('16100','2013-03-14','13:20:00',3.56),('16100','2013-03-14','13:25:00',3.43),('16100','2013-03-14','13:30:00',2.63),('16100','2013-03-14','13:35:00',2.49),('16100','2013-03-14','13:40:00',2.23),('16100','2013-03-14','13:45:00',1.85),('16100','2013-03-14','13:50:00',1.9),('16100','2013-03-14','13:55:00',1.68),('16100','2013-03-14','14:00:00',1.41),('16100','2013-03-14','14:05:00',1.24),('16100','2013-03-14','14:10:00',1.07),('16100','2013-03-14','14:35:00',1.19),('16100','2013-03-14','14:40:00',1.55),('16100','2013-03-14','14:45:00',1.8),('16100','2013-03-14','14:50:00',1.92),('16100','2013-03-14','14:55:00',1.89),('16100','2013-03-14','15:00:00',1.88),('16100','2013-03-14','15:05:00',1.91),('16100','2013-03-14','15:10:00',1.88),('16100','2013-03-14','15:15:00',2.15),('16100','2013-03-14','15:20:00',2.51),('16100','2013-03-14','15:25:00',1.98),('16100','2013-03-14','15:30:00',1.57),('16100','2013-03-14','15:35:00',1.45),('16100','2013-03-14','15:40:00',1.39),('16100','2013-03-14','15:45:00',1.28),('16100','2013-03-14','15:50:00',1.19),('16100','2013-03-14','15:55:00',1.14),('16100','2013-03-14','16:00:00',1.08),('16100','2013-03-14','16:05:00',1.01),('16100','2013-03-14','17:00:00',1.56),('16100','2013-03-14','17:05:00',1.62),('16100','2013-03-14','17:10:00',1.09),('16100','2013-03-14','17:15:00',1.43),('16100','2013-03-14','17:20:00',1.01),('16100','2013-03-13','09:40:00',1.1),('16100','2013-03-13','09:45:00',1.22),('16100','2013-03-13','09:50:00',1.3),('16100','2013-03-13','09:55:00',1.28),('16100','2013-03-13','10:00:00',1.2),('16100','2013-03-13','10:05:00',1.18),('16100','2013-03-13','10:10:00',1.18),('16100','2013-03-13','10:15:00',1.17),('16100','2013-03-13','10:20:00',1.15),('16100','2013-03-13','10:25:00',1.05),('16100','2013-03-13','11:20:00',1.09),('16100','2013-03-13','11:25:00',1.17),('16100','2013-03-13','11:30:00',1.12),('16100','2013-03-13','11:35:00',1.01),('16100','2013-03-13','12:20:00',1.09),('16100','2013-03-13','12:25:00',1.18),('16100','2013-03-13','12:30:00',1.34),('16100','2013-03-13','12:35:00',1.53),('16100','2013-03-13','12:40:00',1.66),('16100','2013-03-13','12:45:00',1.61),('16100','2013-03-13','12:50:00',1.49),('16100','2013-03-13','12:55:00',1.65),('16100','2013-03-13','13:00:00',1.64),('16100','2013-03-13','13:05:00',1.87),('16100','2013-03-13','13:10:00',2.08),('16100','2013-03-13','13:15:00',1.91),('16100','2013-03-13','13:20:00',2.01),('16100','2013-03-13','13:25:00',2.42),('16100','2013-03-13','13:30:00',3.08),('16100','2013-03-13','13:35:00',2.92),('16100','2013-03-13','13:40:00',3.05),('16100','2013-03-13','13:45:00',3.19),('16100','2013-03-13','13:50:00',2.56),('16100','2013-03-13','13:55:00',1.98),('16100','2013-03-13','14:00:00',1.69),('16100','2013-03-13','14:05:00',1.96),('16100','2013-03-13','14:10:00',2.32),('16100','2013-03-13','14:15:00',2.52),('16100','2013-03-13','14:20:00',2.12),('16100','2013-03-13','14:25:00',1.21),('16100','2013-03-13','15:05:00',1.33),('16100','2013-03-13','15:10:00',1.41),('16100','2013-03-13','15:15:00',1.54),('16100','2013-03-13','15:20:00',1.68),('16100','2013-03-13','15:25:00',1.65),('16100','2013-03-13','15:30:00',1.21),('16100','2013-03-13','16:25:00',1.01),('16100','2013-03-12','08:10:00',1.11),('16100','2013-03-12','08:50:00',1.01),('16100','2013-03-12','08:55:00',1.06),('16100','2013-03-12','09:00:00',1.02),('16100','2013-03-12','09:05:00',1.12),('16100','2013-03-12','09:10:00',1.65),('16100','2013-03-12','09:15:00',1.71),('16100','2013-03-12','09:20:00',1.24),('16100','2013-03-12','09:25:00',1.06),('16100','2013-03-12','09:30:00',1.07),('16100','2013-03-12','09:40:00',1.29),('16100','2013-03-12','09:45:00',1.77),('16100','2013-03-12','09:50:00',1.14),('16100','2013-03-12','10:05:00',1.11),('16100','2013-03-12','10:10:00',1.41),('16100','2013-03-12','10:15:00',1.94),('16100','2013-03-12','10:20:00',1.43),('16100','2013-03-12','10:30:00',1.67),('16100','2013-03-12','10:35:00',2.67),('16100','2013-03-12','10:40:00',3.88),('16100','2013-03-12','10:45:00',5.21),('16100','2013-03-12','10:50:00',2.61),('16100','2013-03-12','10:55:00',2.42),('16100','2013-03-12','11:00:00',1.62),('16100','2013-03-12','11:05:00',2.99),('16100','2013-03-12','11:10:00',2.67),('16100','2013-03-12','11:15:00',2.93),('16100','2013-03-12','11:20:00',2.34),('16100','2013-03-12','11:25:00',2.65),('16100','2013-03-12','11:30:00',2.43),('16100','2013-03-12','11:35:00',2.58),('16100','2013-03-12','11:40:00',2.35),('16100','2013-03-12','11:45:00',2.52),('16100','2013-03-12','11:50:00',2.17),('16100','2013-03-12','11:55:00',1.74),('16100','2013-03-12','12:35:00',1.31),('16100','2013-03-12','12:40:00',1.56),('16100','2013-03-12','12:45:00',1.7),('16100','2013-03-12','12:50:00',1.87),('16100','2013-03-12','12:55:00',1.81),('16100','2013-03-12','13:00:00',1.59),('16100','2013-03-12','13:05:00',1.42),('16100','2013-03-12','13:10:00',1.45),('16100','2013-03-12','13:15:00',1.27),('16100','2013-03-12','13:20:00',1.03),('16100','2013-03-12','13:30:00',1.34),('16100','2013-03-12','13:35:00',1.99),('16100','2013-03-12','13:40:00',2.51),('16100','2013-03-12','13:45:00',2.02),('16100','2013-03-12','13:50:00',1.41),('16100','2013-03-12','13:55:00',1.18),('16100','2014-03-24','07:15:00',1.34),('16100','2014-03-24','07:20:00',1.62),('16100','2014-03-24','07:25:00',1.78),('16100','2014-03-24','07:30:00',1.96),('16100','2014-03-24','07:35:00',1.53),('16100','2014-03-24','07:40:00',1.51),('16100','2014-03-24','07:45:00',1.67),('16100','2014-03-24','07:50:00',1.85),('16100','2014-03-24','07:55:00',1.54),('16100','2014-03-24','08:00:00',1.68),('16100','2014-03-24','08:05:00',1.79),('16100','2014-03-24','08:10:00',1.91),('16100','2014-03-24','08:15:00',1.89),('16100','2014-03-24','08:20:00',1.76),('16100','2014-03-24','08:25:00',1.64),('16100','2014-03-24','08:30:00',1.57),('16100','2014-03-24','08:35:00',1.76),('16100','2014-03-24','08:40:00',2.23),('16100','2014-03-24','08:45:00',2.72),('16100','2014-03-24','08:50:00',2.79),('16100','2014-03-24','08:55:00',2.95),('16100','2014-03-24','09:00:00',2.79),('16100','2014-03-24','09:05:00',2.9),('16100','2014-03-24','09:10:00',3.08),('16100','2014-03-24','09:15:00',3.91),('16100','2014-03-24','09:20:00',3.95),('16100','2014-03-24','09:25:00',3.36),('16100','2014-03-24','09:30:00',3.03),('16100','2014-03-24','09:35:00',2.98),('16100','2014-03-24','09:40:00',2.93),('16100','2014-03-24','09:45:00',2.99),('16100','2014-03-24','09:50:00',3.3),('16100','2014-03-24','09:55:00',3.64),('16100','2014-03-24','10:00:00',4.22),('16100','2014-03-24','10:05:00',4.56),('16100','2014-03-24','10:10:00',4.78),('16100','2014-03-24','10:15:00',5.14),('16100','2014-03-24','10:20:00',5.7),('16100','2014-03-24','10:25:00',5.05),('16100','2014-03-24','10:30:00',4.15),('16100','2014-03-24','10:35:00',3.69),('16100','2014-03-24','10:40:00',3.47),('16100','2014-03-24','10:45:00',3.07),('16100','2014-03-24','10:50:00',3.12),('16100','2014-03-24','10:55:00',3.72),('16100','2014-03-24','11:00:00',4.16),('16100','2014-03-24','11:05:00',4.61),('16100','2014-03-24','11:10:00',4.87),('16100','2014-03-24','11:15:00',4.89),('16100','2014-03-24','11:20:00',5.28),('16100','2014-03-24','11:25:00',4.79),('16100','2014-03-24','11:30:00',5.95),('16100','2014-03-24','11:35:00',5.97),('16100','2014-03-24','11:40:00',5.46),('16100','2014-03-24','11:45:00',4.54),('16100','2014-03-24','11:50:00',3.62),('16100','2014-03-24','11:55:00',3.06),('16100','2014-03-24','12:00:00',1.99),('16100','2014-03-24','12:05:00',1.63),('16100','2014-03-24','12:10:00',1.47),('16100','2014-03-24','12:15:00',1.49),('16100','2014-03-24','12:20:00',1.66),('16100','2014-03-24','12:25:00',2.06),('16100','2014-03-24','12:30:00',2),('16100','2014-03-24','12:35:00',1.59),('16100','2014-03-24','12:40:00',1.41),('16100','2014-03-24','12:45:00',1.55),('16100','2014-03-24','12:50:00',1.52),('16100','2014-03-24','12:55:00',1.71),('16100','2014-03-24','13:00:00',1.36),('16100','2014-03-24','15:15:00',1.02),('16100','2013-03-11','08:25:00',3.37),('16100','2013-03-11','08:30:00',3.48),('16100','2013-03-11','08:35:00',3.54),('16100','2013-03-11','08:40:00',3.78),('16100','2013-03-11','08:45:00',3.78),('16100','2013-03-11','08:50:00',4.21),('16100','2013-03-11','08:55:00',4.31),('16100','2013-03-11','09:00:00',4.54),('16100','2013-03-11','09:05:00',4.69),('16100','2013-03-11','09:10:00',4.86),('16100','2013-03-11','09:15:00',5.04),('16100','2013-03-11','09:20:00',5.2),('16100','2013-03-11','09:25:00',5.38),('16100','2013-03-11','09:30:00',5.11),('16100','2013-03-11','09:35:00',5.77),('16100','2013-03-11','09:40:00',5.76),('16100','2013-03-11','09:45:00',5.95),('16100','2013-03-11','09:50:00',5.05),('16100','2013-03-11','09:55:00',6.26),('16100','2013-03-11','10:00:00',6.81),('16100','2013-03-11','10:05:00',7.01),('16100','2013-03-11','10:10:00',4.5),('16100','2013-03-11','10:15:00',6.58),('16100','2013-03-11','10:20:00',7.31),('16100','2013-03-11','10:25:00',6.84),('16100','2013-03-11','10:30:00',7.54),('16100','2013-03-11','10:35:00',7.59),('16100','2013-03-11','10:40:00',7.51),('16100','2013-03-11','10:45:00',7.69),('16100','2013-03-11','10:50:00',7.62),('16100','2013-03-11','10:55:00',5.25),('16100','2013-03-11','11:00:00',6.15),('16100','2013-03-11','11:05:00',8.15),('16100','2013-03-11','11:10:00',7.32),('16100','2013-03-11','11:15:00',7.94),('16100','2013-03-11','11:20:00',6.94),('16100','2013-03-11','11:25:00',2.26),('16100','2013-03-11','11:30:00',1.62),('16100','2013-03-11','11:35:00',2.12),('16100','2013-03-11','11:40:00',3.37),('16100','2013-03-11','11:45:00',2.72),('16100','2013-03-11','11:50:00',2.66),('16100','2013-03-11','11:55:00',8.84),('16100','2013-03-11','12:00:00',9.43),('16100','2013-03-11','12:05:00',6.17),('16100','2013-03-11','12:10:00',1.76),('16100','2013-03-11','12:20:00',1.75),('16100','2013-03-11','12:25:00',2.19),('16100','2013-03-11','12:30:00',2.34),('16100','2013-03-11','12:35:00',7.64),('16100','2013-03-11','12:40:00',6.37),('16100','2013-03-11','12:45:00',4.63),('16100','2013-03-11','12:50:00',9.53),('16100','2013-03-11','12:55:00',7.38),('16100','2013-03-11','13:00:00',4.88),('16100','2013-03-11','13:05:00',4.02),('16100','2013-03-11','13:10:00',5.96),('16100','2013-03-11','13:15:00',6.46),('16100','2013-03-11','13:20:00',3.99),('16100','2013-03-11','13:25:00',3),('16100','2013-03-11','13:30:00',3.33),('16100','2013-03-11','13:35:00',3.76),('16100','2013-03-11','13:40:00',6.12),('16100','2013-03-11','13:45:00',5.44),('16100','2013-03-11','13:50:00',7.1),('16100','2013-03-11','13:55:00',6.22),('16100','2013-03-11','14:00:00',6.77),('16100','2013-03-11','14:05:00',7.49),('16100','2013-03-11','14:10:00',4.35),('16100','2013-03-11','14:15:00',5.7),('16100','2013-03-11','14:20:00',5.56),('16100','2013-03-11','14:25:00',5.6),('16100','2013-03-11','14:30:00',2.41),('16100','2013-03-11','14:55:00',3.47),('16100','2013-03-11','15:00:00',4.59),('16100','2013-03-11','15:05:00',2.21),('16100','2013-03-11','15:10:00',3.11),('16100','2013-03-11','15:15:00',4.6),('16100','2013-03-11','15:20:00',2.76),('16100','2013-03-11','15:25:00',2.09),('16100','2013-03-11','15:30:00',1.18),('16100','2013-03-11','15:35:00',1.12),('16100','2013-03-10','07:50:00',1.64),('16100','2013-03-10','07:55:00',2.23),('16100','2013-03-10','08:00:00',1.94),('16100','2013-03-10','08:05:00',1.97),('16100','2013-03-10','08:10:00',2.67),('16100','2013-03-10','08:15:00',2.91),('16100','2013-03-10','08:20:00',3.24),('16100','2013-03-10','08:25:00',3.27),('16100','2013-03-10','08:30:00',3.41),('16100','2013-03-10','08:35:00',3.6),('16100','2013-03-10','08:40:00',3.89),('16100','2013-03-10','08:45:00',2.56),('16100','2013-03-10','08:50:00',3.53),('16100','2013-03-10','08:55:00',4.44),('16100','2013-03-10','09:00:00',4.6),('16100','2013-03-10','09:05:00',4.72),('16100','2013-03-10','09:10:00',4.88),('16100','2013-03-10','09:15:00',5.05),('16100','2013-03-10','09:20:00',5.26),('16100','2013-03-10','09:25:00',5.75),('16100','2013-03-10','09:30:00',5.72),('16100','2013-03-10','09:35:00',5.94),('16100','2013-03-10','09:40:00',5.45),('16100','2013-03-10','09:45:00',3.7),('16100','2013-03-10','09:50:00',1.87),('16100','2013-03-10','09:55:00',1.55),('16100','2013-03-10','10:00:00',2.28),('16100','2013-03-10','10:05:00',2.73),('16100','2013-03-10','10:10:00',3.3),('16100','2013-03-10','10:15:00',2.9),('16100','2013-03-10','10:20:00',2.7),('16100','2013-03-10','10:25:00',2.76),('16100','2013-03-10','10:30:00',2.75),('16100','2013-03-10','10:35:00',2.87),('16100','2013-03-10','10:40:00',3.64),('16100','2013-03-10','10:45:00',3.27),('16100','2013-03-10','10:50:00',3.31),('16100','2013-03-10','10:55:00',2.54),('16100','2013-03-10','11:00:00',2.7),('16100','2013-03-10','11:05:00',2.41),('16100','2013-03-10','11:10:00',1.98),('16100','2013-03-10','11:15:00',2),('16100','2013-03-10','11:20:00',3.37),('16100','2013-03-10','11:25:00',3.66),('16100','2013-03-10','11:30:00',4.94),('16100','2013-03-10','11:35:00',5.77),('16100','2013-03-10','11:40:00',3.6),('16100','2013-03-10','11:45:00',2.83),('16100','2013-03-10','11:50:00',2.64),('16100','2013-03-10','11:55:00',1.78),('16100','2013-03-10','12:00:00',2.14),('16100','2013-03-10','12:05:00',2.07),('16100','2013-03-10','12:10:00',3.7),('16100','2013-03-10','12:15:00',7.41),('16100','2013-03-10','12:20:00',8.6),('16100','2013-03-10','12:25:00',7.18),('16100','2013-03-10','12:30:00',2.46),('16100','2013-03-10','12:35:00',8.95),('16100','2013-03-10','12:40:00',8.53),('16100','2013-03-10','12:45:00',7.49),('16100','2013-03-10','12:50:00',8.6),('16100','2013-03-10','12:55:00',7.18),('16100','2013-03-10','13:00:00',8.31),('16100','2013-03-10','13:05:00',8.27),('16100','2013-03-10','13:10:00',8.09),('16100','2013-03-10','13:15:00',7.82),('16100','2013-03-10','13:20:00',5.91),('16100','2013-03-10','13:25:00',7.76),('16100','2013-03-10','13:30:00',7.78),('16100','2013-03-10','13:35:00',6.36),('16100','2013-03-10','13:40:00',7.03),('16100','2013-03-10','13:45:00',6.88),('16100','2013-03-10','13:50:00',6.4),('16100','2013-03-10','13:55:00',8.21),('16100','2013-03-10','14:00:00',6.21),('16100','2013-03-10','14:05:00',7.68),('16100','2013-03-10','14:10:00',7.25),('16100','2013-03-10','14:15:00',7.52),('16100','2013-03-10','14:20:00',5.26),('16100','2013-03-10','14:25:00',2.77),('16100','2013-03-10','14:30:00',3.01),('16100','2013-03-10','14:35:00',3.51),('16100','2013-03-10','14:40:00',4.54),('16100','2013-03-10','14:45:00',7.12),('16100','2013-03-10','14:50:00',4.4),('16100','2013-03-10','14:55:00',6.46),('16100','2013-03-10','15:00:00',6.16),('16100','2013-03-10','15:05:00',6.43),('16100','2013-03-10','15:10:00',6.42),('16100','2013-03-10','15:15:00',6.04),('16100','2013-03-10','15:20:00',4.22),('16100','2013-03-10','15:25:00',4.12),('16100','2013-03-10','15:30:00',4.95),('16100','2013-03-10','15:35:00',5.25),('16100','2013-03-10','15:40:00',2.95),('16100','2013-03-10','15:45:00',3.54),('16100','2013-03-10','15:50:00',4.85),('16100','2013-03-10','15:55:00',3.92),('16100','2013-03-10','16:00:00',3.51),('16100','2013-03-10','16:05:00',3.54),('16100','2013-03-10','16:10:00',3.29),('16100','2013-03-10','16:15:00',3.47),('16100','2013-03-10','16:20:00',3.25),('16100','2013-03-10','16:25:00',3.06),('16100','2013-03-10','16:30:00',2.91),('16100','2013-03-10','16:35:00',2.28),('16100','2013-03-10','16:40:00',2.16),('16100','2013-03-10','16:45:00',1.48),('16100','2013-03-10','17:00:00',1.05),('16100','2013-03-10','17:05:00',1.26),('16100','2013-03-10','17:10:00',1.13),('16100','2013-03-09','07:35:00',1.15),('16100','2013-03-09','07:40:00',1.31),('16100','2013-03-09','07:45:00',1.59),('16100','2013-03-09','07:50:00',1.84),('16100','2013-03-09','07:55:00',2.02),('16100','2013-03-09','08:00:00',2.2),('16100','2013-03-09','08:05:00',2.46),('16100','2013-03-09','08:10:00',2.26),('16100','2013-03-09','08:15:00',2.63),('16100','2013-03-09','08:20:00',3.09),('16100','2013-03-09','08:25:00',3.3),('16100','2013-03-09','08:30:00',3.48),('16100','2013-03-09','08:35:00',1.8),('16100','2013-03-09','08:40:00',3.46),('16100','2013-03-09','08:45:00',4.01),('16100','2013-03-09','08:50:00',4.22),('16100','2013-03-09','08:55:00',4.4),('16100','2013-03-09','09:00:00',4.58),('16100','2013-03-09','09:05:00',4.72),('16100','2013-03-09','09:10:00',4.87),('16100','2013-03-09','09:15:00',5.04),('16100','2013-03-09','09:20:00',5.17),('16100','2013-03-09','09:25:00',5.32),('16100','2013-03-09','09:30:00',5.54),('16100','2013-03-09','09:35:00',5.74),('16100','2013-03-09','09:40:00',5.81),('16100','2013-03-09','09:45:00',4.39),('16100','2013-03-09','09:50:00',3.92),('16100','2013-03-09','09:55:00',6.39),('16100','2013-03-09','10:00:00',6.63),('16100','2013-03-09','10:05:00',6.01),('16100','2013-03-09','10:10:00',4.63),('16100','2013-03-09','10:15:00',6.74),('16100','2013-03-09','10:20:00',4.98),('16100','2013-03-09','10:25:00',7.1),('16100','2013-03-09','10:30:00',4.25),('16100','2013-03-09','10:35:00',7.35),('16100','2013-03-09','10:40:00',4.92),('16100','2013-03-09','10:45:00',7.33),('16100','2013-03-09','10:50:00',7.27),('16100','2013-03-09','10:55:00',7.27),('16100','2013-03-09','11:00:00',7.29),('16100','2013-03-09','11:05:00',6.92),('16100','2013-03-09','11:10:00',7.58),('16100','2013-03-09','11:15:00',6.36),('16100','2013-03-09','11:20:00',7.74),('16100','2013-03-09','11:25:00',6.72),('16100','2013-03-09','11:30:00',8.15),('16100','2013-03-09','11:35:00',6.9),('16100','2013-03-09','11:40:00',4.83),('16100','2013-03-09','11:45:00',7.14),('16100','2013-03-09','11:50:00',8.04),('16100','2013-03-09','11:55:00',7.75),('16100','2013-03-09','12:00:00',7.37),('16100','2013-03-09','12:05:00',7.76),('16100','2013-03-09','12:10:00',7.86),('16100','2013-03-09','12:15:00',7.97),('16100','2013-03-09','12:20:00',7.84),('16100','2013-03-09','12:25:00',6.24),('16100','2013-03-09','12:30:00',5.68),('16100','2013-03-09','12:35:00',5.33),('16100','2013-03-09','12:40:00',5.67),('16100','2013-03-09','12:45:00',2.93),('16100','2013-03-09','12:50:00',7.33),('16100','2013-03-09','12:55:00',7.09),('16100','2013-03-09','13:00:00',4.68),('16100','2013-03-09','13:05:00',7.26),('16100','2013-03-09','13:10:00',8.14),('16100','2013-03-09','13:15:00',7.9),('16100','2013-03-09','13:20:00',8.17),('16100','2013-03-09','13:25:00',8.3),('16100','2013-03-09','13:30:00',7.55),('16100','2013-03-09','13:35:00',6.19),('16100','2013-03-09','13:40:00',3.29),('16100','2013-03-09','13:45:00',2.68),('16100','2013-03-09','13:50:00',2.59),('16100','2013-03-09','13:55:00',2.65),('16100','2013-03-09','14:00:00',2.61),('16100','2013-03-09','14:05:00',3.27),('16100','2013-03-09','14:10:00',3.1),('16100','2013-03-09','14:15:00',3.16),('16100','2013-03-09','14:20:00',3.49),('16100','2013-03-09','14:25:00',3.81),('16100','2013-03-09','14:30:00',3.46),('16100','2013-03-09','14:35:00',2.58),('16100','2013-03-09','14:40:00',2.58),('16100','2013-03-09','14:45:00',2.11),('16100','2013-03-09','14:50:00',2.66),('16100','2013-03-09','14:55:00',2.13),('16100','2013-03-09','15:00:00',1.25),('16100','2013-03-09','15:05:00',1.49),('16100','2013-03-09','15:10:00',1.4),('16100','2013-03-09','15:15:00',1.49),('16100','2013-03-09','15:20:00',1.11),('16100','2013-03-09','15:50:00',1.2),('16100','2013-03-08','07:45:00',1.51),('16100','2013-03-08','08:10:00',2.6),('16100','2013-03-08','08:15:00',2.84),('16100','2013-03-08','08:20:00',3.08),('16100','2013-03-08','08:25:00',3.23),('16100','2013-03-08','08:30:00',3.42),('16100','2013-03-08','08:35:00',3.58),('16100','2013-03-08','08:40:00',3.75),('16100','2013-03-08','08:45:00',3.97),('16100','2013-03-08','08:50:00',4.15),('16100','2013-03-08','08:55:00',4.32),('16100','2013-03-08','09:00:00',3.83),('16100','2013-03-08','09:05:00',3.28),('16100','2013-03-08','09:10:00',4.28),('16100','2013-03-08','09:15:00',3.11),('16100','2013-03-08','09:20:00',2.63),('16100','2013-03-08','09:25:00',2.85),('16100','2013-03-08','09:30:00',2.14),('16100','2013-03-08','09:35:00',2.15),('16100','2013-03-08','09:40:00',2.84),('16100','2013-03-08','09:45:00',2.48),('16100','2013-03-08','09:50:00',2.05),('16100','2013-03-08','09:55:00',1.59),('16100','2013-03-08','10:05:00',1.23),('16100','2013-03-08','10:10:00',3.06),('16100','2013-03-08','10:15:00',1.51),('16100','2013-03-08','10:20:00',2.28),('16100','2013-03-08','10:25:00',1.87),('16100','2013-03-08','10:30:00',5.86),('16100','2013-03-08','10:35:00',7.55),('16100','2013-03-08','10:40:00',5.18),('16100','2013-03-08','10:45:00',2.72),('16100','2013-03-08','10:50:00',8.3),('16100','2013-03-08','10:55:00',5.53),('16100','2013-03-08','11:00:00',7.62),('16100','2013-03-08','11:05:00',6.07),('16100','2013-03-08','11:10:00',7.55),('16100','2013-03-08','11:15:00',7.62),('16100','2013-03-08','11:20:00',7.71),('16100','2013-03-08','11:25:00',7.83),('16100','2013-03-08','11:30:00',7.63),('16100','2013-03-08','11:35:00',7.71),('16100','2013-03-08','11:40:00',7.76),('16100','2013-03-08','11:45:00',7.78),('16100','2013-03-08','11:50:00',7.73),('16100','2013-03-08','11:55:00',7.84),('16100','2013-03-08','12:00:00',7.81),('16100','2013-03-08','12:05:00',6.25),('16100','2013-03-08','12:10:00',7.78),('16100','2013-03-08','12:15:00',5.45),('16100','2013-03-08','12:20:00',4.69),('16100','2013-03-08','12:25:00',4.58),('16100','2013-03-08','12:30:00',6.27),('16100','2013-03-08','12:35:00',4.23),('16100','2013-03-08','12:40:00',5.06),('16100','2013-03-08','12:45:00',6.04),('16100','2013-03-08','12:50:00',8.25),('16100','2013-03-08','12:55:00',7.86),('16100','2013-03-08','13:00:00',5.39),('16100','2013-03-08','13:05:00',7.57),('16100','2013-03-08','13:10:00',6.74),('16100','2013-03-08','13:15:00',6.36),('16100','2013-03-08','13:20:00',7.39),('16100','2013-03-08','13:25:00',7.28),('16100','2013-03-08','13:30:00',7.56),('16100','2013-03-08','13:35:00',7.12),('16100','2013-03-08','13:40:00',7.27),('16100','2013-03-08','13:45:00',7.32),('16100','2013-03-08','13:50:00',7.23),('16100','2013-03-08','13:55:00',7.13),('16100','2013-03-08','14:00:00',7.03),('16100','2013-03-08','14:05:00',6.98),('16100','2013-03-08','14:10:00',6.91),('16100','2013-03-08','14:15:00',4.28),('16100','2013-03-08','14:20:00',6.66),('16100','2013-03-08','14:25:00',4.91),('16100','2013-03-08','14:30:00',6.56),('16100','2013-03-08','14:35:00',6.25),('16100','2013-03-08','14:40:00',6.15),('16100','2013-03-08','14:45:00',6.08),('16100','2013-03-08','14:50:00',5.96),('16100','2013-03-08','14:55:00',5.79),('16100','2013-03-08','15:00:00',5.72),('16100','2013-03-08','15:05:00',5.58),('16100','2013-03-08','15:10:00',5.46),('16100','2013-03-08','15:15:00',5.36),('16100','2013-03-08','15:20:00',5.22),('16100','2013-03-08','15:25:00',5.01),('16100','2013-03-08','15:30:00',4.89),('16100','2013-03-08','15:35:00',4.75),('16100','2013-03-08','15:40:00',4.65),('16100','2013-03-08','15:45:00',4.52),('16100','2013-03-08','15:50:00',4.29),('16100','2013-03-08','15:55:00',3.93),('16100','2013-03-08','16:00:00',3.53),('16100','2013-03-08','16:05:00',2.92),('16100','2013-03-08','16:10:00',2.87),('16100','2013-03-08','16:15:00',2.54),('16100','2013-03-08','16:20:00',1.13),('16100','2013-03-08','16:25:00',2.13),('16100','2013-03-08','16:30:00',1.82),('16100','2013-03-08','16:35:00',1.9),('16100','2013-03-08','16:40:00',1.77),('16100','2013-03-08','16:45:00',1.48),('16100','2013-03-08','16:50:00',1.06),('16100','2013-03-07','08:25:00',1.56),('16100','2013-03-07','08:30:00',1.87),('16100','2013-03-07','08:35:00',1.67),('16100','2013-03-07','08:40:00',1.95),('16100','2013-03-07','09:05:00',1.15),('16100','2013-03-07','09:10:00',3.5),('16100','2013-03-07','09:15:00',5.02),('16100','2013-03-07','09:20:00',4.86),('16100','2013-03-07','09:25:00',2.07),('16100','2013-03-07','09:30:00',2.42),('16100','2013-03-07','09:35:00',2.48),('16100','2013-03-07','09:40:00',3.38),('16100','2013-03-07','09:45:00',2.48),('16100','2013-03-07','09:50:00',2.33),('16100','2013-03-07','09:55:00',3.79),('16100','2013-03-07','10:00:00',1.92),('16100','2013-03-07','10:05:00',1.7),('16100','2013-03-07','10:10:00',1.84),('16100','2013-03-07','10:15:00',1.82),('16100','2013-03-07','10:20:00',3.35),('16100','2013-03-07','10:25:00',2.81),('16100','2013-03-07','10:30:00',2.32),('16100','2013-03-07','10:35:00',1.39),('16100','2013-03-07','10:40:00',1.29),('16100','2013-03-07','10:45:00',1.4),('16100','2013-03-07','11:40:00',1.01),('16100','2013-03-07','11:55:00',1.35),('16100','2013-03-07','12:00:00',1.6),('16100','2013-03-07','12:05:00',2.1),('16100','2013-03-07','12:10:00',1.71),('16100','2013-03-07','12:15:00',2.37),('16100','2013-03-07','12:20:00',3.91),('16100','2013-03-07','12:25:00',2.8),('16100','2013-03-07','12:30:00',2.02),('16100','2013-03-07','12:35:00',1.69),('16100','2013-03-07','12:40:00',1.9),('16100','2013-03-07','12:45:00',1.99),('16100','2013-03-07','12:50:00',3.48),('16100','2013-03-07','12:55:00',2.74),('16100','2013-03-07','13:00:00',3.6),('16100','2013-03-07','13:05:00',3),('16100','2013-03-07','13:10:00',2.57),('16100','2013-03-07','13:15:00',1.97),('16100','2013-03-07','13:20:00',1.73),('16100','2013-03-07','13:25:00',1.63),('16100','2013-03-07','13:30:00',1.83),('16100','2013-03-07','13:35:00',2.02),('16100','2013-03-07','13:40:00',1.07),('16100','2013-03-07','13:45:00',1.44),('16100','2013-03-07','17:10:00',1.47),('16100','2013-03-07','17:15:00',1.08),('16100','2013-03-06','08:45:00',1.15),('16100','2013-03-06','08:50:00',1.79),('16100','2013-03-06','08:55:00',2.18),('16100','2013-03-06','09:00:00',1.31),('16100','2013-03-06','09:15:00',1.2),('16100','2013-03-06','09:20:00',1.65),('16100','2013-03-06','09:25:00',1.51),('16100','2013-03-06','10:20:00',1.17),('16100','2013-03-06','10:30:00',1.06),('16100','2013-03-06','10:35:00',1.94),('16100','2013-03-06','10:40:00',1.7),('16100','2013-03-06','10:45:00',1.89),('16100','2013-03-06','10:50:00',2.65),('16100','2013-03-06','10:55:00',3.2),('16100','2013-03-06','11:00:00',2.15),('16100','2013-03-06','11:05:00',1.76),('16100','2013-03-06','11:10:00',1.72),('16100','2013-03-06','11:15:00',1.16),('16100','2013-03-06','11:35:00',1.07),('16100','2013-03-06','11:40:00',4.43),('16100','2013-03-06','11:45:00',6.31),('16100','2013-03-06','11:50:00',5.19),('16100','2013-03-06','11:55:00',4.08),('16100','2013-03-06','12:00:00',3.68),('16100','2013-03-06','12:05:00',2.77),('16100','2013-03-06','12:10:00',1.32),('16100','2013-03-06','12:20:00',2.47),('16100','2013-03-06','12:25:00',4.83),('16100','2013-03-06','12:30:00',2.49),('16100','2013-03-06','12:35:00',1.35),('16100','2013-03-06','13:00:00',1.63),('16100','2013-03-06','13:05:00',3.21),('16100','2013-03-06','13:10:00',5.14),('16100','2013-03-06','13:15:00',5.81),('16100','2013-03-06','13:20:00',2.78),('16100','2013-03-06','13:25:00',1.75),('16100','2013-03-06','13:30:00',2.33),('16100','2013-03-06','13:35:00',3.04),('16100','2013-03-06','13:40:00',2.1),('16100','2013-03-06','14:00:00',1.07),('16100','2013-03-06','14:05:00',1.74),('16100','2013-03-06','14:10:00',1.36),('16100','2013-03-06','14:15:00',1.23),('16100','2013-03-06','14:20:00',1.41),('16100','2013-03-06','14:25:00',1.84),('16100','2013-03-06','14:40:00',1.4),('16100','2013-03-06','14:45:00',1.56),('16100','2013-03-06','14:50:00',1.05),('16100','2013-03-06','15:30:00',1.01),('16100','2013-03-06','15:35:00',1.22),('16100','2013-03-06','15:40:00',1.68),('16100','2013-03-06','15:45:00',1.55),('16100','2013-03-06','15:50:00',1.38),('16100','2013-03-06','16:35:00',1.79),('16100','2013-03-06','16:40:00',1.12),('16100','2013-03-06','16:45:00',1.04),('16100','2013-03-05','09:50:00',1.03),('16100','2013-03-04','08:00:00',1.07),('16100','2013-03-04','08:05:00',1.54),('16100','2013-03-04','08:10:00',1.91),('16100','2013-03-04','08:15:00',3.09),('16100','2013-03-04','08:20:00',1.69),('16100','2013-03-04','08:25:00',2.76),('16100','2013-03-04','08:30:00',2.22),('16100','2013-03-04','08:35:00',3.35),('16100','2013-03-04','08:40:00',3.51),('16100','2013-03-04','08:45:00',3),('16100','2013-03-04','08:50:00',3.3),('16100','2013-03-04','08:55:00',3.22),('16100','2013-03-04','09:00:00',2.6),('16100','2013-03-04','09:05:00',2.5),('16100','2013-03-04','09:10:00',2.32),('16100','2013-03-04','09:15:00',2.36),('16100','2013-03-04','09:20:00',2.44),('16100','2013-03-04','09:25:00',2.4),('16100','2013-03-04','09:30:00',2.58),('16100','2013-03-04','09:35:00',2.75),('16100','2013-03-04','09:40:00',2.83),('16100','2013-03-04','09:45:00',2.96),('16100','2013-03-04','09:50:00',2.82),('16100','2013-03-04','09:55:00',3.17),('16100','2013-03-04','10:00:00',3.83),('16100','2013-03-04','10:05:00',3.7),('16100','2013-03-04','10:10:00',2.95),('16100','2013-03-04','10:15:00',3.07),('16100','2013-03-04','10:20:00',3.75),('16100','2013-03-04','10:25:00',3.6),('16100','2013-03-04','10:30:00',3.06),('16100','2013-03-04','10:35:00',3.09),('16100','2013-03-04','10:40:00',4.1),('16100','2013-03-04','10:45:00',4.72),('16100','2013-03-04','10:50:00',5.13),('16100','2013-03-04','10:55:00',5.18),('16100','2013-03-04','11:00:00',5.14),('16100','2013-03-04','11:05:00',5.04),('16100','2013-03-04','11:10:00',5.39),('16100','2013-03-04','11:15:00',4.85),('16100','2013-03-04','11:20:00',4.72),('16100','2013-03-04','11:25:00',4.6),('16100','2013-03-04','11:30:00',4.64),('16100','2013-03-04','11:35:00',5.39),('16100','2013-03-04','11:40:00',5.55),('16100','2013-03-04','11:45:00',5.65),('16100','2013-03-04','11:50:00',5.98),('16100','2013-03-04','11:55:00',6.11),('16100','2013-03-04','12:00:00',6.01),('16100','2013-03-04','12:05:00',6.51),('16100','2013-03-04','12:10:00',6.2),('16100','2013-03-04','12:15:00',5.53),('16100','2013-03-04','12:20:00',6.51),('16100','2013-03-04','12:25:00',6),('16100','2013-03-04','12:30:00',5.32),('16100','2013-03-04','12:35:00',5.49),('16100','2013-03-04','12:40:00',4.99),('16100','2013-03-04','12:45:00',4.69),('16100','2013-03-04','12:50:00',4.37),('16100','2013-03-04','12:55:00',3.51),('16100','2013-03-04','13:00:00',2.84),('16100','2013-03-04','13:05:00',2.77),('16100','2013-03-04','13:10:00',3.06),('16100','2013-03-04','13:15:00',3.18),('16100','2013-03-04','13:20:00',2.92),('16100','2013-03-04','13:25:00',2.58),('16100','2013-03-04','13:30:00',2.26),('16100','2013-03-04','13:35:00',2.11),('16100','2013-03-04','13:40:00',1.94),('16100','2013-03-04','13:45:00',1.73),('16100','2013-03-04','13:50:00',1.6),('16100','2013-03-04','13:55:00',1.64),('16100','2013-03-04','14:00:00',1.7),('16100','2013-03-04','14:05:00',1.72),('16100','2013-03-04','14:10:00',1.55),('16100','2013-03-04','14:15:00',1.48),('16100','2013-03-04','14:20:00',1.49),('16100','2013-03-04','14:25:00',1.53),('16100','2013-03-04','14:30:00',1.53),('16100','2013-03-04','14:35:00',1.56),('16100','2013-03-04','14:40:00',1.57),('16100','2013-03-04','14:45:00',1.6),('16100','2013-03-04','14:50:00',1.5),('16100','2013-03-04','14:55:00',1.32),('16100','2013-03-04','15:00:00',1.19),('16100','2013-03-04','15:05:00',1.09),('16100','2013-03-04','15:25:00',1.15),('16100','2013-03-04','15:30:00',1.43),('16100','2013-03-04','15:35:00',1.5),('16100','2013-03-04','15:40:00',1.8),('16100','2013-03-04','15:45:00',2.13),('16100','2013-03-04','15:50:00',1.88),('16100','2013-03-04','15:55:00',1.55),('16100','2013-03-04','16:00:00',1.4),('16100','2013-03-04','16:05:00',1.2),('16100','2014-03-23','07:30:00',1.05),('16100','2014-03-23','07:35:00',1.14),('16100','2014-03-23','07:40:00',1.45),('16100','2014-03-23','07:45:00',1.3),('16100','2014-03-23','07:50:00',1.26),('16100','2014-03-23','08:30:00',1.26),('16100','2014-03-23','08:35:00',1.55),('16100','2014-03-23','08:40:00',1.18),('16100','2014-03-23','08:45:00',1.05),('16100','2014-03-23','08:50:00',1.86),('16100','2014-03-23','08:55:00',3.09),('16100','2014-03-23','09:00:00',1.13),('16100','2014-03-23','09:15:00',2.3),('16100','2014-03-23','09:20:00',5.4),('16100','2014-03-23','09:25:00',4.66),('16100','2014-03-23','09:30:00',2.03),('16100','2014-03-23','09:35:00',3.55),('16100','2014-03-23','09:40:00',3.17),('16100','2014-03-23','09:45:00',3.57),('16100','2014-03-23','09:50:00',1.21),('16100','2014-03-23','09:55:00',3.03),('16100','2014-03-23','10:00:00',6.33),('16100','2014-03-23','10:05:00',5.91),('16100','2014-03-23','10:10:00',6.13),('16100','2014-03-23','10:20:00',2.55),('16100','2014-03-23','10:25:00',1.45),('16100','2014-03-23','10:30:00',1.83),('16100','2014-03-23','10:35:00',1.75),('16100','2014-03-23','10:40:00',3.08),('16100','2014-03-23','10:45:00',2.4),('16100','2014-03-23','10:50:00',7.95),('16100','2014-03-23','10:55:00',7.83),('16100','2014-03-23','11:00:00',4.9),('16100','2014-03-23','11:05:00',5.88),('16100','2014-03-23','11:10:00',5.33),('16100','2014-03-23','11:15:00',7.07),('16100','2014-03-23','11:20:00',8.04),('16100','2014-03-23','11:25:00',8.36),('16100','2014-03-23','11:30:00',4.12),('16100','2014-03-23','11:35:00',1.46),('16100','2014-03-23','11:50:00',1.1),('16100','2014-03-23','12:20:00',1.37),('16100','2014-03-23','12:25:00',2.18),('16100','2014-03-23','12:30:00',2.72),('16100','2014-03-23','12:35:00',3.6),('16100','2014-03-23','12:40:00',3.11),('16100','2014-03-23','12:45:00',2.51),('16100','2014-03-23','12:50:00',2.47),('16100','2014-03-23','12:55:00',2.36),('16100','2014-03-23','13:00:00',2.18),('16100','2014-03-23','13:05:00',1.97),('16100','2014-03-23','13:10:00',2.33),('16100','2014-03-23','13:15:00',3.43),('16100','2014-03-23','13:20:00',3.7),('16100','2014-03-23','13:25:00',4.06),('16100','2014-03-23','13:30:00',3.81),('16100','2014-03-23','13:35:00',2.82),('16100','2014-03-23','13:40:00',2.24),('16100','2014-03-23','13:45:00',2.03),('16100','2014-03-23','13:50:00',1.9),('16100','2014-03-23','13:55:00',1.6),('16100','2014-03-23','14:00:00',1.74),('16100','2014-03-23','14:05:00',1.96),('16100','2014-03-23','14:10:00',2.21),('16100','2014-03-23','14:15:00',3.11),('16100','2014-03-23','14:20:00',4.02),('16100','2014-03-23','14:25:00',3.58),('16100','2014-03-23','14:30:00',3.83),('16100','2014-03-23','14:35:00',5.45),('16100','2014-03-23','14:40:00',6.1),('16100','2014-03-23','14:45:00',4.25),('16100','2014-03-23','14:50:00',4.82),('16100','2014-03-23','14:55:00',4.51),('16100','2014-03-23','15:00:00',2.85),('16100','2014-03-23','15:05:00',3.77),('16100','2014-03-23','15:10:00',3.84),('16100','2014-03-23','15:15:00',3.6),('16100','2014-03-23','15:20:00',2.87),('16100','2014-03-23','15:25:00',2.61),('16100','2014-03-23','15:30:00',3.07),('16100','2014-03-23','15:35:00',3.06),('16100','2014-03-23','15:40:00',2.17),('16100','2014-03-23','15:45:00',1.79),('16100','2014-03-23','15:50:00',1.87),('16100','2014-03-23','15:55:00',3.13),('16100','2014-03-23','16:00:00',1.87),('16100','2014-03-23','16:05:00',1.48),('16100','2014-03-22','08:15:00',1.1),('16100','2014-03-22','08:20:00',1.54),('16100','2014-03-22','08:55:00',2.84),('16100','2014-03-22','09:00:00',2.19),('16100','2014-03-22','09:05:00',4.24),('16100','2014-03-22','09:10:00',4.48),('16100','2014-03-22','09:15:00',3.84),('16100','2014-03-22','09:20:00',2.04),('16100','2014-03-22','09:25:00',1.62),('16100','2014-03-22','09:30:00',2.29),('16100','2014-03-22','09:35:00',1.73),('16100','2014-03-22','09:40:00',1.21),('16100','2014-03-22','09:45:00',1.22),('16100','2014-03-22','09:50:00',1.32),('16100','2014-03-22','09:55:00',1.26),('16100','2014-03-22','10:05:00',1.01),('16100','2014-03-22','10:20:00',1.22),('16100','2014-03-22','10:25:00',2.16),('16100','2014-03-22','10:30:00',1.11),('16100','2014-03-22','10:40:00',1.98),('16100','2014-03-22','10:45:00',1.68),('16100','2014-03-22','10:50:00',1.7),('16100','2014-03-22','10:55:00',2.21),('16100','2014-03-22','11:00:00',1.41),('16100','2014-03-22','11:05:00',2.07),('16100','2014-03-22','11:10:00',1.3),('16100','2014-03-22','11:20:00',1.85),('16100','2014-03-22','11:25:00',1.83),('16100','2014-03-22','11:30:00',1.57),('16100','2014-03-22','11:35:00',1.82),('16100','2014-03-22','11:40:00',1.94),('16100','2014-03-22','12:00:00',1.18),('16100','2014-03-22','12:25:00',1.07),('16100','2014-03-22','13:05:00',1.24),('16100','2014-03-22','13:35:00',2.72),('16100','2014-03-22','13:40:00',3.3),('16100','2014-03-22','13:45:00',3.4),('16100','2014-03-22','13:50:00',1.76),('16100','2014-03-22','13:55:00',1.09),('16100','2014-03-22','14:45:00',1.89),('16100','2014-03-22','14:55:00',1.66),('16100','2014-03-22','15:00:00',1.77),('16100','2014-03-22','15:05:00',1.86),('16100','2014-03-22','15:10:00',3.88),('16100','2014-03-22','15:15:00',2.92),('16100','2014-03-22','15:20:00',1.99),('16100','2014-03-22','15:25:00',1.31),('16100','2014-03-22','15:30:00',1.04),('16100','2014-03-22','15:35:00',1.33),('16100','2014-03-21','07:35:00',1.5),('16100','2014-03-21','07:40:00',1.28),('16100','2014-03-21','07:45:00',1.29),('16100','2014-03-21','07:50:00',1.16),('16100','2014-03-21','08:05:00',1.43),('16100','2014-03-21','08:10:00',2.18),('16100','2014-03-21','08:15:00',2.71),('16100','2014-03-21','08:20:00',2.42),('16100','2014-03-21','08:25:00',2.47),('16100','2014-03-21','08:30:00',3.21),('16100','2014-03-21','08:35:00',2.89),('16100','2014-03-21','08:40:00',2.17),('16100','2014-03-21','08:45:00',3.07),('16100','2014-03-21','08:50:00',2.55),('16100','2014-03-21','08:55:00',2.44),('16100','2014-03-21','09:00:00',2.27),('16100','2014-03-21','09:05:00',2.61),('16100','2014-03-21','09:10:00',3.26),('16100','2014-03-21','09:15:00',3.47),('16100','2014-03-21','09:20:00',2.36),('16100','2014-03-21','09:25:00',2.63),('16100','2014-03-21','09:30:00',3.96),('16100','2014-03-21','09:35:00',5.1),('16100','2014-03-21','09:40:00',4.5),('16100','2014-03-21','09:45:00',5.19),('16100','2014-03-21','09:50:00',4.92),('16100','2014-03-21','09:55:00',5.07),('16100','2014-03-21','10:00:00',5.09),('16100','2014-03-21','10:05:00',6.34),('16100','2014-03-21','10:10:00',4),('16100','2014-03-21','10:15:00',2.22),('16100','2014-03-21','10:20:00',2.02),('16100','2014-03-21','10:25:00',2.34),('16100','2014-03-21','10:30:00',3.53),('16100','2014-03-21','10:35:00',3.6),('16100','2014-03-21','10:40:00',3.18),('16100','2014-03-21','10:45:00',4.18),('16100','2014-03-21','10:50:00',5.54),('16100','2014-03-21','10:55:00',3.98),('16100','2014-03-21','11:00:00',1.9),('16100','2014-03-21','11:05:00',2.18),('16100','2014-03-21','11:10:00',3.52),('16100','2014-03-21','11:15:00',5.55),('16100','2014-03-21','11:20:00',7.38),('16100','2014-03-21','11:25:00',4.97),('16100','2014-03-21','11:30:00',4.52),('16100','2014-03-21','11:35:00',6.71),('16100','2014-03-21','11:40:00',4.14),('16100','2014-03-21','11:45:00',4.53),('16100','2014-03-21','11:50:00',1.95),('16100','2014-03-21','11:55:00',5.41),('16100','2014-03-21','12:00:00',4.83),('16100','2014-03-21','12:05:00',7.1),('16100','2014-03-21','12:10:00',4.47),('16100','2014-03-21','12:15:00',7.44),('16100','2014-03-21','12:20:00',6.76),('16100','2014-03-21','12:25:00',5.68),('16100','2014-03-21','12:30:00',4.73),('16100','2014-03-21','12:35:00',5.34),('16100','2014-03-21','12:40:00',7.98),('16100','2014-03-21','12:45:00',6.35),('16100','2014-03-21','12:50:00',6.93),('16100','2014-03-21','12:55:00',7.95),('16100','2014-03-21','13:00:00',7.58),('16100','2014-03-21','13:05:00',4.06),('16100','2014-03-21','13:10:00',4.55),('16100','2014-03-21','13:15:00',5.77),('16100','2014-03-21','13:20:00',2.57),('16100','2014-03-21','13:25:00',7.56),('16100','2014-03-21','13:30:00',6.68),('16100','2014-03-21','13:35:00',6.92),('16100','2014-03-21','13:40:00',7),('16100','2014-03-21','13:45:00',6.8),('16100','2014-03-21','13:50:00',6.72),('16100','2014-03-21','13:55:00',6.56),('16100','2014-03-21','14:00:00',6.62),('16100','2014-03-21','14:05:00',6.21),('16100','2014-03-21','14:10:00',6.31),('16100','2014-03-21','14:15:00',6.21),('16100','2014-03-21','14:20:00',6.06),('16100','2014-03-21','14:25:00',5.92),('16100','2014-03-21','14:30:00',5.88),('16100','2014-03-21','14:35:00',5.72),('16100','2014-03-21','14:40:00',5.39),('16100','2014-03-21','14:45:00',5.53),('16100','2014-03-21','14:50:00',5.03),('16100','2014-03-21','14:55:00',5.3),('16100','2014-03-21','15:00:00',4.51),('16100','2014-03-21','15:05:00',4.98),('16100','2014-03-21','15:10:00',4.83),('16100','2014-03-21','15:15:00',4.7),('16100','2014-03-21','15:20:00',4.82),('16100','2014-03-21','15:25:00',4.48),('16100','2014-03-21','15:30:00',3.28),('16100','2014-03-21','15:35:00',4.91),('16100','2014-03-21','15:40:00',4.62),('16100','2014-03-21','15:45:00',4.18),('16100','2014-03-21','15:50:00',3.54),('16100','2014-03-21','15:55:00',3.18),('16100','2014-03-21','16:00:00',3.15),('16100','2014-03-21','16:05:00',1.32),('16100','2014-03-21','16:10:00',2.23),('16100','2014-03-21','16:15:00',2.45),('16100','2014-03-21','16:20:00',1.84),('16100','2014-03-21','16:25:00',1.23),('16100','2014-03-21','16:30:00',1.13),('16100','2014-03-21','16:35:00',1.31),('16100','2014-03-21','16:40:00',1.85),('16100','2014-03-21','16:45:00',2.33),('16100','2014-03-21','16:50:00',1.2),('16100','2014-03-20','07:35:00',1.15),('16100','2014-03-20','07:40:00',1.35),('16100','2014-03-20','07:45:00',1.57),('16100','2014-03-20','07:50:00',1.81),('16100','2014-03-20','07:55:00',2.02),('16100','2014-03-20','08:00:00',2.2),('16100','2014-03-20','08:05:00',2.37),('16100','2014-03-20','08:10:00',2.52),('16100','2014-03-20','08:15:00',2.7),('16100','2014-03-20','08:20:00',2.82),('16100','2014-03-20','08:25:00',3),('16100','2014-03-20','08:30:00',3.23),('16100','2014-03-20','08:35:00',3.39),('16100','2014-03-20','08:40:00',3.56),('16100','2014-03-20','08:45:00',3.69),('16100','2014-03-20','08:50:00',3.79),('16100','2014-03-20','08:55:00',3.96),('16100','2014-03-20','09:00:00',4.13),('16100','2014-03-20','09:05:00',4.29),('16100','2014-03-20','09:10:00',4.48),('16100','2014-03-20','09:15:00',4.6),('16100','2014-03-20','09:20:00',4.76),('16100','2014-03-20','09:25:00',4.79),('16100','2014-03-20','09:30:00',4.8),('16100','2014-03-20','09:35:00',4.81),('16100','2014-03-20','09:40:00',5.23),('16100','2014-03-20','09:45:00',5.31),('16100','2014-03-20','09:50:00',5.5),('16100','2014-03-20','09:55:00',5.53),('16100','2014-03-20','10:00:00',5.6),('16100','2014-03-20','10:05:00',5.72),('16100','2014-03-20','10:10:00',5.73),('16100','2014-03-20','10:15:00',5.87),('16100','2014-03-20','10:20:00',5.94),('16100','2014-03-20','10:25:00',5.97),('16100','2014-03-20','10:30:00',6.05),('16100','2014-03-20','10:35:00',6.02),('16100','2014-03-20','10:40:00',6.16),('16100','2014-03-20','10:45:00',5.34),('16100','2014-03-20','10:50:00',5.39),('16100','2014-03-20','10:55:00',6.34),('16100','2014-03-20','11:00:00',6.31),('16100','2014-03-20','11:05:00',6.36),('16100','2014-03-20','11:10:00',6.43),('16100','2014-03-20','11:15:00',6.6),('16100','2014-03-20','11:20:00',6.59),('16100','2014-03-20','11:25:00',6.69),('16100','2014-03-20','11:30:00',6.64),('16100','2014-03-20','11:35:00',6.53),('16100','2014-03-20','11:40:00',5.42),('16100','2014-03-20','11:45:00',6.55),('16100','2014-03-20','11:50:00',6.72),('16100','2014-03-20','11:55:00',6.83),('16100','2014-03-20','12:00:00',5.84),('16100','2014-03-20','12:05:00',6.27),('16100','2014-03-20','12:10:00',6.91),('16100','2014-03-20','12:15:00',6.94),('16100','2014-03-20','12:20:00',7.03),('16100','2014-03-20','12:25:00',7.07),('16100','2014-03-20','12:30:00',7.15),('16100','2014-03-20','12:35:00',7.15),('16100','2014-03-20','12:40:00',7.19),('16100','2014-03-20','12:45:00',7.19),('16100','2014-03-20','12:50:00',7.17),('16100','2014-03-20','12:55:00',7.17),('16100','2014-03-20','13:00:00',7.12),('16100','2014-03-20','13:05:00',7),('16100','2014-03-20','13:10:00',7.05),('16100','2014-03-20','13:15:00',6.96),('16100','2014-03-20','13:20:00',6.91),('16100','2014-03-20','13:25:00',6.84),('16100','2014-03-20','13:30:00',6.8),('16100','2014-03-20','13:35:00',6.76),('16100','2014-03-20','13:40:00',6.66),('16100','2014-03-20','13:45:00',6.64),('16100','2014-03-20','13:50:00',6.74),('16100','2014-03-20','13:55:00',6.65),('16100','2014-03-20','14:00:00',6.55),('16100','2014-03-20','14:05:00',6.41),('16100','2014-03-20','14:10:00',6.36),('16100','2014-03-20','14:15:00',6.34),('16100','2014-03-20','14:20:00',6.28),('16100','2014-03-20','14:25:00',6.09),('16100','2014-03-20','14:30:00',6),('16100','2014-03-20','14:35:00',5.82),('16100','2014-03-20','14:40:00',5.54),('16100','2014-03-20','14:45:00',4.67),('16100','2014-03-20','14:50:00',3.13),('16100','2014-03-20','14:55:00',1.73),('16100','2014-03-20','15:00:00',1.69),('16100','2014-03-20','15:05:00',4.69),('16100','2014-03-20','15:10:00',5.42),('16100','2014-03-20','15:15:00',5.74),('16100','2014-03-20','15:20:00',4.88),('16100','2014-03-20','15:25:00',3.13),('16100','2014-03-20','15:30:00',5.29),('16100','2014-03-20','15:35:00',4.73),('16100','2014-03-20','15:40:00',4.44),('16100','2014-03-20','15:45:00',4.24),('16100','2014-03-20','15:50:00',4.7),('16100','2014-03-20','15:55:00',4.5),('16100','2014-03-20','16:00:00',4.26),('16100','2014-03-20','16:05:00',3.97),('16100','2014-03-20','16:10:00',3.72),('16100','2014-03-20','16:15:00',3.44),('16100','2014-03-20','16:20:00',3.1),('16100','2014-03-20','16:25:00',2.88),('16100','2014-03-20','16:30:00',2.69),('16100','2014-03-20','16:35:00',2.46),('16100','2014-03-20','16:40:00',2.29),('16100','2014-03-20','16:45:00',2.14),('16100','2014-03-20','16:50:00',1.96),('16100','2014-03-20','16:55:00',1.75),('16100','2014-03-20','17:00:00',1.47),('16100','2014-03-20','17:05:00',1.24),('16100','2014-03-20','17:10:00',1.12),('16100','2014-03-19','07:25:00',1.08),('16100','2014-03-19','07:30:00',1.22),('16100','2014-03-19','07:35:00',1.39),('16100','2014-03-19','07:40:00',1.55),('16100','2014-03-19','07:45:00',1.79),('16100','2014-03-19','07:50:00',1.96),('16100','2014-03-19','07:55:00',2.04),('16100','2014-03-19','08:00:00',2.1),('16100','2014-03-19','08:05:00',2.25),('16100','2014-03-19','08:10:00',2.17),('16100','2014-03-19','08:15:00',2.33),('16100','2014-03-19','08:20:00',2.49),('16100','2014-03-19','08:25:00',2.82),('16100','2014-03-19','08:30:00',3.05),('16100','2014-03-19','08:35:00',3.25),('16100','2014-03-19','08:40:00',3.52),('16100','2014-03-19','08:45:00',3.7),('16100','2014-03-19','08:50:00',3.89),('16100','2014-03-19','08:55:00',3.9),('16100','2014-03-19','09:00:00',4),('16100','2014-03-19','09:05:00',4.17),('16100','2014-03-19','09:10:00',4.35),('16100','2014-03-19','09:15:00',4.52),('16100','2014-03-19','09:20:00',4.65),('16100','2014-03-19','09:25:00',4.88),('16100','2014-03-19','09:30:00',4.95),('16100','2014-03-19','09:35:00',5.09),('16100','2014-03-19','09:40:00',5.11),('16100','2014-03-19','09:45:00',5.26),('16100','2014-03-19','09:50:00',5.49),('16100','2014-03-19','09:55:00',5.51),('16100','2014-03-19','10:00:00',5.7),('16100','2014-03-19','10:05:00',5.87),('16100','2014-03-19','10:10:00',5.91),('16100','2014-03-19','10:15:00',5.98),('16100','2014-03-19','10:20:00',6.14),('16100','2014-03-19','10:25:00',6.31),('16100','2014-03-19','10:30:00',6.42),('16100','2014-03-19','10:35:00',6.35),('16100','2014-03-19','10:40:00',6.06),('16100','2014-03-19','10:45:00',6.02),('16100','2014-03-19','10:50:00',6.5),('16100','2014-03-19','10:55:00',6.75),('16100','2014-03-19','11:00:00',6.74),('16100','2014-03-19','11:05:00',6.84),('16100','2014-03-19','11:10:00',6.74),('16100','2014-03-19','11:15:00',6.21),('16100','2014-03-19','11:20:00',6.46),('16100','2014-03-19','11:25:00',6.6),('16100','2014-03-19','11:30:00',6.79),('16100','2014-03-19','11:35:00',6.66),('16100','2014-03-19','11:40:00',6.52),('16100','2014-03-19','11:45:00',6.41),('16100','2014-03-19','11:50:00',6.46),('16100','2014-03-19','11:55:00',6.45),('16100','2014-03-19','12:00:00',6.81),('16100','2014-03-19','12:05:00',6.25),('16100','2014-03-19','12:10:00',6.54),('16100','2014-03-19','12:15:00',7.02),('16100','2014-03-19','12:20:00',7.11),('16100','2014-03-19','12:25:00',6.96),('16100','2014-03-19','12:30:00',6.64),('16100','2014-03-19','12:35:00',6.92),('16100','2014-03-19','12:40:00',7.13),('16100','2014-03-19','12:45:00',7.24),('16100','2014-03-19','12:50:00',7.25),('16100','2014-03-19','12:55:00',7.29),('16100','2014-03-19','13:00:00',7.2),('16100','2014-03-19','13:05:00',7.03),('16100','2014-03-19','13:10:00',6.87),('16100','2014-03-19','13:15:00',6.77),('16100','2014-03-19','13:20:00',6.75),('16100','2014-03-19','13:25:00',6.8),('16100','2014-03-19','13:30:00',6.6),('16100','2014-03-19','13:35:00',6.48),('16100','2014-03-19','13:40:00',6.16),('16100','2014-03-19','13:45:00',5.96),('16100','2014-03-19','13:50:00',5.83),('16100','2014-03-19','13:55:00',5.59),('16100','2014-03-19','14:00:00',5.43),('16100','2014-03-19','14:05:00',5.65),('16100','2014-03-19','14:10:00',5.65),('16100','2014-03-19','14:15:00',5.77),('16100','2014-03-19','14:20:00',4.91),('16100','2014-03-19','14:25:00',4.74),('16100','2014-03-19','14:30:00',4.25),('16100','2014-03-19','14:35:00',4.66),('16100','2014-03-19','14:40:00',4.45),('16100','2014-03-19','14:45:00',4.31),('16100','2014-03-19','14:50:00',4.25),('16100','2014-03-19','14:55:00',4.19),('16100','2014-03-19','15:00:00',4.17),('16100','2014-03-19','15:05:00',4.14),('16100','2014-03-19','15:10:00',4.24),('16100','2014-03-19','15:15:00',4.05),('16100','2014-03-19','15:20:00',4.02),('16100','2014-03-19','15:25:00',3.78),('16100','2014-03-19','15:30:00',3.42),('16100','2014-03-19','15:35:00',3.08),('16100','2014-03-19','15:40:00',2.9),('16100','2014-03-19','15:45:00',2.7),('16100','2014-03-19','15:50:00',2.41),('16100','2014-03-19','15:55:00',1.98),('16100','2014-03-19','16:00:00',2),('16100','2014-03-19','16:05:00',2.04),('16100','2014-03-19','16:10:00',1.8),('16100','2014-03-19','16:15:00',1.63),('16100','2014-03-19','16:20:00',1.58),('16100','2014-03-19','16:25:00',1.48),('16100','2014-03-19','16:30:00',1.38),('16100','2014-03-19','16:35:00',1.51),('16100','2014-03-19','16:40:00',1.55),('16100','2014-03-19','16:45:00',1.25),('16100','2014-03-18','08:25:00',1.03),('16100','2014-03-18','08:30:00',1.17),('16100','2014-03-18','08:35:00',1.34),('16100','2014-03-18','08:40:00',1.37),('16100','2014-03-18','08:45:00',1.46),('16100','2014-03-18','08:50:00',1.73),('16100','2014-03-18','08:55:00',1.49),('16100','2014-03-18','09:00:00',1.48),('16100','2014-03-18','09:05:00',1.68),('16100','2014-03-18','09:10:00',1.84),('16100','2014-03-18','09:15:00',2.02),('16100','2014-03-18','09:20:00',2.46),('16100','2014-03-18','09:25:00',3.16),('16100','2014-03-18','09:30:00',3.17),('16100','2014-03-18','09:35:00',3.74),('16100','2014-03-18','09:40:00',3.83),('16100','2014-03-18','09:45:00',3.88),('16100','2014-03-18','09:50:00',4.5),('16100','2014-03-18','09:55:00',3.84),('16100','2014-03-18','10:00:00',3.01),('16100','2014-03-18','10:05:00',2.61),('16100','2014-03-18','10:10:00',2.56),('16100','2014-03-18','10:15:00',2.66),('16100','2014-03-18','10:20:00',2.31),('16100','2014-03-18','10:25:00',2.3),('16100','2014-03-18','10:30:00',2.31),('16100','2014-03-18','10:35:00',2.43),('16100','2014-03-18','10:40:00',2.96),('16100','2014-03-18','10:45:00',3.02),('16100','2014-03-18','10:50:00',3.6),('16100','2014-03-18','10:55:00',2.61),('16100','2014-03-18','11:00:00',2.15),('16100','2014-03-18','11:05:00',2.5),('16100','2014-03-18','11:10:00',3.7),('16100','2014-03-18','11:15:00',3.53),('16100','2014-03-18','11:20:00',5.39),('16100','2014-03-18','11:25:00',7),('16100','2014-03-18','11:30:00',5.75),('16100','2014-03-18','11:35:00',7.7),('16100','2014-03-18','11:40:00',6.55),('16100','2014-03-18','11:45:00',5.46),('16100','2014-03-18','11:50:00',6.26),('16100','2014-03-18','11:55:00',4),('16100','2014-03-18','12:00:00',5.7),('16100','2014-03-18','12:05:00',4.24),('16100','2014-03-18','12:10:00',2.65),('16100','2014-03-18','12:15:00',6.84),('16100','2014-03-18','12:20:00',7.01),('16100','2014-03-18','12:25:00',6.94),('16100','2014-03-18','12:30:00',7.12),('16100','2014-03-18','12:35:00',7.05),('16100','2014-03-18','12:40:00',6.67),('16100','2014-03-18','12:45:00',6.74),('16100','2014-03-18','12:50:00',5.93),('16100','2014-03-18','12:55:00',7.09),('16100','2014-03-18','13:00:00',7.03),('16100','2014-03-18','13:05:00',7.03),('16100','2014-03-18','13:10:00',6.65),('16100','2014-03-18','13:15:00',6.19),('16100','2014-03-18','13:20:00',6.3),('16100','2014-03-18','13:25:00',6.93),('16100','2014-03-18','13:30:00',6.58),('16100','2014-03-18','13:35:00',6.72),('16100','2014-03-18','13:40:00',6.72),('16100','2014-03-18','13:45:00',6.65),('16100','2014-03-18','13:50:00',6.44),('16100','2014-03-18','13:55:00',6.44),('16100','2014-03-18','14:00:00',6.42),('16100','2014-03-18','14:05:00',6.38),('16100','2014-03-18','14:10:00',6.26),('16100','2014-03-18','14:15:00',6.09),('16100','2014-03-18','14:20:00',6.02),('16100','2014-03-18','14:25:00',5.83),('16100','2014-03-18','14:30:00',5.74),('16100','2014-03-18','14:35:00',5.72),('16100','2014-03-18','14:40:00',5.68),('16100','2014-03-18','14:45:00',5.55),('16100','2014-03-18','14:50:00',5.49),('16100','2014-03-18','14:55:00',5.32),('16100','2014-03-18','15:00:00',5.17),('16100','2014-03-18','15:05:00',5.18),('16100','2014-03-18','15:10:00',5.05),('16100','2014-03-18','15:15:00',4.83),('16100','2014-03-18','15:20:00',4.75),('16100','2014-03-18','15:25:00',4.61),('16100','2014-03-18','15:30:00',4.41),('16100','2014-03-18','15:35:00',4.27),('16100','2014-03-18','15:40:00',4.19),('16100','2014-03-18','15:45:00',4.1),('16100','2014-03-18','15:50:00',3.89),('16100','2014-03-18','15:55:00',3.68),('16100','2014-03-18','16:00:00',3.59),('16100','2014-03-18','16:05:00',3.51),('16100','2014-03-18','16:10:00',3.28),('16100','2014-03-18','16:15:00',3.06),('16100','2014-03-18','16:20:00',2.88),('16100','2014-03-18','16:25:00',2.77),('16100','2014-03-18','16:30:00',2.44),('16100','2014-03-18','16:35:00',2.24),('16100','2014-03-18','16:40:00',2.06),('16100','2014-03-18','16:45:00',1.94),('16100','2014-03-18','16:50:00',1.68),('16100','2014-03-18','16:55:00',1.59),('16100','2014-03-18','17:00:00',1.33),('16100','2014-03-18','17:05:00',1.09),('16100','2014-03-17','08:00:00',1.37),('16100','2014-03-17','08:05:00',1.3),('16100','2014-03-17','08:10:00',1.43),('16100','2014-03-17','08:15:00',1.82),('16100','2014-03-17','08:20:00',2.17),('16100','2014-03-17','08:25:00',1.69),('16100','2014-03-17','08:30:00',1.75),('16100','2014-03-17','08:35:00',3.03),('16100','2014-03-17','08:40:00',1.69),('16100','2014-03-17','08:45:00',1.49),('16100','2014-03-17','08:50:00',1.26),('16100','2014-03-17','08:55:00',1.21),('16100','2014-03-17','09:00:00',2),('16100','2014-03-17','09:05:00',1.39),('16100','2014-03-17','09:10:00',2.03),('16100','2014-03-17','09:15:00',3.75),('16100','2014-03-17','09:20:00',4.6),('16100','2014-03-17','09:25:00',4.37),('16100','2014-03-17','09:30:00',4.2),('16100','2014-03-17','09:35:00',4.51),('16100','2014-03-17','09:40:00',4.48),('16100','2014-03-17','09:45:00',2.88),('16100','2014-03-17','09:50:00',3.43),('16100','2014-03-17','09:55:00',2.92),('16100','2014-03-17','10:00:00',5.98),('16100','2014-03-17','10:05:00',4),('16100','2014-03-17','10:10:00',1.92),('16100','2014-03-17','10:15:00',2.18),('16100','2014-03-17','10:20:00',3.15),('16100','2014-03-17','10:25:00',2.24),('16100','2014-03-17','10:30:00',1.99),('16100','2014-03-17','10:35:00',2.61),('16100','2014-03-17','10:40:00',3.36),('16100','2014-03-17','10:45:00',2.08),('16100','2014-03-17','10:50:00',2.03),('16100','2014-03-17','10:55:00',2.01),('16100','2014-03-17','11:00:00',2.85),('16100','2014-03-17','11:05:00',1.91),('16100','2014-03-17','11:10:00',2.54),('16100','2014-03-17','11:15:00',7.39),('16100','2014-03-17','11:20:00',4.44),('16100','2014-03-17','11:25:00',2.61),('16100','2014-03-17','11:30:00',5.13),('16100','2014-03-17','11:35:00',7.7),('16100','2014-03-17','11:40:00',7.67),('16100','2014-03-17','11:45:00',7.84),('16100','2014-03-17','11:50:00',7.04),('16100','2014-03-17','11:55:00',2.9),('16100','2014-03-17','12:00:00',4.29),('16100','2014-03-17','12:05:00',6.27),('16100','2014-03-17','12:10:00',3.54),('16100','2014-03-17','12:15:00',7.3),('16100','2014-03-17','12:20:00',8.33),('16100','2014-03-17','12:25:00',4.52),('16100','2014-03-17','12:30:00',7.6),('16100','2014-03-17','12:35:00',7.85),('16100','2014-03-17','12:40:00',7.71),('16100','2014-03-17','12:45:00',7.59),('16100','2014-03-17','12:50:00',7.14),('16100','2014-03-17','12:55:00',7.05),('16100','2014-03-17','13:00:00',7.55),('16100','2014-03-17','13:05:00',7.14),('16100','2014-03-17','13:10:00',7.31),('16100','2014-03-17','13:15:00',7.05),('16100','2014-03-17','13:20:00',6.94),('16100','2014-03-17','13:25:00',6.99),('16100','2014-03-17','13:30:00',6.84),('16100','2014-03-17','13:35:00',6.79),('16100','2014-03-17','13:40:00',6.77),('16100','2014-03-17','13:45:00',6.69),('16100','2014-03-17','13:50:00',6.74),('16100','2014-03-17','13:55:00',6.59),('16100','2014-03-17','14:00:00',6.51),('16100','2014-03-17','14:05:00',6.39),('16100','2014-03-17','14:10:00',6.21),('16100','2014-03-17','14:15:00',6.26),('16100','2014-03-17','14:20:00',6.16),('16100','2014-03-17','14:25:00',6.04),('16100','2014-03-17','14:30:00',5.93),('16100','2014-03-17','14:35:00',5.89),('16100','2014-03-17','14:40:00',5.75),('16100','2014-03-17','14:45:00',5.63),('16100','2014-03-17','14:50:00',5.56),('16100','2014-03-17','14:55:00',5.49),('16100','2014-03-17','15:00:00',5.32),('16100','2014-03-17','15:05:00',5.22),('16100','2014-03-17','15:10:00',5.07),('16100','2014-03-17','15:15:00',4.83),('16100','2014-03-17','15:20:00',4.72),('16100','2014-03-17','15:25:00',4.64),('16100','2014-03-17','15:30:00',4.49),('16100','2014-03-17','15:35:00',4.36),('16100','2014-03-17','15:40:00',4.2),('16100','2014-03-17','15:45:00',3.99),('16100','2014-03-17','15:50:00',3.86),('16100','2014-03-17','15:55:00',3.71),('16100','2014-03-17','16:00:00',3.54),('16100','2014-03-17','16:05:00',3.38),('16100','2014-03-17','16:10:00',3.18),('16100','2014-03-17','16:15:00',3.07),('16100','2014-03-17','16:20:00',2.93),('16100','2014-03-17','16:25:00',2.81),('16100','2014-03-17','16:30:00',2.54),('16100','2014-03-17','16:35:00',2.37),('16100','2014-03-17','16:40:00',2.21),('16100','2014-03-17','16:45:00',2.03),('16100','2014-03-17','16:50:00',1.81),('16100','2014-03-17','16:55:00',1.67),('16100','2014-03-17','17:00:00',1.47),('16100','2014-03-17','17:05:00',1.27),('16100','2014-03-17','17:10:00',1.12),('16100','2014-04-30','07:55:00',1.25),('16100','2014-04-30','08:00:00',1.2),('16100','2014-04-30','08:05:00',1.38),('16100','2014-04-30','08:10:00',1.64),('16100','2014-04-30','08:15:00',1.8),('16100','2014-04-30','08:20:00',1.97),('16100','2014-04-30','08:25:00',2.25),('16100','2014-04-30','08:30:00',2.51),('16100','2014-04-30','08:35:00',2.8),('16100','2014-04-30','08:40:00',3.3),('16100','2014-04-30','08:45:00',3.21),('16100','2014-04-30','08:50:00',1.51),('16100','2014-04-30','08:55:00',1.59),('16100','2014-04-30','09:00:00',2.49),('16100','2014-04-30','09:05:00',2.43),('16100','2014-04-30','09:10:00',4.42),('16100','2014-04-30','09:15:00',4.45),('16100','2014-04-30','09:20:00',4.31),('16100','2014-04-30','09:25:00',3.73),('16100','2014-04-30','09:30:00',3.92),('16100','2014-04-30','09:35:00',2.38),('16100','2014-04-30','09:40:00',2.42),('16100','2014-04-30','09:45:00',3.26),('16100','2014-04-30','09:50:00',1.81),('16100','2014-04-30','09:55:00',2.14),('16100','2014-04-30','10:00:00',2.3),('16100','2014-04-30','10:05:00',2.36),('16100','2014-04-30','10:10:00',4.08),('16100','2014-04-30','10:15:00',3.72),('16100','2014-04-30','10:20:00',5.22),('16100','2014-04-30','10:25:00',4.44),('16100','2014-04-30','10:30:00',6.95),('16100','2014-04-30','10:35:00',6.67),('16100','2014-04-30','10:40:00',3.23),('16100','2014-04-30','10:45:00',3.18),('16100','2014-04-30','10:50:00',1.88),('16100','2014-04-30','10:55:00',6.84),('16100','2014-04-30','11:00:00',7.5),('16100','2014-04-30','11:05:00',7.65),('16100','2014-04-30','11:10:00',6.49),('16100','2014-04-30','11:15:00',6.9),('16100','2014-04-30','11:20:00',6.03),('16100','2014-04-30','11:25:00',3.17),('16100','2014-04-30','11:30:00',7.6),('16100','2014-04-30','11:35:00',7.89),('16100','2014-04-30','11:40:00',5.35),('16100','2014-04-30','11:45:00',8.06),('16100','2014-04-30','11:50:00',8.14),('16100','2014-04-30','11:55:00',5.2),('16100','2014-04-30','12:00:00',5.73),('16100','2014-04-30','12:05:00',8.38),('16100','2014-04-30','12:10:00',5.28),('16100','2014-04-30','12:15:00',5.78),('16100','2014-04-30','12:20:00',8.31),('16100','2014-04-30','12:25:00',8.36),('16100','2014-04-30','12:30:00',5.23),('16100','2014-04-30','12:35:00',8.9),('16100','2014-04-30','12:40:00',6.36),('16100','2014-04-30','12:45:00',8.33),('16100','2014-04-30','12:50:00',3.17),('16100','2014-04-30','12:55:00',4.13),('16100','2014-04-30','13:00:00',8.1),('16100','2014-04-30','13:05:00',7.86),('16100','2014-04-30','13:10:00',8.33),('16100','2014-04-30','13:15:00',8.24),('16100','2014-04-30','13:20:00',5.8),('16100','2014-04-30','13:25:00',7.73),('16100','2014-04-30','13:30:00',7.75),('16100','2014-04-30','13:35:00',3.33),('16100','2014-04-30','13:40:00',6.9),('16100','2014-04-30','13:45:00',8.73),('16100','2014-04-30','13:50:00',7.92),('16100','2014-04-30','13:55:00',8.15),('16100','2014-04-30','14:00:00',7.81),('16100','2014-04-30','14:05:00',7.69),('16100','2014-04-30','14:10:00',7.49),('16100','2014-04-30','14:15:00',7.49),('16100','2014-04-30','14:20:00',7.42),('16100','2014-04-30','14:25:00',7.39),('16100','2014-04-30','14:30:00',4.68),('16100','2014-04-30','14:35:00',6.48),('16100','2014-04-30','14:40:00',7.61),('16100','2014-04-30','14:45:00',7.5),('16100','2014-04-30','14:50:00',3.75),('16100','2014-04-30','14:55:00',7.37),('16100','2014-04-30','15:00:00',7.31),('16100','2014-04-30','15:05:00',6.19),('16100','2014-04-30','15:10:00',7.18),('16100','2014-04-30','15:15:00',6.86),('16100','2014-04-30','15:20:00',6.73),('16100','2014-04-30','15:25:00',6.62),('16100','2014-04-30','15:30:00',6.53),('16100','2014-04-30','15:35:00',6.42),('16100','2014-04-30','15:40:00',6.35),('16100','2014-04-30','15:45:00',6.21),('16100','2014-04-30','15:50:00',6.13),('16100','2014-04-30','15:55:00',6.02),('16100','2014-04-30','16:00:00',5.89),('16100','2014-04-30','16:05:00',5.79),('16100','2014-04-30','16:10:00',5.81),('16100','2014-04-30','16:15:00',5.47),('16100','2014-04-30','16:20:00',4.98),('16100','2014-04-30','16:25:00',5.01),('16100','2014-04-30','16:30:00',4.98),('16100','2014-04-30','16:35:00',4.84),('16100','2014-04-30','16:40:00',4.47),('16100','2014-04-30','16:45:00',4.12),('16100','2014-04-30','16:50:00',4.7),('16100','2014-04-30','16:55:00',4.35),('16100','2014-04-30','17:00:00',4.2),('16100','2014-04-30','17:05:00',4.2),('16100','2014-04-30','17:10:00',4.03),('16100','2014-04-30','17:15:00',3.86),('16100','2014-04-30','17:20:00',3.63),('16100','2014-04-30','17:25:00',2.92),('16100','2014-04-30','17:30:00',2.59),('16100','2014-04-30','17:35:00',3.09),('16100','2014-04-30','17:40:00',1.56),('16100','2014-04-30','17:45:00',2.95),('16100','2014-04-30','17:50:00',2.72),('16100','2014-04-30','17:55:00',2.51),('16100','2014-04-30','18:00:00',1.5),('16100','2014-04-30','18:05:00',2.36),('16100','2014-04-30','18:10:00',2.07),('16100','2014-04-30','18:15:00',1.48),('16100','2014-04-30','18:20:00',1.68),('16100','2014-04-30','18:25:00',1.54),('16100','2014-04-30','18:30:00',1.21),('16100','2014-04-30','18:35:00',1.17),('16100','2014-03-16','08:30:00',1.14),('16100','2014-03-16','08:35:00',1.2),('16100','2014-03-16','08:40:00',1.2),('16100','2014-03-16','08:45:00',1.17),('16100','2014-03-16','08:50:00',1.34),('16100','2014-03-16','08:55:00',1.65),('16100','2014-03-16','09:00:00',1.38),('16100','2014-03-16','09:05:00',1.61),('16100','2014-03-16','09:10:00',1.52),('16100','2014-03-16','09:15:00',1.82),('16100','2014-03-16','09:20:00',1.8),('16100','2014-03-16','09:25:00',1.6),('16100','2014-03-16','09:30:00',1.61),('16100','2014-03-16','09:35:00',1.62),('16100','2014-03-16','09:40:00',1.65),('16100','2014-03-16','09:45:00',1.8),('16100','2014-03-16','09:50:00',1.57),('16100','2014-03-16','09:55:00',1.71),('16100','2014-03-16','10:00:00',1.66),('16100','2014-03-16','10:05:00',1.74),('16100','2014-03-16','10:10:00',1.92),('16100','2014-03-16','10:15:00',1.85),('16100','2014-03-16','10:20:00',1.86),('16100','2014-03-16','10:25:00',1.54),('16100','2014-03-16','10:30:00',1.26),('16100','2014-03-16','10:35:00',1.45),('16100','2014-03-16','10:40:00',1.52),('16100','2014-03-16','10:45:00',1.42),('16100','2014-03-16','10:50:00',2.66),('16100','2014-03-16','10:55:00',1.76),('16100','2014-03-16','11:00:00',1.62),('16100','2014-03-16','11:05:00',2.23),('16100','2014-03-16','11:10:00',3.65),('16100','2014-03-16','11:15:00',2.52),('16100','2014-03-16','11:20:00',2.27),('16100','2014-03-16','11:25:00',2.03),('16100','2014-03-16','11:30:00',1.62),('16100','2014-03-16','11:35:00',1.73),('16100','2014-03-16','11:40:00',1.86),('16100','2014-03-16','11:45:00',2.07),('16100','2014-03-16','11:50:00',2.01),('16100','2014-03-16','11:55:00',2.88),('16100','2014-03-16','12:00:00',2.66),('16100','2014-03-16','12:05:00',3.12),('16100','2014-03-16','12:10:00',4.88),('16100','2014-03-16','12:15:00',3.7),('16100','2014-03-16','12:20:00',3.03),('16100','2014-03-16','12:25:00',3.65),('16100','2014-03-16','12:30:00',5.44),('16100','2014-03-16','12:35:00',7.19),('16100','2014-03-16','12:40:00',8.63),('16100','2014-03-16','12:45:00',6.73),('16100','2014-03-16','12:50:00',5.26),('16100','2014-03-16','12:55:00',4.93),('16100','2014-03-16','13:00:00',4),('16100','2014-03-16','13:05:00',7.6),('16100','2014-03-16','13:10:00',6.95),('16100','2014-03-16','13:15:00',5.44),('16100','2014-03-16','13:20:00',5.95),('16100','2014-03-16','13:25:00',6.89),('16100','2014-03-16','13:30:00',5.04),('16100','2014-03-16','13:35:00',6.73),('16100','2014-03-16','13:40:00',7.21),('16100','2014-03-16','13:45:00',6.78),('16100','2014-03-16','13:50:00',7.08),('16100','2014-03-16','13:55:00',6.48),('16100','2014-03-16','14:00:00',6.27),('16100','2014-03-16','14:05:00',5.57),('16100','2014-03-16','14:10:00',6.34),('16100','2014-03-16','14:15:00',6.33),('16100','2014-03-16','14:20:00',5.48),('16100','2014-03-16','14:25:00',3.24),('16100','2014-03-16','14:30:00',2.78),('16100','2014-03-16','14:35:00',2.9),('16100','2014-03-16','14:40:00',4.04),('16100','2014-03-16','14:45:00',2.5),('16100','2014-03-16','14:50:00',3.86),('16100','2014-03-16','14:55:00',3.31),('16100','2014-03-16','15:00:00',2.65),('16100','2014-03-16','15:05:00',2.38),('16100','2014-03-16','15:10:00',4.31),('16100','2014-03-16','15:15:00',5.09),('16100','2014-03-16','15:20:00',4.7),('16100','2014-03-16','15:25:00',4.16),('16100','2014-03-16','15:30:00',4.3),('16100','2014-03-16','15:35:00',4.26),('16100','2014-03-16','15:40:00',4),('16100','2014-03-16','15:45:00',4.02),('16100','2014-03-16','15:50:00',3.36),('16100','2014-03-16','15:55:00',2.47),('16100','2014-03-16','16:00:00',3.18),('16100','2014-03-16','16:05:00',3.17),('16100','2014-03-16','16:10:00',3.08),('16100','2014-03-16','16:15:00',2.87),('16100','2014-03-16','16:20:00',2.75),('16100','2014-03-16','16:25:00',2.55),('16100','2014-03-16','16:30:00',2.42),('16100','2014-03-16','16:35:00',2.19),('16100','2014-03-16','16:40:00',2.01),('16100','2014-03-16','16:45:00',1.83),('16100','2014-03-16','16:50:00',1.61),('16100','2014-03-16','16:55:00',1.18),('16100','2014-03-15','07:40:00',1.07),('16100','2014-03-15','07:45:00',1.15),('16100','2014-03-15','07:50:00',1.17),('16100','2014-03-15','07:55:00',1.49),('16100','2014-03-15','08:00:00',1.8),('16100','2014-03-15','08:05:00',2.03),('16100','2014-03-15','08:10:00',2.1),('16100','2014-03-15','08:15:00',2.14),('16100','2014-03-15','08:20:00',2.3),('16100','2014-03-15','08:25:00',2.6),('16100','2014-03-15','08:30:00',2.81),('16100','2014-03-15','08:35:00',2.96),('16100','2014-03-15','08:40:00',3.05),('16100','2014-03-15','08:45:00',3.23),('16100','2014-03-15','08:50:00',3.39),('16100','2014-03-15','08:55:00',3.48),('16100','2014-03-15','09:00:00',3.37),('16100','2014-03-15','09:05:00',3.67),('16100','2014-03-15','09:10:00',3.93),('16100','2014-03-15','09:15:00',4.19),('16100','2014-03-15','09:20:00',4.22),('16100','2014-03-15','09:25:00',4.2),('16100','2014-03-15','09:30:00',4.29),('16100','2014-03-15','09:35:00',4.4),('16100','2014-03-15','09:40:00',4.55),('16100','2014-03-15','09:45:00',4.78),('16100','2014-03-15','09:50:00',5.07),('16100','2014-03-15','09:55:00',5.12),('16100','2014-03-15','10:00:00',5.23),('16100','2014-03-15','10:05:00',5.36),('16100','2014-03-15','10:10:00',5.51),('16100','2014-03-15','10:15:00',5.61),('16100','2014-03-15','10:20:00',5.64),('16100','2014-03-15','10:25:00',5.55),('16100','2014-03-15','10:30:00',5.73),('16100','2014-03-15','10:35:00',5.87),('16100','2014-03-15','10:40:00',5.92),('16100','2014-03-15','10:45:00',6.08),('16100','2014-03-15','10:50:00',6.08),('16100','2014-03-15','10:55:00',6.23),('16100','2014-03-15','11:00:00',6.22),('16100','2014-03-15','11:05:00',6.3),('16100','2014-03-15','11:10:00',6.34),('16100','2014-03-15','11:15:00',6.53),('16100','2014-03-15','11:20:00',6.61),('16100','2014-03-15','11:25:00',6.46),('16100','2014-03-15','11:30:00',6.38),('16100','2014-03-15','11:35:00',6.39),('16100','2014-03-15','11:40:00',6.48),('16100','2014-03-15','11:45:00',6.51),('16100','2014-03-15','11:50:00',6.57),('16100','2014-03-15','11:55:00',6.64),('16100','2014-03-15','12:00:00',6.68),('16100','2014-03-15','12:05:00',6.67),('16100','2014-03-15','12:10:00',6.7),('16100','2014-03-15','12:15:00',6.66),('16100','2014-03-15','12:20:00',6.63),('16100','2014-03-15','12:25:00',6.55),('16100','2014-03-15','12:30:00',6.4),('16100','2014-03-15','12:35:00',6.58),('16100','2014-03-15','12:40:00',6.6),('16100','2014-03-15','12:45:00',6.59),('16100','2014-03-15','12:50:00',6.61),('16100','2014-03-15','12:55:00',6.6),('16100','2014-03-15','13:00:00',6.5),('16100','2014-03-15','13:05:00',6.58),('16100','2014-03-15','13:10:00',6.53),('16100','2014-03-15','13:15:00',6.55),('16100','2014-03-15','13:20:00',6.3),('16100','2014-03-15','13:25:00',6.49),('16100','2014-03-15','13:30:00',6.33),('16100','2014-03-15','13:35:00',6.4),('16100','2014-03-15','13:40:00',6.35),('16100','2014-03-15','13:45:00',6.33),('16100','2014-03-15','13:50:00',6.14),('16100','2014-03-15','13:55:00',6.23),('16100','2014-03-15','14:00:00',5.97),('16100','2014-03-15','14:05:00',5.92),('16100','2014-03-15','14:10:00',5.84),('16100','2014-03-15','14:15:00',5.82),('16100','2014-03-15','14:20:00',5.76),('16100','2014-03-15','14:25:00',5.63),('16100','2014-03-15','14:30:00',5.48),('16100','2014-03-15','14:35:00',5.3),('16100','2014-03-15','14:40:00',5.37),('16100','2014-03-15','14:45:00',5.03),('16100','2014-03-15','14:50:00',4.74),('16100','2014-03-15','14:55:00',4.95),('16100','2014-03-15','15:00:00',4.6),('16100','2014-03-15','15:05:00',4.39),('16100','2014-03-15','15:10:00',4.05),('16100','2014-03-15','15:15:00',3.16),('16100','2014-03-15','15:20:00',3.43),('16100','2014-03-15','15:25:00',3.43),('16100','2014-03-15','15:30:00',3.35),('16100','2014-03-15','15:35:00',2.45),('16100','2014-03-15','15:40:00',2.47),('16100','2014-03-15','15:45:00',3.08),('16100','2014-03-15','15:50:00',2.87),('16100','2014-03-15','15:55:00',2.49),('16100','2014-03-15','16:00:00',2.45),('16100','2014-03-15','16:05:00',2.98),('16100','2014-03-15','16:10:00',3),('16100','2014-03-15','16:15:00',2.81),('16100','2014-03-15','16:20:00',2.6),('16100','2014-03-15','16:25:00',2.52),('16100','2014-03-15','16:30:00',2.46),('16100','2014-03-15','16:35:00',2.15),('16100','2014-03-15','16:40:00',1.89),('16100','2014-03-15','16:45:00',1.74),('16100','2014-03-15','16:50:00',1.51),('16100','2014-03-15','16:55:00',1.23),('16100','2014-03-15','17:00:00',1.01),('16100','2014-03-14','07:40:00',1.02),('16100','2014-03-14','07:45:00',1.16),('16100','2014-03-14','07:50:00',1.3),('16100','2014-03-14','07:55:00',1.45),('16100','2014-03-14','08:00:00',1.61),('16100','2014-03-14','08:05:00',1.76),('16100','2014-03-14','08:10:00',1.93),('16100','2014-03-14','08:15:00',2.07),('16100','2014-03-14','08:20:00',2.25),('16100','2014-03-14','08:25:00',2.41),('16100','2014-03-14','08:30:00',2.53),('16100','2014-03-14','08:35:00',2.7),('16100','2014-03-14','08:40:00',2.86),('16100','2014-03-14','08:45:00',3.01),('16100','2014-03-14','08:50:00',3.15),('16100','2014-03-14','08:55:00',3.28),('16100','2014-03-14','09:00:00',3.4),('16100','2014-03-14','09:05:00',3.56),('16100','2014-03-14','09:10:00',3.69),('16100','2014-03-14','09:15:00',3.83),('16100','2014-03-14','09:20:00',3.96),('16100','2014-03-14','09:25:00',4.1),('16100','2014-03-14','09:30:00',4.21),('16100','2014-03-14','09:35:00',4.3),('16100','2014-03-14','09:40:00',4.45),('16100','2014-03-14','09:45:00',4.68),('16100','2014-03-14','09:50:00',4.81),('16100','2014-03-14','09:55:00',4.95),('16100','2014-03-14','10:00:00',5.05),('16100','2014-03-14','10:05:00',5.08),('16100','2014-03-14','10:10:00',5.16),('16100','2014-03-14','10:15:00',5.27),('16100','2014-03-14','10:20:00',5.35),('16100','2014-03-14','10:25:00',5.49),('16100','2014-03-14','10:30:00',5.52),('16100','2014-03-14','10:35:00',5.66),('16100','2014-03-14','10:40:00',5.74),('16100','2014-03-14','10:45:00',5.76),('16100','2014-03-14','10:50:00',5.75),('16100','2014-03-14','10:55:00',5.68),('16100','2014-03-14','11:00:00',6.01),('16100','2014-03-14','11:05:00',5.98),('16100','2014-03-14','11:10:00',6.17),('16100','2014-03-14','11:15:00',6.32),('16100','2014-03-14','11:20:00',6.28),('16100','2014-03-14','11:25:00',6.33),('16100','2014-03-14','11:30:00',6.31),('16100','2014-03-14','11:35:00',6.31),('16100','2014-03-14','11:40:00',6.49),('16100','2014-03-14','11:45:00',6.66),('16100','2014-03-14','11:50:00',6.61),('16100','2014-03-14','11:55:00',6.6),('16100','2014-03-14','12:00:00',6.69),('16100','2014-03-14','12:05:00',6.71),('16100','2014-03-14','12:10:00',6.69),('16100','2014-03-14','12:15:00',6.61),('16100','2014-03-14','12:20:00',6.65),('16100','2014-03-14','12:25:00',6.73),('16100','2014-03-14','12:30:00',6.76),('16100','2014-03-14','12:35:00',6.77),('16100','2014-03-14','12:40:00',6.79),('16100','2014-03-14','12:45:00',6.77),('16100','2014-03-14','12:50:00',6.74),('16100','2014-03-14','12:55:00',6.71),('16100','2014-03-14','13:00:00',6.7),('16100','2014-03-14','13:05:00',6.78),('16100','2014-03-14','13:10:00',6.69),('16100','2014-03-14','13:15:00',6.64),('16100','2014-03-14','13:20:00',6.6),('16100','2014-03-14','13:25:00',6.6),('16100','2014-03-14','13:30:00',6.54),('16100','2014-03-14','13:35:00',6.55),('16100','2014-03-14','13:40:00',6.46),('16100','2014-03-14','13:45:00',6.43),('16100','2014-03-14','13:50:00',6.33),('16100','2014-03-14','13:55:00',6.33),('16100','2014-03-14','14:00:00',6.22),('16100','2014-03-14','14:05:00',6.15),('16100','2014-03-14','14:10:00',6.06),('16100','2014-03-14','14:15:00',5.99),('16100','2014-03-14','14:20:00',5.9),('16100','2014-03-14','14:25:00',5.79),('16100','2014-03-14','14:30:00',5.67),('16100','2014-03-14','14:35:00',5.54),('16100','2014-03-14','14:40:00',5.39),('16100','2014-03-14','14:45:00',5.32),('16100','2014-03-14','14:50:00',5.24),('16100','2014-03-14','14:55:00',5.15),('16100','2014-03-14','15:00:00',4.99),('16100','2014-03-14','15:05:00',4.79),('16100','2014-03-14','15:10:00',4.66),('16100','2014-03-14','15:15:00',4.59),('16100','2014-03-14','15:20:00',4.33),('16100','2014-03-14','15:25:00',4.25),('16100','2014-03-14','15:30:00',4.17),('16100','2014-03-14','15:35:00',4.02),('16100','2014-03-14','15:40:00',3.84),('16100','2014-03-14','15:45:00',3.73),('16100','2014-03-14','15:50:00',3.37),('16100','2014-03-14','15:55:00',3.16),('16100','2014-03-14','16:00:00',3.04),('16100','2014-03-14','16:05:00',2.8),('16100','2014-03-14','16:10:00',2.65),('16100','2014-03-14','16:15:00',2.52),('16100','2014-03-14','16:20:00',2.46),('16100','2014-03-14','16:25:00',2.3),('16100','2014-03-14','16:30:00',2.12),('16100','2014-03-14','16:35:00',1.93),('16100','2014-03-14','16:40:00',1.75),('16100','2014-03-14','16:45:00',1.6),('16100','2014-03-14','16:50:00',1.45),('16100','2014-03-14','16:55:00',1.29),('16100','2014-03-14','17:00:00',1.14),('16100','2014-03-13','08:00:00',1.08),('16100','2014-03-13','08:05:00',1.15),('16100','2014-03-13','08:10:00',1.23),('16100','2014-03-13','08:15:00',1.34),('16100','2014-03-13','08:20:00',1.44),('16100','2014-03-13','08:25:00',1.57),('16100','2014-03-13','08:30:00',1.87),('16100','2014-03-13','08:35:00',1.91),('16100','2014-03-13','08:40:00',1.76),('16100','2014-03-13','08:45:00',1.62),('16100','2014-03-13','08:50:00',1.61),('16100','2014-03-13','08:55:00',1.71),('16100','2014-03-13','09:00:00',1.76),('16100','2014-03-13','09:05:00',1.89),('16100','2014-03-13','09:10:00',2.19),('16100','2014-03-13','09:15:00',2.85),('16100','2014-03-13','09:20:00',3.18),('16100','2014-03-13','09:25:00',3.11),('16100','2014-03-13','09:30:00',2.82),('16100','2014-03-13','09:35:00',2.99),('16100','2014-03-13','09:40:00',3.26),('16100','2014-03-13','09:45:00',3.86),('16100','2014-03-13','09:50:00',4.36),('16100','2014-03-13','09:55:00',4.85),('16100','2014-03-13','10:00:00',5.46),('16100','2014-03-13','10:05:00',5.7),('16100','2014-03-13','10:10:00',5.97),('16100','2014-03-13','10:15:00',5.95),('16100','2014-03-13','10:20:00',6.01),('16100','2014-03-13','10:25:00',6.2),('16100','2014-03-13','10:30:00',6.01),('16100','2014-03-13','10:35:00',5.76),('16100','2014-03-13','10:40:00',6.01),('16100','2014-03-13','10:45:00',6.25),('16100','2014-03-13','10:50:00',6.1),('16100','2014-03-13','10:55:00',4.23),('16100','2014-03-13','11:00:00',4.4),('16100','2014-03-13','11:05:00',6.05),('16100','2014-03-13','11:10:00',6.01),('16100','2014-03-13','11:15:00',6.53),('16100','2014-03-13','11:20:00',6.83),('16100','2014-03-13','11:25:00',6.73),('16100','2014-03-13','11:30:00',6.53),('16100','2014-03-13','11:35:00',6.55),('16100','2014-03-13','11:40:00',6.48),('16100','2014-03-13','11:45:00',6.42),('16100','2014-03-13','11:50:00',6.27),('16100','2014-03-13','11:55:00',6.61),('16100','2014-03-13','12:00:00',6.53),('16100','2014-03-13','12:05:00',6.78),('16100','2014-03-13','12:10:00',6.75),('16100','2014-03-13','12:15:00',6.54),('16100','2014-03-13','12:20:00',6.22),('16100','2014-03-13','12:25:00',6.22),('16100','2014-03-13','12:30:00',6.18),('16100','2014-03-13','12:35:00',5.14),('16100','2014-03-13','12:40:00',4.18),('16100','2014-03-13','12:45:00',3.69),('16100','2014-03-13','12:50:00',3.49),('16100','2014-03-13','12:55:00',4.08),('16100','2014-03-13','13:00:00',3.82),('16100','2014-03-13','13:05:00',3.36),('16100','2014-03-13','13:10:00',2.93),('16100','2014-03-13','13:15:00',3.89),('16100','2014-03-13','13:20:00',4.28),('16100','2014-03-13','13:25:00',4.54),('16100','2014-03-13','13:30:00',5.19),('16100','2014-03-13','13:35:00',4.77),('16100','2014-03-13','13:40:00',4.09),('16100','2014-03-13','13:45:00',3.38),('16100','2014-03-13','13:50:00',3.63),('16100','2014-03-13','13:55:00',3.84),('16100','2014-03-13','14:00:00',3.95),('16100','2014-03-13','14:05:00',4.1),('16100','2014-03-13','14:10:00',3.87),('16100','2014-03-13','14:15:00',3.81),('16100','2014-03-13','14:20:00',5.06),('16100','2014-03-13','14:25:00',4.4),('16100','2014-03-13','14:30:00',4.28),('16100','2014-03-13','14:35:00',4.58),('16100','2014-03-13','14:40:00',4.78),('16100','2014-03-13','14:45:00',3.8),('16100','2014-03-13','14:50:00',2.97),('16100','2014-03-13','14:55:00',2.66),('16100','2014-03-13','15:00:00',2.38),('16100','2014-03-13','15:05:00',2.07),('16100','2014-03-13','15:10:00',1.93),('16100','2014-03-13','15:15:00',1.83),('16100','2014-03-13','15:20:00',1.73),('16100','2014-03-13','15:25:00',1.97),('16100','2014-03-13','15:30:00',2.35),('16100','2014-03-13','15:35:00',2.29),('16100','2014-03-13','15:40:00',2.61),('16100','2014-03-13','15:45:00',2.71),('16100','2014-03-13','15:50:00',2.24),('16100','2014-03-13','15:55:00',1.91),('16100','2014-03-13','16:00:00',1.74),('16100','2014-03-13','16:05:00',1.54),('16100','2014-03-13','16:10:00',1.47),('16100','2014-03-13','16:15:00',1.31),('16100','2014-03-13','16:20:00',1.18),('16100','2014-03-12','07:35:00',1.12),('16100','2014-03-12','07:40:00',1.29),('16100','2014-03-12','07:45:00',1.48),('16100','2014-03-12','07:50:00',1.67),('16100','2014-03-12','07:55:00',1.87),('16100','2014-03-12','08:00:00',2.04),('16100','2014-03-12','08:05:00',2.25),('16100','2014-03-12','08:10:00',2.45),('16100','2014-03-12','08:15:00',2.63),('16100','2014-03-12','08:20:00',2.82),('16100','2014-03-12','08:25:00',2.99),('16100','2014-03-12','08:30:00',3.15),('16100','2014-03-12','08:35:00',3.34),('16100','2014-03-12','08:40:00',3.53),('16100','2014-03-12','08:45:00',3.68),('16100','2014-03-12','08:50:00',3.85),('16100','2014-03-12','08:55:00',4),('16100','2014-03-12','09:00:00',4.15),('16100','2014-03-12','09:05:00',3.99),('16100','2014-03-12','09:10:00',4.44),('16100','2014-03-12','09:15:00',4.58),('16100','2014-03-12','09:20:00',4.71),('16100','2014-03-12','09:25:00',4.83),('16100','2014-03-12','09:30:00',4.96),('16100','2014-03-12','09:35:00',5.07),('16100','2014-03-12','09:40:00',5.18),('16100','2014-03-12','09:45:00',5.33),('16100','2014-03-12','09:50:00',5.5),('16100','2014-03-12','09:55:00',5.19),('16100','2014-03-12','10:00:00',5.3),('16100','2014-03-12','10:05:00',5.8),('16100','2014-03-12','10:10:00',5.89),('16100','2014-03-12','10:15:00',5.98),('16100','2014-03-12','10:20:00',6.06),('16100','2014-03-12','10:25:00',6.13),('16100','2014-03-12','10:30:00',6.23),('16100','2014-03-12','10:35:00',6.31),('16100','2014-03-12','10:40:00',6.41),('16100','2014-03-12','10:45:00',6.54),('16100','2014-03-12','10:50:00',6.59),('16100','2014-03-12','10:55:00',6.66),('16100','2014-03-12','11:00:00',6.66),('16100','2014-03-12','11:05:00',6.71),('16100','2014-03-12','11:10:00',6.72),('16100','2014-03-12','11:15:00',6.82),('16100','2014-03-12','11:20:00',6.91),('16100','2014-03-12','11:25:00',6.89),('16100','2014-03-12','11:30:00',6.95),('16100','2014-03-12','11:35:00',7.02),('16100','2014-03-12','11:40:00',7.09),('16100','2014-03-12','11:45:00',7.08),('16100','2014-03-12','11:50:00',7.11),('16100','2014-03-12','11:55:00',7.1),('16100','2014-03-12','12:00:00',7.1),('16100','2014-03-12','12:05:00',7.11),('16100','2014-03-12','12:10:00',7.13),('16100','2014-03-12','12:15:00',7.1),('16100','2014-03-12','12:20:00',7.09),('16100','2014-03-12','12:25:00',7.08),('16100','2014-03-12','12:30:00',7.04),('16100','2014-03-12','12:35:00',7.04),('16100','2014-03-12','12:40:00',7.01),('16100','2014-03-12','12:45:00',6.99),('16100','2014-03-12','12:50:00',6.92),('16100','2014-03-12','12:55:00',6.81),('16100','2014-03-12','13:00:00',6.87),('16100','2014-03-12','13:05:00',6.94),('16100','2014-03-12','13:10:00',6.91),('16100','2014-03-12','13:15:00',6.94),('16100','2014-03-12','13:20:00',6.84),('16100','2014-03-12','13:25:00',6.77),('16100','2014-03-12','13:30:00',6.74),('16100','2014-03-12','13:35:00',6.7),('16100','2014-03-12','13:40:00',6.66),('16100','2014-03-12','13:45:00',6.59),('16100','2014-03-12','13:50:00',6.49),('16100','2014-03-12','13:55:00',6.38),('16100','2014-03-12','14:00:00',6.32),('16100','2014-03-12','14:05:00',6.26),('16100','2014-03-12','14:10:00',6.16),('16100','2014-03-12','14:15:00',6.07),('16100','2014-03-12','14:20:00',5.98),('16100','2014-03-12','14:25:00',5.89),('16100','2014-03-12','14:30:00',5.74),('16100','2014-03-12','14:35:00',5.63),('16100','2014-03-12','14:40:00',5.51),('16100','2014-03-12','14:45:00',5.41),('16100','2014-03-12','14:50:00',5.27),('16100','2014-03-12','14:55:00',5.16),('16100','2014-03-12','15:00:00',5),('16100','2014-03-12','15:05:00',4.86),('16100','2014-03-12','15:10:00',4.75),('16100','2014-03-12','15:15:00',4.59),('16100','2014-03-12','15:20:00',4.4),('16100','2014-03-12','15:25:00',4.27),('16100','2014-03-12','15:30:00',4.14),('16100','2014-03-12','15:35:00',4.02),('16100','2014-03-12','15:40:00',3.88),('16100','2014-03-12','15:45:00',3.73),('16100','2014-03-12','15:50:00',3.58),('16100','2014-03-12','15:55:00',3.43),('16100','2014-03-12','16:00:00',3.28),('16100','2014-03-12','16:05:00',3.09),('16100','2014-03-12','16:10:00',2.9),('16100','2014-03-12','16:15:00',2.74),('16100','2014-03-12','16:20:00',2.62),('16100','2014-03-12','16:25:00',2.49),('16100','2014-03-12','16:30:00',2.34),('16100','2014-03-12','16:35:00',2.16),('16100','2014-03-12','16:40:00',1.96),('16100','2014-03-12','16:45:00',1.81),('16100','2014-03-12','16:50:00',1.65),('16100','2014-03-12','16:55:00',1.46),('16100','2014-03-12','17:00:00',1.33),('16100','2014-03-12','17:05:00',1.15),('16100','2014-03-12','17:10:00',1.02),('16100','2014-03-11','07:35:00',1.05),('16100','2014-03-11','07:40:00',1.22),('16100','2014-03-11','07:45:00',1.41),('16100','2014-03-11','07:50:00',1.59),('16100','2014-03-11','07:55:00',1.79),('16100','2014-03-11','08:00:00',1.97),('16100','2014-03-11','08:05:00',2.18),('16100','2014-03-11','08:10:00',2.38),('16100','2014-03-11','08:15:00',2.56),('16100','2014-03-11','08:20:00',2.75),('16100','2014-03-11','08:25:00',2.92),('16100','2014-03-11','08:30:00',3.07),('16100','2014-03-11','08:35:00',3.23),('16100','2014-03-11','08:40:00',3.45),('16100','2014-03-11','08:45:00',3.59),('16100','2014-03-11','08:50:00',3.74),('16100','2014-03-11','08:55:00',3.92),('16100','2014-03-11','09:00:00',4.06),('16100','2014-03-11','09:05:00',4.19),('16100','2014-03-11','09:10:00',4.34),('16100','2014-03-11','09:15:00',4.46),('16100','2014-03-11','09:20:00',4.57),('16100','2014-03-11','09:25:00',4.72),('16100','2014-03-11','09:30:00',4.89),('16100','2014-03-11','09:35:00',5.01),('16100','2014-03-11','09:40:00',5.12),('16100','2014-03-11','09:45:00',5.26),('16100','2014-03-11','09:50:00',5.41),('16100','2014-03-11','09:55:00',5.54),('16100','2014-03-11','10:00:00',5.69),('16100','2014-03-11','10:05:00',5.78),('16100','2014-03-11','10:10:00',5.88),('16100','2014-03-11','10:15:00',5.98),('16100','2014-03-11','10:20:00',6.07),('16100','2014-03-11','10:25:00',6.14),('16100','2014-03-11','10:30:00',6.23),('16100','2014-03-11','10:35:00',6.35),('16100','2014-03-11','10:40:00',6.45),('16100','2014-03-11','10:45:00',6.55),('16100','2014-03-11','10:50:00',6.56),('16100','2014-03-11','10:55:00',6.66),('16100','2014-03-11','11:00:00',6.72),('16100','2014-03-11','11:05:00',6.77),('16100','2014-03-11','11:10:00',6.81),('16100','2014-03-11','11:15:00',6.84),('16100','2014-03-11','11:20:00',6.91),('16100','2014-03-11','11:25:00',6.95),('16100','2014-03-11','11:30:00',7),('16100','2014-03-11','11:35:00',7.03),('16100','2014-03-11','11:40:00',7.09),('16100','2014-03-11','11:45:00',7.05),('16100','2014-03-11','11:50:00',7.13),('16100','2014-03-11','11:55:00',7.17),('16100','2014-03-11','12:00:00',7.22),('16100','2014-03-11','12:05:00',7.2),('16100','2014-03-11','12:10:00',7.19),('16100','2014-03-11','12:15:00',7.22),('16100','2014-03-11','12:20:00',7.25),('16100','2014-03-11','12:25:00',7.25),('16100','2014-03-11','12:30:00',7.18),('16100','2014-03-11','12:35:00',7.12),('16100','2014-03-11','12:40:00',7.13),('16100','2014-03-11','12:45:00',7.15),('16100','2014-03-11','12:50:00',7.12),('16100','2014-03-11','12:55:00',7.13),('16100','2014-03-11','13:00:00',7.08),('16100','2014-03-11','13:05:00',7.03),('16100','2014-03-11','13:10:00',7),('16100','2014-03-11','13:15:00',6.98),('16100','2014-03-11','13:20:00',6.87),('16100','2014-03-11','13:25:00',6.79),('16100','2014-03-11','13:30:00',6.75),('16100','2014-03-11','13:35:00',6.68),('16100','2014-03-11','13:40:00',6.59),('16100','2014-03-11','13:45:00',6.62),('16100','2014-03-11','13:50:00',6.58),('16100','2014-03-11','13:55:00',6.52),('16100','2014-03-11','14:00:00',6.36),('16100','2014-03-11','14:05:00',6.27),('16100','2014-03-11','14:10:00',6.14),('16100','2014-03-11','14:15:00',6.07),('16100','2014-03-11','14:20:00',6),('16100','2014-03-11','14:25:00',5.9),('16100','2014-03-11','14:30:00',5.79),('16100','2014-03-11','14:35:00',5.66),('16100','2014-03-11','14:40:00',5.39),('16100','2014-03-11','14:45:00',5.4),('16100','2014-03-11','14:50:00',5.33),('16100','2014-03-11','14:55:00',5.28),('16100','2014-03-11','15:00:00',4.92),('16100','2014-03-11','15:05:00',4.9),('16100','2014-03-11','15:10:00',4.76),('16100','2014-03-11','15:15:00',4.66),('16100','2014-03-11','15:20:00',4.52),('16100','2014-03-11','15:25:00',4.37),('16100','2014-03-11','15:30:00',4.22),('16100','2014-03-11','15:35:00',4.11),('16100','2014-03-11','15:40:00',3.97),('16100','2014-03-11','15:45:00',3.8),('16100','2014-03-11','15:50:00',3.63),('16100','2014-03-11','15:55:00',3.47),('16100','2014-03-11','16:00:00',3.3),('16100','2014-03-11','16:05:00',3.15),('16100','2014-03-11','16:10:00',3.01),('16100','2014-03-11','16:15:00',2.87),('16100','2014-03-11','16:20:00',2.7),('16100','2014-03-11','16:25:00',2.53),('16100','2014-03-11','16:30:00',2.34),('16100','2014-03-11','16:35:00',2.15),('16100','2014-03-11','16:40:00',1.95),('16100','2014-03-11','16:45:00',1.75),('16100','2014-03-11','16:50:00',1.58),('16100','2014-03-11','16:55:00',1.41),('16100','2014-03-11','17:00:00',1.24),('16100','2014-03-11','17:05:00',1.09),('16100','2014-03-10','09:15:00',1.02),('16100','2014-03-10','10:15:00',1.15),('16100','2014-03-10','10:20:00',1.33),('16100','2014-03-10','10:25:00',1.38),('16100','2014-03-10','10:30:00',1.38),('16100','2014-03-10','10:35:00',1.24),('16100','2014-03-10','10:40:00',1.06),('16100','2014-03-10','10:50:00',1.04),('16100','2014-03-10','10:55:00',1.19),('16100','2014-03-10','11:00:00',1.29),('16100','2014-03-10','11:05:00',1.28),('16100','2014-03-10','11:10:00',1.38),('16100','2014-03-10','11:15:00',1.64),('16100','2014-03-10','11:20:00',1.6),('16100','2014-03-10','11:25:00',1.41),('16100','2014-03-10','11:30:00',1.11),('16100','2014-03-10','11:35:00',1.16),('16100','2014-03-10','11:40:00',1.25),('16100','2014-03-10','11:45:00',1.3),('16100','2014-03-10','11:50:00',1.35),('16100','2014-03-10','11:55:00',1.61),('16100','2014-03-10','12:00:00',1.75),('16100','2014-03-10','12:05:00',1.79),('16100','2014-03-10','12:10:00',1.95),('16100','2014-03-10','12:15:00',2.3),('16100','2014-03-10','12:20:00',2.58),('16100','2014-03-10','12:25:00',2.37),('16100','2014-03-10','12:30:00',2.06),('16100','2014-03-10','12:35:00',1.98),('16100','2014-03-10','12:40:00',1.91),('16100','2014-03-10','12:45:00',2.33),('16100','2014-03-10','12:50:00',2.96),('16100','2014-03-10','12:55:00',3.11),('16100','2014-03-10','13:00:00',3.44),('16100','2014-03-10','13:05:00',3),('16100','2014-03-10','13:10:00',3),('16100','2014-03-10','13:15:00',2.13),('16100','2014-03-10','13:20:00',2.27),('16100','2014-03-10','13:25:00',2.17),('16100','2014-03-10','13:30:00',1.84),('16100','2014-03-10','13:35:00',1.79),('16100','2014-03-10','13:40:00',2.01),('16100','2014-03-10','13:45:00',2.35),('16100','2014-03-10','13:50:00',2.6),('16100','2014-03-10','13:55:00',2.85),('16100','2014-03-10','14:00:00',4.57),('16100','2014-03-10','14:05:00',4.27),('16100','2014-03-10','14:10:00',4.23),('16100','2014-03-10','14:15:00',3.49),('16100','2014-03-10','14:20:00',3.3),('16100','2014-03-10','14:25:00',3.68),('16100','2014-03-10','14:30:00',3.12),('16100','2014-03-10','14:35:00',2.92),('16100','2014-03-10','14:40:00',2.91),('16100','2014-03-10','14:45:00',2.95),('16100','2014-03-10','14:50:00',2.62),('16100','2014-03-10','14:55:00',2.63),('16100','2014-03-10','15:00:00',2.85),('16100','2014-03-10','15:05:00',2.89),('16100','2014-03-10','15:10:00',2.9),('16100','2014-03-10','15:15:00',2.75),('16100','2014-03-10','15:20:00',2),('16100','2014-03-10','15:25:00',1.74),('16100','2014-03-10','15:30:00',1.6),('16100','2014-03-10','15:35:00',1.44),('16100','2014-03-10','15:40:00',1.35),('16100','2014-03-10','15:45:00',1.41),('16100','2014-03-10','15:50:00',1.18),('16100','2014-03-10','15:55:00',1),('16100','2014-03-09','08:30:00',1.08),('16100','2014-03-09','08:35:00',1.18),('16100','2014-03-09','08:40:00',1.32),('16100','2014-03-09','08:45:00',1.37),('16100','2014-03-09','08:50:00',1.45),('16100','2014-03-09','08:55:00',1.53),('16100','2014-03-09','09:00:00',1.56),('16100','2014-03-09','09:05:00',1.6),('16100','2014-03-09','09:10:00',1.64),('16100','2014-03-09','09:15:00',1.63),('16100','2014-03-09','09:20:00',1.24),('16100','2014-03-09','09:25:00',1.14),('16100','2014-03-09','09:30:00',1.34),('16100','2014-03-09','09:35:00',1.7),('16100','2014-03-09','09:40:00',1.9),('16100','2014-03-09','09:45:00',2.01),('16100','2014-03-09','09:50:00',2.01),('16100','2014-03-09','09:55:00',1.58),('16100','2014-03-09','10:00:00',1.21),('16100','2014-03-09','10:05:00',1.28),('16100','2014-03-09','10:10:00',1.24),('16100','2014-03-09','10:15:00',1.48),('16100','2014-03-09','10:20:00',1.6),('16100','2014-03-09','10:25:00',1.38),('16100','2014-03-09','10:30:00',1.4),('16100','2014-03-09','10:35:00',1.43),('16100','2014-03-09','10:40:00',1.29),('16100','2014-03-09','11:15:00',1.11),('16100','2014-03-09','11:20:00',1.37),('16100','2014-03-09','11:25:00',1.25),('16100','2014-03-09','11:30:00',1.1),('16100','2014-03-09','12:10:00',1.03),('16100','2014-03-09','12:35:00',1.03),('16100','2014-03-09','12:40:00',1.23),('16100','2014-03-09','12:45:00',1.4),('16100','2014-03-09','12:50:00',1.47),('16100','2014-03-09','12:55:00',1.54),('16100','2014-03-09','13:00:00',1.71),('16100','2014-03-09','13:05:00',1.79),('16100','2014-03-09','13:10:00',1.85),('16100','2014-03-09','13:15:00',1.69),('16100','2014-03-09','13:20:00',1.5),('16100','2014-03-09','13:25:00',1.41),('16100','2014-03-09','13:30:00',1.15),('16100','2014-03-09','13:35:00',1.06),('16100','2014-03-09','14:05:00',1),('16100','2014-03-09','14:10:00',1.58),('16100','2014-03-09','14:15:00',1.85),('16100','2014-03-09','14:20:00',1.77),('16100','2014-03-09','14:25:00',1.24),('16100','2014-03-09','14:30:00',1.25),('16100','2014-03-09','14:35:00',1.66),('16100','2014-03-09','14:40:00',1.76),('16100','2014-03-09','14:45:00',1.6),('16100','2014-03-09','14:50:00',1.71),('16100','2014-03-09','14:55:00',1.98),('16100','2014-03-09','15:00:00',2.44),('16100','2014-03-09','15:05:00',5.91),('16100','2014-03-09','15:10:00',5.21),('16100','2014-03-09','15:15:00',5.33),('16100','2014-03-09','15:20:00',4.81),('16100','2014-03-09','15:25:00',3.94),('16100','2014-03-09','15:30:00',3.81),('16100','2014-03-09','15:35:00',2.63),('16100','2014-03-09','15:40:00',1.64),('16100','2014-03-09','15:45:00',1.36),('16100','2014-03-09','15:50:00',1.51),('16100','2014-03-09','15:55:00',1.53),('16100','2014-03-09','16:00:00',1.4),('16100','2014-03-09','16:05:00',1.03),('16100','2014-03-09','16:20:00',1.07),('16100','2014-03-09','16:25:00',1.45),('16100','2014-03-09','16:30:00',2.39),('16100','2014-03-09','16:35:00',2.8),('16100','2014-03-09','16:40:00',1.98),('16100','2014-03-09','16:45:00',1.48),('16100','2014-03-09','16:50:00',1.12),('16100','2014-03-09','16:55:00',1.29),('16100','2014-03-09','17:00:00',1.4),('16100','2014-03-09','17:05:00',1.39),('16100','2014-03-08','07:40:00',1.01),('16100','2014-03-08','07:45:00',1.31),('16100','2014-03-08','07:50:00',1.5),('16100','2014-03-08','07:55:00',1.69),('16100','2014-03-08','08:00:00',1.88),('16100','2014-03-08','08:05:00',2.07),('16100','2014-03-08','08:10:00',2.27),('16100','2014-03-08','08:15:00',2.46),('16100','2014-03-08','08:20:00',2.66),('16100','2014-03-08','08:25:00',2.86),('16100','2014-03-08','08:30:00',3.05),('16100','2014-03-08','08:35:00',3.22),('16100','2014-03-08','08:40:00',3.44),('16100','2014-03-08','08:45:00',3.69),('16100','2014-03-08','08:50:00',3.8),('16100','2014-03-08','08:55:00',3.89),('16100','2014-03-08','09:00:00',4.09),('16100','2014-03-08','09:05:00',4.25),('16100','2014-03-08','09:10:00',4.38),('16100','2014-03-08','09:15:00',4.57),('16100','2014-03-08','09:20:00',4.77),('16100','2014-03-08','09:25:00',3.56),('16100','2014-03-08','09:30:00',5.16),('16100','2014-03-08','09:35:00',5.38),('16100','2014-03-08','09:40:00',5.61),('16100','2014-03-08','09:45:00',5.69),('16100','2014-03-08','09:50:00',5.95),('16100','2014-03-08','09:55:00',6.01),('16100','2014-03-08','10:00:00',6.14),('16100','2014-03-08','10:05:00',6.18),('16100','2014-03-08','10:10:00',6.27),('16100','2014-03-08','10:15:00',6.37),('16100','2014-03-08','10:20:00',6.42),('16100','2014-03-08','10:25:00',6.45),('16100','2014-03-08','10:30:00',6.45),('16100','2014-03-08','10:35:00',6.67),('16100','2014-03-08','10:40:00',6.76),('16100','2014-03-08','10:45:00',6.91),('16100','2014-03-08','10:50:00',6.85),('16100','2014-03-08','10:55:00',7.03),('16100','2014-03-08','11:00:00',7.48),('16100','2014-03-08','11:05:00',7.56),('16100','2014-03-08','11:10:00',7.68),('16100','2014-03-08','11:15:00',7.79),('16100','2014-03-08','11:20:00',4.87),('16100','2014-03-08','11:25:00',1.52),('16100','2014-03-08','11:30:00',1.77),('16100','2014-03-08','11:35:00',4.34),('16100','2014-03-08','11:40:00',7.74),('16100','2014-03-08','11:45:00',2.88),('16100','2014-03-08','11:50:00',2.11),('16100','2014-03-08','11:55:00',3.15),('16100','2014-03-08','12:00:00',5.21),('16100','2014-03-08','12:05:00',3.08),('16100','2014-03-08','12:10:00',2.38),('16100','2014-03-08','12:15:00',5.16),('16100','2014-03-08','12:20:00',8.59),('16100','2014-03-08','12:25:00',8.44),('16100','2014-03-08','12:30:00',8.18),('16100','2014-03-08','12:35:00',8.23),('16100','2014-03-08','12:40:00',8.08),('16100','2014-03-08','12:45:00',7.86),('16100','2014-03-08','12:50:00',7.62),('16100','2014-03-08','12:55:00',7.14),('16100','2014-03-08','13:00:00',4.21),('16100','2014-03-08','13:05:00',2.41),('16100','2014-03-08','13:10:00',4.58),('16100','2014-03-08','13:15:00',2.81),('16100','2014-03-08','13:20:00',4.77),('16100','2014-03-08','13:25:00',7.16),('16100','2014-03-08','13:30:00',3.94),('16100','2014-03-08','13:35:00',2.51),('16100','2014-03-08','13:40:00',1.61),('16100','2014-03-08','13:45:00',4.69),('16100','2014-03-08','13:50:00',6.45),('16100','2014-03-08','13:55:00',5.1),('16100','2014-03-08','14:00:00',3.42),('16100','2014-03-08','14:05:00',3.78),('16100','2014-03-08','14:10:00',6.29),('16100','2014-03-08','14:15:00',6.64),('16100','2014-03-08','14:20:00',6.48),('16100','2014-03-08','14:25:00',6.41),('16100','2014-03-08','14:30:00',6.36),('16100','2014-03-08','14:35:00',6.35),('16100','2014-03-08','14:40:00',6.19),('16100','2014-03-08','14:45:00',6.11),('16100','2014-03-08','14:50:00',5.82),('16100','2014-03-08','14:55:00',5.61),('16100','2014-03-08','15:00:00',5.57),('16100','2014-03-08','15:05:00',5.58),('16100','2014-03-08','15:10:00',5.55),('16100','2014-03-08','15:15:00',2.89),('16100','2014-03-08','15:20:00',1.48),('16100','2014-03-08','15:25:00',1.55),('16100','2014-03-08','15:30:00',1.23),('16100','2014-03-08','15:35:00',2.86),('16100','2014-03-08','15:40:00',3.19),('16100','2014-03-08','15:45:00',2.57),('16100','2014-03-08','15:50:00',3.81),('16100','2014-03-08','15:55:00',2.54),('16100','2014-03-08','16:05:00',1.03),('16100','2014-03-08','16:20:00',2.28),('16100','2014-03-08','16:25:00',2.67),('16100','2014-03-08','16:30:00',2.43),('16100','2014-03-08','16:35:00',2.22),('16100','2014-03-08','16:40:00',2.03),('16100','2014-03-08','16:45:00',1.84),('16100','2014-03-08','16:50:00',1.69),('16100','2014-03-08','16:55:00',1.51),('16100','2014-03-08','17:00:00',1.35),('16100','2014-03-08','17:05:00',1.18),('16100','2014-03-07','07:40:00',1.14),('16100','2014-03-07','07:45:00',1.31),('16100','2014-03-07','07:50:00',1.49),('16100','2014-03-07','07:55:00',1.66),('16100','2014-03-07','08:00:00',1.86),('16100','2014-03-07','08:05:00',2.05),('16100','2014-03-07','08:10:00',2.26),('16100','2014-03-07','08:15:00',2.47),('16100','2014-03-07','08:20:00',2.64),('16100','2014-03-07','08:25:00',2.82),('16100','2014-03-07','08:30:00',2.98),('16100','2014-03-07','08:35:00',3.14),('16100','2014-03-07','08:40:00',3.32),('16100','2014-03-07','08:45:00',3.51),('16100','2014-03-07','08:50:00',3.69),('16100','2014-03-07','08:55:00',3.84),('16100','2014-03-07','09:00:00',3.96),('16100','2014-03-07','09:05:00',4.12),('16100','2014-03-07','09:10:00',4.27),('16100','2014-03-07','09:15:00',4.44),('16100','2014-03-07','09:20:00',4.59),('16100','2014-03-07','09:25:00',4.73),('16100','2014-03-07','09:30:00',4.85),('16100','2014-03-07','09:35:00',4.93),('16100','2014-03-07','09:40:00',5.02),('16100','2014-03-07','09:45:00',5.19),('16100','2014-03-07','09:50:00',5.38),('16100','2014-03-07','09:55:00',5.56),('16100','2014-03-07','10:00:00',5.64),('16100','2014-03-07','10:05:00',5.76),('16100','2014-03-07','10:10:00',5.84),('16100','2014-03-07','10:15:00',5.97),('16100','2014-03-07','10:20:00',6.02),('16100','2014-03-07','10:25:00',6.15),('16100','2014-03-07','10:30:00',6.24),('16100','2014-03-07','10:35:00',6.43),('16100','2014-03-07','10:40:00',6.67),('16100','2014-03-07','10:45:00',6.73),('16100','2014-03-07','10:50:00',6.7),('16100','2014-03-07','10:55:00',6.78),('16100','2014-03-07','11:00:00',6.82),('16100','2014-03-07','11:05:00',6.89),('16100','2014-03-07','11:10:00',7.06),('16100','2014-03-07','11:15:00',7.15),('16100','2014-03-07','11:20:00',7.39),('16100','2014-03-07','11:25:00',7.5),('16100','2014-03-07','11:30:00',7.75),('16100','2014-03-07','11:35:00',7.16),('16100','2014-03-07','11:40:00',8.35),('16100','2014-03-07','11:45:00',8.25),('16100','2014-03-07','11:50:00',8.44),('16100','2014-03-07','11:55:00',8.46),('16100','2014-03-07','12:00:00',8.49),('16100','2014-03-07','12:05:00',7.16),('16100','2014-03-07','12:10:00',6.89),('16100','2014-03-07','12:15:00',9.33),('16100','2014-03-07','12:20:00',7.87),('16100','2014-03-07','12:25:00',4.97),('16100','2014-03-07','12:30:00',3.26),('16100','2014-03-07','12:35:00',2.81),('16100','2014-03-07','12:40:00',2.92),('16100','2014-03-07','12:45:00',2.91),('16100','2014-03-07','12:50:00',2.83),('16100','2014-03-07','12:55:00',3.4),('16100','2014-03-07','13:00:00',3.72),('16100','2014-03-07','13:05:00',3.33),('16100','2014-03-07','13:10:00',2.74),('16100','2014-03-07','13:15:00',2.32),('16100','2014-03-07','13:20:00',1.91),('16100','2014-03-07','13:25:00',1.62),('16100','2014-03-07','13:30:00',1.71),('16100','2014-03-07','13:35:00',2.13),('16100','2014-03-07','13:40:00',3.1),('16100','2014-03-07','13:45:00',2.7),('16100','2014-03-07','13:50:00',3.69),('16100','2014-03-07','13:55:00',3.91),('16100','2014-03-07','14:00:00',2.34),('16100','2014-03-07','14:05:00',2.04),('16100','2014-03-07','14:10:00',1.75),('16100','2014-03-07','14:15:00',1.4),('16100','2014-03-07','14:20:00',1.09),('16100','2014-03-07','14:25:00',1.06),('16100','2014-03-07','14:40:00',1.17),('16100','2014-03-07','14:45:00',1.33),('16100','2014-03-07','14:50:00',1.39),('16100','2014-03-07','14:55:00',1.56),('16100','2014-03-07','15:00:00',1.66),('16100','2014-03-07','15:05:00',1.55),('16100','2014-03-07','15:10:00',1.31),('16100','2014-03-07','15:15:00',1.38),('16100','2014-03-07','15:20:00',1.75),('16100','2014-03-07','15:25:00',2.78),('16100','2014-03-07','15:30:00',1.63),('16100','2014-03-07','15:35:00',1.14),('16100','2014-03-07','15:55:00',1.1),('16100','2014-03-07','16:00:00',1.28),('16100','2014-03-07','16:05:00',1.3),('16100','2014-03-07','16:10:00',1.28),('16100','2014-03-07','16:30:00',2.18),('16100','2014-03-07','16:40:00',2.28),('16100','2014-03-07','16:45:00',2.01),('16100','2014-03-07','16:50:00',1.83),('16100','2014-03-07','16:55:00',1.63),('16100','2014-03-07','17:00:00',1.39),('16100','2014-03-07','17:05:00',1.22),('16100','2014-03-07','17:10:00',1.06),('16100','2014-04-29','07:55:00',1.06),('16100','2014-04-29','08:00:00',1.24),('16100','2014-04-29','08:05:00',1.38),('16100','2014-04-29','08:10:00',1.59),('16100','2014-04-29','08:15:00',1.77),('16100','2014-04-29','08:20:00',1.94),('16100','2014-04-29','08:25:00',2.22),('16100','2014-04-29','08:30:00',2.49),('16100','2014-04-29','08:35:00',2.74),('16100','2014-04-29','08:40:00',2.88),('16100','2014-04-29','08:45:00',3.05),('16100','2014-04-29','08:50:00',3.23),('16100','2014-04-29','08:55:00',3.32),('16100','2014-04-29','09:00:00',3.49),('16100','2014-04-29','09:05:00',3.69),('16100','2014-04-29','09:10:00',3.72),('16100','2014-04-29','09:15:00',4.07),('16100','2014-04-29','09:20:00',4.3),('16100','2014-04-29','09:25:00',4.63),('16100','2014-04-29','09:30:00',1.87),('16100','2014-04-29','09:35:00',2.69),('16100','2014-04-29','09:40:00',3.25),('16100','2014-04-29','09:45:00',4.63),('16100','2014-04-29','09:50:00',5.27),('16100','2014-04-29','09:55:00',4.48),('16100','2014-04-29','10:00:00',5.64),('16100','2014-04-29','10:05:00',5.65),('16100','2014-04-29','10:10:00',5.74),('16100','2014-04-29','10:15:00',4.94),('16100','2014-04-29','10:20:00',6.06),('16100','2014-04-29','10:25:00',3.28),('16100','2014-04-29','10:30:00',7.04),('16100','2014-04-29','10:35:00',3.91),('16100','2014-04-29','10:40:00',1.58),('16100','2014-04-29','10:45:00',1.85),('16100','2014-04-29','10:50:00',2.18),('16100','2014-04-29','10:55:00',3.78),('16100','2014-04-29','11:00:00',3.73),('16100','2014-04-29','11:05:00',3.32),('16100','2014-04-29','11:10:00',3.04),('16100','2014-04-29','11:15:00',5.01),('16100','2014-04-29','11:20:00',5.03),('16100','2014-04-29','11:25:00',5.7),('16100','2014-04-29','11:30:00',4.21),('16100','2014-04-29','11:35:00',3.48),('16100','2014-04-29','11:40:00',4.83),('16100','2014-04-29','11:45:00',6.63),('16100','2014-04-29','11:50:00',4.7),('16100','2014-04-29','11:55:00',3.59),('16100','2014-04-29','12:00:00',2.76),('16100','2014-04-29','12:05:00',4.61),('16100','2014-04-29','12:10:00',3.48),('16100','2014-04-29','12:15:00',7.43),('16100','2014-04-29','12:20:00',6.56),('16100','2014-04-29','12:25:00',8.55),('16100','2014-04-29','12:30:00',4.97),('16100','2014-04-29','12:35:00',5.39),('16100','2014-04-29','12:40:00',8.47),('16100','2014-04-29','12:45:00',8.78),('16100','2014-04-29','12:50:00',8.15),('16100','2014-04-29','12:55:00',5.59),('16100','2014-04-29','13:00:00',6.11),('16100','2014-04-29','13:05:00',3.3),('16100','2014-04-29','13:10:00',1.88),('16100','2014-04-29','13:15:00',4.77),('16100','2014-04-29','13:20:00',3.35),('16100','2014-04-29','13:25:00',3.96),('16100','2014-04-29','13:30:00',3.97),('16100','2014-04-29','13:35:00',3.01),('16100','2014-04-29','13:40:00',3.63),('16100','2014-04-29','13:45:00',3.13),('16100','2014-04-29','13:50:00',2.75),('16100','2014-04-29','13:55:00',2.73),('16100','2014-04-29','14:00:00',3.32),('16100','2014-04-29','14:05:00',3.87),('16100','2014-04-29','14:10:00',3.94),('16100','2014-04-29','14:15:00',2.45),('16100','2014-04-29','14:20:00',2.09),('16100','2014-04-29','14:25:00',2.19),('16100','2014-04-29','14:30:00',3.35),('16100','2014-04-29','14:35:00',2.88),('16100','2014-04-29','14:40:00',2.44),('16100','2014-04-29','14:45:00',2.38),('16100','2014-04-29','14:50:00',2.78),('16100','2014-04-29','14:55:00',2.44),('16100','2014-04-29','15:00:00',2.33),('16100','2014-04-29','15:05:00',2.13),('16100','2014-04-29','15:10:00',2.44),('16100','2014-04-29','15:15:00',1.79),('16100','2014-04-29','15:20:00',1.67),('16100','2014-04-29','15:25:00',3.37),('16100','2014-04-29','15:30:00',5.92),('16100','2014-04-29','15:35:00',6.17),('16100','2014-04-29','15:40:00',5.94),('16100','2014-04-29','15:45:00',6.36),('16100','2014-04-29','15:50:00',4.49),('16100','2014-04-29','15:55:00',4.86),('16100','2014-04-29','16:00:00',4.06),('16100','2014-04-29','16:05:00',5.43),('16100','2014-04-29','16:10:00',1.96),('16100','2014-04-29','16:15:00',3.23),('16100','2014-04-29','16:20:00',4.49),('16100','2014-04-29','16:25:00',5.07),('16100','2014-04-29','16:30:00',2.83),('16100','2014-04-29','16:35:00',4.18),('16100','2014-04-29','16:40:00',5.47),('16100','2014-04-29','16:45:00',2.86),('16100','2014-04-29','16:50:00',3.59),('16100','2014-04-29','16:55:00',2.71),('16100','2014-04-29','17:00:00',2.27),('16100','2014-04-29','17:05:00',2.51),('16100','2014-04-29','17:10:00',1.88),('16100','2014-04-29','17:15:00',1.37),('16100','2014-04-29','17:20:00',1.81),('16100','2014-04-29','17:30:00',1.14),('16100','2014-04-29','17:35:00',1.71),('16100','2014-04-29','17:40:00',1.28),('16100','2014-04-29','17:50:00',1.35),('16100','2014-03-06','07:35:00',1.03),('16100','2014-03-06','07:50:00',1.06),('16100','2014-03-06','07:55:00',1.15),('16100','2014-03-06','10:05:00',1.04),('16100','2014-03-06','10:15:00',1.35),('16100','2014-03-06','10:20:00',2.72),('16100','2014-03-06','10:25:00',4.8),('16100','2014-03-06','10:30:00',5.29),('16100','2014-03-06','10:35:00',1.42),('16100','2014-03-06','10:40:00',1.43),('16100','2014-03-06','10:45:00',2.43),('16100','2014-03-06','10:50:00',4.67),('16100','2014-03-06','10:55:00',2.65),('16100','2014-03-06','11:00:00',2.59),('16100','2014-03-06','11:05:00',1.41),('16100','2014-03-06','11:10:00',1.47),('16100','2014-03-06','11:15:00',2.04),('16100','2014-03-06','11:20:00',8.9),('16100','2014-03-06','11:25:00',6.58),('16100','2014-03-06','11:30:00',8.45),('16100','2014-03-06','11:35:00',5.33),('16100','2014-03-06','11:40:00',5.41),('16100','2014-03-06','11:45:00',5.65),('16100','2014-03-06','11:50:00',7.7),('16100','2014-03-06','11:55:00',8.34),('16100','2014-03-06','12:00:00',8.22),('16100','2014-03-06','12:05:00',7.96),('16100','2014-03-06','12:10:00',7.64),('16100','2014-03-06','12:15:00',7.62),('16100','2014-03-06','12:20:00',7.62),('16100','2014-03-06','12:25:00',4.53),('16100','2014-03-06','12:30:00',5.93),('16100','2014-03-06','12:35:00',5.08),('16100','2014-03-06','12:40:00',5.82),('16100','2014-03-06','12:45:00',7.75),('16100','2014-03-06','12:50:00',7.71),('16100','2014-03-06','12:55:00',7.82),('16100','2014-03-06','13:00:00',7.76),('16100','2014-03-06','13:05:00',4.27),('16100','2014-03-06','13:10:00',2.09),('16100','2014-03-06','13:15:00',3.65),('16100','2014-03-06','13:20:00',6.76),('16100','2014-03-06','13:25:00',5.57),('16100','2014-03-06','13:30:00',6.09),('16100','2014-03-06','13:35:00',4.43),('16100','2014-03-06','13:40:00',3.2),('16100','2014-03-06','13:45:00',3.03),('16100','2014-03-06','13:50:00',3.02),('16100','2014-03-06','13:55:00',2.46),('16100','2014-03-06','14:00:00',2.14),('16100','2014-03-06','14:05:00',2.02),('16100','2014-03-06','14:10:00',1.91),('16100','2014-03-06','14:15:00',1.86),('16100','2014-03-06','14:20:00',1.91),('16100','2014-03-06','14:25:00',1.95),('16100','2014-03-06','14:30:00',1.99),('16100','2014-03-06','14:35:00',2.27),('16100','2014-03-06','14:40:00',2.43),('16100','2014-03-06','14:45:00',2.96),('16100','2014-03-06','14:50:00',3.61),('16100','2014-03-06','14:55:00',4.35),('16100','2014-03-06','15:00:00',4.63),('16100','2014-03-06','15:05:00',5.22),('16100','2014-03-06','15:10:00',5.23),('16100','2014-03-06','15:15:00',5.34),('16100','2014-03-06','15:20:00',4.71),('16100','2014-03-06','15:25:00',3.71),('16100','2014-03-06','15:30:00',1.54),('16100','2014-03-06','15:35:00',2.08),('16100','2014-03-06','15:40:00',4.31),('16100','2014-03-06','15:45:00',4.13),('16100','2014-03-06','15:50:00',2.57),('16100','2014-03-06','15:55:00',3.91),('16100','2014-03-06','16:00:00',3.81),('16100','2014-03-06','16:05:00',3.5),('16100','2014-03-06','16:10:00',3.14),('16100','2014-03-06','16:15:00',3.06),('16100','2014-03-06','16:20:00',2.76),('16100','2014-03-06','16:25:00',2.66),('16100','2014-03-06','16:30:00',2.48),('16100','2014-03-06','16:35:00',2.35),('16100','2014-03-06','16:40:00',2.3),('16100','2014-03-06','16:45:00',2.14),('16100','2014-03-06','16:50:00',1.98),('16100','2014-03-06','16:55:00',1.81),('16100','2014-03-06','17:00:00',1.64),('16100','2014-03-06','17:05:00',1.47),('16100','2014-03-06','17:10:00',1.29),('16100','2014-03-06','17:15:00',1.09),('16100','2014-03-05','08:10:00',1.51),('16100','2014-03-05','08:15:00',1.59),('16100','2014-03-05','08:20:00',1.24),('16100','2014-03-05','08:30:00',1.1),('16100','2014-03-05','08:35:00',1.34),('16100','2014-03-05','08:40:00',1.1),('16100','2014-03-05','08:45:00',1.47),('16100','2014-03-05','08:50:00',1.66),('16100','2014-03-05','08:55:00',1.02),('16100','2014-03-05','09:00:00',1.11),('16100','2014-03-05','09:05:00',3.04),('16100','2014-03-05','09:10:00',2.76),('16100','2014-03-05','09:15:00',2.07),('16100','2014-03-05','09:20:00',3.08),('16100','2014-03-05','09:25:00',3.35),('16100','2014-03-05','09:30:00',3.94),('16100','2014-03-05','09:35:00',2.78),('16100','2014-03-05','09:40:00',2.59),('16100','2014-03-05','09:45:00',2.88),('16100','2014-03-05','09:50:00',3.43),('16100','2014-03-05','09:55:00',3.36),('16100','2014-03-05','10:00:00',3.55),('16100','2014-03-05','10:05:00',3.96),('16100','2014-03-05','10:10:00',4.43),('16100','2014-03-05','10:15:00',5.07),('16100','2014-03-05','10:20:00',5.29),('16100','2014-03-05','10:25:00',5.01),('16100','2014-03-05','10:30:00',6.52),('16100','2014-03-05','10:35:00',6.22),('16100','2014-03-05','10:40:00',6.94),('16100','2014-03-05','10:45:00',6.94),('16100','2014-03-05','10:50:00',7.03),('16100','2014-03-05','10:55:00',7.03),('16100','2014-03-05','11:00:00',7.13),('16100','2014-03-05','11:05:00',6.92),('16100','2014-03-05','11:10:00',5.54),('16100','2014-03-05','11:15:00',6.56),('16100','2014-03-05','11:20:00',7.36),('16100','2014-03-05','11:25:00',5.72),('16100','2014-03-05','11:30:00',8.09),('16100','2014-03-05','11:35:00',6.07),('16100','2014-03-05','11:40:00',3.11),('16100','2014-03-05','11:45:00',2.21),('16100','2014-03-05','11:50:00',2.33),('16100','2014-03-05','11:55:00',2.36),('16100','2014-03-05','12:00:00',3.18),('16100','2014-03-05','12:05:00',2.29),('16100','2014-03-05','12:10:00',3.57),('16100','2014-03-05','12:15:00',6.19),('16100','2014-03-05','12:20:00',2.45),('16100','2014-03-05','12:25:00',1.79),('16100','2014-03-05','12:30:00',1.56),('16100','2014-03-05','12:35:00',1.94),('16100','2014-03-05','12:40:00',3.43),('16100','2014-03-05','12:45:00',1.99),('16100','2014-03-05','12:50:00',3.72),('16100','2014-03-05','12:55:00',5.28),('16100','2014-03-05','13:00:00',2.9),('16100','2014-03-05','13:05:00',2.68),('16100','2014-03-05','13:10:00',2.16),('16100','2014-03-05','13:15:00',2.23),('16100','2014-03-05','13:20:00',2.09),('16100','2014-03-05','13:25:00',1.9),('16100','2014-03-05','13:30:00',1.67),('16100','2014-03-05','13:35:00',1.53),('16100','2014-03-05','13:40:00',1.46),('16100','2014-03-05','13:45:00',1.7),('16100','2014-03-05','13:50:00',1.8),('16100','2014-03-05','13:55:00',1.71),('16100','2014-03-05','14:00:00',1.78),('16100','2014-03-05','14:05:00',1.8),('16100','2014-03-05','14:10:00',2.08),('16100','2014-03-05','14:15:00',2.09),('16100','2014-03-05','14:20:00',2.05),('16100','2014-03-05','14:25:00',1.97),('16100','2014-03-05','14:30:00',1.84),('16100','2014-03-05','14:35:00',1.74),('16100','2014-03-05','14:40:00',1.45),('16100','2014-03-05','14:45:00',1.35),('16100','2014-03-05','14:50:00',1.48),('16100','2014-03-05','14:55:00',1.41),('16100','2014-03-05','15:00:00',1.58),('16100','2014-03-05','15:05:00',1.71),('16100','2014-03-05','15:10:00',3.17),('16100','2014-03-05','15:15:00',5.24),('16100','2014-03-05','15:20:00',1.6),('16100','2014-03-05','15:25:00',1.27),('16100','2014-03-05','15:30:00',1.14),('16100','2014-03-05','15:35:00',1.17),('16100','2014-03-05','15:40:00',1.21),('16100','2014-03-05','15:45:00',1.04),('16100','2014-03-05','17:05:00',1.04),('16100','2014-03-05','17:10:00',1.4),('16100','2014-03-05','17:15:00',1.21),('16100','2014-03-04','07:40:00',1.21),('16100','2014-03-04','07:45:00',1.37),('16100','2014-03-04','07:50:00',1.83),('16100','2014-03-04','07:55:00',2.07),('16100','2014-03-04','08:00:00',2.28),('16100','2014-03-04','08:05:00',2.46),('16100','2014-03-04','08:10:00',2.59),('16100','2014-03-04','08:15:00',2.76),('16100','2014-03-04','08:20:00',3.01),('16100','2014-03-04','08:25:00',1.85),('16100','2014-03-04','08:30:00',3.14),('16100','2014-03-04','08:35:00',3.43),('16100','2014-03-04','08:40:00',4.16),('16100','2014-03-04','08:45:00',4.15),('16100','2014-03-04','08:50:00',4.17),('16100','2014-03-04','08:55:00',4.22),('16100','2014-03-04','09:00:00',3.04),('16100','2014-03-04','09:05:00',4.33),('16100','2014-03-04','09:10:00',4.51),('16100','2014-03-04','09:15:00',4.59),('16100','2014-03-04','09:20:00',4.74),('16100','2014-03-04','09:25:00',4.84),('16100','2014-03-04','09:30:00',4.92),('16100','2014-03-04','09:35:00',5.04),('16100','2014-03-04','09:40:00',5.22),('16100','2014-03-04','09:45:00',5.41),('16100','2014-03-04','09:50:00',5.43),('16100','2014-03-04','09:55:00',5.55),('16100','2014-03-04','10:00:00',5.64),('16100','2014-03-04','10:05:00',5.72),('16100','2014-03-04','10:10:00',5.81),('16100','2014-03-04','10:15:00',5.91),('16100','2014-03-04','10:20:00',6),('16100','2014-03-04','10:25:00',6.13),('16100','2014-03-04','10:30:00',6.24),('16100','2014-03-04','10:35:00',6.37),('16100','2014-03-04','10:40:00',6.43),('16100','2014-03-04','10:45:00',6.48),('16100','2014-03-04','10:50:00',6.56),('16100','2014-03-04','10:55:00',5.73),('16100','2014-03-04','11:00:00',5.17),('16100','2014-03-04','11:05:00',6.65),('16100','2014-03-04','11:10:00',7.01),('16100','2014-03-04','11:15:00',7.08),('16100','2014-03-04','11:20:00',7.27),('16100','2014-03-04','11:25:00',7.41),('16100','2014-03-04','11:30:00',3.96),('16100','2014-03-04','11:35:00',2.95),('16100','2014-03-04','11:40:00',3.11),('16100','2014-03-04','11:45:00',5.41),('16100','2014-03-04','11:50:00',3.64),('16100','2014-03-04','11:55:00',7.11),('16100','2014-03-04','12:00:00',4.61),('16100','2014-03-04','12:05:00',4.6),('16100','2014-03-04','12:10:00',2.23),('16100','2014-03-04','12:15:00',2.55),('16100','2014-03-04','12:20:00',7.62),('16100','2014-03-04','12:25:00',6.91),('16100','2014-03-04','12:30:00',7.37),('16100','2014-03-04','12:35:00',4.86),('16100','2014-03-04','12:40:00',2.87),('16100','2014-03-04','12:45:00',2.44),('16100','2014-03-04','12:50:00',1.92),('16100','2014-03-04','12:55:00',1.95),('16100','2014-03-04','13:00:00',5.8),('16100','2014-03-04','13:05:00',5.83),('16100','2014-03-04','13:10:00',6.17),('16100','2014-03-04','13:15:00',4.87),('16100','2014-03-04','13:20:00',4.55),('16100','2014-03-04','13:25:00',7.64),('16100','2014-03-04','13:30:00',7.73),('16100','2014-03-04','13:35:00',6.23),('16100','2014-03-04','13:40:00',4.76),('16100','2014-03-04','13:45:00',3.19),('16100','2014-03-04','13:50:00',2.23),('16100','2014-03-04','13:55:00',2.48),('16100','2014-03-04','14:00:00',2.26),('16100','2014-03-04','14:05:00',3.57),('16100','2014-03-04','14:10:00',2.8),('16100','2014-03-04','14:15:00',2.51),('16100','2014-03-04','14:20:00',2.61),('16100','2014-03-04','14:25:00',2.85),('16100','2014-03-04','14:30:00',2.98),('16100','2014-03-04','14:35:00',4.57),('16100','2014-03-04','14:40:00',2.67),('16100','2014-03-04','14:45:00',5.85),('16100','2014-03-04','14:50:00',3.62),('16100','2014-03-04','14:55:00',4.32),('16100','2014-03-04','15:00:00',2.17),('16100','2014-03-04','15:05:00',1.32),('16100','2014-03-04','15:10:00',1.02),('16100','2014-03-04','15:15:00',1.01),('16100','2014-03-04','15:20:00',1.13),('16100','2014-03-04','15:25:00',1.38),('16100','2014-03-04','15:30:00',1.79),('16100','2014-03-04','15:35:00',1.78),('16100','2014-03-04','15:40:00',2.74),('16100','2014-03-04','15:45:00',2.64),('16100','2014-03-04','15:50:00',5.27),('16100','2014-03-04','15:55:00',3.48),('16100','2014-03-04','16:00:00',4.22),('16100','2014-03-04','16:05:00',2.24),('16100','2014-03-04','16:10:00',1.89),('16100','2014-03-03','09:00:00',1.11),('16100','2014-03-03','09:05:00',2.14),('16100','2014-03-03','09:10:00',3.3),('16100','2014-03-03','09:15:00',3.53),('16100','2014-03-03','09:20:00',1.77),('16100','2014-03-03','09:25:00',1.02),('16100','2014-03-03','09:30:00',1.34),('16100','2014-03-03','09:35:00',1.17),('16100','2014-03-03','09:50:00',1.43),('16100','2014-03-03','09:55:00',2.47),('16100','2014-03-03','10:00:00',3.26),('16100','2014-03-03','10:05:00',3.04),('16100','2014-03-03','10:10:00',1.53),('16100','2014-03-03','10:15:00',1.13),('16100','2014-03-03','10:20:00',1.6),('16100','2014-03-03','10:30:00',2.85),('16100','2014-03-03','10:35:00',3.52),('16100','2014-03-03','10:40:00',2.36),('16100','2014-03-03','10:45:00',2.95),('16100','2014-03-03','10:50:00',7.14),('16100','2014-03-03','10:55:00',7.57),('16100','2014-03-03','11:00:00',4.48),('16100','2014-03-03','11:05:00',4.06),('16100','2014-03-03','11:10:00',2.41),('16100','2014-03-03','11:25:00',2.2),('16100','2014-03-03','11:30:00',2.72),('16100','2014-03-03','11:35:00',2.15),('16100','2014-03-03','11:40:00',1.81),('16100','2014-03-03','11:45:00',1.78),('16100','2014-03-03','11:50:00',4.87),('16100','2014-03-03','11:55:00',7.49),('16100','2014-03-03','12:00:00',6.49),('16100','2014-03-03','12:05:00',5.22),('16100','2014-03-03','12:10:00',7.7),('16100','2014-03-03','12:15:00',7.57),('16100','2014-03-03','12:20:00',6.12),('16100','2014-03-03','12:25:00',7.55),('16100','2014-03-03','12:30:00',7.44),('16100','2014-03-03','12:35:00',7.43),('16100','2014-03-03','12:40:00',7.41),('16100','2014-03-03','12:45:00',7.44),('16100','2014-03-03','12:50:00',7.49),('16100','2014-03-03','12:55:00',7.41),('16100','2014-03-03','13:00:00',7.12),('16100','2014-03-03','13:05:00',5.71),('16100','2014-03-03','13:10:00',7.69),('16100','2014-03-03','13:15:00',6.76),('16100','2014-03-03','13:20:00',4.31),('16100','2014-03-03','13:25:00',2.82),('16100','2014-03-03','13:30:00',1.15),('16100','2014-03-03','13:40:00',1.51),('16100','2014-03-03','13:45:00',1.56),('16100','2014-03-03','13:50:00',3.1),('16100','2014-03-03','13:55:00',2.87),('16100','2014-03-03','14:00:00',3.26),('16100','2014-03-03','14:05:00',6.56),('16100','2014-03-03','14:10:00',6.62),('16100','2014-03-03','14:15:00',6.93),('16100','2014-03-03','14:20:00',6.86),('16100','2014-03-03','14:25:00',6.72),('16100','2014-03-03','14:30:00',6.31),('16100','2014-03-03','14:35:00',6.18),('16100','2014-03-03','14:40:00',6.02),('16100','2014-03-03','14:45:00',5.68),('16100','2014-03-03','14:50:00',5.81),('16100','2014-03-03','14:55:00',5.25),('16100','2014-03-03','15:00:00',5.56),('16100','2014-03-03','15:05:00',5.39),('16100','2014-03-03','15:10:00',5.23),('16100','2014-03-03','15:15:00',5.08),('16100','2014-03-03','15:20:00',4.69),('16100','2014-03-03','15:25:00',3.44),('16100','2014-03-03','15:30:00',5.18),('16100','2014-03-03','15:35:00',3.58),('16100','2014-03-03','15:40:00',3.42),('16100','2014-03-03','15:45:00',2.32),('16100','2014-03-03','15:50:00',1.59),('16100','2014-03-03','15:55:00',1.34),('16100','2014-03-03','16:00:00',1.58),('16100','2014-03-03','16:05:00',1.49),('16100','2014-03-03','16:10:00',1.02),('16100','2014-03-03','16:15:00',1.03),('16100','2014-03-03','16:20:00',1.23),('16100','2014-03-03','16:25:00',2.91),('16100','2014-03-03','16:30:00',2.55),('16100','2014-03-03','16:35:00',2.02),('16100','2014-03-03','16:40:00',2.08),('16100','2014-03-03','16:45:00',2.06),('16100','2014-03-03','16:50:00',1.84),('16100','2014-03-03','16:55:00',1.59),('16100','2014-03-03','17:00:00',1.24),('16100','2014-03-02','07:40:00',1.02),('16100','2014-03-02','07:45:00',1.15),('16100','2014-03-02','07:50:00',1.1),('16100','2014-03-02','07:55:00',1.42),('16100','2014-03-02','08:00:00',1.38),('16100','2014-03-02','08:05:00',2.03),('16100','2014-03-02','08:10:00',2.24),('16100','2014-03-02','08:15:00',2.47),('16100','2014-03-02','08:20:00',2.64),('16100','2014-03-02','08:25:00',2.79),('16100','2014-03-02','08:30:00',2.99),('16100','2014-03-02','08:35:00',3.14),('16100','2014-03-02','08:40:00',3.32),('16100','2014-03-02','08:45:00',3.43),('16100','2014-03-02','08:50:00',3.63),('16100','2014-03-02','08:55:00',3.4),('16100','2014-03-02','09:00:00',3.09),('16100','2014-03-02','09:05:00',3.01),('16100','2014-03-02','09:10:00',4.2),('16100','2014-03-02','09:15:00',4.32),('16100','2014-03-02','09:20:00',4.58),('16100','2014-03-02','09:25:00',4.59),('16100','2014-03-02','09:30:00',4.56),('16100','2014-03-02','09:35:00',4.22),('16100','2014-03-02','09:40:00',4.59),('16100','2014-03-02','09:45:00',4.81),('16100','2014-03-02','09:50:00',5.03),('16100','2014-03-02','09:55:00',5.21),('16100','2014-03-02','10:00:00',5.59),('16100','2014-03-02','10:05:00',5.72),('16100','2014-03-02','10:10:00',5.83),('16100','2014-03-02','10:15:00',5.91),('16100','2014-03-02','10:20:00',6),('16100','2014-03-02','10:25:00',6.05),('16100','2014-03-02','10:30:00',6.11),('16100','2014-03-02','10:35:00',6.26),('16100','2014-03-02','10:40:00',6.33),('16100','2014-03-02','10:45:00',6.38),('16100','2014-03-02','10:50:00',6.46),('16100','2014-03-02','10:55:00',6.52),('16100','2014-03-02','11:00:00',6.56),('16100','2014-03-02','11:05:00',6.56),('16100','2014-03-02','11:10:00',6.64),('16100','2014-03-02','11:15:00',6.69),('16100','2014-03-02','11:20:00',6.71),('16100','2014-03-02','11:25:00',6.85),('16100','2014-03-02','11:30:00',6.97),('16100','2014-03-02','11:35:00',7.05),('16100','2014-03-02','11:40:00',7.16),('16100','2014-03-02','11:45:00',7.23),('16100','2014-03-02','11:50:00',7.25),('16100','2014-03-02','11:55:00',7.32),('16100','2014-03-02','12:00:00',7.33),('16100','2014-03-02','12:05:00',7.34),('16100','2014-03-02','12:10:00',7.35),('16100','2014-03-02','12:15:00',7.33),('16100','2014-03-02','12:20:00',7.35),('16100','2014-03-02','12:25:00',7.35),('16100','2014-03-02','12:30:00',7.35),('16100','2014-03-02','12:35:00',7.38),('16100','2014-03-02','12:40:00',7.39),('16100','2014-03-02','12:45:00',7.31),('16100','2014-03-02','12:50:00',7.28),('16100','2014-03-02','12:55:00',7.27),('16100','2014-03-02','13:00:00',7.25),('16100','2014-03-02','13:05:00',7.23),('16100','2014-03-02','13:10:00',7.17),('16100','2014-03-02','13:15:00',7.14),('16100','2014-03-02','13:20:00',7.13),('16100','2014-03-02','13:25:00',7.04),('16100','2014-03-02','13:30:00',6.99),('16100','2014-03-02','13:35:00',6.97),('16100','2014-03-02','13:40:00',6.88),('16100','2014-03-02','13:45:00',6.95),('16100','2014-03-02','13:50:00',6.92),('16100','2014-03-02','13:55:00',6.75),('16100','2014-03-02','14:00:00',6.66),('16100','2014-03-02','14:05:00',6.58),('16100','2014-03-02','14:10:00',6.49),('16100','2014-03-02','14:15:00',6.46),('16100','2014-03-02','14:20:00',5.36),('16100','2014-03-02','14:25:00',4.77),('16100','2014-03-02','14:30:00',6.3),('16100','2014-03-02','14:35:00',6.1),('16100','2014-03-02','14:40:00',5.59),('16100','2014-03-02','14:45:00',5.79),('16100','2014-03-02','14:50:00',5.66),('16100','2014-03-02','14:55:00',5.49),('16100','2014-03-02','15:00:00',5.42),('16100','2014-03-02','15:05:00',5.32),('16100','2014-03-02','15:10:00',5.19),('16100','2014-03-02','15:15:00',5.1),('16100','2014-03-02','15:20:00',4.97),('16100','2014-03-02','15:25:00',3.74),('16100','2014-03-02','15:30:00',4.82),('16100','2014-03-02','15:35:00',4.63),('16100','2014-03-02','15:40:00',4.43),('16100','2014-03-02','15:45:00',4.09),('16100','2014-03-02','15:50:00',3.39),('16100','2014-03-02','15:55:00',3.83),('16100','2014-03-02','16:00:00',3.13),('16100','2014-03-02','16:05:00',3.39),('16100','2014-03-02','16:10:00',3.27),('16100','2014-03-02','16:15:00',3.06),('16100','2014-03-02','16:20:00',2.88),('16100','2014-03-02','16:25:00',2.7),('16100','2014-03-02','16:30:00',2.5),('16100','2014-03-02','16:35:00',2.32),('16100','2014-03-02','16:40:00',2.15),('16100','2014-03-02','16:45:00',1.97),('16100','2014-03-02','16:50:00',1.74),('16100','2014-03-02','16:55:00',1.46),('16100','2014-03-02','17:00:00',1.45),('16100','2014-03-02','17:05:00',1.22),('16100','2014-03-01','07:55:00',1.24),('16100','2014-03-01','08:00:00',1.13),('16100','2014-03-01','08:20:00',3.06),('16100','2014-03-01','08:25:00',2.25),('16100','2014-03-01','08:30:00',3.23),('16100','2014-03-01','08:35:00',3.26),('16100','2014-03-01','08:40:00',3.38),('16100','2014-03-01','08:45:00',3.58),('16100','2014-03-01','08:50:00',3.82),('16100','2014-03-01','08:55:00',3.96),('16100','2014-03-01','09:00:00',4.17),('16100','2014-03-01','09:05:00',4.39),('16100','2014-03-01','09:10:00',4.61),('16100','2014-03-01','09:15:00',4.74),('16100','2014-03-01','09:20:00',5.01),('16100','2014-03-01','09:25:00',5.12),('16100','2014-03-01','09:30:00',5.75),('16100','2014-03-01','09:35:00',5.79),('16100','2014-03-01','09:40:00',5.5),('16100','2014-03-01','09:45:00',2.12),('16100','2014-03-01','10:10:00',1.32),('16100','2014-03-01','10:15:00',2.64),('16100','2014-03-01','10:20:00',2.77),('16100','2014-03-01','10:25:00',3.61),('16100','2014-03-01','10:30:00',6),('16100','2014-03-01','10:35:00',7.89),('16100','2014-03-01','10:40:00',7.95),('16100','2014-03-01','10:45:00',7.73),('16100','2014-03-01','10:50:00',6.32),('16100','2014-03-01','10:55:00',2.34),('16100','2014-03-01','11:00:00',2.22),('16100','2014-03-01','11:05:00',2.54),('16100','2014-03-01','11:10:00',6.77),('16100','2014-03-01','11:15:00',6.46),('16100','2014-03-01','11:20:00',3.27),('16100','2014-03-01','11:25:00',2.83),('16100','2014-03-01','11:30:00',2.79),('16100','2014-03-01','11:35:00',3.18),('16100','2014-03-01','11:40:00',3.38),('16100','2014-03-01','11:45:00',5.14),('16100','2014-03-01','11:50:00',7.04),('16100','2014-03-01','11:55:00',2.86),('16100','2014-03-01','12:00:00',7.11),('16100','2014-03-01','12:05:00',8.2),('16100','2014-03-01','12:10:00',6.37),('16100','2014-03-01','12:15:00',3.82),('16100','2014-03-01','12:20:00',2.94),('16100','2014-03-01','12:25:00',2.23),('16100','2014-03-01','12:30:00',1.35),('16100','2014-03-01','12:35:00',1.02),('16100','2014-03-01','13:15:00',1.24),('16100','2014-03-01','13:20:00',1.19),('16100','2014-03-01','13:25:00',1.44),('16100','2014-03-01','13:30:00',1.56),('16100','2014-03-01','13:35:00',1.24),('16100','2014-03-01','13:40:00',1.42),('16100','2014-03-01','13:45:00',1.58),('16100','2014-03-01','13:50:00',1.51),('16100','2014-03-01','13:55:00',1.46),('16100','2014-03-01','14:00:00',1.49),('16100','2014-03-01','14:05:00',1.5),('16100','2014-03-01','14:10:00',1.49),('16100','2014-03-01','14:15:00',1.51),('16100','2014-03-01','14:20:00',1.51),('16100','2014-03-01','14:25:00',1.49),('16100','2014-03-01','14:30:00',1.47),('16100','2014-03-01','14:35:00',1.44),('16100','2014-03-01','14:40:00',1.47),('16100','2014-03-01','14:45:00',1.57),('16100','2014-03-01','14:50:00',1.59),('16100','2014-03-01','14:55:00',1.76),('16100','2014-03-01','15:00:00',1.97),('16100','2014-03-01','15:05:00',2.04),('16100','2014-03-01','15:10:00',2.1),('16100','2014-03-01','15:15:00',2.1),('16100','2014-03-01','15:20:00',2.07),('16100','2014-03-01','15:25:00',2.13),('16100','2014-03-01','15:30:00',2.37),('16100','2014-03-01','15:35:00',2.4),('16100','2014-03-01','15:40:00',2.59),('16100','2014-03-01','15:45:00',2.63),('16100','2014-03-01','15:50:00',2.68),('16100','2014-03-01','15:55:00',2.54),('16100','2014-03-01','16:00:00',2.18),('16100','2014-03-01','16:05:00',1.86),('16100','2014-03-01','16:10:00',1.72),('16100','2014-03-01','16:15:00',1.53),('16100','2014-03-01','16:20:00',1.37),('16100','2014-03-01','16:25:00',1.04),('16100','2014-02-28','16:15:00',1.09),('16100','2014-02-27','07:45:00',1.14),('16100','2014-02-27','07:50:00',1.51),('16100','2014-02-27','07:55:00',1.99),('16100','2014-02-27','08:00:00',2.06),('16100','2014-02-27','08:10:00',1.05),('16100','2014-02-27','08:15:00',1.86),('16100','2014-02-27','08:20:00',2.15),('16100','2014-02-27','08:25:00',1.14),('16100','2014-02-27','08:30:00',1.75),('16100','2014-02-27','09:05:00',1.52),('16100','2014-02-27','09:10:00',1.51),('16100','2014-02-27','09:15:00',1.41),('16100','2014-02-27','09:20:00',3.51),('16100','2014-02-27','09:25:00',2.88),('16100','2014-02-27','09:30:00',4.54),('16100','2014-02-27','09:35:00',5.41),('16100','2014-02-27','09:40:00',5.48),('16100','2014-02-27','09:45:00',4.65),('16100','2014-02-27','09:50:00',4.53),('16100','2014-02-27','09:55:00',3.34),('16100','2014-02-27','10:00:00',2.08),('16100','2014-02-27','10:05:00',1.79),('16100','2014-02-27','10:10:00',1.99),('16100','2014-02-27','10:15:00',4.56),('16100','2014-02-27','10:20:00',6.46),('16100','2014-02-27','10:25:00',6.28),('16100','2014-02-27','10:30:00',4.9),('16100','2014-02-27','10:35:00',2.04),('16100','2014-02-27','10:40:00',1.98),('16100','2014-02-27','10:45:00',1.52),('16100','2014-02-27','10:50:00',1.47),('16100','2014-02-27','10:55:00',1.36),('16100','2014-02-27','11:00:00',1.46),('16100','2014-02-27','11:05:00',1.93),('16100','2014-02-27','11:10:00',2),('16100','2014-02-27','11:15:00',2.17),('16100','2014-02-27','11:20:00',2.45),('16100','2014-02-27','11:25:00',2.15),('16100','2014-02-27','11:30:00',2.01),('16100','2014-02-27','11:35:00',1.39),('16100','2014-02-27','11:50:00',1.39),('16100','2014-02-27','11:55:00',2.43),('16100','2014-02-27','12:00:00',2.22),('16100','2014-02-27','12:05:00',1.9),('16100','2014-02-27','12:20:00',1.44),('16100','2014-02-27','12:25:00',5.45),('16100','2014-02-27','12:30:00',7.9),('16100','2014-02-27','12:35:00',8.32),('16100','2014-02-27','12:40:00',4.34),('16100','2014-02-27','12:45:00',3.49),('16100','2014-02-27','12:50:00',4.03),('16100','2014-02-27','12:55:00',6.78),('16100','2014-02-27','13:00:00',4.04),('16100','2014-02-27','13:05:00',1.87),('16100','2014-02-27','13:10:00',1.58),('16100','2014-02-27','13:15:00',1.67),('16100','2014-02-27','13:20:00',1.36),('16100','2014-02-27','13:40:00',1.21),('16100','2014-02-27','13:45:00',1.47),('16100','2014-02-27','13:50:00',1.65),('16100','2014-02-27','13:55:00',1.76),('16100','2014-02-27','14:00:00',1.17),('16100','2014-02-27','14:05:00',1.44),('16100','2014-02-27','14:10:00',1.32),('16100','2014-02-27','14:15:00',2.01),('16100','2014-02-27','14:20:00',7.99),('16100','2014-02-27','14:25:00',2.59),('16100','2014-02-27','14:30:00',1.92),('16100','2014-02-27','14:35:00',1.37),('16100','2014-02-27','15:20:00',1.01),('16100','2014-02-27','15:25:00',1.83),('16100','2014-02-27','15:30:00',2.08),('16100','2014-02-27','15:35:00',5.56),('16100','2014-02-27','15:40:00',1.66),('16100','2014-02-27','16:30:00',1.28),('16100','2014-02-27','16:35:00',2.37),('16100','2014-02-27','16:40:00',1.94),('16100','2014-02-27','16:45:00',1.09),('16100','2014-02-26','10:20:00',1.02),('16100','2014-02-26','10:25:00',1.28),('16100','2014-02-26','10:30:00',1.55),('16100','2014-02-26','10:35:00',1.85),('16100','2014-02-26','10:40:00',2.19),('16100','2014-02-26','10:45:00',2.25),('16100','2014-02-26','10:50:00',2.08),('16100','2014-02-26','10:55:00',2.2),('16100','2014-02-26','11:00:00',2.57),('16100','2014-02-26','11:05:00',2.38),('16100','2014-02-26','11:10:00',2.36),('16100','2014-02-26','11:15:00',2.19),('16100','2014-02-26','11:20:00',2.18),('16100','2014-02-26','11:25:00',2.55),('16100','2014-02-26','11:30:00',2.63),('16100','2014-02-26','11:35:00',2.07),('16100','2014-02-26','11:40:00',1.87),('16100','2014-02-26','11:45:00',1.77),('16100','2014-02-26','11:50:00',1.82),('16100','2014-02-26','11:55:00',2.04),('16100','2014-02-26','12:00:00',1.97),('16100','2014-02-26','12:05:00',2.08),('16100','2014-02-26','12:10:00',2.14),('16100','2014-02-26','12:15:00',2.17),('16100','2014-02-26','12:20:00',2.14),('16100','2014-02-26','12:25:00',2.11),('16100','2014-02-26','12:30:00',2.07),('16100','2014-02-26','12:35:00',1.97),('16100','2014-02-26','12:40:00',1.96),('16100','2014-02-26','12:45:00',2),('16100','2014-02-26','12:50:00',1.89),('16100','2014-02-26','12:55:00',1.88),('16100','2014-02-26','13:00:00',1.86),('16100','2014-02-26','13:05:00',1.9),('16100','2014-02-26','13:10:00',1.95),('16100','2014-02-26','13:15:00',2.08),('16100','2014-02-26','13:20:00',2.22),('16100','2014-02-26','13:25:00',2.45),('16100','2014-02-26','13:30:00',2.67),('16100','2014-02-26','13:35:00',2.88),('16100','2014-02-26','13:40:00',3),('16100','2014-02-26','13:45:00',2.91),('16100','2014-02-26','13:50:00',3.27),('16100','2014-02-26','13:55:00',3.72),('16100','2014-02-26','14:00:00',3.03),('16100','2014-02-26','14:05:00',2.55),('16100','2014-02-26','14:10:00',2.2),('16100','2014-02-26','14:15:00',2.47),('16100','2014-02-26','14:20:00',2.27),('16100','2014-02-26','14:25:00',1.95),('16100','2014-02-26','14:30:00',1.59),('16100','2014-02-26','14:35:00',1.67),('16100','2014-02-26','14:40:00',1.79),('16100','2014-02-26','14:45:00',2.22),('16100','2014-02-26','14:50:00',2.35),('16100','2014-02-26','14:55:00',2.62),('16100','2014-02-26','15:00:00',2.66),('16100','2014-02-26','15:05:00',2.8),('16100','2014-02-26','15:10:00',3.54),('16100','2014-02-26','15:15:00',3.08),('16100','2014-02-26','15:20:00',3.03),('16100','2014-02-26','15:25:00',2.9),('16100','2014-02-26','15:30:00',2.08),('16100','2014-02-26','15:35:00',1.89),('16100','2014-02-26','15:40:00',1.26),('16100','2014-02-26','15:45:00',1.01),('16100','2014-02-26','15:55:00',1.11),('16100','2014-02-26','16:00:00',1.03),('16100','2014-02-26','16:40:00',1.26),('16100','2014-02-26','16:45:00',2.03),('16100','2014-02-26','16:50:00',1.75),('16100','2014-02-26','16:55:00',1.65),('16100','2014-02-26','17:00:00',1.24),('16100','2014-02-25','07:50:00',1.01),('16100','2014-02-25','07:55:00',1.29),('16100','2014-02-25','08:00:00',1.52),('16100','2014-02-25','08:05:00',1.75),('16100','2014-02-25','08:10:00',1.95),('16100','2014-02-25','08:15:00',2.15),('16100','2014-02-25','08:20:00',2.26),('16100','2014-02-25','08:25:00',2.57),('16100','2014-02-25','08:30:00',2.74),('16100','2014-02-25','08:35:00',2.97),('16100','2014-02-25','08:40:00',3.22),('16100','2014-02-25','08:45:00',2.29),('16100','2014-02-25','08:50:00',3.56),('16100','2014-02-25','08:55:00',3.53),('16100','2014-02-25','09:00:00',3.66),('16100','2014-02-25','09:05:00',3.78),('16100','2014-02-25','09:10:00',3.7),('16100','2014-02-25','09:15:00',3.97),('16100','2014-02-25','09:20:00',3.53),('16100','2014-02-25','09:25:00',3.54),('16100','2014-02-25','09:30:00',3.49),('16100','2014-02-25','09:35:00',3.95),('16100','2014-02-25','09:40:00',4.11),('16100','2014-02-25','09:45:00',3.72),('16100','2014-02-25','09:50:00',2.49),('16100','2014-02-25','09:55:00',2.66),('16100','2014-02-25','10:00:00',5.05),('16100','2014-02-25','10:05:00',2.27),('16100','2014-02-25','10:10:00',1.59),('16100','2014-02-25','10:15:00',1.62),('16100','2014-02-25','10:20:00',1.2),('16100','2014-02-25','10:30:00',1.14),('16100','2014-02-25','10:35:00',1.24),('16100','2014-02-25','10:55:00',1.31),('16100','2014-02-25','11:00:00',1.35),('16100','2014-02-25','11:05:00',1.37),('16100','2014-02-25','11:10:00',1.33),('16100','2014-02-25','11:15:00',1.18),('16100','2014-02-25','11:50:00',1.05),('16100','2014-02-25','11:55:00',1.06),('16100','2014-02-25','12:00:00',1.2),('16100','2014-02-25','12:05:00',1.07),('16100','2014-02-25','12:10:00',1.07),('16100','2014-02-25','12:15:00',1.5),('16100','2014-02-25','12:20:00',1.61),('16100','2014-02-25','12:25:00',2.39),('16100','2014-02-25','12:30:00',2.35),('16100','2014-02-25','12:35:00',2.21),('16100','2014-02-25','12:40:00',5.37),('16100','2014-02-25','12:45:00',7.02),('16100','2014-02-25','12:50:00',7.11),('16100','2014-02-25','12:55:00',6.79),('16100','2014-02-25','13:00:00',6.41),('16100','2014-02-25','13:05:00',5.51),('16100','2014-02-25','13:10:00',5.11),('16100','2014-02-25','13:15:00',3.03),('16100','2014-02-25','13:20:00',3.39),('16100','2014-02-25','13:25:00',2.15),('16100','2014-02-25','13:30:00',3.84),('16100','2014-02-25','13:35:00',5.72),('16100','2014-02-25','13:40:00',5.38),('16100','2014-02-25','13:45:00',7.29),('16100','2014-02-25','13:50:00',7.08),('16100','2014-02-25','13:55:00',7.24),('16100','2014-02-25','14:00:00',5.97),('16100','2014-02-25','14:05:00',3.31),('16100','2014-02-25','14:10:00',1.5),('16100','2014-02-25','14:15:00',1.61),('16100','2014-02-25','14:20:00',4.95),('16100','2014-02-25','14:25:00',3.58),('16100','2014-02-25','14:30:00',5.68),('16100','2014-02-25','14:35:00',5.9),('16100','2014-02-25','14:40:00',4.76),('16100','2014-02-25','14:45:00',3.1),('16100','2014-02-25','14:50:00',4.89),('16100','2014-02-25','14:55:00',1.42),('16100','2014-02-25','15:00:00',3.57),('16100','2014-02-25','15:05:00',5.92),('16100','2014-02-25','15:10:00',5.04),('16100','2014-02-25','15:15:00',3.92),('16100','2014-02-25','15:20:00',2.78),('16100','2014-02-25','15:25:00',2.43),('16100','2014-02-25','15:30:00',3.58),('16100','2014-02-25','15:35:00',2.82),('16100','2014-02-25','15:40:00',2.89),('16100','2014-02-25','15:45:00',3.2),('16100','2014-02-25','15:50:00',3.62),('16100','2014-02-25','15:55:00',3.3),('16100','2014-02-25','16:00:00',3.17),('16100','2014-02-25','16:05:00',2.52),('16100','2014-02-25','16:10:00',2.31),('16100','2014-02-25','16:15:00',2.22),('16100','2014-02-25','16:20:00',1.67),('16100','2014-02-25','16:25:00',1.01),('16100','2014-04-28','09:40:00',1.25),('16100','2014-04-28','09:45:00',1.51),('16100','2014-04-28','09:50:00',1.72),('16100','2014-04-28','09:55:00',3.01),('16100','2014-04-28','10:00:00',5.7),('16100','2014-04-28','10:05:00',6.04),('16100','2014-04-28','10:10:00',6.76),('16100','2014-04-28','10:15:00',5.43),('16100','2014-04-28','10:20:00',6.67),('16100','2014-04-28','10:25:00',6.69),('16100','2014-04-28','10:30:00',6.69),('16100','2014-04-28','10:35:00',6.66),('16100','2014-04-28','10:40:00',6.72),('16100','2014-04-28','10:45:00',6.22),('16100','2014-04-28','10:50:00',6.62),('16100','2014-04-28','10:55:00',6.92),('16100','2014-04-28','11:00:00',6.86),('16100','2014-04-28','11:05:00',7.07),('16100','2014-04-28','11:10:00',7.14),('16100','2014-04-28','11:15:00',7.53),('16100','2014-04-28','11:20:00',5.37),('16100','2014-04-28','11:25:00',7.45),('16100','2014-04-28','11:30:00',7.7),('16100','2014-04-28','11:35:00',4.7),('16100','2014-04-28','11:40:00',2.72),('16100','2014-04-28','11:45:00',2.66),('16100','2014-04-28','11:50:00',3.43),('16100','2014-04-28','11:55:00',2.12),('16100','2014-04-28','12:00:00',1.29),('16100','2014-04-28','12:05:00',1.17),('16100','2014-04-28','12:10:00',3.86),('16100','2014-04-28','12:15:00',6.89),('16100','2014-04-28','12:20:00',7.99),('16100','2014-04-28','12:25:00',2.07),('16100','2014-04-28','12:30:00',2.22),('16100','2014-04-28','12:35:00',4.21),('16100','2014-04-28','12:40:00',4.94),('16100','2014-04-28','12:45:00',4.27),('16100','2014-04-28','12:50:00',6.67),('16100','2014-04-28','12:55:00',8.94),('16100','2014-04-28','13:00:00',4.66),('16100','2014-04-28','13:05:00',4.07),('16100','2014-04-28','13:10:00',3.11),('16100','2014-04-28','13:15:00',4.85),('16100','2014-04-28','13:20:00',2.2),('16100','2014-04-28','13:25:00',2.69),('16100','2014-04-28','13:30:00',6.59),('16100','2014-04-28','13:35:00',6.19),('16100','2014-04-28','13:40:00',5.52),('16100','2014-04-28','13:45:00',5.18),('16100','2014-04-28','13:50:00',2.06),('16100','2014-04-28','13:55:00',1.86),('16100','2014-04-28','14:00:00',1.81),('16100','2014-04-28','14:05:00',1.59),('16100','2014-04-28','14:10:00',1.42),('16100','2014-04-28','14:15:00',1.29),('16100','2014-04-28','14:40:00',1.16),('16100','2014-04-28','14:45:00',1.55),('16100','2014-04-28','14:50:00',1.54),('16100','2014-04-28','14:55:00',2.1),('16100','2014-04-28','15:00:00',3.07),('16100','2014-04-28','15:05:00',2.44),('16100','2014-04-28','15:10:00',1.97),('16100','2014-04-28','15:15:00',1.29),('16100','2014-04-28','15:55:00',1.33),('16100','2014-04-28','16:00:00',1.8),('16100','2014-04-28','16:05:00',1.26),('16100','2014-04-28','16:50:00',1.14),('16100','2014-04-28','16:55:00',1.33),('16100','2014-04-28','17:00:00',1.36),('16100','2014-04-28','17:05:00',1.52),('16100','2014-04-28','17:10:00',1.57),('16100','2014-04-28','17:15:00',3.56),('16100','2014-04-28','17:20:00',2.54),('16100','2014-04-28','17:25:00',1.73),('16100','2014-04-28','17:30:00',1.89),('16100','2014-04-28','17:35:00',1.34),('16100','2014-02-24','07:50:00',1.1),('16100','2014-02-24','07:55:00',1.28),('16100','2014-02-24','08:00:00',1.46),('16100','2014-02-24','08:05:00',1.63),('16100','2014-02-24','08:10:00',1.84),('16100','2014-02-24','08:15:00',2.04),('16100','2014-02-24','08:20:00',2.19),('16100','2014-02-24','08:25:00',2.41),('16100','2014-02-24','08:30:00',2.59),('16100','2014-02-24','08:35:00',2.75),('16100','2014-02-24','08:40:00',2.91),('16100','2014-02-24','08:45:00',3.09),('16100','2014-02-24','08:50:00',3.26),('16100','2014-02-24','08:55:00',3.44),('16100','2014-02-24','09:00:00',3.6),('16100','2014-02-24','09:05:00',3.76),('16100','2014-02-24','09:10:00',3.87),('16100','2014-02-24','09:15:00',4.04),('16100','2014-02-24','09:20:00',4.23),('16100','2014-02-24','09:25:00',4.35),('16100','2014-02-24','09:30:00',4.47),('16100','2014-02-24','09:35:00',4.61),('16100','2014-02-24','09:40:00',4.74),('16100','2014-02-24','09:45:00',4.82),('16100','2014-02-24','09:50:00',4.98),('16100','2014-02-24','09:55:00',5.08),('16100','2014-02-24','10:00:00',5.24),('16100','2014-02-24','10:05:00',5.37),('16100','2014-02-24','10:10:00',5.46),('16100','2014-02-24','10:15:00',5.53),('16100','2014-02-24','10:20:00',5.63),('16100','2014-02-24','10:25:00',5.71),('16100','2014-02-24','10:30:00',5.83),('16100','2014-02-24','10:35:00',5.91),('16100','2014-02-24','10:40:00',5.99),('16100','2014-02-24','10:45:00',6.04),('16100','2014-02-24','10:50:00',6.11),('16100','2014-02-24','10:55:00',6.19),('16100','2014-02-24','11:00:00',6.27),('16100','2014-02-24','11:05:00',6.31),('16100','2014-02-24','11:10:00',6.37),('16100','2014-02-24','11:15:00',6.43),('16100','2014-02-24','11:20:00',6.52),('16100','2014-02-24','11:25:00',6.59),('16100','2014-02-24','11:30:00',6.63),('16100','2014-02-24','11:35:00',6.69),('16100','2014-02-24','11:40:00',6.67),('16100','2014-02-24','11:45:00',6.68),('16100','2014-02-24','11:50:00',6.75),('16100','2014-02-24','11:55:00',6.75),('16100','2014-02-24','12:00:00',6.7),('16100','2014-02-24','12:05:00',6.72),('16100','2014-02-24','12:10:00',6.74),('16100','2014-02-24','12:15:00',6.71),('16100','2014-02-24','12:20:00',6.84),('16100','2014-02-24','12:25:00',6.89),('16100','2014-02-24','12:30:00',6.93),('16100','2014-02-24','12:35:00',6.93),('16100','2014-02-24','12:40:00',6.88),('16100','2014-02-24','12:45:00',6.9),('16100','2014-02-24','12:50:00',6.8),('16100','2014-02-24','12:55:00',6.79),('16100','2014-02-24','13:00:00',6.65),('16100','2014-02-24','13:05:00',6.64),('16100','2014-02-24','13:10:00',6.75),('16100','2014-02-24','13:15:00',6.72),('16100','2014-02-24','13:20:00',6.63),('16100','2014-02-24','13:25:00',4.91),('16100','2014-02-24','13:30:00',2.91),('16100','2014-02-24','13:35:00',2.74),('16100','2014-02-24','13:40:00',2.39),('16100','2014-02-24','13:45:00',2.4),('16100','2014-02-24','13:50:00',3.63),('16100','2014-02-24','13:55:00',6.49),('16100','2014-02-24','14:00:00',6.22),('16100','2014-02-24','14:05:00',5.42),('16100','2014-02-24','14:10:00',3.14),('16100','2014-02-24','14:15:00',6.15),('16100','2014-02-24','14:20:00',5.49),('16100','2014-02-24','14:25:00',5.33),('16100','2014-02-24','14:30:00',4.62),('16100','2014-02-24','14:35:00',5.02),('16100','2014-02-24','14:40:00',5.11),('16100','2014-02-24','14:45:00',5.16),('16100','2014-02-24','14:50:00',4.72),('16100','2014-02-24','14:55:00',5.06),('16100','2014-02-24','15:00:00',4.87),('16100','2014-02-24','15:05:00',4.67),('16100','2014-02-24','15:10:00',4.55),('16100','2014-02-24','15:15:00',4.3),('16100','2014-02-24','15:20:00',4.2),('16100','2014-02-24','15:25:00',3.96),('16100','2014-02-24','15:30:00',3.73),('16100','2014-02-24','15:35:00',3.51),('16100','2014-02-24','15:40:00',2.1),('16100','2014-02-24','15:45:00',1.51),('16100','2014-02-24','15:50:00',2.31),('16100','2014-02-24','15:55:00',2.41),('16100','2014-02-24','16:00:00',2.21),('16100','2014-02-24','16:05:00',2.13),('16100','2014-02-24','16:10:00',2),('16100','2014-02-24','16:15:00',1.75),('16100','2014-02-24','16:20:00',1.85),('16100','2014-02-24','16:25:00',1.46),('16100','2014-02-23','07:50:00',1.1),('16100','2014-02-23','07:55:00',1.42),('16100','2014-02-23','08:00:00',1.8),('16100','2014-02-23','08:05:00',2.17),('16100','2014-02-23','08:10:00',2.42),('16100','2014-02-23','08:15:00',2.65),('16100','2014-02-23','08:20:00',2.17),('16100','2014-02-23','08:25:00',1.45),('16100','2014-02-23','08:30:00',1.74),('16100','2014-02-23','08:35:00',1.74),('16100','2014-02-23','08:40:00',1.18),('16100','2014-02-23','08:45:00',2.63),('16100','2014-02-23','08:50:00',3.69),('16100','2014-02-23','08:55:00',3.68),('16100','2014-02-23','09:00:00',3.75),('16100','2014-02-23','09:05:00',3.83),('16100','2014-02-23','09:10:00',3.96),('16100','2014-02-23','09:15:00',4.13),('16100','2014-02-23','09:20:00',4.27),('16100','2014-02-23','09:25:00',4.38),('16100','2014-02-23','09:30:00',4.53),('16100','2014-02-23','09:35:00',4.67),('16100','2014-02-23','09:40:00',4.78),('16100','2014-02-23','09:45:00',4.94),('16100','2014-02-23','09:50:00',5.08),('16100','2014-02-23','09:55:00',5.21),('16100','2014-02-23','10:00:00',5.35),('16100','2014-02-23','10:05:00',5.48),('16100','2014-02-23','10:10:00',5.6),('16100','2014-02-23','10:15:00',5.7),('16100','2014-02-23','10:20:00',5.75),('16100','2014-02-23','10:25:00',5.86),('16100','2014-02-23','10:30:00',5.99),('16100','2014-02-23','10:35:00',6.09),('16100','2014-02-23','10:40:00',6.14),('16100','2014-02-23','10:45:00',6.17),('16100','2014-02-23','10:50:00',6.27),('16100','2014-02-23','10:55:00',6.29),('16100','2014-02-23','11:00:00',6.39),('16100','2014-02-23','11:05:00',6.52),('16100','2014-02-23','11:10:00',6.64),('16100','2014-02-23','11:15:00',6.63),('16100','2014-02-23','11:20:00',6.9),('16100','2014-02-23','11:25:00',7.12),('16100','2014-02-23','11:30:00',4.78),('16100','2014-02-23','11:35:00',5.38),('16100','2014-02-23','11:40:00',2.46),('16100','2014-02-23','11:45:00',3.55),('16100','2014-02-23','11:50:00',7.41),('16100','2014-02-23','11:55:00',7.06),('16100','2014-02-23','12:00:00',6.96),('16100','2014-02-23','12:05:00',6.12),('16100','2014-02-23','12:10:00',5.52),('16100','2014-02-23','12:15:00',7.05),('16100','2014-02-23','12:20:00',6.93),('16100','2014-02-23','12:25:00',6.84),('16100','2014-02-23','12:30:00',6.89),('16100','2014-02-23','12:35:00',6.96),('16100','2014-02-23','12:40:00',6.91),('16100','2014-02-23','12:45:00',6.87),('16100','2014-02-23','12:50:00',7.14),('16100','2014-02-23','12:55:00',3.67),('16100','2014-02-23','13:00:00',3.11),('16100','2014-02-23','13:05:00',3.23),('16100','2014-02-23','13:10:00',1.8),('16100','2014-02-23','13:15:00',1.43),('16100','2014-02-23','13:20:00',1.29),('16100','2014-02-23','13:25:00',1.22),('16100','2014-02-23','13:30:00',1.13),('16100','2014-02-23','13:35:00',1.16),('16100','2014-02-23','13:40:00',1.35),('16100','2014-02-23','13:45:00',1.56),('16100','2014-02-23','13:50:00',1.68),('16100','2014-02-23','13:55:00',1.84),('16100','2014-02-23','14:00:00',2.09),('16100','2014-02-23','14:05:00',2.14),('16100','2014-02-23','14:10:00',2.36),('16100','2014-02-23','14:15:00',3.63),('16100','2014-02-23','14:20:00',2.19),('16100','2014-02-23','14:25:00',1.68),('16100','2014-02-23','14:30:00',1.46),('16100','2014-02-23','14:35:00',1.36),('16100','2014-02-23','14:40:00',1.34),('16100','2014-02-23','14:45:00',1.4),('16100','2014-02-23','14:50:00',1.58),('16100','2014-02-23','14:55:00',1.75),('16100','2014-02-23','15:00:00',1.81),('16100','2014-02-23','15:05:00',1.95),('16100','2014-02-23','15:10:00',2.15),('16100','2014-02-23','15:15:00',4.9),('16100','2014-02-23','15:20:00',5.26),('16100','2014-02-23','15:25:00',4.79),('16100','2014-02-23','15:30:00',4.48),('16100','2014-02-23','15:35:00',4.25),('16100','2014-02-23','15:40:00',4.04),('16100','2014-02-23','15:45:00',3.81),('16100','2014-02-23','15:50:00',3.67),('16100','2014-02-23','15:55:00',3.56),('16100','2014-02-23','16:00:00',3.58),('16100','2014-02-23','16:05:00',3.45),('16100','2014-02-23','16:10:00',2.92),('16100','2014-02-23','16:15:00',1.58),('16100','2014-02-23','16:25:00',1.14),('16100','2014-02-23','16:30:00',2.07),('16100','2014-02-23','16:35:00',2.02),('16100','2014-02-23','16:40:00',1.86),('16100','2014-02-23','16:45:00',1.68),('16100','2014-02-23','16:50:00',1.48),('16100','2014-02-23','16:55:00',1.34),('16100','2014-02-23','17:00:00',1.16),('16100','2014-02-22','07:55:00',1.14),('16100','2014-02-22','08:00:00',1.33),('16100','2014-02-22','08:05:00',1.52),('16100','2014-02-22','08:10:00',1.71),('16100','2014-02-22','08:15:00',1.89),('16100','2014-02-22','08:20:00',2.08),('16100','2014-02-22','08:25:00',2.26),('16100','2014-02-22','08:30:00',2.43),('16100','2014-02-22','08:35:00',2.57),('16100','2014-02-22','08:40:00',2.75),('16100','2014-02-22','08:45:00',2.94),('16100','2014-02-22','08:50:00',3.1),('16100','2014-02-22','08:55:00',3.3),('16100','2014-02-22','09:00:00',3.47),('16100','2014-02-22','09:05:00',3.63),('16100','2014-02-22','09:10:00',3.82),('16100','2014-02-22','09:15:00',3.97),('16100','2014-02-22','09:20:00',3.87),('16100','2014-02-22','09:25:00',3.99),('16100','2014-02-22','09:30:00',4.32),('16100','2014-02-22','09:35:00',4.43),('16100','2014-02-22','09:40:00',4.53),('16100','2014-02-22','09:45:00',4.66),('16100','2014-02-22','09:50:00',4.78),('16100','2014-02-22','09:55:00',4.89),('16100','2014-02-22','10:00:00',5.02),('16100','2014-02-22','10:05:00',5.16),('16100','2014-02-22','10:10:00',5.28),('16100','2014-02-22','10:15:00',5.37),('16100','2014-02-22','10:20:00',5.47),('16100','2014-02-22','10:25:00',5.58),('16100','2014-02-22','10:30:00',5.7),('16100','2014-02-22','10:35:00',5.8),('16100','2014-02-22','10:40:00',5.91),('16100','2014-02-22','10:45:00',5.96),('16100','2014-02-22','10:50:00',6.06),('16100','2014-02-22','10:55:00',6.13),('16100','2014-02-22','11:00:00',6.15),('16100','2014-02-22','11:05:00',6.18),('16100','2014-02-22','11:10:00',6.4),('16100','2014-02-22','11:15:00',6.41),('16100','2014-02-22','11:20:00',6.37),('16100','2014-02-22','11:25:00',6.53),('16100','2014-02-22','11:30:00',6.6),('16100','2014-02-22','11:35:00',6.65),('16100','2014-02-22','11:40:00',6.73),('16100','2014-02-22','11:45:00',6.81),('16100','2014-02-22','11:50:00',6.93),('16100','2014-02-22','11:55:00',6.89),('16100','2014-02-22','12:00:00',6.92),('16100','2014-02-22','12:05:00',7.01),('16100','2014-02-22','12:10:00',6.65),('16100','2014-02-22','12:15:00',6.56),('16100','2014-02-22','12:20:00',3.38),('16100','2014-02-22','12:25:00',6.33),('16100','2014-02-22','12:30:00',6.83),('16100','2014-02-22','12:35:00',4.24),('16100','2014-02-22','12:40:00',4.46),('16100','2014-02-22','12:45:00',6.88),('16100','2014-02-22','12:50:00',7.43),('16100','2014-02-22','12:55:00',6.92),('16100','2014-02-22','13:00:00',6.8),('16100','2014-02-22','13:05:00',6.71),('16100','2014-02-22','13:10:00',6.64),('16100','2014-02-22','13:15:00',6.68),('16100','2014-02-22','13:20:00',5.37),('16100','2014-02-22','13:25:00',2.69),('16100','2014-02-22','13:30:00',4.38),('16100','2014-02-22','13:35:00',5.58),('16100','2014-02-22','13:40:00',6.48),('16100','2014-02-22','13:45:00',4.7),('16100','2014-02-22','13:50:00',4.92),('16100','2014-02-22','13:55:00',5.74),('16100','2014-02-22','14:00:00',6.14),('16100','2014-02-22','14:05:00',4.96),('16100','2014-02-22','14:10:00',4.17),('16100','2014-02-22','14:15:00',5.12),('16100','2014-02-22','14:20:00',4.64),('16100','2014-02-22','14:25:00',5.18),('16100','2014-02-22','14:30:00',6.84),('16100','2014-02-22','14:35:00',5.99),('16100','2014-02-22','14:40:00',6.19),('16100','2014-02-22','14:45:00',3.67),('16100','2014-02-22','14:50:00',4.33),('16100','2014-02-22','14:55:00',1.9),('16100','2014-02-22','15:00:00',2.32),('16100','2014-02-22','15:05:00',1.7),('16100','2014-02-22','15:10:00',1.77),('16100','2014-02-22','15:15:00',4.56),('16100','2014-02-22','15:20:00',5.31),('16100','2014-02-22','15:25:00',3.65),('16100','2014-02-22','15:30:00',5.05),('16100','2014-02-22','15:35:00',4.88),('16100','2014-02-22','15:40:00',3.85),('16100','2014-02-22','15:45:00',3.73),('16100','2014-02-22','15:50:00',2.35),('16100','2014-02-21','09:10:00',1.01),('16100','2014-02-21','09:15:00',1.53),('16100','2014-02-21','09:20:00',1.52),('16100','2014-02-21','09:25:00',1.11),('16100','2014-02-21','09:30:00',1.43),('16100','2014-02-21','09:35:00',1.89),('16100','2014-02-21','09:40:00',3.68),('16100','2014-02-21','09:45:00',4.09),('16100','2014-02-21','09:50:00',1.71),('16100','2014-02-21','09:55:00',3.9),('16100','2014-02-21','10:00:00',3.01),('16100','2014-02-21','10:05:00',3.45),('16100','2014-02-21','10:10:00',1.68),('16100','2014-02-21','10:15:00',1.53),('16100','2014-02-21','10:20:00',1.93),('16100','2014-02-21','10:25:00',4.45),('16100','2014-02-21','10:30:00',3.2),('16100','2014-02-21','10:35:00',2.8),('16100','2014-02-21','10:40:00',2.62),('16100','2014-02-21','10:45:00',3.84),('16100','2014-02-21','10:50:00',1.11),('16100','2014-02-21','11:35:00',1.32),('16100','2014-02-21','11:40:00',1.14),('16100','2014-02-21','11:45:00',1.02),('16100','2014-02-21','11:50:00',1.16),('16100','2014-02-21','11:55:00',1.39),('16100','2014-02-21','12:00:00',1.58),('16100','2014-02-21','12:05:00',1.76),('16100','2014-02-21','12:10:00',2.44),('16100','2014-02-21','12:15:00',3.04),('16100','2014-02-21','12:20:00',2.61),('16100','2014-02-21','12:25:00',2.11),('16100','2014-02-21','12:30:00',2.74),('16100','2014-02-21','12:35:00',2.56),('16100','2014-02-21','12:40:00',7.23),('16100','2014-02-21','12:45:00',6.85),('16100','2014-02-21','12:50:00',7.93),('16100','2014-02-21','12:55:00',2.94),('16100','2014-02-21','13:00:00',5.14),('16100','2014-02-21','13:05:00',6.92),('16100','2014-02-21','13:10:00',1.59),('16100','2014-02-21','13:15:00',1.61),('16100','2014-02-21','13:20:00',1.78),('16100','2014-02-21','13:25:00',2.26),('16100','2014-02-21','13:30:00',4.24),('16100','2014-02-21','13:35:00',5.97),('16100','2014-02-21','13:40:00',4),('16100','2014-02-21','13:45:00',3.86),('16100','2014-02-21','13:50:00',4.17),('16100','2014-02-21','13:55:00',4.77),('16100','2014-02-21','14:00:00',2.26),('16100','2014-02-21','14:05:00',4.05),('16100','2014-02-21','14:10:00',1.53),('16100','2014-02-21','14:15:00',5.02),('16100','2014-02-21','14:20:00',3.34),('16100','2014-02-21','14:25:00',1.42),('16100','2014-02-21','14:30:00',5.06),('16100','2014-02-21','14:35:00',5.54),('16100','2014-02-21','14:40:00',3.32),('16100','2014-02-21','14:45:00',1.59),('16100','2014-02-21','14:50:00',1.52),('16100','2014-02-21','14:55:00',1.99),('16100','2014-02-21','15:00:00',2.69),('16100','2014-02-21','15:05:00',2.96),('16100','2014-02-21','15:10:00',4.37),('16100','2014-02-21','15:15:00',3.93),('16100','2014-02-21','15:20:00',3.23),('16100','2014-02-21','15:25:00',2.5),('16100','2014-02-21','15:30:00',1.56),('16100','2014-02-21','15:35:00',2.99),('16100','2014-02-21','15:40:00',2.36),('16100','2014-02-21','15:45:00',4.49),('16100','2014-02-21','15:50:00',3.96),('16100','2014-02-21','15:55:00',3.47),('16100','2014-02-21','16:00:00',3.24),('16100','2014-02-21','16:05:00',2.87),('16100','2014-02-21','16:10:00',2.15),('16100','2014-02-21','16:15:00',2.46),('16100','2014-02-21','16:20:00',2.54),('16100','2014-02-21','16:25:00',2.27),('16100','2014-02-21','16:30:00',1.98),('16100','2014-02-21','16:35:00',2),('16100','2014-02-21','16:40:00',1.66),('16100','2014-02-21','16:45:00',1.35),('16100','2014-02-21','16:50:00',1.05),('16100','2014-02-21','16:55:00',1.23),('16100','2014-02-21','17:00:00',1.05),('16100','2014-02-20','08:45:00',1.04),('16100','2014-02-20','08:50:00',1.1),('16100','2014-02-20','08:55:00',1.19),('16100','2014-02-20','09:00:00',1.28),('16100','2014-02-20','09:05:00',1.33),('16100','2014-02-20','09:10:00',1.39),('16100','2014-02-20','09:15:00',1.58),('16100','2014-02-20','09:20:00',1.71),('16100','2014-02-20','09:25:00',1.66),('16100','2014-02-20','09:30:00',1.72),('16100','2014-02-20','09:35:00',1.69),('16100','2014-02-20','09:40:00',1.86),('16100','2014-02-20','09:45:00',1.94),('16100','2014-02-20','09:50:00',2.12),('16100','2014-02-20','09:55:00',2.12),('16100','2014-02-20','10:00:00',2.19),('16100','2014-02-20','10:05:00',2.16),('16100','2014-02-20','10:10:00',2.38),('16100','2014-02-20','10:15:00',3.05),('16100','2014-02-20','10:20:00',3.33),('16100','2014-02-20','10:25:00',3.73),('16100','2014-02-20','10:30:00',3.72),('16100','2014-02-20','10:35:00',2.51),('16100','2014-02-20','10:40:00',2.45),('16100','2014-02-20','10:45:00',2.66),('16100','2014-02-20','10:50:00',3.59),('16100','2014-02-20','10:55:00',5.47),('16100','2014-02-20','11:00:00',5.92),('16100','2014-02-20','11:05:00',4.45),('16100','2014-02-20','11:10:00',3.14),('16100','2014-02-20','11:15:00',2.79),('16100','2014-02-20','11:20:00',4.92),('16100','2014-02-20','11:25:00',4.61),('16100','2014-02-20','11:30:00',7.09),('16100','2014-02-20','11:35:00',7.52),('16100','2014-02-20','11:40:00',3.45),('16100','2014-02-20','11:45:00',4.88),('16100','2014-02-20','11:50:00',3.51),('16100','2014-02-20','11:55:00',5.97),('16100','2014-02-20','12:00:00',5.62),('16100','2014-02-20','12:05:00',2.66),('16100','2014-02-20','12:10:00',2.84),('16100','2014-02-20','12:15:00',2.19),('16100','2014-02-20','12:20:00',1.55),('16100','2014-02-20','12:25:00',1.22),('16100','2014-02-20','12:30:00',1.23),('16100','2014-02-20','12:35:00',1.06),('16100','2014-02-20','12:55:00',1.04),('16100','2014-02-20','13:05:00',1.04),('16100','2014-02-20','13:10:00',1.04),('16100','2014-02-20','13:15:00',1.12),('16100','2014-02-20','13:25:00',1.05),('16100','2014-02-20','13:30:00',1.23),('16100','2014-02-20','13:35:00',1.44),('16100','2014-02-20','13:40:00',2.26),('16100','2014-02-20','13:45:00',2.79),('16100','2014-02-20','13:50:00',1.92),('16100','2014-02-20','13:55:00',1.7),('16100','2014-02-20','14:00:00',1.49),('16100','2014-02-20','14:05:00',1.64),('16100','2014-02-20','14:10:00',1.55),('16100','2014-02-20','14:15:00',1.59),('16100','2014-02-20','14:20:00',1.58),('16100','2014-02-20','14:25:00',1.66),('16100','2014-02-20','14:30:00',2.11),('16100','2014-02-20','14:35:00',2.38),('16100','2014-02-20','14:40:00',2.26),('16100','2014-02-20','14:45:00',2.18),('16100','2014-02-20','14:50:00',1.73),('16100','2014-02-20','14:55:00',1.64),('16100','2014-02-20','15:00:00',1.8),('16100','2014-02-20','15:05:00',1.54),('16100','2014-02-20','15:10:00',1.58),('16100','2014-02-20','15:15:00',2.49),('16100','2014-02-20','15:20:00',4.36),('16100','2014-02-20','15:25:00',4.07),('16100','2014-02-20','15:30:00',3.84),('16100','2014-02-20','15:35:00',3.63),('16100','2014-02-20','15:40:00',3.33),('16100','2014-02-20','15:45:00',3.28),('16100','2014-02-20','15:50:00',3.08),('16100','2014-02-20','15:55:00',3.02),('16100','2014-02-20','16:00:00',2.16),('16100','2014-02-20','16:05:00',2.66),('16100','2014-02-20','16:10:00',2.45),('16100','2014-02-20','16:15:00',2.31),('16100','2014-02-20','16:20:00',2.15),('16100','2014-02-20','16:25:00',1.97),('16100','2014-02-20','16:30:00',1.81),('16100','2014-02-20','16:35:00',1.64),('16100','2014-02-20','16:40:00',1.46),('16100','2014-02-20','16:45:00',1.3),('16100','2014-02-20','16:50:00',1.14),('16100','2014-02-19','09:35:00',1.15),('16100','2014-02-19','09:40:00',1.25),('16100','2014-02-19','09:45:00',1.18),('16100','2014-02-19','09:50:00',1.18),('16100','2014-02-19','09:55:00',1.02),('16100','2014-02-19','10:00:00',1.01),('16100','2014-02-19','10:15:00',1.34),('16100','2014-02-19','10:20:00',1.43),('16100','2014-02-19','10:25:00',1.55),('16100','2014-02-19','10:30:00',1.44),('16100','2014-02-19','10:35:00',1.54),('16100','2014-02-19','10:40:00',1.62),('16100','2014-02-19','10:45:00',1.6),('16100','2014-02-19','10:50:00',1.2),('16100','2014-02-19','10:55:00',1.23),('16100','2014-02-19','11:00:00',1.06),('16100','2014-02-19','11:20:00',1.74),('16100','2014-02-19','11:25:00',2.1),('16100','2014-02-19','11:30:00',2.15),('16100','2014-02-19','11:35:00',2.08),('16100','2014-02-19','11:40:00',2.01),('16100','2014-02-19','11:45:00',1.74),('16100','2014-02-19','11:50:00',1.39),('16100','2014-02-19','11:55:00',1.65),('16100','2014-02-19','12:00:00',1.66),('16100','2014-02-19','12:05:00',1.41),('16100','2014-02-19','12:10:00',1.42),('16100','2014-02-19','12:15:00',1.39),('16100','2014-02-19','12:20:00',1.49),('16100','2014-02-19','13:10:00',1.02),('16100','2014-02-19','13:15:00',1.84),('16100','2014-02-19','13:20:00',1.34),('16100','2014-02-19','13:25:00',1.38),('16100','2014-02-19','13:30:00',1.81),('16100','2014-02-19','13:35:00',1.46),('16100','2014-02-19','13:40:00',1.57),('16100','2014-02-19','13:45:00',1.71),('16100','2014-02-19','13:50:00',1.77),('16100','2014-02-19','13:55:00',1.69),('16100','2014-02-19','14:00:00',1.85),('16100','2014-02-19','14:05:00',1.81),('16100','2014-02-19','14:10:00',1.57),('16100','2014-02-19','14:15:00',1.25),('16100','2014-02-19','14:20:00',1.14),('16100','2014-02-18','08:45:00',1.09),('16100','2014-02-18','08:50:00',1.04),('16100','2014-02-18','09:00:00',1.01),('16100','2014-02-18','09:10:00',1.16),('16100','2014-02-18','09:15:00',1.24),('16100','2014-02-18','09:20:00',1.3),('16100','2014-02-18','09:25:00',1.58),('16100','2014-02-18','09:30:00',1.5),('16100','2014-02-18','09:35:00',1.68),('16100','2014-02-18','09:40:00',1.96),('16100','2014-02-18','09:45:00',2.37),('16100','2014-02-18','09:50:00',2.32),('16100','2014-02-18','09:55:00',2.02),('16100','2014-02-18','10:00:00',2.12),('16100','2014-02-18','10:05:00',2.15),('16100','2014-02-18','10:10:00',2.27),('16100','2014-02-18','10:15:00',2.66),('16100','2014-02-18','10:20:00',2.41),('16100','2014-02-18','10:25:00',2.29),('16100','2014-02-18','10:30:00',2.02),('16100','2014-02-18','10:35:00',2.11),('16100','2014-02-18','10:40:00',2.55),('16100','2014-02-18','10:45:00',2.46),('16100','2014-02-18','10:50:00',2.72),('16100','2014-02-18','10:55:00',2.77),('16100','2014-02-18','11:00:00',1.83),('16100','2014-02-18','11:05:00',1.4),('16100','2014-02-18','11:10:00',1.27),('16100','2014-02-18','11:15:00',1.62),('16100','2014-02-18','11:20:00',2.01),('16100','2014-02-18','11:25:00',1.94),('16100','2014-02-18','11:30:00',1.52),('16100','2014-02-18','11:35:00',1.85),('16100','2014-02-18','11:40:00',2.31),('16100','2014-02-18','11:45:00',1.92),('16100','2014-02-18','11:50:00',2.13),('16100','2014-02-18','11:55:00',2.21),('16100','2014-02-18','12:00:00',2.4),('16100','2014-02-18','12:05:00',2.72),('16100','2014-02-18','12:10:00',2.61),('16100','2014-02-18','12:15:00',2.19),('16100','2014-02-18','12:20:00',1.44),('16100','2014-02-18','12:25:00',1.37),('16100','2014-02-18','12:30:00',1.88),('16100','2014-02-18','12:35:00',2.15),('16100','2014-02-18','12:40:00',1.88),('16100','2014-02-18','12:45:00',2.07),('16100','2014-02-18','12:50:00',2),('16100','2014-02-18','12:55:00',1.62),('16100','2014-02-18','13:00:00',2.01),('16100','2014-02-18','13:05:00',2.22),('16100','2014-02-18','13:10:00',1.55),('16100','2014-02-18','13:15:00',1.67),('16100','2014-02-18','13:20:00',1.85),('16100','2014-02-18','13:25:00',2.31),('16100','2014-02-18','13:30:00',2.47),('16100','2014-02-18','13:35:00',2.84),('16100','2014-02-18','13:40:00',3.31),('16100','2014-02-18','13:45:00',3.83),('16100','2014-02-18','13:50:00',3.72),('16100','2014-02-18','13:55:00',3.77),('16100','2014-02-18','14:00:00',3.28),('16100','2014-02-18','14:05:00',2.19),('16100','2014-02-18','14:10:00',1.97),('16100','2014-02-18','14:15:00',2.03),('16100','2014-02-18','14:20:00',2.46),('16100','2014-02-18','14:25:00',2.04),('16100','2014-02-18','14:30:00',2.77),('16100','2014-02-18','14:35:00',2.24),('16100','2014-02-18','14:40:00',2.04),('16100','2014-02-18','14:45:00',1.61),('16100','2014-02-18','14:50:00',2.16),('16100','2014-02-18','14:55:00',1.69),('16100','2014-02-18','15:00:00',1.41),('16100','2014-02-18','15:05:00',1.4),('16100','2014-02-18','15:10:00',1.32),('16100','2014-02-18','15:15:00',1.69),('16100','2014-02-18','15:20:00',1.28),('16100','2014-02-18','15:25:00',1.5),('16100','2014-02-18','15:30:00',1.39),('16100','2014-02-18','15:35:00',1.41),('16100','2014-02-18','15:40:00',1.52),('16100','2014-02-18','15:45:00',1.63),('16100','2014-02-18','15:50:00',1.74),('16100','2014-02-18','15:55:00',1.38),('16100','2014-02-18','16:00:00',1.34),('16100','2014-02-18','16:05:00',1.28),('16100','2014-02-18','16:10:00',1.14),('16100','2014-02-18','16:15:00',1.02),('16100','2014-02-17','07:55:00',1),('16100','2014-02-17','08:00:00',1.19),('16100','2014-02-17','08:05:00',1.37),('16100','2014-02-17','08:10:00',1.54),('16100','2014-02-17','08:15:00',1.73),('16100','2014-02-17','08:20:00',1.91),('16100','2014-02-17','08:25:00',2.06),('16100','2014-02-17','08:30:00',2.19),('16100','2014-02-17','08:35:00',2.38),('16100','2014-02-17','08:40:00',2.54),('16100','2014-02-17','08:45:00',2.71),('16100','2014-02-17','08:50:00',2.89),('16100','2014-02-17','08:55:00',3.07),('16100','2014-02-17','09:00:00',3.22),('16100','2014-02-17','09:05:00',3.4),('16100','2014-02-17','09:10:00',3.56),('16100','2014-02-17','09:15:00',3.7),('16100','2014-02-17','09:20:00',3.84),('16100','2014-02-17','09:25:00',3.91),('16100','2014-02-17','09:30:00',4.07),('16100','2014-02-17','09:35:00',4.21),('16100','2014-02-17','09:40:00',4.31),('16100','2014-02-17','09:45:00',4.47),('16100','2014-02-17','09:50:00',4.58),('16100','2014-02-17','09:55:00',4.69),('16100','2014-02-17','10:00:00',4.82),('16100','2014-02-17','10:05:00',4.95),('16100','2014-02-17','10:10:00',5.05),('16100','2014-02-17','10:15:00',5.13),('16100','2014-02-17','10:20:00',5.24),('16100','2014-02-17','10:25:00',5.33),('16100','2014-02-17','10:30:00',5.46),('16100','2014-02-17','10:35:00',5.52),('16100','2014-02-17','10:40:00',5.61),('16100','2014-02-17','10:45:00',5.7),('16100','2014-02-17','10:50:00',5.78),('16100','2014-02-17','10:55:00',5.9),('16100','2014-02-17','11:00:00',6.03),('16100','2014-02-17','11:05:00',5.92),('16100','2014-02-17','11:10:00',5.62),('16100','2014-02-17','11:15:00',4.9),('16100','2014-02-17','11:20:00',5.78),('16100','2014-02-17','11:25:00',6.27),('16100','2014-02-17','11:30:00',5.29),('16100','2014-02-17','11:35:00',3.66),('16100','2014-02-17','11:40:00',3.34),('16100','2014-02-17','11:45:00',3.2),('16100','2014-02-17','11:50:00',2.45),('16100','2014-02-17','11:55:00',2.42),('16100','2014-02-17','12:00:00',2.51),('16100','2014-02-17','12:05:00',2.42),('16100','2014-02-17','12:10:00',2.49),('16100','2014-02-17','12:15:00',2.76),('16100','2014-02-17','12:20:00',2.98),('16100','2014-02-17','12:25:00',3.38),('16100','2014-02-17','12:30:00',2.97),('16100','2014-02-17','12:35:00',2.64),('16100','2014-02-17','12:40:00',2.55),('16100','2014-02-17','12:45:00',2.45),('16100','2014-02-17','12:50:00',2.27),('16100','2014-02-17','12:55:00',2.42),('16100','2014-02-17','13:00:00',2.27),('16100','2014-02-17','13:05:00',2.09),('16100','2014-02-17','13:10:00',2.12),('16100','2014-02-17','13:15:00',2.72),('16100','2014-02-17','13:20:00',3.85),('16100','2014-02-17','13:25:00',5.57),('16100','2014-02-17','13:30:00',3.73),('16100','2014-02-17','13:35:00',3.09),('16100','2014-02-17','13:40:00',3.67),('16100','2014-02-17','13:45:00',3.81),('16100','2014-02-17','13:50:00',3),('16100','2014-02-17','13:55:00',2.71),('16100','2014-02-17','14:00:00',3.04),('16100','2014-02-17','14:05:00',3.5),('16100','2014-02-17','14:10:00',3.2),('16100','2014-02-17','14:15:00',2.35),('16100','2014-02-17','14:20:00',1.97),('16100','2014-02-17','14:25:00',1.8),('16100','2014-02-17','14:30:00',2.1),('16100','2014-02-17','14:35:00',2.15),('16100','2014-02-17','14:40:00',1.87),('16100','2014-02-17','14:45:00',1.61),('16100','2014-02-17','14:50:00',1.56),('16100','2014-02-17','14:55:00',1.48),('16100','2014-02-17','15:00:00',1.3),('16100','2014-02-17','15:05:00',1.2),('16100','2014-02-17','15:10:00',1.18),('16100','2014-02-17','15:15:00',1.13),('16100','2014-02-17','15:20:00',1.05),('16100','2014-02-17','15:25:00',1.2),('16100','2014-02-17','15:30:00',1.42),('16100','2014-02-17','15:35:00',1.7),('16100','2014-02-17','15:40:00',2.04),('16100','2014-02-17','15:45:00',1.81),('16100','2014-02-17','15:50:00',1.6),('16100','2014-02-17','15:55:00',1.43),('16100','2014-02-17','16:00:00',1.71),('16100','2014-02-17','16:05:00',1.9),('16100','2014-02-17','16:10:00',1.46),('16100','2014-02-17','16:15:00',1.23),('16100','2014-02-17','16:35:00',1.06),('16100','2014-02-16','08:05:00',1.14),('16100','2014-02-16','08:10:00',1.29),('16100','2014-02-16','08:15:00',1.46),('16100','2014-02-16','08:20:00',1.65),('16100','2014-02-16','08:25:00',1.79),('16100','2014-02-16','08:30:00',1.94),('16100','2014-02-16','08:35:00',2.14),('16100','2014-02-16','08:40:00',2.28),('16100','2014-02-16','08:45:00',2.38),('16100','2014-02-16','08:50:00',2.53),('16100','2014-02-16','08:55:00',2.66),('16100','2014-02-16','09:00:00',2.87),('16100','2014-02-16','09:05:00',3.05),('16100','2014-02-16','09:10:00',3.2),('16100','2014-02-16','09:15:00',3.36),('16100','2014-02-16','09:20:00',3.52),('16100','2014-02-16','09:25:00',3.65),('16100','2014-02-16','09:30:00',3.8),('16100','2014-02-16','09:35:00',3.93),('16100','2014-02-16','09:40:00',4.04),('16100','2014-02-16','09:45:00',4.11),('16100','2014-02-16','09:50:00',4.2),('16100','2014-02-16','09:55:00',4.31),('16100','2014-02-16','10:00:00',4.4),('16100','2014-02-16','10:05:00',4.49),('16100','2014-02-16','10:10:00',4.59),('16100','2014-02-16','10:15:00',4.65),('16100','2014-02-16','10:20:00',4.75),('16100','2014-02-16','10:25:00',4.87),('16100','2014-02-16','10:30:00',4.97),('16100','2014-02-16','10:35:00',5.02),('16100','2014-02-16','10:40:00',5.08),('16100','2014-02-16','10:45:00',5.15),('16100','2014-02-16','10:50:00',5.16),('16100','2014-02-16','10:55:00',5.22),('16100','2014-02-16','11:00:00',5.3),('16100','2014-02-16','11:05:00',5.35),('16100','2014-02-16','11:10:00',5.4),('16100','2014-02-16','11:15:00',5.43),('16100','2014-02-16','11:20:00',5.49),('16100','2014-02-16','11:25:00',5.48),('16100','2014-02-16','11:30:00',5.47),('16100','2014-02-16','11:35:00',5.5),('16100','2014-02-16','11:40:00',5.54),('16100','2014-02-16','11:45:00',5.61),('16100','2014-02-16','11:50:00',5.77),('16100','2014-02-16','11:55:00',5.86),('16100','2014-02-16','12:00:00',5.91),('16100','2014-02-16','12:05:00',5.92),('16100','2014-02-16','12:10:00',5.93),('16100','2014-02-16','12:15:00',5.99),('16100','2014-02-16','12:20:00',6.02),('16100','2014-02-16','12:25:00',6.08),('16100','2014-02-16','12:30:00',6.08),('16100','2014-02-16','12:35:00',6.03),('16100','2014-02-16','12:40:00',5.99),('16100','2014-02-16','12:45:00',5.98),('16100','2014-02-16','12:50:00',6),('16100','2014-02-16','12:55:00',5.98),('16100','2014-02-16','13:00:00',5.95),('16100','2014-02-16','13:05:00',5.9),('16100','2014-02-16','13:10:00',5.9),('16100','2014-02-16','13:15:00',5.84),('16100','2014-02-16','13:20:00',5.78),('16100','2014-02-16','13:25:00',5.73),('16100','2014-02-16','13:30:00',5.72),('16100','2014-02-16','13:35:00',5.63),('16100','2014-02-16','13:40:00',5.55),('16100','2014-02-16','13:45:00',5.47),('16100','2014-02-16','13:50:00',5.4),('16100','2014-02-16','13:55:00',5.38),('16100','2014-02-16','14:00:00',5.22),('16100','2014-02-16','14:05:00',5.15),('16100','2014-02-16','14:10:00',4.97),('16100','2014-02-16','14:15:00',5.05),('16100','2014-02-16','14:20:00',4.97),('16100','2014-02-16','14:25:00',4.79),('16100','2014-02-16','14:30:00',4.62),('16100','2014-02-16','14:35:00',4.47),('16100','2014-02-16','14:40:00',4.43),('16100','2014-02-16','14:45:00',4.39),('16100','2014-02-16','14:50:00',4.32),('16100','2014-02-16','14:55:00',4.2),('16100','2014-02-16','15:00:00',4.07),('16100','2014-02-16','15:05:00',3.79),('16100','2014-02-16','15:10:00',3.47),('16100','2014-02-16','15:15:00',3.65),('16100','2014-02-16','15:20:00',3.57),('16100','2014-02-16','15:25:00',3.43),('16100','2014-02-16','15:30:00',3.39),('16100','2014-02-16','15:35:00',3.24),('16100','2014-02-16','15:40:00',2.97),('16100','2014-02-16','15:45:00',2.97),('16100','2014-02-16','15:50:00',2.8),('16100','2014-02-16','15:55:00',2.68),('16100','2014-02-16','16:00:00',2.42),('16100','2014-02-16','16:05:00',2.28),('16100','2014-02-16','16:10:00',2.12),('16100','2014-02-16','16:15:00',1.91),('16100','2014-02-16','16:20:00',1.78),('16100','2014-02-16','16:25:00',1.66),('16100','2014-02-16','16:30:00',1.43),('16100','2014-02-16','16:35:00',1.27),('16100','2014-02-16','16:40:00',1.1),('16100','2014-02-15','08:00:00',1.12),('16100','2014-02-15','08:05:00',1.29),('16100','2014-02-15','08:10:00',1.46),('16100','2014-02-15','08:15:00',1.66),('16100','2014-02-15','08:20:00',1.86),('16100','2014-02-15','08:25:00',2.06),('16100','2014-02-15','08:30:00',2.25),('16100','2014-02-15','08:35:00',2.35),('16100','2014-02-15','08:40:00',2.58),('16100','2014-02-15','08:45:00',2.77),('16100','2014-02-15','08:50:00',2.89),('16100','2014-02-15','08:55:00',3.19),('16100','2014-02-15','09:00:00',3.39),('16100','2014-02-15','09:05:00',3.3),('16100','2014-02-15','09:10:00',3.17),('16100','2014-02-15','09:15:00',3.61),('16100','2014-02-15','09:20:00',3.66),('16100','2014-02-15','09:25:00',3.91),('16100','2014-02-15','09:30:00',3.08),('16100','2014-02-15','09:35:00',4.13),('16100','2014-02-15','09:40:00',4.41),('16100','2014-02-15','09:45:00',4.34),('16100','2014-02-15','09:50:00',4.49),('16100','2014-02-15','09:55:00',4.57),('16100','2014-02-15','10:00:00',4.61),('16100','2014-02-15','10:05:00',5.04),('16100','2014-02-15','10:10:00',5.11),('16100','2014-02-15','10:15:00',5.14),('16100','2014-02-15','10:20:00',4.91),('16100','2014-02-15','10:25:00',5.4),('16100','2014-02-15','10:30:00',5.53),('16100','2014-02-15','10:35:00',5.59),('16100','2014-02-15','10:40:00',5.65),('16100','2014-02-15','10:45:00',5.57),('16100','2014-02-15','10:50:00',4.63),('16100','2014-02-15','10:55:00',5.66),('16100','2014-02-15','11:00:00',5.81),('16100','2014-02-15','11:05:00',5.71),('16100','2014-02-15','11:10:00',5.65),('16100','2014-02-15','11:15:00',5.58),('16100','2014-02-15','11:20:00',4.94),('16100','2014-02-15','11:25:00',5.64),('16100','2014-02-15','11:30:00',5.99),('16100','2014-02-15','11:35:00',6.02),('16100','2014-02-15','11:40:00',5.38),('16100','2014-02-15','11:45:00',6.09),('16100','2014-02-15','11:50:00',5.97),('16100','2014-02-15','11:55:00',6.26),('16100','2014-02-15','12:00:00',6.25),('16100','2014-02-15','12:05:00',6.25),('16100','2014-02-15','12:10:00',6.27),('16100','2014-02-15','12:15:00',6.26),('16100','2014-02-15','12:20:00',6.26),('16100','2014-02-15','12:25:00',6.22),('16100','2014-02-15','12:30:00',6.22),('16100','2014-02-15','12:35:00',6.19),('16100','2014-02-15','12:40:00',6.16),('16100','2014-02-15','12:45:00',6.14),('16100','2014-02-15','12:50:00',6.09),('16100','2014-02-15','12:55:00',6.11),('16100','2014-02-15','13:00:00',6.12),('16100','2014-02-15','13:05:00',5.96),('16100','2014-02-15','13:10:00',5.92),('16100','2014-02-15','13:15:00',6.09),('16100','2014-02-15','13:20:00',6.02),('16100','2014-02-15','13:25:00',5.92),('16100','2014-02-15','13:30:00',5.97),('16100','2014-02-15','13:35:00',5.88),('16100','2014-02-15','13:40:00',5.8),('16100','2014-02-15','13:45:00',5.54),('16100','2014-02-15','13:50:00',5.55),('16100','2014-02-15','13:55:00',5.47),('16100','2014-02-15','14:00:00',5.53),('16100','2014-02-15','14:05:00',5.48),('16100','2014-02-15','14:10:00',5.42),('16100','2014-02-15','14:15:00',5.37),('16100','2014-02-15','14:20:00',5.06),('16100','2014-02-15','14:25:00',5.17),('16100','2014-02-15','14:30:00',5.14),('16100','2014-02-15','14:35:00',4.85),('16100','2014-02-15','14:40:00',4.89),('16100','2014-02-15','14:45:00',4.86),('16100','2014-02-15','14:50:00',4.65),('16100','2014-02-15','14:55:00',3.69),('16100','2014-02-15','15:00:00',3.98),('16100','2014-02-15','15:05:00',4.48),('16100','2014-02-15','15:10:00',4.32),('16100','2014-02-15','15:15:00',4.17),('16100','2014-02-15','15:20:00',4.06),('16100','2014-02-15','15:25:00',3.92),('16100','2014-02-15','15:30:00',3.68),('16100','2014-02-15','15:35:00',3.34),('16100','2014-02-15','15:40:00',2.96),('16100','2014-02-15','15:45:00',1.42),('16100','2014-02-15','15:50:00',2.24),('16100','2014-02-15','15:55:00',1.03),('16100','2014-02-15','16:05:00',1.06),('16100','2014-02-15','16:10:00',2.06),('16100','2014-02-15','16:15:00',2.24),('16100','2014-02-15','16:20:00',2.73),('16100','2014-02-15','16:25:00',2.5),('16100','2014-02-15','16:30:00',2.18),('16100','2014-02-15','16:35:00',1.41),('16100','2014-04-27','08:05:00',1.15),('16100','2014-04-27','08:10:00',1.71),('16100','2014-04-27','08:15:00',2.22),('16100','2014-04-27','08:20:00',2.68),('16100','2014-04-27','08:25:00',1.65),('16100','2014-04-27','08:30:00',1.58),('16100','2014-04-27','08:35:00',1.78),('16100','2014-04-27','08:40:00',1.9),('16100','2014-04-27','08:45:00',2),('16100','2014-04-27','08:50:00',1.65),('16100','2014-04-27','08:55:00',1.5),('16100','2014-04-27','09:00:00',2.28),('16100','2014-04-27','09:05:00',4.12),('16100','2014-04-27','09:10:00',4.24),('16100','2014-04-27','09:15:00',3.82),('16100','2014-04-27','09:20:00',4.58),('16100','2014-04-27','09:25:00',5.12),('16100','2014-04-27','09:30:00',4.45),('16100','2014-04-27','09:35:00',4.76),('16100','2014-04-27','09:40:00',3.75),('16100','2014-04-27','09:45:00',2.19),('16100','2014-04-27','09:50:00',2.32),('16100','2014-04-27','09:55:00',2.73),('16100','2014-04-27','10:00:00',3.52),('16100','2014-04-27','10:05:00',2.4),('16100','2014-04-27','10:10:00',1.87),('16100','2014-04-27','10:15:00',1.73),('16100','2014-04-27','10:20:00',1.79),('16100','2014-04-27','10:25:00',2.36),('16100','2014-04-27','10:30:00',2.19),('16100','2014-04-27','10:35:00',1.83),('16100','2014-04-27','10:40:00',1.62),('16100','2014-04-27','10:45:00',1.74),('16100','2014-04-27','10:50:00',2.13),('16100','2014-04-27','10:55:00',3.03),('16100','2014-04-27','11:00:00',2.97),('16100','2014-04-27','11:05:00',3.09),('16100','2014-04-27','11:10:00',3.09),('16100','2014-04-27','11:15:00',2.69),('16100','2014-04-27','11:20:00',2.44),('16100','2014-04-27','11:25:00',1.91),('16100','2014-04-27','11:30:00',1.98),('16100','2014-04-27','11:35:00',2.86),('16100','2014-04-27','11:40:00',2.72),('16100','2014-04-27','11:45:00',2.41),('16100','2014-04-27','11:50:00',2.4),('16100','2014-04-27','11:55:00',2.72),('16100','2014-04-27','12:00:00',3.18),('16100','2014-04-27','12:05:00',3.2),('16100','2014-04-27','12:10:00',2.75),('16100','2014-04-27','12:15:00',2.33),('16100','2014-04-27','12:20:00',2.57),('16100','2014-04-27','12:25:00',3.22),('16100','2014-04-27','12:30:00',3.81),('16100','2014-04-27','12:35:00',4.88),('16100','2014-04-27','12:40:00',3.93),('16100','2014-04-27','12:45:00',3.67),('16100','2014-04-27','12:50:00',3.59),('16100','2014-04-27','12:55:00',3.77),('16100','2014-04-27','13:00:00',4.34),('16100','2014-04-27','13:05:00',5.06),('16100','2014-04-27','13:10:00',5.03),('16100','2014-04-27','13:15:00',5.45),('16100','2014-04-27','13:20:00',6.09),('16100','2014-04-27','13:25:00',5.25),('16100','2014-04-27','13:30:00',4.39),('16100','2014-04-27','13:35:00',5.97),('16100','2014-04-27','13:40:00',4.8),('16100','2014-04-27','13:45:00',4.9),('16100','2014-04-27','13:50:00',3.97),('16100','2014-04-27','13:55:00',4.17),('16100','2014-04-27','14:00:00',5.21),('16100','2014-04-27','14:05:00',6.72),('16100','2014-04-27','14:10:00',3.94),('16100','2014-04-27','14:15:00',6.11),('16100','2014-04-27','14:20:00',8.31),('16100','2014-04-27','14:25:00',7),('16100','2014-04-27','14:30:00',3.72),('16100','2014-04-27','14:35:00',4.65),('16100','2014-04-27','14:40:00',3.06),('16100','2014-04-27','14:45:00',6.2),('16100','2014-04-27','14:50:00',2.52),('16100','2014-04-27','14:55:00',3.32),('16100','2014-04-27','15:00:00',7.47),('16100','2014-04-27','15:05:00',3.54),('16100','2014-04-27','15:10:00',7.41),('16100','2014-04-27','15:15:00',3.53),('16100','2014-04-27','15:20:00',2.3),('16100','2014-04-27','15:25:00',4),('16100','2014-04-27','15:30:00',3.67),('16100','2014-04-27','15:35:00',2.67),('16100','2014-04-27','15:40:00',6.74),('16100','2014-04-27','15:45:00',5.75),('16100','2014-04-27','15:50:00',1.7),('16100','2014-04-27','15:55:00',4.62),('16100','2014-04-27','16:00:00',2.56),('16100','2014-04-27','16:05:00',1.49),('16100','2014-04-27','16:10:00',1.69),('16100','2014-04-27','16:15:00',2.68),('16100','2014-04-27','16:20:00',3.04),('16100','2014-04-27','16:25:00',2.24),('16100','2014-04-27','16:30:00',5.19),('16100','2014-04-27','16:35:00',2.8),('16100','2014-04-27','16:40:00',1.29),('16100','2014-04-27','16:45:00',1.22),('16100','2014-04-27','16:50:00',1.84),('16100','2014-04-27','16:55:00',3.57),('16100','2014-04-27','17:00:00',3.24),('16100','2014-04-27','17:05:00',3.53),('16100','2014-04-27','17:10:00',1.36),('16100','2014-04-27','17:25:00',1.39),('16100','2014-04-27','17:30:00',1.09),('16100','2014-04-27','17:50:00',1.5),('16100','2014-04-27','17:55:00',1.12),('16100','2014-04-27','18:00:00',1.3),('16100','2014-04-27','18:10:00',1.23),('16100','2014-04-27','18:15:00',1.03),('16100','2014-04-27','18:20:00',1.01),('16100','2014-04-27','18:35:00',1.1),('16100','2014-02-14','08:00:00',1.03),('16100','2014-02-14','08:05:00',1.18),('16100','2014-02-14','08:10:00',1.35),('16100','2014-02-14','08:15:00',1.53),('16100','2014-02-14','08:20:00',1.71),('16100','2014-02-14','08:25:00',1.87),('16100','2014-02-14','08:30:00',2.06),('16100','2014-02-14','08:35:00',2.24),('16100','2014-02-14','08:40:00',2.42),('16100','2014-02-14','08:45:00',2.57),('16100','2014-02-14','08:50:00',2.72),('16100','2014-02-14','08:55:00',2.91),('16100','2014-02-14','09:00:00',3.05),('16100','2014-02-14','09:05:00',3.18),('16100','2014-02-14','09:10:00',3.33),('16100','2014-02-14','09:15:00',3.49),('16100','2014-02-14','09:20:00',3.62),('16100','2014-02-14','09:25:00',3.74),('16100','2014-02-14','09:30:00',3.86),('16100','2014-02-14','09:35:00',4.04),('16100','2014-02-14','09:40:00',4.18),('16100','2014-02-14','09:45:00',4.34),('16100','2014-02-14','09:50:00',4.45),('16100','2014-02-14','09:55:00',4.54),('16100','2014-02-14','10:00:00',4.63),('16100','2014-02-14','10:05:00',4.69),('16100','2014-02-14','10:10:00',4.83),('16100','2014-02-14','10:15:00',4.88),('16100','2014-02-14','10:20:00',5.06),('16100','2014-02-14','10:25:00',5.14),('16100','2014-02-14','10:30:00',5.19),('16100','2014-02-14','10:35:00',5.24),('16100','2014-02-14','10:40:00',5.35),('16100','2014-02-14','10:45:00',5.13),('16100','2014-02-14','10:50:00',5.47),('16100','2014-02-14','10:55:00',5.58),('16100','2014-02-14','11:00:00',5.59),('16100','2014-02-14','11:05:00',5.63),('16100','2014-02-14','11:10:00',5.61),('16100','2014-02-14','11:15:00',5.63),('16100','2014-02-14','11:20:00',5.72),('16100','2014-02-14','11:25:00',5.73),('16100','2014-02-14','11:30:00',5.78),('16100','2014-02-14','11:35:00',5.86),('16100','2014-02-14','11:40:00',5.89),('16100','2014-02-14','11:45:00',6.02),('16100','2014-02-14','11:50:00',6.15),('16100','2014-02-14','11:55:00',5.13),('16100','2014-02-14','12:00:00',2.69),('16100','2014-02-14','12:05:00',6.72),('16100','2014-02-14','12:10:00',6.55),('16100','2014-02-14','12:15:00',6.4),('16100','2014-02-14','12:20:00',6.48),('16100','2014-02-14','12:25:00',6.37),('16100','2014-02-14','12:30:00',6.38),('16100','2014-02-14','12:35:00',5.96),('16100','2014-02-14','12:40:00',4.6),('16100','2014-02-14','12:45:00',5.48),('16100','2014-02-14','12:50:00',6.44),('16100','2014-02-14','12:55:00',6.25),('16100','2014-02-14','13:00:00',6.22),('16100','2014-02-14','13:05:00',6.17),('16100','2014-02-14','13:10:00',6.23),('16100','2014-02-14','13:15:00',6.19),('16100','2014-02-14','13:20:00',6.22),('16100','2014-02-14','13:25:00',6.06),('16100','2014-02-14','13:30:00',6.01),('16100','2014-02-14','13:35:00',5.99),('16100','2014-02-14','13:40:00',5.83),('16100','2014-02-14','13:45:00',5.81),('16100','2014-02-14','13:50:00',5.73),('16100','2014-02-14','13:55:00',5.62),('16100','2014-02-14','14:00:00',5.6),('16100','2014-02-14','14:05:00',5.49),('16100','2014-02-14','14:10:00',5.4),('16100','2014-02-14','14:15:00',5.33),('16100','2014-02-14','14:20:00',5.22),('16100','2014-02-14','14:25:00',5.15),('16100','2014-02-14','14:30:00',5.03),('16100','2014-02-14','14:35:00',4.93),('16100','2014-02-14','14:40:00',4.88),('16100','2014-02-14','14:45:00',4.78),('16100','2014-02-14','14:50:00',4.68),('16100','2014-02-14','14:55:00',4.58),('16100','2014-02-14','15:00:00',4.43),('16100','2014-02-14','15:05:00',4.28),('16100','2014-02-14','15:10:00',4.18),('16100','2014-02-14','15:15:00',4.08),('16100','2014-02-14','15:20:00',3.95),('16100','2014-02-14','15:25:00',3.83),('16100','2014-02-14','15:30:00',3.72),('16100','2014-02-14','15:35:00',3.49),('16100','2014-02-14','15:40:00',3.39),('16100','2014-02-14','15:45:00',3.26),('16100','2014-02-14','15:50:00',3.15),('16100','2014-02-14','15:55:00',2.98),('16100','2014-02-14','16:00:00',2.76),('16100','2014-02-14','16:05:00',2.59),('16100','2014-02-14','16:10:00',2.4),('16100','2014-02-14','16:15:00',2.23),('16100','2014-02-14','16:20:00',2.09),('16100','2014-02-14','16:25:00',1.96),('16100','2014-02-14','16:30:00',1.81),('16100','2014-02-14','16:35:00',1.62),('16100','2014-02-14','16:40:00',1.45),('16100','2014-02-14','16:45:00',1.3),('16100','2014-02-14','16:50:00',1.12),('16100','2014-02-13','08:35:00',1.53),('16100','2014-02-13','08:40:00',2.34),('16100','2014-02-13','08:45:00',2.56),('16100','2014-02-13','08:50:00',2.7),('16100','2014-02-13','08:55:00',2.86),('16100','2014-02-13','09:00:00',3.03),('16100','2014-02-13','09:05:00',3.19),('16100','2014-02-13','09:10:00',3.37),('16100','2014-02-13','09:15:00',3.46),('16100','2014-02-13','09:20:00',3.22),('16100','2014-02-13','09:25:00',2.44),('16100','2014-02-13','09:30:00',2.65),('16100','2014-02-13','09:35:00',1.85),('16100','2014-02-13','09:40:00',2.89),('16100','2014-02-13','09:45:00',2.58),('16100','2014-02-13','09:50:00',2.25),('16100','2014-02-13','09:55:00',3.9),('16100','2014-02-13','10:00:00',2.11),('16100','2014-02-13','10:05:00',3.13),('16100','2014-02-13','10:10:00',4.75),('16100','2014-02-13','10:15:00',5.08),('16100','2014-02-13','10:20:00',5.19),('16100','2014-02-13','10:25:00',4.24),('16100','2014-02-13','10:30:00',5.65),('16100','2014-02-13','10:35:00',5.39),('16100','2014-02-13','10:40:00',5.55),('16100','2014-02-13','10:45:00',5.66),('16100','2014-02-13','10:50:00',5.96),('16100','2014-02-13','10:55:00',6.01),('16100','2014-02-13','11:00:00',6.11),('16100','2014-02-13','11:05:00',6.2),('16100','2014-02-13','11:10:00',6.22),('16100','2014-02-13','11:15:00',6.34),('16100','2014-02-13','11:20:00',5.79),('16100','2014-02-13','11:25:00',5.08),('16100','2014-02-13','11:30:00',6.49),('16100','2014-02-13','11:35:00',6.65),('16100','2014-02-13','11:40:00',6.54),('16100','2014-02-13','11:45:00',5.25),('16100','2014-02-13','11:50:00',6.38),('16100','2014-02-13','11:55:00',6.69),('16100','2014-02-13','12:00:00',6.73),('16100','2014-02-13','12:05:00',6.67),('16100','2014-02-13','12:10:00',6.55),('16100','2014-02-13','12:15:00',6.73),('16100','2014-02-13','12:20:00',6.67),('16100','2014-02-13','12:25:00',6.7),('16100','2014-02-13','12:30:00',6.66),('16100','2014-02-13','12:35:00',6.67),('16100','2014-02-13','12:40:00',6.68),('16100','2014-02-13','12:45:00',6.66),('16100','2014-02-13','12:50:00',6.63),('16100','2014-02-13','12:55:00',6.64),('16100','2014-02-13','13:00:00',6.67),('16100','2014-02-13','13:05:00',6.6),('16100','2014-02-13','13:10:00',6.59),('16100','2014-02-13','13:15:00',6.57),('16100','2014-02-13','13:20:00',6.54),('16100','2014-02-13','13:25:00',6.47),('16100','2014-02-13','13:30:00',6.44),('16100','2014-02-13','13:35:00',6.33),('16100','2014-02-13','13:40:00',6.17),('16100','2014-02-13','13:45:00',6.16),('16100','2014-02-13','13:50:00',6.03),('16100','2014-02-13','13:55:00',5.95),('16100','2014-02-13','14:00:00',5.9),('16100','2014-02-13','14:05:00',5.82),('16100','2014-02-13','14:10:00',5.75),('16100','2014-02-13','14:15:00',5.62),('16100','2014-02-13','14:20:00',5.47),('16100','2014-02-13','14:25:00',5.39),('16100','2014-02-13','14:30:00',5.31),('16100','2014-02-13','14:35:00',5.24),('16100','2014-02-13','14:40:00',5.17),('16100','2014-02-13','14:45:00',5.06),('16100','2014-02-13','14:50:00',4.9),('16100','2014-02-13','14:55:00',4.74),('16100','2014-02-13','15:00:00',4.57),('16100','2014-02-13','15:05:00',4.43),('16100','2014-02-13','15:10:00',4.32),('16100','2014-02-13','15:15:00',4.17),('16100','2014-02-13','15:20:00',4.05),('16100','2014-02-13','15:25:00',3.92),('16100','2014-02-13','15:30:00',3.78),('16100','2014-02-13','15:35:00',3.61),('16100','2014-02-13','15:40:00',3.47),('16100','2014-02-13','15:45:00',3.31),('16100','2014-02-13','15:50:00',3.16),('16100','2014-02-13','15:55:00',2.98),('16100','2014-02-13','16:00:00',2.8),('16100','2014-02-13','16:05:00',2.65),('16100','2014-02-13','16:10:00',2.43),('16100','2014-02-13','16:15:00',2.22),('16100','2014-02-13','16:20:00',2.04),('16100','2014-02-13','16:25:00',1.88),('16100','2014-02-13','16:30:00',1.73),('16100','2014-02-13','16:35:00',1.51),('16100','2014-02-13','16:40:00',1.33),('16100','2014-02-13','16:45:00',1.18),('16100','2014-02-13','16:50:00',1.01),('16100','2014-02-12','08:00:00',1.06),('16100','2014-02-12','08:05:00',1.21),('16100','2014-02-12','08:10:00',1.27),('16100','2014-02-12','08:15:00',1.48),('16100','2014-02-12','08:20:00',1.05),('16100','2014-02-12','08:25:00',1.69),('16100','2014-02-12','08:30:00',2.09),('16100','2014-02-12','08:35:00',2.25),('16100','2014-02-12','08:40:00',2.44),('16100','2014-02-12','08:45:00',2.61),('16100','2014-02-12','08:50:00',2.76),('16100','2014-02-12','08:55:00',2.91),('16100','2014-02-12','09:00:00',3.11),('16100','2014-02-12','09:05:00',3.3),('16100','2014-02-12','09:10:00',3.46),('16100','2014-02-12','09:15:00',3.57),('16100','2014-02-12','09:20:00',3.73),('16100','2014-02-12','09:25:00',3.89),('16100','2014-02-12','09:30:00',3.95),('16100','2014-02-12','09:35:00',4.09),('16100','2014-02-12','09:40:00',4.22),('16100','2014-02-12','09:45:00',4.35),('16100','2014-02-12','09:50:00',4.51),('16100','2014-02-12','09:55:00',4.64),('16100','2014-02-12','10:00:00',4.79),('16100','2014-02-12','10:05:00',4.91),('16100','2014-02-12','10:10:00',5.01),('16100','2014-02-12','10:15:00',5.07),('16100','2014-02-12','10:20:00',5.17),('16100','2014-02-12','10:25:00',5.3),('16100','2014-02-12','10:30:00',5.42),('16100','2014-02-12','10:35:00',5.52),('16100','2014-02-12','10:40:00',5.59),('16100','2014-02-12','10:45:00',5.69),('16100','2014-02-12','10:50:00',5.71),('16100','2014-02-12','10:55:00',5.72),('16100','2014-02-12','11:00:00',5.79),('16100','2014-02-12','11:05:00',5.96),('16100','2014-02-12','11:10:00',4.89),('16100','2014-02-12','11:15:00',3.17),('16100','2014-02-12','11:20:00',6.3),('16100','2014-02-12','11:25:00',6.35),('16100','2014-02-12','11:30:00',6.4),('16100','2014-02-12','11:35:00',5.91),('16100','2014-02-12','11:40:00',6.61),('16100','2014-02-12','11:45:00',6.59),('16100','2014-02-12','11:50:00',6.79),('16100','2014-02-12','11:55:00',6.67),('16100','2014-02-12','12:00:00',6.67),('16100','2014-02-12','12:05:00',6.64),('16100','2014-02-12','12:10:00',6.65),('16100','2014-02-12','12:15:00',7.1),('16100','2014-02-12','12:20:00',6.91),('16100','2014-02-12','12:25:00',5.9),('16100','2014-02-12','12:30:00',7.25),('16100','2014-02-12','12:35:00',7.06),('16100','2014-02-12','12:40:00',6.96),('16100','2014-02-12','12:45:00',3.12),('16100','2014-02-12','12:50:00',6.91),('16100','2014-02-12','12:55:00',5.7),('16100','2014-02-12','13:00:00',6.8),('16100','2014-02-12','13:05:00',6.69),('16100','2014-02-12','13:10:00',6.64),('16100','2014-02-12','13:15:00',6.56),('16100','2014-02-12','13:20:00',6.43),('16100','2014-02-12','13:25:00',6.39),('16100','2014-02-12','13:30:00',6.3),('16100','2014-02-12','13:35:00',6.27),('16100','2014-02-12','13:40:00',6.11),('16100','2014-02-12','13:45:00',6.05),('16100','2014-02-12','13:50:00',6.08),('16100','2014-02-12','13:55:00',5.7),('16100','2014-02-12','14:00:00',5.97),('16100','2014-02-12','14:05:00',5.89),('16100','2014-02-12','14:10:00',5.74),('16100','2014-02-12','14:15:00',3.96),('16100','2014-02-12','14:20:00',5.68),('16100','2014-02-12','14:25:00',5.5),('16100','2014-02-12','14:30:00',5.29),('16100','2014-02-12','14:35:00',2),('16100','2014-02-12','14:40:00',1.62),('16100','2014-02-12','14:45:00',1.69),('16100','2014-02-12','14:50:00',5.24),('16100','2014-02-12','14:55:00',5.24),('16100','2014-02-12','15:00:00',4.52),('16100','2014-02-12','15:05:00',4.66),('16100','2014-02-12','15:10:00',5.13),('16100','2014-02-12','15:15:00',3.62),('16100','2014-02-12','15:20:00',4.44),('16100','2014-02-12','15:25:00',4.46),('16100','2014-02-12','15:30:00',2.7),('16100','2014-02-12','15:35:00',3.89),('16100','2014-02-12','15:40:00',2.74),('16100','2014-02-12','15:45:00',3.74),('16100','2014-02-12','15:50:00',3.19),('16100','2014-02-12','15:55:00',3.29),('16100','2014-02-12','16:00:00',3.02),('16100','2014-02-12','16:05:00',2.76),('16100','2014-02-12','16:10:00',2.52),('16100','2014-02-12','16:15:00',1.37),('16100','2014-02-12','16:30:00',1.37),('16100','2014-02-11','08:05:00',1.01),('16100','2014-02-11','08:10:00',1.2),('16100','2014-02-11','08:15:00',1.36),('16100','2014-02-11','08:20:00',1.37),('16100','2014-02-11','08:25:00',1.11),('16100','2014-02-11','08:30:00',1.73),('16100','2014-02-11','08:35:00',2.18),('16100','2014-02-11','08:40:00',1.88),('16100','2014-02-11','08:45:00',2.54),('16100','2014-02-11','08:50:00',2.69),('16100','2014-02-11','08:55:00',2.96),('16100','2014-02-11','09:00:00',3.01),('16100','2014-02-11','09:05:00',2.83),('16100','2014-02-11','09:10:00',3.49),('16100','2014-02-11','09:15:00',3.63),('16100','2014-02-11','09:20:00',3.79),('16100','2014-02-11','09:25:00',4.12),('16100','2014-02-11','09:30:00',1.16),('16100','2014-02-11','09:35:00',1.67),('16100','2014-02-11','09:40:00',1.69),('16100','2014-02-11','09:45:00',3.82),('16100','2014-02-11','09:50:00',2.58),('16100','2014-02-11','09:55:00',2.41),('16100','2014-02-11','10:00:00',2.81),('16100','2014-02-11','10:05:00',2.35),('16100','2014-02-11','10:10:00',1.78),('16100','2014-02-11','10:15:00',1.71),('16100','2014-02-11','10:20:00',1.83),('16100','2014-02-11','10:25:00',2.51),('16100','2014-02-11','10:30:00',2.24),('16100','2014-02-11','10:35:00',2.11),('16100','2014-02-11','10:40:00',2.95),('16100','2014-02-11','10:45:00',2.41),('16100','2014-02-11','10:50:00',3.65),('16100','2014-02-11','10:55:00',2.02),('16100','2014-02-11','11:00:00',2),('16100','2014-02-11','11:05:00',2.14),('16100','2014-02-11','11:10:00',2.16),('16100','2014-02-11','11:15:00',2.65),('16100','2014-02-11','11:20:00',3.33),('16100','2014-02-11','11:25:00',4.54),('16100','2014-02-11','11:30:00',2.44),('16100','2014-02-11','11:35:00',2.66),('16100','2014-02-11','11:40:00',5.81),('16100','2014-02-11','11:45:00',2.51),('16100','2014-02-11','11:50:00',6.3),('16100','2014-02-11','11:55:00',3.3),('16100','2014-02-11','12:00:00',3.83),('16100','2014-02-11','12:05:00',2.75),('16100','2014-02-11','12:10:00',2.18),('16100','2014-02-11','12:15:00',1.94),('16100','2014-02-11','12:20:00',1.86),('16100','2014-02-11','12:25:00',1.92),('16100','2014-02-11','12:30:00',2.05),('16100','2014-02-11','12:35:00',2.13),('16100','2014-02-11','12:40:00',2.17),('16100','2014-02-11','12:45:00',2.35),('16100','2014-02-11','12:50:00',2.83),('16100','2014-02-11','12:55:00',3.1),('16100','2014-02-11','13:00:00',3.65),('16100','2014-02-11','13:05:00',3.25),('16100','2014-02-11','13:10:00',2.99),('16100','2014-02-11','13:15:00',3.76),('16100','2014-02-11','13:20:00',3.11),('16100','2014-02-11','13:25:00',6.19),('16100','2014-02-11','13:30:00',3.48),('16100','2014-02-11','13:35:00',3.07),('16100','2014-02-11','13:40:00',2.45),('16100','2014-02-11','13:45:00',2.49),('16100','2014-02-11','13:50:00',2.31),('16100','2014-02-11','13:55:00',2.79),('16100','2014-02-11','14:00:00',2.89),('16100','2014-02-11','14:05:00',6.18),('16100','2014-02-11','14:10:00',6.1),('16100','2014-02-11','14:15:00',5.66),('16100','2014-02-11','14:20:00',5.72),('16100','2014-02-11','14:25:00',3.58),('16100','2014-02-11','14:30:00',6.04),('16100','2014-02-11','14:35:00',5.7),('16100','2014-02-11','14:40:00',5.43),('16100','2014-02-11','14:45:00',5.22),('16100','2014-02-11','14:50:00',5.17),('16100','2014-02-11','14:55:00',3.69),('16100','2014-02-11','15:00:00',2.23),('16100','2014-02-11','15:05:00',1.84),('16100','2014-02-11','15:10:00',2.33),('16100','2014-02-11','15:15:00',3.39),('16100','2014-02-11','15:20:00',2.83),('16100','2014-02-11','15:25:00',4.74),('16100','2014-02-11','15:30:00',4.23),('16100','2014-02-11','15:35:00',3.93),('16100','2014-02-11','15:40:00',3.35),('16100','2014-02-11','15:45:00',4.28),('16100','2014-02-11','15:50:00',3.09),('16100','2014-02-11','15:55:00',2.16),('16100','2014-02-11','16:00:00',2.98),('16100','2014-02-11','16:05:00',2.32),('16100','2014-02-11','16:10:00',1.76),('16100','2014-02-11','16:15:00',1.74),('16100','2014-02-11','16:20:00',1.85),('16100','2014-02-11','16:25:00',1.28),('16100','2014-02-10','09:10:00',1.01),('16100','2014-02-10','09:15:00',1.19),('16100','2014-02-10','09:20:00',1.45),('16100','2014-02-10','09:25:00',1.79),('16100','2014-02-10','09:30:00',2.09),('16100','2014-02-10','09:35:00',1.91),('16100','2014-02-10','09:40:00',1.76),('16100','2014-02-10','09:45:00',2.01),('16100','2014-02-10','09:50:00',2.18),('16100','2014-02-10','09:55:00',1.83),('16100','2014-02-10','10:00:00',1.75),('16100','2014-02-10','10:05:00',1.72),('16100','2014-02-10','10:10:00',1.96),('16100','2014-02-10','10:15:00',2.38),('16100','2014-02-10','10:20:00',3.03),('16100','2014-02-10','10:25:00',3.62),('16100','2014-02-10','10:30:00',3.78),('16100','2014-02-10','10:35:00',4.05),('16100','2014-02-10','10:40:00',3.4),('16100','2014-02-10','10:45:00',3.79),('16100','2014-02-10','10:50:00',3.91),('16100','2014-02-10','10:55:00',3.81),('16100','2014-02-10','11:00:00',3.69),('16100','2014-02-10','11:05:00',4.33),('16100','2014-02-10','11:10:00',4.31),('16100','2014-02-10','11:15:00',3.68),('16100','2014-02-10','11:20:00',3.56),('16100','2014-02-10','11:25:00',4.19),('16100','2014-02-10','11:30:00',3.58),('16100','2014-02-10','11:35:00',3.77),('16100','2014-02-10','11:40:00',4.9),('16100','2014-02-10','11:45:00',4.61),('16100','2014-02-10','11:50:00',4.2),('16100','2014-02-10','11:55:00',3.47),('16100','2014-02-10','12:00:00',2.77),('16100','2014-02-10','12:05:00',2.99),('16100','2014-02-10','12:10:00',4.05),('16100','2014-02-10','12:15:00',3.53),('16100','2014-02-10','12:20:00',2.59),('16100','2014-02-10','12:25:00',3.1),('16100','2014-02-10','12:30:00',3.82),('16100','2014-02-10','12:35:00',4.12),('16100','2014-02-10','12:40:00',2.84),('16100','2014-02-10','12:45:00',2.95),('16100','2014-02-10','12:50:00',3.14),('16100','2014-02-10','12:55:00',2.5),('16100','2014-02-10','13:00:00',4.06),('16100','2014-02-10','13:05:00',3.35),('16100','2014-02-10','13:10:00',5.89),('16100','2014-02-10','13:15:00',6.12),('16100','2014-02-10','13:20:00',6.19),('16100','2014-02-10','13:25:00',5.25),('16100','2014-02-10','13:30:00',4.86),('16100','2014-02-10','13:35:00',4.68),('16100','2014-02-10','13:40:00',5.39),('16100','2014-02-10','13:45:00',3.91),('16100','2014-02-10','13:50:00',4.26),('16100','2014-02-10','13:55:00',2.43),('16100','2014-02-10','14:00:00',2.19),('16100','2014-02-10','14:05:00',2.8),('16100','2014-02-10','14:10:00',3.4),('16100','2014-02-10','14:15:00',2.67),('16100','2014-02-10','14:20:00',3.09),('16100','2014-02-10','14:25:00',2.62),('16100','2014-02-10','14:30:00',2.67),('16100','2014-02-10','14:35:00',2.08),('16100','2014-02-10','14:40:00',1.77),('16100','2014-02-10','14:45:00',1.59),('16100','2014-02-10','14:50:00',1.45),('16100','2014-02-10','14:55:00',1.37),('16100','2014-02-10','15:00:00',1.46),('16100','2014-02-10','15:05:00',1.57),('16100','2014-02-10','15:10:00',2.34),('16100','2014-02-10','15:15:00',2.19),('16100','2014-02-10','15:20:00',2.62),('16100','2014-02-10','15:25:00',1.71),('16100','2014-02-10','15:30:00',1.52),('16100','2014-02-10','15:35:00',1.24),('16100','2014-02-10','15:40:00',1.27),('16100','2014-02-10','15:55:00',1.03),('16100','2014-02-10','16:05:00',1.06),('16100','2014-02-10','16:10:00',1.66),('16100','2014-02-10','16:15:00',1.83),('16100','2014-02-10','16:20:00',1.56),('16100','2014-02-10','16:25:00',1.48),('16100','2014-02-10','16:30:00',1.4),('16100','2014-02-10','16:35:00',1.31),('16100','2014-02-10','16:40:00',1.18),('16100','2014-02-09','12:25:00',1.2),('16100','2014-02-09','12:30:00',1.13),('16100','2014-02-09','12:50:00',1.01),('16100','2014-02-09','12:55:00',1.49),('16100','2014-02-09','13:00:00',1.68),('16100','2014-02-09','13:05:00',1.4),('16100','2014-02-09','13:10:00',1.13),('16100','2014-02-09','13:15:00',1.19),('16100','2014-02-09','13:30:00',1.07),('16100','2014-02-09','13:35:00',1.2),('16100','2014-02-09','13:40:00',1.21),('16100','2014-02-09','13:45:00',1.21),('16100','2014-02-09','13:50:00',1.16),('16100','2014-02-09','13:55:00',1.29),('16100','2014-02-09','14:00:00',1.37),('16100','2014-02-09','14:05:00',1.2),('16100','2014-02-09','14:10:00',1.22),('16100','2014-02-09','14:15:00',1.18),('16100','2014-02-09','14:20:00',1.24),('16100','2014-02-09','14:25:00',1.28),('16100','2014-02-09','14:30:00',1.39),('16100','2014-02-09','14:35:00',1.51),('16100','2014-02-09','14:40:00',1.62),('16100','2014-02-09','14:45:00',1.52),('16100','2014-02-09','14:50:00',1.27),('16100','2014-02-09','14:55:00',1.08),('16100','2014-02-09','15:00:00',1.11),('16100','2014-02-09','15:05:00',1.24),('16100','2014-02-09','15:10:00',1.2),('16100','2014-02-09','15:15:00',1),('16100','2014-02-09','15:25:00',1.18),('16100','2014-02-09','15:30:00',1.17),('16100','2014-02-08','11:25:00',1.5),('16100','2014-02-08','11:30:00',1.49),('16100','2014-02-08','11:35:00',1.52),('16100','2014-02-08','12:05:00',1.28),('16100','2014-02-08','12:10:00',1.34),('16100','2014-02-08','12:20:00',2.1),('16100','2014-02-08','12:25:00',1.4),('16100','2014-02-08','12:30:00',1.47),('16100','2014-02-08','12:35:00',1.29),('16100','2014-02-08','12:40:00',2.34),('16100','2014-02-08','12:45:00',1.36),('16100','2014-02-08','12:50:00',1.08),('16100','2014-02-08','12:55:00',2.67),('16100','2014-02-08','13:00:00',3.44),('16100','2014-02-08','13:05:00',1.73),('16100','2014-02-08','13:10:00',1.72),('16100','2014-02-08','13:15:00',1.88),('16100','2014-02-08','13:20:00',2.57),('16100','2014-02-08','13:25:00',1.87),('16100','2014-02-08','13:30:00',1.13),('16100','2014-02-08','13:35:00',4.44),('16100','2014-02-08','13:40:00',3.54),('16100','2014-02-08','13:45:00',4.75),('16100','2014-02-08','13:50:00',4.28),('16100','2014-02-08','13:55:00',6.1),('16100','2014-02-08','14:00:00',6.09),('16100','2014-02-08','14:05:00',2.81),('16100','2014-02-08','14:10:00',2.15),('16100','2014-02-08','14:15:00',1.8),('16100','2014-02-08','14:20:00',3.45),('16100','2014-02-08','14:25:00',4.87),('16100','2014-02-08','14:30:00',4.46),('16100','2014-02-08','14:35:00',2.49),('16100','2014-02-08','14:40:00',2.52),('16100','2014-02-08','14:45:00',1.6),('16100','2014-02-08','14:50:00',1.79),('16100','2014-02-08','14:55:00',4.07),('16100','2014-02-08','15:00:00',1.48),('16100','2014-02-08','15:05:00',3.32),('16100','2014-02-08','15:10:00',3.96),('16100','2014-02-08','15:15:00',2.43),('16100','2014-02-08','15:20:00',2.39),('16100','2014-02-08','15:25:00',2.99),('16100','2014-02-08','15:30:00',3.21),('16100','2014-02-08','15:35:00',2.99),('16100','2014-02-08','15:40:00',2.88),('16100','2014-02-08','15:45:00',2.8),('16100','2014-02-08','15:50:00',2.62),('16100','2014-02-08','15:55:00',2.4),('16100','2014-02-08','16:00:00',2.32),('16100','2014-02-08','16:05:00',2.2),('16100','2014-02-08','16:10:00',1.97),('16100','2014-02-08','16:15:00',1.58),('16100','2014-02-08','16:20:00',1.55),('16100','2014-02-08','16:35:00',1.13),('16100','2014-02-07','09:40:00',1.24),('16100','2014-02-07','09:45:00',1.06),('16100','2014-02-07','09:50:00',2.37),('16100','2014-02-07','09:55:00',4.84),('16100','2014-02-07','10:00:00',4.82),('16100','2014-02-07','10:05:00',4.46),('16100','2014-02-07','10:10:00',4.99),('16100','2014-02-07','10:15:00',5.28),('16100','2014-02-07','10:20:00',4.92),('16100','2014-02-07','10:25:00',3.46),('16100','2014-02-07','10:30:00',3.36),('16100','2014-02-07','10:35:00',3.31),('16100','2014-02-07','10:40:00',1.42),('16100','2014-02-07','10:45:00',2.09),('16100','2014-02-07','10:50:00',2.29),('16100','2014-02-07','10:55:00',6.03),('16100','2014-02-07','11:00:00',2.74),('16100','2014-02-07','11:05:00',6.86),('16100','2014-02-07','11:10:00',5.69),('16100','2014-02-07','11:15:00',2.41),('16100','2014-02-07','11:20:00',2.12),('16100','2014-02-07','11:25:00',3.55),('16100','2014-02-07','11:30:00',2.06),('16100','2014-02-07','11:35:00',4.52),('16100','2014-02-07','11:40:00',1.86),('16100','2014-02-07','11:45:00',1.3),('16100','2014-02-07','11:55:00',6.56),('16100','2014-02-07','12:00:00',7.34),('16100','2014-02-07','12:05:00',3.43),('16100','2014-02-07','12:10:00',3.41),('16100','2014-02-07','12:15:00',6.75),('16100','2014-02-07','12:20:00',1.59),('16100','2014-02-07','12:25:00',6.04),('16100','2014-02-07','12:30:00',6.17),('16100','2014-02-07','12:35:00',4.22),('16100','2014-02-07','12:40:00',2.35),('16100','2014-02-07','12:45:00',4.79),('16100','2014-02-07','12:50:00',3.58),('16100','2014-02-07','12:55:00',6.97),('16100','2014-02-07','13:00:00',5.48),('16100','2014-02-07','13:05:00',2.24),('16100','2014-02-07','13:10:00',4.32),('16100','2014-02-07','13:15:00',2.67),('16100','2014-02-07','13:20:00',6.84),('16100','2014-02-07','13:25:00',6.91),('16100','2014-02-07','13:30:00',6.41),('16100','2014-02-07','13:35:00',2.29),('16100','2014-02-07','13:40:00',4.59),('16100','2014-02-07','13:45:00',6.59),('16100','2014-02-07','13:50:00',4.02),('16100','2014-02-07','13:55:00',4.16),('16100','2014-02-07','14:00:00',5.82),('16100','2014-02-07','14:05:00',3.34),('16100','2014-02-07','14:10:00',2.57),('16100','2014-02-07','14:15:00',3.25),('16100','2014-02-07','14:20:00',2.43),('16100','2014-02-07','14:25:00',3.46),('16100','2014-02-07','14:30:00',3.11),('16100','2014-02-07','14:35:00',3.39),('16100','2014-02-07','14:40:00',5.02),('16100','2014-02-07','14:45:00',2.96),('16100','2014-02-07','14:50:00',2.67),('16100','2014-02-07','14:55:00',3.2),('16100','2014-02-07','15:00:00',1.31),('16100','2014-02-07','15:05:00',4.31),('16100','2014-02-07','15:10:00',2.28),('16100','2014-02-07','15:15:00',2.64),('16100','2014-02-07','15:20:00',2.72),('16100','2014-02-07','15:25:00',4.64),('16100','2014-02-07','15:30:00',2.17),('16100','2014-02-07','15:45:00',2.04),('16100','2014-02-07','15:50:00',2.72),('16100','2014-02-07','15:55:00',3.17),('16100','2014-02-07','16:00:00',2.46),('16100','2014-02-07','16:05:00',1.7),('16100','2014-02-07','16:10:00',1.4),('16100','2014-02-07','16:35:00',1.11),('16100','2014-02-07','16:40:00',1.07),('16100','2014-02-06','08:05:00',1.23),('16100','2014-02-06','08:10:00',1.45),('16100','2014-02-06','08:15:00',1.58),('16100','2014-02-06','08:20:00',1.89),('16100','2014-02-06','08:25:00',1.86),('16100','2014-02-06','08:30:00',1.86),('16100','2014-02-06','08:35:00',1.97),('16100','2014-02-06','08:40:00',2.13),('16100','2014-02-06','08:45:00',2.32),('16100','2014-02-06','08:50:00',2.5),('16100','2014-02-06','08:55:00',2.7),('16100','2014-02-06','09:00:00',2.87),('16100','2014-02-06','09:05:00',3.03),('16100','2014-02-06','09:10:00',3.17),('16100','2014-02-06','09:15:00',3.31),('16100','2014-02-06','09:20:00',3.44),('16100','2014-02-06','09:25:00',3.58),('16100','2014-02-06','09:30:00',3.72),('16100','2014-02-06','09:35:00',3.86),('16100','2014-02-06','09:40:00',3.98),('16100','2014-02-06','09:45:00',4.09),('16100','2014-02-06','09:50:00',4.2),('16100','2014-02-06','09:55:00',4.26),('16100','2014-02-06','10:00:00',4.36),('16100','2014-02-06','10:05:00',4.4),('16100','2014-02-06','10:10:00',4.48),('16100','2014-02-06','10:15:00',4.58),('16100','2014-02-06','10:20:00',4.67),('16100','2014-02-06','10:25:00',4.33),('16100','2014-02-06','10:30:00',3.59),('16100','2014-02-06','10:35:00',3.16),('16100','2014-02-06','10:40:00',2.87),('16100','2014-02-06','10:45:00',1.39),('16100','2014-02-06','10:50:00',6.08),('16100','2014-02-06','10:55:00',5.53),('16100','2014-02-06','11:00:00',5.87),('16100','2014-02-06','11:05:00',5.69),('16100','2014-02-06','11:10:00',4.71),('16100','2014-02-06','11:15:00',2.04),('16100','2014-02-06','11:20:00',3.37),('16100','2014-02-06','11:25:00',2.59),('16100','2014-02-06','11:30:00',5.96),('16100','2014-02-06','11:35:00',6.02),('16100','2014-02-06','11:40:00',3.6),('16100','2014-02-06','11:45:00',1.99),('16100','2014-02-06','11:50:00',6.35),('16100','2014-02-06','11:55:00',3.89),('16100','2014-02-06','12:00:00',2.48),('16100','2014-02-06','12:05:00',2.86),('16100','2014-02-06','12:10:00',4.58),('16100','2014-02-06','12:15:00',5.6),('16100','2014-02-06','12:20:00',6.8),('16100','2014-02-06','12:25:00',6.76),('16100','2014-02-06','12:30:00',6.59),('16100','2014-02-06','12:35:00',7.11),('16100','2014-02-06','12:40:00',6.39),('16100','2014-02-06','12:45:00',6.96),('16100','2014-02-06','12:50:00',5.29),('16100','2014-02-06','12:55:00',6.43),('16100','2014-02-06','13:00:00',5.88),('16100','2014-02-06','13:05:00',6.09),('16100','2014-02-06','13:10:00',6.82),('16100','2014-02-06','13:15:00',6.61),('16100','2014-02-06','13:20:00',6.5),('16100','2014-02-06','13:25:00',6.41),('16100','2014-02-06','13:30:00',6.42),('16100','2014-02-06','13:35:00',5.4),('16100','2014-02-06','13:40:00',6.15),('16100','2014-02-06','13:45:00',6.04),('16100','2014-02-06','13:50:00',5.9),('16100','2014-02-06','13:55:00',5.51),('16100','2014-02-06','14:00:00',5.7),('16100','2014-02-06','14:05:00',5.56),('16100','2014-02-06','14:10:00',5.3),('16100','2014-02-06','14:15:00',4.26),('16100','2014-02-06','14:20:00',4.77),('16100','2014-02-06','14:25:00',5.18),('16100','2014-02-06','14:30:00',5.18),('16100','2014-02-06','14:35:00',5.09),('16100','2014-02-06','14:40:00',4.95),('16100','2014-02-06','14:45:00',4.33),('16100','2014-02-06','14:50:00',4.83),('16100','2014-02-06','14:55:00',3.53),('16100','2014-02-06','15:00:00',4.5),('16100','2014-02-06','15:05:00',4.31),('16100','2014-02-06','15:10:00',4.37),('16100','2014-02-06','15:15:00',4.2),('16100','2014-02-06','15:20:00',3.61),('16100','2014-02-06','15:25:00',3.69),('16100','2014-02-06','15:30:00',3.59),('16100','2014-02-06','15:35:00',3.44),('16100','2014-02-06','15:40:00',3.3),('16100','2014-02-06','15:45:00',3.1),('16100','2014-02-06','15:50:00',2.98),('16100','2014-02-06','15:55:00',2.76),('16100','2014-02-06','16:00:00',2.57),('16100','2014-02-06','16:05:00',2.47),('16100','2014-02-06','16:10:00',2.34),('16100','2014-02-06','16:15:00',2.2),('16100','2014-02-06','16:20:00',2.09),('16100','2014-02-06','16:25:00',1.8),('16100','2014-02-06','16:30:00',1.59),('16100','2014-02-06','16:35:00',1.41),('16100','2014-02-06','16:40:00',1.24),('16100','2014-02-06','16:45:00',1.05),('16100','2014-02-05','08:15:00',1.11),('16100','2014-02-05','08:20:00',1.26),('16100','2014-02-05','08:25:00',1.15),('16100','2014-02-05','08:30:00',1.52),('16100','2014-02-05','08:35:00',1.97),('16100','2014-02-05','08:40:00',2.19),('16100','2014-02-05','08:45:00',2.35),('16100','2014-02-05','08:50:00',2.82),('16100','2014-02-05','08:55:00',3.33),('16100','2014-02-05','09:00:00',3.34),('16100','2014-02-05','09:05:00',1.72),('16100','2014-02-05','09:10:00',1.45),('16100','2014-02-05','09:15:00',2.74),('16100','2014-02-05','09:20:00',1.5),('16100','2014-02-05','09:25:00',2.38),('16100','2014-02-05','09:30:00',3.85),('16100','2014-02-05','09:35:00',1.92),('16100','2014-02-05','09:40:00',3.37),('16100','2014-02-05','09:45:00',4.26),('16100','2014-02-05','09:50:00',4.33),('16100','2014-02-05','09:55:00',4.47),('16100','2014-02-05','10:00:00',4.59),('16100','2014-02-05','10:05:00',4.69),('16100','2014-02-05','10:10:00',4.83),('16100','2014-02-05','10:15:00',5.01),('16100','2014-02-05','10:20:00',5.14),('16100','2014-02-05','10:25:00',5.3),('16100','2014-02-05','10:30:00',5.21),('16100','2014-02-05','10:35:00',3.19),('16100','2014-02-05','10:40:00',4.25),('16100','2014-02-05','10:45:00',5.74),('16100','2014-02-05','10:50:00',3.93),('16100','2014-02-05','10:55:00',6.1),('16100','2014-02-05','11:00:00',6.09),('16100','2014-02-05','11:05:00',5.99),('16100','2014-02-05','11:10:00',4.34),('16100','2014-02-05','11:15:00',6.37),('16100','2014-02-05','11:20:00',6.28),('16100','2014-02-05','11:25:00',6.28),('16100','2014-02-05','11:30:00',6.32),('16100','2014-02-05','11:35:00',6.29),('16100','2014-02-05','11:40:00',6.38),('16100','2014-02-05','11:45:00',6.34),('16100','2014-02-05','11:50:00',5.28),('16100','2014-02-05','11:55:00',6.56),('16100','2014-02-05','12:00:00',6.53),('16100','2014-02-05','12:05:00',6.66),('16100','2014-02-05','12:10:00',5.15),('16100','2014-02-05','12:15:00',6.78),('16100','2014-02-05','12:20:00',6.6),('16100','2014-02-05','12:25:00',6.56),('16100','2014-02-05','12:30:00',6.58),('16100','2014-02-05','12:35:00',6.52),('16100','2014-02-05','12:40:00',6.13),('16100','2014-02-05','12:45:00',6.55),('16100','2014-02-05','12:50:00',6.48),('16100','2014-02-05','12:55:00',4.77),('16100','2014-02-05','13:00:00',6.47),('16100','2014-02-05','13:05:00',6.46),('16100','2014-02-05','13:10:00',6.43),('16100','2014-02-05','13:15:00',6.36),('16100','2014-02-05','13:20:00',6.32),('16100','2014-02-05','13:25:00',6.34),('16100','2014-02-05','13:30:00',6.26),('16100','2014-02-05','13:35:00',6.13),('16100','2014-02-05','13:40:00',6.1),('16100','2014-02-05','13:45:00',5.95),('16100','2014-02-05','13:50:00',5.83),('16100','2014-02-05','13:55:00',5.16),('16100','2014-02-05','14:00:00',5.72),('16100','2014-02-05','14:05:00',5.66),('16100','2014-02-05','14:10:00',5.47),('16100','2014-02-05','14:15:00',5.43),('16100','2014-02-05','14:20:00',5.38),('16100','2014-02-05','14:25:00',5.22),('16100','2014-02-05','14:30:00',5.08),('16100','2014-02-05','14:35:00',5.11),('16100','2014-02-05','14:40:00',4.95),('16100','2014-02-05','14:45:00',4.08),('16100','2014-02-05','14:50:00',4.01),('16100','2014-02-05','14:55:00',4.51),('16100','2014-02-05','15:00:00',4.42),('16100','2014-02-05','15:05:00',4.27),('16100','2014-02-05','15:10:00',4.16),('16100','2014-02-05','15:15:00',4.05),('16100','2014-02-05','15:20:00',3.87),('16100','2014-02-05','15:25:00',3.67),('16100','2014-02-05','15:30:00',3.54),('16100','2014-02-05','15:35:00',3.35),('16100','2014-02-05','15:40:00',3.27),('16100','2014-02-05','15:45:00',3.1),('16100','2014-02-05','15:50:00',2.96),('16100','2014-02-05','15:55:00',2.8),('16100','2014-02-05','16:00:00',2.62),('16100','2014-02-05','16:05:00',2.46),('16100','2014-02-05','16:10:00',2.28),('16100','2014-02-05','16:15:00',2.08),('16100','2014-02-05','16:20:00',1.89),('16100','2014-02-05','16:25:00',1.7),('16100','2014-02-05','16:30:00',1.54),('16100','2014-02-05','16:35:00',1.38),('16100','2014-02-05','16:40:00',1.2),('16100','2014-02-05','16:45:00',1.02),('16100','2014-04-26','08:35:00',1.12),('16100','2014-04-26','08:40:00',1.17),('16100','2014-04-26','08:45:00',1.6),('16100','2014-04-26','08:50:00',1.03),('16100','2014-04-26','09:00:00',1.3),('16100','2014-04-26','09:05:00',1.74),('16100','2014-04-26','09:10:00',1.78),('16100','2014-04-26','09:15:00',1.61),('16100','2014-04-26','09:50:00',1.15),('16100','2014-04-26','09:55:00',1.42),('16100','2014-04-26','10:00:00',1.91),('16100','2014-04-26','10:05:00',1.78),('16100','2014-04-26','10:10:00',2.39),('16100','2014-04-26','10:15:00',3.02),('16100','2014-04-26','10:20:00',3.39),('16100','2014-04-26','10:25:00',2.53),('16100','2014-04-26','10:35:00',1.08),('16100','2014-04-26','10:40:00',1.19),('16100','2014-04-26','10:45:00',1.33),('16100','2014-04-26','10:50:00',1.29),('16100','2014-04-26','10:55:00',1.56),('16100','2014-04-26','11:00:00',1.32),('16100','2014-04-26','11:05:00',1.15),('16100','2014-04-26','11:10:00',1.47),('16100','2014-04-26','11:15:00',1.11),('16100','2014-04-26','11:20:00',1.53),('16100','2014-04-26','11:25:00',2.36),('16100','2014-04-26','11:30:00',4.05),('16100','2014-04-26','11:35:00',4.69),('16100','2014-04-26','11:40:00',3.03),('16100','2014-04-26','11:45:00',2.86),('16100','2014-04-26','11:50:00',2.24),('16100','2014-04-26','11:55:00',3.26),('16100','2014-04-26','12:00:00',1.91),('16100','2014-04-26','12:05:00',1.1),('16100','2014-04-26','12:10:00',1.21),('16100','2014-04-26','12:15:00',2.26),('16100','2014-04-26','12:20:00',3.41),('16100','2014-04-26','12:25:00',4.51),('16100','2014-04-26','12:30:00',5.79),('16100','2014-04-26','12:35:00',4.59),('16100','2014-04-26','12:40:00',4.41),('16100','2014-04-26','12:45:00',3.56),('16100','2014-04-26','12:50:00',4.02),('16100','2014-04-26','12:55:00',3.4),('16100','2014-04-26','13:00:00',2.84),('16100','2014-04-26','13:05:00',3.25),('16100','2014-04-26','13:10:00',2.9),('16100','2014-04-26','13:15:00',3.02),('16100','2014-04-26','13:20:00',3.33),('16100','2014-04-26','13:25:00',3.87),('16100','2014-04-26','13:30:00',3.41),('16100','2014-04-26','13:35:00',2.84),('16100','2014-04-26','13:40:00',2.66),('16100','2014-04-26','13:45:00',2.89),('16100','2014-04-26','13:50:00',3.44),('16100','2014-04-26','13:55:00',4.01),('16100','2014-04-26','14:00:00',4.02),('16100','2014-04-26','14:05:00',3.84),('16100','2014-04-26','14:10:00',2.14),('16100','2014-04-26','14:15:00',2.32),('16100','2014-04-26','14:20:00',2.92),('16100','2014-04-26','14:25:00',3.47),('16100','2014-04-26','14:30:00',3.46),('16100','2014-04-26','14:35:00',3.86),('16100','2014-04-26','14:40:00',4.8),('16100','2014-04-26','14:45:00',4.15),('16100','2014-04-26','14:50:00',3.11),('16100','2014-04-26','14:55:00',3.07),('16100','2014-04-26','15:00:00',3.8),('16100','2014-04-26','15:05:00',4.88),('16100','2014-04-26','15:10:00',5.48),('16100','2014-04-26','15:15:00',5.22),('16100','2014-04-26','15:20:00',2.56),('16100','2014-04-26','15:25:00',1.53),('16100','2014-04-26','15:30:00',1.37),('16100','2014-04-26','15:35:00',1.79),('16100','2014-04-26','15:40:00',1.77),('16100','2014-04-26','15:45:00',1.03),('16100','2014-02-04','09:25:00',2.32),('16100','2014-02-04','09:30:00',1.04),('16100','2014-02-04','10:10:00',1.33),('16100','2014-02-04','10:15:00',1.92),('16100','2014-02-04','10:20:00',2.43),('16100','2014-02-04','10:25:00',5.19),('16100','2014-02-04','10:30:00',4.26),('16100','2014-02-04','10:35:00',4.4),('16100','2014-02-04','10:40:00',5.44),('16100','2014-02-04','10:45:00',5.44),('16100','2014-02-04','10:50:00',4.32),('16100','2014-02-04','10:55:00',2.45),('16100','2014-02-04','11:00:00',3.2),('16100','2014-02-04','11:05:00',3.22),('16100','2014-02-04','11:10:00',2.73),('16100','2014-02-04','11:15:00',3.09),('16100','2014-02-04','11:20:00',1.72),('16100','2014-02-04','11:25:00',3.3),('16100','2014-02-04','12:40:00',1.72),('16100','2014-02-04','12:45:00',4.39),('16100','2014-02-04','12:50:00',5.62),('16100','2014-02-04','12:55:00',4.33),('16100','2014-02-04','13:00:00',3.99),('16100','2014-02-04','13:05:00',4.26),('16100','2014-02-04','13:10:00',3.31),('16100','2014-02-04','13:15:00',2.95),('16100','2014-02-04','13:20:00',2.03),('16100','2014-02-04','13:25:00',2.36),('16100','2014-02-04','13:30:00',3.35),('16100','2014-02-04','13:35:00',2.82),('16100','2014-02-04','13:40:00',3.53),('16100','2014-02-04','13:45:00',3.15),('16100','2014-02-04','13:50:00',2.17),('16100','2014-02-04','13:55:00',1.59),('16100','2014-02-04','14:00:00',1.31),('16100','2014-02-04','14:05:00',1.38),('16100','2014-02-04','14:10:00',1.77),('16100','2014-02-04','14:15:00',1.15),('16100','2014-02-04','14:20:00',1.55),('16100','2014-02-04','14:25:00',5.88),('16100','2014-02-04','14:30:00',3.98),('16100','2014-02-04','14:35:00',4.29),('16100','2014-02-04','14:40:00',2.8),('16100','2014-02-04','14:45:00',3.08),('16100','2014-02-04','14:50:00',2.62),('16100','2014-02-04','14:55:00',1.62),('16100','2014-02-04','15:00:00',1.02),('16100','2014-02-04','15:25:00',1.38),('16100','2014-02-03','08:40:00',1),('16100','2014-02-03','09:05:00',1.01),('16100','2014-02-03','09:10:00',1.06),('16100','2014-02-03','09:15:00',1.22),('16100','2014-02-03','09:20:00',1.43),('16100','2014-02-03','09:25:00',1.55),('16100','2014-02-03','09:30:00',2.06),('16100','2014-02-03','09:35:00',2.57),('16100','2014-02-03','09:40:00',3.71),('16100','2014-02-03','09:45:00',4.71),('16100','2014-02-03','09:50:00',4.42),('16100','2014-02-03','09:55:00',4.43),('16100','2014-02-03','10:00:00',4.55),('16100','2014-02-03','10:05:00',4.71),('16100','2014-02-03','10:10:00',3.95),('16100','2014-02-03','10:15:00',3.61),('16100','2014-02-03','10:20:00',2.6),('16100','2014-02-03','10:25:00',5.01),('16100','2014-02-03','10:30:00',5.07),('16100','2014-02-03','10:35:00',3.54),('16100','2014-02-03','10:40:00',2.59),('16100','2014-02-03','10:45:00',4.85),('16100','2014-02-03','10:50:00',2.17),('16100','2014-02-03','10:55:00',2.03),('16100','2014-02-03','11:00:00',4.64),('16100','2014-02-03','11:05:00',4.75),('16100','2014-02-03','11:10:00',5.73),('16100','2014-02-03','11:15:00',2.56),('16100','2014-02-03','11:20:00',6.53),('16100','2014-02-03','11:25:00',4.64),('16100','2014-02-03','11:30:00',1.79),('16100','2014-02-03','11:35:00',2.22),('16100','2014-02-03','11:40:00',2.37),('16100','2014-02-03','11:45:00',2.12),('16100','2014-02-03','11:50:00',1.67),('16100','2014-02-03','11:55:00',1.9),('16100','2014-02-03','12:00:00',1.62),('16100','2014-02-03','12:05:00',1.79),('16100','2014-02-03','12:10:00',1.96),('16100','2014-02-03','12:15:00',1.51),('16100','2014-02-03','12:20:00',1.05),('16100','2014-02-03','12:45:00',1.18),('16100','2014-02-03','12:50:00',1.46),('16100','2014-02-03','12:55:00',1.91),('16100','2014-02-03','13:00:00',1.9),('16100','2014-02-03','13:05:00',2.1),('16100','2014-02-03','13:10:00',2.84),('16100','2014-02-03','13:15:00',3.41),('16100','2014-02-03','13:20:00',2.42),('16100','2014-02-03','13:25:00',1.73),('16100','2014-02-03','13:30:00',1.37),('16100','2014-02-03','13:40:00',1.08),('16100','2014-02-03','13:45:00',1.29),('16100','2014-02-03','13:50:00',1.33),('16100','2014-02-03','13:55:00',1.33),('16100','2014-02-03','14:10:00',1.12),('16100','2014-02-02','09:45:00',1.12),('16100','2014-02-02','09:50:00',1.45),('16100','2014-02-02','09:55:00',1.63),('16100','2014-02-02','10:00:00',1.32),('16100','2014-02-02','10:05:00',1.14),('16100','2014-02-02','10:10:00',1.27),('16100','2014-02-02','10:15:00',1.6),('16100','2014-02-02','10:20:00',1.65),('16100','2014-02-02','10:25:00',1.43),('16100','2014-02-02','10:30:00',1.46),('16100','2014-02-02','10:35:00',1.53),('16100','2014-02-02','10:40:00',1.53),('16100','2014-02-02','10:45:00',1.54),('16100','2014-02-02','10:50:00',1.48),('16100','2014-02-02','10:55:00',1.53),('16100','2014-02-02','11:00:00',1.55),('16100','2014-02-02','11:05:00',1.61),('16100','2014-02-02','11:10:00',1.6),('16100','2014-02-02','11:15:00',1.52),('16100','2014-02-02','11:20:00',1.39),('16100','2014-02-02','11:25:00',1.55),('16100','2014-02-02','11:30:00',1.59),('16100','2014-02-02','11:35:00',1.74),('16100','2014-02-02','11:40:00',1.93),('16100','2014-02-02','11:45:00',2.07),('16100','2014-02-02','11:50:00',2.12),('16100','2014-02-02','11:55:00',1.97),('16100','2014-02-02','12:00:00',1.76),('16100','2014-02-02','12:05:00',1.6),('16100','2014-02-02','12:10:00',1.57),('16100','2014-02-02','12:15:00',1.56),('16100','2014-02-02','12:20:00',1.63),('16100','2014-02-02','12:25:00',1.61),('16100','2014-02-02','12:30:00',1.56),('16100','2014-02-02','12:35:00',1.42),('16100','2014-02-02','12:40:00',1.49),('16100','2014-02-02','12:45:00',1.26),('16100','2014-02-02','14:30:00',1.24),('16100','2014-02-02','14:35:00',1.31),('16100','2014-02-02','14:40:00',1.29),('16100','2014-02-02','14:45:00',1.32),('16100','2014-02-02','14:50:00',1.24),('16100','2014-02-02','14:55:00',1.13),('16100','2014-02-01','11:50:00',1.05),('16100','2014-02-01','11:55:00',1.09),('16100','2014-02-01','12:00:00',1.15),('16100','2014-02-01','12:05:00',1.17),('16100','2014-02-01','12:10:00',1.16),('16100','2014-02-01','12:15:00',1.13),('16100','2014-02-01','12:20:00',1.08),('16100','2014-01-31','08:50:00',1.17),('16100','2014-01-31','09:25:00',1.01),('16100','2014-01-31','10:20:00',1.21),('16100','2014-01-31','10:25:00',1.17),('16100','2014-01-31','10:30:00',1.01),('16100','2014-01-31','10:40:00',1.09),('16100','2014-01-31','10:45:00',1.23),('16100','2014-01-31','10:50:00',1.32),('16100','2014-01-31','10:55:00',1.45),('16100','2014-01-31','11:00:00',1.9),('16100','2014-01-31','11:05:00',1.92),('16100','2014-01-31','11:10:00',2.12),('16100','2014-01-31','11:15:00',3.2),('16100','2014-01-31','11:20:00',4.07),('16100','2014-01-31','11:25:00',4.1),('16100','2014-01-31','11:30:00',3.75),('16100','2014-01-31','11:35:00',3.95),('16100','2014-01-31','11:40:00',3.7),('16100','2014-01-31','11:45:00',4),('16100','2014-01-31','11:50:00',4.24),('16100','2014-01-31','11:55:00',3.02),('16100','2014-01-31','12:00:00',2.1),('16100','2014-01-31','12:05:00',4.02),('16100','2014-01-31','12:10:00',4.26),('16100','2014-01-31','12:15:00',2.89),('16100','2014-01-31','12:20:00',3.38),('16100','2014-01-31','12:25:00',2.82),('16100','2014-01-31','12:30:00',4.77),('16100','2014-01-31','12:35:00',4.59),('16100','2014-01-31','12:40:00',4.51),('16100','2014-01-31','12:45:00',4.62),('16100','2014-01-31','12:50:00',3.79),('16100','2014-01-31','12:55:00',2.93),('16100','2014-01-31','13:00:00',1.96),('16100','2014-01-31','13:05:00',1.48),('16100','2014-01-31','13:20:00',1.47),('16100','2014-01-31','13:25:00',1.66),('16100','2014-01-31','13:30:00',1.4),('16100','2014-01-31','13:35:00',1.11),('16100','2014-01-30','10:25:00',1.09),('16100','2014-01-30','10:30:00',1.58),('16100','2014-01-30','10:35:00',1.65),('16100','2014-01-29','09:10:00',1.01),('16100','2014-01-29','09:15:00',1.06),('16100','2014-01-29','09:20:00',1.15),('16100','2014-01-29','09:25:00',1.19),('16100','2014-01-29','09:30:00',1.01),('16100','2014-01-29','09:40:00',1.13),('16100','2014-01-29','09:45:00',1.02),('16100','2014-01-29','09:50:00',1.69),('16100','2014-01-29','09:55:00',2.82),('16100','2014-01-29','10:00:00',3.72),('16100','2014-01-29','10:05:00',4.65),('16100','2014-01-29','10:10:00',4.6),('16100','2014-01-29','10:15:00',3.05),('16100','2014-01-29','10:20:00',2.48),('16100','2014-01-29','10:25:00',2.28),('16100','2014-01-29','10:30:00',2.64),('16100','2014-01-29','10:35:00',2.83),('16100','2014-01-29','10:40:00',2.82),('16100','2014-01-29','10:45:00',2.7),('16100','2014-01-29','10:50:00',2.75),('16100','2014-01-29','10:55:00',2.03),('16100','2014-01-29','11:00:00',2.54),('16100','2014-01-29','11:05:00',3.38),('16100','2014-01-29','11:10:00',4.55),('16100','2014-01-29','11:15:00',3.48),('16100','2014-01-29','11:20:00',2.33),('16100','2014-01-29','11:25:00',5.22),('16100','2014-01-29','11:30:00',5.48),('16100','2014-01-29','11:35:00',5.26),('16100','2014-01-29','11:40:00',6.11),('16100','2014-01-29','11:45:00',6.28),('16100','2014-01-29','11:50:00',6.15),('16100','2014-01-29','11:55:00',5.99),('16100','2014-01-29','12:00:00',5.56),('16100','2014-01-29','12:05:00',4.54),('16100','2014-01-29','12:10:00',3.46),('16100','2014-01-29','12:15:00',2.42),('16100','2014-01-29','12:20:00',3.94),('16100','2014-01-29','12:25:00',4.78),('16100','2014-01-29','12:30:00',5.06),('16100','2014-01-29','12:35:00',5.88),('16100','2014-01-29','12:40:00',5.99),('16100','2014-01-29','12:45:00',5.93),('16100','2014-01-29','12:50:00',5.92),('16100','2014-01-29','12:55:00',5.13),('16100','2014-01-29','13:00:00',6.06),('16100','2014-01-29','13:05:00',5.89),('16100','2014-01-29','13:10:00',6),('16100','2014-01-29','13:15:00',5.91),('16100','2014-01-29','13:20:00',5.87),('16100','2014-01-29','13:25:00',5.59),('16100','2014-01-29','13:30:00',4.79),('16100','2014-01-29','13:35:00',4.56),('16100','2014-01-29','13:40:00',4.63),('16100','2014-01-29','13:45:00',6),('16100','2014-01-29','13:50:00',5.87),('16100','2014-01-29','13:55:00',5.19),('16100','2014-01-29','14:00:00',4.5),('16100','2014-01-29','14:05:00',3.99),('16100','2014-01-29','14:10:00',4.38),('16100','2014-01-29','14:15:00',4.04),('16100','2014-01-29','14:20:00',3.25),('16100','2014-01-29','14:25:00',3.59),('16100','2014-01-29','14:30:00',3.61),('16100','2014-01-29','14:35:00',3.33),('16100','2014-01-29','14:40:00',3.5),('16100','2014-01-29','14:45:00',4.44),('16100','2014-01-29','14:50:00',4.48),('16100','2014-01-29','14:55:00',4.3),('16100','2014-01-29','15:00:00',4),('16100','2014-01-29','15:05:00',3.71),('16100','2014-01-29','15:10:00',3.66),('16100','2014-01-29','15:15:00',3.59),('16100','2014-01-29','15:20:00',3.37),('16100','2014-01-29','15:25:00',3.4),('16100','2014-01-29','15:30:00',2.06),('16100','2014-01-29','15:35:00',2.06),('16100','2014-01-29','15:40:00',2.2),('16100','2014-01-29','15:45:00',1.24),('16100','2014-01-28','09:10:00',1.11),('16100','2014-01-28','09:15:00',1.98),('16100','2014-01-28','09:20:00',2.27),('16100','2014-01-28','09:25:00',2.15),('16100','2014-01-28','09:30:00',2.63),('16100','2014-01-28','09:35:00',2.81),('16100','2014-01-28','09:40:00',2.26),('16100','2014-01-28','09:45:00',2.29),('16100','2014-01-28','09:50:00',1.79),('16100','2014-01-28','09:55:00',1.48),('16100','2014-01-28','10:00:00',1.78),('16100','2014-01-28','10:05:00',2.89),('16100','2014-01-28','10:10:00',2.33),('16100','2014-01-28','10:15:00',2.69),('16100','2014-01-28','10:20:00',4.58),('16100','2014-01-28','10:25:00',5.23),('16100','2014-01-28','10:30:00',3.26),('16100','2014-01-28','10:35:00',3.26),('16100','2014-01-28','10:40:00',3.08),('16100','2014-01-28','10:45:00',2.77),('16100','2014-01-28','10:50:00',2.83),('16100','2014-01-28','10:55:00',2.78),('16100','2014-01-28','11:00:00',2.98),('16100','2014-01-28','11:05:00',3.88),('16100','2014-01-28','11:10:00',3.88),('16100','2014-01-28','11:15:00',3.48),('16100','2014-01-28','11:20:00',4.1),('16100','2014-01-28','11:25:00',2.99),('16100','2014-01-28','11:30:00',3.65),('16100','2014-01-28','11:35:00',6.99),('16100','2014-01-28','11:40:00',2.86),('16100','2014-01-28','11:45:00',2.23),('16100','2014-01-28','11:50:00',1.37),('16100','2014-01-28','12:15:00',1.01),('16100','2014-01-28','12:20:00',1.33),('16100','2014-01-28','12:35:00',1.86),('16100','2014-01-28','12:40:00',2.24),('16100','2014-01-28','12:45:00',3),('16100','2014-01-28','12:50:00',5.62),('16100','2014-01-28','12:55:00',5.58),('16100','2014-01-28','13:00:00',5.23),('16100','2014-01-28','13:05:00',4.68),('16100','2014-01-28','13:10:00',2.38),('16100','2014-01-28','13:15:00',1.32),('16100','2014-01-28','13:30:00',1.26),('16100','2014-01-28','13:35:00',5.14),('16100','2014-01-28','13:40:00',6.33),('16100','2014-01-28','13:45:00',6.11),('16100','2014-01-28','13:50:00',5.97),('16100','2014-01-28','13:55:00',5.87),('16100','2014-01-28','14:00:00',5.22),('16100','2014-01-28','14:05:00',2.07),('16100','2014-01-28','14:10:00',1.55),('16100','2014-01-28','14:15:00',1.13),('16100','2014-01-28','14:40:00',1.2),('16100','2014-01-28','15:20:00',1.15),('16100','2014-01-27','08:50:00',1.29),('16100','2014-01-27','08:55:00',1.76),('16100','2014-01-27','09:00:00',1.76),('16100','2014-01-27','09:05:00',2.51),('16100','2014-01-27','09:10:00',2.26),('16100','2014-01-27','09:15:00',2),('16100','2014-01-27','09:20:00',2.24),('16100','2014-01-27','09:25:00',2.71),('16100','2014-01-27','09:30:00',2.9),('16100','2014-01-27','09:35:00',2.58),('16100','2014-01-27','09:40:00',2.54),('16100','2014-01-27','09:45:00',2.82),('16100','2014-01-27','09:50:00',3.69),('16100','2014-01-27','09:55:00',3.85),('16100','2014-01-27','10:00:00',3.66),('16100','2014-01-27','10:05:00',3.91),('16100','2014-01-27','10:10:00',4.41),('16100','2014-01-27','10:15:00',4.74),('16100','2014-01-27','10:20:00',5.04),('16100','2014-01-27','10:25:00',5.16),('16100','2014-01-27','10:30:00',5.23),('16100','2014-01-27','10:35:00',5.33),('16100','2014-01-27','10:40:00',5.59),('16100','2014-01-27','10:45:00',4.95),('16100','2014-01-27','10:50:00',3.06),('16100','2014-01-27','10:55:00',1.81),('16100','2014-01-27','11:00:00',2.19),('16100','2014-01-27','11:05:00',5.07),('16100','2014-01-27','11:10:00',5.1),('16100','2014-01-27','11:15:00',2.39),('16100','2014-01-27','11:20:00',2.26),('16100','2014-01-27','11:25:00',4.92),('16100','2014-01-27','11:30:00',3.47),('16100','2014-01-27','11:35:00',5.68),('16100','2014-01-27','11:40:00',4.3),('16100','2014-01-27','11:45:00',4.31),('16100','2014-01-27','11:50:00',4.93),('16100','2014-01-27','11:55:00',4.87),('16100','2014-01-27','12:00:00',5.09),('16100','2014-01-27','12:05:00',4.76),('16100','2014-01-27','12:10:00',4.91),('16100','2014-01-27','12:15:00',3.32),('16100','2014-01-27','12:20:00',2.39),('16100','2014-01-27','12:25:00',2),('16100','2014-01-27','12:30:00',1.94),('16100','2014-01-27','12:35:00',2.73),('16100','2014-01-27','12:40:00',2.59),('16100','2014-01-27','12:45:00',6.59),('16100','2014-01-27','12:50:00',6.97),('16100','2014-01-27','12:55:00',3.53),('16100','2014-01-27','13:00:00',6.75),('16100','2014-01-27','13:05:00',5.31),('16100','2014-01-27','13:10:00',5.59),('16100','2014-01-27','13:15:00',5.54),('16100','2014-01-27','13:20:00',6.49),('16100','2014-01-27','13:25:00',5.73),('16100','2014-01-27','13:30:00',5.39),('16100','2014-01-27','13:35:00',6.29),('16100','2014-01-27','13:40:00',6.28),('16100','2014-01-27','13:45:00',6.14),('16100','2014-01-27','13:50:00',5.94),('16100','2014-01-27','13:55:00',5.75),('16100','2014-01-27','14:00:00',5.58),('16100','2014-01-27','14:05:00',5.49),('16100','2014-01-27','14:10:00',5.4),('16100','2014-01-27','14:15:00',5.3),('16100','2014-01-27','14:20:00',5.21),('16100','2014-01-27','14:25:00',5.11),('16100','2014-01-27','14:30:00',5.07),('16100','2014-01-27','14:35:00',4.85),('16100','2014-01-27','14:40:00',4.79),('16100','2014-01-27','14:45:00',4.58),('16100','2014-01-27','14:50:00',4.45),('16100','2014-01-27','14:55:00',4.36),('16100','2014-01-27','15:00:00',4.21),('16100','2014-01-27','15:05:00',4.08),('16100','2014-01-27','15:10:00',3.92),('16100','2014-01-27','15:15:00',3.78),('16100','2014-01-27','15:20:00',3.61),('16100','2014-01-27','15:25:00',3.44),('16100','2014-01-27','15:30:00',3.29),('16100','2014-01-27','15:35:00',3.15),('16100','2014-01-27','15:40:00',2.98),('16100','2014-01-27','15:45:00',2.83),('16100','2014-01-27','15:50:00',2.68),('16100','2014-01-27','15:55:00',2.49),('16100','2014-01-27','16:00:00',2.31),('16100','2014-01-27','16:05:00',2.12),('16100','2014-01-27','16:10:00',1.93),('16100','2014-01-27','16:15:00',1.73),('16100','2014-01-27','16:20:00',1.57),('16100','2014-01-27','16:25:00',1.28),('16100','2014-01-26','09:40:00',1.03),('16100','2014-01-26','09:45:00',1.06),('16100','2014-01-26','09:50:00',1.17),('16100','2014-01-26','10:00:00',1.05),('16100','2014-01-26','10:05:00',1.09),('16100','2014-01-26','10:10:00',1.09),('16100','2014-01-26','10:15:00',1.11),('16100','2014-01-26','10:20:00',1.18),('16100','2014-01-26','10:25:00',1.29),('16100','2014-01-26','10:30:00',1.06),('16100','2014-01-26','10:35:00',1.13),('16100','2014-01-26','10:40:00',1.1),('16100','2014-01-26','10:45:00',1.07),('16100','2014-01-26','10:55:00',1.23),('16100','2014-01-26','11:00:00',1.46),('16100','2014-01-26','11:05:00',1.4),('16100','2014-01-26','11:10:00',1.06),('16100','2014-01-26','11:15:00',1.27),('16100','2014-01-26','11:20:00',1.27),('16100','2014-01-26','11:25:00',1.36),('16100','2014-01-26','11:30:00',1.09),('16100','2014-01-26','11:35:00',1.17),('16100','2014-01-26','12:50:00',1.14),('16100','2014-01-26','12:55:00',1.18),('16100','2014-01-26','13:00:00',1.02),('16100','2014-01-26','13:05:00',1.01),('16273','2014-05-05','07:20:00',1.07),('16273','2014-05-05','07:35:00',1.36),('16273','2014-05-05','07:40:00',1.45),('16273','2014-05-05','07:45:00',1.53),('16273','2014-05-05','07:50:00',1.62),('16273','2014-05-05','07:55:00',1.71),('16273','2014-05-05','08:00:00',1.8),('16273','2014-05-05','08:05:00',1.88),('16273','2014-05-05','08:10:00',1.96),('16273','2014-05-05','08:15:00',2.03),('16273','2014-05-05','08:20:00',2.11),('16273','2014-05-05','08:25:00',2.2),('16273','2014-05-05','08:30:00',2.28),('16273','2014-05-05','08:35:00',2.35),('16273','2014-05-05','08:40:00',2.42),('16273','2014-05-05','08:45:00',2.49),('16273','2014-05-05','08:50:00',2.58),('16273','2014-05-05','08:55:00',2.64),('16273','2014-05-05','09:00:00',2.71),('16273','2014-05-05','09:05:00',2.79),('16273','2014-05-05','09:10:00',2.84),('16273','2014-05-05','09:15:00',2.91),('16273','2014-05-05','09:20:00',2.97),('16273','2014-05-05','09:25:00',3.04),('16273','2014-05-05','09:30:00',3.08),('16273','2014-05-05','09:35:00',3.15),('16273','2014-05-05','09:40:00',3.21),('16273','2014-05-05','09:45:00',3.28),('16273','2014-05-05','09:50:00',3.32),('16273','2014-05-05','09:55:00',3.37),('16273','2014-05-05','10:00:00',3.41),('16273','2014-05-05','10:05:00',3.43),('16273','2014-05-05','10:10:00',3.49),('16273','2014-05-05','10:15:00',3.53),('16273','2014-05-05','10:20:00',3.58),('16273','2014-05-05','10:25:00',3.62),('16273','2014-05-05','10:30:00',3.62),('16273','2014-05-05','10:35:00',3.58),('16273','2014-05-05','10:40:00',3.65),('16273','2014-05-05','10:45:00',3.17),('16273','2014-05-05','10:50:00',3.79),('16273','2014-05-05','10:55:00',3.78),('16273','2014-05-05','11:00:00',3.83),('16273','2014-05-05','11:05:00',3.83),('16273','2014-05-05','11:10:00',3.85),('16273','2014-05-05','11:15:00',3.84),('16273','2014-05-05','11:20:00',3.88),('16273','2014-05-05','11:25:00',3.91),('16273','2014-05-05','11:30:00',3.12),('16273','2014-05-05','11:35:00',2.86),('16273','2014-05-05','11:40:00',2.9),('16273','2014-05-05','11:45:00',3.65),('16273','2014-05-05','11:50:00',1),('16273','2014-05-05','11:55:00',1.87),('16273','2014-05-05','12:00:00',3.32),('16273','2014-05-05','12:05:00',4.28),('16273','2014-05-05','12:10:00',4.3),('16273','2014-05-05','12:15:00',3.17),('16273','2014-05-05','12:20:00',4.14),('16273','2014-05-05','12:25:00',4.06),('16273','2014-05-05','12:30:00',4.08),('16273','2014-05-05','12:35:00',4.05),('16273','2014-05-05','12:40:00',4.02),('16273','2014-05-05','12:45:00',3.96),('16273','2014-05-05','12:50:00',3.94),('16273','2014-05-05','12:55:00',3.92),('16273','2014-05-05','13:00:00',3.89),('16273','2014-05-05','13:05:00',3.86),('16273','2014-05-05','13:10:00',3.34),('16273','2014-05-05','13:15:00',1.45),('16273','2014-05-05','13:35:00',1.34),('16273','2014-05-05','13:40:00',3.31),('16273','2014-05-05','13:45:00',2.39),('16273','2014-05-05','13:50:00',1.71),('16273','2014-05-05','13:55:00',2.08),('16273','2014-05-05','14:00:00',3.36),('16273','2014-05-05','14:05:00',4.31),('16273','2014-05-05','14:10:00',4.2),('16273','2014-05-05','14:15:00',3.89),('16273','2014-05-05','14:20:00',3.71),('16273','2014-05-05','14:25:00',3.64),('16273','2014-05-05','14:30:00',3.56),('16273','2014-05-05','14:35:00',3.55),('16273','2014-05-05','14:40:00',3.57),('16273','2014-05-05','14:45:00',3.51),('16273','2014-05-05','14:50:00',3.43),('16273','2014-05-05','14:55:00',3.4),('16273','2014-05-05','15:00:00',3.28),('16273','2014-05-05','15:05:00',3.24),('16273','2014-05-05','15:10:00',3.17),('16273','2014-05-05','15:15:00',3.09),('16273','2014-05-05','15:20:00',3.04),('16273','2014-05-05','15:25:00',2.98),('16273','2014-05-05','15:30:00',2.94),('16273','2014-05-05','15:35:00',2.91),('16273','2014-05-05','15:40:00',2.83),('16273','2014-05-05','15:45:00',2.79),('16273','2014-05-05','15:50:00',2.74),('16273','2014-05-05','15:55:00',2.65),('16273','2014-05-05','16:00:00',2.56),('16273','2014-05-05','16:05:00',2.52),('16273','2014-05-05','16:10:00',2.46),('16273','2014-05-05','16:15:00',2.36),('16273','2014-05-05','16:20:00',2.32),('16273','2014-05-05','16:25:00',2.24),('16273','2014-05-05','16:30:00',2.16),('16273','2014-05-05','16:35:00',2.08),('16273','2014-05-05','16:40:00',2.01),('16273','2014-05-05','16:45:00',1.91),('16273','2014-05-05','16:50:00',1.85),('16273','2014-05-05','16:55:00',1.78),('16273','2014-05-05','17:00:00',1.72),('16273','2014-05-05','17:05:00',1.63),('16273','2014-05-05','17:10:00',1.55),('16273','2014-05-05','17:15:00',1.46),('16273','2014-05-05','17:20:00',1.39),('16273','2014-05-05','17:25:00',1.32),('16273','2014-05-05','17:30:00',1.26),('16273','2014-05-05','17:35:00',1.21),('16273','2014-05-05','17:40:00',1.1),('16273','2014-05-05','17:45:00',1.01),('16273','2014-04-26','09:10:00',1.11),('16273','2014-04-26','09:15:00',1.02),('16273','2014-04-26','09:45:00',1.01),('16273','2014-04-26','09:50:00',1.09),('16273','2014-04-26','09:55:00',1.08),('16273','2014-04-26','10:00:00',1.37),('16273','2014-04-26','10:05:00',1.64),('16273','2014-04-26','10:10:00',1.76),('16273','2014-04-26','10:15:00',1.46),('16273','2014-04-26','10:20:00',1.46),('16273','2014-04-26','10:25:00',1.72),('16273','2014-04-26','10:30:00',1.8),('16273','2014-04-26','10:35:00',1.68),('16273','2014-04-26','10:40:00',1.8),('16273','2014-04-26','10:45:00',1.5),('16273','2014-04-26','10:50:00',1.86),('16273','2014-04-26','10:55:00',2.68),('16273','2014-04-26','11:00:00',3.69),('16273','2014-04-26','11:05:00',3.86),('16273','2014-04-26','11:10:00',3.49),('16273','2014-04-26','11:15:00',3.53),('16273','2014-04-26','11:20:00',3.54),('16273','2014-04-26','11:25:00',3.39),('16273','2014-04-26','11:30:00',2.99),('16273','2014-04-26','11:35:00',3.2),('16273','2014-04-26','11:40:00',3.13),('16273','2014-04-26','11:45:00',2.89),('16273','2014-04-26','11:50:00',3.26),('16273','2014-04-26','11:55:00',3.39),('16273','2014-04-26','12:00:00',2.9),('16273','2014-04-26','12:05:00',1.54),('16273','2014-04-26','12:10:00',1.97),('16273','2014-04-26','12:15:00',2.88),('16273','2014-04-26','12:20:00',2.53),('16273','2014-04-26','12:25:00',2.13),('16273','2014-04-26','12:30:00',2.5),('16273','2014-04-26','12:35:00',2.43),('16273','2014-04-26','12:40:00',2.65),('16273','2014-04-26','12:45:00',2.56),('16273','2014-04-26','12:50:00',2.67),('16273','2014-04-26','12:55:00',3.1),('16273','2014-04-26','13:00:00',2.91),('16273','2014-04-26','13:05:00',2.3),('16273','2014-04-26','13:10:00',1.61),('16273','2014-04-26','13:15:00',2.31),('16273','2014-04-26','13:20:00',1.23),('16273','2014-04-26','13:25:00',2.71),('16273','2014-04-26','13:30:00',2.18),('16273','2014-04-26','13:35:00',2.24),('16273','2014-04-26','13:40:00',2.79),('16273','2014-04-26','13:45:00',1.28),('16273','2014-04-26','13:50:00',1),('16273','2014-04-26','14:00:00',1.57),('16273','2014-04-26','14:05:00',1.83),('16273','2014-04-26','14:10:00',1.94),('16273','2014-04-26','14:15:00',3.13),('16273','2014-04-26','14:20:00',1.76),('16273','2014-04-26','14:50:00',1.44),('16273','2014-04-26','14:55:00',1.23),('16273','2014-01-26','09:00:00',1.59),('16273','2014-01-26','09:05:00',1.3),('16273','2014-01-26','09:25:00',1.53),('16273','2014-01-26','09:30:00',1.32),('16273','2014-01-26','09:45:00',1.13),('16273','2014-01-26','10:05:00',1.34),('16273','2014-01-26','10:10:00',1.43),('16273','2014-01-26','10:15:00',1.39),('16273','2014-01-26','10:30:00',1.12),('16273','2014-01-26','10:50:00',1.01),('16273','2014-01-26','11:20:00',1.15),('16273','2014-01-26','11:25:00',1.26),('16273','2014-01-26','12:10:00',1.14),('16273','2014-01-26','12:15:00',1.26),('16273','2014-01-26','12:20:00',1.51),('16273','2014-01-26','12:25:00',1.72),('16273','2014-01-26','12:30:00',1.54),('16273','2014-01-26','12:35:00',1.18),('16273','2014-01-26','13:00:00',1.22),('16273','2014-01-26','13:05:00',1.24),('16273','2014-01-26','13:10:00',1.13),('16273','2014-01-26','13:15:00',1.3),('16273','2014-01-26','13:20:00',1.38),('16273','2014-01-26','13:25:00',1.19),('16273','2014-01-26','13:30:00',1.05),('16273','2014-01-26','13:45:00',1.08),('16273','2014-01-25','09:45:00',1.06),('16273','2014-01-25','09:50:00',1.37),('16273','2014-01-25','09:55:00',1.63),('16273','2014-01-25','10:00:00',1.7),('16273','2014-01-25','10:05:00',3.03),('16273','2014-01-25','10:10:00',2.43),('16273','2014-01-25','10:15:00',2.7),('16273','2014-01-25','10:20:00',2.94),('16273','2014-01-25','10:25:00',2.71),('16273','2014-01-25','10:30:00',2.85),('16273','2014-01-25','10:35:00',2.1),('16273','2014-01-25','10:40:00',1.74),('16273','2014-01-25','10:45:00',1.93),('16273','2014-01-25','10:50:00',2.5),('16273','2014-01-25','10:55:00',2.89),('16273','2014-01-25','11:00:00',3.11),('16273','2014-01-25','11:05:00',3.23),('16273','2014-01-25','11:10:00',2.93),('16273','2014-01-25','11:15:00',3.14),('16273','2014-01-25','11:20:00',3.1),('16273','2014-01-25','11:25:00',1.61),('16273','2014-01-25','11:30:00',1.42),('16273','2014-01-25','11:35:00',1.52),('16273','2014-01-25','11:40:00',1.59),('16273','2014-01-25','11:45:00',1.6),('16273','2014-01-25','11:50:00',1.55),('16273','2014-01-25','11:55:00',1.52),('16273','2014-01-25','12:00:00',1.68),('16273','2014-01-25','12:05:00',2.01),('16273','2014-01-25','12:10:00',1.94),('16273','2014-01-25','12:15:00',1.6),('16273','2014-01-25','12:20:00',1.66),('16273','2014-01-25','12:25:00',1.71),('16273','2014-01-25','12:30:00',1.81),('16273','2014-01-25','12:35:00',1.92),('16273','2014-01-25','12:40:00',2),('16273','2014-01-25','12:45:00',2),('16273','2014-01-25','12:50:00',2.47),('16273','2014-01-25','12:55:00',2.61),('16273','2014-01-25','13:00:00',2.54),('16273','2014-01-25','13:05:00',2.66),('16273','2014-01-25','13:10:00',2.59),('16273','2014-01-25','13:15:00',2.58),('16273','2014-01-25','13:20:00',2.55),('16273','2014-01-25','13:25:00',2.56),('16273','2014-01-25','13:30:00',2.53),('16273','2014-01-25','13:35:00',2.52),('16273','2014-01-25','13:40:00',2.51),('16273','2014-01-25','13:45:00',2.5),('16273','2014-01-25','13:50:00',2.25),('16273','2014-01-25','13:55:00',1.96),('16273','2014-01-25','14:00:00',2.22),('16273','2014-01-25','14:05:00',2.27),('16273','2014-01-25','14:10:00',1.96),('16273','2014-01-25','14:15:00',1.87),('16273','2014-01-25','14:20:00',1.35),('16273','2014-01-25','14:25:00',1.95),('16273','2014-01-25','14:30:00',1.7),('16273','2014-01-25','14:35:00',1.96),('16273','2014-01-25','14:45:00',1.01),('16273','2014-01-25','14:50:00',2.01),('16273','2014-01-25','14:55:00',1.72),('16273','2014-01-25','15:10:00',1.32),('16273','2014-01-25','15:15:00',1.25),('16273','2014-01-25','15:20:00',1.17),('16273','2014-01-25','15:25:00',1.03),('16273','2014-01-24','10:00:00',1.18),('16273','2014-01-24','10:05:00',1.68),('16273','2014-01-24','10:10:00',1.58),('16273','2014-01-24','10:15:00',2.55),('16273','2014-01-24','10:20:00',1.07),('16273','2014-01-24','10:25:00',1.89),('16273','2014-01-24','10:30:00',2.45),('16273','2014-01-24','10:35:00',2.24),('16273','2014-01-24','10:40:00',1.27),('16273','2014-01-24','10:45:00',1.52),('16273','2014-01-24','10:50:00',1.07),('16273','2014-01-24','11:15:00',1.09),('16273','2014-01-24','11:25:00',1.51),('16273','2014-01-24','11:30:00',1.03),('16273','2014-01-24','11:35:00',1.18),('16273','2014-01-24','11:40:00',3.3),('16273','2014-01-24','11:45:00',2.48),('16273','2014-01-24','11:50:00',1.16),('16273','2014-01-24','11:55:00',1.24),('16273','2014-01-24','12:00:00',3.35),('16273','2014-01-24','12:05:00',2.72),('16273','2014-01-24','12:10:00',1.34),('16273','2014-01-24','12:15:00',2.18),('16273','2014-01-24','12:20:00',2.06),('16273','2014-01-24','12:25:00',1.14),('16273','2014-01-24','12:35:00',2.12),('16273','2014-01-24','12:40:00',2.26),('16273','2014-01-24','12:45:00',1.53),('16273','2014-01-24','12:50:00',1.29),('16273','2014-01-24','12:55:00',1.57),('16273','2014-01-24','13:10:00',1.66),('16273','2014-01-24','13:15:00',1.19),('16273','2014-01-24','13:20:00',1.14),('16273','2014-01-24','13:25:00',1.79),('16273','2014-01-24','13:30:00',1.13),('16273','2014-01-24','13:35:00',1.37),('16273','2014-01-24','13:40:00',2.15),('16273','2014-01-24','13:45:00',1.71),('16273','2014-01-24','13:50:00',1.37),('16273','2014-01-24','14:00:00',1.93),('16273','2014-01-24','14:05:00',2.38),('16273','2014-01-24','14:10:00',1.75),('16273','2014-01-24','14:15:00',1.84),('16273','2014-01-24','14:20:00',2.1),('16273','2014-01-24','14:25:00',1.86),('16273','2014-01-24','14:40:00',1.72),('16273','2014-01-24','14:45:00',1.12),('16273','2014-01-23','12:15:00',1.06),('16273','2014-01-23','12:20:00',1.01),('16273','2014-01-23','12:30:00',1.08),('16273','2014-01-23','12:35:00',1.06),('16273','2014-01-22','11:25:00',1.08),('16273','2014-01-22','11:30:00',1.11),('16273','2014-01-22','16:05:00',1.04),('16273','2014-01-21','09:50:00',1.87),('16273','2014-01-21','10:25:00',1.17),('16273','2014-01-21','11:30:00',2.02),('16273','2014-01-21','11:35:00',2.5),('16273','2014-01-21','11:40:00',1.32),('16273','2014-01-21','11:50:00',1.09),('16273','2014-01-21','11:55:00',1.93),('16273','2014-01-21','12:00:00',1.6),('16273','2014-01-21','12:05:00',1.45),('16273','2014-01-21','12:10:00',1.72),('16273','2014-01-21','12:15:00',1.55),('16273','2014-01-21','12:20:00',1.74),('16273','2014-01-21','12:25:00',1.31),('16273','2014-01-21','12:30:00',1.03),('16273','2014-01-21','12:35:00',1.03),('16273','2014-01-21','13:10:00',1.13),('16273','2014-01-21','15:35:00',1.05),('16273','2014-01-20','11:55:00',1.12),('16273','2014-01-20','12:00:00',1.1),('16273','2014-01-20','12:45:00',1.59),('16273','2014-01-20','12:50:00',1.78),('16273','2014-01-20','13:25:00',1.33),('16273','2014-01-20','13:30:00',1.07),('16273','2014-01-20','14:10:00',1.14),('16273','2014-01-20','14:15:00',1.36),('16273','2014-01-19','11:50:00',1.16),('16273','2014-01-19','11:55:00',1.12),('16273','2014-01-19','13:05:00',1.07),('16273','2014-01-19','13:10:00',1.08),('16273','2014-01-19','14:15:00',1.09),('16273','2014-01-19','14:20:00',1.42),('16273','2014-01-19','14:25:00',1.23),('16273','2014-01-19','14:30:00',1.02),('16273','2014-01-18','09:45:00',1.37),('16273','2014-01-18','09:50:00',1.32),('16273','2014-01-18','09:55:00',1.65),('16273','2014-01-18','10:00:00',2.14),('16273','2014-01-18','10:05:00',1.47),('16273','2014-01-18','10:10:00',2.72),('16273','2014-01-18','10:15:00',2.98),('16273','2014-01-18','10:20:00',2.34),('16273','2014-01-18','10:25:00',2.36),('16273','2014-01-18','10:30:00',1.72),('16273','2014-01-18','10:35:00',1.84),('16273','2014-01-18','10:40:00',1.67),('16273','2014-01-18','10:45:00',1.05),('16273','2014-01-18','10:50:00',1.08),('16273','2014-01-18','11:00:00',2.02),('16273','2014-01-18','11:05:00',3.03),('16273','2014-01-18','11:10:00',2.43),('16273','2014-01-18','11:15:00',2.79),('16273','2014-01-18','11:20:00',2.83),('16273','2014-01-18','11:25:00',2.8),('16273','2014-01-18','11:30:00',2.82),('16273','2014-01-18','11:35:00',2.92),('16273','2014-01-18','11:40:00',1.66),('16273','2014-01-18','11:45:00',1.5),('16273','2014-01-18','11:50:00',1.31),('16273','2014-01-18','11:55:00',2.65),('16273','2014-01-18','12:00:00',2.1),('16273','2014-01-18','12:05:00',2.38),('16273','2014-01-18','12:10:00',2.74),('16273','2014-01-18','12:15:00',2.69),('16273','2014-01-18','12:20:00',2.71),('16273','2014-01-18','12:25:00',2.67),('16273','2014-01-18','12:30:00',2.69),('16273','2014-01-18','12:35:00',2.67),('16273','2014-01-18','12:40:00',2.72),('16273','2014-01-18','12:45:00',2.6),('16273','2014-01-18','12:50:00',2.33),('16273','2014-01-18','12:55:00',1.99),('16273','2014-01-18','13:00:00',2.1),('16273','2014-01-18','13:05:00',1.78),('16273','2014-01-18','13:10:00',2.32),('16273','2014-01-18','13:15:00',2.54),('16273','2014-01-18','13:20:00',2.59),('16273','2014-01-18','13:25:00',1.53),('16273','2014-01-18','13:30:00',2.35),('16273','2014-01-18','13:35:00',2.44),('16273','2014-01-18','13:40:00',1.93),('16273','2014-01-18','13:45:00',2.29),('16273','2014-01-18','13:50:00',1.54),('16273','2014-01-18','13:55:00',1.59),('16273','2014-01-18','14:00:00',2.11),('16273','2014-01-18','14:05:00',1.95),('16273','2014-01-18','14:10:00',1.7),('16273','2014-01-18','14:15:00',1.79),('16273','2014-01-18','14:20:00',1.77),('16273','2014-01-18','14:25:00',1.69),('16273','2014-01-18','14:30:00',1.63),('16273','2014-01-18','14:35:00',1.55),('16273','2014-01-18','14:40:00',1.49),('16273','2014-01-18','14:45:00',1.42),('16273','2014-01-18','14:50:00',1.18),('16273','2014-01-17','08:45:00',1.04),('16273','2014-01-17','08:55:00',1.13),('16273','2014-01-17','09:00:00',1.57),('16273','2014-01-17','09:05:00',1.3),('16273','2014-01-17','09:10:00',1.6),('16273','2014-01-17','09:25:00',1.44),('16273','2014-01-17','09:30:00',1.74),('16273','2014-01-17','09:35:00',1.78),('16273','2014-04-25','07:40:00',1.03),('16273','2014-04-25','07:45:00',1.18),('16273','2014-04-25','07:50:00',1.22),('16273','2014-04-25','07:55:00',1.21),('16273','2014-04-25','08:00:00',1.26),('16273','2014-04-25','08:05:00',1.35),('16273','2014-04-25','08:10:00',1.38),('16273','2014-04-25','08:15:00',1.17),('16273','2014-04-25','08:20:00',1.37),('16273','2014-04-25','08:25:00',1.54),('16273','2014-04-25','08:30:00',2.03),('16273','2014-04-25','08:35:00',1.92),('16273','2014-04-25','08:40:00',2.2),('16273','2014-04-25','08:45:00',2.3),('16273','2014-04-25','08:50:00',2.28),('16273','2014-04-25','08:55:00',1.81),('16273','2014-04-25','09:00:00',1.3),('16273','2014-04-25','09:05:00',2.08),('16273','2014-04-25','09:10:00',1.71),('16273','2014-04-25','09:15:00',1.49),('16273','2014-04-25','09:20:00',1.65),('16273','2014-04-25','09:25:00',1.28),('16273','2014-04-25','09:30:00',1.07),('16273','2014-04-25','09:35:00',1.04),('16273','2014-04-25','09:45:00',1.22),('16273','2014-04-25','09:50:00',1.69),('16273','2014-04-25','09:55:00',1.45),('16273','2014-04-25','10:00:00',1.1),('16273','2014-04-25','10:10:00',1.09),('16273','2014-04-25','10:15:00',1.07),('16273','2014-04-25','10:20:00',1.14),('16273','2014-04-25','10:25:00',1.29),('16273','2014-04-25','10:30:00',2.36),('16273','2014-04-25','10:35:00',3.08),('16273','2014-04-25','10:40:00',1.98),('16273','2014-04-25','10:45:00',1.3),('16273','2014-04-25','10:50:00',3.51),('16273','2014-04-25','10:55:00',2.84),('16273','2014-04-25','11:00:00',1.56),('16273','2014-04-25','11:05:00',1.45),('16273','2014-04-25','11:10:00',1.36),('16273','2014-04-25','11:15:00',1),('16273','2014-04-25','11:20:00',1.05),('16273','2014-04-25','11:25:00',2.96),('16273','2014-04-25','11:30:00',4.01),('16273','2014-04-25','11:35:00',3.9),('16273','2014-04-25','11:40:00',2.64),('16273','2014-04-25','11:45:00',4.01),('16273','2014-04-25','11:50:00',4.03),('16273','2014-04-25','11:55:00',4),('16273','2014-04-25','12:00:00',4.08),('16273','2014-04-25','12:05:00',1.61),('16273','2014-04-25','12:10:00',3.24),('16273','2014-04-25','12:15:00',3.96),('16273','2014-04-25','12:20:00',2.16),('16273','2014-04-25','12:25:00',1.34),('16273','2014-04-25','12:30:00',1.36),('16273','2014-04-25','12:35:00',1.36),('16273','2014-04-25','12:40:00',3.48),('16273','2014-04-25','12:45:00',4.35),('16273','2014-04-25','12:50:00',4.19),('16273','2014-04-25','12:55:00',2.8),('16273','2014-04-25','13:00:00',4.08),('16273','2014-04-25','13:05:00',3.98),('16273','2014-04-25','13:10:00',3.92),('16273','2014-04-25','13:15:00',3.86),('16273','2014-04-25','13:20:00',3.92),('16273','2014-04-25','13:25:00',3.83),('16273','2014-04-25','13:30:00',3.87),('16273','2014-04-25','13:35:00',3.95),('16273','2014-04-25','13:40:00',3.86),('16273','2014-04-25','13:45:00',3),('16273','2014-04-25','13:50:00',3.5),('16273','2014-04-25','13:55:00',3.64),('16273','2014-04-25','14:00:00',3.58),('16273','2014-04-25','14:05:00',3.55),('16273','2014-04-25','14:10:00',3.51),('16273','2014-04-25','14:15:00',3.51),('16273','2014-04-25','14:20:00',3.46),('16273','2014-04-25','14:25:00',3.43),('16273','2014-04-25','14:30:00',3.38),('16273','2014-04-25','14:35:00',3.34),('16273','2014-04-25','14:40:00',3.29),('16273','2014-04-25','14:45:00',3.25),('16273','2014-04-25','14:50:00',3.21),('16273','2014-04-25','14:55:00',3.17),('16273','2014-04-25','15:00:00',3.05),('16273','2014-04-25','15:05:00',3.04),('16273','2014-04-25','15:10:00',2.98),('16273','2014-04-25','15:15:00',2.95),('16273','2014-04-25','15:20:00',2.9),('16273','2014-04-25','15:25:00',2.87),('16273','2014-04-25','15:30:00',2.82),('16273','2014-04-25','15:35:00',2.73),('16273','2014-04-25','15:40:00',2.64),('16273','2014-04-25','15:45:00',2.57),('16273','2014-04-25','15:50:00',2.58),('16273','2014-04-25','15:55:00',2.42),('16273','2014-04-25','16:00:00',2.3),('16273','2014-04-25','16:05:00',2.36),('16273','2014-04-25','16:10:00',2.08),('16273','2014-04-25','16:15:00',1.88),('16273','2014-04-25','16:20:00',2.02),('16273','2014-04-25','16:25:00',1.92),('16273','2014-04-25','16:30:00',2),('16273','2014-04-25','16:35:00',2),('16273','2014-04-25','16:40:00',1.94),('16273','2014-04-25','16:45:00',1.71),('16273','2014-04-25','16:50:00',1.33),('16273','2014-04-25','16:55:00',1.31),('16273','2014-04-25','17:00:00',1.33),('16273','2014-04-25','17:05:00',1.37),('16273','2014-04-25','17:10:00',1.48),('16273','2014-04-25','17:15:00',1.16),('16273','2014-04-25','17:25:00',1.12),('16273','2014-01-16','08:55:00',1.06),('16273','2014-01-16','09:00:00',1.17),('16273','2014-01-16','09:05:00',1.29),('16273','2014-01-16','09:10:00',1.38),('16273','2014-01-16','09:15:00',1.88),('16273','2014-01-16','09:20:00',1.98),('16273','2014-01-16','09:25:00',2.03),('16273','2014-01-16','09:30:00',2.06),('16273','2014-01-16','09:35:00',2.05),('16273','2014-01-16','09:40:00',1.81),('16273','2014-01-16','09:45:00',1.33),('16273','2014-01-16','09:50:00',1.05),('16273','2014-01-16','10:05:00',1.2),('16273','2014-01-16','10:10:00',1.36),('16273','2014-01-16','10:15:00',1.54),('16273','2014-01-16','10:20:00',1.87),('16273','2014-01-16','10:25:00',2.58),('16273','2014-01-16','10:30:00',2.89),('16273','2014-01-16','10:35:00',1.95),('16273','2014-01-16','10:40:00',1.77),('16273','2014-01-16','10:45:00',2.17),('16273','2014-01-16','10:50:00',2.15),('16273','2014-01-16','10:55:00',2.14),('16273','2014-01-16','11:00:00',2.35),('16273','2014-01-16','11:05:00',2.22),('16273','2014-01-16','11:10:00',2),('16273','2014-01-16','11:15:00',1.74),('16273','2014-01-16','11:20:00',1.84),('16273','2014-01-16','11:25:00',1.77),('16273','2014-01-16','11:30:00',1.89),('16273','2014-01-16','11:35:00',1.95),('16273','2014-01-16','11:40:00',1.95),('16273','2014-01-16','11:45:00',2.03),('16273','2014-01-16','11:50:00',1.95),('16273','2014-01-16','11:55:00',1.87),('16273','2014-01-16','12:00:00',1.76),('16273','2014-01-16','12:05:00',1.77),('16273','2014-01-16','12:10:00',1.59),('16273','2014-01-16','12:15:00',1.49),('16273','2014-01-16','12:20:00',1.53),('16273','2014-01-16','12:25:00',1.65),('16273','2014-01-16','12:30:00',1.81),('16273','2014-01-16','12:35:00',1.79),('16273','2014-01-16','12:40:00',1.82),('16273','2014-01-16','12:45:00',1.99),('16273','2014-01-16','12:50:00',2.15),('16273','2014-01-16','12:55:00',2.25),('16273','2014-01-16','13:00:00',2.15),('16273','2014-01-16','13:05:00',2.24),('16273','2014-01-16','13:10:00',2.25),('16273','2014-01-16','13:15:00',2.15),('16273','2014-01-16','13:20:00',1.88),('16273','2014-01-16','13:25:00',1.95),('16273','2014-01-16','13:30:00',2.26),('16273','2014-01-16','13:35:00',2.44),('16273','2014-01-16','13:40:00',2.35),('16273','2014-01-16','13:45:00',2.35),('16273','2014-01-16','13:50:00',1.06),('16273','2014-01-16','13:55:00',1.05),('16273','2014-01-15','09:30:00',1.06),('16273','2014-01-15','09:55:00',1.61),('16273','2014-01-15','10:00:00',2.12),('16273','2014-01-15','10:05:00',2.37),('16273','2014-01-15','10:10:00',2.45),('16273','2014-01-15','10:15:00',2.49),('16273','2014-01-15','10:20:00',2.49),('16273','2014-01-15','10:25:00',2.57),('16273','2014-01-15','10:30:00',2.62),('16273','2014-01-15','10:35:00',2.15),('16273','2014-01-15','10:40:00',1.3),('16273','2014-01-15','10:45:00',1.02),('16273','2014-01-15','10:50:00',1.04),('16273','2014-01-15','10:55:00',2.29),('16273','2014-01-15','11:00:00',2.74),('16273','2014-01-15','11:05:00',2.79),('16273','2014-01-15','11:10:00',2.98),('16273','2014-01-15','11:15:00',2.9),('16273','2014-01-15','11:20:00',2.99),('16273','2014-01-15','11:25:00',2.77),('16273','2014-01-15','11:30:00',1.44),('16273','2014-01-15','11:35:00',1.54),('16273','2014-01-15','11:40:00',1.56),('16273','2014-01-15','11:45:00',1.45),('16273','2014-01-15','11:50:00',1.77),('16273','2014-01-15','11:55:00',1.64),('16273','2014-01-15','12:00:00',1.58),('16273','2014-01-15','12:05:00',1.8),('16273','2014-01-15','12:10:00',1.95),('16273','2014-01-15','12:15:00',1.62),('16273','2014-01-15','12:20:00',1.36),('16273','2014-01-15','12:25:00',1.63),('16273','2014-01-15','12:30:00',2.84),('16273','2014-01-15','12:35:00',2.74),('16273','2014-01-15','12:40:00',1.98),('16273','2014-01-15','12:45:00',2.19),('16273','2014-01-15','12:50:00',1.63),('16273','2014-01-15','12:55:00',2.45),('16273','2014-01-15','13:00:00',2.07),('16273','2014-01-15','13:10:00',1.66),('16273','2014-01-15','13:15:00',2.54),('16273','2014-01-15','13:20:00',2.65),('16273','2014-01-15','13:25:00',2.16),('16273','2014-01-15','13:30:00',2.29),('16273','2014-01-15','13:35:00',1.4),('16273','2014-01-15','13:40:00',1.76),('16273','2014-01-15','13:45:00',1.01),('16273','2014-01-15','13:50:00',2.05),('16273','2014-01-15','13:55:00',2.17),('16273','2014-01-15','14:00:00',2.1),('16273','2014-01-15','14:05:00',1.97),('16273','2014-01-15','14:10:00',1.89),('16273','2014-01-15','14:15:00',1.81),('16273','2014-01-15','14:20:00',1.74),('16273','2014-01-15','14:25:00',1.66),('16273','2014-01-15','14:30:00',1.59),('16273','2014-01-15','14:35:00',1.52),('16273','2014-01-15','14:40:00',1.48),('16273','2014-01-15','14:45:00',1.42),('16273','2014-01-15','14:50:00',1.37),('16273','2014-01-15','14:55:00',1.31),('16273','2014-01-15','15:00:00',1.27),('16273','2014-01-15','15:05:00',1.21),('16273','2014-01-15','15:10:00',1.14),('16273','2014-01-15','15:15:00',1.02),('16273','2014-01-14','10:20:00',1.17),('16273','2014-01-14','10:25:00',1.85),('16273','2014-01-14','10:30:00',2.21),('16273','2014-01-14','10:35:00',1.53),('16273','2014-01-14','10:40:00',1.1),('16273','2014-01-13','08:55:00',1.58),('16273','2014-01-13','09:00:00',1.33),('16273','2014-01-13','09:05:00',1.69),('16273','2014-01-13','09:10:00',1.69),('16273','2014-01-13','09:15:00',1.68),('16273','2014-01-13','09:20:00',1.72),('16273','2014-01-13','09:25:00',1.76),('16273','2014-01-13','09:30:00',1.82),('16273','2014-01-13','09:35:00',1.87),('16273','2014-01-13','09:40:00',1.9),('16273','2014-01-13','09:45:00',1.93),('16273','2014-01-13','09:50:00',1.99),('16273','2014-01-13','09:55:00',2.05),('16273','2014-01-13','10:00:00',2.08),('16273','2014-01-13','10:05:00',2.12),('16273','2014-01-13','10:10:00',2.18),('16273','2014-01-13','10:15:00',2.2),('16273','2014-01-13','10:20:00',2.22),('16273','2014-01-13','10:25:00',2.27),('16273','2014-01-13','10:30:00',2.29),('16273','2014-01-13','10:35:00',2.34),('16273','2014-01-13','10:40:00',2.35),('16273','2014-01-13','10:45:00',2.38),('16273','2014-01-13','10:50:00',2.4),('16273','2014-01-13','10:55:00',2.42),('16273','2014-01-13','11:00:00',2.42),('16273','2014-01-13','11:05:00',2.43),('16273','2014-01-13','11:10:00',2.47),('16273','2014-01-13','11:15:00',2.48),('16273','2014-01-13','11:20:00',2.48),('16273','2014-01-13','11:25:00',2.48),('16273','2014-01-13','11:30:00',2.46),('16273','2014-01-13','11:35:00',2.47),('16273','2014-01-13','11:40:00',2.46),('16273','2014-01-13','11:45:00',2.46),('16273','2014-01-13','11:50:00',2.41),('16273','2014-01-13','11:55:00',2.41),('16273','2014-01-13','12:00:00',2.45),('16273','2014-01-13','12:05:00',2.43),('16273','2014-01-13','12:10:00',2.4),('16273','2014-01-13','12:15:00',2.37),('16273','2014-01-13','12:20:00',2.33),('16273','2014-01-13','12:25:00',2.33),('16273','2014-01-13','12:30:00',2.33),('16273','2014-01-13','12:35:00',2.35),('16273','2014-01-13','12:40:00',2.28),('16273','2014-01-13','12:45:00',2.23),('16273','2014-01-13','12:50:00',2.14),('16273','2014-01-13','12:55:00',2.12),('16273','2014-01-13','13:00:00',2.08),('16273','2014-01-13','13:05:00',2.03),('16273','2014-01-13','13:10:00',2.09),('16273','2014-01-13','13:15:00',2.08),('16273','2014-01-13','13:20:00',2.09),('16273','2014-01-13','13:25:00',2.09),('16273','2014-01-13','13:30:00',2.07),('16273','2014-01-13','13:35:00',2),('16273','2014-01-13','13:40:00',1.93),('16273','2014-01-13','13:45:00',1.92),('16273','2014-01-13','13:50:00',1.89),('16273','2014-01-13','13:55:00',1.84),('16273','2014-01-13','14:00:00',1.7),('16273','2014-01-13','14:05:00',1.71),('16273','2014-01-13','14:10:00',1.66),('16273','2014-01-13','14:15:00',1.59),('16273','2014-01-13','14:20:00',1.53),('16273','2014-01-13','14:25:00',1.51),('16273','2014-01-13','14:30:00',1.44),('16273','2014-01-13','14:35:00',1.38),('16273','2014-01-13','14:40:00',1.35),('16273','2014-01-13','14:45:00',1.28),('16273','2014-01-13','14:50:00',1.22),('16273','2014-01-13','14:55:00',1.18),('16273','2014-01-13','15:00:00',1.13),('16273','2014-01-13','15:05:00',1.07),('16273','2014-01-13','15:10:00',1.01),('16273','2014-01-12','10:25:00',1.04),('16273','2014-01-12','10:30:00',1.08),('16273','2014-01-12','10:35:00',1.24),('16273','2014-01-12','10:40:00',1.28),('16273','2014-01-12','10:45:00',1.48),('16273','2014-01-12','10:50:00',1.61),('16273','2014-01-12','10:55:00',1.7),('16273','2014-01-12','11:00:00',1.55),('16273','2014-01-12','11:05:00',2.14),('16273','2014-01-12','11:10:00',1.88),('16273','2014-01-12','11:15:00',1.89),('16273','2014-01-12','11:20:00',1.62),('16273','2014-01-12','11:25:00',1.56),('16273','2014-01-12','11:30:00',1.64),('16273','2014-01-12','11:35:00',1.57),('16273','2014-01-12','11:40:00',1.61),('16273','2014-01-12','11:45:00',2.18),('16273','2014-01-12','11:50:00',1.58),('16273','2014-01-12','11:55:00',1.4),('16273','2014-01-12','12:00:00',1.25),('16273','2014-01-12','12:05:00',1.15),('16273','2014-01-12','12:10:00',1.1),('16273','2014-01-12','12:15:00',1.07),('16273','2014-01-12','12:20:00',1.04),('16273','2014-01-12','12:25:00',1.05),('16273','2014-01-12','12:30:00',1.03),('16273','2014-01-12','12:50:00',1.02),('16273','2014-01-12','13:00:00',1.02),('16273','2014-01-12','13:15:00',1.06),('16273','2014-01-12','13:20:00',1.12),('16273','2014-01-12','13:25:00',1.2),('16273','2014-01-12','13:30:00',1.19),('16273','2014-01-12','13:35:00',1.08),('16273','2014-01-12','13:40:00',1.04),('16273','2014-01-11','09:45:00',1.14),('16273','2014-01-11','09:50:00',1.67),('16273','2014-01-11','09:55:00',1.71),('16273','2014-01-11','10:00:00',1.27),('16273','2014-01-11','10:05:00',1.4),('16273','2014-01-11','10:10:00',1.6),('16273','2014-01-11','10:15:00',1.67),('16273','2014-01-11','10:20:00',1.91),('16273','2014-01-11','10:25:00',1.78),('16273','2014-01-11','10:30:00',2.12),('16273','2014-01-11','10:35:00',2.18),('16273','2014-01-11','10:40:00',2.52),('16273','2014-01-11','10:45:00',2.5),('16273','2014-01-11','10:50:00',2.47),('16273','2014-01-11','10:55:00',2.33),('16273','2014-01-11','11:00:00',2.28),('16273','2014-01-11','11:05:00',2.31),('16273','2014-01-11','11:10:00',2.14),('16273','2014-01-11','11:15:00',1.88),('16273','2014-01-11','11:20:00',1.62),('16273','2014-01-11','11:25:00',1.74),('16273','2014-01-11','11:30:00',1.81),('16273','2014-01-11','11:35:00',1.63),('16273','2014-01-11','11:40:00',1.78),('16273','2014-01-11','11:45:00',1.86),('16273','2014-01-11','11:50:00',1.78),('16273','2014-01-11','11:55:00',1.85),('16273','2014-01-11','12:00:00',1.71),('16273','2014-01-11','12:05:00',1.92),('16273','2014-01-11','12:10:00',2.16),('16273','2014-01-11','12:15:00',1.85),('16273','2014-01-11','12:20:00',1.22),('16273','2014-01-11','12:25:00',1.69),('16273','2014-01-11','12:30:00',1.86),('16273','2014-01-11','12:35:00',1.48),('16273','2014-01-11','12:40:00',1.26),('16273','2014-01-11','12:45:00',1.48),('16273','2014-01-11','12:50:00',1.53),('16273','2014-01-11','12:55:00',1.29),('16273','2014-01-11','13:00:00',1.66),('16273','2014-01-11','13:05:00',1.35),('16273','2014-01-11','13:10:00',1.07),('16273','2014-01-11','13:15:00',1.03),('16273','2014-01-11','14:00:00',1.08),('16273','2014-01-09','09:45:00',1.19),('16273','2014-01-09','09:50:00',1.48),('16273','2014-01-09','09:55:00',1.23),('16273','2014-01-09','10:00:00',1.04),('16273','2014-01-09','10:05:00',1.04),('16273','2014-01-09','10:10:00',1.09),('16273','2014-01-09','10:15:00',1.13),('16273','2014-01-09','10:35:00',1.04),('16273','2014-01-09','10:40:00',1.08),('16273','2014-01-09','10:45:00',1.01),('16273','2014-01-09','10:50:00',1.1),('16273','2014-01-09','10:55:00',1.29),('16273','2014-01-09','11:00:00',1.26),('16273','2014-01-09','11:05:00',1.3),('16273','2014-01-09','11:10:00',1.35),('16273','2014-01-09','11:15:00',1.29),('16273','2014-01-09','11:20:00',1.38),('16273','2014-01-09','11:25:00',1.37),('16273','2014-01-09','11:30:00',1.43),('16273','2014-01-09','11:35:00',1.4),('16273','2014-01-09','11:40:00',1.62),('16273','2014-01-09','11:45:00',1.3),('16273','2014-01-09','11:50:00',1.23),('16273','2014-01-09','11:55:00',1.23),('16273','2014-01-09','12:00:00',1.3),('16273','2014-01-09','12:05:00',1.57),('16273','2014-01-09','12:10:00',1.63),('16273','2014-01-09','12:15:00',1.33),('16273','2014-01-09','12:20:00',1.18),('16273','2014-01-09','12:25:00',1.33),('16273','2014-01-09','12:30:00',1.36),('16273','2014-01-09','12:35:00',1.26),('16273','2014-01-09','12:40:00',1.35),('16273','2014-01-09','12:45:00',1.44),('16273','2014-01-09','12:50:00',1.61),('16273','2014-01-09','12:55:00',1.81),('16273','2014-01-09','13:00:00',1.7),('16273','2014-01-09','13:05:00',1.49),('16273','2014-01-09','13:10:00',1.4),('16273','2014-01-09','13:15:00',1.07),('16273','2014-01-09','13:20:00',1.01),('16273','2014-01-09','13:25:00',1.04),('16273','2014-01-09','13:30:00',1.07),('16273','2014-01-09','13:35:00',1.07),('16273','2014-01-08','08:55:00',1.34),('16273','2014-01-08','09:00:00',1.43),('16273','2014-01-08','09:05:00',1.57),('16273','2014-01-08','09:10:00',1.58),('16273','2014-01-08','09:15:00',1.7),('16273','2014-01-08','09:20:00',1.78),('16273','2014-01-08','09:25:00',1.79),('16273','2014-01-08','09:30:00',1.74),('16273','2014-01-08','09:35:00',1.91),('16273','2014-01-08','09:40:00',1.85),('16273','2014-01-08','09:45:00',1.72),('16273','2014-01-08','09:50:00',1.96),('16273','2014-01-08','09:55:00',2.01),('16273','2014-01-08','10:00:00',1.89),('16273','2014-01-08','10:05:00',1.98),('16273','2014-01-08','10:10:00',2.13),('16273','2014-01-08','10:15:00',2.25),('16273','2014-01-08','10:20:00',2.3),('16273','2014-01-08','10:25:00',2.29),('16273','2014-01-08','10:30:00',2.37),('16273','2014-01-08','10:35:00',2.35),('16273','2014-01-08','10:40:00',2.39),('16273','2014-01-08','10:45:00',2.41),('16273','2014-01-08','10:50:00',2.43),('16273','2014-01-08','10:55:00',2.42),('16273','2014-01-08','11:00:00',2.45),('16273','2014-01-08','11:05:00',2.46),('16273','2014-01-08','11:10:00',2.48),('16273','2014-01-08','11:15:00',2.45),('16273','2014-01-08','11:20:00',2.31),('16273','2014-01-08','11:25:00',2.37),('16273','2014-01-08','11:30:00',2.47),('16273','2014-01-08','11:35:00',2.48),('16273','2014-01-08','11:40:00',2.49),('16273','2014-01-08','11:45:00',2.49),('16273','2014-01-08','11:50:00',2.5),('16273','2014-01-08','11:55:00',2.48),('16273','2014-01-08','12:00:00',2.46),('16273','2014-01-08','12:05:00',2.35),('16273','2014-01-08','12:10:00',2.4),('16273','2014-01-08','12:15:00',2.42),('16273','2014-01-08','12:20:00',2.39),('16273','2014-01-08','12:25:00',2.4),('16273','2014-01-08','12:30:00',2.37),('16273','2014-01-08','12:35:00',2.3),('16273','2014-01-08','12:40:00',2.17),('16273','2014-01-08','12:45:00',2.28),('16273','2014-01-08','12:50:00',2.17),('16273','2014-01-08','12:55:00',2.17),('16273','2014-01-08','13:00:00',2.15),('16273','2014-01-08','13:05:00',2.11),('16273','2014-01-08','13:10:00',2.14),('16273','2014-01-08','13:15:00',2.12),('16273','2014-01-08','13:20:00',2.12),('16273','2014-01-08','13:25:00',2.05),('16273','2014-01-08','13:30:00',2),('16273','2014-01-08','13:35:00',2),('16273','2014-01-08','13:40:00',1.93),('16273','2014-01-08','13:45:00',1.89),('16273','2014-01-08','13:50:00',1.82),('16273','2014-01-08','13:55:00',1.74),('16273','2014-01-08','14:00:00',1.72),('16273','2014-01-08','14:05:00',1.71),('16273','2014-01-08','14:10:00',1.63),('16273','2014-01-08','14:15:00',1.63),('16273','2014-01-08','14:20:00',1.48),('16273','2014-01-08','14:25:00',1.39),('16273','2014-01-08','14:30:00',1.4),('16273','2014-01-08','14:35:00',1.27),('16273','2014-01-08','14:40:00',1.18),('16273','2014-01-08','14:45:00',1.06),('16273','2014-01-08','14:55:00',1.03),('16273','2014-01-07','08:45:00',1.16),('16273','2014-01-07','08:50:00',1.13),('16273','2014-01-07','08:55:00',1.42),('16273','2014-01-07','09:00:00',1.51),('16273','2014-01-07','09:05:00',1.61),('16273','2014-01-07','09:10:00',1.69),('16273','2014-01-07','09:15:00',1.74),('16273','2014-01-07','09:20:00',1.8),('16273','2014-01-07','09:25:00',1.86),('16273','2014-01-07','09:30:00',1.92),('16273','2014-01-07','09:35:00',2),('16273','2014-01-07','09:40:00',2.06),('16273','2014-01-07','09:45:00',2.1),('16273','2014-01-07','09:50:00',2.17),('16273','2014-01-07','09:55:00',2.22),('16273','2014-01-07','10:00:00',2.27),('16273','2014-01-07','10:05:00',2.33),('16273','2014-01-07','10:10:00',2.35),('16273','2014-01-07','10:15:00',2.38),('16273','2014-01-07','10:20:00',2.42),('16273','2014-01-07','10:25:00',2.43),('16273','2014-01-07','10:30:00',2.47),('16273','2014-01-07','10:35:00',2.5),('16273','2014-01-07','10:40:00',2.48),('16273','2014-01-07','10:45:00',2.49),('16273','2014-01-07','10:50:00',2.51),('16273','2014-01-07','10:55:00',2.5),('16273','2014-01-07','11:00:00',2.54),('16273','2014-01-07','11:05:00',2.57),('16273','2014-01-07','11:10:00',2.58),('16273','2014-01-07','11:15:00',2.59),('16273','2014-01-07','11:20:00',2.59),('16273','2014-01-07','11:25:00',2.59),('16273','2014-01-07','11:30:00',2.6),('16273','2014-01-07','11:35:00',2.58),('16273','2014-01-07','11:40:00',2.56),('16273','2014-01-07','11:45:00',2.53),('16273','2014-01-07','11:50:00',2.45),('16273','2014-01-07','11:55:00',2.44),('16273','2014-01-07','12:00:00',2.44),('16273','2014-01-07','12:05:00',2.44),('16273','2014-01-07','12:10:00',2.46),('16273','2014-01-07','12:15:00',2.48),('16273','2014-01-07','12:20:00',2.47),('16273','2014-01-07','12:25:00',2.48),('16273','2014-01-07','12:30:00',2.48),('16273','2014-01-07','12:35:00',2.44),('16273','2014-01-07','12:40:00',2.38),('16273','2014-01-07','12:45:00',2.29),('16273','2014-01-07','12:50:00',2.33),('16273','2014-01-07','12:55:00',2.34),('16273','2014-01-07','13:00:00',2.32),('16273','2014-01-07','13:05:00',2.24),('16273','2014-01-07','13:10:00',2.2),('16273','2014-01-07','13:15:00',2.09),('16273','2014-01-07','13:20:00',2.06),('16273','2014-01-07','13:25:00',2.04),('16273','2014-01-07','13:30:00',2.06),('16273','2014-01-07','13:35:00',1.99),('16273','2014-01-07','13:40:00',1.96),('16273','2014-01-07','13:45:00',1.93),('16273','2014-01-07','13:50:00',1.92),('16273','2014-01-07','13:55:00',1.79),('16273','2014-01-07','14:00:00',1.77),('16273','2014-01-07','14:05:00',1.67),('16273','2014-01-07','14:10:00',1.63),('16273','2014-01-07','14:15:00',1.59),('16273','2014-01-07','14:20:00',1.54),('16273','2014-01-07','14:25:00',1.51),('16273','2014-01-07','14:30:00',1.48),('16273','2014-01-07','14:35:00',1.43),('16273','2014-01-07','14:40:00',1.36),('16273','2014-01-07','14:45:00',1.21),('16273','2014-01-07','14:50:00',1.21),('16273','2014-01-07','14:55:00',1.14),('16273','2014-01-07','15:00:00',1.15),('16273','2014-01-07','15:05:00',1.09),('16273','2014-04-24','07:35:00',1.08),('16273','2014-04-24','07:40:00',1.03),('16273','2014-04-24','07:45:00',1.29),('16273','2014-04-24','07:50:00',1.38),('16273','2014-04-24','07:55:00',1.47),('16273','2014-04-24','08:00:00',1.55),('16273','2014-04-24','08:05:00',1.63),('16273','2014-04-24','08:10:00',1.72),('16273','2014-04-24','08:15:00',1.8),('16273','2014-04-24','08:20:00',1.88),('16273','2014-04-24','08:25:00',1.96),('16273','2014-04-24','08:30:00',2.04),('16273','2014-04-24','08:35:00',2.12),('16273','2014-04-24','08:40:00',2.19),('16273','2014-04-24','08:45:00',2.28),('16273','2014-04-24','08:50:00',2.34),('16273','2014-04-24','08:55:00',2.4),('16273','2014-04-24','09:00:00',2.47),('16273','2014-04-24','09:05:00',2.52),('16273','2014-04-24','09:10:00',2.6),('16273','2014-04-24','09:15:00',2.66),('16273','2014-04-24','09:20:00',2.7),('16273','2014-04-24','09:25:00',2.76),('16273','2014-04-24','09:30:00',2.78),('16273','2014-04-24','09:35:00',2.85),('16273','2014-04-24','09:40:00',2.91),('16273','2014-04-24','09:45:00',2.93),('16273','2014-04-24','09:50:00',2.95),('16273','2014-04-24','09:55:00',3.02),('16273','2014-04-24','10:00:00',3.09),('16273','2014-04-24','10:05:00',3.13),('16273','2014-04-24','10:10:00',3.16),('16273','2014-04-24','10:15:00',3.18),('16273','2014-04-24','10:20:00',3.23),('16273','2014-04-24','10:25:00',3.34),('16273','2014-04-24','10:30:00',3.38),('16273','2014-04-24','10:35:00',3.51),('16273','2014-04-24','10:40:00',3.63),('16273','2014-04-24','10:45:00',3.55),('16273','2014-04-24','10:50:00',3.52),('16273','2014-04-24','10:55:00',3.58),('16273','2014-04-24','11:00:00',3.55),('16273','2014-04-24','11:05:00',3.61),('16273','2014-04-24','11:10:00',3.63),('16273','2014-04-24','11:15:00',3.61),('16273','2014-04-24','11:20:00',3.64),('16273','2014-04-24','11:25:00',3.68),('16273','2014-04-24','11:30:00',3.7),('16273','2014-04-24','11:35:00',3.71),('16273','2014-04-24','11:40:00',3.7),('16273','2014-04-24','11:45:00',3.7),('16273','2014-04-24','11:50:00',3.75),('16273','2014-04-24','11:55:00',3.77),('16273','2014-04-24','12:00:00',3.9),('16273','2014-04-24','12:05:00',3.93),('16273','2014-04-24','12:10:00',3.84),('16273','2014-04-24','12:15:00',3.81),('16273','2014-04-24','12:20:00',3.65),('16273','2014-04-24','12:25:00',3.82),('16273','2014-04-24','12:30:00',3.75),('16273','2014-04-24','12:35:00',3.78),('16273','2014-04-24','12:40:00',3.77),('16273','2014-04-24','12:45:00',3.75),('16273','2014-04-24','12:50:00',3.75),('16273','2014-04-24','12:55:00',3.76),('16273','2014-04-24','13:00:00',3.85),('16273','2014-04-24','13:05:00',3.85),('16273','2014-04-24','13:10:00',3.75),('16273','2014-04-24','13:15:00',3.31),('16273','2014-04-24','13:20:00',2.73),('16273','2014-04-24','13:25:00',3.84),('16273','2014-04-24','13:30:00',3.92),('16273','2014-04-24','13:35:00',3.93),('16273','2014-04-24','13:40:00',3.84),('16273','2014-04-24','13:45:00',3.69),('16273','2014-04-24','13:50:00',3.67),('16273','2014-04-24','13:55:00',3.63),('16273','2014-04-24','14:00:00',3.62),('16273','2014-04-24','14:05:00',3.61),('16273','2014-04-24','14:10:00',3.58),('16273','2014-04-24','14:15:00',3.54),('16273','2014-04-24','14:20:00',3.52),('16273','2014-04-24','14:25:00',3.5),('16273','2014-04-24','14:30:00',3.48),('16273','2014-04-24','14:35:00',3.49),('16273','2014-04-24','14:40:00',3.45),('16273','2014-04-24','14:45:00',3.38),('16273','2014-04-24','14:50:00',3.31),('16273','2014-04-24','14:55:00',3.25),('16273','2014-04-24','15:00:00',3.24),('16273','2014-04-24','15:05:00',3.11),('16273','2014-04-24','15:10:00',2.78),('16273','2014-04-24','15:15:00',3.48),('16273','2014-04-24','15:20:00',3.16),('16273','2014-04-24','15:25:00',2.56),('16273','2014-04-24','15:30:00',1.8),('16273','2014-04-24','15:35:00',3.33),('16273','2014-04-24','15:40:00',2.65),('16273','2014-04-24','15:45:00',3.19),('16273','2014-04-24','15:50:00',2.83),('16273','2014-04-24','15:55:00',2.69),('16273','2014-04-24','16:00:00',2.39),('16273','2014-04-24','16:05:00',1.71),('16273','2014-04-24','16:10:00',1.71),('16273','2014-04-24','16:15:00',2.23),('16273','2014-04-24','16:20:00',2.61),('16273','2014-04-24','16:25:00',2.48),('16273','2014-04-24','16:30:00',2.49),('16273','2014-04-24','16:35:00',2.47),('16273','2014-04-24','16:40:00',2.24),('16273','2014-04-24','16:45:00',1.75),('16273','2014-04-24','16:50:00',1.29),('16273','2014-04-24','16:55:00',1.11),('16273','2014-04-24','17:00:00',1.03),('16273','2014-04-24','17:05:00',1.17),('16273','2014-04-24','17:10:00',1.29),('16273','2014-04-24','17:15:00',1.25),('16273','2014-04-24','17:20:00',1.23),('16273','2014-04-24','17:25:00',1.03),('16273','2014-01-06','11:15:00',1.01),('16273','2014-01-06','11:20:00',1.13),('16273','2014-01-06','11:25:00',1.07),('16273','2014-01-06','11:30:00',1.5),('16273','2014-01-06','11:35:00',2.94),('16273','2014-01-06','11:40:00',2.73),('16273','2014-01-06','11:45:00',2.72),('16273','2014-01-06','11:50:00',2.66),('16273','2014-01-06','11:55:00',2.59),('16273','2014-01-06','12:00:00',2.44),('16273','2014-01-06','12:05:00',2.51),('16273','2014-01-06','12:10:00',2.57),('16273','2014-01-06','12:15:00',2.52),('16273','2014-01-06','12:20:00',2.47),('16273','2014-01-06','12:25:00',2.45),('16273','2014-01-06','12:30:00',2.4),('16273','2014-01-06','12:35:00',2.41),('16273','2014-01-06','12:40:00',2.38),('16273','2014-01-06','12:45:00',2.34),('16273','2014-01-06','12:50:00',2.26),('16273','2014-01-06','12:55:00',2.21),('16273','2014-01-06','13:00:00',2.22),('16273','2014-01-06','13:05:00',2.19),('16273','2014-01-06','13:10:00',2.18),('16273','2014-01-06','13:15:00',2.15),('16273','2014-01-06','13:20:00',2.11),('16273','2014-01-06','13:25:00',2.07),('16273','2014-01-06','13:30:00',2),('16273','2014-01-06','13:35:00',1.96),('16273','2014-01-06','13:40:00',1.99),('16273','2014-01-06','13:45:00',1.91),('16273','2014-01-06','13:50:00',1.84),('16273','2014-01-06','13:55:00',1.76),('16273','2014-01-06','14:00:00',1.72),('16273','2014-01-06','14:05:00',1.69),('16273','2014-01-06','14:10:00',1.67),('16273','2014-01-06','14:15:00',1.67),('16273','2014-01-06','14:20:00',1.59),('16273','2014-01-06','14:25:00',1.6),('16273','2014-01-06','14:30:00',1.65),('16273','2014-01-06','14:35:00',1.83),('16273','2014-01-06','14:40:00',1.5),('16273','2014-01-06','14:45:00',1.34),('16273','2014-01-06','14:50:00',1.25),('16273','2014-01-06','14:55:00',1.18),('16273','2014-01-06','15:00:00',1.15),('16273','2014-01-06','15:05:00',1.1),('16273','2014-01-03','08:50:00',1.21),('16273','2014-01-03','08:55:00',1.32),('16273','2014-01-03','09:00:00',1.22),('16273','2014-01-03','09:05:00',1.52),('16273','2014-01-03','09:10:00',1.62),('16273','2014-01-03','09:15:00',1.75),('16273','2014-01-03','09:20:00',2),('16273','2014-01-03','09:25:00',2.2),('16273','2014-01-03','09:30:00',2.23),('16273','2014-01-03','09:35:00',1.57),('16273','2014-01-03','09:45:00',1.46),('16273','2014-01-03','09:50:00',2.38),('16273','2014-01-03','09:55:00',2.4),('16273','2014-01-03','10:00:00',2.56),('16273','2014-01-03','10:05:00',1.76),('16273','2014-01-03','10:10:00',1.13),('16273','2014-01-03','10:25:00',1.07),('16273','2014-01-03','10:30:00',1.2),('16273','2014-01-03','10:35:00',1.1),('16273','2014-01-03','10:40:00',1.09),('16273','2014-01-03','10:45:00',1.19),('16273','2014-01-03','10:50:00',1.47),('16273','2014-01-03','10:55:00',1.36),('16273','2014-01-03','11:00:00',1.47),('16273','2014-01-03','11:05:00',1.86),('16273','2014-01-03','11:10:00',1.43),('16273','2014-01-03','11:15:00',1.22),('16273','2014-01-03','11:35:00',1.12),('16273','2014-01-03','11:40:00',1.57),('16273','2014-01-03','11:45:00',1.95),('16273','2014-01-03','11:50:00',1.49),('16273','2014-01-03','11:55:00',1.21),('16273','2014-01-03','12:00:00',1.5),('16273','2014-01-03','12:05:00',2.09),('16273','2014-01-03','12:10:00',2.79),('16273','2014-01-03','12:15:00',2.75),('16273','2014-01-03','12:20:00',1.56),('16273','2014-01-03','12:25:00',1.67),('16273','2014-01-03','12:30:00',1.63),('16273','2014-01-03','12:35:00',1.64),('16273','2014-01-03','12:40:00',1.46),('16273','2014-01-03','12:45:00',1.73),('16273','2014-01-03','12:50:00',1.76),('16273','2014-01-03','12:55:00',1.18),('16273','2014-01-03','13:00:00',1.47),('16273','2014-01-03','13:05:00',2.46),('16273','2014-01-03','13:10:00',1.81),('16273','2014-01-03','13:15:00',1.73),('16273','2014-01-03','13:20:00',1.37),('16273','2014-01-03','13:25:00',1.64),('16273','2014-01-03','13:30:00',1.37),('16273','2014-01-03','13:35:00',1.32),('16273','2014-01-03','13:40:00',1.08),('16273','2014-01-02','08:45:00',1.18),('16273','2014-01-02','08:50:00',1.3),('16273','2014-01-02','08:55:00',1.22),('16273','2014-01-02','09:00:00',1.5),('16273','2014-01-02','09:05:00',1.57),('16273','2014-01-02','09:10:00',1.64),('16273','2014-01-02','09:15:00',1.68),('16273','2014-01-02','09:20:00',1.74),('16273','2014-01-02','09:25:00',1.82),('16273','2014-01-02','09:30:00',1.89),('16273','2014-01-02','09:35:00',1.94),('16273','2014-01-02','09:40:00',1.99),('16273','2014-01-02','09:45:00',2.02),('16273','2014-01-02','09:50:00',2.06),('16273','2014-01-02','09:55:00',2.13),('16273','2014-01-02','10:00:00',2.16),('16273','2014-01-02','10:05:00',2.22),('16273','2014-01-02','10:10:00',2.26),('16273','2014-01-02','10:15:00',2.28),('16273','2014-01-02','10:20:00',2.32),('16273','2014-01-02','10:25:00',2.38),('16273','2014-01-02','10:30:00',2.28),('16273','2014-01-02','10:35:00',2.46),('16273','2014-01-02','10:40:00',2.52),('16273','2014-01-02','10:45:00',2.42),('16273','2014-01-02','10:50:00',1.62),('16273','2014-01-02','10:55:00',1.7),('16273','2014-01-02','11:00:00',1.6),('16273','2014-01-02','11:05:00',1.67),('16273','2014-01-02','11:10:00',1.24),('16273','2014-01-02','11:15:00',1.18),('16273','2014-01-02','11:20:00',1.24),('16273','2014-01-02','11:25:00',1.36),('16273','2014-01-02','11:30:00',1.7),('16273','2014-01-02','11:35:00',1.67),('16273','2014-01-02','11:40:00',1.3),('16273','2014-01-02','11:45:00',1.25),('16273','2014-01-02','11:50:00',1.13),('16273','2014-01-02','11:55:00',1.09),('16273','2014-01-02','12:00:00',1.04),('16273','2014-01-02','12:35:00',1.05),('16273','2014-01-02','12:40:00',1.37),('16273','2014-01-02','12:45:00',2.14),('16273','2014-01-02','12:50:00',2.82),('16273','2014-01-02','12:55:00',1.24),('16273','2014-01-02','13:00:00',1.38),('16273','2014-01-02','13:20:00',1.47),('16273','2014-01-02','13:25:00',1.64),('16273','2014-01-02','13:30:00',1.14),('16273','2014-01-01','08:45:00',1.12),('16273','2014-01-01','11:30:00',1),('16273','2014-01-01','11:35:00',1.05),('16273','2014-01-01','11:40:00',1.06),('16273','2014-01-01','11:45:00',1.09),('16273','2014-01-01','11:50:00',1.22),('16273','2014-01-01','11:55:00',1.16),('16273','2014-01-01','12:00:00',1.25),('16273','2014-01-01','12:05:00',1.24),('16273','2014-01-01','12:10:00',1.19),('16273','2014-01-01','12:15:00',1.13),('16273','2014-01-01','12:20:00',1.23),('16273','2014-01-01','12:25:00',1.99),('16273','2014-01-01','12:30:00',2.65),('16273','2014-01-01','12:35:00',2.05),('16273','2014-01-01','12:40:00',1.4),('16273','2014-01-01','12:45:00',2.62),('16273','2014-01-01','12:50:00',1.56),('16273','2014-01-01','12:55:00',1.43),('16273','2014-01-01','13:00:00',1.15),('16273','2014-01-01','13:05:00',1.04),('16273','2014-01-01','13:10:00',1.16),('16273','2014-01-01','13:15:00',1.14),('16273','2014-01-01','13:20:00',1.06),('16273','2014-01-01','13:25:00',1.13),('16273','2014-01-01','13:30:00',1.33),('16273','2014-01-01','13:35:00',1.6),('16273','2014-01-01','13:40:00',1.32),('16273','2014-01-01','13:45:00',1.49),('16273','2014-01-01','13:50:00',1.73),('16273','2014-01-01','13:55:00',1.29),('16273','2014-01-01','14:00:00',1.18),('16273','2014-01-01','14:05:00',1.65),('16273','2014-01-01','14:10:00',1.9),('16273','2014-01-01','14:15:00',1.14),('16273','2014-01-01','14:55:00',1.02),('16273','2014-01-01','15:05:00',1.08),('16273','2013-12-31','08:50:00',1.09),('16273','2013-12-31','08:55:00',1.46),('16273','2013-12-31','09:00:00',1.38),('16273','2013-12-31','09:05:00',1.66),('16273','2013-12-31','09:10:00',1.5),('16273','2013-12-31','09:15:00',1.85),('16273','2013-12-31','09:20:00',1.87),('16273','2013-12-31','09:25:00',2.08),('16273','2013-12-31','09:30:00',1.88),('16273','2013-12-31','09:35:00',1.58),('16273','2013-12-31','09:40:00',1.13),('16273','2013-12-31','10:05:00',1.42),('16273','2013-12-31','10:10:00',1.16),('16273','2013-12-31','11:00:00',1.05),('16273','2013-12-31','11:05:00',1.18),('16273','2013-12-31','11:10:00',1.36),('16273','2013-12-31','11:15:00',1.73),('16273','2013-12-31','11:20:00',2.44),('16273','2013-12-31','11:25:00',2.22),('16273','2013-12-31','11:30:00',2.53),('16273','2013-12-31','11:35:00',3.2),('16273','2013-12-31','11:40:00',2.96),('16273','2013-12-31','11:45:00',1.84),('16273','2013-12-31','11:50:00',1.96),('16273','2013-12-31','11:55:00',1.47),('16273','2013-12-31','12:00:00',2.23),('16273','2013-12-31','12:05:00',1.67),('16273','2013-12-31','12:10:00',2.1),('16273','2013-12-31','12:15:00',2.56),('16273','2013-12-31','12:20:00',2.54),('16273','2013-12-31','12:25:00',2.46),('16273','2013-12-31','12:30:00',2.42),('16273','2013-12-31','12:35:00',2.39),('16273','2013-12-31','12:40:00',2.34),('16273','2013-12-31','12:45:00',2.32),('16273','2013-12-31','12:50:00',2.29),('16273','2013-12-31','12:55:00',2.24),('16273','2013-12-31','13:00:00',2.21),('16273','2013-12-31','13:05:00',2.2),('16273','2013-12-31','13:10:00',2.15),('16273','2013-12-31','13:15:00',2.11),('16273','2013-12-31','13:20:00',2.07),('16273','2013-12-31','13:25:00',2.02),('16273','2013-12-31','13:30:00',1.98),('16273','2013-12-31','13:35:00',1.93),('16273','2013-12-31','13:40:00',1.9),('16273','2013-12-31','13:45:00',1.85),('16273','2013-12-31','13:50:00',1.79),('16273','2013-12-31','13:55:00',1.74),('16273','2013-12-31','14:00:00',1.69),('16273','2013-12-31','14:05:00',1.63),('16273','2013-12-31','14:10:00',1.59),('16273','2013-12-31','14:15:00',1.54),('16273','2013-12-31','14:20:00',1.48),('16273','2013-12-31','14:25:00',1.42),('16273','2013-12-31','14:30:00',1.36),('16273','2013-12-31','14:35:00',1.29),('16273','2013-12-31','14:40:00',1.25),('16273','2013-12-31','14:45:00',1.19),('16273','2013-12-31','14:50:00',1.13),('16273','2013-12-31','14:55:00',1.08),('16273','2013-12-31','15:00:00',1.02),('16273','2013-12-29','08:55:00',1.16),('16273','2013-12-29','09:00:00',1.34),('16273','2013-12-29','09:05:00',1.4),('16273','2013-12-29','09:10:00',1.49),('16273','2013-12-29','09:15:00',1.71),('16273','2013-12-29','09:20:00',1.8),('16273','2013-12-29','09:25:00',1.97),('16273','2013-12-29','09:30:00',2.21),('16273','2013-12-29','09:35:00',2.4),('16273','2013-12-29','09:40:00',2.13),('16273','2013-12-29','09:45:00',1.8),('16273','2013-12-29','09:50:00',1.81),('16273','2013-12-29','09:55:00',2.06),('16273','2013-12-29','10:00:00',1.94),('16273','2013-12-29','10:05:00',2.22),('16273','2013-12-29','10:10:00',2.24),('16273','2013-12-29','10:15:00',1.83),('16273','2013-12-29','10:20:00',2.21),('16273','2013-12-29','10:25:00',1.94),('16273','2013-12-29','10:30:00',1.55),('16273','2013-12-29','10:35:00',1.12),('16273','2013-12-29','11:15:00',1.1),('16273','2013-12-29','11:20:00',2.26),('16273','2013-12-29','11:25:00',1.72),('16273','2013-12-29','11:30:00',1.17),('16273','2013-12-29','11:35:00',1.13),('16273','2013-12-28','08:45:00',1.23),('16273','2013-12-28','08:50:00',1.13),('16273','2013-12-28','08:55:00',1.47),('16273','2013-12-28','09:00:00',1.55),('16273','2013-12-28','09:05:00',1.63),('16273','2013-12-28','09:10:00',1.69),('16273','2013-12-28','09:15:00',1.76),('16273','2013-12-28','09:20:00',1.83),('16273','2013-12-28','09:25:00',1.9),('16273','2013-12-28','09:30:00',1.96),('16273','2013-12-28','09:35:00',2.01),('16273','2013-12-28','09:40:00',2.06),('16273','2013-12-28','09:45:00',2.12),('16273','2013-12-28','09:50:00',2.15),('16273','2013-12-28','09:55:00',2.19),('16273','2013-12-28','10:00:00',2.23),('16273','2013-12-28','10:05:00',2.27),('16273','2013-12-28','10:10:00',2.31),('16273','2013-12-28','10:15:00',2.34),('16273','2013-12-28','10:20:00',2.37),('16273','2013-12-28','10:25:00',2.4),('16273','2013-12-28','10:30:00',2.42),('16273','2013-12-28','10:35:00',2.45),('16273','2013-12-28','10:40:00',2.47),('16273','2013-12-28','10:45:00',2.49),('16273','2013-12-28','10:50:00',2.5),('16273','2013-12-28','10:55:00',2.51),('16273','2013-12-28','11:00:00',2.5),('16273','2013-12-28','11:05:00',2.52),('16273','2013-12-28','11:10:00',2.52),('16273','2013-12-28','11:15:00',2.51),('16273','2013-12-28','11:20:00',2.53),('16273','2013-12-28','11:25:00',2.53),('16273','2013-12-28','11:30:00',2.51),('16273','2013-12-28','11:35:00',2.5),('16273','2013-12-28','11:40:00',2.53),('16273','2013-12-28','11:45:00',2.51),('16273','2013-12-28','11:50:00',2.5),('16273','2013-12-28','11:55:00',2.5),('16273','2013-12-28','12:00:00',2.48),('16273','2013-12-28','12:05:00',2.48),('16273','2013-12-28','12:10:00',2.47),('16273','2013-12-28','12:15:00',2.45),('16273','2013-12-28','12:20:00',2.4),('16273','2013-12-28','12:25:00',2.39),('16273','2013-12-28','12:30:00',2.34),('16273','2013-12-28','12:35:00',2.32),('16273','2013-12-28','12:40:00',2.29),('16273','2013-12-28','12:45:00',2.26),('16273','2013-12-28','12:50:00',2.21),('16273','2013-12-28','12:55:00',2.15),('16273','2013-12-28','13:00:00',2.15),('16273','2013-12-28','13:05:00',2.11),('16273','2013-12-28','13:10:00',2.05),('16273','2013-12-28','13:15:00',2),('16273','2013-12-28','13:20:00',1.99),('16273','2013-12-28','13:25:00',1.92),('16273','2013-12-28','13:30:00',1.88),('16273','2013-12-28','13:35:00',1.86),('16273','2013-12-28','13:40:00',1.8),('16273','2013-12-28','13:45:00',1.75),('16273','2013-12-28','13:50:00',1.73),('16273','2013-12-28','13:55:00',1.69),('16273','2013-12-28','14:00:00',1.62),('16273','2013-12-28','14:05:00',1.58),('16273','2013-12-28','14:10:00',1.54),('16273','2013-12-28','14:15:00',1.5),('16273','2013-12-28','14:20:00',1.45),('16273','2013-12-28','14:25:00',1.4),('16273','2013-12-28','14:30:00',1.35),('16273','2013-12-28','14:35:00',1.17),('16273','2013-12-28','14:50:00',1.22),('16273','2013-12-28','14:55:00',1.17),('16273','2013-12-28','15:00:00',1.08),('16273','2014-04-23','10:50:00',1.08),('16273','2014-04-23','10:55:00',1.09),('16273','2014-04-23','11:00:00',1.08),('16273','2014-04-23','11:05:00',1.08),('16273','2014-04-23','11:10:00',1.04),('16273','2014-04-23','11:15:00',1.03),('16273','2014-04-23','13:15:00',1.03),('16273','2014-04-23','13:20:00',1.03),('16273','2014-04-23','13:25:00',1.08),('16273','2014-04-23','13:30:00',1.11),('16273','2014-04-23','13:35:00',1.24),('16273','2014-04-23','13:40:00',1.33),('16273','2014-04-23','13:45:00',1.47),('16273','2014-04-23','13:50:00',1.49),('16273','2014-04-23','13:55:00',1.47),('16273','2014-04-23','14:00:00',1.46),('16273','2014-04-23','14:05:00',1.41),('16273','2014-04-23','14:10:00',1.39),('16273','2014-04-23','14:15:00',1.35),('16273','2014-04-23','14:20:00',1.28),('16273','2014-04-23','14:25:00',1.23),('16273','2014-04-23','14:30:00',1.19),('16273','2014-04-23','14:35:00',1.03),('16273','2014-04-23','15:15:00',1.06),('16273','2014-04-23','15:20:00',1.11),('16273','2014-04-23','15:25:00',1.14),('16273','2014-04-23','15:30:00',1.18),('16273','2014-04-23','15:35:00',1.09),('16273','2013-12-27','11:50:00',1.11),('16273','2013-12-27','11:55:00',1.16),('16273','2013-12-27','12:00:00',1.47),('16273','2013-12-27','12:05:00',2.41),('16273','2013-12-27','12:10:00',1.89),('16273','2013-12-27','12:15:00',1.03),('16273','2013-12-27','12:40:00',1.03),('16273','2013-12-27','12:45:00',1.38),('16273','2013-12-27','12:50:00',2),('16273','2013-12-27','12:55:00',1.99),('16273','2013-12-27','13:00:00',1.98),('16273','2013-12-27','13:05:00',1.98),('16273','2013-12-27','13:10:00',1.95),('16273','2013-12-27','13:15:00',1.95),('16273','2013-12-27','13:20:00',1.93),('16273','2013-12-27','13:25:00',2.23),('16273','2013-12-27','13:30:00',1.52),('16273','2013-12-27','13:35:00',1.23),('16273','2013-12-27','13:40:00',1.15),('16273','2013-12-27','13:45:00',1.05),('16273','2013-12-27','13:50:00',1),('16273','2013-12-27','13:55:00',1.05),('16273','2013-12-27','14:00:00',1.2),('16273','2013-12-27','14:05:00',1.37),('16273','2013-12-27','14:10:00',1.45),('16273','2013-12-27','14:35:00',1.01),('16273','2013-12-25','10:40:00',1.04),('16273','2013-12-25','11:05:00',1.41),('16273','2013-12-25','11:10:00',1.17),('16273','2013-12-25','11:15:00',1.81),('16273','2013-12-25','11:20:00',1.73),('16273','2013-12-25','11:45:00',1.22),('16273','2013-12-25','11:50:00',1.91),('16273','2013-12-25','11:55:00',1.95),('16273','2013-12-25','12:00:00',2.18),('16273','2013-12-25','12:05:00',2.55),('16273','2013-12-25','12:10:00',1.8),('16273','2013-12-25','12:15:00',1.82),('16273','2013-12-25','12:20:00',1.01),('16273','2013-12-25','12:25:00',2.74),('16273','2013-12-25','12:30:00',2.62),('16273','2013-12-25','12:35:00',1.13),('16273','2013-12-25','12:45:00',1.02),('16273','2013-12-25','12:55:00',1.05),('16273','2013-12-25','13:25:00',1.12),('16273','2013-12-25','13:35:00',1.27),('16273','2013-12-25','13:40:00',1.26),('16273','2013-12-25','13:45:00',1.22),('16273','2013-12-24','08:45:00',1.09),('16273','2013-12-24','08:50:00',1.23),('16273','2013-12-24','08:55:00',1.12),('16273','2013-12-24','09:00:00',1.37),('16273','2013-12-24','09:05:00',1.47),('16273','2013-12-24','09:10:00',1.53),('16273','2013-12-24','09:15:00',1.61),('16273','2013-12-24','09:20:00',1.67),('16273','2013-12-24','09:25:00',1.71),('16273','2013-12-24','09:30:00',1.76),('16273','2013-12-24','09:35:00',1.81),('16273','2013-12-24','09:40:00',1.88),('16273','2013-12-24','09:45:00',1.94),('16273','2013-12-24','09:50:00',1.96),('16273','2013-12-24','09:55:00',2),('16273','2013-12-24','10:00:00',2.05),('16273','2013-12-24','10:05:00',2.08),('16273','2013-12-24','10:10:00',2.12),('16273','2013-12-24','10:15:00',2.13),('16273','2013-12-24','10:20:00',2.18),('16273','2013-12-24','10:25:00',2.21),('16273','2013-12-24','10:30:00',2.23),('16273','2013-12-24','10:35:00',2.26),('16273','2013-12-24','10:40:00',2.28),('16273','2013-12-24','10:45:00',2.31),('16273','2013-12-24','10:50:00',2.33),('16273','2013-12-24','10:55:00',2.33),('16273','2013-12-24','11:00:00',2.33),('16273','2013-12-24','11:05:00',2.33),('16273','2013-12-24','11:10:00',2.33),('16273','2013-12-24','11:15:00',2.33),('16273','2013-12-24','11:20:00',2.32),('16273','2013-12-24','11:25:00',2.32),('16273','2013-12-24','11:30:00',2.27),('16273','2013-12-24','11:35:00',2.3),('16273','2013-12-24','11:40:00',2.32),('16273','2013-12-24','11:45:00',2.32),('16273','2013-12-24','11:50:00',2.28),('16273','2013-12-24','11:55:00',2.24),('16273','2013-12-24','12:00:00',2.24),('16273','2013-12-24','12:05:00',2.2),('16273','2013-12-24','12:10:00',2.19),('16273','2013-12-24','12:15:00',2.21),('16273','2013-12-24','12:20:00',2.19),('16273','2013-12-24','12:25:00',2.13),('16273','2013-12-24','12:30:00',2.08),('16273','2013-12-24','12:35:00',2.07),('16273','2013-12-24','12:40:00',2.03),('16273','2013-12-24','12:45:00',1.99),('16273','2013-12-24','12:50:00',1.95),('16273','2013-12-24','12:55:00',1.91),('16273','2013-12-24','13:00:00',1.87),('16273','2013-12-24','13:05:00',1.82),('16273','2013-12-24','13:10:00',1.84),('16273','2013-12-24','13:15:00',1.76),('16273','2013-12-24','13:20:00',1.75),('16273','2013-12-24','13:25:00',1.7),('16273','2013-12-24','13:30:00',1.69),('16273','2013-12-24','13:35:00',1.64),('16273','2013-12-24','13:40:00',1.62),('16273','2013-12-24','13:45:00',1.54),('16273','2013-12-24','13:50:00',1.51),('16273','2013-12-24','13:55:00',1.4),('16273','2013-12-24','14:00:00',1.33),('16273','2013-12-24','14:05:00',1.27),('16273','2013-12-24','14:10:00',1.18),('16273','2013-12-24','14:15:00',1.15),('16273','2013-12-24','14:20:00',1.14),('16273','2013-12-24','14:25:00',1.12),('16273','2013-12-24','14:30:00',1.07),('16273','2013-12-24','14:35:00',1.04),('16273','2013-12-24','14:40:00',1.01),('16273','2013-12-23','09:20:00',1.13),('16273','2013-12-23','09:25:00',1.18),('16273','2013-12-23','09:30:00',1.09),('16273','2013-12-23','09:50:00',1.16),('16273','2013-12-23','09:55:00',1.44),('16273','2013-12-23','10:00:00',1.37),('16273','2013-12-23','10:05:00',1.45),('16273','2013-12-23','10:10:00',1.6),('16273','2013-12-23','10:15:00',1.82),('16273','2013-12-23','10:20:00',1.96),('16273','2013-12-23','10:25:00',1.94),('16273','2013-12-23','10:30:00',1.73),('16273','2013-12-23','10:35:00',2.14),('16273','2013-12-23','10:40:00',2.11),('16273','2013-12-23','10:45:00',2.24),('16273','2013-12-23','10:50:00',2.24),('16273','2013-12-23','10:55:00',2.19),('16273','2013-12-23','11:00:00',2.32),('16273','2013-12-23','11:05:00',2.37),('16273','2013-12-23','11:10:00',2.41),('16273','2013-12-23','11:15:00',2.42),('16273','2013-12-23','11:20:00',2.55),('16273','2013-12-23','11:25:00',2.52),('16273','2013-12-23','11:30:00',2.19),('16273','2013-12-23','11:35:00',2.33),('16273','2013-12-23','11:40:00',2.34),('16273','2013-12-23','11:45:00',2.52),('16273','2013-12-23','11:50:00',2.48),('16273','2013-12-23','11:55:00',2.42),('16273','2013-12-23','12:00:00',2.37),('16273','2013-12-23','12:05:00',2.31),('16273','2013-12-23','12:10:00',2.26),('16273','2013-12-23','12:15:00',2.28),('16273','2013-12-23','12:20:00',2.23),('16273','2013-12-23','12:25:00',2.2),('16273','2013-12-23','12:30:00',2.16),('16273','2013-12-23','12:35:00',2.11),('16273','2013-12-23','12:40:00',2.09),('16273','2013-12-23','12:45:00',2.07),('16273','2013-12-23','12:50:00',2.04),('16273','2013-12-23','12:55:00',1.95),('16273','2013-12-23','13:00:00',1.96),('16273','2013-12-23','13:05:00',1.91),('16273','2013-12-23','13:10:00',1.84),('16273','2013-12-23','13:15:00',1.81),('16273','2013-12-23','13:20:00',1.82),('16273','2013-12-23','13:25:00',1.81),('16273','2013-12-23','13:30:00',1.77),('16273','2013-12-23','13:35:00',1.74),('16273','2013-12-23','13:40:00',1.51),('16273','2013-12-23','13:45:00',1.63),('16273','2013-12-23','13:50:00',1.56),('16273','2013-12-23','13:55:00',1.5),('16273','2013-12-23','14:00:00',1.48),('16273','2013-12-23','14:05:00',1.48),('16273','2013-12-23','14:10:00',1.44),('16273','2013-12-23','14:15:00',1.39),('16273','2013-12-23','14:20:00',1.33),('16273','2013-12-23','14:25:00',1.27),('16273','2013-12-23','14:30:00',1.2),('16273','2013-12-23','14:35:00',1.15),('16273','2013-12-23','14:40:00',1.11),('16273','2013-12-23','14:45:00',1.04),('16273','2013-12-23','14:50:00',1.02),('16273','2013-12-22','09:00:00',1),('16273','2013-12-22','09:05:00',1.18),('16273','2013-12-22','09:10:00',1.24),('16273','2013-12-22','09:15:00',1.3),('16273','2013-12-22','09:20:00',1.25),('16273','2013-12-22','09:25:00',1.35),('16273','2013-12-22','09:30:00',1.66),('16273','2013-12-22','09:35:00',2.07),('16273','2013-12-22','09:40:00',2.28),('16273','2013-12-22','09:45:00',2.39),('16273','2013-12-22','09:50:00',2.48),('16273','2013-12-22','09:55:00',2.54),('16273','2013-12-22','10:00:00',2.46),('16273','2013-12-22','10:05:00',2.33),('16273','2013-12-22','10:10:00',2.41),('16273','2013-12-22','10:15:00',2.36),('16273','2013-12-22','10:20:00',2.38),('16273','2013-12-22','10:25:00',2.23),('16273','2013-12-22','10:30:00',2.16),('16273','2013-12-22','10:35:00',2.16),('16273','2013-12-22','10:40:00',2.02),('16273','2013-12-22','10:45:00',2.09),('16273','2013-12-22','10:50:00',2.27),('16273','2013-12-22','10:55:00',2.24),('16273','2013-12-22','11:00:00',2.32),('16273','2013-12-22','11:05:00',2.05),('16273','2013-12-22','11:10:00',2.13),('16273','2013-12-22','11:15:00',2.26),('16273','2013-12-22','11:20:00',2.29),('16273','2013-12-22','11:25:00',2.21),('16273','2013-12-22','11:30:00',2.15),('16273','2013-12-22','11:35:00',2.27),('16273','2013-12-22','11:40:00',2.1),('16273','2013-12-22','11:45:00',1.95),('16273','2013-12-22','11:50:00',1.34),('16273','2013-12-22','11:55:00',1.1),('16273','2013-12-22','12:20:00',1.06),('16273','2013-12-22','12:25:00',1.13),('16273','2013-12-22','12:30:00',1.28),('16273','2013-12-22','12:35:00',1.44),('16273','2013-12-22','12:40:00',1.48),('16273','2013-12-22','12:45:00',1.41),('16273','2013-12-22','12:50:00',1.45),('16273','2013-12-22','12:55:00',1.82),('16273','2013-12-22','13:00:00',2.15),('16273','2013-12-22','13:05:00',2.29),('16273','2013-12-22','13:10:00',2.32),('16273','2013-12-22','13:15:00',2.07),('16273','2013-12-22','13:20:00',1.9),('16273','2013-12-22','13:25:00',1.99),('16273','2013-12-22','13:30:00',1.84),('16273','2013-12-22','13:35:00',1.66),('16273','2013-12-22','13:40:00',1.66),('16273','2013-12-22','13:45:00',1.19),('16273','2013-12-22','13:50:00',1.06),('16273','2013-12-22','13:55:00',1.17),('16273','2013-12-22','14:00:00',1.23),('16273','2013-12-22','14:05:00',1.25),('16273','2013-12-22','14:10:00',1.27),('16273','2013-12-22','14:15:00',1.01),('16273','2013-12-22','14:35:00',1.17),('16273','2013-12-22','14:40:00',1.19),('16273','2013-12-22','14:45:00',1.04),('16273','2013-12-21','08:45:00',1.04),('16273','2013-12-21','08:50:00',1.21),('16273','2013-12-21','08:55:00',1.35),('16273','2013-12-21','09:00:00',1.43),('16273','2013-12-21','09:05:00',1.51),('16273','2013-12-21','09:10:00',1.57),('16273','2013-12-21','09:15:00',1.64),('16273','2013-12-21','09:20:00',1.7),('16273','2013-12-21','09:25:00',1.78),('16273','2013-12-21','09:30:00',1.85),('16273','2013-12-21','09:35:00',1.9),('16273','2013-12-21','09:40:00',1.95),('16273','2013-12-21','09:45:00',2),('16273','2013-12-21','09:50:00',2.04),('16273','2013-12-21','09:55:00',2.09),('16273','2013-12-21','10:00:00',2.13),('16273','2013-12-21','10:05:00',2.17),('16273','2013-12-21','10:10:00',2.2),('16273','2013-12-21','10:15:00',2.23),('16273','2013-12-21','10:20:00',2.25),('16273','2013-12-21','10:25:00',2.3),('16273','2013-12-21','10:30:00',2.33),('16273','2013-12-21','10:35:00',2.37),('16273','2013-12-21','10:40:00',2.41),('16273','2013-12-21','10:45:00',2.43),('16273','2013-12-21','10:50:00',2.46),('16273','2013-12-21','10:55:00',2.46),('16273','2013-12-21','11:00:00',2.47),('16273','2013-12-21','11:05:00',2.49),('16273','2013-12-21','11:10:00',2.52),('16273','2013-12-21','11:15:00',2.52),('16273','2013-12-21','11:20:00',2.53),('16273','2013-12-21','11:25:00',2.53),('16273','2013-12-21','11:30:00',2.53),('16273','2013-12-21','11:35:00',2.49),('16273','2013-12-21','11:40:00',2.52),('16273','2013-12-21','11:45:00',2.52),('16273','2013-12-21','11:50:00',2.52),('16273','2013-12-21','11:55:00',2.5),('16273','2013-12-21','12:00:00',2.48),('16273','2013-12-21','12:05:00',2.46),('16273','2013-12-21','12:10:00',2.45),('16273','2013-12-21','12:15:00',2.42),('16273','2013-12-21','12:20:00',2.38),('16273','2013-12-21','12:25:00',2.36),('16273','2013-12-21','12:30:00',2.34),('16273','2013-12-21','12:35:00',2.33),('16273','2013-12-21','12:40:00',2.3),('16273','2013-12-21','12:45:00',2.27),('16273','2013-12-21','12:50:00',2.23),('16273','2013-12-21','12:55:00',2.2),('16273','2013-12-21','13:00:00',2.17),('16273','2013-12-21','13:05:00',2.14),('16273','2013-12-21','13:10:00',2.1),('16273','2013-12-21','13:15:00',2.06),('16273','2013-12-21','13:20:00',2.02),('16273','2013-12-21','13:25:00',1.97),('16273','2013-12-21','13:30:00',1.93),('16273','2013-12-21','13:35:00',1.88),('16273','2013-12-21','13:40:00',1.85),('16273','2013-12-21','13:45:00',1.8),('16273','2013-12-21','13:50:00',1.75),('16273','2013-12-21','13:55:00',1.69),('16273','2013-12-21','14:00:00',1.63),('16273','2013-12-21','14:05:00',1.59),('16273','2013-12-21','14:10:00',1.53),('16273','2013-12-21','14:15:00',1.47),('16273','2013-12-21','14:20:00',1.41),('16273','2013-12-21','14:25:00',1.35),('16273','2013-12-21','14:30:00',1.3),('16273','2013-12-21','14:35:00',1.23),('16273','2013-12-21','14:40:00',1.16),('16273','2013-12-21','14:45:00',1.11),('16273','2013-12-21','14:50:00',1.05),('16273','2013-12-21','14:55:00',1.01),('16273','2013-12-20','08:45:00',1.04),('16273','2013-12-20','08:50:00',1.15),('16273','2013-12-20','08:55:00',1.1),('16273','2013-12-20','09:00:00',1.39),('16273','2013-12-20','09:05:00',1.45),('16273','2013-12-20','09:10:00',1.51),('16273','2013-12-20','09:15:00',1.58),('16273','2013-12-20','09:20:00',1.65),('16273','2013-12-20','09:25:00',1.71),('16273','2013-12-20','09:30:00',1.75),('16273','2013-12-20','09:35:00',1.81),('16273','2013-12-20','09:40:00',1.84),('16273','2013-12-20','09:45:00',1.85),('16273','2013-12-20','09:50:00',1.91),('16273','2013-12-20','09:55:00',1.99),('16273','2013-12-20','10:00:00',1.98),('16273','2013-12-20','10:05:00',2.03),('16273','2013-12-20','10:10:00',2.07),('16273','2013-12-20','10:15:00',2.13),('16273','2013-12-20','10:20:00',2.18),('16273','2013-12-20','10:25:00',2.18),('16273','2013-12-20','10:30:00',2.19),('16273','2013-12-20','10:35:00',2.22),('16273','2013-12-20','10:40:00',2.25),('16273','2013-12-20','10:45:00',2.28),('16273','2013-12-20','10:50:00',2.29),('16273','2013-12-20','10:55:00',2.3),('16273','2013-12-20','11:00:00',2.3),('16273','2013-12-20','11:05:00',2.3),('16273','2013-12-20','11:10:00',2.28),('16273','2013-12-20','11:15:00',2.29),('16273','2013-12-20','11:20:00',2.31),('16273','2013-12-20','11:25:00',2.32),('16273','2013-12-20','11:30:00',2.32),('16273','2013-12-20','11:35:00',2.32),('16273','2013-12-20','11:40:00',2.32),('16273','2013-12-20','11:45:00',2.3),('16273','2013-12-20','11:50:00',2.27),('16273','2013-12-20','11:55:00',2.29),('16273','2013-12-20','12:00:00',2.26),('16273','2013-12-20','12:05:00',2.26),('16273','2013-12-20','12:10:00',2.22),('16273','2013-12-20','12:15:00',2.21),('16273','2013-12-20','12:20:00',2.18),('16273','2013-12-20','12:25:00',2.14),('16273','2013-12-20','12:30:00',2.12),('16273','2013-12-20','12:35:00',2.09),('16273','2013-12-20','12:40:00',2.04),('16273','2013-12-20','12:45:00',2),('16273','2013-12-20','12:50:00',1.97),('16273','2013-12-20','12:55:00',1.9),('16273','2013-12-20','13:00:00',1.89),('16273','2013-12-20','13:05:00',1.9),('16273','2013-12-20','13:10:00',1.87),('16273','2013-12-20','13:15:00',1.85),('16273','2013-12-20','13:20:00',1.79),('16273','2013-12-20','13:25:00',1.82),('16273','2013-12-20','13:40:00',1.34),('16273','2013-12-20','13:45:00',1.02),('16273','2013-12-20','14:15:00',1.07),('16273','2013-12-20','14:20:00',1.22),('16273','2013-12-20','14:25:00',1.13),('16273','2013-12-19','08:55:00',1.26),('16273','2013-12-19','09:00:00',1.35),('16273','2013-12-19','09:35:00',1.03),('16273','2013-12-19','09:45:00',1.09),('16273','2013-12-19','10:30:00',1.12),('16273','2013-12-19','10:40:00',1.09),('16273','2013-12-19','10:45:00',1.31),('16273','2013-12-19','10:50:00',1.1),('16273','2013-12-19','12:15:00',1.14),('16273','2013-12-19','14:10:00',1.04),('16273','2013-12-19','14:15:00',1.19),('16273','2013-12-19','14:25:00',1.49),('16273','2013-12-19','14:30:00',1.41),('16273','2013-12-19','14:35:00',1.22),('16273','2013-12-19','14:40:00',1.11),('16273','2013-12-18','08:40:00',1.11),('16273','2013-12-18','08:45:00',1.09),('16273','2013-12-18','08:50:00',1.37),('16273','2013-12-18','08:55:00',1.47),('16273','2013-12-18','09:00:00',1.55),('16273','2013-12-18','09:05:00',1.61),('16273','2013-12-18','09:10:00',1.67),('16273','2013-12-18','09:15:00',1.74),('16273','2013-12-18','09:20:00',1.83),('16273','2013-12-18','09:25:00',1.88),('16273','2013-12-18','09:30:00',1.93),('16273','2013-12-18','09:35:00',1.97),('16273','2013-12-18','09:40:00',2.03),('16273','2013-12-18','09:45:00',2.09),('16273','2013-12-18','09:50:00',2.15),('16273','2013-12-18','09:55:00',2.19),('16273','2013-12-18','10:00:00',2.23),('16273','2013-12-18','10:05:00',2.26),('16273','2013-12-18','10:10:00',2.28),('16273','2013-12-18','10:15:00',2.28),('16273','2013-12-18','10:20:00',2.31),('16273','2013-12-18','10:25:00',2.35),('16273','2013-12-18','10:30:00',2.37),('16273','2013-12-18','10:35:00',2.39),('16273','2013-12-18','10:40:00',2.42),('16273','2013-12-18','10:45:00',2.42),('16273','2013-12-18','10:50:00',2.41),('16273','2013-12-18','10:55:00',2.42),('16273','2013-12-18','11:00:00',2.44),('16273','2013-12-18','11:05:00',2.43),('16273','2013-12-18','11:10:00',2.4),('16273','2013-12-18','11:15:00',2.41),('16273','2013-12-18','11:20:00',2.41),('16273','2013-12-18','11:25:00',2.41),('16273','2013-12-18','11:30:00',2.4),('16273','2013-12-18','11:35:00',2.37),('16273','2013-12-18','11:40:00',2.38),('16273','2013-12-18','11:45:00',2.37),('16273','2013-12-18','11:50:00',2.35),('16273','2013-12-18','11:55:00',2.35),('16273','2013-12-18','12:00:00',2.33),('16273','2013-12-18','12:05:00',2.32),('16273','2013-12-18','12:10:00',2.33),('16273','2013-12-18','12:15:00',2.3),('16273','2013-12-18','12:20:00',2.3),('16273','2013-12-18','12:25:00',2.3),('16273','2013-12-18','12:30:00',2.27),('16273','2013-12-18','12:35:00',2.24),('16273','2013-12-18','12:40:00',2.22),('16273','2013-12-18','12:45:00',2.18),('16273','2013-12-18','12:50:00',2.15),('16273','2013-12-18','12:55:00',2.11),('16273','2013-12-18','13:00:00',2.04),('16273','2013-12-18','13:05:00',2.01),('16273','2013-12-18','13:10:00',1.99),('16273','2013-12-18','13:15:00',1.96),('16273','2013-12-18','13:20:00',1.92),('16273','2013-12-18','13:25:00',1.92),('16273','2013-12-18','13:30:00',1.88),('16273','2013-12-18','13:35:00',1.79),('16273','2013-12-18','13:40:00',1.77),('16273','2013-12-18','13:45:00',1.69),('16273','2013-12-18','13:50:00',1.64),('16273','2013-12-18','13:55:00',1.62),('16273','2013-12-18','14:00:00',1.56),('16273','2013-12-18','14:05:00',1.51),('16273','2013-12-18','14:10:00',1.44),('16273','2013-12-18','14:15:00',1.37),('16273','2013-12-18','14:20:00',1.34),('16273','2013-12-18','14:25:00',1.3),('16273','2013-12-18','14:30:00',1.24),('16273','2013-12-18','14:35:00',1.2),('16273','2013-12-18','14:40:00',1.16),('16273','2013-12-18','14:45:00',1.1),('16273','2013-12-18','14:50:00',1.05),('16273','2014-04-22','07:45:00',1.13),('16273','2014-04-22','07:50:00',1.24),('16273','2014-04-22','07:55:00',1.31),('16273','2014-04-22','08:00:00',1.42),('16273','2014-04-22','08:05:00',1.5),('16273','2014-04-22','08:10:00',1.59),('16273','2014-04-22','08:15:00',1.65),('16273','2014-04-22','08:20:00',1.76),('16273','2014-04-22','08:25:00',1.86),('16273','2014-04-22','08:30:00',1.93),('16273','2014-04-22','08:35:00',1.9),('16273','2014-04-22','08:40:00',1.99),('16273','2014-04-22','08:45:00',2.1),('16273','2014-04-22','08:50:00',2.11),('16273','2014-04-22','08:55:00',2.19),('16273','2014-04-22','09:00:00',2.41),('16273','2014-04-22','09:05:00',2.23),('16273','2014-04-22','09:10:00',2.14),('16273','2014-04-22','09:15:00',2.3),('16273','2014-04-22','09:20:00',2.66),('16273','2014-04-22','09:25:00',2.74),('16273','2014-04-22','09:30:00',2.79),('16273','2014-04-22','09:35:00',2.18),('16273','2014-04-22','09:40:00',1.81),('16273','2014-04-22','09:45:00',1.86),('16273','2014-04-22','09:50:00',1.07),('16273','2014-04-22','09:55:00',1.25),('16273','2014-04-22','10:00:00',1.52),('16273','2014-04-22','10:05:00',1.4),('16273','2014-04-22','10:10:00',1.66),('16273','2014-04-22','10:15:00',2.79),('16273','2014-04-22','10:20:00',2.03),('16273','2014-04-22','10:25:00',2.29),('16273','2014-04-22','10:30:00',2.26),('16273','2014-04-22','10:35:00',1.82),('16273','2014-04-22','10:40:00',3.12),('16273','2014-04-22','10:45:00',3.18),('16273','2014-04-22','10:50:00',2.79),('16273','2014-04-22','10:55:00',3.22),('16273','2014-04-22','11:00:00',2.09),('16273','2014-04-22','11:05:00',2.28),('16273','2014-04-22','11:10:00',1.57),('16273','2014-04-22','11:15:00',1.45),('16273','2014-04-22','11:20:00',1.17),('16273','2014-04-22','11:25:00',1.26),('16273','2014-04-22','11:30:00',1.08),('16273','2014-04-22','11:50:00',1.03),('16273','2014-04-22','11:55:00',1.01),('16273','2014-04-22','12:00:00',1.04),('16273','2014-04-22','12:05:00',1.06),('16273','2014-04-22','12:10:00',1.04),('16273','2014-04-22','12:15:00',1.14),('16273','2014-04-22','12:20:00',1.11),('16273','2014-04-22','12:25:00',1.19),('16273','2014-04-22','12:30:00',1.03),('16273','2014-04-22','13:10:00',1.15),('16273','2014-04-22','13:15:00',1.34),('16273','2014-04-22','13:20:00',1.45),('16273','2014-04-22','13:25:00',1.86),('16273','2014-04-22','13:30:00',2.41),('16273','2014-04-22','13:35:00',2.61),('16273','2014-04-22','13:40:00',2.38),('16273','2014-04-22','13:45:00',2.05),('16273','2014-04-22','13:50:00',1.47),('16273','2014-04-22','13:55:00',1.43),('16273','2014-04-22','14:00:00',2.28),('16273','2014-04-22','14:05:00',3.12),('16273','2014-04-22','14:10:00',2.97),('16273','2014-04-22','14:15:00',2.67),('16273','2014-04-22','14:20:00',1.62),('16273','2014-04-22','14:25:00',1.75),('16273','2014-04-22','14:30:00',2.49),('16273','2014-04-22','14:35:00',2.64),('16273','2014-04-22','14:40:00',2.5),('16273','2014-04-22','14:45:00',2.8),('16273','2014-04-22','14:50:00',2.18),('16273','2014-04-22','14:55:00',1.32),('16273','2014-04-22','15:00:00',1.11),('16273','2014-04-22','15:05:00',1.21),('16273','2014-04-22','15:10:00',1.13),('16273','2014-04-22','15:15:00',1.19),('16273','2014-04-22','15:20:00',1.21),('16273','2014-04-22','15:25:00',1.66),('16273','2014-04-22','15:30:00',1.55),('16273','2014-04-22','15:35:00',2.12),('16273','2014-04-22','15:40:00',1.9),('16273','2014-04-22','15:45:00',1.85),('16273','2014-04-22','15:50:00',1.93),('16273','2014-04-22','15:55:00',1.76),('16273','2014-04-22','16:00:00',2.22),('16273','2014-04-22','16:05:00',1.59),('16273','2014-04-22','16:10:00',1.33),('16273','2014-04-22','16:15:00',1.32),('16273','2014-04-22','16:20:00',1.46),('16273','2014-04-22','16:25:00',1.27),('16273','2014-04-22','16:30:00',1.18),('16273','2014-04-22','16:35:00',1.22),('16273','2014-04-22','16:40:00',1.18),('16273','2014-04-22','16:45:00',1.12),('16273','2014-04-22','16:50:00',1.06),('16273','2014-04-22','16:55:00',1.12),('16273','2014-04-22','17:00:00',1.24),('16273','2014-04-22','17:05:00',1.02),('16273','2013-12-17','08:40:00',1.33),('16273','2013-12-17','08:45:00',1.2),('16273','2013-12-17','08:50:00',1.57),('16273','2013-12-17','08:55:00',1.67),('16273','2013-12-17','09:00:00',1.74),('16273','2013-12-17','09:05:00',1.81),('16273','2013-12-17','09:10:00',1.86),('16273','2013-12-17','09:15:00',1.9),('16273','2013-12-17','09:20:00',1.96),('16273','2013-12-17','09:25:00',2.01),('16273','2013-12-17','09:30:00',2.04),('16273','2013-12-17','09:35:00',2.09),('16273','2013-12-17','09:40:00',2.15),('16273','2013-12-17','09:45:00',2.19),('16273','2013-12-17','09:50:00',2.23),('16273','2013-12-17','09:55:00',2.26),('16273','2013-12-17','10:00:00',2.29),('16273','2013-12-17','10:05:00',2.31),('16273','2013-12-17','10:10:00',2.37),('16273','2013-12-17','10:15:00',2.4),('16273','2013-12-17','10:20:00',2.43),('16273','2013-12-17','10:25:00',2.46),('16273','2013-12-17','10:30:00',2.47),('16273','2013-12-17','10:35:00',2.49),('16273','2013-12-17','10:40:00',2.51),('16273','2013-12-17','10:45:00',2.52),('16273','2013-12-17','10:50:00',2.54),('16273','2013-12-17','10:55:00',2.55),('16273','2013-12-17','11:00:00',2.55),('16273','2013-12-17','11:05:00',2.56),('16273','2013-12-17','11:10:00',2.55),('16273','2013-12-17','11:15:00',2.55),('16273','2013-12-17','11:20:00',2.51),('16273','2013-12-17','11:25:00',2.55),('16273','2013-12-17','11:30:00',2.54),('16273','2013-12-17','11:35:00',2.54),('16273','2013-12-17','11:40:00',2.53),('16273','2013-12-17','11:45:00',2.49),('16273','2013-12-17','11:50:00',2.46),('16273','2013-12-17','11:55:00',2.51),('16273','2013-12-17','12:00:00',2.49),('16273','2013-12-17','12:05:00',2.46),('16273','2013-12-17','12:10:00',2.43),('16273','2013-12-17','12:15:00',2.43),('16273','2013-12-17','12:20:00',2.38),('16273','2013-12-17','12:25:00',2.34),('16273','2013-12-17','12:30:00',2.35),('16273','2013-12-17','12:35:00',2.37),('16273','2013-12-17','12:40:00',2.33),('16273','2013-12-17','12:45:00',2.3),('16273','2013-12-17','12:50:00',2.27),('16273','2013-12-17','12:55:00',2.26),('16273','2013-12-17','13:00:00',2.22),('16273','2013-12-17','13:05:00',2.18),('16273','2013-12-17','13:10:00',2.14),('16273','2013-12-17','13:15:00',2.1),('16273','2013-12-17','13:20:00',2.05),('16273','2013-12-17','13:25:00',1.99),('16273','2013-12-17','13:30:00',1.93),('16273','2013-12-17','13:35:00',1.88),('16273','2013-12-17','13:40:00',1.84),('16273','2013-12-17','13:45:00',1.78),('16273','2013-12-17','13:50:00',1.72),('16273','2013-12-17','13:55:00',1.67),('16273','2013-12-17','14:00:00',1.61),('16273','2013-12-17','14:05:00',1.55),('16273','2013-12-17','14:10:00',1.51),('16273','2013-12-17','14:15:00',1.45),('16273','2013-12-17','14:20:00',1.37),('16273','2013-12-17','14:25:00',1.32),('16273','2013-12-17','14:30:00',1.26),('16273','2013-12-17','14:35:00',1.21),('16273','2013-12-17','14:40:00',1.16),('16273','2013-12-17','14:45:00',1.1),('16273','2013-12-17','14:50:00',1.04),('16273','2013-12-16','08:40:00',1.24),('16273','2013-12-16','08:45:00',1.14),('16273','2013-12-16','08:50:00',1.46),('16273','2013-12-16','08:55:00',1.58),('16273','2013-12-16','09:00:00',1.65),('16273','2013-12-16','09:05:00',1.72),('16273','2013-12-16','09:10:00',1.77),('16273','2013-12-16','09:15:00',1.84),('16273','2013-12-16','09:20:00',1.9),('16273','2013-12-16','09:25:00',1.98),('16273','2013-12-16','09:30:00',2.03),('16273','2013-12-16','09:35:00',2.08),('16273','2013-12-16','09:40:00',2.12),('16273','2013-12-16','09:45:00',2.16),('16273','2013-12-16','09:50:00',2.19),('16273','2013-12-16','09:55:00',2.23),('16273','2013-12-16','10:00:00',2.24),('16273','2013-12-16','10:05:00',2.26),('16273','2013-12-16','10:10:00',2.31),('16273','2013-12-16','10:15:00',2.33),('16273','2013-12-16','10:20:00',2.38),('16273','2013-12-16','10:25:00',2.42),('16273','2013-12-16','10:30:00',2.43),('16273','2013-12-16','10:35:00',2.43),('16273','2013-12-16','10:40:00',2.45),('16273','2013-12-16','10:45:00',2.47),('16273','2013-12-16','10:50:00',2.49),('16273','2013-12-16','10:55:00',2.53),('16273','2013-12-16','11:00:00',2.56),('16273','2013-12-16','11:05:00',2.58),('16273','2013-12-16','11:10:00',2.59),('16273','2013-12-16','11:15:00',2.58),('16273','2013-12-16','11:20:00',2.58),('16273','2013-12-16','11:25:00',2.57),('16273','2013-12-16','11:30:00',2.57),('16273','2013-12-16','11:35:00',2.56),('16273','2013-12-16','11:40:00',2.53),('16273','2013-12-16','11:45:00',2.53),('16273','2013-12-16','11:50:00',2.5),('16273','2013-12-16','11:55:00',2.51),('16273','2013-12-16','12:00:00',2.51),('16273','2013-12-16','12:05:00',2.5),('16273','2013-12-16','12:10:00',2.48),('16273','2013-12-16','12:15:00',2.45),('16273','2013-12-16','12:20:00',2.44),('16273','2013-12-16','12:25:00',2.42),('16273','2013-12-16','12:30:00',2.39),('16273','2013-12-16','12:35:00',2.37),('16273','2013-12-16','12:40:00',2.33),('16273','2013-12-16','12:45:00',2.29),('16273','2013-12-16','12:50:00',2.26),('16273','2013-12-16','12:55:00',2.25),('16273','2013-12-16','13:00:00',2.21),('16273','2013-12-16','13:05:00',2.16),('16273','2013-12-16','13:10:00',2.11),('16273','2013-12-16','13:15:00',2.07),('16273','2013-12-16','13:20:00',2.02),('16273','2013-12-16','13:25:00',1.96),('16273','2013-12-16','13:30:00',1.91),('16273','2013-12-16','13:35:00',1.85),('16273','2013-12-16','13:40:00',1.81),('16273','2013-12-16','13:45:00',1.77),('16273','2013-12-16','13:50:00',1.7),('16273','2013-12-16','13:55:00',1.65),('16273','2013-12-16','14:00:00',1.59),('16273','2013-12-16','14:05:00',1.55),('16273','2013-12-16','14:10:00',1.5),('16273','2013-12-16','14:15:00',1.43),('16273','2013-12-16','14:20:00',1.37),('16273','2013-12-16','14:25:00',1.33),('16273','2013-12-16','14:30:00',1.28),('16273','2013-12-16','14:35:00',1.22),('16273','2013-12-16','14:40:00',1.15),('16273','2013-12-16','14:45:00',1.08),('16273','2013-12-16','14:50:00',1.03),('16273','2013-12-15','10:25:00',1.11),('16273','2013-12-15','12:00:00',1.05),('16273','2013-12-14','08:40:00',1.11),('16273','2013-12-14','08:45:00',1.07),('16273','2013-12-14','08:50:00',1.32),('16273','2013-12-14','08:55:00',1.39),('16273','2013-12-14','09:00:00',1.48),('16273','2013-12-14','09:05:00',1.54),('16273','2013-12-14','09:10:00',1.6),('16273','2013-12-14','09:15:00',1.67),('16273','2013-12-14','09:20:00',1.72),('16273','2013-12-14','09:25:00',1.78),('16273','2013-12-14','09:30:00',1.83),('16273','2013-12-14','09:35:00',1.93),('16273','2013-12-14','09:40:00',2),('16273','2013-12-14','09:45:00',2.03),('16273','2013-12-14','09:50:00',2.1),('16273','2013-12-14','09:55:00',2.15),('16273','2013-12-14','10:00:00',2.17),('16273','2013-12-14','10:05:00',2.19),('16273','2013-12-14','10:10:00',2.22),('16273','2013-12-14','10:15:00',2.25),('16273','2013-12-14','10:20:00',2.25),('16273','2013-12-14','10:25:00',2.3),('16273','2013-12-14','10:30:00',2.32),('16273','2013-12-14','10:35:00',2.33),('16273','2013-12-14','10:40:00',2.34),('16273','2013-12-14','10:45:00',2.36),('16273','2013-12-14','10:50:00',2.39),('16273','2013-12-14','10:55:00',2.38),('16273','2013-12-14','11:00:00',2.41),('16273','2013-12-14','11:05:00',2.43),('16273','2013-12-14','11:10:00',2.43),('16273','2013-12-14','11:15:00',2.42),('16273','2013-12-14','11:20:00',2.43),('16273','2013-12-14','11:25:00',2.42),('16273','2013-12-14','11:30:00',2.44),('16273','2013-12-14','11:35:00',2.4),('16273','2013-12-14','11:40:00',2.36),('16273','2013-12-14','11:45:00',2.43),('16273','2013-12-14','11:50:00',2.34),('16273','2013-12-14','11:55:00',2.29),('16273','2013-12-14','12:00:00',2.32),('16273','2013-12-14','12:05:00',2.31),('16273','2013-12-14','12:10:00',2.25),('16273','2013-12-14','12:15:00',2.22),('16273','2013-12-14','12:20:00',2.2),('16273','2013-12-14','12:25:00',2.27),('16273','2013-12-14','12:30:00',2.23),('16273','2013-12-14','12:35:00',2.17),('16273','2013-12-14','12:40:00',2.19),('16273','2013-12-14','12:45:00',2.15),('16273','2013-12-14','12:50:00',2.15),('16273','2013-12-14','12:55:00',2.13),('16273','2013-12-14','13:00:00',2.09),('16273','2013-12-14','13:05:00',2.07),('16273','2013-12-14','13:10:00',2.05),('16273','2013-12-14','13:15:00',1.99),('16273','2013-12-14','13:20:00',1.96),('16273','2013-12-14','13:25:00',1.92),('16273','2013-12-14','13:30:00',1.87),('16273','2013-12-14','13:35:00',1.81),('16273','2013-12-14','13:40:00',1.74),('16273','2013-12-14','13:45:00',1.69),('16273','2013-12-14','13:50:00',1.63),('16273','2013-12-14','13:55:00',1.59),('16273','2013-12-14','14:00:00',1.56),('16273','2013-12-14','14:05:00',1.5),('16273','2013-12-14','14:10:00',1.43),('16273','2013-12-14','14:15:00',1.38),('16273','2013-12-14','14:20:00',1.33),('16273','2013-12-14','14:25:00',1.26),('16273','2013-12-14','14:30:00',1.21),('16273','2013-12-14','14:35:00',1.15),('16273','2013-12-14','14:40:00',1.11),('16273','2013-12-14','14:45:00',1.06),('16273','2013-12-14','14:50:00',1.02),('16273','2013-12-13','08:40:00',1),('16273','2013-12-13','08:45:00',1.01),('16273','2013-12-13','08:50:00',1.21),('16273','2013-12-13','08:55:00',1.29),('16273','2013-12-13','09:00:00',1.35),('16273','2013-12-13','09:05:00',1.4),('16273','2013-12-13','09:10:00',1.46),('16273','2013-12-13','09:15:00',1.51),('16273','2013-12-13','09:20:00',1.55),('16273','2013-12-13','09:25:00',1.61),('16273','2013-12-13','09:30:00',1.68),('16273','2013-12-13','09:35:00',1.74),('16273','2013-12-13','09:40:00',1.8),('16273','2013-12-13','09:45:00',1.85),('16273','2013-12-13','09:50:00',1.88),('16273','2013-12-13','09:55:00',1.9),('16273','2013-12-13','10:00:00',1.96),('16273','2013-12-13','10:05:00',2),('16273','2013-12-13','10:10:00',2.03),('16273','2013-12-13','10:15:00',2.05),('16273','2013-12-13','10:20:00',2.08),('16273','2013-12-13','10:25:00',2.11),('16273','2013-12-13','10:30:00',2.15),('16273','2013-12-13','10:35:00',2.21),('16273','2013-12-13','10:40:00',2.24),('16273','2013-12-13','10:45:00',2.24),('16273','2013-12-13','10:50:00',2.22),('16273','2013-12-13','10:55:00',2.24),('16273','2013-12-13','11:00:00',2.2),('16273','2013-12-13','11:05:00',2.19),('16273','2013-12-13','11:10:00',2.28),('16273','2013-12-13','11:15:00',2.36),('16273','2013-12-13','11:20:00',2.28),('16273','2013-12-13','11:25:00',2.34),('16273','2013-12-13','11:30:00',2.33),('16273','2013-12-13','11:35:00',2.28),('16273','2013-12-13','11:40:00',2.28),('16273','2013-12-13','11:45:00',2.27),('16273','2013-12-13','11:50:00',2.31),('16273','2013-12-13','11:55:00',2.28),('16273','2013-12-13','12:00:00',2.26),('16273','2013-12-13','12:05:00',2.25),('16273','2013-12-13','12:10:00',2.19),('16273','2013-12-13','12:15:00',2.24),('16273','2013-12-13','12:20:00',2.16),('16273','2013-12-13','12:25:00',2.15),('16273','2013-12-13','12:30:00',2.22),('16273','2013-12-13','12:35:00',2.23),('16273','2013-12-13','12:40:00',2.22),('16273','2013-12-13','12:45:00',2.11),('16273','2013-12-13','12:50:00',2.14),('16273','2013-12-13','12:55:00',2.14),('16273','2013-12-13','13:00:00',2.11),('16273','2013-12-13','13:05:00',2.08),('16273','2013-12-13','13:10:00',2.05),('16273','2013-12-13','13:15:00',1.95),('16273','2013-12-13','13:20:00',1.94),('16273','2013-12-13','13:25:00',1.88),('16273','2013-12-13','13:30:00',1.86),('16273','2013-12-13','13:35:00',1.8),('16273','2013-12-13','13:40:00',1.81),('16273','2013-12-13','13:45:00',1.7),('16273','2013-12-13','13:50:00',1.62),('16273','2013-12-13','13:55:00',1.59),('16273','2013-12-13','14:00:00',1.53),('16273','2013-12-13','14:05:00',1.52),('16273','2013-12-13','14:10:00',1.48),('16273','2013-12-13','14:15:00',1.41),('16273','2013-12-13','14:20:00',1.29),('16273','2013-12-13','14:25:00',1.28),('16273','2013-12-13','14:30:00',1.24),('16273','2013-12-13','14:35:00',1.15),('16273','2013-12-13','14:40:00',1.12),('16273','2013-12-13','14:45:00',1.05),('16273','2013-12-13','14:50:00',1.01),('16273','2013-12-12','08:35:00',1.03),('16273','2013-12-12','08:40:00',1.14),('16273','2013-12-12','08:45:00',1.07),('16273','2013-12-12','08:50:00',1.35),('16273','2013-12-12','08:55:00',1.43),('16273','2013-12-12','09:00:00',1.49),('16273','2013-12-12','09:05:00',1.54),('16273','2013-12-12','09:10:00',1.6),('16273','2013-12-12','09:15:00',1.68),('16273','2013-12-12','09:20:00',1.74),('16273','2013-12-12','09:25:00',1.79),('16273','2013-12-12','09:30:00',1.85),('16273','2013-12-12','09:35:00',1.9),('16273','2013-12-12','09:40:00',1.97),('16273','2013-12-12','09:45:00',2.03),('16273','2013-12-12','09:50:00',2.08),('16273','2013-12-12','09:55:00',2.13),('16273','2013-12-12','10:00:00',2.17),('16273','2013-12-12','10:05:00',2.19),('16273','2013-12-12','10:10:00',2.21),('16273','2013-12-12','10:15:00',2.25),('16273','2013-12-12','10:20:00',2.3),('16273','2013-12-12','10:25:00',2.32),('16273','2013-12-12','10:30:00',2.35),('16273','2013-12-12','10:35:00',2.36),('16273','2013-12-12','10:40:00',2.36),('16273','2013-12-12','10:45:00',2.36),('16273','2013-12-12','10:50:00',2.38),('16273','2013-12-12','10:55:00',2.39),('16273','2013-12-12','11:00:00',2.39),('16273','2013-12-12','11:05:00',2.4),('16273','2013-12-12','11:10:00',2.41),('16273','2013-12-12','11:15:00',2.42),('16273','2013-12-12','11:20:00',2.41),('16273','2013-12-12','11:25:00',2.4),('16273','2013-12-12','11:30:00',2.38),('16273','2013-12-12','11:35:00',2.39),('16273','2013-12-12','11:40:00',2.41),('16273','2013-12-12','11:45:00',2.41),('16273','2013-12-12','11:50:00',2.39),('16273','2013-12-12','11:55:00',2.36),('16273','2013-12-12','12:00:00',2.31),('16273','2013-12-12','12:05:00',2.3),('16273','2013-12-12','12:10:00',2.32),('16273','2013-12-12','12:15:00',2.3),('16273','2013-12-12','12:20:00',2.27),('16273','2013-12-12','12:25:00',2.21),('16273','2013-12-12','12:30:00',2.22),('16273','2013-12-12','12:35:00',2.18),('16273','2013-12-12','12:40:00',2.18),('16273','2013-12-12','12:45:00',2.12),('16273','2013-12-12','12:50:00',2.11),('16273','2013-12-12','12:55:00',2.09),('16273','2013-12-12','13:00:00',2.07),('16273','2013-12-12','13:05:00',2.02),('16273','2013-12-12','13:10:00',1.99),('16273','2013-12-12','13:15:00',1.95),('16273','2013-12-12','13:20:00',1.91),('16273','2013-12-12','13:25:00',1.86),('16273','2013-12-12','13:30:00',1.81),('16273','2013-12-12','13:35:00',1.75),('16273','2013-12-12','13:40:00',1.69),('16273','2013-12-12','13:45:00',1.65),('16273','2013-12-12','13:50:00',1.62),('16273','2013-12-12','13:55:00',1.56),('16273','2013-12-12','14:00:00',1.51),('16273','2013-12-12','14:05:00',1.46),('16273','2013-12-12','14:10:00',1.41),('16273','2013-12-12','14:15:00',1.36),('16273','2013-12-12','14:20:00',1.29),('16273','2013-12-12','14:25:00',1.25),('16273','2013-12-12','14:30:00',1.19),('16273','2013-12-12','14:35:00',1.14),('16273','2013-12-12','14:40:00',1.08),('16273','2013-12-12','14:45:00',1.01),('16273','2013-12-11','08:35:00',1.13),('16273','2013-12-11','08:40:00',1.17),('16273','2013-12-11','08:45:00',1.21),('16273','2013-12-11','08:50:00',1.44),('16273','2013-12-11','08:55:00',1.53),('16273','2013-12-11','09:00:00',1.61),('16273','2013-12-11','09:05:00',1.67),('16273','2013-12-11','09:10:00',1.71),('16273','2013-12-11','09:15:00',1.78),('16273','2013-12-11','09:20:00',1.83),('16273','2013-12-11','09:25:00',1.88),('16273','2013-12-11','09:30:00',1.91),('16273','2013-12-11','09:35:00',1.99),('16273','2013-12-11','09:40:00',2.06),('16273','2013-12-11','09:45:00',2.11),('16273','2013-12-11','09:50:00',2.16),('16273','2013-12-11','09:55:00',2.21),('16273','2013-12-11','10:00:00',2.26),('16273','2013-12-11','10:05:00',2.3),('16273','2013-12-11','10:10:00',2.34),('16273','2013-12-11','10:15:00',2.35),('16273','2013-12-11','10:20:00',2.35),('16273','2013-12-11','10:25:00',2.37),('16273','2013-12-11','10:30:00',2.38),('16273','2013-12-11','10:35:00',2.44),('16273','2013-12-11','10:40:00',2.46),('16273','2013-12-11','10:45:00',2.47),('16273','2013-12-11','10:50:00',2.47),('16273','2013-12-11','10:55:00',2.49),('16273','2013-12-11','11:00:00',2.49),('16273','2013-12-11','11:05:00',2.53),('16273','2013-12-11','11:10:00',2.54),('16273','2013-12-11','11:15:00',2.51),('16273','2013-12-11','11:20:00',2.49),('16273','2013-12-11','11:25:00',2.5),('16273','2013-12-11','11:30:00',2.52),('16273','2013-12-11','11:35:00',2.55),('16273','2013-12-11','11:40:00',2.55),('16273','2013-12-11','11:45:00',2.56),('16273','2013-12-11','11:50:00',2.51),('16273','2013-12-11','11:55:00',2.52),('16273','2013-12-11','12:00:00',2.53),('16273','2013-12-11','12:05:00',2.49),('16273','2013-12-11','12:10:00',2.45),('16273','2013-12-11','12:15:00',2.4),('16273','2013-12-11','12:20:00',2.37),('16273','2013-12-11','12:25:00',2.36),('16273','2013-12-11','12:30:00',2.34),('16273','2013-12-11','12:35:00',2.33),('16273','2013-12-11','12:40:00',2.31),('16273','2013-12-11','12:45:00',2.3),('16273','2013-12-11','12:50:00',2.25),('16273','2013-12-11','12:55:00',2.22),('16273','2013-12-11','13:00:00',2.18),('16273','2013-12-11','13:05:00',2.1),('16273','2013-12-11','13:10:00',2.08),('16273','2013-12-11','13:15:00',2.04),('16273','2013-12-11','13:20:00',1.98),('16273','2013-12-11','13:25:00',1.95),('16273','2013-12-11','13:30:00',1.9),('16273','2013-12-11','13:35:00',1.82),('16273','2013-12-11','13:40:00',1.77),('16273','2013-12-11','13:45:00',1.7),('16273','2013-12-11','13:50:00',1.65),('16273','2013-12-11','13:55:00',1.61),('16273','2013-12-11','14:00:00',1.57),('16273','2013-12-11','14:05:00',1.52),('16273','2013-12-11','14:10:00',1.47),('16273','2013-12-11','14:15:00',1.4),('16273','2013-12-11','14:20:00',1.35),('16273','2013-12-11','14:25:00',1.31),('16273','2013-12-11','14:30:00',1.25),('16273','2013-12-11','14:35:00',1.17),('16273','2013-12-11','14:40:00',1.12),('16273','2013-12-11','14:45:00',1.07),('16273','2013-12-11','14:50:00',1.02),('16273','2013-12-10','08:35:00',1.15),('16273','2013-12-10','08:40:00',1.1),('16273','2013-12-10','08:45:00',1.4),('16273','2013-12-10','08:50:00',1.48),('16273','2013-12-10','08:55:00',1.57),('16273','2013-12-10','09:00:00',1.64),('16273','2013-12-10','09:05:00',1.71),('16273','2013-12-10','09:10:00',1.77),('16273','2013-12-10','09:15:00',1.84),('16273','2013-12-10','09:20:00',1.9),('16273','2013-12-10','09:25:00',1.94),('16273','2013-12-10','09:30:00',1.99),('16273','2013-12-10','09:35:00',2.07),('16273','2013-12-10','09:40:00',2.12),('16273','2013-12-10','09:45:00',2.15),('16273','2013-12-10','09:50:00',2.2),('16273','2013-12-10','09:55:00',2.23),('16273','2013-12-10','10:00:00',2.26),('16273','2013-12-10','10:05:00',2.3),('16273','2013-12-10','10:10:00',2.33),('16273','2013-12-10','10:15:00',2.33),('16273','2013-12-10','10:20:00',2.38),('16273','2013-12-10','10:25:00',2.4),('16273','2013-12-10','10:30:00',2.41),('16273','2013-12-10','10:35:00',2.44),('16273','2013-12-10','10:40:00',2.46),('16273','2013-12-10','10:45:00',2.48),('16273','2013-12-10','10:50:00',2.49),('16273','2013-12-10','10:55:00',2.52),('16273','2013-12-10','11:00:00',2.53),('16273','2013-12-10','11:05:00',2.52),('16273','2013-12-10','11:10:00',2.52),('16273','2013-12-10','11:15:00',2.52),('16273','2013-12-10','11:20:00',2.52),('16273','2013-12-10','11:25:00',2.52),('16273','2013-12-10','11:30:00',2.48),('16273','2013-12-10','11:35:00',2.5),('16273','2013-12-10','11:40:00',2.48),('16273','2013-12-10','11:45:00',2.46),('16273','2013-12-10','11:50:00',2.46),('16273','2013-12-10','11:55:00',2.45),('16273','2013-12-10','12:00:00',2.43),('16273','2013-12-10','12:05:00',2.43),('16273','2013-12-10','12:10:00',2.4),('16273','2013-12-10','12:15:00',2.38),('16273','2013-12-10','12:20:00',2.37),('16273','2013-12-10','12:25:00',2.36),('16273','2013-12-10','12:30:00',2.35),('16273','2013-12-10','12:35:00',2.33),('16273','2013-12-10','12:40:00',2.3),('16273','2013-12-10','12:45:00',2.26),('16273','2013-12-10','12:50:00',2.22),('16273','2013-12-10','12:55:00',2.18),('16273','2013-12-10','13:00:00',2.14),('16273','2013-12-10','13:05:00',2.09),('16273','2013-12-10','13:10:00',2.05),('16273','2013-12-10','13:15:00',2.01),('16273','2013-12-10','13:20:00',1.97),('16273','2013-12-10','13:25:00',1.92),('16273','2013-12-10','13:30:00',1.88),('16273','2013-12-10','13:35:00',1.84),('16273','2013-12-10','13:40:00',1.78),('16273','2013-12-10','13:45:00',1.72),('16273','2013-12-10','13:50:00',1.66),('16273','2013-12-10','13:55:00',1.61),('16273','2013-12-10','14:00:00',1.55),('16273','2013-12-10','14:05:00',1.5),('16273','2013-12-10','14:10:00',1.43),('16273','2013-12-10','14:15:00',1.38),('16273','2013-12-10','14:20:00',1.32),('16273','2013-12-10','14:25:00',1.27),('16273','2013-12-10','14:30:00',1.2),('16273','2013-12-10','14:35:00',1.17),('16273','2013-12-10','14:40:00',1.1),('16273','2013-12-10','14:50:00',1.01),('16273','2013-12-09','09:15:00',1.52),('16273','2013-12-09','09:20:00',1.91),('16273','2013-12-09','09:25:00',1.92),('16273','2013-12-09','09:30:00',1.95),('16273','2013-12-09','09:35:00',2.03),('16273','2013-12-09','09:40:00',2.16),('16273','2013-12-09','09:45:00',2.26),('16273','2013-12-09','09:50:00',2.52),('16273','2013-12-09','09:55:00',2.68),('16273','2013-12-09','10:00:00',1.98),('16273','2013-12-09','12:20:00',1.04),('16273','2013-12-09','12:25:00',1.46),('16273','2013-12-09','12:35:00',1.16),('16273','2013-12-09','12:40:00',1.49),('16273','2013-12-09','12:45:00',2.37),('16273','2013-12-09','12:50:00',2.36),('16273','2013-12-09','12:55:00',1.82),('16273','2013-12-09','13:00:00',1.66),('16273','2013-12-09','13:05:00',1.69),('16273','2013-12-09','13:10:00',1.9),('16273','2013-12-09','13:15:00',1.61),('16273','2013-12-09','13:20:00',1.18),('16273','2013-12-09','13:30:00',1.39),('16273','2013-12-09','13:35:00',1.22),('16273','2013-12-09','13:40:00',1.27),('16273','2013-12-08','11:15:00',1.06),('16273','2013-12-08','11:20:00',1.04),('16273','2013-12-08','11:25:00',1.34),('16273','2013-12-08','11:30:00',1.36),('16273','2013-12-08','11:35:00',1.22),('16273','2013-12-08','11:40:00',1.07),('16273','2013-12-08','12:00:00',1.07),('16273','2013-12-08','12:35:00',1.03),('16273','2013-12-08','12:40:00',1.49),('16273','2013-12-08','12:45:00',1.17),('16273','2013-12-08','14:55:00',1.01),('16273','2014-04-21','08:45:00',1.31),('16273','2014-04-21','08:50:00',1.4),('16273','2014-04-21','08:55:00',1.97),('16273','2014-04-21','09:00:00',1.74),('16273','2014-04-21','09:05:00',1.3),('16273','2014-04-21','09:10:00',1.39),('16273','2014-04-21','09:15:00',1.12),('16273','2014-04-21','09:20:00',1.78),('16273','2014-04-21','09:25:00',1.61),('16273','2014-04-21','09:30:00',2.36),('16273','2014-04-21','09:35:00',1.67),('16273','2014-04-21','09:50:00',1.09),('16273','2014-04-21','09:55:00',1.31),('16273','2014-04-21','10:00:00',1.31),('16273','2014-04-21','10:05:00',1.47),('16273','2014-04-21','10:10:00',2.48),('16273','2014-04-21','10:15:00',3.57),('16273','2014-04-21','10:20:00',3.46),('16273','2014-04-21','10:25:00',3.34),('16273','2014-04-21','10:30:00',3.31),('16273','2014-04-21','10:35:00',3.32),('16273','2014-04-21','10:40:00',3.35),('16273','2014-04-21','10:45:00',3.4),('16273','2014-04-21','10:50:00',3.42),('16273','2014-04-21','10:55:00',3.43),('16273','2014-04-21','11:00:00',3.46),('16273','2014-04-21','11:05:00',3.49),('16273','2014-04-21','11:10:00',3.48),('16273','2014-04-21','11:15:00',3.53),('16273','2014-04-21','11:20:00',3.56),('16273','2014-04-21','11:25:00',3.59),('16273','2014-04-21','11:30:00',3.6),('16273','2014-04-21','11:35:00',3.62),('16273','2014-04-21','11:40:00',3.65),('16273','2014-04-21','11:45:00',3.66),('16273','2014-04-21','11:50:00',3.69),('16273','2014-04-21','11:55:00',3.69),('16273','2014-04-21','12:00:00',3.69),('16273','2014-04-21','12:05:00',3.71),('16273','2014-04-21','12:10:00',3.71),('16273','2014-04-21','12:15:00',3.73),('16273','2014-04-21','12:20:00',3.75),('16273','2014-04-21','12:25:00',3.71),('16273','2014-04-21','12:30:00',3.74),('16273','2014-04-21','12:35:00',3.75),('16273','2014-04-21','12:40:00',3.74),('16273','2014-04-21','12:45:00',3.74),('16273','2014-04-21','12:50:00',3.73),('16273','2014-04-21','12:55:00',3.71),('16273','2014-04-21','13:00:00',3.74),('16273','2014-04-21','13:05:00',3.72),('16273','2014-04-21','13:10:00',3.71),('16273','2014-04-21','13:15:00',3.73),('16273','2014-04-21','13:20:00',3.72),('16273','2014-04-21','13:25:00',3.72),('16273','2014-04-21','13:30:00',3.69),('16273','2014-04-21','13:35:00',3.69),('16273','2014-04-21','13:40:00',3.66),('16273','2014-04-21','13:45:00',3.65),('16273','2014-04-21','13:50:00',3.64),('16273','2014-04-21','13:55:00',3.61),('16273','2014-04-21','14:00:00',3.59),('16273','2014-04-21','14:05:00',3.57),('16273','2014-04-21','14:10:00',3.49),('16273','2014-04-21','14:15:00',3.49),('16273','2014-04-21','14:20:00',3.46),('16273','2014-04-21','14:25:00',3.42),('16273','2014-04-21','14:30:00',3.39),('16273','2014-04-21','14:35:00',3.36),('16273','2014-04-21','14:40:00',3.3),('16273','2014-04-21','14:45:00',3.25),('16273','2014-04-21','14:50:00',3.22),('16273','2014-04-21','14:55:00',3.17),('16273','2014-04-21','15:00:00',3.12),('16273','2014-04-21','15:05:00',3.07),('16273','2014-04-21','15:10:00',3.02),('16273','2014-04-21','15:15:00',2.95),('16273','2014-04-21','15:20:00',2.89),('16273','2014-04-21','15:25:00',2.84),('16273','2014-04-21','15:30:00',2.79),('16273','2014-04-21','15:35:00',2.73),('16273','2014-04-21','15:40:00',2.67),('16273','2014-04-21','15:45:00',2.6),('16273','2014-04-21','15:50:00',2.54),('16273','2014-04-21','15:55:00',2.48),('16273','2014-04-21','16:00:00',2.41),('16273','2014-04-21','16:05:00',2.47),('16273','2014-04-21','16:10:00',2.29),('16273','2014-04-21','16:15:00',2.17),('16273','2014-04-21','16:20:00',2.15),('16273','2014-04-21','16:25:00',2.11),('16273','2014-04-21','16:30:00',2.04),('16273','2014-04-21','16:35:00',1.96),('16273','2014-04-21','16:40:00',1.88),('16273','2014-04-21','16:45:00',1.8),('16273','2014-04-21','16:50:00',1.72),('16273','2014-04-21','16:55:00',1.64),('16273','2014-04-21','17:00:00',1.57),('16273','2014-04-21','17:05:00',1.49),('16273','2014-04-21','17:10:00',1.42),('16273','2014-04-21','17:15:00',1.34),('16273','2014-04-21','17:20:00',1.28),('16273','2014-04-21','17:25:00',1.21),('16273','2014-04-21','17:30:00',1.13),('16273','2014-04-21','17:35:00',1.05),('16273','2013-12-07','08:30:00',1.04),('16273','2013-12-07','08:35:00',1.2),('16273','2013-12-07','08:40:00',1.17),('16273','2013-12-07','08:45:00',1.41),('16273','2013-12-07','08:50:00',1.5),('16273','2013-12-07','08:55:00',1.54),('16273','2013-12-07','09:00:00',1.62),('16273','2013-12-07','09:05:00',1.69),('16273','2013-12-07','09:10:00',1.69),('16273','2013-12-07','09:15:00',1.8),('16273','2013-12-07','09:20:00',1.85),('16273','2013-12-07','09:25:00',1.9),('16273','2013-12-07','09:30:00',1.97),('16273','2013-12-07','09:35:00',2.04),('16273','2013-12-07','09:40:00',2.09),('16273','2013-12-07','09:45:00',2.11),('16273','2013-12-07','09:50:00',2.13),('16273','2013-12-07','09:55:00',2.18),('16273','2013-12-07','10:00:00',2.22),('16273','2013-12-07','10:05:00',2.28),('16273','2013-12-07','10:10:00',2.33),('16273','2013-12-07','10:15:00',2.34),('16273','2013-12-07','10:20:00',2.37),('16273','2013-12-07','10:25:00',2.4),('16273','2013-12-07','10:30:00',2.43),('16273','2013-12-07','10:35:00',2.42),('16273','2013-12-07','10:40:00',2.41),('16273','2013-12-07','10:45:00',2.44),('16273','2013-12-07','10:50:00',2.47),('16273','2013-12-07','10:55:00',2.46),('16273','2013-12-07','11:00:00',2.44),('16273','2013-12-07','11:05:00',2.49),('16273','2013-12-07','11:10:00',2.52),('16273','2013-12-07','11:15:00',2.49),('16273','2013-12-07','11:20:00',2.49),('16273','2013-12-07','11:25:00',2.48),('16273','2013-12-07','11:30:00',2.49),('16273','2013-12-07','11:35:00',2.47),('16273','2013-12-07','11:40:00',2.45),('16273','2013-12-07','11:45:00',2.43),('16273','2013-12-07','11:50:00',2.41),('16273','2013-12-07','11:55:00',2.39),('16273','2013-12-07','12:00:00',2.39),('16273','2013-12-07','12:05:00',2.35),('16273','2013-12-07','12:10:00',2.34),('16273','2013-12-07','12:15:00',2.32),('16273','2013-12-07','12:20:00',2.29),('16273','2013-12-07','12:25:00',2.24),('16273','2013-12-07','12:30:00',2.23),('16273','2013-12-07','12:35:00',2.18),('16273','2013-12-07','12:40:00',2.18),('16273','2013-12-07','12:45:00',2.14),('16273','2013-12-07','12:50:00',2.1),('16273','2013-12-07','12:55:00',2.08),('16273','2013-12-07','13:00:00',2.06),('16273','2013-12-07','13:05:00',2.03),('16273','2013-12-07','13:10:00',2),('16273','2013-12-07','13:15:00',1.96),('16273','2013-12-07','13:20:00',1.88),('16273','2013-12-07','13:25:00',1.82),('16273','2013-12-07','13:30:00',1.77),('16273','2013-12-07','13:35:00',1.73),('16273','2013-12-07','13:40:00',1.69),('16273','2013-12-07','13:45:00',1.64),('16273','2013-12-07','13:50:00',1.63),('16273','2013-12-07','13:55:00',1.59),('16273','2013-12-07','14:00:00',1.55),('16273','2013-12-07','14:05:00',1.48),('16273','2013-12-07','14:10:00',1.42),('16273','2013-12-07','14:15:00',1.36),('16273','2013-12-07','14:20:00',1.31),('16273','2013-12-07','14:25:00',1.25),('16273','2013-12-07','14:30:00',1.19),('16273','2013-12-07','14:35:00',1.15),('16273','2013-12-07','14:40:00',1.1),('16273','2013-12-07','14:45:00',1.05),('16273','2013-12-06','11:05:00',1.03),('16273','2013-12-06','11:20:00',1.11),('16273','2013-12-06','11:25:00',1.31),('16273','2013-12-06','11:30:00',1.43),('16273','2013-12-06','11:35:00',1.23),('16273','2013-12-06','11:40:00',1.68),('16273','2013-12-06','11:45:00',1.92),('16273','2013-12-06','11:50:00',1.82),('16273','2013-12-06','11:55:00',1.55),('16273','2013-12-06','12:00:00',1.88),('16273','2013-12-06','12:05:00',2.11),('16273','2013-12-06','12:10:00',2.45),('16273','2013-12-06','12:15:00',2.45),('16273','2013-12-06','12:20:00',2.6),('16273','2013-12-06','12:25:00',1.25),('16273','2013-12-06','12:30:00',1.17),('16273','2013-12-06','12:35:00',1.2),('16273','2013-12-06','14:40:00',1.31),('16273','2013-12-06','14:45:00',1.23),('16273','2013-12-06','14:50:00',1.1),('16273','2013-12-05','08:30:00',1.08),('16273','2013-12-05','08:35:00',1.05),('16273','2013-12-05','08:40:00',1.38),('16273','2013-12-05','08:45:00',1.46),('16273','2013-12-05','08:50:00',1.56),('16273','2013-12-05','08:55:00',1.63),('16273','2013-12-05','09:00:00',1.72),('16273','2013-12-05','09:05:00',1.79),('16273','2013-12-05','09:10:00',1.84),('16273','2013-12-05','09:15:00',1.91),('16273','2013-12-05','09:20:00',1.98),('16273','2013-12-05','09:25:00',2.03),('16273','2013-12-05','09:30:00',2.09),('16273','2013-12-05','09:35:00',2.13),('16273','2013-12-05','09:40:00',2.17),('16273','2013-12-05','09:45:00',2.21),('16273','2013-12-05','09:50:00',2.26),('16273','2013-12-05','09:55:00',2.28),('16273','2013-12-05','10:00:00',2.33),('16273','2013-12-05','10:05:00',2.36),('16273','2013-12-05','10:10:00',2.37),('16273','2013-12-05','10:15:00',2.41),('16273','2013-12-05','10:20:00',2.42),('16273','2013-12-05','10:25:00',2.44),('16273','2013-12-05','10:30:00',2.47),('16273','2013-12-05','10:35:00',2.47),('16273','2013-12-05','10:40:00',2.48),('16273','2013-12-05','10:45:00',2.5),('16273','2013-12-05','10:50:00',2.5),('16273','2013-12-05','10:55:00',2.54),('16273','2013-12-05','11:00:00',2.53),('16273','2013-12-05','11:05:00',2.57),('16273','2013-12-05','11:10:00',2.53),('16273','2013-12-05','11:15:00',2.56),('16273','2013-12-05','11:20:00',2.52),('16273','2013-12-05','11:25:00',2.52),('16273','2013-12-05','11:30:00',2.53),('16273','2013-12-05','11:35:00',2.51),('16273','2013-12-05','11:40:00',2.49),('16273','2013-12-05','11:45:00',2.5),('16273','2013-12-05','11:50:00',2.48),('16273','2013-12-05','11:55:00',2.43),('16273','2013-12-05','12:00:00',2.5),('16273','2013-12-05','12:05:00',2.38),('16273','2013-12-05','12:10:00',2.49),('16273','2013-12-05','12:15:00',2.35),('16273','2013-12-05','12:20:00',2.41),('16273','2013-12-05','12:25:00',2.34),('16273','2013-12-05','12:30:00',2.31),('16273','2013-12-05','12:35:00',2.29),('16273','2013-12-05','12:40:00',2.29),('16273','2013-12-05','12:45:00',2.28),('16273','2013-12-05','12:50:00',2.19),('16273','2013-12-05','12:55:00',2.12),('16273','2013-12-05','13:00:00',2.04),('16273','2013-12-05','13:05:00',2.1),('16273','2013-12-05','13:10:00',2.02),('16273','2013-12-05','13:15:00',2.01),('16273','2013-12-05','13:20:00',1.93),('16273','2013-12-05','13:25:00',1.99),('16273','2013-12-05','13:30:00',1.91),('16273','2013-12-05','13:35:00',1.78),('16273','2013-12-05','13:40:00',1.61),('16273','2013-12-05','13:45:00',1.7),('16273','2013-12-05','13:50:00',1.72),('16273','2013-12-05','14:00:00',1.22),('16273','2013-12-05','14:05:00',1.66),('16273','2013-12-05','14:10:00',1.48),('16273','2013-12-05','14:15:00',1.4),('16273','2013-12-05','14:20:00',1.36),('16273','2013-12-05','14:25:00',1.3),('16273','2013-12-05','14:30:00',1.26),('16273','2013-12-05','14:35:00',1.2),('16273','2013-12-05','14:40:00',1.12),('16273','2013-12-05','14:45:00',1.09),('16273','2013-12-04','08:30:00',1.29),('16273','2013-12-04','08:35:00',1.26),('16273','2013-12-04','08:40:00',1.59),('16273','2013-12-04','08:45:00',1.68),('16273','2013-12-04','08:50:00',1.77),('16273','2013-12-04','08:55:00',1.82),('16273','2013-12-04','09:00:00',1.9),('16273','2013-12-04','09:05:00',1.96),('16273','2013-12-04','09:10:00',2.02),('16273','2013-12-04','09:15:00',2.08),('16273','2013-12-04','09:20:00',2.13),('16273','2013-12-04','09:25:00',2.18),('16273','2013-12-04','09:30:00',2.24),('16273','2013-12-04','09:35:00',2.29),('16273','2013-12-04','09:40:00',2.33),('16273','2013-12-04','09:45:00',2.37),('16273','2013-12-04','09:50:00',2.4),('16273','2013-12-04','09:55:00',2.44),('16273','2013-12-04','10:00:00',2.48),('16273','2013-12-04','10:05:00',2.5),('16273','2013-12-04','10:10:00',2.51),('16273','2013-12-04','10:15:00',2.55),('16273','2013-12-04','10:20:00',2.59),('16273','2013-12-04','10:25:00',2.6),('16273','2013-12-04','10:30:00',2.62),('16273','2013-12-04','10:35:00',2.65),('16273','2013-12-04','10:40:00',2.64),('16273','2013-12-04','10:45:00',2.67),('16273','2013-12-04','10:50:00',2.67),('16273','2013-12-04','10:55:00',2.68),('16273','2013-12-04','11:00:00',2.69),('16273','2013-12-04','11:05:00',2.7),('16273','2013-12-04','11:10:00',2.7),('16273','2013-12-04','11:15:00',2.71),('16273','2013-12-04','11:20:00',2.71),('16273','2013-12-04','11:25:00',2.69),('16273','2013-12-04','11:30:00',2.69),('16273','2013-12-04','11:35:00',2.68),('16273','2013-12-04','11:40:00',2.66),('16273','2013-12-04','11:45:00',2.64),('16273','2013-12-04','11:50:00',2.62),('16273','2013-12-04','11:55:00',2.6),('16273','2013-12-04','12:00:00',2.6),('16273','2013-12-04','12:05:00',2.58),('16273','2013-12-04','12:10:00',2.57),('16273','2013-12-04','12:15:00',2.54),('16273','2013-12-04','12:20:00',2.53),('16273','2013-12-04','12:25:00',2.48),('16273','2013-12-04','12:30:00',2.46),('16273','2013-12-04','12:35:00',2.44),('16273','2013-12-04','12:40:00',2.42),('16273','2013-12-04','12:45:00',2.38),('16273','2013-12-04','12:50:00',2.33),('16273','2013-12-04','12:55:00',2.29),('16273','2013-12-04','13:00:00',2.24),('16273','2013-12-04','13:05:00',2.21),('16273','2013-12-04','13:10:00',2.17),('16273','2013-12-04','13:15:00',2.14),('16273','2013-12-04','13:20:00',2.09),('16273','2013-12-04','13:25:00',2.04),('16273','2013-12-04','13:30:00',1.99),('16273','2013-12-04','13:35:00',1.94),('16273','2013-12-04','13:40:00',1.86),('16273','2013-12-04','13:45:00',1.82),('16273','2013-12-04','13:50:00',1.78),('16273','2013-12-04','13:55:00',1.73),('16273','2013-12-04','14:00:00',1.68),('16273','2013-12-04','14:05:00',1.61),('16273','2013-12-04','14:10:00',1.55),('16273','2013-12-04','14:15:00',1.49),('16273','2013-12-04','14:20:00',1.44),('16273','2013-12-04','14:25:00',1.38),('16273','2013-12-04','14:30:00',1.33),('16273','2013-12-04','14:35:00',1.27),('16273','2013-12-04','14:40:00',1.21),('16273','2013-12-04','14:45:00',1.16),('16273','2013-12-04','14:50:00',1.1),('16273','2013-12-03','09:00:00',1.14),('16273','2013-12-03','09:20:00',1.1),('16273','2013-12-03','09:25:00',1.4),('16273','2013-12-03','09:30:00',1.82),('16273','2013-12-03','09:35:00',2.06),('16273','2013-12-03','09:40:00',2.19),('16273','2013-12-03','09:45:00',2.16),('16273','2013-12-03','09:50:00',2.38),('16273','2013-12-03','09:55:00',2.3),('16273','2013-12-03','10:00:00',2.44),('16273','2013-12-03','10:05:00',2.4),('16273','2013-12-03','10:10:00',2.48),('16273','2013-12-03','10:15:00',2.52),('16273','2013-12-03','10:20:00',2.54),('16273','2013-12-03','10:25:00',2.55),('16273','2013-12-03','10:30:00',2.58),('16273','2013-12-03','10:35:00',2.56),('16273','2013-12-03','10:40:00',2.6),('16273','2013-12-03','10:45:00',2.61),('16273','2013-12-03','10:50:00',2.63),('16273','2013-12-03','10:55:00',2.65),('16273','2013-12-03','11:00:00',2.68),('16273','2013-12-03','11:05:00',2.7),('16273','2013-12-03','11:10:00',2.72),('16273','2013-12-03','11:15:00',2.73),('16273','2013-12-03','11:20:00',2.73),('16273','2013-12-03','11:25:00',2.73),('16273','2013-12-03','11:30:00',2.71),('16273','2013-12-03','11:35:00',2.71),('16273','2013-12-03','11:40:00',2.7),('16273','2013-12-03','11:45:00',2.7),('16273','2013-12-03','11:50:00',2.67),('16273','2013-12-03','11:55:00',2.68),('16273','2013-12-03','12:00:00',2.67),('16273','2013-12-03','12:05:00',2.68),('16273','2013-12-03','12:10:00',2.68),('16273','2013-12-03','12:15:00',2.66),('16273','2013-12-03','12:20:00',2.66),('16273','2013-12-03','12:25:00',2.66),('16273','2013-12-03','12:30:00',2.66),('16273','2013-12-03','12:35:00',2.67),('16273','2013-12-03','12:40:00',2.67),('16273','2013-12-03','12:45:00',2.68),('16273','2013-12-03','12:50:00',2.7),('16273','2013-12-03','12:55:00',2.76),('16273','2013-12-03','13:00:00',2.81),('16273','2013-12-03','13:05:00',2.8),('16273','2013-12-03','13:10:00',2.77),('16273','2013-12-03','13:15:00',2.71),('16273','2013-12-03','13:20:00',2.58),('16273','2013-12-03','13:25:00',2.18),('16273','2013-12-03','13:30:00',1.6),('16273','2013-12-03','13:35:00',1.42),('16273','2013-12-03','13:40:00',1.51),('16273','2013-12-03','13:45:00',1.5),('16273','2013-12-03','13:50:00',1.28),('16273','2013-12-03','14:10:00',1.12),('16273','2013-12-03','14:15:00',1.34),('16273','2013-12-03','14:20:00',1.37),('16273','2013-12-03','14:25:00',1.28),('16273','2013-12-03','14:30:00',1.31),('16273','2013-12-03','14:35:00',1.26),('16273','2013-12-03','14:40:00',1.2),('16273','2013-12-03','14:45:00',1.14),('16273','2013-12-03','14:50:00',1.08),('16273','2013-12-01','11:25:00',1.1),('16273','2013-12-01','11:30:00',1.12),('16273','2013-12-01','11:35:00',1.45),('16273','2013-12-01','11:40:00',1.66),('16273','2013-12-01','11:45:00',1.76),('16273','2013-12-01','11:50:00',1.59),('16273','2013-12-01','11:55:00',1.63),('16273','2013-12-01','12:00:00',2.14),('16273','2013-12-01','12:05:00',2.35),('16273','2013-12-01','12:10:00',1.98),('16273','2013-12-01','12:15:00',1.64),('16273','2013-11-30','09:05:00',1.26),('16273','2013-11-30','09:10:00',1.8),('16273','2013-11-30','09:15:00',1.65),('16273','2013-11-30','09:20:00',1.15),('16273','2013-11-30','09:25:00',1.56),('16273','2013-11-30','09:30:00',1.77),('16273','2013-11-30','09:35:00',1.26),('16273','2013-11-30','09:40:00',1.16),('16273','2013-11-30','09:45:00',1.03),('16273','2013-11-30','10:15:00',1.05),('16273','2013-11-30','10:20:00',1.23),('16273','2013-11-30','10:25:00',1.04),('16273','2013-11-30','10:30:00',1),('16273','2013-11-30','10:40:00',1.01),('16273','2013-11-30','10:50:00',1.08),('16273','2013-11-30','10:55:00',1.17),('16273','2013-11-30','11:00:00',1.03),('16273','2013-11-30','11:05:00',1.06),('16273','2013-11-30','11:10:00',1.12),('16273','2013-11-30','11:15:00',1.12),('16273','2013-11-30','11:20:00',1.14),('16273','2013-11-30','11:25:00',1.11),('16273','2013-11-30','11:30:00',1.05),('16273','2013-11-29','08:25:00',1.2),('16273','2013-11-29','08:30:00',1.19),('16273','2013-11-29','08:35:00',1.46),('16273','2013-11-29','08:40:00',1.55),('16273','2013-11-29','08:45:00',1.64),('16273','2013-11-29','08:50:00',1.71),('16273','2013-11-29','08:55:00',1.78),('16273','2013-11-29','09:00:00',1.87),('16273','2013-11-29','09:05:00',1.95),('16273','2013-11-29','09:10:00',2.01),('16273','2013-11-29','09:15:00',2.06),('16273','2013-11-29','09:20:00',2.11),('16273','2013-11-29','09:25:00',2.15),('16273','2013-11-29','09:30:00',2.22),('16273','2013-11-29','09:35:00',2.29),('16273','2013-11-29','09:40:00',2.34),('16273','2013-11-29','09:45:00',2.37),('16273','2013-11-29','09:50:00',2.42),('16273','2013-11-29','09:55:00',2.46),('16273','2013-11-29','10:00:00',2.49),('16273','2013-11-29','10:05:00',2.53),('16273','2013-11-29','10:10:00',2.57),('16273','2013-11-29','10:15:00',2.6),('16273','2013-11-29','10:20:00',2.63),('16273','2013-11-29','10:25:00',2.66),('16273','2013-11-29','10:30:00',2.68),('16273','2013-11-29','10:35:00',2.7),('16273','2013-11-29','10:40:00',2.72),('16273','2013-11-29','10:45:00',2.73),('16273','2013-11-29','10:50:00',2.74),('16273','2013-11-29','10:55:00',2.75),('16273','2013-11-29','11:00:00',2.75),('16273','2013-11-29','11:05:00',2.75),('16273','2013-11-29','11:10:00',2.74),('16273','2013-11-29','11:15:00',2.73),('16273','2013-11-29','11:20:00',2.74),('16273','2013-11-29','11:25:00',2.74),('16273','2013-11-29','11:30:00',2.74),('16273','2013-11-29','11:35:00',2.73),('16273','2013-11-29','11:40:00',2.71),('16273','2013-11-29','11:45:00',2.7),('16273','2013-11-29','11:50:00',2.68),('16273','2013-11-29','11:55:00',2.68),('16273','2013-11-29','12:00:00',2.66),('16273','2013-11-29','12:05:00',2.63),('16273','2013-11-29','12:10:00',2.61),('16273','2013-11-29','12:15:00',2.56),('16273','2013-11-29','12:20:00',2.53),('16273','2013-11-29','12:25:00',2.52),('16273','2013-11-29','12:30:00',2.49),('16273','2013-11-29','12:35:00',2.45),('16273','2013-11-29','12:40:00',2.43),('16273','2013-11-29','12:45:00',2.38),('16273','2013-11-29','12:50:00',2.35),('16273','2013-11-29','12:55:00',2.32),('16273','2013-11-29','13:00:00',2.28),('16273','2013-11-29','13:05:00',2.25),('16273','2013-11-29','13:10:00',2.21),('16273','2013-11-29','13:15:00',2.18),('16273','2013-11-29','13:20:00',2.13),('16273','2013-11-29','13:25:00',2.08),('16273','2013-11-29','13:30:00',2.02),('16273','2013-11-29','13:35:00',1.97),('16273','2013-11-29','13:40:00',1.92),('16273','2013-11-29','13:45:00',1.86),('16273','2013-11-29','13:50:00',1.81),('16273','2013-11-29','13:55:00',1.74),('16273','2013-11-29','14:00:00',1.67),('16273','2013-11-29','14:05:00',1.61),('16273','2013-11-29','14:10:00',1.55),('16273','2013-11-29','14:15:00',1.51),('16273','2013-11-29','14:20:00',1.44),('16273','2013-11-29','14:25:00',1.38),('16273','2013-11-29','14:30:00',1.33),('16273','2013-11-29','14:35:00',1.27),('16273','2013-11-29','14:40:00',1.2),('16273','2013-11-29','14:45:00',1.15),('16273','2013-11-29','14:50:00',1.09),('16273','2014-04-20','07:35:00',1.14),('16273','2014-04-20','07:40:00',1.19),('16273','2014-04-20','07:45:00',1.27),('16273','2014-04-20','07:50:00',1.08),('16273','2014-04-20','07:55:00',1.34),('16273','2014-04-20','08:00:00',1.52),('16273','2014-04-20','08:05:00',1.11),('16273','2014-04-20','08:10:00',1.1),('16273','2014-04-20','08:15:00',1.88),('16273','2014-04-20','08:20:00',2.76),('16273','2014-04-20','08:40:00',1.97),('16273','2014-04-20','08:45:00',2.13),('16273','2014-04-20','08:50:00',2.43),('16273','2014-04-20','08:55:00',2.47),('16273','2014-04-20','09:00:00',2.5),('16273','2014-04-20','09:05:00',2.61),('16273','2014-04-20','09:10:00',2.24),('16273','2014-04-20','09:15:00',2.26),('16273','2014-04-20','09:20:00',3.06),('16273','2014-04-20','09:25:00',2.32),('16273','2014-04-20','09:30:00',2.13),('16273','2014-04-20','09:35:00',2.93),('16273','2014-04-20','09:40:00',2.1),('16273','2014-04-20','09:45:00',1.88),('16273','2014-04-20','09:50:00',1.81),('16273','2014-04-20','09:55:00',2.35),('16273','2014-04-20','10:00:00',1.81),('16273','2014-04-20','10:05:00',2.42),('16273','2014-04-20','10:10:00',2.43),('16273','2014-04-20','10:15:00',3.22),('16273','2014-04-20','10:20:00',3.07),('16273','2014-04-20','10:25:00',2.46),('16273','2014-04-20','10:30:00',2.52),('16273','2014-04-20','10:35:00',2.47),('16273','2014-04-20','10:40:00',2.28),('16273','2014-04-20','10:45:00',2.44),('16273','2014-04-20','10:50:00',2.85),('16273','2014-04-20','10:55:00',3.23),('16273','2014-04-20','11:00:00',3.03),('16273','2014-04-20','11:05:00',3.17),('16273','2014-04-20','11:10:00',3.74),('16273','2014-04-20','11:15:00',3.71),('16273','2014-04-20','11:20:00',3.78),('16273','2014-04-20','11:25:00',3.89),('16273','2014-04-20','11:30:00',3.99),('16273','2014-04-20','11:35:00',3.94),('16273','2014-04-20','11:40:00',3.94),('16273','2014-04-20','11:45:00',3.93),('16273','2014-04-20','11:50:00',3.92),('16273','2014-04-20','11:55:00',3.88),('16273','2014-04-20','12:00:00',3.89),('16273','2014-04-20','12:05:00',3.92),('16273','2014-04-20','12:10:00',3.94),('16273','2014-04-20','12:15:00',3.94),('16273','2014-04-20','12:20:00',3.92),('16273','2014-04-20','12:25:00',3.92),('16273','2014-04-20','12:30:00',3.91),('16273','2014-04-20','12:35:00',3.93),('16273','2014-04-20','12:40:00',3.94),('16273','2014-04-20','12:45:00',3.89),('16273','2014-04-20','12:50:00',3.88),('16273','2014-04-20','12:55:00',3.84),('16273','2014-04-20','13:00:00',3.84),('16273','2014-04-20','13:05:00',3.71),('16273','2014-04-20','13:10:00',3.29),('16273','2014-04-20','13:15:00',3.84),('16273','2014-04-20','13:20:00',3.83),('16273','2014-04-20','13:25:00',3.8),('16273','2014-04-20','13:30:00',3.78),('16273','2014-04-20','13:35:00',3.76),('16273','2014-04-20','13:40:00',3.74),('16273','2014-04-20','13:45:00',3.67),('16273','2014-04-20','13:50:00',3.67),('16273','2014-04-20','13:55:00',3.64),('16273','2014-04-20','14:00:00',3.64),('16273','2014-04-20','14:05:00',3.66),('16273','2014-04-20','14:10:00',3.85),('16273','2014-04-20','14:15:00',2.98),('16273','2014-04-20','14:20:00',2.24),('16273','2014-04-20','14:25:00',2.25),('16273','2014-04-20','14:30:00',2.05),('16273','2014-04-20','14:35:00',1.98),('16273','2014-04-20','14:40:00',2.04),('16273','2014-04-20','14:45:00',2.2),('16273','2014-04-20','14:50:00',2.42),('16273','2014-04-20','14:55:00',2.81),('16273','2014-04-20','15:00:00',3.81),('16273','2014-04-20','15:05:00',2.96),('16273','2014-04-20','15:10:00',2.54),('16273','2014-04-20','15:15:00',3.09),('16273','2014-04-20','15:20:00',3),('16273','2014-04-20','15:25:00',2.93),('16273','2014-04-20','15:30:00',2.88),('16273','2014-04-20','15:35:00',2.9),('16273','2014-04-20','15:40:00',2.03),('16273','2014-04-20','15:45:00',2.22),('16273','2014-04-20','15:50:00',2.73),('16273','2014-04-20','15:55:00',2.54),('16273','2014-04-20','16:00:00',2.5),('16273','2014-04-20','16:05:00',2.41),('16273','2014-04-20','16:10:00',2.34),('16273','2014-04-20','16:15:00',2.24),('16273','2014-04-20','16:20:00',2.22),('16273','2014-04-20','16:25:00',2.29),('16273','2014-04-20','16:30:00',1.97),('16273','2014-04-20','16:35:00',1.95),('16273','2014-04-20','16:40:00',1.23),('16273','2014-04-20','16:45:00',1.53),('16273','2014-04-20','16:50:00',1.92),('16273','2014-04-20','16:55:00',1.74),('16273','2014-04-20','17:00:00',1.63),('16273','2014-04-20','17:05:00',1.53),('16273','2014-04-20','17:10:00',1.43),('16273','2014-04-20','17:15:00',1.34),('16273','2014-04-20','17:20:00',1.27),('16273','2014-04-20','17:25:00',1.19),('16273','2014-04-20','17:30:00',1.11),('16273','2014-04-20','17:35:00',1.04),('16273','2013-11-27','08:50:00',1.13),('16273','2013-11-27','08:55:00',1.02),('16273','2013-11-27','09:00:00',1.2),('16273','2013-11-27','09:25:00',1.34),('16273','2013-11-27','09:30:00',1.09),('16273','2013-11-27','09:35:00',1.03),('16273','2013-11-27','09:55:00',1.01),('16273','2013-11-27','10:00:00',1.19),('16273','2013-11-27','10:05:00',1.4),('16273','2013-11-27','10:10:00',1.15),('16273','2013-11-27','10:15:00',1.36),('16273','2013-11-27','10:20:00',1.25),('16273','2013-11-27','10:25:00',1.3),('16273','2013-11-27','10:30:00',1.13),('16273','2013-11-27','10:35:00',1.04),('16273','2013-11-27','10:40:00',1.07),('16273','2013-11-27','10:45:00',1.32),('16273','2013-11-27','10:50:00',1.21),('16273','2013-11-27','10:55:00',1.21),('16273','2013-11-27','11:00:00',1.36),('16273','2013-11-27','11:05:00',1.51),('16273','2013-11-27','11:10:00',1.54),('16273','2013-11-27','11:15:00',3.15),('16273','2013-11-27','11:20:00',2.43),('16273','2013-11-27','11:25:00',1.4),('16273','2013-11-27','11:30:00',1.85),('16273','2013-11-27','11:35:00',1.67),('16273','2013-11-27','11:40:00',2.3),('16273','2013-11-27','11:45:00',2.76),('16273','2013-11-27','11:50:00',3.15),('16273','2013-11-27','11:55:00',1.67),('16273','2013-11-27','12:00:00',1.77),('16273','2013-11-27','12:05:00',1.4),('16273','2013-11-27','12:10:00',1.45),('16273','2013-11-27','12:15:00',1.58),('16273','2013-11-27','12:20:00',1.63),('16273','2013-11-27','12:25:00',1.29),('16273','2013-11-27','12:30:00',1.31),('16273','2013-11-27','12:35:00',1.12),('16273','2013-11-27','12:40:00',1.05),('16273','2013-11-27','13:25:00',1.01),('16273','2013-11-26','08:40:00',1.05),('16273','2013-11-26','08:45:00',1.1),('16273','2013-11-26','09:00:00',1.03),('16273','2013-11-26','09:05:00',1.53),('16273','2013-11-26','09:10:00',1.52),('16273','2013-11-26','09:35:00',1.02),('16273','2013-11-26','09:40:00',1.22),('16273','2013-11-26','09:45:00',1.65),('16273','2013-11-26','09:50:00',2.01),('16273','2013-11-26','09:55:00',1.87),('16273','2013-11-26','10:00:00',2.01),('16273','2013-11-26','10:20:00',1.49),('16273','2013-11-26','10:25:00',2.43),('16273','2013-11-26','10:30:00',3.01),('16273','2013-11-26','10:35:00',2.96),('16273','2013-11-26','10:40:00',2.93),('16273','2013-11-26','10:45:00',2.99),('16273','2013-11-26','10:50:00',2.99),('16273','2013-11-26','10:55:00',3.03),('16273','2013-11-26','11:00:00',3.07),('16273','2013-11-26','11:05:00',2.47),('16273','2013-11-26','11:10:00',1.06),('16273','2013-11-26','11:15:00',1.08),('16273','2013-11-26','11:20:00',1.29),('16273','2013-11-26','11:25:00',2.45),('16273','2013-11-26','11:30:00',2.45),('16273','2013-11-26','11:35:00',1.59),('16273','2013-11-26','11:40:00',1.63),('16273','2013-11-26','11:45:00',1.55),('16273','2013-11-26','11:50:00',3.24),('16273','2013-11-26','11:55:00',3.12),('16273','2013-11-26','12:00:00',3.37),('16273','2013-11-26','12:05:00',3.01),('16273','2013-11-26','12:10:00',2.59),('16273','2013-11-26','12:15:00',1.91),('16273','2013-11-26','12:20:00',2.97),('16273','2013-11-26','12:25:00',2.58),('16273','2013-11-26','12:30:00',1.05),('16273','2013-11-26','12:35:00',2.65),('16273','2013-11-26','12:40:00',2.7),('16273','2013-11-26','12:45:00',2.62),('16273','2013-11-26','12:50:00',2.58),('16273','2013-11-26','12:55:00',2.54),('16273','2013-11-26','13:00:00',2.49),('16273','2013-11-26','13:05:00',2.43),('16273','2013-11-26','13:10:00',2.38),('16273','2013-11-26','13:15:00',2.33),('16273','2013-11-26','13:20:00',2.29),('16273','2013-11-26','13:25:00',2.24),('16273','2013-11-26','13:30:00',1.86),('16273','2013-11-26','13:35:00',1.13),('16273','2013-11-26','13:40:00',1.97),('16273','2013-11-26','13:45:00',2.05),('16273','2013-11-26','13:50:00',2.05),('16273','2013-11-26','13:55:00',2.11),('16273','2013-11-26','14:00:00',2.02),('16273','2013-11-26','14:05:00',2),('16273','2013-11-26','14:10:00',1.88),('16273','2013-11-26','14:15:00',1.81),('16273','2013-11-26','14:20:00',1.34),('16273','2013-11-26','14:35:00',1.31),('16273','2013-11-26','14:40:00',1.23),('16273','2013-11-26','14:45:00',1.27),('16273','2013-11-26','14:50:00',1.27),('16273','2013-11-26','14:55:00',1.17),('16273','2013-11-25','08:15:00',1.03),('16273','2013-11-25','08:20:00',1.31),('16273','2013-11-25','08:25:00',1.51),('16273','2013-11-25','08:30:00',1.4),('16273','2013-11-25','08:35:00',1.83),('16273','2013-11-25','08:40:00',2.03),('16273','2013-11-25','08:45:00',2.26),('16273','2013-11-25','08:50:00',1.84),('16273','2013-11-25','09:20:00',1.56),('16273','2013-11-25','09:25:00',1.29),('16273','2013-11-25','09:30:00',1.05),('16273','2013-11-25','09:35:00',1.12),('16273','2013-11-25','09:40:00',1.01),('16273','2013-11-25','09:45:00',1.06),('16273','2013-11-25','09:50:00',1.2),('16273','2013-11-25','09:55:00',2.21),('16273','2013-11-25','10:00:00',1.65),('16273','2013-11-25','10:05:00',2.33),('16273','2013-11-25','10:10:00',2.14),('16273','2013-11-25','10:15:00',2.21),('16273','2013-11-25','10:20:00',2.66),('16273','2013-11-25','10:25:00',2.53),('16273','2013-11-25','10:30:00',2.17),('16273','2013-11-25','10:35:00',2.21),('16273','2013-11-25','10:40:00',2.93),('16273','2013-11-25','10:45:00',2.83),('16273','2013-11-25','10:50:00',2.71),('16273','2013-11-25','10:55:00',2.75),('16273','2013-11-25','11:00:00',2.7),('16273','2013-11-25','11:05:00',2.82),('16273','2013-11-25','11:10:00',2.31),('16273','2013-11-25','11:15:00',1.77),('16273','2013-11-25','11:20:00',1.03),('16273','2013-11-25','11:25:00',1.22),('16273','2013-11-25','11:30:00',1.36),('16273','2013-11-25','11:45:00',2.64),('16273','2013-11-25','11:50:00',1.76),('16273','2013-11-25','11:55:00',2.09),('16273','2013-11-25','12:00:00',2.08),('16273','2013-11-25','12:05:00',1.4),('16273','2013-11-25','12:10:00',1.25),('16273','2013-11-25','12:15:00',1.29),('16273','2013-11-25','12:20:00',1.45),('16273','2013-11-25','12:25:00',2.05),('16273','2013-11-25','12:30:00',1.4),('16273','2013-11-25','12:35:00',1.26),('16273','2013-11-25','12:40:00',1.91),('16273','2013-11-25','12:45:00',2.22),('16273','2013-11-25','12:50:00',2.56),('16273','2013-11-25','12:55:00',2.63),('16273','2013-11-25','13:00:00',2.42),('16273','2013-11-25','13:05:00',2.71),('16273','2013-11-25','13:10:00',2.55),('16273','2013-11-25','13:15:00',2.73),('16273','2013-11-25','13:20:00',2.79),('16273','2013-11-25','13:25:00',2.55),('16273','2013-11-25','13:30:00',1.04),('16273','2013-11-25','13:45:00',1.15),('16273','2013-11-25','13:50:00',1.36),('16273','2013-11-24','09:55:00',1.06),('16273','2013-11-24','10:00:00',1.42),('16273','2013-11-24','10:05:00',1.49),('16273','2013-11-24','10:10:00',1.38),('16273','2013-11-24','10:15:00',1.41),('16273','2013-11-24','10:20:00',1.37),('16273','2013-11-24','10:25:00',1.65),('16273','2013-11-24','10:30:00',1.55),('16273','2013-11-24','10:35:00',1.15),('16273','2013-11-24','11:15:00',1.14),('16273','2013-11-24','11:20:00',1.33),('16273','2013-11-24','11:25:00',1.21),('16273','2013-11-24','11:30:00',1.08),('16273','2013-11-24','12:40:00',1.16),('16273','2013-11-24','12:45:00',1.33),('16273','2013-11-24','12:50:00',1.36),('16273','2013-11-24','12:55:00',1.59),('16273','2013-11-24','13:00:00',1.52),('16273','2013-11-24','13:05:00',1.45),('16273','2013-11-24','13:10:00',1.37),('16273','2013-11-24','13:15:00',1.39),('16273','2013-11-24','13:20:00',1.35),('16273','2013-11-24','13:25:00',1.28),('16273','2013-11-24','13:30:00',1.21),('16273','2013-11-24','13:35:00',1.08),('16273','2013-11-23','08:40:00',1.82),('16273','2013-11-23','10:15:00',1.01),('16273','2013-11-23','10:25:00',1.73),('16273','2013-11-23','10:30:00',2.62),('16273','2013-11-22','12:15:00',1.01),('16273','2013-11-22','12:20:00',1.08),('16273','2013-11-21','08:05:00',1.06),('16273','2013-11-21','09:40:00',1.98),('16273','2013-11-21','09:45:00',1.75),('16273','2013-11-21','09:50:00',2.36),('16273','2013-11-21','09:55:00',1.95),('16273','2013-11-21','10:00:00',2.74),('16273','2013-11-21','10:05:00',1.78),('16273','2013-11-21','10:10:00',2.13),('16273','2013-11-21','10:15:00',2.07),('16273','2013-11-21','10:20:00',2.78),('16273','2013-11-21','10:25:00',3.13),('16273','2013-11-21','10:30:00',2.94),('16273','2013-11-21','10:35:00',1.97),('16273','2013-11-21','10:55:00',1.67),('16273','2013-11-21','11:00:00',1.12),('16273','2013-11-21','11:10:00',2.14),('16273','2013-11-21','11:15:00',3.06),('16273','2013-11-21','11:20:00',2.66),('16273','2013-11-21','11:30:00',2.95),('16273','2013-11-21','11:35:00',2.93),('16273','2013-11-21','11:40:00',2.89),('16273','2013-11-21','11:45:00',2.86),('16273','2013-11-21','11:50:00',2.86),('16273','2013-11-21','11:55:00',2.85),('16273','2013-11-21','12:00:00',2.9),('16273','2013-11-21','12:05:00',2.87),('16273','2013-11-21','12:10:00',2.94),('16273','2013-11-21','12:15:00',3.07),('16273','2013-11-21','12:20:00',3.06),('16273','2013-11-21','12:25:00',3.27),('16273','2013-11-21','12:30:00',3.26),('16273','2013-11-21','12:35:00',3.04),('16273','2013-11-21','12:40:00',3.04),('16273','2013-11-21','12:45:00',1.22),('16273','2013-11-21','12:50:00',1.63),('16273','2013-11-21','13:05:00',2.08),('16273','2013-11-21','13:10:00',2.32),('16273','2013-11-21','13:15:00',2.29),('16273','2013-11-21','13:20:00',1.34),('16273','2013-11-21','13:40:00',1.84),('16273','2013-11-21','13:45:00',1.07),('16273','2013-11-21','13:50:00',1.4),('16273','2013-11-21','13:55:00',1.65),('16273','2013-11-21','14:00:00',1.63),('16273','2013-11-21','14:05:00',1.04),('16273','2013-11-21','14:10:00',1.04),('16273','2013-11-21','14:25:00',1.48),('16273','2013-11-21','14:30:00',1.43),('16273','2013-11-21','14:35:00',1.37),('16273','2013-11-21','14:40:00',1.17),('16273','2013-11-21','14:50:00',1.19),('16273','2013-11-21','14:55:00',1.03),('16273','2013-11-20','08:50:00',1.29),('16273','2013-11-20','08:55:00',2.03),('16273','2013-11-20','09:00:00',1.75),('16273','2013-11-20','09:05:00',1.94),('16273','2013-11-20','09:10:00',2.36),('16273','2013-11-20','09:15:00',2.06),('16273','2013-11-20','09:50:00',1.54),('16273','2013-11-20','11:15:00',1.03),('16273','2013-11-20','11:20:00',2.13),('16273','2013-11-20','11:25:00',1.82),('16273','2013-11-20','11:30:00',1.65),('16273','2013-11-20','11:35:00',1.22),('16273','2013-11-20','11:50:00',1.36),('16273','2013-11-20','12:10:00',1.48),('16273','2013-11-20','12:15:00',1.25),('16273','2013-11-20','12:20:00',1.34),('16273','2013-11-20','12:35:00',1.15),('16273','2013-11-20','12:40:00',1.11),('16273','2013-11-20','12:50:00',1.11),('16273','2013-11-20','12:55:00',1.38),('16273','2013-11-20','13:00:00',1.31),('16273','2013-11-20','13:10:00',1.12),('16273','2013-11-20','13:15:00',1.32),('16273','2013-11-20','13:20:00',2.35),('16273','2013-11-20','13:25:00',1.94),('16273','2013-11-20','13:45:00',1.01),('16273','2013-11-20','14:15:00',1.24),('16273','2013-11-20','14:30:00',1.13),('16273','2013-11-20','14:50:00',1.12),('16273','2013-11-20','14:55:00',1.05),('16273','2013-11-19','09:15:00',1.65),('16273','2013-11-19','09:30:00',1.52),('16273','2013-11-19','09:35:00',2.42),('16273','2013-11-19','09:40:00',2.33),('16273','2013-11-19','09:45:00',2.42),('16273','2013-11-19','09:50:00',2.41),('16273','2013-11-19','09:55:00',2.51),('16273','2013-11-19','10:00:00',2.6),('16273','2013-11-19','10:05:00',1.97),('16273','2013-11-19','10:10:00',1.91),('16273','2013-11-19','10:15:00',1.21),('16273','2013-11-19','10:55:00',1.2),('16273','2013-11-19','11:20:00',1.02),('16273','2013-11-19','11:25:00',1.93),('16273','2013-11-19','11:30:00',2.88),('16273','2013-11-19','11:35:00',2.06),('16273','2013-11-19','11:40:00',2.42),('16273','2013-11-19','11:45:00',2.43),('16273','2013-11-19','11:50:00',2.58),('16273','2013-11-19','11:55:00',2.55),('16273','2013-11-19','12:00:00',2.54),('16273','2013-11-19','12:05:00',2.15),('16273','2013-11-19','12:10:00',2.35),('16273','2013-11-19','12:15:00',2.44),('16273','2013-11-19','12:20:00',1.48),('16273','2013-11-19','12:25:00',1.56),('16273','2013-11-19','12:30:00',2.71),('16273','2013-11-19','12:35:00',1.48),('16273','2013-11-19','12:40:00',1.67),('16273','2013-11-19','12:45:00',2.62),('16273','2013-11-19','12:50:00',1.12),('16273','2013-11-19','13:05:00',1.12),('16273','2013-11-19','13:10:00',1.68),('16273','2013-11-19','13:15:00',1.26),('16273','2013-11-19','15:20:00',1.15),('16273','2013-11-19','15:25:00',1.39),('16273','2013-11-19','15:30:00',1.16),('16273','2013-11-18','08:25:00',1.1),('16273','2013-11-18','08:30:00',1.11),('16273','2013-11-18','08:35:00',1.14),('16273','2013-11-18','08:45:00',1.01),('16273','2013-11-18','08:50:00',1.04),('16273','2013-11-18','09:10:00',1.01),('16273','2013-11-18','09:15:00',1.48),('16273','2013-11-18','09:20:00',1.75),('16273','2013-11-18','09:25:00',1.81),('16273','2013-11-18','09:30:00',2.26),('16273','2013-11-18','09:35:00',1.68),('16273','2013-11-18','09:40:00',1.04),('16273','2013-11-18','09:55:00',1.07),('16273','2013-11-18','10:00:00',1.39),('16273','2013-11-18','10:05:00',1.52),('16273','2013-11-18','10:10:00',1.86),('16273','2013-11-18','10:15:00',1.69),('16273','2013-11-18','10:20:00',1.23),('16273','2013-11-18','10:25:00',1.04),('16273','2013-11-18','10:30:00',1.05),('16273','2013-11-18','10:35:00',1.17),('16273','2013-11-18','10:40:00',1.3),('16273','2013-11-18','10:45:00',1.25),('16273','2013-11-18','10:50:00',1.05),('16273','2013-11-18','11:25:00',1.04),('16273','2013-11-18','11:30:00',1.1),('16273','2013-11-18','11:35:00',1.11),('16273','2013-11-18','11:40:00',1.11),('16273','2013-11-18','11:45:00',1.18),('16273','2013-11-18','11:50:00',1.26),('16273','2013-11-18','11:55:00',1.4),('16273','2013-11-18','12:00:00',1.38),('16273','2013-11-18','12:05:00',1.32),('16273','2013-11-18','12:10:00',1.38),('16273','2013-11-18','12:15:00',1.54),('16273','2013-11-18','12:20:00',1.92),('16273','2013-11-18','12:25:00',1.76),('16273','2013-11-18','12:30:00',1.55),('16273','2013-11-18','12:35:00',1.27),('16273','2013-11-18','12:40:00',1.04),('16273','2013-11-18','13:10:00',1.11),('16273','2013-11-18','13:40:00',1.06),('16273','2013-11-18','13:45:00',1.08),('16273','2014-04-19','07:30:00',1.2),('16273','2014-04-19','07:35:00',1.22),('16273','2014-04-19','07:40:00',1.09),('16273','2014-04-19','07:45:00',1.03),('16273','2014-04-19','07:50:00',1.25),('16273','2014-04-19','08:05:00',1.02),('16273','2014-04-19','08:10:00',1.13),('16273','2014-04-19','08:15:00',1.28),('16273','2014-04-19','08:20:00',1.21),('16273','2014-04-19','08:25:00',1.05),('16273','2014-04-19','08:30:00',1.19),('16273','2014-04-19','08:35:00',1.04),('16273','2014-04-19','09:15:00',1.02),('16273','2014-04-19','09:20:00',1.19),('16273','2014-04-19','09:25:00',1.02),('16273','2014-04-19','10:25:00',1.01),('16273','2014-04-19','10:30:00',1.26),('16273','2014-04-19','10:35:00',2.11),('16273','2014-04-19','10:40:00',1.69),('16273','2014-04-19','10:45:00',1.63),('16273','2014-04-19','10:50:00',2.16),('16273','2014-04-19','10:55:00',1.8),('16273','2014-04-19','11:00:00',1.43),('16273','2014-04-19','11:05:00',2),('16273','2014-04-19','11:10:00',3.51),('16273','2014-04-19','11:15:00',4.52),('16273','2014-04-19','11:20:00',3.79),('16273','2014-04-19','11:25:00',4.64),('16273','2014-04-19','11:30:00',2.68),('16273','2014-04-19','11:35:00',2.08),('16273','2014-04-19','11:40:00',1.91),('16273','2014-04-19','11:45:00',1.12),('16273','2014-04-19','13:05:00',1.16),('16273','2014-04-19','13:10:00',1.97),('16273','2014-04-19','13:15:00',1.36),('16273','2014-04-19','13:25:00',1.16),('16273','2014-04-19','14:30:00',1.51),('16273','2014-04-19','14:35:00',1.89),('16273','2014-04-19','14:40:00',1.68),('16273','2014-04-19','14:45:00',1.24),('16273','2014-04-19','14:55:00',1.23),('16273','2014-04-19','15:00:00',1.55),('16273','2014-04-19','15:40:00',3.19),('16273','2014-04-19','15:45:00',2.73),('16273','2014-04-19','15:50:00',1.86),('16273','2014-04-19','15:55:00',1.38),('16273','2014-04-19','16:05:00',1.19),('16273','2014-04-19','16:10:00',2),('16273','2014-04-19','16:15:00',2.31),('16273','2014-04-19','16:20:00',2.2),('16273','2014-04-19','16:25:00',2.07),('16273','2014-04-19','16:30:00',1.17),('16273','2014-04-19','16:40:00',1.04),('16273','2014-04-19','17:00:00',1.27),('16273','2014-04-19','17:05:00',1.09),('16273','2014-04-19','17:10:00',1.4),('16273','2014-04-19','17:15:00',1.7),('16273','2014-04-19','17:20:00',1.01),('16273','2013-11-17','08:50:00',1.03),('16273','2013-11-17','08:55:00',2.32),('16273','2013-11-17','09:00:00',1.89),('16273','2013-11-17','09:05:00',1.47),('16273','2013-11-17','09:40:00',1.01),('16273','2013-11-17','09:45:00',1.63),('16273','2013-11-17','09:50:00',2.62),('16273','2013-11-17','09:55:00',2.57),('16273','2013-11-17','10:00:00',2.58),('16273','2013-11-17','10:05:00',2.59),('16273','2013-11-17','10:10:00',2.6),('16273','2013-11-17','10:15:00',2.63),('16273','2013-11-17','10:20:00',2.66),('16273','2013-11-17','10:25:00',2.63),('16273','2013-11-17','10:30:00',2.69),('16273','2013-11-17','10:35:00',2.71),('16273','2013-11-17','10:40:00',2.74),('16273','2013-11-17','10:45:00',2.77),('16273','2013-11-17','10:50:00',2.81),('16273','2013-11-17','10:55:00',2.75),('16273','2013-11-17','11:00:00',2.74),('16273','2013-11-17','11:05:00',2.74),('16273','2013-11-17','11:10:00',2.73),('16273','2013-11-17','11:15:00',2.73),('16273','2013-11-17','11:20:00',2.74),('16273','2013-11-17','11:25:00',2.72),('16273','2013-11-17','11:30:00',2.72),('16273','2013-11-17','11:35:00',2.7),('16273','2013-11-17','11:40:00',2.7),('16273','2013-11-17','11:45:00',2.69),('16273','2013-11-17','11:50:00',2.67),('16273','2013-11-17','11:55:00',2.65),('16273','2013-11-17','12:00:00',2.62),('16273','2013-11-17','12:05:00',2.59),('16273','2013-11-17','12:10:00',2.55),('16273','2013-11-17','12:15:00',2.56),('16273','2013-11-17','12:20:00',2.56),('16273','2013-11-17','12:25:00',2.52),('16273','2013-11-17','12:30:00',2.46),('16273','2013-11-17','12:35:00',2.42),('16273','2013-11-17','12:40:00',2.41),('16273','2013-11-17','12:45:00',2.39),('16273','2013-11-17','12:50:00',2.36),('16273','2013-11-17','12:55:00',2.31),('16273','2013-11-17','13:00:00',2.26),('16273','2013-11-17','13:05:00',2.16),('16273','2013-11-17','13:10:00',2.18),('16273','2013-11-17','13:15:00',2.13),('16273','2013-11-17','13:20:00',2.15),('16273','2013-11-17','13:25:00',2.18),('16273','2013-11-17','13:30:00',2.18),('16273','2013-11-17','13:35:00',2.17),('16273','2013-11-17','13:40:00',2.09),('16273','2013-11-17','13:45:00',1.8),('16273','2013-11-17','13:50:00',1.91),('16273','2013-11-17','13:55:00',1.98),('16273','2013-11-17','14:00:00',1.59),('16273','2013-11-17','14:05:00',1.67),('16273','2013-11-17','14:10:00',1.43),('16273','2013-11-17','14:15:00',1.46),('16273','2013-11-17','14:20:00',1.49),('16273','2013-11-17','14:25:00',1.41),('16273','2013-11-17','14:30:00',1.19),('16273','2013-11-17','14:45:00',1.34),('16273','2013-11-17','14:50:00',1.38),('16273','2013-11-17','14:55:00',1.12),('16273','2013-11-17','15:00:00',1.02),('16273','2013-11-17','15:05:00',1.1),('16273','2013-11-17','15:10:00',1.04),('16273','2013-11-16','12:55:00',1.02),('16273','2013-11-16','13:00:00',1.02),('16273','2013-11-16','13:05:00',1.14),('16273','2013-11-16','13:10:00',1.11),('16273','2013-11-16','13:15:00',1.02),('16273','2013-11-15','09:50:00',1.14),('16273','2013-11-15','10:10:00',1.05),('16273','2013-11-15','10:15:00',1.07),('16273','2013-11-15','10:35:00',1.02),('16273','2013-11-15','11:00:00',1.14),('16273','2013-11-15','11:05:00',1.34),('16273','2013-11-15','11:10:00',1.44),('16273','2013-11-15','11:15:00',1.22),('16273','2013-11-15','11:20:00',1.08),('16273','2013-11-15','11:30:00',1.39),('16273','2013-11-15','11:35:00',2.23),('16273','2013-11-15','11:40:00',1.46),('16273','2013-11-15','11:45:00',1.72),('16273','2013-11-15','11:50:00',1.98),('16273','2013-11-15','11:55:00',1.28),('16273','2013-11-15','12:00:00',1.03),('16273','2013-11-14','08:25:00',1.22),('16273','2013-11-14','08:45:00',1.63),('16273','2013-11-14','08:50:00',1.91),('16273','2013-11-14','08:55:00',1.97),('16273','2013-11-14','09:00:00',2.02),('16273','2013-11-14','09:05:00',2.12),('16273','2013-11-14','09:10:00',1.52),('16273','2013-11-14','09:15:00',2.16),('16273','2013-11-14','09:20:00',2.3),('16273','2013-11-14','09:25:00',2.29),('16273','2013-11-14','09:30:00',2.35),('16273','2013-11-14','09:35:00',2.4),('16273','2013-11-14','09:40:00',2.4),('16273','2013-11-14','09:45:00',2.34),('16273','2013-11-14','09:50:00',2.27),('16273','2013-11-14','09:55:00',2.24),('16273','2013-11-14','10:00:00',2.5),('16273','2013-11-14','10:05:00',2.52),('16273','2013-11-14','10:10:00',2.5),('16273','2013-11-14','10:15:00',2.53),('16273','2013-11-14','10:20:00',2.59),('16273','2013-11-14','10:25:00',2.32),('16273','2013-11-14','10:30:00',2.51),('16273','2013-11-14','10:35:00',2.58),('16273','2013-11-14','10:40:00',2.67),('16273','2013-11-14','10:45:00',2.71),('16273','2013-11-14','10:50:00',2.75),('16273','2013-11-14','10:55:00',2.73),('16273','2013-11-14','11:00:00',2.82),('16273','2013-11-14','11:05:00',2.9),('16273','2013-11-14','11:10:00',2.93),('16273','2013-11-14','11:15:00',2.87),('16273','2013-11-14','11:20:00',3.03),('16273','2013-11-14','11:25:00',2.79),('16273','2013-11-14','11:30:00',2.69),('16273','2013-11-14','11:35:00',2.53),('16273','2013-11-14','11:40:00',1.86),('16273','2013-11-14','11:45:00',2.29),('16273','2013-11-14','11:50:00',2.71),('16273','2013-11-14','11:55:00',3.22),('16273','2013-11-14','12:00:00',3.17),('16273','2013-11-14','12:05:00',1.26),('16273','2013-11-14','12:10:00',1.15),('16273','2013-11-14','12:15:00',1.17),('16273','2013-11-14','12:20:00',1.07),('16273','2013-11-14','12:25:00',1),('16273','2013-11-14','12:30:00',1.17),('16273','2013-11-14','12:35:00',1.41),('16273','2013-11-14','12:40:00',1.46),('16273','2013-11-14','12:45:00',1.24),('16273','2013-11-14','12:50:00',1.18),('16273','2013-11-14','12:55:00',1.09),('16273','2013-11-14','13:10:00',2.04),('16273','2013-11-14','13:15:00',2.06),('16273','2013-11-14','13:20:00',2.53),('16273','2013-11-14','13:25:00',2.11),('16273','2013-11-14','13:30:00',1.12),('16273','2013-11-14','13:35:00',1.47),('16273','2013-11-14','13:40:00',1.02),('16273','2013-11-14','13:45:00',1.81),('16273','2013-11-14','13:50:00',1.8),('16273','2013-11-14','13:55:00',1.1),('16273','2013-11-13','10:00:00',1.16),('16273','2013-11-13','10:05:00',1.31),('16273','2013-11-13','10:10:00',1.22),('16273','2013-11-13','10:50:00',1.07),('16273','2013-11-13','10:55:00',2.36),('16273','2013-11-13','11:00:00',3.57),('16273','2013-11-13','11:05:00',2.54),('16273','2013-11-13','11:10:00',1.23),('16273','2013-11-13','11:15:00',2.35),('16273','2013-11-13','11:20:00',2.64),('16273','2013-11-13','11:25:00',1.73),('16273','2013-11-13','11:35:00',1.37),('16273','2013-11-13','11:40:00',1.55),('16273','2013-11-13','11:45:00',1.38),('16273','2013-11-13','11:50:00',1.25),('16273','2013-11-13','11:55:00',1.36),('16273','2013-11-13','12:00:00',1.45),('16273','2013-11-13','12:05:00',1.31),('16273','2013-11-13','12:10:00',1.1),('16273','2013-11-13','12:15:00',1.09),('16273','2013-11-13','12:20:00',1.03),('16273','2013-11-13','13:10:00',1.06),('16273','2013-11-13','13:15:00',1.07),('16273','2013-11-13','13:20:00',1.14),('16273','2013-11-13','13:25:00',1.09),('16273','2013-11-13','14:00:00',1.09),('16273','2013-11-13','14:05:00',1.47),('16273','2013-11-13','14:10:00',1.54),('16273','2013-11-13','14:15:00',1.31),('16273','2013-11-13','14:20:00',1.39),('16273','2013-11-13','14:25:00',1.24),('16273','2013-11-13','14:30:00',1.26),('16273','2013-11-13','14:35:00',1.05),('16273','2013-11-12','11:25:00',1.13),('16273','2013-11-12','11:30:00',1.19),('16273','2013-11-12','11:40:00',1.9),('16273','2013-11-12','11:45:00',2.2),('16273','2013-11-12','11:50:00',2),('16273','2013-11-12','12:00:00',1.19),('16273','2013-11-12','12:05:00',2.91);
INSERT INTO `solarlog` VALUES ('16273','2013-11-12','12:35:00',1.5),('16273','2013-11-12','12:40:00',1.95),('16273','2013-11-12','12:45:00',1.99),('16273','2013-11-12','12:50:00',1.77),('16273','2013-11-12','12:55:00',1.47),('16273','2013-11-12','13:00:00',1.57),('16273','2013-11-12','13:05:00',1.33),('16273','2013-11-12','13:10:00',1.29),('16273','2013-11-12','13:15:00',1.43),('16273','2013-11-12','13:20:00',1.64),('16273','2013-11-12','13:25:00',1.68),('16273','2013-11-12','13:30:00',2.37),('16273','2013-11-12','13:35:00',2.41),('16273','2013-11-12','13:40:00',2.55),('16273','2013-11-12','13:45:00',2.61),('16273','2013-11-12','13:50:00',2.45),('16273','2013-11-12','13:55:00',2.22),('16273','2013-11-12','14:00:00',2.76),('16273','2013-11-12','14:05:00',2.31),('16273','2013-11-12','14:10:00',2.21),('16273','2013-11-12','14:15:00',1.77),('16273','2013-11-12','14:20:00',1.23),('16273','2013-11-12','14:25:00',2.13),('16273','2013-11-12','14:30:00',2.04),('16273','2013-11-12','14:40:00',1.33),('16273','2013-11-12','14:45:00',1.42),('16273','2013-11-12','14:50:00',1.35),('16273','2013-11-12','15:05:00',1.06),('16273','2013-11-12','15:15:00',1.04),('16273','2013-11-11','09:45:00',1.01),('16273','2013-11-11','11:05:00',1.13),('16273','2013-11-11','11:10:00',3.07),('16273','2013-11-11','11:15:00',1.75),('16273','2013-11-11','11:20:00',1.65),('16273','2013-11-11','11:35:00',1.37),('16273','2013-11-11','11:40:00',2.7),('16273','2013-11-11','11:45:00',3.66),('16273','2013-11-11','11:50:00',1.66),('16273','2013-11-11','12:00:00',1.14),('16273','2013-11-11','12:05:00',3.41),('16273','2013-11-11','12:10:00',3.17),('16273','2013-11-11','12:15:00',2.85),('16273','2013-11-11','12:20:00',2.94),('16273','2013-11-11','12:25:00',2.96),('16273','2013-11-11','12:30:00',2.84),('16273','2013-11-11','12:35:00',2.97),('16273','2013-11-11','12:40:00',2.93),('16273','2013-11-11','12:45:00',2.83),('16273','2013-11-11','12:50:00',1.85),('16273','2013-11-11','12:55:00',2.89),('16273','2013-11-11','13:00:00',2.51),('16273','2013-11-11','13:05:00',1.69),('16273','2013-11-11','13:10:00',2.58),('16273','2013-11-11','13:15:00',2.57),('16273','2013-11-11','13:20:00',2.46),('16273','2013-11-11','13:25:00',1.42),('16273','2013-11-11','13:40:00',1.04),('16273','2013-11-11','13:45:00',1.15),('16273','2013-11-11','14:00:00',1.49),('16273','2013-11-11','14:05:00',1.85),('16273','2013-11-11','14:15:00',1.66),('16273','2013-11-11','14:30:00',1.61),('16273','2013-11-11','14:45:00',1.21),('16273','2013-11-10','08:20:00',1.19),('16273','2013-11-10','08:25:00',1.34),('16273','2013-11-10','08:35:00',1.67),('16273','2013-11-10','08:40:00',1.96),('16273','2013-11-10','08:45:00',1.79),('16273','2013-11-10','08:50:00',1.83),('16273','2013-11-10','08:55:00',2.1),('16273','2013-11-10','09:00:00',1.45),('16273','2013-11-10','09:05:00',1.37),('16273','2013-11-10','09:10:00',1.7),('16273','2013-11-10','09:15:00',2.09),('16273','2013-11-10','09:20:00',2.21),('16273','2013-11-10','09:25:00',1.98),('16273','2013-11-10','09:30:00',2.21),('16273','2013-11-10','09:35:00',2.41),('16273','2013-11-10','09:40:00',2.4),('16273','2013-11-10','09:45:00',2.29),('16273','2013-11-10','09:50:00',2.47),('16273','2013-11-10','09:55:00',2.48),('16273','2013-11-10','10:00:00',2.75),('16273','2013-11-10','10:05:00',2.67),('16273','2013-11-10','10:10:00',1.87),('16273','2013-11-10','10:15:00',1.21),('16273','2013-11-10','10:20:00',1.34),('16273','2013-11-10','10:25:00',2.34),('16273','2013-11-10','10:30:00',2.42),('16273','2013-11-10','10:35:00',2.66),('16273','2013-11-10','10:40:00',2.54),('16273','2013-11-10','10:45:00',3.42),('16273','2013-11-10','10:50:00',3.2),('16273','2013-11-10','10:55:00',1.41),('16273','2013-11-10','11:10:00',1.22),('16273','2013-11-10','11:15:00',2.61),('16273','2013-11-10','11:20:00',1.87),('16273','2013-11-10','11:25:00',1.75),('16273','2013-11-10','11:30:00',2.75),('16273','2013-11-10','11:35:00',1.83),('16273','2013-11-10','11:50:00',1.07),('16273','2013-11-10','11:55:00',1.56),('16273','2013-11-10','12:00:00',3.55),('16273','2013-11-10','12:05:00',2.96),('16273','2013-11-10','12:10:00',3.03),('16273','2013-11-10','12:15:00',3.28),('16273','2013-11-10','12:20:00',2.66),('16273','2013-11-10','12:25:00',3.09),('16273','2013-11-10','12:30:00',3.03),('16273','2013-11-10','12:35:00',2.03),('16273','2013-11-10','12:40:00',2.15),('16273','2013-11-10','12:45:00',1.07),('16273','2013-11-10','12:50:00',1.37),('16273','2013-11-10','12:55:00',1.8),('16273','2013-11-10','13:00:00',1.81),('16273','2013-11-10','13:05:00',1.04),('16273','2013-11-10','13:35:00',1.44),('16273','2013-11-10','13:40:00',1.46),('16273','2013-11-09','09:30:00',1.49),('16273','2013-11-09','09:35:00',1.48),('16273','2013-11-09','09:40:00',2.31),('16273','2013-11-09','09:45:00',1.91),('16273','2013-11-09','09:50:00',2.96),('16273','2013-11-09','09:55:00',2.88),('16273','2013-11-09','10:00:00',1.88),('16273','2013-11-09','10:10:00',1.75),('16273','2013-11-09','10:15:00',1.31),('16273','2013-11-09','10:25:00',1.06),('16273','2013-11-09','10:30:00',1.13),('16273','2013-11-09','10:35:00',1.8),('16273','2013-11-09','10:45:00',1.01),('16273','2013-11-09','10:50:00',1.53),('16273','2013-11-09','10:55:00',2.74),('16273','2013-11-09','11:00:00',1.47),('16273','2013-11-09','11:15:00',1.36),('16273','2013-11-09','11:20:00',2.31),('16273','2013-11-09','11:25:00',3.34),('16273','2013-11-09','11:30:00',1.54),('16273','2013-11-09','11:35:00',2.5),('16273','2013-11-09','11:40:00',1.69),('16273','2013-11-09','11:45:00',3.18),('16273','2013-11-09','11:50:00',1.97),('16273','2013-11-09','11:55:00',3.27),('16273','2013-11-09','12:00:00',2.75),('16273','2013-11-09','12:05:00',1.56),('16273','2013-11-09','12:10:00',1.03),('16273','2013-11-09','12:30:00',1.05),('16273','2013-11-09','12:35:00',1.16),('16273','2013-11-09','12:40:00',2.04),('16273','2013-11-09','12:45:00',3.04),('16273','2013-11-09','12:50:00',1.89),('16273','2013-11-09','12:55:00',1.16),('16273','2013-11-09','13:00:00',1.82),('16273','2013-11-09','13:05:00',1.38),('16273','2013-11-09','13:10:00',2.14),('16273','2013-11-09','13:15:00',2.36),('16273','2013-11-09','13:20:00',2.35),('16273','2013-11-09','13:25:00',2.23),('16273','2013-11-09','13:30:00',2.39),('16273','2013-11-09','13:35:00',1.75),('16273','2013-11-09','13:40:00',1.55),('16273','2013-11-09','13:45:00',1.04),('16273','2013-11-09','13:50:00',1.83),('16273','2013-11-09','13:55:00',1.85),('16273','2013-11-09','14:15:00',1.27),('16273','2013-11-09','14:25:00',1.46),('16273','2013-11-09','14:30:00',1.52),('16273','2013-11-09','14:35:00',1.4),('16273','2013-11-09','14:40:00',1.24),('16273','2013-11-09','15:20:00',1.19),('16273','2013-11-08','09:25:00',2.18),('16273','2013-11-08','09:30:00',2.46),('16273','2013-11-08','09:35:00',2.5),('16273','2013-11-08','09:40:00',2.33),('16273','2013-11-08','09:45:00',1.67),('16273','2013-11-08','09:55:00',2.35),('16273','2013-11-08','10:00:00',2.69),('16273','2013-11-08','10:05:00',2.71),('16273','2013-11-08','10:10:00',2.98),('16273','2013-11-08','10:15:00',3.06),('16273','2013-11-08','10:20:00',3.08),('16273','2013-11-08','10:25:00',2.66),('16273','2013-11-08','10:30:00',2.87),('16273','2013-11-08','10:35:00',3.07),('16273','2013-11-08','10:40:00',3.29),('16273','2013-11-08','10:45:00',3.21),('16273','2013-11-08','10:50:00',2.95),('16273','2013-11-08','10:55:00',3.13),('16273','2013-11-08','11:00:00',3.42),('16273','2013-11-08','11:05:00',3.43),('16273','2013-11-08','11:10:00',1.63),('16273','2013-11-08','11:25:00',2.13),('16273','2013-11-08','11:30:00',2.21),('16273','2013-11-08','11:35:00',3.08),('16273','2013-11-08','11:40:00',2.94),('16273','2013-11-08','11:45:00',2.91),('16273','2013-11-08','11:50:00',2.31),('16273','2013-11-08','11:55:00',1.49),('16273','2013-11-08','12:00:00',2.87),('16273','2013-11-08','12:05:00',2.79),('16273','2013-11-08','12:10:00',2.42),('16273','2013-11-08','12:15:00',2.72),('16273','2013-11-08','12:20:00',2.56),('16273','2013-11-08','12:25:00',2.25),('16273','2013-11-08','12:30:00',2.82),('16273','2013-11-08','12:35:00',2.4),('16273','2013-11-08','12:40:00',2.08),('16273','2013-11-08','12:45:00',2.84),('16273','2013-11-08','12:50:00',2.68),('16273','2013-11-08','12:55:00',2.55),('16273','2013-11-08','13:00:00',2.52),('16273','2013-11-08','13:05:00',2.53),('16273','2013-11-08','13:10:00',2.51),('16273','2013-11-08','13:15:00',2.35),('16273','2013-11-08','13:20:00',2.24),('16273','2013-11-08','13:25:00',1.92),('16273','2013-11-08','13:30:00',2.29),('16273','2013-11-08','13:35:00',1.15),('16273','2013-11-08','13:45:00',1.97),('16273','2013-11-08','13:50:00',2.1),('16273','2013-11-08','13:55:00',2.02),('16273','2013-11-08','14:00:00',2.15),('16273','2013-11-08','14:05:00',2.03),('16273','2013-11-08','14:10:00',1.35),('16273','2013-11-08','14:15:00',1.9),('16273','2013-11-08','14:20:00',1.8),('16273','2013-11-08','14:25:00',1.29),('16273','2013-11-08','14:35:00',1.34),('16273','2013-11-08','14:45:00',1.34),('16273','2013-11-08','14:50:00',1.31),('16273','2013-11-08','14:55:00',1.06),('16273','2013-11-08','15:10:00',1.06),('16273','2013-11-08','15:15:00',1.03),('16273','2014-04-18','08:10:00',1.81),('16273','2014-04-18','08:15:00',1.05),('16273','2014-04-18','08:20:00',1.76),('16273','2014-04-18','08:25:00',1.15),('16273','2014-04-18','08:30:00',1.01),('16273','2014-04-18','08:35:00',1.28),('16273','2014-04-18','08:40:00',1.26),('16273','2014-04-18','08:45:00',2.17),('16273','2014-04-18','08:50:00',1.99),('16273','2014-04-18','08:55:00',1.24),('16273','2014-04-18','09:05:00',1.12),('16273','2014-04-18','09:10:00',1.94),('16273','2014-04-18','09:15:00',3.44),('16273','2014-04-18','09:20:00',2.5),('16273','2014-04-18','09:25:00',3.08),('16273','2014-04-18','09:30:00',2.31),('16273','2014-04-18','09:35:00',2.25),('16273','2014-04-18','09:40:00',1.42),('16273','2014-04-18','09:45:00',3.07),('16273','2014-04-18','09:50:00',1.92),('16273','2014-04-18','09:55:00',1.8),('16273','2014-04-18','10:00:00',1.55),('16273','2014-04-18','10:05:00',1.31),('16273','2014-04-18','10:10:00',1.36),('16273','2014-04-18','10:15:00',1.28),('16273','2014-04-18','10:20:00',1.48),('16273','2014-04-18','10:25:00',1.45),('16273','2014-04-18','10:30:00',1.24),('16273','2014-04-18','10:35:00',1.33),('16273','2014-04-18','10:40:00',2.47),('16273','2014-04-18','10:45:00',2.77),('16273','2014-04-18','10:50:00',2.77),('16273','2014-04-18','10:55:00',2.85),('16273','2014-04-18','11:00:00',2.38),('16273','2014-04-18','11:05:00',2.3),('16273','2014-04-18','11:10:00',1.95),('16273','2014-04-18','11:15:00',2.15),('16273','2014-04-18','11:20:00',2.08),('16273','2014-04-18','11:25:00',2.05),('16273','2014-04-18','11:30:00',2.86),('16273','2014-04-18','11:35:00',2.95),('16273','2014-04-18','11:40:00',2.2),('16273','2014-04-18','11:45:00',3.24),('16273','2014-04-18','11:50:00',3.19),('16273','2014-04-18','11:55:00',2.45),('16273','2014-04-18','12:00:00',2.28),('16273','2014-04-18','12:05:00',2.02),('16273','2014-04-18','12:10:00',3.18),('16273','2014-04-18','12:15:00',3.35),('16273','2014-04-18','12:20:00',4.31),('16273','2014-04-18','12:25:00',3.27),('16273','2014-04-18','12:30:00',3.64),('16273','2014-04-18','12:35:00',4.4),('16273','2014-04-18','12:40:00',3.74),('16273','2014-04-18','12:45:00',4.11),('16273','2014-04-18','12:50:00',2.04),('16273','2014-04-18','12:55:00',3.83),('16273','2014-04-18','13:00:00',4.21),('16273','2014-04-18','13:05:00',4.32),('16273','2014-04-18','13:10:00',3.72),('16273','2014-04-18','13:15:00',2.48),('16273','2014-04-18','13:20:00',2.13),('16273','2014-04-18','13:25:00',1.94),('16273','2014-04-18','13:30:00',1.45),('16273','2014-04-18','13:35:00',1.3),('16273','2014-04-18','13:40:00',1.53),('16273','2014-04-18','13:45:00',1.41),('16273','2014-04-18','13:50:00',1.26),('16273','2014-04-18','13:55:00',1.22),('16273','2014-04-18','14:00:00',1.39),('16273','2014-04-18','14:05:00',1.38),('16273','2014-04-18','14:10:00',1.37),('16273','2014-04-18','14:15:00',1.56),('16273','2014-04-18','14:20:00',1.68),('16273','2014-04-18','14:25:00',1.83),('16273','2014-04-18','14:30:00',2.13),('16273','2014-04-18','14:35:00',2.13),('16273','2014-04-18','14:40:00',1.85),('16273','2014-04-18','14:45:00',1.59),('16273','2014-04-18','14:50:00',1.97),('16273','2014-04-18','14:55:00',2.67),('16273','2014-04-18','15:00:00',3.99),('16273','2014-04-18','15:05:00',3.52),('16273','2014-04-18','15:10:00',2.96),('16273','2014-04-18','15:15:00',3.27),('16273','2014-04-18','15:20:00',3.54),('16273','2014-04-18','15:25:00',1.77),('16273','2014-04-18','15:30:00',2.28),('16273','2014-04-18','15:35:00',2.78),('16273','2014-04-18','15:40:00',2.15),('16273','2014-04-18','15:45:00',3.07),('16273','2014-04-18','15:50:00',3.11),('16273','2014-04-18','15:55:00',2.71),('16273','2014-04-18','16:00:00',3.03),('16273','2014-04-18','16:05:00',3),('16273','2014-04-18','16:10:00',3.06),('16273','2014-04-18','16:15:00',2.94),('16273','2014-04-18','16:20:00',2.47),('16273','2014-04-18','16:25:00',2.18),('16273','2014-04-18','16:30:00',1.67),('16273','2014-04-18','16:35:00',1.56),('16273','2014-04-18','16:40:00',2.06),('16273','2014-04-18','16:45:00',1.71),('16273','2014-04-18','16:55:00',1.74),('16273','2014-04-18','17:00:00',1.79),('16273','2014-04-18','17:05:00',1.67),('16273','2014-04-18','17:10:00',1.51),('16273','2014-04-18','17:15:00',1.47),('16273','2014-04-18','17:20:00',1.15),('16273','2014-04-18','17:25:00',1.04),('16273','2014-04-18','17:30:00',1.19),('16273','2013-11-07','07:55:00',1.15),('16273','2013-11-07','08:00:00',1.29),('16273','2013-11-07','08:05:00',1.17),('16273','2013-11-07','08:10:00',1.53),('16273','2013-11-07','08:15:00',1.63),('16273','2013-11-07','08:20:00',1.72),('16273','2013-11-07','08:25:00',1.8),('16273','2013-11-07','08:30:00',1.87),('16273','2013-11-07','08:35:00',1.92),('16273','2013-11-07','08:40:00',1.99),('16273','2013-11-07','08:45:00',2.06),('16273','2013-11-07','08:50:00',2.11),('16273','2013-11-07','08:55:00',2.16),('16273','2013-11-07','09:00:00',2.21),('16273','2013-11-07','09:05:00',2.26),('16273','2013-11-07','09:10:00',2.3),('16273','2013-11-07','09:15:00',2.35),('16273','2013-11-07','09:20:00',2.39),('16273','2013-11-07','09:25:00',2.43),('16273','2013-11-07','09:30:00',2.46),('16273','2013-11-07','09:35:00',2.48),('16273','2013-11-07','09:40:00',2.48),('16273','2013-11-07','09:45:00',2.52),('16273','2013-11-07','09:50:00',2.56),('16273','2013-11-07','09:55:00',2.6),('16273','2013-11-07','10:00:00',2.64),('16273','2013-11-07','10:05:00',2.67),('16273','2013-11-07','10:10:00',2.7),('16273','2013-11-07','10:15:00',2.73),('16273','2013-11-07','10:20:00',2.74),('16273','2013-11-07','10:25:00',2.76),('16273','2013-11-07','10:30:00',2.76),('16273','2013-11-07','10:35:00',2.76),('16273','2013-11-07','10:40:00',2.76),('16273','2013-11-07','10:45:00',2.77),('16273','2013-11-07','10:50:00',2.76),('16273','2013-11-07','10:55:00',2.7),('16273','2013-11-07','11:00:00',2.67),('16273','2013-11-07','11:05:00',2.72),('16273','2013-11-07','11:10:00',2.76),('16273','2013-11-07','11:15:00',2.75),('16273','2013-11-07','11:20:00',2.74),('16273','2013-11-07','11:25:00',2.71),('16273','2013-11-07','11:30:00',2.34),('16273','2013-11-07','11:35:00',2.3),('16273','2013-11-07','11:40:00',2.15),('16273','2013-11-07','11:45:00',2.56),('16273','2013-11-07','11:50:00',2.78),('16273','2013-11-07','11:55:00',2.76),('16273','2013-11-07','12:00:00',1.61),('16273','2013-11-07','12:05:00',1.33),('16273','2013-11-07','12:10:00',2.88),('16273','2013-11-07','12:15:00',2.85),('16273','2013-11-07','12:20:00',2.76),('16273','2013-11-07','12:25:00',2.41),('16273','2013-11-07','12:30:00',1.45),('16273','2013-11-07','12:35:00',1.69),('16273','2013-11-07','12:40:00',1.02),('16273','2013-11-07','12:45:00',2.94),('16273','2013-11-07','12:50:00',2.46),('16273','2013-11-07','12:55:00',2.44),('16273','2013-11-07','13:00:00',2.41),('16273','2013-11-07','13:05:00',2.33),('16273','2013-11-07','13:10:00',2.15),('16273','2013-11-07','13:15:00',2.31),('16273','2013-11-07','13:20:00',2.25),('16273','2013-11-07','13:25:00',2.19),('16273','2013-11-07','13:30:00',2.14),('16273','2013-11-07','13:35:00',2.09),('16273','2013-11-07','13:40:00',2.07),('16273','2013-11-07','13:45:00',1.98),('16273','2013-11-07','13:50:00',1.93),('16273','2013-11-07','13:55:00',1.73),('16273','2013-11-07','14:00:00',1.18),('16273','2013-11-07','14:05:00',1.47),('16273','2013-11-07','14:10:00',1.75),('16273','2013-11-07','14:15:00',1.67),('16273','2013-11-07','14:20:00',1.59),('16273','2013-11-07','14:25:00',1.53),('16273','2013-11-07','14:30:00',1.47),('16273','2013-11-07','14:35:00',1.4),('16273','2013-11-07','14:40:00',1.33),('16273','2013-11-07','14:45:00',1.27),('16273','2013-11-07','14:50:00',1.21),('16273','2013-11-07','14:55:00',1.14),('16273','2013-11-07','15:00:00',1.09),('16273','2013-11-07','15:05:00',1.03),('16273','2013-11-06','08:10:00',1.69),('16273','2013-11-06','08:15:00',1.86),('16273','2013-11-06','08:30:00',1.25),('16273','2013-11-06','08:35:00',2.06),('16273','2013-11-06','08:40:00',2.09),('16273','2013-11-06','08:45:00',2.15),('16273','2013-11-06','08:50:00',2.27),('16273','2013-11-06','08:55:00',1.8),('16273','2013-11-06','09:00:00',1.53),('16273','2013-11-06','09:05:00',1.82),('16273','2013-11-06','09:10:00',2.52),('16273','2013-11-06','09:15:00',2.42),('16273','2013-11-06','09:20:00',2.54),('16273','2013-11-06','09:25:00',2.56),('16273','2013-11-06','09:30:00',2.57),('16273','2013-11-06','09:35:00',2.61),('16273','2013-11-06','09:40:00',2.63),('16273','2013-11-06','09:45:00',2.66),('16273','2013-11-06','09:50:00',2.69),('16273','2013-11-06','09:55:00',2.71),('16273','2013-11-06','10:00:00',2.74),('16273','2013-11-06','10:05:00',2.77),('16273','2013-11-06','10:10:00',2.79),('16273','2013-11-06','10:15:00',2.83),('16273','2013-11-06','10:20:00',2.81),('16273','2013-11-06','10:25:00',2.86),('16273','2013-11-06','10:30:00',2.88),('16273','2013-11-06','10:35:00',2.89),('16273','2013-11-06','10:40:00',2.9),('16273','2013-11-06','10:45:00',2.92),('16273','2013-11-06','10:50:00',2.92),('16273','2013-11-06','10:55:00',2.92),('16273','2013-11-06','11:00:00',2.93),('16273','2013-11-06','11:05:00',2.93),('16273','2013-11-06','11:10:00',2.92),('16273','2013-11-06','11:15:00',2.92),('16273','2013-11-06','11:20:00',2.91),('16273','2013-11-06','11:25:00',2.89),('16273','2013-11-06','11:30:00',2.87),('16273','2013-11-06','11:35:00',2.89),('16273','2013-11-06','11:40:00',2.87),('16273','2013-11-06','11:45:00',2.87),('16273','2013-11-06','11:50:00',2.88),('16273','2013-11-06','11:55:00',2.86),('16273','2013-11-06','12:00:00',2.83),('16273','2013-11-06','12:05:00',2.8),('16273','2013-11-06','12:10:00',2.77),('16273','2013-11-06','12:15:00',2.76),('16273','2013-11-06','12:20:00',2.73),('16273','2013-11-06','12:25:00',2.71),('16273','2013-11-06','12:30:00',2.68),('16273','2013-11-06','12:35:00',2.65),('16273','2013-11-06','12:40:00',2.62),('16273','2013-11-06','12:45:00',2.58),('16273','2013-11-06','12:50:00',2.55),('16273','2013-11-06','12:55:00',2.51),('16273','2013-11-06','13:00:00',2.45),('16273','2013-11-06','13:05:00',2.39),('16273','2013-11-06','13:10:00',2.37),('16273','2013-11-06','13:15:00',2.36),('16273','2013-11-06','13:20:00',2.32),('16273','2013-11-06','13:25:00',2.26),('16273','2013-11-06','13:30:00',2.21),('16273','2013-11-06','13:35:00',2.16),('16273','2013-11-06','13:40:00',2.1),('16273','2013-11-06','13:45:00',2.04),('16273','2013-11-06','13:50:00',1.99),('16273','2013-11-06','13:55:00',1.93),('16273','2013-11-06','14:00:00',1.88),('16273','2013-11-06','14:05:00',1.81),('16273','2013-11-06','14:10:00',1.76),('16273','2013-11-06','14:15:00',1.7),('16273','2013-11-06','14:20:00',1.63),('16273','2013-11-06','14:25:00',1.56),('16273','2013-11-06','14:30:00',1.49),('16273','2013-11-06','14:35:00',1.42),('16273','2013-11-06','14:40:00',1.35),('16273','2013-11-06','14:45:00',1.28),('16273','2013-11-06','14:50:00',1.22),('16273','2013-11-06','14:55:00',1.15),('16273','2013-11-06','15:00:00',1.08),('16273','2013-11-06','15:05:00',1.02),('16273','2013-11-05','10:20:00',1.02),('16273','2013-11-05','10:25:00',1.06),('16273','2013-11-05','10:35:00',1.05),('16273','2013-11-05','10:40:00',1.31),('16273','2013-11-05','10:45:00',1.09),('16273','2013-11-05','11:30:00',1.06),('16273','2013-11-05','11:35:00',1.3),('16273','2013-11-05','11:40:00',1.3),('16273','2013-11-05','11:45:00',1.17),('16273','2013-11-05','11:50:00',1.1),('16273','2013-11-05','11:55:00',1.09),('16273','2013-11-05','12:00:00',1.66),('16273','2013-11-05','12:05:00',1.37),('16273','2013-11-05','12:10:00',1.47),('16273','2013-11-05','12:15:00',1.86),('16273','2013-11-05','12:20:00',2.27),('16273','2013-11-05','12:25:00',2.72),('16273','2013-11-05','12:30:00',1.07),('16273','2013-11-05','13:00:00',1.08),('16273','2013-11-05','13:05:00',1.18),('16273','2013-11-05','13:10:00',1.18),('16273','2013-11-05','13:15:00',1.31),('16273','2013-11-05','13:20:00',1.38),('16273','2013-11-05','13:25:00',1.28),('16273','2013-11-05','13:30:00',1.69),('16273','2013-11-05','13:35:00',1.93),('16273','2013-11-05','13:40:00',1.85),('16273','2013-11-05','13:45:00',2.2),('16273','2013-11-05','13:50:00',2.14),('16273','2013-11-05','13:55:00',2.3),('16273','2013-11-05','14:00:00',2.18),('16273','2013-11-05','14:05:00',2),('16273','2013-11-05','14:10:00',1.79),('16273','2013-11-05','14:15:00',1.88),('16273','2013-11-05','14:20:00',1.43),('16273','2013-11-05','14:25:00',1.2),('16273','2013-11-05','14:30:00',1.51),('16273','2013-11-05','14:35:00',1.37),('16273','2013-11-05','14:40:00',1.1),('16273','2013-11-05','14:45:00',1.27),('16273','2013-11-05','15:25:00',1.27),('16273','2013-11-05','15:30:00',1.3),('16273','2013-11-04','07:50:00',1),('16273','2013-11-04','07:55:00',1.15),('16273','2013-11-04','08:00:00',1.24),('16273','2013-11-04','08:05:00',1.32),('16273','2013-11-04','08:10:00',1.36),('16273','2013-11-04','08:15:00',1.61),('16273','2013-11-04','08:20:00',1.7),('16273','2013-11-04','08:25:00',1.74),('16273','2013-11-04','08:30:00',1.86),('16273','2013-11-04','08:35:00',1.57),('16273','2013-11-04','08:45:00',1.65),('16273','2013-11-04','08:50:00',2.16),('16273','2013-11-04','08:55:00',2.25),('16273','2013-11-04','09:00:00',2.33),('16273','2013-11-04','09:05:00',2.39),('16273','2013-11-04','09:10:00',2.46),('16273','2013-11-04','09:15:00',2.47),('16273','2013-11-04','09:20:00',2.51),('16273','2013-11-04','09:25:00',2.54),('16273','2013-11-04','09:30:00',2.56),('16273','2013-11-04','09:35:00',2.59),('16273','2013-11-04','09:40:00',2.64),('16273','2013-11-04','09:45:00',2.55),('16273','2013-11-04','09:50:00',1.22),('16273','2013-11-04','09:55:00',1.53),('16273','2013-11-04','10:05:00',1.64),('16273','2013-11-04','10:40:00',1.12),('16273','2013-11-04','10:45:00',2.25),('16273','2013-11-04','10:50:00',3.1),('16273','2013-11-04','10:55:00',3.21),('16273','2013-11-04','11:00:00',3.25),('16273','2013-11-04','11:05:00',1.2),('16273','2013-11-04','11:40:00',2),('16273','2013-11-04','11:45:00',2.38),('16273','2013-11-04','11:50:00',3.18),('16273','2013-11-04','11:55:00',2.66),('16273','2013-11-04','12:00:00',2.42),('16273','2013-11-04','12:05:00',1.52),('16273','2013-11-04','12:40:00',2.74),('16273','2013-11-04','12:45:00',1.18),('16273','2013-11-04','12:50:00',1.35),('16273','2013-11-04','13:05:00',1.37),('16273','2013-11-04','13:10:00',1.12),('16273','2013-11-04','13:15:00',1.62),('16273','2013-11-04','13:20:00',2.13),('16273','2013-11-04','13:25:00',1.41),('16273','2013-11-04','13:30:00',1.07),('16273','2013-11-04','13:35:00',1.25),('16273','2013-11-04','13:45:00',1.63),('16273','2013-11-04','14:20:00',1.97),('16273','2013-11-04','14:25:00',1.49),('16273','2013-11-04','15:10:00',1.04),('16273','2013-11-03','08:00:00',1.01),('16273','2013-11-03','08:05:00',1.22),('16273','2013-11-03','08:10:00',1.19),('16273','2013-11-03','08:15:00',1.07),('16273','2013-11-03','08:20:00',1.15),('16273','2013-11-03','08:25:00',1.47),('16273','2013-11-03','08:30:00',1.73),('16273','2013-11-03','08:35:00',1.8),('16273','2013-11-03','08:40:00',2.11),('16273','2013-11-03','08:45:00',2.03),('16273','2013-11-03','08:55:00',2.17),('16273','2013-11-03','09:05:00',1.44),('16273','2013-11-03','09:10:00',1.34),('16273','2013-11-03','09:15:00',1.17),('16273','2013-11-03','09:20:00',1.61),('16273','2013-11-03','09:25:00',1.72),('16273','2013-11-03','10:05:00',1.8),('16273','2013-11-03','10:10:00',2.78),('16273','2013-11-03','10:15:00',2.83),('16273','2013-11-03','10:20:00',2.94),('16273','2013-11-03','10:25:00',1.79),('16273','2013-11-03','10:30:00',1.45),('16273','2013-11-03','10:35:00',1.87),('16273','2013-11-03','10:40:00',1.74),('16273','2013-11-03','11:00:00',2.14),('16273','2013-11-03','11:05:00',1.97),('16273','2013-11-03','11:10:00',2.46),('16273','2013-11-03','11:15:00',1.69),('16273','2013-11-03','11:20:00',1.91),('16273','2013-11-03','11:25:00',3.18),('16273','2013-11-03','11:30:00',3.12),('16273','2013-11-03','11:35:00',3.04),('16273','2013-11-03','11:40:00',2.97),('16273','2013-11-03','11:45:00',3.31),('16273','2013-11-03','11:50:00',3.67),('16273','2013-11-03','11:55:00',3.49),('16273','2013-11-03','12:00:00',1.91),('16273','2013-11-03','12:10:00',1.22),('16273','2013-11-03','12:15:00',3.15),('16273','2013-11-03','12:20:00',2.87),('16273','2013-11-03','12:45:00',1.03),('16273','2013-11-03','12:50:00',1.19),('16273','2013-11-03','12:55:00',1.19),('16273','2013-11-03','13:00:00',1.06),('16273','2013-11-03','13:05:00',1.07),('16273','2013-11-03','13:10:00',1.21),('16273','2013-11-03','13:15:00',1.56),('16273','2013-11-03','13:20:00',3.02),('16273','2013-11-03','13:25:00',2.05),('16273','2013-11-03','13:30:00',1),('16273','2013-11-03','13:35:00',1.11),('16273','2013-11-03','13:40:00',2.2),('16273','2013-11-03','13:45:00',1.44),('16273','2013-11-03','13:50:00',1.76),('16273','2013-11-03','13:55:00',1.62),('16273','2013-11-03','14:00:00',1.8),('16273','2013-11-03','14:05:00',1.82),('16273','2013-11-03','14:10:00',1.76),('16273','2013-11-03','14:15:00',1.38),('16273','2013-11-03','14:20:00',1.9),('16273','2013-11-03','14:25:00',1.35),('16273','2013-11-03','14:30:00',1.43),('16273','2013-11-03','14:35:00',1.47),('16273','2013-11-03','14:40:00',1.1),('16273','2013-11-03','14:45:00',1.15),('16273','2013-11-03','14:50:00',1),('16273','2013-11-02','07:55:00',1.12),('16273','2013-11-02','08:00:00',1.1),('16273','2013-11-02','08:05:00',1.27),('16273','2013-11-02','08:10:00',1.46),('16273','2013-11-02','08:15:00',1.58),('16273','2013-11-02','08:20:00',1.66),('16273','2013-11-02','08:25:00',1.71),('16273','2013-11-02','08:30:00',1.77),('16273','2013-11-02','08:35:00',1.85),('16273','2013-11-02','08:40:00',1.92),('16273','2013-11-02','08:45:00',2.03),('16273','2013-11-02','08:50:00',2.3),('16273','2013-11-02','08:55:00',2.41),('16273','2013-11-02','09:05:00',1.54),('16273','2013-11-02','09:10:00',2.47),('16273','2013-11-02','09:15:00',2.51),('16273','2013-11-02','09:20:00',2.45),('16273','2013-11-02','09:25:00',2.41),('16273','2013-11-02','09:30:00',2.45),('16273','2013-11-02','09:35:00',2.66),('16273','2013-11-02','09:40:00',2.11),('16273','2013-11-02','09:45:00',1.48),('16273','2013-11-02','09:50:00',2.8),('16273','2013-11-02','09:55:00',2.1),('16273','2013-11-02','10:00:00',2.57),('16273','2013-11-02','10:05:00',1.41),('16273','2013-11-02','10:45:00',1.04),('16273','2013-11-02','10:50:00',1.15),('16273','2013-11-02','10:55:00',2.11),('16273','2013-11-02','11:00:00',1.54),('16273','2013-11-02','11:05:00',1.48),('16273','2013-11-02','11:10:00',1.52),('16273','2013-11-02','11:15:00',2.06),('16273','2013-11-02','11:20:00',2.63),('16273','2013-11-02','11:25:00',2.48),('16273','2013-11-02','11:30:00',2.99),('16273','2013-11-02','11:35:00',2.64),('16273','2013-11-02','11:40:00',2.9),('16273','2013-11-02','11:45:00',2.47),('16273','2013-11-02','11:50:00',1.97),('16273','2013-11-02','12:00:00',2.49),('16273','2013-11-02','12:05:00',2.74),('16273','2013-11-02','12:10:00',2.51),('16273','2013-11-02','12:15:00',3.5),('16273','2013-11-02','12:20:00',2.69),('16273','2013-11-02','12:25:00',2.27),('16273','2013-11-02','12:30:00',2.56),('16273','2013-11-02','12:35:00',2.5),('16273','2013-11-02','12:40:00',2.67),('16273','2013-11-02','12:45:00',2.95),('16273','2013-11-02','12:50:00',3.15),('16273','2013-11-02','12:55:00',3.09),('16273','2013-11-02','13:00:00',2.97),('16273','2013-11-02','13:05:00',2.91),('16273','2013-11-02','13:10:00',2.69),('16273','2013-11-02','13:15:00',1.19),('16273','2013-11-02','13:20:00',1.49),('16273','2013-11-02','13:25:00',2.63),('16273','2013-11-02','13:30:00',1.54),('16273','2013-11-02','13:35:00',2.3),('16273','2013-11-02','13:40:00',2.75),('16273','2013-11-02','13:45:00',2.51),('16273','2013-11-02','13:50:00',2.22),('16273','2013-11-02','13:55:00',2.03),('16273','2013-11-02','14:00:00',1.95),('16273','2013-11-02','14:05:00',1.86),('16273','2013-11-02','14:10:00',1.78),('16273','2013-11-02','14:15:00',1.72),('16273','2013-11-02','14:20:00',1.65),('16273','2013-11-02','14:25:00',1.58),('16273','2013-11-02','14:30:00',1.53),('16273','2013-11-02','14:35:00',1.48),('16273','2013-11-02','14:40:00',1.42),('16273','2013-11-02','14:45:00',1.4),('16273','2013-11-02','14:50:00',1.31),('16273','2013-11-02','14:55:00',1.23),('16273','2013-11-02','15:00:00',1.16),('16273','2013-11-01','08:10:00',1.11),('16273','2013-11-01','08:15:00',1.13),('16273','2013-11-01','08:20:00',1.36),('16273','2013-11-01','08:25:00',1.53),('16273','2013-11-01','08:30:00',1.7),('16273','2013-11-01','08:35:00',1.79),('16273','2013-11-01','08:40:00',1.58),('16273','2013-11-01','08:45:00',1.57),('16273','2013-11-01','08:50:00',1.76),('16273','2013-11-01','08:55:00',1.96),('16273','2013-11-01','09:00:00',1.9),('16273','2013-11-01','09:05:00',2.1),('16273','2013-11-01','09:10:00',2.22),('16273','2013-11-01','09:15:00',2.25),('16273','2013-11-01','09:20:00',2.35),('16273','2013-11-01','09:25:00',2.39),('16273','2013-11-01','09:30:00',2.45),('16273','2013-11-01','09:35:00',2.49),('16273','2013-11-01','09:40:00',2.55),('16273','2013-11-01','09:45:00',2.61),('16273','2013-11-01','09:50:00',2.66),('16273','2013-11-01','09:55:00',2.68),('16273','2013-11-01','10:00:00',2.71),('16273','2013-11-01','10:05:00',2.73),('16273','2013-11-01','10:10:00',2.77),('16273','2013-11-01','10:15:00',2.81),('16273','2013-11-01','10:20:00',2.81),('16273','2013-11-01','10:25:00',2.82),('16273','2013-11-01','10:30:00',2.85),('16273','2013-11-01','10:35:00',2.82),('16273','2013-11-01','10:40:00',2.82),('16273','2013-11-01','10:45:00',2.81),('16273','2013-11-01','10:50:00',2.76),('16273','2013-11-01','10:55:00',2.85),('16273','2013-11-01','11:00:00',2.85),('16273','2013-11-01','11:05:00',2.28),('16273','2013-11-01','11:10:00',2.18),('16273','2013-11-01','11:15:00',2.2),('16273','2013-11-01','11:20:00',2.5),('16273','2013-11-01','11:25:00',2.89),('16273','2013-11-01','11:30:00',2.89),('16273','2013-11-01','11:35:00',2.65),('16273','2013-11-01','11:40:00',2.72),('16273','2013-11-01','11:45:00',2.84),('16273','2013-11-01','11:50:00',2.94),('16273','2013-11-01','11:55:00',2.99),('16273','2013-11-01','12:00:00',2.95),('16273','2013-11-01','12:05:00',2.46),('16273','2013-11-01','12:10:00',1.87),('16273','2013-11-01','12:15:00',2.43),('16273','2013-11-01','12:20:00',1.72),('16273','2013-11-01','12:25:00',1.59),('16273','2013-11-01','12:40:00',1.1),('16273','2013-11-01','12:45:00',1.16),('16273','2013-11-01','12:50:00',2.06),('16273','2013-11-01','12:55:00',2.03),('16273','2013-11-01','13:00:00',1.89),('16273','2013-11-01','13:05:00',1.58),('16273','2013-11-01','13:10:00',1.25),('16273','2013-11-01','13:15:00',1.12),('16273','2013-10-31','08:10:00',1),('16273','2013-10-31','08:20:00',1.17),('16273','2013-10-31','08:25:00',1.41),('16273','2013-10-31','08:30:00',1.47),('16273','2013-10-31','08:35:00',1.75),('16273','2013-10-31','08:40:00',1.48),('16273','2013-10-31','08:45:00',1.33),('16273','2013-10-31','09:00:00',1.91),('16273','2013-10-31','09:05:00',2.14),('16273','2013-10-31','09:10:00',2.1),('16273','2013-10-31','09:15:00',2.03),('16273','2013-10-31','09:20:00',1.89),('16273','2013-10-31','09:25:00',2.01),('16273','2013-10-31','09:30:00',2.1),('16273','2013-10-31','09:35:00',2.04),('16273','2013-10-31','09:40:00',2.08),('16273','2013-10-31','09:45:00',2.08),('16273','2013-10-31','09:50:00',2.28),('16273','2013-10-31','09:55:00',2.23),('16273','2013-10-31','10:00:00',2.34),('16273','2013-10-31','10:05:00',2.38),('16273','2013-10-31','10:10:00',2.36),('16273','2013-10-31','10:15:00',2.22),('16273','2013-10-31','10:20:00',2.1),('16273','2013-10-31','10:25:00',2.52),('16273','2013-10-31','10:30:00',2.9),('16273','2013-10-31','10:35:00',2.88),('16273','2013-10-31','10:40:00',2.85),('16273','2013-10-31','10:45:00',2.68),('16273','2013-10-31','10:50:00',2.28),('16273','2013-10-31','10:55:00',2.24),('16273','2013-10-31','11:00:00',2.39),('16273','2013-10-31','11:05:00',2.61),('16273','2013-10-31','11:10:00',2.67),('16273','2013-10-31','11:15:00',2.6),('16273','2013-10-31','11:20:00',2.49),('16273','2013-10-31','11:25:00',2.47),('16273','2013-10-31','11:30:00',2.42),('16273','2013-10-31','11:35:00',2.36),('16273','2013-10-31','11:40:00',2.24),('16273','2013-10-31','11:45:00',2.66),('16273','2013-10-31','11:50:00',2.75),('16273','2013-10-31','11:55:00',2.88),('16273','2013-10-31','12:00:00',2.85),('16273','2013-10-31','12:05:00',2.85),('16273','2013-10-31','12:10:00',2.82),('16273','2013-10-31','12:15:00',2.76),('16273','2013-10-31','12:20:00',2.69),('16273','2013-10-31','12:25:00',2.64),('16273','2013-10-31','12:30:00',2.59),('16273','2013-10-31','12:35:00',2.53),('16273','2013-10-31','12:40:00',2.56),('16273','2013-10-31','12:45:00',2.56),('16273','2013-10-31','12:50:00',2.48),('16273','2013-10-31','12:55:00',2.46),('16273','2013-10-31','13:00:00',2.48),('16273','2013-10-31','13:05:00',2.42),('16273','2013-10-31','13:10:00',2.34),('16273','2013-10-31','13:15:00',2.3),('16273','2013-10-31','13:20:00',2.25),('16273','2013-10-31','13:25:00',2.22),('16273','2013-10-31','13:30:00',2.15),('16273','2013-10-31','13:35:00',2.09),('16273','2013-10-31','13:40:00',2.02),('16273','2013-10-31','13:45:00',1.98),('16273','2013-10-31','13:50:00',1.9),('16273','2013-10-31','13:55:00',1.74),('16273','2013-10-31','14:00:00',1.47),('16273','2013-10-31','14:05:00',1.68),('16273','2013-10-31','14:10:00',1.66),('16273','2013-10-31','14:15:00',1.6),('16273','2013-10-31','14:20:00',1.26),('16273','2013-10-31','14:25:00',1.14),('16273','2013-10-31','14:30:00',1.38),('16273','2013-10-31','14:35:00',1.32),('16273','2013-10-31','14:40:00',1.19),('16273','2013-10-31','14:45:00',1.17),('16273','2013-10-31','14:50:00',1.18),('16273','2013-10-31','14:55:00',1.07),('16273','2013-10-31','15:00:00',1.04),('16273','2013-10-30','08:00:00',1.06),('16273','2013-10-30','08:05:00',1.16),('16273','2013-10-30','08:10:00',1.23),('16273','2013-10-30','08:15:00',1.3),('16273','2013-10-30','08:20:00',1.39),('16273','2013-10-30','08:25:00',1.48),('16273','2013-10-30','08:30:00',1.57),('16273','2013-10-30','08:35:00',1.64),('16273','2013-10-30','08:40:00',1.76),('16273','2013-10-30','08:45:00',1.79),('16273','2013-10-30','08:50:00',1.77),('16273','2013-10-30','08:55:00',2),('16273','2013-10-30','09:00:00',2.1),('16273','2013-10-30','09:05:00',2.17),('16273','2013-10-30','09:10:00',2.18),('16273','2013-10-30','09:15:00',2.23),('16273','2013-10-30','09:20:00',2.23),('16273','2013-10-30','09:25:00',2.2),('16273','2013-10-30','09:30:00',2),('16273','2013-10-30','09:35:00',2.07),('16273','2013-10-30','09:40:00',2.15),('16273','2013-10-30','09:45:00',1.9),('16273','2013-10-30','09:50:00',2.17),('16273','2013-10-30','09:55:00',2.28),('16273','2013-10-30','10:00:00',2.32),('16273','2013-10-30','10:15:00',1.34),('16273','2013-10-30','10:20:00',1.69),('16273','2013-10-30','10:25:00',1.22),('16273','2013-10-30','10:30:00',2.18),('16273','2013-10-30','10:35:00',2.38),('16273','2013-10-30','10:40:00',2.45),('16273','2013-10-30','10:45:00',1.59),('16273','2013-10-30','10:50:00',1.57),('16273','2013-10-30','10:55:00',2.39),('16273','2013-10-30','11:00:00',2.8),('16273','2013-10-30','11:05:00',2.51),('16273','2013-10-30','11:10:00',2.66),('16273','2013-10-30','11:15:00',2.68),('16273','2013-10-30','11:20:00',1.27),('16273','2013-10-30','11:25:00',1.28),('16273','2013-10-30','11:30:00',1.32),('16273','2013-10-30','11:40:00',1.07),('16273','2013-10-30','11:45:00',1.87),('16273','2013-10-30','11:50:00',2.85),('16273','2013-10-30','11:55:00',2.81),('16273','2013-10-30','12:00:00',2.67),('16273','2013-10-30','12:05:00',2.03),('16273','2013-10-30','12:20:00',1.07),('16273','2013-10-30','12:25:00',1.07),('16273','2013-10-30','12:30:00',1.57),('16273','2013-10-30','12:35:00',1.1),('16273','2013-10-30','12:50:00',1.49),('16273','2013-10-30','13:00:00',1.43),('16273','2013-10-30','13:10:00',1.16),('16273','2013-10-30','14:30:00',1.32),('16273','2013-10-30','14:35:00',1.96),('16273','2013-10-30','14:40:00',1.83),('16273','2013-10-30','14:45:00',1.47),('16273','2013-10-30','14:50:00',1.5),('16273','2013-10-30','14:55:00',1.07),('16273','2013-10-30','15:00:00',1.15),('16273','2013-10-30','15:15:00',1.04),('16273','2013-10-29','08:15:00',1.08),('16273','2013-10-29','08:20:00',1.06),('16273','2013-10-29','08:25:00',1.19),('16273','2013-10-29','08:30:00',1.75),('16273','2013-10-29','08:35:00',1.16),('16273','2013-10-29','08:40:00',1.51),('16273','2013-10-29','08:45:00',1.87),('16273','2013-10-29','08:50:00',2.02),('16273','2013-10-29','08:55:00',2.08),('16273','2013-10-29','09:00:00',2.13),('16273','2013-10-29','09:05:00',2.2),('16273','2013-10-29','09:10:00',2.24),('16273','2013-10-29','09:15:00',2.28),('16273','2013-10-29','09:20:00',2.35),('16273','2013-10-29','09:25:00',2.38),('16273','2013-10-29','09:30:00',2.36),('16273','2013-10-29','09:35:00',2.4),('16273','2013-10-29','09:40:00',2.44),('16273','2013-10-29','09:45:00',2.27),('16273','2013-10-29','09:50:00',2.33),('16273','2013-10-29','09:55:00',2.59),('16273','2013-10-29','10:00:00',2.05),('16273','2013-10-29','10:05:00',1.39),('16273','2013-10-29','10:10:00',1.2),('16273','2013-10-29','10:15:00',1.12),('16273','2013-10-29','10:20:00',1.61),('16273','2013-10-29','10:25:00',2.6),('16273','2013-10-29','10:30:00',2.99),('16273','2013-10-29','10:35:00',2.98),('16273','2013-10-29','10:40:00',2.94),('16273','2013-10-29','10:45:00',3.03),('16273','2013-10-29','10:50:00',3.02),('16273','2013-10-29','10:55:00',3.05),('16273','2013-10-29','11:00:00',3.14),('16273','2013-10-29','11:05:00',3.12),('16273','2013-10-29','11:10:00',3.06),('16273','2013-10-29','11:15:00',3.05),('16273','2013-10-29','11:20:00',2.99),('16273','2013-10-29','11:25:00',2.89),('16273','2013-10-29','11:30:00',2.97),('16273','2013-10-29','11:35:00',3.04),('16273','2013-10-29','11:40:00',1.66),('16273','2013-10-29','11:45:00',1.46),('16273','2013-10-29','11:50:00',1.8),('16273','2013-10-29','11:55:00',2.22),('16273','2013-10-29','12:05:00',2.26),('16273','2013-10-29','12:10:00',2.88),('16273','2013-10-29','12:15:00',2.73),('16273','2013-10-29','12:20:00',2.72),('16273','2013-10-29','12:25:00',2.63),('16273','2013-10-29','12:30:00',2.65),('16273','2013-10-29','12:35:00',2.6),('16273','2013-10-29','12:40:00',2.53),('16273','2013-10-29','12:45:00',2.53),('16273','2013-10-29','12:50:00',2.61),('16273','2013-10-29','12:55:00',2.52),('16273','2013-10-29','13:00:00',2.02),('16273','2013-10-29','13:05:00',2.37),('16273','2013-10-29','13:10:00',2.28),('16273','2013-10-29','13:15:00',2.28),('16273','2013-10-29','13:20:00',2.29),('16273','2013-10-29','13:25:00',2.18),('16273','2013-10-29','13:30:00',2.21),('16273','2013-10-29','13:35:00',2.17),('16273','2013-10-29','13:40:00',2.11),('16273','2013-10-29','13:45:00',2.04),('16273','2013-10-29','13:50:00',1.94),('16273','2013-10-29','13:55:00',1.92),('16273','2013-10-29','14:00:00',1.85),('16273','2013-10-29','14:05:00',1.8),('16273','2013-10-29','14:10:00',1.77),('16273','2013-10-29','14:15:00',1.67),('16273','2013-10-29','14:20:00',1.6),('16273','2013-10-29','14:25:00',1.54),('16273','2013-10-29','14:30:00',1.48),('16273','2013-10-29','14:35:00',1.42),('16273','2013-10-29','14:40:00',1.34),('16273','2013-10-29','14:45:00',1.28),('16273','2013-10-29','14:50:00',1.23),('16273','2013-10-29','14:55:00',1.18),('16273','2013-10-29','15:00:00',1.1),('16273','2013-10-29','15:05:00',1.06),('16273','2014-04-17','07:55:00',1.47),('16273','2014-04-17','08:00:00',1.58),('16273','2014-04-17','08:05:00',1.62),('16273','2014-04-17','08:10:00',1.58),('16273','2014-04-17','08:15:00',1.58),('16273','2014-04-17','08:20:00',1.91),('16273','2014-04-17','08:25:00',1.99),('16273','2014-04-17','08:30:00',2.1),('16273','2014-04-17','08:35:00',2.18),('16273','2014-04-17','08:40:00',2.28),('16273','2014-04-17','08:45:00',2.38),('16273','2014-04-17','08:50:00',2.46),('16273','2014-04-17','08:55:00',2.53),('16273','2014-04-17','09:00:00',2.65),('16273','2014-04-17','09:05:00',2.73),('16273','2014-04-17','09:10:00',2.8),('16273','2014-04-17','09:15:00',2.87),('16273','2014-04-17','09:20:00',2.95),('16273','2014-04-17','09:25:00',3.01),('16273','2014-04-17','09:30:00',3.07),('16273','2014-04-17','09:35:00',3.13),('16273','2014-04-17','09:40:00',3.18),('16273','2014-04-17','09:45:00',3.21),('16273','2014-04-17','09:50:00',3.28),('16273','2014-04-17','09:55:00',3.36),('16273','2014-04-17','10:00:00',3.43),('16273','2014-04-17','10:05:00',3.44),('16273','2014-04-17','10:10:00',2.86),('16273','2014-04-17','10:15:00',3.31),('16273','2014-04-17','10:20:00',2.85),('16273','2014-04-17','10:25:00',2.05),('16273','2014-04-17','10:30:00',3.13),('16273','2014-04-17','10:35:00',3.67),('16273','2014-04-17','10:40:00',2.84),('16273','2014-04-17','10:45:00',3.11),('16273','2014-04-17','10:50:00',2.51),('16273','2014-04-17','10:55:00',2.06),('16273','2014-04-17','11:00:00',2.72),('16273','2014-04-17','11:05:00',3.16),('16273','2014-04-17','11:10:00',2.43),('16273','2014-04-17','11:15:00',3.2),('16273','2014-04-17','11:20:00',2.18),('16273','2014-04-17','11:25:00',2.9),('16273','2014-04-17','11:30:00',2.32),('16273','2014-04-17','11:35:00',2.5),('16273','2014-04-17','11:40:00',3.81),('16273','2014-04-17','11:45:00',2.36),('16273','2014-04-17','11:50:00',2.39),('16273','2014-04-17','11:55:00',1.85),('16273','2014-04-17','12:00:00',2.08),('16273','2014-04-17','12:05:00',2.27),('16273','2014-04-17','12:10:00',2.58),('16273','2014-04-17','12:15:00',2.92),('16273','2014-04-17','12:20:00',2.92),('16273','2014-04-17','12:25:00',3.33),('16273','2014-04-17','12:30:00',3.86),('16273','2014-04-17','12:35:00',3.86),('16273','2014-04-17','12:40:00',3.94),('16273','2014-04-17','12:45:00',4.03),('16273','2014-04-17','12:50:00',4.02),('16273','2014-04-17','12:55:00',3.98),('16273','2014-04-17','13:00:00',4.02),('16273','2014-04-17','13:05:00',4.02),('16273','2014-04-17','13:10:00',3.99),('16273','2014-04-17','13:15:00',3.95),('16273','2014-04-17','13:20:00',3.98),('16273','2014-04-17','13:25:00',4.09),('16273','2014-04-17','13:30:00',3.87),('16273','2014-04-17','13:35:00',3.15),('16273','2014-04-17','13:40:00',4.28),('16273','2014-04-17','13:45:00',4.28),('16273','2014-04-17','13:50:00',1.4),('16273','2014-04-17','14:00:00',4.27),('16273','2014-04-17','14:05:00',4.08),('16273','2014-04-17','14:10:00',3.39),('16273','2014-04-17','14:15:00',3.7),('16273','2014-04-17','14:20:00',1.24),('16273','2014-04-17','14:25:00',1.31),('16273','2014-04-17','14:30:00',1.81),('16273','2014-04-17','14:35:00',3.07),('16273','2014-04-17','14:40:00',1.8),('16273','2014-04-17','14:45:00',2.99),('16273','2014-04-17','14:50:00',2.69),('16273','2014-04-17','14:55:00',1.79),('16273','2014-04-17','15:00:00',1.31),('16273','2014-04-17','15:05:00',1.02),('16273','2014-04-17','15:10:00',1.32),('16273','2014-04-17','16:00:00',1.08),('16273','2014-04-17','16:25:00',1.05),('16273','2014-04-17','16:30:00',1.03),('16273','2014-04-17','16:40:00',1.1),('16273','2014-04-17','16:45:00',1.16),('16273','2014-04-17','16:50:00',1.21),('16273','2014-04-17','16:55:00',1.33),('16273','2014-04-17','17:00:00',1.1),('16273','2014-04-17','17:25:00',1.07),('16273','2014-04-17','17:30:00',1.38),('16273','2014-04-17','17:35:00',1.19),('16273','2014-04-17','17:40:00',1.02),('16273','2014-04-17','17:45:00',1.01),('16273','2013-10-28','08:20:00',1.03),('16273','2013-10-28','08:25:00',1.01),('16273','2013-10-28','08:35:00',1.09),('16273','2013-10-28','08:40:00',1.8),('16273','2013-10-28','08:45:00',1.98),('16273','2013-10-28','08:50:00',2.08),('16273','2013-10-28','08:55:00',2.1),('16273','2013-10-28','09:00:00',2.12),('16273','2013-10-28','09:05:00',2.35),('16273','2013-10-28','09:10:00',2.08),('16273','2013-10-28','09:15:00',2.22),('16273','2013-10-28','09:20:00',2.05),('16273','2013-10-28','09:25:00',2.32),('16273','2013-10-28','09:30:00',2.48),('16273','2013-10-28','09:35:00',1.28),('16273','2013-10-28','10:35:00',2.2),('16273','2013-10-28','10:40:00',2.97),('16273','2013-10-28','10:45:00',2.96),('16273','2013-10-28','10:50:00',2.93),('16273','2013-10-28','10:55:00',2.93),('16273','2013-10-28','11:00:00',2.93),('16273','2013-10-28','11:05:00',2.92),('16273','2013-10-28','11:10:00',2.93),('16273','2013-10-28','11:15:00',2.93),('16273','2013-10-28','11:20:00',2.9),('16273','2013-10-28','11:25:00',2.88),('16273','2013-10-28','11:30:00',2.87),('16273','2013-10-28','11:35:00',2.89),('16273','2013-10-28','11:40:00',2.88),('16273','2013-10-28','11:45:00',1.95),('16273','2013-10-28','11:50:00',2.91),('16273','2013-10-28','11:55:00',2.88),('16273','2013-10-28','12:00:00',2.88),('16273','2013-10-28','12:05:00',2.85),('16273','2013-10-28','12:10:00',2.81),('16273','2013-10-28','12:15:00',2.32),('16273','2013-10-28','12:20:00',2.96),('16273','2013-10-28','12:25:00',2.26),('16273','2013-10-28','12:30:00',2.68),('16273','2013-10-28','12:35:00',2.71),('16273','2013-10-28','12:40:00',2.67),('16273','2013-10-28','12:45:00',2.64),('16273','2013-10-28','12:50:00',2.58),('16273','2013-10-28','12:55:00',2.55),('16273','2013-10-28','13:00:00',2.53),('16273','2013-10-28','13:05:00',2.51),('16273','2013-10-28','13:10:00',2.45),('16273','2013-10-28','13:15:00',2.41),('16273','2013-10-28','13:20:00',2.37),('16273','2013-10-28','13:25:00',2.37),('16273','2013-10-28','13:30:00',2.06),('16273','2013-10-28','13:35:00',2),('16273','2013-10-28','13:40:00',2.31),('16273','2013-10-28','13:45:00',2.23),('16273','2013-10-28','13:50:00',1.79),('16273','2013-10-28','13:55:00',2.13),('16273','2013-10-28','14:00:00',1.83),('16273','2013-10-28','14:05:00',1.9),('16273','2013-10-28','14:10:00',1.66),('16273','2013-10-28','14:15:00',1.61),('16273','2013-10-28','14:20:00',1.31),('16273','2013-10-28','14:25:00',1.14),('16273','2013-10-28','14:40:00',1.44),('16273','2013-10-28','14:45:00',1.48),('16273','2013-10-28','14:50:00',1.4),('16273','2013-10-28','14:55:00',1.34),('16273','2013-10-28','15:00:00',1.19),('16273','2013-10-28','15:05:00',1.14),('16273','2013-10-28','15:10:00',1.14),('16273','2013-10-28','15:15:00',1.1),('16273','2013-10-28','15:20:00',1.14),('16273','2013-10-27','09:50:00',1.04),('16273','2013-10-27','09:55:00',1.13),('16273','2013-10-27','10:05:00',1.01),('16273','2013-10-27','10:10:00',1.05),('16273','2013-10-27','10:20:00',1.03),('16273','2013-10-27','10:25:00',1.19),('16273','2013-10-27','10:30:00',1.66),('16273','2013-10-27','10:35:00',1.47),('16273','2013-10-27','10:40:00',1.32),('16273','2013-10-27','10:45:00',1.27),('16273','2013-10-27','10:50:00',1.13),('16273','2013-10-27','10:55:00',1.11),('16273','2013-10-27','11:00:00',1.41),('16273','2013-10-27','11:05:00',1.31),('16273','2013-10-27','11:10:00',1.35),('16273','2013-10-27','11:15:00',1.51),('16273','2013-10-27','11:20:00',1.32),('16273','2013-10-27','11:25:00',1.58),('16273','2013-10-27','11:30:00',1.21),('16273','2013-10-27','11:35:00',1.01),('16273','2013-10-27','11:40:00',1.01),('16273','2013-10-27','11:45:00',1.27),('16273','2013-10-27','11:50:00',2.64),('16273','2013-10-27','11:55:00',3.02),('16273','2013-10-27','12:00:00',1.52),('16273','2013-10-27','12:05:00',1.34),('16273','2013-10-27','12:10:00',1.57),('16273','2013-10-27','12:15:00',1.69),('16273','2013-10-27','12:40:00',1.05),('16273','2013-10-27','12:45:00',2.82),('16273','2013-10-27','12:50:00',1.72),('16273','2013-10-27','12:55:00',1.31),('16273','2013-10-27','13:00:00',1.03),('16273','2013-10-27','13:05:00',2.15),('16273','2013-10-27','13:30:00',1.64),('16273','2013-10-27','13:35:00',2.36),('16273','2013-10-27','13:40:00',1.77),('16273','2013-10-27','13:45:00',1.16),('16273','2013-10-27','13:50:00',1.84),('16273','2013-10-27','13:55:00',2.44),('16273','2013-10-27','14:00:00',2.4),('16273','2013-10-27','14:05:00',2.3),('16273','2013-10-27','14:10:00',1.78),('16273','2013-10-27','14:15:00',1.76),('16273','2013-10-27','14:20:00',1.8),('16273','2013-10-27','14:25:00',1.4),('16273','2013-10-27','14:40:00',1.49),('16273','2013-10-26','08:45:00',1.04),('16273','2013-10-26','08:50:00',1.11),('16273','2013-10-26','08:55:00',1.19),('16273','2013-10-26','09:00:00',1.38),('16273','2013-10-26','09:05:00',1.47),('16273','2013-10-26','09:10:00',1.55),('16273','2013-10-26','09:15:00',1.64),('16273','2013-10-26','09:20:00',1.73),('16273','2013-10-26','09:25:00',1.8),('16273','2013-10-26','09:30:00',1.86),('16273','2013-10-26','09:35:00',1.93),('16273','2013-10-26','09:40:00',2),('16273','2013-10-26','09:45:00',2.04),('16273','2013-10-26','09:50:00',2.09),('16273','2013-10-26','09:55:00',2.13),('16273','2013-10-26','10:00:00',2.17),('16273','2013-10-26','10:05:00',2.21),('16273','2013-10-26','10:10:00',2.24),('16273','2013-10-26','10:15:00',2.28),('16273','2013-10-26','10:20:00',2.33),('16273','2013-10-26','10:25:00',2.4),('16273','2013-10-26','10:30:00',2.46),('16273','2013-10-26','10:35:00',2.5),('16273','2013-10-26','10:40:00',2.55),('16273','2013-10-26','10:45:00',2.58),('16273','2013-10-26','10:50:00',2.62),('16273','2013-10-26','10:55:00',2.6),('16273','2013-10-26','11:00:00',2.64),('16273','2013-10-26','11:05:00',2.67),('16273','2013-10-26','11:10:00',2.72),('16273','2013-10-26','11:15:00',2.73),('16273','2013-10-26','11:20:00',2.74),('16273','2013-10-26','11:25:00',2.74),('16273','2013-10-26','11:30:00',2.74),('16273','2013-10-26','11:35:00',2.8),('16273','2013-10-26','11:40:00',2.78),('16273','2013-10-26','11:45:00',2.78),('16273','2013-10-26','11:50:00',2.75),('16273','2013-10-26','11:55:00',2.79),('16273','2013-10-26','12:00:00',2.66),('16273','2013-10-26','12:05:00',2.82),('16273','2013-10-26','12:10:00',2.77),('16273','2013-10-26','12:15:00',2.82),('16273','2013-10-26','12:20:00',2.8),('16273','2013-10-26','12:25:00',2.75),('16273','2013-10-26','12:30:00',2.78),('16273','2013-10-26','12:35:00',2.81),('16273','2013-10-26','12:40:00',2.82),('16273','2013-10-26','12:45:00',2.77),('16273','2013-10-26','12:50:00',2.7),('16273','2013-10-26','12:55:00',2.71),('16273','2013-10-26','13:00:00',2.74),('16273','2013-10-26','13:05:00',2.74),('16273','2013-10-26','13:10:00',2.65),('16273','2013-10-26','13:15:00',2.61),('16273','2013-10-26','13:20:00',2.62),('16273','2013-10-26','13:25:00',2.61),('16273','2013-10-26','13:30:00',2.6),('16273','2013-10-26','13:35:00',2.5),('16273','2013-10-26','13:40:00',2.52),('16273','2013-10-26','13:45:00',2.53),('16273','2013-10-26','13:50:00',2.46),('16273','2013-10-26','13:55:00',2.44),('16273','2013-10-26','14:00:00',2.29),('16273','2013-10-26','14:05:00',2.38),('16273','2013-10-26','14:10:00',2.21),('16273','2013-10-26','14:15:00',2.26),('16273','2013-10-26','14:20:00',2.05),('16273','2013-10-26','14:25:00',1.96),('16273','2013-10-26','14:30:00',2.28),('16273','2013-10-26','14:35:00',2.39),('16273','2013-10-26','14:40:00',1.84),('16273','2013-10-26','14:45:00',1.15),('16273','2013-10-26','14:50:00',1.83),('16273','2013-10-26','14:55:00',1.5),('16273','2013-10-26','15:00:00',1.92),('16273','2013-10-26','15:05:00',1.85),('16273','2013-10-26','15:10:00',1.8),('16273','2013-10-26','15:15:00',1.5),('16273','2013-10-26','15:20:00',1.63),('16273','2013-10-26','15:25:00',1.59),('16273','2013-10-26','15:30:00',1.53),('16273','2013-10-26','15:35:00',1.43),('16273','2013-10-26','15:40:00',1.39),('16273','2013-10-26','15:45:00',1.29),('16273','2013-10-26','15:50:00',1.25),('16273','2013-10-26','15:55:00',1.18),('16273','2013-10-26','16:00:00',1.12),('16273','2013-10-26','16:05:00',1.09),('16273','2013-10-26','16:10:00',1.02),('16273','2013-10-25','08:45:00',1.05),('16273','2013-10-25','08:50:00',1.12),('16273','2013-10-25','08:55:00',1.21),('16273','2013-10-25','09:00:00',1.41),('16273','2013-10-25','09:05:00',1.51),('16273','2013-10-25','09:10:00',1.59),('16273','2013-10-25','09:15:00',1.67),('16273','2013-10-25','09:20:00',1.75),('16273','2013-10-25','09:25:00',1.82),('16273','2013-10-25','09:30:00',1.88),('16273','2013-10-25','09:35:00',1.95),('16273','2013-10-25','09:40:00',2),('16273','2013-10-25','09:45:00',2.06),('16273','2013-10-25','09:50:00',2.12),('16273','2013-10-25','09:55:00',2.18),('16273','2013-10-25','10:00:00',2.23),('16273','2013-10-25','10:05:00',2.29),('16273','2013-10-25','10:10:00',2.34),('16273','2013-10-25','10:15:00',2.39),('16273','2013-10-25','10:20:00',2.45),('16273','2013-10-25','10:25:00',2.49),('16273','2013-10-25','10:30:00',2.52),('16273','2013-10-25','10:35:00',2.58),('16273','2013-10-25','10:40:00',2.6),('16273','2013-10-25','10:45:00',2.65),('16273','2013-10-25','10:50:00',2.7),('16273','2013-10-25','10:55:00',2.69),('16273','2013-10-25','11:00:00',2.76),('16273','2013-10-25','11:05:00',2.79),('16273','2013-10-25','11:10:00',2.81),('16273','2013-10-25','11:15:00',2.82),('16273','2013-10-25','11:20:00',2.82),('16273','2013-10-25','11:25:00',2.8),('16273','2013-10-25','11:30:00',2.88),('16273','2013-10-25','11:35:00',2.91),('16273','2013-10-25','11:40:00',2.91),('16273','2013-10-25','11:45:00',2.92),('16273','2013-10-25','11:50:00',2.92),('16273','2013-10-25','11:55:00',2.93),('16273','2013-10-25','12:00:00',2.94),('16273','2013-10-25','12:05:00',2.95),('16273','2013-10-25','12:10:00',2.95),('16273','2013-10-25','12:15:00',2.96),('16273','2013-10-25','12:20:00',2.95),('16273','2013-10-25','12:25:00',2.94),('16273','2013-10-25','12:30:00',2.92),('16273','2013-10-25','12:35:00',2.93),('16273','2013-10-25','12:40:00',2.91),('16273','2013-10-25','12:45:00',2.89),('16273','2013-10-25','12:50:00',2.88),('16273','2013-10-25','12:55:00',2.87),('16273','2013-10-25','13:00:00',2.84),('16273','2013-10-25','13:05:00',2.84),('16273','2013-10-25','13:10:00',2.79),('16273','2013-10-25','13:15:00',2.74),('16273','2013-10-25','13:20:00',2.75),('16273','2013-10-25','13:25:00',2.74),('16273','2013-10-25','13:30:00',2.7),('16273','2013-10-25','13:35:00',2.68),('16273','2013-10-25','13:40:00',2.64),('16273','2013-10-25','13:45:00',2.58),('16273','2013-10-25','13:50:00',2.53),('16273','2013-10-25','13:55:00',2.53),('16273','2013-10-25','14:00:00',2.49),('16273','2013-10-25','14:05:00',2.47),('16273','2013-10-25','14:10:00',2.43),('16273','2013-10-25','14:15:00',2.38),('16273','2013-10-25','14:20:00',2.35),('16273','2013-10-25','14:25:00',2.27),('16273','2013-10-25','14:30:00',2.22),('16273','2013-10-25','14:35:00',2.17),('16273','2013-10-25','14:40:00',2.15),('16273','2013-10-25','14:45:00',2.1),('16273','2013-10-25','14:50:00',2.03),('16273','2013-10-25','14:55:00',1.94),('16273','2013-10-25','15:00:00',1.9),('16273','2013-10-25','15:05:00',1.87),('16273','2013-10-25','15:10:00',1.83),('16273','2013-10-25','15:15:00',1.77),('16273','2013-10-25','15:20:00',1.71),('16273','2013-10-25','15:25:00',1.63),('16273','2013-10-25','15:30:00',1.56),('16273','2013-10-25','15:35:00',1.51),('16273','2013-10-25','15:40:00',1.46),('16273','2013-10-25','15:45:00',1.38),('16273','2013-10-25','15:50:00',1.33),('16273','2013-10-25','15:55:00',1.27),('16273','2013-10-25','16:00:00',1.21),('16273','2013-10-25','16:05:00',1.16),('16273','2013-10-25','16:10:00',1.11),('16273','2013-10-25','16:15:00',1.04),('16273','2013-10-24','08:55:00',1.42),('16273','2013-10-24','09:00:00',1.44),('16273','2013-10-24','09:05:00',1.65),('16273','2013-10-24','09:10:00',1.55),('16273','2013-10-24','09:25:00',1.03),('16273','2013-10-24','09:35:00',1),('16273','2013-10-24','09:40:00',1.03),('16273','2013-10-24','09:45:00',1.09),('16273','2013-10-24','09:50:00',1.01),('16273','2013-10-24','10:10:00',1.13),('16273','2013-10-24','10:25:00',1.19),('16273','2013-10-24','10:30:00',1.36),('16273','2013-10-24','10:35:00',1.3),('16273','2013-10-24','10:40:00',1.58),('16273','2013-10-24','10:45:00',2.11),('16273','2013-10-24','10:50:00',2.53),('16273','2013-10-24','10:55:00',1.74),('16273','2013-10-24','11:00:00',1.62),('16273','2013-10-24','11:05:00',1.57),('16273','2013-10-24','11:10:00',1.19),('16273','2013-10-24','11:15:00',1.11),('16273','2013-10-24','11:20:00',1.03),('16273','2013-10-24','11:25:00',1.07),('16273','2013-10-24','11:30:00',1.57),('16273','2013-10-24','11:35:00',2.57),('16273','2013-10-24','11:40:00',2.14),('16273','2013-10-24','11:45:00',3.1),('16273','2013-10-24','11:50:00',1.55),('16273','2013-10-24','11:55:00',1.29),('16273','2013-10-24','12:00:00',1.29),('16273','2013-10-24','12:05:00',1.3),('16273','2013-10-24','12:10:00',1.4),('16273','2013-10-24','12:15:00',1.54),('16273','2013-10-24','12:20:00',1.62),('16273','2013-10-24','12:25:00',1.65),('16273','2013-10-24','12:30:00',1.59),('16273','2013-10-24','12:35:00',1.56),('16273','2013-10-24','12:40:00',1.9),('16273','2013-10-24','12:45:00',1.96),('16273','2013-10-24','12:50:00',1.73),('16273','2013-10-24','12:55:00',1.64),('16273','2013-10-24','13:00:00',1.43),('16273','2013-10-24','13:05:00',1.4),('16273','2013-10-24','13:10:00',1.28),('16273','2013-10-24','13:15:00',1.22),('16273','2013-10-24','13:20:00',1.18),('16273','2013-10-24','13:25:00',1.19),('16273','2013-10-24','13:30:00',1.21),('16273','2013-10-24','13:35:00',1.26),('16273','2013-10-24','13:40:00',1.9),('16273','2013-10-24','13:45:00',1.86),('16273','2013-10-24','13:50:00',1.21),('16273','2013-10-24','13:55:00',1.21),('16273','2013-10-24','14:00:00',1.3),('16273','2013-10-24','14:05:00',1.56),('16273','2013-10-24','14:10:00',1.34),('16273','2013-10-24','14:15:00',1.3),('16273','2013-10-24','14:20:00',1.28),('16273','2013-10-24','14:25:00',1.67),('16273','2013-10-24','14:30:00',1.79),('16273','2013-10-24','14:35:00',1.3),('16273','2013-10-24','14:50:00',1.13),('16273','2013-10-24','14:55:00',1.03),('16273','2013-10-24','15:00:00',1.27),('16273','2013-10-24','15:05:00',1.13),('16273','2013-10-24','15:10:00',1.06),('16273','2013-10-24','15:20:00',1.05),('16273','2013-10-24','15:25:00',1.64),('16273','2013-10-24','15:30:00',2.11),('16273','2013-10-24','15:35:00',1.97),('16273','2013-10-24','15:40:00',1.8),('16273','2013-10-24','15:45:00',1.14),('16273','2013-10-23','09:55:00',1.07),('16273','2013-10-23','10:00:00',1.1),('16273','2013-10-23','10:05:00',1.28),('16273','2013-10-23','10:10:00',1.25),('16273','2013-10-23','10:25:00',1.26),('16273','2013-10-23','10:30:00',1.9),('16273','2013-10-23','10:35:00',2.21),('16273','2013-10-23','10:40:00',1.63),('16273','2013-10-23','10:45:00',1.44),('16273','2013-10-23','10:50:00',2.28),('16273','2013-10-23','10:55:00',2.78),('16273','2013-10-23','11:00:00',2.74),('16273','2013-10-23','11:05:00',2.82),('16273','2013-10-23','11:10:00',2.83),('16273','2013-10-23','11:15:00',2.77),('16273','2013-10-23','11:20:00',2.71),('16273','2013-10-23','11:25:00',2.69),('16273','2013-10-23','11:30:00',2.71),('16273','2013-10-23','11:35:00',2.55),('16273','2013-10-23','11:40:00',2.75),('16273','2013-10-23','11:45:00',2.83),('16273','2013-10-23','11:50:00',2.31),('16273','2013-10-23','11:55:00',2.12),('16273','2013-10-23','12:00:00',1.69),('16273','2013-10-23','12:05:00',2.02),('16273','2013-10-23','12:10:00',2.59),('16273','2013-10-23','12:15:00',1.84),('16273','2013-10-23','12:20:00',2.59),('16273','2013-10-23','12:25:00',2.93),('16273','2013-10-23','12:30:00',2.83),('16273','2013-10-23','12:35:00',2.66),('16273','2013-10-23','12:40:00',2.64),('16273','2013-10-23','12:45:00',2.67),('16273','2013-10-23','12:50:00',2.74),('16273','2013-10-23','12:55:00',2.73),('16273','2013-10-23','13:00:00',2.72),('16273','2013-10-23','13:05:00',2.66),('16273','2013-10-23','13:10:00',2.68),('16273','2013-10-23','13:15:00',2.6),('16273','2013-10-23','13:20:00',2.56),('16273','2013-10-23','13:25:00',2.62),('16273','2013-10-23','13:30:00',2.6),('16273','2013-10-23','13:35:00',2.6),('16273','2013-10-23','13:40:00',2.56),('16273','2013-10-23','13:45:00',2.62),('16273','2013-10-23','13:50:00',2.58),('16273','2013-10-23','13:55:00',2.48),('16273','2013-10-23','14:00:00',2.38),('16273','2013-10-23','14:05:00',2.2),('16273','2013-10-23','14:10:00',2.35),('16273','2013-10-23','14:15:00',2.23),('16273','2013-10-23','14:20:00',2.02),('16273','2013-10-23','14:25:00',2.01),('16273','2013-10-23','14:30:00',1.96),('16273','2013-10-23','14:35:00',1.77),('16273','2013-10-23','14:40:00',1.9),('16273','2013-10-23','14:45:00',1.94),('16273','2013-10-23','14:50:00',1.73),('16273','2013-10-23','14:55:00',1.82),('16273','2013-10-23','15:00:00',1.81),('16273','2013-10-23','15:05:00',1.74),('16273','2013-10-23','15:10:00',1.51),('16273','2013-10-23','15:15:00',1.39),('16273','2013-10-23','15:20:00',1.62),('16273','2013-10-23','15:25:00',1.5),('16273','2013-10-23','15:30:00',1.35),('16273','2013-10-23','15:35:00',1.38),('16273','2013-10-23','15:40:00',1.46),('16273','2013-10-23','15:45:00',1.34),('16273','2013-10-23','15:50:00',1.1),('16273','2013-10-23','15:55:00',1.09),('16273','2013-10-22','08:45:00',1.07),('16273','2013-10-22','08:50:00',1.03),('16273','2013-10-22','08:55:00',1.3),('16273','2013-10-22','09:00:00',1.4),('16273','2013-10-22','09:05:00',1.47),('16273','2013-10-22','09:10:00',1.56),('16273','2013-10-22','09:15:00',1.65),('16273','2013-10-22','09:20:00',1.72),('16273','2013-10-22','09:25:00',1.8),('16273','2013-10-22','09:30:00',1.87),('16273','2013-10-22','09:35:00',1.91),('16273','2013-10-22','09:40:00',1.98),('16273','2013-10-22','09:45:00',1.99),('16273','2013-10-22','09:50:00',2.04),('16273','2013-10-22','09:55:00',2.16),('16273','2013-10-22','10:00:00',2.21),('16273','2013-10-22','10:05:00',2.26),('16273','2013-10-22','10:10:00',2.31),('16273','2013-10-22','10:15:00',2.35),('16273','2013-10-22','10:20:00',2.4),('16273','2013-10-22','10:25:00',2.42),('16273','2013-10-22','10:30:00',2.45),('16273','2013-10-22','10:35:00',2.48),('16273','2013-10-22','10:40:00',2.51),('16273','2013-10-22','10:45:00',2.51),('16273','2013-10-22','10:50:00',2.53),('16273','2013-10-22','10:55:00',2.57),('16273','2013-10-22','11:00:00',2.54),('16273','2013-10-22','11:05:00',2.55),('16273','2013-10-22','11:10:00',2.62),('16273','2013-10-22','11:15:00',2.64),('16273','2013-10-22','11:20:00',2.64),('16273','2013-10-22','11:25:00',2.73),('16273','2013-10-22','11:30:00',2.74),('16273','2013-10-22','11:35:00',2.74),('16273','2013-10-22','11:40:00',2.76),('16273','2013-10-22','11:45:00',2.72),('16273','2013-10-22','11:50:00',2.79),('16273','2013-10-22','11:55:00',2.8),('16273','2013-10-22','12:00:00',2.8),('16273','2013-10-22','12:05:00',2.82),('16273','2013-10-22','12:10:00',2.84),('16273','2013-10-22','12:15:00',2.82),('16273','2013-10-22','12:20:00',2.87),('16273','2013-10-22','12:25:00',2.91),('16273','2013-10-22','12:30:00',2.92),('16273','2013-10-22','12:35:00',2.83),('16273','2013-10-22','12:40:00',2.78),('16273','2013-10-22','12:45:00',2.82),('16273','2013-10-22','12:50:00',2.84),('16273','2013-10-22','12:55:00',2.71),('16273','2013-10-22','13:00:00',2.7),('16273','2013-10-22','13:05:00',2.64),('16273','2013-10-22','13:10:00',2.72),('16273','2013-10-22','13:15:00',2.67),('16273','2013-10-22','13:20:00',2.67),('16273','2013-10-22','13:25:00',2.72),('16273','2013-10-22','13:30:00',2.76),('16273','2013-10-22','13:35:00',1.65),('16273','2013-10-22','13:40:00',1.64),('16273','2013-10-22','13:45:00',2.59),('16273','2013-10-22','13:50:00',2.76),('16273','2013-10-22','13:55:00',2.79),('16273','2013-10-22','14:00:00',2.56),('16273','2013-10-22','14:05:00',2.38),('16273','2013-10-22','14:10:00',2.13),('16273','2013-10-22','14:15:00',2.17),('16273','2013-10-22','14:20:00',2.09),('16273','2013-10-22','14:25:00',2.27),('16273','2013-10-22','14:30:00',2.04),('16273','2013-10-22','14:35:00',2.22),('16273','2013-10-22','14:40:00',2.14),('16273','2013-10-22','14:45:00',2.09),('16273','2013-10-22','14:50:00',2.01),('16273','2013-10-22','14:55:00',1.98),('16273','2013-10-22','15:00:00',1.92),('16273','2013-10-22','15:05:00',1.86),('16273','2013-10-22','15:10:00',1.8),('16273','2013-10-22','15:15:00',1.74),('16273','2013-10-22','15:20:00',1.68),('16273','2013-10-22','15:25:00',1.61),('16273','2013-10-22','15:30:00',1.57),('16273','2013-10-22','15:35:00',1.48),('16273','2013-10-22','15:40:00',1.42),('16273','2013-10-22','15:45:00',1.37),('16273','2013-10-22','15:50:00',1.31),('16273','2013-10-22','15:55:00',1.25),('16273','2013-10-22','16:00:00',1.19),('16273','2013-10-22','16:05:00',1.14),('16273','2013-10-22','16:10:00',1.06),('16273','2013-10-22','16:15:00',1.02),('16273','2013-10-21','09:00:00',1.09),('16273','2013-10-21','09:05:00',1.46),('16273','2013-10-21','09:10:00',1.68),('16273','2013-10-21','09:15:00',1.84),('16273','2013-10-21','09:20:00',1.71),('16273','2013-10-21','09:25:00',1.63),('16273','2013-10-21','09:30:00',1.6),('16273','2013-10-21','09:35:00',1.77),('16273','2013-10-21','09:40:00',1.56),('16273','2013-10-21','09:45:00',1.65),('16273','2013-10-21','09:50:00',1.93),('16273','2013-10-21','09:55:00',2.06),('16273','2013-10-21','10:00:00',2.24),('16273','2013-10-21','10:05:00',2.36),('16273','2013-10-21','10:10:00',2.48),('16273','2013-10-21','10:15:00',2.5),('16273','2013-10-21','10:20:00',2.44),('16273','2013-10-21','10:25:00',2.5),('16273','2013-10-21','10:30:00',2.42),('16273','2013-10-21','10:35:00',2.56),('16273','2013-10-21','10:40:00',2.56),('16273','2013-10-21','10:45:00',2.68),('16273','2013-10-21','10:50:00',2.8),('16273','2013-10-21','10:55:00',2.65),('16273','2013-10-21','11:00:00',2.63),('16273','2013-10-21','11:05:00',2.87),('16273','2013-10-21','11:10:00',2.85),('16273','2013-10-21','11:15:00',2.75),('16273','2013-10-21','11:20:00',2.79),('16273','2013-10-21','11:25:00',2.89),('16273','2013-10-21','11:30:00',2.78),('16273','2013-10-21','11:35:00',2.82),('16273','2013-10-21','11:40:00',2.88),('16273','2013-10-21','11:45:00',2.8),('16273','2013-10-21','11:50:00',2.93),('16273','2013-10-21','11:55:00',2.94),('16273','2013-10-21','12:00:00',2.9),('16273','2013-10-21','12:05:00',2.84),('16273','2013-10-21','12:10:00',2.87),('16273','2013-10-21','12:15:00',2.88),('16273','2013-10-21','12:20:00',2.78),('16273','2013-10-21','12:25:00',2.84),('16273','2013-10-21','12:30:00',2.87),('16273','2013-10-21','12:35:00',2.87),('16273','2013-10-21','12:40:00',2.88),('16273','2013-10-21','12:45:00',2.8),('16273','2013-10-21','12:50:00',2.81),('16273','2013-10-21','12:55:00',2.78),('16273','2013-10-21','13:00:00',2.65),('16273','2013-10-21','13:05:00',2.69),('16273','2013-10-21','13:10:00',2.66),('16273','2013-10-21','13:15:00',2.64),('16273','2013-10-21','13:20:00',2.7),('16273','2013-10-21','13:25:00',2.77),('16273','2013-10-21','13:30:00',2.73),('16273','2013-10-21','13:35:00',2.7),('16273','2013-10-21','13:40:00',2.66),('16273','2013-10-21','13:45:00',2.56),('16273','2013-10-21','13:50:00',2.47),('16273','2013-10-21','13:55:00',2.54),('16273','2013-10-21','14:00:00',2.47),('16273','2013-10-21','14:05:00',2.46),('16273','2013-10-21','14:10:00',2.4),('16273','2013-10-21','14:15:00',2.43),('16273','2013-10-21','14:20:00',2.38),('16273','2013-10-21','14:25:00',2.36),('16273','2013-10-21','14:30:00',2.3),('16273','2013-10-21','14:35:00',2.23),('16273','2013-10-21','14:40:00',2.2),('16273','2013-10-21','14:45:00',2.1),('16273','2013-10-21','14:50:00',2.07),('16273','2013-10-21','14:55:00',2.01),('16273','2013-10-21','15:00:00',1.95),('16273','2013-10-21','15:05:00',1.92),('16273','2013-10-21','15:10:00',1.82),('16273','2013-10-21','15:15:00',1.66),('16273','2013-10-21','15:20:00',1.7),('16273','2013-10-21','15:25:00',1.65),('16273','2013-10-21','15:30:00',1.63),('16273','2013-10-21','15:35:00',1.54),('16273','2013-10-21','15:40:00',1.49),('16273','2013-10-21','15:45:00',1.39),('16273','2013-10-21','15:50:00',1.32),('16273','2013-10-21','15:55:00',1.29),('16273','2013-10-21','16:00:00',1.24),('16273','2013-10-21','16:05:00',1.19),('16273','2013-10-21','16:10:00',1.13),('16273','2013-10-21','16:15:00',1.06),('16273','2013-10-20','08:35:00',1.01),('16273','2013-10-20','08:40:00',1.26),('16273','2013-10-20','08:45:00',1.29),('16273','2013-10-20','08:50:00',1.37),('16273','2013-10-20','08:55:00',1.4),('16273','2013-10-20','09:00:00',1.55),('16273','2013-10-20','09:05:00',1.62),('16273','2013-10-20','09:10:00',1.71),('16273','2013-10-20','09:15:00',1.8),('16273','2013-10-20','09:20:00',1.89),('16273','2013-10-20','09:25:00',1.96),('16273','2013-10-20','09:30:00',2.02),('16273','2013-10-20','09:35:00',2.07),('16273','2013-10-20','09:40:00',2.15),('16273','2013-10-20','09:45:00',2.23),('16273','2013-10-20','09:50:00',2.29),('16273','2013-10-20','09:55:00',2.33),('16273','2013-10-20','10:00:00',2.42),('16273','2013-10-20','10:05:00',2.45),('16273','2013-10-20','10:10:00',2.51),('16273','2013-10-20','10:15:00',2.55),('16273','2013-10-20','10:20:00',2.57),('16273','2013-10-20','10:25:00',2.64),('16273','2013-10-20','10:30:00',2.68),('16273','2013-10-20','10:35:00',2.72),('16273','2013-10-20','10:40:00',2.74),('16273','2013-10-20','10:45:00',2.77),('16273','2013-10-20','10:50:00',2.83),('16273','2013-10-20','10:55:00',2.86),('16273','2013-10-20','11:00:00',2.87),('16273','2013-10-20','11:05:00',2.93),('16273','2013-10-20','11:10:00',2.84),('16273','2013-10-20','11:15:00',2.97),('16273','2013-10-20','11:20:00',2.7),('16273','2013-10-20','11:25:00',2.68),('16273','2013-10-20','11:30:00',2.85),('16273','2013-10-20','11:35:00',3.02),('16273','2013-10-20','11:40:00',2.96),('16273','2013-10-20','11:45:00',2.98),('16273','2013-10-20','11:50:00',2.98),('16273','2013-10-20','11:55:00',2.96),('16273','2013-10-20','12:00:00',3.05),('16273','2013-10-20','12:05:00',2.22),('16273','2013-10-20','12:10:00',2.74),('16273','2013-10-20','12:15:00',2.15),('16273','2013-10-20','12:20:00',1.87),('16273','2013-10-20','12:30:00',1.27),('16273','2013-10-20','12:35:00',1.9),('16273','2013-10-20','12:40:00',2.33),('16273','2013-10-20','12:45:00',3.11),('16273','2013-10-20','12:50:00',1.22),('16273','2013-10-20','12:55:00',1.56),('16273','2013-10-20','13:05:00',1.81),('16273','2013-10-20','13:25:00',1.64),('16273','2013-10-20','13:40:00',1.28),('16273','2013-10-20','13:45:00',1.52),('16273','2013-10-20','13:50:00',1.2),('16273','2013-10-20','14:00:00',1.24),('16273','2013-10-20','14:05:00',2.7),('16273','2013-10-20','14:10:00',1.68),('16273','2013-10-20','14:15:00',1.35),('16273','2013-10-20','14:20:00',2.57),('16273','2013-10-20','14:25:00',2.81),('16273','2013-10-20','14:30:00',2.81),('16273','2013-10-20','14:35:00',2.68),('16273','2013-10-20','14:40:00',2.59),('16273','2013-10-20','14:45:00',2.44),('16273','2013-10-20','14:50:00',2.36),('16273','2013-10-20','14:55:00',2.24),('16273','2013-10-20','15:00:00',2.29),('16273','2013-10-20','15:05:00',2.3),('16273','2013-10-20','15:10:00',2.16),('16273','2013-10-20','15:15:00',2.03),('16273','2013-10-20','15:20:00',1.92),('16273','2013-10-20','15:25:00',1.96),('16273','2013-10-20','15:30:00',1.98),('16273','2013-10-20','15:35:00',1.92),('16273','2013-10-20','15:40:00',1.84),('16273','2013-10-20','15:45:00',1.78),('16273','2013-10-20','15:50:00',1.68),('16273','2013-10-20','15:55:00',1.58),('16273','2013-10-20','16:00:00',1.42),('16273','2013-10-20','16:05:00',1.42),('16273','2013-10-20','16:10:00',1.29),('16273','2013-10-20','16:15:00',1.18),('16273','2013-10-20','16:20:00',1.12),('16273','2013-10-20','16:25:00',1.05),('16273','2013-10-19','08:30:00',1.1),('16273','2013-10-19','08:35:00',1.29),('16273','2013-10-19','08:40:00',1.39),('16273','2013-10-19','08:45:00',1.09),('16273','2013-10-19','08:50:00',1.62),('16273','2013-10-19','08:55:00',1.58),('16273','2013-10-19','09:00:00',1.48),('16273','2013-10-19','09:05:00',2.08),('16273','2013-10-19','09:10:00',2.13),('16273','2013-10-19','09:15:00',2.19),('16273','2013-10-19','09:20:00',2.23),('16273','2013-10-19','09:25:00',2.24),('16273','2013-10-19','09:30:00',2.32),('16273','2013-10-19','09:35:00',2.4),('16273','2013-10-19','09:40:00',2.37),('16273','2013-10-19','09:45:00',2.54),('16273','2013-10-19','09:50:00',2.58),('16273','2013-10-19','09:55:00',2.58),('16273','2013-10-19','10:00:00',2.59),('16273','2013-10-19','10:05:00',2.73),('16273','2013-10-19','10:10:00',2.79),('16273','2013-10-19','10:15:00',2.85),('16273','2013-10-19','10:20:00',2.92),('16273','2013-10-19','10:25:00',2.95),('16273','2013-10-19','10:30:00',2.93),('16273','2013-10-19','10:35:00',2.93),('16273','2013-10-19','10:40:00',2.98),('16273','2013-10-19','10:45:00',3.04),('16273','2013-10-19','10:50:00',3.05),('16273','2013-10-19','10:55:00',2.97),('16273','2013-10-19','11:00:00',2.67),('16273','2013-10-19','11:05:00',2),('16273','2013-10-19','11:10:00',3.3),('16273','2013-10-19','11:15:00',3.31),('16273','2013-10-19','11:20:00',3.29),('16273','2013-10-19','11:25:00',3.26),('16273','2013-10-19','11:30:00',3.21),('16273','2013-10-19','11:35:00',3.18),('16273','2013-10-19','11:40:00',3.09),('16273','2013-10-19','11:45:00',3.24),('16273','2013-10-19','11:50:00',3.24),('16273','2013-10-19','11:55:00',3.2),('16273','2013-10-19','12:00:00',3.15),('16273','2013-10-19','12:05:00',3.2),('16273','2013-10-19','12:10:00',3.06),('16273','2013-10-19','12:15:00',3.14),('16273','2013-10-19','12:20:00',3.05),('16273','2013-10-19','12:25:00',3.09),('16273','2013-10-19','12:30:00',3.1),('16273','2013-10-19','12:35:00',3.18),('16273','2013-10-19','12:40:00',3.26),('16273','2013-10-19','12:45:00',3.36),('16273','2013-10-19','12:50:00',3.39),('16273','2013-10-19','12:55:00',3.11),('16273','2013-10-19','13:00:00',3.17),('16273','2013-10-19','13:05:00',2.97),('16273','2013-10-19','13:10:00',3.02),('16273','2013-10-19','13:15:00',3.22),('16273','2013-10-19','13:20:00',2.73),('16273','2013-10-19','13:25:00',2.42),('16273','2013-10-19','13:30:00',1.91),('16273','2013-10-19','13:35:00',2.63),('16273','2013-10-19','13:40:00',3.15),('16273','2013-10-19','13:45:00',2.93),('16273','2013-10-19','13:50:00',2.64),('16273','2013-10-19','13:55:00',2.92),('16273','2013-10-19','14:00:00',1.99),('16273','2013-10-19','14:05:00',2.64),('16273','2013-10-19','14:10:00',2.28),('16273','2013-10-19','14:15:00',2.54),('16273','2013-10-19','14:20:00',2.85),('16273','2013-10-19','14:25:00',2.71),('16273','2013-10-19','14:30:00',2.03),('16273','2013-10-19','14:35:00',2.46),('16273','2013-10-19','14:40:00',2.52),('16273','2013-10-19','14:45:00',2.4),('16273','2013-10-19','14:50:00',2.3),('16273','2013-10-19','14:55:00',2.24),('16273','2013-10-19','15:00:00',2.24),('16273','2013-10-19','15:05:00',2.09),('16273','2013-10-19','15:10:00',2.01),('16273','2013-10-19','15:15:00',1.92),('16273','2013-10-19','15:20:00',1.86),('16273','2013-10-19','15:25:00',1.84),('16273','2013-10-19','15:30:00',1.64),('16273','2013-10-19','15:35:00',1.47),('16273','2013-10-19','15:40:00',1.64),('16273','2013-10-19','15:45:00',1.6),('16273','2013-10-19','15:50:00',1.56),('16273','2013-10-19','15:55:00',1.47),('16273','2013-10-19','16:00:00',1.39),('16273','2013-10-19','16:05:00',1.41),('16273','2013-10-19','16:15:00',1.01),('16273','2013-10-19','16:20:00',1.24),('16273','2013-10-19','16:25:00',1.24),('16273','2013-10-19','16:30:00',1.2),('16273','2013-10-19','16:35:00',1.14),('16273','2013-10-19','16:40:00',1.04),('16273','2014-05-04','07:15:00',1.03),('16273','2014-05-04','07:20:00',1.16),('16273','2014-05-04','07:25:00',1.17),('16273','2014-05-04','07:30:00',1.29),('16273','2014-05-04','07:35:00',1.48),('16273','2014-05-04','07:40:00',1.61),('16273','2014-05-04','07:45:00',1.8),('16273','2014-05-04','07:50:00',1.77),('16273','2014-05-04','07:55:00',1.87),('16273','2014-05-04','08:00:00',1.95),('16273','2014-05-04','08:05:00',1.92),('16273','2014-05-04','08:10:00',1.44),('16273','2014-05-04','08:15:00',2.16),('16273','2014-05-04','08:20:00',2.27),('16273','2014-05-04','08:25:00',2.45),('16273','2014-05-04','08:30:00',1.6),('16273','2014-05-04','08:35:00',1.94),('16273','2014-05-04','08:40:00',1.92),('16273','2014-05-04','08:45:00',1.72),('16273','2014-05-04','08:50:00',2.19),('16273','2014-05-04','08:55:00',1.49),('16273','2014-05-04','09:00:00',1.45),('16273','2014-05-04','09:05:00',1.53),('16273','2014-05-04','09:10:00',1.51),('16273','2014-05-04','09:15:00',1.35),('16273','2014-05-04','09:20:00',2.03),('16273','2014-05-04','09:25:00',2.61),('16273','2014-05-04','09:30:00',3.25),('16273','2014-05-04','09:35:00',3.85),('16273','2014-05-04','09:40:00',3.25),('16273','2014-05-04','09:45:00',3.81),('16273','2014-05-04','09:50:00',2.39),('16273','2014-05-04','09:55:00',3.02),('16273','2014-05-04','10:00:00',3.72),('16273','2014-05-04','10:05:00',3.87),('16273','2014-05-04','10:10:00',3.59),('16273','2014-05-04','10:15:00',1.92),('16273','2014-05-04','10:20:00',2.84),('16273','2014-05-04','10:25:00',3.15),('16273','2014-05-04','10:30:00',1.82),('16273','2014-05-04','10:35:00',1.7),('16273','2014-05-04','10:40:00',1.94),('16273','2014-05-04','10:45:00',1.79),('16273','2014-05-04','10:50:00',1.93),('16273','2014-05-04','10:55:00',2.2),('16273','2014-05-04','11:00:00',2.5),('16273','2014-05-04','11:05:00',3.7),('16273','2014-05-04','11:10:00',1.9),('16273','2014-05-04','11:15:00',3.93),('16273','2014-05-04','11:20:00',3.01),('16273','2014-05-04','11:25:00',4.29),('16273','2014-05-04','11:30:00',4.07),('16273','2014-05-04','11:35:00',4.07),('16273','2014-05-04','11:40:00',4.12),('16273','2014-05-04','11:45:00',2.24),('16273','2014-05-04','11:50:00',3.98),('16273','2014-05-04','11:55:00',1.85),('16273','2014-05-04','12:00:00',1.54),('16273','2014-05-04','12:05:00',2.01),('16273','2014-05-04','12:10:00',2.77),('16273','2014-05-04','12:15:00',4.61),('16273','2014-05-04','12:20:00',4.56),('16273','2014-05-04','12:25:00',4.67),('16273','2014-05-04','12:30:00',4.15),('16273','2014-05-04','12:35:00',2.22),('16273','2014-05-04','12:40:00',1.69),('16273','2014-05-04','12:45:00',1.15),('16273','2014-05-04','12:50:00',1.26),('16273','2014-05-04','12:55:00',1.54),('16273','2014-05-04','13:00:00',1.8),('16273','2014-05-04','13:05:00',1.35),('16273','2014-05-04','13:10:00',1.18),('16273','2014-05-04','13:15:00',1.05),('16273','2014-05-04','13:30:00',1.02),('16273','2014-05-04','13:35:00',1.16),('16273','2014-05-04','13:40:00',1.25),('16273','2014-05-04','13:45:00',1.31),('16273','2014-05-04','13:50:00',1.54),('16273','2014-05-04','13:55:00',1.59),('16273','2014-05-04','14:00:00',1.32),('16273','2014-05-04','14:05:00',1.08),('16273','2014-05-04','14:30:00',1.04),('16273','2014-05-04','14:35:00',1.09),('16273','2014-05-04','14:40:00',1.31),('16273','2014-05-04','14:45:00',1.56),('16273','2014-05-04','14:50:00',1.91),('16273','2014-05-04','14:55:00',3.92),('16273','2014-05-04','15:00:00',3.84),('16273','2014-05-04','15:05:00',4.14),('16273','2014-05-04','15:10:00',2.72),('16273','2014-05-04','15:15:00',3.08),('16273','2014-05-04','15:20:00',1.59),('16273','2014-05-04','15:25:00',1.28),('16273','2014-05-04','15:30:00',1.27),('16273','2014-05-04','15:35:00',1.24),('16273','2014-05-04','15:40:00',1.15),('16273','2014-05-04','15:50:00',1.07),('16273','2014-05-04','15:55:00',1.1),('16273','2014-04-16','07:40:00',1.12),('16273','2014-04-16','07:45:00',1.26),('16273','2014-04-16','07:50:00',1.14),('16273','2014-04-16','07:55:00',1.47),('16273','2014-04-16','08:00:00',1.56),('16273','2014-04-16','08:05:00',1.67),('16273','2014-04-16','08:10:00',1.76),('16273','2014-04-16','08:15:00',1.85),('16273','2014-04-16','08:20:00',1.95),('16273','2014-04-16','08:25:00',2.04),('16273','2014-04-16','08:30:00',2.04),('16273','2014-04-16','08:35:00',2),('16273','2014-04-16','08:40:00',2.08),('16273','2014-04-16','08:45:00',2.42),('16273','2014-04-16','08:50:00',2.49),('16273','2014-04-16','08:55:00',2.55),('16273','2014-04-16','09:00:00',2.62),('16273','2014-04-16','09:05:00',2.7),('16273','2014-04-16','09:10:00',2.76),('16273','2014-04-16','09:15:00',2.83),('16273','2014-04-16','09:20:00',2.89),('16273','2014-04-16','09:25:00',2.95),('16273','2014-04-16','09:30:00',3.02),('16273','2014-04-16','09:35:00',2.61),('16273','2014-04-16','09:40:00',2.58),('16273','2014-04-16','09:45:00',2.07),('16273','2014-04-16','09:50:00',1.45),('16273','2014-04-16','09:55:00',3.3),('16273','2014-04-16','10:00:00',3.43),('16273','2014-04-16','10:05:00',3.45),('16273','2014-04-16','10:10:00',3.48),('16273','2014-04-16','10:15:00',3.53),('16273','2014-04-16','10:20:00',3.59),('16273','2014-04-16','10:25:00',3.65),('16273','2014-04-16','10:30:00',3.6),('16273','2014-04-16','10:35:00',3.69),('16273','2014-04-16','10:40:00',3.74),('16273','2014-04-16','10:45:00',3.89),('16273','2014-04-16','10:50:00',4.09),('16273','2014-04-16','10:55:00',4.15),('16273','2014-04-16','11:00:00',3.72),('16273','2014-04-16','11:05:00',4.19),('16273','2014-04-16','11:10:00',3.77),('16273','2014-04-16','11:15:00',3.57),('16273','2014-04-16','11:20:00',3.85),('16273','2014-04-16','11:25:00',3.39),('16273','2014-04-16','11:30:00',4.9),('16273','2014-04-16','11:35:00',1.92),('16273','2014-04-16','11:40:00',1.72),('16273','2014-04-16','11:45:00',1.6),('16273','2014-04-16','11:50:00',1.76),('16273','2014-04-16','11:55:00',4.07),('16273','2014-04-16','12:00:00',4.33),('16273','2014-04-16','12:05:00',4.55),('16273','2014-04-16','12:10:00',3.98),('16273','2014-04-16','12:15:00',3.66),('16273','2014-04-16','12:20:00',2.71),('16273','2014-04-16','12:25:00',2.26),('16273','2014-04-16','12:30:00',4.75),('16273','2014-04-16','12:35:00',4.83),('16273','2014-04-16','12:40:00',4.62),('16273','2014-04-16','12:45:00',4.67),('16273','2014-04-16','12:50:00',4.62),('16273','2014-04-16','12:55:00',4.76),('16273','2014-04-16','13:00:00',4.69),('16273','2014-04-16','13:05:00',4.03),('16273','2014-04-16','13:10:00',2.57),('16273','2014-04-16','13:15:00',3.46),('16273','2014-04-16','13:20:00',1.9),('16273','2014-04-16','13:25:00',2.27),('16273','2014-04-16','13:30:00',3.46),('16273','2014-04-16','13:35:00',1.96),('16273','2014-04-16','13:40:00',3.09),('16273','2014-04-16','13:45:00',4.48),('16273','2014-04-16','13:50:00',4.36),('16273','2014-04-16','13:55:00',3.93),('16273','2014-04-16','14:00:00',1.72),('16273','2014-04-16','14:05:00',1.97),('16273','2014-04-16','14:10:00',2.59),('16273','2014-04-16','14:15:00',3.86),('16273','2014-04-16','14:20:00',2.71),('16273','2014-04-16','14:25:00',3.86),('16273','2014-04-16','14:30:00',1.36),('16273','2014-04-16','14:35:00',1.49),('16273','2014-04-16','14:40:00',2.61),('16273','2014-04-16','14:45:00',3.45),('16273','2014-04-16','14:50:00',3.04),('16273','2014-04-16','14:55:00',3.79),('16273','2014-04-16','15:00:00',3.73),('16273','2014-04-16','15:05:00',2.87),('16273','2014-04-16','15:10:00',1.28),('16273','2014-04-16','15:15:00',1.05),('16273','2014-04-16','15:35:00',1.11),('16273','2014-04-16','15:40:00',1.14),('16273','2014-04-16','15:45:00',1.27),('16273','2014-04-16','15:50:00',1.42),('16273','2014-04-16','15:55:00',2.2),('16273','2014-04-16','16:00:00',2.93),('16273','2014-04-16','16:05:00',2.66),('16273','2014-04-16','16:10:00',2.3),('16273','2014-04-16','16:15:00',2.41),('16273','2014-04-16','16:20:00',2.13),('16273','2014-04-16','16:30:00',2.24),('16273','2014-04-16','16:35:00',2.11),('16273','2014-04-16','16:40:00',1.95),('16273','2014-04-16','16:45:00',1.9),('16273','2014-04-16','16:50:00',1.82),('16273','2014-04-16','16:55:00',1.75),('16273','2014-04-16','17:00:00',1.67),('16273','2014-04-16','17:05:00',1.58),('16273','2014-04-16','17:10:00',1.13),('16273','2014-04-16','17:15:00',1.39),('16273','2014-04-16','17:20:00',1.32),('16273','2014-04-16','17:25:00',1.22),('16273','2014-04-16','17:30:00',1.14),('16273','2014-04-16','17:35:00',1.07),('16273','2014-04-16','17:40:00',1),('16273','2013-10-18','08:30:00',1.05),('16273','2013-10-18','08:35:00',1.21),('16273','2013-10-18','08:40:00',1.11),('16273','2013-10-18','08:45:00',1.46),('16273','2013-10-18','08:50:00',1.46),('16273','2013-10-18','08:55:00',1.61),('16273','2013-10-18','09:00:00',1.76),('16273','2013-10-18','09:05:00',1.86),('16273','2013-10-18','09:10:00',1.97),('16273','2013-10-18','09:15:00',2.02),('16273','2013-10-18','09:20:00',2.19),('16273','2013-10-18','09:25:00',2.23),('16273','2013-10-18','09:30:00',2.3),('16273','2013-10-18','09:35:00',2.39),('16273','2013-10-18','09:40:00',2.45),('16273','2013-10-18','09:45:00',2.51),('16273','2013-10-18','09:50:00',2.58),('16273','2013-10-18','09:55:00',2.63),('16273','2013-10-18','10:00:00',2.68),('16273','2013-10-18','10:05:00',2.74),('16273','2013-10-18','10:10:00',2.76),('16273','2013-10-18','10:15:00',2.78),('16273','2013-10-18','10:20:00',2.82),('16273','2013-10-18','10:25:00',2.91),('16273','2013-10-18','10:30:00',2.94),('16273','2013-10-18','10:35:00',2.95),('16273','2013-10-18','10:40:00',2.97),('16273','2013-10-18','10:45:00',2.94),('16273','2013-10-18','10:50:00',2.88),('16273','2013-10-18','10:55:00',3.02),('16273','2013-10-18','11:00:00',3.04),('16273','2013-10-18','11:05:00',3.03),('16273','2013-10-18','11:10:00',2.96),('16273','2013-10-18','11:15:00',3.14),('16273','2013-10-18','11:20:00',3.14),('16273','2013-10-18','11:25:00',3.1),('16273','2013-10-18','11:30:00',3.14),('16273','2013-10-18','11:35:00',3.2),('16273','2013-10-18','11:40:00',2.98),('16273','2013-10-18','11:45:00',2.94),('16273','2013-10-18','11:50:00',3.18),('16273','2013-10-18','11:55:00',3.18),('16273','2013-10-18','12:00:00',3.15),('16273','2013-10-18','12:05:00',3.16),('16273','2013-10-18','12:10:00',3.15),('16273','2013-10-18','12:15:00',3.07),('16273','2013-10-18','12:20:00',3.07),('16273','2013-10-18','12:25:00',3.09),('16273','2013-10-18','12:30:00',3.07),('16273','2013-10-18','12:35:00',3.05),('16273','2013-10-18','12:40:00',3.03),('16273','2013-10-18','12:45:00',2.98),('16273','2013-10-18','12:50:00',3.03),('16273','2013-10-18','12:55:00',3.06),('16273','2013-10-18','13:00:00',3.01),('16273','2013-10-18','13:05:00',2.95),('16273','2013-10-18','13:10:00',2.89),('16273','2013-10-18','13:15:00',2.97),('16273','2013-10-18','13:20:00',2.98),('16273','2013-10-18','13:25:00',2.95),('16273','2013-10-18','13:30:00',2.91),('16273','2013-10-18','13:35:00',2.92),('16273','2013-10-18','13:40:00',2.84),('16273','2013-10-18','13:45:00',2.81),('16273','2013-10-18','13:50:00',2.83),('16273','2013-10-18','13:55:00',2.61),('16273','2013-10-18','14:00:00',2.56),('16273','2013-10-18','14:05:00',2.61),('16273','2013-10-18','14:10:00',2.62),('16273','2013-10-18','14:15:00',2.61),('16273','2013-10-18','14:20:00',2.53),('16273','2013-10-18','14:25:00',2.54),('16273','2013-10-18','14:30:00',2.46),('16273','2013-10-18','14:35:00',2.43),('16273','2013-10-18','14:40:00',2.26),('16273','2013-10-18','14:45:00',2.26),('16273','2013-10-18','14:50:00',2.29),('16273','2013-10-18','14:55:00',2.09),('16273','2013-10-18','15:00:00',1.82),('16273','2013-10-18','15:05:00',2.04),('16273','2013-10-18','15:10:00',1.99),('16273','2013-10-18','15:15:00',2.02),('16273','2013-10-18','15:20:00',1.92),('16273','2013-10-18','15:25:00',1.76),('16273','2013-10-18','15:30:00',1.75),('16273','2013-10-18','15:35:00',1.62),('16273','2013-10-18','15:40:00',1.55),('16273','2013-10-18','15:45:00',1.4),('16273','2013-10-18','15:50:00',1.32),('16273','2013-10-18','15:55:00',1.4),('16273','2013-10-18','16:00:00',1.27),('16273','2013-10-18','16:05:00',1.25),('16273','2013-10-18','16:10:00',1.11),('16273','2013-10-18','16:15:00',1.09),('16273','2013-10-17','08:25:00',1.06),('16273','2013-10-17','08:30:00',1.18),('16273','2013-10-17','08:35:00',1.29),('16273','2013-10-17','08:40:00',1.21),('16273','2013-10-17','08:45:00',1.54),('16273','2013-10-17','08:50:00',1.66),('16273','2013-10-17','08:55:00',1.76),('16273','2013-10-17','09:00:00',1.85),('16273','2013-10-17','09:05:00',1.93),('16273','2013-10-17','09:10:00',2.01),('16273','2013-10-17','09:15:00',2.09),('16273','2013-10-17','09:20:00',2.17),('16273','2013-10-17','09:25:00',2.24),('16273','2013-10-17','09:30:00',2.29),('16273','2013-10-17','09:35:00',2.38),('16273','2013-10-17','09:40:00',2.44),('16273','2013-10-17','09:45:00',2.49),('16273','2013-10-17','09:50:00',2.55),('16273','2013-10-17','09:55:00',2.6),('16273','2013-10-17','10:00:00',2.65),('16273','2013-10-17','10:05:00',2.73),('16273','2013-10-17','10:10:00',2.79),('16273','2013-10-17','10:15:00',2.82),('16273','2013-10-17','10:20:00',2.87),('16273','2013-10-17','10:25:00',2.92),('16273','2013-10-17','10:30:00',2.95),('16273','2013-10-17','10:35:00',2.99),('16273','2013-10-17','10:40:00',3.03),('16273','2013-10-17','10:45:00',3.05),('16273','2013-10-17','10:50:00',3.1),('16273','2013-10-17','10:55:00',3.13),('16273','2013-10-17','11:00:00',3.16),('16273','2013-10-17','11:05:00',3.18),('16273','2013-10-17','11:10:00',3.2),('16273','2013-10-17','11:15:00',3.21),('16273','2013-10-17','11:20:00',3.23),('16273','2013-10-17','11:25:00',3.26),('16273','2013-10-17','11:30:00',3.26),('16273','2013-10-17','11:35:00',3.27),('16273','2013-10-17','11:40:00',3.28),('16273','2013-10-17','11:45:00',3.28),('16273','2013-10-17','11:50:00',3.27),('16273','2013-10-17','11:55:00',3.25),('16273','2013-10-17','12:00:00',3.26),('16273','2013-10-17','12:05:00',3.25),('16273','2013-10-17','12:10:00',3.26),('16273','2013-10-17','12:15:00',3.27),('16273','2013-10-17','12:20:00',3.25),('16273','2013-10-17','12:25:00',3.24),('16273','2013-10-17','12:30:00',3.24),('16273','2013-10-17','12:35:00',3.26),('16273','2013-10-17','12:40:00',3.24),('16273','2013-10-17','12:45:00',3.21),('16273','2013-10-17','12:50:00',3.19),('16273','2013-10-17','12:55:00',3.18),('16273','2013-10-17','13:00:00',3.17),('16273','2013-10-17','13:05:00',3.15),('16273','2013-10-17','13:10:00',3.13),('16273','2013-10-17','13:15:00',3.11),('16273','2013-10-17','13:20:00',3.1),('16273','2013-10-17','13:25:00',3.04),('16273','2013-10-17','13:30:00',3.03),('16273','2013-10-17','13:35:00',3),('16273','2013-10-17','13:40:00',2.97),('16273','2013-10-17','13:45:00',2.93),('16273','2013-10-17','13:50:00',2.91),('16273','2013-10-17','13:55:00',2.89),('16273','2013-10-17','14:00:00',2.83),('16273','2013-10-17','14:05:00',2.79),('16273','2013-10-17','14:10:00',2.74),('16273','2013-10-17','14:15:00',2.7),('16273','2013-10-17','14:20:00',2.67),('16273','2013-10-17','14:25:00',2.62),('16273','2013-10-17','14:30:00',2.57),('16273','2013-10-17','14:35:00',2.53),('16273','2013-10-17','14:40:00',2.48),('16273','2013-10-17','14:45:00',2.42),('16273','2013-10-17','14:50:00',2.38),('16273','2013-10-17','14:55:00',2.33),('16273','2013-10-17','15:00:00',2.28),('16273','2013-10-17','15:05:00',2.21),('16273','2013-10-17','15:10:00',2.15),('16273','2013-10-17','15:15:00',2.08),('16273','2013-10-17','15:20:00',1.99),('16273','2013-10-17','15:25:00',1.95),('16273','2013-10-17','15:30:00',1.88),('16273','2013-10-17','15:35:00',1.78),('16273','2013-10-17','15:40:00',1.72),('16273','2013-10-17','15:45:00',1.67),('16273','2013-10-17','15:50:00',1.58),('16273','2013-10-17','15:55:00',1.52),('16273','2013-10-17','16:00:00',1.46),('16273','2013-10-17','16:05:00',1.39),('16273','2013-10-17','16:10:00',1.33),('16273','2013-10-17','16:15:00',1.26),('16273','2013-10-17','16:20:00',1.19),('16273','2013-10-17','16:25:00',1.12),('16273','2013-10-17','16:30:00',1.06),('16273','2013-10-17','16:35:00',1),('16273','2013-10-16','09:40:00',1.36),('16273','2013-10-16','09:45:00',1.28),('16273','2013-10-16','09:55:00',1.17),('16273','2013-10-16','11:00:00',1.29),('16273','2013-10-16','11:05:00',1.08),('16273','2013-10-16','11:10:00',1.03),('16273','2013-10-16','11:45:00',1.28),('16273','2013-10-16','11:50:00',1.01),('16273','2013-10-16','12:00:00',1.26),('16273','2013-10-16','12:05:00',2.92),('16273','2013-10-16','12:10:00',1.15),('16273','2013-10-16','12:20:00',1.03),('16273','2013-10-16','12:25:00',1.34),('16273','2013-10-16','12:30:00',2.48),('16273','2013-10-16','12:35:00',1.03),('16273','2013-10-16','12:45:00',1.42),('16273','2013-10-16','12:50:00',1.09),('16273','2013-10-16','12:55:00',1.1),('16273','2013-10-16','13:00:00',1.07),('16273','2013-10-16','13:20:00',1.09),('16273','2013-10-16','13:25:00',1.52),('16273','2013-10-16','13:30:00',2.83),('16273','2013-10-16','13:35:00',2.76),('16273','2013-10-16','13:40:00',3.04),('16273','2013-10-16','13:45:00',1.81),('16273','2013-10-16','13:50:00',3.37),('16273','2013-10-16','13:55:00',1.27),('16273','2013-10-16','14:00:00',2.06),('16273','2013-10-16','14:05:00',2.67),('16273','2013-10-16','14:10:00',2.2),('16273','2013-10-16','14:15:00',2.67),('16273','2013-10-16','14:20:00',2.09),('16273','2013-10-16','14:25:00',2.07),('16273','2013-10-16','14:30:00',2.82),('16273','2013-10-16','14:35:00',2.16),('16273','2013-10-16','14:40:00',2.21),('16273','2013-10-16','14:45:00',2.47),('16273','2013-10-16','14:50:00',2.32),('16273','2013-10-16','14:55:00',2.34),('16273','2013-10-16','15:00:00',2.34),('16273','2013-10-16','15:05:00',2.09),('16273','2013-10-16','15:10:00',1.04),('16273','2013-10-16','15:15:00',1.19),('16273','2013-10-16','15:20:00',1.27),('16273','2013-10-16','15:25:00',2.04),('16273','2013-10-16','15:30:00',1.81),('16273','2013-10-16','15:35:00',1.82),('16273','2013-10-16','15:40:00',1.74),('16273','2013-10-16','15:45:00',1.67),('16273','2013-10-16','15:50:00',1.59),('16273','2013-10-16','15:55:00',1.48),('16273','2013-10-16','16:00:00',1.41),('16273','2013-10-16','16:05:00',1.34),('16273','2013-10-16','16:10:00',1.26),('16273','2013-10-16','16:15:00',1.25),('16273','2013-10-16','16:20:00',1.18),('16273','2013-10-16','16:25:00',1.13),('16273','2013-10-16','16:30:00',1.07),('16273','2013-10-16','16:35:00',1.01),('16273','2013-10-15','09:15:00',1.02),('16273','2013-10-15','09:20:00',1.14),('16273','2013-10-15','09:25:00',1.41),('16273','2013-10-15','09:30:00',1.15),('16273','2013-10-15','09:35:00',1.53),('16273','2013-10-15','09:40:00',2.1),('16273','2013-10-15','09:45:00',2.49),('16273','2013-10-15','09:50:00',2.55),('16273','2013-10-15','09:55:00',2.37),('16273','2013-10-15','10:00:00',2.59),('16273','2013-10-15','10:05:00',2.13),('16273','2013-10-15','10:10:00',1.27),('16273','2013-10-15','10:15:00',1.23),('16273','2013-10-15','10:20:00',1.87),('16273','2013-10-15','10:25:00',2.02),('16273','2013-10-15','10:30:00',1.86),('16273','2013-10-15','10:35:00',2.18),('16273','2013-10-15','10:40:00',2.55),('16273','2013-10-15','10:45:00',2.04),('16273','2013-10-15','10:50:00',1.75),('16273','2013-10-15','10:55:00',1.76),('16273','2013-10-15','11:00:00',2.01),('16273','2013-10-15','11:05:00',2.73),('16273','2013-10-15','11:10:00',2.78),('16273','2013-10-15','11:15:00',2.82),('16273','2013-10-15','11:20:00',2.53),('16273','2013-10-15','11:25:00',2.68),('16273','2013-10-15','11:30:00',2.2),('16273','2013-10-15','11:35:00',1.65),('16273','2013-10-15','11:40:00',1.48),('16273','2013-10-15','11:45:00',1.48),('16273','2013-10-15','11:50:00',1.43),('16273','2013-10-15','11:55:00',1.41),('16273','2013-10-15','12:00:00',1.37),('16273','2013-10-15','12:05:00',1.39),('16273','2013-10-15','12:10:00',1.38),('16273','2013-10-15','12:15:00',1.48),('16273','2013-10-15','12:20:00',1.32),('16273','2013-10-15','12:25:00',1.24),('16273','2013-10-15','12:30:00',1.26),('16273','2013-10-15','12:35:00',1.31),('16273','2013-10-15','12:40:00',1.39),('16273','2013-10-15','12:45:00',1.31),('16273','2013-10-15','12:50:00',1.19),('16273','2013-10-15','12:55:00',1.19),('16273','2013-10-15','13:00:00',1.65),('16273','2013-10-15','13:05:00',1.71),('16273','2013-10-15','13:10:00',1.88),('16273','2013-10-15','13:15:00',2.71),('16273','2013-10-15','13:20:00',2.76),('16273','2013-10-15','13:25:00',1.72),('16273','2013-10-15','13:30:00',1.56),('16273','2013-10-15','13:35:00',1.56),('16273','2013-10-15','13:40:00',1.56),('16273','2013-10-15','13:45:00',1.43),('16273','2013-10-15','13:50:00',1.23),('16273','2013-10-15','13:55:00',1.09),('16273','2013-10-15','14:00:00',1.09),('16273','2013-10-15','14:05:00',1.22),('16273','2013-10-15','14:10:00',1.67),('16273','2013-10-15','14:15:00',1.82),('16273','2013-10-15','14:20:00',2.22),('16273','2013-10-15','14:25:00',1.85),('16273','2013-10-15','14:30:00',1.43),('16273','2013-10-15','14:35:00',1.79),('16273','2013-10-15','14:40:00',2.37),('16273','2013-10-15','14:45:00',2.35),('16273','2013-10-15','14:50:00',1.68),('16273','2013-10-15','14:55:00',1.16),('16273','2013-10-15','15:00:00',1.27),('16273','2013-10-15','15:05:00',1.3),('16273','2013-10-15','15:10:00',1.14),('16273','2013-10-15','15:15:00',1.02),('16273','2013-10-15','16:25:00',1.01),('16273','2013-10-15','16:30:00',1.02),('16273','2013-10-14','08:30:00',1.09),('16273','2013-10-14','08:35:00',1.14),('16273','2013-10-14','08:40:00',1.11),('16273','2013-10-14','08:45:00',1.26),('16273','2013-10-14','08:50:00',1.41),('16273','2013-10-14','08:55:00',1.36),('16273','2013-10-14','09:00:00',1.22),('16273','2013-10-14','09:05:00',1.08),('16273','2013-10-14','09:15:00',1.52),('16273','2013-10-14','09:20:00',1.86),('16273','2013-10-14','09:25:00',2.06),('16273','2013-10-14','09:30:00',2.05),('16273','2013-10-14','09:35:00',1.8),('16273','2013-10-14','09:40:00',1.9),('16273','2013-10-14','09:45:00',2.32),('16273','2013-10-14','09:50:00',2.23),('16273','2013-10-14','09:55:00',2.27),('16273','2013-10-14','10:00:00',2.53),('16273','2013-10-14','10:05:00',2.57),('16273','2013-10-14','10:10:00',2.6),('16273','2013-10-14','10:15:00',2.66),('16273','2013-10-14','10:20:00',2.7),('16273','2013-10-14','10:25:00',2.74),('16273','2013-10-14','10:30:00',2.76),('16273','2013-10-14','10:35:00',2.69),('16273','2013-10-14','10:40:00',2.71),('16273','2013-10-14','10:45:00',2.87),('16273','2013-10-14','10:50:00',2.88),('16273','2013-10-14','10:55:00',2.92),('16273','2013-10-14','11:00:00',2.86),('16273','2013-10-14','11:05:00',2.93),('16273','2013-10-14','11:10:00',2.98),('16273','2013-10-14','11:15:00',2.95),('16273','2013-10-14','11:20:00',3.05),('16273','2013-10-14','11:25:00',3.09),('16273','2013-10-14','11:30:00',3.03),('16273','2013-10-14','11:35:00',3.03),('16273','2013-10-14','11:40:00',3),('16273','2013-10-14','11:45:00',3.06),('16273','2013-10-14','11:50:00',3.06),('16273','2013-10-14','11:55:00',3.09),('16273','2013-10-14','12:00:00',3.08),('16273','2013-10-14','12:05:00',3.14),('16273','2013-10-14','12:10:00',3.07),('16273','2013-10-14','12:15:00',2.87),('16273','2013-10-14','12:20:00',3.03),('16273','2013-10-14','12:25:00',3.15),('16273','2013-10-14','12:30:00',3.12),('16273','2013-10-14','12:35:00',3.09),('16273','2013-10-14','12:40:00',3.1),('16273','2013-10-14','12:45:00',3.04),('16273','2013-10-14','12:50:00',3.06),('16273','2013-10-14','12:55:00',3.03),('16273','2013-10-14','13:00:00',3.02),('16273','2013-10-14','13:05:00',2.99),('16273','2013-10-14','13:10:00',2.97),('16273','2013-10-14','13:15:00',2.96),('16273','2013-10-14','13:20:00',2.92),('16273','2013-10-14','13:25:00',2.9),('16273','2013-10-14','13:30:00',2.87),('16273','2013-10-14','13:35:00',2.85),('16273','2013-10-14','13:40:00',2.81),('16273','2013-10-14','13:45:00',2.78),('16273','2013-10-14','13:50:00',2.74),('16273','2013-10-14','13:55:00',2.7),('16273','2013-10-14','14:00:00',2.66),('16273','2013-10-14','14:05:00',2.62),('16273','2013-10-14','14:10:00',2.57),('16273','2013-10-14','14:15:00',2.52),('16273','2013-10-14','14:20:00',2.48),('16273','2013-10-14','14:25:00',2.45),('16273','2013-10-14','14:30:00',2.39),('16273','2013-10-14','14:35:00',2.32),('16273','2013-10-14','14:40:00',2.29),('16273','2013-10-14','14:45:00',2.26),('16273','2013-10-14','14:50:00',2.22),('16273','2013-10-14','14:55:00',2.16),('16273','2013-10-14','15:00:00',2.1),('16273','2013-10-14','15:05:00',2.04),('16273','2013-10-14','15:10:00',1.98),('16273','2013-10-14','15:15:00',1.93),('16273','2013-10-14','15:20:00',1.87),('16273','2013-10-14','15:25:00',1.81),('16273','2013-10-14','15:30:00',1.75),('16273','2013-10-14','15:35:00',1.67),('16273','2013-10-14','15:40:00',1.49),('16273','2013-10-14','16:10:00',1.3),('16273','2013-10-14','16:20:00',1.03),('16273','2013-10-14','16:40:00',1.03),('16273','2013-10-13','08:50:00',1.19),('16273','2013-10-13','08:55:00',1.33),('16273','2013-10-13','09:00:00',1.34),('16273','2013-10-13','09:05:00',1.27),('16273','2013-10-13','09:10:00',1.89),('16273','2013-10-13','09:15:00',2.1),('16273','2013-10-13','09:20:00',1.96),('16273','2013-10-13','09:25:00',1.3),('16273','2013-10-13','09:30:00',1.47),('16273','2013-10-13','09:35:00',1.89),('16273','2013-10-13','09:40:00',2.67),('16273','2013-10-13','09:45:00',2.19),('16273','2013-10-13','09:50:00',2.45),('16273','2013-10-13','09:55:00',1.6),('16273','2013-10-13','10:00:00',1.64),('16273','2013-10-13','10:05:00',2.73),('16273','2013-10-13','10:10:00',1.99),('16273','2013-10-13','10:15:00',1.76),('16273','2013-10-13','10:20:00',1.78),('16273','2013-10-13','10:25:00',2.4),('16273','2013-10-13','10:30:00',3.3),('16273','2013-10-13','10:35:00',3.36),('16273','2013-10-13','10:40:00',3.17),('16273','2013-10-13','10:45:00',3),('16273','2013-10-13','10:50:00',3.16),('16273','2013-10-13','10:55:00',3),('16273','2013-10-13','11:00:00',2.64),('16273','2013-10-13','11:05:00',3.08),('16273','2013-10-13','11:10:00',2.67),('16273','2013-10-13','11:15:00',3.18),('16273','2013-10-13','11:20:00',3.03),('16273','2013-10-13','11:25:00',3.21),('16273','2013-10-13','11:30:00',3.12),('16273','2013-10-13','11:35:00',3.09),('16273','2013-10-13','11:40:00',2.98),('16273','2013-10-13','11:45:00',3.11),('16273','2013-10-13','11:50:00',3.11),('16273','2013-10-13','11:55:00',3.13),('16273','2013-10-13','12:00:00',3.14),('16273','2013-10-13','12:05:00',3.14),('16273','2013-10-13','12:10:00',3.12),('16273','2013-10-13','12:15:00',3.14),('16273','2013-10-13','12:20:00',3.07),('16273','2013-10-13','12:25:00',3.07),('16273','2013-10-13','12:30:00',3.14),('16273','2013-10-13','12:35:00',3.12),('16273','2013-10-13','12:40:00',3.08),('16273','2013-10-13','12:45:00',3.05),('16273','2013-10-13','12:50:00',3.04),('16273','2013-10-13','12:55:00',3.01),('16273','2013-10-13','13:00:00',2.98),('16273','2013-10-13','13:05:00',3.02),('16273','2013-10-13','13:10:00',3.06),('16273','2013-10-13','13:15:00',3.03),('16273','2013-10-13','13:20:00',2.99),('16273','2013-10-13','13:25:00',2.74),('16273','2013-10-13','13:30:00',2.82),('16273','2013-10-13','13:35:00',2.73),('16273','2013-10-13','13:40:00',3.01),('16273','2013-10-13','13:45:00',2.86),('16273','2013-10-13','13:50:00',2.81),('16273','2013-10-13','13:55:00',1.78),('16273','2013-10-13','14:00:00',2.98),('16273','2013-10-13','14:05:00',2.76),('16273','2013-10-13','14:10:00',2.68),('16273','2013-10-13','14:15:00',2.93),('16273','2013-10-13','14:20:00',2.78),('16273','2013-10-13','14:25:00',2.6),('16273','2013-10-13','14:30:00',2),('16273','2013-10-13','14:35:00',2.33),('16273','2013-10-13','14:40:00',2.19),('16273','2013-10-13','14:45:00',2.02),('16273','2013-10-13','14:50:00',1.96),('16273','2013-10-13','14:55:00',1.97),('16273','2013-10-13','15:00:00',2.41),('16273','2013-10-13','15:05:00',1.97),('16273','2013-10-13','15:10:00',1.88),('16273','2013-10-13','15:15:00',1.84),('16273','2013-10-13','15:20:00',1.8),('16273','2013-10-13','15:25:00',1.58),('16273','2013-10-13','15:30:00',1.6),('16273','2013-10-13','15:35:00',1.36),('16273','2013-10-13','15:40:00',1.23),('16273','2013-10-13','15:45:00',1.24),('16273','2013-10-13','15:50:00',1.43),('16273','2013-10-13','15:55:00',1.49),('16273','2013-10-13','16:00:00',1.29),('16273','2013-10-13','16:05:00',1.34),('16273','2013-10-13','16:10:00',1.36),('16273','2013-10-13','16:15:00',1.54),('16273','2013-10-13','16:20:00',1.16),('16273','2013-10-13','16:25:00',1.2),('16273','2013-10-13','16:30:00',1.15),('16273','2013-10-13','16:35:00',1.05),('16273','2013-10-12','11:15:00',1),('16273','2013-10-12','11:20:00',1.16),('16273','2013-10-12','11:25:00',1.28),('16273','2013-10-12','11:30:00',2.07),('16273','2013-10-12','11:35:00',1.73),('16273','2013-10-12','11:40:00',1.47),('16273','2013-10-12','11:45:00',1.24),('16273','2013-10-12','12:10:00',1.1),('16273','2013-10-12','12:15:00',1.96),('16273','2013-10-12','12:20:00',2.93),('16273','2013-10-12','12:25:00',2.11),('16273','2013-10-12','12:30:00',2.31),('16273','2013-10-12','12:35:00',3.51),('16273','2013-10-12','12:40:00',3.12),('16273','2013-10-12','12:45:00',3),('16273','2013-10-12','12:50:00',2.6),('16273','2013-10-12','12:55:00',2.33),('16273','2013-10-12','13:00:00',1.43),('16273','2013-10-12','13:15:00',1.11),('16273','2013-10-12','13:20:00',1.41),('16273','2013-10-12','13:25:00',2.35),('16273','2013-10-12','16:10:00',1.03),('16273','2013-10-12','16:15:00',1.46),('16273','2013-10-12','16:20:00',1.29),('16273','2013-10-12','16:25:00',1.21),('16273','2013-10-11','08:25:00',1.13),('16273','2013-10-11','08:30:00',1.25),('16273','2013-10-11','08:35:00',1.44),('16273','2013-10-11','08:40:00',1.18),('16273','2013-10-11','08:45:00',1.63),('16273','2013-10-11','08:50:00',1.74),('16273','2013-10-11','08:55:00',1.77),('16273','2013-10-11','09:00:00',1.83),('16273','2013-10-11','09:05:00',1.91),('16273','2013-10-11','09:10:00',2.01),('16273','2013-10-11','09:15:00',2.1),('16273','2013-10-11','09:20:00',2.23),('16273','2013-10-11','09:25:00',2.3),('16273','2013-10-11','09:30:00',2.34),('16273','2013-10-11','09:35:00',2.41),('16273','2013-10-11','09:40:00',2.47),('16273','2013-10-11','09:45:00',2.52),('16273','2013-10-11','09:50:00',2.59),('16273','2013-10-11','09:55:00',2.65),('16273','2013-10-11','10:00:00',2.4),('16273','2013-10-11','10:05:00',2.24),('16273','2013-10-11','10:10:00',1.76),('16273','2013-10-11','10:15:00',2.28),('16273','2013-10-11','10:20:00',3.03),('16273','2013-10-11','10:25:00',2.67),('16273','2013-10-11','10:30:00',1.76),('16273','2013-10-11','10:35:00',1.5),('16273','2013-10-11','10:40:00',1.51),('16273','2013-10-11','10:45:00',2.72),('16273','2013-10-11','10:50:00',1.86),('16273','2013-10-11','10:55:00',2.86),('16273','2013-10-11','11:00:00',3.5),('16273','2013-10-11','11:05:00',1.3),('16273','2013-10-11','11:10:00',1.43),('16273','2013-10-11','11:15:00',1.25),('16273','2013-10-11','11:20:00',1.11),('16273','2013-10-11','11:25:00',1.12),('16273','2013-10-11','11:30:00',1.08),('16273','2013-10-11','11:40:00',2.11),('16273','2013-10-11','12:05:00',2.52),('16273','2013-10-11','12:10:00',3.55),('16273','2013-10-11','12:15:00',3.84),('16273','2013-10-11','12:20:00',2.33),('16273','2013-10-11','12:25:00',1.28),('16273','2013-10-11','12:50:00',1.61),('16273','2013-10-11','12:55:00',2.46),('16273','2013-10-11','13:00:00',1.55),('16273','2013-10-11','13:45:00',1.58),('16273','2013-10-11','13:50:00',1),('16273','2013-10-11','15:40:00',1.07),('16273','2013-10-11','16:30:00',1.22),('16273','2013-10-10','08:20:00',1.07),('16273','2013-10-10','08:25:00',1.2),('16273','2013-10-10','08:30:00',1.32),('16273','2013-10-10','08:35:00',1.26),('16273','2013-10-10','08:40:00',1.62),('16273','2013-10-10','08:45:00',1.67),('16273','2013-10-10','08:50:00',1.84),('16273','2013-10-10','08:55:00',1.88),('16273','2013-10-10','09:00:00',1.88),('16273','2013-10-10','09:05:00',2.01),('16273','2013-10-10','09:10:00',2.07),('16273','2013-10-10','09:15:00',2.13),('16273','2013-10-10','09:20:00',2.22),('16273','2013-10-10','09:25:00',2.26),('16273','2013-10-10','09:30:00',2.25),('16273','2013-10-10','09:35:00',2.29),('16273','2013-10-10','09:40:00',2.47),('16273','2013-10-10','09:45:00',2.48),('16273','2013-10-10','09:50:00',2.56),('16273','2013-10-10','09:55:00',1.79),('16273','2013-10-10','10:00:00',2.22),('16273','2013-10-10','10:05:00',2.8),('16273','2013-10-10','10:10:00',2.57),('16273','2013-10-10','10:15:00',1.08),('16273','2013-10-10','10:20:00',2.27),('16273','2013-10-10','10:25:00',2.21),('16273','2013-10-10','10:30:00',1.46),('16273','2013-10-10','10:35:00',1.37),('16273','2013-10-10','10:40:00',3.32),('16273','2013-10-10','10:45:00',1.65),('16273','2013-10-10','11:00:00',1.39),('16273','2013-10-10','11:10:00',1.3),('16273','2013-10-10','11:15:00',1.22),('16273','2013-10-10','11:20:00',3.04),('16273','2013-10-10','11:25:00',3.95),('16273','2013-10-10','11:30:00',3.02),('16273','2013-10-10','11:35:00',3.96),('16273','2013-10-10','11:40:00',3.96),('16273','2013-10-10','11:45:00',3.81),('16273','2013-10-10','11:50:00',4.09),('16273','2013-10-10','11:55:00',3.93),('16273','2013-10-10','12:00:00',3.76),('16273','2013-10-10','12:05:00',3.57),('16273','2013-10-10','12:10:00',2.77),('16273','2013-10-10','12:15:00',3.03),('16273','2013-10-10','12:20:00',2.41),('16273','2013-10-10','12:25:00',3.96),('16273','2013-10-10','12:30:00',3.95),('16273','2013-10-10','12:35:00',3.73),('16273','2013-10-10','12:40:00',3.6),('16273','2013-10-10','12:45:00',3.64),('16273','2013-10-10','12:50:00',3.6),('16273','2013-10-10','12:55:00',3.59),('16273','2013-10-10','13:00:00',3.47),('16273','2013-10-10','13:05:00',3.5),('16273','2013-10-10','13:10:00',3.33),('16273','2013-10-10','13:15:00',3.39),('16273','2013-10-10','13:20:00',3.47),('16273','2013-10-10','13:25:00',3.39),('16273','2013-10-10','13:30:00',2.96),('16273','2013-10-10','13:35:00',1.82),('16273','2013-10-10','13:40:00',2.35),('16273','2013-10-10','13:45:00',2.82),('16273','2013-10-10','13:50:00',1.63),('16273','2013-10-10','13:55:00',2.01),('16273','2013-10-10','14:00:00',3.44),('16273','2013-10-10','14:05:00',2.08),('16273','2013-10-10','14:10:00',1.71),('16273','2013-10-10','14:15:00',2.5),('16273','2013-10-10','14:20:00',2.43),('16273','2013-10-10','14:25:00',2.06),('16273','2013-10-10','14:30:00',1.22),('16273','2013-10-10','14:35:00',2.48),('16273','2013-10-10','14:40:00',1.75),('16273','2013-10-10','14:45:00',1.44),('16273','2013-10-10','14:50:00',1.29),('16273','2013-10-10','14:55:00',2.41),('16273','2013-10-10','15:00:00',1.83),('16273','2013-10-10','15:05:00',1.46),('16273','2013-10-10','15:10:00',1.59),('16273','2013-10-10','15:15:00',1.75),('16273','2013-10-10','15:20:00',2.04),('16273','2013-10-10','15:25:00',1.5),('16273','2013-10-10','15:30:00',1.2),('16273','2013-10-10','15:40:00',1.1),('16273','2013-10-10','15:45:00',1.06),('16273','2013-10-10','15:50:00',1.92),('16273','2013-10-10','15:55:00',1.6),('16273','2013-10-10','16:05:00',1.1),('16273','2013-10-10','16:10:00',1.32),('16273','2013-10-10','16:15:00',1.54),('16273','2013-10-10','16:20:00',1.39),('16273','2013-10-10','16:25:00',1.27),('16273','2013-10-10','16:30:00',1.11),('16273','2013-10-10','16:40:00',1.2),('16273','2013-10-10','16:45:00',1.05),('16273','2013-10-10','16:50:00',1.04),('16273','2013-10-09','08:30:00',1.38),('16273','2013-10-09','08:35:00',1.18),('16273','2013-10-09','08:40:00',1.58),('16273','2013-10-09','08:45:00',1.69),('16273','2013-10-09','08:50:00',1.79),('16273','2013-10-09','08:55:00',1.88),('16273','2013-10-09','09:00:00',1.96),('16273','2013-10-09','09:05:00',2.09),('16273','2013-10-09','09:10:00',2.12),('16273','2013-10-09','09:15:00',2.02),('16273','2013-10-09','09:20:00',2.4),('16273','2013-10-09','09:25:00',2.68),('16273','2013-10-09','09:30:00',2.92),('16273','2013-10-09','09:35:00',3.01),('16273','2013-10-09','09:40:00',3.05),('16273','2013-10-09','09:45:00',2.92),('16273','2013-10-09','09:50:00',3.07),('16273','2013-10-09','09:55:00',2.82),('16273','2013-10-09','10:00:00',1.4),('16273','2013-10-09','10:15:00',1.07),('16273','2013-10-09','10:20:00',1.91),('16273','2013-10-09','10:25:00',1.76),('16273','2013-10-09','10:35:00',3.21),('16273','2013-10-09','10:40:00',2.57),('16273','2013-10-09','10:50:00',1.35),('16273','2013-10-09','10:55:00',1.93),('16273','2013-10-09','11:00:00',1.53),('16273','2013-10-09','11:05:00',3.1),('16273','2013-10-09','11:10:00',2.11),('16273','2013-10-09','11:15:00',1.49),('16273','2013-10-09','11:25:00',1.02),('16273','2013-10-09','11:30:00',2.99),('16273','2013-10-09','11:35:00',1.48),('16273','2013-10-09','11:40:00',1.2),('16273','2013-10-09','11:45:00',1.24),('16273','2013-10-09','11:50:00',2.65),('16273','2013-10-09','11:55:00',3.7),('16273','2013-10-09','12:00:00',3.32),('16273','2013-10-09','12:05:00',1.26),('16273','2013-10-09','12:25:00',1.9),('16273','2013-10-09','12:30:00',1.82),('16273','2013-10-09','12:35:00',1.69),('16273','2013-10-09','12:40:00',1.32),('16273','2013-10-09','12:45:00',1.15),('16273','2013-10-09','12:50:00',1.26),('16273','2013-10-09','12:55:00',1.62),('16273','2013-10-09','13:00:00',1.9),('16273','2013-10-09','13:05:00',1.89),('16273','2013-10-09','13:10:00',2.14),('16273','2013-10-09','13:15:00',3.2),('16273','2013-10-09','13:20:00',1.88),('16273','2013-10-09','13:25:00',2.16),('16273','2013-10-09','13:30:00',2.14),('16273','2013-10-09','13:40:00',3.37),('16273','2013-10-09','13:45:00',3.45),('16273','2013-10-09','13:50:00',3.25),('16273','2013-10-09','13:55:00',3.36),('16273','2013-10-09','14:00:00',2.17),('16273','2013-10-09','14:05:00',3.17),('16273','2013-10-09','14:10:00',1.28),('16273','2013-10-09','14:15:00',1.36),('16273','2013-10-09','14:20:00',1.13),('16273','2013-10-09','14:25:00',1.28),('16273','2013-10-09','14:30:00',2.3),('16273','2013-10-09','14:35:00',3.24),('16273','2013-10-09','14:40:00',2.34),('16273','2013-10-09','14:45:00',2.25),('16273','2013-10-09','14:50:00',1.82),('16273','2013-10-09','14:55:00',3.05),('16273','2013-10-09','15:00:00',2.62),('16273','2013-10-09','15:05:00',2.38),('16273','2013-10-09','15:10:00',2.12),('16273','2013-10-09','15:15:00',1.36),('16273','2013-10-09','15:30:00',1.09),('16273','2013-10-09','15:40:00',1.33),('16273','2013-10-09','15:45:00',1.11),('16273','2013-10-09','16:05:00',1.19),('16273','2013-10-09','16:10:00',1.1),('16273','2013-10-09','16:20:00',1.41),('16273','2013-10-09','16:25:00',1.43),('16273','2013-10-09','16:50:00',1.08),('16273','2014-04-15','07:50:00',1.03),('16273','2014-04-15','08:50:00',1.89),('16273','2014-04-15','08:55:00',2.39),('16273','2014-04-15','09:00:00',2.13),('16273','2014-04-15','09:05:00',2.57),('16273','2014-04-15','09:10:00',3.04),('16273','2014-04-15','09:15:00',2.79),('16273','2014-04-15','09:20:00',2.15),('16273','2014-04-15','09:25:00',1.79),('16273','2014-04-15','09:55:00',2.38),('16273','2014-04-15','10:00:00',1.57),('16273','2014-04-15','10:10:00',1.89),('16273','2014-04-15','10:15:00',2.01),('16273','2014-04-15','10:20:00',2.22),('16273','2014-04-15','10:25:00',1.34),('16273','2014-04-15','10:30:00',1.61),('16273','2014-04-15','10:35:00',1.86),('16273','2014-04-15','10:40:00',1.75),('16273','2014-04-15','10:45:00',3.99),('16273','2014-04-15','10:50:00',2.38),('16273','2014-04-15','10:55:00',2.24),('16273','2014-04-15','11:00:00',3.8),('16273','2014-04-15','11:05:00',1.83),('16273','2014-04-15','11:20:00',1.12),('16273','2014-04-15','11:25:00',1.18),('16273','2014-04-15','11:35:00',1.08),('16273','2014-04-15','11:40:00',1.52),('16273','2014-04-15','11:45:00',1.15),('16273','2014-04-15','12:05:00',1.79),('16273','2014-04-15','12:10:00',2.11),('16273','2014-04-15','12:15:00',1.76),('16273','2014-04-15','12:55:00',1.11),('16273','2014-04-15','13:00:00',1.05),('16273','2014-04-15','13:05:00',1.17),('16273','2014-04-15','13:10:00',1.75),('16273','2014-04-15','13:15:00',1.14),('16273','2014-04-15','13:20:00',1.4),('16273','2014-04-15','13:25:00',1.62),('16273','2014-04-15','13:30:00',2.45),('16273','2014-04-15','13:35:00',1.53),('16273','2014-04-15','13:40:00',3.2),('16273','2014-04-15','13:45:00',2.62),('16273','2014-04-15','13:50:00',1.87),('16273','2014-04-15','13:55:00',2.73),('16273','2014-04-15','14:00:00',2.23),('16273','2014-04-15','14:05:00',1.93),('16273','2014-04-15','14:10:00',2.25),('16273','2014-04-15','14:15:00',3.99),('16273','2014-04-15','14:20:00',2.7),('16273','2014-04-15','14:25:00',2.7),('16273','2014-04-15','14:30:00',2.15),('16273','2014-04-15','14:35:00',1.74),('16273','2014-04-15','14:40:00',2.33),('16273','2014-04-15','14:45:00',2.08),('16273','2014-04-15','14:50:00',2.14),('16273','2014-04-15','14:55:00',2.44),('16273','2014-04-15','15:00:00',2.47),('16273','2014-04-15','15:05:00',2.59),('16273','2014-04-15','15:10:00',2.38),('16273','2014-04-15','15:15:00',3.18),('16273','2014-04-15','15:20:00',3.08),('16273','2014-04-15','15:25:00',2.94),('16273','2014-04-15','15:30:00',2.04),('16273','2014-04-15','15:35:00',2.22),('16273','2014-04-15','15:40:00',1.61),('16273','2014-04-15','15:45:00',1.26),('16273','2014-04-15','15:50:00',1.29),('16273','2014-04-15','15:55:00',1.27),('16273','2014-04-15','16:00:00',1.27),('16273','2014-04-15','16:05:00',1.17),('16273','2013-10-08','08:05:00',1.12),('16273','2013-10-08','09:40:00',1.79),('16273','2013-10-08','09:45:00',2.95),('16273','2013-10-08','09:50:00',2.89),('16273','2013-10-08','09:55:00',3.29),('16273','2013-10-08','10:00:00',2.75),('16273','2013-10-08','10:05:00',1.42),('16273','2013-10-08','12:35:00',1.24),('16273','2013-10-08','12:50:00',1.18),('16273','2013-10-08','12:55:00',1.15),('16273','2013-10-08','13:00:00',1.41),('16273','2013-10-08','13:05:00',2.63),('16273','2013-10-08','13:10:00',1.97),('16273','2013-10-08','13:15:00',1.87),('16273','2013-10-08','13:20:00',1.84),('16273','2013-10-08','13:25:00',2.45),('16273','2013-10-08','13:30:00',1.09),('16273','2013-10-08','13:40:00',1.42),('16273','2013-10-08','13:45:00',1.36),('16273','2013-10-08','14:20:00',1.3),('16273','2013-10-08','14:25:00',1.43),('16273','2013-10-08','14:30:00',2.99),('16273','2013-10-08','14:35:00',3.12),('16273','2013-10-08','14:40:00',2.52),('16273','2013-10-08','14:45:00',2.65),('16273','2013-10-08','14:50:00',2.69),('16273','2013-10-08','14:55:00',2.57),('16273','2013-10-08','15:00:00',2.52),('16273','2013-10-08','15:05:00',2.5),('16273','2013-10-08','15:10:00',2.26),('16273','2013-10-07','08:20:00',1.14),('16273','2013-10-07','08:25:00',1.24),('16273','2013-10-07','08:30:00',1.36),('16273','2013-10-07','08:35:00',1.25),('16273','2013-10-07','08:40:00',1.31),('16273','2013-10-07','08:45:00',1.18),('16273','2013-10-07','08:50:00',1.71),('16273','2013-10-07','09:10:00',1.92),('16273','2013-10-07','09:15:00',2.5),('16273','2013-10-07','09:20:00',2.15),('16273','2013-10-07','09:25:00',1.57),('16273','2013-10-07','09:30:00',2.76),('16273','2013-10-07','09:35:00',2.21),('16273','2013-10-07','09:40:00',2.66),('16273','2013-10-07','09:45:00',2.64),('16273','2013-10-07','09:50:00',2.64),('16273','2013-10-07','09:55:00',2.66),('16273','2013-10-07','10:00:00',2.7),('16273','2013-10-07','10:05:00',2.75),('16273','2013-10-07','10:10:00',2.81),('16273','2013-10-07','10:15:00',2.86),('16273','2013-10-07','10:20:00',2.9),('16273','2013-10-07','10:25:00',2.93),('16273','2013-10-07','10:30:00',2.98),('16273','2013-10-07','10:35:00',3.01),('16273','2013-10-07','10:40:00',3.05),('16273','2013-10-07','10:45:00',3.1),('16273','2013-10-07','10:50:00',3.05),('16273','2013-10-07','10:55:00',3.12),('16273','2013-10-07','11:00:00',3.15),('16273','2013-10-07','11:05:00',3.23),('16273','2013-10-07','11:10:00',2.58),('16273','2013-10-07','11:15:00',3.28),('16273','2013-10-07','11:20:00',3.1),('16273','2013-10-07','11:25:00',3.32),('16273','2013-10-07','11:30:00',2.08),('16273','2013-10-07','11:35:00',2.87),('16273','2013-10-07','11:40:00',3.08),('16273','2013-10-07','11:45:00',3.55),('16273','2013-10-07','11:50:00',3.03),('16273','2013-10-07','11:55:00',2.68),('16273','2013-10-07','12:00:00',1.46),('16273','2013-10-07','12:05:00',3.01),('16273','2013-10-07','12:10:00',3.03),('16273','2013-10-07','12:20:00',1.92),('16273','2013-10-07','12:25:00',4.11),('16273','2013-10-07','12:30:00',3.92),('16273','2013-10-07','12:35:00',1.17),('16273','2013-10-07','12:40:00',1.09),('16273','2013-10-07','12:45:00',2.35),('16273','2013-10-07','12:50:00',4.24),('16273','2013-10-07','12:55:00',2.67),('16273','2013-10-07','13:00:00',3.29),('16273','2013-10-07','13:05:00',2.1),('16273','2013-10-07','13:10:00',2.18),('16273','2013-10-07','13:20:00',2.21),('16273','2013-10-07','13:35:00',1.52),('16273','2013-10-07','13:40:00',1.22),('16273','2013-10-07','13:45:00',3.19),('16273','2013-10-07','13:50:00',1.79),('16273','2013-10-07','13:55:00',1.14),('16273','2013-10-07','14:00:00',2.73),('16273','2013-10-07','14:05:00',3.56),('16273','2013-10-07','14:10:00',2.62),('16273','2013-10-07','14:15:00',1.94),('16273','2013-10-07','14:20:00',3.46),('16273','2013-10-07','14:25:00',2.46),('16273','2013-10-07','14:30:00',2.68),('16273','2013-10-07','14:35:00',3.25),('16273','2013-10-07','14:40:00',1.46),('16273','2013-10-07','14:45:00',2.74),('16273','2013-10-07','14:50:00',1.26),('16273','2013-10-07','14:55:00',2.82),('16273','2013-10-07','15:00:00',2.87),('16273','2013-10-07','15:05:00',2.22),('16273','2013-10-07','15:10:00',1.42),('16273','2013-10-07','15:25:00',1.61),('16273','2013-10-07','15:30:00',2),('16273','2013-10-07','15:35:00',1.61),('16273','2013-10-07','15:40:00',2.18),('16273','2013-10-07','15:50:00',2.06),('16273','2013-10-07','15:55:00',1.92),('16273','2013-10-07','16:00:00',1.59),('16273','2013-10-07','16:05:00',1.42),('16273','2013-10-07','16:15:00',1.59),('16273','2013-10-07','16:25:00',1.48),('16273','2013-10-07','16:30:00',1.3),('16273','2013-10-07','16:35:00',1.19),('16273','2013-10-07','16:40:00',1.11),('16273','2013-10-07','16:45:00',1.03),('16273','2013-10-06','09:05:00',1.56),('16273','2013-10-06','09:25:00',1.98),('16273','2013-10-06','09:30:00',2.41),('16273','2013-10-06','09:35:00',2.33),('16273','2013-10-06','09:40:00',1.99),('16273','2013-10-06','09:45:00',1.89),('16273','2013-10-06','09:50:00',2.58),('16273','2013-10-06','09:55:00',2.71),('16273','2013-10-06','10:00:00',2.78),('16273','2013-10-06','10:05:00',1.85),('16273','2013-10-06','10:10:00',2.41),('16273','2013-10-06','10:15:00',2.35),('16273','2013-10-06','10:20:00',2.56),('16273','2013-10-06','10:25:00',1.98),('16273','2013-10-06','10:30:00',2.55),('16273','2013-10-06','10:35:00',2.34),('16273','2013-10-06','10:40:00',1.79),('16273','2013-10-06','10:45:00',1.88),('16273','2013-10-06','10:50:00',2.4),('16273','2013-10-06','10:55:00',2.89),('16273','2013-10-06','11:00:00',2.89),('16273','2013-10-06','11:05:00',2.89),('16273','2013-10-06','11:10:00',2.96),('16273','2013-10-06','11:15:00',2.95),('16273','2013-10-06','11:20:00',2.86),('16273','2013-10-06','11:25:00',2.77),('16273','2013-10-06','11:30:00',1.86),('16273','2013-10-06','11:35:00',1.41),('16273','2013-10-06','11:40:00',1.96),('16273','2013-10-06','11:45:00',2.45),('16273','2013-10-06','11:50:00',2.71),('16273','2013-10-06','11:55:00',2.67),('16273','2013-10-06','12:00:00',2.91),('16273','2013-10-06','12:05:00',3.21),('16273','2013-10-06','12:10:00',3.26),('16273','2013-10-06','12:15:00',2.57),('16273','2013-10-06','12:20:00',1.91),('16273','2013-10-06','12:25:00',1.95),('16273','2013-10-06','12:30:00',3.21),('16273','2013-10-06','12:35:00',2.83),('16273','2013-10-06','12:40:00',1.79),('16273','2013-10-06','12:45:00',1.86),('16273','2013-10-06','12:50:00',1.31),('16273','2013-10-06','12:55:00',1.84),('16273','2013-10-06','13:00:00',1.76),('16273','2013-10-06','13:05:00',2.06),('16273','2013-10-06','13:10:00',3.06),('16273','2013-10-06','13:15:00',1.38),('16273','2013-10-06','13:20:00',1.07),('16273','2013-10-06','13:25:00',1.16),('16273','2013-10-06','13:30:00',1.19),('16273','2013-10-06','13:35:00',1.06),('16273','2013-10-06','13:40:00',1.83),('16273','2013-10-06','13:45:00',1.75),('16273','2013-10-06','13:50:00',1.39),('16273','2013-10-06','13:55:00',1.18),('16273','2013-10-06','14:00:00',1.93),('16273','2013-10-06','14:05:00',1.7),('16273','2013-10-06','14:10:00',1.16),('16273','2013-10-06','14:15:00',1.43),('16273','2013-10-06','14:20:00',2.58),('16273','2013-10-06','14:25:00',2.57),('16273','2013-10-06','14:30:00',2.13),('16273','2013-10-06','14:35:00',2.25),('16273','2013-10-06','14:40:00',2.03),('16273','2013-10-06','14:45:00',1.82),('16273','2013-10-06','14:50:00',1.93),('16273','2013-10-06','14:55:00',2.01),('16273','2013-10-06','15:00:00',1.85),('16273','2013-10-06','15:05:00',1.47),('16273','2013-10-06','15:10:00',1.12),('16273','2013-10-06','15:15:00',1.02),('16273','2013-10-06','15:45:00',1.03),('16273','2013-10-05','15:55:00',1.01),('16273','2013-10-05','16:00:00',1.15),('16273','2013-10-05','16:05:00',1.07),('16273','2013-10-05','16:10:00',1),('16273','2013-10-04','08:40:00',1.37),('16273','2013-10-04','09:10:00',1.96),('16273','2013-10-04','09:15:00',1.53),('16273','2013-10-04','09:20:00',1.57),('16273','2013-10-04','09:25:00',1.95),('16273','2013-10-04','09:30:00',1.19),('16273','2013-10-04','09:35:00',1.1),('16273','2013-10-04','09:40:00',1.25),('16273','2013-10-04','09:45:00',1.32),('16273','2013-10-04','09:50:00',1.17),('16273','2013-10-04','09:55:00',1.1),('16273','2013-10-04','10:00:00',1.27),('16273','2013-10-04','10:05:00',1.58),('16273','2013-10-04','10:10:00',1.55),('16273','2013-10-04','10:15:00',1.5),('16273','2013-10-04','10:20:00',1.62),('16273','2013-10-04','10:25:00',1.98),('16273','2013-10-04','10:30:00',2.13),('16273','2013-10-04','10:35:00',2.99),('16273','2013-10-04','10:40:00',3.27),('16273','2013-10-04','10:45:00',2.73),('16273','2013-10-04','10:50:00',1.84),('16273','2013-10-04','10:55:00',1.76),('16273','2013-10-04','11:00:00',2.73),('16273','2013-10-04','11:05:00',2.07),('16273','2013-10-04','11:10:00',2.27),('16273','2013-10-04','11:15:00',3.04),('16273','2013-10-04','11:20:00',3.52),('16273','2013-10-04','11:25:00',3.18),('16273','2013-10-04','11:30:00',2.63),('16273','2013-10-04','11:35:00',2.43),('16273','2013-10-04','11:40:00',3.24),('16273','2013-10-04','11:45:00',3.41),('16273','2013-10-04','11:50:00',3.4),('16273','2013-10-04','11:55:00',3.4),('16273','2013-10-04','12:00:00',3.43),('16273','2013-10-04','12:05:00',3.48),('16273','2013-10-04','12:10:00',3.46),('16273','2013-10-04','12:15:00',3.44),('16273','2013-10-04','12:20:00',3.39),('16273','2013-10-04','12:25:00',3.42),('16273','2013-10-04','12:30:00',3.43),('16273','2013-10-04','12:35:00',3.39),('16273','2013-10-04','12:40:00',3.34),('16273','2013-10-04','12:45:00',3.29),('16273','2013-10-04','12:50:00',3.21),('16273','2013-10-04','12:55:00',3.3),('16273','2013-10-04','13:00:00',3.26),('16273','2013-10-04','13:05:00',3.23),('16273','2013-10-04','13:10:00',3.29),('16273','2013-10-04','13:15:00',3.24),('16273','2013-10-04','13:20:00',3.16),('16273','2013-10-04','13:25:00',3.12),('16273','2013-10-04','13:30:00',3.08),('16273','2013-10-04','13:35:00',3.09),('16273','2013-10-04','13:40:00',3.06),('16273','2013-10-04','13:45:00',2.98),('16273','2013-10-04','13:50:00',3.02),('16273','2013-10-04','13:55:00',2.97),('16273','2013-10-04','14:00:00',2.94),('16273','2013-10-04','14:05:00',2.83),('16273','2013-10-04','14:10:00',2.66),('16273','2013-10-04','14:15:00',2.6),('16273','2013-10-04','14:20:00',2.67),('16273','2013-10-04','14:25:00',1.91),('16273','2013-10-04','14:30:00',1.85),('16273','2013-10-04','14:35:00',1.56),('16273','2013-10-04','14:40:00',1.76),('16273','2013-10-04','14:45:00',2.17),('16273','2013-10-04','14:50:00',1.74),('16273','2013-10-04','14:55:00',2.12),('16273','2013-10-04','15:00:00',2.03),('16273','2013-10-04','15:05:00',1.86),('16273','2013-10-04','15:10:00',1.76),('16273','2013-10-04','15:15:00',1.44),('16273','2013-10-04','15:20:00',1.41),('16273','2013-10-04','15:25:00',1.52),('16273','2013-10-04','15:30:00',1.35),('16273','2013-10-04','15:35:00',1.23),('16273','2013-10-04','15:40:00',1.03),('16273','2013-10-04','15:55:00',1.15),('16273','2013-10-03','08:25:00',1.03),('16273','2013-10-03','08:30:00',1.46),('16273','2013-10-03','08:35:00',1.67),('16273','2013-10-03','08:40:00',1.49),('16273','2013-10-03','08:45:00',1.88),('16273','2013-10-03','08:50:00',1.97),('16273','2013-10-03','08:55:00',2.06),('16273','2013-10-03','09:00:00',1.64),('16273','2013-10-03','09:05:00',2.23),('16273','2013-10-03','09:10:00',2.31),('16273','2013-10-03','09:15:00',2.37),('16273','2013-10-03','09:20:00',1.83),('16273','2013-10-03','09:25:00',2.51),('16273','2013-10-03','09:30:00',2.58),('16273','2013-10-03','09:35:00',2.65),('16273','2013-10-03','09:40:00',2.02),('16273','2013-10-03','09:45:00',2.63),('16273','2013-10-03','09:50:00',2.85),('16273','2013-10-03','09:55:00',2.92),('16273','2013-10-03','10:00:00',2.94),('16273','2013-10-03','10:05:00',3.03),('16273','2013-10-03','10:10:00',3.08),('16273','2013-10-03','10:15:00',3.13),('16273','2013-10-03','10:20:00',3.19),('16273','2013-10-03','10:25:00',3.24),('16273','2013-10-03','10:30:00',3.27),('16273','2013-10-03','10:35:00',3.31),('16273','2013-10-03','10:40:00',3.34),('16273','2013-10-03','10:45:00',3.37),('16273','2013-10-03','10:50:00',3.42),('16273','2013-10-03','10:55:00',3.45),('16273','2013-10-03','11:00:00',3.46),('16273','2013-10-03','11:05:00',3.48),('16273','2013-10-03','11:10:00',3.49),('16273','2013-10-03','11:15:00',3.48),('16273','2013-10-03','11:20:00',3.54),('16273','2013-10-03','11:25:00',3.55),('16273','2013-10-03','11:30:00',3.57),('16273','2013-10-03','11:35:00',3.61),('16273','2013-10-03','11:40:00',3.58),('16273','2013-10-03','11:45:00',3.62),('16273','2013-10-03','11:50:00',3.64),('16273','2013-10-03','11:55:00',3.65),('16273','2013-10-03','12:00:00',3.66),('16273','2013-10-03','12:05:00',3.66),('16273','2013-10-03','12:10:00',3.66),('16273','2013-10-03','12:15:00',3.66),('16273','2013-10-03','12:20:00',3.65),('16273','2013-10-03','12:25:00',3.65),('16273','2013-10-03','12:30:00',3.64),('16273','2013-10-03','12:35:00',3.62),('16273','2013-10-03','12:40:00',3.63),('16273','2013-10-03','12:45:00',3.61),('16273','2013-10-03','12:50:00',3.61),('16273','2013-10-03','12:55:00',3.58),('16273','2013-10-03','13:00:00',3.53),('16273','2013-10-03','13:05:00',3.51),('16273','2013-10-03','13:10:00',3.53),('16273','2013-10-03','13:15:00',3.51),('16273','2013-10-03','13:20:00',3.5),('16273','2013-10-03','13:25:00',3.48),('16273','2013-10-03','13:30:00',3.45),('16273','2013-10-03','13:35:00',3.4),('16273','2013-10-03','13:40:00',3.37),('16273','2013-10-03','13:45:00',3.33),('16273','2013-10-03','13:50:00',3.28),('16273','2013-10-03','13:55:00',3.26),('16273','2013-10-03','14:00:00',3.23),('16273','2013-10-03','14:05:00',3.19),('16273','2013-10-03','14:10:00',3.14),('16273','2013-10-03','14:15:00',3.09),('16273','2013-10-03','14:20:00',3.01),('16273','2013-10-03','14:25:00',2.98),('16273','2013-10-03','14:30:00',2.94),('16273','2013-10-03','14:35:00',2.88),('16273','2013-10-03','14:40:00',2.83),('16273','2013-10-03','14:45:00',2.77),('16273','2013-10-03','14:50:00',2.7),('16273','2013-10-03','14:55:00',2.64),('16273','2013-10-03','15:00:00',2.58),('16273','2013-10-03','15:05:00',2.52),('16273','2013-10-03','15:10:00',2.46),('16273','2013-10-03','15:15:00',2.4),('16273','2013-10-03','15:20:00',2.33),('16273','2013-10-03','15:25:00',2.26),('16273','2013-10-03','15:30:00',2.2),('16273','2013-10-03','15:35:00',2.12),('16273','2013-10-03','15:40:00',2.06),('16273','2013-10-03','15:45:00',1.98),('16273','2013-10-03','15:50:00',1.92),('16273','2013-10-03','15:55:00',1.85),('16273','2013-10-03','16:00:00',1.77),('16273','2013-10-03','16:05:00',1.69),('16273','2013-10-03','16:10:00',1.62),('16273','2013-10-03','16:15:00',1.54),('16273','2013-10-03','16:20:00',1.47),('16273','2013-10-03','16:25:00',1.4),('16273','2013-10-03','16:30:00',1.32),('16273','2013-10-03','16:35:00',1.25),('16273','2013-10-03','16:40:00',1.18),('16273','2013-10-03','16:45:00',1.11),('16273','2013-10-03','16:50:00',1.04),('16273','2013-10-02','08:20:00',1.09),('16273','2013-10-02','08:30:00',1.22),('16273','2013-10-02','08:35:00',1.54),('16273','2013-10-02','08:40:00',1.64),('16273','2013-10-02','08:45:00',1.74),('16273','2013-10-02','08:50:00',1.83),('16273','2013-10-02','08:55:00',1.91),('16273','2013-10-02','09:00:00',1.98),('16273','2013-10-02','09:05:00',2.05),('16273','2013-10-02','09:10:00',2.14),('16273','2013-10-02','09:15:00',2.23),('16273','2013-10-02','09:20:00',2.32),('16273','2013-10-02','09:25:00',2.4),('16273','2013-10-02','09:30:00',2.46),('16273','2013-10-02','09:35:00',2.53),('16273','2013-10-02','09:40:00',2.6),('16273','2013-10-02','09:45:00',2.66),('16273','2013-10-02','09:50:00',2.73),('16273','2013-10-02','09:55:00',2.79),('16273','2013-10-02','10:00:00',2.84),('16273','2013-10-02','10:05:00',2.88),('16273','2013-10-02','10:10:00',2.93),('16273','2013-10-02','10:15:00',2.97),('16273','2013-10-02','10:20:00',3.03),('16273','2013-10-02','10:25:00',3.09),('16273','2013-10-02','10:30:00',3.13),('16273','2013-10-02','10:35:00',3.17),('16273','2013-10-02','10:40:00',3.21),('16273','2013-10-02','10:45:00',3.24),('16273','2013-10-02','10:50:00',3.26),('16273','2013-10-02','10:55:00',3.28),('16273','2013-10-02','11:00:00',3.3),('16273','2013-10-02','11:05:00',3.32),('16273','2013-10-02','11:10:00',3.34),('16273','2013-10-02','11:15:00',3.35),('16273','2013-10-02','11:20:00',3.37),('16273','2013-10-02','11:25:00',3.39),('16273','2013-10-02','11:30:00',3.41),('16273','2013-10-02','11:35:00',3.43),('16273','2013-10-02','11:40:00',3.44),('16273','2013-10-02','11:45:00',3.45),('16273','2013-10-02','11:50:00',3.45),('16273','2013-10-02','11:55:00',3.47),('16273','2013-10-02','12:00:00',3.47),('16273','2013-10-02','12:05:00',3.45),('16273','2013-10-02','12:10:00',3.47),('16273','2013-10-02','12:15:00',3.48),('16273','2013-10-02','12:20:00',3.48),('16273','2013-10-02','12:25:00',3.48),('16273','2013-10-02','12:30:00',3.47),('16273','2013-10-02','12:35:00',3.47),('16273','2013-10-02','12:40:00',3.48),('16273','2013-10-02','12:45:00',3.44),('16273','2013-10-02','12:50:00',3.45),('16273','2013-10-02','12:55:00',3.45),('16273','2013-10-02','13:00:00',3.45),('16273','2013-10-02','13:05:00',3.43),('16273','2013-10-02','13:10:00',3.4),('16273','2013-10-02','13:15:00',3.37),('16273','2013-10-02','13:20:00',3.36),('16273','2013-10-02','13:25:00',3.32),('16273','2013-10-02','13:30:00',3.3),('16273','2013-10-02','13:35:00',3.26),('16273','2013-10-02','13:40:00',3.23),('16273','2013-10-02','13:45:00',3.18),('16273','2013-10-02','13:50:00',3.14),('16273','2013-10-02','13:55:00',3.11),('16273','2013-10-02','14:00:00',3.06),('16273','2013-10-02','14:05:00',3.04),('16273','2013-10-02','14:10:00',3),('16273','2013-10-02','14:15:00',2.97),('16273','2013-10-02','14:20:00',2.9),('16273','2013-10-02','14:25:00',2.87),('16273','2013-10-02','14:30:00',2.78),('16273','2013-10-02','14:35:00',2.78),('16273','2013-10-02','14:40:00',2.7),('16273','2013-10-02','14:45:00',2.67),('16273','2013-10-02','14:50:00',2.62),('16273','2013-10-02','14:55:00',2.56),('16273','2013-10-02','15:00:00',2.49),('16273','2013-10-02','15:05:00',2.44),('16273','2013-10-02','15:10:00',2.39),('16273','2013-10-02','15:15:00',2.31),('16273','2013-10-02','15:20:00',2.26),('16273','2013-10-02','15:25:00',2.2),('16273','2013-10-02','15:30:00',2.13),('16273','2013-10-02','15:35:00',2.07),('16273','2013-10-02','15:40:00',2),('16273','2013-10-02','15:45:00',1.91),('16273','2013-10-02','15:50:00',1.85),('16273','2013-10-02','15:55:00',1.78),('16273','2013-10-02','16:00:00',1.71),('16273','2013-10-02','16:05:00',1.65),('16273','2013-10-02','16:10:00',1.58),('16273','2013-10-02','16:15:00',1.51),('16273','2013-10-02','16:20:00',1.44),('16273','2013-10-02','16:25:00',1.37),('16273','2013-10-02','16:30:00',1.3),('16273','2013-10-02','16:35:00',1.22),('16273','2013-10-02','16:40:00',1.15),('16273','2013-10-02','16:45:00',1.09),('16273','2013-10-02','16:50:00',1.02),('16273','2013-10-01','08:10:00',1.05),('16273','2013-10-01','08:15:00',1.13),('16273','2013-10-01','08:20:00',1.22),('16273','2013-10-01','08:25:00',1.32),('16273','2013-10-01','08:30:00',1.23),('16273','2013-10-01','08:35:00',1.57),('16273','2013-10-01','08:40:00',1.66),('16273','2013-10-01','08:45:00',1.76),('16273','2013-10-01','08:50:00',1.85),('16273','2013-10-01','08:55:00',1.93),('16273','2013-10-01','09:00:00',2),('16273','2013-10-01','09:05:00',2.09),('16273','2013-10-01','09:10:00',2.14),('16273','2013-10-01','09:15:00',2.21),('16273','2013-10-01','09:20:00',2.26),('16273','2013-10-01','09:25:00',2.32),('16273','2013-10-01','09:30:00',2.34),('16273','2013-10-01','09:35:00',2.46),('16273','2013-10-01','09:40:00',2.51),('16273','2013-10-01','09:45:00',2.54),('16273','2013-10-01','09:50:00',2.62),('16273','2013-10-01','09:55:00',2.68),('16273','2013-10-01','10:00:00',2.76),('16273','2013-10-01','10:05:00',2.75),('16273','2013-10-01','10:10:00',2.78),('16273','2013-10-01','10:15:00',1.75),('16273','2013-10-01','10:20:00',3.01),('16273','2013-10-01','10:25:00',3),('16273','2013-10-01','10:30:00',3),('16273','2013-10-01','10:35:00',3.1),('16273','2013-10-01','10:40:00',3.01),('16273','2013-10-01','10:45:00',3.13),('16273','2013-10-01','10:50:00',3.13),('16273','2013-10-01','10:55:00',1.28),('16273','2013-10-01','11:00:00',3.32),('16273','2013-10-01','11:05:00',3.32),('16273','2013-10-01','11:10:00',3.33),('16273','2013-10-01','11:15:00',3.4),('16273','2013-10-01','11:20:00',3.48),('16273','2013-10-01','11:25:00',3.5),('16273','2013-10-01','11:30:00',3.48),('16273','2013-10-01','11:35:00',3.47),('16273','2013-10-01','11:40:00',3.49),('16273','2013-10-01','11:45:00',3.52),('16273','2013-10-01','11:50:00',3.57),('16273','2013-10-01','11:55:00',3.75),('16273','2013-10-01','12:00:00',3.32),('16273','2013-10-01','12:05:00',2.97),('16273','2013-10-01','12:10:00',3.54),('16273','2013-10-01','12:15:00',3.6),('16273','2013-10-01','12:20:00',3.65),('16273','2013-10-01','12:25:00',2.95),('16273','2013-10-01','12:30:00',2.61),('16273','2013-10-01','12:35:00',2.65),('16273','2013-10-01','12:40:00',2.82),('16273','2013-10-01','12:45:00',3.59),('16273','2013-10-01','12:50:00',2.2),('16273','2013-10-01','12:55:00',1.62),('16273','2013-10-01','13:00:00',3.77),('16273','2013-10-01','13:05:00',3.58),('16273','2013-10-01','13:10:00',3.5),('16273','2013-10-01','13:15:00',3.44),('16273','2013-10-01','13:20:00',3.3),('16273','2013-10-01','13:25:00',3.29),('16273','2013-10-01','13:30:00',3.29),('16273','2013-10-01','13:35:00',3.22),('16273','2013-10-01','13:40:00',3.18),('16273','2013-10-01','13:45:00',3.19),('16273','2013-10-01','13:50:00',3.12),('16273','2013-10-01','13:55:00',3.09),('16273','2013-10-01','14:00:00',3.03),('16273','2013-10-01','14:05:00',3.01),('16273','2013-10-01','14:10:00',2.99),('16273','2013-10-01','14:15:00',2.94),('16273','2013-10-01','14:20:00',2.9),('16273','2013-10-01','14:25:00',2.85),('16273','2013-10-01','14:30:00',2.81),('16273','2013-10-01','14:35:00',2.78),('16273','2013-10-01','14:40:00',2.75),('16273','2013-10-01','14:45:00',2.7),('16273','2013-10-01','14:50:00',2.65),('16273','2013-10-01','14:55:00',2.6),('16273','2013-10-01','15:00:00',2.55),('16273','2013-10-01','15:05:00',2.48),('16273','2013-10-01','15:10:00',2.43),('16273','2013-10-01','15:15:00',2.38),('16273','2013-10-01','15:20:00',2.31),('16273','2013-10-01','15:25:00',2.24),('16273','2013-10-01','15:30:00',2.19),('16273','2013-10-01','15:35:00',2.12),('16273','2013-10-01','15:40:00',2.04),('16273','2013-10-01','15:45:00',1.96),('16273','2013-10-01','15:50:00',1.88),('16273','2013-10-01','15:55:00',1.81),('16273','2013-10-01','16:00:00',1.74),('16273','2013-10-01','16:05:00',1.67),('16273','2013-10-01','16:10:00',1.6),('16273','2013-10-01','16:15:00',1.53),('16273','2013-10-01','16:20:00',1.44),('16273','2013-10-01','16:25:00',1.39),('16273','2013-10-01','16:30:00',1.31),('16273','2013-10-01','16:35:00',1.25),('16273','2013-10-01','16:40:00',1.18),('16273','2013-10-01','16:45:00',1.11),('16273','2013-10-01','16:50:00',1.03),('16273','2013-09-30','09:35:00',1.18),('16273','2013-09-30','09:40:00',1.7),('16273','2013-09-30','09:45:00',2.01),('16273','2013-09-30','09:50:00',1.03),('16273','2013-09-30','10:05:00',1),('16273','2013-09-30','10:10:00',1.08),('16273','2013-09-30','10:15:00',1.09),('16273','2013-09-30','10:20:00',1.27),('16273','2013-09-30','10:25:00',1.4),('16273','2013-09-30','10:30:00',1.71),('16273','2013-09-30','10:35:00',2.05),('16273','2013-09-30','10:40:00',3.21),('16273','2013-09-30','10:45:00',3.03),('16273','2013-09-30','10:50:00',2.9),('16273','2013-09-30','10:55:00',2.76),('16273','2013-09-30','11:00:00',3.27),('16273','2013-09-30','11:05:00',3.37),('16273','2013-09-30','11:10:00',3.43),('16273','2013-09-30','11:15:00',2.96),('16273','2013-09-30','11:20:00',2.56),('16273','2013-09-30','11:25:00',2.34),('16273','2013-09-30','11:30:00',3.41),('16273','2013-09-30','11:35:00',1.75),('16273','2013-09-30','11:45:00',1.21),('16273','2013-09-30','11:50:00',2.86),('16273','2013-09-30','11:55:00',3.7),('16273','2013-09-30','12:00:00',3.99),('16273','2013-09-30','12:05:00',3.77),('16273','2013-09-30','12:10:00',3.63),('16273','2013-09-30','12:15:00',3.52),('16273','2013-09-30','12:20:00',3.53),('16273','2013-09-30','12:25:00',3.52),('16273','2013-09-30','12:30:00',3.54),('16273','2013-09-30','12:35:00',3.63),('16273','2013-09-30','12:40:00',3.58),('16273','2013-09-30','12:45:00',3.42),('16273','2013-09-30','12:50:00',3.55),('16273','2013-09-30','12:55:00',3.54),('16273','2013-09-30','13:00:00',3.26),('16273','2013-09-30','13:05:00',3.23),('16273','2013-09-30','13:10:00',2.02),('16273','2013-09-30','13:15:00',3.19),('16273','2013-09-30','13:20:00',3.47),('16273','2013-09-30','13:25:00',3.13),('16273','2013-09-30','13:30:00',2.77),('16273','2013-09-30','13:35:00',3.3),('16273','2013-09-30','13:40:00',3),('16273','2013-09-30','13:55:00',1.02),('16273','2013-09-30','14:00:00',1.14),('16273','2013-09-30','14:05:00',1.25),('16273','2013-09-30','14:10:00',1.08),('16273','2013-09-30','14:20:00',1.08),('16273','2013-09-30','14:25:00',2.85),('16273','2013-09-30','14:30:00',3.47),('16273','2013-09-30','14:35:00',3.73),('16273','2013-09-30','14:40:00',2.39),('16273','2013-09-30','14:45:00',2.53),('16273','2013-09-30','14:50:00',1.51),('16273','2013-09-30','15:00:00',1.56),('16273','2013-09-30','15:05:00',2.78),('16273','2013-09-30','15:10:00',1.19),('16273','2013-09-30','15:15:00',1.26),('16273','2013-09-30','15:20:00',1.8),('16273','2013-09-30','15:25:00',2.02),('16273','2013-09-30','15:30:00',2.72),('16273','2013-09-30','15:35:00',1.42),('16273','2013-09-30','16:00:00',1.98),('16273','2013-09-30','16:05:00',1.93),('16273','2013-09-30','16:20:00',1.02),('16273','2013-09-30','16:30:00',1.49),('16273','2013-09-30','16:35:00',1.04),('16273','2013-09-30','16:40:00',1.54),('16273','2013-09-30','16:45:00',1.39),('16273','2013-09-30','16:50:00',1.31),('16273','2013-09-30','17:10:00',1.13),('16273','2013-09-30','17:15:00',1.02),('16273','2013-09-29','08:40:00',1.02),('16273','2013-09-29','09:50:00',1.08),('16273','2013-09-29','09:55:00',1.45),('16273','2013-09-29','10:00:00',1.92),('16273','2013-09-29','10:05:00',2.02),('16273','2013-09-29','10:10:00',2.53),('16273','2013-09-29','10:15:00',1.93),('16273','2013-09-29','10:20:00',2.22),('16273','2013-09-29','10:25:00',2.45),('16273','2013-09-29','10:30:00',2.67),('16273','2013-09-29','10:35:00',2.74),('16273','2013-09-29','10:40:00',2.75),('16273','2013-09-29','10:45:00',2.87),('16273','2013-09-29','10:50:00',2.85),('16273','2013-09-29','10:55:00',2.88),('16273','2013-09-29','11:00:00',2.77),('16273','2013-09-29','11:05:00',2.62),('16273','2013-09-29','11:10:00',2.79),('16273','2013-09-29','11:15:00',2.83),('16273','2013-09-29','11:20:00',2.65),('16273','2013-09-29','11:25:00',2.88),('16273','2013-09-29','11:30:00',2.91),('16273','2013-09-29','11:35:00',3.03),('16273','2013-09-29','11:40:00',3.17),('16273','2013-09-29','11:45:00',2.19),('16273','2013-09-29','11:50:00',1.88),('16273','2013-09-29','11:55:00',3.06),('16273','2013-09-29','12:00:00',3.21),('16273','2013-09-29','12:05:00',3.28),('16273','2013-09-29','12:10:00',2.37),('16273','2013-09-29','12:15:00',1.21),('16273','2013-09-29','12:25:00',1.08),('16273','2013-09-29','12:30:00',1.38),('16273','2013-09-29','12:35:00',1.58),('16273','2013-09-29','12:40:00',1.19),('16273','2013-09-29','12:45:00',1.17),('16273','2013-09-29','12:50:00',1.29),('16273','2013-09-29','13:20:00',1.15),('16273','2013-09-29','13:25:00',2.73),('16273','2013-09-29','13:30:00',2.42),('16273','2013-09-29','13:35:00',2.09),('16273','2013-09-29','13:40:00',2.3),('16273','2013-09-29','13:45:00',2.4),('16273','2013-09-29','13:50:00',2.6),('16273','2013-09-29','13:55:00',1.36),('16273','2013-09-29','14:05:00',1.13),('16273','2013-09-29','14:15:00',1.13),('16273','2013-09-29','14:20:00',1.17),('16273','2013-09-29','14:45:00',1.03),('16273','2013-09-29','14:50:00',1.41),('16273','2013-09-29','15:15:00',1.21),('16273','2013-09-29','15:25:00',1.17),('16273','2013-09-29','15:55:00',1.07),('16273','2013-09-29','16:25:00',1.32),('16273','2013-09-29','16:30:00',1.18),('16273','2014-04-14','07:45:00',1.08),('16273','2014-04-14','07:50:00',1.05),('16273','2014-04-14','07:55:00',1.3),('16273','2014-04-14','08:00:00',1.42),('16273','2014-04-14','08:05:00',1.51),('16273','2014-04-14','08:10:00',1.6),('16273','2014-04-14','08:15:00',1.7),('16273','2014-04-14','08:20:00',1.79),('16273','2014-04-14','08:25:00',1.88),('16273','2014-04-14','08:30:00',1.97),('16273','2014-04-14','08:35:00',2.04),('16273','2014-04-14','08:40:00',2.09),('16273','2014-04-14','08:45:00',2.17),('16273','2014-04-14','08:50:00',2.25),('16273','2014-04-14','08:55:00',2.33),('16273','2014-04-14','09:00:00',2.4),('16273','2014-04-14','09:05:00',2.48),('16273','2014-04-14','09:10:00',2.54),('16273','2014-04-14','09:15:00',2.61),('16273','2014-04-14','09:20:00',2.68),('16273','2014-04-14','09:25:00',2.75),('16273','2014-04-14','09:30:00',2.81),('16273','2014-04-14','09:35:00',2.87),('16273','2014-04-14','09:40:00',2.93),('16273','2014-04-14','09:45:00',2.99),('16273','2014-04-14','09:50:00',3.04),('16273','2014-04-14','09:55:00',3.08),('16273','2014-04-14','10:00:00',3.16),('16273','2014-04-14','10:05:00',3.21),('16273','2014-04-14','10:10:00',3.24),('16273','2014-04-14','10:15:00',3.29),('16273','2014-04-14','10:20:00',3.34),('16273','2014-04-14','10:25:00',3.37),('16273','2014-04-14','10:30:00',3.41),('16273','2014-04-14','10:35:00',3.45),('16273','2014-04-14','10:40:00',3.49),('16273','2014-04-14','10:45:00',3.53),('16273','2014-04-14','10:50:00',3.56),('16273','2014-04-14','10:55:00',3.6),('16273','2014-04-14','11:00:00',3.61),('16273','2014-04-14','11:05:00',3.63),('16273','2014-04-14','11:10:00',3.67),('16273','2014-04-14','11:15:00',3.68),('16273','2014-04-14','11:20:00',3.69),('16273','2014-04-14','11:25:00',3.71),('16273','2014-04-14','11:30:00',3.75),('16273','2014-04-14','11:35:00',3.78),('16273','2014-04-14','11:40:00',3.79),('16273','2014-04-14','11:45:00',3.8),('16273','2014-04-14','11:50:00',3.78),('16273','2014-04-14','11:55:00',3.82),('16273','2014-04-14','12:00:00',3.83),('16273','2014-04-14','12:05:00',3.83),('16273','2014-04-14','12:10:00',3.83),('16273','2014-04-14','12:15:00',3.84),('16273','2014-04-14','12:20:00',3.86),('16273','2014-04-14','12:25:00',3.85),('16273','2014-04-14','12:30:00',3.86),('16273','2014-04-14','12:35:00',3.83),('16273','2014-04-14','12:40:00',3.85),('16273','2014-04-14','12:45:00',3.86),('16273','2014-04-14','12:50:00',3.86),('16273','2014-04-14','12:55:00',3.86),('16273','2014-04-14','13:00:00',3.86),('16273','2014-04-14','13:05:00',3.86),('16273','2014-04-14','13:10:00',3.86),('16273','2014-04-14','13:15:00',3.84),('16273','2014-04-14','13:20:00',3.81),('16273','2014-04-14','13:25:00',3.8),('16273','2014-04-14','13:30:00',3.79),('16273','2014-04-14','13:35:00',3.78),('16273','2014-04-14','13:40:00',3.75),('16273','2014-04-14','13:45:00',3.74),('16273','2014-04-14','13:50:00',3.72),('16273','2014-04-14','13:55:00',3.7),('16273','2014-04-14','14:00:00',3.67),('16273','2014-04-14','14:05:00',3.64),('16273','2014-04-14','14:10:00',3.6),('16273','2014-04-14','14:15:00',3.57),('16273','2014-04-14','14:20:00',3.53),('16273','2014-04-14','14:25:00',3.49),('16273','2014-04-14','14:30:00',3.45),('16273','2014-04-14','14:35:00',3.41),('16273','2014-04-14','14:40:00',3.37),('16273','2014-04-14','14:45:00',3.33),('16273','2014-04-14','14:50:00',3.28),('16273','2014-04-14','14:55:00',3.23),('16273','2014-04-14','15:00:00',3.18),('16273','2014-04-14','15:05:00',3.14),('16273','2014-04-14','15:10:00',3.09),('16273','2014-04-14','15:15:00',3.03),('16273','2014-04-14','15:20:00',2.98),('16273','2014-04-14','15:25:00',2.92),('16273','2014-04-14','15:30:00',2.85),('16273','2014-04-14','15:35:00',2.79),('16273','2014-04-14','15:40:00',2.73),('16273','2014-04-14','15:45:00',2.67),('16273','2014-04-14','15:50:00',2.59),('16273','2014-04-14','15:55:00',2.52),('16273','2014-04-14','16:00:00',2.44),('16273','2014-04-14','16:05:00',2.38),('16273','2014-04-14','16:10:00',2.32),('16273','2014-04-14','16:15:00',2.24),('16273','2014-04-14','16:20:00',2.17),('16273','2014-04-14','16:25:00',2.08),('16273','2014-04-14','16:30:00',2),('16273','2014-04-14','16:35:00',1.93),('16273','2014-04-14','16:40:00',1.85),('16273','2014-04-14','16:45:00',1.77),('16273','2014-04-14','16:50:00',1.69),('16273','2014-04-14','16:55:00',1.61),('16273','2014-04-14','17:00:00',1.52),('16273','2014-04-14','17:05:00',1.45),('16273','2014-04-14','17:10:00',1.37),('16273','2014-04-14','17:15:00',1.29),('16273','2014-04-14','17:20:00',1.22),('16273','2014-04-14','17:25:00',1.15),('16273','2014-04-14','17:30:00',1.07),('16273','2014-04-14','17:35:00',1),('16273','2013-09-28','08:25:00',1.14),('16273','2013-09-28','08:30:00',1.3),('16273','2013-09-28','08:35:00',1.43),('16273','2013-09-28','08:40:00',1.53),('16273','2013-09-28','08:45:00',1.59),('16273','2013-09-28','08:50:00',1.67),('16273','2013-09-28','08:55:00',1.16),('16273','2013-09-28','09:00:00',1.03),('16273','2013-09-28','09:05:00',1.95),('16273','2013-09-28','09:10:00',1.84),('16273','2013-09-28','09:15:00',2.02),('16273','2013-09-28','09:20:00',2.34),('16273','2013-09-28','09:25:00',2.08),('16273','2013-09-28','09:30:00',2.49),('16273','2013-09-28','09:35:00',2.62),('16273','2013-09-28','09:40:00',2.67),('16273','2013-09-28','09:45:00',2),('16273','2013-09-28','09:50:00',2.82),('16273','2013-09-28','09:55:00',2.52),('16273','2013-09-28','10:00:00',1),('16273','2013-09-28','10:20:00',1.08),('16273','2013-09-28','10:25:00',1.43),('16273','2013-09-28','10:30:00',3.21),('16273','2013-09-28','10:35:00',3.29),('16273','2013-09-28','10:40:00',3.37),('16273','2013-09-28','10:45:00',3.39),('16273','2013-09-28','11:00:00',3.04),('16273','2013-09-28','11:05:00',2.23),('16273','2013-09-28','11:10:00',1.9),('16273','2013-09-28','11:15:00',3.43),('16273','2013-09-28','11:20:00',3.42),('16273','2013-09-28','11:25:00',3.37),('16273','2013-09-28','11:30:00',3),('16273','2013-09-28','11:35:00',1.12),('16273','2013-09-28','11:40:00',1.69),('16273','2013-09-28','11:45:00',2.49),('16273','2013-09-28','11:50:00',2.41),('16273','2013-09-28','11:55:00',1.94),('16273','2013-09-28','12:00:00',2.78),('16273','2013-09-28','12:05:00',3.57),('16273','2013-09-28','12:10:00',2.86),('16273','2013-09-28','12:20:00',3.53),('16273','2013-09-28','12:30:00',1.37),('16273','2013-09-28','12:35:00',3.07),('16273','2013-09-28','12:40:00',2.96),('16273','2013-09-28','12:45:00',3.29),('16273','2013-09-28','12:50:00',3.6),('16273','2013-09-28','12:55:00',3.46),('16273','2013-09-28','13:00:00',2.55),('16273','2013-09-28','13:05:00',1.8),('16273','2013-09-28','13:10:00',1.89),('16273','2013-09-28','13:15:00',2.89),('16273','2013-09-28','13:20:00',3.29),('16273','2013-09-28','13:25:00',3.35),('16273','2013-09-28','13:30:00',3.33),('16273','2013-09-28','13:35:00',3.11),('16273','2013-09-28','13:40:00',2.76),('16273','2013-09-28','13:45:00',2.66),('16273','2013-09-28','13:50:00',3.39),('16273','2013-09-28','13:55:00',3.18),('16273','2013-09-28','14:00:00',2.85),('16273','2013-09-28','14:05:00',3.09),('16273','2013-09-28','14:10:00',3.07),('16273','2013-09-28','14:15:00',1.55),('16273','2013-09-28','14:20:00',1.3),('16273','2013-09-28','14:25:00',1.08),('16273','2013-09-28','14:30:00',2.53),('16273','2013-09-28','14:35:00',2.49),('16273','2013-09-28','14:40:00',3.05),('16273','2013-09-28','14:45:00',1.43),('16273','2013-09-28','14:50:00',1.84),('16273','2013-09-28','14:55:00',1.44),('16273','2013-09-28','15:05:00',2.21),('16273','2013-09-28','15:10:00',1.58),('16273','2013-09-28','15:15:00',2.37),('16273','2013-09-28','15:20:00',2.24),('16273','2013-09-28','15:25:00',1.89),('16273','2013-09-28','15:30:00',2.3),('16273','2013-09-28','15:35:00',2.16),('16273','2013-09-28','15:40:00',2.03),('16273','2013-09-28','15:45:00',1.97),('16273','2013-09-28','15:50:00',1.9),('16273','2013-09-28','15:55:00',1.8),('16273','2013-09-28','16:00:00',1.76),('16273','2013-09-28','16:05:00',1.65),('16273','2013-09-28','16:10:00',1.62),('16273','2013-09-28','16:15:00',1.28),('16273','2013-09-28','16:20:00',1.3),('16273','2013-09-28','16:25:00',1.29),('16273','2013-09-28','16:30:00',1.33),('16273','2013-09-28','16:35:00',1.27),('16273','2013-09-28','16:40:00',1.18),('16273','2013-09-28','16:45:00',1.12),('16273','2013-09-28','16:50:00',1.06),('16273','2013-09-27','08:25:00',1.32),('16273','2013-09-27','08:30:00',1.1),('16273','2013-09-27','08:35:00',1.33),('16273','2013-09-27','08:40:00',1.22),('16273','2013-09-27','08:45:00',1.35),('16273','2013-09-27','08:50:00',1.34),('16273','2013-09-27','08:55:00',1.66),('16273','2013-09-27','09:00:00',1.47),('16273','2013-09-27','09:05:00',1.86),('16273','2013-09-27','09:10:00',1.14),('16273','2013-09-27','09:15:00',1.09),('16273','2013-09-27','09:20:00',1.06),('16273','2013-09-27','10:00:00',1.3),('16273','2013-09-27','10:05:00',1.87),('16273','2013-09-27','10:10:00',1.22),('16273','2013-09-27','10:15:00',1.14),('16273','2013-09-27','10:20:00',1.22),('16273','2013-09-27','10:35:00',1.59),('16273','2013-09-27','10:40:00',2.15),('16273','2013-09-27','10:45:00',1.99),('16273','2013-09-27','10:50:00',3.17),('16273','2013-09-27','10:55:00',3.21),('16273','2013-09-27','11:00:00',3.21),('16273','2013-09-27','11:05:00',3.21),('16273','2013-09-27','11:10:00',3.12),('16273','2013-09-27','11:15:00',3.1),('16273','2013-09-27','11:20:00',2.71),('16273','2013-09-27','11:25:00',1.59),('16273','2013-09-27','11:30:00',1.38),('16273','2013-09-27','11:35:00',1.01),('16273','2013-09-27','12:15:00',1.15),('16273','2013-09-27','12:20:00',2.6),('16273','2013-09-27','12:25:00',3.73),('16273','2013-09-27','12:30:00',3.31),('16273','2013-09-27','12:35:00',3.62),('16273','2013-09-27','12:40:00',2.6),('16273','2013-09-27','12:45:00',3.71),('16273','2013-09-27','12:50:00',1.12),('16273','2013-09-27','13:05:00',2.32),('16273','2013-09-27','13:10:00',2.35),('16273','2013-09-27','13:25:00',2.3),('16273','2013-09-27','13:30:00',1.4),('16273','2013-09-27','13:35:00',2.53),('16273','2013-09-27','13:40:00',2.28),('16273','2013-09-27','13:45:00',2.45),('16273','2013-09-27','13:50:00',2.03),('16273','2013-09-27','13:55:00',1.32),('16273','2013-09-27','14:00:00',3.05),('16273','2013-09-27','14:05:00',2.54),('16273','2013-09-27','14:10:00',3.12),('16273','2013-09-27','14:15:00',2.96),('16273','2013-09-27','14:20:00',2.95),('16273','2013-09-27','14:25:00',1.44),('16273','2013-09-27','14:30:00',2.1),('16273','2013-09-27','14:35:00',3.06),('16273','2013-09-27','14:40:00',2.9),('16273','2013-09-27','14:45:00',2.14),('16273','2013-09-27','14:50:00',2.83),('16273','2013-09-27','14:55:00',2.74),('16273','2013-09-27','15:00:00',2.66),('16273','2013-09-27','15:05:00',2.51),('16273','2013-09-27','15:10:00',1.11),('16273','2013-09-27','15:15:00',1.7),('16273','2013-09-27','15:20:00',2.44),('16273','2013-09-27','15:25:00',1.34),('16273','2013-09-27','15:30:00',1.97),('16273','2013-09-27','15:35:00',1),('16273','2013-09-27','15:40:00',2.27),('16273','2013-09-27','15:45:00',1.77),('16273','2013-09-27','15:50:00',2.07),('16273','2013-09-27','15:55:00',1.62),('16273','2013-09-27','16:00:00',1.99),('16273','2013-09-27','16:05:00',1.64),('16273','2013-09-27','16:10:00',1.67),('16273','2013-09-27','16:25:00',1.55),('16273','2013-09-27','16:30:00',1.42),('16273','2013-09-27','16:35:00',1.32),('16273','2013-09-27','16:45:00',1.2),('16273','2013-09-27','16:50:00',1.06),('16273','2013-09-27','16:55:00',1.06),('16273','2013-09-26','08:10:00',1.09),('16273','2013-09-26','08:15:00',1.18),('16273','2013-09-26','08:20:00',1.3),('16273','2013-09-26','08:25:00',1.21),('16273','2013-09-26','08:30:00',1.5),('16273','2013-09-26','08:35:00',1.6),('16273','2013-09-26','08:40:00',1.69),('16273','2013-09-26','08:45:00',1.78),('16273','2013-09-26','08:50:00',1.88),('16273','2013-09-26','08:55:00',1.95),('16273','2013-09-26','09:00:00',1.58),('16273','2013-09-26','09:05:00',2.13),('16273','2013-09-26','09:10:00',2.14),('16273','2013-09-26','09:15:00',2.18),('16273','2013-09-26','09:20:00',2.24),('16273','2013-09-26','09:25:00',2.34),('16273','2013-09-26','09:30:00',2.39),('16273','2013-09-26','09:35:00',2.46),('16273','2013-09-26','09:40:00',2.51),('16273','2013-09-26','09:45:00',2.61),('16273','2013-09-26','09:50:00',2.63),('16273','2013-09-26','09:55:00',2.75),('16273','2013-09-26','10:00:00',2.74),('16273','2013-09-26','10:05:00',2.72),('16273','2013-09-26','10:10:00',2.75),('16273','2013-09-26','10:15:00',2.79),('16273','2013-09-26','10:20:00',2.81),('16273','2013-09-26','10:25:00',2.93),('16273','2013-09-26','10:30:00',2.94),('16273','2013-09-26','10:35:00',3.01),('16273','2013-09-26','10:40:00',2.99),('16273','2013-09-26','10:45:00',3.02),('16273','2013-09-26','10:50:00',3.06),('16273','2013-09-26','10:55:00',3.09),('16273','2013-09-26','11:00:00',3.12),('16273','2013-09-26','11:05:00',2.89),('16273','2013-09-26','11:10:00',3.17),('16273','2013-09-26','11:15:00',3.18),('16273','2013-09-26','11:20:00',3.31),('16273','2013-09-26','11:25:00',3.4),('16273','2013-09-26','11:30:00',1.87),('16273','2013-09-26','11:40:00',2.1),('16273','2013-09-26','11:45:00',3.44),('16273','2013-09-26','11:50:00',3.53),('16273','2013-09-26','11:55:00',1.99),('16273','2013-09-26','12:00:00',2.31),('16273','2013-09-26','12:05:00',2.07),('16273','2013-09-26','12:10:00',1.57),('16273','2013-09-26','12:15:00',1.57),('16273','2013-09-26','12:20:00',1.54),('16273','2013-09-26','12:25:00',1.42),('16273','2013-09-26','12:30:00',1.44),('16273','2013-09-26','12:35:00',1.4),('16273','2013-09-26','12:40:00',1.56),('16273','2013-09-26','12:45:00',1.36),('16273','2013-09-26','12:50:00',2.57),('16273','2013-09-26','12:55:00',1.84),('16273','2013-09-26','13:00:00',1.98),('16273','2013-09-26','13:05:00',1.68),('16273','2013-09-26','13:10:00',1.35),('16273','2013-09-26','13:15:00',1.43),('16273','2013-09-26','13:20:00',2.12),('16273','2013-09-26','13:25:00',3.95),('16273','2013-09-26','13:30:00',2.53),('16273','2013-09-26','13:35:00',3.29),('16273','2013-09-26','13:40:00',3.2),('16273','2013-09-26','13:45:00',3.06),('16273','2013-09-26','13:50:00',2.32),('16273','2013-09-26','13:55:00',2.74),('16273','2013-09-26','14:00:00',3.27),('16273','2013-09-26','14:05:00',2.06),('16273','2013-09-26','14:10:00',2.63),('16273','2013-09-26','14:15:00',3.23),('16273','2013-09-26','14:20:00',3.12),('16273','2013-09-26','14:25:00',2.98),('16273','2013-09-26','14:30:00',2.93),('16273','2013-09-26','14:35:00',2.88),('16273','2013-09-26','14:40:00',2.82),('16273','2013-09-26','14:45:00',2.38),('16273','2013-09-26','14:50:00',1.56),('16273','2013-09-26','14:55:00',2.36),('16273','2013-09-26','15:00:00',2.78),('16273','2013-09-26','15:05:00',2.45),('16273','2013-09-26','15:15:00',1.05),('16273','2013-09-26','15:20:00',2.66),('16273','2013-09-26','15:25:00',2.43),('16273','2013-09-26','15:30:00',2.29),('16273','2013-09-26','15:35:00',2.29),('16273','2013-09-26','15:40:00',2.23),('16273','2013-09-26','15:45:00',2.12),('16273','2013-09-26','15:50:00',2.02),('16273','2013-09-26','15:55:00',1.96),('16273','2013-09-26','16:00:00',1.91),('16273','2013-09-26','16:05:00',1.8),('16273','2013-09-26','16:10:00',1.72),('16273','2013-09-26','16:15:00',1.58),('16273','2013-09-26','16:20:00',1.53),('16273','2013-09-26','16:25:00',1.46),('16273','2013-09-26','16:30:00',1.32),('16273','2013-09-26','16:35:00',1.3),('16273','2013-09-26','16:40:00',1.22),('16273','2013-09-26','16:45:00',1.14),('16273','2013-09-26','16:50:00',1.08),('16273','2013-09-26','16:55:00',1.03),('16273','2013-09-25','08:00:00',1),('16273','2013-09-25','08:15:00',1.24),('16273','2013-09-25','08:20:00',1.31),('16273','2013-09-25','08:25:00',1.26),('16273','2013-09-25','08:30:00',1.09),('16273','2013-09-25','08:35:00',1.42),('16273','2013-09-25','08:40:00',1.68),('16273','2013-09-25','08:45:00',1.4),('16273','2013-09-25','08:50:00',1.02),('16273','2013-09-25','08:55:00',1.74),('16273','2013-09-25','09:05:00',1.23),('16273','2013-09-25','09:10:00',1.68),('16273','2013-09-25','09:15:00',1.44),('16273','2013-09-25','10:15:00',1.03),('16273','2013-09-25','10:30:00',3.04),('16273','2013-09-25','10:35:00',3.23),('16273','2013-09-25','10:40:00',3.21),('16273','2013-09-25','10:45:00',3.35),('16273','2013-09-25','10:50:00',3.45),('16273','2013-09-25','10:55:00',1.89),('16273','2013-09-25','11:10:00',1.33),('16273','2013-09-25','11:15:00',3.64),('16273','2013-09-25','11:20:00',3.53),('16273','2013-09-25','11:25:00',3.52),('16273','2013-09-25','11:30:00',3.53),('16273','2013-09-25','11:35:00',1.64),('16273','2013-09-25','11:40:00',3.98),('16273','2013-09-25','11:45:00',3.21),('16273','2013-09-25','11:50:00',1.36),('16273','2013-09-25','11:55:00',1.09),('16273','2013-09-25','12:00:00',2.33),('16273','2013-09-25','12:05:00',1.79),('16273','2013-09-25','12:15:00',1.02),('16273','2013-09-25','12:20:00',3.44),('16273','2013-09-25','12:25:00',3.59),('16273','2013-09-25','12:30:00',3.39),('16273','2013-09-25','12:35:00',2.73),('16273','2013-09-25','12:40:00',1.2),('16273','2013-09-25','12:50:00',1.45),('16273','2013-09-25','12:55:00',4.04),('16273','2013-09-25','13:00:00',4.03),('16273','2013-09-25','13:05:00',2.93),('16273','2013-09-25','13:10:00',3.39),('16273','2013-09-25','13:15:00',3.67),('16273','2013-09-25','13:20:00',3.64),('16273','2013-09-25','13:25:00',3.7),('16273','2013-09-25','13:30:00',3.66),('16273','2013-09-25','13:35:00',3.54),('16273','2013-09-25','13:40:00',3.58),('16273','2013-09-25','13:45:00',3.5),('16273','2013-09-25','13:50:00',3.53),('16273','2013-09-25','13:55:00',3.46),('16273','2013-09-25','14:00:00',3.4),('16273','2013-09-25','14:05:00',3.44),('16273','2013-09-25','14:10:00',3.36),('16273','2013-09-25','14:15:00',3.21),('16273','2013-09-25','14:20:00',3.04),('16273','2013-09-25','14:25:00',2.91),('16273','2013-09-25','14:30:00',1.89),('16273','2013-09-25','14:35:00',1.14),('16273','2013-09-25','14:40:00',3.18),('16273','2013-09-25','14:45:00',1.76),('16273','2013-09-25','14:50:00',1.11),('16273','2013-09-25','14:55:00',1.19),('16273','2013-09-25','15:00:00',2.36),('16273','2013-09-25','15:05:00',2.75),('16273','2013-09-25','15:10:00',1.75),('16273','2013-09-25','15:15:00',1.75),('16273','2013-09-25','15:20:00',2.61),('16273','2013-09-25','15:25:00',2.47),('16273','2013-09-25','15:30:00',1.64),('16273','2013-09-25','15:35:00',1.66),('16273','2013-09-25','15:40:00',2.03),('16273','2013-09-25','15:45:00',2.14),('16273','2013-09-25','15:50:00',1.67),('16273','2013-09-25','15:55:00',2.16),('16273','2013-09-25','16:00:00',2.06),('16273','2013-09-25','16:05:00',1.7),('16273','2013-09-25','16:10:00',1.85),('16273','2013-09-25','16:15:00',1.2),('16273','2013-09-25','16:20:00',1.69),('16273','2013-09-25','16:25:00',1.57),('16273','2013-09-25','16:30:00',1.48),('16273','2013-09-25','16:35:00',1.4),('16273','2013-09-25','16:40:00',1.33),('16273','2013-09-25','16:45:00',1.25),('16273','2013-09-25','16:50:00',1.17),('16273','2013-09-25','16:55:00',1.1),('16273','2013-09-25','17:00:00',1.04),('16273','2013-09-24','08:05:00',1.04),('16273','2013-09-24','08:10:00',1.17),('16273','2013-09-24','08:15:00',1.15),('16273','2013-09-24','08:20:00',1.36),('16273','2013-09-24','08:25:00',1.5),('16273','2013-09-24','08:30:00',1.62),('16273','2013-09-24','08:35:00',1.72),('16273','2013-09-24','08:40:00',1.8),('16273','2013-09-24','08:45:00',1.88),('16273','2013-09-24','08:50:00',1.99),('16273','2013-09-24','08:55:00',2.08),('16273','2013-09-24','09:00:00',2.17),('16273','2013-09-24','09:05:00',2.25),('16273','2013-09-24','09:10:00',2.31),('16273','2013-09-24','09:15:00',2.39),('16273','2013-09-24','09:20:00',2.46),('16273','2013-09-24','09:25:00',2.52),('16273','2013-09-24','09:30:00',2.57),('16273','2013-09-24','09:35:00',2.64),('16273','2013-09-24','09:40:00',2.67),('16273','2013-09-24','09:45:00',2.72),('16273','2013-09-24','09:50:00',2.78),('16273','2013-09-24','09:55:00',2.83),('16273','2013-09-24','10:00:00',2.88),('16273','2013-09-24','10:05:00',2.93),('16273','2013-09-24','10:10:00',2.98),('16273','2013-09-24','10:15:00',3.03),('16273','2013-09-24','10:20:00',3.04),('16273','2013-09-24','10:25:00',3.09),('16273','2013-09-24','10:30:00',3.11),('16273','2013-09-24','10:35:00',3.16),('16273','2013-09-24','10:40:00',3.2),('16273','2013-09-24','10:45:00',3.24),('16273','2013-09-24','10:50:00',3.26),('16273','2013-09-24','10:55:00',3.3),('16273','2013-09-24','11:00:00',3.32),('16273','2013-09-24','11:05:00',3.37),('16273','2013-09-24','11:10:00',3.38),('16273','2013-09-24','11:15:00',3.37),('16273','2013-09-24','11:20:00',3.43),('16273','2013-09-24','11:25:00',3.43),('16273','2013-09-24','11:30:00',3.46),('16273','2013-09-24','11:35:00',3.46),('16273','2013-09-24','11:40:00',3.49),('16273','2013-09-24','11:45:00',3.49),('16273','2013-09-24','11:50:00',3.5),('16273','2013-09-24','11:55:00',3.51),('16273','2013-09-24','12:00:00',3.52),('16273','2013-09-24','12:05:00',3.48),('16273','2013-09-24','12:10:00',3.51),('16273','2013-09-24','12:15:00',3.52),('16273','2013-09-24','12:20:00',3.54),('16273','2013-09-24','12:25:00',3.54),('16273','2013-09-24','12:30:00',3.55),('16273','2013-09-24','12:35:00',3.52),('16273','2013-09-24','12:40:00',3.54),('16273','2013-09-24','12:45:00',3.51),('16273','2013-09-24','12:50:00',3.51),('16273','2013-09-24','12:55:00',3.48),('16273','2013-09-24','13:00:00',3.48),('16273','2013-09-24','13:05:00',3.45),('16273','2013-09-24','13:10:00',3.44),('16273','2013-09-24','13:15:00',3.41),('16273','2013-09-24','13:20:00',3.43),('16273','2013-09-24','13:25:00',3.38),('16273','2013-09-24','13:30:00',3.37),('16273','2013-09-24','13:35:00',3.37),('16273','2013-09-24','13:40:00',3.34),('16273','2013-09-24','13:45:00',3.32),('16273','2013-09-24','13:50:00',3.29),('16273','2013-09-24','13:55:00',3.28),('16273','2013-09-24','14:00:00',3.24),('16273','2013-09-24','14:05:00',3.22),('16273','2013-09-24','14:10:00',3.15),('16273','2013-09-24','14:15:00',3.12),('16273','2013-09-24','14:20:00',3.08),('16273','2013-09-24','14:25:00',3.04),('16273','2013-09-24','14:30:00',3.01),('16273','2013-09-24','14:35:00',2.95),('16273','2013-09-24','14:40:00',2.91),('16273','2013-09-24','14:45:00',2.86),('16273','2013-09-24','14:50:00',2.81),('16273','2013-09-24','14:55:00',2.74),('16273','2013-09-24','15:00:00',2.7),('16273','2013-09-24','15:05:00',2.66),('16273','2013-09-24','15:10:00',2.57),('16273','2013-09-24','15:15:00',2.53),('16273','2013-09-24','15:20:00',2.47),('16273','2013-09-24','15:25:00',2.42),('16273','2013-09-24','15:30:00',2.36),('16273','2013-09-24','15:35:00',2.3),('16273','2013-09-24','15:40:00',2.23),('16273','2013-09-24','15:45:00',2.14),('16273','2013-09-24','15:50:00',2.08),('16273','2013-09-24','15:55:00',2.01),('16273','2013-09-24','16:00:00',1.93),('16273','2013-09-24','16:05:00',1.83),('16273','2013-09-24','16:10:00',1.77),('16273','2013-09-24','16:15:00',1.67),('16273','2013-09-24','16:20:00',1.63),('16273','2013-09-24','16:25:00',1.53),('16273','2013-09-24','16:30:00',1.46),('16273','2013-09-24','16:35:00',1.41),('16273','2013-09-24','16:40:00',1.34),('16273','2013-09-24','16:45:00',1.27),('16273','2013-09-24','16:50:00',1.19),('16273','2013-09-24','16:55:00',1.12),('16273','2013-09-24','17:00:00',1.05),('16273','2013-09-23','08:00:00',1.02),('16273','2013-09-23','08:05:00',1.14),('16273','2013-09-23','08:10:00',1.25),('16273','2013-09-23','08:15:00',1.15),('16273','2013-09-23','08:20:00',1.49),('16273','2013-09-23','08:25:00',1.61),('16273','2013-09-23','08:30:00',1.71),('16273','2013-09-23','08:35:00',1.81),('16273','2013-09-23','08:40:00',1.9),('16273','2013-09-23','08:45:00',1.99),('16273','2013-09-23','08:50:00',2.06),('16273','2013-09-23','08:55:00',2.14),('16273','2013-09-23','09:00:00',2.22),('16273','2013-09-23','09:05:00',2.29),('16273','2013-09-23','09:10:00',2.36),('16273','2013-09-23','09:15:00',2.43),('16273','2013-09-23','09:20:00',2.5),('16273','2013-09-23','09:25:00',2.57),('16273','2013-09-23','09:30:00',2.62),('16273','2013-09-23','09:35:00',2.68),('16273','2013-09-23','09:40:00',2.75),('16273','2013-09-23','09:45:00',2.81),('16273','2013-09-23','09:50:00',2.86),('16273','2013-09-23','09:55:00',2.92),('16273','2013-09-23','10:00:00',2.97),('16273','2013-09-23','10:05:00',3.02),('16273','2013-09-23','10:10:00',3.07),('16273','2013-09-23','10:15:00',3.11),('16273','2013-09-23','10:20:00',3.15),('16273','2013-09-23','10:25:00',3.2),('16273','2013-09-23','10:30:00',3.22),('16273','2013-09-23','10:35:00',3.24),('16273','2013-09-23','10:40:00',3.27),('16273','2013-09-23','10:45:00',3.29),('16273','2013-09-23','10:50:00',3.32),('16273','2013-09-23','10:55:00',3.34),('16273','2013-09-23','11:00:00',3.39),('16273','2013-09-23','11:05:00',3.41),('16273','2013-09-23','11:10:00',3.46),('16273','2013-09-23','11:15:00',3.49),('16273','2013-09-23','11:20:00',3.52),('16273','2013-09-23','11:25:00',3.54),('16273','2013-09-23','11:30:00',3.54),('16273','2013-09-23','11:35:00',3.59),('16273','2013-09-23','11:40:00',3.59),('16273','2013-09-23','11:45:00',3.61),('16273','2013-09-23','11:50:00',3.64),('16273','2013-09-23','11:55:00',3.62),('16273','2013-09-23','12:00:00',3.58),('16273','2013-09-23','12:05:00',3.6),('16273','2013-09-23','12:10:00',3.65),('16273','2013-09-23','12:15:00',3.68),('16273','2013-09-23','12:20:00',3.66),('16273','2013-09-23','12:25:00',3.66),('16273','2013-09-23','12:30:00',3.64),('16273','2013-09-23','12:35:00',3.62),('16273','2013-09-23','12:40:00',3.61),('16273','2013-09-23','12:45:00',3.63),('16273','2013-09-23','12:50:00',3.6),('16273','2013-09-23','12:55:00',3.54),('16273','2013-09-23','13:00:00',3.52),('16273','2013-09-23','13:05:00',3.44),('16273','2013-09-23','13:10:00',3.48),('16273','2013-09-23','13:15:00',3.47),('16273','2013-09-23','13:20:00',3.44),('16273','2013-09-23','13:25:00',3.42),('16273','2013-09-23','13:30:00',3.4),('16273','2013-09-23','13:35:00',3.36),('16273','2013-09-23','13:40:00',3.31),('16273','2013-09-23','13:45:00',3.28),('16273','2013-09-23','13:50:00',3.24),('16273','2013-09-23','13:55:00',3.2),('16273','2013-09-23','14:00:00',3.19),('16273','2013-09-23','14:05:00',3.15),('16273','2013-09-23','14:10:00',3.09),('16273','2013-09-23','14:15:00',3.06),('16273','2013-09-23','14:20:00',3.03),('16273','2013-09-23','14:25:00',2.98),('16273','2013-09-23','14:30:00',2.93),('16273','2013-09-23','14:35:00',2.91),('16273','2013-09-23','14:40:00',2.83),('16273','2013-09-23','14:45:00',2.77),('16273','2013-09-23','14:50:00',2.73),('16273','2013-09-23','14:55:00',2.65),('16273','2013-09-23','15:00:00',2.64),('16273','2013-09-23','15:05:00',2.61),('16273','2013-09-23','15:10:00',2.55),('16273','2013-09-23','15:15:00',2.49),('16273','2013-09-23','15:20:00',2.41),('16273','2013-09-23','15:25:00',2.36),('16273','2013-09-23','15:30:00',2.32),('16273','2013-09-23','15:35:00',2.27),('16273','2013-09-23','15:40:00',2.22),('16273','2013-09-23','15:45:00',2.09),('16273','2013-09-23','15:50:00',2.03),('16273','2013-09-23','15:55:00',1.99),('16273','2013-09-23','16:00:00',1.88),('16273','2013-09-23','16:05:00',1.83),('16273','2013-09-23','16:10:00',1.73),('16273','2013-09-23','16:15:00',1.68),('16273','2013-09-23','16:20:00',1.62),('16273','2013-09-23','16:25:00',1.52),('16273','2013-09-23','16:30:00',1.45),('16273','2013-09-23','16:35:00',1.38),('16273','2013-09-23','16:40:00',1.31),('16273','2013-09-23','16:45:00',1.25),('16273','2013-09-23','16:50:00',1.18),('16273','2013-09-23','16:55:00',1.11),('16273','2013-09-23','17:00:00',1.03),('16273','2013-09-22','08:25:00',1.35),('16273','2013-09-22','08:30:00',1.66),('16273','2013-09-22','08:35:00',1.75),('16273','2013-09-22','08:40:00',1.84),('16273','2013-09-22','08:45:00',1.93),('16273','2013-09-22','08:50:00',2.02),('16273','2013-09-22','08:55:00',2.1),('16273','2013-09-22','09:00:00',2.17),('16273','2013-09-22','09:05:00',2.22),('16273','2013-09-22','09:10:00',2.32),('16273','2013-09-22','09:15:00',2.39),('16273','2013-09-22','09:20:00',2.47),('16273','2013-09-22','09:25:00',2.54),('16273','2013-09-22','09:30:00',2.61),('16273','2013-09-22','09:35:00',2.65),('16273','2013-09-22','09:40:00',2.72),('16273','2013-09-22','09:45:00',2.79),('16273','2013-09-22','09:50:00',2.86),('16273','2013-09-22','09:55:00',2.92),('16273','2013-09-22','10:00:00',2.98),('16273','2013-09-22','10:05:00',3.03),('16273','2013-09-22','10:10:00',3.1),('16273','2013-09-22','10:15:00',3.14),('16273','2013-09-22','10:20:00',3.19),('16273','2013-09-22','10:25:00',3.23),('16273','2013-09-22','10:30:00',3.29),('16273','2013-09-22','10:35:00',3.34),('16273','2013-09-22','10:40:00',3.37),('16273','2013-09-22','10:45:00',3.39),('16273','2013-09-22','10:50:00',3.43),('16273','2013-09-22','10:55:00',3.45),('16273','2013-09-22','11:00:00',3.51),('16273','2013-09-22','11:05:00',3.54),('16273','2013-09-22','11:10:00',3.54),('16273','2013-09-22','11:15:00',3.56),('16273','2013-09-22','11:20:00',3.61),('16273','2013-09-22','11:25:00',3.6),('16273','2013-09-22','11:30:00',3.62),('16273','2013-09-22','11:35:00',3.64),('16273','2013-09-22','11:40:00',3.64),('16273','2013-09-22','11:45:00',3.63),('16273','2013-09-22','11:50:00',3.63),('16273','2013-09-22','11:55:00',3.63),('16273','2013-09-22','12:00:00',3.64),('16273','2013-09-22','12:05:00',3.66),('16273','2013-09-22','12:10:00',3.67),('16273','2013-09-22','12:15:00',3.68),('16273','2013-09-22','12:20:00',3.68),('16273','2013-09-22','12:25:00',3.69),('16273','2013-09-22','12:30:00',3.68),('16273','2013-09-22','12:35:00',3.66),('16273','2013-09-22','12:40:00',3.64),('16273','2013-09-22','12:45:00',3.65),('16273','2013-09-22','12:50:00',3.65),('16273','2013-09-22','12:55:00',3.64),('16273','2013-09-22','13:00:00',3.62),('16273','2013-09-22','13:05:00',3.6),('16273','2013-09-22','13:10:00',3.58),('16273','2013-09-22','13:15:00',3.57),('16273','2013-09-22','13:20:00',3.57),('16273','2013-09-22','13:25:00',3.54),('16273','2013-09-22','13:30:00',3.53),('16273','2013-09-22','13:35:00',3.53),('16273','2013-09-22','13:40:00',3.51),('16273','2013-09-22','13:45:00',3.51),('16273','2013-09-22','13:50:00',3.57),('16273','2013-09-22','13:55:00',3.59),('16273','2013-09-22','14:00:00',3.39),('16273','2013-09-22','14:05:00',3.4),('16273','2013-09-22','14:10:00',2.5),('16273','2013-09-22','14:15:00',3.3),('16273','2013-09-22','14:20:00',3.3),('16273','2013-09-22','14:25:00',3.41),('16273','2013-09-22','14:30:00',3.54),('16273','2013-09-22','14:35:00',1.86),('16273','2013-09-22','14:40:00',1.27),('16273','2013-09-22','14:45:00',1.84),('16273','2013-09-22','14:50:00',2.6),('16273','2013-09-22','14:55:00',3.01),('16273','2013-09-22','15:00:00',1.92),('16273','2013-09-22','15:05:00',1.48),('16273','2013-09-22','15:10:00',1.56),('16273','2013-09-22','15:15:00',1.79),('16273','2013-09-22','15:20:00',2.25),('16273','2013-09-22','15:25:00',2.55),('16273','2013-09-22','15:30:00',1.09),('16273','2013-09-22','15:40:00',1.41),('16273','2013-09-22','15:45:00',2.34),('16273','2013-09-22','15:50:00',2.22),('16273','2013-09-22','15:55:00',1.8),('16273','2013-09-22','16:00:00',1.22),('16273','2013-09-22','16:10:00',1.49),('16273','2013-09-22','16:15:00',1.84),('16273','2013-09-22','16:20:00',1.48),('16273','2013-09-22','16:25:00',1.1),('16273','2013-09-22','16:40:00',1.06),('16273','2013-09-22','16:50:00',1.05),('16273','2013-09-22','17:00:00',1.05),('16273','2013-09-21','08:05:00',1.09),('16273','2013-09-21','08:10:00',1.21),('16273','2013-09-21','08:15:00',1.15),('16273','2013-09-21','08:20:00',1.46),('16273','2013-09-21','08:25:00',1.56),('16273','2013-09-21','08:30:00',1.67),('16273','2013-09-21','08:35:00',1.73),('16273','2013-09-21','08:40:00',1.82),('16273','2013-09-21','08:45:00',1.9),('16273','2013-09-21','08:50:00',1.99),('16273','2013-09-21','08:55:00',2.08),('16273','2013-09-21','09:00:00',2.15),('16273','2013-09-21','09:05:00',2.22),('16273','2013-09-21','09:10:00',2.3),('16273','2013-09-21','09:15:00',2.37),('16273','2013-09-21','09:20:00',2.42),('16273','2013-09-21','09:25:00',2.48),('16273','2013-09-21','09:30:00',2.54),('16273','2013-09-21','09:35:00',2.59),('16273','2013-09-21','09:40:00',2.64),('16273','2013-09-21','09:45:00',2.7),('16273','2013-09-21','09:50:00',2.75),('16273','2013-09-21','09:55:00',2.84),('16273','2013-09-21','10:00:00',2.89),('16273','2013-09-21','10:05:00',2.94),('16273','2013-09-21','10:10:00',2.99),('16273','2013-09-21','10:15:00',3.03),('16273','2013-09-21','10:20:00',3.05),('16273','2013-09-21','10:25:00',3.11),('16273','2013-09-21','10:30:00',3.13),('16273','2013-09-21','10:35:00',3.17),('16273','2013-09-21','10:40:00',3.21),('16273','2013-09-21','10:45:00',3.22),('16273','2013-09-21','10:50:00',3.26),('16273','2013-09-21','10:55:00',3.28),('16273','2013-09-21','11:00:00',3.31),('16273','2013-09-21','11:05:00',3.33),('16273','2013-09-21','11:10:00',3.35),('16273','2013-09-21','11:15:00',3.38),('16273','2013-09-21','11:20:00',3.4),('16273','2013-09-21','11:25:00',3.42),('16273','2013-09-21','11:30:00',3.45),('16273','2013-09-21','11:35:00',3.46),('16273','2013-09-21','11:40:00',3.48),('16273','2013-09-21','11:45:00',3.48),('16273','2013-09-21','11:50:00',3.44),('16273','2013-09-21','11:55:00',3.52),('16273','2013-09-21','12:00:00',3.53),('16273','2013-09-21','12:05:00',3.52),('16273','2013-09-21','12:10:00',3.56),('16273','2013-09-21','12:15:00',3.51),('16273','2013-09-21','12:20:00',3.26),('16273','2013-09-21','12:25:00',3.63),('16273','2013-09-21','12:30:00',3.49),('16273','2013-09-21','12:35:00',3.28),('16273','2013-09-21','12:40:00',3.48),('16273','2013-09-21','12:45:00',3.51),('16273','2013-09-21','12:50:00',3.57),('16273','2013-09-21','12:55:00',3.52),('16273','2013-09-21','13:00:00',3.5),('16273','2013-09-21','13:05:00',3.56),('16273','2013-09-21','13:10:00',3.55),('16273','2013-09-21','13:15:00',2.88),('16273','2013-09-21','13:20:00',3.53),('16273','2013-09-21','13:25:00',3.3),('16273','2013-09-21','13:30:00',3.3),('16273','2013-09-21','13:35:00',2.92),('16273','2013-09-21','13:40:00',2.88),('16273','2013-09-21','13:45:00',3.03),('16273','2013-09-21','13:50:00',2.97),('16273','2013-09-21','13:55:00',3.16),('16273','2013-09-21','14:00:00',3.15),('16273','2013-09-21','14:05:00',3),('16273','2013-09-21','14:10:00',3.11),('16273','2013-09-21','14:15:00',3.07),('16273','2013-09-21','14:20:00',3),('16273','2013-09-21','14:25:00',2.95),('16273','2013-09-21','14:30:00',2.89),('16273','2013-09-21','14:35:00',2.81),('16273','2013-09-21','14:40:00',2.78),('16273','2013-09-21','14:45:00',2.76),('16273','2013-09-21','14:50:00',2.7),('16273','2013-09-21','14:55:00',2.65),('16273','2013-09-21','15:00:00',2.62),('16273','2013-09-21','15:05:00',2.51),('16273','2013-09-21','15:10:00',2.5),('16273','2013-09-21','15:15:00',2.44),('16273','2013-09-21','15:20:00',2.37),('16273','2013-09-21','15:25:00',2.32),('16273','2013-09-21','15:30:00',2.27),('16273','2013-09-21','15:35:00',2.21),('16273','2013-09-21','15:40:00',1.94),('16273','2013-09-21','15:45:00',2.11),('16273','2013-09-21','15:50:00',1.92),('16273','2013-09-21','15:55:00',1.46),('16273','2013-09-21','16:00:00',1.04),('16273','2013-09-21','16:05:00',1.2),('16273','2013-09-21','16:10:00',1.18),('16273','2013-09-21','16:15:00',1.2),('16273','2013-09-21','16:25:00',1.04),('16273','2013-09-21','16:30:00',1.14),('16273','2013-09-20','08:25:00',1.25),('16273','2013-09-20','08:30:00',2.01),('16273','2013-09-20','08:35:00',2.28),('16273','2013-09-20','08:40:00',2.02),('16273','2013-09-20','08:45:00',1.02),('16273','2013-09-20','08:50:00',1.1),('16273','2013-09-20','09:40:00',1.01),('16273','2013-09-20','09:45:00',1.09),('16273','2013-09-20','09:50:00',1.15),('16273','2013-09-20','09:55:00',1.21),('16273','2013-09-20','10:00:00',1.3),('16273','2013-09-20','10:05:00',1.42),('16273','2013-09-20','10:10:00',1.57),('16273','2013-09-20','10:15:00',2.41),('16273','2013-09-20','10:20:00',2.33),('16273','2013-09-20','10:25:00',2.54),('16273','2013-09-20','10:30:00',1.9),('16273','2013-09-20','10:35:00',1.9),('16273','2013-09-20','10:40:00',1.91),('16273','2013-09-20','10:45:00',1.96),('16273','2013-09-20','10:50:00',1.92),('16273','2013-09-20','10:55:00',2.04),('16273','2013-09-20','11:00:00',1.93),('16273','2013-09-20','11:05:00',1.95),('16273','2013-09-20','11:10:00',2.03),('16273','2013-09-20','11:15:00',2.3),('16273','2013-09-20','11:20:00',2.66),('16273','2013-09-20','11:25:00',3.79),('16273','2013-09-20','11:30:00',3.3),('16273','2013-09-20','11:35:00',4.37),('16273','2013-09-20','11:40:00',4.01),('16273','2013-09-20','11:45:00',3.98),('16273','2013-09-20','11:50:00',3.92),('16273','2013-09-20','11:55:00',3.77),('16273','2013-09-20','12:00:00',3.73),('16273','2013-09-20','12:05:00',3.73),('16273','2013-09-20','12:10:00',3.85),('16273','2013-09-20','12:15:00',2.88),('16273','2013-09-20','12:20:00',2.09),('16273','2013-09-20','12:25:00',3.78),('16273','2013-09-20','12:30:00',3.05),('16273','2013-09-20','12:35:00',3.49),('16273','2013-09-20','12:40:00',3.74),('16273','2013-09-20','12:45:00',3.69),('16273','2013-09-20','12:50:00',3.57),('16273','2013-09-20','12:55:00',3.44),('16273','2013-09-20','13:00:00',3.45),('16273','2013-09-20','13:05:00',3.45),('16273','2013-09-20','13:10:00',3.42),('16273','2013-09-20','13:15:00',3.41),('16273','2013-09-20','13:20:00',3.43),('16273','2013-09-20','13:25:00',3.48),('16273','2013-09-20','13:30:00',3.42),('16273','2013-09-20','13:35:00',3.48),('16273','2013-09-20','13:40:00',3.36),('16273','2013-09-20','13:45:00',2.97),('16273','2013-09-20','13:50:00',1.83),('16273','2013-09-20','13:55:00',2.08),('16273','2013-09-20','14:30:00',1.06),('16273','2013-09-20','14:35:00',1.26),('16273','2013-09-20','14:40:00',1.17),('16273','2013-09-20','14:45:00',2.58),('16273','2013-09-20','14:50:00',2.85),('16273','2013-09-20','14:55:00',1.37),('16273','2013-09-20','15:00:00',1.12),('16273','2013-09-20','15:05:00',1.2),('16273','2013-09-20','15:10:00',1.52),('16273','2013-09-20','15:15:00',1.87),('16273','2013-09-20','15:20:00',1.99),('16273','2013-09-20','15:25:00',1.33),('16273','2013-09-20','15:45:00',1.1),('16273','2013-09-20','15:55:00',1.14),('16273','2013-09-20','16:15:00',1.29),('16273','2013-09-20','16:20:00',1.17),('16273','2013-09-20','16:25:00',1.6),('16273','2013-09-20','16:30:00',1.87),('16273','2013-09-20','16:35:00',1.9),('16273','2013-09-20','16:40:00',1.75),('16273','2013-09-20','16:45:00',1.66),('16273','2013-09-20','16:50:00',1.3),('16273','2013-09-20','17:05:00',1.03),('16273','2013-09-20','17:10:00',1.11),('16273','2013-09-20','17:15:00',1.09),('16273','2013-09-20','17:20:00',1.01),('16273','2013-09-20','17:35:00',1.02),('16273','2013-09-20','17:50:00',1.02),('16273','2013-09-19','08:15:00',1.02),('16273','2013-09-19','08:20:00',1.46),('16273','2013-09-19','08:25:00',1.69),('16273','2013-09-19','08:30:00',1.78),('16273','2013-09-19','08:35:00',1.07),('16273','2013-09-19','08:40:00',1.55),('16273','2013-09-19','08:45:00',1.05),('16273','2013-09-19','08:50:00',2.08),('16273','2013-09-19','08:55:00',1.3),('16273','2013-09-19','09:00:00',2.02),('16273','2013-09-19','09:05:00',1.78),('16273','2013-09-19','09:10:00',2.28),('16273','2013-09-19','09:15:00',1.21),('16273','2013-09-19','09:20:00',1.14),('16273','2013-09-19','09:35:00',2.67),('16273','2013-09-19','09:40:00',2.9),('16273','2013-09-19','09:45:00',2.65),('16273','2013-09-19','09:50:00',2.25),('16273','2013-09-19','09:55:00',3.07),('16273','2013-09-19','10:00:00',1.7),('16273','2013-09-19','10:05:00',2.65),('16273','2013-09-19','10:10:00',1.65),('16273','2013-09-19','10:15:00',2.2),('16273','2013-09-19','10:20:00',1.17),('16273','2013-09-19','10:40:00',1.32),('16273','2013-09-19','10:50:00',2.68),('16273','2013-09-19','10:55:00',3.51),('16273','2013-09-19','11:00:00',1.42),('16273','2013-09-19','11:15:00',1.04),('16273','2013-09-19','11:20:00',2.49),('16273','2013-09-19','11:25:00',2.13),('16273','2013-09-19','11:30:00',2.59),('16273','2013-09-19','11:35:00',2.9),('16273','2013-09-19','11:40:00',2.38),('16273','2013-09-19','11:45:00',2.23),('16273','2013-09-19','11:50:00',2.36),('16273','2013-09-19','11:55:00',1.49),('16273','2013-09-19','12:00:00',2.2),('16273','2013-09-19','12:10:00',1.18),('16273','2013-09-19','12:15:00',3.41),('16273','2013-09-19','12:20:00',3.65),('16273','2013-09-19','12:25:00',3.95),('16273','2013-09-19','12:30:00',3.95),('16273','2013-09-19','12:35:00',3.76),('16273','2013-09-19','12:40:00',3.73),('16273','2013-09-19','12:45:00',2.73),('16273','2013-09-19','12:50:00',1.14),('16273','2013-09-19','12:55:00',2.39),('16273','2013-09-19','13:00:00',2.64),('16273','2013-09-19','13:05:00',3.54),('16273','2013-09-19','13:10:00',4.11),('16273','2013-09-19','13:15:00',2.68),('16273','2013-09-19','13:20:00',1.71),('16273','2013-09-19','13:25:00',2.67),('16273','2013-09-19','13:30:00',2.23),('16273','2013-09-19','13:35:00',2.87),('16273','2013-09-19','13:40:00',3.75),('16273','2013-09-19','13:45:00',3.8),('16273','2013-09-19','13:50:00',3.77),('16273','2013-09-19','13:55:00',2.48),('16273','2013-09-19','14:00:00',2.58),('16273','2013-09-19','14:05:00',3.55),('16273','2013-09-19','14:10:00',3.29),('16273','2013-09-19','14:15:00',3.26),('16273','2013-09-19','14:20:00',2.85),('16273','2013-09-19','14:25:00',3.12),('16273','2013-09-19','14:30:00',3.07),('16273','2013-09-19','14:35:00',3.1),('16273','2013-09-19','14:40:00',2.69),('16273','2013-09-19','14:45:00',3.03),('16273','2013-09-19','14:50:00',3.08),('16273','2013-09-19','14:55:00',3.01),('16273','2013-09-19','15:00:00',2.81),('16273','2013-09-19','15:05:00',2.4),('16273','2013-09-19','15:10:00',1.98),('16273','2013-09-19','15:15:00',1.93),('16273','2013-09-19','15:20:00',2.71),('16273','2013-09-19','15:25:00',2.53),('16273','2013-09-19','15:30:00',1.55),('16273','2013-09-19','15:35:00',1.64),('16273','2013-09-19','15:40:00',1.21),('16273','2013-09-19','15:45:00',1.97),('16273','2013-09-19','15:50:00',1.9),('16273','2013-09-19','16:00:00',1.24),('16273','2013-09-19','16:10:00',1.22),('16273','2013-09-19','16:15:00',1.55),('16273','2013-09-19','16:20:00',1.78),('16273','2013-09-19','16:25:00',1.55),('16273','2013-09-19','16:30:00',1.56),('16273','2013-09-19','16:35:00',1.5),('16273','2013-09-19','16:40:00',1.45),('16273','2013-09-19','16:45:00',1.36),('16273','2013-09-19','16:55:00',1.16),('16273','2013-09-19','17:05:00',1.1),('16273','2013-09-19','17:10:00',1.04),('16273','2014-04-13','09:35:00',1.09),('16273','2014-04-13','09:40:00',1.17),('16273','2014-04-13','09:45:00',1.27),('16273','2014-04-13','09:50:00',1.67),('16273','2014-04-13','09:55:00',1.67),('16273','2014-04-13','10:00:00',2.17),('16273','2014-04-13','10:05:00',2.38),('16273','2014-04-13','10:10:00',2.76),('16273','2014-04-13','10:15:00',2.08),('16273','2014-04-13','10:20:00',2.32),('16273','2014-04-13','10:25:00',2.31),('16273','2014-04-13','10:30:00',2.89),('16273','2014-04-13','10:35:00',2.94),('16273','2014-04-13','10:40:00',3.25),('16273','2014-04-13','10:45:00',2.56),('16273','2014-04-13','10:50:00',3.6),('16273','2014-04-13','10:55:00',3.42),('16273','2014-04-13','11:00:00',1.4),('16273','2014-04-13','11:05:00',2.76),('16273','2014-04-13','11:10:00',3.09),('16273','2014-04-13','11:15:00',2.14),('16273','2014-04-13','11:20:00',1.59),('16273','2014-04-13','11:25:00',1.21),('16273','2014-04-13','11:30:00',1.78),('16273','2014-04-13','11:35:00',3.18),('16273','2014-04-13','11:40:00',2),('16273','2014-04-13','11:45:00',1.47),('16273','2014-04-13','11:50:00',1.87),('16273','2014-04-13','11:55:00',1.93),('16273','2014-04-13','12:00:00',2.03),('16273','2014-04-13','12:05:00',1.8),('16273','2014-04-13','12:10:00',2.28),('16273','2014-04-13','12:50:00',1.09),('16273','2014-04-13','12:55:00',1.47),('16273','2014-04-13','13:00:00',1.87),('16273','2014-04-13','13:05:00',3.67),('16273','2014-04-13','13:10:00',4.02),('16273','2014-04-13','13:15:00',3.83),('16273','2014-04-13','13:20:00',3.63),('16273','2014-04-13','13:25:00',3.3),('16273','2014-04-13','13:30:00',3.24),('16273','2014-04-13','13:35:00',3.27),('16273','2014-04-13','13:40:00',2.53),('16273','2014-04-13','13:45:00',2.25),('16273','2014-04-13','13:50:00',1.72),('16273','2014-04-13','13:55:00',1.73),('16273','2014-04-13','14:00:00',1.85),('16273','2014-04-13','14:05:00',2.77),('16273','2014-04-13','14:10:00',2.82),('16273','2014-04-13','14:15:00',1.57),('16273','2014-04-13','14:20:00',1.63),('16273','2014-04-13','14:25:00',1.82),('16273','2014-04-13','14:30:00',1.39),('16273','2014-04-13','14:35:00',1.47),('16273','2014-04-13','14:40:00',1.47),('16273','2014-04-13','14:45:00',2.72),('16273','2014-04-13','14:50:00',2.84),('16273','2014-04-13','14:55:00',3.37),('16273','2014-04-13','15:00:00',3.3),('16273','2014-04-13','15:05:00',2.92),('16273','2014-04-13','15:10:00',2.72),('16273','2014-04-13','15:15:00',3.01),('16273','2014-04-13','15:20:00',2.98),('16273','2014-04-13','15:25:00',2.86),('16273','2014-04-13','15:30:00',1.93),('16273','2014-04-13','15:35:00',1.75),('16273','2014-04-13','15:40:00',1.9),('16273','2014-04-13','15:45:00',2.17),('16273','2014-04-13','15:50:00',1.73),('16273','2014-04-13','15:55:00',1.38),('16273','2014-04-13','16:00:00',1.34),('16273','2014-04-13','16:05:00',1.17),('16273','2014-04-13','16:10:00',1.05),('16273','2014-04-13','16:15:00',1.16),('16273','2014-04-13','16:20:00',1.19),('16273','2014-04-13','16:25:00',1.02),('16273','2014-04-13','16:30:00',1.17),('16273','2014-04-13','16:35:00',1.65),('16273','2014-04-13','16:40:00',2.17),('16273','2014-04-13','16:45:00',1.45),('16273','2014-04-13','16:50:00',1.74),('16273','2014-04-13','16:55:00',1.62),('16273','2014-04-13','17:00:00',1.27),('16273','2014-04-13','17:05:00',1.33),('16273','2014-04-13','17:10:00',1.28),('16273','2014-04-13','17:15:00',1.03),('16273','2013-09-18','08:05:00',1.03),('16273','2013-09-18','08:10:00',1.02),('16273','2013-09-18','08:15:00',1.27),('16273','2013-09-18','08:20:00',1.03),('16273','2013-09-18','08:25:00',1.38),('16273','2013-09-18','08:30:00',1.77),('16273','2013-09-18','08:35:00',1.75),('16273','2013-09-18','08:40:00',1.49),('16273','2013-09-18','08:45:00',1.81),('16273','2013-09-18','08:50:00',1.26),('16273','2013-09-18','08:55:00',1.52),('16273','2013-09-18','09:00:00',1.1),('16273','2013-09-18','09:05:00',1.18),('16273','2013-09-18','09:10:00',1.21),('16273','2013-09-18','09:15:00',2.1),('16273','2013-09-18','09:20:00',1.66),('16273','2013-09-18','09:25:00',1.73),('16273','2013-09-18','09:30:00',1.43),('16273','2013-09-18','09:40:00',1.34),('16273','2013-09-18','09:45:00',1.42),('16273','2013-09-18','09:50:00',2.87),('16273','2013-09-18','09:55:00',2.98),('16273','2013-09-18','10:00:00',2.93),('16273','2013-09-18','10:05:00',2.94),('16273','2013-09-18','10:10:00',2.96),('16273','2013-09-18','10:15:00',2.97),('16273','2013-09-18','10:20:00',3.05),('16273','2013-09-18','10:25:00',3.1),('16273','2013-09-18','10:30:00',3.14),('16273','2013-09-18','10:35:00',3.16),('16273','2013-09-18','10:40:00',3.23),('16273','2013-09-18','10:45:00',3.24),('16273','2013-09-18','10:50:00',3.3),('16273','2013-09-18','10:55:00',3.37),('16273','2013-09-18','11:00:00',3.37),('16273','2013-09-18','11:05:00',3.05),('16273','2013-09-18','11:10:00',2.61),('16273','2013-09-18','11:15:00',3.62),('16273','2013-09-18','11:20:00',3.66),('16273','2013-09-18','11:25:00',3.67),('16273','2013-09-18','11:30:00',3.62),('16273','2013-09-18','11:35:00',3.7),('16273','2013-09-18','11:40:00',3.79),('16273','2013-09-18','11:45:00',3.7),('16273','2013-09-18','11:50:00',3.74),('16273','2013-09-18','11:55:00',3.62),('16273','2013-09-18','12:00:00',2.55),('16273','2013-09-18','12:05:00',3.72),('16273','2013-09-18','12:10:00',3.41),('16273','2013-09-18','12:15:00',2.5),('16273','2013-09-18','12:20:00',4.14),('16273','2013-09-18','12:25:00',4.06),('16273','2013-09-18','12:30:00',3.5),('16273','2013-09-18','12:35:00',3.97),('16273','2013-09-18','12:40:00',3.93),('16273','2013-09-18','12:45:00',3.56),('16273','2013-09-18','12:50:00',3.37),('16273','2013-09-18','12:55:00',3.78),('16273','2013-09-18','13:00:00',2.79),('16273','2013-09-18','13:05:00',2.71),('16273','2013-09-18','13:10:00',2.69),('16273','2013-09-18','13:20:00',1.1),('16273','2013-09-18','13:25:00',2.57),('16273','2013-09-18','13:30:00',1.11),('16273','2013-09-18','13:35:00',3.64),('16273','2013-09-18','13:40:00',2.86),('16273','2013-09-18','13:45:00',3.85),('16273','2013-09-18','13:50:00',3.68),('16273','2013-09-18','13:55:00',3.52),('16273','2013-09-18','14:00:00',3.54),('16273','2013-09-18','14:05:00',3.56),('16273','2013-09-18','14:10:00',2.73),('16273','2013-09-18','14:15:00',2.47),('16273','2013-09-18','14:20:00',3.35),('16273','2013-09-18','14:25:00',3.26),('16273','2013-09-18','14:30:00',3.23),('16273','2013-09-18','14:35:00',3.27),('16273','2013-09-18','14:40:00',3.33),('16273','2013-09-18','14:45:00',3.19),('16273','2013-09-18','14:50:00',2.72),('16273','2013-09-18','14:55:00',2.79),('16273','2013-09-18','15:00:00',2.53),('16273','2013-09-18','15:05:00',1.07),('16273','2013-09-18','15:15:00',2.61),('16273','2013-09-18','15:20:00',2.03),('16273','2013-09-18','15:25:00',2.66),('16273','2013-09-18','15:30:00',2.65),('16273','2013-09-18','15:35:00',2.59),('16273','2013-09-18','15:40:00',2.48),('16273','2013-09-18','15:45:00',2.24),('16273','2013-09-18','15:50:00',1.97),('16273','2013-09-18','15:55:00',1.49),('16273','2013-09-18','16:00:00',1.89),('16273','2013-09-18','16:05:00',1.06),('16273','2013-09-18','16:10:00',1.86),('16273','2013-09-18','16:15:00',2.06),('16273','2013-09-18','16:20:00',1.4),('16273','2013-09-18','16:25:00',1.52),('16273','2013-09-18','16:30:00',1.37),('16273','2013-09-18','16:35:00',1.5),('16273','2013-09-18','16:40:00',1.42),('16273','2013-09-18','16:45:00',1.11),('16273','2013-09-18','16:55:00',1.26),('16273','2013-09-18','17:00:00',1.11),('16273','2013-09-17','09:25:00',1.06),('16273','2013-09-17','09:40:00',2.23),('16273','2013-09-17','09:45:00',1.49),('16273','2013-09-17','09:50:00',1.24),('16273','2013-09-17','09:55:00',2.28),('16273','2013-09-17','10:00:00',1.57),('16273','2013-09-17','10:05:00',1.28),('16273','2013-09-17','10:20:00',2.29),('16273','2013-09-17','10:25:00',2.99),('16273','2013-09-17','10:30:00',1.98),('16273','2013-09-17','10:35:00',2.18),('16273','2013-09-17','10:40:00',3.83),('16273','2013-09-17','10:45:00',3.85),('16273','2013-09-17','10:50:00',3.17),('16273','2013-09-17','10:55:00',3.08),('16273','2013-09-17','11:00:00',2.03),('16273','2013-09-17','11:05:00',2.86),('16273','2013-09-17','11:10:00',1.94),('16273','2013-09-17','11:15:00',2.19),('16273','2013-09-17','11:20:00',1.55),('16273','2013-09-17','11:25:00',1.38),('16273','2013-09-17','11:30:00',2.07),('16273','2013-09-17','11:35:00',1.45),('16273','2013-09-17','11:40:00',2.26),('16273','2013-09-17','11:45:00',1.17),('16273','2013-09-17','11:50:00',2.92),('16273','2013-09-17','11:55:00',3.89),('16273','2013-09-17','12:00:00',1.84),('16273','2013-09-17','12:05:00',1.67),('16273','2013-09-17','12:10:00',3.23),('16273','2013-09-17','12:15:00',3.22),('16273','2013-09-17','12:20:00',2.25),('16273','2013-09-17','12:25:00',1.64),('16273','2013-09-17','12:30:00',2.88),('16273','2013-09-17','12:35:00',2.09),('16273','2013-09-17','12:40:00',1.54),('16273','2013-09-17','12:45:00',3.61),('16273','2013-09-17','12:50:00',2.48),('16273','2013-09-17','12:55:00',3.09),('16273','2013-09-17','13:00:00',2.93),('16273','2013-09-17','13:05:00',2.08),('16273','2013-09-17','13:10:00',1.65),('16273','2013-09-17','13:15:00',1.52),('16273','2013-09-17','13:20:00',1.28),('16273','2013-09-17','13:25:00',1.54),('16273','2013-09-17','13:30:00',1.26),('16273','2013-09-17','13:35:00',1.32),('16273','2013-09-17','13:40:00',1.14),('16273','2013-09-17','13:45:00',1.11),('16273','2013-09-17','13:50:00',1.26),('16273','2013-09-17','13:55:00',1.38),('16273','2013-09-17','14:00:00',1.14),('16273','2013-09-17','14:05:00',1.78),('16273','2013-09-17','14:10:00',1.45),('16273','2013-09-17','14:15:00',1.19),('16273','2013-09-17','14:20:00',1.42),('16273','2013-09-17','14:25:00',1.22),('16273','2013-09-17','14:30:00',1.23),('16273','2013-09-17','14:50:00',1.52),('16273','2013-09-17','14:55:00',3.19),('16273','2013-09-17','15:00:00',2.88),('16273','2013-09-17','15:05:00',2.51),('16273','2013-09-17','15:10:00',1.58),('16273','2013-09-17','15:15:00',1.77),('16273','2013-09-17','15:20:00',1.59),('16273','2013-09-17','15:25:00',1.21),('16273','2013-09-17','15:40:00',1.33),('16273','2013-09-17','15:45:00',1.24),('16273','2013-09-17','15:50:00',1.13),('16273','2013-09-17','15:55:00',1.62),('16273','2013-09-17','16:00:00',1.86),('16273','2013-09-17','16:05:00',1.31),('16273','2013-09-17','16:10:00',1.48),('16273','2013-09-17','16:35:00',1.15),('16273','2013-09-17','16:40:00',1.19),('16273','2013-09-17','16:45:00',1.08),('16273','2013-09-17','16:55:00',1.13),('16273','2013-09-17','17:00:00',1.43),('16273','2013-09-17','17:05:00',1.44),('16273','2013-09-17','17:10:00',1.32),('16273','2013-09-17','17:15:00',1.16),('16273','2013-09-17','17:20:00',1.31),('16273','2013-09-17','17:25:00',1.17),('16273','2013-09-17','17:30:00',1.18),('16273','2013-09-16','08:05:00',1.06),('16273','2013-09-16','08:10:00',1.11),('16273','2013-09-16','08:20:00',1.47),('16273','2013-09-16','08:25:00',1.38),('16273','2013-09-16','08:30:00',1.69),('16273','2013-09-16','08:35:00',1.79),('16273','2013-09-16','08:40:00',1.87),('16273','2013-09-16','08:45:00',2.07),('16273','2013-09-16','08:50:00',2.36),('16273','2013-09-16','08:55:00',1.78),('16273','2013-09-16','09:05:00',1.1),('16273','2013-09-16','09:10:00',2.4),('16273','2013-09-16','09:15:00',2.45),('16273','2013-09-16','09:20:00',2.49),('16273','2013-09-16','09:25:00',2.55),('16273','2013-09-16','09:30:00',2.6),('16273','2013-09-16','09:35:00',2.66),('16273','2013-09-16','09:40:00',2.74),('16273','2013-09-16','09:45:00',2.86),('16273','2013-09-16','09:50:00',2.96),('16273','2013-09-16','09:55:00',2.69),('16273','2013-09-16','10:00:00',2.3),('16273','2013-09-16','10:05:00',2.66),('16273','2013-09-16','10:10:00',3.17),('16273','2013-09-16','10:15:00',3.21),('16273','2013-09-16','10:20:00',3.31),('16273','2013-09-16','10:25:00',2.52),('16273','2013-09-16','10:30:00',3.48),('16273','2013-09-16','10:35:00',3.44),('16273','2013-09-16','10:40:00',2.64),('16273','2013-09-16','10:45:00',1.11),('16273','2013-09-16','10:50:00',1.44),('16273','2013-09-16','10:55:00',2.12),('16273','2013-09-16','11:00:00',1.05),('16273','2013-09-16','11:05:00',2.21),('16273','2013-09-16','11:10:00',3.54),('16273','2013-09-16','11:25:00',2.83),('16273','2013-09-16','11:30:00',3.87),('16273','2013-09-16','11:35:00',3.96),('16273','2013-09-16','11:40:00',3.87),('16273','2013-09-16','11:45:00',3.89),('16273','2013-09-16','11:50:00',2.83),('16273','2013-09-16','11:55:00',3.96),('16273','2013-09-16','12:00:00',3.81),('16273','2013-09-16','12:05:00',3.94),('16273','2013-09-16','12:10:00',3.95),('16273','2013-09-16','12:15:00',3.94),('16273','2013-09-16','12:20:00',3.83),('16273','2013-09-16','12:25:00',3.64),('16273','2013-09-16','12:30:00',4.05),('16273','2013-09-16','12:35:00',2.73),('16273','2013-09-16','12:40:00',1.4),('16273','2013-09-16','12:45:00',1.08),('16273','2013-09-16','12:50:00',1.52),('16273','2013-09-16','12:55:00',2.12),('16273','2013-09-16','13:00:00',4.08),('16273','2013-09-16','13:05:00',3.8),('16273','2013-09-16','13:10:00',3.71),('16273','2013-09-16','13:15:00',3.75),('16273','2013-09-16','13:20:00',3.6),('16273','2013-09-16','13:25:00',3.59),('16273','2013-09-16','13:30:00',3.57),('16273','2013-09-16','13:35:00',3.64),('16273','2013-09-16','13:40:00',3.75),('16273','2013-09-16','13:45:00',3.87),('16273','2013-09-16','13:50:00',3.67),('16273','2013-09-16','13:55:00',3.42),('16273','2013-09-16','14:00:00',3.37),('16273','2013-09-16','14:05:00',3.33),('16273','2013-09-16','14:10:00',3.29),('16273','2013-09-16','14:15:00',3.24),('16273','2013-09-16','14:20:00',3.2),('16273','2013-09-16','14:25:00',3.17),('16273','2013-09-16','14:30:00',3.13),('16273','2013-09-16','14:35:00',3.05),('16273','2013-09-16','14:40:00',3.05),('16273','2013-09-16','14:45:00',3.04),('16273','2013-09-16','14:50:00',3),('16273','2013-09-16','14:55:00',2.93),('16273','2013-09-16','15:00:00',2.88),('16273','2013-09-16','15:05:00',2.83),('16273','2013-09-16','15:10:00',2.78),('16273','2013-09-16','15:15:00',2.71),('16273','2013-09-16','15:20:00',2.65),('16273','2013-09-16','15:25:00',2.59),('16273','2013-09-16','15:30:00',2.51),('16273','2013-09-16','15:35:00',2.46),('16273','2013-09-16','15:40:00',2.39),('16273','2013-09-16','15:45:00',2.15),('16273','2013-09-16','15:50:00',1.81),('16273','2013-09-16','15:55:00',2.36),('16273','2013-09-16','16:00:00',2.14),('16273','2013-09-16','16:05:00',2.05),('16273','2013-09-16','16:10:00',1.97),('16273','2013-09-16','16:15:00',1.89),('16273','2013-09-16','16:20:00',1.8),('16273','2013-09-16','16:25:00',1.75),('16273','2013-09-16','16:30:00',1.67),('16273','2013-09-16','16:35:00',1.6),('16273','2013-09-16','16:40:00',1.53),('16273','2013-09-16','16:45:00',1.44),('16273','2013-09-16','16:50:00',1.36),('16273','2013-09-16','16:55:00',1.1),('16273','2013-09-16','17:00:00',1.22),('16273','2013-09-16','17:05:00',1.14),('16273','2013-09-15','07:55:00',1.01),('16273','2013-09-15','08:00:00',1.12),('16273','2013-09-15','08:05:00',1.1),('16273','2013-09-15','08:10:00',1.36),('16273','2013-09-15','08:15:00',1.48),('16273','2013-09-15','08:20:00',1.59),('16273','2013-09-15','08:25:00',1.7),('16273','2013-09-15','08:30:00',1.79),('16273','2013-09-15','08:35:00',1.9),('16273','2013-09-15','08:40:00',2),('16273','2013-09-15','08:45:00',2.07),('16273','2013-09-15','08:50:00',1.98),('16273','2013-09-15','08:55:00',2.06),('16273','2013-09-15','09:00:00',2.08),('16273','2013-09-15','09:05:00',2.24),('16273','2013-09-15','09:10:00',2.38),('16273','2013-09-15','09:15:00',2.44),('16273','2013-09-15','09:20:00',2.42),('16273','2013-09-15','09:25:00',2.48),('16273','2013-09-15','09:30:00',2.62),('16273','2013-09-15','09:35:00',2.69),('16273','2013-09-15','09:40:00',2.71),('16273','2013-09-15','09:45:00',2.77),('16273','2013-09-15','09:50:00',2.8),('16273','2013-09-15','09:55:00',2.94),('16273','2013-09-15','10:00:00',2.97),('16273','2013-09-15','10:05:00',2.99),('16273','2013-09-15','10:10:00',2.9),('16273','2013-09-15','10:15:00',2.95),('16273','2013-09-15','10:20:00',3.03),('16273','2013-09-15','10:25:00',2.91),('16273','2013-09-15','10:30:00',2.82),('16273','2013-09-15','10:35:00',3.14),('16273','2013-09-15','10:40:00',3.34),('16273','2013-09-15','10:45:00',3.17),('16273','2013-09-15','10:50:00',3.49),('16273','2013-09-15','10:55:00',3.43),('16273','2013-09-15','11:00:00',1.73),('16273','2013-09-15','11:15:00',2.74),('16273','2013-09-15','11:20:00',2.69),('16273','2013-09-15','11:25:00',3.38),('16273','2013-09-15','11:30:00',1.52),('16273','2013-09-15','11:35:00',1.32),('16273','2013-09-15','11:40:00',3.55),('16273','2013-09-15','11:45:00',3.86),('16273','2013-09-15','11:50:00',4.07),('16273','2013-09-15','11:55:00',4.13),('16273','2013-09-15','12:00:00',4.36),('16273','2013-09-15','12:05:00',3.94),('16273','2013-09-15','12:10:00',2.6),('16273','2013-09-15','12:15:00',1.93),('16273','2013-09-15','12:20:00',1.79),('16273','2013-09-15','12:25:00',1.89),('16273','2013-09-15','12:30:00',1.75),('16273','2013-09-15','12:35:00',1.92),('16273','2013-09-15','12:40:00',1.81),('16273','2013-09-15','12:45:00',1.74),('16273','2013-09-15','12:50:00',1.99),('16273','2013-09-15','12:55:00',1.99),('16273','2013-09-15','13:00:00',1.85),('16273','2013-09-15','13:05:00',1.97),('16273','2013-09-15','13:10:00',2.76),('16273','2013-09-15','13:15:00',1.8),('16273','2013-09-15','13:20:00',1.29),('16273','2013-09-15','13:30:00',2.01),('16273','2013-09-15','13:35:00',2.08),('16273','2013-09-15','13:40:00',1.62),('16273','2013-09-15','13:45:00',2.92),('16273','2013-09-15','13:50:00',1.68),('16273','2013-09-15','13:55:00',2.13),('16273','2013-09-15','14:00:00',1.81),('16273','2013-09-15','14:05:00',1.75),('16273','2013-09-15','14:10:00',1.73),('16273','2013-09-15','14:15:00',1.48),('16273','2013-09-15','14:20:00',1.35),('16273','2013-09-15','14:25:00',1.27),('16273','2013-09-15','14:30:00',1.16),('16273','2013-09-15','14:35:00',1.15),('16273','2013-09-15','14:40:00',1.14),('16273','2013-09-15','14:45:00',1.14),('16273','2013-09-15','14:50:00',1.05),('16273','2013-09-15','14:55:00',1.02),('16273','2013-09-15','15:00:00',1.11),('16273','2013-09-15','15:05:00',1.07),('16273','2013-09-15','15:10:00',1.56),('16273','2013-09-15','15:15:00',1.65),('16273','2013-09-15','15:20:00',1.41),('16273','2013-09-14','08:00:00',1.05),('16273','2013-09-14','08:05:00',1.01),('16273','2013-09-14','08:10:00',1.28),('16273','2013-09-14','08:15:00',1.41),('16273','2013-09-14','08:20:00',1.5),('16273','2013-09-14','08:25:00',1.59),('16273','2013-09-14','08:30:00',1.7),('16273','2013-09-14','08:35:00',1.79),('16273','2013-09-14','08:40:00',1.88),('16273','2013-09-14','08:45:00',1.97),('16273','2013-09-14','08:50:00',2.05),('16273','2013-09-14','08:55:00',2.12),('16273','2013-09-14','09:00:00',2.21),('16273','2013-09-14','09:05:00',2.3),('16273','2013-09-14','09:10:00',2.37),('16273','2013-09-14','09:15:00',2.43),('16273','2013-09-14','09:20:00',2.5),('16273','2013-09-14','09:25:00',2.57),('16273','2013-09-14','09:30:00',2.64),('16273','2013-09-14','09:35:00',2.71),('16273','2013-09-14','09:40:00',2.76),('16273','2013-09-14','09:45:00',2.77),('16273','2013-09-14','09:50:00',2.86),('16273','2013-09-14','09:55:00',2.91),('16273','2013-09-14','10:00:00',2.93),('16273','2013-09-14','10:05:00',2.75),('16273','2013-09-14','10:10:00',2.8),('16273','2013-09-14','10:15:00',3.04),('16273','2013-09-14','10:20:00',3.04),('16273','2013-09-14','10:25:00',3.13),('16273','2013-09-14','10:30:00',3.24),('16273','2013-09-14','10:35:00',2.95),('16273','2013-09-14','10:40:00',2.46),('16273','2013-09-14','10:45:00',2.16),('16273','2013-09-14','10:50:00',2.11),('16273','2013-09-14','10:55:00',3.56),('16273','2013-09-14','11:00:00',3.65),('16273','2013-09-14','11:05:00',1.45),('16273','2013-09-14','11:10:00',3.72),('16273','2013-09-14','11:15:00',3.51),('16273','2013-09-14','11:20:00',3.59),('16273','2013-09-14','11:25:00',3.59),('16273','2013-09-14','11:30:00',2.77),('16273','2013-09-14','11:35:00',3.61),('16273','2013-09-14','11:40:00',3.64),('16273','2013-09-14','11:45:00',3.48),('16273','2013-09-14','11:50:00',3.7),('16273','2013-09-14','11:55:00',3.66),('16273','2013-09-14','12:00:00',3.57),('16273','2013-09-14','12:05:00',3.18),('16273','2013-09-14','12:10:00',3.73),('16273','2013-09-14','12:15:00',3.65),('16273','2013-09-14','12:20:00',2.57),('16273','2013-09-14','12:25:00',3.76),('16273','2013-09-14','12:30:00',3.71),('16273','2013-09-14','12:35:00',3.67),('16273','2013-09-14','12:40:00',3.72),('16273','2013-09-14','12:45:00',3.76),('16273','2013-09-14','12:50:00',3.71),('16273','2013-09-14','12:55:00',3.68),('16273','2013-09-14','13:00:00',3.7),('16273','2013-09-14','13:05:00',3.7),('16273','2013-09-14','13:10:00',3.67),('16273','2013-09-14','13:15:00',3.68),('16273','2013-09-14','13:20:00',3.63),('16273','2013-09-14','13:25:00',3.58),('16273','2013-09-14','13:30:00',3.44),('16273','2013-09-14','13:35:00',3.61),('16273','2013-09-14','13:40:00',4),('16273','2013-09-14','13:45:00',3.75),('16273','2013-09-14','13:50:00',3.94),('16273','2013-09-14','13:55:00',3.73),('16273','2013-09-14','14:00:00',3.42),('16273','2013-09-14','14:05:00',3.28),('16273','2013-09-14','14:10:00',3.31),('16273','2013-09-14','14:15:00',3.24),('16273','2013-09-14','14:20:00',3.19),('16273','2013-09-14','14:25:00',3.15),('16273','2013-09-14','14:30:00',3.11),('16273','2013-09-14','14:35:00',3.09),('16273','2013-09-14','14:40:00',3.03),('16273','2013-09-14','14:45:00',2.99),('16273','2013-09-14','14:50:00',2.95),('16273','2013-09-14','14:55:00',2.86),('16273','2013-09-14','15:00:00',2.83),('16273','2013-09-14','15:05:00',2.79),('16273','2013-09-14','15:10:00',2.74),('16273','2013-09-14','15:15:00',2.68),('16273','2013-09-14','15:20:00',2.63),('16273','2013-09-14','15:25:00',2.57),('16273','2013-09-14','15:30:00',2.51),('16273','2013-09-14','15:35:00',2.46),('16273','2013-09-14','15:40:00',2.38),('16273','2013-09-14','15:45:00',2.32),('16273','2013-09-14','15:50:00',2.25),('16273','2013-09-14','15:55:00',2.18),('16273','2013-09-14','16:00:00',2.12),('16273','2013-09-14','16:05:00',2.03),('16273','2013-09-14','16:10:00',1.96),('16273','2013-09-14','16:15:00',1.89),('16273','2013-09-14','16:20:00',1.83),('16273','2013-09-14','16:25:00',1.76),('16273','2013-09-14','16:30:00',1.68),('16273','2013-09-14','16:35:00',1.6),('16273','2013-09-14','16:40:00',1.52),('16273','2013-09-14','16:45:00',1.45),('16273','2013-09-14','16:50:00',1.39),('16273','2013-09-14','16:55:00',1.31),('16273','2013-09-14','17:00:00',1.23),('16273','2013-09-14','17:05:00',1.14),('16273','2013-09-14','17:10:00',1.12),('16273','2013-09-13','09:25:00',1.02),('16273','2013-09-13','09:30:00',1.11),('16273','2013-09-13','09:35:00',1.17),('16273','2013-09-13','09:40:00',1.31),('16273','2013-09-13','09:45:00',1.4),('16273','2013-09-13','09:50:00',1.3),('16273','2013-09-13','09:55:00',2.28),('16273','2013-09-13','10:00:00',3.34),('16273','2013-09-13','10:05:00',2.64),('16273','2013-09-13','10:10:00',3.38),('16273','2013-09-13','10:15:00',3.53),('16273','2013-09-13','10:20:00',2.37),('16273','2013-09-13','10:25:00',2.83),('16273','2013-09-13','10:30:00',3.36),('16273','2013-09-13','10:35:00',3.27),('16273','2013-09-13','10:40:00',3.31),('16273','2013-09-13','10:45:00',3.34),('16273','2013-09-13','10:50:00',3.34),('16273','2013-09-13','10:55:00',3.38),('16273','2013-09-13','11:00:00',3.4),('16273','2013-09-13','11:05:00',3.44),('16273','2013-09-13','11:10:00',3.47),('16273','2013-09-13','11:15:00',3.49),('16273','2013-09-13','11:20:00',3.52),('16273','2013-09-13','11:25:00',3.55),('16273','2013-09-13','11:30:00',3.55),('16273','2013-09-13','11:35:00',3.57),('16273','2013-09-13','11:40:00',3.55),('16273','2013-09-13','11:45:00',3.56),('16273','2013-09-13','11:50:00',3.5),('16273','2013-09-13','11:55:00',3.58),('16273','2013-09-13','12:00:00',2.76),('16273','2013-09-13','12:05:00',3.68),('16273','2013-09-13','12:10:00',1.72),('16273','2013-09-13','12:15:00',3.87),('16273','2013-09-13','12:20:00',3.82),('16273','2013-09-13','12:25:00',3.82),('16273','2013-09-13','12:30:00',3.81),('16273','2013-09-13','12:35:00',3.8),('16273','2013-09-13','12:40:00',3.8),('16273','2013-09-13','12:45:00',3.66),('16273','2013-09-13','12:50:00',3.67),('16273','2013-09-13','12:55:00',3.63),('16273','2013-09-13','13:00:00',3.6),('16273','2013-09-13','13:05:00',3.66),('16273','2013-09-13','13:10:00',3.62),('16273','2013-09-13','13:15:00',3.63),('16273','2013-09-13','13:20:00',3.59),('16273','2013-09-13','13:25:00',3.57),('16273','2013-09-13','13:30:00',3.48),('16273','2013-09-13','13:35:00',3.43),('16273','2013-09-13','13:40:00',3.46),('16273','2013-09-13','13:45:00',3.45),('16273','2013-09-13','13:50:00',3.42),('16273','2013-09-13','13:55:00',3.37),('16273','2013-09-13','14:00:00',3.32),('16273','2013-09-13','14:05:00',3.32),('16273','2013-09-13','14:10:00',3.26),('16273','2013-09-13','14:15:00',3.26),('16273','2013-09-13','14:20:00',3.23),('16273','2013-09-13','14:25:00',3.23),('16273','2013-09-13','14:30:00',3.18),('16273','2013-09-13','14:35:00',3.13),('16273','2013-09-13','14:40:00',3.07),('16273','2013-09-13','14:45:00',3.05),('16273','2013-09-13','14:50:00',2.97),('16273','2013-09-13','14:55:00',2.93),('16273','2013-09-13','15:00:00',2.9),('16273','2013-09-13','15:05:00',2.84),('16273','2013-09-13','15:10:00',2.78),('16273','2013-09-13','15:15:00',2.73),('16273','2013-09-13','15:20:00',2.66),('16273','2013-09-13','15:25:00',2.59),('16273','2013-09-13','15:30:00',2.55),('16273','2013-09-13','15:35:00',2.5),('16273','2013-09-13','15:40:00',2.43),('16273','2013-09-13','15:45:00',2.36),('16273','2013-09-13','15:50:00',2.3),('16273','2013-09-13','15:55:00',2.22),('16273','2013-09-13','16:00:00',2.16),('16273','2013-09-13','16:05:00',2.09),('16273','2013-09-13','16:10:00',2.02),('16273','2013-09-13','16:15:00',1.94),('16273','2013-09-13','16:20:00',1.86),('16273','2013-09-13','16:25:00',1.78),('16273','2013-09-13','16:30:00',1.71),('16273','2013-09-13','16:35:00',1.63),('16273','2013-09-13','16:40:00',1.55),('16273','2013-09-13','16:45:00',1.48),('16273','2013-09-13','16:50:00',1.4),('16273','2013-09-13','16:55:00',1.32),('16273','2013-09-13','17:00:00',1.25),('16273','2013-09-13','17:05:00',1.17),('16273','2013-09-13','17:10:00',1.09),('16273','2013-09-13','17:15:00',1.04),('16273','2013-09-12','08:15:00',1.35),('16273','2013-09-12','08:20:00',1.72),('16273','2013-09-12','08:25:00',1.26),('16273','2013-09-12','08:50:00',2.11),('16273','2013-09-12','08:55:00',2.1),('16273','2013-09-12','09:00:00',2.18),('16273','2013-09-12','09:05:00',1.79),('16273','2013-09-12','09:10:00',1.76),('16273','2013-09-12','09:15:00',1.83),('16273','2013-09-12','09:20:00',2.4),('16273','2013-09-12','09:25:00',2.9),('16273','2013-09-12','09:30:00',1.89),('16273','2013-09-12','09:35:00',1.35),('16273','2013-09-12','09:50:00',1.1),('16273','2013-09-12','09:55:00',1.17),('16273','2013-09-12','10:00:00',1.8),('16273','2013-09-12','10:05:00',2.57),('16273','2013-09-12','10:10:00',1.85),('16273','2013-09-12','10:15:00',1.37),('16273','2013-09-12','10:20:00',1.05),('16273','2013-09-12','10:25:00',2.48),('16273','2013-09-12','10:30:00',2.22),('16273','2013-09-12','10:35:00',1.61),('16273','2013-09-12','10:40:00',1.33),('16273','2013-09-12','10:45:00',2.12),('16273','2013-09-12','10:50:00',2.49),('16273','2013-09-12','10:55:00',3.82),('16273','2013-09-12','11:00:00',4.26),('16273','2013-09-12','11:05:00',3.86),('16273','2013-09-12','11:10:00',3.35),('16273','2013-09-12','11:30:00',2.14),('16273','2013-09-12','11:35:00',1.55),('16273','2013-09-12','11:40:00',1.54),('16273','2013-09-12','11:45:00',3.18),('16273','2013-09-12','11:50:00',3.33),('16273','2013-09-12','11:55:00',3.84),('16273','2013-09-12','12:00:00',3.77),('16273','2013-09-12','12:05:00',4.01),('16273','2013-09-12','12:10:00',2.45),('16273','2013-09-12','12:15:00',3.45),('16273','2013-09-12','12:20:00',4.29),('16273','2013-09-12','12:25:00',2.82),('16273','2013-09-12','12:30:00',3.99),('16273','2013-09-12','12:35:00',2.84),('16273','2013-09-12','12:40:00',4.11),('16273','2013-09-12','12:45:00',3.1),('16273','2013-09-12','12:50:00',3.8),('16273','2013-09-12','12:55:00',3.75),('16273','2013-09-12','13:00:00',3.53),('16273','2013-09-12','13:05:00',3.86),('16273','2013-09-12','13:10:00',3.62),('16273','2013-09-12','13:15:00',4.05),('16273','2013-09-12','13:20:00',3.37),('16273','2013-09-12','13:25:00',3.69),('16273','2013-09-12','13:30:00',3.76),('16273','2013-09-12','13:35:00',3.75),('16273','2013-09-12','13:40:00',3.6),('16273','2013-09-12','13:45:00',3.55),('16273','2013-09-12','13:50:00',3.44),('16273','2013-09-12','13:55:00',3.51),('16273','2013-09-12','14:00:00',3.49),('16273','2013-09-12','14:05:00',3.48),('16273','2013-09-12','14:10:00',3.47),('16273','2013-09-12','14:15:00',3.31),('16273','2013-09-12','14:20:00',3.08),('16273','2013-09-12','14:25:00',2.22),('16273','2013-09-12','14:30:00',3.21),('16273','2013-09-12','14:35:00',3.43),('16273','2013-09-12','14:40:00',2.41),('16273','2013-09-12','14:45:00',2.75),('16273','2013-09-12','14:50:00',2.89),('16273','2013-09-12','14:55:00',1.84),('16273','2013-09-12','15:00:00',3.06),('16273','2013-09-12','15:05:00',2.95),('16273','2013-09-12','15:10:00',2.87),('16273','2013-09-12','15:15:00',2.83),('16273','2013-09-12','15:20:00',2.77),('16273','2013-09-12','15:25:00',2.71),('16273','2013-09-12','15:30:00',2.64),('16273','2013-09-12','15:35:00',2.57),('16273','2013-09-12','15:40:00',2.51),('16273','2013-09-12','15:45:00',1.82),('16273','2013-09-12','15:50:00',2.27),('16273','2013-09-12','15:55:00',1.51),('16273','2013-09-12','16:00:00',2.37),('16273','2013-09-12','16:05:00',1.6),('16273','2013-09-12','16:10:00',2.1),('16273','2013-09-12','16:15:00',1.4),('16273','2013-09-12','16:20:00',2),('16273','2013-09-12','16:25:00',1.97),('16273','2013-09-12','16:35:00',1.66),('16273','2013-09-12','16:40:00',1.61),('16273','2013-09-12','16:50:00',1.6),('16273','2013-09-12','16:55:00',1.51),('16273','2013-09-12','17:00:00',1.34),('16273','2013-09-12','17:05:00',1.21),('16273','2013-09-12','17:20:00',1.06),('16273','2013-09-11','08:00:00',1.34),('16273','2013-09-11','08:55:00',1.17),('16273','2013-09-11','09:05:00',1.52),('16273','2013-09-11','09:10:00',2.6),('16273','2013-09-11','09:20:00',1.02),('16273','2013-09-11','09:25:00',1.63),('16273','2013-09-11','09:50:00',1.19),('16273','2013-09-11','09:55:00',2.23),('16273','2013-09-11','10:00:00',2.15),('16273','2013-09-11','10:05:00',1.81),('16273','2013-09-11','10:10:00',3.13),('16273','2013-09-11','10:15:00',3.16),('16273','2013-09-11','10:20:00',3.18),('16273','2013-09-11','10:25:00',3.28),('16273','2013-09-11','10:30:00',3.19),('16273','2013-09-11','10:35:00',3.39),('16273','2013-09-11','10:40:00',1.52),('16273','2013-09-11','10:45:00',2.8),('16273','2013-09-11','10:50:00',2.87),('16273','2013-09-11','10:55:00',2.75),('16273','2013-09-11','11:00:00',2.87),('16273','2013-09-11','11:05:00',3.65),('16273','2013-09-11','11:10:00',3.37),('16273','2013-09-11','11:15:00',3.48),('16273','2013-09-11','11:20:00',3.12),('16273','2013-09-11','11:25:00',3.85),('16273','2013-09-11','11:30:00',3.83),('16273','2013-09-11','11:35:00',3.87),('16273','2013-09-11','11:40:00',2.1),('16273','2013-09-11','11:45:00',2.67),('16273','2013-09-11','11:50:00',3.95),('16273','2013-09-11','11:55:00',3.8),('16273','2013-09-11','12:00:00',2.81),('16273','2013-09-11','12:05:00',4.09),('16273','2013-09-11','12:10:00',4.05),('16273','2013-09-11','12:15:00',4.2),('16273','2013-09-11','12:20:00',3.01),('16273','2013-09-11','12:25:00',3.66),('16273','2013-09-11','12:30:00',1.63),('16273','2013-09-11','12:35:00',2.66),('16273','2013-09-11','12:40:00',3.11),('16273','2013-09-11','12:45:00',3),('16273','2013-09-11','12:50:00',3.96),('16273','2013-09-11','12:55:00',3.41),('16273','2013-09-11','13:00:00',2.21),('16273','2013-09-11','13:05:00',2.46),('16273','2013-09-11','13:10:00',3.42),('16273','2013-09-11','13:15:00',4.04),('16273','2013-09-11','13:20:00',4.17),('16273','2013-09-11','13:25:00',3.24),('16273','2013-09-11','13:30:00',2.82),('16273','2013-09-11','13:35:00',4.11),('16273','2013-09-11','13:40:00',3.39),('16273','2013-09-11','13:45:00',3.98),('16273','2013-09-11','13:50:00',3.61),('16273','2013-09-11','13:55:00',3.69),('16273','2013-09-11','14:00:00',3.16),('16273','2013-09-11','14:05:00',3.48),('16273','2013-09-11','14:10:00',2.78),('16273','2013-09-11','14:15:00',2.53),('16273','2013-09-11','14:20:00',2.91),('16273','2013-09-11','14:25:00',2.68),('16273','2013-09-11','14:30:00',2.71),('16273','2013-09-11','14:35:00',2),('16273','2013-09-11','14:40:00',2.27),('16273','2013-09-11','14:45:00',3.44),('16273','2013-09-11','14:50:00',1.24),('16273','2013-09-11','14:55:00',2.89),('16273','2013-09-11','15:00:00',2.96),('16273','2013-09-11','15:05:00',2.53),('16273','2013-09-11','15:10:00',2.57),('16273','2013-09-11','15:15:00',1.45),('16273','2013-09-11','15:20:00',1.9),('16273','2013-09-11','15:25:00',1.35),('16273','2013-09-11','15:30:00',1.62),('16273','2013-09-11','15:35:00',1.59),('16273','2013-09-11','15:40:00',2.08),('16273','2013-09-11','15:45:00',1),('16273','2013-09-11','15:50:00',1.06),('16273','2013-09-11','15:55:00',1.88),('16273','2013-09-11','16:05:00',1.08),('16273','2013-09-11','16:10:00',2.18),('16273','2013-09-11','16:15:00',1.48),('16273','2013-09-11','16:20:00',1.21),('16273','2013-09-11','16:25:00',1.78),('16273','2013-09-11','16:30:00',1.53),('16273','2013-09-11','16:35:00',1.81),('16273','2013-09-11','16:40:00',1.64),('16273','2013-09-11','16:45:00',1.61),('16273','2013-09-11','16:50:00',1.51),('16273','2013-09-11','16:55:00',1.44),('16273','2013-09-11','17:00:00',1.33),('16273','2013-09-11','17:05:00',1.21),('16273','2013-09-11','17:10:00',1.15),('16273','2013-09-11','17:15:00',1.1),('16273','2013-09-11','17:20:00',1.06),('16273','2013-09-11','17:25:00',1.02),('16273','2013-09-11','17:30:00',1.01),('16273','2013-09-10','08:45:00',1.19),('16273','2013-09-10','08:50:00',1.88),('16273','2013-09-10','08:55:00',2.1),('16273','2013-09-10','09:00:00',2.08),('16273','2013-09-10','09:05:00',1.55),('16273','2013-09-10','09:10:00',1.75),('16273','2013-09-10','09:15:00',1.35),('16273','2013-09-10','10:40:00',1.43),('16273','2013-09-10','10:45:00',1.28),('16273','2013-09-10','10:50:00',1.19),('16273','2013-09-10','10:55:00',1.35),('16273','2013-09-10','11:00:00',1.53),('16273','2013-09-10','11:45:00',1.16),('16273','2013-09-10','11:50:00',1.11),('16273','2013-09-10','11:55:00',1.24),('16273','2013-09-10','12:10:00',1.39),('16273','2013-09-10','12:15:00',1.91),('16273','2013-09-10','12:20:00',1.47),('16273','2013-09-10','12:25:00',1.3),('16273','2013-09-10','13:35:00',1.39),('16273','2013-09-10','13:40:00',1.82),('16273','2013-09-10','13:45:00',1.72),('16273','2013-09-10','13:50:00',2.05),('16273','2013-09-10','13:55:00',1.3),('16273','2013-09-10','14:00:00',1.3),('16273','2013-09-10','14:05:00',1.16),('16273','2013-09-10','14:10:00',1.34),('16273','2013-09-10','14:15:00',1.51),('16273','2013-09-10','14:20:00',1.92),('16273','2013-09-10','14:25:00',2),('16273','2013-09-10','14:30:00',1.53),('16273','2013-09-10','14:35:00',1.42),('16273','2013-09-10','14:40:00',1.66),('16273','2013-09-10','14:45:00',2.03),('16273','2013-09-10','14:50:00',2.07),('16273','2013-09-10','14:55:00',1.96),('16273','2013-09-10','15:00:00',2.05),('16273','2013-09-10','15:05:00',2.3),('16273','2013-09-10','15:10:00',1.84),('16273','2013-09-10','15:15:00',1.33),('16273','2013-09-10','15:20:00',1.24),('16273','2013-09-10','15:25:00',1.48),('16273','2013-09-10','15:30:00',1.5),('16273','2013-09-10','15:35:00',1.27),('16273','2013-09-10','15:40:00',1.15),('16273','2013-09-10','15:45:00',1.09),('16273','2013-09-10','15:50:00',1.04),('16273','2013-09-10','16:10:00',1.04),('16273','2013-09-09','08:50:00',1.03),('16273','2013-09-09','08:55:00',1.16),('16273','2013-09-09','09:00:00',1.06),('16273','2013-09-09','09:15:00',1.08),('16273','2013-09-09','09:35:00',1.05),('16273','2013-09-09','09:40:00',1.12),('16273','2013-09-09','09:45:00',1.19),('16273','2013-09-09','09:50:00',1.06),('16273','2013-09-09','10:05:00',1.03),('16273','2013-09-09','10:10:00',1.29),('16273','2013-09-09','10:15:00',1.42),('16273','2013-09-09','10:20:00',1.36),('16273','2013-09-09','10:25:00',1.42),('16273','2013-09-09','10:30:00',1.34),('16273','2013-09-09','10:35:00',1.62),('16273','2013-09-09','10:40:00',1.95),('16273','2013-09-09','10:45:00',2.61),('16273','2013-09-09','10:50:00',2.53),('16273','2013-09-09','10:55:00',2.64),('16273','2013-09-09','11:00:00',2.32),('16273','2013-09-09','11:05:00',1.51),('16273','2013-09-09','11:10:00',1.56),('16273','2013-09-09','11:15:00',2.35),('16273','2013-09-09','11:20:00',2.81),('16273','2013-09-09','11:25:00',1.94),('16273','2013-09-09','11:30:00',1.69),('16273','2013-09-09','11:35:00',1.83),('16273','2013-09-09','11:40:00',3.33),('16273','2013-09-09','11:45:00',2.84),('16273','2013-09-09','11:50:00',2.3),('16273','2013-09-09','11:55:00',2.98),('16273','2013-09-09','12:00:00',1.77),('16273','2013-09-09','12:05:00',1.34),('16273','2013-09-09','12:10:00',1.17),('16273','2013-09-09','12:15:00',1.18),('16273','2013-09-09','12:20:00',1.21),('16273','2013-09-09','12:25:00',1.23),('16273','2013-09-09','12:30:00',1.56),('16273','2013-09-09','12:35:00',1.89),('16273','2013-09-09','12:40:00',1.86),('16273','2013-09-09','12:45:00',1.88),('16273','2013-09-09','12:50:00',2.14),('16273','2013-09-09','12:55:00',1.97),('16273','2013-09-09','13:00:00',2.36),('16273','2013-09-09','13:05:00',3.1),('16273','2013-09-09','13:10:00',3.38),('16273','2013-09-09','13:15:00',2.6),('16273','2013-09-09','13:20:00',2.64),('16273','2013-09-09','13:25:00',3.22),('16273','2013-09-09','13:30:00',3.4),('16273','2013-09-09','13:35:00',3.47),('16273','2013-09-09','13:40:00',2.23),('16273','2013-09-09','13:45:00',2.13),('16273','2013-09-09','13:50:00',3.75),('16273','2013-09-09','13:55:00',1.76),('16273','2013-09-09','14:00:00',3.25),('16273','2013-09-09','14:05:00',2.96),('16273','2013-09-09','14:10:00',2.92),('16273','2013-09-09','14:15:00',2.45),('16273','2013-09-09','14:20:00',1.41),('16273','2013-09-09','14:25:00',2.19),('16273','2013-09-09','14:30:00',2.78),('16273','2013-09-09','14:35:00',2.34),('16273','2013-09-09','14:40:00',2.78),('16273','2013-09-09','14:45:00',2.61),('16273','2013-09-09','14:50:00',2.41),('16273','2013-09-09','14:55:00',2.57),('16273','2013-09-09','15:00:00',2.96),('16273','2013-09-09','15:05:00',2.98),('16273','2013-09-09','15:10:00',2.82),('16273','2013-09-09','15:15:00',2.7),('16273','2013-09-09','15:20:00',2.11),('16273','2013-09-09','15:25:00',1.58),('16273','2013-09-09','15:30:00',1.74),('16273','2013-09-09','15:35:00',1.95),('16273','2013-09-09','15:40:00',1.59),('16273','2013-09-09','15:45:00',1.84),('16273','2013-09-09','15:50:00',1.78),('16273','2013-09-09','15:55:00',1.01),('16273','2013-09-09','16:00:00',1.16),('16273','2013-09-09','16:05:00',1.62),('16273','2013-09-09','16:10:00',2.17),('16273','2013-09-09','16:15:00',1.26),('16273','2013-09-09','16:20:00',1.18),('16273','2013-09-09','16:40:00',1.18),('16273','2013-09-09','16:45:00',1.13),('16273','2014-04-12','08:35:00',1.16),('16273','2014-04-12','08:40:00',1.44),('16273','2014-04-12','08:45:00',1.64),('16273','2014-04-12','08:50:00',1.8),('16273','2014-04-12','08:55:00',1.31),('16273','2014-04-12','09:00:00',1.6),('16273','2014-04-12','09:05:00',2.35),('16273','2014-04-12','09:10:00',2.21),('16273','2014-04-12','09:15:00',1.28),('16273','2014-04-12','09:20:00',1.32),('16273','2014-04-12','09:25:00',1.51),('16273','2014-04-12','09:30:00',1.55),('16273','2014-04-12','09:35:00',1.48),('16273','2014-04-12','09:40:00',1.77),('16273','2014-04-12','09:45:00',1.54),('16273','2014-04-12','09:50:00',1.53),('16273','2014-04-12','09:55:00',1.69),('16273','2014-04-12','10:00:00',1.88),('16273','2014-04-12','10:05:00',1.78),('16273','2014-04-12','10:10:00',1.46),('16273','2014-04-12','10:15:00',1.35),('16273','2014-04-12','10:20:00',1.46),('16273','2014-04-12','10:25:00',1.64),('16273','2014-04-12','10:30:00',1.81),('16273','2014-04-12','10:35:00',1.83),('16273','2014-04-12','10:40:00',2.22),('16273','2014-04-12','10:45:00',2.77),('16273','2014-04-12','10:50:00',2.92),('16273','2014-04-12','10:55:00',3.43),('16273','2014-04-12','11:00:00',3.09),('16273','2014-04-12','11:05:00',3.68),('16273','2014-04-12','11:10:00',3.88),('16273','2014-04-12','11:15:00',2.21),('16273','2014-04-12','11:20:00',2.21),('16273','2014-04-12','11:25:00',2.57),('16273','2014-04-12','11:30:00',2.12),('16273','2014-04-12','11:35:00',2.4),('16273','2014-04-12','11:40:00',2.66),('16273','2014-04-12','11:45:00',3.47),('16273','2014-04-12','11:50:00',2.32),('16273','2014-04-12','11:55:00',3.11),('16273','2014-04-12','12:00:00',1.38),('16273','2014-04-12','12:05:00',1.31),('16273','2014-04-12','12:10:00',1.41),('16273','2014-04-12','12:15:00',1.5),('16273','2014-04-12','12:20:00',2.24),('16273','2014-04-12','12:25:00',1.96),('16273','2014-04-12','12:30:00',1.92),('16273','2014-04-12','12:35:00',1.42),('16273','2014-04-12','12:40:00',2.18),('16273','2014-04-12','12:45:00',2.78),('16273','2014-04-12','12:50:00',2.9),('16273','2014-04-12','12:55:00',2.79),('16273','2014-04-12','13:00:00',3.23),('16273','2014-04-12','13:05:00',2.72),('16273','2014-04-12','13:10:00',4.08),('16273','2014-04-12','13:15:00',4.09),('16273','2014-04-12','13:20:00',3.61),('16273','2014-04-12','13:25:00',3.65),('16273','2014-04-12','13:30:00',3.97),('16273','2014-04-12','13:35:00',3.51),('16273','2014-04-12','13:40:00',3.8),('16273','2014-04-12','13:45:00',3.51),('16273','2014-04-12','13:50:00',2.72),('16273','2014-04-12','13:55:00',2.45),('16273','2014-04-12','14:00:00',2.33),('16273','2014-04-12','14:05:00',3.13),('16273','2014-04-12','14:10:00',3),('16273','2014-04-12','14:15:00',3.06),('16273','2014-04-12','14:20:00',3.28),('16273','2014-04-12','14:25:00',2.7),('16273','2014-04-12','14:30:00',2.61),('16273','2014-04-12','14:35:00',2.49),('16273','2014-04-12','14:40:00',3.11),('16273','2014-04-12','14:45:00',2.75),('16273','2014-04-12','14:50:00',2.82),('16273','2014-04-12','14:55:00',2.88),('16273','2014-04-12','15:00:00',3.06),('16273','2014-04-12','15:05:00',3.07),('16273','2014-04-12','15:10:00',2.76),('16273','2014-04-12','15:15:00',2.25),('16273','2014-04-12','15:20:00',2.69),('16273','2014-04-12','15:25:00',2.47),('16273','2014-04-12','15:30:00',2.2),('16273','2014-04-12','15:35:00',2.1),('16273','2014-04-12','15:40:00',2.53),('16273','2014-04-12','15:45:00',2.58),('16273','2014-04-12','15:50:00',2.71),('16273','2014-04-12','15:55:00',2.63),('16273','2014-04-12','16:00:00',2.49),('16273','2014-04-12','16:05:00',2.4),('16273','2014-04-12','16:10:00',2.34),('16273','2014-04-12','16:15:00',2.32),('16273','2014-04-12','16:20:00',2.03),('16273','2014-04-12','16:25:00',2.03),('16273','2014-04-12','16:30:00',1.82),('16273','2014-04-12','16:35:00',2.18),('16273','2014-04-12','16:40:00',2.07),('16273','2014-04-12','16:45:00',1.37),('16273','2014-04-12','16:50:00',2.03),('16273','2014-04-12','16:55:00',1.79),('16273','2014-04-12','17:00:00',1.53),('16273','2014-04-12','17:05:00',1.43),('16273','2014-04-12','17:10:00',1.38),('16273','2014-04-12','17:15:00',1.26),('16273','2014-04-12','17:20:00',1.13),('16273','2014-04-12','17:25:00',1.29),('16273','2014-04-12','17:30:00',1.19),('16273','2014-04-12','17:35:00',1.16),('16273','2014-04-12','17:40:00',1.19),('16273','2014-04-12','17:45:00',1.05),('16273','2014-04-12','17:50:00',1.05),('16273','2013-09-08','08:35:00',1.34),('16273','2013-09-08','08:40:00',1.59),('16273','2013-09-08','08:50:00',1.08),('16273','2013-09-08','08:55:00',1.6),('16273','2013-09-08','09:00:00',2.04),('16273','2013-09-08','09:05:00',2.02),('16273','2013-09-08','09:10:00',2.07),('16273','2013-09-08','09:15:00',2.24),('16273','2013-09-08','09:20:00',2.27),('16273','2013-09-08','09:25:00',2.3),('16273','2013-09-08','09:30:00',2.36),('16273','2013-09-08','09:35:00',2.43),('16273','2013-09-08','09:40:00',2.52),('16273','2013-09-08','09:45:00',2.53),('16273','2013-09-08','09:50:00',2.6),('16273','2013-09-08','09:55:00',2.67),('16273','2013-09-08','10:00:00',2.73),('16273','2013-09-08','10:05:00',2.81),('16273','2013-09-08','10:10:00',2.85),('16273','2013-09-08','10:15:00',2.84),('16273','2013-09-08','10:20:00',2.86),('16273','2013-09-08','10:25:00',2.98),('16273','2013-09-08','10:30:00',3.04),('16273','2013-09-08','10:35:00',3.07),('16273','2013-09-08','10:40:00',3.04),('16273','2013-09-08','10:45:00',3.1),('16273','2013-09-08','10:50:00',3.11),('16273','2013-09-08','10:55:00',3.16),('16273','2013-09-08','11:00:00',3.11),('16273','2013-09-08','11:05:00',3.19),('16273','2013-09-08','11:10:00',3.2),('16273','2013-09-08','11:15:00',3.2),('16273','2013-09-08','11:20:00',3.22),('16273','2013-09-08','11:25:00',3.26),('16273','2013-09-08','11:30:00',3.24),('16273','2013-09-08','11:35:00',3.19),('16273','2013-09-08','11:40:00',2.99),('16273','2013-09-08','11:45:00',3.22),('16273','2013-09-08','11:50:00',3.16),('16273','2013-09-08','11:55:00',2.74),('16273','2013-09-08','12:00:00',3.17),('16273','2013-09-08','12:05:00',3.33),('16273','2013-09-08','12:10:00',3.46),('16273','2013-09-08','12:15:00',3.43),('16273','2013-09-08','12:20:00',3.4),('16273','2013-09-08','12:25:00',3.43),('16273','2013-09-08','12:30:00',3.4),('16273','2013-09-08','12:35:00',3.29),('16273','2013-09-08','12:40:00',3.3),('16273','2013-09-08','12:45:00',3.31),('16273','2013-09-08','12:50:00',3.26),('16273','2013-09-08','12:55:00',3.25),('16273','2013-09-08','13:00:00',3.35),('16273','2013-09-08','13:05:00',3.35),('16273','2013-09-08','13:10:00',3.27),('16273','2013-09-08','13:15:00',3.24),('16273','2013-09-08','13:20:00',2.97),('16273','2013-09-08','13:25:00',2.98),('16273','2013-09-08','13:30:00',2.66),('16273','2013-09-08','13:35:00',1.85),('16273','2013-09-08','13:40:00',2.09),('16273','2013-09-08','13:45:00',3.05),('16273','2013-09-08','13:50:00',3.01),('16273','2013-09-08','13:55:00',3.2),('16273','2013-09-08','14:00:00',2.96),('16273','2013-09-08','14:05:00',3.32),('16273','2013-09-08','14:10:00',3.08),('16273','2013-09-08','14:15:00',3.52),('16273','2013-09-08','14:20:00',3.42),('16273','2013-09-08','14:25:00',3.14),('16273','2013-09-08','14:30:00',3.19),('16273','2013-09-08','14:35:00',3.08),('16273','2013-09-08','14:40:00',3.1),('16273','2013-09-08','14:45:00',2.89),('16273','2013-09-08','14:50:00',2.76),('16273','2013-09-08','14:55:00',2.91),('16273','2013-09-08','15:00:00',2.21),('16273','2013-09-08','15:05:00',1.46),('16273','2013-09-08','15:10:00',2.26),('16273','2013-09-08','15:15:00',2.69),('16273','2013-09-08','15:20:00',2.79),('16273','2013-09-08','15:25:00',2.69),('16273','2013-09-08','15:30:00',2.58),('16273','2013-09-08','15:35:00',2.34),('16273','2013-09-08','15:40:00',2.42),('16273','2013-09-08','15:45:00',2.12),('16273','2013-09-08','15:50:00',1.96),('16273','2013-09-08','15:55:00',2.05),('16273','2013-09-08','16:00:00',2.03),('16273','2013-09-08','16:05:00',1.68),('16273','2013-09-08','16:10:00',1.72),('16273','2013-09-08','16:15:00',1.91),('16273','2013-09-08','16:20:00',1.67),('16273','2013-09-08','16:25:00',1.66),('16273','2013-09-08','16:30:00',1.59),('16273','2013-09-08','16:35:00',1.19),('16273','2013-09-08','16:40:00',1.43),('16273','2013-09-08','16:55:00',1.39),('16273','2013-09-08','17:00:00',1.43),('16273','2013-09-08','17:05:00',1.36),('16273','2013-09-08','17:10:00',1.23),('16273','2013-09-08','17:15:00',1.04),('16273','2013-09-08','17:20:00',1.01),('16273','2013-09-07','08:05:00',1.19),('16273','2013-09-07','08:10:00',1.28),('16273','2013-09-07','08:15:00',1.38),('16273','2013-09-07','08:20:00',1.46),('16273','2013-09-07','08:25:00',1.57),('16273','2013-09-07','08:30:00',1.66),('16273','2013-09-07','08:35:00',1.73),('16273','2013-09-07','08:40:00',1.8),('16273','2013-09-07','08:45:00',1.88),('16273','2013-09-07','08:50:00',1.97),('16273','2013-09-07','08:55:00',2.04),('16273','2013-09-07','09:00:00',2.13),('16273','2013-09-07','09:05:00',2.2),('16273','2013-09-07','09:10:00',2.27),('16273','2013-09-07','09:15:00',2.35),('16273','2013-09-07','09:20:00',2.4),('16273','2013-09-07','09:25:00',2.45),('16273','2013-09-07','09:30:00',2.5),('16273','2013-09-07','09:35:00',2.52),('16273','2013-09-07','09:40:00',2.6),('16273','2013-09-07','09:45:00',2.66),('16273','2013-09-07','09:50:00',2.7),('16273','2013-09-07','09:55:00',2.76),('16273','2013-09-07','10:00:00',2.81),('16273','2013-09-07','10:05:00',2.87),('16273','2013-09-07','10:10:00',2.91),('16273','2013-09-07','10:15:00',2.95),('16273','2013-09-07','10:20:00',2.98),('16273','2013-09-07','10:25:00',3.03),('16273','2013-09-07','10:30:00',3.09),('16273','2013-09-07','10:35:00',3.11),('16273','2013-09-07','10:40:00',3.12),('16273','2013-09-07','10:45:00',3.15),('16273','2013-09-07','10:50:00',3.11),('16273','2013-09-07','10:55:00',3.16),('16273','2013-09-07','11:00:00',3.26),('16273','2013-09-07','11:05:00',3.29),('16273','2013-09-07','11:10:00',3.29),('16273','2013-09-07','11:15:00',3.28),('16273','2013-09-07','11:20:00',3.29),('16273','2013-09-07','11:25:00',3.33),('16273','2013-09-07','11:30:00',3.35),('16273','2013-09-07','11:35:00',3.36),('16273','2013-09-07','11:40:00',3.39),('16273','2013-09-07','11:45:00',3.42),('16273','2013-09-07','11:50:00',3.4),('16273','2013-09-07','11:55:00',3.39),('16273','2013-09-07','12:00:00',3.39),('16273','2013-09-07','12:05:00',3.36),('16273','2013-09-07','12:10:00',3.44),('16273','2013-09-07','12:15:00',3.43),('16273','2013-09-07','12:20:00',3.41),('16273','2013-09-07','12:25:00',3.37),('16273','2013-09-07','12:30:00',3.37),('16273','2013-09-07','12:35:00',3.35),('16273','2013-09-07','12:40:00',3.4),('16273','2013-09-07','12:45:00',3.46),('16273','2013-09-07','12:50:00',3.49),('16273','2013-09-07','12:55:00',3.43),('16273','2013-09-07','13:00:00',3.4),('16273','2013-09-07','13:05:00',3.42),('16273','2013-09-07','13:10:00',3.45),('16273','2013-09-07','13:15:00',3.43),('16273','2013-09-07','13:20:00',3.38),('16273','2013-09-07','13:25:00',3.27),('16273','2013-09-07','13:30:00',3.31),('16273','2013-09-07','13:35:00',3.36),('16273','2013-09-07','13:40:00',3.37),('16273','2013-09-07','13:45:00',3.34),('16273','2013-09-07','13:50:00',3.25),('16273','2013-09-07','13:55:00',3.28),('16273','2013-09-07','14:00:00',3.24),('16273','2013-09-07','14:05:00',3.23),('16273','2013-09-07','14:10:00',3.22),('16273','2013-09-07','14:15:00',3.2),('16273','2013-09-07','14:20:00',3.16),('16273','2013-09-07','14:25:00',3.13),('16273','2013-09-07','14:30:00',3.1),('16273','2013-09-07','14:35:00',3.06),('16273','2013-09-07','14:40:00',3.01),('16273','2013-09-07','14:45:00',2.97),('16273','2013-09-07','14:50:00',2.92),('16273','2013-09-07','14:55:00',2.87),('16273','2013-09-07','15:00:00',2.82),('16273','2013-09-07','15:05:00',2.78),('16273','2013-09-07','15:10:00',2.74),('16273','2013-09-07','15:15:00',2.69),('16273','2013-09-07','15:20:00',2.63),('16273','2013-09-07','15:25:00',2.58),('16273','2013-09-07','15:30:00',2.52),('16273','2013-09-07','15:35:00',2.45),('16273','2013-09-07','15:40:00',2.4),('16273','2013-09-07','15:45:00',2.34),('16273','2013-09-07','15:50:00',2.27),('16273','2013-09-07','15:55:00',2.2),('16273','2013-09-07','16:00:00',2.13),('16273','2013-09-07','16:05:00',2.05),('16273','2013-09-07','16:10:00',1.99),('16273','2013-09-07','16:15:00',1.91),('16273','2013-09-07','16:20:00',1.84),('16273','2013-09-07','16:25:00',1.76),('16273','2013-09-07','16:30:00',1.69),('16273','2013-09-07','16:35:00',1.63),('16273','2013-09-07','16:40:00',1.55),('16273','2013-09-07','16:45:00',1.49),('16273','2013-09-07','16:50:00',1.41),('16273','2013-09-07','16:55:00',1.33),('16273','2013-09-07','17:00:00',1.26),('16273','2013-09-07','17:05:00',1.19),('16273','2013-09-07','17:10:00',1.12),('16273','2013-09-07','17:15:00',1.06),('16273','2013-09-06','07:55:00',1),('16273','2013-09-06','08:05:00',1.23),('16273','2013-09-06','08:10:00',1.32),('16273','2013-09-06','08:15:00',1.42),('16273','2013-09-06','08:20:00',1.51),('16273','2013-09-06','08:25:00',1.61),('16273','2013-09-06','08:30:00',1.69),('16273','2013-09-06','08:35:00',1.76),('16273','2013-09-06','08:40:00',1.86),('16273','2013-09-06','08:45:00',1.92),('16273','2013-09-06','08:50:00',1.98),('16273','2013-09-06','08:55:00',2.07),('16273','2013-09-06','09:00:00',2.13),('16273','2013-09-06','09:05:00',2.21),('16273','2013-09-06','09:10:00',2.3),('16273','2013-09-06','09:15:00',2.38),('16273','2013-09-06','09:20:00',2.43),('16273','2013-09-06','09:25:00',2.49),('16273','2013-09-06','09:30:00',2.56),('16273','2013-09-06','09:35:00',2.61),('16273','2013-09-06','09:40:00',2.69),('16273','2013-09-06','09:45:00',2.73),('16273','2013-09-06','09:50:00',2.76),('16273','2013-09-06','09:55:00',2.83),('16273','2013-09-06','10:00:00',2.88),('16273','2013-09-06','10:05:00',2.93),('16273','2013-09-06','10:10:00',2.97),('16273','2013-09-06','10:15:00',3.01),('16273','2013-09-06','10:20:00',3.05),('16273','2013-09-06','10:25:00',3.11),('16273','2013-09-06','10:30:00',3.17),('16273','2013-09-06','10:35:00',3.21),('16273','2013-09-06','10:40:00',3.22),('16273','2013-09-06','10:45:00',3.26),('16273','2013-09-06','10:50:00',3.28),('16273','2013-09-06','10:55:00',3.31),('16273','2013-09-06','11:00:00',3.34),('16273','2013-09-06','11:05:00',3.37),('16273','2013-09-06','11:10:00',3.38),('16273','2013-09-06','11:15:00',3.39),('16273','2013-09-06','11:20:00',3.41),('16273','2013-09-06','11:25:00',3.43),('16273','2013-09-06','11:30:00',3.43),('16273','2013-09-06','11:35:00',3.43),('16273','2013-09-06','11:40:00',3.46),('16273','2013-09-06','11:45:00',3.48),('16273','2013-09-06','11:50:00',3.49),('16273','2013-09-06','11:55:00',3.52),('16273','2013-09-06','12:00:00',3.5),('16273','2013-09-06','12:05:00',3.48),('16273','2013-09-06','12:10:00',3.51),('16273','2013-09-06','12:15:00',3.51),('16273','2013-09-06','12:20:00',3.5),('16273','2013-09-06','12:25:00',3.49),('16273','2013-09-06','12:30:00',3.46),('16273','2013-09-06','12:35:00',3.48),('16273','2013-09-06','12:40:00',3.46),('16273','2013-09-06','12:45:00',3.45),('16273','2013-09-06','12:50:00',3.45),('16273','2013-09-06','12:55:00',3.44),('16273','2013-09-06','13:00:00',3.43),('16273','2013-09-06','13:05:00',3.38),('16273','2013-09-06','13:10:00',3.36),('16273','2013-09-06','13:15:00',3.34),('16273','2013-09-06','13:20:00',3.32),('16273','2013-09-06','13:25:00',3.29),('16273','2013-09-06','13:30:00',3.31),('16273','2013-09-06','13:35:00',3.32),('16273','2013-09-06','13:40:00',3.31),('16273','2013-09-06','13:45:00',3.27),('16273','2013-09-06','13:50:00',3.24),('16273','2013-09-06','13:55:00',3.22),('16273','2013-09-06','14:00:00',3.16),('16273','2013-09-06','14:05:00',3.13),('16273','2013-09-06','14:10:00',3.14),('16273','2013-09-06','14:15:00',3.13),('16273','2013-09-06','14:20:00',3.12),('16273','2013-09-06','14:25:00',3.1),('16273','2013-09-06','14:30:00',3.06),('16273','2013-09-06','14:35:00',2.96),('16273','2013-09-06','14:40:00',2.92),('16273','2013-09-06','14:45:00',2.93),('16273','2013-09-06','14:50:00',2.88),('16273','2013-09-06','14:55:00',2.85),('16273','2013-09-06','15:00:00',2.82),('16273','2013-09-06','15:05:00',2.77),('16273','2013-09-06','15:10:00',2.72),('16273','2013-09-06','15:15:00',2.68),('16273','2013-09-06','15:20:00',2.63),('16273','2013-09-06','15:25:00',2.56),('16273','2013-09-06','15:30:00',2.5),('16273','2013-09-06','15:35:00',2.45),('16273','2013-09-06','15:40:00',2.39),('16273','2013-09-06','15:45:00',2.33),('16273','2013-09-06','15:50:00',2.28),('16273','2013-09-06','15:55:00',2.22),('16273','2013-09-06','16:00:00',2.17),('16273','2013-09-06','16:05:00',2.1),('16273','2013-09-06','16:10:00',2.03),('16273','2013-09-06','16:15:00',1.97),('16273','2013-09-06','16:20:00',1.88),('16273','2013-09-06','16:25:00',1.8),('16273','2013-09-06','16:30:00',1.74),('16273','2013-09-06','16:35:00',1.66),('16273','2013-09-06','16:40:00',1.6),('16273','2013-09-06','16:45:00',1.52),('16273','2013-09-06','16:50:00',1.45),('16273','2013-09-06','16:55:00',1.37),('16273','2013-09-06','17:00:00',1.28),('16273','2013-09-06','17:05:00',1.2),('16273','2013-09-06','17:10:00',1.14),('16273','2013-09-06','17:15:00',1.06),('16273','2013-09-06','17:20:00',1),('16273','2013-09-05','07:50:00',1.1),('16273','2013-09-05','07:55:00',1.19),('16273','2013-09-05','08:00:00',1.09),('16273','2013-09-05','08:05:00',1.41),('16273','2013-09-05','08:10:00',1.52),('16273','2013-09-05','08:15:00',1.61),('16273','2013-09-05','08:20:00',1.71),('16273','2013-09-05','08:25:00',1.79),('16273','2013-09-05','08:30:00',1.87),('16273','2013-09-05','08:35:00',1.96),('16273','2013-09-05','08:40:00',2.03),('16273','2013-09-05','08:45:00',2.1),('16273','2013-09-05','08:50:00',2.19),('16273','2013-09-05','08:55:00',2.25),('16273','2013-09-05','09:00:00',2.33),('16273','2013-09-05','09:05:00',2.4),('16273','2013-09-05','09:10:00',2.46),('16273','2013-09-05','09:15:00',2.51),('16273','2013-09-05','09:20:00',2.58),('16273','2013-09-05','09:25:00',2.65),('16273','2013-09-05','09:30:00',2.71),('16273','2013-09-05','09:35:00',2.78),('16273','2013-09-05','09:40:00',2.83),('16273','2013-09-05','09:45:00',2.84),('16273','2013-09-05','09:50:00',2.93),('16273','2013-09-05','09:55:00',2.96),('16273','2013-09-05','10:00:00',3.01),('16273','2013-09-05','10:05:00',3.04),('16273','2013-09-05','10:10:00',3.09),('16273','2013-09-05','10:15:00',3.11),('16273','2013-09-05','10:20:00',3.14),('16273','2013-09-05','10:25:00',3.18),('16273','2013-09-05','10:30:00',3.2),('16273','2013-09-05','10:35:00',3.25),('16273','2013-09-05','10:40:00',3.27),('16273','2013-09-05','10:45:00',3.31),('16273','2013-09-05','10:50:00',3.34),('16273','2013-09-05','10:55:00',3.38),('16273','2013-09-05','11:00:00',3.4),('16273','2013-09-05','11:05:00',3.42),('16273','2013-09-05','11:10:00',3.46),('16273','2013-09-05','11:15:00',3.46),('16273','2013-09-05','11:20:00',3.47),('16273','2013-09-05','11:25:00',3.5),('16273','2013-09-05','11:30:00',3.5),('16273','2013-09-05','11:35:00',3.5),('16273','2013-09-05','11:40:00',3.53),('16273','2013-09-05','11:45:00',3.56),('16273','2013-09-05','11:50:00',3.57),('16273','2013-09-05','11:55:00',3.56),('16273','2013-09-05','12:00:00',3.57),('16273','2013-09-05','12:05:00',3.56),('16273','2013-09-05','12:10:00',3.58),('16273','2013-09-05','12:15:00',3.6),('16273','2013-09-05','12:20:00',3.59),('16273','2013-09-05','12:25:00',3.58),('16273','2013-09-05','12:30:00',3.59),('16273','2013-09-05','12:35:00',3.58),('16273','2013-09-05','12:40:00',3.56),('16273','2013-09-05','12:45:00',3.56),('16273','2013-09-05','12:50:00',3.55),('16273','2013-09-05','12:55:00',3.57),('16273','2013-09-05','13:00:00',3.57),('16273','2013-09-05','13:05:00',3.54),('16273','2013-09-05','13:10:00',3.5),('16273','2013-09-05','13:15:00',3.51),('16273','2013-09-05','13:20:00',3.5),('16273','2013-09-05','13:25:00',3.48),('16273','2013-09-05','13:30:00',3.45),('16273','2013-09-05','13:35:00',3.43),('16273','2013-09-05','13:40:00',3.39),('16273','2013-09-05','13:45:00',3.36),('16273','2013-09-05','13:50:00',3.36),('16273','2013-09-05','13:55:00',3.34),('16273','2013-09-05','14:00:00',3.3),('16273','2013-09-05','14:05:00',3.25),('16273','2013-09-05','14:10:00',3.21),('16273','2013-09-05','14:15:00',3.2),('16273','2013-09-05','14:20:00',3.17),('16273','2013-09-05','14:25:00',3.14),('16273','2013-09-05','14:30:00',3.14),('16273','2013-09-05','14:35:00',3.1),('16273','2013-09-05','14:40:00',3.06),('16273','2013-09-05','14:45:00',3.02),('16273','2013-09-05','14:50:00',2.98),('16273','2013-09-05','14:55:00',2.94),('16273','2013-09-05','15:00:00',2.88),('16273','2013-09-05','15:05:00',2.83),('16273','2013-09-05','15:10:00',2.78),('16273','2013-09-05','15:15:00',2.72),('16273','2013-09-05','15:20:00',2.67),('16273','2013-09-05','15:25:00',2.63),('16273','2013-09-05','15:30:00',2.59),('16273','2013-09-05','15:35:00',2.52),('16273','2013-09-05','15:40:00',2.46),('16273','2013-09-05','15:45:00',2.39),('16273','2013-09-05','15:50:00',2.33),('16273','2013-09-05','15:55:00',2.27),('16273','2013-09-05','16:00:00',2.21),('16273','2013-09-05','16:05:00',2.14),('16273','2013-09-05','16:10:00',2.08),('16273','2013-09-05','16:15:00',2.01),('16273','2013-09-05','16:20:00',1.96),('16273','2013-09-05','16:25:00',1.89),('16273','2013-09-05','16:30:00',1.83),('16273','2013-09-05','16:35:00',1.77),('16273','2013-09-05','16:40:00',1.7),('16273','2013-09-05','16:45:00',1.65),('16273','2013-09-05','16:50:00',1.36),('16273','2013-09-05','16:55:00',1.07),('16273','2013-09-05','17:05:00',1.02),('16273','2013-09-05','17:35:00',1.01),('16273','2013-09-05','17:40:00',1.02),('16273','2013-09-04','07:50:00',1.1),('16273','2013-09-04','07:55:00',1.12),('16273','2013-09-04','08:00:00',1.26),('16273','2013-09-04','08:05:00',1.42),('16273','2013-09-04','08:10:00',1.52),('16273','2013-09-04','08:15:00',1.62),('16273','2013-09-04','08:20:00',1.71),('16273','2013-09-04','08:25:00',1.8),('16273','2013-09-04','08:30:00',1.88),('16273','2013-09-04','08:35:00',1.96),('16273','2013-09-04','08:40:00',2.04),('16273','2013-09-04','08:45:00',2.11),('16273','2013-09-04','08:50:00',2.19),('16273','2013-09-04','08:55:00',2.26),('16273','2013-09-04','09:00:00',2.34),('16273','2013-09-04','09:05:00',2.4),('16273','2013-09-04','09:10:00',2.47),('16273','2013-09-04','09:15:00',2.53),('16273','2013-09-04','09:20:00',2.59),('16273','2013-09-04','09:25:00',2.65),('16273','2013-09-04','09:30:00',2.7),('16273','2013-09-04','09:35:00',2.76),('16273','2013-09-04','09:40:00',2.82),('16273','2013-09-04','09:45:00',2.87),('16273','2013-09-04','09:50:00',2.93),('16273','2013-09-04','09:55:00',2.99),('16273','2013-09-04','10:00:00',3.04),('16273','2013-09-04','10:05:00',3.07),('16273','2013-09-04','10:10:00',3.1),('16273','2013-09-04','10:15:00',3.15),('16273','2013-09-04','10:20:00',3.21),('16273','2013-09-04','10:25:00',3.26),('16273','2013-09-04','10:30:00',3.29),('16273','2013-09-04','10:35:00',3.31),('16273','2013-09-04','10:40:00',3.32),('16273','2013-09-04','10:45:00',3.33),('16273','2013-09-04','10:50:00',3.36),('16273','2013-09-04','10:55:00',3.43),('16273','2013-09-04','11:00:00',3.47),('16273','2013-09-04','11:05:00',3.51),('16273','2013-09-04','11:10:00',3.55),('16273','2013-09-04','11:15:00',3.58),('16273','2013-09-04','11:20:00',3.6),('16273','2013-09-04','11:25:00',3.62),('16273','2013-09-04','11:30:00',3.64),('16273','2013-09-04','11:35:00',3.65),('16273','2013-09-04','11:40:00',3.66),('16273','2013-09-04','11:45:00',3.63),('16273','2013-09-04','11:50:00',3.67),('16273','2013-09-04','11:55:00',3.7),('16273','2013-09-04','12:00:00',3.7),('16273','2013-09-04','12:05:00',3.72),('16273','2013-09-04','12:10:00',3.73),('16273','2013-09-04','12:15:00',3.72),('16273','2013-09-04','12:20:00',3.69),('16273','2013-09-04','12:25:00',3.73),('16273','2013-09-04','12:30:00',3.73),('16273','2013-09-04','12:35:00',3.72),('16273','2013-09-04','12:40:00',3.72),('16273','2013-09-04','12:45:00',3.71),('16273','2013-09-04','12:50:00',3.71),('16273','2013-09-04','12:55:00',3.69),('16273','2013-09-04','13:00:00',3.69),('16273','2013-09-04','13:05:00',3.67),('16273','2013-09-04','13:10:00',3.62),('16273','2013-09-04','13:15:00',3.6),('16273','2013-09-04','13:20:00',3.58),('16273','2013-09-04','13:25:00',3.58),('16273','2013-09-04','13:30:00',3.56),('16273','2013-09-04','13:35:00',3.51),('16273','2013-09-04','13:40:00',3.5),('16273','2013-09-04','13:45:00',3.46),('16273','2013-09-04','13:50:00',3.46),('16273','2013-09-04','13:55:00',3.42),('16273','2013-09-04','14:00:00',3.4),('16273','2013-09-04','14:05:00',3.35),('16273','2013-09-04','14:10:00',3.34),('16273','2013-09-04','14:15:00',3.31),('16273','2013-09-04','14:20:00',3.26),('16273','2013-09-04','14:25:00',3.23),('16273','2013-09-04','14:30:00',3.19),('16273','2013-09-04','14:35:00',3.12),('16273','2013-09-04','14:40:00',3.08),('16273','2013-09-04','14:45:00',3.05),('16273','2013-09-04','14:50:00',2.99),('16273','2013-09-04','14:55:00',2.91),('16273','2013-09-04','15:00:00',2.88),('16273','2013-09-04','15:05:00',2.85),('16273','2013-09-04','15:10:00',2.8),('16273','2013-09-04','15:15:00',2.76),('16273','2013-09-04','15:20:00',2.68),('16273','2013-09-04','15:25:00',2.67),('16273','2013-09-04','15:30:00',2.6),('16273','2013-09-04','15:35:00',2.54),('16273','2013-09-04','15:40:00',2.48),('16273','2013-09-04','15:45:00',2.42),('16273','2013-09-04','15:50:00',2.33),('16273','2013-09-04','15:55:00',2.26),('16273','2013-09-04','16:00:00',2.15),('16273','2013-09-04','16:05:00',2.15),('16273','2013-09-04','16:10:00',2.09),('16273','2013-09-04','16:15:00',1.62),('16273','2013-09-04','16:20:00',1.92),('16273','2013-09-04','16:25:00',1.9),('16273','2013-09-04','16:30:00',1.74),('16273','2013-09-04','16:35:00',1.71),('16273','2013-09-04','16:40:00',1.63),('16273','2013-09-04','16:45:00',1.54),('16273','2013-09-04','16:50:00',1.44),('16273','2013-09-04','16:55:00',1.39),('16273','2013-09-04','17:00:00',1.32),('16273','2013-09-04','17:05:00',1.24),('16273','2013-09-04','17:10:00',1.19),('16273','2013-09-04','17:15:00',1.13),('16273','2013-09-04','17:20:00',1.06),('16273','2013-09-03','07:55:00',1.01),('16273','2013-09-03','08:00:00',1.01),('16273','2013-09-03','08:05:00',1.23),('16273','2013-09-03','08:10:00',1.33),('16273','2013-09-03','08:15:00',1.42),('16273','2013-09-03','08:20:00',1.5),('16273','2013-09-03','08:25:00',1.59),('16273','2013-09-03','08:30:00',1.67),('16273','2013-09-03','08:35:00',1.75),('16273','2013-09-03','08:40:00',1.84),('16273','2013-09-03','08:45:00',1.91),('16273','2013-09-03','08:50:00',1.98),('16273','2013-09-03','08:55:00',2.05),('16273','2013-09-03','09:00:00',2.11),('16273','2013-09-03','09:05:00',2.19),('16273','2013-09-03','09:10:00',2.27),('16273','2013-09-03','09:15:00',2.36),('16273','2013-09-03','09:20:00',2.41),('16273','2013-09-03','09:25:00',2.46),('16273','2013-09-03','09:30:00',2.49),('16273','2013-09-03','09:35:00',2.59),('16273','2013-09-03','09:40:00',2.66),('16273','2013-09-03','09:45:00',2.71),('16273','2013-09-03','09:50:00',2.76),('16273','2013-09-03','09:55:00',2.82),('16273','2013-09-03','10:00:00',2.89),('16273','2013-09-03','10:05:00',2.95),('16273','2013-09-03','10:10:00',3.01),('16273','2013-09-03','10:15:00',3.06),('16273','2013-09-03','10:20:00',3.1),('16273','2013-09-03','10:25:00',3.16),('16273','2013-09-03','10:30:00',3.19),('16273','2013-09-03','10:35:00',3.24),('16273','2013-09-03','10:40:00',3.28),('16273','2013-09-03','10:45:00',3.3),('16273','2013-09-03','10:50:00',3.32),('16273','2013-09-03','10:55:00',3.37),('16273','2013-09-03','11:00:00',3.4),('16273','2013-09-03','11:05:00',3.41),('16273','2013-09-03','11:10:00',3.42),('16273','2013-09-03','11:15:00',3.43),('16273','2013-09-03','11:20:00',3.44),('16273','2013-09-03','11:25:00',3.44),('16273','2013-09-03','11:30:00',3.44),('16273','2013-09-03','11:35:00',3.46),('16273','2013-09-03','11:40:00',3.46),('16273','2013-09-03','11:45:00',3.47),('16273','2013-09-03','11:50:00',3.49),('16273','2013-09-03','11:55:00',3.57),('16273','2013-09-03','12:00:00',3.57),('16273','2013-09-03','12:05:00',3.57),('16273','2013-09-03','12:10:00',3.57),('16273','2013-09-03','12:15:00',3.58),('16273','2013-09-03','12:20:00',3.57),('16273','2013-09-03','12:25:00',3.57),('16273','2013-09-03','12:30:00',3.59),('16273','2013-09-03','12:35:00',3.6),('16273','2013-09-03','12:40:00',3.59),('16273','2013-09-03','12:45:00',3.57),('16273','2013-09-03','12:50:00',3.6),('16273','2013-09-03','12:55:00',3.57),('16273','2013-09-03','13:00:00',3.55),('16273','2013-09-03','13:05:00',3.57),('16273','2013-09-03','13:10:00',3.57),('16273','2013-09-03','13:15:00',3.55),('16273','2013-09-03','13:20:00',3.57),('16273','2013-09-03','13:25:00',3.52),('16273','2013-09-03','13:30:00',3.49),('16273','2013-09-03','13:35:00',3.44),('16273','2013-09-03','13:40:00',3.41),('16273','2013-09-03','13:45:00',3.39),('16273','2013-09-03','13:50:00',3.38),('16273','2013-09-03','13:55:00',3.35),('16273','2013-09-03','14:00:00',3.32),('16273','2013-09-03','14:05:00',3.31),('16273','2013-09-03','14:10:00',3.3),('16273','2013-09-03','14:15:00',3.25),('16273','2013-09-03','14:20:00',3.22),('16273','2013-09-03','14:25:00',3.17),('16273','2013-09-03','14:30:00',3.11),('16273','2013-09-03','14:35:00',3.08),('16273','2013-09-03','14:40:00',3.04),('16273','2013-09-03','14:45:00',3.01),('16273','2013-09-03','14:50:00',2.97),('16273','2013-09-03','14:55:00',2.95),('16273','2013-09-03','15:00:00',2.92),('16273','2013-09-03','15:05:00',2.83),('16273','2013-09-03','15:10:00',2.79),('16273','2013-09-03','15:15:00',2.74),('16273','2013-09-03','15:20:00',2.72),('16273','2013-09-03','15:25:00',2.65),('16273','2013-09-03','15:30:00',2.58),('16273','2013-09-03','15:35:00',2.51),('16273','2013-09-03','15:40:00',2.45),('16273','2013-09-03','15:45:00',2.4),('16273','2013-09-03','15:50:00',2.35),('16273','2013-09-03','15:55:00',2.28),('16273','2013-09-03','16:00:00',2.21),('16273','2013-09-03','16:05:00',2.12),('16273','2013-09-03','16:10:00',2.05),('16273','2013-09-03','16:15:00',1.98),('16273','2013-09-03','16:20:00',1.91),('16273','2013-09-03','16:25:00',1.84),('16273','2013-09-03','16:30:00',1.77),('16273','2013-09-03','16:35:00',1.69),('16273','2013-09-03','16:40:00',1.62),('16273','2013-09-03','16:45:00',1.56),('16273','2013-09-03','16:50:00',1.5),('16273','2013-09-03','16:55:00',1.42),('16273','2013-09-03','17:00:00',1.33),('16273','2013-09-03','17:05:00',1.23),('16273','2013-09-03','17:10:00',1.18),('16273','2013-09-03','17:15:00',1.1),('16273','2013-09-03','17:20:00',1.04),('16273','2013-09-02','08:00:00',1.17),('16273','2013-09-02','08:05:00',1.27),('16273','2013-09-02','08:10:00',1.38),('16273','2013-09-02','08:15:00',1.46),('16273','2013-09-02','08:20:00',1.56),('16273','2013-09-02','08:25:00',1.64),('16273','2013-09-02','08:30:00',1.73),('16273','2013-09-02','08:35:00',1.82),('16273','2013-09-02','08:40:00',1.88),('16273','2013-09-02','08:45:00',1.97),('16273','2013-09-02','08:50:00',2.05),('16273','2013-09-02','08:55:00',2.13),('16273','2013-09-02','09:00:00',2.21),('16273','2013-09-02','09:05:00',2.27),('16273','2013-09-02','09:10:00',2.35),('16273','2013-09-02','09:15:00',2.42),('16273','2013-09-02','09:20:00',2.49),('16273','2013-09-02','09:25:00',2.54),('16273','2013-09-02','09:30:00',2.59),('16273','2013-09-02','09:35:00',2.64),('16273','2013-09-02','09:40:00',2.7),('16273','2013-09-02','09:45:00',2.77),('16273','2013-09-02','09:50:00',2.83),('16273','2013-09-02','09:55:00',2.9),('16273','2013-09-02','10:00:00',2.93),('16273','2013-09-02','10:05:00',3),('16273','2013-09-02','10:10:00',3.05),('16273','2013-09-02','10:15:00',3.09),('16273','2013-09-02','10:20:00',3.12),('16273','2013-09-02','10:25:00',3.17),('16273','2013-09-02','10:30:00',3.2),('16273','2013-09-02','10:35:00',3.26),('16273','2013-09-02','10:40:00',3.29),('16273','2013-09-02','10:45:00',3.31),('16273','2013-09-02','10:50:00',3.33),('16273','2013-09-02','10:55:00',3.34),('16273','2013-09-02','11:00:00',3.38),('16273','2013-09-02','11:05:00',3.41),('16273','2013-09-02','11:10:00',3.43),('16273','2013-09-02','11:15:00',3.46),('16273','2013-09-02','11:20:00',3.51),('16273','2013-09-02','11:25:00',3.53),('16273','2013-09-02','11:30:00',3.51),('16273','2013-09-02','11:35:00',3.51),('16273','2013-09-02','11:40:00',3.55),('16273','2013-09-02','11:45:00',3.51),('16273','2013-09-02','11:50:00',3.55),('16273','2013-09-02','11:55:00',3.58),('16273','2013-09-02','12:00:00',3.61),('16273','2013-09-02','12:05:00',3.6),('16273','2013-09-02','12:10:00',3.58),('16273','2013-09-02','12:15:00',3.56),('16273','2013-09-02','12:20:00',3.56),('16273','2013-09-02','12:25:00',3.56),('16273','2013-09-02','12:30:00',3.57),('16273','2013-09-02','12:35:00',3.57),('16273','2013-09-02','12:40:00',3.55),('16273','2013-09-02','12:45:00',3.52),('16273','2013-09-02','12:50:00',3.56),('16273','2013-09-02','12:55:00',3.56),('16273','2013-09-02','13:00:00',3.5),('16273','2013-09-02','13:05:00',3.51),('16273','2013-09-02','13:10:00',3.51),('16273','2013-09-02','13:15:00',3.54),('16273','2013-09-02','13:20:00',3.52),('16273','2013-09-02','13:25:00',3.5),('16273','2013-09-02','13:30:00',3.47),('16273','2013-09-02','13:35:00',3.45),('16273','2013-09-02','13:40:00',3.4),('16273','2013-09-02','13:45:00',3.37),('16273','2013-09-02','13:50:00',3.38),('16273','2013-09-02','13:55:00',3.35),('16273','2013-09-02','14:00:00',3.02),('16273','2013-09-02','14:05:00',2.39),('16273','2013-09-02','14:10:00',1.86),('16273','2013-09-02','14:15:00',3.25),('16273','2013-09-02','14:20:00',3.21),('16273','2013-09-02','14:25:00',2.89),('16273','2013-09-02','14:30:00',2.96),('16273','2013-09-02','14:35:00',3.13),('16273','2013-09-02','14:40:00',3.05),('16273','2013-09-02','14:45:00',3.02),('16273','2013-09-02','14:50:00',3.07),('16273','2013-09-02','14:55:00',3.04),('16273','2013-09-02','15:00:00',2.96),('16273','2013-09-02','15:05:00',2.89),('16273','2013-09-02','15:10:00',2.82),('16273','2013-09-02','15:15:00',2.8),('16273','2013-09-02','15:20:00',2.76),('16273','2013-09-02','15:25:00',2.69),('16273','2013-09-02','15:30:00',2.65),('16273','2013-09-02','15:35:00',2.61),('16273','2013-09-02','15:40:00',2.53),('16273','2013-09-02','15:45:00',2.48),('16273','2013-09-02','15:50:00',2.41),('16273','2013-09-02','15:55:00',2.35),('16273','2013-09-02','16:00:00',2.27),('16273','2013-09-02','16:05:00',2.17),('16273','2013-09-02','16:10:00',2.12),('16273','2013-09-02','16:15:00',2.07),('16273','2013-09-02','16:20:00',1.98),('16273','2013-09-02','16:25:00',1.91),('16273','2013-09-02','16:30:00',1.83),('16273','2013-09-02','16:35:00',1.74),('16273','2013-09-02','16:40:00',1.67),('16273','2013-09-02','16:45:00',1.6),('16273','2013-09-02','16:50:00',1.54),('16273','2013-09-02','16:55:00',1.45),('16273','2013-09-02','17:00:00',1.37),('16273','2013-09-02','17:05:00',1.3),('16273','2013-09-02','17:10:00',1.23),('16273','2013-09-02','17:15:00',1.15),('16273','2013-09-02','17:20:00',1.07),('16273','2013-09-02','17:25:00',1.02),('16273','2013-09-01','07:50:00',1.04),('16273','2013-09-01','08:00:00',1.25),('16273','2013-09-01','08:05:00',1.37),('16273','2013-09-01','08:10:00',1.48),('16273','2013-09-01','08:15:00',1.57),('16273','2013-09-01','08:20:00',1.65),('16273','2013-09-01','08:25:00',1.7),('16273','2013-09-01','08:30:00',1.81),('16273','2013-09-01','08:35:00',1.89),('16273','2013-09-01','08:40:00',1.95),('16273','2013-09-01','08:45:00',2.03),('16273','2013-09-01','08:50:00',2.11),('16273','2013-09-01','08:55:00',2.18),('16273','2013-09-01','09:00:00',2.25),('16273','2013-09-01','09:05:00',2.31),('16273','2013-09-01','09:10:00',2.39),('16273','2013-09-01','09:15:00',2.47),('16273','2013-09-01','09:20:00',2.54),('16273','2013-09-01','09:25:00',2.6),('16273','2013-09-01','09:30:00',2.66),('16273','2013-09-01','09:35:00',2.72),('16273','2013-09-01','09:40:00',2.78),('16273','2013-09-01','09:45:00',2.83),('16273','2013-09-01','09:50:00',2.88),('16273','2013-09-01','09:55:00',2.92),('16273','2013-09-01','10:00:00',2.94),('16273','2013-09-01','10:05:00',3.02),('16273','2013-09-01','10:10:00',3.08),('16273','2013-09-01','10:15:00',3.1),('16273','2013-09-01','10:20:00',3.12),('16273','2013-09-01','10:25:00',3.17),('16273','2013-09-01','10:30:00',3.19),('16273','2013-09-01','10:35:00',3.25),('16273','2013-09-01','10:40:00',3.28),('16273','2013-09-01','10:45:00',3.33),('16273','2013-09-01','10:50:00',3.37),('16273','2013-09-01','10:55:00',3.42),('16273','2013-09-01','11:00:00',3.45),('16273','2013-09-01','11:05:00',3.48),('16273','2013-09-01','11:10:00',3.5),('16273','2013-09-01','11:15:00',3.54),('16273','2013-09-01','11:20:00',3.56),('16273','2013-09-01','11:25:00',3.6),('16273','2013-09-01','11:30:00',3.61),('16273','2013-09-01','11:35:00',3.59),('16273','2013-09-01','11:40:00',3.64),('16273','2013-09-01','11:45:00',3.65),('16273','2013-09-01','11:50:00',3.66),('16273','2013-09-01','11:55:00',3.61),('16273','2013-09-01','12:00:00',3.62),('16273','2013-09-01','12:05:00',3.62),('16273','2013-09-01','12:10:00',3.63),('16273','2013-09-01','12:15:00',3.64),('16273','2013-09-01','12:20:00',3.57),('16273','2013-09-01','12:25:00',3.63),('16273','2013-09-01','12:30:00',3.6),('16273','2013-09-01','12:35:00',3.61),('16273','2013-09-01','12:40:00',3.6),('16273','2013-09-01','12:45:00',3.59),('16273','2013-09-01','12:50:00',3.59),('16273','2013-09-01','12:55:00',3.56),('16273','2013-09-01','13:00:00',3.37),('16273','2013-09-01','13:05:00',3.27),('16273','2013-09-01','13:10:00',3.68),('16273','2013-09-01','13:15:00',3.41),('16273','2013-09-01','13:20:00',3.12),('16273','2013-09-01','13:25:00',3.27),('16273','2013-09-01','13:30:00',3.52),('16273','2013-09-01','13:35:00',3.57),('16273','2013-09-01','13:40:00',3.56),('16273','2013-09-01','13:45:00',3.53),('16273','2013-09-01','13:50:00',3.49),('16273','2013-09-01','13:55:00',3.39),('16273','2013-09-01','14:00:00',3.31),('16273','2013-09-01','14:05:00',3.04),('16273','2013-09-01','14:10:00',3.11),('16273','2013-09-01','14:15:00',2.9),('16273','2013-09-01','14:20:00',2.81),('16273','2013-09-01','14:25:00',2.79),('16273','2013-09-01','14:30:00',2.71),('16273','2013-09-01','14:35:00',2.75),('16273','2013-09-01','14:40:00',3.02),('16273','2013-09-01','14:45:00',2.9),('16273','2013-09-01','14:50:00',2.85),('16273','2013-09-01','14:55:00',2.86),('16273','2013-09-01','15:00:00',2.86),('16273','2013-09-01','15:05:00',2.76),('16273','2013-09-01','15:10:00',2.73),('16273','2013-09-01','15:15:00',2.67),('16273','2013-09-01','15:20:00',2.58),('16273','2013-09-01','15:25:00',2.32),('16273','2013-09-01','15:30:00',2.1),('16273','2013-09-01','15:35:00',1.97),('16273','2013-09-01','15:40:00',1.97),('16273','2013-09-01','15:45:00',2.13),('16273','2013-09-01','15:50:00',2.09),('16273','2013-09-01','15:55:00',2.07),('16273','2013-09-01','16:00:00',1.73),('16273','2013-09-01','16:05:00',2.09),('16273','2013-09-01','16:10:00',2.22),('16273','2013-09-01','16:15:00',2.01),('16273','2013-09-01','16:20:00',2.07),('16273','2013-09-01','16:25:00',1.86),('16273','2013-09-01','16:30:00',1.9),('16273','2013-09-01','16:35:00',1.74),('16273','2013-09-01','16:40:00',1.65),('16273','2013-09-01','16:45:00',1.57),('16273','2013-09-01','16:50:00',1.41),('16273','2013-09-01','16:55:00',1.34),('16273','2013-09-01','17:00:00',1.39),('16273','2013-09-01','17:05:00',1.34),('16273','2013-09-01','17:10:00',1.36),('16273','2013-09-01','17:15:00',1.29),('16273','2013-09-01','17:20:00',1.19),('16273','2013-09-01','17:25:00',1.15),('16273','2013-09-01','17:30:00',1.16),('16273','2013-08-31','08:15:00',1.33),('16273','2013-08-31','08:20:00',1.53),('16273','2013-08-31','08:25:00',1.8),('16273','2013-08-31','08:30:00',1.89),('16273','2013-08-31','08:35:00',1.94),('16273','2013-08-31','08:40:00',2.03),('16273','2013-08-31','08:45:00',2.21),('16273','2013-08-31','08:50:00',2.37),('16273','2013-08-31','08:55:00',2.52),('16273','2013-08-31','09:00:00',2.3),('16273','2013-08-31','09:05:00',1.88),('16273','2013-08-31','09:10:00',2),('16273','2013-08-31','09:15:00',2.47),('16273','2013-08-31','09:20:00',2.76),('16273','2013-08-31','09:25:00',2.81),('16273','2013-08-31','09:30:00',2.9),('16273','2013-08-31','09:35:00',2.95),('16273','2013-08-31','09:40:00',2.77),('16273','2013-08-31','09:45:00',2.8),('16273','2013-08-31','09:50:00',3.05),('16273','2013-08-31','09:55:00',3.1),('16273','2013-08-31','10:00:00',3.07),('16273','2013-08-31','10:05:00',3.15),('16273','2013-08-31','10:10:00',3.21),('16273','2013-08-31','10:15:00',3.24),('16273','2013-08-31','10:20:00',3.25),('16273','2013-08-31','10:25:00',3.29),('16273','2013-08-31','10:30:00',3.34),('16273','2013-08-31','10:35:00',3.34),('16273','2013-08-31','10:40:00',3.35),('16273','2013-08-31','10:45:00',3.42),('16273','2013-08-31','10:50:00',3.43),('16273','2013-08-31','10:55:00',3.51),('16273','2013-08-31','11:00:00',3.55),('16273','2013-08-31','11:05:00',3.57),('16273','2013-08-31','11:10:00',3.59),('16273','2013-08-31','11:15:00',3.59),('16273','2013-08-31','11:20:00',3.64),('16273','2013-08-31','11:25:00',3.67),('16273','2013-08-31','11:30:00',3.7),('16273','2013-08-31','11:35:00',3.71),('16273','2013-08-31','11:40:00',3.72),('16273','2013-08-31','11:45:00',3.73),('16273','2013-08-31','11:50:00',3.74),('16273','2013-08-31','11:55:00',3.75),('16273','2013-08-31','12:00:00',3.75),('16273','2013-08-31','12:05:00',3.79),('16273','2013-08-31','12:10:00',3.8),('16273','2013-08-31','12:15:00',3.78),('16273','2013-08-31','12:20:00',3.79),('16273','2013-08-31','12:25:00',3.74),('16273','2013-08-31','12:30:00',3.75),('16273','2013-08-31','12:35:00',3.77),('16273','2013-08-31','12:40:00',3.73),('16273','2013-08-31','12:45:00',3.71),('16273','2013-08-31','12:50:00',3.73),('16273','2013-08-31','12:55:00',3.74),('16273','2013-08-31','13:00:00',3.72),('16273','2013-08-31','13:05:00',3.67),('16273','2013-08-31','13:10:00',3.65),('16273','2013-08-31','13:15:00',3.66),('16273','2013-08-31','13:20:00',3.63),('16273','2013-08-31','13:25:00',3.58),('16273','2013-08-31','13:30:00',3.54),('16273','2013-08-31','13:35:00',3.5),('16273','2013-08-31','13:40:00',3.5),('16273','2013-08-31','13:45:00',3.5),('16273','2013-08-31','13:50:00',3.45),('16273','2013-08-31','13:55:00',3.42),('16273','2013-08-31','14:00:00',3.36),('16273','2013-08-31','14:05:00',3.33),('16273','2013-08-31','14:10:00',3.27),('16273','2013-08-31','14:15:00',3.25),('16273','2013-08-31','14:20:00',3.22),('16273','2013-08-31','14:25:00',3.18),('16273','2013-08-31','14:30:00',3.09),('16273','2013-08-31','14:35:00',3.1),('16273','2013-08-31','14:40:00',3.06),('16273','2013-08-31','14:45:00',3.02),('16273','2013-08-31','14:50:00',2.94),('16273','2013-08-31','14:55:00',2.91),('16273','2013-08-31','15:00:00',2.89),('16273','2013-08-31','15:05:00',2.86),('16273','2013-08-31','15:10:00',2.78),('16273','2013-08-31','15:15:00',2.71),('16273','2013-08-31','15:20:00',2.64),('16273','2013-08-31','15:25:00',2.59),('16273','2013-08-31','15:30:00',2.54),('16273','2013-08-31','15:35:00',2.48),('16273','2013-08-31','15:40:00',2.43),('16273','2013-08-31','15:45:00',2.38),('16273','2013-08-31','15:50:00',2.31),('16273','2013-08-31','15:55:00',2.26),('16273','2013-08-31','16:00:00',2.19),('16273','2013-08-31','16:05:00',2.1),('16273','2013-08-31','16:10:00',2.01),('16273','2013-08-31','16:15:00',1.96),('16273','2013-08-31','16:20:00',1.85),('16273','2013-08-31','16:25:00',1.88),('16273','2013-08-31','16:30:00',1.87),('16273','2013-08-31','16:35:00',1.78),('16273','2013-08-31','16:40:00',1.66),('16273','2013-08-31','16:45:00',1.61),('16273','2013-08-31','16:50:00',1.53),('16273','2013-08-31','16:55:00',1.48),('16273','2013-08-31','17:00:00',1.42),('16273','2013-08-31','17:05:00',1.35),('16273','2013-08-31','17:10:00',1.28),('16273','2013-08-31','17:15:00',1.21),('16273','2013-08-31','17:20:00',1.14),('16273','2013-08-31','17:25:00',1.04),('16273','2013-08-30','07:55:00',1.08),('16273','2013-08-30','08:00:00',1.33),('16273','2013-08-30','08:05:00',1.52),('16273','2013-08-30','08:10:00',1.49),('16273','2013-08-30','08:15:00',1.46),('16273','2013-08-30','08:20:00',1.54),('16273','2013-08-30','08:25:00',1.54),('16273','2013-08-30','08:30:00',1.56),('16273','2013-08-30','08:35:00',1.64),('16273','2013-08-30','08:40:00',1.52),('16273','2013-08-30','08:45:00',1.33),('16273','2013-08-30','08:50:00',1.27),('16273','2013-08-30','08:55:00',1.43),('16273','2013-08-30','09:00:00',1.6),('16273','2013-08-30','09:05:00',1.47),('16273','2013-08-30','09:10:00',1.33),('16273','2013-08-30','09:15:00',1.19),('16273','2013-08-30','09:20:00',1.17),('16273','2013-08-30','09:25:00',1.33),('16273','2013-08-30','09:30:00',1.49),('16273','2013-08-30','09:35:00',1.84),('16273','2013-08-30','09:40:00',1.79),('16273','2013-08-30','09:45:00',1.8),('16273','2013-08-30','09:50:00',1.85),('16273','2013-08-30','09:55:00',1.9),('16273','2013-08-30','10:00:00',1.78),('16273','2013-08-30','10:05:00',1.83),('16273','2013-08-30','10:10:00',1.95),('16273','2013-08-30','10:15:00',2.07),('16273','2013-08-30','10:20:00',1.93),('16273','2013-08-30','10:25:00',2.14),('16273','2013-08-30','10:30:00',2.09),('16273','2013-08-30','10:35:00',2.03),('16273','2013-08-30','10:40:00',1.88),('16273','2013-08-30','10:45:00',2.03),('16273','2013-08-30','10:50:00',1.99),('16273','2013-08-30','10:55:00',1.94),('16273','2013-08-30','11:00:00',2.06),('16273','2013-08-30','11:05:00',2.2),('16273','2013-08-30','11:10:00',2.36),('16273','2013-08-30','11:15:00',2.28),('16273','2013-08-30','11:20:00',2.44),('16273','2013-08-30','11:25:00',2.47),('16273','2013-08-30','11:30:00',2.48),('16273','2013-08-30','11:35:00',2.52),('16273','2013-08-30','11:40:00',2.67),('16273','2013-08-30','11:45:00',2.96),('16273','2013-08-30','11:50:00',2.75),('16273','2013-08-30','11:55:00',2.48),('16273','2013-08-30','12:00:00',2.01),('16273','2013-08-30','12:05:00',2.19),('16273','2013-08-30','12:10:00',2.32),('16273','2013-08-30','12:15:00',2.44),('16273','2013-08-30','12:20:00',2.75),('16273','2013-08-30','12:25:00',2.94),('16273','2013-08-30','12:30:00',3.1),('16273','2013-08-30','12:35:00',2.86),('16273','2013-08-30','12:40:00',2.97),('16273','2013-08-30','12:45:00',2.86),('16273','2013-08-30','12:50:00',2.7),('16273','2013-08-30','12:55:00',2.59),('16273','2013-08-30','13:00:00',2.5),('16273','2013-08-30','13:05:00',2.42),('16273','2013-08-30','13:10:00',2.3),('16273','2013-08-30','13:15:00',2.7),('16273','2013-08-30','13:20:00',3.38),('16273','2013-08-30','13:25:00',3.79),('16273','2013-08-30','13:30:00',3.44),('16273','2013-08-30','13:35:00',3.47),('16273','2013-08-30','13:40:00',3.54),('16273','2013-08-30','13:45:00',3.39),('16273','2013-08-30','13:50:00',3.27),('16273','2013-08-30','13:55:00',3.43),('16273','2013-08-30','14:00:00',3.46),('16273','2013-08-30','14:05:00',3.42),('16273','2013-08-30','14:10:00',3.46),('16273','2013-08-30','14:15:00',3.38),('16273','2013-08-30','14:20:00',3.23),('16273','2013-08-30','14:25:00',3.3),('16273','2013-08-30','14:30:00',3.34),('16273','2013-08-30','14:35:00',3.07),('16273','2013-08-30','14:40:00',2.9),('16273','2013-08-30','14:45:00',2.63),('16273','2013-08-30','14:50:00',2.81),('16273','2013-08-30','14:55:00',2.29),('16273','2013-08-30','15:00:00',2.08),('16273','2013-08-30','15:05:00',2.2),('16273','2013-08-30','15:10:00',2.32),('16273','2013-08-30','15:15:00',2.22),('16273','2013-08-30','15:20:00',2.14),('16273','2013-08-30','15:25:00',2.12),('16273','2013-08-30','15:30:00',1.87),('16273','2013-08-30','15:35:00',1.98),('16273','2013-08-30','15:40:00',2.21),('16273','2013-08-30','15:45:00',2.07),('16273','2013-08-30','15:50:00',1.83),('16273','2013-08-30','15:55:00',1.77),('16273','2013-08-30','16:00:00',1.58),('16273','2013-08-30','16:05:00',1.42),('16273','2013-08-30','16:10:00',1.51),('16273','2013-08-30','16:15:00',1.57),('16273','2013-08-30','16:20:00',1.53),('16273','2013-08-30','16:25:00',1.56),('16273','2013-08-30','16:30:00',1.76),('16273','2013-08-30','16:35:00',1.81),('16273','2013-08-30','16:40:00',1.86),('16273','2013-08-30','16:45:00',1.82),('16273','2013-08-30','16:50:00',1.31),('16273','2013-08-30','16:55:00',1.11),('16273','2013-08-30','17:10:00',1.18),('16273','2013-08-30','17:15:00',1.13),('16273','2013-08-30','17:20:00',1.12),('16273','2013-08-30','17:25:00',1.13),('16273','2013-08-30','17:30:00',1.11),('16273','2014-04-11','08:20:00',1.26),('16273','2014-04-11','08:30:00',1.15),('16273','2014-04-11','08:35:00',1.63),('16273','2014-04-11','08:40:00',2.15),('16273','2014-04-11','08:45:00',2.38),('16273','2014-04-11','08:50:00',2.54),('16273','2014-04-11','08:55:00',2.56),('16273','2014-04-11','09:00:00',2.51),('16273','2014-04-11','09:05:00',2.59),('16273','2014-04-11','09:10:00',2.65),('16273','2014-04-11','09:15:00',2.69),('16273','2014-04-11','09:20:00',2.66),('16273','2014-04-11','09:25:00',2.69),('16273','2014-04-11','09:30:00',2.79),('16273','2014-04-11','09:35:00',2.86),('16273','2014-04-11','09:40:00',2.91),('16273','2014-04-11','09:45:00',2.94),('16273','2014-04-11','09:50:00',3.06),('16273','2014-04-11','09:55:00',3.12),('16273','2014-04-11','10:00:00',3.19),('16273','2014-04-11','10:05:00',3.21),('16273','2014-04-11','10:10:00',3.23),('16273','2014-04-11','10:15:00',3.29),('16273','2014-04-11','10:20:00',3.32),('16273','2014-04-11','10:25:00',3.38),('16273','2014-04-11','10:30:00',3.45),('16273','2014-04-11','10:35:00',3.48),('16273','2014-04-11','10:40:00',3.52),('16273','2014-04-11','10:45:00',3.56),('16273','2014-04-11','10:50:00',3.62),('16273','2014-04-11','10:55:00',3.64),('16273','2014-04-11','11:00:00',3.67),('16273','2014-04-11','11:05:00',3.49),('16273','2014-04-11','11:10:00',3.71),('16273','2014-04-11','11:15:00',3.75),('16273','2014-04-11','11:20:00',3.8),('16273','2014-04-11','11:25:00',3.8),('16273','2014-04-11','11:30:00',3.83),('16273','2014-04-11','11:35:00',3.88),('16273','2014-04-11','11:40:00',3.78),('16273','2014-04-11','11:45:00',3.91),('16273','2014-04-11','11:50:00',3.19),('16273','2014-04-11','11:55:00',3.57),('16273','2014-04-11','12:00:00',4.14),('16273','2014-04-11','12:05:00',3.53),('16273','2014-04-11','12:10:00',4.13),('16273','2014-04-11','12:15:00',4.29),('16273','2014-04-11','12:20:00',3.91),('16273','2014-04-11','12:25:00',1.23),('16273','2014-04-11','12:30:00',1.94),('16273','2014-04-11','12:35:00',3.43),('16273','2014-04-11','12:40:00',3.71),('16273','2014-04-11','12:45:00',3.82),('16273','2014-04-11','12:50:00',3.83),('16273','2014-04-11','12:55:00',2.58),('16273','2014-04-11','13:00:00',4.51),('16273','2014-04-11','13:05:00',3.72),('16273','2014-04-11','13:10:00',4.23),('16273','2014-04-11','13:15:00',1.9),('16273','2014-04-11','13:20:00',2.25),('16273','2014-04-11','13:25:00',1.96),('16273','2014-04-11','13:30:00',2.64),('16273','2014-04-11','13:35:00',2.32),('16273','2014-04-11','13:40:00',3.16),('16273','2014-04-11','13:45:00',3.17),('16273','2014-04-11','13:50:00',2.32),('16273','2014-04-11','13:55:00',4.06),('16273','2014-04-11','14:00:00',2.65),('16273','2014-04-11','14:05:00',2.89),('16273','2014-04-11','14:10:00',3.46),('16273','2014-04-11','14:15:00',2.85),('16273','2014-04-11','14:20:00',3.23),('16273','2014-04-11','14:25:00',2.42),('16273','2014-04-11','14:30:00',3.46),('16273','2014-04-11','14:35:00',4),('16273','2014-04-11','14:40:00',3.11),('16273','2014-04-11','14:45:00',3.25),('16273','2014-04-11','14:50:00',2.79),('16273','2014-04-11','14:55:00',2.99),('16273','2014-04-11','15:00:00',2.87),('16273','2014-04-11','15:05:00',3.22),('16273','2014-04-11','15:10:00',3.21),('16273','2014-04-11','15:15:00',3),('16273','2014-04-11','15:20:00',3.04),('16273','2014-04-11','15:25:00',2.92),('16273','2014-04-11','15:30:00',2.85),('16273','2014-04-11','15:35:00',2.76),('16273','2014-04-11','15:40:00',2.74),('16273','2014-04-11','15:45:00',2.82),('16273','2014-04-11','15:50:00',2.11),('16273','2014-04-11','15:55:00',2.13),('16273','2014-04-11','16:00:00',1.23),('16273','2014-04-11','16:05:00',2.57),('16273','2014-04-11','16:10:00',2.43),('16273','2014-04-11','16:15:00',2.1),('16273','2014-04-11','16:20:00',1.76),('16273','2014-04-11','16:25:00',2.29),('16273','2014-04-11','16:30:00',2.16),('16273','2014-04-11','16:35:00',2.05),('16273','2014-04-11','16:40:00',2.05),('16273','2014-04-11','16:45:00',1.69),('16273','2014-04-11','16:50:00',1.41),('16273','2014-04-11','16:55:00',1.59),('16273','2014-04-11','17:00:00',1.53),('16273','2014-04-11','17:05:00',1.2),('16273','2014-04-11','17:10:00',1.09),('16273','2014-04-11','17:15:00',1.19),('16273','2014-04-11','17:20:00',1.11),('16273','2014-04-11','17:35:00',1.12),('16273','2013-08-29','07:45:00',1.05),('16273','2013-08-29','07:50:00',1.01),('16273','2013-08-29','07:55:00',1.24),('16273','2013-08-29','08:00:00',1.4),('16273','2013-08-29','08:05:00',1.43),('16273','2013-08-29','08:10:00',1.44),('16273','2013-08-29','08:15:00',1.69),('16273','2013-08-29','08:20:00',1.89),('16273','2013-08-29','08:25:00',2.09),('16273','2013-08-29','08:30:00',2.19),('16273','2013-08-29','08:35:00',1.53),('16273','2013-08-29','08:40:00',1.21),('16273','2013-08-29','08:45:00',1.15),('16273','2013-08-29','08:50:00',1.32),('16273','2013-08-29','08:55:00',1.59),('16273','2013-08-29','09:00:00',1.43),('16273','2013-08-29','09:05:00',1.42),('16273','2013-08-29','09:10:00',1.45),('16273','2013-08-29','09:15:00',1.43),('16273','2013-08-29','09:20:00',1.52),('16273','2013-08-29','09:25:00',1.47),('16273','2013-08-29','09:30:00',1.58),('16273','2013-08-29','09:35:00',1.73),('16273','2013-08-29','09:40:00',1.46),('16273','2013-08-29','09:45:00',1.33),('16273','2013-08-29','09:50:00',1.33),('16273','2013-08-29','09:55:00',1.33),('16273','2013-08-29','10:00:00',1.31),('16273','2013-08-29','10:05:00',1.32),('16273','2013-08-29','10:10:00',1.3),('16273','2013-08-29','10:15:00',1.34),('16273','2013-08-29','10:20:00',1.37),('16273','2013-08-29','10:25:00',1.4),('16273','2013-08-29','10:30:00',1.38),('16273','2013-08-29','10:35:00',1.22),('16273','2013-08-29','10:40:00',1.13),('16273','2013-08-29','10:45:00',1.13),('16273','2013-08-29','10:50:00',1.26),('16273','2013-08-29','10:55:00',1.42),('16273','2013-08-29','11:00:00',1.39),('16273','2013-08-29','11:05:00',1.58),('16273','2013-08-29','11:10:00',1.69),('16273','2013-08-29','11:15:00',1.75),('16273','2013-08-29','11:20:00',1.45),('16273','2013-08-29','11:25:00',1.23),('16273','2013-08-29','11:30:00',1.15),('16273','2013-08-29','11:35:00',1.3),('16273','2013-08-29','11:40:00',1.49),('16273','2013-08-29','11:45:00',1.6),('16273','2013-08-29','11:50:00',1.73),('16273','2013-08-29','11:55:00',1.7),('16273','2013-08-29','12:00:00',1.73),('16273','2013-08-29','12:05:00',2.33),('16273','2013-08-29','12:10:00',2.7),('16273','2013-08-29','12:15:00',2.81),('16273','2013-08-29','12:20:00',2.67),('16273','2013-08-29','12:25:00',2.35),('16273','2013-08-29','12:30:00',2.56),('16273','2013-08-29','12:35:00',2.83),('16273','2013-08-29','12:40:00',3.56),('16273','2013-08-29','12:45:00',2.73),('16273','2013-08-29','12:50:00',2.69),('16273','2013-08-29','12:55:00',2.29),('16273','2013-08-29','13:00:00',2.47),('16273','2013-08-29','13:05:00',2.07),('16273','2013-08-29','13:10:00',2),('16273','2013-08-29','13:15:00',2.03),('16273','2013-08-29','13:20:00',1.78),('16273','2013-08-29','13:25:00',1.6),('16273','2013-08-29','13:30:00',1.57),('16273','2013-08-29','13:35:00',1.53),('16273','2013-08-29','13:40:00',1.41),('16273','2013-08-29','13:45:00',1.43),('16273','2013-08-29','13:50:00',1.88),('16273','2013-08-29','13:55:00',2.37),('16273','2013-08-29','14:00:00',1.49),('16273','2013-08-29','14:05:00',1.31),('16273','2013-08-29','14:10:00',1.11),('16273','2013-08-29','14:40:00',1.08),('16273','2013-08-29','14:45:00',1.2),('16273','2013-08-29','14:50:00',1.39),('16273','2013-08-29','14:55:00',1.58),('16273','2013-08-29','15:00:00',2.13),('16273','2013-08-29','15:05:00',1.27),('16273','2013-08-29','15:10:00',1.13),('16273','2013-08-29','15:15:00',1.63),('16273','2013-08-29','15:20:00',1.94),('16273','2013-08-29','15:25:00',2.29),('16273','2013-08-29','15:30:00',1.9),('16273','2013-08-29','15:35:00',2.02),('16273','2013-08-29','15:40:00',1.71),('16273','2013-08-29','15:45:00',1.71),('16273','2013-08-29','15:50:00',1.89),('16273','2013-08-29','15:55:00',2.13),('16273','2013-08-29','16:00:00',2.8),('16273','2013-08-29','16:05:00',2.58),('16273','2013-08-29','16:10:00',2.33),('16273','2013-08-29','16:15:00',2.25),('16273','2013-08-29','16:20:00',2.09),('16273','2013-08-29','16:25:00',1.83),('16273','2013-08-29','16:30:00',1.94),('16273','2013-08-29','16:35:00',1.89),('16273','2013-08-29','16:40:00',1.79),('16273','2013-08-29','16:45:00',1.72),('16273','2013-08-29','16:50:00',1.64),('16273','2013-08-29','16:55:00',1.56),('16273','2013-08-29','17:00:00',1.48),('16273','2013-08-29','17:05:00',1.41),('16273','2013-08-29','17:10:00',1.33),('16273','2013-08-29','17:15:00',1.26),('16273','2013-08-29','17:20:00',1.17),('16273','2013-08-29','17:25:00',1.09),('16273','2013-08-29','17:30:00',1.03),('16273','2013-08-28','07:50:00',1.18),('16273','2013-08-28','07:55:00',1.11),('16273','2013-08-28','08:05:00',1.3),('16273','2013-08-28','08:10:00',1.65),('16273','2013-08-28','08:15:00',1.64),('16273','2013-08-28','08:20:00',1.62),('16273','2013-08-28','08:25:00',1.63),('16273','2013-08-28','08:30:00',1.86),('16273','2013-08-28','08:35:00',1.79),('16273','2013-08-28','08:55:00',2.16),('16273','2013-08-28','09:00:00',2.32),('16273','2013-08-28','09:05:00',2.39),('16273','2013-08-28','09:10:00',2.35),('16273','2013-08-28','09:15:00',1.36),('16273','2013-08-28','09:20:00',1.15),('16273','2013-08-28','09:25:00',1.39),('16273','2013-08-28','09:30:00',2.35),('16273','2013-08-28','09:35:00',2.49),('16273','2013-08-28','09:40:00',2.86),('16273','2013-08-28','09:45:00',2.82),('16273','2013-08-28','09:50:00',2.62),('16273','2013-08-28','09:55:00',2.9),('16273','2013-08-28','10:00:00',3.04),('16273','2013-08-28','10:05:00',2.21),('16273','2013-08-28','10:10:00',2.82),('16273','2013-08-28','10:15:00',3.24),('16273','2013-08-28','10:20:00',3.26),('16273','2013-08-28','10:25:00',3.31),('16273','2013-08-28','10:30:00',3.34),('16273','2013-08-28','10:35:00',3.26),('16273','2013-08-28','10:40:00',2.65),('16273','2013-08-28','10:45:00',3.63),('16273','2013-08-28','10:50:00',3.8),('16273','2013-08-28','10:55:00',3.8),('16273','2013-08-28','11:00:00',3.33),('16273','2013-08-28','11:05:00',1.25),('16273','2013-08-28','11:10:00',4.01),('16273','2013-08-28','11:15:00',1.86),('16273','2013-08-28','11:20:00',2.55),('16273','2013-08-28','11:25:00',1.73),('16273','2013-08-28','11:30:00',2.68),('16273','2013-08-28','11:35:00',3.5),('16273','2013-08-28','11:40:00',3.75),('16273','2013-08-28','11:45:00',3.46),('16273','2013-08-28','11:50:00',2.35),('16273','2013-08-28','11:55:00',4.01),('16273','2013-08-28','12:00:00',2.29),('16273','2013-08-28','12:05:00',3.15),('16273','2013-08-28','12:10:00',4),('16273','2013-08-28','12:15:00',3.9),('16273','2013-08-28','12:20:00',3.87),('16273','2013-08-28','12:25:00',3.96),('16273','2013-08-28','12:30:00',3.9),('16273','2013-08-28','12:35:00',3.85),('16273','2013-08-28','12:40:00',3.54),('16273','2013-08-28','12:45:00',3.75),('16273','2013-08-28','12:50:00',3.91),('16273','2013-08-28','12:55:00',3.92),('16273','2013-08-28','13:00:00',3.86),('16273','2013-08-28','13:05:00',3.83),('16273','2013-08-28','13:10:00',3.62),('16273','2013-08-28','13:15:00',3.85),('16273','2013-08-28','13:20:00',3.86),('16273','2013-08-28','13:25:00',3.9),('16273','2013-08-28','13:30:00',3.89),('16273','2013-08-28','13:35:00',3.93),('16273','2013-08-28','13:40:00',3.87),('16273','2013-08-28','13:45:00',3.74),('16273','2013-08-28','13:50:00',3.7),('16273','2013-08-28','13:55:00',3.59),('16273','2013-08-28','14:00:00',2.91),('16273','2013-08-28','14:05:00',3.62),('16273','2013-08-28','14:10:00',3.57),('16273','2013-08-28','14:15:00',3.54),('16273','2013-08-28','14:20:00',3.55),('16273','2013-08-28','14:25:00',3.61),('16273','2013-08-28','14:30:00',3.36),('16273','2013-08-28','14:35:00',3.14),('16273','2013-08-28','14:40:00',3.07),('16273','2013-08-28','14:45:00',3.42),('16273','2013-08-28','14:50:00',1.89),('16273','2013-08-28','14:55:00',2.36),('16273','2013-08-28','15:00:00',2.72),('16273','2013-08-28','15:05:00',3.23),('16273','2013-08-28','15:10:00',2.49),('16273','2013-08-28','15:15:00',2.65),('16273','2013-08-28','15:20:00',2.33),('16273','2013-08-28','15:25:00',3.15),('16273','2013-08-28','15:30:00',2.01),('16273','2013-08-28','15:35:00',2.33),('16273','2013-08-28','15:40:00',2.18),('16273','2013-08-28','15:45:00',2.34),('16273','2013-08-28','15:50:00',2.69),('16273','2013-08-28','15:55:00',2.6),('16273','2013-08-28','16:00:00',2.28),('16273','2013-08-28','16:05:00',2.25),('16273','2013-08-28','16:10:00',2.42),('16273','2013-08-28','16:15:00',2.29),('16273','2013-08-28','16:20:00',2.18),('16273','2013-08-28','16:25:00',2.09),('16273','2013-08-28','16:30:00',2.02),('16273','2013-08-28','16:35:00',1.92),('16273','2013-08-28','16:40:00',1.85),('16273','2013-08-28','16:45:00',1.77),('16273','2013-08-28','16:50:00',1.63),('16273','2013-08-28','16:55:00',1.03),('16273','2013-08-28','17:00:00',1.51),('16273','2013-08-28','17:05:00',1.51),('16273','2013-08-28','17:10:00',1.08),('16273','2013-08-28','17:15:00',1.3),('16273','2013-08-28','17:20:00',1.22),('16273','2013-08-28','17:25:00',1.35),('16273','2013-08-27','08:20:00',1.25),('16273','2013-08-27','08:25:00',1.22),('16273','2013-08-27','08:30:00',1.1),('16273','2013-08-27','08:35:00',1.02),('16273','2013-08-27','08:40:00',1.14),('16273','2013-08-27','08:45:00',1.16),('16273','2013-08-27','08:50:00',1.43),('16273','2013-08-27','08:55:00',1.17),('16273','2013-08-27','09:00:00',1.09),('16273','2013-08-27','09:05:00',1.56),('16273','2013-08-27','09:10:00',1.96),('16273','2013-08-27','09:15:00',1.85),('16273','2013-08-27','09:20:00',2.26),('16273','2013-08-27','09:25:00',2.62),('16273','2013-08-27','09:30:00',2.52),('16273','2013-08-27','09:35:00',1.47),('16273','2013-08-27','09:40:00',1.52),('16273','2013-08-27','09:45:00',1.59),('16273','2013-08-27','09:50:00',1.85),('16273','2013-08-27','09:55:00',1.73),('16273','2013-08-27','10:00:00',2.4),('16273','2013-08-27','10:05:00',2.93),('16273','2013-08-27','10:10:00',3.13),('16273','2013-08-27','10:15:00',3.11),('16273','2013-08-27','10:20:00',3.07),('16273','2013-08-27','10:25:00',3.11),('16273','2013-08-27','10:30:00',3.19),('16273','2013-08-27','10:35:00',3.17),('16273','2013-08-27','10:40:00',3.2),('16273','2013-08-27','10:45:00',3.14),('16273','2013-08-27','10:50:00',2.7),('16273','2013-08-27','10:55:00',3.31),('16273','2013-08-27','11:00:00',3.29),('16273','2013-08-27','11:05:00',3.37),('16273','2013-08-27','11:10:00',3.44),('16273','2013-08-27','11:15:00',3.29),('16273','2013-08-27','11:20:00',3.05),('16273','2013-08-27','11:25:00',3.17),('16273','2013-08-27','11:30:00',3.49),('16273','2013-08-27','11:35:00',3.53),('16273','2013-08-27','11:40:00',2.22),('16273','2013-08-27','11:45:00',2.23),('16273','2013-08-27','11:50:00',2.58),('16273','2013-08-27','11:55:00',2.1),('16273','2013-08-27','12:00:00',1.92),('16273','2013-08-27','12:05:00',2.62),('16273','2013-08-27','12:10:00',3.27),('16273','2013-08-27','12:15:00',3.59),('16273','2013-08-27','12:20:00',3.55),('16273','2013-08-27','12:25:00',3.73),('16273','2013-08-27','12:30:00',3.43),('16273','2013-08-27','12:35:00',3.67),('16273','2013-08-27','12:40:00',3.14),('16273','2013-08-27','12:45:00',2.36),('16273','2013-08-27','12:50:00',1.8),('16273','2013-08-27','12:55:00',1.36),('16273','2013-08-27','13:00:00',1.35),('16273','2013-08-27','13:05:00',1.85),('16273','2013-08-27','13:10:00',2.32),('16273','2013-08-27','13:15:00',1.98),('16273','2013-08-27','13:20:00',2.14),('16273','2013-08-27','13:25:00',2.4),('16273','2013-08-27','13:30:00',2.06),('16273','2013-08-27','13:35:00',1.88),('16273','2013-08-27','13:40:00',2.27),('16273','2013-08-27','13:45:00',3.08),('16273','2013-08-27','13:50:00',3.35),('16273','2013-08-27','13:55:00',3.56),('16273','2013-08-27','14:00:00',1.96),('16273','2013-08-27','14:05:00',2.64),('16273','2013-08-27','14:10:00',2.7),('16273','2013-08-27','14:15:00',1.93),('16273','2013-08-27','14:20:00',1.64),('16273','2013-08-27','14:25:00',1.26),('16273','2013-08-27','14:30:00',1.22),('16273','2013-08-27','14:35:00',1.31),('16273','2013-08-27','14:40:00',1.26),('16273','2013-08-27','14:45:00',1.06),('16273','2013-08-27','16:00:00',1.44),('16273','2013-08-27','16:05:00',2.53),('16273','2013-08-27','16:10:00',1.64),('16273','2013-08-27','16:15:00',1.23),('16273','2013-08-27','16:30:00',1.09),('16273','2013-08-27','16:40:00',1.45),('16273','2013-08-27','16:45:00',1.41),('16273','2013-08-27','16:55:00',1.79),('16273','2013-08-27','17:00:00',2.08),('16273','2013-08-27','17:05:00',1.38),('16273','2013-08-27','17:45:00',1.14),('16273','2013-08-26','08:00:00',1.13),('16273','2013-08-26','08:15:00',1.3),('16273','2013-08-26','08:20:00',1.4),('16273','2013-08-26','08:25:00',1.52),('16273','2013-08-26','08:30:00',1.8),('16273','2013-08-26','08:35:00',1.9),('16273','2013-08-26','08:40:00',1.98),('16273','2013-08-26','08:45:00',2.05),('16273','2013-08-26','08:50:00',2.14),('16273','2013-08-26','08:55:00',2.22),('16273','2013-08-26','09:00:00',2.28),('16273','2013-08-26','09:05:00',2.36),('16273','2013-08-26','09:10:00',2.44),('16273','2013-08-26','09:15:00',2.49),('16273','2013-08-26','09:20:00',2.54),('16273','2013-08-26','09:25:00',2.59),('16273','2013-08-26','09:30:00',2.67),('16273','2013-08-26','09:35:00',2.73),('16273','2013-08-26','09:40:00',2.78),('16273','2013-08-26','09:45:00',2.83),('16273','2013-08-26','09:50:00',2.88),('16273','2013-08-26','09:55:00',2.92),('16273','2013-08-26','10:00:00',2.97),('16273','2013-08-26','10:05:00',3.03),('16273','2013-08-26','10:10:00',3.05),('16273','2013-08-26','10:15:00',3.11),('16273','2013-08-26','10:20:00',3.21),('16273','2013-08-26','10:25:00',3.2),('16273','2013-08-26','10:30:00',3.25),('16273','2013-08-26','10:35:00',3.28),('16273','2013-08-26','10:40:00',3.32),('16273','2013-08-26','10:45:00',3.35),('16273','2013-08-26','10:50:00',3.36),('16273','2013-08-26','10:55:00',3.38),('16273','2013-08-26','11:00:00',3.42),('16273','2013-08-26','11:05:00',3.44),('16273','2013-08-26','11:10:00',3.48),('16273','2013-08-26','11:15:00',3.49),('16273','2013-08-26','11:20:00',3.51),('16273','2013-08-26','11:25:00',3.51),('16273','2013-08-26','11:30:00',3.54),('16273','2013-08-26','11:35:00',3.57),('16273','2013-08-26','11:40:00',3.55),('16273','2013-08-26','11:45:00',3.58),('16273','2013-08-26','11:50:00',3.6),('16273','2013-08-26','11:55:00',3.62),('16273','2013-08-26','12:00:00',3.6),('16273','2013-08-26','12:05:00',3.6),('16273','2013-08-26','12:10:00',3.58),('16273','2013-08-26','12:15:00',3.58),('16273','2013-08-26','12:20:00',3.58),('16273','2013-08-26','12:25:00',3.59),('16273','2013-08-26','12:30:00',3.62),('16273','2013-08-26','12:35:00',3.89),('16273','2013-08-26','12:40:00',3.84),('16273','2013-08-26','12:45:00',3.71),('16273','2013-08-26','12:50:00',3.69),('16273','2013-08-26','12:55:00',3.48),('16273','2013-08-26','13:00:00',2.23),('16273','2013-08-26','13:05:00',2.68),('16273','2013-08-26','13:10:00',2.37),('16273','2013-08-26','13:15:00',2.12),('16273','2013-08-26','13:20:00',2.77),('16273','2013-08-26','13:25:00',2.68),('16273','2013-08-26','13:30:00',2.86),('16273','2013-08-26','13:35:00',2.72),('16273','2013-08-26','13:40:00',3.43),('16273','2013-08-26','13:45:00',3.57),('16273','2013-08-26','13:50:00',2.68),('16273','2013-08-26','13:55:00',2.52),('16273','2013-08-26','14:00:00',2.76),('16273','2013-08-26','14:05:00',2.87),('16273','2013-08-26','14:10:00',3.33),('16273','2013-08-26','14:15:00',3.28),('16273','2013-08-26','14:20:00',3.25),('16273','2013-08-26','14:25:00',3.29),('16273','2013-08-26','14:30:00',3.25),('16273','2013-08-26','14:35:00',3.18),('16273','2013-08-26','14:40:00',2.62),('16273','2013-08-26','14:45:00',1.67),('16273','2013-08-26','14:50:00',1.53),('16273','2013-08-26','14:55:00',1.48),('16273','2013-08-26','15:00:00',1.51),('16273','2013-08-26','15:05:00',1.01),('16273','2013-08-26','15:35:00',1.15),('16273','2013-08-26','15:40:00',1.41),('16273','2013-08-26','15:45:00',1.3),('16273','2013-08-26','15:50:00',1.45),('16273','2013-08-26','15:55:00',2.15),('16273','2013-08-26','16:00:00',2.76),('16273','2013-08-26','16:05:00',2.46),('16273','2013-08-26','16:10:00',2.22),('16273','2013-08-26','16:15:00',2.13),('16273','2013-08-26','16:20:00',2.05),('16273','2013-08-26','16:25:00',1.95),('16273','2013-08-26','16:30:00',1.92),('16273','2013-08-26','16:35:00',1.85),('16273','2013-08-26','16:40:00',1.78),('16273','2013-08-26','16:45:00',1.67),('16273','2013-08-26','16:50:00',1.62),('16273','2013-08-26','16:55:00',1.54),('16273','2013-08-26','17:00:00',1.32),('16273','2013-08-26','17:05:00',1.39),('16273','2013-08-26','17:10:00',1.32),('16273','2013-08-26','17:45:00',1.08),('16273','2013-08-26','17:50:00',1.05),('16273','2013-08-25','07:55:00',1.03),('16273','2013-08-25','08:00:00',1.25),('16273','2013-08-25','08:05:00',1.13),('16273','2013-08-25','08:10:00',1.36),('16273','2013-08-25','08:20:00',1.53),('16273','2013-08-25','08:25:00',1.66),('16273','2013-08-25','08:30:00',1.67),('16273','2013-08-25','08:35:00',1.84),('16273','2013-08-25','08:55:00',1.35),('16273','2013-08-25','09:00:00',2.21),('16273','2013-08-25','09:05:00',1.84),('16273','2013-08-25','09:10:00',2.16),('16273','2013-08-25','09:15:00',2.39),('16273','2013-08-25','09:20:00',2.55),('16273','2013-08-25','09:25:00',2.67),('16273','2013-08-25','09:30:00',2.8),('16273','2013-08-25','09:35:00',2.97),('16273','2013-08-25','09:40:00',3.3),('16273','2013-08-25','09:45:00',2.4),('16273','2013-08-25','09:50:00',2.95),('16273','2013-08-25','09:55:00',1.76),('16273','2013-08-25','15:10:00',1.07),('16273','2013-08-25','15:15:00',1.26),('16273','2013-08-25','15:20:00',1.43),('16273','2013-08-25','15:25:00',2),('16273','2013-08-25','15:30:00',3.11),('16273','2013-08-25','15:35:00',1.97),('16273','2013-08-25','15:40:00',2.58),('16273','2013-08-25','15:45:00',1.65),('16273','2013-08-25','15:50:00',1.9),('16273','2013-08-25','15:55:00',1.84),('16273','2013-08-25','16:00:00',2.71),('16273','2013-08-25','16:05:00',2.46),('16273','2013-08-25','16:10:00',2.34),('16273','2013-08-25','16:15:00',2.21),('16273','2013-08-25','16:20:00',2.15),('16273','2013-08-25','16:25:00',2.04),('16273','2013-08-25','16:30:00',1.99),('16273','2013-08-25','16:35:00',1.68),('16273','2013-08-25','16:45:00',1.25),('16273','2013-08-25','16:50:00',1.99),('16273','2013-08-25','16:55:00',1.81),('16273','2013-08-25','17:00:00',1.66),('16273','2013-08-25','17:05:00',1.57),('16273','2013-08-25','17:10:00',1.44),('16273','2013-08-25','17:15:00',1.35),('16273','2013-08-25','17:20:00',1.26),('16273','2013-08-25','17:25:00',1.16),('16273','2013-08-25','17:30:00',1.03),('16273','2013-08-24','07:55:00',1.12),('16273','2013-08-24','08:00:00',1.21),('16273','2013-08-24','08:05:00',1.29),('16273','2013-08-24','08:10:00',1.35),('16273','2013-08-24','08:15:00',1.43),('16273','2013-08-24','08:20:00',1.52),('16273','2013-08-24','08:25:00',1.57),('16273','2013-08-24','08:30:00',1.67),('16273','2013-08-24','08:35:00',1.76),('16273','2013-08-24','08:40:00',1.87),('16273','2013-08-24','08:45:00',1.95),('16273','2013-08-24','08:50:00',1.99),('16273','2013-08-24','08:55:00',2.05),('16273','2013-08-24','09:00:00',2.17),('16273','2013-08-24','09:05:00',2.2),('16273','2013-08-24','09:10:00',2.27),('16273','2013-08-24','09:15:00',2.32),('16273','2013-08-24','09:20:00',2.41),('16273','2013-08-24','09:25:00',2.48),('16273','2013-08-24','09:30:00',2.58),('16273','2013-08-24','09:35:00',2.62),('16273','2013-08-24','09:40:00',2.7),('16273','2013-08-24','09:45:00',2.69),('16273','2013-08-24','09:50:00',2.81),('16273','2013-08-24','09:55:00',2.89),('16273','2013-08-24','10:00:00',2.94),('16273','2013-08-24','10:05:00',2.98),('16273','2013-08-24','10:10:00',3.03),('16273','2013-08-24','10:15:00',3.09),('16273','2013-08-24','10:20:00',3.12),('16273','2013-08-24','10:25:00',3.16),('16273','2013-08-24','10:30:00',3.2),('16273','2013-08-24','10:35:00',3.25),('16273','2013-08-24','10:40:00',3.29),('16273','2013-08-24','10:45:00',3.32),('16273','2013-08-24','10:50:00',3.36),('16273','2013-08-24','10:55:00',3.38),('16273','2013-08-24','11:00:00',3.41),('16273','2013-08-24','11:05:00',3.45),('16273','2013-08-24','11:10:00',3.47),('16273','2013-08-24','11:15:00',3.5),('16273','2013-08-24','11:20:00',3.52),('16273','2013-08-24','11:25:00',3.49),('16273','2013-08-24','11:30:00',3.52),('16273','2013-08-24','11:35:00',3.54),('16273','2013-08-24','11:40:00',3.59),('16273','2013-08-24','11:45:00',3.55),('16273','2013-08-24','11:50:00',3.57),('16273','2013-08-24','11:55:00',3.58),('16273','2013-08-24','12:00:00',3.63),('16273','2013-08-24','12:05:00',3.63),('16273','2013-08-24','12:10:00',3.61),('16273','2013-08-24','12:15:00',3.6),('16273','2013-08-24','12:20:00',3.63),('16273','2013-08-24','12:25:00',3.64),('16273','2013-08-24','12:30:00',3.67),('16273','2013-08-24','12:35:00',3.67),('16273','2013-08-24','12:40:00',3.65),('16273','2013-08-24','12:45:00',3.66),('16273','2013-08-24','12:50:00',3.63),('16273','2013-08-24','12:55:00',3.66),('16273','2013-08-24','13:00:00',3.63),('16273','2013-08-24','13:05:00',3.63),('16273','2013-08-24','13:10:00',3.58),('16273','2013-08-24','13:15:00',3.6),('16273','2013-08-24','13:20:00',3.58),('16273','2013-08-24','13:25:00',3.54),('16273','2013-08-24','13:30:00',3.54),('16273','2013-08-24','13:35:00',3.51),('16273','2013-08-24','13:40:00',3.5),('16273','2013-08-24','13:45:00',3.48),('16273','2013-08-24','13:50:00',3.47),('16273','2013-08-24','13:55:00',3.42),('16273','2013-08-24','14:00:00',3.41),('16273','2013-08-24','14:05:00',3.38),('16273','2013-08-24','14:10:00',3.35),('16273','2013-08-24','14:15:00',3.32),('16273','2013-08-24','14:20:00',3.28),('16273','2013-08-24','14:25:00',3.23),('16273','2013-08-24','14:30:00',3.22),('16273','2013-08-24','14:35:00',3.18),('16273','2013-08-24','14:40:00',3.14),('16273','2013-08-24','14:45:00',3.1),('16273','2013-08-24','14:50:00',3.06),('16273','2013-08-24','14:55:00',3.02),('16273','2013-08-24','15:00:00',2.96),('16273','2013-08-24','15:05:00',2.92),('16273','2013-08-24','15:10:00',2.87),('16273','2013-08-24','15:15:00',2.83),('16273','2013-08-24','15:20:00',2.77),('16273','2013-08-24','15:25:00',2.71),('16273','2013-08-24','15:30:00',2.66),('16273','2013-08-24','15:35:00',2.59),('16273','2013-08-24','15:40:00',2.53),('16273','2013-08-24','15:45:00',2.49),('16273','2013-08-24','15:50:00',2.44),('16273','2013-08-24','15:55:00',2.39),('16273','2013-08-24','16:00:00',2.32),('16273','2013-08-24','16:05:00',2.26),('16273','2013-08-24','16:10:00',2.19),('16273','2013-08-24','16:15:00',2.13),('16273','2013-08-24','16:20:00',2.06),('16273','2013-08-24','16:25:00',1.99),('16273','2013-08-24','16:30:00',1.92),('16273','2013-08-24','16:35:00',1.85),('16273','2013-08-24','16:40:00',1.77),('16273','2013-08-24','16:45:00',1.7),('16273','2013-08-24','16:50:00',1.63),('16273','2013-08-24','16:55:00',1.56),('16273','2013-08-24','17:00:00',1.49),('16273','2013-08-24','17:05:00',1.42),('16273','2013-08-24','17:10:00',1.34),('16273','2013-08-24','17:15:00',1.27),('16273','2013-08-24','17:20:00',1.2),('16273','2013-08-24','17:25:00',1.13),('16273','2013-08-24','17:30:00',1.06),('16273','2013-08-23','08:00:00',1.06),('16273','2013-08-23','08:05:00',1.14),('16273','2013-08-23','08:10:00',1.28),('16273','2013-08-23','08:15:00',1.24),('16273','2013-08-23','08:20:00',1.24),('16273','2013-08-23','08:25:00',1.45),('16273','2013-08-23','08:30:00',1.53),('16273','2013-08-23','08:35:00',1.65),('16273','2013-08-23','08:40:00',1.72),('16273','2013-08-23','08:45:00',1.72),('16273','2013-08-23','08:50:00',1.92),('16273','2013-08-23','08:55:00',1.92),('16273','2013-08-23','09:00:00',1.81),('16273','2013-08-23','09:05:00',2.05),('16273','2013-08-23','09:10:00',2.12),('16273','2013-08-23','09:15:00',2.17),('16273','2013-08-23','09:20:00',2.25),('16273','2013-08-23','09:25:00',2.33),('16273','2013-08-23','09:30:00',2.35),('16273','2013-08-23','09:35:00',2.38),('16273','2013-08-23','09:40:00',2.48),('16273','2013-08-23','09:45:00',2.52),('16273','2013-08-23','09:50:00',2.63),('16273','2013-08-23','09:55:00',2.65),('16273','2013-08-23','10:00:00',2.72),('16273','2013-08-23','10:05:00',2.73),('16273','2013-08-23','10:10:00',2.78),('16273','2013-08-23','10:15:00',2.71),('16273','2013-08-23','10:20:00',2.8),('16273','2013-08-23','10:25:00',2.86),('16273','2013-08-23','10:30:00',2.77),('16273','2013-08-23','10:35:00',2.74),('16273','2013-08-23','10:40:00',3.09),('16273','2013-08-23','10:45:00',3.28),('16273','2013-08-23','10:50:00',3.13),('16273','2013-08-23','10:55:00',2.62),('16273','2013-08-23','11:00:00',1.03),('16273','2013-08-23','11:05:00',2.21),('16273','2013-08-23','11:10:00',3.27),('16273','2013-08-23','11:15:00',2.55),('16273','2013-08-23','11:20:00',3.05),('16273','2013-08-23','11:25:00',3.4),('16273','2013-08-23','11:30:00',3.53),('16273','2013-08-23','11:35:00',3.11),('16273','2013-08-23','11:40:00',2.81),('16273','2013-08-23','11:45:00',2.17),('16273','2013-08-23','11:50:00',2.62),('16273','2013-08-23','11:55:00',1.89),('16273','2013-08-23','12:00:00',3.68),('16273','2013-08-23','12:05:00',3.73),('16273','2013-08-23','12:10:00',3.08),('16273','2013-08-23','12:15:00',2.03),('16273','2013-08-23','12:20:00',3.73),('16273','2013-08-23','12:25:00',3.33),('16273','2013-08-23','12:30:00',2.48),('16273','2013-08-23','12:35:00',3.72),('16273','2013-08-23','12:40:00',3.65),('16273','2013-08-23','12:45:00',3.64),('16273','2013-08-23','12:50:00',3.61),('16273','2013-08-23','12:55:00',3.59),('16273','2013-08-23','13:00:00',3.58),('16273','2013-08-23','13:05:00',3.57),('16273','2013-08-23','13:10:00',3.57),('16273','2013-08-23','13:15:00',3.56),('16273','2013-08-23','13:20:00',3.57),('16273','2013-08-23','13:25:00',3.56),('16273','2013-08-23','13:30:00',3.54),('16273','2013-08-23','13:35:00',3.53),('16273','2013-08-23','13:40:00',3.51),('16273','2013-08-23','13:45:00',3.49),('16273','2013-08-23','13:50:00',3.46),('16273','2013-08-23','13:55:00',3.43),('16273','2013-08-23','14:00:00',3.41),('16273','2013-08-23','14:05:00',3.38),('16273','2013-08-23','14:10:00',3.37),('16273','2013-08-23','14:15:00',3.35),('16273','2013-08-23','14:20:00',3.32),('16273','2013-08-23','14:25:00',3.26),('16273','2013-08-23','14:30:00',3.24),('16273','2013-08-23','14:35:00',3.2),('16273','2013-08-23','14:40:00',3.16),('16273','2013-08-23','14:45:00',3.02),('16273','2013-08-23','14:50:00',3.05),('16273','2013-08-23','14:55:00',2.92),('16273','2013-08-23','15:00:00',2.82),('16273','2013-08-23','15:05:00',2.88),('16273','2013-08-23','15:10:00',2.77),('16273','2013-08-23','15:15:00',2.75),('16273','2013-08-23','15:20:00',2.81),('16273','2013-08-23','15:25:00',2.8),('16273','2013-08-23','15:30:00',2.54),('16273','2013-08-23','15:35:00',2.62),('16273','2013-08-23','15:40:00',2.44),('16273','2013-08-23','15:45:00',2.4),('16273','2013-08-23','15:50:00',2.41),('16273','2013-08-23','15:55:00',2.3),('16273','2013-08-23','16:00:00',1.99),('16273','2013-08-23','16:05:00',1.89),('16273','2013-08-23','16:10:00',2.22),('16273','2013-08-23','16:15:00',2.24),('16273','2013-08-23','16:20:00',2.09),('16273','2013-08-23','16:25:00',1.99),('16273','2013-08-23','16:30:00',2.03),('16273','2013-08-23','16:35:00',1.95),('16273','2013-08-23','16:40:00',1.85),('16273','2013-08-23','16:45:00',1.74),('16273','2013-08-23','16:50:00',1.66),('16273','2013-08-23','16:55:00',1.6),('16273','2013-08-23','17:00:00',1.52),('16273','2013-08-23','17:05:00',1.43),('16273','2013-08-23','17:10:00',1.35),('16273','2013-08-23','17:15:00',1.27),('16273','2013-08-23','17:20:00',1.21),('16273','2013-08-23','17:25:00',1.15),('16273','2013-08-23','17:30:00',1.07),('16273','2013-08-22','07:55:00',1.13),('16273','2013-08-22','08:00:00',1.21),('16273','2013-08-22','08:05:00',1.27),('16273','2013-08-22','08:10:00',1.36),('16273','2013-08-22','08:15:00',1.45),('16273','2013-08-22','08:20:00',1.52),('16273','2013-08-22','08:25:00',1.59),('16273','2013-08-22','08:30:00',1.63),('16273','2013-08-22','08:35:00',1.73),('16273','2013-08-22','08:40:00',1.84),('16273','2013-08-22','08:45:00',1.92),('16273','2013-08-22','08:50:00',2.03),('16273','2013-08-22','08:55:00',2.13),('16273','2013-08-22','09:00:00',2.21),('16273','2013-08-22','09:05:00',1.62),('16273','2013-08-22','09:10:00',2.15),('16273','2013-08-22','09:15:00',2),('16273','2013-08-22','09:20:00',2.15),('16273','2013-08-22','09:25:00',1.81),('16273','2013-08-22','09:30:00',1.72),('16273','2013-08-22','09:35:00',2.33),('16273','2013-08-22','09:40:00',2.63),('16273','2013-08-22','09:45:00',2.89),('16273','2013-08-22','09:50:00',2.94),('16273','2013-08-22','09:55:00',3.06),('16273','2013-08-22','10:00:00',3.1),('16273','2013-08-22','10:05:00',3.05),('16273','2013-08-22','10:10:00',3.18),('16273','2013-08-22','10:15:00',3.22),('16273','2013-08-22','10:20:00',3.16),('16273','2013-08-22','10:25:00',3.2),('16273','2013-08-22','10:30:00',3.26),('16273','2013-08-22','10:35:00',3.27),('16273','2013-08-22','10:40:00',3.26),('16273','2013-08-22','10:45:00',3.28),('16273','2013-08-22','10:50:00',3.31),('16273','2013-08-22','10:55:00',3.33),('16273','2013-08-22','11:00:00',3.37),('16273','2013-08-22','11:05:00',3.4),('16273','2013-08-22','11:10:00',3.41),('16273','2013-08-22','11:15:00',3.46),('16273','2013-08-22','11:20:00',3.48),('16273','2013-08-22','11:25:00',3.51),('16273','2013-08-22','11:30:00',3.52),('16273','2013-08-22','11:35:00',3.53),('16273','2013-08-22','11:40:00',3.53),('16273','2013-08-22','11:45:00',3.55),('16273','2013-08-22','11:50:00',3.55),('16273','2013-08-22','11:55:00',3.56),('16273','2013-08-22','12:00:00',3.57),('16273','2013-08-22','12:05:00',3.57),('16273','2013-08-22','12:10:00',3.55),('16273','2013-08-22','12:15:00',3.57),('16273','2013-08-22','12:20:00',3.55),('16273','2013-08-22','12:25:00',3.55),('16273','2013-08-22','12:30:00',3.52),('16273','2013-08-22','12:35:00',3.51),('16273','2013-08-22','12:40:00',3.51),('16273','2013-08-22','12:45:00',3.5),('16273','2013-08-22','12:50:00',3.48),('16273','2013-08-22','12:55:00',3.48),('16273','2013-08-22','13:00:00',3.47),('16273','2013-08-22','13:05:00',3.45),('16273','2013-08-22','13:10:00',3.42),('16273','2013-08-22','13:15:00',3.42),('16273','2013-08-22','13:20:00',3.39),('16273','2013-08-22','13:25:00',3.38),('16273','2013-08-22','13:30:00',3.39),('16273','2013-08-22','13:35:00',3.38),('16273','2013-08-22','13:40:00',3.35),('16273','2013-08-22','13:45:00',3.33),('16273','2013-08-22','13:50:00',3.32),('16273','2013-08-22','13:55:00',3.29),('16273','2013-08-22','14:00:00',3.26),('16273','2013-08-22','14:05:00',3.26),('16273','2013-08-22','14:10:00',3.24),('16273','2013-08-22','14:15:00',3.18),('16273','2013-08-22','14:20:00',3.15),('16273','2013-08-22','14:25:00',3.13),('16273','2013-08-22','14:30:00',3.08),('16273','2013-08-22','14:35:00',3.12),('16273','2013-08-22','14:40:00',3.15),('16273','2013-08-22','14:45:00',3.04),('16273','2013-08-22','14:50:00',2.35),('16273','2013-08-22','14:55:00',2.96),('16273','2013-08-22','15:00:00',2.91),('16273','2013-08-22','15:05:00',2.86),('16273','2013-08-22','15:10:00',2.79),('16273','2013-08-22','15:15:00',2.75),('16273','2013-08-22','15:20:00',2.7),('16273','2013-08-22','15:25:00',2.67),('16273','2013-08-22','15:30:00',2.6),('16273','2013-08-22','15:35:00',2.55),('16273','2013-08-22','15:40:00',2.51),('16273','2013-08-22','15:45:00',2.45),('16273','2013-08-22','15:50:00',2.41),('16273','2013-08-22','15:55:00',2.34),('16273','2013-08-22','16:00:00',2.28),('16273','2013-08-22','16:05:00',2.21),('16273','2013-08-22','16:10:00',2.13),('16273','2013-08-22','16:15:00',2.05),('16273','2013-08-22','16:20:00',2),('16273','2013-08-22','16:25:00',1.93),('16273','2013-08-22','16:30:00',1.87),('16273','2013-08-22','16:35:00',1.79),('16273','2013-08-22','16:40:00',1.73),('16273','2013-08-22','16:45:00',1.66),('16273','2013-08-22','16:50:00',1.58),('16273','2013-08-22','16:55:00',1.5),('16273','2013-08-22','17:00:00',1.45),('16273','2013-08-22','17:05:00',1.39),('16273','2013-08-22','17:10:00',1.33),('16273','2013-08-22','17:15:00',1.26),('16273','2013-08-22','17:20:00',1.18),('16273','2013-08-22','17:25:00',1.12),('16273','2013-08-22','17:30:00',1.06),('16273','2013-08-21','09:10:00',2.14),('16273','2013-08-21','09:15:00',1.82),('16273','2013-08-21','09:20:00',1.61),('16273','2013-08-21','09:25:00',2.42),('16273','2013-08-21','09:30:00',2.02),('16273','2013-08-21','09:45:00',1.07),('16273','2013-08-21','09:50:00',1.31),('16273','2013-08-21','09:55:00',1.36),('16273','2013-08-21','10:00:00',1.2),('16273','2013-08-21','10:05:00',1.42),('16273','2013-08-21','10:10:00',1.71),('16273','2013-08-21','10:15:00',2.64),('16273','2013-08-21','10:20:00',3.13),('16273','2013-08-21','10:25:00',3.19),('16273','2013-08-21','10:30:00',2.64),('16273','2013-08-21','10:35:00',2.39),('16273','2013-08-21','10:40:00',3.31),('16273','2013-08-21','10:45:00',3.4),('16273','2013-08-21','10:50:00',2.96),('16273','2013-08-21','10:55:00',3.11),('16273','2013-08-21','11:00:00',2.27),('16273','2013-08-21','11:05:00',2.86),('16273','2013-08-21','11:10:00',1.62),('16273','2013-08-21','11:15:00',2.2),('16273','2013-08-21','11:20:00',2.4),('16273','2013-08-21','11:25:00',3.07),('16273','2013-08-21','11:30:00',2.9),('16273','2013-08-21','11:35:00',3.68),('16273','2013-08-21','11:40:00',3.72),('16273','2013-08-21','11:45:00',3.13),('16273','2013-08-21','11:50:00',3.87),('16273','2013-08-21','11:55:00',3.55),('16273','2013-08-21','12:00:00',3.87),('16273','2013-08-21','12:05:00',3.83),('16273','2013-08-21','12:10:00',3.88),('16273','2013-08-21','12:15:00',3.82),('16273','2013-08-21','12:20:00',3.69),('16273','2013-08-21','12:25:00',3.73),('16273','2013-08-21','12:30:00',3.2),('16273','2013-08-21','12:35:00',3.3),('16273','2013-08-21','12:40:00',2.46),('16273','2013-08-21','12:45:00',1.94),('16273','2013-08-21','12:50:00',3.19),('16273','2013-08-21','12:55:00',3.35),('16273','2013-08-21','13:00:00',3.4),('16273','2013-08-21','13:05:00',3.48),('16273','2013-08-21','13:10:00',3.37),('16273','2013-08-21','13:15:00',3.54),('16273','2013-08-21','13:20:00',3.41),('16273','2013-08-21','13:25:00',3.45),('16273','2013-08-21','13:30:00',3.38),('16273','2013-08-21','13:35:00',3.42),('16273','2013-08-21','13:40:00',3.52),('16273','2013-08-21','13:45:00',3.51),('16273','2013-08-21','13:50:00',3.54),('16273','2013-08-21','13:55:00',3.45),('16273','2013-08-21','14:00:00',3.32),('16273','2013-08-21','14:05:00',3.29),('16273','2013-08-21','14:10:00',3.22),('16273','2013-08-21','14:15:00',3.18),('16273','2013-08-21','14:20:00',2.95),('16273','2013-08-21','14:25:00',2.81),('16273','2013-08-21','14:30:00',3.04),('16273','2013-08-21','14:35:00',2.92),('16273','2013-08-21','14:40:00',2.92),('16273','2013-08-21','14:45:00',3.01),('16273','2013-08-21','14:50:00',3.03),('16273','2013-08-21','14:55:00',2.96),('16273','2013-08-21','15:00:00',2.82),('16273','2013-08-21','15:05:00',2.65),('16273','2013-08-21','15:10:00',2.61),('16273','2013-08-21','15:15:00',2.41),('16273','2013-08-21','15:20:00',2.31),('16273','2013-08-21','15:25:00',2.23),('16273','2013-08-21','15:30:00',2.4),('16273','2013-08-21','15:35:00',2.45),('16273','2013-08-21','15:40:00',2.37),('16273','2013-08-21','15:45:00',2.33),('16273','2013-08-21','15:50:00',2.27),('16273','2013-08-21','15:55:00',2.21),('16273','2013-08-21','16:00:00',2.14),('16273','2013-08-21','16:05:00',2.13),('16273','2013-08-21','16:10:00',2.03),('16273','2013-08-21','16:15:00',2.04),('16273','2013-08-21','16:20:00',2.02),('16273','2013-08-21','16:25:00',1.97),('16273','2013-08-21','16:30:00',1.93),('16273','2013-08-21','16:35:00',1.97),('16273','2013-08-21','16:40:00',1.89),('16273','2013-08-21','16:45:00',1.84),('16273','2013-08-21','16:50:00',1.78),('16273','2013-08-21','16:55:00',1.71),('16273','2013-08-21','17:00:00',1.62),('16273','2013-08-21','17:05:00',1.55),('16273','2013-08-21','17:10:00',1.5),('16273','2013-08-21','17:15:00',1.45),('16273','2013-08-21','17:20:00',1.41),('16273','2013-08-21','17:25:00',1.35),('16273','2013-08-21','17:30:00',1.3),('16273','2013-08-21','17:35:00',1.23),('16273','2013-08-21','17:40:00',1.17),('16273','2013-08-21','17:45:00',1.12),('16273','2013-08-21','17:50:00',1.07),('16273','2013-08-20','07:45:00',1.06),('16273','2013-08-20','07:50:00',1.33),('16273','2013-08-20','07:55:00',1.16),('16273','2013-08-20','08:45:00',1.11),('16273','2013-08-20','08:50:00',1.36),('16273','2013-08-20','09:10:00',1.22),('16273','2013-08-20','09:15:00',1.64),('16273','2013-08-20','09:20:00',2),('16273','2013-08-20','09:25:00',2.56),('16273','2013-08-20','09:30:00',3.02),('16273','2013-08-20','09:35:00',3.17),('16273','2013-08-20','09:50:00',1.66),('16273','2013-08-20','09:55:00',1.79),('16273','2013-08-20','10:00:00',2.92),('16273','2013-08-20','10:05:00',2.38),('16273','2013-08-20','10:10:00',1.15),('16273','2013-08-20','10:15:00',2.18),('16273','2013-08-20','10:20:00',2.52),('16273','2013-08-20','10:25:00',1.25),('16273','2013-08-20','10:40:00',1.28),('16273','2013-08-20','10:45:00',3.43),('16273','2013-08-20','10:50:00',2.96),('16273','2013-08-20','10:55:00',1.79),('16273','2013-08-20','11:00:00',1.31),('16273','2013-08-20','11:05:00',3.03),('16273','2013-08-20','11:10:00',2.58),('16273','2013-08-20','11:15:00',4.03),('16273','2013-08-20','11:20:00',3.19),('16273','2013-08-20','11:25:00',3.64),('16273','2013-08-20','11:30:00',4.11),('16273','2013-08-20','11:35:00',3.03),('16273','2013-08-20','11:40:00',2.83),('16273','2013-08-20','11:45:00',2.5),('16273','2013-08-20','11:50:00',3.33),('16273','2013-08-20','11:55:00',2.19),('16273','2013-08-20','12:00:00',1.97),('16273','2013-08-20','12:05:00',2.56),('16273','2013-08-20','12:10:00',1.68),('16273','2013-08-20','12:15:00',1.5),('16273','2013-08-20','12:20:00',1.65),('16273','2013-08-20','12:25:00',1.57),('16273','2013-08-20','12:30:00',1.73),('16273','2013-08-20','12:35:00',1.83),('16273','2013-08-20','12:40:00',1.51),('16273','2013-08-20','12:45:00',1.62),('16273','2013-08-20','12:50:00',1.87),('16273','2013-08-20','12:55:00',1.68),('16273','2013-08-20','13:00:00',1.51),('16273','2013-08-20','13:05:00',1.52),('16273','2013-08-20','13:10:00',1.74),('16273','2013-08-20','13:15:00',1.68),('16273','2013-08-20','13:20:00',1.74),('16273','2013-08-20','13:25:00',2.07),('16273','2013-08-20','13:30:00',2),('16273','2013-08-20','13:35:00',3.51),('16273','2013-08-20','13:40:00',4.31),('16273','2013-08-20','13:45:00',3.98),('16273','2013-08-20','13:50:00',3.69),('16273','2013-08-20','13:55:00',3.64),('16273','2013-08-20','14:00:00',2.63),('16273','2013-08-20','14:05:00',3.6),('16273','2013-08-20','14:10:00',3.56),('16273','2013-08-20','14:15:00',3.53),('16273','2013-08-20','14:20:00',2.25),('16273','2013-08-20','14:25:00',2.35),('16273','2013-08-20','14:30:00',3.46),('16273','2013-08-20','14:35:00',2.6),('16273','2013-08-20','14:40:00',2.12),('16273','2013-08-20','14:45:00',1.46),('16273','2013-08-20','14:50:00',3.41),('16273','2013-08-20','14:55:00',3.48),('16273','2013-08-20','15:00:00',3.15),('16273','2013-08-20','15:05:00',3.16),('16273','2013-08-20','15:10:00',3.18),('16273','2013-08-20','15:15:00',3.19),('16273','2013-08-20','15:20:00',3.2),('16273','2013-08-20','15:25:00',3),('16273','2013-08-20','15:30:00',3.03),('16273','2013-08-20','15:35:00',3.42),('16273','2013-08-20','15:40:00',2.89),('16273','2013-08-20','15:45:00',2.86),('16273','2013-08-20','15:50:00',2.76),('16273','2013-08-20','15:55:00',2.72),('16273','2013-08-20','16:00:00',2.73),('16273','2013-08-20','16:05:00',2.68),('16273','2013-08-20','16:10:00',2.67),('16273','2013-08-20','16:15:00',2.64),('16273','2013-08-20','16:20:00',2.61),('16273','2013-08-20','16:25:00',2.54),('16273','2013-08-20','16:30:00',2.44),('16273','2013-08-20','16:35:00',2.27),('16273','2013-08-20','16:40:00',2.04),('16273','2013-08-20','16:45:00',1.86),('16273','2013-08-20','16:50:00',1.78),('16273','2013-08-20','16:55:00',1.58),('16273','2013-08-20','17:00:00',1.21),('16273','2013-08-20','17:05:00',1.12),('16273','2013-08-20','17:15:00',1.24),('16273','2013-08-20','17:35:00',1.18),('16273','2013-08-20','17:40:00',1.07),('16273','2014-04-10','07:50:00',1.04),('16273','2014-04-10','07:55:00',1.17),('16273','2014-04-10','08:00:00',1.3),('16273','2014-04-10','08:05:00',1.51),('16273','2014-04-10','08:10:00',1.61),('16273','2014-04-10','08:15:00',1.72),('16273','2014-04-10','08:20:00',1.83),('16273','2014-04-10','08:25:00',1.92),('16273','2014-04-10','08:30:00',2),('16273','2014-04-10','08:35:00',2.1),('16273','2014-04-10','08:40:00',2.2),('16273','2014-04-10','08:45:00',2.28),('16273','2014-04-10','08:50:00',2.35),('16273','2014-04-10','08:55:00',2.41),('16273','2014-04-10','09:00:00',2.51),('16273','2014-04-10','09:05:00',2.58),('16273','2014-04-10','09:10:00',2.64),('16273','2014-04-10','09:15:00',2.72),('16273','2014-04-10','09:20:00',2.75),('16273','2014-04-10','09:25:00',2.83),('16273','2014-04-10','09:30:00',2.9),('16273','2014-04-10','09:35:00',2.94),('16273','2014-04-10','09:40:00',2.99),('16273','2014-04-10','09:45:00',3.02),('16273','2014-04-10','09:50:00',3.09),('16273','2014-04-10','09:55:00',3.15),('16273','2014-04-10','10:00:00',3.19),('16273','2014-04-10','10:05:00',3.25),('16273','2014-04-10','10:10:00',3.33),('16273','2014-04-10','10:15:00',3.29),('16273','2014-04-10','10:20:00',3.34),('16273','2014-04-10','10:25:00',3.38),('16273','2014-04-10','10:30:00',3.4),('16273','2014-04-10','10:35:00',3.56),('16273','2014-04-10','10:40:00',3.58),('16273','2014-04-10','10:45:00',3.53),('16273','2014-04-10','10:50:00',3.54),('16273','2014-04-10','10:55:00',3.61),('16273','2014-04-10','11:00:00',3.67),('16273','2014-04-10','11:05:00',3.74),('16273','2014-04-10','11:10:00',3.76),('16273','2014-04-10','11:15:00',3.77),('16273','2014-04-10','11:20:00',3.89),('16273','2014-04-10','11:25:00',3.91),('16273','2014-04-10','11:30:00',3.91),('16273','2014-04-10','11:35:00',3.81),('16273','2014-04-10','11:40:00',3.84),('16273','2014-04-10','11:45:00',3.86),('16273','2014-04-10','11:50:00',3.79),('16273','2014-04-10','11:55:00',3.79),('16273','2014-04-10','12:00:00',3.69),('16273','2014-04-10','12:05:00',3.57),('16273','2014-04-10','12:10:00',3.8),('16273','2014-04-10','12:15:00',3.85),('16273','2014-04-10','12:20:00',3.79),('16273','2014-04-10','12:25:00',3.78),('16273','2014-04-10','12:30:00',3.66),('16273','2014-04-10','12:35:00',3.87),('16273','2014-04-10','12:40:00',3.68),('16273','2014-04-10','12:45:00',3.84),('16273','2014-04-10','12:50:00',3.81),('16273','2014-04-10','12:55:00',3.86),('16273','2014-04-10','13:00:00',3.72),('16273','2014-04-10','13:05:00',3.41),('16273','2014-04-10','13:10:00',3.9),('16273','2014-04-10','13:15:00',3.8),('16273','2014-04-10','13:20:00',3.6),('16273','2014-04-10','13:25:00',3.69),('16273','2014-04-10','13:30:00',3.67),('16273','2014-04-10','13:35:00',3.7),('16273','2014-04-10','13:40:00',3.63),('16273','2014-04-10','13:45:00',3.67),('16273','2014-04-10','13:50:00',3.61),('16273','2014-04-10','13:55:00',3.57),('16273','2014-04-10','14:00:00',3.54),('16273','2014-04-10','14:05:00',3.49),('16273','2014-04-10','14:10:00',3.42),('16273','2014-04-10','14:15:00',3.5),('16273','2014-04-10','14:20:00',3.44),('16273','2014-04-10','14:25:00',3.41),('16273','2014-04-10','14:30:00',3.37),('16273','2014-04-10','14:35:00',3.25),('16273','2014-04-10','14:40:00',3.31),('16273','2014-04-10','14:45:00',2.89),('16273','2014-04-10','14:50:00',3),('16273','2014-04-10','14:55:00',3.1),('16273','2014-04-10','15:00:00',3.08),('16273','2014-04-10','15:05:00',2.98),('16273','2014-04-10','15:10:00',2.95),('16273','2014-04-10','15:15:00',2.9),('16273','2014-04-10','15:20:00',2.76),('16273','2014-04-10','15:25:00',2.72),('16273','2014-04-10','15:30:00',2.51),('16273','2014-04-10','15:35:00',2.39),('16273','2014-04-10','15:40:00',2.51),('16273','2014-04-10','15:45:00',2.45),('16273','2014-04-10','15:50:00',2.37),('16273','2014-04-10','15:55:00',2.55),('16273','2014-04-10','16:00:00',2.5),('16273','2014-04-10','16:05:00',2.35),('16273','2014-04-10','16:10:00',2.37),('16273','2014-04-10','16:15:00',2.3),('16273','2014-04-10','16:20:00',2.19),('16273','2014-04-10','16:25:00',2.05),('16273','2014-04-10','16:30:00',2.12),('16273','2014-04-10','16:35:00',1.92),('16273','2014-04-10','16:40:00',1.9),('16273','2014-04-10','16:45:00',1.81),('16273','2014-04-10','16:50:00',1.77),('16273','2014-04-10','16:55:00',1.65),('16273','2014-04-10','17:00:00',1.56),('16273','2014-04-10','17:05:00',1.49),('16273','2014-04-10','17:10:00',1.43),('16273','2014-04-10','17:15:00',1.32),('16273','2014-04-10','17:20:00',1.24),('16273','2014-04-10','17:25:00',1.15),('16273','2014-04-10','17:30:00',1.07),('16273','2013-08-19','07:50:00',1.09),('16273','2013-08-19','07:55:00',1.09),('16273','2013-08-19','08:00:00',1.24),('16273','2013-08-19','08:05:00',1.37),('16273','2013-08-19','08:10:00',1.45),('16273','2013-08-19','08:15:00',1.53),('16273','2013-08-19','08:20:00',1.61),('16273','2013-08-19','08:25:00',1.67),('16273','2013-08-19','08:30:00',1.76),('16273','2013-08-19','08:35:00',1.86),('16273','2013-08-19','08:40:00',1.95),('16273','2013-08-19','08:45:00',2.03),('16273','2013-08-19','08:50:00',2.09),('16273','2013-08-19','08:55:00',2.16),('16273','2013-08-19','09:00:00',2.22),('16273','2013-08-19','09:05:00',2.31),('16273','2013-08-19','09:10:00',2.37),('16273','2013-08-19','09:15:00',2.46),('16273','2013-08-19','09:20:00',2.5),('16273','2013-08-19','09:25:00',2.55),('16273','2013-08-19','09:30:00',2.61),('16273','2013-08-19','09:35:00',2.68),('16273','2013-08-19','09:40:00',2.72),('16273','2013-08-19','09:45:00',2.79),('16273','2013-08-19','09:50:00',2.85),('16273','2013-08-19','09:55:00',2.89),('16273','2013-08-19','10:00:00',2.95),('16273','2013-08-19','10:05:00',2.99),('16273','2013-08-19','10:10:00',3),('16273','2013-08-19','10:15:00',3.03),('16273','2013-08-19','10:20:00',3.09),('16273','2013-08-19','10:25:00',3.11),('16273','2013-08-19','10:30:00',3.12),('16273','2013-08-19','10:35:00',3.19),('16273','2013-08-19','10:40:00',3.26),('16273','2013-08-19','10:45:00',3.33),('16273','2013-08-19','10:50:00',3.34),('16273','2013-08-19','10:55:00',3.32),('16273','2013-08-19','11:00:00',3.34),('16273','2013-08-19','11:05:00',3.38),('16273','2013-08-19','11:10:00',3.4),('16273','2013-08-19','11:15:00',3.44),('16273','2013-08-19','11:20:00',3.48),('16273','2013-08-19','11:25:00',3.47),('16273','2013-08-19','11:30:00',3.49),('16273','2013-08-19','11:35:00',3.5),('16273','2013-08-19','11:40:00',3.53),('16273','2013-08-19','11:45:00',3.54),('16273','2013-08-19','11:50:00',3.58),('16273','2013-08-19','11:55:00',3.58),('16273','2013-08-19','12:00:00',3.62),('16273','2013-08-19','12:05:00',3.58),('16273','2013-08-19','12:10:00',3.63),('16273','2013-08-19','12:15:00',3.61),('16273','2013-08-19','12:20:00',3.65),('16273','2013-08-19','12:25:00',3.69),('16273','2013-08-19','12:30:00',3.7),('16273','2013-08-19','12:35:00',3.69),('16273','2013-08-19','12:40:00',3.7),('16273','2013-08-19','12:45:00',3.69),('16273','2013-08-19','12:50:00',3.68),('16273','2013-08-19','12:55:00',3.69),('16273','2013-08-19','13:00:00',3.68),('16273','2013-08-19','13:05:00',3.67),('16273','2013-08-19','13:10:00',3.68),('16273','2013-08-19','13:15:00',3.68),('16273','2013-08-19','13:20:00',3.64),('16273','2013-08-19','13:25:00',3.62),('16273','2013-08-19','13:30:00',3.61),('16273','2013-08-19','13:35:00',3.58),('16273','2013-08-19','13:40:00',3.59),('16273','2013-08-19','13:45:00',3.57),('16273','2013-08-19','13:50:00',3.51),('16273','2013-08-19','13:55:00',3.52),('16273','2013-08-19','14:00:00',3.47),('16273','2013-08-19','14:05:00',3.45),('16273','2013-08-19','14:10:00',3.45),('16273','2013-08-19','14:15:00',3.43),('16273','2013-08-19','14:20:00',3.4),('16273','2013-08-19','14:25:00',3.38),('16273','2013-08-19','14:30:00',3.33),('16273','2013-08-19','14:35:00',3.28),('16273','2013-08-19','14:40:00',3.25),('16273','2013-08-19','14:45:00',3.2),('16273','2013-08-19','14:50:00',3.16),('16273','2013-08-19','14:55:00',3.13),('16273','2013-08-19','15:00:00',3.08),('16273','2013-08-19','15:05:00',3.01),('16273','2013-08-19','15:10:00',3),('16273','2013-08-19','15:15:00',2.95),('16273','2013-08-19','15:20:00',2.91),('16273','2013-08-19','15:25:00',2.85),('16273','2013-08-19','15:30:00',2.78),('16273','2013-08-19','15:35:00',2.72),('16273','2013-08-19','15:40:00',2.66),('16273','2013-08-19','15:45:00',2.57),('16273','2013-08-19','15:50:00',2.53),('16273','2013-08-19','15:55:00',2.49),('16273','2013-08-19','16:00:00',2.42),('16273','2013-08-19','16:05:00',2.36),('16273','2013-08-19','16:10:00',2.3),('16273','2013-08-19','16:15:00',2.22),('16273','2013-08-19','16:20:00',2.14),('16273','2013-08-19','16:25:00',2.08),('16273','2013-08-19','16:30:00',2.02),('16273','2013-08-19','16:35:00',1.96),('16273','2013-08-19','16:40:00',1.88),('16273','2013-08-19','16:45:00',1.81),('16273','2013-08-19','16:50:00',1.73),('16273','2013-08-19','16:55:00',1.66),('16273','2013-08-19','17:00:00',1.59),('16273','2013-08-19','17:05:00',1.52),('16273','2013-08-19','17:10:00',1.44),('16273','2013-08-19','17:15:00',1.37),('16273','2013-08-19','17:20:00',1.29),('16273','2013-08-19','17:25:00',1.21),('16273','2013-08-19','17:30:00',1.15),('16273','2013-08-19','17:35:00',1.08),('16273','2013-08-18','07:45:00',1.09),('16273','2013-08-18','07:50:00',1.19),('16273','2013-08-18','07:55:00',1.28),('16273','2013-08-18','08:00:00',1.37),('16273','2013-08-18','08:05:00',1.45),('16273','2013-08-18','08:10:00',1.54),('16273','2013-08-18','08:15:00',1.62),('16273','2013-08-18','08:20:00',1.71),('16273','2013-08-18','08:25:00',1.79),('16273','2013-08-18','08:30:00',1.87),('16273','2013-08-18','08:35:00',1.94),('16273','2013-08-18','08:40:00',2.02),('16273','2013-08-18','08:45:00',2.08),('16273','2013-08-18','08:50:00',2.15),('16273','2013-08-18','08:55:00',2.22),('16273','2013-08-18','09:00:00',2.3),('16273','2013-08-18','09:05:00',2.38),('16273','2013-08-18','09:10:00',2.43),('16273','2013-08-18','09:15:00',2.49),('16273','2013-08-18','09:20:00',2.56),('16273','2013-08-18','09:25:00',2.62),('16273','2013-08-18','09:30:00',2.66),('16273','2013-08-18','09:35:00',2.42),('16273','2013-08-18','09:40:00',2.37),('16273','2013-08-18','09:45:00',2.78),('16273','2013-08-18','09:50:00',2.62),('16273','2013-08-18','09:55:00',2.88),('16273','2013-08-18','10:00:00',2.94),('16273','2013-08-18','10:05:00',2.99),('16273','2013-08-18','10:10:00',3.04),('16273','2013-08-18','10:15:00',3.08),('16273','2013-08-18','10:20:00',3.1),('16273','2013-08-18','10:25:00',3.14),('16273','2013-08-18','10:30:00',3.16),('16273','2013-08-18','10:35:00',3.19),('16273','2013-08-18','10:40:00',3.2),('16273','2013-08-18','10:45:00',3.23),('16273','2013-08-18','10:50:00',3.24),('16273','2013-08-18','10:55:00',3.3),('16273','2013-08-18','11:00:00',3.35),('16273','2013-08-18','11:05:00',3.37),('16273','2013-08-18','11:10:00',3.38),('16273','2013-08-18','11:15:00',3.36),('16273','2013-08-18','11:20:00',3.43),('16273','2013-08-18','11:25:00',3.41),('16273','2013-08-18','11:30:00',3.41),('16273','2013-08-18','11:35:00',3.46),('16273','2013-08-18','11:40:00',3.46),('16273','2013-08-18','11:45:00',3.52),('16273','2013-08-18','11:50:00',3.55),('16273','2013-08-18','11:55:00',3.61),('16273','2013-08-18','12:00:00',2.68),('16273','2013-08-18','12:05:00',3.67),('16273','2013-08-18','12:10:00',3.6),('16273','2013-08-18','12:15:00',3.52),('16273','2013-08-18','12:20:00',3.68),('16273','2013-08-18','12:25:00',3.62),('16273','2013-08-18','12:30:00',3.65),('16273','2013-08-18','12:35:00',3.61),('16273','2013-08-18','12:40:00',3.54),('16273','2013-08-18','12:45:00',3.61),('16273','2013-08-18','12:50:00',3.65),('16273','2013-08-18','12:55:00',3.62),('16273','2013-08-18','13:00:00',3.61),('16273','2013-08-18','13:05:00',3.62),('16273','2013-08-18','13:10:00',3.61),('16273','2013-08-18','13:15:00',3.61),('16273','2013-08-18','13:20:00',3.56),('16273','2013-08-18','13:25:00',3.59),('16273','2013-08-18','13:30:00',3.57),('16273','2013-08-18','13:35:00',3.57),('16273','2013-08-18','13:40:00',3.55),('16273','2013-08-18','13:45:00',3.52),('16273','2013-08-18','13:50:00',3.51),('16273','2013-08-18','13:55:00',3.48),('16273','2013-08-18','14:00:00',3.48),('16273','2013-08-18','14:05:00',3.46),('16273','2013-08-18','14:10:00',3.42),('16273','2013-08-18','14:15:00',3.39),('16273','2013-08-18','14:20:00',3.35),('16273','2013-08-18','14:25:00',3.34),('16273','2013-08-18','14:30:00',3.31),('16273','2013-08-18','14:35:00',3.28),('16273','2013-08-18','14:40:00',3.24),('16273','2013-08-18','14:45:00',3.2),('16273','2013-08-18','14:50:00',3.15),('16273','2013-08-18','14:55:00',3.13),('16273','2013-08-18','15:00:00',3.07),('16273','2013-08-18','15:05:00',3.03),('16273','2013-08-18','15:10:00',2.99),('16273','2013-08-18','15:15:00',2.92),('16273','2013-08-18','15:20:00',2.86),('16273','2013-08-18','15:25:00',2.83),('16273','2013-08-18','15:30:00',2.76),('16273','2013-08-18','15:35:00',2.7),('16273','2013-08-18','15:40:00',2.65),('16273','2013-08-18','15:45:00',2.6),('16273','2013-08-18','15:50:00',2.55),('16273','2013-08-18','15:55:00',2.49),('16273','2013-08-18','16:00:00',2.43),('16273','2013-08-18','16:05:00',2.35),('16273','2013-08-18','16:10:00',2.3),('16273','2013-08-18','16:15:00',2.24),('16273','2013-08-18','16:20:00',2.17),('16273','2013-08-18','16:25:00',2.1),('16273','2013-08-18','16:30:00',2.03),('16273','2013-08-18','16:35:00',1.96),('16273','2013-08-18','16:40:00',1.88),('16273','2013-08-18','16:45:00',1.82),('16273','2013-08-18','16:50:00',1.75),('16273','2013-08-18','16:55:00',1.68),('16273','2013-08-18','17:00:00',1.61),('16273','2013-08-18','17:05:00',1.53),('16273','2013-08-18','17:10:00',1.46),('16273','2013-08-18','17:15:00',1.39),('16273','2013-08-18','17:20:00',1.31),('16273','2013-08-18','17:25:00',1.25),('16273','2013-08-18','17:30:00',1.17),('16273','2013-08-18','17:35:00',1.1),('16273','2013-08-18','17:40:00',1.03),('16273','2013-08-17','07:45:00',1.08),('16273','2013-08-17','07:50:00',1.17),('16273','2013-08-17','07:55:00',1.25),('16273','2013-08-17','08:00:00',1.33),('16273','2013-08-17','08:05:00',1.41),('16273','2013-08-17','08:10:00',1.49),('16273','2013-08-17','08:15:00',1.57),('16273','2013-08-17','08:20:00',1.68),('16273','2013-08-17','08:25:00',1.77),('16273','2013-08-17','08:30:00',1.85),('16273','2013-08-17','08:35:00',1.94),('16273','2013-08-17','08:40:00',2.01),('16273','2013-08-17','08:45:00',2.1),('16273','2013-08-17','08:50:00',2.19),('16273','2013-08-17','08:55:00',2.25),('16273','2013-08-17','09:00:00',2.31),('16273','2013-08-17','09:05:00',2.38),('16273','2013-08-17','09:10:00',2.46),('16273','2013-08-17','09:15:00',2.5),('16273','2013-08-17','09:20:00',2.58),('16273','2013-08-17','09:25:00',2.63),('16273','2013-08-17','09:30:00',2.7),('16273','2013-08-17','09:35:00',2.74),('16273','2013-08-17','09:40:00',2.79),('16273','2013-08-17','09:45:00',2.84),('16273','2013-08-17','09:50:00',2.9),('16273','2013-08-17','09:55:00',2.94),('16273','2013-08-17','10:00:00',2.99),('16273','2013-08-17','10:05:00',3.04),('16273','2013-08-17','10:10:00',3.08),('16273','2013-08-17','10:15:00',3.13),('16273','2013-08-17','10:20:00',3.15),('16273','2013-08-17','10:25:00',3.17),('16273','2013-08-17','10:30:00',3.2),('16273','2013-08-17','10:35:00',3.25),('16273','2013-08-17','10:40:00',3.27),('16273','2013-08-17','10:45:00',3.31),('16273','2013-08-17','10:50:00',3.34),('16273','2013-08-17','10:55:00',3.36),('16273','2013-08-17','11:00:00',3.39),('16273','2013-08-17','11:05:00',3.39),('16273','2013-08-17','11:10:00',3.42),('16273','2013-08-17','11:15:00',3.45),('16273','2013-08-17','11:20:00',3.47),('16273','2013-08-17','11:25:00',3.48),('16273','2013-08-17','11:30:00',3.47),('16273','2013-08-17','11:35:00',3.53),('16273','2013-08-17','11:40:00',3.49),('16273','2013-08-17','11:45:00',3.5),('16273','2013-08-17','11:50:00',3.51),('16273','2013-08-17','11:55:00',3.59),('16273','2013-08-17','12:00:00',3.55),('16273','2013-08-17','12:05:00',3.57),('16273','2013-08-17','12:10:00',3.57),('16273','2013-08-17','12:15:00',3.46),('16273','2013-08-17','12:20:00',3.66),('16273','2013-08-17','12:25:00',3.66),('16273','2013-08-17','12:30:00',3.68),('16273','2013-08-17','12:35:00',3.66),('16273','2013-08-17','12:40:00',3.62),('16273','2013-08-17','12:45:00',3.43),('16273','2013-08-17','12:50:00',3.66),('16273','2013-08-17','12:55:00',3.64),('16273','2013-08-17','13:00:00',3.63),('16273','2013-08-17','13:05:00',3.66),('16273','2013-08-17','13:10:00',3.66),('16273','2013-08-17','13:15:00',3.6),('16273','2013-08-17','13:20:00',3.57),('16273','2013-08-17','13:25:00',3.67),('16273','2013-08-17','13:30:00',3.56),('16273','2013-08-17','13:35:00',3.48),('16273','2013-08-17','13:40:00',3.43),('16273','2013-08-17','13:45:00',3.57),('16273','2013-08-17','13:50:00',3.48),('16273','2013-08-17','13:55:00',3.4),('16273','2013-08-17','14:00:00',3.46),('16273','2013-08-17','14:05:00',3.46),('16273','2013-08-17','14:10:00',3.4),('16273','2013-08-17','14:15:00',3.41),('16273','2013-08-17','14:20:00',3.35),('16273','2013-08-17','14:25:00',3.33),('16273','2013-08-17','14:30:00',3.29),('16273','2013-08-17','14:35:00',3.27),('16273','2013-08-17','14:40:00',3.21),('16273','2013-08-17','14:45:00',3.19),('16273','2013-08-17','14:50:00',3.16),('16273','2013-08-17','14:55:00',3.12),('16273','2013-08-17','15:00:00',3.08),('16273','2013-08-17','15:05:00',3.03),('16273','2013-08-17','15:10:00',2.98),('16273','2013-08-17','15:15:00',2.92),('16273','2013-08-17','15:20:00',2.9),('16273','2013-08-17','15:25:00',2.85),('16273','2013-08-17','15:30:00',2.81),('16273','2013-08-17','15:35:00',2.75),('16273','2013-08-17','15:40:00',2.69),('16273','2013-08-17','15:45:00',2.63),('16273','2013-08-17','15:50:00',2.57),('16273','2013-08-17','15:55:00',2.51),('16273','2013-08-17','16:00:00',2.45),('16273','2013-08-17','16:05:00',2.4),('16273','2013-08-17','16:10:00',2.34),('16273','2013-08-17','16:15:00',2.27),('16273','2013-08-17','16:20:00',2.21),('16273','2013-08-17','16:25:00',2.15),('16273','2013-08-17','16:30:00',2.08),('16273','2013-08-17','16:35:00',2.02),('16273','2013-08-17','16:40:00',1.92),('16273','2013-08-17','16:45:00',1.87),('16273','2013-08-17','16:50:00',1.79),('16273','2013-08-17','16:55:00',1.73),('16273','2013-08-17','17:00:00',1.6),('16273','2013-08-17','17:05:00',1.57),('16273','2013-08-17','17:10:00',1.43),('16273','2013-08-17','17:15:00',1.46),('16273','2013-08-17','17:20:00',1.35),('16273','2013-08-17','17:25:00',1.33),('16273','2013-08-17','17:30:00',1.25),('16273','2013-08-17','17:35:00',1.19),('16273','2013-08-17','17:40:00',1.1),('16273','2013-08-17','17:45:00',1.02),('16273','2013-08-16','07:45:00',1.13),('16273','2013-08-16','07:50:00',1.22),('16273','2013-08-16','07:55:00',1.31),('16273','2013-08-16','08:00:00',1.4),('16273','2013-08-16','08:05:00',1.48),('16273','2013-08-16','08:10:00',1.56),('16273','2013-08-16','08:15:00',1.64),('16273','2013-08-16','08:20:00',1.73),('16273','2013-08-16','08:25:00',1.8),('16273','2013-08-16','08:30:00',1.88),('16273','2013-08-16','08:35:00',1.96),('16273','2013-08-16','08:40:00',2.04),('16273','2013-08-16','08:45:00',2.13),('16273','2013-08-16','08:50:00',2.21),('16273','2013-08-16','08:55:00',2.3),('16273','2013-08-16','09:00:00',2.38),('16273','2013-08-16','09:05:00',2.46),('16273','2013-08-16','09:10:00',2.53),('16273','2013-08-16','09:15:00',2.6),('16273','2013-08-16','09:20:00',2.66),('16273','2013-08-16','09:25:00',2.69),('16273','2013-08-16','09:30:00',2.79),('16273','2013-08-16','09:35:00',2.85),('16273','2013-08-16','09:40:00',2.89),('16273','2013-08-16','09:45:00',2.95),('16273','2013-08-16','09:50:00',3),('16273','2013-08-16','09:55:00',3.07),('16273','2013-08-16','10:00:00',3.11),('16273','2013-08-16','10:05:00',3.15),('16273','2013-08-16','10:10:00',3.19),('16273','2013-08-16','10:15:00',3.24),('16273','2013-08-16','10:20:00',3.28),('16273','2013-08-16','10:25:00',3.31),('16273','2013-08-16','10:30:00',3.35),('16273','2013-08-16','10:35:00',3.39),('16273','2013-08-16','10:40:00',3.41),('16273','2013-08-16','10:45:00',3.44),('16273','2013-08-16','10:50:00',3.48),('16273','2013-08-16','10:55:00',3.51),('16273','2013-08-16','11:00:00',3.53),('16273','2013-08-16','11:05:00',3.57),('16273','2013-08-16','11:10:00',3.57),('16273','2013-08-16','11:15:00',3.58),('16273','2013-08-16','11:20:00',3.63),('16273','2013-08-16','11:25:00',3.65),('16273','2013-08-16','11:30:00',3.65),('16273','2013-08-16','11:35:00',3.67),('16273','2013-08-16','11:40:00',3.66),('16273','2013-08-16','11:45:00',3.67),('16273','2013-08-16','11:50:00',3.67),('16273','2013-08-16','11:55:00',3.68),('16273','2013-08-16','12:00:00',3.68),('16273','2013-08-16','12:05:00',3.7),('16273','2013-08-16','12:10:00',3.69),('16273','2013-08-16','12:15:00',3.69),('16273','2013-08-16','12:20:00',3.71),('16273','2013-08-16','12:25:00',3.7),('16273','2013-08-16','12:30:00',3.64),('16273','2013-08-16','12:35:00',3.7),('16273','2013-08-16','12:40:00',3.68),('16273','2013-08-16','12:45:00',3.68),('16273','2013-08-16','12:50:00',3.66),('16273','2013-08-16','12:55:00',3.64),('16273','2013-08-16','13:00:00',3.62),('16273','2013-08-16','13:05:00',3.61),('16273','2013-08-16','13:10:00',3.58),('16273','2013-08-16','13:15:00',3.57),('16273','2013-08-16','13:20:00',3.54),('16273','2013-08-16','13:25:00',3.55),('16273','2013-08-16','13:30:00',3.54),('16273','2013-08-16','13:35:00',3.51),('16273','2013-08-16','13:40:00',3.47),('16273','2013-08-16','13:45:00',3.43),('16273','2013-08-16','13:50:00',3.43),('16273','2013-08-16','13:55:00',3.39),('16273','2013-08-16','14:00:00',3.37),('16273','2013-08-16','14:05:00',3.35),('16273','2013-08-16','14:10:00',3.33),('16273','2013-08-16','14:15:00',3.3),('16273','2013-08-16','14:20:00',3.27),('16273','2013-08-16','14:25:00',3.24),('16273','2013-08-16','14:30:00',3.17),('16273','2013-08-16','14:35:00',3.17),('16273','2013-08-16','14:40:00',3.19),('16273','2013-08-16','14:45:00',3.17),('16273','2013-08-16','14:50:00',3.14),('16273','2013-08-16','14:55:00',3.1),('16273','2013-08-16','15:00:00',3.06),('16273','2013-08-16','15:05:00',3.04),('16273','2013-08-16','15:10:00',2.99),('16273','2013-08-16','15:15:00',2.95),('16273','2013-08-16','15:20:00',2.91),('16273','2013-08-16','15:25:00',2.85),('16273','2013-08-16','15:30:00',2.78),('16273','2013-08-16','15:35:00',2.74),('16273','2013-08-16','15:40:00',2.68),('16273','2013-08-16','15:45:00',2.62),('16273','2013-08-16','15:50:00',2.56),('16273','2013-08-16','15:55:00',2.5),('16273','2013-08-16','16:00:00',2.43),('16273','2013-08-16','16:05:00',2.38),('16273','2013-08-16','16:10:00',2.31),('16273','2013-08-16','16:15:00',2.25),('16273','2013-08-16','16:20:00',2.18),('16273','2013-08-16','16:25:00',2.12),('16273','2013-08-16','16:30:00',2.05),('16273','2013-08-16','16:35:00',1.98),('16273','2013-08-16','16:40:00',1.91),('16273','2013-08-16','16:45:00',1.83),('16273','2013-08-16','16:50:00',1.77),('16273','2013-08-16','16:55:00',1.69),('16273','2013-08-16','17:00:00',1.61),('16273','2013-08-16','17:05:00',1.54),('16273','2013-08-16','17:10:00',1.47),('16273','2013-08-16','17:15:00',1.39),('16273','2013-08-16','17:20:00',1.33),('16273','2013-08-16','17:25:00',1.25),('16273','2013-08-16','17:30:00',1.18),('16273','2013-08-16','17:35:00',1.11),('16273','2013-08-16','17:40:00',1.04),('16273','2013-08-15','08:05:00',1.28),('16273','2013-08-15','08:10:00',1.77),('16273','2013-08-15','08:15:00',1.91),('16273','2013-08-15','08:20:00',1.93),('16273','2013-08-15','08:25:00',1.95),('16273','2013-08-15','08:30:00',1.98),('16273','2013-08-15','08:35:00',2.04),('16273','2013-08-15','08:40:00',2.1),('16273','2013-08-15','08:45:00',2.19),('16273','2013-08-15','08:50:00',2.26),('16273','2013-08-15','08:55:00',2.15),('16273','2013-08-15','09:00:00',2.44),('16273','2013-08-15','09:05:00',2.51),('16273','2013-08-15','09:10:00',2.6),('16273','2013-08-15','09:15:00',2.66),('16273','2013-08-15','09:20:00',2.72),('16273','2013-08-15','09:25:00',2.76),('16273','2013-08-15','09:30:00',2.81),('16273','2013-08-15','09:35:00',2.86),('16273','2013-08-15','09:40:00',2.9),('16273','2013-08-15','09:45:00',2.95),('16273','2013-08-15','09:50:00',3.03),('16273','2013-08-15','09:55:00',3.08),('16273','2013-08-15','10:00:00',3.14),('16273','2013-08-15','10:05:00',3.2),('16273','2013-08-15','10:10:00',3.25),('16273','2013-08-15','10:15:00',3.29),('16273','2013-08-15','10:20:00',3.32),('16273','2013-08-15','10:25:00',3.34),('16273','2013-08-15','10:30:00',3.37),('16273','2013-08-15','10:35:00',3.43),('16273','2013-08-15','10:40:00',3.48),('16273','2013-08-15','10:45:00',3.53),('16273','2013-08-15','10:50:00',3.56),('16273','2013-08-15','10:55:00',3.6),('16273','2013-08-15','11:00:00',3.64),('16273','2013-08-15','11:05:00',3.7),('16273','2013-08-15','11:10:00',3.6),('16273','2013-08-15','11:15:00',3.4),('16273','2013-08-15','11:20:00',3.49),('16273','2013-08-15','11:25:00',3.73),('16273','2013-08-15','11:30:00',3.58),('16273','2013-08-15','11:35:00',3.71),('16273','2013-08-15','11:40:00',3.79),('16273','2013-08-15','11:45:00',3.4),('16273','2013-08-15','11:50:00',2.77),('16273','2013-08-15','11:55:00',2.51),('16273','2013-08-15','12:00:00',2.58),('16273','2013-08-15','12:05:00',3.07),('16273','2013-08-15','12:10:00',3.4),('16273','2013-08-15','12:15:00',3.58),('16273','2013-08-15','12:20:00',3.48),('16273','2013-08-15','12:25:00',3.46),('16273','2013-08-15','12:30:00',3.65),('16273','2013-08-15','12:35:00',3.77),('16273','2013-08-15','12:40:00',3.84),('16273','2013-08-15','12:45:00',3.85),('16273','2013-08-15','12:50:00',3.84),('16273','2013-08-15','12:55:00',3.78),('16273','2013-08-15','13:00:00',3.77),('16273','2013-08-15','13:05:00',3.64),('16273','2013-08-15','13:10:00',3.53),('16273','2013-08-15','13:15:00',3.51),('16273','2013-08-15','13:20:00',3.41),('16273','2013-08-15','13:25:00',3.5),('16273','2013-08-15','13:30:00',3.52),('16273','2013-08-15','13:35:00',3.46),('16273','2013-08-15','13:40:00',3.37),('16273','2013-08-15','13:45:00',3.44),('16273','2013-08-15','13:50:00',3.48),('16273','2013-08-15','13:55:00',3.48),('16273','2013-08-15','14:00:00',3.4),('16273','2013-08-15','14:05:00',3.21),('16273','2013-08-15','14:10:00',3.35),('16273','2013-08-15','14:15:00',3.28),('16273','2013-08-15','14:20:00',2.85),('16273','2013-08-15','14:25:00',2.91),('16273','2013-08-15','14:30:00',3.26),('16273','2013-08-15','14:35:00',3.17),('16273','2013-08-15','14:40:00',3.17),('16273','2013-08-15','14:45:00',3.14),('16273','2013-08-15','14:50:00',3.08),('16273','2013-08-15','14:55:00',2.96),('16273','2013-08-15','15:00:00',2.94),('16273','2013-08-15','15:05:00',2.93),('16273','2013-08-15','15:10:00',2.88),('16273','2013-08-15','15:15:00',2.81),('16273','2013-08-15','15:20:00',2.73),('16273','2013-08-15','15:25:00',2.77),('16273','2013-08-15','15:30:00',2.71),('16273','2013-08-15','15:35:00',2.66),('16273','2013-08-15','15:40:00',2.62),('16273','2013-08-15','15:45:00',2.56),('16273','2013-08-15','15:50:00',2.03),('16273','2013-08-15','15:55:00',2.45),('16273','2013-08-15','16:00:00',2.37),('16273','2013-08-15','16:05:00',2.37),('16273','2013-08-15','16:10:00',2.32),('16273','2013-08-15','16:15:00',2.02),('16273','2013-08-15','16:20:00',1.97),('16273','2013-08-15','16:25:00',1.52),('16273','2013-08-15','16:35:00',1.43),('16273','2013-08-15','16:40:00',1.46),('16273','2013-08-15','16:45:00',1.25),('16273','2013-08-15','16:50:00',1.7),('16273','2013-08-15','16:55:00',1.09),('16273','2013-08-15','17:00:00',1.7),('16273','2013-08-15','17:05:00',1.64),('16273','2013-08-15','17:10:00',1.55),('16273','2013-08-15','17:15:00',1.47),('16273','2013-08-15','17:20:00',1.41),('16273','2013-08-15','17:25:00',1.3),('16273','2013-08-15','17:30:00',1.12),('16273','2013-08-15','17:35:00',1.16),('16273','2013-08-15','17:40:00',1.06),('16273','2013-08-14','07:50:00',1.08),('16273','2013-08-14','07:55:00',1.24),('16273','2013-08-14','08:00:00',1.34),('16273','2013-08-14','08:05:00',1.31),('16273','2013-08-14','08:10:00',1.51),('16273','2013-08-14','08:15:00',1.54),('16273','2013-08-14','08:20:00',1.58),('16273','2013-08-14','08:25:00',1.55),('16273','2013-08-14','08:35:00',1.83),('16273','2013-08-14','08:40:00',2.03),('16273','2013-08-14','08:45:00',2.25),('16273','2013-08-14','08:50:00',1.89),('16273','2013-08-14','08:55:00',1.22),('16273','2013-08-14','09:15:00',1.43),('16273','2013-08-14','09:20:00',1.25),('16273','2013-08-14','09:25:00',2.36),('16273','2013-08-14','09:30:00',2.54),('16273','2013-08-14','09:35:00',2.45),('16273','2013-08-14','09:40:00',2.12),('16273','2013-08-14','09:45:00',1.75),('16273','2013-08-14','09:50:00',2.76),('16273','2013-08-14','09:55:00',3.39),('16273','2013-08-14','10:00:00',3.06),('16273','2013-08-14','10:05:00',3.22),('16273','2013-08-14','10:10:00',2.56),('16273','2013-08-14','10:15:00',1.79),('16273','2013-08-14','10:20:00',1.05),('16273','2013-08-14','10:25:00',1.17),('16273','2013-08-14','10:30:00',1.38),('16273','2013-08-14','10:35:00',3.48),('16273','2013-08-14','10:40:00',3.35),('16273','2013-08-14','10:45:00',1.98),('16273','2013-08-14','10:50:00',2.19),('16273','2013-08-14','10:55:00',1.21),('16273','2013-08-14','11:00:00',1.21),('16273','2013-08-14','11:05:00',1.19),('16273','2013-08-14','11:10:00',1.27),('16273','2013-08-14','11:15:00',2.9),('16273','2013-08-14','11:20:00',3.9),('16273','2013-08-14','11:25:00',2.18),('16273','2013-08-14','11:30:00',1.24),('16273','2013-08-14','11:35:00',1.29),('16273','2013-08-14','11:40:00',3.34),('16273','2013-08-14','11:45:00',2.1),('16273','2013-08-14','11:50:00',1.82),('16273','2013-08-14','11:55:00',3.25),('16273','2013-08-14','12:00:00',3.7),('16273','2013-08-14','12:05:00',3.72),('16273','2013-08-14','12:10:00',3.89),('16273','2013-08-14','12:15:00',3.86),('16273','2013-08-14','12:20:00',3.91),('16273','2013-08-14','12:25:00',3.84),('16273','2013-08-14','12:30:00',3.57),('16273','2013-08-14','12:35:00',1.96),('16273','2013-08-14','12:40:00',1.67),('16273','2013-08-14','12:45:00',1.09),('16273','2013-08-14','12:50:00',1.26),('16273','2013-08-14','12:55:00',1.69),('16273','2013-08-14','13:00:00',2.61),('16273','2013-08-14','13:05:00',3.19),('16273','2013-08-14','13:10:00',3.33),('16273','2013-08-14','13:15:00',3.65),('16273','2013-08-14','13:20:00',3.67),('16273','2013-08-14','13:25:00',3.79),('16273','2013-08-14','13:30:00',3.62),('16273','2013-08-14','13:35:00',3.62),('16273','2013-08-14','13:40:00',3.66),('16273','2013-08-14','13:45:00',3.7),('16273','2013-08-14','13:50:00',3.65),('16273','2013-08-14','13:55:00',3.56),('16273','2013-08-14','14:00:00',3.55),('16273','2013-08-14','14:05:00',3.61),('16273','2013-08-14','14:10:00',3.49),('16273','2013-08-14','14:15:00',2.64),('16273','2013-08-14','14:20:00',3.61),('16273','2013-08-14','14:25:00',3.43),('16273','2013-08-14','14:30:00',3.35),('16273','2013-08-14','14:35:00',3.31),('16273','2013-08-14','14:40:00',3.29),('16273','2013-08-14','14:45:00',3.23),('16273','2013-08-14','14:50:00',3.21),('16273','2013-08-14','14:55:00',3.18),('16273','2013-08-14','15:00:00',3.12),('16273','2013-08-14','15:05:00',3.08),('16273','2013-08-14','15:10:00',3.03),('16273','2013-08-14','15:15:00',2.98),('16273','2013-08-14','15:20:00',2.93),('16273','2013-08-14','15:25:00',2.9),('16273','2013-08-14','15:30:00',2.82),('16273','2013-08-14','15:35:00',2.79),('16273','2013-08-14','15:40:00',2.74),('16273','2013-08-14','15:45:00',2.67),('16273','2013-08-14','15:50:00',2.63),('16273','2013-08-14','15:55:00',2.55),('16273','2013-08-14','16:00:00',2.49),('16273','2013-08-14','16:05:00',2.43),('16273','2013-08-14','16:10:00',2.36),('16273','2013-08-14','16:15:00',2.29),('16273','2013-08-14','16:20:00',2.23),('16273','2013-08-14','16:25:00',2.16),('16273','2013-08-14','16:30:00',2.09),('16273','2013-08-14','16:35:00',2.03),('16273','2013-08-14','16:40:00',1.94),('16273','2013-08-14','16:45:00',1.88),('16273','2013-08-14','16:50:00',1.82),('16273','2013-08-14','16:55:00',1.74),('16273','2013-08-14','17:00:00',1.65),('16273','2013-08-14','17:05:00',1.59),('16273','2013-08-14','17:10:00',1.51),('16273','2013-08-14','17:15:00',1.44),('16273','2013-08-14','17:20:00',1.37),('16273','2013-08-14','17:25:00',1.29),('16273','2013-08-14','17:30:00',1.21),('16273','2013-08-14','17:35:00',1.16),('16273','2013-08-14','17:40:00',1.08),('16273','2013-08-14','17:45:00',1.01),('16273','2013-08-13','07:40:00',1.04),('16273','2013-08-13','07:45:00',1.14),('16273','2013-08-13','07:50:00',1.23),('16273','2013-08-13','07:55:00',1.32),('16273','2013-08-13','08:00:00',1.38),('16273','2013-08-13','08:05:00',1.47),('16273','2013-08-13','08:10:00',1.54),('16273','2013-08-13','08:15:00',1.64),('16273','2013-08-13','08:20:00',1.71),('16273','2013-08-13','08:25:00',1.8),('16273','2013-08-13','08:30:00',1.89),('16273','2013-08-13','08:35:00',1.96),('16273','2013-08-13','08:40:00',2.07),('16273','2013-08-13','08:45:00',2.13),('16273','2013-08-13','08:50:00',2.21),('16273','2013-08-13','08:55:00',2.25),('16273','2013-08-13','09:00:00',2.31),('16273','2013-08-13','09:05:00',2.39),('16273','2013-08-13','09:10:00',2.46),('16273','2013-08-13','09:15:00',2.55),('16273','2013-08-13','09:20:00',2.59),('16273','2013-08-13','09:25:00',2.61),('16273','2013-08-13','09:30:00',2.73),('16273','2013-08-13','09:35:00',2.59),('16273','2013-08-13','09:40:00',2.62),('16273','2013-08-13','09:45:00',2.25),('16273','2013-08-13','09:50:00',2.98),('16273','2013-08-13','09:55:00',3.06),('16273','2013-08-13','10:00:00',3.15),('16273','2013-08-13','10:05:00',3.25),('16273','2013-08-13','10:10:00',3.23),('16273','2013-08-13','10:15:00',3.26),('16273','2013-08-13','10:20:00',3.12),('16273','2013-08-13','10:25:00',3.24),('16273','2013-08-13','10:30:00',3.41),('16273','2013-08-13','10:35:00',3.4),('16273','2013-08-13','10:40:00',3.36),('16273','2013-08-13','10:45:00',3.41),('16273','2013-08-13','10:50:00',3.54),('16273','2013-08-13','10:55:00',2.66),('16273','2013-08-13','11:00:00',2),('16273','2013-08-13','11:05:00',3.01),('16273','2013-08-13','11:10:00',3.49),('16273','2013-08-13','11:15:00',3.52),('16273','2013-08-13','11:20:00',3.59),('16273','2013-08-13','11:25:00',3.56),('16273','2013-08-13','11:30:00',3.58),('16273','2013-08-13','11:35:00',3.55),('16273','2013-08-13','11:40:00',3.67),('16273','2013-08-13','11:45:00',3.69),('16273','2013-08-13','11:50:00',3.82),('16273','2013-08-13','11:55:00',2.4),('16273','2013-08-13','12:00:00',3.36),('16273','2013-08-13','12:05:00',4.01),('16273','2013-08-13','12:10:00',3.92),('16273','2013-08-13','12:15:00',3.84),('16273','2013-08-13','12:20:00',3.91),('16273','2013-08-13','12:25:00',3.52),('16273','2013-08-13','12:30:00',3.82),('16273','2013-08-13','12:35:00',3.8),('16273','2013-08-13','12:40:00',3.87),('16273','2013-08-13','12:45:00',3.81),('16273','2013-08-13','12:50:00',3.79),('16273','2013-08-13','12:55:00',3.11),('16273','2013-08-13','13:00:00',3.73),('16273','2013-08-13','13:05:00',3.76),('16273','2013-08-13','13:10:00',3.66),('16273','2013-08-13','13:15:00',3.67),('16273','2013-08-13','13:20:00',3.7),('16273','2013-08-13','13:25:00',3.63),('16273','2013-08-13','13:30:00',3.63),('16273','2013-08-13','13:35:00',3.62),('16273','2013-08-13','13:40:00',3.6),('16273','2013-08-13','13:45:00',3.64),('16273','2013-08-13','13:50:00',3.1),('16273','2013-08-13','13:55:00',3.59),('16273','2013-08-13','14:00:00',3.59),('16273','2013-08-13','14:05:00',3.47),('16273','2013-08-13','14:10:00',3.47),('16273','2013-08-13','14:15:00',3.42),('16273','2013-08-13','14:20:00',3.4),('16273','2013-08-13','14:25:00',3.37),('16273','2013-08-13','14:30:00',3.37),('16273','2013-08-13','14:35:00',3.32),('16273','2013-08-13','14:40:00',3.31),('16273','2013-08-13','14:45:00',3.25),('16273','2013-08-13','14:50:00',3.21),('16273','2013-08-13','14:55:00',3.17),('16273','2013-08-13','15:00:00',3.1),('16273','2013-08-13','15:05:00',3.07),('16273','2013-08-13','15:10:00',3.04),('16273','2013-08-13','15:15:00',2.98),('16273','2013-08-13','15:20:00',2.95),('16273','2013-08-13','15:25:00',2.89),('16273','2013-08-13','15:30:00',2.84),('16273','2013-08-13','15:35:00',2.79),('16273','2013-08-13','15:40:00',2.74),('16273','2013-08-13','15:45:00',2.67),('16273','2013-08-13','15:50:00',2.51),('16273','2013-08-13','15:55:00',2.57),('16273','2013-08-13','16:00:00',2.49),('16273','2013-08-13','16:05:00',2.43),('16273','2013-08-13','16:10:00',2.36),('16273','2013-08-13','16:15:00',2.3),('16273','2013-08-13','16:20:00',2.23),('16273','2013-08-13','16:25:00',2.17),('16273','2013-08-13','16:30:00',2.09),('16273','2013-08-13','16:35:00',2.03),('16273','2013-08-13','16:40:00',1.97),('16273','2013-08-13','16:45:00',1.89),('16273','2013-08-13','16:50:00',1.83),('16273','2013-08-13','16:55:00',1.76),('16273','2013-08-13','17:00:00',1.68),('16273','2013-08-13','17:05:00',1.61),('16273','2013-08-13','17:10:00',1.53),('16273','2013-08-13','17:15:00',1.45),('16273','2013-08-13','17:20:00',1.38),('16273','2013-08-13','17:25:00',1.3),('16273','2013-08-13','17:30:00',1.23),('16273','2013-08-13','17:35:00',1.16),('16273','2013-08-13','17:40:00',1.08),('16273','2013-08-13','17:45:00',1.01),('16273','2013-08-12','07:45:00',1.02),('16273','2013-08-12','07:50:00',1.1),('16273','2013-08-12','07:55:00',1.19),('16273','2013-08-12','08:00:00',1.26),('16273','2013-08-12','08:05:00',1.31),('16273','2013-08-12','08:10:00',1.37),('16273','2013-08-12','08:15:00',1.47),('16273','2013-08-12','08:20:00',1.6),('16273','2013-08-12','08:25:00',1.68),('16273','2013-08-12','08:30:00',1.8),('16273','2013-08-12','08:35:00',1.91),('16273','2013-08-12','08:40:00',2.01),('16273','2013-08-12','08:45:00',2.09),('16273','2013-08-12','08:50:00',2.15),('16273','2013-08-12','08:55:00',2.21),('16273','2013-08-12','09:00:00',2.27),('16273','2013-08-12','09:05:00',2.34),('16273','2013-08-12','09:10:00',2.42),('16273','2013-08-12','09:15:00',2.48),('16273','2013-08-12','09:20:00',2.53),('16273','2013-08-12','09:25:00',2.58),('16273','2013-08-12','09:30:00',2.63),('16273','2013-08-12','09:35:00',2.69),('16273','2013-08-12','09:40:00',2.73),('16273','2013-08-12','09:45:00',2.81),('16273','2013-08-12','09:50:00',2.87),('16273','2013-08-12','09:55:00',2.91),('16273','2013-08-12','10:00:00',2.95),('16273','2013-08-12','10:05:00',2.99),('16273','2013-08-12','10:10:00',3),('16273','2013-08-12','10:15:00',3.06),('16273','2013-08-12','10:20:00',3.11),('16273','2013-08-12','10:25:00',3.14),('16273','2013-08-12','10:30:00',3.19),('16273','2013-08-12','10:35:00',3.23),('16273','2013-08-12','10:40:00',3.29),('16273','2013-08-12','10:45:00',3.31),('16273','2013-08-12','10:50:00',3.33),('16273','2013-08-12','10:55:00',3.32),('16273','2013-08-12','11:00:00',3.33),('16273','2013-08-12','11:05:00',3.36),('16273','2013-08-12','11:10:00',3.44),('16273','2013-08-12','11:15:00',3.43),('16273','2013-08-12','11:20:00',2.87),('16273','2013-08-12','11:25:00',3.56),('16273','2013-08-12','11:30:00',3.37),('16273','2013-08-12','11:35:00',3.69),('16273','2013-08-12','11:40:00',2.39),('16273','2013-08-12','11:45:00',1.12),('16273','2013-08-12','11:50:00',1.23),('16273','2013-08-12','11:55:00',3.95),('16273','2013-08-12','12:00:00',4.06),('16273','2013-08-12','12:05:00',3.96),('16273','2013-08-12','12:10:00',3.39),('16273','2013-08-12','12:15:00',3.84),('16273','2013-08-12','12:20:00',4),('16273','2013-08-12','12:25:00',1.86),('16273','2013-08-12','12:30:00',3.15),('16273','2013-08-12','12:35:00',3.56),('16273','2013-08-12','12:40:00',1.64),('16273','2013-08-12','12:45:00',3.79),('16273','2013-08-12','12:50:00',3.73),('16273','2013-08-12','12:55:00',2.89),('16273','2013-08-12','13:00:00',1.34),('16273','2013-08-12','13:05:00',2.63),('16273','2013-08-12','13:10:00',2.72),('16273','2013-08-12','13:15:00',3.21),('16273','2013-08-12','13:20:00',3.75),('16273','2013-08-12','13:25:00',3.61),('16273','2013-08-12','13:30:00',1.71),('16273','2013-08-12','13:35:00',3.31),('16273','2013-08-12','13:40:00',2.46),('16273','2013-08-12','13:45:00',3.86),('16273','2013-08-12','13:50:00',3.79),('16273','2013-08-12','13:55:00',3.75),('16273','2013-08-12','14:00:00',3.76),('16273','2013-08-12','14:05:00',3.31),('16273','2013-08-12','14:10:00',2.07),('16273','2013-08-12','14:15:00',2.41),('16273','2013-08-12','14:20:00',3.78),('16273','2013-08-12','14:25:00',3.56),('16273','2013-08-12','14:30:00',2.56),('16273','2013-08-12','14:35:00',3.1),('16273','2013-08-12','14:40:00',3.5),('16273','2013-08-12','14:45:00',3.47),('16273','2013-08-12','14:50:00',3.26),('16273','2013-08-12','14:55:00',3.23),('16273','2013-08-12','15:00:00',3.13),('16273','2013-08-12','15:05:00',3.11),('16273','2013-08-12','15:10:00',3.07),('16273','2013-08-12','15:15:00',2.98),('16273','2013-08-12','15:20:00',2.65),('16273','2013-08-12','15:25:00',2.92),('16273','2013-08-12','15:30:00',2.86),('16273','2013-08-12','15:35:00',2.82),('16273','2013-08-12','15:40:00',2.74),('16273','2013-08-12','15:45:00',2.2),('16273','2013-08-12','15:50:00',2.65),('16273','2013-08-12','15:55:00',2.57),('16273','2013-08-12','16:00:00',2.47),('16273','2013-08-12','16:05:00',2.41),('16273','2013-08-12','16:10:00',2.36),('16273','2013-08-12','16:15:00',2.3),('16273','2013-08-12','16:20:00',2.28),('16273','2013-08-12','16:25:00',2.2),('16273','2013-08-12','16:30:00',2.13),('16273','2013-08-12','16:35:00',2.04),('16273','2013-08-12','16:40:00',1.95),('16273','2013-08-12','16:45:00',1.86),('16273','2013-08-12','16:50:00',1.81),('16273','2013-08-12','16:55:00',1.72),('16273','2013-08-12','17:00:00',1.65),('16273','2013-08-12','17:05:00',1.59),('16273','2013-08-12','17:10:00',1.5),('16273','2013-08-12','17:15:00',1.44),('16273','2013-08-12','17:20:00',1.38),('16273','2013-08-12','17:25:00',1.3),('16273','2013-08-12','17:30:00',1.24),('16273','2013-08-12','17:35:00',1.17),('16273','2013-08-12','17:40:00',1.11),('16273','2013-08-12','17:45:00',1.04),('16273','2013-08-11','07:40:00',1.04),('16273','2013-08-11','07:45:00',1.15),('16273','2013-08-11','07:50:00',1.25),('16273','2013-08-11','07:55:00',1.33),('16273','2013-08-11','08:00:00',1.41),('16273','2013-08-11','08:05:00',1.5),('16273','2013-08-11','08:10:00',1.58),('16273','2013-08-11','08:15:00',1.67),('16273','2013-08-11','08:20:00',1.75),('16273','2013-08-11','08:25:00',1.83),('16273','2013-08-11','08:30:00',1.92),('16273','2013-08-11','08:35:00',2),('16273','2013-08-11','08:40:00',2.05),('16273','2013-08-11','08:45:00',2.15),('16273','2013-08-11','08:50:00',2.2),('16273','2013-08-11','08:55:00',2.27),('16273','2013-08-11','09:00:00',2.34),('16273','2013-08-11','09:05:00',2.42),('16273','2013-08-11','09:10:00',2.46),('16273','2013-08-11','09:15:00',2.54),('16273','2013-08-11','09:20:00',2.6),('16273','2013-08-11','09:25:00',2.65),('16273','2013-08-11','09:30:00',2.71),('16273','2013-08-11','09:35:00',2.77),('16273','2013-08-11','09:40:00',2.82),('16273','2013-08-11','09:45:00',2.87),('16273','2013-08-11','09:50:00',2.93),('16273','2013-08-11','09:55:00',2.95),('16273','2013-08-11','10:00:00',3.03),('16273','2013-08-11','10:05:00',3.06),('16273','2013-08-11','10:10:00',3.12),('16273','2013-08-11','10:15:00',3.16),('16273','2013-08-11','10:20:00',3.19),('16273','2013-08-11','10:25:00',3.23),('16273','2013-08-11','10:30:00',3.3),('16273','2013-08-11','10:35:00',3.33),('16273','2013-08-11','10:40:00',3.36),('16273','2013-08-11','10:45:00',3.4),('16273','2013-08-11','10:50:00',3.42),('16273','2013-08-11','10:55:00',3.44),('16273','2013-08-11','11:00:00',3.49),('16273','2013-08-11','11:05:00',3.49),('16273','2013-08-11','11:10:00',3.51),('16273','2013-08-11','11:15:00',3.54),('16273','2013-08-11','11:20:00',3.56),('16273','2013-08-11','11:25:00',3.58),('16273','2013-08-11','11:30:00',3.62),('16273','2013-08-11','11:35:00',3.6),('16273','2013-08-11','11:40:00',3.58),('16273','2013-08-11','11:45:00',3.59),('16273','2013-08-11','11:50:00',3.61),('16273','2013-08-11','11:55:00',3.64),('16273','2013-08-11','12:00:00',3.63),('16273','2013-08-11','12:05:00',3.63),('16273','2013-08-11','12:10:00',3.65),('16273','2013-08-11','12:15:00',3.66),('16273','2013-08-11','12:20:00',3.67),('16273','2013-08-11','12:25:00',3.65),('16273','2013-08-11','12:30:00',3.63),('16273','2013-08-11','12:35:00',3.64),('16273','2013-08-11','12:40:00',3.63),('16273','2013-08-11','12:45:00',3.64),('16273','2013-08-11','12:50:00',3.63),('16273','2013-08-11','12:55:00',3.61),('16273','2013-08-11','13:00:00',3.59),('16273','2013-08-11','13:05:00',3.6),('16273','2013-08-11','13:10:00',3.6),('16273','2013-08-11','13:15:00',3.59),('16273','2013-08-11','13:20:00',3.55),('16273','2013-08-11','13:25:00',3.52),('16273','2013-08-11','13:30:00',3.55),('16273','2013-08-11','13:35:00',3.55),('16273','2013-08-11','13:40:00',3.51),('16273','2013-08-11','13:45:00',3.46),('16273','2013-08-11','13:50:00',3.42),('16273','2013-08-11','13:55:00',3.42),('16273','2013-08-11','14:00:00',3.39),('16273','2013-08-11','14:05:00',3.37),('16273','2013-08-11','14:10:00',3.34),('16273','2013-08-11','14:15:00',3.31),('16273','2013-08-11','14:20:00',3.29),('16273','2013-08-11','14:25:00',3.2),('16273','2013-08-11','14:30:00',3.25),('16273','2013-08-11','14:35:00',3.21),('16273','2013-08-11','14:40:00',3.17),('16273','2013-08-11','14:45:00',3.14),('16273','2013-08-11','14:50:00',3.09),('16273','2013-08-11','14:55:00',3.05),('16273','2013-08-11','15:00:00',3.01),('16273','2013-08-11','15:05:00',2.99),('16273','2013-08-11','15:10:00',2.97),('16273','2013-08-11','15:15:00',2.93),('16273','2013-08-11','15:20:00',2.9),('16273','2013-08-11','15:25:00',2.86),('16273','2013-08-11','15:30:00',2.81),('16273','2013-08-11','15:35:00',2.77),('16273','2013-08-11','15:40:00',2.71),('16273','2013-08-11','15:45:00',2.67),('16273','2013-08-11','15:50:00',2.61),('16273','2013-08-11','15:55:00',2.53),('16273','2013-08-11','16:00:00',2.48),('16273','2013-08-11','16:05:00',2.42),('16273','2013-08-11','16:10:00',2.36),('16273','2013-08-11','16:15:00',2.3),('16273','2013-08-11','16:20:00',2.24),('16273','2013-08-11','16:25:00',2.17),('16273','2013-08-11','16:30:00',2.08),('16273','2013-08-11','16:35:00',2.03),('16273','2013-08-11','16:40:00',1.95),('16273','2013-08-11','16:45:00',1.88),('16273','2013-08-11','16:50:00',1.81),('16273','2013-08-11','16:55:00',1.74),('16273','2013-08-11','17:00:00',1.67),('16273','2013-08-11','17:05:00',1.6),('16273','2013-08-11','17:10:00',1.52),('16273','2013-08-11','17:15:00',1.44),('16273','2013-08-11','17:20:00',1.37),('16273','2013-08-11','17:25:00',1.31),('16273','2013-08-11','17:30:00',1.24),('16273','2013-08-11','17:35:00',1.17),('16273','2013-08-11','17:40:00',1.1),('16273','2013-08-11','17:45:00',1.02),('16273','2013-08-10','07:45:00',1.17),('16273','2013-08-10','07:50:00',1.28),('16273','2013-08-10','07:55:00',1.38),('16273','2013-08-10','08:00:00',1.47),('16273','2013-08-10','08:05:00',1.55),('16273','2013-08-10','08:10:00',1.63),('16273','2013-08-10','08:15:00',1.72),('16273','2013-08-10','08:20:00',1.81),('16273','2013-08-10','08:25:00',1.89),('16273','2013-08-10','08:30:00',1.95),('16273','2013-08-10','08:35:00',2.04),('16273','2013-08-10','08:40:00',2.1),('16273','2013-08-10','08:45:00',2.17),('16273','2013-08-10','08:50:00',2.25),('16273','2013-08-10','08:55:00',2.32),('16273','2013-08-10','09:00:00',2.38),('16273','2013-08-10','09:05:00',2.45),('16273','2013-08-10','09:10:00',2.51),('16273','2013-08-10','09:15:00',2.56),('16273','2013-08-10','09:20:00',2.62),('16273','2013-08-10','09:25:00',2.7),('16273','2013-08-10','09:30:00',2.73),('16273','2013-08-10','09:35:00',2.79),('16273','2013-08-10','09:40:00',2.85),('16273','2013-08-10','09:45:00',2.88),('16273','2013-08-10','09:50:00',2.95),('16273','2013-08-10','09:55:00',3),('16273','2013-08-10','10:00:00',3.04),('16273','2013-08-10','10:05:00',3.08),('16273','2013-08-10','10:10:00',3.12),('16273','2013-08-10','10:15:00',3.16),('16273','2013-08-10','10:20:00',3.21),('16273','2013-08-10','10:25:00',3.25),('16273','2013-08-10','10:30:00',3.3),('16273','2013-08-10','10:35:00',3.34),('16273','2013-08-10','10:40:00',3.37),('16273','2013-08-10','10:45:00',3.42),('16273','2013-08-10','10:50:00',3.48),('16273','2013-08-10','10:55:00',3.53),('16273','2013-08-10','11:00:00',3.54),('16273','2013-08-10','11:05:00',3.62),('16273','2013-08-10','11:10:00',3.67),('16273','2013-08-10','11:15:00',3.71),('16273','2013-08-10','11:20:00',3.69),('16273','2013-08-10','11:25:00',3.64),('16273','2013-08-10','11:30:00',3.62),('16273','2013-08-10','11:35:00',3.68),('16273','2013-08-10','11:40:00',3.68),('16273','2013-08-10','11:45:00',3.7),('16273','2013-08-10','11:50:00',3.7),('16273','2013-08-10','11:55:00',3.7),('16273','2013-08-10','12:00:00',1.98),('16273','2013-08-10','12:05:00',3),('16273','2013-08-10','12:10:00',3.8),('16273','2013-08-10','12:15:00',3.74),('16273','2013-08-10','12:20:00',3.76),('16273','2013-08-10','12:25:00',3.79),('16273','2013-08-10','12:30:00',3.79),('16273','2013-08-10','12:35:00',3.83),('16273','2013-08-10','12:40:00',3.8),('16273','2013-08-10','12:45:00',3.79),('16273','2013-08-10','12:50:00',1.95),('16273','2013-08-10','12:55:00',3.31),('16273','2013-08-10','13:00:00',3.81),('16273','2013-08-10','13:05:00',3.72),('16273','2013-08-10','13:10:00',3.71),('16273','2013-08-10','13:15:00',3.74),('16273','2013-08-10','13:20:00',3.87),('16273','2013-08-10','13:25:00',3.88),('16273','2013-08-10','13:30:00',3.66),('16273','2013-08-10','13:35:00',1.17),('16273','2013-08-10','13:40:00',2.69),('16273','2013-08-10','13:45:00',3.89),('16273','2013-08-10','13:50:00',3.06),('16273','2013-08-10','13:55:00',2.04),('16273','2013-08-10','14:00:00',1.35),('16273','2013-08-10','14:05:00',1.7),('16273','2013-08-10','14:10:00',2.84),('16273','2013-08-10','14:15:00',1.32),('16273','2013-08-10','15:40:00',1.07),('16273','2013-08-10','15:45:00',1.25),('16273','2013-08-10','15:50:00',1.39),('16273','2013-08-10','15:55:00',1.41),('16273','2013-08-10','16:00:00',1.55),('16273','2013-08-10','16:05:00',1.39),('16273','2013-08-10','16:10:00',1.36),('16273','2013-08-10','16:15:00',1.1),('16273','2013-08-10','16:20:00',2),('16273','2013-08-10','16:25:00',1.12),('16273','2013-08-10','16:55:00',1.04),('16273','2013-08-10','17:05:00',1.05),('16273','2014-04-09','08:00:00',1.09),('16273','2014-04-09','08:10:00',1.27),('16273','2014-04-09','08:15:00',1.2),('16273','2014-04-09','08:50:00',1.1),('16273','2014-04-09','08:55:00',1.15),('16273','2014-04-09','09:00:00',1.62),('16273','2014-04-09','09:05:00',1.16),('16273','2014-04-09','09:10:00',1),('16273','2014-04-09','09:40:00',2.18),('16273','2014-04-09','09:45:00',1.71),('16273','2014-04-09','09:50:00',2.67),('16273','2014-04-09','09:55:00',2.99),('16273','2014-04-09','10:00:00',2.8),('16273','2014-04-09','10:05:00',3.12),('16273','2014-04-09','10:10:00',1.37),('16273','2014-04-09','10:15:00',1.61),('16273','2014-04-09','10:20:00',2.75),('16273','2014-04-09','10:25:00',3.35),('16273','2014-04-09','10:30:00',3.44),('16273','2014-04-09','10:35:00',3.53),('16273','2014-04-09','10:40:00',2.55),('16273','2014-04-09','10:45:00',2.61),('16273','2014-04-09','10:50:00',1.36),('16273','2014-04-09','10:55:00',1.96),('16273','2014-04-09','11:00:00',3.84),('16273','2014-04-09','11:05:00',2.84),('16273','2014-04-09','11:10:00',3.92),('16273','2014-04-09','11:15:00',3.56),('16273','2014-04-09','11:20:00',1.39),('16273','2014-04-09','11:25:00',1.87),('16273','2014-04-09','11:30:00',2.72),('16273','2014-04-09','11:35:00',1.86),('16273','2014-04-09','11:40:00',4.21),('16273','2014-04-09','11:45:00',1.37),('16273','2014-04-09','11:50:00',2.49),('16273','2014-04-09','11:55:00',1.32),('16273','2014-04-09','12:00:00',3.09),('16273','2014-04-09','12:05:00',3.02),('16273','2014-04-09','12:10:00',1.77),('16273','2014-04-09','12:15:00',2.52),('16273','2014-04-09','12:20:00',2.06),('16273','2014-04-09','12:25:00',1.5),('16273','2014-04-09','12:30:00',1.37),('16273','2014-04-09','12:35:00',1.32),('16273','2014-04-09','12:40:00',1.11),('16273','2014-04-09','14:30:00',1.24),('16273','2014-04-09','14:35:00',1.51),('16273','2014-04-09','14:40:00',1.58),('16273','2014-04-09','14:45:00',1.84),('16273','2014-04-09','14:50:00',1.47),('16273','2014-04-09','14:55:00',1.3),('16273','2014-04-09','15:00:00',1.3),('16273','2014-04-09','15:05:00',1.05),('16273','2014-04-09','15:25:00',1.14),('16273','2014-04-09','15:30:00',1.28),('16273','2014-04-09','15:35:00',1.16),('16273','2014-04-09','15:40:00',2.12),('16273','2014-04-09','15:45:00',1.55),('16273','2014-04-09','15:50:00',2.27),('16273','2014-04-09','15:55:00',2.34),('16273','2014-04-09','16:00:00',1.77),('16273','2014-04-09','16:05:00',2.15),('16273','2014-04-09','16:10:00',2.35),('16273','2014-04-09','16:15:00',2.3),('16273','2014-04-09','16:20:00',2.27),('16273','2014-04-09','16:25:00',2.04),('16273','2014-04-09','16:30:00',1.99),('16273','2014-04-09','16:35:00',1.92),('16273','2014-04-09','16:40:00',1.81),('16273','2014-04-09','16:45:00',1.73),('16273','2014-04-09','16:50:00',1.66),('16273','2014-04-09','16:55:00',1.62),('16273','2014-04-09','17:00:00',1.58),('16273','2014-04-09','17:05:00',1.47),('16273','2014-04-09','17:10:00',1.27),('16273','2014-04-09','17:15:00',1.27),('16273','2014-04-09','17:20:00',1.18),('16273','2014-04-09','17:25:00',1.17),('16273','2014-04-09','17:30:00',1.26),('16273','2014-04-09','17:35:00',1.21),('16273','2014-04-09','17:40:00',1.28),('16273','2014-04-09','17:45:00',1.03),('16273','2014-04-09','17:50:00',1.03),('16273','2013-08-09','08:00:00',1.04),('16273','2013-08-09','08:25:00',1.08),('16273','2013-08-09','08:30:00',1.34),('16273','2013-08-09','08:35:00',1.34),('16273','2013-08-09','08:40:00',1.63),('16273','2013-08-09','08:45:00',1.88),('16273','2013-08-09','08:50:00',1.59),('16273','2013-08-09','08:55:00',1.16),('16273','2013-08-09','09:00:00',1.99),('16273','2013-08-09','09:05:00',2.34),('16273','2013-08-09','09:10:00',1.7),('16273','2013-08-09','09:15:00',1.09),('16273','2013-08-09','09:20:00',1.46),('16273','2013-08-09','09:25:00',2.04),('16273','2013-08-09','09:30:00',2.34),('16273','2013-08-09','09:35:00',1.35),('16273','2013-08-09','09:40:00',1.78),('16273','2013-08-09','09:45:00',2.67),('16273','2013-08-09','09:50:00',2.98),('16273','2013-08-09','09:55:00',2.81),('16273','2013-08-09','10:00:00',2.71),('16273','2013-08-09','10:05:00',2.79),('16273','2013-08-09','10:10:00',2.78),('16273','2013-08-09','10:15:00',2.88),('16273','2013-08-09','10:20:00',2.92),('16273','2013-08-09','10:25:00',2.88),('16273','2013-08-09','10:30:00',2.43),('16273','2013-08-09','10:35:00',2.97),('16273','2013-08-09','10:40:00',3.09),('16273','2013-08-09','10:45:00',3.16),('16273','2013-08-09','10:50:00',3.17),('16273','2013-08-09','10:55:00',3.19),('16273','2013-08-09','11:00:00',3.19),('16273','2013-08-09','11:05:00',3.22),('16273','2013-08-09','11:10:00',3.19),('16273','2013-08-09','11:15:00',3.16),('16273','2013-08-09','11:20:00',3.23),('16273','2013-08-09','11:25:00',3.29),('16273','2013-08-09','11:30:00',3.33),('16273','2013-08-09','11:35:00',3.34),('16273','2013-08-09','11:40:00',3.33),('16273','2013-08-09','11:45:00',3.39),('16273','2013-08-09','11:50:00',3.39),('16273','2013-08-09','11:55:00',3.4),('16273','2013-08-09','12:00:00',3.41),('16273','2013-08-09','12:05:00',3.48),('16273','2013-08-09','12:10:00',3.56),('16273','2013-08-09','12:15:00',3.72),('16273','2013-08-09','12:20:00',3.12),('16273','2013-08-09','12:25:00',2.5),('16273','2013-08-09','12:30:00',3.32),('16273','2013-08-09','12:35:00',2.03),('16273','2013-08-09','12:40:00',2.13),('16273','2013-08-09','12:45:00',1.18),('16273','2013-08-09','12:50:00',1.01),('16273','2013-08-09','13:10:00',1.02),('16273','2013-08-09','13:15:00',1.2),('16273','2013-08-09','13:20:00',1.34),('16273','2013-08-09','13:25:00',1.44),('16273','2013-08-09','13:30:00',1.38),('16273','2013-08-09','13:35:00',1.29),('16273','2013-08-09','13:40:00',1.09),('16273','2013-08-09','15:10:00',1.36),('16273','2013-08-09','15:15:00',1.55),('16273','2013-08-09','15:30:00',1.05),('16273','2013-08-09','15:35:00',1.25),('16273','2013-08-09','15:40:00',2.22),('16273','2013-08-09','15:45:00',2.13),('16273','2013-08-09','15:50:00',1.6),('16273','2013-08-09','16:50:00',1.07),('16273','2013-08-08','07:45:00',1.02),('16273','2013-08-08','07:50:00',1.09),('16273','2013-08-08','07:55:00',1.18),('16273','2013-08-08','08:00:00',1.26),('16273','2013-08-08','08:05:00',1.33),('16273','2013-08-08','08:10:00',1.4),('16273','2013-08-08','08:15:00',1.48),('16273','2013-08-08','08:20:00',1.55),('16273','2013-08-08','08:25:00',1.62),('16273','2013-08-08','08:30:00',1.69),('16273','2013-08-08','08:35:00',1.75),('16273','2013-08-08','08:40:00',1.84),('16273','2013-08-08','08:45:00',1.92),('16273','2013-08-08','08:50:00',1.99),('16273','2013-08-08','08:55:00',2.05),('16273','2013-08-08','09:00:00',2.1),('16273','2013-08-08','09:05:00',2.16),('16273','2013-08-08','09:10:00',2.22),('16273','2013-08-08','09:15:00',2.29),('16273','2013-08-08','09:20:00',2.36),('16273','2013-08-08','09:25:00',2.41),('16273','2013-08-08','09:30:00',2.47),('16273','2013-08-08','09:35:00',2.49),('16273','2013-08-08','09:40:00',2.56),('16273','2013-08-08','09:45:00',2.61),('16273','2013-08-08','09:50:00',2.67),('16273','2013-08-08','09:55:00',2.72),('16273','2013-08-08','10:00:00',2.76),('16273','2013-08-08','10:05:00',2.83),('16273','2013-08-08','10:10:00',2.87),('16273','2013-08-08','10:15:00',2.9),('16273','2013-08-08','10:20:00',2.95),('16273','2013-08-08','10:25:00',2.96),('16273','2013-08-08','10:30:00',3.02),('16273','2013-08-08','10:35:00',3.04),('16273','2013-08-08','10:40:00',3.05),('16273','2013-08-08','10:45:00',3.09),('16273','2013-08-08','10:50:00',3.13),('16273','2013-08-08','10:55:00',3.13),('16273','2013-08-08','11:00:00',3.19),('16273','2013-08-08','11:05:00',3.23),('16273','2013-08-08','11:10:00',3.25),('16273','2013-08-08','11:15:00',3.29),('16273','2013-08-08','11:20:00',3.29),('16273','2013-08-08','11:25:00',3.31),('16273','2013-08-08','11:30:00',3.33),('16273','2013-08-08','11:35:00',3.33),('16273','2013-08-08','11:40:00',3.34),('16273','2013-08-08','11:45:00',3.33),('16273','2013-08-08','11:50:00',3.33),('16273','2013-08-08','11:55:00',3.36),('16273','2013-08-08','12:00:00',3.42),('16273','2013-08-08','12:05:00',3.45),('16273','2013-08-08','12:10:00',3.47),('16273','2013-08-08','12:15:00',3.52),('16273','2013-08-08','12:20:00',3.52),('16273','2013-08-08','12:25:00',3.52),('16273','2013-08-08','12:30:00',3.52),('16273','2013-08-08','12:35:00',3.52),('16273','2013-08-08','12:40:00',3.53),('16273','2013-08-08','12:45:00',3.52),('16273','2013-08-08','12:50:00',3.52),('16273','2013-08-08','12:55:00',3.5),('16273','2013-08-08','13:00:00',3.48),('16273','2013-08-08','13:05:00',3.49),('16273','2013-08-08','13:10:00',3.49),('16273','2013-08-08','13:15:00',3.47),('16273','2013-08-08','13:20:00',3.47),('16273','2013-08-08','13:25:00',3.45),('16273','2013-08-08','13:30:00',3.43),('16273','2013-08-08','13:35:00',3.42),('16273','2013-08-08','13:40:00',3.35),('16273','2013-08-08','13:45:00',3.39),('16273','2013-08-08','13:50:00',3.36),('16273','2013-08-08','13:55:00',3.33),('16273','2013-08-08','14:00:00',3.31),('16273','2013-08-08','14:05:00',3.29),('16273','2013-08-08','14:10:00',3.26),('16273','2013-08-08','14:15:00',3.23),('16273','2013-08-08','14:20:00',3.21),('16273','2013-08-08','14:25:00',3.19),('16273','2013-08-08','14:30:00',3.15),('16273','2013-08-08','14:35:00',3.11),('16273','2013-08-08','14:40:00',3.08),('16273','2013-08-08','14:45:00',3.04),('16273','2013-08-08','14:50:00',3.01),('16273','2013-08-08','14:55:00',2.97),('16273','2013-08-08','15:00:00',2.92),('16273','2013-08-08','15:05:00',2.88),('16273','2013-08-08','15:10:00',2.83),('16273','2013-08-08','15:15:00',2.74),('16273','2013-08-08','15:20:00',2.75),('16273','2013-08-08','15:25:00',2.69),('16273','2013-08-08','15:30:00',2.57),('16273','2013-08-08','15:35:00',2.58),('16273','2013-08-08','15:40:00',2.52),('16273','2013-08-08','15:45:00',2.46),('16273','2013-08-08','15:50:00',2.43),('16273','2013-08-08','15:55:00',2.38),('16273','2013-08-08','16:00:00',2.34),('16273','2013-08-08','16:05:00',2.29),('16273','2013-08-08','16:10:00',2.23),('16273','2013-08-08','16:15:00',2.17),('16273','2013-08-08','16:20:00',2.11),('16273','2013-08-08','16:25:00',2.04),('16273','2013-08-08','16:30:00',1.98),('16273','2013-08-08','16:35:00',1.91),('16273','2013-08-08','16:40:00',1.84),('16273','2013-08-08','16:45:00',1.79),('16273','2013-08-08','16:50:00',1.72),('16273','2013-08-08','16:55:00',1.65),('16273','2013-08-08','17:00:00',1.58),('16273','2013-08-08','17:05:00',1.52),('16273','2013-08-08','17:10:00',1.45),('16273','2013-08-08','17:15:00',1.38),('16273','2013-08-08','17:20:00',1.31),('16273','2013-08-08','17:25:00',1.25),('16273','2013-08-08','17:30:00',1.19),('16273','2013-08-08','17:35:00',1.12),('16273','2013-08-08','17:40:00',1.05),('16273','2013-08-07','07:40:00',1.03),('16273','2013-08-07','07:45:00',1.12),('16273','2013-08-07','07:50:00',1.19),('16273','2013-08-07','07:55:00',1.27),('16273','2013-08-07','08:00:00',1.34),('16273','2013-08-07','08:05:00',1.42),('16273','2013-08-07','08:10:00',1.5),('16273','2013-08-07','08:15:00',1.57),('16273','2013-08-07','08:20:00',1.64),('16273','2013-08-07','08:25:00',1.72),('16273','2013-08-07','08:30:00',1.78),('16273','2013-08-07','08:35:00',1.85),('16273','2013-08-07','08:40:00',1.93),('16273','2013-08-07','08:45:00',2.01),('16273','2013-08-07','08:50:00',2.07),('16273','2013-08-07','08:55:00',2.14),('16273','2013-08-07','09:00:00',2.19),('16273','2013-08-07','09:05:00',2.25),('16273','2013-08-07','09:10:00',2.32),('16273','2013-08-07','09:15:00',2.35),('16273','2013-08-07','09:20:00',2.41),('16273','2013-08-07','09:25:00',2.46),('16273','2013-08-07','09:30:00',2.5),('16273','2013-08-07','09:35:00',2.52),('16273','2013-08-07','09:40:00',2.56),('16273','2013-08-07','09:45:00',2.67),('16273','2013-08-07','09:50:00',2.68),('16273','2013-08-07','09:55:00',2.72),('16273','2013-08-07','10:00:00',2.73),('16273','2013-08-07','10:05:00',2.78),('16273','2013-08-07','10:10:00',2.88),('16273','2013-08-07','10:15:00',2.9),('16273','2013-08-07','10:20:00',2.94),('16273','2013-08-07','10:25:00',2.98),('16273','2013-08-07','10:30:00',3.02),('16273','2013-08-07','10:35:00',3.05),('16273','2013-08-07','10:40:00',3.1),('16273','2013-08-07','10:45:00',3.1),('16273','2013-08-07','10:50:00',3.17),('16273','2013-08-07','10:55:00',3.19),('16273','2013-08-07','11:00:00',3.2),('16273','2013-08-07','11:05:00',3.23),('16273','2013-08-07','11:10:00',3.27),('16273','2013-08-07','11:15:00',3.25),('16273','2013-08-07','11:20:00',3.3),('16273','2013-08-07','11:25:00',3.35),('16273','2013-08-07','11:30:00',3.34),('16273','2013-08-07','11:35:00',3.34),('16273','2013-08-07','11:40:00',3.41),('16273','2013-08-07','11:45:00',3.4),('16273','2013-08-07','11:50:00',3.34),('16273','2013-08-07','11:55:00',3.42),('16273','2013-08-07','12:00:00',3.34),('16273','2013-08-07','12:05:00',3.38),('16273','2013-08-07','12:10:00',3.5),('16273','2013-08-07','12:15:00',3.47),('16273','2013-08-07','12:20:00',3.43),('16273','2013-08-07','12:25:00',3.49),('16273','2013-08-07','12:30:00',3.5),('16273','2013-08-07','12:35:00',3.51),('16273','2013-08-07','12:40:00',3.52),('16273','2013-08-07','12:45:00',3.49),('16273','2013-08-07','12:50:00',3.48),('16273','2013-08-07','12:55:00',3.52),('16273','2013-08-07','13:00:00',3.45),('16273','2013-08-07','13:05:00',3.45),('16273','2013-08-07','13:10:00',3.49),('16273','2013-08-07','13:15:00',3.48),('16273','2013-08-07','13:20:00',3.49),('16273','2013-08-07','13:25:00',3.46),('16273','2013-08-07','13:30:00',3.47),('16273','2013-08-07','13:35:00',3.45),('16273','2013-08-07','13:40:00',3.47),('16273','2013-08-07','13:45:00',3.43),('16273','2013-08-07','13:50:00',3.42),('16273','2013-08-07','13:55:00',3.39),('16273','2013-08-07','14:00:00',3.38),('16273','2013-08-07','14:05:00',3.36),('16273','2013-08-07','14:10:00',3.33),('16273','2013-08-07','14:15:00',3.29),('16273','2013-08-07','14:20:00',3.26),('16273','2013-08-07','14:25:00',3.23),('16273','2013-08-07','14:30:00',3.18),('16273','2013-08-07','14:35:00',3.18),('16273','2013-08-07','14:40:00',3.11),('16273','2013-08-07','14:45:00',3.11),('16273','2013-08-07','14:50:00',3.03),('16273','2013-08-07','14:55:00',3.04),('16273','2013-08-07','15:00:00',2.98),('16273','2013-08-07','15:05:00',2.95),('16273','2013-08-07','15:10:00',2.88),('16273','2013-08-07','15:15:00',2.85),('16273','2013-08-07','15:20:00',2.8),('16273','2013-08-07','15:25:00',2.74),('16273','2013-08-07','15:30:00',2.71),('16273','2013-08-07','15:35:00',2.66),('16273','2013-08-07','15:40:00',2.61),('16273','2013-08-07','15:45:00',2.56),('16273','2013-08-07','15:50:00',2.51),('16273','2013-08-07','15:55:00',2.44),('16273','2013-08-07','16:00:00',2.39),('16273','2013-08-07','16:05:00',2.34),('16273','2013-08-07','16:10:00',2.27),('16273','2013-08-07','16:15:00',2.22),('16273','2013-08-07','16:20:00',2.15),('16273','2013-08-07','16:25:00',2.08),('16273','2013-08-07','16:30:00',2.02),('16273','2013-08-07','16:35:00',1.95),('16273','2013-08-07','16:40:00',1.89),('16273','2013-08-07','16:45:00',1.82),('16273','2013-08-07','16:50:00',1.75),('16273','2013-08-07','16:55:00',1.69),('16273','2013-08-07','17:00:00',1.62),('16273','2013-08-07','17:05:00',1.56),('16273','2013-08-07','17:10:00',1.48),('16273','2013-08-07','17:15:00',1.42),('16273','2013-08-07','17:20:00',1.35),('16273','2013-08-07','17:25:00',1.27),('16273','2013-08-07','17:30:00',1.21),('16273','2013-08-07','17:35:00',1.15),('16273','2013-08-07','17:40:00',1.08),('16273','2013-08-07','17:45:00',1.01),('16273','2013-08-06','07:45:00',1.04),('16273','2013-08-06','07:50:00',1.13),('16273','2013-08-06','07:55:00',1.21),('16273','2013-08-06','08:00:00',1.29),('16273','2013-08-06','08:05:00',1.37),('16273','2013-08-06','08:10:00',1.45),('16273','2013-08-06','08:15:00',1.53),('16273','2013-08-06','08:20:00',1.6),('16273','2013-08-06','08:25:00',1.67),('16273','2013-08-06','08:30:00',1.75),('16273','2013-08-06','08:35:00',1.82),('16273','2013-08-06','08:40:00',1.88),('16273','2013-08-06','08:45:00',1.95),('16273','2013-08-06','08:50:00',2.02),('16273','2013-08-06','08:55:00',2.08),('16273','2013-08-06','09:00:00',2.16),('16273','2013-08-06','09:05:00',2.23),('16273','2013-08-06','09:10:00',2.27),('16273','2013-08-06','09:15:00',2.34),('16273','2013-08-06','09:20:00',2.38),('16273','2013-08-06','09:25:00',2.43),('16273','2013-08-06','09:30:00',2.49),('16273','2013-08-06','09:35:00',2.55),('16273','2013-08-06','09:40:00',2.62),('16273','2013-08-06','09:45:00',2.65),('16273','2013-08-06','09:50:00',2.72),('16273','2013-08-06','09:55:00',2.76),('16273','2013-08-06','10:00:00',2.82),('16273','2013-08-06','10:05:00',2.85),('16273','2013-08-06','10:10:00',2.91),('16273','2013-08-06','10:15:00',2.94),('16273','2013-08-06','10:20:00',2.98),('16273','2013-08-06','10:25:00',3.01),('16273','2013-08-06','10:30:00',3.03),('16273','2013-08-06','10:35:00',3.05),('16273','2013-08-06','10:40:00',3.09),('16273','2013-08-06','10:45:00',3.13),('16273','2013-08-06','10:50:00',3.16),('16273','2013-08-06','10:55:00',3.18),('16273','2013-08-06','11:00:00',3.19),('16273','2013-08-06','11:05:00',3.2),('16273','2013-08-06','11:10:00',3.21),('16273','2013-08-06','11:15:00',3.26),('16273','2013-08-06','11:20:00',3.27),('16273','2013-08-06','11:25:00',3.28),('16273','2013-08-06','11:30:00',3.31),('16273','2013-08-06','11:35:00',3.37),('16273','2013-08-06','11:40:00',3.34),('16273','2013-08-06','11:45:00',3.39),('16273','2013-08-06','11:50:00',3.39),('16273','2013-08-06','11:55:00',3.4),('16273','2013-08-06','12:00:00',3.43),('16273','2013-08-06','12:05:00',3.44),('16273','2013-08-06','12:10:00',3.46),('16273','2013-08-06','12:15:00',3.48),('16273','2013-08-06','12:20:00',3.45),('16273','2013-08-06','12:25:00',3.5),('16273','2013-08-06','12:30:00',3.51),('16273','2013-08-06','12:35:00',3.5),('16273','2013-08-06','12:40:00',3.54),('16273','2013-08-06','12:45:00',3.53),('16273','2013-08-06','12:50:00',3.52),('16273','2013-08-06','12:55:00',3.53),('16273','2013-08-06','14:00:00',2.79),('16273','2013-08-06','14:05:00',3.36),('16273','2013-08-06','14:10:00',3.35),('16273','2013-08-06','14:15:00',3.33),('16273','2013-08-06','14:20:00',2.1),('16273','2013-08-06','14:25:00',3.28),('16273','2013-08-06','14:30:00',3.25),('16273','2013-08-06','14:35:00',3.22),('16273','2013-08-06','14:40:00',2.12),('16273','2013-08-06','14:45:00',3.15),('16273','2013-08-06','14:50:00',3.12),('16273','2013-08-06','14:55:00',3.09),('16273','2013-08-06','15:00:00',2.03),('16273','2013-08-06','15:05:00',2.96),('16273','2013-08-06','15:10:00',2.97),('16273','2013-08-06','15:15:00',2.93),('16273','2013-08-06','15:20:00',2.23),('16273','2013-08-06','15:25:00',2.6),('16273','2013-08-06','15:30:00',2.76),('16273','2013-08-06','15:35:00',2.71),('16273','2013-08-06','15:40:00',2.65),('16273','2013-08-06','15:45:00',2.61),('16273','2013-08-06','15:50:00',2.55),('16273','2013-08-06','15:55:00',2.49),('16273','2013-08-06','16:00:00',2.44),('16273','2013-08-06','16:05:00',2.38),('16273','2013-08-06','16:10:00',2.32),('16273','2013-08-06','16:15:00',2.25),('16273','2013-08-06','16:20:00',2.18),('16273','2013-08-06','16:25:00',2.11),('16273','2013-08-06','16:30:00',2.05),('16273','2013-08-06','16:35:00',1.99),('16273','2013-08-06','16:40:00',1.92),('16273','2013-08-06','16:45:00',1.86),('16273','2013-08-06','17:10:00',1.42),('16273','2013-08-06','17:15:00',1.44),('16273','2013-08-06','17:20:00',1.38),('16273','2013-08-06','17:25:00',1.31),('16273','2013-08-06','17:30:00',1.09),('16273','2013-08-06','17:35:00',1.17),('16273','2013-08-06','17:40:00',1.11),('16273','2013-08-06','17:45:00',1.04),('16273','2013-08-05','07:40:00',1.01),('16273','2013-08-05','07:45:00',1.09),('16273','2013-08-05','07:50:00',1.17),('16273','2013-08-05','07:55:00',1.25),('16273','2013-08-05','08:00:00',1.32),('16273','2013-08-05','08:05:00',1.4),('16273','2013-08-05','08:10:00',1.49),('16273','2013-08-05','08:15:00',1.56),('16273','2013-08-05','08:20:00',1.65),('16273','2013-08-05','08:25:00',1.72),('16273','2013-08-05','08:30:00',1.81),('16273','2013-08-05','08:35:00',1.89),('16273','2013-08-05','08:40:00',1.96),('16273','2013-08-05','08:45:00',2.03),('16273','2013-08-05','08:50:00',2.1),('16273','2013-08-05','08:55:00',2.16),('16273','2013-08-05','09:00:00',2.22),('16273','2013-08-05','09:05:00',2.29),('16273','2013-08-05','09:10:00',2.36),('16273','2013-08-05','09:15:00',2.43),('16273','2013-08-05','09:20:00',2.46),('16273','2013-08-05','09:25:00',2.53),('16273','2013-08-05','09:30:00',2.59),('16273','2013-08-05','09:35:00',2.66),('16273','2013-08-05','09:40:00',2.7),('16273','2013-08-05','09:45:00',2.75),('16273','2013-08-05','09:50:00',2.79),('16273','2013-08-05','09:55:00',2.83),('16273','2013-08-05','10:00:00',2.86),('16273','2013-08-05','10:05:00',2.9),('16273','2013-08-05','10:10:00',2.96),('16273','2013-08-05','10:15:00',3.01),('16273','2013-08-05','10:20:00',3.04),('16273','2013-08-05','10:25:00',3.07),('16273','2013-08-05','10:30:00',3.11),('16273','2013-08-05','10:35:00',3.11),('16273','2013-08-05','10:40:00',3.17),('16273','2013-08-05','10:45:00',3.2),('16273','2013-08-05','10:50:00',3.27),('16273','2013-08-05','10:55:00',3.29),('16273','2013-08-05','11:00:00',3.3),('16273','2013-08-05','11:05:00',3.34),('16273','2013-08-05','11:10:00',3.38),('16273','2013-08-05','11:15:00',3.39),('16273','2013-08-05','11:20:00',3.44),('16273','2013-08-05','11:25:00',3.45),('16273','2013-08-05','11:30:00',3.45),('16273','2013-08-05','11:35:00',3.47),('16273','2013-08-05','11:40:00',3.5),('16273','2013-08-05','11:45:00',3.47),('16273','2013-08-05','11:50:00',3.49),('16273','2013-08-05','11:55:00',3.51),('16273','2013-08-05','12:00:00',3.52),('16273','2013-08-05','12:05:00',3.54),('16273','2013-08-05','12:10:00',3.49),('16273','2013-08-05','12:15:00',3.58),('16273','2013-08-05','12:20:00',3.52),('16273','2013-08-05','12:25:00',3.55),('16273','2013-08-05','12:30:00',3.56),('16273','2013-08-05','12:35:00',3.53),('16273','2013-08-05','12:40:00',3.56),('16273','2013-08-05','12:45:00',3.55),('16273','2013-08-05','12:50:00',3.52),('16273','2013-08-05','12:55:00',3.54),('16273','2013-08-05','13:00:00',3.53),('16273','2013-08-05','13:05:00',3.53),('16273','2013-08-05','13:10:00',3.5),('16273','2013-08-05','13:15:00',3.49),('16273','2013-08-05','13:20:00',3.5),('16273','2013-08-05','13:25:00',3.45),('16273','2013-08-05','13:30:00',3.42),('16273','2013-08-05','13:35:00',3.43),('16273','2013-08-05','13:40:00',3.42),('16273','2013-08-05','13:45:00',3.43),('16273','2013-08-05','13:50:00',3.4),('16273','2013-08-05','13:55:00',3.41),('16273','2013-08-05','14:00:00',3.39),('16273','2013-08-05','14:05:00',3.35),('16273','2013-08-05','14:10:00',3.32),('16273','2013-08-05','14:15:00',3.3),('16273','2013-08-05','14:20:00',3.27),('16273','2013-08-05','14:25:00',3.25),('16273','2013-08-05','14:30:00',3.22),('16273','2013-08-05','14:35:00',3.16),('16273','2013-08-05','14:40:00',3.14),('16273','2013-08-05','14:45:00',3.11),('16273','2013-08-05','14:50:00',3.08),('16273','2013-08-05','14:55:00',3.04),('16273','2013-08-05','15:00:00',3.01),('16273','2013-08-05','15:05:00',2.97),('16273','2013-08-05','15:10:00',2.93),('16273','2013-08-05','15:15:00',2.9),('16273','2013-08-05','15:20:00',2.83),('16273','2013-08-05','15:25:00',2.81),('16273','2013-08-05','15:30:00',2.76),('16273','2013-08-05','15:35:00',2.72),('16273','2013-08-05','15:40:00',2.67),('16273','2013-08-05','15:45:00',2.61),('16273','2013-08-05','15:50:00',2.55),('16273','2013-08-05','15:55:00',2.49),('16273','2013-08-05','16:00:00',2.44),('16273','2013-08-05','16:05:00',2.37),('16273','2013-08-05','16:10:00',2.31),('16273','2013-08-05','16:15:00',2.25),('16273','2013-08-05','16:20:00',2.19),('16273','2013-08-05','16:25:00',2.11),('16273','2013-08-05','16:30:00',2.06),('16273','2013-08-05','16:35:00',1.96),('16273','2013-08-05','16:40:00',1.92),('16273','2013-08-05','16:45:00',1.85),('16273','2013-08-05','16:50:00',1.78),('16273','2013-08-05','16:55:00',1.72),('16273','2013-08-05','17:00:00',1.64),('16273','2013-08-05','17:05:00',1.57),('16273','2013-08-05','17:10:00',1.51),('16273','2013-08-05','17:15:00',1.43),('16273','2013-08-05','17:20:00',1.37),('16273','2013-08-05','17:25:00',1.3),('16273','2013-08-05','17:30:00',1.23),('16273','2013-08-05','17:35:00',1.17),('16273','2013-08-05','17:40:00',1.1),('16273','2013-08-05','17:45:00',1.03),('16273','2013-08-04','07:35:00',1.08),('16273','2013-08-04','07:40:00',1.16),('16273','2013-08-04','07:45:00',1.24),('16273','2013-08-04','07:50:00',1.32),('16273','2013-08-04','07:55:00',1.39),('16273','2013-08-04','08:00:00',1.48),('16273','2013-08-04','08:05:00',1.57),('16273','2013-08-04','08:10:00',1.64),('16273','2013-08-04','08:15:00',1.71),('16273','2013-08-04','08:20:00',1.79),('16273','2013-08-04','08:25:00',1.87),('16273','2013-08-04','08:30:00',1.91),('16273','2013-08-04','08:35:00',1.98),('16273','2013-08-04','08:40:00',2.06),('16273','2013-08-04','08:45:00',2.12),('16273','2013-08-04','08:50:00',2.2),('16273','2013-08-04','08:55:00',2.27),('16273','2013-08-04','09:00:00',2.32),('16273','2013-08-04','09:05:00',2.38),('16273','2013-08-04','09:10:00',2.44),('16273','2013-08-04','09:15:00',2.5),('16273','2013-08-04','09:20:00',2.57),('16273','2013-08-04','09:25:00',2.62),('16273','2013-08-04','09:30:00',2.68),('16273','2013-08-04','09:35:00',2.71),('16273','2013-08-04','09:40:00',2.77),('16273','2013-08-04','09:45:00',2.82),('16273','2013-08-04','09:50:00',2.89),('16273','2013-08-04','09:55:00',2.92),('16273','2013-08-04','10:00:00',2.95),('16273','2013-08-04','10:05:00',2.98),('16273','2013-08-04','10:10:00',3.02),('16273','2013-08-04','10:15:00',3.07),('16273','2013-08-04','10:20:00',3.12),('16273','2013-08-04','10:25:00',3.17),('16273','2013-08-04','10:30:00',3.22),('16273','2013-08-04','10:35:00',3.24),('16273','2013-08-04','10:40:00',3.28),('16273','2013-08-04','10:45:00',3.3),('16273','2013-08-04','10:50:00',3.36),('16273','2013-08-04','10:55:00',3.4),('16273','2013-08-04','11:00:00',3.42),('16273','2013-08-04','11:05:00',3.44),('16273','2013-08-04','11:10:00',3.45),('16273','2013-08-04','11:15:00',3.46),('16273','2013-08-04','11:20:00',3.48),('16273','2013-08-04','11:25:00',3.5),('16273','2013-08-04','11:30:00',3.53),('16273','2013-08-04','11:35:00',3.53),('16273','2013-08-04','11:40:00',3.55),('16273','2013-08-04','11:45:00',3.54),('16273','2013-08-04','11:50:00',3.56),('16273','2013-08-04','11:55:00',3.58),('16273','2013-08-04','12:00:00',3.62),('16273','2013-08-04','12:05:00',3.62),('16273','2013-08-04','12:10:00',3.63),('16273','2013-08-04','12:15:00',3.63),('16273','2013-08-04','12:20:00',3.63),('16273','2013-08-04','12:25:00',3.63),('16273','2013-08-04','12:30:00',3.64),('16273','2013-08-04','12:35:00',3.64),('16273','2013-08-04','12:40:00',3.65),('16273','2013-08-04','12:45:00',3.64),('16273','2013-08-04','12:50:00',3.6),('16273','2013-08-04','12:55:00',3.62),('16273','2013-08-04','13:00:00',3.61),('16273','2013-08-04','13:05:00',3.61),('16273','2013-08-04','13:10:00',3.6),('16273','2013-08-04','13:15:00',3.6),('16273','2013-08-04','13:20:00',3.6),('16273','2013-08-04','13:25:00',3.59),('16273','2013-08-04','13:30:00',3.57),('16273','2013-08-04','13:35:00',3.53),('16273','2013-08-04','13:40:00',3.55),('16273','2013-08-04','13:45:00',3.52),('16273','2013-08-04','13:50:00',3.5),('16273','2013-08-04','13:55:00',3.49),('16273','2013-08-04','14:00:00',3.47),('16273','2013-08-04','14:05:00',3.46),('16273','2013-08-04','14:10:00',3.43),('16273','2013-08-04','14:15:00',3.41),('16273','2013-08-04','14:20:00',3.37),('16273','2013-08-04','14:25:00',3.35),('16273','2013-08-04','14:30:00',3.31),('16273','2013-08-04','14:35:00',3.29),('16273','2013-08-04','14:40:00',3.25),('16273','2013-08-04','14:45:00',3.21),('16273','2013-08-04','14:50:00',3.16),('16273','2013-08-04','14:55:00',3.13),('16273','2013-08-04','15:00:00',3.1),('16273','2013-08-04','15:05:00',3.06),('16273','2013-08-04','15:10:00',3.01),('16273','2013-08-04','15:15:00',2.98),('16273','2013-08-04','15:20:00',2.93),('16273','2013-08-04','15:25:00',2.88),('16273','2013-08-04','15:30:00',2.82),('16273','2013-08-04','15:35:00',2.77),('16273','2013-08-04','15:40:00',2.74),('16273','2013-08-04','15:45:00',2.7),('16273','2013-08-04','15:50:00',2.63),('16273','2013-08-04','15:55:00',2.57),('16273','2013-08-04','16:00:00',2.51),('16273','2013-08-04','16:05:00',2.45),('16273','2013-08-04','16:10:00',2.39),('16273','2013-08-04','16:15:00',2.33),('16273','2013-08-04','16:20:00',2.26),('16273','2013-08-04','16:25:00',2.2),('16273','2013-08-04','16:30:00',2.12),('16273','2013-08-04','16:35:00',2.05),('16273','2013-08-04','16:40:00',1.98),('16273','2013-08-04','16:45:00',1.91),('16273','2013-08-04','16:50:00',1.84),('16273','2013-08-04','16:55:00',1.77),('16273','2013-08-04','17:00:00',1.7),('16273','2013-08-04','17:05:00',1.63),('16273','2013-08-04','17:10:00',1.55),('16273','2013-08-04','17:15:00',1.47),('16273','2013-08-04','17:20:00',1.4),('16273','2013-08-04','17:25:00',1.33),('16273','2013-08-04','17:30:00',1.25),('16273','2013-08-04','17:35:00',1.18),('16273','2013-08-04','17:40:00',1.11),('16273','2013-08-04','17:45:00',1.04),('16273','2013-08-03','07:35:00',1.08),('16273','2013-08-03','07:40:00',1.15),('16273','2013-08-03','07:45:00',1.24),('16273','2013-08-03','07:50:00',1.3),('16273','2013-08-03','07:55:00',1.39),('16273','2013-08-03','08:00:00',1.46),('16273','2013-08-03','08:05:00',1.55),('16273','2013-08-03','08:10:00',1.63),('16273','2013-08-03','08:15:00',1.7),('16273','2013-08-03','08:20:00',1.78),('16273','2013-08-03','08:25:00',1.86),('16273','2013-08-03','08:30:00',1.94),('16273','2013-08-03','08:35:00',2),('16273','2013-08-03','08:40:00',2.08),('16273','2013-08-03','08:45:00',2.15),('16273','2013-08-03','08:50:00',2.22),('16273','2013-08-03','08:55:00',2.28),('16273','2013-08-03','09:00:00',2.32),('16273','2013-08-03','09:05:00',2.4),('16273','2013-08-03','09:10:00',2.46),('16273','2013-08-03','09:15:00',2.52),('16273','2013-08-03','09:20:00',2.57),('16273','2013-08-03','09:25:00',2.62),('16273','2013-08-03','09:30:00',2.68),('16273','2013-08-03','09:35:00',2.74),('16273','2013-08-03','09:40:00',2.78),('16273','2013-08-03','09:45:00',2.83),('16273','2013-08-03','09:50:00',2.87),('16273','2013-08-03','09:55:00',2.92),('16273','2013-08-03','10:00:00',2.96),('16273','2013-08-03','10:05:00',3.02),('16273','2013-08-03','10:10:00',3.06),('16273','2013-08-03','10:15:00',3.07),('16273','2013-08-03','10:20:00',3.13),('16273','2013-08-03','10:25:00',3.13),('16273','2013-08-03','10:30:00',3.2),('16273','2013-08-03','10:35:00',3.21),('16273','2013-08-03','10:40:00',3.28),('16273','2013-08-03','10:45:00',3.29),('16273','2013-08-03','10:50:00',3.32),('16273','2013-08-03','10:55:00',3.36),('16273','2013-08-03','11:00:00',3.37),('16273','2013-08-03','11:05:00',3.41),('16273','2013-08-03','11:10:00',3.43),('16273','2013-08-03','11:15:00',3.48),('16273','2013-08-03','11:20:00',3.51),('16273','2013-08-03','11:25:00',3.51),('16273','2013-08-03','11:30:00',3.51),('16273','2013-08-03','11:35:00',3.53),('16273','2013-08-03','11:40:00',3.53),('16273','2013-08-03','11:45:00',3.51),('16273','2013-08-03','11:50:00',3.54),('16273','2013-08-03','11:55:00',3.58),('16273','2013-08-03','12:00:00',3.61),('16273','2013-08-03','12:05:00',3.61),('16273','2013-08-03','12:10:00',3.57),('16273','2013-08-03','12:15:00',3.55),('16273','2013-08-03','12:20:00',3.54),('16273','2013-08-03','12:25:00',3.53),('16273','2013-08-03','12:30:00',3.5),('16273','2013-08-03','12:35:00',3.54),('16273','2013-08-03','12:40:00',3.56),('16273','2013-08-03','12:45:00',3.53),('16273','2013-08-03','12:50:00',3.55),('16273','2013-08-03','12:55:00',3.54),('16273','2013-08-03','13:00:00',3.56),('16273','2013-08-03','13:05:00',3.58),('16273','2013-08-03','13:10:00',3.57),('16273','2013-08-03','13:15:00',3.51),('16273','2013-08-03','13:20:00',3.52),('16273','2013-08-03','13:25:00',3.48),('16273','2013-08-03','13:30:00',3.49),('16273','2013-08-03','13:35:00',3.5),('16273','2013-08-03','13:40:00',3.49),('16273','2013-08-03','13:45:00',3.45),('16273','2013-08-03','13:50:00',3.42),('16273','2013-08-03','13:55:00',3.42),('16273','2013-08-03','14:00:00',3.4),('16273','2013-08-03','14:05:00',3.39),('16273','2013-08-03','14:10:00',3.39),('16273','2013-08-03','14:15:00',3.34),('16273','2013-08-03','14:20:00',3.32),('16273','2013-08-03','14:25:00',3.29),('16273','2013-08-03','14:30:00',3.28),('16273','2013-08-03','14:35:00',3.24),('16273','2013-08-03','14:40:00',3.2),('16273','2013-08-03','14:45:00',3.19),('16273','2013-08-03','14:50:00',3.17),('16273','2013-08-03','14:55:00',3.14),('16273','2013-08-03','15:00:00',3.07),('16273','2013-08-03','15:05:00',3.02),('16273','2013-08-03','15:10:00',2.98),('16273','2013-08-03','15:15:00',2.94),('16273','2013-08-03','15:20:00',2.9),('16273','2013-08-03','15:25:00',2.86),('16273','2013-08-03','15:30:00',2.82),('16273','2013-08-03','15:35:00',2.76),('16273','2013-08-03','15:40:00',2.71),('16273','2013-08-03','15:45:00',2.67),('16273','2013-08-03','15:50:00',2.6),('16273','2013-08-03','15:55:00',2.53),('16273','2013-08-03','16:00:00',2.49),('16273','2013-08-03','16:05:00',2.42),('16273','2013-08-03','16:10:00',2.37),('16273','2013-08-03','16:15:00',2.31),('16273','2013-08-03','16:20:00',2.25),('16273','2013-08-03','16:25:00',2.2),('16273','2013-08-03','16:30:00',2.12),('16273','2013-08-03','16:35:00',2.03),('16273','2013-08-03','16:40:00',1.96),('16273','2013-08-03','16:45:00',1.89),('16273','2013-08-03','16:50:00',1.82),('16273','2013-08-03','16:55:00',1.76),('16273','2013-08-03','17:00:00',1.69),('16273','2013-08-03','17:05:00',1.61),('16273','2013-08-03','17:10:00',1.55),('16273','2013-08-03','17:15:00',1.48),('16273','2013-08-03','17:20:00',1.41),('16273','2013-08-03','17:25:00',1.34),('16273','2013-08-03','17:30:00',1.26),('16273','2013-08-03','17:35:00',1.19),('16273','2013-08-03','17:40:00',1.13),('16273','2013-08-03','17:45:00',1.07),('16273','2013-08-02','07:30:00',1.08),('16273','2013-08-02','07:35:00',1.17),('16273','2013-08-02','07:40:00',1.26),('16273','2013-08-02','07:45:00',1.34),('16273','2013-08-02','07:50:00',1.42),('16273','2013-08-02','07:55:00',1.51),('16273','2013-08-02','08:00:00',1.59),('16273','2013-08-02','08:05:00',1.66),('16273','2013-08-02','08:10:00',1.74),('16273','2013-08-02','08:15:00',1.82),('16273','2013-08-02','08:20:00',1.89),('16273','2013-08-02','08:25:00',1.96),('16273','2013-08-02','08:30:00',2.04),('16273','2013-08-02','08:35:00',2.11),('16273','2013-08-02','08:40:00',2.18),('16273','2013-08-02','08:45:00',2.25),('16273','2013-08-02','08:50:00',2.31),('16273','2013-08-02','08:55:00',2.37),('16273','2013-08-02','09:00:00',2.41),('16273','2013-08-02','09:05:00',2.49),('16273','2013-08-02','09:10:00',2.54),('16273','2013-08-02','09:15:00',2.6),('16273','2013-08-02','09:20:00',2.66),('16273','2013-08-02','09:25:00',2.72),('16273','2013-08-02','09:30:00',2.78),('16273','2013-08-02','09:35:00',2.83),('16273','2013-08-02','09:40:00',2.88),('16273','2013-08-02','09:45:00',2.92),('16273','2013-08-02','09:50:00',2.95),('16273','2013-08-02','09:55:00',2.98),('16273','2013-08-02','10:00:00',3.02),('16273','2013-08-02','10:05:00',3.07),('16273','2013-08-02','10:10:00',3.12),('16273','2013-08-02','10:15:00',3.16),('16273','2013-08-02','10:20:00',3.21),('16273','2013-08-02','10:25:00',3.23),('16273','2013-08-02','10:30:00',3.27),('16273','2013-08-02','10:35:00',3.3),('16273','2013-08-02','10:40:00',3.33),('16273','2013-08-02','10:45:00',3.34),('16273','2013-08-02','10:50:00',3.38),('16273','2013-08-02','10:55:00',3.41),('16273','2013-08-02','11:00:00',3.43),('16273','2013-08-02','11:05:00',3.45),('16273','2013-08-02','11:10:00',3.46),('16273','2013-08-02','11:15:00',3.46),('16273','2013-08-02','11:20:00',3.51),('16273','2013-08-02','11:25:00',3.53),('16273','2013-08-02','11:30:00',3.54),('16273','2013-08-02','11:35:00',3.55),('16273','2013-08-02','11:40:00',3.55),('16273','2013-08-02','11:45:00',3.55),('16273','2013-08-02','11:50:00',3.58),('16273','2013-08-02','11:55:00',3.59),('16273','2013-08-02','12:00:00',3.59),('16273','2013-08-02','12:05:00',3.59),('16273','2013-08-02','12:10:00',3.61),('16273','2013-08-02','12:15:00',3.61),('16273','2013-08-02','12:20:00',3.62),('16273','2013-08-02','12:25:00',3.6),('16273','2013-08-02','12:30:00',3.62),('16273','2013-08-02','12:35:00',3.61),('16273','2013-08-02','12:40:00',3.59),('16273','2013-08-02','12:45:00',3.58),('16273','2013-08-02','12:50:00',3.59),('16273','2013-08-02','12:55:00',3.58),('16273','2013-08-02','13:00:00',3.57),('16273','2013-08-02','13:05:00',3.61),('16273','2013-08-02','13:10:00',3.6),('16273','2013-08-02','13:15:00',3.58),('16273','2013-08-02','13:20:00',3.57),('16273','2013-08-02','13:25:00',3.55),('16273','2013-08-02','13:30:00',3.53),('16273','2013-08-02','13:35:00',3.47),('16273','2013-08-02','13:40:00',3.47),('16273','2013-08-02','13:45:00',3.41),('16273','2013-08-02','13:50:00',3.44),('16273','2013-08-02','13:55:00',3.47),('16273','2013-08-02','14:00:00',3.47),('16273','2013-08-02','14:05:00',3.49),('16273','2013-08-02','14:10:00',3.46),('16273','2013-08-02','14:15:00',3.39),('16273','2013-08-02','14:20:00',3.36),('16273','2013-08-02','14:25:00',3.35),('16273','2013-08-02','14:30:00',3.29),('16273','2013-08-02','14:35:00',3.28),('16273','2013-08-02','14:40:00',3.26),('16273','2013-08-02','14:45:00',3.21),('16273','2013-08-02','14:50:00',3.19),('16273','2013-08-02','14:55:00',3.13),('16273','2013-08-02','15:00:00',3.09),('16273','2013-08-02','15:05:00',3.06),('16273','2013-08-02','15:10:00',3.03),('16273','2013-08-02','15:15:00',2.99),('16273','2013-08-02','15:20:00',2.96),('16273','2013-08-02','15:25:00',2.92),('16273','2013-08-02','15:30:00',2.88),('16273','2013-08-02','15:35:00',2.84),('16273','2013-08-02','15:40:00',2.77),('16273','2013-08-02','15:45:00',2.7),('16273','2013-08-02','15:50:00',2.64),('16273','2013-08-02','15:55:00',2.58),('16273','2013-08-02','16:00:00',2.52),('16273','2013-08-02','16:05:00',2.48),('16273','2013-08-02','16:10:00',2.41),('16273','2013-08-02','16:15:00',2.35),('16273','2013-08-02','16:20:00',2.3),('16273','2013-08-02','16:25:00',2.22),('16273','2013-08-02','16:30:00',2.15),('16273','2013-08-02','16:35:00',2.08),('16273','2013-08-02','16:40:00',2),('16273','2013-08-02','16:45:00',1.92),('16273','2013-08-02','16:50:00',1.87),('16273','2013-08-02','16:55:00',1.81),('16273','2013-08-02','17:00:00',1.75),('16273','2013-08-02','17:05:00',1.66),('16273','2013-08-02','17:10:00',1.59),('16273','2013-08-02','17:15:00',1.51),('16273','2013-08-02','17:20:00',1.43),('16273','2013-08-02','17:25:00',1.36),('16273','2013-08-02','17:30:00',1.3),('16273','2013-08-02','17:35:00',1.24),('16273','2013-08-02','17:40:00',1.17),('16273','2013-08-02','17:45:00',1.09),('16273','2013-08-02','17:50:00',1.02),('16273','2013-08-01','07:30:00',1.1),('16273','2013-08-01','07:35:00',1.19),('16273','2013-08-01','07:40:00',1.28),('16273','2013-08-01','07:45:00',1.36),('16273','2013-08-01','07:50:00',1.44),('16273','2013-08-01','07:55:00',1.53),('16273','2013-08-01','08:00:00',1.61),('16273','2013-08-01','08:05:00',1.69),('16273','2013-08-01','08:10:00',1.77),('16273','2013-08-01','08:15:00',1.83),('16273','2013-08-01','08:20:00',1.91),('16273','2013-08-01','08:25:00',1.98),('16273','2013-08-01','08:30:00',2.06),('16273','2013-08-01','08:35:00',2.12),('16273','2013-08-01','08:40:00',2.21),('16273','2013-08-01','08:45:00',2.27),('16273','2013-08-01','08:50:00',2.34),('16273','2013-08-01','08:55:00',2.42),('16273','2013-08-01','09:00:00',2.48),('16273','2013-08-01','09:05:00',2.55),('16273','2013-08-01','09:10:00',2.62),('16273','2013-08-01','09:15:00',2.7),('16273','2013-08-01','09:20:00',2.77),('16273','2013-08-01','09:25:00',2.84),('16273','2013-08-01','09:30:00',2.91),('16273','2013-08-01','09:35:00',2.98),('16273','2013-08-01','09:40:00',3.02),('16273','2013-08-01','09:45:00',3.08),('16273','2013-08-01','09:50:00',3.13),('16273','2013-08-01','09:55:00',3.2),('16273','2013-08-01','10:00:00',3.25),('16273','2013-08-01','10:05:00',3.3),('16273','2013-08-01','10:10:00',3.35),('16273','2013-08-01','10:15:00',3.4),('16273','2013-08-01','10:20:00',3.45),('16273','2013-08-01','10:25:00',3.49),('16273','2013-08-01','10:30:00',3.51),('16273','2013-08-01','10:35:00',3.56),('16273','2013-08-01','10:40:00',3.61),('16273','2013-08-01','10:45:00',3.63),('16273','2013-08-01','10:50:00',3.65),('16273','2013-08-01','10:55:00',3.67),('16273','2013-08-01','11:00:00',3.69),('16273','2013-08-01','11:05:00',3.71),('16273','2013-08-01','11:10:00',3.72),('16273','2013-08-01','11:15:00',3.78),('16273','2013-08-01','11:20:00',3.8),('16273','2013-08-01','11:25:00',3.81),('16273','2013-08-01','11:30:00',3.81),('16273','2013-08-01','11:35:00',3.83),('16273','2013-08-01','11:40:00',3.83),('16273','2013-08-01','11:45:00',3.82),('16273','2013-08-01','11:50:00',3.82),('16273','2013-08-01','11:55:00',3.86),('16273','2013-08-01','12:00:00',3.88),('16273','2013-08-01','12:05:00',3.88),('16273','2013-08-01','12:10:00',3.89),('16273','2013-08-01','12:15:00',3.92),('16273','2013-08-01','12:20:00',3.93),('16273','2013-08-01','12:25:00',3.89),('16273','2013-08-01','12:30:00',3.9),('16273','2013-08-01','12:35:00',3.88),('16273','2013-08-01','12:40:00',3.89),('16273','2013-08-01','12:45:00',3.88),('16273','2013-08-01','12:50:00',3.87),('16273','2013-08-01','12:55:00',3.86),('16273','2013-08-01','13:00:00',3.84),('16273','2013-08-01','13:05:00',3.85),('16273','2013-08-01','13:10:00',3.85),('16273','2013-08-01','13:15:00',3.83),('16273','2013-08-01','13:20:00',3.82),('16273','2013-08-01','13:25:00',3.79),('16273','2013-08-01','13:30:00',3.78),('16273','2013-08-01','13:35:00',3.75),('16273','2013-08-01','13:40:00',3.75),('16273','2013-08-01','13:45:00',3.72),('16273','2013-08-01','13:50:00',3.71),('16273','2013-08-01','13:55:00',3.68),('16273','2013-08-01','14:00:00',3.67),('16273','2013-08-01','14:05:00',3.63),('16273','2013-08-01','14:10:00',3.59),('16273','2013-08-01','14:15:00',3.52),('16273','2013-08-01','14:20:00',3.54),('16273','2013-08-01','14:25:00',3.51),('16273','2013-08-01','14:30:00',3.45),('16273','2013-08-01','14:35:00',3.4),('16273','2013-08-01','14:40:00',3.37),('16273','2013-08-01','14:45:00',3.34),('16273','2013-08-01','14:50:00',3.26),('16273','2013-08-01','14:55:00',3.25),('16273','2013-08-01','15:00:00',3.2),('16273','2013-08-01','15:05:00',3.17),('16273','2013-08-01','15:10:00',3.13),('16273','2013-08-01','15:15:00',3.08),('16273','2013-08-01','15:20:00',3.03),('16273','2013-08-01','15:25:00',2.97),('16273','2013-08-01','15:30:00',2.88),('16273','2013-08-01','15:35:00',2.86),('16273','2013-08-01','15:40:00',2.81),('16273','2013-08-01','15:45:00',2.76),('16273','2013-08-01','15:50:00',2.7),('16273','2013-08-01','15:55:00',2.6),('16273','2013-08-01','16:00:00',2.56),('16273','2013-08-01','16:05:00',2.5),('16273','2013-08-01','16:10:00',2.44),('16273','2013-08-01','16:15:00',2.38),('16273','2013-08-01','16:20:00',2.31),('16273','2013-08-01','16:25:00',2.25),('16273','2013-08-01','16:30:00',2.18),('16273','2013-08-01','16:35:00',2.11),('16273','2013-08-01','16:40:00',2.03),('16273','2013-08-01','16:45:00',1.96),('16273','2013-08-01','16:50:00',1.9),('16273','2013-08-01','16:55:00',1.82),('16273','2013-08-01','17:00:00',1.75),('16273','2013-08-01','17:05:00',1.68),('16273','2013-08-01','17:10:00',1.6),('16273','2013-08-01','17:15:00',1.52),('16273','2013-08-01','17:20:00',1.46),('16273','2013-08-01','17:25:00',1.38),('16273','2013-08-01','17:30:00',1.3),('16273','2013-08-01','17:35:00',1.23),('16273','2013-08-01','17:40:00',1.15),('16273','2013-08-01','17:45:00',1.07),('16273','2013-08-01','17:50:00',1),('16273','2013-07-31','07:30:00',1.1),('16273','2013-07-31','07:35:00',1.18),('16273','2013-07-31','07:40:00',1.3),('16273','2013-07-31','07:45:00',1.4),('16273','2013-07-31','07:50:00',1.48),('16273','2013-07-31','07:55:00',1.55),('16273','2013-07-31','08:00:00',1.63),('16273','2013-07-31','08:05:00',1.72),('16273','2013-07-31','08:10:00',1.8),('16273','2013-07-31','08:15:00',1.89),('16273','2013-07-31','08:20:00',1.95),('16273','2013-07-31','08:25:00',2.01),('16273','2013-07-31','08:30:00',2.08),('16273','2013-07-31','08:35:00',2.16),('16273','2013-07-31','08:40:00',2.23),('16273','2013-07-31','08:45:00',2.3),('16273','2013-07-31','08:50:00',2.36),('16273','2013-07-31','08:55:00',2.38),('16273','2013-07-31','09:00:00',2.47),('16273','2013-07-31','09:05:00',2.52),('16273','2013-07-31','09:10:00',2.58),('16273','2013-07-31','09:15:00',2.64),('16273','2013-07-31','09:20:00',2.7),('16273','2013-07-31','09:25:00',2.73),('16273','2013-07-31','09:30:00',2.79),('16273','2013-07-31','09:35:00',2.83),('16273','2013-07-31','09:40:00',2.92),('16273','2013-07-31','09:45:00',2.95),('16273','2013-07-31','09:50:00',3.01),('16273','2013-07-31','09:55:00',3.06),('16273','2013-07-31','10:00:00',3.11),('16273','2013-07-31','10:05:00',3.15),('16273','2013-07-31','10:10:00',3.19),('16273','2013-07-31','10:15:00',3.24),('16273','2013-07-31','10:20:00',3.3),('16273','2013-07-31','10:25:00',3.36),('16273','2013-07-31','10:30:00',3.39),('16273','2013-07-31','10:35:00',3.4),('16273','2013-07-31','10:40:00',3.46),('16273','2013-07-31','10:45:00',3.46),('16273','2013-07-31','10:50:00',3.56),('16273','2013-07-31','10:55:00',3.61),('16273','2013-07-31','11:00:00',3.62),('16273','2013-07-31','11:05:00',3.66),('16273','2013-07-31','11:10:00',3.67),('16273','2013-07-31','11:15:00',3.66),('16273','2013-07-31','11:20:00',3.64),('16273','2013-07-31','11:25:00',3.69),('16273','2013-07-31','11:30:00',3.73),('16273','2013-07-31','11:35:00',3.73),('16273','2013-07-31','11:40:00',3.72),('16273','2013-07-31','11:45:00',3.77),('16273','2013-07-31','11:50:00',3.8),('16273','2013-07-31','11:55:00',3.83),('16273','2013-07-31','12:00:00',3.78),('16273','2013-07-31','12:05:00',3.86),('16273','2013-07-31','12:10:00',3.85),('16273','2013-07-31','12:15:00',3.88),('16273','2013-07-31','12:20:00',3.9),('16273','2013-07-31','12:25:00',3.9),('16273','2013-07-31','12:30:00',3.93),('16273','2013-07-31','12:35:00',3.89),('16273','2013-07-31','12:40:00',3.88),('16273','2013-07-31','12:45:00',3.86),('16273','2013-07-31','12:50:00',3.85),('16273','2013-07-31','12:55:00',3.87),('16273','2013-07-31','13:00:00',3.86),('16273','2013-07-31','13:05:00',3.84),('16273','2013-07-31','13:10:00',3.86),('16273','2013-07-31','13:15:00',3.8),('16273','2013-07-31','13:20:00',3.76),('16273','2013-07-31','13:25:00',3.79),('16273','2013-07-31','13:30:00',3.76),('16273','2013-07-31','13:35:00',3.72),('16273','2013-07-31','13:40:00',3.68),('16273','2013-07-31','13:45:00',3.55),('16273','2013-07-31','13:50:00',3.65),('16273','2013-07-31','13:55:00',3.65),('16273','2013-07-31','14:00:00',2.65),('16273','2013-07-31','14:05:00',3.6),('16273','2013-07-31','14:10:00',2.22),('16273','2013-07-31','14:15:00',3.65),('16273','2013-07-31','14:20:00',3.22),('16273','2013-07-31','14:25:00',2.85),('16273','2013-07-31','14:30:00',3.5),('16273','2013-07-31','14:35:00',3.46),('16273','2013-07-31','14:40:00',3.4),('16273','2013-07-31','14:45:00',3.31),('16273','2013-07-31','14:50:00',3.28),('16273','2013-07-31','14:55:00',3.22),('16273','2013-07-31','15:00:00',3.14),('16273','2013-07-31','15:05:00',3.22),('16273','2013-07-31','15:10:00',3.13),('16273','2013-07-31','15:15:00',3.1),('16273','2013-07-31','15:20:00',3.02),('16273','2013-07-31','15:25:00',2.26),('16273','2013-07-31','15:30:00',2.9),('16273','2013-07-31','15:35:00',2.86),('16273','2013-07-31','15:40:00',2.82),('16273','2013-07-31','15:45:00',2.8),('16273','2013-07-31','15:50:00',2.69),('16273','2013-07-31','15:55:00',2.68),('16273','2013-07-31','16:00:00',2.67),('16273','2013-07-31','16:05:00',2.58),('16273','2013-07-31','16:10:00',2.28),('16273','2013-07-31','16:15:00',2.38),('16273','2013-07-31','16:20:00',2.41),('16273','2013-07-31','16:25:00',1.94),('16273','2013-07-31','16:30:00',1.82),('16273','2013-07-31','16:35:00',2.17),('16273','2013-07-31','16:40:00',1.58),('16273','2013-07-31','16:45:00',1.28),('16273','2013-07-31','16:50:00',1),('16273','2013-07-31','16:55:00',2.01),('16273','2013-07-31','17:00:00',1.06),('16273','2013-07-31','17:05:00',1.09),('16273','2013-07-31','17:10:00',1.87),('16273','2013-07-31','17:15:00',1.71),('16273','2013-07-31','17:20:00',1.58),('16273','2013-07-31','17:25:00',1.44),('16273','2013-07-31','17:30:00',1.34),('16273','2013-07-31','17:35:00',1.25),('16273','2013-07-31','17:40:00',1.16),('16273','2013-07-31','17:45:00',1.09),('16273','2013-07-31','17:50:00',1.03),('16273','2014-04-08','08:15:00',1.11),('16273','2014-04-08','08:30:00',1.7),('16273','2014-04-08','08:35:00',1.68),('16273','2014-04-08','08:40:00',1.42),('16273','2014-04-08','08:45:00',1.93),('16273','2014-04-08','08:50:00',2.06),('16273','2014-04-08','08:55:00',2.15),('16273','2014-04-08','09:00:00',2.22),('16273','2014-04-08','09:05:00',2.28),('16273','2014-04-08','09:10:00',2.35),('16273','2014-04-08','09:15:00',2.42),('16273','2014-04-08','09:20:00',2.47),('16273','2014-04-08','09:25:00',2.48),('16273','2014-04-08','09:30:00',2.5),('16273','2014-04-08','09:35:00',2.56),('16273','2014-04-08','09:40:00',2.63),('16273','2014-04-08','09:45:00',2.67),('16273','2014-04-08','09:50:00',2.62),('16273','2014-04-08','09:55:00',2.8),('16273','2014-04-08','10:00:00',2.93),('16273','2014-04-08','10:05:00',2.99),('16273','2014-04-08','10:10:00',3.02),('16273','2014-04-08','10:15:00',3.03),('16273','2014-04-08','10:20:00',3.1),('16273','2014-04-08','10:25:00',3.15),('16273','2014-04-08','10:30:00',3.21),('16273','2014-04-08','10:35:00',3.29),('16273','2014-04-08','10:40:00',3.29),('16273','2014-04-08','10:45:00',3.32),('16273','2014-04-08','10:50:00',3.35),('16273','2014-04-08','10:55:00',3.4),('16273','2014-04-08','11:00:00',3.41),('16273','2014-04-08','11:05:00',3.45),('16273','2014-04-08','11:10:00',3.44),('16273','2014-04-08','11:15:00',3.49),('16273','2014-04-08','11:20:00',3.57),('16273','2014-04-08','11:25:00',3.64),('16273','2014-04-08','11:30:00',3.51),('16273','2014-04-08','11:35:00',3.51),('16273','2014-04-08','11:40:00',3.56),('16273','2014-04-08','11:45:00',3.54),('16273','2014-04-08','11:50:00',3.57),('16273','2014-04-08','11:55:00',3.61),('16273','2014-04-08','12:00:00',3.54),('16273','2014-04-08','12:05:00',3.51),('16273','2014-04-08','12:10:00',3.35),('16273','2014-04-08','12:15:00',3.21),('16273','2014-04-08','12:20:00',3.74),('16273','2014-04-08','12:25:00',3.53),('16273','2014-04-08','12:30:00',3.53),('16273','2014-04-08','12:35:00',3.81),('16273','2014-04-08','12:40:00',3.58),('16273','2014-04-08','12:45:00',3.54),('16273','2014-04-08','12:50:00',3.55),('16273','2014-04-08','12:55:00',3.38),('16273','2014-04-08','13:00:00',3.39),('16273','2014-04-08','13:05:00',3.52),('16273','2014-04-08','13:10:00',3.73),('16273','2014-04-08','13:15:00',3.71),('16273','2014-04-08','13:20:00',3.71),('16273','2014-04-08','13:25:00',3.66),('16273','2014-04-08','13:30:00',3.64),('16273','2014-04-08','13:35:00',3.59),('16273','2014-04-08','13:40:00',3.58),('16273','2014-04-08','13:45:00',3.61),('16273','2014-04-08','13:50:00',3.38),('16273','2014-04-08','13:55:00',3.17),('16273','2014-04-08','14:00:00',3.19),('16273','2014-04-08','14:05:00',3.06),('16273','2014-04-08','14:10:00',3.45),('16273','2014-04-08','14:15:00',3.47),('16273','2014-04-08','14:20:00',3.42),('16273','2014-04-08','14:25:00',2.82),('16273','2014-04-08','14:30:00',3.38),('16273','2014-04-08','14:35:00',2.88),('16273','2014-04-08','14:40:00',2.78),('16273','2014-04-08','14:45:00',3.27),('16273','2014-04-08','14:50:00',3.2),('16273','2014-04-08','14:55:00',3.09),('16273','2014-04-08','15:00:00',3.03),('16273','2014-04-08','15:05:00',2.99),('16273','2014-04-08','15:10:00',2.9),('16273','2014-04-08','15:15:00',2.85),('16273','2014-04-08','15:20:00',2.82),('16273','2014-04-08','15:25:00',2.69),('16273','2014-04-08','15:30:00',2.69),('16273','2014-04-08','15:35:00',2.53),('16273','2014-04-08','15:40:00',2.51),('16273','2014-04-08','15:45:00',2.5),('16273','2014-04-08','15:50:00',2.43),('16273','2014-04-08','15:55:00',2.37),('16273','2014-04-08','16:00:00',2.37),('16273','2014-04-08','16:05:00',2.31),('16273','2014-04-08','16:10:00',2.17),('16273','2014-04-08','16:15:00',2.15),('16273','2014-04-08','16:20:00',1.96),('16273','2014-04-08','16:25:00',1.94),('16273','2014-04-08','16:30:00',1.92),('16273','2014-04-08','16:35:00',1.83),('16273','2014-04-08','16:40:00',1.74),('16273','2014-04-08','16:45:00',1.71),('16273','2014-04-08','16:50:00',1.52),('16273','2014-04-08','16:55:00',1.46),('16273','2014-04-08','17:00:00',1.47),('16273','2014-04-08','17:05:00',1.38),('16273','2014-04-08','17:10:00',1.29),('16273','2014-04-08','17:15:00',1.24),('16273','2014-04-08','17:20:00',1.15),('16273','2014-04-08','17:25:00',1),('16273','2013-07-30','07:40:00',1.15),('16273','2013-07-30','07:45:00',1.6),('16273','2013-07-30','07:50:00',1.52),('16273','2013-07-30','08:00:00',1.3),('16273','2013-07-30','08:05:00',1.66),('16273','2013-07-30','08:10:00',1.75),('16273','2013-07-30','08:15:00',1.81),('16273','2013-07-30','08:20:00',1.89),('16273','2013-07-30','08:25:00',1.98),('16273','2013-07-30','08:30:00',2.08),('16273','2013-07-30','08:35:00',2.08),('16273','2013-07-30','08:40:00',1.83),('16273','2013-07-30','08:45:00',1.44),('16273','2013-07-30','08:50:00',2.26),('16273','2013-07-30','08:55:00',2.22),('16273','2013-07-30','09:00:00',2.64),('16273','2013-07-30','09:05:00',1.84),('16273','2013-07-30','09:10:00',2.7),('16273','2013-07-30','09:15:00',2.85),('16273','2013-07-30','09:20:00',2.87),('16273','2013-07-30','09:25:00',2.84),('16273','2013-07-30','09:30:00',2.19),('16273','2013-07-30','09:35:00',3.03),('16273','2013-07-30','09:40:00',2.02),('16273','2013-07-30','09:50:00',1.1),('16273','2013-07-30','09:55:00',3.24),('16273','2013-07-30','10:00:00',2.85),('16273','2013-07-30','10:05:00',2.8),('16273','2013-07-30','10:10:00',2.13),('16273','2013-07-30','10:15:00',1.5),('16273','2013-07-30','10:20:00',1.41),('16273','2013-07-30','10:30:00',2),('16273','2013-07-30','10:35:00',3.67),('16273','2013-07-30','10:40:00',3.19),('16273','2013-07-30','10:45:00',3.29),('16273','2013-07-30','10:50:00',3.51),('16273','2013-07-30','10:55:00',3.55),('16273','2013-07-30','11:00:00',3.53),('16273','2013-07-30','11:05:00',2.66),('16273','2013-07-30','11:15:00',1.93),('16273','2013-07-30','11:20:00',1.98),('16273','2013-07-30','11:25:00',3.74),('16273','2013-07-30','11:30:00',3.8),('16273','2013-07-30','11:35:00',3.8),('16273','2013-07-30','11:40:00',3.83),('16273','2013-07-30','11:45:00',3.82),('16273','2013-07-30','11:50:00',2.85),('16273','2013-07-30','11:55:00',3.81),('16273','2013-07-30','12:00:00',3.76),('16273','2013-07-30','12:05:00',3.78),('16273','2013-07-30','12:10:00',3.81),('16273','2013-07-30','12:15:00',3.86),('16273','2013-07-30','12:20:00',3.75),('16273','2013-07-30','12:25:00',3.83),('16273','2013-07-30','12:30:00',3.84),('16273','2013-07-30','12:35:00',3.65),('16273','2013-07-30','12:40:00',3.93),('16273','2013-07-30','12:45:00',3.77),('16273','2013-07-30','12:50:00',3.79),('16273','2013-07-30','12:55:00',3.07),('16273','2013-07-30','13:00:00',3.99),('16273','2013-07-30','13:05:00',2.4),('16273','2013-07-30','13:10:00',2.64),('16273','2013-07-30','13:15:00',2.44),('16273','2013-07-30','13:20:00',3.93),('16273','2013-07-30','13:25:00',3.86),('16273','2013-07-30','13:30:00',3.81),('16273','2013-07-30','13:35:00',3.8),('16273','2013-07-30','13:40:00',3.73),('16273','2013-07-30','13:45:00',3.15),('16273','2013-07-30','13:50:00',3.69),('16273','2013-07-30','13:55:00',3.7),('16273','2013-07-30','14:00:00',3.68),('16273','2013-07-30','14:05:00',3.64),('16273','2013-07-30','14:10:00',3.46),('16273','2013-07-30','14:15:00',3.43),('16273','2013-07-30','14:20:00',3.47),('16273','2013-07-30','14:25:00',3.43),('16273','2013-07-30','14:30:00',3.4),('16273','2013-07-30','14:35:00',3.36),('16273','2013-07-30','14:40:00',3.28),('16273','2013-07-30','14:45:00',3.28),('16273','2013-07-30','14:50:00',3.25),('16273','2013-07-30','14:55:00',3.21),('16273','2013-07-30','15:00:00',3.15),('16273','2013-07-30','15:05:00',3.1),('16273','2013-07-30','15:10:00',3.07),('16273','2013-07-30','15:15:00',3.02),('16273','2013-07-30','15:20:00',2.98),('16273','2013-07-30','15:25:00',2.91),('16273','2013-07-30','15:30:00',2.86),('16273','2013-07-30','15:35:00',2.79),('16273','2013-07-30','15:40:00',2.76),('16273','2013-07-30','15:45:00',2.72),('16273','2013-07-30','15:50:00',2.65),('16273','2013-07-30','15:55:00',2.6),('16273','2013-07-30','16:00:00',2.54),('16273','2013-07-30','16:05:00',2.48),('16273','2013-07-30','16:10:00',2.42),('16273','2013-07-30','16:15:00',2.36),('16273','2013-07-30','16:20:00',2.3),('16273','2013-07-30','16:25:00',2.22),('16273','2013-07-30','16:30:00',2.14),('16273','2013-07-30','16:35:00',2.06),('16273','2013-07-30','16:40:00',1.99),('16273','2013-07-30','16:45:00',1.92),('16273','2013-07-30','16:50:00',1.87),('16273','2013-07-30','16:55:00',1.8),('16273','2013-07-30','17:00:00',1.72),('16273','2013-07-30','17:05:00',1.65),('16273','2013-07-30','17:10:00',1.57),('16273','2013-07-30','17:15:00',1.5),('16273','2013-07-30','17:20:00',1.43),('16273','2013-07-30','17:25:00',1.37),('16273','2013-07-30','17:30:00',1.3),('16273','2013-07-30','17:35:00',1.25),('16273','2013-07-30','17:40:00',1.18),('16273','2013-07-30','17:45:00',1.09),('16273','2013-07-30','17:50:00',1.02),('16273','2013-07-29','07:40:00',1.07),('16273','2013-07-29','07:45:00',1.16),('16273','2013-07-29','07:50:00',1.25),('16273','2013-07-29','07:55:00',1.32),('16273','2013-07-29','08:00:00',1.4),('16273','2013-07-29','08:05:00',1.47),('16273','2013-07-29','08:10:00',1.55),('16273','2013-07-29','08:15:00',1.61),('16273','2013-07-29','08:20:00',1.68),('16273','2013-07-29','08:25:00',1.76),('16273','2013-07-29','08:30:00',1.86),('16273','2013-07-29','08:35:00',1.93),('16273','2013-07-29','08:40:00',2.01),('16273','2013-07-29','08:45:00',2.07),('16273','2013-07-29','08:50:00',2.15),('16273','2013-07-29','08:55:00',2.21),('16273','2013-07-29','09:00:00',2.28),('16273','2013-07-29','09:05:00',2.35),('16273','2013-07-29','09:10:00',2.41),('16273','2013-07-29','09:15:00',2.47),('16273','2013-07-29','09:20:00',2.52),('16273','2013-07-29','09:25:00',2.59),('16273','2013-07-29','09:30:00',2.63),('16273','2013-07-29','09:35:00',2.68),('16273','2013-07-29','09:40:00',2.74),('16273','2013-07-29','09:45:00',2.81),('16273','2013-07-29','09:50:00',2.86),('16273','2013-07-29','09:55:00',2.9),('16273','2013-07-29','10:00:00',2.94),('16273','2013-07-29','10:05:00',2.96),('16273','2013-07-29','10:10:00',3.01),('16273','2013-07-29','10:15:00',3.06),('16273','2013-07-29','10:20:00',3.1),('16273','2013-07-29','10:25:00',3.12),('16273','2013-07-29','10:30:00',3.15),('16273','2013-07-29','10:35:00',3.18),('16273','2013-07-29','10:40:00',3.2),('16273','2013-07-29','10:45:00',3.25),('16273','2013-07-29','10:50:00',3.29),('16273','2013-07-29','10:55:00',3.3),('16273','2013-07-29','11:00:00',3.3),('16273','2013-07-29','11:05:00',3.34),('16273','2013-07-29','11:10:00',3.35),('16273','2013-07-29','11:15:00',3.35),('16273','2013-07-29','11:20:00',3.35),('16273','2013-07-29','11:25:00',3.39),('16273','2013-07-29','11:30:00',3.44),('16273','2013-07-29','11:35:00',3.46),('16273','2013-07-29','11:40:00',3.46),('16273','2013-07-29','11:45:00',3.41),('16273','2013-07-29','11:50:00',3.5),('16273','2013-07-29','11:55:00',3.52),('16273','2013-07-29','12:00:00',3.53),('16273','2013-07-29','12:05:00',3.55),('16273','2013-07-29','12:10:00',3.55),('16273','2013-07-29','12:15:00',3.55),('16273','2013-07-29','12:20:00',3.55),('16273','2013-07-29','12:25:00',3.53),('16273','2013-07-29','12:30:00',3.53),('16273','2013-07-29','12:35:00',3.52),('16273','2013-07-29','12:40:00',3.5),('16273','2013-07-29','12:45:00',3.5),('16273','2013-07-29','12:50:00',3.51),('16273','2013-07-29','12:55:00',3.57),('16273','2013-07-29','13:00:00',3.6),('16273','2013-07-29','13:05:00',3.6),('16273','2013-07-29','13:10:00',3.6),('16273','2013-07-29','13:15:00',3.6),('16273','2013-07-29','13:20:00',3.6),('16273','2013-07-29','13:25:00',3.57),('16273','2013-07-29','13:30:00',3.58),('16273','2013-07-29','13:35:00',3.57),('16273','2013-07-29','13:40:00',3.55),('16273','2013-07-29','13:45:00',3.53),('16273','2013-07-29','13:50:00',3.52),('16273','2013-07-29','13:55:00',3.49),('16273','2013-07-29','14:00:00',3.48),('16273','2013-07-29','14:05:00',3.44),('16273','2013-07-29','14:10:00',3.43),('16273','2013-07-29','14:15:00',3.4),('16273','2013-07-29','14:20:00',3.39),('16273','2013-07-29','14:25:00',3.34),('16273','2013-07-29','14:30:00',3.3),('16273','2013-07-29','14:35:00',3.28),('16273','2013-07-29','14:40:00',3.25),('16273','2013-07-29','14:45:00',3.21),('16273','2013-07-29','14:50:00',3.18),('16273','2013-07-29','14:55:00',3.14),('16273','2013-07-29','15:00:00',3.06),('16273','2013-07-29','15:05:00',3.05),('16273','2013-07-29','15:10:00',3.01),('16273','2013-07-29','15:15:00',2.96),('16273','2013-07-29','15:20:00',2.93),('16273','2013-07-29','15:25:00',2.89),('16273','2013-07-29','15:30:00',2.87),('16273','2013-07-29','15:35:00',2.87),('16273','2013-07-29','15:40:00',2.34),('16273','2013-07-29','15:45:00',2.43),('16273','2013-07-29','15:50:00',1.94),('16273','2013-07-29','15:55:00',1.85),('16273','2013-07-29','16:00:00',2.77),('16273','2013-07-29','16:05:00',2.24),('16273','2013-07-29','16:10:00',2.35),('16273','2013-07-29','16:15:00',1.74),('16273','2013-07-29','16:20:00',2),('16273','2013-07-29','16:25:00',2.43),('16273','2013-07-29','16:30:00',2.19),('16273','2013-07-29','16:35:00',2.21),('16273','2013-07-29','16:40:00',1.9),('16273','2013-07-29','16:45:00',1.79),('16273','2013-07-29','16:50:00',1.38),('16273','2013-07-29','16:55:00',1.02),('16273','2013-07-29','17:00:00',1.6),('16273','2013-07-29','17:05:00',1.62),('16273','2013-07-29','17:10:00',1.33),('16273','2013-07-29','17:15:00',1.81),('16273','2013-07-29','17:20:00',1.29),('16273','2013-07-29','17:40:00',1.46),('16273','2013-07-29','17:45:00',1.19),('16273','2013-07-28','07:40:00',1.07),('16273','2013-07-28','07:45:00',1.16),('16273','2013-07-28','07:50:00',1.23),('16273','2013-07-28','07:55:00',1.31),('16273','2013-07-28','08:00:00',1.4),('16273','2013-07-28','08:05:00',1.49),('16273','2013-07-28','08:10:00',1.57),('16273','2013-07-28','08:15:00',1.62),('16273','2013-07-28','08:20:00',1.74),('16273','2013-07-28','08:25:00',1.79),('16273','2013-07-28','08:30:00',1.86),('16273','2013-07-28','08:35:00',1.92),('16273','2013-07-28','08:40:00',1.99),('16273','2013-07-28','08:45:00',2.08),('16273','2013-07-28','08:50:00',2.16),('16273','2013-07-28','08:55:00',2.19),('16273','2013-07-28','09:00:00',2.23),('16273','2013-07-28','09:05:00',2.3),('16273','2013-07-28','09:10:00',2.35),('16273','2013-07-28','09:15:00',2.41),('16273','2013-07-28','09:20:00',2.46),('16273','2013-07-28','09:25:00',2.53),('16273','2013-07-28','09:30:00',2.58),('16273','2013-07-28','09:35:00',2.62),('16273','2013-07-28','09:40:00',2.67),('16273','2013-07-28','09:45:00',2.74),('16273','2013-07-28','09:50:00',2.8),('16273','2013-07-28','09:55:00',2.83),('16273','2013-07-28','10:00:00',2.84),('16273','2013-07-28','10:05:00',2.88),('16273','2013-07-28','10:10:00',2.93),('16273','2013-07-28','10:15:00',2.98),('16273','2013-07-28','10:20:00',3.03),('16273','2013-07-28','10:25:00',3.02),('16273','2013-07-28','10:30:00',3.06),('16273','2013-07-28','10:35:00',3.09),('16273','2013-07-28','10:40:00',3.16),('16273','2013-07-28','10:45:00',3.19),('16273','2013-07-28','10:50:00',3.22),('16273','2013-07-28','10:55:00',3.25),('16273','2013-07-28','11:00:00',3.27),('16273','2013-07-28','11:05:00',3.32),('16273','2013-07-28','11:10:00',3.35),('16273','2013-07-28','11:15:00',3.38),('16273','2013-07-28','11:20:00',3.42),('16273','2013-07-28','11:25:00',3.36),('16273','2013-07-28','11:30:00',3.43),('16273','2013-07-28','11:35:00',3.45),('16273','2013-07-28','11:40:00',3.47),('16273','2013-07-28','11:45:00',3.48),('16273','2013-07-28','11:50:00',3.51),('16273','2013-07-28','11:55:00',3.54),('16273','2013-07-28','12:00:00',3.57),('16273','2013-07-28','12:05:00',3.58),('16273','2013-07-28','12:10:00',3.6),('16273','2013-07-28','12:15:00',3.64),('16273','2013-07-28','12:20:00',3.61),('16273','2013-07-28','12:25:00',3.57),('16273','2013-07-28','12:30:00',3.61),('16273','2013-07-28','12:35:00',3.64),('16273','2013-07-28','12:40:00',3.64),('16273','2013-07-28','12:45:00',3.63),('16273','2013-07-28','12:50:00',3.61),('16273','2013-07-28','12:55:00',3.63),('16273','2013-07-28','13:00:00',3.61),('16273','2013-07-28','13:05:00',3.61),('16273','2013-07-28','13:10:00',3.61),('16273','2013-07-28','13:15:00',3.59),('16273','2013-07-28','13:20:00',3.58),('16273','2013-07-28','13:25:00',3.56),('16273','2013-07-28','13:30:00',3.53),('16273','2013-07-28','13:35:00',3.53),('16273','2013-07-28','13:40:00',3.51),('16273','2013-07-28','13:45:00',3.52),('16273','2013-07-28','13:50:00',3.51),('16273','2013-07-28','13:55:00',3.48),('16273','2013-07-28','14:00:00',3.46),('16273','2013-07-28','14:05:00',3.44),('16273','2013-07-28','14:10:00',3.4),('16273','2013-07-28','14:15:00',3.37),('16273','2013-07-28','14:20:00',3.33),('16273','2013-07-28','14:25:00',3.31),('16273','2013-07-28','14:30:00',3.23),('16273','2013-07-28','14:35:00',3.23),('16273','2013-07-28','14:40:00',3.22),('16273','2013-07-28','14:45:00',3.18),('16273','2013-07-28','14:50:00',3.13),('16273','2013-07-28','14:55:00',3.1),('16273','2013-07-28','15:00:00',3.02),('16273','2013-07-28','15:05:00',2.98),('16273','2013-07-28','15:10:00',2.95),('16273','2013-07-28','15:15:00',2.92),('16273','2013-07-28','15:20:00',2.88),('16273','2013-07-28','15:25:00',2.84),('16273','2013-07-28','15:30:00',2.82),('16273','2013-07-28','15:35:00',2.78),('16273','2013-07-28','15:40:00',2.74),('16273','2013-07-28','15:45:00',2.69),('16273','2013-07-28','15:50:00',2.63),('16273','2013-07-28','15:55:00',2.58),('16273','2013-07-28','16:00:00',2.52),('16273','2013-07-28','16:05:00',2.47),('16273','2013-07-28','16:10:00',2.41),('16273','2013-07-28','16:15:00',2.34),('16273','2013-07-28','16:20:00',2.29),('16273','2013-07-28','16:25:00',2.22),('16273','2013-07-28','16:30:00',2.17),('16273','2013-07-28','16:35:00',2.1),('16273','2013-07-28','16:40:00',2.04),('16273','2013-07-28','16:45:00',1.97),('16273','2013-07-28','16:50:00',1.9),('16273','2013-07-28','16:55:00',1.84),('16273','2013-07-28','17:00:00',1.77),('16273','2013-07-28','17:05:00',1.69),('16273','2013-07-28','17:10:00',1.62),('16273','2013-07-28','17:15:00',1.55),('16273','2013-07-28','17:20:00',1.47),('16273','2013-07-28','17:25:00',1.41),('16273','2013-07-28','17:30:00',1.33),('16273','2013-07-28','17:35:00',1.27),('16273','2013-07-28','17:40:00',1.2),('16273','2013-07-28','17:45:00',1.13),('16273','2013-07-28','17:50:00',1.06),('16273','2013-07-27','07:35:00',1.03),('16273','2013-07-27','07:40:00',1.12),('16273','2013-07-27','07:45:00',1.19),('16273','2013-07-27','07:50:00',1.27),('16273','2013-07-27','07:55:00',1.34),('16273','2013-07-27','08:00:00',1.42),('16273','2013-07-27','08:05:00',1.5),('16273','2013-07-27','08:10:00',1.57),('16273','2013-07-27','08:15:00',1.64),('16273','2013-07-27','08:20:00',1.72),('16273','2013-07-27','08:25:00',1.79),('16273','2013-07-27','08:30:00',1.87),('16273','2013-07-27','08:35:00',1.96),('16273','2013-07-27','08:40:00',2.06),('16273','2013-07-27','08:45:00',2.12),('16273','2013-07-27','08:50:00',2.19),('16273','2013-07-27','08:55:00',2.27),('16273','2013-07-27','09:00:00',2.31),('16273','2013-07-27','09:05:00',2.36),('16273','2013-07-27','09:10:00',2.41),('16273','2013-07-27','09:15:00',2.48),('16273','2013-07-27','09:20:00',2.51),('16273','2013-07-27','09:25:00',2.6),('16273','2013-07-27','09:30:00',2.67),('16273','2013-07-27','09:35:00',2.71),('16273','2013-07-27','09:40:00',2.77),('16273','2013-07-27','09:45:00',2.83),('16273','2013-07-27','09:50:00',2.86),('16273','2013-07-27','09:55:00',2.92),('16273','2013-07-27','10:00:00',2.98),('16273','2013-07-27','10:05:00',3.02),('16273','2013-07-27','10:10:00',3.04),('16273','2013-07-27','10:15:00',3.11),('16273','2013-07-27','10:20:00',3.15),('16273','2013-07-27','10:25:00',3.19),('16273','2013-07-27','10:30:00',3.23),('16273','2013-07-27','10:35:00',3.25),('16273','2013-07-27','10:40:00',3.27),('16273','2013-07-27','10:45:00',3.3),('16273','2013-07-27','10:50:00',3.32),('16273','2013-07-27','10:55:00',3.32),('16273','2013-07-27','11:00:00',3.34),('16273','2013-07-27','11:05:00',3.38),('16273','2013-07-27','11:10:00',3.43),('16273','2013-07-27','11:15:00',3.46),('16273','2013-07-27','11:20:00',3.48),('16273','2013-07-27','11:25:00',3.46),('16273','2013-07-27','11:30:00',3.46),('16273','2013-07-27','11:35:00',3.53),('16273','2013-07-27','11:40:00',3.54),('16273','2013-07-27','11:45:00',3.55),('16273','2013-07-27','11:50:00',3.56),('16273','2013-07-27','11:55:00',3.48),('16273','2013-07-27','12:00:00',3.54),('16273','2013-07-27','12:05:00',3.54),('16273','2013-07-27','12:10:00',3.56),('16273','2013-07-27','12:15:00',3.59),('16273','2013-07-27','12:20:00',3.61),('16273','2013-07-27','12:25:00',3.61),('16273','2013-07-27','12:30:00',3.63),('16273','2013-07-27','12:35:00',3.6),('16273','2013-07-27','12:40:00',3.57),('16273','2013-07-27','12:45:00',3.62),('16273','2013-07-27','12:50:00',3.58),('16273','2013-07-27','12:55:00',3.65),('16273','2013-07-27','13:00:00',3.67),('16273','2013-07-27','13:05:00',3.66),('16273','2013-07-27','13:10:00',3.65),('16273','2013-07-27','13:15:00',3.61),('16273','2013-07-27','13:20:00',3.6),('16273','2013-07-27','13:25:00',3.59),('16273','2013-07-27','13:30:00',3.59),('16273','2013-07-27','13:35:00',3.57),('16273','2013-07-27','13:40:00',3.58),('16273','2013-07-27','13:45:00',3.54),('16273','2013-07-27','13:50:00',3.51),('16273','2013-07-27','13:55:00',3.5),('16273','2013-07-27','14:00:00',3.48),('16273','2013-07-27','14:05:00',3.41),('16273','2013-07-27','14:10:00',3.42),('16273','2013-07-27','14:15:00',3.39),('16273','2013-07-27','14:20:00',3.39),('16273','2013-07-27','14:25:00',3.34),('16273','2013-07-27','14:30:00',3.31),('16273','2013-07-27','14:35:00',3.29),('16273','2013-07-27','14:40:00',3.24),('16273','2013-07-27','14:45:00',3.2),('16273','2013-07-27','14:50:00',3.16),('16273','2013-07-27','14:55:00',3.14),('16273','2013-07-27','15:00:00',3.11),('16273','2013-07-27','15:05:00',3.04),('16273','2013-07-27','15:10:00',3.01),('16273','2013-07-27','15:15:00',2.97),('16273','2013-07-27','15:20:00',2.95),('16273','2013-07-27','15:25:00',2.88),('16273','2013-07-27','15:30:00',2.83),('16273','2013-07-27','15:35:00',2.79),('16273','2013-07-27','15:40:00',2.74),('16273','2013-07-27','15:45:00',2.68),('16273','2013-07-27','15:50:00',2.64),('16273','2013-07-27','15:55:00',2.61),('16273','2013-07-27','16:00:00',2.54),('16273','2013-07-27','16:05:00',2.49),('16273','2013-07-27','16:10:00',2.41),('16273','2013-07-27','16:15:00',2.38),('16273','2013-07-27','16:20:00',2.33),('16273','2013-07-27','16:25:00',2.26),('16273','2013-07-27','16:30:00',2.19),('16273','2013-07-27','16:35:00',2.13),('16273','2013-07-27','16:40:00',2.06),('16273','2013-07-27','16:45:00',1.99),('16273','2013-07-27','16:50:00',1.92),('16273','2013-07-27','16:55:00',1.85),('16273','2013-07-27','17:00:00',1.78),('16273','2013-07-27','17:05:00',1.7),('16273','2013-07-27','17:10:00',1.63),('16273','2013-07-27','17:15:00',1.56),('16273','2013-07-27','17:20:00',1.48),('16273','2013-07-27','17:25:00',1.41),('16273','2013-07-27','17:30:00',1.35),('16273','2013-07-27','17:35:00',1.28),('16273','2013-07-27','17:40:00',1.2),('16273','2013-07-27','17:45:00',1.14),('16273','2013-07-27','17:50:00',1.08),('16273','2013-07-27','17:55:00',1.01),('16273','2013-07-26','07:50:00',1.06),('16273','2013-07-26','07:55:00',1.34),('16273','2013-07-26','08:00:00',1.32),('16273','2013-07-26','08:05:00',1.58),('16273','2013-07-26','08:10:00',1.48),('16273','2013-07-26','08:15:00',1.68),('16273','2013-07-26','08:20:00',1.65),('16273','2013-07-26','08:25:00',1.53),('16273','2013-07-26','08:30:00',1.86),('16273','2013-07-26','08:35:00',1.52),('16273','2013-07-26','08:40:00',1.42),('16273','2013-07-26','08:45:00',1.57),('16273','2013-07-26','08:50:00',1.13),('16273','2013-07-26','08:55:00',1.59),('16273','2013-07-26','09:00:00',2.3),('16273','2013-07-26','09:05:00',2.36),('16273','2013-07-26','09:10:00',2.43),('16273','2013-07-26','09:15:00',2.52),('16273','2013-07-26','09:20:00',2.57),('16273','2013-07-26','09:25:00',2.58),('16273','2013-07-26','09:30:00',2.69),('16273','2013-07-26','09:35:00',2.26),('16273','2013-07-26','09:40:00',2.68),('16273','2013-07-26','09:45:00',2.69),('16273','2013-07-26','09:50:00',2.87),('16273','2013-07-26','09:55:00',2.82),('16273','2013-07-26','10:00:00',2.84),('16273','2013-07-26','10:05:00',3.01),('16273','2013-07-26','10:10:00',3.07),('16273','2013-07-26','10:15:00',3.11),('16273','2013-07-26','10:20:00',3.17),('16273','2013-07-26','10:25:00',3.18),('16273','2013-07-26','10:30:00',3.18),('16273','2013-07-26','10:35:00',3.19),('16273','2013-07-26','10:40:00',3.32),('16273','2013-07-26','10:45:00',3.34),('16273','2013-07-26','10:50:00',3.36),('16273','2013-07-26','10:55:00',2.76),('16273','2013-07-26','11:00:00',3.53),('16273','2013-07-26','11:05:00',3.35),('16273','2013-07-26','11:10:00',3.53),('16273','2013-07-26','11:15:00',3.47),('16273','2013-07-26','11:20:00',3.49),('16273','2013-07-26','11:25:00',3.52),('16273','2013-07-26','11:30:00',3.53),('16273','2013-07-26','11:35:00',3.54),('16273','2013-07-26','11:40:00',3.49),('16273','2013-07-26','11:45:00',3.36),('16273','2013-07-26','11:50:00',3.76),('16273','2013-07-26','11:55:00',3.71),('16273','2013-07-26','12:00:00',2.7),('16273','2013-07-26','12:05:00',1.36),('16273','2013-07-26','12:10:00',3.27),('16273','2013-07-26','12:15:00',3.94),('16273','2013-07-26','12:20:00',3.8),('16273','2013-07-26','12:25:00',3.92),('16273','2013-07-26','12:30:00',3.01),('16273','2013-07-26','12:35:00',2.68),('16273','2013-07-26','12:40:00',3.98),('16273','2013-07-26','12:45:00',3.83),('16273','2013-07-26','12:50:00',3.51),('16273','2013-07-26','12:55:00',1.97),('16273','2013-07-26','13:00:00',3.06),('16273','2013-07-26','13:05:00',3.84),('16273','2013-07-26','13:10:00',3.78),('16273','2013-07-26','13:15:00',3.83),('16273','2013-07-26','13:20:00',3.64),('16273','2013-07-26','13:25:00',3.57),('16273','2013-07-26','13:30:00',3.64),('16273','2013-07-26','13:35:00',3.59),('16273','2013-07-26','13:40:00',3.55),('16273','2013-07-26','13:45:00',3.56),('16273','2013-07-26','13:50:00',3.56),('16273','2013-07-26','13:55:00',3.58),('16273','2013-07-26','14:00:00',3.53),('16273','2013-07-26','14:05:00',3.51),('16273','2013-07-26','14:10:00',3.53),('16273','2013-07-26','14:15:00',3.1),('16273','2013-07-26','14:20:00',3.42),('16273','2013-07-26','14:25:00',3.39),('16273','2013-07-26','14:30:00',3.35),('16273','2013-07-26','14:35:00',3.32),('16273','2013-07-26','14:40:00',3.28),('16273','2013-07-26','14:45:00',3.21),('16273','2013-07-26','14:50:00',3.19),('16273','2013-07-26','14:55:00',3.14),('16273','2013-07-26','15:00:00',3.11),('16273','2013-07-26','15:05:00',3.08),('16273','2013-07-26','15:10:00',3.02),('16273','2013-07-26','15:15:00',3.01),('16273','2013-07-26','15:20:00',2.97),('16273','2013-07-26','15:25:00',2.92),('16273','2013-07-26','15:30:00',2.87),('16273','2013-07-26','15:35:00',2.82),('16273','2013-07-26','15:40:00',2.74),('16273','2013-07-26','15:45:00',2.69),('16273','2013-07-26','15:50:00',2.67),('16273','2013-07-26','15:55:00',2.62),('16273','2013-07-26','16:00:00',2.56),('16273','2013-07-26','16:05:00',2.5),('16273','2013-07-26','16:10:00',2.45),('16273','2013-07-26','16:15:00',2.38),('16273','2013-07-26','16:20:00',2.31),('16273','2013-07-26','16:25:00',2.25),('16273','2013-07-26','16:30:00',2.16),('16273','2013-07-26','16:35:00',2.09),('16273','2013-07-26','16:40:00',2.02),('16273','2013-07-26','16:45:00',1.96),('16273','2013-07-26','16:50:00',1.9),('16273','2013-07-26','16:55:00',1.83),('16273','2013-07-26','17:00:00',1.77),('16273','2013-07-26','17:05:00',1.7),('16273','2013-07-26','17:10:00',1.64),('16273','2013-07-26','17:15:00',1.57),('16273','2013-07-26','17:20:00',1.5),('16273','2013-07-26','17:25:00',1.43),('16273','2013-07-26','17:30:00',1.35),('16273','2013-07-26','17:35:00',1.28),('16273','2013-07-26','17:40:00',1.21),('16273','2013-07-26','17:45:00',1.14),('16273','2013-07-26','17:50:00',1.06),('16273','2013-07-26','17:55:00',1.01),('16273','2013-07-25','07:35:00',1.03),('16273','2013-07-25','07:40:00',1.1),('16273','2013-07-25','07:45:00',1.18),('16273','2013-07-25','07:50:00',1.27),('16273','2013-07-25','07:55:00',1.34),('16273','2013-07-25','08:00:00',1.43),('16273','2013-07-25','08:05:00',1.49),('16273','2013-07-25','08:10:00',1.57),('16273','2013-07-25','08:15:00',1.61),('16273','2013-07-25','08:20:00',1.67),('16273','2013-07-25','08:25:00',1.71),('16273','2013-07-25','08:30:00',1.79),('16273','2013-07-25','08:35:00',1.9),('16273','2013-07-25','08:40:00',1.99),('16273','2013-07-25','08:45:00',2.05),('16273','2013-07-25','08:50:00',2.32),('16273','2013-07-25','08:55:00',2.47),('16273','2013-07-25','09:00:00',2.44),('16273','2013-07-25','09:20:00',2.67),('16273','2013-07-25','09:25:00',2.79),('16273','2013-07-25','09:30:00',1.86),('16273','2013-07-25','09:35:00',2.48),('16273','2013-07-25','09:40:00',2.22),('16273','2013-07-25','09:55:00',2.99),('16273','2013-07-25','10:00:00',3.22),('16273','2013-07-25','10:05:00',3.17),('16273','2013-07-25','10:10:00',3.23),('16273','2013-07-25','10:15:00',3.25),('16273','2013-07-25','10:20:00',3.21),('16273','2013-07-25','10:25:00',3.35),('16273','2013-07-25','10:30:00',3.35),('16273','2013-07-25','10:35:00',3.37),('16273','2013-07-25','10:40:00',3.38),('16273','2013-07-25','10:45:00',3.38),('16273','2013-07-25','10:50:00',3.32),('16273','2013-07-25','10:55:00',3.34),('16273','2013-07-25','11:00:00',3.55),('16273','2013-07-25','11:05:00',3.62),('16273','2013-07-25','11:10:00',2.75),('16273','2013-07-25','11:15:00',1.04),('16273','2013-07-25','11:20:00',3.61),('16273','2013-07-25','11:25:00',3.63),('16273','2013-07-25','11:30:00',3.7),('16273','2013-07-25','11:35:00',3.72),('16273','2013-07-25','11:40:00',3.74),('16273','2013-07-25','11:45:00',2.6),('16273','2013-07-25','11:55:00',2.89),('16273','2013-07-25','12:00:00',2.99),('16273','2013-07-25','12:05:00',3.53),('16273','2013-07-25','12:10:00',3.54),('16273','2013-07-25','12:15:00',3.2),('16273','2013-07-25','12:20:00',3.79),('16273','2013-07-25','12:25:00',3.74),('16273','2013-07-25','12:30:00',3.72),('16273','2013-07-25','12:35:00',3.73),('16273','2013-07-25','12:40:00',3.67),('16273','2013-07-25','12:45:00',3.64),('16273','2013-07-25','12:50:00',3.68),('16273','2013-07-25','12:55:00',3.73),('16273','2013-07-25','13:00:00',3.75),('16273','2013-07-25','13:05:00',3.79),('16273','2013-07-25','13:10:00',3.68),('16273','2013-07-25','13:15:00',3.74),('16273','2013-07-25','13:20:00',3.72),('16273','2013-07-25','13:25:00',3.73),('16273','2013-07-25','13:30:00',3.68),('16273','2013-07-25','13:35:00',3.68),('16273','2013-07-25','13:40:00',3.65),('16273','2013-07-25','13:45:00',3.64),('16273','2013-07-25','13:50:00',3.66),('16273','2013-07-25','13:55:00',3.62),('16273','2013-07-25','14:00:00',3.6),('16273','2013-07-25','14:05:00',3.59),('16273','2013-07-25','14:10:00',3.57),('16273','2013-07-25','14:15:00',3.52),('16273','2013-07-25','14:20:00',3.52),('16273','2013-07-25','14:25:00',3.49),('16273','2013-07-25','14:30:00',3.45),('16273','2013-07-25','14:35:00',3.4),('16273','2013-07-25','14:40:00',3.38),('16273','2013-07-25','14:45:00',3.35),('16273','2013-07-25','14:50:00',3.31),('16273','2013-07-25','14:55:00',3.27),('16273','2013-07-25','15:00:00',3.22),('16273','2013-07-25','15:05:00',3.22),('16273','2013-07-25','15:10:00',3.14),('16273','2013-07-25','15:15:00',3.1),('16273','2013-07-25','15:20:00',3.09),('16273','2013-07-25','15:25:00',3.01),('16273','2013-07-25','15:30:00',2.99),('16273','2013-07-25','15:35:00',2.92),('16273','2013-07-25','15:40:00',2.87),('16273','2013-07-25','15:45:00',2.82),('16273','2013-07-25','15:50:00',2.76),('16273','2013-07-25','15:55:00',2.71),('16273','2013-07-25','16:00:00',2.65),('16273','2013-07-25','16:05:00',2.58),('16273','2013-07-25','16:10:00',2.48),('16273','2013-07-25','16:15:00',2.46),('16273','2013-07-25','16:20:00',2.4),('16273','2013-07-25','16:25:00',2.33),('16273','2013-07-25','16:30:00',2.28),('16273','2013-07-25','16:35:00',2.19),('16273','2013-07-25','16:40:00',2.1),('16273','2013-07-25','16:45:00',2.07),('16273','2013-07-25','16:50:00',1.98),('16273','2013-07-25','16:55:00',1.93),('16273','2013-07-25','17:00:00',1.85),('16273','2013-07-25','17:05:00',1.79),('16273','2013-07-25','17:10:00',1.69),('16273','2013-07-25','17:15:00',1.62),('16273','2013-07-25','17:20:00',1.56),('16273','2013-07-25','17:25:00',1.47),('16273','2013-07-25','17:30:00',1.38),('16273','2013-07-25','17:35:00',1.32),('16273','2013-07-25','17:40:00',1.25),('16273','2013-07-25','17:45:00',1.18),('16273','2013-07-25','17:50:00',1.12),('16273','2013-07-25','17:55:00',1.03),('16273','2013-07-24','07:40:00',1.31),('16273','2013-07-24','07:45:00',1.13),('16273','2013-07-24','07:50:00',1.15),('16273','2013-07-24','07:55:00',1.62),('16273','2013-07-24','08:00:00',1.36),('16273','2013-07-24','08:05:00',1.14),('16273','2013-07-24','08:15:00',1),('16273','2013-07-24','08:20:00',1.04),('16273','2013-07-24','08:25:00',1.26),('16273','2013-07-24','08:30:00',1.22),('16273','2013-07-24','08:35:00',1.08),('16273','2013-07-24','08:40:00',1.04),('16273','2013-07-24','08:45:00',1.84),('16273','2013-07-24','08:50:00',2.43),('16273','2013-07-24','08:55:00',2.51),('16273','2013-07-24','09:00:00',1.94),('16273','2013-07-24','09:05:00',1.85),('16273','2013-07-24','09:10:00',1.39),('16273','2013-07-24','09:15:00',1.09),('16273','2013-07-24','09:30:00',2.09),('16273','2013-07-24','09:35:00',1.24),('16273','2013-07-24','09:40:00',1.12),('16273','2013-07-24','09:45:00',1.98),('16273','2013-07-24','09:50:00',1.97),('16273','2013-07-24','09:55:00',1.52),('16273','2013-07-24','10:15:00',1.89),('16273','2013-07-24','10:20:00',3.57),('16273','2013-07-24','10:25:00',3.29),('16273','2013-07-24','10:30:00',3.13),('16273','2013-07-24','10:35:00',1.96),('16273','2013-07-24','10:40:00',3.16),('16273','2013-07-24','10:45:00',3.59),('16273','2013-07-24','10:50:00',3.61),('16273','2013-07-24','10:55:00',3.47),('16273','2013-07-24','11:00:00',3.76),('16273','2013-07-24','11:05:00',3.54),('16273','2013-07-24','11:10:00',2.78),('16273','2013-07-24','11:15:00',1.14),('16273','2013-07-24','11:20:00',3.48),('16273','2013-07-24','11:25:00',3.91),('16273','2013-07-24','11:30:00',2.61),('16273','2013-07-24','11:35:00',3.79),('16273','2013-07-24','11:40:00',1.85),('16273','2013-07-24','11:45:00',3.81),('16273','2013-07-24','11:50:00',3.94),('16273','2013-07-24','11:55:00',3.88),('16273','2013-07-24','12:00:00',2.78),('16273','2013-07-24','12:05:00',1.53),('16273','2013-07-24','12:10:00',4.04),('16273','2013-07-24','12:15:00',3.77),('16273','2013-07-24','12:20:00',3.7),('16273','2013-07-24','12:25:00',3.9),('16273','2013-07-24','12:30:00',3.94),('16273','2013-07-24','12:35:00',3.87),('16273','2013-07-24','12:40:00',3.79),('16273','2013-07-24','12:45:00',3.78),('16273','2013-07-24','12:50:00',3.8),('16273','2013-07-24','12:55:00',3.53),('16273','2013-07-24','13:00:00',3.81),('16273','2013-07-24','13:05:00',3.72),('16273','2013-07-24','13:10:00',3.76),('16273','2013-07-24','13:15:00',3.68),('16273','2013-07-24','13:20:00',3.73),('16273','2013-07-24','13:25:00',3.67),('16273','2013-07-24','13:30:00',3.71),('16273','2013-07-24','13:35:00',3.69),('16273','2013-07-24','13:40:00',3.7),('16273','2013-07-24','13:45:00',3.67),('16273','2013-07-24','13:50:00',3.67),('16273','2013-07-24','13:55:00',3.63),('16273','2013-07-24','14:00:00',3.64),('16273','2013-07-24','14:05:00',3.6),('16273','2013-07-24','14:10:00',3.61),('16273','2013-07-24','14:15:00',3.55),('16273','2013-07-24','14:20:00',3.56),('16273','2013-07-24','14:25:00',3.57),('16273','2013-07-24','14:30:00',3.54),('16273','2013-07-24','14:35:00',3.46),('16273','2013-07-24','14:40:00',3.42),('16273','2013-07-24','14:45:00',3.43),('16273','2013-07-24','14:50:00',3.41),('16273','2013-07-24','14:55:00',3.36),('16273','2013-07-24','15:00:00',2.7),('16273','2013-07-24','15:05:00',3.29),('16273','2013-07-24','15:10:00',3.09),('16273','2013-07-24','15:15:00',3.11),('16273','2013-07-24','15:20:00',3.1),('16273','2013-07-24','15:25:00',2.71),('16273','2013-07-24','15:30:00',2.97),('16273','2013-07-24','15:35:00',3.03),('16273','2013-07-24','15:40:00',2.86),('16273','2013-07-24','15:45:00',2.9),('16273','2013-07-24','15:50:00',2.93),('16273','2013-07-24','15:55:00',2.86),('16273','2013-07-24','16:00:00',2.79),('16273','2013-07-24','16:05:00',2.71),('16273','2013-07-24','16:10:00',2.65),('16273','2013-07-24','16:15:00',2.57),('16273','2013-07-24','16:20:00',2.51),('16273','2013-07-24','16:25:00',2.45),('16273','2013-07-24','16:30:00',2.38),('16273','2013-07-24','16:35:00',2.28),('16273','2013-07-24','16:40:00',2.31),('16273','2013-07-24','16:45:00',2.31),('16273','2013-07-24','16:50:00',2.23),('16273','2013-07-24','16:55:00',2.14),('16273','2013-07-24','17:00:00',1.99),('16273','2013-07-24','17:05:00',1.89),('16273','2013-07-24','17:10:00',1.77),('16273','2013-07-24','17:15:00',1.72),('16273','2013-07-24','17:20:00',1.63),('16273','2013-07-24','17:25:00',1.55),('16273','2013-07-24','17:30:00',1.44),('16273','2013-07-24','17:35:00',1.35),('16273','2013-07-24','17:40:00',1.3),('16273','2013-07-24','17:45:00',1.22),('16273','2013-07-24','17:50:00',1.14),('16273','2013-07-24','17:55:00',1.06),('16273','2013-07-23','07:25:00',1.02),('16273','2013-07-23','07:30:00',1.11),('16273','2013-07-23','07:35:00',1.19),('16273','2013-07-23','07:40:00',1.26),('16273','2013-07-23','07:45:00',1.33),('16273','2013-07-23','07:50:00',1.41),('16273','2013-07-23','07:55:00',1.49),('16273','2013-07-23','08:00:00',1.57),('16273','2013-07-23','08:05:00',1.63),('16273','2013-07-23','08:10:00',1.72),('16273','2013-07-23','08:15:00',1.79),('16273','2013-07-23','08:20:00',1.86),('16273','2013-07-23','08:25:00',1.95),('16273','2013-07-23','08:30:00',2.05),('16273','2013-07-23','08:35:00',2.11),('16273','2013-07-23','08:40:00',2.16),('16273','2013-07-23','08:45:00',2.21),('16273','2013-07-23','08:50:00',2.23),('16273','2013-07-23','08:55:00',2.33),('16273','2013-07-23','09:00:00',2.4),('16273','2013-07-23','09:05:00',2.46),('16273','2013-07-23','09:10:00',2.53),('16273','2013-07-23','09:15:00',2.59),('16273','2013-07-23','09:20:00',2.65),('16273','2013-07-23','09:25:00',2.69),('16273','2013-07-23','09:30:00',2.74),('16273','2013-07-23','09:35:00',2.8),('16273','2013-07-23','09:40:00',2.83),('16273','2013-07-23','09:45:00',2.87),('16273','2013-07-23','09:50:00',2.92),('16273','2013-07-23','09:55:00',2.96),('16273','2013-07-23','10:00:00',3.01),('16273','2013-07-23','10:05:00',3.02),('16273','2013-07-23','10:10:00',3.06),('16273','2013-07-23','10:15:00',3.11),('16273','2013-07-23','10:20:00',3.12),('16273','2013-07-23','10:25:00',3.12),('16273','2013-07-23','10:30:00',3.16),('16273','2013-07-23','10:35:00',3.19),('16273','2013-07-23','10:40:00',3.25),('16273','2013-07-23','10:45:00',3.28),('16273','2013-07-23','10:50:00',3.29),('16273','2013-07-23','10:55:00',3.4),('16273','2013-07-23','11:00:00',3.45),('16273','2013-07-23','11:05:00',3.54),('16273','2013-07-23','11:10:00',3.62),('16273','2013-07-23','11:15:00',3.58),('16273','2013-07-23','11:20:00',2.61),('16273','2013-07-23','11:25:00',1.34),('16273','2013-07-23','11:30:00',1.01),('16273','2013-07-23','11:35:00',1.03),('16273','2013-07-23','11:40:00',3.05),('16273','2013-07-23','11:45:00',3.73),('16273','2013-07-23','11:50:00',3.82),('16273','2013-07-23','11:55:00',3.85),('16273','2013-07-23','12:00:00',2.49),('16273','2013-07-23','12:05:00',1.09),('16273','2013-07-23','12:10:00',2.01),('16273','2013-07-23','12:15:00',3.54),('16273','2013-07-23','12:20:00',3.51),('16273','2013-07-23','12:25:00',2.42),('16273','2013-07-23','12:30:00',3.93),('16273','2013-07-23','12:35:00',3.91),('16273','2013-07-23','12:40:00',3.32),('16273','2013-07-23','12:45:00',4),('16273','2013-07-23','12:50:00',3.96),('16273','2013-07-23','12:55:00',4),('16273','2013-07-23','13:00:00',3.88),('16273','2013-07-23','13:05:00',3.41),('16273','2013-07-23','13:10:00',3.32),('16273','2013-07-23','13:15:00',3.4),('16273','2013-07-23','13:20:00',3.8),('16273','2013-07-23','13:25:00',3.95),('16273','2013-07-23','13:30:00',3.93),('16273','2013-07-23','13:35:00',3.63),('16273','2013-07-23','13:40:00',3.83),('16273','2013-07-23','13:45:00',3.84),('16273','2013-07-23','13:50:00',3.82),('16273','2013-07-23','13:55:00',3.44),('16273','2013-07-23','14:00:00',2.58),('16273','2013-07-23','14:05:00',3.82),('16273','2013-07-23','14:10:00',3.7),('16273','2013-07-23','14:15:00',3.6),('16273','2013-07-23','14:20:00',3.46),('16273','2013-07-23','14:25:00',3.64),('16273','2013-07-23','14:30:00',3.63),('16273','2013-07-23','14:35:00',3.59),('16273','2013-07-23','14:40:00',3.53),('16273','2013-07-23','14:45:00',3.48),('16273','2013-07-23','14:50:00',3.38),('16273','2013-07-23','14:55:00',3.34),('16273','2013-07-23','15:00:00',3.29),('16273','2013-07-23','15:05:00',3.25),('16273','2013-07-23','15:10:00',3.2),('16273','2013-07-23','15:15:00',3.13),('16273','2013-07-23','15:20:00',3.02),('16273','2013-07-23','15:25:00',2.98),('16273','2013-07-23','15:30:00',2.93),('16273','2013-07-23','15:35:00',2.88),('16273','2013-07-23','15:40:00',2.85),('16273','2013-07-23','15:45:00',2.79),('16273','2013-07-23','15:50:00',2.73),('16273','2013-07-23','15:55:00',2.69),('16273','2013-07-23','16:00:00',2.63),('16273','2013-07-23','16:05:00',2.58),('16273','2013-07-23','16:10:00',2.51),('16273','2013-07-23','16:15:00',2.46),('16273','2013-07-23','16:20:00',2.4),('16273','2013-07-23','16:25:00',2.33),('16273','2013-07-23','16:30:00',2.28),('16273','2013-07-23','16:35:00',2.21),('16273','2013-07-23','16:40:00',2.13),('16273','2013-07-23','16:45:00',2.07),('16273','2013-07-23','16:50:00',1.99),('16273','2013-07-23','16:55:00',1.91),('16273','2013-07-23','17:00:00',1.85),('16273','2013-07-23','17:05:00',1.78),('16273','2013-07-23','17:10:00',1.69),('16273','2013-07-23','17:15:00',1.63),('16273','2013-07-23','17:20:00',1.56),('16273','2013-07-23','17:25:00',1.48),('16273','2013-07-23','17:30:00',1.42),('16273','2013-07-23','17:35:00',1.35),('16273','2013-07-23','17:40:00',1.28),('16273','2013-07-23','17:45:00',1.21),('16273','2013-07-23','17:50:00',1.14),('16273','2013-07-23','17:55:00',1.06),('16273','2013-07-22','07:30:00',1.04),('16273','2013-07-22','07:35:00',1.13),('16273','2013-07-22','07:40:00',1.21),('16273','2013-07-22','07:45:00',1.29),('16273','2013-07-22','07:50:00',1.37),('16273','2013-07-22','07:55:00',1.45),('16273','2013-07-22','08:00:00',1.54),('16273','2013-07-22','08:05:00',1.61),('16273','2013-07-22','08:10:00',1.7),('16273','2013-07-22','08:15:00',1.78),('16273','2013-07-22','08:20:00',1.87),('16273','2013-07-22','08:25:00',1.94),('16273','2013-07-22','08:30:00',2.01),('16273','2013-07-22','08:35:00',2.09),('16273','2013-07-22','08:40:00',2.16),('16273','2013-07-22','08:45:00',2.23),('16273','2013-07-22','08:50:00',2.29),('16273','2013-07-22','08:55:00',2.36),('16273','2013-07-22','09:00:00',2.43),('16273','2013-07-22','09:05:00',2.48),('16273','2013-07-22','09:10:00',2.54),('16273','2013-07-22','09:15:00',2.6),('16273','2013-07-22','09:20:00',2.66),('16273','2013-07-22','09:25:00',2.71),('16273','2013-07-22','09:30:00',2.77),('16273','2013-07-22','09:35:00',2.82),('16273','2013-07-22','09:40:00',2.87),('16273','2013-07-22','09:45:00',2.92),('16273','2013-07-22','09:50:00',2.96),('16273','2013-07-22','09:55:00',3.02),('16273','2013-07-22','10:00:00',3.04),('16273','2013-07-22','10:05:00',3.06),('16273','2013-07-22','10:10:00',3.13),('16273','2013-07-22','10:15:00',3.19),('16273','2013-07-22','10:20:00',3.24),('16273','2013-07-22','10:25:00',3.28),('16273','2013-07-22','10:30:00',3.31),('16273','2013-07-22','10:35:00',3.35),('16273','2013-07-22','10:40:00',3.37),('16273','2013-07-22','10:45:00',3.38),('16273','2013-07-22','10:50:00',3.43),('16273','2013-07-22','10:55:00',3.46),('16273','2013-07-22','11:00:00',3.48),('16273','2013-07-22','11:05:00',3.5),('16273','2013-07-22','11:10:00',3.53),('16273','2013-07-22','11:15:00',3.56),('16273','2013-07-22','11:20:00',3.58),('16273','2013-07-22','11:25:00',3.59),('16273','2013-07-22','11:30:00',3.61),('16273','2013-07-22','11:35:00',3.6),('16273','2013-07-22','11:40:00',3.64),('16273','2013-07-22','11:45:00',3.64),('16273','2013-07-22','11:50:00',3.65),('16273','2013-07-22','11:55:00',3.68),('16273','2013-07-22','12:00:00',3.67),('16273','2013-07-22','12:05:00',3.67),('16273','2013-07-22','12:10:00',3.69),('16273','2013-07-22','12:15:00',3.68),('16273','2013-07-22','12:20:00',3.67),('16273','2013-07-22','12:25:00',3.68),('16273','2013-07-22','12:30:00',3.7),('16273','2013-07-22','12:35:00',3.71),('16273','2013-07-22','12:40:00',3.69),('16273','2013-07-22','12:45:00',3.69),('16273','2013-07-22','12:50:00',3.67),('16273','2013-07-22','12:55:00',3.68),('16273','2013-07-22','13:00:00',3.65),('16273','2013-07-22','13:05:00',3.66),('16273','2013-07-22','13:10:00',3.67),('16273','2013-07-22','13:15:00',3.69),('16273','2013-07-22','13:20:00',3.67),('16273','2013-07-22','13:25:00',3.64),('16273','2013-07-22','13:30:00',3.61),('16273','2013-07-22','13:35:00',3.6),('16273','2013-07-22','13:40:00',3.61),('16273','2013-07-22','13:45:00',3.57),('16273','2013-07-22','13:50:00',3.5),('16273','2013-07-22','13:55:00',3.51),('16273','2013-07-22','14:00:00',3.49),('16273','2013-07-22','14:05:00',3.46),('16273','2013-07-22','14:10:00',3.44),('16273','2013-07-22','14:15:00',3.39),('16273','2013-07-22','14:20:00',3.37),('16273','2013-07-22','14:25:00',3.32),('16273','2013-07-22','14:30:00',3.25),('16273','2013-07-22','14:35:00',1.86),('16273','2013-07-22','14:40:00',3.31),('16273','2013-07-22','14:45:00',3.2),('16273','2013-07-22','14:50:00',3.21),('16273','2013-07-22','14:55:00',3.21),('16273','2013-07-22','15:00:00',3.22),('16273','2013-07-22','15:05:00',3.34),('16273','2013-07-22','15:10:00',3.31),('16273','2013-07-22','15:15:00',3.17),('16273','2013-07-22','15:20:00',2.64),('16273','2013-07-22','15:25:00',2.07),('16273','2013-07-22','15:40:00',2.08),('16273','2013-07-22','15:45:00',2.97),('16273','2013-07-22','15:50:00',1.48),('16273','2013-07-22','15:55:00',1.05),('16273','2013-07-22','16:00:00',2.28),('16273','2013-07-22','16:05:00',2.54),('16273','2013-07-22','16:10:00',2.55),('16273','2013-07-22','16:15:00',2.47),('16273','2013-07-22','16:20:00',2.34),('16273','2013-07-22','16:25:00',2.33),('16273','2013-07-22','16:30:00',2.22),('16273','2013-07-22','16:35:00',2.16),('16273','2013-07-22','16:40:00',2.1),('16273','2013-07-22','16:45:00',1.96),('16273','2013-07-22','16:50:00',1.91),('16273','2013-07-22','16:55:00',1.88),('16273','2013-07-22','17:00:00',1.8),('16273','2013-07-22','17:05:00',1.75),('16273','2013-07-22','17:10:00',1.65),('16273','2013-07-22','17:15:00',1.61),('16273','2013-07-22','17:20:00',1.51),('16273','2013-07-22','17:25:00',1.45),('16273','2013-07-22','17:30:00',1.4),('16273','2013-07-22','17:35:00',1.34),('16273','2013-07-22','17:40:00',1.25),('16273','2013-07-22','17:45:00',1.21),('16273','2013-07-22','17:50:00',1.15),('16273','2013-07-22','17:55:00',1.12),('16273','2013-07-22','18:00:00',1.03),('16273','2013-07-21','07:30:00',1.01),('16273','2013-07-21','07:35:00',1.1),('16273','2013-07-21','07:40:00',1.19),('16273','2013-07-21','07:45:00',1.27),('16273','2013-07-21','07:50:00',1.32),('16273','2013-07-21','07:55:00',1.37),('16273','2013-07-21','08:00:00',1.45),('16273','2013-07-21','08:05:00',1.52),('16273','2013-07-21','08:10:00',1.44),('16273','2013-07-21','08:15:00',1.69),('16273','2013-07-21','08:20:00',1.77),('16273','2013-07-21','08:25:00',1.85),('16273','2013-07-21','08:30:00',1.95),('16273','2013-07-21','08:35:00',2.03),('16273','2013-07-21','08:40:00',2.08),('16273','2013-07-21','08:45:00',2.13),('16273','2013-07-21','08:50:00',2.21),('16273','2013-07-21','08:55:00',2.28),('16273','2013-07-21','09:00:00',2.33),('16273','2013-07-21','09:05:00',2.4),('16273','2013-07-21','09:10:00',2.48),('16273','2013-07-21','09:15:00',2.54),('16273','2013-07-21','09:20:00',2.59),('16273','2013-07-21','09:25:00',2.66),('16273','2013-07-21','09:30:00',2.71),('16273','2013-07-21','09:35:00',2.73),('16273','2013-07-21','09:40:00',2.76),('16273','2013-07-21','09:45:00',2.82),('16273','2013-07-21','09:50:00',2.88),('16273','2013-07-21','09:55:00',2.95),('16273','2013-07-21','10:00:00',2.97),('16273','2013-07-21','10:05:00',3.05),('16273','2013-07-21','10:10:00',3.08),('16273','2013-07-21','10:15:00',3.13),('16273','2013-07-21','10:20:00',3.17),('16273','2013-07-21','10:25:00',3.19),('16273','2013-07-21','10:30:00',3.21),('16273','2013-07-21','10:35:00',3.26),('16273','2013-07-21','10:40:00',3.3),('16273','2013-07-21','10:45:00',3.35),('16273','2013-07-21','10:50:00',3.37),('16273','2013-07-21','10:55:00',3.39),('16273','2013-07-21','11:00:00',3.42),('16273','2013-07-21','11:05:00',3.4),('16273','2013-07-21','11:10:00',3.43),('16273','2013-07-21','11:15:00',3.49),('16273','2013-07-21','11:20:00',3.51),('16273','2013-07-21','11:25:00',3.53),('16273','2013-07-21','11:30:00',3.49),('16273','2013-07-21','11:35:00',3.51),('16273','2013-07-21','11:40:00',3.52),('16273','2013-07-21','11:45:00',3.53),('16273','2013-07-21','11:50:00',3.59),('16273','2013-07-21','11:55:00',3.64),('16273','2013-07-21','12:00:00',3.64),('16273','2013-07-21','12:05:00',3.64),('16273','2013-07-21','12:10:00',3.7),('16273','2013-07-21','12:15:00',3.83),('16273','2013-07-21','12:20:00',4),('16273','2013-07-21','12:25:00',3.06),('16273','2013-07-21','12:30:00',1.83),('16273','2013-07-21','12:35:00',1.82),('16273','2013-07-21','12:40:00',1.78),('16273','2013-07-21','12:45:00',1.73),('16273','2013-07-21','12:50:00',1.71),('16273','2013-07-21','12:55:00',1.81),('16273','2013-07-21','13:00:00',2.22),('16273','2013-07-21','13:05:00',4.64),('16273','2013-07-21','13:10:00',3.62),('16273','2013-07-21','13:15:00',2.25),('16273','2013-07-21','13:20:00',2.15),('16273','2013-07-21','13:25:00',1.81),('16273','2013-07-21','13:30:00',2.04),('16273','2013-07-21','13:35:00',3.63),('16273','2013-07-21','13:40:00',2.4),('16273','2013-07-21','13:45:00',2.33),('16273','2013-07-21','13:50:00',2.19),('16273','2013-07-21','13:55:00',3.61),('16273','2013-07-21','14:00:00',4.37),('16273','2013-07-21','14:05:00',2.87),('16273','2013-07-21','14:10:00',2.51),('16273','2013-07-21','14:15:00',1.66),('16273','2013-07-21','14:20:00',1.41),('16273','2013-07-21','14:25:00',1.33),('16273','2013-07-21','14:30:00',1.21),('16273','2013-07-21','14:35:00',1.07),('16273','2013-07-21','14:40:00',1.1),('16273','2013-07-21','14:45:00',1.27),('16273','2013-07-21','14:50:00',1.45),('16273','2013-07-21','14:55:00',1.86),('16273','2013-07-21','15:00:00',1.73),('16273','2013-07-21','15:05:00',1.31),('16273','2013-07-21','15:10:00',1.24),('16273','2013-07-21','15:15:00',1.25),('16273','2013-07-21','15:20:00',1.29),('16273','2013-07-21','15:25:00',1.16),('16273','2013-07-21','15:30:00',1.18),('16273','2013-07-21','15:35:00',1.25),('16273','2013-07-21','15:40:00',1.37),('16273','2013-07-21','15:45:00',1.57),('16273','2013-07-21','15:50:00',1.71),('16273','2013-07-21','15:55:00',1.67),('16273','2013-07-21','16:00:00',1.63),('16273','2013-07-21','16:05:00',1.56),('16273','2013-07-21','16:10:00',1.08),('16273','2013-07-21','16:35:00',1.06),('16273','2013-07-21','16:40:00',1.14),('16273','2013-07-21','16:45:00',1.15),('16273','2013-07-21','16:50:00',1.15),('16273','2013-07-21','16:55:00',1.05),('16273','2013-07-21','17:00:00',1.24),('16273','2013-07-21','17:05:00',1.84),('16273','2013-07-21','17:10:00',1.97),('16273','2013-07-21','17:15:00',1.29),('16273','2014-04-07','08:15:00',1.01),('16273','2014-04-07','08:20:00',1.51),('16273','2014-04-07','08:25:00',1.34),('16273','2014-04-07','08:30:00',1.5),('16273','2014-04-07','08:35:00',1.42),('16273','2014-04-07','08:40:00',1.11),('16273','2014-04-07','08:45:00',1.04),('16273','2014-04-07','09:30:00',1.01),('16273','2014-04-07','09:35:00',1.04),('16273','2014-04-07','09:40:00',1.07),('16273','2014-04-07','09:45:00',1.08),('16273','2014-04-07','09:50:00',1.08),('16273','2014-04-07','09:55:00',1.09),('16273','2014-04-07','10:00:00',1.12),('16273','2014-04-07','10:05:00',1.1),('16273','2014-04-07','10:10:00',1.1),('16273','2014-04-07','10:15:00',1.14),('16273','2014-04-07','10:20:00',1.16),('16273','2014-04-07','10:25:00',1.15),('16273','2014-04-07','10:30:00',1.14),('16273','2014-04-07','10:35:00',1.17),('16273','2014-04-07','10:40:00',1.23),('16273','2014-04-07','10:45:00',1.3),('16273','2014-04-07','10:50:00',1.34),('16273','2014-04-07','10:55:00',1.36),('16273','2014-04-07','11:00:00',1.38),('16273','2014-04-07','11:05:00',1.41),('16273','2014-04-07','11:10:00',1.43),('16273','2014-04-07','11:15:00',1.48),('16273','2014-04-07','11:20:00',1.5),('16273','2014-04-07','11:25:00',1.5),('16273','2014-04-07','11:30:00',1.56),('16273','2014-04-07','11:35:00',1.47),('16273','2014-04-07','11:40:00',1.42),('16273','2014-04-07','11:45:00',1.41),('16273','2014-04-07','11:50:00',1.43),('16273','2014-04-07','11:55:00',1.51),('16273','2014-04-07','12:00:00',1.81),('16273','2014-04-07','12:05:00',2.43),('16273','2014-04-07','12:10:00',3.43),('16273','2014-04-07','12:15:00',3.95),('16273','2014-04-07','12:20:00',3.46),('16273','2014-04-07','12:25:00',2.72),('16273','2014-04-07','12:30:00',1.63),('16273','2014-04-07','12:35:00',3.42),('16273','2014-04-07','12:40:00',3.87),('16273','2014-04-07','12:45:00',3.75),('16273','2014-04-07','12:50:00',3.65),('16273','2014-04-07','12:55:00',3.58),('16273','2014-04-07','13:00:00',3.55),('16273','2014-04-07','13:05:00',3.55),('16273','2014-04-07','13:10:00',3.51),('16273','2014-04-07','13:15:00',3.54),('16273','2014-04-07','13:20:00',3.52),('16273','2014-04-07','13:25:00',3.49),('16273','2014-04-07','13:30:00',3.46),('16273','2014-04-07','13:35:00',3.48),('16273','2014-04-07','13:40:00',3.47),('16273','2014-04-07','13:45:00',3.42),('16273','2014-04-07','13:50:00',3.38),('16273','2014-04-07','13:55:00',3.33),('16273','2014-04-07','14:00:00',3.3),('16273','2014-04-07','14:05:00',3.28),('16273','2014-04-07','14:10:00',3.3),('16273','2014-04-07','14:15:00',3.26),('16273','2014-04-07','14:20:00',3.21),('16273','2014-04-07','14:25:00',3.21),('16273','2014-04-07','14:30:00',3.17),('16273','2014-04-07','14:35:00',3.12),('16273','2014-04-07','14:40:00',3.06),('16273','2014-04-07','14:45:00',3.1),('16273','2014-04-07','14:50:00',3.07),('16273','2014-04-07','14:55:00',3.02),('16273','2014-04-07','15:00:00',2.99),('16273','2014-04-07','15:05:00',2.93),('16273','2014-04-07','15:10:00',2.88),('16273','2014-04-07','15:15:00',2.81),('16273','2014-04-07','15:20:00',2.72),('16273','2014-04-07','15:25:00',2.68),('16273','2014-04-07','15:30:00',2.66),('16273','2014-04-07','15:35:00',2.64),('16273','2014-04-07','15:40:00',2.57),('16273','2014-04-07','15:45:00',2.5),('16273','2014-04-07','15:50:00',2.44),('16273','2014-04-07','15:55:00',2.4),('16273','2014-04-07','16:00:00',2.36),('16273','2014-04-07','16:05:00',2.31),('16273','2014-04-07','16:10:00',2.23),('16273','2014-04-07','16:15:00',2.2),('16273','2014-04-07','16:20:00',1.24),('16273','2014-04-07','16:55:00',1.56),('16273','2014-04-07','17:00:00',1.55),('16273','2014-04-07','17:05:00',1.57),('16273','2014-04-07','17:10:00',1.6),('16273','2014-04-07','17:15:00',1.53),('16273','2014-04-07','17:20:00',1.55),('16273','2014-04-07','17:25:00',1.52),('16273','2014-04-07','17:30:00',1.39),('16273','2014-04-07','17:35:00',1.18),('16273','2014-04-07','17:40:00',1.33),('16273','2014-04-07','17:45:00',1.16),('16273','2013-07-20','07:25:00',1.01),('16273','2013-07-20','07:30:00',1.1),('16273','2013-07-20','07:35:00',1.19),('16273','2013-07-20','07:40:00',1.26),('16273','2013-07-20','07:45:00',1.32),('16273','2013-07-20','07:50:00',1.42),('16273','2013-07-20','07:55:00',1.51),('16273','2013-07-20','08:00:00',1.59),('16273','2013-07-20','08:05:00',1.68),('16273','2013-07-20','08:10:00',1.75),('16273','2013-07-20','08:15:00',1.82),('16273','2013-07-20','08:20:00',1.9),('16273','2013-07-20','08:25:00',1.98),('16273','2013-07-20','08:30:00',2.05),('16273','2013-07-20','08:35:00',2.14),('16273','2013-07-20','08:40:00',2.21),('16273','2013-07-20','08:45:00',2.23),('16273','2013-07-20','08:50:00',2.37),('16273','2013-07-20','08:55:00',2.38),('16273','2013-07-20','09:00:00',2.55),('16273','2013-07-20','09:05:00',2.65),('16273','2013-07-20','09:10:00',2.72),('16273','2013-07-20','09:15:00',2.69),('16273','2013-07-20','09:20:00',2.62),('16273','2013-07-20','09:25:00',2.43),('16273','2013-07-20','09:30:00',2.46),('16273','2013-07-20','09:35:00',2.8),('16273','2013-07-20','09:40:00',2.95),('16273','2013-07-20','09:45:00',2.84),('16273','2013-07-20','09:50:00',2.93),('16273','2013-07-20','09:55:00',2.97),('16273','2013-07-20','10:00:00',3.09),('16273','2013-07-20','10:05:00',3.1),('16273','2013-07-20','10:10:00',3.16),('16273','2013-07-20','10:15:00',3.21),('16273','2013-07-20','10:20:00',3.25),('16273','2013-07-20','10:25:00',3.29),('16273','2013-07-20','10:30:00',3.32),('16273','2013-07-20','10:35:00',3.35),('16273','2013-07-20','10:40:00',3.38),('16273','2013-07-20','10:45:00',3.42),('16273','2013-07-20','10:50:00',3.46),('16273','2013-07-20','10:55:00',3.46),('16273','2013-07-20','11:00:00',3.48),('16273','2013-07-20','11:05:00',3.5),('16273','2013-07-20','11:10:00',3.54),('16273','2013-07-20','11:15:00',3.56),('16273','2013-07-20','11:20:00',3.55),('16273','2013-07-20','11:25:00',3.5),('16273','2013-07-20','11:30:00',3.46),('16273','2013-07-20','11:35:00',3.63),('16273','2013-07-20','11:40:00',3.67),('16273','2013-07-20','11:45:00',3.68),('16273','2013-07-20','11:50:00',3.71),('16273','2013-07-20','11:55:00',3.7),('16273','2013-07-20','12:00:00',3.73),('16273','2013-07-20','12:05:00',3.73),('16273','2013-07-20','12:10:00',3.74),('16273','2013-07-20','12:15:00',3.76),('16273','2013-07-20','12:20:00',3.78),('16273','2013-07-20','12:25:00',3.77),('16273','2013-07-20','12:30:00',3.71),('16273','2013-07-20','12:35:00',3.74),('16273','2013-07-20','12:40:00',3.79),('16273','2013-07-20','12:45:00',3.8),('16273','2013-07-20','12:50:00',3.79),('16273','2013-07-20','12:55:00',3.78),('16273','2013-07-20','13:00:00',3.77),('16273','2013-07-20','13:05:00',3.81),('16273','2013-07-20','13:10:00',3.84),('16273','2013-07-20','13:15:00',3.8),('16273','2013-07-20','13:20:00',3.72),('16273','2013-07-20','13:25:00',3.73),('16273','2013-07-20','13:30:00',3.75),('16273','2013-07-20','13:35:00',3.74),('16273','2013-07-20','13:40:00',3.69),('16273','2013-07-20','13:45:00',3.67),('16273','2013-07-20','13:50:00',3.64),('16273','2013-07-20','13:55:00',3.6),('16273','2013-07-20','14:00:00',3.58),('16273','2013-07-20','14:05:00',3.56),('16273','2013-07-20','14:10:00',3.54),('16273','2013-07-20','14:15:00',3.52),('16273','2013-07-20','14:20:00',3.5),('16273','2013-07-20','14:25:00',3.47),('16273','2013-07-20','14:30:00',3.42),('16273','2013-07-20','14:35:00',3.41),('16273','2013-07-20','14:40:00',3.37),('16273','2013-07-20','14:45:00',3.32),('16273','2013-07-20','14:50:00',3.3),('16273','2013-07-20','14:55:00',3.26),('16273','2013-07-20','15:00:00',3.23),('16273','2013-07-20','15:05:00',3.2),('16273','2013-07-20','15:10:00',3.16),('16273','2013-07-20','15:15:00',3.11),('16273','2013-07-20','15:20:00',3.07),('16273','2013-07-20','15:25:00',3.02),('16273','2013-07-20','15:30:00',2.98),('16273','2013-07-20','15:35:00',2.89),('16273','2013-07-20','15:40:00',2.87),('16273','2013-07-20','15:45:00',2.82),('16273','2013-07-20','15:50:00',2.78),('16273','2013-07-20','15:55:00',2.71),('16273','2013-07-20','16:00:00',2.65),('16273','2013-07-20','16:05:00',2.58),('16273','2013-07-20','16:10:00',2.55),('16273','2013-07-20','16:15:00',2.5),('16273','2013-07-20','16:20:00',2.41),('16273','2013-07-20','16:25:00',2.35),('16273','2013-07-20','16:30:00',2.29),('16273','2013-07-20','16:35:00',2.22),('16273','2013-07-20','16:40:00',2.16),('16273','2013-07-20','16:45:00',2.09),('16273','2013-07-20','16:50:00',2.01),('16273','2013-07-20','16:55:00',1.94),('16273','2013-07-20','17:00:00',1.87),('16273','2013-07-20','17:05:00',1.79),('16273','2013-07-20','17:10:00',1.73),('16273','2013-07-20','17:15:00',1.65),('16273','2013-07-20','17:20:00',1.58),('16273','2013-07-20','17:25:00',1.51),('16273','2013-07-20','17:30:00',1.44),('16273','2013-07-20','17:35:00',1.37),('16273','2013-07-20','17:40:00',1.3),('16273','2013-07-20','17:45:00',1.23),('16273','2013-07-20','17:50:00',1.15),('16273','2013-07-20','17:55:00',1.1),('16273','2013-07-20','18:00:00',1.02),('16273','2013-07-19','07:30:00',1.02),('16273','2013-07-19','07:35:00',1.1),('16273','2013-07-19','07:40:00',1.17),('16273','2013-07-19','07:45:00',1.24),('16273','2013-07-19','07:50:00',1.31),('16273','2013-07-19','07:55:00',1.39),('16273','2013-07-19','08:00:00',1.47),('16273','2013-07-19','08:05:00',1.55),('16273','2013-07-19','08:10:00',1.62),('16273','2013-07-19','08:15:00',1.7),('16273','2013-07-19','08:20:00',1.78),('16273','2013-07-19','08:25:00',1.87),('16273','2013-07-19','08:30:00',1.94),('16273','2013-07-19','08:35:00',2.02),('16273','2013-07-19','08:40:00',2.09),('16273','2013-07-19','08:45:00',2.15),('16273','2013-07-19','08:50:00',2.21),('16273','2013-07-19','08:55:00',2.29),('16273','2013-07-19','09:00:00',2.32),('16273','2013-07-19','09:05:00',2.38),('16273','2013-07-19','09:10:00',2.49),('16273','2013-07-19','09:15:00',2.5),('16273','2013-07-19','09:20:00',2.54),('16273','2013-07-19','09:25:00',2.58),('16273','2013-07-19','09:30:00',2.64),('16273','2013-07-19','09:35:00',2.68),('16273','2013-07-19','09:40:00',2.71),('16273','2013-07-19','09:45:00',2.75),('16273','2013-07-19','09:50:00',2.8),('16273','2013-07-19','09:55:00',2.81),('16273','2013-07-19','10:00:00',2.9),('16273','2013-07-19','10:05:00',2.93),('16273','2013-07-19','10:10:00',2.99),('16273','2013-07-19','10:15:00',3.02),('16273','2013-07-19','10:20:00',3.09),('16273','2013-07-19','10:25:00',3.12),('16273','2013-07-19','10:30:00',3.19),('16273','2013-07-19','10:35:00',3.21),('16273','2013-07-19','10:40:00',3.22),('16273','2013-07-19','10:45:00',3.27),('16273','2013-07-19','10:50:00',3.29),('16273','2013-07-19','10:55:00',3.31),('16273','2013-07-19','11:00:00',3.33),('16273','2013-07-19','11:05:00',3.38),('16273','2013-07-19','11:10:00',3.44),('16273','2013-07-19','11:15:00',3.42),('16273','2013-07-19','11:20:00',3.34),('16273','2013-07-19','11:25:00',3.4),('16273','2013-07-19','11:30:00',3.38),('16273','2013-07-19','11:35:00',3.56),('16273','2013-07-19','11:40:00',3.62),('16273','2013-07-19','11:45:00',2.25),('16273','2013-07-19','11:50:00',3.1),('16273','2013-07-19','11:55:00',3.69),('16273','2013-07-19','12:00:00',3.76),('16273','2013-07-19','12:05:00',3.72),('16273','2013-07-19','12:10:00',3.74),('16273','2013-07-19','12:15:00',3.73),('16273','2013-07-19','12:20:00',3.76),('16273','2013-07-19','12:25:00',3.62),('16273','2013-07-19','12:30:00',3.73),('16273','2013-07-19','12:35:00',3.77),('16273','2013-07-19','12:40:00',3.75),('16273','2013-07-19','12:45:00',3.79),('16273','2013-07-19','12:50:00',3.71),('16273','2013-07-19','12:55:00',3.78),('16273','2013-07-19','13:00:00',3.77),('16273','2013-07-19','13:05:00',3.42),('16273','2013-07-19','13:10:00',3.81),('16273','2013-07-19','13:15:00',3.79),('16273','2013-07-19','13:20:00',3.8),('16273','2013-07-19','13:25:00',3.79),('16273','2013-07-19','13:30:00',3.75),('16273','2013-07-19','13:35:00',3.73),('16273','2013-07-19','13:40:00',3.73),('16273','2013-07-19','13:45:00',3.7),('16273','2013-07-19','13:50:00',3.7),('16273','2013-07-19','13:55:00',3.59),('16273','2013-07-19','14:00:00',3.65),('16273','2013-07-19','14:05:00',3.64),('16273','2013-07-19','14:10:00',3.61),('16273','2013-07-19','14:15:00',3.58),('16273','2013-07-19','14:20:00',3.56),('16273','2013-07-19','14:25:00',3.55),('16273','2013-07-19','14:30:00',3.51),('16273','2013-07-19','14:35:00',3.46),('16273','2013-07-19','14:40:00',3.35),('16273','2013-07-19','14:45:00',3.43),('16273','2013-07-19','14:50:00',2.59),('16273','2013-07-19','14:55:00',3.05),('16273','2013-07-19','15:00:00',3.44),('16273','2013-07-19','15:05:00',3.21),('16273','2013-07-19','15:10:00',3.24),('16273','2013-07-19','15:15:00',2.45),('16273','2013-07-19','15:20:00',1.95),('16273','2013-07-19','15:25:00',3.2),('16273','2013-07-19','15:30:00',3.2),('16273','2013-07-19','15:35:00',3.11),('16273','2013-07-19','15:40:00',3.02),('16273','2013-07-19','15:45:00',2.9),('16273','2013-07-19','15:50:00',2.82),('16273','2013-07-19','15:55:00',2.77),('16273','2013-07-19','16:00:00',2.68),('16273','2013-07-19','16:05:00',2.65),('16273','2013-07-19','16:10:00',2.61),('16273','2013-07-19','16:15:00',2.51),('16273','2013-07-19','16:20:00',2.46),('16273','2013-07-19','16:25:00',2.39),('16273','2013-07-19','16:30:00',2.34),('16273','2013-07-19','16:35:00',2.28),('16273','2013-07-19','16:40:00',2.03),('16273','2013-07-19','16:45:00',2.16),('16273','2013-07-19','16:50:00',2.15),('16273','2013-07-19','16:55:00',2.07),('16273','2013-07-19','17:00:00',2.01),('16273','2013-07-19','17:05:00',1.6),('16273','2013-07-19','17:10:00',1.15),('16273','2013-07-19','17:15:00',1.4),('16273','2013-07-19','17:20:00',1.3),('16273','2013-07-19','17:25:00',1.12),('16273','2013-07-19','17:30:00',1.39),('16273','2013-07-19','17:35:00',1.35),('16273','2013-07-19','17:40:00',1.13),('16273','2013-07-19','17:45:00',1.07),('16273','2013-07-18','07:25:00',1.04),('16273','2013-07-18','07:30:00',1.11),('16273','2013-07-18','07:35:00',1.2),('16273','2013-07-18','07:40:00',1.28),('16273','2013-07-18','07:45:00',1.35),('16273','2013-07-18','07:50:00',1.43),('16273','2013-07-18','07:55:00',1.5),('16273','2013-07-18','08:00:00',1.57),('16273','2013-07-18','08:05:00',1.65),('16273','2013-07-18','08:10:00',1.72),('16273','2013-07-18','08:15:00',1.8),('16273','2013-07-18','08:20:00',1.89),('16273','2013-07-18','08:25:00',1.97),('16273','2013-07-18','08:30:00',2.06),('16273','2013-07-18','08:35:00',2.13),('16273','2013-07-18','08:40:00',2.21),('16273','2013-07-18','08:45:00',2.27),('16273','2013-07-18','08:50:00',2.35),('16273','2013-07-18','08:55:00',2.42),('16273','2013-07-18','09:00:00',2.49),('16273','2013-07-18','09:05:00',2.54),('16273','2013-07-18','09:10:00',2.6),('16273','2013-07-18','09:15:00',2.66),('16273','2013-07-18','09:20:00',2.72),('16273','2013-07-18','09:25:00',2.78),('16273','2013-07-18','09:30:00',2.82),('16273','2013-07-18','09:35:00',2.87),('16273','2013-07-18','09:40:00',2.92),('16273','2013-07-18','09:45:00',2.97),('16273','2013-07-18','09:50:00',3.03),('16273','2013-07-18','09:55:00',3.07),('16273','2013-07-18','10:00:00',3.08),('16273','2013-07-18','10:05:00',3.15),('16273','2013-07-18','10:10:00',3.18),('16273','2013-07-18','10:15:00',3.22),('16273','2013-07-18','10:20:00',3.26),('16273','2013-07-18','10:25:00',3.29),('16273','2013-07-18','10:30:00',3.3),('16273','2013-07-18','10:35:00',3.28),('16273','2013-07-18','10:40:00',3.13),('16273','2013-07-18','10:45:00',3.32),('16273','2013-07-18','10:50:00',3.47),('16273','2013-07-18','10:55:00',3.49),('16273','2013-07-18','11:00:00',3.49),('16273','2013-07-18','11:05:00',3.52),('16273','2013-07-18','11:10:00',3.55),('16273','2013-07-18','11:15:00',3.59),('16273','2013-07-18','11:20:00',3.59),('16273','2013-07-18','11:25:00',3.6),('16273','2013-07-18','11:30:00',3.63),('16273','2013-07-18','11:35:00',3.65),('16273','2013-07-18','11:40:00',3.66),('16273','2013-07-18','11:45:00',3.6),('16273','2013-07-18','11:50:00',3.65),('16273','2013-07-18','11:55:00',3.67),('16273','2013-07-18','12:00:00',3.67),('16273','2013-07-18','12:05:00',3.68),('16273','2013-07-18','12:10:00',3.7),('16273','2013-07-18','12:15:00',3.73),('16273','2013-07-18','12:20:00',3.68),('16273','2013-07-18','12:25:00',3.7),('16273','2013-07-18','12:30:00',3.74),('16273','2013-07-18','12:35:00',3.74),('16273','2013-07-18','12:40:00',3.76),('16273','2013-07-18','12:45:00',3.8),('16273','2013-07-18','12:50:00',3.72),('16273','2013-07-18','12:55:00',3.71),('16273','2013-07-18','13:00:00',3.73),('16273','2013-07-18','13:05:00',3.72),('16273','2013-07-18','13:10:00',3.73),('16273','2013-07-18','13:15:00',3.72),('16273','2013-07-18','13:20:00',3.75),('16273','2013-07-18','13:25:00',3.71),('16273','2013-07-18','13:30:00',3.71),('16273','2013-07-18','13:35:00',3.68),('16273','2013-07-18','13:40:00',3.68),('16273','2013-07-18','13:45:00',3.67),('16273','2013-07-18','13:50:00',3.63),('16273','2013-07-18','13:55:00',3.61),('16273','2013-07-18','14:00:00',3.59),('16273','2013-07-18','14:05:00',3.56),('16273','2013-07-18','14:10:00',3.56),('16273','2013-07-18','14:15:00',3.55),('16273','2013-07-18','14:20:00',3.51),('16273','2013-07-18','14:25:00',3.5),('16273','2013-07-18','14:30:00',3.44),('16273','2013-07-18','14:35:00',3.4),('16273','2013-07-18','14:40:00',3.39),('16273','2013-07-18','14:45:00',3.33),('16273','2013-07-18','14:50:00',3.29),('16273','2013-07-18','14:55:00',3.29),('16273','2013-07-18','15:00:00',3.22),('16273','2013-07-18','15:05:00',3.15),('16273','2013-07-18','15:10:00',3.13),('16273','2013-07-18','15:15:00',3.1),('16273','2013-07-18','15:20:00',3.06),('16273','2013-07-18','15:25:00',2.99),('16273','2013-07-18','15:30:00',2.96),('16273','2013-07-18','15:35:00',2.9),('16273','2013-07-18','15:40:00',2.84),('16273','2013-07-18','15:45:00',2.79),('16273','2013-07-18','15:50:00',2.72),('16273','2013-07-18','15:55:00',2.69),('16273','2013-07-18','16:00:00',2.63),('16273','2013-07-18','16:05:00',2.56),('16273','2013-07-18','16:10:00',2.5),('16273','2013-07-18','16:15:00',2.42),('16273','2013-07-18','16:20:00',2.38),('16273','2013-07-18','16:25:00',2.31),('16273','2013-07-18','16:30:00',2.24),('16273','2013-07-18','16:35:00',2.16),('16273','2013-07-18','16:40:00',2.13),('16273','2013-07-18','16:45:00',2.04),('16273','2013-07-18','16:50:00',1.97),('16273','2013-07-18','16:55:00',1.89),('16273','2013-07-18','17:00:00',1.81),('16273','2013-07-18','17:05:00',1.74),('16273','2013-07-18','17:10:00',1.66),('16273','2013-07-18','17:15:00',1.49),('16273','2013-07-18','17:20:00',1.54),('16273','2013-07-18','17:25:00',1.25),('16273','2013-07-18','17:30:00',1.19),('16273','2013-07-18','17:35:00',1.33),('16273','2013-07-18','17:40:00',1.25),('16273','2013-07-18','17:45:00',1.21),('16273','2013-07-18','17:50:00',1.13),('16273','2013-07-18','17:55:00',1.05),('16273','2013-07-17','07:25:00',1.08),('16273','2013-07-17','07:30:00',1.16),('16273','2013-07-17','07:35:00',1.25),('16273','2013-07-17','07:40:00',1.33),('16273','2013-07-17','07:45:00',1.41),('16273','2013-07-17','07:50:00',1.5),('16273','2013-07-17','07:55:00',1.58),('16273','2013-07-17','08:00:00',1.64),('16273','2013-07-17','08:05:00',1.72),('16273','2013-07-17','08:10:00',1.79),('16273','2013-07-17','08:15:00',1.86),('16273','2013-07-17','08:20:00',1.97),('16273','2013-07-17','08:25:00',2.02),('16273','2013-07-17','08:30:00',2.08),('16273','2013-07-17','08:35:00',2.18),('16273','2013-07-17','08:40:00',2.27),('16273','2013-07-17','08:45:00',2.32),('16273','2013-07-17','08:50:00',2.39),('16273','2013-07-17','08:55:00',2.45),('16273','2013-07-17','09:00:00',2.52),('16273','2013-07-17','09:05:00',2.59),('16273','2013-07-17','09:10:00',2.66),('16273','2013-07-17','09:15:00',2.71),('16273','2013-07-17','09:20:00',2.77),('16273','2013-07-17','09:25:00',2.82),('16273','2013-07-17','09:30:00',2.88),('16273','2013-07-17','09:35:00',2.94),('16273','2013-07-17','09:40:00',2.98),('16273','2013-07-17','09:45:00',3.04),('16273','2013-07-17','09:50:00',3.09),('16273','2013-07-17','09:55:00',3.14),('16273','2013-07-17','10:00:00',3.18),('16273','2013-07-17','10:05:00',3.22),('16273','2013-07-17','10:10:00',3.26),('16273','2013-07-17','10:15:00',3.28),('16273','2013-07-17','10:20:00',3.34),('16273','2013-07-17','10:25:00',3.39),('16273','2013-07-17','10:30:00',3.41),('16273','2013-07-17','10:35:00',3.43),('16273','2013-07-17','10:40:00',3.47),('16273','2013-07-17','10:45:00',3.49),('16273','2013-07-17','10:50:00',3.54),('16273','2013-07-17','10:55:00',3.57),('16273','2013-07-17','11:00:00',3.61),('16273','2013-07-17','11:05:00',3.63),('16273','2013-07-17','11:10:00',3.68),('16273','2013-07-17','11:15:00',3.73),('16273','2013-07-17','11:20:00',3.72),('16273','2013-07-17','11:25:00',3.73),('16273','2013-07-17','11:30:00',3.79),('16273','2013-07-17','11:35:00',3.79),('16273','2013-07-17','11:40:00',3.8),('16273','2013-07-17','11:45:00',3.75),('16273','2013-07-17','11:50:00',3.78),('16273','2013-07-17','11:55:00',3.78),('16273','2013-07-17','12:00:00',3.83),('16273','2013-07-17','12:05:00',3.84),('16273','2013-07-17','12:10:00',3.84),('16273','2013-07-17','12:15:00',3.86),('16273','2013-07-17','12:20:00',3.88),('16273','2013-07-17','12:25:00',3.84),('16273','2013-07-17','12:30:00',3.84),('16273','2013-07-17','12:35:00',3.84),('16273','2013-07-17','12:40:00',3.83),('16273','2013-07-17','12:45:00',3.82),('16273','2013-07-17','12:50:00',3.81),('16273','2013-07-17','12:55:00',3.79),('16273','2013-07-17','13:00:00',3.77),('16273','2013-07-17','13:05:00',3.78),('16273','2013-07-17','13:10:00',3.8),('16273','2013-07-17','13:15:00',3.76),('16273','2013-07-17','13:20:00',3.75),('16273','2013-07-17','13:25:00',3.72),('16273','2013-07-17','13:30:00',3.7),('16273','2013-07-17','13:35:00',3.62),('16273','2013-07-17','13:40:00',3.66),('16273','2013-07-17','13:45:00',3.63),('16273','2013-07-17','13:50:00',3.62),('16273','2013-07-17','13:55:00',3.64),('16273','2013-07-17','14:00:00',3.6),('16273','2013-07-17','14:05:00',3.56),('16273','2013-07-17','14:10:00',3.54),('16273','2013-07-17','14:15:00',3.44),('16273','2013-07-17','14:20:00',3.47),('16273','2013-07-17','14:25:00',3.46),('16273','2013-07-17','14:30:00',3.42),('16273','2013-07-17','14:35:00',3.39),('16273','2013-07-17','14:40:00',3.34),('16273','2013-07-17','14:45:00',3.33),('16273','2013-07-17','14:50:00',3.27),('16273','2013-07-17','14:55:00',3.24),('16273','2013-07-17','15:00:00',3.22),('16273','2013-07-17','15:05:00',3.22),('16273','2013-07-17','15:10:00',3.14),('16273','2013-07-17','15:15:00',3.1),('16273','2013-07-17','15:20:00',3.04),('16273','2013-07-17','15:25:00',3.03),('16273','2013-07-17','15:30:00',2.99),('16273','2013-07-17','15:35:00',3.01),('16273','2013-07-17','15:40:00',3.08),('16273','2013-07-17','15:45:00',3.12),('16273','2013-07-17','15:50:00',2.93),('16273','2013-07-17','15:55:00',2.79),('16273','2013-07-17','16:00:00',2.75),('16273','2013-07-17','16:05:00',2.7),('16273','2013-07-17','16:10:00',2.68),('16273','2013-07-17','16:15:00',2.45),('16273','2013-07-17','16:20:00',2.5),('16273','2013-07-17','16:25:00',2.3),('16273','2013-07-17','16:30:00',2.28),('16273','2013-07-17','16:35:00',2.22),('16273','2013-07-17','16:40:00',2.14),('16273','2013-07-17','16:45:00',2.1),('16273','2013-07-17','16:50:00',2.01),('16273','2013-07-17','16:55:00',1.94),('16273','2013-07-17','17:00:00',1.86),('16273','2013-07-17','17:05:00',1.78),('16273','2013-07-17','17:10:00',1.72),('16273','2013-07-17','17:15:00',1.66),('16273','2013-07-17','17:20:00',1.58),('16273','2013-07-17','17:25:00',1.51),('16273','2013-07-17','17:30:00',1.44),('16273','2013-07-17','17:35:00',1.36),('16273','2013-07-17','17:40:00',1.3),('16273','2013-07-17','17:45:00',1.23),('16273','2013-07-17','17:50:00',1.15),('16273','2013-07-17','17:55:00',1.08),('16273','2013-07-17','18:00:00',1.01),('16273','2013-07-16','07:25:00',1.06),('16273','2013-07-16','07:30:00',1.13),('16273','2013-07-16','07:35:00',1.21),('16273','2013-07-16','07:40:00',1.29),('16273','2013-07-16','07:45:00',1.38),('16273','2013-07-16','07:50:00',1.46),('16273','2013-07-16','07:55:00',1.55),('16273','2013-07-16','08:00:00',1.62),('16273','2013-07-16','08:05:00',1.7),('16273','2013-07-16','08:10:00',1.75),('16273','2013-07-16','08:15:00',1.8),('16273','2013-07-16','08:20:00',1.89),('16273','2013-07-16','08:25:00',1.97),('16273','2013-07-16','08:30:00',2.03),('16273','2013-07-16','08:35:00',2.12),('16273','2013-07-16','08:40:00',2.19),('16273','2013-07-16','08:45:00',2.25),('16273','2013-07-16','08:50:00',2.32),('16273','2013-07-16','08:55:00',2.38),('16273','2013-07-16','09:00:00',2.42),('16273','2013-07-16','09:05:00',2.5),('16273','2013-07-16','09:10:00',2.56),('16273','2013-07-16','09:15:00',2.63),('16273','2013-07-16','09:20:00',2.7),('16273','2013-07-16','09:25:00',2.77),('16273','2013-07-16','09:30:00',2.81),('16273','2013-07-16','09:35:00',2.87),('16273','2013-07-16','09:40:00',2.94),('16273','2013-07-16','09:45:00',2.99),('16273','2013-07-16','09:50:00',3.05),('16273','2013-07-16','09:55:00',3.11),('16273','2013-07-16','10:00:00',3.16),('16273','2013-07-16','10:05:00',3.2),('16273','2013-07-16','10:10:00',3.22),('16273','2013-07-16','10:15:00',3.24),('16273','2013-07-16','10:20:00',3.29),('16273','2013-07-16','10:25:00',3.34),('16273','2013-07-16','10:30:00',3.37),('16273','2013-07-16','10:35:00',3.38),('16273','2013-07-16','10:40:00',3.41),('16273','2013-07-16','10:45:00',3.45),('16273','2013-07-16','10:50:00',3.49),('16273','2013-07-16','10:55:00',3.53),('16273','2013-07-16','11:00:00',3.57),('16273','2013-07-16','11:05:00',3.6),('16273','2013-07-16','11:10:00',3.61),('16273','2013-07-16','11:15:00',3.63),('16273','2013-07-16','11:20:00',3.65),('16273','2013-07-16','11:25:00',3.65),('16273','2013-07-16','11:30:00',3.65),('16273','2013-07-16','11:35:00',3.65),('16273','2013-07-16','11:40:00',3.67),('16273','2013-07-16','11:45:00',3.69),('16273','2013-07-16','11:50:00',3.69),('16273','2013-07-16','11:55:00',3.72),('16273','2013-07-16','12:00:00',3.7),('16273','2013-07-16','12:05:00',3.73),('16273','2013-07-16','12:10:00',3.74),('16273','2013-07-16','12:15:00',3.76),('16273','2013-07-16','12:20:00',3.8),('16273','2013-07-16','12:25:00',3.83),('16273','2013-07-16','12:30:00',3.85),('16273','2013-07-16','12:35:00',3.88),('16273','2013-07-16','12:40:00',3.87),('16273','2013-07-16','12:45:00',3.87),('16273','2013-07-16','12:50:00',3.86),('16273','2013-07-16','12:55:00',3.86),('16273','2013-07-16','13:00:00',3.83),('16273','2013-07-16','13:05:00',3.8),('16273','2013-07-16','13:10:00',3.8),('16273','2013-07-16','13:15:00',3.78),('16273','2013-07-16','13:20:00',3.7),('16273','2013-07-16','13:25:00',3.78),('16273','2013-07-16','13:30:00',3.74),('16273','2013-07-16','13:35:00',3.77),('16273','2013-07-16','13:40:00',3.7),('16273','2013-07-16','13:45:00',3.68),('16273','2013-07-16','13:50:00',3.64),('16273','2013-07-16','13:55:00',3.62),('16273','2013-07-16','14:00:00',3.61),('16273','2013-07-16','14:05:00',3.63),('16273','2013-07-16','14:10:00',3.55),('16273','2013-07-16','14:15:00',3.49),('16273','2013-07-16','14:20:00',2.93),('16273','2013-07-16','14:25:00',2.79),('16273','2013-07-16','14:30:00',3.49),('16273','2013-07-16','14:35:00',3.43),('16273','2013-07-16','14:40:00',3.44),('16273','2013-07-16','14:45:00',3.43),('16273','2013-07-16','14:50:00',2.52),('16273','2013-07-16','14:55:00',1.34),('16273','2013-07-16','15:00:00',3.06),('16273','2013-07-16','15:05:00',3.3),('16273','2013-07-16','15:10:00',3.23),('16273','2013-07-16','15:15:00',3.17),('16273','2013-07-16','15:20:00',2.54),('16273','2013-07-16','15:25:00',3.08),('16273','2013-07-16','15:30:00',2.98),('16273','2013-07-16','15:35:00',2.92),('16273','2013-07-16','15:40:00',2.85),('16273','2013-07-16','15:45:00',2.79),('16273','2013-07-16','15:50:00',2.69),('16273','2013-07-16','15:55:00',2.67),('16273','2013-07-16','16:00:00',2.65),('16273','2013-07-16','16:05:00',2.61),('16273','2013-07-16','16:10:00',2.58),('16273','2013-07-16','16:15:00',2.68),('16273','2013-07-16','16:20:00',2.62),('16273','2013-07-16','16:25:00',2.45),('16273','2013-07-16','16:30:00',2.35),('16273','2013-07-16','16:35:00',2.31),('16273','2013-07-16','16:40:00',2.26),('16273','2013-07-16','16:45:00',2.15),('16273','2013-07-16','16:50:00',2.09),('16273','2013-07-16','16:55:00',2.02),('16273','2013-07-16','17:00:00',1.97),('16273','2013-07-16','17:05:00',1.82),('16273','2013-07-16','17:10:00',1.75),('16273','2013-07-16','17:15:00',1.68),('16273','2013-07-16','17:20:00',1.61),('16273','2013-07-16','17:25:00',1.55),('16273','2013-07-16','17:30:00',1.42),('16273','2013-07-16','17:35:00',1.36),('16273','2013-07-16','17:40:00',1.3),('16273','2013-07-16','17:45:00',1.27),('16273','2013-07-16','17:50:00',1.28),('16273','2013-07-16','17:55:00',1.14),('16273','2013-07-15','07:20:00',1.04),('16273','2013-07-15','07:25:00',1.12),('16273','2013-07-15','07:30:00',1.2),('16273','2013-07-15','07:35:00',1.29),('16273','2013-07-15','07:40:00',1.37),('16273','2013-07-15','07:45:00',1.44),('16273','2013-07-15','07:50:00',1.53),('16273','2013-07-15','07:55:00',1.61),('16273','2013-07-15','08:00:00',1.68),('16273','2013-07-15','08:05:00',1.76),('16273','2013-07-15','08:10:00',1.85),('16273','2013-07-15','08:15:00',1.93),('16273','2013-07-15','08:20:00',2.01),('16273','2013-07-15','08:25:00',2.09),('16273','2013-07-15','08:30:00',2.15),('16273','2013-07-15','08:35:00',2.24),('16273','2013-07-15','08:40:00',2.33),('16273','2013-07-15','08:45:00',2.41),('16273','2013-07-15','08:50:00',2.46),('16273','2013-07-15','08:55:00',2.53),('16273','2013-07-15','09:00:00',2.61),('16273','2013-07-15','09:05:00',2.66),('16273','2013-07-15','09:10:00',2.71),('16273','2013-07-15','09:15:00',2.76),('16273','2013-07-15','09:20:00',2.81),('16273','2013-07-15','09:25:00',2.86),('16273','2013-07-15','09:30:00',2.93),('16273','2013-07-15','09:35:00',2.99),('16273','2013-07-15','09:40:00',3.03),('16273','2013-07-15','09:45:00',3.08),('16273','2013-07-15','09:50:00',3.14),('16273','2013-07-15','09:55:00',3.19),('16273','2013-07-15','10:00:00',3.23),('16273','2013-07-15','10:05:00',3.27),('16273','2013-07-15','10:10:00',3.29),('16273','2013-07-15','10:15:00',3.33),('16273','2013-07-15','10:20:00',3.35),('16273','2013-07-15','10:25:00',3.38),('16273','2013-07-15','10:30:00',3.38),('16273','2013-07-15','10:35:00',3.41),('16273','2013-07-15','10:40:00',3.45),('16273','2013-07-15','10:45:00',3.48),('16273','2013-07-15','10:50:00',3.49),('16273','2013-07-15','10:55:00',3.53),('16273','2013-07-15','11:00:00',3.57),('16273','2013-07-15','11:05:00',3.61),('16273','2013-07-15','11:10:00',3.64),('16273','2013-07-15','11:15:00',3.68),('16273','2013-07-15','11:20:00',3.69),('16273','2013-07-15','11:25:00',3.7),('16273','2013-07-15','11:30:00',3.72),('16273','2013-07-15','11:35:00',3.74),('16273','2013-07-15','11:40:00',3.74),('16273','2013-07-15','11:45:00',3.75),('16273','2013-07-15','11:50:00',3.76),('16273','2013-07-15','11:55:00',3.77),('16273','2013-07-15','12:00:00',3.77),('16273','2013-07-15','12:05:00',3.8),('16273','2013-07-15','12:10:00',3.77),('16273','2013-07-15','12:15:00',3.76),('16273','2013-07-15','12:20:00',3.74),('16273','2013-07-15','12:25:00',3.77),('16273','2013-07-15','12:30:00',3.76),('16273','2013-07-15','12:35:00',3.78),('16273','2013-07-15','12:40:00',3.76),('16273','2013-07-15','12:45:00',3.74),('16273','2013-07-15','12:50:00',3.75),('16273','2013-07-15','12:55:00',3.73),('16273','2013-07-15','13:00:00',3.72),('16273','2013-07-15','13:05:00',3.74),('16273','2013-07-15','13:10:00',3.74),('16273','2013-07-15','13:15:00',3.73),('16273','2013-07-15','13:20:00',3.7),('16273','2013-07-15','13:25:00',3.71),('16273','2013-07-15','13:30:00',3.78),('16273','2013-07-15','13:35:00',3.76),('16273','2013-07-15','13:40:00',3.72),('16273','2013-07-15','13:45:00',3.73),('16273','2013-07-15','13:50:00',3.74),('16273','2013-07-15','13:55:00',3.73),('16273','2013-07-15','14:00:00',3.81),('16273','2013-07-15','14:05:00',3.79),('16273','2013-07-15','14:10:00',3.83),('16273','2013-07-15','14:15:00',3.69),('16273','2013-07-15','14:20:00',3.65),('16273','2013-07-15','14:25:00',3.62),('16273','2013-07-15','14:30:00',3.48),('16273','2013-07-15','14:35:00',3.62),('16273','2013-07-15','14:40:00',3.42),('16273','2013-07-15','14:45:00',2.92),('16273','2013-07-15','14:50:00',3.3),('16273','2013-07-15','14:55:00',2.06),('16273','2013-07-15','15:00:00',3.37),('16273','2013-07-15','15:05:00',3.42),('16273','2013-07-15','15:10:00',3.16),('16273','2013-07-15','15:15:00',1.78),('16273','2013-07-15','15:20:00',1.05),('16273','2013-07-15','15:25:00',1.53),('16273','2013-07-15','15:30:00',3.16),('16273','2013-07-15','15:35:00',3.08),('16273','2013-07-15','15:40:00',2.83),('16273','2013-07-15','15:45:00',2.86),('16273','2013-07-15','15:50:00',2.78),('16273','2013-07-15','15:55:00',2.73),('16273','2013-07-15','16:00:00',2.68),('16273','2013-07-15','16:05:00',2.62),('16273','2013-07-15','16:10:00',2.53),('16273','2013-07-15','16:15:00',2.45),('16273','2013-07-15','16:20:00',2.4),('16273','2013-07-15','16:25:00',2.37),('16273','2013-07-15','16:30:00',2.32),('16273','2013-07-15','16:35:00',2.24),('16273','2013-07-15','16:40:00',2.18),('16273','2013-07-15','16:45:00',2.11),('16273','2013-07-15','16:50:00',2.04),('16273','2013-07-15','16:55:00',1.97),('16273','2013-07-15','17:00:00',1.89),('16273','2013-07-15','17:05:00',1.81),('16273','2013-07-15','17:10:00',1.74),('16273','2013-07-15','17:15:00',1.67),('16273','2013-07-15','17:20:00',1.6),('16273','2013-07-15','17:25:00',1.53),('16273','2013-07-15','17:30:00',1.45),('16273','2013-07-15','17:35:00',1.38),('16273','2013-07-15','17:40:00',1.3),('16273','2013-07-15','17:45:00',1.24),('16273','2013-07-15','17:50:00',1.17),('16273','2013-07-15','17:55:00',1.11),('16273','2013-07-15','18:00:00',1.05),('16273','2013-07-14','07:50:00',1.05),('16273','2013-07-14','07:55:00',1.23),('16273','2013-07-14','08:00:00',1.66),('16273','2013-07-14','08:05:00',1.13),('16273','2013-07-14','08:10:00',1.21),('16273','2013-07-14','08:15:00',1.34),('16273','2013-07-14','08:20:00',2.02),('16273','2013-07-14','08:25:00',1.47),('16273','2013-07-14','08:30:00',1.73),('16273','2013-07-14','08:35:00',1),('16273','2013-07-14','08:45:00',1.02),('16273','2013-07-14','08:50:00',1.37),('16273','2013-07-14','08:55:00',1.23),('16273','2013-07-14','09:00:00',1.24),('16273','2013-07-14','09:05:00',1.28),('16273','2013-07-14','09:10:00',1.17),('16273','2013-07-14','09:20:00',1.2),('16273','2013-07-14','09:25:00',1.94),('16273','2013-07-14','09:30:00',2.22),('16273','2013-07-14','09:35:00',1.68),('16273','2013-07-14','09:40:00',1.57),('16273','2013-07-14','09:45:00',1.53),('16273','2013-07-14','09:50:00',1.47),('16273','2013-07-14','09:55:00',1.46),('16273','2013-07-14','10:00:00',1.49),('16273','2013-07-14','10:05:00',1.68),('16273','2013-07-14','10:10:00',1.63),('16273','2013-07-14','10:15:00',2.05),('16273','2013-07-14','10:20:00',2.19),('16273','2013-07-14','10:25:00',2.5),('16273','2013-07-14','10:30:00',2.07),('16273','2013-07-14','10:35:00',2.11),('16273','2013-07-14','10:40:00',2.95),('16273','2013-07-14','10:45:00',3.03),('16273','2013-07-14','10:50:00',3.32),('16273','2013-07-14','10:55:00',3.93),('16273','2013-07-14','11:00:00',3.46),('16273','2013-07-14','11:05:00',1.97),('16273','2013-07-14','11:10:00',4.29),('16273','2013-07-14','11:15:00',3.69),('16273','2013-07-14','11:20:00',3.66),('16273','2013-07-14','11:25:00',3.73),('16273','2013-07-14','11:30:00',3.38),('16273','2013-07-14','11:35:00',3.24),('16273','2013-07-14','11:40:00',3.2),('16273','2013-07-14','11:45:00',1.76),('16273','2013-07-14','11:50:00',3.76),('16273','2013-07-14','11:55:00',3.79),('16273','2013-07-14','12:00:00',4.03),('16273','2013-07-14','12:05:00',4),('16273','2013-07-14','12:10:00',3.52),('16273','2013-07-14','12:15:00',2.28),('16273','2013-07-14','12:20:00',3.2),('16273','2013-07-14','12:25:00',1.35),('16273','2013-07-14','12:30:00',3.23),('16273','2013-07-14','12:35:00',3.92),('16273','2013-07-14','12:40:00',3.55),('16273','2013-07-14','12:45:00',3.63),('16273','2013-07-14','12:50:00',4.11),('16273','2013-07-14','12:55:00',3.94),('16273','2013-07-14','13:00:00',3.89),('16273','2013-07-14','13:05:00',3.83),('16273','2013-07-14','13:10:00',3.81),('16273','2013-07-14','13:15:00',3.8),('16273','2013-07-14','13:20:00',3.82),('16273','2013-07-14','13:25:00',3.83),('16273','2013-07-14','13:30:00',3.84),('16273','2013-07-14','13:35:00',3.83),('16273','2013-07-14','13:40:00',3.8),('16273','2013-07-14','13:45:00',3.74),('16273','2013-07-14','13:50:00',3.8),('16273','2013-07-14','13:55:00',3.81),('16273','2013-07-14','14:00:00',3.8),('16273','2013-07-14','14:05:00',3.78),('16273','2013-07-14','14:10:00',3.76),('16273','2013-07-14','14:15:00',3.73),('16273','2013-07-14','14:20:00',3.71),('16273','2013-07-14','14:25:00',3.67),('16273','2013-07-14','14:30:00',3.62),('16273','2013-07-14','14:35:00',3.57),('16273','2013-07-14','14:40:00',3.51),('16273','2013-07-14','14:45:00',3.49),('16273','2013-07-14','14:50:00',3.44),('16273','2013-07-14','14:55:00',3.39),('16273','2013-07-14','15:00:00',3.3),('16273','2013-07-14','15:05:00',3.32),('16273','2013-07-14','15:10:00',3.28),('16273','2013-07-14','15:15:00',3.23),('16273','2013-07-14','15:20:00',3.16),('16273','2013-07-14','15:25:00',3.09),('16273','2013-07-14','15:30:00',3.05),('16273','2013-07-14','15:35:00',3.01),('16273','2013-07-14','15:40:00',2.98),('16273','2013-07-14','15:45:00',2.92),('16273','2013-07-14','15:50:00',2.86),('16273','2013-07-14','15:55:00',2.65),('16273','2013-07-14','16:00:00',2.53),('16273','2013-07-14','16:05:00',2.29),('16273','2013-07-14','16:10:00',1.45),('16273','2013-07-14','16:15:00',1.84),('16273','2013-07-14','16:20:00',1.95),('16273','2013-07-14','16:25:00',1.49),('16273','2013-07-14','16:30:00',1.82),('16273','2013-07-14','16:35:00',2.06),('16273','2013-07-14','16:40:00',2.34),('16273','2013-07-14','16:45:00',2.28),('16273','2013-07-14','16:50:00',2.31),('16273','2013-07-14','16:55:00',1.44),('16273','2013-07-14','17:00:00',1.17),('16273','2013-07-14','17:05:00',1.7),('16273','2013-07-14','17:15:00',1.09),('16273','2013-07-14','17:20:00',1.78),('16273','2013-07-14','17:25:00',1.75),('16273','2013-07-14','17:30:00',1.6),('16273','2013-07-14','17:35:00',1.66),('16273','2013-07-14','17:40:00',1.12),('16273','2013-07-14','17:45:00',1.03),('16273','2013-07-13','07:45:00',1.17),('16273','2013-07-13','07:50:00',1.45),('16273','2013-07-13','07:55:00',1.49),('16273','2013-07-13','08:00:00',1.57),('16273','2013-07-13','08:05:00',1.65),('16273','2013-07-13','08:10:00',1.72),('16273','2013-07-13','08:15:00',1.79),('16273','2013-07-13','08:20:00',1.87),('16273','2013-07-13','08:25:00',1.95),('16273','2013-07-13','08:30:00',2.03),('16273','2013-07-13','08:35:00',2.12),('16273','2013-07-13','08:40:00',2.21),('16273','2013-07-13','08:45:00',2.26),('16273','2013-07-13','08:50:00',2.36),('16273','2013-07-13','08:55:00',2.43),('16273','2013-07-13','09:00:00',2.49),('16273','2013-07-13','09:05:00',2.55),('16273','2013-07-13','09:10:00',2.63),('16273','2013-07-13','09:15:00',2.67),('16273','2013-07-13','09:20:00',2.7),('16273','2013-07-13','09:25:00',2.77),('16273','2013-07-13','09:30:00',2.8),('16273','2013-07-13','09:35:00',2.9),('16273','2013-07-13','09:40:00',2.96),('16273','2013-07-13','09:45:00',3.01),('16273','2013-07-13','09:50:00',3.05),('16273','2013-07-13','09:55:00',3.06),('16273','2013-07-13','10:00:00',3.05),('16273','2013-07-13','10:05:00',3.15),('16273','2013-07-13','10:10:00',3.24),('16273','2013-07-13','10:15:00',2.89),('16273','2013-07-13','10:20:00',2.7),('16273','2013-07-13','10:25:00',3.52),('16273','2013-07-13','10:30:00',3.43),('16273','2013-07-13','10:35:00',2.9),('16273','2013-07-13','10:40:00',2.42),('16273','2013-07-13','10:45:00',3.23),('16273','2013-07-13','10:50:00',2.76),('16273','2013-07-13','10:55:00',1.56),('16273','2013-07-13','11:00:00',3.73),('16273','2013-07-13','11:05:00',2.14),('16273','2013-07-13','11:10:00',3.77),('16273','2013-07-13','11:15:00',3.82),('16273','2013-07-13','11:20:00',3.34),('16273','2013-07-13','11:25:00',3.82),('16273','2013-07-13','11:30:00',3.71),('16273','2013-07-13','11:35:00',3.85),('16273','2013-07-13','11:40:00',3.79),('16273','2013-07-13','11:45:00',3.79),('16273','2013-07-13','11:50:00',3.92),('16273','2013-07-13','11:55:00',3.76),('16273','2013-07-13','12:00:00',2.64),('16273','2013-07-13','12:05:00',3.57),('16273','2013-07-13','12:10:00',3.66),('16273','2013-07-13','12:15:00',3.95),('16273','2013-07-13','12:20:00',3.91),('16273','2013-07-13','12:25:00',3.97),('16273','2013-07-13','12:30:00',3.99),('16273','2013-07-13','12:35:00',3.49),('16273','2013-07-13','12:40:00',3.22),('16273','2013-07-13','12:45:00',4.1),('16273','2013-07-13','12:50:00',4.03),('16273','2013-07-13','12:55:00',3.64),('16273','2013-07-13','13:00:00',3.89),('16273','2013-07-13','13:05:00',3.89),('16273','2013-07-13','13:10:00',3.88),('16273','2013-07-13','13:15:00',3.86),('16273','2013-07-13','13:20:00',3.87),('16273','2013-07-13','13:25:00',3.85),('16273','2013-07-13','13:30:00',3.83),('16273','2013-07-13','13:35:00',3.83),('16273','2013-07-13','13:40:00',3.83),('16273','2013-07-13','13:45:00',3.78),('16273','2013-07-13','13:50:00',3.75),('16273','2013-07-13','13:55:00',3.77),('16273','2013-07-13','14:00:00',3.72),('16273','2013-07-13','14:05:00',3.74),('16273','2013-07-13','14:10:00',3.72),('16273','2013-07-13','14:15:00',3.68),('16273','2013-07-13','14:20:00',3.64),('16273','2013-07-13','14:25:00',3.62),('16273','2013-07-13','14:30:00',3.56),('16273','2013-07-13','14:35:00',3.57),('16273','2013-07-13','14:40:00',3.56),('16273','2013-07-13','14:45:00',3.48),('16273','2013-07-13','14:50:00',3.49),('16273','2013-07-13','14:55:00',3.45),('16273','2013-07-13','15:00:00',3.34),('16273','2013-07-13','15:05:00',3.37),('16273','2013-07-13','15:10:00',3.32),('16273','2013-07-13','15:15:00',3.25),('16273','2013-07-13','15:20:00',3.14),('16273','2013-07-13','15:25:00',3.19),('16273','2013-07-13','15:30:00',2.96),('16273','2013-07-13','15:35:00',3.09),('16273','2013-07-13','15:40:00',3.02),('16273','2013-07-13','15:45:00',2.97),('16273','2013-07-13','15:50:00',2.9),('16273','2013-07-13','15:55:00',2.87),('16273','2013-07-13','16:00:00',2.79),('16273','2013-07-13','16:05:00',2.73),('16273','2013-07-13','16:10:00',2.64),('16273','2013-07-13','16:15:00',2.56),('16273','2013-07-13','16:20:00',2.53),('16273','2013-07-13','16:25:00',2.47),('16273','2013-07-13','16:30:00',2.39),('16273','2013-07-13','16:35:00',2.34),('16273','2013-07-13','16:40:00',2.27),('16273','2013-07-13','16:45:00',2.18),('16273','2013-07-13','16:50:00',2.12),('16273','2013-07-13','16:55:00',2.02),('16273','2013-07-13','17:00:00',1.97),('16273','2013-07-13','17:05:00',1.83),('16273','2013-07-13','17:10:00',1.82),('16273','2013-07-13','17:15:00',1.72),('16273','2013-07-13','17:20:00',1.66),('16273','2013-07-13','17:25:00',1.6),('16273','2013-07-13','17:30:00',1.49),('16273','2013-07-13','17:35:00',1.45),('16273','2013-07-13','17:40:00',1.37),('16273','2013-07-13','17:45:00',1.32),('16273','2013-07-13','17:50:00',1.26),('16273','2013-07-13','17:55:00',1.19),('16273','2013-07-13','18:00:00',1.06),('16273','2013-07-13','18:05:00',1.04),('16273','2013-07-12','08:00:00',1.25),('16273','2013-07-12','08:05:00',1.78),('16273','2013-07-12','08:10:00',1.87),('16273','2013-07-12','08:15:00',1.49),('16273','2013-07-12','08:20:00',1.37),('16273','2013-07-12','08:25:00',1.96),('16273','2013-07-12','08:30:00',1.05),('16273','2013-07-12','08:55:00',1.01),('16273','2013-07-12','09:00:00',1.89),('16273','2013-07-12','09:05:00',2.07),('16273','2013-07-12','09:10:00',1.42),('16273','2013-07-12','09:15:00',1.38),('16273','2013-07-12','09:20:00',2.39),('16273','2013-07-12','09:25:00',2.23),('16273','2013-07-12','09:30:00',2.49),('16273','2013-07-12','09:35:00',2.57),('16273','2013-07-12','09:40:00',2.42),('16273','2013-07-12','09:45:00',1.94),('16273','2013-07-12','09:50:00',1.66),('16273','2013-07-12','09:55:00',1.88),('16273','2013-07-12','10:00:00',2.31),('16273','2013-07-12','10:05:00',3.08),('16273','2013-07-12','10:10:00',2.87),('16273','2013-07-12','10:15:00',3.35),('16273','2013-07-12','10:20:00',3.33),('16273','2013-07-12','10:25:00',3.56),('16273','2013-07-12','10:30:00',2.73),('16273','2013-07-12','10:35:00',1.05),('16273','2013-07-12','10:40:00',1.43),('16273','2013-07-12','10:45:00',3.36),('16273','2013-07-12','10:50:00',3.21),('16273','2013-07-12','10:55:00',1.12),('16273','2013-07-12','11:00:00',1.11),('16273','2013-07-12','11:05:00',1.17),('16273','2013-07-12','11:10:00',2.37),('16273','2013-07-12','11:15:00',1.59),('16273','2013-07-12','11:20:00',2.2),('16273','2013-07-12','11:25:00',2.74),('16273','2013-07-12','11:30:00',3.63),('16273','2013-07-12','11:35:00',3.04),('16273','2013-07-12','11:40:00',1.62),('16273','2013-07-12','11:45:00',3.6),('16273','2013-07-12','11:50:00',3.82),('16273','2013-07-12','11:55:00',3.97),('16273','2013-07-12','12:00:00',2.5),('16273','2013-07-12','12:05:00',3.94),('16273','2013-07-12','12:10:00',2.95),('16273','2013-07-12','12:15:00',4.16),('16273','2013-07-12','12:20:00',4.27),('16273','2013-07-12','12:25:00',4.03),('16273','2013-07-12','12:30:00',4.18),('16273','2013-07-12','12:35:00',3.62),('16273','2013-07-12','12:40:00',3.14),('16273','2013-07-12','12:45:00',3.76),('16273','2013-07-12','12:50:00',4.16),('16273','2013-07-12','12:55:00',4.19),('16273','2013-07-12','13:00:00',4),('16273','2013-07-12','13:05:00',3.05),('16273','2013-07-12','13:10:00',3.49),('16273','2013-07-12','13:15:00',3.6),('16273','2013-07-12','13:20:00',3.65),('16273','2013-07-12','13:25:00',3.1),('16273','2013-07-12','13:30:00',3.8),('16273','2013-07-12','13:35:00',3.93),('16273','2013-07-12','13:40:00',3.5),('16273','2013-07-12','13:45:00',4.07),('16273','2013-07-12','13:50:00',2.54),('16273','2013-07-12','13:55:00',3.58),('16273','2013-07-12','14:00:00',3.59),('16273','2013-07-12','14:05:00',3.33),('16273','2013-07-12','14:10:00',3.74),('16273','2013-07-12','14:15:00',4.09),('16273','2013-07-12','14:20:00',3.09),('16273','2013-07-12','14:25:00',3.85),('16273','2013-07-12','14:30:00',3.18),('16273','2013-07-12','14:35:00',3.57),('16273','2013-07-12','14:40:00',3.47),('16273','2013-07-12','14:45:00',3.42),('16273','2013-07-12','14:50:00',3.33),('16273','2013-07-12','14:55:00',3.26),('16273','2013-07-12','15:00:00',3.3),('16273','2013-07-12','15:05:00',3.24),('16273','2013-07-12','15:10:00',3.19),('16273','2013-07-12','15:15:00',3.08),('16273','2013-07-12','15:20:00',2.7),('16273','2013-07-12','15:25:00',3.13),('16273','2013-07-12','15:30:00',3.14),('16273','2013-07-12','15:35:00',3.04),('16273','2013-07-12','15:40:00',2.82),('16273','2013-07-12','15:45:00',2.81),('16273','2013-07-12','15:50:00',2.76),('16273','2013-07-12','15:55:00',2.74),('16273','2013-07-12','16:00:00',2.68),('16273','2013-07-12','16:05:00',2.65),('16273','2013-07-12','16:10:00',2.58),('16273','2013-07-12','16:15:00',2.53),('16273','2013-07-12','16:20:00',2.47),('16273','2013-07-12','16:25:00',2.41),('16273','2013-07-12','16:30:00',2.35),('16273','2013-07-12','16:35:00',2.29),('16273','2013-07-12','16:40:00',2.21),('16273','2013-07-12','16:45:00',2.14),('16273','2013-07-12','16:50:00',2.07),('16273','2013-07-12','16:55:00',1.98),('16273','2013-07-12','17:00:00',1.89),('16273','2013-07-12','17:05:00',1.84),('16273','2013-07-12','17:10:00',1.77),('16273','2013-07-12','17:15:00',1.7),('16273','2013-07-12','17:20:00',1.61),('16273','2013-07-12','17:25:00',1.56),('16273','2013-07-12','17:30:00',1.47),('16273','2013-07-12','17:35:00',1.41),('16273','2013-07-12','17:40:00',1.34),('16273','2013-07-12','17:45:00',1.26),('16273','2013-07-12','17:50:00',1.11),('16273','2013-07-12','17:55:00',1.05),('16273','2013-07-12','18:00:00',1.07),('16273','2013-07-12','18:05:00',1.02),('16273','2013-07-11','07:25:00',1.06),('16273','2013-07-11','07:30:00',1.13),('16273','2013-07-11','07:35:00',1.16),('16273','2013-07-11','07:40:00',1.22),('16273','2013-07-11','07:45:00',1.33),('16273','2013-07-11','07:50:00',1.43),('16273','2013-07-11','07:55:00',1.51),('16273','2013-07-11','08:00:00',1.6),('16273','2013-07-11','08:05:00',1.67),('16273','2013-07-11','08:10:00',1.72),('16273','2013-07-11','08:15:00',1.79),('16273','2013-07-11','08:20:00',1.89),('16273','2013-07-11','08:25:00',1.96),('16273','2013-07-11','08:30:00',2.05),('16273','2013-07-11','08:35:00',2.13),('16273','2013-07-11','08:40:00',2.17),('16273','2013-07-11','08:45:00',2.33),('16273','2013-07-11','08:50:00',2.32),('16273','2013-07-11','08:55:00',2.42),('16273','2013-07-11','09:00:00',2.47),('16273','2013-07-11','09:05:00',2.56),('16273','2013-07-11','09:10:00',2.65),('16273','2013-07-11','09:15:00',2.47),('16273','2013-07-11','09:20:00',2.69),('16273','2013-07-11','09:25:00',2.39),('16273','2013-07-11','09:30:00',2.91),('16273','2013-07-11','09:35:00',2.11),('16273','2013-07-11','09:40:00',3.13),('16273','2013-07-11','09:45:00',2.96),('16273','2013-07-11','09:50:00',2.92),('16273','2013-07-11','09:55:00',1.44),('16273','2013-07-11','10:00:00',1.22),('16273','2013-07-11','10:05:00',3.05),('16273','2013-07-11','10:10:00',3.34),('16273','2013-07-11','10:15:00',2.17),('16273','2013-07-11','10:20:00',1.23),('16273','2013-07-11','10:25:00',1.65),('16273','2013-07-11','10:30:00',3.47),('16273','2013-07-11','10:35:00',3.66),('16273','2013-07-11','10:40:00',3.27),('16273','2013-07-11','10:45:00',2.9),('16273','2013-07-11','10:50:00',3.38),('16273','2013-07-11','10:55:00',4.03),('16273','2013-07-11','11:00:00',2.09),('16273','2013-07-11','11:05:00',2.91),('16273','2013-07-11','11:10:00',4.07),('16273','2013-07-11','11:15:00',2.6),('16273','2013-07-11','11:20:00',1.96),('16273','2013-07-11','11:25:00',1.28),('16273','2013-07-11','11:30:00',2.06),('16273','2013-07-11','11:35:00',4.02),('16273','2013-07-11','11:40:00',4.33),('16273','2013-07-11','11:45:00',1.86),('16273','2013-07-11','11:50:00',4.22),('16273','2013-07-11','11:55:00',4.23),('16273','2013-07-11','12:00:00',4.05),('16273','2013-07-11','12:05:00',4.11),('16273','2013-07-11','12:10:00',4.07),('16273','2013-07-11','12:15:00',3.29),('16273','2013-07-11','12:20:00',3.14),('16273','2013-07-11','12:25:00',4.01),('16273','2013-07-11','12:30:00',4.03),('16273','2013-07-11','12:35:00',3.65),('16273','2013-07-11','12:40:00',3.99),('16273','2013-07-11','12:45:00',3.89),('16273','2013-07-11','12:50:00',3.89),('16273','2013-07-11','12:55:00',3.95),('16273','2013-07-11','13:00:00',3.57),('16273','2013-07-11','13:05:00',3.68),('16273','2013-07-11','13:10:00',3.97),('16273','2013-07-11','13:15:00',4.02),('16273','2013-07-11','13:20:00',3.99),('16273','2013-07-11','13:25:00',3.92),('16273','2013-07-11','13:30:00',3.89),('16273','2013-07-11','13:35:00',3.86),('16273','2013-07-11','13:40:00',3.84),('16273','2013-07-11','13:45:00',3.8),('16273','2013-07-11','13:50:00',3.74),('16273','2013-07-11','13:55:00',3.78),('16273','2013-07-11','14:00:00',3.75),('16273','2013-07-11','14:05:00',3.77),('16273','2013-07-11','14:10:00',3.22),('16273','2013-07-11','14:15:00',3.58),('16273','2013-07-11','14:20:00',3.67),('16273','2013-07-11','14:25:00',3.69),('16273','2013-07-11','14:30:00',3.59),('16273','2013-07-11','14:35:00',3.53),('16273','2013-07-11','14:40:00',3.55),('16273','2013-07-11','14:45:00',3.25),('16273','2013-07-11','14:50:00',3.5),('16273','2013-07-11','14:55:00',3.46),('16273','2013-07-11','15:00:00',3.27),('16273','2013-07-11','15:05:00',3.38),('16273','2013-07-11','15:10:00',3.35),('16273','2013-07-11','15:15:00',3.3),('16273','2013-07-11','15:20:00',3.2),('16273','2013-07-11','15:25:00',3.18),('16273','2013-07-11','15:30:00',3.13),('16273','2013-07-11','15:35:00',2.74),('16273','2013-07-11','15:40:00',3.05),('16273','2013-07-11','15:45:00',3.1),('16273','2013-07-11','15:50:00',2.93),('16273','2013-07-11','15:55:00',2.85),('16273','2013-07-11','16:00:00',2.9),('16273','2013-07-11','16:05:00',2.79),('16273','2013-07-11','16:10:00',2.74),('16273','2013-07-11','16:15:00',2.73),('16273','2013-07-11','16:20:00',1.68),('16273','2013-07-11','16:25:00',2.61),('16273','2013-07-11','16:30:00',2.4),('16273','2013-07-11','16:35:00',1.97),('16273','2013-07-11','16:40:00',2.34),('16273','2013-07-11','16:45:00',1.93),('16273','2013-07-11','16:50:00',1.85),('16273','2013-07-11','16:55:00',2.24),('16273','2013-07-11','17:00:00',1.94),('16273','2013-07-11','17:05:00',1.95),('16273','2013-07-11','17:10:00',1.88),('16273','2013-07-11','17:15:00',1.71),('16273','2013-07-11','17:20:00',1.13),('16273','2013-07-11','17:25:00',1.76),('16273','2013-07-11','17:30:00',1.32),('16273','2013-07-11','17:35:00',1.26),('16273','2013-07-11','17:40:00',1.05),('16273','2013-07-11','17:50:00',1.36),('16273','2013-07-11','18:00:00',1.09),('16273','2013-07-11','18:05:00',1.16),('16273','2013-07-11','18:15:00',1.05),('16273','2014-05-03','07:25:00',1.05),('16273','2014-05-03','07:30:00',1.11),('16273','2014-05-03','07:35:00',1.47),('16273','2014-05-03','07:40:00',1.49),('16273','2014-05-03','07:45:00',1.57),('16273','2014-05-03','07:50:00',1.66),('16273','2014-05-03','07:55:00',1.79),('16273','2014-05-03','08:00:00',1.44),('16273','2014-05-03','08:20:00',1.81),('16273','2014-05-03','08:25:00',2.47),('16273','2014-05-03','08:30:00',2.66),('16273','2014-05-03','08:35:00',2.79),('16273','2014-05-03','08:40:00',3.1),('16273','2014-05-03','08:45:00',2.55),('16273','2014-05-03','08:50:00',2.4),('16273','2014-05-03','08:55:00',2.27),('16273','2014-05-03','09:00:00',1.71),('16273','2014-05-03','09:05:00',1.49),('16273','2014-05-03','09:10:00',1.46),('16273','2014-05-03','09:15:00',2.38),('16273','2014-05-03','09:20:00',3.95),('16273','2014-05-03','09:25:00',3.59),('16273','2014-05-03','09:30:00',3.35),('16273','2014-05-03','09:35:00',1.27),('16273','2014-05-03','09:40:00',1.16),('16273','2014-05-03','09:45:00',1.31),('16273','2014-05-03','09:50:00',1.52),('16273','2014-05-03','09:55:00',1.95),('16273','2014-05-03','10:00:00',2.77),('16273','2014-05-03','10:05:00',3.65),('16273','2014-05-03','10:10:00',1.32),('16273','2014-05-03','10:15:00',1.27),('16273','2014-05-03','10:20:00',1.74),('16273','2014-05-03','10:25:00',1.45),('16273','2014-05-03','10:30:00',2.21),('16273','2014-05-03','10:35:00',4.52),('16273','2014-05-03','10:40:00',3.73),('16273','2014-05-03','10:45:00',1.8),('16273','2014-05-03','10:50:00',3.22),('16273','2014-05-03','10:55:00',2.29),('16273','2014-05-03','11:00:00',1.21),('16273','2014-05-03','11:05:00',1.34),('16273','2014-05-03','11:10:00',1.38),('16273','2014-05-03','11:40:00',1.95),('16273','2014-05-03','11:45:00',1.92),('16273','2014-05-03','11:50:00',1.68),('16273','2014-05-03','11:55:00',2.68),('16273','2014-05-03','12:00:00',2.43),('16273','2014-05-03','12:05:00',1.57),('16273','2014-05-03','12:10:00',1.44),('16273','2014-05-03','12:15:00',1.45),('16273','2014-05-03','12:20:00',1.3),('16273','2014-05-03','12:25:00',1.19),('16273','2014-05-03','12:30:00',1.14),('16273','2014-05-03','12:35:00',1.39),('16273','2014-05-03','12:40:00',1.6),('16273','2014-05-03','12:45:00',1.56),('16273','2014-05-03','12:50:00',1.33),('16273','2014-05-03','12:55:00',1.53),('16273','2014-05-03','13:00:00',1.85),('16273','2014-05-03','13:05:00',1.7),('16273','2014-05-03','13:10:00',1.54),('16273','2014-05-03','13:15:00',1.46),('16273','2014-05-03','13:20:00',1.45),('16273','2014-05-03','13:25:00',1.45),('16273','2014-05-03','13:30:00',1.38),('16273','2014-05-03','13:35:00',1.47),('16273','2014-05-03','13:40:00',1.62),('16273','2014-05-03','13:45:00',1.71),('16273','2014-05-03','13:50:00',1.74),('16273','2014-05-03','13:55:00',1.96),('16273','2014-05-03','14:00:00',2.1),('16273','2014-05-03','14:05:00',2.01),('16273','2014-05-03','14:10:00',2.16),('16273','2014-05-03','14:15:00',2.1),('16273','2014-05-03','14:20:00',2.2),('16273','2014-05-03','14:25:00',2.04),('16273','2014-05-03','14:30:00',1.63),('16273','2014-05-03','14:35:00',1.06),('16273','2014-05-03','17:40:00',1.08),('16273','2014-04-06','08:15:00',1.56),('16273','2014-04-06','08:20:00',1.65),('16273','2014-04-06','08:25:00',1.74),('16273','2014-04-06','08:30:00',1.82),('16273','2014-04-06','08:35:00',1.92),('16273','2014-04-06','08:40:00',2.01),('16273','2014-04-06','08:45:00',2.09),('16273','2014-04-06','08:50:00',2.18),('16273','2014-04-06','08:55:00',2.26),('16273','2014-04-06','09:00:00',2.35),('16273','2014-04-06','09:05:00',2.43),('16273','2014-04-06','09:10:00',2.55),('16273','2014-04-06','09:15:00',2.63),('16273','2014-04-06','09:20:00',1.94),('16273','2014-04-06','09:35:00',1.79),('16273','2014-04-06','09:40:00',1.9),('16273','2014-04-06','09:45:00',1.54),('16273','2014-04-06','09:50:00',1.7),('16273','2014-04-06','09:55:00',1.62),('16273','2014-04-06','10:00:00',2.39),('16273','2014-04-06','10:05:00',3.09),('16273','2014-04-06','10:10:00',3.45),('16273','2014-04-06','10:15:00',3.78),('16273','2014-04-06','10:20:00',3.58),('16273','2014-04-06','10:25:00',2.56),('16273','2014-04-06','10:30:00',3.02),('16273','2014-04-06','10:35:00',1.66),('16273','2014-04-06','10:40:00',1.48),('16273','2014-04-06','10:45:00',1.47),('16273','2014-04-06','10:50:00',1.76),('16273','2014-04-06','10:55:00',1.82),('16273','2014-04-06','11:00:00',3.28),('16273','2014-04-06','11:05:00',3.98),('16273','2014-04-06','11:10:00',3.93),('16273','2014-04-06','11:15:00',3.86),('16273','2014-04-06','11:20:00',3.95),('16273','2014-04-06','11:25:00',3.55),('16273','2014-04-06','11:30:00',4.02),('16273','2014-04-06','11:35:00',3.94),('16273','2014-04-06','11:40:00',3.88),('16273','2014-04-06','11:45:00',3.84),('16273','2014-04-06','11:50:00',3.91),('16273','2014-04-06','11:55:00',3.88),('16273','2014-04-06','12:00:00',3.88),('16273','2014-04-06','12:05:00',3.87),('16273','2014-04-06','12:10:00',3.49),('16273','2014-04-06','12:15:00',3.71),('16273','2014-04-06','12:20:00',3.73),('16273','2014-04-06','12:25:00',3.9),('16273','2014-04-06','12:30:00',3.96),('16273','2014-04-06','12:35:00',3.25),('16273','2014-04-06','12:40:00',3.24),('16273','2014-04-06','12:45:00',3.87),('16273','2014-04-06','12:50:00',3.97),('16273','2014-04-06','12:55:00',2.98),('16273','2014-04-06','13:00:00',3.9),('16273','2014-04-06','13:05:00',3.61),('16273','2014-04-06','13:10:00',3.91),('16273','2014-04-06','13:15:00',4.01),('16273','2014-04-06','13:20:00',3.94),('16273','2014-04-06','13:25:00',3.82),('16273','2014-04-06','13:30:00',3.75),('16273','2014-04-06','13:35:00',3.76),('16273','2014-04-06','13:40:00',3.72),('16273','2014-04-06','13:45:00',3.67),('16273','2014-04-06','13:50:00',3.76),('16273','2014-04-06','13:55:00',1.43),('16273','2014-04-06','14:00:00',3.36),('16273','2014-04-06','14:05:00',3.06),('16273','2014-04-06','14:10:00',3.42),('16273','2014-04-06','14:15:00',3.71),('16273','2014-04-06','14:20:00',3.58),('16273','2014-04-06','14:25:00',3.27),('16273','2014-04-06','14:30:00',3.29),('16273','2014-04-06','14:35:00',1.83),('16273','2014-04-06','14:40:00',3.42),('16273','2014-04-06','14:45:00',2.18),('16273','2014-04-06','14:50:00',2.49),('16273','2014-04-06','14:55:00',3.69),('16273','2014-04-06','15:00:00',3.29),('16273','2014-04-06','15:05:00',2.27),('16273','2014-04-06','16:10:00',2.22),('16273','2014-04-06','16:15:00',1.5),('16273','2014-04-06','16:50:00',1.85),('16273','2014-04-06','16:55:00',2.08),('16273','2014-04-06','17:00:00',2.07),('16273','2014-04-06','17:05:00',1.37),('16273','2014-04-06','17:30:00',1.18),('16273','2014-04-06','17:35:00',1.14),('16273','2014-04-06','17:40:00',1.04),('16273','2013-07-10','07:15:00',1.1),('16273','2013-07-10','07:20:00',1.24),('16273','2013-07-10','07:25:00',1.34),('16273','2013-07-10','07:30:00',1.45),('16273','2013-07-10','07:35:00',1.6),('16273','2013-07-10','07:40:00',1.45),('16273','2013-07-10','07:45:00',1.25),('16273','2013-07-10','07:50:00',1.03),('16273','2013-07-10','08:10:00',1.06),('16273','2013-07-10','08:15:00',1.23),('16273','2013-07-10','08:20:00',1.91),('16273','2013-07-10','08:25:00',2.39),('16273','2013-07-10','08:30:00',2.34),('16273','2013-07-10','08:35:00',2.54),('16273','2013-07-10','08:40:00',2.22),('16273','2013-07-10','08:45:00',1.71),('16273','2013-07-10','08:50:00',1.97),('16273','2013-07-10','08:55:00',2.68),('16273','2013-07-10','09:00:00',2.65),('16273','2013-07-10','09:05:00',2.73),('16273','2013-07-10','09:10:00',2.76),('16273','2013-07-10','09:15:00',2.8),('16273','2013-07-10','09:20:00',2.63),('16273','2013-07-10','09:25:00',2.88),('16273','2013-07-10','09:30:00',2.94),('16273','2013-07-10','09:35:00',3),('16273','2013-07-10','09:40:00',3.04),('16273','2013-07-10','09:45:00',3.1),('16273','2013-07-10','09:50:00',3.13),('16273','2013-07-10','09:55:00',3.14),('16273','2013-07-10','10:00:00',3.14),('16273','2013-07-10','10:05:00',3.18),('16273','2013-07-10','10:10:00',3.24),('16273','2013-07-10','10:15:00',3.3),('16273','2013-07-10','10:20:00',3.32),('16273','2013-07-10','10:25:00',3.35),('16273','2013-07-10','10:30:00',3.38),('16273','2013-07-10','10:35:00',3.43),('16273','2013-07-10','10:40:00',3.46),('16273','2013-07-10','10:45:00',3.47),('16273','2013-07-10','10:50:00',3.5),('16273','2013-07-10','10:55:00',3.55),('16273','2013-07-10','11:00:00',3.58),('16273','2013-07-10','11:05:00',3.6),('16273','2013-07-10','11:10:00',3.6),('16273','2013-07-10','11:15:00',3.61),('16273','2013-07-10','11:20:00',3.62),('16273','2013-07-10','11:25:00',3.64),('16273','2013-07-10','11:30:00',3.61),('16273','2013-07-10','11:35:00',3.69),('16273','2013-07-10','11:40:00',3.71),('16273','2013-07-10','11:45:00',3.69),('16273','2013-07-10','11:50:00',3.74),('16273','2013-07-10','11:55:00',3.72),('16273','2013-07-10','12:00:00',3.78),('16273','2013-07-10','12:05:00',3.83),('16273','2013-07-10','12:10:00',3.84),('16273','2013-07-10','12:15:00',3.85),('16273','2013-07-10','12:20:00',3.85),('16273','2013-07-10','12:25:00',3.82),('16273','2013-07-10','12:30:00',3.87),('16273','2013-07-10','12:35:00',3.88),('16273','2013-07-10','12:40:00',3.88),('16273','2013-07-10','12:45:00',3.87),('16273','2013-07-10','12:50:00',3.88),('16273','2013-07-10','12:55:00',3.81),('16273','2013-07-10','13:00:00',3.87),('16273','2013-07-10','13:05:00',3.86),('16273','2013-07-10','13:10:00',3.85),('16273','2013-07-10','13:15:00',3.85),('16273','2013-07-10','13:20:00',3.85),('16273','2013-07-10','13:25:00',3.86),('16273','2013-07-10','13:30:00',3.83),('16273','2013-07-10','13:35:00',3.85),('16273','2013-07-10','13:40:00',3.84),('16273','2013-07-10','13:45:00',3.82),('16273','2013-07-10','13:50:00',3.81),('16273','2013-07-10','13:55:00',3.79),('16273','2013-07-10','14:00:00',3.76),('16273','2013-07-10','14:05:00',3.73),('16273','2013-07-10','14:10:00',3.71),('16273','2013-07-10','14:15:00',3.67),('16273','2013-07-10','14:20:00',3.65),('16273','2013-07-10','14:25:00',3.6),('16273','2013-07-10','14:30:00',3.58),('16273','2013-07-10','14:35:00',3.54),('16273','2013-07-10','14:40:00',3.5),('16273','2013-07-10','14:45:00',3.47),('16273','2013-07-10','14:50:00',3.43),('16273','2013-07-10','14:55:00',3.4),('16273','2013-07-10','15:00:00',3.37),('16273','2013-07-10','15:05:00',3.33),('16273','2013-07-10','15:10:00',3.31),('16273','2013-07-10','15:15:00',3.26),('16273','2013-07-10','15:20:00',3.22),('16273','2013-07-10','15:25:00',3.17),('16273','2013-07-10','15:30:00',3.12),('16273','2013-07-10','15:35:00',3.06),('16273','2013-07-10','15:40:00',3),('16273','2013-07-10','15:45:00',2.94),('16273','2013-07-10','15:50:00',2.88),('16273','2013-07-10','15:55:00',2.84),('16273','2013-07-10','16:00:00',2.74),('16273','2013-07-10','16:05:00',2.71),('16273','2013-07-10','16:10:00',2.66),('16273','2013-07-10','16:15:00',2.58),('16273','2013-07-10','16:20:00',2.53),('16273','2013-07-10','16:25:00',2.46),('16273','2013-07-10','16:30:00',2.37),('16273','2013-07-10','16:35:00',2.32),('16273','2013-07-10','16:40:00',2.26),('16273','2013-07-10','16:45:00',2.2),('16273','2013-07-10','16:50:00',2.15),('16273','2013-07-10','16:55:00',2.11),('16273','2013-07-10','17:00:00',2.15),('16273','2013-07-10','17:05:00',2.27),('16273','2013-07-10','17:10:00',2.29),('16273','2013-07-10','17:15:00',2.12),('16273','2013-07-10','17:20:00',2.09),('16273','2013-07-10','17:25:00',2),('16273','2013-07-10','17:30:00',1.76),('16273','2013-07-10','17:35:00',1.73),('16273','2013-07-10','17:40:00',1.55),('16273','2013-07-10','17:45:00',1.42),('16273','2013-07-10','17:50:00',1.32),('16273','2013-07-10','17:55:00',1.25),('16273','2013-07-10','18:00:00',1.14),('16273','2013-07-09','07:20:00',1),('16273','2013-07-09','07:25:00',1.09),('16273','2013-07-09','07:30:00',1.2),('16273','2013-07-09','07:35:00',1.32),('16273','2013-07-09','07:40:00',1.45),('16273','2013-07-09','07:45:00',1.56),('16273','2013-07-09','07:50:00',1.64),('16273','2013-07-09','07:55:00',1.7),('16273','2013-07-09','08:00:00',1.78),('16273','2013-07-09','08:05:00',1.8),('16273','2013-07-09','08:10:00',1.83),('16273','2013-07-09','08:15:00',1.91),('16273','2013-07-09','08:20:00',1.99),('16273','2013-07-09','08:25:00',2.07),('16273','2013-07-09','08:30:00',2.13),('16273','2013-07-09','08:35:00',2.19),('16273','2013-07-09','08:40:00',2.27),('16273','2013-07-09','08:45:00',2.33),('16273','2013-07-09','08:50:00',2.4),('16273','2013-07-09','08:55:00',2.45),('16273','2013-07-09','09:00:00',2.51),('16273','2013-07-09','09:05:00',2.54),('16273','2013-07-09','09:10:00',2.64),('16273','2013-07-09','09:15:00',2.71),('16273','2013-07-09','09:20:00',2.76),('16273','2013-07-09','09:25:00',2.78),('16273','2013-07-09','09:30:00',2.85),('16273','2013-07-09','09:35:00',2.89),('16273','2013-07-09','09:40:00',2.95),('16273','2013-07-09','09:45:00',3.01),('16273','2013-07-09','09:50:00',3.06),('16273','2013-07-09','09:55:00',3.1),('16273','2013-07-09','10:00:00',3.13),('16273','2013-07-09','10:05:00',3.19),('16273','2013-07-09','10:10:00',3.21),('16273','2013-07-09','10:15:00',3.26),('16273','2013-07-09','10:20:00',3.31),('16273','2013-07-09','10:25:00',3.34),('16273','2013-07-09','10:30:00',3.35),('16273','2013-07-09','10:35:00',3.38),('16273','2013-07-09','10:40:00',3.43),('16273','2013-07-09','10:45:00',3.47),('16273','2013-07-09','10:50:00',3.48),('16273','2013-07-09','10:55:00',3.51),('16273','2013-07-09','11:00:00',3.54),('16273','2013-07-09','11:05:00',3.58),('16273','2013-07-09','11:10:00',3.62),('16273','2013-07-09','11:15:00',3.63),('16273','2013-07-09','11:20:00',3.64),('16273','2013-07-09','11:25:00',3.64),('16273','2013-07-09','11:30:00',3.71),('16273','2013-07-09','11:35:00',3.72),('16273','2013-07-09','11:40:00',3.76),('16273','2013-07-09','11:45:00',3.78),('16273','2013-07-09','11:50:00',3.76),('16273','2013-07-09','11:55:00',3.72),('16273','2013-07-09','12:00:00',3.63),('16273','2013-07-09','12:05:00',3.74),('16273','2013-07-09','12:10:00',3.76),('16273','2013-07-09','12:15:00',3.79),('16273','2013-07-09','12:20:00',3.74),('16273','2013-07-09','12:25:00',3.75),('16273','2013-07-09','12:30:00',3.77),('16273','2013-07-09','12:35:00',3.75),('16273','2013-07-09','12:40:00',3.77),('16273','2013-07-09','12:45:00',3.89),('16273','2013-07-09','12:50:00',4.01),('16273','2013-07-09','12:55:00',3.98),('16273','2013-07-09','13:00:00',3.87),('16273','2013-07-09','13:05:00',3.8),('16273','2013-07-09','13:10:00',3.85),('16273','2013-07-09','13:15:00',3.86),('16273','2013-07-09','13:20:00',3.86),('16273','2013-07-09','13:25:00',3.9),('16273','2013-07-09','13:30:00',3.87),('16273','2013-07-09','13:35:00',3.9),('16273','2013-07-09','13:40:00',3.87),('16273','2013-07-09','13:45:00',3.8),('16273','2013-07-09','13:50:00',3.3),('16273','2013-07-09','13:55:00',3.81),('16273','2013-07-09','14:00:00',3.83),('16273','2013-07-09','14:05:00',2.95),('16273','2013-07-09','14:10:00',3.26),('16273','2013-07-09','14:15:00',3.61),('16273','2013-07-09','14:20:00',3.84),('16273','2013-07-09','14:25:00',3.91),('16273','2013-07-09','14:30:00',1.85),('16273','2013-07-09','14:35:00',1.03),('16273','2013-07-08','07:40:00',1.41),('16273','2013-07-08','07:45:00',1.61),('16273','2013-07-08','07:50:00',1.67),('16273','2013-07-08','07:55:00',1.72),('16273','2013-07-08','08:00:00',1.77),('16273','2013-07-08','08:05:00',1.81),('16273','2013-07-08','08:10:00',1.86),('16273','2013-07-08','08:15:00',1.94),('16273','2013-07-08','08:20:00',2.03),('16273','2013-07-08','08:25:00',2.09),('16273','2013-07-08','08:30:00',2.17),('16273','2013-07-08','08:35:00',2.24),('16273','2013-07-08','08:40:00',2.28),('16273','2013-07-08','08:45:00',2.35),('16273','2013-07-08','08:50:00',2.41),('16273','2013-07-08','08:55:00',2.46),('16273','2013-07-08','09:00:00',2.52),('16273','2013-07-08','09:05:00',2.55),('16273','2013-07-08','09:10:00',2.61),('16273','2013-07-08','09:15:00',2.68),('16273','2013-07-08','09:20:00',2.75),('16273','2013-07-08','09:25:00',2.81),('16273','2013-07-08','09:30:00',2.86),('16273','2013-07-08','09:35:00',2.93),('16273','2013-07-08','09:40:00',2.97),('16273','2013-07-08','09:45:00',3.02),('16273','2013-07-08','09:50:00',3.07),('16273','2013-07-08','09:55:00',3.09),('16273','2013-07-08','10:00:00',3.16),('16273','2013-07-08','10:05:00',3.2),('16273','2013-07-08','10:10:00',3.22),('16273','2013-07-08','10:15:00',3.26),('16273','2013-07-08','10:20:00',3.3),('16273','2013-07-08','10:25:00',3.32),('16273','2013-07-08','10:30:00',3.27),('16273','2013-07-08','10:35:00',2.56),('16273','2013-07-08','10:40:00',3.49),('16273','2013-07-08','10:45:00',3.49),('16273','2013-07-08','10:50:00',3.5),('16273','2013-07-08','10:55:00',3.5),('16273','2013-07-08','11:00:00',3.53),('16273','2013-07-08','11:05:00',3.57),('16273','2013-07-08','11:10:00',3.59),('16273','2013-07-08','11:15:00',3.58),('16273','2013-07-08','11:20:00',3.63),('16273','2013-07-08','11:25:00',3.68),('16273','2013-07-08','11:30:00',3.72),('16273','2013-07-08','11:35:00',3.53),('16273','2013-07-08','11:40:00',3.56),('16273','2013-07-08','11:45:00',2.87),('16273','2013-07-08','11:50:00',2.44),('16273','2013-07-08','11:55:00',2.79),('16273','2013-07-08','12:00:00',4.03),('16273','2013-07-08','12:05:00',3.49),('16273','2013-07-08','12:10:00',2.92),('16273','2013-07-08','12:15:00',4),('16273','2013-07-08','12:20:00',3.9),('16273','2013-07-08','12:25:00',3.77),('16273','2013-07-08','12:30:00',3.47),('16273','2013-07-08','12:35:00',3.64),('16273','2013-07-08','12:40:00',3.82),('16273','2013-07-08','12:45:00',4.04),('16273','2013-07-08','12:50:00',3.97),('16273','2013-07-08','12:55:00',3.98),('16273','2013-07-08','13:00:00',2.97),('16273','2013-07-08','13:05:00',1.8),('16273','2013-07-08','13:10:00',4.23),('16273','2013-07-08','13:15:00',3.03),('16273','2013-07-08','13:20:00',3.64),('16273','2013-07-08','13:25:00',2.23),('16273','2013-07-08','14:15:00',1.06),('16273','2013-07-08','14:20:00',1.14),('16273','2013-07-08','14:25:00',1.14),('16273','2013-07-08','14:30:00',1.11),('16273','2013-07-08','14:35:00',1.16),('16273','2013-07-08','14:40:00',1.43),('16273','2013-07-08','14:45:00',1.96),('16273','2013-07-08','14:50:00',1.75),('16273','2013-07-08','14:55:00',1.6),('16273','2013-07-08','15:00:00',1.38),('16273','2013-07-08','15:05:00',1.32),('16273','2013-07-08','15:10:00',1.28),('16273','2013-07-08','15:15:00',1.14),('16273','2013-07-07','07:15:00',1.07),('16273','2013-07-07','07:20:00',1.15),('16273','2013-07-07','07:25:00',1.23),('16273','2013-07-07','07:30:00',1.31),('16273','2013-07-07','07:35:00',1.39),('16273','2013-07-07','07:40:00',1.47),('16273','2013-07-07','07:45:00',1.55),('16273','2013-07-07','07:50:00',1.63),('16273','2013-07-07','07:55:00',1.72),('16273','2013-07-07','08:00:00',1.8),('16273','2013-07-07','08:05:00',1.88),('16273','2013-07-07','08:10:00',1.96),('16273','2013-07-07','08:15:00',2.05),('16273','2013-07-07','08:20:00',2.13),('16273','2013-07-07','08:25:00',2.19),('16273','2013-07-07','08:30:00',2.26),('16273','2013-07-07','08:35:00',2.33),('16273','2013-07-07','08:40:00',2.24),('16273','2013-07-07','08:45:00',1.43),('16273','2013-07-07','08:50:00',2.09),('16273','2013-07-07','08:55:00',2.07),('16273','2013-07-07','09:00:00',2.75),('16273','2013-07-07','09:05:00',2.89),('16273','2013-07-07','09:10:00',2.97),('16273','2013-07-07','09:15:00',1.88),('16273','2013-07-07','09:20:00',1.48),('16273','2013-07-07','09:25:00',1.39),('16273','2013-07-07','09:30:00',1.45),('16273','2013-07-07','09:35:00',2.43),('16273','2013-07-07','09:40:00',3.27),('16273','2013-07-07','09:45:00',2.82),('16273','2013-07-07','09:50:00',3.29),('16273','2013-07-07','09:55:00',3.44),('16273','2013-07-07','10:00:00',3.49),('16273','2013-07-07','10:05:00',3.49),('16273','2013-07-07','10:10:00',3.41),('16273','2013-07-07','10:15:00',3.33),('16273','2013-07-07','10:20:00',2.84),('16273','2013-07-07','10:25:00',3.63),('16273','2013-07-07','10:30:00',3.68),('16273','2013-07-07','10:35:00',3.61),('16273','2013-07-07','10:40:00',3.13),('16273','2013-07-07','10:45:00',3.69),('16273','2013-07-07','10:50:00',3.62),('16273','2013-07-07','10:55:00',3.7),('16273','2013-07-07','11:00:00',3.71),('16273','2013-07-07','11:05:00',3.75),('16273','2013-07-07','11:10:00',3.74),('16273','2013-07-07','11:15:00',3.77),('16273','2013-07-07','11:20:00',3.8),('16273','2013-07-07','11:25:00',3.64),('16273','2013-07-07','11:30:00',3.38),('16273','2013-07-07','11:35:00',3.82),('16273','2013-07-07','11:40:00',3.4),('16273','2013-07-07','11:45:00',3.51),('16273','2013-07-07','11:50:00',3.68),('16273','2013-07-07','11:55:00',3.87),('16273','2013-07-07','12:00:00',3.71),('16273','2013-07-07','12:05:00',2.91),('16273','2013-07-07','12:10:00',2.91),('16273','2013-07-07','12:15:00',3.16),('16273','2013-07-07','12:20:00',2.87),('16273','2013-07-07','12:25:00',2.69),('16273','2013-07-07','12:30:00',3.64),('16273','2013-07-07','12:35:00',3.86),('16273','2013-07-07','12:40:00',3.8),('16273','2013-07-07','12:45:00',3.74),('16273','2013-07-07','12:50:00',3.82),('16273','2013-07-07','12:55:00',3.89),('16273','2013-07-07','13:00:00',3.98),('16273','2013-07-07','13:05:00',3.95),('16273','2013-07-07','13:10:00',3.81),('16273','2013-07-07','13:15:00',3.83),('16273','2013-07-07','13:20:00',3.86),('16273','2013-07-07','13:25:00',3.85),('16273','2013-07-07','13:30:00',3.85),('16273','2013-07-07','13:35:00',3.98),('16273','2013-07-07','13:40:00',3.99),('16273','2013-07-07','13:45:00',2.89),('16273','2013-07-07','13:50:00',3.82),('16273','2013-07-07','13:55:00',4.24),('16273','2013-07-07','14:00:00',2.8),('16273','2013-07-07','14:05:00',1.33),('16273','2013-07-07','14:10:00',1.19),('16273','2013-07-07','14:15:00',1.04),('16273','2013-07-07','14:20:00',1.1),('16273','2013-07-07','14:25:00',1.26),('16273','2013-07-07','14:30:00',1.42),('16273','2013-07-07','14:35:00',1.75),('16273','2013-07-07','14:40:00',1.29),('16273','2013-07-07','14:55:00',1.01),('16273','2013-07-07','15:00:00',1.07),('16273','2013-07-07','15:05:00',1.23),('16273','2013-07-07','15:10:00',1.93),('16273','2013-07-07','15:15:00',2.45),('16273','2013-07-07','15:20:00',1.58),('16273','2013-07-07','17:10:00',1.02),('16273','2013-07-07','17:15:00',1.06),('16273','2013-07-07','17:20:00',1.11),('16273','2013-07-07','17:25:00',1.16),('16273','2013-07-07','17:30:00',1.2),('16273','2013-07-07','17:35:00',1.1),('16273','2013-07-07','17:40:00',1.03),('16273','2013-07-07','17:45:00',1.02),('16273','2013-07-07','17:50:00',1.03),('16273','2013-07-06','07:15:00',1.03),('16273','2013-07-06','07:20:00',1.11),('16273','2013-07-06','07:25:00',1.19),('16273','2013-07-06','07:30:00',1.27),('16273','2013-07-06','07:35:00',1.35),('16273','2013-07-06','07:40:00',1.42),('16273','2013-07-06','07:45:00',1.49),('16273','2013-07-06','07:50:00',1.54),('16273','2013-07-06','07:55:00',1.62),('16273','2013-07-06','08:00:00',1.72),('16273','2013-07-06','08:05:00',1.81),('16273','2013-07-06','08:10:00',1.89),('16273','2013-07-06','08:15:00',1.96),('16273','2013-07-06','08:20:00',2.01),('16273','2013-07-06','08:25:00',2.08),('16273','2013-07-06','08:30:00',2.16),('16273','2013-07-06','08:35:00',2.23),('16273','2013-07-06','08:40:00',2.31),('16273','2013-07-06','08:45:00',2.38),('16273','2013-07-06','08:50:00',2.45),('16273','2013-07-06','08:55:00',2.51),('16273','2013-07-06','09:00:00',2.57),('16273','2013-07-06','09:05:00',2.64),('16273','2013-07-06','09:10:00',2.71),('16273','2013-07-06','09:15:00',2.77),('16273','2013-07-06','09:20:00',2.82),('16273','2013-07-06','09:25:00',2.89),('16273','2013-07-06','09:30:00',2.94),('16273','2013-07-06','09:35:00',2.98),('16273','2013-07-06','09:40:00',3.02),('16273','2013-07-06','09:45:00',3.06),('16273','2013-07-06','09:50:00',3.1),('16273','2013-07-06','09:55:00',3.16),('16273','2013-07-06','10:00:00',3.22),('16273','2013-07-06','10:05:00',3.24),('16273','2013-07-06','10:10:00',3.21),('16273','2013-07-06','10:15:00',3.26),('16273','2013-07-06','10:20:00',3.3),('16273','2013-07-06','10:25:00',3.37),('16273','2013-07-06','10:30:00',3.43),('16273','2013-07-06','10:35:00',3.46),('16273','2013-07-06','10:40:00',3.53),('16273','2013-07-06','10:45:00',3.56),('16273','2013-07-06','10:50:00',3.57),('16273','2013-07-06','10:55:00',3.62),('16273','2013-07-06','11:00:00',3.64),('16273','2013-07-06','11:05:00',3.67),('16273','2013-07-06','11:10:00',3.71),('16273','2013-07-06','11:15:00',3.71),('16273','2013-07-06','11:20:00',3.73),('16273','2013-07-06','11:25:00',3.73),('16273','2013-07-06','11:30:00',3.76),('16273','2013-07-06','11:35:00',3.76),('16273','2013-07-06','11:40:00',3.77),('16273','2013-07-06','11:45:00',3.82),('16273','2013-07-06','11:50:00',3.82),('16273','2013-07-06','11:55:00',3.79),('16273','2013-07-06','12:00:00',3.83),('16273','2013-07-06','12:05:00',3.85),('16273','2013-07-06','12:10:00',3.85),('16273','2013-07-06','12:15:00',3.86),('16273','2013-07-06','12:20:00',3.87),('16273','2013-07-06','12:25:00',3.9),('16273','2013-07-06','12:30:00',3.88),('16273','2013-07-06','12:35:00',3.88),('16273','2013-07-06','12:40:00',3.89),('16273','2013-07-06','12:45:00',3.91),('16273','2013-07-06','12:50:00',3.92),('16273','2013-07-06','12:55:00',3.91),('16273','2013-07-06','13:00:00',3.82),('16273','2013-07-06','13:05:00',3.81),('16273','2013-07-06','13:10:00',3.79),('16273','2013-07-06','13:15:00',3.83),('16273','2013-07-06','13:20:00',3.33),('16273','2013-07-06','13:25:00',3.34),('16273','2013-07-06','13:30:00',3.82),('16273','2013-07-06','13:35:00',3.83),('16273','2013-07-06','13:40:00',3.85),('16273','2013-07-06','13:45:00',3.74),('16273','2013-07-06','13:50:00',3.76),('16273','2013-07-06','13:55:00',3.71),('16273','2013-07-06','14:00:00',2.72),('16273','2013-07-06','14:05:00',3.05),('16273','2013-07-06','14:10:00',3.62),('16273','2013-07-06','14:15:00',3.57),('16273','2013-07-06','14:20:00',3.6),('16273','2013-07-06','14:25:00',3.58),('16273','2013-07-06','14:30:00',3.54),('16273','2013-07-06','14:35:00',3.44),('16273','2013-07-06','14:40:00',3.25),('16273','2013-07-06','14:45:00',2.26),('16273','2013-07-06','14:55:00',2.81),('16273','2013-07-06','15:00:00',1.73),('16273','2013-07-06','15:05:00',1.65),('16273','2013-07-06','15:10:00',1.99),('16273','2013-07-06','16:55:00',1.12),('16273','2013-07-06','17:00:00',1.11),('16273','2013-07-06','17:05:00',1.32),('16273','2013-07-06','17:10:00',1.51),('16273','2013-07-06','17:15:00',1.54),('16273','2013-07-06','17:20:00',1.28),('16273','2013-07-06','17:25:00',1.25),('16273','2013-07-06','17:30:00',1.23),('16273','2013-07-05','07:20:00',1.08),('16273','2013-07-05','07:25:00',1.17),('16273','2013-07-05','07:30:00',1.25),('16273','2013-07-05','07:35:00',1.31),('16273','2013-07-05','07:40:00',1.38),('16273','2013-07-05','07:45:00',1.44),('16273','2013-07-05','07:50:00',1.53),('16273','2013-07-05','07:55:00',1.62),('16273','2013-07-05','08:00:00',1.71),('16273','2013-07-05','08:05:00',1.78),('16273','2013-07-05','08:10:00',1.86),('16273','2013-07-05','08:15:00',1.95),('16273','2013-07-05','08:20:00',2.03),('16273','2013-07-05','08:25:00',2.1),('16273','2013-07-05','08:30:00',2.18),('16273','2013-07-05','08:35:00',2.27),('16273','2013-07-05','08:40:00',2.33),('16273','2013-07-05','08:45:00',2.38),('16273','2013-07-05','08:50:00',2.45),('16273','2013-07-05','08:55:00',2.51),('16273','2013-07-05','09:00:00',2.58),('16273','2013-07-05','09:05:00',2.63),('16273','2013-07-05','09:10:00',2.7),('16273','2013-07-05','09:15:00',2.76),('16273','2013-07-05','09:20:00',2.8),('16273','2013-07-05','09:25:00',2.86),('16273','2013-07-05','09:30:00',2.89),('16273','2013-07-05','09:35:00',2.93),('16273','2013-07-05','09:40:00',3),('16273','2013-07-05','09:45:00',3.05),('16273','2013-07-05','09:50:00',3.09),('16273','2013-07-05','09:55:00',3.16),('16273','2013-07-05','10:00:00',3.18),('16273','2013-07-05','10:05:00',3.24),('16273','2013-07-05','10:10:00',3.28),('16273','2013-07-05','10:15:00',3.29),('16273','2013-07-05','10:20:00',3.32),('16273','2013-07-05','10:25:00',3.37),('16273','2013-07-05','10:30:00',3.41),('16273','2013-07-05','10:35:00',3.44),('16273','2013-07-05','10:40:00',3.48),('16273','2013-07-05','10:45:00',3.5),('16273','2013-07-05','10:50:00',3.54),('16273','2013-07-05','10:55:00',3.57),('16273','2013-07-05','11:00:00',3.58),('16273','2013-07-05','11:05:00',3.61),('16273','2013-07-05','11:10:00',3.66),('16273','2013-07-05','11:15:00',3.69),('16273','2013-07-05','11:20:00',3.7),('16273','2013-07-05','11:25:00',3.69),('16273','2013-07-05','11:30:00',3.73),('16273','2013-07-05','11:35:00',3.76),('16273','2013-07-05','11:40:00',3.75),('16273','2013-07-05','11:45:00',3.74),('16273','2013-07-05','11:50:00',3.79),('16273','2013-07-05','11:55:00',3.75),('16273','2013-07-05','12:00:00',3.78),('16273','2013-07-05','12:05:00',3.79),('16273','2013-07-05','12:10:00',3.83),('16273','2013-07-05','12:15:00',3.85),('16273','2013-07-05','12:20:00',3.64),('16273','2013-07-05','12:25:00',3.59),('16273','2013-07-05','12:30:00',3.8),('16273','2013-07-05','12:35:00',3.65),('16273','2013-07-05','12:40:00',2.83),('16273','2013-07-05','12:45:00',2.18),('16273','2013-07-05','12:50:00',3.33),('16273','2013-07-05','12:55:00',3.19),('16273','2013-07-05','13:05:00',1.46),('16273','2013-07-05','13:10:00',4.22),('16273','2013-07-05','13:15:00',4.1),('16273','2013-07-05','13:20:00',4.07),('16273','2013-07-05','13:25:00',3.97),('16273','2013-07-05','13:30:00',3.92),('16273','2013-07-05','13:35:00',3.95),('16273','2013-07-05','13:40:00',3.85),('16273','2013-07-05','13:45:00',3.8),('16273','2013-07-05','13:50:00',3.72),('16273','2013-07-05','13:55:00',3.77),('16273','2013-07-05','14:00:00',3.75),('16273','2013-07-05','14:05:00',3.76),('16273','2013-07-05','14:10:00',3.76),('16273','2013-07-05','14:15:00',3.74),('16273','2013-07-05','14:20:00',3.67),('16273','2013-07-05','14:25:00',3.61),('16273','2013-07-05','14:30:00',3.6),('16273','2013-07-05','14:35:00',3.52),('16273','2013-07-05','14:40:00',3.52),('16273','2013-07-05','14:45:00',3.49),('16273','2013-07-05','14:50:00',3.43),('16273','2013-07-05','14:55:00',3.41),('16273','2013-07-05','15:00:00',3.36),('16273','2013-07-05','15:05:00',3.3),('16273','2013-07-05','15:10:00',3.4),('16273','2013-07-05','15:15:00',3.32),('16273','2013-07-05','15:20:00',3.07),('16273','2013-07-05','15:25:00',2.96),('16273','2013-07-05','15:30:00',2.48),('16273','2013-07-05','15:35:00',2.01),('16273','2013-07-05','15:40:00',2.05),('16273','2013-07-05','15:45:00',2.99),('16273','2013-07-05','15:50:00',2.93),('16273','2013-07-05','15:55:00',2.84),('16273','2013-07-05','16:00:00',2.75),('16273','2013-07-05','16:05:00',2.69),('16273','2013-07-05','16:10:00',2.32),('16273','2013-07-05','16:15:00',1.46),('16273','2013-07-05','16:20:00',1.92),('16273','2013-07-05','16:25:00',1.53),('16273','2013-07-05','16:30:00',2.38),('16273','2013-07-05','16:35:00',2.25),('16273','2013-07-05','16:40:00',2.21),('16273','2013-07-05','16:45:00',2.17),('16273','2013-07-05','16:50:00',2.11),('16273','2013-07-05','16:55:00',2.01),('16273','2013-07-05','17:00:00',1.63),('16273','2013-07-05','17:05:00',1.84),('16273','2013-07-05','17:10:00',1.51),('16273','2013-07-05','17:15:00',1.35),('16273','2013-07-05','17:20:00',1.13),('16273','2013-07-05','17:35:00',1.23),('16273','2013-07-05','17:40:00',1.32),('16273','2013-07-05','17:45:00',1.27),('16273','2013-07-05','17:50:00',1.19),('16273','2013-07-05','17:55:00',1.11),('16273','2013-07-05','18:00:00',1.06),('16273','2013-07-05','18:05:00',1.02),('16273','2013-07-05','18:10:00',1.03),('16273','2013-07-05','18:15:00',1.03),('16273','2013-07-04','11:00:00',1.03),('16273','2013-07-04','11:05:00',1.05),('16273','2013-07-04','11:10:00',1.1),('16273','2013-07-04','11:15:00',1.22),('16273','2013-07-04','11:20:00',1.36),('16273','2013-07-04','11:25:00',1.38),('16273','2013-07-04','11:30:00',1.37),('16273','2013-07-04','11:35:00',1.39),('16273','2013-07-04','11:40:00',1.41),('16273','2013-07-04','11:45:00',1.15),('16273','2013-07-04','11:50:00',1.19),('16273','2013-07-04','11:55:00',1.26),('16273','2013-07-04','12:00:00',1.39),('16273','2013-07-04','12:05:00',1.46),('16273','2013-07-04','12:10:00',1.3),('16273','2013-07-04','12:15:00',1.15),('16273','2013-07-04','12:20:00',1.04),('16273','2013-07-04','12:25:00',1.22),('16273','2013-07-04','12:30:00',1.08),('16273','2013-07-04','12:40:00',1.03),('16273','2013-07-04','12:45:00',1.04),('16273','2013-07-04','12:50:00',1.14),('16273','2013-07-04','12:55:00',1.28),('16273','2013-07-04','13:00:00',1.42),('16273','2013-07-04','13:05:00',1.94),('16273','2013-07-04','13:10:00',2.36),('16273','2013-07-04','13:15:00',2.37),('16273','2013-07-04','13:20:00',1.6),('16273','2013-07-04','13:25:00',1.42),('16273','2013-07-04','13:30:00',2.3),('16273','2013-07-04','13:35:00',4.15),('16273','2013-07-04','13:40:00',3),('16273','2013-07-04','13:45:00',3.14),('16273','2013-07-04','13:50:00',1.63),('16273','2013-07-04','13:55:00',1.66),('16273','2013-07-04','14:00:00',1.58),('16273','2013-07-04','14:05:00',1.39),('16273','2013-07-04','14:10:00',1.27),('16273','2013-07-04','14:15:00',1.22),('16273','2013-07-04','14:20:00',1.18),('16273','2013-07-04','14:25:00',1.22),('16273','2013-07-04','14:30:00',1.25),('16273','2013-07-04','14:35:00',1.29),('16273','2013-07-04','14:40:00',1.28),('16273','2013-07-04','14:45:00',1.39),('16273','2013-07-04','14:50:00',1.78),('16273','2013-07-04','14:55:00',1.26),('16273','2013-07-04','15:00:00',1.31),('16273','2013-07-04','15:05:00',1.34),('16273','2013-07-04','15:10:00',2.53),('16273','2013-07-04','15:15:00',1.97),('16273','2013-07-04','15:20:00',3.46),('16273','2013-07-04','15:25:00',3.2),('16273','2013-07-04','15:30:00',2.96),('16273','2013-07-04','15:35:00',2.54),('16273','2013-07-04','15:40:00',1.9),('16273','2013-07-04','15:45:00',1.63),('16273','2013-07-04','15:50:00',1.64),('16273','2013-07-04','15:55:00',1.82),('16273','2013-07-04','16:00:00',1.97),('16273','2013-07-04','16:05:00',1.77),('16273','2013-07-04','16:10:00',1.84),('16273','2013-07-04','16:15:00',1.61),('16273','2013-07-04','16:20:00',2.23),('16273','2013-07-04','16:25:00',1.99),('16273','2013-07-04','16:30:00',1.87),('16273','2013-07-04','16:35:00',1.64),('16273','2013-07-04','16:40:00',1.56),('16273','2013-07-04','16:45:00',1.46),('16273','2013-07-04','16:50:00',1.37),('16273','2013-07-04','16:55:00',1.63),('16273','2013-07-04','17:00:00',1.64),('16273','2013-07-04','17:05:00',1.29),('16273','2013-07-04','17:10:00',1.23),('16273','2013-07-04','17:15:00',1.43),('16273','2013-07-04','17:20:00',1.64),('16273','2013-07-04','17:25:00',1.94),('16273','2013-07-04','17:30:00',1.86),('16273','2013-07-04','17:35:00',1.58),('16273','2013-07-04','17:40:00',1.09),('16273','2013-07-04','17:45:00',1.07),('16273','2013-07-04','17:50:00',1.39),('16273','2013-07-04','17:55:00',1.3),('16273','2013-07-04','18:00:00',1.25),('16273','2013-07-04','18:05:00',1.02),('16273','2013-07-04','18:15:00',1.01),('16273','2013-07-03','07:10:00',1),('16273','2013-07-03','07:15:00',1.09),('16273','2013-07-03','07:20:00',1.16),('16273','2013-07-03','07:25:00',1.26),('16273','2013-07-03','07:30:00',1.31),('16273','2013-07-03','07:35:00',1.4),('16273','2013-07-03','07:40:00',1.49),('16273','2013-07-03','07:45:00',1.57),('16273','2013-07-03','07:50:00',1.66),('16273','2013-07-03','07:55:00',1.73),('16273','2013-07-03','08:00:00',1.82),('16273','2013-07-03','08:05:00',1.91),('16273','2013-07-03','08:10:00',1.98),('16273','2013-07-03','08:15:00',2.07),('16273','2013-07-03','08:20:00',2.14),('16273','2013-07-03','08:25:00',2.23),('16273','2013-07-03','08:30:00',2.28),('16273','2013-07-03','08:35:00',2.36),('16273','2013-07-03','08:40:00',2.41),('16273','2013-07-03','08:45:00',2.47),('16273','2013-07-03','08:50:00',2.5),('16273','2013-07-03','08:55:00',2.6),('16273','2013-07-03','09:00:00',2.67),('16273','2013-07-03','09:05:00',2.73),('16273','2013-07-03','09:10:00',2.75),('16273','2013-07-03','09:15:00',2.83),('16273','2013-07-03','09:20:00',2.9),('16273','2013-07-03','09:25:00',2.93),('16273','2013-07-03','09:30:00',2.96),('16273','2013-07-03','09:35:00',2.99),('16273','2013-07-03','09:40:00',3.03),('16273','2013-07-03','09:45:00',3.03),('16273','2013-07-03','09:50:00',3.13),('16273','2013-07-03','09:55:00',3.15),('16273','2013-07-03','10:00:00',3.28),('16273','2013-07-03','10:05:00',3.35),('16273','2013-07-03','10:10:00',3.41),('16273','2013-07-03','10:15:00',3.43),('16273','2013-07-03','10:20:00',3.48),('16273','2013-07-03','10:25:00',3.51),('16273','2013-07-03','10:30:00',3.51),('16273','2013-07-03','10:35:00',3.57),('16273','2013-07-03','10:40:00',3.6),('16273','2013-07-03','10:45:00',3.62),('16273','2013-07-03','10:50:00',3.67),('16273','2013-07-03','10:55:00',3.7),('16273','2013-07-03','11:00:00',3.74),('16273','2013-07-03','11:05:00',3.76),('16273','2013-07-03','11:10:00',3.81),('16273','2013-07-03','11:15:00',3.81),('16273','2013-07-03','11:20:00',3.83),('16273','2013-07-03','11:25:00',3.84),('16273','2013-07-03','11:30:00',3.88),('16273','2013-07-03','11:35:00',3.89),('16273','2013-07-03','11:40:00',3.91),('16273','2013-07-03','11:45:00',3.93),('16273','2013-07-03','11:50:00',3.94),('16273','2013-07-03','11:55:00',3.94),('16273','2013-07-03','12:00:00',3.93),('16273','2013-07-03','12:05:00',3.95),('16273','2013-07-03','12:10:00',3.97),('16273','2013-07-03','12:15:00',3.99),('16273','2013-07-03','12:20:00',4),('16273','2013-07-03','12:25:00',3.98),('16273','2013-07-03','12:30:00',4),('16273','2013-07-03','12:35:00',4.01),('16273','2013-07-03','12:40:00',4.01),('16273','2013-07-03','12:45:00',3.99),('16273','2013-07-03','12:50:00',3.96),('16273','2013-07-03','12:55:00',3.96),('16273','2013-07-03','13:00:00',3.95),('16273','2013-07-03','13:05:00',3.96),('16273','2013-07-03','13:10:00',3.96),('16273','2013-07-03','13:15:00',3.95),('16273','2013-07-03','13:20:00',3.93),('16273','2013-07-03','13:25:00',3.91),('16273','2013-07-03','13:30:00',3.9),('16273','2013-07-03','13:35:00',3.88),('16273','2013-07-03','13:40:00',3.88),('16273','2013-07-03','13:45:00',3.87),('16273','2013-07-03','13:50:00',3.86),('16273','2013-07-03','13:55:00',3.84),('16273','2013-07-03','14:00:00',3.81),('16273','2013-07-03','14:05:00',3.79),('16273','2013-07-03','14:10:00',3.75),('16273','2013-07-03','14:15:00',3.74),('16273','2013-07-03','14:20:00',3.71),('16273','2013-07-03','14:25:00',3.68),('16273','2013-07-03','14:30:00',3.64),('16273','2013-07-03','14:35:00',3.62),('16273','2013-07-03','14:40:00',3.57),('16273','2013-07-03','14:45:00',3.55),('16273','2013-07-03','14:50:00',3.53),('16273','2013-07-03','14:55:00',3.49),('16273','2013-07-03','15:00:00',3.44),('16273','2013-07-03','15:05:00',3.39),('16273','2013-07-03','15:10:00',3.33),('16273','2013-07-03','15:15:00',3.29),('16273','2013-07-03','15:20:00',3.23),('16273','2013-07-03','15:25:00',3.19),('16273','2013-07-03','15:30:00',3.14),('16273','2013-07-03','15:35:00',3.08),('16273','2013-07-03','15:40:00',3.02),('16273','2013-07-03','15:45:00',2.97),('16273','2013-07-03','15:50:00',2.93),('16273','2013-07-03','15:55:00',2.87),('16273','2013-07-03','16:00:00',2.81),('16273','2013-07-03','16:05:00',2.76),('16273','2013-07-03','16:10:00',2.7),('16273','2013-07-03','16:15:00',2.64),('16273','2013-07-03','16:20:00',2.57),('16273','2013-07-03','16:25:00',2.51),('16273','2013-07-03','16:30:00',2.45),('16273','2013-07-03','16:35:00',2.38),('16273','2013-07-03','16:40:00',2.29),('16273','2013-07-03','16:45:00',2.24),('16273','2013-07-03','16:50:00',2.17),('16273','2013-07-03','16:55:00',2.1),('16273','2013-07-03','17:00:00',2.03),('16273','2013-07-03','17:05:00',1.96),('16273','2013-07-03','17:10:00',1.88),('16273','2013-07-03','17:15:00',1.79),('16273','2013-07-03','17:20:00',1.72),('16273','2013-07-03','17:25:00',1.64),('16273','2013-07-03','17:30:00',1.57),('16273','2013-07-03','17:35:00',1.49),('16273','2013-07-03','17:40:00',1.4),('16273','2013-07-03','17:45:00',1.33),('16273','2013-07-03','17:50:00',1.26),('16273','2013-07-03','17:55:00',1.17),('16273','2013-07-03','18:00:00',1.1),('16273','2013-07-03','18:05:00',1.03),('16273','2013-07-02','07:15:00',1.05),('16273','2013-07-02','07:20:00',1.14),('16273','2013-07-02','07:25:00',1.23),('16273','2013-07-02','07:30:00',1.3),('16273','2013-07-02','07:35:00',1.37),('16273','2013-07-02','07:40:00',1.46),('16273','2013-07-02','07:45:00',1.54),('16273','2013-07-02','07:50:00',1.6),('16273','2013-07-02','07:55:00',1.69),('16273','2013-07-02','08:00:00',1.76),('16273','2013-07-02','08:05:00',1.83),('16273','2013-07-02','08:10:00',1.91),('16273','2013-07-02','08:15:00',2),('16273','2013-07-02','08:20:00',2.07),('16273','2013-07-02','08:25:00',2.15),('16273','2013-07-02','08:30:00',2.24),('16273','2013-07-02','08:35:00',2.31),('16273','2013-07-02','08:40:00',2.37),('16273','2013-07-02','08:45:00',2.43),('16273','2013-07-02','08:50:00',2.47),('16273','2013-07-02','08:55:00',2.55),('16273','2013-07-02','09:00:00',2.62),('16273','2013-07-02','09:05:00',2.67),('16273','2013-07-02','09:10:00',2.73),('16273','2013-07-02','09:15:00',2.79),('16273','2013-07-02','09:20:00',2.85),('16273','2013-07-02','09:25:00',2.89),('16273','2013-07-02','09:30:00',2.92),('16273','2013-07-02','09:35:00',2.98),('16273','2013-07-02','09:40:00',3.03),('16273','2013-07-02','09:45:00',3.07),('16273','2013-07-02','09:50:00',3.12),('16273','2013-07-02','09:55:00',3.15),('16273','2013-07-02','10:00:00',3.19),('16273','2013-07-02','10:05:00',3.25),('16273','2013-07-02','10:10:00',3.27),('16273','2013-07-02','10:15:00',3.32),('16273','2013-07-02','10:20:00',3.35),('16273','2013-07-02','10:25:00',3.38),('16273','2013-07-02','10:30:00',3.41),('16273','2013-07-02','10:35:00',3.43),('16273','2013-07-02','10:40:00',3.48),('16273','2013-07-02','10:45:00',3.51),('16273','2013-07-02','10:50:00',3.53),('16273','2013-07-02','10:55:00',3.57),('16273','2013-07-02','11:00:00',3.64),('16273','2013-07-02','11:05:00',3.63),('16273','2013-07-02','11:10:00',3.63),('16273','2013-07-02','11:15:00',3.64),('16273','2013-07-02','11:20:00',3.63),('16273','2013-07-02','11:25:00',3.65),('16273','2013-07-02','11:30:00',3.71),('16273','2013-07-02','11:35:00',3.72),('16273','2013-07-02','11:40:00',3.78),('16273','2013-07-02','11:45:00',3.78),('16273','2013-07-02','11:50:00',3.78),('16273','2013-07-02','11:55:00',3.62),('16273','2013-07-02','12:00:00',3.71),('16273','2013-07-02','12:05:00',3.95),('16273','2013-07-02','12:10:00',3.8),('16273','2013-07-02','12:15:00',3.83),('16273','2013-07-02','12:20:00',3.8),('16273','2013-07-02','12:25:00',3.85),('16273','2013-07-02','12:30:00',3.88),('16273','2013-07-02','12:35:00',3.89),('16273','2013-07-02','12:40:00',3.89),('16273','2013-07-02','12:45:00',3.89),('16273','2013-07-02','12:50:00',3.9),('16273','2013-07-02','12:55:00',3.92),('16273','2013-07-02','13:00:00',3.87),('16273','2013-07-02','13:05:00',3.84),('16273','2013-07-02','13:10:00',3.86),('16273','2013-07-02','13:15:00',3.82),('16273','2013-07-02','13:20:00',3.77),('16273','2013-07-02','13:25:00',3.81),('16273','2013-07-02','13:30:00',3.84),('16273','2013-07-02','13:35:00',3.76),('16273','2013-07-02','13:40:00',3.77),('16273','2013-07-02','13:45:00',3.75),('16273','2013-07-02','13:50:00',3.74),('16273','2013-07-02','13:55:00',3.71),('16273','2013-07-02','14:00:00',3.7),('16273','2013-07-02','14:05:00',3.66),('16273','2013-07-02','14:10:00',3.66),('16273','2013-07-02','14:15:00',3.63),('16273','2013-07-02','14:20:00',3.62),('16273','2013-07-02','14:25:00',3.6),('16273','2013-07-02','14:30:00',3.55),('16273','2013-07-02','14:35:00',3.53),('16273','2013-07-02','14:40:00',3.51),('16273','2013-07-02','14:45:00',3.47),('16273','2013-07-02','14:50:00',3.38),('16273','2013-07-02','14:55:00',3.39),('16273','2013-07-02','15:00:00',3.35),('16273','2013-07-02','15:05:00',3.32),('16273','2013-07-02','15:10:00',3.29),('16273','2013-07-02','15:15:00',3.25),('16273','2013-07-02','15:20:00',3.18),('16273','2013-07-02','15:25:00',3.13),('16273','2013-07-02','15:30:00',3.09),('16273','2013-07-02','15:35:00',3.05),('16273','2013-07-02','15:40:00',3),('16273','2013-07-02','15:45:00',2.95),('16273','2013-07-02','15:50:00',2.89),('16273','2013-07-02','15:55:00',2.83),('16273','2013-07-02','16:00:00',2.76),('16273','2013-07-02','16:05:00',2.71),('16273','2013-07-02','16:10:00',2.64),('16273','2013-07-02','16:15:00',2.59),('16273','2013-07-02','16:20:00',2.53),('16273','2013-07-02','16:25:00',2.46),('16273','2013-07-02','16:30:00',2.4),('16273','2013-07-02','16:35:00',2.33),('16273','2013-07-02','16:40:00',2.25),('16273','2013-07-02','16:45:00',2.19),('16273','2013-07-02','16:50:00',2.12),('16273','2013-07-02','16:55:00',2.05),('16273','2013-07-02','17:00:00',1.98),('16273','2013-07-02','17:05:00',1.9),('16273','2013-07-02','17:10:00',1.82),('16273','2013-07-02','17:15:00',1.75),('16273','2013-07-02','17:20:00',1.67),('16273','2013-07-02','17:25:00',1.59),('16273','2013-07-02','17:30:00',1.52),('16273','2013-07-02','17:35:00',1.45),('16273','2013-07-02','17:40:00',1.37),('16273','2013-07-02','17:45:00',1.3),('16273','2013-07-02','17:50:00',1.22),('16273','2013-07-02','17:55:00',1.14),('16273','2013-07-02','18:00:00',1.08),('16273','2013-07-02','18:05:00',1.01),('16273','2013-07-01','07:15:00',1.08),('16273','2013-07-01','07:20:00',1.17),('16273','2013-07-01','07:25:00',1.26),('16273','2013-07-01','07:30:00',1.32),('16273','2013-07-01','07:35:00',1.41),('16273','2013-07-01','07:40:00',1.5),('16273','2013-07-01','07:45:00',1.59),('16273','2013-07-01','07:50:00',1.68),('16273','2013-07-01','07:55:00',1.77),('16273','2013-07-01','08:00:00',1.85),('16273','2013-07-01','08:05:00',1.91),('16273','2013-07-01','08:10:00',1.98),('16273','2013-07-01','08:15:00',2.06),('16273','2013-07-01','08:20:00',2.11),('16273','2013-07-01','08:25:00',2.21),('16273','2013-07-01','08:30:00',2.28),('16273','2013-07-01','08:35:00',2.34),('16273','2013-07-01','08:40:00',2.41),('16273','2013-07-01','08:45:00',2.49),('16273','2013-07-01','08:50:00',2.55),('16273','2013-07-01','08:55:00',2.62),('16273','2013-07-01','09:00:00',2.7),('16273','2013-07-01','09:05:00',2.76),('16273','2013-07-01','09:10:00',2.83),('16273','2013-07-01','09:15:00',2.89),('16273','2013-07-01','09:20:00',2.94),('16273','2013-07-01','09:25:00',2.99),('16273','2013-07-01','09:30:00',3.04),('16273','2013-07-01','09:35:00',3.07),('16273','2013-07-01','09:40:00',3.14),('16273','2013-07-01','09:45:00',3.18),('16273','2013-07-01','09:50:00',3.22),('16273','2013-07-01','09:55:00',3.24),('16273','2013-07-01','10:00:00',3.28),('16273','2013-07-01','10:05:00',3.31),('16273','2013-07-01','10:10:00',3.39),('16273','2013-07-01','10:15:00',3.44),('16273','2013-07-01','10:20:00',3.52),('16273','2013-07-01','10:25:00',3.52),('16273','2013-07-01','10:30:00',3.55),('16273','2013-07-01','10:35:00',3.58),('16273','2013-07-01','10:40:00',3.64),('16273','2013-07-01','10:45:00',3.66),('16273','2013-07-01','10:50:00',3.69),('16273','2013-07-01','10:55:00',3.71),('16273','2013-07-01','11:00:00',3.75),('16273','2013-07-01','11:05:00',3.78),('16273','2013-07-01','11:10:00',3.79),('16273','2013-07-01','11:15:00',3.81),('16273','2013-07-01','11:20:00',3.79),('16273','2013-07-01','11:25:00',3.82),('16273','2013-07-01','11:30:00',3.82),('16273','2013-07-01','11:35:00',3.86),('16273','2013-07-01','11:40:00',3.86),('16273','2013-07-01','11:45:00',3.86),('16273','2013-07-01','11:50:00',3.87),('16273','2013-07-01','11:55:00',3.91),('16273','2013-07-01','12:00:00',3.9),('16273','2013-07-01','12:05:00',3.88),('16273','2013-07-01','12:10:00',3.86),('16273','2013-07-01','12:15:00',3.88),('16273','2013-07-01','12:20:00',3.87),('16273','2013-07-01','12:25:00',3.88),('16273','2013-07-01','12:30:00',3.91),('16273','2013-07-01','12:35:00',3.86),('16273','2013-07-01','12:40:00',3.91),('16273','2013-07-01','12:45:00',3.9),('16273','2013-07-01','12:50:00',3.94),('16273','2013-07-01','12:55:00',3.93),('16273','2013-07-01','13:00:00',3.92),('16273','2013-07-01','13:05:00',3.93),('16273','2013-07-01','13:10:00',3.91),('16273','2013-07-01','13:15:00',3.9),('16273','2013-07-01','13:20:00',3.91),('16273','2013-07-01','13:25:00',3.87),('16273','2013-07-01','13:30:00',3.79),('16273','2013-07-01','13:35:00',3.82),('16273','2013-07-01','13:40:00',3.8),('16273','2013-07-01','13:45:00',3.76),('16273','2013-07-01','13:50:00',3.73),('16273','2013-07-01','13:55:00',3.73),('16273','2013-07-01','14:00:00',3.7),('16273','2013-07-01','14:05:00',3.65),('16273','2013-07-01','14:10:00',3.64),('16273','2013-07-01','14:15:00',3.66),('16273','2013-07-01','14:20:00',3.65),('16273','2013-07-01','14:25:00',3.63),('16273','2013-07-01','14:30:00',3.59),('16273','2013-07-01','14:35:00',3.56),('16273','2013-07-01','14:40:00',3.51),('16273','2013-07-01','14:45:00',3.5),('16273','2013-07-01','14:50:00',3.45),('16273','2013-07-01','14:55:00',3.42),('16273','2013-07-01','15:00:00',3.37),('16273','2013-07-01','15:05:00',3.33),('16273','2013-07-01','15:10:00',3.27),('16273','2013-07-01','15:15:00',3.24),('16273','2013-07-01','15:20:00',3.2),('16273','2013-07-01','15:25:00',3.16),('16273','2013-07-01','15:30:00',3.1),('16273','2013-07-01','15:35:00',3.04),('16273','2013-07-01','15:40:00',2.98),('16273','2013-07-01','15:45:00',2.94),('16273','2013-07-01','15:50:00',2.88),('16273','2013-07-01','15:55:00',2.82),('16273','2013-07-01','16:00:00',2.75),('16273','2013-07-01','16:05:00',2.53),('16273','2013-07-01','16:10:00',2.53),('16273','2013-07-01','16:15:00',2.57),('16273','2013-07-01','16:20:00',2.49),('16273','2013-07-01','16:25:00',2.42),('16273','2013-07-01','16:30:00',2.38),('16273','2013-07-01','16:35:00',2.3),('16273','2013-07-01','16:40:00',2.24),('16273','2013-07-01','16:45:00',2.2),('16273','2013-07-01','16:50:00',2.12),('16273','2013-07-01','16:55:00',2.04),('16273','2013-07-01','17:00:00',1.97),('16273','2013-07-01','17:05:00',1.88),('16273','2013-07-01','17:10:00',1.8),('16273','2013-07-01','17:15:00',1.74),('16273','2013-07-01','17:20:00',1.66),('16273','2013-07-01','17:25:00',1.58),('16273','2013-07-01','17:30:00',1.52),('16273','2013-07-01','17:35:00',1.45),('16273','2013-07-01','17:40:00',1.38),('16273','2013-07-01','17:45:00',1.3),('16273','2013-07-01','17:50:00',1.23),('16273','2013-07-01','17:55:00',1.15),('16273','2013-07-01','18:00:00',1.06),('16273','2013-07-01','18:05:00',1),('16273','2014-04-05','08:40:00',1.46),('16273','2014-04-05','08:45:00',1.23),('16273','2014-04-05','08:50:00',1.21),('16273','2014-04-05','09:20:00',1.04),('16273','2014-04-05','09:25:00',1.33),('16273','2014-04-05','09:30:00',1.82),('16273','2014-04-05','09:35:00',1.72),('16273','2014-04-05','09:40:00',1.55),('16273','2014-04-05','09:45:00',1.7),('16273','2014-04-05','09:50:00',2.15),('16273','2014-04-05','09:55:00',2.84),('16273','2014-04-05','10:00:00',1.96),('16273','2014-04-05','10:05:00',1.66),('16273','2014-04-05','10:10:00',1.66),('16273','2014-04-05','10:15:00',1.77),('16273','2014-04-05','10:20:00',1.71),('16273','2014-04-05','10:25:00',2.11),('16273','2014-04-05','10:30:00',2.99),('16273','2014-04-05','10:35:00',3.2),('16273','2014-04-05','10:40:00',3.73),('16273','2014-04-05','10:45:00',3.81),('16273','2014-04-05','10:50:00',3.76),('16273','2014-04-05','10:55:00',3.7),('16273','2014-04-05','11:00:00',3.57),('16273','2014-04-05','11:05:00',3.54),('16273','2014-04-05','11:10:00',3.41),('16273','2014-04-05','11:15:00',3.24),('16273','2014-04-05','11:20:00',2.66),('16273','2014-04-05','11:25:00',2.46),('16273','2014-04-05','11:30:00',3.03),('16273','2014-04-05','11:35:00',3.39),('16273','2014-04-05','11:40:00',3.8),('16273','2014-04-05','11:45:00',4.06),('16273','2014-04-05','11:50:00',4.08),('16273','2014-04-05','11:55:00',3.57),('16273','2014-04-05','12:00:00',3.51),('16273','2014-04-05','12:05:00',3.2),('16273','2014-04-05','12:10:00',2.81),('16273','2014-04-05','12:15:00',2.87),('16273','2014-04-05','12:20:00',2.54),('16273','2014-04-05','12:25:00',2.33),('16273','2014-04-05','12:30:00',2.18),('16273','2014-04-05','12:35:00',2.09),('16273','2014-04-05','12:40:00',2.04),('16273','2014-04-05','12:45:00',1.94),('16273','2014-04-05','12:50:00',1.96),('16273','2014-04-05','12:55:00',1.78),('16273','2014-04-05','13:00:00',2.13),('16273','2014-04-05','13:05:00',2.47),('16273','2014-04-05','13:10:00',2.66),('16273','2014-04-05','13:15:00',2.54),('16273','2014-04-05','13:20:00',3.55),('16273','2014-04-05','13:25:00',2.18),('16273','2014-04-05','13:30:00',2.63),('16273','2014-04-05','13:35:00',2.95),('16273','2014-04-05','13:40:00',3.09),('16273','2014-04-05','13:45:00',2.89),('16273','2014-04-05','13:50:00',2.62),('16273','2014-04-05','13:55:00',3.72),('16273','2014-04-05','14:00:00',4.02),('16273','2014-04-05','14:05:00',4.3),('16273','2014-04-05','14:10:00',3.31),('16273','2014-04-05','14:15:00',1.5),('16273','2014-04-05','14:20:00',1.08),('16273','2014-04-05','15:00:00',1.43),('16273','2014-04-05','15:05:00',2.81),('16273','2014-04-05','15:10:00',3.71),('16273','2014-04-05','15:15:00',3.5),('16273','2014-04-05','15:20:00',3.14),('16273','2014-04-05','15:25:00',1.98),('16273','2014-04-05','15:30:00',2.24),('16273','2014-04-05','15:35:00',1.7),('16273','2014-04-05','15:40:00',2.96),('16273','2014-04-05','15:45:00',2.25),('16273','2014-04-05','15:50:00',1.69),('16273','2014-04-05','16:10:00',1.15),('16273','2014-04-05','16:15:00',1.29),('16273','2014-04-05','16:30:00',1.95),('16273','2014-04-05','16:35:00',1.93),('16273','2014-04-05','16:40:00',2.34),('16273','2014-04-05','16:45:00',1.1),('16273','2014-04-05','16:55:00',1.32),('16273','2014-04-05','17:00:00',1.91),('16273','2014-04-05','17:05:00',1.75),('16273','2014-04-05','17:10:00',1.65),('16273','2014-04-05','17:15:00',1.48),('16273','2014-04-05','17:20:00',1.41),('16273','2014-04-05','17:25:00',1.3),('16273','2014-04-05','17:30:00',1.21),('16273','2013-06-30','07:10:00',1.08),('16273','2013-06-30','07:15:00',1.16),('16273','2013-06-30','07:20:00',1.24),('16273','2013-06-30','07:25:00',1.32),('16273','2013-06-30','07:30:00',1.4),('16273','2013-06-30','07:35:00',1.48),('16273','2013-06-30','07:40:00',1.57),('16273','2013-06-30','07:45:00',1.65),('16273','2013-06-30','07:50:00',1.73),('16273','2013-06-30','07:55:00',1.82),('16273','2013-06-30','08:00:00',1.9),('16273','2013-06-30','08:05:00',1.99),('16273','2013-06-30','08:10:00',2.07),('16273','2013-06-30','08:15:00',2.14),('16273','2013-06-30','08:20:00',2.21),('16273','2013-06-30','08:25:00',2.3),('16273','2013-06-30','08:30:00',2.37),('16273','2013-06-30','08:35:00',2.43),('16273','2013-06-30','08:40:00',2.49),('16273','2013-06-30','08:45:00',2.56),('16273','2013-06-30','08:50:00',2.62),('16273','2013-06-30','08:55:00',2.69),('16273','2013-06-30','09:00:00',2.74),('16273','2013-06-30','09:05:00',2.81),('16273','2013-06-30','09:10:00',2.87),('16273','2013-06-30','09:15:00',2.94),('16273','2013-06-30','09:20:00',3),('16273','2013-06-30','09:25:00',3.05),('16273','2013-06-30','09:30:00',3.11),('16273','2013-06-30','09:35:00',3.15),('16273','2013-06-30','09:40:00',3.2),('16273','2013-06-30','09:45:00',3.26),('16273','2013-06-30','09:50:00',3.31),('16273','2013-06-30','09:55:00',3.33),('16273','2013-06-30','10:00:00',3.38),('16273','2013-06-30','10:05:00',3.41),('16273','2013-06-30','10:10:00',3.47),('16273','2013-06-30','10:15:00',3.5),('16273','2013-06-30','10:20:00',3.53),('16273','2013-06-30','10:25:00',3.57),('16273','2013-06-30','10:30:00',3.61),('16273','2013-06-30','10:35:00',3.64),('16273','2013-06-30','10:40:00',3.65),('16273','2013-06-30','10:45:00',3.68),('16273','2013-06-30','10:50:00',3.7),('16273','2013-06-30','10:55:00',3.74),('16273','2013-06-30','11:00:00',3.76),('16273','2013-06-30','11:05:00',3.79),('16273','2013-06-30','11:10:00',3.78),('16273','2013-06-30','11:15:00',3.79),('16273','2013-06-30','11:20:00',3.8),('16273','2013-06-30','11:25:00',3.83),('16273','2013-06-30','11:30:00',3.83),('16273','2013-06-30','11:35:00',3.84),('16273','2013-06-30','11:40:00',3.88),('16273','2013-06-30','11:45:00',3.9),('16273','2013-06-30','11:50:00',3.91),('16273','2013-06-30','11:55:00',3.87),('16273','2013-06-30','12:00:00',3.9),('16273','2013-06-30','12:05:00',3.96),('16273','2013-06-30','12:10:00',3.35),('16273','2013-06-30','12:15:00',3.49),('16273','2013-06-30','12:20:00',4.06),('16273','2013-06-30','12:25:00',4.04),('16273','2013-06-30','12:30:00',4.03),('16273','2013-06-30','12:35:00',4.03),('16273','2013-06-30','12:40:00',4.01),('16273','2013-06-30','12:45:00',4.18),('16273','2013-06-30','12:50:00',3.94),('16273','2013-06-30','12:55:00',4.17),('16273','2013-06-30','13:00:00',4.1),('16273','2013-06-30','13:05:00',4.29),('16273','2013-06-30','13:10:00',3.91),('16273','2013-06-30','13:15:00',3.87),('16273','2013-06-30','13:20:00',3.58),('16273','2013-06-30','13:25:00',4.25),('16273','2013-06-30','13:30:00',3.77),('16273','2013-06-30','13:35:00',2.57),('16273','2013-06-30','13:40:00',1.86),('16273','2013-06-30','13:45:00',3.96),('16273','2013-06-30','13:50:00',3.97),('16273','2013-06-30','13:55:00',3.86),('16273','2013-06-30','14:00:00',3.89),('16273','2013-06-30','14:05:00',3.82),('16273','2013-06-30','14:10:00',3.77),('16273','2013-06-30','14:15:00',3.7),('16273','2013-06-30','14:20:00',3.68),('16273','2013-06-30','14:25:00',3.66),('16273','2013-06-30','14:30:00',3.57),('16273','2013-06-30','14:35:00',3.56),('16273','2013-06-30','14:40:00',3.53),('16273','2013-06-30','14:45:00',3.51),('16273','2013-06-30','14:50:00',3.45),('16273','2013-06-30','14:55:00',3.47),('16273','2013-06-30','15:00:00',3.42),('16273','2013-06-30','15:05:00',3.38),('16273','2013-06-30','15:10:00',3.35),('16273','2013-06-30','15:15:00',3.31),('16273','2013-06-30','15:20:00',3.27),('16273','2013-06-30','15:25:00',3.22),('16273','2013-06-30','15:30:00',3.19),('16273','2013-06-30','15:35:00',3.14),('16273','2013-06-30','15:40:00',3.08),('16273','2013-06-30','15:45:00',2.99),('16273','2013-06-30','15:50:00',2.95),('16273','2013-06-30','15:55:00',2.77),('16273','2013-06-30','16:00:00',2.6),('16273','2013-06-30','16:05:00',2.74),('16273','2013-06-30','16:10:00',2.16),('16273','2013-06-30','16:15:00',2.72),('16273','2013-06-30','16:20:00',2.63),('16273','2013-06-30','16:25:00',2.55),('16273','2013-06-30','16:30:00',2.48),('16273','2013-06-30','16:35:00',2.38),('16273','2013-06-30','16:40:00',2.32),('16273','2013-06-30','16:45:00',2.22),('16273','2013-06-30','16:50:00',2.16),('16273','2013-06-30','16:55:00',2.07),('16273','2013-06-30','17:00:00',2.01),('16273','2013-06-30','17:05:00',1.92),('16273','2013-06-30','17:10:00',1.84),('16273','2013-06-30','17:15:00',1.76),('16273','2013-06-30','17:20:00',1.7),('16273','2013-06-30','17:25:00',1.59),('16273','2013-06-30','17:30:00',1.54),('16273','2013-06-30','17:35:00',1.47),('16273','2013-06-30','17:40:00',1.36),('16273','2013-06-30','17:45:00',1.32),('16273','2013-06-30','17:50:00',1.25),('16273','2013-06-30','17:55:00',1.16),('16273','2013-06-30','18:00:00',1.1),('16273','2013-06-30','18:05:00',1.04),('16273','2013-06-29','07:20:00',1.35),('16273','2013-06-29','07:25:00',1.18),('16273','2013-06-29','07:30:00',1.4),('16273','2013-06-29','07:45:00',1.22),('16273','2013-06-29','07:50:00',1.8),('16273','2013-06-29','07:55:00',1.79),('16273','2013-06-29','08:15:00',1.17),('16273','2013-06-29','08:20:00',2.24),('16273','2013-06-29','08:25:00',2.29),('16273','2013-06-29','08:30:00',2.43),('16273','2013-06-29','08:35:00',2.46),('16273','2013-06-29','08:40:00',2.53),('16273','2013-06-29','08:45:00',2.58),('16273','2013-06-29','08:50:00',2.64),('16273','2013-06-29','08:55:00',2.69),('16273','2013-06-29','09:00:00',2.74),('16273','2013-06-29','09:05:00',2.82),('16273','2013-06-29','09:10:00',2.89),('16273','2013-06-29','09:15:00',2.93),('16273','2013-06-29','09:20:00',2.95),('16273','2013-06-29','09:25:00',3.03),('16273','2013-06-29','09:30:00',3.04),('16273','2013-06-29','09:35:00',3.12),('16273','2013-06-29','09:40:00',3.19),('16273','2013-06-29','09:45:00',3.22),('16273','2013-06-29','09:50:00',3.27),('16273','2013-06-29','09:55:00',3.32),('16273','2013-06-29','10:00:00',3.36),('16273','2013-06-29','10:05:00',3.38),('16273','2013-06-29','10:10:00',3.44),('16273','2013-06-29','10:15:00',3.47),('16273','2013-06-29','10:20:00',3.54),('16273','2013-06-29','10:25:00',3.55),('16273','2013-06-29','10:30:00',3.52),('16273','2013-06-29','10:35:00',3.6),('16273','2013-06-29','10:40:00',3.72),('16273','2013-06-29','10:45:00',3.78),('16273','2013-06-29','10:50:00',3.86),('16273','2013-06-29','10:55:00',3.95),('16273','2013-06-29','11:00:00',3.93),('16273','2013-06-29','11:05:00',4.03),('16273','2013-06-29','11:10:00',2.76),('16273','2013-06-29','11:25:00',1.98),('16273','2013-06-29','11:30:00',1.83),('16273','2013-06-29','11:35:00',3.07),('16273','2013-06-29','11:40:00',4.27),('16273','2013-06-29','11:45:00',4.22),('16273','2013-06-29','11:50:00',3.57),('16273','2013-06-29','11:55:00',3.91),('16273','2013-06-29','12:00:00',4.08),('16273','2013-06-29','12:05:00',4.07),('16273','2013-06-29','12:10:00',4.12),('16273','2013-06-29','12:15:00',4.21),('16273','2013-06-29','12:20:00',3.27),('16273','2013-06-29','12:25:00',4.1),('16273','2013-06-29','12:30:00',1.16),('16273','2013-06-29','12:35:00',1.77),('16273','2013-06-29','12:40:00',2.86),('16273','2013-06-29','12:45:00',2.77),('16273','2013-06-29','12:50:00',1.38),('16273','2013-06-29','12:55:00',1.47),('16273','2013-06-29','13:00:00',2.68),('16273','2013-06-29','13:05:00',1.31),('16273','2013-06-29','13:10:00',4.37),('16273','2013-06-29','13:15:00',4.16),('16273','2013-06-29','13:20:00',3.98),('16273','2013-06-29','13:25:00',4.33),('16273','2013-06-29','13:30:00',4.37),('16273','2013-06-29','13:35:00',3.73),('16273','2013-06-29','13:40:00',4.06),('16273','2013-06-29','13:45:00',3.99),('16273','2013-06-29','13:50:00',3.98),('16273','2013-06-29','13:55:00',3.96),('16273','2013-06-29','14:00:00',3.9),('16273','2013-06-29','14:05:00',3.87),('16273','2013-06-29','14:10:00',3.87),('16273','2013-06-29','14:15:00',3.94),('16273','2013-06-29','14:20:00',3.94),('16273','2013-06-29','14:25:00',3.86),('16273','2013-06-29','14:30:00',3.86),('16273','2013-06-29','14:35:00',3.85),('16273','2013-06-29','14:40:00',3.79),('16273','2013-06-29','14:45:00',3.79),('16273','2013-06-29','14:50:00',3.77),('16273','2013-06-29','14:55:00',3.8),('16273','2013-06-29','15:00:00',3.72),('16273','2013-06-29','15:05:00',3.85),('16273','2013-06-29','15:10:00',3.9),('16273','2013-06-29','15:15:00',3.17),('16273','2013-06-29','15:20:00',2.57),('16273','2013-06-29','15:25:00',1.42),('16273','2013-06-29','15:30:00',1.43),('16273','2013-06-29','15:35:00',2.07),('16273','2013-06-29','15:40:00',2.25),('16273','2013-06-29','15:45:00',1.19),('16273','2013-06-29','16:15:00',1.06),('16273','2013-06-29','16:20:00',1.14),('16273','2013-06-29','16:25:00',1.3),('16273','2013-06-29','16:30:00',1.89),('16273','2013-06-29','16:35:00',2.41),('16273','2013-06-29','16:40:00',2.61),('16273','2013-06-29','16:45:00',1.98),('16273','2013-06-29','16:50:00',1.64),('16273','2013-06-29','16:55:00',1.84),('16273','2013-06-29','17:00:00',2.05),('16273','2013-06-29','17:05:00',2.61),('16273','2013-06-29','17:10:00',2.01),('16273','2013-06-29','17:15:00',2.43),('16273','2013-06-29','17:20:00',1.77),('16273','2013-06-29','17:25:00',1.23),('16273','2013-06-29','17:30:00',1.63),('16273','2013-06-29','17:35:00',1.09),('16273','2013-06-29','17:40:00',1.57),('16273','2013-06-29','17:45:00',1.49),('16273','2013-06-29','17:50:00',1.34),('16273','2013-06-29','17:55:00',1.22),('16273','2013-06-29','18:05:00',1.01),('16273','2013-06-29','18:10:00',1.03),('16273','2013-06-29','18:15:00',1.14),('16273','2013-06-28','07:10:00',1.12),('16273','2013-06-28','07:15:00',1.02),('16273','2013-06-28','07:25:00',1.38),('16273','2013-06-28','07:30:00',1.25),('16273','2013-06-28','07:35:00',1.55),('16273','2013-06-28','07:40:00',1.55),('16273','2013-06-28','07:45:00',1.53),('16273','2013-06-28','07:50:00',1.44),('16273','2013-06-28','07:55:00',1.51),('16273','2013-06-28','08:00:00',1.89),('16273','2013-06-28','08:05:00',1.93),('16273','2013-06-28','08:10:00',1.97),('16273','2013-06-28','08:15:00',2),('16273','2013-06-28','08:20:00',2.11),('16273','2013-06-28','08:25:00',2.33),('16273','2013-06-28','08:30:00',2.28),('16273','2013-06-28','08:35:00',2.19),('16273','2013-06-28','08:40:00',2.62),('16273','2013-06-28','08:45:00',2.42),('16273','2013-06-28','08:50:00',2.71),('16273','2013-06-28','08:55:00',2.68),('16273','2013-06-28','09:00:00',2.26),('16273','2013-06-28','09:05:00',2.86),('16273','2013-06-28','09:10:00',3),('16273','2013-06-28','09:15:00',3.15),('16273','2013-06-28','09:20:00',1.93),('16273','2013-06-28','09:25:00',2.39),('16273','2013-06-28','09:30:00',1.9),('16273','2013-06-28','09:35:00',2.09),('16273','2013-06-28','09:40:00',2.27),('16273','2013-06-28','09:45:00',3.5),('16273','2013-06-28','09:50:00',3.63),('16273','2013-06-28','09:55:00',3.45),('16273','2013-06-28','10:00:00',3.13),('16273','2013-06-28','10:05:00',3.41),('16273','2013-06-28','10:10:00',3.74),('16273','2013-06-28','10:15:00',3.7),('16273','2013-06-28','10:20:00',3.76),('16273','2013-06-28','10:25:00',3.83),('16273','2013-06-28','10:30:00',2.72),('16273','2013-06-28','10:35:00',2.37),('16273','2013-06-28','10:40:00',1.12),('16273','2013-06-28','10:45:00',3.12),('16273','2013-06-28','10:50:00',3.92),('16273','2013-06-28','10:55:00',3.95),('16273','2013-06-28','11:00:00',3.72),('16273','2013-06-28','11:05:00',3.75),('16273','2013-06-28','11:10:00',3.38),('16273','2013-06-28','11:15:00',3.32),('16273','2013-06-28','11:20:00',4.01),('16273','2013-06-28','11:25:00',3.71),('16273','2013-06-28','11:30:00',3.8),('16273','2013-06-28','11:35:00',3.84),('16273','2013-06-28','11:40:00',2.78),('16273','2013-06-28','11:45:00',3.28),('16273','2013-06-28','11:50:00',2.84),('16273','2013-06-28','11:55:00',2.69),('16273','2013-06-28','12:00:00',4.39),('16273','2013-06-28','12:05:00',2.95),('16273','2013-06-28','12:10:00',3.81),('16273','2013-06-28','12:15:00',3.7),('16273','2013-06-28','12:20:00',3.87),('16273','2013-06-28','12:25:00',4.31),('16273','2013-06-28','12:30:00',4.13),('16273','2013-06-28','12:35:00',4.17),('16273','2013-06-28','12:40:00',3.17),('16273','2013-06-28','12:45:00',3.65),('16273','2013-06-28','12:50:00',4.04),('16273','2013-06-28','12:55:00',4.25),('16273','2013-06-28','13:00:00',4.19),('16273','2013-06-28','13:05:00',3.85),('16273','2013-06-28','13:10:00',4.18),('16273','2013-06-28','13:15:00',3.57),('16273','2013-06-28','13:20:00',4.06),('16273','2013-06-28','13:25:00',4.11),('16273','2013-06-28','13:30:00',3.52),('16273','2013-06-28','13:35:00',4.09),('16273','2013-06-28','13:40:00',4.13),('16273','2013-06-28','13:45:00',3.24),('16273','2013-06-28','13:50:00',3.92),('16273','2013-06-28','13:55:00',4.05),('16273','2013-06-28','14:00:00',3.99),('16273','2013-06-28','14:05:00',4.07),('16273','2013-06-28','14:10:00',2.83),('16273','2013-06-28','14:15:00',4.2),('16273','2013-06-28','14:20:00',3.98),('16273','2013-06-28','14:25:00',4.04),('16273','2013-06-28','14:30:00',3.38),('16273','2013-06-28','14:35:00',3.95),('16273','2013-06-28','14:40:00',2.36),('16273','2013-06-28','14:45:00',3.78),('16273','2013-06-28','14:50:00',3.55),('16273','2013-06-28','14:55:00',2.99),('16273','2013-06-28','15:00:00',3.71),('16273','2013-06-28','15:05:00',3.35),('16273','2013-06-28','15:10:00',3.45),('16273','2013-06-28','15:15:00',3.15),('16273','2013-06-28','15:20:00',1.51),('16273','2013-06-28','15:25:00',3.65),('16273','2013-06-28','15:30:00',2.36),('16273','2013-06-28','15:35:00',3.62),('16273','2013-06-28','15:40:00',3.17),('16273','2013-06-28','15:45:00',2.52),('16273','2013-06-28','15:50:00',2.93),('16273','2013-06-28','15:55:00',3.19),('16273','2013-06-28','16:00:00',1.7),('16273','2013-06-28','16:05:00',2.16),('16273','2013-06-28','16:10:00',2.02),('16273','2013-06-28','16:15:00',2.66),('16273','2013-06-28','16:20:00',1.8),('16273','2013-06-28','16:25:00',1.78),('16273','2013-06-28','16:30:00',2.39),('16273','2013-06-28','16:35:00',2.66),('16273','2013-06-28','16:40:00',2.33),('16273','2013-06-28','16:45:00',2.26),('16273','2013-06-28','16:50:00',2.48),('16273','2013-06-28','16:55:00',1.8),('16273','2013-06-28','17:00:00',2.01),('16273','2013-06-28','17:05:00',1.79),('16273','2013-06-28','17:10:00',1.88),('16273','2013-06-28','17:15:00',1.79),('16273','2013-06-28','17:20:00',1.72),('16273','2013-06-28','17:25:00',1.63),('16273','2013-06-28','17:30:00',1.57),('16273','2013-06-28','17:35:00',1.5),('16273','2013-06-28','17:40:00',1.42),('16273','2013-06-28','17:45:00',1.35),('16273','2013-06-28','17:50:00',1.26),('16273','2013-06-28','17:55:00',1.19),('16273','2013-06-28','18:00:00',1.12),('16273','2013-06-28','18:05:00',1.09),('16273','2013-06-27','07:15:00',1.13),('16273','2013-06-27','07:20:00',1.22),('16273','2013-06-27','07:25:00',1.3),('16273','2013-06-27','07:30:00',1.4),('16273','2013-06-27','07:35:00',1.5),('16273','2013-06-27','07:40:00',1.58),('16273','2013-06-27','07:45:00',1.66),('16273','2013-06-27','07:50:00',1.74),('16273','2013-06-27','07:55:00',1.81),('16273','2013-06-27','08:00:00',1.91),('16273','2013-06-27','08:05:00',1.95),('16273','2013-06-27','08:10:00',2.02),('16273','2013-06-27','08:15:00',2.14),('16273','2013-06-27','08:20:00',2.23),('16273','2013-06-27','08:25:00',2.27),('16273','2013-06-27','08:30:00',2.31),('16273','2013-06-27','08:35:00',2.39),('16273','2013-06-27','08:40:00',2.44),('16273','2013-06-27','08:45:00',2.53),('16273','2013-06-27','08:50:00',2.67),('16273','2013-06-27','08:55:00',2.75),('16273','2013-06-27','09:00:00',2.76),('16273','2013-06-27','09:05:00',2.82),('16273','2013-06-27','09:10:00',2.89),('16273','2013-06-27','09:15:00',2.97),('16273','2013-06-27','09:20:00',3.06),('16273','2013-06-27','09:25:00',3.15),('16273','2013-06-27','09:30:00',3.18),('16273','2013-06-27','09:35:00',3.2),('16273','2013-06-27','09:40:00',3.2),('16273','2013-06-27','09:45:00',3.25),('16273','2013-06-27','09:50:00',3.31),('16273','2013-06-27','09:55:00',3.31),('16273','2013-06-27','10:00:00',3.37),('16273','2013-06-27','10:05:00',3.43),('16273','2013-06-27','10:10:00',3.44),('16273','2013-06-27','10:15:00',3.49),('16273','2013-06-27','10:20:00',3.64),('16273','2013-06-27','10:25:00',3.79),('16273','2013-06-27','10:30:00',3.94),('16273','2013-06-27','10:35:00',3.47),('16273','2013-06-27','10:40:00',3.77),('16273','2013-06-27','10:45:00',3.44),('16273','2013-06-27','10:50:00',3.97),('16273','2013-06-27','10:55:00',3.78),('16273','2013-06-27','11:00:00',1.58),('16273','2013-06-27','11:05:00',2.35),('16273','2013-06-27','11:10:00',3.38),('16273','2013-06-27','11:15:00',1.16),('16273','2013-06-27','11:20:00',1.36),('16273','2013-06-27','11:25:00',1.76),('16273','2013-06-27','11:30:00',1.92),('16273','2013-06-27','11:35:00',1.43),('16273','2013-06-27','11:40:00',1.41),('16273','2013-06-27','11:45:00',1.4),('16273','2013-06-27','11:50:00',4.03),('16273','2013-06-27','11:55:00',4.47),('16273','2013-06-27','12:00:00',4.42),('16273','2013-06-27','12:05:00',4.46),('16273','2013-06-27','12:10:00',3.39),('16273','2013-06-27','12:15:00',1.73),('16273','2013-06-27','12:20:00',3.28),('16273','2013-06-27','12:25:00',4.08),('16273','2013-06-27','12:30:00',2.22),('16273','2013-06-27','12:35:00',1.28),('16273','2013-06-27','12:40:00',1.47),('16273','2013-06-27','12:45:00',1.57),('16273','2013-06-27','12:50:00',1.64),('16273','2013-06-27','12:55:00',3.96),('16273','2013-06-27','13:00:00',3.86),('16273','2013-06-27','13:05:00',4.22),('16273','2013-06-27','13:10:00',4.15),('16273','2013-06-27','13:15:00',3.28),('16273','2013-06-27','13:20:00',2.86),('16273','2013-06-27','13:25:00',4.35),('16273','2013-06-27','13:30:00',4.34),('16273','2013-06-27','13:35:00',4.27),('16273','2013-06-27','13:40:00',4.16),('16273','2013-06-27','13:45:00',3.75),('16273','2013-06-27','13:50:00',3.92),('16273','2013-06-27','13:55:00',3.83),('16273','2013-06-27','14:00:00',3.76),('16273','2013-06-27','14:05:00',3.74),('16273','2013-06-27','14:10:00',3.7),('16273','2013-06-27','14:15:00',3.68),('16273','2013-06-27','14:20:00',3.69),('16273','2013-06-27','14:25:00',3.68),('16273','2013-06-27','14:30:00',3.69),('16273','2013-06-27','14:35:00',3.65),('16273','2013-06-27','14:40:00',3.69),('16273','2013-06-27','14:45:00',3.6),('16273','2013-06-27','14:50:00',3.44),('16273','2013-06-27','14:55:00',3.4),('16273','2013-06-27','15:00:00',3.37),('16273','2013-06-27','15:05:00',3.34),('16273','2013-06-27','15:10:00',3.3),('16273','2013-06-27','15:15:00',3.26),('16273','2013-06-27','15:20:00',3.24),('16273','2013-06-27','15:25:00',3.2),('16273','2013-06-27','15:30:00',3.14),('16273','2013-06-27','15:35:00',3.07),('16273','2013-06-27','15:40:00',2.98),('16273','2013-06-27','15:45:00',2.94),('16273','2013-06-27','15:50:00',2.86),('16273','2013-06-27','15:55:00',2.78),('16273','2013-06-27','16:00:00',2.72),('16273','2013-06-27','16:05:00',2.69),('16273','2013-06-27','16:10:00',2.65),('16273','2013-06-27','16:15:00',2.6),('16273','2013-06-27','16:20:00',2.55),('16273','2013-06-27','16:25:00',2.46),('16273','2013-06-27','16:30:00',2.34),('16273','2013-06-27','16:35:00',2.32),('16273','2013-06-27','16:40:00',2.27),('16273','2013-06-27','16:45:00',2.17),('16273','2013-06-27','16:50:00',2.14),('16273','2013-06-27','16:55:00',2.06),('16273','2013-06-27','17:00:00',1.95),('16273','2013-06-27','17:05:00',1.86),('16273','2013-06-27','17:10:00',1.8),('16273','2013-06-27','17:15:00',1.8),('16273','2013-06-27','17:20:00',1.73),('16273','2013-06-27','17:25:00',1.67),('16273','2013-06-27','17:30:00',1.57),('16273','2013-06-27','17:35:00',1.49),('16273','2013-06-27','17:40:00',1.42),('16273','2013-06-27','17:45:00',1.36),('16273','2013-06-27','17:50:00',1.26),('16273','2013-06-27','17:55:00',1.19),('16273','2013-06-27','18:00:00',1.13),('16273','2013-06-27','18:05:00',1.07),('16273','2013-06-26','07:05:00',1.01),('16273','2013-06-26','07:10:00',1.09),('16273','2013-06-26','07:15:00',1.17),('16273','2013-06-26','07:20:00',1.25),('16273','2013-06-26','07:25:00',1.32),('16273','2013-06-26','07:30:00',1.41),('16273','2013-06-26','07:35:00',1.48),('16273','2013-06-26','07:40:00',1.57),('16273','2013-06-26','07:45:00',1.66),('16273','2013-06-26','07:50:00',1.72),('16273','2013-06-26','07:55:00',1.78),('16273','2013-06-26','08:00:00',1.87),('16273','2013-06-26','08:05:00',1.97),('16273','2013-06-26','08:10:00',2.04),('16273','2013-06-26','08:15:00',2.11),('16273','2013-06-26','08:20:00',2.2),('16273','2013-06-26','08:25:00',2.27),('16273','2013-06-26','08:30:00',2.31),('16273','2013-06-26','08:35:00',2.39),('16273','2013-06-26','08:40:00',2.48),('16273','2013-06-26','08:45:00',2.53),('16273','2013-06-26','08:50:00',2.59),('16273','2013-06-26','08:55:00',2.66),('16273','2013-06-26','09:00:00',2.7),('16273','2013-06-26','09:05:00',2.76),('16273','2013-06-26','09:10:00',2.81),('16273','2013-06-26','09:15:00',2.87),('16273','2013-06-26','09:20:00',2.91),('16273','2013-06-26','09:25:00',2.99),('16273','2013-06-26','09:30:00',3.04),('16273','2013-06-26','09:35:00',3.07),('16273','2013-06-26','09:40:00',3.11),('16273','2013-06-26','09:45:00',3.14),('16273','2013-06-26','09:50:00',3.18),('16273','2013-06-26','09:55:00',3.25),('16273','2013-06-26','10:00:00',3.29),('16273','2013-06-26','10:05:00',3.37),('16273','2013-06-26','10:10:00',3.44),('16273','2013-06-26','10:15:00',3.46),('16273','2013-06-26','10:20:00',3.48),('16273','2013-06-26','10:25:00',3.52),('16273','2013-06-26','10:30:00',3.53),('16273','2013-06-26','10:35:00',3.55),('16273','2013-06-26','10:40:00',3.59),('16273','2013-06-26','10:45:00',3.63),('16273','2013-06-26','10:50:00',3.66),('16273','2013-06-26','10:55:00',3.68),('16273','2013-06-26','11:00:00',3.68),('16273','2013-06-26','11:05:00',3.71),('16273','2013-06-26','11:10:00',3.75),('16273','2013-06-26','11:15:00',3.78),('16273','2013-06-26','11:20:00',3.78),('16273','2013-06-26','11:25:00',3.81),('16273','2013-06-26','11:30:00',3.82),('16273','2013-06-26','11:35:00',3.83),('16273','2013-06-26','11:40:00',3.87),('16273','2013-06-26','11:45:00',3.91),('16273','2013-06-26','11:50:00',3.94),('16273','2013-06-26','11:55:00',3.9),('16273','2013-06-26','12:00:00',3.91),('16273','2013-06-26','12:05:00',3.95),('16273','2013-06-26','12:10:00',3.95),('16273','2013-06-26','12:15:00',3.98),('16273','2013-06-26','12:20:00',3.97),('16273','2013-06-26','12:25:00',4.04),('16273','2013-06-26','12:30:00',4.02),('16273','2013-06-26','12:35:00',4.03),('16273','2013-06-26','12:40:00',4.07),('16273','2013-06-26','12:45:00',4.11),('16273','2013-06-26','12:50:00',4.11),('16273','2013-06-26','12:55:00',4.14),('16273','2013-06-26','13:00:00',4.16),('16273','2013-06-26','13:05:00',4.22),('16273','2013-06-26','13:10:00',2.81),('16273','2013-06-26','13:15:00',1.05),('16273','2013-06-26','13:20:00',1.48),('16273','2013-06-26','13:25:00',4.41),('16273','2013-06-26','13:30:00',4.13),('16273','2013-06-26','13:35:00',4.01),('16273','2013-06-26','13:40:00',3.98),('16273','2013-06-26','13:45:00',3.93),('16273','2013-06-26','13:50:00',3.82),('16273','2013-06-26','13:55:00',3.8),('16273','2013-06-26','14:00:00',3.76),('16273','2013-06-26','14:05:00',3.72),('16273','2013-06-26','14:10:00',3.71),('16273','2013-06-26','14:15:00',3.66),('16273','2013-06-26','14:20:00',3.65),('16273','2013-06-26','14:25:00',3.63),('16273','2013-06-26','14:30:00',3.63),('16273','2013-06-26','14:35:00',3.6),('16273','2013-06-26','14:40:00',3.56),('16273','2013-06-26','14:45:00',3.52),('16273','2013-06-26','14:50:00',3.47),('16273','2013-06-26','14:55:00',3.44),('16273','2013-06-26','15:00:00',3.38),('16273','2013-06-26','15:05:00',3.34),('16273','2013-06-26','15:10:00',3.27),('16273','2013-06-26','15:15:00',3.25),('16273','2013-06-26','15:20:00',3.18),('16273','2013-06-26','15:25:00',3.16),('16273','2013-06-26','15:30:00',3.11),('16273','2013-06-26','15:35:00',3.06),('16273','2013-06-26','15:40:00',3.01),('16273','2013-06-26','15:45:00',2.95),('16273','2013-06-26','15:50:00',2.88),('16273','2013-06-26','15:55:00',2.83),('16273','2013-06-26','16:00:00',2.78),('16273','2013-06-26','16:05:00',2.73),('16273','2013-06-26','16:10:00',2.68),('16273','2013-06-26','16:15:00',2.62),('16273','2013-06-26','16:20:00',2.55),('16273','2013-06-26','16:25:00',2.48),('16273','2013-06-26','16:30:00',2.43),('16273','2013-06-26','16:35:00',2.34),('16273','2013-06-26','16:40:00',2.27),('16273','2013-06-26','16:45:00',2.22),('16273','2013-06-26','16:50:00',2.13),('16273','2013-06-26','16:55:00',2.06),('16273','2013-06-26','17:00:00',1.98),('16273','2013-06-26','17:05:00',1.91),('16273','2013-06-26','17:10:00',1.85),('16273','2013-06-26','17:15:00',1.77),('16273','2013-06-26','17:20:00',1.7),('16273','2013-06-26','17:25:00',1.63),('16273','2013-06-26','17:30:00',1.57),('16273','2013-06-26','17:35:00',1.48),('16273','2013-06-26','17:40:00',1.41),('16273','2013-06-26','17:45:00',1.33),('16273','2013-06-26','17:50:00',1.27),('16273','2013-06-26','17:55:00',1.19),('16273','2013-06-26','18:00:00',1.11),('16273','2013-06-26','18:05:00',1.04),('16273','2013-06-26','18:25:00',1.01),('16273','2013-06-25','07:10:00',1.04),('16273','2013-06-25','07:15:00',1.12),('16273','2013-06-25','07:20:00',1.03),('16273','2013-06-25','07:30:00',1.36),('16273','2013-06-25','07:35:00',1.46),('16273','2013-06-25','07:40:00',1.52),('16273','2013-06-25','07:45:00',1.63),('16273','2013-06-25','07:50:00',1.66),('16273','2013-06-25','07:55:00',1.65),('16273','2013-06-25','08:05:00',1.99),('16273','2013-06-25','08:10:00',2.08),('16273','2013-06-25','08:15:00',2.12),('16273','2013-06-25','08:20:00',2.22),('16273','2013-06-25','08:25:00',2.31),('16273','2013-06-25','08:30:00',2.34),('16273','2013-06-25','08:35:00',2.41),('16273','2013-06-25','08:40:00',2.52),('16273','2013-06-25','08:45:00',2.55),('16273','2013-06-25','08:50:00',2.63),('16273','2013-06-25','08:55:00',2.66),('16273','2013-06-25','09:00:00',2.65),('16273','2013-06-25','09:05:00',2.74),('16273','2013-06-25','09:10:00',2.91),('16273','2013-06-25','09:15:00',1.83),('16273','2013-06-25','09:20:00',1.06),('16273','2013-06-25','09:25:00',1.58),('16273','2013-06-25','09:30:00',1.1),('16273','2013-06-25','09:35:00',2.84),('16273','2013-06-25','09:40:00',3.53),('16273','2013-06-25','09:45:00',3.58),('16273','2013-06-25','09:50:00',3.55),('16273','2013-06-25','09:55:00',3.12),('16273','2013-06-25','10:00:00',2.18),('16273','2013-06-25','10:05:00',1.36),('16273','2013-06-25','10:10:00',1.04),('16273','2013-06-25','10:15:00',1.41),('16273','2013-06-25','10:20:00',2.37),('16273','2013-06-25','10:25:00',1.19),('16273','2013-06-25','10:30:00',2.02),('16273','2013-06-25','10:35:00',3.81),('16273','2013-06-25','10:40:00',3.9),('16273','2013-06-25','10:45:00',3.92),('16273','2013-06-25','10:50:00',3.87),('16273','2013-06-25','10:55:00',3.92),('16273','2013-06-25','11:00:00',3.99),('16273','2013-06-25','11:05:00',4.02),('16273','2013-06-25','11:10:00',4.07),('16273','2013-06-25','11:15:00',4.11),('16273','2013-06-25','11:20:00',3.6),('16273','2013-06-25','11:25:00',4.19),('16273','2013-06-25','11:30:00',4.3),('16273','2013-06-25','11:35:00',3.4),('16273','2013-06-25','11:40:00',2.92),('16273','2013-06-25','11:45:00',2.59),('16273','2013-06-25','11:50:00',3.22),('16273','2013-06-25','11:55:00',3.59),('16273','2013-06-25','12:00:00',4.48),('16273','2013-06-25','12:05:00',3.82),('16273','2013-06-25','12:10:00',3.61),('16273','2013-06-25','12:15:00',1.75),('16273','2013-06-25','12:20:00',2.86),('16273','2013-06-25','12:25:00',3.11),('16273','2013-06-25','12:30:00',3.99),('16273','2013-06-25','12:35:00',4.32),('16273','2013-06-25','12:40:00',3.47),('16273','2013-06-25','12:45:00',3.15),('16273','2013-06-25','12:50:00',2.54),('16273','2013-06-25','12:55:00',4.25),('16273','2013-06-25','13:00:00',4.15),('16273','2013-06-25','13:05:00',4.13),('16273','2013-06-25','13:10:00',4.04),('16273','2013-06-25','13:15:00',4.04),('16273','2013-06-25','13:20:00',3.99),('16273','2013-06-25','13:25:00',3.98),('16273','2013-06-25','13:30:00',3.97),('16273','2013-06-25','13:35:00',3.95),('16273','2013-06-25','13:40:00',3.92),('16273','2013-06-25','13:45:00',3.9),('16273','2013-06-25','13:50:00',3.87),('16273','2013-06-25','13:55:00',3.85),('16273','2013-06-25','14:00:00',3.83),('16273','2013-06-25','14:05:00',3.8),('16273','2013-06-25','14:10:00',3.75),('16273','2013-06-25','14:15:00',3.72),('16273','2013-06-25','14:20:00',3.7),('16273','2013-06-25','14:25:00',3.66),('16273','2013-06-25','14:30:00',3.64),('16273','2013-06-25','14:35:00',3.59),('16273','2013-06-25','14:40:00',3.55),('16273','2013-06-25','14:45:00',3.51),('16273','2013-06-25','14:50:00',3.5),('16273','2013-06-25','14:55:00',3.45),('16273','2013-06-25','15:00:00',3.41),('16273','2013-06-25','15:05:00',3.35),('16273','2013-06-25','15:10:00',3.33),('16273','2013-06-25','15:15:00',3.28),('16273','2013-06-25','15:20:00',3.22),('16273','2013-06-25','15:25:00',3.17),('16273','2013-06-25','15:30:00',3.12),('16273','2013-06-25','15:35:00',3.06),('16273','2013-06-25','15:40:00',3.01),('16273','2013-06-25','15:45:00',2.95),('16273','2013-06-25','15:50:00',2.89),('16273','2013-06-25','15:55:00',2.83),('16273','2013-06-25','16:00:00',2.76),('16273','2013-06-25','16:05:00',2.72),('16273','2013-06-25','16:10:00',2.65),('16273','2013-06-25','16:15:00',2.58),('16273','2013-06-25','16:20:00',2.5),('16273','2013-06-25','16:25:00',2.46),('16273','2013-06-25','16:30:00',2.38),('16273','2013-06-25','16:35:00',2.31),('16273','2013-06-25','16:40:00',2.25),('16273','2013-06-25','16:45:00',2.19),('16273','2013-06-25','16:50:00',2.11),('16273','2013-06-25','16:55:00',2.04),('16273','2013-06-25','17:00:00',1.97),('16273','2013-06-25','17:05:00',1.9),('16273','2013-06-25','17:10:00',1.82),('16273','2013-06-25','17:15:00',1.75),('16273','2013-06-25','17:20:00',1.68),('16273','2013-06-25','17:25:00',1.6),('16273','2013-06-25','17:30:00',1.52),('16273','2013-06-25','17:35:00',1.44),('16273','2013-06-25','17:40:00',1.37),('16273','2013-06-25','17:45:00',1.3),('16273','2013-06-25','17:50:00',1.23),('16273','2013-06-25','17:55:00',1.15),('16273','2013-06-25','18:00:00',1.08),('16273','2013-06-25','18:05:00',1.01),('16273','2013-06-24','07:05:00',1.01),('16273','2013-06-24','08:10:00',1.52),('16273','2013-06-24','08:15:00',2.32),('16273','2013-06-24','08:20:00',2.31),('16273','2013-06-24','08:25:00',2.27),('16273','2013-06-24','08:30:00',1.26),('16273','2013-06-24','08:35:00',2.33),('16273','2013-06-24','08:40:00',2.49),('16273','2013-06-24','08:45:00',2.65),('16273','2013-06-24','08:50:00',2.92),('16273','2013-06-24','08:55:00',2.48),('16273','2013-06-24','09:00:00',1.02),('16273','2013-06-24','09:05:00',1.24),('16273','2013-06-24','09:10:00',1.4),('16273','2013-06-24','09:15:00',2.33),('16273','2013-06-24','09:20:00',1.72),('16273','2013-06-24','09:25:00',3.25),('16273','2013-06-24','09:30:00',3.41),('16273','2013-06-24','09:35:00',3.12),('16273','2013-06-24','09:40:00',3.39),('16273','2013-06-24','09:45:00',3.41),('16273','2013-06-24','09:50:00',3.43),('16273','2013-06-24','09:55:00',3.51),('16273','2013-06-24','10:00:00',3.68),('16273','2013-06-24','10:05:00',2.26),('16273','2013-06-24','10:10:00',2.74),('16273','2013-06-24','10:15:00',3.66),('16273','2013-06-24','10:20:00',4.05),('16273','2013-06-24','10:25:00',3.33),('16273','2013-06-24','10:30:00',2.96),('16273','2013-06-24','10:35:00',4.22),('16273','2013-06-24','10:40:00',2.82),('16273','2013-06-24','10:45:00',1.79),('16273','2013-06-24','10:50:00',1.62),('16273','2013-06-24','10:55:00',2.23),('16273','2013-06-24','11:00:00',3.97),('16273','2013-06-24','11:05:00',1.76),('16273','2013-06-24','11:10:00',2.33),('16273','2013-06-24','11:15:00',1.63),('16273','2013-06-24','11:20:00',1.19),('16273','2013-06-24','11:25:00',1.16),('16273','2013-06-24','11:30:00',1.37),('16273','2013-06-24','11:35:00',1.38),('16273','2013-06-24','11:40:00',2.13),('16273','2013-06-24','11:45:00',1.97),('16273','2013-06-24','11:50:00',3.49),('16273','2013-06-24','11:55:00',2.68),('16273','2013-06-24','12:00:00',3.72),('16273','2013-06-24','12:05:00',3.69),('16273','2013-06-24','12:10:00',1.26),('16273','2013-06-24','12:15:00',4.09),('16273','2013-06-24','12:20:00',4.48),('16273','2013-06-24','12:25:00',3.9),('16273','2013-06-24','12:30:00',3.38),('16273','2013-06-24','12:35:00',2.48),('16273','2013-06-24','12:40:00',3.09),('16273','2013-06-24','12:45:00',3.71),('16273','2013-06-24','12:50:00',4.46),('16273','2013-06-24','12:55:00',1.97),('16273','2013-06-24','13:00:00',3.09),('16273','2013-06-24','13:05:00',3.9),('16273','2013-06-24','13:10:00',3.85),('16273','2013-06-24','13:15:00',2.6),('16273','2013-06-24','13:20:00',3.15),('16273','2013-06-24','13:25:00',3.09),('16273','2013-06-24','13:30:00',3.45),('16273','2013-06-24','13:35:00',4.06),('16273','2013-06-24','13:40:00',3.78),('16273','2013-06-24','13:45:00',3.44),('16273','2013-06-24','13:50:00',4.12),('16273','2013-06-24','13:55:00',4.14),('16273','2013-06-24','14:00:00',3.52),('16273','2013-06-24','14:05:00',3.88),('16273','2013-06-24','14:10:00',3.84),('16273','2013-06-24','14:15:00',3.94),('16273','2013-06-24','14:20:00',3.71),('16273','2013-06-24','14:25:00',3.1),('16273','2013-06-24','14:30:00',3.12),('16273','2013-06-24','14:35:00',4.14),('16273','2013-06-24','14:40:00',3.02),('16273','2013-06-24','14:45:00',3.31),('16273','2013-06-24','14:50:00',2.52),('16273','2013-06-24','14:55:00',3.14),('16273','2013-06-24','15:00:00',3.86),('16273','2013-06-24','15:05:00',2.38),('16273','2013-06-24','15:10:00',3.26),('16273','2013-06-24','15:15:00',2.61),('16273','2013-06-24','15:20:00',2.92),('16273','2013-06-24','15:25:00',2.9),('16273','2013-06-24','15:30:00',1.66),('16273','2013-06-24','15:35:00',3.44),('16273','2013-06-24','15:40:00',3.5),('16273','2013-06-24','15:45:00',3.42),('16273','2013-06-24','15:50:00',3.67),('16273','2013-06-24','15:55:00',1.71),('16273','2013-06-24','16:00:00',2.3),('16273','2013-06-24','16:05:00',1.69),('16273','2013-06-24','16:10:00',1.65),('16273','2013-06-24','16:15:00',2.84),('16273','2013-06-24','16:25:00',1.77),('16273','2013-06-24','16:30:00',1.51),('16273','2013-06-24','16:35:00',2.07),('16273','2013-06-24','16:40:00',1.71),('16273','2013-06-24','16:45:00',1.15),('16273','2013-06-24','16:50:00',1.09),('16273','2013-06-24','16:55:00',1.01),('16273','2013-06-24','17:00:00',1.16),('16273','2013-06-24','17:05:00',1.48),('16273','2013-06-24','17:10:00',1.97),('16273','2013-06-24','17:15:00',1.34),('16273','2013-06-24','17:20:00',1.95),('16273','2013-06-24','17:25:00',1.55),('16273','2013-06-24','17:35:00',1.71),('16273','2013-06-24','17:45:00',1.2),('16273','2013-06-24','18:00:00',1.03),('16273','2013-06-23','08:45:00',1.22),('16273','2013-06-23','08:50:00',1.16),('16273','2013-06-23','08:55:00',1.2),('16273','2013-06-23','09:05:00',1.03),('16273','2013-06-23','09:10:00',2.06),('16273','2013-06-23','09:15:00',2.85),('16273','2013-06-23','09:20:00',3.05),('16273','2013-06-23','09:25:00',2.71),('16273','2013-06-23','09:30:00',2.54),('16273','2013-06-23','09:35:00',3.13),('16273','2013-06-23','09:40:00',2.1),('16273','2013-06-23','09:45:00',3.42),('16273','2013-06-23','09:50:00',3.32),('16273','2013-06-23','09:55:00',3.37),('16273','2013-06-23','10:00:00',3.39),('16273','2013-06-23','10:05:00',3.41),('16273','2013-06-23','10:10:00',3.04),('16273','2013-06-23','10:15:00',3.14),('16273','2013-06-23','10:20:00',3.38),('16273','2013-06-23','10:25:00',3.49),('16273','2013-06-23','10:30:00',3.4),('16273','2013-06-23','10:35:00',3.48),('16273','2013-06-23','10:40:00',3.51),('16273','2013-06-23','10:45:00',3.6),('16273','2013-06-23','10:50:00',3.65),('16273','2013-06-23','10:55:00',3.69),('16273','2013-06-23','11:00:00',3.71),('16273','2013-06-23','11:05:00',3.69),('16273','2013-06-23','11:10:00',3.71),('16273','2013-06-23','11:15:00',3.74),('16273','2013-06-23','11:20:00',3.68),('16273','2013-06-23','11:25:00',3.75),('16273','2013-06-23','11:30:00',3.81),('16273','2013-06-23','11:35:00',3.82),('16273','2013-06-23','11:40:00',3.79),('16273','2013-06-23','11:45:00',3.84),('16273','2013-06-23','11:50:00',3.86),('16273','2013-06-23','11:55:00',3.86),('16273','2013-06-23','12:00:00',3.92),('16273','2013-06-23','12:05:00',3.94),('16273','2013-06-23','12:10:00',3.96),('16273','2013-06-23','12:15:00',3.91),('16273','2013-06-23','12:20:00',3.95),('16273','2013-06-23','12:25:00',3.97),('16273','2013-06-23','12:30:00',3.99),('16273','2013-06-23','12:35:00',3.98),('16273','2013-06-23','12:40:00',3.97),('16273','2013-06-23','12:45:00',3.98),('16273','2013-06-23','12:50:00',3.94),('16273','2013-06-23','12:55:00',3.94),('16273','2013-06-23','13:00:00',3.94),('16273','2013-06-23','13:05:00',3.96),('16273','2013-06-23','13:10:00',3.95),('16273','2013-06-23','13:15:00',3.93),('16273','2013-06-23','13:20:00',3.94),('16273','2013-06-23','13:25:00',3.9),('16273','2013-06-23','13:30:00',3.92),('16273','2013-06-23','13:35:00',3.9),('16273','2013-06-23','13:40:00',3.88),('16273','2013-06-23','13:45:00',3.9),('16273','2013-06-23','13:50:00',3.9),('16273','2013-06-23','13:55:00',3.87),('16273','2013-06-23','14:00:00',3.85),('16273','2013-06-23','14:05:00',3.82),('16273','2013-06-23','14:10:00',3.81),('16273','2013-06-23','14:15:00',3.79),('16273','2013-06-23','14:20:00',3.74),('16273','2013-06-23','14:25:00',3.7),('16273','2013-06-23','14:30:00',3.67),('16273','2013-06-23','14:35:00',3.65),('16273','2013-06-23','14:40:00',3.61),('16273','2013-06-23','14:45:00',3.56),('16273','2013-06-23','14:50:00',3.52),('16273','2013-06-23','14:55:00',3.49),('16273','2013-06-23','15:00:00',3.26),('16273','2013-06-23','15:05:00',3.41),('16273','2013-06-23','15:10:00',3.35),('16273','2013-06-23','15:15:00',3.32),('16273','2013-06-23','15:20:00',3.24),('16273','2013-06-23','15:25:00',3.22),('16273','2013-06-23','15:30:00',3.16),('16273','2013-06-23','15:35:00',3.1),('16273','2013-06-23','15:40:00',3.05),('16273','2013-06-23','15:45:00',2.99),('16273','2013-06-23','15:50:00',2.94),('16273','2013-06-23','15:55:00',2.88),('16273','2013-06-23','16:00:00',2.81),('16273','2013-06-23','16:05:00',2.74),('16273','2013-06-23','16:10:00',2.69),('16273','2013-06-23','16:15:00',2.64),('16273','2013-06-23','16:20:00',2.58),('16273','2013-06-23','16:25:00',2.51),('16273','2013-06-23','16:30:00',2.42),('16273','2013-06-23','16:35:00',2.37),('16273','2013-06-23','16:40:00',2.3),('16273','2013-06-23','16:45:00',2.22),('16273','2013-06-23','16:50:00',2.15),('16273','2013-06-23','16:55:00',2.08),('16273','2013-06-23','17:00:00',2.01),('16273','2013-06-23','17:05:00',1.88),('16273','2013-06-23','17:10:00',1.68),('16273','2013-06-23','17:15:00',1.73),('16273','2013-06-23','17:20:00',1.71),('16273','2013-06-23','17:25:00',1.64),('16273','2013-06-23','17:30:00',1.55),('16273','2013-06-23','17:35:00',1.48),('16273','2013-06-23','17:40:00',1.41),('16273','2013-06-23','17:45:00',1.32),('16273','2013-06-23','17:50:00',1.25),('16273','2013-06-23','17:55:00',1.2),('16273','2013-06-23','18:00:00',1.1),('16273','2013-06-23','18:05:00',1.01),('16273','2013-06-22','07:10:00',1.01),('16273','2013-06-22','07:15:00',1.08),('16273','2013-06-22','07:20:00',1.13),('16273','2013-06-22','07:25:00',1.21),('16273','2013-06-22','07:30:00',1.25),('16273','2013-06-22','07:35:00',1.33),('16273','2013-06-22','07:40:00',1.41),('16273','2013-06-22','07:45:00',1.51),('16273','2013-06-22','07:50:00',1.61),('16273','2013-06-22','07:55:00',1.68),('16273','2013-06-22','08:00:00',1.72),('16273','2013-06-22','08:05:00',1.79),('16273','2013-06-22','08:10:00',1.89),('16273','2013-06-22','08:15:00',1.96),('16273','2013-06-22','08:20:00',2.04),('16273','2013-06-22','08:25:00',2.08),('16273','2013-06-22','08:30:00',2.18),('16273','2013-06-22','08:35:00',2.26),('16273','2013-06-22','08:40:00',2.34),('16273','2013-06-22','08:45:00',2.41),('16273','2013-06-22','08:50:00',2.49),('16273','2013-06-22','08:55:00',2.55),('16273','2013-06-22','09:00:00',2.6),('16273','2013-06-22','09:05:00',2.64),('16273','2013-06-22','09:10:00',2.7),('16273','2013-06-22','09:15:00',2.74),('16273','2013-06-22','09:20:00',2.83),('16273','2013-06-22','09:25:00',2.89),('16273','2013-06-22','09:30:00',2.95),('16273','2013-06-22','09:35:00',3.01),('16273','2013-06-22','09:40:00',3.04),('16273','2013-06-22','09:45:00',3.1),('16273','2013-06-22','09:50:00',3.17),('16273','2013-06-22','09:55:00',3.2),('16273','2013-06-22','10:00:00',3.22),('16273','2013-06-22','10:05:00',3.29),('16273','2013-06-22','10:10:00',3.35),('16273','2013-06-22','10:15:00',3.39),('16273','2013-06-22','10:20:00',3.37),('16273','2013-06-22','10:25:00',3.42),('16273','2013-06-22','10:30:00',3.45),('16273','2013-06-22','10:35:00',3.52),('16273','2013-06-22','10:40:00',3.55),('16273','2013-06-22','10:45:00',3.56),('16273','2013-06-22','10:50:00',3.6),('16273','2013-06-22','10:55:00',3.62),('16273','2013-06-22','11:00:00',3.63),('16273','2013-06-22','11:05:00',3.66),('16273','2013-06-22','11:10:00',3.69),('16273','2013-06-22','11:15:00',3.7),('16273','2013-06-22','11:20:00',3.72),('16273','2013-06-22','11:25:00',3.76),('16273','2013-06-22','11:30:00',3.76),('16273','2013-06-22','11:35:00',3.81),('16273','2013-06-22','11:40:00',3.78),('16273','2013-06-22','11:45:00',3.8),('16273','2013-06-22','11:50:00',3.79),('16273','2013-06-22','11:55:00',3.9),('16273','2013-06-22','12:00:00',3.85),('16273','2013-06-22','12:05:00',3.85),('16273','2013-06-22','12:10:00',3.86),('16273','2013-06-22','12:15:00',3.85),('16273','2013-06-22','12:20:00',3.86),('16273','2013-06-22','12:25:00',3.86),('16273','2013-06-22','12:30:00',3.82),('16273','2013-06-22','12:35:00',3.87),('16273','2013-06-22','12:40:00',3.81),('16273','2013-06-22','12:45:00',3.81),('16273','2013-06-22','12:50:00',3.78),('16273','2013-06-22','12:55:00',3.74),('16273','2013-06-22','13:00:00',3.72),('16273','2013-06-22','13:05:00',3.68),('16273','2013-06-22','13:10:00',3.86),('16273','2013-06-22','13:15:00',3.86),('16273','2013-06-22','13:20:00',3.86),('16273','2013-06-22','13:25:00',3.88),('16273','2013-06-22','13:30:00',3.78),('16273','2013-06-22','13:35:00',3.54),('16273','2013-06-22','13:40:00',3.49),('16273','2013-06-22','13:45:00',3.83),('16273','2013-06-22','13:50:00',2.53),('16273','2013-06-22','13:55:00',3.85),('16273','2013-06-22','14:00:00',4.03),('16273','2013-06-22','14:05:00',3.87),('16273','2013-06-22','14:10:00',3.5),('16273','2013-06-22','14:15:00',2.17),('16273','2013-06-22','14:20:00',3.13),('16273','2013-06-22','14:25:00',2.17),('16273','2013-06-22','14:30:00',1.73),('16273','2013-06-22','14:35:00',1.97),('16273','2013-06-22','14:40:00',2.8),('16273','2013-06-22','14:45:00',3.44),('16273','2013-06-22','14:50:00',3.62),('16273','2013-06-22','14:55:00',3.53),('16273','2013-06-22','15:00:00',3.07),('16273','2013-06-22','15:05:00',3.35),('16273','2013-06-22','15:10:00',3.44),('16273','2013-06-22','15:15:00',3.37),('16273','2013-06-22','15:20:00',3.11),('16273','2013-06-22','15:25:00',3.03),('16273','2013-06-22','15:30:00',2.68),('16273','2013-06-22','15:35:00',2.14),('16273','2013-06-22','15:40:00',1.85),('16273','2013-06-22','15:45:00',1.55),('16273','2013-06-22','15:50:00',1.95),('16273','2013-06-22','15:55:00',1.5),('16273','2013-06-22','16:00:00',1.25),('16273','2013-06-22','16:05:00',1.21),('16273','2013-06-22','16:10:00',1.47),('16273','2013-06-22','16:15:00',1.44),('16273','2013-06-22','16:20:00',1.23),('16273','2013-06-22','16:25:00',1.12),('16273','2013-06-22','16:50:00',1.3),('16273','2013-06-22','16:55:00',1.76),('16273','2013-06-22','17:00:00',1.92),('16273','2013-06-22','17:05:00',1.91),('16273','2013-06-22','17:10:00',2.04),('16273','2013-06-22','17:15:00',2.03),('16273','2013-06-22','17:20:00',2.08),('16273','2013-06-22','17:25:00',1.81),('16273','2013-06-22','17:30:00',1.7),('16273','2013-06-22','17:35:00',1.54),('16273','2013-06-22','17:40:00',1.47),('16273','2013-06-22','17:45:00',1.32),('16273','2013-06-22','17:50:00',1.22),('16273','2013-06-22','17:55:00',1.15),('16273','2013-06-21','07:15:00',1.04),('16273','2013-06-21','07:20:00',1.11),('16273','2013-06-21','07:25:00',1.18),('16273','2013-06-21','07:30:00',1.25),('16273','2013-06-21','07:35:00',1.34),('16273','2013-06-21','07:40:00',1.42),('16273','2013-06-21','07:45:00',1.49),('16273','2013-06-21','07:50:00',1.58),('16273','2013-06-21','07:55:00',1.66),('16273','2013-06-21','08:00:00',1.72),('16273','2013-06-21','08:05:00',1.81),('16273','2013-06-21','08:10:00',1.88),('16273','2013-06-21','08:15:00',1.95),('16273','2013-06-21','08:20:00',2.01),('16273','2013-06-21','08:25:00',2.08),('16273','2013-06-21','08:30:00',2.12),('16273','2013-06-21','08:35:00',2.22),('16273','2013-06-21','08:40:00',2.27),('16273','2013-06-21','08:45:00',2.35),('16273','2013-06-21','08:50:00',2.43),('16273','2013-06-21','08:55:00',2.49),('16273','2013-06-21','09:00:00',2.55),('16273','2013-06-21','09:05:00',2.61),('16273','2013-06-21','09:10:00',2.65),('16273','2013-06-21','09:15:00',2.7),('16273','2013-06-21','09:20:00',2.71),('16273','2013-06-21','09:25:00',2.81),('16273','2013-06-21','09:30:00',2.87),('16273','2013-06-21','09:35:00',2.89),('16273','2013-06-21','09:40:00',2.97),('16273','2013-06-21','09:45:00',3.04),('16273','2013-06-21','09:50:00',3.07),('16273','2013-06-21','09:55:00',3.11),('16273','2013-06-21','10:00:00',3.11),('16273','2013-06-21','10:05:00',3.14),('16273','2013-06-21','10:10:00',3.21),('16273','2013-06-21','10:15:00',3.27),('16273','2013-06-21','10:20:00',3.29),('16273','2013-06-21','10:25:00',3.3),('16273','2013-06-21','10:30:00',3.29),('16273','2013-06-21','10:35:00',3.36),('16273','2013-06-21','10:40:00',3.39),('16273','2013-06-21','10:45:00',3.41),('16273','2013-06-21','10:50:00',3.45),('16273','2013-06-21','10:55:00',3.45),('16273','2013-06-21','11:00:00',3.48),('16273','2013-06-21','11:05:00',3.49),('16273','2013-06-21','11:10:00',3.53),('16273','2013-06-21','11:15:00',3.55),('16273','2013-06-21','11:20:00',3.55),('16273','2013-06-21','11:25:00',3.58),('16273','2013-06-21','11:30:00',3.61),('16273','2013-06-21','11:35:00',3.67),('16273','2013-06-21','11:40:00',3.69),('16273','2013-06-21','11:45:00',3.7),('16273','2013-06-21','11:50:00',3.71),('16273','2013-06-21','11:55:00',3.69),('16273','2013-06-21','12:00:00',3.69),('16273','2013-06-21','12:05:00',3.7),('16273','2013-06-21','12:10:00',3.69),('16273','2013-06-21','12:15:00',3.65),('16273','2013-06-21','12:20:00',3.66),('16273','2013-06-21','12:25:00',3.71),('16273','2013-06-21','12:30:00',3.76),('16273','2013-06-21','12:35:00',3.77),('16273','2013-06-21','12:40:00',3.74),('16273','2013-06-21','12:45:00',3.75),('16273','2013-06-21','12:50:00',3.74),('16273','2013-06-21','12:55:00',3.75),('16273','2013-06-21','13:00:00',3.74),('16273','2013-06-21','13:05:00',3.72),('16273','2013-06-21','13:10:00',3.71),('16273','2013-06-21','13:15:00',3.75),('16273','2013-06-21','13:20:00',3.71),('16273','2013-06-21','13:25:00',3.7),('16273','2013-06-21','13:30:00',3.72),('16273','2013-06-21','13:35:00',3.73),('16273','2013-06-21','13:40:00',3.73),('16273','2013-06-21','13:45:00',3.68),('16273','2013-06-21','13:50:00',3.66),('16273','2013-06-21','13:55:00',3.64),('16273','2013-06-21','14:00:00',3.63),('16273','2013-06-21','14:05:00',3.56),('16273','2013-06-21','14:10:00',3.6),('16273','2013-06-21','14:15:00',3.58),('16273','2013-06-21','14:20:00',3.55),('16273','2013-06-21','14:25:00',3.52),('16273','2013-06-21','14:30:00',3.47),('16273','2013-06-21','14:35:00',3.44),('16273','2013-06-21','14:40:00',3.43),('16273','2013-06-21','14:45:00',3.4),('16273','2013-06-21','14:50:00',3.35),('16273','2013-06-21','14:55:00',3.31),('16273','2013-06-21','15:00:00',3.28),('16273','2013-06-21','15:05:00',3.25),('16273','2013-06-21','15:10:00',3.19),('16273','2013-06-21','15:15:00',3.14),('16273','2013-06-21','15:20:00',3.08),('16273','2013-06-21','15:25:00',3.04),('16273','2013-06-21','15:30:00',2.98),('16273','2013-06-21','15:35:00',2.94),('16273','2013-06-21','15:40:00',2.89),('16273','2013-06-21','15:45:00',2.83),('16273','2013-06-21','15:50:00',2.77),('16273','2013-06-21','15:55:00',2.73),('16273','2013-06-21','16:00:00',2.67),('16273','2013-06-21','16:05:00',2.62),('16273','2013-06-21','16:10:00',2.55),('16273','2013-06-21','16:15:00',2.49),('16273','2013-06-21','16:20:00',2.42),('16273','2013-06-21','16:25:00',2.37),('16273','2013-06-21','16:30:00',2.32),('16273','2013-06-21','16:35:00',2.25),('16273','2013-06-21','16:40:00',2.18),('16273','2013-06-21','16:45:00',2.11),('16273','2013-06-21','16:50:00',2.04),('16273','2013-06-21','16:55:00',1.96),('16273','2013-06-21','17:00:00',1.9),('16273','2013-06-21','17:05:00',1.82),('16273','2013-06-21','17:10:00',1.76),('16273','2013-06-21','17:15:00',1.67),('16273','2013-06-21','17:20:00',1.6),('16273','2013-06-21','17:25:00',1.53),('16273','2013-06-21','17:30:00',1.46),('16273','2013-06-21','17:35:00',1.38),('16273','2013-06-21','17:40:00',1.31),('16273','2013-06-21','17:45:00',1.24),('16273','2013-06-21','17:50:00',1.16),('16273','2013-06-21','17:55:00',1.1),('16273','2013-06-21','18:00:00',1.02),('16273','2014-04-04','09:00:00',1.12),('16273','2014-04-04','09:05:00',1),('16273','2014-04-04','11:10:00',1.08),('16273','2014-04-04','13:00:00',1.5),('16273','2014-04-04','13:05:00',1.66),('16273','2014-04-04','13:10:00',3.14),('16273','2014-04-04','13:15:00',1.43),('16273','2014-04-04','13:20:00',2.1),('16273','2014-04-04','13:25:00',3.18),('16273','2014-04-04','13:30:00',2.99),('16273','2014-04-04','13:35:00',1.88),('16273','2014-04-04','13:40:00',2.44),('16273','2014-04-04','13:45:00',1.89),('16273','2014-04-04','13:50:00',2.37),('16273','2014-04-04','13:55:00',1.78),('16273','2014-04-04','14:00:00',1.75),('16273','2014-04-04','14:05:00',1.94),('16273','2014-04-04','14:10:00',1.43),('16273','2014-04-04','14:15:00',1.32),('16273','2014-04-04','14:20:00',2.32),('16273','2014-04-04','14:25:00',1.33),('16273','2014-04-04','14:30:00',1.86),('16273','2014-04-04','14:35:00',1.69),('16273','2014-04-04','14:40:00',1.48),('16273','2014-04-04','14:45:00',2),('16273','2014-04-04','14:50:00',1.44),('16273','2014-04-04','14:55:00',1.39),('16273','2014-04-04','15:00:00',1.21),('16273','2014-04-04','15:05:00',2.21),('16273','2014-04-04','15:10:00',1.93),('16273','2014-04-04','15:15:00',2.13),('16273','2014-04-04','15:20:00',2.25),('16273','2014-04-04','15:25:00',2.42),('16273','2014-04-04','15:30:00',3.2),('16273','2014-04-04','15:35:00',1.7),('16273','2014-04-04','15:40:00',1.26),('16273','2014-04-04','15:45:00',1.98),('16273','2014-04-04','15:50:00',2.18),('16273','2014-04-04','15:55:00',2.15),('16273','2014-04-04','16:00:00',2.33),('16273','2014-04-04','16:05:00',2.03),('16273','2014-04-04','16:10:00',2.56),('16273','2014-04-04','16:15:00',2.66),('16273','2014-04-04','16:20:00',2.13),('16273','2014-04-04','16:25:00',1.1),('16273','2014-04-04','16:30:00',1.3),('16273','2014-04-04','16:35:00',1.48),('16273','2014-04-04','16:40:00',2.72),('16273','2014-04-04','16:45:00',1.65),('16273','2014-04-04','16:50:00',2.13),('16273','2014-04-04','16:55:00',1.2),('16273','2014-04-04','17:00:00',2.08),('16273','2014-04-04','17:05:00',2.09),('16273','2014-04-04','17:10:00',1.23),('16273','2014-04-04','17:15:00',1.14),('16273','2014-04-04','17:25:00',1.31),('16273','2014-04-04','17:30:00',1.19),('16273','2014-04-04','17:40:00',1.08),('16273','2014-04-04','17:45:00',1.06),('16273','2013-06-20','07:15:00',1.03),('16273','2013-06-20','07:20:00',1.1),('16273','2013-06-20','07:25:00',1.18),('16273','2013-06-20','07:30:00',1.25),('16273','2013-06-20','07:35:00',1.33),('16273','2013-06-20','07:40:00',1.41),('16273','2013-06-20','07:45:00',1.49),('16273','2013-06-20','07:50:00',1.59),('16273','2013-06-20','07:55:00',1.65),('16273','2013-06-20','08:00:00',1.71),('16273','2013-06-20','08:05:00',1.79),('16273','2013-06-20','08:10:00',1.87),('16273','2013-06-20','08:15:00',1.97),('16273','2013-06-20','08:20:00',2.04),('16273','2013-06-20','08:25:00',2.12),('16273','2013-06-20','08:30:00',2.2),('16273','2013-06-20','08:35:00',2.25),('16273','2013-06-20','08:40:00',2.32),('16273','2013-06-20','08:45:00',2.39),('16273','2013-06-20','08:50:00',2.45),('16273','2013-06-20','08:55:00',2.51),('16273','2013-06-20','09:00:00',2.58),('16273','2013-06-20','09:05:00',2.62),('16273','2013-06-20','09:10:00',2.66),('16273','2013-06-20','09:15:00',2.71),('16273','2013-06-20','09:20:00',2.78),('16273','2013-06-20','09:25:00',2.79),('16273','2013-06-20','09:30:00',2.86),('16273','2013-06-20','09:35:00',2.93),('16273','2013-06-20','09:40:00',2.99),('16273','2013-06-20','09:45:00',3.05),('16273','2013-06-20','09:50:00',3.07),('16273','2013-06-20','09:55:00',3.14),('16273','2013-06-20','10:00:00',3.18),('16273','2013-06-20','10:05:00',3.2),('16273','2013-06-20','10:10:00',3.23),('16273','2013-06-20','10:15:00',3.29),('16273','2013-06-20','10:20:00',3.31),('16273','2013-06-20','10:25:00',3.34),('16273','2013-06-20','10:30:00',3.38),('16273','2013-06-20','10:35:00',3.4),('16273','2013-06-20','10:40:00',3.43),('16273','2013-06-20','10:45:00',3.44),('16273','2013-06-20','10:50:00',3.48),('16273','2013-06-20','10:55:00',3.52),('16273','2013-06-20','11:00:00',3.52),('16273','2013-06-20','11:05:00',3.51),('16273','2013-06-20','11:10:00',3.52),('16273','2013-06-20','11:15:00',3.52),('16273','2013-06-20','11:20:00',3.53),('16273','2013-06-20','11:25:00',3.54),('16273','2013-06-20','11:30:00',3.56),('16273','2013-06-20','11:35:00',3.62),('16273','2013-06-20','11:40:00',3.65),('16273','2013-06-20','11:45:00',3.64),('16273','2013-06-20','11:50:00',3.66),('16273','2013-06-20','11:55:00',3.67),('16273','2013-06-20','12:00:00',3.71),('16273','2013-06-20','12:05:00',3.74),('16273','2013-06-20','12:10:00',3.73),('16273','2013-06-20','12:15:00',3.73),('16273','2013-06-20','12:20:00',3.73),('16273','2013-06-20','12:25:00',3.77),('16273','2013-06-20','12:30:00',3.77),('16273','2013-06-20','12:35:00',3.77),('16273','2013-06-20','12:40:00',3.83),('16273','2013-06-20','12:45:00',3.85),('16273','2013-06-20','12:50:00',3.8),('16273','2013-06-20','12:55:00',3.79),('16273','2013-06-20','13:00:00',3.78),('16273','2013-06-20','13:05:00',3.8),('16273','2013-06-20','13:10:00',3.8),('16273','2013-06-20','13:15:00',3.79),('16273','2013-06-20','13:20:00',3.8),('16273','2013-06-20','13:25:00',3.82),('16273','2013-06-20','13:30:00',3.83),('16273','2013-06-20','13:35:00',3.81),('16273','2013-06-20','13:40:00',3.79),('16273','2013-06-20','13:45:00',3.76),('16273','2013-06-20','13:50:00',3.73),('16273','2013-06-20','13:55:00',3.72),('16273','2013-06-20','14:00:00',3.71),('16273','2013-06-20','14:05:00',3.66),('16273','2013-06-20','14:10:00',3.65),('16273','2013-06-20','14:15:00',3.64),('16273','2013-06-20','14:20:00',3.62),('16273','2013-06-20','14:25:00',3.57),('16273','2013-06-20','14:30:00',3.54),('16273','2013-06-20','14:35:00',3.5),('16273','2013-06-20','14:40:00',3.48),('16273','2013-06-20','14:45:00',3.45),('16273','2013-06-20','14:50:00',3.41),('16273','2013-06-20','14:55:00',3.36),('16273','2013-06-20','15:00:00',3.32),('16273','2013-06-20','15:05:00',3.27),('16273','2013-06-20','15:10:00',3.23),('16273','2013-06-20','15:15:00',3.17),('16273','2013-06-20','15:20:00',3.13),('16273','2013-06-20','15:25:00',3.09),('16273','2013-06-20','15:30:00',3.04),('16273','2013-06-20','15:35:00',2.98),('16273','2013-06-20','15:40:00',2.92),('16273','2013-06-20','15:45:00',2.87),('16273','2013-06-20','15:50:00',2.81),('16273','2013-06-20','15:55:00',2.75),('16273','2013-06-20','16:00:00',2.7),('16273','2013-06-20','16:05:00',2.65),('16273','2013-06-20','16:10:00',2.59),('16273','2013-06-20','16:15:00',2.52),('16273','2013-06-20','16:20:00',2.46),('16273','2013-06-20','16:25:00',2.4),('16273','2013-06-20','16:30:00',2.33),('16273','2013-06-20','16:35:00',2.24),('16273','2013-06-20','16:40:00',2.19),('16273','2013-06-20','16:45:00',2.1),('16273','2013-06-20','16:50:00',2.05),('16273','2013-06-20','16:55:00',1.98),('16273','2013-06-20','17:00:00',1.91),('16273','2013-06-20','17:05:00',1.82),('16273','2013-06-20','17:10:00',1.75),('16273','2013-06-20','17:15:00',1.67),('16273','2013-06-20','17:20:00',1.6),('16273','2013-06-20','17:25:00',1.53),('16273','2013-06-20','17:30:00',1.47),('16273','2013-06-20','17:35:00',1.4),('16273','2013-06-20','17:40:00',1.32),('16273','2013-06-20','17:45:00',1.25),('16273','2013-06-20','17:50:00',1.18),('16273','2013-06-20','17:55:00',1.1),('16273','2013-06-20','18:00:00',1.03),('16273','2013-06-19','07:15:00',1.06),('16273','2013-06-19','07:20:00',1.13),('16273','2013-06-19','07:25:00',1.21),('16273','2013-06-19','07:30:00',1.27),('16273','2013-06-19','07:35:00',1.34),('16273','2013-06-19','07:40:00',1.41),('16273','2013-06-19','07:45:00',1.48),('16273','2013-06-19','07:50:00',1.56),('16273','2013-06-19','07:55:00',1.63),('16273','2013-06-19','08:00:00',1.71),('16273','2013-06-19','08:05:00',1.79),('16273','2013-06-19','08:10:00',1.87),('16273','2013-06-19','08:15:00',1.93),('16273','2013-06-19','08:20:00',1.98),('16273','2013-06-19','08:25:00',2.05),('16273','2013-06-19','08:30:00',2.11),('16273','2013-06-19','08:35:00',2.17),('16273','2013-06-19','08:40:00',2.23),('16273','2013-06-19','08:45:00',2.31),('16273','2013-06-19','08:50:00',2.4),('16273','2013-06-19','08:55:00',2.47),('16273','2013-06-19','09:00:00',2.52),('16273','2013-06-19','09:05:00',2.57),('16273','2013-06-19','09:10:00',2.61),('16273','2013-06-19','09:15:00',2.65),('16273','2013-06-19','09:20:00',2.71),('16273','2013-06-19','09:25:00',2.75),('16273','2013-06-19','09:30:00',2.8),('16273','2013-06-19','09:35:00',2.83),('16273','2013-06-19','09:40:00',2.85),('16273','2013-06-19','09:45:00',2.9),('16273','2013-06-19','09:50:00',2.93),('16273','2013-06-19','09:55:00',3),('16273','2013-06-19','10:00:00',3.04),('16273','2013-06-19','10:05:00',3.08),('16273','2013-06-19','10:10:00',3.13),('16273','2013-06-19','10:15:00',3.17),('16273','2013-06-19','10:20:00',3.19),('16273','2013-06-19','10:25:00',3.22),('16273','2013-06-19','10:30:00',3.25),('16273','2013-06-19','10:35:00',3.26),('16273','2013-06-19','10:40:00',3.3),('16273','2013-06-19','10:45:00',3.31),('16273','2013-06-19','10:50:00',3.37),('16273','2013-06-19','10:55:00',3.39),('16273','2013-06-19','11:00:00',3.43),('16273','2013-06-19','11:05:00',3.45),('16273','2013-06-19','11:10:00',3.48),('16273','2013-06-19','11:15:00',3.49),('16273','2013-06-19','11:20:00',3.52),('16273','2013-06-19','11:25:00',3.54),('16273','2013-06-19','11:30:00',3.53),('16273','2013-06-19','11:35:00',3.57),('16273','2013-06-19','11:40:00',3.59),('16273','2013-06-19','11:45:00',3.62),('16273','2013-06-19','11:50:00',3.62),('16273','2013-06-19','11:55:00',3.66),('16273','2013-06-19','12:00:00',3.68),('16273','2013-06-19','12:05:00',3.7),('16273','2013-06-19','12:10:00',3.72),('16273','2013-06-19','12:15:00',3.65),('16273','2013-06-19','12:20:00',3.72),('16273','2013-06-19','12:25:00',3.71),('16273','2013-06-19','12:30:00',3.71),('16273','2013-06-19','12:35:00',3.71),('16273','2013-06-19','12:40:00',3.69),('16273','2013-06-19','12:45:00',3.68),('16273','2013-06-19','12:50:00',3.67),('16273','2013-06-19','12:55:00',3.69),('16273','2013-06-19','13:00:00',3.69),('16273','2013-06-19','13:05:00',3.7),('16273','2013-06-19','13:10:00',3.7),('16273','2013-06-19','13:15:00',3.7),('16273','2013-06-19','13:20:00',3.7),('16273','2013-06-19','13:25:00',3.7),('16273','2013-06-19','13:30:00',3.68),('16273','2013-06-19','13:35:00',3.67),('16273','2013-06-19','13:40:00',3.68),('16273','2013-06-19','13:45:00',3.64),('16273','2013-06-19','13:50:00',3.63),('16273','2013-06-19','13:55:00',3.61),('16273','2013-06-19','14:00:00',3.59),('16273','2013-06-19','14:05:00',3.57),('16273','2013-06-19','14:10:00',3.54),('16273','2013-06-19','14:15:00',3.52),('16273','2013-06-19','14:20:00',3.49),('16273','2013-06-19','14:25:00',3.46),('16273','2013-06-19','14:30:00',3.44),('16273','2013-06-19','14:35:00',3.4),('16273','2013-06-19','14:40:00',3.37),('16273','2013-06-19','14:45:00',3.33),('16273','2013-06-19','14:50:00',3.29),('16273','2013-06-19','14:55:00',3.26),('16273','2013-06-19','15:00:00',3.22),('16273','2013-06-19','15:05:00',3.17),('16273','2013-06-19','15:10:00',3.12),('16273','2013-06-19','15:15:00',3.08),('16273','2013-06-19','15:20:00',3.04),('16273','2013-06-19','15:25:00',3),('16273','2013-06-19','15:30:00',2.93),('16273','2013-06-19','15:35:00',2.88),('16273','2013-06-19','15:40:00',2.82),('16273','2013-06-19','15:45:00',2.78),('16273','2013-06-19','15:50:00',2.74),('16273','2013-06-19','15:55:00',2.68),('16273','2013-06-19','16:00:00',2.63),('16273','2013-06-19','16:05:00',2.57),('16273','2013-06-19','16:10:00',2.51),('16273','2013-06-19','16:15:00',2.46),('16273','2013-06-19','16:20:00',2.4),('16273','2013-06-19','16:25:00',2.33),('16273','2013-06-19','16:30:00',2.27),('16273','2013-06-19','16:35:00',2.17),('16273','2013-06-19','16:40:00',2.14),('16273','2013-06-19','16:45:00',2.07),('16273','2013-06-19','16:50:00',2.01),('16273','2013-06-19','16:55:00',1.95),('16273','2013-06-19','17:00:00',1.88),('16273','2013-06-19','17:05:00',1.81),('16273','2013-06-19','17:10:00',1.74),('16273','2013-06-19','17:15:00',1.67),('16273','2013-06-19','17:20:00',1.59),('16273','2013-06-19','17:25:00',1.52),('16273','2013-06-19','17:30:00',1.44),('16273','2013-06-19','17:35:00',1.37),('16273','2013-06-19','17:40:00',1.3),('16273','2013-06-19','17:45:00',1.23),('16273','2013-06-19','17:50:00',1.14),('16273','2013-06-19','17:55:00',1.08),('16273','2013-06-19','18:00:00',1.01),('16273','2013-06-18','07:15:00',1.02),('16273','2013-06-18','07:20:00',1.1),('16273','2013-06-18','07:25:00',1.17),('16273','2013-06-18','07:30:00',1.24),('16273','2013-06-18','07:35:00',1.32),('16273','2013-06-18','07:40:00',1.39),('16273','2013-06-18','07:45:00',1.48),('16273','2013-06-18','07:50:00',1.54),('16273','2013-06-18','07:55:00',1.62),('16273','2013-06-18','08:00:00',1.69),('16273','2013-06-18','08:05:00',1.77),('16273','2013-06-18','08:10:00',1.85),('16273','2013-06-18','08:15:00',1.93),('16273','2013-06-18','08:20:00',2.01),('16273','2013-06-18','08:25:00',2.08),('16273','2013-06-18','08:30:00',2.14),('16273','2013-06-18','08:35:00',2.2),('16273','2013-06-18','08:40:00',2.26),('16273','2013-06-18','08:45:00',2.31),('16273','2013-06-18','08:50:00',2.37),('16273','2013-06-18','08:55:00',2.43),('16273','2013-06-18','09:00:00',2.49),('16273','2013-06-18','09:05:00',2.54),('16273','2013-06-18','09:10:00',2.6),('16273','2013-06-18','09:15:00',2.65),('16273','2013-06-18','09:20:00',2.7),('16273','2013-06-18','09:25:00',2.75),('16273','2013-06-18','09:30:00',2.81),('16273','2013-06-18','09:35:00',2.86),('16273','2013-06-18','09:40:00',2.91),('16273','2013-06-18','09:45:00',2.95),('16273','2013-06-18','09:50:00',3),('16273','2013-06-18','09:55:00',3.03),('16273','2013-06-18','10:00:00',3.03),('16273','2013-06-18','10:05:00',3.1),('16273','2013-06-18','10:10:00',3.15),('16273','2013-06-18','10:15:00',3.2),('16273','2013-06-18','10:20:00',3.23),('16273','2013-06-18','10:25:00',3.24),('16273','2013-06-18','10:30:00',3.27),('16273','2013-06-18','10:35:00',3.31),('16273','2013-06-18','10:40:00',3.35),('16273','2013-06-18','10:45:00',3.36),('16273','2013-06-18','10:50:00',3.39),('16273','2013-06-18','10:55:00',3.41),('16273','2013-06-18','11:00:00',3.39),('16273','2013-06-18','11:05:00',3.46),('16273','2013-06-18','11:10:00',3.48),('16273','2013-06-18','11:15:00',3.47),('16273','2013-06-18','11:20:00',3.49),('16273','2013-06-18','11:25:00',3.52),('16273','2013-06-18','11:30:00',3.52),('16273','2013-06-18','11:35:00',3.52),('16273','2013-06-18','11:40:00',3.53),('16273','2013-06-18','11:45:00',3.56),('16273','2013-06-18','11:50:00',3.6),('16273','2013-06-18','11:55:00',3.61),('16273','2013-06-18','12:00:00',3.57),('16273','2013-06-18','12:05:00',3.58),('16273','2013-06-18','12:10:00',3.56),('16273','2013-06-18','12:15:00',3.59),('16273','2013-06-18','12:20:00',3.54),('16273','2013-06-18','12:25:00',3.57),('16273','2013-06-18','12:30:00',3.55),('16273','2013-06-18','12:35:00',3.6),('16273','2013-06-18','12:40:00',3.7),('16273','2013-06-18','12:45:00',3.68),('16273','2013-06-18','12:50:00',3.59),('16273','2013-06-18','12:55:00',3.59),('16273','2013-06-18','13:00:00',3.62),('16273','2013-06-18','13:05:00',3.57),('16273','2013-06-18','13:10:00',3.62),('16273','2013-06-18','13:15:00',3.58),('16273','2013-06-18','13:20:00',3.6),('16273','2013-06-18','13:25:00',3.58),('16273','2013-06-18','13:30:00',3.53),('16273','2013-06-18','13:35:00',3.48),('16273','2013-06-18','13:40:00',3.51),('16273','2013-06-18','13:45:00',3.56),('16273','2013-06-18','13:50:00',3.57),('16273','2013-06-18','13:55:00',3.55),('16273','2013-06-18','14:00:00',3.6),('16273','2013-06-18','14:05:00',3.63),('16273','2013-06-18','14:10:00',3.63),('16273','2013-06-18','14:15:00',3.6),('16273','2013-06-18','14:20:00',3.57),('16273','2013-06-18','14:25:00',3.55),('16273','2013-06-18','14:30:00',3.56),('16273','2013-06-18','14:35:00',3.64),('16273','2013-06-18','14:40:00',3.63),('16273','2013-06-18','14:45:00',3.56),('16273','2013-06-18','14:50:00',3.49),('16273','2013-06-18','14:55:00',3.42),('16273','2013-06-18','15:00:00',3.33),('16273','2013-06-18','15:05:00',3.25),('16273','2013-06-18','15:10:00',3.19),('16273','2013-06-18','15:15:00',3.11),('16273','2013-06-18','15:20:00',3.06),('16273','2013-06-18','15:25:00',3.02),('16273','2013-06-18','15:30:00',2.96),('16273','2013-06-18','15:35:00',2.91),('16273','2013-06-18','15:40:00',2.84),('16273','2013-06-18','15:45:00',2.79),('16273','2013-06-18','15:50:00',2.74),('16273','2013-06-18','15:55:00',2.71),('16273','2013-06-18','16:00:00',2.66),('16273','2013-06-18','16:05:00',2.62),('16273','2013-06-18','16:10:00',2.57),('16273','2013-06-18','16:15:00',2.52),('16273','2013-06-18','16:20:00',2.46),('16273','2013-06-18','16:25:00',2.42),('16273','2013-06-18','16:30:00',2.36),('16273','2013-06-18','16:35:00',2.27),('16273','2013-06-18','16:40:00',2.21),('16273','2013-06-18','16:45:00',2.14),('16273','2013-06-18','16:50:00',2.06),('16273','2013-06-18','16:55:00',1.98),('16273','2013-06-18','17:00:00',1.91),('16273','2013-06-18','17:05:00',1.83),('16273','2013-06-18','17:10:00',1.75),('16273','2013-06-18','17:15:00',1.67),('16273','2013-06-18','17:20:00',1.6),('16273','2013-06-18','17:25:00',1.51),('16273','2013-06-18','17:30:00',1.44),('16273','2013-06-18','17:35:00',1.37),('16273','2013-06-18','17:40:00',1.3),('16273','2013-06-18','17:45:00',1.23),('16273','2013-06-18','17:50:00',1.16),('16273','2013-06-18','17:55:00',1.1),('16273','2013-06-18','18:00:00',1.03),('16273','2013-06-17','07:10:00',1.02),('16273','2013-06-17','07:15:00',1.1),('16273','2013-06-17','07:20:00',1.18),('16273','2013-06-17','07:25:00',1.26),('16273','2013-06-17','07:30:00',1.32),('16273','2013-06-17','07:35:00',1.4),('16273','2013-06-17','07:40:00',1.48),('16273','2013-06-17','07:45:00',1.56),('16273','2013-06-17','07:50:00',1.64),('16273','2013-06-17','07:55:00',1.71),('16273','2013-06-17','08:00:00',1.78),('16273','2013-06-17','08:05:00',1.86),('16273','2013-06-17','08:10:00',1.94),('16273','2013-06-17','08:15:00',2.01),('16273','2013-06-17','08:20:00',2.08),('16273','2013-06-17','08:25:00',2.15),('16273','2013-06-17','08:30:00',2.22),('16273','2013-06-17','08:35:00',2.28),('16273','2013-06-17','08:40:00',2.36),('16273','2013-06-17','08:45:00',2.42),('16273','2013-06-17','08:50:00',2.47),('16273','2013-06-17','08:55:00',2.52),('16273','2013-06-17','09:00:00',2.58),('16273','2013-06-17','09:05:00',2.64),('16273','2013-06-17','09:10:00',2.69),('16273','2013-06-17','09:15:00',2.75),('16273','2013-06-17','09:20:00',2.8),('16273','2013-06-17','09:25:00',2.87),('16273','2013-06-17','09:30:00',2.92),('16273','2013-06-17','09:35:00',2.97),('16273','2013-06-17','09:40:00',3),('16273','2013-06-17','09:45:00',3.04),('16273','2013-06-17','09:50:00',3.09),('16273','2013-06-17','09:55:00',3.15),('16273','2013-06-17','10:00:00',3.18),('16273','2013-06-17','10:05:00',3.21),('16273','2013-06-17','10:10:00',3.25),('16273','2013-06-17','10:15:00',3.27),('16273','2013-06-17','10:20:00',3.32),('16273','2013-06-17','10:25:00',3.36),('16273','2013-06-17','10:30:00',3.39),('16273','2013-06-17','10:35:00',3.42),('16273','2013-06-17','10:40:00',3.44),('16273','2013-06-17','10:45:00',3.47),('16273','2013-06-17','10:50:00',3.51),('16273','2013-06-17','10:55:00',3.57),('16273','2013-06-17','11:00:00',3.55),('16273','2013-06-17','11:05:00',3.54),('16273','2013-06-17','11:10:00',3.61),('16273','2013-06-17','11:15:00',3.58),('16273','2013-06-17','11:20:00',3.64),('16273','2013-06-17','11:25:00',3.68),('16273','2013-06-17','11:30:00',3.7),('16273','2013-06-17','11:35:00',3.73),('16273','2013-06-17','11:40:00',3.72),('16273','2013-06-17','11:45:00',3.73),('16273','2013-06-17','11:50:00',3.75),('16273','2013-06-17','11:55:00',3.77),('16273','2013-06-17','12:00:00',3.79),('16273','2013-06-17','12:05:00',3.8),('16273','2013-06-17','12:10:00',3.82),('16273','2013-06-17','12:15:00',3.8),('16273','2013-06-17','12:20:00',3.82),('16273','2013-06-17','12:25:00',3.83),('16273','2013-06-17','12:30:00',3.84),('16273','2013-06-17','12:35:00',3.85),('16273','2013-06-17','12:40:00',3.84),('16273','2013-06-17','12:45:00',3.82),('16273','2013-06-17','12:50:00',3.83),('16273','2013-06-17','12:55:00',3.84),('16273','2013-06-17','13:00:00',3.84),('16273','2013-06-17','13:05:00',3.8),('16273','2013-06-17','13:10:00',3.8),('16273','2013-06-17','13:15:00',3.77),('16273','2013-06-17','13:20:00',3.71),('16273','2013-06-17','13:25:00',3.71),('16273','2013-06-17','13:30:00',3.71),('16273','2013-06-17','13:35:00',3.71),('16273','2013-06-17','13:40:00',3.69),('16273','2013-06-17','13:45:00',3.68),('16273','2013-06-17','13:50:00',3.66),('16273','2013-06-17','13:55:00',3.65),('16273','2013-06-17','14:00:00',3.63),('16273','2013-06-17','14:05:00',3.57),('16273','2013-06-17','14:10:00',3.58),('16273','2013-06-17','14:15:00',3.56),('16273','2013-06-17','14:20:00',3.52),('16273','2013-06-17','14:25:00',3.49),('16273','2013-06-17','14:30:00',3.44),('16273','2013-06-17','14:35:00',3.4),('16273','2013-06-17','14:40:00',3.38),('16273','2013-06-17','14:45:00',3.34),('16273','2013-06-17','14:50:00',3.31),('16273','2013-06-17','14:55:00',3.28),('16273','2013-06-17','15:00:00',3.25),('16273','2013-06-17','15:05:00',3.21),('16273','2013-06-17','15:10:00',3.18),('16273','2013-06-17','15:15:00',3.13),('16273','2013-06-17','15:20:00',3.09),('16273','2013-06-17','15:25:00',3.05),('16273','2013-06-17','15:30:00',3),('16273','2013-06-17','15:35:00',2.95),('16273','2013-06-17','15:40:00',2.89),('16273','2013-06-17','15:45:00',2.85),('16273','2013-06-17','15:50:00',2.77),('16273','2013-06-17','15:55:00',2.75),('16273','2013-06-17','16:00:00',2.69),('16273','2013-06-17','16:05:00',2.64),('16273','2013-06-17','16:10:00',2.57),('16273','2013-06-17','16:15:00',2.51),('16273','2013-06-17','16:20:00',2.45),('16273','2013-06-17','16:25:00',2.39),('16273','2013-06-17','16:30:00',2.33),('16273','2013-06-17','16:35:00',2.27),('16273','2013-06-17','16:40:00',2.2),('16273','2013-06-17','16:45:00',2.14),('16273','2013-06-17','16:50:00',2.08),('16273','2013-06-17','16:55:00',2.01),('16273','2013-06-17','17:00:00',1.94),('16273','2013-06-17','17:05:00',1.84),('16273','2013-06-17','17:10:00',1.79),('16273','2013-06-17','17:15:00',1.72),('16273','2013-06-17','17:20:00',1.65),('16273','2013-06-17','17:25:00',1.58),('16273','2013-06-17','17:30:00',1.52),('16273','2013-06-17','17:35:00',1.45),('16273','2013-06-17','17:40:00',1.38),('16273','2013-06-17','17:45:00',1.31),('16273','2013-06-17','17:50:00',1.24),('16273','2013-06-17','17:55:00',1.17),('16273','2013-06-17','18:00:00',1.1),('16273','2013-06-17','18:05:00',1.03),('16273','2013-06-16','07:10:00',1.07),('16273','2013-06-16','07:15:00',1.14),('16273','2013-06-16','07:20:00',1.21),('16273','2013-06-16','07:25:00',1.27),('16273','2013-06-16','07:30:00',1.33),('16273','2013-06-16','07:35:00',1.42),('16273','2013-06-16','07:40:00',1.49),('16273','2013-06-16','07:45:00',1.57),('16273','2013-06-16','07:50:00',1.65),('16273','2013-06-16','07:55:00',1.74),('16273','2013-06-16','08:00:00',1.81),('16273','2013-06-16','08:05:00',1.91),('16273','2013-06-16','08:10:00',1.99),('16273','2013-06-16','08:15:00',2.07),('16273','2013-06-16','08:20:00',2.11),('16273','2013-06-16','08:25:00',2.2),('16273','2013-06-16','08:30:00',2.28),('16273','2013-06-16','08:35:00',2.33),('16273','2013-06-16','08:40:00',2.39),('16273','2013-06-16','08:45:00',2.47),('16273','2013-06-16','08:50:00',2.53),('16273','2013-06-16','08:55:00',2.57),('16273','2013-06-16','09:00:00',2.62),('16273','2013-06-16','09:05:00',2.72),('16273','2013-06-16','09:10:00',2.75),('16273','2013-06-16','09:15:00',2.77),('16273','2013-06-16','09:20:00',2.9),('16273','2013-06-16','09:25:00',2.95),('16273','2013-06-16','09:30:00',3.01),('16273','2013-06-16','09:35:00',3.08),('16273','2013-06-16','09:40:00',3.13),('16273','2013-06-16','09:45:00',3.18),('16273','2013-06-16','09:50:00',3.24),('16273','2013-06-16','09:55:00',3.27),('16273','2013-06-16','10:00:00',3.32),('16273','2013-06-16','10:05:00',3.36),('16273','2013-06-16','10:10:00',3.36),('16273','2013-06-16','10:15:00',3.39),('16273','2013-06-16','10:20:00',3.42),('16273','2013-06-16','10:25:00',3.45),('16273','2013-06-16','10:30:00',3.48),('16273','2013-06-16','10:35:00',3.51),('16273','2013-06-16','10:40:00',3.54),('16273','2013-06-16','10:45:00',3.57),('16273','2013-06-16','10:50:00',3.6),('16273','2013-06-16','10:55:00',3.64),('16273','2013-06-16','11:00:00',3.66),('16273','2013-06-16','11:05:00',3.69),('16273','2013-06-16','11:10:00',3.69),('16273','2013-06-16','11:15:00',3.73),('16273','2013-06-16','11:20:00',3.73),('16273','2013-06-16','11:25:00',3.74),('16273','2013-06-16','11:30:00',3.76),('16273','2013-06-16','11:35:00',3.76),('16273','2013-06-16','11:40:00',3.78),('16273','2013-06-16','11:45:00',3.8),('16273','2013-06-16','11:50:00',3.8),('16273','2013-06-16','11:55:00',3.84),('16273','2013-06-16','12:00:00',3.83),('16273','2013-06-16','12:05:00',3.83),('16273','2013-06-16','12:10:00',3.87),('16273','2013-06-16','12:15:00',3.78),('16273','2013-06-16','12:20:00',3.88),('16273','2013-06-16','12:25:00',3.85),('16273','2013-06-16','12:30:00',3.89),('16273','2013-06-16','12:35:00',3.91),('16273','2013-06-16','12:40:00',3.87),('16273','2013-06-16','12:45:00',3.9),('16273','2013-06-16','12:50:00',3.88),('16273','2013-06-16','12:55:00',3.9),('16273','2013-06-16','13:00:00',3.91),('16273','2013-06-16','13:05:00',3.9),('16273','2013-06-16','13:10:00',3.89),('16273','2013-06-16','13:15:00',3.88),('16273','2013-06-16','13:20:00',3.87),('16273','2013-06-16','13:25:00',3.87),('16273','2013-06-16','13:30:00',3.84),('16273','2013-06-16','13:35:00',3.84),('16273','2013-06-16','13:40:00',3.82),('16273','2013-06-16','13:45:00',3.79),('16273','2013-06-16','13:50:00',3.78),('16273','2013-06-16','13:55:00',3.76),('16273','2013-06-16','14:00:00',3.73),('16273','2013-06-16','14:05:00',3.68),('16273','2013-06-16','14:10:00',3.66),('16273','2013-06-16','14:15:00',3.64),('16273','2013-06-16','14:20:00',3.62),('16273','2013-06-16','14:25:00',3.58),('16273','2013-06-16','14:30:00',3.55),('16273','2013-06-16','14:35:00',3.52),('16273','2013-06-16','14:40:00',3.47),('16273','2013-06-16','14:45:00',3.44),('16273','2013-06-16','14:50:00',3.4),('16273','2013-06-16','14:55:00',3.38),('16273','2013-06-16','15:00:00',3.35),('16273','2013-06-16','15:05:00',3.3),('16273','2013-06-16','15:10:00',3.25),('16273','2013-06-16','15:15:00',3.18),('16273','2013-06-16','15:20:00',3.15),('16273','2013-06-16','15:25:00',3.09),('16273','2013-06-16','15:30:00',3.05),('16273','2013-06-16','15:35:00',3),('16273','2013-06-16','15:40:00',2.96),('16273','2013-06-16','15:45:00',2.9),('16273','2013-06-16','15:50:00',2.84),('16273','2013-06-16','15:55:00',2.78),('16273','2013-06-16','16:00:00',2.72),('16273','2013-06-16','16:05:00',2.66),('16273','2013-06-16','16:10:00',2.61),('16273','2013-06-16','16:15:00',2.54),('16273','2013-06-16','16:20:00',2.47),('16273','2013-06-16','16:25:00',2.4),('16273','2013-06-16','16:30:00',2.33),('16273','2013-06-16','16:35:00',2.26),('16273','2013-06-16','16:40:00',2.2),('16273','2013-06-16','16:45:00',2.13),('16273','2013-06-16','16:50:00',2.06),('16273','2013-06-16','16:55:00',1.99),('16273','2013-06-16','17:00:00',1.91),('16273','2013-06-16','17:05:00',1.83),('16273','2013-06-16','17:10:00',1.76),('16273','2013-06-16','17:15:00',1.68),('16273','2013-06-16','17:20:00',1.61),('16273','2013-06-16','17:25:00',1.54),('16273','2013-06-16','17:30:00',1.46),('16273','2013-06-16','17:35:00',1.39),('16273','2013-06-16','17:40:00',1.31),('16273','2013-06-16','17:45:00',1.24),('16273','2013-06-16','17:50:00',1.16),('16273','2013-06-16','17:55:00',1.1),('16273','2013-06-16','18:00:00',1.02),('16273','2013-06-15','07:15:00',1.03),('16273','2013-06-15','07:20:00',1.11),('16273','2013-06-15','07:25:00',1.19),('16273','2013-06-15','07:30:00',1.27),('16273','2013-06-15','07:35:00',1.35),('16273','2013-06-15','07:40:00',1.44),('16273','2013-06-15','07:45:00',1.49),('16273','2013-06-15','07:50:00',1.61),('16273','2013-06-15','07:55:00',1.65),('16273','2013-06-15','08:00:00',1.59),('16273','2013-06-15','08:05:00',1.55),('16273','2013-06-15','08:10:00',1.69),('16273','2013-06-15','08:15:00',1.2),('16273','2013-06-15','08:20:00',1.21),('16273','2013-06-15','08:25:00',1.46),('16273','2013-06-15','08:30:00',1.36),('16273','2013-06-15','08:50:00',1.74),('16273','2013-06-15','08:55:00',2.63),('16273','2013-06-15','09:00:00',2.66),('16273','2013-06-15','09:05:00',2.79),('16273','2013-06-15','09:10:00',2.87),('16273','2013-06-15','09:15:00',2.92),('16273','2013-06-15','09:20:00',2.9),('16273','2013-06-15','09:25:00',3.02),('16273','2013-06-15','09:30:00',2.85),('16273','2013-06-15','09:35:00',2.8),('16273','2013-06-15','09:40:00',3.1),('16273','2013-06-15','09:45:00',3.11),('16273','2013-06-15','09:50:00',3.21),('16273','2013-06-15','09:55:00',3.24),('16273','2013-06-15','10:00:00',3.25),('16273','2013-06-15','10:05:00',3.35),('16273','2013-06-15','10:10:00',3.3),('16273','2013-06-15','10:15:00',3.4),('16273','2013-06-15','10:20:00',3.46),('16273','2013-06-15','10:25:00',3.48),('16273','2013-06-15','10:30:00',3.48),('16273','2013-06-15','10:35:00',3.04),('16273','2013-06-15','10:40:00',3.58),('16273','2013-06-15','10:45:00',3.62),('16273','2013-06-15','10:50:00',3.64),('16273','2013-06-15','10:55:00',3.57),('16273','2013-06-15','11:00:00',3.7),('16273','2013-06-15','11:05:00',3.71),('16273','2013-06-15','11:10:00',3.71),('16273','2013-06-15','11:15:00',3.69),('16273','2013-06-15','11:20:00',3.88),('16273','2013-06-15','11:25:00',3.85),('16273','2013-06-15','11:30:00',3.85),('16273','2013-06-15','11:35:00',3.83),('16273','2013-06-15','11:40:00',3.88),('16273','2013-06-15','11:45:00',3.85),('16273','2013-06-15','11:50:00',3.92),('16273','2013-06-15','11:55:00',3.87),('16273','2013-06-15','12:00:00',3.96),('16273','2013-06-15','12:05:00',3.96),('16273','2013-06-15','12:10:00',3.96),('16273','2013-06-15','12:15:00',3.94),('16273','2013-06-15','12:20:00',3.94),('16273','2013-06-15','12:25:00',3.9),('16273','2013-06-15','12:30:00',3.95),('16273','2013-06-15','12:35:00',3.96),('16273','2013-06-15','12:40:00',3.89),('16273','2013-06-15','12:45:00',3.94),('16273','2013-06-15','12:50:00',3.95),('16273','2013-06-15','12:55:00',3.92),('16273','2013-06-15','13:00:00',3.89),('16273','2013-06-15','13:05:00',3.88),('16273','2013-06-15','13:10:00',3.86),('16273','2013-06-15','13:15:00',3.85),('16273','2013-06-15','13:20:00',3.83),('16273','2013-06-15','13:25:00',3.86),('16273','2013-06-15','13:30:00',3.83),('16273','2013-06-15','13:35:00',3.83),('16273','2013-06-15','13:40:00',3.8),('16273','2013-06-15','13:45:00',3.77),('16273','2013-06-15','13:50:00',3.77),('16273','2013-06-15','13:55:00',3.76),('16273','2013-06-15','14:00:00',3.72),('16273','2013-06-15','14:05:00',3.69),('16273','2013-06-15','14:10:00',3.66),('16273','2013-06-15','14:15:00',3.63),('16273','2013-06-15','14:20:00',3.59),('16273','2013-06-15','14:25:00',3.57),('16273','2013-06-15','14:30:00',3.53),('16273','2013-06-15','14:35:00',3.52),('16273','2013-06-15','14:40:00',3.47),('16273','2013-06-15','14:45:00',3.44),('16273','2013-06-15','14:50:00',3.4),('16273','2013-06-15','14:55:00',3.37),('16273','2013-06-15','15:00:00',3.32),('16273','2013-06-15','15:05:00',3.29),('16273','2013-06-15','15:10:00',3.24),('16273','2013-06-15','15:15:00',3.21),('16273','2013-06-15','15:20:00',3.15),('16273','2013-06-15','15:25:00',3.11),('16273','2013-06-15','15:30:00',3.05),('16273','2013-06-15','15:35:00',2.99),('16273','2013-06-15','15:40:00',2.94),('16273','2013-06-15','15:45:00',2.89),('16273','2013-06-15','15:50:00',2.82),('16273','2013-06-15','15:55:00',2.77),('16273','2013-06-15','16:00:00',2.72),('16273','2013-06-15','16:05:00',2.66),('16273','2013-06-15','16:10:00',2.59),('16273','2013-06-15','16:15:00',2.53),('16273','2013-06-15','16:20:00',2.47),('16273','2013-06-15','16:25:00',2.38),('16273','2013-06-15','16:30:00',2.32),('16273','2013-06-15','16:35:00',2.27),('16273','2013-06-15','16:40:00',2.2),('16273','2013-06-15','16:45:00',2.12),('16273','2013-06-15','16:50:00',2.04),('16273','2013-06-15','16:55:00',1.99),('16273','2013-06-15','17:00:00',1.89),('16273','2013-06-15','17:05:00',1.81),('16273','2013-06-15','17:10:00',1.76),('16273','2013-06-15','17:15:00',1.68),('16273','2013-06-15','17:20:00',1.6),('16273','2013-06-15','17:25:00',1.53),('16273','2013-06-15','17:30:00',1.45),('16273','2013-06-15','17:35:00',1.37),('16273','2013-06-15','17:40:00',1.31),('16273','2013-06-15','17:45:00',1.25),('16273','2013-06-15','17:50:00',1.18),('16273','2013-06-15','17:55:00',1.11),('16273','2013-06-15','18:00:00',1.03),('16273','2013-06-14','07:05:00',1.06),('16273','2013-06-14','07:10:00',1.15),('16273','2013-06-14','07:15:00',1.24),('16273','2013-06-14','07:20:00',1.32),('16273','2013-06-14','07:25:00',1.4),('16273','2013-06-14','07:30:00',1.49),('16273','2013-06-14','07:35:00',1.57),('16273','2013-06-14','07:40:00',1.65),('16273','2013-06-14','07:45:00',1.73),('16273','2013-06-14','07:50:00',1.83),('16273','2013-06-14','07:55:00',1.9),('16273','2013-06-14','08:00:00',1.99),('16273','2013-06-14','08:05:00',2.07),('16273','2013-06-14','08:10:00',2.15),('16273','2013-06-14','08:15:00',2.2),('16273','2013-06-14','08:20:00',2.29),('16273','2013-06-14','08:25:00',2.36),('16273','2013-06-14','08:30:00',2.43),('16273','2013-06-14','08:35:00',2.49),('16273','2013-06-14','08:40:00',2.54),('16273','2013-06-14','08:45:00',2.61),('16273','2013-06-14','08:50:00',2.67),('16273','2013-06-14','08:55:00',2.73),('16273','2013-06-14','09:00:00',2.8),('16273','2013-06-14','09:05:00',2.84),('16273','2013-06-14','09:10:00',2.88),('16273','2013-06-14','09:15:00',2.92),('16273','2013-06-14','09:20:00',2.99),('16273','2013-06-14','09:25:00',3.04),('16273','2013-06-14','09:30:00',3.06),('16273','2013-06-14','09:35:00',3.14),('16273','2013-06-14','09:40:00',3.2),('16273','2013-06-14','09:45:00',3.24),('16273','2013-06-14','09:50:00',3.26),('16273','2013-06-14','09:55:00',3.27),('16273','2013-06-14','10:00:00',3.32),('16273','2013-06-14','10:05:00',3.38),('16273','2013-06-14','10:10:00',3.38),('16273','2013-06-14','10:15:00',3.37),('16273','2013-06-14','10:20:00',3.48),('16273','2013-06-14','10:25:00',3.49),('16273','2013-06-14','10:30:00',3.47),('16273','2013-06-14','10:35:00',3.35),('16273','2013-06-14','10:40:00',3.52),('16273','2013-06-14','10:45:00',3.62),('16273','2013-06-14','10:50:00',3.68),('16273','2013-06-14','10:55:00',3.7),('16273','2013-06-14','11:00:00',3.72),('16273','2013-06-14','11:05:00',3.74),('16273','2013-06-14','11:10:00',3.72),('16273','2013-06-14','11:15:00',3.73),('16273','2013-06-14','11:20:00',3.82),('16273','2013-06-14','11:25:00',3.85),('16273','2013-06-14','11:30:00',3.87),('16273','2013-06-14','11:35:00',3.91),('16273','2013-06-14','11:40:00',3.9),('16273','2013-06-14','11:45:00',3.91),('16273','2013-06-14','11:50:00',3.9),('16273','2013-06-14','11:55:00',3.9),('16273','2013-06-14','12:00:00',3.96),('16273','2013-06-14','12:05:00',4),('16273','2013-06-14','12:10:00',4.02),('16273','2013-06-14','12:15:00',4),('16273','2013-06-14','12:20:00',3.99),('16273','2013-06-14','12:25:00',3.96),('16273','2013-06-14','12:30:00',3.94),('16273','2013-06-14','12:35:00',3.96),('16273','2013-06-14','12:40:00',3.97),('16273','2013-06-14','12:45:00',3.95),('16273','2013-06-14','12:50:00',3.95),('16273','2013-06-14','12:55:00',3.92),('16273','2013-06-14','13:00:00',3.91),('16273','2013-06-14','13:05:00',3.94),('16273','2013-06-14','13:10:00',3.92),('16273','2013-06-14','13:15:00',3.92),('16273','2013-06-14','13:20:00',3.92),('16273','2013-06-14','13:25:00',3.93),('16273','2013-06-14','13:30:00',3.88),('16273','2013-06-14','13:35:00',3.87),('16273','2013-06-14','13:40:00',3.84),('16273','2013-06-14','13:45:00',3.81),('16273','2013-06-14','13:50:00',3.83),('16273','2013-06-14','13:55:00',3.77),('16273','2013-06-14','14:00:00',3.76),('16273','2013-06-14','14:05:00',3.74),('16273','2013-06-14','14:10:00',3.73),('16273','2013-06-14','14:15:00',3.71),('16273','2013-06-14','14:20:00',3.68),('16273','2013-06-14','14:25:00',3.67),('16273','2013-06-14','14:30:00',3.63),('16273','2013-06-14','14:35:00',3.59),('16273','2013-06-14','14:40:00',3.55),('16273','2013-06-14','14:45:00',3.43),('16273','2013-06-14','14:50:00',3.44),('16273','2013-06-14','14:55:00',3.4),('16273','2013-06-14','15:00:00',3.34),('16273','2013-06-14','15:05:00',3.32),('16273','2013-06-14','15:10:00',3.28),('16273','2013-06-14','15:15:00',3.22),('16273','2013-06-14','15:20:00',3.18),('16273','2013-06-14','15:25:00',3.09),('16273','2013-06-14','15:30:00',3.01),('16273','2013-06-14','15:35:00',3),('16273','2013-06-14','15:40:00',2.95),('16273','2013-06-14','15:45:00',2.94),('16273','2013-06-14','15:50:00',2.91),('16273','2013-06-14','15:55:00',2.84),('16273','2013-06-14','16:00:00',2.76),('16273','2013-06-14','16:05:00',2.71),('16273','2013-06-14','16:10:00',2.67),('16273','2013-06-14','16:15:00',2.6),('16273','2013-06-14','16:20:00',2.51),('16273','2013-06-14','16:25:00',2.47),('16273','2013-06-14','16:30:00',2.4),('16273','2013-06-14','16:35:00',2.33),('16273','2013-06-14','16:40:00',2.26),('16273','2013-06-14','16:45:00',2.18),('16273','2013-06-14','16:50:00',2.07),('16273','2013-06-14','16:55:00',1.98),('16273','2013-06-14','17:00:00',1.92),('16273','2013-06-14','17:05:00',1.86),('16273','2013-06-14','17:10:00',1.76),('16273','2013-06-14','17:15:00',1.72),('16273','2013-06-14','17:20:00',1.64),('16273','2013-06-14','17:25:00',1.56),('16273','2013-06-14','17:30:00',1.5),('16273','2013-06-14','17:35:00',1.43),('16273','2013-06-14','17:40:00',1.35),('16273','2013-06-14','17:45:00',1.27),('16273','2013-06-14','17:50:00',1.2),('16273','2013-06-14','17:55:00',1.12),('16273','2013-06-14','18:00:00',1.05),('16273','2013-06-13','07:05:00',1.07),('16273','2013-06-13','07:10:00',1.15),('16273','2013-06-13','07:15:00',1.24),('16273','2013-06-13','07:20:00',1.33),('16273','2013-06-13','07:25:00',1.41),('16273','2013-06-13','07:30:00',1.5),('16273','2013-06-13','07:35:00',1.58),('16273','2013-06-13','07:40:00',1.66),('16273','2013-06-13','07:45:00',1.74),('16273','2013-06-13','07:50:00',1.83),('16273','2013-06-13','07:55:00',1.91),('16273','2013-06-13','08:00:00',1.99),('16273','2013-06-13','08:05:00',2.07),('16273','2013-06-13','08:10:00',2.15),('16273','2013-06-13','08:15:00',2.22),('16273','2013-06-13','08:20:00',2.29),('16273','2013-06-13','08:25:00',2.36),('16273','2013-06-13','08:30:00',2.44),('16273','2013-06-13','08:35:00',2.5),('16273','2013-06-13','08:40:00',2.56),('16273','2013-06-13','08:45:00',2.63),('16273','2013-06-13','08:50:00',2.71),('16273','2013-06-13','08:55:00',2.77),('16273','2013-06-13','09:00:00',2.82),('16273','2013-06-13','09:05:00',2.86),('16273','2013-06-13','09:10:00',2.96),('16273','2013-06-13','09:15:00',3.03),('16273','2013-06-13','09:20:00',3.07),('16273','2013-06-13','09:25:00',3.11),('16273','2013-06-13','09:30:00',3.13),('16273','2013-06-13','09:35:00',3.24),('16273','2013-06-13','09:40:00',3.31),('16273','2013-06-13','09:45:00',3.36),('16273','2013-06-13','09:50:00',3.4),('16273','2013-06-13','09:55:00',3.43),('16273','2013-06-13','10:00:00',3.48),('16273','2013-06-13','10:05:00',3.49),('16273','2013-06-13','10:10:00',3.54),('16273','2013-06-13','10:15:00',3.58),('16273','2013-06-13','10:20:00',3.61),('16273','2013-06-13','10:25:00',3.64),('16273','2013-06-13','10:30:00',3.69),('16273','2013-06-13','10:35:00',3.72),('16273','2013-06-13','10:40:00',3.74),('16273','2013-06-13','10:45:00',3.72),('16273','2013-06-13','10:50:00',3.8),('16273','2013-06-13','10:55:00',3.79),('16273','2013-06-13','11:00:00',3.8),('16273','2013-06-13','11:05:00',3.84),('16273','2013-06-13','11:10:00',3.85),('16273','2013-06-13','11:15:00',3.87),('16273','2013-06-13','11:20:00',3.89),('16273','2013-06-13','11:25:00',3.9),('16273','2013-06-13','11:30:00',3.95),('16273','2013-06-13','11:35:00',3.94),('16273','2013-06-13','11:40:00',3.96),('16273','2013-06-13','11:45:00',3.98),('16273','2013-06-13','11:50:00',4),('16273','2013-06-13','11:55:00',4),('16273','2013-06-13','12:00:00',4.02),('16273','2013-06-13','12:05:00',4.04),('16273','2013-06-13','12:10:00',4.02),('16273','2013-06-13','12:15:00',4.01),('16273','2013-06-13','12:20:00',4.03),('16273','2013-06-13','12:25:00',4.03),('16273','2013-06-13','12:30:00',4.02),('16273','2013-06-13','12:35:00',4.05),('16273','2013-06-13','12:40:00',4.08),('16273','2013-06-13','12:45:00',4.04),('16273','2013-06-13','12:50:00',4.03),('16273','2013-06-13','12:55:00',4),('16273','2013-06-13','13:00:00',4),('16273','2013-06-13','13:05:00',3.98),('16273','2013-06-13','13:10:00',3.94),('16273','2013-06-13','13:15:00',3.92),('16273','2013-06-13','13:20:00',3.88),('16273','2013-06-13','13:25:00',3.87),('16273','2013-06-13','13:30:00',3.89),('16273','2013-06-13','13:35:00',3.9),('16273','2013-06-13','13:40:00',3.86),('16273','2013-06-13','13:45:00',3.85),('16273','2013-06-13','13:50:00',3.79),('16273','2013-06-13','13:55:00',3.82),('16273','2013-06-13','14:00:00',3.77),('16273','2013-06-13','14:05:00',3.73),('16273','2013-06-13','14:10:00',3.76),('16273','2013-06-13','14:15:00',3.75),('16273','2013-06-13','14:20:00',3.67),('16273','2013-06-13','14:25:00',3.65),('16273','2013-06-13','14:30:00',2.35),('16273','2013-06-13','14:35:00',3.42),('16273','2013-06-13','14:40:00',2.52),('16273','2013-06-13','14:45:00',3.05),('16273','2013-06-13','14:50:00',3.26),('16273','2013-06-13','14:55:00',2.27),('16273','2013-06-13','15:00:00',3.38),('16273','2013-06-13','15:05:00',3.29),('16273','2013-06-13','15:10:00',3.27),('16273','2013-06-13','15:15:00',3.23),('16273','2013-06-13','15:20:00',3.18),('16273','2013-06-13','15:25:00',3.09),('16273','2013-06-13','15:30:00',3.05),('16273','2013-06-13','15:35:00',2.99),('16273','2013-06-13','15:40:00',2.94),('16273','2013-06-13','15:45:00',2.93),('16273','2013-06-13','15:50:00',2.82),('16273','2013-06-13','15:55:00',2.75),('16273','2013-06-13','16:00:00',2.69),('16273','2013-06-13','16:05:00',2.62),('16273','2013-06-13','16:10:00',2.63),('16273','2013-06-13','16:15:00',2.56),('16273','2013-06-13','16:20:00',2.5),('16273','2013-06-13','16:25:00',2.44),('16273','2013-06-13','16:30:00',2.37),('16273','2013-06-13','16:35:00',2.28),('16273','2013-06-13','16:40:00',2.23),('16273','2013-06-13','16:45:00',2.15),('16273','2013-06-13','16:50:00',2.05),('16273','2013-06-13','16:55:00',2),('16273','2013-06-13','17:00:00',1.93),('16273','2013-06-13','17:05:00',1.86),('16273','2013-06-13','17:10:00',1.78),('16273','2013-06-13','17:15:00',1.71),('16273','2013-06-13','17:20:00',1.62),('16273','2013-06-13','17:25:00',1.54),('16273','2013-06-13','17:30:00',1.47),('16273','2013-06-13','17:35:00',1.39),('16273','2013-06-13','17:40:00',1.31),('16273','2013-06-13','17:45:00',1.24),('16273','2013-06-13','17:50:00',1.17),('16273','2013-06-13','17:55:00',1.11),('16273','2013-06-13','18:00:00',1.02),('16273','2013-06-12','07:05:00',1.11),('16273','2013-06-12','07:10:00',1.19),('16273','2013-06-12','07:15:00',1.27),('16273','2013-06-12','07:20:00',1.35),('16273','2013-06-12','07:25:00',1.43),('16273','2013-06-12','07:30:00',1.51),('16273','2013-06-12','07:35:00',1.6),('16273','2013-06-12','07:40:00',1.68),('16273','2013-06-12','07:45:00',1.77),('16273','2013-06-12','07:50:00',1.85),('16273','2013-06-12','07:55:00',1.93),('16273','2013-06-12','08:00:00',2),('16273','2013-06-12','08:05:00',2.08),('16273','2013-06-12','08:10:00',2.16),('16273','2013-06-12','08:15:00',2.25),('16273','2013-06-12','08:20:00',2.33),('16273','2013-06-12','08:25:00',2.4),('16273','2013-06-12','08:30:00',2.47),('16273','2013-06-12','08:35:00',2.55),('16273','2013-06-12','08:40:00',2.62),('16273','2013-06-12','08:45:00',2.68),('16273','2013-06-12','08:50:00',2.73),('16273','2013-06-12','08:55:00',2.8),('16273','2013-06-12','09:00:00',2.87),('16273','2013-06-12','09:05:00',2.93),('16273','2013-06-12','09:10:00',3),('16273','2013-06-12','09:15:00',3.05),('16273','2013-06-12','09:20:00',3.1),('16273','2013-06-12','09:25:00',3.16),('16273','2013-06-12','09:30:00',3.2),('16273','2013-06-12','09:35:00',3.26),('16273','2013-06-12','09:40:00',3.29),('16273','2013-06-12','09:45:00',3.29),('16273','2013-06-12','09:50:00',3.32),('16273','2013-06-12','09:55:00',3.38),('16273','2013-06-12','10:00:00',3.43),('16273','2013-06-12','10:05:00',3.46),('16273','2013-06-12','10:10:00',3.54),('16273','2013-06-12','10:15:00',3.59),('16273','2013-06-12','10:20:00',3.57),('16273','2013-06-12','10:25:00',3.63),('16273','2013-06-12','10:30:00',3.66),('16273','2013-06-12','10:35:00',3.74),('16273','2013-06-12','10:40:00',3.74),('16273','2013-06-12','10:45:00',3.76),('16273','2013-06-12','10:50:00',3.76),('16273','2013-06-12','10:55:00',3.84),('16273','2013-06-12','11:00:00',3.89),('16273','2013-06-12','11:05:00',3.92),('16273','2013-06-12','11:10:00',3.98),('16273','2013-06-12','11:15:00',3.95),('16273','2013-06-12','11:20:00',3.99),('16273','2013-06-12','11:25:00',4),('16273','2013-06-12','11:30:00',3.99),('16273','2013-06-12','11:35:00',4.03),('16273','2013-06-12','11:40:00',4.06),('16273','2013-06-12','11:45:00',4.03),('16273','2013-06-12','11:50:00',4),('16273','2013-06-12','11:55:00',3.34),('16273','2013-06-12','12:00:00',4.04),('16273','2013-06-12','12:05:00',4),('16273','2013-06-12','12:10:00',4),('16273','2013-06-12','12:15:00',4),('16273','2013-06-12','12:20:00',3.98),('16273','2013-06-12','12:25:00',4.04),('16273','2013-06-12','12:30:00',3.98),('16273','2013-06-12','12:35:00',3.42),('16273','2013-06-12','12:40:00',4.1),('16273','2013-06-12','12:45:00',4.08),('16273','2013-06-12','12:50:00',3.95),('16273','2013-06-12','12:55:00',4.05),('16273','2013-06-12','13:00:00',4.12),('16273','2013-06-12','13:05:00',4.02),('16273','2013-06-12','13:10:00',4),('16273','2013-06-12','13:15:00',4.05),('16273','2013-06-12','13:20:00',4.07),('16273','2013-06-12','13:25:00',3.93),('16273','2013-06-12','13:30:00',3.52),('16273','2013-06-12','13:35:00',3.26),('16273','2013-06-12','13:40:00',2.98),('16273','2013-06-12','13:45:00',2.51),('16273','2013-06-12','13:50:00',4),('16273','2013-06-12','13:55:00',4),('16273','2013-06-12','14:00:00',3.9),('16273','2013-06-12','14:05:00',3.83),('16273','2013-06-12','14:10:00',3.83),('16273','2013-06-12','14:15:00',3.8),('16273','2013-06-12','14:20:00',3.74),('16273','2013-06-12','14:25:00',3.72),('16273','2013-06-12','14:30:00',3.65),('16273','2013-06-12','14:35:00',3.6),('16273','2013-06-12','14:40:00',3.58),('16273','2013-06-12','14:45:00',3.54),('16273','2013-06-12','14:50:00',3.46),('16273','2013-06-12','14:55:00',3.35),('16273','2013-06-12','15:00:00',3.43),('16273','2013-06-12','15:05:00',3.35),('16273','2013-06-12','15:10:00',3.36),('16273','2013-06-12','15:15:00',3.31),('16273','2013-06-12','15:20:00',3.21),('16273','2013-06-12','15:25:00',3.21),('16273','2013-06-12','15:30:00',3.14),('16273','2013-06-12','15:35:00',3.01),('16273','2013-06-12','15:40:00',2.97),('16273','2013-06-12','15:45:00',2.96),('16273','2013-06-12','15:50:00',2.87),('16273','2013-06-12','15:55:00',2.88),('16273','2013-06-12','16:00:00',2.82),('16273','2013-06-12','16:05:00',2.77),('16273','2013-06-12','16:10:00',2.7),('16273','2013-06-12','16:15:00',2.63),('16273','2013-06-12','16:20:00',2.59),('16273','2013-06-12','16:25:00',2.54),('16273','2013-06-12','16:30:00',2.45),('16273','2013-06-12','16:35:00',2.35),('16273','2013-06-12','16:40:00',2.34),('16273','2013-06-12','16:45:00',2.31),('16273','2013-06-12','16:50:00',2.18),('16273','2013-06-12','16:55:00',2.07),('16273','2013-06-12','17:00:00',1.91),('16273','2013-06-12','17:15:00',1.45),('16273','2013-06-12','17:20:00',1.49),('16273','2013-06-12','17:25:00',1.61),('16273','2013-06-12','17:30:00',1.53),('16273','2013-06-12','17:35:00',1.45),('16273','2013-06-12','17:45:00',1.45),('16273','2013-06-12','17:50:00',1.33),('16273','2013-06-12','17:55:00',1.42),('16273','2013-06-12','18:00:00',1.34),('16273','2013-06-12','18:05:00',1.08),('16273','2013-06-11','07:25:00',1.17),('16273','2013-06-11','07:30:00',1.45),('16273','2013-06-11','07:35:00',1.35),('16273','2013-06-11','07:40:00',1.6),('16273','2013-06-11','07:45:00',1.71),('16273','2013-06-11','07:50:00',1.78),('16273','2013-06-11','07:55:00',1.86),('16273','2013-06-11','08:00:00',1.94),('16273','2013-06-11','08:05:00',2.02),('16273','2013-06-11','08:10:00',2.11),('16273','2013-06-11','08:15:00',2.17),('16273','2013-06-11','08:20:00',2.24),('16273','2013-06-11','08:25:00',2.33),('16273','2013-06-11','08:30:00',2.41),('16273','2013-06-11','08:35:00',2.45),('16273','2013-06-11','08:40:00',2.55),('16273','2013-06-11','08:45:00',2.63),('16273','2013-06-11','08:50:00',2.69),('16273','2013-06-11','08:55:00',2.75),('16273','2013-06-11','09:00:00',2.8),('16273','2013-06-11','09:05:00',2.87),('16273','2013-06-11','09:10:00',2.9),('16273','2013-06-11','09:15:00',2.99),('16273','2013-06-11','09:20:00',2.33),('16273','2013-06-11','09:25:00',2.83),('16273','2013-06-11','09:30:00',3.19),('16273','2013-06-11','09:35:00',3.05),('16273','2013-06-11','09:40:00',2.51),('16273','2013-06-11','09:45:00',3.39),('16273','2013-06-11','09:50:00',3.36),('16273','2013-06-11','09:55:00',3.42),('16273','2013-06-11','10:00:00',3.44),('16273','2013-06-11','10:05:00',3.52),('16273','2013-06-11','10:10:00',3.55),('16273','2013-06-11','10:15:00',3.61),('16273','2013-06-11','10:20:00',3.74),('16273','2013-06-11','10:25:00',3.84),('16273','2013-06-11','10:30:00',3.8),('16273','2013-06-11','10:35:00',2.91),('16273','2013-06-11','10:40:00',3.33),('16273','2013-06-11','10:45:00',2.37),('16273','2013-06-11','10:50:00',3.88),('16273','2013-06-11','10:55:00',3.93),('16273','2013-06-11','11:00:00',3.95),('16273','2013-06-11','11:05:00',3.91),('16273','2013-06-11','11:10:00',3.94),('16273','2013-06-11','11:15:00',3.99),('16273','2013-06-11','11:20:00',4.03),('16273','2013-06-11','11:25:00',4.01),('16273','2013-06-11','11:30:00',4.06),('16273','2013-06-11','11:35:00',4.05),('16273','2013-06-11','11:40:00',4.1),('16273','2013-06-11','11:45:00',4.06),('16273','2013-06-11','11:50:00',3.73),('16273','2013-06-11','11:55:00',3.84),('16273','2013-06-11','12:00:00',4.15),('16273','2013-06-11','12:05:00',4.14),('16273','2013-06-11','12:10:00',4.14),('16273','2013-06-11','12:15:00',4.14),('16273','2013-06-11','12:20:00',4.12),('16273','2013-06-11','12:25:00',4.14),('16273','2013-06-11','12:30:00',4.15),('16273','2013-06-11','12:35:00',4.14),('16273','2013-06-11','12:40:00',4.11),('16273','2013-06-11','12:45:00',4.13),('16273','2013-06-11','12:50:00',4.18),('16273','2013-06-11','12:55:00',4.14),('16273','2013-06-11','13:00:00',3.2),('16273','2013-06-11','13:05:00',4.22),('16273','2013-06-11','13:10:00',4.15),('16273','2013-06-11','13:15:00',4.13),('16273','2013-06-11','13:20:00',4.06),('16273','2013-06-11','13:25:00',4.13),('16273','2013-06-11','13:30:00',4.14),('16273','2013-06-11','13:35:00',3.77),('16273','2013-06-11','13:40:00',3.79),('16273','2013-06-11','13:45:00',4.08),('16273','2013-06-11','13:50:00',3.87),('16273','2013-06-11','13:55:00',3.96),('16273','2013-06-11','14:00:00',3.9),('16273','2013-06-11','14:05:00',3.94),('16273','2013-06-11','14:10:00',3.88),('16273','2013-06-11','14:15:00',3.85),('16273','2013-06-11','14:20:00',3.8),('16273','2013-06-11','14:25:00',3.78),('16273','2013-06-11','14:30:00',3.75),('16273','2013-06-11','14:35:00',3.7),('16273','2013-06-11','14:40:00',3.61),('16273','2013-06-11','14:45:00',3.65),('16273','2013-06-11','14:50:00',3.08),('16273','2013-06-11','14:55:00',3.58),('16273','2013-06-11','15:00:00',3.22),('16273','2013-06-11','15:05:00',3.39),('16273','2013-06-11','15:10:00',3.39),('16273','2013-06-11','15:15:00',2.89),('16273','2013-06-11','15:20:00',3.33),('16273','2013-06-11','15:25:00',3.38),('16273','2013-06-11','15:30:00',2.96),('16273','2013-06-11','15:35:00',3.22),('16273','2013-06-11','15:40:00',3.14),('16273','2013-06-11','15:45:00',2.88),('16273','2013-06-11','15:50:00',3.03),('16273','2013-06-11','15:55:00',2.57),('16273','2013-06-11','16:00:00',2.83),('16273','2013-06-11','16:05:00',2.79),('16273','2013-06-11','16:10:00',2.71),('16273','2013-06-11','16:15:00',2.67),('16273','2013-06-11','16:20:00',2.6),('16273','2013-06-11','16:25:00',2.51),('16273','2013-06-11','16:30:00',2.47),('16273','2013-06-11','16:35:00',2.43),('16273','2013-06-11','16:40:00',2.43),('16273','2013-06-11','16:45:00',2.42),('16273','2013-06-11','16:50:00',2.35),('16273','2013-06-11','16:55:00',2.2),('16273','2013-06-11','17:00:00',2.1),('16273','2013-06-11','17:05:00',1.24),('16273','2014-04-03','08:50:00',1.01),('16273','2014-04-03','08:55:00',1.11),('16273','2014-04-03','09:00:00',1.23),('16273','2014-04-03','09:05:00',1.29),('16273','2014-04-03','09:10:00',1.15),('16273','2014-04-03','09:15:00',1.12),('16273','2014-04-03','09:20:00',1.19),('16273','2014-04-03','09:25:00',1.33),('16273','2014-04-03','09:30:00',1.59),('16273','2014-04-03','09:35:00',1.7),('16273','2014-04-03','09:40:00',1.66),('16273','2014-04-03','09:45:00',1.66),('16273','2014-04-03','09:50:00',1.75),('16273','2014-04-03','09:55:00',2.01),('16273','2014-04-03','10:00:00',2.41),('16273','2014-04-03','10:05:00',2.56),('16273','2014-04-03','10:10:00',2.94),('16273','2014-04-03','10:15:00',3.09),('16273','2014-04-03','10:20:00',2.51),('16273','2014-04-03','10:25:00',1.99),('16273','2014-04-03','10:30:00',3.03),('16273','2014-04-03','10:35:00',2.51),('16273','2014-04-03','10:40:00',2.61),('16273','2014-04-03','10:45:00',2.64),('16273','2014-04-03','10:50:00',2.18),('16273','2014-04-03','10:55:00',1.91),('16273','2014-04-03','11:00:00',1.58),('16273','2014-04-03','11:05:00',1.51),('16273','2014-04-03','11:10:00',1.42),('16273','2014-04-03','11:15:00',1.32),('16273','2014-04-03','11:20:00',1.2),('16273','2014-04-03','11:25:00',1.16),('16273','2014-04-03','11:30:00',1.23),('16273','2014-04-03','11:35:00',1.37),('16273','2014-04-03','11:40:00',1.43),('16273','2014-04-03','11:45:00',1.62),('16273','2014-04-03','11:50:00',1.86),('16273','2014-04-03','11:55:00',1.99),('16273','2014-04-03','12:00:00',2.15),('16273','2014-04-03','12:05:00',2.04),('16273','2014-04-03','12:10:00',1.86),('16273','2014-04-03','12:15:00',2.03),('16273','2014-04-03','12:20:00',2.41),('16273','2014-04-03','12:25:00',3.31),('16273','2014-04-03','12:30:00',3.87),('16273','2014-04-03','12:35:00',2.71),('16273','2014-04-03','12:40:00',2.45),('16273','2014-04-03','12:45:00',2.01),('16273','2014-04-03','12:50:00',2.74),('16273','2014-04-03','12:55:00',2.18),('16273','2014-04-03','13:00:00',1.93),('16273','2014-04-03','13:05:00',2.31),('16273','2014-04-03','13:10:00',2.91),('16273','2014-04-03','13:15:00',2.54),('16273','2014-04-03','13:20:00',2.58),('16273','2014-04-03','13:25:00',2.83),('16273','2014-04-03','13:30:00',3.84),('16273','2014-04-03','13:35:00',3.26),('16273','2014-04-03','13:40:00',1.6),('16273','2014-04-03','13:45:00',1.84),('16273','2014-04-03','13:50:00',2.3),('16273','2014-04-03','13:55:00',2.08),('16273','2014-04-03','14:00:00',3.2),('16273','2014-04-03','14:05:00',3),('16273','2014-04-03','14:10:00',2.73),('16273','2014-04-03','14:15:00',3.37),('16273','2014-04-03','14:20:00',2.91),('16273','2014-04-03','14:25:00',3.06),('16273','2014-04-03','14:30:00',3.47),('16273','2014-04-03','14:35:00',3.31),('16273','2014-04-03','14:40:00',3.05),('16273','2014-04-03','14:45:00',3.05),('16273','2014-04-03','14:50:00',3.03),('16273','2014-04-03','14:55:00',2.99),('16273','2014-04-03','15:00:00',2.98),('16273','2014-04-03','15:05:00',2.92),('16273','2014-04-03','15:10:00',2.87),('16273','2014-04-03','15:15:00',2.82),('16273','2014-04-03','15:20:00',2.77),('16273','2014-04-03','15:25:00',2.73),('16273','2014-04-03','15:30:00',2.67),('16273','2014-04-03','15:35:00',2.64),('16273','2014-04-03','15:40:00',2.6),('16273','2014-04-03','15:45:00',2.52),('16273','2014-04-03','15:50:00',2.45),('16273','2014-04-03','15:55:00',2.42),('16273','2014-04-03','16:00:00',2.34),('16273','2014-04-03','16:05:00',2.23),('16273','2014-04-03','16:10:00',2.21),('16273','2014-04-03','16:15:00',2.14),('16273','2014-04-03','16:20:00',2.08),('16273','2014-04-03','16:25:00',1.98),('16273','2014-04-03','16:30:00',1.86),('16273','2014-04-03','16:35:00',1.82),('16273','2014-04-03','16:40:00',1.72),('16273','2014-04-03','16:45:00',1.71),('16273','2014-04-03','16:50:00',1.58),('16273','2014-04-03','16:55:00',1.33),('16273','2014-04-03','17:00:00',1.21),('16273','2014-04-03','17:05:00',1.09),('16273','2014-04-03','17:10:00',1.38),('16273','2014-04-03','17:15:00',1.57),('16273','2014-04-03','17:20:00',1.45),('16273','2014-04-03','17:25:00',1.29),('16273','2013-06-10','07:20:00',1.33),('16273','2013-06-10','07:25:00',1.48),('16273','2013-06-10','07:30:00',1.42),('16273','2013-06-10','07:55:00',1.12),('16273','2013-06-10','08:10:00',1.9),('16273','2013-06-10','08:15:00',1.13),('16273','2013-06-10','08:20:00',1.38),('16273','2013-06-10','08:25:00',1.41),('16273','2013-06-10','08:35:00',1.02),('16273','2013-06-10','08:45:00',2.45),('16273','2013-06-10','08:50:00',3.23),('16273','2013-06-10','08:55:00',1.48),('16273','2013-06-10','09:00:00',1.11),('16273','2013-06-10','09:05:00',1.08),('16273','2013-06-10','09:10:00',2.45),('16273','2013-06-10','09:15:00',3.37),('16273','2013-06-10','09:20:00',2.61),('16273','2013-06-10','09:25:00',1.97),('16273','2013-06-10','09:30:00',2.38),('16273','2013-06-10','09:35:00',1.35),('16273','2013-06-10','09:40:00',2.31),('16273','2013-06-10','09:45:00',2.34),('16273','2013-06-10','09:50:00',1.39),('16273','2013-06-10','09:55:00',1.72),('16273','2013-06-10','10:00:00',1.89),('16273','2013-06-10','10:05:00',1.79),('16273','2013-06-10','10:10:00',3.38),('16273','2013-06-10','10:15:00',2.37),('16273','2013-06-10','10:20:00',1.93),('16273','2013-06-10','10:25:00',3.02),('16273','2013-06-10','10:30:00',3.35),('16273','2013-06-10','10:35:00',2.73),('16273','2013-06-10','10:40:00',3.31),('16273','2013-06-10','10:45:00',3.55),('16273','2013-06-10','10:50:00',2.35),('16273','2013-06-10','10:55:00',3.14),('16273','2013-06-10','11:00:00',3.77),('16273','2013-06-10','11:05:00',2.51),('16273','2013-06-10','11:10:00',3.87),('16273','2013-06-10','11:15:00',4.07),('16273','2013-06-10','11:20:00',3.33),('16273','2013-06-10','11:25:00',1.88),('16273','2013-06-10','11:30:00',1.42),('16273','2013-06-10','11:35:00',1.28),('16273','2013-06-10','11:40:00',2.23),('16273','2013-06-10','11:45:00',1.41),('16273','2013-06-10','11:55:00',3.59),('16273','2013-06-10','12:00:00',3.45),('16273','2013-06-10','12:05:00',3.71),('16273','2013-06-10','12:10:00',4.21),('16273','2013-06-10','12:15:00',2.69),('16273','2013-06-10','12:20:00',2.27),('16273','2013-06-10','12:25:00',2.03),('16273','2013-06-10','12:30:00',4.86),('16273','2013-06-10','12:35:00',3.08),('16273','2013-06-10','12:40:00',2.06),('16273','2013-06-10','12:45:00',3),('16273','2013-06-10','12:50:00',1.39),('16273','2013-06-10','12:55:00',2.63),('16273','2013-06-10','13:00:00',3.49),('16273','2013-06-10','13:05:00',2.37),('16273','2013-06-10','13:10:00',3.22),('16273','2013-06-10','13:15:00',4.45),('16273','2013-06-10','13:20:00',2.98),('16273','2013-06-10','13:25:00',3.14),('16273','2013-06-10','13:30:00',1.75),('16273','2013-06-10','13:35:00',1.56),('16273','2013-06-10','13:40:00',4.35),('16273','2013-06-10','13:45:00',4.33),('16273','2013-06-10','13:50:00',3.37),('16273','2013-06-10','13:55:00',3.73),('16273','2013-06-10','14:00:00',4.01),('16273','2013-06-10','14:05:00',3.31),('16273','2013-06-10','14:10:00',3.4),('16273','2013-06-10','14:15:00',3.95),('16273','2013-06-10','14:20:00',3.78),('16273','2013-06-10','14:25:00',3.8),('16273','2013-06-10','14:30:00',3.76),('16273','2013-06-10','14:35:00',3.69),('16273','2013-06-10','14:40:00',3.65),('16273','2013-06-10','14:45:00',3.63),('16273','2013-06-10','14:50:00',3.59),('16273','2013-06-10','14:55:00',3.53),('16273','2013-06-10','15:00:00',3.5),('16273','2013-06-10','15:05:00',3.42),('16273','2013-06-10','15:10:00',3.41),('16273','2013-06-10','15:15:00',3.37),('16273','2013-06-10','15:20:00',3.33),('16273','2013-06-10','15:25:00',3.27),('16273','2013-06-10','15:30:00',3.22),('16273','2013-06-10','15:35:00',3.16),('16273','2013-06-10','15:40:00',3.14),('16273','2013-06-10','15:45:00',3.06),('16273','2013-06-10','15:50:00',2.99),('16273','2013-06-10','15:55:00',2.92),('16273','2013-06-10','16:00:00',2.88),('16273','2013-06-10','16:05:00',2.81),('16273','2013-06-10','16:10:00',2.75),('16273','2013-06-10','16:15:00',2.69),('16273','2013-06-10','16:20:00',2.6),('16273','2013-06-10','16:25:00',2.55),('16273','2013-06-10','16:30:00',2.46),('16273','2013-06-10','16:35:00',2.39),('16273','2013-06-10','16:40:00',2.32),('16273','2013-06-10','16:45:00',2.25),('16273','2013-06-10','16:50:00',2.16),('16273','2013-06-10','16:55:00',2.08),('16273','2013-06-10','17:00:00',2.01),('16273','2013-06-10','17:05:00',1.94),('16273','2013-06-10','17:10:00',1.84),('16273','2013-06-10','17:15:00',1.76),('16273','2013-06-10','17:20:00',1.68),('16273','2013-06-10','17:25:00',1.61),('16273','2013-06-10','17:30:00',1.53),('16273','2013-06-10','17:35:00',1.45),('16273','2013-06-10','17:40:00',1.36),('16273','2013-06-10','17:45:00',1.28),('16273','2013-06-10','17:50:00',1.2),('16273','2013-06-10','17:55:00',1.14),('16273','2013-06-10','18:00:00',1.06),('16273','2013-06-09','07:45:00',1.41),('16273','2013-06-09','07:50:00',1.16),('16273','2013-06-09','07:55:00',1.33),('16273','2013-06-09','08:00:00',1.78),('16273','2013-06-09','08:05:00',1.35),('16273','2013-06-09','08:10:00',1.46),('16273','2013-06-09','08:15:00',1.79),('16273','2013-06-09','08:20:00',2.14),('16273','2013-06-09','08:25:00',2.06),('16273','2013-06-09','08:30:00',2.29),('16273','2013-06-09','08:35:00',2.38),('16273','2013-06-09','08:40:00',2.37),('16273','2013-06-09','08:45:00',2.48),('16273','2013-06-09','08:50:00',2.62),('16273','2013-06-09','08:55:00',2.5),('16273','2013-06-09','09:00:00',2.7),('16273','2013-06-09','09:05:00',2.75),('16273','2013-06-09','09:10:00',2.76),('16273','2013-06-09','09:15:00',2.9),('16273','2013-06-09','09:20:00',2.94),('16273','2013-06-09','09:25:00',2.98),('16273','2013-06-09','09:30:00',3.04),('16273','2013-06-09','09:35:00',3.08),('16273','2013-06-09','09:40:00',3.09),('16273','2013-06-09','09:45:00',3.14),('16273','2013-06-09','09:50:00',3.21),('16273','2013-06-09','09:55:00',3.28),('16273','2013-06-09','10:00:00',3.3),('16273','2013-06-09','10:05:00',3.33),('16273','2013-06-09','10:10:00',3.37),('16273','2013-06-09','10:15:00',3.44),('16273','2013-06-09','10:20:00',3.42),('16273','2013-06-09','10:25:00',3.47),('16273','2013-06-09','10:30:00',3.5),('16273','2013-06-09','10:35:00',3.52),('16273','2013-06-09','10:40:00',3.55),('16273','2013-06-09','10:45:00',3.54),('16273','2013-06-09','10:50:00',3.48),('16273','2013-06-09','10:55:00',3.54),('16273','2013-06-09','11:00:00',3.62),('16273','2013-06-09','11:05:00',3.71),('16273','2013-06-09','11:10:00',3.73),('16273','2013-06-09','11:15:00',3.68),('16273','2013-06-09','11:20:00',3.73),('16273','2013-06-09','11:25:00',3.76),('16273','2013-06-09','11:30:00',3.85),('16273','2013-06-09','11:35:00',3.8),('16273','2013-06-09','11:40:00',3.72),('16273','2013-06-09','11:45:00',3.59),('16273','2013-06-09','11:50:00',2.78),('16273','2013-06-09','11:55:00',3.86),('16273','2013-06-09','12:00:00',3.95),('16273','2013-06-09','12:05:00',3.86),('16273','2013-06-09','12:10:00',3.91),('16273','2013-06-09','12:15:00',3.97),('16273','2013-06-09','12:20:00',3.83),('16273','2013-06-09','12:25:00',2.29),('16273','2013-06-09','12:30:00',3.24),('16273','2013-06-09','12:35:00',4.11),('16273','2013-06-09','12:40:00',3.89),('16273','2013-06-09','12:45:00',3.59),('16273','2013-06-09','12:50:00',3.37),('16273','2013-06-09','12:55:00',3.39),('16273','2013-06-09','13:00:00',3.66),('16273','2013-06-09','13:05:00',3.87),('16273','2013-06-09','13:10:00',3.75),('16273','2013-06-09','13:15:00',3.93),('16273','2013-06-09','13:20:00',3.68),('16273','2013-06-09','13:25:00',3.97),('16273','2013-06-09','13:30:00',4.02),('16273','2013-06-09','13:35:00',3.93),('16273','2013-06-09','13:40:00',3.36),('16273','2013-06-09','13:45:00',2.75),('16273','2013-06-09','13:50:00',2.77),('16273','2013-06-09','13:55:00',4.12),('16273','2013-06-09','14:00:00',4.07),('16273','2013-06-09','14:05:00',4.01),('16273','2013-06-09','14:10:00',3.81),('16273','2013-06-09','14:15:00',1.92),('16273','2013-06-09','14:20:00',1.06),('16273','2013-06-09','14:25:00',1.04),('16273','2013-06-09','14:30:00',2.04),('16273','2013-06-09','14:35:00',4.15),('16273','2013-06-09','14:40:00',3.38),('16273','2013-06-09','14:45:00',3.75),('16273','2013-06-09','14:50:00',3.56),('16273','2013-06-09','14:55:00',3.53),('16273','2013-06-09','15:00:00',3.02),('16273','2013-06-09','15:05:00',3.41),('16273','2013-06-09','15:10:00',3.36),('16273','2013-06-09','15:15:00',3.26),('16273','2013-06-09','15:20:00',3.18),('16273','2013-06-09','15:25:00',3.14),('16273','2013-06-09','15:30:00',3.01),('16273','2013-06-09','15:35:00',2.82),('16273','2013-06-09','15:40:00',2.27),('16273','2013-06-09','15:45:00',2.39),('16273','2013-06-09','15:50:00',2.95),('16273','2013-06-09','15:55:00',2.74),('16273','2013-06-09','16:00:00',2.92),('16273','2013-06-09','16:05:00',2.04),('16273','2013-06-09','16:10:00',2.34),('16273','2013-06-09','16:15:00',1.82),('16273','2013-06-09','16:20:00',1.9),('16273','2013-06-09','16:25:00',1.58),('16273','2013-06-09','18:05:00',1.2),('16273','2013-06-08','07:05:00',1.02),('16273','2013-06-08','07:10:00',1.09),('16273','2013-06-08','07:15:00',1.16),('16273','2013-06-08','07:20:00',1.23),('16273','2013-06-08','07:25:00',1.32),('16273','2013-06-08','07:30:00',1.36),('16273','2013-06-08','07:35:00',1.46),('16273','2013-06-08','07:40:00',1.52),('16273','2013-06-08','07:45:00',1.61),('16273','2013-06-08','07:50:00',1.71),('16273','2013-06-08','07:55:00',1.81),('16273','2013-06-08','08:00:00',1.88),('16273','2013-06-08','08:05:00',1.95),('16273','2013-06-08','08:10:00',2.02),('16273','2013-06-08','08:15:00',2.09),('16273','2013-06-08','08:20:00',2.18),('16273','2013-06-08','08:25:00',2.24),('16273','2013-06-08','08:30:00',2.32),('16273','2013-06-08','08:35:00',2.39),('16273','2013-06-08','08:40:00',2.48),('16273','2013-06-08','08:45:00',2.55),('16273','2013-06-08','08:50:00',2.59),('16273','2013-06-08','08:55:00',2.66),('16273','2013-06-08','09:00:00',2.69),('16273','2013-06-08','09:05:00',2.78),('16273','2013-06-08','09:10:00',2.92),('16273','2013-06-08','09:15:00',3.09),('16273','2013-06-08','09:20:00',3.27),('16273','2013-06-08','09:25:00',2.61),('16273','2013-06-08','09:30:00',1.74),('16273','2013-06-08','09:35:00',1.48),('16273','2013-06-08','09:40:00',1.3),('16273','2013-06-08','09:45:00',3.43),('16273','2013-06-08','09:50:00',3.28),('16273','2013-06-08','09:55:00',3.25),('16273','2013-06-08','10:00:00',1.28),('16273','2013-06-08','10:05:00',3.23),('16273','2013-06-08','10:10:00',2.2),('16273','2013-06-08','10:15:00',3.79),('16273','2013-06-08','10:20:00',3.76),('16273','2013-06-08','10:25:00',3.6),('16273','2013-06-08','10:30:00',3.67),('16273','2013-06-08','10:35:00',3.23),('16273','2013-06-08','10:40:00',2.58),('16273','2013-06-08','10:45:00',3.65),('16273','2013-06-08','10:50:00',4.02),('16273','2013-06-08','10:55:00',1.59),('16273','2013-06-08','11:00:00',1.24),('16273','2013-06-08','11:05:00',3.89),('16273','2013-06-08','11:10:00',4.25),('16273','2013-06-08','11:15:00',4.23),('16273','2013-06-08','11:20:00',4.1),('16273','2013-06-08','11:25:00',3.95),('16273','2013-06-08','11:30:00',3.87),('16273','2013-06-08','11:35:00',3.3),('16273','2013-06-08','11:40:00',4.07),('16273','2013-06-08','11:45:00',3.68),('16273','2013-06-08','11:50:00',4.08),('16273','2013-06-08','11:55:00',4.02),('16273','2013-06-08','12:00:00',4),('16273','2013-06-08','12:05:00',4.11),('16273','2013-06-08','12:10:00',3.76),('16273','2013-06-08','12:15:00',3.74),('16273','2013-06-08','12:20:00',3.95),('16273','2013-06-08','12:25:00',3.94),('16273','2013-06-08','12:30:00',3.91),('16273','2013-06-08','12:35:00',3.91),('16273','2013-06-08','12:40:00',4.01),('16273','2013-06-08','12:45:00',4.09),('16273','2013-06-08','12:50:00',4.02),('16273','2013-06-08','12:55:00',4.01),('16273','2013-06-08','13:00:00',4.01),('16273','2013-06-08','13:05:00',3.95),('16273','2013-06-08','13:10:00',4.01),('16273','2013-06-08','13:15:00',3.97),('16273','2013-06-08','13:20:00',3.99),('16273','2013-06-08','13:25:00',3.96),('16273','2013-06-08','13:30:00',3.9),('16273','2013-06-08','13:35:00',3.89),('16273','2013-06-08','13:40:00',3.87),('16273','2013-06-08','13:45:00',3.88),('16273','2013-06-08','13:50:00',3.89),('16273','2013-06-08','13:55:00',3.86),('16273','2013-06-08','14:00:00',3.84),('16273','2013-06-08','14:05:00',3.83),('16273','2013-06-08','14:10:00',3.83),('16273','2013-06-08','14:15:00',3.78),('16273','2013-06-08','14:20:00',3.76),('16273','2013-06-08','14:25:00',3.72),('16273','2013-06-08','14:30:00',3.68),('16273','2013-06-08','14:35:00',3.62),('16273','2013-06-08','14:40:00',3.61),('16273','2013-06-08','14:45:00',3.58),('16273','2013-06-08','14:50:00',3.53),('16273','2013-06-08','14:55:00',3.49),('16273','2013-06-08','15:00:00',3.38),('16273','2013-06-08','15:05:00',3.35),('16273','2013-06-08','15:10:00',3.22),('16273','2013-06-08','15:15:00',3.33),('16273','2013-06-08','15:20:00',3.25),('16273','2013-06-08','15:25:00',2.86),('16273','2013-06-08','15:30:00',2.79),('16273','2013-06-08','15:35:00',3.01),('16273','2013-06-08','15:40:00',3.15),('16273','2013-06-08','15:45:00',3.27),('16273','2013-06-08','15:50:00',2.93),('16273','2013-06-08','15:55:00',2.96),('16273','2013-06-08','16:00:00',2.88),('16273','2013-06-08','16:05:00',2.88),('16273','2013-06-08','16:10:00',2.85),('16273','2013-06-08','16:15:00',2.78),('16273','2013-06-08','16:20:00',2.66),('16273','2013-06-08','16:25:00',2.53),('16273','2013-06-08','16:30:00',2.44),('16273','2013-06-08','16:35:00',2.35),('16273','2013-06-08','16:40:00',2.29),('16273','2013-06-08','16:45:00',2),('16273','2013-06-08','16:50:00',1.95),('16273','2013-06-08','16:55:00',2.1),('16273','2013-06-08','17:00:00',2.06),('16273','2013-06-08','17:05:00',2.13),('16273','2013-06-08','17:10:00',2.06),('16273','2013-06-08','17:15:00',1.9),('16273','2013-06-08','17:20:00',1.75),('16273','2013-06-08','17:25:00',1.35),('16273','2013-06-08','17:30:00',1.19),('16273','2013-06-08','17:35:00',1.59),('16273','2013-06-08','17:40:00',1.51),('16273','2013-06-08','17:45:00',1.45),('16273','2013-06-08','17:50:00',1.35),('16273','2013-06-08','17:55:00',1.12),('16273','2013-06-07','07:05:00',1.07),('16273','2013-06-07','07:10:00',1.16),('16273','2013-06-07','07:15:00',1.25),('16273','2013-06-07','07:20:00',1.34),('16273','2013-06-07','07:25:00',1.42),('16273','2013-06-07','07:30:00',1.48),('16273','2013-06-07','07:35:00',1.59),('16273','2013-06-07','07:40:00',1.67),('16273','2013-06-07','07:45:00',1.75),('16273','2013-06-07','07:50:00',1.84),('16273','2013-06-07','07:55:00',1.93),('16273','2013-06-07','08:00:00',2.01),('16273','2013-06-07','08:05:00',2.09),('16273','2013-06-07','08:10:00',2.17),('16273','2013-06-07','08:15:00',2.25),('16273','2013-06-07','08:20:00',2.32),('16273','2013-06-07','08:25:00',2.39),('16273','2013-06-07','08:30:00',2.46),('16273','2013-06-07','08:35:00',2.53),('16273','2013-06-07','08:40:00',2.59),('16273','2013-06-07','08:45:00',2.67),('16273','2013-06-07','08:50:00',2.74),('16273','2013-06-07','08:55:00',2.8),('16273','2013-06-07','09:00:00',2.85),('16273','2013-06-07','09:05:00',2.9),('16273','2013-06-07','09:10:00',2.97),('16273','2013-06-07','09:15:00',2.99),('16273','2013-06-07','09:20:00',3.08),('16273','2013-06-07','09:25:00',3.12),('16273','2013-06-07','09:30:00',3.17),('16273','2013-06-07','09:35:00',3.23),('16273','2013-06-07','09:40:00',3.28),('16273','2013-06-07','09:45:00',3.32),('16273','2013-06-07','09:50:00',3.37),('16273','2013-06-07','09:55:00',3.43),('16273','2013-06-07','10:00:00',3.48),('16273','2013-06-07','10:05:00',3.52),('16273','2013-06-07','10:10:00',3.57),('16273','2013-06-07','10:15:00',3.61),('16273','2013-06-07','10:20:00',3.62),('16273','2013-06-07','10:25:00',3.66),('16273','2013-06-07','10:30:00',3.69),('16273','2013-06-07','10:35:00',3.72),('16273','2013-06-07','10:40:00',3.74),('16273','2013-06-07','10:45:00',3.76),('16273','2013-06-07','10:50:00',3.81),('16273','2013-06-07','10:55:00',3.84),('16273','2013-06-07','11:00:00',3.87),('16273','2013-06-07','11:05:00',3.87),('16273','2013-06-07','11:10:00',3.89),('16273','2013-06-07','11:15:00',3.91),('16273','2013-06-07','11:20:00',3.93),('16273','2013-06-07','11:25:00',3.94),('16273','2013-06-07','11:30:00',3.95),('16273','2013-06-07','11:35:00',3.96),('16273','2013-06-07','11:40:00',3.98),('16273','2013-06-07','11:45:00',4),('16273','2013-06-07','11:50:00',4.04),('16273','2013-06-07','11:55:00',4.03),('16273','2013-06-07','12:00:00',4.03),('16273','2013-06-07','12:05:00',4.04),('16273','2013-06-07','12:10:00',4.04),('16273','2013-06-07','12:15:00',4.05),('16273','2013-06-07','12:20:00',4.05),('16273','2013-06-07','12:25:00',4.03),('16273','2013-06-07','12:30:00',4.04),('16273','2013-06-07','12:35:00',4.02),('16273','2013-06-07','12:40:00',4.01),('16273','2013-06-07','12:45:00',4.02),('16273','2013-06-07','12:50:00',4),('16273','2013-06-07','12:55:00',3.97),('16273','2013-06-07','13:00:00',3.96),('16273','2013-06-07','13:05:00',3.95),('16273','2013-06-07','13:10:00',3.93),('16273','2013-06-07','13:15:00',3.91),('16273','2013-06-07','13:20:00',3.91),('16273','2013-06-07','13:25:00',3.87),('16273','2013-06-07','13:30:00',3.85),('16273','2013-06-07','13:35:00',3.84),('16273','2013-06-07','13:40:00',3.83),('16273','2013-06-07','13:45:00',3.82),('16273','2013-06-07','13:50:00',3.82),('16273','2013-06-07','13:55:00',3.8),('16273','2013-06-07','14:00:00',3.72),('16273','2013-06-07','14:05:00',3.7),('16273','2013-06-07','14:10:00',3.69),('16273','2013-06-07','14:15:00',3.67),('16273','2013-06-07','14:20:00',3.63),('16273','2013-06-07','14:25:00',3.59),('16273','2013-06-07','14:30:00',3.53),('16273','2013-06-07','14:35:00',3.45),('16273','2013-06-07','14:40:00',3.15),('16273','2013-06-07','14:45:00',3.41),('16273','2013-06-07','14:50:00',3.36),('16273','2013-06-07','14:55:00',3.38),('16273','2013-06-07','15:00:00',3.37),('16273','2013-06-07','15:05:00',3.36),('16273','2013-06-07','15:10:00',3.32),('16273','2013-06-07','15:15:00',3.3),('16273','2013-06-07','15:20:00',3.23),('16273','2013-06-07','15:25:00',3.21),('16273','2013-06-07','15:30:00',3.14),('16273','2013-06-07','15:35:00',3.08),('16273','2013-06-07','15:40:00',3.01),('16273','2013-06-07','15:45:00',2.96),('16273','2013-06-07','15:50:00',2.88),('16273','2013-06-07','15:55:00',2.73),('16273','2013-06-07','16:00:00',2.57),('16273','2013-06-07','16:05:00',2.7),('16273','2013-06-07','16:10:00',2.63),('16273','2013-06-07','16:15:00',2.53),('16273','2013-06-07','16:20:00',2.36),('16273','2013-06-07','16:25:00',2.47),('16273','2013-06-07','16:30:00',2.44),('16273','2013-06-07','16:35:00',2.35),('16273','2013-06-07','16:40:00',2.3),('16273','2013-06-07','16:45:00',2.2),('16273','2013-06-07','16:50:00',2.11),('16273','2013-06-07','16:55:00',2.05),('16273','2013-06-07','17:00:00',1.9),('16273','2013-06-07','17:05:00',1.83),('16273','2013-06-07','17:10:00',1.82),('16273','2013-06-07','17:15:00',1.76),('16273','2013-06-07','17:20:00',1.67),('16273','2013-06-07','17:25:00',1.57),('16273','2013-06-07','17:30:00',1.5),('16273','2013-06-07','17:35:00',1.44),('16273','2013-06-07','17:40:00',1.39),('16273','2013-06-07','17:45:00',1.33),('16273','2013-06-07','17:50:00',1.25),('16273','2013-06-07','17:55:00',1.2),('16273','2013-06-07','18:05:00',1.03),('16273','2013-06-06','07:00:00',1.19),('16273','2013-06-06','07:05:00',1.19),('16273','2013-06-06','07:45:00',1.62),('16273','2013-06-06','07:50:00',1.79),('16273','2013-06-06','07:55:00',1.84),('16273','2013-06-06','08:00:00',1.56),('16273','2013-06-06','08:05:00',1.82),('16273','2013-06-06','08:10:00',1.42),('16273','2013-06-06','08:15:00',2.01),('16273','2013-06-06','08:20:00',2.28),('16273','2013-06-06','08:25:00',2.34),('16273','2013-06-06','08:30:00',2.42),('16273','2013-06-06','08:35:00',2.47),('16273','2013-06-06','08:40:00',2.55),('16273','2013-06-06','08:45:00',2.5),('16273','2013-06-06','08:50:00',2.68),('16273','2013-06-06','08:55:00',2.63),('16273','2013-06-06','09:00:00',2.82),('16273','2013-06-06','09:05:00',2.84),('16273','2013-06-06','09:10:00',2.85),('16273','2013-06-06','09:15:00',2.95),('16273','2013-06-06','09:20:00',2.87),('16273','2013-06-06','09:25:00',3.04),('16273','2013-06-06','09:30:00',3.16),('16273','2013-06-06','09:35:00',3.24),('16273','2013-06-06','09:40:00',3.3),('16273','2013-06-06','09:45:00',3.25),('16273','2013-06-06','09:50:00',3.29),('16273','2013-06-06','09:55:00',3.29),('16273','2013-06-06','10:00:00',3.34),('16273','2013-06-06','10:05:00',3.44),('16273','2013-06-06','10:10:00',3.46),('16273','2013-06-06','10:15:00',3.54),('16273','2013-06-06','10:20:00',3.56),('16273','2013-06-06','10:25:00',3.61),('16273','2013-06-06','10:30:00',3.58),('16273','2013-06-06','10:35:00',3.64),('16273','2013-06-06','10:40:00',3.77),('16273','2013-06-06','10:45:00',3.79),('16273','2013-06-06','10:50:00',3.77),('16273','2013-06-06','10:55:00',3.86),('16273','2013-06-06','11:00:00',3.89),('16273','2013-06-06','11:05:00',3.83),('16273','2013-06-06','11:10:00',3.83),('16273','2013-06-06','11:15:00',3.9),('16273','2013-06-06','11:20:00',3.52),('16273','2013-06-06','11:25:00',3.87),('16273','2013-06-06','11:30:00',3.22),('16273','2013-06-06','11:35:00',3.98),('16273','2013-06-06','11:40:00',4),('16273','2013-06-06','11:45:00',3.99),('16273','2013-06-06','11:50:00',4.02),('16273','2013-06-06','11:55:00',4.03),('16273','2013-06-06','12:00:00',4.06),('16273','2013-06-06','12:05:00',4.08),('16273','2013-06-06','12:10:00',4.06),('16273','2013-06-06','12:15:00',4.04),('16273','2013-06-06','12:20:00',4),('16273','2013-06-06','12:25:00',3.98),('16273','2013-06-06','12:30:00',4.04),('16273','2013-06-06','12:35:00',4.05),('16273','2013-06-06','12:40:00',4),('16273','2013-06-06','12:45:00',4.01),('16273','2013-06-06','12:50:00',4.04),('16273','2013-06-06','12:55:00',4.23),('16273','2013-06-06','13:00:00',4.34),('16273','2013-06-06','13:05:00',4.31),('16273','2013-06-06','13:10:00',1.49),('16273','2013-06-06','13:15:00',1.17),('16273','2013-06-06','13:20:00',3.52),('16273','2013-06-06','13:25:00',4.21),('16273','2013-06-06','13:30:00',3.92),('16273','2013-06-06','13:35:00',3.96),('16273','2013-06-06','13:40:00',3.91),('16273','2013-06-06','13:45:00',3.89),('16273','2013-06-06','13:50:00',3.81),('16273','2013-06-06','13:55:00',3.76),('16273','2013-06-06','14:00:00',3.69),('16273','2013-06-06','14:05:00',3.76),('16273','2013-06-06','14:10:00',3.72),('16273','2013-06-06','14:15:00',3.7),('16273','2013-06-06','14:20:00',3.72),('16273','2013-06-06','14:25:00',3.69),('16273','2013-06-06','14:30:00',3.64),('16273','2013-06-06','14:35:00',3.6),('16273','2013-06-06','14:40:00',3.53),('16273','2013-06-06','14:45:00',3.49),('16273','2013-06-06','14:50:00',3.46),('16273','2013-06-06','14:55:00',3.41),('16273','2013-06-06','15:00:00',3.36),('16273','2013-06-06','15:05:00',3.32),('16273','2013-06-06','15:10:00',3.25),('16273','2013-06-06','15:15:00',3.2),('16273','2013-06-06','15:20:00',3.16),('16273','2013-06-06','15:25:00',3.09),('16273','2013-06-06','15:30:00',3.06),('16273','2013-06-06','15:35:00',3.01),('16273','2013-06-06','15:40:00',2.94),('16273','2013-06-06','15:45:00',2.87),('16273','2013-06-06','15:50:00',2.82),('16273','2013-06-06','15:55:00',2.78),('16273','2013-06-06','16:00:00',2.72),('16273','2013-06-06','16:05:00',2.68),('16273','2013-06-06','16:10:00',2.61),('16273','2013-06-06','16:15:00',2.55),('16273','2013-06-06','16:20:00',2.48),('16273','2013-06-06','16:25:00',2.44),('16273','2013-06-06','16:30:00',2.34),('16273','2013-06-06','16:35:00',2.29),('16273','2013-06-06','16:40:00',2.2),('16273','2013-06-06','16:45:00',2.13),('16273','2013-06-06','16:50:00',2.07),('16273','2013-06-06','16:55:00',2.01),('16273','2013-06-06','17:00:00',1.92),('16273','2013-06-06','17:05:00',1.85),('16273','2013-06-06','17:10:00',1.77),('16273','2013-06-06','17:15:00',1.68),('16273','2013-06-06','17:20:00',1.63),('16273','2013-06-06','17:25:00',1.56),('16273','2013-06-06','17:30:00',1.48),('16273','2013-06-06','17:35:00',1.41),('16273','2013-06-06','17:40:00',1.33),('16273','2013-06-06','17:45:00',1.24),('16273','2013-06-06','17:50:00',1.17),('16273','2013-06-06','17:55:00',1.09),('16273','2013-06-06','18:00:00',1.03),('16273','2013-06-05','07:10:00',1.16),('16273','2013-06-05','07:15:00',1.26),('16273','2013-06-05','07:20:00',1.47),('16273','2013-06-05','07:25:00',1.36),('16273','2013-06-05','07:45:00',1.33),('16273','2013-06-05','07:50:00',1.78),('16273','2013-06-05','07:55:00',1.85),('16273','2013-06-05','08:00:00',1.98),('16273','2013-06-05','08:05:00',2.08),('16273','2013-06-05','08:10:00',2.11),('16273','2013-06-05','08:15:00',2.19),('16273','2013-06-05','08:20:00',2.28),('16273','2013-06-05','08:25:00',2.33),('16273','2013-06-05','08:30:00',2.41),('16273','2013-06-05','08:35:00',2.5),('16273','2013-06-05','08:40:00',2.58),('16273','2013-06-05','08:45:00',2.58),('16273','2013-06-05','08:50:00',2.78),('16273','2013-06-05','08:55:00',2.88),('16273','2013-06-05','09:00:00',2.49),('16273','2013-06-05','09:05:00',1.22),('16273','2013-06-05','09:10:00',1.91),('16273','2013-06-05','09:15:00',3.19),('16273','2013-06-05','09:20:00',3.04),('16273','2013-06-05','09:25:00',2.89),('16273','2013-06-05','09:30:00',1.33),('16273','2013-06-05','09:35:00',1.42),('16273','2013-06-05','09:40:00',1.18),('16273','2013-06-05','09:45:00',2.02),('16273','2013-06-05','09:50:00',3.64),('16273','2013-06-05','09:55:00',3.66),('16273','2013-06-05','10:00:00',3.79),('16273','2013-06-05','10:05:00',3.8),('16273','2013-06-05','10:10:00',3.16),('16273','2013-06-05','10:15:00',1.65),('16273','2013-06-05','10:20:00',1.16),('16273','2013-06-05','10:25:00',1.13),('16273','2013-06-05','10:30:00',3.18),('16273','2013-06-05','10:35:00',4.01),('16273','2013-06-05','10:40:00',3.93),('16273','2013-06-05','10:45:00',2.12),('16273','2013-06-05','10:50:00',2.91),('16273','2013-06-05','10:55:00',4.05),('16273','2013-06-05','11:00:00',3.7),('16273','2013-06-05','11:05:00',4.51),('16273','2013-06-05','11:10:00',3.89),('16273','2013-06-05','11:15:00',4.41),('16273','2013-06-05','11:20:00',4.42),('16273','2013-06-05','11:25:00',4.4),('16273','2013-06-05','11:30:00',4.3),('16273','2013-06-05','11:35:00',4.26),('16273','2013-06-05','11:40:00',4.27),('16273','2013-06-05','11:45:00',4.31),('16273','2013-06-05','11:50:00',4.41),('16273','2013-06-05','11:55:00',3.48),('16273','2013-06-05','12:00:00',3.47),('16273','2013-06-05','12:05:00',1.6),('16273','2013-06-05','12:10:00',1.75),('16273','2013-06-05','12:15:00',4.51),('16273','2013-06-05','12:20:00',4.83),('16273','2013-06-05','12:25:00',3.78),('16273','2013-06-05','12:30:00',3.87),('16273','2013-06-05','12:35:00',2.37),('16273','2013-06-05','12:40:00',3.59),('16273','2013-06-05','12:45:00',1.78),('16273','2013-06-05','12:50:00',2.38),('16273','2013-06-05','12:55:00',3.93),('16273','2013-06-05','13:00:00',3.12),('16273','2013-06-05','13:05:00',3.85),('16273','2013-06-05','13:10:00',1.89),('16273','2013-06-05','13:15:00',2.82),('16273','2013-06-05','13:20:00',3.74),('16273','2013-06-05','13:25:00',4.04),('16273','2013-06-05','13:30:00',3.88),('16273','2013-06-05','13:35:00',3.17),('16273','2013-06-05','13:40:00',3.36),('16273','2013-06-05','13:45:00',2.84),('16273','2013-06-05','13:50:00',4.2),('16273','2013-06-05','13:55:00',3.84),('16273','2013-06-05','14:00:00',4),('16273','2013-06-05','14:05:00',3.98),('16273','2013-06-05','14:10:00',3.95),('16273','2013-06-05','14:15:00',3.45),('16273','2013-06-05','14:20:00',3.57),('16273','2013-06-05','14:25:00',3.86),('16273','2013-06-05','14:30:00',3.57),('16273','2013-06-05','14:35:00',3.03),('16273','2013-06-05','14:40:00',3.52),('16273','2013-06-05','14:45:00',3.71),('16273','2013-06-05','14:50:00',3.6),('16273','2013-06-05','14:55:00',3.54),('16273','2013-06-05','15:00:00',3.07),('16273','2013-06-05','15:05:00',3.49),('16273','2013-06-05','15:10:00',3.46),('16273','2013-06-05','15:15:00',3.11),('16273','2013-06-05','15:20:00',3.18),('16273','2013-06-05','15:25:00',3.48),('16273','2013-06-05','15:30:00',3.55),('16273','2013-06-05','15:35:00',2.38),('16273','2013-06-05','15:40:00',3.01),('16273','2013-06-05','15:45:00',2.36),('16273','2013-06-05','15:50:00',2.2),('16273','2013-06-05','15:55:00',2.35),('16273','2013-06-05','16:00:00',3.31),('16273','2013-06-05','16:05:00',2.7),('16273','2013-06-05','16:10:00',2.9),('16273','2013-06-05','16:15:00',2.09),('16273','2013-06-05','16:20:00',1.89),('16273','2013-06-05','16:25:00',1.47),('16273','2013-06-05','16:30:00',2.13),('16273','2013-06-05','16:35:00',2.77),('16273','2013-06-05','16:40:00',2.34),('16273','2013-06-05','16:45:00',1.44),('16273','2013-06-05','16:50:00',2.52),('16273','2013-06-05','16:55:00',1.86),('16273','2013-06-05','17:00:00',1.81),('16273','2013-06-05','17:05:00',1.44),('16273','2013-06-05','17:10:00',1.51),('16273','2013-06-05','17:15:00',1.61),('16273','2013-06-05','17:20:00',1.48),('16273','2013-06-05','17:25:00',1.1),('16273','2013-06-05','17:30:00',1.13),('16273','2013-06-05','17:35:00',1.06),('16273','2013-06-05','17:40:00',1.31),('16273','2013-06-05','17:45:00',1.3),('16273','2013-06-05','17:50:00',1.24),('16273','2013-06-05','17:55:00',1.11),('16273','2013-06-05','18:00:00',1.07),('16273','2013-06-05','18:20:00',1.1),('16273','2013-06-04','07:15:00',1.1),('16273','2013-06-04','07:20:00',1.35),('16273','2013-06-04','07:25:00',1.48),('16273','2013-06-04','07:30:00',1.7),('16273','2013-06-04','07:35:00',1.87),('16273','2013-06-04','07:40:00',2.05),('16273','2013-06-04','07:45:00',2.19),('16273','2013-06-04','07:50:00',2.14),('16273','2013-06-04','07:55:00',1.65),('16273','2013-06-04','08:00:00',1.5),('16273','2013-06-04','08:05:00',2.02),('16273','2013-06-04','08:10:00',2.34),('16273','2013-06-04','08:15:00',2.58),('16273','2013-06-04','08:20:00',2.92),('16273','2013-06-04','08:25:00',2.89),('16273','2013-06-04','08:30:00',2.33),('16273','2013-06-04','08:35:00',1.57),('16273','2013-06-04','08:40:00',1.55),('16273','2013-06-04','08:45:00',1.37),('16273','2013-06-04','08:50:00',1.37),('16273','2013-06-04','08:55:00',1.66),('16273','2013-06-04','09:00:00',1.45),('16273','2013-06-04','09:05:00',1.5),('16273','2013-06-04','09:10:00',2.2),('16273','2013-06-04','09:15:00',2.73),('16273','2013-06-04','09:20:00',3.07),('16273','2013-06-04','09:25:00',2.8),('16273','2013-06-04','09:30:00',2.99),('16273','2013-06-04','09:35:00',2.86),('16273','2013-06-04','09:40:00',2.48),('16273','2013-06-04','09:45:00',1.51),('16273','2013-06-04','09:50:00',1.26),('16273','2013-06-04','09:55:00',1.04),('16273','2013-06-04','10:00:00',1.21),('16273','2013-06-04','10:05:00',1.53),('16273','2013-06-04','10:10:00',2.41),('16273','2013-06-04','10:15:00',1.95),('16273','2013-06-04','10:20:00',1.7),('16273','2013-06-04','10:25:00',1.64),('16273','2013-06-04','10:30:00',1.83),('16273','2013-06-04','10:35:00',1.84),('16273','2013-06-04','10:40:00',2.13),('16273','2013-06-04','10:45:00',2.42),('16273','2013-06-04','10:50:00',2.81),('16273','2013-06-04','10:55:00',2.56),('16273','2013-06-04','11:00:00',2.54),('16273','2013-06-04','11:05:00',3.43),('16273','2013-06-04','11:10:00',2.8),('16273','2013-06-04','11:15:00',2.24),('16273','2013-06-04','11:20:00',2.34),('16273','2013-06-04','11:25:00',3.43),('16273','2013-06-04','11:30:00',3.21),('16273','2013-06-04','11:35:00',3.66),('16273','2013-06-04','11:40:00',3.06),('16273','2013-06-04','11:45:00',4.03),('16273','2013-06-04','11:50:00',4.47),('16273','2013-06-04','11:55:00',4.36),('16273','2013-06-04','12:00:00',4.6),('16273','2013-06-04','12:05:00',3.01),('16273','2013-06-04','12:10:00',2.05),('16273','2013-06-04','12:15:00',3.13),('16273','2013-06-04','12:20:00',2.59),('16273','2013-06-04','12:25:00',2.44),('16273','2013-06-04','12:30:00',2.96),('16273','2013-06-04','12:35:00',2.27),('16273','2013-06-04','12:40:00',2.52),('16273','2013-06-04','12:45:00',1.9),('16273','2013-06-04','12:50:00',2.67),('16273','2013-06-04','12:55:00',2.6),('16273','2013-06-04','13:00:00',1.66),('16273','2013-06-04','13:05:00',1.8),('16273','2013-06-04','13:10:00',2.88),('16273','2013-06-04','13:15:00',3.09),('16273','2013-06-04','13:20:00',3.6),('16273','2013-06-04','13:25:00',3.95),('16273','2013-06-04','13:30:00',2.76),('16273','2013-06-04','13:35:00',2.4),('16273','2013-06-04','13:40:00',2.87),('16273','2013-06-04','13:45:00',3.03),('16273','2013-06-04','13:50:00',2.24),('16273','2013-06-04','13:55:00',2.24),('16273','2013-06-04','14:00:00',2.39),('16273','2013-06-04','14:05:00',4.22),('16273','2013-06-04','14:10:00',2.88),('16273','2013-06-04','14:15:00',1.32),('16273','2013-06-04','14:20:00',1.04),('16273','2013-06-04','14:25:00',1.27),('16273','2013-06-04','14:30:00',2.51),('16273','2013-06-04','14:35:00',4.24),('16273','2013-06-04','14:40:00',4.47),('16273','2013-06-04','14:45:00',4.38),('16273','2013-06-04','14:50:00',3.98),('16273','2013-06-04','14:55:00',4.28),('16273','2013-06-04','15:00:00',3.45),('16273','2013-06-04','15:05:00',2.29),('16273','2013-06-04','15:10:00',3.84),('16273','2013-06-04','15:15:00',3.69),('16273','2013-06-04','15:20:00',1.91),('16273','2013-06-04','15:25:00',2.22),('16273','2013-06-04','15:30:00',2.13),('16273','2013-06-04','15:35:00',1.24),('16273','2013-06-04','15:40:00',1),('16273','2013-06-04','15:50:00',1.01),('16273','2013-06-04','15:55:00',1.08),('16273','2013-06-04','16:00:00',1.71),('16273','2013-06-04','16:05:00',1.6),('16273','2013-06-04','16:10:00',1.79),('16273','2013-06-04','16:15:00',1.88),('16273','2013-06-04','16:20:00',1.57),('16273','2013-06-04','16:25:00',1.87),('16273','2013-06-04','16:30:00',2.71),('16273','2013-06-04','16:35:00',3.25),('16273','2013-06-04','16:40:00',2.16),('16273','2013-06-04','16:45:00',1.48),('16273','2013-06-03','06:55:00',1.1),('16273','2013-06-03','07:05:00',1.19),('16273','2013-06-03','07:10:00',1.23),('16273','2013-06-03','07:15:00',1.19),('16273','2013-06-03','07:20:00',1.34),('16273','2013-06-03','07:25:00',1.38),('16273','2013-06-03','07:30:00',1.44),('16273','2013-06-03','07:35:00',1.51),('16273','2013-06-03','07:40:00',1.64),('16273','2013-06-03','07:45:00',1.72),('16273','2013-06-03','07:50:00',1.8),('16273','2013-06-03','07:55:00',1.9),('16273','2013-06-03','08:00:00',1.97),('16273','2013-06-03','08:05:00',2.04),('16273','2013-06-03','08:10:00',2.12),('16273','2013-06-03','08:15:00',2.18),('16273','2013-06-03','08:20:00',2.25),('16273','2013-06-03','08:25:00',2.36),('16273','2013-06-03','08:30:00',2.4),('16273','2013-06-03','08:35:00',2.29),('16273','2013-06-03','08:40:00',2.55),('16273','2013-06-03','08:45:00',2.74),('16273','2013-06-03','08:50:00',2.83),('16273','2013-06-03','08:55:00',2.15),('16273','2013-06-03','09:00:00',2.2),('16273','2013-06-03','09:05:00',1.75),('16273','2013-06-03','09:10:00',2.81),('16273','2013-06-03','09:15:00',3),('16273','2013-06-03','09:20:00',2.35),('16273','2013-06-03','09:25:00',1.7),('16273','2013-06-03','10:05:00',1.05),('16273','2013-06-03','10:10:00',1.21),('16273','2013-06-03','10:15:00',1.55),('16273','2013-06-03','10:20:00',2.77),('16273','2013-06-03','10:25:00',2.99),('16273','2013-06-03','10:30:00',3.26),('16273','2013-06-03','10:35:00',3.26),('16273','2013-06-03','10:40:00',2.24),('16273','2013-06-03','10:45:00',2.05),('16273','2013-06-03','10:50:00',2.18),('16273','2013-06-03','10:55:00',1.73),('16273','2013-06-03','11:00:00',2.68),('16273','2013-06-03','11:05:00',4.53),('16273','2013-06-03','11:10:00',2.74),('16273','2013-06-03','11:15:00',2.11),('16273','2013-06-03','11:20:00',1.75),('16273','2013-06-03','11:25:00',2),('16273','2013-06-03','11:30:00',3.32),('16273','2013-06-03','11:35:00',3.96),('16273','2013-06-03','11:40:00',4.46),('16273','2013-06-03','11:45:00',2.37),('16273','2013-06-03','11:50:00',1.52),('16273','2013-06-03','11:55:00',1.69),('16273','2013-06-03','12:00:00',2.08),('16273','2013-06-03','12:05:00',1.34),('16273','2013-06-03','12:10:00',1.04),('16273','2013-06-03','12:25:00',2.76),('16273','2013-06-03','12:30:00',1.3),('16273','2013-06-03','12:50:00',1.28),('16273','2013-06-03','12:55:00',2.43),('16273','2013-06-03','13:00:00',1.47),('16273','2013-06-03','13:05:00',1.51),('16273','2013-06-03','13:10:00',1.68),('16273','2013-06-03','13:15:00',2.98),('16273','2013-06-03','13:20:00',2.09),('16273','2013-06-03','13:25:00',2.82),('16273','2013-06-03','13:30:00',3),('16273','2013-06-03','13:35:00',3.17),('16273','2013-06-03','13:40:00',4.12),('16273','2013-06-03','13:45:00',4.55),('16273','2013-06-03','13:50:00',2.41),('16273','2013-06-03','13:55:00',3.91),('16273','2013-06-03','14:00:00',2.84),('16273','2013-06-03','14:05:00',4.21),('16273','2013-06-03','14:10:00',3.3),('16273','2013-06-03','14:15:00',2.71),('16273','2013-06-03','14:20:00',2.08),('16273','2013-06-03','14:25:00',2.7),('16273','2013-06-03','14:30:00',3.88),('16273','2013-06-03','14:35:00',3.88),('16273','2013-06-03','14:40:00',3.68),('16273','2013-06-03','14:45:00',3.12),('16273','2013-06-03','14:50:00',3.76),('16273','2013-06-03','14:55:00',2.77),('16273','2013-06-03','15:00:00',3.76),('16273','2013-06-03','15:05:00',3.56),('16273','2013-06-03','15:10:00',3.28),('16273','2013-06-03','15:15:00',3),('16273','2013-06-03','15:20:00',3.62),('16273','2013-06-03','15:25:00',3.25),('16273','2013-06-03','15:30:00',2.58),('16273','2013-06-03','15:35:00',2.97),('16273','2013-06-03','15:40:00',3.14),('16273','2013-06-03','15:45:00',3.11),('16273','2013-06-03','15:50:00',3.08),('16273','2013-06-03','15:55:00',3.01),('16273','2013-06-03','16:00:00',2.92),('16273','2013-06-03','16:05:00',2.84),('16273','2013-06-03','16:10:00',2.8),('16273','2013-06-03','16:15:00',2.66),('16273','2013-06-03','16:20:00',2.35),('16273','2013-06-03','16:25:00',2.39),('16273','2013-06-03','16:30:00',2.48),('16273','2013-06-03','16:35:00',2.09),('16273','2013-06-03','16:40:00',1.95),('16273','2013-06-03','16:45:00',1.74),('16273','2013-06-03','16:50:00',1.78),('16273','2013-06-03','16:55:00',2.5),('16273','2013-06-03','17:00:00',1.85),('16273','2013-06-03','17:05:00',1.7),('16273','2013-06-03','17:10:00',1.82),('16273','2013-06-03','17:15:00',1.56),('16273','2013-06-03','17:20:00',1.6),('16273','2013-06-03','17:25:00',1.6),('16273','2013-06-03','17:30:00',1.63),('16273','2013-06-03','17:35:00',1.27),('16273','2013-06-02','06:45:00',1.21),('16273','2013-06-02','06:50:00',1.29),('16273','2013-06-02','08:35:00',1.47),('16273','2013-06-02','08:40:00',1.24),('16273','2013-06-02','08:45:00',1.05),('16273','2013-06-02','09:10:00',2.93),('16273','2013-06-02','09:15:00',3.22),('16273','2013-06-02','09:20:00',3.3),('16273','2013-06-02','09:25:00',3.29),('16273','2013-06-02','09:30:00',3.27),('16273','2013-06-02','09:35:00',3.36),('16273','2013-06-02','09:40:00',3.37),('16273','2013-06-02','09:45:00',3.38),('16273','2013-06-02','09:50:00',3.28),('16273','2013-06-02','09:55:00',3.25),('16273','2013-06-02','10:00:00',3.59),('16273','2013-06-02','10:05:00',3.66),('16273','2013-06-02','10:10:00',3.79),('16273','2013-06-02','10:15:00',3.98),('16273','2013-06-02','10:20:00',3.89),('16273','2013-06-02','10:25:00',3.69),('16273','2013-06-02','10:30:00',3.16),('16273','2013-06-02','10:35:00',3.55),('16273','2013-06-02','10:40:00',4.2),('16273','2013-06-02','10:45:00',4.45),('16273','2013-06-02','10:50:00',3.81),('16273','2013-06-02','10:55:00',1.61),('16273','2013-06-02','11:00:00',2.98),('16273','2013-06-02','11:05:00',1.96),('16273','2013-06-02','11:10:00',1.92),('16273','2013-06-02','11:15:00',3.05),('16273','2013-06-02','11:20:00',4.76),('16273','2013-06-02','11:25:00',3.22),('16273','2013-06-02','11:30:00',1.6),('16273','2013-06-02','11:35:00',3.55),('16273','2013-06-02','11:40:00',2.81),('16273','2013-06-02','11:45:00',2.45),('16273','2013-06-02','11:50:00',3.09),('16273','2013-06-02','11:55:00',4.6),('16273','2013-06-02','12:00:00',3.87),('16273','2013-06-02','12:05:00',3.63),('16273','2013-06-02','12:10:00',2.94),('16273','2013-06-02','12:15:00',4.63),('16273','2013-06-02','12:20:00',4.45),('16273','2013-06-02','12:25:00',4.27),('16273','2013-06-02','12:30:00',4.15),('16273','2013-06-02','12:35:00',4.23),('16273','2013-06-02','12:40:00',2.68),('16273','2013-06-02','12:45:00',3.81),('16273','2013-06-02','12:50:00',4.07),('16273','2013-06-02','12:55:00',4.25),('16273','2013-06-02','13:00:00',3.97),('16273','2013-06-02','13:05:00',4.25),('16273','2013-06-02','13:10:00',4.14),('16273','2013-06-02','13:15:00',4.13),('16273','2013-06-02','13:20:00',4.13),('16273','2013-06-02','13:25:00',4.11),('16273','2013-06-02','13:30:00',4.07),('16273','2013-06-02','13:35:00',4.03),('16273','2013-06-02','13:40:00',3.82),('16273','2013-06-02','13:45:00',3.46),('16273','2013-06-02','13:50:00',4.06),('16273','2013-06-02','13:55:00',3.87),('16273','2013-06-02','14:00:00',3.87),('16273','2013-06-02','14:05:00',3.17),('16273','2013-06-02','14:10:00',4.04),('16273','2013-06-02','14:15:00',3.96),('16273','2013-06-02','14:20:00',3.97),('16273','2013-06-02','14:25:00',3.32),('16273','2013-06-02','14:30:00',3.85),('16273','2013-06-02','14:35:00',3.72),('16273','2013-06-02','14:40:00',3.27),('16273','2013-06-02','14:45:00',3.67),('16273','2013-06-02','14:50:00',2.36),('16273','2013-06-02','14:55:00',3.24),('16273','2013-06-02','15:00:00',3.57),('16273','2013-06-02','15:05:00',3.08),('16273','2013-06-02','15:10:00',3.22),('16273','2013-06-02','15:15:00',2.51),('16273','2013-06-02','15:20:00',3.07),('16273','2013-06-02','15:25:00',2.96),('16273','2013-06-02','15:30:00',1.69),('16273','2013-06-02','15:35:00',3.01),('16273','2013-06-02','15:40:00',3.35),('16273','2013-06-02','15:45:00',2.55),('16273','2013-06-02','15:50:00',3.13),('16273','2013-06-02','15:55:00',3.06),('16273','2013-06-02','16:00:00',1.68),('16273','2013-06-02','16:05:00',2.14),('16273','2013-06-02','16:10:00',2.01),('16273','2013-06-02','16:15:00',2.85),('16273','2013-06-02','16:20:00',2.27),('16273','2013-06-02','16:25:00',2.53),('16273','2013-06-02','16:30:00',2.17),('16273','2013-06-02','16:35:00',2.42),('16273','2013-06-02','16:40:00',2.3),('16273','2013-06-02','16:45:00',1.7),('16273','2013-06-02','16:50:00',2.21),('16273','2013-06-02','16:55:00',1.84),('16273','2013-06-02','17:00:00',1.88),('16273','2013-06-02','17:05:00',1.84),('16273','2013-06-02','17:10:00',1.77),('16273','2013-06-02','17:15:00',1.41),('16273','2013-06-02','17:20:00',1.76),('16273','2013-06-02','17:25:00',1.09),('16273','2013-06-02','17:30:00',1.25),('16273','2013-06-02','17:35:00',1.2),('16273','2013-06-02','17:40:00',1.25),('16273','2013-06-02','17:45:00',1.36),('16273','2013-06-02','17:50:00',1.22),('16273','2013-06-02','17:55:00',1.24),('16273','2013-06-02','18:00:00',1.03),('16273','2013-06-01','07:05:00',1.12),('16273','2013-06-01','07:10:00',1.22),('16273','2013-06-01','07:15:00',1.31),('16273','2013-06-01','07:20:00',1.4),('16273','2013-06-01','07:25:00',1.49),('16273','2013-06-01','07:30:00',1.58),('16273','2013-06-01','07:35:00',1.7),('16273','2013-06-01','07:40:00',1.92),('16273','2013-06-01','07:45:00',1.77),('16273','2013-06-01','07:50:00',1.14),('16273','2013-06-01','08:25:00',1.59),('16273','2013-06-01','08:30:00',1.27),('16273','2013-06-01','08:40:00',1.32),('16273','2013-06-01','08:55:00',2.13),('16273','2013-06-01','10:20:00',1.24),('16273','2013-06-01','10:25:00',1.13),('16273','2013-06-01','10:30:00',1.38),('16273','2013-06-01','10:35:00',1.63),('16273','2013-06-01','10:40:00',1.98),('16273','2013-06-01','10:45:00',2.41),('16273','2013-06-01','10:50:00',1.67),('16273','2013-06-01','10:55:00',1.15),('16273','2013-06-01','11:00:00',1.37),('16273','2013-06-01','11:10:00',1.01),('16273','2013-06-01','11:15:00',1.39),('16273','2013-06-01','11:20:00',1.27),('16273','2013-06-01','11:25:00',1.59),('16273','2013-06-01','11:30:00',1.23),('16273','2013-06-01','11:35:00',1.02),('16273','2013-06-01','11:40:00',1.37),('16273','2013-06-01','11:45:00',2.03),('16273','2013-06-01','11:50:00',1.82),('16273','2013-06-01','11:55:00',1.97),('16273','2013-06-01','12:00:00',1.16),('16273','2013-06-01','12:05:00',3.26),('16273','2013-06-01','12:10:00',1.09),('16273','2013-06-01','12:15:00',1.26),('16273','2013-06-01','12:20:00',2.64),('16273','2013-06-01','12:25:00',2.12),('16273','2013-06-01','12:30:00',1.78),('16273','2013-06-01','12:35:00',2.07),('16273','2013-06-01','12:40:00',1.82),('16273','2013-06-01','12:45:00',1.95),('16273','2013-06-01','12:50:00',2.13),('16273','2013-06-01','12:55:00',2.14),('16273','2013-06-01','13:00:00',2.02),('16273','2013-06-01','13:05:00',2.16),('16273','2013-06-01','13:10:00',2.35),('16273','2013-06-01','13:15:00',2.57),('16273','2013-06-01','13:20:00',2.29),('16273','2013-06-01','13:25:00',2.12),('16273','2013-06-01','13:30:00',1.72),('16273','2013-06-01','13:35:00',1.65),('16273','2013-06-01','13:40:00',2.04),('16273','2013-06-01','13:45:00',1.29),('16273','2013-06-01','13:50:00',1.72),('16273','2013-06-01','13:55:00',2.03),('16273','2013-06-01','14:00:00',2.62),('16273','2013-06-01','14:05:00',2.41),('16273','2013-06-01','14:10:00',2.19),('16273','2013-06-01','14:15:00',2.4),('16273','2013-06-01','14:20:00',1.65),('16273','2013-06-01','14:25:00',1.28),('16273','2013-06-01','14:30:00',1.06),('16273','2013-06-01','14:40:00',1.01),('16273','2013-06-01','14:45:00',1.16),('16273','2013-06-01','14:50:00',1.14),('16273','2013-06-01','15:30:00',1.05),('16273','2013-06-01','15:35:00',1.52),('16273','2013-06-01','15:40:00',1.78),('16273','2013-06-01','15:45:00',1.66),('16273','2013-06-01','15:50:00',2.14),('16273','2013-06-01','15:55:00',1.61),('16273','2013-06-01','16:00:00',1.05),('16273','2013-06-01','16:15:00',1.13),('16273','2013-06-01','16:20:00',1.12),('16273','2013-06-01','16:25:00',1.1),('16273','2013-06-01','16:35:00',1.09),('16273','2013-06-01','16:40:00',1.18),('16273','2013-06-01','16:45:00',1.06),('16273','2013-06-01','18:30:00',1.09),('16273','2014-04-02','08:10:00',1.31),('16273','2014-04-02','08:15:00',1.23),('16273','2014-04-02','09:00:00',1.23),('16273','2014-04-02','09:05:00',1.46),('16273','2014-04-02','09:10:00',1.6),('16273','2014-04-02','09:15:00',1.19),('16273','2014-04-02','09:20:00',2),('16273','2014-04-02','09:25:00',2.84),('16273','2014-04-02','09:30:00',2.56),('16273','2014-04-02','09:35:00',1.33),('16273','2014-04-02','09:55:00',1.02),('16273','2014-04-02','10:00:00',1.1),('16273','2014-04-02','10:05:00',1.06),('16273','2014-04-02','10:10:00',1.3),('16273','2014-04-02','10:15:00',2.18),('16273','2014-04-02','10:20:00',2.53),('16273','2014-04-02','10:25:00',2.98),('16273','2014-04-02','10:30:00',3.38),('16273','2014-04-02','10:35:00',3.3),('16273','2014-04-02','10:40:00',1.61),('16273','2014-04-02','10:45:00',1.04),('16273','2014-04-02','11:10:00',1.41),('16273','2014-04-02','11:15:00',2.85),('16273','2014-04-02','11:20:00',1.4),('16273','2014-04-02','11:25:00',1.44),('16273','2014-04-02','11:30:00',1.36),('16273','2014-04-02','11:35:00',1.41),('16273','2014-04-02','11:40:00',2.49),('16273','2014-04-02','11:45:00',4.06),('16273','2014-04-02','11:50:00',4),('16273','2014-04-02','11:55:00',3.38),('16273','2014-04-02','12:00:00',1.5),('16273','2014-04-02','12:05:00',1.23),('16273','2014-04-02','12:10:00',4.34),('16273','2014-04-02','12:15:00',4.29),('16273','2014-04-02','12:20:00',3.69),('16273','2014-04-02','12:25:00',4.32),('16273','2014-04-02','12:30:00',4.27),('16273','2014-04-02','12:35:00',2.23),('16273','2014-04-02','12:40:00',2.14),('16273','2014-04-02','12:45:00',1.22),('16273','2014-04-02','12:50:00',2.4),('16273','2014-04-02','12:55:00',2.21),('16273','2014-04-02','13:00:00',2.1),('16273','2014-04-02','13:05:00',1.99),('16273','2014-04-02','13:10:00',1.27),('16273','2014-04-02','13:15:00',1.07),('16273','2014-04-02','13:20:00',1.5),('16273','2014-04-02','13:25:00',1.8),('16273','2014-04-02','13:30:00',3.42),('16273','2014-04-02','13:35:00',3.03),('16273','2014-04-02','13:40:00',3.35),('16273','2014-04-02','13:45:00',3.22),('16273','2014-04-02','13:50:00',3.15),('16273','2014-04-02','13:55:00',1.51),('16273','2014-04-02','14:00:00',3.01),('16273','2014-04-02','14:05:00',2.81),('16273','2014-04-02','14:10:00',2.68),('16273','2014-04-02','14:15:00',3.01),('16273','2014-04-02','14:20:00',1.98),('16273','2014-04-02','14:25:00',3.6),('16273','2014-04-02','14:30:00',3.45),('16273','2014-04-02','14:35:00',3.42),('16273','2014-04-02','14:40:00',3.35),('16273','2014-04-02','14:45:00',3.24),('16273','2014-04-02','14:50:00',2.97),('16273','2014-04-02','14:55:00',3.05),('16273','2014-04-02','15:00:00',3.04),('16273','2014-04-02','15:05:00',2.87),('16273','2014-04-02','15:10:00',2.9),('16273','2014-04-02','15:15:00',2.9),('16273','2014-04-02','15:20:00',2.86),('16273','2014-04-02','15:25:00',2.78),('16273','2014-04-02','15:30:00',2.62),('16273','2014-04-02','15:35:00',2.59),('16273','2014-04-02','15:40:00',2.58),('16273','2014-04-02','15:45:00',2.54),('16273','2014-04-02','15:50:00',2.47),('16273','2014-04-02','15:55:00',2.3),('16273','2014-04-02','16:00:00',2.29),('16273','2014-04-02','16:05:00',2.18),('16273','2014-04-02','16:10:00',2.1),('16273','2014-04-02','16:15:00',2.02),('16273','2014-04-02','16:20:00',2.03),('16273','2014-04-02','16:25:00',1.88),('16273','2014-04-02','16:30:00',1.94),('16273','2014-04-02','16:35:00',1.82),('16273','2014-04-02','16:40:00',1.73),('16273','2014-04-02','16:45:00',1.63),('16273','2014-04-02','16:50:00',1.52),('16273','2014-04-02','16:55:00',1.53),('16273','2014-04-02','17:00:00',1.46),('16273','2014-04-02','17:05:00',1.28),('16273','2014-04-02','17:10:00',1.22),('16273','2014-04-02','17:15:00',1.08),('16273','2014-04-02','17:20:00',1.09),('16273','2014-04-02','17:25:00',1.01),('16273','2013-05-31','07:05:00',1.07),('16273','2013-05-31','07:10:00',1.18),('16273','2013-05-31','07:15:00',1.29),('16273','2013-05-31','07:20:00',1.39),('16273','2013-05-31','07:25:00',1.47),('16273','2013-05-31','07:30:00',1.56),('16273','2013-05-31','07:35:00',1.65),('16273','2013-05-31','07:40:00',1.73),('16273','2013-05-31','07:45:00',1.81),('16273','2013-05-31','07:50:00',1.92),('16273','2013-05-31','07:55:00',2.05),('16273','2013-05-31','08:00:00',2.04),('16273','2013-05-31','08:05:00',2.15),('16273','2013-05-31','08:10:00',2.24),('16273','2013-05-31','08:15:00',2.3),('16273','2013-05-31','08:20:00',2.38),('16273','2013-05-31','08:25:00',2.46),('16273','2013-05-31','08:30:00',2.3),('16273','2013-05-31','08:35:00',1.32),('16273','2013-05-31','08:40:00',2.81),('16273','2013-05-31','08:45:00',3.02),('16273','2013-05-31','08:50:00',1.99),('16273','2013-05-31','08:55:00',1.48),('16273','2013-05-31','09:00:00',2.56),('16273','2013-05-31','09:05:00',2.99),('16273','2013-05-31','09:10:00',1.39),('16273','2013-05-31','09:15:00',2.43),('16273','2013-05-31','09:20:00',1.22),('16273','2013-05-31','09:25:00',1.51),('16273','2013-05-31','09:30:00',2.69),('16273','2013-05-31','09:35:00',3.6),('16273','2013-05-31','09:40:00',3.63),('16273','2013-05-31','09:45:00',3.85),('16273','2013-05-31','09:50:00',2.31),('16273','2013-05-31','09:55:00',3.07),('16273','2013-05-31','10:00:00',3.78),('16273','2013-05-31','10:05:00',3.23),('16273','2013-05-31','10:10:00',2.33),('16273','2013-05-31','10:15:00',1.04),('16273','2013-05-31','10:20:00',2.47),('16273','2013-05-31','10:25:00',3.45),('16273','2013-05-31','10:30:00',2.35),('16273','2013-05-31','10:35:00',4.18),('16273','2013-05-31','10:40:00',4.45),('16273','2013-05-31','10:45:00',1.67),('16273','2013-05-31','10:50:00',1.94),('16273','2013-05-31','10:55:00',1.97),('16273','2013-05-31','11:00:00',2.26),('16273','2013-05-31','11:05:00',2.17),('16273','2013-05-31','11:10:00',2.93),('16273','2013-05-31','11:20:00',2.02),('16273','2013-05-31','11:25:00',2.4),('16273','2013-05-31','11:30:00',1.54),('16273','2013-05-31','11:35:00',2.67),('16273','2013-05-31','11:40:00',2.9),('16273','2013-05-31','11:45:00',2.56),('16273','2013-05-31','11:50:00',2.77),('16273','2013-05-31','11:55:00',3.52),('16273','2013-05-31','12:00:00',3.1),('16273','2013-05-31','12:05:00',2.07),('16273','2013-05-31','12:10:00',1.55),('16273','2013-05-31','12:15:00',2.09),('16273','2013-05-31','12:20:00',2.83),('16273','2013-05-31','12:25:00',1.55),('16273','2013-05-31','12:30:00',2.47),('16273','2013-05-31','12:35:00',3.68),('16273','2013-05-31','12:40:00',1.09),('16273','2013-05-31','12:45:00',1.64),('16273','2013-05-31','12:50:00',3.61),('16273','2013-05-31','12:55:00',2.64),('16273','2013-05-31','13:00:00',1.21),('16273','2013-05-31','13:10:00',1.25),('16273','2013-05-31','13:15:00',3.56),('16273','2013-05-31','13:20:00',2.18),('16273','2013-05-31','13:25:00',2.35),('16273','2013-05-31','13:30:00',1.23),('16273','2013-05-31','13:35:00',1.26),('16273','2013-05-31','13:40:00',3.11),('16273','2013-05-31','13:45:00',2.45),('16273','2013-05-31','13:50:00',1.97),('16273','2013-05-31','13:55:00',1.28),('16273','2013-05-31','14:25:00',1.83),('16273','2013-05-31','14:30:00',1.01),('16273','2013-05-31','14:50:00',2.05),('16273','2013-05-31','14:55:00',2.31),('16273','2013-05-31','15:00:00',1.25),('16273','2013-05-31','15:05:00',1.49),('16273','2013-05-31','15:10:00',2.23),('16273','2013-05-31','15:15:00',2.3),('16273','2013-05-31','15:20:00',1.69),('16273','2013-05-31','15:25:00',1.34),('16273','2013-05-31','15:30:00',1.47),('16273','2013-05-31','15:35:00',1.36),('16273','2013-05-31','15:40:00',1.63),('16273','2013-05-31','15:45:00',2.48),('16273','2013-05-31','15:50:00',2.11),('16273','2013-05-31','15:55:00',1.43),('16273','2013-05-31','16:00:00',1),('16273','2013-05-31','16:15:00',1.26),('16273','2013-05-31','16:20:00',1.3),('16273','2013-05-31','16:25:00',1.01),('16273','2013-05-31','16:35:00',1.06),('16273','2013-05-31','16:40:00',1.07),('16273','2013-05-30','07:35:00',1.65),('16273','2013-05-30','07:40:00',1.75),('16273','2013-05-30','07:45:00',1.42),('16273','2013-05-30','08:10:00',1.18),('16273','2013-05-30','08:20:00',1.15),('16273','2013-05-30','08:25:00',2.58),('16273','2013-05-30','08:30:00',2.66),('16273','2013-05-30','08:35:00',2.71),('16273','2013-05-30','08:40:00',2.77),('16273','2013-05-30','08:45:00',2.91),('16273','2013-05-30','08:50:00',3.13),('16273','2013-05-30','08:55:00',2.82),('16273','2013-05-30','09:00:00',3.19),('16273','2013-05-30','09:05:00',3.46),('16273','2013-05-30','09:10:00',2.91),('16273','2013-05-30','09:15:00',2.41),('16273','2013-05-30','09:20:00',3.29),('16273','2013-05-30','09:25:00',3.47),('16273','2013-05-30','09:30:00',3.05),('16273','2013-05-30','09:35:00',2.62),('16273','2013-05-30','09:40:00',3.2),('16273','2013-05-30','09:45:00',2.81),('16273','2013-05-30','09:50:00',2.1),('16273','2013-05-30','09:55:00',3.3),('16273','2013-05-30','10:00:00',3.41),('16273','2013-05-30','10:05:00',3.72),('16273','2013-05-30','10:10:00',2.01),('16273','2013-05-30','10:15:00',3.78),('16273','2013-05-30','10:20:00',3.21),('16273','2013-05-30','10:25:00',3.26),('16273','2013-05-30','10:30:00',4.27),('16273','2013-05-30','10:35:00',3.77),('16273','2013-05-30','10:40:00',2.89),('16273','2013-05-30','10:45:00',4.53),('16273','2013-05-30','10:50:00',3.53),('16273','2013-05-30','10:55:00',2.66),('16273','2013-05-30','11:00:00',4.25),('16273','2013-05-30','11:05:00',3.58),('16273','2013-05-30','11:10:00',4.68),('16273','2013-05-30','11:15:00',2.53),('16273','2013-05-30','11:20:00',4.47),('16273','2013-05-30','11:25:00',3.45),('16273','2013-05-30','11:30:00',3.87),('16273','2013-05-30','11:35:00',4.05),('16273','2013-05-30','11:40:00',2.45),('16273','2013-05-30','11:45:00',4.18),('16273','2013-05-30','11:50:00',4.3),('16273','2013-05-30','11:55:00',1.97),('16273','2013-05-30','12:00:00',2.55),('16273','2013-05-30','12:05:00',2.43),('16273','2013-05-30','12:10:00',4.21),('16273','2013-05-30','12:15:00',2.29),('16273','2013-05-30','12:20:00',3.08),('16273','2013-05-30','12:25:00',3.91),('16273','2013-05-30','12:30:00',4.03),('16273','2013-05-30','12:35:00',3.89),('16273','2013-05-30','12:40:00',2.48),('16273','2013-05-30','12:45:00',3.21),('16273','2013-05-30','12:50:00',2.77),('16273','2013-05-30','12:55:00',3.25),('16273','2013-05-30','13:00:00',3.29),('16273','2013-05-30','13:05:00',3.02),('16273','2013-05-30','13:10:00',2.45),('16273','2013-05-30','13:15:00',1.67),('16273','2013-05-30','13:20:00',1.53),('16273','2013-05-30','13:25:00',1.89),('16273','2013-05-30','13:30:00',2.38),('16273','2013-05-30','13:35:00',1.81),('16273','2013-05-30','13:40:00',1.8),('16273','2013-05-30','13:45:00',2.07),('16273','2013-05-30','13:50:00',4.56),('16273','2013-05-30','13:55:00',3.59),('16273','2013-05-30','14:00:00',4.75),('16273','2013-05-30','14:05:00',4.68),('16273','2013-05-30','14:10:00',4.12),('16273','2013-05-30','14:15:00',4.58),('16273','2013-05-30','14:20:00',4.54),('16273','2013-05-30','14:25:00',4.49),('16273','2013-05-30','14:30:00',3.65),('16273','2013-05-30','14:35:00',3.04),('16273','2013-05-30','14:40:00',3.14),('16273','2013-05-30','14:45:00',3.02),('16273','2013-05-30','14:50:00',3.36),('16273','2013-05-30','14:55:00',1.74),('16273','2013-05-30','15:00:00',3.25),('16273','2013-05-30','15:05:00',3.53),('16273','2013-05-30','15:10:00',3.85),('16273','2013-05-30','15:15:00',2.37),('16273','2013-05-30','15:20:00',2.3),('16273','2013-05-30','15:25:00',2.91),('16273','2013-05-30','15:30:00',2.9),('16273','2013-05-30','15:35:00',3.83),('16273','2013-05-30','15:40:00',2.61),('16273','2013-05-30','15:45:00',1.47),('16273','2013-05-30','15:50:00',2.3),('16273','2013-05-30','15:55:00',3.51),('16273','2013-05-30','16:00:00',3.19),('16273','2013-05-30','16:05:00',3.05),('16273','2013-05-30','16:10:00',1.73),('16273','2013-05-30','16:20:00',1.02),('16273','2013-05-30','16:25:00',1.25),('16273','2013-05-30','16:30:00',1.02),('16273','2013-05-30','16:35:00',2.29),('16273','2013-05-30','16:40:00',2.17),('16273','2013-05-30','16:45:00',1.4),('16273','2013-05-30','16:50:00',2.07),('16273','2013-05-30','16:55:00',2.65),('16273','2013-05-30','17:00:00',2.27),('16273','2013-05-30','17:55:00',1.01),('16273','2013-05-30','18:00:00',1.44),('16273','2013-05-30','18:25:00',1.02),('16273','2013-05-30','18:30:00',1.32),('16273','2013-05-30','18:35:00',1.25),('16273','2013-05-30','18:40:00',1.16),('16273','2013-05-29','07:05:00',1.06),('16273','2013-05-29','07:10:00',1.17),('16273','2013-05-29','07:15:00',1.27),('16273','2013-05-29','07:20:00',1.36),('16273','2013-05-29','07:25:00',1.45),('16273','2013-05-29','07:30:00',1.53),('16273','2013-05-29','07:35:00',1.6),('16273','2013-05-29','07:40:00',1.69),('16273','2013-05-29','07:45:00',1.77),('16273','2013-05-29','07:50:00',1.86),('16273','2013-05-29','07:55:00',1.93),('16273','2013-05-29','08:00:00',2.03),('16273','2013-05-29','08:05:00',2.11),('16273','2013-05-29','08:10:00',2.2),('16273','2013-05-29','08:15:00',2.28),('16273','2013-05-29','08:20:00',2.36),('16273','2013-05-29','08:25:00',2.42),('16273','2013-05-29','08:30:00',2.5),('16273','2013-05-29','08:35:00',2.58),('16273','2013-05-29','08:40:00',2.64),('16273','2013-05-29','08:45:00',2.71),('16273','2013-05-29','08:50:00',2.75),('16273','2013-05-29','08:55:00',2.85),('16273','2013-05-29','09:00:00',2.92),('16273','2013-05-29','09:05:00',2.99),('16273','2013-05-29','09:10:00',3.07),('16273','2013-05-29','09:15:00',3.12),('16273','2013-05-29','09:20:00',3.18),('16273','2013-05-29','09:25:00',3.25),('16273','2013-05-29','09:30:00',3.31),('16273','2013-05-29','09:35:00',3.35),('16273','2013-05-29','09:40:00',3.42),('16273','2013-05-29','09:45:00',3.47),('16273','2013-05-29','09:50:00',3.52),('16273','2013-05-29','09:55:00',3.55),('16273','2013-05-29','10:00:00',3.56),('16273','2013-05-29','10:05:00',3.6),('16273','2013-05-29','10:10:00',3.69),('16273','2013-05-29','10:15:00',3.72),('16273','2013-05-29','10:20:00',3.58),('16273','2013-05-29','10:25:00',3.74),('16273','2013-05-29','10:30:00',3.87),('16273','2013-05-29','10:35:00',3.89),('16273','2013-05-29','10:40:00',3.27),('16273','2013-05-29','10:45:00',3.53),('16273','2013-05-29','10:50:00',3.85),('16273','2013-05-29','10:55:00',3.68),('16273','2013-05-29','11:00:00',3.36),('16273','2013-05-29','11:05:00',1.85),('16273','2013-05-29','11:10:00',4.46),('16273','2013-05-29','11:15:00',2.33),('16273','2013-05-29','11:20:00',3.07),('16273','2013-05-29','11:25:00',2.57),('16273','2013-05-29','11:30:00',2.71),('16273','2013-05-29','11:35:00',3.64),('16273','2013-05-29','11:40:00',3.81),('16273','2013-05-29','11:45:00',3.93),('16273','2013-05-29','11:50:00',4.54),('16273','2013-05-29','11:55:00',4.51),('16273','2013-05-29','12:00:00',4.38),('16273','2013-05-29','12:05:00',4.35),('16273','2013-05-29','12:10:00',4.39),('16273','2013-05-29','12:15:00',4.44),('16273','2013-05-29','12:20:00',4.45),('16273','2013-05-29','12:25:00',4.4),('16273','2013-05-29','12:30:00',4.34),('16273','2013-05-29','12:35:00',4.34),('16273','2013-05-29','12:40:00',4.35),('16273','2013-05-29','12:45:00',4.34),('16273','2013-05-29','12:50:00',4.33),('16273','2013-05-29','12:55:00',4.34),('16273','2013-05-29','13:00:00',4.18),('16273','2013-05-29','13:05:00',4.41),('16273','2013-05-29','13:10:00',3.8),('16273','2013-05-29','13:15:00',2.19),('16273','2013-05-29','13:20:00',3.79),('16273','2013-05-29','13:25:00',3.51),('16273','2013-05-29','13:30:00',1.85),('16273','2013-05-29','13:35:00',2.54),('16273','2013-05-29','13:40:00',3.03),('16273','2013-05-29','13:45:00',2.98),('16273','2013-05-29','13:50:00',4.11),('16273','2013-05-29','13:55:00',4.27),('16273','2013-05-29','14:00:00',4.14),('16273','2013-05-29','14:05:00',3.98),('16273','2013-05-29','14:10:00',4.37),('16273','2013-05-29','14:15:00',2.71),('16273','2013-05-29','14:20:00',3.34),('16273','2013-05-29','14:25:00',3.55),('16273','2013-05-29','14:30:00',2.86),('16273','2013-05-29','14:35:00',3.79),('16273','2013-05-29','14:40:00',3.71),('16273','2013-05-29','14:45:00',2.6),('16273','2013-05-29','14:50:00',4),('16273','2013-05-29','14:55:00',3.81),('16273','2013-05-29','15:00:00',3.46),('16273','2013-05-29','15:05:00',2.45),('16273','2013-05-29','15:10:00',3.32),('16273','2013-05-29','15:15:00',3.92),('16273','2013-05-29','15:20:00',2.26),('16273','2013-05-29','15:25:00',2.53),('16273','2013-05-29','15:30:00',2.75),('16273','2013-05-29','15:35:00',3.05),('16273','2013-05-29','15:40:00',2.5),('16273','2013-05-29','15:45:00',2.81),('16273','2013-05-29','15:50:00',2.71),('16273','2013-05-29','15:55:00',2.81),('16273','2013-05-29','16:00:00',2.71),('16273','2013-05-29','16:05:00',2.52),('16273','2013-05-29','16:10:00',2.41),('16273','2013-05-29','16:15:00',2.66),('16273','2013-05-29','16:20:00',2.82),('16273','2013-05-29','16:25:00',2.84),('16273','2013-05-29','16:30:00',2.26),('16273','2013-05-29','16:35:00',1.75),('16273','2013-05-29','16:40:00',1.54),('16273','2013-05-29','16:45:00',1.31),('16273','2013-05-29','16:50:00',1.08),('16273','2013-05-29','17:30:00',1.37),('16273','2013-05-29','17:35:00',1.47),('16273','2013-05-29','17:40:00',1.08),('16273','2013-05-29','17:55:00',1.11),('16273','2013-05-29','18:00:00',1.11),('16273','2013-05-29','18:05:00',1.37),('16273','2013-05-29','18:10:00',1.17),('16273','2013-05-29','18:15:00',1.06),('16273','2013-05-28','07:15:00',1.23),('16273','2013-05-28','07:20:00',1.13),('16273','2013-05-28','07:25:00',1.35),('16273','2013-05-28','07:30:00',1.39),('16273','2013-05-28','07:35:00',1.23),('16273','2013-05-28','07:40:00',1.32),('16273','2013-05-28','07:45:00',1.41),('16273','2013-05-28','07:50:00',1.39),('16273','2013-05-28','07:55:00',1.21),('16273','2013-05-28','08:00:00',1.27),('16273','2013-05-28','08:05:00',1.49),('16273','2013-05-28','08:10:00',1.72),('16273','2013-05-28','08:15:00',1.96),('16273','2013-05-28','08:20:00',1.72),('16273','2013-05-28','08:25:00',1.83),('16273','2013-05-28','08:30:00',2.08),('16273','2013-05-28','08:35:00',1.9),('16273','2013-05-28','08:40:00',1.54),('16273','2013-05-28','08:45:00',1.61),('16273','2013-05-28','08:50:00',1.61),('16273','2013-05-28','08:55:00',1.7),('16273','2013-05-28','09:00:00',1.65),('16273','2013-05-28','09:05:00',1.93),('16273','2013-05-28','09:10:00',2.14),('16273','2013-05-28','09:15:00',2.2),('16273','2013-05-28','09:20:00',2.15),('16273','2013-05-28','09:25:00',2.34),('16273','2013-05-28','09:30:00',2.65),('16273','2013-05-28','09:35:00',2.76),('16273','2013-05-28','09:40:00',2.57),('16273','2013-05-28','09:45:00',2.51),('16273','2013-05-28','09:50:00',2.55),('16273','2013-05-28','09:55:00',2.28),('16273','2013-05-28','10:00:00',2.05),('16273','2013-05-28','10:05:00',2.21),('16273','2013-05-28','10:10:00',2.4),('16273','2013-05-28','10:15:00',2.54),('16273','2013-05-28','10:20:00',2.32),('16273','2013-05-28','10:25:00',2.46),('16273','2013-05-28','10:30:00',2.85),('16273','2013-05-28','10:35:00',3.05),('16273','2013-05-28','10:40:00',3.09),('16273','2013-05-28','10:45:00',2.44),('16273','2013-05-28','10:50:00',2.62),('16273','2013-05-28','10:55:00',2.46),('16273','2013-05-28','11:00:00',2.75),('16273','2013-05-28','11:05:00',3.28),('16273','2013-05-28','11:10:00',2.95),('16273','2013-05-28','11:15:00',2.18),('16273','2013-05-28','11:20:00',2.02),('16273','2013-05-28','11:25:00',3.91),('16273','2013-05-28','11:30:00',3.1),('16273','2013-05-28','11:35:00',3.65),('16273','2013-05-28','11:40:00',3.01),('16273','2013-05-28','11:45:00',1.04),('16273','2013-05-28','11:50:00',1.12),('16273','2013-05-28','11:55:00',1.3),('16273','2013-05-28','12:00:00',2.13),('16273','2013-05-28','12:05:00',2.25),('16273','2013-05-28','12:10:00',2.45),('16273','2013-05-28','12:15:00',2.34),('16273','2013-05-28','12:20:00',2.3),('16273','2013-05-28','12:25:00',2.66),('16273','2013-05-28','12:30:00',2.23),('16273','2013-05-28','12:35:00',2.19),('16273','2013-05-28','12:40:00',2.23),('16273','2013-05-28','12:45:00',2.13),('16273','2013-05-28','12:50:00',2.2),('16273','2013-05-28','12:55:00',2.48),('16273','2013-05-28','13:00:00',2.58),('16273','2013-05-28','13:05:00',2.61),('16273','2013-05-28','13:10:00',1.89),('16273','2013-05-28','13:15:00',1.68),('16273','2013-05-28','13:20:00',2.77),('16273','2013-05-28','13:25:00',2.83),('16273','2013-05-28','13:30:00',4.17),('16273','2013-05-28','13:35:00',2.34),('16273','2013-05-28','13:40:00',2.39),('16273','2013-05-28','13:45:00',1.93),('16273','2013-05-28','13:50:00',2.19),('16273','2013-05-28','13:55:00',1.74),('16273','2013-05-28','14:00:00',1.9),('16273','2013-05-28','14:05:00',2.41),('16273','2013-05-28','14:10:00',2.32),('16273','2013-05-28','14:15:00',2.91),('16273','2013-05-28','14:20:00',3.35),('16273','2013-05-28','14:25:00',2.47),('16273','2013-05-28','14:30:00',3.13),('16273','2013-05-28','14:35:00',2.52),('16273','2013-05-28','14:40:00',2.4),('16273','2013-05-28','14:45:00',2.63),('16273','2013-05-28','14:50:00',3.02),('16273','2013-05-28','14:55:00',3.26),('16273','2013-05-28','15:00:00',2.75),('16273','2013-05-28','15:05:00',1.55),('16273','2013-05-28','15:10:00',2.09),('16273','2013-05-28','15:15:00',2.19),('16273','2013-05-28','15:20:00',1.91),('16273','2013-05-28','15:25:00',1.53),('16273','2013-05-28','15:30:00',1.93),('16273','2013-05-28','15:35:00',1.69),('16273','2013-05-28','15:40:00',1.85),('16273','2013-05-28','15:45:00',1.91),('16273','2013-05-28','15:50:00',2.16),('16273','2013-05-28','15:55:00',2.4),('16273','2013-05-28','16:00:00',2.41),('16273','2013-05-28','16:05:00',1.98),('16273','2013-05-28','16:10:00',1.67),('16273','2013-05-28','16:15:00',1.84),('16273','2013-05-28','16:20:00',1.6),('16273','2013-05-28','16:25:00',1.15),('16273','2013-05-28','16:30:00',1.05),('16273','2013-05-28','16:35:00',1.07),('16273','2013-05-28','16:40:00',2.27),('16273','2013-05-28','16:45:00',2.1),('16273','2013-05-28','16:50:00',1.99),('16273','2013-05-28','16:55:00',1.91),('16273','2013-05-28','17:00:00',1.85),('16273','2013-05-28','17:05:00',1.78),('16273','2013-05-28','17:10:00',1.71),('16273','2013-05-28','17:15:00',1.62),('16273','2013-05-28','17:20:00',1.54),('16273','2013-05-28','17:25:00',1.46),('16273','2013-05-28','17:30:00',1.36),('16273','2013-05-28','17:35:00',1.32),('16273','2013-05-28','17:40:00',1.26),('16273','2013-05-28','17:45:00',1.19),('16273','2013-05-28','18:15:00',1.04),('16273','2013-05-27','07:10:00',1.22),('16273','2013-05-27','07:15:00',1.06),('16273','2013-05-27','07:20:00',1.17),('16273','2013-05-27','07:25:00',1.52),('16273','2013-05-27','07:30:00',1.6),('16273','2013-05-27','07:35:00',1.66),('16273','2013-05-27','07:40:00',1.73),('16273','2013-05-27','07:45:00',1.82),('16273','2013-05-27','07:50:00',2),('16273','2013-05-27','07:55:00',2.21),('16273','2013-05-27','08:00:00',2.49),('16273','2013-05-27','08:05:00',1.4),('16273','2013-05-27','08:10:00',1.34),('16273','2013-05-27','08:15:00',2.26),('16273','2013-05-27','08:20:00',2.32),('16273','2013-05-27','08:25:00',2.35),('16273','2013-05-27','08:30:00',2.09),('16273','2013-05-27','08:35:00',1.86),('16273','2013-05-27','08:40:00',2.8),('16273','2013-05-27','08:45:00',3.05),('16273','2013-05-27','08:50:00',3.33),('16273','2013-05-27','08:55:00',1.17),('16273','2013-05-27','09:00:00',2.74),('16273','2013-05-27','09:05:00',1.87),('16273','2013-05-27','09:15:00',2.25),('16273','2013-05-27','09:20:00',3.46),('16273','2013-05-27','09:25:00',3.44),('16273','2013-05-27','09:30:00',3.54),('16273','2013-05-27','09:35:00',3.77),('16273','2013-05-27','09:40:00',3.28),('16273','2013-05-27','09:45:00',2.33),('16273','2013-05-27','09:50:00',3.49),('16273','2013-05-27','09:55:00',3.67),('16273','2013-05-27','10:00:00',3.73),('16273','2013-05-27','10:05:00',3.78),('16273','2013-05-27','10:10:00',3.86),('16273','2013-05-27','10:15:00',3.94),('16273','2013-05-27','10:20:00',4.04),('16273','2013-05-27','10:25:00',4.09),('16273','2013-05-27','10:30:00',2.63),('16273','2013-05-27','10:35:00',4.25),('16273','2013-05-27','10:40:00',4.43),('16273','2013-05-27','10:45:00',3.64),('16273','2013-05-27','10:50:00',1.89),('16273','2013-05-27','10:55:00',4.59),('16273','2013-05-27','11:00:00',2.56),('16273','2013-05-27','11:05:00',3.98),('16273','2013-05-27','11:10:00',1.68),('16273','2013-05-27','11:15:00',3.8),('16273','2013-05-27','11:20:00',3.13),('16273','2013-05-27','11:25:00',3.5),('16273','2013-05-27','11:30:00',1.93),('16273','2013-05-27','11:35:00',4.37),('16273','2013-05-27','11:40:00',3.49),('16273','2013-05-27','11:45:00',2.96),('16273','2013-05-27','11:50:00',4.61),('16273','2013-05-27','11:55:00',4.57),('16273','2013-05-27','12:00:00',3.14),('16273','2013-05-27','12:05:00',3.77),('16273','2013-05-27','12:10:00',4.64),('16273','2013-05-27','12:15:00',4.54),('16273','2013-05-27','12:20:00',3.23),('16273','2013-05-27','12:25:00',4.59),('16273','2013-05-27','12:30:00',4.5),('16273','2013-05-27','12:35:00',3.99),('16273','2013-05-27','12:40:00',4.45),('16273','2013-05-27','12:45:00',2.73),('16273','2013-05-27','12:50:00',4.51),('16273','2013-05-27','12:55:00',4.62),('16273','2013-05-27','13:00:00',4.09),('16273','2013-05-27','13:05:00',4.29),('16273','2013-05-27','13:10:00',4.1),('16273','2013-05-27','13:15:00',1.92),('16273','2013-05-27','13:20:00',4.19),('16273','2013-05-27','13:25:00',4.23),('16273','2013-05-27','13:30:00',4.03),('16273','2013-05-27','13:35:00',3.93),('16273','2013-05-27','13:40:00',4.25),('16273','2013-05-27','13:45:00',4.17),('16273','2013-05-27','13:50:00',4.16),('16273','2013-05-27','13:55:00',4.06),('16273','2013-05-27','14:00:00',3.94),('16273','2013-05-27','14:05:00',4.01),('16273','2013-05-27','14:10:00',3.94),('16273','2013-05-27','14:15:00',3.94),('16273','2013-05-27','14:20:00',3.92),('16273','2013-05-27','14:25:00',3.88),('16273','2013-05-27','14:30:00',3.89),('16273','2013-05-27','14:35:00',3.87),('16273','2013-05-27','14:40:00',3.83),('16273','2013-05-27','14:45:00',3.77),('16273','2013-05-27','14:50:00',3.63),('16273','2013-05-27','14:55:00',2.95),('16273','2013-05-27','15:00:00',1.76),('16273','2013-05-27','15:05:00',3.55),('16273','2013-05-27','15:10:00',2.92),('16273','2013-05-27','15:15:00',3.06),('16273','2013-05-27','15:20:00',2.88),('16273','2013-05-27','15:25:00',2.98),('16273','2013-05-27','15:30:00',3.53),('16273','2013-05-27','15:35:00',3.23),('16273','2013-05-27','15:40:00',2.61),('16273','2013-05-27','15:45:00',3.09),('16273','2013-05-27','15:50:00',2.76),('16273','2013-05-27','15:55:00',2.01),('16273','2013-05-27','16:00:00',2.43),('16273','2013-05-27','16:05:00',2.22),('16273','2013-05-27','16:10:00',1.91),('16273','2013-05-27','16:15:00',2.62),('16273','2013-05-27','16:20:00',3.11),('16273','2013-05-27','16:25:00',2.72),('16273','2013-05-27','16:30:00',2.54),('16273','2013-05-27','16:35:00',1.53),('16273','2013-05-27','16:40:00',1.13),('16273','2013-05-27','16:45:00',1.15),('16273','2013-05-27','16:50:00',1.26),('16273','2013-05-27','16:55:00',1.3),('16273','2013-05-27','17:00:00',1.33),('16273','2013-05-27','17:05:00',1.56),('16273','2013-05-27','17:10:00',1.48),('16273','2013-05-27','17:15:00',1.25),('16273','2013-05-27','17:20:00',1.14),('16273','2013-05-27','17:25:00',1.1),('16273','2013-05-27','17:30:00',1.05),('16273','2013-05-27','18:20:00',1.27),('16273','2013-05-27','18:25:00',1.1),('16273','2013-05-26','07:35:00',1.66),('16273','2013-05-26','07:40:00',1.95),('16273','2013-05-26','07:45:00',1.42),('16273','2013-05-26','07:55:00',2),('16273','2013-05-26','08:00:00',2.01),('16273','2013-05-26','08:05:00',1.39),('16273','2013-05-26','08:10:00',1.84),('16273','2013-05-26','08:15:00',1.78),('16273','2013-05-26','08:20:00',1.49),('16273','2013-05-26','08:30:00',2.77),('16273','2013-05-26','08:35:00',2.5),('16273','2013-05-26','08:40:00',1.85),('16273','2013-05-26','08:50:00',3.43),('16273','2013-05-26','08:55:00',1.23),('16273','2013-05-26','09:05:00',3.3),('16273','2013-05-26','09:10:00',1.49),('16273','2013-05-26','09:20:00',1.23),('16273','2013-05-26','09:25:00',1.41),('16273','2013-05-26','09:35:00',2.3),('16273','2013-05-26','09:40:00',1.06),('16273','2013-05-26','09:50:00',1.93),('16273','2013-05-26','09:55:00',2.8),('16273','2013-05-26','10:00:00',4.04),('16273','2013-05-26','10:05:00',3.72),('16273','2013-05-26','10:10:00',3.56),('16273','2013-05-26','10:15:00',3.45),('16273','2013-05-26','10:20:00',3.75),('16273','2013-05-26','10:25:00',3.38),('16273','2013-05-26','10:30:00',3.85),('16273','2013-05-26','10:35:00',4.06),('16273','2013-05-26','10:40:00',3.86),('16273','2013-05-26','10:45:00',4.06),('16273','2013-05-26','10:50:00',4.21),('16273','2013-05-26','10:55:00',4.26),('16273','2013-05-26','11:00:00',4.26),('16273','2013-05-26','11:05:00',4.31),('16273','2013-05-26','11:10:00',3.98),('16273','2013-05-26','11:15:00',4.35),('16273','2013-05-26','11:20:00',4.34),('16273','2013-05-26','11:25:00',4.36),('16273','2013-05-26','11:30:00',4.41),('16273','2013-05-26','11:35:00',4.43),('16273','2013-05-26','11:40:00',4.43),('16273','2013-05-26','11:45:00',4.42),('16273','2013-05-26','11:50:00',4.12),('16273','2013-05-26','11:55:00',4.57),('16273','2013-05-26','12:00:00',4.47),('16273','2013-05-26','12:05:00',4.52),('16273','2013-05-26','12:10:00',4.51),('16273','2013-05-26','12:15:00',4.52),('16273','2013-05-26','12:20:00',4.27),('16273','2013-05-26','12:25:00',4.03),('16273','2013-05-26','12:30:00',3.64),('16273','2013-05-26','12:35:00',4.36),('16273','2013-05-26','12:40:00',4.39),('16273','2013-05-26','12:45:00',4.46),('16273','2013-05-26','12:50:00',4.48),('16273','2013-05-26','12:55:00',4.49),('16273','2013-05-26','13:00:00',4.16),('16273','2013-05-26','13:05:00',4.51),('16273','2013-05-26','13:10:00',4.11),('16273','2013-05-26','13:15:00',4.29),('16273','2013-05-26','13:20:00',4.37),('16273','2013-05-26','13:25:00',4.33),('16273','2013-05-26','13:30:00',4.3),('16273','2013-05-26','13:35:00',4.28),('16273','2013-05-26','13:40:00',4.27),('16273','2013-05-26','13:45:00',4.25),('16273','2013-05-26','13:50:00',4.21),('16273','2013-05-26','13:55:00',3.88),('16273','2013-05-26','14:00:00',4.22),('16273','2013-05-26','14:05:00',4.14),('16273','2013-05-26','14:10:00',4.1),('16273','2013-05-26','14:15:00',4.04),('16273','2013-05-26','14:20:00',4.01),('16273','2013-05-26','14:25:00',3.53),('16273','2013-05-26','14:30:00',3.95),('16273','2013-05-26','14:35:00',3.93),('16273','2013-05-26','14:40:00',3.88),('16273','2013-05-26','14:45:00',3.8),('16273','2013-05-26','14:50:00',3.74),('16273','2013-05-26','14:55:00',3.71),('16273','2013-05-26','15:00:00',3.69),('16273','2013-05-26','15:05:00',3.64),('16273','2013-05-26','15:10:00',3.58),('16273','2013-05-26','15:15:00',3.52),('16273','2013-05-26','15:20:00',3.47),('16273','2013-05-26','15:25:00',3.41),('16273','2013-05-26','15:30:00',3.33),('16273','2013-05-26','15:35:00',3.28),('16273','2013-05-26','15:40:00',3.23),('16273','2013-05-26','15:45:00',3.15),('16273','2013-05-26','15:50:00',3.09),('16273','2013-05-26','15:55:00',3.02),('16273','2013-05-26','16:00:00',2.95),('16273','2013-05-26','16:05:00',2.89),('16273','2013-05-26','16:10:00',2.83),('16273','2013-05-26','16:15:00',2.74),('16273','2013-05-26','16:20:00',2.67),('16273','2013-05-26','16:25:00',2.6),('16273','2013-05-26','16:30:00',2.52),('16273','2013-05-26','16:35:00',2.45),('16273','2013-05-26','16:40:00',2.37),('16273','2013-05-26','16:45:00',2.28),('16273','2013-05-26','16:50:00',2.21),('16273','2013-05-26','16:55:00',2.13),('16273','2013-05-26','17:00:00',2.05),('16273','2013-05-26','17:05:00',1.95),('16273','2013-05-26','17:10:00',1.86),('16273','2013-05-26','17:15:00',1.78),('16273','2013-05-26','17:20:00',1.7),('16273','2013-05-26','17:25:00',1.61),('16273','2013-05-26','17:30:00',1.5),('16273','2013-05-26','17:35:00',1.44),('16273','2013-05-26','17:40:00',1.35),('16273','2013-05-26','17:45:00',1.27),('16273','2013-05-26','17:50:00',1.19),('16273','2013-05-26','17:55:00',1.11),('16273','2013-05-26','18:00:00',1.02),('16273','2013-05-25','07:15:00',1.27),('16273','2013-05-25','07:20:00',1.5),('16273','2013-05-25','07:25:00',1.63),('16273','2013-05-25','07:30:00',1.26),('16273','2013-05-25','07:40:00',2.02),('16273','2013-05-25','07:45:00',1.64),('16273','2013-05-25','07:50:00',1.4),('16273','2013-05-25','08:10:00',2.08),('16273','2013-05-25','08:15:00',2.67),('16273','2013-05-25','08:20:00',1.72),('16273','2013-05-25','08:30:00',2.34),('16273','2013-05-25','08:35:00',2.09),('16273','2013-05-25','08:40:00',1.3),('16273','2013-05-25','08:45:00',2.72),('16273','2013-05-25','08:50:00',3.26),('16273','2013-05-25','08:55:00',3.31),('16273','2013-05-25','09:00:00',2.5),('16273','2013-05-25','09:05:00',1.91),('16273','2013-05-25','09:10:00',1.08),('16273','2013-05-25','09:15:00',1.84),('16273','2013-05-25','09:20:00',3.45),('16273','2013-05-25','09:25:00',2.53),('16273','2013-05-25','09:30:00',1.75),('16273','2013-05-25','09:35:00',3.8),('16273','2013-05-25','09:40:00',3.2),('16273','2013-05-25','09:45:00',3.28),('16273','2013-05-25','09:50:00',1.26),('16273','2013-05-25','10:00:00',1.14),('16273','2013-05-25','10:05:00',1.5),('16273','2013-05-25','10:30:00',1.47),('16273','2013-05-25','10:45:00',1.03),('16273','2013-05-25','10:50:00',1.05),('16273','2013-05-25','10:55:00',2.01),('16273','2013-05-25','11:00:00',3.08),('16273','2013-05-25','11:05:00',1.27),('16273','2013-05-25','11:10:00',2.41),('16273','2013-05-25','11:25:00',1.79),('16273','2013-05-25','11:30:00',1.04),('16273','2013-05-25','11:35:00',2.11),('16273','2013-05-25','11:40:00',2.55),('16273','2013-05-25','11:45:00',1.75),('16273','2013-05-25','11:50:00',2.19),('16273','2013-05-25','11:55:00',3.46),('16273','2013-05-25','12:00:00',4.16),('16273','2013-05-25','12:05:00',1.35),('16273','2013-05-25','12:10:00',1.86),('16273','2013-05-25','12:15:00',2.85),('16273','2013-05-25','12:20:00',1.5),('16273','2013-05-25','12:25:00',1.73),('16273','2013-05-25','12:30:00',1.15),('16273','2013-05-25','12:40:00',1.27),('16273','2013-05-25','12:45:00',1.62),('16273','2013-05-25','12:50:00',2.42),('16273','2013-05-25','12:55:00',4.09),('16273','2013-05-25','13:00:00',2.5),('16273','2013-05-25','13:05:00',1.94),('16273','2013-05-25','13:10:00',2.17),('16273','2013-05-25','13:15:00',2.25),('16273','2013-05-25','13:20:00',2.05),('16273','2013-05-25','13:25:00',2.33),('16273','2013-05-25','13:30:00',2.03),('16273','2013-05-25','13:35:00',3.16),('16273','2013-05-25','13:40:00',2.03),('16273','2013-05-25','13:45:00',2.11),('16273','2013-05-25','13:50:00',3),('16273','2013-05-25','13:55:00',4.42),('16273','2013-05-25','14:00:00',3.79),('16273','2013-05-25','14:05:00',4.5),('16273','2013-05-25','14:10:00',4.07),('16273','2013-05-25','14:15:00',4.57),('16273','2013-05-25','14:20:00',4.19),('16273','2013-05-25','14:25:00',2.64),('16273','2013-05-25','14:30:00',2.72),('16273','2013-05-25','14:35:00',3.91),('16273','2013-05-25','14:40:00',4.27),('16273','2013-05-25','14:45:00',3.68),('16273','2013-05-25','14:50:00',3.55),('16273','2013-05-25','14:55:00',2.82),('16273','2013-05-25','15:00:00',3.61),('16273','2013-05-25','15:05:00',2.81),('16273','2013-05-25','15:10:00',1.55),('16273','2013-05-25','15:15:00',1.44),('16273','2013-05-25','15:20:00',1.14),('16273','2013-05-25','15:25:00',2.03),('16273','2013-05-25','15:30:00',3.42),('16273','2013-05-25','15:35:00',1.82),('16273','2013-05-25','15:40:00',2.92),('16273','2013-05-25','15:45:00',2.61),('16273','2013-05-25','15:50:00',1.67),('16273','2013-05-25','15:55:00',1.29),('16273','2013-05-25','16:00:00',3.14),('16273','2013-05-25','16:05:00',2.23),('16273','2013-05-25','16:10:00',2.02),('16273','2013-05-25','16:15:00',1.62),('16273','2013-05-25','16:20:00',1.16),('16273','2013-05-25','16:25:00',1.24),('16273','2013-05-25','16:30:00',3.02),('16273','2013-05-25','16:35:00',3.05),('16273','2013-05-25','16:40:00',2.85),('16273','2013-05-25','16:45:00',2.44),('16273','2013-05-25','16:50:00',2.43),('16273','2013-05-25','16:55:00',2.16),('16273','2013-05-25','17:00:00',2.36),('16273','2013-05-25','17:05:00',2.23),('16273','2013-05-25','17:10:00',2.08),('16273','2013-05-25','17:15:00',1.96),('16273','2013-05-25','17:20:00',1.72),('16273','2013-05-25','17:25:00',1.32),('16273','2013-05-25','17:30:00',2.11),('16273','2013-05-25','17:35:00',1.65),('16273','2013-05-25','17:40:00',1.82),('16273','2013-05-25','17:45:00',1.66),('16273','2013-05-25','17:50:00',1.58),('16273','2013-05-25','17:55:00',1.28),('16273','2013-05-24','07:55:00',1.34),('16273','2013-05-24','08:00:00',1.61),('16273','2013-05-24','08:05:00',1.08),('16273','2013-05-24','08:10:00',1.44),('16273','2013-05-24','08:20:00',2.21),('16273','2013-05-24','08:25:00',2.46),('16273','2013-05-24','08:30:00',2.54),('16273','2013-05-24','08:35:00',2.58),('16273','2013-05-24','08:40:00',2.65),('16273','2013-05-24','08:45:00',2.78),('16273','2013-05-24','08:50:00',2.85),('16273','2013-05-24','08:55:00',3.1),('16273','2013-05-24','09:00:00',2.35),('16273','2013-05-24','09:10:00',2.38),('16273','2013-05-24','09:20:00',1.94),('16273','2013-05-24','09:25:00',1.98),('16273','2013-05-24','09:35:00',1.6),('16273','2013-05-24','09:45:00',1.15),('16273','2013-05-24','09:50:00',3.03),('16273','2013-05-24','09:55:00',3.24),('16273','2013-05-24','10:20:00',1.73),('16273','2013-05-24','10:25:00',4.37),('16273','2013-05-24','10:30:00',4.19),('16273','2013-05-24','10:35:00',3.74),('16273','2013-05-24','10:40:00',4.25),('16273','2013-05-24','10:45:00',4.26),('16273','2013-05-24','10:50:00',2.46),('16273','2013-05-24','10:55:00',3.98),('16273','2013-05-24','11:00:00',3.89),('16273','2013-05-24','11:05:00',4.13),('16273','2013-05-24','11:10:00',2.26),('16273','2013-05-24','11:15:00',4.47),('16273','2013-05-24','11:20:00',4.72),('16273','2013-05-24','11:25:00',3.24),('16273','2013-05-24','11:30:00',1.51),('16273','2013-05-24','11:40:00',1.61),('16273','2013-05-24','11:45:00',3.97),('16273','2013-05-24','11:50:00',1.98),('16273','2013-05-24','11:55:00',2.8),('16273','2013-05-24','12:00:00',3.13),('16273','2013-05-24','12:05:00',3.12),('16273','2013-05-24','12:10:00',2.15),('16273','2013-05-24','12:15:00',1.83),('16273','2013-05-24','12:20:00',2.36),('16273','2013-05-24','12:25:00',3.1),('16273','2013-05-24','12:30:00',2.68),('16273','2013-05-24','12:35:00',2.36),('16273','2013-05-24','12:40:00',2.44),('16273','2013-05-24','12:45:00',2.43),('16273','2013-05-24','12:50:00',2.47),('16273','2013-05-24','12:55:00',2.23),('16273','2013-05-24','13:00:00',4.08),('16273','2013-05-24','13:05:00',4.5),('16273','2013-05-24','13:10:00',3.5),('16273','2013-05-24','13:15:00',3.54),('16273','2013-05-24','13:20:00',3.92),('16273','2013-05-24','13:25:00',4.36),('16273','2013-05-24','13:30:00',3.11),('16273','2013-05-24','13:35:00',1.74),('16273','2013-05-24','13:40:00',1.08),('16273','2013-05-24','13:45:00',1.37),('16273','2013-05-24','13:50:00',3.6),('16273','2013-05-24','13:55:00',3.59),('16273','2013-05-24','14:00:00',2.18),('16273','2013-05-24','14:05:00',3.94),('16273','2013-05-24','14:10:00',1.93),('16273','2013-05-24','14:15:00',3.1),('16273','2013-05-24','14:20:00',3.55),('16273','2013-05-24','14:25:00',4.58),('16273','2013-05-24','14:30:00',4.49),('16273','2013-05-24','14:35:00',4.37),('16273','2013-05-24','14:40:00',3.57),('16273','2013-05-24','14:45:00',1.93),('16273','2013-05-24','14:50:00',1.96),('16273','2013-05-24','14:55:00',3.39),('16273','2013-05-24','15:00:00',3.47),('16273','2013-05-24','15:05:00',2.7),('16273','2013-05-24','15:10:00',2.78),('16273','2013-05-24','15:15:00',3.93),('16273','2013-05-24','15:20:00',3.96),('16273','2013-05-24','15:25:00',1.99),('16273','2013-05-24','15:30:00',1.53),('16273','2013-05-24','15:35:00',2.05),('16273','2013-05-24','15:40:00',2.32),('16273','2013-05-24','15:45:00',1.8),('16273','2013-05-24','15:50:00',1.69),('16273','2013-05-24','15:55:00',1.79),('16273','2013-05-24','16:00:00',1.76),('16273','2013-05-24','16:05:00',1.56),('16273','2013-05-24','16:10:00',1.22),('16273','2013-05-24','16:15:00',1.05),('16273','2013-05-24','16:20:00',1.21),('16273','2013-05-24','16:25:00',1.06),('16273','2013-05-24','16:40:00',1.01),('16273','2013-05-24','16:45:00',1.23),('16273','2013-05-24','16:50:00',1.19),('16273','2013-05-24','16:55:00',1.16),('16273','2013-05-24','17:00:00',1.03),('16273','2013-05-24','17:15:00',1.07),('16273','2013-05-24','17:20:00',1.03),('16273','2013-05-24','17:25:00',1.01),('16273','2013-05-23','07:40:00',1.02),('16273','2013-05-23','07:45:00',1.1),('16273','2013-05-23','08:15:00',1.51),('16273','2013-05-23','08:20:00',2.22),('16273','2013-05-23','08:25:00',2.21),('16273','2013-05-23','08:30:00',2.73),('16273','2013-05-23','08:35:00',2.3),('16273','2013-05-23','08:40:00',1.16),('16273','2013-05-23','09:05:00',1.72),('16273','2013-05-23','09:10:00',3.34),('16273','2013-05-23','09:15:00',3.51),('16273','2013-05-23','09:20:00',2.57),('16273','2013-05-23','09:25:00',1.52),('16273','2013-05-23','09:35:00',2.02),('16273','2013-05-23','09:40:00',1.59),('16273','2013-05-23','09:45:00',1.01),('16273','2013-05-23','09:50:00',2.11),('16273','2013-05-23','09:55:00',4.46),('16273','2013-05-23','10:00:00',1.64),('16273','2013-05-23','10:05:00',1.42),('16273','2013-05-23','10:10:00',1.45),('16273','2013-05-23','10:15:00',3.64),('16273','2013-05-23','10:20:00',1.35),('16273','2013-05-23','10:25:00',1.83),('16273','2013-05-23','10:30:00',2.54),('16273','2013-05-23','10:35:00',3.27),('16273','2013-05-23','10:40:00',2),('16273','2013-05-23','10:45:00',2.09),('16273','2013-05-23','10:50:00',1.52),('16273','2013-05-23','10:55:00',2.39),('16273','2013-05-23','11:00:00',4.08),('16273','2013-05-23','11:05:00',1.62),('16273','2013-05-23','11:10:00',1.94),('16273','2013-05-23','11:15:00',1.97),('16273','2013-05-23','11:20:00',1.85),('16273','2013-05-23','11:25:00',4.38),('16273','2013-05-23','11:30:00',4.72),('16273','2013-05-23','11:35:00',2.61),('16273','2013-05-23','11:40:00',3.44),('16273','2013-05-23','11:45:00',3.6),('16273','2013-05-23','11:50:00',4.09),('16273','2013-05-23','11:55:00',2.65),('16273','2013-05-23','12:00:00',2.87),('16273','2013-05-23','12:05:00',2.44),('16273','2013-05-23','12:10:00',3.65),('16273','2013-05-23','12:15:00',3.52),('16273','2013-05-23','12:20:00',3.38),('16273','2013-05-23','12:25:00',2.02),('16273','2013-05-23','12:30:00',1.54),('16273','2013-05-23','12:35:00',3.94),('16273','2013-05-23','12:40:00',4.74),('16273','2013-05-23','12:45:00',2.12),('16273','2013-05-23','12:50:00',3.49),('16273','2013-05-23','12:55:00',2.89),('16273','2013-05-23','13:00:00',4.49),('16273','2013-05-23','13:05:00',3.31),('16273','2013-05-23','13:10:00',4.27),('16273','2013-05-23','13:15:00',3.74),('16273','2013-05-23','13:20:00',2.09),('16273','2013-05-23','13:25:00',2.17),('16273','2013-05-23','13:30:00',3.08),('16273','2013-05-23','13:35:00',2.39),('16273','2013-05-23','13:40:00',3.65),('16273','2013-05-23','13:45:00',2.85),('16273','2013-05-23','13:50:00',4.03),('16273','2013-05-23','13:55:00',4.09),('16273','2013-05-23','14:00:00',3.89),('16273','2013-05-23','14:05:00',2.82),('16273','2013-05-23','14:10:00',3.87),('16273','2013-05-23','14:15:00',3.69),('16273','2013-05-23','14:20:00',2.89),('16273','2013-05-23','14:25:00',4.45),('16273','2013-05-23','14:30:00',4.17),('16273','2013-05-23','14:35:00',2.76),('16273','2013-05-23','14:40:00',1.25),('16273','2013-05-23','14:45:00',2.72),('16273','2013-05-23','14:50:00',2.73),('16273','2013-05-23','14:55:00',2.58),('16273','2013-05-23','15:00:00',2.47),('16273','2013-05-23','15:05:00',2.6),('16273','2013-05-23','15:10:00',2.41),('16273','2013-05-23','15:15:00',2.73),('16273','2013-05-23','15:20:00',2.55),('16273','2013-05-23','15:25:00',2.41),('16273','2013-05-23','15:30:00',1.79),('16273','2013-05-23','15:35:00',1.27),('16273','2013-05-23','15:40:00',1.65),('16273','2013-05-23','15:45:00',3.73),('16273','2013-05-23','15:50:00',2.92),('16273','2013-05-23','15:55:00',2.85),('16273','2013-05-23','16:00:00',2.92),('16273','2013-05-23','16:05:00',2.54),('16273','2013-05-23','16:10:00',2.63),('16273','2013-05-23','16:15:00',2.04),('16273','2013-05-23','16:20:00',2.27),('16273','2013-05-23','16:25:00',1.58),('16273','2013-05-23','16:30:00',1.54),('16273','2013-05-23','16:35:00',2.36),('16273','2013-05-23','16:40:00',1.21),('16273','2013-05-23','16:50:00',1.37),('16273','2013-05-23','16:55:00',1.42),('16273','2013-05-23','17:00:00',1.72),('16273','2013-05-23','17:05:00',1.72),('16273','2013-05-23','17:10:00',1.12),('16273','2013-05-23','17:45:00',1.52),('16273','2013-05-23','17:50:00',1.64),('16273','2013-05-23','17:55:00',1.36),('16273','2013-05-22','08:00:00',1.2),('16273','2013-05-22','08:05:00',1.92),('16273','2013-05-22','08:10:00',1.83),('16273','2013-05-22','08:15:00',1.07),('16273','2013-05-22','08:20:00',1.2),('16273','2013-05-22','08:25:00',2.03),('16273','2013-05-22','08:30:00',1.75),('16273','2013-05-22','09:20:00',1.19),('16273','2013-05-22','09:25:00',2.06),('16273','2013-05-22','09:30:00',3.17),('16273','2013-05-22','09:35:00',3.19),('16273','2013-05-22','09:40:00',3.22),('16273','2013-05-22','09:45:00',3.24),('16273','2013-05-22','09:50:00',3.29),('16273','2013-05-22','09:55:00',3.36),('16273','2013-05-22','10:00:00',3.41),('16273','2013-05-22','10:05:00',3.43),('16273','2013-05-22','10:10:00',3.42),('16273','2013-05-22','10:15:00',3.47),('16273','2013-05-22','10:20:00',3.61),('16273','2013-05-22','10:25:00',3.62),('16273','2013-05-22','10:30:00',3.59),('16273','2013-05-22','10:35:00',3.05),('16273','2013-05-22','10:40:00',3.01),('16273','2013-05-22','10:45:00',3.93),('16273','2013-05-22','10:50:00',3.8),('16273','2013-05-22','10:55:00',3.81),('16273','2013-05-22','11:00:00',3.84),('16273','2013-05-22','11:05:00',3.86),('16273','2013-05-22','11:10:00',3.85),('16273','2013-05-22','11:15:00',3.86),('16273','2013-05-22','11:20:00',3.92),('16273','2013-05-22','11:25:00',4.02),('16273','2013-05-22','11:30:00',3.69),('16273','2013-05-22','11:35:00',3.86),('16273','2013-05-22','11:40:00',2.69),('16273','2013-05-22','11:45:00',3.35),('16273','2013-05-22','11:50:00',2.77),('16273','2013-05-22','11:55:00',3.18),('16273','2013-05-22','12:00:00',2.19),('16273','2013-05-22','12:05:00',2.43),('16273','2013-05-22','12:30:00',1.91),('16273','2013-05-22','12:35:00',1.44),('16273','2013-05-22','12:40:00',1.19),('16273','2013-05-22','13:05:00',1.42),('16273','2013-05-22','13:10:00',1.51),('16273','2013-05-22','13:15:00',2.36),('16273','2013-05-22','13:20:00',2.11),('16273','2013-05-22','13:25:00',1.21),('16273','2013-05-22','13:30:00',2.25),('16273','2013-05-22','13:35:00',2.98),('16273','2013-05-22','13:40:00',3.5),('16273','2013-05-22','13:45:00',3.09),('16273','2013-05-22','13:50:00',2.4),('16273','2013-05-22','13:55:00',3.35),('16273','2013-05-22','14:00:00',2.86),('16273','2013-05-22','14:05:00',4.04),('16273','2013-05-22','14:10:00',3.85),('16273','2013-05-22','14:15:00',3.75),('16273','2013-05-22','14:20:00',3.71),('16273','2013-05-22','14:25:00',3.66),('16273','2013-05-22','14:30:00',3.63),('16273','2013-05-22','14:35:00',3.58),('16273','2013-05-22','14:40:00',3.52),('16273','2013-05-22','14:45:00',3.48),('16273','2013-05-22','14:50:00',3.4),('16273','2013-05-22','14:55:00',3.38),('16273','2013-05-22','15:00:00',3.16),('16273','2013-05-22','15:05:00',3.26),('16273','2013-05-22','15:10:00',2.71),('16273','2013-05-22','15:15:00',3.21),('16273','2013-05-22','15:20:00',3.14),('16273','2013-05-22','15:25:00',3.14),('16273','2013-05-22','15:30:00',2.9),('16273','2013-05-22','15:35:00',3),('16273','2013-05-22','15:40:00',2.85),('16273','2013-05-22','15:45:00',2.8),('16273','2013-05-22','15:50:00',2.78),('16273','2013-05-22','15:55:00',2.69),('16273','2013-05-22','16:00:00',2.63),('16273','2013-05-22','16:05:00',2.56),('16273','2013-05-22','16:10:00',2.51),('16273','2013-05-22','16:15:00',2.53),('16273','2013-05-22','16:20:00',2.43),('16273','2013-05-22','16:25:00',2.13),('16273','2013-05-22','16:30:00',1.97),('16273','2013-05-22','16:35:00',1.83),('16273','2013-05-22','16:40:00',1.45),('16273','2013-05-22','16:45:00',1.1),('16273','2013-05-22','16:50:00',1.08),('16273','2013-05-22','17:20:00',1.48),('16273','2013-05-22','17:25:00',1.1),('16273','2013-05-22','17:30:00',1.2),('16273','2013-05-22','17:35:00',1.52),('16273','2013-05-22','17:40:00',1.61),('16273','2013-05-22','18:00:00',1.13),('16273','2013-05-22','18:40:00',1.11),('16273','2014-04-01','08:10:00',1.21),('16273','2014-04-01','08:15:00',1.16),('16273','2014-04-01','08:20:00',1.38),('16273','2014-04-01','08:25:00',1.55),('16273','2014-04-01','08:30:00',1.65),('16273','2014-04-01','08:35:00',1.76),('16273','2014-04-01','08:40:00',1.84),('16273','2014-04-01','08:45:00',1.92),('16273','2014-04-01','08:50:00',1.97),('16273','2014-04-01','08:55:00',2.07),('16273','2014-04-01','09:00:00',2.15),('16273','2014-04-01','09:05:00',2.23),('16273','2014-04-01','09:10:00',2.3),('16273','2014-04-01','09:15:00',2.38),('16273','2014-04-01','09:20:00',2.41),('16273','2014-04-01','09:25:00',2.45),('16273','2014-04-01','09:30:00',2.49),('16273','2014-04-01','09:35:00',2.66),('16273','2014-04-01','09:40:00',2.77),('16273','2014-04-01','09:45:00',2.82),('16273','2014-04-01','09:50:00',2.89),('16273','2014-04-01','09:55:00',2.95),('16273','2014-04-01','10:00:00',3.03),('16273','2014-04-01','10:05:00',3.05),('16273','2014-04-01','10:10:00',3.13),('16273','2014-04-01','10:15:00',3.17),('16273','2014-04-01','10:20:00',3.21),('16273','2014-04-01','10:25:00',3.1),('16273','2014-04-01','10:30:00',3.31),('16273','2014-04-01','10:35:00',3.38),('16273','2014-04-01','10:40:00',3.24),('16273','2014-04-01','10:45:00',3.26),('16273','2014-04-01','10:50:00',3.16),('16273','2014-04-01','10:55:00',3.5),('16273','2014-04-01','11:00:00',3.5),('16273','2014-04-01','11:05:00',3.43),('16273','2014-04-01','11:10:00',3.57),('16273','2014-04-01','11:15:00',3.63),('16273','2014-04-01','11:20:00',3.65),('16273','2014-04-01','11:25:00',3.62),('16273','2014-04-01','11:30:00',3.67),('16273','2014-04-01','11:35:00',3.69),('16273','2014-04-01','11:40:00',3.76),('16273','2014-04-01','11:45:00',3.77),('16273','2014-04-01','11:50:00',3.78),('16273','2014-04-01','11:55:00',3.8),('16273','2014-04-01','12:00:00',3.84),('16273','2014-04-01','12:05:00',3.84),('16273','2014-04-01','12:10:00',3.87),('16273','2014-04-01','12:15:00',3.88),('16273','2014-04-01','12:20:00',3.92),('16273','2014-04-01','12:25:00',3.91),('16273','2014-04-01','12:30:00',3.95),('16273','2014-04-01','12:35:00',4.05),('16273','2014-04-01','12:40:00',3.99),('16273','2014-04-01','12:45:00',3.94),('16273','2014-04-01','12:50:00',4.03),('16273','2014-04-01','12:55:00',3.96),('16273','2014-04-01','13:00:00',3.93),('16273','2014-04-01','13:05:00',3.84),('16273','2014-04-01','13:10:00',3.82),('16273','2014-04-01','13:15:00',3.82),('16273','2014-04-01','13:20:00',3.88),('16273','2014-04-01','13:25:00',3.86),('16273','2014-04-01','13:30:00',3.93),('16273','2014-04-01','13:35:00',3.99),('16273','2014-04-01','13:40:00',3.96),('16273','2014-04-01','13:45:00',3.55),('16273','2014-04-01','13:50:00',3.27),('16273','2014-04-01','13:55:00',3.85),('16273','2014-04-01','14:00:00',3.72),('16273','2014-04-01','14:05:00',3.4),('16273','2014-04-01','14:10:00',3.44),('16273','2014-04-01','14:15:00',3.59),('16273','2014-04-01','14:20:00',3.63),('16273','2014-04-01','14:25:00',3.18),('16273','2014-04-01','14:30:00',3.12),('16273','2014-04-01','14:35:00',3.24),('16273','2014-04-01','14:40:00',3.51),('16273','2014-04-01','14:45:00',3.48),('16273','2014-04-01','14:50:00',3.25),('16273','2014-04-01','14:55:00',2.36),('16273','2014-04-01','15:00:00',2.6),('16273','2014-04-01','15:05:00',3.07),('16273','2014-04-01','15:10:00',3.16),('16273','2014-04-01','15:15:00',2.55),('16273','2014-04-01','15:20:00',3.1),('16273','2014-04-01','15:25:00',2.98),('16273','2014-04-01','15:30:00',2.81),('16273','2014-04-01','15:35:00',2.93),('16273','2014-04-01','15:40:00',2.29),('16273','2014-04-01','15:45:00',2.87),('16273','2014-04-01','15:50:00',2.74),('16273','2014-04-01','15:55:00',2.34),('16273','2014-04-01','16:00:00',1.86),('16273','2014-04-01','16:05:00',2.3),('16273','2014-04-01','16:10:00',1.69),('16273','2014-04-01','16:15:00',1.67),('16273','2014-04-01','16:20:00',2.05),('16273','2014-04-01','16:25:00',2.23),('16273','2014-04-01','16:30:00',1.64),('16273','2014-04-01','16:35:00',1.67),('16273','2014-04-01','16:40:00',1.81),('16273','2014-04-01','16:45:00',1.7),('16273','2014-04-01','16:50:00',1.58),('16273','2014-04-01','16:55:00',1.62),('16273','2014-04-01','17:00:00',1.53),('16273','2014-04-01','17:05:00',1.42),('16273','2014-04-01','17:10:00',1.34),('16273','2014-04-01','17:15:00',1.29),('16273','2014-04-01','17:20:00',1.17),('16273','2014-04-01','17:25:00',1.1),('16273','2014-04-01','17:30:00',1.04),('16273','2013-05-21','07:15:00',1.09),('16273','2013-05-21','07:20:00',1.18),('16273','2013-05-21','07:25:00',1.31),('16273','2013-05-21','07:30:00',1.53),('16273','2013-05-21','07:35:00',1.84),('16273','2013-05-21','07:40:00',1.71),('16273','2013-05-21','07:45:00',1.3),('16273','2013-05-21','07:50:00',1.35),('16273','2013-05-21','08:00:00',1.17),('16273','2013-05-21','08:05:00',2.14),('16273','2013-05-21','08:10:00',2.28),('16273','2013-05-21','08:15:00',1.57),('16273','2013-05-21','08:20:00',1.84),('16273','2013-05-21','08:25:00',1.34),('16273','2013-05-21','08:30:00',1.28),('16273','2013-05-21','08:35:00',1.62),('16273','2013-05-21','08:40:00',1.43),('16273','2013-05-21','08:45:00',1.23),('16273','2013-05-21','08:50:00',1.34),('16273','2013-05-21','08:55:00',1.37),('16273','2013-05-21','09:00:00',1.3),('16273','2013-05-21','09:05:00',1.39),('16273','2013-05-21','09:10:00',1.79),('16273','2013-05-21','09:15:00',1.84),('16273','2013-05-21','09:20:00',2.38),('16273','2013-05-21','09:25:00',1.91),('16273','2013-05-21','09:30:00',1.7),('16273','2013-05-21','09:35:00',1.87),('16273','2013-05-21','09:40:00',1.61),('16273','2013-05-21','09:45:00',1.64),('16273','2013-05-21','09:50:00',1.73),('16273','2013-05-21','09:55:00',2.13),('16273','2013-05-21','10:00:00',1.91),('16273','2013-05-21','10:05:00',1.97),('16273','2013-05-21','10:10:00',1.94),('16273','2013-05-21','10:15:00',1.68),('16273','2013-05-21','10:20:00',2.05),('16273','2013-05-21','10:25:00',2.28),('16273','2013-05-21','10:30:00',1.67),('16273','2013-05-21','10:35:00',1.99),('16273','2013-05-21','10:40:00',2.85),('16273','2013-05-21','10:45:00',2.63),('16273','2013-05-21','10:50:00',1.98),('16273','2013-05-21','10:55:00',1.73),('16273','2013-05-21','11:00:00',1.63),('16273','2013-05-21','11:05:00',2.56),('16273','2013-05-21','11:10:00',2.56),('16273','2013-05-21','11:15:00',2.52),('16273','2013-05-21','11:20:00',4.06),('16273','2013-05-21','11:25:00',2.89),('16273','2013-05-21','11:30:00',2.96),('16273','2013-05-21','11:35:00',2.18),('16273','2013-05-21','11:40:00',2.44),('16273','2013-05-21','11:45:00',2.59),('16273','2013-05-21','11:50:00',2.65),('16273','2013-05-21','11:55:00',2.3),('16273','2013-05-21','12:00:00',2.87),('16273','2013-05-21','12:05:00',3.5),('16273','2013-05-21','12:10:00',3.45),('16273','2013-05-21','12:15:00',2.72),('16273','2013-05-21','12:20:00',2.24),('16273','2013-05-21','12:25:00',2.86),('16273','2013-05-21','12:30:00',2.43),('16273','2013-05-21','12:35:00',2.19),('16273','2013-05-21','12:40:00',2.63),('16273','2013-05-21','12:45:00',2.91),('16273','2013-05-21','12:50:00',2.72),('16273','2013-05-21','12:55:00',2.72),('16273','2013-05-21','13:00:00',3.21),('16273','2013-05-21','13:05:00',2.44),('16273','2013-05-21','13:10:00',2.65),('16273','2013-05-21','13:15:00',3.22),('16273','2013-05-21','13:20:00',2.79),('16273','2013-05-21','13:25:00',2.3),('16273','2013-05-21','13:30:00',1.52),('16273','2013-05-21','13:35:00',1.11),('16273','2013-05-21','14:05:00',1.17),('16273','2013-05-21','14:10:00',2.22),('16273','2013-05-21','14:15:00',1.85),('16273','2013-05-21','14:20:00',2.72),('16273','2013-05-21','14:25:00',4.02),('16273','2013-05-21','14:30:00',3.49),('16273','2013-05-21','14:35:00',2.12),('16273','2013-05-21','14:40:00',1.59),('16273','2013-05-21','15:15:00',1.36),('16273','2013-05-21','15:20:00',1.59),('16273','2013-05-21','15:25:00',2.15),('16273','2013-05-21','15:30:00',2.55),('16273','2013-05-21','15:35:00',2.74),('16273','2013-05-21','15:40:00',2.06),('16273','2013-05-21','15:45:00',1.46),('16273','2013-05-21','16:05:00',1.23),('16273','2013-05-21','16:25:00',1.14),('16273','2013-05-21','16:30:00',1.53),('16273','2013-05-21','16:35:00',1.44),('16273','2013-05-21','16:40:00',1.17),('16273','2013-05-21','16:45:00',1),('16273','2013-05-20','07:15:00',1.29),('16273','2013-05-20','07:25:00',1.39),('16273','2013-05-20','07:35:00',1.34),('16273','2013-05-20','07:40:00',1.31),('16273','2013-05-20','07:45:00',1.75),('16273','2013-05-20','07:50:00',1.71),('16273','2013-05-20','07:55:00',2.11),('16273','2013-05-20','08:00:00',2.19),('16273','2013-05-20','08:05:00',2.16),('16273','2013-05-20','08:10:00',2.55),('16273','2013-05-20','08:15:00',2.38),('16273','2013-05-20','08:20:00',2.65),('16273','2013-05-20','08:25:00',2.84),('16273','2013-05-20','08:30:00',1.55),('16273','2013-05-20','08:35:00',1.56),('16273','2013-05-20','08:55:00',1.78),('16273','2013-05-20','09:00:00',2.98),('16273','2013-05-20','09:05:00',1.41),('16273','2013-05-20','09:15:00',3.09),('16273','2013-05-20','09:20:00',3.45),('16273','2013-05-20','09:25:00',3.25),('16273','2013-05-20','09:30:00',3.26),('16273','2013-05-20','09:35:00',3.69),('16273','2013-05-20','09:40:00',3.84),('16273','2013-05-20','09:45:00',3.41),('16273','2013-05-20','09:50:00',3.92),('16273','2013-05-20','09:55:00',3.79),('16273','2013-05-20','10:00:00',2.03),('16273','2013-05-20','10:05:00',2.71),('16273','2013-05-20','10:10:00',3.7),('16273','2013-05-20','10:15:00',1.43),('16273','2013-05-20','10:20:00',3.51),('16273','2013-05-20','10:25:00',3.01),('16273','2013-05-20','10:30:00',4.12),('16273','2013-05-20','10:35:00',4.2),('16273','2013-05-20','10:40:00',3.57),('16273','2013-05-20','10:45:00',2.93),('16273','2013-05-20','10:50:00',4.02),('16273','2013-05-20','10:55:00',3.54),('16273','2013-05-20','11:00:00',2.67),('16273','2013-05-20','11:05:00',3.65),('16273','2013-05-20','11:10:00',4.39),('16273','2013-05-20','11:15:00',4.01),('16273','2013-05-20','11:20:00',4.4),('16273','2013-05-20','11:25:00',4),('16273','2013-05-20','11:30:00',4.5),('16273','2013-05-20','11:35:00',4.55),('16273','2013-05-20','11:40:00',3.64),('16273','2013-05-20','11:45:00',3.43),('16273','2013-05-20','11:50:00',3.99),('16273','2013-05-20','11:55:00',4.34),('16273','2013-05-20','12:00:00',4.32),('16273','2013-05-20','12:05:00',4.38),('16273','2013-05-20','12:10:00',4.39),('16273','2013-05-20','12:15:00',3.53),('16273','2013-05-20','12:20:00',4.36),('16273','2013-05-20','12:25:00',4.34),('16273','2013-05-20','12:30:00',4.32),('16273','2013-05-20','12:35:00',4.33),('16273','2013-05-20','12:40:00',4.33),('16273','2013-05-20','12:45:00',4.3),('16273','2013-05-20','12:50:00',4.28),('16273','2013-05-20','12:55:00',4.29),('16273','2013-05-20','13:00:00',4.29),('16273','2013-05-20','13:05:00',4.27),('16273','2013-05-20','13:10:00',4.22),('16273','2013-05-20','13:15:00',4.24),('16273','2013-05-20','13:20:00',4.21),('16273','2013-05-20','13:25:00',4.15),('16273','2013-05-20','13:30:00',4.13),('16273','2013-05-20','13:35:00',4.1),('16273','2013-05-20','13:40:00',4.12),('16273','2013-05-20','13:45:00',4.11),('16273','2013-05-20','13:50:00',4.03),('16273','2013-05-20','13:55:00',4.04),('16273','2013-05-20','14:00:00',4.07),('16273','2013-05-20','14:05:00',4.04),('16273','2013-05-20','14:10:00',3.82),('16273','2013-05-20','14:15:00',2.72),('16273','2013-05-20','14:20:00',3.49),('16273','2013-05-20','14:25:00',3.55),('16273','2013-05-20','14:30:00',3.78),('16273','2013-05-20','14:35:00',3.72),('16273','2013-05-20','14:40:00',3.72),('16273','2013-05-20','14:45:00',3.63),('16273','2013-05-20','14:50:00',3.24),('16273','2013-05-20','14:55:00',3.61),('16273','2013-05-20','15:00:00',3.54),('16273','2013-05-20','15:05:00',3.49),('16273','2013-05-20','15:10:00',3.49),('16273','2013-05-20','15:15:00',3.41),('16273','2013-05-20','15:20:00',3.34),('16273','2013-05-20','15:25:00',3.29),('16273','2013-05-20','15:30:00',3.21),('16273','2013-05-20','15:35:00',3.17),('16273','2013-05-20','15:40:00',3.1),('16273','2013-05-20','15:45:00',3.06),('16273','2013-05-20','15:50:00',2.98),('16273','2013-05-20','15:55:00',2.93),('16273','2013-05-20','16:00:00',2.84),('16273','2013-05-20','16:05:00',2.77),('16273','2013-05-20','16:10:00',2.69),('16273','2013-05-20','16:15:00',2.61),('16273','2013-05-20','16:20:00',2.54),('16273','2013-05-20','16:25:00',2.48),('16273','2013-05-20','16:30:00',2.37),('16273','2013-05-20','16:35:00',2.25),('16273','2013-05-20','16:40:00',2.06),('16273','2013-05-20','16:45:00',2.07),('16273','2013-05-20','16:50:00',2.09),('16273','2013-05-20','16:55:00',1.55),('16273','2013-05-20','17:00:00',1.43),('16273','2013-05-20','17:05:00',1.6),('16273','2013-05-20','17:10:00',1.26),('16273','2013-05-20','17:15:00',1.51),('16273','2013-05-20','17:20:00',1.73),('16273','2013-05-20','17:25:00',1.73),('16273','2013-05-20','17:30:00',1.34),('16273','2013-05-20','17:35:00',1.35),('16273','2013-05-20','17:40:00',1.25),('16273','2013-05-20','17:45:00',1.18),('16273','2013-05-20','17:50:00',1.11),('16273','2013-05-20','17:55:00',1.04),('16273','2013-05-19','08:25:00',1.04),('16273','2013-05-19','08:30:00',1.43),('16273','2013-05-19','08:35:00',1.16),('16273','2013-05-19','08:40:00',1.36),('16273','2013-05-19','09:05:00',1.02),('16273','2013-05-19','09:25:00',1.21),('16273','2013-05-19','09:30:00',1.28),('16273','2013-05-19','09:35:00',1.25),('16273','2013-05-19','09:40:00',1.18),('16273','2013-05-19','09:45:00',1.41),('16273','2013-05-19','09:50:00',1.58),('16273','2013-05-19','09:55:00',1.97),('16273','2013-05-19','10:00:00',2.41),('16273','2013-05-19','10:05:00',2.44),('16273','2013-05-19','10:10:00',2.21),('16273','2013-05-19','10:15:00',2.27),('16273','2013-05-19','10:20:00',1.82),('16273','2013-05-19','10:25:00',2.87),('16273','2013-05-19','10:30:00',3.19),('16273','2013-05-19','10:35:00',2.6),('16273','2013-05-19','10:40:00',3.4),('16273','2013-05-19','10:45:00',3.45),('16273','2013-05-19','10:50:00',3.98),('16273','2013-05-19','10:55:00',3.59),('16273','2013-05-19','11:00:00',3.29),('16273','2013-05-19','11:05:00',3.01),('16273','2013-05-19','11:10:00',3.88),('16273','2013-05-19','11:15:00',4.26),('16273','2013-05-19','11:20:00',3.63),('16273','2013-05-19','11:25:00',4.32),('16273','2013-05-19','11:30:00',3.9),('16273','2013-05-19','11:35:00',4.35),('16273','2013-05-19','11:40:00',4.27),('16273','2013-05-19','11:45:00',4.27),('16273','2013-05-19','11:50:00',4.3),('16273','2013-05-19','11:55:00',4.34),('16273','2013-05-19','12:00:00',4.35),('16273','2013-05-19','12:05:00',4.34),('16273','2013-05-19','12:10:00',4.36),('16273','2013-05-19','12:15:00',4.38),('16273','2013-05-19','12:20:00',4.4),('16273','2013-05-19','12:25:00',4.42),('16273','2013-05-19','12:30:00',4.35),('16273','2013-05-19','12:35:00',4.35),('16273','2013-05-19','12:40:00',4.42),('16273','2013-05-19','12:45:00',4.39),('16273','2013-05-19','12:50:00',4.45),('16273','2013-05-19','12:55:00',4.37),('16273','2013-05-19','13:00:00',4.33),('16273','2013-05-19','13:05:00',4.33),('16273','2013-05-19','13:10:00',4.28),('16273','2013-05-19','13:15:00',4.23),('16273','2013-05-19','13:20:00',4.22),('16273','2013-05-19','13:25:00',4.19),('16273','2013-05-19','13:30:00',4.17),('16273','2013-05-19','13:35:00',4.16),('16273','2013-05-19','13:40:00',4.17),('16273','2013-05-19','13:45:00',4.14),('16273','2013-05-19','13:50:00',4.12),('16273','2013-05-19','13:55:00',4.05),('16273','2013-05-19','14:00:00',4.02),('16273','2013-05-19','14:05:00',4.01),('16273','2013-05-19','14:10:00',4.01),('16273','2013-05-19','14:15:00',3.96),('16273','2013-05-19','14:20:00',3.93),('16273','2013-05-19','14:25:00',3.89),('16273','2013-05-19','14:30:00',3.83),('16273','2013-05-19','14:35:00',3.77),('16273','2013-05-19','14:40:00',3.73),('16273','2013-05-19','14:45:00',3.69),('16273','2013-05-19','14:50:00',3.66),('16273','2013-05-19','14:55:00',3.64),('16273','2013-05-19','15:00:00',3.6),('16273','2013-05-19','15:05:00',3.53),('16273','2013-05-19','15:10:00',3.49),('16273','2013-05-19','15:15:00',3.45),('16273','2013-05-19','15:20:00',3.4),('16273','2013-05-19','15:25:00',3.32),('16273','2013-05-19','15:30:00',3.23),('16273','2013-05-19','15:35:00',3.19),('16273','2013-05-19','15:40:00',3.11),('16273','2013-05-19','15:45:00',3.08),('16273','2013-05-19','15:50:00',3.03),('16273','2013-05-19','15:55:00',2.95),('16273','2013-05-19','16:00:00',2.88),('16273','2013-05-19','16:05:00',2.81),('16273','2013-05-19','16:10:00',2.73),('16273','2013-05-19','16:15:00',2.65),('16273','2013-05-19','16:20:00',2.58),('16273','2013-05-19','16:25:00',2.51),('16273','2013-05-19','16:30:00',2.45),('16273','2013-05-19','16:35:00',2.38),('16273','2013-05-19','16:40:00',2.3),('16273','2013-05-19','16:45:00',2.19),('16273','2013-05-19','16:50:00',2.13),('16273','2013-05-19','16:55:00',2.06),('16273','2013-05-19','17:00:00',1.96),('16273','2013-05-19','17:05:00',1.87),('16273','2013-05-19','17:10:00',1.8),('16273','2013-05-19','17:15:00',1.72),('16273','2013-05-19','17:20:00',1.63),('16273','2013-05-19','17:25:00',1.54),('16273','2013-05-19','17:30:00',1.46),('16273','2013-05-19','17:35:00',1.37),('16273','2013-05-19','17:40:00',1.29),('16273','2013-05-19','17:45:00',1.21),('16273','2013-05-19','17:50:00',1.13),('16273','2013-05-19','17:55:00',1.06),('16273','2013-05-18','07:10:00',1.02),('16273','2013-05-18','07:15:00',1.16),('16273','2013-05-18','07:20:00',1.26),('16273','2013-05-18','07:25:00',1.34),('16273','2013-05-18','07:30:00',1.43),('16273','2013-05-18','07:35:00',1.53),('16273','2013-05-18','07:40:00',1.63),('16273','2013-05-18','07:45:00',1.59),('16273','2013-05-18','07:50:00',1.4),('16273','2013-05-18','07:55:00',1.33),('16273','2013-05-18','08:00:00',2.06),('16273','2013-05-18','08:05:00',1.03),('16273','2013-05-18','08:10:00',1.01),('16273','2013-05-18','08:15:00',1.16),('16273','2013-05-18','08:20:00',1.6),('16273','2013-05-18','08:25:00',1.78),('16273','2013-05-18','08:30:00',1.73),('16273','2013-05-18','08:35:00',1.92),('16273','2013-05-18','08:40:00',2.76),('16273','2013-05-18','08:45:00',2.75),('16273','2013-05-18','08:50:00',2.85),('16273','2013-05-18','08:55:00',2.76),('16273','2013-05-18','09:00:00',2.82),('16273','2013-05-18','09:05:00',2.98),('16273','2013-05-18','09:10:00',3.01),('16273','2013-05-18','09:15:00',3.06),('16273','2013-05-18','09:20:00',3.11),('16273','2013-05-18','09:25:00',3.16),('16273','2013-05-18','09:30:00',3.22),('16273','2013-05-18','09:35:00',3.26),('16273','2013-05-18','09:40:00',3.3),('16273','2013-05-18','09:45:00',3.36),('16273','2013-05-18','09:50:00',3.41),('16273','2013-05-18','09:55:00',3.45),('16273','2013-05-18','10:00:00',3.48),('16273','2013-05-18','10:05:00',3.54),('16273','2013-05-18','10:10:00',3.57),('16273','2013-05-18','10:15:00',3.6),('16273','2013-05-18','10:20:00',3.63),('16273','2013-05-18','10:25:00',3.67),('16273','2013-05-18','10:30:00',3.7),('16273','2013-05-18','10:35:00',3.72),('16273','2013-05-18','10:40:00',3.74),('16273','2013-05-18','10:45:00',3.78),('16273','2013-05-18','10:50:00',3.85),('16273','2013-05-18','10:55:00',3.95),('16273','2013-05-18','11:00:00',4.1),('16273','2013-05-18','11:05:00',3.12),('16273','2013-05-18','11:10:00',3.69),('16273','2013-05-18','11:15:00',3.73),('16273','2013-05-18','11:20:00',3.8),('16273','2013-05-18','11:25:00',3.36),('16273','2013-05-18','11:30:00',4.04),('16273','2013-05-18','11:35:00',3.9),('16273','2013-05-18','11:40:00',3.97),('16273','2013-05-18','11:45:00',3.97),('16273','2013-05-18','11:50:00',4),('16273','2013-05-18','11:55:00',3.97),('16273','2013-05-18','12:00:00',3.95),('16273','2013-05-18','12:05:00',3.92),('16273','2013-05-18','12:10:00',3.91),('16273','2013-05-18','12:15:00',3.94),('16273','2013-05-18','12:20:00',3.99),('16273','2013-05-18','12:25:00',3.55),('16273','2013-05-18','12:30:00',3.97),('16273','2013-05-18','12:35:00',3.98),('16273','2013-05-18','12:40:00',3.96),('16273','2013-05-18','12:45:00',2.92),('16273','2013-05-18','12:50:00',3.86),('16273','2013-05-18','12:55:00',3.93),('16273','2013-05-18','13:00:00',3.9),('16273','2013-05-18','13:05:00',3.88),('16273','2013-05-18','13:10:00',3.87),('16273','2013-05-18','13:15:00',3.85),('16273','2013-05-18','13:20:00',3.83),('16273','2013-05-18','13:25:00',3.84),('16273','2013-05-18','13:30:00',3.86),('16273','2013-05-18','13:35:00',3.83),('16273','2013-05-18','13:40:00',3.55),('16273','2013-05-18','13:45:00',3.84),('16273','2013-05-18','13:50:00',3.7),('16273','2013-05-18','13:55:00',3.96),('16273','2013-05-18','14:00:00',2.53),('16273','2013-05-18','14:05:00',2.59),('16273','2013-05-18','14:10:00',2.78),('16273','2013-05-18','14:15:00',3.63),('16273','2013-05-18','14:20:00',3.53),('16273','2013-05-18','14:25:00',3.62),('16273','2013-05-18','14:30:00',3.14),('16273','2013-05-18','14:35:00',3.58),('16273','2013-05-18','14:40:00',3.43),('16273','2013-05-18','14:45:00',3.24),('16273','2013-05-18','14:50:00',3.44),('16273','2013-05-18','14:55:00',3.27),('16273','2013-05-18','15:00:00',3.11),('16273','2013-05-18','15:05:00',3.11),('16273','2013-05-18','15:10:00',3.08),('16273','2013-05-18','15:15:00',3),('16273','2013-05-18','15:20:00',2.96),('16273','2013-05-18','15:25:00',2.91),('16273','2013-05-18','15:30:00',2.83),('16273','2013-05-18','15:35:00',2.84),('16273','2013-05-18','15:40:00',2.77),('16273','2013-05-18','15:45:00',2.7),('16273','2013-05-18','15:50:00',2.65),('16273','2013-05-18','15:55:00',2.59),('16273','2013-05-18','16:00:00',2.52),('16273','2013-05-18','16:05:00',2.46),('16273','2013-05-18','16:10:00',2.39),('16273','2013-05-18','16:15:00',2.31),('16273','2013-05-18','16:20:00',2.25),('16273','2013-05-18','16:25:00',2.18),('16273','2013-05-18','16:30:00',2.13),('16273','2013-05-18','16:35:00',2.06),('16273','2013-05-18','16:40:00',1.98),('16273','2013-05-18','16:45:00',1.9),('16273','2013-05-18','16:50:00',1.83),('16273','2013-05-18','16:55:00',1.76),('16273','2013-05-18','17:00:00',1.69),('16273','2013-05-18','17:05:00',1.63),('16273','2013-05-18','17:10:00',1.57),('16273','2013-05-18','17:15:00',1.49),('16273','2013-05-18','17:20:00',1.43),('16273','2013-05-18','17:25:00',1.37),('16273','2013-05-18','17:30:00',1.3),('16273','2013-05-18','17:35:00',1.24),('16273','2013-05-18','17:40:00',1.18),('16273','2013-05-18','17:45:00',1.12),('16273','2013-05-18','17:50:00',1.05),('16273','2013-05-17','07:25:00',1.15),('16273','2013-05-17','07:30:00',1.18),('16273','2013-05-17','07:35:00',1.43),('16273','2013-05-17','07:40:00',1.69),('16273','2013-05-17','07:45:00',1.57),('16273','2013-05-17','07:50:00',1.06),('16273','2013-05-17','08:00:00',1.18),('16273','2013-05-17','08:05:00',1.62),('16273','2013-05-17','08:10:00',2.16),('16273','2013-05-17','08:15:00',2.24),('16273','2013-05-17','08:20:00',1.54),('16273','2013-05-17','10:20:00',1.12),('16273','2013-05-17','10:25:00',1.27),('16273','2013-05-17','10:30:00',1.31),('16273','2013-05-17','10:35:00',1.27),('16273','2013-05-17','10:40:00',1.55),('16273','2013-05-17','10:45:00',3.35),('16273','2013-05-17','10:50:00',3.68),('16273','2013-05-17','10:55:00',2.91),('16273','2013-05-17','11:00:00',1.94),('16273','2013-05-17','11:05:00',1.69),('16273','2013-05-17','11:10:00',3.07),('16273','2013-05-17','11:15:00',3.2),('16273','2013-05-17','11:20:00',2.05),('16273','2013-05-17','11:25:00',2.13),('16273','2013-05-17','11:30:00',2.26),('16273','2013-05-17','11:35:00',2.14),('16273','2013-05-17','11:40:00',3.38),('16273','2013-05-17','11:45:00',4.31),('16273','2013-05-17','11:50:00',4.61),('16273','2013-05-17','11:55:00',3.85),('16273','2013-05-17','12:00:00',3.84),('16273','2013-05-17','12:05:00',4.25),('16273','2013-05-17','12:10:00',3.93),('16273','2013-05-17','12:15:00',3.93),('16273','2013-05-17','12:20:00',4.72),('16273','2013-05-17','12:25:00',4.36),('16273','2013-05-17','12:30:00',4.6),('16273','2013-05-17','12:35:00',3.1),('16273','2013-05-17','12:40:00',3.98),('16273','2013-05-17','12:45:00',3.65),('16273','2013-05-17','12:50:00',4.39),('16273','2013-05-17','12:55:00',1.82),('16273','2013-05-17','13:00:00',1.1),('16273','2013-05-17','13:05:00',1.03),('16273','2013-05-17','13:15:00',1.02),('16273','2013-05-17','13:20:00',1.21),('16273','2013-05-17','13:25:00',2.27),('16273','2013-05-17','13:30:00',4.27),('16273','2013-05-17','13:35:00',2.43),('16273','2013-05-17','13:40:00',1.95),('16273','2013-05-17','13:45:00',2.49),('16273','2013-05-17','13:50:00',3.27),('16273','2013-05-17','13:55:00',3.45),('16273','2013-05-17','14:00:00',3.7),('16273','2013-05-17','14:05:00',3.76),('16273','2013-05-17','14:10:00',3.57),('16273','2013-05-17','14:15:00',3.99),('16273','2013-05-17','14:20:00',3.36),('16273','2013-05-17','14:25:00',3.22),('16273','2013-05-17','14:30:00',3.6),('16273','2013-05-17','14:35:00',4.06),('16273','2013-05-17','14:40:00',3.07),('16273','2013-05-17','14:45:00',2.67),('16273','2013-05-17','14:50:00',2.78),('16273','2013-05-17','14:55:00',3.61),('16273','2013-05-17','15:00:00',3.21),('16273','2013-05-17','15:05:00',3.6),('16273','2013-05-17','15:10:00',3.53),('16273','2013-05-17','15:15:00',3.55),('16273','2013-05-17','15:20:00',3.49),('16273','2013-05-17','15:25:00',3.38),('16273','2013-05-17','15:30:00',2.89),('16273','2013-05-17','15:35:00',3.33),('16273','2013-05-17','15:40:00',2.66),('16273','2013-05-17','15:45:00',2.12),('16273','2013-05-17','15:50:00',3.02),('16273','2013-05-17','15:55:00',2.9),('16273','2013-05-17','16:00:00',2.87),('16273','2013-05-17','16:05:00',2.78),('16273','2013-05-17','16:10:00',2.72),('16273','2013-05-17','16:15:00',2.67),('16273','2013-05-17','16:20:00',2.6),('16273','2013-05-17','16:25:00',2.34),('16273','2013-05-17','16:30:00',2.56),('16273','2013-05-17','16:35:00',2.44),('16273','2013-05-17','16:40:00',2.36),('16273','2013-05-17','16:45:00',2.32),('16273','2013-05-17','16:50:00',2.33),('16273','2013-05-17','16:55:00',2.32),('16273','2013-05-17','17:00:00',2.3),('16273','2013-05-17','17:05:00',2.25),('16273','2013-05-17','17:10:00',2.05),('16273','2013-05-17','17:15:00',1.68),('16273','2013-05-17','17:20:00',1.61),('16273','2013-05-17','17:25:00',1.54),('16273','2013-05-17','17:30:00',1.5),('16273','2013-05-17','17:35:00',1.48),('16273','2013-05-17','17:40:00',1.33),('16273','2013-05-17','17:45:00',1.18),('16273','2013-05-17','17:50:00',1.08),('16273','2013-05-17','17:55:00',1.02),('16273','2013-05-16','09:20:00',1.38),('16273','2013-05-16','09:25:00',1.76),('16273','2013-05-16','09:30:00',1.63),('16273','2013-05-16','09:35:00',1.91),('16273','2013-05-16','09:40:00',2.41),('16273','2013-05-16','09:45:00',3.49),('16273','2013-05-16','09:50:00',2.1),('16273','2013-05-16','09:55:00',1.2),('16273','2013-05-16','10:00:00',2.95),('16273','2013-05-16','10:05:00',1.14),('16273','2013-05-16','10:10:00',1.52),('16273','2013-05-16','10:15:00',1.69),('16273','2013-05-16','10:20:00',2.5),('16273','2013-05-16','10:25:00',1.38),('16273','2013-05-16','10:30:00',1.3),('16273','2013-05-16','10:35:00',1.58),('16273','2013-05-16','10:40:00',2.15),('16273','2013-05-16','10:45:00',3.59),('16273','2013-05-16','10:50:00',2.84),('16273','2013-05-16','10:55:00',2.46),('16273','2013-05-16','11:00:00',4.23),('16273','2013-05-16','11:05:00',3.67),('16273','2013-05-16','11:10:00',4.18),('16273','2013-05-16','11:15:00',4.2),('16273','2013-05-16','11:20:00',3.44),('16273','2013-05-16','11:25:00',2.66),('16273','2013-05-16','11:30:00',2.55),('16273','2013-05-16','11:35:00',2.83),('16273','2013-05-16','11:40:00',3.26),('16273','2013-05-16','11:45:00',2.7),('16273','2013-05-16','11:50:00',3.27),('16273','2013-05-16','11:55:00',2.99),('16273','2013-05-16','12:00:00',1.95),('16273','2013-05-16','12:05:00',2.01),('16273','2013-05-16','12:10:00',1.65),('16273','2013-05-16','12:15:00',1.63),('16273','2013-05-16','12:20:00',1.7),('16273','2013-05-16','12:25:00',1.74),('16273','2013-05-16','12:30:00',2.34),('16273','2013-05-16','12:35:00',3.89),('16273','2013-05-16','12:40:00',3.27),('16273','2013-05-16','12:45:00',4.12),('16273','2013-05-16','12:50:00',3.96),('16273','2013-05-16','12:55:00',3.52),('16273','2013-05-16','13:00:00',3.86),('16273','2013-05-16','13:05:00',3.83),('16273','2013-05-16','13:10:00',3.76),('16273','2013-05-16','13:15:00',3.71),('16273','2013-05-16','13:20:00',3.73),('16273','2013-05-16','13:25:00',3.74),('16273','2013-05-16','13:30:00',3.71),('16273','2013-05-16','13:35:00',3.7),('16273','2013-05-16','13:40:00',3.69),('16273','2013-05-16','13:45:00',3.61),('16273','2013-05-16','13:50:00',3.59),('16273','2013-05-16','13:55:00',3.55),('16273','2013-05-16','14:00:00',3.54),('16273','2013-05-16','14:05:00',3.47),('16273','2013-05-16','14:10:00',3.49),('16273','2013-05-16','14:15:00',3.44),('16273','2013-05-16','14:20:00',3.38),('16273','2013-05-16','14:25:00',3.39),('16273','2013-05-16','14:30:00',3.28),('16273','2013-05-16','14:35:00',3.26),('16273','2013-05-16','14:40:00',3.24),('16273','2013-05-16','14:45:00',3.2),('16273','2013-05-16','14:50:00',3.16),('16273','2013-05-16','14:55:00',2.95),('16273','2013-05-16','15:00:00',3.05),('16273','2013-05-16','15:05:00',3.07),('16273','2013-05-16','15:10:00',3.08),('16273','2013-05-16','15:15:00',2.95),('16273','2013-05-16','15:20:00',2.93),('16273','2013-05-16','15:25:00',2.81),('16273','2013-05-16','15:30:00',2.74),('16273','2013-05-16','15:35:00',2.73),('16273','2013-05-16','15:40:00',2.69),('16273','2013-05-16','15:45:00',2.65),('16273','2013-05-16','15:50:00',2.6),('16273','2013-05-16','15:55:00',2.51),('16273','2013-05-16','16:00:00',2.42),('16273','2013-05-16','16:05:00',2.34),('16273','2013-05-16','16:10:00',2.34),('16273','2013-05-16','16:15:00',2.1),('16273','2013-05-16','16:20:00',2.14),('16273','2013-05-16','16:25:00',2.22),('16273','2013-05-16','16:30:00',2.06),('16273','2013-05-16','16:35:00',2.14),('16273','2013-05-16','16:40:00',2.12),('16273','2013-05-16','16:45:00',1.94),('16273','2013-05-16','16:50:00',1.69),('16273','2013-05-16','16:55:00',1.56),('16273','2013-05-16','17:00:00',1.12),('16273','2013-05-16','17:05:00',1.47),('16273','2013-05-16','17:10:00',1.14),('16273','2013-05-16','17:15:00',1.27),('16273','2013-05-16','17:20:00',1.41),('16273','2013-05-16','17:25:00',1.34),('16273','2013-05-16','17:30:00',1.35),('16273','2013-05-15','07:15:00',1.14),('16273','2013-05-15','07:20:00',1.25),('16273','2013-05-15','07:25:00',1.36),('16273','2013-05-15','07:30:00',1.46),('16273','2013-05-15','07:35:00',1.49),('16273','2013-05-15','07:40:00',1.61),('16273','2013-05-15','07:45:00',1.75),('16273','2013-05-15','07:50:00',1.73),('16273','2013-05-15','07:55:00',1.67),('16273','2013-05-15','08:00:00',1.58),('16273','2013-05-15','08:05:00',1.88),('16273','2013-05-15','08:10:00',2.08),('16273','2013-05-15','08:15:00',2.14),('16273','2013-05-15','08:20:00',2.2),('16273','2013-05-15','08:25:00',2.16),('16273','2013-05-15','08:30:00',2.29),('16273','2013-05-15','08:35:00',2.42),('16273','2013-05-15','08:40:00',2.5),('16273','2013-05-15','08:45:00',2.61),('16273','2013-05-15','08:50:00',2.69),('16273','2013-05-15','08:55:00',2.6),('16273','2013-05-15','09:00:00',2.72),('16273','2013-05-15','09:05:00',2.69),('16273','2013-05-15','09:10:00',2.77),('16273','2013-05-15','09:15:00',2.79),('16273','2013-05-15','09:20:00',2.84),('16273','2013-05-15','09:25:00',3),('16273','2013-05-15','09:30:00',3.14),('16273','2013-05-15','09:35:00',3.12),('16273','2013-05-15','09:40:00',3.13),('16273','2013-05-15','09:45:00',3.21),('16273','2013-05-15','09:50:00',3.25),('16273','2013-05-15','09:55:00',3.34),('16273','2013-05-15','10:00:00',3.39),('16273','2013-05-15','10:05:00',3.42),('16273','2013-05-15','10:10:00',3.33),('16273','2013-05-15','10:15:00',3.51),('16273','2013-05-15','10:20:00',3.6),('16273','2013-05-15','10:25:00',3.51),('16273','2013-05-15','10:30:00',3.56),('16273','2013-05-15','10:35:00',3.59),('16273','2013-05-15','10:40:00',3.66),('16273','2013-05-15','10:45:00',3.67),('16273','2013-05-15','10:50:00',3.76),('16273','2013-05-15','10:55:00',3.75),('16273','2013-05-15','11:00:00',3.73),('16273','2013-05-15','11:05:00',3.7),('16273','2013-05-15','11:10:00',3.87),('16273','2013-05-15','11:15:00',3.78),('16273','2013-05-15','11:20:00',3.79),('16273','2013-05-15','11:25:00',4.04),('16273','2013-05-15','11:30:00',3.93),('16273','2013-05-15','11:35:00',3.87),('16273','2013-05-15','11:40:00',3.97),('16273','2013-05-15','11:45:00',2.93),('16273','2013-05-15','11:50:00',1.96),('16273','2013-05-15','11:55:00',2.43),('16273','2013-05-15','12:00:00',3.12),('16273','2013-05-15','12:05:00',4.71),('16273','2013-05-15','12:10:00',4.07),('16273','2013-05-15','12:15:00',4.31),('16273','2013-05-15','12:20:00',3.78),('16273','2013-05-15','12:25:00',3.18),('16273','2013-05-15','12:30:00',3.18),('16273','2013-05-15','12:35:00',3.14),('16273','2013-05-15','12:40:00',2.44),('16273','2013-05-15','12:45:00',2.37),('16273','2013-05-15','12:50:00',2.3),('16273','2013-05-15','12:55:00',2.38),('16273','2013-05-15','13:00:00',2.45),('16273','2013-05-15','13:05:00',2.49),('16273','2013-05-15','13:10:00',2.34),('16273','2013-05-15','13:15:00',2.33),('16273','2013-05-15','13:20:00',2.41),('16273','2013-05-15','13:25:00',2.39),('16273','2013-05-15','13:30:00',2.59),('16273','2013-05-15','13:35:00',2.37),('16273','2013-05-15','13:40:00',2.24),('16273','2013-05-15','13:45:00',2.3),('16273','2013-05-15','13:50:00',2.24),('16273','2013-05-15','13:55:00',1.84),('16273','2013-05-15','14:00:00',1.85),('16273','2013-05-15','14:05:00',2.1),('16273','2013-05-15','14:10:00',2.23),('16273','2013-05-15','14:15:00',2.05),('16273','2013-05-15','14:20:00',1.93),('16273','2013-05-15','14:25:00',1.67),('16273','2013-05-15','14:30:00',1.44),('16273','2013-05-15','14:35:00',1.34),('16273','2013-05-15','14:40:00',1.28),('16273','2013-05-15','14:45:00',1.28),('16273','2013-05-15','14:50:00',1.27),('16273','2013-05-15','14:55:00',1.31),('16273','2013-05-15','15:00:00',1.22),('16273','2013-05-15','15:35:00',1.05),('16273','2013-05-15','15:40:00',1.36),('16273','2013-05-15','15:45:00',1.84),('16273','2013-05-15','15:50:00',2.03),('16273','2013-05-15','15:55:00',1.88),('16273','2013-05-15','16:00:00',1.92),('16273','2013-05-15','16:05:00',1.75),('16273','2013-05-15','16:10:00',1.56),('16273','2013-05-15','16:15:00',1.43),('16273','2013-05-15','16:20:00',1.39),('16273','2013-05-15','16:25:00',1.24),('16273','2013-05-15','16:30:00',1.19),('16273','2013-05-15','16:35:00',1.24),('16273','2013-05-15','16:40:00',1.21),('16273','2013-05-15','16:45:00',1.15),('16273','2013-05-15','16:50:00',1.16),('16273','2013-05-15','16:55:00',1.28),('16273','2013-05-15','17:00:00',1.45),('16273','2013-05-15','17:05:00',1.47),('16273','2013-05-15','17:10:00',1.46),('16273','2013-05-15','17:15:00',1.58),('16273','2013-05-15','17:20:00',1.28),('16273','2013-05-15','17:25:00',1.29),('16273','2013-05-15','17:30:00',1.06),('16273','2013-05-14','07:05:00',1.02),('16273','2013-05-14','07:15:00',1.2),('16273','2013-05-14','07:20:00',1.3),('16273','2013-05-14','07:25:00',1.4),('16273','2013-05-14','07:30:00',1.49),('16273','2013-05-14','07:35:00',1.57),('16273','2013-05-14','07:40:00',1.66),('16273','2013-05-14','07:45:00',1.74),('16273','2013-05-14','07:50:00',1.84),('16273','2013-05-14','07:55:00',1.95),('16273','2013-05-14','08:00:00',2.03),('16273','2013-05-14','08:05:00',2.12),('16273','2013-05-14','08:10:00',2.21),('16273','2013-05-14','08:15:00',2.28),('16273','2013-05-14','08:20:00',2.37),('16273','2013-05-14','08:25:00',2.46),('16273','2013-05-14','08:30:00',2.53),('16273','2013-05-14','08:35:00',2.6),('16273','2013-05-14','08:40:00',2.67),('16273','2013-05-14','08:45:00',2.73),('16273','2013-05-14','08:50:00',2.81),('16273','2013-05-14','08:55:00',2.87),('16273','2013-05-14','09:00:00',2.94),('16273','2013-05-14','09:05:00',3.01),('16273','2013-05-14','09:10:00',3.08),('16273','2013-05-14','09:15:00',3.13),('16273','2013-05-14','09:20:00',3.19),('16273','2013-05-14','09:25:00',3.24),('16273','2013-05-14','09:30:00',3.29),('16273','2013-05-14','09:35:00',3.34),('16273','2013-05-14','09:40:00',3.39),('16273','2013-05-14','09:45:00',3.44),('16273','2013-05-14','09:50:00',3.5),('16273','2013-05-14','09:55:00',3.54),('16273','2013-05-14','10:00:00',3.58),('16273','2013-05-14','10:05:00',3.59),('16273','2013-05-14','10:10:00',3.68),('16273','2013-05-14','10:15:00',3.71),('16273','2013-05-14','10:20:00',3.76),('16273','2013-05-14','10:25:00',3.8),('16273','2013-05-14','10:30:00',3.83),('16273','2013-05-14','10:35:00',3.87),('16273','2013-05-14','10:40:00',3.91),('16273','2013-05-14','10:45:00',3.89),('16273','2013-05-14','10:50:00',3.92),('16273','2013-05-14','10:55:00',3.96),('16273','2013-05-14','11:00:00',3.96),('16273','2013-05-14','11:05:00',3.98),('16273','2013-05-14','11:10:00',4),('16273','2013-05-14','11:15:00',4.01),('16273','2013-05-14','11:20:00',4),('16273','2013-05-14','11:25:00',4),('16273','2013-05-14','11:30:00',4.02),('16273','2013-05-14','11:35:00',4.03),('16273','2013-05-14','11:40:00',4.03),('16273','2013-05-14','11:45:00',4.04),('16273','2013-05-14','11:50:00',4.05),('16273','2013-05-14','11:55:00',4.06),('16273','2013-05-14','12:00:00',4.01),('16273','2013-05-14','12:05:00',4.05),('16273','2013-05-14','12:10:00',4.06),('16273','2013-05-14','12:15:00',4.08),('16273','2013-05-14','12:20:00',4.1),('16273','2013-05-14','12:25:00',4.08),('16273','2013-05-14','12:30:00',4.09),('16273','2013-05-14','12:35:00',4.1),('16273','2013-05-14','12:40:00',4.07),('16273','2013-05-14','12:45:00',4.06),('16273','2013-05-14','12:50:00',4.02),('16273','2013-05-14','12:55:00',4.03),('16273','2013-05-14','13:00:00',4.02),('16273','2013-05-14','13:05:00',4.01),('16273','2013-05-14','13:10:00',4),('16273','2013-05-14','13:15:00',3.96),('16273','2013-05-14','13:20:00',3.93),('16273','2013-05-14','13:25:00',3.92),('16273','2013-05-14','13:30:00',3.91),('16273','2013-05-14','13:35:00',3.91),('16273','2013-05-14','13:40:00',3.87),('16273','2013-05-14','13:45:00',3.81),('16273','2013-05-14','13:50:00',3.75),('16273','2013-05-14','13:55:00',3.78),('16273','2013-05-14','14:00:00',3.8),('16273','2013-05-14','14:05:00',3.79),('16273','2013-05-14','14:10:00',3.76),('16273','2013-05-14','14:15:00',3.74),('16273','2013-05-14','14:20:00',3.72),('16273','2013-05-14','14:25:00',3.71),('16273','2013-05-14','14:30:00',3.67),('16273','2013-05-14','14:35:00',3.63),('16273','2013-05-14','14:40:00',3.6),('16273','2013-05-14','14:45:00',3.57),('16273','2013-05-14','14:50:00',3.54),('16273','2013-05-14','14:55:00',3.49),('16273','2013-05-14','15:00:00',3.46),('16273','2013-05-14','15:05:00',3.34),('16273','2013-05-14','15:10:00',3.36),('16273','2013-05-14','15:15:00',3.31),('16273','2013-05-14','15:20:00',3.25),('16273','2013-05-14','15:25:00',3.18),('16273','2013-05-14','15:30:00',3.13),('16273','2013-05-14','15:35:00',3.07),('16273','2013-05-14','15:40:00',3.01),('16273','2013-05-14','15:45:00',2.94),('16273','2013-05-14','15:50:00',2.88),('16273','2013-05-14','15:55:00',2.82),('16273','2013-05-14','16:00:00',2.76),('16273','2013-05-14','16:05:00',2.69),('16273','2013-05-14','16:10:00',2.63),('16273','2013-05-14','16:15:00',2.55),('16273','2013-05-14','16:20:00',2.46),('16273','2013-05-14','16:25:00',2.41),('16273','2013-05-14','16:30:00',2.33),('16273','2013-05-14','16:35:00',2.25),('16273','2013-05-14','16:40:00',2.16),('16273','2013-05-14','16:45:00',2.09),('16273','2013-05-14','16:50:00',2.01),('16273','2013-05-14','16:55:00',1.93),('16273','2013-05-14','17:00:00',1.84),('16273','2013-05-14','17:05:00',1.76),('16273','2013-05-14','17:10:00',1.68),('16273','2013-05-14','17:15:00',1.6),('16273','2013-05-14','17:20:00',1.52),('16273','2013-05-14','17:25:00',1.44),('16273','2013-05-14','17:30:00',1.35),('16273','2013-05-14','17:35:00',1.26),('16273','2013-05-14','17:40:00',1.19),('16273','2013-05-14','17:45:00',1.12),('16273','2013-05-14','17:50:00',1.04),('16273','2013-05-13','07:25:00',1.34),('16273','2013-05-13','07:30:00',1.74),('16273','2013-05-13','07:35:00',1.85),('16273','2013-05-13','07:40:00',1.77),('16273','2013-05-13','07:45:00',1.42),('16273','2013-05-13','07:55:00',1.32),('16273','2013-05-13','08:00:00',1.86),('16273','2013-05-13','08:05:00',1.94),('16273','2013-05-13','08:10:00',2.01),('16273','2013-05-13','08:15:00',2.06),('16273','2013-05-13','08:20:00',2.18),('16273','2013-05-13','08:25:00',2.25),('16273','2013-05-13','08:30:00',2.35),('16273','2013-05-13','08:35:00',2.43),('16273','2013-05-13','08:40:00',2.51),('16273','2013-05-13','08:45:00',2.6),('16273','2013-05-13','08:50:00',2.66),('16273','2013-05-13','08:55:00',2.72),('16273','2013-05-13','09:00:00',2.79),('16273','2013-05-13','09:05:00',2.82),('16273','2013-05-13','09:10:00',2.9),('16273','2013-05-13','09:15:00',2.97),('16273','2013-05-13','09:20:00',3.03),('16273','2013-05-13','09:25:00',3.17),('16273','2013-05-13','09:30:00',2.98),('16273','2013-05-13','09:35:00',3.38),('16273','2013-05-13','09:40:00',3.53),('16273','2013-05-13','09:45:00',3.74),('16273','2013-05-13','09:50:00',3.7),('16273','2013-05-13','09:55:00',1.51),('16273','2013-05-13','10:00:00',1.9),('16273','2013-05-13','10:05:00',1.9),('16273','2013-05-13','10:10:00',1.94),('16273','2013-05-13','10:15:00',2.84),('16273','2013-05-13','10:20:00',2.59),('16273','2013-05-13','10:25:00',3.55),('16273','2013-05-13','10:30:00',3.03),('16273','2013-05-13','10:35:00',4.1),('16273','2013-05-13','10:40:00',4.07),('16273','2013-05-13','10:45:00',4.09),('16273','2013-05-13','10:50:00',4.12),('16273','2013-05-13','10:55:00',4.23),('16273','2013-05-13','11:00:00',4.27),('16273','2013-05-13','11:05:00',4.19),('16273','2013-05-13','11:10:00',1.57),('16273','2013-05-13','11:15:00',2.44),('16273','2013-05-13','11:20:00',1.41),('16273','2013-05-13','11:25:00',1.32),('16273','2013-05-13','11:30:00',1.06),('16273','2013-05-13','11:35:00',1.5),('16273','2013-05-13','11:40:00',1.23),('16273','2013-05-13','11:45:00',4.87),('16273','2013-05-13','11:50:00',4.82),('16273','2013-05-13','11:55:00',2.69),('16273','2013-05-13','12:35:00',2.3),('16273','2013-05-13','12:40:00',4.69),('16273','2013-05-13','12:45:00',4.42),('16273','2013-05-13','12:50:00',4.31),('16273','2013-05-13','12:55:00',4.06),('16273','2013-05-13','13:00:00',3.81),('16273','2013-05-13','13:05:00',1.69),('16273','2013-05-13','13:10:00',1.74),('16273','2013-05-13','13:15:00',1.07),('16273','2013-05-13','13:20:00',1.09),('16273','2013-05-13','13:25:00',1.25),('16273','2013-05-13','13:30:00',1.27),('16273','2013-05-13','13:35:00',2.43),('16273','2013-05-13','13:40:00',4.43),('16273','2013-05-13','13:45:00',2.61),('16273','2013-05-13','13:50:00',1),('16273','2013-05-13','14:10:00',3.56),('16273','2013-05-13','14:15:00',3.03),('16273','2013-05-13','14:45:00',1.65),('16273','2013-05-13','14:50:00',1.87),('16273','2013-05-13','14:55:00',1.3),('16273','2013-05-13','15:00:00',1.93),('16273','2013-05-13','15:20:00',1.31),('16273','2013-05-13','15:25:00',1.14),('16273','2013-05-13','15:30:00',2.81),('16273','2013-05-13','15:35:00',3.26),('16273','2013-05-13','15:40:00',2.04),('16273','2013-05-13','15:45:00',2.52),('16273','2013-05-13','15:50:00',1.95),('16273','2013-05-13','16:05:00',1.2),('16273','2013-05-13','16:10:00',1.42),('16273','2013-05-13','16:15:00',1.38),('16273','2013-05-13','16:20:00',1.13),('16273','2013-05-13','16:25:00',1.04),('16273','2013-05-13','17:00:00',1.79),('16273','2013-05-13','17:05:00',1.47),('16273','2013-05-13','17:10:00',2.03),('16273','2013-05-13','17:15:00',2.11),('16273','2013-05-13','17:20:00',1.76),('16273','2013-05-13','17:25:00',1.56),('16273','2013-05-13','17:30:00',1.45),('16273','2013-05-13','17:35:00',1.34),('16273','2013-05-13','17:40:00',1.23),('16273','2013-05-13','17:45:00',1.18),('16273','2013-05-13','17:50:00',1.14),('16273','2013-05-13','17:55:00',1.17),('16273','2013-05-13','18:00:00',1.09),('16273','2013-05-13','18:30:00',1.04),('16273','2013-05-12','07:25:00',1.23),('16273','2013-05-12','07:30:00',1.35),('16273','2013-05-12','07:35:00',1.22),('16273','2013-05-12','07:40:00',1.46),('16273','2013-05-12','07:45:00',1.8),('16273','2013-05-12','07:50:00',1.39),('16273','2013-05-12','07:55:00',1.47),('16273','2013-05-12','08:00:00',1.72),('16273','2013-05-12','08:05:00',1.94),('16273','2013-05-12','08:10:00',1.04),('16273','2013-05-12','08:35:00',1.04),('16273','2013-05-12','08:40:00',1.75),('16273','2013-05-12','08:45:00',1.7),('16273','2013-05-12','08:50:00',2.22),('16273','2013-05-12','08:55:00',3.18),('16273','2013-05-12','09:00:00',3.17),('16273','2013-05-12','09:05:00',2.78),('16273','2013-05-12','09:10:00',3.31),('16273','2013-05-12','09:15:00',3.3),('16273','2013-05-12','09:20:00',2.5),('16273','2013-05-12','09:25:00',1.16),('16273','2013-05-12','09:35:00',1.92),('16273','2013-05-12','09:40:00',3.74),('16273','2013-05-12','09:45:00',2.9),('16273','2013-05-12','09:50:00',1.56),('16273','2013-05-12','09:55:00',3.06),('16273','2013-05-12','10:00:00',2.96),('16273','2013-05-12','10:05:00',1.45),('16273','2013-05-12','10:10:00',2.87),('16273','2013-05-12','10:15:00',1.4),('16273','2013-05-12','10:20:00',1.98),('16273','2013-05-12','10:25:00',4),('16273','2013-05-12','10:30:00',4.26),('16273','2013-05-12','10:35:00',3.95),('16273','2013-05-12','10:40:00',4.18),('16273','2013-05-12','10:45:00',1.51),('16273','2013-05-12','10:50:00',3.54),('16273','2013-05-12','10:55:00',4.42),('16273','2013-05-12','11:00:00',3.71),('16273','2013-05-12','11:05:00',4.13),('16273','2013-05-12','11:10:00',4.17),('16273','2013-05-12','11:15:00',3.47),('16273','2013-05-12','11:20:00',3.55),('16273','2013-05-12','11:25:00',3.88),('16273','2013-05-12','11:30:00',1.52),('16273','2013-05-12','11:35:00',1.43),('16273','2013-05-12','11:40:00',3.22),('16273','2013-05-12','11:45:00',2.38),('16273','2013-05-12','11:50:00',4.56),('16273','2013-05-12','11:55:00',4.4),('16273','2013-05-12','12:00:00',4.42),('16273','2013-05-12','12:05:00',4.36),('16273','2013-05-12','12:10:00',4.38),('16273','2013-05-12','12:15:00',4.41),('16273','2013-05-12','12:20:00',4.48),('16273','2013-05-12','12:25:00',4.54),('16273','2013-05-12','12:30:00',1.58),('16273','2013-05-12','12:35:00',1.98),('16273','2013-05-12','12:40:00',2.56),('16273','2013-05-12','12:45:00',1.74),('16273','2013-05-12','12:50:00',3.29),('16273','2013-05-12','12:55:00',4.38),('16273','2013-05-12','13:00:00',3.73),('16273','2013-05-12','13:05:00',4.2),('16273','2013-05-12','13:10:00',4.2),('16273','2013-05-12','13:15:00',4.18),('16273','2013-05-12','13:20:00',4.17),('16273','2013-05-12','13:25:00',4.14),('16273','2013-05-12','13:30:00',4.16),('16273','2013-05-12','13:35:00',4),('16273','2013-05-12','13:40:00',4.21),('16273','2013-05-12','13:45:00',4.26),('16273','2013-05-12','13:50:00',3.59),('16273','2013-05-12','13:55:00',3.59),('16273','2013-05-12','14:00:00',4),('16273','2013-05-12','14:05:00',3.95),('16273','2013-05-12','14:10:00',2.68),('16273','2013-05-12','14:15:00',2.52),('16273','2013-05-12','14:20:00',3.62),('16273','2013-05-12','14:25:00',3.75),('16273','2013-05-12','14:30:00',2.96),('16273','2013-05-12','14:35:00',3.78),('16273','2013-05-12','14:40:00',2.15),('16273','2013-05-12','14:45:00',2.59),('16273','2013-05-12','14:50:00',3.39),('16273','2013-05-12','14:55:00',3.03),('16273','2013-05-12','15:00:00',2.84),('16273','2013-05-12','15:05:00',3.13),('16273','2013-05-12','15:10:00',3.65),('16273','2013-05-12','15:15:00',3.47),('16273','2013-05-12','15:20:00',3.32),('16273','2013-05-12','15:25:00',3.19),('16273','2013-05-12','15:30:00',3.14),('16273','2013-05-12','15:35:00',3.06),('16273','2013-05-12','15:40:00',3),('16273','2013-05-12','15:45:00',2.92),('16273','2013-05-12','15:50:00',2.88),('16273','2013-05-12','15:55:00',2.78),('16273','2013-05-12','16:00:00',2.72),('16273','2013-05-12','16:05:00',2.64),('16273','2013-05-12','16:10:00',2.57),('16273','2013-05-12','16:15:00',1.98),('16273','2013-05-12','16:20:00',2.1),('16273','2013-05-12','16:25:00',2.5),('16273','2013-05-12','16:30:00',2.13),('16273','2013-05-12','16:35:00',1.8),('16273','2013-05-12','16:40:00',2.43),('16273','2013-05-12','16:45:00',2.53),('16273','2013-05-12','16:50:00',1.47),('16273','2013-05-12','16:55:00',2.23),('16273','2013-05-12','17:00:00',1.42),('16273','2013-05-12','17:05:00',1.46),('16273','2013-05-12','17:10:00',2.25),('16273','2013-05-12','17:15:00',1.67),('16273','2013-05-12','17:20:00',1.85),('16273','2013-05-12','17:25:00',1.82),('16273','2013-05-12','17:30:00',1.52),('16273','2013-05-12','17:35:00',1.51),('16273','2013-05-12','17:40:00',1.75),('16273','2013-05-12','17:45:00',1.72),('16273','2013-05-12','17:50:00',1.51),('16273','2013-05-12','17:55:00',1.15),('16273','2013-05-12','18:00:00',1.31),('16273','2013-05-12','18:05:00',1.45),('16273','2013-05-12','18:10:00',1.2),('16273','2013-05-12','18:15:00',1.08),('16273','2013-05-12','18:20:00',1.23),('16273','2013-05-12','18:25:00',1.23),('16273','2013-05-12','18:30:00',1.04),('16273','2013-05-12','18:35:00',1.02),('16273','2014-03-31','08:05:00',1.08),('16273','2014-03-31','08:10:00',1.2),('16273','2014-03-31','08:15:00',1.15),('16273','2014-03-31','08:20:00',1.43),('16273','2014-03-31','08:25:00',1.54),('16273','2014-03-31','08:30:00',1.63),('16273','2014-03-31','08:35:00',1.72),('16273','2014-03-31','08:40:00',1.8),('16273','2014-03-31','08:45:00',1.87),('16273','2014-03-31','08:50:00',1.97),('16273','2014-03-31','08:55:00',2.07),('16273','2014-03-31','09:00:00',2.17),('16273','2014-03-31','09:05:00',2.24),('16273','2014-03-31','09:10:00',2.31),('16273','2014-03-31','09:15:00',2.39),('16273','2014-03-31','09:20:00',2.46),('16273','2014-03-31','09:25:00',2.54),('16273','2014-03-31','09:30:00',2.59),('16273','2014-03-31','09:35:00',2.67),('16273','2014-03-31','09:40:00',2.73),('16273','2014-03-31','09:45:00',2.8),('16273','2014-03-31','09:50:00',2.83),('16273','2014-03-31','09:55:00',2.89),('16273','2014-03-31','10:00:00',2.92),('16273','2014-03-31','10:05:00',3),('16273','2014-03-31','10:10:00',3.03),('16273','2014-03-31','10:15:00',3.07),('16273','2014-03-31','10:20:00',3.13),('16273','2014-03-31','10:25:00',3.15),('16273','2014-03-31','10:30:00',3.18),('16273','2014-03-31','10:35:00',3.23),('16273','2014-03-31','10:40:00',3.28),('16273','2014-03-31','10:45:00',3.31),('16273','2014-03-31','10:50:00',3.35),('16273','2014-03-31','10:55:00',3.4),('16273','2014-03-31','11:00:00',3.41),('16273','2014-03-31','11:05:00',3.41),('16273','2014-03-31','11:10:00',3.46),('16273','2014-03-31','11:15:00',3.49),('16273','2014-03-31','11:20:00',3.49),('16273','2014-03-31','11:25:00',3.53),('16273','2014-03-31','11:30:00',3.54),('16273','2014-03-31','11:35:00',3.56),('16273','2014-03-31','11:40:00',3.56),('16273','2014-03-31','11:45:00',3.57),('16273','2014-03-31','11:50:00',3.59),('16273','2014-03-31','11:55:00',3.58),('16273','2014-03-31','12:00:00',3.56),('16273','2014-03-31','12:05:00',3.61),('16273','2014-03-31','12:10:00',3.58),('16273','2014-03-31','12:15:00',3.62),('16273','2014-03-31','12:20:00',3.67),('16273','2014-03-31','12:25:00',3.7),('16273','2014-03-31','12:30:00',3.7),('16273','2014-03-31','12:35:00',3.68),('16273','2014-03-31','12:40:00',3.68),('16273','2014-03-31','12:45:00',3.67),('16273','2014-03-31','12:50:00',3.69),('16273','2014-03-31','12:55:00',3.69),('16273','2014-03-31','13:00:00',3.7),('16273','2014-03-31','13:05:00',3.69),('16273','2014-03-31','13:10:00',3.69),('16273','2014-03-31','13:15:00',3.68),('16273','2014-03-31','13:20:00',3.66),('16273','2014-03-31','13:25:00',3.63),('16273','2014-03-31','13:30:00',3.63),('16273','2014-03-31','13:35:00',3.61),('16273','2014-03-31','13:40:00',3.61),('16273','2014-03-31','13:45:00',3.59),('16273','2014-03-31','13:50:00',3.57),('16273','2014-03-31','13:55:00',3.53),('16273','2014-03-31','14:00:00',3.5),('16273','2014-03-31','14:05:00',3.47),('16273','2014-03-31','14:10:00',3.46),('16273','2014-03-31','14:15:00',3.43),('16273','2014-03-31','14:20:00',3.39),('16273','2014-03-31','14:25:00',3.35),('16273','2014-03-31','14:30:00',3.31),('16273','2014-03-31','14:35:00',3.28),('16273','2014-03-31','14:40:00',3.23),('16273','2014-03-31','14:45:00',3.19),('16273','2014-03-31','14:50:00',3.12),('16273','2014-03-31','14:55:00',3.08),('16273','2014-03-31','15:00:00',3.03),('16273','2014-03-31','15:05:00',2.99),('16273','2014-03-31','15:10:00',2.95),('16273','2014-03-31','15:15:00',2.89),('16273','2014-03-31','15:20:00',2.83),('16273','2014-03-31','15:25:00',2.78),('16273','2014-03-31','15:30:00',2.72),('16273','2014-03-31','15:35:00',2.66),('16273','2014-03-31','15:40:00',2.6),('16273','2014-03-31','15:45:00',2.53),('16273','2014-03-31','15:50:00',2.47),('16273','2014-03-31','15:55:00',2.37),('16273','2014-03-31','16:00:00',2.29),('16273','2014-03-31','16:05:00',2.21),('16273','2014-03-31','16:10:00',2.15),('16273','2014-03-31','16:15:00',2.07),('16273','2014-03-31','16:20:00',2.01),('16273','2014-03-31','16:25:00',1.95),('16273','2014-03-31','16:30:00',1.88),('16273','2014-03-31','16:35:00',1.8),('16273','2014-03-31','16:40:00',1.71),('16273','2014-03-31','16:45:00',1.64),('16273','2014-03-31','16:50:00',1.55),('16273','2014-03-31','16:55:00',1.47),('16273','2014-03-31','17:00:00',1.4),('16273','2014-03-31','17:05:00',1.32),('16273','2014-03-31','17:10:00',1.25),('16273','2014-03-31','17:15:00',1.17),('16273','2014-03-31','17:20:00',1.1),('16273','2014-03-31','17:25:00',1.04),('16273','2013-05-11','07:20:00',1.13),('16273','2013-05-11','07:25:00',1.23),('16273','2013-05-11','07:30:00',1.34),('16273','2013-05-11','07:35:00',1.49),('16273','2013-05-11','07:40:00',1.74),('16273','2013-05-11','07:45:00',1.76),('16273','2013-05-11','07:50:00',1.27),('16273','2013-05-11','07:55:00',1.45),('16273','2013-05-11','08:00:00',1.59),('16273','2013-05-11','08:05:00',1.17),('16273','2013-05-11','08:10:00',1.05),('16273','2013-05-11','08:30:00',2.04),('16273','2013-05-11','08:35:00',1.99),('16273','2013-05-11','08:40:00',1.27),('16273','2013-05-11','08:45:00',1.15),('16273','2013-05-11','08:50:00',2.42),('16273','2013-05-11','08:55:00',3.29),('16273','2013-05-11','09:00:00',1.87),('16273','2013-05-11','09:05:00',3.01),('16273','2013-05-11','09:10:00',1.74),('16273','2013-05-11','09:15:00',2.02),('16273','2013-05-11','09:20:00',1.25),('16273','2013-05-11','09:25:00',1.11),('16273','2013-05-11','09:30:00',1.44),('16273','2013-05-11','09:35:00',3.81),('16273','2013-05-11','09:40:00',3.24),('16273','2013-05-11','09:45:00',3.2),('16273','2013-05-11','09:50:00',1.36),('16273','2013-05-11','10:00:00',1.66),('16273','2013-05-11','10:05:00',1.61),('16273','2013-05-11','10:10:00',3.8),('16273','2013-05-11','10:15:00',2.75),('16273','2013-05-11','10:30:00',2.34),('16273','2013-05-11','10:35:00',1.83),('16273','2013-05-11','10:40:00',1.4),('16273','2013-05-11','10:45:00',3.48),('16273','2013-05-11','10:50:00',2.21),('16273','2013-05-11','10:55:00',1.53),('16273','2013-05-11','11:00:00',3.37),('16273','2013-05-11','11:05:00',1.6),('16273','2013-05-11','11:10:00',1.2),('16273','2013-05-11','11:15:00',3.93),('16273','2013-05-11','11:20:00',4.35),('16273','2013-05-11','11:25:00',2.93),('16273','2013-05-11','11:30:00',4.23),('16273','2013-05-11','11:35:00',2.39),('16273','2013-05-11','11:40:00',1.33),('16273','2013-05-11','11:45:00',2.87),('16273','2013-05-11','11:50:00',3.31),('16273','2013-05-11','11:55:00',3.13),('16273','2013-05-11','12:00:00',3.59),('16273','2013-05-11','12:05:00',4.02),('16273','2013-05-11','12:10:00',3.6),('16273','2013-05-11','12:15:00',1.6),('16273','2013-05-11','12:20:00',3.5),('16273','2013-05-11','12:25:00',2.67),('16273','2013-05-11','12:30:00',3.06),('16273','2013-05-11','12:35:00',2.27),('16273','2013-05-11','12:40:00',1.8),('16273','2013-05-11','12:45:00',2.14),('16273','2013-05-11','12:50:00',2.1),('16273','2013-05-11','12:55:00',1.83),('16273','2013-05-11','13:00:00',2.66),('16273','2013-05-11','13:05:00',1.97),('16273','2013-05-11','13:10:00',2.61),('16273','2013-05-11','13:15:00',2.52),('16273','2013-05-11','13:20:00',2.52),('16273','2013-05-11','13:25:00',1.86),('16273','2013-05-11','13:30:00',2.49),('16273','2013-05-11','13:35:00',2.44),('16273','2013-05-11','13:40:00',2.93),('16273','2013-05-11','13:45:00',3.25),('16273','2013-05-11','13:50:00',3.5),('16273','2013-05-11','13:55:00',4.14),('16273','2013-05-11','14:00:00',3.19),('16273','2013-05-11','14:05:00',3.35),('16273','2013-05-11','14:10:00',3.2),('16273','2013-05-11','14:15:00',2.51),('16273','2013-05-11','14:20:00',1.93),('16273','2013-05-11','14:25:00',2.85),('16273','2013-05-11','14:30:00',2.43),('16273','2013-05-11','14:35:00',2.87),('16273','2013-05-11','14:40:00',3.41),('16273','2013-05-11','14:45:00',2.44),('16273','2013-05-11','14:50:00',4.21),('16273','2013-05-11','14:55:00',3.54),('16273','2013-05-11','15:00:00',2.82),('16273','2013-05-11','15:05:00',3.65),('16273','2013-05-11','15:10:00',2.06),('16273','2013-05-11','15:15:00',2.26),('16273','2013-05-11','15:20:00',1.8),('16273','2013-05-11','15:25:00',3.29),('16273','2013-05-11','15:30:00',2.14),('16273','2013-05-11','15:35:00',2.31),('16273','2013-05-11','15:40:00',2.87),('16273','2013-05-11','15:45:00',2.51),('16273','2013-05-11','15:50:00',2.47),('16273','2013-05-11','15:55:00',3.18),('16273','2013-05-11','16:00:00',2.95),('16273','2013-05-11','16:05:00',2.74),('16273','2013-05-11','16:10:00',2.5),('16273','2013-05-11','16:15:00',2.74),('16273','2013-05-11','16:20:00',2.01),('16273','2013-05-11','16:25:00',2.17),('16273','2013-05-11','16:30:00',2.18),('16273','2013-05-11','16:35:00',2.32),('16273','2013-05-11','16:40:00',2.26),('16273','2013-05-11','16:45:00',2.21),('16273','2013-05-11','16:50:00',2.13),('16273','2013-05-11','16:55:00',2.05),('16273','2013-05-11','17:00:00',2.2),('16273','2013-05-11','17:05:00',2.01),('16273','2013-05-11','17:10:00',1.85),('16273','2013-05-11','17:15:00',1.53),('16273','2013-05-11','17:20:00',1.9),('16273','2013-05-11','17:25:00',1.46),('16273','2013-05-11','17:30:00',1.39),('16273','2013-05-11','17:35:00',1.11),('16273','2013-05-11','17:45:00',1.11),('16273','2013-05-10','07:20:00',1.02),('16273','2013-05-10','07:35:00',1.03),('16273','2013-05-10','07:40:00',1.31),('16273','2013-05-10','07:45:00',1.65),('16273','2013-05-10','07:50:00',1.86),('16273','2013-05-10','07:55:00',2.18),('16273','2013-05-10','08:00:00',1.89),('16273','2013-05-10','08:05:00',1.28),('16273','2013-05-10','08:10:00',1.63),('16273','2013-05-10','08:15:00',1.58),('16273','2013-05-10','08:20:00',1.42),('16273','2013-05-10','08:25:00',1.66),('16273','2013-05-10','08:50:00',1.28),('16273','2013-05-10','08:55:00',2.8),('16273','2013-05-10','09:00:00',2.73),('16273','2013-05-10','09:05:00',2.7),('16273','2013-05-10','09:10:00',2.63),('16273','2013-05-10','09:15:00',1.28),('16273','2013-05-10','09:20:00',2.72),('16273','2013-05-10','09:25:00',2.49),('16273','2013-05-10','09:30:00',1.95),('16273','2013-05-10','09:35:00',2.77),('16273','2013-05-10','09:40:00',3.66),('16273','2013-05-10','09:45:00',3.28),('16273','2013-05-10','09:50:00',3),('16273','2013-05-10','09:55:00',3.75),('16273','2013-05-10','10:00:00',3.54),('16273','2013-05-10','10:05:00',3.23),('16273','2013-05-10','10:10:00',2.72),('16273','2013-05-10','10:15:00',3.51),('16273','2013-05-10','10:20:00',3.65),('16273','2013-05-10','10:25:00',3.67),('16273','2013-05-10','10:30:00',3.69),('16273','2013-05-10','10:35:00',3.76),('16273','2013-05-10','10:40:00',3.83),('16273','2013-05-10','10:45:00',3.8),('16273','2013-05-10','10:50:00',3.76),('16273','2013-05-10','10:55:00',3.17),('16273','2013-05-10','11:00:00',3.37),('16273','2013-05-10','11:05:00',3.75),('16273','2013-05-10','11:10:00',3.63),('16273','2013-05-10','11:15:00',3.11),('16273','2013-05-10','11:20:00',3.24),('16273','2013-05-10','11:25:00',4.31),('16273','2013-05-10','11:30:00',1.38),('16273','2013-05-10','11:35:00',4.32),('16273','2013-05-10','11:40:00',3.9),('16273','2013-05-10','11:45:00',4.15),('16273','2013-05-10','11:50:00',2.74),('16273','2013-05-10','11:55:00',3.2),('16273','2013-05-10','12:00:00',3.04),('16273','2013-05-10','12:05:00',3.21),('16273','2013-05-10','12:10:00',2.82),('16273','2013-05-10','12:15:00',2.75),('16273','2013-05-10','12:20:00',3.04),('16273','2013-05-10','12:25:00',4.41),('16273','2013-05-10','12:30:00',4.82),('16273','2013-05-10','12:35:00',4.41),('16273','2013-05-10','12:40:00',3.7),('16273','2013-05-10','12:45:00',4.13),('16273','2013-05-10','12:50:00',3.89),('16273','2013-05-10','12:55:00',3.5),('16273','2013-05-10','13:00:00',4.57),('16273','2013-05-10','13:05:00',4.57),('16273','2013-05-10','13:10:00',2.62),('16273','2013-05-10','13:15:00',3.63),('16273','2013-05-10','13:20:00',4.53),('16273','2013-05-10','13:25:00',4.75),('16273','2013-05-10','13:30:00',4.18),('16273','2013-05-10','13:35:00',2.66),('16273','2013-05-10','13:40:00',2.05),('16273','2013-05-10','13:45:00',1.96),('16273','2013-05-10','13:50:00',2.02),('16273','2013-05-10','13:55:00',2.39),('16273','2013-05-10','14:00:00',2.75),('16273','2013-05-10','14:05:00',2.9),('16273','2013-05-10','14:10:00',2.74),('16273','2013-05-10','14:15:00',2.35),('16273','2013-05-10','14:20:00',2.2),('16273','2013-05-10','14:25:00',2.34),('16273','2013-05-10','14:30:00',1.94),('16273','2013-05-10','14:35:00',1.57),('16273','2013-05-10','14:40:00',1.33),('16273','2013-05-10','14:45:00',1.25),('16273','2013-05-10','14:50:00',1.46),('16273','2013-05-10','14:55:00',2.07),('16273','2013-05-10','15:00:00',3.12),('16273','2013-05-10','15:05:00',2.47),('16273','2013-05-10','15:10:00',2.07),('16273','2013-05-10','15:15:00',1.97),('16273','2013-05-10','15:20:00',2.08),('16273','2013-05-10','15:25:00',2.36),('16273','2013-05-10','15:30:00',2.38),('16273','2013-05-10','15:35:00',2.09),('16273','2013-05-10','15:40:00',1.86),('16273','2013-05-10','15:45:00',1.78),('16273','2013-05-10','15:50:00',1.73),('16273','2013-05-10','15:55:00',1.62),('16273','2013-05-10','16:00:00',1.55),('16273','2013-05-10','16:05:00',1.6),('16273','2013-05-10','16:10:00',1.6),('16273','2013-05-10','16:15:00',1.98),('16273','2013-05-10','16:20:00',1.74),('16273','2013-05-10','16:25:00',1.65),('16273','2013-05-10','16:30:00',1.6),('16273','2013-05-10','16:35:00',1.49),('16273','2013-05-10','16:40:00',1.24),('16273','2013-05-10','16:55:00',1.13),('16273','2013-05-10','17:00:00',1.6),('16273','2013-05-10','17:05:00',1.73),('16273','2013-05-10','17:10:00',2.07),('16273','2013-05-10','17:15:00',2.57),('16273','2013-05-10','17:20:00',2.26),('16273','2013-05-10','17:25:00',1.79),('16273','2013-05-10','17:35:00',1.22),('16273','2013-05-09','07:15:00',1.04),('16273','2013-05-09','07:20:00',1.01),('16273','2013-05-09','07:25:00',1.26),('16273','2013-05-09','07:30:00',1.35),('16273','2013-05-09','07:35:00',1.45),('16273','2013-05-09','07:40:00',1.53),('16273','2013-05-09','07:45:00',1.63),('16273','2013-05-09','07:50:00',1.71),('16273','2013-05-09','07:55:00',1.79),('16273','2013-05-09','08:00:00',1.87),('16273','2013-05-09','08:05:00',1.95),('16273','2013-05-09','08:10:00',2.05),('16273','2013-05-09','08:15:00',2.13),('16273','2013-05-09','08:20:00',2.21),('16273','2013-05-09','08:25:00',2.28),('16273','2013-05-09','08:30:00',2.36),('16273','2013-05-09','08:35:00',2.43),('16273','2013-05-09','08:40:00',2.5),('16273','2013-05-09','08:45:00',2.59),('16273','2013-05-09','08:50:00',2.66),('16273','2013-05-09','08:55:00',2.73),('16273','2013-05-09','09:00:00',2.79),('16273','2013-05-09','09:05:00',2.88),('16273','2013-05-09','09:10:00',2.94),('16273','2013-05-09','09:15:00',3),('16273','2013-05-09','09:20:00',3.06),('16273','2013-05-09','09:25:00',3.13),('16273','2013-05-09','09:30:00',3.19),('16273','2013-05-09','09:35:00',3.22),('16273','2013-05-09','09:40:00',3.31),('16273','2013-05-09','09:45:00',3.33),('16273','2013-05-09','09:50:00',3.39),('16273','2013-05-09','09:55:00',3.41),('16273','2013-05-09','10:00:00',3.48),('16273','2013-05-09','10:05:00',3.53),('16273','2013-05-09','10:10:00',3.58),('16273','2013-05-09','10:15:00',3.59),('16273','2013-05-09','10:20:00',3.62),('16273','2013-05-09','10:25:00',3.65),('16273','2013-05-09','10:30:00',3.69),('16273','2013-05-09','10:35:00',3.69),('16273','2013-05-09','10:40:00',3.72),('16273','2013-05-09','10:45:00',3.77),('16273','2013-05-09','10:50:00',3.79),('16273','2013-05-09','10:55:00',3.81),('16273','2013-05-09','11:00:00',3.83),('16273','2013-05-09','11:05:00',3.84),('16273','2013-05-09','11:10:00',3.85),('16273','2013-05-09','11:15:00',3.88),('16273','2013-05-09','11:20:00',3.87),('16273','2013-05-09','11:25:00',3.91),('16273','2013-05-09','11:30:00',3.96),('16273','2013-05-09','11:35:00',4.01),('16273','2013-05-09','11:40:00',3.99),('16273','2013-05-09','11:45:00',4),('16273','2013-05-09','11:50:00',3.96),('16273','2013-05-09','11:55:00',4.03),('16273','2013-05-09','12:00:00',4.17),('16273','2013-05-09','12:05:00',2.51),('16273','2013-05-09','12:10:00',1.79),('16273','2013-05-09','12:25:00',1.5),('16273','2013-05-09','12:30:00',4.51),('16273','2013-05-09','12:35:00',4.41),('16273','2013-05-09','12:40:00',4.28),('16273','2013-05-09','12:45:00',4.28),('16273','2013-05-09','12:50:00',4.18),('16273','2013-05-09','12:55:00',4.07),('16273','2013-05-09','13:00:00',3.53),('16273','2013-05-09','13:05:00',3.63),('16273','2013-05-09','13:10:00',2.13),('16273','2013-05-09','13:15:00',2.81),('16273','2013-05-09','13:20:00',1.75),('16273','2013-05-09','13:25:00',1.39),('16273','2013-05-09','13:30:00',4.05),('16273','2013-05-09','13:35:00',3.82),('16273','2013-05-09','13:40:00',4.3),('16273','2013-05-09','13:45:00',3.47),('16273','2013-05-09','13:50:00',2.23),('16273','2013-05-09','13:55:00',2.35),('16273','2013-05-09','14:00:00',2.75),('16273','2013-05-09','14:05:00',4.1),('16273','2013-05-09','14:10:00',3.88),('16273','2013-05-09','14:15:00',3.76),('16273','2013-05-09','14:20:00',3.72),('16273','2013-05-09','14:25:00',3.67),('16273','2013-05-09','14:30:00',3.6),('16273','2013-05-09','14:35:00',3.58),('16273','2013-05-09','14:40:00',3.36),('16273','2013-05-09','14:45:00',3.33),('16273','2013-05-09','14:50:00',3.45),('16273','2013-05-09','14:55:00',3.43),('16273','2013-05-09','15:00:00',3.39),('16273','2013-05-09','15:05:00',3.37),('16273','2013-05-09','15:10:00',3.32),('16273','2013-05-09','15:15:00',3.22),('16273','2013-05-09','15:20:00',3.19),('16273','2013-05-09','15:25:00',3.09),('16273','2013-05-09','15:30:00',3.04),('16273','2013-05-09','15:35:00',3.02),('16273','2013-05-09','15:40:00',2.95),('16273','2013-05-09','15:45:00',2.91),('16273','2013-05-09','15:50:00',2.83),('16273','2013-05-09','15:55:00',2.75),('16273','2013-05-09','16:00:00',2.68),('16273','2013-05-09','16:05:00',2.61),('16273','2013-05-09','16:10:00',2.53),('16273','2013-05-09','16:15:00',2.46),('16273','2013-05-09','16:20:00',2.39),('16273','2013-05-09','16:25:00',2.33),('16273','2013-05-09','16:30:00',2.25),('16273','2013-05-09','16:35:00',2.17),('16273','2013-05-09','16:40:00',2.08),('16273','2013-05-09','16:45:00',2.02),('16273','2013-05-09','16:50:00',1.95),('16273','2013-05-09','16:55:00',1.86),('16273','2013-05-09','17:00:00',1.78),('16273','2013-05-09','17:05:00',1.7),('16273','2013-05-09','17:10:00',1.62),('16273','2013-05-09','17:15:00',1.55),('16273','2013-05-09','17:20:00',1.47),('16273','2013-05-09','17:25:00',1.39),('16273','2013-05-09','17:30:00',1.3),('16273','2013-05-09','17:35:00',1.22),('16273','2013-05-09','17:40:00',1.14),('16273','2013-05-09','17:45:00',1.07),('16273','2013-05-09','17:50:00',1),('16273','2013-05-08','07:35:00',1.3),('16273','2013-05-08','07:45:00',1.55),('16273','2013-05-08','07:50:00',1.66),('16273','2013-05-08','07:55:00',1.72),('16273','2013-05-08','08:00:00',1.73),('16273','2013-05-08','08:05:00',1.84),('16273','2013-05-08','08:10:00',2),('16273','2013-05-08','08:15:00',2.1),('16273','2013-05-08','08:20:00',2.15),('16273','2013-05-08','08:25:00',2.17),('16273','2013-05-08','08:30:00',2.34),('16273','2013-05-08','08:35:00',2.24),('16273','2013-05-08','08:40:00',2.44),('16273','2013-05-08','08:50:00',2.56),('16273','2013-05-08','08:55:00',2.37),('16273','2013-05-08','09:00:00',1.57),('16273','2013-05-08','09:20:00',2.02),('16273','2013-05-08','09:25:00',3.56),('16273','2013-05-08','09:30:00',3.58),('16273','2013-05-08','09:35:00',3.67),('16273','2013-05-08','09:40:00',3.21),('16273','2013-05-08','09:45:00',3.64),('16273','2013-05-08','09:50:00',1.4),('16273','2013-05-08','10:25:00',1.47),('16273','2013-05-08','10:30:00',3.82),('16273','2013-05-08','10:35:00',3.83),('16273','2013-05-08','10:40:00',2.26),('16273','2013-05-08','10:45:00',2.96),('16273','2013-05-08','10:50:00',3.81),('16273','2013-05-08','10:55:00',4.45),('16273','2013-05-08','11:00:00',3.86),('16273','2013-05-08','11:05:00',4.14),('16273','2013-05-08','11:10:00',1.96),('16273','2013-05-08','11:15:00',1.08),('16273','2013-05-08','11:25:00',2.29),('16273','2013-05-08','11:30:00',4.7),('16273','2013-05-08','11:35:00',4.48),('16273','2013-05-08','11:40:00',4.74),('16273','2013-05-08','11:45:00',2.28),('16273','2013-05-08','11:50:00',3.69),('16273','2013-05-08','11:55:00',3.36),('16273','2013-05-08','12:00:00',2.63),('16273','2013-05-08','12:05:00',4),('16273','2013-05-08','12:10:00',1.84),('16273','2013-05-08','12:15:00',1.7),('16273','2013-05-08','12:20:00',2.64),('16273','2013-05-08','12:25:00',1.2),('16273','2013-05-08','12:30:00',2.69),('16273','2013-05-08','12:35:00',4.64),('16273','2013-05-08','12:40:00',2.97),('16273','2013-05-08','12:45:00',1.5),('16273','2013-05-08','12:50:00',1.86),('16273','2013-05-08','12:55:00',1.99),('16273','2013-05-08','13:00:00',1.84),('16273','2013-05-08','13:05:00',2.34),('16273','2013-05-08','13:10:00',1.68),('16273','2013-05-08','13:15:00',1.55),('16273','2013-05-08','13:20:00',2.83),('16273','2013-05-08','13:25:00',4.9),('16273','2013-05-08','13:30:00',2.07),('16273','2013-05-08','13:35:00',1.38),('16273','2013-05-08','13:40:00',1.59),('16273','2013-05-08','13:45:00',4.22),('16273','2013-05-08','13:50:00',3.6),('16273','2013-05-08','13:55:00',1.64),('16273','2013-05-08','14:00:00',3.67),('16273','2013-05-08','14:05:00',3.96),('16273','2013-05-08','14:10:00',3.52),('16273','2013-05-08','14:15:00',4.06),('16273','2013-05-08','14:20:00',3.98),('16273','2013-05-08','14:25:00',3.87),('16273','2013-05-08','14:30:00',2.42),('16273','2013-05-08','14:35:00',2.45),('16273','2013-05-08','14:40:00',2.63),('16273','2013-05-08','14:45:00',3.59),('16273','2013-05-08','14:50:00',3.93),('16273','2013-05-08','14:55:00',3.45),('16273','2013-05-08','15:00:00',2.41),('16273','2013-05-08','15:05:00',3.34),('16273','2013-05-08','15:10:00',1.95),('16273','2013-05-08','15:15:00',2.89),('16273','2013-05-08','15:20:00',3.36),('16273','2013-05-08','15:25:00',3.21),('16273','2013-05-08','15:30:00',3.12),('16273','2013-05-08','15:35:00',3.06),('16273','2013-05-08','15:40:00',2.99),('16273','2013-05-08','15:45:00',2.9),('16273','2013-05-08','15:50:00',2.85),('16273','2013-05-08','15:55:00',2.8),('16273','2013-05-08','16:00:00',2.72),('16273','2013-05-08','16:05:00',2.65),('16273','2013-05-08','16:10:00',2.57),('16273','2013-05-08','16:15:00',2.49),('16273','2013-05-08','16:20:00',2.44),('16273','2013-05-08','16:25:00',2.38),('16273','2013-05-08','16:30:00',2.33),('16273','2013-05-08','16:35:00',2.34),('16273','2013-05-08','16:40:00',2.13),('16273','2013-05-08','16:45:00',1.75),('16273','2013-05-08','16:50:00',2.23),('16273','2013-05-08','16:55:00',2.05),('16273','2013-05-08','17:00:00',1.92),('16273','2013-05-08','17:05:00',1.43),('16273','2013-05-08','17:10:00',1.56),('16273','2013-05-08','17:15:00',1.46),('16273','2013-05-08','17:20:00',1.09),('16273','2013-05-08','17:25:00',1.09),('16273','2013-05-08','17:30:00',1.18),('16273','2013-05-08','17:35:00',1.15),('16273','2013-05-08','17:40:00',1.3),('16273','2013-05-08','17:45:00',1.24),('16273','2013-05-08','17:50:00',1.27),('16273','2013-05-08','17:55:00',1.31),('16273','2013-05-08','18:00:00',1.34),('16273','2013-05-08','18:05:00',1.3),('16273','2013-05-08','18:10:00',1.15),('16273','2013-05-07','07:20:00',1.06),('16273','2013-05-07','07:25:00',1.25),('16273','2013-05-07','07:30:00',1.35),('16273','2013-05-07','07:35:00',1.46),('16273','2013-05-07','07:40:00',1.47),('16273','2013-05-07','07:45:00',1.55),('16273','2013-05-07','07:50:00',1.66),('16273','2013-05-07','07:55:00',1.75),('16273','2013-05-07','08:00:00',1.86),('16273','2013-05-07','08:05:00',1.96),('16273','2013-05-07','08:10:00',2.06),('16273','2013-05-07','08:15:00',2.13),('16273','2013-05-07','08:20:00',2.21),('16273','2013-05-07','08:25:00',2.31),('16273','2013-05-07','08:30:00',2.39),('16273','2013-05-07','08:35:00',2.51),('16273','2013-05-07','08:40:00',2.53),('16273','2013-05-07','08:45:00',2.7),('16273','2013-05-07','08:50:00',2.92),('16273','2013-05-07','08:55:00',3.01),('16273','2013-05-07','09:00:00',1.85),('16273','2013-05-07','09:05:00',3.14),('16273','2013-05-07','09:10:00',1.34),('16273','2013-05-07','09:50:00',2.74),('16273','2013-05-07','09:55:00',3.77),('16273','2013-05-07','10:00:00',3.77),('16273','2013-05-07','10:05:00',3.9),('16273','2013-05-07','10:10:00',2.64),('16273','2013-05-07','10:15:00',1.09),('16273','2013-05-07','10:20:00',1.05),('16273','2013-05-07','10:45:00',1.03),('16273','2013-05-07','10:50:00',1.11),('16273','2013-05-07','10:55:00',2.3),('16273','2013-05-07','11:00:00',1.93),('16273','2013-05-07','11:15:00',2.27),('16273','2013-05-07','11:20:00',4.58),('16273','2013-05-07','11:25:00',4.48),('16273','2013-05-07','11:30:00',4.56),('16273','2013-05-07','11:35:00',4.07),('16273','2013-05-07','11:40:00',4.37),('16273','2013-05-07','11:45:00',4.84),('16273','2013-05-07','11:50:00',4.05),('16273','2013-05-07','11:55:00',3.91),('16273','2013-05-07','12:00:00',2.84),('16273','2013-05-07','12:05:00',3.78),('16273','2013-05-07','12:10:00',4.94),('16273','2013-05-07','12:15:00',4.65),('16273','2013-05-07','12:20:00',4.76),('16273','2013-05-07','12:25:00',1.55),('16273','2013-05-07','12:30:00',2.13),('16273','2013-05-07','12:35:00',4.24),('16273','2013-05-07','12:40:00',2.65),('16273','2013-05-07','12:45:00',3.15),('16273','2013-05-07','12:50:00',4.47),('16273','2013-05-07','12:55:00',3.02),('16273','2013-05-07','13:00:00',3.98),('16273','2013-05-07','13:05:00',3.06),('16273','2013-05-07','13:10:00',3.75),('16273','2013-05-07','13:15:00',4.62),('16273','2013-05-07','13:20:00',4.16),('16273','2013-05-07','13:25:00',4.25),('16273','2013-05-07','13:30:00',3.12),('16273','2013-05-07','13:35:00',3.53),('16273','2013-05-07','13:40:00',3.09),('16273','2013-05-07','13:45:00',4.35),('16273','2013-05-07','13:50:00',3.12),('16273','2013-05-07','13:55:00',3.24),('16273','2013-05-07','14:00:00',3.42),('16273','2013-05-07','14:05:00',4.34),('16273','2013-05-07','14:10:00',3.74),('16273','2013-05-07','14:15:00',3.66),('16273','2013-05-07','14:20:00',3.32),('16273','2013-05-07','14:25:00',3.54),('16273','2013-05-07','14:30:00',3.99),('16273','2013-05-07','14:35:00',3.92),('16273','2013-05-07','14:40:00',3.88),('16273','2013-05-07','14:45:00',3.46),('16273','2013-05-07','14:50:00',3.54),('16273','2013-05-07','14:55:00',2.35),('16273','2013-05-07','15:00:00',1.22),('16273','2013-05-07','15:05:00',1.71),('16273','2013-05-07','15:10:00',1.06),('16273','2013-05-07','15:15:00',1.75),('16273','2013-05-07','15:20:00',2.51),('16273','2013-05-07','15:25:00',2.15),('16273','2013-05-07','15:30:00',3.93),('16273','2013-05-07','15:35:00',2.58),('16273','2013-05-07','15:40:00',2.91),('16273','2013-05-07','15:45:00',2.25),('16273','2013-05-07','15:50:00',3.45),('16273','2013-05-07','15:55:00',3.85),('16273','2013-05-07','16:00:00',3.21),('16273','2013-05-07','16:05:00',2.57),('16273','2013-05-07','16:10:00',2.41),('16273','2013-05-07','16:15:00',2.64),('16273','2013-05-07','16:20:00',2.86),('16273','2013-05-07','16:25:00',2.81),('16273','2013-05-07','16:30:00',2.8),('16273','2013-05-07','16:35:00',2.43),('16273','2013-05-07','16:40:00',2.3),('16273','2013-05-07','16:45:00',1.35),('16273','2013-05-07','16:50:00',1.98),('16273','2013-05-07','16:55:00',2.1),('16273','2013-05-07','17:00:00',1.16),('16273','2013-05-07','17:05:00',1.13),('16273','2013-05-07','17:10:00',1.24),('16273','2013-05-07','17:15:00',1.2),('16273','2013-05-07','17:20:00',1.24),('16273','2013-05-07','17:25:00',1.18),('16273','2013-05-06','08:20:00',1.22),('16273','2013-05-06','08:25:00',1.31),('16273','2013-05-06','08:30:00',1.2),('16273','2013-05-06','08:35:00',1.34),('16273','2013-05-06','08:40:00',1.37),('16273','2013-05-06','08:45:00',1.74),('16273','2013-05-06','08:50:00',1.42),('16273','2013-05-06','08:55:00',1.42),('16273','2013-05-06','09:00:00',1.53),('16273','2013-05-06','09:05:00',1.02),('16273','2013-05-06','09:25:00',1.08),('16273','2013-05-06','09:30:00',1.11),('16273','2013-05-06','09:35:00',1.03),('16273','2013-05-06','09:50:00',1.07),('16273','2013-05-06','09:55:00',1.24),('16273','2013-05-06','10:00:00',1.48),('16273','2013-05-06','10:05:00',1.7),('16273','2013-05-06','10:10:00',1.8),('16273','2013-05-06','10:15:00',1.92),('16273','2013-05-06','10:20:00',2.45),('16273','2013-05-06','10:25:00',1.91),('16273','2013-05-06','10:30:00',1.63),('16273','2013-05-06','10:35:00',1.43),('16273','2013-05-06','10:40:00',1.49),('16273','2013-05-06','10:45:00',1.57),('16273','2013-05-06','10:50:00',1.28),('16273','2013-05-06','11:05:00',1.28),('16273','2013-05-06','11:10:00',1.33),('16273','2013-05-06','11:20:00',1.44),('16273','2013-05-06','11:25:00',2.84),('16273','2013-05-06','11:30:00',1.38),('16273','2013-05-06','11:40:00',1.12),('16273','2013-05-06','11:45:00',1.01),('16273','2013-05-06','11:50:00',2.14),('16273','2013-05-06','11:55:00',1.9),('16273','2013-05-06','12:00:00',1.83),('16273','2013-05-06','12:05:00',2.52),('16273','2013-05-06','12:10:00',4),('16273','2013-05-06','12:15:00',2.05),('16273','2013-05-06','12:20:00',3.69),('16273','2013-05-06','12:25:00',3.73),('16273','2013-05-06','12:30:00',3.49),('16273','2013-05-06','12:35:00',3.97),('16273','2013-05-06','12:40:00',3.74),('16273','2013-05-06','12:45:00',4.64),('16273','2013-05-06','12:50:00',3.16),('16273','2013-05-06','12:55:00',3.52),('16273','2013-05-06','13:00:00',2.74),('16273','2013-05-06','13:05:00',3.37),('16273','2013-05-06','13:10:00',3.66),('16273','2013-05-06','13:15:00',2.75),('16273','2013-05-06','13:20:00',3.7),('16273','2013-05-06','13:25:00',3.66),('16273','2013-05-06','13:30:00',4.04),('16273','2013-05-06','13:35:00',1.64),('16273','2013-05-06','13:40:00',2.18),('16273','2013-05-06','13:45:00',1.73),('16273','2013-05-06','13:50:00',1.65),('16273','2013-05-06','13:55:00',4.34),('16273','2013-05-06','14:00:00',2.77),('16273','2013-05-06','14:05:00',3.22),('16273','2013-05-06','14:10:00',3.67),('16273','2013-05-06','14:15:00',4.37),('16273','2013-05-06','14:20:00',2.37),('16273','2013-05-06','14:25:00',3.07),('16273','2013-05-06','14:30:00',3.1),('16273','2013-05-06','14:35:00',2.27),('16273','2013-05-06','14:40:00',3.61),('16273','2013-05-06','14:45:00',3.05),('16273','2013-05-06','14:50:00',2.74),('16273','2013-05-06','14:55:00',2.65),('16273','2013-05-06','15:00:00',2.35),('16273','2013-05-06','15:05:00',2.55),('16273','2013-05-06','15:10:00',2.47),('16273','2013-05-06','15:15:00',3.35),('16273','2013-05-06','15:20:00',1.93),('16273','2013-05-06','15:25:00',1.92),('16273','2013-05-06','15:30:00',2.02),('16273','2013-05-06','15:35:00',2.22),('16273','2013-05-06','15:40:00',2.71),('16273','2013-05-06','15:45:00',2.6),('16273','2013-05-06','15:50:00',1.36),('16273','2013-05-06','15:55:00',2.13),('16273','2013-05-06','16:00:00',2.51),('16273','2013-05-06','16:05:00',2.05),('16273','2013-05-06','16:10:00',1.76),('16273','2013-05-06','16:15:00',1.78),('16273','2013-05-06','16:20:00',1.03),('16273','2013-05-06','16:25:00',1.08),('16273','2013-05-06','16:30:00',2.02),('16273','2013-05-06','16:35:00',2.69),('16273','2013-05-06','16:40:00',1.09),('16273','2013-05-06','16:45:00',1.13),('16273','2013-05-06','16:55:00',1.04),('16273','2013-05-06','17:00:00',1.38),('16273','2013-05-06','17:05:00',1.3),('16273','2013-05-06','17:15:00',1.17),('16273','2013-05-06','17:20:00',1.48),('16273','2013-05-06','17:25:00',2.11),('16273','2013-05-06','17:30:00',1.86),('16273','2013-05-06','17:35:00',1.44),('16273','2013-05-05','07:35:00',1.12),('16273','2013-05-05','07:40:00',1.29),('16273','2013-05-05','07:45:00',1.38),('16273','2013-05-05','07:50:00',1.42),('16273','2013-05-05','07:55:00',1.44),('16273','2013-05-05','08:00:00',1.55),('16273','2013-05-05','08:05:00',1.57),('16273','2013-05-05','08:10:00',1.79),('16273','2013-05-05','08:15:00',1.95),('16273','2013-05-05','08:20:00',1.84),('16273','2013-05-05','08:25:00',1.14),('16273','2013-05-05','08:30:00',1.1),('16273','2013-05-05','08:35:00',1.54),('16273','2013-05-05','08:40:00',2),('16273','2013-05-05','08:45:00',1.72),('16273','2013-05-05','08:50:00',1.82),('16273','2013-05-05','08:55:00',1.75),('16273','2013-05-05','09:00:00',1.65),('16273','2013-05-05','09:05:00',1.61),('16273','2013-05-05','09:10:00',1.5),('16273','2013-05-05','09:15:00',1.65),('16273','2013-05-05','09:20:00',2.11),('16273','2013-05-05','09:25:00',1.78),('16273','2013-05-05','09:30:00',2.18),('16273','2013-05-05','09:35:00',2.04),('16273','2013-05-05','09:40:00',2.3),('16273','2013-05-05','09:45:00',3.37),('16273','2013-05-05','09:50:00',1.67),('16273','2013-05-05','09:55:00',1.27),('16273','2013-05-05','10:00:00',1.15),('16273','2013-05-05','10:05:00',1.24),('16273','2013-05-05','10:10:00',1.41),('16273','2013-05-05','10:15:00',1.46),('16273','2013-05-05','10:20:00',1.81),('16273','2013-05-05','10:25:00',1.9),('16273','2013-05-05','10:30:00',1.52),('16273','2013-05-05','10:35:00',1.29),('16273','2013-05-05','10:40:00',1.16),('16273','2013-05-05','10:50:00',1.05),('16273','2013-05-05','10:55:00',1.24),('16273','2013-05-05','11:00:00',1.41),('16273','2013-05-05','11:05:00',2.5),('16273','2013-05-05','11:10:00',4.06),('16273','2013-05-05','11:15:00',2.36),('16273','2013-05-05','11:20:00',3.52),('16273','2013-05-05','11:25:00',3.47),('16273','2013-05-05','11:30:00',3.02),('16273','2013-05-05','11:35:00',2.47),('16273','2013-05-05','11:40:00',2.25),('16273','2013-05-05','11:45:00',2.79),('16273','2013-05-05','11:50:00',3.12),('16273','2013-05-05','11:55:00',3.74),('16273','2013-05-05','12:00:00',2.78),('16273','2013-05-05','12:05:00',4.53),('16273','2013-05-05','12:10:00',4.31),('16273','2013-05-05','12:15:00',4.18),('16273','2013-05-05','12:20:00',4.19),('16273','2013-05-05','12:25:00',3.93),('16273','2013-05-05','12:30:00',4.23),('16273','2013-05-05','12:35:00',3.92),('16273','2013-05-05','12:40:00',3.77),('16273','2013-05-05','12:45:00',2.38),('16273','2013-05-05','12:50:00',3.48),('16273','2013-05-05','12:55:00',1.87),('16273','2013-05-05','13:00:00',1.32),('16273','2013-05-05','13:05:00',2.45),('16273','2013-05-05','13:10:00',4.24),('16273','2013-05-05','13:15:00',3.07),('16273','2013-05-05','13:20:00',3.46),('16273','2013-05-05','13:25:00',4.08),('16273','2013-05-05','13:30:00',2.83),('16273','2013-05-05','13:35:00',2.98),('16273','2013-05-05','13:40:00',3.67),('16273','2013-05-05','13:45:00',2.96),('16273','2013-05-05','13:50:00',2.64),('16273','2013-05-05','13:55:00',2.76),('16273','2013-05-05','14:00:00',3.3),('16273','2013-05-05','14:05:00',3.61),('16273','2013-05-05','14:10:00',3.21),('16273','2013-05-05','14:15:00',3.82),('16273','2013-05-05','14:20:00',3.29),('16273','2013-05-05','14:25:00',3.41),('16273','2013-05-05','14:30:00',3.43),('16273','2013-05-05','14:35:00',3.4),('16273','2013-05-05','14:40:00',3.37),('16273','2013-05-05','14:45:00',3.31),('16273','2013-05-05','14:50:00',3.27),('16273','2013-05-05','14:55:00',3.25),('16273','2013-05-05','15:00:00',3.18),('16273','2013-05-05','15:05:00',3.15),('16273','2013-05-05','15:10:00',3.08),('16273','2013-05-05','15:15:00',3.03),('16273','2013-05-05','15:20:00',2.99),('16273','2013-05-05','15:25:00',2.94),('16273','2013-05-05','15:30:00',2.88),('16273','2013-05-05','15:35:00',2.8),('16273','2013-05-05','15:40:00',2.74),('16273','2013-05-05','15:45:00',2.68),('16273','2013-05-05','15:50:00',2.63),('16273','2013-05-05','15:55:00',2.56),('16273','2013-05-05','16:00:00',2.5),('16273','2013-05-05','16:05:00',2.45),('16273','2013-05-05','16:10:00',2.38),('16273','2013-05-05','16:15:00',2.33),('16273','2013-05-05','16:20:00',2.27),('16273','2013-05-05','16:25:00',2.21),('16273','2013-05-05','16:30:00',2.13),('16273','2013-05-05','16:35:00',2.07),('16273','2013-05-05','16:40:00',1.98),('16273','2013-05-05','16:45:00',1.91),('16273','2013-05-05','16:50:00',1.85),('16273','2013-05-05','16:55:00',1.76),('16273','2013-05-05','17:00:00',1.68),('16273','2013-05-05','17:05:00',1.6),('16273','2013-05-05','17:10:00',1.52),('16273','2013-05-05','17:15:00',1.46),('16273','2013-05-05','17:20:00',1.38),('16273','2013-05-05','17:25:00',1.29),('16273','2013-05-05','17:30:00',1.23),('16273','2013-05-05','17:35:00',1.16),('16273','2013-05-05','17:40:00',1.09),('16273','2013-05-05','17:45:00',1.02),('16273','2013-05-04','07:35:00',1.03),('16273','2013-05-04','07:40:00',1.35),('16273','2013-05-04','07:45:00',1.45),('16273','2013-05-04','07:50:00',1.5),('16273','2013-05-04','07:55:00',1.59),('16273','2013-05-04','08:00:00',1.69),('16273','2013-05-04','08:05:00',1.77),('16273','2013-05-04','08:10:00',1.84),('16273','2013-05-04','08:15:00',1.92),('16273','2013-05-04','08:20:00',1.99),('16273','2013-05-04','08:25:00',2.06),('16273','2013-05-04','08:30:00',2.15),('16273','2013-05-04','08:35:00',2.21),('16273','2013-05-04','08:40:00',2.3),('16273','2013-05-04','08:45:00',2.37),('16273','2013-05-04','08:50:00',2.45),('16273','2013-05-04','08:55:00',2.48),('16273','2013-05-04','09:00:00',2.58),('16273','2013-05-04','09:05:00',2.65),('16273','2013-05-04','09:10:00',2.62),('16273','2013-05-04','09:15:00',2.72),('16273','2013-05-04','09:20:00',2.77),('16273','2013-05-04','09:25:00',2.83),('16273','2013-05-04','09:30:00',2.89),('16273','2013-05-04','09:35:00',2.92),('16273','2013-05-04','09:40:00',2.98),('16273','2013-05-04','09:45:00',3.02),('16273','2013-05-04','09:50:00',3.11),('16273','2013-05-04','09:55:00',2.98),('16273','2013-05-04','10:00:00',3.21),('16273','2013-05-04','10:05:00',3.23),('16273','2013-05-04','10:10:00',3.29),('16273','2013-05-04','10:15:00',3.34),('16273','2013-05-04','10:20:00',3.4),('16273','2013-05-04','10:25:00',3.41),('16273','2013-05-04','10:30:00',3.43),('16273','2013-05-04','10:35:00',3.38),('16273','2013-05-04','10:40:00',3.31),('16273','2013-05-04','10:45:00',3.29),('16273','2013-05-04','10:50:00',3.46),('16273','2013-05-04','10:55:00',3.54),('16273','2013-05-04','11:00:00',3.61),('16273','2013-05-04','11:05:00',3.61),('16273','2013-05-04','11:10:00',3.41),('16273','2013-05-04','11:15:00',3.15),('16273','2013-05-04','11:20:00',3.5),('16273','2013-05-04','11:25:00',3.49),('16273','2013-05-04','11:30:00',3.33),('16273','2013-05-04','11:35:00',3.36),('16273','2013-05-04','11:40:00',3.38),('16273','2013-05-04','11:45:00',3.29),('16273','2013-05-04','11:50:00',3.25),('16273','2013-05-04','11:55:00',3.37),('16273','2013-05-04','12:00:00',3.39),('16273','2013-05-04','12:05:00',3.29),('16273','2013-05-04','12:10:00',3.57),('16273','2013-05-04','12:15:00',3.65),('16273','2013-05-04','12:20:00',3.7),('16273','2013-05-04','12:25:00',3.75),('16273','2013-05-04','12:30:00',3.75),('16273','2013-05-04','12:35:00',3.68),('16273','2013-05-04','12:40:00',3.65),('16273','2013-05-04','12:45:00',3.67),('16273','2013-05-04','12:50:00',3.61),('16273','2013-05-04','12:55:00',3.5),('16273','2013-05-04','13:00:00',3.53),('16273','2013-05-04','13:05:00',3.54),('16273','2013-05-04','13:10:00',3.47),('16273','2013-05-04','13:15:00',3.65),('16273','2013-05-04','13:20:00',3.7),('16273','2013-05-04','13:25:00',3.6),('16273','2013-05-04','13:30:00',3.27),('16273','2013-05-04','13:35:00',3.54),('16273','2013-05-04','13:40:00',3.41),('16273','2013-05-04','13:45:00',3.08),('16273','2013-05-04','13:50:00',2.93),('16273','2013-05-04','13:55:00',3.37),('16273','2013-05-04','14:00:00',3.27),('16273','2013-05-04','14:05:00',3.17),('16273','2013-05-04','14:10:00',3.35),('16273','2013-05-04','14:15:00',3.16),('16273','2013-05-04','14:20:00',3.16),('16273','2013-05-04','14:25:00',3.09),('16273','2013-05-04','14:30:00',3.09),('16273','2013-05-04','14:35:00',3.01),('16273','2013-05-04','14:40:00',3.11),('16273','2013-05-04','14:45:00',2.89),('16273','2013-05-04','14:50:00',2.87),('16273','2013-05-04','14:55:00',3),('16273','2013-05-04','15:00:00',2.94),('16273','2013-05-04','15:05:00',2.8),('16273','2013-05-04','15:10:00',2.91),('16273','2013-05-04','15:15:00',2.92),('16273','2013-05-04','15:20:00',2.96),('16273','2013-05-04','15:25:00',2.89),('16273','2013-05-04','15:30:00',2.83),('16273','2013-05-04','15:35:00',2.65),('16273','2013-05-04','15:40:00',2.74),('16273','2013-05-04','15:45:00',2.67),('16273','2013-05-04','15:50:00',2.6),('16273','2013-05-04','15:55:00',2.53),('16273','2013-05-04','16:00:00',2.47),('16273','2013-05-04','16:05:00',2.4),('16273','2013-05-04','16:10:00',2.34),('16273','2013-05-04','16:15:00',2.28),('16273','2013-05-04','16:20:00',2.22),('16273','2013-05-04','16:25:00',2.15),('16273','2013-05-04','16:30:00',2.08),('16273','2013-05-04','16:35:00',2),('16273','2013-05-04','16:40:00',1.92),('16273','2013-05-04','16:45:00',1.85),('16273','2013-05-04','16:50:00',1.79),('16273','2013-05-04','16:55:00',1.71),('16273','2013-05-04','17:00:00',1.64),('16273','2013-05-04','17:05:00',1.58),('16273','2013-05-04','17:10:00',1.39),('16273','2013-05-04','17:15:00',1.41),('16273','2013-05-04','17:20:00',1.36),('16273','2013-05-04','17:25:00',1.29),('16273','2013-05-04','17:30:00',1.18),('16273','2013-05-04','17:35:00',1.12),('16273','2013-05-03','08:00:00',1.03),('16273','2013-05-03','08:05:00',1.32),('16273','2013-05-03','08:10:00',1.53),('16273','2013-05-03','08:15:00',1.48),('16273','2013-05-03','08:20:00',1.85),('16273','2013-05-03','08:25:00',1.67),('16273','2013-05-03','08:30:00',1.54),('16273','2013-05-03','08:35:00',1.6),('16273','2013-05-03','08:40:00',1.83),('16273','2013-05-03','08:45:00',1.81),('16273','2013-05-03','08:50:00',1.81),('16273','2013-05-03','08:55:00',2.31),('16273','2013-05-03','09:00:00',2.52),('16273','2013-05-03','09:05:00',2.58),('16273','2013-05-03','09:10:00',2.64),('16273','2013-05-03','09:15:00',2.86),('16273','2013-05-03','09:20:00',2.97),('16273','2013-05-03','09:25:00',3.01),('16273','2013-05-03','09:30:00',3.04),('16273','2013-05-03','09:35:00',3.12),('16273','2013-05-03','09:40:00',3.16),('16273','2013-05-03','09:45:00',3.2),('16273','2013-05-03','09:50:00',3.28),('16273','2013-05-03','09:55:00',3.33),('16273','2013-05-03','10:00:00',3.36),('16273','2013-05-03','10:05:00',3.41),('16273','2013-05-03','10:10:00',3.46),('16273','2013-05-03','10:15:00',3.49),('16273','2013-05-03','10:20:00',3.52),('16273','2013-05-03','10:25:00',3.57),('16273','2013-05-03','10:30:00',3.58),('16273','2013-05-03','10:35:00',3.62),('16273','2013-05-03','10:40:00',3.65),('16273','2013-05-03','10:45:00',3.69),('16273','2013-05-03','10:50:00',3.7),('16273','2013-05-03','10:55:00',3.72),('16273','2013-05-03','11:00:00',3.75),('16273','2013-05-03','11:05:00',3.76),('16273','2013-05-03','11:10:00',3.78),('16273','2013-05-03','11:15:00',3.8),('16273','2013-05-03','11:20:00',3.8),('16273','2013-05-03','11:25:00',3.82),('16273','2013-05-03','11:30:00',3.82),('16273','2013-05-03','11:35:00',3.82),('16273','2013-05-03','11:40:00',3.84),('16273','2013-05-03','11:45:00',3.84),('16273','2013-05-03','11:50:00',3.82),('16273','2013-05-03','11:55:00',3.84),('16273','2013-05-03','12:00:00',3.91),('16273','2013-05-03','12:05:00',3.86),('16273','2013-05-03','12:10:00',3.87),('16273','2013-05-03','12:15:00',3.88),('16273','2013-05-03','12:20:00',3.87),('16273','2013-05-03','12:25:00',3.86),('16273','2013-05-03','12:30:00',3.85),('16273','2013-05-03','12:35:00',3.88),('16273','2013-05-03','12:40:00',3.86),('16273','2013-05-03','12:45:00',3.75),('16273','2013-05-03','12:50:00',3.88),('16273','2013-05-03','12:55:00',3.86),('16273','2013-05-03','13:00:00',3.85),('16273','2013-05-03','13:05:00',3.87),('16273','2013-05-03','13:10:00',3.87),('16273','2013-05-03','13:15:00',3.85),('16273','2013-05-03','13:20:00',3.81),('16273','2013-05-03','13:25:00',3.71),('16273','2013-05-03','13:30:00',3.61),('16273','2013-05-03','13:35:00',3.69),('16273','2013-05-03','13:40:00',3.73),('16273','2013-05-03','13:45:00',3.72),('16273','2013-05-03','13:50:00',3.66),('16273','2013-05-03','13:55:00',3.62),('16273','2013-05-03','14:00:00',3.6),('16273','2013-05-03','14:05:00',3.62),('16273','2013-05-03','14:10:00',3.62),('16273','2013-05-03','14:15:00',3.57),('16273','2013-05-03','14:20:00',3.53),('16273','2013-05-03','14:25:00',3.5),('16273','2013-05-03','14:30:00',3.45),('16273','2013-05-03','14:35:00',3.42),('16273','2013-05-03','14:40:00',3.37),('16273','2013-05-03','14:45:00',3.33),('16273','2013-05-03','14:50:00',3.25),('16273','2013-05-03','14:55:00',3.21),('16273','2013-05-03','15:00:00',3.18),('16273','2013-05-03','15:05:00',3.15),('16273','2013-05-03','15:10:00',3.09),('16273','2013-05-03','15:15:00',3.03),('16273','2013-05-03','15:20:00',2.98),('16273','2013-05-03','15:25:00',2.94),('16273','2013-05-03','15:30:00',2.89),('16273','2013-05-03','15:35:00',2.85),('16273','2013-05-03','15:40:00',2.78),('16273','2013-05-03','15:45:00',2.73),('16273','2013-05-03','15:50:00',2.66),('16273','2013-05-03','15:55:00',2.61),('16273','2013-05-03','16:00:00',2.55),('16273','2013-05-03','16:05:00',2.48),('16273','2013-05-03','16:10:00',2.4),('16273','2013-05-03','16:15:00',2.32),('16273','2013-05-03','16:20:00',2.28),('16273','2013-05-03','16:25:00',2.22),('16273','2013-05-03','16:30:00',2.14),('16273','2013-05-03','16:35:00',2.03),('16273','2013-05-03','16:40:00',1.98),('16273','2013-05-03','16:45:00',1.91),('16273','2013-05-03','16:50:00',1.82),('16273','2013-05-03','16:55:00',1.74),('16273','2013-05-03','17:00:00',1.66),('16273','2013-05-03','17:05:00',1.6),('16273','2013-05-03','17:10:00',1.52),('16273','2013-05-03','17:15:00',1.44),('16273','2013-05-03','17:20:00',1.36),('16273','2013-05-03','17:25:00',1.3),('16273','2013-05-03','17:30:00',1.22),('16273','2013-05-03','17:35:00',1.15),('16273','2013-05-03','17:40:00',1.08),('16273','2013-05-03','17:45:00',1.02),('16273','2013-05-02','08:45:00',1.22),('16273','2013-05-02','08:50:00',1.54),('16273','2013-05-02','08:55:00',1.22),('16273','2013-05-02','09:25:00',1.45),('16273','2013-05-02','09:30:00',2),('16273','2013-05-02','09:35:00',1.11),('16273','2013-05-02','09:45:00',1.27),('16273','2013-05-02','09:50:00',1.65),('16273','2013-05-02','09:55:00',1.01),('16273','2013-05-02','10:10:00',1.14),('16273','2013-05-02','10:15:00',1.98),('16273','2013-05-02','10:20:00',1.8),('16273','2013-05-02','10:25:00',1.86),('16273','2013-05-02','10:30:00',2.12),('16273','2013-05-02','10:35:00',4.09),('16273','2013-05-02','10:40:00',3.06),('16273','2013-05-02','10:45:00',2.52),('16273','2013-05-02','10:50:00',2.68),('16273','2013-05-02','10:55:00',3.22),('16273','2013-05-02','11:00:00',3.79),('16273','2013-05-02','11:05:00',2.84),('16273','2013-05-02','11:10:00',3.64),('16273','2013-05-02','11:15:00',3.81),('16273','2013-05-02','11:20:00',3.9),('16273','2013-05-02','11:25:00',3.88),('16273','2013-05-02','11:30:00',3.52),('16273','2013-05-02','11:35:00',3.76),('16273','2013-05-02','11:40:00',3.85),('16273','2013-05-02','11:45:00',3.83),('16273','2013-05-02','11:50:00',3.83),('16273','2013-05-02','11:55:00',3.76),('16273','2013-05-02','12:00:00',3.84),('16273','2013-05-02','12:05:00',3.81),('16273','2013-05-02','12:10:00',3.8),('16273','2013-05-02','12:15:00',3.8),('16273','2013-05-02','12:20:00',3.81),('16273','2013-05-02','12:25:00',3.8),('16273','2013-05-02','12:30:00',3.77),('16273','2013-05-02','12:35:00',3.83),('16273','2013-05-02','12:40:00',3.75),('16273','2013-05-02','12:45:00',3.81),('16273','2013-05-02','12:50:00',3.85),('16273','2013-05-02','12:55:00',3.75),('16273','2013-05-02','13:00:00',3.82),('16273','2013-05-02','13:05:00',3.84),('16273','2013-05-02','13:10:00',3.81),('16273','2013-05-02','13:15:00',3.82),('16273','2013-05-02','13:20:00',3.85),('16273','2013-05-02','13:25:00',3.82),('16273','2013-05-02','13:30:00',3.75),('16273','2013-05-02','13:35:00',3.73),('16273','2013-05-02','13:40:00',3.69),('16273','2013-05-02','13:45:00',3.73),('16273','2013-05-02','13:50:00',3.7),('16273','2013-05-02','13:55:00',3.66),('16273','2013-05-02','14:00:00',3.64),('16273','2013-05-02','14:05:00',3.63),('16273','2013-05-02','14:10:00',3.58),('16273','2013-05-02','14:15:00',3.53),('16273','2013-05-02','14:20:00',3.49),('16273','2013-05-02','14:25:00',3.43),('16273','2013-05-02','14:30:00',3.41),('16273','2013-05-02','14:35:00',3.37),('16273','2013-05-02','14:40:00',3.33),('16273','2013-05-02','14:45:00',3.31),('16273','2013-05-02','14:50:00',3.26),('16273','2013-05-02','14:55:00',3.19),('16273','2013-05-02','15:00:00',3.19),('16273','2013-05-02','15:05:00',3.15),('16273','2013-05-02','15:10:00',3.1),('16273','2013-05-02','15:15:00',3.06),('16273','2013-05-02','15:20:00',3.02),('16273','2013-05-02','15:25:00',2.98),('16273','2013-05-02','15:30:00',2.92),('16273','2013-05-02','15:35:00',2.88),('16273','2013-05-02','15:40:00',2.81),('16273','2013-05-02','15:45:00',2.76),('16273','2013-05-02','15:50:00',2.7),('16273','2013-05-02','15:55:00',2.63),('16273','2013-05-02','16:00:00',2.55),('16273','2013-05-02','16:05:00',2.49),('16273','2013-05-02','16:10:00',2.41),('16273','2013-05-02','16:15:00',2.35),('16273','2013-05-02','16:20:00',2.3),('16273','2013-05-02','16:25:00',2.22),('16273','2013-05-02','16:30:00',2.15),('16273','2013-05-02','16:35:00',2.07),('16273','2013-05-02','16:40:00',1.98),('16273','2013-05-02','16:45:00',1.92),('16273','2013-05-02','16:50:00',1.84),('16273','2013-05-02','16:55:00',1.76),('16273','2013-05-02','17:00:00',1.68),('16273','2013-05-02','17:05:00',1.6),('16273','2013-05-02','17:10:00',1.52),('16273','2013-05-02','17:15:00',1.45),('16273','2013-05-02','17:20:00',1.37),('16273','2013-05-02','17:25:00',1.29),('16273','2013-05-02','17:30:00',1.23),('16273','2013-05-02','17:35:00',1.15),('16273','2013-05-02','17:40:00',1.08),('16273','2013-05-02','17:45:00',1.02),('16273','2014-03-30','08:15:00',1.09),('16273','2014-03-30','08:20:00',1.23),('16273','2014-03-30','08:25:00',1.33),('16273','2014-03-30','08:30:00',1.35),('16273','2014-03-30','08:35:00',1.39),('16273','2014-03-30','08:40:00',1.36),('16273','2014-03-30','08:45:00',1.39),('16273','2014-03-30','08:50:00',1.45),('16273','2014-03-30','08:55:00',1.46),('16273','2014-03-30','09:00:00',1.52),('16273','2014-03-30','09:05:00',1.76),('16273','2014-03-30','09:10:00',1.85),('16273','2014-03-30','09:15:00',1.94),('16273','2014-03-30','09:20:00',2.02),('16273','2014-03-30','09:25:00',1.94),('16273','2014-03-30','09:30:00',2.19),('16273','2014-03-30','09:35:00',2.37),('16273','2014-03-30','09:40:00',2.36),('16273','2014-03-30','09:45:00',2.34),('16273','2014-03-30','09:50:00',2.36),('16273','2014-03-30','09:55:00',2.65),('16273','2014-03-30','10:00:00',2.96),('16273','2014-03-30','10:05:00',2.98),('16273','2014-03-30','10:10:00',2.96),('16273','2014-03-30','10:15:00',2.98),('16273','2014-03-30','10:20:00',3.03),('16273','2014-03-30','10:25:00',3.06),('16273','2014-03-30','10:30:00',3.08),('16273','2014-03-30','10:35:00',3.1),('16273','2014-03-30','10:40:00',3.06),('16273','2014-03-30','10:45:00',2.94),('16273','2014-03-30','10:50:00',2.96),('16273','2014-03-30','10:55:00',3.1),('16273','2014-03-30','11:00:00',3.25),('16273','2014-03-30','11:05:00',3.16),('16273','2014-03-30','11:10:00',3.16),('16273','2014-03-30','11:15:00',3.19),('16273','2014-03-30','11:20:00',3.2),('16273','2014-03-30','11:25:00',3.45),('16273','2014-03-30','11:30:00',3.61),('16273','2014-03-30','11:35:00',3.67),('16273','2014-03-30','11:40:00',3.63),('16273','2014-03-30','11:45:00',3.57),('16273','2014-03-30','11:50:00',3.51),('16273','2014-03-30','11:55:00',3.62),('16273','2014-03-30','12:00:00',3.59),('16273','2014-03-30','12:05:00',3.72),('16273','2014-03-30','12:10:00',3.79),('16273','2014-03-30','12:15:00',3.62),('16273','2014-03-30','12:20:00',3.65),('16273','2014-03-30','12:25:00',3.82),('16273','2014-03-30','12:30:00',3.83),('16273','2014-03-30','12:35:00',3.75),('16273','2014-03-30','12:40:00',3.63),('16273','2014-03-30','12:45:00',3.7),('16273','2014-03-30','12:50:00',3.73),('16273','2014-03-30','12:55:00',3.69),('16273','2014-03-30','13:00:00',3.64),('16273','2014-03-30','13:05:00',3.8),('16273','2014-03-30','13:10:00',3.83),('16273','2014-03-30','13:15:00',3.82),('16273','2014-03-30','13:20:00',3.76),('16273','2014-03-30','13:25:00',3.77),('16273','2014-03-30','13:30:00',3.72),('16273','2014-03-30','13:35:00',3.7),('16273','2014-03-30','13:40:00',3.71),('16273','2014-03-30','13:45:00',3.72),('16273','2014-03-30','13:50:00',3.65),('16273','2014-03-30','13:55:00',3.54),('16273','2014-03-30','14:00:00',3.25),('16273','2014-03-30','14:05:00',2.89),('16273','2014-03-30','14:10:00',2.56),('16273','2014-03-30','14:15:00',2.56),('16273','2014-03-30','14:20:00',2.46),('16273','2014-03-30','14:25:00',2.06),('16273','2014-03-30','14:30:00',2.06),('16273','2014-03-30','14:35:00',2.22),('16273','2014-03-30','14:40:00',2.36),('16273','2014-03-30','14:45:00',2.36),('16273','2014-03-30','14:50:00',2.38),('16273','2014-03-30','14:55:00',2.77),('16273','2014-03-30','15:00:00',3.03),('16273','2014-03-30','15:05:00',3.05),('16273','2014-03-30','15:10:00',2.98),('16273','2014-03-30','15:15:00',2.95),('16273','2014-03-30','15:20:00',2.89),('16273','2014-03-30','15:25:00',2.83),('16273','2014-03-30','15:30:00',2.71),('16273','2014-03-30','15:35:00',2.69),('16273','2014-03-30','15:40:00',2.74),('16273','2014-03-30','15:45:00',2.79),('16273','2014-03-30','15:50:00',2.65),('16273','2014-03-30','15:55:00',2.61),('16273','2014-03-30','16:00:00',2.35),('16273','2014-03-30','16:05:00',2.13),('16273','2014-03-30','16:10:00',2.05),('16273','2014-03-30','16:15:00',1.96),('16273','2014-03-30','16:20:00',1.86),('16273','2014-03-30','16:25:00',1.9),('16273','2014-03-30','16:30:00',1.86),('16273','2014-03-30','16:35:00',1.82),('16273','2014-03-30','16:40:00',1.63),('16273','2014-03-30','16:45:00',1.47),('16273','2014-03-30','16:50:00',1.44),('16273','2014-03-30','16:55:00',1.45),('16273','2014-03-30','17:00:00',1.39),('16273','2014-03-30','17:05:00',1.31),('16273','2014-03-30','17:10:00',1.3),('16273','2014-03-30','17:15:00',1.26),('16273','2014-03-30','17:20:00',1.22),('16273','2014-03-30','17:25:00',1.15),('16273','2014-03-30','17:30:00',1.05),('16273','2013-05-01','07:40:00',1.02),('16273','2013-05-01','07:45:00',1.13),('16273','2013-05-01','07:50:00',1.21),('16273','2013-05-01','07:55:00',1.27),('16273','2013-05-01','08:00:00',1.34),('16273','2013-05-01','08:05:00',1.44),('16273','2013-05-01','08:10:00',1.56),('16273','2013-05-01','08:15:00',1.66),('16273','2013-05-01','08:20:00',1.75),('16273','2013-05-01','08:25:00',1.84),('16273','2013-05-01','08:30:00',1.95),('16273','2013-05-01','08:35:00',2.03),('16273','2013-05-01','08:40:00',2.1),('16273','2013-05-01','08:45:00',2.19),('16273','2013-05-01','08:50:00',2.28),('16273','2013-05-01','08:55:00',2.36),('16273','2013-05-01','09:00:00',2.41),('16273','2013-05-01','09:05:00',2.44),('16273','2013-05-01','09:10:00',2.49),('16273','2013-05-01','09:15:00',2.54),('16273','2013-05-01','09:20:00',2.53),('16273','2013-05-01','09:25:00',2.63),('16273','2013-05-01','09:30:00',2.69),('16273','2013-05-01','09:35:00',2.75),('16273','2013-05-01','09:40:00',2.79),('16273','2013-05-01','09:45:00',2.85),('16273','2013-05-01','09:50:00',2.9),('16273','2013-05-01','09:55:00',2.95),('16273','2013-05-01','10:00:00',3),('16273','2013-05-01','10:05:00',3.07),('16273','2013-05-01','10:10:00',3.11),('16273','2013-05-01','10:15:00',3.14),('16273','2013-05-01','10:20:00',3.2),('16273','2013-05-01','10:25:00',3.31),('16273','2013-05-01','10:30:00',3.44),('16273','2013-05-01','10:35:00',3.47),('16273','2013-05-01','10:40:00',3.48),('16273','2013-05-01','10:45:00',3.47),('16273','2013-05-01','10:50:00',3.51),('16273','2013-05-01','10:55:00',3.52),('16273','2013-05-01','11:00:00',3.53),('16273','2013-05-01','11:05:00',3.48),('16273','2013-05-01','11:10:00',3.68),('16273','2013-05-01','11:15:00',3.61),('16273','2013-05-01','11:20:00',3.45),('16273','2013-05-01','11:25:00',3.7),('16273','2013-05-01','11:30:00',3.23),('16273','2013-05-01','11:35:00',2.96),('16273','2013-05-01','11:40:00',3),('16273','2013-05-01','11:45:00',3.89),('16273','2013-05-01','11:50:00',3.82),('16273','2013-05-01','11:55:00',3.75),('16273','2013-05-01','12:00:00',3.74),('16273','2013-05-01','12:05:00',3.7),('16273','2013-05-01','12:10:00',3.68),('16273','2013-05-01','12:15:00',3.67),('16273','2013-05-01','12:20:00',3.63),('16273','2013-05-01','12:25:00',3.65),('16273','2013-05-01','12:30:00',3.69),('16273','2013-05-01','12:35:00',3.59),('16273','2013-05-01','12:40:00',2.41),('16273','2013-05-01','12:45:00',1.6),('16273','2013-05-01','12:50:00',1.44),('16273','2013-05-01','12:55:00',1.46),('16273','2013-05-01','13:00:00',1.59),('16273','2013-05-01','13:05:00',2.13),('16273','2013-05-01','13:10:00',3.53),('16273','2013-05-01','13:15:00',4.14),('16273','2013-05-01','13:20:00',3.82),('16273','2013-05-01','13:25:00',3.21),('16273','2013-05-01','13:30:00',3.96),('16273','2013-05-01','13:35:00',3.79),('16273','2013-05-01','13:40:00',3.75),('16273','2013-05-01','13:45:00',3.73),('16273','2013-05-01','13:50:00',3.71),('16273','2013-05-01','13:55:00',3.64),('16273','2013-05-01','14:00:00',3.62),('16273','2013-05-01','14:05:00',3.19),('16273','2013-05-01','14:10:00',3.49),('16273','2013-05-01','14:15:00',3.28),('16273','2013-05-01','14:20:00',3.68),('16273','2013-05-01','14:25:00',3.47),('16273','2013-05-01','14:30:00',3.61),('16273','2013-05-01','14:35:00',3.37),('16273','2013-05-01','14:40:00',2.88),('16273','2013-05-01','14:45:00',3.13),('16273','2013-05-01','14:50:00',2.79),('16273','2013-05-01','14:55:00',2.95),('16273','2013-05-01','15:00:00',2.12),('16273','2013-05-01','15:05:00',2.86),('16273','2013-05-01','15:10:00',3.01),('16273','2013-05-01','15:15:00',2.41),('16273','2013-05-01','15:20:00',2.42),('16273','2013-05-01','15:25:00',2.17),('16273','2013-05-01','15:30:00',1.9),('16273','2013-05-01','15:35:00',1.87),('16273','2013-05-01','15:40:00',1.93),('16273','2013-05-01','15:45:00',1.71),('16273','2013-05-01','15:50:00',1.64),('16273','2013-05-01','15:55:00',1.66),('16273','2013-05-01','16:00:00',1.9),('16273','2013-05-01','16:05:00',1.71),('16273','2013-05-01','16:10:00',1.6),('16273','2013-05-01','16:15:00',1.51),('16273','2013-05-01','16:20:00',1.35),('16273','2013-05-01','16:25:00',1.15),('16273','2013-05-01','16:30:00',1.05),('16273','2013-05-01','16:35:00',1.08),('16273','2013-05-01','16:40:00',1.08),('16273','2013-04-30','08:45:00',1.27),('16273','2013-04-30','08:50:00',1.58),('16273','2013-04-30','08:55:00',2.45),('16273','2013-04-30','09:00:00',2.19),('16273','2013-04-30','09:05:00',1.54),('16273','2013-04-30','09:10:00',2.41),('16273','2013-04-30','09:15:00',2.73),('16273','2013-04-30','09:20:00',1.98),('16273','2013-04-30','09:25:00',2.1),('16273','2013-04-30','09:30:00',2.46),('16273','2013-04-30','09:35:00',2.53),('16273','2013-04-30','09:40:00',2.37),('16273','2013-04-30','09:45:00',2.59),('16273','2013-04-30','09:50:00',2.85),('16273','2013-04-30','09:55:00',2.51),('16273','2013-04-30','10:00:00',1.92),('16273','2013-04-30','10:05:00',1.65),('16273','2013-04-30','10:10:00',1.7),('16273','2013-04-30','10:15:00',2.38),('16273','2013-04-30','10:20:00',2.74),('16273','2013-04-30','10:25:00',1.9),('16273','2013-04-30','10:30:00',1.56),('16273','2013-04-30','10:35:00',1.37),('16273','2013-04-30','10:40:00',1.82),('16273','2013-04-30','10:45:00',1.74),('16273','2013-04-30','10:50:00',1.91),('16273','2013-04-30','10:55:00',2.34),('16273','2013-04-30','11:00:00',2.08),('16273','2013-04-30','11:05:00',2.12),('16273','2013-04-30','11:10:00',2.09),('16273','2013-04-30','11:15:00',2.01),('16273','2013-04-30','11:20:00',2.05),('16273','2013-04-30','11:25:00',1.94),('16273','2013-04-30','11:30:00',2.02),('16273','2013-04-30','11:35:00',2.3),('16273','2013-04-30','11:40:00',1.7),('16273','2013-04-30','11:45:00',1.42),('16273','2013-04-30','11:50:00',1.44),('16273','2013-04-30','11:55:00',1.73),('16273','2013-04-30','12:00:00',2.31),('16273','2013-04-30','12:05:00',1.88),('16273','2013-04-30','12:10:00',2.3),('16273','2013-04-30','12:15:00',2.9),('16273','2013-04-30','12:20:00',2.01),('16273','2013-04-30','12:25:00',1.44),('16273','2013-04-30','12:30:00',1.97),('16273','2013-04-30','12:35:00',4.2),('16273','2013-04-30','12:40:00',4.24),('16273','2013-04-30','12:45:00',4),('16273','2013-04-30','12:50:00',3.77),('16273','2013-04-30','12:55:00',3.58),('16273','2013-04-30','13:00:00',3.72),('16273','2013-04-30','13:05:00',3.82),('16273','2013-04-30','13:10:00',3.75),('16273','2013-04-30','13:15:00',3.7),('16273','2013-04-30','13:20:00',3.69),('16273','2013-04-30','13:25:00',3.65),('16273','2013-04-30','13:30:00',3.59),('16273','2013-04-30','13:35:00',3.58),('16273','2013-04-30','13:40:00',3.55),('16273','2013-04-30','13:45:00',3.5),('16273','2013-04-30','13:50:00',3.47),('16273','2013-04-30','13:55:00',3.43),('16273','2013-04-30','14:00:00',3.41),('16273','2013-04-30','14:05:00',3.37),('16273','2013-04-30','14:10:00',3.34),('16273','2013-04-30','14:15:00',3.29),('16273','2013-04-30','14:20:00',3.26),('16273','2013-04-30','14:25:00',3.23),('16273','2013-04-30','14:30:00',3.19),('16273','2013-04-30','14:35:00',3.14),('16273','2013-04-30','14:40:00',3.09),('16273','2013-04-30','14:45:00',3.02),('16273','2013-04-30','14:50:00',2.98),('16273','2013-04-30','14:55:00',2.93),('16273','2013-04-30','15:00:00',2.96),('16273','2013-04-30','15:05:00',2.93),('16273','2013-04-30','15:10:00',2.9),('16273','2013-04-30','15:15:00',2.84),('16273','2013-04-30','15:20:00',2.78),('16273','2013-04-30','15:25:00',2.73),('16273','2013-04-30','15:30:00',2.68),('16273','2013-04-30','15:35:00',2.62),('16273','2013-04-30','15:40:00',2.57),('16273','2013-04-30','15:45:00',2.52),('16273','2013-04-30','15:50:00',2.46),('16273','2013-04-30','15:55:00',2.4),('16273','2013-04-30','16:00:00',2.33),('16273','2013-04-30','16:05:00',2.28),('16273','2013-04-30','16:10:00',2.21),('16273','2013-04-30','16:15:00',2.14),('16273','2013-04-30','16:20:00',2.08),('16273','2013-04-30','16:25:00',2.02),('16273','2013-04-30','16:30:00',1.8),('16273','2013-04-30','16:35:00',1.84),('16273','2013-04-30','16:40:00',1.45),('16273','2013-04-30','16:45:00',1.21),('16273','2013-04-30','16:50:00',1.54),('16273','2013-04-30','16:55:00',1.63),('16273','2013-04-30','17:00:00',1.47),('16273','2013-04-30','17:10:00',1.09),('16273','2013-04-30','17:15:00',1.08),('16273','2013-04-30','17:20:00',1.24),('16273','2013-04-30','17:25:00',1.18),('16273','2013-04-30','17:30:00',1.12),('16273','2013-04-30','17:35:00',1.07),('16273','2013-04-30','17:40:00',1),('16273','2013-04-29','07:45:00',1.06),('16273','2013-04-29','07:50:00',1.22),('16273','2013-04-29','07:55:00',1.4),('16273','2013-04-29','08:00:00',1.43),('16273','2013-04-29','08:05:00',1.38),('16273','2013-04-29','08:10:00',1.31),('16273','2013-04-29','08:15:00',1.55),('16273','2013-04-29','08:20:00',1.8),('16273','2013-04-29','08:25:00',2.14),('16273','2013-04-29','08:30:00',2.37),('16273','2013-04-29','08:35:00',2.26),('16273','2013-04-29','08:40:00',2.15),('16273','2013-04-29','08:45:00',2.28),('16273','2013-04-29','08:50:00',2.41),('16273','2013-04-29','08:55:00',2.36),('16273','2013-04-29','09:00:00',2.48),('16273','2013-04-29','09:05:00',2.61),('16273','2013-04-29','09:10:00',2.55),('16273','2013-04-29','09:15:00',2.45),('16273','2013-04-29','09:20:00',2.65),('16273','2013-04-29','09:25:00',2.68),('16273','2013-04-29','09:30:00',2.59),('16273','2013-04-29','09:35:00',2.72),('16273','2013-04-29','09:40:00',2.61),('16273','2013-04-29','09:45:00',2.69),('16273','2013-04-29','09:50:00',2.59),('16273','2013-04-29','09:55:00',2.84),('16273','2013-04-29','10:00:00',3.05),('16273','2013-04-29','10:05:00',2.82),('16273','2013-04-29','10:10:00',2.46),('16273','2013-04-29','10:15:00',3.08),('16273','2013-04-29','10:20:00',3.51),('16273','2013-04-29','10:25:00',3.6),('16273','2013-04-29','10:30:00',3.22),('16273','2013-04-29','10:35:00',2.9),('16273','2013-04-29','10:40:00',2.99),('16273','2013-04-29','10:45:00',3.16),('16273','2013-04-29','10:50:00',3.25),('16273','2013-04-29','10:55:00',3.06),('16273','2013-04-29','11:00:00',3.06),('16273','2013-04-29','11:05:00',3.35),('16273','2013-04-29','11:10:00',3.55),('16273','2013-04-29','11:15:00',3.57),('16273','2013-04-29','11:20:00',3.58),('16273','2013-04-29','11:25:00',3.1),('16273','2013-04-29','11:30:00',3.38),('16273','2013-04-29','11:35:00',3.23),('16273','2013-04-29','11:40:00',3.81),('16273','2013-04-29','11:45:00',3.52),('16273','2013-04-29','11:50:00',3.62),('16273','2013-04-29','11:55:00',3.74),('16273','2013-04-29','12:00:00',3.72),('16273','2013-04-29','12:05:00',3.75),('16273','2013-04-29','12:10:00',3.73),('16273','2013-04-29','12:15:00',3.77),('16273','2013-04-29','12:20:00',3.69),('16273','2013-04-29','12:25:00',3.78),('16273','2013-04-29','12:30:00',3.78),('16273','2013-04-29','12:35:00',3.78),('16273','2013-04-29','12:40:00',3.7),('16273','2013-04-29','12:45:00',3.51),('16273','2013-04-29','12:50:00',3.45),('16273','2013-04-29','12:55:00',3.56),('16273','2013-04-29','13:00:00',3.43),('16273','2013-04-29','13:05:00',3.43),('16273','2013-04-29','13:10:00',3.18),('16273','2013-04-29','13:15:00',3.78),('16273','2013-04-29','13:20:00',3.71),('16273','2013-04-29','13:25:00',3.79),('16273','2013-04-29','13:30:00',3.69),('16273','2013-04-29','13:35:00',3.62),('16273','2013-04-29','13:40:00',3.52),('16273','2013-04-29','13:45:00',3.37),('16273','2013-04-29','13:50:00',3.47),('16273','2013-04-29','13:55:00',3.5),('16273','2013-04-29','14:00:00',3.37),('16273','2013-04-29','14:05:00',3.51),('16273','2013-04-29','14:10:00',3.49),('16273','2013-04-29','14:15:00',3.46),('16273','2013-04-29','14:20:00',3.35),('16273','2013-04-29','14:25:00',3.2),('16273','2013-04-29','14:30:00',2.88),('16273','2013-04-29','14:35:00',2.87),('16273','2013-04-29','14:40:00',2.85),('16273','2013-04-29','14:45:00',2.9),('16273','2013-04-29','14:50:00',2.74),('16273','2013-04-29','14:55:00',2.68),('16273','2013-04-29','15:00:00',2.45),('16273','2013-04-29','15:05:00',2.7),('16273','2013-04-29','15:10:00',3.07),('16273','2013-04-29','15:15:00',3.04),('16273','2013-04-29','15:20:00',2.95),('16273','2013-04-29','15:25:00',2.58),('16273','2013-04-29','15:30:00',2.4),('16273','2013-04-29','15:35:00',2.39),('16273','2013-04-29','15:40:00',2.21),('16273','2013-04-29','15:45:00',2.2),('16273','2013-04-29','15:50:00',2.31),('16273','2013-04-29','15:55:00',2.34),('16273','2013-04-29','16:00:00',2.57),('16273','2013-04-29','16:05:00',2.55),('16273','2013-04-29','16:10:00',2.6),('16273','2013-04-29','16:15:00',2.24),('16273','2013-04-29','16:20:00',2.05),('16273','2013-04-29','16:25:00',2.13),('16273','2013-04-29','16:30:00',2.17),('16273','2013-04-29','16:35:00',2.18),('16273','2013-04-29','16:40:00',2.13),('16273','2013-04-29','16:45:00',2.18),('16273','2013-04-29','16:50:00',2.11),('16273','2013-04-29','16:55:00',1.97),('16273','2013-04-29','17:00:00',1.86),('16273','2013-04-29','17:05:00',1.75),('16273','2013-04-29','17:10:00',1.49),('16273','2013-04-29','17:15:00',1.38),('16273','2013-04-29','17:20:00',1.42),('16273','2013-04-29','17:25:00',1.17),('16273','2013-04-29','17:30:00',1.35),('16273','2013-04-29','17:35:00',1.12),('16273','2013-04-29','17:50:00',1.17),('16273','2013-04-29','17:55:00',1.07),('16273','2013-04-29','18:00:00',1.13),('16273','2013-04-29','18:05:00',1.04),('16273','2013-04-28','07:35:00',1.14),('16273','2013-04-28','07:40:00',1.28),('16273','2013-04-28','07:45:00',1.39),('16273','2013-04-28','07:50:00',1.46),('16273','2013-04-28','07:55:00',1.54),('16273','2013-04-28','08:00:00',1.65),('16273','2013-04-28','08:05:00',1.76),('16273','2013-04-28','08:10:00',1.87),('16273','2013-04-28','08:15:00',1.96),('16273','2013-04-28','08:20:00',2.06),('16273','2013-04-28','08:25:00',2.16),('16273','2013-04-28','08:30:00',2.21),('16273','2013-04-28','08:35:00',2.31),('16273','2013-04-28','08:40:00',2.38),('16273','2013-04-28','08:45:00',2.46),('16273','2013-04-28','08:50:00',2.51),('16273','2013-04-28','08:55:00',2.59),('16273','2013-04-28','09:00:00',2.67),('16273','2013-04-28','09:05:00',2.73),('16273','2013-04-28','09:10:00',2.81),('16273','2013-04-28','09:15:00',2.88),('16273','2013-04-28','09:20:00',2.95),('16273','2013-04-28','09:25:00',3.02),('16273','2013-04-28','09:30:00',3.08),('16273','2013-04-28','09:35:00',3.11),('16273','2013-04-28','09:40:00',3.19),('16273','2013-04-28','09:45:00',3.24),('16273','2013-04-28','09:50:00',3.3),('16273','2013-04-28','09:55:00',3.33),('16273','2013-04-28','10:00:00',3.38),('16273','2013-04-28','10:05:00',3.39),('16273','2013-04-28','10:10:00',3.42),('16273','2013-04-28','10:15:00',3.51),('16273','2013-04-28','10:20:00',3.54),('16273','2013-04-28','10:25:00',3.37),('16273','2013-04-28','10:30:00',3.35),('16273','2013-04-28','10:35:00',3.55),('16273','2013-04-28','10:40:00',3.44),('16273','2013-04-28','10:45:00',3.55),('16273','2013-04-28','10:50:00',3.65),('16273','2013-04-28','10:55:00',3.68),('16273','2013-04-28','11:00:00',3.73),('16273','2013-04-28','11:05:00',3.75),('16273','2013-04-28','11:10:00',3.7),('16273','2013-04-28','11:15:00',3.76),('16273','2013-04-28','11:20:00',3.79),('16273','2013-04-28','11:25:00',3.83),('16273','2013-04-28','11:30:00',3.85),('16273','2013-04-28','11:35:00',3.71),('16273','2013-04-28','11:40:00',3.57),('16273','2013-04-28','11:45:00',3.62),('16273','2013-04-28','11:50:00',3.53),('16273','2013-04-28','11:55:00',3.14),('16273','2013-04-28','12:00:00',3.19),('16273','2013-04-28','12:05:00',3.46),('16273','2013-04-28','12:10:00',3.4),('16273','2013-04-28','12:15:00',3.41),('16273','2013-04-28','12:20:00',3.7),('16273','2013-04-28','12:25:00',3.54),('16273','2013-04-28','12:30:00',3.41),('16273','2013-04-28','12:35:00',3.28),('16273','2013-04-28','12:40:00',2.42),('16273','2013-04-28','12:45:00',3.71),('16273','2013-04-28','12:50:00',3.74),('16273','2013-04-28','12:55:00',3.67),('16273','2013-04-28','13:00:00',3.9),('16273','2013-04-28','13:05:00',3.92),('16273','2013-04-28','13:10:00',3.44),('16273','2013-04-28','13:15:00',3.67),('16273','2013-04-28','13:20:00',3.72),('16273','2013-04-28','13:25:00',3.36),('16273','2013-04-28','13:30:00',3.53),('16273','2013-04-28','13:35:00',3.86),('16273','2013-04-28','13:40:00',3.75),('16273','2013-04-28','13:45:00',3.62),('16273','2013-04-28','13:50:00',3.66),('16273','2013-04-28','13:55:00',3.62),('16273','2013-04-28','14:00:00',3.59),('16273','2013-04-28','14:05:00',3.38),('16273','2013-04-28','14:10:00',3.47),('16273','2013-04-28','14:15:00',3.48),('16273','2013-04-28','14:20:00',3.42),('16273','2013-04-28','14:25:00',3.38),('16273','2013-04-28','14:30:00',3.38),('16273','2013-04-28','14:35:00',3.36),('16273','2013-04-28','14:40:00',3.29),('16273','2013-04-28','14:45:00',3.28),('16273','2013-04-28','14:50:00',3.22),('16273','2013-04-28','14:55:00',3.18),('16273','2013-04-28','15:00:00',3.14),('16273','2013-04-28','15:05:00',3.08),('16273','2013-04-28','15:10:00',3.01),('16273','2013-04-28','15:15:00',2.97),('16273','2013-04-28','15:20:00',2.94),('16273','2013-04-28','15:25:00',2.89),('16273','2013-04-28','15:30:00',2.83),('16273','2013-04-28','15:35:00',2.77),('16273','2013-04-28','15:40:00',2.71),('16273','2013-04-28','15:45:00',2.66),('16273','2013-04-28','15:50:00',2.6),('16273','2013-04-28','15:55:00',2.52),('16273','2013-04-28','16:00:00',2.46),('16273','2013-04-28','16:05:00',2.38),('16273','2013-04-28','16:10:00',2.33),('16273','2013-04-28','16:15:00',2.27),('16273','2013-04-28','16:20:00',2.2),('16273','2013-04-28','16:25:00',2.12),('16273','2013-04-28','16:30:00',2.04),('16273','2013-04-28','16:35:00',1.97),('16273','2013-04-28','16:40:00',1.88),('16273','2013-04-28','16:45:00',1.82),('16273','2013-04-28','16:50:00',1.77),('16273','2013-04-28','16:55:00',1.68),('16273','2013-04-28','17:00:00',1.61),('16273','2013-04-28','17:05:00',1.44),('16273','2013-04-28','17:10:00',1.44),('16273','2013-04-28','17:15:00',1.39),('16273','2013-04-28','17:20:00',1.32),('16273','2013-04-28','17:25:00',1.25),('16273','2013-04-28','17:30:00',1.03),('16273','2013-04-28','17:35:00',1.06),('16273','2013-04-28','17:40:00',1.03),('16273','2013-04-28','17:45:00',1),('16273','2013-04-27','12:45:00',1.03),('16273','2013-04-27','12:50:00',1.19),('16273','2013-04-27','12:55:00',1.19),('16273','2013-04-27','13:10:00',1.29),('16273','2013-04-27','13:15:00',1.95),('16273','2013-04-27','13:20:00',1.28),('16273','2013-04-27','14:30:00',1.25),('16273','2013-04-27','14:35:00',1.55),('16273','2013-04-27','14:40:00',1.46),('16273','2013-04-27','16:45:00',1.1),('16273','2013-04-27','16:55:00',1.14),('16273','2013-04-26','08:00:00',1.19),('16273','2013-04-26','08:05:00',1.27),('16273','2013-04-26','08:10:00',1.48),('16273','2013-04-26','08:15:00',1.57),('16273','2013-04-26','08:20:00',1.56),('16273','2013-04-26','08:25:00',1.62),('16273','2013-04-26','08:30:00',1.72),('16273','2013-04-26','08:35:00',1.71),('16273','2013-04-26','08:40:00',1.94),('16273','2013-04-26','08:45:00',2.23),('16273','2013-04-26','08:50:00',2.38),('16273','2013-04-26','08:55:00',2.5),('16273','2013-04-26','09:00:00',2.56),('16273','2013-04-26','09:05:00',1.96),('16273','2013-04-26','09:10:00',2.66),('16273','2013-04-26','09:15:00',2.57),('16273','2013-04-26','09:20:00',1.99),('16273','2013-04-26','09:25:00',2.32),('16273','2013-04-26','09:30:00',2.8),('16273','2013-04-26','09:35:00',2.8),('16273','2013-04-26','09:40:00',2.89),('16273','2013-04-26','09:45:00',2.8),('16273','2013-04-26','09:50:00',2.66),('16273','2013-04-26','09:55:00',2.82),('16273','2013-04-26','10:00:00',3.14),('16273','2013-04-26','10:05:00',3.21),('16273','2013-04-26','10:10:00',3.23),('16273','2013-04-26','10:15:00',3.04),('16273','2013-04-26','10:20:00',3.39),('16273','2013-04-26','10:25:00',3.48),('16273','2013-04-26','10:30:00',3.47),('16273','2013-04-26','10:35:00',2.83),('16273','2013-04-26','10:40:00',3.21),('16273','2013-04-26','10:45:00',3.56),('16273','2013-04-26','10:50:00',3.66),('16273','2013-04-26','10:55:00',3.69),('16273','2013-04-26','11:00:00',3.59),('16273','2013-04-26','11:05:00',3.79),('16273','2013-04-26','11:10:00',3.74),('16273','2013-04-26','11:15:00',2.82),('16273','2013-04-26','11:20:00',2.86),('16273','2013-04-26','11:25:00',3.5),('16273','2013-04-26','11:30:00',3.28),('16273','2013-04-26','11:35:00',3.98),('16273','2013-04-26','11:40:00',3.34),('16273','2013-04-26','11:45:00',2.57),('16273','2013-04-26','11:50:00',2.36),('16273','2013-04-26','11:55:00',2.33),('16273','2013-04-26','12:00:00',2.23),('16273','2013-04-26','12:05:00',1.91),('16273','2013-04-26','12:10:00',2.04),('16273','2013-04-26','12:15:00',2.01),('16273','2013-04-26','12:20:00',1.71),('16273','2013-04-26','12:25:00',1.53),('16273','2013-04-26','12:30:00',1.73),('16273','2013-04-26','12:35:00',2.15),('16273','2013-04-26','12:40:00',2.19),('16273','2013-04-26','12:45:00',1.91),('16273','2013-04-26','12:50:00',1.58),('16273','2013-04-26','12:55:00',1.27),('16273','2013-04-26','13:00:00',1.29),('16273','2013-04-26','13:05:00',1.55),('16273','2013-04-26','13:10:00',3.58),('16273','2013-04-26','13:15:00',4.05),('16273','2013-04-26','13:20:00',4.32),('16273','2013-04-26','13:25:00',3.43),('16273','2013-04-26','13:30:00',2.5),('16273','2013-04-26','13:35:00',2.26),('16273','2013-04-26','13:40:00',2.69),('16273','2013-04-26','13:45:00',2.88),('16273','2013-04-26','13:50:00',2.46),('16273','2013-04-26','13:55:00',2.25),('16273','2013-04-26','14:00:00',2.83),('16273','2013-04-26','14:05:00',2.3),('16273','2013-04-26','14:10:00',2.4),('16273','2013-04-26','14:15:00',2.14),('16273','2013-04-26','14:20:00',2.96),('16273','2013-04-26','14:25:00',2.56),('16273','2013-04-26','14:30:00',1.76),('16273','2013-04-26','14:35:00',1.53),('16273','2013-04-26','14:40:00',1.64),('16273','2013-04-26','14:45:00',1.33),('16273','2013-04-26','14:50:00',1.24),('16273','2013-04-26','14:55:00',1.39),('16273','2013-04-26','15:00:00',1.67),('16273','2013-04-26','15:05:00',1.38),('16273','2013-04-26','15:10:00',3.03),('16273','2013-04-26','15:15:00',2.29),('16273','2013-04-26','15:20:00',2.03),('16273','2013-04-26','15:25:00',3.48),('16273','2013-04-26','15:30:00',3.35),('16273','2013-04-26','15:35:00',2.49),('16273','2013-04-26','15:40:00',1.98),('16273','2013-04-26','15:45:00',1.52),('16273','2013-04-26','15:50:00',1.06),('16273','2013-04-25','08:00:00',1.02),('16273','2013-04-25','08:05:00',1.06),('16273','2013-04-25','08:10:00',1.23),('16273','2013-04-25','08:30:00',1),('16273','2013-04-25','08:35:00',1.18),('16273','2013-04-25','08:40:00',1.93),('16273','2013-04-25','08:45:00',2.32),('16273','2013-04-25','08:50:00',1.88),('16273','2013-04-25','08:55:00',1.36),('16273','2013-04-25','09:00:00',1.58),('16273','2013-04-25','09:05:00',1.4),('16273','2013-04-25','09:10:00',1.41),('16273','2013-04-25','09:15:00',1.43),('16273','2013-04-25','09:20:00',1.41),('16273','2013-04-25','09:25:00',1.6),('16273','2013-04-25','09:30:00',2.04),('16273','2013-04-25','09:35:00',2.56),('16273','2013-04-25','09:40:00',3.03),('16273','2013-04-25','09:45:00',3.21),('16273','2013-04-25','09:50:00',3.19),('16273','2013-04-25','09:55:00',3.17),('16273','2013-04-25','10:00:00',3.04),('16273','2013-04-25','10:05:00',3.34),('16273','2013-04-25','10:10:00',3.44),('16273','2013-04-25','10:15:00',3.51),('16273','2013-04-25','10:20:00',3.43),('16273','2013-04-25','10:25:00',3.5),('16273','2013-04-25','10:30:00',3.48),('16273','2013-04-25','10:35:00',3.55),('16273','2013-04-25','10:40:00',3.62),('16273','2013-04-25','10:45:00',3.61),('16273','2013-04-25','10:50:00',3.65),('16273','2013-04-25','10:55:00',3.67),('16273','2013-04-25','11:00:00',3.71),('16273','2013-04-25','11:05:00',3.75),('16273','2013-04-25','11:10:00',3.79),('16273','2013-04-25','11:15:00',3.82),('16273','2013-04-25','11:20:00',3.83),('16273','2013-04-25','11:25:00',3.89),('16273','2013-04-25','11:30:00',3.9),('16273','2013-04-25','11:35:00',3.9),('16273','2013-04-25','11:40:00',3.91),('16273','2013-04-25','11:45:00',3.98),('16273','2013-04-25','11:50:00',4.01),('16273','2013-04-25','11:55:00',3.95),('16273','2013-04-25','12:00:00',3.68),('16273','2013-04-25','12:05:00',3.77),('16273','2013-04-25','12:10:00',3.92),('16273','2013-04-25','12:15:00',3.91),('16273','2013-04-25','12:20:00',3.85),('16273','2013-04-25','12:25:00',3.81),('16273','2013-04-25','12:30:00',3.82),('16273','2013-04-25','12:35:00',3.85),('16273','2013-04-25','12:40:00',3.84),('16273','2013-04-25','12:45:00',3.81),('16273','2013-04-25','12:50:00',3.81),('16273','2013-04-25','12:55:00',3.82),('16273','2013-04-25','13:00:00',3.84),('16273','2013-04-25','13:05:00',3.79),('16273','2013-04-25','13:10:00',3.88),('16273','2013-04-25','13:15:00',2.88),('16273','2013-04-25','13:20:00',2.84),('16273','2013-04-25','13:25:00',2.66),('16273','2013-04-25','13:30:00',2.36),('16273','2013-04-25','13:35:00',2.14),('16273','2013-04-25','13:40:00',2.08),('16273','2013-04-25','13:45:00',2.06),('16273','2013-04-25','13:50:00',2.03),('16273','2013-04-25','13:55:00',2.16),('16273','2013-04-25','14:00:00',2.01),('16273','2013-04-25','14:05:00',2.09),('16273','2013-04-25','14:10:00',2.13),('16273','2013-04-25','14:15:00',2.52),('16273','2013-04-25','14:20:00',3.02),('16273','2013-04-25','14:25:00',3.34),('16273','2013-04-25','14:30:00',3.47),('16273','2013-04-25','14:35:00',3.34),('16273','2013-04-25','14:40:00',3.26),('16273','2013-04-25','14:45:00',3.01),('16273','2013-04-25','14:50:00',2.67),('16273','2013-04-25','14:55:00',2.67),('16273','2013-04-25','15:00:00',2.74),('16273','2013-04-25','15:05:00',2.13),('16273','2013-04-25','15:10:00',2.4),('16273','2013-04-25','15:15:00',2.55),('16273','2013-04-25','15:20:00',2.77),('16273','2013-04-25','15:25:00',2.75),('16273','2013-04-25','15:30:00',2.38),('16273','2013-04-25','15:35:00',2.24),('16273','2013-04-25','15:40:00',2.19),('16273','2013-04-25','15:45:00',1.87),('16273','2013-04-25','15:50:00',1.91),('16273','2013-04-25','15:55:00',2.25),('16273','2013-04-25','16:00:00',2.43),('16273','2013-04-25','16:05:00',2.38),('16273','2013-04-25','16:10:00',1.94),('16273','2013-04-25','16:15:00',2.06),('16273','2013-04-25','16:20:00',2.27),('16273','2013-04-25','16:25:00',2.13),('16273','2013-04-25','16:30:00',1.83),('16273','2013-04-25','16:35:00',1.58),('16273','2013-04-25','16:40:00',1.79),('16273','2013-04-25','16:45:00',1.47),('16273','2013-04-25','16:50:00',1.42),('16273','2013-04-25','16:55:00',1.65),('16273','2013-04-25','17:00:00',1.7),('16273','2013-04-25','17:05:00',1.56),('16273','2013-04-25','17:10:00',1.2),('16273','2013-04-25','17:15:00',1.24),('16273','2013-04-25','17:20:00',1.32),('16273','2013-04-25','17:25:00',1.33),('16273','2013-04-25','17:30:00',1.3),('16273','2013-04-25','17:35:00',1.23),('16273','2013-04-25','17:40:00',1.12),('16273','2013-04-24','07:50:00',1.22),('16273','2013-04-24','07:55:00',1.38),('16273','2013-04-24','08:00:00',1.45),('16273','2013-04-24','08:05:00',1.57),('16273','2013-04-24','08:10:00',1.77),('16273','2013-04-24','08:15:00',1.86),('16273','2013-04-24','08:20:00',2.03),('16273','2013-04-24','08:25:00',2.03),('16273','2013-04-24','08:30:00',1.92),('16273','2013-04-24','08:35:00',1.89),('16273','2013-04-24','08:40:00',2.03),('16273','2013-04-24','08:45:00',2.18),('16273','2013-04-24','08:50:00',2.08),('16273','2013-04-24','08:55:00',2.49),('16273','2013-04-24','09:00:00',2.75),('16273','2013-04-24','09:05:00',2.9),('16273','2013-04-24','09:10:00',2.98),('16273','2013-04-24','09:15:00',2.47),('16273','2013-04-24','09:20:00',1.87),('16273','2013-04-24','09:25:00',2.1),('16273','2013-04-24','09:30:00',3.07),('16273','2013-04-24','09:35:00',2.31),('16273','2013-04-24','09:40:00',2.38),('16273','2013-04-24','09:45:00',2.58),('16273','2013-04-24','09:50:00',3.22),('16273','2013-04-24','09:55:00',3.67),('16273','2013-04-24','10:00:00',3.59),('16273','2013-04-24','10:05:00',3.45),('16273','2013-04-24','10:10:00',3.05),('16273','2013-04-24','10:15:00',3.37),('16273','2013-04-24','10:20:00',3.61),('16273','2013-04-24','10:25:00',3.52),('16273','2013-04-24','10:30:00',3.37),('16273','2013-04-24','10:35:00',3.46),('16273','2013-04-24','10:40:00',3.71),('16273','2013-04-24','10:45:00',3.7),('16273','2013-04-24','10:50:00',3.73),('16273','2013-04-24','10:55:00',3.71),('16273','2013-04-24','11:00:00',3.71),('16273','2013-04-24','11:05:00',3.97),('16273','2013-04-24','11:10:00',4),('16273','2013-04-24','11:15:00',4),('16273','2013-04-24','11:20:00',3.95),('16273','2013-04-24','11:25:00',3.28),('16273','2013-04-24','11:30:00',3.07),('16273','2013-04-24','11:35:00',2.75),('16273','2013-04-24','11:40:00',3.18),('16273','2013-04-24','11:45:00',2.47),('16273','2013-04-24','11:50:00',2.12),('16273','2013-04-24','11:55:00',2.82),('16273','2013-04-24','12:00:00',3.16),('16273','2013-04-24','12:05:00',3.31),('16273','2013-04-24','12:10:00',2.68),('16273','2013-04-24','12:15:00',4.03),('16273','2013-04-24','12:20:00',3.08),('16273','2013-04-24','12:25:00',3.49),('16273','2013-04-24','12:30:00',3.56),('16273','2013-04-24','12:35:00',3.49),('16273','2013-04-24','12:40:00',3.84),('16273','2013-04-24','12:45:00',3.83),('16273','2013-04-24','12:50:00',3.71),('16273','2013-04-24','12:55:00',3.48),('16273','2013-04-24','13:00:00',3.16),('16273','2013-04-24','13:05:00',4.12),('16273','2013-04-24','13:10:00',3.48),('16273','2013-04-24','13:15:00',3.53),('16273','2013-04-24','13:20:00',3.49),('16273','2013-04-24','13:25:00',3.37),('16273','2013-04-24','13:30:00',3.08),('16273','2013-04-24','13:35:00',4.03),('16273','2013-04-24','13:40:00',3.08),('16273','2013-04-24','13:45:00',2.59),('16273','2013-04-24','13:50:00',3.59),('16273','2013-04-24','13:55:00',3.38),('16273','2013-04-24','14:00:00',2.52),('16273','2013-04-24','14:05:00',2.8),('16273','2013-04-24','14:10:00',3.71),('16273','2013-04-24','14:15:00',3.33),('16273','2013-04-24','14:20:00',3.49),('16273','2013-04-24','14:25:00',3.24),('16273','2013-04-24','14:30:00',2.94),('16273','2013-04-24','14:35:00',2.63),('16273','2013-04-24','14:40:00',2.76),('16273','2013-04-24','14:45:00',2.27),('16273','2013-04-24','14:50:00',2.03),('16273','2013-04-24','14:55:00',2.21),('16273','2013-04-24','15:00:00',2.18),('16273','2013-04-24','15:05:00',1.91),('16273','2013-04-24','15:10:00',2.01),('16273','2013-04-24','15:15:00',2.11),('16273','2013-04-24','15:20:00',1.75),('16273','2013-04-24','15:25:00',1.62),('16273','2013-04-24','15:30:00',1.56),('16273','2013-04-24','15:35:00',1.53),('16273','2013-04-24','15:40:00',1.59),('16273','2013-04-24','15:45:00',1.67),('16273','2013-04-24','15:50:00',1.93),('16273','2013-04-24','15:55:00',2.11),('16273','2013-04-24','16:00:00',2.22),('16273','2013-04-24','16:05:00',2.31),('16273','2013-04-24','16:10:00',2.41),('16273','2013-04-24','16:15:00',2.88),('16273','2013-04-24','16:20:00',2.12),('16273','2013-04-24','16:25:00',1.61),('16273','2013-04-24','16:30:00',1.6),('16273','2013-04-24','16:35:00',1.93),('16273','2013-04-24','16:40:00',2.01),('16273','2013-04-24','16:45:00',1.94),('16273','2013-04-24','16:50:00',2.15),('16273','2013-04-24','16:55:00',2.02),('16273','2013-04-24','17:00:00',1.88),('16273','2013-04-24','17:05:00',1.79),('16273','2013-04-24','17:10:00',1.31),('16273','2013-04-24','17:15:00',1.38),('16273','2013-04-24','17:20:00',1.22),('16273','2013-04-23','07:30:00',1.11),('16273','2013-04-23','07:35:00',1.22),('16273','2013-04-23','07:40:00',1.14),('16273','2013-04-23','07:45:00',1.45),('16273','2013-04-23','07:50:00',1.54),('16273','2013-04-23','07:55:00',1.65),('16273','2013-04-23','08:00:00',1.74),('16273','2013-04-23','08:05:00',1.83),('16273','2013-04-23','08:10:00',1.93),('16273','2013-04-23','08:15:00',2),('16273','2013-04-23','08:20:00',2.12),('16273','2013-04-23','08:25:00',2.22),('16273','2013-04-23','08:30:00',2.3),('16273','2013-04-23','08:35:00',2.38),('16273','2013-04-23','08:40:00',2.46),('16273','2013-04-23','08:45:00',2.53),('16273','2013-04-23','08:50:00',2.63),('16273','2013-04-23','08:55:00',2.69),('16273','2013-04-23','09:00:00',2.76),('16273','2013-04-23','09:05:00',2.83),('16273','2013-04-23','09:10:00',2.89),('16273','2013-04-23','09:15:00',2.97),('16273','2013-04-23','09:20:00',3.02),('16273','2013-04-23','09:25:00',3.08),('16273','2013-04-23','09:30:00',3.17),('16273','2013-04-23','09:35:00',3.23),('16273','2013-04-23','09:40:00',3.12),('16273','2013-04-23','09:45:00',3.36),('16273','2013-04-23','09:50:00',3.32),('16273','2013-04-23','09:55:00',3.45),('16273','2013-04-23','10:00:00',3.5),('16273','2013-04-23','10:05:00',3.55),('16273','2013-04-23','10:10:00',3.58),('16273','2013-04-23','10:15:00',3.62),('16273','2013-04-23','10:20:00',3.67),('16273','2013-04-23','10:25:00',3.71),('16273','2013-04-23','10:30:00',3.68),('16273','2013-04-23','10:35:00',3.74),('16273','2013-04-23','10:40:00',3.8),('16273','2013-04-23','10:45:00',3.59),('16273','2013-04-23','10:50:00',3.84),('16273','2013-04-23','10:55:00',3.86),('16273','2013-04-23','11:00:00',3.88),('16273','2013-04-23','11:05:00',3.89),('16273','2013-04-23','11:10:00',3.92),('16273','2013-04-23','11:15:00',3.91),('16273','2013-04-23','11:20:00',3.94),('16273','2013-04-23','11:25:00',3.97),('16273','2013-04-23','11:30:00',3.96),('16273','2013-04-23','11:35:00',3.98),('16273','2013-04-23','11:40:00',4.04),('16273','2013-04-23','11:45:00',4.04),('16273','2013-04-23','11:50:00',4.05),('16273','2013-04-23','11:55:00',4.04),('16273','2013-04-23','12:00:00',4.02),('16273','2013-04-23','12:05:00',4.06),('16273','2013-04-23','12:10:00',4.12),('16273','2013-04-23','12:15:00',4.07),('16273','2013-04-23','12:20:00',4.06),('16273','2013-04-23','12:25:00',4.12),('16273','2013-04-23','12:30:00',4.08),('16273','2013-04-23','12:35:00',4.19),('16273','2013-04-23','12:40:00',4.37),('16273','2013-04-23','12:45:00',4.46),('16273','2013-04-23','12:50:00',4.35),('16273','2013-04-23','12:55:00',4.34),('16273','2013-04-23','13:00:00',3.97),('16273','2013-04-23','13:05:00',2.97),('16273','2013-04-23','13:10:00',3.88),('16273','2013-04-23','13:15:00',3.69),('16273','2013-04-23','13:20:00',3.39),('16273','2013-04-23','13:25:00',2.99),('16273','2013-04-23','13:30:00',4.06),('16273','2013-04-23','13:35:00',4.02),('16273','2013-04-23','13:40:00',3.68),('16273','2013-04-23','13:45:00',3.58),('16273','2013-04-23','13:50:00',3.41),('16273','2013-04-23','13:55:00',4.13),('16273','2013-04-23','14:00:00',3.99),('16273','2013-04-23','14:05:00',3.86),('16273','2013-04-23','14:10:00',3.9),('16273','2013-04-23','14:15:00',3.78),('16273','2013-04-23','14:20:00',3.12),('16273','2013-04-23','14:25:00',3.48),('16273','2013-04-23','14:30:00',2.96),('16273','2013-04-23','14:35:00',3.41),('16273','2013-04-23','14:40:00',3.54),('16273','2013-04-23','14:45:00',3.17),('16273','2013-04-23','14:50:00',1.54),('16273','2013-04-23','14:55:00',1.64),('16273','2013-04-23','15:00:00',1.76),('16273','2013-04-23','15:05:00',2.14),('16273','2013-04-23','15:10:00',2.49),('16273','2013-04-23','15:15:00',2.66),('16273','2013-04-23','15:20:00',2.65),('16273','2013-04-23','15:25:00',2.19),('16273','2013-04-23','15:30:00',2.23),('16273','2013-04-23','15:35:00',2.37),('16273','2013-04-23','15:40:00',2.11),('16273','2013-04-23','15:45:00',2.32),('16273','2013-04-23','15:50:00',2.44),('16273','2013-04-23','15:55:00',2.28),('16273','2013-04-23','16:00:00',2.18),('16273','2013-04-23','16:05:00',1.89),('16273','2013-04-23','16:10:00',1.64),('16273','2013-04-23','16:15:00',1.3),('16273','2013-04-23','16:20:00',1.43),('16273','2013-04-23','16:25:00',1.6),('16273','2013-04-23','16:30:00',1.32),('16273','2013-04-23','16:35:00',1.14),('16273','2013-04-23','16:40:00',1.14),('16273','2013-04-23','16:45:00',1.24),('16273','2013-04-23','16:50:00',1.18),('16273','2013-04-23','16:55:00',1.25),('16273','2013-04-23','17:00:00',1.67),('16273','2013-04-23','17:05:00',1.9),('16273','2013-04-23','17:10:00',1.95),('16273','2013-04-23','17:15:00',1.8),('16273','2013-04-23','17:20:00',1.37),('16273','2013-04-23','17:25:00',1.42),('16273','2013-04-23','17:30:00',1.21),('16273','2013-04-23','17:40:00',1.32),('16273','2013-04-23','17:45:00',1.11),('16273','2013-04-22','08:40:00',1.21),('16273','2013-04-22','09:20:00',1),('16273','2013-04-22','09:40:00',1.2),('16273','2013-04-22','10:35:00',1.97),('16273','2013-04-22','10:40:00',2.45),('16273','2013-04-22','10:45:00',4.09),('16273','2013-04-22','10:50:00',1.52),('16273','2013-04-22','11:05:00',1.01),('16273','2013-04-22','11:15:00',1.01),('16273','2013-04-22','11:20:00',1.78),('16273','2013-04-22','11:25:00',1.75),('16273','2013-04-22','11:30:00',1.11),('16273','2013-04-22','11:40:00',1.81),('16273','2013-04-22','11:45:00',4.64),('16273','2013-04-22','11:50:00',4.44),('16273','2013-04-22','11:55:00',4.41),('16273','2013-04-22','12:00:00',4.42),('16273','2013-04-22','12:05:00',4.51),('16273','2013-04-22','12:10:00',4.48),('16273','2013-04-22','12:15:00',4.32),('16273','2013-04-22','12:20:00',4.24),('16273','2013-04-22','12:25:00',4.39),('16273','2013-04-22','12:30:00',3.86),('16273','2013-04-22','12:35:00',3.24),('16273','2013-04-22','12:40:00',2.77),('16273','2013-04-22','12:45:00',2.52),('16273','2013-04-22','12:50:00',4.08),('16273','2013-04-22','12:55:00',3.93),('16273','2013-04-22','13:00:00',1.87),('16273','2013-04-22','13:05:00',1.98),('16273','2013-04-22','13:10:00',2.71),('16273','2013-04-22','13:15:00',1.8),('16273','2013-04-22','13:20:00',1.4),('16273','2013-04-22','13:30:00',1.25),('16273','2013-04-22','13:50:00',3.06),('16273','2013-04-22','13:55:00',2.16),('16273','2013-04-22','14:00:00',3.01),('16273','2013-04-22','14:05:00',3.99),('16273','2013-04-22','14:10:00',3.41),('16273','2013-04-22','14:15:00',2.5),('16273','2013-04-22','14:20:00',1.13),('16273','2013-04-22','14:25:00',1.08),('16273','2013-04-22','14:30:00',3.29),('16273','2013-04-22','14:35:00',3.21),('16273','2013-04-22','14:40:00',1.49),('16273','2013-04-22','14:45:00',2.25),('16273','2013-04-22','14:50:00',2.12),('16273','2013-04-22','14:55:00',1.27),('16273','2013-04-22','15:05:00',3.2),('16273','2013-04-22','15:10:00',2.05),('16273','2013-04-22','15:20:00',1.46),('16273','2013-04-22','15:25:00',1.63),('16273','2013-04-22','15:30:00',2.65),('16273','2013-04-22','15:35:00',1.3),('16273','2013-04-22','15:40:00',1.46),('16273','2013-04-22','15:45:00',2.14),('16273','2013-04-22','15:50:00',2.47),('16273','2013-04-22','17:00:00',1.07),('16273','2013-04-22','17:05:00',1.21),('16273','2013-04-22','17:10:00',1.41),('16273','2013-04-22','17:15:00',1.34),('16273','2013-04-22','17:20:00',1.54),('16273','2013-04-22','17:25:00',1.85),('16273','2013-04-22','17:30:00',1.31),('16273','2013-04-22','17:35:00',1.29),('16273','2013-04-22','17:40:00',1.55),('16273','2013-04-22','17:45:00',1.64),('16273','2013-04-22','17:50:00',1.71),('16273','2013-04-22','17:55:00',1.46),('16273','2014-03-29','07:10:00',1.09),('16273','2014-03-29','07:15:00',1.04),('16273','2014-03-29','07:20:00',1.3),('16273','2014-03-29','07:25:00',1.39),('16273','2014-03-29','07:30:00',1.47),('16273','2014-03-29','07:35:00',1.58),('16273','2014-03-29','07:40:00',1.7),('16273','2014-03-29','07:45:00',1.8),('16273','2014-03-29','07:50:00',1.9),('16273','2014-03-29','07:55:00',1.98),('16273','2014-03-29','08:00:00',2.05),('16273','2014-03-29','08:05:00',2.15),('16273','2014-03-29','08:10:00',2.24),('16273','2014-03-29','08:15:00',2.33),('16273','2014-03-29','08:20:00',2.42),('16273','2014-03-29','08:25:00',2.48),('16273','2014-03-29','08:30:00',2.54),('16273','2014-03-29','08:35:00',2.61),('16273','2014-03-29','08:40:00',2.69),('16273','2014-03-29','08:45:00',2.76),('16273','2014-03-29','08:50:00',2.79),('16273','2014-03-29','08:55:00',2.86),('16273','2014-03-29','09:00:00',2.92),('16273','2014-03-29','09:05:00',2.96),('16273','2014-03-29','09:10:00',3.02),('16273','2014-03-29','09:15:00',3.08),('16273','2014-03-29','09:20:00',3.12),('16273','2014-03-29','09:25:00',3.18),('16273','2014-03-29','09:30:00',3.21),('16273','2014-03-29','09:35:00',3.24),('16273','2014-03-29','09:40:00',3.26),('16273','2014-03-29','09:45:00',3.3),('16273','2014-03-29','09:50:00',3.35),('16273','2014-03-29','09:55:00',3.38),('16273','2014-03-29','10:00:00',3.41),('16273','2014-03-29','10:05:00',3.43),('16273','2014-03-29','10:10:00',3.49),('16273','2014-03-29','10:15:00',3.57),('16273','2014-03-29','10:20:00',3.58),('16273','2014-03-29','10:25:00',3.59),('16273','2014-03-29','10:30:00',3.58),('16273','2014-03-29','10:35:00',3.59),('16273','2014-03-29','10:40:00',3.67),('16273','2014-03-29','10:45:00',3.68),('16273','2014-03-29','10:50:00',3.7),('16273','2014-03-29','10:55:00',3.72),('16273','2014-03-29','11:00:00',3.75),('16273','2014-03-29','11:05:00',3.78),('16273','2014-03-29','11:10:00',3.76),('16273','2014-03-29','11:15:00',3.75),('16273','2014-03-29','11:20:00',3.74),('16273','2014-03-29','11:25:00',3.75),('16273','2014-03-29','11:30:00',3.74),('16273','2014-03-29','11:35:00',3.72),('16273','2014-03-29','11:40:00',3.74),('16273','2014-03-29','11:45:00',3.76),('16273','2014-03-29','11:50:00',3.71),('16273','2014-03-29','11:55:00',3.69),('16273','2014-03-29','12:00:00',3.65),('16273','2014-03-29','12:05:00',3.56),('16273','2014-03-29','12:10:00',3.59),('16273','2014-03-29','12:15:00',3.56),('16273','2014-03-29','12:20:00',3.54),('16273','2014-03-29','12:25:00',3.57),('16273','2014-03-29','12:30:00',3.59),('16273','2014-03-29','12:35:00',3.52),('16273','2014-03-29','12:40:00',3.52),('16273','2014-03-29','12:45:00',3.54),('16273','2014-03-29','12:50:00',3.55),('16273','2014-03-29','12:55:00',3.51),('16273','2014-03-29','13:00:00',3.08),('16273','2014-03-29','13:05:00',2.92),('16273','2014-03-29','13:10:00',2.72),('16273','2014-03-29','13:15:00',2.29),('16273','2014-03-29','13:20:00',2.54),('16273','2014-03-29','13:25:00',2.34),('16273','2014-03-29','13:30:00',2.37),('16273','2014-03-29','13:35:00',2.38),('16273','2014-03-29','13:40:00',2.98),('16273','2014-03-29','13:45:00',2.99),('16273','2014-03-29','13:50:00',3),('16273','2014-03-29','13:55:00',3.06),('16273','2014-03-29','14:00:00',2.99),('16273','2014-03-29','14:05:00',2.91),('16273','2014-03-29','14:10:00',2.9),('16273','2014-03-29','14:15:00',2.6),('16273','2014-03-29','14:20:00',2.56),('16273','2014-03-29','14:25:00',2.66),('16273','2014-03-29','14:30:00',2.65),('16273','2014-03-29','14:35:00',2.59),('16273','2014-03-29','14:40:00',2.54),('16273','2014-03-29','14:45:00',2.46),('16273','2014-03-29','14:50:00',2.24),('16273','2014-03-29','14:55:00',2.28),('16273','2014-03-29','15:00:00',2.25),('16273','2014-03-29','15:05:00',2.19),('16273','2014-03-29','15:10:00',2.11),('16273','2014-03-29','15:15:00',2.03),('16273','2014-03-29','15:20:00',1.95),('16273','2014-03-29','15:25:00',1.88),('16273','2014-03-29','15:30:00',1.8),('16273','2014-03-29','15:35:00',1.72),('16273','2014-03-29','15:40:00',1.65),('16273','2014-03-29','15:45:00',1.58),('16273','2014-03-29','15:50:00',1.51),('16273','2014-03-29','15:55:00',1.44),('16273','2014-03-29','16:00:00',1.36),('16273','2014-03-29','16:05:00',1.27),('16273','2014-03-29','16:10:00',1.21),('16273','2014-03-29','16:15:00',1.12),('16273','2014-03-29','16:20:00',1.05),('16273','2014-03-29','16:25:00',1),('16273','2013-04-21','08:45:00',1.2),('16273','2013-04-21','08:50:00',1.2),('16273','2013-04-21','08:55:00',1.07),('16273','2013-04-21','09:10:00',1.02),('16273','2013-04-21','09:20:00',1.04),('16273','2013-04-21','09:25:00',1.36),('16273','2013-04-21','09:30:00',1.93),('16273','2013-04-21','09:35:00',1.91),('16273','2013-04-21','09:40:00',2.02),('16273','2013-04-21','09:45:00',2.34),('16273','2013-04-21','09:50:00',2.35),('16273','2013-04-21','09:55:00',2.72),('16273','2013-04-21','10:00:00',1.62),('16273','2013-04-21','10:05:00',2.9),('16273','2013-04-21','10:10:00',2.93),('16273','2013-04-21','10:15:00',3.67),('16273','2013-04-21','10:20:00',3.73),('16273','2013-04-21','10:25:00',3.91),('16273','2013-04-21','10:30:00',3.65),('16273','2013-04-21','10:35:00',3.64),('16273','2013-04-21','10:40:00',2.77),('16273','2013-04-21','10:45:00',3.93),('16273','2013-04-21','10:50:00',3.86),('16273','2013-04-21','10:55:00',3.99),('16273','2013-04-21','11:00:00',3.59),('16273','2013-04-21','11:05:00',3.79),('16273','2013-04-21','11:10:00',3.98),('16273','2013-04-21','11:15:00',4.1),('16273','2013-04-21','11:20:00',3.57),('16273','2013-04-21','11:25:00',2.83),('16273','2013-04-21','11:30:00',2.7),('16273','2013-04-21','11:35:00',2.74),('16273','2013-04-21','11:40:00',2.63),('16273','2013-04-21','11:45:00',2.31),('16273','2013-04-21','11:50:00',2.42),('16273','2013-04-21','11:55:00',2.62),('16273','2013-04-21','12:00:00',2.51),('16273','2013-04-21','12:05:00',2.33),('16273','2013-04-21','12:10:00',2.09),('16273','2013-04-21','12:15:00',1.88),('16273','2013-04-21','12:20:00',1.89),('16273','2013-04-21','12:25:00',2.02),('16273','2013-04-21','12:30:00',2.02),('16273','2013-04-21','12:35:00',2.12),('16273','2013-04-21','12:40:00',2.17),('16273','2013-04-21','12:45:00',2.14),('16273','2013-04-21','12:50:00',2.24),('16273','2013-04-21','12:55:00',2.22),('16273','2013-04-21','13:00:00',2.36),('16273','2013-04-21','13:05:00',2.98),('16273','2013-04-21','13:10:00',2.42),('16273','2013-04-21','13:15:00',2.34),('16273','2013-04-21','13:20:00',2.4),('16273','2013-04-21','13:25:00',2.42),('16273','2013-04-21','13:30:00',2.85),('16273','2013-04-21','13:35:00',3.45),('16273','2013-04-21','13:40:00',3.21),('16273','2013-04-21','13:45:00',3.85),('16273','2013-04-21','13:50:00',3.09),('16273','2013-04-21','13:55:00',2.97),('16273','2013-04-21','14:00:00',2.92),('16273','2013-04-21','14:05:00',4.05),('16273','2013-04-21','14:10:00',3.72),('16273','2013-04-21','14:15:00',3.65),('16273','2013-04-21','14:20:00',4.06),('16273','2013-04-21','14:25:00',3.92),('16273','2013-04-21','14:30:00',3.63),('16273','2013-04-21','14:35:00',3.45),('16273','2013-04-21','14:40:00',3.62),('16273','2013-04-21','14:45:00',2.81),('16273','2013-04-21','14:50:00',2.36),('16273','2013-04-21','14:55:00',3.36),('16273','2013-04-21','15:00:00',3.5),('16273','2013-04-21','15:05:00',3.26),('16273','2013-04-21','15:10:00',3.1),('16273','2013-04-21','15:15:00',2.25),('16273','2013-04-21','15:20:00',2.31),('16273','2013-04-21','15:25:00',2.53),('16273','2013-04-21','15:30:00',2.28),('16273','2013-04-21','15:35:00',1.82),('16273','2013-04-21','15:40:00',2.12),('16273','2013-04-21','15:45:00',1.19),('16273','2013-04-21','15:50:00',1.01),('16273','2013-04-20','07:55:00',1.03),('16273','2013-04-20','08:00:00',1.17),('16273','2013-04-20','08:05:00',1.18),('16273','2013-04-20','08:15:00',1.19),('16273','2013-04-20','08:20:00',1.09),('16273','2013-04-20','08:25:00',1.4),('16273','2013-04-20','08:30:00',1.53),('16273','2013-04-20','08:35:00',2.14),('16273','2013-04-20','08:40:00',2.21),('16273','2013-04-20','08:45:00',2.37),('16273','2013-04-20','08:50:00',2.4),('16273','2013-04-20','08:55:00',2.42),('16273','2013-04-20','09:00:00',2.24),('16273','2013-04-20','09:05:00',2.62),('16273','2013-04-20','09:10:00',1.53),('16273','2013-04-20','09:15:00',1.61),('16273','2013-04-20','09:20:00',1.2),('16273','2013-04-20','09:25:00',1.09),('16273','2013-04-20','10:20:00',1.22),('16273','2013-04-20','10:25:00',1.64),('16273','2013-04-20','10:30:00',1.86),('16273','2013-04-20','10:35:00',2.47),('16273','2013-04-20','10:40:00',2.95),('16273','2013-04-20','10:45:00',4.11),('16273','2013-04-20','10:50:00',1.87),('16273','2013-04-20','10:55:00',3.63),('16273','2013-04-20','11:00:00',4.04),('16273','2013-04-20','11:05:00',3.56),('16273','2013-04-20','11:10:00',2.91),('16273','2013-04-20','11:15:00',4.31),('16273','2013-04-20','11:20:00',2.96),('16273','2013-04-20','11:25:00',1.68),('16273','2013-04-20','11:30:00',3.05),('16273','2013-04-20','11:35:00',2.61),('16273','2013-04-20','11:40:00',3.92),('16273','2013-04-20','11:45:00',3.31),('16273','2013-04-20','11:50:00',1.68),('16273','2013-04-20','11:55:00',3.73),('16273','2013-04-20','12:00:00',4.28),('16273','2013-04-20','12:05:00',4.11),('16273','2013-04-20','12:10:00',3.8),('16273','2013-04-20','12:15:00',1.71),('16273','2013-04-20','12:20:00',3.46),('16273','2013-04-20','12:25:00',4.36),('16273','2013-04-20','12:30:00',4.25),('16273','2013-04-20','12:35:00',3.76),('16273','2013-04-20','12:40:00',4.12),('16273','2013-04-20','12:45:00',4.13),('16273','2013-04-20','12:50:00',4.1),('16273','2013-04-20','12:55:00',4.1),('16273','2013-04-20','13:00:00',4.06),('16273','2013-04-20','13:05:00',3.71),('16273','2013-04-20','13:10:00',3.9),('16273','2013-04-20','13:15:00',4.01),('16273','2013-04-20','13:20:00',4),('16273','2013-04-20','13:25:00',3.64),('16273','2013-04-20','13:30:00',4.32),('16273','2013-04-20','13:35:00',3.22),('16273','2013-04-20','13:40:00',3.35),('16273','2013-04-20','13:45:00',2.34),('16273','2013-04-20','13:50:00',4.26),('16273','2013-04-20','13:55:00',4.1),('16273','2013-04-20','14:00:00',3.97),('16273','2013-04-20','14:05:00',3.82),('16273','2013-04-20','14:10:00',3.72),('16273','2013-04-20','14:15:00',3.72),('16273','2013-04-20','14:20:00',3.58),('16273','2013-04-20','14:25:00',3.52),('16273','2013-04-20','14:30:00',3.45),('16273','2013-04-20','14:35:00',3.49),('16273','2013-04-20','14:40:00',3.47),('16273','2013-04-20','14:45:00',3.36),('16273','2013-04-20','14:50:00',3.32),('16273','2013-04-20','14:55:00',3.36),('16273','2013-04-20','15:00:00',2.93),('16273','2013-04-20','15:05:00',1.52),('16273','2013-04-20','15:10:00',2.92),('16273','2013-04-20','15:15:00',3.13),('16273','2013-04-20','15:20:00',1.98),('16273','2013-04-20','15:25:00',1.17),('16273','2013-04-20','15:55:00',1.23),('16273','2013-04-20','16:00:00',2.18),('16273','2013-04-20','16:05:00',2.98),('16273','2013-04-20','16:10:00',3.01),('16273','2013-04-20','16:15:00',2.54),('16273','2013-04-20','16:20:00',2.53),('16273','2013-04-20','16:25:00',2.56),('16273','2013-04-20','16:30:00',2.46),('16273','2013-04-20','16:35:00',2.28),('16273','2013-04-20','16:40:00',2.1),('16273','2013-04-20','16:45:00',1.95),('16273','2013-04-20','16:50:00',1.84),('16273','2013-04-20','16:55:00',1.75),('16273','2013-04-20','17:00:00',1.65),('16273','2013-04-20','17:05:00',1.57),('16273','2013-04-20','17:10:00',1.48),('16273','2013-04-20','17:15:00',1.42),('16273','2013-04-20','17:20:00',1.38),('16273','2013-04-20','17:25:00',1.34),('16273','2013-04-20','17:30:00',1.31),('16273','2013-04-20','17:35:00',1.08),('16273','2013-04-19','08:05:00',1.13),('16273','2013-04-19','08:10:00',1.13),('16273','2013-04-19','08:15:00',1.33),('16273','2013-04-19','08:20:00',1.53),('16273','2013-04-19','08:25:00',1.8),('16273','2013-04-19','08:30:00',2.26),('16273','2013-04-19','08:35:00',1.6),('16273','2013-04-19','08:40:00',2.16),('16273','2013-04-19','08:45:00',1.73),('16273','2013-04-19','08:50:00',1.64),('16273','2013-04-19','08:55:00',2.39),('16273','2013-04-19','09:00:00',2.3),('16273','2013-04-19','09:05:00',2.66),('16273','2013-04-19','09:10:00',2.59),('16273','2013-04-19','09:15:00',2.69),('16273','2013-04-19','09:20:00',2.52),('16273','2013-04-19','09:25:00',2.63),('16273','2013-04-19','09:30:00',1.7),('16273','2013-04-19','09:35:00',2.48),('16273','2013-04-19','09:40:00',2.87),('16273','2013-04-19','09:45:00',2.83),('16273','2013-04-19','09:50:00',2.98),('16273','2013-04-19','09:55:00',3.04),('16273','2013-04-19','10:00:00',3.09),('16273','2013-04-19','10:05:00',3.14),('16273','2013-04-19','10:10:00',3.22),('16273','2013-04-19','10:15:00',3.27),('16273','2013-04-19','10:20:00',3.28),('16273','2013-04-19','10:25:00',3.29),('16273','2013-04-19','10:30:00',3.35),('16273','2013-04-19','10:35:00',3.36),('16273','2013-04-19','10:40:00',3.37),('16273','2013-04-19','10:45:00',3.45),('16273','2013-04-19','10:50:00',3),('16273','2013-04-19','10:55:00',3.54),('16273','2013-04-19','11:00:00',3.53),('16273','2013-04-19','11:05:00',3.44),('16273','2013-04-19','11:10:00',3.57),('16273','2013-04-19','11:15:00',3.61),('16273','2013-04-19','11:20:00',3.63),('16273','2013-04-19','11:25:00',3.7),('16273','2013-04-19','11:30:00',3.69),('16273','2013-04-19','11:35:00',3.7),('16273','2013-04-19','11:40:00',3.75),('16273','2013-04-19','11:45:00',3.77),('16273','2013-04-19','11:50:00',3.7),('16273','2013-04-19','11:55:00',3.72),('16273','2013-04-19','12:00:00',3.6),('16273','2013-04-19','12:05:00',3.78),('16273','2013-04-19','12:10:00',3.72),('16273','2013-04-19','12:15:00',3.71),('16273','2013-04-19','12:20:00',3.56),('16273','2013-04-19','12:25:00',3.75),('16273','2013-04-19','12:30:00',3.78),('16273','2013-04-19','12:35:00',3.74),('16273','2013-04-19','12:40:00',3.82),('16273','2013-04-19','12:45:00',3.84),('16273','2013-04-19','12:50:00',3.81),('16273','2013-04-19','12:55:00',3.82),('16273','2013-04-19','13:00:00',3.79),('16273','2013-04-19','13:05:00',3.79),('16273','2013-04-19','13:10:00',3.8),('16273','2013-04-19','13:15:00',3.75),('16273','2013-04-19','13:20:00',3.75),('16273','2013-04-19','13:25:00',3.73),('16273','2013-04-19','13:30:00',3.71),('16273','2013-04-19','13:35:00',3.67),('16273','2013-04-19','13:40:00',3.65),('16273','2013-04-19','13:45:00',3.64),('16273','2013-04-19','13:50:00',3.63),('16273','2013-04-19','13:55:00',3.6),('16273','2013-04-19','14:00:00',3.55),('16273','2013-04-19','14:05:00',3.53),('16273','2013-04-19','14:10:00',3.49),('16273','2013-04-19','14:15:00',3.46),('16273','2013-04-19','14:20:00',3.41),('16273','2013-04-19','14:25:00',3.4),('16273','2013-04-19','14:30:00',3.4),('16273','2013-04-19','14:35:00',3.35),('16273','2013-04-19','14:40:00',3.29),('16273','2013-04-19','14:45:00',3.24),('16273','2013-04-19','14:50:00',3.2),('16273','2013-04-19','14:55:00',3.17),('16273','2013-04-19','15:00:00',3.12),('16273','2013-04-19','15:05:00',3.06),('16273','2013-04-19','15:10:00',3.02),('16273','2013-04-19','15:15:00',2.97),('16273','2013-04-19','15:20:00',2.92),('16273','2013-04-19','15:25:00',2.86),('16273','2013-04-19','15:30:00',2.81),('16273','2013-04-19','15:35:00',2.74),('16273','2013-04-19','15:40:00',2.69),('16273','2013-04-19','15:45:00',2.64),('16273','2013-04-19','15:50:00',2.59),('16273','2013-04-19','15:55:00',2.5),('16273','2013-04-19','16:00:00',2.42),('16273','2013-04-19','16:05:00',2.36),('16273','2013-04-19','16:10:00',2.3),('16273','2013-04-19','16:15:00',2.22),('16273','2013-04-19','16:20:00',2.15),('16273','2013-04-19','16:25:00',2.07),('16273','2013-04-19','16:30:00',1.98),('16273','2013-04-19','16:35:00',1.91),('16273','2013-04-19','16:40:00',1.83),('16273','2013-04-19','16:45:00',1.76),('16273','2013-04-19','16:50:00',1.67),('16273','2013-04-19','16:55:00',1.58),('16273','2013-04-19','17:00:00',1.49),('16273','2013-04-19','17:05:00',1.43),('16273','2013-04-19','17:10:00',1.35),('16273','2013-04-19','17:15:00',1.29),('16273','2013-04-19','17:20:00',1.23),('16273','2013-04-19','17:25:00',1.16),('16273','2013-04-19','17:30:00',1.09),('16273','2013-04-19','17:35:00',1.02),('16273','2013-04-18','08:00:00',1.3),('16273','2013-04-18','08:05:00',1.34),('16273','2013-04-18','08:10:00',1.29),('16273','2013-04-18','08:15:00',1.52),('16273','2013-04-18','08:20:00',1.46),('16273','2013-04-18','08:25:00',1.46),('16273','2013-04-18','08:30:00',1.33),('16273','2013-04-18','08:35:00',1.23),('16273','2013-04-18','08:40:00',1.37),('16273','2013-04-18','08:45:00',1.43),('16273','2013-04-18','08:50:00',1.53),('16273','2013-04-18','08:55:00',1.67),('16273','2013-04-18','09:00:00',1.33),('16273','2013-04-18','09:05:00',1.56),('16273','2013-04-18','09:10:00',1.82),('16273','2013-04-18','09:15:00',1.87),('16273','2013-04-18','09:20:00',2.12),('16273','2013-04-18','09:25:00',2.4),('16273','2013-04-18','09:30:00',2.34),('16273','2013-04-18','09:35:00',2.02),('16273','2013-04-18','09:40:00',1.93),('16273','2013-04-18','09:45:00',1.99),('16273','2013-04-18','09:50:00',2.13),('16273','2013-04-18','09:55:00',2.88),('16273','2013-04-18','10:00:00',3.15),('16273','2013-04-18','10:05:00',3.16),('16273','2013-04-18','10:10:00',3.28),('16273','2013-04-18','10:15:00',3.28),('16273','2013-04-18','10:20:00',3.36),('16273','2013-04-18','10:25:00',3.42),('16273','2013-04-18','10:30:00',3.49),('16273','2013-04-18','10:35:00',3.52),('16273','2013-04-18','10:40:00',3.57),('16273','2013-04-18','10:45:00',3.58),('16273','2013-04-18','10:50:00',3.59),('16273','2013-04-18','10:55:00',3.61),('16273','2013-04-18','11:00:00',3.63),('16273','2013-04-18','11:05:00',3.69),('16273','2013-04-18','11:10:00',3.73),('16273','2013-04-18','11:15:00',3.75),('16273','2013-04-18','11:20:00',3.79),('16273','2013-04-18','11:25:00',3.85),('16273','2013-04-18','11:30:00',3.87),('16273','2013-04-18','11:35:00',3.85),('16273','2013-04-18','11:40:00',3.86),('16273','2013-04-18','11:45:00',3.88),('16273','2013-04-18','11:50:00',3.85),('16273','2013-04-18','11:55:00',3.92),('16273','2013-04-18','12:00:00',3.78),('16273','2013-04-18','12:05:00',3.94),('16273','2013-04-18','12:10:00',3.95),('16273','2013-04-18','12:15:00',3.93),('16273','2013-04-18','12:20:00',3.93),('16273','2013-04-18','12:25:00',3.95),('16273','2013-04-18','12:30:00',3.95),('16273','2013-04-18','12:35:00',3.93),('16273','2013-04-18','12:40:00',3.95),('16273','2013-04-18','12:45:00',3.94),('16273','2013-04-18','12:50:00',3.93),('16273','2013-04-18','12:55:00',3.91),('16273','2013-04-18','13:00:00',3.9),('16273','2013-04-18','13:05:00',3.89),('16273','2013-04-18','13:10:00',3.86),('16273','2013-04-18','13:15:00',3.87),('16273','2013-04-18','13:20:00',3.85),('16273','2013-04-18','13:25:00',3.84),('16273','2013-04-18','13:30:00',3.81),('16273','2013-04-18','13:35:00',3.77),('16273','2013-04-18','13:40:00',3.75),('16273','2013-04-18','13:45:00',3.74),('16273','2013-04-18','13:50:00',3.72),('16273','2013-04-18','13:55:00',3.69),('16273','2013-04-18','14:00:00',3.66),('16273','2013-04-18','14:05:00',3.65),('16273','2013-04-18','14:10:00',3.65),('16273','2013-04-18','14:15:00',3.61),('16273','2013-04-18','14:20:00',3.57),('16273','2013-04-18','14:25:00',3.53),('16273','2013-04-18','14:30:00',3.5),('16273','2013-04-18','14:35:00',3.45),('16273','2013-04-18','14:40:00',3.4),('16273','2013-04-18','14:45:00',3.36),('16273','2013-04-18','14:50:00',3.31),('16273','2013-04-18','14:55:00',3.26),('16273','2013-04-18','15:00:00',3.14),('16273','2013-04-18','15:05:00',3.14),('16273','2013-04-18','15:10:00',3.09),('16273','2013-04-18','15:15:00',3.02),('16273','2013-04-18','15:20:00',2.96),('16273','2013-04-18','15:25:00',2.91),('16273','2013-04-18','15:30:00',2.82),('16273','2013-04-18','15:35:00',2.77),('16273','2013-04-18','15:40:00',2.73),('16273','2013-04-18','15:45:00',2.65),('16273','2013-04-18','15:50:00',2.59),('16273','2013-04-18','15:55:00',2.53),('16273','2013-04-18','16:00:00',2.46),('16273','2013-04-18','16:05:00',2.4),('16273','2013-04-18','16:10:00',2.33),('16273','2013-04-18','16:15:00',2.22),('16273','2013-04-18','16:20:00',2.16),('16273','2013-04-18','16:25:00',2.08),('16273','2013-04-18','16:30:00',2.01),('16273','2013-04-18','16:35:00',1.94),('16273','2013-04-18','16:40:00',1.86),('16273','2013-04-18','16:45:00',1.78),('16273','2013-04-18','16:50:00',1.71),('16273','2013-04-18','16:55:00',1.62),('16273','2013-04-18','17:00:00',1.55),('16273','2013-04-18','17:05:00',1.47),('16273','2013-04-18','17:10:00',1.4),('16273','2013-04-18','17:15:00',1.33),('16273','2013-04-18','17:20:00',1.26),('16273','2013-04-18','17:25:00',1.2),('16273','2013-04-18','17:30:00',1.11),('16273','2013-04-18','17:35:00',1.04),('16273','2013-04-17','07:40:00',1.11),('16273','2013-04-17','07:45:00',1.04),('16273','2013-04-17','07:50:00',1.34),('16273','2013-04-17','07:55:00',1.46),('16273','2013-04-17','08:00:00',1.55),('16273','2013-04-17','08:05:00',1.64),('16273','2013-04-17','08:10:00',1.72),('16273','2013-04-17','08:15:00',1.81),('16273','2013-04-17','08:20:00',1.89),('16273','2013-04-17','08:25:00',1.99),('16273','2013-04-17','08:30:00',2.07),('16273','2013-04-17','08:35:00',2.14),('16273','2013-04-17','08:40:00',2.25),('16273','2013-04-17','08:45:00',2.32),('16273','2013-04-17','08:50:00',2.42),('16273','2013-04-17','08:55:00',2.49),('16273','2013-04-17','09:00:00',2.55),('16273','2013-04-17','09:05:00',2.61),('16273','2013-04-17','09:10:00',2.68),('16273','2013-04-17','09:15:00',2.75),('16273','2013-04-17','09:20:00',2.8),('16273','2013-04-17','09:25:00',2.87),('16273','2013-04-17','09:30:00',2.92),('16273','2013-04-17','09:35:00',2.98),('16273','2013-04-17','09:40:00',3.06),('16273','2013-04-17','09:45:00',3.11),('16273','2013-04-17','09:50:00',3.14),('16273','2013-04-17','09:55:00',3.23),('16273','2013-04-17','10:00:00',3.25),('16273','2013-04-17','10:05:00',3.33),('16273','2013-04-17','10:10:00',3.36),('16273','2013-04-17','10:15:00',3.41),('16273','2013-04-17','10:20:00',3.43),('16273','2013-04-17','10:25:00',3.47),('16273','2013-04-17','10:30:00',3.45),('16273','2013-04-17','10:35:00',3.54),('16273','2013-04-17','10:40:00',3.57),('16273','2013-04-17','10:45:00',3.63),('16273','2013-04-17','10:50:00',3.65),('16273','2013-04-17','10:55:00',3.67),('16273','2013-04-17','11:00:00',3.69),('16273','2013-04-17','11:05:00',3.72),('16273','2013-04-17','11:10:00',3.74),('16273','2013-04-17','11:15:00',3.78),('16273','2013-04-17','11:20:00',3.8),('16273','2013-04-17','11:25:00',3.82),('16273','2013-04-17','11:30:00',3.84),('16273','2013-04-17','11:35:00',3.83),('16273','2013-04-17','11:40:00',3.85),('16273','2013-04-17','11:45:00',3.86),('16273','2013-04-17','11:50:00',3.87),('16273','2013-04-17','11:55:00',3.88),('16273','2013-04-17','12:00:00',3.89),('16273','2013-04-17','12:05:00',3.88),('16273','2013-04-17','12:10:00',3.88),('16273','2013-04-17','12:15:00',3.89),('16273','2013-04-17','12:20:00',3.89),('16273','2013-04-17','12:25:00',3.89),('16273','2013-04-17','12:30:00',3.89),('16273','2013-04-17','12:35:00',3.89),('16273','2013-04-17','12:40:00',3.88),('16273','2013-04-17','12:45:00',3.9),('16273','2013-04-17','12:50:00',3.89),('16273','2013-04-17','12:55:00',3.92),('16273','2013-04-17','13:00:00',3.7),('16273','2013-04-17','13:05:00',3.35),('16273','2013-04-17','13:10:00',3.8),('16273','2013-04-17','13:15:00',3.89),('16273','2013-04-17','13:20:00',3.92),('16273','2013-04-17','13:25:00',3.84),('16273','2013-04-17','13:30:00',3.75),('16273','2013-04-17','13:35:00',3.84),('16273','2013-04-17','13:40:00',3.88),('16273','2013-04-17','13:45:00',3.82),('16273','2013-04-17','13:50:00',3.72),('16273','2013-04-17','13:55:00',3.45),('16273','2013-04-17','14:00:00',3.26),('16273','2013-04-17','14:05:00',2.57),('16273','2013-04-17','14:10:00',3.58),('16273','2013-04-17','14:15:00',3.17),('16273','2013-04-17','14:20:00',3.95),('16273','2013-04-17','14:25:00',3.78),('16273','2013-04-17','14:30:00',3.54),('16273','2013-04-17','14:35:00',3.67),('16273','2013-04-17','14:40:00',3.83),('16273','2013-04-17','14:45:00',2.53),('16273','2013-04-17','14:50:00',2.32),('16273','2013-04-17','14:55:00',1.75),('16273','2013-04-17','15:00:00',1.63),('16273','2013-04-17','15:05:00',2.24),('16273','2013-04-17','15:10:00',3.03),('16273','2013-04-17','15:15:00',2.08),('16273','2013-04-17','15:20:00',2.33),('16273','2013-04-17','15:25:00',1.19),('16273','2013-04-17','15:30:00',1.82),('16273','2013-04-17','15:35:00',2.53),('16273','2013-04-17','15:40:00',3.02),('16273','2013-04-17','15:45:00',2.82),('16273','2013-04-17','15:50:00',2.71),('16273','2013-04-17','15:55:00',2.33),('16273','2013-04-17','16:00:00',2.71),('16273','2013-04-17','16:05:00',2.61),('16273','2013-04-17','16:10:00',2.42),('16273','2013-04-17','16:15:00',2.38),('16273','2013-04-17','16:20:00',2.19),('16273','2013-04-17','16:25:00',2.18),('16273','2013-04-17','16:30:00',2.1),('16273','2013-04-17','16:35:00',2.06),('16273','2013-04-17','16:40:00',1.82),('16273','2013-04-17','16:45:00',1.78),('16273','2013-04-17','16:50:00',1.77),('16273','2013-04-17','16:55:00',1.67),('16273','2013-04-17','17:00:00',1.59),('16273','2013-04-17','17:05:00',1.5),('16273','2013-04-17','17:10:00',1.42),('16273','2013-04-17','17:15:00',1.35),('16273','2013-04-17','17:20:00',1.27),('16273','2013-04-17','17:25:00',1.19),('16273','2013-04-17','17:30:00',1.12),('16273','2013-04-17','17:35:00',1.04),('16273','2013-04-16','07:45:00',1.06),('16273','2013-04-16','07:50:00',1.02),('16273','2013-04-16','07:55:00',1.22),('16273','2013-04-16','08:00:00',1.32),('16273','2013-04-16','08:05:00',1.46),('16273','2013-04-16','08:10:00',1.42),('16273','2013-04-16','08:45:00',1.04),('16273','2013-04-16','09:00:00',2.26),('16273','2013-04-16','09:05:00',2.55),('16273','2013-04-16','09:10:00',2.59),('16273','2013-04-16','09:15:00',2.85),('16273','2013-04-16','09:20:00',2.09),('16273','2013-04-16','09:25:00',1.51),('16273','2013-04-16','09:30:00',1.86),('16273','2013-04-16','09:35:00',1.64),('16273','2013-04-16','09:40:00',1.83),('16273','2013-04-16','09:45:00',1.72),('16273','2013-04-16','09:50:00',1.64),('16273','2013-04-16','09:55:00',1.68),('16273','2013-04-16','10:00:00',1.66),('16273','2013-04-16','10:05:00',1.4),('16273','2013-04-16','10:10:00',1.29),('16273','2013-04-16','10:15:00',1.32),('16273','2013-04-16','10:20:00',1.32),('16273','2013-04-16','10:25:00',1.33),('16273','2013-04-16','10:30:00',1.3),('16273','2013-04-16','10:35:00',1.33),('16273','2013-04-16','10:40:00',1.4),('16273','2013-04-16','10:45:00',1.45),('16273','2013-04-16','10:50:00',1.44),('16273','2013-04-16','10:55:00',1.42),('16273','2013-04-16','11:00:00',1.5),('16273','2013-04-16','11:05:00',1.59),('16273','2013-04-16','11:10:00',1.66),('16273','2013-04-16','11:15:00',1.69),('16273','2013-04-16','11:20:00',1.7),('16273','2013-04-16','11:25:00',1.77),('16273','2013-04-16','11:30:00',1.74),('16273','2013-04-16','11:35:00',1.61),('16273','2013-04-16','11:40:00',1.83),('16273','2013-04-16','11:45:00',2.28),('16273','2013-04-16','11:50:00',2.36),('16273','2013-04-16','11:55:00',2.6),('16273','2013-04-16','12:00:00',2.69),('16273','2013-04-16','12:05:00',3.25),('16273','2013-04-16','12:10:00',3.41),('16273','2013-04-16','12:15:00',3.35),('16273','2013-04-16','12:20:00',3.48),('16273','2013-04-16','12:25:00',3.37),('16273','2013-04-16','12:30:00',3.68),('16273','2013-04-16','12:35:00',3.09),('16273','2013-04-16','12:40:00',3.52),('16273','2013-04-16','12:45:00',3.49),('16273','2013-04-16','12:50:00',3.5),('16273','2013-04-16','12:55:00',3.42),('16273','2013-04-16','13:00:00',3.76),('16273','2013-04-16','13:05:00',3.73),('16273','2013-04-16','13:10:00',3.68),('16273','2013-04-16','13:15:00',3.76),('16273','2013-04-16','13:20:00',3.77),('16273','2013-04-16','13:25:00',3.74),('16273','2013-04-16','13:30:00',3.75),('16273','2013-04-16','13:35:00',3.72),('16273','2013-04-16','13:40:00',3.71),('16273','2013-04-16','13:45:00',3.73),('16273','2013-04-16','13:50:00',3.68),('16273','2013-04-16','13:55:00',3.65),('16273','2013-04-16','14:00:00',3.62),('16273','2013-04-16','14:05:00',3.53),('16273','2013-04-16','14:10:00',3.56),('16273','2013-04-16','14:15:00',3.59),('16273','2013-04-16','14:20:00',3.3),('16273','2013-04-16','14:25:00',2.85),('16273','2013-04-16','14:30:00',3.04),('16273','2013-04-16','14:35:00',2.46),('16273','2013-04-16','14:40:00',3.19),('16273','2013-04-16','14:45:00',3.39),('16273','2013-04-16','14:50:00',3.34),('16273','2013-04-16','14:55:00',3.24),('16273','2013-04-16','15:00:00',3.21),('16273','2013-04-16','15:05:00',3.16),('16273','2013-04-16','15:10:00',2.76),('16273','2013-04-16','15:15:00',2.53),('16273','2013-04-16','15:20:00',2.47),('16273','2013-04-16','15:25:00',2.87),('16273','2013-04-16','15:30:00',2.89),('16273','2013-04-16','15:35:00',2.79),('16273','2013-04-16','15:40:00',2.74),('16273','2013-04-16','15:45:00',2.67),('16273','2013-04-16','15:50:00',2.6),('16273','2013-04-16','15:55:00',2.52),('16273','2013-04-16','16:00:00',2.45),('16273','2013-04-16','16:05:00',2.38),('16273','2013-04-16','16:10:00',2.31),('16273','2013-04-16','16:15:00',2.24),('16273','2013-04-16','16:20:00',2.17),('16273','2013-04-16','16:25:00',1.99),('16273','2013-04-16','16:30:00',1.94),('16273','2013-04-16','16:35:00',1.97),('16273','2013-04-16','16:40:00',1.91),('16273','2013-04-16','16:45:00',1.71),('16273','2013-04-16','16:50:00',1.77),('16273','2013-04-16','16:55:00',1.67),('16273','2013-04-16','17:00:00',1.58),('16273','2013-04-16','17:05:00',1.5),('16273','2013-04-16','17:10:00',1.34),('16273','2013-04-16','17:15:00',1.35),('16273','2013-04-16','17:20:00',1.29),('16273','2013-04-16','17:25:00',1.22),('16273','2013-04-16','17:30:00',1.17),('16273','2013-04-16','17:35:00',1.1),('16273','2013-04-16','17:40:00',1.02),('16273','2013-04-15','07:40:00',1.1),('16273','2013-04-15','07:45:00',1.18),('16273','2013-04-15','07:50:00',1.11),('16273','2013-04-15','07:55:00',1.4),('16273','2013-04-15','08:00:00',1.5),('16273','2013-04-15','08:05:00',1.61),('16273','2013-04-15','08:10:00',1.74),('16273','2013-04-15','08:15:00',1.84),('16273','2013-04-15','08:20:00',1.93),('16273','2013-04-15','08:25:00',2.02),('16273','2013-04-15','08:30:00',2.1),('16273','2013-04-15','08:35:00',2.18),('16273','2013-04-15','08:40:00',2.27),('16273','2013-04-15','08:45:00',2.35),('16273','2013-04-15','08:50:00',2.42),('16273','2013-04-15','08:55:00',2.51),('16273','2013-04-15','09:00:00',2.58),('16273','2013-04-15','09:05:00',2.66),('16273','2013-04-15','09:10:00',2.74),('16273','2013-04-15','09:15:00',2.81),('16273','2013-04-15','09:20:00',2.87),('16273','2013-04-15','09:25:00',2.92),('16273','2013-04-15','09:30:00',2.99),('16273','2013-04-15','09:35:00',3.05),('16273','2013-04-15','09:40:00',3.09),('16273','2013-04-15','09:45:00',3.14),('16273','2013-04-15','09:50:00',3.2),('16273','2013-04-15','09:55:00',3.24),('16273','2013-04-15','10:00:00',3.29),('16273','2013-04-15','10:05:00',3.33),('16273','2013-04-15','10:10:00',3.37),('16273','2013-04-15','10:15:00',3.43),('16273','2013-04-15','10:20:00',3.47),('16273','2013-04-15','10:25:00',3.49),('16273','2013-04-15','10:30:00',3.51),('16273','2013-04-15','10:35:00',3.55),('16273','2013-04-15','10:40:00',3.59),('16273','2013-04-15','10:45:00',3.62),('16273','2013-04-15','10:50:00',3.65),('16273','2013-04-15','10:55:00',3.68),('16273','2013-04-15','11:00:00',3.7),('16273','2013-04-15','11:05:00',3.73),('16273','2013-04-15','11:10:00',3.76),('16273','2013-04-15','11:15:00',3.78),('16273','2013-04-15','11:20:00',3.8),('16273','2013-04-15','11:25:00',3.82),('16273','2013-04-15','11:30:00',3.84),('16273','2013-04-15','11:35:00',3.85),('16273','2013-04-15','11:40:00',3.86),('16273','2013-04-15','11:45:00',3.88),('16273','2013-04-15','11:50:00',3.91),('16273','2013-04-15','11:55:00',3.91),('16273','2013-04-15','12:00:00',3.92),('16273','2013-04-15','12:05:00',3.92),('16273','2013-04-15','12:10:00',3.91),('16273','2013-04-15','12:15:00',3.91),('16273','2013-04-15','12:20:00',3.91),('16273','2013-04-15','12:25:00',3.93),('16273','2013-04-15','12:30:00',3.92),('16273','2013-04-15','12:35:00',3.91),('16273','2013-04-15','12:40:00',3.91),('16273','2013-04-15','12:45:00',3.9),('16273','2013-04-15','12:50:00',3.88),('16273','2013-04-15','12:55:00',3.86),('16273','2013-04-15','13:00:00',3.86),('16273','2013-04-15','13:05:00',3.85),('16273','2013-04-15','13:10:00',3.82),('16273','2013-04-15','13:15:00',3.81),('16273','2013-04-15','13:20:00',3.84),('16273','2013-04-15','13:25:00',3.88),('16273','2013-04-15','13:30:00',3.88),('16273','2013-04-15','13:35:00',3.86),('16273','2013-04-15','13:40:00',3.85),('16273','2013-04-15','13:45:00',3.86),('16273','2013-04-15','13:50:00',3.81),('16273','2013-04-15','13:55:00',3.79),('16273','2013-04-15','14:00:00',3.75),('16273','2013-04-15','14:05:00',3.72),('16273','2013-04-15','14:10:00',3.66),('16273','2013-04-15','14:15:00',3.63),('16273','2013-04-15','14:20:00',3.59),('16273','2013-04-15','14:25:00',3.54),('16273','2013-04-15','14:30:00',3.5),('16273','2013-04-15','14:35:00',3.46),('16273','2013-04-15','14:40:00',3.42),('16273','2013-04-15','14:45:00',3.38),('16273','2013-04-15','14:50:00',3.34),('16273','2013-04-15','14:55:00',3.27),('16273','2013-04-15','15:00:00',3.23),('16273','2013-04-15','15:05:00',3.2),('16273','2013-04-15','15:10:00',3.15),('16273','2013-04-15','15:15:00',3.09),('16273','2013-04-15','15:20:00',3.03),('16273','2013-04-15','15:25:00',2.97),('16273','2013-04-15','15:30:00',2.91),('16273','2013-04-15','15:35:00',2.85),('16273','2013-04-15','15:40:00',2.77),('16273','2013-04-15','15:45:00',2.7),('16273','2013-04-15','15:50:00',2.63),('16273','2013-04-15','15:55:00',2.56),('16273','2013-04-15','16:00:00',2.49),('16273','2013-04-15','16:05:00',2.4),('16273','2013-04-15','16:10:00',2.33),('16273','2013-04-15','16:15:00',2.26),('16273','2013-04-15','16:20:00',2.2),('16273','2013-04-15','16:25:00',2.12),('16273','2013-04-15','16:30:00',2.04),('16273','2013-04-15','16:35:00',1.97),('16273','2013-04-15','16:40:00',1.88),('16273','2013-04-15','16:45:00',1.81),('16273','2013-04-15','16:50:00',1.73),('16273','2013-04-15','16:55:00',1.65),('16273','2013-04-15','17:00:00',1.57),('16273','2013-04-15','17:05:00',1.48),('16273','2013-04-15','17:10:00',1.4),('16273','2013-04-15','17:15:00',1.32),('16273','2013-04-15','17:20:00',1.24),('16273','2013-04-15','17:25:00',1.17),('16273','2013-04-15','17:30:00',1.1),('16273','2013-04-15','17:35:00',1.03),('16273','2013-04-14','07:45:00',1.07),('16273','2013-04-14','07:50:00',1.06),('16273','2013-04-14','07:55:00',1.31),('16273','2013-04-14','08:00:00',1.4),('16273','2013-04-14','08:05:00',1.45),('16273','2013-04-14','08:10:00',1.61),('16273','2013-04-14','08:15:00',1.66),('16273','2013-04-14','08:20:00',1.74),('16273','2013-04-14','08:25:00',1.81),('16273','2013-04-14','08:30:00',1.86),('16273','2013-04-14','08:35:00',1.95),('16273','2013-04-14','08:40:00',2.04),('16273','2013-04-14','08:45:00',2.06),('16273','2013-04-14','08:50:00',2.24),('16273','2013-04-14','08:55:00',2.33),('16273','2013-04-14','09:00:00',2.39),('16273','2013-04-14','09:05:00',2.44),('16273','2013-04-14','09:10:00',2.51),('16273','2013-04-14','09:15:00',2.58),('16273','2013-04-14','09:20:00',2.64),('16273','2013-04-14','09:25:00',2.71),('16273','2013-04-14','09:30:00',2.79),('16273','2013-04-14','09:35:00',2.86),('16273','2013-04-14','09:40:00',2.94),('16273','2013-04-14','09:45:00',3),('16273','2013-04-14','09:50:00',3.06),('16273','2013-04-14','09:55:00',3.12),('16273','2013-04-14','10:00:00',3.18),('16273','2013-04-14','10:05:00',3.23),('16273','2013-04-14','10:10:00',3.28),('16273','2013-04-14','10:15:00',3.32),('16273','2013-04-14','10:20:00',3.36),('16273','2013-04-14','10:25:00',3.39),('16273','2013-04-14','10:30:00',3.43),('16273','2013-04-14','10:35:00',3.48),('16273','2013-04-14','10:40:00',3.46),('16273','2013-04-14','10:45:00',3.58),('16273','2013-04-14','10:50:00',3.59),('16273','2013-04-14','10:55:00',3.65),('16273','2013-04-14','11:00:00',3.7),('16273','2013-04-14','11:05:00',3.72),('16273','2013-04-14','11:10:00',3.73),('16273','2013-04-14','11:15:00',3.75),('16273','2013-04-14','11:20:00',3.77),('16273','2013-04-14','11:25:00',3.79),('16273','2013-04-14','11:30:00',3.79),('16273','2013-04-14','11:35:00',3.81),('16273','2013-04-14','11:40:00',3.79),('16273','2013-04-14','11:45:00',3.82),('16273','2013-04-14','11:50:00',3.81),('16273','2013-04-14','11:55:00',3.76),('16273','2013-04-14','12:00:00',3.86),('16273','2013-04-14','12:05:00',3.87),('16273','2013-04-14','12:10:00',3.84),('16273','2013-04-14','12:15:00',3.88),('16273','2013-04-14','12:20:00',3.85),('16273','2013-04-14','12:25:00',3.88),('16273','2013-04-14','12:30:00',3.88),('16273','2013-04-14','12:35:00',3.84),('16273','2013-04-14','12:40:00',3.89),('16273','2013-04-14','12:45:00',3.89),('16273','2013-04-14','12:50:00',3.86),('16273','2013-04-14','12:55:00',3.8),('16273','2013-04-14','13:00:00',3.75),('16273','2013-04-14','13:05:00',2.84),('16273','2013-04-14','13:10:00',3.95),('16273','2013-04-14','13:15:00',3.94),('16273','2013-04-14','13:20:00',3.94),('16273','2013-04-14','13:25:00',1.78),('16273','2013-04-14','13:30:00',3.75),('16273','2013-04-14','13:35:00',3.46),('16273','2013-04-14','13:40:00',3.74),('16273','2013-04-14','13:45:00',3.8),('16273','2013-04-14','13:50:00',3.73),('16273','2013-04-14','13:55:00',3.38),('16273','2013-04-14','14:00:00',3.41),('16273','2013-04-14','14:05:00',3.36),('16273','2013-04-14','14:10:00',3.47),('16273','2013-04-14','14:15:00',3.04),('16273','2013-04-14','14:20:00',3.47),('16273','2013-04-14','14:25:00',3.43),('16273','2013-04-14','14:30:00',3.32),('16273','2013-04-14','14:35:00',3.31),('16273','2013-04-14','14:40:00',3.27),('16273','2013-04-14','14:45:00',3.25),('16273','2013-04-14','14:50:00',3.26),('16273','2013-04-14','14:55:00',3.18),('16273','2013-04-14','15:00:00',3.14),('16273','2013-04-14','15:05:00',3.1),('16273','2013-04-14','15:10:00',3.05),('16273','2013-04-14','15:15:00',2.99),('16273','2013-04-14','15:20:00',2.89),('16273','2013-04-14','15:25:00',2.86),('16273','2013-04-14','15:30:00',2.84),('16273','2013-04-14','15:35:00',2.76),('16273','2013-04-14','15:40:00',2.69),('16273','2013-04-14','15:45:00',2.64),('16273','2013-04-14','15:50:00',2.59),('16273','2013-04-14','15:55:00',2.53),('16273','2013-04-14','16:00:00',2.45),('16273','2013-04-14','16:05:00',2.35),('16273','2013-04-14','16:10:00',2.26),('16273','2013-04-14','16:15:00',2.2),('16273','2013-04-14','16:20:00',2.14),('16273','2013-04-14','16:25:00',2.07),('16273','2013-04-14','16:30:00',2),('16273','2013-04-14','16:35:00',1.92),('16273','2013-04-14','16:40:00',1.84),('16273','2013-04-14','16:45:00',1.76),('16273','2013-04-14','16:50:00',1.67),('16273','2013-04-14','16:55:00',1.6),('16273','2013-04-14','17:00:00',1.52),('16273','2013-04-14','17:05:00',1.43),('16273','2013-04-14','17:10:00',1.37),('16273','2013-04-14','17:15:00',1.29),('16273','2013-04-14','17:20:00',1.22),('16273','2013-04-14','17:25:00',1.15),('16273','2013-04-14','17:30:00',1.08),('16273','2013-04-14','17:35:00',1.01),('16273','2013-04-13','07:50:00',1.1),('16273','2013-04-13','07:55:00',1.06),('16273','2013-04-13','08:00:00',1.36),('16273','2013-04-13','08:05:00',1.42),('16273','2013-04-13','08:55:00',1.64),('16273','2013-04-13','09:00:00',2.44),('16273','2013-04-13','09:05:00',2.49),('16273','2013-04-13','09:10:00',2.62),('16273','2013-04-13','09:15:00',2.59),('16273','2013-04-13','09:20:00',2.71),('16273','2013-04-13','09:25:00',2.76),('16273','2013-04-13','09:30:00',2.79),('16273','2013-04-13','09:35:00',2.14),('16273','2013-04-13','09:40:00',1.85),('16273','2013-04-13','09:45:00',2.16),('16273','2013-04-13','09:50:00',3.24),('16273','2013-04-13','09:55:00',2.43),('16273','2013-04-13','10:05:00',1.62),('16273','2013-04-13','10:10:00',1.34),('16273','2013-04-13','10:15:00',1.15),('16273','2013-04-13','10:20:00',1.57),('16273','2013-04-13','10:25:00',3.91),('16273','2013-04-13','10:30:00',3.68),('16273','2013-04-13','10:35:00',3.64),('16273','2013-04-13','10:40:00',3.72),('16273','2013-04-13','10:45:00',3.38),('16273','2013-04-13','10:50:00',3.37),('16273','2013-04-13','10:55:00',3.7),('16273','2013-04-13','11:00:00',4.04),('16273','2013-04-13','11:05:00',3.99),('16273','2013-04-13','11:10:00',4.1),('16273','2013-04-13','11:15:00',3.3),('16273','2013-04-13','11:20:00',2.3),('16273','2013-04-13','11:25:00',4.1),('16273','2013-04-13','11:30:00',4.07),('16273','2013-04-13','11:35:00',3.75),('16273','2013-04-13','11:40:00',3.28),('16273','2013-04-13','11:45:00',4.1),('16273','2013-04-13','11:50:00',3.5),('16273','2013-04-13','11:55:00',3.18),('16273','2013-04-13','12:00:00',4.13),('16273','2013-04-13','12:05:00',2.2),('16273','2013-04-13','12:10:00',3.88),('16273','2013-04-13','12:15:00',4.18),('16273','2013-04-13','12:20:00',4.24),('16273','2013-04-13','12:25:00',4.2),('16273','2013-04-13','12:30:00',4.12),('16273','2013-04-13','12:35:00',2.36),('16273','2013-04-13','12:40:00',4.29),('16273','2013-04-13','12:45:00',4.05),('16273','2013-04-13','12:50:00',3.89),('16273','2013-04-13','12:55:00',3.95),('16273','2013-04-13','13:00:00',3.94),('16273','2013-04-13','13:05:00',4.08),('16273','2013-04-13','13:10:00',3.97),('16273','2013-04-13','13:15:00',3.76),('16273','2013-04-13','13:20:00',3.81),('16273','2013-04-13','13:25:00',3.82),('16273','2013-04-13','13:30:00',3.48),('16273','2013-04-13','13:35:00',3.13),('16273','2013-04-13','13:40:00',2.95),('16273','2013-04-13','13:45:00',3.3),('16273','2013-04-13','13:50:00',3.25),('16273','2013-04-13','13:55:00',3.28),('16273','2013-04-13','14:00:00',3.13),('16273','2013-04-13','14:05:00',3.15),('16273','2013-04-13','14:10:00',3.12),('16273','2013-04-13','14:15:00',3.11),('16273','2013-04-13','14:20:00',3.16),('16273','2013-04-13','14:25:00',3.31),('16273','2013-04-13','14:30:00',3.42),('16273','2013-04-13','14:35:00',3.38),('16273','2013-04-13','14:40:00',3.33),('16273','2013-04-13','14:45:00',3.23),('16273','2013-04-13','14:50:00',3.18),('16273','2013-04-13','14:55:00',3.03),('16273','2013-04-13','15:00:00',2.84),('16273','2013-04-13','15:05:00',2.87),('16273','2013-04-13','15:10:00',2.66),('16273','2013-04-13','15:15:00',2.57),('16273','2013-04-13','15:20:00',2.42),('16273','2013-04-13','15:25:00',2.44),('16273','2013-04-13','15:30:00',2.36),('16273','2013-04-13','15:35:00',2.38),('16273','2013-04-13','15:40:00',2.42),('16273','2013-04-13','15:45:00',2.43),('16273','2013-04-13','15:50:00',2.37),('16273','2013-04-13','15:55:00',2.24),('16273','2013-04-13','16:00:00',2.25),('16273','2013-04-13','16:05:00',2.04),('16273','2013-04-13','16:10:00',2.03),('16273','2013-04-13','16:15:00',1.95),('16273','2013-04-13','16:20:00',1.92),('16273','2013-04-13','16:25:00',1.71),('16273','2013-04-13','16:30:00',1.69),('16273','2013-04-13','16:35:00',1.53),('16273','2013-04-13','16:40:00',1.47),('16273','2013-04-13','16:45:00',1.53),('16273','2013-04-13','16:50:00',1.34),('16273','2013-04-13','16:55:00',1.15),('16273','2013-04-13','17:00:00',1.16),('16273','2013-04-13','17:05:00',1.37),('16273','2013-04-13','17:10:00',1.57),('16273','2013-04-13','17:15:00',1.31),('16273','2013-04-13','17:20:00',1.3),('16273','2013-04-13','17:25:00',1.26),('16273','2013-04-13','17:30:00',1.13),('16273','2013-04-13','17:35:00',1.12),('16273','2013-04-12','08:10:00',1.12),('16273','2013-04-12','08:15:00',1.93),('16273','2013-04-12','08:20:00',1.67),('16273','2013-04-12','08:25:00',1.15),('16273','2013-04-12','08:30:00',1.51),('16273','2013-04-12','08:35:00',1.79),('16273','2013-04-12','08:40:00',1.38),('16273','2013-04-12','08:45:00',1.59),('16273','2013-04-12','08:50:00',1.28),('16273','2013-04-12','08:55:00',1.53),('16273','2013-04-12','09:00:00',1.3),('16273','2013-04-12','09:15:00',1.74),('16273','2013-04-12','09:21:00',1.76),('16273','2013-04-12','09:25:00',1.44),('16273','2013-04-12','09:30:00',2.1),('16273','2013-04-12','09:35:00',3.33),('16273','2013-04-12','09:40:00',1.65),('16273','2013-04-12','09:45:00',1.17),('16273','2013-04-12','09:50:00',1.33),('16273','2013-04-12','09:55:00',1.07),('16273','2013-04-12','10:00:00',1.03),('16273','2013-04-12','10:05:00',1.14),('16273','2013-04-12','10:10:00',1.22),('16273','2013-04-12','10:15:00',1.14),('16273','2013-04-12','10:20:00',1.19),('16273','2013-04-12','10:25:00',1.12),('16273','2013-04-12','10:30:00',1.14),('16273','2013-04-12','10:35:00',1.52),('16273','2013-04-12','10:40:00',1.86),('16273','2013-04-12','10:45:00',3.44),('16273','2013-04-12','10:50:00',2.78),('16273','2013-04-12','10:55:00',3),('16273','2013-04-12','11:01:00',4.37),('16273','2013-04-12','11:05:00',3.83),('16273','2013-04-12','11:10:00',3.34),('16273','2013-04-12','11:15:00',4.19),('16273','2013-04-12','11:20:00',2.92),('16273','2013-04-12','11:25:00',4.08),('16273','2013-04-12','11:30:00',4.17),('16273','2013-04-12','11:35:00',3.54),('16273','2013-04-12','11:40:00',2.75),('16273','2013-04-12','11:45:00',3.98),('16273','2013-04-12','11:50:00',3.07),('16273','2013-04-12','11:55:00',4.33),('16273','2013-04-12','12:00:00',3.97),('16273','2013-04-12','12:05:00',3.91),('16273','2013-04-12','12:10:00',4.08),('16273','2013-04-12','12:15:00',4.13),('16273','2013-04-12','12:20:00',4.12),('16273','2013-04-12','12:25:00',4.23),('16273','2013-04-12','12:30:00',4.12),('16273','2013-04-12','12:35:00',3.94),('16273','2013-04-12','12:40:00',3.93),('16273','2013-04-12','12:45:00',3.63),('16273','2013-04-12','12:50:00',4.03),('16273','2013-04-12','12:55:00',3.95),('16273','2013-04-12','13:00:00',4),('16273','2013-04-12','13:05:00',4.01),('16273','2013-04-12','13:10:00',3.99),('16273','2013-04-12','13:15:00',3.95),('16273','2013-04-12','13:20:00',3.92),('16273','2013-04-12','13:25:00',3.91),('16273','2013-04-12','13:30:00',3.88),('16273','2013-04-12','13:35:00',3.84),('16273','2013-04-12','13:40:00',3.85),('16273','2013-04-12','13:45:00',3.85),('16273','2013-04-12','13:50:00',3.8),('16273','2013-04-12','13:55:00',3.75),('16273','2013-04-12','14:00:00',3.72),('16273','2013-04-12','14:05:00',3.68),('16273','2013-04-12','14:10:00',3.62),('16273','2013-04-12','14:15:00',3.54),('16273','2013-04-12','14:20:00',3.56),('16273','2013-04-12','14:25:00',3.52),('16273','2013-04-12','14:30:00',3.47),('16273','2013-04-12','14:35:00',3.43),('16273','2013-04-12','14:40:00',3.39),('16273','2013-04-12','14:45:00',3.35),('16273','2013-04-12','14:50:00',3.29),('16273','2013-04-12','14:55:00',3.23),('16273','2013-04-12','15:00:00',3.19),('16273','2013-04-12','15:05:00',3.15),('16273','2013-04-12','15:10:00',3.1),('16273','2013-04-12','15:15:00',3.03),('16273','2013-04-12','15:20:00',2.98),('16273','2013-04-12','15:25:00',2.92),('16273','2013-04-12','15:30:00',2.85),('16273','2013-04-12','15:35:00',2.78),('16273','2013-04-12','15:40:00',2.72),('16273','2013-04-12','15:45:00',2.67),('16273','2013-04-12','15:50:00',2.6),('16273','2013-04-12','15:55:00',2.53),('16273','2013-04-12','16:00:00',2.46),('16273','2013-04-12','16:05:00',2.41),('16273','2013-04-12','16:10:00',2.3),('16273','2013-04-12','16:15:00',2.34),('16273','2013-04-12','16:20:00',2.18),('16273','2013-04-12','16:25:00',1.8),('16273','2013-04-12','16:30:00',2.24),('16273','2013-04-12','16:35:00',2.19),('16273','2013-04-12','16:40:00',1.96),('16273','2013-04-12','16:45:00',1.78),('16273','2013-04-12','16:50:00',1.7),('16273','2013-04-12','16:55:00',1.32),('16273','2013-04-12','17:05:00',1.45),('16273','2013-04-12','17:10:00',1.45),('16273','2013-04-12','17:20:00',1.44),('16273','2013-04-12','17:25:00',1.29),('16273','2013-04-12','17:30:00',1.07),('16273','2013-04-12','17:35:00',1.09),('16273','2014-03-28','07:05:00',1.04),('16273','2014-03-28','07:10:00',1.26),('16273','2014-03-28','07:15:00',1.34),('16273','2014-03-28','07:20:00',1.2),('16273','2014-03-28','07:25:00',1.4),('16273','2014-03-28','07:30:00',1.62),('16273','2014-03-28','07:35:00',1.79),('16273','2014-03-28','07:40:00',1.88),('16273','2014-03-28','07:45:00',1.95),('16273','2014-03-28','07:50:00',2.03),('16273','2014-03-28','07:55:00',2.1),('16273','2014-03-28','08:00:00',2.19),('16273','2014-03-28','08:05:00',2.29),('16273','2014-03-28','08:10:00',2.37),('16273','2014-03-28','08:15:00',2.43),('16273','2014-03-28','08:20:00',2.47),('16273','2014-03-28','08:25:00',2.54),('16273','2014-03-28','08:30:00',2.62),('16273','2014-03-28','08:35:00',2.68),('16273','2014-03-28','08:40:00',2.76),('16273','2014-03-28','08:45:00',2.83),('16273','2014-03-28','08:50:00',2.9),('16273','2014-03-28','08:55:00',3.02),('16273','2014-03-28','09:00:00',3.13),('16273','2014-03-28','09:05:00',3.27),('16273','2014-03-28','09:10:00',3.41),('16273','2014-03-28','09:15:00',3.01),('16273','2014-03-28','09:20:00',2.84),('16273','2014-03-28','09:25:00',3.72),('16273','2014-03-28','09:30:00',3.47),('16273','2014-03-28','09:35:00',2.15),('16273','2014-03-28','09:40:00',2.72),('16273','2014-03-28','09:45:00',2.61),('16273','2014-03-28','09:50:00',2.47),('16273','2014-03-28','09:55:00',3.18),('16273','2014-03-28','10:00:00',3.59),('16273','2014-03-28','10:05:00',3.62),('16273','2014-03-28','10:10:00',3.58),('16273','2014-03-28','10:15:00',3.48),('16273','2014-03-28','10:20:00',3.46),('16273','2014-03-28','10:25:00',3.66),('16273','2014-03-28','10:30:00',3.72),('16273','2014-03-28','10:35:00',3.79),('16273','2014-03-28','10:40:00',3.78),('16273','2014-03-28','10:45:00',3.7),('16273','2014-03-28','10:50:00',3.35),('16273','2014-03-28','10:55:00',3.75),('16273','2014-03-28','11:00:00',3.79),('16273','2014-03-28','11:05:00',3.82),('16273','2014-03-28','11:10:00',3.81),('16273','2014-03-28','11:15:00',3.83),('16273','2014-03-28','11:20:00',3.81),('16273','2014-03-28','11:25:00',3.67),('16273','2014-03-28','11:30:00',3.81),('16273','2014-03-28','11:35:00',3.87),('16273','2014-03-28','11:40:00',3.89),('16273','2014-03-28','11:45:00',3.88),('16273','2014-03-28','11:50:00',3.91),('16273','2014-03-28','11:55:00',4.03),('16273','2014-03-28','12:00:00',4.17),('16273','2014-03-28','12:05:00',3.17),('16273','2014-03-28','12:15:00',2.59),('16273','2014-03-28','12:20:00',4.17),('16273','2014-03-28','12:25:00',3.3),('16273','2014-03-28','12:30:00',3.73),('16273','2014-03-28','12:35:00',3.24),('16273','2014-03-28','12:40:00',2.46),('16273','2014-03-28','12:45:00',3.96),('16273','2014-03-28','12:50:00',3.89),('16273','2014-03-28','12:55:00',3.93),('16273','2014-03-28','13:00:00',3.87),('16273','2014-03-28','13:05:00',2.89),('16273','2014-03-28','13:10:00',2.91),('16273','2014-03-28','13:15:00',1.77),('16273','2014-03-28','13:20:00',2.77),('16273','2014-03-28','13:25:00',2.07),('16273','2014-03-28','13:30:00',1.43),('16273','2014-03-28','13:35:00',2.3),('16273','2014-03-28','13:40:00',3.23),('16273','2014-03-28','13:45:00',3.36),('16273','2014-03-28','13:50:00',3.27),('16273','2014-03-28','13:55:00',3.2),('16273','2014-03-28','14:00:00',3.13),('16273','2014-03-28','14:05:00',3.08),('16273','2014-03-28','14:10:00',3.01),('16273','2014-03-28','14:15:00',2.94),('16273','2014-03-28','14:20:00',2.89),('16273','2014-03-28','14:25:00',2.83),('16273','2014-03-28','14:30:00',2.78),('16273','2014-03-28','14:35:00',2.72),('16273','2014-03-28','14:40:00',2.66),('16273','2014-03-28','14:45:00',2.58),('16273','2014-03-28','14:50:00',2.52),('16273','2014-03-28','14:55:00',2.43),('16273','2014-03-28','15:00:00',2.37),('16273','2014-03-28','15:05:00',2.3),('16273','2014-03-28','15:10:00',2.22),('16273','2014-03-28','15:15:00',2.15),('16273','2014-03-28','15:20:00',2.06),('16273','2014-03-28','15:25:00',1.97),('16273','2014-03-28','15:30:00',1.9),('16273','2014-03-28','15:35:00',1.84),('16273','2014-03-28','15:40:00',1.75),('16273','2014-03-28','15:45:00',1.68),('16273','2014-03-28','15:50:00',1.62),('16273','2014-03-28','15:55:00',1.57),('16273','2014-03-28','16:00:00',1.52),('16273','2014-03-28','16:05:00',1.46),('16273','2014-03-28','16:10:00',1.33),('16273','2014-03-28','16:15:00',1.25),('16273','2014-03-28','16:20:00',1.19),('16273','2014-03-28','16:25:00',1.16),('16273','2014-03-28','16:30:00',1.16),('16273','2013-04-11','07:45:00',1.02),('16273','2013-04-11','07:50:00',1.15),('16273','2013-04-11','07:55:00',1.11),('16273','2013-04-11','08:00:00',1.39),('16273','2013-04-11','08:05:00',1.5),('16273','2013-04-11','08:10:00',1.59),('16273','2013-04-11','08:15:00',1.66),('16273','2013-04-11','08:20:00',1.78),('16273','2013-04-11','08:25:00',1.85),('16273','2013-04-11','08:30:00',1.95),('16273','2013-04-11','08:35:00',2.02),('16273','2013-04-11','08:40:00',2.11),('16273','2013-04-11','08:45:00',2.2),('16273','2013-04-11','08:50:00',2.31),('16273','2013-04-11','08:55:00',2.36),('16273','2013-04-11','09:00:00',2.39),('16273','2013-04-11','09:05:00',2.49),('16273','2013-04-11','09:10:00',2.57),('16273','2013-04-11','09:15:00',2.63),('16273','2013-04-11','09:20:00',2.74),('16273','2013-04-11','09:25:00',2.79),('16273','2013-04-11','09:30:00',2.88),('16273','2013-04-11','09:35:00',2.78),('16273','2013-04-11','09:40:00',3.25),('16273','2013-04-11','09:45:00',2.84),('16273','2013-04-11','09:50:00',2.79),('16273','2013-04-11','10:00:00',2.56),('16273','2013-04-11','10:05:00',3.39),('16273','2013-04-11','10:10:00',3.18),('16273','2013-04-11','10:15:00',2.82),('16273','2013-04-11','10:20:00',3.58),('16273','2013-04-11','10:25:00',3.61),('16273','2013-04-11','10:30:00',3.71),('16273','2013-04-11','10:35:00',3.87),('16273','2013-04-11','10:40:00',3.82),('16273','2013-04-11','10:45:00',2.5),('16273','2013-04-11','10:50:00',1.19),('16273','2013-04-11','10:55:00',1.95),('16273','2013-04-11','11:00:00',1.38),('16273','2013-04-11','11:05:00',1.02),('16273','2013-04-11','11:10:00',1.47),('16273','2013-04-11','11:15:00',1.32),('16273','2013-04-11','11:20:00',1.46),('16273','2013-04-11','11:25:00',4.5),('16273','2013-04-11','11:30:00',4.1),('16273','2013-04-11','11:35:00',1.57),('16273','2013-04-11','11:40:00',1.89),('16273','2013-04-11','11:45:00',4.6),('16273','2013-04-11','11:50:00',2.96),('16273','2013-04-11','11:55:00',2.51),('16273','2013-04-11','12:00:00',2.24),('16273','2013-04-11','12:05:00',3.67),('16273','2013-04-11','12:10:00',2.61),('16273','2013-04-11','12:15:00',4.44),('16273','2013-04-11','12:20:00',3.06),('16273','2013-04-11','12:25:00',3.91),('16273','2013-04-11','12:30:00',4.24),('16273','2013-04-11','12:35:00',2.59),('16273','2013-04-11','12:40:00',2.24),('16273','2013-04-11','12:45:00',3.41),('16273','2013-04-11','12:50:00',4.23),('16273','2013-04-11','12:55:00',2.98),('16273','2013-04-11','13:00:00',2.71),('16273','2013-04-11','13:05:00',3.28),('16273','2013-04-11','13:10:00',3.96),('16273','2013-04-11','13:15:00',1.75),('16273','2013-04-11','13:20:00',4.08),('16273','2013-04-11','13:25:00',4.24),('16273','2013-04-11','13:30:00',2.34),('16273','2013-04-11','13:35:00',4.06),('16273','2013-04-11','13:40:00',2.33),('16273','2013-04-11','13:45:00',3.16),('16273','2013-04-11','13:50:00',4.21),('16273','2013-04-11','13:55:00',4),('16273','2013-04-11','14:00:00',3.32),('16273','2013-04-11','14:05:00',2.1),('16273','2013-04-11','14:10:00',4.05),('16273','2013-04-11','14:20:00',3.91),('16273','2013-04-11','14:25:00',2.87),('16273','2013-04-11','14:30:00',3.01),('16273','2013-04-11','14:35:00',3.65),('16273','2013-04-11','14:40:00',3.52),('16273','2013-04-11','14:45:00',3.47),('16273','2013-04-11','14:50:00',3.47),('16273','2013-04-11','14:55:00',3.37),('16273','2013-04-11','15:00:00',3.27),('16273','2013-04-11','15:05:00',2.98),('16273','2013-04-11','15:10:00',3.2),('16273','2013-04-11','15:15:00',3.04),('16273','2013-04-11','15:20:00',3.01),('16273','2013-04-11','15:25:00',2.96),('16273','2013-04-11','15:30:00',2.91),('16273','2013-04-11','15:35:00',2.86),('16273','2013-04-11','15:40:00',2.81),('16273','2013-04-11','15:45:00',2.72),('16273','2013-04-11','15:50:00',2.62),('16273','2013-04-11','15:55:00',2.56),('16273','2013-04-11','16:00:00',2.49),('16273','2013-04-11','16:05:00',2.42),('16273','2013-04-11','16:10:00',2.34),('16273','2013-04-11','16:15:00',2.27),('16273','2013-04-11','16:20:00',2.2),('16273','2013-04-11','16:25:00',2.12),('16273','2013-04-11','16:30:00',2.04),('16273','2013-04-11','16:35:00',1.96),('16273','2013-04-11','16:40:00',1.88),('16273','2013-04-11','16:45:00',1.81),('16273','2013-04-11','16:50:00',1.73),('16273','2013-04-11','16:55:00',1.64),('16273','2013-04-11','17:00:00',1.56),('16273','2013-04-11','17:05:00',1.48),('16273','2013-04-11','17:10:00',1.4),('16273','2013-04-11','17:15:00',1.32),('16273','2013-04-11','17:20:00',1.25),('16273','2013-04-11','17:25:00',1.18),('16273','2013-04-11','17:30:00',1.1),('16273','2013-04-11','17:35:00',1.03),('16273','2013-04-10','08:25:00',1.12),('16273','2013-04-10','08:45:00',1.22),('16273','2013-04-10','08:50:00',1.31),('16273','2013-04-10','08:55:00',1.08),('16273','2013-04-10','09:00:00',1.56),('16273','2013-04-10','09:05:00',2.58),('16273','2013-04-10','09:10:00',2.47),('16273','2013-04-10','09:15:00',2.62),('16273','2013-04-10','09:20:00',2.77),('16273','2013-04-10','09:25:00',2.85),('16273','2013-04-10','09:30:00',2.91),('16273','2013-04-10','09:35:00',2.99),('16273','2013-04-10','09:40:00',3.09),('16273','2013-04-10','09:45:00',3.17),('16273','2013-04-10','09:50:00',3.12),('16273','2013-04-10','09:55:00',3.29),('16273','2013-04-10','10:00:00',3.31),('16273','2013-04-10','10:05:00',2.79),('16273','2013-04-10','10:10:00',2.35),('16273','2013-04-10','10:15:00',3.02),('16273','2013-04-10','10:20:00',3.62),('16273','2013-04-10','10:25:00',2.14),('16273','2013-04-10','10:30:00',2.44),('16273','2013-04-10','10:40:00',2.82),('16273','2013-04-10','10:45:00',3.41),('16273','2013-04-10','10:50:00',2.52),('16273','2013-04-10','10:55:00',3.89),('16273','2013-04-10','11:00:00',3.78),('16273','2013-04-10','11:05:00',3.63),('16273','2013-04-10','11:10:00',2.15),('16273','2013-04-10','11:15:00',3.31),('16273','2013-04-10','11:20:00',3.67),('16273','2013-04-10','11:25:00',4.2),('16273','2013-04-10','11:30:00',4.1),('16273','2013-04-10','11:35:00',3.5),('16273','2013-04-10','11:40:00',4.06),('16273','2013-04-10','11:45:00',4.1),('16273','2013-04-10','11:50:00',4.1),('16273','2013-04-10','11:55:00',4.13),('16273','2013-04-10','12:00:00',4.07),('16273','2013-04-10','12:05:00',4.3),('16273','2013-04-10','12:10:00',2.8),('16273','2013-04-10','12:15:00',2.37),('16273','2013-04-10','12:20:00',1.99),('16273','2013-04-10','12:25:00',3.15),('16273','2013-04-10','12:30:00',3.76),('16273','2013-04-10','12:35:00',3.51),('16273','2013-04-10','12:40:00',4.44),('16273','2013-04-10','12:45:00',1.29),('16273','2013-04-10','12:50:00',3.99),('16273','2013-04-10','12:55:00',4.27),('16273','2013-04-10','13:00:00',3.79),('16273','2013-04-10','13:05:00',4.24),('16273','2013-04-10','13:10:00',4.3),('16273','2013-04-10','13:15:00',4.17),('16273','2013-04-10','13:20:00',2.57),('16273','2013-04-10','13:25:00',2.08),('16273','2013-04-10','13:30:00',2.77),('16273','2013-04-10','13:35:00',3.62),('16273','2013-04-10','13:40:00',3.03),('16273','2013-04-10','13:45:00',2.79),('16273','2013-04-10','13:50:00',3.11),('16273','2013-04-10','13:55:00',2.42),('16273','2013-04-10','14:00:00',1.98),('16273','2013-04-10','14:05:00',2.31),('16273','2013-04-10','14:10:00',3.53),('16273','2013-04-10','14:15:00',3.48),('16273','2013-04-10','14:20:00',1.5),('16273','2013-04-10','14:25:00',3.18),('16273','2013-04-10','14:30:00',2.48),('16273','2013-04-10','14:35:00',3.06),('16273','2013-04-10','14:40:00',2.59),('16273','2013-04-10','14:45:00',2.59),('16273','2013-04-10','14:50:00',3.7),('16273','2013-04-10','14:55:00',2.76),('16273','2013-04-10','15:00:00',2.4),('16273','2013-04-10','15:05:00',2.52),('16273','2013-04-10','15:10:00',2.91),('16273','2013-04-10','15:15:00',2.43),('16273','2013-04-10','15:20:00',3.09),('16273','2013-04-10','15:25:00',3),('16273','2013-04-10','15:30:00',2.94),('16273','2013-04-10','15:35:00',2.83),('16273','2013-04-10','15:40:00',2.82),('16273','2013-04-10','15:45:00',2.52),('16273','2013-04-10','15:50:00',2.24),('16273','2013-04-10','15:55:00',2.56),('16273','2013-04-10','16:00:00',2.58),('16273','2013-04-10','16:05:00',2.01),('16273','2013-04-10','16:10:00',2.36),('16273','2013-04-10','16:15:00',1.98),('16273','2013-04-10','16:20:00',2.11),('16273','2013-04-10','16:25:00',1.53),('16273','2013-04-10','16:30:00',1.46),('16273','2013-04-10','16:35:00',1.91),('16273','2013-04-10','16:40:00',1.47),('16273','2013-04-10','16:45:00',1.12),('16273','2013-04-10','17:10:00',1.33),('16273','2013-04-10','17:15:00',1.01),('16273','2013-04-10','17:20:00',1.41),('16273','2013-04-10','17:25:00',1.54),('16273','2013-04-10','17:30:00',1.16),('16273','2013-04-10','17:35:00',1.23),('16273','2013-04-10','17:45:00',1.01),('16273','2013-04-09','08:05:00',1.4),('16273','2013-04-09','08:10:00',1.62),('16273','2013-04-09','08:15:00',1.88),('16273','2013-04-09','08:30:00',1.09),('16273','2013-04-09','08:35:00',2.1),('16273','2013-04-09','08:40:00',1.51),('16273','2013-04-09','08:45:00',2.11),('16273','2013-04-09','08:50:00',2.34),('16273','2013-04-09','08:55:00',2.47),('16273','2013-04-09','09:00:00',2.41),('16273','2013-04-09','09:05:00',1.48),('16273','2013-04-09','09:10:00',1.14),('16273','2013-04-09','09:15:00',1.39),('16273','2013-04-09','09:20:00',1.27),('16273','2013-04-09','09:25:00',1.04),('16273','2013-04-09','09:30:00',2.33),('16273','2013-04-09','09:35:00',2.04),('16273','2013-04-09','09:40:00',2.41),('16273','2013-04-09','09:45:00',2.09),('16273','2013-04-09','09:50:00',1.37),('16273','2013-04-09','09:55:00',1.26),('16273','2013-04-09','10:15:00',2.8),('16273','2013-04-09','10:20:00',3.91),('16273','2013-04-09','10:25:00',2.79),('16273','2013-04-09','10:30:00',1.95),('16273','2013-04-09','10:35:00',1.98),('16273','2013-04-09','10:40:00',2.7),('16273','2013-04-09','10:45:00',2.49),('16273','2013-04-09','10:50:00',2.59),('16273','2013-04-09','10:55:00',2.45),('16273','2013-04-09','11:00:00',1.06),('16273','2013-04-09','11:05:00',4.18),('16273','2013-04-09','11:10:00',3.51),('16273','2013-04-09','11:15:00',3.12),('16273','2013-04-09','11:20:00',4.25),('16273','2013-04-09','11:25:00',2.69),('16273','2013-04-09','11:30:00',3.26),('16273','2013-04-09','11:35:00',2.93),('16273','2013-04-09','11:40:00',3.65),('16273','2013-04-09','11:45:00',3.91),('16273','2013-04-09','11:50:00',2.06),('16273','2013-04-09','11:55:00',3.2),('16273','2013-04-09','12:00:00',4.57),('16273','2013-04-09','12:05:00',3.41),('16273','2013-04-09','12:10:00',1.43),('16273','2013-04-09','12:15:00',3.05),('16273','2013-04-09','12:20:00',3.48),('16273','2013-04-09','12:25:00',3.75),('16273','2013-04-09','12:30:00',4.28),('16273','2013-04-09','12:35:00',3.4),('16273','2013-04-09','12:40:00',2.44),('16273','2013-04-09','12:45:00',4.69),('16273','2013-04-09','12:50:00',4.65),('16273','2013-04-09','12:55:00',4.43),('16273','2013-04-09','13:00:00',4.04),('16273','2013-04-09','13:05:00',4.55),('16273','2013-04-09','13:10:00',4.37),('16273','2013-04-09','13:15:00',4.14),('16273','2013-04-09','13:20:00',3.92),('16273','2013-04-09','13:25:00',3),('16273','2013-04-09','13:30:00',4.17),('16273','2013-04-09','13:35:00',3.2),('16273','2013-04-09','13:40:00',3.92),('16273','2013-04-09','13:45:00',3.03),('16273','2013-04-09','13:50:00',3.93),('16273','2013-04-09','13:55:00',3.69),('16273','2013-04-09','14:00:00',3.37),('16273','2013-04-09','14:05:00',3.51),('16273','2013-04-09','14:10:00',3.13),('16273','2013-04-09','14:15:00',3.34),('16273','2013-04-09','14:20:00',3.04),('16273','2013-04-09','14:25:00',1.89),('16273','2013-04-09','14:30:00',2.66),('16273','2013-04-09','14:35:00',2.68),('16273','2013-04-09','14:40:00',3.05),('16273','2013-04-09','14:45:00',2.12),('16273','2013-04-09','14:50:00',3.46),('16273','2013-04-09','14:55:00',3.42),('16273','2013-04-09','15:00:00',3.42),('16273','2013-04-09','15:05:00',3.26),('16273','2013-04-09','15:10:00',3.21),('16273','2013-04-09','15:15:00',3.14),('16273','2013-04-09','15:20:00',3.17),('16273','2013-04-09','15:25:00',3.11),('16273','2013-04-09','15:30:00',3.03),('16273','2013-04-09','15:35:00',2.92),('16273','2013-04-09','15:40:00',2.89),('16273','2013-04-09','15:45:00',2.81),('16273','2013-04-09','15:50:00',2.59),('16273','2013-04-09','15:55:00',2.04),('16273','2013-04-09','16:00:00',2.25),('16273','2013-04-09','16:05:00',2.59),('16273','2013-04-09','16:10:00',2.39),('16273','2013-04-09','16:15:00',2.09),('16273','2013-04-09','16:20:00',2.22),('16273','2013-04-09','16:25:00',2.27),('16273','2013-04-09','16:30:00',2.02),('16273','2013-04-09','16:35:00',1.95),('16273','2013-04-09','16:40:00',1.86),('16273','2013-04-09','16:45:00',2.04),('16273','2013-04-09','16:50:00',1.95),('16273','2013-04-09','16:55:00',1.75),('16273','2013-04-09','17:00:00',1.88),('16273','2013-04-09','17:05:00',1.73),('16273','2013-04-09','17:10:00',1.62),('16273','2013-04-09','17:15:00',1.49),('16273','2013-04-09','17:20:00',1.42),('16273','2013-04-09','17:25:00',1.12),('16273','2013-04-09','17:30:00',1.1),('16273','2013-04-09','17:35:00',1.08),('16273','2013-04-09','17:40:00',1.02),('16273','2013-04-09','17:45:00',1.05),('16273','2013-04-08','08:00:00',1.07),('16273','2013-04-08','08:15:00',1.27),('16273','2013-04-08','08:25:00',1.14),('16273','2013-04-08','08:30:00',1.31),('16273','2013-04-08','08:35:00',1.87),('16273','2013-04-08','08:40:00',1.19),('16273','2013-04-08','08:45:00',1.53),('16273','2013-04-08','08:50:00',2.15),('16273','2013-04-08','08:55:00',2.57),('16273','2013-04-08','09:00:00',2.49),('16273','2013-04-08','09:05:00',2.53),('16273','2013-04-08','09:10:00',2.55),('16273','2013-04-08','09:15:00',2.86),('16273','2013-04-08','09:20:00',2.88),('16273','2013-04-08','09:25:00',2.94),('16273','2013-04-08','09:30:00',3.08),('16273','2013-04-08','09:35:00',3.2),('16273','2013-04-08','09:40:00',2.99),('16273','2013-04-08','09:45:00',1.87),('16273','2013-04-08','09:50:00',1.97),('16273','2013-04-08','09:55:00',3.22),('16273','2013-04-08','10:00:00',3.43),('16273','2013-04-08','10:05:00',3.37),('16273','2013-04-08','10:10:00',3.42),('16273','2013-04-08','10:15:00',3.46),('16273','2013-04-08','10:20:00',3.38),('16273','2013-04-08','10:25:00',3.42),('16273','2013-04-08','10:30:00',3.27),('16273','2013-04-08','10:35:00',3.63),('16273','2013-04-08','10:40:00',3.7),('16273','2013-04-08','10:45:00',3.62),('16273','2013-04-08','10:50:00',3.42),('16273','2013-04-08','10:55:00',3.54),('16273','2013-04-08','11:00:00',3.21),('16273','2013-04-08','11:05:00',2.91),('16273','2013-04-08','11:10:00',2.53),('16273','2013-04-08','11:15:00',2.12),('16273','2013-04-08','11:20:00',1.93),('16273','2013-04-08','11:25:00',2.51),('16273','2013-04-08','11:30:00',3.09),('16273','2013-04-08','11:35:00',2.81),('16273','2013-04-08','11:40:00',2.77),('16273','2013-04-08','11:45:00',2.33),('16273','2013-04-08','11:50:00',2.54),('16273','2013-04-08','11:55:00',2.21),('16273','2013-04-08','12:00:00',2.1),('16273','2013-04-08','12:05:00',2.48),('16273','2013-04-08','12:10:00',2.79),('16273','2013-04-08','12:15:00',2.85),('16273','2013-04-08','12:20:00',2.74),('16273','2013-04-08','12:25:00',2.81),('16273','2013-04-08','12:30:00',2.85),('16273','2013-04-08','12:35:00',3.46),('16273','2013-04-08','12:40:00',3.2),('16273','2013-04-08','12:45:00',3.34),('16273','2013-04-08','12:50:00',3.27),('16273','2013-04-08','12:55:00',3.29),('16273','2013-04-08','13:00:00',2.89),('16273','2013-04-08','13:05:00',3.41),('16273','2013-04-08','13:10:00',2.86),('16273','2013-04-08','13:15:00',3.31),('16273','2013-04-08','13:20:00',3.13),('16273','2013-04-08','13:25:00',3.25),('16273','2013-04-08','13:30:00',2.88),('16273','2013-04-08','13:35:00',3.06),('16273','2013-04-08','13:40:00',2.72),('16273','2013-04-08','13:45:00',3.59),('16273','2013-04-08','13:50:00',3.44),('16273','2013-04-08','13:55:00',2.57),('16273','2013-04-08','14:00:00',3.23),('16273','2013-04-08','14:05:00',3.32),('16273','2013-04-08','14:10:00',3.35),('16273','2013-04-08','14:15:00',2.84),('16273','2013-04-08','14:20:00',3.25),('16273','2013-04-08','14:25:00',3.32),('16273','2013-04-08','14:30:00',3.18),('16273','2013-04-08','14:35:00',3.2),('16273','2013-04-08','14:40:00',3.34),('16273','2013-04-08','14:45:00',3.37),('16273','2013-04-08','14:50:00',3.44),('16273','2013-04-08','14:55:00',2.58),('16273','2013-04-08','15:00:00',2.85),('16273','2013-04-08','15:05:00',2.86),('16273','2013-04-08','15:10:00',2.32),('16273','2013-04-08','15:15:00',2.91),('16273','2013-04-08','15:20:00',3.13),('16273','2013-04-08','15:25:00',3.03),('16273','2013-04-08','15:30:00',2.92),('16273','2013-04-08','15:35:00',2.87),('16273','2013-04-08','15:40:00',2.78),('16273','2013-04-08','15:45:00',2.71),('16273','2013-04-08','15:50:00',2.65),('16273','2013-04-08','15:55:00',2.58),('16273','2013-04-08','16:00:00',2.41),('16273','2013-04-08','16:05:00',2.28),('16273','2013-04-08','16:10:00',2.34),('16273','2013-04-08','16:15:00',2.33),('16273','2013-04-08','16:20:00',2.2),('16273','2013-04-08','16:25:00',2.11),('16273','2013-04-08','16:30:00',2.06),('16273','2013-04-08','16:35:00',1.97),('16273','2013-04-08','16:40:00',1.9),('16273','2013-04-08','16:45:00',1.8),('16273','2013-04-08','16:50:00',1.74),('16273','2013-04-08','16:55:00',1.67),('16273','2013-04-08','17:00:00',1.59),('16273','2013-04-08','17:05:00',1.46),('16273','2013-04-08','17:10:00',1.36),('16273','2013-04-08','17:15:00',1.28),('16273','2013-04-08','17:20:00',1.29),('16273','2013-04-08','17:25:00',1.16),('16273','2013-04-08','17:30:00',1.09),('16273','2013-04-07','08:15:00',1.05),('16273','2013-04-07','08:20:00',1.14),('16273','2013-04-07','08:25:00',1.26),('16273','2013-04-07','08:30:00',1.37),('16273','2013-04-07','08:35:00',1.42),('16273','2013-04-07','08:40:00',1.46),('16273','2013-04-07','08:45:00',1.56),('16273','2013-04-07','08:50:00',1.71),('16273','2013-04-07','08:55:00',1.78),('16273','2013-04-07','09:00:00',1.89),('16273','2013-04-07','09:05:00',1.96),('16273','2013-04-07','09:10:00',2.01),('16273','2013-04-07','09:15:00',2.04),('16273','2013-04-07','09:20:00',2.22),('16273','2013-04-07','09:25:00',2.08),('16273','2013-04-07','09:30:00',2.03),('16273','2013-04-07','09:35:00',2.13),('16273','2013-04-07','09:40:00',2.25),('16273','2013-04-07','09:45:00',2.27),('16273','2013-04-07','09:50:00',2.49),('16273','2013-04-07','09:55:00',2.51),('16273','2013-04-07','10:00:00',2.44),('16273','2013-04-07','10:05:00',2.14),('16273','2013-04-07','10:10:00',1.88),('16273','2013-04-07','10:15:00',2.33),('16273','2013-04-07','10:20:00',2.63),('16273','2013-04-07','10:25:00',2.91),('16273','2013-04-07','10:30:00',3.18),('16273','2013-04-07','10:35:00',3.26),('16273','2013-04-07','10:40:00',3.38),('16273','2013-04-07','10:45:00',3.36),('16273','2013-04-07','10:50:00',3.12),('16273','2013-04-07','10:55:00',3.07),('16273','2013-04-07','11:00:00',3.09),('16273','2013-04-07','11:05:00',2.79),('16273','2013-04-07','11:10:00',2.76),('16273','2013-04-07','11:15:00',2.41),('16273','2013-04-07','11:20:00',2.19),('16273','2013-04-07','11:25:00',2.17),('16273','2013-04-07','11:30:00',2.35),('16273','2013-04-07','11:35:00',2.74),('16273','2013-04-07','11:40:00',3.44),('16273','2013-04-07','11:45:00',3.76),('16273','2013-04-07','11:50:00',3.95),('16273','2013-04-07','11:55:00',3.69),('16273','2013-04-07','12:00:00',2.78),('16273','2013-04-07','12:05:00',2.81),('16273','2013-04-07','12:10:00',2.84),('16273','2013-04-07','12:15:00',2.82),('16273','2013-04-07','12:20:00',2.7),('16273','2013-04-07','12:25:00',2.89),('16273','2013-04-07','12:30:00',3.17),('16273','2013-04-07','12:35:00',3.22),('16273','2013-04-07','12:40:00',3.01),('16273','2013-04-07','12:45:00',3),('16273','2013-04-07','12:50:00',2.66),('16273','2013-04-07','12:55:00',3),('16273','2013-04-07','13:00:00',2.97),('16273','2013-04-07','13:05:00',2.82),('16273','2013-04-07','13:10:00',2.77),('16273','2013-04-07','13:15:00',2.96),('16273','2013-04-07','13:20:00',2.8),('16273','2013-04-07','13:25:00',2.54),('16273','2013-04-07','13:30:00',2.75),('16273','2013-04-07','13:35:00',2.91),('16273','2013-04-07','13:40:00',2.87),('16273','2013-04-07','13:45:00',2.59),('16273','2013-04-07','13:50:00',2.42),('16273','2013-04-07','13:55:00',2.49),('16273','2013-04-07','14:00:00',2.47),('16273','2013-04-07','14:05:00',2.27),('16273','2013-04-07','14:10:00',2.38),('16273','2013-04-07','14:15:00',2.51),('16273','2013-04-07','14:20:00',2.21),('16273','2013-04-07','14:25:00',2.2),('16273','2013-04-07','14:30:00',2.3),('16273','2013-04-07','14:35:00',2.36),('16273','2013-04-07','14:40:00',2.46),('16273','2013-04-07','14:45:00',2.38),('16273','2013-04-07','14:50:00',2.33),('16273','2013-04-07','14:55:00',2.27),('16273','2013-04-07','15:00:00',2.19),('16273','2013-04-07','15:05:00',2.21),('16273','2013-04-07','15:10:00',2.11),('16273','2013-04-07','15:15:00',2.02),('16273','2013-04-07','15:20:00',2.02),('16273','2013-04-07','15:25:00',1.55),('16273','2013-04-07','15:30:00',1.97),('16273','2013-04-07','15:35:00',2.04),('16273','2013-04-07','15:40:00',2.16),('16273','2013-04-07','15:45:00',1.83),('16273','2013-04-07','15:50:00',1.16),('16273','2013-04-07','15:55:00',1.19),('16273','2013-04-07','16:00:00',1.18),('16273','2013-04-07','16:05:00',1.29),('16273','2013-04-07','16:10:00',1.46),('16273','2013-04-07','16:15:00',1.6),('16273','2013-04-07','16:20:00',1.87),('16273','2013-04-07','16:25:00',2.03),('16273','2013-04-07','16:30:00',1.84),('16273','2013-04-07','17:10:00',1.15),('16273','2013-04-07','17:15:00',1.57),('16273','2013-04-07','17:20:00',1.47),('16273','2013-04-07','17:25:00',1.08),('16273','2013-04-07','17:30:00',1.25),('16273','2013-04-07','17:35:00',1.15),('16273','2013-04-07','17:40:00',1.14),('16273','2013-04-07','17:45:00',1.06),('16273','2013-04-06','07:55:00',1.15),('16273','2013-04-06','08:00:00',1.25),('16273','2013-04-06','08:05:00',1.18),('16273','2013-04-06','08:10:00',1.49),('16273','2013-04-06','08:15:00',1.58),('16273','2013-04-06','08:20:00',1.71),('16273','2013-04-06','08:25:00',1.82),('16273','2013-04-06','08:30:00',1.89),('16273','2013-04-06','08:35:00',1.97),('16273','2013-04-06','08:40:00',2.06),('16273','2013-04-06','08:45:00',2.15),('16273','2013-04-06','08:50:00',2.25),('16273','2013-04-06','08:55:00',2.33),('16273','2013-04-06','09:00:00',2.41),('16273','2013-04-06','09:05:00',2.49),('16273','2013-04-06','09:10:00',2.54),('16273','2013-04-06','09:15:00',2.59),('16273','2013-04-06','09:20:00',2.66),('16273','2013-04-06','09:25:00',2.73),('16273','2013-04-06','09:30:00',2.81),('16273','2013-04-06','09:35:00',2.82),('16273','2013-04-06','09:40:00',2.93),('16273','2013-04-06','09:45:00',3.01),('16273','2013-04-06','09:50:00',3.03),('16273','2013-04-06','09:55:00',3.08),('16273','2013-04-06','10:00:00',3.11),('16273','2013-04-06','10:05:00',3.17),('16273','2013-04-06','10:10:00',2.99),('16273','2013-04-06','10:15:00',3.22),('16273','2013-04-06','10:20:00',3.44),('16273','2013-04-06','10:25:00',3.4),('16273','2013-04-06','10:30:00',3.41),('16273','2013-04-06','10:35:00',3.53),('16273','2013-04-06','10:40:00',3.57),('16273','2013-04-06','10:45:00',3.62),('16273','2013-04-06','10:50:00',3.62),('16273','2013-04-06','10:55:00',3.61),('16273','2013-04-06','11:00:00',3.66),('16273','2013-04-06','11:05:00',3.73),('16273','2013-04-06','11:10:00',3.74),('16273','2013-04-06','11:15:00',3.78),('16273','2013-04-06','11:20:00',3.81),('16273','2013-04-06','11:25:00',3.9),('16273','2013-04-06','11:30:00',3.95),('16273','2013-04-06','11:35:00',3.91),('16273','2013-04-06','11:40:00',3.97),('16273','2013-04-06','11:45:00',4),('16273','2013-04-06','11:50:00',4),('16273','2013-04-06','11:55:00',3.97),('16273','2013-04-06','12:00:00',4),('16273','2013-04-06','12:05:00',3.96),('16273','2013-04-06','12:10:00',3.94),('16273','2013-04-06','12:15:00',3.97),('16273','2013-04-06','12:20:00',4.03),('16273','2013-04-06','12:25:00',3.97),('16273','2013-04-06','12:30:00',3.58),('16273','2013-04-06','12:35:00',2.7),('16273','2013-04-06','12:40:00',3.99),('16273','2013-04-06','12:45:00',3.58),('16273','2013-04-06','12:50:00',4.14),('16273','2013-04-06','12:55:00',3.51),('16273','2013-04-06','13:00:00',4.19),('16273','2013-04-06','13:05:00',4.13),('16273','2013-04-06','13:10:00',4.09),('16273','2013-04-06','13:15:00',4.05),('16273','2013-04-06','13:20:00',4.01),('16273','2013-04-06','13:25:00',3.99),('16273','2013-04-06','13:30:00',4),('16273','2013-04-06','13:35:00',3.91),('16273','2013-04-06','13:40:00',3.83),('16273','2013-04-06','13:45:00',3.88),('16273','2013-04-06','13:50:00',3.84),('16273','2013-04-06','13:55:00',3.8),('16273','2013-04-06','14:00:00',3.8),('16273','2013-04-06','14:05:00',3.74),('16273','2013-04-06','14:10:00',3.68),('16273','2013-04-06','14:15:00',3.65),('16273','2013-04-06','14:20:00',3.58),('16273','2013-04-06','14:25:00',3.54),('16273','2013-04-06','14:30:00',3.49),('16273','2013-04-06','14:35:00',3.45),('16273','2013-04-06','14:40:00',3.39),('16273','2013-04-06','14:45:00',3.34),('16273','2013-04-06','14:50:00',3.29),('16273','2013-04-06','14:55:00',3.23),('16273','2013-04-06','15:00:00',3.14),('16273','2013-04-06','15:05:00',3.11),('16273','2013-04-06','15:10:00',3.04),('16273','2013-04-06','15:15:00',2.99),('16273','2013-04-06','15:20:00',2.96),('16273','2013-04-06','15:25:00',2.84),('16273','2013-04-06','15:30:00',2.75),('16273','2013-04-06','15:35:00',2.73),('16273','2013-04-06','15:40:00',2.7),('16273','2013-04-06','15:45:00',2.71),('16273','2013-04-06','15:50:00',2.68),('16273','2013-04-06','15:55:00',2.17),('16273','2013-04-06','16:00:00',2.11),('16273','2013-04-06','16:05:00',1.95),('16273','2013-04-06','16:10:00',1.81),('16273','2013-04-06','16:15:00',1.87),('16273','2013-04-06','16:20:00',1.74),('16273','2013-04-06','16:25:00',1.4),('16273','2013-04-06','16:30:00',1.52),('16273','2013-04-06','16:35:00',1.93),('16273','2013-04-06','16:40:00',1.7),('16273','2013-04-06','16:45:00',1.87),('16273','2013-04-06','16:50:00',1.7),('16273','2013-04-06','16:55:00',1.37),('16273','2013-04-06','17:00:00',1.13),('16273','2013-04-06','17:05:00',1.1),('16273','2013-04-06','17:10:00',1.06),('16273','2013-04-05','08:40:00',1.37),('16273','2013-04-05','08:45:00',1.93),('16273','2013-04-05','08:50:00',1.36),('16273','2013-04-05','08:55:00',1.26),('16273','2013-04-05','09:05:00',1.06),('16273','2013-04-05','09:10:00',2.25),('16273','2013-04-05','09:15:00',1.13),('16273','2013-04-05','09:20:00',1.27),('16273','2013-04-05','09:25:00',1.6),('16273','2013-04-05','09:35:00',1.76),('16273','2013-04-05','09:40:00',1.63),('16273','2013-04-05','09:45:00',1.91),('16273','2013-04-05','09:50:00',2.52),('16273','2013-04-05','09:55:00',2.27),('16273','2013-04-05','10:00:00',2.97),('16273','2013-04-05','10:05:00',3.48),('16273','2013-04-05','10:10:00',2.68),('16273','2013-04-05','10:15:00',2.86),('16273','2013-04-05','10:20:00',3.47),('16273','2013-04-05','10:25:00',2.86),('16273','2013-04-05','10:30:00',2.74),('16273','2013-04-05','10:35:00',3.12),('16273','2013-04-05','10:40:00',1.42),('16273','2013-04-05','10:45:00',2.67),('16273','2013-04-05','10:50:00',2.38),('16273','2013-04-05','10:55:00',3.76),('16273','2013-04-05','11:00:00',3.7),('16273','2013-04-05','11:05:00',3.71),('16273','2013-04-05','11:10:00',3.8),('16273','2013-04-05','11:15:00',4.01),('16273','2013-04-05','11:20:00',3.68),('16273','2013-04-05','11:25:00',3.88),('16273','2013-04-05','11:30:00',4.29),('16273','2013-04-05','11:35:00',4),('16273','2013-04-05','11:40:00',4.08),('16273','2013-04-05','11:45:00',3.68),('16273','2013-04-05','11:50:00',4.05),('16273','2013-04-05','11:55:00',3.39),('16273','2013-04-05','12:00:00',3.67),('16273','2013-04-05','12:05:00',2.56),('16273','2013-04-05','12:10:00',1.69),('16273','2013-04-05','12:15:00',1.46),('16273','2013-04-05','12:25:00',1.93),('16273','2013-04-05','12:30:00',1.46),('16273','2013-04-05','12:35:00',2.26),('16273','2013-04-05','12:40:00',3.36),('16273','2013-04-05','12:45:00',3.14),('16273','2013-04-05','12:50:00',3.33),('16273','2013-04-05','12:55:00',4.01),('16273','2013-04-05','13:00:00',3.95),('16273','2013-04-05','13:05:00',2.85),('16273','2013-04-05','13:10:00',3.65),('16273','2013-04-05','13:15:00',3.71),('16273','2013-04-05','13:20:00',3.93),('16273','2013-04-05','13:25:00',4.01),('16273','2013-04-05','13:30:00',3.78),('16273','2013-04-05','13:35:00',2.2),('16273','2013-04-05','13:40:00',2.76),('16273','2013-04-05','13:45:00',2.76),('16273','2013-04-05','13:50:00',1.79),('16273','2013-04-05','13:55:00',3.57),('16273','2013-04-05','14:00:00',3.42),('16273','2013-04-05','14:05:00',4.16),('16273','2013-04-05','14:10:00',2.37),('16273','2013-04-05','14:15:00',3.19),('16273','2013-04-05','14:20:00',3.21),('16273','2013-04-05','14:25:00',3.93),('16273','2013-04-05','14:30:00',3.83),('16273','2013-04-05','14:35:00',3.08),('16273','2013-04-05','14:40:00',3),('16273','2013-04-05','14:45:00',2.28),('16273','2013-04-05','14:50:00',1.9),('16273','2013-04-05','14:55:00',2.15),('16273','2013-04-05','15:00:00',1.97),('16273','2013-04-05','15:05:00',1.53),('16273','2013-04-05','15:10:00',1.71),('16273','2013-04-05','15:15:00',1.66),('16273','2013-04-05','15:20:00',1.8),('16273','2013-04-05','15:25:00',1.37),('16273','2013-04-05','15:35:00',1.04),('16273','2013-04-05','15:55:00',1.09),('16273','2013-04-05','16:00:00',1.94),('16273','2013-04-05','16:05:00',2.19),('16273','2013-04-05','16:10:00',1.55),('16273','2013-04-05','16:15:00',1.76),('16273','2013-04-05','16:20:00',1.36),('16273','2013-04-05','16:25:00',1.59),('16273','2013-04-05','16:30:00',1.71),('16273','2013-04-05','16:35:00',2.16),('16273','2013-04-05','16:40:00',2.43),('16273','2013-04-05','16:45:00',1.47),('16273','2013-04-05','16:50:00',1.99),('16273','2013-04-05','16:55:00',2.34),('16273','2013-04-05','17:00:00',1.98),('16273','2013-04-05','17:15:00',1.36),('16273','2013-04-05','17:20:00',1.23),('16273','2013-04-05','17:25:00',1.31),('16273','2013-04-05','17:30:00',1.26),('16273','2013-04-05','17:40:00',1.28),('16273','2013-04-05','17:45:00',1.02),('16273','2013-04-04','08:50:00',1.3),('16273','2013-04-04','08:55:00',2.05),('16273','2013-04-04','09:00:00',1.31),('16273','2013-04-04','09:05:00',1.15),('16273','2013-04-04','09:10:00',1.33),('16273','2013-04-04','09:15:00',1.14),('16273','2013-04-04','09:25:00',1.32),('16273','2013-04-04','09:30:00',2.36),('16273','2013-04-04','09:35:00',2.45),('16273','2013-04-04','09:40:00',1.73),('16273','2013-04-04','09:45:00',1.06),('16273','2013-04-04','09:50:00',1.07),('16273','2013-04-04','09:55:00',1.65),('16273','2013-04-04','10:00:00',2.17),('16273','2013-04-04','10:05:00',1.73),('16273','2013-04-04','10:10:00',1.24),('16273','2013-04-04','10:15:00',1.48),('16273','2013-04-04','10:20:00',3.23),('16273','2013-04-04','10:25:00',2.84),('16273','2013-04-04','10:30:00',1.78),('16273','2013-04-04','10:35:00',3.84),('16273','2013-04-04','10:40:00',2.09),('16273','2013-04-04','10:45:00',2.25),('16273','2013-04-04','10:50:00',3.56),('16273','2013-04-04','10:55:00',2.32),('16273','2013-04-04','11:00:00',1.19),('16273','2013-04-04','11:05:00',1.02),('16273','2013-04-04','11:10:00',1.35),('16273','2013-04-04','11:15:00',1.35),('16273','2013-04-04','11:20:00',1.03),('16273','2013-04-04','11:25:00',1.07),('16273','2013-04-04','11:30:00',1.51),('16273','2013-04-04','11:35:00',2.6),('16273','2013-04-04','11:40:00',3.3),('16273','2013-04-04','11:45:00',3.6),('16273','2013-04-04','11:50:00',2.07),('16273','2013-04-04','11:55:00',2.5),('16273','2013-04-04','12:00:00',4.04),('16273','2013-04-04','12:05:00',4.02),('16273','2013-04-04','12:10:00',3.59),('16273','2013-04-04','12:15:00',3),('16273','2013-04-04','12:20:00',1.9),('16273','2013-04-04','12:25:00',3.07),('16273','2013-04-04','12:30:00',2.5),('16273','2013-04-04','12:35:00',2.67),('16273','2013-04-04','12:40:00',2.29),('16273','2013-04-04','12:45:00',3.25),('16273','2013-04-04','12:50:00',3.41),('16273','2013-04-04','12:55:00',3.63),('16273','2013-04-04','13:00:00',3.52),('16273','2013-04-04','13:05:00',3.72),('16273','2013-04-04','13:10:00',3.91),('16273','2013-04-04','13:15:00',3.83),('16273','2013-04-04','13:20:00',3.76),('16273','2013-04-04','13:25:00',3.77),('16273','2013-04-04','13:30:00',3.48),('16273','2013-04-04','13:35:00',3.31),('16273','2013-04-04','13:40:00',3.21),('16273','2013-04-04','13:45:00',3.1),('16273','2013-04-04','13:50:00',2.36),('16273','2013-04-04','13:55:00',2.29),('16273','2013-04-04','14:00:00',2.82),('16273','2013-04-04','14:05:00',3.72),('16273','2013-04-04','14:10:00',3.58),('16273','2013-04-04','14:15:00',3.45),('16273','2013-04-04','14:20:00',3.38),('16273','2013-04-04','14:25:00',3.37),('16273','2013-04-04','14:30:00',3.36),('16273','2013-04-04','14:35:00',3.28),('16273','2013-04-04','14:40:00',3.22),('16273','2013-04-04','14:45:00',3.16),('16273','2013-04-04','14:50:00',3.1),('16273','2013-04-04','14:55:00',3.09),('16273','2013-04-04','15:00:00',3.01),('16273','2013-04-04','15:05:00',2.83),('16273','2013-04-04','15:10:00',2.68),('16273','2013-04-04','15:15:00',2.76),('16273','2013-04-04','15:20:00',2.58),('16273','2013-04-04','15:25:00',2.74),('16273','2013-04-04','15:30:00',2.64),('16273','2013-04-04','15:35:00',2.57),('16273','2013-04-04','15:40:00',2.5),('16273','2013-04-04','15:45:00',2.43),('16273','2013-04-04','15:50:00',2.41),('16273','2013-04-04','15:55:00',2.35),('16273','2013-04-04','16:00:00',2.19),('16273','2013-04-04','16:05:00',2.22),('16273','2013-04-04','16:10:00',1.84),('16273','2013-04-04','16:15:00',1.8),('16273','2013-04-04','16:20:00',1.83),('16273','2013-04-04','16:25:00',2.08),('16273','2013-04-04','16:30:00',1.72),('16273','2013-04-04','16:35:00',1.49),('16273','2013-04-04','16:40:00',1.64),('16273','2013-04-04','16:45:00',1.27),('16273','2013-04-04','16:50:00',1.48),('16273','2013-04-04','16:55:00',1.22),('16273','2013-04-04','17:00:00',1.31),('16273','2013-04-04','17:05:00',1.27),('16273','2013-04-03','08:00:00',1.24),('16273','2013-04-03','08:05:00',1.51),('16273','2013-04-03','08:13:00',1.56),('16273','2013-04-03','08:20:00',1.11),('16273','2013-04-03','08:25:00',1.06),('16273','2013-04-03','08:30:00',1.41),('16273','2013-04-03','08:35:00',2.04),('16273','2013-04-03','08:40:00',2.11),('16273','2013-04-03','08:45:00',2.19),('16273','2013-04-03','08:50:00',2.4),('16273','2013-04-03','08:55:00',2.32),('16273','2013-04-03','09:00:00',2.46),('16273','2013-04-03','09:05:00',2.32),('16273','2013-04-03','09:10:00',2.56),('16273','2013-04-03','09:15:00',2.74),('16273','2013-04-03','09:20:00',2.89),('16273','2013-04-03','09:25:00',2.77),('16273','2013-04-03','09:30:00',3.03),('16273','2013-04-03','09:35:00',2.89),('16273','2013-04-03','09:40:00',2.93),('16273','2013-04-03','09:45:00',3.26),('16273','2013-04-03','09:50:00',2.04),('16273','2013-04-03','09:55:00',1.37),('16273','2013-04-03','10:00:00',1.98),('16273','2013-04-03','10:05:00',4.1),('16273','2013-04-03','10:10:00',3.68),('16273','2013-04-03','10:15:00',3.87),('16273','2013-04-03','10:20:00',3.13),('16273','2013-04-03','10:25:00',1.89),('16273','2013-04-03','10:30:00',1.68),('16273','2013-04-03','10:35:00',1.68),('16273','2013-04-03','10:40:00',2.42),('16273','2013-04-03','10:45:00',3.33),('16273','2013-04-03','10:50:00',2.35),('16273','2013-04-03','10:55:00',2.55),('16273','2013-04-03','11:00:00',2.33),('16273','2013-04-03','11:05:00',2.01),('16273','2013-04-03','11:10:00',1.96),('16273','2013-04-03','11:15:00',2.65),('16273','2013-04-03','11:20:00',1.91),('16273','2013-04-03','11:25:00',2.85),('16273','2013-04-03','11:30:00',2.47),('16273','2013-04-03','11:35:00',2.39),('16273','2013-04-03','11:40:00',3.75),('16273','2013-04-03','11:45:00',2.87),('16273','2013-04-03','11:50:00',3.07),('16273','2013-04-03','11:55:00',2.99),('16273','2013-04-03','12:00:00',4.11),('16273','2013-04-03','12:05:00',4.38),('16273','2013-04-03','12:10:00',2.88),('16273','2013-04-03','12:15:00',3.1),('16273','2013-04-03','12:20:00',3.61),('16273','2013-04-03','12:25:00',3.34),('16273','2013-04-03','12:30:00',4.56),('16273','2013-04-03','12:35:00',3.94),('16273','2013-04-03','12:40:00',2.98),('16273','2013-04-03','12:45:00',3.7),('16273','2013-04-03','12:50:00',3.24),('16273','2013-04-03','12:55:00',2.44),('16273','2013-04-03','13:00:00',3.36),('16273','2013-04-03','13:05:00',2.49),('16273','2013-04-03','13:10:00',2.95),('16273','2013-04-03','13:15:00',3.5),('16273','2013-04-03','13:20:00',3.23),('16273','2013-04-03','13:25:00',3.29),('16273','2013-04-03','13:30:00',3.22),('16273','2013-04-03','13:35:00',4.6),('16273','2013-04-03','13:40:00',4.25),('16273','2013-04-03','13:45:00',3.95),('16273','2013-04-03','13:50:00',4.65),('16273','2013-04-03','13:55:00',3.86),('16273','2013-04-03','14:00:00',4.46),('16273','2013-04-03','14:05:00',3.96),('16273','2013-04-03','14:10:00',4.31),('16273','2013-04-03','14:15:00',3.59),('16273','2013-04-03','14:20:00',3.93),('16273','2013-04-03','14:25:00',2.19),('16273','2013-04-03','14:30:00',3.8),('16273','2013-04-03','14:35:00',3.32),('16273','2013-04-03','14:40:00',3.32),('16273','2013-04-03','14:45:00',3.17),('16273','2013-04-03','14:50:00',3.51),('16273','2013-04-03','14:55:00',3.51),('16273','2013-04-03','15:00:00',3.52),('16273','2013-04-03','15:05:00',2.98),('16273','2013-04-03','15:10:00',3.02),('16273','2013-04-03','15:15:00',2.35),('16273','2013-04-03','15:20:00',2.92),('16273','2013-04-03','15:25:00',1.48),('16273','2013-04-03','15:30:00',3.3),('16273','2013-04-03','15:35:00',2.84),('16273','2013-04-03','15:40:00',2.91),('16273','2013-04-03','15:45:00',2.77),('16273','2013-04-03','15:50:00',2.92),('16273','2013-04-03','15:55:00',2.71),('16273','2013-04-03','16:00:00',2.66),('16273','2013-04-03','16:05:00',2.45),('16273','2013-04-03','16:10:00',2.18),('16273','2013-04-03','16:15:00',2.36),('16273','2013-04-03','16:20:00',2.3),('16273','2013-04-03','16:25:00',2.21),('16273','2013-04-03','16:30:00',2.12),('16273','2013-04-03','16:35:00',2.02),('16273','2013-04-03','16:40:00',1.94),('16273','2013-04-03','16:45:00',1.84),('16273','2013-04-03','16:50:00',1.76),('16273','2013-04-03','16:55:00',1.59),('16273','2013-04-03','17:00:00',1.62),('16273','2013-04-03','17:05:00',1.5),('16273','2013-04-03','17:10:00',1.41),('16273','2013-04-03','17:15:00',1.33),('16273','2013-04-03','17:20:00',1.25),('16273','2013-04-03','17:25:00',1.18),('16273','2013-04-03','17:30:00',1.09),('16273','2013-04-03','17:35:00',1.01),('16273','2013-04-02','08:35:00',1.68),('16273','2013-04-02','08:40:00',1.19),('16273','2013-04-02','08:50:00',1.01),('16273','2013-04-02','08:55:00',2.18),('16273','2013-04-02','09:00:00',2.38),('16273','2013-04-02','09:05:00',2.47),('16273','2013-04-02','09:10:00',2.42),('16273','2013-04-02','09:15:00',2.73),('16273','2013-04-02','09:20:00',2.87),('16273','2013-04-02','09:25:00',3.07),('16273','2013-04-02','09:30:00',2.95),('16273','2013-04-02','09:35:00',2.38),('16273','2013-04-02','09:40:00',1.79),('16273','2013-04-02','09:45:00',3.06),('16273','2013-04-02','09:50:00',2.98),('16273','2013-04-02','09:55:00',3.39),('16273','2013-04-02','10:00:00',3.81),('16273','2013-04-02','10:05:00',4.07),('16273','2013-04-02','10:10:00',3.83),('16273','2013-04-02','10:15:00',3.38),('16273','2013-04-02','10:20:00',4.04),('16273','2013-04-02','10:25:00',3.92),('16273','2013-04-02','10:30:00',3.66),('16273','2013-04-02','10:35:00',2.19),('16273','2013-04-02','10:40:00',3.31),('16273','2013-04-02','10:45:00',3.76),('16273','2013-04-02','10:50:00',3.45),('16273','2013-04-02','10:55:00',2.92),('16273','2013-04-02','11:00:00',4.05),('16273','2013-04-02','11:05:00',4.02),('16273','2013-04-02','11:10:00',2.47),('16273','2013-04-02','11:15:00',4.44),('16273','2013-04-02','11:20:00',3.52),('16273','2013-04-02','11:25:00',3.42),('16273','2013-04-02','11:30:00',4.55),('16273','2013-04-02','11:35:00',3.06),('16273','2013-04-02','11:40:00',3.36),('16273','2013-04-02','11:45:00',3.03),('16273','2013-04-02','11:50:00',1.01),('16273','2013-04-02','12:00:00',1.1),('16273','2013-04-02','12:05:00',1.52),('16273','2013-04-02','12:10:00',1.48),('16273','2013-04-02','12:15:00',1.61),('16273','2013-04-02','12:20:00',1.03),('16273','2013-04-02','12:25:00',1.63),('16273','2013-04-02','12:30:00',2),('16273','2013-04-02','12:35:00',1.79),('16273','2013-04-02','12:40:00',1.36),('16273','2013-04-02','12:45:00',1.47),('16273','2013-04-02','12:50:00',1.61),('16273','2013-04-02','12:55:00',1.6),('16273','2013-04-02','13:00:00',2.28),('16273','2013-04-02','13:05:00',2.49),('16273','2013-04-02','13:10:00',1.12),('16273','2013-04-02','13:15:00',1.18),('16273','2013-04-02','13:20:00',1.35),('16273','2013-04-02','13:25:00',1.42),('16273','2013-04-02','13:30:00',1.36),('16273','2013-04-02','13:35:00',1.15),('16273','2013-04-02','13:40:00',1.11),('16273','2013-04-02','13:45:00',1.48),('16273','2013-04-02','13:50:00',2.48),('16273','2013-04-02','13:55:00',2.93),('16273','2013-04-02','14:00:00',2.86),('16273','2013-04-02','14:05:00',4.22),('16273','2013-04-02','14:10:00',2.53),('16273','2013-04-02','14:15:00',1.21),('16273','2013-04-02','14:20:00',2.7),('16273','2013-04-02','14:25:00',2.28),('16273','2013-04-02','14:45:00',1.62),('16273','2013-04-02','15:15:00',1.36),('16273','2013-04-02','15:35:00',1.04),('16273','2013-04-02','15:50:00',1.53),('16273','2013-04-02','15:55:00',1.51),('16273','2013-04-02','16:00:00',1.18),('16273','2013-04-02','16:05:00',1.04),('16273','2013-04-02','16:25:00',1.1),('16273','2013-04-02','16:30:00',1.03),('16273','2013-04-02','17:40:00',1.42),('16273','2014-05-02','07:25:00',1.13),('16273','2014-05-02','07:30:00',1.12),('16273','2014-05-02','07:35:00',1.4),('16273','2014-05-02','07:40:00',1.52),('16273','2014-05-02','07:45:00',2.03),('16273','2014-05-02','07:50:00',1.68),('16273','2014-05-02','08:10:00',1.4),('16273','2014-05-02','08:15:00',1.32),('16273','2014-05-02','08:25:00',1.35),('16273','2014-05-02','08:30:00',1.13),('16273','2014-05-02','08:35:00',2.17),('16273','2014-05-02','08:40:00',1.07),('16273','2014-05-02','08:45:00',1.15),('16273','2014-05-02','08:50:00',1.23),('16273','2014-05-02','08:55:00',1.14),('16273','2014-05-02','09:00:00',1.02),('16273','2014-05-02','09:05:00',1.12),('16273','2014-05-02','09:10:00',1.91),('16273','2014-05-02','09:15:00',2.1),('16273','2014-05-02','09:20:00',1.5),('16273','2014-05-02','09:25:00',1.21),('16273','2014-05-02','09:30:00',1.55),('16273','2014-05-02','09:35:00',2.36),('16273','2014-05-02','09:40:00',2.32),('16273','2014-05-02','09:45:00',1.69),('16273','2014-05-02','09:50:00',1.18),('16273','2014-05-02','12:30:00',1.13),('16273','2014-05-02','12:35:00',1.68),('16273','2014-05-02','12:40:00',1.79),('16273','2014-05-02','12:45:00',2.22),('16273','2014-05-02','12:50:00',2.24),('16273','2014-05-02','12:55:00',1.85),('16273','2014-05-02','13:00:00',2.09),('16273','2014-05-02','13:05:00',2.14),('16273','2014-05-02','13:10:00',2.79),('16273','2014-05-02','13:15:00',3.19),('16273','2014-05-02','13:20:00',3.76),('16273','2014-05-02','13:25:00',2.56),('16273','2014-05-02','13:30:00',3.15),('16273','2014-05-02','13:35:00',2.12),('16273','2014-05-02','13:40:00',2.04),('16273','2014-05-02','13:45:00',1.61),('16273','2014-05-02','13:50:00',2.18),('16273','2014-05-02','13:55:00',2.77),('16273','2014-05-02','14:00:00',3.06),('16273','2014-05-02','14:05:00',3.5),('16273','2014-05-02','14:10:00',2.98),('16273','2014-05-02','14:15:00',2.62),('16273','2014-05-02','14:20:00',2.98),('16273','2014-05-02','14:25:00',1.3),('16273','2014-05-02','14:30:00',1.78),('16273','2014-05-02','15:05:00',1.19),('16273','2014-05-02','15:10:00',1.52),('16273','2014-05-02','15:15:00',1.3),('16273','2014-05-02','15:20:00',2.03),('16273','2014-05-02','15:25:00',2.91),('16273','2014-05-02','15:30:00',2.97),('16273','2014-05-02','15:35:00',2.22),('16273','2014-05-02','15:45:00',1.44),('16273','2014-05-02','15:50:00',1.51),('16273','2014-05-02','15:55:00',1.18),('16273','2014-05-02','16:00:00',1.08),('16273','2014-05-02','16:05:00',1.53),('16273','2014-05-02','16:10:00',1.08),('16273','2014-05-02','16:15:00',1.12),('16273','2014-05-02','16:20:00',1.38),('16273','2014-05-02','16:35:00',1.03),('16273','2014-05-02','16:40:00',1.38),('16273','2014-05-02','16:45:00',1.69),('16273','2014-05-02','16:50:00',1.2),('16273','2014-05-02','16:55:00',1.02),('16273','2014-03-27','09:10:00',1.07),('16273','2014-03-27','09:15:00',1.09),('16273','2014-03-27','09:20:00',1.18),('16273','2014-03-27','09:25:00',1.11),('16273','2014-03-27','10:00:00',1.05),('16273','2014-03-27','10:05:00',1.35),('16273','2014-03-27','10:10:00',1.44),('16273','2014-03-27','10:15:00',1.45),('16273','2014-03-27','10:20:00',1.32),('16273','2014-03-27','10:25:00',1.04),('16273','2014-03-27','10:30:00',1.36),('16273','2014-03-27','10:35:00',1.39),('16273','2014-03-27','10:40:00',2.78),('16273','2014-03-27','10:45:00',2.94),('16273','2014-03-27','10:50:00',1.42),('16273','2014-03-27','11:00:00',2.25),('16273','2014-03-27','11:05:00',1.78),('16273','2014-03-27','11:50:00',2.35),('16273','2014-03-27','11:55:00',1.25),('16273','2014-03-27','12:45:00',1.04),('16273','2014-03-27','12:50:00',1.28),('16273','2014-03-27','12:55:00',1.39),('16273','2014-03-27','13:00:00',1.55),('16273','2014-03-27','13:05:00',2.27),('16273','2014-03-27','13:10:00',2.64),('16273','2014-03-27','13:15:00',2.99),('16273','2014-03-27','13:20:00',2.95),('16273','2014-03-27','13:25:00',2.66),('16273','2014-03-27','13:30:00',2.33),('16273','2014-03-27','13:35:00',2.26),('16273','2014-03-27','13:40:00',2.2),('16273','2014-03-27','13:45:00',2.21),('16273','2014-03-27','13:50:00',1.43),('16273','2014-03-27','13:55:00',1.23),('16273','2014-03-27','14:00:00',1.85),('16273','2014-03-27','14:05:00',1.41),('16273','2014-03-27','14:15:00',1.27),('16273','2014-03-27','14:20:00',2.31),('16273','2014-03-27','14:25:00',1.33),('16273','2014-03-27','14:30:00',1.04),('16273','2014-03-27','15:35:00',1.72),('16273','2014-03-27','15:40:00',1.06),('16273','2014-03-27','15:45:00',1.15),('16273','2014-03-27','15:50:00',1.67),('16273','2014-03-27','16:20:00',1.14),('16273','2014-03-27','16:40:00',1.27),('16273','2013-04-01','08:05:00',1.01),('16273','2013-04-01','08:10:00',1.15),('16273','2013-04-01','08:15:00',1.21),('16273','2013-04-01','08:20:00',1.53),('16273','2013-04-01','08:25:00',1.19),('16273','2013-04-01','08:30:00',1.54),('16273','2013-04-01','08:35:00',1.44),('16273','2013-04-01','08:40:00',1.65),('16273','2013-04-01','08:45:00',2.31),('16273','2013-04-01','08:50:00',2.24),('16273','2013-04-01','08:55:00',2.32),('16273','2013-04-01','09:00:00',2.38),('16273','2013-04-01','09:05:00',2.39),('16273','2013-04-01','09:10:00',2.53),('16273','2013-04-01','09:15:00',2.35),('16273','2013-04-01','09:20:00',2.31),('16273','2013-04-01','09:25:00',2.25),('16273','2013-04-01','09:30:00',2.09),('16273','2013-04-01','09:35:00',1.64),('16273','2013-04-01','09:40:00',2.84),('16273','2013-04-01','09:45:00',3.16),('16273','2013-04-01','09:50:00',2.82),('16273','2013-04-01','09:55:00',3.03),('16273','2013-04-01','10:00:00',3.48),('16273','2013-04-01','10:05:00',2.08),('16273','2013-04-01','10:10:00',2.27),('16273','2013-04-01','10:15:00',2.9),('16273','2013-04-01','10:20:00',3.18),('16273','2013-04-01','10:25:00',3.09),('16273','2013-04-01','10:30:00',1.8),('16273','2013-04-01','10:35:00',1.94),('16273','2013-04-01','10:40:00',3.29),('16273','2013-04-01','10:45:00',2.87),('16273','2013-04-01','10:50:00',1.95),('16273','2013-04-01','10:55:00',1.44),('16273','2013-04-01','11:00:00',2.85),('16273','2013-04-01','11:05:00',1.95),('16273','2013-04-01','11:10:00',1.59),('16273','2013-04-01','11:15:00',2.8),('16273','2013-04-01','11:20:00',1.86),('16273','2013-04-01','11:25:00',3.54),('16273','2013-04-01','11:30:00',2.06),('16273','2013-04-01','11:35:00',2.76),('16273','2013-04-01','11:40:00',2.8),('16273','2013-04-01','11:45:00',2.12),('16273','2013-04-01','11:50:00',1.97),('16273','2013-04-01','11:55:00',2.42),('16273','2013-04-01','12:00:00',2.14),('16273','2013-04-01','12:05:00',2.16),('16273','2013-04-01','12:10:00',2.38),('16273','2013-04-01','12:15:00',1.95),('16273','2013-04-01','12:20:00',1.79),('16273','2013-04-01','12:25:00',2.29),('16273','2013-04-01','12:30:00',2.3),('16273','2013-04-01','12:35:00',2.17),('16273','2013-04-01','12:40:00',2.47),('16273','2013-04-01','12:45:00',2.54),('16273','2013-04-01','12:50:00',2.86),('16273','2013-04-01','12:55:00',2.6),('16273','2013-04-01','13:00:00',2.89),('16273','2013-04-01','13:05:00',2.95),('16273','2013-04-01','13:10:00',2.69),('16273','2013-04-01','13:15:00',2.55),('16273','2013-04-01','13:20:00',2.54),('16273','2013-04-01','13:25:00',2.66),('16273','2013-04-01','13:30:00',2.27),('16273','2013-04-01','13:35:00',2.43),('16273','2013-04-01','13:40:00',3.16),('16273','2013-04-01','13:45:00',3.3),('16273','2013-04-01','13:50:00',2.76),('16273','2013-04-01','13:55:00',2.35),('16273','2013-04-01','14:00:00',1.71),('16273','2013-04-01','14:05:00',1.9),('16273','2013-04-01','14:10:00',2.11),('16273','2013-04-01','14:15:00',2.15),('16273','2013-04-01','14:20:00',3.38),('16273','2013-04-01','14:25:00',3.35),('16273','2013-04-01','14:30:00',2.56),('16273','2013-04-01','14:35:00',2.09),('16273','2013-04-01','14:40:00',1.77),('16273','2013-04-01','14:45:00',2.17),('16273','2013-04-01','14:50:00',2.09),('16273','2013-04-01','14:55:00',1.79),('16273','2013-04-01','15:00:00',1.69),('16273','2013-04-01','15:05:00',1.8),('16273','2013-04-01','15:10:00',1.97),('16273','2013-04-01','15:15:00',1.91),('16273','2013-04-01','15:20:00',2.16),('16273','2013-04-01','15:25:00',1.85),('16273','2013-04-01','15:30:00',2.04),('16273','2013-04-01','15:35:00',1.82),('16273','2013-04-01','15:40:00',1.99),('16273','2013-04-01','15:45:00',2.56),('16273','2013-04-01','15:50:00',2.2),('16273','2013-04-01','15:55:00',1.83),('16273','2013-04-01','16:00:00',1.43),('16273','2013-04-01','16:05:00',1.25),('16273','2013-03-31','09:05:00',1.16),('16273','2013-03-31','09:15:00',1.12),('16273','2013-03-31','09:20:00',1.8),('16273','2013-03-31','09:25:00',2.05),('16273','2013-03-31','09:30:00',1.43),('16273','2013-03-31','09:35:00',1.1),('16273','2013-03-31','09:40:00',2.06),('16273','2013-03-31','10:05:00',1.05),('16273','2013-03-31','10:10:00',1.25),('16273','2013-03-31','10:15:00',1.63),('16273','2013-03-31','10:20:00',1.74),('16273','2013-03-31','10:25:00',1.32),('16273','2013-03-31','10:30:00',1.37),('16273','2013-03-31','10:45:00',1.13),('16273','2013-03-31','10:50:00',1.4),('16273','2013-03-31','11:00:00',2.88),('16273','2013-03-31','11:05:00',1.01),('16273','2013-03-31','11:20:00',1.12),('16273','2013-03-31','11:25:00',1.63),('16273','2013-03-31','11:30:00',2.6),('16273','2013-03-31','11:35:00',3.96),('16273','2013-03-31','11:40:00',3.23),('16273','2013-03-31','11:45:00',2.06),('16273','2013-03-31','11:50:00',1.14),('16273','2013-03-31','11:55:00',1.03),('16273','2013-03-31','12:25:00',1.16),('16273','2013-03-31','12:30:00',2.25),('16273','2013-03-31','12:35:00',2.74),('16273','2013-03-31','12:40:00',3.56),('16273','2013-03-31','12:45:00',2.8),('16273','2013-03-31','12:50:00',2.4),('16273','2013-03-31','12:55:00',2.71),('16273','2013-03-31','13:00:00',2),('16273','2013-03-31','13:05:00',1.47),('16273','2013-03-31','13:10:00',2.51),('16273','2013-03-31','13:15:00',3.66),('16273','2013-03-31','13:20:00',3.55),('16273','2013-03-31','13:25:00',1.24),('16273','2013-03-31','13:30:00',1.18),('16273','2013-03-31','13:35:00',2.24),('16273','2013-03-31','13:40:00',3.22),('16273','2013-03-31','13:45:00',2.95),('16273','2013-03-31','13:50:00',2.44),('16273','2013-03-31','13:55:00',3.05),('16273','2013-03-31','14:00:00',3.36),('16273','2013-03-31','14:05:00',3.41),('16273','2013-03-31','14:10:00',3.44),('16273','2013-03-31','14:15:00',2.52),('16273','2013-03-31','14:20:00',3.33),('16273','2013-03-31','14:25:00',2.61),('16273','2013-03-31','14:30:00',2.03),('16273','2013-03-31','14:35:00',3.64),('16273','2013-03-31','14:40:00',3.66),('16273','2013-03-31','14:45:00',3.49),('16273','2013-03-31','14:50:00',2.3),('16273','2013-03-31','14:55:00',3.57),('16273','2013-03-31','15:00:00',2.86),('16273','2013-03-31','15:05:00',3.3),('16273','2013-03-31','15:10:00',3.61),('16273','2013-03-31','15:15:00',3.41),('16273','2013-03-31','15:20:00',3.06),('16273','2013-03-31','15:25:00',2.59),('16273','2013-03-31','15:30:00',2.24),('16273','2013-03-31','15:35:00',2.15),('16273','2013-03-31','15:40:00',1.95),('16273','2013-03-31','15:45:00',1.12),('16273','2013-03-31','15:55:00',1.36),('16273','2013-03-31','16:10:00',1.45),('16273','2013-03-31','16:15:00',2.2),('16273','2013-03-31','16:20:00',1.1),('16273','2013-03-31','16:30:00',1.1),('16273','2013-03-31','16:35:00',1.04),('16273','2013-03-31','17:00:00',1.03),('16273','2013-03-31','17:30:00',1),('16273','2013-03-31','17:50:00',1.2),('16273','2013-03-30','09:35:00',1.82),('16273','2013-03-30','09:40:00',1.72),('16273','2013-03-30','09:45:00',1.78),('16273','2013-03-30','09:50:00',1.36),('16273','2013-03-30','09:55:00',1.73),('16273','2013-03-30','10:00:00',1.93),('16273','2013-03-30','10:05:00',1.71),('16273','2013-03-30','10:10:00',1.35),('16273','2013-03-30','10:15:00',1.38),('16273','2013-03-30','10:20:00',1.47),('16273','2013-03-30','10:25:00',1.63),('16273','2013-03-30','10:30:00',1.74),('16273','2013-03-30','10:35:00',1.48),('16273','2013-03-30','10:40:00',1.65),('16273','2013-03-30','10:45:00',1.67),('16273','2013-03-30','10:50:00',1.8),('16273','2013-03-30','10:55:00',1.6),('16273','2013-03-30','11:00:00',2.4),('16273','2013-03-30','11:05:00',2.35),('16273','2013-03-30','11:10:00',1.16),('16273','2013-03-30','11:15:00',1.13),('16273','2013-03-30','11:20:00',1.38),('16273','2013-03-30','11:25:00',1.97),('16273','2013-03-30','11:30:00',2.31),('16273','2013-03-30','11:35:00',3.02),('16273','2013-03-30','11:40:00',2.21),('16273','2013-03-30','11:45:00',2.36),('16273','2013-03-30','11:50:00',2.04),('16273','2013-03-30','11:55:00',2.17),('16273','2013-03-30','12:00:00',1.41),('16273','2013-03-30','12:55:00',1.95),('16273','2013-03-30','13:00:00',1.96),('16273','2013-03-30','13:05:00',1.62),('16273','2013-03-30','13:10:00',1.16),('16273','2013-03-30','13:15:00',1.26),('16273','2013-03-30','13:20:00',1.07),('16273','2013-03-30','13:40:00',2.27),('16273','2013-03-30','13:45:00',1.82),('16273','2013-03-30','13:50:00',1.92),('16273','2013-03-30','13:55:00',1.77),('16273','2013-03-30','14:00:00',2.1),('16273','2013-03-30','14:05:00',1.22),('16273','2013-03-30','14:10:00',1.36),('16273','2013-03-30','14:15:00',2.09),('16273','2013-03-30','14:20:00',2.4),('16273','2013-03-30','14:25:00',1.22),('16273','2013-03-30','14:30:00',1.31),('16273','2013-03-30','14:35:00',1.33),('16273','2013-03-30','14:40:00',1.42),('16273','2013-03-30','14:45:00',1.06),('16273','2013-03-30','14:55:00',1.15),('16273','2013-03-30','15:10:00',1.05),('16273','2013-03-30','15:15:00',1.03),('16273','2013-03-29','07:10:00',1.12),('16273','2013-03-29','07:15:00',1.28),('16273','2013-03-29','07:20:00',1.24),('16273','2013-03-29','07:25:00',1.46),('16273','2013-03-29','07:30:00',1.68),('16273','2013-03-29','07:35:00',1.78),('16273','2013-03-29','07:40:00',1.57),('16273','2013-03-29','07:45:00',1.92),('16273','2013-03-29','07:55:00',1.35),('16273','2013-03-29','08:00:00',2.27),('16273','2013-03-29','08:05:00',2.33),('16273','2013-03-29','08:10:00',1.74),('16273','2013-03-29','08:15:00',2.58),('16273','2013-03-29','08:20:00',2.49),('16273','2013-03-29','08:25:00',2.63),('16273','2013-03-29','08:30:00',2.75),('16273','2013-03-29','08:35:00',2.8),('16273','2013-03-29','08:40:00',2.68),('16273','2013-03-29','08:45:00',2.47),('16273','2013-03-29','08:50:00',2.24),('16273','2013-03-29','08:55:00',2.87),('16273','2013-03-29','09:00:00',3.05),('16273','2013-03-29','09:05:00',2.86),('16273','2013-03-29','09:10:00',3.28),('16273','2013-03-29','09:15:00',3.4),('16273','2013-03-29','09:20:00',3.3),('16273','2013-03-29','09:25:00',3.51),('16273','2013-03-29','09:30:00',3.53),('16273','2013-03-29','09:35:00',3.28),('16273','2013-03-29','09:40:00',3.25),('16273','2013-03-29','09:45:00',2.76),('16273','2013-03-29','09:50:00',3.52),('16273','2013-03-29','09:55:00',3.25),('16273','2013-03-29','10:00:00',2.86),('16273','2013-03-29','10:05:00',3.04),('16273','2013-03-29','10:10:00',3.03),('16273','2013-03-29','10:15:00',3.14),('16273','2013-03-29','10:20:00',2.82),('16273','2013-03-29','10:25:00',2.99),('16273','2013-03-29','10:30:00',3.21),('16273','2013-03-29','10:35:00',3.66),('16273','2013-03-29','10:40:00',3.45),('16273','2013-03-29','10:45:00',3.49),('16273','2013-03-29','10:50:00',3.49),('16273','2013-03-29','10:55:00',3.59),('16273','2013-03-29','11:00:00',3.95),('16273','2013-03-29','11:05:00',4.15),('16273','2013-03-29','11:10:00',3.06),('16273','2013-03-29','11:15:00',4.16),('16273','2013-03-29','11:20:00',3.54),('16273','2013-03-29','11:25:00',4.01),('16273','2013-03-29','11:30:00',3.96),('16273','2013-03-29','11:35:00',4.04),('16273','2013-03-29','11:40:00',4.04),('16273','2013-03-29','11:45:00',4.05),('16273','2013-03-29','11:50:00',4.04);
INSERT INTO `solarlog` VALUES ('16273','2013-03-29','11:55:00',4.06),('16273','2013-03-29','12:00:00',4.06),('16273','2013-03-29','12:05:00',4.07),('16273','2013-03-29','12:10:00',4.05),('16273','2013-03-29','12:15:00',4.03),('16273','2013-03-29','12:20:00',3.98),('16273','2013-03-29','12:25:00',3.87),('16273','2013-03-29','12:30:00',4.03),('16273','2013-03-29','12:35:00',3.99),('16273','2013-03-29','12:40:00',3.99),('16273','2013-03-29','12:45:00',4.01),('16273','2013-03-29','12:50:00',3.42),('16273','2013-03-29','12:55:00',3.64),('16273','2013-03-29','13:00:00',3.53),('16273','2013-03-29','13:05:00',3.67),('16273','2013-03-29','13:10:00',3.99),('16273','2013-03-29','13:15:00',3.95),('16273','2013-03-29','13:20:00',3.92),('16273','2013-03-29','13:25:00',3.54),('16273','2013-03-29','13:30:00',3.18),('16273','2013-03-29','13:35:00',2.67),('16273','2013-03-29','13:40:00',3.12),('16273','2013-03-29','13:45:00',3),('16273','2013-03-29','13:50:00',3.19),('16273','2013-03-29','13:55:00',3.34),('16273','2013-03-29','14:00:00',2.54),('16273','2013-03-29','14:05:00',2.2),('16273','2013-03-29','14:10:00',2.18),('16273','2013-03-29','14:15:00',2.1),('16273','2013-03-29','14:20:00',2.44),('16273','2013-03-29','14:25:00',1.98),('16273','2013-03-29','14:30:00',1.82),('16273','2013-03-29','14:35:00',1.78),('16273','2013-03-29','14:40:00',1.71),('16273','2013-03-29','14:45:00',1.61),('16273','2013-03-29','14:50:00',1.62),('16273','2013-03-29','14:55:00',1.46),('16273','2013-03-29','15:00:00',1.42),('16273','2013-03-29','15:05:00',1.38),('16273','2013-03-29','15:10:00',1.4),('16273','2013-03-29','15:15:00',1.27),('16273','2013-03-29','15:20:00',1.15),('16273','2013-03-29','15:25:00',1.08),('16273','2013-03-29','15:30:00',1.04),('16273','2013-03-29','15:45:00',1.1),('16273','2013-03-29','15:50:00',1.22),('16273','2013-03-29','15:55:00',1.5),('16273','2013-03-29','16:00:00',1.36),('16273','2013-03-29','16:05:00',1.03),('16273','2013-03-29','16:30:00',1.07),('16273','2013-03-29','16:35:00',1.52),('16273','2013-03-29','16:40:00',1.29),('16273','2013-03-29','16:45:00',1),('16273','2013-03-28','09:10:00',1.21),('16273','2013-03-28','09:15:00',1.7),('16273','2013-03-28','09:20:00',1.68),('16273','2013-03-28','09:25:00',1.11),('16273','2013-03-28','12:45:00',1.61),('16273','2013-03-28','12:50:00',1.37),('16273','2013-03-28','12:55:00',1.21),('16273','2013-03-28','13:00:00',1.37),('16273','2013-03-28','13:05:00',1.97),('16273','2013-03-28','13:10:00',1.63),('16273','2013-03-28','13:15:00',1.76),('16273','2013-03-28','13:20:00',2.03),('16273','2013-03-28','13:25:00',1.58),('16273','2013-03-28','13:30:00',1.51),('16273','2013-03-28','13:35:00',1.5),('16273','2013-03-28','13:40:00',1.02),('16273','2013-03-28','13:50:00',1.09),('16273','2013-03-28','13:55:00',1.52),('16273','2013-03-28','14:00:00',1.78),('16273','2013-03-28','14:05:00',1.67),('16273','2013-03-28','14:10:00',1.9),('16273','2013-03-28','14:15:00',1.93),('16273','2013-03-28','14:20:00',1.52),('16273','2013-03-28','14:25:00',1.19),('16273','2013-03-28','14:30:00',1.24),('16273','2013-03-28','14:35:00',1.24),('16273','2013-03-28','14:40:00',1.04),('16273','2013-03-28','15:00:00',1.07),('16273','2013-03-28','15:05:00',2.57),('16273','2013-03-28','15:10:00',3.28),('16273','2013-03-28','15:15:00',2.82),('16273','2013-03-28','15:20:00',1.33),('16273','2013-03-28','15:25:00',1.48),('16273','2013-03-28','15:30:00',1.27),('16273','2013-03-28','15:35:00',1.11),('16273','2013-03-28','15:40:00',1.78),('16273','2013-03-28','15:45:00',1.56),('16273','2013-03-28','15:50:00',1.79),('16273','2013-03-28','15:55:00',1.5),('16273','2013-03-28','16:00:00',1.21),('16273','2013-03-28','16:05:00',1.34),('16273','2013-03-28','16:10:00',1.59),('16273','2013-03-28','16:30:00',1.16),('16273','2013-03-28','16:55:00',1.1),('16273','2013-03-28','17:00:00',1.13),('16273','2013-03-28','17:05:00',1.03),('16273','2013-03-27','07:05:00',1.04),('16273','2013-03-27','07:15:00',1.17),('16273','2013-03-27','07:20:00',1.19),('16273','2013-03-27','07:25:00',1.47),('16273','2013-03-27','07:30:00',1.31),('16273','2013-03-27','07:35:00',1.53),('16273','2013-03-27','07:40:00',1.8),('16273','2013-03-27','07:45:00',2.12),('16273','2013-03-27','07:50:00',2.43),('16273','2013-03-27','07:55:00',1.55),('16273','2013-03-27','08:00:00',1.44),('16273','2013-03-27','08:05:00',1.16),('16273','2013-03-27','08:10:00',1.16),('16273','2013-03-27','08:15:00',1.14),('16273','2013-03-27','08:20:00',1.18),('16273','2013-03-27','08:25:00',1.5),('16273','2013-03-27','08:30:00',2.43),('16273','2013-03-27','08:35:00',1.99),('16273','2013-03-27','08:40:00',1.69),('16273','2013-03-27','08:45:00',1.97),('16273','2013-03-27','08:50:00',1.7),('16273','2013-03-27','08:55:00',1.08),('16273','2013-03-27','09:25:00',1.34),('16273','2013-03-27','09:30:00',1.78),('16273','2013-03-27','09:35:00',2.12),('16273','2013-03-27','09:40:00',3.26),('16273','2013-03-27','09:45:00',2.17),('16273','2013-03-27','09:50:00',3.63),('16273','2013-03-27','09:55:00',3.28),('16273','2013-03-27','10:00:00',2),('16273','2013-03-27','10:05:00',2.21),('16273','2013-03-27','10:10:00',3.16),('16273','2013-03-27','10:15:00',2.13),('16273','2013-03-27','10:20:00',2.93),('16273','2013-03-27','10:25:00',2.43),('16273','2013-03-27','10:30:00',2.32),('16273','2013-03-27','10:35:00',2.88),('16273','2013-03-27','10:40:00',2.7),('16273','2013-03-27','10:45:00',2.55),('16273','2013-03-27','10:50:00',1.99),('16273','2013-03-27','10:55:00',1.72),('16273','2013-03-27','11:00:00',1.68),('16273','2013-03-27','11:05:00',1.44),('16273','2013-03-27','11:10:00',1.03),('16273','2013-03-27','11:25:00',1.3),('16273','2013-03-27','11:30:00',1.69),('16273','2013-03-27','11:35:00',1.74),('16273','2013-03-27','11:40:00',1.6),('16273','2013-03-27','11:45:00',1.73),('16273','2013-03-27','11:50:00',2.83),('16273','2013-03-27','11:55:00',2.77),('16273','2013-03-27','12:00:00',2.3),('16273','2013-03-27','12:05:00',1.69),('16273','2013-03-27','12:10:00',1.99),('16273','2013-03-27','12:15:00',1.4),('16273','2013-03-27','12:20:00',1.13),('16273','2013-03-27','12:25:00',1.16),('16273','2013-03-27','12:30:00',1.61),('16273','2013-03-27','12:35:00',2.13),('16273','2013-03-27','12:40:00',2.99),('16273','2013-03-27','12:45:00',1.74),('16273','2013-03-27','12:50:00',2.17),('16273','2013-03-27','12:55:00',3.2),('16273','2013-03-27','13:00:00',3.13),('16273','2013-03-27','13:05:00',2.35),('16273','2013-03-27','13:10:00',2.11),('16273','2013-03-27','13:15:00',1.71),('16273','2013-03-27','13:20:00',1.65),('16273','2013-03-27','13:25:00',1.69),('16273','2013-03-27','13:30:00',1.81),('16273','2013-03-27','13:35:00',2.12),('16273','2013-03-27','13:40:00',2.36),('16273','2013-03-27','13:45:00',2.13),('16273','2013-03-27','13:50:00',1.73),('16273','2013-03-27','13:55:00',1.65),('16273','2013-03-27','14:00:00',1.5),('16273','2013-03-27','14:05:00',1.65),('16273','2013-03-27','14:10:00',1.9),('16273','2013-03-27','14:15:00',1.79),('16273','2013-03-27','14:20:00',1.57),('16273','2013-03-27','14:25:00',1.33),('16273','2013-03-27','14:30:00',1.49),('16273','2013-03-27','14:35:00',1.6),('16273','2013-03-27','14:40:00',1.32),('16273','2013-03-27','14:45:00',1.3),('16273','2013-03-27','15:20:00',1),('16273','2013-03-26','07:45:00',1.27),('16273','2013-03-26','08:25:00',1.02),('16273','2013-03-26','09:05:00',1.35),('16273','2013-03-26','09:10:00',1.43),('16273','2013-03-26','09:40:00',1.35),('16273','2013-03-26','09:45:00',1.55),('16273','2013-03-26','09:50:00',1.83),('16273','2013-03-26','10:45:00',1.06),('16273','2013-03-26','10:50:00',1.33),('16273','2013-03-26','10:55:00',2.14),('16273','2013-03-26','11:00:00',1.61),('16273','2013-03-26','11:40:00',1.07),('16273','2013-03-26','11:45:00',2.93),('16273','2013-03-26','11:50:00',3.06),('16273','2013-03-26','11:55:00',2.56),('16273','2013-03-26','12:00:00',1.57),('16273','2013-03-26','12:05:00',1.37),('16273','2013-03-26','12:10:00',1.32),('16273','2013-03-26','12:15:00',1.56),('16273','2013-03-26','12:20:00',2.81),('16273','2013-03-26','12:25:00',2.42),('16273','2013-03-26','12:30:00',2.2),('16273','2013-03-26','12:35:00',1.62),('16273','2013-03-26','12:40:00',2.18),('16273','2013-03-26','12:45:00',1.28),('16273','2013-03-26','12:50:00',1.13),('16273','2013-03-26','12:55:00',1.71),('16273','2013-03-26','13:00:00',1.65),('16273','2013-03-26','13:05:00',1.51),('16273','2013-03-26','13:10:00',1.12),('16273','2013-03-26','13:15:00',1.59),('16273','2013-03-26','13:20:00',1.82),('16273','2013-03-26','13:25:00',1.65),('16273','2013-03-26','13:30:00',2.15),('16273','2013-03-26','13:35:00',2.36),('16273','2013-03-26','13:40:00',1.81),('16273','2013-03-26','13:45:00',1.29),('16273','2013-03-26','13:50:00',1.41),('16273','2013-03-26','13:55:00',1.22),('16273','2013-03-26','14:00:00',1.45),('16273','2013-03-26','14:05:00',1.46),('16273','2013-03-26','14:10:00',1.32),('16273','2013-03-26','14:15:00',1.19),('16273','2013-03-26','14:20:00',1.05),('16273','2013-03-26','14:25:00',1.08),('16273','2013-03-26','14:30:00',1.09),('16273','2013-03-26','14:35:00',1.07),('16273','2013-03-25','08:15:00',2.54),('16273','2013-03-25','08:20:00',2.78),('16273','2013-03-25','08:25:00',2.91),('16273','2013-03-25','08:30:00',2.48),('16273','2013-03-25','08:40:00',1.73),('16273','2013-03-25','08:45:00',2.41),('16273','2013-03-25','08:50:00',1.49),('16273','2013-03-25','09:15:00',1.69),('16273','2013-03-25','09:20:00',3.16),('16273','2013-03-25','10:05:00',1.58),('16273','2013-03-25','10:10:00',1.37),('16273','2013-03-25','10:15:00',1.23),('16273','2013-03-25','10:20:00',1.11),('16273','2013-03-25','10:25:00',1.51),('16273','2013-03-25','10:30:00',1.52),('16273','2013-03-25','10:35:00',1.89),('16273','2013-03-25','10:40:00',1.68),('16273','2013-03-25','10:45:00',1.46),('16273','2013-03-25','10:50:00',1.66),('16273','2013-03-25','11:15:00',1.98),('16273','2013-03-25','11:20:00',1.3),('16273','2013-03-25','11:35:00',1.47),('16273','2013-03-25','11:40:00',2.69),('16273','2013-03-25','11:45:00',3.46),('16273','2013-03-25','11:50:00',3.77),('16273','2013-03-25','11:55:00',2.58),('16273','2013-03-25','12:00:00',2.13),('16273','2013-03-25','12:05:00',1.52),('16273','2013-03-25','12:10:00',3.75),('16273','2013-03-25','12:15:00',4.42),('16273','2013-03-25','12:20:00',3.52),('16273','2013-03-25','12:25:00',3.13),('16273','2013-03-25','12:30:00',3.34),('16273','2013-03-25','12:35:00',3.62),('16273','2013-03-25','12:40:00',4.34),('16273','2013-03-25','12:45:00',4.1),('16273','2013-03-25','12:50:00',1.34),('16273','2013-03-25','12:55:00',2.35),('16273','2013-03-25','13:00:00',1.35),('16273','2013-03-25','13:05:00',1.11),('16273','2013-03-25','13:10:00',1.18),('16273','2013-03-25','13:15:00',1.03),('16273','2013-03-25','13:20:00',2.82),('16273','2013-03-25','13:25:00',2.61),('16273','2013-03-25','13:30:00',2.66),('16273','2013-03-25','13:35:00',1.18),('16273','2013-03-25','13:40:00',1.62),('16273','2013-03-25','13:45:00',3.05),('16273','2013-03-25','13:50:00',2.35),('16273','2013-03-25','13:55:00',2.67),('16273','2013-03-25','14:00:00',2.73),('16273','2013-03-25','14:05:00',2.4),('16273','2013-03-25','14:10:00',2.15),('16273','2013-03-25','14:15:00',2.12),('16273','2013-03-25','14:20:00',2.36),('16273','2013-03-25','14:25:00',1.46),('16273','2013-03-25','14:30:00',2.25),('16273','2013-03-25','14:35:00',1.52),('16273','2013-03-25','14:40:00',1.55),('16273','2013-03-25','14:45:00',1.58),('16273','2013-03-25','14:50:00',2.32),('16273','2013-03-25','14:55:00',2.02),('16273','2013-03-25','15:00:00',2.31),('16273','2013-03-25','15:05:00',1.64),('16273','2013-03-25','15:10:00',2),('16273','2013-03-25','15:15:00',1.42),('16273','2013-03-25','15:20:00',1.99),('16273','2013-03-25','15:25:00',2.55),('16273','2013-03-25','15:30:00',1.65),('16273','2013-03-25','15:35:00',1.84),('16273','2013-03-25','15:40:00',2.08),('16273','2013-03-25','15:45:00',1.86),('16273','2013-03-25','15:50:00',1.71),('16273','2013-03-25','15:55:00',1.01),('16273','2013-03-25','16:00:00',1.41),('16273','2013-03-25','16:05:00',1.19),('16273','2013-03-25','16:20:00',1.43),('16273','2013-03-25','16:25:00',1.46),('16273','2013-03-25','16:30:00',1.37),('16273','2013-03-25','16:35:00',1.24),('16273','2013-03-24','07:20:00',1.01),('16273','2013-03-24','07:25:00',1.2),('16273','2013-03-24','07:35:00',1.18),('16273','2013-03-24','07:40:00',1.26),('16273','2013-03-24','07:45:00',1.5),('16273','2013-03-24','07:50:00',1.55),('16273','2013-03-24','07:55:00',1.71),('16273','2013-03-24','08:00:00',2.05),('16273','2013-03-24','08:05:00',2.21),('16273','2013-03-24','08:10:00',2.24),('16273','2013-03-24','08:15:00',2.37),('16273','2013-03-24','08:20:00',2.41),('16273','2013-03-24','08:25:00',2.46),('16273','2013-03-24','08:30:00',2.55),('16273','2013-03-24','08:35:00',2.63),('16273','2013-03-24','08:40:00',2.7),('16273','2013-03-24','08:45:00',2.76),('16273','2013-03-24','08:50:00',2.73),('16273','2013-03-24','08:55:00',2.82),('16273','2013-03-24','09:00:00',2.87),('16273','2013-03-24','09:05:00',2.92),('16273','2013-03-24','09:10:00',3.03),('16273','2013-03-24','09:15:00',3.1),('16273','2013-03-24','09:20:00',3.12),('16273','2013-03-24','09:25:00',3.17),('16273','2013-03-24','09:30:00',3.23),('16273','2013-03-24','09:35:00',3.28),('16273','2013-03-24','09:40:00',3.32),('16273','2013-03-24','09:45:00',3.37),('16273','2013-03-24','09:50:00',3.41),('16273','2013-03-24','09:55:00',3.44),('16273','2013-03-24','10:00:00',3.48),('16273','2013-03-24','10:05:00',3.46),('16273','2013-03-24','10:10:00',3.53),('16273','2013-03-24','10:15:00',3.57),('16273','2013-03-24','10:20:00',3.57),('16273','2013-03-24','10:25:00',3.56),('16273','2013-03-24','10:30:00',3.59),('16273','2013-03-24','10:35:00',3.62),('16273','2013-03-24','10:40:00',3.63),('16273','2013-03-24','10:45:00',3.65),('16273','2013-03-24','10:50:00',3.66),('16273','2013-03-24','10:55:00',3.7),('16273','2013-03-24','11:00:00',3.71),('16273','2013-03-24','11:05:00',3.7),('16273','2013-03-24','11:10:00',3.74),('16273','2013-03-24','11:15:00',3.79),('16273','2013-03-24','11:20:00',3.79),('16273','2013-03-24','11:25:00',3.8),('16273','2013-03-24','11:30:00',3.78),('16273','2013-03-24','11:35:00',3.76),('16273','2013-03-24','11:40:00',3.77),('16273','2013-03-24','11:45:00',3.78),('16273','2013-03-24','11:50:00',3.76),('16273','2013-03-24','11:55:00',3.76),('16273','2013-03-24','12:00:00',3.74),('16273','2013-03-24','12:05:00',3.72),('16273','2013-03-24','12:10:00',3.75),('16273','2013-03-24','12:15:00',3.79),('16273','2013-03-24','12:20:00',3.78),('16273','2013-03-24','12:25:00',3.78),('16273','2013-03-24','12:30:00',3.78),('16273','2013-03-24','12:35:00',3.77),('16273','2013-03-24','12:40:00',3.77),('16273','2013-03-24','12:45:00',3.75),('16273','2013-03-24','12:50:00',3.72),('16273','2013-03-24','12:55:00',3.69),('16273','2013-03-24','13:00:00',3.65),('16273','2013-03-24','13:05:00',3.55),('16273','2013-03-24','13:10:00',3.57),('16273','2013-03-24','13:15:00',3.56),('16273','2013-03-24','13:20:00',3.5),('16273','2013-03-24','13:25:00',3.47),('16273','2013-03-24','13:30:00',3.43),('16273','2013-03-24','13:35:00',3.39),('16273','2013-03-24','13:40:00',3.35),('16273','2013-03-24','13:45:00',3.29),('16273','2013-03-24','13:50:00',3.24),('16273','2013-03-24','13:55:00',3.18),('16273','2013-03-24','14:00:00',3.12),('16273','2013-03-24','14:05:00',3.06),('16273','2013-03-24','14:10:00',3.01),('16273','2013-03-24','14:15:00',2.93),('16273','2013-03-24','14:20:00',2.84),('16273','2013-03-24','14:25:00',2.73),('16273','2013-03-24','14:30:00',2.61),('16273','2013-03-24','14:35:00',2.58),('16273','2013-03-24','14:40:00',2.61),('16273','2013-03-24','14:45:00',2.52),('16273','2013-03-24','14:50:00',2.42),('16273','2013-03-24','14:55:00',2.37),('16273','2013-03-24','15:00:00',2.31),('16273','2013-03-24','15:05:00',2.27),('16273','2013-03-24','15:10:00',2.15),('16273','2013-03-24','15:15:00',2.16),('16273','2013-03-24','15:20:00',2.07),('16273','2013-03-24','15:25:00',1.91),('16273','2013-03-24','15:30:00',1.89),('16273','2013-03-24','15:35:00',1.86),('16273','2013-03-24','15:40:00',1.71),('16273','2013-03-24','15:45:00',1.06),('16273','2013-03-24','15:50:00',1.07),('16273','2013-03-24','15:55:00',1.03),('16273','2013-03-24','16:00:00',1.03),('16273','2013-03-24','16:15:00',1.24),('16273','2013-03-24','16:20:00',1.02),('16273','2013-03-23','07:15:00',1.09),('16273','2013-03-23','07:20:00',1.2),('16273','2013-03-23','07:25:00',1.01),('16273','2013-03-23','07:30:00',1.34),('16273','2013-03-23','07:35:00',1.41),('16273','2013-03-23','07:40:00',1.56),('16273','2013-03-23','07:45:00',1.61),('16273','2013-03-23','07:50:00',1.84),('16273','2013-03-23','07:55:00',2.02),('16273','2013-03-23','08:00:00',2.2),('16273','2013-03-23','08:05:00',2.27),('16273','2013-03-23','08:10:00',2.32),('16273','2013-03-23','08:15:00',2.39),('16273','2013-03-23','08:20:00',2.45),('16273','2013-03-23','08:25:00',2.5),('16273','2013-03-23','08:30:00',2.58),('16273','2013-03-23','08:35:00',2.66),('16273','2013-03-23','08:40:00',2.74),('16273','2013-03-23','08:45:00',2.77),('16273','2013-03-23','08:50:00',2.95),('16273','2013-03-23','08:55:00',2.96),('16273','2013-03-23','09:00:00',3.05),('16273','2013-03-23','09:05:00',3.13),('16273','2013-03-23','09:10:00',3.17),('16273','2013-03-23','09:15:00',3.18),('16273','2013-03-23','09:20:00',3.27),('16273','2013-03-23','09:25:00',3.31),('16273','2013-03-23','09:30:00',3.4),('16273','2013-03-23','09:35:00',3.28),('16273','2013-03-23','09:40:00',3.48),('16273','2013-03-23','09:45:00',3.46),('16273','2013-03-23','09:50:00',3.57),('16273','2013-03-23','09:55:00',3.59),('16273','2013-03-23','10:00:00',3.56),('16273','2013-03-23','10:05:00',3.51),('16273','2013-03-23','10:10:00',3.6),('16273','2013-03-23','10:15:00',3.59),('16273','2013-03-23','10:20:00',3.17),('16273','2013-03-23','10:25:00',3.38),('16273','2013-03-23','10:30:00',3.72),('16273','2013-03-23','10:35:00',3.63),('16273','2013-03-23','10:40:00',3.53),('16273','2013-03-23','10:45:00',3.56),('16273','2013-03-23','10:50:00',3.47),('16273','2013-03-23','10:55:00',3.14),('16273','2013-03-23','11:00:00',2.95),('16273','2013-03-23','11:05:00',1.96),('16273','2013-03-23','11:10:00',2.82),('16273','2013-03-23','11:15:00',3.5),('16273','2013-03-23','11:20:00',3.67),('16273','2013-03-23','11:25:00',3.53),('16273','2013-03-23','11:30:00',2.98),('16273','2013-03-23','11:35:00',3.9),('16273','2013-03-23','11:40:00',3.79),('16273','2013-03-23','11:45:00',3.52),('16273','2013-03-23','11:50:00',3.67),('16273','2013-03-23','11:55:00',3.67),('16273','2013-03-23','12:00:00',3.68),('16273','2013-03-23','12:05:00',3.68),('16273','2013-03-23','12:10:00',3.77),('16273','2013-03-23','12:15:00',3.71),('16273','2013-03-23','12:20:00',3.71),('16273','2013-03-23','12:25:00',3.65),('16273','2013-03-23','12:30:00',3.7),('16273','2013-03-23','12:35:00',3.57),('16273','2013-03-23','12:40:00',3.61),('16273','2013-03-23','12:45:00',3.71),('16273','2013-03-23','12:50:00',3.68),('16273','2013-03-23','12:55:00',2.9),('16273','2013-03-23','13:00:00',3.4),('16273','2013-03-23','13:05:00',3.57),('16273','2013-03-23','13:10:00',3.45),('16273','2013-03-23','13:15:00',3.52),('16273','2013-03-23','13:20:00',3.51),('16273','2013-03-23','13:25:00',3.41),('16273','2013-03-23','13:30:00',3.4),('16273','2013-03-23','13:35:00',3.37),('16273','2013-03-23','13:40:00',3.29),('16273','2013-03-23','13:45:00',3.23),('16273','2013-03-23','13:50:00',3.19),('16273','2013-03-23','13:55:00',3.17),('16273','2013-03-23','14:00:00',3.17),('16273','2013-03-23','14:05:00',3.04),('16273','2013-03-23','14:10:00',2.92),('16273','2013-03-23','14:15:00',2.91),('16273','2013-03-23','14:20:00',2.87),('16273','2013-03-23','14:25:00',2.87),('16273','2013-03-23','14:30:00',2.75),('16273','2013-03-23','14:35:00',2.66),('16273','2013-03-23','14:40:00',2.52),('16273','2013-03-23','14:45:00',2.43),('16273','2013-03-23','14:50:00',2.41),('16273','2013-03-23','14:55:00',2.32),('16273','2013-03-23','15:00:00',2.37),('16273','2013-03-23','15:05:00',2.2),('16273','2013-03-23','15:10:00',2.09),('16273','2013-03-23','15:15:00',2.03),('16273','2013-03-23','15:20:00',2.06),('16273','2013-03-23','15:25:00',1.95),('16273','2013-03-23','15:30:00',1.71),('16273','2013-03-23','15:35:00',1.72),('16273','2013-03-23','15:40:00',1.65),('16273','2013-03-23','15:45:00',1.35),('16273','2013-03-23','15:50:00',1.36),('16273','2013-03-23','15:55:00',1.26),('16273','2013-03-23','16:00:00',1.24),('16273','2013-03-23','16:05:00',1.38),('16273','2013-03-23','16:10:00',1.44),('16273','2013-03-23','16:15:00',1.28),('16273','2013-03-23','16:20:00',1.12),('16273','2014-03-26','07:10:00',1.13),('16273','2014-03-26','07:15:00',1.25),('16273','2014-03-26','07:20:00',1.49),('16273','2014-03-26','07:25:00',1.32),('16273','2014-03-26','07:30:00',1.74),('16273','2014-03-26','07:35:00',1.94),('16273','2014-03-26','07:40:00',1.84),('16273','2014-03-26','07:45:00',1.94),('16273','2014-03-26','07:50:00',2),('16273','2014-03-26','07:55:00',2.09),('16273','2014-03-26','08:00:00',2.19),('16273','2014-03-26','08:05:00',2.3),('16273','2014-03-26','08:10:00',2.45),('16273','2014-03-26','08:15:00',2.58),('16273','2014-03-26','08:40:00',1.04),('16273','2014-03-26','08:45:00',1.23),('16273','2014-03-26','08:50:00',1.44),('16273','2014-03-26','08:55:00',1.5),('16273','2014-03-26','09:00:00',2.11),('16273','2014-03-26','09:05:00',3.02),('16273','2014-03-26','09:10:00',2.88),('16273','2014-03-26','09:15:00',3.72),('16273','2014-03-26','09:20:00',3.48),('16273','2014-03-26','09:25:00',3.3),('16273','2014-03-26','09:30:00',3.31),('16273','2014-03-26','09:35:00',3.35),('16273','2014-03-26','09:40:00',3.38),('16273','2014-03-26','09:45:00',3.38),('16273','2014-03-26','09:50:00',3.42),('16273','2014-03-26','09:55:00',3.44),('16273','2014-03-26','10:00:00',3.5),('16273','2014-03-26','10:05:00',3.57),('16273','2014-03-26','10:10:00',3.62),('16273','2014-03-26','10:15:00',3.3),('16273','2014-03-26','10:20:00',1.39),('16273','2014-03-26','10:25:00',1.15),('16273','2014-03-26','10:30:00',1.08),('16273','2014-03-26','10:35:00',1.06),('16273','2014-03-26','10:40:00',1.32),('16273','2014-03-26','10:45:00',3.34),('16273','2014-03-26','10:50:00',3.56),('16273','2014-03-26','10:55:00',2.27),('16273','2014-03-26','11:00:00',1.24),('16273','2014-03-26','11:05:00',1.74),('16273','2014-03-26','11:10:00',1.26),('16273','2014-03-26','11:15:00',1.26),('16273','2014-03-26','11:20:00',1.04),('16273','2014-03-26','11:35:00',1.04),('16273','2014-03-26','11:40:00',1.84),('16273','2014-03-26','11:45:00',2.29),('16273','2014-03-26','11:50:00',2.7),('16273','2014-03-26','11:55:00',3.03),('16273','2014-03-26','12:00:00',3.22),('16273','2014-03-26','12:05:00',2.07),('16273','2014-03-26','12:10:00',1.13),('16273','2014-03-26','12:15:00',1.02),('16273','2014-03-26','12:20:00',1.47),('16273','2014-03-26','12:25:00',1.67),('16273','2014-03-26','12:30:00',2.07),('16273','2014-03-26','12:35:00',4.03),('16273','2014-03-26','12:40:00',4.35),('16273','2014-03-26','12:45:00',4.29),('16273','2014-03-26','12:50:00',3.85),('16273','2014-03-26','12:55:00',3.88),('16273','2014-03-26','13:00:00',1.59),('16273','2014-03-26','13:05:00',1.16),('16273','2014-03-26','13:10:00',1.1),('16273','2014-03-26','13:15:00',1.08),('16273','2014-03-26','13:20:00',1.9),('16273','2014-03-26','13:25:00',2.82),('16273','2014-03-26','13:30:00',3.77),('16273','2014-03-26','13:35:00',3),('16273','2014-03-26','13:40:00',2.14),('16273','2014-03-26','13:45:00',3.05),('16273','2014-03-26','13:50:00',3.31),('16273','2014-03-26','13:55:00',3.05),('16273','2014-03-26','14:00:00',3.08),('16273','2014-03-26','14:05:00',3.46),('16273','2014-03-26','14:10:00',3.36),('16273','2014-03-26','14:15:00',1.55),('16273','2014-03-26','14:20:00',1.05),('16273','2014-03-26','14:25:00',1.07),('16273','2014-03-26','14:45:00',1.09),('16273','2014-03-26','14:50:00',2.01),('16273','2014-03-26','14:55:00',2.26),('16273','2014-03-26','15:00:00',2.44),('16273','2014-03-26','15:05:00',2.4),('16273','2014-03-26','15:10:00',2.15),('16273','2014-03-26','15:15:00',2.28),('16273','2014-03-26','15:20:00',1.76),('16273','2014-03-26','15:25:00',2),('16273','2014-03-26','15:30:00',2.11),('16273','2014-03-26','15:35:00',1.91),('16273','2014-03-26','15:40:00',1.57),('16273','2014-03-26','15:50:00',1.12),('16273','2014-03-26','16:10:00',1.21),('16273','2014-03-26','16:15:00',1.49),('16273','2014-03-26','16:20:00',1.28),('16273','2013-03-22','07:15:00',1.1),('16273','2013-03-22','07:20:00',1.21),('16273','2013-03-22','07:25:00',1.26),('16273','2013-03-22','07:30:00',1.27),('16273','2013-03-22','07:35:00',1.58),('16273','2013-03-22','07:40:00',1.67),('16273','2013-03-22','07:45:00',1.78),('16273','2013-03-22','07:50:00',1.89),('16273','2013-03-22','07:55:00',1.98),('16273','2013-03-22','08:00:00',2.06),('16273','2013-03-22','08:05:00',2.19),('16273','2013-03-22','08:10:00',2.31),('16273','2013-03-22','08:15:00',2.41),('16273','2013-03-22','08:20:00',2.47),('16273','2013-03-22','08:25:00',2.53),('16273','2013-03-22','08:30:00',2.61),('16273','2013-03-22','08:35:00',2.71),('16273','2013-03-22','08:40:00',2.77),('16273','2013-03-22','08:45:00',2.82),('16273','2013-03-22','08:50:00',2.87),('16273','2013-03-22','08:55:00',2.94),('16273','2013-03-22','09:00:00',2.99),('16273','2013-03-22','09:05:00',3.03),('16273','2013-03-22','09:10:00',3.08),('16273','2013-03-22','09:15:00',3.15),('16273','2013-03-22','09:20:00',3.19),('16273','2013-03-22','09:25:00',3.28),('16273','2013-03-22','09:30:00',3.33),('16273','2013-03-22','09:35:00',3.34),('16273','2013-03-22','09:40:00',3.41),('16273','2013-03-22','09:45:00',3.46),('16273','2013-03-22','09:50:00',3.5),('16273','2013-03-22','09:55:00',3.55),('16273','2013-03-22','10:00:00',3.59),('16273','2013-03-22','10:05:00',3.62),('16273','2013-03-22','10:10:00',3.68),('16273','2013-03-22','10:15:00',3.71),('16273','2013-03-22','10:20:00',3.72),('16273','2013-03-22','10:25:00',3.75),('16273','2013-03-22','10:30:00',3.77),('16273','2013-03-22','10:35:00',3.78),('16273','2013-03-22','10:40:00',3.81),('16273','2013-03-22','10:45:00',3.84),('16273','2013-03-22','10:50:00',3.81),('16273','2013-03-22','10:55:00',3.85),('16273','2013-03-22','11:00:00',3.89),('16273','2013-03-22','11:05:00',3.9),('16273','2013-03-22','11:10:00',3.9),('16273','2013-03-22','11:15:00',3.88),('16273','2013-03-22','11:20:00',3.88),('16273','2013-03-22','11:25:00',3.91),('16273','2013-03-22','11:30:00',3.85),('16273','2013-03-22','11:35:00',3.96),('16273','2013-03-22','11:40:00',3.97),('16273','2013-03-22','11:45:00',3.97),('16273','2013-03-22','11:50:00',3.98),('16273','2013-03-22','11:55:00',3.98),('16273','2013-03-22','12:00:00',3.98),('16273','2013-03-22','12:05:00',3.97),('16273','2013-03-22','12:10:00',3.98),('16273','2013-03-22','12:15:00',3.93),('16273','2013-03-22','12:20:00',3.93),('16273','2013-03-22','12:25:00',3.93),('16273','2013-03-22','12:30:00',3.92),('16273','2013-03-22','12:35:00',3.88),('16273','2013-03-22','12:40:00',3.7),('16273','2013-03-22','12:45:00',3.86),('16273','2013-03-22','12:50:00',3.79),('16273','2013-03-22','12:55:00',3.81),('16273','2013-03-22','13:00:00',3.77),('16273','2013-03-22','13:05:00',3.75),('16273','2013-03-22','13:10:00',3.7),('16273','2013-03-22','13:15:00',3.64),('16273','2013-03-22','13:20:00',3.27),('16273','2013-03-22','13:25:00',3.05),('16273','2013-03-22','13:30:00',3.54),('16273','2013-03-22','13:35:00',3.47),('16273','2013-03-22','13:40:00',3.32),('16273','2013-03-22','13:45:00',3.46),('16273','2013-03-22','13:50:00',3.34),('16273','2013-03-22','13:55:00',3.27),('16273','2013-03-22','14:00:00',3.2),('16273','2013-03-22','14:05:00',3.17),('16273','2013-03-22','14:10:00',3.12),('16273','2013-03-22','14:15:00',3.06),('16273','2013-03-22','14:20:00',3),('16273','2013-03-22','14:25:00',2.94),('16273','2013-03-22','14:30:00',2.92),('16273','2013-03-22','14:35:00',2.79),('16273','2013-03-22','14:40:00',2.76),('16273','2013-03-22','14:45:00',2.66),('16273','2013-03-22','14:50:00',2.59),('16273','2013-03-22','14:55:00',2.61),('16273','2013-03-22','15:00:00',2.55),('16273','2013-03-22','15:05:00',2.31),('16273','2013-03-22','15:10:00',1.86),('16273','2013-03-22','15:15:00',1.47),('16273','2013-03-22','15:20:00',1.53),('16273','2013-03-22','15:25:00',1.63),('16273','2013-03-22','15:30:00',1.68),('16273','2013-03-22','15:35:00',1.6),('16273','2013-03-22','15:40:00',1.56),('16273','2013-03-22','15:45:00',1.45),('16273','2013-03-22','15:50:00',1.33),('16273','2013-03-22','15:55:00',1.35),('16273','2013-03-22','16:00:00',1.19),('16273','2013-03-22','16:05:00',1.39),('16273','2013-03-22','16:10:00',1.33),('16273','2013-03-22','16:15:00',1.31),('16273','2013-03-22','16:20:00',1.26),('16273','2013-03-22','16:25:00',1.3),('16273','2013-03-22','16:30:00',1.26),('16273','2013-03-22','16:35:00',1.19),('16273','2013-03-22','16:40:00',1.13),('16273','2013-03-22','16:45:00',1.02),('16273','2013-03-21','08:05:00',2.4),('16273','2013-03-21','08:10:00',2.28),('16273','2013-03-21','08:15:00',2.05),('16273','2013-03-21','08:20:00',2.16),('16273','2013-03-21','08:25:00',2.81),('16273','2013-03-21','08:30:00',2.17),('16273','2013-03-21','08:35:00',3.21),('16273','2013-03-21','08:40:00',2.49),('16273','2013-03-21','08:45:00',2.48),('16273','2013-03-21','08:55:00',1.14),('16273','2013-03-21','09:00:00',1.33),('16273','2013-03-21','09:05:00',2.93),('16273','2013-03-21','09:10:00',2.73),('16273','2013-03-21','09:15:00',1.94),('16273','2013-03-21','09:25:00',3.78),('16273','2013-03-21','09:30:00',3.5),('16273','2013-03-21','09:35:00',2.14),('16273','2013-03-21','09:40:00',3.48),('16273','2013-03-21','09:45:00',3.71),('16273','2013-03-21','09:50:00',3.72),('16273','2013-03-21','09:55:00',3.08),('16273','2013-03-21','10:00:00',2.08),('16273','2013-03-21','10:05:00',3.86),('16273','2013-03-21','10:10:00',3.84),('16273','2013-03-21','10:15:00',3.84),('16273','2013-03-21','10:20:00',3.83),('16273','2013-03-21','10:25:00',3.88),('16273','2013-03-21','10:30:00',3.89),('16273','2013-03-21','10:35:00',3.91),('16273','2013-03-21','10:40:00',3.89),('16273','2013-03-21','10:45:00',3.99),('16273','2013-03-21','10:50:00',4.03),('16273','2013-03-21','10:55:00',4.02),('16273','2013-03-21','11:00:00',4.07),('16273','2013-03-21','11:05:00',4.09),('16273','2013-03-21','11:10:00',4.11),('16273','2013-03-21','11:15:00',4.1),('16273','2013-03-21','11:20:00',4.14),('16273','2013-03-21','11:25:00',4.14),('16273','2013-03-21','11:30:00',4.14),('16273','2013-03-21','11:35:00',4.12),('16273','2013-03-21','11:40:00',4.16),('16273','2013-03-21','11:45:00',4.15),('16273','2013-03-21','11:50:00',4.16),('16273','2013-03-21','11:55:00',4.15),('16273','2013-03-21','12:00:00',4.16),('16273','2013-03-21','12:05:00',4.16),('16273','2013-03-21','12:10:00',4.13),('16273','2013-03-21','12:15:00',4.14),('16273','2013-03-21','12:20:00',4.12),('16273','2013-03-21','12:25:00',4.1),('16273','2013-03-21','12:30:00',4.08),('16273','2013-03-21','12:35:00',4.04),('16273','2013-03-21','12:40:00',4.01),('16273','2013-03-21','12:45:00',3.99),('16273','2013-03-21','12:50:00',3.93),('16273','2013-03-21','12:55:00',3.91),('16273','2013-03-21','13:00:00',3.88),('16273','2013-03-21','13:05:00',3.83),('16273','2013-03-21','13:10:00',3.8),('16273','2013-03-21','13:15:00',3.75),('16273','2013-03-21','13:20:00',3.69),('16273','2013-03-21','13:25:00',3.66),('16273','2013-03-21','13:30:00',3.61),('16273','2013-03-21','13:35:00',3.57),('16273','2013-03-21','13:40:00',3.51),('16273','2013-03-21','13:45:00',3.44),('16273','2013-03-21','13:50:00',3.39),('16273','2013-03-21','13:55:00',3.34),('16273','2013-03-21','14:00:00',3.27),('16273','2013-03-21','14:05:00',3.2),('16273','2013-03-21','14:10:00',3.16),('16273','2013-03-21','14:15:00',3.11),('16273','2013-03-21','14:20:00',3.04),('16273','2013-03-21','14:25:00',2.96),('16273','2013-03-21','14:30:00',2.9),('16273','2013-03-21','14:35:00',2.82),('16273','2013-03-21','14:40:00',2.76),('16273','2013-03-21','14:45:00',2.69),('16273','2013-03-21','14:50:00',2.61),('16273','2013-03-21','14:55:00',2.53),('16273','2013-03-21','15:00:00',2.45),('16273','2013-03-21','15:05:00',2.38),('16273','2013-03-21','15:10:00',2.31),('16273','2013-03-21','15:15:00',2.23),('16273','2013-03-21','15:20:00',2.15),('16273','2013-03-21','15:25:00',2.07),('16273','2013-03-21','15:30:00',1.98),('16273','2013-03-21','15:35:00',1.89),('16273','2013-03-21','15:40:00',1.79),('16273','2013-03-21','15:45:00',1.71),('16273','2013-03-21','15:50:00',1.63),('16273','2013-03-21','15:55:00',1.55),('16273','2013-03-21','16:00:00',1.46),('16273','2013-03-21','16:05:00',1.38),('16273','2013-03-21','16:10:00',1.3),('16273','2013-03-21','16:15:00',1.23),('16273','2013-03-21','16:20:00',1.14),('16273','2013-03-21','16:25:00',1.08),('16273','2013-03-20','07:15:00',1.08),('16273','2013-03-20','07:20:00',1.2),('16273','2013-03-20','07:25:00',1.35),('16273','2013-03-20','07:30:00',1.37),('16273','2013-03-20','07:35:00',1.49),('16273','2013-03-20','07:40:00',1.67),('16273','2013-03-20','07:45:00',1.84),('16273','2013-03-20','07:50:00',1.86),('16273','2013-03-20','08:00:00',1.06),('16273','2013-03-20','08:05:00',2.24),('16273','2013-03-20','08:10:00',2.28),('16273','2013-03-20','08:15:00',2.36),('16273','2013-03-20','08:20:00',2.44),('16273','2013-03-20','08:25:00',2.58),('16273','2013-03-20','08:30:00',2.24),('16273','2013-03-20','08:35:00',2.07),('16273','2013-03-20','08:40:00',2.6),('16273','2013-03-20','08:45:00',2.77),('16273','2013-03-20','08:50:00',2.75),('16273','2013-03-20','08:55:00',2.77),('16273','2013-03-20','09:00:00',2.65),('16273','2013-03-20','09:05:00',2.24),('16273','2013-03-20','09:10:00',2.76),('16273','2013-03-20','09:15:00',2.5),('16273','2013-03-20','09:20:00',3.33),('16273','2013-03-20','09:25:00',2.81),('16273','2013-03-20','09:30:00',3.32),('16273','2013-03-20','09:35:00',3.1),('16273','2013-03-20','09:40:00',3.27),('16273','2013-03-20','09:45:00',3.52),('16273','2013-03-20','09:50:00',3.68),('16273','2013-03-20','09:55:00',2.74),('16273','2013-03-20','10:00:00',3.36),('16273','2013-03-20','10:05:00',2.95),('16273','2013-03-20','10:10:00',2.6),('16273','2013-03-20','10:15:00',2),('16273','2013-03-20','10:20:00',2.78),('16273','2013-03-20','10:25:00',3.33),('16273','2013-03-20','10:30:00',3.2),('16273','2013-03-20','10:35:00',3.44),('16273','2013-03-20','10:40:00',3.11),('16273','2013-03-20','10:45:00',3.12),('16273','2013-03-20','10:50:00',2.88),('16273','2013-03-20','10:55:00',2.55),('16273','2013-03-20','11:00:00',3.66),('16273','2013-03-20','11:05:00',2.46),('16273','2013-03-20','11:10:00',2.13),('16273','2013-03-20','11:15:00',2.39),('16273','2013-03-20','11:20:00',2.59),('16273','2013-03-20','11:25:00',2.23),('16273','2013-03-20','11:30:00',2.37),('16273','2013-03-20','11:35:00',2.6),('16273','2013-03-20','11:40:00',2.14),('16273','2013-03-20','11:45:00',1.86),('16273','2013-03-20','11:50:00',1.98),('16273','2013-03-20','11:55:00',1.93),('16273','2013-03-20','12:00:00',2.15),('16273','2013-03-20','12:05:00',2.04),('16273','2013-03-20','12:10:00',1.65),('16273','2013-03-20','12:15:00',1.33),('16273','2013-03-20','12:20:00',1.19),('16273','2013-03-20','12:25:00',1.11),('16273','2013-03-20','12:30:00',1.28),('16273','2013-03-20','12:35:00',1.41),('16273','2013-03-20','12:40:00',1.08),('16273','2013-03-20','12:45:00',1.24),('16273','2013-03-20','12:50:00',1.67),('16273','2013-03-20','12:55:00',1.97),('16273','2013-03-20','13:00:00',1.24),('16273','2013-03-20','13:05:00',1.35),('16273','2013-03-20','13:10:00',1.18),('16273','2013-03-20','13:15:00',1.14),('16273','2013-03-20','13:20:00',1.21),('16273','2013-03-20','13:25:00',1.31),('16273','2013-03-20','13:30:00',1.41),('16273','2013-03-20','13:35:00',1.46),('16273','2013-03-20','13:40:00',1.88),('16273','2013-03-20','13:45:00',1.69),('16273','2013-03-20','13:50:00',1.49),('16273','2013-03-20','13:55:00',1.54),('16273','2013-03-20','14:00:00',1.36),('16273','2013-03-20','14:05:00',1.13),('16273','2013-03-20','14:10:00',1.34),('16273','2013-03-20','14:15:00',1.81),('16273','2013-03-20','14:20:00',1.82),('16273','2013-03-20','14:25:00',1.88),('16273','2013-03-20','14:30:00',1.56),('16273','2013-03-20','14:35:00',1.17),('16273','2013-03-20','14:40:00',1.03),('16273','2013-03-19','07:25:00',1.03),('16273','2013-03-19','07:35:00',1.46),('16273','2013-03-19','07:40:00',1.65),('16273','2013-03-19','07:45:00',1.71),('16273','2013-03-19','07:50:00',1.89),('16273','2013-03-19','07:55:00',1.53),('16273','2013-03-19','08:00:00',1.69),('16273','2013-03-19','08:05:00',1.98),('16273','2013-03-19','08:10:00',2.08),('16273','2013-03-19','08:15:00',2.24),('16273','2013-03-19','08:20:00',2.4),('16273','2013-03-19','08:25:00',2.51),('16273','2013-03-19','08:30:00',2.61),('16273','2013-03-19','08:35:00',2.71),('16273','2013-03-19','08:40:00',2.76),('16273','2013-03-19','08:45:00',2.85),('16273','2013-03-19','08:50:00',2.91),('16273','2013-03-19','08:55:00',2.97),('16273','2013-03-19','09:00:00',3.05),('16273','2013-03-19','09:05:00',3.09),('16273','2013-03-19','09:10:00',3.17),('16273','2013-03-19','09:15:00',3.26),('16273','2013-03-19','09:20:00',3.3),('16273','2013-03-19','09:25:00',3.37),('16273','2013-03-19','09:30:00',3.41),('16273','2013-03-19','09:35:00',3.49),('16273','2013-03-19','09:40:00',3.15),('16273','2013-03-19','09:45:00',3.33),('16273','2013-03-19','09:50:00',3.66),('16273','2013-03-19','09:55:00',2.71),('16273','2013-03-19','10:00:00',3.8),('16273','2013-03-19','10:05:00',3.78),('16273','2013-03-19','10:10:00',3.79),('16273','2013-03-19','10:15:00',3.85),('16273','2013-03-19','10:20:00',3.86),('16273','2013-03-19','10:25:00',3.88),('16273','2013-03-19','10:30:00',3.93),('16273','2013-03-19','10:35:00',3.95),('16273','2013-03-19','10:40:00',3.86),('16273','2013-03-19','10:45:00',4),('16273','2013-03-19','10:50:00',4.05),('16273','2013-03-19','10:55:00',4.07),('16273','2013-03-19','11:00:00',4.09),('16273','2013-03-19','11:05:00',4.08),('16273','2013-03-19','11:10:00',4.11),('16273','2013-03-19','11:15:00',4.19),('16273','2013-03-19','11:20:00',4.1),('16273','2013-03-19','11:25:00',4.15),('16273','2013-03-19','11:30:00',3.22),('16273','2013-03-19','11:35:00',2.87),('16273','2013-03-19','11:40:00',3.84),('16273','2013-03-19','11:45:00',3.61),('16273','2013-03-19','11:50:00',4.2),('16273','2013-03-19','11:55:00',4.14),('16273','2013-03-19','12:00:00',4.13),('16273','2013-03-19','12:05:00',4.01),('16273','2013-03-19','12:10:00',3.97),('16273','2013-03-19','12:15:00',4.05),('16273','2013-03-19','12:20:00',4.03),('16273','2013-03-19','12:25:00',3.58),('16273','2013-03-19','12:30:00',4.04),('16273','2013-03-19','12:35:00',3.96),('16273','2013-03-19','12:40:00',3.95),('16273','2013-03-19','12:45:00',3.93),('16273','2013-03-19','12:50:00',3.58),('16273','2013-03-19','12:55:00',3.74),('16273','2013-03-19','13:00:00',3.76),('16273','2013-03-19','13:05:00',3.74),('16273','2013-03-19','13:10:00',3.71),('16273','2013-03-19','13:15:00',3.7),('16273','2013-03-19','13:20:00',3.61),('16273','2013-03-19','13:25:00',3.6),('16273','2013-03-19','13:30:00',3.5),('16273','2013-03-19','13:35:00',3.49),('16273','2013-03-19','13:40:00',3.41),('16273','2013-03-19','13:45:00',3.41),('16273','2013-03-19','13:50:00',3.34),('16273','2013-03-19','13:55:00',3.27),('16273','2013-03-19','14:00:00',3.22),('16273','2013-03-19','14:05:00',3.16),('16273','2013-03-19','14:10:00',3.11),('16273','2013-03-19','14:15:00',3.06),('16273','2013-03-19','14:20:00',2.97),('16273','2013-03-19','14:25:00',2.91),('16273','2013-03-19','14:30:00',2.84),('16273','2013-03-19','14:35:00',2.78),('16273','2013-03-19','14:40:00',2.71),('16273','2013-03-19','14:45:00',2.64),('16273','2013-03-19','14:50:00',2.59),('16273','2013-03-19','14:55:00',2.5),('16273','2013-03-19','15:00:00',2.41),('16273','2013-03-19','15:05:00',2.34),('16273','2013-03-19','15:10:00',2.25),('16273','2013-03-19','15:15:00',2.18),('16273','2013-03-19','15:20:00',2.09),('16273','2013-03-19','15:25:00',2.02),('16273','2013-03-19','15:30:00',1.94),('16273','2013-03-19','15:35:00',1.86),('16273','2013-03-19','15:40:00',1.77),('16273','2013-03-19','15:45:00',1.69),('16273','2013-03-19','15:50:00',1.61),('16273','2013-03-19','15:55:00',1.52),('16273','2013-03-19','16:00:00',1.45),('16273','2013-03-19','16:05:00',1.36),('16273','2013-03-19','16:10:00',1.28),('16273','2013-03-19','16:15:00',1.21),('16273','2013-03-19','16:20:00',1.14),('16273','2013-03-19','16:25:00',1.08),('16273','2013-03-19','16:30:00',1.01),('16273','2013-03-18','08:40:00',1.12),('16273','2013-03-18','09:50:00',1.03),('16273','2013-03-18','09:55:00',1.22),('16273','2013-03-18','10:00:00',1.39),('16273','2013-03-18','10:05:00',1.43),('16273','2013-03-18','10:10:00',1.69),('16273','2013-03-18','10:15:00',2.2),('16273','2013-03-18','10:20:00',2.29),('16273','2013-03-18','10:25:00',2.25),('16273','2013-03-18','10:30:00',1.84),('16273','2013-03-18','10:35:00',1.5),('16273','2013-03-18','10:40:00',1.85),('16273','2013-03-18','10:45:00',1.39),('16273','2013-03-18','10:50:00',1),('16273','2013-03-18','10:55:00',1.04),('16273','2013-03-18','11:00:00',1.18),('16273','2013-03-18','11:05:00',1.4),('16273','2013-03-18','11:10:00',1.74),('16273','2013-03-18','11:15:00',1.95),('16273','2013-03-18','11:20:00',2.05),('16273','2013-03-18','11:25:00',2.37),('16273','2013-03-18','11:30:00',2.48),('16273','2013-03-18','11:35:00',1.72),('16273','2013-03-18','11:40:00',1.4),('16273','2013-03-18','11:45:00',1.09),('16273','2013-03-18','11:50:00',1.07),('16273','2013-03-18','11:55:00',1.16),('16273','2013-03-18','12:00:00',1.5),('16273','2013-03-18','12:05:00',1.88),('16273','2013-03-18','12:10:00',2.79),('16273','2013-03-18','12:15:00',4.02),('16273','2013-03-18','12:20:00',3.5),('16273','2013-03-18','12:25:00',3.48),('16273','2013-03-18','12:30:00',3.1),('16273','2013-03-18','12:35:00',2.07),('16273','2013-03-18','12:40:00',2.18),('16273','2013-03-18','12:45:00',3),('16273','2013-03-18','12:50:00',2.99),('16273','2013-03-18','12:55:00',2.54),('16273','2013-03-18','13:00:00',1.63),('16273','2013-03-18','13:05:00',1.71),('16273','2013-03-18','13:10:00',1.18),('16273','2013-03-18','13:15:00',1.22),('16273','2013-03-18','13:20:00',2.17),('16273','2013-03-18','13:25:00',1.46),('16273','2013-03-18','13:30:00',1.02),('16273','2013-03-18','13:35:00',1.66),('16273','2013-03-18','13:40:00',1.62),('16273','2013-03-18','13:45:00',1.44),('16273','2013-03-18','13:50:00',1.06),('16273','2013-03-18','13:55:00',1.06),('16273','2013-03-18','14:00:00',1.81),('16273','2013-03-18','14:05:00',1.88),('16273','2013-03-18','14:10:00',1.49),('16273','2013-03-18','14:20:00',1.1),('16273','2013-03-17','08:10:00',1.05),('16273','2013-03-17','08:15:00',1.02),('16273','2013-03-17','08:20:00',1.42),('16273','2013-03-17','08:25:00',1.51),('16273','2013-03-17','08:30:00',1.11),('16273','2013-03-17','08:35:00',1.16),('16273','2013-03-17','08:40:00',1.53),('16273','2013-03-17','08:45:00',1.32),('16273','2013-03-17','08:50:00',1.19),('16273','2013-03-17','08:55:00',1.13),('16273','2013-03-17','09:00:00',1.29),('16273','2013-03-17','09:05:00',1.71),('16273','2013-03-17','09:10:00',1.68),('16273','2013-03-17','09:15:00',1.42),('16273','2013-03-17','09:20:00',1.31),('16273','2013-03-17','09:25:00',1.22),('16273','2013-03-17','09:30:00',1.4),('16273','2013-03-17','09:35:00',1.39),('16273','2013-03-17','09:40:00',1.4),('16273','2013-03-17','09:45:00',1.56),('16273','2013-03-17','09:50:00',1.64),('16273','2013-03-17','09:55:00',1.82),('16273','2013-03-17','10:00:00',1.67),('16273','2013-03-17','10:05:00',1.54),('16273','2013-03-17','10:10:00',1.69),('16273','2013-03-17','10:15:00',1.8),('16273','2013-03-17','10:20:00',1.85),('16273','2013-03-17','10:25:00',1.77),('16273','2013-03-17','10:30:00',1.76),('16273','2013-03-17','10:35:00',1.72),('16273','2013-03-17','10:40:00',1.7),('16273','2013-03-17','10:45:00',1.66),('16273','2013-03-17','10:50:00',1.47),('16273','2013-03-17','10:55:00',1.32),('16273','2013-03-17','11:00:00',1.33),('16273','2013-03-17','11:05:00',1.47),('16273','2013-03-17','11:10:00',1.56),('16273','2013-03-17','11:15:00',1.84),('16273','2013-03-17','11:20:00',1.87),('16273','2013-03-17','11:25:00',1.6),('16273','2013-03-17','11:30:00',1.56),('16273','2013-03-17','11:35:00',1.47),('16273','2013-03-17','11:40:00',1.38),('16273','2013-03-17','11:45:00',1.25),('16273','2013-03-17','11:50:00',1.11),('16273','2013-03-17','11:55:00',1.04),('16273','2013-03-17','12:00:00',1.08),('16273','2013-03-17','12:05:00',1.36),('16273','2013-03-17','12:10:00',1.79),('16273','2013-03-17','12:15:00',2.51),('16273','2013-03-17','12:20:00',2.65),('16273','2013-03-17','12:25:00',2.93),('16273','2013-03-17','12:30:00',2.45),('16273','2013-03-17','12:35:00',2.68),('16273','2013-03-17','12:40:00',2.36),('16273','2013-03-17','12:45:00',2.07),('16273','2013-03-17','12:50:00',1.69),('16273','2013-03-17','12:55:00',2.06),('16273','2013-03-17','13:00:00',2.04),('16273','2013-03-17','13:05:00',2.18),('16273','2013-03-17','13:10:00',2.31),('16273','2013-03-17','13:15:00',1.9),('16273','2013-03-17','13:20:00',1.67),('16273','2013-03-17','13:25:00',2.44),('16273','2013-03-17','13:30:00',2.98),('16273','2013-03-17','13:35:00',2.22),('16273','2013-03-17','13:40:00',1.82),('16273','2013-03-17','13:45:00',1.44),('16273','2013-03-17','13:50:00',2.08),('16273','2013-03-17','13:55:00',1.93),('16273','2013-03-17','14:00:00',1.97),('16273','2013-03-17','14:05:00',2.09),('16273','2013-03-17','14:10:00',2.1),('16273','2013-03-17','14:15:00',2.15),('16273','2013-03-17','14:20:00',1.98),('16273','2013-03-17','14:25:00',1.94),('16273','2013-03-17','14:30:00',1.8),('16273','2013-03-17','14:35:00',1.61),('16273','2013-03-17','14:40:00',1.48),('16273','2013-03-17','14:45:00',1.29),('16273','2013-03-17','14:50:00',1.21),('16273','2013-03-17','14:55:00',1.66),('16273','2013-03-17','15:00:00',1.82),('16273','2013-03-17','15:05:00',2.52),('16273','2013-03-17','15:10:00',1.84),('16273','2013-03-17','15:15:00',1.96),('16273','2013-03-17','15:20:00',2.02),('16273','2013-03-17','15:25:00',1.27),('16273','2013-03-17','15:30:00',1.33),('16273','2013-03-17','15:35:00',1.06),('16273','2013-03-17','15:40:00',1.14),('16273','2013-03-16','08:00:00',1.09),('16273','2013-03-16','08:05:00',1.41),('16273','2013-03-16','08:15:00',1.11),('16273','2013-03-16','08:20:00',1.51),('16273','2013-03-16','08:25:00',2.39),('16273','2013-03-16','08:30:00',2.83),('16273','2013-03-16','08:35:00',2.69),('16273','2013-03-16','08:40:00',2.66),('16273','2013-03-16','08:45:00',3.37),('16273','2013-03-16','08:50:00',3.22),('16273','2013-03-16','08:55:00',3.39),('16273','2013-03-16','09:00:00',2.97),('16273','2013-03-16','09:05:00',3.34),('16273','2013-03-16','09:10:00',3.31),('16273','2013-03-16','09:15:00',3.22),('16273','2013-03-16','09:20:00',3.19),('16273','2013-03-16','09:25:00',3.57),('16273','2013-03-16','09:30:00',2.44),('16273','2013-03-16','09:35:00',3.58),('16273','2013-03-16','09:40:00',3.31),('16273','2013-03-16','09:45:00',3.66),('16273','2013-03-16','09:50:00',2.29),('16273','2013-03-16','09:55:00',2.6),('16273','2013-03-16','10:00:00',4.2),('16273','2013-03-16','10:05:00',3.29),('16273','2013-03-16','10:10:00',3.33),('16273','2013-03-16','10:15:00',3.58),('16273','2013-03-16','10:20:00',4.43),('16273','2013-03-16','10:25:00',4.03),('16273','2013-03-16','10:30:00',4.04),('16273','2013-03-16','10:35:00',4.02),('16273','2013-03-16','10:40:00',3.98),('16273','2013-03-16','10:45:00',4.09),('16273','2013-03-16','10:50:00',4.01),('16273','2013-03-16','10:55:00',4.01),('16273','2013-03-16','11:00:00',4.05),('16273','2013-03-16','11:05:00',4.04),('16273','2013-03-16','11:10:00',3.99),('16273','2013-03-16','11:15:00',4.02),('16273','2013-03-16','11:20:00',4.06),('16273','2013-03-16','11:25:00',4.06),('16273','2013-03-16','11:30:00',4.06),('16273','2013-03-16','11:35:00',4.03),('16273','2013-03-16','11:40:00',3.95),('16273','2013-03-16','11:45:00',3.99),('16273','2013-03-16','11:50:00',4.02),('16273','2013-03-16','11:55:00',4),('16273','2013-03-16','12:00:00',3.97),('16273','2013-03-16','12:05:00',4.02),('16273','2013-03-16','12:10:00',3.97),('16273','2013-03-16','12:15:00',3.92),('16273','2013-03-16','12:20:00',3.9),('16273','2013-03-16','12:25:00',3.34),('16273','2013-03-16','12:30:00',3.78),('16273','2013-03-16','12:35:00',3.98),('16273','2013-03-16','12:40:00',3.91),('16273','2013-03-16','12:45:00',3.86),('16273','2013-03-16','12:50:00',3.89),('16273','2013-03-16','12:55:00',3.89),('16273','2013-03-16','13:00:00',3.89),('16273','2013-03-16','13:05:00',3.83),('16273','2013-03-16','13:10:00',3.81),('16273','2013-03-16','13:15:00',3.83),('16273','2013-03-16','13:20:00',3.7),('16273','2013-03-16','13:25:00',3.63),('16273','2013-03-16','13:30:00',3.54),('16273','2013-03-16','13:35:00',3.62),('16273','2013-03-16','13:40:00',3.6),('16273','2013-03-16','13:45:00',3.31),('16273','2013-03-16','13:50:00',3.35),('16273','2013-03-16','13:55:00',3.37),('16273','2013-03-16','14:00:00',3.3),('16273','2013-03-16','14:05:00',3.37),('16273','2013-03-16','14:10:00',3.22),('16273','2013-03-16','14:15:00',3.24),('16273','2013-03-16','14:20:00',3.21),('16273','2013-03-16','14:25:00',3.34),('16273','2013-03-16','14:30:00',3.06),('16273','2013-03-16','14:35:00',2.7),('16273','2013-03-16','14:40:00',3.01),('16273','2013-03-16','14:45:00',2.97),('16273','2013-03-16','14:50:00',2.75),('16273','2013-03-16','14:55:00',2.8),('16273','2013-03-16','15:00:00',2.1),('16273','2013-03-16','15:05:00',1.67),('16273','2013-03-16','15:10:00',2.18),('16273','2013-03-16','15:15:00',2.35),('16273','2013-03-16','15:20:00',2.23),('16273','2013-03-16','15:25:00',2.11),('16273','2013-03-16','15:30:00',1.99),('16273','2013-03-16','15:35:00',1.9),('16273','2013-03-16','15:40:00',1.82),('16273','2013-03-16','15:45:00',1.76),('16273','2013-03-16','15:50:00',1.69),('16273','2013-03-16','15:55:00',1.56),('16273','2013-03-16','16:00:00',1.49),('16273','2013-03-16','16:05:00',1.42),('16273','2013-03-16','16:10:00',1.41),('16273','2013-03-16','16:15:00',1.46),('16273','2013-03-16','16:20:00',1.48),('16273','2013-03-16','16:25:00',1.44),('16273','2013-03-16','16:30:00',1.27),('16273','2013-03-16','16:35:00',1.19),('16273','2013-03-16','16:40:00',1.09),('16273','2013-03-15','10:25:00',1.12),('16273','2013-03-15','10:30:00',1.23),('16273','2013-03-15','10:35:00',1.28),('16273','2013-03-15','10:40:00',1.38),('16273','2013-03-15','10:45:00',1.34),('16273','2013-03-15','10:50:00',1.54),('16273','2013-03-15','10:55:00',1.69),('16273','2013-03-15','11:00:00',1.42),('16273','2013-03-15','11:05:00',1.2),('16273','2013-03-15','11:10:00',1),('16273','2013-03-15','11:15:00',1.06),('16273','2013-03-15','11:20:00',1.11),('16273','2013-03-15','11:25:00',1.22),('16273','2013-03-15','11:30:00',1.48),('16273','2013-03-15','11:35:00',1.57),('16273','2013-03-15','11:40:00',1.78),('16273','2013-03-15','11:45:00',1.79),('16273','2013-03-15','11:50:00',1.52),('16273','2013-03-15','11:55:00',1.59),('16273','2013-03-15','12:00:00',1.72),('16273','2013-03-15','12:05:00',1.58),('16273','2013-03-15','12:10:00',1.56),('16273','2013-03-15','12:15:00',1.87),('16273','2013-03-15','12:20:00',1.89),('16273','2013-03-15','12:25:00',1.81),('16273','2013-03-15','12:30:00',1.79),('16273','2013-03-15','12:35:00',1.59),('16273','2013-03-15','12:40:00',1.45),('16273','2013-03-15','12:45:00',1.39),('16273','2013-03-15','12:50:00',1.23),('16273','2013-03-15','12:55:00',1.23),('16273','2013-03-15','13:00:00',1.29),('16273','2013-03-15','13:05:00',1.31),('16273','2013-03-15','13:10:00',1.39),('16273','2013-03-15','13:15:00',1.56),('16273','2013-03-15','13:20:00',1.74),('16273','2013-03-15','13:25:00',1.58),('16273','2013-03-15','13:30:00',1.55),('16273','2013-03-15','13:35:00',1.17),('16273','2013-03-15','13:40:00',1.02),('16273','2013-03-15','13:50:00',1.07),('16273','2013-03-15','13:55:00',1.03),('16273','2013-03-15','14:40:00',1.03),('16273','2013-03-15','14:45:00',1.2),('16273','2013-03-15','14:50:00',1.25),('16273','2013-03-15','14:55:00',1.26),('16273','2013-03-15','15:00:00',1.25),('16273','2013-03-15','15:05:00',1.27),('16273','2013-03-15','15:10:00',1.34),('16273','2013-03-15','15:15:00',1.51),('16273','2013-03-15','15:20:00',1.33),('16273','2013-03-15','15:25:00',1.08),('16273','2013-03-14','12:35:00',1.01),('16273','2013-03-14','12:40:00',1.03),('16273','2013-03-14','12:45:00',1.07),('16273','2013-03-14','12:50:00',1.02),('16273','2013-03-14','12:55:00',1.2),('16273','2013-03-14','13:00:00',1.2),('16273','2013-03-14','13:05:00',1.09),('16273','2013-03-14','13:15:00',1.18),('16273','2013-03-14','13:20:00',1.43),('16273','2013-03-14','13:25:00',1.61),('16273','2013-03-14','13:30:00',1.74),('16273','2013-03-14','13:35:00',1.64),('16273','2013-03-14','13:40:00',1.3),('16273','2013-03-14','13:45:00',1.25),('16273','2013-03-14','13:50:00',1.18),('16273','2013-03-14','13:55:00',1.24),('16273','2013-03-14','14:00:00',1.34),('16273','2013-03-14','14:05:00',1.41),('16273','2013-03-14','14:10:00',1.2),('16273','2013-03-14','14:15:00',1.08),('16273','2013-03-13','09:10:00',1.29),('16273','2013-03-13','10:10:00',1.01),('16273','2013-03-13','10:30:00',1.25),('16273','2013-03-13','10:35:00',2.32),('16273','2013-03-13','10:40:00',3),('16273','2013-03-13','10:45:00',2.47),('16273','2013-03-13','10:50:00',1.53),('16273','2013-03-13','10:55:00',1.01),('16273','2013-03-13','11:00:00',1.31),('16273','2013-03-13','11:05:00',2.02),('16273','2013-03-13','11:10:00',1.75),('16273','2013-03-13','11:15:00',1.16),('16273','2013-03-13','11:20:00',1.08),('16273','2013-03-13','11:25:00',1.41),('16273','2013-03-13','11:30:00',1.55),('16273','2013-03-13','11:35:00',1.49),('16273','2013-03-13','11:40:00',1.46),('16273','2013-03-13','11:45:00',1.46),('16273','2013-03-13','11:50:00',1.22),('16273','2013-03-13','12:45:00',1.02),('16273','2013-03-13','12:50:00',1.07),('16273','2013-03-13','12:55:00',1.1),('16273','2013-03-13','13:00:00',1.04),('16273','2013-03-13','13:05:00',1.1),('16273','2013-03-13','13:30:00',1.15),('16273','2013-03-13','13:35:00',1.39),('16273','2013-03-13','13:40:00',1.52),('16273','2013-03-13','13:45:00',1.17),('16273','2014-03-25','07:10:00',1.25),('16273','2014-03-25','07:15:00',1.47),('16273','2014-03-25','07:20:00',1.35),('16273','2014-03-25','07:25:00',1.52),('16273','2014-03-25','07:30:00',1.23),('16273','2014-03-25','07:35:00',1.02),('16273','2014-03-25','07:40:00',1.18),('16273','2014-03-25','07:45:00',1.27),('16273','2014-03-25','07:50:00',1.28),('16273','2014-03-25','07:55:00',1.17),('16273','2014-03-25','08:00:00',1.17),('16273','2014-03-25','08:05:00',1.23),('16273','2014-03-25','08:10:00',1.35),('16273','2014-03-25','08:15:00',1.24),('16273','2014-03-25','08:20:00',1.09),('16273','2014-03-25','08:35:00',1.16),('16273','2014-03-25','08:40:00',1.62),('16273','2014-03-25','08:45:00',1.8),('16273','2014-03-25','08:50:00',1.92),('16273','2014-03-25','08:55:00',1.75),('16273','2014-03-25','09:00:00',1.65),('16273','2014-03-25','09:05:00',1.71),('16273','2014-03-25','09:10:00',2.13),('16273','2014-03-25','09:15:00',2.38),('16273','2014-03-25','09:20:00',2.22),('16273','2014-03-25','09:25:00',1.89),('16273','2014-03-25','09:30:00',1.7),('16273','2014-03-25','09:35:00',1.75),('16273','2014-03-25','09:40:00',1.63),('16273','2014-03-25','09:45:00',1.7),('16273','2014-03-25','09:50:00',1.94),('16273','2014-03-25','09:55:00',2.19),('16273','2014-03-25','10:00:00',2.48),('16273','2014-03-25','10:05:00',2.71),('16273','2014-03-25','10:10:00',2.93),('16273','2014-03-25','10:15:00',2.81),('16273','2014-03-25','10:20:00',2.9),('16273','2014-03-25','10:25:00',2.59),('16273','2014-03-25','10:30:00',2.13),('16273','2014-03-25','10:35:00',1.97),('16273','2014-03-25','10:40:00',1.8),('16273','2014-03-25','10:45:00',1.64),('16273','2014-03-25','10:50:00',1.73),('16273','2014-03-25','10:55:00',1.93),('16273','2014-03-25','11:00:00',2.17),('16273','2014-03-25','11:05:00',2.39),('16273','2014-03-25','11:10:00',2.44),('16273','2014-03-25','11:15:00',2.55),('16273','2014-03-25','11:20:00',2.69),('16273','2014-03-25','11:25:00',2.86),('16273','2014-03-25','11:30:00',2.94),('16273','2014-03-25','11:35:00',2.81),('16273','2014-03-25','11:40:00',2.27),('16273','2014-03-25','11:45:00',1.94),('16273','2014-03-25','11:50:00',1.68),('16273','2014-03-25','11:55:00',1.07),('16273','2014-03-25','12:10:00',1),('16273','2014-03-25','12:15:00',1.04),('16273','2014-03-25','12:20:00',1.15),('16273','2014-03-25','12:25:00',1.04),('16273','2014-03-25','12:30:00',1.05),('16273','2014-03-25','12:35:00',1.11),('16273','2014-03-25','12:40:00',1.15),('16273','2014-03-25','12:45:00',1.14),('16273','2014-03-25','12:50:00',1.06),('16273','2013-03-12','13:35:00',1.36),('16273','2013-03-12','13:40:00',2.79),('16273','2013-03-12','13:45:00',2.72),('16273','2013-03-12','13:50:00',3.01),('16273','2013-03-12','13:55:00',1.99),('16273','2013-03-12','14:00:00',2.2),('16273','2013-03-12','14:05:00',1.76),('16273','2013-03-12','14:10:00',2.06),('16273','2013-03-12','14:15:00',1.49),('16273','2013-03-12','14:20:00',1.32),('16273','2013-03-12','14:25:00',1.74),('16273','2013-03-12','14:50:00',1.4),('16273','2013-03-12','14:55:00',1.91),('16273','2013-03-12','15:00:00',1.06),('16273','2013-03-12','15:05:00',1.23),('16273','2013-03-12','15:10:00',1.84),('16273','2013-03-12','15:15:00',1.87),('16273','2013-03-12','15:20:00',1.64),('16273','2014-03-24','07:40:00',1.21),('16273','2014-03-24','08:30:00',1.38),('16273','2014-03-24','08:45:00',1.03),('16273','2014-03-24','08:50:00',1.93),('16273','2014-03-24','08:55:00',1.18),('16273','2014-03-24','09:15:00',3.38),('16273','2014-03-24','09:20:00',2.78),('16273','2014-03-24','09:25:00',1.51),('16273','2014-03-24','09:30:00',1.03),('16273','2014-03-24','09:35:00',2.57),('16273','2014-03-24','09:40:00',2.64),('16273','2014-03-24','09:45:00',1.35),('16273','2014-03-24','09:50:00',1.27),('16273','2014-03-24','09:55:00',3.28),('16273','2014-03-24','10:00:00',3.88),('16273','2014-03-24','10:05:00',4.7),('16273','2014-03-24','10:10:00',1.2),('16273','2014-03-24','10:15:00',1.64),('16273','2014-03-24','10:25:00',1.22),('16273','2014-03-24','10:30:00',1.48),('16273','2014-03-24','10:35:00',1),('16273','2014-03-24','10:40:00',1.51),('16273','2014-03-24','10:45:00',3.75),('16273','2014-03-24','10:50:00',4.24),('16273','2014-03-24','10:55:00',3.39),('16273','2014-03-24','11:00:00',2.51),('16273','2014-03-24','11:05:00',3.54),('16273','2014-03-24','11:10:00',3.1),('16273','2014-03-24','11:15:00',3.29),('16273','2014-03-24','11:20:00',4.25),('16273','2014-03-24','11:25:00',4.06),('16273','2014-03-24','11:30:00',1.72),('16273','2014-03-24','12:20:00',1.08),('16273','2014-03-24','12:25:00',1.49),('16273','2014-03-24','12:30:00',1.9),('16273','2014-03-24','12:35:00',1.73),('16273','2014-03-24','12:40:00',1.33),('16273','2014-03-24','12:45:00',1.25),('16273','2014-03-24','12:50:00',1.22),('16273','2014-03-24','12:55:00',1.17),('16273','2014-03-24','13:00:00',1.12),('16273','2014-03-24','13:05:00',1.02),('16273','2014-03-24','13:10:00',1.21),('16273','2014-03-24','13:15:00',1.16),('16273','2014-03-24','13:20:00',1.19),('16273','2014-03-24','13:25:00',1.32),('16273','2014-03-24','13:30:00',1.33),('16273','2014-03-24','13:35:00',1.33),('16273','2014-03-24','13:40:00',1.14),('16273','2014-03-24','13:45:00',1.14),('16273','2014-03-24','14:00:00',1.03),('16273','2014-03-24','14:05:00',1.16),('16273','2014-03-24','14:10:00',1.47),('16273','2014-03-24','14:15:00',2),('16273','2014-03-24','14:20:00',1.94),('16273','2014-03-24','14:25:00',1.9),('16273','2014-03-24','14:30:00',2.16),('16273','2014-03-24','14:35:00',2.4),('16273','2014-03-24','14:40:00',2.84),('16273','2014-03-24','14:45:00',2.87),('16273','2014-03-24','14:50:00',2.41),('16273','2014-03-24','14:55:00',2.16),('16273','2014-03-24','15:00:00',1.86),('16273','2014-03-24','15:05:00',1.66),('16273','2014-03-24','15:10:00',1.66),('16273','2014-03-24','15:15:00',1.46),('16273','2014-03-24','15:20:00',1.62),('16273','2014-03-24','15:25:00',1.82),('16273','2014-03-24','15:30:00',1.18),('16273','2014-03-24','15:40:00',1.34),('16273','2014-03-24','15:45:00',1.26),('16273','2014-03-24','15:50:00',1.62),('16273','2014-03-24','16:00:00',1.67),('16273','2014-03-23','08:25:00',1.1),('16273','2014-03-23','08:30:00',1.29),('16273','2014-03-23','08:45:00',1.29),('16273','2014-03-23','08:50:00',1.84),('16273','2014-03-23','08:55:00',1.58),('16273','2014-03-23','09:00:00',2.33),('16273','2014-03-23','09:05:00',2.83),('16273','2014-03-23','09:10:00',2.48),('16273','2014-03-23','09:15:00',1.65),('16273','2014-03-23','09:20:00',1.01),('16273','2014-03-23','09:25:00',1.11),('16273','2014-03-23','09:30:00',1.22),('16273','2014-03-23','09:55:00',1.03),('16273','2014-03-23','10:05:00',1.06),('16273','2014-03-23','10:20:00',1.65),('16273','2014-03-23','10:25:00',2.28),('16273','2014-03-23','10:30:00',1.09),('16273','2014-03-23','10:35:00',1.25),('16273','2014-03-23','10:40:00',1.36),('16273','2014-03-23','10:50:00',1.51),('16273','2014-03-23','10:55:00',1.11),('16273','2014-03-23','11:05:00',1.14),('16273','2014-03-23','11:20:00',1.08),('16273','2014-03-23','11:35:00',1.14),('16273','2014-03-23','13:35:00',1.63),('16273','2014-03-23','13:40:00',1.78),('16273','2014-03-23','13:45:00',1.11),('16273','2014-03-23','13:50:00',1.02),('16273','2014-03-23','15:05:00',1.32),('16273','2014-03-23','15:10:00',1.33),('16273','2014-03-23','15:15:00',1.43),('16273','2014-03-23','15:20:00',1.01),('16273','2014-03-22','07:45:00',1.36),('16273','2014-03-22','07:50:00',1.07),('16273','2014-03-22','08:00:00',1.1),('16273','2014-03-22','08:05:00',1.27),('16273','2014-03-22','08:10:00',1.79),('16273','2014-03-22','08:15:00',1.77),('16273','2014-03-22','08:20:00',1.72),('16273','2014-03-22','08:25:00',1.91),('16273','2014-03-22','08:30:00',1.85),('16273','2014-03-22','08:35:00',1.87),('16273','2014-03-22','08:40:00',2.24),('16273','2014-03-22','08:45:00',1.62),('16273','2014-03-22','08:50:00',1.97),('16273','2014-03-22','08:55:00',1.38),('16273','2014-03-22','09:00:00',1.44),('16273','2014-03-22','09:05:00',1.93),('16273','2014-03-22','09:10:00',1.26),('16273','2014-03-22','09:15:00',1.21),('16273','2014-03-22','09:20:00',1.65),('16273','2014-03-22','09:25:00',1.8),('16273','2014-03-22','09:30:00',2.21),('16273','2014-03-22','09:35:00',2.57),('16273','2014-03-22','09:40:00',2.96),('16273','2014-03-22','09:45:00',1.17),('16273','2014-03-22','09:50:00',2.23),('16273','2014-03-22','09:55:00',3.5),('16273','2014-03-22','10:00:00',2.79),('16273','2014-03-22','10:05:00',1.87),('16273','2014-03-22','10:10:00',1.08),('16273','2014-03-22','10:15:00',1.17),('16273','2014-03-22','10:20:00',1.33),('16273','2014-03-22','10:25:00',1.6),('16273','2014-03-22','10:30:00',1.64),('16273','2014-03-22','10:35:00',1.39),('16273','2014-03-22','10:40:00',1.47),('16273','2014-03-22','10:45:00',1.29),('16273','2014-03-22','10:50:00',1.14),('16273','2014-03-22','10:55:00',1.31),('16273','2014-03-22','11:00:00',1.77),('16273','2014-03-22','11:05:00',2.39),('16273','2014-03-22','11:10:00',2.21),('16273','2014-03-22','11:15:00',1.89),('16273','2014-03-22','11:20:00',2.19),('16273','2014-03-22','11:25:00',4.12),('16273','2014-03-22','11:30:00',3.16),('16273','2014-03-22','11:35:00',2.1),('16273','2014-03-22','11:40:00',3.42),('16273','2014-03-22','11:45:00',1.89),('16273','2014-03-22','11:50:00',3.74),('16273','2014-03-22','11:55:00',3.84),('16273','2014-03-22','12:00:00',2.52),('16273','2014-03-22','12:05:00',2.15),('16273','2014-03-22','12:10:00',2.81),('16273','2014-03-22','12:15:00',1.27),('16273','2014-03-22','12:20:00',3.71),('16273','2014-03-22','12:25:00',3.76),('16273','2014-03-22','12:30:00',2.72),('16273','2014-03-22','12:35:00',1.89),('16273','2014-03-22','12:40:00',2.5),('16273','2014-03-22','12:45:00',2.34),('16273','2014-03-22','12:50:00',1.34),('16273','2014-03-22','12:55:00',2.53),('16273','2014-03-22','13:00:00',2.57),('16273','2014-03-22','13:05:00',1.33),('16273','2014-03-22','13:10:00',2.93),('16273','2014-03-22','13:15:00',2.29),('16273','2014-03-22','13:20:00',3.44),('16273','2014-03-22','13:25:00',2.99),('16273','2014-03-22','13:30:00',3.3),('16273','2014-03-22','13:35:00',3.22),('16273','2014-03-22','13:40:00',3.14),('16273','2014-03-22','13:45:00',1.83),('16273','2014-03-22','13:50:00',2.07),('16273','2014-03-22','13:55:00',2.91),('16273','2014-03-22','14:00:00',2.88),('16273','2014-03-22','14:05:00',2.84),('16273','2014-03-22','14:10:00',2.79),('16273','2014-03-22','14:15:00',2.64),('16273','2014-03-22','14:20:00',1.74),('16273','2014-03-22','14:25:00',2.64),('16273','2014-03-22','14:30:00',2.53),('16273','2014-03-22','14:35:00',2.47),('16273','2014-03-22','14:40:00',2.4),('16273','2014-03-22','14:45:00',2.33),('16273','2014-03-22','14:50:00',2.12),('16273','2014-03-22','14:55:00',2.15),('16273','2014-03-22','15:00:00',2.11),('16273','2014-03-22','15:05:00',2.02),('16273','2014-03-22','15:10:00',1.74),('16273','2014-03-22','15:15:00',1.68),('16273','2014-03-22','15:20:00',1.87),('16273','2014-03-22','15:25:00',1.79),('16273','2014-03-22','15:30:00',1.92),('16273','2014-03-22','15:35:00',1.53),('16273','2014-03-22','15:40:00',1.46),('16273','2014-03-22','15:45:00',1.48),('16273','2014-03-22','15:50:00',1.17),('16273','2014-03-22','15:55:00',1.51),('16273','2014-03-22','16:00:00',1.41),('16273','2014-03-22','16:05:00',1.15),('16273','2014-03-22','16:20:00',1.11),('16273','2014-03-21','07:30:00',1.02),('16273','2014-03-21','07:35:00',1.24),('16273','2014-03-21','07:40:00',1.37),('16273','2014-03-21','07:45:00',1.53),('16273','2014-03-21','07:50:00',1.67),('16273','2014-03-21','07:55:00',1.74),('16273','2014-03-21','08:00:00',1.82),('16273','2014-03-21','08:05:00',1.88),('16273','2014-03-21','08:10:00',1.97),('16273','2014-03-21','08:15:00',1.98),('16273','2014-03-21','08:20:00',2.09),('16273','2014-03-21','08:25:00',2.2),('16273','2014-03-21','08:30:00',2.28),('16273','2014-03-21','08:35:00',2.34),('16273','2014-03-21','08:40:00',2.41),('16273','2014-03-21','08:45:00',2.46),('16273','2014-03-21','08:50:00',2.53),('16273','2014-03-21','08:55:00',2.57),('16273','2014-03-21','09:00:00',2.66),('16273','2014-03-21','09:05:00',2.65),('16273','2014-03-21','09:10:00',2.75),('16273','2014-03-21','09:15:00',2.76),('16273','2014-03-21','09:20:00',2.87),('16273','2014-03-21','09:25:00',2.79),('16273','2014-03-21','09:30:00',2.95),('16273','2014-03-21','09:35:00',3.06),('16273','2014-03-21','09:40:00',3.03),('16273','2014-03-21','09:45:00',3.07),('16273','2014-03-21','09:50:00',3.1),('16273','2014-03-21','09:55:00',3.16),('16273','2014-03-21','10:00:00',3.08),('16273','2014-03-21','10:05:00',3.13),('16273','2014-03-21','10:10:00',3.04),('16273','2014-03-21','10:15:00',3.16),('16273','2014-03-21','10:20:00',3.16),('16273','2014-03-21','10:25:00',3.25),('16273','2014-03-21','10:30:00',3.27),('16273','2014-03-21','10:35:00',3.34),('16273','2014-03-21','10:40:00',3.31),('16273','2014-03-21','10:45:00',3.34),('16273','2014-03-21','10:50:00',3.36),('16273','2014-03-21','10:55:00',3.46),('16273','2014-03-21','11:00:00',3.42),('16273','2014-03-21','11:05:00',3.42),('16273','2014-03-21','11:10:00',3.44),('16273','2014-03-21','11:15:00',3.43),('16273','2014-03-21','11:20:00',3.4),('16273','2014-03-21','11:25:00',3.45),('16273','2014-03-21','11:30:00',3.48),('16273','2014-03-21','11:35:00',3.52),('16273','2014-03-21','11:40:00',3.42),('16273','2014-03-21','11:45:00',3.32),('16273','2014-03-21','11:50:00',3.48),('16273','2014-03-21','11:55:00',3.45),('16273','2014-03-21','12:00:00',3.44),('16273','2014-03-21','12:05:00',3.48),('16273','2014-03-21','12:10:00',3.46),('16273','2014-03-21','12:15:00',3.5),('16273','2014-03-21','12:20:00',3.46),('16273','2014-03-21','12:25:00',3.43),('16273','2014-03-21','12:30:00',3.45),('16273','2014-03-21','12:35:00',3.45),('16273','2014-03-21','12:40:00',3.44),('16273','2014-03-21','12:45:00',3.43),('16273','2014-03-21','12:50:00',3.39),('16273','2014-03-21','12:55:00',3.36),('16273','2014-03-21','13:00:00',3.26),('16273','2014-03-21','13:05:00',3.29),('16273','2014-03-21','13:10:00',3.25),('16273','2014-03-21','13:15:00',3.23),('16273','2014-03-21','13:20:00',3.22),('16273','2014-03-21','13:25:00',3.18),('16273','2014-03-21','13:30:00',3.09),('16273','2014-03-21','13:35:00',3.09),('16273','2014-03-21','13:40:00',3.1),('16273','2014-03-21','13:45:00',3.02),('16273','2014-03-21','13:50:00',3),('16273','2014-03-21','13:55:00',2.97),('16273','2014-03-21','14:00:00',2.9),('16273','2014-03-21','14:05:00',2.84),('16273','2014-03-21','14:10:00',2.8),('16273','2014-03-21','14:15:00',2.75),('16273','2014-03-21','14:20:00',2.69),('16273','2014-03-21','14:25:00',2.61),('16273','2014-03-21','14:30:00',2.53),('16273','2014-03-21','14:35:00',1.96),('16273','2014-03-21','14:40:00',1.82),('16273','2014-03-21','14:45:00',1.05),('16273','2014-03-21','14:50:00',1.11),('16273','2014-03-21','14:55:00',2),('16273','2014-03-21','15:00:00',2.3),('16273','2014-03-21','15:05:00',2.39),('16273','2014-03-21','15:10:00',2.4),('16273','2014-03-21','15:15:00',1.83),('16273','2014-03-21','15:20:00',1.3),('16273','2014-03-21','15:25:00',2.17),('16273','2014-03-21','15:30:00',2.04),('16273','2014-03-21','15:35:00',1.98),('16273','2014-03-21','15:40:00',1.73),('16273','2014-03-21','15:45:00',1.83),('16273','2014-03-21','15:50:00',1.81),('16273','2014-03-21','15:55:00',1.72),('16273','2014-03-21','16:00:00',1.59),('16273','2014-03-21','16:05:00',1.42),('16273','2014-03-21','16:10:00',1.3),('16273','2014-03-21','16:15:00',1.18),('16273','2014-03-21','16:20:00',1.08),('16273','2014-03-20','07:30:00',1.07),('16273','2014-03-20','07:35:00',1.32),('16273','2014-03-20','07:40:00',1.45),('16273','2014-03-20','07:45:00',1.54),('16273','2014-03-20','07:50:00',1.59),('16273','2014-03-20','07:55:00',1.61),('16273','2014-03-20','08:00:00',1.69),('16273','2014-03-20','08:05:00',1.65),('16273','2014-03-20','08:10:00',1.62),('16273','2014-03-20','08:15:00',1.74),('16273','2014-03-20','08:20:00',1.87),('16273','2014-03-20','08:25:00',1.96),('16273','2014-03-20','08:30:00',2.1),('16273','2014-03-20','08:35:00',2.27),('16273','2014-03-20','08:40:00',2.37),('16273','2014-03-20','08:45:00',2.49),('16273','2014-03-20','08:50:00',2.51),('16273','2014-03-20','08:55:00',2.58),('16273','2014-03-20','09:00:00',2.62),('16273','2014-03-20','09:05:00',2.71),('16273','2014-03-20','09:10:00',2.75),('16273','2014-03-20','09:15:00',2.77),('16273','2014-03-20','09:20:00',2.87),('16273','2014-03-20','09:25:00',2.89),('16273','2014-03-20','09:30:00',2.91),('16273','2014-03-20','09:35:00',2.98),('16273','2014-03-20','09:40:00',2.96),('16273','2014-03-20','09:45:00',3.05),('16273','2014-03-20','09:50:00',3.14),('16273','2014-03-20','09:55:00',3.17),('16273','2014-03-20','10:00:00',3.25),('16273','2014-03-20','10:05:00',3.3),('16273','2014-03-20','10:10:00',3.25),('16273','2014-03-20','10:15:00',3.3),('16273','2014-03-20','10:20:00',3.41),('16273','2014-03-20','10:25:00',3.44),('16273','2014-03-20','10:30:00',3.43),('16273','2014-03-20','10:35:00',3.26),('16273','2014-03-20','10:40:00',3.17),('16273','2014-03-20','10:45:00',3.37),('16273','2014-03-20','10:50:00',3.49),('16273','2014-03-20','10:55:00',3.49),('16273','2014-03-20','11:00:00',3.5),('16273','2014-03-20','11:05:00',3.49),('16273','2014-03-20','11:10:00',3.26),('16273','2014-03-20','11:15:00',3.27),('16273','2014-03-20','11:20:00',3.4),('16273','2014-03-20','11:25:00',3.44),('16273','2014-03-20','11:30:00',3.34),('16273','2014-03-20','11:35:00',3.19),('16273','2014-03-20','11:40:00',3.14),('16273','2014-03-20','11:45:00',3.29),('16273','2014-03-20','11:50:00',3.36),('16273','2014-03-20','11:55:00',3.29),('16273','2014-03-20','12:00:00',2.96),('16273','2014-03-20','12:05:00',3.29),('16273','2014-03-20','12:10:00',3.44),('16273','2014-03-20','12:15:00',3.54),('16273','2014-03-20','12:20:00',3.28),('16273','2014-03-20','12:25:00',3.24),('16273','2014-03-20','12:30:00',3.43),('16273','2014-03-20','12:35:00',3.53),('16273','2014-03-20','12:40:00',3.51),('16273','2014-03-20','12:45:00',3.49),('16273','2014-03-20','12:50:00',3.42),('16273','2014-03-20','12:55:00',3.32),('16273','2014-03-20','13:00:00',3.24),('16273','2014-03-20','13:05:00',3.1),('16273','2014-03-20','13:10:00',3.12),('16273','2014-03-20','13:15:00',3.11),('16273','2014-03-20','13:20:00',3.07),('16273','2014-03-20','13:25:00',3.04),('16273','2014-03-20','13:30:00',2.96),('16273','2014-03-20','13:35:00',2.85),('16273','2014-03-20','13:40:00',2.71),('16273','2014-03-20','13:45:00',2.64),('16273','2014-03-20','13:50:00',2.69),('16273','2014-03-20','13:55:00',2.45),('16273','2014-03-20','14:00:00',2.5),('16273','2014-03-20','14:05:00',2.52),('16273','2014-03-20','14:10:00',2.47),('16273','2014-03-20','14:15:00',2.11),('16273','2014-03-20','14:20:00',2.04),('16273','2014-03-20','14:25:00',2.03),('16273','2014-03-20','14:30:00',2.08),('16273','2014-03-20','14:35:00',2.04),('16273','2014-03-20','14:40:00',2.08),('16273','2014-03-20','14:45:00',2.06),('16273','2014-03-20','14:50:00',2.04),('16273','2014-03-20','14:55:00',2),('16273','2014-03-20','15:00:00',1.84),('16273','2014-03-20','15:05:00',1.74),('16273','2014-03-20','15:10:00',1.77),('16273','2014-03-20','15:15:00',1.71),('16273','2014-03-20','15:20:00',1.62),('16273','2014-03-20','15:25:00',1.4),('16273','2014-03-20','15:30:00',1.34),('16273','2014-03-20','15:35:00',1.23),('16273','2014-03-20','15:40:00',1.12),('16273','2014-03-19','08:45:00',1),('16273','2014-03-19','09:00:00',1.06),('16273','2014-03-19','09:05:00',1.18),('16273','2014-03-19','09:10:00',1.15),('16273','2014-03-19','09:15:00',1.13),('16273','2014-03-19','09:20:00',1.31),('16273','2014-03-19','09:25:00',1.61),('16273','2014-03-19','09:30:00',1.6),('16273','2014-03-19','09:35:00',1.81),('16273','2014-03-19','09:40:00',1.73),('16273','2014-03-19','09:45:00',2.29),('16273','2014-03-19','09:50:00',2.03),('16273','2014-03-19','09:55:00',1.35),('16273','2014-03-19','10:00:00',1.3),('16273','2014-03-19','10:05:00',1.3),('16273','2014-03-19','10:10:00',1.32),('16273','2014-03-19','10:15:00',1.39),('16273','2014-03-19','10:20:00',3.61),('16273','2014-03-19','10:25:00',2.64),('16273','2014-03-19','10:30:00',1.35),('16273','2014-03-19','10:35:00',1.48),('16273','2014-03-19','10:40:00',1.96),('16273','2014-03-19','10:45:00',2.06),('16273','2014-03-19','10:50:00',1.5),('16273','2014-03-19','10:55:00',1.27),('16273','2014-03-19','11:00:00',1.08),('16273','2014-03-19','11:05:00',1.12),('16273','2014-03-19','11:10:00',1.19),('16273','2014-03-19','11:15:00',1.35),('16273','2014-03-19','11:20:00',1.47),('16273','2014-03-19','11:25:00',1.68),('16273','2014-03-19','11:30:00',1.89),('16273','2014-03-19','11:35:00',2.2),('16273','2014-03-19','11:40:00',1.95),('16273','2014-03-19','11:45:00',2.18),('16273','2014-03-19','11:50:00',1.55),('16273','2014-03-19','11:55:00',1.91),('16273','2014-03-19','12:00:00',3.17),('16273','2014-03-19','12:05:00',2.58),('16273','2014-03-19','12:10:00',3.61),('16273','2014-03-19','12:15:00',3.2),('16273','2014-03-19','12:20:00',3.23),('16273','2014-03-19','12:25:00',3.53),('16273','2014-03-19','12:30:00',3.52),('16273','2014-03-19','12:35:00',3.19),('16273','2014-03-19','12:40:00',3.22),('16273','2014-03-19','12:45:00',3.45),('16273','2014-03-19','12:50:00',3.47),('16273','2014-03-19','12:55:00',3.03),('16273','2014-03-19','13:00:00',3.29),('16273','2014-03-19','13:05:00',3.37),('16273','2014-03-19','13:10:00',3.08),('16273','2014-03-19','13:15:00',2.79),('16273','2014-03-19','13:20:00',2.93),('16273','2014-03-19','13:25:00',3.19),('16273','2014-03-19','13:30:00',3.07),('16273','2014-03-19','13:35:00',3.03),('16273','2014-03-19','13:40:00',3.09),('16273','2014-03-19','13:45:00',3),('16273','2014-03-19','13:50:00',2.96),('16273','2014-03-19','13:55:00',2.89),('16273','2014-03-19','14:00:00',2.85),('16273','2014-03-19','14:05:00',2.8),('16273','2014-03-19','14:10:00',2.75),('16273','2014-03-19','14:15:00',2.7),('16273','2014-03-19','14:20:00',2.58),('16273','2014-03-19','14:25:00',2.52),('16273','2014-03-19','14:30:00',2.49),('16273','2014-03-19','14:35:00',2.47),('16273','2014-03-19','14:40:00',2.38),('16273','2014-03-19','14:45:00',2.36),('16273','2014-03-19','14:50:00',2.3),('16273','2014-03-19','14:55:00',2.21),('16273','2014-03-19','15:00:00',2.13),('16273','2014-03-19','15:05:00',2.06),('16273','2014-03-19','15:10:00',2),('16273','2014-03-19','15:15:00',1.91),('16273','2014-03-19','15:20:00',1.85),('16273','2014-03-19','15:25:00',1.79),('16273','2014-03-19','15:30:00',1.68),('16273','2014-03-19','15:35:00',1.63),('16273','2014-03-19','15:40:00',1.57),('16273','2014-03-19','15:45:00',1.49),('16273','2014-03-19','15:50:00',1.43),('16273','2014-03-19','15:55:00',1.35),('16273','2014-03-19','16:00:00',1.28),('16273','2014-03-19','16:05:00',1.22),('16273','2014-03-19','16:10:00',1.15),('16273','2014-03-19','16:15:00',1.08),('16273','2014-03-18','07:45:00',1.25),('16273','2014-03-18','07:50:00',1.11),('16273','2014-03-18','07:55:00',1.13),('16273','2014-03-18','08:00:00',1.09),('16273','2014-03-18','08:15:00',1.03),('16273','2014-03-18','08:25:00',1.02),('16273','2014-03-18','08:30:00',1.83),('16273','2014-03-18','08:35:00',2.18),('16273','2014-03-18','08:40:00',1.16),('16273','2014-03-18','08:45:00',1.18),('16273','2014-03-18','08:50:00',1.22),('16273','2014-03-18','08:55:00',1.4),('16273','2014-03-18','09:00:00',2.99),('16273','2014-03-18','09:05:00',3.33),('16273','2014-03-18','09:10:00',3),('16273','2014-03-18','09:15:00',2.92),('16273','2014-03-18','09:20:00',3.29),('16273','2014-03-18','09:25:00',3.42),('16273','2014-03-18','09:30:00',3.46),('16273','2014-03-18','09:35:00',3.37),('16273','2014-03-18','09:40:00',1.47),('16273','2014-03-18','09:55:00',1.05),('16273','2014-03-18','10:00:00',1),('16273','2014-03-18','10:05:00',1.94),('16273','2014-03-18','10:10:00',2.14),('16273','2014-03-18','10:15:00',1.43),('16273','2014-03-18','10:20:00',3.03),('16273','2014-03-18','10:25:00',1.27),('16273','2014-03-18','10:30:00',2.2),('16273','2014-03-18','10:35:00',4.04),('16273','2014-03-18','10:40:00',3.74),('16273','2014-03-18','10:45:00',1.53),('16273','2014-03-18','10:50:00',1.37),('16273','2014-03-18','10:55:00',1.67),('16273','2014-03-18','11:00:00',3.79),('16273','2014-03-18','11:05:00',1.38),('16273','2014-03-18','11:10:00',1.45),('16273','2014-03-18','11:15:00',1.79),('16273','2014-03-18','11:20:00',2.43),('16273','2014-03-18','11:25:00',2.37),('16273','2014-03-18','11:30:00',3.29),('16273','2014-03-18','11:35:00',3.58),('16273','2014-03-18','11:40:00',3.48),('16273','2014-03-18','11:45:00',3.55),('16273','2014-03-18','11:50:00',3.18),('16273','2014-03-18','11:55:00',1.99),('16273','2014-03-18','12:00:00',2.09),('16273','2014-03-18','12:05:00',2.72),('16273','2014-03-18','12:10:00',2.05),('16273','2014-03-18','12:15:00',3.52),('16273','2014-03-18','12:20:00',2.59),('16273','2014-03-18','12:25:00',2.4),('16273','2014-03-18','12:30:00',2.95),('16273','2014-03-18','12:35:00',3.32),('16273','2014-03-18','12:40:00',3.11),('16273','2014-03-18','12:45:00',3.35),('16273','2014-03-18','12:50:00',2.57),('16273','2014-03-18','12:55:00',3.42),('16273','2014-03-18','13:00:00',3.37),('16273','2014-03-18','13:05:00',2.89),('16273','2014-03-18','13:10:00',3.29),('16273','2014-03-18','13:15:00',3.23),('16273','2014-03-18','13:20:00',3.22),('16273','2014-03-18','13:25:00',3.17),('16273','2014-03-18','13:30:00',3.18),('16273','2014-03-18','13:35:00',3.12),('16273','2014-03-18','13:40:00',3.06),('16273','2014-03-18','13:45:00',3.01),('16273','2014-03-18','13:50:00',2.99),('16273','2014-03-18','13:55:00',2.94),('16273','2014-03-18','14:00:00',2.92),('16273','2014-03-18','14:05:00',2.86),('16273','2014-03-18','14:10:00',2.74),('16273','2014-03-18','14:15:00',2.68),('16273','2014-03-18','14:20:00',2.65),('16273','2014-03-18','14:25:00',2.62),('16273','2014-03-18','14:30:00',2.49),('16273','2014-03-18','14:35:00',2.46),('16273','2014-03-18','14:40:00',2.42),('16273','2014-03-18','14:45:00',2.38),('16273','2014-03-18','14:50:00',2.29),('16273','2014-03-18','14:55:00',2.23),('16273','2014-03-18','15:00:00',2.14),('16273','2014-03-18','15:05:00',2.07),('16273','2014-03-18','15:10:00',2.01),('16273','2014-03-18','15:15:00',1.93),('16273','2014-03-18','15:20:00',1.85),('16273','2014-03-18','15:25:00',1.75),('16273','2014-03-18','15:30:00',1.69),('16273','2014-03-18','15:35:00',1.54),('16273','2014-03-18','15:40:00',1.52),('16273','2014-03-18','15:45:00',1.44),('16273','2014-03-18','15:50:00',1.37),('16273','2014-03-18','15:55:00',1.31),('16273','2014-03-18','16:00:00',1.25),('16273','2014-03-18','16:05:00',1.19),('16273','2014-03-18','16:10:00',1.04),('16273','2014-03-18','16:15:00',1.04),('16273','2014-05-01','07:40:00',1.45),('16273','2014-05-01','07:45:00',1.55),('16273','2014-05-01','07:50:00',1.61),('16273','2014-05-01','07:55:00',1.75),('16273','2014-05-01','08:00:00',1.87),('16273','2014-05-01','08:05:00',1.41),('16273','2014-05-01','08:10:00',1.92),('16273','2014-05-01','08:15:00',1.99),('16273','2014-05-01','08:20:00',2.06),('16273','2014-05-01','08:25:00',2.14),('16273','2014-05-01','08:30:00',2.23),('16273','2014-05-01','08:35:00',2.2),('16273','2014-05-01','08:40:00',1.68),('16273','2014-05-01','08:45:00',2.31),('16273','2014-05-01','08:50:00',1.78),('16273','2014-05-01','08:55:00',2.56),('16273','2014-05-01','09:00:00',2.48),('16273','2014-05-01','09:05:00',2.32),('16273','2014-05-01','09:10:00',1.62),('16273','2014-05-01','09:15:00',2.03),('16273','2014-05-01','09:20:00',1.02),('16273','2014-05-01','09:25:00',1.37),('16273','2014-05-01','09:30:00',2.5),('16273','2014-05-01','09:35:00',1.85),('16273','2014-05-01','09:40:00',1.31),('16273','2014-05-01','09:45:00',1.37),('16273','2014-05-01','09:50:00',2.25),('16273','2014-05-01','09:55:00',1.84),('16273','2014-05-01','10:00:00',2.94),('16273','2014-05-01','10:05:00',2.68),('16273','2014-05-01','10:10:00',1.43),('16273','2014-05-01','10:15:00',1.56),('16273','2014-05-01','10:20:00',2.15),('16273','2014-05-01','10:25:00',3.57),('16273','2014-05-01','10:30:00',2.88),('16273','2014-05-01','10:35:00',2.19),('16273','2014-05-01','10:40:00',2.87),('16273','2014-05-01','10:45:00',3.87),('16273','2014-05-01','10:50:00',3.56),('16273','2014-05-01','10:55:00',3.63),('16273','2014-05-01','11:00:00',4.03),('16273','2014-05-01','11:05:00',4.09),('16273','2014-05-01','11:10:00',2.33),('16273','2014-05-01','11:15:00',2.19),('16273','2014-05-01','11:20:00',3.23),('16273','2014-05-01','11:25:00',2.85),('16273','2014-05-01','11:30:00',1.86),('16273','2014-05-01','11:35:00',4.21),('16273','2014-05-01','11:40:00',4.32),('16273','2014-05-01','11:45:00',3.96),('16273','2014-05-01','11:50:00',4.29),('16273','2014-05-01','11:55:00',4.25),('16273','2014-05-01','12:00:00',4.17),('16273','2014-05-01','12:05:00',4.29),('16273','2014-05-01','12:10:00',3.04),('16273','2014-05-01','12:15:00',1.32),('16273','2014-05-01','12:20:00',1.44),('16273','2014-05-01','12:25:00',3.9),('16273','2014-05-01','12:30:00',2.74),('16273','2014-05-01','12:35:00',2.79),('16273','2014-05-01','12:40:00',4.51),('16273','2014-05-01','12:45:00',4.24),('16273','2014-05-01','12:50:00',2.93),('16273','2014-05-01','12:55:00',1.45),('16273','2014-05-01','13:00:00',3.29),('16273','2014-05-01','13:05:00',4.41),('16273','2014-05-01','13:10:00',4.29),('16273','2014-05-01','13:15:00',4.2),('16273','2014-05-01','13:20:00',4.05),('16273','2014-05-01','13:25:00',4.12),('16273','2014-05-01','13:30:00',4.21),('16273','2014-05-01','13:35:00',4),('16273','2014-05-01','13:40:00',3.94),('16273','2014-05-01','13:45:00',3.87),('16273','2014-05-01','13:50:00',3.49),('16273','2014-05-01','13:55:00',3.75),('16273','2014-05-01','14:00:00',3.74),('16273','2014-05-01','14:05:00',3.71),('16273','2014-05-01','14:10:00',3.66),('16273','2014-05-01','14:15:00',3.65),('16273','2014-05-01','14:20:00',3.61),('16273','2014-05-01','14:25:00',3.53),('16273','2014-05-01','14:30:00',3.43),('16273','2014-05-01','14:35:00',3.62),('16273','2014-05-01','14:40:00',3.43),('16273','2014-05-01','14:45:00',3.48),('16273','2014-05-01','14:50:00',3.33),('16273','2014-05-01','14:55:00',3.28),('16273','2014-05-01','15:00:00',3.32),('16273','2014-05-01','15:05:00',2.28),('16273','2014-05-01','15:10:00',3.35),('16273','2014-05-01','15:15:00',3.22),('16273','2014-05-01','15:20:00',3.07),('16273','2014-05-01','15:25:00',3.01),('16273','2014-05-01','15:30:00',2.99),('16273','2014-05-01','15:35:00',2.93),('16273','2014-05-01','15:40:00',2.81),('16273','2014-05-01','15:45:00',2.71),('16273','2014-05-01','15:50:00',2.66),('16273','2014-05-01','15:55:00',2.68),('16273','2014-05-01','16:00:00',2.72),('16273','2014-05-01','16:05:00',2.53),('16273','2014-05-01','16:10:00',2.42),('16273','2014-05-01','16:15:00',2.27),('16273','2014-05-01','16:20:00',2.15),('16273','2014-05-01','16:25:00',2.26),('16273','2014-05-01','16:30:00',2.2),('16273','2014-05-01','16:35:00',2.08),('16273','2014-05-01','16:40:00',1.8),('16273','2014-05-01','16:45:00',1.66),('16273','2014-05-01','16:50:00',1.59),('16273','2014-05-01','16:55:00',1.75),('16273','2014-05-01','17:00:00',1.51),('16273','2014-05-01','17:05:00',1.65),('16273','2014-05-01','17:10:00',1.57),('16273','2014-05-01','17:15:00',1.48),('16273','2014-05-01','17:20:00',1.26),('16273','2014-05-01','17:25:00',1.33),('16273','2014-05-01','17:30:00',1.29),('16273','2014-05-01','17:40:00',1.13),('16273','2014-03-17','10:25:00',1.19),('16273','2014-03-17','10:30:00',1.31),('16273','2014-03-17','10:35:00',1.63),('16273','2014-03-17','10:40:00',1.54),('16273','2014-03-17','10:45:00',2.42),('16273','2014-03-17','10:50:00',1.68),('16273','2014-03-17','10:55:00',1.84),('16273','2014-03-17','11:00:00',1.2),('16273','2014-03-17','11:05:00',1.29),('16273','2014-03-17','11:10:00',1.17),('16273','2014-03-17','11:20:00',1.17),('16273','2014-03-17','11:25:00',1.16),('16273','2014-03-17','11:35:00',1.14),('16273','2014-03-17','11:40:00',1.15),('16273','2014-03-17','11:45:00',1.25),('16273','2014-03-17','11:50:00',1.9),('16273','2014-03-17','11:55:00',2.3),('16273','2014-03-17','12:00:00',1.96),('16273','2014-03-17','12:05:00',3.97),('16273','2014-03-17','12:10:00',2.83),('16273','2014-03-17','12:15:00',2.87),('16273','2014-03-17','12:20:00',2.24),('16273','2014-03-17','12:25:00',2.68),('16273','2014-03-17','12:30:00',2.81),('16273','2014-03-17','12:35:00',3.64),('16273','2014-03-17','12:40:00',1.91),('16273','2014-03-17','12:45:00',2.57),('16273','2014-03-17','12:50:00',3.47),('16273','2014-03-17','12:55:00',3.55),('16273','2014-03-17','13:00:00',3.49),('16273','2014-03-17','13:05:00',3.28),('16273','2014-03-17','13:10:00',3.26),('16273','2014-03-17','13:15:00',3.29),('16273','2014-03-17','13:20:00',3.34),('16273','2014-03-17','13:25:00',3.15),('16273','2014-03-17','13:30:00',3.09),('16273','2014-03-17','13:35:00',2.73),('16273','2014-03-17','13:40:00',2.91),('16273','2014-03-17','13:45:00',2.7),('16273','2014-03-17','13:50:00',3.08),('16273','2014-03-17','13:55:00',2.3),('16273','2014-03-17','14:00:00',2.41),('16273','2014-03-17','14:05:00',2.84),('16273','2014-03-17','14:10:00',2.47),('16273','2014-03-17','14:15:00',1.65),('16273','2014-03-17','14:20:00',2.79),('16273','2014-03-17','14:25:00',2.18),('16273','2014-03-17','14:30:00',2.11),('16273','2014-03-17','14:35:00',2.17),('16273','2014-03-17','14:40:00',1.8),('16273','2014-03-17','14:45:00',2.43),('16273','2014-03-17','14:50:00',2.24),('16273','2014-03-17','14:55:00',2.07),('16273','2014-03-17','15:00:00',1.89),('16273','2014-03-17','15:05:00',2.03),('16273','2014-03-17','15:10:00',2.18),('16273','2014-03-17','15:15:00',1.26),('16273','2014-03-17','15:20:00',1.78),('16273','2014-03-17','15:25:00',1.76),('16273','2014-03-17','15:30:00',1.83),('16273','2014-03-17','15:35:00',1.57),('16273','2014-03-17','15:40:00',1.24),('16273','2014-03-17','15:45:00',1.42),('16273','2014-03-17','15:50:00',1.48),('16273','2014-03-17','15:55:00',1.19),('16273','2014-03-17','16:00:00',1.09),('16273','2014-03-17','16:05:00',1.17),('16273','2014-03-17','16:10:00',1.05),('16273','2014-03-17','16:15:00',1.02),('16273','2014-03-16','07:50:00',1.04),('16273','2014-03-16','07:55:00',1.07),('16273','2014-03-16','08:00:00',1.3),('16273','2014-03-16','08:05:00',1.47),('16273','2014-03-16','08:10:00',1.58),('16273','2014-03-16','08:15:00',1.57),('16273','2014-03-16','08:20:00',1.63),('16273','2014-03-16','08:25:00',1.78),('16273','2014-03-16','08:30:00',1.9),('16273','2014-03-16','08:35:00',2),('16273','2014-03-16','08:40:00',2.08),('16273','2014-03-16','08:45:00',2.11),('16273','2014-03-16','08:50:00',2.21),('16273','2014-03-16','08:55:00',2.26),('16273','2014-03-16','09:00:00',2.2),('16273','2014-03-16','09:05:00',2.25),('16273','2014-03-16','09:10:00',2.37),('16273','2014-03-16','09:15:00',2.56),('16273','2014-03-16','09:20:00',2.48),('16273','2014-03-16','09:25:00',2.56),('16273','2014-03-16','09:30:00',2.56),('16273','2014-03-16','09:35:00',2.52),('16273','2014-03-16','09:40:00',2.57),('16273','2014-03-16','09:45:00',2.69),('16273','2014-03-16','09:50:00',2.86),('16273','2014-03-16','09:55:00',2.8),('16273','2014-03-16','10:00:00',2.9),('16273','2014-03-16','10:05:00',2.83),('16273','2014-03-16','10:10:00',2.98),('16273','2014-03-16','10:15:00',3.07),('16273','2014-03-16','10:20:00',3.1),('16273','2014-03-16','10:25:00',3.06),('16273','2014-03-16','10:30:00',3.06),('16273','2014-03-16','10:35:00',3.1),('16273','2014-03-16','10:40:00',3.16),('16273','2014-03-16','10:45:00',3.21),('16273','2014-03-16','10:50:00',3.19),('16273','2014-03-16','10:55:00',3.21),('16273','2014-03-16','11:00:00',3.24),('16273','2014-03-16','11:05:00',3.3),('16273','2014-03-16','11:10:00',3.3),('16273','2014-03-16','11:15:00',3.3),('16273','2014-03-16','11:20:00',3.29),('16273','2014-03-16','11:25:00',3.31),('16273','2014-03-16','11:30:00',3.24),('16273','2014-03-16','11:35:00',3.3),('16273','2014-03-16','11:40:00',3.28),('16273','2014-03-16','11:45:00',3.37),('16273','2014-03-16','11:50:00',3.32),('16273','2014-03-16','11:55:00',3.34),('16273','2014-03-16','12:00:00',3.36),('16273','2014-03-16','12:05:00',3.34),('16273','2014-03-16','12:10:00',3.33),('16273','2014-03-16','12:15:00',3.29),('16273','2014-03-16','12:20:00',3.3),('16273','2014-03-16','12:25:00',3.26),('16273','2014-03-16','12:30:00',3.22),('16273','2014-03-16','12:35:00',3.21),('16273','2014-03-16','12:40:00',3.19),('16273','2014-03-16','12:45:00',3.19),('16273','2014-03-16','12:50:00',3.19),('16273','2014-03-16','12:55:00',3.19),('16273','2014-03-16','13:00:00',3.14),('16273','2014-03-16','13:05:00',3.09),('16273','2014-03-16','13:10:00',3.09),('16273','2014-03-16','13:15:00',3.03),('16273','2014-03-16','13:20:00',2.94),('16273','2014-03-16','13:25:00',2.98),('16273','2014-03-16','13:30:00',2.94),('16273','2014-03-16','13:35:00',2.93),('16273','2014-03-16','13:40:00',2.85),('16273','2014-03-16','13:45:00',2.88),('16273','2014-03-16','13:50:00',2.82),('16273','2014-03-16','13:55:00',2.78),('16273','2014-03-16','14:00:00',2.73),('16273','2014-03-16','14:05:00',2.66),('16273','2014-03-16','14:10:00',2.58),('16273','2014-03-16','14:15:00',2.56),('16273','2014-03-16','14:20:00',2.51),('16273','2014-03-16','14:25:00',2.46),('16273','2014-03-16','14:30:00',2.39),('16273','2014-03-16','14:35:00',2.31),('16273','2014-03-16','14:40:00',2.21),('16273','2014-03-16','14:45:00',2),('16273','2014-03-16','14:50:00',1.94),('16273','2014-03-16','14:55:00',2.21),('16273','2014-03-16','15:00:00',1.85),('16273','2014-03-16','15:05:00',1.77),('16273','2014-03-16','15:10:00',1.65),('16273','2014-03-16','15:15:00',1.39),('16273','2014-03-16','15:20:00',1.34),('16273','2014-03-16','15:25:00',1.41),('16273','2014-03-16','15:30:00',1.34),('16273','2014-03-16','15:35:00',1.07),('16273','2014-03-16','15:40:00',1.03),('16273','2014-03-16','15:45:00',1.27),('16273','2014-03-16','15:50:00',1.13),('16273','2014-03-16','16:05:00',1.1),('16273','2014-03-16','16:10:00',1.11),('16273','2014-03-16','16:15:00',1.06),('16273','2014-03-15','07:50:00',1.11),('16273','2014-03-15','07:55:00',1.21),('16273','2014-03-15','08:00:00',1.3),('16273','2014-03-15','08:05:00',1.38),('16273','2014-03-15','08:10:00',1.46),('16273','2014-03-15','08:15:00',1.55),('16273','2014-03-15','08:20:00',1.62),('16273','2014-03-15','08:25:00',1.69),('16273','2014-03-15','08:30:00',1.78),('16273','2014-03-15','08:35:00',1.86),('16273','2014-03-15','08:40:00',1.95),('16273','2014-03-15','08:45:00',2.04),('16273','2014-03-15','08:50:00',2.05),('16273','2014-03-15','08:55:00',2.17),('16273','2014-03-15','09:00:00',2.24),('16273','2014-03-15','09:05:00',2.3),('16273','2014-03-15','09:10:00',2.37),('16273','2014-03-15','09:15:00',2.45),('16273','2014-03-15','09:20:00',2.48),('16273','2014-03-15','09:25:00',2.52),('16273','2014-03-15','09:30:00',2.56),('16273','2014-03-15','09:35:00',2.6),('16273','2014-03-15','09:40:00',2.66),('16273','2014-03-15','09:45:00',2.69),('16273','2014-03-15','09:50:00',2.74),('16273','2014-03-15','09:55:00',2.81),('16273','2014-03-15','10:00:00',2.86),('16273','2014-03-15','10:05:00',2.9),('16273','2014-03-15','10:10:00',2.94),('16273','2014-03-15','10:15:00',2.97),('16273','2014-03-15','10:20:00',2.99),('16273','2014-03-15','10:25:00',3.01),('16273','2014-03-15','10:30:00',3.04),('16273','2014-03-15','10:35:00',3.09),('16273','2014-03-15','10:40:00',3.13),('16273','2014-03-15','10:45:00',3.16),('16273','2014-03-15','10:50:00',3.2),('16273','2014-03-15','10:55:00',3.19),('16273','2014-03-15','11:00:00',3.23),('16273','2014-03-15','11:05:00',3.15),('16273','2014-03-15','11:10:00',3.21),('16273','2014-03-15','11:15:00',3.23),('16273','2014-03-15','11:20:00',3.31),('16273','2014-03-15','11:25:00',3.23),('16273','2014-03-15','11:30:00',3.19),('16273','2014-03-15','11:35:00',3.3),('16273','2014-03-15','11:40:00',3.3),('16273','2014-03-15','11:45:00',3.29),('16273','2014-03-15','11:50:00',3.23),('16273','2014-03-15','11:55:00',3.28),('16273','2014-03-15','12:00:00',3.26),('16273','2014-03-15','12:05:00',3.27),('16273','2014-03-15','12:10:00',3.27),('16273','2014-03-15','12:15:00',3.29),('16273','2014-03-15','12:20:00',3.29),('16273','2014-03-15','12:25:00',3.3),('16273','2014-03-15','12:30:00',3.27),('16273','2014-03-15','12:35:00',3.28),('16273','2014-03-15','12:40:00',3.24),('16273','2014-03-15','12:45:00',3.24),('16273','2014-03-15','12:50:00',3.22),('16273','2014-03-15','12:55:00',3.16),('16273','2014-03-15','13:00:00',3.16),('16273','2014-03-15','13:05:00',3.14),('16273','2014-03-15','13:10:00',3.15),('16273','2014-03-15','13:15:00',3.13),('16273','2014-03-15','13:20:00',3.08),('16273','2014-03-15','13:25:00',3.05),('16273','2014-03-15','13:30:00',3.01),('16273','2014-03-15','13:35:00',2.97),('16273','2014-03-15','13:40:00',2.93),('16273','2014-03-15','13:45:00',2.89),('16273','2014-03-15','13:50:00',2.85),('16273','2014-03-15','13:55:00',2.8),('16273','2014-03-15','14:00:00',2.76),('16273','2014-03-15','14:05:00',2.72),('16273','2014-03-15','14:10:00',2.66),('16273','2014-03-15','14:15:00',2.6),('16273','2014-03-15','14:20:00',2.54),('16273','2014-03-15','14:25:00',2.48),('16273','2014-03-15','14:30:00',2.43),('16273','2014-03-15','14:35:00',2.33),('16273','2014-03-15','14:40:00',2.3),('16273','2014-03-15','14:45:00',2.23),('16273','2014-03-15','14:50:00',2.18),('16273','2014-03-15','14:55:00',2.09),('16273','2014-03-15','15:00:00',2.02),('16273','2014-03-15','15:05:00',1.95),('16273','2014-03-15','15:10:00',1.9),('16273','2014-03-15','15:15:00',1.83),('16273','2014-03-15','15:20:00',1.71),('16273','2014-03-15','15:25:00',1.66),('16273','2014-03-15','15:30:00',1.61),('16273','2014-03-15','15:35:00',1.53),('16273','2014-03-15','15:40:00',1.45),('16273','2014-03-15','15:45:00',1.36),('16273','2014-03-15','15:50:00',1.29),('16273','2014-03-15','15:55:00',1.22),('16273','2014-03-15','16:00:00',1.13),('16273','2014-03-15','16:05:00',1.08),('16273','2014-03-15','16:10:00',1.04),('16273','2014-03-14','08:25:00',1.04),('16273','2014-03-14','08:30:00',1.07),('16273','2014-03-14','08:55:00',1.01),('16273','2014-03-14','09:00:00',1.12),('16273','2014-03-14','09:05:00',1.26),('16273','2014-03-14','09:10:00',1.5),('16273','2014-03-14','09:15:00',1.8),('16273','2014-03-14','09:20:00',1.85),('16273','2014-03-14','09:25:00',1.68),('16273','2014-03-14','09:30:00',1.73),('16273','2014-03-14','09:35:00',1.62),('16273','2014-03-14','09:40:00',1.64),('16273','2014-03-14','09:45:00',1.99),('16273','2014-03-14','09:50:00',2.4),('16273','2014-03-14','09:55:00',2.7),('16273','2014-03-14','10:00:00',3.04),('16273','2014-03-14','10:05:00',3.33),('16273','2014-03-14','10:10:00',3.37),('16273','2014-03-14','10:15:00',3.27),('16273','2014-03-14','10:20:00',2.75),('16273','2014-03-14','10:25:00',3.17),('16273','2014-03-14','10:30:00',3.15),('16273','2014-03-14','10:35:00',3.19),('16273','2014-03-14','10:40:00',3.26),('16273','2014-03-14','10:45:00',3.26),('16273','2014-03-14','10:50:00',3.22),('16273','2014-03-14','10:55:00',2.38),('16273','2014-03-14','11:00:00',3.17),('16273','2014-03-14','11:05:00',3.24),('16273','2014-03-14','11:10:00',3.24),('16273','2014-03-14','11:15:00',3.47),('16273','2014-03-14','11:20:00',3.47),('16273','2014-03-14','11:25:00',3.26),('16273','2014-03-14','11:30:00',3.06),('16273','2014-03-14','11:35:00',3.27),('16273','2014-03-14','11:40:00',3.32),('16273','2014-03-14','11:45:00',3.36),('16273','2014-03-14','11:50:00',3.44),('16273','2014-03-14','11:55:00',3.53),('16273','2014-03-14','12:00:00',3.52),('16273','2014-03-14','12:05:00',3.48),('16273','2014-03-14','12:10:00',3.47),('16273','2014-03-14','12:15:00',3.44),('16273','2014-03-14','12:20:00',3.24),('16273','2014-03-14','12:25:00',3.05),('16273','2014-03-14','12:30:00',2.71),('16273','2014-03-14','12:35:00',2.08),('16273','2014-03-14','12:40:00',1.66),('16273','2014-03-14','12:45:00',1.67),('16273','2014-03-14','12:50:00',2.1),('16273','2014-03-14','12:55:00',2.37),('16273','2014-03-14','13:00:00',2.45),('16273','2014-03-14','13:05:00',2),('16273','2014-03-14','13:10:00',2.07),('16273','2014-03-14','13:15:00',2.46),('16273','2014-03-14','13:20:00',2.37),('16273','2014-03-14','13:25:00',1.98),('16273','2014-03-14','13:30:00',2.03),('16273','2014-03-14','13:35:00',1.89),('16273','2014-03-14','13:40:00',1.69),('16273','2014-03-14','13:45:00',1.84),('16273','2014-03-14','13:50:00',1.94),('16273','2014-03-14','13:55:00',2.01),('16273','2014-03-14','14:00:00',2.05),('16273','2014-03-14','14:05:00',1.97),('16273','2014-03-14','14:10:00',2.54),('16273','2014-03-14','14:15:00',2.34),('16273','2014-03-14','14:20:00',2.43),('16273','2014-03-14','14:25:00',2.66),('16273','2014-03-14','14:30:00',2.57),('16273','2014-03-14','14:35:00',2.01),('16273','2014-03-14','14:40:00',1.82),('16273','2014-03-14','14:45:00',1.56),('16273','2014-03-14','14:50:00',1.45),('16273','2014-03-14','14:55:00',1.41),('16273','2014-03-14','15:00:00',1.47),('16273','2014-03-14','15:05:00',1.18),('16273','2014-03-14','15:10:00',1.13),('16273','2014-03-14','15:15:00',1.17),('16273','2014-03-14','15:20:00',1.11),('16273','2014-03-14','15:25:00',1.15),('16273','2014-03-14','15:30:00',1.33),('16273','2014-03-14','15:35:00',1.38),('16273','2014-03-14','15:40:00',1.43),('16273','2014-03-14','15:45:00',1.31),('16273','2014-03-14','15:50:00',1.06),('16273','2014-03-14','15:55:00',1.04),('16273','2014-03-13','07:30:00',1.04),('16273','2014-03-13','07:35:00',1.18),('16273','2014-03-13','07:40:00',1.3),('16273','2014-03-13','07:45:00',1.22),('16273','2014-03-13','07:50:00',1.56),('16273','2014-03-13','07:55:00',1.66),('16273','2014-03-13','08:00:00',1.76),('16273','2014-03-13','08:05:00',1.84),('16273','2014-03-13','08:10:00',1.92),('16273','2014-03-13','08:15:00',2.01),('16273','2014-03-13','08:20:00',2.09),('16273','2014-03-13','08:25:00',2.16),('16273','2014-03-13','08:30:00',2.23),('16273','2014-03-13','08:35:00',2.31),('16273','2014-03-13','08:40:00',2.38),('16273','2014-03-13','08:45:00',2.46),('16273','2014-03-13','08:50:00',2.53),('16273','2014-03-13','08:55:00',2.59),('16273','2014-03-13','09:00:00',2.65),('16273','2014-03-13','09:05:00',2.7),('16273','2014-03-13','09:10:00',2.78),('16273','2014-03-13','09:15:00',2.84),('16273','2014-03-13','09:20:00',2.89),('16273','2014-03-13','09:25:00',2.94),('16273','2014-03-13','09:30:00',2.99),('16273','2014-03-13','09:35:00',3.04),('16273','2014-03-13','09:40:00',3.07),('16273','2014-03-13','09:45:00',3.11),('16273','2014-03-13','09:50:00',3.15),('16273','2014-03-13','09:55:00',3.17),('16273','2014-03-13','10:00:00',3.22),('16273','2014-03-13','10:05:00',3.24),('16273','2014-03-13','10:10:00',3.3),('16273','2014-03-13','10:15:00',3.33),('16273','2014-03-13','10:20:00',3.34),('16273','2014-03-13','10:25:00',3.33),('16273','2014-03-13','10:30:00',3.36),('16273','2014-03-13','10:35:00',3.39),('16273','2014-03-13','10:40:00',3.4),('16273','2014-03-13','10:45:00',3.42),('16273','2014-03-13','10:50:00',3.49),('16273','2014-03-13','10:55:00',3.51),('16273','2014-03-13','11:00:00',3.52),('16273','2014-03-13','11:05:00',3.53),('16273','2014-03-13','11:10:00',3.53),('16273','2014-03-13','11:15:00',3.56),('16273','2014-03-13','11:20:00',3.56),('16273','2014-03-13','11:25:00',3.56),('16273','2014-03-13','11:30:00',3.56),('16273','2014-03-13','11:35:00',3.57),('16273','2014-03-13','11:40:00',3.56),('16273','2014-03-13','11:45:00',3.54),('16273','2014-03-13','11:50:00',3.53),('16273','2014-03-13','11:55:00',3.5),('16273','2014-03-13','12:00:00',3.49),('16273','2014-03-13','12:05:00',3.44),('16273','2014-03-13','12:10:00',3.46),('16273','2014-03-13','12:15:00',3.44),('16273','2014-03-13','12:20:00',3.38),('16273','2014-03-13','12:25:00',3.35),('16273','2014-03-13','12:30:00',3.35),('16273','2014-03-13','12:35:00',3.32),('16273','2014-03-13','12:40:00',3.34),('16273','2014-03-13','12:45:00',3.32),('16273','2014-03-13','12:50:00',3.3),('16273','2014-03-13','12:55:00',3.28),('16273','2014-03-13','13:00:00',3.28),('16273','2014-03-13','13:05:00',3.25),('16273','2014-03-13','13:10:00',3.2),('16273','2014-03-13','13:15:00',3.18),('16273','2014-03-13','13:20:00',3.12),('16273','2014-03-13','13:25:00',3.12),('16273','2014-03-13','13:30:00',3.07),('16273','2014-03-13','13:35:00',3.03),('16273','2014-03-13','13:40:00',2.99),('16273','2014-03-13','13:45:00',2.95),('16273','2014-03-13','13:50:00',2.86),('16273','2014-03-13','13:55:00',2.83),('16273','2014-03-13','14:00:00',2.78),('16273','2014-03-13','14:05:00',2.73),('16273','2014-03-13','14:10:00',2.66),('16273','2014-03-13','14:15:00',2.61),('16273','2014-03-13','14:20:00',2.56),('16273','2014-03-13','14:25:00',2.51),('16273','2014-03-13','14:30:00',2.44),('16273','2014-03-13','14:35:00',2.38),('16273','2014-03-13','14:40:00',2.3),('16273','2014-03-13','14:45:00',2.23),('16273','2014-03-13','14:50:00',2.17),('16273','2014-03-13','14:55:00',2.09),('16273','2014-03-13','15:00:00',2.01),('16273','2014-03-13','15:05:00',1.93),('16273','2014-03-13','15:10:00',1.87),('16273','2014-03-13','15:15:00',1.8),('16273','2014-03-13','15:20:00',1.73),('16273','2014-03-13','15:25:00',1.66),('16273','2014-03-13','15:30:00',1.59),('16273','2014-03-13','15:35:00',1.51),('16273','2014-03-13','15:40:00',1.44),('16273','2014-03-13','15:45:00',1.37),('16273','2014-03-13','15:50:00',1.3),('16273','2014-03-13','15:55:00',1.23),('16273','2014-03-13','16:00:00',1.17),('16273','2014-03-13','16:05:00',1.09),('16273','2014-03-13','16:10:00',1.04),('16273','2014-03-12','07:35:00',1.12),('16273','2014-03-12','07:40:00',1.22),('16273','2014-03-12','07:45:00',1.16),('16273','2014-03-12','07:50:00',1.48),('16273','2014-03-12','07:55:00',1.59),('16273','2014-03-12','08:00:00',1.7),('16273','2014-03-12','08:05:00',1.79),('16273','2014-03-12','08:10:00',1.88),('16273','2014-03-12','08:15:00',1.97),('16273','2014-03-12','08:20:00',2.05),('16273','2014-03-12','08:25:00',2.14),('16273','2014-03-12','08:30:00',2.22),('16273','2014-03-12','08:35:00',2.3),('16273','2014-03-12','08:40:00',2.36),('16273','2014-03-12','08:45:00',2.43),('16273','2014-03-12','08:50:00',2.48),('16273','2014-03-12','08:55:00',2.56),('16273','2014-03-12','09:00:00',2.64),('16273','2014-03-12','09:05:00',2.69),('16273','2014-03-12','09:10:00',2.75),('16273','2014-03-12','09:15:00',2.79),('16273','2014-03-12','09:20:00',2.85),('16273','2014-03-12','09:25:00',2.89),('16273','2014-03-12','09:30:00',2.93),('16273','2014-03-12','09:35:00',2.98),('16273','2014-03-12','09:40:00',3.02),('16273','2014-03-12','09:45:00',3.06),('16273','2014-03-12','09:50:00',3.13),('16273','2014-03-12','09:55:00',3.17),('16273','2014-03-12','10:00:00',3.22),('16273','2014-03-12','10:05:00',3.25),('16273','2014-03-12','10:10:00',3.27),('16273','2014-03-12','10:15:00',3.3),('16273','2014-03-12','10:20:00',3.35),('16273','2014-03-12','10:25:00',3.38),('16273','2014-03-12','10:30:00',3.41),('16273','2014-03-12','10:35:00',3.4),('16273','2014-03-12','10:40:00',3.43),('16273','2014-03-12','10:45:00',3.44),('16273','2014-03-12','10:50:00',3.47),('16273','2014-03-12','10:55:00',3.48),('16273','2014-03-12','11:00:00',3.49),('16273','2014-03-12','11:05:00',3.51),('16273','2014-03-12','11:10:00',3.53),('16273','2014-03-12','11:15:00',3.56),('16273','2014-03-12','11:20:00',3.58),('16273','2014-03-12','11:25:00',3.56),('16273','2014-03-12','11:30:00',3.54),('16273','2014-03-12','11:35:00',3.55),('16273','2014-03-12','11:40:00',3.57),('16273','2014-03-12','11:45:00',3.55),('16273','2014-03-12','11:50:00',3.5),('16273','2014-03-12','11:55:00',3.53),('16273','2014-03-12','12:00:00',3.52),('16273','2014-03-12','12:05:00',3.54),('16273','2014-03-12','12:10:00',3.51),('16273','2014-03-12','12:15:00',3.48),('16273','2014-03-12','12:20:00',3.5),('16273','2014-03-12','12:25:00',3.48),('16273','2014-03-12','12:30:00',3.47),('16273','2014-03-12','12:35:00',3.45),('16273','2014-03-12','12:40:00',3.4),('16273','2014-03-12','12:45:00',3.38),('16273','2014-03-12','12:50:00',3.34),('16273','2014-03-12','12:55:00',3.33),('16273','2014-03-12','13:00:00',3.3),('16273','2014-03-12','13:05:00',3.26),('16273','2014-03-12','13:10:00',3.26),('16273','2014-03-12','13:15:00',3.21),('16273','2014-03-12','13:20:00',3.18),('16273','2014-03-12','13:25:00',3.12),('16273','2014-03-12','13:30:00',3.05),('16273','2014-03-12','13:35:00',2.98),('16273','2014-03-12','13:40:00',3),('16273','2014-03-12','13:45:00',2.95),('16273','2014-03-12','13:50:00',2.87),('16273','2014-03-12','13:55:00',2.81),('16273','2014-03-12','14:00:00',2.79),('16273','2014-03-12','14:05:00',2.76),('16273','2014-03-12','14:10:00',2.71),('16273','2014-03-12','14:15:00',2.62),('16273','2014-03-12','14:20:00',2.53),('16273','2014-03-12','14:25:00',2.46),('16273','2014-03-12','14:30:00',2.42),('16273','2014-03-12','14:35:00',2.37),('16273','2014-03-12','14:40:00',2.32),('16273','2014-03-12','14:45:00',2.25),('16273','2014-03-12','14:50:00',2.18),('16273','2014-03-12','14:55:00',2.13),('16273','2014-03-12','15:00:00',2.06),('16273','2014-03-12','15:05:00',1.96),('16273','2014-03-12','15:10:00',1.87),('16273','2014-03-12','15:15:00',1.81),('16273','2014-03-12','15:20:00',1.75),('16273','2014-03-12','15:25:00',1.67),('16273','2014-03-12','15:30:00',1.6),('16273','2014-03-12','15:35:00',1.52),('16273','2014-03-12','15:40:00',1.45),('16273','2014-03-12','15:45:00',1.4),('16273','2014-03-12','15:50:00',1.33),('16273','2014-03-12','15:55:00',1.25),('16273','2014-03-12','16:00:00',1.18),('16273','2014-03-12','16:05:00',1.1),('16273','2014-03-12','16:10:00',1.03),('16273','2014-03-11','11:20:00',1.04),('16273','2014-03-11','12:00:00',1.09),('16273','2014-03-11','12:05:00',1.1),('16273','2014-03-11','12:10:00',1.15),('16273','2014-03-11','12:15:00',1.33),('16273','2014-03-11','12:20:00',1.7),('16273','2014-03-11','12:25:00',1.65),('16273','2014-03-11','12:30:00',1.54),('16273','2014-03-11','12:35:00',1.44),('16273','2014-03-11','12:40:00',1.47),('16273','2014-03-11','12:45:00',1.68),('16273','2014-03-11','12:50:00',1.61),('16273','2014-03-11','12:55:00',1.58),('16273','2014-03-11','13:00:00',1.54),('16273','2014-03-11','13:05:00',1.42),('16273','2014-03-11','13:10:00',1.49),('16273','2014-03-11','13:15:00',1.66),('16273','2014-03-11','13:20:00',1.62),('16273','2014-03-11','13:25:00',1.38),('16273','2014-03-11','13:30:00',1.18),('16273','2014-03-11','13:35:00',1.16),('16273','2014-03-11','13:40:00',1.1),('16273','2014-03-11','13:45:00',1.16),('16273','2014-03-11','13:50:00',1.36),('16273','2014-03-11','13:55:00',1.77),('16273','2014-03-11','14:00:00',1.93),('16273','2014-03-11','14:05:00',1.71),('16273','2014-03-11','14:10:00',2.38),('16273','2014-03-11','14:15:00',2.68),('16273','2014-03-11','14:20:00',2.28),('16273','2014-03-11','14:25:00',1.83),('16273','2014-03-11','14:30:00',1.69),('16273','2014-03-11','14:35:00',1.66),('16273','2014-03-11','14:40:00',1.58),('16273','2014-03-11','14:45:00',1.47),('16273','2014-03-11','14:50:00',1.39),('16273','2014-03-11','14:55:00',1.38),('16273','2014-03-11','15:00:00',1.54),('16273','2014-03-11','15:05:00',1.61),('16273','2014-03-11','15:10:00',1.51),('16273','2014-03-11','15:15:00',1.41),('16273','2014-03-11','15:20:00',1.23),('16273','2014-03-11','15:25:00',1.1),('16273','2014-03-10','08:55:00',1.04),('16273','2014-03-10','09:00:00',1.08),('16273','2014-03-10','09:05:00',1.09),('16273','2014-03-10','09:10:00',1.09),('16273','2014-03-10','09:15:00',1.13),('16273','2014-03-10','09:20:00',1.08),('16273','2014-03-10','09:25:00',1.06),('16273','2014-03-10','09:30:00',1.11),('16273','2014-03-10','09:35:00',1.16),('16273','2014-03-10','09:40:00',1.31),('16273','2014-03-10','09:45:00',1.38),('16273','2014-03-10','09:50:00',1.32),('16273','2014-03-10','09:55:00',1.19),('16273','2014-03-10','10:00:00',1.03),('16273','2014-03-10','10:10:00',1.13),('16273','2014-03-10','10:15:00',1.31),('16273','2014-03-10','10:20:00',1.32),('16273','2014-03-10','10:25:00',1.29),('16273','2014-03-10','13:10:00',1.02),('16273','2014-03-10','13:15:00',1.05),('16273','2014-03-10','14:45:00',1),('16273','2014-03-10','14:50:00',1.11),('16273','2014-03-10','14:55:00',1.59),('16273','2014-03-10','15:00:00',1.5),('16273','2014-03-10','15:05:00',1.8),('16273','2014-03-10','15:10:00',2.27),('16273','2014-03-10','15:15:00',2.12),('16273','2014-03-10','15:20:00',2.06),('16273','2014-03-10','15:25:00',1.95),('16273','2014-03-10','15:30:00',1.85),('16273','2014-03-10','15:35:00',1.79),('16273','2014-03-10','15:40:00',1.65),('16273','2014-03-10','15:45:00',1.18),('16273','2014-03-10','15:50:00',1.12),('16273','2014-03-10','15:55:00',1.13),('16273','2014-03-09','07:40:00',1.08),('16273','2014-03-09','07:45:00',1.2),('16273','2014-03-09','07:50:00',1.15),('16273','2014-03-09','07:55:00',1.42),('16273','2014-03-09','08:00:00',1.59),('16273','2014-03-09','08:05:00',1.68),('16273','2014-03-09','08:10:00',1.78),('16273','2014-03-09','08:15:00',1.88),('16273','2014-03-09','08:20:00',1.96),('16273','2014-03-09','08:25:00',2.06),('16273','2014-03-09','08:30:00',2.05),('16273','2014-03-09','08:35:00',1.03),('16273','2014-03-09','08:40:00',2.34),('16273','2014-03-09','08:45:00',2.38),('16273','2014-03-09','08:50:00',2.38),('16273','2014-03-09','08:55:00',2.51),('16273','2014-03-09','09:00:00',2.58),('16273','2014-03-09','09:05:00',2.64),('16273','2014-03-09','09:10:00',2.64),('16273','2014-03-09','09:15:00',2.75),('16273','2014-03-09','09:20:00',2.84),('16273','2014-03-09','09:25:00',2.91),('16273','2014-03-09','09:30:00',2.97),('16273','2014-03-09','09:35:00',3.07),('16273','2014-03-09','09:40:00',3.13),('16273','2014-03-09','09:45:00',3.19),('16273','2014-03-09','09:50:00',3.23),('16273','2014-03-09','09:55:00',3.24),('16273','2014-03-09','10:00:00',3.25),('16273','2014-03-09','10:05:00',3.23),('16273','2014-03-09','10:10:00',3.39),('16273','2014-03-09','10:15:00',3.48),('16273','2014-03-09','10:20:00',3.48),('16273','2014-03-09','10:25:00',3.51),('16273','2014-03-09','10:30:00',3.63),('16273','2014-03-09','10:35:00',3.76),('16273','2014-03-09','10:40:00',3.75),('16273','2014-03-09','10:45:00',3.75),('16273','2014-03-09','10:50:00',3.71),('16273','2014-03-09','10:55:00',3.73),('16273','2014-03-09','11:00:00',3.81),('16273','2014-03-09','11:05:00',3.29),('16273','2014-03-09','11:10:00',2.13),('16273','2014-03-09','11:15:00',2.82),('16273','2014-03-09','11:20:00',3.02),('16273','2014-03-09','11:25:00',3.74),('16273','2014-03-09','11:30:00',2.52),('16273','2014-03-09','11:40:00',1.12),('16273','2014-03-09','11:45:00',2.18),('16273','2014-03-09','11:50:00',2.95),('16273','2014-03-09','11:55:00',4.08),('16273','2014-03-09','12:00:00',4.3),('16273','2014-03-09','12:05:00',2.72),('16273','2014-03-09','12:10:00',1.44),('16273','2014-03-09','12:15:00',3.65),('16273','2014-03-09','12:20:00',4.04),('16273','2014-03-09','12:25:00',3.89),('16273','2014-03-09','12:30:00',3.37),('16273','2014-03-09','12:35:00',3.54),('16273','2014-03-09','12:40:00',3.86),('16273','2014-03-09','12:45:00',3.84),('16273','2014-03-09','12:50:00',3.69),('16273','2014-03-09','12:55:00',3.58),('16273','2014-03-09','13:00:00',3.59),('16273','2014-03-09','13:05:00',3.52),('16273','2014-03-09','13:10:00',3.57),('16273','2014-03-09','13:15:00',3.58),('16273','2014-03-09','13:20:00',3.53),('16273','2014-03-09','13:25:00',3.56),('16273','2014-03-09','13:30:00',3.52),('16273','2014-03-09','13:35:00',3.43),('16273','2014-03-09','13:40:00',3.37),('16273','2014-03-09','13:45:00',3.27),('16273','2014-03-09','13:50:00',3.18),('16273','2014-03-09','13:55:00',2.18),('16273','2014-03-09','14:05:00',1.31),('16273','2014-03-09','14:10:00',1.48),('16273','2014-03-09','14:15:00',2.82),('16273','2014-03-09','14:20:00',2.38),('16273','2014-03-09','14:25:00',2.59),('16273','2014-03-09','14:30:00',2.57),('16273','2014-03-09','14:35:00',2.55),('16273','2014-03-09','14:40:00',2.55),('16273','2014-03-09','14:45:00',2.49),('16273','2014-03-09','14:50:00',1.94),('16273','2014-03-09','14:55:00',2.17),('16273','2014-03-09','15:00:00',1.46),('16273','2014-03-09','15:20:00',1.15),('16273','2014-03-09','15:35:00',1.25),('16273','2014-03-09','15:40:00',1.4),('16273','2014-03-09','15:50:00',1.09),('16273','2014-03-09','15:55:00',1.43),('16273','2014-03-09','16:05:00',1.12),('16273','2014-03-09','16:10:00',1.2),('16273','2014-03-09','16:15:00',1.14),('16273','2014-03-09','16:20:00',1.08),('16273','2014-03-08','07:35:00',1.03),('16273','2014-03-08','07:40:00',1.14),('16273','2014-03-08','07:45:00',1.25),('16273','2014-03-08','07:50:00',1.17),('16273','2014-03-08','07:55:00',1.49),('16273','2014-03-08','08:00:00',1.61),('16273','2014-03-08','08:05:00',1.71),('16273','2014-03-08','08:10:00',1.82),('16273','2014-03-08','08:15:00',1.91),('16273','2014-03-08','08:20:00',1.98),('16273','2014-03-08','08:25:00',2.05),('16273','2014-03-08','08:30:00',2.13),('16273','2014-03-08','08:35:00',2.21),('16273','2014-03-08','08:40:00',2.27),('16273','2014-03-08','08:45:00',2.37),('16273','2014-03-08','08:50:00',2.46),('16273','2014-03-08','08:55:00',2.53),('16273','2014-03-08','09:00:00',2.58),('16273','2014-03-08','09:05:00',2.65),('16273','2014-03-08','09:10:00',2.7),('16273','2014-03-08','09:15:00',2.76),('16273','2014-03-08','09:20:00',2.82),('16273','2014-03-08','09:25:00',2.88),('16273','2014-03-08','09:30:00',2.93),('16273','2014-03-08','09:35:00',2.96),('16273','2014-03-08','09:40:00',3),('16273','2014-03-08','09:45:00',3.04),('16273','2014-03-08','09:50:00',3.1),('16273','2014-03-08','09:55:00',3.1),('16273','2014-03-08','10:00:00',3.22),('16273','2014-03-08','10:05:00',3.26),('16273','2014-03-08','10:10:00',3.3),('16273','2014-03-08','10:15:00',3.31),('16273','2014-03-08','10:20:00',3.35),('16273','2014-03-08','10:25:00',3.38),('16273','2014-03-08','10:30:00',3.12),('16273','2014-03-08','10:35:00',3.43),('16273','2014-03-08','10:40:00',3.65),('16273','2014-03-08','10:45:00',3.56),('16273','2014-03-08','10:50:00',3.59),('16273','2014-03-08','10:55:00',3.53),('16273','2014-03-08','11:00:00',3.49),('16273','2014-03-08','11:05:00',3.54),('16273','2014-03-08','11:10:00',3.57),('16273','2014-03-08','11:15:00',3.65),('16273','2014-03-08','11:20:00',3.71),('16273','2014-03-08','11:25:00',3.03),('16273','2014-03-08','11:30:00',2.65),('16273','2014-03-08','11:35:00',1.39),('16273','2014-03-08','11:40:00',2.57),('16273','2014-03-08','11:45:00',3.53),('16273','2014-03-08','11:50:00',1.82),('16273','2014-03-08','11:55:00',2.25),('16273','2014-03-08','12:00:00',4.26),('16273','2014-03-08','12:05:00',4.29),('16273','2014-03-08','12:10:00',3.62),('16273','2014-03-08','12:15:00',1.57),('16273','2014-03-08','12:20:00',1.59),('16273','2014-03-08','12:25:00',1.34),('16273','2014-03-08','12:30:00',1.27),('16273','2014-03-08','12:35:00',1.29),('16273','2014-03-08','12:40:00',1.37),('16273','2014-03-08','12:45:00',1.51),('16273','2014-03-08','12:50:00',1.49),('16273','2014-03-08','12:55:00',1.36),('16273','2014-03-08','13:00:00',1.32),('16273','2014-03-08','13:05:00',1.64),('16273','2014-03-08','13:10:00',1.57),('16273','2014-03-08','13:15:00',1.59),('16273','2014-03-08','13:20:00',1.24),('16273','2014-03-08','13:25:00',1.03),('16273','2014-03-08','13:40:00',1.38),('16273','2014-03-08','13:45:00',1.37),('16273','2014-03-08','13:50:00',1.45),('16273','2014-03-08','13:55:00',1.6),('16273','2014-03-08','14:00:00',1.34),('16273','2014-03-08','14:05:00',1.19),('16273','2014-03-08','14:10:00',1.12),('16273','2014-03-08','14:15:00',1.03),('16273','2014-03-08','15:25:00',1.24),('16273','2014-03-08','15:30:00',1.06),('16273','2014-04-30','07:25:00',1),('16273','2014-04-30','07:30:00',1.07),('16273','2014-04-30','07:35:00',1.25),('16273','2014-04-30','07:40:00',1.37),('16273','2014-04-30','07:45:00',1.4),('16273','2014-04-30','07:50:00',1.54),('16273','2014-04-30','07:55:00',1.62),('16273','2014-04-30','08:00:00',1.68),('16273','2014-04-30','08:05:00',1.77),('16273','2014-04-30','08:10:00',1.84),('16273','2014-04-30','08:15:00',1.92),('16273','2014-04-30','08:20:00',2),('16273','2014-04-30','08:25:00',2.08),('16273','2014-04-30','08:30:00',2.13),('16273','2014-04-30','08:35:00',2.22),('16273','2014-04-30','08:40:00',2.32),('16273','2014-04-30','08:45:00',2.33),('16273','2014-04-30','08:50:00',2.42),('16273','2014-04-30','08:55:00',2.42),('16273','2014-04-30','09:00:00',2.47),('16273','2014-04-30','09:05:00',2.67),('16273','2014-04-30','09:10:00',2.74),('16273','2014-04-30','09:15:00',2.84),('16273','2014-04-30','09:20:00',2.84),('16273','2014-04-30','09:25:00',1.92),('16273','2014-04-30','09:30:00',3.08),('16273','2014-04-30','09:35:00',3.2),('16273','2014-04-30','09:40:00',3.28),('16273','2014-04-30','09:45:00',3.32),('16273','2014-04-30','09:50:00',2.5),('16273','2014-04-30','09:55:00',2.17),('16273','2014-04-30','10:00:00',3.01),('16273','2014-04-30','10:05:00',2.97),('16273','2014-04-30','10:10:00',2.67),('16273','2014-04-30','10:15:00',1.93),('16273','2014-04-30','10:20:00',1.4),('16273','2014-04-30','10:25:00',2.12),('16273','2014-04-30','10:30:00',3.09),('16273','2014-04-30','10:35:00',3.41),('16273','2014-04-30','10:40:00',3.32),('16273','2014-04-30','10:45:00',4.32),('16273','2014-04-30','10:50:00',2.13),('16273','2014-04-30','10:55:00',2.9),('16273','2014-04-30','11:00:00',2.37),('16273','2014-04-30','11:05:00',2.21),('16273','2014-04-30','11:10:00',2.11),('16273','2014-04-30','11:15:00',2.7),('16273','2014-04-30','11:20:00',1.56),('16273','2014-04-30','11:25:00',1.46),('16273','2014-04-30','11:30:00',1.29),('16273','2014-04-30','11:35:00',1.87),('16273','2014-04-30','11:40:00',3.87),('16273','2014-04-30','11:45:00',2.74),('16273','2014-04-30','11:50:00',2.76),('16273','2014-04-30','11:55:00',1.56),('16273','2014-04-30','12:00:00',1.27),('16273','2014-04-30','12:05:00',1.2),('16273','2014-04-30','12:10:00',2.19),('16273','2014-04-30','12:15:00',2.24),('16273','2014-04-30','12:20:00',2.68),('16273','2014-04-30','12:25:00',4.69),('16273','2014-04-30','12:30:00',4.29),('16273','2014-04-30','12:35:00',2.86),('16273','2014-04-30','12:40:00',2.63),('16273','2014-04-30','12:45:00',3.5),('16273','2014-04-30','12:50:00',2.49),('16273','2014-04-30','12:55:00',2.36),('16273','2014-04-30','13:00:00',3.05),('16273','2014-04-30','13:05:00',4.19),('16273','2014-04-30','13:10:00',2.19),('16273','2014-04-30','13:15:00',2.66),('16273','2014-04-30','13:20:00',4.67),('16273','2014-04-30','13:25:00',3.55),('16273','2014-04-30','13:30:00',2.35),('16273','2014-04-30','13:35:00',4),('16273','2014-04-30','13:40:00',2.61),('16273','2014-04-30','13:45:00',1.57),('16273','2014-04-30','13:50:00',1.65),('16273','2014-04-30','13:55:00',2.05),('16273','2014-04-30','14:00:00',2.52),('16273','2014-04-30','14:05:00',1.44),('16273','2014-04-30','14:10:00',1.41),('16273','2014-04-30','14:15:00',1.67),('16273','2014-04-30','14:20:00',1.58),('16273','2014-04-30','14:25:00',1.7),('16273','2014-04-30','14:30:00',2.37),('16273','2014-04-30','14:35:00',1.88),('16273','2014-04-30','14:40:00',1.37),('16273','2014-04-30','14:45:00',1.69),('16273','2014-04-30','14:50:00',1.61),('16273','2014-04-30','14:55:00',1.25),('16273','2014-04-30','15:00:00',1.62),('16273','2014-04-30','15:05:00',2.03),('16273','2014-04-30','15:10:00',1.34),('16273','2014-04-30','15:15:00',1.07),('16273','2014-04-30','15:20:00',1.3),('16273','2014-04-30','15:25:00',1.99),('16273','2014-04-30','15:30:00',2.47),('16273','2014-04-30','15:35:00',2),('16273','2014-04-30','15:40:00',3.23),('16273','2014-04-30','15:45:00',2.73),('16273','2014-04-30','15:50:00',2.7),('16273','2014-04-30','15:55:00',1.78),('16273','2014-04-30','16:00:00',1.03),('16273','2014-04-30','16:05:00',2.55),('16273','2014-04-30','16:10:00',1.83),('16273','2014-04-30','16:15:00',2.15),('16273','2014-04-30','16:20:00',1.67),('16273','2014-04-30','16:25:00',1.92),('16273','2014-04-30','16:30:00',1.72),('16273','2014-04-30','16:35:00',1.53),('16273','2014-04-30','16:40:00',1.26),('16273','2014-04-30','16:45:00',2),('16273','2014-04-30','16:50:00',1.48),('16273','2014-04-30','17:00:00',1.03),('16273','2014-04-30','17:15:00',1.36),('16273','2014-04-30','17:30:00',1.03),('16273','2014-04-30','17:35:00',1.2),('16273','2014-03-07','09:45:00',1.81),('16273','2014-03-07','09:50:00',3.17),('16273','2014-03-07','09:55:00',1.21),('16273','2014-03-07','10:05:00',2.89),('16273','2014-03-07','10:10:00',3.2),('16273','2014-03-07','10:15:00',3.79),('16273','2014-03-07','10:20:00',3.59),('16273','2014-03-07','10:25:00',3.36),('16273','2014-03-07','10:30:00',3.8),('16273','2014-03-07','10:35:00',3.81),('16273','2014-03-07','10:40:00',3.86),('16273','2014-03-07','10:45:00',2.03),('16273','2014-03-07','10:50:00',3.39),('16273','2014-03-07','10:55:00',2.02),('16273','2014-03-07','11:00:00',2.32),('16273','2014-03-07','11:10:00',1.06),('16273','2014-03-07','11:15:00',1.07),('16273','2014-03-07','12:00:00',1.26),('16273','2014-03-07','12:05:00',2.8),('16273','2014-03-07','12:10:00',3.63),('16273','2014-03-07','12:15:00',3.71),('16273','2014-03-07','12:20:00',3.68),('16273','2014-03-07','12:25:00',3.73),('16273','2014-03-07','12:30:00',3.58),('16273','2014-03-07','12:35:00',3.71),('16273','2014-03-07','12:40:00',3.95),('16273','2014-03-07','12:45:00',3.69),('16273','2014-03-07','12:50:00',3.6),('16273','2014-03-07','12:55:00',1.16),('16273','2014-03-07','13:05:00',1.07),('16273','2014-03-07','13:10:00',1.43),('16273','2014-03-07','13:15:00',2.6),('16273','2014-03-07','13:20:00',2.54),('16273','2014-03-07','13:25:00',2.29),('16273','2014-03-07','13:30:00',2.23),('16273','2014-03-07','13:35:00',1.98),('16273','2014-03-07','13:40:00',1.85),('16273','2014-03-07','13:45:00',1.81),('16273','2014-03-07','13:50:00',1.81),('16273','2014-03-07','13:55:00',1.53),('16273','2014-03-07','14:00:00',1.29),('16273','2014-03-07','14:05:00',1.19),('16273','2014-03-07','14:10:00',1.12),('16273','2014-03-07','14:15:00',1.09),('16273','2014-03-07','14:20:00',1.1),('16273','2014-03-07','14:25:00',1.17),('16273','2014-03-07','14:30:00',1.28),('16273','2014-03-07','14:35:00',1.51),('16273','2014-03-07','14:40:00',1.77),('16273','2014-03-07','14:45:00',1.96),('16273','2014-03-07','14:50:00',2.51),('16273','2014-03-07','14:55:00',2.49),('16273','2014-03-07','15:00:00',2.34),('16273','2014-03-07','15:05:00',2.55),('16273','2014-03-07','15:10:00',2.55),('16273','2014-03-07','15:15:00',2.4),('16273','2014-03-07','15:20:00',2.3),('16273','2014-03-07','15:25:00',2.07),('16273','2014-03-07','15:30:00',2.05),('16273','2014-03-07','15:35:00',1.55),('16273','2014-03-06','08:40:00',1.03),('16273','2014-03-06','08:55:00',1.96),('16273','2014-03-06','09:00:00',1.62),('16273','2014-03-06','09:05:00',1.87),('16273','2014-03-06','09:10:00',2.42),('16273','2014-03-06','09:15:00',2.79),('16273','2014-03-06','09:20:00',3.17),('16273','2014-03-06','09:25:00',3.21),('16273','2014-03-06','09:30:00',3.05),('16273','2014-03-06','09:35:00',2.67),('16273','2014-03-06','09:40:00',1.87),('16273','2014-03-06','09:45:00',1.78),('16273','2014-03-06','09:50:00',1.94),('16273','2014-03-06','09:55:00',2.24),('16273','2014-03-06','10:00:00',2.51),('16273','2014-03-06','10:05:00',2.6),('16273','2014-03-06','10:10:00',2.74),('16273','2014-03-06','10:15:00',2.66),('16273','2014-03-06','10:20:00',3.19),('16273','2014-03-06','10:25:00',3.05),('16273','2014-03-06','10:30:00',2.04),('16273','2014-03-06','10:35:00',2.76),('16273','2014-03-06','10:40:00',1.56),('16273','2014-03-06','10:45:00',3.23),('16273','2014-03-06','10:50:00',3.72),('16273','2014-03-06','10:55:00',2.97),('16273','2014-03-06','11:00:00',3.33),('16273','2014-03-06','11:05:00',3.6),('16273','2014-03-06','11:10:00',2.61),('16273','2014-03-06','11:15:00',3.55),('16273','2014-03-06','11:20:00',3.54),('16273','2014-03-06','11:25:00',2.17),('16273','2014-03-06','11:30:00',4.07),('16273','2014-03-06','11:35:00',4.05),('16273','2014-03-06','11:40:00',4.04),('16273','2014-03-06','11:45:00',3.01),('16273','2014-03-06','11:50:00',3.06),('16273','2014-03-06','11:55:00',2.9),('16273','2014-03-06','12:00:00',2.5),('16273','2014-03-06','12:05:00',2.17),('16273','2014-03-06','12:10:00',1.47),('16273','2014-03-06','12:15:00',3.44),('16273','2014-03-06','12:20:00',1.79),('16273','2014-03-06','12:25:00',1.06),('16273','2014-03-06','12:30:00',1.13),('16273','2014-03-06','12:35:00',1.35),('16273','2014-03-06','12:40:00',1.29),('16273','2014-03-06','12:45:00',1.34),('16273','2014-03-06','12:50:00',2.48),('16273','2014-03-06','12:55:00',2.63),('16273','2014-03-06','13:00:00',2.17),('16273','2014-03-06','13:05:00',1.83),('16273','2014-03-06','13:10:00',1.33),('16273','2014-03-06','13:15:00',1.36),('16273','2014-03-06','13:20:00',1.37),('16273','2014-03-06','13:25:00',1.24),('16273','2014-03-06','13:30:00',1.53),('16273','2014-03-06','13:35:00',1.15),('16273','2014-03-06','13:50:00',1.05),('16273','2014-03-06','13:55:00',1.06),('16273','2014-03-06','14:00:00',1.14),('16273','2014-03-06','14:05:00',1.11),('16273','2014-03-06','14:10:00',1.07),('16273','2014-03-06','14:15:00',1.13),('16273','2014-03-06','14:20:00',1.41),('16273','2014-03-06','14:25:00',1.48),('16273','2014-03-06','14:30:00',1.32),('16273','2014-03-06','14:35:00',1.15),('16273','2014-03-06','14:50:00',1.26),('16273','2014-03-06','15:00:00',1.04),('16273','2014-03-06','15:05:00',1.2),('16273','2014-03-06','15:10:00',1.21),('16273','2014-03-06','15:15:00',1.22),('16273','2014-03-06','15:20:00',2.34),('16273','2014-03-06','15:25:00',1.78),('16273','2014-03-06','15:30:00',1.03),('16273','2014-03-05','07:45:00',1.03),('16273','2014-03-05','07:50:00',1.57),('16273','2014-03-05','07:55:00',1.56),('16273','2014-03-05','08:00:00',1.63),('16273','2014-03-05','08:05:00',1.78),('16273','2014-03-05','08:10:00',1.14),('16273','2014-03-05','08:15:00',1.15),('16273','2014-03-05','08:20:00',1),('16273','2014-03-05','08:50:00',1.08),('16273','2014-03-05','08:55:00',1.35),('16273','2014-03-05','09:00:00',3.22),('16273','2014-03-05','09:05:00',3.05),('16273','2014-03-05','09:10:00',2.89),('16273','2014-03-05','09:15:00',2.88),('16273','2014-03-05','09:20:00',2.9),('16273','2014-03-05','09:25:00',2.93),('16273','2014-03-05','09:30:00',2.94),('16273','2014-03-05','09:35:00',3.01),('16273','2014-03-05','09:40:00',3.06),('16273','2014-03-05','09:45:00',3.1),('16273','2014-03-05','09:50:00',3.11),('16273','2014-03-05','09:55:00',3.15),('16273','2014-03-05','10:00:00',3.21),('16273','2014-03-05','10:05:00',3.25),('16273','2014-03-05','10:10:00',3.25),('16273','2014-03-05','10:15:00',3.29),('16273','2014-03-05','10:20:00',3.31),('16273','2014-03-05','10:25:00',3.34),('16273','2014-03-05','10:30:00',3.38),('16273','2014-03-05','10:35:00',3.43),('16273','2014-03-05','10:40:00',3.43),('16273','2014-03-05','10:45:00',3.44),('16273','2014-03-05','10:50:00',3.48),('16273','2014-03-05','10:55:00',3.49),('16273','2014-03-05','11:00:00',3.53),('16273','2014-03-05','11:05:00',3.56),('16273','2014-03-05','11:10:00',3.58),('16273','2014-03-05','11:15:00',3.61),('16273','2014-03-05','11:20:00',3.65),('16273','2014-03-05','11:25:00',3.69),('16273','2014-03-05','11:30:00',3.7),('16273','2014-03-05','11:35:00',2.12),('16273','2014-03-05','11:40:00',1.32),('16273','2014-03-05','11:45:00',1.86),('16273','2014-03-05','11:55:00',1.37),('16273','2014-03-05','12:00:00',3.5),('16273','2014-03-05','12:05:00',2.95),('16273','2014-03-05','12:10:00',2.66),('16273','2014-03-05','12:15:00',3.28),('16273','2014-03-05','12:20:00',2.76),('16273','2014-03-05','12:25:00',3.19),('16273','2014-03-05','12:30:00',2.28),('16273','2014-03-05','12:35:00',2.07),('16273','2014-03-05','12:40:00',2.4),('16273','2014-03-05','12:50:00',2.39),('16273','2014-03-05','12:55:00',2.46),('16273','2014-03-05','13:00:00',1.56),('16273','2014-03-05','13:05:00',2.83),('16273','2014-03-05','13:10:00',1.89),('16273','2014-03-05','13:15:00',2.44),('16273','2014-03-05','13:20:00',2.87),('16273','2014-03-05','13:25:00',1.38),('16273','2014-03-05','13:30:00',2.37),('16273','2014-03-05','13:35:00',2.97),('16273','2014-03-05','13:40:00',2.01),('16273','2014-03-05','13:45:00',3.48),('16273','2014-03-05','13:50:00',3.37),('16273','2014-03-05','13:55:00',2.58),('16273','2014-03-05','14:00:00',1.28),('16273','2014-03-05','14:05:00',1.05),('16273','2014-03-05','14:10:00',1.07),('16273','2014-03-05','14:15:00',1.71),('16273','2014-03-05','14:20:00',1.86),('16273','2014-03-05','14:25:00',1.29),('16273','2014-03-05','14:30:00',1.34),('16273','2014-03-05','14:35:00',1.64),('16273','2014-03-05','14:40:00',1.28),('16273','2014-03-05','14:50:00',1.1),('16273','2014-03-05','14:55:00',1.78),('16273','2014-03-05','15:00:00',2.1),('16273','2014-03-05','15:05:00',2.57),('16273','2014-03-05','15:10:00',1.32),('16273','2014-03-05','15:50:00',1.05),('16273','2014-03-05','15:55:00',1.56),('16273','2014-03-05','16:00:00',1.51),('16273','2014-03-05','16:05:00',1.65),('16273','2014-03-05','16:10:00',1.54),('16273','2014-03-04','09:05:00',1.33),('16273','2014-03-04','09:10:00',2.45),('16273','2014-03-04','09:15:00',1.31),('16273','2014-03-04','09:50:00',1.69),('16273','2014-03-04','09:55:00',2.88),('16273','2014-03-04','10:00:00',2.18),('16273','2014-03-04','10:05:00',1.14),('16273','2014-03-04','10:15:00',1.01),('16273','2014-03-04','10:25:00',1.11),('16273','2014-03-04','10:30:00',1.97),('16273','2014-03-04','10:35:00',1.34),('16273','2014-03-04','10:40:00',1.27),('16273','2014-03-04','10:45:00',2.04),('16273','2014-03-04','10:50:00',4.01),('16273','2014-03-04','10:55:00',2.69),('16273','2014-03-04','11:00:00',1.63),('16273','2014-03-04','11:05:00',1.53),('16273','2014-03-04','11:20:00',1.44),('16273','2014-03-04','11:25:00',3.52),('16273','2014-03-04','11:30:00',2.21),('16273','2014-03-04','11:35:00',1.36),('16273','2014-03-04','11:40:00',1.83),('16273','2014-03-04','11:45:00',2.82),('16273','2014-03-04','11:50:00',3.03),('16273','2014-03-04','11:55:00',1.99),('16273','2014-03-04','12:00:00',1.9),('16273','2014-03-04','12:05:00',3.91),('16273','2014-03-04','12:10:00',2.72),('16273','2014-03-04','12:15:00',1.78),('16273','2014-03-04','12:20:00',1.89),('16273','2014-03-04','12:25:00',3.16),('16273','2014-03-04','12:30:00',3.57),('16273','2014-03-04','12:35:00',3.5),('16273','2014-03-04','12:40:00',3.48),('16273','2014-03-04','12:45:00',3.5),('16273','2014-03-04','12:50:00',3.48),('16273','2014-03-04','12:55:00',2.84),('16273','2014-03-04','13:00:00',3.22),('16273','2014-03-04','13:05:00',3.38),('16273','2014-03-04','13:10:00',3.21),('16273','2014-03-04','13:15:00',2.66),('16273','2014-03-04','13:20:00',1.23),('16273','2014-03-04','13:45:00',2.17),('16273','2014-03-04','13:50:00',1.28),('16273','2014-03-04','13:55:00',2.69),('16273','2014-03-04','14:00:00',2.65),('16273','2014-03-04','14:05:00',3.23),('16273','2014-03-04','14:10:00',3.07),('16273','2014-03-04','14:15:00',2.52),('16273','2014-03-04','14:20:00',2.74),('16273','2014-03-04','14:25:00',2.72),('16273','2014-03-04','14:30:00',2.6),('16273','2014-03-04','14:35:00',2.52),('16273','2014-03-04','14:40:00',2.48),('16273','2014-03-04','14:45:00',2.41),('16273','2014-03-04','14:50:00',2.34),('16273','2014-03-04','14:55:00',2.23),('16273','2014-03-04','15:00:00',2.13),('16273','2014-03-04','15:05:00',2.05),('16273','2014-03-04','15:10:00',1.97),('16273','2014-03-04','15:15:00',1.78),('16273','2014-03-04','15:20:00',1.76),('16273','2014-03-04','15:25:00',1.79),('16273','2014-03-04','15:30:00',1.41),('16273','2014-03-04','15:35:00',1.44),('16273','2014-03-04','15:55:00',1.04),('16273','2014-03-04','16:00:00',1.06),('16273','2014-03-04','16:20:00',1.26),('16273','2014-03-04','16:25:00',1.08),('16273','2014-03-03','07:45:00',1.15),('16273','2014-03-03','07:50:00',1.16),('16273','2014-03-03','07:55:00',1.2),('16273','2014-03-03','08:00:00',1.6),('16273','2014-03-03','08:05:00',1.46),('16273','2014-03-03','08:10:00',1.84),('16273','2014-03-03','08:15:00',1.96),('16273','2014-03-03','08:20:00',2.03),('16273','2014-03-03','08:25:00',2.11),('16273','2014-03-03','08:30:00',2.17),('16273','2014-03-03','08:35:00',2.25),('16273','2014-03-03','08:40:00',2.32),('16273','2014-03-03','08:45:00',2.39),('16273','2014-03-03','08:50:00',2.39),('16273','2014-03-03','08:55:00',2.33),('16273','2014-03-03','09:00:00',2.19),('16273','2014-03-03','09:05:00',2.59),('16273','2014-03-03','09:10:00',2.9),('16273','2014-03-03','09:15:00',2.88),('16273','2014-03-03','09:20:00',2.75),('16273','2014-03-03','09:25:00',2.86),('16273','2014-03-03','09:30:00',2.9),('16273','2014-03-03','09:35:00',2.99),('16273','2014-03-03','09:40:00',2.83),('16273','2014-03-03','09:45:00',2.97),('16273','2014-03-03','09:50:00',3.06),('16273','2014-03-03','09:55:00',3.11),('16273','2014-03-03','10:00:00',3.04),('16273','2014-03-03','10:05:00',3.17),('16273','2014-03-03','10:10:00',3.22),('16273','2014-03-03','10:15:00',3.25),('16273','2014-03-03','10:20:00',3.29),('16273','2014-03-03','10:25:00',3.29),('16273','2014-03-03','10:30:00',3.31),('16273','2014-03-03','10:35:00',3.33),('16273','2014-03-03','10:40:00',3.35),('16273','2014-03-03','10:45:00',3.38),('16273','2014-03-03','10:50:00',3.39),('16273','2014-03-03','10:55:00',3.41),('16273','2014-03-03','11:00:00',3.42),('16273','2014-03-03','11:05:00',3.48),('16273','2014-03-03','11:10:00',3.5),('16273','2014-03-03','11:15:00',3.49),('16273','2014-03-03','11:20:00',3.52),('16273','2014-03-03','11:25:00',3.51),('16273','2014-03-03','11:30:00',3.55),('16273','2014-03-03','11:35:00',3.58),('16273','2014-03-03','11:40:00',3.58),('16273','2014-03-03','11:45:00',3.58),('16273','2014-03-03','11:50:00',3.57),('16273','2014-03-03','11:55:00',3.54),('16273','2014-03-03','12:00:00',3.57),('16273','2014-03-03','12:05:00',3.56),('16273','2014-03-03','12:10:00',3.55),('16273','2014-03-03','12:15:00',3.53),('16273','2014-03-03','12:20:00',3.52),('16273','2014-03-03','12:25:00',3.5),('16273','2014-03-03','12:30:00',3.5),('16273','2014-03-03','12:35:00',3.46),('16273','2014-03-03','12:40:00',3.45),('16273','2014-03-03','12:45:00',3.41),('16273','2014-03-03','12:50:00',3.39),('16273','2014-03-03','12:55:00',3.36),('16273','2014-03-03','13:00:00',3.33),('16273','2014-03-03','13:05:00',3.32),('16273','2014-03-03','13:10:00',3.26),('16273','2014-03-03','13:15:00',3.25),('16273','2014-03-03','13:20:00',3.22),('16273','2014-03-03','13:25:00',2.66),('16273','2014-03-03','13:30:00',2.91),('16273','2014-03-03','13:35:00',2.44),('16273','2014-03-03','13:40:00',3.19),('16273','2014-03-03','13:45:00',2.91),('16273','2014-03-03','13:50:00',2.97),('16273','2014-03-03','13:55:00',2.93),('16273','2014-03-03','14:00:00',2.88),('16273','2014-03-03','14:05:00',2.87),('16273','2014-03-03','14:10:00',1.69),('16273','2014-03-03','14:15:00',2.66),('16273','2014-03-03','14:20:00',2.51),('16273','2014-03-03','14:25:00',2.66),('16273','2014-03-03','14:30:00',2.5),('16273','2014-03-03','14:35:00',2.45),('16273','2014-03-03','14:40:00',2.37),('16273','2014-03-03','14:45:00',2.31),('16273','2014-03-03','14:50:00',2.22),('16273','2014-03-03','14:55:00',1.92),('16273','2014-03-03','15:00:00',2.12),('16273','2014-03-03','15:05:00',1.8),('16273','2014-03-03','15:10:00',1.45),('16273','2014-03-03','15:15:00',2.11),('16273','2014-03-03','15:20:00',1.91),('16273','2014-03-03','15:25:00',1.76),('16273','2014-03-03','15:30:00',1.6),('16273','2014-03-03','15:35:00',1.62),('16273','2014-03-03','15:40:00',1.55),('16273','2014-03-03','15:45:00',1.43),('16273','2014-03-03','15:50:00',1.37),('16273','2014-03-03','15:55:00',1.33),('16273','2014-03-03','16:00:00',1.18),('16273','2014-03-03','16:05:00',1.11),('16273','2014-03-03','16:10:00',1.03),('16273','2014-03-02','08:10:00',1.44),('16273','2014-03-02','08:15:00',2.16),('16273','2014-03-02','08:20:00',2.31),('16273','2014-03-02','08:25:00',2.09),('16273','2014-03-02','08:30:00',2.18),('16273','2014-03-02','08:35:00',2.28),('16273','2014-03-02','08:40:00',2.35),('16273','2014-03-02','08:45:00',2.44),('16273','2014-03-02','08:50:00',2.52),('16273','2014-03-02','08:55:00',2.58),('16273','2014-03-02','09:00:00',2.67),('16273','2014-03-02','09:05:00',2.75),('16273','2014-03-02','09:10:00',2.48),('16273','2014-03-02','09:15:00',2.79),('16273','2014-03-02','09:20:00',2.29),('16273','2014-03-02','09:25:00',1.82),('16273','2014-03-02','09:30:00',2.59),('16273','2014-03-02','10:10:00',1.21),('16273','2014-03-02','10:15:00',1.66),('16273','2014-03-02','10:20:00',3.12),('16273','2014-03-02','10:25:00',2.8),('16273','2014-03-02','10:30:00',4.44),('16273','2014-03-02','10:35:00',4.19),('16273','2014-03-02','10:40:00',4.03),('16273','2014-03-02','10:45:00',2.32),('16273','2014-03-02','10:50:00',1.26),('16273','2014-03-02','10:55:00',1.22),('16273','2014-03-02','11:00:00',1.74),('16273','2014-03-02','11:05:00',2.04),('16273','2014-03-02','11:10:00',3.36),('16273','2014-03-02','11:15:00',4.19),('16273','2014-03-02','11:20:00',3.31),('16273','2014-03-02','11:25:00',3.75),('16273','2014-03-02','11:30:00',2.78),('16273','2014-03-02','11:35:00',2.92),('16273','2014-03-02','11:40:00',1.89),('16273','2014-03-02','11:45:00',2.22),('16273','2014-03-02','11:50:00',3.66),('16273','2014-03-02','11:55:00',3.83),('16273','2014-03-02','12:00:00',3.26),('16273','2014-03-02','12:05:00',2.86),('16273','2014-03-02','12:10:00',1.47),('16273','2014-03-02','12:15:00',1.1),('16273','2014-03-02','12:20:00',1.03),('16273','2014-03-02','15:10:00',1.02),('16273','2014-03-02','15:15:00',1.04),('16273','2014-02-28','07:50:00',1.32),('16273','2014-02-28','07:55:00',1.09),('16273','2014-02-28','08:10:00',1.32),('16273','2014-02-28','08:15:00',1.22),('16273','2014-02-28','08:25:00',1.58),('16273','2014-02-28','09:05:00',1.31),('16273','2014-02-28','09:15:00',1.37),('16273','2014-02-28','09:20:00',2.57),('16273','2014-02-28','09:25:00',1.73),('16273','2014-02-28','09:30:00',3.28),('16273','2014-02-28','09:35:00',3.24),('16273','2014-02-28','09:40:00',1.69),('16273','2014-02-28','09:45:00',1.06),('16273','2014-02-28','09:50:00',1.21),('16273','2014-02-28','09:55:00',1.19),('16273','2014-02-28','10:00:00',1.18),('16273','2014-02-28','10:05:00',1.08),('16273','2014-02-28','10:10:00',2.29),('16273','2014-02-28','10:15:00',3.75),('16273','2014-02-28','10:20:00',2.74),('16273','2014-02-28','10:30:00',1.19),('16273','2014-02-28','10:35:00',1.23),('16273','2014-02-28','10:55:00',1),('16273','2014-02-28','11:00:00',1.65),('16273','2014-02-28','11:05:00',1.43),('16273','2014-02-28','11:10:00',1.24),('16273','2014-02-28','11:15:00',1.35),('16273','2014-02-28','11:20:00',1.41),('16273','2014-02-28','11:25:00',1.13),('16273','2014-02-28','11:45:00',1.18),('16273','2014-02-28','11:50:00',1.63),('16273','2014-02-28','11:55:00',2.27),('16273','2014-02-28','12:00:00',1.34),('16273','2014-02-28','12:15:00',1.3),('16273','2014-02-28','12:20:00',1.92),('16273','2014-02-28','12:25:00',2.64),('16273','2014-02-28','12:30:00',2.91),('16273','2014-02-28','12:35:00',1.11),('16273','2014-02-28','12:40:00',1.38),('16273','2014-02-28','12:45:00',1.45),('16273','2014-02-28','12:50:00',2.81),('16273','2014-02-28','12:55:00',2.05),('16273','2014-02-28','13:00:00',1.31),('16273','2014-02-28','13:05:00',1.19),('16273','2014-02-28','13:45:00',1.05),('16273','2014-02-28','13:50:00',1.04),('16273','2014-02-28','14:10:00',2.44),('16273','2014-02-28','14:15:00',2.49),('16273','2014-02-28','14:20:00',1.66),('16273','2014-02-28','14:25:00',1.52),('16273','2014-02-28','15:15:00',1.55),('16273','2014-02-28','15:20:00',1.04),('16273','2014-02-28','15:25:00',1.54),('16273','2014-02-28','15:30:00',2.24),('16273','2014-02-27','10:35:00',1.06),('16273','2014-02-27','10:40:00',1.17),('16273','2014-02-27','10:45:00',1.15),('16273','2014-02-27','10:50:00',1.27),('16273','2014-02-27','10:55:00',1.5),('16273','2014-02-27','11:00:00',1.56),('16273','2014-02-27','11:05:00',1.51),('16273','2014-02-27','11:10:00',1.48),('16273','2014-02-27','11:15:00',1.25),('16273','2014-02-27','11:20:00',1.41),('16273','2014-02-27','11:25:00',1.37),('16273','2014-02-27','11:30:00',1.25),('16273','2014-02-27','11:35:00',1.12),('16273','2014-02-27','11:40:00',1.1),('16273','2014-02-27','11:45:00',1.21),('16273','2014-02-27','11:50:00',1.25),('16273','2014-02-27','11:55:00',1.16),('16273','2014-02-27','12:00:00',1.17),('16273','2014-02-27','12:05:00',1.19),('16273','2014-02-27','12:10:00',1.22),('16273','2014-02-27','12:15:00',1.21),('16273','2014-02-27','12:20:00',1.15),('16273','2014-02-27','12:25:00',1.16),('16273','2014-02-27','12:30:00',1.15),('16273','2014-02-27','12:35:00',1.14),('16273','2014-02-27','12:40:00',1.15),('16273','2014-02-27','12:45:00',1.19),('16273','2014-02-27','12:50:00',1.2),('16273','2014-02-27','12:55:00',1.16),('16273','2014-02-27','13:00:00',1.1),('16273','2014-02-27','13:05:00',1.01),('16273','2014-02-27','13:10:00',1.02),('16273','2014-02-27','13:15:00',1.15),('16273','2014-02-27','13:20:00',1.28),('16273','2014-02-27','13:25:00',1.43),('16273','2014-02-27','13:30:00',1.54),('16273','2014-02-27','13:35:00',1.64),('16273','2014-02-27','13:40:00',1.63),('16273','2014-02-27','13:45:00',1.6),('16273','2014-02-27','13:50:00',1.49),('16273','2014-02-27','13:55:00',1.48),('16273','2014-02-27','14:00:00',1.68),('16273','2014-02-27','14:05:00',1.61),('16273','2014-02-27','14:10:00',1.33),('16273','2014-02-27','14:15:00',1.47),('16273','2014-02-27','14:20:00',1.38),('16273','2014-02-27','14:25:00',1.26),('16273','2014-02-27','14:30:00',1.2),('16273','2014-02-27','14:35:00',1.29),('16273','2014-02-27','14:40:00',1.43),('16273','2014-02-27','14:45:00',1.39),('16273','2014-02-27','14:50:00',1.35),('16273','2014-02-27','14:55:00',1.49),('16273','2014-02-27','15:00:00',1.82),('16273','2014-02-27','15:05:00',1.89),('16273','2014-02-27','15:10:00',1.76),('16273','2014-02-27','15:15:00',1.65),('16273','2014-02-27','15:20:00',1.66),('16273','2014-02-27','15:25:00',1.54),('16273','2014-02-27','15:30:00',1.02),('16273','2014-02-26','07:55:00',1.02),('16273','2014-02-26','08:00:00',1.27),('16273','2014-02-26','08:05:00',1.2),('16273','2014-02-26','08:10:00',1.54),('16273','2014-02-26','08:15:00',1.65),('16273','2014-02-26','08:20:00',1.76),('16273','2014-02-26','08:25:00',1.89),('16273','2014-02-26','08:30:00',1.98),('16273','2014-02-26','08:35:00',2.08),('16273','2014-02-26','08:40:00',2.18),('16273','2014-02-26','08:45:00',2.16),('16273','2014-02-26','08:50:00',2.18),('16273','2014-02-26','08:55:00',2.28),('16273','2014-02-26','09:00:00',2.32),('16273','2014-02-26','09:05:00',2.36),('16273','2014-02-26','09:10:00',2.35),('16273','2014-02-26','09:15:00',1.66),('16273','2014-02-26','09:20:00',1.61),('16273','2014-02-26','09:25:00',1.7),('16273','2014-02-26','09:30:00',1.92),('16273','2014-02-26','09:35:00',2.02),('16273','2014-02-26','09:40:00',1.27),('16273','2014-02-26','09:45:00',1.24),('16273','2014-02-26','09:50:00',1.24),('16273','2014-02-26','09:55:00',1.04),('16273','2014-02-26','12:20:00',1.43),('16273','2014-02-26','12:25:00',1.87),('16273','2014-02-26','12:30:00',3.65),('16273','2014-02-26','12:35:00',2.98),('16273','2014-02-26','12:40:00',2.48),('16273','2014-02-26','12:45:00',2.56),('16273','2014-02-26','12:50:00',3.28),('16273','2014-02-26','12:55:00',2.19),('16273','2014-02-26','13:00:00',1.59),('16273','2014-02-26','13:05:00',2.71),('16273','2014-02-26','13:10:00',2.53),('16273','2014-02-26','13:15:00',2.3),('16273','2014-02-26','13:20:00',3.23),('16273','2014-02-26','13:25:00',2.94),('16273','2014-02-26','13:30:00',2.72),('16273','2014-02-26','13:35:00',2.59),('16273','2014-02-26','13:40:00',2.43),('16273','2014-02-26','13:45:00',3.1),('16273','2014-02-26','13:50:00',1.8),('16273','2014-02-26','13:55:00',1.07),('16273','2014-02-26','14:00:00',1.05),('16273','2014-02-26','14:05:00',1.12),('16273','2014-02-26','14:10:00',2.96),('16273','2014-02-26','14:15:00',2.4),('16273','2014-02-26','14:20:00',3.12),('16273','2014-02-26','14:25:00',1.39),('16273','2014-02-26','14:30:00',1.93),('16273','2014-02-26','14:35:00',2.32),('16273','2014-02-26','14:40:00',1.03),('16273','2014-02-26','14:45:00',1.87),('16273','2014-02-26','14:50:00',2.31),('16273','2014-02-26','14:55:00',2.36),('16273','2014-02-26','15:00:00',2.15),('16273','2014-02-26','15:05:00',2),('16273','2014-02-26','15:10:00',1.7),('16273','2014-02-26','15:15:00',1.25),('16273','2014-02-26','15:20:00',1.05),('16273','2014-02-26','15:25:00',1.35),('16273','2014-02-26','15:30:00',1.28),('16273','2014-02-26','15:35:00',1.31),('16273','2014-02-26','15:40:00',1.42),('16273','2014-02-26','15:45:00',1.36),('16273','2014-02-26','15:50:00',1.38),('16273','2014-02-26','15:55:00',1.41),('16273','2014-02-26','16:00:00',1.2),('16273','2014-04-29','09:45:00',1.25),('16273','2014-04-29','09:50:00',2.34),('16273','2014-04-29','09:55:00',2.77),('16273','2014-04-29','10:00:00',3.35),('16273','2014-04-29','10:05:00',3.81),('16273','2014-04-29','10:10:00',3.56),('16273','2014-04-29','10:15:00',3.99),('16273','2014-04-29','10:20:00',3.92),('16273','2014-04-29','10:25:00',3.83),('16273','2014-04-29','10:30:00',3.83),('16273','2014-04-29','10:35:00',3.85),('16273','2014-04-29','10:40:00',3.25),('16273','2014-04-29','10:45:00',3.19),('16273','2014-04-29','10:50:00',3.72),('16273','2014-04-29','10:55:00',3.85),('16273','2014-04-29','11:00:00',3.83),('16273','2014-04-29','11:05:00',4.05),('16273','2014-04-29','11:10:00',4.04),('16273','2014-04-29','11:15:00',4.13),('16273','2014-04-29','11:20:00',3.71),('16273','2014-04-29','11:25:00',1.65),('16273','2014-04-29','11:30:00',1.16),('16273','2014-04-29','11:35:00',1.81),('16273','2014-04-29','11:40:00',1.63),('16273','2014-04-29','11:45:00',1.37),('16273','2014-04-29','11:50:00',1.4),('16273','2014-04-29','11:55:00',1.44),('16273','2014-04-29','12:00:00',2.48),('16273','2014-04-29','12:05:00',3.63),('16273','2014-04-29','12:10:00',3.14),('16273','2014-04-29','12:15:00',4.22),('16273','2014-04-29','12:20:00',3.58),('16273','2014-04-29','12:25:00',4.77),('16273','2014-04-29','12:30:00',3.42),('16273','2014-04-29','12:35:00',2.84),('16273','2014-04-29','12:40:00',4.71),('16273','2014-04-29','12:45:00',4.73),('16273','2014-04-29','12:50:00',3.56),('16273','2014-04-29','12:55:00',1.49),('16273','2014-04-29','13:00:00',4.29),('16273','2014-04-29','13:05:00',2.42),('16273','2014-04-29','13:10:00',4.19),('16273','2014-04-29','13:15:00',4.2),('16273','2014-04-29','13:20:00',1.26),('16273','2014-04-29','13:25:00',2.82),('16273','2014-04-29','13:30:00',3.71),('16273','2014-04-29','13:35:00',2.84),('16273','2014-04-29','13:40:00',1.44),('16273','2014-04-29','13:45:00',1.4),('16273','2014-04-29','13:50:00',1.51),('16273','2014-04-29','13:55:00',1.01),('16273','2014-04-29','14:40:00',1.08),('16273','2014-04-29','14:45:00',1.35),('16273','2014-04-29','14:50:00',1.97),('16273','2014-04-29','14:55:00',2.3),('16273','2014-04-29','15:00:00',3.77),('16273','2014-04-29','15:05:00',3.29),('16273','2014-04-29','15:10:00',2.39),('16273','2014-04-29','15:15:00',2.02),('16273','2014-04-29','15:20:00',3.97),('16273','2014-04-29','15:25:00',4.16),('16273','2014-04-29','15:30:00',3.79),('16273','2014-04-29','15:35:00',2.29),('16273','2014-04-29','15:40:00',1.61),('16273','2014-04-29','15:45:00',1.87),('16273','2014-04-29','15:50:00',3.25),('16273','2014-04-29','15:55:00',2.62),('16273','2014-04-29','16:00:00',2.14),('16273','2014-04-29','16:05:00',1.74),('16273','2014-04-29','16:10:00',1.71),('16273','2014-04-29','16:15:00',1.34),('16273','2014-04-29','16:20:00',1.06),('16273','2014-04-29','16:25:00',1.34),('16273','2014-04-29','16:30:00',1.36),('16273','2014-04-29','16:35:00',1.5),('16273','2014-04-29','16:40:00',1.05),('16273','2014-04-29','17:00:00',1.07),('16273','2014-04-29','17:05:00',1.34),('16273','2014-04-29','17:10:00',2.07),('16273','2014-04-29','17:15:00',2.2),('16273','2014-04-29','17:20:00',1.81),('16273','2014-04-29','17:25:00',1.59),('16273','2014-04-29','17:40:00',1.37),('16273','2014-04-29','17:45:00',1.03),('16273','2014-02-25','07:55:00',1.09),('16273','2014-02-25','08:00:00',1.23),('16273','2014-02-25','08:05:00',1.34),('16273','2014-02-25','08:10:00',1.26),('16273','2014-02-25','08:15:00',1.6),('16273','2014-02-25','08:20:00',1.69),('16273','2014-02-25','08:25:00',1.78),('16273','2014-02-25','08:30:00',1.88),('16273','2014-02-25','08:35:00',1.94),('16273','2014-02-25','08:40:00',2.03),('16273','2014-02-25','08:45:00',2.12),('16273','2014-02-25','08:50:00',2.19),('16273','2014-02-25','08:55:00',2.27),('16273','2014-02-25','09:00:00',2.33),('16273','2014-02-25','09:05:00',2.39),('16273','2014-02-25','09:10:00',2.45),('16273','2014-02-25','09:15:00',2.51),('16273','2014-02-25','09:20:00',2.55),('16273','2014-02-25','09:25:00',2.61),('16273','2014-02-25','09:30:00',2.66),('16273','2014-02-25','09:35:00',2.71),('16273','2014-02-25','09:40:00',2.75),('16273','2014-02-25','09:45:00',2.8),('16273','2014-02-25','09:50:00',2.85),('16273','2014-02-25','09:55:00',2.88),('16273','2014-02-25','10:00:00',2.9),('16273','2014-02-25','10:05:00',2.95),('16273','2014-02-25','10:10:00',3.01),('16273','2014-02-25','10:15:00',3.02),('16273','2014-02-25','10:20:00',3.06),('16273','2014-02-25','10:25:00',3.07),('16273','2014-02-25','10:30:00',3.08),('16273','2014-02-25','10:35:00',3.1),('16273','2014-02-25','10:40:00',3.15),('16273','2014-02-25','10:45:00',3.21),('16273','2014-02-25','10:50:00',3.18),('16273','2014-02-25','10:55:00',3.19),('16273','2014-02-25','11:00:00',3.16),('16273','2014-02-25','11:05:00',3.22),('16273','2014-02-25','11:10:00',3.26),('16273','2014-02-25','11:15:00',3.27),('16273','2014-02-25','11:20:00',3.25),('16273','2014-02-25','11:25:00',3.25),('16273','2014-02-25','11:30:00',3.25),('16273','2014-02-25','11:35:00',3.32),('16273','2014-02-25','11:40:00',3.33),('16273','2014-02-25','11:45:00',3.29),('16273','2014-02-25','11:50:00',3.29),('16273','2014-02-25','11:55:00',3.29),('16273','2014-02-25','12:00:00',3.28),('16273','2014-02-25','12:05:00',3.28),('16273','2014-02-25','12:10:00',3.24),('16273','2014-02-25','12:15:00',3.23),('16273','2014-02-25','12:20:00',3.28),('16273','2014-02-25','12:25:00',3.28),('16273','2014-02-25','12:30:00',3.25),('16273','2014-02-25','12:35:00',3.2),('16273','2014-02-25','12:40:00',3.18),('16273','2014-02-25','12:45:00',3.19),('16273','2014-02-25','12:50:00',3.2),('16273','2014-02-25','12:55:00',3.18),('16273','2014-02-25','13:00:00',3.13),('16273','2014-02-25','13:05:00',3.09),('16273','2014-02-25','13:10:00',3.05),('16273','2014-02-25','13:15:00',2.35),('16273','2014-02-25','13:20:00',3.06),('16273','2014-02-25','13:25:00',1.28),('16273','2014-02-25','13:40:00',1.44),('16273','2014-02-25','13:45:00',1.03),('16273','2014-02-25','13:50:00',1.05),('16273','2014-02-25','13:55:00',2.81),('16273','2014-02-25','14:00:00',2.95),('16273','2014-02-25','14:05:00',2.66),('16273','2014-02-25','14:10:00',2.36),('16273','2014-02-25','14:15:00',2.16),('16273','2014-02-25','14:20:00',2.08),('16273','2014-02-25','14:25:00',2.15),('16273','2014-02-25','14:30:00',2.15),('16273','2014-02-25','14:35:00',2.28),('16273','2014-02-25','14:40:00',2.26),('16273','2014-02-25','14:45:00',2.15),('16273','2014-02-25','14:50:00',2.15),('16273','2014-02-25','14:55:00',1.99),('16273','2014-02-25','15:00:00',1.96),('16273','2014-02-25','15:05:00',1.88),('16273','2014-02-25','15:10:00',1.78),('16273','2014-02-25','15:15:00',1.63),('16273','2014-02-25','15:20:00',1.51),('16273','2014-02-25','15:25:00',1.39),('16273','2014-02-25','15:30:00',1.31),('16273','2014-02-25','15:35:00',1.14),('16273','2014-02-24','07:55:00',1.08),('16273','2014-02-24','08:00:00',1.39),('16273','2014-02-24','08:05:00',1.57),('16273','2014-02-24','08:25:00',1.46),('16273','2014-02-24','08:30:00',1.01),('16273','2014-02-24','08:35:00',1.95),('16273','2014-02-24','08:40:00',1.19),('16273','2014-02-24','08:50:00',1.58),('16273','2014-02-24','08:55:00',2.57),('16273','2014-02-24','09:00:00',2.54),('16273','2014-02-24','09:05:00',2.44),('16273','2014-02-24','09:10:00',2.53),('16273','2014-02-24','09:15:00',2.57),('16273','2014-02-24','09:20:00',2.63),('16273','2014-02-24','09:25:00',2.66),('16273','2014-02-24','09:30:00',2.73),('16273','2014-02-24','09:35:00',2.79),('16273','2014-02-24','09:40:00',2.82),('16273','2014-02-24','09:45:00',2.86),('16273','2014-02-24','09:50:00',2.91),('16273','2014-02-24','09:55:00',2.95),('16273','2014-02-24','10:00:00',2.96),('16273','2014-02-24','10:05:00',3.06),('16273','2014-02-24','10:10:00',3.11),('16273','2014-02-24','10:15:00',3.15),('16273','2014-02-24','10:20:00',3.15),('16273','2014-02-24','10:25:00',3.18),('16273','2014-02-24','10:30:00',3.22),('16273','2014-02-24','10:35:00',3.23),('16273','2014-02-24','10:40:00',3.24),('16273','2014-02-24','10:45:00',3.25),('16273','2014-02-24','10:50:00',3.27),('16273','2014-02-24','10:55:00',3.3),('16273','2014-02-24','11:00:00',3.33),('16273','2014-02-24','11:05:00',3.33),('16273','2014-02-24','11:10:00',3.37),('16273','2014-02-24','11:15:00',3.32),('16273','2014-02-24','11:20:00',3.35),('16273','2014-02-24','11:25:00',3.46),('16273','2014-02-24','11:30:00',3.58),('16273','2014-02-24','11:35:00',2.48),('16273','2014-02-24','11:40:00',3.33),('16273','2014-02-24','11:45:00',1.95),('16273','2014-02-24','11:50:00',2.79),('16273','2014-02-24','11:55:00',3.46),('16273','2014-02-24','12:00:00',3.42),('16273','2014-02-24','12:05:00',3.39),('16273','2014-02-24','12:10:00',3.36),('16273','2014-02-24','12:15:00',3.33),('16273','2014-02-24','12:20:00',3.32),('16273','2014-02-24','12:25:00',3.29),('16273','2014-02-24','12:30:00',3.26),('16273','2014-02-24','12:35:00',3.23),('16273','2014-02-24','12:40:00',3.22),('16273','2014-02-24','12:45:00',3.2),('16273','2014-02-24','12:50:00',1.3),('16273','2014-02-24','13:00:00',1.33),('16273','2014-02-24','13:10:00',1),('16273','2014-02-24','13:15:00',1.45),('16273','2014-02-24','13:20:00',3.95),('16273','2014-02-24','13:25:00',1.57),('16273','2014-02-24','14:00:00',1.02),('16273','2014-02-24','14:05:00',1.1),('16273','2014-02-24','14:10:00',1.11),('16273','2014-02-24','14:15:00',1.05),('16273','2014-02-24','14:20:00',1.12),('16273','2014-02-24','14:25:00',1.14),('16273','2014-02-24','14:30:00',1.3),('16273','2014-02-24','14:35:00',1.18),('16273','2014-02-24','14:55:00',1.09),('16273','2014-02-24','15:00:00',1.72),('16273','2014-02-24','15:05:00',2.13),('16273','2014-02-24','15:10:00',2.41),('16273','2014-02-24','15:15:00',2.07),('16273','2014-02-24','15:20:00',1.84),('16273','2014-02-24','15:25:00',1.65),('16273','2014-02-24','15:30:00',1.48),('16273','2014-02-24','15:35:00',1.43),('16273','2014-02-24','15:40:00',1.34),('16273','2014-02-24','15:45:00',1.27),('16273','2014-02-24','15:55:00',1.01),('16273','2014-02-24','16:00:00',1.13),('16273','2014-02-24','16:05:00',1.09),('16273','2014-02-24','16:10:00',1.07),('16273','2014-02-24','16:15:00',1.09),('16273','2014-02-24','16:20:00',1.03),('16273','2014-02-23','08:00:00',1.12),('16273','2014-02-23','08:05:00',1.25),('16273','2014-02-23','08:10:00',1.37),('16273','2014-02-23','08:15:00',1.26),('16273','2014-02-23','08:20:00',1.62),('16273','2014-02-23','08:25:00',1.72),('16273','2014-02-23','08:30:00',1.82),('16273','2014-02-23','08:35:00',1.91),('16273','2014-02-23','08:40:00',1.99),('16273','2014-02-23','08:45:00',2.07),('16273','2014-02-23','08:50:00',2.17),('16273','2014-02-23','08:55:00',2.26),('16273','2014-02-23','09:00:00',2.33),('16273','2014-02-23','09:05:00',2.39),('16273','2014-02-23','09:10:00',2.5),('16273','2014-02-23','09:15:00',2.58),('16273','2014-02-23','09:20:00',2.2),('16273','2014-02-23','09:25:00',2.36),('16273','2014-02-23','09:30:00',2.66),('16273','2014-02-23','09:35:00',2.71),('16273','2014-02-23','09:40:00',2.71),('16273','2014-02-23','09:45:00',2.79),('16273','2014-02-23','09:50:00',2.85),('16273','2014-02-23','09:55:00',2.88),('16273','2014-02-23','10:00:00',2.91),('16273','2014-02-23','10:05:00',2.96),('16273','2014-02-23','10:10:00',3.01),('16273','2014-02-23','10:15:00',3.07),('16273','2014-02-23','10:20:00',3.05),('16273','2014-02-23','10:25:00',3.12),('16273','2014-02-23','10:30:00',3.14),('16273','2014-02-23','10:35:00',3.17),('16273','2014-02-23','10:40:00',3.19),('16273','2014-02-23','10:45:00',3.2),('16273','2014-02-23','10:50:00',3.21),('16273','2014-02-23','10:55:00',3.22),('16273','2014-02-23','11:00:00',3.28),('16273','2014-02-23','11:05:00',3.3),('16273','2014-02-23','11:10:00',3.32),('16273','2014-02-23','11:15:00',3.35),('16273','2014-02-23','11:20:00',3.37),('16273','2014-02-23','11:25:00',3.36),('16273','2014-02-23','11:30:00',3.38),('16273','2014-02-23','11:35:00',3.39),('16273','2014-02-23','11:40:00',3.39),('16273','2014-02-23','11:45:00',3.42),('16273','2014-02-23','11:50:00',3.47),('16273','2014-02-23','11:55:00',3.28),('16273','2014-02-23','12:00:00',3.34),('16273','2014-02-23','12:05:00',2.74),('16273','2014-02-23','12:10:00',3.29),('16273','2014-02-23','12:15:00',2.86),('16273','2014-02-23','12:20:00',1.48),('16273','2014-02-23','12:25:00',1.64),('16273','2014-02-23','12:30:00',1.64),('16273','2014-02-23','12:35:00',2.41),('16273','2014-02-23','12:40:00',2.59),('16273','2014-02-23','12:45:00',2.87),('16273','2014-02-23','12:50:00',2.98),('16273','2014-02-23','12:55:00',3.27),('16273','2014-02-23','13:00:00',3.26),('16273','2014-02-23','13:05:00',3.21),('16273','2014-02-23','13:10:00',3.2),('16273','2014-02-23','13:15:00',3.08),('16273','2014-02-23','13:20:00',2.86),('16273','2014-02-23','13:25:00',2.48),('16273','2014-02-23','13:30:00',2.52),('16273','2014-02-23','13:35:00',2.55),('16273','2014-02-23','13:40:00',2.77),('16273','2014-02-23','13:45:00',2.56),('16273','2014-02-23','13:50:00',2.28),('16273','2014-02-23','13:55:00',2.48),('16273','2014-02-23','14:00:00',2.78),('16273','2014-02-23','14:05:00',2.56),('16273','2014-02-23','14:10:00',1.46),('16273','2014-02-23','14:15:00',2.29),('16273','2014-02-23','14:20:00',2.09),('16273','2014-02-23','14:25:00',1.55),('16273','2014-02-23','14:30:00',2.28),('16273','2014-02-23','14:35:00',2.22),('16273','2014-02-23','14:40:00',2.53),('16273','2014-02-23','14:45:00',2.63),('16273','2014-02-23','14:50:00',2.34),('16273','2014-02-23','14:55:00',1.14),('16273','2014-02-23','15:00:00',1.2),('16273','2014-02-23','15:05:00',1.09),('16273','2014-02-23','15:15:00',1.29),('16273','2014-02-23','15:20:00',1.98),('16273','2014-02-23','15:25:00',1.83),('16273','2014-02-23','15:30:00',1.83),('16273','2014-02-23','15:40:00',1.7),('16273','2014-02-23','15:45:00',1.68),('16273','2014-02-23','15:50:00',1.82),('16273','2014-02-23','15:55:00',1.84),('16273','2014-02-23','16:00:00',1.55),('16273','2014-02-23','16:05:00',1.15),('16273','2014-02-22','09:15:00',1.04),('16273','2014-02-22','09:35:00',1.93),('16273','2014-02-22','09:40:00',2.77),('16273','2014-02-22','09:45:00',1.85),('16273','2014-02-22','09:50:00',1.37),('16273','2014-02-22','09:55:00',1.43),('16273','2014-02-22','10:00:00',2.23),('16273','2014-02-22','10:05:00',1.13),('16273','2014-02-22','10:20:00',1.58),('16273','2014-02-22','10:25:00',1.99),('16273','2014-02-22','10:30:00',2.53),('16273','2014-02-22','10:35:00',3.43),('16273','2014-02-22','10:40:00',2.31),('16273','2014-02-22','10:45:00',1.12),('16273','2014-02-22','11:55:00',1.1),('16273','2014-02-22','12:00:00',1.19),('16273','2014-02-22','12:05:00',1.15),('16273','2014-02-22','12:10:00',1.11),('16273','2014-02-22','12:15:00',1.15),('16273','2014-02-22','12:20:00',1.15),('16273','2014-02-22','12:25:00',1.06),('16273','2014-02-22','12:30:00',1.75),('16273','2014-02-22','12:35:00',3.05),('16273','2014-02-22','12:40:00',3.36),('16273','2014-02-22','12:45:00',3.22),('16273','2014-02-22','12:50:00',2.49),('16273','2014-02-22','12:55:00',3.82),('16273','2014-02-22','13:00:00',2),('16273','2014-02-22','13:10:00',1.3),('16273','2014-02-22','13:15:00',1.54),('16273','2014-02-22','13:30:00',1.81),('16273','2014-02-22','13:35:00',2.94),('16273','2014-02-22','13:40:00',1.48),('16273','2014-02-22','13:45:00',1.17),('16273','2014-02-22','13:50:00',1.37),('16273','2014-02-22','13:55:00',1.32),('16273','2014-02-22','14:00:00',1.41),('16273','2014-02-22','14:05:00',2.53),('16273','2014-02-22','14:10:00',1.21),('16273','2014-02-22','14:20:00',1.08),('16273','2014-02-22','14:25:00',2.42),('16273','2014-02-22','14:50:00',1.55),('16273','2014-02-22','14:55:00',1.89),('16273','2014-02-22','15:00:00',1.45),('16273','2014-02-22','15:05:00',1.31),('16273','2014-02-22','15:20:00',1.31),('16273','2014-02-22','15:25:00',1.95),('16273','2014-02-22','15:40:00',1.14),('16273','2014-02-22','15:45:00',1.42),('16273','2014-02-22','16:00:00',1.18),('16273','2014-02-21','09:15:00',1.03),('16273','2014-02-21','09:20:00',1.02),('16273','2014-02-21','09:25:00',1.02),('16273','2014-02-21','09:40:00',1.01),('16273','2014-02-21','09:45:00',1.06),('16273','2014-02-21','09:50:00',1.22),('16273','2014-02-21','09:55:00',1.52),('16273','2014-02-21','10:00:00',1.75),('16273','2014-02-21','10:05:00',2.13),('16273','2014-02-21','10:10:00',2.13),('16273','2014-02-21','10:15:00',1.8),('16273','2014-02-21','10:20:00',1.81),('16273','2014-02-21','10:25:00',1.57),('16273','2014-02-21','10:30:00',1.49),('16273','2014-02-21','10:35:00',1.65),('16273','2014-02-21','10:40:00',2.3),('16273','2014-02-21','10:45:00',3.54),('16273','2014-02-21','10:50:00',3.48),('16273','2014-02-21','10:55:00',3.4),('16273','2014-02-21','11:00:00',3.55),('16273','2014-02-21','11:05:00',3.49),('16273','2014-02-21','11:10:00',2.79),('16273','2014-02-21','11:15:00',1.56),('16273','2014-02-21','11:20:00',1.85),('16273','2014-02-21','11:25:00',2.98),('16273','2014-02-21','11:30:00',3.14),('16273','2014-02-21','11:35:00',2.4),('16273','2014-02-21','11:40:00',3.47),('16273','2014-02-21','11:45:00',3.01),('16273','2014-02-21','11:50:00',2.42),('16273','2014-02-21','11:55:00',2.59),('16273','2014-02-21','12:00:00',1.08),('16273','2014-02-21','12:05:00',1.13),('16273','2014-02-21','12:10:00',1.1),('16273','2014-02-21','14:10:00',1.26),('16273','2014-02-21','14:15:00',1.18),('16273','2014-02-21','14:20:00',1.31),('16273','2014-02-21','14:25:00',1.47),('16273','2014-02-21','14:30:00',2.21),('16273','2014-02-21','14:35:00',1.41),('16273','2014-02-21','14:40:00',1.59),('16273','2014-02-21','14:45:00',1.74),('16273','2014-02-21','14:50:00',2.03),('16273','2014-02-21','14:55:00',1.96),('16273','2014-02-21','15:00:00',1.42),('16273','2014-02-21','15:05:00',1.23),('16273','2014-02-21','15:10:00',2.29),('16273','2014-02-21','15:15:00',1.99),('16273','2014-02-21','15:20:00',1.66),('16273','2014-02-21','15:25:00',1.5),('16273','2014-02-21','15:30:00',1.39),('16273','2014-02-21','15:35:00',1.33),('16273','2014-02-21','15:40:00',1.26),('16273','2014-02-21','15:45:00',1.2),('16273','2014-02-21','15:50:00',1.14),('16273','2014-02-21','15:55:00',1.06),('16273','2014-02-21','16:00:00',1.05),('16273','2014-02-20','10:15:00',1.02),('16273','2014-02-20','10:20:00',1.06),('16273','2014-02-20','10:35:00',1.05),('16273','2014-02-20','10:40:00',1.14),('16273','2014-02-20','10:45:00',1.1),('16273','2014-02-20','10:50:00',1.05),('16273','2014-02-20','10:55:00',1.05),('16273','2014-02-20','11:20:00',1.13),('16273','2014-02-20','11:25:00',1.22),('16273','2014-02-20','11:30:00',1.26),('16273','2014-02-20','11:35:00',1.06),('16273','2014-02-20','11:40:00',1.07),('16273','2014-02-20','11:55:00',1.08),('16273','2014-02-20','12:00:00',1.05),('16273','2014-02-20','12:20:00',1.16),('16273','2014-02-20','12:30:00',1.03),('16273','2014-02-20','12:35:00',1.09),('16273','2014-02-20','12:40:00',1.2),('16273','2014-02-20','12:45:00',1.15),('16273','2014-02-20','12:50:00',1.01),('16273','2014-02-20','12:55:00',1.11),('16273','2014-02-20','13:00:00',1.27),('16273','2014-02-20','13:05:00',1.08),('16273','2014-02-20','13:10:00',1.32),('16273','2014-02-20','13:15:00',1.35),('16273','2014-02-20','13:20:00',1.14),('16273','2014-02-20','13:25:00',1.32),('16273','2014-02-20','13:30:00',1.23),('16273','2014-02-20','13:35:00',1.13),('16273','2014-02-20','13:40:00',1.22),('16273','2014-02-20','13:45:00',1.18),('16273','2014-02-20','13:50:00',1.23),('16273','2014-02-20','13:55:00',1.11),('16273','2014-02-20','14:00:00',1.26),('16273','2014-02-20','14:05:00',1.12),('16273','2014-02-19','09:40:00',1.16),('16273','2014-02-19','09:45:00',1.42),('16273','2014-02-19','09:50:00',1.31),('16273','2014-02-19','09:55:00',1.18),('16273','2014-02-19','10:00:00',1.24),('16273','2014-02-19','10:05:00',1.3),('16273','2014-02-19','10:10:00',1.36),('16273','2014-02-19','10:15:00',1.47),('16273','2014-02-19','10:20:00',1.37),('16273','2014-02-19','10:25:00',1.26),('16273','2014-02-19','10:30:00',1.14),('16273','2014-02-19','10:35:00',1.22),('16273','2014-02-19','10:40:00',1.41),('16273','2014-02-19','10:45:00',1.35),('16273','2014-02-19','10:50:00',1.49),('16273','2014-02-19','10:55:00',1.53),('16273','2014-02-19','11:00:00',1.23),('16273','2014-02-19','11:10:00',1.28),('16273','2014-02-19','11:15:00',1.4),('16273','2014-02-19','11:20:00',1.32),('16273','2014-02-19','11:25:00',1.03),('16273','2014-02-19','11:40:00',1.38),('16273','2014-02-19','11:45:00',1.47),('16273','2014-02-19','11:50:00',1.4),('16273','2014-02-19','11:55:00',1.13),('16273','2014-02-19','12:00:00',1.22),('16273','2014-02-19','12:05:00',1.31),('16273','2014-02-19','12:10:00',1.3),('16273','2014-02-19','12:15:00',1.04),('16273','2014-02-19','12:30:00',1.22),('16273','2014-02-19','12:35:00',1.02),('16273','2014-02-19','12:40:00',1.15),('16273','2014-02-19','12:45:00',1.42),('16273','2014-02-19','12:50:00',1.31),('16273','2014-02-19','12:55:00',1.37),('16273','2014-02-19','13:00:00',1.95),('16273','2014-02-19','13:05:00',1.79),('16273','2014-02-19','13:10:00',2.01),('16273','2014-02-19','13:15:00',1.8),('16273','2014-02-19','13:20:00',1.45),('16273','2014-02-19','13:25:00',1.43),('16273','2014-02-19','13:30:00',1.56),('16273','2014-02-19','13:35:00',1.68),('16273','2014-02-19','13:40:00',1.71),('16273','2014-02-19','13:45:00',1.84),('16273','2014-02-19','13:50:00',1.82),('16273','2014-02-19','13:55:00',1.87),('16273','2014-02-19','14:00:00',1.37),('16273','2014-02-19','14:05:00',1.13),('16273','2014-02-19','14:10:00',1.01),('16273','2014-02-19','14:15:00',1.12),('16273','2014-02-19','14:20:00',1.11),('16273','2014-02-19','14:25:00',1.3),('16273','2014-02-19','14:30:00',1.28),('16273','2014-02-19','14:35:00',1.12),('16273','2014-02-18','08:05:00',1.1),('16273','2014-02-18','08:10:00',1.24),('16273','2014-02-18','08:15:00',1.23),('16273','2014-02-18','08:20:00',1.37),('16273','2014-02-18','08:25:00',1.61),('16273','2014-02-18','08:30:00',1.7),('16273','2014-02-18','08:35:00',1.77),('16273','2014-02-18','08:40:00',1.85),('16273','2014-02-18','08:45:00',1.92),('16273','2014-02-18','08:50:00',1.98),('16273','2014-02-18','08:55:00',2.07),('16273','2014-02-18','09:00:00',2.14),('16273','2014-02-18','09:05:00',2.21),('16273','2014-02-18','09:10:00',2.28),('16273','2014-02-18','09:15:00',2.35),('16273','2014-02-18','09:20:00',2.39),('16273','2014-02-18','09:25:00',2.46),('16273','2014-02-18','09:30:00',2.5),('16273','2014-02-18','09:35:00',2.54),('16273','2014-02-18','09:40:00',2.61),('16273','2014-02-18','09:45:00',2.67),('16273','2014-02-18','09:50:00',2.7),('16273','2014-02-18','09:55:00',2.74),('16273','2014-02-18','10:00:00',2.79),('16273','2014-02-18','10:05:00',2.83),('16273','2014-02-18','10:10:00',2.84),('16273','2014-02-18','10:15:00',2.85),('16273','2014-02-18','10:20:00',2.89),('16273','2014-02-18','10:25:00',2.94),('16273','2014-02-18','10:30:00',2.96),('16273','2014-02-18','10:35:00',2.99),('16273','2014-02-18','10:40:00',3.03),('16273','2014-02-18','10:45:00',3.05),('16273','2014-02-18','10:50:00',3.1),('16273','2014-02-18','10:55:00',3.15),('16273','2014-02-18','11:00:00',3.16),('16273','2014-02-18','11:05:00',2.97),('16273','2014-02-18','11:10:00',2.76),('16273','2014-02-18','11:15:00',2.66),('16273','2014-02-18','11:20:00',3.14),('16273','2014-02-18','11:25:00',3.18),('16273','2014-02-18','11:30:00',2.53),('16273','2014-02-18','11:35:00',1.81),('16273','2014-02-18','11:40:00',1.76),('16273','2014-02-18','11:45:00',1.56),('16273','2014-02-18','11:50:00',1.33),('16273','2014-02-18','11:55:00',1.34),('16273','2014-02-18','12:00:00',1.37),('16273','2014-02-18','12:05:00',1.35),('16273','2014-02-18','12:10:00',1.44),('16273','2014-02-18','12:15:00',1.55),('16273','2014-02-18','12:20:00',1.7),('16273','2014-02-18','12:25:00',1.75),('16273','2014-02-18','12:30:00',1.58),('16273','2014-02-18','12:35:00',1.42),('16273','2014-02-18','12:40:00',1.38),('16273','2014-02-18','12:45:00',1.33),('16273','2014-02-18','12:50:00',1.31),('16273','2014-02-18','12:55:00',1.33),('16273','2014-02-18','13:00:00',1.26),('16273','2014-02-18','13:05:00',1.19),('16273','2014-02-18','13:10:00',1.28),('16273','2014-02-18','13:15:00',1.76),('16273','2014-02-18','13:20:00',2.44),('16273','2014-02-18','13:25:00',2.58),('16273','2014-02-18','13:30:00',1.66),('16273','2014-02-18','13:35:00',1.81),('16273','2014-02-18','13:40:00',2),('16273','2014-02-18','13:45:00',1.89),('16273','2014-02-18','13:50:00',1.53),('16273','2014-02-18','13:55:00',1.54),('16273','2014-02-18','14:00:00',1.49),('16273','2014-02-18','14:05:00',1.9),('16273','2014-02-18','14:10:00',1.45),('16273','2014-02-18','14:15:00',1.21),('16273','2014-02-18','14:20:00',1.06),('16273','2014-02-18','14:25:00',1.09),('16273','2014-02-18','14:30:00',1.22),('16273','2014-02-18','14:35:00',1.16),('16273','2014-02-18','14:40:00',1.01),('16273','2014-02-18','15:40:00',1.04),('16273','2014-02-17','08:15:00',1.09),('16273','2014-02-17','08:20:00',1.08),('16273','2014-02-17','08:25:00',1.35),('16273','2014-02-17','08:30:00',1.44),('16273','2014-02-17','08:35:00',1.56),('16273','2014-02-17','08:40:00',1.62),('16273','2014-02-17','08:45:00',1.66),('16273','2014-02-17','08:50:00',1.72),('16273','2014-02-17','08:55:00',1.78),('16273','2014-02-17','09:00:00',1.9),('16273','2014-02-17','09:05:00',1.98),('16273','2014-02-17','09:10:00',2.06),('16273','2014-02-17','09:15:00',2.13),('16273','2014-02-17','09:20:00',2.2),('16273','2014-02-17','09:25:00',2.25),('16273','2014-02-17','09:30:00',2.3),('16273','2014-02-17','09:35:00',2.35),('16273','2014-02-17','09:40:00',2.38),('16273','2014-02-17','09:45:00',2.4),('16273','2014-02-17','09:50:00',2.45),('16273','2014-02-17','09:55:00',2.5),('16273','2014-02-17','10:00:00',2.53),('16273','2014-02-17','10:05:00',2.57),('16273','2014-02-17','10:10:00',2.59),('16273','2014-02-17','10:15:00',2.62),('16273','2014-02-17','10:20:00',2.65),('16273','2014-02-17','10:25:00',2.68),('16273','2014-02-17','10:30:00',2.68),('16273','2014-02-17','10:35:00',2.68),('16273','2014-02-17','10:40:00',2.74),('16273','2014-02-17','10:45:00',2.79),('16273','2014-02-17','10:50:00',2.78),('16273','2014-02-17','10:55:00',2.79),('16273','2014-02-17','11:00:00',2.81),('16273','2014-02-17','11:05:00',2.81),('16273','2014-02-17','11:10:00',2.8),('16273','2014-02-17','11:15:00',2.85),('16273','2014-02-17','11:20:00',2.85),('16273','2014-02-17','11:25:00',2.9),('16273','2014-02-17','11:30:00',2.92),('16273','2014-02-17','11:35:00',2.96),('16273','2014-02-17','11:40:00',2.95),('16273','2014-02-17','11:45:00',2.96),('16273','2014-02-17','11:50:00',2.97),('16273','2014-02-17','11:55:00',2.97),('16273','2014-02-17','12:00:00',2.98),('16273','2014-02-17','12:05:00',3),('16273','2014-02-17','12:10:00',2.97),('16273','2014-02-17','12:15:00',2.96),('16273','2014-02-17','12:20:00',2.94),('16273','2014-02-17','12:25:00',2.89),('16273','2014-02-17','12:30:00',2.92),('16273','2014-02-17','12:35:00',2.9),('16273','2014-02-17','12:40:00',2.89),('16273','2014-02-17','12:45:00',2.86),('16273','2014-02-17','12:50:00',2.85),('16273','2014-02-17','12:55:00',2.82),('16273','2014-02-17','13:00:00',2.79),('16273','2014-02-17','13:05:00',2.75),('16273','2014-02-17','13:10:00',2.72),('16273','2014-02-17','13:15:00',2.69),('16273','2014-02-17','13:20:00',2.67),('16273','2014-02-17','13:25:00',2.63),('16273','2014-02-17','13:30:00',2.59),('16273','2014-02-17','13:35:00',2.55),('16273','2014-02-17','13:40:00',2.5),('16273','2014-02-17','13:45:00',2.45),('16273','2014-02-17','13:50:00',2.44),('16273','2014-02-17','13:55:00',2.39),('16273','2014-02-17','14:00:00',2.32),('16273','2014-02-17','14:05:00',2.29),('16273','2014-02-17','14:10:00',2.16),('16273','2014-02-17','14:15:00',2.23),('16273','2014-02-17','14:20:00',2.15),('16273','2014-02-17','14:25:00',2.07),('16273','2014-02-17','14:30:00',1.97),('16273','2014-02-17','14:35:00',1.9),('16273','2014-02-17','14:40:00',1.89),('16273','2014-02-17','14:45:00',1.85),('16273','2014-02-17','14:50:00',1.79),('16273','2014-02-17','14:55:00',1.73),('16273','2014-02-17','15:00:00',1.65),('16273','2014-02-17','15:05:00',1.51),('16273','2014-02-17','15:10:00',1.43),('16273','2014-02-17','15:15:00',1.48),('16273','2014-02-17','15:20:00',1.38),('16273','2014-02-17','15:25:00',1.34),('16273','2014-02-17','15:30:00',1.28),('16273','2014-02-17','15:35:00',1.18),('16273','2014-02-17','15:40:00',1.15),('16273','2014-02-17','15:45:00',1.09),('16273','2014-02-17','15:50:00',1.03),('16273','2014-02-16','08:05:00',1.05),('16273','2014-02-16','08:10:00',1.18),('16273','2014-02-16','08:15:00',1.3),('16273','2014-02-16','08:20:00',1.18),('16273','2014-02-16','08:25:00',1.56),('16273','2014-02-16','08:30:00',1.69),('16273','2014-02-16','08:35:00',1.61),('16273','2014-02-16','08:40:00',1.91),('16273','2014-02-16','08:45:00',1.79),('16273','2014-02-16','08:50:00',2.04),('16273','2014-02-16','08:55:00',2.13),('16273','2014-02-16','09:00:00',2.24),('16273','2014-02-16','09:05:00',2.25),('16273','2014-02-16','09:10:00',1.98),('16273','2014-02-16','09:15:00',2.24),('16273','2014-02-16','09:20:00',2.27),('16273','2014-02-16','09:25:00',2.24),('16273','2014-02-16','09:30:00',2.02),('16273','2014-02-16','09:35:00',2.56),('16273','2014-02-16','09:40:00',2.63),('16273','2014-02-16','09:45:00',2.66),('16273','2014-02-16','09:50:00',2.66),('16273','2014-02-16','09:55:00',2.53),('16273','2014-02-16','10:00:00',2.76),('16273','2014-02-16','10:05:00',2.84),('16273','2014-02-16','10:10:00',2.82),('16273','2014-02-16','10:15:00',2.86),('16273','2014-02-16','10:20:00',2.9),('16273','2014-02-16','10:25:00',3.01),('16273','2014-02-16','10:30:00',2.97),('16273','2014-02-16','10:35:00',2.91),('16273','2014-02-16','10:40:00',3.07),('16273','2014-02-16','10:45:00',2.59),('16273','2014-02-16','10:50:00',2.71),('16273','2014-02-16','10:55:00',3.04),('16273','2014-02-16','11:00:00',3.02),('16273','2014-02-16','11:05:00',2.93),('16273','2014-02-16','11:10:00',2.9),('16273','2014-02-16','11:15:00',2.75),('16273','2014-02-16','11:20:00',2.69),('16273','2014-02-16','11:25:00',2.91),('16273','2014-02-16','11:30:00',3.1),('16273','2014-02-16','11:35:00',2.99),('16273','2014-02-16','11:40:00',2.61),('16273','2014-02-16','11:45:00',2.99),('16273','2014-02-16','11:50:00',2.96),('16273','2014-02-16','11:55:00',3.06),('16273','2014-02-16','12:00:00',3.02),('16273','2014-02-16','12:05:00',3.05),('16273','2014-02-16','12:10:00',3.04),('16273','2014-02-16','12:15:00',3.01),('16273','2014-02-16','12:20:00',3),('16273','2014-02-16','12:25:00',3.01),('16273','2014-02-16','12:30:00',2.99),('16273','2014-02-16','12:35:00',3),('16273','2014-02-16','12:40:00',2.95),('16273','2014-02-16','12:45:00',2.94),('16273','2014-02-16','12:50:00',2.9),('16273','2014-02-16','12:55:00',2.85),('16273','2014-02-16','13:00:00',2.86),('16273','2014-02-16','13:05:00',2.76),('16273','2014-02-16','13:10:00',2.85),('16273','2014-02-16','13:15:00',2.8),('16273','2014-02-16','13:20:00',2.77),('16273','2014-02-16','13:25:00',2.73),('16273','2014-02-16','13:30:00',2.72),('16273','2014-02-16','13:35:00',2.7),('16273','2014-02-16','13:40:00',2.68),('16273','2014-02-16','13:45:00',2.52),('16273','2014-02-16','13:50:00',2.51),('16273','2014-02-16','13:55:00',2.49),('16273','2014-02-16','14:00:00',2.47),('16273','2014-02-16','14:05:00',2.42),('16273','2014-02-16','14:10:00',2.36),('16273','2014-02-16','14:15:00',2.28),('16273','2014-02-16','14:20:00',2.27),('16273','2014-02-16','14:25:00',2.21),('16273','2014-02-16','14:30:00',2.13),('16273','2014-02-16','14:35:00',2),('16273','2014-02-16','14:40:00',2.01),('16273','2014-02-16','14:45:00',1.94),('16273','2014-02-16','14:50:00',1.88),('16273','2014-02-16','14:55:00',1.51),('16273','2014-02-16','15:00:00',1.68),('16273','2014-02-16','15:05:00',1.69),('16273','2014-02-16','15:10:00',1.6),('16273','2014-02-16','15:15:00',1.54),('16273','2014-02-16','15:20:00',1.46),('16273','2014-02-16','15:25:00',1.36),('16273','2014-02-16','15:30:00',1.31),('16273','2014-02-16','15:35:00',1.18),('16273','2014-02-16','16:20:00',1.06),('16273','2014-04-28','08:00:00',1.19),('16273','2014-04-28','08:05:00',1.98),('16273','2014-04-28','08:10:00',2.27),('16273','2014-04-28','08:15:00',1.87),('16273','2014-04-28','08:20:00',1.29),('16273','2014-04-28','08:25:00',1.3),('16273','2014-04-28','08:30:00',1.36),('16273','2014-04-28','08:35:00',1.13),('16273','2014-04-28','08:40:00',1.1),('16273','2014-04-28','08:50:00',2.45),('16273','2014-04-28','08:55:00',2.74),('16273','2014-04-28','09:00:00',2.12),('16273','2014-04-28','09:05:00',2.9),('16273','2014-04-28','09:10:00',2.21),('16273','2014-04-28','09:15:00',2.32),('16273','2014-04-28','09:20:00',2.91),('16273','2014-04-28','09:25:00',2.73),('16273','2014-04-28','09:30:00',1.8),('16273','2014-04-28','09:35:00',1.55),('16273','2014-04-28','09:40:00',1.83),('16273','2014-04-28','09:45:00',1.66),('16273','2014-04-28','09:50:00',2),('16273','2014-04-28','09:55:00',1.95),('16273','2014-04-28','10:00:00',1.56),('16273','2014-04-28','10:05:00',1.03),('16273','2014-04-28','10:15:00',1.05),('16273','2014-04-28','10:20:00',1.35),('16273','2014-04-28','10:25:00',1.8),('16273','2014-04-28','10:30:00',1.7),('16273','2014-04-28','10:35:00',1.54),('16273','2014-04-28','10:40:00',1.65),('16273','2014-04-28','10:45:00',2.02),('16273','2014-04-28','10:50:00',2.16),('16273','2014-04-28','10:55:00',1.79),('16273','2014-04-28','11:00:00',2.01),('16273','2014-04-28','11:05:00',1.99),('16273','2014-04-28','11:10:00',1.65),('16273','2014-04-28','11:15:00',1.47),('16273','2014-04-28','11:20:00',1.15),('16273','2014-04-28','11:25:00',1.22),('16273','2014-04-28','11:35:00',1.09),('16273','2014-04-28','11:40:00',1.39),('16273','2014-04-28','11:45:00',1.55),('16273','2014-04-28','11:50:00',1.74),('16273','2014-04-28','11:55:00',1.68),('16273','2014-04-28','12:00:00',1.47),('16273','2014-04-28','12:05:00',1.29),('16273','2014-04-28','12:10:00',2.16),('16273','2014-04-28','12:15:00',2.24),('16273','2014-04-28','12:20:00',2.26),('16273','2014-04-28','12:25:00',2.6),('16273','2014-04-28','12:30:00',2.96),('16273','2014-04-28','12:35:00',2.48),('16273','2014-04-28','12:40:00',2.34),('16273','2014-04-28','12:45:00',2.09),('16273','2014-04-28','12:50:00',2.03),('16273','2014-04-28','12:55:00',1.92),('16273','2014-04-28','13:00:00',2.06),('16273','2014-04-28','13:05:00',2.95),('16273','2014-04-28','13:10:00',4.02),('16273','2014-04-28','13:15:00',4.22),('16273','2014-04-28','13:20:00',3.73),('16273','2014-04-28','13:25:00',4.23),('16273','2014-04-28','13:30:00',4.1),('16273','2014-04-28','13:35:00',2.82),('16273','2014-04-28','13:40:00',2.46),('16273','2014-04-28','13:45:00',2.58),('16273','2014-04-28','13:50:00',3.42),('16273','2014-04-28','13:55:00',3.85),('16273','2014-04-28','14:00:00',2.98),('16273','2014-04-28','14:05:00',4.05),('16273','2014-04-28','14:10:00',2.93),('16273','2014-04-28','14:15:00',3.28),('16273','2014-04-28','14:20:00',4.32),('16273','2014-04-28','14:25:00',3.19),('16273','2014-04-28','14:30:00',2.5),('16273','2014-04-28','14:35:00',1.84),('16273','2014-04-28','14:40:00',2.35),('16273','2014-04-28','14:45:00',3.44),('16273','2014-04-28','14:50:00',2.26),('16273','2014-04-28','14:55:00',2.75),('16273','2014-04-28','15:00:00',2.22),('16273','2014-04-28','15:05:00',2.51),('16273','2014-04-28','15:10:00',2.05),('16273','2014-04-28','15:15:00',1.7),('16273','2014-04-28','15:20:00',1.38),('16273','2014-04-28','15:25:00',1.43),('16273','2014-04-28','15:30:00',1.31),('16273','2014-04-28','15:35:00',2.06),('16273','2014-04-28','15:40:00',2.75),('16273','2014-04-28','15:45:00',3.27),('16273','2014-04-28','15:50:00',2.34),('16273','2014-04-28','15:55:00',1.93),('16273','2014-04-28','16:00:00',2),('16273','2014-04-28','16:05:00',1.91),('16273','2014-04-28','16:10:00',1.7),('16273','2014-04-28','16:15:00',1.55),('16273','2014-04-28','16:20:00',2.04),('16273','2014-04-28','16:25:00',1.07),('16273','2014-04-28','16:45:00',1.76),('16273','2014-04-28','16:50:00',1.1),('16273','2014-04-28','17:05:00',1.33),('16273','2014-04-28','17:15:00',1.16),('16273','2014-04-28','17:20:00',1.31),('16273','2014-04-28','17:25:00',1.42),('16273','2014-02-15','08:10:00',1.07),('16273','2014-02-15','08:15:00',1.21),('16273','2014-02-15','08:20:00',1.26),('16273','2014-02-15','08:25:00',1.34),('16273','2014-02-15','08:30:00',1.58),('16273','2014-02-15','08:35:00',1.68),('16273','2014-02-15','08:40:00',1.77),('16273','2014-02-15','08:45:00',1.82),('16273','2014-02-15','08:50:00',1.75),('16273','2014-02-15','08:55:00',2.01),('16273','2014-02-15','09:00:00',2.07),('16273','2014-02-15','09:05:00',2.13),('16273','2014-02-15','09:10:00',2.18),('16273','2014-02-15','09:15:00',2.23),('16273','2014-02-15','09:20:00',2.31),('16273','2014-02-15','09:25:00',2.34),('16273','2014-02-15','09:30:00',2.38),('16273','2014-02-15','09:35:00',2.41),('16273','2014-02-15','09:40:00',2.43),('16273','2014-02-15','09:45:00',2.5),('16273','2014-02-15','09:50:00',2.52),('16273','2014-02-15','09:55:00',2.55),('16273','2014-02-15','10:00:00',2.56),('16273','2014-02-15','10:05:00',2.6),('16273','2014-02-15','10:10:00',2.63),('16273','2014-02-15','10:15:00',2.67),('16273','2014-02-15','10:20:00',2.69),('16273','2014-02-15','10:25:00',2.7),('16273','2014-02-15','10:30:00',2.76),('16273','2014-02-15','10:35:00',2.79),('16273','2014-02-15','10:40:00',2.84),('16273','2014-02-15','10:45:00',2.86),('16273','2014-02-15','10:50:00',2.85),('16273','2014-02-15','10:55:00',2.87),('16273','2014-02-15','11:00:00',2.9),('16273','2014-02-15','11:05:00',2.93),('16273','2014-02-15','11:10:00',2.92),('16273','2014-02-15','11:15:00',2.99),('16273','2014-02-15','11:20:00',2.98),('16273','2014-02-15','11:25:00',3.03),('16273','2014-02-15','11:30:00',2.72),('16273','2014-02-15','11:35:00',2.98),('16273','2014-02-15','11:40:00',3.33),('16273','2014-02-15','11:45:00',3.16),('16273','2014-02-15','11:50:00',3.13),('16273','2014-02-15','11:55:00',3.23),('16273','2014-02-15','12:00:00',1.09),('16273','2014-02-15','12:05:00',2.95),('16273','2014-02-15','12:15:00',3.41),('16273','2014-02-15','12:20:00',3.36),('16273','2014-02-15','12:25:00',3.2),('16273','2014-02-15','12:30:00',3.15),('16273','2014-02-15','12:35:00',3.13),('16273','2014-02-15','12:40:00',1.82),('16273','2014-02-15','12:45:00',2.85),('16273','2014-02-15','12:50:00',3.07),('16273','2014-02-15','12:55:00',3.07),('16273','2014-02-15','13:00:00',3),('16273','2014-02-15','13:05:00',2.91),('16273','2014-02-15','13:10:00',2.95),('16273','2014-02-15','13:15:00',2.7),('16273','2014-02-15','13:20:00',2.78),('16273','2014-02-15','13:25:00',2.77),('16273','2014-02-15','13:30:00',2.71),('16273','2014-02-15','13:35:00',2.66),('16273','2014-02-15','13:40:00',2.62),('16273','2014-02-15','13:45:00',2.55),('16273','2014-02-15','13:50:00',2.49),('16273','2014-02-15','13:55:00',2.47),('16273','2014-02-15','14:00:00',2.41),('16273','2014-02-15','14:05:00',2.37),('16273','2014-02-15','14:10:00',2.31),('16273','2014-02-15','14:15:00',2.28),('16273','2014-02-15','14:20:00',2.2),('16273','2014-02-15','14:25:00',2.13),('16273','2014-02-15','14:30:00',2.04),('16273','2014-02-15','14:35:00',2.01),('16273','2014-02-15','14:40:00',1.97),('16273','2014-02-15','14:45:00',1.91),('16273','2014-02-15','14:50:00',1.83),('16273','2014-02-15','14:55:00',1.76),('16273','2014-02-15','15:00:00',1.69),('16273','2014-02-15','15:05:00',1.64),('16273','2014-02-15','15:10:00',1.58),('16273','2014-02-15','15:15:00',1.49),('16273','2014-02-15','15:20:00',1.42),('16273','2014-02-15','15:25:00',1.36),('16273','2014-02-15','15:30:00',1.3),('16273','2014-02-15','15:35:00',1.23),('16273','2014-02-15','15:40:00',1.17),('16273','2014-02-15','15:45:00',1.1),('16273','2014-02-15','15:50:00',1.05),('16273','2014-02-15','15:55:00',1),('16273','2014-02-14','08:30:00',1.43),('16273','2014-02-14','08:35:00',1.31),('16273','2014-02-14','08:40:00',1.76),('16273','2014-02-14','08:45:00',1.85),('16273','2014-02-14','08:50:00',1.92),('16273','2014-02-14','08:55:00',1.82),('16273','2014-02-14','09:00:00',1.81),('16273','2014-02-14','09:05:00',2.12),('16273','2014-02-14','09:10:00',2.2),('16273','2014-02-14','09:15:00',2.29),('16273','2014-02-14','09:20:00',2.27),('16273','2014-02-14','09:25:00',2.35),('16273','2014-02-14','09:30:00',2.16),('16273','2014-02-14','09:35:00',2.4),('16273','2014-02-14','09:40:00',2.65),('16273','2014-02-14','09:45:00',2.69),('16273','2014-02-14','09:50:00',2.75),('16273','2014-02-14','09:55:00',2.6),('16273','2014-02-14','10:00:00',2.83),('16273','2014-02-14','10:05:00',2.82),('16273','2014-02-14','10:10:00',2.8),('16273','2014-02-14','10:15:00',2.46),('16273','2014-02-14','10:20:00',3.04),('16273','2014-02-14','10:25:00',2.61),('16273','2014-02-14','10:30:00',2.85),('16273','2014-02-14','10:35:00',2.8),('16273','2014-02-14','10:40:00',3.1),('16273','2014-02-14','10:45:00',3.11),('16273','2014-02-14','10:50:00',3.16),('16273','2014-02-14','10:55:00',3.2),('16273','2014-02-14','11:00:00',3.21),('16273','2014-02-14','11:05:00',3.21),('16273','2014-02-14','11:10:00',3.18),('16273','2014-02-14','11:15:00',3.27),('16273','2014-02-14','11:20:00',3.25),('16273','2014-02-14','11:25:00',3.25),('16273','2014-02-14','11:30:00',3.23),('16273','2014-02-14','11:35:00',3.24),('16273','2014-02-14','11:40:00',3.24),('16273','2014-02-14','11:45:00',3.23),('16273','2014-02-14','11:50:00',3.22),('16273','2014-02-14','11:55:00',3.22),('16273','2014-02-14','12:00:00',3.14),('16273','2014-02-14','12:05:00',3.09),('16273','2014-02-14','12:10:00',3.21),('16273','2014-02-14','12:15:00',3.19),('16273','2014-02-14','12:20:00',3.2),('16273','2014-02-14','12:25:00',3.17),('16273','2014-02-14','12:30:00',3.14),('16273','2014-02-14','12:35:00',3.14),('16273','2014-02-14','12:40:00',3.09),('16273','2014-02-14','12:45:00',3.06),('16273','2014-02-14','12:50:00',3.03),('16273','2014-02-14','12:55:00',2.98),('16273','2014-02-14','13:00:00',2.98),('16273','2014-02-14','13:05:00',2.92),('16273','2014-02-14','13:10:00',2.91),('16273','2014-02-14','13:15:00',2.9),('16273','2014-02-14','13:20:00',2.82),('16273','2014-02-14','13:25:00',2.78),('16273','2014-02-14','13:30:00',2.79),('16273','2014-02-14','13:35:00',2.73),('16273','2014-02-14','13:40:00',2.67),('16273','2014-02-14','13:45:00',2.64),('16273','2014-02-14','13:50:00',2.59),('16273','2014-02-14','13:55:00',2.57),('16273','2014-02-14','14:00:00',2.52),('16273','2014-02-14','14:05:00',2.46),('16273','2014-02-14','14:10:00',2.39),('16273','2014-02-14','14:15:00',2.34),('16273','2014-02-14','14:20:00',2.28),('16273','2014-02-14','14:25:00',2.21),('16273','2014-02-14','14:30:00',2.15),('16273','2014-02-14','14:35:00',2.09),('16273','2014-02-14','14:40:00',2.01),('16273','2014-02-14','14:45:00',1.94),('16273','2014-02-14','14:50:00',1.88),('16273','2014-02-14','14:55:00',1.81),('16273','2014-02-14','15:00:00',1.75),('16273','2014-02-14','15:05:00',1.67),('16273','2014-02-14','15:10:00',1.6),('16273','2014-02-14','15:15:00',1.54),('16273','2014-02-14','15:20:00',1.47),('16273','2014-02-14','15:25:00',1.4),('16273','2014-02-14','15:30:00',1.32),('16273','2014-02-14','15:35:00',1.25),('16273','2014-02-14','15:40:00',1.19),('16273','2014-02-14','15:45:00',1.12),('16273','2014-02-14','15:50:00',1.06),('16273','2014-02-14','15:55:00',1.01),('16273','2014-02-13','08:10:00',1.03),('16273','2014-02-13','08:15:00',1.2),('16273','2014-02-13','08:20:00',1.3),('16273','2014-02-13','08:25:00',1.18),('16273','2014-02-13','08:30:00',1.55),('16273','2014-02-13','08:35:00',1.64),('16273','2014-02-13','08:40:00',1.75),('16273','2014-02-13','08:45:00',1.84),('16273','2014-02-13','08:50:00',1.91),('16273','2014-02-13','08:55:00',1.98),('16273','2014-02-13','09:00:00',2.05),('16273','2014-02-13','09:05:00',2.14),('16273','2014-02-13','09:10:00',2.2),('16273','2014-02-13','09:15:00',2.3),('16273','2014-02-13','09:20:00',2.36),('16273','2014-02-13','09:25:00',2.4),('16273','2014-02-13','09:30:00',2.42),('16273','2014-02-13','09:35:00',2.53),('16273','2014-02-13','09:40:00',2.58),('16273','2014-02-13','09:45:00',2.62),('16273','2014-02-13','09:50:00',2.66),('16273','2014-02-13','09:55:00',2.7),('16273','2014-02-13','10:00:00',2.72),('16273','2014-02-13','10:05:00',2.76),('16273','2014-02-13','10:10:00',2.8),('16273','2014-02-13','10:15:00',2.82),('16273','2014-02-13','10:20:00',2.87),('16273','2014-02-13','10:25:00',2.92),('16273','2014-02-13','10:30:00',2.95),('16273','2014-02-13','10:35:00',2.99),('16273','2014-02-13','10:40:00',3),('16273','2014-02-13','10:45:00',3.01),('16273','2014-02-13','10:50:00',3.04),('16273','2014-02-13','10:55:00',3.04),('16273','2014-02-13','11:00:00',2.89),('16273','2014-02-13','11:05:00',2.1),('16273','2014-02-13','11:10:00',3.26),('16273','2014-02-13','11:15:00',3.26),('16273','2014-02-13','11:20:00',3.38),('16273','2014-02-13','11:25:00',3.31),('16273','2014-02-13','11:30:00',3.43),('16273','2014-02-13','11:35:00',3.06),('16273','2014-02-13','11:40:00',3.31),('16273','2014-02-13','11:45:00',3.15),('16273','2014-02-13','11:50:00',3.17),('16273','2014-02-13','11:55:00',3.22),('16273','2014-02-13','12:00:00',3.27),('16273','2014-02-13','12:05:00',3.42),('16273','2014-02-13','12:10:00',3.47),('16273','2014-02-13','12:15:00',3.38),('16273','2014-02-13','12:20:00',3.29),('16273','2014-02-13','12:25:00',3.06),('16273','2014-02-13','12:30:00',3.2),('16273','2014-02-13','12:35:00',2.18),('16273','2014-02-13','12:40:00',3.11),('16273','2014-02-13','12:45:00',3.21),('16273','2014-02-13','12:50:00',2.17),('16273','2014-02-13','12:55:00',3.17),('16273','2014-02-13','13:00:00',3.05),('16273','2014-02-13','13:05:00',3.01),('16273','2014-02-13','13:10:00',2.96),('16273','2014-02-13','13:15:00',2.92),('16273','2014-02-13','13:20:00',2.88),('16273','2014-02-13','13:25:00',2.84),('16273','2014-02-13','13:30:00',2.81),('16273','2014-02-13','13:35:00',2.76),('16273','2014-02-13','13:40:00',2.7),('16273','2014-02-13','13:45:00',2.67),('16273','2014-02-13','13:50:00',2.61),('16273','2014-02-13','13:55:00',2.57),('16273','2014-02-13','14:00:00',2.52),('16273','2014-02-13','14:05:00',2.48),('16273','2014-02-13','14:10:00',2.41),('16273','2014-02-13','14:15:00',2.32),('16273','2014-02-13','14:20:00',2.3),('16273','2014-02-13','14:25:00',2.26),('16273','2014-02-13','14:30:00',2.32),('16273','2014-02-13','14:35:00',2.31),('16273','2014-02-13','14:40:00',2.27),('16273','2014-02-13','14:45:00',1.86),('16273','2014-02-13','14:50:00',1.1),('16273','2014-02-13','14:55:00',1.71),('16273','2014-02-13','15:00:00',1.94),('16273','2014-02-13','15:05:00',1.83),('16273','2014-02-13','15:10:00',1.73),('16273','2014-02-13','15:15:00',1.65),('16273','2014-02-13','15:20:00',1.36),('16273','2014-02-13','15:25:00',1.4),('16273','2014-02-13','15:30:00',1.41),('16273','2014-02-13','15:35:00',1.26),('16273','2014-02-13','15:40:00',1.32),('16273','2014-02-13','15:50:00',1.15),('16273','2014-02-13','15:55:00',1.07),('16273','2014-02-13','16:00:00',1.01),('16273','2014-02-12','08:35:00',1.63),('16273','2014-02-12','08:40:00',1.78),('16273','2014-02-12','08:45:00',1.86),('16273','2014-02-12','08:50:00',1.95),('16273','2014-02-12','08:55:00',2.03),('16273','2014-02-12','09:00:00',2.11),('16273','2014-02-12','09:05:00',2.13),('16273','2014-02-12','09:10:00',2.28),('16273','2014-02-12','09:15:00',2.37),('16273','2014-02-12','09:20:00',2.49),('16273','2014-02-12','09:25:00',1.99),('16273','2014-02-12','09:30:00',1.25),('16273','2014-02-12','09:35:00',1.66),('16273','2014-02-12','09:40:00',1.65),('16273','2014-02-12','09:45:00',1.05),('16273','2014-02-12','09:50:00',2.1),('16273','2014-02-12','09:55:00',2.95),('16273','2014-02-12','10:00:00',1.56),('16273','2014-02-12','10:05:00',1.24),('16273','2014-02-12','10:10:00',1.12),('16273','2014-02-12','10:15:00',1.06),('16273','2014-02-12','10:20:00',1.1),('16273','2014-02-12','10:25:00',1.03),('16273','2014-02-12','10:30:00',1.2),('16273','2014-02-12','10:35:00',1.15),('16273','2014-02-12','10:40:00',1.15),('16273','2014-02-12','10:45:00',1.03),('16273','2014-02-12','11:00:00',1.02),('16273','2014-02-12','11:05:00',1.16),('16273','2014-02-12','11:10:00',2.92),('16273','2014-02-12','11:15:00',2.39),('16273','2014-02-12','11:20:00',1.1),('16273','2014-02-12','11:25:00',1.19),('16273','2014-02-12','11:30:00',1.78),('16273','2014-02-12','11:35:00',3.2),('16273','2014-02-12','11:40:00',3.53),('16273','2014-02-12','11:45:00',1.83),('16273','2014-02-12','11:50:00',1.48),('16273','2014-02-12','11:55:00',1.51),('16273','2014-02-12','12:00:00',1.34),('16273','2014-02-12','12:10:00',1.11),('16273','2014-02-12','12:15:00',1.22),('16273','2014-02-12','12:20:00',1.23),('16273','2014-02-12','12:25:00',1.27),('16273','2014-02-12','12:30:00',1.3),('16273','2014-02-12','12:35:00',1.37),('16273','2014-02-12','12:40:00',1.46),('16273','2014-02-12','12:45:00',1.56),('16273','2014-02-12','12:50:00',1.5),('16273','2014-02-12','12:55:00',1.51),('16273','2014-02-12','13:00:00',1.62),('16273','2014-02-12','13:05:00',1.56),('16273','2014-02-12','13:10:00',1.71),('16273','2014-02-12','13:15:00',1.55),('16273','2014-02-12','13:20:00',1.59),('16273','2014-02-12','13:25:00',1.91),('16273','2014-02-12','13:30:00',1.37),('16273','2014-02-12','13:35:00',1.28),('16273','2014-02-12','13:40:00',1.3),('16273','2014-02-12','13:45:00',1.3),('16273','2014-02-12','13:50:00',1.36),('16273','2014-02-12','13:55:00',1.76),('16273','2014-02-12','14:00:00',2.01),('16273','2014-02-12','14:05:00',2.32),('16273','2014-02-12','14:10:00',1.69),('16273','2014-02-12','14:15:00',1.47),('16273','2014-02-12','14:20:00',1.89),('16273','2014-02-12','14:25:00',2.6),('16273','2014-02-12','14:30:00',2.53),('16273','2014-02-12','14:35:00',2.28),('16273','2014-02-12','14:40:00',2.14),('16273','2014-02-12','14:45:00',2.03),('16273','2014-02-12','14:50:00',1.95),('16273','2014-02-12','14:55:00',1.91),('16273','2014-02-12','15:00:00',1.9),('16273','2014-02-12','15:05:00',1.91),('16273','2014-02-12','15:10:00',1.53),('16273','2014-02-12','15:15:00',1.13),('16273','2014-02-12','15:20:00',1.4),('16273','2014-02-12','15:25:00',1.49),('16273','2014-02-12','15:30:00',1.83),('16273','2014-02-12','15:35:00',1.64),('16273','2014-02-12','15:40:00',1.31),('16273','2014-02-12','15:45:00',1.52),('16273','2014-02-12','15:50:00',1.42),('16273','2014-02-12','16:10:00',1.22),('16273','2014-02-11','09:25:00',1.22),('16273','2014-02-11','09:30:00',1.17),('16273','2014-02-11','09:40:00',1.09),('16273','2014-02-11','09:45:00',1.26),('16273','2014-02-11','09:50:00',1.26),('16273','2014-02-11','09:55:00',1.02),('16273','2014-02-11','10:15:00',1.52),('16273','2014-02-11','10:20:00',1.66),('16273','2014-02-11','10:25:00',1.98),('16273','2014-02-11','10:30:00',1.85),('16273','2014-02-11','10:35:00',1.89),('16273','2014-02-11','10:40:00',1.77),('16273','2014-02-11','10:45:00',1.68),('16273','2014-02-11','10:50:00',1.93),('16273','2014-02-11','10:55:00',1.76),('16273','2014-02-11','11:00:00',1.82),('16273','2014-02-11','11:05:00',2.36),('16273','2014-02-11','11:10:00',2.09),('16273','2014-02-11','11:15:00',2.19),('16273','2014-02-11','11:20:00',1.83),('16273','2014-02-11','11:25:00',1.55),('16273','2014-02-11','11:30:00',1.84),('16273','2014-02-11','11:35:00',2.41),('16273','2014-02-11','11:40:00',2.37),('16273','2014-02-11','11:45:00',2.45),('16273','2014-02-11','11:50:00',2.31),('16273','2014-02-11','11:55:00',1.52),('16273','2014-02-11','12:00:00',1.43),('16273','2014-02-11','12:05:00',1.75),('16273','2014-02-11','12:10:00',2.22),('16273','2014-02-11','12:15:00',1.58),('16273','2014-02-11','12:20:00',1.26),('16273','2014-02-11','12:25:00',1.79),('16273','2014-02-11','12:30:00',1.97),('16273','2014-02-11','12:35:00',2.12),('16273','2014-02-11','12:40:00',1.42),('16273','2014-02-11','12:45:00',1.82),('16273','2014-02-11','12:50:00',2.05),('16273','2014-02-11','12:55:00',1.66),('16273','2014-02-11','13:00:00',2.32),('16273','2014-02-11','13:05:00',1.78),('16273','2014-02-11','13:10:00',2.87),('16273','2014-02-11','13:15:00',2.86),('16273','2014-02-11','13:20:00',2.65),('16273','2014-02-11','13:25:00',2.32),('16273','2014-02-11','13:30:00',2.21),('16273','2014-02-11','13:35:00',2.26),('16273','2014-02-11','13:40:00',2.32),('16273','2014-02-11','13:45:00',1.69),('16273','2014-02-11','13:50:00',1.81),('16273','2014-02-11','13:55:00',1.62),('16273','2014-02-11','14:00:00',1.09),('16273','2014-02-11','14:05:00',1.24),('16273','2014-02-11','14:10:00',1.52),('16273','2014-02-11','14:15:00',1.26),('16273','2014-02-11','14:20:00',1.3),('16273','2014-02-11','14:25:00',1.31),('16273','2014-02-11','14:30:00',1.14),('16273','2014-02-11','14:35:00',1.1),('16273','2014-02-11','15:05:00',1.04),('16273','2014-02-11','15:10:00',1.13),('16273','2014-02-11','15:15:00',1.21),('16273','2014-02-11','15:20:00',1.23),('16273','2014-02-10','12:55:00',1.01),('16273','2014-02-10','13:00:00',1.01),('16273','2014-02-09','12:05:00',2.66),('16273','2014-02-09','12:10:00',1.1),('16273','2014-02-09','12:15:00',1.21),('16273','2014-02-09','12:20:00',1.78),('16273','2014-02-09','12:25:00',2.78),('16273','2014-02-09','12:35:00',1.33),('16273','2014-02-09','12:40:00',1.53),('16273','2014-02-09','12:50:00',1.36),('16273','2014-02-09','12:55:00',2.4),('16273','2014-02-09','13:00:00',1.17),('16273','2014-02-09','13:05:00',1.06),('16273','2014-02-09','13:10:00',1.18),('16273','2014-02-09','13:15:00',1.44),('16273','2014-02-09','13:20:00',1.15),('16273','2014-02-09','13:30:00',1.1),('16273','2014-02-09','13:35:00',1.67),('16273','2014-02-09','13:40:00',2.7),('16273','2014-02-09','13:45:00',1.12),('16273','2014-02-09','13:50:00',2.39),('16273','2014-02-09','13:55:00',2.17),('16273','2014-02-09','14:00:00',2.02),('16273','2014-02-09','14:05:00',1.43),('16273','2014-02-09','14:10:00',1.12),('16273','2014-02-09','14:15:00',1.09),('16273','2014-02-09','14:20:00',1.49),('16273','2014-02-09','14:25:00',2.14),('16273','2014-02-09','14:30:00',1.86),('16273','2014-02-09','14:35:00',1.28),('16273','2014-02-09','14:40:00',1.36),('16273','2014-02-09','14:45:00',1.26),('16273','2014-02-09','14:50:00',1.44),('16273','2014-02-09','14:55:00',1.69),('16273','2014-02-09','15:00:00',1.53),('16273','2014-02-09','15:05:00',1.4),('16273','2014-02-09','15:10:00',1.25),('16273','2014-02-09','15:15:00',1.02),('16273','2014-02-09','15:20:00',1.08),('16273','2014-02-09','15:25:00',1.35),('16273','2014-02-09','15:30:00',1.23),('16273','2014-02-09','15:35:00',1.2),('16273','2014-02-09','15:40:00',1.09),('16273','2014-02-09','15:45:00',1.04),('16273','2014-02-08','09:35:00',1.2),('16273','2014-02-08','09:40:00',1.31),('16273','2014-02-08','09:45:00',1.29),('16273','2014-02-08','09:50:00',2.04),('16273','2014-02-08','09:55:00',2.42),('16273','2014-02-08','10:00:00',2.61),('16273','2014-02-08','10:05:00',2.73),('16273','2014-02-08','10:10:00',2.63),('16273','2014-02-08','10:15:00',2.27),('16273','2014-02-08','10:20:00',2.48),('16273','2014-02-08','10:25:00',1.85),('16273','2014-02-08','10:35:00',1.11),('16273','2014-02-08','10:40:00',1.57),('16273','2014-02-08','10:45:00',1.06),('16273','2014-02-08','10:50:00',1.78),('16273','2014-02-08','10:55:00',2.17),('16273','2014-02-08','11:00:00',1.66),('16273','2014-02-08','11:05:00',1.1),('16273','2014-02-08','11:10:00',3.62),('16273','2014-02-08','11:15:00',1.53),('16273','2014-02-08','11:30:00',1.27),('16273','2014-02-08','11:35:00',1.19),('16273','2014-02-08','11:50:00',2.89),('16273','2014-02-08','11:55:00',1.4),('16273','2014-02-08','12:00:00',1.08),('16273','2014-02-08','12:05:00',1.18),('16273','2014-02-08','12:10:00',1.34),('16273','2014-02-08','12:15:00',1.69),('16273','2014-02-08','12:20:00',1.05),('16273','2014-02-08','12:25:00',1.68),('16273','2014-02-08','12:30:00',2.13),('16273','2014-02-08','12:35:00',1.82),('16273','2014-02-08','12:40:00',2.14),('16273','2014-02-08','12:45:00',3.41),('16273','2014-02-08','12:50:00',2.47),('16273','2014-02-08','12:55:00',3.11),('16273','2014-02-08','13:00:00',2.99),('16273','2014-02-08','13:05:00',2.26),('16273','2014-02-08','13:10:00',2.71),('16273','2014-02-08','13:15:00',2.26),('16273','2014-02-08','13:20:00',1.99),('16273','2014-02-08','13:25:00',2.35),('16273','2014-02-08','13:30:00',2.3),('16273','2014-02-08','13:35:00',1.96),('16273','2014-02-08','13:40:00',1.85),('16273','2014-02-08','13:45:00',2.53),('16273','2014-02-08','13:50:00',2.52),('16273','2014-02-08','13:55:00',2.12),('16273','2014-02-08','14:00:00',2.6),('16273','2014-02-08','14:05:00',2.65),('16273','2014-02-08','14:10:00',2.6),('16273','2014-02-08','14:15:00',2.46),('16273','2014-02-08','14:20:00',2.46),('16273','2014-02-08','14:25:00',1.8),('16273','2014-02-08','14:30:00',1.13),('16273','2014-02-08','14:35:00',1.87),('16273','2014-02-08','14:40:00',1.08),('16273','2014-02-08','14:45:00',2.3),('16273','2014-02-08','14:50:00',2.16),('16273','2014-02-08','14:55:00',2.09),('16273','2014-02-08','15:00:00',1.99),('16273','2014-02-08','15:05:00',1.49),('16273','2014-02-08','15:10:00',1.89),('16273','2014-02-08','15:15:00',1.34),('16273','2014-02-08','15:30:00',1.23),('16273','2014-02-08','15:35:00',1.57),('16273','2014-02-08','15:40:00',1.16),('16273','2014-02-08','15:45:00',1.24),('16273','2014-02-07','08:15:00',1.01),('16273','2014-02-07','08:20:00',1.04),('16273','2014-02-07','08:25:00',1.22),('16273','2014-02-07','08:30:00',1.21),('16273','2014-02-07','08:35:00',1.36),('16273','2014-02-07','08:40:00',1.59),('16273','2014-02-07','08:45:00',1.7),('16273','2014-02-07','08:50:00',1.79),('16273','2014-02-07','08:55:00',1.86),('16273','2014-02-07','09:00:00',1.93),('16273','2014-02-07','09:05:00',2.02),('16273','2014-02-07','09:10:00',2.06),('16273','2014-02-07','09:15:00',2.12),('16273','2014-02-07','09:20:00',2.18),('16273','2014-02-07','09:25:00',2.24),('16273','2014-02-07','09:30:00',2.28),('16273','2014-02-07','09:35:00',2.29),('16273','2014-02-07','09:40:00',2.34),('16273','2014-02-07','09:45:00',2.36),('16273','2014-02-07','09:50:00',2.2),('16273','2014-02-07','09:55:00',2.3),('16273','2014-02-07','10:00:00',2.4),('16273','2014-02-07','10:05:00',2.68),('16273','2014-02-07','10:10:00',2.81),('16273','2014-02-07','10:15:00',2.84),('16273','2014-02-07','10:20:00',2.8),('16273','2014-02-07','10:25:00',1.91),('16273','2014-02-07','10:30:00',2.98),('16273','2014-02-07','10:35:00',2.98),('16273','2014-02-07','10:40:00',3.03),('16273','2014-02-07','10:45:00',3.15),('16273','2014-02-07','10:50:00',2.66),('16273','2014-02-07','10:55:00',3.12),('16273','2014-02-07','11:00:00',1.89),('16273','2014-02-07','11:05:00',1.37),('16273','2014-02-07','11:10:00',1.59),('16273','2014-02-07','11:15:00',2.38),('16273','2014-02-07','11:20:00',3.08),('16273','2014-02-07','11:25:00',2.44),('16273','2014-02-07','11:30:00',2.78),('16273','2014-02-07','11:35:00',1.91),('16273','2014-02-07','11:40:00',2.92),('16273','2014-02-07','11:45:00',1.82),('16273','2014-02-07','11:50:00',1.59),('16273','2014-02-07','11:55:00',3.56),('16273','2014-02-07','12:00:00',3.44),('16273','2014-02-07','12:05:00',1.12),('16273','2014-02-07','12:10:00',2.03),('16273','2014-02-07','12:15:00',1.56),('16273','2014-02-07','12:20:00',2.83),('16273','2014-02-07','12:25:00',3.24),('16273','2014-02-07','12:30:00',3.34),('16273','2014-02-07','12:35:00',1.08),('16273','2014-02-07','12:40:00',1.15),('16273','2014-02-07','12:45:00',3.32),('16273','2014-02-07','12:50:00',2.63),('16273','2014-02-07','12:55:00',3.33),('16273','2014-02-07','13:00:00',2.26),('16273','2014-02-07','13:05:00',3.3),('16273','2014-02-07','13:10:00',3.03),('16273','2014-02-07','13:15:00',1.76),('16273','2014-02-07','13:20:00',3.19),('16273','2014-02-07','13:25:00',2.87),('16273','2014-02-07','13:30:00',2.76),('16273','2014-02-07','13:35:00',2.69),('16273','2014-02-07','13:40:00',2.43),('16273','2014-02-07','13:45:00',2.6),('16273','2014-02-07','13:50:00',2.53),('16273','2014-02-07','13:55:00',2.48),('16273','2014-02-07','14:00:00',2.41),('16273','2014-02-07','14:05:00',2.38),('16273','2014-02-07','14:10:00',2.33),('16273','2014-02-07','14:15:00',2.26),('16273','2014-02-07','14:20:00',2.19),('16273','2014-02-07','14:25:00',2.13),('16273','2014-02-07','14:30:00',2.07),('16273','2014-02-07','14:35:00',1.7),('16273','2014-02-07','14:40:00',1.74),('16273','2014-02-07','14:45:00',1.9),('16273','2014-02-07','14:50:00',1.89),('16273','2014-02-07','14:55:00',1.48),('16273','2014-02-07','15:00:00',1.73),('16273','2014-02-07','15:05:00',1.68),('16273','2014-02-07','15:10:00',1.53),('16273','2014-02-07','15:15:00',1.44),('16273','2014-02-07','15:20:00',1.36),('16273','2014-02-07','15:25:00',1.29),('16273','2014-02-07','15:30:00',1.22),('16273','2014-02-07','15:35:00',1.16),('16273','2014-02-07','15:40:00',1.09),('16273','2014-02-07','15:45:00',1.04),('16273','2014-02-06','08:30:00',1.18),('16273','2014-02-06','08:35:00',1.16),('16273','2014-02-06','08:40:00',1.58),('16273','2014-02-06','08:45:00',1.71),('16273','2014-02-06','08:50:00',1.84),('16273','2014-02-06','08:55:00',2.01),('16273','2014-02-06','09:00:00',2.16),('16273','2014-02-06','09:05:00',2.3),('16273','2014-02-06','09:10:00',2.16),('16273','2014-02-06','09:15:00',2.02),('16273','2014-02-06','09:20:00',2.27),('16273','2014-02-06','09:25:00',2.35),('16273','2014-02-06','09:30:00',2.11),('16273','2014-02-06','09:35:00',2.37),('16273','2014-02-06','09:40:00',2.44),('16273','2014-02-06','09:45:00',2.46),('16273','2014-02-06','09:50:00',2.52),('16273','2014-02-06','09:55:00',2.6),('16273','2014-02-06','10:00:00',2.69),('16273','2014-02-06','10:05:00',2.69),('16273','2014-02-06','10:10:00',2.68),('16273','2014-02-06','10:15:00',2.72),('16273','2014-02-06','10:20:00',2.79),('16273','2014-02-06','10:25:00',2.84),('16273','2014-02-06','10:30:00',2.6),('16273','2014-02-06','10:35:00',2.76),('16273','2014-02-06','10:40:00',2.45),('16273','2014-02-06','10:45:00',2.44),('16273','2014-02-06','10:50:00',2.71),('16273','2014-02-06','10:55:00',1.67),('16273','2014-02-06','11:00:00',2.34),('16273','2014-02-06','11:05:00',3.15),('16273','2014-02-06','11:10:00',3.15),('16273','2014-02-06','11:15:00',3.17),('16273','2014-02-06','11:20:00',3.2),('16273','2014-02-06','11:25:00',3.32),('16273','2014-02-06','11:30:00',3.27),('16273','2014-02-06','11:35:00',3.14),('16273','2014-02-06','11:40:00',3.14),('16273','2014-02-06','11:45:00',3.12),('16273','2014-02-06','11:50:00',3.15),('16273','2014-02-06','11:55:00',3.12),('16273','2014-02-06','12:00:00',3.11),('16273','2014-02-06','12:05:00',3.13),('16273','2014-02-06','12:10:00',3.13),('16273','2014-02-06','12:15:00',3.1),('16273','2014-02-06','12:20:00',3.09),('16273','2014-02-06','12:25:00',3.07),('16273','2014-02-06','12:30:00',3.05),('16273','2014-02-06','12:35:00',3.03),('16273','2014-02-06','12:40:00',3.01),('16273','2014-02-06','12:45:00',2.99),('16273','2014-02-06','12:50:00',2.96),('16273','2014-02-06','12:55:00',2.93),('16273','2014-02-06','13:00:00',2.9),('16273','2014-02-06','13:05:00',2.86),('16273','2014-02-06','13:10:00',2.79),('16273','2014-02-06','13:15:00',2.82),('16273','2014-02-06','13:20:00',2.85),('16273','2014-02-06','13:25:00',2.77),('16273','2014-02-06','13:30:00',2.69),('16273','2014-02-06','13:35:00',2.67),('16273','2014-02-06','13:40:00',2.6),('16273','2014-02-06','13:45:00',2.45),('16273','2014-02-06','13:50:00',2.52),('16273','2014-02-06','13:55:00',1.77),('16273','2014-02-06','14:00:00',2.42),('16273','2014-02-06','14:05:00',2.27),('16273','2014-02-06','14:10:00',1.45),('16273','2014-02-06','14:15:00',1.99),('16273','2014-02-06','14:20:00',2.17),('16273','2014-02-06','14:25:00',2.09),('16273','2014-02-06','14:30:00',2.04),('16273','2014-02-06','14:35:00',1.96),('16273','2014-02-06','14:40:00',1.88),('16273','2014-02-06','14:45:00',1.8),('16273','2014-02-06','14:50:00',1.74),('16273','2014-02-06','14:55:00',1.67),('16273','2014-02-06','15:00:00',1.61),('16273','2014-02-06','15:05:00',1.53),('16273','2014-02-06','15:10:00',1.47),('16273','2014-02-06','15:15:00',1.4),('16273','2014-02-06','15:20:00',1.33),('16273','2014-02-06','15:25:00',1.26),('16273','2014-02-06','15:30:00',1.2),('16273','2014-02-06','15:35:00',1.14),('16273','2014-02-06','15:40:00',1.07),('16273','2014-02-06','15:45:00',1.03),('16273','2014-04-27','08:30:00',1.03),('16273','2014-04-27','10:00:00',1.03),('16273','2014-04-27','10:05:00',1.2),('16273','2014-04-27','10:10:00',1.11),('16273','2014-04-27','10:30:00',1.74),('16273','2014-04-27','10:35:00',1.88),('16273','2014-04-27','10:45:00',1.14),('16273','2014-04-27','10:50:00',1.52),('16273','2014-04-27','10:55:00',1.26),('16273','2014-04-27','11:00:00',1.42),('16273','2014-04-27','11:05:00',1.45),('16273','2014-04-27','11:10:00',1.1),('16273','2014-04-27','11:15:00',1.27),('16273','2014-04-27','11:20:00',1.74),('16273','2014-04-27','11:25:00',2),('16273','2014-04-27','11:30:00',1.96),('16273','2014-04-27','11:35:00',2.45),('16273','2014-04-27','11:40:00',1.94),('16273','2014-04-27','11:45:00',2.46),('16273','2014-04-27','11:50:00',1.95),('16273','2014-04-27','11:55:00',1.37),('16273','2014-04-27','12:00:00',1.79),('16273','2014-04-27','12:05:00',1.42),('16273','2014-04-27','12:10:00',1.58),('16273','2014-04-27','12:15:00',1.58),('16273','2014-04-27','12:20:00',2.42),('16273','2014-04-27','12:25:00',3.63),('16273','2014-04-27','12:30:00',2.86),('16273','2014-04-27','12:35:00',2.87),('16273','2014-04-27','12:40:00',2.88),('16273','2014-04-27','12:45:00',2.22),('16273','2014-04-27','12:50:00',2.4),('16273','2014-04-27','12:55:00',1.99),('16273','2014-04-27','13:00:00',1.93),('16273','2014-04-27','13:05:00',2.27),('16273','2014-04-27','13:10:00',2.3),('16273','2014-04-27','13:15:00',2.13),('16273','2014-04-27','13:20:00',2.22),('16273','2014-04-27','13:25:00',1.81),('16273','2014-04-27','13:30:00',1.32),('16273','2014-04-27','13:35:00',1.23),('16273','2014-04-27','13:40:00',1.41),('16273','2014-04-27','13:45:00',1.72),('16273','2014-04-27','13:50:00',1.81),('16273','2014-04-27','13:55:00',2.42),('16273','2014-04-27','14:00:00',1.78),('16273','2014-04-27','14:05:00',1.32),('16273','2014-04-27','14:10:00',1.26),('16273','2014-04-27','14:15:00',1.65),('16273','2014-04-27','14:20:00',1.78),('16273','2014-04-27','14:25:00',1.59),('16273','2014-04-27','14:30:00',1.9),('16273','2014-04-27','14:35:00',2.1),('16273','2014-04-27','14:40:00',2.24),('16273','2014-04-27','14:45:00',1.68),('16273','2014-04-27','14:50:00',1.67),('16273','2014-04-27','14:55:00',1.99),('16273','2014-04-27','15:00:00',2.28),('16273','2014-04-27','15:05:00',2.18),('16273','2014-04-27','15:10:00',2.11),('16273','2014-04-27','15:15:00',1.6),('16273','2014-04-27','15:20:00',1.03),('16273','2014-04-27','15:30:00',1.08),('16273','2014-04-27','15:35:00',1.07),('16273','2014-02-05','10:10:00',1.59),('16273','2014-02-05','10:15:00',1.47),('16273','2014-02-05','10:20:00',1.36),('16273','2014-02-05','10:25:00',1.48),('16273','2014-02-05','10:30:00',2.09),('16273','2014-02-05','10:35:00',2.99),('16273','2014-02-05','10:40:00',2.94),('16273','2014-02-05','10:45:00',2.46),('16273','2014-02-05','10:55:00',1.34),('16273','2014-02-05','11:00:00',1.49),('16273','2014-02-05','11:05:00',3.03),('16273','2014-02-05','11:10:00',2.5),('16273','2014-02-05','12:30:00',1.04),('16273','2014-02-05','12:35:00',1.08),('16273','2014-02-05','12:40:00',1.96),('16273','2014-02-05','12:45:00',1.85),('16273','2014-02-05','12:50:00',1.97),('16273','2014-02-05','12:55:00',2.34),('16273','2014-02-05','13:00:00',1.95),('16273','2014-02-05','13:05:00',1.43),('16273','2014-02-05','13:25:00',1.02),('16273','2014-02-05','13:30:00',1.12),('16273','2014-02-05','13:35:00',1.42),('16273','2014-02-05','13:40:00',1.54),('16273','2014-02-05','13:45:00',1.5),('16273','2014-02-05','13:50:00',1.02),('16273','2014-02-05','14:10:00',1.11),('16273','2014-02-05','14:15:00',1.6),('16273','2014-02-05','14:20:00',1.97),('16273','2014-02-05','14:25:00',1.87),('16273','2014-02-05','14:30:00',1.08),('16273','2014-02-05','14:35:00',1.24),('16273','2014-02-05','14:40:00',1.19),('16273','2014-02-05','14:45:00',1.05),('16273','2014-02-04','09:20:00',1.14),('16273','2014-02-04','09:25:00',1.42),('16273','2014-02-04','09:30:00',2.07),('16273','2014-02-04','09:35:00',2.04),('16273','2014-02-04','09:40:00',1.72),('16273','2014-02-04','09:45:00',2.09),('16273','2014-02-04','09:50:00',1.47),('16273','2014-02-04','09:55:00',2.39),('16273','2014-02-04','10:00:00',2.72),('16273','2014-02-04','10:05:00',2.83),('16273','2014-02-04','10:10:00',2.32),('16273','2014-02-04','10:15:00',1.09),('16273','2014-02-04','10:20:00',2.01),('16273','2014-02-04','10:25:00',3.07),('16273','2014-02-04','10:30:00',2.75),('16273','2014-02-04','10:35:00',2.61),('16273','2014-02-04','10:40:00',2.98),('16273','2014-02-04','10:45:00',2.76),('16273','2014-02-04','10:50:00',1.49),('16273','2014-02-04','10:55:00',1.51),('16273','2014-02-04','11:00:00',1.12),('16273','2014-02-04','11:05:00',1.96),('16273','2014-02-04','11:10:00',2.21),('16273','2014-02-04','11:15:00',3.84),('16273','2014-02-04','11:20:00',2.02),('16273','2014-02-04','11:25:00',2.1),('16273','2014-02-04','11:30:00',1.32),('16273','2014-02-04','11:35:00',1.1),('16273','2014-02-04','11:40:00',1.18),('16273','2014-02-04','11:45:00',1.08),('16273','2014-02-04','11:50:00',2.11),('16273','2014-02-04','11:55:00',1.24),('16273','2014-02-04','12:00:00',1.41),('16273','2014-02-04','12:30:00',1.09),('16273','2014-02-04','12:35:00',1.06),('16273','2014-02-04','12:40:00',1.13),('16273','2014-02-04','12:45:00',1.45),('16273','2014-02-04','12:50:00',1.49),('16273','2014-02-04','12:55:00',1.37),('16273','2014-02-04','13:00:00',1.46),('16273','2014-02-04','13:05:00',1.48),('16273','2014-02-04','13:10:00',1.18),('16273','2014-02-04','13:15:00',1.1),('16273','2014-02-04','13:20:00',1.02),('16273','2014-02-03','09:55:00',1.06),('16273','2014-02-03','10:15:00',1.16),('16273','2014-02-03','10:20:00',1.61),('16273','2014-02-03','10:25:00',1.24),('16273','2014-02-03','10:40:00',1.03),('16273','2014-02-03','10:45:00',1.03),('16273','2014-02-01','11:00:00',1.19),('16273','2014-02-01','11:05:00',1.24),('16273','2014-02-01','11:10:00',1.41),('16273','2014-02-01','11:15:00',1.92),('16273','2014-02-01','11:20:00',2.03),('16273','2014-02-01','11:25:00',2),('16273','2014-02-01','11:30:00',1.95),('16273','2014-02-01','11:35:00',2.12),('16273','2014-02-01','11:40:00',2.1),('16273','2014-02-01','11:45:00',1.9),('16273','2014-02-01','11:50:00',1.64),('16273','2014-02-01','11:55:00',1.66),('16273','2014-02-01','12:00:00',1.65),('16273','2014-02-01','12:05:00',1.7),('16273','2014-02-01','12:10:00',1.94),('16273','2014-02-01','12:15:00',1.12),('16273','2014-02-01','12:30:00',1.17),('16273','2014-02-01','12:35:00',2.35),('16273','2014-02-01','12:40:00',1.55),('16273','2014-02-01','12:45:00',2.04),('16273','2014-02-01','12:50:00',1.94),('16273','2014-02-01','13:35:00',1.01),('16273','2014-01-31','10:30:00',1.23),('16273','2014-01-30','09:50:00',1.28),('16273','2014-01-30','09:55:00',1.72),('16273','2014-01-30','10:00:00',1.73),('16273','2014-01-30','10:05:00',1.73),('16273','2014-01-30','10:10:00',1.62),('16273','2014-01-30','10:15:00',1.29),('16273','2014-01-30','10:20:00',1.17),('16273','2014-01-30','10:25:00',1.57),('16273','2014-01-30','10:30:00',1.76),('16273','2014-01-30','10:35:00',2.54),('16273','2014-01-30','10:40:00',1.78),('16273','2014-01-30','10:45:00',2.47),('16273','2014-01-30','10:50:00',1.89),('16273','2014-01-30','10:55:00',1.43),('16273','2014-01-30','11:00:00',1.97),('16273','2014-01-30','11:05:00',3.05),('16273','2014-01-30','11:10:00',3.36),('16273','2014-01-30','11:15:00',3.23),('16273','2014-01-30','11:20:00',3.19),('16273','2014-01-30','11:25:00',2.94),('16273','2014-01-30','11:30:00',2.33),('16273','2014-01-30','11:35:00',2.23),('16273','2014-01-30','11:40:00',2.96),('16273','2014-01-30','11:45:00',3.01),('16273','2014-01-30','11:50:00',2.88),('16273','2014-01-30','11:55:00',2.79),('16273','2014-01-30','12:00:00',2.79),('16273','2014-01-30','12:05:00',2.61),('16273','2014-01-30','12:10:00',2.32),('16273','2014-01-30','12:15:00',2.47),('16273','2014-01-30','12:20:00',2.36),('16273','2014-01-30','12:25:00',2.29),('16273','2014-01-30','12:30:00',2.54),('16273','2014-01-30','12:35:00',2.8),('16273','2014-01-30','12:40:00',2.66),('16273','2014-01-30','12:45:00',2.67),('16273','2014-01-30','12:50:00',2.69),('16273','2014-01-30','12:55:00',2.61),('16273','2014-01-30','13:00:00',2.5),('16273','2014-01-30','13:05:00',2.61),('16273','2014-01-30','13:10:00',2.62),('16273','2014-01-30','13:15:00',2.58),('16273','2014-01-30','13:20:00',2.44),('16273','2014-01-30','13:25:00',1.95),('16273','2014-01-30','13:30:00',1.86),('16273','2014-01-30','13:35:00',1.79),('16273','2014-01-30','13:40:00',2.31),('16273','2014-01-30','13:45:00',2.55),('16273','2014-01-30','13:50:00',2.39),('16273','2014-01-30','13:55:00',1.98),('16273','2014-01-30','14:00:00',1.7),('16273','2014-01-30','14:05:00',1.76),('16273','2014-01-30','14:10:00',1.8),('16273','2014-01-30','14:15:00',1.48),('16273','2014-01-30','14:20:00',1.33),('16273','2014-01-30','14:25:00',1.44),('16273','2014-01-30','14:30:00',1.53),('16273','2014-01-30','14:35:00',1.25),('16273','2014-01-30','14:40:00',1.68),('16273','2014-01-30','14:45:00',1.83),('16273','2014-01-30','14:50:00',1.71),('16273','2014-01-30','14:55:00',1.59),('16273','2014-01-30','15:00:00',1.41),('16273','2014-01-30','15:05:00',1.34),('16273','2014-01-30','15:10:00',1.34),('16273','2014-01-30','15:15:00',1.32),('16273','2014-01-30','15:20:00',1.31),('16273','2014-01-30','15:25:00',1.19),('16273','2014-01-30','15:30:00',1.12),('16273','2014-01-30','15:35:00',1.07),('16273','2014-01-29','09:15:00',2.19),('16273','2014-01-29','09:20:00',1.57),('16273','2014-01-29','09:25:00',1.29),('16273','2014-01-29','09:30:00',1.37),('16273','2014-01-29','09:35:00',1.38),('16273','2014-01-29','09:40:00',1.57),('16273','2014-01-29','09:45:00',1.22),('16273','2014-01-29','10:00:00',1.25),('16273','2014-01-29','10:05:00',1.79),('16273','2014-01-29','10:10:00',1.75),('16273','2014-01-29','10:15:00',2.01),('16273','2014-01-29','10:20:00',2.82),('16273','2014-01-29','10:25:00',3.24),('16273','2014-01-29','10:30:00',2.77),('16273','2014-01-29','10:35:00',2.39),('16273','2014-01-29','10:40:00',1.61),('16273','2014-01-29','10:45:00',1.62),('16273','2014-01-29','10:50:00',1.6),('16273','2014-01-29','10:55:00',1.83),('16273','2014-01-29','11:00:00',2.2),('16273','2014-01-29','11:05:00',1.92),('16273','2014-01-29','11:10:00',1.99),('16273','2014-01-29','11:15:00',2.33),('16273','2014-01-29','11:20:00',2.38),('16273','2014-01-29','11:25:00',1.77),('16273','2014-01-29','11:30:00',1.99),('16273','2014-01-29','11:35:00',2.34),('16273','2014-01-29','11:40:00',1.53),('16273','2014-01-29','12:55:00',1.82),('16273','2014-01-29','13:00:00',1.81),('16273','2014-01-29','13:25:00',1.69),('16273','2014-01-29','13:30:00',2.54),('16273','2014-01-29','13:35:00',2.04),('16273','2014-01-29','13:40:00',2.71),('16273','2014-01-29','13:45:00',1.69),('16273','2014-01-29','13:50:00',2.23),('16273','2014-01-29','13:55:00',1.41),('16273','2014-01-29','15:15:00',1.06),('16273','2014-01-28','09:15:00',1.17),('16273','2014-01-28','09:20:00',1.43),('16273','2014-01-28','09:25:00',1.51),('16273','2014-01-28','09:30:00',1.33),('16273','2014-01-28','09:35:00',1.31),('16273','2014-01-28','09:40:00',1.53),('16273','2014-01-28','09:45:00',2.06),('16273','2014-01-28','09:50:00',2.12),('16273','2014-01-28','09:55:00',2.35),('16273','2014-01-28','10:00:00',2.62),('16273','2014-01-28','10:05:00',2.63),('16273','2014-01-28','10:10:00',2.61),('16273','2014-01-28','10:15:00',2.67),('16273','2014-01-28','10:20:00',2.76),('16273','2014-01-28','10:25:00',2.77),('16273','2014-01-28','10:30:00',2.8),('16273','2014-01-28','10:35:00',2.82),('16273','2014-01-28','10:40:00',2.94),('16273','2014-01-28','10:45:00',1.54),('16273','2014-01-28','10:50:00',2.12),('16273','2014-01-28','10:55:00',2.51),('16273','2014-01-28','11:00:00',1.55),('16273','2014-01-28','11:05:00',1.59),('16273','2014-01-28','11:10:00',2.44),('16273','2014-01-28','11:15:00',1.88),('16273','2014-01-28','11:20:00',2.24),('16273','2014-01-28','11:25:00',1.61),('16273','2014-01-28','11:30:00',3.51),('16273','2014-01-28','11:35:00',1.92),('16273','2014-01-28','11:40:00',2.47),('16273','2014-01-28','11:45:00',2.95),('16273','2014-01-28','11:50:00',2.3),('16273','2014-01-28','11:55:00',3.1),('16273','2014-01-28','12:00:00',1.81),('16273','2014-01-28','12:05:00',1.94),('16273','2014-01-28','12:10:00',1.48),('16273','2014-01-28','12:15:00',1.18),('16273','2014-01-28','12:20:00',1.11),('16273','2014-01-28','12:25:00',1.16),('16273','2014-01-28','12:30:00',1.48),('16273','2014-01-28','12:35:00',1.64),('16273','2014-01-28','12:40:00',3.08),('16273','2014-01-28','12:45:00',3.09),('16273','2014-01-28','12:50:00',1.94),('16273','2014-01-28','12:55:00',2.99),('16273','2014-01-28','13:00:00',2.46),('16273','2014-01-28','13:05:00',2.48),('16273','2014-01-28','13:10:00',2.76),('16273','2014-01-28','13:15:00',2.9),('16273','2014-01-28','13:20:00',2.43),('16273','2014-01-28','13:25:00',2.45),('16273','2014-01-28','13:30:00',2.76),('16273','2014-01-28','13:35:00',2.66),('16273','2014-01-28','13:40:00',2.54),('16273','2014-01-28','13:45:00',2.46),('16273','2014-01-28','13:50:00',2.39),('16273','2014-01-28','13:55:00',2.32),('16273','2014-01-28','14:00:00',2.26),('16273','2014-01-28','14:05:00',2.22),('16273','2014-01-28','14:10:00',2.16),('16273','2014-01-28','14:15:00',2.09),('16273','2014-01-28','14:20:00',2.02),('16273','2014-01-28','14:25:00',1.98),('16273','2014-01-28','14:30:00',1.91),('16273','2014-01-28','14:35:00',1.84),('16273','2014-01-28','14:40:00',1.76),('16273','2014-01-28','14:45:00',1.7),('16273','2014-01-28','14:50:00',1.62),('16273','2014-01-28','14:55:00',1.56),('16273','2014-01-28','15:00:00',1.48),('16273','2014-01-28','15:05:00',1.41),('16273','2014-01-28','15:10:00',1.33),('16273','2014-01-28','15:15:00',1.26),('16273','2014-01-28','15:20:00',1.2),('16273','2014-01-28','15:25:00',1.13),('16273','2014-01-28','15:30:00',1.07),('325','2014-05-05','08:25:00',1.04),('325','2014-05-05','08:30:00',1.09),('325','2014-05-05','08:35:00',1.14),('325','2014-05-05','08:40:00',1.19),('325','2014-05-05','08:45:00',1.24),('325','2014-05-05','08:50:00',1.31),('325','2014-05-05','08:55:00',1.36),('325','2014-05-05','09:00:00',1.41),('325','2014-05-05','09:05:00',1.54),('325','2014-05-05','09:10:00',2.33),('325','2014-05-05','09:15:00',2.4),('325','2014-05-05','09:20:00',2.52),('325','2014-05-05','09:25:00',2.59),('325','2014-05-05','09:30:00',2.76),('325','2014-05-05','09:35:00',2.83),('325','2014-05-05','09:40:00',2.92),('325','2014-05-05','09:45:00',3.02),('325','2014-05-05','09:50:00',3.2),('325','2014-05-05','09:55:00',3.31),('325','2014-05-05','10:00:00',3.38),('325','2014-05-05','10:05:00',3.48),('325','2014-05-05','10:10:00',3.58),('325','2014-05-05','10:15:00',3.64),('325','2014-05-05','10:20:00',3.66),('325','2014-05-05','10:25:00',3.75),('325','2014-05-05','10:30:00',3.83),('325','2014-05-05','10:35:00',3.9),('325','2014-05-05','10:40:00',3.97),('325','2014-05-05','10:45:00',4.04),('325','2014-05-05','10:50:00',4.08),('325','2014-05-05','10:55:00',4.12),('325','2014-05-05','11:00:00',4.17),('325','2014-05-05','11:05:00',4.21),('325','2014-05-05','11:10:00',4.13),('325','2014-05-05','11:15:00',4.37),('325','2014-05-05','11:20:00',4.34),('325','2014-05-05','11:25:00',4.38),('325','2014-05-05','11:30:00',4.42),('325','2014-05-05','11:35:00',4.41),('325','2014-05-05','11:40:00',4.44),('325','2014-05-05','11:45:00',4.54),('325','2014-05-05','11:50:00',4.59),('325','2014-05-05','11:55:00',4.06),('325','2014-05-05','12:00:00',4.56),('325','2014-05-05','12:05:00',4.41),('325','2014-05-05','12:10:00',2.1),('325','2014-05-05','12:15:00',3.39),('325','2014-05-05','12:20:00',2.66),('325','2014-05-05','12:25:00',2.72),('325','2014-05-05','12:30:00',4.96),('325','2014-05-05','12:35:00',3.9),('325','2014-05-05','12:40:00',1.56),('325','2014-05-05','12:45:00',2.16),('325','2014-05-05','12:50:00',4.66),('325','2014-05-05','12:55:00',2.42),('325','2014-05-05','13:00:00',1.73),('325','2014-05-05','13:05:00',3.07),('325','2014-05-05','13:10:00',5.25),('325','2014-05-05','13:15:00',5.08),('325','2014-05-05','13:20:00',4.94),('325','2014-05-05','13:25:00',4.85),('325','2014-05-05','13:30:00',4.83),('325','2014-05-05','13:35:00',4.82),('325','2014-05-05','13:40:00',4.82),('325','2014-05-05','13:45:00',4.85),('325','2014-05-05','13:50:00',4.84),('325','2014-05-05','13:55:00',4.82),('325','2014-05-05','14:00:00',4.71),('325','2014-05-05','14:05:00',4.11),('325','2014-05-05','14:10:00',2.98),('325','2014-05-05','14:15:00',4.96),('325','2014-05-05','14:20:00',5.25),('325','2014-05-05','14:25:00',5.13),('325','2014-05-05','14:30:00',4.16),('325','2014-05-05','14:35:00',2.97),('325','2014-05-05','14:40:00',2.36),('325','2014-05-05','14:45:00',1.65),('325','2014-05-05','14:50:00',1.58),('325','2014-05-05','14:55:00',1.76),('325','2014-05-05','15:00:00',2.55),('325','2014-05-05','15:05:00',4.64),('325','2014-05-05','15:10:00',3.26),('325','2014-05-05','15:15:00',1.45),('325','2014-05-05','15:20:00',1.44),('325','2014-05-05','15:25:00',1.77),('325','2014-05-05','15:30:00',4.12),('325','2014-05-05','15:35:00',3.06),('325','2014-05-05','15:40:00',1.42),('325','2014-05-05','15:45:00',3.65),('325','2014-05-05','15:50:00',1.59),('325','2014-05-05','15:55:00',1.24),('325','2014-05-05','16:00:00',2.58),('325','2014-05-05','16:05:00',1.94),('325','2014-05-05','16:10:00',2.21),('325','2014-05-05','16:15:00',1.4),('325','2014-05-05','16:20:00',1.64),('325','2014-05-05','16:25:00',1.83),('325','2014-05-05','16:30:00',1.78),('325','2014-05-05','16:35:00',3.62),('325','2014-05-05','16:40:00',3.32),('325','2014-05-05','16:45:00',3.07),('325','2014-05-05','16:50:00',2.95),('325','2014-05-05','16:55:00',2.71),('325','2014-05-05','17:00:00',2.52),('325','2014-05-05','17:05:00',2.47),('325','2014-05-05','17:10:00',2.43),('325','2014-05-05','17:15:00',2.33),('325','2014-05-05','17:20:00',2.24),('325','2014-05-05','17:25:00',2.12),('325','2014-05-05','17:30:00',2.08),('325','2014-05-05','17:35:00',1.92),('325','2014-05-05','17:40:00',1.86),('325','2014-05-05','17:45:00',1.78),('325','2014-05-05','17:50:00',1.67),('325','2014-05-05','17:55:00',1.58),('325','2014-05-05','18:00:00',1.47),('325','2014-05-05','18:05:00',1.39),('325','2014-05-05','18:10:00',1.31),('325','2014-05-05','18:15:00',1.2),('325','2014-05-05','18:20:00',1.09),('325','2014-05-04','08:20:00',1),('325','2014-05-04','08:25:00',1.01),('325','2014-05-04','08:30:00',1.08),('325','2014-05-04','08:35:00',1.31),('325','2014-05-04','08:40:00',1.13),('325','2014-05-04','08:45:00',1.01),('325','2014-05-04','08:50:00',1.07),('325','2014-05-04','08:55:00',1.03),('325','2014-05-04','09:00:00',1.21),('325','2014-05-04','09:05:00',1.77),('325','2014-05-04','09:10:00',1.85),('325','2014-05-04','09:15:00',1.94),('325','2014-05-04','09:20:00',2.47),('325','2014-05-04','09:25:00',3.27),('325','2014-05-04','09:30:00',1.94),('325','2014-05-04','09:35:00',1.2),('325','2014-05-04','09:40:00',1.36),('325','2014-05-04','09:45:00',2.28),('325','2014-05-04','09:50:00',2.64),('325','2014-05-04','09:55:00',1.98),('325','2014-05-04','10:00:00',3.68),('325','2014-05-04','10:05:00',3.92),('325','2014-05-04','10:10:00',2.42),('325','2014-05-04','10:15:00',2.55),('325','2014-05-04','10:20:00',1.94),('325','2014-05-04','10:25:00',1.97),('325','2014-05-04','10:30:00',2.21),('325','2014-05-04','10:35:00',2.18),('325','2014-05-04','10:40:00',2.42),('325','2014-05-04','10:45:00',3.02),('325','2014-05-04','10:50:00',2.64),('325','2014-05-04','10:55:00',2.61),('325','2014-05-04','11:00:00',2.55),('325','2014-05-04','11:05:00',2.75),('325','2014-05-04','11:10:00',4.39),('325','2014-05-04','11:15:00',3.9),('325','2014-05-04','11:20:00',4.69),('325','2014-05-04','11:25:00',4.57),('325','2014-05-04','11:30:00',4.2),('325','2014-05-04','11:35:00',3.94),('325','2014-05-04','11:40:00',3.07),('325','2014-05-04','11:45:00',3.96),('325','2014-05-04','11:50:00',3.58),('325','2014-05-04','11:55:00',4.57),('325','2014-05-04','12:00:00',2.45),('325','2014-05-04','12:05:00',2.39),('325','2014-05-04','12:10:00',1.91),('325','2014-05-04','12:15:00',1.8),('325','2014-05-04','12:20:00',1.65),('325','2014-05-04','12:25:00',1.78),('325','2014-05-04','12:30:00',3.48),('325','2014-05-04','12:35:00',5.66),('325','2014-05-04','12:40:00',4.88),('325','2014-05-04','12:45:00',2.42),('325','2014-05-04','12:50:00',1.84),('325','2014-05-04','12:55:00',1.91),('325','2014-05-04','13:00:00',2.16),('325','2014-05-04','13:05:00',1.64),('325','2014-05-04','13:10:00',1.73),('325','2014-05-04','13:15:00',1.73),('325','2014-05-04','13:20:00',1.61),('325','2014-05-04','13:25:00',1.74),('325','2014-05-04','13:30:00',1.61),('325','2014-05-04','13:35:00',1.55),('325','2014-05-04','13:40:00',1.55),('325','2014-05-04','13:45:00',1.37),('325','2014-05-04','13:50:00',1.28),('325','2014-05-04','13:55:00',1.34),('325','2014-05-04','14:00:00',1.35),('325','2014-05-04','14:05:00',1.38),('325','2014-05-04','14:10:00',1.37),('325','2014-05-04','14:15:00',1.28),('325','2014-05-04','14:50:00',1.12),('325','2014-05-04','14:55:00',1.77),('325','2014-05-04','15:00:00',2.04),('325','2014-05-04','15:05:00',2.31),('325','2014-05-04','15:10:00',3.07),('325','2014-05-04','15:15:00',2.38),('325','2014-05-04','15:20:00',2.22),('325','2014-05-04','15:25:00',1.78),('325','2014-05-04','15:30:00',1.53),('325','2014-05-04','15:50:00',1.15),('325','2014-05-04','15:55:00',1.22),('325','2014-05-04','16:00:00',1.13),('325','2014-05-04','16:05:00',1.18),('325','2014-05-04','16:10:00',1.37),('325','2014-05-04','16:15:00',1.29),('325','2014-05-04','16:20:00',1.09),('325','2014-05-04','17:35:00',1.05),('325','2014-05-04','17:40:00',1.08),('325','2014-04-25','08:30:00',1.04),('325','2014-04-25','08:35:00',1.07),('325','2014-04-25','08:40:00',1.13),('325','2014-04-25','08:45:00',1.24),('325','2014-04-25','08:50:00',1.44),('325','2014-04-25','08:55:00',1.53),('325','2014-04-25','09:00:00',1.07),('325','2014-04-25','09:05:00',1.11),('325','2014-04-25','09:25:00',1.46),('325','2014-04-25','09:30:00',1.11),('325','2014-04-25','09:35:00',1.03),('325','2014-04-25','09:55:00',1.09),('325','2014-04-25','10:00:00',1.27),('325','2014-04-25','10:05:00',1.27),('325','2014-04-25','10:10:00',1.38),('325','2014-04-25','10:15:00',1.26),('325','2014-04-25','10:20:00',1.46),('325','2014-04-25','10:25:00',1.48),('325','2014-04-25','10:30:00',3.12),('325','2014-04-25','10:35:00',3.58),('325','2014-04-25','10:40:00',2.98),('325','2014-04-25','10:45:00',3.03),('325','2014-04-25','10:50:00',1.74),('325','2014-04-25','10:55:00',3.4),('325','2014-04-25','11:00:00',2.39),('325','2014-04-25','11:05:00',2.56),('325','2014-04-25','11:10:00',4.31),('325','2014-04-25','11:15:00',4.42),('325','2014-04-25','11:20:00',4.27),('325','2014-04-25','11:25:00',4.19),('325','2014-04-25','11:30:00',2.98),('325','2014-04-25','11:35:00',4.29),('325','2014-04-25','11:40:00',1.98),('325','2014-04-25','11:45:00',1.41),('325','2014-04-25','11:50:00',2.11),('325','2014-04-25','11:55:00',4.36),('325','2014-04-25','12:00:00',2.82),('325','2014-04-25','12:05:00',5.15),('325','2014-04-25','12:10:00',3.17),('325','2014-04-25','12:15:00',1.72),('325','2014-04-25','12:20:00',2.7),('325','2014-04-25','12:25:00',4.48),('325','2014-04-25','12:30:00',4.81),('325','2014-04-25','12:35:00',4.87),('325','2014-04-25','12:40:00',4.96),('325','2014-04-25','12:45:00',4.97),('325','2014-04-25','12:50:00',2),('325','2014-04-25','12:55:00',2.28),('325','2014-04-25','13:00:00',2.57),('325','2014-04-25','13:05:00',2.98),('325','2014-04-25','13:10:00',3.85),('325','2014-04-25','13:15:00',2.22),('325','2014-04-25','13:20:00',2.39),('325','2014-04-25','13:25:00',2.79),('325','2014-04-25','13:30:00',1.45),('325','2014-04-25','13:35:00',1.16),('325','2014-04-25','13:40:00',1.79),('325','2014-04-25','13:45:00',1.32),('325','2014-04-25','13:50:00',2.84),('325','2014-04-25','13:55:00',2.3),('325','2014-04-25','14:00:00',1.49),('325','2014-04-25','14:05:00',1.58),('325','2014-04-25','14:10:00',1.23),('325','2014-04-25','14:15:00',1.52),('325','2014-04-25','14:20:00',4.22),('325','2014-04-25','14:25:00',2.26),('325','2014-04-25','14:30:00',2.49),('325','2014-04-25','14:35:00',4.52),('325','2014-04-25','14:40:00',4.44),('325','2014-04-25','14:45:00',4.3),('325','2014-04-25','14:50:00',4.23),('325','2014-04-25','14:55:00',4.2),('325','2014-04-25','15:00:00',4.14),('325','2014-04-25','15:05:00',4.11),('325','2014-04-25','15:10:00',4.07),('325','2014-04-25','15:15:00',4.03),('325','2014-04-25','15:20:00',3.82),('325','2014-04-25','15:25:00',3.84),('325','2014-04-25','15:30:00',3.73),('325','2014-04-25','15:35:00',3.79),('325','2014-04-25','15:40:00',3.73),('325','2014-04-25','15:45:00',3.63),('325','2014-04-25','15:50:00',3.59),('325','2014-04-25','15:55:00',3.52),('325','2014-04-25','16:00:00',3.47),('325','2014-04-25','16:05:00',3.37),('325','2014-04-25','16:10:00',3.25),('325','2014-04-25','16:15:00',3.07),('325','2014-04-25','16:20:00',2.88),('325','2014-04-25','16:25:00',2.97),('325','2014-04-25','16:30:00',3.02),('325','2014-04-25','16:35:00',3.03),('325','2014-04-25','16:40:00',3.02),('325','2014-04-25','16:45:00',2.85),('325','2014-04-25','16:50:00',2.53),('325','2014-04-25','16:55:00',2.16),('325','2014-04-25','17:00:00',2.18),('325','2014-04-25','17:05:00',2.36),('325','2014-04-25','17:10:00',1.98),('325','2014-04-25','17:15:00',2.03),('325','2014-04-25','17:20:00',1.39),('325','2014-04-25','17:25:00',1.08),('325','2014-04-25','17:30:00',1.14),('325','2014-04-25','17:35:00',1.14),('325','2014-04-25','17:40:00',1.09),('325','2014-01-25','09:05:00',1.25),('325','2014-01-25','09:10:00',1.1),('325','2014-01-25','09:20:00',1.04),('325','2014-01-25','09:50:00',1.39),('325','2014-01-25','09:55:00',1.61),('325','2014-01-25','10:00:00',1.18),('325','2014-01-25','10:05:00',1.94),('325','2014-01-25','10:10:00',2.25),('325','2014-01-25','10:15:00',3.1),('325','2014-01-25','10:20:00',3.06),('325','2014-01-25','10:25:00',1.97),('325','2014-01-25','10:30:00',1.87),('325','2014-01-25','10:35:00',1.68),('325','2014-01-25','10:40:00',2.19),('325','2014-01-25','10:45:00',1.81),('325','2014-01-25','10:50:00',2.41),('325','2014-01-25','10:55:00',2.08),('325','2014-01-25','11:00:00',1.3),('325','2014-01-25','11:05:00',1.21),('325','2014-01-25','11:10:00',1.11),('325','2014-01-25','11:15:00',1.13),('325','2014-01-25','11:20:00',1.2),('325','2014-01-25','11:25:00',1.85),('325','2014-01-25','11:30:00',4.01),('325','2014-01-25','11:35:00',4.5),('325','2014-01-25','11:40:00',1.88),('325','2014-01-25','11:45:00',1.39),('325','2014-01-25','11:50:00',1.61),('325','2014-01-25','11:55:00',1.73),('325','2014-01-25','12:00:00',1.68),('325','2014-01-25','12:05:00',1.89),('325','2014-01-25','12:10:00',2.03),('325','2014-01-25','12:15:00',1.87),('325','2014-01-25','12:20:00',2.06),('325','2014-01-25','12:25:00',2.25),('325','2014-01-25','12:30:00',2.12),('325','2014-01-25','12:35:00',1.85),('325','2014-01-25','12:40:00',2),('325','2014-01-25','12:45:00',2.43),('325','2014-01-25','12:50:00',2.47),('325','2014-01-25','12:55:00',3.05),('325','2014-01-25','13:00:00',3.17),('325','2014-01-25','13:05:00',2.99),('325','2014-01-25','13:10:00',3.53),('325','2014-01-25','13:15:00',2.74),('325','2014-01-25','13:20:00',1.59),('325','2014-01-25','13:25:00',2.18),('325','2014-01-25','13:30:00',1.83),('325','2014-01-25','13:35:00',2.32),('325','2014-01-25','13:40:00',1.16),('325','2014-01-25','13:45:00',1.52),('325','2014-01-25','13:50:00',1.51),('325','2014-01-25','14:00:00',1.61),('325','2014-01-25','14:05:00',1.96),('325','2014-01-25','14:10:00',2.86),('325','2014-01-25','14:15:00',2.65),('325','2014-01-25','14:20:00',2.87),('325','2014-01-25','14:25:00',2.9),('325','2014-01-25','14:30:00',3.11),('325','2014-01-25','14:35:00',3.2),('325','2014-01-25','14:40:00',2.9),('325','2014-01-25','14:45:00',3.07),('325','2014-01-25','14:50:00',2.85),('325','2014-01-25','14:55:00',2.67),('325','2014-01-25','15:00:00',2.41),('325','2014-01-25','15:05:00',2.26),('325','2014-01-25','15:10:00',2.14),('325','2014-01-25','15:15:00',2.03),('325','2014-01-25','15:20:00',1.9),('325','2014-01-25','15:25:00',1.8),('325','2014-01-25','15:30:00',1.7),('325','2014-01-25','15:35:00',1.58),('325','2014-01-25','15:40:00',1.48),('325','2014-01-25','15:45:00',1.39),('325','2014-01-25','15:50:00',1.29),('325','2014-01-25','15:55:00',1.2),('325','2014-01-25','16:00:00',1.11),('325','2014-01-25','16:05:00',1),('325','2014-01-24','10:05:00',1.02),('325','2014-01-24','10:10:00',1.11),('325','2014-01-24','10:15:00',2.08),('325','2014-01-24','10:25:00',1.46),('325','2014-01-24','10:30:00',1.97),('325','2014-01-24','10:35:00',1.73),('325','2014-01-24','10:40:00',2.8),('325','2014-01-24','10:45:00',2.31),('325','2014-01-24','10:50:00',1.38),('325','2014-01-24','10:55:00',1.09),('325','2014-01-24','11:00:00',1.16),('325','2014-01-24','11:25:00',1.21),('325','2014-01-24','11:30:00',1.7),('325','2014-01-24','11:35:00',1.49),('325','2014-01-24','11:45:00',2.19),('325','2014-01-24','11:50:00',3.71),('325','2014-01-24','11:55:00',3.13),('325','2014-01-24','12:00:00',2.04),('325','2014-01-24','12:05:00',1.83),('325','2014-01-24','12:10:00',1.24),('325','2014-01-24','12:25:00',2.29),('325','2014-01-24','12:30:00',1.51),('325','2014-01-24','12:35:00',3.24),('325','2014-01-24','12:40:00',3.43),('325','2014-01-24','12:45:00',1.66),('325','2014-01-24','12:50:00',1.28),('325','2014-01-24','12:55:00',1.97),('325','2014-01-24','13:00:00',1.87),('325','2014-01-24','13:05:00',2.29),('325','2014-01-24','13:10:00',1.31),('325','2014-01-24','13:30:00',1.28),('325','2014-01-24','13:35:00',1.94),('325','2014-01-24','13:40:00',1.7),('325','2014-01-24','13:45:00',1.2),('325','2014-01-24','13:50:00',1.22),('325','2014-01-24','13:55:00',1.77),('325','2014-01-24','14:00:00',1.41),('325','2014-01-24','14:10:00',3.53),('325','2014-01-24','14:15:00',3.32),('325','2014-01-24','14:20:00',2.9),('325','2014-01-24','14:25:00',2.41),('325','2014-01-24','14:35:00',1.02),('325','2014-01-24','14:40:00',1.15),('325','2014-01-24','14:45:00',1.22),('325','2014-01-23','11:00:00',1.12),('325','2014-01-23','11:05:00',1.11),('325','2014-01-23','11:10:00',1.08),('325','2014-01-23','11:15:00',1.07),('325','2014-01-23','11:20:00',1.02),('325','2014-01-23','12:30:00',1.05),('325','2014-01-22','11:10:00',1.02),('325','2014-01-22','13:10:00',1.1),('325','2014-01-22','13:15:00',1.52),('325','2014-01-22','13:20:00',1.02),('325','2014-01-22','16:05:00',1.27),('325','2014-01-22','16:10:00',1.28),('325','2014-01-21','10:00:00',1.22),('325','2014-01-21','10:05:00',1.18),('325','2014-01-21','10:55:00',1.69),('325','2014-01-21','11:00:00',2.42),('325','2014-01-21','11:50:00',1.09),('325','2014-01-21','12:00:00',1.08),('325','2014-01-21','12:05:00',1.93),('325','2014-01-21','12:10:00',1.96),('325','2014-01-21','12:15:00',1.37),('325','2014-01-21','12:20:00',1.2),('325','2014-01-21','12:25:00',1.52),('325','2014-01-21','12:30:00',1.84),('325','2014-01-21','12:35:00',1.61),('325','2014-01-21','12:40:00',1.38),('325','2014-01-21','12:45:00',1.28),('325','2014-01-21','12:50:00',2.06),('325','2014-01-21','13:20:00',1.06),('325','2014-01-21','14:00:00',1.19),('325','2014-01-21','14:05:00',1.43),('325','2014-01-21','14:10:00',1.25),('325','2014-01-21','14:15:00',1.02),('325','2014-01-21','15:35:00',1.09),('325','2014-01-20','11:15:00',1.06),('325','2014-01-20','11:20:00',1.85),('325','2014-01-20','11:25:00',2.19),('325','2014-01-20','11:30:00',2.2),('325','2014-01-20','11:35:00',2.26),('325','2014-01-20','11:40:00',3.31),('325','2014-01-20','11:45:00',3.59),('325','2014-01-20','11:50:00',1.92),('325','2014-01-20','11:55:00',1),('325','2014-01-20','12:00:00',1.08),('325','2014-01-20','12:05:00',1.19),('325','2014-01-20','12:30:00',1.09),('325','2014-01-20','13:15:00',1.03),('325','2014-01-20','13:20:00',4.36),('325','2014-01-20','13:25:00',3.99),('325','2014-01-20','13:30:00',3.66),('325','2014-01-20','13:35:00',3.46),('325','2014-01-20','13:40:00',2.92),('325','2014-01-20','13:45:00',2.61),('325','2014-01-20','13:50:00',1.13),('325','2014-01-20','13:55:00',1.61),('325','2014-01-20','14:00:00',3.43),('325','2014-01-20','14:05:00',1.8),('325','2014-01-20','14:10:00',1.33),('325','2014-01-19','11:55:00',1.05),('325','2014-01-19','12:00:00',1.06),('325','2014-01-19','12:05:00',1.11),('325','2014-01-19','12:10:00',1.03),('325','2014-01-19','13:05:00',1.07),('325','2014-01-19','13:10:00',1.18),('325','2014-01-19','14:20:00',1.58),('325','2014-01-19','14:25:00',1.83),('325','2014-01-19','14:30:00',2.2),('325','2014-01-19','14:35:00',1.25),('325','2014-01-19','14:40:00',1.02),('325','2014-01-18','09:55:00',1),('325','2014-01-18','10:00:00',1.25),('325','2014-01-18','10:05:00',1.67),('325','2014-01-18','10:10:00',1.95),('325','2014-01-18','10:15:00',2.8),('325','2014-01-18','10:20:00',2.2),('325','2014-01-18','10:25:00',1.77),('325','2014-01-18','10:30:00',1.83),('325','2014-01-18','10:35:00',1.2),('325','2014-01-18','10:40:00',1.25),('325','2014-01-18','10:45:00',1.4),('325','2014-01-18','10:50:00',1.36),('325','2014-01-18','10:55:00',1.17),('325','2014-01-18','11:05:00',1.61),('325','2014-01-18','11:10:00',3.04),('325','2014-01-18','11:15:00',3.35),('325','2014-01-18','11:20:00',3.2),('325','2014-01-18','11:25:00',3.07),('325','2014-01-18','11:30:00',3.12),('325','2014-01-18','11:35:00',3.18),('325','2014-01-18','11:40:00',3.31),('325','2014-01-18','11:45:00',3.55),('325','2014-01-18','11:50:00',3.32),('325','2014-01-18','11:55:00',3.62),('325','2014-01-18','12:00:00',3.6),('325','2014-01-18','12:05:00',2.89),('325','2014-01-18','12:10:00',3.4),('325','2014-01-18','12:15:00',3.23),('325','2014-01-18','12:20:00',3.25),('325','2014-01-18','12:25:00',3.23),('325','2014-01-18','12:30:00',3.28),('325','2014-01-18','12:35:00',3.27),('325','2014-01-18','12:40:00',3.33),('325','2014-01-18','12:45:00',3.24),('325','2014-01-18','12:50:00',2.87),('325','2014-01-18','12:55:00',3.4),('325','2014-01-18','13:00:00',2.41),('325','2014-01-18','13:05:00',2.04),('325','2014-01-18','13:10:00',2.76),('325','2014-01-18','13:15:00',3.31),('325','2014-01-18','13:20:00',2.23),('325','2014-01-18','13:25:00',1.69),('325','2014-01-18','13:30:00',2.9),('325','2014-01-18','13:35:00',1.97),('325','2014-01-18','13:40:00',2.68),('325','2014-01-18','13:45:00',3.05),('325','2014-01-18','13:50:00',2.39),('325','2014-01-18','13:55:00',2.98),('325','2014-01-18','14:00:00',2.9),('325','2014-01-18','14:05:00',2.76),('325','2014-01-18','14:10:00',2.6),('325','2014-01-18','14:15:00',2.48),('325','2014-01-18','14:20:00',2.57),('325','2014-01-18','14:25:00',2.45),('325','2014-01-18','14:30:00',2.36),('325','2014-01-18','14:35:00',2.29),('325','2014-01-18','14:40:00',2.22),('325','2014-01-18','14:45:00',2.15),('325','2014-01-18','14:50:00',2.07),('325','2014-01-18','14:55:00',1.35),('325','2014-01-18','15:55:00',1.02),('325','2014-01-17','09:25:00',1.03),('325','2014-01-17','09:30:00',1.13),('325','2014-01-17','09:35:00',1.23),('325','2014-01-17','09:40:00',1.34),('325','2014-01-17','09:45:00',1.44),('325','2014-01-17','11:25:00',1.21),('325','2014-01-17','11:30:00',1.89),('325','2014-01-17','11:35:00',2.49),('325','2014-01-17','11:40:00',1.93),('325','2014-01-17','11:55:00',1.3),('325','2014-01-17','12:00:00',1.62),('325','2014-01-17','12:05:00',1.69),('325','2014-01-17','12:10:00',1.22),('325','2014-01-17','12:40:00',1.04),('325','2014-01-17','12:45:00',1.19),('325','2014-01-16','09:20:00',1.14),('325','2014-01-16','09:25:00',1.26),('325','2014-01-16','09:30:00',1.36),('325','2014-01-16','09:35:00',1.46),('325','2014-01-16','09:40:00',1.6),('325','2014-01-16','09:45:00',1.51),('325','2014-01-16','09:50:00',1.25),('325','2014-01-16','09:55:00',1.05),('325','2014-01-16','10:05:00',1.03),('325','2014-01-16','10:10:00',1.16),('325','2014-01-16','10:15:00',1.46),('325','2014-01-16','10:20:00',1.39),('325','2014-01-16','10:25:00',1.65),('325','2014-01-16','10:30:00',2.41),('325','2014-01-16','10:35:00',3.09),('325','2014-01-16','10:40:00',2.62),('325','2014-01-16','10:45:00',1.99),('325','2014-01-16','10:50:00',2.19),('325','2014-01-16','10:55:00',2.41),('325','2014-01-16','11:00:00',2.43),('325','2014-01-16','11:05:00',2.44),('325','2014-01-16','11:10:00',2.54),('325','2014-01-16','11:15:00',2.41),('325','2014-01-16','11:20:00',2.19),('325','2014-01-16','11:25:00',2.25),('325','2014-01-16','11:30:00',2.04),('325','2014-01-16','11:35:00',1.95),('325','2014-01-16','11:40:00',1.9),('325','2014-01-16','11:45:00',1.94),('325','2014-01-16','11:50:00',1.46),('325','2014-01-16','11:55:00',1.59),('325','2014-01-16','12:00:00',1.68),('325','2014-01-16','12:05:00',1.76),('325','2014-01-16','12:10:00',2.05),('325','2014-01-16','12:15:00',1.87),('325','2014-01-16','12:20:00',1.69),('325','2014-01-16','12:25:00',1.6),('325','2014-01-16','12:30:00',1.76),('325','2014-01-16','12:35:00',2.16),('325','2014-01-16','12:40:00',2.18),('325','2014-01-16','12:45:00',2.23),('325','2014-01-16','12:50:00',2.46),('325','2014-01-16','12:55:00',2.47),('325','2014-01-16','13:00:00',2.61),('325','2014-01-16','13:05:00',2.38),('325','2014-01-16','13:10:00',2.67),('325','2014-01-16','13:15:00',2.47),('325','2014-01-16','13:20:00',2.25),('325','2014-01-16','13:25:00',2.08),('325','2014-01-16','13:30:00',1.23),('325','2014-01-16','13:35:00',1.11),('325','2014-01-16','13:40:00',1.87),('325','2014-01-16','13:45:00',2.54),('325','2014-01-16','13:50:00',2.31),('325','2014-01-16','13:55:00',2.05),('325','2014-01-16','14:00:00',1.17),('325','2014-01-16','14:05:00',1.15),('325','2014-01-16','14:10:00',1.05),('325','2014-01-16','14:25:00',1.02),('325','2014-01-16','14:30:00',1.04),('325','2014-01-16','15:05:00',1.07),('325','2014-01-16','15:10:00',1.04),('325','2014-04-24','08:35:00',1.01),('325','2014-04-24','08:40:00',1.05),('325','2014-04-24','08:45:00',1.1),('325','2014-04-24','08:50:00',1.15),('325','2014-04-24','08:55:00',1.19),('325','2014-04-24','09:00:00',1.39),('325','2014-04-24','09:05:00',1.93),('325','2014-04-24','09:10:00',2.08),('325','2014-04-24','09:15:00',2.19),('325','2014-04-24','09:20:00',2.32),('325','2014-04-24','09:25:00',2.43),('325','2014-04-24','09:30:00',2.52),('325','2014-04-24','09:35:00',2.67),('325','2014-04-24','09:40:00',2.79),('325','2014-04-24','09:45:00',2.88),('325','2014-04-24','09:50:00',3),('325','2014-04-24','09:55:00',3.05),('325','2014-04-24','10:00:00',3.11),('325','2014-04-24','10:05:00',3.04),('325','2014-04-24','10:10:00',3.1),('325','2014-04-24','10:15:00',3.29),('325','2014-04-24','10:20:00',3.36),('325','2014-04-24','10:25:00',3.44),('325','2014-04-24','10:30:00',3.51),('325','2014-04-24','10:35:00',3.58),('325','2014-04-24','10:40:00',3.62),('325','2014-04-24','10:45:00',3.74),('325','2014-04-24','10:50:00',3.83),('325','2014-04-24','10:55:00',3.85),('325','2014-04-24','11:00:00',3.8),('325','2014-04-24','11:05:00',3.9),('325','2014-04-24','11:10:00',3.95),('325','2014-04-24','11:15:00',3.99),('325','2014-04-24','11:20:00',4.02),('325','2014-04-24','11:25:00',4.04),('325','2014-04-24','11:30:00',4.05),('325','2014-04-24','11:35:00',4.08),('325','2014-04-24','11:40:00',4.13),('325','2014-04-24','11:45:00',4.19),('325','2014-04-24','11:50:00',4.23),('325','2014-04-24','11:55:00',4.23),('325','2014-04-24','12:00:00',4.27),('325','2014-04-24','12:05:00',4.38),('325','2014-04-24','12:10:00',4.35),('325','2014-04-24','12:15:00',4.47),('325','2014-04-24','12:20:00',4.43),('325','2014-04-24','12:25:00',4.46),('325','2014-04-24','12:30:00',4.53),('325','2014-04-24','12:35:00',4.49),('325','2014-04-24','12:40:00',4.49),('325','2014-04-24','12:45:00',4.48),('325','2014-04-24','12:50:00',4.47),('325','2014-04-24','12:55:00',4.53),('325','2014-04-24','13:00:00',4.53),('325','2014-04-24','13:05:00',4.46),('325','2014-04-24','13:10:00',4.56),('325','2014-04-24','13:15:00',4.63),('325','2014-04-24','13:20:00',4.56),('325','2014-04-24','13:25:00',4.58),('325','2014-04-24','13:30:00',3.55),('325','2014-04-24','13:35:00',1.08),('325','2014-04-24','13:40:00',2.43),('325','2014-04-24','13:45:00',3.26),('325','2014-04-24','13:50:00',4.27),('325','2014-04-24','13:55:00',4.79),('325','2014-04-24','14:00:00',4.68),('325','2014-04-24','14:05:00',5.01),('325','2014-04-24','14:10:00',4.25),('325','2014-04-24','14:15:00',4.21),('325','2014-04-24','14:20:00',4.74),('325','2014-04-24','14:25:00',4.77),('325','2014-04-24','14:30:00',3.86),('325','2014-04-24','14:35:00',3.77),('325','2014-04-24','14:40:00',3.22),('325','2014-04-24','14:45:00',2.37),('325','2014-04-24','14:50:00',2.6),('325','2014-04-24','14:55:00',5.12),('325','2014-04-24','15:00:00',4.73),('325','2014-04-24','15:05:00',4.65),('325','2014-04-24','15:10:00',4.87),('325','2014-04-24','15:15:00',4.57),('325','2014-04-24','15:20:00',3.08),('325','2014-04-24','15:25:00',2.29),('325','2014-04-24','15:30:00',2.84),('325','2014-04-24','15:35:00',2.73),('325','2014-04-24','15:40:00',2.59),('325','2014-04-24','15:45:00',2.41),('325','2014-04-24','15:50:00',2.64),('325','2014-04-24','15:55:00',3.21),('325','2014-04-24','16:00:00',4.21),('325','2014-04-24','16:05:00',3.85),('325','2014-04-24','16:10:00',3.2),('325','2014-04-24','16:15:00',3.98),('325','2014-04-24','16:20:00',3.49),('325','2014-04-24','16:25:00',2.65),('325','2014-04-24','16:30:00',2.83),('325','2014-04-24','16:35:00',2.04),('325','2014-04-24','16:40:00',2.07),('325','2014-04-24','16:45:00',1.65),('325','2014-04-24','16:50:00',1.43),('325','2014-04-24','16:55:00',1.38),('325','2014-04-24','17:00:00',1.42),('325','2014-04-24','17:05:00',1.31),('325','2014-04-24','17:10:00',1.23),('325','2014-04-24','17:15:00',1.11),('325','2014-04-24','17:20:00',1.1),('325','2014-04-24','17:25:00',1.1),('325','2014-04-24','17:30:00',1.12),('325','2014-04-24','17:35:00',1.01),('325','2014-01-15','10:15:00',1.85),('325','2014-01-15','10:20:00',2.48),('325','2014-01-15','10:25:00',2.71),('325','2014-01-15','10:30:00',2.44),('325','2014-01-15','10:35:00',1.88),('325','2014-01-15','10:40:00',2.4),('325','2014-01-15','10:45:00',1.71),('325','2014-01-15','10:50:00',1.27),('325','2014-01-15','10:55:00',1.2),('325','2014-01-15','11:00:00',1.73),('325','2014-01-15','11:05:00',2.21),('325','2014-01-15','11:10:00',2.93),('325','2014-01-15','11:15:00',3.08),('325','2014-01-15','11:20:00',2.9),('325','2014-01-15','11:25:00',2.7),('325','2014-01-15','11:30:00',2.09),('325','2014-01-15','11:35:00',1.22),('325','2014-01-15','11:40:00',2.46),('325','2014-01-15','11:45:00',2.56),('325','2014-01-15','11:50:00',2.72),('325','2014-01-15','11:55:00',2.4),('325','2014-01-15','12:00:00',2.27),('325','2014-01-15','12:05:00',1.88),('325','2014-01-15','12:10:00',1.79),('325','2014-01-15','12:15:00',2.12),('325','2014-01-15','12:20:00',2.82),('325','2014-01-15','12:25:00',2.15),('325','2014-01-15','12:30:00',1.6),('325','2014-01-15','12:35:00',1.85),('325','2014-01-15','12:40:00',1.62),('325','2014-01-15','12:45:00',1.79),('325','2014-01-15','12:50:00',1.82),('325','2014-01-15','12:55:00',1.53),('325','2014-01-15','13:00:00',1.51),('325','2014-01-15','13:05:00',1.67),('325','2014-01-15','13:10:00',2.54),('325','2014-01-15','13:15:00',3.51),('325','2014-01-15','13:20:00',3.47),('325','2014-01-15','13:25:00',3.3),('325','2014-01-15','13:30:00',3.17),('325','2014-01-15','13:35:00',2.7),('325','2014-01-15','13:40:00',2.69),('325','2014-01-15','13:45:00',2.9),('325','2014-01-15','13:50:00',2.14),('325','2014-01-15','13:55:00',1.59),('325','2014-01-15','14:00:00',2.64),('325','2014-01-15','14:05:00',2.62),('325','2014-01-15','14:10:00',2.56),('325','2014-01-15','14:15:00',2.48),('325','2014-01-15','14:20:00',2.46),('325','2014-01-15','14:25:00',2.4),('325','2014-01-15','14:30:00',2.37),('325','2014-01-15','14:35:00',2.34),('325','2014-01-15','14:40:00',2.36),('325','2014-01-15','14:45:00',2.33),('325','2014-01-15','14:50:00',2.18),('325','2014-01-15','14:55:00',2.09),('325','2014-01-15','15:00:00',2.02),('325','2014-01-15','15:05:00',1.93),('325','2014-01-15','15:10:00',1.86),('325','2014-01-15','15:15:00',1.74),('325','2014-01-15','15:20:00',1.44),('325','2014-01-15','15:25:00',1.5),('325','2014-01-15','15:30:00',1.37),('325','2014-01-15','15:35:00',1.34),('325','2014-01-15','15:40:00',1.25),('325','2014-01-15','15:45:00',1.15),('325','2014-01-14','10:25:00',1.97),('325','2014-01-14','10:30:00',3.22),('325','2014-01-14','10:35:00',3.27),('325','2014-01-14','10:40:00',2.8),('325','2014-01-14','10:45:00',2.55),('325','2014-01-14','10:50:00',1.48),('325','2014-01-14','10:55:00',1.31),('325','2014-01-14','11:00:00',1.69),('325','2014-01-14','11:05:00',1.18),('325','2014-01-14','11:20:00',1.01),('325','2014-01-14','11:30:00',1.04),('325','2014-01-14','11:35:00',1.21),('325','2014-01-14','11:40:00',1.34),('325','2014-01-13','09:10:00',1.04),('325','2014-01-13','09:15:00',1.02),('325','2014-01-13','09:20:00',1.03),('325','2014-01-13','09:25:00',1.04),('325','2014-01-13','09:30:00',1.07),('325','2014-01-13','09:35:00',1.12),('325','2014-01-13','09:40:00',1.16),('325','2014-01-13','09:45:00',1.19),('325','2014-01-13','09:50:00',1.23),('325','2014-01-13','09:55:00',1.26),('325','2014-01-13','10:00:00',1.3),('325','2014-01-13','10:05:00',1.32),('325','2014-01-13','10:10:00',1.49),('325','2014-01-13','10:15:00',2.15),('325','2014-01-13','10:20:00',2.33),('325','2014-01-13','10:25:00',2.38),('325','2014-01-13','10:30:00',2.46),('325','2014-01-13','10:35:00',2.51),('325','2014-01-13','10:40:00',2.56),('325','2014-01-13','10:45:00',2.6),('325','2014-01-13','10:50:00',2.62),('325','2014-01-13','10:55:00',2.66),('325','2014-01-13','11:00:00',2.71),('325','2014-01-13','11:05:00',2.73),('325','2014-01-13','11:10:00',2.76),('325','2014-01-13','11:15:00',2.81),('325','2014-01-13','11:20:00',2.84),('325','2014-01-13','11:25:00',2.88),('325','2014-01-13','11:30:00',2.9),('325','2014-01-13','11:35:00',2.92),('325','2014-01-13','11:40:00',2.92),('325','2014-01-13','11:45:00',2.93),('325','2014-01-13','11:50:00',2.92),('325','2014-01-13','11:55:00',2.94),('325','2014-01-13','12:00:00',2.91),('325','2014-01-13','12:05:00',2.85),('325','2014-01-13','12:10:00',2.87),('325','2014-01-13','12:15:00',2.89),('325','2014-01-13','12:20:00',2.92),('325','2014-01-13','12:25:00',2.92),('325','2014-01-13','12:30:00',2.95),('325','2014-01-13','12:35:00',2.88),('325','2014-01-13','12:40:00',2.86),('325','2014-01-13','12:45:00',2.87),('325','2014-01-13','12:50:00',2.75),('325','2014-01-13','12:55:00',2.67),('325','2014-01-13','13:00:00',2.67),('325','2014-01-13','13:05:00',2.71),('325','2014-01-13','13:10:00',2.65),('325','2014-01-13','13:15:00',2.64),('325','2014-01-13','13:20:00',2.66),('325','2014-01-13','13:25:00',2.65),('325','2014-01-13','13:30:00',2.55),('325','2014-01-13','13:35:00',2.51),('325','2014-01-13','13:40:00',2.45),('325','2014-01-13','13:45:00',2.44),('325','2014-01-13','13:50:00',2.4),('325','2014-01-13','13:55:00',2.37),('325','2014-01-13','14:00:00',2.34),('325','2014-01-13','14:05:00',2.22),('325','2014-01-13','14:10:00',2.24),('325','2014-01-13','14:15:00',2.19),('325','2014-01-13','14:20:00',2.18),('325','2014-01-13','14:25:00',2.11),('325','2014-01-13','14:30:00',2.04),('325','2014-01-13','14:35:00',1.96),('325','2014-01-13','14:40:00',1.93),('325','2014-01-13','14:45:00',1.89),('325','2014-01-13','14:50:00',1.79),('325','2014-01-13','14:55:00',1.71),('325','2014-01-13','15:00:00',1.67),('325','2014-01-13','15:05:00',1.61),('325','2014-01-13','15:10:00',1.52),('325','2014-01-13','15:15:00',1.43),('325','2014-01-13','15:20:00',1.35),('325','2014-01-13','15:25:00',1.26),('325','2014-01-13','15:30:00',1.17),('325','2014-01-13','15:35:00',1.07),('325','2014-01-12','09:50:00',1.02),('325','2014-01-12','09:55:00',1.01),('325','2014-01-12','10:20:00',1.15),('325','2014-01-12','10:25:00',1.11),('325','2014-01-12','10:30:00',1.14),('325','2014-01-12','10:35:00',1.31),('325','2014-01-12','10:40:00',1.48),('325','2014-01-12','10:45:00',1.44),('325','2014-01-12','10:50:00',1.59),('325','2014-01-12','10:55:00',1.72),('325','2014-01-12','11:00:00',1.62),('325','2014-01-12','11:05:00',1.73),('325','2014-01-12','11:10:00',2.03),('325','2014-01-12','11:15:00',1.8),('325','2014-01-12','11:20:00',1.57),('325','2014-01-12','11:25:00',1.56),('325','2014-01-12','11:30:00',1.7),('325','2014-01-12','11:35:00',1.47),('325','2014-01-12','11:40:00',2.06),('325','2014-01-12','11:45:00',2.52),('325','2014-01-12','11:50:00',2.37),('325','2014-01-12','11:55:00',2.09),('325','2014-01-12','12:00:00',1.56),('325','2014-01-12','12:05:00',1.57),('325','2014-01-12','12:10:00',1.3),('325','2014-01-12','12:20:00',1.27),('325','2014-01-12','12:25:00',1.23),('325','2014-01-12','12:30:00',1.28),('325','2014-01-12','12:35:00',1.34),('325','2014-01-12','12:40:00',1.47),('325','2014-01-12','12:45:00',1.42),('325','2014-01-12','12:50:00',1.48),('325','2014-01-12','12:55:00',1.43),('325','2014-01-12','13:00:00',1.46),('325','2014-01-12','13:05:00',1.35),('325','2014-01-12','13:10:00',1.22),('325','2014-01-12','13:15:00',1.12),('325','2014-01-12','13:20:00',1.05),('325','2014-01-12','13:25:00',1.35),('325','2014-01-12','13:30:00',1.55),('325','2014-01-12','13:35:00',1.41),('325','2014-01-12','13:40:00',1.24),('325','2014-01-12','13:45:00',1.09),('325','2014-01-11','09:55:00',1.34),('325','2014-01-11','10:00:00',1.42),('325','2014-01-11','10:05:00',1.19),('325','2014-01-11','10:10:00',1.22),('325','2014-01-11','10:15:00',1.53),('325','2014-01-11','10:20:00',1.67),('325','2014-01-11','10:25:00',1.98),('325','2014-01-11','10:30:00',1.98),('325','2014-01-11','10:35:00',2.07),('325','2014-01-11','10:40:00',2.61),('325','2014-01-11','10:45:00',2.75),('325','2014-01-11','10:50:00',2.78),('325','2014-01-11','10:55:00',2.77),('325','2014-01-11','11:00:00',2.67),('325','2014-01-11','11:05:00',2.6),('325','2014-01-11','11:10:00',2.75),('325','2014-01-11','11:15:00',2.46),('325','2014-01-11','11:20:00',2.32),('325','2014-01-11','11:25:00',2.33),('325','2014-01-11','11:30:00',2.34),('325','2014-01-11','11:35:00',2.08),('325','2014-01-11','11:40:00',1.88),('325','2014-01-11','11:45:00',1.92),('325','2014-01-11','11:50:00',2.13),('325','2014-01-11','11:55:00',2.13),('325','2014-01-11','12:00:00',2.22),('325','2014-01-11','12:05:00',2.48),('325','2014-01-11','12:10:00',2.26),('325','2014-01-11','12:15:00',2.27),('325','2014-01-11','12:20:00',2.29),('325','2014-01-11','12:25:00',2.09),('325','2014-01-11','12:30:00',1.97),('325','2014-01-11','12:35:00',1.82),('325','2014-01-11','12:40:00',1.72),('325','2014-01-11','12:45:00',1.94),('325','2014-01-11','12:50:00',2.34),('325','2014-01-11','12:55:00',2.41),('325','2014-01-11','13:00:00',2.2),('325','2014-01-11','13:05:00',2.04),('325','2014-01-11','13:10:00',1.86),('325','2014-01-11','13:15:00',2.34),('325','2014-01-11','13:20:00',2.01),('325','2014-01-11','13:25:00',1.68),('325','2014-01-11','13:30:00',1.37),('325','2014-01-11','13:35:00',1.4),('325','2014-01-11','13:40:00',1.32),('325','2014-01-11','13:45:00',1.43),('325','2014-01-11','13:50:00',1.03),('325','2014-01-11','13:55:00',1.21),('325','2014-01-11','14:00:00',1.6),('325','2014-01-11','14:05:00',1.7),('325','2014-01-11','14:10:00',1.36),('325','2014-01-10','13:05:00',1.01),('325','2014-01-09','09:30:00',1.18),('325','2014-01-09','09:35:00',1.04),('325','2014-01-09','09:40:00',1.25),('325','2014-01-09','09:45:00',1.68),('325','2014-01-09','09:50:00',1.78),('325','2014-01-09','09:55:00',1.76),('325','2014-01-09','10:00:00',1.8),('325','2014-01-09','10:05:00',1.74),('325','2014-01-09','10:10:00',1.62),('325','2014-01-09','10:15:00',1.81),('325','2014-01-09','10:20:00',1.88),('325','2014-01-09','10:25:00',2.07),('325','2014-01-09','10:30:00',2.13),('325','2014-01-09','10:35:00',2.2),('325','2014-01-09','10:40:00',2.48),('325','2014-01-09','10:45:00',1.91),('325','2014-01-09','10:50:00',1.22),('325','2014-01-09','10:55:00',1.33),('325','2014-01-09','11:00:00',1.6),('325','2014-01-09','11:05:00',1.42),('325','2014-01-09','11:10:00',1.14),('325','2014-01-09','11:15:00',1.34),('325','2014-01-09','11:20:00',1.83),('325','2014-01-09','11:25:00',1.49),('325','2014-01-09','11:30:00',1.48),('325','2014-01-09','11:35:00',1.8),('325','2014-01-09','11:40:00',1.61),('325','2014-01-09','11:45:00',1.11),('325','2014-01-09','13:05:00',1.04),('325','2014-01-09','13:10:00',1.08),('325','2014-01-09','13:15:00',1.12),('325','2014-01-09','13:20:00',1.06),('325','2014-01-09','13:25:00',1.02),('325','2014-01-08','09:25:00',1.05),('325','2014-01-08','09:30:00',1.05),('325','2014-01-08','09:35:00',1.05),('325','2014-01-08','09:40:00',1.17),('325','2014-01-08','09:45:00',1.2),('325','2014-01-08','09:50:00',1.24),('325','2014-01-08','09:55:00',1.32),('325','2014-01-08','10:00:00',1.38),('325','2014-01-08','10:05:00',1.33),('325','2014-01-08','10:10:00',1.59),('325','2014-01-08','10:15:00',2.16),('325','2014-01-08','10:20:00',2.24),('325','2014-01-08','10:25:00',2.42),('325','2014-01-08','10:30:00',2.51),('325','2014-01-08','10:35:00',2.43),('325','2014-01-08','10:40:00',2.4),('325','2014-01-08','10:45:00',2.62),('325','2014-01-08','10:50:00',2.69),('325','2014-01-08','10:55:00',2.72),('325','2014-01-08','11:00:00',2.74),('325','2014-01-08','11:05:00',2.79),('325','2014-01-08','11:10:00',2.81),('325','2014-01-08','11:15:00',2.84),('325','2014-01-08','11:20:00',2.86),('325','2014-01-08','11:25:00',2.86),('325','2014-01-08','11:30:00',2.88),('325','2014-01-08','11:35:00',2.97),('325','2014-01-08','11:40:00',3.03),('325','2014-01-08','11:45:00',2.99),('325','2014-01-08','11:50:00',2.99),('325','2014-01-08','11:55:00',2.94),('325','2014-01-08','12:00:00',2.92),('325','2014-01-08','12:05:00',2.88),('325','2014-01-08','12:10:00',2.91),('325','2014-01-08','12:15:00',2.9),('325','2014-01-08','12:20:00',2.9),('325','2014-01-08','12:25:00',2.91),('325','2014-01-08','12:30:00',2.95),('325','2014-01-08','12:35:00',2.94),('325','2014-01-08','12:40:00',2.8),('325','2014-01-08','12:45:00',2.71),('325','2014-01-08','12:50:00',2.66),('325','2014-01-08','12:55:00',2.76),('325','2014-01-08','13:00:00',2.75),('325','2014-01-08','13:05:00',2.81),('325','2014-01-08','13:10:00',2.74),('325','2014-01-08','13:15:00',2.67),('325','2014-01-08','13:20:00',2.68),('325','2014-01-08','13:25:00',2.61),('325','2014-01-08','13:30:00',2.59),('325','2014-01-08','13:35:00',2.53),('325','2014-01-08','13:40:00',2.48),('325','2014-01-08','13:45:00',2.45),('325','2014-01-08','13:50:00',2.43),('325','2014-01-08','13:55:00',2.4),('325','2014-01-08','14:00:00',2.35),('325','2014-01-08','14:05:00',2.34),('325','2014-01-08','14:10:00',2.29),('325','2014-01-08','14:15:00',2.22),('325','2014-01-08','14:20:00',2.25),('325','2014-01-08','14:25:00',2.21),('325','2014-01-08','14:30:00',2.22),('325','2014-01-08','14:35:00',2.11),('325','2014-01-08','14:40:00',1.91),('325','2014-01-08','14:45:00',1.81),('325','2014-01-08','14:50:00',1.77),('325','2014-01-08','14:55:00',1.43),('325','2014-01-08','15:00:00',1.4),('325','2014-01-08','15:05:00',1.27),('325','2014-01-08','15:10:00',1.15),('325','2014-01-08','15:15:00',1.21),('325','2014-01-08','15:20:00',1.33),('325','2014-01-08','15:25:00',1.17),('325','2014-01-08','15:30:00',1.05),('325','2014-01-07','09:30:00',1.04),('325','2014-01-07','09:35:00',1.08),('325','2014-01-07','09:40:00',1.12),('325','2014-01-07','09:45:00',1.16),('325','2014-01-07','09:50:00',1.2),('325','2014-01-07','09:55:00',1.24),('325','2014-01-07','10:00:00',1.27),('325','2014-01-07','10:05:00',1.74),('325','2014-01-07','10:10:00',2.16),('325','2014-01-07','10:15:00',2.35),('325','2014-01-07','10:20:00',2.47),('325','2014-01-07','10:25:00',2.55),('325','2014-01-07','10:30:00',2.59),('325','2014-01-07','10:35:00',2.63),('325','2014-01-07','10:40:00',2.68),('325','2014-01-07','10:45:00',2.74),('325','2014-01-07','10:50:00',2.79),('325','2014-01-07','10:55:00',2.84),('325','2014-01-07','11:00:00',2.87),('325','2014-01-07','11:05:00',2.92),('325','2014-01-07','11:10:00',2.94),('325','2014-01-07','11:15:00',2.97),('325','2014-01-07','11:20:00',2.99),('325','2014-01-07','11:25:00',3.01),('325','2014-01-07','11:30:00',3),('325','2014-01-07','11:35:00',3.02),('325','2014-01-07','11:40:00',3.04),('325','2014-01-07','11:45:00',3.06),('325','2014-01-07','11:50:00',3.08),('325','2014-01-07','11:55:00',3.06),('325','2014-01-07','12:00:00',3.06),('325','2014-01-07','12:05:00',3.06),('325','2014-01-07','12:10:00',3.07),('325','2014-01-07','12:15:00',3.02),('325','2014-01-07','12:20:00',3.02),('325','2014-01-07','12:25:00',3.04),('325','2014-01-07','12:30:00',2.98),('325','2014-01-07','12:35:00',2.97),('325','2014-01-07','12:40:00',2.94),('325','2014-01-07','12:45:00',2.96),('325','2014-01-07','12:50:00',2.89),('325','2014-01-07','12:55:00',2.88),('325','2014-01-07','13:00:00',2.78),('325','2014-01-07','13:05:00',2.74),('325','2014-01-07','13:10:00',2.75),('325','2014-01-07','13:15:00',2.79),('325','2014-01-07','13:20:00',2.78),('325','2014-01-07','13:25:00',2.65),('325','2014-01-07','13:30:00',2.59),('325','2014-01-07','13:35:00',2.62),('325','2014-01-07','13:40:00',2.6),('325','2014-01-07','13:45:00',2.67),('325','2014-01-07','13:50:00',2.66),('325','2014-01-07','13:55:00',2.55),('325','2014-01-07','14:00:00',2.51),('325','2014-01-07','14:05:00',2.39),('325','2014-01-07','14:10:00',2.33),('325','2014-01-07','14:15:00',2.3),('325','2014-01-07','14:20:00',2.26),('325','2014-01-07','14:25:00',2.17),('325','2014-01-07','14:30:00',2.11),('325','2014-01-07','14:35:00',2.08),('325','2014-01-07','14:40:00',2.03),('325','2014-01-07','14:45:00',1.91),('325','2014-01-07','14:50:00',1.93),('325','2014-01-07','14:55:00',1.79),('325','2014-01-07','15:00:00',1.76),('325','2014-01-07','15:05:00',1.72),('325','2014-01-07','15:10:00',1.62),('325','2014-01-07','15:15:00',1.51),('325','2014-01-07','15:20:00',1.43),('325','2014-01-07','15:25:00',1.31),('325','2014-01-07','15:30:00',1.17),('325','2014-01-07','15:35:00',1.02),('325','2014-01-06','11:15:00',1.24),('325','2014-01-06','11:20:00',1.02),('325','2014-01-06','11:25:00',1.08),('325','2014-01-06','11:35:00',1.54),('325','2014-01-06','11:40:00',3.45),('325','2014-01-06','11:45:00',2.89),('325','2014-01-06','11:50:00',3.24),('325','2014-01-06','11:55:00',3.27),('325','2014-01-06','12:00:00',3.25),('325','2014-01-06','12:05:00',3.22),('325','2014-01-06','12:10:00',3.08),('325','2014-01-06','12:15:00',3.09),('325','2014-01-06','12:20:00',3.09),('325','2014-01-06','12:25:00',3.05),('325','2014-01-06','12:30:00',3.05),('325','2014-01-06','12:35:00',3.03),('325','2014-01-06','12:40:00',3.01),('325','2014-01-06','12:45:00',3),('325','2014-01-06','12:50:00',2.99),('325','2014-01-06','12:55:00',2.94),('325','2014-01-06','13:00:00',2.9),('325','2014-01-06','13:05:00',2.86),('325','2014-01-06','13:10:00',2.88),('325','2014-01-06','13:15:00',2.97),('325','2014-01-06','13:20:00',2.85),('325','2014-01-06','13:25:00',2.83),('325','2014-01-06','13:30:00',2.74),('325','2014-01-06','13:35:00',2.69),('325','2014-01-06','13:40:00',2.65),('325','2014-01-06','13:45:00',2.52),('325','2014-01-06','13:50:00',2.47),('325','2014-01-06','13:55:00',2.5),('325','2014-01-06','14:00:00',2.28),('325','2014-01-06','14:05:00',1.02),('325','2014-01-06','14:10:00',1.14),('325','2014-01-06','14:15:00',2.36),('325','2014-01-06','14:20:00',2.09),('325','2014-01-06','14:35:00',1.91),('325','2014-01-06','14:40:00',2.27),('325','2014-01-06','14:45:00',2.4),('325','2014-01-06','14:50:00',1.89),('325','2014-01-06','14:55:00',1.9),('325','2014-01-06','15:00:00',1.72),('325','2014-01-06','15:05:00',1.64),('325','2014-01-06','15:10:00',1.58),('325','2014-01-06','15:15:00',1.35),('325','2014-01-06','15:20:00',1.35),('325','2014-01-06','15:25:00',1.31),('325','2014-01-06','15:30:00',1.22),('325','2014-04-23','13:10:00',1.01),('325','2014-04-23','13:15:00',1.19),('325','2014-04-23','13:20:00',1.33),('325','2014-04-23','13:25:00',1.39),('325','2014-04-23','13:30:00',1.5),('325','2014-04-23','13:35:00',1.55),('325','2014-04-23','13:40:00',1.64),('325','2014-04-23','13:45:00',1.66),('325','2014-04-23','13:50:00',1.64),('325','2014-04-23','13:55:00',1.64),('325','2014-04-23','14:00:00',1.57),('325','2014-04-23','14:05:00',1.56),('325','2014-04-23','14:10:00',1.51),('325','2014-04-23','14:15:00',1.27),('325','2014-04-23','14:20:00',1.07),('325','2014-04-23','14:45:00',1.04),('325','2014-04-23','14:50:00',1.26),('325','2014-04-23','14:55:00',1.46),('325','2014-04-23','15:00:00',1.66),('325','2014-04-23','15:05:00',1.77),('325','2014-04-23','15:10:00',1.74),('325','2014-04-23','15:15:00',1.81),('325','2014-04-23','15:20:00',1.57),('325','2014-04-23','15:25:00',1.42),('325','2014-04-23','15:30:00',1.34),('325','2014-04-23','15:35:00',1.28),('325','2014-04-23','15:40:00',1.27),('325','2014-04-23','15:45:00',1.43),('325','2014-04-23','15:50:00',1.15),('325','2014-04-23','15:55:00',1.05),('325','2014-01-03','09:30:00',1.03),('325','2014-01-03','09:35:00',1.27),('325','2014-01-03','09:40:00',1.58),('325','2014-01-03','09:45:00',1.56),('325','2014-01-03','09:50:00',1.12),('325','2014-01-03','09:55:00',1.16),('325','2014-01-03','10:00:00',1.55),('325','2014-01-03','10:05:00',1.25),('325','2014-01-03','10:10:00',2.01),('325','2014-01-03','10:15:00',1.71),('325','2014-01-03','10:20:00',1.81),('325','2014-01-03','10:25:00',1.02),('325','2014-01-03','10:35:00',1.03),('325','2014-01-03','10:40:00',1.09),('325','2014-01-03','10:45:00',1.3),('325','2014-01-03','10:50:00',1.2),('325','2014-01-03','11:30:00',1.1),('325','2014-01-03','11:35:00',1.27),('325','2014-01-03','11:40:00',1.52),('325','2014-01-03','11:45:00',1.5),('325','2014-01-03','11:50:00',1.38),('325','2014-01-03','11:55:00',1.42),('325','2014-01-03','12:00:00',1.95),('325','2014-01-03','12:05:00',2.07),('325','2014-01-03','12:10:00',2.36),('325','2014-01-03','12:15:00',3.35),('325','2014-01-03','12:20:00',3.24),('325','2014-01-03','12:25:00',2.79),('325','2014-01-03','12:30:00',2.46),('325','2014-01-03','12:35:00',2.02),('325','2014-01-03','12:40:00',2.05),('325','2014-01-03','12:45:00',2.07),('325','2014-01-03','12:50:00',1.91),('325','2014-01-03','12:55:00',1.49),('325','2014-01-03','13:00:00',1.22),('325','2014-01-03','13:05:00',1.96),('325','2014-01-03','13:10:00',1.44),('325','2014-01-03','13:15:00',1.29),('325','2014-01-03','13:20:00',1.11),('325','2014-01-03','13:25:00',1.19),('325','2014-01-03','13:30:00',1.63),('325','2014-01-03','13:35:00',1.83),('325','2014-01-03','13:40:00',1.49),('325','2014-01-03','13:45:00',1.2),('325','2014-01-02','09:30:00',1.02),('325','2014-01-02','09:35:00',1.06),('325','2014-01-02','09:40:00',1.1),('325','2014-01-02','09:45:00',1.16),('325','2014-01-02','09:50:00',1.19),('325','2014-01-02','09:55:00',1.23),('325','2014-01-02','10:00:00',1.27),('325','2014-01-02','10:05:00',1.56),('325','2014-01-02','10:10:00',2.17),('325','2014-01-02','10:15:00',2.36),('325','2014-01-02','10:20:00',2.5),('325','2014-01-02','10:25:00',2.51),('325','2014-01-02','10:30:00',2.57),('325','2014-01-02','10:35:00',2.59),('325','2014-01-02','10:40:00',2.6),('325','2014-01-02','10:45:00',2.66),('325','2014-01-02','10:50:00',2.73),('325','2014-01-02','10:55:00',2.9),('325','2014-01-02','11:00:00',2.8),('325','2014-01-02','11:05:00',2.79),('325','2014-01-02','11:10:00',2.15),('325','2014-01-02','11:15:00',1.8),('325','2014-01-02','11:20:00',1.8),('325','2014-01-02','11:25:00',1.86),('325','2014-01-02','11:30:00',1.97),('325','2014-01-02','11:35:00',2.62),('325','2014-01-02','11:40:00',2),('325','2014-01-02','11:45:00',1.86),('325','2014-01-02','11:50:00',1.38),('325','2014-01-02','11:55:00',1.28),('325','2014-01-02','12:00:00',1.11),('325','2014-01-02','12:05:00',1.16),('325','2014-01-02','12:10:00',1.07),('325','2014-01-02','12:45:00',1.06),('325','2014-01-02','12:50:00',1.69),('325','2014-01-02','12:55:00',1.52),('325','2014-01-02','13:30:00',1.2),('325','2014-01-02','13:35:00',2.63),('325','2014-01-02','13:40:00',2.16),('325','2014-01-02','13:45:00',1.21),('325','2014-01-01','09:05:00',1.11),('325','2014-01-01','09:30:00',1.12),('325','2014-01-01','09:35:00',1.33),('325','2014-01-01','09:40:00',1.23),('325','2014-01-01','09:45:00',1.52),('325','2014-01-01','09:50:00',1.91),('325','2014-01-01','09:55:00',1.77),('325','2014-01-01','10:00:00',1.39),('325','2014-01-01','10:05:00',1.17),('325','2014-01-01','11:25:00',1.03),('325','2014-01-01','11:30:00',1.04),('325','2014-01-01','11:35:00',1),('325','2014-01-01','11:55:00',1.03),('325','2014-01-01','12:00:00',1.14),('325','2014-01-01','12:05:00',1.21),('325','2014-01-01','12:10:00',1.28),('325','2014-01-01','12:15:00',1.32),('325','2014-01-01','12:20:00',1.35),('325','2014-01-01','12:25:00',1.36),('325','2014-01-01','12:30:00',1.35),('325','2014-01-01','12:35:00',1.35),('325','2014-01-01','12:40:00',1.25),('325','2014-01-01','12:45:00',1.28),('325','2014-01-01','12:50:00',1.31),('325','2014-01-01','12:55:00',1.3),('325','2014-01-01','13:00:00',1.28),('325','2014-01-01','13:05:00',1.18),('325','2014-01-01','13:10:00',1.13),('325','2014-01-01','13:15:00',1.12),('325','2014-01-01','13:20:00',1.24),('325','2014-01-01','13:25:00',1.33),('325','2014-01-01','13:30:00',1.41),('325','2014-01-01','13:35:00',1.59),('325','2014-01-01','13:40:00',1.46),('325','2014-01-01','13:45:00',1.31),('325','2014-01-01','13:50:00',1.78),('325','2014-01-01','13:55:00',2.24),('325','2014-01-01','14:00:00',1.79),('325','2014-01-01','14:05:00',1.23),('325','2014-01-01','14:10:00',1.2),('325','2014-01-01','14:15:00',1.36),('325','2014-01-01','14:20:00',1.12),('325','2014-01-01','15:00:00',1.01),('325','2014-01-01','15:05:00',1.49),('325','2014-01-01','15:10:00',1.77),('325','2014-01-01','15:15:00',1.53),('325','2014-01-01','15:20:00',1.37),('325','2014-01-01','15:25:00',1.23),('325','2014-01-01','15:30:00',1.09),('325','2013-12-31','09:20:00',1.03),('325','2013-12-31','09:25:00',1.09),('325','2013-12-31','09:30:00',1.22),('325','2013-12-31','09:35:00',1.29),('325','2013-12-31','09:40:00',1.09),('325','2013-12-31','09:50:00',1.54),('325','2013-12-31','09:55:00',1.27),('325','2013-12-31','10:00:00',1.35),('325','2013-12-31','10:05:00',1.15),('325','2013-12-31','10:45:00',1.06),('325','2013-12-31','10:50:00',1.47),('325','2013-12-31','10:55:00',1.71),('325','2013-12-31','11:00:00',1.36),('325','2013-12-31','11:05:00',1.41),('325','2013-12-31','11:10:00',1.43),('325','2013-12-31','11:15:00',2.15),('325','2013-12-31','11:20:00',1.46),('325','2013-12-31','11:25:00',2.38),('325','2013-12-31','11:30:00',3.61),('325','2013-12-31','11:35:00',2.3),('325','2013-12-31','11:40:00',2.75),('325','2013-12-31','11:50:00',1.36),('325','2013-12-31','11:55:00',1.91),('325','2013-12-31','12:00:00',3.41),('325','2013-12-31','12:05:00',3.27),('325','2013-12-31','12:10:00',3.23),('325','2013-12-31','12:15:00',3.2),('325','2013-12-31','12:20:00',3.17),('325','2013-12-31','12:25:00',3.14),('325','2013-12-31','12:30:00',3.11),('325','2013-12-31','12:35:00',3.06),('325','2013-12-31','12:40:00',3.04),('325','2013-12-31','12:45:00',3.03),('325','2013-12-31','12:50:00',3),('325','2013-12-31','12:55:00',2.97),('325','2013-12-31','13:00:00',2.97),('325','2013-12-31','13:05:00',2.94),('325','2013-12-31','13:10:00',2.91),('325','2013-12-31','13:15:00',2.88),('325','2013-12-31','13:20:00',2.86),('325','2013-12-31','13:25:00',2.82),('325','2013-12-31','13:30:00',2.78),('325','2013-12-31','13:35:00',2.73),('325','2013-12-31','13:40:00',2.68),('325','2013-12-31','13:45:00',2.63),('325','2013-12-31','13:50:00',2.58),('325','2013-12-31','13:55:00',2.53),('325','2013-12-31','14:00:00',2.46),('325','2013-12-31','14:05:00',2.41),('325','2013-12-31','14:10:00',2.35),('325','2013-12-31','14:15:00',2.29),('325','2013-12-31','14:20:00',2.23),('325','2013-12-31','14:25:00',2.17),('325','2013-12-31','14:30:00',2.1),('325','2013-12-31','14:35:00',2.02),('325','2013-12-31','14:40:00',1.95),('325','2013-12-31','14:45:00',1.86),('325','2013-12-31','14:50:00',1.78),('325','2013-12-31','14:55:00',1.69),('325','2013-12-31','15:00:00',1.62),('325','2013-12-31','15:05:00',1.53),('325','2013-12-31','15:10:00',1.43),('325','2013-12-31','15:15:00',1.36),('325','2013-12-31','15:20:00',1.26),('325','2013-12-31','15:25:00',1.17),('325','2013-12-31','15:30:00',1.09),('325','2013-12-30','11:25:00',1.09),('325','2013-12-30','11:30:00',1.07),('325','2013-12-30','11:35:00',1.01),('325','2013-12-29','09:15:00',1.06),('325','2013-12-29','09:20:00',1.1),('325','2013-12-29','09:25:00',1.07),('325','2013-12-29','09:30:00',1.12),('325','2013-12-29','09:35:00',1.15),('325','2013-12-29','09:40:00',1.22),('325','2013-12-29','09:45:00',1.28),('325','2013-12-29','09:50:00',1.26),('325','2013-12-29','09:55:00',1.16),('325','2013-12-29','10:00:00',1.21),('325','2013-12-29','10:05:00',1.49),('325','2013-12-29','10:10:00',2.28),('325','2013-12-29','10:15:00',2.33),('325','2013-12-29','10:20:00',2.62),('325','2013-12-29','10:25:00',2.29),('325','2013-12-29','10:30:00',3.11),('325','2013-12-29','10:35:00',3.29),('325','2013-12-29','10:40:00',1.63),('325','2013-12-29','10:45:00',1.36),('325','2013-12-29','10:50:00',1.05),('325','2013-12-29','10:55:00',1.41),('325','2013-12-29','11:05:00',1.07),('325','2013-12-28','09:25:00',1.01),('325','2013-12-28','09:30:00',1.05),('325','2013-12-28','09:35:00',1.09),('325','2013-12-28','09:40:00',1.13),('325','2013-12-28','09:45:00',1.18),('325','2013-12-28','09:50:00',1.21),('325','2013-12-28','09:55:00',1.25),('325','2013-12-28','10:00:00',1.29),('325','2013-12-28','10:05:00',1.82),('325','2013-12-28','10:10:00',2.32),('325','2013-12-28','10:15:00',2.44),('325','2013-12-28','10:20:00',2.51),('325','2013-12-28','10:25:00',2.58),('325','2013-12-28','10:30:00',2.62),('325','2013-12-28','10:35:00',2.68),('325','2013-12-28','10:40:00',2.72),('325','2013-12-28','10:45:00',2.75),('325','2013-12-28','10:50:00',2.8),('325','2013-12-28','10:55:00',2.84),('325','2013-12-28','11:00:00',2.88),('325','2013-12-28','11:05:00',2.91),('325','2013-12-28','11:10:00',2.94),('325','2013-12-28','11:15:00',2.96),('325','2013-12-28','11:20:00',3),('325','2013-12-28','11:25:00',3),('325','2013-12-28','11:30:00',3.02),('325','2013-12-28','11:35:00',3.02),('325','2013-12-28','11:40:00',3.02),('325','2013-12-28','11:45:00',3.04),('325','2013-12-28','11:50:00',3.05),('325','2013-12-28','11:55:00',3.05),('325','2013-12-28','12:00:00',3.03),('325','2013-12-28','12:05:00',3.03),('325','2013-12-28','12:10:00',3.05),('325','2013-12-28','12:15:00',3.02),('325','2013-12-28','12:20:00',3),('325','2013-12-28','12:25:00',2.97),('325','2013-12-28','12:30:00',2.96),('325','2013-12-28','12:35:00',2.97),('325','2013-12-28','12:40:00',2.94),('325','2013-12-28','12:45:00',2.92),('325','2013-12-28','12:50:00',2.85),('325','2013-12-28','12:55:00',2.86),('325','2013-12-28','13:00:00',2.82),('325','2013-12-28','13:05:00',2.77),('325','2013-12-28','13:10:00',2.75),('325','2013-12-28','13:15:00',2.74),('325','2013-12-28','13:20:00',2.66),('325','2013-12-28','13:25:00',2.56),('325','2013-12-28','13:30:00',2.51),('325','2013-12-28','13:35:00',2.49),('325','2013-12-28','13:40:00',2.45),('325','2013-12-28','13:45:00',2.43),('325','2013-12-28','13:50:00',2.4),('325','2013-12-28','13:55:00',2.34),('325','2013-12-28','14:00:00',2.25),('325','2013-12-28','14:05:00',2.19),('325','2013-12-28','14:10:00',2.12),('325','2013-12-28','14:15:00',2.01),('325','2013-12-28','14:20:00',1.99),('325','2013-12-28','14:25:00',1.96),('325','2013-12-28','14:30:00',1.9),('325','2013-12-28','14:35:00',1.85),('325','2013-12-28','14:40:00',1.81),('325','2013-12-28','14:45:00',1.45),('325','2013-12-28','14:50:00',1.14),('325','2013-12-28','15:00:00',1.27),('325','2013-12-28','15:05:00',1.5),('325','2013-12-28','15:10:00',1.36),('325','2013-12-28','15:15:00',1.27),('325','2013-12-28','15:20:00',1.18),('325','2013-12-28','15:25:00',1.08),('325','2013-12-27','12:05:00',1.09),('325','2013-12-27','12:10:00',2.23),('325','2013-12-27','12:15:00',1.67),('325','2013-12-27','12:20:00',2.08),('325','2013-12-27','12:25:00',1.39),('325','2013-12-27','12:30:00',1.12),('325','2013-12-27','12:35:00',1.43),('325','2013-12-27','12:40:00',1.77),('325','2013-12-27','12:45:00',2.36),('325','2013-12-27','12:50:00',2.75),('325','2013-12-27','12:55:00',2.79),('325','2013-12-27','13:00:00',2.81),('325','2013-12-27','13:05:00',2.64),('325','2013-12-27','13:10:00',1.65),('325','2013-12-27','13:15:00',1.64),('325','2013-12-27','13:20:00',2.35),('325','2013-12-27','13:25:00',2.1),('325','2013-12-27','13:30:00',2.87),('325','2013-12-27','13:35:00',2.38),('325','2013-12-27','13:40:00',1.45),('325','2013-12-27','13:45:00',1.28),('325','2013-12-27','13:50:00',1.1),('325','2013-12-27','14:05:00',1.11),('325','2013-12-27','14:10:00',1.3),('325','2013-12-27','14:15:00',1.35),('325','2013-12-27','14:20:00',1.28),('325','2013-12-27','14:25:00',1.23),('325','2013-12-27','14:30:00',1.28),('325','2013-12-27','14:35:00',1.36),('325','2013-12-27','14:40:00',1.43),('325','2013-12-27','14:45:00',1.33),('325','2014-04-22','08:25:00',1),('325','2014-04-22','08:30:00',1.07),('325','2014-04-22','08:35:00',1.14),('325','2014-04-22','08:40:00',1.21),('325','2014-04-22','08:45:00',1.27),('325','2014-04-22','08:50:00',1.36),('325','2014-04-22','08:55:00',1.46),('325','2014-04-22','09:00:00',1.53),('325','2014-04-22','09:05:00',1.95),('325','2014-04-22','09:10:00',1.88),('325','2014-04-22','09:15:00',1.86),('325','2014-04-22','09:20:00',2.21),('325','2014-04-22','09:25:00',2.55),('325','2014-04-22','09:30:00',2.55),('325','2014-04-22','09:35:00',2.72),('325','2014-04-22','09:40:00',2.75),('325','2014-04-22','09:45:00',3.03),('325','2014-04-22','09:50:00',2.34),('325','2014-04-22','09:55:00',1.45),('325','2014-04-22','10:00:00',1.38),('325','2014-04-22','10:05:00',1.48),('325','2014-04-22','10:10:00',1.95),('325','2014-04-22','10:15:00',2.03),('325','2014-04-22','10:20:00',3.22),('325','2014-04-22','10:25:00',2.19),('325','2014-04-22','10:30:00',3.54),('325','2014-04-22','10:35:00',3.63),('325','2014-04-22','10:40:00',3.55),('325','2014-04-22','10:45:00',3.93),('325','2014-04-22','10:50:00',4.14),('325','2014-04-22','10:55:00',3.06),('325','2014-04-22','11:00:00',2.05),('325','2014-04-22','11:05:00',2.44),('325','2014-04-22','11:10:00',1.72),('325','2014-04-22','11:15:00',1.46),('325','2014-04-22','11:20:00',1.28),('325','2014-04-22','11:25:00',1.29),('325','2014-04-22','11:30:00',1.17),('325','2014-04-22','11:35:00',1.21),('325','2014-04-22','11:40:00',1.05),('325','2014-04-22','12:00:00',1.01),('325','2014-04-22','12:05:00',1.22),('325','2014-04-22','12:10:00',1.19),('325','2014-04-22','12:15:00',1.22),('325','2014-04-22','12:20:00',1.27),('325','2014-04-22','12:25:00',1.39),('325','2014-04-22','12:30:00',1.6),('325','2014-04-22','12:35:00',1.34),('325','2014-04-22','12:40:00',1.01),('325','2014-04-22','13:15:00',1.55),('325','2014-04-22','13:20:00',2.27),('325','2014-04-22','13:25:00',2.74),('325','2014-04-22','13:30:00',2.85),('325','2014-04-22','13:35:00',2.77),('325','2014-04-22','13:40:00',3.32),('325','2014-04-22','13:45:00',3.36),('325','2014-04-22','13:50:00',2.73),('325','2014-04-22','13:55:00',1.54),('325','2014-04-22','14:00:00',1.38),('325','2014-04-22','14:05:00',2.1),('325','2014-04-22','14:10:00',3.71),('325','2014-04-22','14:15:00',3.54),('325','2014-04-22','14:20:00',4.42),('325','2014-04-22','14:25:00',2.54),('325','2014-04-22','14:30:00',2.23),('325','2014-04-22','14:35:00',2.63),('325','2014-04-22','14:40:00',3.46),('325','2014-04-22','14:45:00',4.5),('325','2014-04-22','14:50:00',3.95),('325','2014-04-22','14:55:00',2.99),('325','2014-04-22','15:00:00',1.34),('325','2014-04-22','15:05:00',1.23),('325','2014-04-22','15:10:00',1.15),('325','2014-04-22','15:15:00',1.19),('325','2014-04-22','15:20:00',1.34),('325','2014-04-22','15:25:00',1.51),('325','2014-04-22','15:30:00',1.95),('325','2014-04-22','15:35:00',2.67),('325','2014-04-22','15:40:00',2.27),('325','2014-04-22','15:45:00',2.08),('325','2014-04-22','15:50:00',2.37),('325','2014-04-22','15:55:00',1.91),('325','2014-04-22','16:00:00',2.3),('325','2014-04-22','16:05:00',1.55),('325','2014-04-22','16:10:00',1.48),('325','2014-04-22','16:15:00',1.4),('325','2014-04-22','16:20:00',1.64),('325','2014-04-22','16:25:00',1.55),('325','2014-04-22','16:30:00',1.3),('325','2014-04-22','16:35:00',1.55),('325','2014-04-22','16:40:00',1.93),('325','2014-04-22','16:45:00',1.7),('325','2014-04-22','16:50:00',1.33),('325','2014-04-22','16:55:00',1.15),('325','2014-04-22','17:00:00',1.35),('325','2014-04-22','17:05:00',1.5),('325','2014-04-22','17:10:00',1.13),('325','2013-12-25','10:25:00',1.08),('325','2013-12-25','10:30:00',1.65),('325','2013-12-25','10:35:00',1.6),('325','2013-12-25','10:40:00',1.45),('325','2013-12-25','10:45:00',1.64),('325','2013-12-25','10:50:00',1.39),('325','2013-12-25','11:10:00',1.04),('325','2013-12-25','11:15:00',1.48),('325','2013-12-25','11:20:00',2.14),('325','2013-12-25','11:25:00',1.96),('325','2013-12-25','11:30:00',1.84),('325','2013-12-25','11:40:00',2.23),('325','2013-12-25','11:45:00',2.64),('325','2013-12-25','11:50:00',1.53),('325','2013-12-25','11:55:00',2.94),('325','2013-12-25','12:00:00',1.49),('325','2013-12-25','12:05:00',1.31),('325','2013-12-25','12:10:00',1.12),('325','2013-12-25','12:15:00',1.14),('325','2013-12-25','12:20:00',1.28),('325','2013-12-25','12:25:00',1.85),('325','2013-12-25','12:30:00',1.77),('325','2013-12-25','12:45:00',1.19),('325','2013-12-25','12:50:00',1.55),('325','2013-12-25','13:10:00',1.01),('325','2013-12-25','13:25:00',1.15),('325','2013-12-25','13:30:00',1.08),('325','2013-12-25','13:35:00',1.05),('325','2013-12-25','13:40:00',1.27),('325','2013-12-25','13:45:00',1.3),('325','2013-12-25','13:50:00',1.5),('325','2013-12-25','13:55:00',1.18),('325','2013-12-25','14:00:00',1.05),('325','2013-12-25','15:15:00',1.02),('325','2013-12-24','09:30:00',1.04),('325','2013-12-24','09:35:00',1.1),('325','2013-12-24','09:40:00',1.14),('325','2013-12-24','09:45:00',1.17),('325','2013-12-24','09:50:00',1.2),('325','2013-12-24','09:55:00',1.34),('325','2013-12-24','10:00:00',1.84),('325','2013-12-24','10:05:00',1.98),('325','2013-12-24','10:10:00',2.14),('325','2013-12-24','10:15:00',2.24),('325','2013-12-24','10:20:00',2.34),('325','2013-12-24','10:25:00',2.39),('325','2013-12-24','10:30:00',2.42),('325','2013-12-24','10:35:00',2.49),('325','2013-12-24','10:40:00',2.53),('325','2013-12-24','10:45:00',2.51),('325','2013-12-24','10:50:00',2.56),('325','2013-12-24','10:55:00',2.59),('325','2013-12-24','11:00:00',2.57),('325','2013-12-24','11:05:00',2.64),('325','2013-12-24','11:10:00',2.68),('325','2013-12-24','11:15:00',2.64),('325','2013-12-24','11:20:00',2.64),('325','2013-12-24','11:25:00',2.67),('325','2013-12-24','11:30:00',2.72),('325','2013-12-24','11:35:00',2.74),('325','2013-12-24','11:40:00',2.76),('325','2013-12-24','11:45:00',2.79),('325','2013-12-24','11:50:00',2.79),('325','2013-12-24','11:55:00',2.78),('325','2013-12-24','12:00:00',2.76),('325','2013-12-24','12:05:00',2.72),('325','2013-12-24','12:10:00',2.73),('325','2013-12-24','12:15:00',2.75),('325','2013-12-24','12:20:00',2.74),('325','2013-12-24','12:25:00',2.71),('325','2013-12-24','12:30:00',2.65),('325','2013-12-24','12:35:00',2.6),('325','2013-12-24','12:40:00',2.56),('325','2013-12-24','12:45:00',2.53),('325','2013-12-24','12:50:00',2.56),('325','2013-12-24','12:55:00',2.56),('325','2013-12-24','13:00:00',2.51),('325','2013-12-24','13:05:00',2.5),('325','2013-12-24','13:10:00',2.48),('325','2013-12-24','13:15:00',2.43),('325','2013-12-24','13:20:00',2.39),('325','2013-12-24','13:25:00',2.32),('325','2013-12-24','13:30:00',2.34),('325','2013-12-24','13:35:00',2.3),('325','2013-12-24','13:40:00',2.18),('325','2013-12-24','13:45:00',2.12),('325','2013-12-24','13:50:00',2.06),('325','2013-12-24','13:55:00',1.98),('325','2013-12-24','14:00:00',1.92),('325','2013-12-24','14:05:00',1.87),('325','2013-12-24','14:10:00',1.84),('325','2013-12-24','14:15:00',1.79),('325','2013-12-24','14:20:00',1.7),('325','2013-12-24','14:25:00',1.62),('325','2013-12-24','14:30:00',1.56),('325','2013-12-24','14:35:00',1.44),('325','2013-12-24','14:40:00',1.3),('325','2013-12-24','14:45:00',1.17),('325','2013-12-24','14:50:00',1.12),('325','2013-12-24','14:55:00',1.03),('325','2013-12-23','09:40:00',1.02),('325','2013-12-23','09:45:00',1.03),('325','2013-12-23','09:50:00',1.2),('325','2013-12-23','09:55:00',1.37),('325','2013-12-23','10:00:00',1.6),('325','2013-12-23','10:05:00',1.79),('325','2013-12-23','10:10:00',2.28),('325','2013-12-23','10:15:00',2.39),('325','2013-12-23','10:20:00',2.46),('325','2013-12-23','10:25:00',2.37),('325','2013-12-23','10:30:00',2.3),('325','2013-12-23','10:35:00',2.3),('325','2013-12-23','10:40:00',2.36),('325','2013-12-23','10:45:00',2.37),('325','2013-12-23','10:50:00',2.5),('325','2013-12-23','10:55:00',2.66),('325','2013-12-23','11:00:00',2.87),('325','2013-12-23','11:05:00',2.95),('325','2013-12-23','11:10:00',2.97),('325','2013-12-23','11:15:00',2.92),('325','2013-12-23','11:20:00',2.91),('325','2013-12-23','11:25:00',2.81),('325','2013-12-23','11:30:00',2.9),('325','2013-12-23','11:35:00',3.04),('325','2013-12-23','11:40:00',2.73),('325','2013-12-23','11:45:00',2.53),('325','2013-12-23','11:50:00',2.78),('325','2013-12-23','11:55:00',2.81),('325','2013-12-23','12:00:00',2.9),('325','2013-12-23','12:05:00',2.93),('325','2013-12-23','12:10:00',2.93),('325','2013-12-23','12:15:00',2.9),('325','2013-12-23','12:20:00',2.78),('325','2013-12-23','12:25:00',2.76),('325','2013-12-23','12:30:00',2.78),('325','2013-12-23','12:35:00',2.88),('325','2013-12-23','12:40:00',2.91),('325','2013-12-23','12:45:00',2.87),('325','2013-12-23','12:50:00',2.86),('325','2013-12-23','12:55:00',2.86),('325','2013-12-23','13:00:00',2.84),('325','2013-12-23','13:05:00',2.82),('325','2013-12-23','13:10:00',2.77),('325','2013-12-23','13:15:00',2.69),('325','2013-12-23','13:20:00',2.16),('325','2013-12-23','13:25:00',2.49),('325','2013-12-23','13:30:00',2.13),('325','2013-12-23','13:35:00',1.08),('325','2013-12-23','13:40:00',2.17),('325','2013-12-23','13:45:00',1.3),('325','2013-12-23','13:50:00',2.01),('325','2013-12-23','13:55:00',2.14),('325','2013-12-23','14:00:00',2.33),('325','2013-12-23','14:05:00',2.28),('325','2013-12-23','14:10:00',2.2),('325','2013-12-23','14:15:00',2.11),('325','2013-12-23','14:20:00',2.05),('325','2013-12-23','14:25:00',1.99),('325','2013-12-23','14:30:00',1.74),('325','2013-12-23','14:35:00',1.84),('325','2013-12-23','14:40:00',1.74),('325','2013-12-23','14:45:00',1.63),('325','2013-12-23','14:50:00',1.56),('325','2013-12-23','14:55:00',1.47),('325','2013-12-23','15:00:00',1.38),('325','2013-12-23','15:05:00',1.29),('325','2013-12-23','15:10:00',1.19),('325','2013-12-23','15:15:00',1.1),('325','2013-12-22','09:20:00',1.07),('325','2013-12-22','09:25:00',1.08),('325','2013-12-22','09:30:00',1.15),('325','2013-12-22','09:35:00',1.46),('325','2013-12-22','09:40:00',1.71),('325','2013-12-22','09:45:00',1.75),('325','2013-12-22','09:50:00',1.81),('325','2013-12-22','09:55:00',1.79),('325','2013-12-22','10:00:00',1.76),('325','2013-12-22','10:05:00',2.03),('325','2013-12-22','10:10:00',2.59),('325','2013-12-22','10:15:00',2.58),('325','2013-12-22','10:20:00',2.52),('325','2013-12-22','10:25:00',2.57),('325','2013-12-22','10:30:00',2.69),('325','2013-12-22','10:35:00',2.5),('325','2013-12-22','10:40:00',2.35),('325','2013-12-22','10:45:00',2.57),('325','2013-12-22','10:50:00',2.58),('325','2013-12-22','10:55:00',2.35),('325','2013-12-22','11:00:00',2.15),('325','2013-12-22','11:05:00',2.21),('325','2013-12-22','11:10:00',2.92),('325','2013-12-22','11:15:00',2.77),('325','2013-12-22','11:20:00',2.58),('325','2013-12-22','11:25:00',2.62),('325','2013-12-22','11:30:00',2.43),('325','2013-12-22','11:35:00',2.5),('325','2013-12-22','11:40:00',2.61),('325','2013-12-22','11:45:00',2.39),('325','2013-12-22','11:50:00',1.81),('325','2013-12-22','11:55:00',1.32),('325','2013-12-22','12:00:00',1),('325','2013-12-22','12:10:00',1),('325','2013-12-22','12:15:00',1.05),('325','2013-12-22','12:20:00',1.31),('325','2013-12-22','12:25:00',1.38),('325','2013-12-22','12:30:00',1.73),('325','2013-12-22','12:35:00',1.95),('325','2013-12-22','12:40:00',1.89),('325','2013-12-22','12:45:00',1.83),('325','2013-12-22','12:50:00',2.22),('325','2013-12-22','12:55:00',2.77),('325','2013-12-22','13:00:00',2.66),('325','2013-12-22','13:05:00',3.27),('325','2013-12-22','13:10:00',3.26),('325','2013-12-22','13:15:00',2.41),('325','2013-12-22','13:20:00',2.34),('325','2013-12-22','13:25:00',2.42),('325','2013-12-22','13:30:00',2.18),('325','2013-12-22','13:35:00',2.11),('325','2013-12-22','13:40:00',1.74),('325','2013-12-22','13:45:00',2),('325','2013-12-22','13:50:00',1.75),('325','2013-12-22','13:55:00',1.62),('325','2013-12-22','14:00:00',1.42),('325','2013-12-22','14:05:00',1.68),('325','2013-12-22','14:10:00',1.78),('325','2013-12-22','14:15:00',1.3),('325','2013-12-22','14:20:00',1.4),('325','2013-12-22','14:25:00',1.12),('325','2013-12-22','14:30:00',1.13),('325','2013-12-22','14:35:00',1.44),('325','2013-12-22','14:40:00',1.46),('325','2013-12-22','14:45:00',1.39),('325','2013-12-21','09:25:00',1),('325','2013-12-21','09:30:00',1.04),('325','2013-12-21','09:35:00',1.08),('325','2013-12-21','09:40:00',1.12),('325','2013-12-21','09:45:00',1.17),('325','2013-12-21','09:50:00',1.2),('325','2013-12-21','09:55:00',1.24),('325','2013-12-21','10:00:00',1.73),('325','2013-12-21','10:05:00',2.12),('325','2013-12-21','10:10:00',2.28),('325','2013-12-21','10:15:00',2.39),('325','2013-12-21','10:20:00',2.44),('325','2013-12-21','10:25:00',2.49),('325','2013-12-21','10:30:00',2.54),('325','2013-12-21','10:35:00',2.59),('325','2013-12-21','10:40:00',2.63),('325','2013-12-21','10:45:00',2.67),('325','2013-12-21','10:50:00',2.7),('325','2013-12-21','10:55:00',2.74),('325','2013-12-21','11:00:00',2.78),('325','2013-12-21','11:05:00',2.83),('325','2013-12-21','11:10:00',2.86),('325','2013-12-21','11:15:00',2.88),('325','2013-12-21','11:20:00',2.91),('325','2013-12-21','11:25:00',2.95),('325','2013-12-21','11:30:00',2.98),('325','2013-12-21','11:35:00',2.99),('325','2013-12-21','11:40:00',3),('325','2013-12-21','11:45:00',3.01),('325','2013-12-21','11:50:00',3.01),('325','2013-12-21','11:55:00',3.02),('325','2013-12-21','12:00:00',3.02),('325','2013-12-21','12:05:00',3.03),('325','2013-12-21','12:10:00',3.03),('325','2013-12-21','12:15:00',3.02),('325','2013-12-21','12:20:00',3.01),('325','2013-12-21','12:25:00',3),('325','2013-12-21','12:30:00',2.99),('325','2013-12-21','12:35:00',2.98),('325','2013-12-21','12:40:00',2.97),('325','2013-12-21','12:45:00',2.93),('325','2013-12-21','12:50:00',2.92),('325','2013-12-21','12:55:00',2.9),('325','2013-12-21','13:00:00',2.87),('325','2013-12-21','13:05:00',2.82),('325','2013-12-21','13:10:00',2.79),('325','2013-12-21','13:15:00',2.77),('325','2013-12-21','13:20:00',2.71),('325','2013-12-21','13:25:00',2.66),('325','2013-12-21','13:30:00',2.62),('325','2013-12-21','13:35:00',2.56),('325','2013-12-21','13:40:00',2.52),('325','2013-12-21','13:45:00',2.48),('325','2013-12-21','13:50:00',2.42),('325','2013-12-21','13:55:00',2.37),('325','2013-12-21','14:00:00',2.32),('325','2013-12-21','14:05:00',2.25),('325','2013-12-21','14:10:00',2.19),('325','2013-12-21','14:15:00',2.12),('325','2013-12-21','14:20:00',2.1),('325','2013-12-21','14:25:00',2.02),('325','2013-12-21','14:30:00',1.95),('325','2013-12-21','14:35:00',1.89),('325','2013-12-21','14:40:00',1.81),('325','2013-12-21','14:45:00',1.74),('325','2013-12-21','14:50:00',1.64),('325','2013-12-21','14:55:00',1.54),('325','2013-12-21','15:00:00',1.46),('325','2013-12-21','15:05:00',1.36),('325','2013-12-21','15:10:00',1.28),('325','2013-12-21','15:15:00',1.2),('325','2013-12-21','15:20:00',1.12),('325','2013-12-21','15:25:00',1.03),('325','2013-12-20','09:30:00',1.04),('325','2013-12-20','09:35:00',1.08),('325','2013-12-20','09:40:00',1.12),('325','2013-12-20','09:45:00',1.17),('325','2013-12-20','09:50:00',1.21),('325','2013-12-20','09:55:00',1.24),('325','2013-12-20','10:00:00',1.47),('325','2013-12-20','10:05:00',2.04),('325','2013-12-20','10:10:00',2.19),('325','2013-12-20','10:15:00',2.29),('325','2013-12-20','10:20:00',2.32),('325','2013-12-20','10:25:00',2.36),('325','2013-12-20','10:30:00',2.42),('325','2013-12-20','10:35:00',2.45),('325','2013-12-20','10:40:00',2.49),('325','2013-12-20','10:45:00',2.55),('325','2013-12-20','10:50:00',2.59),('325','2013-12-20','10:55:00',2.62),('325','2013-12-20','11:00:00',2.66),('325','2013-12-20','11:05:00',2.7),('325','2013-12-20','11:10:00',2.73),('325','2013-12-20','11:15:00',2.75),('325','2013-12-20','11:20:00',2.77),('325','2013-12-20','11:25:00',2.77),('325','2013-12-20','11:30:00',2.8),('325','2013-12-20','11:35:00',2.83),('325','2013-12-20','11:40:00',2.82),('325','2013-12-20','11:45:00',2.85),('325','2013-12-20','11:50:00',2.84),('325','2013-12-20','11:55:00',2.82),('325','2013-12-20','12:00:00',2.86),('325','2013-12-20','12:05:00',2.84),('325','2013-12-20','12:10:00',2.82),('325','2013-12-20','12:15:00',2.8),('325','2013-12-20','12:20:00',2.82),('325','2013-12-20','12:25:00',2.79),('325','2013-12-20','12:30:00',2.79),('325','2013-12-20','12:35:00',2.78),('325','2013-12-20','12:40:00',2.73),('325','2013-12-20','12:45:00',2.72),('325','2013-12-20','12:50:00',2.67),('325','2013-12-20','12:55:00',2.64),('325','2013-12-20','13:00:00',2.63),('325','2013-12-20','13:05:00',2.56),('325','2013-12-20','13:10:00',2.54),('325','2013-12-20','13:15:00',2.5),('325','2013-12-20','13:20:00',2.43),('325','2013-12-20','13:25:00',2.36),('325','2013-12-20','13:30:00',2.3),('325','2013-12-20','13:35:00',2.27),('325','2013-12-20','13:40:00',2.18),('325','2013-12-20','13:45:00',2.1),('325','2013-12-20','13:50:00',2.09),('325','2013-12-20','13:55:00',2.07),('325','2013-12-20','14:00:00',1.46),('325','2013-12-20','14:05:00',1.02),('325','2013-12-20','14:10:00',1.36),('325','2013-12-19','09:00:00',1.09),('325','2013-12-19','09:05:00',1.13),('325','2013-12-19','09:10:00',1.07),('325','2013-12-19','09:20:00',1.39),('325','2013-12-19','09:25:00',1.14),('325','2013-12-19','09:30:00',1.4),('325','2013-12-19','09:35:00',1.03),('325','2013-12-19','09:50:00',1.25),('325','2013-12-19','09:55:00',1.39),('325','2013-12-19','10:00:00',1.51),('325','2013-12-19','10:05:00',2.05),('325','2013-12-19','10:10:00',2.56),('325','2013-12-19','10:15:00',2.33),('325','2013-12-19','10:20:00',1.77),('325','2013-12-19','10:25:00',1.39),('325','2013-12-19','10:35:00',1.04),('325','2013-12-19','10:40:00',1.75),('325','2013-12-19','10:45:00',2.74),('325','2013-12-19','10:50:00',1.71),('325','2013-12-19','11:15:00',1.3),('325','2013-12-19','11:20:00',1.08),('325','2013-12-19','14:25:00',1.77),('325','2013-12-19','14:30:00',2.24),('325','2013-12-19','14:35:00',1.98),('325','2013-12-19','14:40:00',1.78),('325','2013-12-19','14:45:00',1.02),('325','2013-12-18','09:25:00',1.03),('325','2013-12-18','09:30:00',1.08),('325','2013-12-18','09:35:00',1.12),('325','2013-12-18','09:40:00',1.17),('325','2013-12-18','09:45:00',1.21),('325','2013-12-18','09:50:00',1.25),('325','2013-12-18','09:55:00',1.27),('325','2013-12-18','10:00:00',1.9),('325','2013-12-18','10:05:00',2.19),('325','2013-12-18','10:10:00',2.35),('325','2013-12-18','10:15:00',2.45),('325','2013-12-18','10:20:00',2.53),('325','2013-12-18','10:25:00',2.56),('325','2013-12-18','10:30:00',2.62),('325','2013-12-18','10:35:00',2.65),('325','2013-12-18','10:40:00',2.66),('325','2013-12-18','10:45:00',2.71),('325','2013-12-18','10:50:00',2.75),('325','2013-12-18','10:55:00',2.77),('325','2013-12-18','11:00:00',2.82),('325','2013-12-18','11:05:00',2.85),('325','2013-12-18','11:10:00',2.9),('325','2013-12-18','11:15:00',2.9),('325','2013-12-18','11:20:00',2.9),('325','2013-12-18','11:25:00',2.89),('325','2013-12-18','11:30:00',2.9),('325','2013-12-18','11:35:00',2.91),('325','2013-12-18','11:40:00',2.93),('325','2013-12-18','11:45:00',2.92),('325','2013-12-18','11:50:00',2.93),('325','2013-12-18','11:55:00',2.92),('325','2013-12-18','12:00:00',2.94),('325','2013-12-18','12:05:00',2.92),('325','2013-12-18','12:10:00',2.94),('325','2013-12-18','12:15:00',2.96),('325','2013-12-18','12:20:00',2.93),('325','2013-12-18','12:25:00',2.93),('325','2013-12-18','12:30:00',2.91),('325','2013-12-18','12:35:00',2.88),('325','2013-12-18','12:40:00',2.88),('325','2013-12-18','12:45:00',2.85),('325','2013-12-18','12:50:00',2.83),('325','2013-12-18','12:55:00',2.79),('325','2013-12-18','13:00:00',2.71),('325','2013-12-18','13:05:00',2.75),('325','2013-12-18','13:10:00',2.7),('325','2013-12-18','13:15:00',2.62),('325','2013-12-18','13:20:00',2.59),('325','2013-12-18','13:25:00',2.56),('325','2013-12-18','13:30:00',2.51),('325','2013-12-18','13:35:00',2.46),('325','2013-12-18','13:40:00',2.36),('325','2013-12-18','13:45:00',2.32),('325','2013-12-18','13:50:00',2.23),('325','2013-12-18','13:55:00',2.21),('325','2013-12-18','14:00:00',2.19),('325','2013-12-18','14:05:00',2.05),('325','2013-12-18','14:10:00',2.04),('325','2013-12-18','14:15:00',2.03),('325','2013-12-18','14:20:00',1.98),('325','2013-12-18','14:25:00',1.93),('325','2013-12-18','14:30:00',1.83),('325','2013-12-18','14:35:00',1.8),('325','2013-12-18','14:40:00',1.74),('325','2013-12-18','14:45:00',1.63),('325','2013-12-18','14:50:00',1.57),('325','2013-12-18','14:55:00',1.51),('325','2013-12-18','15:00:00',1.42),('325','2013-12-18','15:05:00',1.31),('325','2013-12-18','15:10:00',1.26),('325','2013-12-18','15:15:00',1.16),('325','2013-12-18','15:20:00',1.05),('325','2013-12-17','09:25:00',1.03),('325','2013-12-17','09:30:00',1.08),('325','2013-12-17','09:35:00',1.12),('325','2013-12-17','09:40:00',1.16),('325','2013-12-17','09:45:00',1.2),('325','2013-12-17','09:50:00',1.23),('325','2013-12-17','09:55:00',1.27),('325','2013-12-17','10:00:00',2.11),('325','2013-12-17','10:05:00',2.34),('325','2013-12-17','10:10:00',2.48),('325','2013-12-17','10:15:00',2.56),('325','2013-12-17','10:20:00',2.61),('325','2013-12-17','10:25:00',2.66),('325','2013-12-17','10:30:00',2.69),('325','2013-12-17','10:35:00',2.72),('325','2013-12-17','10:40:00',2.77),('325','2013-12-17','10:45:00',2.8),('325','2013-12-17','10:50:00',2.83),('325','2013-12-17','10:55:00',2.87),('325','2013-12-17','11:00:00',2.89),('325','2013-12-17','11:05:00',2.92),('325','2013-12-17','11:10:00',2.95),('325','2013-12-17','11:15:00',2.98),('325','2013-12-17','11:20:00',3),('325','2013-12-17','11:25:00',3),('325','2013-12-17','11:30:00',3.01),('325','2013-12-17','11:35:00',3.04),('325','2013-12-17','11:40:00',3.05),('325','2013-12-17','11:45:00',3.07),('325','2013-12-17','11:50:00',3.1),('325','2013-12-17','11:55:00',3.1),('325','2013-12-17','12:00:00',3.1),('325','2013-12-17','12:05:00',3.09),('325','2013-12-17','12:10:00',3.07),('325','2013-12-17','12:15:00',3.1),('325','2013-12-17','12:20:00',3.09),('325','2013-12-17','12:25:00',3.09),('325','2013-12-17','12:30:00',3.09),('325','2013-12-17','12:35:00',3.06),('325','2013-12-17','12:40:00',3.02),('325','2013-12-17','12:45:00',3.01),('325','2013-12-17','12:50:00',2.99),('325','2013-12-17','12:55:00',2.96),('325','2013-12-17','13:00:00',2.93),('325','2013-12-17','13:05:00',2.89),('325','2013-12-17','13:10:00',2.87),('325','2013-12-17','13:15:00',2.83),('325','2013-12-17','13:20:00',2.78),('325','2013-12-17','13:25:00',2.73),('325','2013-12-17','13:30:00',2.7),('325','2013-12-17','13:35:00',2.64),('325','2013-12-17','13:40:00',2.59),('325','2013-12-17','13:45:00',2.54),('325','2013-12-17','13:50:00',2.51),('325','2013-12-17','13:55:00',2.45),('325','2013-12-17','14:00:00',2.36),('325','2013-12-17','14:05:00',2.3),('325','2013-12-17','14:10:00',2.24),('325','2013-12-17','14:15:00',2.16),('325','2013-12-17','14:20:00',2.1),('325','2013-12-17','14:25:00',2.02),('325','2013-12-17','14:30:00',1.94),('325','2013-12-17','14:35:00',1.85),('325','2013-12-17','14:40:00',1.8),('325','2013-12-17','14:45:00',1.72),('325','2013-12-17','14:50:00',1.63),('325','2013-12-17','14:55:00',1.54),('325','2013-12-17','15:00:00',1.44),('325','2013-12-17','15:05:00',1.34),('325','2013-12-17','15:10:00',1.27),('325','2013-12-17','15:15:00',1.21),('325','2013-12-17','15:20:00',1.16),('325','2013-12-17','15:25:00',1.08),('325','2014-04-21','09:20:00',1.39),('325','2014-04-21','09:25:00',1.21),('325','2014-04-21','09:55:00',1.06),('325','2014-04-21','10:00:00',1.4),('325','2014-04-21','10:05:00',2.63),('325','2014-04-21','10:10:00',3.05),('325','2014-04-21','10:15:00',3.37),('325','2014-04-21','10:20:00',3.43),('325','2014-04-21','10:25:00',3.47),('325','2014-04-21','10:30:00',3.5),('325','2014-04-21','10:35:00',3.53),('325','2014-04-21','10:40:00',3.57),('325','2014-04-21','10:45:00',3.64),('325','2014-04-21','10:50:00',3.71),('325','2014-04-21','10:55:00',3.75),('325','2014-04-21','11:00:00',3.79),('325','2014-04-21','11:05:00',3.83),('325','2014-04-21','11:10:00',3.87),('325','2014-04-21','11:15:00',3.89),('325','2014-04-21','11:20:00',3.96),('325','2014-04-21','11:25:00',4),('325','2014-04-21','11:30:00',4.03),('325','2014-04-21','11:35:00',4.06),('325','2014-04-21','11:40:00',4.12),('325','2014-04-21','11:45:00',4.14),('325','2014-04-21','11:50:00',4.21),('325','2014-04-21','11:55:00',4.25),('325','2014-04-21','12:00:00',4.29),('325','2014-04-21','12:05:00',4.32),('325','2014-04-21','12:10:00',4.35),('325','2014-04-21','12:15:00',4.38),('325','2014-04-21','12:20:00',4.41),('325','2014-04-21','12:25:00',4.42),('325','2014-04-21','12:30:00',4.44),('325','2014-04-21','12:35:00',4.45),('325','2014-04-21','12:40:00',4.48),('325','2014-04-21','12:45:00',4.51),('325','2014-04-21','12:50:00',4.53),('325','2014-04-21','12:55:00',4.52),('325','2014-04-21','13:00:00',4.53),('325','2014-04-21','13:05:00',4.54),('325','2014-04-21','13:10:00',4.51),('325','2014-04-21','13:15:00',4.53),('325','2014-04-21','13:20:00',4.53),('325','2014-04-21','13:25:00',4.52),('325','2014-04-21','13:30:00',4.49),('325','2014-04-21','13:35:00',4.47),('325','2014-04-21','13:40:00',4.49),('325','2014-04-21','13:45:00',4.51),('325','2014-04-21','13:50:00',4.54),('325','2014-04-21','13:55:00',4.54),('325','2014-04-21','14:00:00',4.52),('325','2014-04-21','14:05:00',4.53),('325','2014-04-21','14:10:00',4.51),('325','2014-04-21','14:15:00',4.48),('325','2014-04-21','14:20:00',4.47),('325','2014-04-21','14:25:00',4.43),('325','2014-04-21','14:30:00',4.41),('325','2014-04-21','14:35:00',4.35),('325','2014-04-21','14:40:00',4.3),('325','2014-04-21','14:45:00',4.29),('325','2014-04-21','14:50:00',4.26),('325','2014-04-21','14:55:00',4.22),('325','2014-04-21','15:00:00',4.18),('325','2014-04-21','15:05:00',4.14),('325','2014-04-21','15:10:00',4.06),('325','2014-04-21','15:15:00',4.02),('325','2014-04-21','15:20:00',3.97),('325','2014-04-21','15:25:00',3.92),('325','2014-04-21','15:30:00',3.85),('325','2014-04-21','15:35:00',3.8),('325','2014-04-21','15:40:00',3.74),('325','2014-04-21','15:45:00',3.68),('325','2014-04-21','15:50:00',3.62),('325','2014-04-21','15:55:00',3.55),('325','2014-04-21','16:00:00',3.51),('325','2014-04-21','16:05:00',3.45),('325','2014-04-21','16:10:00',3.39),('325','2014-04-21','16:15:00',3.53),('325','2014-04-21','16:20:00',3.24),('325','2014-04-21','16:25:00',2.94),('325','2014-04-21','16:30:00',3.06),('325','2014-04-21','16:35:00',3.02),('325','2014-04-21','16:40:00',2.93),('325','2014-04-21','16:45:00',2.82),('325','2014-04-21','16:50:00',2.68),('325','2014-04-21','16:55:00',2.53),('325','2014-04-21','17:00:00',2.43),('325','2014-04-21','17:05:00',2.44),('325','2014-04-21','17:10:00',2.34),('325','2014-04-21','17:15:00',2.23),('325','2014-04-21','17:20:00',2.13),('325','2014-04-21','17:25:00',2.06),('325','2014-04-21','17:30:00',1.97),('325','2014-04-21','17:35:00',1.88),('325','2014-04-21','17:40:00',1.67),('325','2014-04-21','17:45:00',1.69),('325','2014-04-21','17:50:00',1.58),('325','2014-04-21','17:55:00',1.49),('325','2014-04-21','18:00:00',1.38),('325','2014-04-21','18:05:00',1.28),('325','2014-04-21','18:10:00',1.18),('325','2014-04-21','18:15:00',1.06),('325','2013-12-16','09:25:00',1.04),('325','2013-12-16','09:30:00',1.08),('325','2013-12-16','09:35:00',1.13),('325','2013-12-16','09:40:00',1.17),('325','2013-12-16','09:45:00',1.2),('325','2013-12-16','09:50:00',1.24),('325','2013-12-16','09:55:00',1.27),('325','2013-12-16','10:00:00',2.08),('325','2013-12-16','10:05:00',2.31),('325','2013-12-16','10:10:00',2.45),('325','2013-12-16','10:15:00',2.51),('325','2013-12-16','10:20:00',2.54),('325','2013-12-16','10:25:00',2.55),('325','2013-12-16','10:30:00',2.58),('325','2013-12-16','10:35:00',2.63),('325','2013-12-16','10:40:00',2.69),('325','2013-12-16','10:45:00',2.73),('325','2013-12-16','10:50:00',2.75),('325','2013-12-16','10:55:00',2.76),('325','2013-12-16','11:00:00',2.81),('325','2013-12-16','11:05:00',2.85),('325','2013-12-16','11:10:00',2.83),('325','2013-12-16','11:15:00',2.85),('325','2013-12-16','11:20:00',2.88),('325','2013-12-16','11:25:00',2.92),('325','2013-12-16','11:30:00',2.94),('325','2013-12-16','11:35:00',2.95),('325','2013-12-16','11:40:00',2.98),('325','2013-12-16','11:45:00',3.03),('325','2013-12-16','11:50:00',3.04),('325','2013-12-16','11:55:00',3.05),('325','2013-12-16','12:00:00',3.07),('325','2013-12-16','12:05:00',3.07),('325','2013-12-16','12:10:00',3.07),('325','2013-12-16','12:15:00',3.07),('325','2013-12-16','12:20:00',3.06),('325','2013-12-16','12:25:00',3.06),('325','2013-12-16','12:30:00',3.06),('325','2013-12-16','12:35:00',3.02),('325','2013-12-16','12:40:00',2.99),('325','2013-12-16','12:45:00',2.97),('325','2013-12-16','12:50:00',2.96),('325','2013-12-16','12:55:00',2.93),('325','2013-12-16','13:00:00',2.9),('325','2013-12-16','13:05:00',2.9),('325','2013-12-16','13:10:00',2.86),('325','2013-12-16','13:15:00',2.8),('325','2013-12-16','13:20:00',2.74),('325','2013-12-16','13:25:00',2.69),('325','2013-12-16','13:30:00',2.65),('325','2013-12-16','13:35:00',2.57),('325','2013-12-16','13:40:00',2.54),('325','2013-12-16','13:45:00',2.49),('325','2013-12-16','13:50:00',2.45),('325','2013-12-16','13:55:00',2.39),('325','2013-12-16','14:00:00',2.31),('325','2013-12-16','14:05:00',2.27),('325','2013-12-16','14:10:00',2.22),('325','2013-12-16','14:15:00',2.15),('325','2013-12-16','14:20:00',2.1),('325','2013-12-16','14:25:00',2.03),('325','2013-12-16','14:30:00',1.93),('325','2013-12-16','14:35:00',1.86),('325','2013-12-16','14:40:00',1.79),('325','2013-12-16','14:45:00',1.7),('325','2013-12-16','14:50:00',1.59),('325','2013-12-16','14:55:00',1.51),('325','2013-12-16','15:00:00',1.42),('325','2013-12-16','15:05:00',1.33),('325','2013-12-16','15:10:00',1.28),('325','2013-12-16','15:15:00',1.22),('325','2013-12-16','15:20:00',1.13),('325','2013-12-16','15:25:00',1.04),('325','2013-12-15','10:20:00',1.31),('325','2013-12-15','10:25:00',1.28),('325','2013-12-15','10:30:00',1.19),('325','2013-12-15','10:35:00',1.28),('325','2013-12-15','10:40:00',1.28),('325','2013-12-15','10:45:00',1.29),('325','2013-12-15','10:50:00',1.02),('325','2013-12-14','09:20:00',1.04),('325','2013-12-14','09:25:00',1.07),('325','2013-12-14','09:30:00',1.11),('325','2013-12-14','09:35:00',1.16),('325','2013-12-14','09:40:00',1.2),('325','2013-12-14','09:45:00',1.24),('325','2013-12-14','09:50:00',1.28),('325','2013-12-14','09:55:00',1.31),('325','2013-12-14','10:00:00',2.05),('325','2013-12-14','10:05:00',2.26),('325','2013-12-14','10:10:00',2.38),('325','2013-12-14','10:15:00',2.44),('325','2013-12-14','10:20:00',2.49),('325','2013-12-14','10:25:00',2.54),('325','2013-12-14','10:30:00',2.58),('325','2013-12-14','10:35:00',2.62),('325','2013-12-14','10:40:00',2.64),('325','2013-12-14','10:45:00',2.68),('325','2013-12-14','10:50:00',2.7),('325','2013-12-14','10:55:00',2.71),('325','2013-12-14','11:00:00',2.74),('325','2013-12-14','11:05:00',2.76),('325','2013-12-14','11:10:00',2.79),('325','2013-12-14','11:15:00',2.8),('325','2013-12-14','11:20:00',2.83),('325','2013-12-14','11:25:00',2.84),('325','2013-12-14','11:30:00',2.88),('325','2013-12-14','11:35:00',2.86),('325','2013-12-14','11:40:00',2.88),('325','2013-12-14','11:45:00',2.86),('325','2013-12-14','11:50:00',2.81),('325','2013-12-14','11:55:00',2.84),('325','2013-12-14','12:00:00',2.82),('325','2013-12-14','12:05:00',2.85),('325','2013-12-14','12:10:00',2.87),('325','2013-12-14','12:15:00',2.86),('325','2013-12-14','12:20:00',2.82),('325','2013-12-14','12:25:00',2.81),('325','2013-12-14','12:30:00',2.43),('325','2013-12-14','12:35:00',2.83),('325','2013-12-14','12:40:00',2.53),('325','2013-12-14','12:45:00',2.56),('325','2013-12-14','12:50:00',2.8),('325','2013-12-14','12:55:00',2.7),('325','2013-12-14','13:00:00',2.69),('325','2013-12-14','13:05:00',2.73),('325','2013-12-14','13:10:00',2.64),('325','2013-12-14','13:15:00',2.62),('325','2013-12-14','13:20:00',2.64),('325','2013-12-14','13:25:00',2.62),('325','2013-12-14','13:30:00',2.58),('325','2013-12-14','13:35:00',2.54),('325','2013-12-14','13:40:00',2.51),('325','2013-12-14','13:45:00',2.44),('325','2013-12-14','13:50:00',2.38),('325','2013-12-14','13:55:00',2.32),('325','2013-12-14','14:00:00',2.27),('325','2013-12-14','14:05:00',2.25),('325','2013-12-14','14:10:00',2.15),('325','2013-12-14','14:15:00',2.08),('325','2013-12-14','14:20:00',2.02),('325','2013-12-14','14:25:00',1.93),('325','2013-12-14','14:30:00',1.86),('325','2013-12-14','14:35:00',1.76),('325','2013-12-14','14:40:00',1.7),('325','2013-12-14','14:45:00',1.3),('325','2013-12-14','14:50:00',1.51),('325','2013-12-14','14:55:00',1.45),('325','2013-12-14','15:00:00',1.37),('325','2013-12-14','15:05:00',1.25),('325','2013-12-14','15:10:00',1.22),('325','2013-12-14','15:15:00',1.15),('325','2013-12-14','15:20:00',1.09),('325','2013-12-14','15:25:00',1),('325','2013-12-13','09:20:00',1.02),('325','2013-12-13','09:25:00',1.06),('325','2013-12-13','09:30:00',1.1),('325','2013-12-13','09:35:00',1.15),('325','2013-12-13','09:40:00',1.2),('325','2013-12-13','09:45:00',1.24),('325','2013-12-13','09:50:00',1.28),('325','2013-12-13','09:55:00',1.31),('325','2013-12-13','10:00:00',1.9),('325','2013-12-13','10:05:00',2.07),('325','2013-12-13','10:10:00',2.16),('325','2013-12-13','10:15:00',2.23),('325','2013-12-13','10:20:00',2.28),('325','2013-12-13','10:25:00',2.3),('325','2013-12-13','10:30:00',2.34),('325','2013-12-13','10:35:00',2.42),('325','2013-12-13','10:40:00',2.45),('325','2013-12-13','10:45:00',2.49),('325','2013-12-13','10:50:00',2.53),('325','2013-12-13','10:55:00',2.58),('325','2013-12-13','11:00:00',2.63),('325','2013-12-13','11:05:00',2.69),('325','2013-12-13','11:10:00',2.72),('325','2013-12-13','11:15:00',2.75),('325','2013-12-13','11:20:00',2.72),('325','2013-12-13','11:25:00',2.73),('325','2013-12-13','11:30:00',2.71),('325','2013-12-13','11:35:00',2.73),('325','2013-12-13','11:40:00',2.79),('325','2013-12-13','11:45:00',2.82),('325','2013-12-13','11:50:00',2.84),('325','2013-12-13','11:55:00',2.83),('325','2013-12-13','12:00:00',2.84),('325','2013-12-13','12:05:00',2.83),('325','2013-12-13','12:10:00',2.82),('325','2013-12-13','12:15:00',2.78),('325','2013-12-13','12:20:00',2.79),('325','2013-12-13','12:25:00',2.81),('325','2013-12-13','12:30:00',2.76),('325','2013-12-13','12:35:00',2.62),('325','2013-12-13','12:40:00',2.81),('325','2013-12-13','12:45:00',2.72),('325','2013-12-13','12:50:00',2.69),('325','2013-12-13','12:55:00',2.67),('325','2013-12-13','13:00:00',2.69),('325','2013-12-13','13:05:00',2.65),('325','2013-12-13','13:10:00',2.69),('325','2013-12-13','13:15:00',2.6),('325','2013-12-13','13:20:00',2.63),('325','2013-12-13','13:25:00',2.63),('325','2013-12-13','13:30:00',2.59),('325','2013-12-13','13:35:00',2.53),('325','2013-12-13','13:40:00',2.46),('325','2013-12-13','13:45:00',2.39),('325','2013-12-13','13:50:00',2.31),('325','2013-12-13','13:55:00',2.3),('325','2013-12-13','14:00:00',2.26),('325','2013-12-13','14:05:00',2.23),('325','2013-12-13','14:10:00',2.13),('325','2013-12-13','14:15:00',2.07),('325','2013-12-13','14:20:00',2.02),('325','2013-12-13','14:25:00',1.95),('325','2013-12-13','14:30:00',1.89),('325','2013-12-13','14:35:00',1.83),('325','2013-12-13','14:40:00',1.78),('325','2013-12-13','14:45:00',1.7),('325','2013-12-13','14:50:00',1.6),('325','2013-12-13','14:55:00',1.45),('325','2013-12-13','15:00:00',1.39),('325','2013-12-13','15:05:00',1.24),('325','2013-12-13','15:10:00',1.15),('325','2013-12-13','15:15:00',1.1),('325','2013-12-13','15:20:00',1.04),('325','2013-12-12','09:20:00',1.03),('325','2013-12-12','09:25:00',1.07),('325','2013-12-12','09:30:00',1.12),('325','2013-12-12','09:35:00',1.18),('325','2013-12-12','09:40:00',1.22),('325','2013-12-12','09:45:00',1.25),('325','2013-12-12','09:50:00',1.28),('325','2013-12-12','09:55:00',1.48),('325','2013-12-12','10:00:00',2.1),('325','2013-12-12','10:05:00',2.26),('325','2013-12-12','10:10:00',2.37),('325','2013-12-12','10:15:00',2.42),('325','2013-12-12','10:20:00',2.47),('325','2013-12-12','10:25:00',2.51),('325','2013-12-12','10:30:00',2.55),('325','2013-12-12','10:35:00',2.61),('325','2013-12-12','10:40:00',2.64),('325','2013-12-12','10:45:00',2.68),('325','2013-12-12','10:50:00',2.72),('325','2013-12-12','10:55:00',2.74),('325','2013-12-12','11:00:00',2.76),('325','2013-12-12','11:05:00',2.77),('325','2013-12-12','11:10:00',2.8),('325','2013-12-12','11:15:00',2.82),('325','2013-12-12','11:20:00',2.83),('325','2013-12-12','11:25:00',2.84),('325','2013-12-12','11:30:00',2.85),('325','2013-12-12','11:35:00',2.84),('325','2013-12-12','11:40:00',2.85),('325','2013-12-12','11:45:00',2.91),('325','2013-12-12','11:50:00',2.89),('325','2013-12-12','11:55:00',2.88),('325','2013-12-12','12:00:00',2.9),('325','2013-12-12','12:05:00',2.89),('325','2013-12-12','12:10:00',2.87),('325','2013-12-12','12:15:00',2.88),('325','2013-12-12','12:20:00',2.89),('325','2013-12-12','12:25:00',2.91),('325','2013-12-12','12:30:00',2.89),('325','2013-12-12','12:35:00',2.87),('325','2013-12-12','12:40:00',2.79),('325','2013-12-12','12:45:00',2.76),('325','2013-12-12','12:50:00',2.74),('325','2013-12-12','12:55:00',2.75),('325','2013-12-12','13:00:00',2.67),('325','2013-12-12','13:05:00',2.65),('325','2013-12-12','13:10:00',2.65),('325','2013-12-12','13:15:00',2.57),('325','2013-12-12','13:20:00',2.55),('325','2013-12-12','13:25:00',2.61),('325','2013-12-12','13:30:00',2.52),('325','2013-12-12','13:35:00',2.47),('325','2013-12-12','13:40:00',2.42),('325','2013-12-12','13:45:00',2.41),('325','2013-12-12','13:50:00',2.35),('325','2013-12-12','13:55:00',2.31),('325','2013-12-12','14:00:00',2.25),('325','2013-12-12','14:05:00',2.17),('325','2013-12-12','14:10:00',2.09),('325','2013-12-12','14:15:00',2.02),('325','2013-12-12','14:20:00',1.93),('325','2013-12-12','14:25:00',1.87),('325','2013-12-12','14:30:00',1.79),('325','2013-12-12','14:35:00',1.7),('325','2013-12-12','14:40:00',1.61),('325','2013-12-12','14:45:00',1.55),('325','2013-12-12','14:50:00',1.48),('325','2013-12-12','14:55:00',1.39),('325','2013-12-12','15:00:00',1.29),('325','2013-12-12','15:05:00',1.18),('325','2013-12-12','15:10:00',1.11),('325','2013-12-12','15:15:00',1.03),('325','2013-12-11','09:20:00',1.01),('325','2013-12-11','09:25:00',1.06),('325','2013-12-11','09:30:00',1.1),('325','2013-12-11','09:35:00',1.14),('325','2013-12-11','09:40:00',1.18),('325','2013-12-11','09:45:00',1.23),('325','2013-12-11','09:50:00',1.26),('325','2013-12-11','09:55:00',1.92),('325','2013-12-11','10:00:00',2.19),('325','2013-12-11','10:05:00',2.32),('325','2013-12-11','10:10:00',2.45),('325','2013-12-11','10:15:00',2.52),('325','2013-12-11','10:20:00',2.59),('325','2013-12-11','10:25:00',2.65),('325','2013-12-11','10:30:00',2.68),('325','2013-12-11','10:35:00',2.75),('325','2013-12-11','10:40:00',2.78),('325','2013-12-11','10:45:00',2.79),('325','2013-12-11','10:50:00',2.78),('325','2013-12-11','10:55:00',2.84),('325','2013-12-11','11:00:00',2.88),('325','2013-12-11','11:05:00',2.94),('325','2013-12-11','11:10:00',2.97),('325','2013-12-11','11:15:00',2.97),('325','2013-12-11','11:20:00',3),('325','2013-12-11','11:25:00',3),('325','2013-12-11','11:30:00',2.92),('325','2013-12-11','11:35:00',2.98),('325','2013-12-11','11:40:00',2.99),('325','2013-12-11','11:45:00',3),('325','2013-12-11','11:50:00',3.04),('325','2013-12-11','11:55:00',3.07),('325','2013-12-11','12:00:00',3.07),('325','2013-12-11','12:05:00',3.06),('325','2013-12-11','12:10:00',3.07),('325','2013-12-11','12:15:00',3.02),('325','2013-12-11','12:20:00',3),('325','2013-12-11','12:25:00',2.97),('325','2013-12-11','12:30:00',2.89),('325','2013-12-11','12:35:00',2.91),('325','2013-12-11','12:40:00',2.93),('325','2013-12-11','12:45:00',2.91),('325','2013-12-11','12:50:00',2.91),('325','2013-12-11','12:55:00',2.88),('325','2013-12-11','13:00:00',2.88),('325','2013-12-11','13:05:00',2.86),('325','2013-12-11','13:10:00',2.78),('325','2013-12-11','13:15:00',2.75),('325','2013-12-11','13:20:00',2.72),('325','2013-12-11','13:25:00',2.68),('325','2013-12-11','13:30:00',2.65),('325','2013-12-11','13:35:00',2.61),('325','2013-12-11','13:40:00',2.55),('325','2013-12-11','13:45:00',2.47),('325','2013-12-11','13:50:00',2.4),('325','2013-12-11','13:55:00',2.34),('325','2013-12-11','14:00:00',2.31),('325','2013-12-11','14:05:00',2.26),('325','2013-12-11','14:10:00',2.19),('325','2013-12-11','14:15:00',2.13),('325','2013-12-11','14:20:00',2.07),('325','2013-12-11','14:25:00',2.01),('325','2013-12-11','14:30:00',1.94),('325','2013-12-11','14:35:00',1.87),('325','2013-12-11','14:40:00',1.78),('325','2013-12-11','14:45:00',1.68),('325','2013-12-11','14:50:00',1.61),('325','2013-12-11','14:55:00',1.52),('325','2013-12-11','15:00:00',1.42),('325','2013-12-11','15:05:00',1.34),('325','2013-12-11','15:10:00',1.24),('325','2013-12-11','15:15:00',1.14),('325','2013-12-11','15:20:00',1.06),('325','2013-12-10','09:20:00',1.04),('325','2013-12-10','09:25:00',1.08),('325','2013-12-10','09:30:00',1.11),('325','2013-12-10','09:35:00',1.15),('325','2013-12-10','09:40:00',1.2),('325','2013-12-10','09:45:00',1.23),('325','2013-12-10','09:50:00',1.27),('325','2013-12-10','09:55:00',1.66),('325','2013-12-10','10:00:00',2.26),('325','2013-12-10','10:05:00',2.39),('325','2013-12-10','10:10:00',2.51),('325','2013-12-10','10:15:00',2.57),('325','2013-12-10','10:20:00',2.61),('325','2013-12-10','10:25:00',2.66),('325','2013-12-10','10:30:00',2.7),('325','2013-12-10','10:35:00',2.74),('325','2013-12-10','10:40:00',2.77),('325','2013-12-10','10:45:00',2.79),('325','2013-12-10','10:50:00',2.81),('325','2013-12-10','10:55:00',2.86),('325','2013-12-10','11:00:00',2.9),('325','2013-12-10','11:05:00',2.94),('325','2013-12-10','11:10:00',2.96),('325','2013-12-10','11:15:00',2.99),('325','2013-12-10','11:20:00',3.01),('325','2013-12-10','11:25:00',3.03),('325','2013-12-10','11:30:00',3.06),('325','2013-12-10','11:35:00',3.07),('325','2013-12-10','11:40:00',3.08),('325','2013-12-10','11:45:00',3.09),('325','2013-12-10','11:50:00',3.09),('325','2013-12-10','11:55:00',3.09),('325','2013-12-10','12:00:00',3.08),('325','2013-12-10','12:05:00',3.07),('325','2013-12-10','12:10:00',3.06),('325','2013-12-10','12:15:00',3.05),('325','2013-12-10','12:20:00',3.02),('325','2013-12-10','12:25:00',3),('325','2013-12-10','12:30:00',2.95),('325','2013-12-10','12:35:00',2.92),('325','2013-12-10','12:40:00',2.86),('325','2013-12-10','12:45:00',2.85),('325','2013-12-10','12:50:00',2.86),('325','2013-12-10','12:55:00',2.8),('325','2013-12-10','13:00:00',2.77),('325','2013-12-10','13:05:00',2.71),('325','2013-12-10','13:10:00',2.73),('325','2013-12-10','13:15:00',2.66),('325','2013-12-10','13:20:00',2.64),('325','2013-12-10','13:25:00',2.59),('325','2013-12-10','13:30:00',2.56),('325','2013-12-10','13:35:00',2.57),('325','2013-12-10','13:40:00',2.54),('325','2013-12-10','13:45:00',2.51),('325','2013-12-10','13:50:00',2.47),('325','2013-12-10','13:55:00',2.43),('325','2013-12-10','14:00:00',2.36),('325','2013-12-10','14:05:00',2.31),('325','2013-12-10','14:10:00',2.24),('325','2013-12-10','14:15:00',2.18),('325','2013-12-10','14:20:00',2.11),('325','2013-12-10','14:25:00',2.06),('325','2013-12-10','14:30:00',2.01),('325','2013-12-10','14:35:00',1.94),('325','2013-12-10','14:40:00',1.86),('325','2013-12-10','14:45:00',1.73),('325','2013-12-10','14:50:00',1.69),('325','2013-12-10','14:55:00',1.59),('325','2013-12-10','15:00:00',1.48),('325','2013-12-10','15:05:00',1.39),('325','2013-12-10','15:10:00',1.3),('325','2013-12-10','15:15:00',1.21),('325','2013-12-10','15:20:00',1.12),('325','2013-12-10','15:25:00',1.02),('325','2013-12-09','09:30:00',1.14),('325','2013-12-09','09:35:00',1.21),('325','2013-12-09','09:40:00',1.26),('325','2013-12-09','09:45:00',1.3),('325','2013-12-09','09:50:00',1.34),('325','2013-12-09','09:55:00',1.78),('325','2013-12-09','10:00:00',2.23),('325','2013-12-09','10:05:00',2.54),('325','2013-12-09','10:10:00',2.66),('325','2013-12-09','10:15:00',3.17),('325','2013-12-09','10:20:00',3.25),('325','2013-12-09','10:25:00',1.46),('325','2013-12-09','12:25:00',1.11),('325','2013-12-09','12:30:00',2.46),('325','2013-12-09','12:35:00',1.25),('325','2013-12-09','12:40:00',1.54),('325','2013-12-09','12:45:00',1.99),('325','2013-12-09','12:50:00',1.74),('325','2013-12-09','12:55:00',2.4),('325','2013-12-09','13:00:00',2.73),('325','2013-12-09','13:05:00',1.56),('325','2013-12-09','13:10:00',2.44),('325','2013-12-09','13:15:00',1.56),('325','2013-12-09','13:20:00',1.94),('325','2013-12-09','13:25:00',1.15),('325','2013-12-09','13:45:00',1),('325','2013-12-09','13:50:00',1.13),('325','2013-12-09','13:55:00',1.16),('325','2013-12-09','14:00:00',1.01),('325','2013-12-08','10:35:00',1.01),('325','2013-12-08','10:40:00',1.11),('325','2013-12-08','10:45:00',1.14),('325','2013-12-08','10:50:00',1.22),('325','2013-12-08','10:55:00',1.45),('325','2013-12-08','11:00:00',1.5),('325','2013-12-08','11:05:00',1.24),('325','2013-12-08','11:10:00',1.29),('325','2013-12-08','11:15:00',2),('325','2013-12-08','11:20:00',1.19),('325','2013-12-08','12:55:00',1.72),('325','2013-12-08','13:00:00',1.65),('325','2013-12-08','13:05:00',1.7),('325','2013-12-08','13:10:00',2.52),('325','2013-12-08','13:15:00',1.85),('325','2013-12-08','13:20:00',1.02),('325','2013-12-08','13:25:00',2.23),('325','2013-12-08','13:30:00',1.54),('325','2013-12-08','15:30:00',1.04),('325','2013-12-07','09:15:00',1.04),('325','2013-12-07','09:20:00',1.09),('325','2013-12-07','09:25:00',1.14),('325','2013-12-07','09:30:00',1.19),('325','2013-12-07','09:35:00',1.23),('325','2013-12-07','09:40:00',1.27),('325','2013-12-07','09:45:00',1.31),('325','2013-12-07','09:50:00',1.61),('325','2013-12-07','09:55:00',2.19),('325','2013-12-07','10:00:00',2.33),('325','2013-12-07','10:05:00',2.42),('325','2013-12-07','10:10:00',2.48),('325','2013-12-07','10:15:00',2.51),('325','2013-12-07','10:20:00',2.56),('325','2013-12-07','10:25:00',2.61),('325','2013-12-07','10:30:00',2.64),('325','2013-12-07','10:35:00',2.7),('325','2013-12-07','10:40:00',2.76),('325','2013-12-07','10:45:00',2.79),('325','2013-12-07','10:50:00',2.78),('325','2013-12-07','10:55:00',2.76),('325','2013-12-07','11:00:00',2.79),('325','2013-12-07','11:05:00',2.83),('325','2013-12-07','11:10:00',2.86),('325','2013-12-07','11:15:00',2.88),('325','2013-12-07','11:20:00',2.89),('325','2013-12-07','11:25:00',2.9),('325','2013-12-07','11:30:00',2.9),('325','2013-12-07','11:35:00',2.89),('325','2013-12-07','11:40:00',2.88),('325','2013-12-07','11:45:00',2.89),('325','2013-12-07','11:50:00',2.88),('325','2013-12-07','11:55:00',2.88),('325','2013-12-07','12:00:00',2.88),('325','2013-12-07','12:05:00',2.87),('325','2013-12-07','12:10:00',2.89),('325','2013-12-07','12:15:00',2.9),('325','2013-12-07','12:20:00',2.88),('325','2013-12-07','12:25:00',2.86),('325','2013-12-07','12:30:00',2.85),('325','2013-12-07','12:35:00',2.83),('325','2013-12-07','12:40:00',2.81),('325','2013-12-07','12:45:00',2.79),('325','2013-12-07','12:50:00',2.77),('325','2013-12-07','12:55:00',2.6),('325','2013-12-07','13:00:00',2.29),('325','2013-12-07','13:05:00',2.72),('325','2013-12-07','13:10:00',2.7),('325','2013-12-07','13:15:00',2.68),('325','2013-12-07','13:20:00',2.66),('325','2013-12-07','13:25:00',2.6),('325','2013-12-07','13:30:00',2.56),('325','2013-12-07','13:35:00',2.54),('325','2013-12-07','13:40:00',2.51),('325','2013-12-07','13:45:00',2.47),('325','2013-12-07','13:50:00',2.4),('325','2013-12-07','13:55:00',2.34),('325','2013-12-07','14:00:00',2.26),('325','2013-12-07','14:05:00',2.23),('325','2013-12-07','14:10:00',2.17),('325','2013-12-07','14:15:00',2.08),('325','2013-12-07','14:20:00',1.94),('325','2013-12-07','14:25:00',1.89),('325','2013-12-07','14:30:00',1.83),('325','2013-12-07','14:35:00',1.73),('325','2013-12-07','14:40:00',1.64),('325','2013-12-07','14:45:00',1.55),('325','2013-12-07','14:50:00',1.49),('325','2013-12-07','14:55:00',1.41),('325','2013-12-07','15:00:00',1.31),('325','2013-12-07','15:05:00',1.22),('325','2013-12-07','15:10:00',1.16),('325','2013-12-07','15:15:00',1.06),('325','2014-04-20','08:20:00',1.29),('325','2014-04-20','08:25:00',1.35),('325','2014-04-20','08:30:00',1.49),('325','2014-04-20','08:35:00',1.19),('325','2014-04-20','08:45:00',1.4),('325','2014-04-20','08:50:00',1.03),('325','2014-04-20','08:55:00',1.14),('325','2014-04-20','09:00:00',1.98),('325','2014-04-20','09:05:00',1.49),('325','2014-04-20','09:10:00',2.07),('325','2014-04-20','09:15:00',2.45),('325','2014-04-20','09:20:00',2.32),('325','2014-04-20','09:25:00',3.1),('325','2014-04-20','09:30:00',3.61),('325','2014-04-20','09:35:00',3.16),('325','2014-04-20','09:40:00',2.03),('325','2014-04-20','09:45:00',1.46),('325','2014-04-20','09:50:00',1.65),('325','2014-04-20','09:55:00',1.87),('325','2014-04-20','10:00:00',2.18),('325','2014-04-20','10:05:00',2.85),('325','2014-04-20','10:10:00',2.66),('325','2014-04-20','10:15:00',3.2),('325','2014-04-20','10:20:00',3.17),('325','2014-04-20','10:25:00',2.95),('325','2014-04-20','10:30:00',2.64),('325','2014-04-20','10:35:00',2.88),('325','2014-04-20','10:40:00',2.71),('325','2014-04-20','10:45:00',2.75),('325','2014-04-20','10:50:00',3.1),('325','2014-04-20','10:55:00',3.06),('325','2014-04-20','11:00:00',3.65),('325','2014-04-20','11:05:00',3.67),('325','2014-04-20','11:10:00',3.8),('325','2014-04-20','11:15:00',3.36),('325','2014-04-20','11:20:00',3.64),('325','2014-04-20','11:25:00',4.48),('325','2014-04-20','11:30:00',4.55),('325','2014-04-20','11:35:00',4.58),('325','2014-04-20','11:40:00',3.47),('325','2014-04-20','11:45:00',4),('325','2014-04-20','11:50:00',4.26),('325','2014-04-20','11:55:00',4.65),('325','2014-04-20','12:00:00',4.67),('325','2014-04-20','12:05:00',4.68),('325','2014-04-20','12:10:00',3.6),('325','2014-04-20','12:15:00',1.36),('325','2014-04-20','12:20:00',4.08),('325','2014-04-20','12:25:00',3.88),('325','2014-04-20','12:30:00',4.98),('325','2014-04-20','12:35:00',4.74),('325','2014-04-20','12:40:00',4.74),('325','2014-04-20','12:45:00',4.72),('325','2014-04-20','12:50:00',4.75),('325','2014-04-20','12:55:00',4.76),('325','2014-04-20','13:00:00',4.77),('325','2014-04-20','13:05:00',4.81),('325','2014-04-20','13:10:00',4.75),('325','2014-04-20','13:15:00',4.94),('325','2014-04-20','13:20:00',4.72),('325','2014-04-20','13:25:00',4.72),('325','2014-04-20','13:30:00',4.74),('325','2014-04-20','13:35:00',4.74),('325','2014-04-20','13:40:00',4.75),('325','2014-04-20','13:45:00',4.74),('325','2014-04-20','13:50:00',4.73),('325','2014-04-20','13:55:00',4.69),('325','2014-04-20','14:00:00',4.63),('325','2014-04-20','14:05:00',4.63),('325','2014-04-20','14:10:00',4.62),('325','2014-04-20','14:15:00',4.82),('325','2014-04-20','14:20:00',3.52),('325','2014-04-20','14:25:00',3.47),('325','2014-04-20','14:30:00',3.29),('325','2014-04-20','14:35:00',2.68),('325','2014-04-20','14:40:00',2.64),('325','2014-04-20','14:45:00',2.9),('325','2014-04-20','14:50:00',2.81),('325','2014-04-20','14:55:00',3.19),('325','2014-04-20','15:00:00',4.33),('325','2014-04-20','15:05:00',3.81),('325','2014-04-20','15:10:00',4.28),('325','2014-04-20','15:15:00',4.18),('325','2014-04-20','15:20:00',4.07),('325','2014-04-20','15:25:00',4.02),('325','2014-04-20','15:30:00',3.99),('325','2014-04-20','15:35:00',3.93),('325','2014-04-20','15:40:00',4.01),('325','2014-04-20','15:45:00',3.12),('325','2014-04-20','15:50:00',2.96),('325','2014-04-20','15:55:00',3.81),('325','2014-04-20','16:00:00',3.67),('325','2014-04-20','16:05:00',3.6),('325','2014-04-20','16:10:00',3.55),('325','2014-04-20','16:15:00',3.51),('325','2014-04-20','16:20:00',3.47),('325','2014-04-20','16:25:00',3.13),('325','2014-04-20','16:30:00',3.41),('325','2014-04-20','16:35:00',3.13),('325','2014-04-20','16:40:00',2.56),('325','2014-04-20','16:45:00',2.21),('325','2014-04-20','16:50:00',2.77),('325','2014-04-20','16:55:00',2.86),('325','2014-04-20','17:00:00',2.69),('325','2014-04-20','17:05:00',2.55),('325','2014-04-20','17:10:00',2.4),('325','2014-04-20','17:15:00',2.27),('325','2014-04-20','17:20:00',2.16),('325','2014-04-20','17:25:00',2.07),('325','2014-04-20','17:30:00',1.96),('325','2014-04-20','17:35:00',1.88),('325','2014-04-20','17:40:00',1.78),('325','2014-04-20','17:45:00',1.68),('325','2014-04-20','17:50:00',1.57),('325','2014-04-20','17:55:00',1.49),('325','2014-04-20','18:00:00',1.38),('325','2014-04-20','18:05:00',1.28),('325','2014-04-20','18:10:00',1.18),('325','2014-04-20','18:15:00',1.02),('325','2013-12-06','10:10:00',1.27),('325','2013-12-06','10:15:00',1.06),('325','2013-12-06','11:05:00',1),('325','2013-12-06','11:25:00',1.03),('325','2013-12-06','11:30:00',1.17),('325','2013-12-06','11:35:00',1.43),('325','2013-12-06','11:40:00',2.3),('325','2013-12-06','11:45:00',1.9),('325','2013-12-06','11:50:00',2.29),('325','2013-12-06','11:55:00',2.24),('325','2013-12-06','12:00:00',2.06),('325','2013-12-06','12:05:00',1.81),('325','2013-12-06','12:10:00',2.52),('325','2013-12-06','12:15:00',1.69),('325','2013-12-06','12:20:00',2.04),('325','2013-12-06','12:25:00',1.24),('325','2013-12-06','12:30:00',1.5),('325','2013-12-06','12:35:00',1.65),('325','2013-12-06','12:40:00',2.37),('325','2013-12-06','12:45:00',1.22),('325','2013-12-06','12:50:00',1.09),('325','2013-12-06','13:45:00',1.02),('325','2013-12-06','14:35:00',1.04),('325','2013-12-06','14:40:00',1.09),('325','2013-12-06','14:45:00',1.17),('325','2013-12-06','14:50:00',1.02),('325','2013-12-05','09:10:00',1.04),('325','2013-12-05','09:15:00',1.08),('325','2013-12-05','09:20:00',1.12),('325','2013-12-05','09:25:00',1.17),('325','2013-12-05','09:30:00',1.21),('325','2013-12-05','09:35:00',1.26),('325','2013-12-05','09:40:00',1.29),('325','2013-12-05','09:45:00',1.32),('325','2013-12-05','09:50:00',1.42),('325','2013-12-05','09:55:00',2.14),('325','2013-12-05','10:00:00',2.32),('325','2013-12-05','10:05:00',2.44),('325','2013-12-05','10:10:00',2.52),('325','2013-12-05','10:15:00',2.57),('325','2013-12-05','10:20:00',2.62),('325','2013-12-05','10:25:00',2.69),('325','2013-12-05','10:30:00',2.72),('325','2013-12-05','10:35:00',2.76),('325','2013-12-05','10:40:00',2.76),('325','2013-12-05','10:45:00',2.79),('325','2013-12-05','10:50:00',2.86),('325','2013-12-05','10:55:00',2.88),('325','2013-12-05','11:00:00',2.92),('325','2013-12-05','11:05:00',2.93),('325','2013-12-05','11:10:00',2.97),('325','2013-12-05','11:15:00',2.98),('325','2013-12-05','11:20:00',2.99),('325','2013-12-05','11:25:00',3.03),('325','2013-12-05','11:30:00',3.06),('325','2013-12-05','11:35:00',3.09),('325','2013-12-05','11:40:00',3.06),('325','2013-12-05','11:45:00',3.01),('325','2013-12-05','11:50:00',3.02),('325','2013-12-05','11:55:00',3.03),('325','2013-12-05','12:00:00',3.03),('325','2013-12-05','12:05:00',3.01),('325','2013-12-05','12:10:00',2.92),('325','2013-12-05','12:15:00',2.98),('325','2013-12-05','12:20:00',2.99),('325','2013-12-05','12:25:00',2.89),('325','2013-12-05','12:30:00',2.89),('325','2013-12-05','12:35:00',2.96),('325','2013-12-05','12:40:00',2.88),('325','2013-12-05','12:45:00',2.71),('325','2013-12-05','12:50:00',2.76),('325','2013-12-05','12:55:00',2.19),('325','2013-12-05','13:00:00',2.94),('325','2013-12-05','13:05:00',2.94),('325','2013-12-05','13:10:00',2.85),('325','2013-12-05','13:15:00',2.77),('325','2013-12-05','13:20:00',2.74),('325','2013-12-05','13:25:00',2.59),('325','2013-12-05','13:30:00',2.5),('325','2013-12-05','13:35:00',2.54),('325','2013-12-05','13:40:00',2.47),('325','2013-12-05','13:45:00',2.41),('325','2013-12-05','13:50:00',2.36),('325','2013-12-05','13:55:00',2.26),('325','2013-12-05','14:00:00',2.25),('325','2013-12-05','14:05:00',2.19),('325','2013-12-05','14:10:00',2.14),('325','2013-12-05','14:15:00',2.07),('325','2013-12-05','14:20:00',2.03),('325','2013-12-05','14:25:00',1.91),('325','2013-12-05','14:30:00',1.86),('325','2013-12-05','14:35:00',1.77),('325','2013-12-05','14:40:00',1.71),('325','2013-12-05','14:45:00',1.66),('325','2013-12-05','14:50:00',1.59),('325','2013-12-05','14:55:00',1.49),('325','2013-12-05','15:00:00',1.38),('325','2013-12-05','15:05:00',1.31),('325','2013-12-05','15:10:00',1.18),('325','2013-12-05','15:15:00',1.12),('325','2013-12-05','15:20:00',1.02),('325','2013-12-04','09:10:00',1.04),('325','2013-12-04','09:15:00',1.08),('325','2013-12-04','09:20:00',1.12),('325','2013-12-04','09:25:00',1.17),('325','2013-12-04','09:30:00',1.21),('325','2013-12-04','09:35:00',1.26),('325','2013-12-04','09:40:00',1.29),('325','2013-12-04','09:45:00',1.32),('325','2013-12-04','09:50:00',2.17),('325','2013-12-04','09:55:00',2.45),('325','2013-12-04','10:00:00',2.58),('325','2013-12-04','10:05:00',2.65),('325','2013-12-04','10:10:00',2.72),('325','2013-12-04','10:15:00',2.77),('325','2013-12-04','10:20:00',2.82),('325','2013-12-04','10:25:00',2.87),('325','2013-12-04','10:30:00',2.91),('325','2013-12-04','10:35:00',2.94),('325','2013-12-04','10:40:00',2.98),('325','2013-12-04','10:45:00',3.02),('325','2013-12-04','10:50:00',3.04),('325','2013-12-04','10:55:00',3.07),('325','2013-12-04','11:00:00',3.1),('325','2013-12-04','11:05:00',3.12),('325','2013-12-04','11:10:00',3.14),('325','2013-12-04','11:15:00',3.16),('325','2013-12-04','11:20:00',3.19),('325','2013-12-04','11:25:00',3.19),('325','2013-12-04','11:30:00',3.2),('325','2013-12-04','11:35:00',3.21),('325','2013-12-04','11:40:00',3.21),('325','2013-12-04','11:45:00',3.2),('325','2013-12-04','11:50:00',3.2),('325','2013-12-04','11:55:00',3.2),('325','2013-12-04','12:00:00',3.21),('325','2013-12-04','12:05:00',3.21),('325','2013-12-04','12:10:00',3.2),('325','2013-12-04','12:15:00',3.18),('325','2013-12-04','12:20:00',3.17),('325','2013-12-04','12:25:00',3.16),('325','2013-12-04','12:30:00',3.14),('325','2013-12-04','12:35:00',3.13),('325','2013-12-04','12:40:00',3.11),('325','2013-12-04','12:45:00',3.09),('325','2013-12-04','12:50:00',3.05),('325','2013-12-04','12:55:00',3.02),('325','2013-12-04','13:00:00',2.99),('325','2013-12-04','13:05:00',2.98),('325','2013-12-04','13:10:00',2.94),('325','2013-12-04','13:15:00',2.9),('325','2013-12-04','13:20:00',2.87),('325','2013-12-04','13:25:00',2.8),('325','2013-12-04','13:30:00',2.76),('325','2013-12-04','13:35:00',2.72),('325','2013-12-04','13:40:00',2.67),('325','2013-12-04','13:45:00',2.63),('325','2013-12-04','13:50:00',2.58),('325','2013-12-04','13:55:00',2.54),('325','2013-12-04','14:00:00',2.45),('325','2013-12-04','14:05:00',2.41),('325','2013-12-04','14:10:00',2.35),('325','2013-12-04','14:15:00',2.28),('325','2013-12-04','14:20:00',2.19),('325','2013-12-04','14:25:00',2.1),('325','2013-12-04','14:30:00',2.06),('325','2013-12-04','14:35:00',1.99),('325','2013-12-04','14:40:00',1.91),('325','2013-12-04','14:45:00',1.82),('325','2013-12-04','14:50:00',1.73),('325','2013-12-04','14:55:00',1.64),('325','2013-12-04','15:00:00',1.54),('325','2013-12-04','15:05:00',1.44),('325','2013-12-04','15:10:00',1.35),('325','2013-12-04','15:15:00',1.27),('325','2013-12-04','15:20:00',1.18),('325','2013-12-04','15:25:00',1.09),('325','2013-12-03','09:40:00',1.09),('325','2013-12-03','09:45:00',1.2),('325','2013-12-03','09:50:00',1.29),('325','2013-12-03','09:55:00',1.76),('325','2013-12-03','10:00:00',2.52),('325','2013-12-03','10:05:00',2.61),('325','2013-12-03','10:10:00',2.67),('325','2013-12-03','10:15:00',2.72),('325','2013-12-03','10:20:00',2.75),('325','2013-12-03','10:25:00',2.81),('325','2013-12-03','10:30:00',2.85),('325','2013-12-03','10:35:00',2.9),('325','2013-12-03','10:40:00',2.93),('325','2013-12-03','10:45:00',2.98),('325','2013-12-03','10:50:00',3.03),('325','2013-12-03','10:55:00',3.09),('325','2013-12-03','11:00:00',3.12),('325','2013-12-03','11:05:00',3.15),('325','2013-12-03','11:10:00',3.18),('325','2013-12-03','11:15:00',3.21),('325','2013-12-03','11:20:00',3.21),('325','2013-12-03','11:25:00',3.21),('325','2013-12-03','11:30:00',3.21),('325','2013-12-03','11:35:00',3.22),('325','2013-12-03','11:40:00',3.22),('325','2013-12-03','11:45:00',3.23),('325','2013-12-03','11:50:00',3.26),('325','2013-12-03','11:55:00',3.25),('325','2013-12-03','12:00:00',3.24),('325','2013-12-03','12:05:00',3.27),('325','2013-12-03','12:10:00',3.28),('325','2013-12-03','12:15:00',3.29),('325','2013-12-03','12:20:00',3.31),('325','2013-12-03','12:25:00',3.32),('325','2013-12-03','12:30:00',3.34),('325','2013-12-03','12:35:00',3.37),('325','2013-12-03','12:40:00',3.39),('325','2013-12-03','12:45:00',3.44),('325','2013-12-03','12:50:00',3.54),('325','2013-12-03','12:55:00',3.62),('325','2013-12-03','13:00:00',3.67),('325','2013-12-03','13:05:00',3.71),('325','2013-12-03','13:10:00',3.71),('325','2013-12-03','13:15:00',3.62),('325','2013-12-03','13:20:00',3.54),('325','2013-12-03','13:25:00',3.42),('325','2013-12-03','13:30:00',3.33),('325','2013-12-03','13:35:00',3.2),('325','2013-12-03','13:40:00',3.05),('325','2013-12-03','13:45:00',2.95),('325','2013-12-03','13:50:00',2.82),('325','2013-12-03','13:55:00',2.67),('325','2013-12-03','14:00:00',2.57),('325','2013-12-03','14:05:00',2.34),('325','2013-12-03','14:10:00',2.28),('325','2013-12-03','14:15:00',2.2),('325','2013-12-03','14:20:00',1.96),('325','2013-12-03','14:25:00',1.78),('325','2013-12-03','14:30:00',1.87),('325','2013-12-03','14:35:00',1.95),('325','2013-12-03','14:40:00',1.88),('325','2013-12-03','14:45:00',1.8),('325','2013-12-03','14:50:00',1.7),('325','2013-12-03','14:55:00',1.58),('325','2013-12-03','15:00:00',1.49),('325','2013-12-03','15:05:00',1.41),('325','2013-12-03','15:10:00',1.32),('325','2013-12-03','15:15:00',1.23),('325','2013-12-03','15:20:00',1.14),('325','2013-12-03','15:25:00',1.04),('325','2013-12-01','11:35:00',1.15),('325','2013-12-01','11:40:00',1.15),('325','2013-12-01','11:55:00',1.34),('325','2013-12-01','12:00:00',1.17),('325','2013-12-01','12:05:00',1.42),('325','2013-12-01','12:10:00',1.73),('325','2013-12-01','12:15:00',1.17),('325','2013-11-30','09:10:00',1.24),('325','2013-11-30','09:15:00',1.35),('325','2013-11-30','09:20:00',1.51),('325','2013-11-30','09:25:00',1.52),('325','2013-11-30','09:30:00',1.73),('325','2013-11-30','09:35:00',1.83),('325','2013-11-30','09:40:00',1.89),('325','2013-11-30','09:45:00',1.54),('325','2013-11-30','09:50:00',1.26),('325','2013-11-30','09:55:00',1.19),('325','2013-11-30','10:00:00',1.18),('325','2013-11-30','10:05:00',1.09),('325','2013-11-30','10:10:00',1.03),('325','2013-11-30','10:15:00',1.14),('325','2013-11-30','10:20:00',1.27),('325','2013-11-30','10:25:00',1.23),('325','2013-11-30','10:30:00',1.3),('325','2013-11-30','10:35:00',1.47),('325','2013-11-30','10:40:00',1.66),('325','2013-11-30','10:45:00',1.53),('325','2013-11-30','10:50:00',1.33),('325','2013-11-30','10:55:00',1.2),('325','2013-11-30','11:00:00',1.11),('325','2013-11-30','11:05:00',1.61),('325','2013-11-30','11:10:00',1.41),('325','2013-11-30','11:15:00',1.37),('325','2013-11-30','11:20:00',1.31),('325','2013-11-30','11:25:00',1.38),('325','2013-11-30','11:30:00',1.18),('325','2013-11-30','11:35:00',1.1),('325','2013-11-30','11:40:00',1.01),('325','2013-11-29','09:05:00',1.02),('325','2013-11-29','09:10:00',1.07),('325','2013-11-29','09:15:00',1.11),('325','2013-11-29','09:20:00',1.16),('325','2013-11-29','09:25:00',1.2),('325','2013-11-29','09:30:00',1.25),('325','2013-11-29','09:35:00',1.28),('325','2013-11-29','09:40:00',1.32),('325','2013-11-29','09:45:00',1.45),('325','2013-11-29','09:50:00',2.37),('325','2013-11-29','09:55:00',2.53),('325','2013-11-29','10:00:00',2.61),('325','2013-11-29','10:05:00',2.67),('325','2013-11-29','10:10:00',2.73),('325','2013-11-29','10:15:00',2.8),('325','2013-11-29','10:20:00',2.85),('325','2013-11-29','10:25:00',2.91),('325','2013-11-29','10:30:00',2.95),('325','2013-11-29','10:35:00',3),('325','2013-11-29','10:40:00',3.03),('325','2013-11-29','10:45:00',3.07),('325','2013-11-29','10:50:00',3.1),('325','2013-11-29','10:55:00',3.12),('325','2013-11-29','11:00:00',3.15),('325','2013-11-29','11:05:00',3.18),('325','2013-11-29','11:10:00',3.21),('325','2013-11-29','11:15:00',3.22),('325','2013-11-29','11:20:00',3.24),('325','2013-11-29','11:25:00',3.27),('325','2013-11-29','11:30:00',3.29),('325','2013-11-29','11:35:00',3.3),('325','2013-11-29','11:40:00',3.3),('325','2013-11-29','11:45:00',3.3),('325','2013-11-29','11:50:00',3.31),('325','2013-11-29','11:55:00',3.31),('325','2013-11-29','12:00:00',3.32),('325','2013-11-29','12:05:00',3.3),('325','2013-11-29','12:10:00',3.28),('325','2013-11-29','12:15:00',3.27),('325','2013-11-29','12:20:00',3.27),('325','2013-11-29','12:25:00',3.25),('325','2013-11-29','12:30:00',3.21),('325','2013-11-29','12:35:00',3.2),('325','2013-11-29','12:40:00',3.18),('325','2013-11-29','12:45:00',3.17),('325','2013-11-29','12:50:00',3.16),('325','2013-11-29','12:55:00',3.13),('325','2013-11-29','13:00:00',3.08),('325','2013-11-29','13:05:00',3.05),('325','2013-11-29','13:10:00',3.02),('325','2013-11-29','13:15:00',2.97),('325','2013-11-29','13:20:00',2.91),('325','2013-11-29','13:25:00',2.87),('325','2013-11-29','13:30:00',2.81),('325','2013-11-29','13:35:00',2.77),('325','2013-11-29','13:40:00',2.72),('325','2013-11-29','13:45:00',2.66),('325','2013-11-29','13:50:00',2.6),('325','2013-11-29','13:55:00',2.53),('325','2013-11-29','14:00:00',2.47),('325','2013-11-29','14:05:00',2.4),('325','2013-11-29','14:10:00',2.33),('325','2013-11-29','14:15:00',2.28),('325','2013-11-29','14:20:00',2.2),('325','2013-11-29','14:25:00',2.12),('325','2013-11-29','14:30:00',2.05),('325','2013-11-29','14:35:00',1.96),('325','2013-11-29','14:40:00',1.87),('325','2013-11-29','14:45:00',1.79),('325','2013-11-29','14:50:00',1.71),('325','2013-11-29','14:55:00',1.58),('325','2013-11-29','15:00:00',1.51),('325','2013-11-29','15:05:00',1.43),('325','2013-11-29','15:10:00',1.34),('325','2013-11-29','15:15:00',1.24),('325','2013-11-29','15:20:00',1.16),('325','2013-11-29','15:25:00',1.07),('325','2013-11-28','12:55:00',1.08),('325','2013-11-27','09:35:00',1.04),('325','2013-11-27','09:40:00',1.03),('325','2013-11-27','09:50:00',1.31),('325','2013-11-27','09:55:00',1.55),('325','2013-11-27','10:00:00',1.29),('325','2013-11-27','10:05:00',1.3),('325','2013-11-27','10:10:00',1.29),('325','2013-11-27','10:15:00',1.4),('325','2013-11-27','10:20:00',1.19),('325','2013-11-27','10:25:00',1.12),('325','2013-11-27','10:30:00',1.18),('325','2013-11-27','10:35:00',1.24),('325','2013-11-27','10:40:00',1.37),('325','2013-11-27','10:45:00',1.53),('325','2013-11-27','10:50:00',1.38),('325','2013-11-27','10:55:00',1.42),('325','2013-11-27','11:00:00',1.51),('325','2013-11-27','11:05:00',1.58),('325','2013-11-27','11:10:00',2.01),('325','2013-11-27','11:15:00',1.5),('325','2013-11-27','11:20:00',1.48),('325','2013-11-27','11:25:00',1.68),('325','2013-11-27','11:30:00',2.72),('325','2013-11-27','11:35:00',2.59),('325','2013-11-27','11:40:00',1.68),('325','2013-11-27','11:45:00',1.85),('325','2013-11-27','11:50:00',3.15),('325','2013-11-27','11:55:00',3.41),('325','2013-11-27','12:00:00',3.72),('325','2013-11-27','12:05:00',2.3),('325','2013-11-27','12:10:00',1.67),('325','2013-11-27','12:15:00',2.6),('325','2013-11-27','12:20:00',3.67),('325','2013-11-27','12:25:00',2.6),('325','2013-11-27','12:30:00',1.38),('325','2013-11-27','12:35:00',3.45),('325','2013-11-27','12:40:00',1.65),('325','2013-11-27','12:45:00',1.06),('325','2013-11-27','12:50:00',1.05),('325','2013-11-27','12:55:00',1.04),('325','2013-11-27','13:00:00',1.08),('325','2013-11-27','13:05:00',1.06),('325','2013-11-27','13:10:00',1.06),('325','2013-11-27','13:15:00',1.04),('325','2013-11-27','13:20:00',1.03),('325','2013-11-27','13:25:00',1.01),('325','2013-11-27','13:30:00',1.03),('325','2013-11-27','13:40:00',1.01),('325','2014-04-19','07:55:00',1.43),('325','2014-04-19','08:00:00',1.14),('325','2014-04-19','08:10:00',1.2),('325','2014-04-19','08:15:00',1.05),('325','2014-04-19','08:20:00',1.19),('325','2014-04-19','08:25:00',1.47),('325','2014-04-19','08:30:00',1.67),('325','2014-04-19','08:35:00',1.62),('325','2014-04-19','08:40:00',1.75),('325','2014-04-19','08:45:00',1.65),('325','2014-04-19','08:50:00',1.32),('325','2014-04-19','09:20:00',1.14),('325','2014-04-19','09:25:00',1.6),('325','2014-04-19','09:30:00',2.07),('325','2014-04-19','09:35:00',1.81),('325','2014-04-19','09:40:00',1.1),('325','2014-04-19','10:35:00',1.04),('325','2014-04-19','10:40:00',1.28),('325','2014-04-19','10:45:00',1.19),('325','2014-04-19','10:50:00',1.31),('325','2014-04-19','10:55:00',1.69),('325','2014-04-19','11:00:00',1.63),('325','2014-04-19','11:05:00',1.31),('325','2014-04-19','11:10:00',1.35),('325','2014-04-19','11:15:00',2.12),('325','2014-04-19','11:20:00',3.36),('325','2014-04-19','11:25:00',2.75),('325','2014-04-19','11:30:00',2.6),('325','2014-04-19','11:35:00',2.75),('325','2014-04-19','11:40:00',2.55),('325','2014-04-19','11:45:00',2.11),('325','2014-04-19','11:50:00',1.59),('325','2014-04-19','11:55:00',1),('325','2014-04-19','13:15:00',1.61),('325','2014-04-19','13:20:00',1.32),('325','2014-04-19','14:30:00',1.5),('325','2014-04-19','14:35:00',1.59),('325','2014-04-19','14:40:00',2.07),('325','2014-04-19','14:45:00',2.08),('325','2014-04-19','14:50:00',1.21),('325','2014-04-19','14:55:00',1.2),('325','2014-04-19','15:00:00',1.56),('325','2014-04-19','15:05:00',1.12),('325','2014-04-19','15:25:00',1.23),('325','2014-04-19','15:30:00',1.07),('325','2014-04-19','15:45:00',1.13),('325','2014-04-19','15:50:00',3.57),('325','2014-04-19','15:55:00',2.64),('325','2014-04-19','16:00:00',2.7),('325','2014-04-19','16:05:00',2.32),('325','2014-04-19','16:10:00',2.02),('325','2014-04-19','16:15:00',2.01),('325','2014-04-19','16:20:00',2.21),('325','2014-04-19','16:25:00',2.04),('325','2014-04-19','16:30:00',3.51),('325','2014-04-19','16:35:00',1.64),('325','2014-04-19','16:40:00',1.14),('325','2014-04-19','16:45:00',1.06),('325','2014-04-19','17:05:00',1.07),('325','2014-04-19','17:10:00',1.02),('325','2014-04-19','17:15:00',1.3),('325','2014-04-19','17:20:00',1.97),('325','2014-04-19','17:25:00',1.4),('325','2014-04-19','17:30:00',1.24),('325','2014-04-19','17:35:00',1.04),('325','2013-11-26','09:10:00',1.25),('325','2013-11-26','09:15:00',1.18),('325','2013-11-26','09:20:00',1.14),('325','2013-11-26','09:25:00',1.11),('325','2013-11-26','09:30:00',1.19),('325','2013-11-26','09:35:00',1.27),('325','2013-11-26','09:40:00',1.41),('325','2013-11-26','09:45:00',1.15),('325','2013-11-26','09:50:00',1.29),('325','2013-11-26','09:55:00',2.25),('325','2013-11-26','10:00:00',1.61),('325','2013-11-26','10:05:00',1.69),('325','2013-11-26','10:10:00',1.55),('325','2013-11-26','10:15:00',1.1),('325','2013-11-26','10:20:00',2.25),('325','2013-11-26','10:25:00',2.32),('325','2013-11-26','10:30:00',2.29),('325','2013-11-26','10:35:00',3.29),('325','2013-11-26','10:40:00',3.3),('325','2013-11-26','10:45:00',3.34),('325','2013-11-26','10:50:00',3.32),('325','2013-11-26','10:55:00',3.37),('325','2013-11-26','11:00:00',3.43),('325','2013-11-26','11:05:00',3.22),('325','2013-11-26','11:10:00',3.91),('325','2013-11-26','11:15:00',4.03),('325','2013-11-26','11:20:00',2.93),('325','2013-11-26','11:25:00',3.87),('325','2013-11-26','11:30:00',3.9),('325','2013-11-26','11:35:00',2.97),('325','2013-11-26','11:40:00',3.31),('325','2013-11-26','11:45:00',3.9),('325','2013-11-26','11:50:00',3.01),('325','2013-11-26','11:55:00',2.12),('325','2013-11-26','12:00:00',1.28),('325','2013-11-26','12:05:00',1.9),('325','2013-11-26','12:15:00',1.86),('325','2013-11-26','12:20:00',3.64),('325','2013-11-26','12:25:00',3.54),('325','2013-11-26','12:30:00',3.47),('325','2013-11-26','12:35:00',3.48),('325','2013-11-26','12:40:00',3.47),('325','2013-11-26','12:45:00',3.43),('325','2013-11-26','12:50:00',3.41),('325','2013-11-26','12:55:00',3.38),('325','2013-11-26','13:00:00',3.35),('325','2013-11-26','13:05:00',3.32),('325','2013-11-26','13:10:00',3.28),('325','2013-11-26','13:15:00',3.23),('325','2013-11-26','13:20:00',3.18),('325','2013-11-26','13:25:00',3.13),('325','2013-11-26','13:30:00',3.09),('325','2013-11-26','13:35:00',3.05),('325','2013-11-26','13:40:00',2.99),('325','2013-11-26','13:45:00',2.94),('325','2013-11-26','13:50:00',2.94),('325','2013-11-26','13:55:00',2.85),('325','2013-11-26','14:00:00',3),('325','2013-11-26','14:05:00',3.27),('325','2013-11-26','14:10:00',3.15),('325','2013-11-26','14:15:00',3.53),('325','2013-11-26','14:20:00',3.23),('325','2013-11-26','14:25:00',2.08),('325','2013-11-26','14:30:00',1.62),('325','2013-11-26','14:35:00',1.9),('325','2013-11-26','14:40:00',1.85),('325','2013-11-26','14:45:00',2.2),('325','2013-11-26','14:50:00',2.12),('325','2013-11-26','14:55:00',2.32),('325','2013-11-26','15:00:00',2.18),('325','2013-11-26','15:05:00',1.95),('325','2013-11-26','15:10:00',1.72),('325','2013-11-26','15:15:00',1.56),('325','2013-11-26','15:20:00',1.43),('325','2013-11-26','15:25:00',1.31),('325','2013-11-26','15:30:00',1.2),('325','2013-11-26','15:35:00',1.08),('325','2013-11-25','08:40:00',1.05),('325','2013-11-25','08:45:00',1.17),('325','2013-11-25','08:50:00',1.31),('325','2013-11-25','08:55:00',1.52),('325','2013-11-25','09:00:00',1.68),('325','2013-11-25','09:05:00',1.76),('325','2013-11-25','09:10:00',1.74),('325','2013-11-25','09:15:00',1.83),('325','2013-11-25','09:20:00',2.09),('325','2013-11-25','09:25:00',1.81),('325','2013-11-25','09:30:00',1.8),('325','2013-11-25','09:35:00',1.67),('325','2013-11-25','09:40:00',1.82),('325','2013-11-25','09:45:00',1.25),('325','2013-11-25','09:50:00',2.12),('325','2013-11-25','09:55:00',1.53),('325','2013-11-25','10:00:00',1.86),('325','2013-11-25','10:05:00',1.98),('325','2013-11-25','10:10:00',1.72),('325','2013-11-25','10:15:00',2.35),('325','2013-11-25','10:20:00',1.27),('325','2013-11-25','10:25:00',1.66),('325','2013-11-25','10:30:00',2.1),('325','2013-11-25','10:35:00',2.74),('325','2013-11-25','10:40:00',3.82),('325','2013-11-25','10:45:00',3.37),('325','2013-11-25','10:50:00',2.71),('325','2013-11-25','10:55:00',2.74),('325','2013-11-25','11:00:00',3.35),('325','2013-11-25','11:05:00',3.51),('325','2013-11-25','11:10:00',3.94),('325','2013-11-25','11:15:00',3.17),('325','2013-11-25','11:20:00',1.28),('325','2013-11-25','11:25:00',1.33),('325','2013-11-25','11:30:00',1.83),('325','2013-11-25','11:35:00',1.4),('325','2013-11-25','11:40:00',1.24),('325','2013-11-25','11:45:00',1.42),('325','2013-11-25','11:50:00',1.82),('325','2013-11-25','11:55:00',1.54),('325','2013-11-25','12:00:00',1.97),('325','2013-11-25','12:05:00',2.06),('325','2013-11-25','12:10:00',2.85),('325','2013-11-25','12:15:00',2.08),('325','2013-11-25','12:20:00',1.71),('325','2013-11-25','12:25:00',1.73),('325','2013-11-25','12:30:00',1.53),('325','2013-11-25','12:35:00',1.53),('325','2013-11-25','12:40:00',2.99),('325','2013-11-25','12:45:00',2.78),('325','2013-11-25','12:50:00',2.85),('325','2013-11-25','12:55:00',3.14),('325','2013-11-25','13:00:00',3.77),('325','2013-11-25','13:05:00',3.31),('325','2013-11-25','13:10:00',2.38),('325','2013-11-25','13:15:00',1.94),('325','2013-11-25','13:20:00',4.05),('325','2013-11-25','13:25:00',3.96),('325','2013-11-25','13:30:00',1.69),('325','2013-11-25','13:35:00',1.16),('325','2013-11-24','09:55:00',1.27),('325','2013-11-24','10:00:00',1.47),('325','2013-11-24','10:05:00',1.52),('325','2013-11-24','10:10:00',1.58),('325','2013-11-24','10:15:00',1.49),('325','2013-11-24','10:20:00',1.28),('325','2013-11-24','10:25:00',1.86),('325','2013-11-24','10:30:00',1.71),('325','2013-11-24','10:35:00',1.43),('325','2013-11-24','10:40:00',1.12),('325','2013-11-24','10:45:00',1.09),('325','2013-11-24','10:50:00',1.12),('325','2013-11-24','10:55:00',1.22),('325','2013-11-24','11:00:00',1.25),('325','2013-11-24','11:05:00',1.29),('325','2013-11-24','11:10:00',1.36),('325','2013-11-24','11:15:00',1.43),('325','2013-11-24','11:20:00',1.6),('325','2013-11-24','11:25:00',1.58),('325','2013-11-24','11:30:00',1.53),('325','2013-11-24','11:35:00',1.26),('325','2013-11-24','11:40:00',1.17),('325','2013-11-24','11:45:00',1.19),('325','2013-11-24','11:50:00',1.29),('325','2013-11-24','11:55:00',1.14),('325','2013-11-24','12:25:00',1.05),('325','2013-11-24','12:30:00',1.01),('325','2013-11-24','12:35:00',1.01),('325','2013-11-24','12:40:00',1.08),('325','2013-11-24','12:45:00',1.09),('325','2013-11-24','12:50:00',1.09),('325','2013-11-24','12:55:00',1.04),('325','2013-11-24','13:00:00',1.25),('325','2013-11-24','13:05:00',1.69),('325','2013-11-24','13:10:00',1.81),('325','2013-11-24','13:15:00',1.66),('325','2013-11-24','13:20:00',1.34),('325','2013-11-24','13:25:00',1.05),('325','2013-11-23','10:15:00',1.26),('325','2013-11-23','10:20:00',1.3),('325','2013-11-23','10:25:00',1.81),('325','2013-11-23','10:30:00',2.18),('325','2013-11-23','10:35:00',1.19),('325','2013-11-23','10:40:00',2.79),('325','2013-11-23','13:20:00',1.52),('325','2013-11-23','13:25:00',1.55),('325','2013-11-23','13:30:00',1.17),('325','2013-11-23','13:35:00',1.78),('325','2013-11-23','13:40:00',1.29),('325','2013-11-23','13:55:00',1.14),('325','2013-11-23','14:00:00',1.09),('325','2013-11-21','09:20:00',1.02),('325','2013-11-21','09:25:00',1.07),('325','2013-11-21','09:40:00',1.36),('325','2013-11-21','09:45:00',1.8),('325','2013-11-21','09:50:00',1.35),('325','2013-11-21','09:55:00',2.16),('325','2013-11-21','10:00:00',1.89),('325','2013-11-21','10:05:00',2.29),('325','2013-11-21','10:10:00',2.57),('325','2013-11-21','10:15:00',2.88),('325','2013-11-21','10:20:00',2.44),('325','2013-11-21','10:25:00',1.82),('325','2013-11-21','10:30:00',2.81),('325','2013-11-21','10:35:00',2.96),('325','2013-11-21','10:40:00',3.23),('325','2013-11-21','10:45:00',1.83),('325','2013-11-21','11:15:00',1.63),('325','2013-11-21','11:20:00',1.92),('325','2013-11-21','11:25:00',2.23),('325','2013-11-21','11:30:00',2.47),('325','2013-11-21','11:35:00',2.33),('325','2013-11-21','11:40:00',2.47),('325','2013-11-21','11:45:00',3.14),('325','2013-11-21','11:50:00',3.01),('325','2013-11-21','11:55:00',3.41),('325','2013-11-21','12:00:00',1.57),('325','2013-11-21','12:05:00',3.32),('325','2013-11-21','12:10:00',3.32),('325','2013-11-21','12:15:00',3.3),('325','2013-11-21','12:20:00',3.34),('325','2013-11-21','12:25:00',3.41),('325','2013-11-21','12:30:00',3.57),('325','2013-11-21','12:35:00',3.56),('325','2013-11-21','12:40:00',3.68),('325','2013-11-21','12:45:00',3.61),('325','2013-11-21','12:50:00',3.57),('325','2013-11-21','12:55:00',3.46),('325','2013-11-21','13:00:00',3.56),('325','2013-11-21','13:05:00',3.3),('325','2013-11-21','13:10:00',2.77),('325','2013-11-21','13:15:00',3.48),('325','2013-11-21','13:20:00',3.2),('325','2013-11-21','13:25:00',2.3),('325','2013-11-21','13:40:00',2.02),('325','2013-11-21','13:45:00',2.95),('325','2013-11-21','13:50:00',1.54),('325','2013-11-21','13:55:00',2.88),('325','2013-11-21','14:00:00',2.44),('325','2013-11-21','14:05:00',1.05),('325','2013-11-21','14:10:00',1.44),('325','2013-11-21','14:25:00',1.65),('325','2013-11-21','14:35:00',1.1),('325','2013-11-21','14:40:00',1.93),('325','2013-11-21','14:45:00',1.83),('325','2013-11-21','14:50:00',1.58),('325','2013-11-21','14:55:00',1.2),('325','2013-11-21','15:00:00',1.53),('325','2013-11-21','15:05:00',1.45),('325','2013-11-21','15:10:00',1.34),('325','2013-11-21','15:25:00',1.07),('325','2013-11-20','09:10:00',1.04),('325','2013-11-20','09:15:00',1.2),('325','2013-11-20','09:20:00',1.22),('325','2013-11-20','09:25:00',1.33),('325','2013-11-20','09:30:00',1.43),('325','2013-11-20','10:00:00',1.93),('325','2013-11-20','10:10:00',1.55),('325','2013-11-20','10:15:00',2.04),('325','2013-11-20','11:20:00',1.08),('325','2013-11-20','11:25:00',1.23),('325','2013-11-20','11:30:00',1.05),('325','2013-11-20','11:35:00',1.1),('325','2013-11-20','11:40:00',1.39),('325','2013-11-20','11:45:00',4.69),('325','2013-11-20','11:50:00',3.73),('325','2013-11-20','11:55:00',1.58),('325','2013-11-20','12:15:00',1.14),('325','2013-11-20','12:20:00',2.08),('325','2013-11-20','12:25:00',1.49),('325','2013-11-20','12:35:00',1),('325','2013-11-20','12:45:00',1.28),('325','2013-11-20','12:50:00',2.35),('325','2013-11-20','12:55:00',2.65),('325','2013-11-20','13:00:00',1.87),('325','2013-11-20','13:05:00',1.8),('325','2013-11-20','13:15:00',1.06),('325','2013-11-20','13:20:00',1.43),('325','2013-11-20','13:25:00',1.38),('325','2013-11-20','13:35:00',1.77),('325','2013-11-20','13:45:00',1.56),('325','2013-11-20','13:50:00',1.87),('325','2013-11-20','14:20:00',1.27),('325','2013-11-20','14:25:00',1.83),('325','2013-11-20','14:40:00',1.21),('325','2013-11-20','14:45:00',1.32),('325','2013-11-20','15:05:00',1.63),('325','2013-11-20','15:10:00',1.52),('325','2013-11-20','15:15:00',1.2),('325','2013-11-20','15:20:00',1.1),('325','2013-11-19','09:35:00',1.1),('325','2013-11-19','09:40:00',1.56),('325','2013-11-19','09:45:00',1.88),('325','2013-11-19','09:55:00',1.03),('325','2013-11-19','10:00:00',1.63),('325','2013-11-19','10:05:00',1.21),('325','2013-11-19','10:50:00',1.32),('325','2013-11-19','11:20:00',2.66),('325','2013-11-19','11:25:00',2.49),('325','2013-11-19','11:30:00',2.71),('325','2013-11-19','11:35:00',3.26),('325','2013-11-19','11:40:00',2.89),('325','2013-11-19','11:45:00',3.05),('325','2013-11-19','11:50:00',3),('325','2013-11-19','11:55:00',2.64),('325','2013-11-19','12:00:00',2.24),('325','2013-11-19','12:05:00',3.08),('325','2013-11-19','12:10:00',2.66),('325','2013-11-19','12:15:00',2.95),('325','2013-11-19','12:20:00',1.06),('325','2013-11-19','12:25:00',1.13),('325','2013-11-19','12:30:00',1.56),('325','2013-11-19','12:40:00',1.4),('325','2013-11-19','12:45:00',2.51),('325','2013-11-19','12:50:00',2.52),('325','2013-11-19','12:55:00',3.23),('325','2013-11-19','13:00:00',1.11),('325','2013-11-19','13:10:00',1.15),('325','2013-11-19','13:15:00',2.19),('325','2013-11-19','13:20:00',1.54),('325','2013-11-19','15:25:00',1.46),('325','2013-11-19','15:30:00',1.72),('325','2013-11-19','15:35:00',1.26),('325','2013-11-19','15:40:00',1.03),('325','2013-11-18','09:15:00',1.13),('325','2013-11-18','09:20:00',1.32),('325','2013-11-18','09:25:00',1.4),('325','2013-11-18','09:30:00',1.3),('325','2013-11-18','09:35:00',1.63),('325','2013-11-18','09:40:00',1.35),('325','2013-11-18','09:45:00',1.32),('325','2013-11-18','09:50:00',1.07),('325','2013-11-18','09:55:00',1.1),('325','2013-11-18','10:00:00',1.25),('325','2013-11-18','10:05:00',1.41),('325','2013-11-18','10:10:00',1.82),('325','2013-11-18','10:15:00',1.88),('325','2013-11-18','10:20:00',1.5),('325','2013-11-18','10:25:00',1.41),('325','2013-11-18','10:30:00',1.24),('325','2013-11-18','10:35:00',1.24),('325','2013-11-18','10:40:00',1.28),('325','2013-11-18','10:45:00',1.33),('325','2013-11-18','10:50:00',1.23),('325','2013-11-18','10:55:00',1.07),('325','2013-11-18','11:25:00',1.01),('325','2013-11-18','11:30:00',1.13),('325','2013-11-18','11:35:00',1.19),('325','2013-11-18','11:40:00',1.23),('325','2013-11-18','11:45:00',1.27),('325','2013-11-18','11:50:00',1.34),('325','2013-11-18','11:55:00',1.44),('325','2013-11-18','12:00:00',1.52),('325','2013-11-18','12:05:00',1.6),('325','2013-11-18','12:10:00',1.57),('325','2013-11-18','12:15:00',1.68),('325','2013-11-18','12:20:00',1.78),('325','2013-11-18','12:25:00',1.82),('325','2013-11-18','12:30:00',1.61),('325','2013-11-18','12:35:00',1.39),('325','2013-11-18','12:40:00',1.15),('325','2013-11-18','12:45:00',1.02),('325','2013-11-18','13:05:00',1),('325','2013-11-18','13:10:00',1.13),('325','2013-11-18','13:15:00',1.03),('325','2013-11-18','13:35:00',1.23),('325','2013-11-18','13:40:00',1.27),('325','2013-11-18','13:45:00',1.15),('325','2013-11-18','13:50:00',1.04),('325','2013-11-17','08:45:00',1.02),('325','2013-11-17','08:50:00',1.41),('325','2013-11-17','08:55:00',1.45),('325','2013-11-17','09:00:00',1.22),('325','2013-11-17','09:05:00',1.13),('325','2013-11-17','09:10:00',1.17),('325','2013-11-17','09:20:00',1.13),('325','2013-11-17','09:25:00',1.44),('325','2013-11-17','09:30:00',1.47),('325','2013-11-17','09:35:00',1.32),('325','2013-11-17','09:40:00',1.71),('325','2013-11-17','09:45:00',2.25),('325','2013-11-17','09:50:00',2.38),('325','2013-11-17','09:55:00',2.45),('325','2013-11-17','10:00:00',2.5),('325','2013-11-17','10:05:00',2.57),('325','2013-11-17','10:10:00',2.64),('325','2013-11-17','10:15:00',2.72),('325','2013-11-17','10:20:00',2.78),('325','2013-11-17','10:25:00',2.82),('325','2013-11-17','10:30:00',2.84),('325','2013-11-17','10:35:00',2.87),('325','2013-11-17','10:40:00',2.89),('325','2013-11-17','10:45:00',2.91),('325','2013-11-17','10:50:00',2.94),('325','2013-11-17','10:55:00',2.97),('325','2013-11-17','11:00:00',2.99),('325','2013-11-17','11:05:00',3.01),('325','2013-11-17','11:10:00',3.02),('325','2013-11-17','11:15:00',3.04),('325','2013-11-17','11:20:00',3.06),('325','2013-11-17','11:25:00',3.07),('325','2013-11-17','11:30:00',3.07),('325','2013-11-17','11:35:00',3.06),('325','2013-11-17','11:40:00',3.07),('325','2013-11-17','11:45:00',3.08),('325','2013-11-17','11:50:00',3.09),('325','2013-11-17','11:55:00',3.09),('325','2013-11-17','12:00:00',3.09),('325','2013-11-17','12:05:00',3.06),('325','2013-11-17','12:10:00',3.03),('325','2013-11-17','12:15:00',3.03),('325','2013-11-17','12:20:00',3.01),('325','2013-11-17','12:25:00',2.98),('325','2013-11-17','12:30:00',2.99),('325','2013-11-17','12:35:00',2.97),('325','2013-11-17','12:40:00',2.93),('325','2013-11-17','12:45:00',2.87),('325','2013-11-17','12:50:00',2.85),('325','2013-11-17','12:55:00',2.84),('325','2013-11-17','13:00:00',2.85),('325','2013-11-17','13:05:00',2.83),('325','2013-11-17','13:10:00',2.79),('325','2013-11-17','13:15:00',2.77),('325','2013-11-17','13:20:00',2.75),('325','2013-11-17','13:25:00',2.68),('325','2013-11-17','13:30:00',2.69),('325','2013-11-17','13:35:00',2.68),('325','2013-11-17','13:40:00',2.6),('325','2013-11-17','13:45:00',1.29),('325','2013-11-17','14:00:00',1.17),('325','2013-11-17','14:05:00',1.13),('325','2013-11-17','14:10:00',2.27),('325','2013-11-17','14:15:00',2.16),('325','2013-11-17','14:20:00',2.04),('325','2013-11-17','14:25:00',1.97),('325','2013-11-17','14:30:00',1.83),('325','2013-11-17','14:35:00',1.8),('325','2013-11-17','14:40:00',1.7),('325','2013-11-17','14:45:00',1.47),('325','2013-11-17','15:20:00',1.26),('325','2013-11-17','15:25:00',1.03),('325','2013-11-17','15:30:00',1.02),('325','2014-04-18','08:05:00',1.12),('325','2014-04-18','08:10:00',1.2),('325','2014-04-18','08:40:00',1.16),('325','2014-04-18','08:45:00',1.28),('325','2014-04-18','08:50:00',1.06),('325','2014-04-18','08:55:00',1),('325','2014-04-18','09:00:00',1.11),('325','2014-04-18','09:05:00',1.84),('325','2014-04-18','09:10:00',2.74),('325','2014-04-18','09:15:00',2.79),('325','2014-04-18','09:20:00',2.66),('325','2014-04-18','09:25:00',1.47),('325','2014-04-18','09:30:00',3.01),('325','2014-04-18','09:35:00',1.79),('325','2014-04-18','09:40:00',1.01),('325','2014-04-18','09:45:00',1.78),('325','2014-04-18','09:50:00',2.43),('325','2014-04-18','09:55:00',2.74),('325','2014-04-18','10:00:00',2.34),('325','2014-04-18','10:05:00',1.64),('325','2014-04-18','10:10:00',1.49),('325','2014-04-18','10:15:00',1.54),('325','2014-04-18','10:20:00',1.51),('325','2014-04-18','10:25:00',1.57),('325','2014-04-18','10:30:00',1.32),('325','2014-04-18','10:35:00',1.21),('325','2014-04-18','10:40:00',1.39),('325','2014-04-18','10:45:00',2.54),('325','2014-04-18','10:50:00',3.05),('325','2014-04-18','10:55:00',3.31),('325','2014-04-18','11:00:00',2.01),('325','2014-04-18','11:05:00',1.73),('325','2014-04-18','11:10:00',1.91),('325','2014-04-18','11:15:00',3.22),('325','2014-04-18','11:20:00',2.05),('325','2014-04-18','11:25:00',1.48),('325','2014-04-18','11:30:00',1.67),('325','2014-04-18','11:35:00',1.69),('325','2014-04-18','11:40:00',1.75),('325','2014-04-18','11:45:00',1.66),('325','2014-04-18','11:50:00',2.04),('325','2014-04-18','11:55:00',1.81),('325','2014-04-18','12:00:00',1.95),('325','2014-04-18','12:05:00',3.81),('325','2014-04-18','12:10:00',3.71),('325','2014-04-18','12:15:00',4.1),('325','2014-04-18','12:20:00',4.42),('325','2014-04-18','12:25:00',3.03),('325','2014-04-18','12:30:00',4.95),('325','2014-04-18','12:35:00',4.81),('325','2014-04-18','12:40:00',4.89),('325','2014-04-18','12:45:00',4.12),('325','2014-04-18','12:50:00',4.03),('325','2014-04-18','12:55:00',3.19),('325','2014-04-18','13:00:00',4.75),('325','2014-04-18','13:05:00',2.81),('325','2014-04-18','13:10:00',2.8),('325','2014-04-18','13:15:00',2.53),('325','2014-04-18','13:20:00',2.39),('325','2014-04-18','13:25:00',1.72),('325','2014-04-18','13:30:00',1.35),('325','2014-04-18','13:35:00',1.4),('325','2014-04-18','13:40:00',1.4),('325','2014-04-18','13:45:00',1.19),('325','2014-04-18','13:50:00',1.35),('325','2014-04-18','13:55:00',2.44),('325','2014-04-18','14:00:00',2.11),('325','2014-04-18','14:05:00',1.88),('325','2014-04-18','14:10:00',1.6),('325','2014-04-18','14:15:00',1.41),('325','2014-04-18','14:20:00',1.6),('325','2014-04-18','14:25:00',2.12),('325','2014-04-18','14:30:00',2.48),('325','2014-04-18','14:35:00',2.86),('325','2014-04-18','14:40:00',2.55),('325','2014-04-18','14:45:00',2.95),('325','2014-04-18','14:50:00',3.61),('325','2014-04-18','14:55:00',3.05),('325','2014-04-18','15:00:00',4.85),('325','2014-04-18','15:05:00',3.01),('325','2014-04-18','15:10:00',1.94),('325','2014-04-18','15:15:00',2.24),('325','2014-04-18','15:20:00',2.09),('325','2014-04-18','15:25:00',2.66),('325','2014-04-18','15:30:00',3.16),('325','2014-04-18','15:35:00',3.81),('325','2014-04-18','15:40:00',3.96),('325','2014-04-18','15:45:00',2.47),('325','2014-04-18','15:50:00',2.78),('325','2014-04-18','15:55:00',3.39),('325','2014-04-18','16:00:00',2.73),('325','2014-04-18','16:05:00',2.03),('325','2014-04-18','16:10:00',1.59),('325','2014-04-18','16:15:00',1.38),('325','2014-04-18','16:20:00',1.49),('325','2014-04-18','16:25:00',2.44),('325','2014-04-18','16:30:00',2.86),('325','2014-04-18','16:35:00',3.3),('325','2014-04-18','16:40:00',3.36),('325','2014-04-18','16:45:00',3.04),('325','2014-04-18','16:50:00',2.96),('325','2014-04-18','16:55:00',2.96),('325','2014-04-18','17:00:00',3.17),('325','2014-04-18','17:05:00',2.97),('325','2014-04-18','17:10:00',2.52),('325','2014-04-18','17:15:00',2),('325','2014-04-18','17:20:00',2.23),('325','2014-04-18','17:25:00',2.18),('325','2014-04-18','17:30:00',1.94),('325','2014-04-18','17:35:00',1.85),('325','2014-04-18','17:40:00',1.77),('325','2014-04-18','17:45:00',1.67),('325','2014-04-18','17:50:00',1.59),('325','2014-04-18','17:55:00',1.49),('325','2014-04-18','18:00:00',1.41),('325','2014-04-18','18:05:00',1.25),('325','2014-04-18','18:10:00',1.15),('325','2013-11-16','13:05:00',1.08),('325','2013-11-15','09:10:00',1.1),('325','2013-11-15','09:15:00',1.28),('325','2013-11-15','09:20:00',1.07),('325','2013-11-15','09:25:00',1.01),('325','2013-11-15','09:30:00',1.25),('325','2013-11-15','09:35:00',1.35),('325','2013-11-15','09:40:00',1.11),('325','2013-11-15','10:10:00',1.18),('325','2013-11-15','10:15:00',1.46),('325','2013-11-15','10:20:00',1.32),('325','2013-11-15','10:25:00',1.04),('325','2013-11-15','10:50:00',1.1),('325','2013-11-15','10:55:00',1.36),('325','2013-11-15','11:00:00',1.33),('325','2013-11-15','11:05:00',1.32),('325','2013-11-15','11:10:00',1.28),('325','2013-11-15','11:15:00',1.37),('325','2013-11-15','11:20:00',1.86),('325','2013-11-15','11:25:00',1.83),('325','2013-11-15','11:30:00',1.89),('325','2013-11-15','11:35:00',1.88),('325','2013-11-15','11:40:00',2.04),('325','2013-11-15','11:45:00',1.6),('325','2013-11-15','11:50:00',1.35),('325','2013-11-15','11:55:00',1.23),('325','2013-11-15','12:00:00',1.24),('325','2013-11-15','12:05:00',1.5),('325','2013-11-15','12:10:00',1.16),('325','2013-11-15','12:15:00',1.32),('325','2013-11-15','12:20:00',1.65),('325','2013-11-15','12:25:00',1.82),('325','2013-11-15','12:30:00',1.45),('325','2013-11-15','12:35:00',1.26),('325','2013-11-15','12:40:00',1.18),('325','2013-11-15','12:45:00',1.16),('325','2013-11-15','12:50:00',1.25),('325','2013-11-15','12:55:00',1.49),('325','2013-11-15','13:00:00',1.61),('325','2013-11-15','13:05:00',1.35),('325','2013-11-15','13:10:00',1.2),('325','2013-11-15','13:25:00',1.05),('325','2013-11-15','13:30:00',1.21),('325','2013-11-15','13:35:00',1.42),('325','2013-11-15','13:40:00',1.56),('325','2013-11-15','13:45:00',2.08),('325','2013-11-15','13:50:00',2.21),('325','2013-11-15','13:55:00',1.43),('325','2013-11-15','14:00:00',1.14),('325','2013-11-15','14:05:00',1.01),('325','2013-11-14','09:00:00',1.33),('325','2013-11-14','09:05:00',1.34),('325','2013-11-14','09:10:00',1.14),('325','2013-11-14','09:15:00',1.07),('325','2013-11-14','09:20:00',1.35),('325','2013-11-14','09:25:00',1.34),('325','2013-11-14','09:30:00',1.37),('325','2013-11-14','09:35:00',1.4),('325','2013-11-14','09:40:00',1.86),('325','2013-11-14','09:45:00',2.28),('325','2013-11-14','09:50:00',2.04),('325','2013-11-14','09:55:00',1.51),('325','2013-11-14','10:00:00',1.1),('325','2013-11-14','10:05:00',2.02),('325','2013-11-14','10:10:00',2.36),('325','2013-11-14','10:15:00',2.73),('325','2013-11-14','10:20:00',2.8),('325','2013-11-14','10:25:00',2.78),('325','2013-11-14','10:30:00',2.81),('325','2013-11-14','10:35:00',2.82),('325','2013-11-14','10:40:00',2.78),('325','2013-11-14','10:45:00',2.8),('325','2013-11-14','10:50:00',2.88),('325','2013-11-14','10:55:00',2.89),('325','2013-11-14','11:00:00',2.92),('325','2013-11-14','11:05:00',3.06),('325','2013-11-14','11:10:00',3.12),('325','2013-11-14','11:15:00',3.18),('325','2013-11-14','11:20:00',3.25),('325','2013-11-14','11:25:00',3.29),('325','2013-11-14','11:30:00',3.28),('325','2013-11-14','11:35:00',2.9),('325','2013-11-14','11:40:00',2.78),('325','2013-11-14','11:45:00',2.07),('325','2013-11-14','11:50:00',2.31),('325','2013-11-14','11:55:00',2.7),('325','2013-11-14','12:00:00',3.24),('325','2013-11-14','12:05:00',2.04),('325','2013-11-14','12:10:00',1.5),('325','2013-11-14','12:15:00',1.48),('325','2013-11-14','12:20:00',1.37),('325','2013-11-14','12:25:00',1.17),('325','2013-11-14','12:30:00',1.16),('325','2013-11-14','12:35:00',1.2),('325','2013-11-14','12:40:00',1.17),('325','2013-11-14','12:45:00',1.19),('325','2013-11-14','12:50:00',1.21),('325','2013-11-14','12:55:00',1.17),('325','2013-11-14','13:00:00',1.15),('325','2013-11-14','13:05:00',1.01),('325','2013-11-14','13:30:00',1.01),('325','2013-11-14','13:55:00',1.25),('325','2013-11-12','11:25:00',1.57),('325','2013-11-12','11:35:00',1.11),('325','2013-11-12','11:40:00',1.87),('325','2013-11-12','11:45:00',1.14),('325','2013-11-12','11:50:00',2.02),('325','2013-11-12','11:55:00',1.07),('325','2013-11-12','12:00:00',2.74),('325','2013-11-12','12:05:00',1.69),('325','2013-11-12','12:25:00',1.03),('325','2013-11-12','12:30:00',4.16),('325','2013-11-12','12:35:00',3.79),('325','2013-11-12','12:40:00',2.16),('325','2013-11-12','12:45:00',2.04),('325','2013-11-12','12:50:00',2.14),('325','2013-11-12','12:55:00',2.6),('325','2013-11-12','13:00:00',2.09),('325','2013-11-12','13:05:00',2.16),('325','2013-11-12','13:10:00',2.93),('325','2013-11-12','13:15:00',2.65),('325','2013-11-12','13:20:00',2.09),('325','2013-11-12','13:25:00',2.26),('325','2013-11-12','13:30:00',1.95),('325','2013-11-12','13:35:00',2.02),('325','2013-11-12','13:40:00',2.22),('325','2013-11-12','13:45:00',1.83),('325','2013-11-12','13:50:00',1.46),('325','2013-11-12','13:55:00',1.6),('325','2013-11-12','14:00:00',1.43),('325','2013-11-12','14:05:00',1.5),('325','2013-11-12','14:10:00',3.14),('325','2013-11-12','14:15:00',3.14),('325','2013-11-12','14:20:00',2.67),('325','2013-11-12','14:25:00',1.24),('325','2013-11-12','14:30:00',1.73),('325','2013-11-12','14:35:00',2.05),('325','2013-11-12','14:40:00',2.09),('325','2013-11-12','14:45:00',1.71),('325','2013-11-12','14:50:00',1.38),('325','2013-11-11','09:50:00',1.16),('325','2013-11-11','09:55:00',1.16),('325','2013-11-11','10:05:00',1.12),('325','2013-11-11','10:10:00',1.27),('325','2013-11-11','10:15:00',2.06),('325','2013-11-11','10:20:00',2.6),('325','2013-11-11','10:25:00',1.53),('325','2013-11-11','11:05:00',1.65),('325','2013-11-11','11:10:00',3.75),('325','2013-11-11','11:15:00',3.19),('325','2013-11-11','11:20:00',2.51),('325','2013-11-11','11:25:00',2.19),('325','2013-11-11','11:30:00',4.14),('325','2013-11-11','11:35:00',2.55),('325','2013-11-11','11:40:00',4.16),('325','2013-11-11','11:45:00',2.62),('325','2013-11-11','11:50:00',4.19),('325','2013-11-11','11:55:00',3.97),('325','2013-11-11','12:00:00',3.72),('325','2013-11-11','12:05:00',3.55),('325','2013-11-11','12:10:00',3.48),('325','2013-11-11','12:15:00',3.19),('325','2013-11-11','12:20:00',3.52),('325','2013-11-11','12:25:00',3.59),('325','2013-11-11','12:30:00',1.77),('325','2013-11-11','12:40:00',1.88),('325','2013-11-11','12:45:00',2.69),('325','2013-11-11','12:50:00',1.39),('325','2013-11-11','13:00:00',1.24),('325','2013-11-11','13:05:00',1.1),('325','2013-11-11','13:10:00',1.79),('325','2013-11-11','13:15:00',2.33),('325','2013-11-11','13:35:00',1.29),('325','2013-11-11','13:40:00',1.84),('325','2013-11-11','14:00:00',2.73),('325','2013-11-11','14:05:00',2.03),('325','2013-11-11','14:20:00',1.52),('325','2013-11-11','14:25:00',2.62),('325','2013-11-11','14:30:00',2.36),('325','2013-11-11','14:35:00',2.24),('325','2013-11-11','14:40:00',1.97),('325','2013-11-11','14:45:00',1.12),('325','2013-11-10','08:35:00',1.16),('325','2013-11-10','08:40:00',1.24),('325','2013-11-10','08:45:00',1.01),('325','2013-11-10','08:50:00',1.39),('325','2013-11-10','08:55:00',1.36),('325','2013-11-10','09:00:00',1.36),('325','2013-11-10','09:05:00',1.03),('325','2013-11-10','09:10:00',1.01),('325','2013-11-10','09:15:00',1.27),('325','2013-11-10','09:20:00',1.48),('325','2013-11-10','09:25:00',1.58),('325','2013-11-10','09:30:00',1.36),('325','2013-11-10','09:35:00',1.35),('325','2013-11-10','09:40:00',1.81),('325','2013-11-10','09:45:00',2.37),('325','2013-11-10','09:50:00',2.52),('325','2013-11-10','09:55:00',2.51),('325','2013-11-10','10:00:00',2.59),('325','2013-11-10','10:05:00',2.8),('325','2013-11-10','10:10:00',2.96),('325','2013-11-10','10:15:00',2.93),('325','2013-11-10','10:20:00',2.64),('325','2013-11-10','10:25:00',3.25),('325','2013-11-10','10:30:00',3.01),('325','2013-11-10','10:35:00',2.11),('325','2013-11-10','10:40:00',3.22),('325','2013-11-10','10:45:00',2.54),('325','2013-11-10','10:50:00',3.34),('325','2013-11-10','10:55:00',3.36),('325','2013-11-10','11:00:00',2.47),('325','2013-11-10','11:05:00',1.86),('325','2013-11-10','11:10:00',1.04),('325','2013-11-10','11:20:00',1.11),('325','2013-11-10','11:25:00',1.26),('325','2013-11-10','11:35:00',1.55),('325','2013-11-10','11:40:00',2.3),('325','2013-11-10','11:45:00',2.54),('325','2013-11-10','11:55:00',1.75),('325','2013-11-10','12:05:00',1.61),('325','2013-11-10','12:10:00',2.19),('325','2013-11-10','12:15:00',3.38),('325','2013-11-10','12:20:00',3.31),('325','2013-11-10','12:25:00',3.05),('325','2013-11-10','12:30:00',1.6),('325','2013-11-10','12:35:00',2.94),('325','2013-11-10','12:40:00',3.54),('325','2013-11-10','12:45:00',3.57),('325','2013-11-10','12:50:00',3.44),('325','2013-11-10','12:55:00',1.58),('325','2013-11-10','13:00:00',1.26),('325','2013-11-10','13:45:00',1.05),('325','2013-11-10','13:50:00',2.73),('325','2013-11-10','13:55:00',1.89),('325','2013-11-10','14:30:00',1.06),('325','2013-11-09','09:40:00',1.85),('325','2013-11-09','09:45:00',1.58),('325','2013-11-09','09:50:00',3.1),('325','2013-11-09','09:55:00',2.9),('325','2013-11-09','10:00:00',2.87),('325','2013-11-09','10:05:00',2.46),('325','2013-11-09','10:10:00',2.48),('325','2013-11-09','10:15:00',2.53),('325','2013-11-09','10:20:00',2.44),('325','2013-11-09','10:25:00',1.57),('325','2013-11-09','10:30:00',1.22),('325','2013-11-09','10:35:00',1.38),('325','2013-11-09','10:40:00',1.41),('325','2013-11-09','10:45:00',1.52),('325','2013-11-09','10:50:00',1.82),('325','2013-11-09','10:55:00',2.1),('325','2013-11-09','11:00:00',2.19),('325','2013-11-09','11:05:00',2.52),('325','2013-11-09','11:10:00',2.47),('325','2013-11-09','11:15:00',2.52),('325','2013-11-09','11:20:00',2.12),('325','2013-11-09','11:25:00',2.86),('325','2013-11-09','11:30:00',2.16),('325','2013-11-09','11:35:00',2.28),('325','2013-11-09','11:40:00',3.31),('325','2013-11-09','11:45:00',3.66),('325','2013-11-09','11:50:00',2.97),('325','2013-11-09','11:55:00',3.76),('325','2013-11-09','12:00:00',4.07),('325','2013-11-09','12:05:00',3.79),('325','2013-11-09','12:10:00',1.98),('325','2013-11-09','12:15:00',2.32),('325','2013-11-09','12:20:00',1.2),('325','2013-11-09','12:25:00',1.94),('325','2013-11-09','12:30:00',2.23),('325','2013-11-09','12:35:00',3.92),('325','2013-11-09','12:40:00',3.82),('325','2013-11-09','12:45:00',2.17),('325','2013-11-09','12:50:00',1.96),('325','2013-11-09','12:55:00',1.93),('325','2013-11-09','13:00:00',3.12),('325','2013-11-09','13:05:00',2.52),('325','2013-11-09','13:10:00',3.38),('325','2013-11-09','13:15:00',3.08),('325','2013-11-09','13:25:00',3.03),('325','2013-11-09','13:30:00',2.97),('325','2013-11-09','13:35:00',2.49),('325','2013-11-09','13:40:00',2.78),('325','2013-11-09','13:45:00',2.72),('325','2013-11-09','13:50:00',2.71),('325','2013-11-09','13:55:00',2.65),('325','2013-11-09','14:00:00',2.44),('325','2013-11-09','14:05:00',2.23),('325','2013-11-09','14:10:00',1.3),('325','2013-11-09','14:15:00',1.59),('325','2013-11-09','14:20:00',2.5),('325','2013-11-09','14:25:00',1.71),('325','2013-11-09','14:35:00',1.47),('325','2013-11-09','14:40:00',1.35),('325','2013-11-09','14:45:00',1.01),('325','2013-11-09','14:50:00',1.76),('325','2013-11-09','15:30:00',1.11),('325','2013-11-09','15:35:00',1.02),('325','2013-11-08','09:05:00',1.03),('325','2013-11-08','09:10:00',1.18),('325','2013-11-08','09:15:00',1.04),('325','2013-11-08','09:20:00',1.06),('325','2013-11-08','09:25:00',1.52),('325','2013-11-08','09:30:00',2),('325','2013-11-08','09:35:00',1.39),('325','2013-11-08','09:40:00',1.11),('325','2013-11-08','09:45:00',1.55),('325','2013-11-08','09:50:00',2.64),('325','2013-11-08','09:55:00',1.73),('325','2013-11-08','10:00:00',2.71),('325','2013-11-08','10:05:00',1.92),('325','2013-11-08','10:10:00',1.32),('325','2013-11-08','10:40:00',1.51),('325','2013-11-08','10:45:00',2.28),('325','2013-11-08','10:50:00',2.53),('325','2013-11-08','10:55:00',1.11),('325','2013-11-08','11:00:00',1.08),('325','2013-11-08','11:20:00',2.52),('325','2013-11-08','11:25:00',1.26),('325','2013-11-08','11:35:00',3.18),('325','2013-11-08','11:40:00',3.63),('325','2013-11-08','11:45:00',3.06),('325','2013-11-08','11:50:00',3.66),('325','2013-11-08','11:55:00',3.51),('325','2013-11-08','12:00:00',2.97),('325','2013-11-08','12:05:00',3.24),('325','2013-11-08','12:10:00',2.83),('325','2013-11-08','12:15:00',1.3),('325','2013-11-08','12:20:00',2.03),('325','2013-11-08','12:35:00',2.89),('325','2013-11-08','12:40:00',2.5),('325','2013-11-08','12:45:00',3.44),('325','2013-11-08','12:50:00',3.47),('325','2013-11-08','12:55:00',3.4),('325','2013-11-08','13:00:00',3.25),('325','2013-11-08','13:05:00',3.25),('325','2013-11-08','13:10:00',3.33),('325','2013-11-08','13:15:00',1.85),('325','2013-11-08','13:20:00',2.03),('325','2013-11-08','13:25:00',1.36),('325','2013-11-08','13:30:00',2.16),('325','2013-11-08','13:35:00',2.95),('325','2013-11-08','13:40:00',2.84),('325','2013-11-08','13:45:00',2.74),('325','2013-11-08','13:50:00',2.71),('325','2013-11-08','13:55:00',2.68),('325','2013-11-08','14:00:00',2.58),('325','2013-11-08','14:05:00',2.48),('325','2013-11-08','14:10:00',2.43),('325','2013-11-08','14:20:00',2.31),('325','2013-11-08','14:25:00',2.14),('325','2013-11-08','14:30:00',2.26),('325','2013-11-08','14:35:00',2.11),('325','2013-11-08','14:40:00',2.04),('325','2013-11-08','14:45:00',1.91),('325','2013-11-08','14:50:00',1.03),('325','2013-11-08','15:00:00',1.57),('325','2013-11-08','15:05:00',1.62),('325','2013-11-08','15:10:00',1.49),('325','2013-11-08','15:25:00',1.04),('325','2013-11-07','08:50:00',1.02),('325','2013-11-07','08:55:00',1.06),('325','2013-11-07','09:00:00',1.1),('325','2013-11-07','09:05:00',1.14),('325','2013-11-07','09:10:00',1.18),('325','2013-11-07','09:15:00',1.22),('325','2013-11-07','09:20:00',1.25),('325','2013-11-07','09:25:00',1.28),('325','2013-11-07','09:30:00',1.31),('325','2013-11-07','09:35:00',1.95),('325','2013-11-07','09:40:00',2.36),('325','2013-11-07','09:45:00',2.47),('325','2013-11-07','09:50:00',2.51),('325','2013-11-07','09:55:00',2.56),('325','2013-11-07','10:00:00',2.62),('325','2013-11-07','10:05:00',2.67),('325','2013-11-07','10:10:00',2.7),('325','2013-11-07','10:15:00',2.72),('325','2013-11-07','10:20:00',2.75),('325','2013-11-07','10:25:00',2.83),('325','2013-11-07','10:30:00',2.86),('325','2013-11-07','10:35:00',2.89),('325','2013-11-07','10:40:00',2.9),('325','2013-11-07','10:45:00',2.95),('325','2013-11-07','10:50:00',2.93),('325','2013-11-07','10:55:00',2.95),('325','2013-11-07','11:00:00',2.97),('325','2013-11-07','11:05:00',2.99),('325','2013-11-07','11:10:00',2.97),('325','2013-11-07','11:15:00',3),('325','2013-11-07','11:20:00',2.98),('325','2013-11-07','11:25:00',2.98),('325','2013-11-07','11:30:00',3.04),('325','2013-11-07','11:35:00',3.06),('325','2013-11-07','11:40:00',3.05),('325','2013-11-07','11:45:00',3.04),('325','2013-11-07','11:50:00',3.06),('325','2013-11-07','11:55:00',3.04),('325','2013-11-07','12:00:00',3.02),('325','2013-11-07','12:15:00',2.95),('325','2013-11-07','12:20:00',2.94),('325','2013-11-07','12:25:00',2.99),('325','2013-11-07','12:30:00',3.01),('325','2013-11-07','12:35:00',2.99),('325','2013-11-07','12:40:00',2.99),('325','2013-11-07','12:45:00',2.92),('325','2013-11-07','12:50:00',2.86),('325','2013-11-07','12:55:00',2.88),('325','2013-11-07','13:00:00',2.97),('325','2013-11-07','13:05:00',2.25),('325','2013-11-07','13:10:00',1.18),('325','2013-11-07','13:15:00',1.19),('325','2013-11-07','13:20:00',1.27),('325','2013-11-07','13:25:00',2.76),('325','2013-11-07','13:30:00',3.07),('325','2013-11-07','13:35:00',2.96),('325','2013-11-07','13:40:00',1.92),('325','2013-11-07','13:45:00',2.17),('325','2013-11-07','13:50:00',2.53),('325','2013-11-07','13:55:00',2.06),('325','2013-11-07','14:00:00',1.55),('325','2013-11-07','14:05:00',1.64),('325','2013-11-07','14:10:00',2.05),('325','2013-11-07','14:20:00',2.1),('325','2013-11-07','14:25:00',1.69),('325','2013-11-07','14:30:00',1.89),('325','2013-11-07','14:35:00',2),('325','2013-11-07','14:40:00',2),('325','2013-11-07','14:45:00',1.9),('325','2013-11-07','14:50:00',1.84),('325','2013-11-07','14:55:00',1.74),('325','2013-11-07','15:00:00',1.63),('325','2013-11-07','15:05:00',1.56),('325','2013-11-07','15:10:00',1.45),('325','2013-11-07','15:15:00',1.37),('325','2013-11-07','15:20:00',1.28),('325','2013-11-07','15:25:00',1.2),('325','2013-11-07','15:30:00',1.12),('325','2013-11-07','15:35:00',1.02),('325','2014-04-17','08:40:00',1.05),('325','2014-04-17','08:45:00',1.1),('325','2014-04-17','08:50:00',1.18),('325','2014-04-17','08:55:00',1.26),('325','2014-04-17','09:00:00',1.55),('325','2014-04-17','09:05:00',1.96),('325','2014-04-17','09:10:00',2.19),('325','2014-04-17','09:15:00',2.37),('325','2014-04-17','09:20:00',2.55),('325','2014-04-17','09:25:00',2.61),('325','2014-04-17','09:30:00',2.75),('325','2014-04-17','09:35:00',2.66),('325','2014-04-17','09:40:00',2.47),('325','2014-04-17','09:45:00',2.61),('325','2014-04-17','09:50:00',3.06),('325','2014-04-17','09:55:00',3.19),('325','2014-04-17','10:00:00',3.35),('325','2014-04-17','10:05:00',3.61),('325','2014-04-17','10:10:00',3.43),('325','2014-04-17','10:15:00',2.61),('325','2014-04-17','10:20:00',3.78),('325','2014-04-17','10:25:00',3.91),('325','2014-04-17','10:30:00',4.23),('325','2014-04-17','10:35:00',4.47),('325','2014-04-17','10:40:00',4.19),('325','2014-04-17','10:45:00',3.82),('325','2014-04-17','10:50:00',2.81),('325','2014-04-17','10:55:00',2.51),('325','2014-04-17','11:00:00',2.91),('325','2014-04-17','11:05:00',3.18),('325','2014-04-17','11:10:00',3.14),('325','2014-04-17','11:15:00',2.34),('325','2014-04-17','11:20:00',3.1),('325','2014-04-17','11:25:00',4.19),('325','2014-04-17','11:30:00',2.68),('325','2014-04-17','11:35:00',2.31),('325','2014-04-17','11:40:00',2.54),('325','2014-04-17','11:45:00',4.29),('325','2014-04-17','11:50:00',3.38),('325','2014-04-17','11:55:00',2.46),('325','2014-04-17','12:00:00',3.31),('325','2014-04-17','12:05:00',3.14),('325','2014-04-17','12:10:00',2.71),('325','2014-04-17','12:15:00',2.36),('325','2014-04-17','12:20:00',2.71),('325','2014-04-17','12:25:00',3.16),('325','2014-04-17','12:30:00',3.62),('325','2014-04-17','12:35:00',4.12),('325','2014-04-17','12:40:00',4.79),('325','2014-04-17','12:45:00',4.54),('325','2014-04-17','12:50:00',3.01),('325','2014-04-17','12:55:00',2.64),('325','2014-04-17','13:00:00',5.08),('325','2014-04-17','13:05:00',5.07),('325','2014-04-17','13:10:00',4.47),('325','2014-04-17','13:15:00',4.12),('325','2014-04-17','13:20:00',1.99),('325','2014-04-17','13:25:00',4.6),('325','2014-04-17','13:30:00',4.59),('325','2014-04-17','13:35:00',1.82),('325','2014-04-17','13:40:00',1.01),('325','2014-04-17','13:50:00',2.73),('325','2014-04-17','13:55:00',1.67),('325','2014-04-17','14:00:00',1.06),('325','2014-04-17','14:05:00',1.2),('325','2014-04-17','14:10:00',2.95),('325','2014-04-17','14:15:00',4.49),('325','2014-04-17','14:20:00',1.53),('325','2014-04-17','14:25:00',2.25),('325','2014-04-17','14:30:00',1.91),('325','2014-04-17','14:35:00',2.57),('325','2014-04-17','14:40:00',3.67),('325','2014-04-17','14:45:00',1.45),('325','2014-04-17','15:25:00',1.14),('325','2014-04-17','15:30:00',2.19),('325','2014-04-17','15:35:00',2.81),('325','2014-04-17','15:40:00',2.06),('325','2014-04-17','15:45:00',1.49),('325','2014-04-17','15:50:00',1.25),('325','2014-04-17','15:55:00',1.4),('325','2014-04-17','16:00:00',1.15),('325','2014-04-17','16:10:00',1.09),('325','2014-04-17','16:15:00',1.09),('325','2014-04-17','16:20:00',1.03),('325','2014-04-17','16:25:00',1.17),('325','2014-04-17','16:30:00',1.19),('325','2014-04-17','16:35:00',1.08),('325','2014-04-17','16:40:00',1.3),('325','2014-04-17','16:45:00',1.9),('325','2014-04-17','16:50:00',1.8),('325','2014-04-17','16:55:00',1.35),('325','2014-04-17','17:00:00',1.1),('325','2014-04-17','17:15:00',1.02),('325','2014-04-17','17:20:00',1.17),('325','2014-04-17','17:30:00',1.02),('325','2014-04-17','17:35:00',1.08),('325','2014-04-17','17:40:00',1.02),('325','2013-11-06','08:45:00',1.02),('325','2013-11-06','08:50:00',1.13),('325','2013-11-06','08:55:00',1.13),('325','2013-11-06','09:15:00',1.11),('325','2013-11-06','09:20:00',1.12),('325','2013-11-06','09:25:00',1.31),('325','2013-11-06','09:30:00',1.53),('325','2013-11-06','09:35:00',2.31),('325','2013-11-06','09:40:00',2.46),('325','2013-11-06','09:45:00',2.58),('325','2013-11-06','09:50:00',2.61),('325','2013-11-06','09:55:00',2.66),('325','2013-11-06','10:00:00',2.72),('325','2013-11-06','10:05:00',2.79),('325','2013-11-06','10:10:00',2.84),('325','2013-11-06','10:15:00',2.89),('325','2013-11-06','10:20:00',2.93),('325','2013-11-06','10:25:00',2.98),('325','2013-11-06','10:30:00',3.01),('325','2013-11-06','10:35:00',3.05),('325','2013-11-06','10:40:00',3.08),('325','2013-11-06','10:45:00',3.12),('325','2013-11-06','10:50:00',3.16),('325','2013-11-06','10:55:00',3.17),('325','2013-11-06','11:00:00',3.19),('325','2013-11-06','11:05:00',3.21),('325','2013-11-06','11:10:00',3.23),('325','2013-11-06','11:15:00',3.25),('325','2013-11-06','11:20:00',3.27),('325','2013-11-06','11:25:00',3.28),('325','2013-11-06','11:30:00',3.28),('325','2013-11-06','11:35:00',3.26),('325','2013-11-06','11:40:00',3.28),('325','2013-11-06','11:45:00',3.31),('325','2013-11-06','11:50:00',3.28),('325','2013-11-06','11:55:00',3.3),('325','2013-11-06','12:00:00',3.3),('325','2013-11-06','12:05:00',3.28),('325','2013-11-06','12:10:00',3.27),('325','2013-11-06','12:15:00',3.25),('325','2013-11-06','12:20:00',3.25),('325','2013-11-06','12:25:00',3.24),('325','2013-11-06','12:30:00',3.23),('325','2013-11-06','12:35:00',3.22),('325','2013-11-06','12:40:00',3.18),('325','2013-11-06','12:45:00',3.17),('325','2013-11-06','12:50:00',3.13),('325','2013-11-06','12:55:00',3.09),('325','2013-11-06','13:00:00',3.07),('325','2013-11-06','13:05:00',3.04),('325','2013-11-06','13:10:00',2.98),('325','2013-11-06','13:15:00',2.96),('325','2013-11-06','13:20:00',2.93),('325','2013-11-06','13:25:00',2.89),('325','2013-11-06','13:30:00',2.84),('325','2013-11-06','13:35:00',2.8),('325','2013-11-06','13:40:00',2.75),('325','2013-11-06','13:45:00',2.69),('325','2013-11-06','13:50:00',2.64),('325','2013-11-06','13:55:00',2.59),('325','2013-11-06','14:00:00',2.52),('325','2013-11-06','14:05:00',2.49),('325','2013-11-06','14:10:00',2.45),('325','2013-11-06','14:15:00',2.39),('325','2013-11-06','14:20:00',2.33),('325','2013-11-06','14:25:00',2.25),('325','2013-11-06','14:30:00',2.19),('325','2013-11-06','14:35:00',2.12),('325','2013-11-06','14:40:00',2.04),('325','2013-11-06','14:45:00',1.96),('325','2013-11-06','14:50:00',1.87),('325','2013-11-06','14:55:00',1.77),('325','2013-11-06','15:00:00',1.68),('325','2013-11-06','15:05:00',1.6),('325','2013-11-06','15:10:00',1.52),('325','2013-11-06','15:15:00',1.44),('325','2013-11-06','15:20:00',1.35),('325','2013-11-06','15:25:00',1.24),('325','2013-11-06','15:30:00',1.16),('325','2013-11-06','15:35:00',1.06),('325','2013-11-05','08:30:00',1.11),('325','2013-11-05','08:35:00',1.35),('325','2013-11-05','08:40:00',1.33),('325','2013-11-05','10:15:00',1.07),('325','2013-11-05','10:20:00',1.76),('325','2013-11-05','10:25:00',2.37),('325','2013-11-05','10:30:00',1.61),('325','2013-11-05','10:35:00',2.55),('325','2013-11-05','10:40:00',1.66),('325','2013-11-05','10:45:00',1.84),('325','2013-11-05','10:50:00',1.4),('325','2013-11-05','10:55:00',1.2),('325','2013-11-05','11:35:00',1.2),('325','2013-11-05','11:40:00',1.55),('325','2013-11-05','11:45:00',1.44),('325','2013-11-05','11:50:00',1.35),('325','2013-11-05','11:55:00',1.18),('325','2013-11-05','12:00:00',1.05),('325','2013-11-05','12:05:00',1.38),('325','2013-11-05','12:10:00',1.64),('325','2013-11-05','12:15:00',1.62),('325','2013-11-05','12:20:00',1.68),('325','2013-11-05','12:25:00',1.68),('325','2013-11-05','12:30:00',1.61),('325','2013-11-05','12:35:00',1.12),('325','2013-11-05','13:30:00',1.3),('325','2013-11-05','13:35:00',2.61),('325','2013-11-05','13:40:00',2.83),('325','2013-11-05','13:45:00',2.32),('325','2013-11-05','13:50:00',1.24),('325','2013-11-05','13:55:00',2.02),('325','2013-11-05','14:00:00',1.36),('325','2013-11-05','14:05:00',3.18),('325','2013-11-05','14:10:00',2.49),('325','2013-11-05','14:20:00',1.27),('325','2013-11-05','14:25:00',1.55),('325','2013-11-05','14:30:00',2.07),('325','2013-11-05','14:35:00',1.59),('325','2013-11-05','14:45:00',1.68),('325','2013-11-05','15:15:00',1.07),('325','2013-11-05','15:30:00',1.29),('325','2013-11-05','15:35:00',1.06),('325','2013-11-04','09:10:00',1.42),('325','2013-11-04','09:15:00',1.73),('325','2013-11-04','09:20:00',1.92),('325','2013-11-04','09:25:00',2.07),('325','2013-11-04','10:00:00',2.31),('325','2013-11-04','10:05:00',2.92),('325','2013-11-04','10:10:00',2.96),('325','2013-11-04','10:15:00',3.03),('325','2013-11-04','10:20:00',2.84),('325','2013-11-04','10:25:00',3.43),('325','2013-11-04','10:30:00',3.52),('325','2013-11-04','10:35:00',2.69),('325','2013-11-04','10:40:00',3.91),('325','2013-11-04','10:45:00',2.32),('325','2013-11-04','10:50:00',3.39),('325','2013-11-04','10:55:00',3.35),('325','2013-11-04','11:00:00',2.58),('325','2013-11-04','11:05:00',3.65),('325','2013-11-04','11:10:00',1.38),('325','2013-11-04','11:15:00',1.97),('325','2013-11-04','11:20:00',1.85),('325','2013-11-04','11:25:00',1.52),('325','2013-11-04','11:30:00',2.78),('325','2013-11-04','11:35:00',2.7),('325','2013-11-04','11:40:00',2.41),('325','2013-11-04','11:45:00',2.75),('325','2013-11-04','11:50:00',4.34),('325','2013-11-04','11:55:00',3.76),('325','2013-11-04','12:00:00',3.56),('325','2013-11-04','12:05:00',3.56),('325','2013-11-04','12:10:00',3.52),('325','2013-11-04','12:15:00',3.48),('325','2013-11-04','12:20:00',3.48),('325','2013-11-04','12:25:00',3.45),('325','2013-11-04','12:30:00',3.44),('325','2013-11-04','12:35:00',3.48),('325','2013-11-04','12:40:00',3.43),('325','2013-11-04','12:45:00',3.4),('325','2013-11-04','12:50:00',3.32),('325','2013-11-04','12:55:00',3.26),('325','2013-11-04','13:00:00',3.24),('325','2013-11-04','13:05:00',3.22),('325','2013-11-04','13:10:00',3.16),('325','2013-11-04','13:15:00',3.14),('325','2013-11-04','13:20:00',2.8),('325','2013-11-04','13:25:00',2.84),('325','2013-11-04','13:30:00',3.02),('325','2013-11-04','13:35:00',3.02),('325','2013-11-04','13:40:00',2.57),('325','2013-11-04','13:45:00',2.99),('325','2013-11-04','13:50:00',2.85),('325','2013-11-04','13:55:00',1.71),('325','2013-11-04','14:00:00',1.24),('325','2013-11-04','14:05:00',2.61),('325','2013-11-04','14:10:00',2.7),('325','2013-11-04','14:15:00',1.95),('325','2013-11-04','14:20:00',1.62),('325','2013-11-04','14:25:00',1.24),('325','2013-11-04','14:30:00',1.23),('325','2013-11-04','14:35:00',2.54),('325','2013-11-04','14:40:00',2.2),('325','2013-11-04','14:45:00',2.16),('325','2013-11-04','14:50:00',2.05),('325','2013-11-04','14:55:00',1.96),('325','2013-11-04','15:00:00',1.79),('325','2013-11-04','15:10:00',1.4),('325','2013-11-04','15:15:00',1.46),('325','2013-11-04','15:20:00',1.4),('325','2013-11-04','15:25:00',1.39),('325','2013-11-04','15:30:00',1.27),('325','2013-11-04','15:35:00',1.18),('325','2013-11-04','15:45:00',1.1),('325','2013-11-03','08:50:00',1.39),('325','2013-11-03','09:35:00',1.15),('325','2013-11-03','09:40:00',2.86),('325','2013-11-03','09:45:00',1.19),('325','2013-11-03','10:05:00',1.32),('325','2013-11-03','10:10:00',1.36),('325','2013-11-03','10:20:00',2.85),('325','2013-11-03','10:25:00',1.82),('325','2013-11-03','10:30:00',3.17),('325','2013-11-03','10:35:00',2.29),('325','2013-11-03','11:15:00',1.12),('325','2013-11-03','11:20:00',2.38),('325','2013-11-03','11:25:00',1.51),('325','2013-11-03','11:30:00',2.81),('325','2013-11-03','11:35:00',3.21),('325','2013-11-03','11:40:00',3.63),('325','2013-11-03','11:45:00',3.69),('325','2013-11-03','11:50:00',3.43),('325','2013-11-03','11:55:00',2.65),('325','2013-11-03','12:00:00',2.24),('325','2013-11-03','12:05:00',3.87),('325','2013-11-03','12:10:00',2.57),('325','2013-11-03','12:15:00',2.11),('325','2013-11-03','12:20:00',1.23),('325','2013-11-03','12:25:00',2.23),('325','2013-11-03','12:30:00',1.11),('325','2013-11-03','12:35:00',1.32),('325','2013-11-03','12:40:00',1.37),('325','2013-11-03','12:45:00',1.06),('325','2013-11-03','12:50:00',1.13),('325','2013-11-03','13:25:00',1.05),('325','2013-11-03','13:30:00',1.05),('325','2013-11-03','13:35:00',1.2),('325','2013-11-03','13:40:00',1.68),('325','2013-11-03','13:45:00',2.12),('325','2013-11-03','13:55:00',1.58),('325','2013-11-03','14:00:00',1.33),('325','2013-11-03','14:05:00',2.16),('325','2013-11-03','14:10:00',2.57),('325','2013-11-03','14:15:00',2.58),('325','2013-11-03','14:20:00',1.94),('325','2013-11-03','14:25:00',1.87),('325','2013-11-03','14:30:00',1.33),('325','2013-11-03','14:35:00',1.74),('325','2013-11-03','14:40:00',2.15),('325','2013-11-03','14:45:00',1.85),('325','2013-11-03','14:50:00',1.43),('325','2013-11-03','14:55:00',1.06),('325','2013-11-03','15:05:00',1.2),('325','2013-11-02','08:45:00',1.02),('325','2013-11-02','08:50:00',1.07),('325','2013-11-02','08:55:00',1.13),('325','2013-11-02','09:00:00',1.21),('325','2013-11-02','09:05:00',1.41),('325','2013-11-02','09:10:00',1.4),('325','2013-11-02','09:15:00',1.36),('325','2013-11-02','09:20:00',1.35),('325','2013-11-02','09:25:00',1.49),('325','2013-11-02','09:30:00',1.5),('325','2013-11-02','09:35:00',2.07),('325','2013-11-02','09:40:00',2.28),('325','2013-11-02','09:45:00',2.4),('325','2013-11-02','09:50:00',2.56),('325','2013-11-02','09:55:00',2.42),('325','2013-11-02','10:00:00',2.91),('325','2013-11-02','10:05:00',2.77),('325','2013-11-02','10:10:00',1.33),('325','2013-11-02','10:15:00',1.25),('325','2013-11-02','10:55:00',1.03),('325','2013-11-02','11:00:00',1.28),('325','2013-11-02','11:05:00',1.41),('325','2013-11-02','11:10:00',1.15),('325','2013-11-02','11:45:00',1.05),('325','2013-11-02','11:50:00',1.48),('325','2013-11-02','11:55:00',2.61),('325','2013-11-02','12:00:00',3.65),('325','2013-11-02','12:05:00',3.81),('325','2013-11-02','12:10:00',3.5),('325','2013-11-02','12:15:00',3.15),('325','2013-11-02','12:20:00',3.78),('325','2013-11-02','12:25:00',3.41),('325','2013-11-02','12:30:00',3.95),('325','2013-11-02','12:35:00',3.36),('325','2013-11-02','12:40:00',3.47),('325','2013-11-02','12:45:00',2.21),('325','2013-11-02','12:50:00',3.27),('325','2013-11-02','12:55:00',3.48),('325','2013-11-02','13:00:00',1.69),('325','2013-11-02','13:05:00',3.08),('325','2013-11-02','13:10:00',3.72),('325','2013-11-02','13:15:00',1.39),('325','2013-11-02','13:20:00',1.09),('325','2013-11-02','13:30:00',1.09),('325','2013-11-02','13:35:00',2.96),('325','2013-11-02','13:40:00',2.94),('325','2013-11-02','13:45:00',3.52),('325','2013-11-02','13:50:00',3.54),('325','2013-11-02','13:55:00',3.35),('325','2013-11-02','14:00:00',3),('325','2013-11-02','14:05:00',2.68),('325','2013-11-02','14:10:00',2.5),('325','2013-11-02','14:15:00',2.43),('325','2013-11-02','14:20:00',2.35),('325','2013-11-02','14:25:00',2.28),('325','2013-11-02','14:30:00',2.22),('325','2013-11-02','14:35:00',2.13),('325','2013-11-02','14:40:00',2.05),('325','2013-11-02','14:45:00',1.97),('325','2013-11-02','14:50:00',1.93),('325','2013-11-02','14:55:00',1.41),('325','2013-11-02','15:00:00',1.47),('325','2013-11-02','15:15:00',1.01),('325','2013-11-01','08:40:00',1),('325','2013-11-01','08:50:00',1.01),('325','2013-11-01','08:55:00',1.04),('325','2013-11-01','09:00:00',1.1),('325','2013-11-01','09:05:00',1.22),('325','2013-11-01','09:10:00',1.26),('325','2013-11-01','09:15:00',1.3),('325','2013-11-01','09:20:00',1.35),('325','2013-11-01','09:25:00',1.39),('325','2013-11-01','09:30:00',1.43),('325','2013-11-01','09:35:00',2.23),('325','2013-11-01','09:40:00',2.38),('325','2013-11-01','09:45:00',2.46),('325','2013-11-01','09:50:00',2.51),('325','2013-11-01','09:55:00',2.58),('325','2013-11-01','10:00:00',2.66),('325','2013-11-01','10:05:00',2.73),('325','2013-11-01','10:10:00',2.78),('325','2013-11-01','10:15:00',2.82),('325','2013-11-01','10:20:00',2.86),('325','2013-11-01','10:25:00',2.9),('325','2013-11-01','10:30:00',2.85),('325','2013-11-01','10:35:00',2.94),('325','2013-11-01','10:40:00',2.96),('325','2013-11-01','10:45:00',2.94),('325','2013-11-01','10:50:00',2.9),('325','2013-11-01','10:55:00',2.97),('325','2013-11-01','11:00:00',3.03),('325','2013-11-01','11:05:00',2.67),('325','2013-11-01','11:10:00',2.44),('325','2013-11-01','11:15:00',2.71),('325','2013-11-01','11:20:00',3.22),('325','2013-11-01','11:25:00',3.35),('325','2013-11-01','11:30:00',3.35),('325','2013-11-01','11:35:00',3.09),('325','2013-11-01','11:40:00',2.73),('325','2013-11-01','11:45:00',3.1),('325','2013-11-01','11:50:00',3.34),('325','2013-11-01','11:55:00',3.34),('325','2013-11-01','12:00:00',3.18),('325','2013-11-01','12:05:00',3.12),('325','2013-11-01','12:10:00',2.98),('325','2013-11-01','12:15:00',2.69),('325','2013-11-01','12:20:00',2.83),('325','2013-11-01','12:25:00',2.93),('325','2013-11-01','12:30:00',1.61),('325','2013-11-01','13:10:00',1.39),('325','2013-11-01','13:15:00',1.39),('325','2013-11-01','13:20:00',1.37),('325','2013-11-01','13:25:00',1.16),('325','2013-11-01','13:30:00',1.25),('325','2013-11-01','13:35:00',1.32),('325','2013-11-01','13:40:00',1.27),('325','2013-10-31','08:35:00',1.01),('325','2013-10-31','08:40:00',1.22),('325','2013-10-31','08:45:00',1.24),('325','2013-10-31','08:50:00',1.31),('325','2013-10-31','08:55:00',1.25),('325','2013-10-31','09:00:00',1.21),('325','2013-10-31','09:05:00',1.1),('325','2013-10-31','09:20:00',1.26),('325','2013-10-31','09:25:00',1.28),('325','2013-10-31','09:30:00',1.39),('325','2013-10-31','09:35:00',1.82),('325','2013-10-31','09:40:00',1.87),('325','2013-10-31','09:45:00',1.84),('325','2013-10-31','09:50:00',1.87),('325','2013-10-31','09:55:00',1.95),('325','2013-10-31','10:00:00',2.04),('325','2013-10-31','10:05:00',1.98),('325','2013-10-31','10:10:00',1.88),('325','2013-10-31','10:15:00',1.72),('325','2013-10-31','10:20:00',1.57),('325','2013-10-31','10:25:00',1.79),('325','2013-10-31','10:30:00',1.82),('325','2013-10-31','10:35:00',2.13),('325','2013-10-31','10:40:00',2.12),('325','2013-10-31','10:45:00',1.94),('325','2013-10-31','10:50:00',2.02),('325','2013-10-31','10:55:00',2.21),('325','2013-10-31','11:00:00',2.55),('325','2013-10-31','11:05:00',3.02),('325','2013-10-31','11:10:00',2.91),('325','2013-10-31','11:15:00',2.92),('325','2013-10-31','11:20:00',2.9),('325','2013-10-31','11:25:00',2.63),('325','2013-10-31','11:30:00',2.92),('325','2013-10-31','11:35:00',2.76),('325','2013-10-31','11:40:00',3.05),('325','2013-10-31','11:45:00',3.21),('325','2013-10-31','11:50:00',3.13),('325','2013-10-31','11:55:00',3.1),('325','2013-10-31','12:00:00',3.03),('325','2013-10-31','12:05:00',3.02),('325','2013-10-31','12:10:00',3.09),('325','2013-10-31','12:15:00',3.06),('325','2013-10-31','12:20:00',3.03),('325','2013-10-31','12:25:00',3.05),('325','2013-10-31','12:30:00',2.99),('325','2013-10-31','12:35:00',2.84),('325','2013-10-31','12:40:00',2.96),('325','2013-10-31','12:45:00',3.03),('325','2013-10-31','12:50:00',3.11),('325','2013-10-31','12:55:00',3.12),('325','2013-10-31','13:00:00',3.05),('325','2013-10-31','13:05:00',2.99),('325','2013-10-31','13:10:00',2.9),('325','2013-10-31','13:15:00',2.86),('325','2013-10-31','13:20:00',2.84),('325','2013-10-31','13:25:00',2.79),('325','2013-10-31','13:30:00',2.7),('325','2013-10-31','13:35:00',2.65),('325','2013-10-31','13:40:00',2.52),('325','2013-10-31','13:45:00',2.42),('325','2013-10-31','13:50:00',1.83),('325','2013-10-31','13:55:00',1.71),('325','2013-10-31','14:00:00',2.4),('325','2013-10-31','14:05:00',2.31),('325','2013-10-31','14:10:00',2.11),('325','2013-10-31','14:15:00',1.93),('325','2013-10-31','14:45:00',1.01),('325','2013-10-31','14:55:00',1.22),('325','2013-10-31','15:00:00',1.28),('325','2013-10-31','15:05:00',1.15),('325','2013-10-31','15:10:00',1.08),('325','2013-10-31','15:15:00',1.01),('325','2013-10-30','08:35:00',1.04),('325','2013-10-30','08:40:00',1.1),('325','2013-10-30','08:45:00',1.16),('325','2013-10-30','08:50:00',1.21),('325','2013-10-30','08:55:00',1.19),('325','2013-10-30','09:00:00',1.25),('325','2013-10-30','09:05:00',1.31),('325','2013-10-30','09:10:00',1.4),('325','2013-10-30','09:15:00',1.44),('325','2013-10-30','09:20:00',1.48),('325','2013-10-30','09:25:00',1.54),('325','2013-10-30','09:30:00',1.65),('325','2013-10-30','09:35:00',2.16),('325','2013-10-30','09:40:00',2.22),('325','2013-10-30','09:45:00',2.35),('325','2013-10-30','09:50:00',2.39),('325','2013-10-30','09:55:00',2.21),('325','2013-10-30','10:00:00',1.94),('325','2013-10-30','10:05:00',1.82),('325','2013-10-30','10:10:00',2.5),('325','2013-10-30','10:15:00',2.74),('325','2013-10-30','10:20:00',2.58),('325','2013-10-30','10:25:00',2.57),('325','2013-10-30','10:30:00',2.71),('325','2013-10-30','10:35:00',2.58),('325','2013-10-30','10:40:00',2.78),('325','2013-10-30','10:45:00',2.86),('325','2013-10-30','10:50:00',2),('325','2013-10-30','10:55:00',2.07),('325','2013-10-30','11:00:00',2.55),('325','2013-10-30','11:05:00',2.63),('325','2013-10-30','11:10:00',3.09),('325','2013-10-30','11:15:00',3.03),('325','2013-10-30','11:20:00',2.53),('325','2013-10-30','11:25:00',1.38),('325','2013-10-30','11:30:00',1.17),('325','2013-10-30','11:40:00',1.25),('325','2013-10-30','11:45:00',1.59),('325','2013-10-30','11:50:00',1.48),('325','2013-10-30','12:00:00',1.2),('325','2013-10-30','12:05:00',1.19),('325','2013-10-30','12:10:00',1.26),('325','2013-10-30','12:15:00',2.48),('325','2013-10-30','12:20:00',3.61),('325','2013-10-30','12:25:00',1.63),('325','2013-10-30','12:30:00',1.65),('325','2013-10-30','12:35:00',1.22),('325','2013-10-30','12:40:00',1.24),('325','2013-10-30','12:45:00',1.25),('325','2013-10-30','12:50:00',2.03),('325','2013-10-30','12:55:00',2.74),('325','2013-10-30','13:00:00',1.97),('325','2013-10-30','13:05:00',3.11),('325','2013-10-30','13:10:00',2.98),('325','2013-10-30','13:15:00',3.3),('325','2013-10-30','13:20:00',3.19),('325','2013-10-30','13:25:00',2.83),('325','2013-10-30','13:30:00',1.44),('325','2013-10-30','13:35:00',2.57),('325','2013-10-30','13:40:00',2.82),('325','2013-10-30','13:45:00',1.76),('325','2013-10-30','13:50:00',1.46),('325','2013-10-30','13:55:00',2.74),('325','2013-10-30','14:00:00',2.82),('325','2013-10-30','14:05:00',2.16),('325','2013-10-30','14:10:00',1.7),('325','2013-10-30','14:20:00',1.02),('325','2013-10-30','14:30:00',1.41),('325','2013-10-30','14:35:00',2.01),('325','2013-10-30','14:40:00',1.98),('325','2013-10-30','14:45:00',1.17),('325','2013-10-30','15:05:00',1.09),('325','2013-10-30','15:10:00',1.18),('325','2013-10-30','15:15:00',1.35),('325','2013-10-30','15:20:00',1.34),('325','2013-10-30','15:25:00',1.18),('325','2013-10-29','08:45:00',1.15),('325','2013-10-29','08:50:00',1.17),('325','2013-10-29','08:55:00',1.22),('325','2013-10-29','09:00:00',1.26),('325','2013-10-29','09:05:00',1.3),('325','2013-10-29','09:10:00',1.34),('325','2013-10-29','09:15:00',1.38),('325','2013-10-29','09:20:00',1.42),('325','2013-10-29','09:25:00',1.45),('325','2013-10-29','09:30:00',1.66),('325','2013-10-29','09:35:00',2.29),('325','2013-10-29','09:40:00',2.53),('325','2013-10-29','09:45:00',2.59),('325','2013-10-29','09:50:00',2.01),('325','2013-10-29','09:55:00',2.2),('325','2013-10-29','10:00:00',1.98),('325','2013-10-29','10:05:00',2.67),('325','2013-10-29','10:10:00',2.62),('325','2013-10-29','10:15:00',1.47),('325','2013-10-29','10:20:00',1.07),('325','2013-10-29','10:25:00',1.52),('325','2013-10-29','10:30:00',1.6),('325','2013-10-29','10:35:00',1.92),('325','2013-10-29','10:40:00',3.19),('325','2013-10-29','10:45:00',3.43),('325','2013-10-29','10:50:00',3.5),('325','2013-10-29','10:55:00',3.55),('325','2013-10-29','11:00:00',3.47),('325','2013-10-29','11:05:00',3.54),('325','2013-10-29','11:10:00',3.41),('325','2013-10-29','11:15:00',3.29),('325','2013-10-29','11:20:00',3.27),('325','2013-10-29','11:25:00',3.29),('325','2013-10-29','11:30:00',3.35),('325','2013-10-29','11:35:00',3.32),('325','2013-10-29','11:40:00',3.31),('325','2013-10-29','11:45:00',3.32),('325','2013-10-29','11:50:00',3.34),('325','2013-10-29','11:55:00',3.23),('325','2013-10-29','12:00:00',3.16),('325','2013-10-29','12:05:00',3.19),('325','2013-10-29','12:10:00',3.16),('325','2013-10-29','12:15:00',3.16),('325','2013-10-29','12:20:00',3.11),('325','2013-10-29','12:25:00',2.81),('325','2013-10-29','12:30:00',2.96),('325','2013-10-29','12:35:00',3.08),('325','2013-10-29','12:40:00',3),('325','2013-10-29','12:45:00',2.52),('325','2013-10-29','12:50:00',2.99),('325','2013-10-29','12:55:00',2.84),('325','2013-10-29','13:00:00',2.89),('325','2013-10-29','13:05:00',2.78),('325','2013-10-29','13:10:00',2.9),('325','2013-10-29','13:15:00',2.88),('325','2013-10-29','13:20:00',2.83),('325','2013-10-29','13:25:00',2.78),('325','2013-10-29','13:30:00',2.77),('325','2013-10-29','13:35:00',2.67),('325','2013-10-29','13:40:00',2.51),('325','2013-10-29','13:45:00',2.55),('325','2013-10-29','13:50:00',2.51),('325','2013-10-29','13:55:00',2.18),('325','2013-10-29','14:00:00',2.39),('325','2013-10-29','14:05:00',2.33),('325','2013-10-29','14:10:00',2.27),('325','2013-10-29','14:15:00',2.24),('325','2013-10-29','14:20:00',2.2),('325','2013-10-29','14:25:00',2.09),('325','2013-10-29','14:30:00',2.03),('325','2013-10-29','14:35:00',1.96),('325','2013-10-29','14:40:00',1.89),('325','2013-10-29','14:45:00',1.8),('325','2013-10-29','14:50:00',1.72),('325','2013-10-29','14:55:00',1.63),('325','2013-10-29','15:00:00',1.57),('325','2013-10-29','15:05:00',1.49),('325','2013-10-29','15:10:00',1.44),('325','2013-10-29','15:15:00',1.36),('325','2013-10-29','15:20:00',1.24),('325','2013-10-29','15:25:00',1.15),('325','2013-10-29','15:30:00',1.08),('325','2013-10-28','08:50:00',1.04),('325','2013-10-28','08:55:00',1.27),('325','2013-10-28','09:00:00',1.38),('325','2013-10-28','09:05:00',1.55),('325','2013-10-28','09:10:00',1.64),('325','2013-10-28','09:15:00',1.54),('325','2013-10-28','09:20:00',1.46),('325','2013-10-28','09:25:00',1.72),('325','2013-10-28','09:30:00',1.64),('325','2013-10-28','09:35:00',1.81),('325','2013-10-28','09:40:00',2.65),('325','2013-10-28','09:45:00',2.65),('325','2013-10-28','09:50:00',1.51),('325','2013-10-28','09:55:00',1.15),('325','2013-10-28','10:45:00',1.46),('325','2013-10-28','10:50:00',3.27),('325','2013-10-28','10:55:00',3.22),('325','2013-10-28','11:00:00',3.24),('325','2013-10-28','11:05:00',3.24),('325','2013-10-28','11:10:00',3.27),('325','2013-10-28','11:15:00',3.27),('325','2013-10-28','11:20:00',3.26),('325','2013-10-28','11:25:00',3.26),('325','2013-10-28','11:30:00',3.29),('325','2013-10-28','11:35:00',3.28),('325','2013-10-28','11:40:00',3.31),('325','2013-10-28','11:45:00',3.27),('325','2013-10-28','11:50:00',3.33),('325','2013-10-28','11:55:00',2.59),('325','2013-10-28','12:00:00',2.89),('325','2013-10-28','12:05:00',3.09),('325','2013-10-28','12:10:00',3.4),('325','2013-10-28','12:15:00',3.4),('325','2013-10-28','12:20:00',2.96),('325','2013-10-28','12:25:00',2.16),('325','2013-10-28','12:30:00',3.77),('325','2013-10-28','12:35:00',3.68),('325','2013-10-28','12:40:00',3.36),('325','2013-10-28','12:45:00',3.49),('325','2013-10-28','12:50:00',3.38),('325','2013-10-28','12:55:00',3.22),('325','2013-10-28','13:00:00',3.17),('325','2013-10-28','13:05:00',3.14),('325','2013-10-28','13:10:00',3.07),('325','2013-10-28','13:15:00',3.05),('325','2013-10-28','13:20:00',2.96),('325','2013-10-28','13:25:00',2.92),('325','2013-10-28','13:30:00',2.89),('325','2013-10-28','13:35:00',2.87),('325','2013-10-28','13:40:00',2.87),('325','2013-10-28','13:45:00',2.78),('325','2013-10-28','13:50:00',2.75),('325','2013-10-28','13:55:00',2.78),('325','2013-10-28','14:00:00',2.71),('325','2013-10-28','14:05:00',2.82),('325','2013-10-28','14:10:00',2.67),('325','2013-10-28','14:15:00',2.55),('325','2013-10-28','14:20:00',2.56),('325','2013-10-28','14:25:00',2.43),('325','2013-10-28','14:30:00',1.5),('325','2013-10-28','14:35:00',2.08),('325','2013-10-28','14:40:00',1.4),('325','2013-10-28','14:45:00',2.12),('325','2013-10-28','14:50:00',1.92),('325','2013-10-28','14:55:00',1.87),('325','2013-10-28','15:00:00',1.82),('325','2013-10-28','15:05:00',1.66),('325','2013-10-28','15:10:00',1.6),('325','2013-10-28','15:15:00',1.22),('325','2013-10-28','15:40:00',1.28),('325','2013-10-28','15:45:00',1.2),('325','2014-04-16','08:45:00',1.08),('325','2014-04-16','08:50:00',1.32),('325','2014-04-16','08:55:00',1.76),('325','2014-04-16','09:00:00',1.95),('325','2014-04-16','09:05:00',2.07),('325','2014-04-16','09:10:00',2.2),('325','2014-04-16','09:15:00',2.39),('325','2014-04-16','09:20:00',2.48),('325','2014-04-16','09:25:00',2.68),('325','2014-04-16','09:30:00',1.47),('325','2014-04-16','09:35:00',1.05),('325','2014-04-16','09:50:00',1.06),('325','2014-04-16','09:55:00',2.13),('325','2014-04-16','10:00:00',2.31),('325','2014-04-16','10:05:00',3.42),('325','2014-04-16','10:10:00',3.54),('325','2014-04-16','10:15:00',3.67),('325','2014-04-16','10:20:00',3.75),('325','2014-04-16','10:25:00',3.81),('325','2014-04-16','10:30:00',3.89),('325','2014-04-16','10:35:00',3.97),('325','2014-04-16','10:40:00',4.03),('325','2014-04-16','10:45:00',4.08),('325','2014-04-16','10:50:00',4.26),('325','2014-04-16','10:55:00',3.93),('325','2014-04-16','11:00:00',4.13),('325','2014-04-16','11:05:00',2.07),('325','2014-04-16','11:10:00',1.78),('325','2014-04-16','11:15:00',2.04),('325','2014-04-16','11:20:00',4.03),('325','2014-04-16','11:25:00',3.84),('325','2014-04-16','11:30:00',4.35),('325','2014-04-16','11:35:00',3.11),('325','2014-04-16','11:40:00',3.77),('325','2014-04-16','11:45:00',4.65),('325','2014-04-16','11:50:00',5.32),('325','2014-04-16','11:55:00',5.32),('325','2014-04-16','12:00:00',5.27),('325','2014-04-16','12:05:00',4.6),('325','2014-04-16','12:10:00',4.57),('325','2014-04-16','12:15:00',5.35),('325','2014-04-16','12:20:00',2.12),('325','2014-04-16','12:25:00',1.28),('325','2014-04-16','12:30:00',1.85),('325','2014-04-16','12:35:00',5.18),('325','2014-04-16','12:40:00',4.71),('325','2014-04-16','12:45:00',5.04),('325','2014-04-16','12:50:00',4.88),('325','2014-04-16','12:55:00',1.23),('325','2014-04-16','13:00:00',2.94),('325','2014-04-16','13:05:00',1.81),('325','2014-04-16','13:20:00',1.44),('325','2014-04-16','13:25:00',1.18),('325','2014-04-16','13:35:00',1.62),('325','2014-04-16','13:40:00',3.06),('325','2014-04-16','13:45:00',5.79),('325','2014-04-16','13:50:00',5.25),('325','2014-04-16','13:55:00',4.78),('325','2014-04-16','14:00:00',1.92),('325','2014-04-16','14:05:00',4.36),('325','2014-04-16','14:10:00',5.04),('325','2014-04-16','14:15:00',5.55),('325','2014-04-16','14:20:00',4.27),('325','2014-04-16','14:25:00',4.43),('325','2014-04-16','14:30:00',5),('325','2014-04-16','14:35:00',4.77),('325','2014-04-16','14:40:00',4.67),('325','2014-04-16','14:45:00',4.92),('325','2014-04-16','14:50:00',5.05),('325','2014-04-16','14:55:00',1.97),('325','2014-04-16','15:00:00',1.37),('325','2014-04-16','15:05:00',3.43),('325','2014-04-16','15:10:00',5.05),('325','2014-04-16','15:15:00',3.39),('325','2014-04-16','15:25:00',1.2),('325','2014-04-16','15:30:00',2.45),('325','2014-04-16','15:35:00',4.63),('325','2014-04-16','15:40:00',4.43),('325','2014-04-16','15:45:00',4.25),('325','2014-04-16','15:50:00',4.02),('325','2014-04-16','15:55:00',3.98),('325','2014-04-16','16:00:00',3.88),('325','2014-04-16','16:05:00',3.76),('325','2014-04-16','16:10:00',3.67),('325','2014-04-16','16:15:00',3.6),('325','2014-04-16','16:20:00',3.57),('325','2014-04-16','16:25:00',3.45),('325','2014-04-16','16:30:00',3.36),('325','2014-04-16','16:35:00',3.25),('325','2014-04-16','16:40:00',3.18),('325','2014-04-16','16:45:00',3.07),('325','2014-04-16','16:50:00',2.89),('325','2014-04-16','16:55:00',2.82),('325','2014-04-16','17:00:00',2.75),('325','2014-04-16','17:05:00',2.64),('325','2014-04-16','17:10:00',2.54),('325','2014-04-16','17:15:00',2.44),('325','2014-04-16','17:20:00',2.32),('325','2014-04-16','17:25:00',2.19),('325','2014-04-16','17:30:00',2.06),('325','2014-04-16','17:35:00',2),('325','2014-04-16','17:40:00',1.87),('325','2014-04-16','17:45:00',1.79),('325','2014-04-16','17:50:00',1.77),('325','2014-04-16','17:55:00',1.76),('325','2014-04-16','18:00:00',1.58),('325','2014-04-16','18:05:00',1.4),('325','2014-04-16','18:10:00',1.15),('325','2014-04-16','18:20:00',1.15),('325','2013-10-27','09:55:00',1.04),('325','2013-10-27','10:00:00',1.07),('325','2013-10-27','10:05:00',1.09),('325','2013-10-27','10:10:00',1.19),('325','2013-10-27','10:15:00',1.29),('325','2013-10-27','10:20:00',1.36),('325','2013-10-27','10:25:00',1.31),('325','2013-10-27','10:30:00',1.3),('325','2013-10-27','10:35:00',1.33),('325','2013-10-27','10:40:00',1.39),('325','2013-10-27','10:45:00',1.54),('325','2013-10-27','10:50:00',1.46),('325','2013-10-27','10:55:00',1.33),('325','2013-10-27','11:00:00',1.12),('325','2013-10-27','11:30:00',1.19),('325','2013-10-27','11:35:00',1.96),('325','2013-10-27','11:40:00',2.35),('325','2013-10-27','11:45:00',2.7),('325','2013-10-27','11:50:00',1.28),('325','2013-10-27','11:55:00',1.11),('325','2013-10-27','12:00:00',1.26),('325','2013-10-27','12:05:00',1.33),('325','2013-10-27','12:10:00',1.22),('325','2013-10-27','12:15:00',1.81),('325','2013-10-27','12:20:00',2.84),('325','2013-10-27','12:25:00',2.98),('325','2013-10-27','12:30:00',2.81),('325','2013-10-27','12:35:00',3.56),('325','2013-10-27','12:40:00',2.23),('325','2013-10-27','12:45:00',3.24),('325','2013-10-27','12:50:00',3.17),('325','2013-10-27','12:55:00',2.51),('325','2013-10-27','13:00:00',1.11),('325','2013-10-27','13:05:00',1.66),('325','2013-10-27','13:10:00',1.9),('325','2013-10-27','13:15:00',1.05),('325','2013-10-27','13:20:00',1.1),('325','2013-10-27','13:25:00',2.99),('325','2013-10-27','13:30:00',2.89),('325','2013-10-27','13:35:00',2.23),('325','2013-10-27','13:40:00',1.12),('325','2013-10-27','13:55:00',1.01),('325','2013-10-27','14:00:00',1.16),('325','2013-10-27','14:10:00',1.69),('325','2013-10-27','14:15:00',1.58),('325','2013-10-27','14:20:00',1.15),('325','2013-10-27','14:25:00',1.97),('325','2013-10-27','14:30:00',2.13),('325','2013-10-27','14:35:00',1.72),('325','2013-10-27','14:40:00',1.54),('325','2013-10-27','14:45:00',1.09),('325','2013-10-27','14:55:00',1.33),('325','2013-10-27','15:00:00',1.56),('325','2013-10-27','15:05:00',1.48),('325','2013-10-27','15:10:00',1.57),('325','2013-10-27','15:15:00',1.5),('325','2013-10-27','15:20:00',1.41),('325','2013-10-27','15:25:00',1.19),('325','2013-10-26','09:35:00',1.02),('325','2013-10-26','09:40:00',1.07),('325','2013-10-26','09:45:00',1.11),('325','2013-10-26','09:50:00',1.14),('325','2013-10-26','09:55:00',1.19),('325','2013-10-26','10:00:00',1.24),('325','2013-10-26','10:05:00',1.29),('325','2013-10-26','10:10:00',1.32),('325','2013-10-26','10:15:00',1.36),('325','2013-10-26','10:20:00',1.4),('325','2013-10-26','10:25:00',1.44),('325','2013-10-26','10:30:00',1.9),('325','2013-10-26','10:35:00',2.36),('325','2013-10-26','10:40:00',2.46),('325','2013-10-26','10:45:00',2.51),('325','2013-10-26','10:50:00',2.58),('325','2013-10-26','10:55:00',2.65),('325','2013-10-26','11:00:00',2.7),('325','2013-10-26','11:05:00',2.77),('325','2013-10-26','11:10:00',2.82),('325','2013-10-26','11:15:00',2.84),('325','2013-10-26','11:20:00',2.89),('325','2013-10-26','11:25:00',2.94),('325','2013-10-26','11:30:00',2.95),('325','2013-10-26','11:35:00',3.02),('325','2013-10-26','11:40:00',3.04),('325','2013-10-26','11:45:00',3.06),('325','2013-10-26','11:50:00',3.09),('325','2013-10-26','11:55:00',3.12),('325','2013-10-26','12:00:00',3.11),('325','2013-10-26','12:05:00',3.14),('325','2013-10-26','12:10:00',3.17),('325','2013-10-26','12:15:00',3.16),('325','2013-10-26','12:20:00',3.15),('325','2013-10-26','12:25:00',3.14),('325','2013-10-26','12:30:00',3.14),('325','2013-10-26','12:35:00',3.24),('325','2013-10-26','12:40:00',2.98),('325','2013-10-26','12:45:00',3),('325','2013-10-26','12:50:00',3.02),('325','2013-10-26','12:55:00',2.94),('325','2013-10-26','13:00:00',3.21),('325','2013-10-26','13:05:00',3.03),('325','2013-10-26','13:10:00',3),('325','2013-10-26','13:15:00',3.24),('325','2013-10-26','13:20:00',2.97),('325','2013-10-26','13:25:00',3.1),('325','2013-10-26','13:30:00',3.22),('325','2013-10-26','13:35:00',3.26),('325','2013-10-26','13:40:00',3.24),('325','2013-10-26','13:45:00',2.87),('325','2013-10-26','13:50:00',2.97),('325','2013-10-26','13:55:00',2.79),('325','2013-10-26','14:00:00',2.81),('325','2013-10-26','14:05:00',2.79),('325','2013-10-26','14:10:00',2.27),('325','2013-10-26','14:15:00',2.03),('325','2013-10-26','14:20:00',2.02),('325','2013-10-26','14:25:00',2.05),('325','2013-10-26','14:30:00',2.56),('325','2013-10-26','14:35:00',2.37),('325','2013-10-26','14:40:00',2.27),('325','2013-10-26','14:45:00',1.41),('325','2013-10-26','14:50:00',1.84),('325','2013-10-26','14:55:00',2.52),('325','2013-10-26','15:00:00',2.42),('325','2013-10-26','15:05:00',2.32),('325','2013-10-26','15:10:00',2.32),('325','2013-10-26','15:15:00',2.08),('325','2013-10-26','15:20:00',2.01),('325','2013-10-26','15:25:00',2.17),('325','2013-10-26','15:30:00',2.13),('325','2013-10-26','15:35:00',2.04),('325','2013-10-26','15:40:00',1.93),('325','2013-10-26','15:45:00',1.86),('325','2013-10-26','15:50:00',1.65),('325','2013-10-26','15:55:00',1.6),('325','2013-10-26','16:00:00',1.54),('325','2013-10-26','16:05:00',1.49),('325','2013-10-26','16:10:00',1.4),('325','2013-10-26','16:15:00',1.31),('325','2013-10-26','16:20:00',1.27),('325','2013-10-26','16:25:00',1.15),('325','2013-10-26','16:30:00',1.12),('325','2013-10-25','09:35:00',1.01),('325','2013-10-25','09:40:00',1.05),('325','2013-10-25','09:45:00',1.1),('325','2013-10-25','09:50:00',1.15),('325','2013-10-25','09:55:00',1.18),('325','2013-10-25','10:00:00',1.23),('325','2013-10-25','10:05:00',1.27),('325','2013-10-25','10:10:00',1.3),('325','2013-10-25','10:15:00',1.34),('325','2013-10-25','10:20:00',1.38),('325','2013-10-25','10:25:00',1.77),('325','2013-10-25','10:30:00',2.31),('325','2013-10-25','10:35:00',2.45),('325','2013-10-25','10:40:00',2.53),('325','2013-10-25','10:45:00',2.59),('325','2013-10-25','10:50:00',2.63),('325','2013-10-25','10:55:00',2.68),('325','2013-10-25','11:00:00',2.71),('325','2013-10-25','11:05:00',2.8),('325','2013-10-25','11:10:00',2.86),('325','2013-10-25','11:15:00',2.84),('325','2013-10-25','11:20:00',2.88),('325','2013-10-25','11:25:00',2.92),('325','2013-10-25','11:30:00',2.96),('325','2013-10-25','11:35:00',3.07),('325','2013-10-25','11:40:00',3.15),('325','2013-10-25','11:45:00',3.18),('325','2013-10-25','11:50:00',3.2),('325','2013-10-25','11:55:00',3.23),('325','2013-10-25','12:00:00',3.26),('325','2013-10-25','12:05:00',3.29),('325','2013-10-25','12:10:00',3.3),('325','2013-10-25','12:15:00',3.3),('325','2013-10-25','12:20:00',3.31),('325','2013-10-25','12:25:00',3.31),('325','2013-10-25','12:30:00',3.3),('325','2013-10-25','12:35:00',3.31),('325','2013-10-25','12:40:00',3.35),('325','2013-10-25','12:45:00',3.36),('325','2013-10-25','12:50:00',3.35),('325','2013-10-25','12:55:00',3.33),('325','2013-10-25','13:00:00',3.32),('325','2013-10-25','13:05:00',3.31),('325','2013-10-25','13:10:00',3.29),('325','2013-10-25','13:15:00',3.28),('325','2013-10-25','13:20:00',3.27),('325','2013-10-25','13:25:00',3.25),('325','2013-10-25','13:30:00',3.22),('325','2013-10-25','13:35:00',3.19),('325','2013-10-25','13:40:00',3.16),('325','2013-10-25','13:45:00',3.14),('325','2013-10-25','13:50:00',3.12),('325','2013-10-25','13:55:00',3.08),('325','2013-10-25','14:00:00',3.07),('325','2013-10-25','14:05:00',3.03),('325','2013-10-25','14:10:00',2.98),('325','2013-10-25','14:15:00',2.98),('325','2013-10-25','14:20:00',2.96),('325','2013-10-25','14:25:00',2.93),('325','2013-10-25','14:30:00',2.88),('325','2013-10-25','14:35:00',2.78),('325','2013-10-25','14:40:00',2.76),('325','2013-10-25','14:45:00',2.74),('325','2013-10-25','14:50:00',2.72),('325','2013-10-25','14:55:00',2.63),('325','2013-10-25','15:00:00',2.56),('325','2013-10-25','15:05:00',2.51),('325','2013-10-25','15:10:00',2.42),('325','2013-10-25','15:15:00',2.36),('325','2013-10-25','15:20:00',2.34),('325','2013-10-25','15:25:00',2.25),('325','2013-10-25','15:30:00',2.15),('325','2013-10-25','15:35:00',2.07),('325','2013-10-25','15:40:00',2.06),('325','2013-10-25','15:45:00',1.96),('325','2013-10-25','15:50:00',1.89),('325','2013-10-25','15:55:00',1.82),('325','2013-10-25','16:00:00',1.75),('325','2013-10-25','16:05:00',1.66),('325','2013-10-25','16:10:00',1.59),('325','2013-10-25','16:15:00',1.52),('325','2013-10-25','16:20:00',1.45),('325','2013-10-25','16:25:00',1.37),('325','2013-10-25','16:30:00',1.29),('325','2013-10-25','16:35:00',1.2),('325','2013-10-25','16:40:00',1.11),('325','2013-10-25','16:45:00',1.01),('325','2013-10-24','09:05:00',1.02),('325','2013-10-24','09:10:00',1.06),('325','2013-10-24','09:15:00',1.27),('325','2013-10-24','09:35:00',1.01),('325','2013-10-24','09:40:00',1.08),('325','2013-10-24','09:45:00',1.11),('325','2013-10-24','09:50:00',1.11),('325','2013-10-24','09:55:00',1.09),('325','2013-10-24','10:00:00',1.06),('325','2013-10-24','10:05:00',1.01),('325','2013-10-24','10:20:00',1.23),('325','2013-10-24','10:35:00',1.89),('325','2013-10-24','10:40:00',1.12),('325','2013-10-24','10:45:00',2.21),('325','2013-10-24','10:50:00',1.71),('325','2013-10-24','10:55:00',2.07),('325','2013-10-24','11:00:00',3.24),('325','2013-10-24','11:05:00',3.42),('325','2013-10-24','11:10:00',2.26),('325','2013-10-24','11:15:00',1.96),('325','2013-10-24','11:20:00',1.77),('325','2013-10-24','11:25:00',1.62),('325','2013-10-24','11:30:00',1.22),('325','2013-10-24','11:35:00',1.22),('325','2013-10-24','11:40:00',1.16),('325','2013-10-24','11:45:00',1.26),('325','2013-10-24','11:50:00',2.21),('325','2013-10-24','11:55:00',2.9),('325','2013-10-24','12:00:00',1.71),('325','2013-10-24','12:05:00',1.38),('325','2013-10-24','12:10:00',1.32),('325','2013-10-24','12:15:00',1.35),('325','2013-10-24','12:20:00',1.44),('325','2013-10-24','12:25:00',1.59),('325','2013-10-24','12:30:00',1.68),('325','2013-10-24','12:35:00',1.87),('325','2013-10-24','12:40:00',2.25),('325','2013-10-24','12:45:00',2.37),('325','2013-10-24','12:50:00',2.05),('325','2013-10-24','12:55:00',3.07),('325','2013-10-24','13:00:00',3.65),('325','2013-10-24','13:05:00',3.53),('325','2013-10-24','13:10:00',2.74),('325','2013-10-24','13:15:00',2.35),('325','2013-10-24','13:20:00',2.72),('325','2013-10-24','13:25:00',1.89),('325','2013-10-24','13:30:00',1.4),('325','2013-10-24','13:35:00',1.36),('325','2013-10-24','13:40:00',1.41),('325','2013-10-24','13:45:00',1.52),('325','2013-10-24','13:50:00',1.91),('325','2013-10-24','13:55:00',2.67),('325','2013-10-24','14:00:00',2.34),('325','2013-10-24','14:05:00',1.55),('325','2013-10-24','14:10:00',1.47),('325','2013-10-24','14:15:00',1.4),('325','2013-10-24','14:20:00',1.53),('325','2013-10-24','14:25:00',1.57),('325','2013-10-24','14:30:00',1.65),('325','2013-10-24','14:35:00',1.97),('325','2013-10-24','14:40:00',2.35),('325','2013-10-24','14:45:00',2.44),('325','2013-10-24','14:50:00',1.8),('325','2013-10-24','15:00:00',1.06),('325','2013-10-24','15:05:00',1.61),('325','2013-10-24','15:10:00',2.08),('325','2013-10-24','15:15:00',1.21),('325','2013-10-24','15:20:00',1.51),('325','2013-10-24','15:25:00',1.09),('325','2013-10-24','15:30:00',1.59),('325','2013-10-24','15:35:00',2.4),('325','2013-10-24','15:40:00',2.15),('325','2013-10-24','15:45:00',2.15),('325','2013-10-24','15:50:00',1.26),('325','2013-10-23','10:20:00',1.12),('325','2013-10-23','10:25:00',1.2),('325','2013-10-23','10:30:00',1.07),('325','2013-10-23','10:40:00',1.37),('325','2013-10-23','10:45:00',1.28),('325','2013-10-23','10:50:00',1.38),('325','2013-10-23','10:55:00',1.51),('325','2013-10-23','11:00:00',1.54),('325','2013-10-23','11:05:00',1.79),('325','2013-10-23','11:10:00',1.62),('325','2013-10-23','11:15:00',2.05),('325','2013-10-23','11:20:00',2.66),('325','2013-10-23','11:25:00',3.05),('325','2013-10-23','11:30:00',3.03),('325','2013-10-23','11:35:00',2.77),('325','2013-10-23','11:40:00',3.05),('325','2013-10-23','11:45:00',3.05),('325','2013-10-23','11:50:00',3.13),('325','2013-10-23','11:55:00',3.15),('325','2013-10-23','12:00:00',3.14),('325','2013-10-23','12:05:00',2.88),('325','2013-10-23','12:10:00',2.95),('325','2013-10-23','12:15:00',2.81),('325','2013-10-23','12:20:00',3.05),('325','2013-10-23','12:25:00',3.08),('325','2013-10-23','12:30:00',3.12),('325','2013-10-23','12:35:00',3.22),('325','2013-10-23','12:40:00',2.88),('325','2013-10-23','12:45:00',3),('325','2013-10-23','12:50:00',1.97),('325','2013-10-23','12:55:00',2.56),('325','2013-10-23','13:00:00',2.99),('325','2013-10-23','13:05:00',3.09),('325','2013-10-23','13:10:00',3.08),('325','2013-10-23','13:15:00',3.04),('325','2013-10-23','13:20:00',3.12),('325','2013-10-23','13:25:00',3.14),('325','2013-10-23','13:30:00',3.07),('325','2013-10-23','13:35:00',3),('325','2013-10-23','13:40:00',3.02),('325','2013-10-23','13:45:00',2.88),('325','2013-10-23','13:50:00',2.75),('325','2013-10-23','13:55:00',2.64),('325','2013-10-23','14:00:00',2.78),('325','2013-10-23','14:05:00',2.91),('325','2013-10-23','14:10:00',2.78),('325','2013-10-23','14:15:00',2.6),('325','2013-10-23','14:20:00',2.65),('325','2013-10-23','14:25:00',2.6),('325','2013-10-23','14:30:00',2.52),('325','2013-10-23','14:35:00',2.54),('325','2013-10-23','14:40:00',2.59),('325','2013-10-23','14:45:00',2.53),('325','2013-10-23','14:50:00',2.46),('325','2013-10-23','14:55:00',2.54),('325','2013-10-23','15:00:00',2.56),('325','2013-10-23','15:05:00',2.56),('325','2013-10-23','15:10:00',2.45),('325','2013-10-23','15:15:00',2.38),('325','2013-10-23','15:20:00',2.39),('325','2013-10-23','15:25:00',2.33),('325','2013-10-23','15:30:00',2.09),('325','2013-10-23','15:35:00',1.93),('325','2013-10-23','15:40:00',2.18),('325','2013-10-23','15:45:00',2.16),('325','2013-10-23','15:50:00',1.96),('325','2013-10-23','15:55:00',1.57),('325','2013-10-23','16:00:00',1.22),('325','2013-10-23','16:05:00',1.02),('325','2013-10-23','16:15:00',1.05),('325','2013-10-23','16:35:00',1.11),('325','2013-10-23','16:40:00',1.16),('325','2013-10-23','16:45:00',1.01),('325','2013-10-22','09:30:00',1.02),('325','2013-10-22','09:35:00',1.08),('325','2013-10-22','09:40:00',1.12),('325','2013-10-22','09:45:00',1.17),('325','2013-10-22','09:50:00',1.22),('325','2013-10-22','09:55:00',1.26),('325','2013-10-22','10:00:00',1.31),('325','2013-10-22','10:05:00',1.36),('325','2013-10-22','10:10:00',1.4),('325','2013-10-22','10:15:00',1.44),('325','2013-10-22','10:20:00',1.48),('325','2013-10-22','10:25:00',1.97),('325','2013-10-22','10:30:00',2.28),('325','2013-10-22','10:35:00',2.4),('325','2013-10-22','10:40:00',2.49),('325','2013-10-22','10:45:00',2.52),('325','2013-10-22','10:50:00',2.56),('325','2013-10-22','10:55:00',2.62),('325','2013-10-22','11:00:00',2.71),('325','2013-10-22','11:05:00',2.76),('325','2013-10-22','11:10:00',2.78),('325','2013-10-22','11:15:00',2.77),('325','2013-10-22','11:20:00',2.8),('325','2013-10-22','11:25:00',2.85),('325','2013-10-22','11:30:00',2.88),('325','2013-10-22','11:35:00',2.9),('325','2013-10-22','11:40:00',2.96),('325','2013-10-22','11:45:00',2.94),('325','2013-10-22','11:50:00',3),('325','2013-10-22','11:55:00',3.07),('325','2013-10-22','12:00:00',3.05),('325','2013-10-22','12:05:00',3.04),('325','2013-10-22','12:10:00',3.1),('325','2013-10-22','12:15:00',3.06),('325','2013-10-22','12:20:00',3.02),('325','2013-10-22','12:25:00',3.1),('325','2013-10-22','12:30:00',3.15),('325','2013-10-22','12:35:00',3.15),('325','2013-10-22','12:40:00',3.13),('325','2013-10-22','12:45:00',3.14),('325','2013-10-22','12:50:00',3.15),('325','2013-10-22','12:55:00',3.06),('325','2013-10-22','13:00:00',3.1),('325','2013-10-22','13:05:00',3.07),('325','2013-10-22','13:10:00',3.06),('325','2013-10-22','13:15:00',3.18),('325','2013-10-22','13:20:00',3.17),('325','2013-10-22','13:25:00',3.17),('325','2013-10-22','13:30:00',3),('325','2013-10-22','13:35:00',3),('325','2013-10-22','13:40:00',2.78),('325','2013-10-22','13:45:00',2.93),('325','2013-10-22','13:50:00',2.99),('325','2013-10-22','13:55:00',2.65),('325','2013-10-22','14:00:00',2.9),('325','2013-10-22','14:05:00',3.06),('325','2013-10-22','14:10:00',2.99),('325','2013-10-22','14:15:00',3.09),('325','2013-10-22','14:20:00',3.16),('325','2013-10-22','14:25:00',3.19),('325','2013-10-22','14:30:00',2.99),('325','2013-10-22','14:35:00',2.77),('325','2013-10-22','14:40:00',2.71),('325','2013-10-22','14:45:00',2.65),('325','2013-10-22','14:50:00',2.61),('325','2013-10-22','14:55:00',2.53),('325','2013-10-22','15:00:00',2.44),('325','2013-10-22','15:05:00',2.38),('325','2013-10-22','15:10:00',2.35),('325','2013-10-22','15:15:00',2.29),('325','2013-10-22','15:20:00',2.24),('325','2013-10-22','15:25:00',2.13),('325','2013-10-22','15:30:00',2.11),('325','2013-10-22','15:35:00',2.11),('325','2013-10-22','15:40:00',1.97),('325','2013-10-22','15:45:00',1.87),('325','2013-10-22','15:50:00',1.83),('325','2013-10-22','15:55:00',1.7),('325','2013-10-22','16:00:00',1.63),('325','2013-10-22','16:05:00',1.57),('325','2013-10-22','16:10:00',1.32),('325','2013-10-22','16:15:00',1.39),('325','2013-10-22','16:20:00',1.29),('325','2013-10-22','16:25:00',1.29),('325','2013-10-22','16:30:00',1.22),('325','2013-10-22','16:35:00',1.15),('325','2013-10-22','16:40:00',1.07),('325','2013-10-21','09:20:00',1.04),('325','2013-10-21','09:25:00',1.06),('325','2013-10-21','09:40:00',1.12),('325','2013-10-21','09:45:00',1.07),('325','2013-10-21','09:50:00',1.16),('325','2013-10-21','09:55:00',1.28),('325','2013-10-21','10:00:00',1.24),('325','2013-10-21','10:05:00',1.47),('325','2013-10-21','10:10:00',1.48),('325','2013-10-21','10:15:00',1.54),('325','2013-10-21','10:20:00',1.54),('325','2013-10-21','10:25:00',1.62),('325','2013-10-21','10:30:00',2.2),('325','2013-10-21','10:35:00',2.41),('325','2013-10-21','10:40:00',2.39),('325','2013-10-21','10:45:00',2.45),('325','2013-10-21','10:50:00',2.62),('325','2013-10-21','10:55:00',2.6),('325','2013-10-21','11:00:00',2.86),('325','2013-10-21','11:05:00',2.41),('325','2013-10-21','11:10:00',2.71),('325','2013-10-21','11:15:00',3),('325','2013-10-21','11:20:00',2.93),('325','2013-10-21','11:25:00',2.96),('325','2013-10-21','11:30:00',3.09),('325','2013-10-21','11:35:00',3.05),('325','2013-10-21','11:40:00',3.07),('325','2013-10-21','11:45:00',3.18),('325','2013-10-21','11:50:00',3.21),('325','2013-10-21','11:55:00',3.24),('325','2013-10-21','12:00:00',3.32),('325','2013-10-21','12:05:00',3.36),('325','2013-10-21','12:10:00',3.36),('325','2013-10-21','12:15:00',3.31),('325','2013-10-21','12:20:00',3.3),('325','2013-10-21','12:25:00',3.28),('325','2013-10-21','12:30:00',3.19),('325','2013-10-21','12:35:00',3.35),('325','2013-10-21','12:40:00',3.38),('325','2013-10-21','12:45:00',3.37),('325','2013-10-21','12:50:00',3.36),('325','2013-10-21','12:55:00',3.35),('325','2013-10-21','13:00:00',3.29),('325','2013-10-21','13:05:00',3.23),('325','2013-10-21','13:10:00',3.2),('325','2013-10-21','13:15:00',3.23),('325','2013-10-21','13:20:00',3.17),('325','2013-10-21','13:25:00',3.28),('325','2013-10-21','13:30:00',3.31),('325','2013-10-21','13:35:00',3.27),('325','2013-10-21','13:40:00',3.23),('325','2013-10-21','13:45:00',3.2),('325','2013-10-21','13:50:00',3.08),('325','2013-10-21','13:55:00',3.05),('325','2013-10-21','14:00:00',3.05),('325','2013-10-21','14:05:00',3.06),('325','2013-10-21','14:10:00',3.01),('325','2013-10-21','14:15:00',2.97),('325','2013-10-21','14:20:00',2.96),('325','2013-10-21','14:25:00',2.86),('325','2013-10-21','14:30:00',2.9),('325','2013-10-21','14:35:00',2.82),('325','2013-10-21','14:40:00',2.66),('325','2013-10-21','14:45:00',2.65),('325','2013-10-21','14:50:00',2.55),('325','2013-10-21','14:55:00',2.57),('325','2013-10-21','15:00:00',2.55),('325','2013-10-21','15:05:00',2.51),('325','2013-10-21','15:10:00',2.47),('325','2013-10-21','15:15:00',2.41),('325','2013-10-21','15:20:00',2.36),('325','2013-10-21','15:25:00',2.31),('325','2013-10-21','15:30:00',2.17),('325','2013-10-21','15:35:00',2.13),('325','2013-10-21','15:40:00',2.11),('325','2013-10-21','15:45:00',2.02),('325','2013-10-21','15:50:00',1.93),('325','2013-10-21','15:55:00',1.89),('325','2013-10-21','16:00:00',1.83),('325','2013-10-21','16:05:00',1.73),('325','2013-10-21','16:10:00',1.65),('325','2013-10-21','16:15:00',1.55),('325','2013-10-21','16:20:00',1.47),('325','2013-10-21','16:25:00',1.38),('325','2013-10-21','16:30:00',1.31),('325','2013-10-21','16:35:00',1.22),('325','2013-10-21','16:40:00',1.14),('325','2013-10-21','16:45:00',1.05),('325','2013-10-20','09:30:00',1.07),('325','2013-10-20','09:35:00',1.11),('325','2013-10-20','09:40:00',1.16),('325','2013-10-20','09:45:00',1.2),('325','2013-10-20','09:50:00',1.23),('325','2013-10-20','09:55:00',1.28),('325','2013-10-20','10:00:00',1.33),('325','2013-10-20','10:05:00',1.37),('325','2013-10-20','10:10:00',1.41),('325','2013-10-20','10:15:00',1.45),('325','2013-10-20','10:20:00',1.49),('325','2013-10-20','10:25:00',2.27),('325','2013-10-20','10:30:00',2.47),('325','2013-10-20','10:35:00',2.59),('325','2013-10-20','10:40:00',2.66),('325','2013-10-20','10:45:00',2.71),('325','2013-10-20','10:50:00',2.77),('325','2013-10-20','10:55:00',2.83),('325','2013-10-20','11:00:00',2.91),('325','2013-10-20','11:05:00',2.96),('325','2013-10-20','11:10:00',2.99),('325','2013-10-20','11:15:00',3.03),('325','2013-10-20','11:20:00',3.07),('325','2013-10-20','11:25:00',3.12),('325','2013-10-20','11:30:00',3.16),('325','2013-10-20','11:35:00',3.22),('325','2013-10-20','11:40:00',3.28),('325','2013-10-20','11:45:00',3.29),('325','2013-10-20','11:50:00',3.28),('325','2013-10-20','11:55:00',3.29),('325','2013-10-20','12:00:00',3.27),('325','2013-10-20','12:05:00',3.38),('325','2013-10-20','12:10:00',3.41),('325','2013-10-20','12:15:00',2.78),('325','2013-10-20','12:20:00',2.75),('325','2013-10-20','12:25:00',2.97),('325','2013-10-20','12:30:00',3.68),('325','2013-10-20','12:35:00',2.53),('325','2013-10-20','12:40:00',1.31),('325','2013-10-20','12:45:00',1.92),('325','2013-10-20','12:50:00',2.01),('325','2013-10-20','12:55:00',2.22),('325','2013-10-20','13:00:00',3.81),('325','2013-10-20','13:05:00',2.85),('325','2013-10-20','13:10:00',1.82),('325','2013-10-20','13:15:00',1.24),('325','2013-10-20','13:20:00',2.36),('325','2013-10-20','13:25:00',1.69),('325','2013-10-20','13:30:00',1.07),('325','2013-10-20','13:35:00',1.2),('325','2013-10-20','13:40:00',2.38),('325','2013-10-20','13:45:00',1.41),('325','2013-10-20','13:50:00',1.17),('325','2013-10-20','13:55:00',1.3),('325','2013-10-20','14:10:00',1.02),('325','2013-10-20','16:30:00',1.01),('325','2013-10-20','16:35:00',1.17),('325','2013-10-20','16:40:00',1.46),('325','2013-10-20','16:45:00',1.15),('325','2013-10-20','16:50:00',1.44),('325','2013-10-20','16:55:00',1.4),('325','2013-10-20','17:00:00',1.24),('325','2013-10-20','17:05:00',1.08),('325','2013-10-19','09:15:00',1.13),('325','2013-10-19','09:20:00',1.15),('325','2013-10-19','09:25:00',1.17),('325','2013-10-19','09:30:00',1.19),('325','2013-10-19','09:35:00',1.24),('325','2013-10-19','09:40:00',1.3),('325','2013-10-19','09:45:00',1.35),('325','2013-10-19','09:50:00',1.4),('325','2013-10-19','09:55:00',1.47),('325','2013-10-19','10:00:00',1.46),('325','2013-10-19','10:05:00',1.45),('325','2013-10-19','10:10:00',1.54),('325','2013-10-19','10:15:00',1.51),('325','2013-10-19','10:20:00',1.73),('325','2013-10-19','10:25:00',2.63),('325','2013-10-19','10:30:00',2.78),('325','2013-10-19','10:35:00',2.88),('325','2013-10-19','10:40:00',2.94),('325','2013-10-19','10:45:00',2.92),('325','2013-10-19','10:50:00',3.03),('325','2013-10-19','10:55:00',3.17),('325','2013-10-19','11:00:00',2.96),('325','2013-10-19','11:05:00',2.96),('325','2013-10-19','11:10:00',1.18),('325','2013-10-19','11:15:00',1.43),('325','2013-10-19','11:20:00',3),('325','2013-10-19','11:25:00',3.55),('325','2013-10-19','11:30:00',3.59),('325','2013-10-19','11:35:00',3.52),('325','2013-10-19','11:40:00',3.41),('325','2013-10-19','11:45:00',3.6),('325','2013-10-19','11:50:00',3.21),('325','2013-10-19','11:55:00',3.58),('325','2013-10-19','12:00:00',3.66),('325','2013-10-19','12:05:00',3.67),('325','2013-10-19','12:10:00',3.62),('325','2013-10-19','12:15:00',3.64),('325','2013-10-19','12:20:00',3.56),('325','2013-10-19','12:25:00',3.32),('325','2013-10-19','12:30:00',3.61),('325','2013-10-19','12:35:00',3.7),('325','2013-10-19','12:40:00',3.79),('325','2013-10-19','12:45:00',3.88),('325','2013-10-19','12:50:00',3.86),('325','2013-10-19','12:55:00',4.01),('325','2013-10-19','13:00:00',4.04),('325','2013-10-19','13:05:00',3.3),('325','2013-10-19','13:10:00',3.71),('325','2013-10-19','13:15:00',3.47),('325','2013-10-19','13:20:00',3.49),('325','2013-10-19','13:25:00',3.67),('325','2013-10-19','13:30:00',3.99),('325','2013-10-19','13:35:00',2.71),('325','2013-10-19','13:40:00',2.48),('325','2013-10-19','13:45:00',2.58),('325','2013-10-19','13:50:00',3.33),('325','2013-10-19','13:55:00',3.89),('325','2013-10-19','14:00:00',3.25),('325','2013-10-19','14:05:00',2.63),('325','2013-10-19','14:10:00',2.25),('325','2013-10-19','14:15:00',2.87),('325','2013-10-19','14:20:00',2.06),('325','2013-10-19','14:25:00',2),('325','2013-10-19','14:30:00',2.96),('325','2013-10-19','14:35:00',3.27),('325','2013-10-19','14:40:00',2.89),('325','2013-10-19','14:45:00',2.49),('325','2013-10-19','14:50:00',3.33),('325','2013-10-19','14:55:00',3.17),('325','2013-10-19','15:00:00',3.06),('325','2013-10-19','15:05:00',2.97),('325','2013-10-19','15:10:00',2.92),('325','2013-10-19','15:15:00',2.84),('325','2013-10-19','15:20:00',2.65),('325','2013-10-19','15:25:00',2.54),('325','2013-10-19','15:30:00',2.41),('325','2013-10-19','15:35:00',2.43),('325','2013-10-19','15:40:00',2.21),('325','2013-10-19','15:45:00',1.87),('325','2013-10-19','15:50:00',2.16),('325','2013-10-19','15:55:00',2.24),('325','2013-10-19','16:00:00',1.81),('325','2013-10-19','16:05:00',1.97),('325','2013-10-19','16:10:00',1.82),('325','2013-10-19','16:15:00',2),('325','2013-10-19','16:20:00',1.67),('325','2013-10-19','16:25:00',1.36),('325','2013-10-19','16:30:00',1.74),('325','2013-10-19','16:35:00',1.68),('325','2013-10-19','16:40:00',1.61),('325','2013-10-19','16:45:00',1.45),('325','2013-10-19','16:50:00',1.31),('325','2013-10-18','09:20:00',1.01),('325','2013-10-18','09:25:00',1.05),('325','2013-10-18','09:30:00',1.1),('325','2013-10-18','09:35:00',1.15),('325','2013-10-18','09:40:00',1.2),('325','2013-10-18','09:45:00',1.24),('325','2013-10-18','09:50:00',1.29),('325','2013-10-18','09:55:00',1.33),('325','2013-10-18','10:00:00',1.37),('325','2013-10-18','10:05:00',1.42),('325','2013-10-18','10:10:00',1.46),('325','2013-10-18','10:15:00',1.51),('325','2013-10-18','10:20:00',1.7),('325','2013-10-18','10:25:00',2.59),('325','2013-10-18','10:30:00',2.76),('325','2013-10-18','10:35:00',2.87),('325','2013-10-18','10:40:00',2.93),('325','2013-10-18','10:45:00',2.95),('325','2013-10-18','10:50:00',3.03),('325','2013-10-18','10:55:00',3.07),('325','2013-10-18','11:00:00',3.11),('325','2013-10-18','11:05:00',2.99),('325','2013-10-18','11:10:00',3.09),('325','2013-10-18','11:15:00',3.14),('325','2013-10-18','11:20:00',3.35),('325','2013-10-18','11:25:00',3.33),('325','2013-10-18','11:30:00',3.31),('325','2013-10-18','11:35:00',3.42),('325','2013-10-18','11:40:00',3.55),('325','2013-10-18','11:45:00',3.44),('325','2013-10-18','11:50:00',3.4),('325','2013-10-18','11:55:00',3.59),('325','2013-10-18','12:00:00',3.54),('325','2013-10-18','12:05:00',3.55),('325','2013-10-18','12:10:00',3.58),('325','2013-10-18','12:15:00',3.54),('325','2013-10-18','12:20:00',3.5),('325','2013-10-18','12:25:00',3.55),('325','2013-10-18','12:30:00',3.59),('325','2013-10-18','12:35:00',3.54),('325','2013-10-18','12:40:00',3.57),('325','2013-10-18','12:45:00',3.5),('325','2013-10-18','12:50:00',3.49),('325','2013-10-18','12:55:00',3.52),('325','2013-10-18','13:00:00',3.53),('325','2013-10-18','13:05:00',3.48),('325','2013-10-18','13:10:00',3.33),('325','2013-10-18','13:15:00',3.43),('325','2013-10-18','13:20:00',3.53),('325','2013-10-18','13:25:00',3.55),('325','2013-10-18','13:30:00',3.58),('325','2013-10-18','13:35:00',3.53),('325','2013-10-18','13:40:00',3.49),('325','2013-10-18','13:45:00',3.41),('325','2013-10-18','13:50:00',3.4),('325','2013-10-18','13:55:00',3.37),('325','2013-10-18','14:00:00',3.2),('325','2013-10-18','14:05:00',3.17),('325','2013-10-18','14:10:00',3.14),('325','2013-10-18','14:15:00',3.21),('325','2013-10-18','14:20:00',3.18),('325','2013-10-18','14:25:00',3.18),('325','2013-10-18','14:30:00',3.15),('325','2013-10-18','14:35:00',3.01),('325','2013-10-18','14:40:00',3.02),('325','2013-10-18','14:45:00',2.92),('325','2013-10-18','14:50:00',2.86),('325','2013-10-18','14:55:00',2.9),('325','2013-10-18','15:00:00',2.45),('325','2013-10-18','15:05:00',2.31),('325','2013-10-18','15:10:00',2.55),('325','2013-10-18','15:15:00',2.55),('325','2013-10-18','15:20:00',2.63),('325','2013-10-18','15:25:00',2.48),('325','2013-10-18','15:30:00',2.38),('325','2013-10-18','15:35:00',2.37),('325','2013-10-18','15:40:00',2.24),('325','2013-10-18','15:45:00',2.06),('325','2013-10-18','15:50:00',1.97),('325','2013-10-18','15:55:00',1.81),('325','2013-10-18','16:00:00',1.94),('325','2013-10-18','16:05:00',1.79),('325','2013-10-18','16:10:00',1.71),('325','2013-10-18','16:15:00',1.55),('325','2013-10-18','16:20:00',1.49),('325','2013-10-18','16:25:00',1.28),('325','2013-10-18','16:30:00',1.17),('325','2013-10-18','16:35:00',1.11),('325','2014-05-03','08:10:00',1.23),('325','2014-05-03','08:15:00',1.28),('325','2014-05-03','08:25:00',1.03),('325','2014-05-03','08:30:00',1.24),('325','2014-05-03','08:45:00',1.04),('325','2014-05-03','08:50:00',1.69),('325','2014-05-03','08:55:00',1.73),('325','2014-05-03','09:00:00',1.58),('325','2014-05-03','09:05:00',1.77),('325','2014-05-03','09:10:00',1.07),('325','2014-05-03','09:15:00',1.7),('325','2014-05-03','09:20:00',2.65),('325','2014-05-03','09:25:00',1.72),('325','2014-05-03','09:30:00',1.53),('325','2014-05-03','09:35:00',3.03),('325','2014-05-03','09:40:00',2.5),('325','2014-05-03','09:45:00',3.67),('325','2014-05-03','09:50:00',2.62),('325','2014-05-03','09:55:00',3.67),('325','2014-05-03','10:00:00',3.68),('325','2014-05-03','10:05:00',3.69),('325','2014-05-03','10:10:00',3.6),('325','2014-05-03','10:15:00',4.37),('325','2014-05-03','10:20:00',1.45),('325','2014-05-03','10:25:00',1.31),('325','2014-05-03','10:30:00',1.84),('325','2014-05-03','10:35:00',1.76),('325','2014-05-03','10:40:00',1.71),('325','2014-05-03','10:45:00',1.21),('325','2014-05-03','10:50:00',1.14),('325','2014-05-03','10:55:00',1.86),('325','2014-05-03','11:00:00',2.03),('325','2014-05-03','11:05:00',5.02),('325','2014-05-03','11:10:00',5.82),('325','2014-05-03','11:15:00',5.15),('325','2014-05-03','11:20:00',5.08),('325','2014-05-03','11:25:00',4.14),('325','2014-05-03','11:30:00',5.1),('325','2014-05-03','11:35:00',3.07),('325','2014-05-03','11:40:00',3.33),('325','2014-05-03','11:45:00',2.99),('325','2014-05-03','11:50:00',2.52),('325','2014-05-03','11:55:00',2.66),('325','2014-05-03','12:00:00',1.86),('325','2014-05-03','12:05:00',1.36),('325','2014-05-03','12:10:00',1.19),('325','2014-05-03','12:15:00',1.13),('325','2014-05-03','12:20:00',1.1),('325','2014-05-03','12:25:00',1.2),('325','2014-05-03','12:30:00',1.7),('325','2014-05-03','12:35:00',2.27),('325','2014-05-03','12:40:00',2.22),('325','2014-05-03','12:45:00',2.1),('325','2014-05-03','12:50:00',1.71),('325','2014-05-03','12:55:00',1.69),('325','2014-05-03','13:00:00',1.99),('325','2014-05-03','13:05:00',2.63),('325','2014-05-03','13:10:00',2.94),('325','2014-05-03','13:15:00',3.13),('325','2014-05-03','13:20:00',2.78),('325','2014-05-03','13:25:00',2.8),('325','2014-05-03','13:30:00',3.52),('325','2014-05-03','13:35:00',3.64),('325','2014-05-03','13:40:00',2.4),('325','2014-05-03','13:45:00',1.96),('325','2014-05-03','13:50:00',1.92),('325','2014-05-03','13:55:00',1.93),('325','2014-05-03','14:00:00',1.91),('325','2014-05-03','14:05:00',1.98),('325','2014-05-03','14:10:00',2.21),('325','2014-05-03','14:15:00',2.79),('325','2014-05-03','14:20:00',3.06),('325','2014-05-03','14:25:00',3.69),('325','2014-05-03','14:30:00',2.06),('325','2014-05-03','14:35:00',1.46),('325','2014-05-03','14:40:00',1.02),('325','2014-05-03','14:55:00',3.3),('325','2014-05-03','15:00:00',2.74),('325','2014-05-03','15:05:00',1.38),('325','2014-05-03','15:10:00',1.09),('325','2014-05-03','17:05:00',1),('325','2014-05-03','17:10:00',1.01),('325','2014-05-03','17:15:00',1),('325','2014-05-03','17:50:00',1.12),('325','2014-05-03','17:55:00',1.18),('325','2014-04-15','09:00:00',1.24),('325','2014-04-15','09:05:00',1.5),('325','2014-04-15','09:10:00',1.85),('325','2014-04-15','09:15:00',2.14),('325','2014-04-15','09:20:00',2.38),('325','2014-04-15','09:25:00',2.79),('325','2014-04-15','09:30:00',1.85),('325','2014-04-15','09:45:00',1.21),('325','2014-04-15','09:50:00',1.79),('325','2014-04-15','09:55:00',1.05),('325','2014-04-15','10:00:00',1.45),('325','2014-04-15','10:05:00',1.72),('325','2014-04-15','10:10:00',2.38),('325','2014-04-15','10:15:00',1.84),('325','2014-04-15','10:20:00',2.03),('325','2014-04-15','10:25:00',2.53),('325','2014-04-15','10:30:00',3.86),('325','2014-04-15','10:35:00',2.16),('325','2014-04-15','10:40:00',2.8),('325','2014-04-15','10:45:00',2.92),('325','2014-04-15','10:50:00',2.48),('325','2014-04-15','10:55:00',1.86),('325','2014-04-15','11:00:00',2.18),('325','2014-04-15','11:05:00',3.03),('325','2014-04-15','11:10:00',1.82),('325','2014-04-15','11:15:00',1.62),('325','2014-04-15','11:20:00',1.21),('325','2014-04-15','11:25:00',1.8),('325','2014-04-15','11:30:00',1.22),('325','2014-04-15','11:45:00',1.28),('325','2014-04-15','11:50:00',1.41),('325','2014-04-15','12:15:00',1.77),('325','2014-04-15','12:20:00',2),('325','2014-04-15','13:05:00',1.15),('325','2014-04-15','13:10:00',1.32),('325','2014-04-15','13:15:00',2.73),('325','2014-04-15','13:20:00',2.73),('325','2014-04-15','13:25:00',2.18),('325','2014-04-15','13:30:00',2.65),('325','2014-04-15','13:35:00',2.73),('325','2014-04-15','13:40:00',1.5),('325','2014-04-15','14:00:00',3.57),('325','2014-04-15','14:05:00',1.54),('325','2014-04-15','14:10:00',2.37),('325','2014-04-15','14:15:00',4.44),('325','2014-04-15','14:20:00',3.87),('325','2014-04-15','14:25:00',3.1),('325','2014-04-15','14:30:00',1.83),('325','2014-04-15','14:35:00',1.64),('325','2014-04-15','14:40:00',3.85),('325','2014-04-15','14:45:00',2.51),('325','2014-04-15','14:50:00',2.9),('325','2014-04-15','14:55:00',1.89),('325','2014-04-15','15:05:00',1.23),('325','2014-04-15','15:10:00',1.21),('325','2014-04-15','15:15:00',2.59),('325','2014-04-15','15:20:00',2.03),('325','2014-04-15','15:25:00',2.21),('325','2014-04-15','15:30:00',1.65),('325','2014-04-15','15:35:00',1.5),('325','2014-04-15','15:40:00',1.52),('325','2014-04-15','15:45:00',1.44),('325','2014-04-15','15:50:00',1.44),('325','2014-04-15','15:55:00',1.54),('325','2014-04-15','16:00:00',1.69),('325','2014-04-15','16:05:00',1.71),('325','2013-10-17','09:20:00',1.02),('325','2013-10-17','09:25:00',1.07),('325','2013-10-17','09:30:00',1.12),('325','2013-10-17','09:35:00',1.16),('325','2013-10-17','09:40:00',1.2),('325','2013-10-17','09:45:00',1.25),('325','2013-10-17','09:50:00',1.29),('325','2013-10-17','09:55:00',1.33),('325','2013-10-17','10:00:00',1.36),('325','2013-10-17','10:05:00',1.4),('325','2013-10-17','10:10:00',1.45),('325','2013-10-17','10:15:00',1.49),('325','2013-10-17','10:20:00',2.5),('325','2013-10-17','10:25:00',2.63),('325','2013-10-17','10:30:00',2.75),('325','2013-10-17','10:35:00',2.86),('325','2013-10-17','10:40:00',2.93),('325','2013-10-17','10:45:00',3.01),('325','2013-10-17','10:50:00',3.1),('325','2013-10-17','10:55:00',3.16),('325','2013-10-17','11:00:00',3.23),('325','2013-10-17','11:05:00',3.28),('325','2013-10-17','11:10:00',3.33),('325','2013-10-17','11:15:00',3.37),('325','2013-10-17','11:20:00',3.4),('325','2013-10-17','11:25:00',3.43),('325','2013-10-17','11:30:00',3.48),('325','2013-10-17','11:35:00',3.52),('325','2013-10-17','11:40:00',3.6),('325','2013-10-17','11:45:00',3.59),('325','2013-10-17','11:50:00',3.59),('325','2013-10-17','11:55:00',3.62),('325','2013-10-17','12:00:00',3.63),('325','2013-10-17','12:05:00',3.66),('325','2013-10-17','12:10:00',3.66),('325','2013-10-17','12:15:00',3.67),('325','2013-10-17','12:20:00',3.7),('325','2013-10-17','12:25:00',3.71),('325','2013-10-17','12:30:00',3.72),('325','2013-10-17','12:35:00',3.75),('325','2013-10-17','12:40:00',3.77),('325','2013-10-17','12:45:00',3.78),('325','2013-10-17','12:50:00',3.77),('325','2013-10-17','12:55:00',3.75),('325','2013-10-17','13:00:00',3.75),('325','2013-10-17','13:05:00',3.73),('325','2013-10-17','13:10:00',3.72),('325','2013-10-17','13:15:00',3.69),('325','2013-10-17','13:20:00',3.67),('325','2013-10-17','13:25:00',3.65),('325','2013-10-17','13:30:00',3.64),('325','2013-10-17','13:35:00',3.64),('325','2013-10-17','13:40:00',3.62),('325','2013-10-17','13:45:00',3.61),('325','2013-10-17','13:50:00',3.59),('325','2013-10-17','13:55:00',3.55),('325','2013-10-17','14:00:00',3.53),('325','2013-10-17','14:05:00',3.49),('325','2013-10-17','14:10:00',3.48),('325','2013-10-17','14:15:00',3.47),('325','2013-10-17','14:20:00',3.42),('325','2013-10-17','14:25:00',3.36),('325','2013-10-17','14:30:00',3.31),('325','2013-10-17','14:35:00',3.27),('325','2013-10-17','14:40:00',3.23),('325','2013-10-17','14:45:00',3.19),('325','2013-10-17','14:50:00',3.12),('325','2013-10-17','14:55:00',3.04),('325','2013-10-17','15:00:00',2.99),('325','2013-10-17','15:05:00',2.96),('325','2013-10-17','15:10:00',2.91),('325','2013-10-17','15:15:00',2.85),('325','2013-10-17','15:20:00',2.78),('325','2013-10-17','15:25:00',2.71),('325','2013-10-17','15:30:00',2.64),('325','2013-10-17','15:35:00',2.57),('325','2013-10-17','15:40:00',2.51),('325','2013-10-17','15:45:00',2.42),('325','2013-10-17','15:50:00',2.33),('325','2013-10-17','15:55:00',2.25),('325','2013-10-17','16:00:00',2.16),('325','2013-10-17','16:05:00',2.09),('325','2013-10-17','16:10:00',1.99),('325','2013-10-17','16:15:00',1.9),('325','2013-10-17','16:20:00',1.83),('325','2013-10-17','16:25:00',1.74),('325','2013-10-17','16:30:00',1.65),('325','2013-10-17','16:35:00',1.56),('325','2013-10-17','16:40:00',1.47),('325','2013-10-17','16:45:00',1.35),('325','2013-10-17','16:50:00',1.26),('325','2013-10-17','16:55:00',1.17),('325','2013-10-17','17:00:00',1.08),('325','2013-10-16','09:45:00',1.53),('325','2013-10-16','09:50:00',1.22),('325','2013-10-16','11:15:00',1.3),('325','2013-10-16','11:55:00',1.21),('325','2013-10-16','12:10:00',1.71),('325','2013-10-16','12:15:00',3.56),('325','2013-10-16','12:20:00',1.71),('325','2013-10-16','12:30:00',1.53),('325','2013-10-16','12:35:00',1.4),('325','2013-10-16','12:40:00',4.27),('325','2013-10-16','12:45:00',2.82),('325','2013-10-16','12:50:00',3.56),('325','2013-10-16','12:55:00',1.94),('325','2013-10-16','13:00:00',2.54),('325','2013-10-16','13:05:00',3.85),('325','2013-10-16','13:10:00',2.5),('325','2013-10-16','13:15:00',3.8),('325','2013-10-16','13:20:00',4.08),('325','2013-10-16','13:25:00',3.99),('325','2013-10-16','13:30:00',3.8),('325','2013-10-16','13:35:00',3.69),('325','2013-10-16','13:40:00',3.72),('325','2013-10-16','13:45:00',3.68),('325','2013-10-16','13:50:00',3.38),('325','2013-10-16','13:55:00',3.86),('325','2013-10-16','14:00:00',2.97),('325','2013-10-16','14:05:00',2.49),('325','2013-10-16','14:10:00',3.84),('325','2013-10-16','14:15:00',3.1),('325','2013-10-16','14:20:00',3.31),('325','2013-10-16','14:25:00',3.86),('325','2013-10-16','14:30:00',3.48),('325','2013-10-16','14:35:00',2.82),('325','2013-10-16','14:40:00',3.35),('325','2013-10-16','14:45:00',2.39),('325','2013-10-16','14:50:00',3.09),('325','2013-10-16','14:55:00',2.88),('325','2013-10-16','15:00:00',3.07),('325','2013-10-16','15:05:00',2.04),('325','2013-10-16','15:10:00',2.63),('325','2013-10-16','15:15:00',2.6),('325','2013-10-16','15:20:00',2.28),('325','2013-10-16','15:25:00',1.69),('325','2013-10-16','15:35:00',1.87),('325','2013-10-16','15:40:00',2.62),('325','2013-10-16','15:45:00',2.44),('325','2013-10-16','15:50:00',2.35),('325','2013-10-16','15:55:00',2.29),('325','2013-10-16','16:00:00',2.2),('325','2013-10-16','16:05:00',2.12),('325','2013-10-16','16:10:00',1.93),('325','2013-10-16','16:15:00',1.89),('325','2013-10-16','16:20:00',1.81),('325','2013-10-16','16:25:00',1.71),('325','2013-10-16','16:30:00',1.61),('325','2013-10-16','16:35:00',1.32),('325','2013-10-16','16:40:00',1.47),('325','2013-10-16','16:45:00',1.36),('325','2013-10-16','16:50:00',1.26),('325','2013-10-16','16:55:00',1.17),('325','2013-10-16','17:00:00',1.07),('325','2013-10-15','09:30:00',1.12),('325','2013-10-15','09:40:00',1.03),('325','2013-10-15','09:45:00',1.34),('325','2013-10-15','09:50:00',1.47),('325','2013-10-15','09:55:00',1.58),('325','2013-10-15','10:00:00',1.62),('325','2013-10-15','10:05:00',1.8),('325','2013-10-15','10:10:00',1.45),('325','2013-10-15','10:15:00',1.03),('325','2013-10-15','10:20:00',1.03),('325','2013-10-15','10:25:00',1.32),('325','2013-10-15','10:30:00',1.56),('325','2013-10-15','10:35:00',1.42),('325','2013-10-15','10:40:00',1.7),('325','2013-10-15','10:45:00',1.93),('325','2013-10-15','10:50:00',1.94),('325','2013-10-15','10:55:00',1.94),('325','2013-10-15','11:00:00',1.95),('325','2013-10-15','11:05:00',2.14),('325','2013-10-15','11:10:00',2.78),('325','2013-10-15','11:15:00',3.01),('325','2013-10-15','11:20:00',3.05),('325','2013-10-15','11:25:00',2.84),('325','2013-10-15','11:30:00',2.96),('325','2013-10-15','11:35:00',2.46),('325','2013-10-15','11:40:00',1.92),('325','2013-10-15','11:45:00',1.55),('325','2013-10-15','11:50:00',1.49),('325','2013-10-15','11:55:00',1.49),('325','2013-10-15','12:00:00',1.55),('325','2013-10-15','12:05:00',1.54),('325','2013-10-15','12:10:00',1.56),('325','2013-10-15','12:15:00',1.52),('325','2013-10-15','12:20:00',1.62),('325','2013-10-15','12:25:00',1.41),('325','2013-10-15','12:30:00',1.32),('325','2013-10-15','12:35:00',1.27),('325','2013-10-15','12:40:00',1.3),('325','2013-10-15','12:45:00',1.46),('325','2013-10-15','12:50:00',1.37),('325','2013-10-15','12:55:00',1.22),('325','2013-10-15','13:00:00',1.24),('325','2013-10-15','13:05:00',1.74),('325','2013-10-15','13:10:00',1.95),('325','2013-10-15','13:15:00',2.02),('325','2013-10-15','13:20:00',3.03),('325','2013-10-15','13:25:00',3.35),('325','2013-10-15','13:30:00',2.06),('325','2013-10-15','13:35:00',1.71),('325','2013-10-15','13:40:00',1.59),('325','2013-10-15','13:45:00',1.67),('325','2013-10-15','13:50:00',1.54),('325','2013-10-15','13:55:00',1.31),('325','2013-10-15','14:00:00',1.18),('325','2013-10-15','14:05:00',1.18),('325','2013-10-15','14:10:00',1.35),('325','2013-10-15','14:15:00',1.94),('325','2013-10-15','14:20:00',2.09),('325','2013-10-15','14:25:00',2.49),('325','2013-10-15','14:30:00',2.17),('325','2013-10-15','14:35:00',1.52),('325','2013-10-15','14:40:00',2.26),('325','2013-10-15','14:45:00',2.28),('325','2013-10-15','14:50:00',2.74),('325','2013-10-15','14:55:00',2.05),('325','2013-10-15','15:00:00',1.38),('325','2013-10-15','15:05:00',1.43),('325','2013-10-15','15:10:00',1.46),('325','2013-10-15','15:15:00',1.34),('325','2013-10-15','15:20:00',1.19),('325','2013-10-15','15:25:00',1.05),('325','2013-10-15','15:30:00',1.01),('325','2013-10-15','15:35:00',1.06),('325','2013-10-15','15:40:00',1.11),('325','2013-10-15','15:45:00',1.05),('325','2013-10-15','16:30:00',1.23),('325','2013-10-15','16:35:00',1.22),('325','2013-10-14','09:25:00',1.12),('325','2013-10-14','09:30:00',1.25),('325','2013-10-14','09:35:00',1.22),('325','2013-10-14','09:40:00',1.12),('325','2013-10-14','09:50:00',1.16),('325','2013-10-14','09:55:00',1.31),('325','2013-10-14','10:00:00',1.32),('325','2013-10-14','10:05:00',1.41),('325','2013-10-14','10:10:00',1.5),('325','2013-10-14','10:15:00',1.57),('325','2013-10-14','10:20:00',1.97),('325','2013-10-14','10:25:00',2.48),('325','2013-10-14','10:30:00',2.61),('325','2013-10-14','10:35:00',2.68),('325','2013-10-14','10:40:00',2.64),('325','2013-10-14','10:45:00',2.73),('325','2013-10-14','10:50:00',2.84),('325','2013-10-14','10:55:00',2.93),('325','2013-10-14','11:00:00',3),('325','2013-10-14','11:05:00',3),('325','2013-10-14','11:10:00',3.16),('325','2013-10-14','11:15:00',3.11),('325','2013-10-14','11:20:00',3.13),('325','2013-10-14','11:25:00',3.22),('325','2013-10-14','11:30:00',3.3),('325','2013-10-14','11:35:00',3.26),('325','2013-10-14','11:40:00',3.31),('325','2013-10-14','11:45:00',3.27),('325','2013-10-14','11:50:00',3.34),('325','2013-10-14','11:55:00',3.35),('325','2013-10-14','12:00:00',3.37),('325','2013-10-14','12:05:00',3.41),('325','2013-10-14','12:10:00',3.46),('325','2013-10-14','12:15:00',3.39),('325','2013-10-14','12:20:00',3.18),('325','2013-10-14','12:25:00',3.42),('325','2013-10-14','12:30:00',3.54),('325','2013-10-14','12:35:00',3.51),('325','2013-10-14','12:40:00',3.52),('325','2013-10-14','12:45:00',3.53),('325','2013-10-14','12:50:00',3.5),('325','2013-10-14','12:55:00',3.49),('325','2013-10-14','13:00:00',3.49),('325','2013-10-14','13:05:00',3.48),('325','2013-10-14','13:10:00',3.47),('325','2013-10-14','13:15:00',3.46),('325','2013-10-14','13:20:00',3.47),('325','2013-10-14','13:25:00',3.46),('325','2013-10-14','13:30:00',3.43),('325','2013-10-14','13:35:00',3.41),('325','2013-10-14','13:40:00',3.39),('325','2013-10-14','13:45:00',3.39),('325','2013-10-14','13:50:00',3.36),('325','2013-10-14','13:55:00',3.34),('325','2013-10-14','14:00:00',3.31),('325','2013-10-14','14:05:00',3.28),('325','2013-10-14','14:10:00',3.26),('325','2013-10-14','14:15:00',3.22),('325','2013-10-14','14:20:00',3.18),('325','2013-10-14','14:25:00',3.15),('325','2013-10-14','14:30:00',3.13),('325','2013-10-14','14:35:00',3.08),('325','2013-10-14','14:40:00',3.05),('325','2013-10-14','14:45:00',2.99),('325','2013-10-14','14:50:00',2.93),('325','2013-10-14','14:55:00',2.88),('325','2013-10-14','15:00:00',2.82),('325','2013-10-14','15:05:00',2.75),('325','2013-10-14','15:10:00',2.68),('325','2013-10-14','15:15:00',2.6),('325','2013-10-14','15:20:00',2.56),('325','2013-10-14','15:25:00',2.49),('325','2013-10-14','15:30:00',2.41),('325','2013-10-14','15:35:00',2.31),('325','2013-10-14','15:40:00',2),('325','2013-10-14','15:45:00',1.64),('325','2013-10-14','15:50:00',1.72),('325','2013-10-14','15:55:00',1.2),('325','2013-10-14','16:00:00',1.5),('325','2013-10-14','16:05:00',1.25),('325','2013-10-14','16:10:00',1.04),('325','2013-10-14','16:25:00',1.06),('325','2013-10-14','16:30:00',1.05),('325','2013-10-13','09:15:00',1.25),('325','2013-10-13','09:20:00',1.31),('325','2013-10-13','09:25:00',1.17),('325','2013-10-13','09:35:00',1.23),('325','2013-10-13','09:40:00',1.66),('325','2013-10-13','09:45:00',2.05),('325','2013-10-13','09:50:00',2.03),('325','2013-10-13','09:55:00',2.08),('325','2013-10-13','10:00:00',1.56),('325','2013-10-13','10:05:00',1.38),('325','2013-10-13','10:10:00',1.9),('325','2013-10-13','10:15:00',1.95),('325','2013-10-13','10:20:00',1.7),('325','2013-10-13','10:25:00',1.82),('325','2013-10-13','10:30:00',2.77),('325','2013-10-13','10:35:00',3.23),('325','2013-10-13','10:40:00',3.33),('325','2013-10-13','10:45:00',3.41),('325','2013-10-13','10:50:00',2.86),('325','2013-10-13','10:55:00',2.35),('325','2013-10-13','11:00:00',3.07),('325','2013-10-13','11:05:00',2.98),('325','2013-10-13','11:10:00',2.95),('325','2013-10-13','11:15:00',3.41),('325','2013-10-13','11:20:00',3.29),('325','2013-10-13','11:25:00',3.24),('325','2013-10-13','11:30:00',3.34),('325','2013-10-13','11:35:00',3.3),('325','2013-10-13','11:40:00',3.35),('325','2013-10-13','11:45:00',3.38),('325','2013-10-13','11:50:00',3.42),('325','2013-10-13','11:55:00',3.44),('325','2013-10-13','12:00:00',3.46),('325','2013-10-13','12:05:00',3.48),('325','2013-10-13','12:10:00',3.47),('325','2013-10-13','12:15:00',3.53),('325','2013-10-13','12:20:00',3.45),('325','2013-10-13','12:25:00',3.41),('325','2013-10-13','12:30:00',3.52),('325','2013-10-13','12:35:00',3.58),('325','2013-10-13','12:40:00',3.58),('325','2013-10-13','12:45:00',3.53),('325','2013-10-13','12:50:00',3.49),('325','2013-10-13','12:55:00',3.49),('325','2013-10-13','13:00:00',3.51),('325','2013-10-13','13:05:00',3.5),('325','2013-10-13','13:10:00',3.52),('325','2013-10-13','13:15:00',3.57),('325','2013-10-13','13:20:00',3.61),('325','2013-10-13','13:25:00',3.14),('325','2013-10-13','13:30:00',2.67),('325','2013-10-13','13:35:00',2.97),('325','2013-10-13','13:40:00',2.04),('325','2013-10-13','13:45:00',2.42),('325','2013-10-13','13:50:00',2.65),('325','2013-10-13','13:55:00',2.76),('325','2013-10-13','14:00:00',3.37),('325','2013-10-13','14:05:00',3.35),('325','2013-10-13','14:10:00',3.41),('325','2013-10-13','14:15:00',3.14),('325','2013-10-13','14:20:00',3.4),('325','2013-10-13','14:25:00',3.41),('325','2013-10-13','14:30:00',2.83),('325','2013-10-13','14:35:00',2.63),('325','2013-10-13','14:40:00',2.95),('325','2013-10-13','14:45:00',2.28),('325','2013-10-13','14:50:00',1.88),('325','2013-10-13','14:55:00',2.32),('325','2013-10-13','15:00:00',2.89),('325','2013-10-13','15:05:00',2.41),('325','2013-10-13','15:10:00',1.67),('325','2013-10-13','15:15:00',2.02),('325','2013-10-13','15:20:00',2.34),('325','2013-10-13','15:25:00',2.42),('325','2013-10-13','15:30:00',1.8),('325','2013-10-13','15:35:00',1.65),('325','2013-10-13','15:40:00',1.61),('325','2013-10-13','15:45:00',1.51),('325','2013-10-13','15:50:00',1.42),('325','2013-10-13','15:55:00',1.35),('325','2013-10-13','16:00:00',1.56),('325','2013-10-13','16:05:00',1.86),('325','2013-10-13','16:10:00',1.53),('325','2013-10-13','16:15:00',1.38),('325','2013-10-13','16:20:00',1.42),('325','2013-10-13','16:25:00',1.92),('325','2013-10-13','16:30:00',1.84),('325','2013-10-13','16:35:00',1.54),('325','2013-10-13','16:40:00',1.23),('325','2013-10-13','16:50:00',1.01),('325','2013-10-12','11:20:00',1.09),('325','2013-10-12','11:25:00',1.17),('325','2013-10-12','11:30:00',1.42),('325','2013-10-12','11:35:00',2.06),('325','2013-10-12','11:40:00',3.11),('325','2013-10-12','11:45:00',1.53),('325','2013-10-12','11:50:00',1.47),('325','2013-10-12','11:55:00',1.2),('325','2013-10-12','12:15:00',1.2),('325','2013-10-12','12:20:00',2.35),('325','2013-10-12','12:25:00',3.83),('325','2013-10-12','12:30:00',2.83),('325','2013-10-12','12:35:00',3.43),('325','2013-10-12','12:40:00',3.54),('325','2013-10-12','12:45:00',3.1),('325','2013-10-12','12:50:00',3.25),('325','2013-10-12','12:55:00',2.74),('325','2013-10-12','13:00:00',2.09),('325','2013-10-12','13:05:00',1.01),('325','2013-10-12','13:15:00',1.4),('325','2013-10-12','13:20:00',1.43),('325','2013-10-12','13:25:00',1.7),('325','2013-10-12','13:30:00',3.73),('325','2013-10-12','13:35:00',1.41),('325','2013-10-12','15:55:00',1.02),('325','2013-10-12','16:00:00',1.18),('325','2013-10-12','16:05:00',1.12),('325','2013-10-12','16:10:00',1.21),('325','2013-10-12','16:15:00',1.89),('325','2013-10-12','16:20:00',2.07),('325','2013-10-12','16:25:00',1.13),('325','2013-10-11','09:45:00',1.33),('325','2013-10-11','09:50:00',1.36),('325','2013-10-11','09:55:00',1.38),('325','2013-10-11','10:00:00',1.45),('325','2013-10-11','10:05:00',1.52),('325','2013-10-11','10:10:00',1.57),('325','2013-10-11','10:15:00',1.51),('325','2013-10-11','10:20:00',2.24),('325','2013-10-11','10:25:00',2.77),('325','2013-10-11','10:30:00',2.98),('325','2013-10-11','10:35:00',3.17),('325','2013-10-11','10:40:00',1.81),('325','2013-10-11','11:05:00',2.67),('325','2013-10-11','11:10:00',2.19),('325','2013-10-11','11:15:00',1.01),('325','2013-10-11','11:20:00',1.08),('325','2013-10-11','11:25:00',1.07),('325','2013-10-11','11:35:00',1.09),('325','2013-10-11','11:40:00',2.03),('325','2013-10-11','11:45:00',1.88),('325','2013-10-11','11:50:00',2.23),('325','2013-10-11','11:55:00',1.89),('325','2013-10-11','12:00:00',2.57),('325','2013-10-11','12:05:00',3.14),('325','2013-10-11','12:10:00',1.51),('325','2013-10-11','12:15:00',1.1),('325','2013-10-11','12:25:00',1.91),('325','2013-10-11','12:30:00',1.37),('325','2013-10-11','13:05:00',1.9),('325','2013-10-11','13:10:00',2.04),('325','2013-10-11','13:15:00',1.66),('325','2013-10-11','13:20:00',3.43),('325','2013-10-11','13:25:00',4.58),('325','2013-10-11','13:30:00',1.56),('325','2013-10-11','13:40:00',3.08),('325','2013-10-11','13:45:00',3.73),('325','2013-10-11','13:50:00',1.26),('325','2013-10-11','15:35:00',1.3),('325','2013-10-11','15:40:00',1.6),('325','2013-10-11','15:45:00',1.02),('325','2013-10-11','15:55:00',1.31),('325','2013-10-11','16:00:00',2.52),('325','2013-10-11','16:05:00',1.05),('325','2013-10-11','16:30:00',1.05),('325','2013-10-11','17:00:00',1.21),('325','2013-10-10','09:10:00',1.01),('325','2013-10-10','09:15:00',1.08),('325','2013-10-10','09:20:00',1.09),('325','2013-10-10','09:25:00',1.1),('325','2013-10-10','09:30:00',1.15),('325','2013-10-10','09:40:00',1.21),('325','2013-10-10','09:45:00',1.34),('325','2013-10-10','09:50:00',1.38),('325','2013-10-10','09:55:00',1.24),('325','2013-10-10','10:10:00',1.31),('325','2013-10-10','10:15:00',1.61),('325','2013-10-10','10:20:00',2.45),('325','2013-10-10','10:25:00',2),('325','2013-10-10','10:30:00',1.61),('325','2013-10-10','10:35:00',2.17),('325','2013-10-10','10:40:00',2.49),('325','2013-10-10','10:45:00',3.04),('325','2013-10-10','10:50:00',2.64),('325','2013-10-10','10:55:00',2.63),('325','2013-10-10','11:05:00',1.33),('325','2013-10-10','11:20:00',2.4),('325','2013-10-10','11:25:00',3.73),('325','2013-10-10','11:30:00',1.06),('325','2013-10-10','11:35:00',2.12),('325','2013-10-10','11:40:00',2.44),('325','2013-10-10','11:50:00',3),('325','2013-10-10','11:55:00',2.88),('325','2013-10-10','12:00:00',4.07),('325','2013-10-10','12:05:00',4.14),('325','2013-10-10','12:10:00',1.47),('325','2013-10-10','12:20:00',3),('325','2013-10-10','12:25:00',3.69),('325','2013-10-10','12:35:00',3.72),('325','2013-10-10','12:40:00',4.31),('325','2013-10-10','12:45:00',3.05),('325','2013-10-10','12:50:00',2.49),('325','2013-10-10','12:55:00',4.45),('325','2013-10-10','13:00:00',4.3),('325','2013-10-10','13:05:00',4.48),('325','2013-10-10','13:10:00',3.14),('325','2013-10-10','13:15:00',2.34),('325','2013-10-10','13:20:00',1.15),('325','2013-10-10','13:25:00',3.74),('325','2013-10-10','13:30:00',4.73),('325','2013-10-10','13:35:00',4.45),('325','2013-10-10','13:40:00',3.68),('325','2013-10-10','13:45:00',2.45),('325','2013-10-10','13:50:00',4.19),('325','2013-10-10','13:55:00',4.05),('325','2013-10-10','14:00:00',3.93),('325','2013-10-10','14:05:00',3.63),('325','2013-10-10','14:10:00',4.15),('325','2013-10-10','14:15:00',2.8),('325','2013-10-10','14:20:00',3.18),('325','2013-10-10','14:25:00',3.67),('325','2013-10-10','14:30:00',4.04),('325','2013-10-10','14:35:00',4.03),('325','2013-10-10','14:40:00',3.78),('325','2013-10-10','14:45:00',3.65),('325','2013-10-10','14:50:00',3.5),('325','2013-10-10','14:55:00',3.1),('325','2013-10-10','15:00:00',3.11),('325','2013-10-10','15:05:00',2.84),('325','2013-10-10','15:10:00',3.41),('325','2013-10-10','15:15:00',2.24),('325','2013-10-10','15:20:00',2.2),('325','2013-10-10','15:25:00',1.77),('325','2013-10-10','15:30:00',2.32),('325','2013-10-10','15:35:00',1.14),('325','2013-10-10','15:40:00',2.81),('325','2013-10-10','15:45:00',2.19),('325','2013-10-10','15:50:00',1.84),('325','2013-10-10','15:55:00',3.04),('325','2013-10-10','16:00:00',2.61),('325','2013-10-10','16:05:00',1.03),('325','2013-10-10','16:10:00',1.29),('325','2013-10-10','16:15:00',1.01),('325','2013-10-10','16:20:00',1.05),('325','2013-10-10','16:25:00',1.56),('325','2013-10-10','16:45:00',1.16),('325','2013-10-10','16:50:00',1.22),('325','2013-10-10','16:55:00',1.4),('325','2013-10-10','17:00:00',1.11),('325','2013-10-10','17:15:00',1.03),('325','2013-10-10','17:20:00',1.02),('325','2013-10-09','09:10:00',1.03),('325','2013-10-09','09:20:00',1.03),('325','2013-10-09','09:25:00',1.18),('325','2013-10-09','09:30:00',1.24),('325','2013-10-09','09:35:00',1.3),('325','2013-10-09','09:40:00',1.39),('325','2013-10-09','09:45:00',1.43),('325','2013-10-09','09:50:00',1.48),('325','2013-10-09','09:55:00',1.58),('325','2013-10-09','10:00:00',1.74),('325','2013-10-09','10:05:00',1.95),('325','2013-10-09','10:10:00',1.69),('325','2013-10-09','10:15:00',1.15),('325','2013-10-09','10:30:00',1.13),('325','2013-10-09','10:35:00',1.07),('325','2013-10-09','10:40:00',1.23),('325','2013-10-09','10:45:00',2.43),('325','2013-10-09','10:50:00',3.85),('325','2013-10-09','10:55:00',3.01),('325','2013-10-09','11:00:00',3.34),('325','2013-10-09','11:05:00',4.19),('325','2013-10-09','11:10:00',4.29),('325','2013-10-09','11:15:00',3.47),('325','2013-10-09','11:20:00',3.23),('325','2013-10-09','11:25:00',3.78),('325','2013-10-09','11:30:00',4.36),('325','2013-10-09','11:35:00',4.48),('325','2013-10-09','11:40:00',4.41),('325','2013-10-09','11:45:00',3.92),('325','2013-10-09','11:50:00',3.75),('325','2013-10-09','11:55:00',3.42),('325','2013-10-09','12:00:00',1.26),('325','2013-10-09','12:05:00',2.41),('325','2013-10-09','12:10:00',2.37),('325','2013-10-09','12:15:00',4.69),('325','2013-10-09','12:20:00',3.98),('325','2013-10-09','12:25:00',2.48),('325','2013-10-09','12:30:00',1.94),('325','2013-10-09','12:35:00',3.05),('325','2013-10-09','12:40:00',1.31),('325','2013-10-09','12:55:00',1.18),('325','2013-10-09','13:10:00',1.07),('325','2013-10-09','13:15:00',1.4),('325','2013-10-09','13:20:00',2.84),('325','2013-10-09','13:25:00',4.73),('325','2013-10-09','13:30:00',4.11),('325','2013-10-09','13:35:00',3.94),('325','2013-10-09','13:40:00',2.52),('325','2013-10-09','13:45:00',2.53),('325','2013-10-09','13:50:00',2.68),('325','2013-10-09','13:55:00',3.99),('325','2013-10-09','14:00:00',2.77),('325','2013-10-09','14:05:00',2.7),('325','2013-10-09','14:50:00',1.5),('325','2013-10-09','14:55:00',2.35),('325','2013-10-09','15:00:00',1.61),('325','2013-10-09','15:05:00',3.72),('325','2013-10-09','15:10:00',3.36),('325','2013-10-09','15:15:00',3.27),('325','2013-10-09','15:20:00',2.99),('325','2013-10-09','15:25:00',3.27),('325','2013-10-09','15:30:00',2.36),('325','2013-10-09','15:35:00',2.16),('325','2013-10-09','15:40:00',2.06),('325','2013-10-09','15:45:00',1.54),('325','2013-10-09','16:10:00',1.1),('325','2013-10-09','16:15:00',1.3),('325','2013-10-09','16:20:00',1.82),('325','2013-10-09','16:25:00',1.87),('325','2013-10-09','16:30:00',2.47),('325','2013-10-09','16:35:00',1.58),('325','2013-10-09','16:40:00',1.28),('325','2013-10-09','17:30:00',1.06),('325','2013-10-09','17:35:00',1.15),('325','2013-10-08','10:05:00',1.01),('325','2013-10-08','10:55:00',1.17),('325','2013-10-08','11:00:00',1.77),('325','2013-10-08','11:05:00',1.14),('325','2013-10-08','11:10:00',1.45),('325','2013-10-08','11:15:00',2.75),('325','2013-10-08','11:20:00',4.04),('325','2013-10-08','11:25:00',2.56),('325','2013-10-08','11:30:00',2.5),('325','2013-10-08','11:35:00',2.17),('325','2013-10-08','11:40:00',1.56),('325','2013-10-08','11:45:00',1.33),('325','2013-10-08','12:20:00',1.12),('325','2013-10-08','12:25:00',1.56),('325','2013-10-08','12:30:00',2.15),('325','2013-10-08','12:35:00',2.23),('325','2013-10-08','12:40:00',4.8),('325','2013-10-08','12:45:00',4.14),('325','2013-10-08','12:50:00',3.57),('325','2013-10-08','12:55:00',4.32),('325','2013-10-08','13:00:00',4.26),('325','2013-10-08','13:05:00',2.18),('325','2013-10-08','13:10:00',1.59),('325','2013-10-08','13:15:00',3.23),('325','2013-10-08','13:20:00',1.53),('325','2013-10-08','13:25:00',2.8),('325','2013-10-08','13:30:00',2.61),('325','2013-10-08','13:35:00',1.59),('325','2013-10-08','13:40:00',1.07),('325','2013-10-08','14:05:00',1.31),('325','2013-10-08','14:10:00',1.79),('325','2013-10-08','14:15:00',2.48),('325','2013-10-08','14:20:00',2.79),('325','2013-10-08','14:25:00',3.03),('325','2013-10-08','14:30:00',2.59),('325','2013-10-08','14:35:00',1.36),('325','2013-10-08','14:40:00',1.71),('325','2013-10-08','14:45:00',3.27),('325','2013-10-08','14:50:00',3.62),('325','2013-10-08','14:55:00',3.44),('325','2013-10-08','15:00:00',3.34),('325','2013-10-08','15:05:00',3.27),('325','2013-10-08','15:10:00',3.29),('325','2013-10-08','15:15:00',3.04),('325','2013-10-08','15:20:00',3.19),('325','2013-10-08','15:25:00',3.49),('325','2013-10-08','15:30:00',3.63),('325','2013-10-08','15:35:00',3.18),('325','2013-10-08','15:40:00',2),('325','2013-10-08','15:45:00',1.37),('325','2013-10-08','15:50:00',2.23),('325','2013-10-08','15:55:00',1.36),('325','2013-10-08','16:00:00',1.44),('325','2013-10-08','16:30:00',1.07),('325','2014-04-14','08:40:00',1.02),('325','2014-04-14','08:45:00',1.09),('325','2014-04-14','08:50:00',1.16),('325','2014-04-14','08:55:00',1.22),('325','2014-04-14','09:00:00',1.29),('325','2014-04-14','09:05:00',1.54),('325','2014-04-14','09:10:00',2.13),('325','2014-04-14','09:15:00',2.24),('325','2014-04-14','09:20:00',2.22),('325','2014-04-14','09:25:00',2.08),('325','2014-04-14','09:30:00',2.18),('325','2014-04-14','09:35:00',2.49),('325','2014-04-14','09:40:00',2.63),('325','2014-04-14','09:45:00',2.74),('325','2014-04-14','09:50:00',2.89),('325','2014-04-14','09:55:00',2.96),('325','2014-04-14','10:00:00',3.04),('325','2014-04-14','10:05:00',3.15),('325','2014-04-14','10:10:00',3.23),('325','2014-04-14','10:15:00',3.35),('325','2014-04-14','10:20:00',3.44),('325','2014-04-14','10:25:00',3.5),('325','2014-04-14','10:30:00',3.56),('325','2014-04-14','10:35:00',3.66),('325','2014-04-14','10:40:00',3.72),('325','2014-04-14','10:45:00',3.75),('325','2014-04-14','10:50:00',3.82),('325','2014-04-14','10:55:00',3.89),('325','2014-04-14','11:00:00',3.93),('325','2014-04-14','11:05:00',3.98),('325','2014-04-14','11:10:00',4.03),('325','2014-04-14','11:15:00',4.07),('325','2014-04-14','11:20:00',4.14),('325','2014-04-14','11:25:00',4.17),('325','2014-04-14','11:30:00',4.22),('325','2014-04-14','11:35:00',4.25),('325','2014-04-14','11:40:00',4.27),('325','2014-04-14','11:45:00',4.3),('325','2014-04-14','11:50:00',4.33),('325','2014-04-14','11:55:00',4.41),('325','2014-04-14','12:00:00',4.43),('325','2014-04-14','12:05:00',4.47),('325','2014-04-14','12:10:00',4.49),('325','2014-04-14','12:15:00',4.51),('325','2014-04-14','12:20:00',4.53),('325','2014-04-14','12:25:00',4.54),('325','2014-04-14','12:30:00',4.53),('325','2014-04-14','12:35:00',4.57),('325','2014-04-14','12:40:00',4.59),('325','2014-04-14','12:45:00',4.59),('325','2014-04-14','12:50:00',4.61),('325','2014-04-14','12:55:00',4.64),('325','2014-04-14','13:00:00',4.64),('325','2014-04-14','13:05:00',4.61),('325','2014-04-14','13:10:00',4.59),('325','2014-04-14','13:15:00',4.65),('325','2014-04-14','13:20:00',4.62),('325','2014-04-14','13:25:00',4.63),('325','2014-04-14','13:30:00',4.65),('325','2014-04-14','13:35:00',4.66),('325','2014-04-14','13:40:00',4.67),('325','2014-04-14','13:45:00',4.65),('325','2014-04-14','13:50:00',4.62),('325','2014-04-14','13:55:00',4.61),('325','2014-04-14','14:00:00',4.59),('325','2014-04-14','14:05:00',4.6),('325','2014-04-14','14:10:00',4.58),('325','2014-04-14','14:15:00',4.58),('325','2014-04-14','14:20:00',4.57),('325','2014-04-14','14:25:00',4.55),('325','2014-04-14','14:30:00',4.52),('325','2014-04-14','14:35:00',4.47),('325','2014-04-14','14:40:00',4.44),('325','2014-04-14','14:45:00',4.39),('325','2014-04-14','14:50:00',4.37),('325','2014-04-14','14:55:00',4.34),('325','2014-04-14','15:00:00',4.3),('325','2014-04-14','15:05:00',4.26),('325','2014-04-14','15:10:00',4.2),('325','2014-04-14','15:15:00',4.15),('325','2014-04-14','15:20:00',4.1),('325','2014-04-14','15:25:00',4.06),('325','2014-04-14','15:30:00',4.01),('325','2014-04-14','15:35:00',3.94),('325','2014-04-14','15:40:00',3.89),('325','2014-04-14','15:45:00',3.82),('325','2014-04-14','15:50:00',3.76),('325','2014-04-14','15:55:00',3.69),('325','2014-04-14','16:00:00',3.6),('325','2014-04-14','16:05:00',3.52),('325','2014-04-14','16:10:00',3.44),('325','2014-04-14','16:15:00',3.37),('325','2014-04-14','16:20:00',3.31),('325','2014-04-14','16:25:00',3.23),('325','2014-04-14','16:30:00',3.15),('325','2014-04-14','16:35:00',3.06),('325','2014-04-14','16:40:00',2.96),('325','2014-04-14','16:45:00',2.85),('325','2014-04-14','16:50:00',2.7),('325','2014-04-14','16:55:00',2.66),('325','2014-04-14','17:00:00',2.56),('325','2014-04-14','17:05:00',2.47),('325','2014-04-14','17:10:00',2.37),('325','2014-04-14','17:15:00',2.27),('325','2014-04-14','17:20:00',2.18),('325','2014-04-14','17:25:00',2.08),('325','2014-04-14','17:30:00',1.92),('325','2014-04-14','17:35:00',1.82),('325','2014-04-14','17:40:00',1.71),('325','2014-04-14','17:45:00',1.62),('325','2014-04-14','17:50:00',1.51),('325','2014-04-14','17:55:00',1.41),('325','2014-04-14','18:00:00',1.3),('325','2014-04-14','18:05:00',1.19),('325','2014-04-14','18:10:00',1.08),('325','2013-10-07','09:00:00',1.18),('325','2013-10-07','09:05:00',1.1),('325','2013-10-07','09:10:00',1.06),('325','2013-10-07','09:15:00',1.09),('325','2013-10-07','09:20:00',1.1),('325','2013-10-07','09:25:00',1.16),('325','2013-10-07','09:30:00',1.2),('325','2013-10-07','09:35:00',1.24),('325','2013-10-07','09:40:00',1.28),('325','2013-10-07','09:45:00',1.32),('325','2013-10-07','09:50:00',1.37),('325','2013-10-07','09:55:00',1.41),('325','2013-10-07','10:00:00',1.44),('325','2013-10-07','10:05:00',1.5),('325','2013-10-07','10:10:00',1.54),('325','2013-10-07','10:15:00',1.74),('325','2013-10-07','10:20:00',2.63),('325','2013-10-07','10:25:00',2.76),('325','2013-10-07','10:30:00',2.89),('325','2013-10-07','10:35:00',3.21),('325','2013-10-07','10:40:00',3.05),('325','2013-10-07','10:45:00',3.1),('325','2013-10-07','10:50:00',3.18),('325','2013-10-07','10:55:00',2.68),('325','2013-10-07','11:00:00',2.74),('325','2013-10-07','11:05:00',3.5),('325','2013-10-07','11:10:00',3.25),('325','2013-10-07','11:15:00',3.35),('325','2013-10-07','11:20:00',3.36),('325','2013-10-07','11:25:00',3.51),('325','2013-10-07','11:30:00',3.53),('325','2013-10-07','11:35:00',3.56),('325','2013-10-07','11:40:00',3.61),('325','2013-10-07','11:45:00',3.68),('325','2013-10-07','11:50:00',3.71),('325','2013-10-07','11:55:00',3.74),('325','2013-10-07','12:00:00',3.74),('325','2013-10-07','12:05:00',3.89),('325','2013-10-06','09:05:00',1.01),('325','2013-10-06','09:30:00',1.06),('325','2013-10-06','09:35:00',1.23),('325','2013-10-06','09:40:00',1.1),('325','2013-10-06','09:45:00',1.05),('325','2013-10-06','09:50:00',1.61),('325','2013-10-06','09:55:00',1.83),('325','2013-10-06','10:00:00',2.11),('325','2013-10-06','10:05:00',2.15),('325','2013-10-06','10:10:00',2.11),('325','2013-10-06','10:15:00',1.97),('325','2013-10-06','10:20:00',2.03),('325','2013-10-06','10:25:00',2.22),('325','2013-10-06','10:30:00',2.24),('325','2013-10-06','10:35:00',2.23),('325','2013-10-06','10:40:00',2.02),('325','2013-10-06','10:45:00',1.73),('325','2013-10-06','10:50:00',2.29),('325','2013-10-06','10:55:00',2.37),('325','2013-10-06','11:00:00',2.69),('325','2013-10-06','11:05:00',2.94),('325','2013-10-06','11:10:00',3.06),('325','2013-10-06','11:15:00',3.04),('325','2013-10-06','11:20:00',3.14),('325','2013-10-06','11:25:00',3.14),('325','2013-10-06','11:30:00',3.06),('325','2013-10-06','11:35:00',3.01),('325','2013-10-06','11:40:00',2.14),('325','2013-10-06','11:45:00',2.3),('325','2013-10-06','11:50:00',2.42),('325','2013-10-06','11:55:00',2.92),('325','2013-10-06','12:00:00',2.85),('325','2013-10-06','12:05:00',2.88),('325','2013-10-06','12:10:00',3.66),('325','2013-10-06','12:15:00',3.53),('325','2013-10-06','12:20:00',3.4),('325','2013-10-06','12:25:00',2.58),('325','2013-10-06','12:30:00',2.8),('325','2013-10-06','12:35:00',3.01),('325','2013-10-06','12:40:00',2.87),('325','2013-10-06','12:45:00',2.95),('325','2013-10-06','12:50:00',3.16),('325','2013-10-06','12:55:00',3.55),('325','2013-10-06','13:00:00',3.48),('325','2013-10-06','13:05:00',3.36),('325','2013-10-06','13:10:00',3.4),('325','2013-10-06','13:15:00',3.33),('325','2013-10-06','13:20:00',1.53),('325','2013-10-06','13:25:00',1.08),('325','2013-10-06','13:45:00',2.11),('325','2013-10-06','13:50:00',4.16),('325','2013-10-06','13:55:00',3.89),('325','2013-10-06','14:00:00',2.92),('325','2013-10-06','14:05:00',2.02),('325','2013-10-06','14:10:00',1.66),('325','2013-10-06','14:15:00',1.52),('325','2013-10-06','14:20:00',1.71),('325','2013-10-06','14:25:00',1.74),('325','2013-10-06','14:30:00',2.55),('325','2013-10-06','14:35:00',2.42),('325','2013-10-06','14:40:00',2.44),('325','2013-10-06','14:45:00',1.78),('325','2013-10-06','14:50:00',2.15),('325','2013-10-06','14:55:00',2.8),('325','2013-10-06','15:00:00',2.03),('325','2013-10-06','15:05:00',1.5),('325','2013-10-06','15:10:00',1.22),('325','2013-10-06','15:15:00',1.21),('325','2013-10-06','15:55:00',1.02),('325','2013-10-06','16:00:00',1.1),('325','2013-10-06','17:15:00',1.04),('325','2013-10-05','16:00:00',1.06),('325','2013-10-05','16:05:00',1.32),('325','2013-10-05','16:10:00',1.25),('325','2013-10-05','16:15:00',1.14),('325','2013-10-05','16:20:00',1.19),('325','2013-10-05','16:25:00',1.13),('325','2013-10-05','16:40:00',1.01),('325','2013-10-05','16:50:00',1.02),('325','2013-10-04','09:25:00',1.03),('325','2013-10-04','09:30:00',1.09),('325','2013-10-04','09:35:00',1.15),('325','2013-10-04','09:40:00',1.14),('325','2013-10-04','09:45:00',1.19),('325','2013-10-04','09:50:00',1.38),('325','2013-10-04','09:55:00',2.19),('325','2013-10-04','10:00:00',1.87),('325','2013-10-04','10:05:00',1.42),('325','2013-10-04','10:10:00',1.49),('325','2013-10-04','10:15:00',1.68),('325','2013-10-04','10:20:00',1.56),('325','2013-10-04','10:25:00',1.7),('325','2013-10-04','10:30:00',2.06),('325','2013-10-04','10:35:00',1.91),('325','2013-10-04','10:40:00',2.63),('325','2013-10-04','10:45:00',2.72),('325','2013-10-04','10:50:00',2.17),('325','2013-10-04','10:55:00',2.53),('325','2013-10-04','11:00:00',1.98),('325','2013-10-04','11:05:00',1.73),('325','2013-10-04','11:10:00',1.96),('325','2013-10-04','11:15:00',3.23),('325','2013-10-04','11:20:00',2.95),('325','2013-10-04','11:25:00',2.94),('325','2013-10-04','11:30:00',4),('325','2013-10-04','11:35:00',3.58),('325','2013-10-04','11:40:00',3.88),('325','2013-10-04','11:45:00',3.89),('325','2013-10-04','11:50:00',3.85),('325','2013-10-04','11:55:00',3.83),('325','2013-10-04','12:00:00',3.86),('325','2013-10-04','12:05:00',3.89),('325','2013-10-04','12:10:00',3.89),('325','2013-10-04','12:15:00',3.77),('325','2013-10-04','12:20:00',3.82),('325','2013-10-04','12:25:00',3.97),('325','2013-10-04','12:30:00',4.1),('325','2013-10-04','12:35:00',3.82),('325','2013-10-04','12:40:00',3.86),('325','2013-10-04','12:45:00',3.89),('325','2013-10-04','12:50:00',3.81),('325','2013-10-04','12:55:00',3.79),('325','2013-10-04','13:00:00',3.84),('325','2013-10-04','13:05:00',3.9),('325','2013-10-04','13:10:00',3.89),('325','2013-10-04','13:15:00',4.04),('325','2013-10-04','13:20:00',3.93),('325','2013-10-04','13:25:00',3.69),('325','2013-10-04','13:30:00',3.97),('325','2013-10-04','13:35:00',3.99),('325','2013-10-04','13:40:00',3.77),('325','2013-10-04','13:45:00',3.75),('325','2013-10-04','13:50:00',3.73),('325','2013-10-04','13:55:00',3.69),('325','2013-10-04','14:00:00',3.66),('325','2013-10-04','14:05:00',3.65),('325','2013-10-04','14:10:00',3.3),('325','2013-10-04','14:15:00',2.78),('325','2013-10-04','14:20:00',3.4),('325','2013-10-04','14:25:00',3.49),('325','2013-10-04','14:30:00',3.02),('325','2013-10-04','14:35:00',2.09),('325','2013-10-04','14:40:00',1.77),('325','2013-10-04','14:45:00',2.17),('325','2013-10-04','14:50:00',2.79),('325','2013-10-04','14:55:00',2.71),('325','2013-10-04','15:00:00',2.34),('325','2013-10-04','15:05:00',2.65),('325','2013-10-04','15:10:00',2.17),('325','2013-10-04','15:15:00',1.76),('325','2013-10-04','15:20:00',1.53),('325','2013-10-04','15:25:00',2.87),('325','2013-10-04','15:30:00',2.27),('325','2013-10-04','15:35:00',1.28),('325','2013-10-04','16:00:00',1.11),('325','2013-10-04','16:05:00',1.2),('325','2013-10-04','16:10:00',1.08),('325','2013-10-03','09:05:00',1.03),('325','2013-10-03','09:10:00',1.08),('325','2013-10-03','09:15:00',1.14),('325','2013-10-03','09:20:00',1.19),('325','2013-10-03','09:25:00',1.23),('325','2013-10-03','09:30:00',1.28),('325','2013-10-03','09:35:00',1.34),('325','2013-10-03','09:40:00',1.38),('325','2013-10-03','09:45:00',1.43),('325','2013-10-03','09:50:00',1.48),('325','2013-10-03','09:55:00',1.52),('325','2013-10-03','10:00:00',1.57),('325','2013-10-03','10:05:00',1.63),('325','2013-10-03','10:10:00',1.68),('325','2013-10-03','10:15:00',2.75),('325','2013-10-03','10:20:00',2.91),('325','2013-10-03','10:25:00',3.05),('325','2013-10-03','10:30:00',3.18),('325','2013-10-03','10:35:00',3.24),('325','2013-10-03','10:40:00',3.3),('325','2013-10-03','10:45:00',3.4),('325','2013-10-03','10:50:00',3.46),('325','2013-10-03','10:55:00',3.54),('325','2013-10-03','11:00:00',3.58),('325','2013-10-03','11:05:00',3.63),('325','2013-10-03','11:10:00',3.69),('325','2013-10-03','11:15:00',3.73),('325','2013-10-03','11:20:00',3.79),('325','2013-10-03','11:25:00',3.82),('325','2013-10-03','11:30:00',3.85),('325','2013-10-03','11:35:00',3.9),('325','2013-10-03','11:40:00',3.94),('325','2013-10-03','11:45:00',4.02),('325','2013-10-03','11:50:00',4.06),('325','2013-10-03','11:55:00',4.09),('325','2013-10-03','12:00:00',4.09),('325','2013-10-03','12:05:00',4.12),('325','2013-10-03','12:10:00',4.12),('325','2013-10-03','12:15:00',4.12),('325','2013-10-03','12:20:00',4.12),('325','2013-10-03','12:25:00',4.14),('325','2013-10-03','12:30:00',4.14),('325','2013-10-03','12:35:00',4.16),('325','2013-10-03','12:40:00',4.16),('325','2013-10-03','12:45:00',4.16),('325','2013-10-03','12:50:00',4.18),('325','2013-10-03','12:55:00',4.17),('325','2013-10-03','13:00:00',4.14),('325','2013-10-03','13:05:00',4.07),('325','2013-10-03','13:10:00',4.13),('325','2013-10-03','13:15:00',4.1),('325','2013-10-03','13:20:00',4.09),('325','2013-10-03','13:25:00',4.07),('325','2013-10-03','13:30:00',4.09),('325','2013-10-03','13:35:00',4.08),('325','2013-10-03','13:40:00',4.05),('325','2013-10-03','13:45:00',4.02),('325','2013-10-03','13:50:00',4),('325','2013-10-03','13:55:00',3.99),('325','2013-10-03','14:00:00',3.98),('325','2013-10-03','14:05:00',3.97),('325','2013-10-03','14:10:00',3.94),('325','2013-10-03','14:15:00',3.9),('325','2013-10-03','14:20:00',3.86),('325','2013-10-03','14:25:00',3.81),('325','2013-10-03','14:30:00',3.77),('325','2013-10-03','14:35:00',3.72),('325','2013-10-03','14:40:00',3.68),('325','2013-10-03','14:45:00',3.63),('325','2013-10-03','14:50:00',3.59),('325','2013-10-03','14:55:00',3.54),('325','2013-10-03','15:00:00',3.48),('325','2013-10-03','15:05:00',3.41),('325','2013-10-03','15:10:00',3.35),('325','2013-10-03','15:15:00',3.3),('325','2013-10-03','15:20:00',3.23),('325','2013-10-03','15:25:00',3.17),('325','2013-10-03','15:30:00',3.09),('325','2013-10-03','15:35:00',3.02),('325','2013-10-03','15:40:00',2.94),('325','2013-10-03','15:45:00',2.87),('325','2013-10-03','15:50:00',2.79),('325','2013-10-03','15:55:00',2.71),('325','2013-10-03','16:00:00',2.63),('325','2013-10-03','16:05:00',2.54),('325','2013-10-03','16:10:00',2.46),('325','2013-10-03','16:15:00',2.36),('325','2013-10-03','16:20:00',2.23),('325','2013-10-03','16:25:00',2.16),('325','2013-10-03','16:30:00',2.07),('325','2013-10-03','16:35:00',1.99),('325','2013-10-03','16:40:00',1.88),('325','2013-10-03','16:45:00',1.79),('325','2013-10-03','16:50:00',1.69),('325','2013-10-03','16:55:00',1.59),('325','2013-10-03','17:00:00',1.47),('325','2013-10-03','17:05:00',1.37),('325','2013-10-03','17:10:00',1.27),('325','2013-10-03','17:15:00',1.17),('325','2013-10-03','17:20:00',1.07),('325','2013-10-02','09:10:00',1.04),('325','2013-10-02','09:15:00',1.09),('325','2013-10-02','09:20:00',1.14),('325','2013-10-02','09:25:00',1.19),('325','2013-10-02','09:30:00',1.24),('325','2013-10-02','09:35:00',1.28),('325','2013-10-02','09:40:00',1.33),('325','2013-10-02','09:45:00',1.36),('325','2013-10-02','09:50:00',1.41),('325','2013-10-02','09:55:00',1.45),('325','2013-10-02','10:00:00',1.2),('325','2013-10-02','10:05:00',1.54),('325','2013-10-02','10:10:00',1.58),('325','2013-10-02','10:15:00',2.19),('325','2013-10-02','10:20:00',2.72),('325','2013-10-02','10:25:00',2.87),('325','2013-10-02','10:30:00',2.99),('325','2013-10-02','10:35:00',3.05),('325','2013-10-02','10:40:00',3.13),('325','2013-10-02','10:45:00',3.23),('325','2013-10-02','10:50:00',3.3),('325','2013-10-02','10:55:00',3.4),('325','2013-10-02','11:00:00',3.45),('325','2013-10-02','11:05:00',3.5),('325','2013-10-02','11:10:00',3.55),('325','2013-10-02','11:15:00',3.58),('325','2013-10-02','11:20:00',3.62),('325','2013-10-02','11:25:00',3.66),('325','2013-10-02','11:30:00',3.69),('325','2013-10-02','11:35:00',3.72),('325','2013-10-02','11:40:00',3.75),('325','2013-10-02','11:45:00',3.83),('325','2013-10-02','11:50:00',3.87),('325','2013-10-02','11:55:00',3.89),('325','2013-10-02','12:00:00',3.9),('325','2013-10-02','12:05:00',3.92),('325','2013-10-02','12:10:00',3.95),('325','2013-10-02','12:15:00',3.97),('325','2013-10-02','12:20:00',3.98),('325','2013-10-02','12:25:00',3.97),('325','2013-10-02','12:30:00',3.97),('325','2013-10-02','12:35:00',3.98),('325','2013-10-02','12:40:00',4.01),('325','2013-10-02','12:45:00',4),('325','2013-10-02','12:50:00',4.01),('325','2013-10-02','12:55:00',4.02),('325','2013-10-02','13:00:00',4.01),('325','2013-10-02','13:05:00',4.02),('325','2013-10-02','13:10:00',4.02),('325','2013-10-02','13:15:00',4.01),('325','2013-10-02','13:20:00',4),('325','2013-10-02','13:25:00',3.99),('325','2013-10-02','13:30:00',3.99),('325','2013-10-02','13:35:00',3.96),('325','2013-10-02','13:40:00',3.93),('325','2013-10-02','13:45:00',3.92),('325','2013-10-02','13:50:00',3.89),('325','2013-10-02','13:55:00',3.86),('325','2013-10-02','14:00:00',3.84),('325','2013-10-02','14:05:00',3.84),('325','2013-10-02','14:10:00',3.81),('325','2013-10-02','14:15:00',3.76),('325','2013-10-02','14:20:00',3.73),('325','2013-10-02','14:25:00',3.7),('325','2013-10-02','14:30:00',3.67),('325','2013-10-02','14:35:00',3.63),('325','2013-10-02','14:40:00',3.58),('325','2013-10-02','14:45:00',3.53),('325','2013-10-02','14:50:00',3.49),('325','2013-10-02','14:55:00',3.45),('325','2013-10-02','15:00:00',3.4),('325','2013-10-02','15:05:00',3.34),('325','2013-10-02','15:10:00',3.28),('325','2013-10-02','15:15:00',3.21),('325','2013-10-02','15:20:00',3.15),('325','2013-10-02','15:25:00',3.08),('325','2013-10-02','15:30:00',3.01),('325','2013-10-02','15:35:00',2.93),('325','2013-10-02','15:40:00',2.88),('325','2013-10-02','15:45:00',2.81),('325','2013-10-02','15:50:00',2.74),('325','2013-10-02','15:55:00',2.67),('325','2013-10-02','16:00:00',2.57),('325','2013-10-02','16:05:00',2.49),('325','2013-10-02','16:10:00',2.4),('325','2013-10-02','16:15:00',2.32),('325','2013-10-02','16:20:00',2.19),('325','2013-10-02','16:25:00',2.1),('325','2013-10-02','16:30:00',2.02),('325','2013-10-02','16:35:00',1.93),('325','2013-10-02','16:40:00',1.84),('325','2013-10-02','16:45:00',1.75),('325','2013-10-02','16:50:00',1.65),('325','2013-10-02','16:55:00',1.56),('325','2013-10-02','17:00:00',1.45),('325','2013-10-02','17:05:00',1.35),('325','2013-10-02','17:10:00',1.25),('325','2013-10-02','17:15:00',1.14),('325','2013-10-02','17:20:00',1.05),('325','2013-10-01','09:05:00',1),('325','2013-10-01','09:10:00',1.05),('325','2013-10-01','09:15:00',1.09),('325','2013-10-01','09:20:00',1.14),('325','2013-10-01','09:25:00',1.18),('325','2013-10-01','09:30:00',1.21),('325','2013-10-01','09:35:00',1.27),('325','2013-10-01','09:40:00',1.31),('325','2013-10-01','09:45:00',1.34),('325','2013-10-01','09:50:00',1.4),('325','2013-10-01','09:55:00',1.42),('325','2013-10-01','10:00:00',1.47),('325','2013-10-01','10:05:00',1.54),('325','2013-10-01','10:10:00',2.51),('325','2013-10-01','10:15:00',2.6),('325','2013-10-01','10:20:00',2.74),('325','2013-10-01','10:25:00',2.87),('325','2013-10-01','10:30:00',2.98),('325','2013-10-01','10:35:00',3.01),('325','2013-10-01','10:40:00',3.06),('325','2013-10-01','10:45:00',3.17),('325','2013-10-01','10:50:00',3.28),('325','2013-10-01','10:55:00',3.39),('325','2013-10-01','11:00:00',3.43),('325','2013-10-01','11:05:00',3.36),('325','2013-10-01','11:10:00',3.86),('325','2013-10-01','11:15:00',3.67),('325','2013-10-01','11:30:00',2.26),('325','2013-10-01','11:35:00',3.88),('325','2013-10-01','11:40:00',3.87),('325','2013-10-01','11:45:00',3.94),('325','2013-10-01','11:50:00',2.1),('325','2013-10-01','11:55:00',1.69),('325','2013-10-01','12:00:00',4.07),('325','2013-10-01','12:05:00',3.99),('325','2013-10-01','12:10:00',3.97),('325','2013-10-01','12:15:00',4.11),('325','2013-10-01','12:20:00',4.14),('325','2013-10-01','12:25:00',3.26),('325','2013-10-01','12:30:00',3.46),('325','2013-10-01','12:40:00',1.06),('325','2013-10-01','12:45:00',3.98),('325','2013-10-01','12:55:00',2.89),('325','2013-10-01','13:00:00',4.34),('325','2013-10-01','13:05:00',3.21),('325','2013-10-01','13:10:00',1.05),('325','2013-10-01','13:15:00',2.97),('325','2013-10-01','13:20:00',4.39),('325','2013-10-01','13:25:00',2.93),('325','2013-10-01','13:30:00',4.33),('325','2013-10-01','13:35:00',4.35),('325','2013-10-01','13:40:00',4.2),('325','2013-10-01','13:45:00',4.15),('325','2013-10-01','13:50:00',4.03),('325','2013-10-01','13:55:00',3.81),('325','2013-10-01','14:00:00',3.79),('325','2013-10-01','14:05:00',3.78),('325','2013-10-01','14:10:00',3.69),('325','2013-10-01','14:15:00',3.64),('325','2013-10-01','14:20:00',3.67),('325','2013-10-01','14:25:00',3.63),('325','2013-10-01','14:30:00',3.59),('325','2013-10-01','14:35:00',2.74),('325','2013-10-01','14:40:00',3.27),('325','2013-10-01','14:45:00',3.56),('325','2013-10-01','14:50:00',3.52),('325','2013-10-01','14:55:00',3.56),('325','2013-10-01','15:00:00',3.43),('325','2013-10-01','15:05:00',3.34),('325','2013-10-01','15:10:00',3.26),('325','2013-10-01','15:15:00',3.22),('325','2013-10-01','15:20:00',3.16),('325','2013-10-01','15:25:00',3.11),('325','2013-10-01','15:30:00',3.03),('325','2013-10-01','15:35:00',2.97),('325','2013-10-01','15:40:00',2.89),('325','2013-10-01','15:45:00',2.82),('325','2013-10-01','15:50:00',2.73),('325','2013-10-01','15:55:00',2.66),('325','2013-10-01','16:00:00',2.58),('325','2013-10-01','16:05:00',2.51),('325','2013-10-01','16:10:00',2.42),('325','2013-10-01','16:15:00',2.33),('325','2013-10-01','16:20:00',2.2),('325','2013-10-01','16:25:00',2.13),('325','2013-10-01','16:30:00',2.05),('325','2013-10-01','16:35:00',1.95),('325','2013-10-01','16:40:00',1.85),('325','2013-10-01','16:45:00',1.77),('325','2013-10-01','16:50:00',1.68),('325','2013-10-01','16:55:00',1.59),('325','2013-10-01','17:00:00',1.47),('325','2013-10-01','17:05:00',1.37),('325','2013-10-01','17:10:00',1.29),('325','2013-10-01','17:15:00',1.17),('325','2013-10-01','17:20:00',1.1),('325','2013-10-01','17:25:00',1.01),('325','2013-09-30','09:50:00',1.18),('325','2013-09-30','09:55:00',1.03),('325','2013-09-30','10:10:00',1.09),('325','2013-09-30','10:15:00',1.1),('325','2013-09-30','10:20:00',1.11),('325','2013-09-30','10:25:00',1.21),('325','2013-09-30','10:30:00',1.31),('325','2013-09-30','10:35:00',1.47),('325','2013-09-30','10:40:00',2.25),('325','2013-09-30','10:45:00',3.39),('325','2013-09-30','10:50:00',3.47),('325','2013-09-30','10:55:00',3.16),('325','2013-09-30','11:00:00',2.53),('325','2013-09-30','11:05:00',2.37),('325','2013-09-30','11:10:00',3.63),('325','2013-09-30','11:15:00',2.96),('325','2013-09-30','11:20:00',3),('325','2013-09-30','11:25:00',2.22),('325','2013-09-30','11:30:00',2.25),('325','2013-09-30','11:35:00',2.39),('325','2013-09-30','11:40:00',4.2),('325','2013-09-30','11:45:00',1.89),('325','2013-09-30','11:50:00',1.47),('325','2013-09-30','11:55:00',1.39),('325','2013-09-30','12:00:00',1.48),('325','2013-09-30','12:10:00',2.81),('325','2013-09-30','12:15:00',4.28),('325','2013-09-30','12:20:00',4.3),('325','2013-09-30','12:25:00',4.21),('325','2013-09-30','12:30:00',4.14),('325','2013-09-30','12:35:00',4.16),('325','2013-09-30','12:40:00',3.96),('325','2013-09-30','12:45:00',3.63),('325','2013-09-30','12:50:00',4.31),('325','2013-09-30','12:55:00',4.23),('325','2013-09-30','13:00:00',4.24),('325','2013-09-30','13:05:00',4.35),('325','2013-09-30','13:10:00',4.11),('325','2013-09-30','13:15:00',4.28),('325','2013-09-30','13:20:00',4.66),('325','2013-09-30','13:25:00',4.65),('325','2013-09-30','13:30:00',4.44),('325','2013-09-30','13:35:00',3.9),('325','2013-09-30','13:40:00',3.36),('325','2013-09-30','13:45:00',1.55),('325','2013-09-30','13:50:00',4.05),('325','2013-09-30','13:55:00',3.07),('325','2013-09-30','14:00:00',1.84),('325','2013-09-30','14:05:00',1.37),('325','2013-09-30','14:10:00',1.32),('325','2013-09-30','14:15:00',1.23),('325','2013-09-30','14:20:00',1.07),('325','2013-09-30','14:25:00',1.3),('325','2013-09-30','14:30:00',3.11),('325','2013-09-30','14:35:00',2.75),('325','2013-09-30','14:40:00',4),('325','2013-09-30','14:45:00',3.8),('325','2013-09-30','14:50:00',3.31),('325','2013-09-30','14:55:00',2.28),('325','2013-09-30','15:00:00',2.22),('325','2013-09-30','15:05:00',3.4),('325','2013-09-30','15:10:00',4.06),('325','2013-09-30','15:15:00',1.66),('325','2013-09-30','15:20:00',2.11),('325','2013-09-30','15:25:00',3.01),('325','2013-09-30','15:30:00',1.56),('325','2013-09-30','15:35:00',3.64),('325','2013-09-30','15:40:00',3.51),('325','2013-09-30','15:45:00',1.85),('325','2013-09-30','16:10:00',1.57),('325','2013-09-30','16:15:00',1.85),('325','2013-09-30','16:20:00',1.57),('325','2013-09-30','16:45:00',1.31),('325','2013-09-30','16:55:00',1.01),('325','2013-09-30','17:00:00',1.05),('325','2013-09-30','17:25:00',1.01),('325','2013-09-29','08:50:00',1.11),('325','2013-09-29','09:15:00',1.07),('325','2013-09-29','09:55:00',1.01),('325','2013-09-29','10:00:00',1.15),('325','2013-09-29','10:05:00',1.43),('325','2013-09-29','10:10:00',1.63),('325','2013-09-29','10:15:00',2.01),('325','2013-09-29','10:20:00',1.61),('325','2013-09-29','10:25:00',1.56),('325','2013-09-29','10:30:00',1.75),('325','2013-09-29','10:35:00',1.87),('325','2013-09-29','10:40:00',1.93),('325','2013-09-29','10:45:00',2.37),('325','2013-09-29','10:50:00',2.86),('325','2013-09-29','10:55:00',2.91),('325','2013-09-29','11:00:00',2.96),('325','2013-09-29','11:05:00',2.85),('325','2013-09-29','11:10:00',2.86),('325','2013-09-29','11:15:00',3.09),('325','2013-09-29','11:20:00',3.07),('325','2013-09-29','11:25:00',2.92),('325','2013-09-29','11:30:00',3.15),('325','2013-09-29','11:35:00',3.09),('325','2013-09-29','11:40:00',3.1),('325','2013-09-29','11:45:00',3.33),('325','2013-09-29','11:50:00',3.46),('325','2013-09-29','11:55:00',3.54),('325','2013-09-29','12:00:00',3.14),('325','2013-09-29','12:05:00',2.82),('325','2013-09-29','12:10:00',3.55),('325','2013-09-29','12:15:00',3.93),('325','2013-09-29','12:20:00',2.13),('325','2013-09-29','12:25:00',1.75),('325','2013-09-29','12:30:00',1.94),('325','2013-09-29','12:35:00',1.84),('325','2013-09-29','12:40:00',1.54),('325','2013-09-29','12:45:00',1.33),('325','2013-09-29','12:50:00',1.32),('325','2013-09-29','12:55:00',1.19),('325','2013-09-29','13:00:00',1.14),('325','2013-09-29','13:05:00',1.04),('325','2013-09-29','13:10:00',1.03),('325','2013-09-29','13:25:00',1.47),('325','2013-09-29','13:30:00',1.71),('325','2013-09-29','13:35:00',2.11),('325','2013-09-29','13:40:00',1.81),('325','2013-09-29','13:45:00',1.64),('325','2013-09-29','13:50:00',1.82),('325','2013-09-29','13:55:00',2.02),('325','2013-09-29','14:00:00',2.03),('325','2013-09-29','14:05:00',2.28),('325','2013-09-29','14:10:00',1.31),('325','2013-09-29','14:15:00',1.75),('325','2013-09-29','14:20:00',2.53),('325','2013-09-29','14:25:00',1.47),('325','2013-09-29','14:30:00',1.53),('325','2013-09-29','14:35:00',1.22),('325','2013-09-29','15:00:00',1.09),('325','2013-09-29','16:00:00',1.18),('325','2013-09-29','16:30:00',1.14),('325','2013-09-29','16:35:00',1.05),('325','2013-09-28','09:05:00',1.02),('325','2013-09-28','09:10:00',1.09),('325','2013-09-28','09:15:00',1.15),('325','2013-09-28','09:20:00',1.19),('325','2013-09-28','09:25:00',1.26),('325','2013-09-28','09:30:00',1.32),('325','2013-09-28','09:35:00',1.37),('325','2013-09-28','09:40:00',1.37),('325','2013-09-28','09:45:00',1.43),('325','2013-09-28','09:50:00',1.58),('325','2013-09-28','09:55:00',1.43),('325','2013-09-28','10:00:00',1.61),('325','2013-09-28','10:05:00',1.41),('325','2013-09-28','10:10:00',1.55),('325','2013-09-28','10:15:00',2.13),('325','2013-09-28','10:20:00',1.44),('325','2013-09-28','10:25:00',1.06),('325','2013-09-28','10:30:00',1.57),('325','2013-09-28','10:35:00',1.91),('325','2013-09-28','10:40:00',2.29),('325','2013-09-28','10:45:00',3.11),('325','2013-09-28','10:50:00',3.57),('325','2013-09-28','10:55:00',1.8),('325','2013-09-28','11:10:00',2.16),('325','2013-09-28','11:15:00',3.93),('325','2013-09-28','11:20:00',3.98),('325','2013-09-28','11:25:00',3.93),('325','2013-09-28','11:30:00',3.85),('325','2013-09-28','11:35:00',2.62),('325','2013-09-28','11:50:00',1.57),('325','2013-09-28','11:55:00',1.58),('325','2013-09-28','12:00:00',3.36),('325','2013-09-28','12:05:00',3.14),('325','2013-09-28','12:10:00',2.75),('325','2013-09-28','12:15:00',1.71),('325','2013-09-28','12:20:00',3.85),('325','2013-09-28','12:25:00',4.18),('325','2013-09-28','12:30:00',3.8),('325','2013-09-28','12:35:00',3.74),('325','2013-09-28','12:40:00',4.11),('325','2013-09-28','12:45:00',2.74),('325','2013-09-28','12:50:00',3.44),('325','2013-09-28','12:55:00',3.96),('325','2013-09-28','13:00:00',3.33),('325','2013-09-28','13:05:00',1.96),('325','2013-09-28','13:10:00',3.68),('325','2013-09-28','13:15:00',4.08),('325','2013-09-28','13:20:00',4.15),('325','2013-09-28','13:25:00',4.28),('325','2013-09-28','13:30:00',1.81),('325','2013-09-28','13:35:00',1.88),('325','2013-09-28','13:40:00',2.94),('325','2013-09-28','13:45:00',3.38),('325','2013-09-28','13:50:00',2.38),('325','2013-09-28','13:55:00',1.82),('325','2013-09-28','14:00:00',2.15),('325','2013-09-28','14:05:00',1.85),('325','2013-09-28','14:10:00',2.46),('325','2013-09-28','14:15:00',4.09),('325','2013-09-28','14:20:00',4.2),('325','2013-09-28','14:25:00',3.95),('325','2013-09-28','14:30:00',3.89),('325','2013-09-28','14:35:00',3.85),('325','2013-09-28','14:40:00',3.77),('325','2013-09-28','14:45:00',3.69),('325','2013-09-28','14:50:00',3.58),('325','2013-09-28','14:55:00',3.58),('325','2013-09-28','15:00:00',3.51),('325','2013-09-28','15:05:00',3.27),('325','2013-09-28','15:10:00',2.69),('325','2013-09-28','15:15:00',3.29),('325','2013-09-28','15:20:00',3.27),('325','2013-09-28','15:25:00',3.07),('325','2013-09-28','15:30:00',2.97),('325','2013-09-28','15:35:00',2.96),('325','2013-09-28','15:40:00',2.88),('325','2013-09-28','15:45:00',2.93),('325','2013-09-28','15:50:00',2.56),('325','2013-09-28','15:55:00',2.44),('325','2013-09-28','16:00:00',2.65),('325','2013-09-28','16:05:00',2.59),('325','2013-09-28','16:10:00',2.47),('325','2013-09-28','16:15:00',1.96),('325','2013-09-28','16:20:00',1.69),('325','2013-09-28','16:25:00',1.95),('325','2013-09-28','16:30:00',1.92),('325','2013-09-28','16:35:00',1.94),('325','2013-09-28','16:40:00',1.83),('325','2013-09-28','16:45:00',1.73),('325','2013-09-28','16:50:00',1.65),('325','2013-09-28','16:55:00',1.55),('325','2013-09-28','17:00:00',1.47),('325','2013-09-28','17:05:00',1.35),('325','2013-09-28','17:10:00',1.26),('325','2013-09-28','17:15:00',1.17),('325','2013-09-28','17:20:00',1.08),('325','2013-09-28','17:25:00',1),('325','2014-04-13','09:05:00',1.25),('325','2014-04-13','09:10:00',1.38),('325','2014-04-13','09:15:00',1.23),('325','2014-04-13','09:20:00',1.33),('325','2014-04-13','09:25:00',1.48),('325','2014-04-13','09:30:00',1.91),('325','2014-04-13','09:35:00',1.69),('325','2014-04-13','09:40:00',2.06),('325','2014-04-13','09:45:00',1.74),('325','2014-04-13','09:50:00',1.42),('325','2014-04-13','09:55:00',1.49),('325','2014-04-13','10:00:00',2.43),('325','2014-04-13','10:05:00',2.87),('325','2014-04-13','10:10:00',2.59),('325','2014-04-13','10:15:00',2.52),('325','2014-04-13','10:20:00',2.79),('325','2014-04-13','10:25:00',2.04),('325','2014-04-13','10:30:00',3.49),('325','2014-04-13','10:35:00',3.62),('325','2014-04-13','10:40:00',3.66),('325','2014-04-13','10:45:00',3.67),('325','2014-04-13','10:50:00',3.86),('325','2014-04-13','10:55:00',3.91),('325','2014-04-13','11:00:00',3.74),('325','2014-04-13','11:05:00',4.01),('325','2014-04-13','11:10:00',3.96),('325','2014-04-13','11:15:00',4.16),('325','2014-04-13','11:20:00',4.93),('325','2014-04-13','11:25:00',2.8),('325','2014-04-13','11:30:00',2.42),('325','2014-04-13','11:35:00',3.13),('325','2014-04-13','11:40:00',4.09),('325','2014-04-13','11:45:00',4.12),('325','2014-04-13','11:50:00',3.95),('325','2014-04-13','11:55:00',2.7),('325','2014-04-13','12:00:00',2.27),('325','2014-04-13','12:05:00',1.76),('325','2014-04-13','12:10:00',1.55),('325','2014-04-13','12:15:00',1.49),('325','2014-04-13','12:20:00',1.41),('325','2014-04-13','12:25:00',1.04),('325','2014-04-13','13:05:00',1.39),('325','2014-04-13','13:10:00',2.09),('325','2014-04-13','13:15:00',2.18),('325','2014-04-13','13:20:00',3.37),('325','2014-04-13','13:25:00',3.86),('325','2014-04-13','13:30:00',4.89),('325','2014-04-13','13:35:00',4.49),('325','2014-04-13','13:40:00',3.64),('325','2014-04-13','13:45:00',2.15),('325','2014-04-13','13:50:00',3.32),('325','2014-04-13','13:55:00',3.05),('325','2014-04-13','14:00:00',4.73),('325','2014-04-13','14:05:00',4.13),('325','2014-04-13','14:10:00',4.03),('325','2014-04-13','14:15:00',5.05),('325','2014-04-13','14:20:00',2.07),('325','2014-04-13','14:25:00',1.8),('325','2014-04-13','14:30:00',1.84),('325','2014-04-13','14:35:00',1.74),('325','2014-04-13','14:40:00',1.53),('325','2014-04-13','14:45:00',2.76),('325','2014-04-13','14:50:00',4.6),('325','2014-04-13','14:55:00',4.47),('325','2014-04-13','15:00:00',3.46),('325','2014-04-13','15:05:00',4.14),('325','2014-04-13','15:10:00',4.21),('325','2014-04-13','15:15:00',3.56),('325','2014-04-13','15:20:00',3.54),('325','2014-04-13','15:25:00',3.91),('325','2014-04-13','15:30:00',3.56),('325','2014-04-13','15:35:00',2.41),('325','2014-04-13','15:40:00',1.6),('325','2014-04-13','15:45:00',1.63),('325','2014-04-13','15:50:00',2.22),('325','2014-04-13','15:55:00',2.04),('325','2014-04-13','16:00:00',3.63),('325','2014-04-13','16:05:00',2.81),('325','2014-04-13','16:10:00',1.26),('325','2014-04-13','16:15:00',1.51),('325','2014-04-13','16:20:00',1.46),('325','2014-04-13','16:25:00',1.91),('325','2014-04-13','16:30:00',1.44),('325','2014-04-13','16:35:00',1.54),('325','2014-04-13','16:40:00',2.97),('325','2014-04-13','16:45:00',2.79),('325','2014-04-13','16:50:00',2.66),('325','2014-04-13','16:55:00',2.26),('325','2014-04-13','17:00:00',1.75),('325','2014-04-13','17:05:00',1.69),('325','2014-04-13','17:10:00',1.07),('325','2014-04-13','17:15:00',1.09),('325','2014-04-13','17:20:00',1.65),('325','2014-04-13','17:25:00',1.44),('325','2014-04-13','17:50:00',1.02),('325','2014-04-13','17:55:00',1.1),('325','2014-04-13','18:00:00',1.01),('325','2014-04-13','18:05:00',1.16),('325','2013-09-27','08:55:00',1.18),('325','2013-09-27','09:00:00',1.12),('325','2013-09-27','09:15:00',1),('325','2013-09-27','09:50:00',1.82),('325','2013-09-27','09:55:00',1.72),('325','2013-09-27','10:00:00',1.89),('325','2013-09-27','10:05:00',1.45),('325','2013-09-27','10:10:00',1.9),('325','2013-09-27','10:15:00',1.55),('325','2013-09-27','10:20:00',2.12),('325','2013-09-27','10:25:00',1.46),('325','2013-09-27','10:30:00',1.33),('325','2013-09-27','10:35:00',1.14),('325','2013-09-27','10:40:00',1.19),('325','2013-09-27','10:45:00',1.13),('325','2013-09-27','10:50:00',1.88),('325','2013-09-27','10:55:00',3.04),('325','2013-09-27','11:00:00',3.05),('325','2013-09-27','11:05:00',2.4),('325','2013-09-27','11:10:00',2.69),('325','2013-09-27','11:15:00',2.53),('325','2013-09-27','11:20:00',3.45),('325','2013-09-27','11:25:00',2.51),('325','2013-09-27','11:30:00',1.98),('325','2013-09-27','11:35:00',1.15),('325','2013-09-27','11:40:00',1.15),('325','2013-09-27','11:45:00',1.25),('325','2013-09-27','11:50:00',1.45),('325','2013-09-27','11:55:00',2.53),('325','2013-09-27','12:00:00',3.02),('325','2013-09-27','12:05:00',2.05),('325','2013-09-27','12:10:00',3.41),('325','2013-09-27','12:40:00',1.79),('325','2013-09-27','12:45:00',2.54),('325','2013-09-27','12:50:00',3.88),('325','2013-09-27','12:55:00',3.91),('325','2013-09-27','13:00:00',3.73),('325','2013-09-27','13:05:00',2.95),('325','2013-09-27','13:10:00',3.36),('325','2013-09-27','13:15:00',1.6),('325','2013-09-27','13:20:00',1.98),('325','2013-09-27','13:25:00',1.18),('325','2013-09-27','13:40:00',3.08),('325','2013-09-27','13:45:00',1.04),('325','2013-09-27','13:50:00',1.14),('325','2013-09-27','13:55:00',1.74),('325','2013-09-27','14:00:00',3.98),('325','2013-09-27','14:05:00',3.59),('325','2013-09-27','14:10:00',3.94),('325','2013-09-27','14:15:00',3.92),('325','2013-09-27','14:20:00',3.87),('325','2013-09-27','14:25:00',3.28),('325','2013-09-27','14:30:00',3.57),('325','2013-09-27','14:35:00',3.66),('325','2013-09-27','14:40:00',3.63),('325','2013-09-27','14:45:00',3.51),('325','2013-09-27','14:50:00',3.37),('325','2013-09-27','14:55:00',3.36),('325','2013-09-27','15:00:00',2.9),('325','2013-09-27','15:05:00',1.67),('325','2013-09-27','15:10:00',3.32),('325','2013-09-27','15:15:00',3.13),('325','2013-09-27','15:20:00',2.8),('325','2013-09-27','15:25:00',2.62),('325','2013-09-27','15:30:00',3.13),('325','2013-09-27','15:35:00',3.05),('325','2013-09-27','15:40:00',1.35),('325','2013-09-27','15:45:00',2.22),('325','2013-09-27','15:50:00',2.98),('325','2013-09-27','15:55:00',2.72),('325','2013-09-27','16:00:00',1.91),('325','2013-09-27','16:05:00',1.21),('325','2013-09-27','16:10:00',1.58),('325','2013-09-27','16:15:00',2.21),('325','2013-09-27','16:20:00',2.3),('325','2013-09-27','16:25:00',1.78),('325','2013-09-27','16:30:00',2.09),('325','2013-09-27','16:35:00',1.97),('325','2013-09-27','16:40:00',1.88),('325','2013-09-27','16:45:00',1.84),('325','2013-09-27','16:50:00',1.65),('325','2013-09-27','16:55:00',1.07),('325','2013-09-27','17:10:00',1.47),('325','2013-09-27','17:15:00',1.34),('325','2013-09-27','17:20:00',1.18),('325','2013-09-27','17:25:00',1.08),('325','2013-09-26','09:00:00',1.02),('325','2013-09-26','09:05:00',1.07),('325','2013-09-26','09:10:00',1.11),('325','2013-09-26','09:15:00',1.16),('325','2013-09-26','09:20:00',1.21),('325','2013-09-26','09:25:00',1.25),('325','2013-09-26','09:30:00',1.3),('325','2013-09-26','09:35:00',1.34),('325','2013-09-26','09:40:00',1.38),('325','2013-09-26','09:45:00',1.43),('325','2013-09-26','09:50:00',1.47),('325','2013-09-26','09:55:00',1.51),('325','2013-09-26','10:00:00',1.59),('325','2013-09-26','10:05:00',2.3),('325','2013-09-26','10:10:00',2.34),('325','2013-09-26','10:15:00',2.54),('325','2013-09-26','10:20:00',2.72),('325','2013-09-26','10:25:00',2.79),('325','2013-09-26','10:30:00',2.92),('325','2013-09-26','10:35:00',2.99),('325','2013-09-26','10:40:00',3.03),('325','2013-09-26','10:45:00',3.07),('325','2013-09-26','10:50:00',3.15),('325','2013-09-26','10:55:00',3.2),('325','2013-09-26','11:00:00',3.22),('325','2013-09-26','11:05:00',3.32),('325','2013-09-26','11:10:00',3.35),('325','2013-09-26','11:15:00',3.35),('325','2013-09-26','11:20:00',3.3),('325','2013-09-26','11:25:00',3.33),('325','2013-09-26','11:30:00',2.44),('325','2013-09-26','11:35:00',2.84),('325','2013-09-26','11:40:00',3.64),('325','2013-09-26','11:45:00',3.57),('325','2013-09-26','11:50:00',3.91),('325','2013-09-26','11:55:00',3.98),('325','2013-09-26','12:00:00',3.72),('325','2013-09-26','12:05:00',4),('325','2013-09-26','12:10:00',1.25),('325','2013-09-26','12:15:00',1.41),('325','2013-09-26','12:20:00',1.79),('325','2013-09-26','12:25:00',1.29),('325','2013-09-26','12:30:00',1.49),('325','2013-09-26','12:35:00',1.81),('325','2013-09-26','12:40:00',1.64),('325','2013-09-26','12:45:00',1.64),('325','2013-09-26','12:50:00',1.72),('325','2013-09-26','12:55:00',3.93),('325','2013-09-26','13:00:00',2.84),('325','2013-09-26','13:05:00',2.29),('325','2013-09-26','13:10:00',2.76),('325','2013-09-26','13:15:00',4.41),('325','2013-09-26','13:20:00',4.38),('325','2013-09-26','13:25:00',2.69),('325','2013-09-26','13:30:00',2.82),('325','2013-09-26','13:35:00',2.07),('325','2013-09-26','13:40:00',1.69),('325','2013-09-26','13:45:00',1.52),('325','2013-09-26','13:50:00',2.14),('325','2013-09-26','13:55:00',2.23),('325','2013-09-26','14:00:00',2.76),('325','2013-09-26','14:05:00',4.19),('325','2013-09-26','14:10:00',3.43),('325','2013-09-26','14:15:00',3.01),('325','2013-09-26','14:20:00',1.32),('325','2013-09-26','14:30:00',1.91),('325','2013-09-26','14:35:00',1.1),('325','2013-09-26','14:40:00',2.76),('325','2013-09-26','14:45:00',4.14),('325','2013-09-26','14:50:00',3.1),('325','2013-09-26','14:55:00',1.47),('325','2013-09-26','15:00:00',1.3),('325','2013-09-26','15:05:00',1.83),('325','2013-09-26','15:10:00',1.09),('325','2013-09-26','15:15:00',1.13),('325','2013-09-26','15:20:00',2.97),('325','2013-09-26','15:25:00',1.02),('325','2013-09-26','15:35:00',2.27),('325','2013-09-26','15:40:00',1.03),('325','2013-09-26','15:45:00',1.12),('325','2013-09-26','15:50:00',2.54),('325','2013-09-26','15:55:00',2.8),('325','2013-09-26','16:00:00',2.49),('325','2013-09-26','16:05:00',1.16),('325','2013-09-26','16:10:00',2.29),('325','2013-09-26','16:15:00',2.39),('325','2013-09-26','16:20:00',2.33),('325','2013-09-26','16:25:00',2.26),('325','2013-09-26','16:30:00',2.13),('325','2013-09-26','16:35:00',2.04),('325','2013-09-26','16:40:00',1.93),('325','2013-09-26','16:45:00',1.83),('325','2013-09-26','16:50:00',1.74),('325','2013-09-26','16:55:00',1.66),('325','2013-09-26','17:00:00',1.52),('325','2013-09-26','17:05:00',1.43),('325','2013-09-26','17:10:00',1.39),('325','2013-09-26','17:15:00',1.06),('325','2013-09-26','17:20:00',1.18),('325','2013-09-26','17:25:00',1.09),('325','2013-09-26','17:30:00',1.04),('325','2013-09-25','09:05:00',1.42),('325','2013-09-25','09:10:00',1.7),('325','2013-09-25','09:15:00',1.01),('325','2013-09-25','09:20:00',1.05),('325','2013-09-25','09:25:00',1.54),('325','2013-09-25','09:30:00',1.16),('325','2013-09-25','09:35:00',1.58),('325','2013-09-25','09:40:00',1.63),('325','2013-09-25','09:50:00',1.36),('325','2013-09-25','09:55:00',1.09),('325','2013-09-25','10:00:00',1.63),('325','2013-09-25','10:10:00',1),('325','2013-09-25','10:20:00',1.58),('325','2013-09-25','10:25:00',1.5),('325','2013-09-25','10:30:00',1.76),('325','2013-09-25','10:35:00',1.4),('325','2013-09-25','10:40:00',2.12),('325','2013-09-25','10:45:00',3.8),('325','2013-09-25','10:50:00',3.63),('325','2013-09-25','10:55:00',3.23),('325','2013-09-25','11:00:00',1.72),('325','2013-09-25','11:10:00',1.05),('325','2013-09-25','11:15:00',3.51),('325','2013-09-25','11:20:00',3.55),('325','2013-09-25','11:25:00',3.57),('325','2013-09-25','11:30:00',3.63),('325','2013-09-25','11:35:00',3.57),('325','2013-09-25','11:40:00',3.17),('325','2013-09-25','11:45:00',2.03),('325','2013-09-25','11:50:00',1.01),('325','2013-09-25','12:10:00',2.68),('325','2013-09-25','12:15:00',3.66),('325','2013-09-25','12:20:00',1.62),('325','2013-09-25','12:25:00',2.52),('325','2013-09-25','12:30:00',4.46),('325','2013-09-25','12:35:00',3.34),('325','2013-09-25','12:40:00',1.06),('325','2013-09-25','12:45:00',2.94),('325','2013-09-25','12:50:00',2.61),('325','2013-09-25','12:55:00',1.22),('325','2013-09-25','13:00:00',3.05),('325','2013-09-25','13:10:00',1.78),('325','2013-09-25','13:15:00',1.67),('325','2013-09-25','13:20:00',1.56),('325','2013-09-25','13:25:00',2.49),('325','2013-09-25','13:30:00',2.01),('325','2013-09-25','13:35:00',4.77),('325','2013-09-25','13:40:00',4.61),('325','2013-09-25','13:45:00',4.57),('325','2013-09-25','13:50:00',4.05),('325','2013-09-25','13:55:00',1.33),('325','2013-09-25','14:05:00',1.17),('325','2013-09-25','14:10:00',1.14),('325','2013-09-25','14:15:00',1.01),('325','2013-09-25','14:20:00',1.28),('325','2013-09-25','14:25:00',1.52),('325','2013-09-25','14:30:00',2.68),('325','2013-09-25','14:35:00',3.56),('325','2013-09-25','14:40:00',3.6),('325','2013-09-25','14:45:00',1.94),('325','2013-09-25','14:50:00',3.5),('325','2013-09-25','14:55:00',3.37),('325','2013-09-25','15:00:00',3.94),('325','2013-09-25','15:05:00',3.72),('325','2013-09-25','15:10:00',3.51),('325','2013-09-25','15:15:00',2.78),('325','2013-09-25','15:20:00',3.46),('325','2013-09-25','15:25:00',3.27),('325','2013-09-25','15:30:00',3.34),('325','2013-09-25','15:35:00',3.43),('325','2013-09-25','15:40:00',3.28),('325','2013-09-25','15:45:00',3),('325','2013-09-25','15:50:00',3.03),('325','2013-09-25','15:55:00',2.99),('325','2013-09-25','16:00:00',2.91),('325','2013-09-25','16:05:00',2.76),('325','2013-09-25','16:10:00',2.67),('325','2013-09-25','16:15:00',2.58),('325','2013-09-25','16:20:00',2.13),('325','2013-09-25','16:25:00',1.79),('325','2013-09-25','16:30:00',2.34),('325','2013-09-25','16:35:00',2.07),('325','2013-09-25','16:40:00',2.01),('325','2013-09-25','16:45:00',1.98),('325','2013-09-25','16:50:00',1.88),('325','2013-09-25','16:55:00',1.78),('325','2013-09-25','17:00:00',1.7),('325','2013-09-25','17:05:00',1.57),('325','2013-09-25','17:10:00',1.48),('325','2013-09-25','17:15:00',1.37),('325','2013-09-25','17:20:00',1.27),('325','2013-09-25','17:25:00',1.18),('325','2013-09-25','17:30:00',1.09),('325','2013-09-24','09:00:00',1.02),('325','2013-09-24','09:05:00',1.07),('325','2013-09-24','09:10:00',1.12),('325','2013-09-24','09:15:00',1.17),('325','2013-09-24','09:20:00',1.21),('325','2013-09-24','09:25:00',1.27),('325','2013-09-24','09:30:00',1.31),('325','2013-09-24','09:35:00',1.36),('325','2013-09-24','09:40:00',1.39),('325','2013-09-24','09:45:00',1.44),('325','2013-09-24','09:50:00',1.47),('325','2013-09-24','09:55:00',1.75),('325','2013-09-24','10:00:00',2.58),('325','2013-09-24','10:05:00',2.68),('325','2013-09-24','10:10:00',2.74),('325','2013-09-24','10:15:00',2.85),('325','2013-09-24','10:20:00',2.94),('325','2013-09-24','10:25:00',3.05),('325','2013-09-24','10:30:00',3.12),('325','2013-09-24','10:35:00',3.17),('325','2013-09-24','10:40:00',3.23),('325','2013-09-24','10:45:00',3.3),('325','2013-09-24','10:50:00',3.39),('325','2013-09-24','10:55:00',3.45),('325','2013-09-24','11:00:00',3.49),('325','2013-09-24','11:05:00',3.52),('325','2013-09-24','11:10:00',3.54),('325','2013-09-24','11:15:00',3.57),('325','2013-09-24','11:20:00',3.61),('325','2013-09-24','11:25:00',3.68),('325','2013-09-24','11:30:00',3.68),('325','2013-09-24','11:35:00',3.68),('325','2013-09-24','11:40:00',3.7),('325','2013-09-24','11:45:00',3.76),('325','2013-09-24','11:50:00',3.84),('325','2013-09-24','11:55:00',3.82),('325','2013-09-24','12:00:00',3.84),('325','2013-09-24','12:05:00',3.87),('325','2013-09-24','12:10:00',3.91),('325','2013-09-24','12:15:00',3.91),('325','2013-09-24','12:20:00',3.92),('325','2013-09-24','12:25:00',3.95),('325','2013-09-24','12:30:00',4),('325','2013-09-24','12:35:00',4.01),('325','2013-09-24','12:40:00',4.03),('325','2013-09-24','12:45:00',4.02),('325','2013-09-24','12:50:00',4.01),('325','2013-09-24','12:55:00',4.02),('325','2013-09-24','13:00:00',4.04),('325','2013-09-24','13:05:00',4.05),('325','2013-09-24','13:10:00',4.06),('325','2013-09-24','13:15:00',4.02),('325','2013-09-24','13:20:00',4.02),('325','2013-09-24','13:25:00',3.98),('325','2013-09-24','13:30:00',4.02),('325','2013-09-24','13:35:00',3.99),('325','2013-09-24','13:40:00',4.03),('325','2013-09-24','13:45:00',3.95),('325','2013-09-24','13:50:00',3.93),('325','2013-09-24','13:55:00',3.91),('325','2013-09-24','14:00:00',3.93),('325','2013-09-24','14:05:00',3.89),('325','2013-09-24','14:10:00',3.89),('325','2013-09-24','14:15:00',3.84),('325','2013-09-24','14:20:00',3.8),('325','2013-09-24','14:25:00',3.78),('325','2013-09-24','14:30:00',3.74),('325','2013-09-24','14:35:00',3.72),('325','2013-09-24','14:40:00',3.69),('325','2013-09-24','14:45:00',3.62),('325','2013-09-24','14:50:00',3.59),('325','2013-09-24','14:55:00',3.55),('325','2013-09-24','15:00:00',3.51),('325','2013-09-24','15:05:00',3.45),('325','2013-09-24','15:10:00',3.42),('325','2013-09-24','15:15:00',3.35),('325','2013-09-24','15:20:00',3.33),('325','2013-09-24','15:25:00',3.27),('325','2013-09-24','15:30:00',3.21),('325','2013-09-24','15:35:00',3.16),('325','2013-09-24','15:40:00',3.09),('325','2013-09-24','15:45:00',3.05),('325','2013-09-24','15:50:00',2.96),('325','2013-09-24','15:55:00',2.89),('325','2013-09-24','16:00:00',2.82),('325','2013-09-24','16:05:00',2.73),('325','2013-09-24','16:10:00',2.66),('325','2013-09-24','16:15:00',2.6),('325','2013-09-24','16:20:00',2.5),('325','2013-09-24','16:25:00',2.36),('325','2013-09-24','16:30:00',2.27),('325','2013-09-24','16:35:00',2.19),('325','2013-09-24','16:40:00',2.12),('325','2013-09-24','16:45:00',2.03),('325','2013-09-24','16:50:00',1.96),('325','2013-09-24','16:55:00',1.85),('325','2013-09-24','17:00:00',1.74),('325','2013-09-24','17:05:00',1.63),('325','2013-09-24','17:10:00',1.52),('325','2013-09-24','17:15:00',1.43),('325','2013-09-24','17:20:00',1.32),('325','2013-09-24','17:25:00',1.22),('325','2013-09-24','17:30:00',1.09),('325','2013-09-23','09:00:00',1.04),('325','2013-09-23','09:05:00',1.09),('325','2013-09-23','09:10:00',1.14),('325','2013-09-23','09:15:00',1.19),('325','2013-09-23','09:20:00',1.24),('325','2013-09-23','09:25:00',1.28),('325','2013-09-23','09:30:00',1.33),('325','2013-09-23','09:35:00',1.37),('325','2013-09-23','09:40:00',1.41),('325','2013-09-23','09:45:00',1.45),('325','2013-09-23','09:50:00',1.49),('325','2013-09-23','09:55:00',1.54),('325','2013-09-23','10:00:00',1.59),('325','2013-09-23','10:05:00',2.4),('325','2013-09-23','10:10:00',2.78),('325','2013-09-23','10:15:00',2.89),('325','2013-09-23','10:20:00',2.97),('325','2013-09-23','10:25:00',3.08),('325','2013-09-23','10:30:00',3.16),('325','2013-09-23','10:35:00',3.22),('325','2013-09-23','10:40:00',3.31),('325','2013-09-23','10:45:00',3.38),('325','2013-09-23','10:50:00',3.45),('325','2013-09-23','10:55:00',3.52),('325','2013-09-23','11:00:00',3.54),('325','2013-09-23','11:05:00',3.58),('325','2013-09-23','11:10:00',3.62),('325','2013-09-23','11:15:00',3.71),('325','2013-09-23','11:20:00',3.76),('325','2013-09-23','11:25:00',3.79),('325','2013-09-23','11:30:00',3.82),('325','2013-09-23','11:35:00',3.86),('325','2013-09-23','11:40:00',3.88),('325','2013-09-23','11:45:00',3.94),('325','2013-09-23','11:50:00',4),('325','2013-09-23','11:55:00',4.03),('325','2013-09-23','12:00:00',4.05),('325','2013-09-23','12:05:00',4.07),('325','2013-09-23','12:10:00',4.09),('325','2013-09-23','12:15:00',4.11),('325','2013-09-23','12:20:00',4.12),('325','2013-09-23','12:25:00',4.14),('325','2013-09-23','12:30:00',4.13),('325','2013-09-23','12:35:00',4.12),('325','2013-09-23','12:40:00',4.13),('325','2013-09-23','12:45:00',4.12),('325','2013-09-23','12:50:00',4.1),('325','2013-09-23','12:55:00',4.08),('325','2013-09-23','13:00:00',4.1),('325','2013-09-23','13:05:00',4.09),('325','2013-09-23','13:10:00',4.05),('325','2013-09-23','13:15:00',4.02),('325','2013-09-23','13:20:00',4.04),('325','2013-09-23','13:25:00',3.95),('325','2013-09-23','13:30:00',3.97),('325','2013-09-23','13:35:00',3.99),('325','2013-09-23','13:40:00',4),('325','2013-09-23','13:45:00',4),('325','2013-09-23','13:50:00',3.96),('325','2013-09-23','13:55:00',3.95),('325','2013-09-23','14:00:00',3.91),('325','2013-09-23','14:05:00',3.85),('325','2013-09-23','14:10:00',3.81),('325','2013-09-23','14:15:00',3.87),('325','2013-09-23','14:20:00',3.82),('325','2013-09-23','14:25:00',3.78),('325','2013-09-23','14:30:00',3.78),('325','2013-09-23','14:35:00',3.69),('325','2013-09-23','14:40:00',3.61),('325','2013-09-23','14:45:00',3.6),('325','2013-09-23','14:50:00',3.39),('325','2013-09-23','14:55:00',3.38),('325','2013-09-23','15:00:00',3.54),('325','2013-09-23','15:05:00',3.53),('325','2013-09-23','15:10:00',2.74),('325','2013-09-23','15:15:00',2.41),('325','2013-09-23','15:20:00',2.71),('325','2013-09-23','15:25:00',2.46),('325','2013-09-23','15:30:00',3.2),('325','2013-09-23','15:35:00',3.16),('325','2013-09-23','15:40:00',3.11),('325','2013-09-23','15:45:00',3.02),('325','2013-09-23','15:50:00',2.93),('325','2013-09-23','15:55:00',2.84),('325','2013-09-23','16:00:00',2.74),('325','2013-09-23','16:05:00',2.69),('325','2013-09-23','16:10:00',2.62),('325','2013-09-23','16:15:00',2.55),('325','2013-09-23','16:20:00',2.47),('325','2013-09-23','16:25:00',2.33),('325','2013-09-23','16:30:00',2.17),('325','2013-09-23','16:35:00',1.97),('325','2013-09-23','16:40:00',2.03),('325','2013-09-23','16:45:00',1.98),('325','2013-09-23','16:50:00',1.86),('325','2013-09-23','16:55:00',1.78),('325','2013-09-23','17:00:00',1.69),('325','2013-09-23','17:05:00',1.57),('325','2013-09-23','17:10:00',1.48),('325','2013-09-23','17:15:00',1.4),('325','2013-09-23','17:20:00',1.3),('325','2013-09-23','17:25:00',1.21),('325','2013-09-23','17:30:00',1.12),('325','2013-09-23','17:35:00',1.03),('325','2013-09-22','09:00:00',1.04),('325','2013-09-22','09:05:00',1.09),('325','2013-09-22','09:10:00',1.15),('325','2013-09-22','09:15:00',1.2),('325','2013-09-22','09:20:00',1.25),('325','2013-09-22','09:25:00',1.29),('325','2013-09-22','09:30:00',1.34),('325','2013-09-22','09:35:00',1.38),('325','2013-09-22','09:40:00',1.42),('325','2013-09-22','09:45:00',1.47),('325','2013-09-22','09:50:00',1.52),('325','2013-09-22','09:55:00',1.56),('325','2013-09-22','10:00:00',1.61),('325','2013-09-22','10:05:00',2.52),('325','2013-09-22','10:10:00',2.81),('325','2013-09-22','10:15:00',2.92),('325','2013-09-22','10:20:00',3.01),('325','2013-09-22','10:25:00',3.1),('325','2013-09-22','10:30:00',3.19),('325','2013-09-22','10:35:00',3.26),('325','2013-09-22','10:40:00',3.32),('325','2013-09-22','10:45:00',3.38),('325','2013-09-22','10:50:00',3.47),('325','2013-09-22','10:55:00',3.53),('325','2013-09-22','11:00:00',3.57),('325','2013-09-22','11:05:00',3.6),('325','2013-09-22','11:10:00',3.65),('325','2013-09-22','11:15:00',3.67),('325','2013-09-22','11:20:00',3.74),('325','2013-09-22','11:25:00',3.8),('325','2013-09-22','11:30:00',3.84),('325','2013-09-22','11:35:00',3.89),('325','2013-09-22','11:40:00',3.92),('325','2013-09-22','11:45:00',3.98),('325','2013-09-22','11:50:00',4.05),('325','2013-09-22','11:55:00',4.07),('325','2013-09-22','12:00:00',4.1),('325','2013-09-22','12:05:00',4.13),('325','2013-09-22','12:10:00',4.13),('325','2013-09-22','12:15:00',4.15),('325','2013-09-22','12:20:00',4.17),('325','2013-09-22','12:25:00',4.2),('325','2013-09-22','12:30:00',4.2),('325','2013-09-22','12:35:00',4.2),('325','2013-09-22','12:40:00',4.22),('325','2013-09-22','12:45:00',4.22),('325','2013-09-22','12:50:00',4.23),('325','2013-09-22','12:55:00',4.25),('325','2013-09-22','13:00:00',4.22),('325','2013-09-22','13:05:00',4.2),('325','2013-09-22','13:10:00',4.22),('325','2013-09-22','13:15:00',4.21),('325','2013-09-22','13:20:00',4.18),('325','2013-09-22','13:25:00',4.14),('325','2013-09-22','13:30:00',4.15),('325','2013-09-22','13:35:00',4.13),('325','2013-09-22','13:40:00',4.07),('325','2013-09-22','13:45:00',4.1),('325','2013-09-22','13:50:00',4.1),('325','2013-09-22','13:55:00',4.09),('325','2013-09-22','14:00:00',4.06),('325','2013-09-22','14:05:00',4.08),('325','2013-09-22','14:10:00',3.89),('325','2013-09-22','14:15:00',3.84),('325','2013-09-22','14:20:00',3.8),('325','2013-09-22','14:25:00',3.84),('325','2013-09-22','14:30:00',1.18),('325','2013-09-22','14:35:00',3.82),('325','2013-09-22','14:40:00',3.97),('325','2013-09-22','14:45:00',3.2),('325','2013-09-22','14:50:00',3.78),('325','2013-09-22','14:55:00',3.73),('325','2013-09-22','15:00:00',3.77),('325','2013-09-22','15:05:00',3.82),('325','2013-09-22','15:10:00',3.7),('325','2013-09-22','15:15:00',3.86),('325','2013-09-22','15:20:00',4.01),('325','2013-09-22','15:25:00',2.03),('325','2013-09-22','15:30:00',1.41),('325','2013-09-22','15:35:00',1.24),('325','2013-09-22','15:40:00',3.41),('325','2013-09-22','15:45:00',3.26),('325','2013-09-22','15:50:00',3.07),('325','2013-09-22','15:55:00',3.05),('325','2013-09-22','16:00:00',3.2),('325','2013-09-22','16:05:00',3.22),('325','2013-09-22','16:10:00',3.46),('325','2013-09-22','16:15:00',2.93),('325','2013-09-22','16:20:00',2.13),('325','2013-09-22','16:25:00',1.45),('325','2013-09-22','16:30:00',1.68),('325','2013-09-22','16:35:00',1.33),('325','2013-09-22','16:40:00',1.06),('325','2013-09-22','16:45:00',1.68),('325','2013-09-22','16:50:00',2.31),('325','2013-09-22','16:55:00',1.68),('325','2013-09-22','17:00:00',1.79),('325','2013-09-22','17:05:00',1.9),('325','2013-09-22','17:10:00',1.61),('325','2013-09-21','09:00:00',1.04),('325','2013-09-21','09:05:00',1.09),('325','2013-09-21','09:10:00',1.14),('325','2013-09-21','09:15:00',1.18),('325','2013-09-21','09:20:00',1.23),('325','2013-09-21','09:25:00',1.27),('325','2013-09-21','09:30:00',1.32),('325','2013-09-21','09:35:00',1.36),('325','2013-09-21','09:40:00',1.39),('325','2013-09-21','09:45:00',1.44),('325','2013-09-21','09:50:00',1.49),('325','2013-09-21','09:55:00',1.53),('325','2013-09-21','10:00:00',1.74),('325','2013-09-21','10:05:00',2.66),('325','2013-09-21','10:10:00',2.74),('325','2013-09-21','10:15:00',2.84),('325','2013-09-21','10:20:00',2.94),('325','2013-09-21','10:25:00',3.05),('325','2013-09-21','10:30:00',3.13),('325','2013-09-21','10:35:00',3.19),('325','2013-09-21','10:40:00',3.26),('325','2013-09-21','10:45:00',3.32),('325','2013-09-21','10:50:00',3.4),('325','2013-09-21','10:55:00',3.47),('325','2013-09-21','11:00:00',3.52),('325','2013-09-21','11:05:00',3.55),('325','2013-09-21','11:10:00',3.57),('325','2013-09-21','11:15:00',3.62),('325','2013-09-21','11:20:00',3.67),('325','2013-09-21','11:25:00',3.71),('325','2013-09-21','11:30:00',3.73),('325','2013-09-21','11:35:00',3.8),('325','2013-09-21','11:40:00',3.83),('325','2013-09-21','11:45:00',3.87),('325','2013-09-21','11:50:00',3.94),('325','2013-09-21','11:55:00',3.88),('325','2013-09-21','12:00:00',3.96),('325','2013-09-21','12:05:00',4.03),('325','2013-09-21','12:10:00',4.03),('325','2013-09-21','12:15:00',4.08),('325','2013-09-21','12:20:00',3.9),('325','2013-09-21','12:25:00',3.8),('325','2013-09-21','12:30:00',4.16),('325','2013-09-21','12:35:00',4.06),('325','2013-09-21','12:40:00',3.91),('325','2013-09-21','12:45:00',4),('325','2013-09-21','12:50:00',4.06),('325','2013-09-21','12:55:00',4.13),('325','2013-09-21','13:00:00',4.13),('325','2013-09-21','13:05:00',4.03),('325','2013-09-21','13:10:00',4.11),('325','2013-09-21','13:15:00',4.2),('325','2013-09-21','13:20:00',3.43),('325','2013-09-21','13:25:00',3.92),('325','2013-09-21','13:30:00',3.94),('325','2013-09-21','13:35:00',3.95),('325','2013-09-21','13:40:00',3.48),('325','2013-09-21','13:45:00',3.5),('325','2013-09-21','13:50:00',3.6),('325','2013-09-21','13:55:00',3.51),('325','2013-09-21','14:00:00',3.79),('325','2013-09-21','14:05:00',3.89),('325','2013-09-21','14:10:00',3.76),('325','2013-09-21','14:15:00',3.9),('325','2013-09-21','14:20:00',3.88),('325','2013-09-21','14:25:00',3.84),('325','2013-09-21','14:30:00',3.78),('325','2013-09-21','14:35:00',3.72),('325','2013-09-21','14:40:00',3.69),('325','2013-09-21','14:45:00',3.62),('325','2013-09-21','14:50:00',3.6),('325','2013-09-21','14:55:00',3.55),('325','2013-09-21','15:00:00',3.51),('325','2013-09-21','15:05:00',3.48),('325','2013-09-21','15:10:00',3.36),('325','2013-09-21','15:15:00',3.31),('325','2013-09-21','15:20:00',3.32),('325','2013-09-21','15:25:00',3.24),('325','2013-09-21','15:30:00',3.18),('325','2013-09-21','15:35:00',3.12),('325','2013-09-21','15:40:00',2.78),('325','2013-09-21','15:45:00',2.06),('325','2013-09-21','15:50:00',2.95),('325','2013-09-21','15:55:00',2.75),('325','2013-09-21','16:00:00',2.09),('325','2013-09-21','16:05:00',1.44),('325','2013-09-21','16:10:00',1.73),('325','2013-09-21','16:15:00',1.57),('325','2013-09-21','16:20:00',1.73),('325','2013-09-21','16:30:00',1.31),('325','2013-09-21','16:35:00',1.52),('325','2013-09-21','16:40:00',1.06),('325','2013-09-21','16:55:00',1.22),('325','2013-09-21','17:05:00',1.09),('325','2013-09-21','17:15:00',1.08),('325','2013-09-21','17:40:00',1.01),('325','2013-09-20','08:40:00',1.09),('325','2013-09-20','08:45:00',1.1),('325','2013-09-20','09:00:00',1.01),('325','2013-09-20','09:05:00',1.11),('325','2013-09-20','09:15:00',1.11),('325','2013-09-20','09:20:00',1.22),('325','2013-09-20','09:25:00',1.27),('325','2013-09-20','09:30:00',1.13),('325','2013-09-20','09:35:00',1.17),('325','2013-09-20','09:40:00',1.21),('325','2013-09-20','09:45:00',1.34),('325','2013-09-20','09:50:00',1.31),('325','2013-09-20','09:55:00',1.47),('325','2013-09-20','10:00:00',1.68),('325','2013-09-20','10:05:00',1.82),('325','2013-09-20','10:10:00',1.99),('325','2013-09-20','10:15:00',2.99),('325','2013-09-20','10:20:00',2.24),('325','2013-09-20','10:25:00',1.93),('325','2013-09-20','10:30:00',1.91),('325','2013-09-20','10:35:00',2.3),('325','2013-09-20','10:40:00',2.41),('325','2013-09-20','10:45:00',2.39),('325','2013-09-20','10:50:00',2.61),('325','2013-09-20','10:55:00',2.16),('325','2013-09-20','11:00:00',1.94),('325','2013-09-20','11:05:00',2.04),('325','2013-09-20','11:10:00',2.18),('325','2013-09-20','11:15:00',2.37),('325','2013-09-20','11:20:00',2.76),('325','2013-09-20','11:25:00',2.42),('325','2013-09-20','11:30:00',2.98),('325','2013-09-20','11:35:00',3.24),('325','2013-09-20','11:40:00',3.37),('325','2013-09-20','11:45:00',4.33),('325','2013-09-20','11:50:00',4.23),('325','2013-09-20','11:55:00',4.12),('325','2013-09-20','12:00:00',4.07),('325','2013-09-20','12:05:00',4.08),('325','2013-09-20','12:10:00',4.13),('325','2013-09-20','12:15:00',4.21),('325','2013-09-20','12:20:00',4.29),('325','2013-09-20','12:25:00',3.33),('325','2013-09-20','12:30:00',3.96),('325','2013-09-20','12:35:00',2.61),('325','2013-09-20','12:40:00',4.23),('325','2013-09-20','12:45:00',3.01),('325','2013-09-20','12:50:00',4.37),('325','2013-09-20','12:55:00',4.2),('325','2013-09-20','13:00:00',3.11),('325','2013-09-20','13:05:00',4.14),('325','2013-09-20','13:10:00',3.83),('325','2013-09-20','13:15:00',2.76),('325','2013-09-20','13:20:00',4.1),('325','2013-09-20','13:25:00',2.83),('325','2013-09-20','13:30:00',3.79),('325','2013-09-20','13:35:00',3.48),('325','2013-09-20','13:40:00',3.71),('325','2013-09-20','13:45:00',4.17),('325','2013-09-20','13:50:00',3.92),('325','2013-09-20','13:55:00',3.69),('325','2013-09-20','14:00:00',4.07),('325','2013-09-20','14:05:00',3.1),('325','2013-09-20','14:10:00',1.66),('325','2013-09-20','14:15:00',3.02),('325','2013-09-20','14:20:00',3.56),('325','2013-09-20','14:25:00',4.14),('325','2013-09-20','14:30:00',3.82),('325','2013-09-20','14:35:00',3.08),('325','2013-09-20','14:40:00',3.91),('325','2013-09-20','14:45:00',3.9),('325','2013-09-20','14:50:00',3.84),('325','2013-09-20','14:55:00',3.83),('325','2013-09-20','15:00:00',3.45),('325','2013-09-20','15:05:00',4.01),('325','2013-09-20','15:10:00',2.14),('325','2013-09-20','15:15:00',1.85),('325','2013-09-20','15:20:00',1.89),('325','2013-09-20','15:30:00',1.34),('325','2013-09-20','15:35:00',3.03),('325','2013-09-20','15:40:00',3.45),('325','2013-09-20','15:45:00',3.22),('325','2013-09-20','15:50:00',3.2),('325','2013-09-20','15:55:00',3.25),('325','2013-09-20','16:00:00',3.4),('325','2013-09-20','16:05:00',2.34),('325','2013-09-20','16:10:00',1.68),('325','2013-09-20','16:15:00',2.31),('325','2013-09-20','16:20:00',2.04),('325','2013-09-20','16:25:00',1.29),('325','2013-09-20','16:30:00',1.02),('325','2013-09-20','16:45:00',1.31),('325','2013-09-20','16:50:00',1.98),('325','2013-09-20','16:55:00',2.38),('325','2013-09-20','17:00:00',2.18),('325','2013-09-20','17:05:00',2.28),('325','2013-09-20','17:10:00',2.32),('325','2013-09-20','17:15:00',2.07),('325','2013-09-20','17:20:00',2.08),('325','2013-09-20','17:25:00',1.84),('325','2013-09-20','17:30:00',1.53),('325','2013-09-20','17:35:00',1.35),('325','2013-09-20','17:40:00',1.34),('325','2013-09-20','17:45:00',1.24),('325','2013-09-20','17:50:00',1.1),('325','2013-09-20','17:55:00',1.04),('325','2013-09-20','18:00:00',1.03),('325','2013-09-20','18:05:00',1.03),('325','2013-09-19','09:10:00',1.44),('325','2013-09-19','09:15:00',1.4),('325','2013-09-19','09:20:00',1.16),('325','2013-09-19','10:05:00',2.28),('325','2013-09-19','10:10:00',1.72),('325','2013-09-19','10:20:00',1.03),('325','2013-09-19','10:25:00',1.15),('325','2013-09-19','10:30:00',1.26),('325','2013-09-19','10:35:00',2.6),('325','2013-09-19','10:40:00',2.19),('325','2013-09-19','10:45:00',2.33),('325','2013-09-19','10:50:00',1.58),('325','2013-09-19','10:55:00',3.92),('325','2013-09-19','11:00:00',3.16),('325','2013-09-19','11:05:00',2.71),('325','2013-09-19','11:10:00',2.5),('325','2013-09-19','11:15:00',1.73),('325','2013-09-19','11:20:00',2.37),('325','2013-09-19','11:25:00',3.18),('325','2013-09-19','11:30:00',3.38),('325','2013-09-19','11:35:00',4.25),('325','2013-09-19','11:40:00',2.41),('325','2013-09-19','11:45:00',3.65),('325','2013-09-19','11:50:00',3.6),('325','2013-09-19','11:55:00',4.02),('325','2013-09-19','12:00:00',3.16),('325','2013-09-19','12:05:00',2.39),('325','2013-09-19','12:10:00',3.07),('325','2013-09-19','12:15:00',2.34),('325','2013-09-19','12:20:00',4.49),('325','2013-09-19','12:25:00',4.46),('325','2013-09-19','12:30:00',4.47),('325','2013-09-19','12:35:00',4.41),('325','2013-09-19','12:40:00',3.8),('325','2013-09-19','12:45:00',2.89),('325','2013-09-19','12:50:00',4.63),('325','2013-09-19','12:55:00',4.54),('325','2013-09-19','13:00:00',4.54),('325','2013-09-19','13:05:00',4.63),('325','2013-09-19','13:10:00',4.81),('325','2013-09-19','13:15:00',4.77),('325','2013-09-19','13:20:00',3.78),('325','2013-09-19','13:25:00',3.34),('325','2013-09-19','13:30:00',4.44),('325','2013-09-19','13:35:00',4.5),('325','2013-09-19','13:40:00',4.8),('325','2013-09-19','13:45:00',4.87),('325','2013-09-19','13:50:00',3.38),('325','2013-09-19','13:55:00',1.37),('325','2013-09-19','14:00:00',1.61),('325','2013-09-19','14:05:00',4.47),('325','2013-09-19','14:10:00',4.27),('325','2013-09-19','14:15:00',4.18),('325','2013-09-19','14:20:00',4.09),('325','2013-09-19','14:25:00',3.99),('325','2013-09-19','14:30:00',4),('325','2013-09-19','14:35:00',3.98),('325','2013-09-19','14:40:00',3.8),('325','2013-09-19','14:45:00',3.71),('325','2013-09-19','14:50:00',3.57),('325','2013-09-19','14:55:00',3.91),('325','2013-09-19','15:00:00',3.5),('325','2013-09-19','15:05:00',3.21),('325','2013-09-19','15:10:00',2.94),('325','2013-09-19','15:15:00',2.88),('325','2013-09-19','15:20:00',3.64),('325','2013-09-19','15:25:00',3.19),('325','2013-09-19','15:30:00',1.84),('325','2013-09-19','15:35:00',2.39),('325','2013-09-19','15:40:00',3.42),('325','2013-09-19','15:45:00',3.4),('325','2013-09-19','15:50:00',3.18),('325','2013-09-19','15:55:00',2.86),('325','2013-09-19','16:00:00',2.97),('325','2013-09-19','16:05:00',2.9),('325','2013-09-19','16:10:00',2.24),('325','2013-09-19','16:15:00',2.71),('325','2013-09-19','16:20:00',2.81),('325','2013-09-19','16:25:00',2.05),('325','2013-09-19','16:30:00',2.26),('325','2013-09-19','16:35:00',2.04),('325','2013-09-19','16:40:00',1.01),('325','2013-09-19','16:45:00',1.65),('325','2013-09-19','16:50:00',1.68),('325','2013-09-19','16:55:00',2.15),('325','2013-09-19','17:00:00',1.74),('325','2013-09-19','17:05:00',1.79),('325','2013-09-19','17:10:00',1.65),('325','2013-09-19','17:15:00',1.57),('325','2013-09-19','17:20:00',1.36),('325','2013-09-19','17:25:00',1.28),('325','2013-09-19','17:30:00',1.2),('325','2013-09-19','17:35:00',1.03),('325','2013-09-18','08:55:00',1.25),('325','2013-09-18','09:00:00',1.3),('325','2013-09-18','09:05:00',1.12),('325','2013-09-18','09:15:00',1.28),('325','2013-09-18','09:20:00',1.79),('325','2013-09-18','09:25:00',1.62),('325','2013-09-18','09:35:00',1.63),('325','2013-09-18','09:40:00',1.48),('325','2013-09-18','09:50:00',1.02),('325','2013-09-18','09:55:00',1.61),('325','2013-09-18','10:00:00',1.74),('325','2013-09-18','10:05:00',1.97),('325','2013-09-18','10:10:00',1.91),('325','2013-09-18','10:15:00',1.81),('325','2013-09-18','10:20:00',1.84),('325','2013-09-18','10:25:00',1.88),('325','2013-09-18','10:30:00',1.93),('325','2013-09-18','10:35:00',3.11),('325','2013-09-18','10:40:00',3.17),('325','2013-09-18','10:45:00',3.23),('325','2013-09-18','10:50:00',3.04),('325','2013-09-18','10:55:00',3.53),('325','2013-09-18','11:00:00',3.61),('325','2013-09-18','11:05:00',3.75),('325','2013-09-18','11:10:00',3.82),('325','2013-09-18','11:15:00',2.96),('325','2013-09-18','11:20:00',3.73),('325','2013-09-18','11:25:00',3.96),('325','2013-09-18','11:30:00',3.29),('325','2013-09-18','11:35:00',4.21),('325','2013-09-18','11:40:00',3.35),('325','2013-09-18','11:45:00',4.02),('325','2013-09-18','11:50:00',4.08),('325','2013-09-18','11:55:00',4.1),('325','2013-09-18','12:00:00',4.12),('325','2013-09-18','12:05:00',4.29),('325','2013-09-18','12:10:00',4.33),('325','2013-09-18','12:15:00',4.41),('325','2013-09-18','12:20:00',3.71),('325','2013-09-18','12:25:00',1.4),('325','2013-09-18','12:30:00',3.05),('325','2013-09-18','12:35:00',4.55),('325','2013-09-18','12:40:00',2.28),('325','2013-09-18','12:45:00',4.1),('325','2013-09-18','12:50:00',4.38),('325','2013-09-18','12:55:00',3.48),('325','2013-09-18','13:00:00',1.73),('325','2013-09-18','13:05:00',4.66),('325','2013-09-18','13:10:00',4.52),('325','2013-09-18','13:15:00',4.43),('325','2013-09-18','13:20:00',4.36),('325','2013-09-18','13:25:00',4.41),('325','2013-09-18','13:30:00',4.35),('325','2013-09-18','13:35:00',4.33),('325','2013-09-18','13:40:00',4.36),('325','2013-09-18','13:45:00',3.03),('325','2013-09-18','13:50:00',4.07),('325','2013-09-18','13:55:00',4.34),('325','2013-09-18','14:00:00',4.15),('325','2013-09-18','14:05:00',2.27),('325','2013-09-18','14:10:00',4),('325','2013-09-18','14:15:00',2.44),('325','2013-09-18','14:20:00',4.19),('325','2013-09-18','14:25:00',4.12),('325','2013-09-18','14:30:00',4),('325','2013-09-18','14:35:00',3.98),('325','2013-09-18','14:40:00',3.98),('325','2013-09-18','14:45:00',3.88),('325','2013-09-18','14:50:00',3.13),('325','2013-09-18','14:55:00',3.01),('325','2013-09-18','15:00:00',3.85),('325','2013-09-18','15:05:00',2.57),('325','2013-09-18','15:10:00',1.4),('325','2013-09-18','15:15:00',3.05),('325','2013-09-18','15:20:00',1.7),('325','2013-09-18','15:25:00',3.75),('325','2013-09-18','15:30:00',3.01),('325','2013-09-18','15:35:00',3.62),('325','2013-09-18','15:40:00',3.41),('325','2013-09-18','15:45:00',3.14),('325','2013-09-18','15:50:00',2.27),('325','2013-09-18','15:55:00',3.15),('325','2013-09-18','16:00:00',3.28),('325','2013-09-18','16:05:00',3.06),('325','2013-09-18','16:10:00',3.02),('325','2013-09-18','16:15:00',2.88),('325','2013-09-18','16:20:00',2.69),('325','2013-09-18','16:25:00',2.36),('325','2013-09-18','16:30:00',2.22),('325','2013-09-18','16:35:00',2.1),('325','2013-09-18','16:40:00',2.19),('325','2013-09-18','16:45:00',2.1),('325','2013-09-18','16:50:00',1.87),('325','2013-09-18','16:55:00',1.84),('325','2013-09-18','17:00:00',1.94),('325','2013-09-18','17:05:00',1.72),('325','2013-09-18','17:10:00',1.7),('325','2013-09-18','17:15:00',1.63),('325','2013-09-18','17:20:00',1.3),('325','2013-09-18','17:25:00',1.37),('325','2013-09-18','17:30:00',1.36),('325','2013-09-18','17:35:00',1.22),('325','2013-09-18','17:40:00',1.12),('325','2013-09-18','17:45:00',1.02),('325','2014-04-12','09:10:00',1.07),('325','2014-04-12','09:15:00',1.53),('325','2014-04-12','09:20:00',2.09),('325','2014-04-12','09:25:00',2.15),('325','2014-04-12','09:30:00',1.65),('325','2014-04-12','09:35:00',1.45),('325','2014-04-12','09:40:00',1.28),('325','2014-04-12','09:45:00',1.28),('325','2014-04-12','09:50:00',1.46),('325','2014-04-12','09:55:00',1.46),('325','2014-04-12','10:00:00',1.49),('325','2014-04-12','10:05:00',1.51),('325','2014-04-12','10:10:00',1.65),('325','2014-04-12','10:15:00',1.82),('325','2014-04-12','10:20:00',1.88),('325','2014-04-12','10:25:00',1.97),('325','2014-04-12','10:30:00',2.15),('325','2014-04-12','10:35:00',2.33),('325','2014-04-12','10:40:00',2.44),('325','2014-04-12','10:45:00',2.72),('325','2014-04-12','10:50:00',2.61),('325','2014-04-12','10:55:00',3.07),('325','2014-04-12','11:00:00',3.2),('325','2014-04-12','11:05:00',2.49),('325','2014-04-12','11:10:00',2.59),('325','2014-04-12','11:15:00',3.24),('325','2014-04-12','11:20:00',4.32),('325','2014-04-12','11:25:00',2.88),('325','2014-04-12','11:30:00',3.79),('325','2014-04-12','11:35:00',4.15),('325','2014-04-12','11:40:00',3.84),('325','2014-04-12','11:45:00',3.47),('325','2014-04-12','11:50:00',3.27),('325','2014-04-12','11:55:00',3.48),('325','2014-04-12','12:00:00',2.86),('325','2014-04-12','12:05:00',1.66),('325','2014-04-12','12:10:00',1.95),('325','2014-04-12','12:15:00',2.06),('325','2014-04-12','12:20:00',4.03),('325','2014-04-12','12:25:00',3.53),('325','2014-04-12','12:30:00',3.2),('325','2014-04-12','12:35:00',2.9),('325','2014-04-12','12:40:00',3.33),('325','2014-04-12','12:45:00',2.28),('325','2014-04-12','12:50:00',3.37),('325','2014-04-12','12:55:00',2.92),('325','2014-04-12','13:00:00',2.29),('325','2014-04-12','13:05:00',3.6),('325','2014-04-12','13:10:00',3.35),('325','2014-04-12','13:15:00',3.77),('325','2014-04-12','13:20:00',3.24),('325','2014-04-12','13:25:00',4.83),('325','2014-04-12','13:30:00',2.99),('325','2014-04-12','13:35:00',1.61),('325','2014-04-12','13:40:00',2.27),('325','2014-04-12','13:45:00',4.29),('325','2014-04-12','13:50:00',1.87),('325','2014-04-12','13:55:00',3.22),('325','2014-04-12','14:00:00',4.3),('325','2014-04-12','14:05:00',4.65),('325','2014-04-12','14:10:00',4.32),('325','2014-04-12','14:15:00',2.33),('325','2014-04-12','14:20:00',3.28),('325','2014-04-12','14:25:00',2.04),('325','2014-04-12','14:30:00',2.75),('325','2014-04-12','14:35:00',1.47),('325','2014-04-12','14:40:00',2.02),('325','2014-04-12','14:45:00',3.87),('325','2014-04-12','14:50:00',3.73),('325','2014-04-12','14:55:00',3.83),('325','2014-04-12','15:00:00',2.54),('325','2014-04-12','15:05:00',3.99),('325','2014-04-12','15:10:00',4.06),('325','2014-04-12','15:15:00',3.89),('325','2014-04-12','15:20:00',2.5),('325','2014-04-12','15:25:00',2.52),('325','2014-04-12','15:30:00',2.61),('325','2014-04-12','15:35:00',2.33),('325','2014-04-12','15:40:00',3.02),('325','2014-04-12','15:45:00',3.43),('325','2014-04-12','15:50:00',3.82),('325','2014-04-12','15:55:00',3.65),('325','2014-04-12','16:00:00',3.71),('325','2014-04-12','16:05:00',3.63),('325','2014-04-12','16:10:00',3.45),('325','2014-04-12','16:15:00',3.57),('325','2014-04-12','16:20:00',3.53),('325','2014-04-12','16:25:00',3.16),('325','2014-04-12','16:30:00',2.84),('325','2014-04-12','16:35:00',2.68),('325','2014-04-12','16:40:00',2.59),('325','2014-04-12','16:45:00',2.56),('325','2014-04-12','16:50:00',1.84),('325','2014-04-12','16:55:00',2.6),('325','2014-04-12','17:00:00',2.46),('325','2014-04-12','17:05:00',2.36),('325','2014-04-12','17:10:00',2.31),('325','2014-04-12','17:15:00',2.19),('325','2014-04-12','17:20:00',1.75),('325','2014-04-12','17:25:00',2.06),('325','2014-04-12','17:30:00',1.76),('325','2014-04-12','17:35:00',1.54),('325','2014-04-12','17:40:00',1.95),('325','2014-04-12','17:45:00',1.91),('325','2014-04-12','17:50:00',1.75),('325','2014-04-12','17:55:00',1.35),('325','2014-04-12','18:00:00',1.21),('325','2013-09-17','09:20:00',1.2),('325','2013-09-17','09:30:00',1.07),('325','2013-09-17','09:40:00',1.18),('325','2013-09-17','09:45:00',1.7),('325','2013-09-17','09:50:00',1.04),('325','2013-09-17','09:55:00',1.55),('325','2013-09-17','10:00:00',1.61),('325','2013-09-17','10:05:00',1.46),('325','2013-09-17','10:10:00',1.58),('325','2013-09-17','10:20:00',1.53),('325','2013-09-17','10:25:00',2.07),('325','2013-09-17','10:30:00',2.86),('325','2013-09-17','10:35:00',1.82),('325','2013-09-17','10:40:00',1.84),('325','2013-09-17','10:45:00',2.61),('325','2013-09-17','10:50:00',3.78),('325','2013-09-17','10:55:00',3.13),('325','2013-09-17','11:00:00',2.42),('325','2013-09-17','11:05:00',1.84),('325','2013-09-17','11:10:00',3.81),('325','2013-09-17','11:15:00',2.86),('325','2013-09-17','11:20:00',2.53),('325','2013-09-17','11:25:00',1.78),('325','2013-09-17','11:30:00',2.01),('325','2013-09-17','11:35:00',3.36),('325','2013-09-17','11:40:00',3.35),('325','2013-09-17','11:45:00',3.12),('325','2013-09-17','11:50:00',3.66),('325','2013-09-17','11:55:00',3.35),('325','2013-09-17','12:00:00',3.63),('325','2013-09-17','12:05:00',3.84),('325','2013-09-17','12:10:00',1.92),('325','2013-09-17','12:15:00',2.34),('325','2013-09-17','12:20:00',2.71),('325','2013-09-17','12:25:00',4.38),('325','2013-09-17','12:30:00',2.89),('325','2013-09-17','12:35:00',2.3),('325','2013-09-17','12:40:00',3.48),('325','2013-09-17','12:45:00',4.02),('325','2013-09-17','12:50:00',3.05),('325','2013-09-17','12:55:00',3.37),('325','2013-09-17','13:00:00',2.2),('325','2013-09-17','13:05:00',1.59),('325','2013-09-17','13:10:00',3.39),('325','2013-09-17','13:15:00',3.01),('325','2013-09-17','13:20:00',2.72),('325','2013-09-17','13:25:00',2.34),('325','2013-09-17','13:30:00',1.83),('325','2013-09-17','13:35:00',2.19),('325','2013-09-17','13:40:00',2.31),('325','2013-09-17','13:45:00',1.66),('325','2013-09-17','13:55:00',1.39),('325','2013-09-17','14:00:00',1.83),('325','2013-09-17','14:05:00',1.29),('325','2013-09-17','14:15:00',1.29),('325','2013-09-17','14:25:00',1.8),('325','2013-09-17','14:35:00',1.22),('325','2013-09-17','14:50:00',1.54),('325','2013-09-17','14:55:00',3.86),('325','2013-09-17','15:00:00',3.62),('325','2013-09-17','15:05:00',3.01),('325','2013-09-17','15:10:00',2.67),('325','2013-09-17','15:15:00',3.28),('325','2013-09-17','15:20:00',3.29),('325','2013-09-17','15:25:00',2.97),('325','2013-09-17','15:30:00',2.35),('325','2013-09-17','15:35:00',1.18),('325','2013-09-17','15:45:00',1.63),('325','2013-09-17','15:50:00',1.93),('325','2013-09-17','15:55:00',2.09),('325','2013-09-17','16:00:00',1.42),('325','2013-09-17','16:05:00',1.94),('325','2013-09-17','16:10:00',1.9),('325','2013-09-17','16:15:00',1.76),('325','2013-09-17','16:20:00',1.07),('325','2013-09-17','16:40:00',1.38),('325','2013-09-17','16:45:00',1.69),('325','2013-09-17','16:50:00',1.31),('325','2013-09-17','16:55:00',1.11),('325','2013-09-17','17:00:00',1.67),('325','2013-09-17','17:05:00',1.86),('325','2013-09-17','17:10:00',1.71),('325','2013-09-17','17:15:00',1.69),('325','2013-09-17','17:20:00',1.31),('325','2013-09-17','17:25:00',1.43),('325','2013-09-17','17:30:00',1.32),('325','2013-09-17','17:35:00',1.02),('325','2013-09-17','17:40:00',1.02),('325','2013-09-16','09:05:00',1.38),('325','2013-09-16','09:10:00',1.31),('325','2013-09-16','09:15:00',1.36),('325','2013-09-16','09:20:00',1.35),('325','2013-09-16','09:25:00',1.25),('325','2013-09-16','09:30:00',1.33),('325','2013-09-16','09:35:00',1.44),('325','2013-09-16','09:40:00',1.5),('325','2013-09-16','09:45:00',1.58),('325','2013-09-16','09:50:00',1.62),('325','2013-09-16','09:55:00',2.06),('325','2013-09-16','10:00:00',2.34),('325','2013-09-16','10:05:00',2.94),('325','2013-09-16','10:10:00',1.58),('325','2013-09-16','10:15:00',1.35),('325','2013-09-16','10:20:00',1.92),('325','2013-09-16','10:25:00',2.78),('325','2013-09-16','10:30:00',3.4),('325','2013-09-16','10:35:00',3.62),('325','2013-09-16','10:40:00',3.87),('325','2013-09-16','10:45:00',4.12),('325','2013-09-16','10:50:00',3.94),('325','2013-09-16','10:55:00',1.05),('325','2013-09-16','11:00:00',1.71),('325','2013-09-16','11:05:00',1.56),('325','2013-09-16','11:25:00',4.47),('325','2013-09-16','11:30:00',4.18),('325','2013-09-16','11:35:00',4.15),('325','2013-09-16','11:40:00',4.13),('325','2013-09-16','11:45:00',3),('325','2013-09-16','11:50:00',4.31),('325','2013-09-16','11:55:00',4.26),('325','2013-09-16','12:00:00',4.43),('325','2013-09-16','12:05:00',4.06),('325','2013-09-16','12:10:00',4.57),('325','2013-09-16','12:15:00',4.47),('325','2013-09-16','12:20:00',4.33),('325','2013-09-16','12:25:00',4.33),('325','2013-09-16','12:30:00',4.22),('325','2013-09-16','12:35:00',4.39),('325','2013-09-16','12:40:00',4.62),('325','2013-09-16','12:45:00',3.43),('325','2013-09-16','12:50:00',4.95),('325','2013-09-16','12:55:00',3.06),('325','2013-09-16','13:00:00',2.88),('325','2013-09-16','13:05:00',3.58),('325','2013-09-16','13:10:00',4.65),('325','2013-09-16','13:15:00',3.97),('325','2013-09-16','13:20:00',4.37),('325','2013-09-16','13:25:00',4.35),('325','2013-09-16','13:30:00',4.31),('325','2013-09-16','13:35:00',4.33),('325','2013-09-16','13:40:00',4.32),('325','2013-09-16','13:45:00',4.3),('325','2013-09-16','13:50:00',4.36),('325','2013-09-16','13:55:00',4.41),('325','2013-09-16','14:00:00',3.34),('325','2013-09-16','14:05:00',4.25),('325','2013-09-16','14:10:00',4.14),('325','2013-09-16','14:15:00',4.1),('325','2013-09-16','14:20:00',4.05),('325','2013-09-16','14:25:00',4.04),('325','2013-09-16','14:30:00',3.99),('325','2013-09-16','14:35:00',3.95),('325','2013-09-16','14:40:00',3.89),('325','2013-09-16','14:45:00',3.87),('325','2013-09-16','14:50:00',3.57),('325','2013-09-16','14:55:00',3.81),('325','2013-09-16','15:00:00',3.78),('325','2013-09-16','15:05:00',3.73),('325','2013-09-16','15:10:00',3.69),('325','2013-09-16','15:15:00',3.64),('325','2013-09-16','15:20:00',3.59),('325','2013-09-16','15:25:00',3.52),('325','2013-09-16','15:30:00',3.46),('325','2013-09-16','15:35:00',3.41),('325','2013-09-16','15:40:00',3.37),('325','2013-09-16','15:45:00',3.28),('325','2013-09-16','15:50:00',3.22),('325','2013-09-16','15:55:00',3.15),('325','2013-09-16','16:00:00',3.02),('325','2013-09-16','16:05:00',2.34),('325','2013-09-16','16:10:00',2.98),('325','2013-09-16','16:15:00',2.86),('325','2013-09-16','16:20:00',2.76),('325','2013-09-16','16:25:00',2.69),('325','2013-09-16','16:30:00',2.55),('325','2013-09-16','16:35:00',2.47),('325','2013-09-16','16:40:00',2.4),('325','2013-09-16','16:45:00',2.31),('325','2013-09-16','16:50:00',2.21),('325','2013-09-16','16:55:00',2.12),('325','2013-09-16','17:00:00',2.02),('325','2013-09-16','17:05:00',1.93),('325','2013-09-16','17:10:00',1.8),('325','2013-09-16','17:15:00',1.69),('325','2013-09-16','17:20:00',1.6),('325','2013-09-16','17:25:00',1.51),('325','2013-09-16','17:30:00',1.44),('325','2013-09-16','17:35:00',1.01),('325','2013-09-16','17:45:00',1.14),('325','2013-09-15','08:45:00',1.01),('325','2013-09-15','08:50:00',1.03),('325','2013-09-15','08:55:00',1.01),('325','2013-09-15','09:00:00',1.08),('325','2013-09-15','09:05:00',1.1),('325','2013-09-15','09:10:00',1.21),('325','2013-09-15','09:15:00',1.32),('325','2013-09-15','09:20:00',1.3),('325','2013-09-15','09:25:00',1.36),('325','2013-09-15','09:30:00',1.37),('325','2013-09-15','09:35:00',1.46),('325','2013-09-15','09:40:00',1.49),('325','2013-09-15','09:45:00',1.52),('325','2013-09-15','09:50:00',1.58),('325','2013-09-15','09:55:00',2.48),('325','2013-09-15','10:00:00',2.69),('325','2013-09-15','10:05:00',2.78),('325','2013-09-15','10:10:00',2.8),('325','2013-09-15','10:15:00',2.82),('325','2013-09-15','10:20:00',2.91),('325','2013-09-15','10:25:00',3.01),('325','2013-09-15','10:30:00',2.9),('325','2013-09-15','10:35:00',2.01),('325','2013-09-15','10:40:00',1.35),('325','2013-09-15','10:50:00',1.64),('325','2013-09-15','10:55:00',3.57),('325','2013-09-15','11:00:00',4.05),('325','2013-09-15','11:05:00',4.02),('325','2013-09-15','11:10:00',2.58),('325','2013-09-15','11:15:00',1.74),('325','2013-09-15','11:20:00',1.76),('325','2013-09-15','11:30:00',2.33),('325','2013-09-15','11:35:00',2.04),('325','2013-09-15','11:40:00',1.5),('325','2013-09-15','11:45:00',3.19),('325','2013-09-15','11:50:00',2.91),('325','2013-09-15','11:55:00',1.49),('325','2013-09-15','12:00:00',1.26),('325','2013-09-15','12:05:00',1.18),('325','2013-09-15','12:10:00',1.21),('325','2013-09-15','12:15:00',1.34),('325','2013-09-15','12:20:00',1.71),('325','2013-09-15','12:25:00',1.9),('325','2013-09-15','12:30:00',1.71),('325','2013-09-15','12:35:00',1.5),('325','2013-09-15','12:40:00',1.45),('325','2013-09-15','12:45:00',1.25),('325','2013-09-15','12:50:00',1.41),('325','2013-09-15','12:55:00',1.43),('325','2013-09-15','13:00:00',1.28),('325','2013-09-15','13:25:00',1.26),('325','2013-09-15','13:30:00',1.18),('325','2013-09-15','13:35:00',1.19),('325','2013-09-15','13:40:00',1.4),('325','2013-09-15','13:45:00',2.25),('325','2013-09-15','13:50:00',1.75),('325','2013-09-15','13:55:00',1.24),('325','2013-09-15','14:00:00',2.01),('325','2013-09-15','14:05:00',1.79),('325','2013-09-15','14:10:00',1.63),('325','2013-09-15','14:15:00',1.61),('325','2013-09-15','14:20:00',1.5),('325','2013-09-15','14:25:00',1.42),('325','2013-09-15','14:30:00',1.29),('325','2013-09-15','14:35:00',1.11),('325','2013-09-15','14:40:00',1.14),('325','2013-09-15','14:45:00',1.05),('325','2013-09-15','14:50:00',1.09),('325','2013-09-15','14:55:00',1.07),('325','2013-09-15','15:00:00',1.1),('325','2013-09-15','15:05:00',1.19),('325','2013-09-15','15:10:00',1.45),('325','2013-09-15','15:15:00',2.97),('325','2013-09-15','15:20:00',2.12),('325','2013-09-15','15:25:00',1.52),('325','2013-09-15','15:30:00',1.11),('325','2013-09-15','15:35:00',1.11),('325','2013-09-15','15:40:00',1.03),('325','2013-09-15','15:45:00',1.02),('325','2013-09-14','08:55:00',1.04),('325','2013-09-14','09:00:00',1.08),('325','2013-09-14','09:05:00',1.12),('325','2013-09-14','09:10:00',1.19),('325','2013-09-14','09:15:00',1.25),('325','2013-09-14','09:20:00',1.3),('325','2013-09-14','09:25:00',1.36),('325','2013-09-14','09:30:00',1.41),('325','2013-09-14','09:35:00',1.46),('325','2013-09-14','09:40:00',1.5),('325','2013-09-14','09:45:00',1.55),('325','2013-09-14','09:50:00',1.6),('325','2013-09-14','09:55:00',1.86),('325','2013-09-14','10:00:00',2.64),('325','2013-09-14','10:05:00',2.66),('325','2013-09-14','10:10:00',2.57),('325','2013-09-14','10:15:00',2.64),('325','2013-09-14','10:20:00',2.89),('325','2013-09-14','10:25:00',3.04),('325','2013-09-14','10:30:00',3.17),('325','2013-09-14','10:35:00',3.4),('325','2013-09-14','10:40:00',3.44),('325','2013-09-14','10:45:00',2.38),('325','2013-09-14','10:50:00',4.02),('325','2013-09-14','10:55:00',2.19),('325','2013-09-14','11:00:00',1.86),('325','2013-09-14','11:05:00',2.12),('325','2013-09-14','11:10:00',3.22),('325','2013-09-14','11:15:00',1.39),('325','2013-09-14','11:25:00',3.84),('325','2013-09-14','11:30:00',4.02),('325','2013-09-14','11:35:00',4.18),('325','2013-09-14','11:40:00',4.13),('325','2013-09-14','11:45:00',4.19),('325','2013-09-14','11:50:00',3.04),('325','2013-09-14','12:30:00',1.59),('325','2013-09-14','12:35:00',2.35),('325','2013-09-14','12:40:00',1.11),('325','2013-09-14','12:45:00',1.02),('325','2013-09-14','12:55:00',1.91),('325','2013-09-14','13:00:00',1.63),('325','2013-09-14','13:05:00',1.54),('325','2013-09-14','13:10:00',3.67),('325','2013-09-14','13:15:00',4.81),('325','2013-09-14','13:20:00',3.03),('325','2013-09-14','13:25:00',4.78),('325','2013-09-14','13:30:00',4.39),('325','2013-09-14','13:35:00',4.45),('325','2013-09-14','13:40:00',4.59),('325','2013-09-14','13:45:00',3.1),('325','2013-09-14','13:50:00',2.94),('325','2013-09-14','13:55:00',4.52),('325','2013-09-14','14:00:00',4.52),('325','2013-09-14','14:05:00',4.3),('325','2013-09-14','14:10:00',4.2),('325','2013-09-14','14:15:00',4.17),('325','2013-09-14','14:20:00',4.08),('325','2013-09-14','14:25:00',4.09),('325','2013-09-14','14:30:00',4.06),('325','2013-09-14','14:35:00',4.01),('325','2013-09-14','14:40:00',4),('325','2013-09-14','14:45:00',3.91),('325','2013-09-14','14:50:00',3.89),('325','2013-09-14','14:55:00',3.84),('325','2013-09-14','15:00:00',3.76),('325','2013-09-14','15:05:00',3.71),('325','2013-09-14','15:10:00',3.69),('325','2013-09-14','15:15:00',3.62),('325','2013-09-14','15:20:00',3.57),('325','2013-09-14','15:25:00',3.53),('325','2013-09-14','15:30:00',3.51),('325','2013-09-14','15:35:00',3.41),('325','2013-09-14','15:40:00',3.34),('325','2013-09-14','15:45:00',3.28),('325','2013-09-14','15:50:00',3.2),('325','2013-09-14','15:55:00',3.13),('325','2013-09-14','16:00:00',3.07),('325','2013-09-14','16:05:00',2.98),('325','2013-09-14','16:10:00',2.87),('325','2013-09-14','16:15:00',2.83),('325','2013-09-14','16:20:00',2.72),('325','2013-09-14','16:25:00',2.7),('325','2013-09-14','16:30:00',2.59),('325','2013-09-14','16:35:00',2.44),('325','2013-09-14','16:40:00',2.4),('325','2013-09-14','16:45:00',2.3),('325','2013-09-14','16:50:00',2.24),('325','2013-09-14','16:55:00',2.13),('325','2013-09-14','17:00:00',2.07),('325','2013-09-14','17:05:00',1.93),('325','2013-09-14','17:10:00',1.88),('325','2013-09-14','17:15:00',1.73),('325','2013-09-14','17:20:00',1.38),('325','2013-09-14','17:25:00',1.51),('325','2013-09-14','17:30:00',1.43),('325','2013-09-14','17:35:00',1.16),('325','2013-09-14','17:40:00',1.22),('325','2013-09-14','17:45:00',1.14),('325','2013-09-14','17:50:00',1.05),('325','2013-09-13','08:55:00',1.01),('325','2013-09-13','09:20:00',1.02),('325','2013-09-13','09:25:00',1.14),('325','2013-09-13','09:30:00',1.21),('325','2013-09-13','09:35:00',1.3),('325','2013-09-13','09:40:00',1.38),('325','2013-09-13','09:45:00',1.33),('325','2013-09-13','09:50:00',1.53),('325','2013-09-13','09:55:00',2.1),('325','2013-09-13','10:00:00',1.83),('325','2013-09-13','10:05:00',1.24),('325','2013-09-13','10:10:00',2.07),('325','2013-09-13','10:15:00',3.68),('325','2013-09-13','10:20:00',3.1),('325','2013-09-13','10:25:00',1.48),('325','2013-09-13','10:30:00',2.98),('325','2013-09-13','10:35:00',3.38),('325','2013-09-13','10:40:00',3.39),('325','2013-09-13','10:45:00',3.42),('325','2013-09-13','10:50:00',3.5),('325','2013-09-13','10:55:00',3.58),('325','2013-09-13','11:00:00',3.61),('325','2013-09-13','11:05:00',3.64),('325','2013-09-13','11:10:00',3.72),('325','2013-09-13','11:15:00',3.77),('325','2013-09-13','11:20:00',3.79),('325','2013-09-13','11:25:00',3.83),('325','2013-09-13','11:30:00',3.89),('325','2013-09-13','11:35:00',3.92),('325','2013-09-13','11:40:00',3.93),('325','2013-09-13','11:45:00',3.94),('325','2013-09-13','11:50:00',3.98),('325','2013-09-13','11:55:00',4.04),('325','2013-09-13','12:00:00',4.09),('325','2013-09-13','12:05:00',4.12),('325','2013-09-13','12:10:00',4.16),('325','2013-09-13','12:15:00',4.2),('325','2013-09-13','12:20:00',4.18),('325','2013-09-13','12:25:00',4.22),('325','2013-09-13','12:30:00',4.29),('325','2013-09-13','12:35:00',4.33),('325','2013-09-13','12:40:00',4.38),('325','2013-09-13','12:45:00',4.37),('325','2013-09-13','12:50:00',4.36),('325','2013-09-13','12:55:00',4.33),('325','2013-09-13','13:00:00',4.25),('325','2013-09-13','13:05:00',4.23),('325','2013-09-13','13:10:00',4.2),('325','2013-09-13','13:15:00',4.17),('325','2013-09-13','13:20:00',4.17),('325','2013-09-13','13:25:00',4.13),('325','2013-09-13','13:30:00',4.13),('325','2013-09-13','13:35:00',4.14),('325','2013-09-13','13:40:00',4.13),('325','2013-09-13','13:45:00',4.18),('325','2013-09-13','13:50:00',4.14),('325','2013-09-13','13:55:00',4.11),('325','2013-09-13','14:00:00',4.07),('325','2013-09-13','14:05:00',4.06),('325','2013-09-13','14:10:00',4.06),('325','2013-09-13','14:15:00',4.02),('325','2013-09-13','14:20:00',4.06),('325','2013-09-13','14:25:00',1.2),('325','2013-09-13','14:35:00',4.12),('325','2013-09-13','14:40:00',3.79),('325','2013-09-13','14:45:00',3.77),('325','2013-09-13','14:50:00',3.31),('325','2013-09-13','14:55:00',3.81),('325','2013-09-13','15:00:00',3.8),('325','2013-09-13','15:05:00',3.77),('325','2013-09-13','15:10:00',3.72),('325','2013-09-13','15:15:00',3.65),('325','2013-09-13','15:20:00',3.62),('325','2013-09-13','15:25:00',3.54),('325','2013-09-13','15:30:00',3.49),('325','2013-09-13','15:35:00',3.43),('325','2013-09-13','15:40:00',3.37),('325','2013-09-13','15:45:00',3.31),('325','2013-09-13','15:50:00',3.25),('325','2013-09-13','15:55:00',3.17),('325','2013-09-13','16:00:00',3.09),('325','2013-09-13','16:05:00',3.03),('325','2013-09-13','16:10:00',2.96),('325','2013-09-13','16:15:00',2.88),('325','2013-09-13','16:20:00',2.8),('325','2013-09-13','16:25:00',2.72),('325','2013-09-13','16:30:00',2.63),('325','2013-09-13','16:35:00',2.48),('325','2013-09-13','16:40:00',2.41),('325','2013-09-13','16:45:00',2.32),('325','2013-09-13','16:50:00',2.23),('325','2013-09-13','16:55:00',2.13),('325','2013-09-13','17:00:00',2.04),('325','2013-09-13','17:05:00',1.94),('325','2013-09-13','17:10:00',1.83),('325','2013-09-13','17:15:00',1.72),('325','2013-09-13','17:20:00',1.63),('325','2013-09-13','17:25:00',1.53),('325','2013-09-13','17:30:00',1.42),('325','2013-09-13','17:35:00',1.33),('325','2013-09-13','17:40:00',1.23),('325','2013-09-13','17:45:00',1.14),('325','2013-09-13','17:50:00',1.05),('325','2013-09-12','08:25:00',1.06),('325','2013-09-12','08:30:00',1.15),('325','2013-09-12','08:35:00',1.15),('325','2013-09-12','09:00:00',1.16),('325','2013-09-12','09:05:00',1.18),('325','2013-09-12','09:10:00',1.02),('325','2013-09-12','09:15:00',1.46),('325','2013-09-12','09:20:00',1.51),('325','2013-09-12','09:25:00',1.63),('325','2013-09-12','09:30:00',1.8),('325','2013-09-12','09:35:00',1.79),('325','2013-09-12','09:40:00',1.62),('325','2013-09-12','09:45:00',2),('325','2013-09-12','09:50:00',1.65),('325','2013-09-12','09:55:00',1.06),('325','2013-09-12','10:00:00',1.06),('325','2013-09-12','10:05:00',1.49),('325','2013-09-12','10:10:00',1.76),('325','2013-09-12','10:15:00',1.68),('325','2013-09-12','10:20:00',1.08),('325','2013-09-12','10:25:00',1.42),('325','2013-09-12','10:30:00',2.44),('325','2013-09-12','10:35:00',1.8),('325','2013-09-12','10:55:00',2.15),('325','2013-09-12','11:00:00',2.53),('325','2013-09-12','11:05:00',3.78),('325','2013-09-12','11:10:00',3.06),('325','2013-09-12','11:15:00',2.6),('325','2013-09-12','11:20:00',1.43),('325','2013-09-12','11:40:00',1.43),('325','2013-09-12','11:45:00',2),('325','2013-09-12','11:50:00',1.67),('325','2013-09-12','11:55:00',3.27),('325','2013-09-12','12:00:00',3.12),('325','2013-09-12','12:05:00',3.84),('325','2013-09-12','12:10:00',3.17),('325','2013-09-12','12:15:00',2.84),('325','2013-09-12','12:20:00',1.4),('325','2013-09-12','12:25:00',2.07),('325','2013-09-12','12:30:00',1.52),('325','2013-09-12','12:35:00',3.62),('325','2013-09-12','12:40:00',3.58),('325','2013-09-12','12:45:00',1.08),('325','2013-09-12','12:50:00',2.22),('325','2013-09-12','12:55:00',2.8),('325','2013-09-12','13:00:00',4.03),('325','2013-09-12','13:05:00',2.67),('325','2013-09-12','13:10:00',2.86),('325','2013-09-12','13:15:00',4.81),('325','2013-09-12','13:20:00',4.98),('325','2013-09-12','13:25:00',4.32),('325','2013-09-12','13:30:00',3.86),('325','2013-09-12','13:35:00',2.2),('325','2013-09-12','13:40:00',3.7),('325','2013-09-12','13:45:00',2.94),('325','2013-09-12','13:50:00',4.28),('325','2013-09-12','13:55:00',4.33),('325','2013-09-12','14:00:00',3.92),('325','2013-09-12','14:05:00',4.04),('325','2013-09-12','14:10:00',3.95),('325','2013-09-12','14:15:00',4.1),('325','2013-09-12','14:20:00',4.24),('325','2013-09-12','14:25:00',3.89),('325','2013-09-12','14:30:00',4.38),('325','2013-09-12','14:35:00',2.2),('325','2013-09-12','14:40:00',3.52),('325','2013-09-12','14:45:00',3.97),('325','2013-09-12','14:50:00',4.06),('325','2013-09-12','14:55:00',3.94),('325','2013-09-12','15:00:00',3.53),('325','2013-09-12','15:05:00',2.27),('325','2013-09-12','15:10:00',2.82),('325','2013-09-12','15:15:00',3.85),('325','2013-09-12','15:20:00',3.68),('325','2013-09-12','15:25:00',3.22),('325','2013-09-12','15:30:00',3.61),('325','2013-09-12','15:35:00',3.49),('325','2013-09-12','15:40:00',3.45),('325','2013-09-12','15:45:00',3.4),('325','2013-09-12','15:50:00',3.34),('325','2013-09-12','15:55:00',3.3),('325','2013-09-12','16:00:00',3.2),('325','2013-09-12','16:05:00',1.45),('325','2013-09-12','16:10:00',3.3),('325','2013-09-12','16:15:00',2.21),('325','2013-09-12','16:20:00',2.24),('325','2013-09-12','16:25:00',1.85),('325','2013-09-12','16:30:00',2.19),('325','2013-09-12','16:40:00',2.78),('325','2013-09-12','16:45:00',2.49),('325','2013-09-12','16:50:00',1.15),('325','2013-09-12','16:55:00',1.32),('325','2013-09-12','17:00:00',2.32),('325','2013-09-12','17:05:00',2.11),('325','2013-09-12','17:10:00',1.9),('325','2013-09-12','17:15:00',1.41),('325','2013-09-12','17:20:00',1.15),('325','2013-09-12','17:30:00',1.67),('325','2013-09-12','17:35:00',1.49),('325','2013-09-12','17:40:00',1.37),('325','2013-09-12','17:45:00',1.25),('325','2013-09-12','17:50:00',1.1),('325','2013-09-12','17:55:00',1.02),('325','2013-09-11','08:55:00',1.06),('325','2013-09-11','09:00:00',1.47),('325','2013-09-11','09:05:00',1.4),('325','2013-09-11','09:10:00',1.4),('325','2013-09-11','09:15:00',1.54),('325','2013-09-11','09:20:00',1.88),('325','2013-09-11','09:25:00',1.32),('325','2013-09-11','09:30:00',1.16),('325','2013-09-11','09:35:00',1.68),('325','2013-09-11','09:40:00',1.25),('325','2013-09-11','10:00:00',1.11),('325','2013-09-11','10:05:00',1.64),('325','2013-09-11','10:15:00',2.84),('325','2013-09-11','10:20:00',2.82),('325','2013-09-11','10:25:00',2.83),('325','2013-09-11','10:30:00',2.95),('325','2013-09-11','10:35:00',2.43),('325','2013-09-11','10:40:00',1.96),('325','2013-09-11','10:45:00',2.47),('325','2013-09-11','10:50:00',2.48),('325','2013-09-11','10:55:00',1.6),('325','2013-09-11','11:00:00',1.69),('325','2013-09-11','11:05:00',2.18),('325','2013-09-11','11:10:00',3),('325','2013-09-11','11:15:00',4.25),('325','2013-09-11','11:20:00',3.29),('325','2013-09-11','11:25:00',1.83),('325','2013-09-11','11:30:00',2.47),('325','2013-09-11','11:35:00',2.37),('325','2013-09-11','11:40:00',4.26),('325','2013-09-11','11:45:00',4.2),('325','2013-09-11','11:50:00',3.89),('325','2013-09-11','11:55:00',3.02),('325','2013-09-11','12:00:00',4.25),('325','2013-09-11','12:05:00',3.54),('325','2013-09-11','12:10:00',2.81),('325','2013-09-11','12:15:00',1.7),('325','2013-09-11','12:20:00',2.19),('325','2013-09-11','12:25:00',3.92),('325','2013-09-11','12:30:00',2.23),('325','2013-09-11','12:35:00',2.84),('325','2013-09-11','12:40:00',1.76),('325','2013-09-11','12:45:00',3.25),('325','2013-09-11','12:50:00',5.08),('325','2013-09-11','13:00:00',4.21),('325','2013-09-11','13:05:00',3.67),('325','2013-09-11','13:10:00',4.64),('325','2013-09-11','13:15:00',4.73),('325','2013-09-11','13:20:00',4.34),('325','2013-09-11','13:25:00',2.35),('325','2013-09-11','13:30:00',2.72),('325','2013-09-11','13:35:00',4.19),('325','2013-09-11','13:40:00',2.53),('325','2013-09-11','13:45:00',4.32),('325','2013-09-11','13:50:00',3.51),('325','2013-09-11','13:55:00',2.71),('325','2013-09-11','14:00:00',4.38),('325','2013-09-11','14:05:00',3.66),('325','2013-09-11','14:10:00',3.73),('325','2013-09-11','14:15:00',4.03),('325','2013-09-11','14:20:00',3.52),('325','2013-09-11','14:25:00',3.44),('325','2013-09-11','14:30:00',2.86),('325','2013-09-11','14:35:00',2.74),('325','2013-09-11','14:40:00',2.68),('325','2013-09-11','14:45:00',3.55),('325','2013-09-11','14:50:00',4.42),('325','2013-09-11','14:55:00',1.85),('325','2013-09-11','15:00:00',3.95),('325','2013-09-11','15:05:00',2.99),('325','2013-09-11','15:10:00',2.57),('325','2013-09-11','15:15:00',3.6),('325','2013-09-11','15:20:00',4.13),('325','2013-09-11','15:25:00',1.85),('325','2013-09-11','15:30:00',3.24),('325','2013-09-11','15:35:00',1.02),('325','2013-09-11','15:40:00',1.78),('325','2013-09-11','15:45:00',3.12),('325','2013-09-11','15:50:00',3.45),('325','2013-09-11','15:55:00',2.82),('325','2013-09-11','16:00:00',2.92),('325','2013-09-11','16:05:00',3.28),('325','2013-09-11','16:10:00',3.11),('325','2013-09-11','16:15:00',2.99),('325','2013-09-11','16:20:00',2.77),('325','2013-09-11','16:25:00',2.69),('325','2013-09-11','16:30:00',1.43),('325','2013-09-11','16:40:00',1.88),('325','2013-09-11','16:45:00',2.52),('325','2013-09-11','16:50:00',2.34),('325','2013-09-11','16:55:00',1.31),('325','2013-09-11','17:00:00',2.16),('325','2013-09-11','17:05:00',2.03),('325','2013-09-11','17:10:00',1.94),('325','2013-09-11','17:15:00',1.81),('325','2013-09-11','17:20:00',1.7),('325','2013-09-11','17:25:00',1.59),('325','2013-09-11','17:30:00',1.5),('325','2013-09-11','17:35:00',1.42),('325','2013-09-11','17:40:00',1.19),('325','2013-09-11','17:45:00',1.25),('325','2013-09-10','08:55:00',1.15),('325','2013-09-10','09:00:00',1.19),('325','2013-09-10','09:05:00',1.24),('325','2013-09-10','09:10:00',1.7),('325','2013-09-10','09:15:00',1.5),('325','2013-09-10','09:20:00',1.29),('325','2013-09-10','09:25:00',1.33),('325','2013-09-10','09:30:00',2.09),('325','2013-09-10','09:35:00',2.23),('325','2013-09-10','09:40:00',1.54),('325','2013-09-10','09:45:00',1.32),('325','2013-09-10','09:50:00',1.2),('325','2013-09-10','09:55:00',1.06),('325','2013-09-10','10:25:00',1.03),('325','2013-09-10','10:30:00',1.01),('325','2013-09-10','10:35:00',1.19),('325','2013-09-10','10:40:00',1.59),('325','2013-09-10','10:45:00',2.13),('325','2013-09-10','10:50:00',1.23),('325','2013-09-10','10:55:00',1.38),('325','2013-09-10','11:00:00',1.69),('325','2013-09-10','11:05:00',1.45),('325','2013-09-10','11:10:00',1.38),('325','2013-09-10','11:15:00',1.19),('325','2013-09-10','11:20:00',1.31),('325','2013-09-10','11:25:00',1.38),('325','2013-09-10','11:30:00',1.05),('325','2013-09-10','11:45:00',1.29),('325','2013-09-10','11:50:00',1.26),('325','2013-09-10','11:55:00',1.56),('325','2013-09-10','12:00:00',1.35),('325','2013-09-10','12:05:00',1.02),('325','2013-09-10','12:10:00',1.03),('325','2013-09-10','12:15:00',1.08),('325','2013-09-10','13:25:00',1.06),('325','2013-09-10','13:35:00',1.1),('325','2013-09-10','13:40:00',1.89),('325','2013-09-10','13:45:00',2.85),('325','2013-09-10','13:50:00',1.88),('325','2013-09-10','13:55:00',1.6),('325','2013-09-10','14:00:00',1.16),('325','2013-09-10','14:05:00',1.32),('325','2013-09-10','14:10:00',1.37),('325','2013-09-10','14:15:00',1.68),('325','2013-09-10','14:20:00',1.68),('325','2013-09-10','14:25:00',2.4),('325','2013-09-10','14:30:00',2.03),('325','2013-09-10','14:35:00',1.54),('325','2013-09-10','14:40:00',1.87),('325','2013-09-10','14:45:00',1.97),('325','2013-09-10','14:50:00',2.35),('325','2013-09-10','14:55:00',2.03),('325','2013-09-10','15:00:00',2.65),('325','2013-09-10','15:05:00',2.42),('325','2013-09-10','15:10:00',1.83),('325','2013-09-10','15:15:00',1.71),('325','2013-09-10','15:20:00',2.17),('325','2013-09-10','15:25:00',1.91),('325','2013-09-10','15:30:00',2.25),('325','2013-09-10','15:35:00',1.82),('325','2013-09-10','15:40:00',1.23),('325','2013-09-10','15:45:00',1.04),('325','2013-09-10','15:50:00',1.11),('325','2013-09-10','15:55:00',1.01),('325','2013-09-10','16:00:00',1.07),('325','2013-09-10','16:05:00',1.11),('325','2013-09-10','16:10:00',1.43),('325','2013-09-10','16:15:00',1.52),('325','2013-09-10','16:20:00',1.04),('325','2013-09-09','08:55:00',1.13),('325','2013-09-09','09:00:00',1.15),('325','2013-09-09','09:05:00',1.07),('325','2013-09-09','09:35:00',1.17),('325','2013-09-09','10:00:00',1.46),('325','2013-09-09','10:05:00',1.75),('325','2013-09-09','10:10:00',1.69),('325','2013-09-09','10:15:00',1.63),('325','2013-09-09','10:20:00',1.64),('325','2013-09-09','10:25:00',1.58),('325','2013-09-09','10:30:00',1.53),('325','2013-09-09','10:35:00',1.59),('325','2013-09-09','10:40:00',1.71),('325','2013-09-09','10:45:00',2.09),('325','2013-09-09','10:50:00',2.71),('325','2013-09-09','10:55:00',2.55),('325','2013-09-09','11:00:00',2.8),('325','2013-09-09','11:05:00',2.39),('325','2013-09-09','11:10:00',2.16),('325','2013-09-09','11:15:00',2.23),('325','2013-09-09','11:20:00',2.15),('325','2013-09-09','11:25:00',2.17),('325','2013-09-09','11:30:00',2.22),('325','2013-09-09','11:35:00',2.38),('325','2013-09-09','11:40:00',3.25),('325','2013-09-09','11:45:00',3.21),('325','2013-09-09','11:50:00',3.39),('325','2013-09-09','11:55:00',2.11),('325','2013-09-09','12:00:00',2.87),('325','2013-09-09','12:05:00',3.37),('325','2013-09-09','12:10:00',3.13),('325','2013-09-09','12:15:00',2.37),('325','2013-09-09','12:20:00',1.38),('325','2013-09-09','12:25:00',1.11),('325','2013-09-09','12:30:00',1.09),('325','2013-09-09','12:35:00',1.11),('325','2013-09-09','12:40:00',1.53),('325','2013-09-09','12:45:00',1.42),('325','2013-09-09','12:50:00',1.21),('325','2013-09-09','12:55:00',1.7),('325','2013-09-09','13:00:00',1.87),('325','2013-09-09','13:05:00',2.3),('325','2013-09-09','13:10:00',2.17),('325','2013-09-09','13:15:00',2.8),('325','2013-09-09','13:20:00',3.39),('325','2013-09-09','13:25:00',3.41),('325','2013-09-09','13:30:00',3.98),('325','2013-09-09','13:35:00',3.76),('325','2013-09-09','13:40:00',3.72),('325','2013-09-09','13:45:00',4.21),('325','2013-09-09','13:50:00',4.05),('325','2013-09-09','13:55:00',4.26),('325','2013-09-09','14:00:00',3.91),('325','2013-09-09','14:05:00',3.85),('325','2013-09-09','14:10:00',4.16),('325','2013-09-09','14:15:00',2.54),('325','2013-09-09','14:20:00',2.04),('325','2013-09-09','14:25:00',1.57),('325','2013-09-09','14:30:00',2.23),('325','2013-09-09','14:35:00',3.65),('325','2013-09-09','14:40:00',4.15),('325','2013-09-09','14:45:00',3.28),('325','2013-09-09','14:50:00',3.68),('325','2013-09-09','14:55:00',2.37),('325','2013-09-09','15:00:00',2.62),('325','2013-09-09','15:05:00',2.45),('325','2013-09-09','15:10:00',2.29),('325','2013-09-09','15:15:00',1.45),('325','2013-09-09','15:20:00',2.61),('325','2013-09-09','15:25:00',1.47),('325','2013-09-09','15:30:00',3.1),('325','2013-09-09','15:35:00',2.52),('325','2013-09-09','15:40:00',2.38),('325','2013-09-09','15:45:00',1.51),('325','2013-09-09','15:50:00',1.54),('325','2013-09-09','15:55:00',1.62),('325','2013-09-09','16:00:00',1.83),('325','2013-09-09','16:05:00',1.4),('325','2013-09-09','16:10:00',1.94),('325','2013-09-09','16:15:00',2.19),('325','2013-09-09','16:20:00',1.93),('325','2013-09-09','16:25:00',1.23),('325','2013-09-09','16:30:00',1.14),('325','2013-09-09','16:35:00',1.29),('325','2013-09-09','16:40:00',1.42),('325','2013-09-09','16:45:00',1.93),('325','2013-09-09','17:00:00',1.04),('325','2013-09-08','09:05:00',1.03),('325','2013-09-08','09:10:00',1.05),('325','2013-09-08','09:15:00',1.08),('325','2013-09-08','09:20:00',1.03),('325','2013-09-08','09:25:00',1.17),('325','2013-09-08','09:30:00',1.41),('325','2013-09-08','09:35:00',1.39),('325','2013-09-08','09:40:00',1.49),('325','2013-09-08','09:45:00',1.66),('325','2013-09-08','09:50:00',1.58),('325','2013-09-08','09:55:00',1.71),('325','2013-09-08','10:00:00',2.36),('325','2013-09-08','10:05:00',2.55),('325','2013-09-08','10:10:00',2.66),('325','2013-09-08','10:15:00',2.74),('325','2013-09-08','10:20:00',2.79),('325','2013-09-08','10:25:00',2.91),('325','2013-09-08','10:30:00',2.92),('325','2013-09-08','10:35:00',3.02),('325','2013-09-08','10:40:00',3.12),('325','2013-09-08','10:45:00',3.17),('325','2013-09-08','10:50:00',3.22),('325','2013-09-08','10:55:00',3.19),('325','2013-09-08','11:00:00',3.25),('325','2013-09-08','11:05:00',3.36),('325','2013-09-08','11:10:00',3.4),('325','2013-09-08','11:15:00',3.45),('325','2013-09-08','11:20:00',3.49),('325','2013-09-08','11:25:00',3.47),('325','2013-09-08','11:30:00',3.5),('325','2013-09-08','11:35:00',3.5),('325','2013-09-08','11:40:00',3.59),('325','2013-09-08','11:45:00',3.6),('325','2013-09-08','11:50:00',3.53),('325','2013-09-08','11:55:00',3.6),('325','2013-09-08','12:00:00',3.53),('325','2013-09-08','12:05:00',3.49),('325','2013-09-08','12:10:00',3.62),('325','2013-09-08','12:15:00',3.83),('325','2013-09-08','12:20:00',3.76),('325','2013-09-08','12:25:00',3.76),('325','2013-09-08','12:30:00',3.75),('325','2013-09-08','12:35:00',3.76),('325','2013-09-08','12:40:00',3.71),('325','2013-09-08','12:45:00',3.84),('325','2013-09-08','12:50:00',3.81),('325','2013-09-08','12:55:00',3.83),('325','2013-09-08','13:00:00',3.78),('325','2013-09-08','13:05:00',3.89),('325','2013-09-08','13:10:00',3.75),('325','2013-09-08','13:15:00',3.78),('325','2013-09-08','13:20:00',3.8),('325','2013-09-08','13:25:00',3.41),('325','2013-09-08','13:30:00',3.49),('325','2013-09-08','13:35:00',3.33),('325','2013-09-08','13:40:00',2.42),('325','2013-09-08','13:45:00',2.31),('325','2013-09-08','13:50:00',3.13),('325','2013-09-08','13:55:00',3.17),('325','2013-09-08','14:00:00',3.69),('325','2013-09-08','14:05:00',3.58),('325','2013-09-08','14:10:00',3.94),('325','2013-09-08','14:15:00',3.52),('325','2013-09-08','14:20:00',3.97),('325','2013-09-08','14:25:00',4.16),('325','2013-09-08','14:30:00',3.68),('325','2013-09-08','14:35:00',3.91),('325','2013-09-08','14:40:00',3.78),('325','2013-09-08','14:45:00',3.68),('325','2013-09-08','14:50:00',3.69),('325','2013-09-08','14:55:00',3.69),('325','2013-09-08','15:00:00',3.67),('325','2013-09-08','15:05:00',2.84),('325','2013-09-08','15:10:00',2.03),('325','2013-09-08','15:15:00',2.74),('325','2013-09-08','15:20:00',3.44),('325','2013-09-08','15:25:00',3.5),('325','2013-09-08','15:30:00',3.51),('325','2013-09-08','15:35:00',3.37),('325','2013-09-08','15:40:00',3.12),('325','2013-09-08','15:45:00',3.2),('325','2013-09-08','15:50:00',3.03),('325','2013-09-08','15:55:00',2.56),('325','2013-09-08','16:00:00',2.68),('325','2013-09-08','16:05:00',2.66),('325','2013-09-08','16:10:00',2.38),('325','2013-09-08','16:15:00',2.76),('325','2013-09-08','16:20:00',2.44),('325','2013-09-08','16:25:00',2.35),('325','2013-09-08','16:30:00',2.47),('325','2013-09-08','16:35:00',2.23),('325','2013-09-08','16:40:00',1.8),('325','2013-09-08','16:45:00',1.39),('325','2013-09-08','16:50:00',1.33),('325','2013-09-08','16:55:00',1.23),('325','2013-09-08','17:00:00',1.59),('325','2013-09-08','17:05:00',2.09),('325','2013-09-08','17:10:00',1.95),('325','2013-09-08','17:15:00',1.78),('325','2013-09-08','17:20:00',1.51),('325','2013-09-08','17:25:00',1.48),('325','2013-09-08','17:30:00',1.34),('325','2013-09-08','17:45:00',1.06),('325','2013-09-08','17:50:00',1.05),('325','2014-04-11','08:35:00',1.22),('325','2014-04-11','08:40:00',1.32),('325','2014-04-11','08:45:00',1.38),('325','2014-04-11','08:50:00',1.37),('325','2014-04-11','08:55:00',1.37),('325','2014-04-11','09:00:00',1.33),('325','2014-04-11','09:05:00',1.41),('325','2014-04-11','09:10:00',1.75),('325','2014-04-11','09:15:00',1.65),('325','2014-04-11','09:20:00',1.54),('325','2014-04-11','09:25:00',1.58),('325','2014-04-11','09:30:00',1.63),('325','2014-04-11','09:35:00',1.66),('325','2014-04-11','09:40:00',1.71),('325','2014-04-11','09:45:00',1.75),('325','2014-04-11','09:50:00',1.8),('325','2014-04-11','09:55:00',1.85),('325','2014-04-11','10:00:00',1.89),('325','2014-04-11','10:05:00',1.94),('325','2014-04-11','10:10:00',1.97),('325','2014-04-11','10:15:00',3.2),('325','2014-04-11','10:20:00',3.4),('325','2014-04-11','10:25:00',3.48),('325','2014-04-11','10:30:00',3.54),('325','2014-04-11','10:35:00',3.6),('325','2014-04-11','10:40:00',3.69),('325','2014-04-11','10:45:00',3.77),('325','2014-04-11','10:50:00',3.83),('325','2014-04-11','10:55:00',3.92),('325','2014-04-11','11:00:00',4),('325','2014-04-11','11:05:00',4.04),('325','2014-04-11','11:10:00',4.06),('325','2014-04-11','11:15:00',4.1),('325','2014-04-11','11:20:00',4.17),('325','2014-04-11','11:25:00',4.22),('325','2014-04-11','11:30:00',4.28),('325','2014-04-11','11:35:00',4.33),('325','2014-04-11','11:40:00',4.34),('325','2014-04-11','11:45:00',4.41),('325','2014-04-11','11:50:00',4.48),('325','2014-04-11','11:55:00',4.69),('325','2014-04-11','12:00:00',4.69),('325','2014-04-11','12:05:00',4.59),('325','2014-04-11','12:10:00',4.52),('325','2014-04-11','12:15:00',4.4),('325','2014-04-11','12:20:00',4.64),('325','2014-04-11','12:25:00',4.73),('325','2014-04-11','12:30:00',4.82),('325','2014-04-11','12:35:00',4.76),('325','2014-04-11','12:40:00',4.79),('325','2014-04-11','12:45:00',4.45),('325','2014-04-11','12:50:00',5.18),('325','2014-04-11','12:55:00',4.91),('325','2014-04-11','13:00:00',3.35),('325','2014-04-11','13:05:00',4.3),('325','2014-04-11','13:10:00',3.54),('325','2014-04-11','13:15:00',4.02),('325','2014-04-11','13:20:00',4.03),('325','2014-04-11','13:25:00',4.17),('325','2014-04-11','13:30:00',2.46),('325','2014-04-11','13:35:00',4.68),('325','2014-04-11','13:40:00',3.6),('325','2014-04-11','13:45:00',4.81),('325','2014-04-11','13:50:00',3.3),('325','2014-04-11','13:55:00',5.12),('325','2014-04-11','14:00:00',2.2),('325','2014-04-11','14:05:00',4.94),('325','2014-04-11','14:10:00',3.24),('325','2014-04-11','14:15:00',3.24),('325','2014-04-11','14:20:00',3.08),('325','2014-04-11','14:25:00',4.15),('325','2014-04-11','14:30:00',4.7),('325','2014-04-11','14:35:00',4.78),('325','2014-04-11','14:40:00',2.53),('325','2014-04-11','14:45:00',3.88),('325','2014-04-11','14:50:00',4.69),('325','2014-04-11','14:55:00',4.29),('325','2014-04-11','15:00:00',5.05),('325','2014-04-11','15:05:00',4.35),('325','2014-04-11','15:10:00',4.3),('325','2014-04-11','15:15:00',3.55),('325','2014-04-11','15:20:00',3.97),('325','2014-04-11','15:25:00',3.83),('325','2014-04-11','15:30:00',3.9),('325','2014-04-11','15:35:00',2.23),('325','2014-04-11','15:40:00',3.91),('325','2014-04-11','15:45:00',3.66),('325','2014-04-11','15:50:00',3.63),('325','2014-04-11','15:55:00',3.64),('325','2014-04-11','16:00:00',3.51),('325','2014-04-11','16:05:00',3.4),('325','2014-04-11','16:10:00',3.21),('325','2014-04-11','16:15:00',3.25),('325','2014-04-11','16:20:00',3.04),('325','2014-04-11','16:25:00',3.09),('325','2014-04-11','16:30:00',3.02),('325','2014-04-11','16:35:00',2.55),('325','2014-04-11','16:40:00',2.59),('325','2014-04-11','16:45:00',2.3),('325','2014-04-11','16:50:00',1.64),('325','2014-04-11','16:55:00',2.44),('325','2014-04-11','17:00:00',2.38),('325','2014-04-11','17:05:00',2.43),('325','2014-04-11','17:10:00',2.3),('325','2014-04-11','17:15:00',1.93),('325','2014-04-11','17:20:00',2.15),('325','2014-04-11','17:25:00',2.04),('325','2014-04-11','17:30:00',2),('325','2014-04-11','17:35:00',1.92),('325','2014-04-11','17:40:00',1.81),('325','2014-04-11','17:45:00',1.62),('325','2014-04-11','17:50:00',1.48),('325','2014-04-11','17:55:00',1.36),('325','2014-04-11','18:00:00',1.25),('325','2014-04-11','18:05:00',1.15),('325','2014-04-11','18:10:00',1.05),('325','2013-09-07','09:05:00',1.02),('325','2013-09-07','09:10:00',1.09),('325','2013-09-07','09:15:00',1.14),('325','2013-09-07','09:20:00',1.19),('325','2013-09-07','09:25:00',1.25),('325','2013-09-07','09:30:00',1.31),('325','2013-09-07','09:35:00',1.36),('325','2013-09-07','09:40:00',1.39),('325','2013-09-07','09:45:00',1.42),('325','2013-09-07','09:50:00',1.47),('325','2013-09-07','09:55:00',1.52),('325','2013-09-07','10:00:00',2.34),('325','2013-09-07','10:05:00',2.61),('325','2013-09-07','10:10:00',2.71),('325','2013-09-07','10:15:00',2.78),('325','2013-09-07','10:20:00',2.89),('325','2013-09-07','10:25:00',2.95),('325','2013-09-07','10:30:00',2.99),('325','2013-09-07','10:35:00',3.08),('325','2013-09-07','10:40:00',3.17),('325','2013-09-07','10:45:00',3.21),('325','2013-09-07','10:50:00',3.28),('325','2013-09-07','10:55:00',3.36),('325','2013-09-07','11:00:00',3.39),('325','2013-09-07','11:05:00',3.42),('325','2013-09-07','11:10:00',3.47),('325','2013-09-07','11:15:00',3.51),('325','2013-09-07','11:20:00',3.54),('325','2013-09-07','11:25:00',3.59),('325','2013-09-07','11:30:00',3.65),('325','2013-09-07','11:35:00',3.7),('325','2013-09-07','11:40:00',3.73),('325','2013-09-07','11:45:00',3.74),('325','2013-09-07','11:50:00',3.78),('325','2013-09-07','11:55:00',3.84),('325','2013-09-07','12:00:00',3.85),('325','2013-09-07','12:05:00',3.89),('325','2013-09-07','12:10:00',3.91),('325','2013-09-07','12:15:00',3.93),('325','2013-09-07','12:20:00',3.95),('325','2013-09-07','12:25:00',3.95),('325','2013-09-07','12:30:00',3.96),('325','2013-09-07','12:35:00',3.98),('325','2013-09-07','12:40:00',3.94),('325','2013-09-07','12:45:00',3.94),('325','2013-09-07','12:50:00',3.96),('325','2013-09-07','12:55:00',3.9),('325','2013-09-07','13:00:00',3.99),('325','2013-09-07','13:05:00',4.02),('325','2013-09-07','13:10:00',3.99),('325','2013-09-07','13:15:00',3.97),('325','2013-09-07','13:20:00',3.99),('325','2013-09-07','13:25:00',4.06),('325','2013-09-07','13:30:00',4.06),('325','2013-09-07','13:35:00',3.99),('325','2013-09-07','13:40:00',3.95),('325','2013-09-07','13:45:00',3.98),('325','2013-09-07','13:50:00',4),('325','2013-09-07','13:55:00',3.81),('325','2013-09-07','14:00:00',4.03),('325','2013-09-07','14:05:00',4.01),('325','2013-09-07','14:10:00',3.99),('325','2013-09-07','14:15:00',3.95),('325','2013-09-07','14:20:00',3.87),('325','2013-09-07','14:25:00',3.81),('325','2013-09-07','14:30:00',3.86),('325','2013-09-07','14:35:00',3.84),('325','2013-09-07','14:40:00',3.8),('325','2013-09-07','14:45:00',3.8),('325','2013-09-07','14:50:00',3.74),('325','2013-09-07','14:55:00',3.73),('325','2013-09-07','15:00:00',3.67),('325','2013-09-07','15:05:00',3.62),('325','2013-09-07','15:10:00',3.58),('325','2013-09-07','15:15:00',3.55),('325','2013-09-07','15:20:00',3.53),('325','2013-09-07','15:25:00',3.49),('325','2013-09-07','15:30:00',3.42),('325','2013-09-07','15:35:00',3.34),('325','2013-09-07','15:40:00',3.24),('325','2013-09-07','15:45:00',3.19),('325','2013-09-07','15:50:00',3.13),('325','2013-09-07','15:55:00',3.05),('325','2013-09-07','16:00:00',3),('325','2013-09-07','16:05:00',2.92),('325','2013-09-07','16:10:00',2.86),('325','2013-09-07','16:15:00',2.78),('325','2013-09-07','16:20:00',2.69),('325','2013-09-07','16:25:00',2.6),('325','2013-09-07','16:30:00',2.53),('325','2013-09-07','16:35:00',2.45),('325','2013-09-07','16:40:00',2.32),('325','2013-09-07','16:45:00',2.24),('325','2013-09-07','16:50:00',2.17),('325','2013-09-07','16:55:00',2.09),('325','2013-09-07','17:00:00',1.99),('325','2013-09-07','17:05:00',1.9),('325','2013-09-07','17:10:00',1.82),('325','2013-09-07','17:15:00',1.73),('325','2013-09-07','17:20:00',1.64),('325','2013-09-07','17:25:00',1.51),('325','2013-09-07','17:30:00',1.4),('325','2013-09-07','17:35:00',1.33),('325','2013-09-07','17:40:00',1.26),('325','2013-09-07','17:45:00',1.17),('325','2013-09-07','17:50:00',1.08),('325','2013-09-06','09:05:00',1.04),('325','2013-09-06','09:10:00',1.15),('325','2013-09-06','09:15:00',1.19),('325','2013-09-06','09:20:00',1.24),('325','2013-09-06','09:25:00',1.27),('325','2013-09-06','09:30:00',1.32),('325','2013-09-06','09:35:00',1.34),('325','2013-09-06','09:40:00',1.37),('325','2013-09-06','09:45:00',1.4),('325','2013-09-06','09:50:00',1.45),('325','2013-09-06','09:55:00',1.5),('325','2013-09-06','10:00:00',1.74),('325','2013-09-06','10:05:00',2.62),('325','2013-09-06','10:10:00',2.74),('325','2013-09-06','10:15:00',2.84),('325','2013-09-06','10:20:00',2.9),('325','2013-09-06','10:25:00',2.98),('325','2013-09-06','10:30:00',3.05),('325','2013-09-06','10:35:00',3.15),('325','2013-09-06','10:40:00',3.27),('325','2013-09-06','10:45:00',3.32),('325','2013-09-06','10:50:00',3.36),('325','2013-09-06','10:55:00',3.42),('325','2013-09-06','11:00:00',3.48),('325','2013-09-06','11:05:00',3.51),('325','2013-09-06','11:10:00',3.57),('325','2013-09-06','11:15:00',3.62),('325','2013-09-06','11:20:00',3.64),('325','2013-09-06','11:25:00',3.67),('325','2013-09-06','11:30:00',3.71),('325','2013-09-06','11:35:00',3.77),('325','2013-09-06','11:40:00',3.81),('325','2013-09-06','11:45:00',3.83),('325','2013-09-06','11:50:00',3.84),('325','2013-09-06','11:55:00',3.91),('325','2013-09-06','12:00:00',3.89),('325','2013-09-06','12:05:00',3.87),('325','2013-09-06','12:10:00',3.87),('325','2013-09-06','12:15:00',3.96),('325','2013-09-06','12:20:00',4),('325','2013-09-06','12:25:00',3.98),('325','2013-09-06','12:30:00',3.99),('325','2013-09-06','12:35:00',4.02),('325','2013-09-06','12:40:00',4.05),('325','2013-09-06','12:45:00',4.09),('325','2013-09-06','12:50:00',4.06),('325','2013-09-06','12:55:00',4.03),('325','2013-09-06','13:00:00',4.03),('325','2013-09-06','13:05:00',4.02),('325','2013-09-06','13:10:00',4.03),('325','2013-09-06','13:15:00',4.04),('325','2013-09-06','13:20:00',4.03),('325','2013-09-06','13:25:00',4),('325','2013-09-06','13:30:00',4),('325','2013-09-06','13:35:00',3.97),('325','2013-09-06','13:40:00',3.97),('325','2013-09-06','13:45:00',3.95),('325','2013-09-06','13:50:00',3.93),('325','2013-09-06','13:55:00',3.87),('325','2013-09-06','14:00:00',3.84),('325','2013-09-06','14:05:00',3.85),('325','2013-09-06','14:10:00',3.84),('325','2013-09-06','14:15:00',3.84),('325','2013-09-06','14:20:00',3.81),('325','2013-09-06','14:25:00',3.81),('325','2013-09-06','14:30:00',3.7),('325','2013-09-06','14:35:00',3.6),('325','2013-09-06','14:40:00',3.69),('325','2013-09-06','14:45:00',3.6),('325','2013-09-06','14:50:00',3.65),('325','2013-09-06','14:55:00',3.72),('325','2013-09-06','15:00:00',3.66),('325','2013-09-06','15:05:00',3.59),('325','2013-09-06','15:10:00',3.5),('325','2013-09-06','15:15:00',3.48),('325','2013-09-06','15:20:00',3.46),('325','2013-09-06','15:25:00',3.4),('325','2013-09-06','15:30:00',3.33),('325','2013-09-06','15:35:00',3.21),('325','2013-09-06','15:40:00',3.21),('325','2013-09-06','15:45:00',3.18),('325','2013-09-06','15:50:00',3.12),('325','2013-09-06','15:55:00',3.06),('325','2013-09-06','16:00:00',2.97),('325','2013-09-06','16:05:00',2.9),('325','2013-09-06','16:10:00',2.83),('325','2013-09-06','16:15:00',2.76),('325','2013-09-06','16:20:00',2.69),('325','2013-09-06','16:25:00',2.64),('325','2013-09-06','16:30:00',2.59),('325','2013-09-06','16:35:00',2.5),('325','2013-09-06','16:40:00',2.39),('325','2013-09-06','16:45:00',2.22),('325','2013-09-06','16:50:00',2.22),('325','2013-09-06','16:55:00',2.11),('325','2013-09-06','17:00:00',2.05),('325','2013-09-06','17:05:00',1.93),('325','2013-09-06','17:10:00',1.83),('325','2013-09-06','17:15:00',1.78),('325','2013-09-06','17:20:00',1.66),('325','2013-09-06','17:25:00',1.52),('325','2013-09-06','17:30:00',1.43),('325','2013-09-06','17:35:00',1.35),('325','2013-09-06','17:40:00',1.29),('325','2013-09-06','17:45:00',1.19),('325','2013-09-06','17:50:00',1.08),('325','2013-09-05','08:50:00',1),('325','2013-09-05','08:55:00',1.05),('325','2013-09-05','09:00:00',1.08),('325','2013-09-05','09:05:00',1.12),('325','2013-09-05','09:10:00',1.18),('325','2013-09-05','09:15:00',1.24),('325','2013-09-05','09:20:00',1.27),('325','2013-09-05','09:25:00',1.3),('325','2013-09-05','09:30:00',1.34),('325','2013-09-05','09:35:00',1.37),('325','2013-09-05','09:40:00',1.38),('325','2013-09-05','09:45:00',1.41),('325','2013-09-05','09:50:00',1.45),('325','2013-09-05','09:55:00',1.51),('325','2013-09-05','10:00:00',1.56),('325','2013-09-05','10:05:00',1.62),('325','2013-09-05','10:10:00',1.67),('325','2013-09-05','10:15:00',2.84),('325','2013-09-05','10:20:00',3.03),('325','2013-09-05','10:25:00',3.1),('325','2013-09-05','10:30:00',3.16),('325','2013-09-05','10:35:00',3.24),('325','2013-09-05','10:40:00',3.33),('325','2013-09-05','10:45:00',3.41),('325','2013-09-05','10:50:00',3.46),('325','2013-09-05','10:55:00',3.56),('325','2013-09-05','11:00:00',3.61),('325','2013-09-05','11:05:00',3.66),('325','2013-09-05','11:10:00',3.69),('325','2013-09-05','11:15:00',3.71),('325','2013-09-05','11:20:00',3.72),('325','2013-09-05','11:25:00',3.82),('325','2013-09-05','11:30:00',3.79),('325','2013-09-05','11:35:00',3.77),('325','2013-09-05','11:40:00',3.8),('325','2013-09-05','11:45:00',3.82),('325','2013-09-05','11:50:00',3.88),('325','2013-09-05','11:55:00',3.99),('325','2013-09-05','12:00:00',3.99),('325','2013-09-05','12:05:00',4.03),('325','2013-09-05','12:10:00',4.07),('325','2013-09-05','12:15:00',4.09),('325','2013-09-05','12:20:00',4.1),('325','2013-09-05','12:25:00',4.13),('325','2013-09-05','12:30:00',4.13),('325','2013-09-05','12:35:00',4.15),('325','2013-09-05','12:40:00',4.14),('325','2013-09-05','12:45:00',4.18),('325','2013-09-05','12:50:00',4.2),('325','2013-09-05','12:55:00',4.18),('325','2013-09-05','13:00:00',4.15),('325','2013-09-05','13:05:00',4.16),('325','2013-09-05','13:10:00',4.16),('325','2013-09-05','13:15:00',4.14),('325','2013-09-05','13:20:00',4.15),('325','2013-09-05','13:25:00',4.17),('325','2013-09-05','13:30:00',4.15),('325','2013-09-05','13:35:00',4.11),('325','2013-09-05','13:40:00',4.08),('325','2013-09-05','13:45:00',4.03),('325','2013-09-05','13:50:00',4.01),('325','2013-09-05','13:55:00',4.04),('325','2013-09-05','14:00:00',4.05),('325','2013-09-05','14:05:00',4.06),('325','2013-09-05','14:10:00',4.07),('325','2013-09-05','14:15:00',4.02),('325','2013-09-05','14:20:00',3.95),('325','2013-09-05','14:25:00',3.91),('325','2013-09-05','14:30:00',3.88),('325','2013-09-05','14:35:00',3.82),('325','2013-09-05','14:40:00',3.83),('325','2013-09-05','14:45:00',3.8),('325','2013-09-05','14:50:00',3.78),('325','2013-09-05','14:55:00',3.78),('325','2013-09-05','15:00:00',3.77),('325','2013-09-05','15:05:00',3.75),('325','2013-09-05','15:10:00',3.65),('325','2013-09-05','15:15:00',3.63),('325','2013-09-05','15:20:00',3.58),('325','2013-09-05','15:25:00',3.51),('325','2013-09-05','15:30:00',3.45),('325','2013-09-05','15:35:00',3.41),('325','2013-09-05','15:40:00',3.35),('325','2013-09-05','15:45:00',3.29),('325','2013-09-05','15:50:00',3.24),('325','2013-09-05','15:55:00',3.2),('325','2013-09-05','16:00:00',3.12),('325','2013-09-05','16:05:00',3.07),('325','2013-09-05','16:10:00',3),('325','2013-09-05','16:15:00',2.93),('325','2013-09-05','16:20:00',2.86),('325','2013-09-05','16:25:00',2.79),('325','2013-09-05','16:30:00',2.75),('325','2013-09-05','16:35:00',2.72),('325','2013-09-05','16:40:00',2.62),('325','2013-09-05','16:45:00',2.51),('325','2013-09-05','16:50:00',2.15),('325','2013-09-05','16:55:00',1.74),('325','2013-09-05','17:00:00',1.39),('325','2013-09-05','17:05:00',1.52),('325','2013-09-05','17:10:00',1.52),('325','2013-09-05','17:15:00',1.34),('325','2013-09-05','17:20:00',1.5),('325','2013-09-05','17:25:00',1.49),('325','2013-09-05','17:30:00',1.41),('325','2013-09-05','17:35:00',1.51),('325','2013-09-05','17:40:00',1.61),('325','2013-09-05','17:45:00',1.4),('325','2013-09-05','17:50:00',1.29),('325','2013-09-05','17:55:00',1.08),('325','2013-09-04','08:55:00',1.03),('325','2013-09-04','09:00:00',1.08),('325','2013-09-04','09:05:00',1.11),('325','2013-09-04','09:10:00',1.16),('325','2013-09-04','09:15:00',1.23),('325','2013-09-04','09:20:00',1.27),('325','2013-09-04','09:25:00',1.3),('325','2013-09-04','09:30:00',1.33),('325','2013-09-04','09:35:00',1.36),('325','2013-09-04','09:40:00',1.37),('325','2013-09-04','09:45:00',1.46),('325','2013-09-04','09:50:00',1.54),('325','2013-09-04','09:55:00',1.6),('325','2013-09-04','10:00:00',1.63),('325','2013-09-04','10:05:00',1.66),('325','2013-09-04','10:10:00',1.69),('325','2013-09-04','10:15:00',2.44),('325','2013-09-04','10:20:00',3.09),('325','2013-09-04','10:25:00',3.15),('325','2013-09-04','10:30:00',3.21),('325','2013-09-04','10:35:00',3.31),('325','2013-09-04','10:40:00',3.43),('325','2013-09-04','10:45:00',3.5),('325','2013-09-04','10:50:00',3.59),('325','2013-09-04','10:55:00',3.67),('325','2013-09-04','11:00:00',3.72),('325','2013-09-04','11:05:00',3.76),('325','2013-09-04','11:10:00',3.8),('325','2013-09-04','11:15:00',3.83),('325','2013-09-04','11:20:00',3.88),('325','2013-09-04','11:25:00',3.92),('325','2013-09-04','11:30:00',3.96),('325','2013-09-04','11:35:00',3.98),('325','2013-09-04','11:40:00',4.01),('325','2013-09-04','11:45:00',4.05),('325','2013-09-04','11:50:00',4.09),('325','2013-09-04','11:55:00',4.16),('325','2013-09-04','12:00:00',4.19),('325','2013-09-04','12:05:00',4.19),('325','2013-09-04','12:10:00',4.21),('325','2013-09-04','12:15:00',4.2),('325','2013-09-04','12:20:00',4.22),('325','2013-09-04','12:25:00',4.26),('325','2013-09-04','12:30:00',4.26),('325','2013-09-04','12:35:00',4.28),('325','2013-09-04','12:40:00',4.3),('325','2013-09-04','12:45:00',4.29),('325','2013-09-04','12:50:00',4.28),('325','2013-09-04','12:55:00',4.29),('325','2013-09-04','13:00:00',4.29),('325','2013-09-04','13:05:00',4.27),('325','2013-09-04','13:10:00',4.28),('325','2013-09-04','13:15:00',4.29),('325','2013-09-04','13:20:00',4.27),('325','2013-09-04','13:25:00',4.27),('325','2013-09-04','13:30:00',4.27),('325','2013-09-04','13:35:00',4.27),('325','2013-09-04','13:40:00',4.26),('325','2013-09-04','13:45:00',4.22),('325','2013-09-04','13:50:00',4.18),('325','2013-09-04','13:55:00',4.17),('325','2013-09-04','14:00:00',4.15),('325','2013-09-04','14:05:00',4.15),('325','2013-09-04','14:10:00',4.15),('325','2013-09-04','14:15:00',4.13),('325','2013-09-04','14:20:00',4.09),('325','2013-09-04','14:25:00',4.08),('325','2013-09-04','14:30:00',4.05),('325','2013-09-04','14:35:00',4.01),('325','2013-09-04','14:40:00',3.96),('325','2013-09-04','14:45:00',3.94),('325','2013-09-04','14:50:00',3.91),('325','2013-09-04','14:55:00',3.87),('325','2013-09-04','15:00:00',3.82),('325','2013-09-04','15:05:00',3.77),('325','2013-09-04','15:10:00',3.72),('325','2013-09-04','15:15:00',3.67),('325','2013-09-04','15:20:00',3.64),('325','2013-09-04','15:25:00',3.58),('325','2013-09-04','15:30:00',3.53),('325','2013-09-04','15:35:00',3.47),('325','2013-09-04','15:40:00',3.42),('325','2013-09-04','15:45:00',3.36),('325','2013-09-04','15:50:00',3.3),('325','2013-09-04','15:55:00',3.22),('325','2013-09-04','16:00:00',3.14),('325','2013-09-04','16:05:00',3.06),('325','2013-09-04','16:10:00',2.99),('325','2013-09-04','16:15:00',2.94),('325','2013-09-04','16:20:00',2.87),('325','2013-09-04','16:25:00',2.78),('325','2013-09-04','16:30:00',2.71),('325','2013-09-04','16:35:00',2.64),('325','2013-09-04','16:40:00',2.54),('325','2013-09-04','16:45:00',2.37),('325','2013-09-04','16:50:00',2.28),('325','2013-09-04','16:55:00',2.26),('325','2013-09-04','17:00:00',2.17),('325','2013-09-04','17:05:00',2.08),('325','2013-09-04','17:10:00',2),('325','2013-09-04','17:15:00',1.91),('325','2013-09-04','17:20:00',1.82),('325','2013-09-04','17:25:00',1.7),('325','2013-09-04','17:30:00',1.61),('325','2013-09-04','17:35:00',1.51),('325','2013-09-04','17:40:00',1.4),('325','2013-09-04','17:45:00',1.29),('325','2013-09-04','17:50:00',1.19),('325','2013-09-04','17:55:00',1.1),('325','2013-09-04','18:00:00',1),('325','2013-09-03','08:55:00',1.01),('325','2013-09-03','09:00:00',1.05),('325','2013-09-03','09:05:00',1.1),('325','2013-09-03','09:10:00',1.13),('325','2013-09-03','09:15:00',1.19),('325','2013-09-03','09:20:00',1.24),('325','2013-09-03','09:25:00',1.31),('325','2013-09-03','09:30:00',1.38),('325','2013-09-03','09:35:00',1.41),('325','2013-09-03','09:40:00',1.44),('325','2013-09-03','09:45:00',1.48),('325','2013-09-03','09:50:00',1.57),('325','2013-09-03','09:55:00',1.63),('325','2013-09-03','10:00:00',1.67),('325','2013-09-03','10:05:00',1.7),('325','2013-09-03','10:10:00',2.4),('325','2013-09-03','10:15:00',2.83),('325','2013-09-03','10:20:00',2.96),('325','2013-09-03','10:25:00',3.01),('325','2013-09-03','10:30:00',3.06),('325','2013-09-03','10:35:00',3.18),('325','2013-09-03','10:40:00',3.31),('325','2013-09-03','10:45:00',3.4),('325','2013-09-03','10:50:00',3.49),('325','2013-09-03','10:55:00',3.54),('325','2013-09-03','11:00:00',3.57),('325','2013-09-03','11:05:00',3.6),('325','2013-09-03','11:10:00',3.63),('325','2013-09-03','11:15:00',3.67),('325','2013-09-03','11:20:00',3.72),('325','2013-09-03','11:25:00',3.76),('325','2013-09-03','11:30:00',3.8),('325','2013-09-03','11:35:00',3.83),('325','2013-09-03','11:40:00',3.85),('325','2013-09-03','11:45:00',3.87),('325','2013-09-03','11:50:00',3.91),('325','2013-09-03','11:55:00',4),('325','2013-09-03','12:00:00',4.03),('325','2013-09-03','12:05:00',4.06),('325','2013-09-03','12:10:00',4.07),('325','2013-09-03','12:15:00',4.09),('325','2013-09-03','12:20:00',4.12),('325','2013-09-03','12:25:00',4.16),('325','2013-09-03','12:30:00',4.18),('325','2013-09-03','12:35:00',4.19),('325','2013-09-03','12:40:00',4.2),('325','2013-09-03','12:45:00',4.21),('325','2013-09-03','12:50:00',4.2),('325','2013-09-03','12:55:00',4.2),('325','2013-09-03','13:00:00',4.21),('325','2013-09-03','13:05:00',4.2),('325','2013-09-03','13:10:00',4.2),('325','2013-09-03','13:15:00',4.21),('325','2013-09-03','13:20:00',4.24),('325','2013-09-03','13:25:00',4.18),('325','2013-09-03','13:30:00',4.15),('325','2013-09-03','13:35:00',4.15),('325','2013-09-03','13:40:00',4.18),('325','2013-09-03','13:45:00',4.11),('325','2013-09-03','13:50:00',4.14),('325','2013-09-03','13:55:00',4.15),('325','2013-09-03','14:00:00',4.1),('325','2013-09-03','14:05:00',4.01),('325','2013-09-03','14:10:00',4.02),('325','2013-09-03','14:15:00',3.99),('325','2013-09-03','14:20:00',3.97),('325','2013-09-03','14:25:00',3.94),('325','2013-09-03','14:30:00',3.92),('325','2013-09-03','14:35:00',3.93),('325','2013-09-03','14:40:00',3.92),('325','2013-09-03','14:45:00',3.87),('325','2013-09-03','14:50:00',3.85),('325','2013-09-03','14:55:00',3.82),('325','2013-09-03','15:00:00',3.78),('325','2013-09-03','15:05:00',3.7),('325','2013-09-03','15:10:00',3.64),('325','2013-09-03','15:15:00',3.62),('325','2013-09-03','15:20:00',3.58),('325','2013-09-03','15:25:00',3.53),('325','2013-09-03','15:30:00',3.48),('325','2013-09-03','15:35:00',3.39),('325','2013-09-03','15:40:00',3.32),('325','2013-09-03','15:45:00',3.25),('325','2013-09-03','15:50:00',3.22),('325','2013-09-03','15:55:00',3.17),('325','2013-09-03','16:00:00',3.12),('325','2013-09-03','16:05:00',3.07),('325','2013-09-03','16:10:00',3),('325','2013-09-03','16:15:00',2.9),('325','2013-09-03','16:20:00',2.82),('325','2013-09-03','16:25:00',2.75),('325','2013-09-03','16:30:00',2.69),('325','2013-09-03','16:35:00',2.62),('325','2013-09-03','16:40:00',2.53),('325','2013-09-03','16:45:00',2.39),('325','2013-09-03','16:50:00',2.3),('325','2013-09-03','16:55:00',2.27),('325','2013-09-03','17:00:00',2.19),('325','2013-09-03','17:05:00',2.08),('325','2013-09-03','17:10:00',2),('325','2013-09-03','17:15:00',1.91),('325','2013-09-03','17:20:00',1.82),('325','2013-09-03','17:25:00',1.72),('325','2013-09-03','17:30:00',1.61),('325','2013-09-03','17:35:00',1.53),('325','2013-09-03','17:40:00',1.43),('325','2013-09-03','17:45:00',1.34),('325','2013-09-03','17:50:00',1.24),('325','2013-09-03','17:55:00',1.09),('325','2013-09-02','08:55:00',1.01),('325','2013-09-02','09:00:00',1.05),('325','2013-09-02','09:05:00',1.1),('325','2013-09-02','09:10:00',1.27),('325','2013-09-02','09:15:00',1.23),('325','2013-09-02','09:20:00',1.24),('325','2013-09-02','09:25:00',1.3),('325','2013-09-02','09:30:00',1.36),('325','2013-09-02','09:35:00',1.41),('325','2013-09-02','09:40:00',1.44),('325','2013-09-02','09:45:00',1.47),('325','2013-09-02','09:50:00',1.52),('325','2013-09-02','09:55:00',1.57),('325','2013-09-02','10:00:00',1.62),('325','2013-09-02','10:05:00',2.38),('325','2013-09-02','10:10:00',2.79),('325','2013-09-02','10:15:00',2.91),('325','2013-09-02','10:20:00',3),('325','2013-09-02','10:25:00',3.05),('325','2013-09-02','10:30:00',3.11),('325','2013-09-02','10:35:00',3.21),('325','2013-09-02','10:40:00',3.29),('325','2013-09-02','10:45:00',3.38),('325','2013-09-02','10:50:00',3.48),('325','2013-09-02','10:55:00',3.54),('325','2013-09-02','11:00:00',3.57),('325','2013-09-02','11:05:00',3.61),('325','2013-09-02','11:10:00',3.65),('325','2013-09-02','11:15:00',3.7),('325','2013-09-02','11:20:00',3.71),('325','2013-09-02','11:25:00',3.75),('325','2013-09-02','11:30:00',3.81),('325','2013-09-02','11:35:00',3.84),('325','2013-09-02','11:40:00',3.87),('325','2013-09-02','11:45:00',3.87),('325','2013-09-02','11:50:00',3.89),('325','2013-09-02','11:55:00',3.95),('325','2013-09-02','12:00:00',3.97),('325','2013-09-02','12:05:00',3.99),('325','2013-09-02','12:10:00',4.05),('325','2013-09-02','12:15:00',4.09),('325','2013-09-02','12:20:00',4.07),('325','2013-09-02','12:25:00',4.07),('325','2013-09-02','12:30:00',4.03),('325','2013-09-02','12:35:00',4.07),('325','2013-09-02','12:40:00',4.08),('325','2013-09-02','12:45:00',4.08),('325','2013-09-02','12:50:00',4.14),('325','2013-09-02','12:55:00',4.15),('325','2013-09-02','13:00:00',4.15),('325','2013-09-02','13:05:00',4.13),('325','2013-09-02','13:10:00',4.15),('325','2013-09-02','13:15:00',4.14),('325','2013-09-02','13:20:00',4.1),('325','2013-09-02','13:25:00',4.1),('325','2013-09-02','13:30:00',4.06),('325','2013-09-02','13:35:00',4.01),('325','2013-09-02','13:40:00',4.04),('325','2013-09-02','13:45:00',4.12),('325','2013-09-02','13:50:00',3.61),('325','2013-09-02','13:55:00',1.41),('325','2013-09-02','14:00:00',4.3),('325','2013-09-02','14:05:00',4.25),('325','2013-09-02','14:10:00',4.14),('325','2013-09-02','14:15:00',4.08),('325','2013-09-02','14:20:00',3.36),('325','2013-09-02','14:25:00',4.01),('325','2013-09-02','14:30:00',4.01),('325','2013-09-02','14:35:00',3.91),('325','2013-09-02','14:40:00',3.93),('325','2013-09-02','14:45:00',4.02),('325','2013-09-02','14:50:00',3.17),('325','2013-09-02','14:55:00',1.43),('325','2013-09-02','15:00:00',2.82),('325','2013-09-02','15:05:00',2.94),('325','2013-09-02','15:10:00',1.17),('325','2013-09-02','15:15:00',1.46),('325','2013-09-02','15:20:00',1.39),('325','2013-09-02','15:25:00',2.32),('325','2013-09-02','15:30:00',3.62),('325','2013-09-02','15:35:00',3.56),('325','2013-09-02','15:40:00',3.25),('325','2013-09-02','15:45:00',3.26),('325','2013-09-02','15:50:00',3.31),('325','2013-09-02','15:55:00',3.25),('325','2013-09-02','16:00:00',3.19),('325','2013-09-02','16:05:00',3.09),('325','2013-09-02','16:10:00',3.04),('325','2013-09-02','16:15:00',3),('325','2013-09-02','16:20:00',2.93),('325','2013-09-02','16:25:00',2.81),('325','2013-09-02','16:30:00',2.72),('325','2013-09-02','16:35:00',2.64),('325','2013-09-02','16:40:00',2.55),('325','2013-09-02','16:45:00',2.39),('325','2013-09-02','16:50:00',2.26),('325','2013-09-02','16:55:00',2.19),('325','2013-09-02','17:00:00',2.11),('325','2013-09-02','17:05:00',2.01),('325','2013-09-02','17:10:00',1.93),('325','2013-09-02','17:15:00',1.85),('325','2013-09-02','17:20:00',1.77),('325','2013-09-02','17:25:00',1.69),('325','2013-09-02','17:30:00',1.56),('325','2013-09-02','17:35:00',1.48),('325','2013-09-02','17:40:00',1.39),('325','2013-09-02','17:45:00',1.31),('325','2013-09-02','17:50:00',1.21),('325','2013-09-02','17:55:00',1.12),('325','2013-09-02','18:00:00',1.04),('325','2013-09-01','08:55:00',1.04),('325','2013-09-01','09:00:00',1.1),('325','2013-09-01','09:05:00',1.25),('325','2013-09-01','09:10:00',1.49),('325','2013-09-01','09:15:00',1.48),('325','2013-09-01','09:20:00',1.42),('325','2013-09-01','09:25:00',1.77),('325','2013-09-01','09:30:00',2.05),('325','2013-09-01','09:35:00',2.15),('325','2013-09-01','09:40:00',2.23),('325','2013-09-01','09:45:00',2.32),('325','2013-09-01','09:50:00',2.44),('325','2013-09-01','09:55:00',2.55),('325','2013-09-01','10:00:00',2.63),('325','2013-09-01','10:05:00',2.73),('325','2013-09-01','10:10:00',2.84),('325','2013-09-01','10:15:00',2.93),('325','2013-09-01','10:20:00',2.99),('325','2013-09-01','10:25:00',3.05),('325','2013-09-01','10:30:00',3.1),('325','2013-09-01','10:35:00',3.21),('325','2013-09-01','10:40:00',3.29),('325','2013-09-01','10:45:00',3.36),('325','2013-09-01','10:50:00',3.46),('325','2013-09-01','10:55:00',3.57),('325','2013-09-01','11:00:00',3.62),('325','2013-09-01','11:05:00',3.66),('325','2013-09-01','11:10:00',3.69),('325','2013-09-01','11:15:00',3.7),('325','2013-09-01','11:20:00',3.71),('325','2013-09-01','11:25:00',3.78),('325','2013-09-01','11:30:00',3.82),('325','2013-09-01','11:35:00',3.84),('325','2013-09-01','11:40:00',3.89),('325','2013-09-01','11:45:00',3.95),('325','2013-09-01','11:50:00',3.97),('325','2013-09-01','11:55:00',4.01),('325','2013-09-01','12:00:00',4.02),('325','2013-09-01','12:05:00',3.96),('325','2013-09-01','12:10:00',4.05),('325','2013-09-01','12:15:00',4.1),('325','2013-09-01','12:20:00',4.13),('325','2013-09-01','12:25:00',4),('325','2013-09-01','12:30:00',4.14),('325','2013-09-01','12:35:00',4.13),('325','2013-09-01','12:40:00',4.15),('325','2013-09-01','12:45:00',4.14),('325','2013-09-01','12:50:00',4.18),('325','2013-09-01','12:55:00',4.18),('325','2013-09-01','13:00:00',4.27),('325','2013-09-01','13:05:00',4.16),('325','2013-09-01','13:10:00',4.23),('325','2013-09-01','13:15:00',4.08),('325','2013-09-01','13:20:00',4.25),('325','2013-09-01','13:25:00',4.22),('325','2013-09-01','13:30:00',4.27),('325','2013-09-01','13:35:00',4.17),('325','2013-09-01','13:40:00',4.18),('325','2013-09-01','13:45:00',3.92),('325','2013-09-01','13:50:00',3.45),('325','2013-09-01','13:55:00',3.66),('325','2013-09-01','14:00:00',3.27),('325','2013-09-01','14:05:00',3.37),('325','2013-09-01','14:10:00',3.8),('325','2013-09-01','14:15:00',3.66),('325','2013-09-01','14:20:00',3.42),('325','2013-09-01','14:25:00',3.51),('325','2013-09-01','14:30:00',3.51),('325','2013-09-01','14:35:00',3.51),('325','2013-09-01','14:40:00',3.54),('325','2013-09-01','14:45:00',3.59),('325','2013-09-01','14:50:00',3.54),('325','2013-09-01','14:55:00',3.42),('325','2013-09-01','15:00:00',3.47),('325','2013-09-01','15:05:00',3.38),('325','2013-09-01','15:10:00',3.44),('325','2013-09-01','15:15:00',3.36),('325','2013-09-01','15:20:00',3.21),('325','2013-09-01','15:25:00',2.72),('325','2013-09-01','15:30:00',2.47),('325','2013-09-01','15:35:00',2.62),('325','2013-09-01','15:40:00',3.05),('325','2013-09-01','15:45:00',2.8),('325','2013-09-01','15:50:00',2.11),('325','2013-09-01','15:55:00',2.34),('325','2013-09-01','16:00:00',2.84),('325','2013-09-01','16:05:00',3),('325','2013-09-01','16:10:00',2.93),('325','2013-09-01','16:15:00',2.92),('325','2013-09-01','16:20:00',2.63),('325','2013-09-01','16:25:00',2.78),('325','2013-09-01','16:30:00',2.93),('325','2013-09-01','16:35:00',2.84),('325','2013-09-01','16:40:00',2.68),('325','2013-09-01','16:45:00',2.42),('325','2013-09-01','16:50:00',2.31),('325','2013-09-01','16:55:00',2.04),('325','2013-09-01','17:00:00',1.73),('325','2013-09-01','17:05:00',1.82),('325','2013-09-01','17:10:00',1.43),('325','2013-09-01','17:15:00',1.52),('325','2013-09-01','17:20:00',1.63),('325','2013-09-01','17:25:00',1.56),('325','2013-09-01','17:30:00',1.34),('325','2013-09-01','17:35:00',1.35),('325','2013-09-01','17:40:00',1.41),('325','2013-09-01','17:45:00',1.17),('325','2013-09-01','17:50:00',1.04),('325','2013-09-01','17:55:00',1.02),('325','2013-09-01','18:00:00',1.01),('325','2013-09-01','18:05:00',1),('325','2013-09-01','18:10:00',1.04),('325','2013-08-31','08:45:00',1.01),('325','2013-08-31','08:50:00',1.15),('325','2013-08-31','08:55:00',1.29),('325','2013-08-31','09:00:00',1.38),('325','2013-08-31','09:05:00',1.52),('325','2013-08-31','09:10:00',1.32),('325','2013-08-31','09:15:00',1.52),('325','2013-08-31','09:20:00',1.51),('325','2013-08-31','09:25:00',1.87),('325','2013-08-31','09:30:00',2.14),('325','2013-08-31','09:35:00',2.29),('325','2013-08-31','09:40:00',2.33),('325','2013-08-31','09:45:00',2.25),('325','2013-08-31','09:50:00',2.32),('325','2013-08-31','09:55:00',2.55),('325','2013-08-31','10:00:00',2.74),('325','2013-08-31','10:05:00',2.8),('325','2013-08-31','10:10:00',2.93),('325','2013-08-31','10:15:00',3),('325','2013-08-31','10:20:00',3.05),('325','2013-08-31','10:25:00',3.11),('325','2013-08-31','10:30:00',3.18),('325','2013-08-31','10:35:00',3.29),('325','2013-08-31','10:40:00',3.41),('325','2013-08-31','10:45:00',3.5),('325','2013-08-31','10:50:00',3.63),('325','2013-08-31','10:55:00',3.72),('325','2013-08-31','11:00:00',3.78),('325','2013-08-31','11:05:00',3.8),('325','2013-08-31','11:10:00',3.82),('325','2013-08-31','11:15:00',3.86),('325','2013-08-31','11:20:00',3.9),('325','2013-08-31','11:25:00',3.93),('325','2013-08-31','11:30:00',4.01),('325','2013-08-31','11:35:00',4.07),('325','2013-08-31','11:40:00',4.11),('325','2013-08-31','11:45:00',4.14),('325','2013-08-31','11:50:00',4.18),('325','2013-08-31','11:55:00',4.23),('325','2013-08-31','12:00:00',4.11),('325','2013-08-31','12:05:00',3.84),('325','2013-08-31','12:10:00',3.5),('325','2013-08-31','12:15:00',4),('325','2013-08-31','12:20:00',4.27),('325','2013-08-31','12:25:00',4.21),('325','2013-08-31','12:30:00',4.26),('325','2013-08-31','12:35:00',4.28),('325','2013-08-31','12:40:00',4.28),('325','2013-08-31','12:45:00',4.28),('325','2013-08-31','12:50:00',4.25),('325','2013-08-31','12:55:00',4.28),('325','2013-08-31','13:00:00',4.26),('325','2013-08-31','13:05:00',4.3),('325','2013-08-31','13:10:00',4.25),('325','2013-08-31','13:15:00',4.3),('325','2013-08-31','13:20:00',4.24),('325','2013-08-31','13:25:00',4.22),('325','2013-08-31','13:30:00',4.27),('325','2013-08-31','13:35:00',4.23),('325','2013-08-31','13:40:00',4.21),('325','2013-08-31','13:45:00',4.15),('325','2013-08-31','13:50:00',4.19),('325','2013-08-31','13:55:00',4.17),('325','2013-08-31','14:00:00',4.15),('325','2013-08-31','14:05:00',4.14),('325','2013-08-31','14:10:00',4.1),('325','2013-08-31','14:15:00',4.06),('325','2013-08-31','14:20:00',4.03),('325','2013-08-31','14:25:00',3.98),('325','2013-08-31','14:30:00',3.93),('325','2013-08-31','14:35:00',3.77),('325','2013-08-31','14:40:00',3.83),('325','2013-08-31','14:45:00',3.83),('325','2013-08-31','14:50:00',3.82),('325','2013-08-31','14:55:00',3.72),('325','2013-08-31','15:00:00',3.71),('325','2013-08-31','15:05:00',3.67),('325','2013-08-31','15:10:00',3.64),('325','2013-08-31','15:15:00',3.58),('325','2013-08-31','15:20:00',3.53),('325','2013-08-31','15:25:00',3.48),('325','2013-08-31','15:30:00',3.44),('325','2013-08-31','15:35:00',3.34),('325','2013-08-31','15:40:00',3.31),('325','2013-08-31','15:45:00',3.25),('325','2013-08-31','15:50:00',3.18),('325','2013-08-31','15:55:00',3.11),('325','2013-08-31','16:00:00',3.08),('325','2013-08-31','16:05:00',3.02),('325','2013-08-31','16:10:00',2.97),('325','2013-08-31','16:15:00',2.89),('325','2013-08-31','16:20:00',2.85),('325','2013-08-31','16:25:00',2.73),('325','2013-08-31','16:30:00',2.68),('325','2013-08-31','16:35:00',2.66),('325','2013-08-31','16:40:00',2.55),('325','2013-08-31','16:45:00',2.39),('325','2013-08-31','16:50:00',2.24),('325','2013-08-31','16:55:00',2.21),('325','2013-08-31','17:00:00',2.13),('325','2013-08-31','17:05:00',2.1),('325','2013-08-31','17:10:00',2.01),('325','2013-08-31','17:15:00',1.91),('325','2013-08-31','17:20:00',1.85),('325','2013-08-31','17:25:00',1.75),('325','2013-08-31','17:30:00',1.62),('325','2013-08-31','17:35:00',1.48),('325','2013-08-31','17:40:00',1.43),('325','2013-08-31','17:45:00',1.3),('325','2013-08-31','17:50:00',1.23),('325','2013-08-31','17:55:00',1.05),('325','2013-08-30','08:25:00',1.02),('325','2013-08-30','08:30:00',1.09),('325','2013-08-30','08:35:00',1.21),('325','2013-08-30','08:40:00',1.26),('325','2013-08-30','08:45:00',1.18),('325','2013-08-30','08:50:00',1.12),('325','2013-08-30','08:55:00',1.15),('325','2013-08-30','09:00:00',1.33),('325','2013-08-30','09:05:00',1.45),('325','2013-08-30','09:10:00',1.34),('325','2013-08-30','09:15:00',1.26),('325','2013-08-30','09:20:00',1.15),('325','2013-08-30','09:25:00',1.23),('325','2013-08-30','09:30:00',1.49),('325','2013-08-30','09:35:00',1.62),('325','2013-08-30','09:40:00',1.57),('325','2013-08-30','09:45:00',1.6),('325','2013-08-30','09:50:00',1.65),('325','2013-08-30','09:55:00',1.73),('325','2013-08-30','10:00:00',1.78),('325','2013-08-30','10:05:00',1.79),('325','2013-08-30','10:10:00',1.8),('325','2013-08-30','10:15:00',1.92),('325','2013-08-30','10:20:00',1.97),('325','2013-08-30','10:25:00',1.9),('325','2013-08-30','10:30:00',2.06),('325','2013-08-30','10:35:00',2.03),('325','2013-08-30','10:40:00',1.99),('325','2013-08-30','10:45:00',2),('325','2013-08-30','10:50:00',2.14),('325','2013-08-30','10:55:00',2.03),('325','2013-08-30','11:00:00',2.15),('325','2013-08-30','11:05:00',2.27),('325','2013-08-30','11:10:00',2.42),('325','2013-08-30','11:15:00',2.42),('325','2013-08-30','11:20:00',2.45),('325','2013-08-30','11:25:00',2.52),('325','2013-08-30','11:30:00',2.69),('325','2013-08-30','11:35:00',2.54),('325','2013-08-30','11:40:00',2.8),('325','2013-08-30','11:45:00',2.8),('325','2013-08-30','11:50:00',3.18),('325','2013-08-30','11:55:00',2.77),('325','2013-08-30','12:00:00',2.45),('325','2013-08-30','12:05:00',2.11),('325','2013-08-30','12:10:00',2.34),('325','2013-08-30','12:15:00',2.58),('325','2013-08-30','12:20:00',2.78),('325','2013-08-30','12:25:00',3.19),('325','2013-08-30','12:30:00',3.53),('325','2013-08-30','12:35:00',3.35),('325','2013-08-30','12:40:00',3.26),('325','2013-08-30','12:45:00',3.39),('325','2013-08-30','12:50:00',3.28),('325','2013-08-30','12:55:00',3.04),('325','2013-08-30','13:00:00',3.01),('325','2013-08-30','13:05:00',2.99),('325','2013-08-30','13:10:00',3),('325','2013-08-30','13:15:00',2.86),('325','2013-08-30','13:20:00',3.5),('325','2013-08-30','13:25:00',3.9),('325','2013-08-30','13:30:00',4.22),('325','2013-08-30','13:35:00',3.92),('325','2013-08-30','13:40:00',4.18),('325','2013-08-30','13:45:00',3.78),('325','2013-08-30','13:50:00',3.81),('325','2013-08-30','13:55:00',4.1),('325','2013-08-30','14:00:00',4.26),('325','2013-08-30','14:05:00',4.07),('325','2013-08-30','14:10:00',4.15),('325','2013-08-30','14:15:00',4.04),('325','2013-08-30','14:20:00',4.18),('325','2013-08-30','14:25:00',4.07),('325','2013-08-30','14:30:00',4.05),('325','2013-08-30','14:35:00',4.12),('325','2013-08-30','14:40:00',3.9),('325','2013-08-30','14:45:00',3.18),('325','2013-08-30','14:50:00',2.8),('325','2013-08-30','14:55:00',3.08),('325','2013-08-30','15:00:00',2.62),('325','2013-08-30','15:05:00',2.43),('325','2013-08-30','15:10:00',2.46),('325','2013-08-30','15:15:00',3.1),('325','2013-08-30','15:20:00',2.6),('325','2013-08-30','15:25:00',2.39),('325','2013-08-30','15:30:00',2.23),('325','2013-08-30','15:35:00',1.85),('325','2013-08-30','15:40:00',2.02),('325','2013-08-30','15:45:00',2.39),('325','2013-08-30','15:50:00',2.54),('325','2013-08-30','15:55:00',2.45),('325','2013-08-30','16:00:00',2.31),('325','2013-08-30','16:05:00',2.01),('325','2013-08-30','16:10:00',1.66),('325','2013-08-30','16:15:00',1.54),('325','2013-08-30','16:20:00',1.79),('325','2013-08-30','16:25:00',1.72),('325','2013-08-30','16:30:00',1.98),('325','2013-08-30','16:35:00',1.61),('325','2013-08-30','16:40:00',2.34),('325','2013-08-30','16:45:00',2.65),('325','2013-08-30','16:50:00',2.45),('325','2013-08-30','16:55:00',1.71),('325','2013-08-30','17:00:00',2.03),('325','2013-08-30','17:05:00',1.41),('325','2013-08-30','17:10:00',1.61),('325','2013-08-30','17:15:00',1.47),('325','2013-08-30','17:20:00',1.26),('325','2013-08-30','17:25:00',1.36),('325','2013-08-30','17:30:00',1.34),('325','2013-08-30','17:35:00',1.57),('325','2013-08-30','17:40:00',1.25),('325','2013-08-30','17:45:00',1.35),('325','2013-08-30','17:50:00',1.21),('325','2013-08-30','17:55:00',1.26),('325','2013-08-30','18:00:00',1.1),('325','2013-08-29','08:30:00',1.23),('325','2013-08-29','08:35:00',1.29),('325','2013-08-29','08:40:00',1.13),('325','2013-08-29','08:45:00',1),('325','2013-08-29','08:50:00',1.17),('325','2013-08-29','08:55:00',1.42),('325','2013-08-29','09:00:00',1.43),('325','2013-08-29','09:05:00',1.45),('325','2013-08-29','09:10:00',1.45),('325','2013-08-29','09:15:00',1.57),('325','2013-08-29','09:20:00',1.54),('325','2013-08-29','09:25:00',1.45),('325','2013-08-29','09:30:00',1.5),('325','2013-08-29','09:35:00',1.62),('325','2013-08-29','09:40:00',1.65),('325','2013-08-29','09:45:00',1.48),('325','2013-08-29','09:50:00',1.46),('325','2013-08-29','09:55:00',1.52),('325','2013-08-29','10:00:00',1.58),('325','2013-08-29','10:05:00',1.53),('325','2013-08-29','10:10:00',1.51),('325','2013-08-29','10:15:00',1.51),('325','2013-08-29','10:20:00',1.54),('325','2013-08-29','10:25:00',1.54),('325','2013-08-29','10:30:00',1.58),('325','2013-08-29','10:35:00',1.48),('325','2013-08-29','10:40:00',1.36),('325','2013-08-29','10:45:00',1.27),('325','2013-08-29','10:50:00',1.27),('325','2013-08-29','10:55:00',1.42),('325','2013-08-29','11:00:00',1.5),('325','2013-08-29','11:05:00',1.53),('325','2013-08-29','11:10:00',2.34),('325','2013-08-29','11:15:00',2.54),('325','2013-08-29','11:20:00',2.34),('325','2013-08-29','11:25:00',1.83),('325','2013-08-29','11:30:00',1.57),('325','2013-08-29','11:35:00',1.41),('325','2013-08-29','11:40:00',1.6),('325','2013-08-29','11:45:00',1.9),('325','2013-08-29','11:50:00',1.97),('325','2013-08-29','11:55:00',1.9),('325','2013-08-29','12:00:00',1.89),('325','2013-08-29','12:05:00',2.22),('325','2013-08-29','12:10:00',2.77),('325','2013-08-29','12:15:00',3.14),('325','2013-08-29','12:20:00',2.85),('325','2013-08-29','12:25:00',2.88),('325','2013-08-29','12:30:00',2.87),('325','2013-08-29','12:35:00',3.54),('325','2013-08-29','12:40:00',4.95),('325','2013-08-29','12:45:00',4.78),('325','2013-08-29','12:50:00',2.62),('325','2013-08-29','12:55:00',3.85),('325','2013-08-29','13:00:00',2.86),('325','2013-08-29','13:05:00',2.67),('325','2013-08-29','13:10:00',2.58),('325','2013-08-29','13:15:00',2.47),('325','2013-08-29','13:20:00',2.38),('325','2013-08-29','13:25:00',2.03),('325','2013-08-29','13:30:00',1.86),('325','2013-08-29','13:35:00',1.72),('325','2013-08-29','13:40:00',1.65),('325','2013-08-29','13:45:00',1.54),('325','2013-08-29','13:50:00',1.52),('325','2013-08-29','13:55:00',1.89),('325','2013-08-29','14:00:00',2.4),('325','2013-08-29','14:05:00',1.72),('325','2013-08-29','14:10:00',1.54),('325','2013-08-29','14:15:00',1.25),('325','2013-08-29','14:20:00',1.03),('325','2013-08-29','14:45:00',1),('325','2013-08-29','14:50:00',1.19),('325','2013-08-29','14:55:00',1.4),('325','2013-08-29','15:00:00',1.57),('325','2013-08-29','15:05:00',1.85),('325','2013-08-29','15:10:00',1.42),('325','2013-08-29','15:15:00',1.23),('325','2013-08-29','15:20:00',1.36),('325','2013-08-29','15:25:00',1.57),('325','2013-08-29','15:30:00',2.72),('325','2013-08-29','15:35:00',2.36),('325','2013-08-29','15:40:00',2.37),('325','2013-08-29','15:45:00',2.52),('325','2013-08-29','15:50:00',3.1),('325','2013-08-29','15:55:00',3.62),('325','2013-08-29','16:00:00',3.19),('325','2013-08-29','16:05:00',3.64),('325','2013-08-29','16:10:00',3.46),('325','2013-08-29','16:15:00',3.23),('325','2013-08-29','16:20:00',3.1),('325','2013-08-29','16:25:00',2.94),('325','2013-08-29','16:30:00',2.84),('325','2013-08-29','16:35:00',2.79),('325','2013-08-29','16:40:00',2.72),('325','2013-08-29','16:45:00',2.62),('325','2013-08-29','16:50:00',2.48),('325','2013-08-29','16:55:00',2.41),('325','2013-08-29','17:00:00',2.36),('325','2013-08-29','17:05:00',2.28),('325','2013-08-29','17:10:00',2.16),('325','2013-08-29','17:15:00',2.07),('325','2013-08-29','17:20:00',1.97),('325','2013-08-29','17:25:00',1.87),('325','2013-08-29','17:30:00',1.78),('325','2013-08-29','17:35:00',1.64),('325','2013-08-29','17:40:00',1.55),('325','2013-08-29','17:45:00',1.45),('325','2013-08-29','17:50:00',1.36),('325','2013-08-29','17:55:00',1.26),('325','2013-08-29','18:00:00',1.16),('325','2013-08-29','18:05:00',1.07),('325','2014-04-10','08:35:00',1.02),('325','2014-04-10','08:40:00',1.09),('325','2014-04-10','08:45:00',1.15),('325','2014-04-10','08:50:00',1.2),('325','2014-04-10','08:55:00',1.26),('325','2014-04-10','09:00:00',1.27),('325','2014-04-10','09:05:00',1.38),('325','2014-04-10','09:10:00',1.57),('325','2014-04-10','09:15:00',1.64),('325','2014-04-10','09:20:00',1.95),('325','2014-04-10','09:25:00',2.29),('325','2014-04-10','09:30:00',2.4),('325','2014-04-10','09:35:00',2.52),('325','2014-04-10','09:40:00',2.58),('325','2014-04-10','09:45:00',2.73),('325','2014-04-10','09:50:00',2.87),('325','2014-04-10','09:55:00',2.99),('325','2014-04-10','10:00:00',3.06),('325','2014-04-10','10:05:00',3.14),('325','2014-04-10','10:10:00',3.27),('325','2014-04-10','10:15:00',3.29),('325','2014-04-10','10:20:00',3.43),('325','2014-04-10','10:25:00',3.49),('325','2014-04-10','10:30:00',3.54),('325','2014-04-10','10:35:00',3.68),('325','2014-04-10','10:40:00',3.76),('325','2014-04-10','10:45:00',3.77),('325','2014-04-10','10:50:00',3.72),('325','2014-04-10','10:55:00',3.88),('325','2014-04-10','11:00:00',3.9),('325','2014-04-10','11:05:00',4.04),('325','2014-04-10','11:10:00',3.96),('325','2014-04-10','11:15:00',4.1),('325','2014-04-10','11:20:00',4.22),('325','2014-04-10','11:25:00',4.3),('325','2014-04-10','11:30:00',4.3),('325','2014-04-10','11:35:00',4.37),('325','2014-04-10','11:40:00',4.18),('325','2014-04-10','11:45:00',4.34),('325','2014-04-10','11:50:00',4.21),('325','2014-04-10','11:55:00',4.44),('325','2014-04-10','12:00:00',4.36),('325','2014-04-10','12:05:00',4.14),('325','2014-04-10','12:10:00',4.34),('325','2014-04-10','12:15:00',4.4),('325','2014-04-10','12:20:00',4.47),('325','2014-04-10','12:25:00',4.19),('325','2014-04-10','12:30:00',4.33),('325','2014-04-10','12:35:00',4.62),('325','2014-04-10','12:40:00',4.4),('325','2014-04-10','12:45:00',4.47),('325','2014-04-10','12:50:00',4.46),('325','2014-04-10','12:55:00',4.43),('325','2014-04-10','13:00:00',4.31),('325','2014-04-10','13:05:00',4.26),('325','2014-04-10','13:10:00',4.44),('325','2014-04-10','13:15:00',4.37),('325','2014-04-10','13:20:00',4.25),('325','2014-04-10','13:25:00',4.56),('325','2014-04-10','13:30:00',4.52),('325','2014-04-10','13:35:00',4.62),('325','2014-04-10','13:40:00',4.35),('325','2014-04-10','13:45:00',4.58),('325','2014-04-10','13:50:00',4.57),('325','2014-04-10','13:55:00',4.54),('325','2014-04-10','14:00:00',4.49),('325','2014-04-10','14:05:00',4.4),('325','2014-04-10','14:10:00',4.36),('325','2014-04-10','14:15:00',4.39),('325','2014-04-10','14:20:00',4.46),('325','2014-04-10','14:25:00',4.41),('325','2014-04-10','14:30:00',4.34),('325','2014-04-10','14:35:00',4.32),('325','2014-04-10','14:40:00',4.28),('325','2014-04-10','14:45:00',3.87),('325','2014-04-10','14:50:00',4.31),('325','2014-04-10','14:55:00',4.23),('325','2014-04-10','15:00:00',4.17),('325','2014-04-10','15:05:00',4.12),('325','2014-04-10','15:10:00',4),('325','2014-04-10','15:15:00',3.98),('325','2014-04-10','15:20:00',3.94),('325','2014-04-10','15:25:00',3.88),('325','2014-04-10','15:30:00',3.58),('325','2014-04-10','15:35:00',3.45),('325','2014-04-10','15:40:00',3.46),('325','2014-04-10','15:45:00',3.54),('325','2014-04-10','15:50:00',3.52),('325','2014-04-10','15:55:00',3.47),('325','2014-04-10','16:00:00',3.4),('325','2014-04-10','16:05:00',3.44),('325','2014-04-10','16:10:00',3.44),('325','2014-04-10','16:15:00',3.5),('325','2014-04-10','16:20:00',3.34),('325','2014-04-10','16:25:00',3.3),('325','2014-04-10','16:30:00',3.26),('325','2014-04-10','16:35:00',3.1),('325','2014-04-10','16:40:00',3.06),('325','2014-04-10','16:45:00',3.02),('325','2014-04-10','16:50:00',2.78),('325','2014-04-10','16:55:00',2.74),('325','2014-04-10','17:00:00',2.61),('325','2014-04-10','17:05:00',2.53),('325','2014-04-10','17:10:00',2.4),('325','2014-04-10','17:15:00',2.26),('325','2014-04-10','17:20:00',2.21),('325','2014-04-10','17:25:00',2.07),('325','2014-04-10','17:30:00',1.91),('325','2014-04-10','17:35:00',1.81),('325','2014-04-10','17:40:00',1.7),('325','2014-04-10','17:45:00',1.6),('325','2014-04-10','17:50:00',1.49),('325','2014-04-10','17:55:00',1.38),('325','2014-04-10','18:00:00',1.27),('325','2014-04-10','18:05:00',1.16),('325','2014-04-10','18:10:00',1.05),('325','2013-08-28','08:40:00',1.15),('325','2013-08-28','08:45:00',1.15),('325','2013-08-28','09:00:00',1.4),('325','2013-08-28','09:10:00',1.16),('325','2013-08-28','09:15:00',1.67),('325','2013-08-28','09:20:00',1.11),('325','2013-08-28','09:30:00',1.2),('325','2013-08-28','09:35:00',1.98),('325','2013-08-28','09:40:00',2.34),('325','2013-08-28','09:45:00',2.47),('325','2013-08-28','09:50:00',2.62),('325','2013-08-28','09:55:00',2.66),('325','2013-08-28','10:00:00',2.68),('325','2013-08-28','10:05:00',2.79),('325','2013-08-28','10:10:00',2.89),('325','2013-08-28','10:15:00',3.14),('325','2013-08-28','10:20:00',3.14),('325','2013-08-28','10:25:00',1.03),('325','2013-08-28','10:30:00',2.85),('325','2013-08-28','10:35:00',1.26),('325','2013-08-28','10:40:00',2.48),('325','2013-08-28','10:45:00',3.57),('325','2013-08-28','10:50:00',3.07),('325','2013-08-28','10:55:00',3.72),('325','2013-08-28','11:00:00',2.29),('325','2013-08-28','11:05:00',3.32),('325','2013-08-28','11:10:00',1.77),('325','2013-08-28','11:15:00',3.1),('325','2013-08-28','11:20:00',4.04),('325','2013-08-28','11:25:00',4.27),('325','2013-08-28','11:30:00',4.31),('325','2013-08-28','11:35:00',4.39),('325','2013-08-28','11:40:00',4.04),('325','2013-08-28','11:45:00',3.15),('325','2013-08-28','11:50:00',3.39),('325','2013-08-28','11:55:00',1.79),('325','2013-08-28','12:00:00',3.85),('325','2013-08-28','12:05:00',2.56),('325','2013-08-28','12:10:00',4.63),('325','2013-08-28','12:15:00',4.57),('325','2013-08-28','12:20:00',4.36),('325','2013-08-28','12:25:00',4.49),('325','2013-08-28','12:30:00',4.43),('325','2013-08-28','12:35:00',4.43),('325','2013-08-28','12:40:00',4.53),('325','2013-08-28','12:45:00',4.61),('325','2013-08-28','12:50:00',4.54),('325','2013-08-28','12:55:00',4.54),('325','2013-08-28','13:00:00',4.65),('325','2013-08-28','13:05:00',4.22),('325','2013-08-28','13:10:00',4.64),('325','2013-08-28','13:15:00',4.61),('325','2013-08-28','13:20:00',4.6),('325','2013-08-28','13:25:00',4.64),('325','2013-08-28','13:30:00',4.65),('325','2013-08-28','13:35:00',4.48),('325','2013-08-28','13:40:00',3.73),('325','2013-08-28','13:45:00',3.52),('325','2013-08-28','13:50:00',4.57),('325','2013-08-28','13:55:00',4.28),('325','2013-08-28','14:00:00',4.54),('325','2013-08-28','14:05:00',4.47),('325','2013-08-28','14:10:00',4.47),('325','2013-08-28','14:15:00',4.42),('325','2013-08-28','14:20:00',4.36),('325','2013-08-28','14:25:00',4.37),('325','2013-08-28','14:30:00',3.58),('325','2013-08-28','14:35:00',3.74),('325','2013-08-28','14:40:00',4.36),('325','2013-08-28','14:45:00',4.22),('325','2013-08-28','14:50:00',4.18),('325','2013-08-28','14:55:00',4.14),('325','2013-08-28','15:00:00',4.05),('325','2013-08-28','15:05:00',4.11),('325','2013-08-28','15:10:00',4.12),('325','2013-08-28','15:15:00',4.05),('325','2013-08-28','15:20:00',3.6),('325','2013-08-28','15:25:00',2.77),('325','2013-08-28','15:30:00',3.76),('325','2013-08-28','15:35:00',2.13),('325','2013-08-28','15:45:00',2.39),('325','2013-08-28','15:50:00',2.1),('325','2013-08-28','15:55:00',3.68),('325','2013-08-28','16:00:00',3.7),('325','2013-08-28','16:05:00',3.63),('325','2013-08-28','16:10:00',2.14),('325','2013-08-28','16:15:00',2.35),('325','2013-08-28','16:20:00',3),('325','2013-08-28','16:25:00',3.27),('325','2013-08-28','16:30:00',3.09),('325','2013-08-28','16:35:00',3.01),('325','2013-08-28','16:40:00',2.92),('325','2013-08-28','16:45:00',2.75),('325','2013-08-28','16:50:00',2.55),('325','2013-08-28','16:55:00',2.53),('325','2013-08-28','17:00:00',2.46),('325','2013-08-28','17:05:00',2.34),('325','2013-08-28','17:10:00',1.68),('325','2013-08-28','17:15:00',1.94),('325','2013-08-28','17:20:00',1.48),('325','2013-08-28','17:25:00',1.56),('325','2013-08-28','17:30:00',1.11),('325','2013-08-28','17:35:00',1.68),('325','2013-08-28','17:40:00',1.71),('325','2013-08-28','17:55:00',1.19),('325','2013-08-27','08:25:00',1.1),('325','2013-08-27','08:30:00',1.08),('325','2013-08-27','09:15:00',1.22),('325','2013-08-27','09:20:00',1.5),('325','2013-08-27','09:25:00',1.85),('325','2013-08-27','09:30:00',1.95),('325','2013-08-27','09:35:00',1.14),('325','2013-08-27','09:45:00',1.01),('325','2013-08-27','09:50:00',1.05),('325','2013-08-27','09:55:00',1.23),('325','2013-08-27','10:00:00',1.54),('325','2013-08-27','10:05:00',2.26),('325','2013-08-27','10:10:00',2.77),('325','2013-08-27','10:15:00',2.84),('325','2013-08-27','10:20:00',2.99),('325','2013-08-27','10:25:00',3.04),('325','2013-08-27','10:30:00',3.06),('325','2013-08-27','10:35:00',3.18),('325','2013-08-27','10:40:00',3.13),('325','2013-08-27','10:45:00',3.27),('325','2013-08-27','10:50:00',3.39),('325','2013-08-27','10:55:00',3.44),('325','2013-08-27','11:00:00',3.54),('325','2013-08-27','11:05:00',3.65),('325','2013-08-27','11:10:00',3.69),('325','2013-08-27','11:15:00',3.67),('325','2013-08-27','11:20:00',3.2),('325','2013-08-27','11:25:00',3.48),('325','2013-08-27','11:30:00',3.64),('325','2013-08-27','11:35:00',3.74),('325','2013-08-27','11:40:00',3.5),('325','2013-08-27','11:45:00',4.28),('325','2013-08-27','11:50:00',3.22),('325','2013-08-27','11:55:00',4.2),('325','2013-08-27','12:00:00',4.51),('325','2013-08-27','12:05:00',4.06),('325','2013-08-27','12:10:00',3.33),('325','2013-08-27','12:15:00',4.18),('325','2013-08-27','12:20:00',4.26),('325','2013-08-27','12:25:00',3.74),('325','2013-08-27','12:30:00',3.16),('325','2013-08-27','12:35:00',4.62),('325','2013-08-27','12:40:00',3.11),('325','2013-08-27','12:45:00',3.06),('325','2013-08-27','12:50:00',1.91),('325','2013-08-27','12:55:00',1.5),('325','2013-08-27','13:00:00',1.23),('325','2013-08-27','13:05:00',1.46),('325','2013-08-27','13:10:00',1.77),('325','2013-08-27','13:15:00',1.94),('325','2013-08-27','13:20:00',2.35),('325','2013-08-27','13:25:00',2.45),('325','2013-08-27','13:30:00',2.54),('325','2013-08-27','13:35:00',1.92),('325','2013-08-27','13:40:00',1.83),('325','2013-08-27','13:45:00',2.57),('325','2013-08-27','13:50:00',3.81),('325','2013-08-27','13:55:00',2.92),('325','2013-08-27','14:00:00',3.75),('325','2013-08-27','14:05:00',2.24),('325','2013-08-27','14:10:00',2.92),('325','2013-08-27','14:15:00',3.23),('325','2013-08-27','14:20:00',2.26),('325','2013-08-27','14:25:00',1.29),('325','2013-08-27','14:30:00',1.25),('325','2013-08-27','14:35:00',1.05),('325','2013-08-27','14:40:00',1.22),('325','2013-08-27','14:45:00',1.22),('325','2013-08-27','15:55:00',1.63),('325','2013-08-27','16:00:00',1.66),('325','2013-08-27','16:05:00',1.98),('325','2013-08-27','16:10:00',3.82),('325','2013-08-27','16:15:00',3.62),('325','2013-08-27','16:20:00',2.41),('325','2013-08-27','16:25:00',2.37),('325','2013-08-27','16:35:00',1.21),('325','2013-08-27','16:40:00',2.08),('325','2013-08-27','16:45:00',1.87),('325','2013-08-27','16:50:00',2.52),('325','2013-08-27','16:55:00',2.29),('325','2013-08-27','17:05:00',1.4),('325','2013-08-27','17:10:00',2.79),('325','2013-08-27','17:15:00',1.36),('325','2013-08-27','17:45:00',1.25),('325','2013-08-27','17:50:00',1.51),('325','2013-08-27','17:55:00',1.53),('325','2013-08-27','18:00:00',1.27),('325','2013-08-26','08:45:00',1.01),('325','2013-08-26','08:50:00',1.07),('325','2013-08-26','08:55:00',1.13),('325','2013-08-26','09:00:00',1.18),('325','2013-08-26','09:05:00',1.54),('325','2013-08-26','09:10:00',1.8),('325','2013-08-26','09:15:00',1.99),('325','2013-08-26','09:20:00',2.09),('325','2013-08-26','09:25:00',2.18),('325','2013-08-26','09:30:00',2.15),('325','2013-08-26','09:35:00',2.03),('325','2013-08-26','09:40:00',1.88),('325','2013-08-26','09:45:00',2.1),('325','2013-08-26','09:50:00',2.39),('325','2013-08-26','09:55:00',2.5),('325','2013-08-26','10:00:00',2.63),('325','2013-08-26','10:05:00',2.73),('325','2013-08-26','10:10:00',2.78),('325','2013-08-26','10:15:00',2.84),('325','2013-08-26','10:20:00',2.98),('325','2013-08-26','10:25:00',3.01),('325','2013-08-26','10:30:00',3.05),('325','2013-08-26','10:35:00',3.15),('325','2013-08-26','10:40:00',3.24),('325','2013-08-26','10:45:00',3.35),('325','2013-08-26','10:50:00',3.44),('325','2013-08-26','10:55:00',3.56),('325','2013-08-26','11:00:00',3.61),('325','2013-08-26','11:05:00',3.62),('325','2013-08-26','11:10:00',3.67),('325','2013-08-26','11:15:00',3.71),('325','2013-08-26','11:20:00',3.72),('325','2013-08-26','11:25:00',3.78),('325','2013-08-26','11:30:00',3.86),('325','2013-08-26','11:35:00',3.92),('325','2013-08-26','11:40:00',3.93),('325','2013-08-26','11:45:00',3.96),('325','2013-08-26','11:50:00',3.19),('325','2013-08-26','11:55:00',4.05),('325','2013-08-26','12:00:00',4.06),('325','2013-08-26','12:05:00',4.1),('325','2013-08-26','12:10:00',4.11),('325','2013-08-26','12:15:00',4.12),('325','2013-08-26','12:20:00',4.1),('325','2013-08-26','12:25:00',4.11),('325','2013-08-26','12:30:00',4.1),('325','2013-08-26','12:35:00',4.12),('325','2013-08-26','12:40:00',4.17),('325','2013-08-26','12:45:00',4.2),('325','2013-08-26','12:50:00',4.2),('325','2013-08-26','12:55:00',4.26),('325','2013-08-26','13:00:00',4.35),('325','2013-08-26','13:05:00',4.92),('325','2013-08-26','13:10:00',4.15),('325','2013-08-26','13:15:00',4.03),('325','2013-08-26','13:20:00',3.38),('325','2013-08-26','13:25:00',3.12),('325','2013-08-26','13:30:00',3.07),('325','2013-08-26','13:35:00',4.09),('325','2013-08-26','13:40:00',4.25),('325','2013-08-26','13:45:00',4.27),('325','2013-08-26','13:50:00',4.16),('325','2013-08-26','13:55:00',3.07),('325','2013-08-26','14:00:00',2.95),('325','2013-08-26','14:05:00',3.66),('325','2013-08-26','14:10:00',3.08),('325','2013-08-26','14:15:00',4.01),('325','2013-08-26','14:20:00',4.14),('325','2013-08-26','14:25:00',4.08),('325','2013-08-26','14:30:00',4.05),('325','2013-08-26','14:35:00',3.87),('325','2013-08-26','14:40:00',3.53),('325','2013-08-26','14:45:00',2.62),('325','2013-08-26','14:50:00',2.32),('325','2013-08-26','14:55:00',2.17),('325','2013-08-26','15:00:00',2.02),('325','2013-08-26','15:05:00',1.44),('325','2013-08-26','15:10:00',1.13),('325','2013-08-26','15:35:00',1.08),('325','2013-08-26','15:40:00',1.69),('325','2013-08-26','15:45:00',1.78),('325','2013-08-26','15:50:00',1.83),('325','2013-08-26','15:55:00',1.65),('325','2013-08-26','16:00:00',2.6),('325','2013-08-26','16:05:00',3.57),('325','2013-08-26','16:10:00',3.15),('325','2013-08-26','16:15:00',3.01),('325','2013-08-26','16:20:00',2.94),('325','2013-08-26','16:25:00',2.85),('325','2013-08-26','16:30:00',2.77),('325','2013-08-26','16:35:00',2.71),('325','2013-08-26','16:40:00',2.64),('325','2013-08-26','16:45:00',2.58),('325','2013-08-26','16:50:00',2.34),('325','2013-08-26','16:55:00',2.25),('325','2013-08-26','17:00:00',2.22),('325','2013-08-26','17:05:00',2.05),('325','2013-08-26','17:10:00',2.07),('325','2013-08-26','17:15:00',1.98),('325','2013-08-26','17:20:00',1.42),('325','2013-08-26','17:30:00',1.45),('325','2013-08-26','17:35:00',1.09),('325','2013-08-26','17:40:00',1.12),('325','2013-08-26','17:45:00',1.32),('325','2013-08-26','17:50:00',1.49),('325','2013-08-26','17:55:00',1.43),('325','2013-08-26','18:00:00',1.25),('325','2013-08-26','18:05:00',1.08),('325','2013-08-25','08:40:00',1.14),('325','2013-08-25','08:45:00',1.08),('325','2013-08-25','09:15:00',1.01),('325','2013-08-25','09:20:00',2.07),('325','2013-08-25','09:25:00',2.16),('325','2013-08-25','09:30:00',1.86),('325','2013-08-25','09:40:00',2.2),('325','2013-08-25','09:45:00',2.99),('325','2013-08-25','09:50:00',2.45),('325','2013-08-25','09:55:00',2.29),('325','2013-08-25','10:00:00',1.96),('325','2013-08-25','10:05:00',1.26),('325','2013-08-25','15:15:00',1.17),('325','2013-08-25','15:20:00',1.43),('325','2013-08-25','15:25:00',1.59),('325','2013-08-25','15:30:00',2.28),('325','2013-08-25','15:35:00',3.63),('325','2013-08-25','15:40:00',3.69),('325','2013-08-25','15:45:00',3.87),('325','2013-08-25','15:50:00',2.56),('325','2013-08-25','15:55:00',2.91),('325','2013-08-25','16:00:00',3.78),('325','2013-08-25','16:05:00',3.52),('325','2013-08-25','16:10:00',3.34),('325','2013-08-25','16:15:00',3.21),('325','2013-08-25','16:20:00',3.11),('325','2013-08-25','16:25:00',3.06),('325','2013-08-25','16:30:00',2.97),('325','2013-08-25','16:35:00',2.85),('325','2013-08-25','16:40:00',2),('325','2013-08-25','16:45:00',1.38),('325','2013-08-25','16:50:00',2.13),('325','2013-08-25','16:55:00',2.22),('325','2013-08-25','17:00:00',2.52),('325','2013-08-25','17:05:00',2.45),('325','2013-08-25','17:10:00',2.3),('325','2013-08-25','17:15:00',2.12),('325','2013-08-25','17:20:00',2.01),('325','2013-08-25','17:25:00',1.91),('325','2013-08-25','17:30:00',1.81),('325','2013-08-25','17:35:00',1.53),('325','2013-08-25','17:40:00',1.41),('325','2013-08-25','17:45:00',1.55),('325','2013-08-25','17:50:00',1.37),('325','2013-08-25','17:55:00',1.17),('325','2013-08-24','08:45:00',1.14),('325','2013-08-24','08:50:00',1.19),('325','2013-08-24','08:55:00',1.28),('325','2013-08-24','09:00:00',1.32),('325','2013-08-24','09:05:00',1.49),('325','2013-08-24','09:15:00',1.76),('325','2013-08-24','09:25:00',2.28),('325','2013-08-24','09:30:00',2.28),('325','2013-08-24','09:35:00',1.84),('325','2013-08-24','09:40:00',1.59),('325','2013-08-24','09:45:00',2.01),('325','2013-08-24','09:50:00',2.42),('325','2013-08-24','09:55:00',2.67),('325','2013-08-24','10:00:00',2.68),('325','2013-08-24','10:05:00',2.74),('325','2013-08-24','10:10:00',2.82),('325','2013-08-24','10:15:00',2.86),('325','2013-08-24','10:20:00',2.97),('325','2013-08-24','10:25:00',2.97),('325','2013-08-24','10:30:00',3.02),('325','2013-08-24','10:35:00',3.14),('325','2013-08-24','10:40:00',3.15),('325','2013-08-24','10:45:00',2.47),('325','2013-08-24','10:50:00',2.63),('325','2013-08-24','10:55:00',3.61),('325','2013-08-24','11:00:00',3.62),('325','2013-08-24','11:05:00',3.72),('325','2013-08-24','11:10:00',3.71),('325','2013-08-24','11:15:00',3.71),('325','2013-08-24','11:20:00',3.78),('325','2013-08-24','11:25:00',3.73),('325','2013-08-24','11:30:00',3.82),('325','2013-08-24','11:35:00',3.89),('325','2013-08-24','11:40:00',3.93),('325','2013-08-24','11:45:00',3.98),('325','2013-08-24','11:50:00',3.96),('325','2013-08-24','11:55:00',4.07),('325','2013-08-24','12:00:00',4.06),('325','2013-08-24','12:05:00',4.12),('325','2013-08-24','12:10:00',4.19),('325','2013-08-24','12:15:00',4.13),('325','2013-08-24','12:20:00',4.22),('325','2013-08-24','12:25:00',4.2),('325','2013-08-24','12:30:00',4.21),('325','2013-08-24','12:35:00',4.21),('325','2013-08-24','12:40:00',4.24),('325','2013-08-24','12:45:00',4.23),('325','2013-08-24','12:50:00',4.26),('325','2013-08-24','12:55:00',4.2),('325','2013-08-24','13:00:00',4.22),('325','2013-08-24','13:05:00',4.25),('325','2013-08-24','13:10:00',4.26),('325','2013-08-24','13:15:00',4.26),('325','2013-08-24','13:20:00',4.3),('325','2013-08-24','13:25:00',4.3),('325','2013-08-24','13:30:00',4.3),('325','2013-08-24','13:35:00',4.28),('325','2013-08-24','13:40:00',4.23),('325','2013-08-24','13:45:00',4.26),('325','2013-08-24','13:50:00',4.26),('325','2013-08-24','13:55:00',4.24),('325','2013-08-24','14:00:00',4.23),('325','2013-08-24','14:05:00',4.22),('325','2013-08-24','14:10:00',4.16),('325','2013-08-24','14:15:00',4.14),('325','2013-08-24','14:20:00',4.09),('325','2013-08-24','14:25:00',4.04),('325','2013-08-24','14:30:00',4.03),('325','2013-08-24','14:35:00',4.02),('325','2013-08-24','14:40:00',3.99),('325','2013-08-24','14:45:00',3.94),('325','2013-08-24','14:50:00',3.9),('325','2013-08-24','14:55:00',3.88),('325','2013-08-24','15:00:00',3.86),('325','2013-08-24','15:05:00',3.84),('325','2013-08-24','15:10:00',3.78),('325','2013-08-24','15:15:00',3.75),('325','2013-08-24','15:20:00',3.7),('325','2013-08-24','15:25:00',3.65),('325','2013-08-24','15:30:00',3.61),('325','2013-08-24','15:35:00',3.56),('325','2013-08-24','15:40:00',3.49),('325','2013-08-24','15:45:00',3.43),('325','2013-08-24','15:50:00',3.38),('325','2013-08-24','15:55:00',3.31),('325','2013-08-24','16:00:00',3.24),('325','2013-08-24','16:05:00',3.17),('325','2013-08-24','16:10:00',3.12),('325','2013-08-24','16:15:00',3.06),('325','2013-08-24','16:20:00',2.99),('325','2013-08-24','16:25:00',2.93),('325','2013-08-24','16:30:00',2.84),('325','2013-08-24','16:35:00',2.75),('325','2013-08-24','16:40:00',2.67),('325','2013-08-24','16:45:00',2.59),('325','2013-08-24','16:50:00',2.51),('325','2013-08-24','16:55:00',2.36),('325','2013-08-24','17:00:00',2.28),('325','2013-08-24','17:05:00',2.23),('325','2013-08-24','17:10:00',2.15),('325','2013-08-24','17:15:00',2.08),('325','2013-08-24','17:20:00',1.98),('325','2013-08-24','17:25:00',1.9),('325','2013-08-24','17:30:00',1.81),('325','2013-08-24','17:35:00',1.68),('325','2013-08-24','17:40:00',1.59),('325','2013-08-24','17:45:00',1.5),('325','2013-08-24','17:50:00',1.41),('325','2013-08-24','17:55:00',1.31),('325','2013-08-24','18:00:00',1.23),('325','2013-08-24','18:05:00',1.13),('325','2013-08-24','18:10:00',1.04),('325','2013-08-23','08:45:00',1.04),('325','2013-08-23','08:50:00',1.11),('325','2013-08-23','08:55:00',1.19),('325','2013-08-23','09:00:00',1.25),('325','2013-08-23','09:05:00',1.26),('325','2013-08-23','09:10:00',1.53),('325','2013-08-23','09:15:00',1.74),('325','2013-08-23','09:20:00',1.81),('325','2013-08-23','09:25:00',1.92),('325','2013-08-23','09:30:00',1.95),('325','2013-08-23','09:35:00',1.99),('325','2013-08-23','09:40:00',2.06),('325','2013-08-23','09:45:00',2.14),('325','2013-08-23','09:50:00',2.08),('325','2013-08-23','09:55:00',2.02),('325','2013-08-23','10:00:00',1.94),('325','2013-08-23','10:05:00',2.04),('325','2013-08-23','10:10:00',2.55),('325','2013-08-23','10:15:00',2.63),('325','2013-08-23','10:20:00',2.68),('325','2013-08-23','10:25:00',2.73),('325','2013-08-23','10:30:00',2.81),('325','2013-08-23','10:35:00',2.87),('325','2013-08-23','10:40:00',2.93),('325','2013-08-23','10:45:00',2.98),('325','2013-08-23','10:50:00',3.12),('325','2013-08-23','10:55:00',3.19),('325','2013-08-23','11:00:00',3.26),('325','2013-08-23','11:05:00',3.26),('325','2013-08-23','11:10:00',2.58),('325','2013-08-23','11:15:00',1.23),('325','2013-08-23','11:20:00',1.53),('325','2013-08-23','11:25:00',3.47),('325','2013-08-23','11:30:00',3.8),('325','2013-08-23','11:35:00',3.93),('325','2013-08-23','11:40:00',3.86),('325','2013-08-23','11:45:00',3.87),('325','2013-08-23','11:50:00',2.82),('325','2013-08-23','11:55:00',1.19),('325','2013-08-23','12:00:00',1.53),('325','2013-08-23','12:05:00',3.19),('325','2013-08-23','12:10:00',2.81),('325','2013-08-23','12:15:00',1.05),('325','2013-08-23','12:20:00',1.07),('325','2013-08-23','12:25:00',1.15),('325','2013-08-23','12:30:00',2.1),('325','2013-08-23','12:35:00',2.72),('325','2013-08-23','12:40:00',1.34),('325','2013-08-23','12:45:00',3.35),('325','2013-08-23','12:50:00',3.28),('325','2013-08-23','12:55:00',1.09),('325','2013-08-23','13:00:00',3.17),('325','2013-08-23','13:05:00',3.38),('325','2013-08-23','13:10:00',2.14),('325','2013-08-23','13:15:00',1.94),('325','2013-08-23','13:20:00',3.66),('325','2013-08-23','13:25:00',3.76),('325','2013-08-23','13:30:00',4.45),('325','2013-08-23','13:35:00',2.96),('325','2013-08-23','13:40:00',2.62),('325','2013-08-23','13:45:00',2.81),('325','2013-08-23','13:50:00',2.52),('325','2013-08-23','13:55:00',4.61),('325','2013-08-23','14:00:00',4.26),('325','2013-08-23','14:05:00',3.63),('325','2013-08-23','14:10:00',4.26),('325','2013-08-23','14:15:00',4.15),('325','2013-08-23','14:20:00',3.99),('325','2013-08-23','14:25:00',3.97),('325','2013-08-23','14:30:00',4.02),('325','2013-08-23','14:35:00',3.92),('325','2013-08-23','14:40:00',3.95),('325','2013-08-23','14:45:00',3.94),('325','2013-08-23','14:50:00',3.86),('325','2013-08-23','14:55:00',3.82),('325','2013-08-23','15:00:00',3.75),('325','2013-08-23','15:05:00',3.63),('325','2013-08-23','15:10:00',3.82),('325','2013-08-23','15:15:00',3.63),('325','2013-08-23','15:20:00',3.66),('325','2013-08-23','15:25:00',3.65),('325','2013-08-23','15:30:00',3.72),('325','2013-08-23','15:35:00',3.44),('325','2013-08-23','15:40:00',3.43),('325','2013-08-23','15:45:00',3.4),('325','2013-08-23','15:50:00',3.13),('325','2013-08-23','15:55:00',3.31),('325','2013-08-23','16:00:00',3.14),('325','2013-08-23','16:05:00',2.97),('325','2013-08-23','16:10:00',2.71),('325','2013-08-23','16:15:00',2.96),('325','2013-08-23','16:20:00',3.1),('325','2013-08-23','16:25:00',3),('325','2013-08-23','16:30:00',2.92),('325','2013-08-23','16:35:00',2.88),('325','2013-08-23','16:40:00',2.8),('325','2013-08-23','16:45:00',2.74),('325','2013-08-23','16:50:00',2.6),('325','2013-08-23','16:55:00',2.44),('325','2013-08-23','17:00:00',2.28),('325','2013-08-23','17:05:00',2.21),('325','2013-08-23','17:10:00',2.12),('325','2013-08-23','17:15:00',2.03),('325','2013-08-23','17:20:00',1.94),('325','2013-08-23','17:25:00',1.84),('325','2013-08-23','17:30:00',1.75),('325','2013-08-23','17:35:00',1.64),('325','2013-08-23','17:40:00',1.51),('325','2013-08-23','17:45:00',1.45),('325','2013-08-23','17:50:00',1.37),('325','2013-08-23','17:55:00',1.28),('325','2013-08-23','18:00:00',1.19),('325','2013-08-23','18:05:00',1.1),('325','2013-08-22','08:45:00',1.05),('325','2013-08-22','08:50:00',1.12),('325','2013-08-22','08:55:00',1.21),('325','2013-08-22','09:00:00',1.29),('325','2013-08-22','09:05:00',1.43),('325','2013-08-22','09:10:00',1.62),('325','2013-08-22','09:15:00',2),('325','2013-08-22','09:20:00',2.2),('325','2013-08-22','09:25:00',2.26),('325','2013-08-22','09:30:00',2.41),('325','2013-08-22','09:35:00',1.62),('325','2013-08-22','09:40:00',2.06),('325','2013-08-22','09:45:00',2.36),('325','2013-08-22','09:50:00',2.46),('325','2013-08-22','09:55:00',2.11),('325','2013-08-22','10:00:00',2.4),('325','2013-08-22','10:05:00',2.28),('325','2013-08-22','10:10:00',2.73),('325','2013-08-22','10:15:00',2.82),('325','2013-08-22','10:20:00',2.86),('325','2013-08-22','10:25:00',2.9),('325','2013-08-22','10:30:00',2.97),('325','2013-08-22','10:35:00',3.03),('325','2013-08-22','10:40:00',3.09),('325','2013-08-22','10:45:00',3.15),('325','2013-08-22','10:50:00',3.26),('325','2013-08-22','10:55:00',3.36),('325','2013-08-22','11:00:00',3.47),('325','2013-08-22','11:05:00',3.5),('325','2013-08-22','11:10:00',3.51),('325','2013-08-22','11:15:00',3.54),('325','2013-08-22','11:20:00',3.6),('325','2013-08-22','11:25:00',3.64),('325','2013-08-22','11:30:00',3.68),('325','2013-08-22','11:35:00',3.71),('325','2013-08-22','11:40:00',3.78),('325','2013-08-22','11:45:00',3.81),('325','2013-08-22','11:50:00',3.83),('325','2013-08-22','11:55:00',3.91),('325','2013-08-22','12:00:00',3.92),('325','2013-08-22','12:05:00',3.94),('325','2013-08-22','12:10:00',3.96),('325','2013-08-22','12:15:00',3.95),('325','2013-08-22','12:20:00',3.99),('325','2013-08-22','12:25:00',4),('325','2013-08-22','12:30:00',4),('325','2013-08-22','12:35:00',3.99),('325','2013-08-22','12:40:00',4.01),('325','2013-08-22','12:45:00',4.03),('325','2013-08-22','12:50:00',4.03),('325','2013-08-22','12:55:00',4.03),('325','2013-08-22','13:00:00',4.02),('325','2013-08-22','13:05:00',4.05),('325','2013-08-22','13:10:00',4.02),('325','2013-08-22','13:15:00',4.02),('325','2013-08-22','13:20:00',3.99),('325','2013-08-22','13:25:00',4),('325','2013-08-22','13:30:00',3.98),('325','2013-08-22','13:35:00',3.95),('325','2013-08-22','13:40:00',3.93),('325','2013-08-22','13:45:00',3.98),('325','2013-08-22','13:50:00',3.98),('325','2013-08-22','13:55:00',3.95),('325','2013-08-22','14:00:00',3.93),('325','2013-08-22','14:05:00',3.93),('325','2013-08-22','14:10:00',3.89),('325','2013-08-22','14:15:00',3.88),('325','2013-08-22','14:20:00',3.88),('325','2013-08-22','14:25:00',3.88),('325','2013-08-22','14:30:00',3.88),('325','2013-08-22','14:35:00',3.9),('325','2013-08-22','14:40:00',3.74),('325','2013-08-22','14:45:00',3.74),('325','2013-08-22','14:50:00',3.8),('325','2013-08-22','14:55:00',3.77),('325','2013-08-22','15:00:00',3.68),('325','2013-08-22','15:05:00',3.71),('325','2013-08-22','15:10:00',3.67),('325','2013-08-22','15:15:00',3.57),('325','2013-08-22','15:20:00',3.55),('325','2013-08-22','15:25:00',3.54),('325','2013-08-22','15:30:00',3.47),('325','2013-08-22','15:35:00',3.4),('325','2013-08-22','15:40:00',3.38),('325','2013-08-22','15:45:00',3.34),('325','2013-08-22','15:50:00',3.29),('325','2013-08-22','15:55:00',3.2),('325','2013-08-22','16:00:00',3.12),('325','2013-08-22','16:05:00',3.03),('325','2013-08-22','16:10:00',2.98),('325','2013-08-22','16:15:00',2.93),('325','2013-08-22','16:20:00',2.87),('325','2013-08-22','16:25:00',2.81),('325','2013-08-22','16:30:00',2.73),('325','2013-08-22','16:35:00',2.64),('325','2013-08-22','16:40:00',2.56),('325','2013-08-22','16:45:00',2.48),('325','2013-08-22','16:50:00',2.36),('325','2013-08-22','16:55:00',2.28),('325','2013-08-22','17:00:00',2.16),('325','2013-08-22','17:05:00',2.1),('325','2013-08-22','17:10:00',2.03),('325','2013-08-22','17:15:00',1.94),('325','2013-08-22','17:20:00',1.84),('325','2013-08-22','17:25:00',1.78),('325','2013-08-22','17:30:00',1.69),('325','2013-08-22','17:35:00',1.6),('325','2013-08-22','17:40:00',1.48),('325','2013-08-22','17:45:00',1.4),('325','2013-08-22','17:50:00',1.3),('325','2013-08-22','17:55:00',1.24),('325','2013-08-22','18:00:00',1.16),('325','2013-08-22','18:05:00',1.09),('325','2013-08-22','18:10:00',1.04),('325','2013-08-22','18:15:00',1.04),('325','2013-08-21','09:05:00',1.3),('325','2013-08-21','09:10:00',1.34),('325','2013-08-21','09:15:00',1.81),('325','2013-08-21','09:20:00',1.84),('325','2013-08-21','09:25:00',1.13),('325','2013-08-21','09:40:00',1.03),('325','2013-08-21','09:45:00',1.21),('325','2013-08-21','09:50:00',1.95),('325','2013-08-21','09:55:00',3.18),('325','2013-08-21','10:00:00',3.17),('325','2013-08-21','10:05:00',2.81),('325','2013-08-21','10:10:00',2.55),('325','2013-08-21','10:15:00',2.39),('325','2013-08-21','10:20:00',2.26),('325','2013-08-21','10:25:00',1.8),('325','2013-08-21','10:30:00',2.39),('325','2013-08-21','10:35:00',2.96),('325','2013-08-21','10:40:00',1.94),('325','2013-08-21','10:45:00',2.16),('325','2013-08-21','10:50:00',2.34),('325','2013-08-21','10:55:00',1.91),('325','2013-08-21','11:00:00',2.7),('325','2013-08-21','11:05:00',2.06),('325','2013-08-21','11:10:00',1.81),('325','2013-08-21','11:15:00',2.14),('325','2013-08-21','11:20:00',2.77),('325','2013-08-21','11:25:00',2.69),('325','2013-08-21','11:30:00',3.42),('325','2013-08-21','11:35:00',4.48),('325','2013-08-21','11:40:00',4.27),('325','2013-08-21','11:45:00',4.24),('325','2013-08-21','11:50:00',4.16),('325','2013-08-21','11:55:00',4.15),('325','2013-08-21','12:00:00',4.27),('325','2013-08-21','12:05:00',4.27),('325','2013-08-21','12:10:00',4.26),('325','2013-08-21','12:15:00',4.3),('325','2013-08-21','12:20:00',4.29),('325','2013-08-21','12:25:00',3),('325','2013-08-21','12:30:00',2.62),('325','2013-08-21','12:35:00',2.09),('325','2013-08-21','12:40:00',3.87),('325','2013-08-21','12:45:00',4.17),('325','2013-08-21','12:50:00',3.98),('325','2013-08-21','12:55:00',3.95),('325','2013-08-21','13:00:00',4.08),('325','2013-08-21','13:05:00',4.1),('325','2013-08-21','13:10:00',4.17),('325','2013-08-21','13:15:00',4.23),('325','2013-08-21','13:20:00',4.23),('325','2013-08-21','13:25:00',4.2),('325','2013-08-21','13:30:00',4.08),('325','2013-08-21','13:35:00',4.06),('325','2013-08-21','13:40:00',4.08),('325','2013-08-21','13:45:00',4.18),('325','2013-08-21','13:50:00',4.04),('325','2013-08-21','13:55:00',3.94),('325','2013-08-21','14:00:00',3.91),('325','2013-08-21','14:05:00',3.94),('325','2013-08-21','14:10:00',4.05),('325','2013-08-21','14:15:00',2.77),('325','2013-08-21','14:20:00',1.69),('325','2013-08-21','14:25:00',2.02),('325','2013-08-21','14:30:00',3.6),('325','2013-08-21','14:35:00',3.72),('325','2013-08-21','14:40:00',3.72),('325','2013-08-21','14:45:00',3.62),('325','2013-08-21','14:50:00',3.53),('325','2013-08-21','14:55:00',3.57),('325','2013-08-21','15:00:00',3.63),('325','2013-08-21','15:05:00',3.58),('325','2013-08-21','15:10:00',3.52),('325','2013-08-21','15:15:00',3.43),('325','2013-08-21','15:20:00',3.38),('325','2013-08-21','15:25:00',3.2),('325','2013-08-21','15:30:00',3.14),('325','2013-08-21','15:35:00',3.03),('325','2013-08-21','15:40:00',2.85),('325','2013-08-21','15:45:00',2.92),('325','2013-08-21','15:50:00',2.94),('325','2013-08-21','15:55:00',2.92),('325','2013-08-21','16:00:00',2.74),('325','2013-08-21','16:05:00',2.61),('325','2013-08-21','16:10:00',2.54),('325','2013-08-21','16:15:00',2.55),('325','2013-08-21','16:20:00',2.72),('325','2013-08-21','16:25:00',2.72),('325','2013-08-21','16:30:00',2.86),('325','2013-08-21','16:35:00',2.8),('325','2013-08-21','16:40:00',2.7),('325','2013-08-21','16:45:00',2.6),('325','2013-08-21','16:50:00',2.52),('325','2013-08-21','16:55:00',2.42),('325','2013-08-21','17:00:00',2.33),('325','2013-08-21','17:05:00',2.23),('325','2013-08-21','17:10:00',2.22),('325','2013-08-21','17:15:00',2.15),('325','2013-08-21','17:20:00',2.13),('325','2013-08-21','17:25:00',2.04),('325','2013-08-21','17:30:00',1.93),('325','2013-08-21','17:35:00',1.88),('325','2013-08-21','17:40:00',1.79),('325','2013-08-21','17:45:00',1.69),('325','2013-08-21','17:50:00',1.66),('325','2013-08-21','17:55:00',1.59),('325','2013-08-21','18:00:00',1.5),('325','2013-08-21','18:05:00',1.41),('325','2013-08-21','18:10:00',1.28),('325','2013-08-21','18:15:00',1.21),('325','2013-08-21','18:20:00',1.08),('325','2013-08-20','09:20:00',1.22),('325','2013-08-20','09:25:00',1.73),('325','2013-08-20','09:30:00',2.31),('325','2013-08-20','09:35:00',2.48),('325','2013-08-20','09:40:00',3.18),('325','2013-08-20','09:45:00',2.62),('325','2013-08-20','09:50:00',1.85),('325','2013-08-20','09:55:00',3.4),('325','2013-08-20','10:00:00',2.85),('325','2013-08-20','10:05:00',1.37),('325','2013-08-20','10:10:00',1.11),('325','2013-08-20','10:15:00',1.55),('325','2013-08-20','10:20:00',1.26),('325','2013-08-20','10:25:00',1.01),('325','2013-08-20','10:30:00',1.05),('325','2013-08-20','10:35:00',1.11),('325','2013-08-20','10:40:00',1.9),('325','2013-08-20','10:45:00',3.73),('325','2013-08-20','10:50:00',3.53),('325','2013-08-20','10:55:00',2.03),('325','2013-08-20','11:00:00',1.07),('325','2013-08-20','11:05:00',1.05),('325','2013-08-20','11:10:00',3.72),('325','2013-08-20','11:15:00',4.02),('325','2013-08-20','11:20:00',4.09),('325','2013-08-20','11:25:00',2.28),('325','2013-08-20','11:30:00',3.47),('325','2013-08-20','11:35:00',3.99),('325','2013-08-20','11:40:00',4.33),('325','2013-08-20','11:45:00',4.5),('325','2013-08-20','11:50:00',4.78),('325','2013-08-20','11:55:00',4.45),('325','2013-08-20','12:00:00',2.57),('325','2013-08-20','12:05:00',1.46),('325','2013-08-20','12:10:00',1.79),('325','2013-08-20','12:25:00',1.27),('325','2013-08-20','12:30:00',1.57),('325','2013-08-20','12:35:00',1.69),('325','2013-08-20','12:40:00',1.73),('325','2013-08-20','12:45:00',1.74),('325','2013-08-20','12:50:00',1.77),('325','2013-08-20','12:55:00',1.81),('325','2013-08-20','13:00:00',1.77),('325','2013-08-20','13:05:00',1.65),('325','2013-08-20','13:10:00',1.67),('325','2013-08-20','13:15:00',1.74),('325','2013-08-20','13:20:00',1.8),('325','2013-08-20','13:25:00',1.84),('325','2013-08-20','13:30:00',2.03),('325','2013-08-20','13:35:00',2.94),('325','2013-08-20','13:40:00',4.36),('325','2013-08-20','13:45:00',3.96),('325','2013-08-20','13:50:00',4.63),('325','2013-08-20','13:55:00',4.46),('325','2013-08-20','14:00:00',4.42),('325','2013-08-20','14:05:00',4.06),('325','2013-08-20','14:10:00',4.03),('325','2013-08-20','14:15:00',4.24),('325','2013-08-20','14:20:00',4.21),('325','2013-08-20','14:25:00',3.85),('325','2013-08-20','14:30:00',3.69),('325','2013-08-20','14:35:00',3.99),('325','2013-08-20','14:40:00',4.22),('325','2013-08-20','14:45:00',3.4),('325','2013-08-20','14:50:00',3.93),('325','2013-08-20','14:55:00',3.7),('325','2013-08-20','15:00:00',3.51),('325','2013-08-20','15:05:00',4.24),('325','2013-08-20','15:10:00',4.1),('325','2013-08-20','15:15:00',4.09),('325','2013-08-20','15:20:00',3.99),('325','2013-08-20','15:25:00',3.96),('325','2013-08-20','15:30:00',3.96),('325','2013-08-20','15:35:00',3.93),('325','2013-08-20','15:40:00',3.99),('325','2013-08-20','15:45:00',4.09),('325','2013-08-20','15:50:00',4.28),('325','2013-08-20','15:55:00',4.26),('325','2013-08-20','16:00:00',4.04),('325','2013-08-20','16:05:00',3.98),('325','2013-08-20','16:10:00',3.88),('325','2013-08-20','16:15:00',3.85),('325','2013-08-20','16:20:00',3.79),('325','2013-08-20','16:25:00',3.67),('325','2013-08-20','16:30:00',3.37),('325','2013-08-20','16:35:00',3.34),('325','2013-08-20','16:40:00',3.38),('325','2013-08-20','16:45:00',3.25),('325','2013-08-20','16:50:00',3.07),('325','2013-08-20','16:55:00',2.85),('325','2013-08-20','17:00:00',2.57),('325','2013-08-20','17:05:00',2.42),('325','2013-08-20','17:10:00',2.36),('325','2013-08-20','17:15:00',2.21),('325','2013-08-20','17:20:00',2.13),('325','2013-08-20','17:25:00',2.04),('325','2013-08-20','17:30:00',1.99),('325','2013-08-20','17:35:00',1.91),('325','2013-08-20','17:40:00',1.8),('325','2013-08-20','17:45:00',1.74),('325','2013-08-20','17:50:00',1.56),('325','2013-08-20','17:55:00',1.42),('325','2013-08-20','18:00:00',1.27),('325','2013-08-20','18:05:00',1.22),('325','2013-08-20','18:10:00',1.25),('325','2013-08-20','18:15:00',1.25),('325','2013-08-20','18:20:00',1.17),('325','2013-08-20','18:25:00',1.11),('325','2013-08-20','18:30:00',1.12),('325','2013-08-19','08:45:00',1.01),('325','2013-08-19','08:50:00',1.06),('325','2013-08-19','08:55:00',1.11),('325','2013-08-19','09:00:00',1.16),('325','2013-08-19','09:05:00',1.22),('325','2013-08-19','09:10:00',1.53),('325','2013-08-19','09:15:00',1.76),('325','2013-08-19','09:20:00',1.83),('325','2013-08-19','09:25:00',2.04),('325','2013-08-19','09:30:00',2.15),('325','2013-08-19','09:35:00',2.22),('325','2013-08-19','09:40:00',2.29),('325','2013-08-19','09:45:00',2.39),('325','2013-08-19','09:50:00',2.51),('325','2013-08-19','09:55:00',2.58),('325','2013-08-19','10:00:00',2.68),('325','2013-08-19','10:05:00',2.64),('325','2013-08-19','10:10:00',2.48),('325','2013-08-19','10:15:00',2.61),('325','2013-08-19','10:20:00',2.86),('325','2013-08-19','10:25:00',2.9),('325','2013-08-19','10:30:00',2.99),('325','2013-08-19','10:35:00',3.04),('325','2013-08-19','10:40:00',3.08),('325','2013-08-19','10:45:00',3.15),('325','2013-08-19','10:50:00',3.28),('325','2013-08-19','10:55:00',3.36),('325','2013-08-19','11:00:00',3.46),('325','2013-08-19','11:05:00',3.54),('325','2013-08-19','11:10:00',3.55),('325','2013-08-19','11:15:00',3.57),('325','2013-08-19','11:20:00',3.6),('325','2013-08-19','11:25:00',3.65),('325','2013-08-19','11:30:00',3.69),('325','2013-08-19','11:35:00',3.7),('325','2013-08-19','11:40:00',3.75),('325','2013-08-19','11:45:00',3.76),('325','2013-08-19','11:50:00',3.85),('325','2013-08-19','11:55:00',3.95),('325','2013-08-19','12:00:00',4.02),('325','2013-08-19','12:05:00',4.03),('325','2013-08-19','12:10:00',4.07),('325','2013-08-19','12:15:00',4.11),('325','2013-08-19','12:20:00',4.09),('325','2013-08-19','12:25:00',4.11),('325','2013-08-19','12:30:00',4.13),('325','2013-08-19','12:35:00',4.13),('325','2013-08-19','12:40:00',4.16),('325','2013-08-19','12:45:00',4.18),('325','2013-08-19','12:50:00',4.2),('325','2013-08-19','12:55:00',4.25),('325','2013-08-19','13:00:00',4.26),('325','2013-08-19','13:05:00',4.27),('325','2013-08-19','13:10:00',4.25),('325','2013-08-19','13:15:00',4.26),('325','2013-08-19','13:20:00',4.24),('325','2013-08-19','13:25:00',4.25),('325','2013-08-19','13:30:00',4.22),('325','2013-08-19','13:35:00',4.2),('325','2013-08-19','13:40:00',4.21),('325','2013-08-19','13:45:00',4.22),('325','2013-08-19','13:50:00',4.24),('325','2013-08-19','13:55:00',4.22),('325','2013-08-19','14:00:00',4.21),('325','2013-08-19','14:05:00',4.19),('325','2013-08-19','14:10:00',4.17),('325','2013-08-19','14:15:00',4.12),('325','2013-08-19','14:20:00',4.07),('325','2013-08-19','14:25:00',4.03),('325','2013-08-19','14:30:00',4.03),('325','2013-08-19','14:35:00',3.98),('325','2013-08-19','14:40:00',3.99),('325','2013-08-19','14:45:00',3.99),('325','2013-08-19','14:50:00',3.97),('325','2013-08-19','14:55:00',3.95),('325','2013-08-19','15:00:00',3.91),('325','2013-08-19','15:05:00',3.88),('325','2013-08-19','15:10:00',3.86),('325','2013-08-19','15:15:00',3.84),('325','2013-08-19','15:20:00',3.83),('325','2013-08-19','15:25:00',3.76),('325','2013-08-19','15:30:00',3.73),('325','2013-08-19','15:35:00',3.71),('325','2013-08-19','15:40:00',3.63),('325','2013-08-19','15:45:00',3.57),('325','2013-08-19','15:50:00',3.51),('325','2013-08-19','15:55:00',3.44),('325','2013-08-19','16:00:00',3.38),('325','2013-08-19','16:05:00',3.33),('325','2013-08-19','16:10:00',3.27),('325','2013-08-19','16:15:00',3.2),('325','2013-08-19','16:20:00',3.13),('325','2013-08-19','16:25:00',3.05),('325','2013-08-19','16:30:00',2.98),('325','2013-08-19','16:35:00',2.9),('325','2013-08-19','16:40:00',2.82),('325','2013-08-19','16:45:00',2.75),('325','2013-08-19','16:50:00',2.68),('325','2013-08-19','16:55:00',2.59),('325','2013-08-19','17:00:00',2.43),('325','2013-08-19','17:05:00',2.25),('325','2013-08-19','17:10:00',2.24),('325','2013-08-19','17:15:00',2.22),('325','2013-08-19','17:20:00',2.13),('325','2013-08-19','17:25:00',2.03),('325','2013-08-19','17:30:00',1.94),('325','2013-08-19','17:35:00',1.85),('325','2013-08-19','17:40:00',1.72),('325','2013-08-19','17:45:00',1.65),('325','2013-08-19','17:50:00',1.56),('325','2013-08-19','17:55:00',1.47),('325','2013-08-19','18:00:00',1.38),('325','2013-08-19','18:05:00',1.29),('325','2013-08-19','18:10:00',1.19),('325','2013-08-19','18:15:00',1.1),('325','2014-04-09','09:50:00',1.71),('325','2014-04-09','09:55:00',2.02),('325','2014-04-09','10:00:00',2.01),('325','2014-04-09','10:05:00',2.02),('325','2014-04-09','10:10:00',2.03),('325','2014-04-09','10:15:00',2.6),('325','2014-04-09','10:20:00',3.33),('325','2014-04-09','10:25:00',3.61),('325','2014-04-09','10:30:00',3.84),('325','2014-04-09','10:35:00',2.17),('325','2014-04-09','10:40:00',1.5),('325','2014-04-09','10:45:00',2.01),('325','2014-04-09','10:50:00',1.58),('325','2014-04-09','10:55:00',4.26),('325','2014-04-09','11:00:00',4.33),('325','2014-04-09','11:05:00',4.47),('325','2014-04-09','11:10:00',4.58),('325','2014-04-09','11:15:00',4.68),('325','2014-04-09','11:20:00',2.92),('325','2014-04-09','11:25:00',1.6),('325','2014-04-09','11:30:00',2.05),('325','2014-04-09','11:35:00',4.73),('325','2014-04-09','11:40:00',4.12),('325','2014-04-09','11:45:00',2.3),('325','2014-04-09','11:50:00',3.51),('325','2014-04-09','11:55:00',4.81),('325','2014-04-09','12:00:00',4.96),('325','2014-04-09','12:05:00',5.21),('325','2014-04-09','12:10:00',4.7),('325','2014-04-09','12:15:00',1.88),('325','2014-04-09','12:20:00',1.57),('325','2014-04-09','12:25:00',1.15),('325','2014-04-09','12:30:00',1.01),('325','2014-04-09','13:15:00',1.16),('325','2014-04-09','13:20:00',1.34),('325','2014-04-09','13:25:00',1.35),('325','2014-04-09','13:30:00',1.06),('325','2014-04-09','13:35:00',1.1),('325','2014-04-09','14:00:00',1.1),('325','2014-04-09','14:05:00',1.47),('325','2014-04-09','14:10:00',1.53),('325','2014-04-09','14:15:00',1.46),('325','2014-04-09','14:20:00',1.33),('325','2014-04-09','14:25:00',1.54),('325','2014-04-09','14:30:00',1.61),('325','2014-04-09','14:35:00',2.7),('325','2014-04-09','14:40:00',2.72),('325','2014-04-09','14:45:00',2.12),('325','2014-04-09','14:50:00',2.48),('325','2014-04-09','14:55:00',2.68),('325','2014-04-09','15:00:00',1.96),('325','2014-04-09','15:05:00',4.05),('325','2014-04-09','15:10:00',4.73),('325','2014-04-09','15:15:00',3.92),('325','2014-04-09','15:20:00',4.33),('325','2014-04-09','15:25:00',3.45),('325','2014-04-09','15:30:00',2.07),('325','2014-04-09','15:35:00',2.99),('325','2014-04-09','15:40:00',2.98),('325','2014-04-09','15:45:00',1.66),('325','2014-04-09','15:50:00',1.32),('325','2014-04-09','15:55:00',1.32),('325','2014-04-09','16:00:00',2.08),('325','2014-04-09','16:05:00',1.8),('325','2014-04-09','16:10:00',3.1),('325','2014-04-09','16:15:00',3.4),('325','2014-04-09','16:20:00',3.09),('325','2014-04-09','16:25:00',3.11),('325','2014-04-09','16:30:00',3.5),('325','2014-04-09','16:35:00',3.59),('325','2014-04-09','16:40:00',2.62),('325','2014-04-09','16:45:00',3),('325','2014-04-09','16:50:00',2.01),('325','2014-04-09','16:55:00',2.39),('325','2014-04-09','17:00:00',2.4),('325','2014-04-09','17:05:00',2.88),('325','2014-04-09','17:10:00',2.36),('325','2014-04-09','17:15:00',2.1),('325','2014-04-09','17:20:00',2.01),('325','2014-04-09','17:25:00',1.93),('325','2014-04-09','17:30:00',1.54),('325','2014-04-09','17:45:00',1.23),('325','2014-04-09','17:50:00',1.25),('325','2014-04-09','17:55:00',1.21),('325','2014-04-09','18:00:00',1.04),('325','2013-08-18','08:50:00',1.05),('325','2013-08-18','08:55:00',1.1),('325','2013-08-18','09:00:00',1.14),('325','2013-08-18','09:05:00',1.19),('325','2013-08-18','09:10:00',1.58),('325','2013-08-18','09:15:00',1.85),('325','2013-08-18','09:20:00',2.01),('325','2013-08-18','09:25:00',2.07),('325','2013-08-18','09:30:00',2.26),('325','2013-08-18','09:35:00',2.32),('325','2013-08-18','09:40:00',2.36),('325','2013-08-18','09:45:00',2.42),('325','2013-08-18','09:50:00',2.45),('325','2013-08-18','09:55:00',2.15),('325','2013-08-18','10:00:00',2.67),('325','2013-08-18','10:05:00',2.32),('325','2013-08-18','10:10:00',2.83),('325','2013-08-18','10:15:00',2.65),('325','2013-08-18','10:20:00',2.64),('325','2013-08-18','10:25:00',2.95),('325','2013-08-18','10:30:00',3.01),('325','2013-08-18','10:35:00',3.06),('325','2013-08-18','10:40:00',3.09),('325','2013-08-18','10:45:00',3.15),('325','2013-08-18','10:50:00',3.27),('325','2013-08-18','10:55:00',3.22),('325','2013-08-18','11:00:00',3.46),('325','2013-08-18','11:05:00',3.54),('325','2013-08-18','11:10:00',3.53),('325','2013-08-18','11:15:00',3.57),('325','2013-08-18','11:20:00',3.59),('325','2013-08-18','11:25:00',3.64),('325','2013-08-18','11:30:00',3.63),('325','2013-08-18','11:35:00',3.71),('325','2013-08-18','11:40:00',3.76),('325','2013-08-18','11:45:00',3.81),('325','2013-08-18','11:50:00',3.83),('325','2013-08-18','11:55:00',3.94),('325','2013-08-18','12:00:00',4.02),('325','2013-08-18','12:05:00',4.09),('325','2013-08-18','12:10:00',4.22),('325','2013-08-18','12:15:00',4.25),('325','2013-08-18','12:20:00',3.78),('325','2013-08-18','12:25:00',2.4),('325','2013-08-18','12:30:00',1.39),('325','2013-08-18','12:35:00',1.01),('325','2013-08-18','12:45:00',1.17),('325','2013-08-18','12:50:00',1.37),('325','2013-08-18','12:55:00',2.83),('325','2013-08-18','13:00:00',3.72),('325','2013-08-18','13:05:00',3.25),('325','2013-08-18','13:10:00',4.42),('325','2013-08-18','13:15:00',4.32),('325','2013-08-18','13:20:00',4.34),('325','2013-08-18','13:25:00',4.24),('325','2013-08-18','13:30:00',4.22),('325','2013-08-18','13:35:00',4.22),('325','2013-08-18','13:40:00',4.24),('325','2013-08-18','13:45:00',4.24),('325','2013-08-18','13:50:00',4.17),('325','2013-08-18','13:55:00',4.21),('325','2013-08-18','14:00:00',4.26),('325','2013-08-18','14:05:00',4.17),('325','2013-08-18','14:10:00',4.15),('325','2013-08-18','14:15:00',4.11),('325','2013-08-18','14:20:00',4.08),('325','2013-08-18','14:25:00',4.04),('325','2013-08-18','14:30:00',4.01),('325','2013-08-18','14:35:00',3.98),('325','2013-08-18','14:40:00',3.97),('325','2013-08-18','14:45:00',4),('325','2013-08-18','14:50:00',3.97),('325','2013-08-18','14:55:00',3.93),('325','2013-08-18','15:00:00',3.93),('325','2013-08-18','15:05:00',3.91),('325','2013-08-18','15:10:00',3.86),('325','2013-08-18','15:15:00',3.81),('325','2013-08-18','15:20:00',3.79),('325','2013-08-18','15:25:00',3.75),('325','2013-08-18','15:30:00',3.72),('325','2013-08-18','15:35:00',3.68),('325','2013-08-18','15:40:00',3.63),('325','2013-08-18','15:45:00',3.57),('325','2013-08-18','15:50:00',3.49),('325','2013-08-18','15:55:00',3.44),('325','2013-08-18','16:00:00',3.38),('325','2013-08-18','16:05:00',3.33),('325','2013-08-18','16:10:00',3.26),('325','2013-08-18','16:15:00',3.19),('325','2013-08-18','16:20:00',3.12),('325','2013-08-18','16:25:00',3.06),('325','2013-08-18','16:30:00',2.99),('325','2013-08-18','16:35:00',2.92),('325','2013-08-18','16:40:00',2.84),('325','2013-08-18','16:45:00',2.77),('325','2013-08-18','16:50:00',2.69),('325','2013-08-18','16:55:00',2.58),('325','2013-08-18','17:00:00',2.45),('325','2013-08-18','17:05:00',2.29),('325','2013-08-18','17:10:00',2.11),('325','2013-08-18','17:15:00',2.21),('325','2013-08-18','17:20:00',2.17),('325','2013-08-18','17:25:00',2.08),('325','2013-08-18','17:30:00',1.98),('325','2013-08-18','17:35:00',1.88),('325','2013-08-18','17:40:00',1.74),('325','2013-08-18','17:45:00',1.67),('325','2013-08-18','17:50:00',1.58),('325','2013-08-18','17:55:00',1.48),('325','2013-08-18','18:00:00',1.39),('325','2013-08-18','18:05:00',1.3),('325','2013-08-18','18:10:00',1.21),('325','2013-08-18','18:15:00',1.13),('325','2013-08-18','18:20:00',1.02),('325','2013-08-17','08:50:00',1.02),('325','2013-08-17','08:55:00',1.07),('325','2013-08-17','09:00:00',1.12),('325','2013-08-17','09:05:00',1.16),('325','2013-08-17','09:10:00',1.34),('325','2013-08-17','09:15:00',1.98),('325','2013-08-17','09:20:00',2.07),('325','2013-08-17','09:25:00',2.13),('325','2013-08-17','09:30:00',2.19),('325','2013-08-17','09:35:00',2.3),('325','2013-08-17','09:40:00',2.38),('325','2013-08-17','09:45:00',2.49),('325','2013-08-17','09:50:00',2.61),('325','2013-08-17','09:55:00',2.78),('325','2013-08-17','10:00:00',2.85),('325','2013-08-17','10:05:00',2.87),('325','2013-08-17','10:10:00',2.91),('325','2013-08-17','10:15:00',2.87),('325','2013-08-17','10:20:00',2.68),('325','2013-08-17','10:25:00',2.64),('325','2013-08-17','10:30:00',3),('325','2013-08-17','10:35:00',3.05),('325','2013-08-17','10:40:00',3.11),('325','2013-08-17','10:45:00',3.17),('325','2013-08-17','10:50:00',3.27),('325','2013-08-17','10:55:00',3.37),('325','2013-08-17','11:00:00',3.48),('325','2013-08-17','11:05:00',3.57),('325','2013-08-17','11:10:00',3.56),('325','2013-08-17','11:15:00',3.57),('325','2013-08-17','11:20:00',3.62),('325','2013-08-17','11:25:00',3.65),('325','2013-08-17','11:30:00',3.68),('325','2013-08-17','11:35:00',3.74),('325','2013-08-17','11:40:00',3.82),('325','2013-08-17','11:45:00',3.91),('325','2013-08-17','11:50:00',3.88),('325','2013-08-17','11:55:00',3.87),('325','2013-08-17','12:00:00',4.06),('325','2013-08-17','12:05:00',4.09),('325','2013-08-17','12:10:00',4.07),('325','2013-08-17','12:15:00',4.04),('325','2013-08-17','12:20:00',4.01),('325','2013-08-17','12:25:00',4.21),('325','2013-08-17','12:30:00',4.22),('325','2013-08-17','12:35:00',4.23),('325','2013-08-17','12:40:00',4.03),('325','2013-08-17','12:45:00',4.17),('325','2013-08-17','12:50:00',4.24),('325','2013-08-17','12:55:00',4.29),('325','2013-08-17','13:00:00',4.29),('325','2013-08-17','13:05:00',3.6),('325','2013-08-17','13:10:00',2.02),('325','2013-08-17','13:15:00',4.36),('325','2013-08-17','13:20:00',4.43),('325','2013-08-17','13:25:00',4.37),('325','2013-08-17','13:30:00',4.36),('325','2013-08-17','13:35:00',3.3),('325','2013-08-17','13:40:00',1.71),('325','2013-08-17','13:45:00',3.53),('325','2013-08-17','13:50:00',1.81),('325','2013-08-17','13:55:00',3.72),('325','2013-08-17','14:00:00',1.34),('325','2013-08-17','14:05:00',4.17),('325','2013-08-17','14:10:00',4.23),('325','2013-08-17','14:15:00',4.13),('325','2013-08-17','14:20:00',3.49),('325','2013-08-17','14:25:00',4.07),('325','2013-08-17','14:30:00',4.07),('325','2013-08-17','14:35:00',3.94),('325','2013-08-17','14:40:00',3.88),('325','2013-08-17','14:45:00',3.95),('325','2013-08-17','14:50:00',3.96),('325','2013-08-17','14:55:00',3.94),('325','2013-08-17','15:00:00',3.89),('325','2013-08-17','15:05:00',3.9),('325','2013-08-17','15:10:00',3.84),('325','2013-08-17','15:15:00',3.81),('325','2013-08-17','15:20:00',3.83),('325','2013-08-17','15:25:00',3.73),('325','2013-08-17','15:30:00',3.74),('325','2013-08-17','15:35:00',3.69),('325','2013-08-17','15:40:00',3.64),('325','2013-08-17','15:45:00',3.57),('325','2013-08-17','15:50:00',3.52),('325','2013-08-17','15:55:00',3.49),('325','2013-08-17','16:00:00',3.42),('325','2013-08-17','16:05:00',3.34),('325','2013-08-17','16:10:00',3.27),('325','2013-08-17','16:15:00',3.24),('325','2013-08-17','16:20:00',3.18),('325','2013-08-17','16:25:00',3.12),('325','2013-08-17','16:30:00',3.08),('325','2013-08-17','16:35:00',3),('325','2013-08-17','16:40:00',2.92),('325','2013-08-17','16:45:00',2.78),('325','2013-08-17','16:50:00',2.72),('325','2013-08-17','16:55:00',2.66),('325','2013-08-17','17:00:00',2.51),('325','2013-08-17','17:05:00',2.34),('325','2013-08-17','17:10:00',2.08),('325','2013-08-17','17:15:00',1.84),('325','2013-08-17','17:20:00',1.8),('325','2013-08-17','17:25:00',2.17),('325','2013-08-17','17:30:00',2.11),('325','2013-08-17','17:35:00',2.02),('325','2013-08-17','17:40:00',1.87),('325','2013-08-17','17:45:00',1.8),('325','2013-08-17','17:50:00',1.69),('325','2013-08-17','17:55:00',1.59),('325','2013-08-17','18:00:00',1.49),('325','2013-08-17','18:05:00',1.38),('325','2013-08-17','18:10:00',1.29),('325','2013-08-17','18:15:00',1.19),('325','2013-08-17','18:20:00',1.09),('325','2013-08-16','08:50:00',1.03),('325','2013-08-16','08:55:00',1.08),('325','2013-08-16','09:00:00',1.13),('325','2013-08-16','09:05:00',1.18),('325','2013-08-16','09:10:00',1.25),('325','2013-08-16','09:15:00',1.86),('325','2013-08-16','09:20:00',2.04),('325','2013-08-16','09:25:00',2.11),('325','2013-08-16','09:30:00',2.18),('325','2013-08-16','09:35:00',2.31),('325','2013-08-16','09:40:00',2.48),('325','2013-08-16','09:45:00',2.56),('325','2013-08-16','09:50:00',2.62),('325','2013-08-16','09:55:00',2.7),('325','2013-08-16','10:00:00',2.79),('325','2013-08-16','10:05:00',2.86),('325','2013-08-16','10:10:00',3.01),('325','2013-08-16','10:15:00',3.02),('325','2013-08-16','10:20:00',2.99),('325','2013-08-16','10:25:00',3.12),('325','2013-08-16','10:30:00',3.33),('325','2013-08-16','10:35:00',3.39),('325','2013-08-16','10:40:00',3.45),('325','2013-08-16','10:45:00',3.53),('325','2013-08-16','10:50:00',3.63),('325','2013-08-16','10:55:00',3.68),('325','2013-08-16','11:00:00',3.72),('325','2013-08-16','11:05:00',3.75),('325','2013-08-16','11:10:00',3.79),('325','2013-08-16','11:15:00',3.83),('325','2013-08-16','11:20:00',3.85),('325','2013-08-16','11:25:00',3.88),('325','2013-08-16','11:30:00',3.89),('325','2013-08-16','11:35:00',3.91),('325','2013-08-16','11:40:00',3.94),('325','2013-08-16','11:45:00',3.96),('325','2013-08-16','11:50:00',4.02),('325','2013-08-16','11:55:00',4.09),('325','2013-08-16','12:00:00',4.1),('325','2013-08-16','12:05:00',4.14),('325','2013-08-16','12:10:00',4.16),('325','2013-08-16','12:15:00',4.16),('325','2013-08-16','12:20:00',4.16),('325','2013-08-16','12:25:00',4.16),('325','2013-08-16','12:30:00',4.18),('325','2013-08-16','12:35:00',4.2),('325','2013-08-16','12:40:00',4.2),('325','2013-08-16','12:45:00',4.18),('325','2013-08-16','12:50:00',4.21),('325','2013-08-16','12:55:00',4.24),('325','2013-08-16','13:00:00',4.24),('325','2013-08-16','13:05:00',4.22),('325','2013-08-16','13:10:00',4.2),('325','2013-08-16','13:15:00',4.18),('325','2013-08-16','13:20:00',4.15),('325','2013-08-16','13:25:00',4.14),('325','2013-08-16','13:30:00',4.12),('325','2013-08-16','13:35:00',4.09),('325','2013-08-16','13:40:00',4.08),('325','2013-08-16','13:45:00',4.08),('325','2013-08-16','13:50:00',4.11),('325','2013-08-16','13:55:00',4.14),('325','2013-08-16','14:00:00',4.13),('325','2013-08-16','14:05:00',4.08),('325','2013-08-16','14:10:00',4.03),('325','2013-08-16','14:15:00',3.98),('325','2013-08-16','14:20:00',3.9),('325','2013-08-16','14:25:00',3.85),('325','2013-08-16','14:30:00',3.8),('325','2013-08-16','14:35:00',3.82),('325','2013-08-16','14:40:00',3.85),('325','2013-08-16','14:45:00',3.85),('325','2013-08-16','14:50:00',3.8),('325','2013-08-16','14:55:00',3.79),('325','2013-08-16','15:00:00',3.73),('325','2013-08-16','15:05:00',3.77),('325','2013-08-16','15:10:00',3.77),('325','2013-08-16','15:15:00',3.73),('325','2013-08-16','15:20:00',3.76),('325','2013-08-16','15:25:00',3.74),('325','2013-08-16','15:30:00',3.71),('325','2013-08-16','15:35:00',3.66),('325','2013-08-16','15:40:00',3.61),('325','2013-08-16','15:45:00',3.57),('325','2013-08-16','15:50:00',3.54),('325','2013-08-16','15:55:00',3.48),('325','2013-08-16','16:00:00',3.4),('325','2013-08-16','16:05:00',3.34),('325','2013-08-16','16:10:00',3.28),('325','2013-08-16','16:15:00',3.21),('325','2013-08-16','16:20:00',3.13),('325','2013-08-16','16:25:00',3.07),('325','2013-08-16','16:30:00',3.02),('325','2013-08-16','16:35:00',2.97),('325','2013-08-16','16:40:00',2.88),('325','2013-08-16','16:45:00',2.81),('325','2013-08-16','16:50:00',2.72),('325','2013-08-16','16:55:00',2.61),('325','2013-08-16','17:00:00',2.47),('325','2013-08-16','17:05:00',2.42),('325','2013-08-16','17:10:00',2.34),('325','2013-08-16','17:15:00',2.25),('325','2013-08-16','17:20:00',2.17),('325','2013-08-16','17:25:00',2.07),('325','2013-08-16','17:30:00',1.98),('325','2013-08-16','17:35:00',1.89),('325','2013-08-16','17:40:00',1.78),('325','2013-08-16','17:45:00',1.69),('325','2013-08-16','17:50:00',1.59),('325','2013-08-16','17:55:00',1.49),('325','2013-08-16','18:00:00',1.4),('325','2013-08-16','18:05:00',1.31),('325','2013-08-16','18:10:00',1.23),('325','2013-08-16','18:15:00',1.14),('325','2013-08-16','18:20:00',1.05),('325','2013-08-15','08:50:00',1.05),('325','2013-08-15','08:55:00',1.11),('325','2013-08-15','09:00:00',1.23),('325','2013-08-15','09:05:00',1.24),('325','2013-08-15','09:10:00',1.11),('325','2013-08-15','09:15:00',1.87),('325','2013-08-15','09:20:00',2.18),('325','2013-08-15','09:25:00',2.18),('325','2013-08-15','09:30:00',2.23),('325','2013-08-15','09:35:00',2.29),('325','2013-08-15','09:40:00',2.46),('325','2013-08-15','09:45:00',2.54),('325','2013-08-15','09:50:00',2.64),('325','2013-08-15','09:55:00',2.71),('325','2013-08-15','10:00:00',2.8),('325','2013-08-15','10:05:00',2.87),('325','2013-08-15','10:10:00',2.91),('325','2013-08-15','10:15:00',2.93),('325','2013-08-15','10:20:00',3.04),('325','2013-08-15','10:25:00',3.25),('325','2013-08-15','10:30:00',3.35),('325','2013-08-15','10:35:00',3.4),('325','2013-08-15','10:40:00',3.45),('325','2013-08-15','10:45:00',3.54),('325','2013-08-15','10:50:00',3.63),('325','2013-08-15','10:55:00',3.42),('325','2013-08-15','11:00:00',3.22),('325','2013-08-15','11:05:00',3.44),('325','2013-08-15','11:10:00',2.7),('325','2013-08-15','11:15:00',2.33),('325','2013-08-15','11:20:00',2.66),('325','2013-08-15','11:25:00',3.02),('325','2013-08-15','11:30:00',3.45),('325','2013-08-15','11:35:00',3.9),('325','2013-08-15','11:40:00',4.12),('325','2013-08-15','11:45:00',4.27),('325','2013-08-15','11:50:00',4.34),('325','2013-08-15','11:55:00',4.42),('325','2013-08-15','12:00:00',4.44),('325','2013-08-15','12:05:00',4.43),('325','2013-08-15','12:10:00',4.39),('325','2013-08-15','12:15:00',4.32),('325','2013-08-15','12:20:00',4.37),('325','2013-08-15','12:25:00',4.35),('325','2013-08-15','12:30:00',4.34),('325','2013-08-15','12:35:00',4.32),('325','2013-08-15','12:40:00',4.34),('325','2013-08-15','12:45:00',4.3),('325','2013-08-15','12:50:00',4.34),('325','2013-08-15','12:55:00',4.29),('325','2013-08-15','13:00:00',4.16),('325','2013-08-15','13:05:00',4.18),('325','2013-08-15','13:10:00',4.2),('325','2013-08-15','13:15:00',4.13),('325','2013-08-15','13:20:00',4.01),('325','2013-08-15','13:25:00',4.1),('325','2013-08-15','13:30:00',4.11),('325','2013-08-15','13:35:00',4.14),('325','2013-08-15','13:40:00',4.19),('325','2013-08-15','13:45:00',4.18),('325','2013-08-15','13:50:00',4.18),('325','2013-08-15','13:55:00',4.16),('325','2013-08-15','14:00:00',4.11),('325','2013-08-15','14:05:00',4.11),('325','2013-08-15','14:10:00',4.07),('325','2013-08-15','14:15:00',4.03),('325','2013-08-15','14:20:00',4.02),('325','2013-08-15','14:25:00',3.97),('325','2013-08-15','14:30:00',4.01),('325','2013-08-15','14:35:00',3.96),('325','2013-08-15','14:40:00',3.97),('325','2013-08-15','14:45:00',3.93),('325','2013-08-15','14:50:00',3.88),('325','2013-08-15','14:55:00',3.82),('325','2013-08-15','15:00:00',3.76),('325','2013-08-15','15:05:00',3.73),('325','2013-08-15','15:10:00',3.72),('325','2013-08-15','15:15:00',3.68),('325','2013-08-15','15:20:00',3.64),('325','2013-08-15','15:25:00',3.62),('325','2013-08-15','15:30:00',3.57),('325','2013-08-15','15:35:00',3.52),('325','2013-08-15','15:40:00',3.49),('325','2013-08-15','15:45:00',3.46),('325','2013-08-15','15:50:00',3.4),('325','2013-08-15','15:55:00',3.33),('325','2013-08-15','16:00:00',3.26),('325','2013-08-15','16:05:00',3.24),('325','2013-08-15','16:10:00',3.19),('325','2013-08-15','16:15:00',3.02),('325','2013-08-15','16:20:00',2.96),('325','2013-08-15','16:25:00',2.91),('325','2013-08-15','16:30:00',2.88),('325','2013-08-15','16:35:00',2.74),('325','2013-08-15','16:40:00',2.57),('325','2013-08-15','16:45:00',2.59),('325','2013-08-15','16:50:00',2.51),('325','2013-08-15','16:55:00',2.5),('325','2013-08-15','17:00:00',2.39),('325','2013-08-15','17:05:00',2.25),('325','2013-08-15','17:10:00',2.23),('325','2013-08-15','17:15:00',2.15),('325','2013-08-15','17:20:00',2.06),('325','2013-08-15','17:25:00',1.98),('325','2013-08-15','17:30:00',1.76),('325','2013-08-15','17:35:00',1.84),('325','2013-08-15','17:40:00',1.72),('325','2013-08-15','17:45:00',1.64),('325','2013-08-15','17:50:00',1.54),('325','2013-08-15','17:55:00',1.47),('325','2013-08-15','18:00:00',1.39),('325','2013-08-15','18:05:00',1.29),('325','2013-08-15','18:10:00',1.18),('325','2013-08-15','18:15:00',1.12),('325','2013-08-15','18:20:00',1.05),('325','2013-08-14','08:45:00',1.07),('325','2013-08-14','08:50:00',1.14),('325','2013-08-14','08:55:00',1.26),('325','2013-08-14','09:00:00',1.36),('325','2013-08-14','09:05:00',1.23),('325','2013-08-14','09:10:00',1.8),('325','2013-08-14','09:15:00',2.05),('325','2013-08-14','09:20:00',2.13),('325','2013-08-14','09:25:00',2.11),('325','2013-08-14','09:30:00',2.34),('325','2013-08-14','09:35:00',2.45),('325','2013-08-14','09:40:00',1.74),('325','2013-08-14','09:45:00',2.52),('325','2013-08-14','09:50:00',1.66),('325','2013-08-14','09:55:00',2.61),('325','2013-08-14','10:00:00',2.99),('325','2013-08-14','10:05:00',2.76),('325','2013-08-14','10:10:00',2.67),('325','2013-08-14','10:15:00',1.61),('325','2013-08-14','10:20:00',2.44),('325','2013-08-14','10:25:00',3.42),('325','2013-08-14','10:30:00',2.83),('325','2013-08-14','10:35:00',2.06),('325','2013-08-14','10:40:00',1.22),('325','2013-08-14','10:45:00',1.01),('325','2013-08-14','10:50:00',1.04),('325','2013-08-14','10:55:00',1.26),('325','2013-08-14','11:00:00',3.7),('325','2013-08-14','11:05:00',3.75),('325','2013-08-14','11:10:00',3.61),('325','2013-08-14','11:15:00',3.7),('325','2013-08-14','11:20:00',3.48),('325','2013-08-14','11:25:00',3.68),('325','2013-08-14','11:30:00',4.07),('325','2013-08-14','11:35:00',2.57),('325','2013-08-14','11:40:00',1.65),('325','2013-08-14','11:45:00',1.48),('325','2013-08-14','11:50:00',2.17),('325','2013-08-14','11:55:00',3.79),('325','2013-08-14','12:00:00',4.08),('325','2013-08-14','12:05:00',2.05),('325','2013-08-14','12:10:00',1.49),('325','2013-08-14','12:15:00',1.34),('325','2013-08-14','12:20:00',1.23),('325','2013-08-14','12:25:00',1.59),('325','2013-08-14','12:30:00',1.24),('325','2013-08-14','12:35:00',1.34),('325','2013-08-14','12:40:00',1.63),('325','2013-08-14','12:45:00',2.03),('325','2013-08-14','12:50:00',2.87),('325','2013-08-14','12:55:00',3.26),('325','2013-08-14','13:00:00',2.27),('325','2013-08-14','13:05:00',1.11),('325','2013-08-14','13:10:00',1.22),('325','2013-08-14','13:15:00',1.59),('325','2013-08-14','13:20:00',1.41),('325','2013-08-14','13:25:00',3.3),('325','2013-08-14','13:30:00',4.46),('325','2013-08-14','13:35:00',2.21),('325','2013-08-14','13:40:00',3.03),('325','2013-08-14','13:45:00',4.71),('325','2013-08-14','13:50:00',3.77),('325','2013-08-14','13:55:00',3.04),('325','2013-08-14','14:00:00',4.65),('325','2013-08-14','14:05:00',3.57),('325','2013-08-14','14:10:00',4.39),('325','2013-08-14','14:15:00',4.44),('325','2013-08-14','14:20:00',3.5),('325','2013-08-14','14:25:00',4.33),('325','2013-08-14','14:30:00',3.8),('325','2013-08-14','14:35:00',4.26),('325','2013-08-14','14:40:00',4.19),('325','2013-08-14','14:45:00',4.11),('325','2013-08-14','14:50:00',4.14),('325','2013-08-14','14:55:00',4.11),('325','2013-08-14','15:00:00',3.97),('325','2013-08-14','15:05:00',3.91),('325','2013-08-14','15:10:00',3.75),('325','2013-08-14','15:15:00',3.96),('325','2013-08-14','15:20:00',3.91),('325','2013-08-14','15:25:00',3.83),('325','2013-08-14','15:30:00',3.72),('325','2013-08-14','15:35:00',3.69),('325','2013-08-14','15:40:00',3.67),('325','2013-08-14','15:45:00',3.61),('325','2013-08-14','15:50:00',3.55),('325','2013-08-14','15:55:00',3.52),('325','2013-08-14','16:00:00',3.43),('325','2013-08-14','16:05:00',3.37),('325','2013-08-14','16:10:00',3.35),('325','2013-08-14','16:15:00',3.32),('325','2013-08-14','16:20:00',3.24),('325','2013-08-14','16:25:00',3.16),('325','2013-08-14','16:30:00',3.09),('325','2013-08-14','16:35:00',3.02),('325','2013-08-14','16:40:00',2.96),('325','2013-08-14','16:45:00',2.88),('325','2013-08-14','16:50:00',2.78),('325','2013-08-14','16:55:00',2.69),('325','2013-08-14','17:00:00',2.56),('325','2013-08-14','17:05:00',2.5),('325','2013-08-14','17:10:00',2.39),('325','2013-08-14','17:15:00',2.32),('325','2013-08-14','17:20:00',2.21),('325','2013-08-14','17:25:00',2.12),('325','2013-08-14','17:30:00',2.02),('325','2013-08-14','17:35:00',1.95),('325','2013-08-14','17:40:00',1.84),('325','2013-08-14','17:45:00',1.75),('325','2013-08-14','17:50:00',1.66),('325','2013-08-14','17:55:00',1.56),('325','2013-08-14','18:00:00',1.46),('325','2013-08-14','18:05:00',1.39),('325','2013-08-14','18:10:00',1.3),('325','2013-08-14','18:15:00',1.21),('325','2013-08-14','18:20:00',1.16),('325','2013-08-14','18:25:00',1.11),('325','2013-08-14','18:30:00',1.01),('325','2013-08-13','08:45:00',1.03),('325','2013-08-13','08:50:00',1.07),('325','2013-08-13','08:55:00',1.09),('325','2013-08-13','09:00:00',1.14),('325','2013-08-13','09:05:00',1.19),('325','2013-08-13','09:10:00',1.26),('325','2013-08-13','09:15:00',1.41),('325','2013-08-13','09:20:00',2),('325','2013-08-13','09:25:00',2.09),('325','2013-08-13','09:30:00',2.16),('325','2013-08-13','09:35:00',2.23),('325','2013-08-13','09:40:00',2.24),('325','2013-08-13','09:45:00',2.39),('325','2013-08-13','09:50:00',2.48),('325','2013-08-13','09:55:00',2.58),('325','2013-08-13','10:00:00',2.74),('325','2013-08-13','10:05:00',2.62),('325','2013-08-13','10:10:00',2.77),('325','2013-08-13','10:15:00',3.04),('325','2013-08-13','10:20:00',3.13),('325','2013-08-13','10:25:00',3.23),('325','2013-08-13','10:30:00',3.31),('325','2013-08-13','10:35:00',3.28),('325','2013-08-13','10:40:00',3.31),('325','2013-08-13','10:45:00',3.41),('325','2013-08-13','10:50:00',3.54),('325','2013-08-13','10:55:00',3.55),('325','2013-08-13','11:00:00',3.63),('325','2013-08-13','11:05:00',3.67),('325','2013-08-13','11:10:00',3.7),('325','2013-08-13','11:15:00',3.75),('325','2013-08-13','11:20:00',3.76),('325','2013-08-13','11:25:00',3.81),('325','2013-08-13','11:30:00',3.82),('325','2013-08-13','11:35:00',3.82),('325','2013-08-13','11:40:00',3.83),('325','2013-08-13','11:45:00',3.87),('325','2013-08-13','11:50:00',3.95),('325','2013-08-13','11:55:00',4.05),('325','2013-08-13','12:00:00',2.51),('325','2013-08-13','12:05:00',4.2),('325','2013-08-13','12:10:00',4.34),('325','2013-08-13','12:15:00',4.38),('325','2013-08-13','12:20:00',4.29),('325','2013-08-13','12:25:00',4.39),('325','2013-08-13','12:30:00',4.45),('325','2013-08-13','12:35:00',2.27),('325','2013-08-13','12:40:00',2.3),('325','2013-08-13','12:45:00',2.33),('325','2013-08-13','12:50:00',1.65),('325','2013-08-13','12:55:00',1.6),('325','2013-08-13','13:00:00',1.41),('325','2013-08-13','13:05:00',3.72),('325','2013-08-13','13:10:00',4.6),('325','2013-08-13','13:15:00',4.66),('325','2013-08-13','13:20:00',1.71),('325','2013-08-13','13:25:00',1.37),('325','2013-08-13','13:30:00',2.23),('325','2013-08-13','13:35:00',4.79),('325','2013-08-13','13:40:00',2.72),('325','2013-08-13','13:45:00',1.48),('325','2013-08-13','13:50:00',1.53),('325','2013-08-13','13:55:00',3.24),('325','2013-08-13','14:00:00',4.79),('325','2013-08-13','14:05:00',4.64),('325','2013-08-13','14:10:00',4.53),('325','2013-08-13','14:15:00',4.2),('325','2013-08-13','14:20:00',4.35),('325','2013-08-13','14:25:00',3.68),('325','2013-08-13','14:30:00',3.93),('325','2013-08-13','14:35:00',2.71),('325','2013-08-13','14:40:00',3.68),('325','2013-08-13','14:45:00',2.96),('325','2013-08-13','14:50:00',3.29),('325','2013-08-13','14:55:00',3.88),('325','2013-08-13','15:00:00',4.01),('325','2013-08-13','15:05:00',3.61),('325','2013-08-13','15:10:00',4.1),('325','2013-08-13','15:15:00',3.94),('325','2013-08-13','15:20:00',3.9),('325','2013-08-13','15:25:00',3.86),('325','2013-08-13','15:30:00',3.84),('325','2013-08-13','15:35:00',3.82),('325','2013-08-13','15:40:00',3.74),('325','2013-08-13','15:45:00',3.66),('325','2013-08-13','15:50:00',3.57),('325','2013-08-13','15:55:00',3.49),('325','2013-08-13','16:00:00',3.45),('325','2013-08-13','16:05:00',3.4),('325','2013-08-13','16:10:00',3.33),('325','2013-08-13','16:15:00',3.26),('325','2013-08-13','16:20:00',3.21),('325','2013-08-13','16:25:00',3.15),('325','2013-08-13','16:30:00',3.09),('325','2013-08-13','16:35:00',3.01),('325','2013-08-13','16:40:00',2.95),('325','2013-08-13','16:45:00',2.85),('325','2013-08-13','16:50:00',2.77),('325','2013-08-13','16:55:00',2.67),('325','2013-08-13','17:00:00',2.54),('325','2013-08-13','17:05:00',2.48),('325','2013-08-13','17:10:00',2.42),('325','2013-08-13','17:15:00',2.33),('325','2013-08-13','17:20:00',2.24),('325','2013-08-13','17:25:00',2.14),('325','2013-08-13','17:30:00',2.04),('325','2013-08-13','17:35:00',1.96),('325','2013-08-13','17:40:00',1.84),('325','2013-08-13','17:45:00',1.75),('325','2013-08-13','17:50:00',1.66),('325','2013-08-13','17:55:00',1.57),('325','2013-08-13','18:00:00',1.47),('325','2013-08-13','18:05:00',1.38),('325','2013-08-13','18:10:00',1.28),('325','2013-08-13','18:15:00',1.19),('325','2013-08-13','18:20:00',1.11),('325','2013-08-13','18:25:00',1),('325','2013-08-12','08:45:00',1.02),('325','2013-08-12','08:50:00',1.06),('325','2013-08-12','08:55:00',1.09),('325','2013-08-12','09:00:00',1.14),('325','2013-08-12','09:05:00',1.2),('325','2013-08-12','09:10:00',1.26),('325','2013-08-12','09:15:00',1.31),('325','2013-08-12','09:20:00',1.75),('325','2013-08-12','09:25:00',2.06),('325','2013-08-12','09:30:00',2.12),('325','2013-08-12','09:35:00',2.21),('325','2013-08-12','09:40:00',2.26),('325','2013-08-12','09:45:00',2.36),('325','2013-08-12','09:50:00',2.56),('325','2013-08-12','09:55:00',2.65),('325','2013-08-12','10:00:00',2.72),('325','2013-08-12','10:05:00',2.79),('325','2013-08-12','10:10:00',2.82),('325','2013-08-12','10:15:00',2.84),('325','2013-08-12','10:20:00',2.88),('325','2013-08-12','10:25:00',2.93),('325','2013-08-12','10:30:00',3.02),('325','2013-08-12','10:35:00',3.05),('325','2013-08-12','10:40:00',3.09),('325','2013-08-12','10:45:00',3.12),('325','2013-08-12','10:50:00',3.2),('325','2013-08-12','10:55:00',3.3),('325','2013-08-12','11:00:00',3.37),('325','2013-08-12','11:05:00',3.5),('325','2013-08-12','11:10:00',3.56),('325','2013-08-12','11:15:00',3.57),('325','2013-08-12','11:20:00',3.6),('325','2013-08-12','11:25:00',3.66),('325','2013-08-12','11:30:00',3.69),('325','2013-08-12','11:35:00',3.74),('325','2013-08-12','11:40:00',3.78),('325','2013-08-12','11:45:00',3.83),('325','2013-08-12','11:50:00',3.7),('325','2013-08-12','11:55:00',3.74),('325','2013-08-12','12:00:00',4.23),('325','2013-08-12','12:05:00',4.28),('325','2013-08-12','12:10:00',3.44),('325','2013-08-12','12:15:00',1.27),('325','2013-08-12','12:20:00',1.98),('325','2013-08-12','12:25:00',1.71),('325','2013-08-12','12:30:00',3.57),('325','2013-08-12','12:35:00',4.54),('325','2013-08-12','12:40:00',2.27),('325','2013-08-12','12:45:00',1.19),('325','2013-08-12','12:50:00',1.1),('325','2013-08-12','12:55:00',1.1),('325','2013-08-12','13:15:00',1.19),('325','2013-08-12','13:20:00',1.63),('325','2013-08-12','13:25:00',1.56),('325','2013-08-12','13:30:00',1.34),('325','2013-08-12','13:35:00',1.49),('325','2013-08-12','13:40:00',1.27),('325','2013-08-12','13:45:00',1.59),('325','2013-08-12','13:50:00',4.97),('325','2013-08-12','13:55:00',3.39),('325','2013-08-12','14:00:00',2.8),('325','2013-08-12','14:05:00',4.27),('325','2013-08-12','14:10:00',1.24),('325','2013-08-12','14:15:00',1.01),('325','2013-08-12','14:30:00',1),('325','2013-08-12','14:35:00',1.27),('325','2013-08-12','14:40:00',1.3),('325','2013-08-12','14:45:00',2.47),('325','2013-08-12','14:50:00',1.88),('325','2013-08-12','14:55:00',3.17),('325','2013-08-12','15:00:00',4.47),('325','2013-08-12','15:05:00',3.37),('325','2013-08-12','15:10:00',3.38),('325','2013-08-12','15:15:00',3.32),('325','2013-08-12','15:20:00',3.38),('325','2013-08-12','15:25:00',3.95),('325','2013-08-12','15:30:00',3.83),('325','2013-08-12','15:35:00',3.72),('325','2013-08-12','15:40:00',3.73),('325','2013-08-12','15:45:00',3.68),('325','2013-08-12','15:50:00',3.61),('325','2013-08-12','15:55:00',3.53),('325','2013-08-12','16:00:00',3.47),('325','2013-08-12','16:05:00',3.38),('325','2013-08-12','16:10:00',3.3),('325','2013-08-12','16:15:00',3.23),('325','2013-08-12','16:20:00',3.21),('325','2013-08-12','16:25:00',3.15),('325','2013-08-12','16:30:00',3.06),('325','2013-08-12','16:35:00',3),('325','2013-08-12','16:40:00',2.86),('325','2013-08-12','16:45:00',2.81),('325','2013-08-12','16:50:00',2.74),('325','2013-08-12','16:55:00',2.7),('325','2013-08-12','17:00:00',2.53),('325','2013-08-12','17:05:00',2.43),('325','2013-08-12','17:10:00',2.37),('325','2013-08-12','17:15:00',2.3),('325','2013-08-12','17:20:00',2.21),('325','2013-08-12','17:25:00',2.13),('325','2013-08-12','17:30:00',2.04),('325','2013-08-12','17:35:00',1.96),('325','2013-08-12','17:40:00',1.83),('325','2013-08-12','17:45:00',1.71),('325','2013-08-12','17:50:00',1.66),('325','2013-08-12','17:55:00',1.58),('325','2013-08-12','18:00:00',1.49),('325','2013-08-12','18:05:00',1.39),('325','2013-08-12','18:10:00',1.3),('325','2013-08-12','18:15:00',1.21),('325','2013-08-12','18:20:00',1.13),('325','2013-08-12','18:25:00',1.05),('325','2013-08-11','08:40:00',1.03),('325','2013-08-11','08:45:00',1.1),('325','2013-08-11','08:50:00',1.15),('325','2013-08-11','08:55:00',1.23),('325','2013-08-11','09:00:00',1.28),('325','2013-08-11','09:05:00',1.32),('325','2013-08-11','09:10:00',1.35),('325','2013-08-11','09:15:00',1.38),('325','2013-08-11','09:20:00',1.46),('325','2013-08-11','09:25:00',2.16),('325','2013-08-11','09:30:00',2.23),('325','2013-08-11','09:35:00',2.29),('325','2013-08-11','09:40:00',2.35),('325','2013-08-11','09:45:00',2.41),('325','2013-08-11','09:50:00',2.59),('325','2013-08-11','09:55:00',2.72),('325','2013-08-11','10:00:00',2.8),('325','2013-08-11','10:05:00',2.87),('325','2013-08-11','10:10:00',2.92),('325','2013-08-11','10:15:00',2.94),('325','2013-08-11','10:20:00',2.96),('325','2013-08-11','10:25:00',3.05),('325','2013-08-11','10:30:00',3.13),('325','2013-08-11','10:35:00',3.17),('325','2013-08-11','10:40:00',3.18),('325','2013-08-11','10:45:00',3.22),('325','2013-08-11','10:50:00',3.3),('325','2013-08-11','10:55:00',3.4),('325','2013-08-11','11:00:00',3.51),('325','2013-08-11','11:05:00',3.62),('325','2013-08-11','11:10:00',3.68),('325','2013-08-11','11:15:00',3.67),('325','2013-08-11','11:20:00',3.68),('325','2013-08-11','11:25:00',3.7),('325','2013-08-11','11:30:00',3.74),('325','2013-08-11','11:35:00',3.78),('325','2013-08-11','11:40:00',3.82),('325','2013-08-11','11:45:00',3.89),('325','2013-08-11','11:50:00',3.96),('325','2013-08-11','11:55:00',4.05),('325','2013-08-11','12:00:00',4.11),('325','2013-08-11','12:05:00',4.16),('325','2013-08-11','12:10:00',4.18),('325','2013-08-11','12:15:00',4.18),('325','2013-08-11','12:20:00',4.17),('325','2013-08-11','12:25:00',4.16),('325','2013-08-11','12:30:00',4.17),('325','2013-08-11','12:35:00',4.17),('325','2013-08-11','12:40:00',4.19),('325','2013-08-11','12:45:00',4.18),('325','2013-08-11','12:50:00',4.19),('325','2013-08-11','12:55:00',4.26),('325','2013-08-11','13:00:00',4.28),('325','2013-08-11','13:05:00',4.29),('325','2013-08-11','13:10:00',4.28),('325','2013-08-11','13:15:00',4.23),('325','2013-08-11','13:20:00',4.13),('325','2013-08-11','13:25:00',4.14),('325','2013-08-11','13:30:00',4.1),('325','2013-08-11','13:35:00',4.07),('325','2013-08-11','13:40:00',4.1),('325','2013-08-11','13:45:00',4.16),('325','2013-08-11','13:50:00',4.15),('325','2013-08-11','13:55:00',4.13),('325','2013-08-11','14:00:00',4.12),('325','2013-08-11','14:05:00',4.09),('325','2013-08-11','14:10:00',4.03),('325','2013-08-11','14:15:00',4),('325','2013-08-11','14:20:00',3.95),('325','2013-08-11','14:25:00',3.9),('325','2013-08-11','14:30:00',3.86),('325','2013-08-11','14:35:00',3.76),('325','2013-08-11','14:40:00',3.78),('325','2013-08-11','14:45:00',3.8),('325','2013-08-11','14:50:00',3.78),('325','2013-08-11','14:55:00',3.73),('325','2013-08-11','15:00:00',3.53),('325','2013-08-11','15:05:00',3.58),('325','2013-08-11','15:10:00',3.71),('325','2013-08-11','15:15:00',3.62),('325','2013-08-11','15:20:00',3.3),('325','2013-08-11','15:25:00',2.77),('325','2013-08-11','15:30:00',3.11),('325','2013-08-11','15:35:00',3.53),('325','2013-08-11','15:40:00',3.54),('325','2013-08-11','15:45:00',3.54),('325','2013-08-11','15:50:00',3.49),('325','2013-08-11','15:55:00',3.49),('325','2013-08-11','16:00:00',3.4),('325','2013-08-11','16:05:00',3.36),('325','2013-08-11','16:10:00',3.31),('325','2013-08-11','16:15:00',3.24),('325','2013-08-11','16:20:00',3.16),('325','2013-08-11','16:25:00',3.09),('325','2013-08-11','16:30:00',3.02),('325','2013-08-11','16:35:00',2.97),('325','2013-08-11','16:40:00',2.88),('325','2013-08-11','16:45:00',2.8),('325','2013-08-11','16:50:00',2.73),('325','2013-08-11','16:55:00',2.64),('325','2013-08-11','17:00:00',2.52),('325','2013-08-11','17:05:00',2.43),('325','2013-08-11','17:10:00',2.38),('325','2013-08-11','17:15:00',2.3),('325','2013-08-11','17:20:00',2.22),('325','2013-08-11','17:25:00',2.13),('325','2013-08-11','17:30:00',2.04),('325','2013-08-11','17:35:00',1.96),('325','2013-08-11','17:40:00',1.85),('325','2013-08-11','17:45:00',1.72),('325','2013-08-11','17:50:00',1.66),('325','2013-08-11','17:55:00',1.56),('325','2013-08-11','18:00:00',1.46),('325','2013-08-11','18:05:00',1.37),('325','2013-08-11','18:10:00',1.24),('325','2013-08-11','18:15:00',1.18),('325','2013-08-11','18:20:00',1.11),('325','2013-08-11','18:25:00',1.03),('325','2013-08-10','08:40:00',1.02),('325','2013-08-10','08:45:00',1.08),('325','2013-08-10','08:50:00',1.14),('325','2013-08-10','08:55:00',1.21),('325','2013-08-10','09:00:00',1.25),('325','2013-08-10','09:05:00',1.29),('325','2013-08-10','09:10:00',1.33),('325','2013-08-10','09:15:00',1.82),('325','2013-08-10','09:20:00',2.13),('325','2013-08-10','09:25:00',2.2),('325','2013-08-10','09:30:00',2.27),('325','2013-08-10','09:35:00',2.33),('325','2013-08-10','09:40:00',2.38),('325','2013-08-10','09:45:00',2.41),('325','2013-08-10','09:50:00',2.58),('325','2013-08-10','09:55:00',2.73),('325','2013-08-10','10:00:00',2.8),('325','2013-08-10','10:05:00',2.88),('325','2013-08-10','10:10:00',2.64),('325','2013-08-10','10:15:00',2.49),('325','2013-08-10','10:20:00',2.95),('325','2013-08-10','10:25:00',3.01),('325','2013-08-10','10:30:00',3.1),('325','2013-08-10','10:35:00',3.16),('325','2013-08-10','10:40:00',3.18),('325','2013-08-10','10:45:00',3.44),('325','2013-08-10','10:50:00',3.57),('325','2013-08-10','10:55:00',3.65),('325','2013-08-10','11:00:00',3.74),('325','2013-08-10','11:05:00',3.79),('325','2013-08-10','11:10:00',3.86),('325','2013-08-10','11:15:00',3.95),('325','2013-08-10','11:20:00',3.36),('325','2013-08-10','11:25:00',3.19),('325','2013-08-10','11:30:00',4.05),('325','2013-08-10','11:35:00',3.85),('325','2013-08-10','11:40:00',4.01),('325','2013-08-10','11:45:00',4.02),('325','2013-08-10','11:50:00',4.07),('325','2013-08-10','11:55:00',4.14),('325','2013-08-10','12:00:00',4.18),('325','2013-08-10','12:05:00',4.22),('325','2013-08-10','12:10:00',4.24),('325','2013-08-10','12:15:00',4.24),('325','2013-08-10','12:20:00',4.2),('325','2013-08-10','12:25:00',4.2),('325','2013-08-10','12:30:00',4.2),('325','2013-08-10','12:35:00',4.21),('325','2013-08-10','12:40:00',4.25),('325','2013-08-10','12:45:00',4.27),('325','2013-08-10','12:50:00',4.41),('325','2013-08-10','12:55:00',4.07),('325','2013-08-10','13:00:00',4.41),('325','2013-08-10','13:05:00',4.34),('325','2013-08-10','13:10:00',4.3),('325','2013-08-10','13:15:00',4.43),('325','2013-08-10','13:20:00',4.45),('325','2013-08-10','13:25:00',4.56),('325','2013-08-10','13:30:00',4.61),('325','2013-08-10','13:35:00',3.66),('325','2013-08-10','13:40:00',1.33),('325','2013-08-10','13:50:00',1.27),('325','2013-08-10','13:55:00',4.41),('325','2013-08-10','14:00:00',4.69),('325','2013-08-10','14:05:00',4.58),('325','2013-08-10','14:10:00',2.34),('325','2013-08-10','14:15:00',4.06),('325','2013-08-10','14:20:00',2.65),('325','2013-08-10','14:25:00',1.33),('325','2013-08-10','14:30:00',1.22),('325','2013-08-10','14:35:00',1.06),('325','2013-08-10','15:00:00',1.02),('325','2013-08-10','15:05:00',1.05),('325','2013-08-10','15:10:00',1.09),('325','2013-08-10','15:15:00',1.19),('325','2013-08-10','15:20:00',1.22),('325','2013-08-10','15:25:00',1.11),('325','2013-08-10','15:30:00',1.07),('325','2013-08-10','15:35:00',1.34),('325','2013-08-10','15:40:00',1.3),('325','2013-08-10','15:45:00',1.5),('325','2013-08-10','15:50:00',2.16),('325','2013-08-10','15:55:00',2.41),('325','2013-08-10','16:00:00',2.52),('325','2013-08-10','16:05:00',4.64),('325','2013-08-10','16:10:00',2.65),('325','2013-08-10','16:15:00',2.36),('325','2013-08-10','16:20:00',2.58),('325','2013-08-10','16:25:00',1.19),('325','2013-08-10','16:30:00',2.34),('325','2013-08-10','16:35:00',2.23),('325','2013-08-10','16:40:00',2.72),('325','2013-08-10','16:45:00',3.15),('325','2013-08-10','16:50:00',2.94),('325','2013-08-10','16:55:00',2.71),('325','2013-08-10','17:00:00',1.75),('325','2013-08-10','17:05:00',1.76),('325','2013-08-10','17:10:00',1.06),('325','2013-08-10','17:15:00',1.22),('325','2013-08-10','17:20:00',1.36),('325','2013-08-10','17:25:00',1.85),('325','2013-08-10','17:30:00',1.41),('325','2013-08-09','08:40:00',1.06),('325','2013-08-09','08:45:00',1.13),('325','2013-08-09','08:50:00',1.15),('325','2013-08-09','08:55:00',1.29),('325','2013-08-09','09:00:00',1.3),('325','2013-08-09','09:05:00',1.41),('325','2013-08-09','09:10:00',1.59),('325','2013-08-09','09:15:00',1.73),('325','2013-08-09','09:20:00',1.33),('325','2013-08-09','09:25:00',1.43),('325','2013-08-09','09:30:00',1.36),('325','2013-08-09','09:35:00',2.05),('325','2013-08-09','09:40:00',1.78),('325','2013-08-09','09:45:00',2.31),('325','2013-08-09','09:50:00',1.82),('325','2013-08-09','09:55:00',1.72),('325','2013-08-09','10:00:00',1.79),('325','2013-08-09','10:05:00',1.86),('325','2013-08-09','10:10:00',2.55),('325','2013-08-09','10:15:00',2.8),('325','2013-08-09','10:20:00',2.77),('325','2013-08-09','10:25:00',2.73),('325','2013-08-09','10:30:00',2.83),('325','2013-08-09','10:35:00',2.92),('325','2013-08-09','10:40:00',2.64),('325','2013-08-09','10:45:00',3.07),('325','2013-08-09','10:50:00',3.02),('325','2013-08-09','10:55:00',3.13),('325','2013-08-09','11:00:00',3.33),('325','2013-08-09','11:05:00',3.39),('325','2013-08-09','11:10:00',3.43),('325','2013-08-09','11:15:00',3.52),('325','2013-08-09','11:20:00',3.57),('325','2013-08-09','11:25:00',3.57),('325','2013-08-09','11:30:00',3.61),('325','2013-08-09','11:35:00',3.6),('325','2013-08-09','11:40:00',3.68),('325','2013-08-09','11:45:00',3.7),('325','2013-08-09','11:50:00',3.71),('325','2013-08-09','11:55:00',3.76),('325','2013-08-09','12:00:00',3.82),('325','2013-08-09','12:05:00',3.88),('325','2013-08-09','12:10:00',3.82),('325','2013-08-09','12:15:00',3.89),('325','2013-08-09','12:20:00',4.07),('325','2013-08-09','12:25:00',3.31),('325','2013-08-09','12:30:00',2.99),('325','2013-08-09','12:35:00',3.19),('325','2013-08-09','12:40:00',4.15),('325','2013-08-09','12:45:00',3.59),('325','2013-08-09','12:50:00',2.83),('325','2013-08-09','12:55:00',3.02),('325','2013-08-09','13:00:00',1.34),('325','2013-08-09','13:15:00',1.24),('325','2013-08-09','13:20:00',1.7),('325','2013-08-09','13:25:00',2.26),('325','2013-08-09','13:30:00',1.87),('325','2013-08-09','13:35:00',1.5),('325','2013-08-09','13:40:00',1.44),('325','2013-08-09','13:45:00',1.37),('325','2013-08-09','13:50:00',1.47),('325','2013-08-09','13:55:00',1.32),('325','2013-08-09','14:00:00',1.37),('325','2013-08-09','14:05:00',1.23),('325','2013-08-09','14:10:00',1.58),('325','2013-08-09','14:25:00',1.02),('325','2013-08-09','15:05:00',1.37),('325','2013-08-09','15:10:00',3.01),('325','2013-08-09','15:15:00',2.76),('325','2013-08-09','15:20:00',1.66),('325','2013-08-09','15:25:00',1.26),('325','2013-08-09','15:30:00',1.33),('325','2013-08-09','15:35:00',2.35),('325','2013-08-09','15:40:00',1.75),('325','2013-08-09','15:45:00',3.14),('325','2013-08-09','15:50:00',2.14),('325','2013-08-09','15:55:00',1.89),('325','2013-08-09','16:00:00',1.28),('325','2013-08-09','16:50:00',1.67),('325','2013-08-09','16:55:00',2.59),('325','2013-08-09','17:00:00',1.47),('325','2013-08-09','17:05:00',1.8),('325','2013-08-09','19:20:00',1.03),('325','2013-08-09','19:25:00',1.01),('325','2014-04-08','08:20:00',1.05),('325','2014-04-08','08:30:00',1.04),('325','2014-04-08','08:45:00',1.12),('325','2014-04-08','08:50:00',1.15),('325','2014-04-08','08:55:00',1.24),('325','2014-04-08','09:00:00',1.29),('325','2014-04-08','09:05:00',1.34),('325','2014-04-08','09:10:00',1.38),('325','2014-04-08','09:15:00',1.43),('325','2014-04-08','09:20:00',1.48),('325','2014-04-08','09:25:00',1.54),('325','2014-04-08','09:30:00',1.59),('325','2014-04-08','09:35:00',1.62),('325','2014-04-08','09:40:00',1.65),('325','2014-04-08','09:45:00',1.71),('325','2014-04-08','09:50:00',1.76),('325','2014-04-08','09:55:00',1.78),('325','2014-04-08','10:00:00',1.81),('325','2014-04-08','10:05:00',1.81),('325','2014-04-08','10:10:00',1.9),('325','2014-04-08','10:15:00',2.23),('325','2014-04-08','10:20:00',3.08),('325','2014-04-08','10:25:00',3.18),('325','2014-04-08','10:30:00',3.25),('325','2014-04-08','10:35:00',3.33),('325','2014-04-08','10:40:00',3.43),('325','2014-04-08','10:45:00',3.45),('325','2014-04-08','10:50:00',3.54),('325','2014-04-08','10:55:00',3.65),('325','2014-04-08','11:00:00',3.71),('325','2014-04-08','11:05:00',3.61),('325','2014-04-08','11:10:00',3.7),('325','2014-04-08','11:15:00',3.75),('325','2014-04-08','11:20:00',3.85),('325','2014-04-08','11:25:00',3.75),('325','2014-04-08','11:30:00',3.83),('325','2014-04-08','11:35:00',3.76),('325','2014-04-08','11:40:00',3.96),('325','2014-04-08','11:45:00',4.03),('325','2014-04-08','11:50:00',4.02),('325','2014-04-08','11:55:00',4.01),('325','2014-04-08','12:00:00',4.08),('325','2014-04-08','12:05:00',4.06),('325','2014-04-08','12:10:00',3.98),('325','2014-04-08','12:15:00',3.74),('325','2014-04-08','12:20:00',3.77),('325','2014-04-08','12:25:00',3.76),('325','2014-04-08','12:30:00',4.44),('325','2014-04-08','12:35:00',4.37),('325','2014-04-08','12:40:00',3.65),('325','2014-04-08','12:45:00',2.83),('325','2014-04-08','12:50:00',3.9),('325','2014-04-08','12:55:00',4.35),('325','2014-04-08','13:00:00',4.17),('325','2014-04-08','13:05:00',4.32),('325','2014-04-08','13:10:00',4.43),('325','2014-04-08','13:15:00',4.53),('325','2014-04-08','13:20:00',4.49),('325','2014-04-08','13:25:00',4.55),('325','2014-04-08','13:30:00',4.5),('325','2014-04-08','13:35:00',4.52),('325','2014-04-08','13:40:00',4.46),('325','2014-04-08','13:45:00',4.41),('325','2014-04-08','13:50:00',4.43),('325','2014-04-08','13:55:00',4.46),('325','2014-04-08','14:00:00',4.43),('325','2014-04-08','14:05:00',4.42),('325','2014-04-08','14:10:00',4.4),('325','2014-04-08','14:15:00',4.36),('325','2014-04-08','14:20:00',4.04),('325','2014-04-08','14:25:00',4.07),('325','2014-04-08','14:30:00',4.36),('325','2014-04-08','14:35:00',4.16),('325','2014-04-08','14:40:00',3.7),('325','2014-04-08','14:45:00',3.82),('325','2014-04-08','14:50:00',4.11),('325','2014-04-08','14:55:00',4.21),('325','2014-04-08','15:00:00',4.1),('325','2014-04-08','15:05:00',4),('325','2014-04-08','15:10:00',3.99),('325','2014-04-08','15:15:00',3.92),('325','2014-04-08','15:20:00',3.83),('325','2014-04-08','15:25:00',3.66),('325','2014-04-08','15:30:00',3.55),('325','2014-04-08','15:35:00',3.74),('325','2014-04-08','15:40:00',3.64),('325','2014-04-08','15:45:00',3.46),('325','2014-04-08','15:50:00',3.53),('325','2014-04-08','15:55:00',3.46),('325','2014-04-08','16:00:00',3.3),('325','2014-04-08','16:05:00',3.25),('325','2014-04-08','16:10:00',3.12),('325','2014-04-08','16:15:00',2.94),('325','2014-04-08','16:20:00',2.69),('325','2014-04-08','16:25:00',2.85),('325','2014-04-08','16:30:00',3.01),('325','2014-04-08','16:35:00',2.88),('325','2014-04-08','16:40:00',2.73),('325','2014-04-08','16:45:00',2.55),('325','2014-04-08','16:50:00',2.52),('325','2014-04-08','16:55:00',2.39),('325','2014-04-08','17:00:00',2.24),('325','2014-04-08','17:05:00',2.3),('325','2014-04-08','17:10:00',2.15),('325','2014-04-08','17:15:00',2.04),('325','2014-04-08','17:20:00',1.95),('325','2014-04-08','17:25:00',1.74),('325','2014-04-08','17:30:00',1.59),('325','2014-04-08','17:35:00',1.47),('325','2014-04-08','17:40:00',1.45),('325','2014-04-08','17:45:00',1.39),('325','2014-04-08','17:50:00',1.31),('325','2014-04-08','17:55:00',1.16),('325','2014-04-08','18:00:00',1.13),('325','2014-04-08','18:05:00',1.09),('325','2013-08-08','08:45:00',1),('325','2013-08-08','08:50:00',1.05),('325','2013-08-08','08:55:00',1.07),('325','2013-08-08','09:00:00',1.1),('325','2013-08-08','09:05:00',1.2),('325','2013-08-08','09:10:00',1.28),('325','2013-08-08','09:15:00',1.34),('325','2013-08-08','09:20:00',1.92),('325','2013-08-08','09:25:00',2),('325','2013-08-08','09:30:00',2.07),('325','2013-08-08','09:35:00',2.13),('325','2013-08-08','09:40:00',2.2),('325','2013-08-08','09:45:00',2.25),('325','2013-08-08','09:50:00',2.35),('325','2013-08-08','09:55:00',2.45),('325','2013-08-08','10:00:00',2.59),('325','2013-08-08','10:05:00',2.68),('325','2013-08-08','10:10:00',2.74),('325','2013-08-08','10:15:00',2.77),('325','2013-08-08','10:20:00',2.78),('325','2013-08-08','10:25:00',2.8),('325','2013-08-08','10:30:00',2.86),('325','2013-08-08','10:35:00',2.95),('325','2013-08-08','10:40:00',2.99),('325','2013-08-08','10:45:00',3.01),('325','2013-08-08','10:50:00',3.08),('325','2013-08-08','10:55:00',3.14),('325','2013-08-08','11:00:00',3.22),('325','2013-08-08','11:05:00',3.32),('325','2013-08-08','11:10:00',3.41),('325','2013-08-08','11:15:00',3.38),('325','2013-08-08','11:20:00',3.38),('325','2013-08-08','11:25:00',3.42),('325','2013-08-08','11:30:00',3.48),('325','2013-08-08','11:35:00',3.59),('325','2013-08-08','11:40:00',3.63),('325','2013-08-08','11:45:00',3.67),('325','2013-08-08','11:50:00',3.73),('325','2013-08-08','11:55:00',3.74),('325','2013-08-08','12:00:00',3.78),('325','2013-08-08','12:05:00',3.87),('325','2013-08-08','12:10:00',3.88),('325','2013-08-08','12:15:00',3.86),('325','2013-08-08','12:20:00',3.87),('325','2013-08-08','12:25:00',3.83),('325','2013-08-08','12:30:00',3.81),('325','2013-08-08','12:35:00',3.99),('325','2013-08-08','12:40:00',3.96),('325','2013-08-08','12:45:00',3.94),('325','2013-08-08','12:50:00',3.96),('325','2013-08-08','12:55:00',4.03),('325','2013-08-08','13:00:00',4.06),('325','2013-08-08','13:05:00',4.12),('325','2013-08-08','13:10:00',4.06),('325','2013-08-08','13:15:00',4.04),('325','2013-08-08','13:20:00',4.01),('325','2013-08-08','13:25:00',3.97),('325','2013-08-08','13:30:00',3.94),('325','2013-08-08','13:35:00',3.88),('325','2013-08-08','13:40:00',3.86),('325','2013-08-08','13:45:00',3.91),('325','2013-08-08','13:50:00',4.01),('325','2013-08-08','13:55:00',4.01),('325','2013-08-08','14:00:00',4),('325','2013-08-08','14:05:00',3.96),('325','2013-08-08','14:10:00',3.86),('325','2013-08-08','14:15:00',3.79),('325','2013-08-08','14:20:00',3.74),('325','2013-08-08','14:25:00',3.87),('325','2013-08-08','14:30:00',3.87),('325','2013-08-08','14:35:00',3.83),('325','2013-08-08','14:40:00',3.81),('325','2013-08-08','14:45:00',3.75),('325','2013-08-08','14:50:00',3.72),('325','2013-08-08','14:55:00',3.68),('325','2013-08-08','15:00:00',3.66),('325','2013-08-08','15:05:00',3.64),('325','2013-08-08','15:10:00',3.63),('325','2013-08-08','15:15:00',3.54),('325','2013-08-08','15:20:00',3.5),('325','2013-08-08','15:25:00',3.45),('325','2013-08-08','15:30:00',3.41),('325','2013-08-08','15:35:00',3.39),('325','2013-08-08','15:40:00',3.36),('325','2013-08-08','15:45:00',3.32),('325','2013-08-08','15:50:00',3.27),('325','2013-08-08','15:55:00',3.24),('325','2013-08-08','16:00:00',3.19),('325','2013-08-08','16:05:00',3.16),('325','2013-08-08','16:10:00',3.13),('325','2013-08-08','16:15:00',3.07),('325','2013-08-08','16:20:00',3.03),('325','2013-08-08','16:25:00',2.98),('325','2013-08-08','16:30:00',2.93),('325','2013-08-08','16:35:00',2.84),('325','2013-08-08','16:40:00',2.77),('325','2013-08-08','16:45:00',2.69),('325','2013-08-08','16:50:00',2.6),('325','2013-08-08','16:55:00',2.52),('325','2013-08-08','17:00:00',2.4),('325','2013-08-08','17:05:00',2.26),('325','2013-08-08','17:10:00',2.25),('325','2013-08-08','17:15:00',2.16),('325','2013-08-08','17:20:00',2.08),('325','2013-08-08','17:25:00',2),('325','2013-08-08','17:30:00',1.91),('325','2013-08-08','17:35:00',1.82),('325','2013-08-08','17:40:00',1.74),('325','2013-08-08','17:45:00',1.61),('325','2013-08-08','17:50:00',1.56),('325','2013-08-08','17:55:00',1.48),('325','2013-08-08','18:00:00',1.41),('325','2013-08-08','18:05:00',1.32),('325','2013-08-08','18:10:00',1.23),('325','2013-08-08','18:15:00',1.15),('325','2013-08-08','18:20:00',1.07),('325','2013-08-07','08:50:00',1.05),('325','2013-08-07','08:55:00',1.08),('325','2013-08-07','09:00:00',1.11),('325','2013-08-07','09:05:00',1.19),('325','2013-08-07','09:10:00',1.27),('325','2013-08-07','09:15:00',1.45),('325','2013-08-07','09:20:00',1.94),('325','2013-08-07','09:25:00',2.02),('325','2013-08-07','09:30:00',2.11),('325','2013-08-07','09:35:00',2.16),('325','2013-08-07','09:40:00',2.22),('325','2013-08-07','09:45:00',2.26),('325','2013-08-07','09:50:00',2.38),('325','2013-08-07','09:55:00',2.48),('325','2013-08-07','10:00:00',2.61),('325','2013-08-07','10:05:00',2.72),('325','2013-08-07','10:10:00',2.8),('325','2013-08-07','10:15:00',2.82),('325','2013-08-07','10:20:00',2.79),('325','2013-08-07','10:25:00',2.83),('325','2013-08-07','10:30:00',2.9),('325','2013-08-07','10:35:00',2.97),('325','2013-08-07','10:40:00',3.01),('325','2013-08-07','10:45:00',3.02),('325','2013-08-07','10:50:00',3.11),('325','2013-08-07','10:55:00',3.16),('325','2013-08-07','11:00:00',3.24),('325','2013-08-07','11:05:00',3.34),('325','2013-08-07','11:10:00',3.43),('325','2013-08-07','11:15:00',3.45),('325','2013-08-07','11:20:00',3.44),('325','2013-08-07','11:25:00',3.44),('325','2013-08-07','11:30:00',3.48),('325','2013-08-07','11:35:00',3.5),('325','2013-08-07','11:40:00',3.53),('325','2013-08-07','11:45:00',3.58),('325','2013-08-07','11:50:00',3.68),('325','2013-08-07','11:55:00',3.77),('325','2013-08-07','12:00:00',3.85),('325','2013-08-07','12:05:00',3.89),('325','2013-08-07','12:10:00',3.82),('325','2013-08-07','12:15:00',3.86),('325','2013-08-07','12:20:00',3.81),('325','2013-08-07','12:25:00',3.84),('325','2013-08-07','12:30:00',3.85),('325','2013-08-07','12:35:00',3.81),('325','2013-08-07','12:40:00',3.91),('325','2013-08-07','12:45:00',3.83),('325','2013-08-07','12:50:00',3.89),('325','2013-08-07','12:55:00',3.95),('325','2013-08-07','13:00:00',4.06),('325','2013-08-07','13:05:00',4.13),('325','2013-08-07','13:10:00',4.07),('325','2013-08-07','13:15:00',4.03),('325','2013-08-07','13:20:00',3.98),('325','2013-08-07','13:25:00',4.01),('325','2013-08-07','13:30:00',3.94),('325','2013-08-07','13:35:00',3.91),('325','2013-08-07','13:40:00',3.95),('325','2013-08-07','13:45:00',3.95),('325','2013-08-07','13:50:00',3.98),('325','2013-08-07','13:55:00',3.98),('325','2013-08-07','14:00:00',4.01),('325','2013-08-07','14:05:00',3.96),('325','2013-08-07','14:10:00',3.89),('325','2013-08-07','14:15:00',3.78),('325','2013-08-07','14:20:00',3.69),('325','2013-08-07','14:25:00',3.64),('325','2013-08-07','14:30:00',3.56),('325','2013-08-07','14:35:00',3.56),('325','2013-08-07','14:40:00',3.6),('325','2013-08-07','14:45:00',3.6),('325','2013-08-07','14:50:00',3.63),('325','2013-08-07','14:55:00',3.63),('325','2013-08-07','15:00:00',3.63),('325','2013-08-07','15:05:00',3.57),('325','2013-08-07','15:10:00',3.58),('325','2013-08-07','15:15:00',3.58),('325','2013-08-07','15:20:00',3.57),('325','2013-08-07','15:25:00',3.49),('325','2013-08-07','15:30:00',3.48),('325','2013-08-07','15:35:00',3.46),('325','2013-08-07','15:40:00',3.45),('325','2013-08-07','15:45:00',3.4),('325','2013-08-07','15:50:00',3.35),('325','2013-08-07','15:55:00',3.26),('325','2013-08-07','16:00:00',3.19),('325','2013-08-07','16:05:00',3.16),('325','2013-08-07','16:10:00',3.1),('325','2013-08-07','16:15:00',3.07),('325','2013-08-07','16:20:00',3.01),('325','2013-08-07','16:25:00',2.98),('325','2013-08-07','16:30:00',2.92),('325','2013-08-07','16:35:00',2.86),('325','2013-08-07','16:40:00',2.77),('325','2013-08-07','16:45:00',2.72),('325','2013-08-07','16:50:00',2.65),('325','2013-08-07','16:55:00',2.59),('325','2013-08-07','17:00:00',2.47),('325','2013-08-07','17:05:00',2.33),('325','2013-08-07','17:10:00',2.3),('325','2013-08-07','17:15:00',2.23),('325','2013-08-07','17:20:00',2.16),('325','2013-08-07','17:25:00',2.02),('325','2013-08-07','17:30:00',1.95),('325','2013-08-07','17:35:00',1.88),('325','2013-08-07','17:40:00',1.78),('325','2013-08-07','17:45:00',1.65),('325','2013-08-07','17:50:00',1.6),('325','2013-08-07','17:55:00',1.52),('325','2013-08-07','18:00:00',1.43),('325','2013-08-07','18:05:00',1.32),('325','2013-08-07','18:10:00',1.23),('325','2013-08-07','18:15:00',1.16),('325','2013-08-07','18:20:00',1.07),('325','2013-08-07','18:25:00',1),('325','2013-08-06','08:45:00',1.01),('325','2013-08-06','08:50:00',1.06),('325','2013-08-06','08:55:00',1.08),('325','2013-08-06','09:00:00',1.12),('325','2013-08-06','09:05:00',1.17),('325','2013-08-06','09:10:00',1.24),('325','2013-08-06','09:15:00',1.32),('325','2013-08-06','09:20:00',1.48),('325','2013-08-06','09:25:00',2),('325','2013-08-06','09:30:00',2.09),('325','2013-08-06','09:35:00',2.16),('325','2013-08-06','09:40:00',2.22),('325','2013-08-06','09:45:00',2.25),('325','2013-08-06','09:50:00',2.33),('325','2013-08-06','09:55:00',2.44),('325','2013-08-06','10:00:00',2.64),('325','2013-08-06','10:05:00',2.77),('325','2013-08-06','10:10:00',2.83),('325','2013-08-06','10:15:00',2.89),('325','2013-08-06','10:20:00',2.9),('325','2013-08-06','10:25:00',2.92),('325','2013-08-06','10:30:00',2.96),('325','2013-08-06','10:35:00',2.99),('325','2013-08-06','10:40:00',3.01),('325','2013-08-06','10:45:00',3.02),('325','2013-08-06','10:50:00',3.09),('325','2013-08-06','10:55:00',3.17),('325','2013-08-06','11:00:00',3.23),('325','2013-08-06','11:05:00',3.29),('325','2013-08-06','11:10:00',3.39),('325','2013-08-06','11:15:00',3.43),('325','2013-08-06','11:20:00',3.46),('325','2013-08-06','11:25:00',3.48),('325','2013-08-06','11:30:00',3.5),('325','2013-08-06','11:35:00',3.51),('325','2013-08-06','11:40:00',3.54),('325','2013-08-06','11:45:00',3.59),('325','2013-08-06','11:50:00',3.65),('325','2013-08-06','11:55:00',3.75),('325','2013-08-06','12:00:00',3.78),('325','2013-08-06','12:05:00',3.85),('325','2013-08-06','12:10:00',3.86),('325','2013-08-06','12:15:00',3.84),('325','2013-08-06','12:20:00',3.84),('325','2013-08-06','12:25:00',3.85),('325','2013-08-06','12:30:00',3.85),('325','2013-08-06','12:35:00',3.85),('325','2013-08-06','12:40:00',3.88),('325','2013-08-06','12:45:00',3.88),('325','2013-08-06','12:50:00',3.88),('325','2013-08-06','12:55:00',3.93),('325','2013-08-06','13:00:00',3.99),('325','2013-08-06','13:05:00',4.06),('325','2013-08-06','13:10:00',4.05),('325','2013-08-06','13:15:00',4.02),('325','2013-08-06','13:20:00',3.98),('325','2013-08-06','13:25:00',3.92),('325','2013-08-06','13:30:00',3.95),('325','2013-08-06','13:35:00',3.88),('325','2013-08-06','13:40:00',3.93),('325','2013-08-06','13:45:00',4.07),('325','2013-08-06','13:50:00',4.12),('325','2013-08-06','13:55:00',4.09),('325','2013-08-06','14:00:00',4.07),('325','2013-08-06','14:05:00',4.05),('325','2013-08-06','14:10:00',3.99),('325','2013-08-06','14:15:00',3.94),('325','2013-08-06','14:20:00',3.87),('325','2013-08-06','14:25:00',3.84),('325','2013-08-06','14:30:00',3.8),('325','2013-08-06','14:35:00',3.78),('325','2013-08-06','14:40:00',3.85),('325','2013-08-06','14:45:00',3.97),('325','2013-08-06','14:50:00',3.95),('325','2013-08-06','14:55:00',3.93),('325','2013-08-06','15:00:00',3.89),('325','2013-08-06','15:05:00',3.85),('325','2013-08-06','15:10:00',3.81),('325','2013-08-06','15:15:00',3.79),('325','2013-08-06','15:20:00',3.76),('325','2013-08-06','15:25:00',3.72),('325','2013-08-06','15:30:00',3.67),('325','2013-08-06','15:35:00',3.63),('325','2013-08-06','15:40:00',3.59),('325','2013-08-06','15:45:00',3.55),('325','2013-08-06','15:50:00',3.49),('325','2013-08-06','15:55:00',3.43),('325','2013-08-06','16:00:00',3.39),('325','2013-08-06','16:05:00',3.33),('325','2013-08-06','16:10:00',3.27),('325','2013-08-06','16:15:00',3.21),('325','2013-08-06','16:20:00',3.14),('325','2013-08-06','16:25:00',3.08),('325','2013-08-06','16:30:00',3.02),('325','2013-08-06','16:35:00',2.95),('325','2013-08-06','16:40:00',2.87),('325','2013-08-06','16:45:00',2.79),('325','2013-08-06','16:50:00',2.72),('325','2013-08-06','16:55:00',2.64),('325','2013-08-06','17:00:00',2.54),('325','2013-08-06','17:05:00',2.4),('325','2013-08-06','17:10:00',2.36),('325','2013-08-06','17:15:00',2.3),('325','2013-08-06','17:20:00',2.22),('325','2013-08-06','17:25:00',2.12),('325','2013-08-06','17:30:00',2.05),('325','2013-08-06','17:35:00',1.95),('325','2013-08-06','17:40:00',1.85),('325','2013-08-06','17:45:00',1.72),('325','2013-08-06','17:50:00',1.66),('325','2013-08-06','17:55:00',1.57),('325','2013-08-06','18:00:00',1.48),('325','2013-08-06','18:05:00',1.4),('325','2013-08-06','18:10:00',1.31),('325','2013-08-06','18:15:00',1.23),('325','2013-08-06','18:20:00',1.15),('325','2013-08-06','18:25:00',1.06),('325','2013-08-05','08:45:00',1.03),('325','2013-08-05','08:50:00',1.07),('325','2013-08-05','08:55:00',1.1),('325','2013-08-05','09:00:00',1.12),('325','2013-08-05','09:05:00',1.25),('325','2013-08-05','09:10:00',1.29),('325','2013-08-05','09:15:00',1.31),('325','2013-08-05','09:20:00',1.36),('325','2013-08-05','09:25:00',1.41),('325','2013-08-05','09:30:00',1.71),('325','2013-08-05','09:35:00',2.18),('325','2013-08-05','09:40:00',2.23),('325','2013-08-05','09:45:00',2.27),('325','2013-08-05','09:50:00',2.36),('325','2013-08-05','09:55:00',2.45),('325','2013-08-05','10:00:00',2.57),('325','2013-08-05','10:05:00',2.63),('325','2013-08-05','10:10:00',2.78),('325','2013-08-05','10:15:00',2.83),('325','2013-08-05','10:20:00',2.84),('325','2013-08-05','10:25:00',2.85),('325','2013-08-05','10:30:00',2.89),('325','2013-08-05','10:35:00',2.99),('325','2013-08-05','10:40:00',3.05),('325','2013-08-05','10:45:00',3.09),('325','2013-08-05','10:50:00',3.16),('325','2013-08-05','10:55:00',3.22),('325','2013-08-05','11:00:00',3.29),('325','2013-08-05','11:05:00',3.38),('325','2013-08-05','11:10:00',3.47),('325','2013-08-05','11:15:00',3.55),('325','2013-08-05','11:20:00',3.51),('325','2013-08-05','11:25:00',3.53),('325','2013-08-05','11:30:00',3.54),('325','2013-08-05','11:35:00',3.58),('325','2013-08-05','11:40:00',3.61),('325','2013-08-05','11:45:00',3.63),('325','2013-08-05','11:50:00',3.72),('325','2013-08-05','11:55:00',3.89),('325','2013-08-05','12:00:00',3.93),('325','2013-08-05','12:05:00',4),('325','2013-08-05','12:10:00',4),('325','2013-08-05','12:15:00',3.98),('325','2013-08-05','12:20:00',3.94),('325','2013-08-05','12:25:00',3.96),('325','2013-08-05','12:30:00',3.97),('325','2013-08-05','12:35:00',3.96),('325','2013-08-05','12:40:00',3.99),('325','2013-08-05','12:45:00',3.96),('325','2013-08-05','12:50:00',3.96),('325','2013-08-05','12:55:00',4.02),('325','2013-08-05','13:00:00',4.05),('325','2013-08-05','13:05:00',4.09),('325','2013-08-05','13:10:00',4.05),('325','2013-08-05','13:15:00',4.02),('325','2013-08-05','13:20:00',4),('325','2013-08-05','13:25:00',3.99),('325','2013-08-05','13:30:00',3.93),('325','2013-08-05','13:35:00',3.86),('325','2013-08-05','13:40:00',3.85),('325','2013-08-05','13:45:00',3.83),('325','2013-08-05','13:50:00',3.91),('325','2013-08-05','13:55:00',3.91),('325','2013-08-05','14:00:00',4),('325','2013-08-05','14:05:00',3.99),('325','2013-08-05','14:10:00',3.88),('325','2013-08-05','14:15:00',3.81),('325','2013-08-05','14:20:00',3.74),('325','2013-08-05','14:25:00',3.71),('325','2013-08-05','14:30:00',3.66),('325','2013-08-05','14:35:00',3.63),('325','2013-08-05','14:40:00',3.65),('325','2013-08-05','14:45:00',3.61),('325','2013-08-05','14:50:00',3.61),('325','2013-08-05','14:55:00',3.6),('325','2013-08-05','15:00:00',3.62),('325','2013-08-05','15:05:00',3.68),('325','2013-08-05','15:10:00',3.75),('325','2013-08-05','15:15:00',3.71),('325','2013-08-05','15:20:00',3.69),('325','2013-08-05','15:25:00',3.66),('325','2013-08-05','15:30:00',3.62),('325','2013-08-05','15:35:00',3.59),('325','2013-08-05','15:40:00',3.55),('325','2013-08-05','15:45:00',3.5),('325','2013-08-05','15:50:00',3.44),('325','2013-08-05','15:55:00',3.39),('325','2013-08-05','16:00:00',3.37),('325','2013-08-05','16:05:00',3.32),('325','2013-08-05','16:10:00',3.26),('325','2013-08-05','16:15:00',3.19),('325','2013-08-05','16:20:00',3.11),('325','2013-08-05','16:25:00',3.04),('325','2013-08-05','16:30:00',2.98),('325','2013-08-05','16:35:00',2.93),('325','2013-08-05','16:40:00',2.86),('325','2013-08-05','16:45:00',2.77),('325','2013-08-05','16:50:00',2.7),('325','2013-08-05','16:55:00',2.62),('325','2013-08-05','17:00:00',2.5),('325','2013-08-05','17:05:00',2.37),('325','2013-08-05','17:10:00',2.34),('325','2013-08-05','17:15:00',2.26),('325','2013-08-05','17:20:00',2.18),('325','2013-08-05','17:25:00',2.1),('325','2013-08-05','17:30:00',2.02),('325','2013-08-05','17:35:00',1.95),('325','2013-08-05','17:40:00',1.86),('325','2013-08-05','17:45:00',1.72),('325','2013-08-05','17:50:00',1.63),('325','2013-08-05','17:55:00',1.55),('325','2013-08-05','18:00:00',1.46),('325','2013-08-05','18:05:00',1.36),('325','2013-08-05','18:10:00',1.28),('325','2013-08-05','18:15:00',1.19),('325','2013-08-05','18:20:00',1.11),('325','2013-08-05','18:25:00',1.03),('325','2013-08-04','08:40:00',1.01),('325','2013-08-04','08:45:00',1.07),('325','2013-08-04','08:50:00',1.12),('325','2013-08-04','08:55:00',1.18),('325','2013-08-04','09:00:00',1.23),('325','2013-08-04','09:05:00',1.24),('325','2013-08-04','09:10:00',1.25),('325','2013-08-04','09:15:00',1.26),('325','2013-08-04','09:20:00',1.98),('325','2013-08-04','09:25:00',2.13),('325','2013-08-04','09:30:00',2.22),('325','2013-08-04','09:35:00',2.31),('325','2013-08-04','09:40:00',2.37),('325','2013-08-04','09:45:00',2.42),('325','2013-08-04','09:50:00',2.5),('325','2013-08-04','09:55:00',2.58),('325','2013-08-04','10:00:00',2.67),('325','2013-08-04','10:05:00',2.74),('325','2013-08-04','10:10:00',2.87),('325','2013-08-04','10:15:00',2.93),('325','2013-08-04','10:20:00',2.93),('325','2013-08-04','10:25:00',2.93),('325','2013-08-04','10:30:00',2.96),('325','2013-08-04','10:35:00',3.05),('325','2013-08-04','10:40:00',3.15),('325','2013-08-04','10:45:00',3.14),('325','2013-08-04','10:50:00',3.2),('325','2013-08-04','10:55:00',3.26),('325','2013-08-04','11:00:00',3.32),('325','2013-08-04','11:05:00',3.4),('325','2013-08-04','11:10:00',3.49),('325','2013-08-04','11:15:00',3.56),('325','2013-08-04','11:20:00',3.57),('325','2013-08-04','11:25:00',3.6),('325','2013-08-04','11:30:00',3.64),('325','2013-08-04','11:35:00',3.64),('325','2013-08-04','11:40:00',3.68),('325','2013-08-04','11:45:00',3.73),('325','2013-08-04','11:50:00',3.84),('325','2013-08-04','11:55:00',3.97),('325','2013-08-04','12:00:00',4),('325','2013-08-04','12:05:00',4.05),('325','2013-08-04','12:10:00',4.13),('325','2013-08-04','12:15:00',4.1),('325','2013-08-04','12:20:00',4.09),('325','2013-08-04','12:25:00',4.07),('325','2013-08-04','12:30:00',4.06),('325','2013-08-04','12:35:00',4.02),('325','2013-08-04','12:40:00',4.07),('325','2013-08-04','12:45:00',4.04),('325','2013-08-04','12:50:00',4.06),('325','2013-08-04','12:55:00',4.09),('325','2013-08-04','13:00:00',4.08),('325','2013-08-04','13:05:00',4.16),('325','2013-08-04','13:10:00',4.12),('325','2013-08-04','13:15:00',4.05),('325','2013-08-04','13:20:00',4.08),('325','2013-08-04','13:25:00',4.06),('325','2013-08-04','13:30:00',4.01),('325','2013-08-04','13:35:00',4),('325','2013-08-04','13:40:00',4.02),('325','2013-08-04','13:45:00',4.05),('325','2013-08-04','13:50:00',4.09),('325','2013-08-04','13:55:00',4.17),('325','2013-08-04','14:00:00',4.19),('325','2013-08-04','14:05:00',4.15),('325','2013-08-04','14:10:00',4.06),('325','2013-08-04','14:15:00',3.96),('325','2013-08-04','14:20:00',3.86),('325','2013-08-04','14:25:00',3.83),('325','2013-08-04','14:30:00',3.77),('325','2013-08-04','14:35:00',3.82),('325','2013-08-04','14:40:00',4.04),('325','2013-08-04','14:45:00',4.01),('325','2013-08-04','14:50:00',3.99),('325','2013-08-04','14:55:00',3.96),('325','2013-08-04','15:00:00',3.91),('325','2013-08-04','15:05:00',3.92),('325','2013-08-04','15:10:00',3.87),('325','2013-08-04','15:15:00',3.81),('325','2013-08-04','15:20:00',3.79),('325','2013-08-04','15:25:00',3.73),('325','2013-08-04','15:30:00',3.68),('325','2013-08-04','15:35:00',3.69),('325','2013-08-04','15:40:00',3.63),('325','2013-08-04','15:45:00',3.55),('325','2013-08-04','15:50:00',3.49),('325','2013-08-04','15:55:00',3.48),('325','2013-08-04','16:00:00',3.39),('325','2013-08-04','16:05:00',3.4),('325','2013-08-04','16:10:00',3.35),('325','2013-08-04','16:15:00',3.3),('325','2013-08-04','16:20:00',3.23),('325','2013-08-04','16:25:00',3.17),('325','2013-08-04','16:30:00',3.09),('325','2013-08-04','16:35:00',3.02),('325','2013-08-04','16:40:00',2.96),('325','2013-08-04','16:45:00',2.86),('325','2013-08-04','16:50:00',2.77),('325','2013-08-04','16:55:00',2.7),('325','2013-08-04','17:00:00',2.63),('325','2013-08-04','17:05:00',2.55),('325','2013-08-04','17:10:00',2.47),('325','2013-08-04','17:15:00',2.38),('325','2013-08-04','17:20:00',2.29),('325','2013-08-04','17:25:00',2.2),('325','2013-08-04','17:30:00',2.11),('325','2013-08-04','17:35:00',2.01),('325','2013-08-04','17:40:00',1.93),('325','2013-08-04','17:45:00',1.81),('325','2013-08-04','17:50:00',1.72),('325','2013-08-04','17:55:00',1.62),('325','2013-08-04','18:00:00',1.54),('325','2013-08-04','18:05:00',1.43),('325','2013-08-04','18:10:00',1.34),('325','2013-08-04','18:15:00',1.26),('325','2013-08-04','18:20:00',1.18),('325','2013-08-04','18:25:00',1.08),('325','2013-08-03','08:40:00',1.01),('325','2013-08-03','08:45:00',1.06),('325','2013-08-03','08:50:00',1.11),('325','2013-08-03','08:55:00',1.17),('325','2013-08-03','09:00:00',1.21),('325','2013-08-03','09:05:00',1.22),('325','2013-08-03','09:10:00',1.23),('325','2013-08-03','09:15:00',1.24),('325','2013-08-03','09:20:00',1.84),('325','2013-08-03','09:25:00',2.1),('325','2013-08-03','09:30:00',2.18),('325','2013-08-03','09:35:00',2.27),('325','2013-08-03','09:40:00',2.33),('325','2013-08-03','09:45:00',2.38),('325','2013-08-03','09:50:00',2.49),('325','2013-08-03','09:55:00',2.65),('325','2013-08-03','10:00:00',2.78),('325','2013-08-03','10:05:00',2.82),('325','2013-08-03','10:10:00',2.88),('325','2013-08-03','10:15:00',3.01),('325','2013-08-03','10:20:00',3.05),('325','2013-08-03','10:25:00',3.05),('325','2013-08-03','10:30:00',3.05),('325','2013-08-03','10:35:00',3.09),('325','2013-08-03','10:40:00',3.15),('325','2013-08-03','10:45:00',3.16),('325','2013-08-03','10:50:00',3.22),('325','2013-08-03','10:55:00',3.27),('325','2013-08-03','11:00:00',3.35),('325','2013-08-03','11:05:00',3.43),('325','2013-08-03','11:10:00',3.53),('325','2013-08-03','11:15:00',3.62),('325','2013-08-03','11:20:00',3.61),('325','2013-08-03','11:25:00',3.62),('325','2013-08-03','11:30:00',3.58),('325','2013-08-03','11:35:00',3.61),('325','2013-08-03','11:40:00',3.65),('325','2013-08-03','11:45:00',3.69),('325','2013-08-03','11:50:00',3.76),('325','2013-08-03','11:55:00',3.85),('325','2013-08-03','12:00:00',3.9),('325','2013-08-03','12:05:00',3.97),('325','2013-08-03','12:10:00',3.98),('325','2013-08-03','12:15:00',3.98),('325','2013-08-03','12:20:00',3.96),('325','2013-08-03','12:25:00',3.87),('325','2013-08-03','12:30:00',3.91),('325','2013-08-03','12:35:00',3.91),('325','2013-08-03','12:40:00',3.9),('325','2013-08-03','12:45:00',3.93),('325','2013-08-03','12:50:00',3.93),('325','2013-08-03','12:55:00',4),('325','2013-08-03','13:00:00',4.06),('325','2013-08-03','13:05:00',4.08),('325','2013-08-03','13:10:00',4.02),('325','2013-08-03','13:15:00',4),('325','2013-08-03','13:20:00',4.04),('325','2013-08-03','13:25:00',4.03),('325','2013-08-03','13:30:00',3.96),('325','2013-08-03','13:35:00',4.07),('325','2013-08-03','13:40:00',4.08),('325','2013-08-03','13:45:00',4.05),('325','2013-08-03','13:50:00',4.07),('325','2013-08-03','13:55:00',4.02),('325','2013-08-03','14:00:00',3.93),('325','2013-08-03','14:05:00',3.88),('325','2013-08-03','14:10:00',3.8),('325','2013-08-03','14:15:00',3.72),('325','2013-08-03','14:20:00',3.69),('325','2013-08-03','14:25:00',3.8),('325','2013-08-03','14:30:00',3.97),('325','2013-08-03','14:35:00',4.01),('325','2013-08-03','14:40:00',4.03),('325','2013-08-03','14:45:00',4.01),('325','2013-08-03','14:50:00',4),('325','2013-08-03','14:55:00',3.97),('325','2013-08-03','15:00:00',3.94),('325','2013-08-03','15:05:00',3.87),('325','2013-08-03','15:10:00',3.83),('325','2013-08-03','15:15:00',3.79),('325','2013-08-03','15:20:00',3.76),('325','2013-08-03','15:25:00',3.72),('325','2013-08-03','15:30:00',3.7),('325','2013-08-03','15:35:00',3.64),('325','2013-08-03','15:40:00',3.59),('325','2013-08-03','15:45:00',3.58),('325','2013-08-03','15:50:00',3.56),('325','2013-08-03','15:55:00',3.5),('325','2013-08-03','16:00:00',3.43),('325','2013-08-03','16:05:00',3.34),('325','2013-08-03','16:10:00',3.29),('325','2013-08-03','16:15:00',3.21),('325','2013-08-03','16:20:00',3.14),('325','2013-08-03','16:25:00',3.09),('325','2013-08-03','16:30:00',3.04),('325','2013-08-03','16:35:00',2.97),('325','2013-08-03','16:40:00',2.91),('325','2013-08-03','16:45:00',2.84),('325','2013-08-03','16:50:00',2.78),('325','2013-08-03','16:55:00',2.7),('325','2013-08-03','17:00:00',2.58),('325','2013-08-03','17:05:00',2.43),('325','2013-08-03','17:10:00',2.42),('325','2013-08-03','17:15:00',2.34),('325','2013-08-03','17:20:00',2.26),('325','2013-08-03','17:25:00',2.16),('325','2013-08-03','17:30:00',2.09),('325','2013-08-03','17:35:00',2.02),('325','2013-08-03','17:40:00',1.93),('325','2013-08-03','17:45:00',1.81),('325','2013-08-03','17:50:00',1.68),('325','2013-08-03','17:55:00',1.63),('325','2013-08-03','18:00:00',1.54),('325','2013-08-03','18:05:00',1.45),('325','2013-08-03','18:10:00',1.36),('325','2013-08-03','18:15:00',1.27),('325','2013-08-03','18:20:00',1.2),('325','2013-08-03','18:25:00',1.11),('325','2013-08-03','18:30:00',1.03),('325','2013-08-02','08:40:00',1.03),('325','2013-08-02','08:45:00',1.08),('325','2013-08-02','08:50:00',1.14),('325','2013-08-02','08:55:00',1.19),('325','2013-08-02','09:00:00',1.23),('325','2013-08-02','09:05:00',1.23),('325','2013-08-02','09:10:00',1.25),('325','2013-08-02','09:15:00',1.26),('325','2013-08-02','09:20:00',1.76),('325','2013-08-02','09:25:00',2.18),('325','2013-08-02','09:30:00',2.35),('325','2013-08-02','09:35:00',2.47),('325','2013-08-02','09:40:00',2.54),('325','2013-08-02','09:45:00',2.58),('325','2013-08-02','09:50:00',2.66),('325','2013-08-02','09:55:00',2.7),('325','2013-08-02','10:00:00',2.83),('325','2013-08-02','10:05:00',2.89),('325','2013-08-02','10:10:00',2.92),('325','2013-08-02','10:15:00',3.01),('325','2013-08-02','10:20:00',3.09),('325','2013-08-02','10:25:00',3.11),('325','2013-08-02','10:30:00',3.13),('325','2013-08-02','10:35:00',3.16),('325','2013-08-02','10:40:00',3.21),('325','2013-08-02','10:45:00',3.22),('325','2013-08-02','10:50:00',3.27),('325','2013-08-02','10:55:00',3.28),('325','2013-08-02','11:00:00',3.35),('325','2013-08-02','11:05:00',3.45),('325','2013-08-02','11:10:00',3.56),('325','2013-08-02','11:15:00',3.65),('325','2013-08-02','11:20:00',3.67),('325','2013-08-02','11:25:00',3.67),('325','2013-08-02','11:30:00',3.68),('325','2013-08-02','11:35:00',3.68),('325','2013-08-02','11:40:00',3.71),('325','2013-08-02','11:45:00',3.75),('325','2013-08-02','11:50:00',3.83),('325','2013-08-02','11:55:00',3.95),('325','2013-08-02','12:00:00',4),('325','2013-08-02','12:05:00',4.09),('325','2013-08-02','12:10:00',4.15),('325','2013-08-02','12:15:00',4.12),('325','2013-08-02','12:20:00',4.08),('325','2013-08-02','12:25:00',4.06),('325','2013-08-02','12:30:00',4.03),('325','2013-08-02','12:35:00',4.02),('325','2013-08-02','12:40:00',4.03),('325','2013-08-02','12:45:00',3.99),('325','2013-08-02','12:50:00',4),('325','2013-08-02','12:55:00',4.11),('325','2013-08-02','13:00:00',4.13),('325','2013-08-02','13:05:00',4.18),('325','2013-08-02','13:10:00',4.16),('325','2013-08-02','13:15:00',4.15),('325','2013-08-02','13:20:00',4.08),('325','2013-08-02','13:25:00',4.03),('325','2013-08-02','13:30:00',3.97),('325','2013-08-02','13:35:00',3.92),('325','2013-08-02','13:40:00',3.96),('325','2013-08-02','13:45:00',3.95),('325','2013-08-02','13:50:00',4),('325','2013-08-02','13:55:00',4.04),('325','2013-08-02','14:00:00',4.04),('325','2013-08-02','14:05:00',4.03),('325','2013-08-02','14:10:00',3.96),('325','2013-08-02','14:15:00',3.82),('325','2013-08-02','14:20:00',3.73),('325','2013-08-02','14:25:00',3.82),('325','2013-08-02','14:30:00',3.99),('325','2013-08-02','14:35:00',4.09),('325','2013-08-02','14:40:00',4.1),('325','2013-08-02','14:45:00',4.08),('325','2013-08-02','14:50:00',4.05),('325','2013-08-02','14:55:00',4.02),('325','2013-08-02','15:00:00',3.98),('325','2013-08-02','15:05:00',3.95),('325','2013-08-02','15:10:00',3.87),('325','2013-08-02','15:15:00',3.84),('325','2013-08-02','15:20:00',3.84),('325','2013-08-02','15:25:00',3.83),('325','2013-08-02','15:30:00',3.76),('325','2013-08-02','15:35:00',3.72),('325','2013-08-02','15:40:00',3.67),('325','2013-08-02','15:45:00',3.63),('325','2013-08-02','15:50:00',3.58),('325','2013-08-02','15:55:00',3.55),('325','2013-08-02','16:00:00',3.52),('325','2013-08-02','16:05:00',3.44),('325','2013-08-02','16:10:00',3.37),('325','2013-08-02','16:15:00',3.34),('325','2013-08-02','16:20:00',3.28),('325','2013-08-02','16:25:00',3.2),('325','2013-08-02','16:30:00',3.14),('325','2013-08-02','16:35:00',3.08),('325','2013-08-02','16:40:00',3),('325','2013-08-02','16:45:00',2.92),('325','2013-08-02','16:50:00',2.84),('325','2013-08-02','16:55:00',2.76),('325','2013-08-02','17:00:00',2.65),('325','2013-08-02','17:05:00',2.51),('325','2013-08-02','17:10:00',2.48),('325','2013-08-02','17:15:00',2.43),('325','2013-08-02','17:20:00',2.35),('325','2013-08-02','17:25:00',2.26),('325','2013-08-02','17:30:00',2.16),('325','2013-08-02','17:35:00',2.09),('325','2013-08-02','17:40:00',2),('325','2013-08-02','17:45:00',1.88),('325','2013-08-02','17:50:00',1.73),('325','2013-08-02','17:55:00',1.68),('325','2013-08-02','18:00:00',1.59),('325','2013-08-02','18:05:00',1.51),('325','2013-08-02','18:10:00',1.42),('325','2013-08-02','18:15:00',1.33),('325','2013-08-02','18:20:00',1.24),('325','2013-08-02','18:25:00',1.15),('325','2013-08-02','18:30:00',1.06),('325','2013-08-01','08:40:00',1.05),('325','2013-08-01','08:45:00',1.1),('325','2013-08-01','08:50:00',1.16),('325','2013-08-01','08:55:00',1.22),('325','2013-08-01','09:00:00',1.25),('325','2013-08-01','09:05:00',1.25),('325','2013-08-01','09:10:00',1.27),('325','2013-08-01','09:15:00',1.35),('325','2013-08-01','09:20:00',1.7),('325','2013-08-01','09:25:00',2.31),('325','2013-08-01','09:30:00',2.42),('325','2013-08-01','09:35:00',2.53),('325','2013-08-01','09:40:00',2.6),('325','2013-08-01','09:45:00',2.67),('325','2013-08-01','09:50:00',2.75),('325','2013-08-01','09:55:00',2.79),('325','2013-08-01','10:00:00',2.94),('325','2013-08-01','10:05:00',2.99),('325','2013-08-01','10:10:00',3.04),('325','2013-08-01','10:15:00',3.11),('325','2013-08-01','10:20:00',3.27),('325','2013-08-01','10:25:00',3.42),('325','2013-08-01','10:30:00',3.47),('325','2013-08-01','10:35:00',3.52),('325','2013-08-01','10:40:00',3.57),('325','2013-08-01','10:45:00',3.62),('325','2013-08-01','10:50:00',3.71),('325','2013-08-01','10:55:00',3.79),('325','2013-08-01','11:00:00',3.85),('325','2013-08-01','11:05:00',3.91),('325','2013-08-01','11:10:00',3.95),('325','2013-08-01','11:15:00',3.99),('325','2013-08-01','11:20:00',4.02),('325','2013-08-01','11:25:00',4.06),('325','2013-08-01','11:30:00',4.08),('325','2013-08-01','11:35:00',4.11),('325','2013-08-01','11:40:00',4.14),('325','2013-08-01','11:45:00',4.18),('325','2013-08-01','11:50:00',4.23),('325','2013-08-01','11:55:00',4.29),('325','2013-08-01','12:00:00',4.3),('325','2013-08-01','12:05:00',4.32),('325','2013-08-01','12:10:00',4.33),('325','2013-08-01','12:15:00',4.33),('325','2013-08-01','12:20:00',4.36),('325','2013-08-01','12:25:00',4.38),('325','2013-08-01','12:30:00',4.4),('325','2013-08-01','12:35:00',4.41),('325','2013-08-01','12:40:00',4.4),('325','2013-08-01','12:45:00',4.4),('325','2013-08-01','12:50:00',4.42),('325','2013-08-01','12:55:00',4.37),('325','2013-08-01','13:00:00',4.43),('325','2013-08-01','13:05:00',4.4),('325','2013-08-01','13:10:00',4.43),('325','2013-08-01','13:15:00',4.09),('325','2013-08-01','13:20:00',4.45),('325','2013-08-01','13:25:00',4.45),('325','2013-08-01','13:30:00',4.36),('325','2013-08-01','13:35:00',4.2),('325','2013-08-01','13:40:00',4.43),('325','2013-08-01','13:45:00',4.41),('325','2013-08-01','13:50:00',4.46),('325','2013-08-01','13:55:00',4.1),('325','2013-08-01','14:00:00',4.23),('325','2013-08-01','14:05:00',4.29),('325','2013-08-01','14:10:00',4.28),('325','2013-08-01','14:15:00',4.23),('325','2013-08-01','14:20:00',4.19),('325','2013-08-01','14:25:00',4.21),('325','2013-08-01','14:30:00',4.18),('325','2013-08-01','14:35:00',3.8),('325','2013-08-01','14:40:00',4),('325','2013-08-01','14:45:00',4.16),('325','2013-08-01','14:50:00',3.05),('325','2013-08-01','14:55:00',4.11),('325','2013-08-01','15:00:00',4),('325','2013-08-01','15:05:00',4.01),('325','2013-08-01','15:10:00',4.03),('325','2013-08-01','15:15:00',3.65),('325','2013-08-01','15:20:00',3.94),('325','2013-08-01','15:25:00',3.89),('325','2013-08-01','15:30:00',3.77),('325','2013-08-01','15:35:00',3.66),('325','2013-08-01','15:40:00',2.94),('325','2013-08-01','15:45:00',3.67),('325','2013-08-01','15:50:00',3.62),('325','2013-08-01','15:55:00',3.61),('325','2013-08-01','16:00:00',3.58),('325','2013-08-01','16:05:00',3.57),('325','2013-08-01','16:10:00',3.47),('325','2013-08-01','16:15:00',3.36),('325','2013-08-01','16:20:00',3.32),('325','2013-08-01','16:25:00',3.27),('325','2013-08-01','16:30:00',3.18),('325','2013-08-01','16:35:00',3.12),('325','2013-08-01','16:40:00',3.04),('325','2013-08-01','16:45:00',2.96),('325','2013-08-01','16:50:00',2.88),('325','2013-08-01','16:55:00',2.81),('325','2013-08-01','17:00:00',2.69),('325','2013-08-01','17:05:00',2.56),('325','2013-08-01','17:10:00',2.5),('325','2013-08-01','17:15:00',2.45),('325','2013-08-01','17:20:00',2.37),('325','2013-08-01','17:25:00',2.28),('325','2013-08-01','17:30:00',2.21),('325','2013-08-01','17:35:00',2.12),('325','2013-08-01','17:40:00',2.03),('325','2013-08-01','17:45:00',1.91),('325','2013-08-01','17:50:00',1.78),('325','2013-08-01','17:55:00',1.74),('325','2013-08-01','18:00:00',1.65),('325','2013-08-01','18:05:00',1.55),('325','2013-08-01','18:10:00',1.46),('325','2013-08-01','18:15:00',1.37),('325','2013-08-01','18:20:00',1.29),('325','2013-08-01','18:25:00',1.19),('325','2013-08-01','18:30:00',1.1),('325','2013-07-31','08:40:00',1.05),('325','2013-07-31','08:45:00',1.1),('325','2013-07-31','08:50:00',1.17),('325','2013-07-31','08:55:00',1.22),('325','2013-07-31','09:00:00',1.24),('325','2013-07-31','09:05:00',1.25),('325','2013-07-31','09:10:00',1.31),('325','2013-07-31','09:15:00',1.35),('325','2013-07-31','09:20:00',1.39),('325','2013-07-31','09:25:00',2.31),('325','2013-07-31','09:30:00',2.43),('325','2013-07-31','09:35:00',2.56),('325','2013-07-31','09:40:00',2.63),('325','2013-07-31','09:45:00',2.68),('325','2013-07-31','09:50:00',2.77),('325','2013-07-31','09:55:00',2.81),('325','2013-07-31','10:00:00',2.92),('325','2013-07-31','10:05:00',3.02),('325','2013-07-31','10:10:00',3.07),('325','2013-07-31','10:15:00',3.14),('325','2013-07-31','10:20:00',3.26),('325','2013-07-31','10:25:00',3.4),('325','2013-07-31','10:30:00',3.45),('325','2013-07-31','10:35:00',3.49),('325','2013-07-31','10:40:00',3.59),('325','2013-07-31','10:45:00',3.65),('325','2013-07-31','10:50:00',3.74),('325','2013-07-31','10:55:00',3.82),('325','2013-07-31','11:00:00',3.9),('325','2013-07-31','11:05:00',3.94),('325','2013-07-31','11:10:00',3.98),('325','2013-07-31','11:15:00',4),('325','2013-07-31','11:20:00',4.03),('325','2013-07-31','11:25:00',4.08),('325','2013-07-31','11:30:00',4.1),('325','2013-07-31','11:35:00',4.13),('325','2013-07-31','11:40:00',4.15),('325','2013-07-31','11:45:00',4.17),('325','2013-07-31','11:50:00',4.24),('325','2013-07-31','11:55:00',4.32),('325','2013-07-31','12:00:00',4.3),('325','2013-07-31','12:05:00',4.31),('325','2013-07-31','12:10:00',4.37),('325','2013-07-31','12:15:00',4.42),('325','2013-07-31','12:20:00',4.39),('325','2013-07-31','12:25:00',4.46),('325','2013-07-31','12:30:00',4.45),('325','2013-07-31','12:35:00',4.42),('325','2013-07-31','12:40:00',4.5),('325','2013-07-31','12:45:00',3.47),('325','2013-07-31','12:50:00',1.99),('325','2013-07-31','12:55:00',4.12),('325','2013-07-31','13:00:00',1.83),('325','2013-07-31','13:05:00',3.97),('325','2013-07-31','13:10:00',3.3),('325','2013-07-31','13:15:00',4.65),('325','2013-07-31','13:20:00',4.6),('325','2013-07-31','13:25:00',3.85),('325','2013-07-31','13:30:00',4.29),('325','2013-07-31','13:35:00',4.53),('325','2013-07-31','13:40:00',4.5),('325','2013-07-31','13:45:00',4.57),('325','2013-07-31','13:50:00',4.58),('325','2013-07-31','13:55:00',2.9),('325','2013-07-31','14:00:00',3.11),('325','2013-07-31','14:05:00',4.46),('325','2013-07-31','14:10:00',4.32),('325','2013-07-31','14:15:00',2.97),('325','2013-07-31','14:20:00',3.62),('325','2013-07-31','14:25:00',2.71),('325','2013-07-31','14:30:00',4.43),('325','2013-07-31','14:35:00',4.28),('325','2013-07-31','14:40:00',4.1),('325','2013-07-31','14:45:00',4.19),('325','2013-07-31','14:50:00',4.39),('325','2013-07-31','14:55:00',3.08),('325','2013-07-31','15:00:00',1.28),('325','2013-07-31','15:05:00',4.03),('325','2013-07-31','15:10:00',4.13),('325','2013-07-31','15:15:00',3.43),('325','2013-07-31','15:20:00',3.9),('325','2013-07-31','15:25:00',4.05),('325','2013-07-31','15:30:00',3.89),('325','2013-07-31','15:35:00',3.9),('325','2013-07-31','15:40:00',3.87),('325','2013-07-31','15:45:00',3.73),('325','2013-07-31','15:50:00',3.65),('325','2013-07-31','15:55:00',3.6),('325','2013-07-31','16:00:00',3.51),('325','2013-07-31','16:05:00',3.54),('325','2013-07-31','16:10:00',3.51),('325','2013-07-31','16:15:00',3.43),('325','2013-07-31','16:20:00',3.44),('325','2013-07-31','16:25:00',3.46),('325','2013-07-31','16:30:00',3.37),('325','2013-07-31','16:35:00',3.19),('325','2013-07-31','16:40:00',3.05),('325','2013-07-31','16:45:00',2.94),('325','2013-07-31','16:50:00',2.91),('325','2013-07-31','16:55:00',2.83),('325','2013-07-31','17:00:00',2.65),('325','2013-07-31','17:05:00',2.55),('325','2013-07-31','17:10:00',2.36),('325','2013-07-31','17:15:00',2.54),('325','2013-07-31','17:20:00',1.56),('325','2013-07-31','17:25:00',2.3),('325','2013-07-31','17:30:00',2.18),('325','2013-07-31','17:35:00',2.07),('325','2013-07-31','17:40:00',1.97),('325','2013-07-31','17:45:00',1.92),('325','2013-07-31','17:50:00',1.77),('325','2013-07-31','17:55:00',1.73),('325','2013-07-31','18:00:00',1.65),('325','2013-07-31','18:05:00',1.54),('325','2013-07-31','18:10:00',1.45),('325','2013-07-31','18:15:00',1.38),('325','2013-07-31','18:20:00',1.3),('325','2013-07-31','18:25:00',1.22),('325','2013-07-31','18:30:00',1.13),('325','2013-07-31','18:35:00',1.02),('325','2013-07-30','08:20:00',1.08),('325','2013-07-30','08:35:00',1.04),('325','2013-07-30','08:40:00',1.05),('325','2013-07-30','08:45:00',1.1),('325','2013-07-30','08:50:00',1.15),('325','2013-07-30','08:55:00',1.21),('325','2013-07-30','09:00:00',1.22),('325','2013-07-30','09:05:00',1.28),('325','2013-07-30','09:10:00',1.34),('325','2013-07-30','09:15:00',1.44),('325','2013-07-30','09:20:00',1.44),('325','2013-07-30','09:25:00',1.4),('325','2013-07-30','09:30:00',2),('325','2013-07-30','09:35:00',2.19),('325','2013-07-30','09:55:00',1.89),('325','2013-07-30','10:00:00',3.05),('325','2013-07-30','10:05:00',3.21),('325','2013-07-30','10:10:00',3.18),('325','2013-07-30','10:15:00',3.19),('325','2013-07-30','10:20:00',3.3),('325','2013-07-30','10:25:00',3.43),('325','2013-07-30','10:30:00',3.47),('325','2013-07-30','10:35:00',3.42),('325','2013-07-30','10:40:00',3.41),('325','2013-07-30','10:45:00',3.46),('325','2013-07-30','10:50:00',3.39),('325','2013-07-30','10:55:00',3.34),('325','2013-07-30','11:00:00',3.07),('325','2013-07-30','11:05:00',3.42),('325','2013-07-30','11:10:00',3.15),('325','2013-07-30','11:15:00',3.75),('325','2013-07-30','11:20:00',4.13),('325','2013-07-30','11:25:00',4.03),('325','2013-07-30','11:30:00',4.05),('325','2013-07-30','11:35:00',4.18),('325','2013-07-30','11:40:00',4.08),('325','2013-07-30','11:45:00',2.95),('325','2013-07-30','11:50:00',2.36),('325','2013-07-30','11:55:00',3.63),('325','2013-07-30','12:00:00',4.23),('325','2013-07-30','12:05:00',4.2),('325','2013-07-30','12:10:00',4.09),('325','2013-07-30','12:15:00',4.22),('325','2013-07-30','12:20:00',4.28),('325','2013-07-30','12:25:00',4.28),('325','2013-07-30','12:30:00',4.2),('325','2013-07-30','12:35:00',2.38),('325','2013-07-30','12:40:00',1.03),('325','2013-07-30','12:45:00',3.79),('325','2013-07-30','12:50:00',4.19),('325','2013-07-30','12:55:00',3.43),('325','2013-07-30','13:00:00',3.31),('325','2013-07-30','13:05:00',1.55),('325','2013-07-30','13:10:00',2.7),('325','2013-07-30','13:15:00',3.18),('325','2013-07-30','13:20:00',4.65),('325','2013-07-30','13:25:00',4.53),('325','2013-07-30','13:30:00',4.39),('325','2013-07-30','13:35:00',4.27),('325','2013-07-30','13:40:00',4.36),('325','2013-07-30','13:45:00',4.35),('325','2013-07-30','13:50:00',4.36),('325','2013-07-30','13:55:00',4.53),('325','2013-07-30','14:00:00',4.44),('325','2013-07-30','14:05:00',3.68),('325','2013-07-30','14:10:00',4.48),('325','2013-07-30','14:15:00',4.2),('325','2013-07-30','14:20:00',4.07),('325','2013-07-30','14:25:00',4.22),('325','2013-07-30','14:30:00',4.3),('325','2013-07-30','14:35:00',4.31),('325','2013-07-30','14:40:00',4.15),('325','2013-07-30','14:45:00',4.17),('325','2013-07-30','14:50:00',4.14),('325','2013-07-30','14:55:00',4.03),('325','2013-07-30','15:00:00',4.1),('325','2013-07-30','15:05:00',3.95),('325','2013-07-30','15:10:00',3.85),('325','2013-07-30','15:15:00',3.82),('325','2013-07-30','15:20:00',3.82),('325','2013-07-30','15:25:00',3.85),('325','2013-07-30','15:30:00',3.8),('325','2013-07-30','15:35:00',3.73),('325','2013-07-30','15:40:00',3.69),('325','2013-07-30','15:45:00',3.63),('325','2013-07-30','15:50:00',3.58),('325','2013-07-30','15:55:00',3.54),('325','2013-07-30','16:00:00',3.53),('325','2013-07-30','16:05:00',3.44),('325','2013-07-30','16:10:00',3.39),('325','2013-07-30','16:15:00',3.33),('325','2013-07-30','16:20:00',3.26),('325','2013-07-30','16:25:00',3.22),('325','2013-07-30','16:30:00',3.11),('325','2013-07-30','16:35:00',3.06),('325','2013-07-30','16:40:00',3.01),('325','2013-07-30','16:45:00',2.95),('325','2013-07-30','16:50:00',2.86),('325','2013-07-30','16:55:00',2.78),('325','2013-07-30','17:00:00',2.68),('325','2013-07-30','17:05:00',2.57),('325','2013-07-30','17:10:00',2.49),('325','2013-07-30','17:15:00',2.4),('325','2013-07-30','17:20:00',2.34),('325','2013-07-30','17:25:00',2.28),('325','2013-07-30','17:30:00',2.19),('325','2013-07-30','17:35:00',2.08),('325','2013-07-30','17:40:00',2),('325','2013-07-30','17:45:00',1.91),('325','2013-07-30','17:50:00',1.79),('325','2013-07-30','17:55:00',1.68),('325','2013-07-30','18:00:00',1.59),('325','2013-07-30','18:05:00',1.51),('325','2013-07-30','18:10:00',1.42),('325','2013-07-30','18:15:00',1.34),('325','2013-07-30','18:20:00',1.26),('325','2013-07-30','18:25:00',1.19),('325','2013-07-30','18:30:00',1.09),('325','2014-04-07','08:30:00',1.06),('325','2014-04-07','08:35:00',1.3),('325','2014-04-07','08:40:00',1.37),('325','2014-04-07','08:45:00',1.28),('325','2014-04-07','08:50:00',1.24),('325','2014-04-07','08:55:00',1.17),('325','2014-04-07','09:00:00',1.13),('325','2014-04-07','09:05:00',1.15),('325','2014-04-07','09:10:00',1.33),('325','2014-04-07','09:15:00',1.41),('325','2014-04-07','09:20:00',1.22),('325','2014-04-07','09:25:00',1.18),('325','2014-04-07','09:30:00',1.17),('325','2014-04-07','09:35:00',1.15),('325','2014-04-07','09:40:00',1.19),('325','2014-04-07','09:45:00',1.25),('325','2014-04-07','09:50:00',1.32),('325','2014-04-07','09:55:00',1.37),('325','2014-04-07','10:00:00',1.38),('325','2014-04-07','10:05:00',1.39),('325','2014-04-07','10:10:00',1.39),('325','2014-04-07','10:15:00',1.32),('325','2014-04-07','10:20:00',1.32),('325','2014-04-07','10:25:00',1.36),('325','2014-04-07','10:30:00',1.38),('325','2014-04-07','10:35:00',1.47),('325','2014-04-07','10:40:00',1.49),('325','2014-04-07','10:45:00',1.54),('325','2014-04-07','10:50:00',1.62),('325','2014-04-07','10:55:00',1.77),('325','2014-04-07','11:00:00',1.92),('325','2014-04-07','11:05:00',1.95),('325','2014-04-07','11:10:00',2.2),('325','2014-04-07','11:15:00',2.32),('325','2014-04-07','11:20:00',2.34),('325','2014-04-07','11:25:00',2.08),('325','2014-04-07','11:30:00',2.04),('325','2014-04-07','11:35:00',2.05),('325','2014-04-07','11:40:00',2.01),('325','2014-04-07','11:45:00',1.9),('325','2014-04-07','11:50:00',1.81),('325','2014-04-07','11:55:00',1.77),('325','2014-04-07','12:00:00',2),('325','2014-04-07','12:05:00',2.53),('325','2014-04-07','12:10:00',2.7),('325','2014-04-07','12:15:00',3.59),('325','2014-04-07','12:20:00',4.19),('325','2014-04-07','12:25:00',3.83),('325','2014-04-07','12:30:00',2.61),('325','2014-04-07','12:35:00',2.35),('325','2014-04-07','12:40:00',2.98),('325','2014-04-07','12:45:00',4.39),('325','2014-04-07','12:50:00',4.43),('325','2014-04-07','12:55:00',4.34),('325','2014-04-07','13:00:00',4.37),('325','2014-04-07','13:05:00',4.36),('325','2014-04-07','13:10:00',4.32),('325','2014-04-07','13:15:00',4.3),('325','2014-04-07','13:20:00',4.29),('325','2014-04-07','13:25:00',4.29),('325','2014-04-07','13:30:00',4.28),('325','2014-04-07','13:35:00',4.24),('325','2014-04-07','13:40:00',4.23),('325','2014-04-07','13:45:00',4.23),('325','2014-04-07','13:50:00',4.26),('325','2014-04-07','13:55:00',4.23),('325','2014-04-07','14:00:00',4.23),('325','2014-04-07','14:05:00',4.22),('325','2014-04-07','14:10:00',4.18),('325','2014-04-07','14:15:00',4.1),('325','2014-04-07','14:20:00',4.11),('325','2014-04-07','14:25:00',4.19),('325','2014-04-07','14:30:00',4.17),('325','2014-04-07','14:35:00',4.04),('325','2014-04-07','14:40:00',4.02),('325','2014-04-07','14:45:00',4.01),('325','2014-04-07','14:50:00',3.96),('325','2014-04-07','14:55:00',3.97),('325','2014-04-07','15:00:00',3.88),('325','2014-04-07','15:05:00',3.91),('325','2014-04-07','15:10:00',3.84),('325','2014-04-07','15:15:00',3.93),('325','2014-04-07','15:20:00',4.09),('325','2014-04-07','15:25:00',4.07),('325','2014-04-07','15:30:00',3.77),('325','2014-04-07','15:35:00',3.76),('325','2014-04-07','15:40:00',3.71),('325','2014-04-07','15:45:00',3.75),('325','2014-04-07','15:50:00',3.91),('325','2014-04-07','15:55:00',3.88),('325','2014-04-07','16:00:00',3.06),('325','2014-04-07','16:05:00',2.4),('325','2014-04-07','16:10:00',3.23),('325','2014-04-07','16:15:00',3.2),('325','2014-04-07','16:20:00',2.97),('325','2014-04-07','16:25:00',2.86),('325','2014-04-07','16:30:00',2.69),('325','2014-04-07','16:35:00',1.45),('325','2014-04-07','16:40:00',1.45),('325','2014-04-07','16:45:00',1.78),('325','2014-04-07','16:50:00',2.54),('325','2014-04-07','16:55:00',2.66),('325','2014-04-07','17:00:00',2.7),('325','2014-04-07','17:05:00',2.57),('325','2014-04-07','17:10:00',1.7),('325','2014-04-07','17:15:00',2.13),('325','2014-04-07','17:20:00',1.65),('325','2014-04-07','17:25:00',1.07),('325','2014-04-07','17:45:00',1),('325','2014-04-07','17:55:00',1.19),('325','2014-04-07','18:00:00',1.07),('325','2013-07-29','08:40:00',1.03),('325','2013-07-29','08:45:00',1.06),('325','2013-07-29','08:50:00',1.13),('325','2013-07-29','08:55:00',1.15),('325','2013-07-29','09:00:00',1.19),('325','2013-07-29','09:05:00',1.26),('325','2013-07-29','09:10:00',1.33),('325','2013-07-29','09:15:00',1.38),('325','2013-07-29','09:20:00',1.4),('325','2013-07-29','09:25:00',1.44),('325','2013-07-29','09:30:00',1.52),('325','2013-07-29','09:35:00',2.15),('325','2013-07-29','09:40:00',2.28),('325','2013-07-29','09:45:00',2.36),('325','2013-07-29','09:50:00',2.47),('325','2013-07-29','09:55:00',2.55),('325','2013-07-29','10:00:00',2.63),('325','2013-07-29','10:05:00',2.68),('325','2013-07-29','10:10:00',2.74),('325','2013-07-29','10:15:00',2.78),('325','2013-07-29','10:20:00',2.81),('325','2013-07-29','10:25:00',2.86),('325','2013-07-29','10:30:00',2.99),('325','2013-07-29','10:35:00',3.04),('325','2013-07-29','10:40:00',3.14),('325','2013-07-29','10:45:00',3.18),('325','2013-07-29','10:50:00',3.24),('325','2013-07-29','10:55:00',3.27),('325','2013-07-29','11:00:00',3.31),('325','2013-07-29','11:05:00',3.4),('325','2013-07-29','11:10:00',3.44),('325','2013-07-29','11:15:00',3.5),('325','2013-07-29','11:20:00',3.62),('325','2013-07-29','11:25:00',3.73),('325','2013-07-29','11:30:00',3.73),('325','2013-07-29','11:35:00',3.76),('325','2013-07-29','11:40:00',3.77),('325','2013-07-29','11:45:00',3.78),('325','2013-07-29','11:50:00',3.82),('325','2013-07-29','11:55:00',3.89),('325','2013-07-29','12:00:00',3.99),('325','2013-07-29','12:05:00',4),('325','2013-07-29','12:10:00',4.06),('325','2013-07-29','12:15:00',4),('325','2013-07-29','12:20:00',4),('325','2013-07-29','12:25:00',4),('325','2013-07-29','12:30:00',3.97),('325','2013-07-29','12:35:00',3.95),('325','2013-07-29','12:40:00',3.94),('325','2013-07-29','12:45:00',3.94),('325','2013-07-29','12:50:00',3.92),('325','2013-07-29','12:55:00',3.98),('325','2013-07-29','13:00:00',4.09),('325','2013-07-29','13:05:00',4.06),('325','2013-07-29','13:10:00',4.13),('325','2013-07-29','13:15:00',4.13),('325','2013-07-29','13:20:00',4.14),('325','2013-07-29','13:25:00',4.12),('325','2013-07-29','13:30:00',4.07),('325','2013-07-29','13:35:00',4.01),('325','2013-07-29','13:40:00',4.04),('325','2013-07-29','13:45:00',4.25),('325','2013-07-29','13:50:00',4.27),('325','2013-07-29','13:55:00',4.22),('325','2013-07-29','14:00:00',4.15),('325','2013-07-29','14:05:00',4.12),('325','2013-07-29','14:10:00',4.04),('325','2013-07-29','14:15:00',3.97),('325','2013-07-29','14:20:00',4.12),('325','2013-07-29','14:25:00',4.12),('325','2013-07-29','14:30:00',4.1),('325','2013-07-29','14:35:00',4.09),('325','2013-07-29','14:40:00',4.06),('325','2013-07-29','14:45:00',4.01),('325','2013-07-29','14:50:00',4),('325','2013-07-29','14:55:00',3.98),('325','2013-07-29','15:00:00',3.94),('325','2013-07-29','15:05:00',3.92),('325','2013-07-29','15:10:00',3.9),('325','2013-07-29','15:15:00',3.83),('325','2013-07-29','15:20:00',3.79),('325','2013-07-29','15:25:00',3.78),('325','2013-07-29','15:30:00',3.74),('325','2013-07-29','15:35:00',3.71),('325','2013-07-29','15:40:00',3.76),('325','2013-07-29','15:45:00',3.74),('325','2013-07-29','15:50:00',2.91),('325','2013-07-29','15:55:00',2.02),('325','2013-07-29','16:00:00',1.96),('325','2013-07-29','16:05:00',3.13),('325','2013-07-29','16:10:00',3.27),('325','2013-07-29','16:15:00',2.59),('325','2013-07-29','16:20:00',2.58),('325','2013-07-29','16:25:00',2.84),('325','2013-07-29','16:30:00',3.26),('325','2013-07-29','16:35:00',2.71),('325','2013-07-29','16:40:00',2.84),('325','2013-07-29','16:45:00',3.19),('325','2013-07-29','16:50:00',2.69),('325','2013-07-29','16:55:00',2.05),('325','2013-07-29','17:00:00',1.46),('325','2013-07-29','17:05:00',2.23),('325','2013-07-29','17:10:00',1.33),('325','2013-07-29','17:15:00',1.31),('325','2013-07-29','17:20:00',2.38),('325','2013-07-29','17:25:00',2.08),('325','2013-07-29','17:30:00',1.38),('325','2013-07-29','17:40:00',1.24),('325','2013-07-29','17:45:00',1.89),('325','2013-07-29','17:50:00',1.76),('325','2013-07-29','17:55:00',1.61),('325','2013-07-29','18:00:00',1.1),('325','2013-07-29','18:10:00',1.4),('325','2013-07-29','18:15:00',1.11),('325','2013-07-29','18:20:00',1.24),('325','2013-07-29','18:25:00',1.22),('325','2013-07-29','18:30:00',1.12),('325','2013-07-28','08:40:00',1.06),('325','2013-07-28','08:45:00',1.11),('325','2013-07-28','08:50:00',1.18),('325','2013-07-28','08:55:00',1.21),('325','2013-07-28','09:00:00',1.24),('325','2013-07-28','09:05:00',1.26),('325','2013-07-28','09:10:00',1.28),('325','2013-07-28','09:15:00',1.32),('325','2013-07-28','09:20:00',1.35),('325','2013-07-28','09:25:00',1.39),('325','2013-07-28','09:30:00',1.45),('325','2013-07-28','09:35:00',2.2),('325','2013-07-28','09:40:00',2.28),('325','2013-07-28','09:45:00',2.36),('325','2013-07-28','09:50:00',2.44),('325','2013-07-28','09:55:00',2.54),('325','2013-07-28','10:00:00',2.64),('325','2013-07-28','10:05:00',2.7),('325','2013-07-28','10:10:00',2.75),('325','2013-07-28','10:15:00',2.8),('325','2013-07-28','10:20:00',2.8),('325','2013-07-28','10:25:00',2.82),('325','2013-07-28','10:30:00',2.92),('325','2013-07-28','10:35:00',3.05),('325','2013-07-28','10:40:00',3.14),('325','2013-07-28','10:45:00',3.17),('325','2013-07-28','10:50:00',3.21),('325','2013-07-28','10:55:00',3.22),('325','2013-07-28','11:00:00',3.31),('325','2013-07-28','11:05:00',3.36),('325','2013-07-28','11:10:00',3.42),('325','2013-07-28','11:15:00',3.52),('325','2013-07-28','11:20:00',3.56),('325','2013-07-28','11:25:00',3.55),('325','2013-07-28','11:30:00',3.58),('325','2013-07-28','11:35:00',3.61),('325','2013-07-28','11:40:00',3.6),('325','2013-07-28','11:45:00',3.59),('325','2013-07-28','11:50:00',3.69),('325','2013-07-28','11:55:00',3.77),('325','2013-07-28','12:00:00',3.81),('325','2013-07-28','12:05:00',3.84),('325','2013-07-28','12:10:00',3.87),('325','2013-07-28','12:15:00',3.95),('325','2013-07-28','12:20:00',3.94),('325','2013-07-28','12:25:00',3.97),('325','2013-07-28','12:30:00',4.01),('325','2013-07-28','12:35:00',3.96),('325','2013-07-28','12:40:00',3.93),('325','2013-07-28','12:45:00',3.87),('325','2013-07-28','12:50:00',3.92),('325','2013-07-28','12:55:00',3.99),('325','2013-07-28','13:00:00',4.03),('325','2013-07-28','13:05:00',4.22),('325','2013-07-28','13:10:00',4.01),('325','2013-07-28','13:15:00',3.63),('325','2013-07-28','13:20:00',4.14),('325','2013-07-28','13:25:00',4.05),('325','2013-07-28','13:30:00',4.01),('325','2013-07-28','13:35:00',3.98),('325','2013-07-28','13:40:00',4.01),('325','2013-07-28','13:45:00',4.06),('325','2013-07-28','13:50:00',3.98),('325','2013-07-28','13:55:00',3.97),('325','2013-07-28','14:00:00',4.02),('325','2013-07-28','14:05:00',4.05),('325','2013-07-28','14:10:00',4),('325','2013-07-28','14:15:00',3.87),('325','2013-07-28','14:20:00',3.79),('325','2013-07-28','14:25:00',3.78),('325','2013-07-28','14:30:00',3.73),('325','2013-07-28','14:35:00',3.74),('325','2013-07-28','14:40:00',3.99),('325','2013-07-28','14:45:00',3.95),('325','2013-07-28','14:50:00',3.98),('325','2013-07-28','14:55:00',3.92),('325','2013-07-28','15:00:00',3.9),('325','2013-07-28','15:05:00',3.85),('325','2013-07-28','15:10:00',3.83),('325','2013-07-28','15:15:00',3.75),('325','2013-07-28','15:20:00',3.71),('325','2013-07-28','15:25:00',3.7),('325','2013-07-28','15:30:00',3.65),('325','2013-07-28','15:35:00',3.61),('325','2013-07-28','15:40:00',3.56),('325','2013-07-28','15:45:00',3.56),('325','2013-07-28','15:50:00',3.51),('325','2013-07-28','15:55:00',3.49),('325','2013-07-28','16:00:00',3.44),('325','2013-07-28','16:05:00',3.43),('325','2013-07-28','16:10:00',3.38),('325','2013-07-28','16:15:00',3.35),('325','2013-07-28','16:20:00',3.28),('325','2013-07-28','16:25:00',3.23),('325','2013-07-28','16:30:00',3.16),('325','2013-07-28','16:35:00',3.09),('325','2013-07-28','16:40:00',3.02),('325','2013-07-28','16:45:00',2.96),('325','2013-07-28','16:50:00',2.89),('325','2013-07-28','16:55:00',2.81),('325','2013-07-28','17:00:00',2.71),('325','2013-07-28','17:05:00',2.58),('325','2013-07-28','17:10:00',2.5),('325','2013-07-28','17:15:00',2.47),('325','2013-07-28','17:20:00',2.38),('325','2013-07-28','17:25:00',2.29),('325','2013-07-28','17:30:00',2.2),('325','2013-07-28','17:35:00',2.12),('325','2013-07-28','17:40:00',2.05),('325','2013-07-28','17:45:00',1.95),('325','2013-07-28','17:50:00',1.8),('325','2013-07-28','17:55:00',1.72),('325','2013-07-28','18:00:00',1.65),('325','2013-07-28','18:05:00',1.56),('325','2013-07-28','18:10:00',1.46),('325','2013-07-28','18:15:00',1.38),('325','2013-07-28','18:20:00',1.3),('325','2013-07-28','18:25:00',1.22),('325','2013-07-28','18:30:00',1.12),('325','2013-07-28','18:35:00',1),('325','2013-07-27','08:40:00',1.03),('325','2013-07-27','08:45:00',1.08),('325','2013-07-27','08:50:00',1.12),('325','2013-07-27','08:55:00',1.15),('325','2013-07-27','09:00:00',1.18),('325','2013-07-27','09:05:00',1.24),('325','2013-07-27','09:10:00',1.31),('325','2013-07-27','09:15:00',1.35),('325','2013-07-27','09:20:00',1.38),('325','2013-07-27','09:25:00',1.4),('325','2013-07-27','09:30:00',1.43),('325','2013-07-27','09:35:00',2.06),('325','2013-07-27','09:40:00',2.37),('325','2013-07-27','09:45:00',2.42),('325','2013-07-27','09:50:00',2.49),('325','2013-07-27','09:55:00',2.6),('325','2013-07-27','10:00:00',2.71),('325','2013-07-27','10:05:00',2.78),('325','2013-07-27','10:10:00',2.83),('325','2013-07-27','10:15:00',2.89),('325','2013-07-27','10:20:00',2.87),('325','2013-07-27','10:25:00',2.89),('325','2013-07-27','10:30:00',2.93),('325','2013-07-27','10:35:00',3.05),('325','2013-07-27','10:40:00',3.15),('325','2013-07-27','10:45:00',3.24),('325','2013-07-27','10:50:00',3.25),('325','2013-07-27','10:55:00',3.3),('325','2013-07-27','11:00:00',3.35),('325','2013-07-27','11:05:00',3.43),('325','2013-07-27','11:10:00',3.54),('325','2013-07-27','11:15:00',3.65),('325','2013-07-27','11:20:00',3.7),('325','2013-07-27','11:25:00',3.7),('325','2013-07-27','11:30:00',3.67),('325','2013-07-27','11:35:00',3.67),('325','2013-07-27','11:40:00',3.65),('325','2013-07-27','11:45:00',3.68),('325','2013-07-27','11:50:00',3.75),('325','2013-07-27','11:55:00',3.83),('325','2013-07-27','12:00:00',3.9),('325','2013-07-27','12:05:00',4.01),('325','2013-07-27','12:10:00',3.99),('325','2013-07-27','12:15:00',4.03),('325','2013-07-27','12:20:00',3.97),('325','2013-07-27','12:25:00',4.02),('325','2013-07-27','12:30:00',3.92),('325','2013-07-27','12:35:00',3.98),('325','2013-07-27','12:40:00',3.93),('325','2013-07-27','12:45:00',4),('325','2013-07-27','12:50:00',4.01),('325','2013-07-27','12:55:00',4.1),('325','2013-07-27','13:00:00',3.36),('325','2013-07-27','13:05:00',1.06),('325','2013-07-27','13:10:00',2.59),('325','2013-07-27','13:15:00',4.29),('325','2013-07-27','13:20:00',4.18),('325','2013-07-27','13:25:00',4.11),('325','2013-07-27','13:30:00',4.06),('325','2013-07-27','13:35:00',3.99),('325','2013-07-27','13:40:00',4.06),('325','2013-07-27','13:45:00',4.06),('325','2013-07-27','13:50:00',4.03),('325','2013-07-27','13:55:00',4.06),('325','2013-07-27','14:00:00',4.04),('325','2013-07-27','14:05:00',4.18),('325','2013-07-27','14:10:00',4.17),('325','2013-07-27','14:15:00',3.96),('325','2013-07-27','14:20:00',3.85),('325','2013-07-27','14:25:00',3.86),('325','2013-07-27','14:30:00',3.81),('325','2013-07-27','14:35:00',3.79),('325','2013-07-27','14:40:00',3.76),('325','2013-07-27','14:45:00',3.77),('325','2013-07-27','14:50:00',3.79),('325','2013-07-27','14:55:00',3.75),('325','2013-07-27','15:00:00',3.72),('325','2013-07-27','15:05:00',3.74),('325','2013-07-27','15:10:00',3.69),('325','2013-07-27','15:15:00',3.72),('325','2013-07-27','15:20:00',3.71),('325','2013-07-27','15:25:00',3.78),('325','2013-07-27','15:30:00',3.76),('325','2013-07-27','15:35:00',3.72),('325','2013-07-27','15:40:00',3.67),('325','2013-07-27','15:45:00',3.65),('325','2013-07-27','15:50:00',3.59),('325','2013-07-27','15:55:00',3.54),('325','2013-07-27','16:00:00',3.48),('325','2013-07-27','16:05:00',3.43),('325','2013-07-27','16:10:00',3.38),('325','2013-07-27','16:15:00',3.32),('325','2013-07-27','16:20:00',3.27),('325','2013-07-27','16:25:00',3.23),('325','2013-07-27','16:30:00',3.18),('325','2013-07-27','16:35:00',3.11),('325','2013-07-27','16:40:00',3.06),('325','2013-07-27','16:45:00',2.97),('325','2013-07-27','16:50:00',2.89),('325','2013-07-27','16:55:00',2.8),('325','2013-07-27','17:00:00',2.69),('325','2013-07-27','17:05:00',2.6),('325','2013-07-27','17:10:00',2.53),('325','2013-07-27','17:15:00',2.47),('325','2013-07-27','17:20:00',2.38),('325','2013-07-27','17:25:00',2.29),('325','2013-07-27','17:30:00',2.2),('325','2013-07-27','17:35:00',2.12),('325','2013-07-27','17:40:00',2.03),('325','2013-07-27','17:45:00',1.95),('325','2013-07-27','17:50:00',1.82),('325','2013-07-27','17:55:00',1.72),('325','2013-07-27','18:00:00',1.67),('325','2013-07-27','18:05:00',1.58),('325','2013-07-27','18:10:00',1.5),('325','2013-07-27','18:15:00',1.4),('325','2013-07-27','18:20:00',1.31),('325','2013-07-27','18:25:00',1.23),('325','2013-07-27','18:30:00',1.15),('325','2013-07-27','18:35:00',1.03),('325','2013-07-26','08:35:00',1.04),('325','2013-07-26','08:40:00',1.07),('325','2013-07-26','08:45:00',1.12),('325','2013-07-26','08:50:00',1.18),('325','2013-07-26','08:55:00',1.21),('325','2013-07-26','09:00:00',1.21),('325','2013-07-26','09:05:00',1.24),('325','2013-07-26','09:10:00',1.32),('325','2013-07-26','09:15:00',1.39),('325','2013-07-26','09:20:00',1.4),('325','2013-07-26','09:25:00',1.46),('325','2013-07-26','09:30:00',1.51),('325','2013-07-26','09:35:00',1.73),('325','2013-07-26','09:40:00',2.21),('325','2013-07-26','09:45:00',2.32),('325','2013-07-26','09:50:00',2.4),('325','2013-07-26','09:55:00',2.53),('325','2013-07-26','10:00:00',2.66),('325','2013-07-26','10:05:00',2.74),('325','2013-07-26','10:10:00',2.75),('325','2013-07-26','10:15:00',2.83),('325','2013-07-26','10:20:00',2.89),('325','2013-07-26','10:25:00',2.95),('325','2013-07-26','10:30:00',2.99),('325','2013-07-26','10:35:00',3.08),('325','2013-07-26','10:40:00',3.19),('325','2013-07-26','10:45:00',3.23),('325','2013-07-26','10:50:00',3.25),('325','2013-07-26','10:55:00',3.28),('325','2013-07-26','11:00:00',3.29),('325','2013-07-26','11:05:00',3.5),('325','2013-07-26','11:10:00',3.55),('325','2013-07-26','11:15:00',3.63),('325','2013-07-26','11:20:00',3.75),('325','2013-07-26','11:25:00',3.69),('325','2013-07-26','11:30:00',3.69),('325','2013-07-26','11:35:00',3.72),('325','2013-07-26','11:40:00',3.71),('325','2013-07-26','11:45:00',3.7),('325','2013-07-26','11:50:00',3.83),('325','2013-07-26','11:55:00',2.99),('325','2013-07-26','12:00:00',1.88),('325','2013-07-26','12:05:00',3.2),('325','2013-07-26','12:10:00',4.32),('325','2013-07-26','12:15:00',4.25),('325','2013-07-26','12:20:00',4.29),('325','2013-07-26','12:25:00',4.27),('325','2013-07-26','12:30:00',4.25),('325','2013-07-26','12:35:00',4.19),('325','2013-07-26','12:40:00',4.23),('325','2013-07-26','12:45:00',4.25),('325','2013-07-26','12:50:00',2.61),('325','2013-07-26','12:55:00',1.67),('325','2013-07-26','13:00:00',1.91),('325','2013-07-26','13:05:00',1.48),('325','2013-07-26','13:10:00',2.23),('325','2013-07-26','13:15:00',1.77),('325','2013-07-26','13:20:00',1.47),('325','2013-07-26','13:25:00',1.41),('325','2013-07-26','13:30:00',4.35),('325','2013-07-26','13:35:00',4.56),('325','2013-07-26','13:40:00',4.38),('325','2013-07-26','13:45:00',4.51),('325','2013-07-26','13:50:00',4.38),('325','2013-07-26','13:55:00',4.39),('325','2013-07-26','14:00:00',3.58),('325','2013-07-26','14:05:00',3.12),('325','2013-07-26','14:10:00',4.33),('325','2013-07-26','14:15:00',4.15),('325','2013-07-26','14:20:00',3.99),('325','2013-07-26','14:25:00',3.98),('325','2013-07-26','14:30:00',3.97),('325','2013-07-26','14:35:00',3.93),('325','2013-07-26','14:40:00',3.82),('325','2013-07-26','14:45:00',3.86),('325','2013-07-26','14:50:00',3.83),('325','2013-07-26','14:55:00',3.83),('325','2013-07-26','15:00:00',3.83),('325','2013-07-26','15:05:00',3.78),('325','2013-07-26','15:10:00',3.78),('325','2013-07-26','15:15:00',3.8),('325','2013-07-26','15:20:00',3.74),('325','2013-07-26','15:25:00',3.69),('325','2013-07-26','15:30:00',3.68),('325','2013-07-26','15:35:00',3.66),('325','2013-07-26','15:40:00',3.7),('325','2013-07-26','15:45:00',3.67),('325','2013-07-26','15:50:00',3.6),('325','2013-07-26','15:55:00',3.57),('325','2013-07-26','16:00:00',3.5),('325','2013-07-26','16:05:00',3.47),('325','2013-07-26','16:10:00',3.41),('325','2013-07-26','16:15:00',3.38),('325','2013-07-26','16:20:00',3.31),('325','2013-07-26','16:25:00',3.28),('325','2013-07-26','16:30:00',3.2),('325','2013-07-26','16:35:00',3.11),('325','2013-07-26','16:40:00',3.05),('325','2013-07-26','16:45:00',2.98),('325','2013-07-26','16:50:00',2.9),('325','2013-07-26','16:55:00',2.8),('325','2013-07-26','17:00:00',2.73),('325','2013-07-26','17:05:00',2.59),('325','2013-07-26','17:10:00',2.54),('325','2013-07-26','17:15:00',2.45),('325','2013-07-26','17:20:00',2.36),('325','2013-07-26','17:25:00',2.29),('325','2013-07-26','17:30:00',2.19),('325','2013-07-26','17:35:00',2.1),('325','2013-07-26','17:40:00',2.02),('325','2013-07-26','17:45:00',1.92),('325','2013-07-26','17:50:00',1.77),('325','2013-07-26','17:55:00',1.62),('325','2013-07-26','18:00:00',1.57),('325','2013-07-26','18:05:00',1.52),('325','2013-07-26','18:10:00',1.43),('325','2013-07-26','18:15:00',1.31),('325','2013-07-26','18:20:00',1.25),('325','2013-07-26','18:25:00',1.2),('325','2013-07-26','18:30:00',1.1),('325','2013-07-25','08:35:00',1.03),('325','2013-07-25','08:40:00',1.07),('325','2013-07-25','08:45:00',1.14),('325','2013-07-25','08:50:00',1.18),('325','2013-07-25','08:55:00',1.24),('325','2013-07-25','09:00:00',1.25),('325','2013-07-25','09:05:00',1.28),('325','2013-07-25','09:10:00',1.41),('325','2013-07-25','09:15:00',1.58),('325','2013-07-25','09:20:00',1.48),('325','2013-07-25','09:25:00',1.46),('325','2013-07-25','09:30:00',1.72),('325','2013-07-25','09:35:00',1.36),('325','2013-07-25','09:40:00',1.11),('325','2013-07-25','09:45:00',1.03),('325','2013-07-25','09:55:00',1.25),('325','2013-07-25','10:00:00',2.61),('325','2013-07-25','10:05:00',2.79),('325','2013-07-25','10:10:00',2.86),('325','2013-07-25','10:15:00',2.83),('325','2013-07-25','10:20:00',2.42),('325','2013-07-25','10:25:00',1.73),('325','2013-07-25','10:30:00',1.34),('325','2013-07-25','10:35:00',2.45),('325','2013-07-25','10:40:00',3.26),('325','2013-07-25','10:45:00',3.64),('325','2013-07-25','10:50:00',3.65),('325','2013-07-25','10:55:00',3.67),('325','2013-07-25','11:00:00',3.81),('325','2013-07-25','11:05:00',3.79),('325','2013-07-25','11:10:00',3.9),('325','2013-07-25','11:15:00',3.88),('325','2013-07-25','11:20:00',3.85),('325','2013-07-25','11:25:00',3.9),('325','2013-07-25','11:30:00',3.99),('325','2013-07-25','11:35:00',2.67),('325','2013-07-25','11:40:00',3.29),('325','2013-07-25','11:45:00',3.42),('325','2013-07-25','11:50:00',4.29),('325','2013-07-25','11:55:00',3.8),('325','2013-07-25','12:00:00',4.31),('325','2013-07-25','12:05:00',1.68),('325','2013-07-25','12:10:00',3.48),('325','2013-07-25','12:15:00',2.44),('325','2013-07-25','12:20:00',4.62),('325','2013-07-25','12:25:00',3.7),('325','2013-07-25','12:30:00',4.42),('325','2013-07-25','12:35:00',3.95),('325','2013-07-25','12:40:00',3.06),('325','2013-07-25','12:45:00',2.62),('325','2013-07-25','12:50:00',4.6),('325','2013-07-25','12:55:00',4.59),('325','2013-07-25','13:00:00',4.37),('325','2013-07-25','13:05:00',4.58),('325','2013-07-25','13:10:00',4.59),('325','2013-07-25','13:15:00',4.43),('325','2013-07-25','13:20:00',4.36),('325','2013-07-25','13:25:00',4.19),('325','2013-07-25','13:30:00',4.2),('325','2013-07-25','13:35:00',4.18),('325','2013-07-25','13:40:00',4.39),('325','2013-07-25','13:45:00',4.44),('325','2013-07-25','13:50:00',4.43),('325','2013-07-25','13:55:00',4.41),('325','2013-07-25','14:00:00',4.34),('325','2013-07-25','14:05:00',4.32),('325','2013-07-25','14:10:00',4.29),('325','2013-07-25','14:15:00',4.28),('325','2013-07-25','14:20:00',4.29),('325','2013-07-25','14:25:00',4.29),('325','2013-07-25','14:30:00',4.33),('325','2013-07-25','14:35:00',4.29),('325','2013-07-25','14:40:00',4.28),('325','2013-07-25','14:45:00',4.26),('325','2013-07-25','14:50:00',4.24),('325','2013-07-25','14:55:00',4.21),('325','2013-07-25','15:00:00',4.2),('325','2013-07-25','15:05:00',4.15),('325','2013-07-25','15:10:00',4.09),('325','2013-07-25','15:15:00',4.05),('325','2013-07-25','15:20:00',4),('325','2013-07-25','15:25:00',3.94),('325','2013-07-25','15:30:00',3.91),('325','2013-07-25','15:35:00',3.88),('325','2013-07-25','15:40:00',3.84),('325','2013-07-25','15:45:00',3.81),('325','2013-07-25','15:50:00',3.73),('325','2013-07-25','15:55:00',3.68),('325','2013-07-25','16:00:00',3.64),('325','2013-07-25','16:05:00',3.61),('325','2013-07-25','16:10:00',3.57),('325','2013-07-25','16:15:00',3.52),('325','2013-07-25','16:20:00',3.45),('325','2013-07-25','16:25:00',3.35),('325','2013-07-25','16:30:00',3.28),('325','2013-07-25','16:35:00',3.24),('325','2013-07-25','16:40:00',3.17),('325','2013-07-25','16:45:00',3.1),('325','2013-07-25','16:50:00',3.03),('325','2013-07-25','16:55:00',2.95),('325','2013-07-25','17:00:00',2.87),('325','2013-07-25','17:05:00',2.72),('325','2013-07-25','17:10:00',2.61),('325','2013-07-25','17:15:00',2.58),('325','2013-07-25','17:20:00',2.49),('325','2013-07-25','17:25:00',2.43),('325','2013-07-25','17:30:00',2.34),('325','2013-07-25','17:35:00',2.25),('325','2013-07-25','17:40:00',2.16),('325','2013-07-25','17:45:00',2.05),('325','2013-07-25','17:50:00',1.93),('325','2013-07-25','17:55:00',1.84),('325','2013-07-25','18:00:00',1.76),('325','2013-07-25','18:05:00',1.66),('325','2013-07-25','18:10:00',1.56),('325','2013-07-25','18:15:00',1.45),('325','2013-07-25','18:20:00',1.37),('325','2013-07-25','18:25:00',1.2),('325','2013-07-25','18:30:00',1.17),('325','2013-07-25','18:35:00',1.04),('325','2013-07-24','08:15:00',1.09),('325','2013-07-24','08:25:00',1.07),('325','2013-07-24','08:45:00',1.19),('325','2013-07-24','08:50:00',1.32),('325','2013-07-24','08:55:00',1.28),('325','2013-07-24','09:00:00',1.18),('325','2013-07-24','09:05:00',1.24),('325','2013-07-24','09:10:00',1.82),('325','2013-07-24','09:15:00',1.44),('325','2013-07-24','09:20:00',1.48),('325','2013-07-24','09:25:00',1.46),('325','2013-07-24','09:30:00',1.78),('325','2013-07-24','09:35:00',1.54),('325','2013-07-24','09:40:00',1.25),('325','2013-07-24','09:45:00',1.43),('325','2013-07-24','09:50:00',1.29),('325','2013-07-24','09:55:00',1.11),('325','2013-07-24','10:10:00',1.5),('325','2013-07-24','10:15:00',2.93),('325','2013-07-24','10:20:00',3.24),('325','2013-07-24','10:25:00',3.36),('325','2013-07-24','10:30:00',3.38),('325','2013-07-24','10:35:00',3.42),('325','2013-07-24','10:40:00',2.41),('325','2013-07-24','10:45:00',2.22),('325','2013-07-24','10:50:00',1.41),('325','2013-07-24','10:55:00',1.4),('325','2013-07-24','11:00:00',2.42),('325','2013-07-24','11:05:00',3.65),('325','2013-07-24','11:10:00',4.01),('325','2013-07-24','11:15:00',4.05),('325','2013-07-24','11:20:00',2.96),('325','2013-07-24','11:25:00',4.08),('325','2013-07-24','11:30:00',4.14),('325','2013-07-24','11:35:00',3.98),('325','2013-07-24','11:40:00',4.04),('325','2013-07-24','11:45:00',4.12),('325','2013-07-24','11:50:00',3.88),('325','2013-07-24','11:55:00',4.1),('325','2013-07-24','12:00:00',4.04),('325','2013-07-24','12:05:00',2.56),('325','2013-07-24','12:10:00',4.75),('325','2013-07-24','12:15:00',3.59),('325','2013-07-24','12:20:00',1.52),('325','2013-07-24','12:25:00',1.92),('325','2013-07-24','12:30:00',2),('325','2013-07-24','12:35:00',1.33),('325','2013-07-24','12:40:00',3.19),('325','2013-07-24','12:45:00',3.62),('325','2013-07-24','12:50:00',3.6),('325','2013-07-24','12:55:00',4.57),('325','2013-07-24','13:00:00',2.88),('325','2013-07-24','13:05:00',4.55),('325','2013-07-24','13:10:00',3.64),('325','2013-07-24','13:15:00',4.18),('325','2013-07-24','13:20:00',2.21),('325','2013-07-24','13:25:00',3.95),('325','2013-07-24','13:30:00',4.47),('325','2013-07-24','13:35:00',3.1),('325','2013-07-24','13:40:00',4.73),('325','2013-07-24','13:45:00',4.64),('325','2013-07-24','13:50:00',4.44),('325','2013-07-24','13:55:00',3.78),('325','2013-07-24','14:00:00',4.56),('325','2013-07-24','14:05:00',4.56),('325','2013-07-24','14:10:00',4.45),('325','2013-07-24','14:15:00',4.33),('325','2013-07-24','14:20:00',4.5),('325','2013-07-24','14:25:00',4.51),('325','2013-07-24','14:30:00',3.8),('325','2013-07-24','14:35:00',4.56),('325','2013-07-24','14:40:00',4.38),('325','2013-07-24','14:45:00',4.39),('325','2013-07-24','14:50:00',4.34),('325','2013-07-24','14:55:00',4.26),('325','2013-07-24','15:00:00',4.23),('325','2013-07-24','15:05:00',4.17),('325','2013-07-24','15:10:00',4.11),('325','2013-07-24','15:15:00',4.11),('325','2013-07-24','15:20:00',4.09),('325','2013-07-24','15:25:00',4.06),('325','2013-07-24','15:30:00',3.85),('325','2013-07-24','15:35:00',3.78),('325','2013-07-24','15:40:00',3.9),('325','2013-07-24','15:45:00',3.77),('325','2013-07-24','15:50:00',3.67),('325','2013-07-24','15:55:00',3.68),('325','2013-07-24','16:00:00',3.65),('325','2013-07-24','16:05:00',3.58),('325','2013-07-24','16:10:00',3.53),('325','2013-07-24','16:15:00',3.54),('325','2013-07-24','16:20:00',3.53),('325','2013-07-24','16:25:00',3.51),('325','2013-07-24','16:30:00',3.42),('325','2013-07-24','16:35:00',3.38),('325','2013-07-24','16:40:00',3.3),('325','2013-07-24','16:45:00',3.19),('325','2013-07-24','16:50:00',3.17),('325','2013-07-24','16:55:00',3.19),('325','2013-07-24','17:00:00',3.07),('325','2013-07-24','17:05:00',2.94),('325','2013-07-24','17:10:00',2.63),('325','2013-07-24','17:15:00',2.69),('325','2013-07-24','17:20:00',2.57),('325','2013-07-24','17:25:00',2.46),('325','2013-07-24','17:30:00',2.37),('325','2013-07-24','17:35:00',2.22),('325','2013-07-24','17:40:00',2.15),('325','2013-07-24','17:45:00',2.04),('325','2013-07-24','17:50:00',1.94),('325','2013-07-24','17:55:00',1.79),('325','2013-07-24','18:00:00',1.7),('325','2013-07-24','18:05:00',1.62),('325','2013-07-24','18:10:00',1.47),('325','2013-07-24','18:15:00',1.4),('325','2013-07-24','18:20:00',1.33),('325','2013-07-24','18:25:00',1.27),('325','2013-07-24','18:30:00',1.17),('325','2013-07-24','18:35:00',1.05),('325','2013-07-23','08:40:00',1.03),('325','2013-07-23','08:45:00',1.16),('325','2013-07-23','08:50:00',1.24),('325','2013-07-23','08:55:00',1.29),('325','2013-07-23','09:00:00',1.3),('325','2013-07-23','09:05:00',1.29),('325','2013-07-23','09:10:00',1.32),('325','2013-07-23','09:15:00',1.35),('325','2013-07-23','09:20:00',1.38),('325','2013-07-23','09:25:00',1.4),('325','2013-07-23','09:30:00',1.42),('325','2013-07-23','09:35:00',1.79),('325','2013-07-23','09:40:00',2.48),('325','2013-07-23','09:45:00',2.54),('325','2013-07-23','09:50:00',2.58),('325','2013-07-23','09:55:00',2.68),('325','2013-07-23','10:00:00',2.73),('325','2013-07-23','10:05:00',2.81),('325','2013-07-23','10:10:00',2.85),('325','2013-07-23','10:15:00',2.88),('325','2013-07-23','10:20:00',2.97),('325','2013-07-23','10:25:00',3.07),('325','2013-07-23','10:30:00',3.14),('325','2013-07-23','10:35:00',3.2),('325','2013-07-23','10:40:00',3.26),('325','2013-07-23','10:45:00',3.36),('325','2013-07-23','10:50:00',3.4),('325','2013-07-23','10:55:00',3.44),('325','2013-07-23','11:00:00',3.46),('325','2013-07-23','11:05:00',3.53),('325','2013-07-23','11:10:00',3.64),('325','2013-07-23','11:15:00',3.78),('325','2013-07-23','11:20:00',3.88),('325','2013-07-23','11:25:00',3.85),('325','2013-07-23','11:30:00',3.81),('325','2013-07-23','11:35:00',3.82),('325','2013-07-23','11:40:00',3.9),('325','2013-07-23','11:45:00',3.89),('325','2013-07-23','11:50:00',3.95),('325','2013-07-23','11:55:00',4.08),('325','2013-07-23','12:00:00',4.12),('325','2013-07-23','12:05:00',4.25),('325','2013-07-23','12:10:00',4.32),('325','2013-07-23','12:15:00',4.38),('325','2013-07-23','12:20:00',4.35),('325','2013-07-23','12:25:00',4.28),('325','2013-07-23','12:30:00',3.14),('325','2013-07-23','12:35:00',1.05),('325','2013-07-23','12:45:00',3.09),('325','2013-07-23','12:50:00',2.18),('325','2013-07-23','12:55:00',3.34),('325','2013-07-23','13:00:00',1.09),('325','2013-07-23','13:30:00',2.64),('325','2013-07-23','13:35:00',4.29),('325','2013-07-23','13:40:00',2.39),('325','2013-07-23','13:55:00',1.3),('325','2013-07-23','14:00:00',4.12),('325','2013-07-23','14:05:00',4.6),('325','2013-07-23','14:10:00',1.52),('325','2013-07-23','14:25:00',1.73),('325','2013-07-23','14:30:00',2.63),('325','2013-07-23','14:35:00',3.6),('325','2013-07-23','14:40:00',1.84),('325','2013-07-23','14:45:00',3.39),('325','2013-07-23','14:50:00',2.22),('325','2013-07-23','14:55:00',3.5),('325','2013-07-23','15:00:00',4.76),('325','2013-07-23','15:05:00',4.36),('325','2013-07-23','15:10:00',4.22),('325','2013-07-23','15:15:00',4.22),('325','2013-07-23','15:20:00',4.05),('325','2013-07-23','15:25:00',4),('325','2013-07-23','15:30:00',3.9),('325','2013-07-23','15:35:00',3.94),('325','2013-07-23','15:40:00',3.75),('325','2013-07-23','15:45:00',3.7),('325','2013-07-23','15:50:00',3.67),('325','2013-07-23','15:55:00',3.64),('325','2013-07-23','16:00:00',3.59),('325','2013-07-23','16:05:00',3.57),('325','2013-07-23','16:10:00',3.49),('325','2013-07-23','16:15:00',3.42),('325','2013-07-23','16:20:00',3.37),('325','2013-07-23','16:25:00',3.32),('325','2013-07-23','16:30:00',3.25),('325','2013-07-23','16:35:00',3.18),('325','2013-07-23','16:40:00',3.1),('325','2013-07-23','16:45:00',3.03),('325','2013-07-23','16:50:00',2.97),('325','2013-07-23','16:55:00',2.91),('325','2013-07-23','17:00:00',2.82),('325','2013-07-23','17:05:00',2.7),('325','2013-07-23','17:10:00',2.58),('325','2013-07-23','17:15:00',2.57),('325','2013-07-23','17:20:00',2.49),('325','2013-07-23','17:25:00',2.4),('325','2013-07-23','17:30:00',2.32),('325','2013-07-23','17:35:00',2.26),('325','2013-07-23','17:40:00',2.17),('325','2013-07-23','17:45:00',2.07),('325','2013-07-23','17:50:00',1.96),('325','2013-07-23','17:55:00',1.83),('325','2013-07-23','18:00:00',1.79),('325','2013-07-23','18:05:00',1.69),('325','2013-07-23','18:10:00',1.6),('325','2013-07-23','18:15:00',1.51),('325','2013-07-23','18:20:00',1.43),('325','2013-07-23','18:25:00',1.32),('325','2013-07-23','18:30:00',1.22),('325','2013-07-23','18:35:00',1.05),('325','2013-07-22','08:35:00',1.03),('325','2013-07-22','08:40:00',1.08),('325','2013-07-22','08:45:00',1.2),('325','2013-07-22','08:50:00',1.27),('325','2013-07-22','08:55:00',1.31),('325','2013-07-22','09:00:00',1.32),('325','2013-07-22','09:05:00',1.32),('325','2013-07-22','09:10:00',1.36),('325','2013-07-22','09:15:00',1.4),('325','2013-07-22','09:20:00',1.41),('325','2013-07-22','09:25:00',1.44),('325','2013-07-22','09:30:00',1.47),('325','2013-07-22','09:35:00',1.51),('325','2013-07-22','09:40:00',2.32),('325','2013-07-22','09:45:00',2.51),('325','2013-07-22','09:50:00',2.59),('325','2013-07-22','09:55:00',2.7),('325','2013-07-22','10:00:00',2.77),('325','2013-07-22','10:05:00',2.86),('325','2013-07-22','10:10:00',2.91),('325','2013-07-22','10:15:00',2.97),('325','2013-07-22','10:20:00',2.98),('325','2013-07-22','10:25:00',2.99),('325','2013-07-22','10:30:00',3.01),('325','2013-07-22','10:35:00',3.08),('325','2013-07-22','10:40:00',3.16),('325','2013-07-22','10:45:00',3.34),('325','2013-07-22','10:50:00',3.4),('325','2013-07-22','10:55:00',3.41),('325','2013-07-22','11:00:00',3.44),('325','2013-07-22','11:05:00',3.51),('325','2013-07-22','11:10:00',3.78),('325','2013-07-22','11:15:00',3.83),('325','2013-07-22','11:20:00',3.89),('325','2013-07-22','11:25:00',3.92),('325','2013-07-22','11:30:00',3.93),('325','2013-07-22','11:35:00',3.96),('325','2013-07-22','11:40:00',3.99),('325','2013-07-22','11:45:00',4.01),('325','2013-07-22','11:50:00',4.05),('325','2013-07-22','11:55:00',4.08),('325','2013-07-22','12:00:00',4.16),('325','2013-07-22','12:05:00',4.19),('325','2013-07-22','12:10:00',4.18),('325','2013-07-22','12:15:00',4.23),('325','2013-07-22','12:20:00',4.22),('325','2013-07-22','12:25:00',4.16),('325','2013-07-22','12:30:00',4.12),('325','2013-07-22','12:35:00',4.1),('325','2013-07-22','12:40:00',4.08),('325','2013-07-22','12:45:00',4.05),('325','2013-07-22','12:50:00',4.06),('325','2013-07-22','12:55:00',4.14),('325','2013-07-22','13:00:00',4.23),('325','2013-07-22','13:05:00',4.28),('325','2013-07-22','13:10:00',4.27),('325','2013-07-22','13:15:00',4.23),('325','2013-07-22','13:20:00',4.19),('325','2013-07-22','13:25:00',4.18),('325','2013-07-22','13:30:00',4.08),('325','2013-07-22','13:35:00',4.02),('325','2013-07-22','13:40:00',4.02),('325','2013-07-22','13:45:00',4.06),('325','2013-07-22','13:50:00',4.05),('325','2013-07-22','13:55:00',4.06),('325','2013-07-22','14:00:00',4.07),('325','2013-07-22','14:05:00',4.12),('325','2013-07-22','14:10:00',4.06),('325','2013-07-22','14:15:00',4.05),('325','2013-07-22','14:20:00',4.08),('325','2013-07-22','14:25:00',4.04),('325','2013-07-22','14:30:00',4.13),('325','2013-07-22','14:35:00',4.12),('325','2013-07-22','14:40:00',4.08),('325','2013-07-22','14:45:00',4.08),('325','2013-07-22','14:50:00',4.06),('325','2013-07-22','14:55:00',4.03),('325','2013-07-22','15:00:00',3.97),('325','2013-07-22','15:05:00',3.89),('325','2013-07-22','15:10:00',3.94),('325','2013-07-22','15:15:00',3.86),('325','2013-07-22','15:20:00',3.6),('325','2013-07-22','15:25:00',3.5),('325','2013-07-22','15:30:00',3.02),('325','2013-07-22','15:45:00',2.07),('325','2013-07-22','15:50:00',4),('325','2013-07-22','15:55:00',4.07),('325','2013-07-22','16:00:00',4.03),('325','2013-07-22','16:05:00',3.94),('325','2013-07-22','16:10:00',3.8),('325','2013-07-22','16:15:00',3.73),('325','2013-07-22','16:20:00',3.64),('325','2013-07-22','16:25:00',3.5),('325','2013-07-22','16:30:00',3.3),('325','2013-07-22','16:35:00',3.27),('325','2013-07-22','16:40:00',3.04),('325','2013-07-22','16:45:00',2.94),('325','2013-07-22','16:50:00',2.89),('325','2013-07-22','16:55:00',2.85),('325','2013-07-22','17:00:00',2.77),('325','2013-07-22','17:05:00',2.67),('325','2013-07-22','17:10:00',2.53),('325','2013-07-22','17:15:00',2.51),('325','2013-07-22','17:20:00',2.44),('325','2013-07-22','17:25:00',2.34),('325','2013-07-22','17:30:00',2.21),('325','2013-07-22','17:35:00',2.19),('325','2013-07-22','17:40:00',2.15),('325','2013-07-22','17:45:00',1.85),('325','2013-07-22','17:50:00',1.76),('325','2013-07-22','17:55:00',1.74),('325','2013-07-22','18:00:00',1.75),('325','2013-07-22','18:05:00',1.65),('325','2013-07-22','18:10:00',1.5),('325','2013-07-22','18:15:00',1.36),('325','2013-07-22','18:20:00',1.29),('325','2013-07-22','18:25:00',1.25),('325','2013-07-22','18:30:00',1.11),('325','2013-07-21','08:35:00',1.04),('325','2013-07-21','08:40:00',1.11),('325','2013-07-21','08:45:00',1.2),('325','2013-07-21','08:50:00',1.27),('325','2013-07-21','08:55:00',1.31),('325','2013-07-21','09:00:00',1.33),('325','2013-07-21','09:05:00',1.34),('325','2013-07-21','09:10:00',1.38),('325','2013-07-21','09:15:00',1.42),('325','2013-07-21','09:20:00',1.45),('325','2013-07-21','09:25:00',1.47),('325','2013-07-21','09:30:00',1.52),('325','2013-07-21','09:35:00',1.56),('325','2013-07-21','09:40:00',1.82),('325','2013-07-21','09:45:00',2.44),('325','2013-07-21','09:50:00',2.52),('325','2013-07-21','09:55:00',2.63),('325','2013-07-21','10:00:00',2.72),('325','2013-07-21','10:05:00',2.79),('325','2013-07-21','10:10:00',2.83),('325','2013-07-21','10:15:00',2.88),('325','2013-07-21','10:20:00',2.92),('325','2013-07-21','10:25:00',2.91),('325','2013-07-21','10:30:00',2.92),('325','2013-07-21','10:35:00',2.98),('325','2013-07-21','10:40:00',3.07),('325','2013-07-21','10:45:00',3.19),('325','2013-07-21','10:50:00',3.33),('325','2013-07-21','10:55:00',3.35),('325','2013-07-21','11:00:00',3.4),('325','2013-07-21','11:05:00',3.47),('325','2013-07-21','11:10:00',3.51),('325','2013-07-21','11:15:00',3.57),('325','2013-07-21','11:20:00',3.65),('325','2013-07-21','11:25:00',3.72),('325','2013-07-21','11:30:00',3.73),('325','2013-07-21','11:35:00',3.72),('325','2013-07-21','11:40:00',3.82),('325','2013-07-21','11:45:00',3.82),('325','2013-07-21','11:50:00',3.8),('325','2013-07-21','11:55:00',3.86),('325','2013-07-21','12:00:00',3.97),('325','2013-07-21','12:05:00',3.82),('325','2013-07-21','12:10:00',3.7),('325','2013-07-21','12:15:00',4.23),('325','2013-07-21','12:20:00',4.08),('325','2013-07-21','12:25:00',4.62),('325','2013-07-21','12:30:00',4.12),('325','2013-07-21','12:35:00',4.91),('325','2013-07-21','12:40:00',4.93),('325','2013-07-21','12:45:00',4.79),('325','2013-07-21','12:50:00',4.3),('325','2013-07-21','12:55:00',4.98),('325','2013-07-21','13:00:00',5.05),('325','2013-07-21','13:05:00',4.29),('325','2013-07-21','13:10:00',3.28),('325','2013-07-21','13:15:00',2.53),('325','2013-07-21','13:20:00',3.01),('325','2013-07-21','13:25:00',4.09),('325','2013-07-21','13:30:00',4.59),('325','2013-07-21','13:35:00',4.55),('325','2013-07-21','13:40:00',3.9),('325','2013-07-21','13:45:00',4.53),('325','2013-07-21','13:50:00',2.49),('325','2013-07-21','13:55:00',1.02),('325','2013-07-21','14:00:00',1.02),('325','2013-07-21','14:05:00',1.17),('325','2013-07-21','14:10:00',1.11),('325','2013-07-21','14:15:00',1.11),('325','2013-07-21','14:20:00',1.39),('325','2013-07-21','14:25:00',1.56),('325','2013-07-21','14:30:00',1.23),('325','2013-07-21','14:35:00',1.21),('325','2013-07-21','14:40:00',1.26),('325','2013-07-21','14:45:00',1.42),('325','2013-07-21','14:50:00',1.68),('325','2013-07-21','14:55:00',1.75),('325','2013-07-21','15:00:00',1.83),('325','2013-07-21','15:05:00',1.72),('325','2013-07-21','15:10:00',1.83),('325','2013-07-21','15:15:00',4.35),('325','2013-07-21','15:20:00',4.08),('325','2013-07-21','15:25:00',1.72),('325','2013-07-21','15:30:00',1.52),('325','2013-07-21','15:35:00',1.7),('325','2013-07-21','15:40:00',2.81),('325','2013-07-21','15:45:00',3.51),('325','2013-07-21','15:50:00',2.91),('325','2013-07-21','15:55:00',2.12),('325','2013-07-21','16:00:00',1.59),('325','2013-07-21','16:05:00',1.13),('325','2013-07-21','16:55:00',1.07),('325','2013-07-21','17:00:00',1.2),('325','2013-07-21','17:05:00',1.38),('325','2013-07-21','17:10:00',1.46),('325','2013-07-21','17:15:00',1.19),('325','2013-07-21','17:20:00',1.05),('325','2013-07-20','08:35:00',1.03),('325','2013-07-20','08:40:00',1.1),('325','2013-07-20','08:45:00',1.25),('325','2013-07-20','08:50:00',1.31),('325','2013-07-20','08:55:00',1.38),('325','2013-07-20','09:00:00',1.4),('325','2013-07-20','09:05:00',1.44),('325','2013-07-20','09:10:00',1.53),('325','2013-07-20','09:15:00',1.61),('325','2013-07-20','09:20:00',1.62),('325','2013-07-20','09:25:00',1.57),('325','2013-07-20','09:30:00',1.55),('325','2013-07-20','09:35:00',1.58),('325','2013-07-20','09:40:00',1.95),('325','2013-07-20','09:45:00',2.57),('325','2013-07-20','09:50:00',2.55),('325','2013-07-20','09:55:00',2.58),('325','2013-07-20','10:00:00',2.77),('325','2013-07-20','10:05:00',2.83),('325','2013-07-20','10:10:00',2.92),('325','2013-07-20','10:15:00',2.96),('325','2013-07-20','10:20:00',2.97),('325','2013-07-20','10:25:00',2.97),('325','2013-07-20','10:30:00',2.98),('325','2013-07-20','10:35:00',3.04),('325','2013-07-20','10:40:00',3.11),('325','2013-07-20','10:45:00',3.24),('325','2013-07-20','10:50:00',3.35),('325','2013-07-20','10:55:00',3.4),('325','2013-07-20','11:00:00',3.44),('325','2013-07-20','11:05:00',3.48),('325','2013-07-20','11:10:00',3.54),('325','2013-07-20','11:15:00',3.6),('325','2013-07-20','11:20:00',3.64),('325','2013-07-20','11:25:00',3.71),('325','2013-07-20','11:30:00',3.8),('325','2013-07-20','11:35:00',3.78),('325','2013-07-20','11:40:00',3.79),('325','2013-07-20','11:45:00',3.83),('325','2013-07-20','11:50:00',3.88),('325','2013-07-20','11:55:00',3.99),('325','2013-07-20','12:00:00',4.03),('325','2013-07-20','12:05:00',4.21),('325','2013-07-20','12:10:00',4.28),('325','2013-07-20','12:15:00',4.32),('325','2013-07-20','12:20:00',4.27),('325','2013-07-20','12:25:00',4.16),('325','2013-07-20','12:30:00',4.17),('325','2013-07-20','12:35:00',4.2),('325','2013-07-20','12:40:00',4.21),('325','2013-07-20','12:45:00',4.26),('325','2013-07-20','12:50:00',4.2),('325','2013-07-20','12:55:00',4.25),('325','2013-07-20','13:00:00',4.47),('325','2013-07-20','13:05:00',4.3),('325','2013-07-20','13:10:00',1.18),('325','2013-07-20','13:15:00',1.6),('325','2013-07-20','13:20:00',4.16),('325','2013-07-20','13:25:00',4.64),('325','2013-07-20','13:30:00',4.64),('325','2013-07-20','13:35:00',4.57),('325','2013-07-20','13:40:00',4.64),('325','2013-07-20','13:45:00',4.03),('325','2013-07-20','13:50:00',1.23),('325','2013-07-20','13:55:00',1.46),('325','2013-07-20','14:00:00',4.58),('325','2013-07-20','14:05:00',4.44),('325','2013-07-20','14:10:00',4.47),('325','2013-07-20','14:15:00',4.48),('325','2013-07-20','14:20:00',4.41),('325','2013-07-20','14:25:00',4.19),('325','2013-07-20','14:30:00',3.88),('325','2013-07-20','14:35:00',4.11),('325','2013-07-20','14:40:00',3.97),('325','2013-07-20','14:45:00',4.3),('325','2013-07-20','14:50:00',4.39),('325','2013-07-20','14:55:00',4.15),('325','2013-07-20','15:00:00',4.3),('325','2013-07-20','15:05:00',4.12),('325','2013-07-20','15:10:00',4.11),('325','2013-07-20','15:15:00',4.04),('325','2013-07-20','15:20:00',3.95),('325','2013-07-20','15:25:00',3.95),('325','2013-07-20','15:30:00',3.92),('325','2013-07-20','15:35:00',3.85),('325','2013-07-20','15:40:00',3.79),('325','2013-07-20','15:45:00',3.74),('325','2013-07-20','15:50:00',3.68),('325','2013-07-20','15:55:00',3.6),('325','2013-07-20','16:00:00',3.57),('325','2013-07-20','16:05:00',3.53),('325','2013-07-20','16:10:00',3.46),('325','2013-07-20','16:15:00',3.47),('325','2013-07-20','16:20:00',3.4),('325','2013-07-20','16:25:00',3.34),('325','2013-07-20','16:30:00',3.27),('325','2013-07-20','16:35:00',3.17),('325','2013-07-20','16:40:00',3.13),('325','2013-07-20','16:45:00',3.07),('325','2013-07-20','16:50:00',3),('325','2013-07-20','16:55:00',2.87),('325','2013-07-20','17:00:00',2.78),('325','2013-07-20','17:05:00',2.68),('325','2013-07-20','17:10:00',2.54),('325','2013-07-20','17:15:00',2.52),('325','2013-07-20','17:20:00',2.45),('325','2013-07-20','17:25:00',2.36),('325','2013-07-20','17:30:00',2.28),('325','2013-07-20','17:35:00',2.21),('325','2013-07-20','17:40:00',2.14),('325','2013-07-20','17:45:00',2.04),('325','2013-07-20','17:50:00',1.96),('325','2013-07-20','17:55:00',1.81),('325','2013-07-20','18:00:00',1.74),('325','2013-07-20','18:05:00',1.65),('325','2013-07-20','18:10:00',1.56),('325','2013-07-20','18:15:00',1.46),('325','2013-07-20','18:20:00',1.38),('325','2013-07-20','18:25:00',1.29),('325','2013-07-20','18:30:00',1.15),('325','2014-04-06','08:40:00',1.05),('325','2014-04-06','08:45:00',1.09),('325','2014-04-06','09:10:00',1.18),('325','2014-04-06','09:15:00',1.54),('325','2014-04-06','09:20:00',1.47),('325','2014-04-06','09:25:00',1.47),('325','2014-04-06','09:30:00',1.32),('325','2014-04-06','09:35:00',1.64),('325','2014-04-06','09:40:00',1.88),('325','2014-04-06','09:45:00',2.25),('325','2014-04-06','09:50:00',2.64),('325','2014-04-06','09:55:00',2.64),('325','2014-04-06','10:00:00',2.62),('325','2014-04-06','10:05:00',2.04),('325','2014-04-06','10:10:00',1.65),('325','2014-04-06','10:15:00',1.96),('325','2014-04-06','10:20:00',1.62),('325','2014-04-06','10:25:00',1.28),('325','2014-04-06','10:30:00',1.36),('325','2014-04-06','10:35:00',1.52),('325','2014-04-06','10:40:00',1.69),('325','2014-04-06','10:45:00',2.56),('325','2014-04-06','10:50:00',2.34),('325','2014-04-06','10:55:00',1.52),('325','2014-04-06','11:00:00',2.4),('325','2014-04-06','11:05:00',3.74),('325','2014-04-06','11:10:00',4.59),('325','2014-04-06','11:15:00',3.2),('325','2014-04-06','11:20:00',4.03),('325','2014-04-06','11:25:00',4.37),('325','2014-04-06','11:30:00',4.57),('325','2014-04-06','11:35:00',4.36),('325','2014-04-06','11:40:00',3.61),('325','2014-04-06','11:45:00',4.77),('325','2014-04-06','11:50:00',3.88),('325','2014-04-06','11:55:00',4.01),('325','2014-04-06','12:00:00',4.81),('325','2014-04-06','12:05:00',4.6),('325','2014-04-06','12:10:00',4.65),('325','2014-04-06','12:15:00',4.25),('325','2014-04-06','12:20:00',4.05),('325','2014-04-06','12:25:00',2.15),('325','2014-04-06','12:30:00',2.22),('325','2014-04-06','12:35:00',2.16),('325','2014-04-06','12:40:00',1.37),('325','2014-04-06','12:45:00',1.09),('325','2014-04-06','12:50:00',1.16),('325','2014-04-06','12:55:00',1.33),('325','2014-04-06','13:00:00',4.82),('325','2014-04-06','13:05:00',4.27),('325','2014-04-06','13:10:00',5.13),('325','2014-04-06','13:15:00',3.8),('325','2014-04-06','13:20:00',2.53),('325','2014-04-06','13:25:00',1.67),('325','2014-04-06','13:30:00',3.84),('325','2014-04-06','13:35:00',5.18),('325','2014-04-06','13:40:00',2.11),('325','2014-04-06','13:45:00',2.71),('325','2014-04-06','13:50:00',4.52),('325','2014-04-06','13:55:00',4.89),('325','2014-04-06','14:00:00',4.67),('325','2014-04-06','14:05:00',4.26),('325','2014-04-06','14:10:00',4.68),('325','2014-04-06','14:15:00',4.34),('325','2014-04-06','14:20:00',2.4),('325','2014-04-06','14:25:00',1.53),('325','2014-04-06','14:30:00',1.14),('325','2014-04-06','14:35:00',1.31),('325','2014-04-06','14:40:00',1.69),('325','2014-04-06','14:45:00',4.98),('325','2014-04-06','14:50:00',4.29),('325','2014-04-06','14:55:00',3.58),('325','2014-04-06','15:00:00',2.88),('325','2014-04-06','15:05:00',1.32),('325','2014-04-06','15:10:00',3.16),('325','2014-04-06','15:15:00',3.54),('325','2014-04-06','15:20:00',3.17),('325','2014-04-06','15:25:00',2.05),('325','2014-04-06','15:30:00',1.72),('325','2014-04-06','15:50:00',1.28),('325','2014-04-06','15:55:00',3.96),('325','2014-04-06','16:00:00',3.25),('325','2014-04-06','16:05:00',1.99),('325','2014-04-06','16:10:00',3.03),('325','2014-04-06','16:15:00',1.54),('325','2014-04-06','16:35:00',1.34),('325','2014-04-06','16:40:00',2.47),('325','2014-04-06','16:45:00',3.28),('325','2014-04-06','16:50:00',3.32),('325','2014-04-06','16:55:00',2.41),('325','2014-04-06','17:00:00',1.07),('325','2014-04-06','17:25:00',2.03),('325','2014-04-06','17:30:00',1.97),('325','2014-04-06','17:35:00',1.36),('325','2014-04-06','17:45:00',1.2),('325','2014-04-06','17:50:00',1.57),('325','2014-04-06','17:55:00',1.41),('325','2014-04-06','18:00:00',1.28),('325','2014-04-06','18:05:00',1.17),('325','2014-04-06','18:10:00',1.07),('325','2014-04-06','18:15:00',1.02),('325','2014-04-06','18:20:00',1),('325','2013-07-19','08:30:00',1.01),('325','2013-07-19','08:35:00',1.1),('325','2013-07-19','08:40:00',1.16),('325','2013-07-19','08:45:00',1.23),('325','2013-07-19','08:50:00',1.29),('325','2013-07-19','08:55:00',1.32),('325','2013-07-19','09:00:00',1.33),('325','2013-07-19','09:05:00',1.34),('325','2013-07-19','09:10:00',1.39),('325','2013-07-19','09:15:00',1.43),('325','2013-07-19','09:20:00',1.45),('325','2013-07-19','09:25:00',1.48),('325','2013-07-19','09:30:00',1.53),('325','2013-07-19','09:35:00',1.58),('325','2013-07-19','09:40:00',1.62),('325','2013-07-19','09:45:00',2.24),('325','2013-07-19','09:50:00',2.48),('325','2013-07-19','09:55:00',2.54),('325','2013-07-19','10:00:00',2.57),('325','2013-07-19','10:05:00',2.62),('325','2013-07-19','10:10:00',2.74),('325','2013-07-19','10:15:00',2.84),('325','2013-07-19','10:20:00',2.86),('325','2013-07-19','10:25:00',2.88),('325','2013-07-19','10:30:00',2.86),('325','2013-07-19','10:35:00',2.99),('325','2013-07-19','10:40:00',3.1),('325','2013-07-19','10:45:00',3.18),('325','2013-07-19','10:50:00',3.2),('325','2013-07-19','10:55:00',3.25),('325','2013-07-19','11:00:00',3.33),('325','2013-07-19','11:05:00',3.4),('325','2013-07-19','11:10:00',3.47),('325','2013-07-19','11:15:00',3.6),('325','2013-07-19','11:20:00',3.7),('325','2013-07-19','11:25:00',3.7),('325','2013-07-19','11:30:00',3.68),('325','2013-07-19','11:35:00',3.74),('325','2013-07-19','11:40:00',3.68),('325','2013-07-19','11:45:00',3.74),('325','2013-07-19','11:50:00',3.71),('325','2013-07-19','11:55:00',3.79),('325','2013-07-19','12:00:00',3.9),('325','2013-07-19','12:05:00',4.05),('325','2013-07-19','12:10:00',4.16),('325','2013-07-19','12:15:00',4.3),('325','2013-07-19','12:20:00',4.29),('325','2013-07-19','12:25:00',4.22),('325','2013-07-19','12:30:00',4.13),('325','2013-07-19','12:35:00',4.08),('325','2013-07-19','12:40:00',4.06),('325','2013-07-19','12:45:00',4),('325','2013-07-19','12:50:00',4.31),('325','2013-07-19','12:55:00',4.34),('325','2013-07-19','13:00:00',4.15),('325','2013-07-19','13:05:00',4.45),('325','2013-07-19','13:10:00',3.25),('325','2013-07-19','13:15:00',1.92),('325','2013-07-19','13:20:00',3.02),('325','2013-07-19','13:25:00',4.64),('325','2013-07-19','13:30:00',4.44),('325','2013-07-19','13:35:00',4.32),('325','2013-07-19','13:40:00',4.32),('325','2013-07-19','13:45:00',4.34),('325','2013-07-19','13:50:00',4.36),('325','2013-07-19','13:55:00',4.41),('325','2013-07-19','14:00:00',4.4),('325','2013-07-19','14:05:00',4.36),('325','2013-07-19','14:10:00',4.39),('325','2013-07-19','14:15:00',4.3),('325','2013-07-19','14:20:00',4.43),('325','2013-07-19','14:25:00',4.12),('325','2013-07-19','14:30:00',4.12),('325','2013-07-19','14:35:00',3.94),('325','2013-07-19','14:40:00',4.25),('325','2013-07-19','14:45:00',4.13),('325','2013-07-19','14:50:00',4.17),('325','2013-07-19','14:55:00',4.24),('325','2013-07-19','15:00:00',4.23),('325','2013-07-19','15:05:00',4.21),('325','2013-07-19','15:10:00',4.12),('325','2013-07-19','15:15:00',2.62),('325','2013-07-19','15:20:00',2.85),('325','2013-07-19','15:25:00',3.75),('325','2013-07-19','15:30:00',4.19),('325','2013-07-19','15:35:00',4.03),('325','2013-07-19','15:40:00',3.94),('325','2013-07-19','15:45:00',3.93),('325','2013-07-19','15:50:00',3.84),('325','2013-07-19','15:55:00',3.76),('325','2013-07-19','16:00:00',3.67),('325','2013-07-19','16:05:00',3.64),('325','2013-07-19','16:10:00',3.62),('325','2013-07-19','16:15:00',3.55),('325','2013-07-19','16:20:00',3.51),('325','2013-07-19','16:25:00',3.45),('325','2013-07-19','16:30:00',3.42),('325','2013-07-19','16:35:00',3.36),('325','2013-07-19','16:40:00',3.3),('325','2013-07-19','16:45:00',3.23),('325','2013-07-19','16:50:00',3.19),('325','2013-07-19','16:55:00',3.19),('325','2013-07-19','17:00:00',2.58),('325','2013-07-19','17:05:00',3.08),('325','2013-07-19','17:10:00',2.75),('325','2013-07-19','17:15:00',2.74),('325','2013-07-19','17:20:00',2.41),('325','2013-07-19','17:25:00',1.93),('325','2013-07-19','17:30:00',2.34),('325','2013-07-19','17:35:00',2.56),('325','2013-07-19','17:40:00',2.05),('325','2013-07-19','17:45:00',1.45),('325','2013-07-19','17:50:00',1.02),('325','2013-07-18','08:30:00',1.04),('325','2013-07-18','08:35:00',1.11),('325','2013-07-18','08:40:00',1.16),('325','2013-07-18','08:45:00',1.22),('325','2013-07-18','08:50:00',1.28),('325','2013-07-18','08:55:00',1.31),('325','2013-07-18','09:00:00',1.32),('325','2013-07-18','09:05:00',1.32),('325','2013-07-18','09:10:00',1.35),('325','2013-07-18','09:15:00',1.39),('325','2013-07-18','09:20:00',1.41),('325','2013-07-18','09:25:00',1.44),('325','2013-07-18','09:30:00',1.48),('325','2013-07-18','09:35:00',1.52),('325','2013-07-18','09:40:00',1.55),('325','2013-07-18','09:45:00',2.42),('325','2013-07-18','09:50:00',2.56),('325','2013-07-18','09:55:00',2.63),('325','2013-07-18','10:00:00',2.65),('325','2013-07-18','10:05:00',2.82),('325','2013-07-18','10:10:00',2.89),('325','2013-07-18','10:15:00',2.97),('325','2013-07-18','10:20:00',2.99),('325','2013-07-18','10:25:00',2.99),('325','2013-07-18','10:30:00',3),('325','2013-07-18','10:35:00',3.09),('325','2013-07-18','10:40:00',3.16),('325','2013-07-18','10:45:00',3.3),('325','2013-07-18','10:50:00',3.32),('325','2013-07-18','10:55:00',3.39),('325','2013-07-18','11:00:00',3.44),('325','2013-07-18','11:05:00',3.47),('325','2013-07-18','11:10:00',3.54),('325','2013-07-18','11:15:00',3.62),('325','2013-07-18','11:20:00',3.73),('325','2013-07-18','11:25:00',3.77),('325','2013-07-18','11:30:00',3.76),('325','2013-07-18','11:35:00',3.76),('325','2013-07-18','11:40:00',3.74),('325','2013-07-18','11:45:00',3.76),('325','2013-07-18','11:50:00',3.81),('325','2013-07-18','11:55:00',3.87),('325','2013-07-18','12:00:00',3.9),('325','2013-07-18','12:05:00',3.99),('325','2013-07-18','12:10:00',4),('325','2013-07-18','12:15:00',4.11),('325','2013-07-18','12:20:00',4.02),('325','2013-07-18','12:25:00',4.12),('325','2013-07-18','12:30:00',4.32),('325','2013-07-18','12:35:00',4.35),('325','2013-07-18','12:40:00',4.49),('325','2013-07-18','12:45:00',4.46),('325','2013-07-18','12:50:00',2.74),('325','2013-07-18','12:55:00',4.42),('325','2013-07-18','13:00:00',4.41),('325','2013-07-18','13:05:00',4.26),('325','2013-07-18','13:10:00',4.38),('325','2013-07-18','13:15:00',4.41),('325','2013-07-18','13:20:00',4.45),('325','2013-07-18','13:25:00',4.25),('325','2013-07-18','13:30:00',4.2),('325','2013-07-18','13:35:00',4.47),('325','2013-07-18','13:40:00',4.4),('325','2013-07-18','13:45:00',4.41),('325','2013-07-18','13:50:00',4.43),('325','2013-07-18','13:55:00',4.31),('325','2013-07-18','14:00:00',4.26),('325','2013-07-18','14:05:00',4.27),('325','2013-07-18','14:10:00',4.32),('325','2013-07-18','14:15:00',4.34),('325','2013-07-18','14:20:00',4.28),('325','2013-07-18','14:25:00',4.15),('325','2013-07-18','14:30:00',4.22),('325','2013-07-18','14:35:00',4.21),('325','2013-07-18','14:40:00',4.21),('325','2013-07-18','14:45:00',4.17),('325','2013-07-18','14:50:00',4.08),('325','2013-07-18','14:55:00',4.08),('325','2013-07-18','15:00:00',4.09),('325','2013-07-18','15:05:00',4.05),('325','2013-07-18','15:10:00',4),('325','2013-07-18','15:15:00',3.98),('325','2013-07-18','15:20:00',3.98),('325','2013-07-18','15:25:00',3.96),('325','2013-07-18','15:30:00',3.9),('325','2013-07-18','15:35:00',3.87),('325','2013-07-18','15:40:00',3.79),('325','2013-07-18','15:45:00',3.76),('325','2013-07-18','15:50:00',3.7),('325','2013-07-18','15:55:00',3.62),('325','2013-07-18','16:00:00',3.59),('325','2013-07-18','16:05:00',3.53),('325','2013-07-18','16:10:00',3.48),('325','2013-07-18','16:15:00',3.4),('325','2013-07-18','16:20:00',3.37),('325','2013-07-18','16:25:00',3.31),('325','2013-07-18','16:30:00',3.23),('325','2013-07-18','16:35:00',3.17),('325','2013-07-18','16:40:00',3.1),('325','2013-07-18','16:45:00',3.04),('325','2013-07-18','16:50:00',2.93),('325','2013-07-18','16:55:00',2.84),('325','2013-07-18','17:00:00',2.75),('325','2013-07-18','17:05:00',2.65),('325','2013-07-18','17:10:00',2.54),('325','2013-07-18','17:15:00',2.44),('325','2013-07-18','17:20:00',2.44),('325','2013-07-18','17:25:00',2.32),('325','2013-07-18','17:30:00',2.21),('325','2013-07-18','17:35:00',2.11),('325','2013-07-18','17:40:00',1.84),('325','2013-07-18','17:45:00',1.85),('325','2013-07-18','17:50:00',1.86),('325','2013-07-18','17:55:00',1.68),('325','2013-07-18','18:00:00',1.57),('325','2013-07-18','18:05:00',1.31),('325','2013-07-18','18:10:00',1.41),('325','2013-07-18','18:15:00',1.29),('325','2013-07-18','18:20:00',1.21),('325','2013-07-18','18:25:00',1.11),('325','2013-07-17','08:25:00',1.02),('325','2013-07-17','08:30:00',1.08),('325','2013-07-17','08:35:00',1.16),('325','2013-07-17','08:40:00',1.2),('325','2013-07-17','08:45:00',1.27),('325','2013-07-17','08:50:00',1.32),('325','2013-07-17','08:55:00',1.35),('325','2013-07-17','09:00:00',1.36),('325','2013-07-17','09:05:00',1.36),('325','2013-07-17','09:10:00',1.4),('325','2013-07-17','09:15:00',1.43),('325','2013-07-17','09:20:00',1.46),('325','2013-07-17','09:25:00',1.48),('325','2013-07-17','09:30:00',1.51),('325','2013-07-17','09:35:00',1.55),('325','2013-07-17','09:40:00',1.61),('325','2013-07-17','09:45:00',2.6),('325','2013-07-17','09:50:00',2.66),('325','2013-07-17','09:55:00',2.8),('325','2013-07-17','10:00:00',2.85),('325','2013-07-17','10:05:00',2.92),('325','2013-07-17','10:10:00',2.99),('325','2013-07-17','10:15:00',3.07),('325','2013-07-17','10:20:00',3.08),('325','2013-07-17','10:25:00',3.08),('325','2013-07-17','10:30:00',3.16),('325','2013-07-17','10:35:00',3.27),('325','2013-07-17','10:40:00',3.29),('325','2013-07-17','10:45:00',3.38),('325','2013-07-17','10:50:00',3.43),('325','2013-07-17','10:55:00',3.46),('325','2013-07-17','11:00:00',3.52),('325','2013-07-17','11:05:00',3.59),('325','2013-07-17','11:10:00',3.68),('325','2013-07-17','11:15:00',3.74),('325','2013-07-17','11:20:00',3.85),('325','2013-07-17','11:25:00',3.9),('325','2013-07-17','11:30:00',3.91),('325','2013-07-17','11:35:00',3.86),('325','2013-07-17','11:40:00',3.85),('325','2013-07-17','11:45:00',3.85),('325','2013-07-17','11:50:00',3.92),('325','2013-07-17','11:55:00',3.95),('325','2013-07-17','12:00:00',4.24),('325','2013-07-17','12:05:00',4.32),('325','2013-07-17','12:10:00',4.3),('325','2013-07-17','12:15:00',4.32),('325','2013-07-17','12:20:00',4.27),('325','2013-07-17','12:25:00',4.24),('325','2013-07-17','12:30:00',4.24),('325','2013-07-17','12:35:00',4.36),('325','2013-07-17','12:40:00',4.37),('325','2013-07-17','12:45:00',4.37),('325','2013-07-17','12:50:00',4.35),('325','2013-07-17','12:55:00',4.36),('325','2013-07-17','13:00:00',4.4),('325','2013-07-17','13:05:00',4.4),('325','2013-07-17','13:10:00',4.38),('325','2013-07-17','13:15:00',4.4),('325','2013-07-17','13:20:00',4.39),('325','2013-07-17','13:25:00',4.32),('325','2013-07-17','13:30:00',4.37),('325','2013-07-17','13:35:00',4.34),('325','2013-07-17','13:40:00',4.31),('325','2013-07-17','13:45:00',4.31),('325','2013-07-17','13:50:00',4.27),('325','2013-07-17','13:55:00',4.21),('325','2013-07-17','14:00:00',4.19),('325','2013-07-17','14:05:00',4.16),('325','2013-07-17','14:10:00',4.11),('325','2013-07-17','14:15:00',4.03),('325','2013-07-17','14:20:00',3.95),('325','2013-07-17','14:25:00',3.9),('325','2013-07-17','14:30:00',4.09),('325','2013-07-17','14:35:00',4.13),('325','2013-07-17','14:40:00',4.23),('325','2013-07-17','14:45:00',4.21),('325','2013-07-17','14:50:00',4.09),('325','2013-07-17','14:55:00',3.92),('325','2013-07-17','15:00:00',4.07),('325','2013-07-17','15:05:00',4.06),('325','2013-07-17','15:10:00',3.95),('325','2013-07-17','15:15:00',3.97),('325','2013-07-17','15:20:00',3.96),('325','2013-07-17','15:25:00',3.93),('325','2013-07-17','15:30:00',3.89),('325','2013-07-17','15:35:00',3.9),('325','2013-07-17','15:40:00',3.85),('325','2013-07-17','15:45:00',3.7),('325','2013-07-17','15:50:00',2.9),('325','2013-07-17','15:55:00',2.9),('325','2013-07-17','16:00:00',3.66),('325','2013-07-17','16:05:00',3.56),('325','2013-07-17','16:10:00',3.53),('325','2013-07-17','16:15:00',3.48),('325','2013-07-17','16:20:00',3),('325','2013-07-17','16:25:00',3.26),('325','2013-07-17','16:30:00',3.17),('325','2013-07-17','16:35:00',3.18),('325','2013-07-17','16:40:00',3.05),('325','2013-07-17','16:45:00',3.06),('325','2013-07-17','16:50:00',2.96),('325','2013-07-17','16:55:00',2.93),('325','2013-07-17','17:00:00',2.87),('325','2013-07-17','17:05:00',2.74),('325','2013-07-17','17:10:00',2.61),('325','2013-07-17','17:15:00',2.59),('325','2013-07-17','17:20:00',2.51),('325','2013-07-17','17:25:00',2.42),('325','2013-07-17','17:30:00',2.31),('325','2013-07-17','17:35:00',2.24),('325','2013-07-17','17:40:00',2.1),('325','2013-07-17','17:45:00',2.05),('325','2013-07-17','17:50:00',1.98),('325','2013-07-17','17:55:00',1.84),('325','2013-07-17','18:00:00',1.72),('325','2013-07-17','18:05:00',1.68),('325','2013-07-17','18:10:00',1.59),('325','2013-07-17','18:15:00',1.51),('325','2013-07-17','18:20:00',1.4),('325','2013-07-17','18:25:00',1.3),('325','2013-07-17','18:30:00',1.14),('325','2013-07-16','08:30:00',1.08),('325','2013-07-16','08:35:00',1.15),('325','2013-07-16','08:40:00',1.19),('325','2013-07-16','08:45:00',1.25),('325','2013-07-16','08:50:00',1.31),('325','2013-07-16','08:55:00',1.34),('325','2013-07-16','09:00:00',1.34),('325','2013-07-16','09:05:00',1.35),('325','2013-07-16','09:10:00',1.4),('325','2013-07-16','09:15:00',1.43),('325','2013-07-16','09:20:00',1.46),('325','2013-07-16','09:25:00',1.49),('325','2013-07-16','09:30:00',1.52),('325','2013-07-16','09:35:00',1.58),('325','2013-07-16','09:40:00',1.62),('325','2013-07-16','09:45:00',2.48),('325','2013-07-16','09:50:00',2.61),('325','2013-07-16','09:55:00',2.73),('325','2013-07-16','10:00:00',2.79),('325','2013-07-16','10:05:00',2.85),('325','2013-07-16','10:10:00',2.93),('325','2013-07-16','10:15:00',3.02),('325','2013-07-16','10:20:00',3.05),('325','2013-07-16','10:25:00',3.05),('325','2013-07-16','10:30:00',3.07),('325','2013-07-16','10:35:00',3.12),('325','2013-07-16','10:40:00',3.22),('325','2013-07-16','10:45:00',3.35),('325','2013-07-16','10:50:00',3.38),('325','2013-07-16','10:55:00',3.4),('325','2013-07-16','11:00:00',3.47),('325','2013-07-16','11:05:00',3.54),('325','2013-07-16','11:10:00',3.62),('325','2013-07-16','11:15:00',3.69),('325','2013-07-16','11:20:00',3.81),('325','2013-07-16','11:25:00',3.87),('325','2013-07-16','11:30:00',3.85),('325','2013-07-16','11:35:00',3.82),('325','2013-07-16','11:40:00',3.79),('325','2013-07-16','11:45:00',3.82),('325','2013-07-16','11:50:00',3.91),('325','2013-07-16','11:55:00',3.98),('325','2013-07-16','12:00:00',4.02),('325','2013-07-16','12:05:00',4.11),('325','2013-07-16','12:10:00',4.22),('325','2013-07-16','12:15:00',4.31),('325','2013-07-16','12:20:00',4.29),('325','2013-07-16','12:25:00',4.22),('325','2013-07-16','12:30:00',4.19),('325','2013-07-16','12:35:00',4.14),('325','2013-07-16','12:40:00',4.12),('325','2013-07-16','12:45:00',4.1),('325','2013-07-16','12:50:00',4.09),('325','2013-07-16','12:55:00',4.18),('325','2013-07-16','13:00:00',4.31),('325','2013-07-16','13:05:00',4.37),('325','2013-07-16','13:10:00',4.36),('325','2013-07-16','13:15:00',4.37),('325','2013-07-16','13:20:00',4.38),('325','2013-07-16','13:25:00',4.39),('325','2013-07-16','13:30:00',4.41),('325','2013-07-16','13:35:00',4.35),('325','2013-07-16','13:40:00',4.4),('325','2013-07-16','13:45:00',4.45),('325','2013-07-16','13:50:00',4.56),('325','2013-07-16','13:55:00',3.89),('325','2013-07-16','14:00:00',4.25),('325','2013-07-16','14:05:00',4.19),('325','2013-07-16','14:10:00',1.63),('325','2013-07-16','14:15:00',3.57),('325','2013-07-16','14:20:00',1.42),('325','2013-07-16','14:25:00',4.17),('325','2013-07-16','14:30:00',4.35),('325','2013-07-16','14:35:00',4.28),('325','2013-07-16','14:40:00',4.23),('325','2013-07-16','14:45:00',4.18),('325','2013-07-16','14:50:00',4.17),('325','2013-07-16','14:55:00',4.18),('325','2013-07-16','15:00:00',4.12),('325','2013-07-16','15:05:00',4.05),('325','2013-07-16','15:10:00',4.02),('325','2013-07-16','15:15:00',3.96),('325','2013-07-16','15:20:00',3.91),('325','2013-07-16','15:25:00',3.9),('325','2013-07-16','15:30:00',3.89),('325','2013-07-16','15:35:00',2.82),('325','2013-07-16','15:40:00',3.72),('325','2013-07-16','15:45:00',2.63),('325','2013-07-16','15:50:00',3.62),('325','2013-07-16','15:55:00',3.6),('325','2013-07-16','16:00:00',3.31),('325','2013-07-16','16:05:00',2.82),('325','2013-07-16','16:10:00',3.02),('325','2013-07-16','16:15:00',2.05),('325','2013-07-16','16:20:00',1.5),('325','2013-07-16','16:25:00',1.53),('325','2013-07-16','16:30:00',1.11),('325','2013-07-16','16:45:00',1.05),('325','2013-07-16','16:50:00',1.63),('325','2013-07-16','16:55:00',1.9),('325','2013-07-16','17:00:00',2.78),('325','2013-07-16','17:05:00',3.23),('325','2013-07-16','17:10:00',2.96),('325','2013-07-16','17:15:00',2.61),('325','2013-07-16','17:20:00',1.6),('325','2013-07-16','17:25:00',2.32),('325','2013-07-16','17:30:00',2),('325','2013-07-16','17:35:00',2),('325','2013-07-16','17:40:00',2.29),('325','2013-07-16','17:45:00',2.34),('325','2013-07-16','17:50:00',1.83),('325','2013-07-16','17:55:00',1.23),('325','2013-07-16','18:05:00',1.46),('325','2013-07-16','18:10:00',1.24),('325','2013-07-16','18:15:00',1.47),('325','2013-07-16','18:20:00',1.34),('325','2013-07-16','18:25:00',1.28),('325','2013-07-16','18:30:00',1.12),('325','2013-07-15','08:25:00',1.04),('325','2013-07-15','08:30:00',1.09),('325','2013-07-15','08:35:00',1.16),('325','2013-07-15','08:40:00',1.21),('325','2013-07-15','08:45:00',1.28),('325','2013-07-15','08:50:00',1.33),('325','2013-07-15','08:55:00',1.35),('325','2013-07-15','09:00:00',1.35),('325','2013-07-15','09:05:00',1.36),('325','2013-07-15','09:10:00',1.39),('325','2013-07-15','09:15:00',1.42),('325','2013-07-15','09:20:00',1.46),('325','2013-07-15','09:25:00',1.49),('325','2013-07-15','09:30:00',1.51),('325','2013-07-15','09:35:00',1.56),('325','2013-07-15','09:40:00',1.68),('325','2013-07-15','09:45:00',2.57),('325','2013-07-15','09:50:00',2.65),('325','2013-07-15','09:55:00',2.78),('325','2013-07-15','10:00:00',2.83),('325','2013-07-15','10:05:00',2.89),('325','2013-07-15','10:10:00',2.98),('325','2013-07-15','10:15:00',3.06),('325','2013-07-15','10:20:00',3.08),('325','2013-07-15','10:25:00',3.06),('325','2013-07-15','10:30:00',3.05),('325','2013-07-15','10:35:00',3.12),('325','2013-07-15','10:40:00',3.18),('325','2013-07-15','10:45:00',3.31),('325','2013-07-15','10:50:00',3.37),('325','2013-07-15','10:55:00',3.39),('325','2013-07-15','11:00:00',3.48),('325','2013-07-15','11:05:00',3.55),('325','2013-07-15','11:10:00',3.6),('325','2013-07-15','11:15:00',3.67),('325','2013-07-15','11:20:00',3.77),('325','2013-07-15','11:25:00',3.86),('325','2013-07-15','11:30:00',3.83),('325','2013-07-15','11:35:00',3.8),('325','2013-07-15','11:40:00',3.79),('325','2013-07-15','11:45:00',3.83),('325','2013-07-15','11:50:00',3.86),('325','2013-07-15','11:55:00',3.9),('325','2013-07-15','12:00:00',4.03),('325','2013-07-15','12:05:00',4.1),('325','2013-07-15','12:10:00',4.15),('325','2013-07-15','12:15:00',4.25),('325','2013-07-15','12:20:00',4.3),('325','2013-07-15','12:25:00',4.25),('325','2013-07-15','12:30:00',4.18),('325','2013-07-15','12:35:00',4.14),('325','2013-07-15','12:40:00',4.07),('325','2013-07-15','12:45:00',4.03),('325','2013-07-15','12:50:00',4.02),('325','2013-07-15','12:55:00',4.1),('325','2013-07-15','13:00:00',4.36),('325','2013-07-15','13:05:00',4.38),('325','2013-07-15','13:10:00',2.34),('325','2013-07-15','13:15:00',4.5),('325','2013-07-15','13:20:00',4.43),('325','2013-07-15','13:25:00',4.58),('325','2013-07-15','13:30:00',4.66),('325','2013-07-15','13:35:00',4.68),('325','2013-07-15','13:40:00',3.23),('325','2013-07-15','13:45:00',1.73),('325','2013-07-15','13:50:00',2.52),('325','2013-07-15','13:55:00',3.44),('325','2013-07-15','14:00:00',4.6),('325','2013-07-15','14:05:00',4.57),('325','2013-07-15','14:10:00',3.38),('325','2013-07-15','14:15:00',1.03),('325','2013-07-15','14:20:00',1.87),('325','2013-07-15','14:25:00',4.64),('325','2013-07-15','14:30:00',4.48),('325','2013-07-15','14:35:00',4.48),('325','2013-07-15','14:40:00',4.21),('325','2013-07-15','14:45:00',4.33),('325','2013-07-15','14:50:00',4.3),('325','2013-07-15','14:55:00',4.3),('325','2013-07-15','15:00:00',4.24),('325','2013-07-15','15:05:00',4.14),('325','2013-07-15','15:10:00',4.09),('325','2013-07-15','15:15:00',4.03),('325','2013-07-15','15:20:00',3.79),('325','2013-07-15','15:25:00',1.01),('325','2013-07-15','15:30:00',4.05),('325','2013-07-15','15:35:00',4.04),('325','2013-07-15','15:40:00',3.97),('325','2013-07-15','15:45:00',3.78),('325','2013-07-15','15:50:00',3.82),('325','2013-07-15','15:55:00',3.75),('325','2013-07-15','16:00:00',3.63),('325','2013-07-15','16:05:00',3.6),('325','2013-07-15','16:10:00',3.54),('325','2013-07-15','16:15:00',3.48),('325','2013-07-15','16:20:00',3.36),('325','2013-07-15','16:25:00',3.32),('325','2013-07-15','16:30:00',3.27),('325','2013-07-15','16:35:00',3.18),('325','2013-07-15','16:40:00',3.12),('325','2013-07-15','16:45:00',3.05),('325','2013-07-15','16:50:00',2.98),('325','2013-07-15','16:55:00',2.91),('325','2013-07-15','17:00:00',2.83),('325','2013-07-15','17:05:00',2.73),('325','2013-07-15','17:10:00',2.58),('325','2013-07-15','17:15:00',2.56),('325','2013-07-15','17:20:00',2.47),('325','2013-07-15','17:25:00',2.41),('325','2013-07-15','17:30:00',2.33),('325','2013-07-15','17:35:00',2.21),('325','2013-07-15','17:40:00',2.12),('325','2013-07-15','17:45:00',2.03),('325','2013-07-15','17:50:00',1.92),('325','2013-07-15','17:55:00',1.81),('325','2013-07-15','18:00:00',1.69),('325','2013-07-15','18:05:00',1.63),('325','2013-07-15','18:10:00',1.56),('325','2013-07-15','18:15:00',1.46),('325','2013-07-15','18:20:00',1.36),('325','2013-07-15','18:25:00',1.25),('325','2013-07-15','18:30:00',1.11),('325','2013-07-14','07:50:00',1.06),('325','2013-07-14','07:55:00',1.15),('325','2013-07-14','08:00:00',1.23),('325','2013-07-14','08:05:00',1.17),('325','2013-07-14','08:10:00',1.24),('325','2013-07-14','08:15:00',1.08),('325','2013-07-14','08:20:00',1.43),('325','2013-07-14','08:25:00',1.1),('325','2013-07-14','08:35:00',1.06),('325','2013-07-14','08:55:00',1.06),('325','2013-07-14','09:00:00',1.09),('325','2013-07-14','09:05:00',1.13),('325','2013-07-14','09:10:00',1.34),('325','2013-07-14','09:15:00',1.18),('325','2013-07-14','09:20:00',1.43),('325','2013-07-14','09:25:00',1.55),('325','2013-07-14','09:30:00',1.83),('325','2013-07-14','09:35:00',1.93),('325','2013-07-14','09:40:00',1.72),('325','2013-07-14','09:45:00',1.69),('325','2013-07-14','09:50:00',1.63),('325','2013-07-14','09:55:00',1.64),('325','2013-07-14','10:00:00',1.64),('325','2013-07-14','10:05:00',1.81),('325','2013-07-14','10:10:00',1.76),('325','2013-07-14','10:15:00',1.74),('325','2013-07-14','10:20:00',2.24),('325','2013-07-14','10:25:00',2.95),('325','2013-07-14','10:30:00',2.99),('325','2013-07-14','10:35:00',3.41),('325','2013-07-14','10:40:00',2.96),('325','2013-07-14','10:45:00',2.96),('325','2013-07-14','10:50:00',3.71),('325','2013-07-14','10:55:00',3.56),('325','2013-07-14','11:00:00',3.01),('325','2013-07-14','11:05:00',1.3),('325','2013-07-14','11:10:00',1.89),('325','2013-07-14','11:15:00',2.02),('325','2013-07-14','11:20:00',2.53),('325','2013-07-14','11:25:00',1.59),('325','2013-07-14','11:30:00',1.47),('325','2013-07-14','11:35:00',1.73),('325','2013-07-14','11:40:00',1.56),('325','2013-07-14','11:45:00',1.5),('325','2013-07-14','11:50:00',2.11),('325','2013-07-14','11:55:00',4.8),('325','2013-07-14','12:00:00',4.39),('325','2013-07-14','12:05:00',4.26),('325','2013-07-14','12:10:00',4.77),('325','2013-07-14','12:15:00',4.48),('325','2013-07-14','12:20:00',4.63),('325','2013-07-14','12:25:00',4.54),('325','2013-07-14','12:30:00',4.41),('325','2013-07-14','12:35:00',4.72),('325','2013-07-14','12:40:00',3.91),('325','2013-07-14','12:45:00',3.85),('325','2013-07-14','12:50:00',4.16),('325','2013-07-14','12:55:00',4.68),('325','2013-07-14','13:00:00',2.29),('325','2013-07-14','13:05:00',4.44),('325','2013-07-14','13:10:00',4.92),('325','2013-07-14','13:15:00',4.69),('325','2013-07-14','13:20:00',4.42),('325','2013-07-14','13:25:00',4.58),('325','2013-07-14','13:30:00',4.53),('325','2013-07-14','13:35:00',4.53),('325','2013-07-14','13:40:00',4.55),('325','2013-07-14','13:45:00',4.54),('325','2013-07-14','13:50:00',4.56),('325','2013-07-14','13:55:00',4.5),('325','2013-07-14','14:00:00',4.46),('325','2013-07-14','14:05:00',4.43),('325','2013-07-14','14:10:00',4.38),('325','2013-07-14','14:15:00',4.37),('325','2013-07-14','14:20:00',4.42),('325','2013-07-14','14:25:00',4.41),('325','2013-07-14','14:30:00',4.39),('325','2013-07-14','14:35:00',4.35),('325','2013-07-14','14:40:00',4.34),('325','2013-07-14','14:45:00',4.33),('325','2013-07-14','14:50:00',4.24),('325','2013-07-14','14:55:00',4.19),('325','2013-07-14','15:00:00',4.16),('325','2013-07-14','15:05:00',4.16),('325','2013-07-14','15:10:00',4.13),('325','2013-07-14','15:15:00',4.08),('325','2013-07-14','15:20:00',4),('325','2013-07-14','15:25:00',3.99),('325','2013-07-14','15:30:00',3.95),('325','2013-07-14','15:35:00',3.92),('325','2013-07-14','15:40:00',3.83),('325','2013-07-14','15:45:00',3.79),('325','2013-07-14','15:50:00',3.7),('325','2013-07-14','15:55:00',3.71),('325','2013-07-14','16:00:00',3.57),('325','2013-07-14','16:05:00',3.56),('325','2013-07-14','16:10:00',3.54),('325','2013-07-14','16:15:00',3.53),('325','2013-07-14','16:20:00',3.56),('325','2013-07-14','16:25:00',2.54),('325','2013-07-14','16:30:00',3.39),('325','2013-07-14','16:35:00',3.45),('325','2013-07-14','16:40:00',3.17),('325','2013-07-14','16:45:00',2.77),('325','2013-07-14','16:50:00',3.02),('325','2013-07-14','16:55:00',2.61),('325','2013-07-14','17:00:00',3.06),('325','2013-07-14','17:05:00',1.43),('325','2013-07-14','17:10:00',2.68),('325','2013-07-14','17:15:00',2.2),('325','2013-07-14','17:20:00',1.33),('325','2013-07-14','17:25:00',2.21),('325','2013-07-14','17:30:00',2.73),('325','2013-07-14','17:35:00',2.19),('325','2013-07-14','17:40:00',1.87),('325','2013-07-14','17:45:00',1.61),('325','2013-07-14','17:50:00',1.92),('325','2013-07-14','17:55:00',1.76),('325','2013-07-14','18:00:00',1.16),('325','2013-07-14','18:05:00',1.45),('325','2013-07-13','08:30:00',1.03),('325','2013-07-13','08:35:00',1.11),('325','2013-07-13','08:40:00',1.19),('325','2013-07-13','08:45:00',1.29),('325','2013-07-13','08:50:00',1.29),('325','2013-07-13','08:55:00',1.34),('325','2013-07-13','09:00:00',1.35),('325','2013-07-13','09:05:00',1.38),('325','2013-07-13','09:10:00',1.41),('325','2013-07-13','09:15:00',1.45),('325','2013-07-13','09:20:00',1.48),('325','2013-07-13','09:25:00',1.49),('325','2013-07-13','09:30:00',1.5),('325','2013-07-13','09:35:00',1.57),('325','2013-07-13','09:40:00',1.87),('325','2013-07-13','09:45:00',2.48),('325','2013-07-13','09:50:00',2.58),('325','2013-07-13','09:55:00',2.66),('325','2013-07-13','10:00:00',2.76),('325','2013-07-13','10:05:00',2.82),('325','2013-07-13','10:10:00',2.92),('325','2013-07-13','10:15:00',3.03),('325','2013-07-13','10:20:00',3.05),('325','2013-07-13','10:25:00',2.1),('325','2013-07-13','10:30:00',3.31),('325','2013-07-13','10:35:00',3.38),('325','2013-07-13','10:40:00',3.41),('325','2013-07-13','10:45:00',3),('325','2013-07-13','10:50:00',3.67),('325','2013-07-13','10:55:00',3.84),('325','2013-07-13','11:00:00',3.4),('325','2013-07-13','11:05:00',2.85),('325','2013-07-13','11:10:00',4.04),('325','2013-07-13','11:15:00',2.96),('325','2013-07-13','11:20:00',1.48),('325','2013-07-13','11:25:00',2.67),('325','2013-07-13','11:30:00',4.44),('325','2013-07-13','11:35:00',3.84),('325','2013-07-13','11:40:00',1.04),('325','2013-07-13','11:45:00',2.08),('325','2013-07-13','11:50:00',4.65),('325','2013-07-13','11:55:00',2.09),('325','2013-07-13','12:00:00',3.4),('325','2013-07-13','12:05:00',4.65),('325','2013-07-13','12:10:00',4.61),('325','2013-07-13','12:15:00',4.6),('325','2013-07-13','12:20:00',4.44),('325','2013-07-13','12:25:00',3.5),('325','2013-07-13','12:30:00',2.96),('325','2013-07-13','12:35:00',4.13),('325','2013-07-13','12:40:00',3.52),('325','2013-07-13','12:45:00',3.09),('325','2013-07-13','12:50:00',2.55),('325','2013-07-13','12:55:00',4.48),('325','2013-07-13','13:00:00',4.75),('325','2013-07-13','13:05:00',4.07),('325','2013-07-13','13:10:00',4.13),('325','2013-07-13','13:15:00',4.51),('325','2013-07-13','13:20:00',4.57),('325','2013-07-13','13:25:00',4.49),('325','2013-07-13','13:30:00',4.52),('325','2013-07-13','13:35:00',4.56),('325','2013-07-13','13:40:00',4.5),('325','2013-07-13','13:45:00',4.5),('325','2013-07-13','13:50:00',4.47),('325','2013-07-13','13:55:00',4.37),('325','2013-07-13','14:00:00',4.31),('325','2013-07-13','14:05:00',4.28),('325','2013-07-13','14:10:00',4.21),('325','2013-07-13','14:15:00',4.13),('325','2013-07-13','14:20:00',4.12),('325','2013-07-13','14:25:00',4.08),('325','2013-07-13','14:30:00',4.03),('325','2013-07-13','14:35:00',4.26),('325','2013-07-13','14:40:00',4.3),('325','2013-07-13','14:45:00',4.31),('325','2013-07-13','14:50:00',4.3),('325','2013-07-13','14:55:00',4.25),('325','2013-07-13','15:00:00',4.25),('325','2013-07-13','15:05:00',4.26),('325','2013-07-13','15:10:00',4.23),('325','2013-07-13','15:15:00',4.22),('325','2013-07-13','15:20:00',3.99),('325','2013-07-13','15:25:00',4.15),('325','2013-07-13','15:30:00',4.02),('325','2013-07-13','15:35:00',4.07),('325','2013-07-13','15:40:00',4),('325','2013-07-13','15:45:00',3.92),('325','2013-07-13','15:50:00',3.87),('325','2013-07-13','15:55:00',3.83),('325','2013-07-13','16:00:00',3.77),('325','2013-07-13','16:05:00',3.72),('325','2013-07-13','16:10:00',3.65),('325','2013-07-13','16:15:00',3.6),('325','2013-07-13','16:20:00',3.56),('325','2013-07-13','16:25:00',3.53),('325','2013-07-13','16:30:00',3.45),('325','2013-07-13','16:35:00',3.4),('325','2013-07-13','16:40:00',3.3),('325','2013-07-13','16:45:00',3.2),('325','2013-07-13','16:50:00',3.13),('325','2013-07-13','16:55:00',3.06),('325','2013-07-13','17:00:00',2.95),('325','2013-07-13','17:05:00',2.79),('325','2013-07-13','17:10:00',2.74),('325','2013-07-13','17:15:00',2.69),('325','2013-07-13','17:20:00',2.51),('325','2013-07-13','17:25:00',2.55),('325','2013-07-13','17:30:00',2.38),('325','2013-07-13','17:35:00',2.29),('325','2013-07-13','17:40:00',2.25),('325','2013-07-13','17:45:00',2.18),('325','2013-07-13','17:50:00',2.04),('325','2013-07-13','17:55:00',2.02),('325','2013-07-13','18:00:00',1.8),('325','2013-07-13','18:05:00',1.68),('325','2013-07-13','18:10:00',1.68),('325','2013-07-13','18:15:00',1.59),('325','2013-07-13','18:20:00',1.48),('325','2013-07-13','18:25:00',1.33),('325','2013-07-13','18:30:00',1.16),('325','2013-07-13','18:35:00',1.03),('325','2013-07-12','08:10:00',1.03),('325','2013-07-12','08:15:00',1.03),('325','2013-07-12','08:45:00',1.04),('325','2013-07-12','09:10:00',1.34),('325','2013-07-12','09:15:00',1.58),('325','2013-07-12','09:20:00',2.23),('325','2013-07-12','09:25:00',2.02),('325','2013-07-12','09:30:00',1.41),('325','2013-07-12','09:35:00',1.96),('325','2013-07-12','09:40:00',2.06),('325','2013-07-12','09:45:00',2.57),('325','2013-07-12','09:50:00',2.68),('325','2013-07-12','09:55:00',2.73),('325','2013-07-12','10:00:00',2.83),('325','2013-07-12','10:05:00',3.04),('325','2013-07-12','10:10:00',2.97),('325','2013-07-12','10:15:00',3.21),('325','2013-07-12','10:20:00',3.15),('325','2013-07-12','10:25:00',1.67),('325','2013-07-12','10:40:00',1.3),('325','2013-07-12','10:45:00',1.83),('325','2013-07-12','10:50:00',3.51),('325','2013-07-12','10:55:00',3.32),('325','2013-07-12','11:00:00',1.39),('325','2013-07-12','11:05:00',1.2),('325','2013-07-12','11:10:00',1.39),('325','2013-07-12','11:15:00',4.24),('325','2013-07-12','11:20:00',4.38),('325','2013-07-12','11:25:00',2.36),('325','2013-07-12','11:30:00',3.23),('325','2013-07-12','11:35:00',3.4),('325','2013-07-12','11:40:00',4.45),('325','2013-07-12','11:45:00',1.59),('325','2013-07-12','11:50:00',3.67),('325','2013-07-12','11:55:00',4.34),('325','2013-07-12','12:00:00',4.66),('325','2013-07-12','12:05:00',3.84),('325','2013-07-12','12:10:00',4.37),('325','2013-07-12','12:15:00',3.44),('325','2013-07-12','12:20:00',3.51),('325','2013-07-12','12:25:00',4.71),('325','2013-07-12','12:30:00',4.84),('325','2013-07-12','12:35:00',3.15),('325','2013-07-12','12:40:00',4.71),('325','2013-07-12','12:45:00',4.23),('325','2013-07-12','12:50:00',2.53),('325','2013-07-12','12:55:00',4.32),('325','2013-07-12','13:00:00',4.52),('325','2013-07-12','13:05:00',4.67),('325','2013-07-12','13:10:00',4.7),('325','2013-07-12','13:15:00',4.62),('325','2013-07-12','13:20:00',4.59),('325','2013-07-12','13:25:00',4.64),('325','2013-07-12','13:30:00',4.57),('325','2013-07-12','13:35:00',4.61),('325','2013-07-12','13:40:00',4.01),('325','2013-07-12','13:45:00',3.94),('325','2013-07-12','13:50:00',4.69),('325','2013-07-12','13:55:00',4.45),('325','2013-07-12','14:00:00',3.98),('325','2013-07-12','14:05:00',2.8),('325','2013-07-12','14:10:00',3.64),('325','2013-07-12','14:15:00',4.77),('325','2013-07-12','14:20:00',4.47),('325','2013-07-12','14:25:00',4.59),('325','2013-07-12','14:30:00',4.54),('325','2013-07-12','14:35:00',4.33),('325','2013-07-12','14:40:00',4.23),('325','2013-07-12','14:45:00',4.29),('325','2013-07-12','14:50:00',4.23),('325','2013-07-12','14:55:00',4.19),('325','2013-07-12','15:00:00',4.2),('325','2013-07-12','15:05:00',4.19),('325','2013-07-12','15:10:00',3.86),('325','2013-07-12','15:15:00',4.06),('325','2013-07-12','15:20:00',4.06),('325','2013-07-12','15:25:00',4.03),('325','2013-07-12','15:30:00',3.96),('325','2013-07-12','15:35:00',3.9),('325','2013-07-12','15:40:00',3.8),('325','2013-07-12','15:45:00',3.8),('325','2013-07-12','15:50:00',3.74),('325','2013-07-12','15:55:00',3.71),('325','2013-07-12','16:00:00',3.64),('325','2013-07-12','16:05:00',3.57),('325','2013-07-12','16:10:00',3.52),('325','2013-07-12','16:15:00',3.47),('325','2013-07-12','16:20:00',3.39),('325','2013-07-12','16:25:00',3.35),('325','2013-07-12','16:30:00',3.3),('325','2013-07-12','16:35:00',3.25),('325','2013-07-12','16:40:00',3.2),('325','2013-07-12','16:45:00',3.14),('325','2013-07-12','16:50:00',3.04),('325','2013-07-12','16:55:00',2.96),('325','2013-07-12','17:00:00',2.84),('325','2013-07-12','17:05:00',2.74),('325','2013-07-12','17:10:00',2.6),('325','2013-07-12','17:15:00',2.56),('325','2013-07-12','17:20:00',2.46),('325','2013-07-12','17:25:00',2.39),('325','2013-07-12','17:30:00',2.31),('325','2013-07-12','17:35:00',2.24),('325','2013-07-12','17:40:00',2.14),('325','2013-07-12','17:45:00',2.05),('325','2013-07-12','17:50:00',1.98),('325','2013-07-12','17:55:00',1.86),('325','2013-07-12','18:00:00',1.76),('325','2013-07-12','18:05:00',1.68),('325','2013-07-12','18:10:00',1.6),('325','2013-07-12','18:15:00',1.51),('325','2013-07-12','18:20:00',1.32),('325','2013-07-12','18:25:00',1.25),('325','2013-07-12','18:30:00',1.12),('325','2013-07-12','18:35:00',1.01),('325','2013-07-11','08:30:00',1.03),('325','2013-07-11','08:35:00',1.12),('325','2013-07-11','08:40:00',1.19),('325','2013-07-11','08:45:00',1.28),('325','2013-07-11','08:50:00',1.29),('325','2013-07-11','08:55:00',1.34),('325','2013-07-11','09:00:00',1.36),('325','2013-07-11','09:05:00',1.36),('325','2013-07-11','09:10:00',1.41),('325','2013-07-11','09:15:00',1.58),('325','2013-07-11','09:20:00',1.56),('325','2013-07-11','09:25:00',1.29),('325','2013-07-11','09:30:00',2.02),('325','2013-07-11','09:35:00',2.35),('325','2013-07-11','09:40:00',2.67),('325','2013-07-11','09:45:00',2.58),('325','2013-07-11','09:50:00',1.92),('325','2013-07-11','09:55:00',1.5),('325','2013-07-11','10:00:00',1.49),('325','2013-07-11','10:05:00',2.21),('325','2013-07-11','10:10:00',3.31),('325','2013-07-11','10:15:00',3.33),('325','2013-07-11','10:20:00',3.63),('325','2013-07-11','10:25:00',3.34),('325','2013-07-11','10:30:00',2.24),('325','2013-07-11','10:35:00',1.26),('325','2013-07-11','10:40:00',2.58),('325','2013-07-11','10:45:00',3.73),('325','2013-07-11','10:50:00',3.73),('325','2013-07-11','10:55:00',3.94),('325','2013-07-11','11:00:00',3.94),('325','2013-07-11','11:05:00',2.7),('325','2013-07-11','11:10:00',3.88),('325','2013-07-11','11:15:00',3.61),('325','2013-07-11','11:20:00',3.3),('325','2013-07-11','11:25:00',2.18),('325','2013-07-11','11:30:00',2.34),('325','2013-07-11','11:35:00',4.23),('325','2013-07-11','11:40:00',4.5),('325','2013-07-11','11:45:00',2.21),('325','2013-07-11','11:50:00',4.64),('325','2013-07-11','11:55:00',4.61),('325','2013-07-11','12:00:00',2.02),('325','2013-07-11','12:05:00',2.72),('325','2013-07-11','12:10:00',1.72),('325','2013-07-11','12:15:00',4.76),('325','2013-07-11','12:20:00',4.72),('325','2013-07-11','12:25:00',4.78),('325','2013-07-11','12:30:00',4.66),('325','2013-07-11','12:35:00',4.59),('325','2013-07-11','12:40:00',4.65),('325','2013-07-11','12:45:00',4.46),('325','2013-07-11','12:50:00',3.25),('325','2013-07-11','12:55:00',3.78),('325','2013-07-11','13:00:00',4.71),('325','2013-07-11','13:05:00',4.76),('325','2013-07-11','13:10:00',4.14),('325','2013-07-11','13:15:00',4.63),('325','2013-07-11','13:20:00',4.48),('325','2013-07-11','13:25:00',4.3),('325','2013-07-11','13:30:00',4.26),('325','2013-07-11','13:35:00',3.1),('325','2013-07-11','13:40:00',3.74),('325','2013-07-11','13:45:00',4.22),('325','2013-07-11','13:50:00',3.54),('325','2013-07-11','13:55:00',4.29),('325','2013-07-11','14:00:00',4.52),('325','2013-07-11','14:05:00',4.54),('325','2013-07-11','14:10:00',4.3),('325','2013-07-11','14:15:00',4.18),('325','2013-07-11','14:20:00',4.51),('325','2013-07-11','14:25:00',4.47),('325','2013-07-11','14:30:00',4.23),('325','2013-07-11','14:35:00',4.45),('325','2013-07-11','14:40:00',4.29),('325','2013-07-11','14:45:00',4.46),('325','2013-07-11','14:50:00',4.44),('325','2013-07-11','14:55:00',4.5),('325','2013-07-11','15:00:00',3.82),('325','2013-07-11','15:05:00',4),('325','2013-07-11','15:10:00',3.65),('325','2013-07-11','15:15:00',2.42),('325','2013-07-11','15:20:00',3.1),('325','2013-07-11','15:25:00',4.34),('325','2013-07-11','15:30:00',4.11),('325','2013-07-11','15:35:00',3.01),('325','2013-07-11','15:40:00',4.01),('325','2013-07-11','15:45:00',3.93),('325','2013-07-11','15:50:00',2.24),('325','2013-07-11','15:55:00',2.82),('325','2013-07-11','16:00:00',2.92),('325','2013-07-11','16:05:00',2.97),('325','2013-07-11','16:10:00',1.93),('325','2013-07-11','16:15:00',1.76),('325','2013-07-11','16:20:00',3.06),('325','2013-07-11','16:25:00',2.92),('325','2013-07-11','16:30:00',3.39),('325','2013-07-11','16:35:00',1.34),('325','2013-07-11','16:40:00',3.33),('325','2013-07-11','16:45:00',3.53),('325','2013-07-11','16:50:00',2.84),('325','2013-07-11','16:55:00',2.75),('325','2013-07-11','17:00:00',1.85),('325','2013-07-11','17:05:00',2.65),('325','2013-07-11','17:10:00',2.23),('325','2013-07-11','17:15:00',2.23),('325','2013-07-11','17:20:00',2.06),('325','2013-07-11','17:25:00',2.64),('325','2013-07-11','17:30:00',2.6),('325','2013-07-11','17:35:00',2.46),('325','2013-07-11','17:40:00',2.25),('325','2013-07-11','17:45:00',1.77),('325','2013-07-11','17:50:00',2.06),('325','2013-07-11','17:55:00',1.91),('325','2013-07-11','18:00:00',1.74),('325','2013-07-11','18:05:00',1.55),('325','2013-07-11','18:10:00',1.74),('325','2013-07-11','18:15:00',1.67),('325','2013-07-11','18:20:00',1.29),('325','2013-07-11','18:25:00',1.24),('325','2013-07-11','18:30:00',1.15),('325','2013-07-10','07:40:00',1.02),('325','2013-07-10','07:45:00',1.11),('325','2013-07-10','07:50:00',1.16),('325','2013-07-10','07:55:00',1.22),('325','2013-07-10','08:00:00',1.14),('325','2013-07-10','08:05:00',1.14),('325','2013-07-10','08:10:00',1.31),('325','2013-07-10','08:15:00',1.33),('325','2013-07-10','08:20:00',1.38),('325','2013-07-10','08:25:00',1.33),('325','2013-07-10','08:30:00',1.32),('325','2013-07-10','08:35:00',1.47),('325','2013-07-10','08:40:00',1.51),('325','2013-07-10','08:45:00',1.48),('325','2013-07-10','08:50:00',1.44),('325','2013-07-10','08:55:00',1.37),('325','2013-07-10','09:00:00',1.37),('325','2013-07-10','09:05:00',1.49),('325','2013-07-10','09:10:00',1.56),('325','2013-07-10','09:15:00',1.88),('325','2013-07-10','09:20:00',1.84),('325','2013-07-10','09:25:00',1.48),('325','2013-07-10','09:30:00',2.2),('325','2013-07-10','09:35:00',2.44),('325','2013-07-10','09:40:00',2.5),('325','2013-07-10','09:45:00',2.58),('325','2013-07-10','09:50:00',2.61),('325','2013-07-10','09:55:00',2.1),('325','2013-07-10','10:00:00',2.78),('325','2013-07-10','10:05:00',2.84),('325','2013-07-10','10:10:00',2.91),('325','2013-07-10','10:15:00',3.02),('325','2013-07-10','10:20:00',3.07),('325','2013-07-10','10:25:00',3.08),('325','2013-07-10','10:30:00',3.07),('325','2013-07-10','10:35:00',3.13),('325','2013-07-10','10:40:00',3.2),('325','2013-07-10','10:45:00',3.33),('325','2013-07-10','10:50:00',3.39),('325','2013-07-10','10:55:00',3.38),('325','2013-07-10','11:00:00',3.44),('325','2013-07-10','11:05:00',3.51),('325','2013-07-10','11:10:00',3.54),('325','2013-07-10','11:15:00',3.64),('325','2013-07-10','11:20:00',3.75),('325','2013-07-10','11:25:00',3.81),('325','2013-07-10','11:30:00',3.76),('325','2013-07-10','11:35:00',3.79),('325','2013-07-10','11:40:00',3.81),('325','2013-07-10','11:45:00',3.82),('325','2013-07-10','11:50:00',3.85),('325','2013-07-10','11:55:00',3.92),('325','2013-07-10','12:00:00',3.97),('325','2013-07-10','12:05:00',4.09),('325','2013-07-10','12:10:00',4.17),('325','2013-07-10','12:15:00',4.23),('325','2013-07-10','12:20:00',4.23),('325','2013-07-10','12:25:00',4.26),('325','2013-07-10','12:30:00',4.2),('325','2013-07-10','12:35:00',4.2),('325','2013-07-10','12:40:00',4.16),('325','2013-07-10','12:45:00',4.13),('325','2013-07-10','12:50:00',4.26),('325','2013-07-10','12:55:00',4.44),('325','2013-07-10','13:00:00',4.46),('325','2013-07-10','13:05:00',4.51),('325','2013-07-10','13:10:00',4.49),('325','2013-07-10','13:15:00',4.47),('325','2013-07-10','13:20:00',4.46),('325','2013-07-10','13:25:00',4.51),('325','2013-07-10','13:30:00',4.5),('325','2013-07-10','13:35:00',4.5),('325','2013-07-10','13:40:00',4.52),('325','2013-07-10','13:45:00',4.52),('325','2013-07-10','13:50:00',4.43),('325','2013-07-10','13:55:00',4.38),('325','2013-07-10','14:00:00',4.33),('325','2013-07-10','14:05:00',4.31),('325','2013-07-10','14:10:00',4.26),('325','2013-07-10','14:15:00',4.2),('325','2013-07-10','14:20:00',4.17),('325','2013-07-10','14:25:00',4.31),('325','2013-07-10','14:30:00',4.36),('325','2013-07-10','14:35:00',4.35),('325','2013-07-10','14:40:00',4.35),('325','2013-07-10','14:45:00',4.31),('325','2013-07-10','14:50:00',4.29),('325','2013-07-10','14:55:00',4.29),('325','2013-07-10','15:00:00',4.27),('325','2013-07-10','15:05:00',4.24),('325','2013-07-10','15:10:00',4.19),('325','2013-07-10','15:15:00',4.14),('325','2013-07-10','15:20:00',4.1),('325','2013-07-10','15:25:00',4.07),('325','2013-07-10','15:30:00',4.05),('325','2013-07-10','15:35:00',4),('325','2013-07-10','15:40:00',3.07),('325','2013-07-10','15:45:00',3.77),('325','2013-07-10','15:50:00',3.72),('325','2013-07-10','15:55:00',3.72),('325','2013-07-10','16:00:00',3.68),('325','2013-07-10','16:05:00',3.63),('325','2013-07-10','16:10:00',3.58),('325','2013-07-10','16:15:00',3.53),('325','2013-07-10','16:20:00',3.49),('325','2013-07-10','16:25:00',3.4),('325','2013-07-10','16:30:00',3.35),('325','2013-07-10','16:35:00',3.24),('325','2013-07-10','16:40:00',3.18),('325','2013-07-10','16:45:00',3.13),('325','2013-07-10','16:50:00',3.08),('325','2013-07-10','16:55:00',3.03),('325','2013-07-10','17:00:00',3.05),('325','2013-07-10','17:05:00',2.37),('325','2013-07-10','17:10:00',2.19),('325','2013-07-10','17:15:00',1.53),('325','2013-07-10','17:20:00',1.7),('325','2013-07-10','17:35:00',1.48),('325','2013-07-10','17:40:00',1.45),('325','2013-07-10','17:45:00',1.94),('325','2013-07-10','17:50:00',2.06),('325','2013-07-10','17:55:00',1.89),('325','2013-07-10','18:00:00',1.88),('325','2013-07-10','18:05:00',1.71),('325','2013-07-10','18:20:00',1.19),('325','2014-05-02','08:15:00',1.79),('325','2014-05-02','08:20:00',1.6),('325','2014-05-02','08:45:00',1.32),('325','2014-05-02','08:50:00',1.24),('325','2014-05-02','09:15:00',1.3),('325','2014-05-02','09:20:00',1.55),('325','2014-05-02','09:25:00',1.77),('325','2014-05-02','09:30:00',1.93),('325','2014-05-02','09:35:00',1.92),('325','2014-05-02','09:40:00',1.8),('325','2014-05-02','09:45:00',1.67),('325','2014-05-02','09:50:00',1.58),('325','2014-05-02','09:55:00',1.57),('325','2014-05-02','10:00:00',1.92),('325','2014-05-02','10:05:00',2.14),('325','2014-05-02','10:10:00',1.71),('325','2014-05-02','10:15:00',1.6),('325','2014-05-02','10:20:00',1.51),('325','2014-05-02','10:25:00',1.31),('325','2014-05-02','10:40:00',1.1),('325','2014-05-02','10:45:00',1.4),('325','2014-05-02','10:50:00',1.09),('325','2014-05-02','12:30:00',1.09),('325','2014-05-02','12:35:00',1.17),('325','2014-05-02','12:40:00',1.24),('325','2014-05-02','12:45:00',1.7),('325','2014-05-02','12:50:00',1.99),('325','2014-05-02','12:55:00',1.44),('325','2014-05-02','13:00:00',1.68),('325','2014-05-02','13:05:00',1.91),('325','2014-05-02','13:10:00',1.9),('325','2014-05-02','13:15:00',2.71),('325','2014-05-02','13:20:00',3.57),('325','2014-05-02','13:25:00',3.99),('325','2014-05-02','13:30:00',3.38),('325','2014-05-02','13:35:00',3.45),('325','2014-05-02','13:40:00',2.83),('325','2014-05-02','13:45:00',2.17),('325','2014-05-02','13:50:00',1.91),('325','2014-05-02','13:55:00',1.41),('325','2014-05-02','14:00:00',1.48),('325','2014-05-02','14:05:00',2.84),('325','2014-05-02','14:30:00',1.16),('325','2014-05-02','14:35:00',1.84),('325','2014-05-02','14:40:00',3.24),('325','2014-05-02','14:45:00',1.64),('325','2014-05-02','14:50:00',1.51),('325','2014-05-02','14:55:00',2.17),('325','2014-05-02','15:00:00',2.43),('325','2014-05-02','15:05:00',2.24),('325','2014-05-02','15:10:00',4.86),('325','2014-05-02','15:15:00',3.41),('325','2014-05-02','15:20:00',3.07),('325','2014-05-02','15:25:00',1.56),('325','2014-05-02','15:30:00',1.41),('325','2014-05-02','15:35:00',2.69),('325','2014-05-02','15:40:00',3.56),('325','2014-05-02','15:45:00',1.25),('325','2014-05-02','16:00:00',1.68),('325','2014-05-02','16:05:00',1.81),('325','2014-05-02','16:10:00',1.08),('325','2014-05-02','16:15:00',1.25),('325','2014-05-02','16:20:00',2.06),('325','2014-05-02','17:15:00',1.01),('325','2014-05-02','17:20:00',1.06),('325','2014-05-02','17:25:00',1.25),('325','2014-04-05','09:15:00',1.04),('325','2014-04-05','09:20:00',1.5),('325','2014-04-05','09:25:00',1.71),('325','2014-04-05','09:30:00',2.75),('325','2014-04-05','09:35:00',2.84),('325','2014-04-05','09:40:00',2.82),('325','2014-04-05','09:45:00',2.57),('325','2014-04-05','09:50:00',1.7),('325','2014-04-05','09:55:00',1.5),('325','2014-04-05','10:00:00',1.9),('325','2014-04-05','10:05:00',1.91),('325','2014-04-05','10:10:00',2.08),('325','2014-04-05','10:15:00',1.69),('325','2014-04-05','10:20:00',2.12),('325','2014-04-05','10:25:00',3.04),('325','2014-04-05','10:30:00',2.63),('325','2014-04-05','10:35:00',2.82),('325','2014-04-05','10:40:00',2.8),('325','2014-04-05','10:45:00',3.49),('325','2014-04-05','10:50:00',2.93),('325','2014-04-05','10:55:00',2.91),('325','2014-04-05','11:00:00',3.45),('325','2014-04-05','11:05:00',3.63),('325','2014-04-05','11:10:00',3.88),('325','2014-04-05','11:15:00',4.17),('325','2014-04-05','11:20:00',4.49),('325','2014-04-05','11:25:00',3.79),('325','2014-04-05','11:30:00',2.98),('325','2014-04-05','11:35:00',2.34),('325','2014-04-05','11:40:00',2.76),('325','2014-04-05','11:45:00',3.93),('325','2014-04-05','11:50:00',4.25),('325','2014-04-05','11:55:00',3.93),('325','2014-04-05','12:00:00',4.52),('325','2014-04-05','12:05:00',3.53),('325','2014-04-05','12:10:00',3.34),('325','2014-04-05','12:15:00',3.75),('325','2014-04-05','12:20:00',3.09),('325','2014-04-05','12:25:00',4.06),('325','2014-04-05','12:30:00',3.37),('325','2014-04-05','12:35:00',2.5),('325','2014-04-05','12:40:00',2.96),('325','2014-04-05','12:45:00',4.26),('325','2014-04-05','12:50:00',4.48),('325','2014-04-05','12:55:00',4.91),('325','2014-04-05','13:00:00',3.85),('325','2014-04-05','13:05:00',3.11),('325','2014-04-05','13:10:00',2.42),('325','2014-04-05','13:15:00',2.36),('325','2014-04-05','13:20:00',2.76),('325','2014-04-05','13:25:00',4.89),('325','2014-04-05','13:30:00',4.28),('325','2014-04-05','13:35:00',4.37),('325','2014-04-05','13:40:00',3.91),('325','2014-04-05','13:45:00',4.75),('325','2014-04-05','13:50:00',5.08),('325','2014-04-05','13:55:00',4.15),('325','2014-04-05','14:00:00',3.71),('325','2014-04-05','14:05:00',5.28),('325','2014-04-05','14:10:00',3.69),('325','2014-04-05','14:25:00',1.06),('325','2014-04-05','14:30:00',1.51),('325','2014-04-05','14:35:00',1.11),('325','2014-04-05','14:55:00',4.6),('325','2014-04-05','15:00:00',4.62),('325','2014-04-05','15:05:00',4.54),('325','2014-04-05','15:10:00',3.6),('325','2014-04-05','15:15:00',2.41),('325','2014-04-05','15:20:00',3.78),('325','2014-04-05','15:25:00',3.1),('325','2014-04-05','15:30:00',1.88),('325','2014-04-05','15:35:00',1.53),('325','2014-04-05','15:40:00',1.99),('325','2014-04-05','15:45:00',2.42),('325','2014-04-05','15:50:00',2.88),('325','2014-04-05','15:55:00',1.43),('325','2014-04-05','16:00:00',1.26),('325','2014-04-05','16:05:00',1.29),('325','2014-04-05','16:10:00',1.25),('325','2014-04-05','16:15:00',1.71),('325','2014-04-05','16:20:00',4.32),('325','2014-04-05','16:25:00',3.78),('325','2014-04-05','16:30:00',2.24),('325','2014-04-05','16:35:00',3.11),('325','2014-04-05','16:40:00',1.63),('325','2014-04-05','16:45:00',2.26),('325','2014-04-05','16:50:00',1.6),('325','2014-04-05','16:55:00',2.81),('325','2014-04-05','17:00:00',1.79),('325','2014-04-05','17:05:00',2.24),('325','2014-04-05','17:10:00',1.86),('325','2014-04-05','17:20:00',1.35),('325','2014-04-05','17:25:00',1.28),('325','2014-04-05','17:30:00',1.39),('325','2014-04-05','17:35:00',1.16),('325','2013-07-09','08:25:00',1.04),('325','2013-07-09','08:30:00',1.11),('325','2013-07-09','08:35:00',1.16),('325','2013-07-09','08:40:00',1.22),('325','2013-07-09','08:45:00',1.27),('325','2013-07-09','08:50:00',1.31),('325','2013-07-09','08:55:00',1.34),('325','2013-07-09','09:00:00',1.37),('325','2013-07-09','09:05:00',1.41),('325','2013-07-09','09:10:00',1.45),('325','2013-07-09','09:15:00',1.5),('325','2013-07-09','09:20:00',1.54),('325','2013-07-09','09:25:00',1.6),('325','2013-07-09','09:30:00',1.65),('325','2013-07-09','09:35:00',1.66),('325','2013-07-09','09:40:00',2.23),('325','2013-07-09','09:45:00',2.6),('325','2013-07-09','09:50:00',2.69),('325','2013-07-09','09:55:00',2.76),('325','2013-07-09','10:00:00',2.66),('325','2013-07-09','10:05:00',2.66),('325','2013-07-09','10:10:00',2.9),('325','2013-07-09','10:15:00',2.99),('325','2013-07-09','10:20:00',3.02),('325','2013-07-09','10:25:00',3.02),('325','2013-07-09','10:30:00',3.03),('325','2013-07-09','10:35:00',3.1),('325','2013-07-09','10:40:00',3.17),('325','2013-07-09','10:45:00',3.32),('325','2013-07-09','10:50:00',3.37),('325','2013-07-09','10:55:00',3.4),('325','2013-07-09','11:00:00',3.46),('325','2013-07-09','11:05:00',3.53),('325','2013-07-09','11:10:00',3.58),('325','2013-07-09','11:15:00',3.61),('325','2013-07-09','11:20:00',3.59),('325','2013-07-09','11:25:00',3.37),('325','2013-07-09','11:30:00',2.51),('325','2013-07-09','11:35:00',2.66),('325','2013-07-09','11:40:00',3.35),('325','2013-07-09','11:45:00',4.05),('325','2013-07-09','11:50:00',4.52),('325','2013-07-09','11:55:00',4.45),('325','2013-07-09','12:00:00',4.46),('325','2013-07-09','12:05:00',4.46),('325','2013-07-09','12:10:00',4.4),('325','2013-07-09','12:15:00',4.38),('325','2013-07-09','12:20:00',4.3),('325','2013-07-09','12:25:00',4.21),('325','2013-07-09','12:30:00',4.15),('325','2013-07-09','12:35:00',4.15),('325','2013-07-09','12:40:00',4.17),('325','2013-07-09','12:45:00',4.18),('325','2013-07-09','12:50:00',4.15),('325','2013-07-09','12:55:00',4.23),('325','2013-07-09','13:00:00',4.32),('325','2013-07-09','13:05:00',4.45),('325','2013-07-09','13:10:00',4.52),('325','2013-07-09','13:15:00',4.41),('325','2013-07-09','13:20:00',4.3),('325','2013-07-09','13:25:00',4.32),('325','2013-07-09','13:30:00',4.6),('325','2013-07-09','13:35:00',4.48),('325','2013-07-09','13:40:00',4.51),('325','2013-07-09','13:45:00',4),('325','2013-07-09','13:50:00',3.35),('325','2013-07-09','13:55:00',3.62),('325','2013-07-09','14:00:00',3.63),('325','2013-07-09','14:05:00',3.41),('325','2013-07-09','14:10:00',3.71),('325','2013-07-09','14:15:00',3.81),('325','2013-07-09','14:20:00',2.91),('325','2013-07-09','14:25:00',2.81),('325','2013-07-09','14:30:00',1.89),('325','2013-07-09','14:35:00',1.14),('325','2013-07-09','14:40:00',1.01),('325','2013-07-08','08:25:00',1.05),('325','2013-07-08','08:30:00',1.13),('325','2013-07-08','08:35:00',1.18),('325','2013-07-08','08:40:00',1.24),('325','2013-07-08','08:45:00',1.29),('325','2013-07-08','08:50:00',1.33),('325','2013-07-08','08:55:00',1.34),('325','2013-07-08','09:00:00',1.35),('325','2013-07-08','09:05:00',1.37),('325','2013-07-08','09:10:00',1.41),('325','2013-07-08','09:15:00',1.43),('325','2013-07-08','09:20:00',1.47),('325','2013-07-08','09:25:00',1.47),('325','2013-07-08','09:30:00',1.52),('325','2013-07-08','09:35:00',1.62),('325','2013-07-08','09:40:00',2.19),('325','2013-07-08','09:45:00',2.6),('325','2013-07-08','09:50:00',2.66),('325','2013-07-08','09:55:00',2.68),('325','2013-07-08','10:00:00',2.75),('325','2013-07-08','10:05:00',2.85),('325','2013-07-08','10:10:00',2.9),('325','2013-07-08','10:15:00',3.01),('325','2013-07-08','10:20:00',3.07),('325','2013-07-08','10:25:00',3.07),('325','2013-07-08','10:30:00',3.05),('325','2013-07-08','10:35:00',3.15),('325','2013-07-08','10:40:00',3.19),('325','2013-07-08','10:45:00',3.32),('325','2013-07-08','10:50:00',3.36),('325','2013-07-08','10:55:00',3.37),('325','2013-07-08','11:00:00',3.4),('325','2013-07-08','11:05:00',3.48),('325','2013-07-08','11:10:00',3.82),('325','2013-07-08','11:15:00',3.92),('325','2013-07-08','11:20:00',3.97),('325','2013-07-08','11:25:00',4.04),('325','2013-07-08','11:30:00',4.09),('325','2013-07-08','11:35:00',4.12),('325','2013-07-08','11:40:00',3.94),('325','2013-07-08','11:45:00',4.1),('325','2013-07-08','11:50:00',4.22),('325','2013-07-08','11:55:00',4.21),('325','2013-07-08','12:00:00',4.21),('325','2013-07-08','12:05:00',4.29),('325','2013-07-08','12:10:00',4.41),('325','2013-07-08','12:15:00',4.52),('325','2013-07-08','12:20:00',4.53),('325','2013-07-08','12:25:00',4.49),('325','2013-07-08','12:30:00',3.92),('325','2013-07-08','12:35:00',4.39),('325','2013-07-08','12:40:00',4.39),('325','2013-07-08','12:45:00',4.35),('325','2013-07-08','12:50:00',4.39),('325','2013-07-08','12:55:00',4.46),('325','2013-07-08','13:00:00',4.57),('325','2013-07-08','13:05:00',4.5),('325','2013-07-08','13:10:00',3.58),('325','2013-07-08','13:15:00',4.62),('325','2013-07-08','13:20:00',2.93),('325','2013-07-08','13:25:00',1.32),('325','2013-07-08','14:35:00',1.15),('325','2013-07-08','14:40:00',1.22),('325','2013-07-08','14:45:00',1.16),('325','2013-07-08','14:50:00',1.11),('325','2013-07-08','14:55:00',1.09),('325','2013-07-08','15:00:00',1.01),('325','2013-07-08','17:35:00',1.02),('325','2013-07-08','17:40:00',1.06),('325','2013-07-08','17:45:00',1.07),('325','2013-07-08','17:50:00',1.09),('325','2013-07-08','17:55:00',1.07),('325','2013-07-08','18:40:00',1.14),('325','2013-07-08','18:45:00',1.07),('325','2013-07-07','08:30:00',1.01),('325','2013-07-07','08:35:00',1.21),('325','2013-07-07','08:50:00',1.04),('325','2013-07-07','08:55:00',1.44),('325','2013-07-07','09:00:00',1.45),('325','2013-07-07','09:05:00',1.3),('325','2013-07-07','09:10:00',1.38),('325','2013-07-07','09:15:00',1.53),('325','2013-07-07','09:20:00',1.43),('325','2013-07-07','09:25:00',1.76),('325','2013-07-07','09:30:00',2.4),('325','2013-07-07','09:35:00',2.53),('325','2013-07-07','09:40:00',2.51),('325','2013-07-07','09:45:00',2.71),('325','2013-07-07','09:50:00',2.83),('325','2013-07-07','09:55:00',2.94),('325','2013-07-07','10:00:00',2.98),('325','2013-07-07','10:05:00',2.79),('325','2013-07-07','10:10:00',2.88),('325','2013-07-07','10:15:00',2.94),('325','2013-07-07','10:20:00',2.87),('325','2013-07-07','10:25:00',3.15),('325','2013-07-07','10:30:00',2.72),('325','2013-07-07','10:35:00',3.33),('325','2013-07-07','10:40:00',3.27),('325','2013-07-07','10:45:00',3.38),('325','2013-07-07','10:50:00',3.54),('325','2013-07-07','10:55:00',3.5),('325','2013-07-07','11:00:00',3.56),('325','2013-07-07','11:05:00',3.6),('325','2013-07-07','11:10:00',3.7),('325','2013-07-07','11:15:00',3.8),('325','2013-07-07','11:20:00',3.55),('325','2013-07-07','11:25:00',3.46),('325','2013-07-07','11:30:00',3.46),('325','2013-07-07','11:35:00',3.34),('325','2013-07-07','11:40:00',3.49),('325','2013-07-07','11:45:00',2.87),('325','2013-07-07','11:50:00',3.05),('325','2013-07-07','11:55:00',2.33),('325','2013-07-07','12:00:00',2.4),('325','2013-07-07','12:05:00',4.06),('325','2013-07-07','12:10:00',4.18),('325','2013-07-07','12:15:00',4.29),('325','2013-07-07','12:20:00',4.37),('325','2013-07-07','12:25:00',4.15),('325','2013-07-07','12:30:00',4.01),('325','2013-07-07','12:35:00',4.15),('325','2013-07-07','12:40:00',4.25),('325','2013-07-07','12:45:00',4.28),('325','2013-07-07','12:50:00',4.25),('325','2013-07-07','12:55:00',4.61),('325','2013-07-07','13:00:00',4.48),('325','2013-07-07','13:05:00',4.54),('325','2013-07-07','13:10:00',4.51),('325','2013-07-07','13:15:00',4.54),('325','2013-07-07','13:20:00',4.46),('325','2013-07-07','13:25:00',4.07),('325','2013-07-07','13:30:00',3.51),('325','2013-07-07','13:35:00',4.5),('325','2013-07-07','13:40:00',4.42),('325','2013-07-07','13:45:00',2.74),('325','2013-07-07','13:50:00',4.94),('325','2013-07-07','13:55:00',3.83),('325','2013-07-07','14:00:00',3.27),('325','2013-07-07','14:05:00',3.28),('325','2013-07-07','14:10:00',2.83),('325','2013-07-07','14:15:00',1.56),('325','2013-07-07','14:20:00',1.3),('325','2013-07-07','14:25:00',1.11),('325','2013-07-07','14:30:00',1.05),('325','2013-07-07','15:05:00',1.13),('325','2013-07-07','17:10:00',1.04),('325','2013-07-07','17:15:00',1.09),('325','2013-07-07','17:20:00',1.1),('325','2013-07-07','17:25:00',1.09),('325','2013-07-07','17:30:00',1.05),('325','2013-07-06','08:25:00',1.04),('325','2013-07-06','08:30:00',1.11),('325','2013-07-06','08:35:00',1.16),('325','2013-07-06','08:40:00',1.22),('325','2013-07-06','08:45:00',1.27),('325','2013-07-06','08:50:00',1.31),('325','2013-07-06','08:55:00',1.32),('325','2013-07-06','09:00:00',1.31),('325','2013-07-06','09:05:00',1.33),('325','2013-07-06','09:10:00',1.38),('325','2013-07-06','09:15:00',1.41),('325','2013-07-06','09:20:00',1.43),('325','2013-07-06','09:25:00',1.47),('325','2013-07-06','09:30:00',1.49),('325','2013-07-06','09:35:00',1.53),('325','2013-07-06','09:40:00',2.26),('325','2013-07-06','09:45:00',2.6),('325','2013-07-06','09:50:00',2.7),('325','2013-07-06','09:55:00',2.74),('325','2013-07-06','10:00:00',2.8),('325','2013-07-06','10:05:00',2.87),('325','2013-07-06','10:10:00',2.95),('325','2013-07-06','10:15:00',3.05),('325','2013-07-06','10:20:00',3.09),('325','2013-07-06','10:25:00',3.1),('325','2013-07-06','10:30:00',3.09),('325','2013-07-06','10:35:00',3.13),('325','2013-07-06','10:40:00',3.25),('325','2013-07-06','10:45:00',3.37),('325','2013-07-06','10:50:00',3.4),('325','2013-07-06','10:55:00',3.43),('325','2013-07-06','11:00:00',3.5),('325','2013-07-06','11:05:00',3.53),('325','2013-07-06','11:10:00',3.65),('325','2013-07-06','11:15:00',3.96),('325','2013-07-06','11:20:00',3.97),('325','2013-07-06','11:25:00',3.99),('325','2013-07-06','11:30:00',4.03),('325','2013-07-06','11:35:00',4.06),('325','2013-07-06','11:40:00',4.09),('325','2013-07-06','11:45:00',4.15),('325','2013-07-06','11:50:00',4.23),('325','2013-07-06','11:55:00',4.21),('325','2013-07-06','12:00:00',4.22),('325','2013-07-06','12:05:00',4.3),('325','2013-07-06','12:10:00',4.37),('325','2013-07-06','12:15:00',4.36),('325','2013-07-06','12:20:00',4.37),('325','2013-07-06','12:25:00',4.41),('325','2013-07-06','12:30:00',4.43),('325','2013-07-06','12:35:00',4.44),('325','2013-07-06','12:40:00',4.43),('325','2013-07-06','12:45:00',4.45),('325','2013-07-06','12:50:00',4.45),('325','2013-07-06','12:55:00',4.42),('325','2013-07-06','13:00:00',4.47),('325','2013-07-06','13:05:00',4.46),('325','2013-07-06','13:10:00',4.46),('325','2013-07-06','13:15:00',4.47),('325','2013-07-06','13:20:00',4.48),('325','2013-07-06','13:25:00',4.45),('325','2013-07-06','13:30:00',4.49),('325','2013-07-06','13:35:00',4.43),('325','2013-07-06','13:40:00',4.49),('325','2013-07-06','13:45:00',4.47),('325','2013-07-06','13:50:00',4.38),('325','2013-07-06','13:55:00',4.29),('325','2013-07-06','14:00:00',4.32),('325','2013-07-06','14:05:00',4.38),('325','2013-07-06','14:10:00',4.34),('325','2013-07-06','14:15:00',4.34),('325','2013-07-06','14:20:00',4.43),('325','2013-07-06','14:25:00',4.34),('325','2013-07-06','14:30:00',4.24),('325','2013-07-06','14:35:00',4.24),('325','2013-07-06','14:40:00',4.23),('325','2013-07-06','14:45:00',4.18),('325','2013-07-06','14:50:00',4.18),('325','2013-07-06','14:55:00',4),('325','2013-07-06','15:00:00',4.28),('325','2013-07-06','15:05:00',4.27),('325','2013-07-06','15:10:00',4.13),('325','2013-07-06','15:15:00',4.04),('325','2013-07-06','15:20:00',4),('325','2013-07-06','15:25:00',4.03),('325','2013-07-06','15:30:00',3.15),('325','2013-07-06','15:35:00',2.11),('325','2013-07-06','16:45:00',1.06),('325','2013-07-06','16:50:00',1.82),('325','2013-07-06','16:55:00',1.81),('325','2013-07-06','17:00:00',1.18),('325','2013-07-06','17:05:00',1.12),('325','2013-07-06','17:10:00',1.18),('325','2013-07-06','17:15:00',2.17),('325','2013-07-06','17:20:00',1.23),('325','2013-07-06','17:25:00',1.07),('325','2013-07-06','17:30:00',1.26),('325','2013-07-06','17:35:00',1.23),('325','2013-07-06','17:40:00',1.06),('325','2013-07-06','17:45:00',1),('325','2013-07-05','08:20:00',1),('325','2013-07-05','08:25:00',1.06),('325','2013-07-05','08:30:00',1.12),('325','2013-07-05','08:35:00',1.17),('325','2013-07-05','08:40:00',1.24),('325','2013-07-05','08:45:00',1.28),('325','2013-07-05','08:50:00',1.32),('325','2013-07-05','08:55:00',1.33),('325','2013-07-05','09:00:00',1.33),('325','2013-07-05','09:05:00',1.36),('325','2013-07-05','09:10:00',1.42),('325','2013-07-05','09:15:00',1.45),('325','2013-07-05','09:20:00',1.49),('325','2013-07-05','09:25:00',1.53),('325','2013-07-05','09:30:00',1.56),('325','2013-07-05','09:35:00',1.6),('325','2013-07-05','09:40:00',2.34),('325','2013-07-05','09:45:00',2.63),('325','2013-07-05','09:50:00',2.72),('325','2013-07-05','09:55:00',2.73),('325','2013-07-05','10:00:00',2.8),('325','2013-07-05','10:05:00',2.86),('325','2013-07-05','10:10:00',2.95),('325','2013-07-05','10:15:00',3.04),('325','2013-07-05','10:20:00',3.09),('325','2013-07-05','10:25:00',3.15),('325','2013-07-05','10:30:00',3.21),('325','2013-07-05','10:35:00',3.27),('325','2013-07-05','10:40:00',3.34),('325','2013-07-05','10:45:00',3.39),('325','2013-07-05','10:50:00',3.39),('325','2013-07-05','10:55:00',3.39),('325','2013-07-05','11:00:00',3.55),('325','2013-07-05','11:05:00',3.8),('325','2013-07-05','11:10:00',3.84),('325','2013-07-05','11:15:00',3.9),('325','2013-07-05','11:20:00',3.94),('325','2013-07-05','11:25:00',3.98),('325','2013-07-05','11:30:00',4.04),('325','2013-07-05','11:35:00',4.06),('325','2013-07-05','11:40:00',4.1),('325','2013-07-05','11:45:00',4.08),('325','2013-07-05','11:50:00',4.11),('325','2013-07-05','11:55:00',4.19),('325','2013-07-05','12:00:00',4.18),('325','2013-07-05','12:05:00',4.23),('325','2013-07-05','12:10:00',4.23),('325','2013-07-05','12:15:00',4.25),('325','2013-07-05','12:20:00',4.28),('325','2013-07-05','12:25:00',3.67),('325','2013-07-05','12:30:00',4.2),('325','2013-07-05','12:35:00',2.87),('325','2013-07-05','12:40:00',4.04),('325','2013-07-05','12:45:00',4.17),('325','2013-07-05','12:50:00',4.38),('325','2013-07-05','12:55:00',4.48),('325','2013-07-05','13:00:00',3.27),('325','2013-07-05','13:05:00',3.21),('325','2013-07-05','13:10:00',4.68),('325','2013-07-05','13:15:00',4.6),('325','2013-07-05','13:20:00',2.59),('325','2013-07-05','13:25:00',4.7),('325','2013-07-05','13:30:00',4.34),('325','2013-07-05','13:35:00',4.29),('325','2013-07-05','13:40:00',4.52),('325','2013-07-05','13:45:00',4.49),('325','2013-07-05','13:50:00',4.43),('325','2013-07-05','13:55:00',4.38),('325','2013-07-05','14:00:00',4.34),('325','2013-07-05','14:05:00',4.34),('325','2013-07-05','14:10:00',2.45),('325','2013-07-05','14:15:00',4.35),('325','2013-07-05','14:20:00',4.27),('325','2013-07-05','14:25:00',4.26),('325','2013-07-05','14:30:00',4.25),('325','2013-07-05','14:35:00',4.3),('325','2013-07-05','14:40:00',4.12),('325','2013-07-05','14:45:00',3.11),('325','2013-07-05','14:50:00',3.6),('325','2013-07-05','14:55:00',4.19),('325','2013-07-05','15:00:00',4.19),('325','2013-07-05','15:05:00',2.85),('325','2013-07-05','15:10:00',4.25),('325','2013-07-05','15:15:00',4.17),('325','2013-07-05','15:20:00',2.6),('325','2013-07-05','15:25:00',4.22),('325','2013-07-05','15:30:00',4.06),('325','2013-07-05','15:35:00',3.97),('325','2013-07-05','15:40:00',3.84),('325','2013-07-05','15:45:00',3.85),('325','2013-07-05','15:50:00',3.83),('325','2013-07-05','15:55:00',3.73),('325','2013-07-05','16:00:00',3.64),('325','2013-07-05','16:05:00',3.62),('325','2013-07-05','16:10:00',3.54),('325','2013-07-05','16:15:00',3.44),('325','2013-07-05','16:20:00',3.45),('325','2013-07-05','16:25:00',3.4),('325','2013-07-05','16:30:00',3.34),('325','2013-07-05','16:35:00',3.28),('325','2013-07-05','16:40:00',3.19),('325','2013-07-05','16:45:00',3.13),('325','2013-07-05','16:50:00',3.03),('325','2013-07-05','16:55:00',2.9),('325','2013-07-05','17:00:00',2.83),('325','2013-07-05','17:05:00',2.73),('325','2013-07-05','17:10:00',2.63),('325','2013-07-05','17:15:00',2.57),('325','2013-07-05','17:20:00',2.6),('325','2013-07-05','17:25:00',2.44),('325','2013-07-05','17:30:00',2.4),('325','2013-07-05','17:35:00',2.3),('325','2013-07-05','17:40:00',2.15),('325','2013-07-05','17:45:00',2.05),('325','2013-07-05','17:50:00',1.93),('325','2013-07-05','17:55:00',1.86),('325','2013-07-05','18:00:00',1.77),('325','2013-07-05','18:05:00',1.7),('325','2013-07-05','18:10:00',1.53),('325','2013-07-05','18:15:00',1.34),('325','2013-07-05','18:20:00',1.22),('325','2013-07-04','11:10:00',1.07),('325','2013-07-04','11:15:00',1.11),('325','2013-07-04','11:20:00',1.1),('325','2013-07-04','11:25:00',1.21),('325','2013-07-04','11:30:00',1.34),('325','2013-07-04','11:35:00',1.53),('325','2013-07-04','11:40:00',1.65),('325','2013-07-04','11:45:00',1.69),('325','2013-07-04','11:50:00',1.69),('325','2013-07-04','11:55:00',1.51),('325','2013-07-04','12:00:00',1.43),('325','2013-07-04','12:05:00',2.05),('325','2013-07-04','12:10:00',2.74),('325','2013-07-04','12:15:00',2.55),('325','2013-07-04','12:20:00',2.44),('325','2013-07-04','12:25:00',3.49),('325','2013-07-04','12:30:00',2.77),('325','2013-07-04','12:35:00',2.22),('325','2013-07-04','12:40:00',1.66),('325','2013-07-04','12:45:00',1.34),('325','2013-07-04','12:50:00',1.07),('325','2013-07-04','13:00:00',1.15),('325','2013-07-04','13:05:00',1.46),('325','2013-07-04','13:10:00',1.96),('325','2013-07-04','13:15:00',2.31),('325','2013-07-04','13:20:00',2.27),('325','2013-07-04','13:25:00',3.04),('325','2013-07-04','13:30:00',2.56),('325','2013-07-04','13:35:00',2.54),('325','2013-07-04','13:40:00',3.04),('325','2013-07-04','13:45:00',4.37),('325','2013-07-04','13:50:00',5.59),('325','2013-07-04','13:55:00',4.51),('325','2013-07-04','14:00:00',3.31),('325','2013-07-04','14:05:00',2.45),('325','2013-07-04','14:10:00',2.29),('325','2013-07-04','14:15:00',2.37),('325','2013-07-04','14:20:00',2.32),('325','2013-07-04','14:25:00',2.1),('325','2013-07-04','14:30:00',2.07),('325','2013-07-04','14:35:00',2.18),('325','2013-07-04','14:40:00',2.65),('325','2013-07-04','14:45:00',3.11),('325','2013-07-04','14:50:00',2.79),('325','2013-07-04','14:55:00',2.31),('325','2013-07-04','15:00:00',1.94),('325','2013-07-04','15:05:00',2.48),('325','2013-07-04','15:10:00',3.8),('325','2013-07-04','15:15:00',3.02),('325','2013-07-04','15:20:00',3.2),('325','2013-07-04','15:25:00',2.84),('325','2013-07-04','15:30:00',2.79),('325','2013-07-04','15:35:00',2.63),('325','2013-07-04','15:40:00',2.82),('325','2013-07-04','15:45:00',3.69),('325','2013-07-04','15:50:00',2.25),('325','2013-07-04','15:55:00',2.57),('325','2013-07-04','16:00:00',2.71),('325','2013-07-04','16:05:00',2.63),('325','2013-07-04','16:10:00',2),('325','2013-07-04','16:15:00',1.95),('325','2013-07-04','16:20:00',1.99),('325','2013-07-04','16:25:00',2.44),('325','2013-07-04','16:30:00',2.28),('325','2013-07-04','16:35:00',2.43),('325','2013-07-04','16:40:00',1.96),('325','2013-07-04','16:45:00',1.68),('325','2013-07-04','16:50:00',1.63),('325','2013-07-04','16:55:00',1.53),('325','2013-07-04','17:00:00',1.33),('325','2013-07-04','17:05:00',1.34),('325','2013-07-04','17:10:00',2.03),('325','2013-07-04','17:15:00',2.6),('325','2013-07-04','17:20:00',2.45),('325','2013-07-04','17:25:00',2.91),('325','2013-07-04','17:30:00',2.69),('325','2013-07-04','17:35:00',2),('325','2013-07-04','17:40:00',2.35),('325','2013-07-04','17:45:00',2.34),('325','2013-07-04','17:50:00',2.29),('325','2013-07-04','17:55:00',1.89),('325','2013-07-04','18:00:00',2.1),('325','2013-07-04','18:05:00',1.98),('325','2013-07-04','18:10:00',1.91),('325','2013-07-04','18:15:00',1.8),('325','2013-07-04','18:20:00',1.59),('325','2013-07-04','18:25:00',1.25),('325','2013-07-03','08:20:00',1.01),('325','2013-07-03','08:25:00',1.07),('325','2013-07-03','08:30:00',1.12),('325','2013-07-03','08:35:00',1.16),('325','2013-07-03','08:40:00',1.24),('325','2013-07-03','08:45:00',1.29),('325','2013-07-03','08:50:00',1.33),('325','2013-07-03','08:55:00',1.33),('325','2013-07-03','09:00:00',1.33),('325','2013-07-03','09:05:00',1.34),('325','2013-07-03','09:10:00',1.39),('325','2013-07-03','09:15:00',1.42),('325','2013-07-03','09:20:00',1.43),('325','2013-07-03','09:25:00',1.44),('325','2013-07-03','09:30:00',1.49),('325','2013-07-03','09:35:00',1.59),('325','2013-07-03','09:40:00',2.46),('325','2013-07-03','09:45:00',2.62),('325','2013-07-03','09:50:00',2.74),('325','2013-07-03','09:55:00',2.75),('325','2013-07-03','10:00:00',2.79),('325','2013-07-03','10:05:00',2.86),('325','2013-07-03','10:10:00',2.97),('325','2013-07-03','10:15:00',3.02),('325','2013-07-03','10:20:00',3.08),('325','2013-07-03','10:25:00',3.08),('325','2013-07-03','10:30:00',3.11),('325','2013-07-03','10:35:00',3.21),('325','2013-07-03','10:40:00',3.28),('325','2013-07-03','10:45:00',3.37),('325','2013-07-03','10:50:00',3.4),('325','2013-07-03','10:55:00',3.43),('325','2013-07-03','11:00:00',3.52),('325','2013-07-03','11:05:00',3.6),('325','2013-07-03','11:10:00',3.68),('325','2013-07-03','11:15:00',3.78),('325','2013-07-03','11:20:00',3.83),('325','2013-07-03','11:25:00',3.89),('325','2013-07-03','11:30:00',3.9),('325','2013-07-03','11:35:00',3.88),('325','2013-07-03','11:40:00',3.92),('325','2013-07-03','11:45:00',3.89),('325','2013-07-03','11:50:00',3.93),('325','2013-07-03','11:55:00',4.03),('325','2013-07-03','12:00:00',4.06),('325','2013-07-03','12:05:00',4.16),('325','2013-07-03','12:10:00',4.28),('325','2013-07-03','12:15:00',4.36),('325','2013-07-03','12:20:00',4.36),('325','2013-07-03','12:25:00',4.35),('325','2013-07-03','12:30:00',4.32),('325','2013-07-03','12:35:00',4.26),('325','2013-07-03','12:40:00',4.22),('325','2013-07-03','12:45:00',4.2),('325','2013-07-03','12:50:00',4.52),('325','2013-07-03','12:55:00',4.6),('325','2013-07-03','13:00:00',4.62),('325','2013-07-03','13:05:00',4.62),('325','2013-07-03','13:10:00',4.64),('325','2013-07-03','13:15:00',4.63),('325','2013-07-03','13:20:00',4.61),('325','2013-07-03','13:25:00',4.63),('325','2013-07-03','13:30:00',4.62),('325','2013-07-03','13:35:00',4.63),('325','2013-07-03','13:40:00',4.61),('325','2013-07-03','13:45:00',4.59),('325','2013-07-03','13:50:00',4.51),('325','2013-07-03','13:55:00',4.43),('325','2013-07-03','14:00:00',4.36),('325','2013-07-03','14:05:00',4.33),('325','2013-07-03','14:10:00',4.22),('325','2013-07-03','14:15:00',4.21),('325','2013-07-03','14:20:00',4.16),('325','2013-07-03','14:25:00',4.25),('325','2013-07-03','14:30:00',4.36),('325','2013-07-03','14:35:00',4.38),('325','2013-07-03','14:40:00',4.37),('325','2013-07-03','14:45:00',4.4),('325','2013-07-03','14:50:00',4.37),('325','2013-07-03','14:55:00',4.35),('325','2013-07-03','15:00:00',4.36),('325','2013-07-03','15:05:00',4.3),('325','2013-07-03','15:10:00',4.29),('325','2013-07-03','15:15:00',4.25),('325','2013-07-03','15:20:00',4.2),('325','2013-07-03','15:25:00',4.14),('325','2013-07-03','15:30:00',4.11),('325','2013-07-03','15:35:00',4.07),('325','2013-07-03','15:40:00',4.01),('325','2013-07-03','15:45:00',3.96),('325','2013-07-03','15:50:00',3.91),('325','2013-07-03','15:55:00',3.84),('325','2013-07-03','16:00:00',3.77),('325','2013-07-03','16:05:00',3.74),('325','2013-07-03','16:10:00',3.67),('325','2013-07-03','16:15:00',3.62),('325','2013-07-03','16:20:00',3.58),('325','2013-07-03','16:25:00',3.51),('325','2013-07-03','16:30:00',3.47),('325','2013-07-03','16:35:00',3.39),('325','2013-07-03','16:40:00',3.32),('325','2013-07-03','16:45:00',3.22),('325','2013-07-03','16:50:00',3.18),('325','2013-07-03','16:55:00',3.11),('325','2013-07-03','17:00:00',3.03),('325','2013-07-03','17:05:00',2.9),('325','2013-07-03','17:10:00',2.78),('325','2013-07-03','17:15:00',2.75),('325','2013-07-03','17:20:00',2.68),('325','2013-07-03','17:25:00',2.6),('325','2013-07-03','17:30:00',2.52),('325','2013-07-03','17:35:00',2.44),('325','2013-07-03','17:40:00',2.35),('325','2013-07-03','17:45:00',2.27),('325','2013-07-03','17:50:00',2.17),('325','2013-07-03','17:55:00',2.05),('325','2013-07-03','18:00:00',1.96),('325','2013-07-03','18:05:00',1.82),('325','2013-07-03','18:10:00',1.74),('325','2013-07-03','18:15:00',1.65),('325','2013-07-03','18:20:00',1.45),('325','2013-07-03','18:25:00',1.27),('325','2013-07-03','18:30:00',1.17),('325','2013-07-03','18:35:00',1.08),('325','2013-07-03','18:40:00',1.03),('325','2013-07-02','08:20:00',1.01),('325','2013-07-02','08:25:00',1.07),('325','2013-07-02','08:30:00',1.14),('325','2013-07-02','08:35:00',1.18),('325','2013-07-02','08:40:00',1.25),('325','2013-07-02','08:45:00',1.29),('325','2013-07-02','08:50:00',1.31),('325','2013-07-02','08:55:00',1.32),('325','2013-07-02','09:00:00',1.32),('325','2013-07-02','09:05:00',1.34),('325','2013-07-02','09:10:00',1.39),('325','2013-07-02','09:15:00',1.41),('325','2013-07-02','09:20:00',1.43),('325','2013-07-02','09:25:00',1.46),('325','2013-07-02','09:30:00',1.49),('325','2013-07-02','09:35:00',1.74),('325','2013-07-02','09:40:00',2.55),('325','2013-07-02','09:45:00',2.64),('325','2013-07-02','09:50:00',2.73),('325','2013-07-02','09:55:00',2.75),('325','2013-07-02','10:00:00',2.75),('325','2013-07-02','10:05:00',2.86),('325','2013-07-02','10:10:00',2.93),('325','2013-07-02','10:15:00',3.02),('325','2013-07-02','10:20:00',3.09),('325','2013-07-02','10:25:00',3.13),('325','2013-07-02','10:30:00',3.2),('325','2013-07-02','10:35:00',3.24),('325','2013-07-02','10:40:00',3.3),('325','2013-07-02','10:45:00',3.37),('325','2013-07-02','10:50:00',3.38),('325','2013-07-02','10:55:00',3.37),('325','2013-07-02','11:00:00',3.43),('325','2013-07-02','11:05:00',3.47),('325','2013-07-02','11:10:00',3.51),('325','2013-07-02','11:15:00',3.63),('325','2013-07-02','11:20:00',3.76),('325','2013-07-02','11:25:00',3.85),('325','2013-07-02','11:30:00',3.8),('325','2013-07-02','11:35:00',3.79),('325','2013-07-02','11:40:00',3.76),('325','2013-07-02','11:45:00',3.77),('325','2013-07-02','11:50:00',3.84),('325','2013-07-02','11:55:00',3.81),('325','2013-07-02','12:00:00',3.96),('325','2013-07-02','12:05:00',4.08),('325','2013-07-02','12:10:00',4.19),('325','2013-07-02','12:15:00',4.18),('325','2013-07-02','12:20:00',4.19),('325','2013-07-02','12:25:00',4.18),('325','2013-07-02','12:30:00',4.29),('325','2013-07-02','12:35:00',4.32),('325','2013-07-02','12:40:00',4.27),('325','2013-07-02','12:45:00',4.29),('325','2013-07-02','12:50:00',4.71),('325','2013-07-02','12:55:00',4.16),('325','2013-07-02','13:00:00',1.47),('325','2013-07-02','13:05:00',4.6),('325','2013-07-02','13:10:00',4.65),('325','2013-07-02','13:15:00',3.57),('325','2013-07-02','13:20:00',4.58),('325','2013-07-02','13:25:00',4.46),('325','2013-07-02','13:30:00',4.57),('325','2013-07-02','13:35:00',4.54),('325','2013-07-02','13:40:00',4.43),('325','2013-07-02','13:45:00',4.39),('325','2013-07-02','13:50:00',4.34),('325','2013-07-02','13:55:00',4.32),('325','2013-07-02','14:00:00',4.27),('325','2013-07-02','14:05:00',4.31),('325','2013-07-02','14:10:00',4.34),('325','2013-07-02','14:15:00',4.35),('325','2013-07-02','14:20:00',4.34),('325','2013-07-02','14:25:00',4.31),('325','2013-07-02','14:30:00',4.3),('325','2013-07-02','14:35:00',4.26),('325','2013-07-02','14:40:00',4.27),('325','2013-07-02','14:45:00',4.25),('325','2013-07-02','14:50:00',4.22),('325','2013-07-02','14:55:00',4.21),('325','2013-07-02','15:00:00',4.22),('325','2013-07-02','15:05:00',4.19),('325','2013-07-02','15:10:00',4.15),('325','2013-07-02','15:15:00',4.1),('325','2013-07-02','15:20:00',4.06),('325','2013-07-02','15:25:00',4.05),('325','2013-07-02','15:30:00',4.02),('325','2013-07-02','15:35:00',3.98),('325','2013-07-02','15:40:00',3.92),('325','2013-07-02','15:45:00',3.87),('325','2013-07-02','15:50:00',3.83),('325','2013-07-02','15:55:00',3.77),('325','2013-07-02','16:00:00',3.71),('325','2013-07-02','16:05:00',3.68),('325','2013-07-02','16:10:00',3.61),('325','2013-07-02','16:15:00',3.55),('325','2013-07-02','16:20:00',3.5),('325','2013-07-02','16:25:00',3.45),('325','2013-07-02','16:30:00',3.38),('325','2013-07-02','16:35:00',3.32),('325','2013-07-02','16:40:00',3.25),('325','2013-07-02','16:45:00',3.17),('325','2013-07-02','16:50:00',3.09),('325','2013-07-02','16:55:00',3.04),('325','2013-07-02','17:00:00',2.97),('325','2013-07-02','17:05:00',2.84),('325','2013-07-02','17:10:00',2.68),('325','2013-07-02','17:15:00',2.67),('325','2013-07-02','17:20:00',2.6),('325','2013-07-02','17:25:00',2.52),('325','2013-07-02','17:30:00',2.43),('325','2013-07-02','17:35:00',2.34),('325','2013-07-02','17:40:00',2.24),('325','2013-07-02','17:45:00',2.14),('325','2013-07-02','17:50:00',2.06),('325','2013-07-02','17:55:00',1.96),('325','2013-07-02','18:00:00',1.83),('325','2013-07-02','18:05:00',1.76),('325','2013-07-02','18:10:00',1.67),('325','2013-07-02','18:15:00',1.56),('325','2013-07-02','18:20:00',1.39),('325','2013-07-02','18:25:00',1.21),('325','2013-07-02','18:30:00',1.14),('325','2013-07-02','18:35:00',1.02),('325','2013-07-01','08:15:00',1),('325','2013-07-01','08:20:00',1.05),('325','2013-07-01','08:25:00',1.11),('325','2013-07-01','08:30:00',1.16),('325','2013-07-01','08:35:00',1.21),('325','2013-07-01','08:40:00',1.29),('325','2013-07-01','08:45:00',1.33),('325','2013-07-01','08:50:00',1.36),('325','2013-07-01','08:55:00',1.36),('325','2013-07-01','09:00:00',1.36),('325','2013-07-01','09:05:00',1.37),('325','2013-07-01','09:10:00',1.42),('325','2013-07-01','09:15:00',1.45),('325','2013-07-01','09:20:00',1.47),('325','2013-07-01','09:25:00',1.51),('325','2013-07-01','09:30:00',1.56),('325','2013-07-01','09:35:00',1.75),('325','2013-07-01','09:40:00',2.59),('325','2013-07-01','09:45:00',2.74),('325','2013-07-01','09:50:00',2.83),('325','2013-07-01','09:55:00',2.82),('325','2013-07-01','10:00:00',2.85),('325','2013-07-01','10:05:00',2.91),('325','2013-07-01','10:10:00',3),('325','2013-07-01','10:15:00',3.09),('325','2013-07-01','10:20:00',3.15),('325','2013-07-01','10:25:00',3.15),('325','2013-07-01','10:30:00',3.19),('325','2013-07-01','10:35:00',3.26),('325','2013-07-01','10:40:00',3.36),('325','2013-07-01','10:45:00',3.48),('325','2013-07-01','10:50:00',3.6),('325','2013-07-01','10:55:00',3.76),('325','2013-07-01','11:00:00',3.94),('325','2013-07-01','11:05:00',4),('325','2013-07-01','11:10:00',4),('325','2013-07-01','11:15:00',4.11),('325','2013-07-01','11:20:00',4.17),('325','2013-07-01','11:25:00',4.21),('325','2013-07-01','11:30:00',4.22),('325','2013-07-01','11:35:00',4.22),('325','2013-07-01','11:40:00',4.24),('325','2013-07-01','11:45:00',4.32),('325','2013-07-01','11:50:00',4.37),('325','2013-07-01','11:55:00',4.36),('325','2013-07-01','12:00:00',4.34),('325','2013-07-01','12:05:00',4.36),('325','2013-07-01','12:10:00',4.36),('325','2013-07-01','12:15:00',4.37),('325','2013-07-01','12:20:00',4.36),('325','2013-07-01','12:25:00',4.45),('325','2013-07-01','12:30:00',4.46),('325','2013-07-01','12:35:00',4.5),('325','2013-07-01','12:40:00',4.45),('325','2013-07-01','12:45:00',4.46),('325','2013-07-01','12:50:00',4.49),('325','2013-07-01','12:55:00',4.49),('325','2013-07-01','13:00:00',4.49),('325','2013-07-01','13:05:00',4.5),('325','2013-07-01','13:10:00',4.54),('325','2013-07-01','13:15:00',4.51),('325','2013-07-01','13:20:00',4.54),('325','2013-07-01','13:25:00',4.51),('325','2013-07-01','13:30:00',4.53),('325','2013-07-01','13:35:00',4.54),('325','2013-07-01','13:40:00',4.52),('325','2013-07-01','13:45:00',4.46),('325','2013-07-01','13:50:00',4.45),('325','2013-07-01','13:55:00',4.4),('325','2013-07-01','14:00:00',4.36),('325','2013-07-01','14:05:00',4.35),('325','2013-07-01','14:10:00',4.27),('325','2013-07-01','14:15:00',4.2),('325','2013-07-01','14:20:00',4.18),('325','2013-07-01','14:25:00',4.14),('325','2013-07-01','14:30:00',4.23),('325','2013-07-01','14:35:00',4.3),('325','2013-07-01','14:40:00',4.29),('325','2013-07-01','14:45:00',4.29),('325','2013-07-01','14:50:00',4.27),('325','2013-07-01','14:55:00',4.23),('325','2013-07-01','15:00:00',4.21),('325','2013-07-01','15:05:00',4.15),('325','2013-07-01','15:10:00',4.15),('325','2013-07-01','15:15:00',4.11),('325','2013-07-01','15:20:00',4.06),('325','2013-07-01','15:25:00',4.02),('325','2013-07-01','15:30:00',3.97),('325','2013-07-01','15:35:00',3.89),('325','2013-07-01','15:40:00',3.84),('325','2013-07-01','15:45:00',3.84),('325','2013-07-01','15:50:00',3.8),('325','2013-07-01','15:55:00',3.7),('325','2013-07-01','16:00:00',3.68),('325','2013-07-01','16:05:00',3.61),('325','2013-07-01','16:10:00',3.56),('325','2013-07-01','16:15:00',3.49),('325','2013-07-01','16:20:00',3.41),('325','2013-07-01','16:25:00',3.37),('325','2013-07-01','16:30:00',3.3),('325','2013-07-01','16:35:00',3.22),('325','2013-07-01','16:40:00',3.16),('325','2013-07-01','16:45:00',3.12),('325','2013-07-01','16:50:00',3.06),('325','2013-07-01','16:55:00',3),('325','2013-07-01','17:00:00',2.92),('325','2013-07-01','17:05:00',2.81),('325','2013-07-01','17:10:00',2.67),('325','2013-07-01','17:15:00',2.66),('325','2013-07-01','17:20:00',2.55),('325','2013-07-01','17:25:00',2.47),('325','2013-07-01','17:30:00',2.37),('325','2013-07-01','17:35:00',2.28),('325','2013-07-01','17:40:00',2.2),('325','2013-07-01','17:45:00',2.13),('325','2013-07-01','17:50:00',2.06),('325','2013-07-01','17:55:00',1.96),('325','2013-07-01','18:00:00',1.67),('325','2013-07-01','18:05:00',1.74),('325','2013-07-01','18:10:00',1.64),('325','2013-07-01','18:15:00',1.29),('325','2013-07-01','18:20:00',1.3),('325','2013-07-01','18:25:00',1.27),('325','2013-07-01','18:30:00',1.18),('325','2013-07-01','18:35:00',1.05),('325','2013-06-30','08:15:00',1.01),('325','2013-06-30','08:20:00',1.06),('325','2013-06-30','08:25:00',1.12),('325','2013-06-30','08:30:00',1.18),('325','2013-06-30','08:35:00',1.22),('325','2013-06-30','08:40:00',1.29),('325','2013-06-30','08:45:00',1.33),('325','2013-06-30','08:50:00',1.36),('325','2013-06-30','08:55:00',1.36),('325','2013-06-30','09:00:00',1.35),('325','2013-06-30','09:05:00',1.36),('325','2013-06-30','09:10:00',1.42),('325','2013-06-30','09:15:00',1.44),('325','2013-06-30','09:20:00',1.46),('325','2013-06-30','09:25:00',1.5),('325','2013-06-30','09:30:00',1.63),('325','2013-06-30','09:35:00',2.37),('325','2013-06-30','09:40:00',2.84),('325','2013-06-30','09:45:00',2.96),('325','2013-06-30','09:50:00',3.05),('325','2013-06-30','09:55:00',3.1),('325','2013-06-30','10:00:00',3.18),('325','2013-06-30','10:05:00',3.24),('325','2013-06-30','10:10:00',3.31),('325','2013-06-30','10:15:00',3.37),('325','2013-06-30','10:20:00',3.44),('325','2013-06-30','10:25:00',3.52),('325','2013-06-30','10:30:00',3.58),('325','2013-06-30','10:35:00',3.65),('325','2013-06-30','10:40:00',3.73),('325','2013-06-30','10:45:00',3.78),('325','2013-06-30','10:50:00',3.82),('325','2013-06-30','10:55:00',3.86),('325','2013-06-30','11:00:00',3.97),('325','2013-06-30','11:05:00',4.01),('325','2013-06-30','11:10:00',4.05),('325','2013-06-30','11:15:00',4.12),('325','2013-06-30','11:20:00',4.14),('325','2013-06-30','11:25:00',4.16),('325','2013-06-30','11:30:00',4.2),('325','2013-06-30','11:35:00',4.22),('325','2013-06-30','11:40:00',4.25),('325','2013-06-30','11:45:00',4.3),('325','2013-06-30','11:50:00',4.38),('325','2013-06-30','11:55:00',4.41),('325','2013-06-30','12:00:00',4.37),('325','2013-06-30','12:05:00',4.36),('325','2013-06-30','12:10:00',4.47),('325','2013-06-30','12:15:00',4.47),('325','2013-06-30','12:20:00',4.43),('325','2013-06-30','12:25:00',4.35),('325','2013-06-30','12:30:00',4.31),('325','2013-06-30','12:35:00',4.28),('325','2013-06-30','12:40:00',4.24),('325','2013-06-30','12:45:00',4.19),('325','2013-06-30','12:50:00',4.31),('325','2013-06-30','12:55:00',4.42),('325','2013-06-30','13:00:00',4.46),('325','2013-06-30','13:05:00',4.49),('325','2013-06-30','13:10:00',4.5),('325','2013-06-30','13:15:00',4.47),('325','2013-06-30','13:20:00',4.41),('325','2013-06-30','13:25:00',4.38),('325','2013-06-30','13:30:00',4.29),('325','2013-06-30','13:35:00',4.37),('325','2013-06-30','13:40:00',3.13),('325','2013-06-30','13:45:00',4.68),('325','2013-06-30','13:50:00',4.65),('325','2013-06-30','13:55:00',4.58),('325','2013-06-30','14:00:00',4.55),('325','2013-06-30','14:05:00',4.46),('325','2013-06-30','14:10:00',4.3),('325','2013-06-30','14:15:00',4.21),('325','2013-06-30','14:20:00',4.2),('325','2013-06-30','14:25:00',4.16),('325','2013-06-30','14:30:00',4.21),('325','2013-06-30','14:35:00',4.28),('325','2013-06-30','14:40:00',4.34),('325','2013-06-30','14:45:00',4.34),('325','2013-06-30','14:50:00',4.29),('325','2013-06-30','14:55:00',4.25),('325','2013-06-30','15:00:00',4.2),('325','2013-06-30','15:05:00',4.15),('325','2013-06-30','15:10:00',4.16),('325','2013-06-30','15:15:00',4.14),('325','2013-06-30','15:20:00',4.17),('325','2013-06-30','15:25:00',4.12),('325','2013-06-30','15:30:00',4.07),('325','2013-06-30','15:35:00',4.05),('325','2013-06-30','15:40:00',4.03),('325','2013-06-30','15:45:00',3.96),('325','2013-06-30','15:50:00',3.93),('325','2013-06-30','15:55:00',3.85),('325','2013-06-30','16:00:00',3.8),('325','2013-06-30','16:05:00',3.75),('325','2013-06-30','16:10:00',3.73),('325','2013-06-30','16:15:00',3.46),('325','2013-06-30','16:20:00',3.54),('325','2013-06-30','16:25:00',3.69),('325','2013-06-30','16:30:00',3.58),('325','2013-06-30','16:35:00',3.49),('325','2013-06-30','16:40:00',3.31),('325','2013-06-30','16:45:00',3.26),('325','2013-06-30','16:50:00',3.19),('325','2013-06-30','16:55:00',3.08),('325','2013-06-30','17:00:00',2.95),('325','2013-06-30','17:05:00',2.81),('325','2013-06-30','17:10:00',2.7),('325','2013-06-30','17:15:00',2.69),('325','2013-06-30','17:20:00',2.6),('325','2013-06-30','17:25:00',2.51),('325','2013-06-30','17:30:00',2.41),('325','2013-06-30','17:35:00',2.32),('325','2013-06-30','17:40:00',2.25),('325','2013-06-30','17:45:00',2.15),('325','2013-06-30','17:50:00',2.06),('325','2013-06-30','17:55:00',1.97),('325','2013-06-30','18:00:00',1.81),('325','2013-06-30','18:05:00',1.71),('325','2013-06-30','18:10:00',1.67),('325','2013-06-30','18:15:00',1.55),('325','2013-06-30','18:20:00',1.39),('325','2013-06-30','18:25:00',1.23),('325','2013-06-30','18:30:00',1.12),('325','2013-06-30','18:35:00',1.03),('325','2014-04-04','09:05:00',1.43),('325','2014-04-04','09:10:00',1.76),('325','2014-04-04','09:15:00',1.69),('325','2014-04-04','09:20:00',1.22),('325','2014-04-04','13:10:00',1.29),('325','2014-04-04','13:20:00',1.93),('325','2014-04-04','13:25:00',2.26),('325','2014-04-04','13:30:00',2.39),('325','2014-04-04','13:35:00',3.11),('325','2014-04-04','13:40:00',5.17),('325','2014-04-04','13:45:00',3.37),('325','2014-04-04','13:50:00',4.5),('325','2014-04-04','13:55:00',2),('325','2014-04-04','14:00:00',3.65),('325','2014-04-04','14:05:00',4.65),('325','2014-04-04','14:10:00',4.95),('325','2014-04-04','14:15:00',3.19),('325','2014-04-04','14:20:00',3.39),('325','2014-04-04','14:25:00',2.76),('325','2014-04-04','14:30:00',1.31),('325','2014-04-04','14:35:00',1.81),('325','2014-04-04','14:40:00',1.48),('325','2014-04-04','14:45:00',1.81),('325','2014-04-04','14:50:00',3.45),('325','2014-04-04','14:55:00',4.71),('325','2014-04-04','15:00:00',4.46),('325','2014-04-04','15:05:00',3.47),('325','2014-04-04','15:10:00',3.05),('325','2014-04-04','15:15:00',3.02),('325','2014-04-04','15:20:00',2.21),('325','2014-04-04','15:25:00',2.25),('325','2014-04-04','15:30:00',1.61),('325','2014-04-04','15:35:00',1.36),('325','2014-04-04','15:40:00',2.53),('325','2014-04-04','15:45:00',2.02),('325','2014-04-04','15:50:00',1.88),('325','2014-04-04','15:55:00',3.52),('325','2014-04-04','16:00:00',3.7),('325','2014-04-04','16:05:00',2.96),('325','2014-04-04','16:10:00',3.74),('325','2014-04-04','16:15:00',1.71),('325','2014-04-04','16:20:00',1.24),('325','2014-04-04','16:25:00',1.13),('325','2014-04-04','16:30:00',2.02),('325','2014-04-04','16:35:00',1.64),('325','2014-04-04','16:40:00',1.51),('325','2014-04-04','16:45:00',2.85),('325','2014-04-04','16:50:00',2.61),('325','2014-04-04','16:55:00',2.66),('325','2014-04-04','17:00:00',2.25),('325','2014-04-04','17:05:00',2.01),('325','2014-04-04','17:10:00',2.35),('325','2014-04-04','17:15:00',1.89),('325','2014-04-04','17:20:00',2.37),('325','2014-04-04','17:25:00',2.12),('325','2014-04-04','17:30:00',2.36),('325','2014-04-04','17:35:00',1.76),('325','2014-04-04','17:40:00',1.2),('325','2014-04-04','17:45:00',1.71),('325','2014-04-04','17:50:00',1.61),('325','2014-04-04','17:55:00',1.38),('325','2014-04-04','18:00:00',1.25),('325','2014-04-04','18:05:00',1.11),('325','2013-06-29','07:55:00',1.1),('325','2013-06-29','08:00:00',1.3),('325','2013-06-29','08:05:00',1.44),('325','2013-06-29','08:10:00',1.43),('325','2013-06-29','08:15:00',1.26),('325','2013-06-29','08:25:00',1.26),('325','2013-06-29','08:30:00',1.22),('325','2013-06-29','08:35:00',1.32),('325','2013-06-29','08:45:00',1.29),('325','2013-06-29','08:50:00',1.42),('325','2013-06-29','08:55:00',1.4),('325','2013-06-29','09:00:00',1.46),('325','2013-06-29','09:05:00',1.5),('325','2013-06-29','09:10:00',1.54),('325','2013-06-29','09:15:00',1.58),('325','2013-06-29','09:20:00',1.62),('325','2013-06-29','09:25:00',1.67),('325','2013-06-29','09:30:00',1.69),('325','2013-06-29','09:35:00',2.1),('325','2013-06-29','09:40:00',2.77),('325','2013-06-29','09:45:00',2.91),('325','2013-06-29','09:50:00',2.99),('325','2013-06-29','09:55:00',3.05),('325','2013-06-29','10:00:00',3.13),('325','2013-06-29','10:05:00',3.22),('325','2013-06-29','10:10:00',3.28),('325','2013-06-29','10:15:00',3.32),('325','2013-06-29','10:20:00',3.37),('325','2013-06-29','10:25:00',3.47),('325','2013-06-29','10:30:00',3.54),('325','2013-06-29','10:35:00',3.61),('325','2013-06-29','10:40:00',3.71),('325','2013-06-29','10:45:00',3.71),('325','2013-06-29','10:50:00',1.06),('325','2013-06-29','10:55:00',3.52),('325','2013-06-29','11:00:00',4.14),('325','2013-06-29','11:05:00',4.14),('325','2013-06-29','11:10:00',4.19),('325','2013-06-29','11:15:00',4.32),('325','2013-06-29','11:20:00',3.9),('325','2013-06-29','11:25:00',4.68),('325','2013-06-29','11:30:00',3.69),('325','2013-06-29','11:35:00',2.98),('325','2013-06-29','11:40:00',2.76),('325','2013-06-29','11:45:00',5.08),('325','2013-06-29','11:50:00',5.12),('325','2013-06-29','11:55:00',3.66),('325','2013-06-29','12:00:00',4.06),('325','2013-06-29','12:05:00',4.26),('325','2013-06-29','12:10:00',4.76),('325','2013-06-29','12:15:00',4.57),('325','2013-06-29','12:20:00',2.74),('325','2013-06-29','12:25:00',4.44),('325','2013-06-29','12:30:00',4.82),('325','2013-06-29','12:35:00',1.95),('325','2013-06-29','12:40:00',3.28),('325','2013-06-29','12:45:00',5.26),('325','2013-06-29','12:50:00',3.81),('325','2013-06-29','12:55:00',5.14),('325','2013-06-29','13:00:00',3.22),('325','2013-06-29','13:05:00',4.55),('325','2013-06-29','13:10:00',4.71),('325','2013-06-29','13:15:00',4),('325','2013-06-29','13:20:00',2.26),('325','2013-06-29','13:25:00',3.37),('325','2013-06-29','13:30:00',1.11),('325','2013-06-29','13:40:00',1.07),('325','2013-06-29','13:45:00',1.79),('325','2013-06-29','13:50:00',1.94),('325','2013-06-29','13:55:00',4.39),('325','2013-06-29','14:00:00',5.09),('325','2013-06-29','14:05:00',5.03),('325','2013-06-29','14:10:00',4.83),('325','2013-06-29','14:15:00',4.81),('325','2013-06-29','14:20:00',5.04),('325','2013-06-29','14:25:00',4.95),('325','2013-06-29','14:30:00',4.7),('325','2013-06-29','14:35:00',4.76),('325','2013-06-29','14:40:00',4.83),('325','2013-06-29','14:45:00',4.93),('325','2013-06-29','14:50:00',5.15),('325','2013-06-29','14:55:00',4),('325','2013-06-29','15:00:00',4.39),('325','2013-06-29','15:05:00',5.29),('325','2013-06-29','15:10:00',3.34),('325','2013-06-29','15:15:00',3.59),('325','2013-06-29','15:20:00',1.72),('325','2013-06-29','15:25:00',1.36),('325','2013-06-29','16:40:00',1.28),('325','2013-06-29','16:45:00',1.75),('325','2013-06-29','16:50:00',2.88),('325','2013-06-29','16:55:00',1.3),('325','2013-06-29','17:00:00',1.32),('325','2013-06-29','17:05:00',1.62),('325','2013-06-29','17:10:00',1.17),('325','2013-06-29','17:15:00',1.12),('325','2013-06-29','17:20:00',1.4),('325','2013-06-29','17:25:00',1.66),('325','2013-06-29','17:30:00',3.09),('325','2013-06-29','17:35:00',1.88),('325','2013-06-29','17:40:00',1.4),('325','2013-06-29','17:45:00',2.26),('325','2013-06-29','17:50:00',1.97),('325','2013-06-29','17:55:00',2.03),('325','2013-06-29','18:00:00',1.85),('325','2013-06-29','18:05:00',1.68),('325','2013-06-29','18:20:00',1.35),('325','2013-06-28','08:20:00',1.03),('325','2013-06-28','08:25:00',1.06),('325','2013-06-28','08:30:00',1.17),('325','2013-06-28','08:35:00',1.25),('325','2013-06-28','08:40:00',1.31),('325','2013-06-28','08:45:00',1.37),('325','2013-06-28','08:50:00',1.43),('325','2013-06-28','08:55:00',1.47),('325','2013-06-28','09:00:00',1.5),('325','2013-06-28','09:05:00',1.6),('325','2013-06-28','09:10:00',1.75),('325','2013-06-28','09:15:00',1.99),('325','2013-06-28','09:25:00',1.02),('325','2013-06-28','09:30:00',2.65),('325','2013-06-28','09:35:00',2.81),('325','2013-06-28','09:40:00',2.98),('325','2013-06-28','09:45:00',3.11),('325','2013-06-28','09:50:00',2.52),('325','2013-06-28','09:55:00',2.44),('325','2013-06-28','10:00:00',1.8),('325','2013-06-28','10:05:00',3.42),('325','2013-06-28','10:10:00',3.53),('325','2013-06-28','10:15:00',2.97),('325','2013-06-28','10:20:00',1.44),('325','2013-06-28','10:25:00',1.45),('325','2013-06-28','10:30:00',4.35),('325','2013-06-28','10:35:00',4.56),('325','2013-06-28','10:40:00',2.9),('325','2013-06-28','10:45:00',3.33),('325','2013-06-28','10:50:00',2.28),('325','2013-06-28','10:55:00',2.4),('325','2013-06-28','11:00:00',2.26),('325','2013-06-28','11:05:00',2.17),('325','2013-06-28','11:10:00',1.76),('325','2013-06-28','11:15:00',2.24),('325','2013-06-28','11:20:00',2.11),('325','2013-06-28','11:25:00',4.4),('325','2013-06-28','11:30:00',4.61),('325','2013-06-28','11:35:00',3.84),('325','2013-06-28','11:40:00',4.34),('325','2013-06-28','11:45:00',4.46),('325','2013-06-28','11:50:00',3.97),('325','2013-06-28','11:55:00',2.71),('325','2013-06-28','12:00:00',2.47),('325','2013-06-28','12:05:00',2.91),('325','2013-06-28','12:10:00',4.08),('325','2013-06-28','12:15:00',5.06),('325','2013-06-28','12:20:00',4.74),('325','2013-06-28','12:25:00',3.68),('325','2013-06-28','12:30:00',4.87),('325','2013-06-28','12:35:00',3.55),('325','2013-06-28','12:40:00',2.54),('325','2013-06-28','12:45:00',5),('325','2013-06-28','12:50:00',4.94),('325','2013-06-28','12:55:00',4.82),('325','2013-06-28','13:00:00',4.85),('325','2013-06-28','13:05:00',3.91),('325','2013-06-28','13:10:00',3.64),('325','2013-06-28','13:15:00',4.98),('325','2013-06-28','13:20:00',4.82),('325','2013-06-28','13:25:00',4.82),('325','2013-06-28','13:30:00',4.8),('325','2013-06-28','13:35:00',4.89),('325','2013-06-28','13:40:00',4.62),('325','2013-06-28','13:45:00',4.89),('325','2013-06-28','13:50:00',4.5),('325','2013-06-28','13:55:00',4.33),('325','2013-06-28','14:00:00',3.96),('325','2013-06-28','14:05:00',4.98),('325','2013-06-28','14:10:00',4.26),('325','2013-06-28','14:15:00',4),('325','2013-06-28','14:20:00',4.34),('325','2013-06-28','14:25:00',2.02),('325','2013-06-28','14:30:00',2.74),('325','2013-06-28','14:35:00',4.51),('325','2013-06-28','14:40:00',4.9),('325','2013-06-28','14:45:00',4.87),('325','2013-06-28','14:50:00',4.45),('325','2013-06-28','14:55:00',4.53),('325','2013-06-28','15:00:00',3.41),('325','2013-06-28','15:05:00',4.49),('325','2013-06-28','15:10:00',4.54),('325','2013-06-28','15:15:00',4.6),('325','2013-06-28','15:20:00',4.55),('325','2013-06-28','15:25:00',4.45),('325','2013-06-28','15:30:00',3.91),('325','2013-06-28','15:35:00',3.64),('325','2013-06-28','15:40:00',2.77),('325','2013-06-28','15:45:00',2.72),('325','2013-06-28','15:50:00',3.09),('325','2013-06-28','15:55:00',3.9),('325','2013-06-28','16:00:00',3.89),('325','2013-06-28','16:05:00',2.89),('325','2013-06-28','16:10:00',1.03),('325','2013-06-28','16:15:00',2.52),('325','2013-06-28','16:20:00',3.34),('325','2013-06-28','16:25:00',2.26),('325','2013-06-28','16:30:00',3.97),('325','2013-06-28','16:35:00',1.16),('325','2013-06-28','16:40:00',2.4),('325','2013-06-28','16:45:00',3.04),('325','2013-06-28','16:50:00',3.72),('325','2013-06-28','16:55:00',3.27),('325','2013-06-28','17:00:00',3.11),('325','2013-06-28','17:05:00',2.31),('325','2013-06-28','17:10:00',2.46),('325','2013-06-28','17:15:00',2.68),('325','2013-06-28','17:20:00',2.65),('325','2013-06-28','17:25:00',2.64),('325','2013-06-28','17:30:00',2.55),('325','2013-06-28','17:35:00',2.43),('325','2013-06-28','17:40:00',2.3),('325','2013-06-28','17:45:00',2.23),('325','2013-06-28','17:50:00',2.15),('325','2013-06-28','17:55:00',2.06),('325','2013-06-28','18:00:00',1.93),('325','2013-06-28','18:05:00',1.84),('325','2013-06-28','18:10:00',1.75),('325','2013-06-28','18:15:00',1.63),('325','2013-06-28','18:20:00',1.45),('325','2013-06-28','18:25:00',1.04),('325','2013-06-27','08:15:00',1.02),('325','2013-06-27','08:20:00',1.07),('325','2013-06-27','08:25:00',1.13),('325','2013-06-27','08:30:00',1.18),('325','2013-06-27','08:35:00',1.23),('325','2013-06-27','08:40:00',1.29),('325','2013-06-27','08:45:00',1.33),('325','2013-06-27','08:50:00',1.36),('325','2013-06-27','08:55:00',1.4),('325','2013-06-27','09:00:00',1.41),('325','2013-06-27','09:05:00',1.42),('325','2013-06-27','09:10:00',1.47),('325','2013-06-27','09:15:00',1.49),('325','2013-06-27','09:20:00',1.57),('325','2013-06-27','09:25:00',1.61),('325','2013-06-27','09:30:00',1.66),('325','2013-06-27','09:35:00',2.03),('325','2013-06-27','09:40:00',2.71),('325','2013-06-27','09:45:00',2.79),('325','2013-06-27','09:50:00',2.93),('325','2013-06-27','09:55:00',3.02),('325','2013-06-27','10:00:00',2.86),('325','2013-06-27','10:05:00',2.93),('325','2013-06-27','10:10:00',2.99),('325','2013-06-27','10:15:00',2.96),('325','2013-06-27','10:20:00',3.02),('325','2013-06-27','10:25:00',3.25),('325','2013-06-27','10:30:00',3.44),('325','2013-06-27','10:35:00',3.09),('325','2013-06-27','10:40:00',3.52),('325','2013-06-27','10:45:00',4.03),('325','2013-06-27','10:50:00',3.3),('325','2013-06-27','10:55:00',4.06),('325','2013-06-27','11:00:00',4.16),('325','2013-06-27','11:05:00',4.27),('325','2013-06-27','11:10:00',4.33),('325','2013-06-27','11:15:00',4.37),('325','2013-06-27','11:20:00',4.38),('325','2013-06-27','11:25:00',4.44),('325','2013-06-27','11:30:00',4.4),('325','2013-06-27','11:35:00',4.42),('325','2013-06-27','11:40:00',4.61),('325','2013-06-27','11:45:00',4.64),('325','2013-06-27','11:50:00',4.56),('325','2013-06-27','11:55:00',1.51),('325','2013-06-27','12:00:00',1.57),('325','2013-06-27','12:05:00',1.29),('325','2013-06-27','12:10:00',1.24),('325','2013-06-27','12:15:00',1.08),('325','2013-06-27','12:20:00',1.17),('325','2013-06-27','12:25:00',2.66),('325','2013-06-27','12:30:00',3.06),('325','2013-06-27','12:35:00',4.23),('325','2013-06-27','12:40:00',1.9),('325','2013-06-27','12:45:00',1.82),('325','2013-06-27','12:50:00',1.72),('325','2013-06-27','12:55:00',1.2),('325','2013-06-27','13:00:00',1.06),('325','2013-06-27','13:05:00',1.41),('325','2013-06-27','13:10:00',1.5),('325','2013-06-27','13:15:00',1.61),('325','2013-06-27','13:20:00',1.59),('325','2013-06-27','13:25:00',1.69),('325','2013-06-27','13:30:00',1.48),('325','2013-06-27','13:35:00',1.41),('325','2013-06-27','13:40:00',1.34),('325','2013-06-27','13:45:00',1.55),('325','2013-06-27','13:50:00',1.83),('325','2013-06-27','13:55:00',1.55),('325','2013-06-27','14:00:00',1.54),('325','2013-06-27','14:05:00',1.5),('325','2013-06-27','14:10:00',2.14),('325','2013-06-27','14:15:00',4.56),('325','2013-06-27','14:20:00',2.83),('325','2013-06-27','14:25:00',2.7),('325','2013-06-27','14:30:00',4.04),('325','2013-06-27','14:35:00',3.14),('325','2013-06-27','14:40:00',4.62),('325','2013-06-27','14:45:00',3.92),('325','2013-06-27','14:50:00',1.89),('325','2013-06-27','14:55:00',4.41),('325','2013-06-27','15:00:00',4.28),('325','2013-06-27','15:05:00',4.2),('325','2013-06-27','15:10:00',4.16),('325','2013-06-27','15:15:00',4.11),('325','2013-06-27','15:20:00',4.08),('325','2013-06-27','15:25:00',4.09),('325','2013-06-27','15:30:00',4.02),('325','2013-06-27','15:35:00',3.97),('325','2013-06-27','15:40:00',3.94),('325','2013-06-27','15:45:00',3.87),('325','2013-06-27','15:50:00',3.85),('325','2013-06-27','15:55:00',3.75),('325','2013-06-27','16:00:00',3.65),('325','2013-06-27','16:05:00',3.56),('325','2013-06-27','16:10:00',3.53),('325','2013-06-27','16:15:00',3.51),('325','2013-06-27','16:20:00',3.47),('325','2013-06-27','16:25:00',3.43),('325','2013-06-27','16:30:00',3.37),('325','2013-06-27','16:35:00',3.1),('325','2013-06-27','16:40:00',3.18),('325','2013-06-27','16:45:00',3.17),('325','2013-06-27','16:50:00',3.06),('325','2013-06-27','16:55:00',2.96),('325','2013-06-27','17:00:00',2.9),('325','2013-06-27','17:05:00',2.76),('325','2013-06-27','17:10:00',2.62),('325','2013-06-27','17:15:00',2.54),('325','2013-06-27','17:20:00',2.61),('325','2013-06-27','17:25:00',2.51),('325','2013-06-27','17:30:00',2.45),('325','2013-06-27','17:35:00',2.34),('325','2013-06-27','17:40:00',1.65),('325','2013-06-27','17:45:00',1.11),('325','2013-06-27','17:50:00',2),('325','2013-06-27','17:55:00',1.93),('325','2013-06-27','18:00:00',1.79),('325','2013-06-27','18:05:00',1.72),('325','2013-06-27','18:10:00',1.61),('325','2013-06-27','18:15:00',1.45),('325','2013-06-27','18:20:00',1.3),('325','2013-06-27','18:25:00',1.23),('325','2013-06-27','18:30:00',1.14),('325','2013-06-27','18:35:00',1.02),('325','2013-06-26','08:15:00',1.01),('325','2013-06-26','08:20:00',1.05),('325','2013-06-26','08:25:00',1.12),('325','2013-06-26','08:30:00',1.17),('325','2013-06-26','08:35:00',1.23),('325','2013-06-26','08:40:00',1.29),('325','2013-06-26','08:45:00',1.33),('325','2013-06-26','08:50:00',1.35),('325','2013-06-26','08:55:00',1.35),('325','2013-06-26','09:00:00',1.35),('325','2013-06-26','09:05:00',1.38),('325','2013-06-26','09:10:00',1.44),('325','2013-06-26','09:15:00',1.45),('325','2013-06-26','09:20:00',1.47),('325','2013-06-26','09:25:00',1.77),('325','2013-06-26','09:30:00',2.5),('325','2013-06-26','09:35:00',2.55),('325','2013-06-26','09:40:00',2.63),('325','2013-06-26','09:45:00',2.73),('325','2013-06-26','09:50:00',2.8),('325','2013-06-26','09:55:00',2.81),('325','2013-06-26','10:00:00',2.85),('325','2013-06-26','10:05:00',2.93),('325','2013-06-26','10:10:00',3.04),('325','2013-06-26','10:15:00',3.17),('325','2013-06-26','10:20:00',3.2),('325','2013-06-26','10:25:00',3.19),('325','2013-06-26','10:30:00',3.21),('325','2013-06-26','10:35:00',3.36),('325','2013-06-26','10:40:00',3.45),('325','2013-06-26','10:45:00',3.5),('325','2013-06-26','10:50:00',3.51),('325','2013-06-26','10:55:00',3.52),('325','2013-06-26','11:00:00',3.62),('325','2013-06-26','11:05:00',3.64),('325','2013-06-26','11:10:00',3.71),('325','2013-06-26','11:15:00',3.81),('325','2013-06-26','11:20:00',3.92),('325','2013-06-26','11:25:00',3.99),('325','2013-06-26','11:30:00',3.95),('325','2013-06-26','11:35:00',3.92),('325','2013-06-26','11:40:00',3.87),('325','2013-06-26','11:45:00',3.9),('325','2013-06-26','11:50:00',3.94),('325','2013-06-26','11:55:00',4),('325','2013-06-26','12:00:00',4.1),('325','2013-06-26','12:05:00',4.27),('325','2013-06-26','12:10:00',4.32),('325','2013-06-26','12:15:00',4.41),('325','2013-06-26','12:20:00',4.34),('325','2013-06-26','12:25:00',4.2),('325','2013-06-26','12:30:00',4.16),('325','2013-06-26','12:40:00',3.13),('325','2013-06-26','12:45:00',2.48),('325','2013-06-26','12:50:00',1.09),('325','2013-06-26','12:55:00',1.07),('325','2013-06-26','13:00:00',1.22),('325','2013-06-26','13:05:00',1.16),('325','2013-06-26','13:10:00',2.4),('325','2013-06-26','13:15:00',3.98),('325','2013-06-26','13:20:00',1.13),('325','2013-06-26','13:25:00',1.62),('325','2013-06-26','13:30:00',5.34),('325','2013-06-26','13:35:00',2.49),('325','2013-06-26','13:40:00',1.17),('325','2013-06-26','13:45:00',1.84),('325','2013-06-26','13:50:00',5.32),('325','2013-06-26','13:55:00',1.66),('325','2013-06-26','14:00:00',4.15),('325','2013-06-26','14:05:00',4.67),('325','2013-06-26','14:10:00',4.66),('325','2013-06-26','14:15:00',4.54),('325','2013-06-26','14:20:00',4.51),('325','2013-06-26','14:25:00',4.62),('325','2013-06-26','14:30:00',4.66),('325','2013-06-26','14:35:00',4.41),('325','2013-06-26','14:40:00',4.58),('325','2013-06-26','14:45:00',3.37),('325','2013-06-26','14:50:00',4.59),('325','2013-06-26','14:55:00',4.48),('325','2013-06-26','15:00:00',4.28),('325','2013-06-26','15:05:00',4.28),('325','2013-06-26','15:10:00',4.21),('325','2013-06-26','15:15:00',4.17),('325','2013-06-26','15:20:00',4.16),('325','2013-06-26','15:25:00',4.09),('325','2013-06-26','15:30:00',4.04),('325','2013-06-26','15:35:00',4.04),('325','2013-06-26','15:40:00',3.98),('325','2013-06-26','15:45:00',3.88),('325','2013-06-26','15:50:00',3.88),('325','2013-06-26','15:55:00',3.78),('325','2013-06-26','16:00:00',3.74),('325','2013-06-26','16:05:00',3.71),('325','2013-06-26','16:10:00',3.63),('325','2013-06-26','16:15:00',3.57),('325','2013-06-26','16:20:00',3.51),('325','2013-06-26','16:25:00',3.46),('325','2013-06-26','16:30:00',3.39),('325','2013-06-26','16:35:00',3.31),('325','2013-06-26','16:40:00',3.22),('325','2013-06-26','16:45:00',3.16),('325','2013-06-26','16:50:00',3.08),('325','2013-06-26','16:55:00',3.03),('325','2013-06-26','17:00:00',2.97),('325','2013-06-26','17:05:00',2.85),('325','2013-06-26','17:10:00',2.75),('325','2013-06-26','17:15:00',2.69),('325','2013-06-26','17:20:00',2.59),('325','2013-06-26','17:25:00',2.5),('325','2013-06-26','17:30:00',2.42),('325','2013-06-26','17:35:00',2.34),('325','2013-06-26','17:40:00',2.24),('325','2013-06-26','17:45:00',2.15),('325','2013-06-26','17:50:00',2.05),('325','2013-06-26','17:55:00',1.96),('325','2013-06-26','18:00:00',1.82),('325','2013-06-26','18:05:00',1.81),('325','2013-06-26','18:10:00',2.01),('325','2013-06-26','18:15:00',1.49),('325','2013-06-25','08:25:00',1.14),('325','2013-06-25','08:30:00',1.22),('325','2013-06-25','08:35:00',1.26),('325','2013-06-25','08:40:00',1.32),('325','2013-06-25','08:45:00',1.35),('325','2013-06-25','08:50:00',1.36),('325','2013-06-25','08:55:00',1.37),('325','2013-06-25','09:00:00',1.37),('325','2013-06-25','09:05:00',1.4),('325','2013-06-25','09:10:00',1.45),('325','2013-06-25','09:15:00',1.75),('325','2013-06-25','09:20:00',2.19),('325','2013-06-25','09:25:00',2.14),('325','2013-06-25','09:30:00',2.71),('325','2013-06-25','09:35:00',2.85),('325','2013-06-25','09:40:00',2.94),('325','2013-06-25','09:45:00',2.45),('325','2013-06-25','09:50:00',1.19),('325','2013-06-25','09:55:00',2.22),('325','2013-06-25','10:00:00',2.35),('325','2013-06-25','10:05:00',3.33),('325','2013-06-25','10:10:00',3.67),('325','2013-06-25','10:15:00',3.76),('325','2013-06-25','10:20:00',2.66),('325','2013-06-25','10:30:00',3.74),('325','2013-06-25','10:35:00',4.06),('325','2013-06-25','10:40:00',4.01),('325','2013-06-25','10:45:00',3.68),('325','2013-06-25','10:55:00',3.53),('325','2013-06-25','11:00:00',1.85),('325','2013-06-25','11:05:00',2.65),('325','2013-06-25','11:10:00',2.03),('325','2013-06-25','11:15:00',2.3),('325','2013-06-25','11:20:00',1.11),('325','2013-06-25','11:25:00',1.1),('325','2013-06-25','11:30:00',1.13),('325','2013-06-25','11:35:00',2.93),('325','2013-06-25','11:40:00',5.34),('325','2013-06-25','11:45:00',4.32),('325','2013-06-25','11:50:00',4.67),('325','2013-06-25','11:55:00',1.6),('325','2013-06-25','12:00:00',1.12),('325','2013-06-25','12:05:00',1.01),('325','2013-06-25','12:10:00',1.1),('325','2013-06-25','12:15:00',1.1),('325','2013-06-25','12:20:00',1.34),('325','2013-06-25','12:25:00',1.41),('325','2013-06-25','12:30:00',1.58),('325','2013-06-25','12:35:00',3.8),('325','2013-06-25','12:40:00',2.09),('325','2013-06-25','12:45:00',5.07),('325','2013-06-25','12:50:00',2.02),('325','2013-06-25','12:55:00',1.96),('325','2013-06-25','13:00:00',4.49),('325','2013-06-25','13:05:00',3.21),('325','2013-06-25','13:10:00',3.41),('325','2013-06-25','13:15:00',4.76),('325','2013-06-25','13:20:00',4.32),('325','2013-06-25','13:25:00',3.72),('325','2013-06-25','13:30:00',4.15),('325','2013-06-25','13:35:00',4.04),('325','2013-06-25','13:40:00',5.03),('325','2013-06-25','13:45:00',4.69),('325','2013-06-25','13:50:00',3.95),('325','2013-06-25','13:55:00',4.43),('325','2013-06-25','14:00:00',4.1),('325','2013-06-25','14:05:00',4.7),('325','2013-06-25','14:10:00',4.71),('325','2013-06-25','14:15:00',4.71),('325','2013-06-25','14:20:00',4.43),('325','2013-06-25','14:25:00',4.49),('325','2013-06-25','14:30:00',4.39),('325','2013-06-25','14:35:00',4.29),('325','2013-06-25','14:40:00',4.45),('325','2013-06-25','14:45:00',4.44),('325','2013-06-25','14:50:00',4.41),('325','2013-06-25','14:55:00',4.36),('325','2013-06-25','15:00:00',4.31),('325','2013-06-25','15:05:00',4.29),('325','2013-06-25','15:10:00',4.24),('325','2013-06-25','15:15:00',4.21),('325','2013-06-25','15:20:00',4.16),('325','2013-06-25','15:25:00',4.1),('325','2013-06-25','15:30:00',4.05),('325','2013-06-25','15:35:00',4.01),('325','2013-06-25','15:40:00',3.96),('325','2013-06-25','15:45:00',3.88),('325','2013-06-25','15:50:00',3.84),('325','2013-06-25','15:55:00',3.78),('325','2013-06-25','16:00:00',3.72),('325','2013-06-25','16:05:00',3.67),('325','2013-06-25','16:10:00',3.61),('325','2013-06-25','16:15:00',3.55),('325','2013-06-25','16:20:00',3.5),('325','2013-06-25','16:25:00',3.44),('325','2013-06-25','16:30:00',3.4),('325','2013-06-25','16:35:00',3.32),('325','2013-06-25','16:40:00',3.24),('325','2013-06-25','16:45:00',3.16),('325','2013-06-25','16:50:00',3.09),('325','2013-06-25','16:55:00',3.02),('325','2013-06-25','17:00:00',2.93),('325','2013-06-25','17:05:00',2.81),('325','2013-06-25','17:10:00',2.68),('325','2013-06-25','17:15:00',2.66),('325','2013-06-25','17:20:00',2.6),('325','2013-06-25','17:25:00',2.5),('325','2013-06-25','17:30:00',2.42),('325','2013-06-25','17:35:00',2.33),('325','2013-06-25','17:40:00',2.24),('325','2013-06-25','17:45:00',2.14),('325','2013-06-25','17:50:00',2.05),('325','2013-06-25','17:55:00',1.95),('325','2013-06-25','18:00:00',1.82),('325','2013-06-25','18:05:00',1.75),('325','2013-06-25','18:10:00',1.64),('325','2013-06-25','18:15:00',1.48),('325','2013-06-25','18:20:00',1.32),('325','2013-06-25','18:25:00',1.21),('325','2013-06-25','18:30:00',1.12),('325','2013-06-25','18:35:00',1.01),('325','2013-06-24','08:40:00',1.27),('325','2013-06-24','08:45:00',1.45),('325','2013-06-24','08:50:00',1.46),('325','2013-06-24','08:55:00',1.43),('325','2013-06-24','09:00:00',1.47),('325','2013-06-24','09:05:00',1.47),('325','2013-06-24','09:10:00',1.42),('325','2013-06-24','09:15:00',2.25),('325','2013-06-24','09:20:00',2.42),('325','2013-06-24','09:25:00',3.31),('325','2013-06-24','09:30:00',1.79),('325','2013-06-24','09:35:00',2.21),('325','2013-06-24','09:40:00',3.19),('325','2013-06-24','09:45:00',2.84),('325','2013-06-24','09:50:00',3.31),('325','2013-06-24','09:55:00',3.25),('325','2013-06-24','10:00:00',3.32),('325','2013-06-24','10:05:00',3.43),('325','2013-06-24','10:10:00',3.57),('325','2013-06-24','10:15:00',3.16),('325','2013-06-24','10:20:00',3.85),('325','2013-06-24','10:25:00',4.09),('325','2013-06-24','10:30:00',3.56),('325','2013-06-24','10:35:00',3.22),('325','2013-06-24','10:40:00',1.55),('325','2013-06-24','10:45:00',1.97),('325','2013-06-24','10:50:00',4.05),('325','2013-06-24','10:55:00',2.81),('325','2013-06-24','11:00:00',3.37),('325','2013-06-24','11:05:00',4.21),('325','2013-06-24','11:10:00',1.42),('325','2013-06-24','11:15:00',4.99),('325','2013-06-24','11:20:00',3.35),('325','2013-06-24','11:25:00',1.91),('325','2013-06-24','11:30:00',2.29),('325','2013-06-24','11:35:00',1.44),('325','2013-06-24','11:40:00',1.29),('325','2013-06-24','11:45:00',2.76),('325','2013-06-24','11:50:00',2.02),('325','2013-06-24','11:55:00',5.02),('325','2013-06-24','12:00:00',2.67),('325','2013-06-24','12:05:00',3.91),('325','2013-06-24','12:10:00',5.11),('325','2013-06-24','12:15:00',2.43),('325','2013-06-24','12:20:00',5.65),('325','2013-06-24','12:25:00',3.92),('325','2013-06-24','12:30:00',3.42),('325','2013-06-24','12:35:00',5.45),('325','2013-06-24','12:40:00',3.79),('325','2013-06-24','12:45:00',3.88),('325','2013-06-24','12:50:00',4.27),('325','2013-06-24','12:55:00',5.11),('325','2013-06-24','13:00:00',5.06),('325','2013-06-24','13:05:00',5.44),('325','2013-06-24','13:10:00',3.68),('325','2013-06-24','13:15:00',3.7),('325','2013-06-24','13:20:00',2.26),('325','2013-06-24','13:25:00',4.68),('325','2013-06-24','13:30:00',4.83),('325','2013-06-24','13:35:00',3.74),('325','2013-06-24','13:40:00',4.46),('325','2013-06-24','13:45:00',4.98),('325','2013-06-24','13:50:00',4.85),('325','2013-06-24','13:55:00',4.73),('325','2013-06-24','14:00:00',4.18),('325','2013-06-24','14:05:00',4.74),('325','2013-06-24','14:10:00',4.72),('325','2013-06-24','14:15:00',4.72),('325','2013-06-24','14:20:00',4.66),('325','2013-06-24','14:25:00',4.7),('325','2013-06-24','14:30:00',4.68),('325','2013-06-24','14:35:00',4.69),('325','2013-06-24','14:40:00',4.7),('325','2013-06-24','14:45:00',4.79),('325','2013-06-24','14:50:00',4.29),('325','2013-06-24','14:55:00',3.2),('325','2013-06-24','15:00:00',4.2),('325','2013-06-24','15:05:00',2.33),('325','2013-06-24','15:10:00',3.57),('325','2013-06-24','15:15:00',4.4),('325','2013-06-24','15:20:00',3.83),('325','2013-06-24','15:25:00',4.17),('325','2013-06-24','15:30:00',3.59),('325','2013-06-24','15:35:00',1.78),('325','2013-06-24','15:40:00',3.25),('325','2013-06-24','15:45:00',2.88),('325','2013-06-24','15:50:00',3.69),('325','2013-06-24','15:55:00',3.66),('325','2013-06-24','16:00:00',4.4),('325','2013-06-24','16:05:00',4),('325','2013-06-24','16:10:00',2.82),('325','2013-06-24','16:15:00',3.74),('325','2013-06-24','16:20:00',3.01),('325','2013-06-24','16:25:00',2.81),('325','2013-06-24','16:30:00',3.71),('325','2013-06-24','16:35:00',2.65),('325','2013-06-24','16:40:00',2.62),('325','2013-06-24','16:45:00',2.04),('325','2013-06-24','16:50:00',2.22),('325','2013-06-24','16:55:00',1.54),('325','2013-06-24','17:00:00',1.65),('325','2013-06-24','17:05:00',2.56),('325','2013-06-24','17:10:00',3.32),('325','2013-06-24','17:15:00',2.93),('325','2013-06-24','17:20:00',2.15),('325','2013-06-24','17:25:00',2.39),('325','2013-06-24','17:30:00',1.9),('325','2013-06-24','17:50:00',1.74),('325','2013-06-24','17:55:00',1.43),('325','2013-06-24','18:00:00',2.22),('325','2013-06-24','18:05:00',1.73),('325','2013-06-24','18:10:00',1.62),('325','2013-06-24','18:15:00',1.67),('325','2013-06-24','18:20:00',1.5),('325','2013-06-24','18:25:00',1.43),('325','2013-06-24','18:35:00',1.03),('325','2013-06-23','08:50:00',1.09),('325','2013-06-23','08:55:00',1.05),('325','2013-06-23','09:00:00',1.51),('325','2013-06-23','09:05:00',1.16),('325','2013-06-23','09:20:00',1.23),('325','2013-06-23','09:25:00',2.45),('325','2013-06-23','09:30:00',2.68),('325','2013-06-23','09:35:00',2.8),('325','2013-06-23','09:40:00',3.29),('325','2013-06-23','09:45:00',1.72),('325','2013-06-23','09:50:00',1.15),('325','2013-06-23','09:55:00',2.14),('325','2013-06-23','10:00:00',2.43),('325','2013-06-23','10:05:00',1.87),('325','2013-06-23','10:10:00',1.94),('325','2013-06-23','10:15:00',2.63),('325','2013-06-23','10:20:00',1.84),('325','2013-06-23','10:25:00',3.21),('325','2013-06-23','10:30:00',3.16),('325','2013-06-23','10:35:00',3.56),('325','2013-06-23','10:40:00',3.76),('325','2013-06-23','10:45:00',3.67),('325','2013-06-23','10:50:00',3.69),('325','2013-06-23','10:55:00',3.79),('325','2013-06-23','11:00:00',3.86),('325','2013-06-23','11:05:00',3.92),('325','2013-06-23','11:10:00',3.94),('325','2013-06-23','11:15:00',2.81),('325','2013-06-23','11:20:00',4.2),('325','2013-06-23','11:25:00',4.22),('325','2013-06-23','11:30:00',4.09),('325','2013-06-23','11:35:00',4.17),('325','2013-06-23','11:40:00',4.17),('325','2013-06-23','11:45:00',4.31),('325','2013-06-23','11:50:00',4.23),('325','2013-06-23','11:55:00',4.31),('325','2013-06-23','12:00:00',4.44),('325','2013-06-23','12:05:00',4.45),('325','2013-06-23','12:10:00',4.48),('325','2013-06-23','12:15:00',4.45),('325','2013-06-23','12:20:00',4.41),('325','2013-06-23','12:25:00',4.54),('325','2013-06-23','12:30:00',4.53),('325','2013-06-23','12:35:00',4.56),('325','2013-06-23','12:40:00',4.6),('325','2013-06-23','12:45:00',4.61),('325','2013-06-23','12:50:00',4.62),('325','2013-06-23','12:55:00',4.59),('325','2013-06-23','13:00:00',4.6),('325','2013-06-23','13:05:00',4.63),('325','2013-06-23','13:10:00',4.62),('325','2013-06-23','13:15:00',4.61),('325','2013-06-23','13:20:00',4.64),('325','2013-06-23','13:25:00',4.64),('325','2013-06-23','13:30:00',4.64),('325','2013-06-23','13:35:00',4.67),('325','2013-06-23','13:40:00',4.65),('325','2013-06-23','13:45:00',4.63),('325','2013-06-23','13:50:00',4.57),('325','2013-06-23','13:55:00',4.55),('325','2013-06-23','14:00:00',4.54),('325','2013-06-23','14:05:00',4.51),('325','2013-06-23','14:10:00',4.5),('325','2013-06-23','14:15:00',4.48),('325','2013-06-23','14:20:00',4.47),('325','2013-06-23','14:25:00',4.47),('325','2013-06-23','14:30:00',4.44),('325','2013-06-23','14:35:00',4.42),('325','2013-06-23','14:40:00',4.41),('325','2013-06-23','14:45:00',4.41),('325','2013-06-23','14:50:00',4.4),('325','2013-06-23','14:55:00',4.39),('325','2013-06-23','15:00:00',4.38),('325','2013-06-23','15:05:00',4.34),('325','2013-06-23','15:10:00',4.3),('325','2013-06-23','15:15:00',4.26),('325','2013-06-23','15:20:00',4.22),('325','2013-06-23','15:25:00',4.15),('325','2013-06-23','15:30:00',4.08),('325','2013-06-23','15:35:00',4.04),('325','2013-06-23','15:40:00',4),('325','2013-06-23','15:45:00',3.98),('325','2013-06-23','15:50:00',3.91),('325','2013-06-23','15:55:00',3.85),('325','2013-06-23','16:00:00',3.8),('325','2013-06-23','16:05:00',3.74),('325','2013-06-23','16:10:00',3.66),('325','2013-06-23','16:15:00',3.6),('325','2013-06-23','16:20:00',3.53),('325','2013-06-23','16:25:00',3.5),('325','2013-06-23','16:30:00',3.42),('325','2013-06-23','16:35:00',3.4),('325','2013-06-23','16:40:00',3.32),('325','2013-06-23','16:45:00',3.24),('325','2013-06-23','16:50:00',3.17),('325','2013-06-23','16:55:00',3.08),('325','2013-06-23','17:00:00',2.98),('325','2013-06-23','17:05:00',2.86),('325','2013-06-23','17:10:00',2.81),('325','2013-06-23','17:15:00',2.74),('325','2013-06-23','17:20:00',2.56),('325','2013-06-23','17:25:00',2.51),('325','2013-06-23','17:30:00',2.49),('325','2013-06-23','17:35:00',2.39),('325','2013-06-23','17:40:00',2.31),('325','2013-06-23','17:45:00',2.22),('325','2013-06-23','17:50:00',2.16),('325','2013-06-23','17:55:00',2.02),('325','2013-06-23','18:00:00',1.91),('325','2013-06-23','18:05:00',1.84),('325','2013-06-23','18:10:00',1.72),('325','2013-06-23','18:15:00',1.51),('325','2013-06-23','18:20:00',1.36),('325','2013-06-23','18:25:00',1.28),('325','2013-06-23','18:30:00',1.15),('325','2013-06-23','18:35:00',1.07),('325','2013-06-23','18:40:00',1.03),('325','2013-06-22','08:20:00',1.02),('325','2013-06-22','08:25:00',1.09),('325','2013-06-22','08:30:00',1.14),('325','2013-06-22','08:35:00',1.21),('325','2013-06-22','08:40:00',1.27),('325','2013-06-22','08:45:00',1.3),('325','2013-06-22','08:50:00',1.33),('325','2013-06-22','08:55:00',1.34),('325','2013-06-22','09:00:00',1.39),('325','2013-06-22','09:05:00',1.44),('325','2013-06-22','09:10:00',1.48),('325','2013-06-22','09:15:00',1.53),('325','2013-06-22','09:20:00',1.58),('325','2013-06-22','09:25:00',2.03),('325','2013-06-22','09:30:00',2.48),('325','2013-06-22','09:35:00',2.52),('325','2013-06-22','09:40:00',2.57),('325','2013-06-22','09:45:00',2.64),('325','2013-06-22','09:50:00',2.74),('325','2013-06-22','09:55:00',2.74),('325','2013-06-22','10:00:00',2.78),('325','2013-06-22','10:05:00',2.88),('325','2013-06-22','10:10:00',2.94),('325','2013-06-22','10:15:00',3.04),('325','2013-06-22','10:20:00',3.09),('325','2013-06-22','10:25:00',3.08),('325','2013-06-22','10:30:00',3.11),('325','2013-06-22','10:35:00',3.17),('325','2013-06-22','10:40:00',3.29),('325','2013-06-22','10:45:00',3.41),('325','2013-06-22','10:50:00',3.45),('325','2013-06-22','10:55:00',3.44),('325','2013-06-22','11:00:00',3.52),('325','2013-06-22','11:05:00',3.56),('325','2013-06-22','11:10:00',3.65),('325','2013-06-22','11:15:00',3.75),('325','2013-06-22','11:20:00',3.87),('325','2013-06-22','11:25:00',3.91),('325','2013-06-22','11:30:00',3.91),('325','2013-06-22','11:35:00',3.88),('325','2013-06-22','11:40:00',3.85),('325','2013-06-22','11:45:00',3.89),('325','2013-06-22','11:50:00',3.89),('325','2013-06-22','11:55:00',3.93),('325','2013-06-22','12:00:00',4.05),('325','2013-06-22','12:05:00',4.07),('325','2013-06-22','12:10:00',4.1),('325','2013-06-22','12:15:00',4.3),('325','2013-06-22','12:20:00',4.23),('325','2013-06-22','12:25:00',4.19),('325','2013-06-22','12:30:00',4.14),('325','2013-06-22','12:35:00',4.14),('325','2013-06-22','12:40:00',4.1),('325','2013-06-22','12:45:00',4.33),('325','2013-06-22','12:50:00',4.31),('325','2013-06-22','12:55:00',4.29),('325','2013-06-22','13:00:00',4.22),('325','2013-06-22','13:05:00',4.25),('325','2013-06-22','13:10:00',4.26),('325','2013-06-22','13:15:00',4.21),('325','2013-06-22','13:20:00',4.19),('325','2013-06-22','13:25:00',4.51),('325','2013-06-22','13:30:00',4.64),('325','2013-06-22','13:35:00',4.64),('325','2013-06-22','13:40:00',4.1),('325','2013-06-22','13:45:00',4.46),('325','2013-06-22','13:50:00',4.44),('325','2013-06-22','13:55:00',3.03),('325','2013-06-22','14:00:00',3.01),('325','2013-06-22','14:05:00',4.7),('325','2013-06-22','14:10:00',4.47),('325','2013-06-22','14:15:00',4.34),('325','2013-06-22','14:20:00',3.69),('325','2013-06-22','14:25:00',4.39),('325','2013-06-22','14:30:00',3.06),('325','2013-06-22','14:35:00',2.45),('325','2013-06-22','14:40:00',1.83),('325','2013-06-22','14:45:00',2.52),('325','2013-06-22','14:50:00',3.69),('325','2013-06-22','14:55:00',4.14),('325','2013-06-22','15:00:00',4.02),('325','2013-06-22','15:05:00',3.13),('325','2013-06-22','15:10:00',4.09),('325','2013-06-22','15:15:00',4.18),('325','2013-06-22','15:20:00',3.82),('325','2013-06-22','15:25:00',3.59),('325','2013-06-22','15:30:00',2.67),('325','2013-06-22','15:35:00',2.04),('325','2013-06-22','15:40:00',2.62),('325','2013-06-22','15:45:00',3.19),('325','2013-06-22','15:50:00',2.74),('325','2013-06-22','15:55:00',2.76),('325','2013-06-22','16:00:00',1.9),('325','2013-06-22','16:05:00',1.27),('325','2013-06-22','16:10:00',1.34),('325','2013-06-22','16:15:00',1.73),('325','2013-06-22','16:20:00',1.92),('325','2013-06-22','16:25:00',1.29),('325','2013-06-22','16:30:00',1.03),('325','2013-06-22','16:55:00',1.38),('325','2013-06-22','17:00:00',1.65),('325','2013-06-22','17:05:00',1.55),('325','2013-06-22','17:10:00',2.25),('325','2013-06-22','17:15:00',3.09),('325','2013-06-22','17:20:00',2.86),('325','2013-06-22','17:25:00',2.94),('325','2013-06-22','17:30:00',2.43),('325','2013-06-22','17:35:00',2.01),('325','2013-06-22','17:40:00',2.32),('325','2013-06-22','17:45:00',2.31),('325','2013-06-22','17:50:00',2.06),('325','2013-06-22','17:55:00',2.04),('325','2013-06-22','18:00:00',1.8),('325','2013-06-22','18:05:00',1.49),('325','2013-06-22','18:10:00',1.02),('325','2013-06-22','18:15:00',1.04),('325','2013-06-21','08:20:00',1.01),('325','2013-06-21','08:25:00',1.08),('325','2013-06-21','08:30:00',1.13),('325','2013-06-21','08:35:00',1.2),('325','2013-06-21','08:40:00',1.24),('325','2013-06-21','08:45:00',1.28),('325','2013-06-21','08:50:00',1.31),('325','2013-06-21','08:55:00',1.33),('325','2013-06-21','09:00:00',1.38),('325','2013-06-21','09:05:00',1.41),('325','2013-06-21','09:10:00',1.46),('325','2013-06-21','09:15:00',1.82),('325','2013-06-21','09:20:00',2.22),('325','2013-06-21','09:25:00',2.32),('325','2013-06-21','09:30:00',2.39),('325','2013-06-21','09:35:00',2.42),('325','2013-06-21','09:40:00',2.47),('325','2013-06-21','09:45:00',2.56),('325','2013-06-21','09:50:00',2.61),('325','2013-06-21','09:55:00',2.64),('325','2013-06-21','10:00:00',2.65),('325','2013-06-21','10:05:00',2.72),('325','2013-06-21','10:10:00',2.8),('325','2013-06-21','10:15:00',2.9),('325','2013-06-21','10:20:00',2.9),('325','2013-06-21','10:25:00',2.92),('325','2013-06-21','10:30:00',2.97),('325','2013-06-21','10:35:00',3.01),('325','2013-06-21','10:40:00',3.09),('325','2013-06-21','10:45:00',3.2),('325','2013-06-21','10:50:00',3.22),('325','2013-06-21','10:55:00',3.21),('325','2013-06-21','11:00:00',3.25),('325','2013-06-21','11:05:00',3.31),('325','2013-06-21','11:10:00',3.38),('325','2013-06-21','11:15:00',3.51),('325','2013-06-21','11:20:00',3.62),('325','2013-06-21','11:25:00',3.7),('325','2013-06-21','11:30:00',3.69),('325','2013-06-21','11:35:00',3.66),('325','2013-06-21','11:40:00',3.63),('325','2013-06-21','11:45:00',3.64),('325','2013-06-21','11:50:00',3.66),('325','2013-06-21','11:55:00',3.73),('325','2013-06-21','12:00:00',3.77),('325','2013-06-21','12:05:00',3.88),('325','2013-06-21','12:10:00',3.97),('325','2013-06-21','12:15:00',4),('325','2013-06-21','12:20:00',4),('325','2013-06-21','12:25:00',3.92),('325','2013-06-21','12:30:00',3.85),('325','2013-06-21','12:35:00',3.82),('325','2013-06-21','12:40:00',3.81),('325','2013-06-21','12:45:00',3.81),('325','2013-06-21','12:50:00',3.86),('325','2013-06-21','12:55:00',3.91),('325','2013-06-21','13:00:00',3.92),('325','2013-06-21','13:05:00',3.97),('325','2013-06-21','13:10:00',4.01),('325','2013-06-21','13:15:00',4),('325','2013-06-21','13:20:00',4),('325','2013-06-21','13:25:00',3.93),('325','2013-06-21','13:30:00',3.96),('325','2013-06-21','13:35:00',3.96),('325','2013-06-21','13:40:00',3.98),('325','2013-06-21','13:45:00',3.99),('325','2013-06-21','13:50:00',4),('325','2013-06-21','13:55:00',4.1),('325','2013-06-21','14:00:00',4.08),('325','2013-06-21','14:05:00',4.05),('325','2013-06-21','14:10:00',3.98),('325','2013-06-21','14:15:00',3.96),('325','2013-06-21','14:20:00',3.97),('325','2013-06-21','14:25:00',3.97),('325','2013-06-21','14:30:00',3.93),('325','2013-06-21','14:35:00',3.97),('325','2013-06-21','14:40:00',4.14),('325','2013-06-21','14:45:00',4.13),('325','2013-06-21','14:50:00',4.13),('325','2013-06-21','14:55:00',4.12),('325','2013-06-21','15:00:00',4.09),('325','2013-06-21','15:05:00',4.06),('325','2013-06-21','15:10:00',4.03),('325','2013-06-21','15:15:00',4.01),('325','2013-06-21','15:20:00',3.96),('325','2013-06-21','15:25:00',3.91),('325','2013-06-21','15:30:00',3.88),('325','2013-06-21','15:35:00',3.83),('325','2013-06-21','15:40:00',3.79),('325','2013-06-21','15:45:00',3.73),('325','2013-06-21','15:50:00',3.66),('325','2013-06-21','15:55:00',3.62),('325','2013-06-21','16:00:00',3.56),('325','2013-06-21','16:05:00',3.51),('325','2013-06-21','16:10:00',3.47),('325','2013-06-21','16:15:00',3.41),('325','2013-06-21','16:20:00',3.38),('325','2013-06-21','16:25:00',3.33),('325','2013-06-21','16:30:00',3.27),('325','2013-06-21','16:35:00',3.21),('325','2013-06-21','16:40:00',3.13),('325','2013-06-21','16:45:00',3.07),('325','2013-06-21','16:50:00',3),('325','2013-06-21','16:55:00',2.93),('325','2013-06-21','17:00:00',2.84),('325','2013-06-21','17:05:00',2.72),('325','2013-06-21','17:10:00',2.61),('325','2013-06-21','17:15:00',2.59),('325','2013-06-21','17:20:00',2.5),('325','2013-06-21','17:25:00',2.42),('325','2013-06-21','17:30:00',2.34),('325','2013-06-21','17:35:00',2.25),('325','2013-06-21','17:40:00',2.17),('325','2013-06-21','17:45:00',2.08),('325','2013-06-21','17:50:00',1.99),('325','2013-06-21','17:55:00',1.88),('325','2013-06-21','18:00:00',1.77),('325','2013-06-21','18:05:00',1.71),('325','2013-06-21','18:10:00',1.6),('325','2013-06-21','18:15:00',1.41),('325','2013-06-21','18:20:00',1.25),('325','2013-06-21','18:25:00',1.16),('325','2013-06-21','18:30:00',1.05),('325','2013-06-20','08:20:00',1),('325','2013-06-20','08:25:00',1.06),('325','2013-06-20','08:30:00',1.11),('325','2013-06-20','08:35:00',1.18),('325','2013-06-20','08:40:00',1.22),('325','2013-06-20','08:45:00',1.26),('325','2013-06-20','08:50:00',1.27),('325','2013-06-20','08:55:00',1.29),('325','2013-06-20','09:00:00',1.35),('325','2013-06-20','09:05:00',1.39),('325','2013-06-20','09:10:00',1.43),('325','2013-06-20','09:15:00',1.46),('325','2013-06-20','09:20:00',1.5),('325','2013-06-20','09:25:00',2.08),('325','2013-06-20','09:30:00',2.43),('325','2013-06-20','09:35:00',2.46),('325','2013-06-20','09:40:00',2.54),('325','2013-06-20','09:45:00',2.61),('325','2013-06-20','09:50:00',2.66),('325','2013-06-20','09:55:00',2.69),('325','2013-06-20','10:00:00',2.71),('325','2013-06-20','10:05:00',2.78),('325','2013-06-20','10:10:00',2.86),('325','2013-06-20','10:15:00',2.95),('325','2013-06-20','10:20:00',2.99),('325','2013-06-20','10:25:00',3.03),('325','2013-06-20','10:30:00',3.15),('325','2013-06-20','10:35:00',3.22),('325','2013-06-20','10:40:00',3.27),('325','2013-06-20','10:45:00',3.29),('325','2013-06-20','10:50:00',3.27),('325','2013-06-20','10:55:00',3.29),('325','2013-06-20','11:00:00',3.39),('325','2013-06-20','11:05:00',3.46),('325','2013-06-20','11:10:00',3.51),('325','2013-06-20','11:15:00',3.53),('325','2013-06-20','11:20:00',3.58),('325','2013-06-20','11:25:00',3.62),('325','2013-06-20','11:30:00',3.63),('325','2013-06-20','11:35:00',3.68),('325','2013-06-20','11:40:00',3.68),('325','2013-06-20','11:45:00',3.67),('325','2013-06-20','11:50:00',3.6),('325','2013-06-20','11:55:00',3.61),('325','2013-06-20','12:00:00',3.61),('325','2013-06-20','12:05:00',3.79),('325','2013-06-20','12:10:00',3.6),('325','2013-06-20','12:15:00',3.76),('325','2013-06-20','12:20:00',3.22),('325','2013-06-20','12:25:00',3.86),('325','2013-06-20','12:30:00',4.23),('325','2013-06-20','12:35:00',4.26),('325','2013-06-20','12:40:00',4.18),('325','2013-06-20','12:45:00',3.43),('325','2013-06-20','12:50:00',3.97),('325','2013-06-20','12:55:00',4.17),('325','2013-06-20','13:00:00',4.38),('325','2013-06-20','13:05:00',4.31),('325','2013-06-20','13:10:00',3.78),('325','2013-06-20','13:15:00',1.94),('325','2013-06-20','13:20:00',4.35),('325','2013-06-20','13:25:00',4.23),('325','2013-06-20','13:30:00',3.88),('325','2013-06-20','13:35:00',4.29),('325','2013-06-20','13:40:00',4.29),('325','2013-06-20','13:45:00',4.33),('325','2013-06-20','13:50:00',4.31),('325','2013-06-20','13:55:00',4.18),('325','2013-06-20','14:00:00',4.17),('325','2013-06-20','14:05:00',4.1),('325','2013-06-20','14:10:00',4.11),('325','2013-06-20','14:15:00',4.29),('325','2013-06-20','14:20:00',4.31),('325','2013-06-20','14:25:00',4.3),('325','2013-06-20','14:30:00',4.32),('325','2013-06-20','14:35:00',4.33),('325','2013-06-20','14:40:00',4.33),('325','2013-06-20','14:45:00',4.3),('325','2013-06-20','14:50:00',4.28),('325','2013-06-20','14:55:00',4.25),('325','2013-06-20','15:00:00',4.22),('325','2013-06-20','15:05:00',4.16),('325','2013-06-20','15:10:00',4.12),('325','2013-06-20','15:15:00',4.09),('325','2013-06-20','15:20:00',4.03),('325','2013-06-20','15:25:00',4),('325','2013-06-20','15:30:00',3.93),('325','2013-06-20','15:35:00',3.89),('325','2013-06-20','15:40:00',3.86),('325','2013-06-20','15:45:00',3.81),('325','2013-06-20','15:50:00',3.76),('325','2013-06-20','15:55:00',3.68),('325','2013-06-20','16:00:00',3.64),('325','2013-06-20','16:05:00',3.59),('325','2013-06-20','16:10:00',3.54),('325','2013-06-20','16:15:00',3.49),('325','2013-06-20','16:20:00',3.43),('325','2013-06-20','16:25:00',3.39),('325','2013-06-20','16:30:00',3.32),('325','2013-06-20','16:35:00',3.25),('325','2013-06-20','16:40:00',3.16),('325','2013-06-20','16:45:00',3.09),('325','2013-06-20','16:50:00',3.03),('325','2013-06-20','16:55:00',2.97),('325','2013-06-20','17:00:00',2.88),('325','2013-06-20','17:05:00',2.73),('325','2013-06-20','17:10:00',2.59),('325','2013-06-20','17:15:00',2.59),('325','2013-06-20','17:20:00',2.52),('325','2013-06-20','17:25:00',2.43),('325','2013-06-20','17:30:00',2.36),('325','2013-06-20','17:35:00',2.28),('325','2013-06-20','17:40:00',2.21),('325','2013-06-20','17:45:00',2.12),('325','2013-06-20','17:50:00',2.03),('325','2013-06-20','17:55:00',1.91),('325','2013-06-20','18:00:00',1.79),('325','2013-06-20','18:05:00',1.73),('325','2013-06-20','18:10:00',1.62),('325','2013-06-20','18:15:00',1.44),('325','2013-06-20','18:20:00',1.27),('325','2013-06-20','18:25:00',1.17),('325','2013-06-20','18:30:00',1.07),('325','2013-06-20','18:35:00',1),('325','2014-04-03','08:55:00',1.04),('325','2014-04-03','09:00:00',1.15),('325','2014-04-03','09:05:00',1.25),('325','2014-04-03','09:10:00',1.21),('325','2014-04-03','09:15:00',1.15),('325','2014-04-03','09:20:00',1.17),('325','2014-04-03','09:25:00',1.25),('325','2014-04-03','09:30:00',1.43),('325','2014-04-03','09:35:00',1.63),('325','2014-04-03','09:40:00',1.69),('325','2014-04-03','09:45:00',1.66),('325','2014-04-03','09:50:00',1.57),('325','2014-04-03','09:55:00',1.63),('325','2014-04-03','10:00:00',1.84),('325','2014-04-03','10:05:00',2.05),('325','2014-04-03','10:10:00',2.13),('325','2014-04-03','10:15:00',2.4),('325','2014-04-03','10:20:00',2.48),('325','2014-04-03','10:25:00',2.35),('325','2014-04-03','10:30:00',2.32),('325','2014-04-03','10:35:00',2.5),('325','2014-04-03','10:40:00',2.26),('325','2014-04-03','10:45:00',2.49),('325','2014-04-03','10:50:00',2.14),('325','2014-04-03','10:55:00',2.24),('325','2014-04-03','11:00:00',2.07),('325','2014-04-03','11:05:00',1.72),('325','2014-04-03','11:10:00',1.62),('325','2014-04-03','11:15:00',1.5),('325','2014-04-03','11:20:00',1.42),('325','2014-04-03','11:25:00',1.32),('325','2014-04-03','11:30:00',1.34),('325','2014-04-03','11:35:00',1.45),('325','2014-04-03','11:40:00',1.6),('325','2014-04-03','11:45:00',1.86),('325','2014-04-03','11:50:00',2.3),('325','2014-04-03','11:55:00',2.51),('325','2014-04-03','12:00:00',2.37),('325','2014-04-03','12:05:00',2.4),('325','2014-04-03','12:10:00',2.3),('325','2014-04-03','12:15:00',2.25),('325','2014-04-03','12:20:00',2.57),('325','2014-04-03','12:25:00',3.25),('325','2014-04-03','12:30:00',4.2),('325','2014-04-03','12:35:00',4.04),('325','2014-04-03','12:40:00',4.44),('325','2014-04-03','12:45:00',2.45),('325','2014-04-03','12:50:00',3.03),('325','2014-04-03','12:55:00',2.88),('325','2014-04-03','13:00:00',2.71),('325','2014-04-03','13:05:00',3.59),('325','2014-04-03','13:10:00',2.74),('325','2014-04-03','13:15:00',4.78),('325','2014-04-03','13:20:00',2.83),('325','2014-04-03','13:25:00',2.97),('325','2014-04-03','13:30:00',3.13),('325','2014-04-03','13:35:00',5.01),('325','2014-04-03','13:40:00',4.2),('325','2014-04-03','13:45:00',2.31),('325','2014-04-03','13:50:00',2.33),('325','2014-04-03','13:55:00',2.84),('325','2014-04-03','14:00:00',4),('325','2014-04-03','14:05:00',3.76),('325','2014-04-03','14:10:00',2.95),('325','2014-04-03','14:15:00',3.93),('325','2014-04-03','14:20:00',4.06),('325','2014-04-03','14:25:00',4.24),('325','2014-04-03','14:30:00',4.32),('325','2014-04-03','14:35:00',4.35),('325','2014-04-03','14:40:00',4.2),('325','2014-04-03','14:45:00',4.09),('325','2014-04-03','14:50:00',4.02),('325','2014-04-03','14:55:00',3.95),('325','2014-04-03','15:00:00',3.88),('325','2014-04-03','15:05:00',3.84),('325','2014-04-03','15:10:00',3.81),('325','2014-04-03','15:15:00',3.81),('325','2014-04-03','15:20:00',3.82),('325','2014-04-03','15:25:00',3.79),('325','2014-04-03','15:30:00',3.73),('325','2014-04-03','15:35:00',3.69),('325','2014-04-03','15:40:00',3.66),('325','2014-04-03','15:45:00',3.6),('325','2014-04-03','15:50:00',3.55),('325','2014-04-03','15:55:00',3.5),('325','2014-04-03','16:00:00',3.47),('325','2014-04-03','16:05:00',3.36),('325','2014-04-03','16:10:00',3.36),('325','2014-04-03','16:15:00',3.25),('325','2014-04-03','16:20:00',3.19),('325','2014-04-03','16:25:00',3.08),('325','2014-04-03','16:30:00',2.98),('325','2014-04-03','16:35:00',2.9),('325','2014-04-03','16:40:00',2.8),('325','2014-04-03','16:45:00',2.55),('325','2014-04-03','16:50:00',1.87),('325','2014-04-03','16:55:00',1.69),('325','2014-04-03','17:00:00',1.26),('325','2014-04-03','17:05:00',1.12),('325','2014-04-03','17:10:00',1.03),('325','2014-04-03','17:20:00',1.11),('325','2014-04-03','17:25:00',1.14),('325','2014-04-03','17:30:00',1.1),('325','2014-04-03','17:45:00',1.23),('325','2014-04-03','17:50:00',1.46),('325','2014-04-03','17:55:00',1.28),('325','2014-04-03','18:00:00',1.16),('325','2014-04-03','18:05:00',1.04),('325','2013-06-19','08:25:00',1.05),('325','2013-06-19','08:30:00',1.1),('325','2013-06-19','08:35:00',1.16),('325','2013-06-19','08:40:00',1.21),('325','2013-06-19','08:45:00',1.24),('325','2013-06-19','08:50:00',1.26),('325','2013-06-19','08:55:00',1.27),('325','2013-06-19','09:00:00',1.28),('325','2013-06-19','09:05:00',1.31),('325','2013-06-19','09:10:00',1.36),('325','2013-06-19','09:15:00',1.39),('325','2013-06-19','09:20:00',1.41),('325','2013-06-19','09:25:00',1.44),('325','2013-06-19','09:30:00',1.48),('325','2013-06-19','09:35:00',2.37),('325','2013-06-19','09:40:00',2.48),('325','2013-06-19','09:45:00',2.57),('325','2013-06-19','09:50:00',2.63),('325','2013-06-19','09:55:00',2.63),('325','2013-06-19','10:00:00',2.68),('325','2013-06-19','10:05:00',2.75),('325','2013-06-19','10:10:00',2.82),('325','2013-06-19','10:15:00',2.89),('325','2013-06-19','10:20:00',2.91),('325','2013-06-19','10:25:00',2.92),('325','2013-06-19','10:30:00',2.97),('325','2013-06-19','10:35:00',3.03),('325','2013-06-19','10:40:00',3.11),('325','2013-06-19','10:45:00',3.2),('325','2013-06-19','10:50:00',3.2),('325','2013-06-19','10:55:00',3.26),('325','2013-06-19','11:00:00',3.3),('325','2013-06-19','11:05:00',3.33),('325','2013-06-19','11:10:00',3.37),('325','2013-06-19','11:15:00',3.46),('325','2013-06-19','11:20:00',3.61),('325','2013-06-19','11:25:00',3.63),('325','2013-06-19','11:30:00',3.76),('325','2013-06-19','11:35:00',3.77),('325','2013-06-19','11:40:00',3.85),('325','2013-06-19','11:45:00',3.91),('325','2013-06-19','11:50:00',3.95),('325','2013-06-19','11:55:00',3.95),('325','2013-06-19','12:00:00',4.01),('325','2013-06-19','12:05:00',3.95),('325','2013-06-19','12:10:00',3.95),('325','2013-06-19','12:15:00',3.93),('325','2013-06-19','12:20:00',3.82),('325','2013-06-19','12:25:00',3.9),('325','2013-06-19','12:30:00',3.89),('325','2013-06-19','12:35:00',3.97),('325','2013-06-19','12:40:00',3.94),('325','2013-06-19','12:45:00',3.9),('325','2013-06-19','12:50:00',4.03),('325','2013-06-19','12:55:00',4.07),('325','2013-06-19','13:00:00',4.09),('325','2013-06-19','13:05:00',4.13),('325','2013-06-19','13:10:00',4.11),('325','2013-06-19','13:15:00',4.03),('325','2013-06-19','13:20:00',4.04),('325','2013-06-19','13:25:00',3.99),('325','2013-06-19','13:30:00',4.02),('325','2013-06-19','13:35:00',4.28),('325','2013-06-19','13:40:00',4.27),('325','2013-06-19','13:45:00',4.25),('325','2013-06-19','13:50:00',4.2),('325','2013-06-19','13:55:00',4.14),('325','2013-06-19','14:00:00',4.08),('325','2013-06-19','14:05:00',4.04),('325','2013-06-19','14:10:00',3.97),('325','2013-06-19','14:15:00',3.92),('325','2013-06-19','14:20:00',3.92),('325','2013-06-19','14:25:00',3.9),('325','2013-06-19','14:30:00',3.87),('325','2013-06-19','14:35:00',3.87),('325','2013-06-19','14:40:00',4.04),('325','2013-06-19','14:45:00',4.02),('325','2013-06-19','14:50:00',4.01),('325','2013-06-19','14:55:00',4.01),('325','2013-06-19','15:00:00',3.97),('325','2013-06-19','15:05:00',3.93),('325','2013-06-19','15:10:00',3.89),('325','2013-06-19','15:15:00',3.87),('325','2013-06-19','15:20:00',3.84),('325','2013-06-19','15:25:00',3.81),('325','2013-06-19','15:30:00',3.78),('325','2013-06-19','15:35:00',3.74),('325','2013-06-19','15:40:00',3.65),('325','2013-06-19','15:45:00',3.62),('325','2013-06-19','15:50:00',3.55),('325','2013-06-19','15:55:00',3.5),('325','2013-06-19','16:00:00',3.44),('325','2013-06-19','16:05:00',3.39),('325','2013-06-19','16:10:00',3.33),('325','2013-06-19','16:15:00',3.28),('325','2013-06-19','16:20:00',3.23),('325','2013-06-19','16:25:00',3.18),('325','2013-06-19','16:30:00',3.12),('325','2013-06-19','16:35:00',3.06),('325','2013-06-19','16:40:00',3.01),('325','2013-06-19','16:45:00',2.94),('325','2013-06-19','16:50:00',2.89),('325','2013-06-19','16:55:00',2.82),('325','2013-06-19','17:00:00',2.73),('325','2013-06-19','17:05:00',2.59),('325','2013-06-19','17:10:00',2.51),('325','2013-06-19','17:15:00',2.48),('325','2013-06-19','17:20:00',2.44),('325','2013-06-19','17:25:00',2.39),('325','2013-06-19','17:30:00',2.31),('325','2013-06-19','17:35:00',2.22),('325','2013-06-19','17:40:00',2.14),('325','2013-06-19','17:45:00',2.06),('325','2013-06-19','17:50:00',1.96),('325','2013-06-19','17:55:00',1.85),('325','2013-06-19','18:00:00',1.74),('325','2013-06-19','18:05:00',1.66),('325','2013-06-19','18:10:00',1.54),('325','2013-06-19','18:15:00',1.36),('325','2013-06-19','18:20:00',1.2),('325','2013-06-19','18:25:00',1.1),('325','2013-06-18','08:25:00',1.06),('325','2013-06-18','08:30:00',1.09),('325','2013-06-18','08:35:00',1.16),('325','2013-06-18','08:40:00',1.21),('325','2013-06-18','08:45:00',1.25),('325','2013-06-18','08:50:00',1.26),('325','2013-06-18','08:55:00',1.27),('325','2013-06-18','09:00:00',1.28),('325','2013-06-18','09:05:00',1.32),('325','2013-06-18','09:10:00',1.37),('325','2013-06-18','09:15:00',1.39),('325','2013-06-18','09:20:00',1.41),('325','2013-06-18','09:25:00',2.05),('325','2013-06-18','09:30:00',2.29),('325','2013-06-18','09:35:00',2.34),('325','2013-06-18','09:40:00',2.44),('325','2013-06-18','09:45:00',2.52),('325','2013-06-18','09:50:00',2.17),('325','2013-06-18','09:55:00',2.63),('325','2013-06-18','10:00:00',2.67),('325','2013-06-18','10:05:00',2.71),('325','2013-06-18','10:10:00',2.82),('325','2013-06-18','10:15:00',2.88),('325','2013-06-18','10:20:00',2.9),('325','2013-06-18','10:25:00',2.93),('325','2013-06-18','10:30:00',2.98),('325','2013-06-18','10:35:00',3.04),('325','2013-06-18','10:40:00',3.13),('325','2013-06-18','10:45:00',3.19),('325','2013-06-18','10:50:00',3.22),('325','2013-06-18','10:55:00',3.24),('325','2013-06-18','11:00:00',3.3),('325','2013-06-18','11:05:00',3.35),('325','2013-06-18','11:10:00',3.41),('325','2013-06-18','11:15:00',3.64),('325','2013-06-18','11:20:00',3.75),('325','2013-06-18','11:25:00',3.78),('325','2013-06-18','11:30:00',3.78),('325','2013-06-18','11:35:00',3.76),('325','2013-06-18','11:40:00',3.74),('325','2013-06-18','11:45:00',3.82),('325','2013-06-18','11:50:00',3.88),('325','2013-06-18','11:55:00',3.88),('325','2013-06-18','12:00:00',3.9),('325','2013-06-18','12:05:00',3.94),('325','2013-06-18','12:10:00',3.95),('325','2013-06-18','12:15:00',3.78),('325','2013-06-18','12:20:00',3.93),('325','2013-06-18','12:25:00',3.88),('325','2013-06-18','12:30:00',3.74),('325','2013-06-18','12:35:00',3.7),('325','2013-06-18','12:40:00',3.53),('325','2013-06-18','12:45:00',3.27),('325','2013-06-18','12:50:00',1.7),('325','2013-06-18','12:55:00',3.06),('325','2013-06-18','13:00:00',2.81),('325','2013-06-18','13:05:00',1.76),('325','2013-06-18','13:10:00',4.1),('325','2013-06-18','13:15:00',4.22),('325','2013-06-18','13:20:00',4.31),('325','2013-06-18','13:25:00',4.15),('325','2013-06-18','13:30:00',2.18),('325','2013-06-18','13:35:00',3.88),('325','2013-06-18','13:40:00',4.12),('325','2013-06-18','13:45:00',4.09),('325','2013-06-18','13:50:00',4.01),('325','2013-06-18','13:55:00',3.94),('325','2013-06-18','14:00:00',4),('325','2013-06-18','14:05:00',4.28),('325','2013-06-18','14:10:00',4.21),('325','2013-06-18','14:15:00',4.13),('325','2013-06-18','14:20:00',4.13),('325','2013-06-18','14:25:00',4.08),('325','2013-06-18','14:30:00',4.08),('325','2013-06-18','14:35:00',4.17),('325','2013-06-18','14:40:00',4.23),('325','2013-06-18','14:45:00',4.21),('325','2013-06-18','14:50:00',4.16),('325','2013-06-18','14:55:00',4.15),('325','2013-06-18','15:00:00',4.07),('325','2013-06-18','15:05:00',4),('325','2013-06-18','15:10:00',4),('325','2013-06-18','15:15:00',3.93),('325','2013-06-18','15:20:00',3.86),('325','2013-06-18','15:25:00',3.83),('325','2013-06-18','15:30:00',3.79),('325','2013-06-18','15:35:00',3.78),('325','2013-06-18','15:40:00',3.78),('325','2013-06-18','15:45:00',3.7),('325','2013-06-18','15:50:00',3.66),('325','2013-06-18','15:55:00',3.62),('325','2013-06-18','16:00:00',3.58),('325','2013-06-18','16:05:00',3.53),('325','2013-06-18','16:10:00',3.5),('325','2013-06-18','16:15:00',3.49),('325','2013-06-18','16:20:00',3.45),('325','2013-06-18','16:25:00',3.36),('325','2013-06-18','16:30:00',3.29),('325','2013-06-18','16:35:00',3.08),('325','2013-06-18','16:40:00',3.11),('325','2013-06-18','16:45:00',3.01),('325','2013-06-18','16:50:00',2.93),('325','2013-06-18','16:55:00',2.87),('325','2013-06-18','17:00:00',2.77),('325','2013-06-18','17:05:00',2.65),('325','2013-06-18','17:10:00',2.52),('325','2013-06-18','17:15:00',2.53),('325','2013-06-18','17:20:00',2.47),('325','2013-06-18','17:25:00',2.39),('325','2013-06-18','17:30:00',2.3),('325','2013-06-18','17:35:00',2.2),('325','2013-06-18','17:40:00',2.13),('325','2013-06-18','17:45:00',2.03),('325','2013-06-18','17:50:00',1.95),('325','2013-06-18','17:55:00',1.84),('325','2013-06-18','18:00:00',1.75),('325','2013-06-18','18:05:00',1.67),('325','2013-06-18','18:10:00',1.56),('325','2013-06-18','18:15:00',1.38),('325','2013-06-18','18:20:00',1.26),('325','2013-06-18','18:25:00',1.18),('325','2013-06-18','18:30:00',1.04),('325','2013-06-17','08:20:00',1.02),('325','2013-06-17','08:25:00',1.08),('325','2013-06-17','08:30:00',1.12),('325','2013-06-17','08:35:00',1.19),('325','2013-06-17','08:40:00',1.24),('325','2013-06-17','08:45:00',1.27),('325','2013-06-17','08:50:00',1.26),('325','2013-06-17','08:55:00',1.26),('325','2013-06-17','09:00:00',1.29),('325','2013-06-17','09:05:00',1.33),('325','2013-06-17','09:10:00',1.38),('325','2013-06-17','09:15:00',1.4),('325','2013-06-17','09:20:00',1.52),('325','2013-06-17','09:25:00',2.33),('325','2013-06-17','09:30:00',2.44),('325','2013-06-17','09:35:00',2.49),('325','2013-06-17','09:40:00',2.56),('325','2013-06-17','09:45:00',2.65),('325','2013-06-17','09:50:00',2.71),('325','2013-06-17','09:55:00',2.71),('325','2013-06-17','10:00:00',2.76),('325','2013-06-17','10:05:00',2.82),('325','2013-06-17','10:10:00',2.9),('325','2013-06-17','10:15:00',2.99),('325','2013-06-17','10:20:00',3.01),('325','2013-06-17','10:25:00',3),('325','2013-06-17','10:30:00',3.06),('325','2013-06-17','10:35:00',3.13),('325','2013-06-17','10:40:00',3.22),('325','2013-06-17','10:45:00',3.29),('325','2013-06-17','10:50:00',3.29),('325','2013-06-17','10:55:00',3.3),('325','2013-06-17','11:00:00',3.38),('325','2013-06-17','11:05:00',3.45),('325','2013-06-17','11:10:00',3.5),('325','2013-06-17','11:15:00',3.6),('325','2013-06-17','11:20:00',3.72),('325','2013-06-17','11:25:00',3.76),('325','2013-06-17','11:30:00',3.74),('325','2013-06-17','11:35:00',3.72),('325','2013-06-17','11:40:00',3.67),('325','2013-06-17','11:45:00',3.74),('325','2013-06-17','11:50:00',3.72),('325','2013-06-17','11:55:00',3.77),('325','2013-06-17','12:00:00',3.87),('325','2013-06-17','12:05:00',3.99),('325','2013-06-17','12:10:00',4),('325','2013-06-17','12:15:00',3.99),('325','2013-06-17','12:20:00',4.03),('325','2013-06-17','12:25:00',3.97),('325','2013-06-17','12:30:00',3.92),('325','2013-06-17','12:35:00',3.9),('325','2013-06-17','12:40:00',3.86),('325','2013-06-17','12:45:00',3.92),('325','2013-06-17','12:50:00',4.08),('325','2013-06-17','12:55:00',4.16),('325','2013-06-17','13:00:00',4.19),('325','2013-06-17','13:05:00',4.25),('325','2013-06-17','13:10:00',4.19),('325','2013-06-17','13:15:00',4.13),('325','2013-06-17','13:20:00',4.08),('325','2013-06-17','13:25:00',3.99),('325','2013-06-17','13:30:00',3.98),('325','2013-06-17','13:35:00',4.01),('325','2013-06-17','13:40:00',4.02),('325','2013-06-17','13:45:00',4),('325','2013-06-17','13:50:00',4.01),('325','2013-06-17','13:55:00',3.99),('325','2013-06-17','14:00:00',4.03),('325','2013-06-17','14:05:00',4),('325','2013-06-17','14:10:00',4.17),('325','2013-06-17','14:15:00',4.12),('325','2013-06-17','14:20:00',4.12),('325','2013-06-17','14:25:00',4.12),('325','2013-06-17','14:30:00',4.11),('325','2013-06-17','14:35:00',4.1),('325','2013-06-17','14:40:00',4.1),('325','2013-06-17','14:45:00',4.08),('325','2013-06-17','14:50:00',4.06),('325','2013-06-17','14:55:00',4.04),('325','2013-06-17','15:00:00',3.99),('325','2013-06-17','15:05:00',3.97),('325','2013-06-17','15:20:00',3.88),('325','2013-06-17','15:25:00',3.84),('325','2013-06-17','15:30:00',3.8),('325','2013-06-17','15:35:00',3.76),('325','2013-06-17','15:40:00',3.71),('325','2013-06-17','15:45:00',3.66),('325','2013-06-17','15:50:00',3.6),('325','2013-06-17','15:55:00',3.55),('325','2013-06-17','16:00:00',3.51),('325','2013-06-17','16:05:00',3.46),('325','2013-06-17','16:10:00',3.41),('325','2013-06-17','16:15:00',3.37),('325','2013-06-17','16:20:00',3.32),('325','2013-06-17','16:25:00',3.27),('325','2013-06-17','16:30:00',3.19),('325','2013-06-17','16:35:00',3.13),('325','2013-06-17','16:40:00',3.07),('325','2013-06-17','16:45:00',2.99),('325','2013-06-17','16:50:00',2.94),('325','2013-06-17','16:55:00',2.89),('325','2013-06-17','17:00:00',2.79),('325','2013-06-17','17:05:00',2.66),('325','2013-06-17','17:10:00',2.52),('325','2013-06-17','17:15:00',2.53),('325','2013-06-17','17:20:00',2.49),('325','2013-06-17','17:25:00',2.41),('325','2013-06-17','17:30:00',2.35),('325','2013-06-17','17:35:00',2.27),('325','2013-06-17','17:40:00',2.19),('325','2013-06-17','17:45:00',2.09),('325','2013-06-17','17:50:00',2),('325','2013-06-17','17:55:00',1.89),('325','2013-06-17','18:00:00',1.78),('325','2013-06-17','18:05:00',1.73),('325','2013-06-17','18:10:00',1.62),('325','2013-06-17','18:15:00',1.43),('325','2013-06-17','18:20:00',1.29),('325','2013-06-17','18:25:00',1.14),('325','2013-06-17','18:30:00',1.07),('325','2013-06-16','08:20:00',1.03),('325','2013-06-16','08:25:00',1.09),('325','2013-06-16','08:30:00',1.14),('325','2013-06-16','08:35:00',1.2),('325','2013-06-16','08:40:00',1.24),('325','2013-06-16','08:45:00',1.3),('325','2013-06-16','08:50:00',1.31),('325','2013-06-16','08:55:00',1.32),('325','2013-06-16','09:00:00',1.31),('325','2013-06-16','09:05:00',1.34),('325','2013-06-16','09:10:00',1.38),('325','2013-06-16','09:15:00',1.4),('325','2013-06-16','09:20:00',1.43),('325','2013-06-16','09:25:00',1.49),('325','2013-06-16','09:30:00',1.6),('325','2013-06-16','09:35:00',2.52),('325','2013-06-16','09:40:00',2.6),('325','2013-06-16','09:45:00',2.68),('325','2013-06-16','09:50:00',2.74),('325','2013-06-16','09:55:00',2.75),('325','2013-06-16','10:00:00',2.81),('325','2013-06-16','10:05:00',2.9),('325','2013-06-16','10:10:00',2.99),('325','2013-06-16','10:15:00',3.03),('325','2013-06-16','10:20:00',3.05),('325','2013-06-16','10:25:00',3.09),('325','2013-06-16','10:30:00',3.13),('325','2013-06-16','10:35:00',3.2),('325','2013-06-16','10:40:00',3.29),('325','2013-06-16','10:45:00',3.39),('325','2013-06-16','10:50:00',3.41),('325','2013-06-16','10:55:00',3.58),('325','2013-06-16','11:00:00',3.74),('325','2013-06-16','11:05:00',3.8),('325','2013-06-16','11:10:00',3.89),('325','2013-06-16','11:15:00',3.96),('325','2013-06-16','11:20:00',3.98),('325','2013-06-16','11:25:00',4.05),('325','2013-06-16','11:30:00',3.99),('325','2013-06-16','11:35:00',4.04),('325','2013-06-16','11:40:00',4.12),('325','2013-06-16','11:45:00',4.17),('325','2013-06-16','11:50:00',4.2),('325','2013-06-16','11:55:00',4.24),('325','2013-06-16','12:00:00',4.28),('325','2013-06-16','12:05:00',4.32),('325','2013-06-16','12:10:00',4.28),('325','2013-06-16','12:15:00',4.28),('325','2013-06-16','12:20:00',4.25),('325','2013-06-16','12:25:00',4.15),('325','2013-06-16','12:30:00',4.08),('325','2013-06-16','12:35:00',4.02),('325','2013-06-16','12:40:00',3.97),('325','2013-06-16','12:45:00',4.02),('325','2013-06-16','12:50:00',4.1),('325','2013-06-16','12:55:00',4.18),('325','2013-06-16','13:00:00',4.29),('325','2013-06-16','13:05:00',4.39),('325','2013-06-16','13:10:00',4.51),('325','2013-06-16','13:15:00',4.48),('325','2013-06-16','13:20:00',4.47),('325','2013-06-16','13:25:00',4.48),('325','2013-06-16','13:30:00',4.48),('325','2013-06-16','13:35:00',4.5),('325','2013-06-16','13:40:00',4.5),('325','2013-06-16','13:45:00',4.43),('325','2013-06-16','13:50:00',4.38),('325','2013-06-16','13:55:00',4.3),('325','2013-06-16','14:00:00',4.24),('325','2013-06-16','14:05:00',4.15),('325','2013-06-16','14:10:00',4.13),('325','2013-06-16','14:15:00',4.1),('325','2013-06-16','14:20:00',4.09),('325','2013-06-16','14:25:00',4.13),('325','2013-06-16','14:30:00',4.21),('325','2013-06-16','14:35:00',4.2),('325','2013-06-16','14:40:00',4.22),('325','2013-06-16','14:45:00',4.21),('325','2013-06-16','14:50:00',4.19),('325','2013-06-16','14:55:00',4.17),('325','2013-06-16','15:00:00',4.15),('325','2013-06-16','15:05:00',4.12),('325','2013-06-16','15:10:00',4.08),('325','2013-06-16','15:15:00',4.04),('325','2013-06-16','15:20:00',4.02),('325','2013-06-16','15:25:00',3.97),('325','2013-06-16','15:30:00',3.94),('325','2013-06-16','15:35:00',3.91),('325','2013-06-16','15:40:00',3.86),('325','2013-06-16','15:45:00',3.8),('325','2013-06-16','15:50:00',3.74),('325','2013-06-16','15:55:00',3.69),('325','2013-06-16','16:00:00',3.64),('325','2013-06-16','16:05:00',3.58),('325','2013-06-16','16:10:00',3.53),('325','2013-06-16','16:15:00',3.48),('325','2013-06-16','16:20:00',3.43),('325','2013-06-16','16:25:00',3.36),('325','2013-06-16','16:30:00',3.29),('325','2013-06-16','16:35:00',3.23),('325','2013-06-16','16:40:00',3.18),('325','2013-06-16','16:45:00',3.09),('325','2013-06-16','16:50:00',3.01),('325','2013-06-16','16:55:00',2.93),('325','2013-06-16','17:00:00',2.83),('325','2013-06-16','17:05:00',2.69),('325','2013-06-16','17:10:00',2.61),('325','2013-06-16','17:15:00',2.58),('325','2013-06-16','17:20:00',2.49),('325','2013-06-16','17:25:00',2.41),('325','2013-06-16','17:30:00',2.33),('325','2013-06-16','17:35:00',2.24),('325','2013-06-16','17:40:00',2.15),('325','2013-06-16','17:45:00',2.07),('325','2013-06-16','17:50:00',1.96),('325','2013-06-16','17:55:00',1.83),('325','2013-06-16','18:00:00',1.76),('325','2013-06-16','18:05:00',1.68),('325','2013-06-16','18:10:00',1.57),('325','2013-06-16','18:15:00',1.39),('325','2013-06-16','18:20:00',1.22),('325','2013-06-16','18:25:00',1.16),('325','2013-06-16','18:30:00',1.03),('325','2013-06-15','08:15:00',1.02),('325','2013-06-15','08:20:00',1.04),('325','2013-06-15','08:25:00',1.13),('325','2013-06-15','08:30:00',1.18),('325','2013-06-15','08:35:00',1.27),('325','2013-06-15','08:40:00',1.29),('325','2013-06-15','08:45:00',1.37),('325','2013-06-15','08:50:00',1.4),('325','2013-06-15','08:55:00',1.39),('325','2013-06-15','09:00:00',1.36),('325','2013-06-15','09:05:00',1.52),('325','2013-06-15','09:10:00',1.54),('325','2013-06-15','09:15:00',1.63),('325','2013-06-15','09:20:00',1.24),('325','2013-06-15','09:25:00',1.61),('325','2013-06-15','09:30:00',1.76),('325','2013-06-15','09:35:00',2.42),('325','2013-06-15','09:40:00',2.73),('325','2013-06-15','09:45:00',2.65),('325','2013-06-15','09:50:00',2.73),('325','2013-06-15','09:55:00',2.76),('325','2013-06-15','10:00:00',2.87),('325','2013-06-15','10:05:00',2.92),('325','2013-06-15','10:10:00',2.99),('325','2013-06-15','10:15:00',3.13),('325','2013-06-15','10:20:00',3.17),('325','2013-06-15','10:25:00',3.11),('325','2013-06-15','10:30:00',3.26),('325','2013-06-15','10:35:00',3.12),('325','2013-06-15','10:40:00',3.01),('325','2013-06-15','10:45:00',3.26),('325','2013-06-15','10:50:00',3.24),('325','2013-06-15','10:55:00',3.75),('325','2013-06-15','11:00:00',3.83),('325','2013-06-15','11:05:00',3.7),('325','2013-06-15','11:10:00',3.9),('325','2013-06-15','11:15:00',2.69),('325','2013-06-15','11:20:00',3.72),('325','2013-06-15','11:25:00',4.23),('325','2013-06-15','11:30:00',3.56),('325','2013-06-15','11:35:00',4.09),('325','2013-06-15','11:40:00',4.06),('325','2013-06-15','11:45:00',3.59),('325','2013-06-15','11:50:00',4.39),('325','2013-06-15','11:55:00',4),('325','2013-06-15','12:00:00',4.15),('325','2013-06-15','12:05:00',4.41),('325','2013-06-15','12:10:00',4.45),('325','2013-06-15','12:15:00',4.44),('325','2013-06-15','12:20:00',4.37),('325','2013-06-15','12:25:00',4.24),('325','2013-06-15','12:30:00',4.24),('325','2013-06-15','12:35:00',4.2),('325','2013-06-15','12:40:00',4.14),('325','2013-06-15','12:45:00',4.18),('325','2013-06-15','12:50:00',4.52),('325','2013-06-15','12:55:00',4.53),('325','2013-06-15','13:00:00',4.52),('325','2013-06-15','13:05:00',4.53),('325','2013-06-15','13:10:00',4.52),('325','2013-06-15','13:15:00',4.54),('325','2013-06-15','13:20:00',4.52),('325','2013-06-15','13:25:00',4.51),('325','2013-06-15','13:30:00',4.48),('325','2013-06-15','13:35:00',4.49),('325','2013-06-15','13:40:00',4.48),('325','2013-06-15','13:45:00',4.43),('325','2013-06-15','13:50:00',4.37),('325','2013-06-15','13:55:00',4.29),('325','2013-06-15','14:00:00',4.2),('325','2013-06-15','14:05:00',4.15),('325','2013-06-15','14:10:00',4.09),('325','2013-06-15','14:15:00',4.06),('325','2013-06-15','14:20:00',4.06),('325','2013-06-15','14:25:00',3.97),('325','2013-06-15','14:30:00',4.07),('325','2013-06-15','14:35:00',4.16),('325','2013-06-15','14:40:00',4.23),('325','2013-06-15','14:45:00',4.19),('325','2013-06-15','14:50:00',4.14),('325','2013-06-15','14:55:00',4.18),('325','2013-06-15','15:00:00',4.14),('325','2013-06-15','15:05:00',4.15),('325','2013-06-15','15:10:00',4.11),('325','2013-06-15','15:15:00',4.06),('325','2013-06-15','15:20:00',4.03),('325','2013-06-15','15:25:00',4.01),('325','2013-06-15','15:30:00',3.96),('325','2013-06-15','15:35:00',3.91),('325','2013-06-15','15:40:00',3.85),('325','2013-06-15','15:45:00',3.79),('325','2013-06-15','15:50:00',3.74),('325','2013-06-15','15:55:00',3.69),('325','2013-06-15','16:00:00',3.62),('325','2013-06-15','16:05:00',3.56),('325','2013-06-15','16:10:00',3.51),('325','2013-06-15','16:15:00',3.47),('325','2013-06-15','16:20:00',3.41),('325','2013-06-15','16:25:00',3.35),('325','2013-06-15','16:30:00',3.3),('325','2013-06-15','16:35:00',3.23),('325','2013-06-15','16:40:00',3.15),('325','2013-06-15','16:45:00',3.08),('325','2013-06-15','16:50:00',3.03),('325','2013-06-15','16:55:00',2.92),('325','2013-06-15','17:00:00',2.83),('325','2013-06-15','17:05:00',2.69),('325','2013-06-15','17:10:00',2.61),('325','2013-06-15','17:15:00',2.58),('325','2013-06-15','17:20:00',2.48),('325','2013-06-15','17:25:00',2.4),('325','2013-06-15','17:30:00',2.29),('325','2013-06-15','17:35:00',2.2),('325','2013-06-15','17:40:00',2.11),('325','2013-06-15','17:45:00',1.99),('325','2013-06-15','17:50:00',1.92),('325','2013-06-15','17:55:00',1.79),('325','2013-06-15','18:00:00',1.72),('325','2013-06-15','18:05:00',1.64),('325','2013-06-15','18:10:00',1.52),('325','2013-06-15','18:15:00',1.35),('325','2013-06-15','18:20:00',1.2),('325','2013-06-15','18:25:00',1.05),('325','2013-06-15','18:30:00',1.01),('325','2013-06-14','08:20:00',1.05),('325','2013-06-14','08:25:00',1.12),('325','2013-06-14','08:30:00',1.16),('325','2013-06-14','08:35:00',1.23),('325','2013-06-14','08:40:00',1.28),('325','2013-06-14','08:45:00',1.31),('325','2013-06-14','08:50:00',1.32),('325','2013-06-14','08:55:00',1.36),('325','2013-06-14','09:00:00',1.4),('325','2013-06-14','09:05:00',1.43),('325','2013-06-14','09:10:00',1.47),('325','2013-06-14','09:15:00',1.5),('325','2013-06-14','09:20:00',1.55),('325','2013-06-14','09:25:00',1.58),('325','2013-06-14','09:30:00',1.84),('325','2013-06-14','09:35:00',2.67),('325','2013-06-14','09:40:00',2.76),('325','2013-06-14','09:45:00',2.84),('325','2013-06-14','09:50:00',2.86),('325','2013-06-14','09:55:00',2.86),('325','2013-06-14','10:00:00',2.91),('325','2013-06-14','10:05:00',2.97),('325','2013-06-14','10:10:00',3.08),('325','2013-06-14','10:15:00',3.15),('325','2013-06-14','10:20:00',3.16),('325','2013-06-14','10:25:00',3.17),('325','2013-06-14','10:30:00',3.16),('325','2013-06-14','10:35:00',3.38),('325','2013-06-14','10:40:00',3.49),('325','2013-06-14','10:45:00',3.55),('325','2013-06-14','10:50:00',3.51),('325','2013-06-14','10:55:00',3.51),('325','2013-06-14','11:00:00',3.52),('325','2013-06-14','11:05:00',3.58),('325','2013-06-14','11:10:00',3.71),('325','2013-06-14','11:15:00',3.82),('325','2013-06-14','11:20:00',3.92),('325','2013-06-14','11:25:00',3.81),('325','2013-06-14','11:30:00',3.95),('325','2013-06-14','11:35:00',3.91),('325','2013-06-14','11:40:00',3.9),('325','2013-06-14','11:45:00',3.93),('325','2013-06-14','11:50:00',3.96),('325','2013-06-14','11:55:00',4),('325','2013-06-14','12:00:00',4.09),('325','2013-06-14','12:05:00',4.17),('325','2013-06-14','12:10:00',4.23),('325','2013-06-14','12:15:00',4.26),('325','2013-06-14','12:20:00',4.23),('325','2013-06-14','12:25:00',4.12),('325','2013-06-14','12:30:00',4.12),('325','2013-06-14','12:35:00',4.05),('325','2013-06-14','12:40:00',4.08),('325','2013-06-14','12:45:00',4.13),('325','2013-06-14','12:50:00',4.23),('325','2013-06-14','12:55:00',4.5),('325','2013-06-14','13:00:00',4.5),('325','2013-06-14','13:05:00',4.55),('325','2013-06-14','13:10:00',4.56),('325','2013-06-14','13:15:00',4.54),('325','2013-06-14','13:20:00',4.55),('325','2013-06-14','13:25:00',4.58),('325','2013-06-14','13:30:00',4.49),('325','2013-06-14','13:35:00',4.47),('325','2013-06-14','13:40:00',4.49),('325','2013-06-14','13:45:00',4.4),('325','2013-06-14','13:50:00',4.4),('325','2013-06-14','13:55:00',4.27),('325','2013-06-14','14:00:00',4.21),('325','2013-06-14','14:05:00',4.19),('325','2013-06-14','14:10:00',4.14),('325','2013-06-14','14:15:00',4.11),('325','2013-06-14','14:20:00',4.01),('325','2013-06-14','14:25:00',4),('325','2013-06-14','14:30:00',3.99),('325','2013-06-14','14:35:00',3.96),('325','2013-06-14','14:40:00',3.92),('325','2013-06-14','14:45:00',4.12),('325','2013-06-14','14:50:00',4.24),('325','2013-06-14','14:55:00',4.24),('325','2013-06-14','15:00:00',4.2),('325','2013-06-14','15:05:00',4.17),('325','2013-06-14','15:10:00',4.12),('325','2013-06-14','15:15:00',4.09),('325','2013-06-14','15:20:00',4.07),('325','2013-06-14','15:25:00',4.04),('325','2013-06-14','15:30:00',4.01),('325','2013-06-14','15:35:00',3.97),('325','2013-06-14','15:40:00',3.92),('325','2013-06-14','15:45:00',3.88),('325','2013-06-14','15:50:00',3.84),('325','2013-06-14','15:55:00',3.77),('325','2013-06-14','16:00:00',3.71),('325','2013-06-14','16:05:00',3.66),('325','2013-06-14','16:10:00',3.59),('325','2013-06-14','16:15:00',3.54),('325','2013-06-14','16:20:00',3.49),('325','2013-06-14','16:25:00',3.4),('325','2013-06-14','16:30:00',3.35),('325','2013-06-14','16:35:00',3.28),('325','2013-06-14','16:40:00',3.2),('325','2013-06-14','16:45:00',3.15),('325','2013-06-14','16:50:00',3.07),('325','2013-06-14','16:55:00',2.98),('325','2013-06-14','17:00:00',2.9),('325','2013-06-14','17:05:00',2.7),('325','2013-06-14','17:10:00',2.63),('325','2013-06-14','17:15:00',2.66),('325','2013-06-14','17:20:00',2.55),('325','2013-06-14','17:25:00',2.46),('325','2013-06-14','17:30:00',2.3),('325','2013-06-14','17:35:00',2.27),('325','2013-06-14','17:40:00',2.23),('325','2013-06-14','17:45:00',2.14),('325','2013-06-14','17:50:00',2.04),('325','2013-06-14','17:55:00',1.89),('325','2013-06-14','18:00:00',1.78),('325','2013-06-14','18:05:00',1.74),('325','2013-06-14','18:10:00',1.62),('325','2013-06-14','18:15:00',1.43),('325','2013-06-14','18:20:00',1.25),('325','2013-06-14','18:25:00',1.11),('325','2013-06-14','18:30:00',1.08),('325','2013-06-14','18:35:00',1.03),('325','2013-06-13','08:15:00',1.02),('325','2013-06-13','08:20:00',1.07),('325','2013-06-13','08:25:00',1.12),('325','2013-06-13','08:30:00',1.15),('325','2013-06-13','08:35:00',1.22),('325','2013-06-13','08:40:00',1.27),('325','2013-06-13','08:45:00',1.3),('325','2013-06-13','08:50:00',1.3),('325','2013-06-13','08:55:00',1.29),('325','2013-06-13','09:00:00',1.29),('325','2013-06-13','09:05:00',1.34),('325','2013-06-13','09:10:00',1.38),('325','2013-06-13','09:15:00',1.39),('325','2013-06-13','09:20:00',1.42),('325','2013-06-13','09:25:00',1.68),('325','2013-06-13','09:30:00',2.6),('325','2013-06-13','09:35:00',2.67),('325','2013-06-13','09:40:00',2.77),('325','2013-06-13','09:45:00',2.88),('325','2013-06-13','09:50:00',2.93),('325','2013-06-13','09:55:00',2.95),('325','2013-06-13','10:00:00',3),('325','2013-06-13','10:05:00',3.09),('325','2013-06-13','10:10:00',3.17),('325','2013-06-13','10:15:00',3.22),('325','2013-06-13','10:20:00',3.28),('325','2013-06-13','10:25:00',3.35),('325','2013-06-13','10:30:00',3.41),('325','2013-06-13','10:35:00',3.48),('325','2013-06-13','10:40:00',3.51),('325','2013-06-13','10:45:00',3.63),('325','2013-06-13','10:50:00',3.86),('325','2013-06-13','10:55:00',3.95),('325','2013-06-13','11:00:00',4.05),('325','2013-06-13','11:05:00',4.08),('325','2013-06-13','11:10:00',4.14),('325','2013-06-13','11:15:00',4.18),('325','2013-06-13','11:20:00',4.2),('325','2013-06-13','11:25:00',4.25),('325','2013-06-13','11:30:00',4.29),('325','2013-06-13','11:35:00',4.31),('325','2013-06-13','11:40:00',4.37),('325','2013-06-13','11:45:00',4.42),('325','2013-06-13','11:50:00',4.47),('325','2013-06-13','11:55:00',4.48),('325','2013-06-13','12:00:00',4.48),('325','2013-06-13','12:05:00',4.51),('325','2013-06-13','12:10:00',4.52),('325','2013-06-13','12:15:00',4.5),('325','2013-06-13','12:20:00',4.56),('325','2013-06-13','12:25:00',4.59),('325','2013-06-13','12:30:00',4.59),('325','2013-06-13','12:35:00',4.58),('325','2013-06-13','12:40:00',4.6),('325','2013-06-13','12:45:00',4.6),('325','2013-06-13','12:50:00',4.61),('325','2013-06-13','12:55:00',4.57),('325','2013-06-13','13:00:00',4.57),('325','2013-06-13','13:05:00',4.57),('325','2013-06-13','13:10:00',4.59),('325','2013-06-13','13:15:00',4.61),('325','2013-06-13','13:20:00',4.56),('325','2013-06-13','13:25:00',4.57),('325','2013-06-13','13:30:00',4.55),('325','2013-06-13','13:35:00',4.58),('325','2013-06-13','13:40:00',4.56),('325','2013-06-13','13:45:00',4.44),('325','2013-06-13','13:50:00',4.39),('325','2013-06-13','13:55:00',4.32),('325','2013-06-13','14:00:00',4.26),('325','2013-06-13','14:05:00',4.2),('325','2013-06-13','14:10:00',4.17),('325','2013-06-13','14:15:00',4.25),('325','2013-06-13','14:20:00',4.32),('325','2013-06-13','14:25:00',4.33),('325','2013-06-13','14:30:00',4),('325','2013-06-13','14:35:00',4.28),('325','2013-06-13','14:40:00',4.43),('325','2013-06-13','14:45:00',4.36),('325','2013-06-13','14:50:00',4.26),('325','2013-06-13','14:55:00',4.23),('325','2013-06-13','15:00:00',4.24),('325','2013-06-13','15:05:00',4.19),('325','2013-06-13','15:10:00',4.12),('325','2013-06-13','15:15:00',4.09),('325','2013-06-13','15:20:00',4.03),('325','2013-06-13','15:25:00',4),('325','2013-06-13','15:30:00',3.95),('325','2013-06-13','15:35:00',3.91),('325','2013-06-13','15:40:00',3.88),('325','2013-06-13','15:45:00',3.83),('325','2013-06-13','15:50:00',3.78),('325','2013-06-13','15:55:00',3.72),('325','2013-06-13','16:00:00',3.66),('325','2013-06-13','16:05:00',3.59),('325','2013-06-13','16:10:00',3.51),('325','2013-06-13','16:15:00',3.47),('325','2013-06-13','16:20:00',3.41),('325','2013-06-13','16:25:00',3.36),('325','2013-06-13','16:30:00',3.29),('325','2013-06-13','16:35:00',3.24),('325','2013-06-13','16:40:00',3.16),('325','2013-06-13','16:45:00',3.04),('325','2013-06-13','16:50:00',2.94),('325','2013-06-13','16:55:00',2.91),('325','2013-06-13','17:00:00',2.82),('325','2013-06-13','17:05:00',2.7),('325','2013-06-13','17:10:00',2.69),('325','2013-06-13','17:15:00',2.6),('325','2013-06-13','17:20:00',2.54),('325','2013-06-13','17:25:00',2.45),('325','2013-06-13','17:30:00',2.37),('325','2013-06-13','17:35:00',2.28),('325','2013-06-13','17:40:00',2.18),('325','2013-06-13','17:45:00',2.11),('325','2013-06-13','17:50:00',2.01),('325','2013-06-13','17:55:00',1.86),('325','2013-06-13','18:00:00',1.77),('325','2013-06-13','18:05:00',1.69),('325','2013-06-13','18:10:00',1.57),('325','2013-06-13','18:15:00',1.4),('325','2013-06-13','18:20:00',1.23),('325','2013-06-13','18:25:00',1.13),('325','2013-06-13','18:30:00',1.05),('325','2013-06-13','18:35:00',1.01),('325','2013-06-12','08:15:00',1.03),('325','2013-06-12','08:20:00',1.08),('325','2013-06-12','08:25:00',1.15),('325','2013-06-12','08:30:00',1.19),('325','2013-06-12','08:35:00',1.26),('325','2013-06-12','08:40:00',1.31),('325','2013-06-12','08:45:00',1.34),('325','2013-06-12','08:50:00',1.34),('325','2013-06-12','08:55:00',1.33),('325','2013-06-12','09:00:00',1.33),('325','2013-06-12','09:05:00',1.37),('325','2013-06-12','09:10:00',1.4),('325','2013-06-12','09:15:00',1.43),('325','2013-06-12','09:20:00',1.5),('325','2013-06-12','09:25:00',2.55),('325','2013-06-12','09:30:00',2.64),('325','2013-06-12','09:35:00',2.7),('325','2013-06-12','09:40:00',2.8),('325','2013-06-12','09:45:00',2.9),('325','2013-06-12','09:50:00',2.91),('325','2013-06-12','09:55:00',2.91),('325','2013-06-12','10:00:00',2.98),('325','2013-06-12','10:05:00',3.06),('325','2013-06-12','10:10:00',3.15),('325','2013-06-12','10:15:00',3.22),('325','2013-06-12','10:20:00',3.27),('325','2013-06-12','10:25:00',3.28),('325','2013-06-12','10:30:00',3.44),('325','2013-06-12','10:35:00',3.49),('325','2013-06-12','10:40:00',3.55),('325','2013-06-12','10:45:00',3.59),('325','2013-06-12','10:50:00',3.61),('325','2013-06-12','10:55:00',3.66),('325','2013-06-12','11:00:00',4.03),('325','2013-06-12','11:05:00',4.16),('325','2013-06-12','11:10:00',4.22),('325','2013-06-12','11:15:00',4.27),('325','2013-06-12','11:20:00',4.29),('325','2013-06-12','11:25:00',4.27),('325','2013-06-12','11:30:00',4.31),('325','2013-06-12','11:35:00',4.32),('325','2013-06-12','11:40:00',4.39),('325','2013-06-12','11:45:00',4.47),('325','2013-06-12','11:50:00',4.45),('325','2013-06-12','11:55:00',4.48),('325','2013-06-12','12:00:00',4.47),('325','2013-06-12','12:05:00',4.32),('325','2013-06-12','12:10:00',4.48),('325','2013-06-12','12:15:00',4.49),('325','2013-06-12','12:20:00',4.6),('325','2013-06-12','12:25:00',3.44),('325','2013-06-12','12:30:00',2.77),('325','2013-06-12','12:35:00',4.93),('325','2013-06-12','12:40:00',4.99),('325','2013-06-12','12:45:00',1.43),('325','2013-06-12','12:50:00',2.01),('325','2013-06-12','12:55:00',3.01),('325','2013-06-12','13:00:00',4.39),('325','2013-06-12','13:05:00',3.02),('325','2013-06-12','13:10:00',4.86),('325','2013-06-12','13:15:00',4.75),('325','2013-06-12','13:20:00',4.69),('325','2013-06-12','13:25:00',4.63),('325','2013-06-12','13:30:00',4.59),('325','2013-06-12','13:35:00',4.61),('325','2013-06-12','13:40:00',4.64),('325','2013-06-12','13:45:00',4.11),('325','2013-06-12','13:50:00',4.54),('325','2013-06-12','13:55:00',4.52),('325','2013-06-12','14:00:00',3.31),('325','2013-06-12','14:05:00',2.33),('325','2013-06-12','14:10:00',1.52),('325','2013-06-12','14:15:00',4.59),('325','2013-06-12','14:20:00',2.56),('325','2013-06-12','14:25:00',2.35),('325','2013-06-12','14:30:00',4.27),('325','2013-06-12','14:35:00',4.02),('325','2013-06-12','14:40:00',4.6),('325','2013-06-12','14:45:00',4.61),('325','2013-06-12','14:50:00',4.61),('325','2013-06-12','14:55:00',4.56),('325','2013-06-12','15:00:00',4.5),('325','2013-06-12','15:05:00',4.43),('325','2013-06-12','15:10:00',4.32),('325','2013-06-12','15:15:00',4.04),('325','2013-06-12','15:20:00',4.3),('325','2013-06-12','15:25:00',4.12),('325','2013-06-12','15:30:00',3.98),('325','2013-06-12','15:35:00',3.95),('325','2013-06-12','15:40:00',3.95),('325','2013-06-12','15:45:00',3.93),('325','2013-06-12','15:50:00',3.94),('325','2013-06-12','15:55:00',3.95),('325','2013-06-12','16:00:00',3.96),('325','2013-06-12','16:05:00',3.76),('325','2013-06-12','16:10:00',3.71),('325','2013-06-12','16:15:00',3.66),('325','2013-06-12','16:20:00',3.57),('325','2013-06-12','16:25:00',3.58),('325','2013-06-12','16:30:00',2.77),('325','2013-06-12','16:35:00',3.16),('325','2013-06-12','16:40:00',3.39),('325','2013-06-12','16:45:00',2.06),('325','2013-06-12','16:50:00',2.8),('325','2013-06-12','16:55:00',2.54),('325','2013-06-12','17:00:00',2.93),('325','2013-06-12','17:05:00',2.86),('325','2013-06-12','17:10:00',2.8),('325','2013-06-12','17:15:00',2.71),('325','2013-06-12','17:20:00',2.62),('325','2013-06-12','17:25:00',2.52),('325','2013-06-12','17:30:00',2.45),('325','2013-06-12','17:35:00',2.4),('325','2013-06-12','17:40:00',2.33),('325','2013-06-12','18:05:00',1.52),('325','2013-06-12','18:10:00',1.64),('325','2013-06-12','18:15:00',1.48),('325','2013-06-12','18:20:00',1.31),('325','2013-06-12','18:25:00',1.17),('325','2013-06-12','18:30:00',1.08),('325','2013-06-12','18:35:00',1.02),('325','2013-06-11','08:05:00',1.05),('325','2013-06-11','08:15:00',1.06),('325','2013-06-11','08:20:00',1.35),('325','2013-06-11','08:25:00',1.47),('325','2013-06-11','08:30:00',1.46),('325','2013-06-11','08:35:00',1.52),('325','2013-06-11','08:40:00',1.58),('325','2013-06-11','08:45:00',1.39),('325','2013-06-11','08:50:00',1.38),('325','2013-06-11','08:55:00',1.58),('325','2013-06-11','09:00:00',1.57),('325','2013-06-11','09:05:00',1.71),('325','2013-06-11','09:10:00',1.73),('325','2013-06-11','09:15:00',1.75),('325','2013-06-11','09:20:00',1.77),('325','2013-06-11','09:25:00',2.05),('325','2013-06-11','09:30:00',2.38),('325','2013-06-11','09:40:00',2.99),('325','2013-06-11','09:45:00',3.21),('325','2013-06-11','09:50:00',3.23),('325','2013-06-11','09:55:00',3),('325','2013-06-11','10:00:00',1.15),('325','2013-06-11','10:05:00',2.3),('325','2013-06-11','10:10:00',3.57),('325','2013-06-11','10:15:00',3.64),('325','2013-06-11','10:20:00',3.74),('325','2013-06-11','10:25:00',3.72),('325','2013-06-11','10:30:00',3.8),('325','2013-06-11','10:35:00',3.91),('325','2013-06-11','10:40:00',3.93),('325','2013-06-11','10:45:00',3.99),('325','2013-06-11','10:50:00',2.2),('325','2013-06-11','10:55:00',2.27),('325','2013-06-11','11:00:00',4.44),('325','2013-06-11','11:05:00',2.18),('325','2013-06-11','11:10:00',3.91),('325','2013-06-11','11:15:00',4.55),('325','2013-06-11','11:20:00',4.41),('325','2013-06-11','11:25:00',4.44),('325','2013-06-11','11:30:00',4.44),('325','2013-06-11','11:35:00',4.49),('325','2013-06-11','11:40:00',4.47),('325','2013-06-11','11:45:00',4.58),('325','2013-06-11','11:50:00',4.65),('325','2013-06-11','11:55:00',4.68),('325','2013-06-11','12:00:00',4.33),('325','2013-06-11','12:05:00',4.77),('325','2013-06-11','12:10:00',4.68),('325','2013-06-11','12:15:00',4.64),('325','2013-06-11','12:20:00',4.57),('325','2013-06-11','12:25:00',4.74),('325','2013-06-11','12:30:00',4.77),('325','2013-06-11','12:35:00',4.8),('325','2013-06-11','12:40:00',4.8),('325','2013-06-11','12:45:00',4.79),('325','2013-06-11','12:50:00',4.86),('325','2013-06-11','12:55:00',4.84),('325','2013-06-11','13:00:00',4.87),('325','2013-06-11','13:05:00',4.88),('325','2013-06-11','13:10:00',4.88),('325','2013-06-11','13:15:00',4.91),('325','2013-06-11','13:20:00',4.88),('325','2013-06-11','13:25:00',4.87),('325','2013-06-11','13:30:00',4.89),('325','2013-06-11','13:35:00',4.87),('325','2013-06-11','13:40:00',4.86),('325','2013-06-11','13:45:00',4.03),('325','2013-06-11','13:50:00',5),('325','2013-06-11','13:55:00',4.78),('325','2013-06-11','14:00:00',4.76),('325','2013-06-11','14:05:00',4.69),('325','2013-06-11','14:10:00',4.66),('325','2013-06-11','14:15:00',4.64),('325','2013-06-11','14:20:00',4.61),('325','2013-06-11','14:25:00',4.62),('325','2013-06-11','14:30:00',4.6),('325','2013-06-11','14:35:00',4.57),('325','2013-06-11','14:40:00',4.56),('325','2013-06-11','14:45:00',4.53),('325','2013-06-11','14:50:00',4.5),('325','2013-06-11','14:55:00',4.46),('325','2013-06-11','15:00:00',4.46),('325','2013-06-11','15:05:00',4.41),('325','2013-06-11','15:10:00',4.38),('325','2013-06-11','15:15:00',4.31),('325','2013-06-11','15:20:00',4.26),('325','2013-06-11','15:25:00',4.2),('325','2013-06-11','15:30:00',4.18),('325','2013-06-11','15:35:00',4.16),('325','2013-06-11','15:40:00',4.03),('325','2013-06-11','15:45:00',4.17),('325','2013-06-11','15:50:00',3.99),('325','2013-06-11','15:55:00',3.98),('325','2013-06-11','16:00:00',3.63),('325','2013-06-11','16:05:00',3.85),('325','2013-06-11','16:10:00',3.76),('325','2013-06-11','16:15:00',3.7),('325','2013-06-11','16:20:00',3.66),('325','2013-06-11','16:25:00',3.6),('325','2013-06-11','16:30:00',3.54),('325','2013-06-11','16:35:00',3.47),('325','2013-06-11','16:40:00',3.47),('325','2013-06-11','16:45:00',3.6),('325','2013-06-11','16:50:00',3.6),('325','2013-06-11','16:55:00',3.43),('325','2013-06-11','17:00:00',2.69),('325','2013-06-11','17:05:00',1.83),('325','2013-06-10','07:35:00',1.1),('325','2013-06-10','08:05:00',1.12),('325','2013-06-10','08:10:00',1.47),('325','2013-06-10','08:15:00',1.38),('325','2013-06-10','08:20:00',1.18),('325','2013-06-10','08:25:00',1.2),('325','2013-06-10','08:30:00',1.08),('325','2013-06-10','08:35:00',1.02),('325','2013-06-10','08:40:00',1.35),('325','2013-06-10','08:55:00',1.09),('325','2013-06-10','09:00:00',1.09),('325','2013-06-10','09:05:00',1.16),('325','2013-06-10','09:10:00',1.17),('325','2013-06-10','09:15:00',1.4),('325','2013-06-10','09:20:00',2.69),('325','2013-06-10','09:25:00',2.88),('325','2013-06-10','09:30:00',2.24),('325','2013-06-10','09:35:00',3.26),('325','2013-06-10','09:40:00',2.2),('325','2013-06-10','09:45:00',3.49),('325','2013-06-10','09:50:00',1.76),('325','2013-06-10','09:55:00',1.59),('325','2013-06-10','10:00:00',1.99),('325','2013-06-10','10:05:00',2.07),('325','2013-06-10','10:10:00',1.95),('325','2013-06-10','10:15:00',1.99),('325','2013-06-10','10:20:00',1.86),('325','2013-06-10','10:25:00',1.94),('325','2013-06-10','10:30:00',1.57),('325','2013-06-10','10:35:00',2.4),('325','2013-06-10','10:40:00',1.52),('325','2013-06-10','10:45:00',1.25),('325','2013-06-10','10:50:00',2.06),('325','2013-06-10','10:55:00',3.72),('325','2013-06-10','11:00:00',2.87),('325','2013-06-10','11:05:00',2.67),('325','2013-06-10','11:10:00',1.86),('325','2013-06-10','11:15:00',3.88),('325','2013-06-10','11:20:00',4.37),('325','2013-06-10','11:25:00',4.66),('325','2013-06-10','11:30:00',4.81),('325','2013-06-10','11:35:00',3.69),('325','2013-06-10','11:40:00',2.83),('325','2013-06-10','11:45:00',2.78),('325','2013-06-10','11:50:00',2.35),('325','2013-06-10','11:55:00',4.89),('325','2013-06-10','12:00:00',3.31),('325','2013-06-10','12:05:00',1.66),('325','2013-06-10','12:10:00',4.11),('325','2013-06-10','12:15:00',4.72),('325','2013-06-10','12:20:00',5.05),('325','2013-06-10','12:25:00',4.59),('325','2013-06-10','12:30:00',5.25),('325','2013-06-10','12:35:00',4.46),('325','2013-06-10','12:40:00',5.44),('325','2013-06-10','12:45:00',2.41),('325','2013-06-10','12:50:00',2.34),('325','2013-06-10','12:55:00',4.93),('325','2013-06-10','13:00:00',5.3),('325','2013-06-10','13:05:00',4.56),('325','2013-06-10','13:10:00',2.17),('325','2013-06-10','13:15:00',3.98),('325','2013-06-10','13:20:00',3.63),('325','2013-06-10','13:25:00',2.63),('325','2013-06-10','13:30:00',3.13),('325','2013-06-10','13:35:00',5.34),('325','2013-06-10','13:40:00',5.18),('325','2013-06-10','13:45:00',4.9),('325','2013-06-10','13:50:00',4.91),('325','2013-06-10','13:55:00',4.69),('325','2013-06-10','14:00:00',4.3),('325','2013-06-10','14:05:00',5.07),('325','2013-06-10','14:10:00',3.76),('325','2013-06-10','14:15:00',4.77),('325','2013-06-10','14:20:00',4.76),('325','2013-06-10','14:25:00',4.69),('325','2013-06-10','14:30:00',4.6),('325','2013-06-10','14:35:00',4.55),('325','2013-06-10','14:40:00',4.07),('325','2013-06-10','14:45:00',4.59),('325','2013-06-10','14:50:00',4.53),('325','2013-06-10','14:55:00',4.5),('325','2013-06-10','15:00:00',4.47),('325','2013-06-10','15:05:00',4.44),('325','2013-06-10','15:10:00',4.39),('325','2013-06-10','15:15:00',4.37),('325','2013-06-10','15:20:00',4.33),('325','2013-06-10','15:25:00',4.3),('325','2013-06-10','15:30:00',4.28),('325','2013-06-10','15:35:00',4.23),('325','2013-06-10','15:40:00',4.17),('325','2013-06-10','15:45:00',4.11),('325','2013-06-10','15:50:00',4.04),('325','2013-06-10','15:55:00',3.99),('325','2013-06-10','16:00:00',3.9),('325','2013-06-10','16:05:00',3.84),('325','2013-06-10','16:10:00',3.78),('325','2013-06-10','16:15:00',3.74),('325','2013-06-10','16:20:00',3.68),('325','2013-06-10','16:25:00',3.63),('325','2013-06-10','16:30:00',3.55),('325','2013-06-10','16:35:00',3.47),('325','2013-06-10','16:40:00',3.41),('325','2013-06-10','16:45:00',3.34),('325','2013-06-10','16:50:00',3.27),('325','2013-06-10','16:55:00',3.18),('325','2013-06-10','17:00:00',3.05),('325','2013-06-10','17:05:00',2.9),('325','2013-06-10','17:10:00',2.9),('325','2013-06-10','17:15:00',2.83),('325','2013-06-10','17:20:00',2.74),('325','2013-06-10','17:25:00',2.64),('325','2013-06-10','17:30:00',2.54),('325','2013-06-10','17:35:00',2.44),('325','2013-06-10','17:40:00',2.34),('325','2013-06-10','17:45:00',2.25),('325','2013-06-10','17:50:00',2.15),('325','2013-06-10','17:55:00',2.02),('325','2013-06-10','18:00:00',1.93),('325','2013-06-10','18:05:00',1.83),('325','2013-06-10','18:10:00',1.7),('325','2013-06-10','18:15:00',1.49),('325','2013-06-10','18:20:00',1.31),('325','2013-06-10','18:25:00',1.21),('325','2013-06-10','18:30:00',1.11),('325','2013-06-10','18:35:00',1.08),('325','2014-04-02','08:50:00',1.13),('325','2014-04-02','09:50:00',1.63),('325','2014-04-02','09:55:00',2.3),('325','2014-04-02','10:00:00',1.93),('325','2014-04-02','10:05:00',2.45),('325','2014-04-02','10:10:00',2.72),('325','2014-04-02','10:15:00',2.88),('325','2014-04-02','10:20:00',2.27),('325','2014-04-02','10:25:00',2.02),('325','2014-04-02','10:30:00',1.21),('325','2014-04-02','10:35:00',1.37),('325','2014-04-02','10:40:00',1.46),('325','2014-04-02','10:45:00',2.31),('325','2014-04-02','10:50:00',3.71),('325','2014-04-02','10:55:00',4.18),('325','2014-04-02','11:00:00',3.43),('325','2014-04-02','11:05:00',1.39),('325','2014-04-02','11:10:00',1.7),('325','2014-04-02','11:15:00',4.03),('325','2014-04-02','11:20:00',4.15),('325','2014-04-02','11:25:00',4.69),('325','2014-04-02','11:30:00',3.22),('325','2014-04-02','11:35:00',1.2),('325','2014-04-02','11:40:00',1.2),('325','2014-04-02','11:45:00',3.21),('325','2014-04-02','11:50:00',4.58),('325','2014-04-02','11:55:00',4.69),('325','2014-04-02','12:00:00',4.21),('325','2014-04-02','12:05:00',1.5),('325','2014-04-02','12:10:00',2.33),('325','2014-04-02','12:15:00',4.7),('325','2014-04-02','12:20:00',4.14),('325','2014-04-02','12:25:00',2.57),('325','2014-04-02','12:30:00',4.88),('325','2014-04-02','12:35:00',4.91),('325','2014-04-02','12:40:00',4.9),('325','2014-04-02','12:45:00',3.67),('325','2014-04-02','12:50:00',4.35),('325','2014-04-02','12:55:00',1.98),('325','2014-04-02','13:00:00',3.48),('325','2014-04-02','13:05:00',5.29),('325','2014-04-02','13:10:00',4.34),('325','2014-04-02','13:15:00',4.23),('325','2014-04-02','13:20:00',4.68),('325','2014-04-02','13:25:00',4.76),('325','2014-04-02','13:30:00',4.76),('325','2014-04-02','13:35:00',3.9),('325','2014-04-02','13:40:00',4.84),('325','2014-04-02','13:45:00',4.63),('325','2014-04-02','13:50:00',4.65),('325','2014-04-02','13:55:00',4.64),('325','2014-04-02','14:00:00',4.56),('325','2014-04-02','14:05:00',4.54),('325','2014-04-02','14:10:00',4.54),('325','2014-04-02','14:15:00',4.47),('325','2014-04-02','14:20:00',4.38),('325','2014-04-02','14:25:00',4.48),('325','2014-04-02','14:30:00',4.41),('325','2014-04-02','14:35:00',4.35),('325','2014-04-02','14:40:00',4.28),('325','2014-04-02','14:45:00',4.07),('325','2014-04-02','14:50:00',4.14),('325','2014-04-02','14:55:00',3.82),('325','2014-04-02','15:00:00',4.03),('325','2014-04-02','15:05:00',4.05),('325','2014-04-02','15:10:00',3.75),('325','2014-04-02','15:15:00',3.85),('325','2014-04-02','15:20:00',3.85),('325','2014-04-02','15:25:00',3.78),('325','2014-04-02','15:30:00',3.56),('325','2014-04-02','15:35:00',3.47),('325','2014-04-02','15:40:00',3.53),('325','2014-04-02','15:45:00',3.63),('325','2014-04-02','15:50:00',3.58),('325','2014-04-02','15:55:00',3.11),('325','2014-04-02','16:00:00',3.27),('325','2014-04-02','16:05:00',3.24),('325','2014-04-02','16:10:00',3.2),('325','2014-04-02','16:15:00',3.1),('325','2014-04-02','16:20:00',3.01),('325','2014-04-02','16:25:00',2.89),('325','2014-04-02','16:30:00',2.94),('325','2014-04-02','16:35:00',2.87),('325','2014-04-02','16:40:00',2.73),('325','2014-04-02','16:45:00',2.54),('325','2014-04-02','16:50:00',2.37),('325','2014-04-02','16:55:00',2.37),('325','2014-04-02','17:00:00',2.41),('325','2014-04-02','17:05:00',2.17),('325','2014-04-02','17:10:00',2.08),('325','2014-04-02','17:15:00',1.85),('325','2014-04-02','17:20:00',1.85),('325','2014-04-02','17:25:00',1.72),('325','2014-04-02','17:30:00',1.54),('325','2014-04-02','17:35:00',1.51),('325','2014-04-02','17:40:00',1.12),('325','2014-04-02','17:45:00',1.14),('325','2014-04-02','17:50:00',1.38),('325','2014-04-02','17:55:00',1.18),('325','2014-04-02','18:00:00',1.07),('325','2013-06-09','07:35:00',1.01),('325','2013-06-09','08:20:00',1.14),('325','2013-06-09','08:25:00',1.2),('325','2013-06-09','08:30:00',1.28),('325','2013-06-09','08:35:00',1.35),('325','2013-06-09','08:40:00',1.37),('325','2013-06-09','08:45:00',1.39),('325','2013-06-09','08:50:00',1.43),('325','2013-06-09','08:55:00',1.44),('325','2013-06-09','09:00:00',1.46),('325','2013-06-09','09:05:00',1.5),('325','2013-06-09','09:10:00',1.53),('325','2013-06-09','09:15:00',1.56),('325','2013-06-09','09:20:00',1.75),('325','2013-06-09','09:25:00',2.46),('325','2013-06-09','09:30:00',2.56),('325','2013-06-09','09:35:00',2.67),('325','2013-06-09','09:40:00',2.68),('325','2013-06-09','09:45:00',2.71),('325','2013-06-09','09:50:00',2.83),('325','2013-06-09','09:55:00',2.85),('325','2013-06-09','10:00:00',2.92),('325','2013-06-09','10:05:00',3.02),('325','2013-06-09','10:10:00',3.11),('325','2013-06-09','10:15:00',3.14),('325','2013-06-09','10:20:00',3.18),('325','2013-06-09','10:25:00',3.28),('325','2013-06-09','10:30:00',3.34),('325','2013-06-09','10:35:00',3.37),('325','2013-06-09','10:40:00',3.45),('325','2013-06-09','10:45:00',3.44),('325','2013-06-09','10:50:00',3.45),('325','2013-06-09','10:55:00',3.53),('325','2013-06-09','11:00:00',3.56),('325','2013-06-09','11:05:00',3.56),('325','2013-06-09','11:10:00',3.76),('325','2013-06-09','11:15:00',3.92),('325','2013-06-09','11:20:00',4.03),('325','2013-06-09','11:25:00',4),('325','2013-06-09','11:30:00',4.05),('325','2013-06-09','11:35:00',4.13),('325','2013-06-09','11:40:00',4.19),('325','2013-06-09','11:45:00',4.26),('325','2013-06-09','11:50:00',4.21),('325','2013-06-09','11:55:00',4.2),('325','2013-06-09','12:00:00',4.2),('325','2013-06-09','12:05:00',4.3),('325','2013-06-09','12:10:00',3.8),('325','2013-06-09','12:15:00',4.14),('325','2013-06-09','12:20:00',4.37),('325','2013-06-09','12:25:00',4.45),('325','2013-06-09','12:30:00',4.4),('325','2013-06-09','12:35:00',4.32),('325','2013-06-09','12:40:00',4.38),('325','2013-06-09','12:45:00',4.23),('325','2013-06-09','12:50:00',4.53),('325','2013-06-09','12:55:00',3.9),('325','2013-06-09','13:00:00',4.03),('325','2013-06-09','13:05:00',2.62),('325','2013-06-09','13:10:00',2.08),('325','2013-06-09','13:15:00',2.51),('325','2013-06-09','13:20:00',2.81),('325','2013-06-09','13:25:00',4.96),('325','2013-06-09','13:30:00',4.69),('325','2013-06-09','13:35:00',4.7),('325','2013-06-09','13:40:00',4.83),('325','2013-06-09','13:45:00',4.84),('325','2013-06-09','13:50:00',4.99),('325','2013-06-09','13:55:00',4.49),('325','2013-06-09','14:00:00',4.79),('325','2013-06-09','14:05:00',4.66),('325','2013-06-09','14:10:00',4.75),('325','2013-06-09','14:15:00',3.23),('325','2013-06-09','14:20:00',2.06),('325','2013-06-09','14:25:00',1.21),('325','2013-06-09','14:30:00',1.74),('325','2013-06-09','14:35:00',4.2),('325','2013-06-09','14:40:00',4.14),('325','2013-06-09','14:45:00',4.31),('325','2013-06-09','14:50:00',4.41),('325','2013-06-09','14:55:00',4.42),('325','2013-06-09','15:00:00',4.33),('325','2013-06-09','15:05:00',4.16),('325','2013-06-09','15:10:00',4.22),('325','2013-06-09','15:15:00',4.14),('325','2013-06-09','15:20:00',4.1),('325','2013-06-09','15:25:00',4.11),('325','2013-06-09','15:30:00',3.99),('325','2013-06-09','15:35:00',3.98),('325','2013-06-09','15:40:00',3.11),('325','2013-06-09','15:45:00',3.17),('325','2013-06-09','15:50:00',3.66),('325','2013-06-09','15:55:00',3.89),('325','2013-06-09','16:00:00',2.8),('325','2013-06-09','16:05:00',3.64),('325','2013-06-09','16:10:00',3.35),('325','2013-06-09','16:15:00',1.92),('325','2013-06-09','16:20:00',1.83),('325','2013-06-09','16:25:00',2.32),('325','2013-06-09','16:30:00',1.44),('325','2013-06-09','16:35:00',1.03),('325','2013-06-09','17:05:00',1),('325','2013-06-09','18:00:00',1.08),('325','2013-06-09','18:10:00',1.41),('325','2013-06-08','08:15:00',1.01),('325','2013-06-08','08:20:00',1.07),('325','2013-06-08','08:25:00',1.13),('325','2013-06-08','08:30:00',1.18),('325','2013-06-08','08:35:00',1.25),('325','2013-06-08','08:40:00',1.29),('325','2013-06-08','08:45:00',1.34),('325','2013-06-08','08:50:00',1.34),('325','2013-06-08','08:55:00',1.33),('325','2013-06-08','09:00:00',1.35),('325','2013-06-08','09:05:00',1.4),('325','2013-06-08','09:10:00',1.41),('325','2013-06-08','09:15:00',1.45),('325','2013-06-08','09:20:00',1.5),('325','2013-06-08','09:25:00',1.53),('325','2013-06-08','09:30:00',1.84),('325','2013-06-08','09:35:00',2.63),('325','2013-06-08','09:40:00',2.71),('325','2013-06-08','09:45:00',2.8),('325','2013-06-08','09:50:00',2.8),('325','2013-06-08','09:55:00',2.87),('325','2013-06-08','10:00:00',2.93),('325','2013-06-08','10:05:00',2.23),('325','2013-06-08','10:10:00',2.4),('325','2013-06-08','10:15:00',2.66),('325','2013-06-08','10:20:00',3.44),('325','2013-06-08','10:25:00',3.46),('325','2013-06-08','10:30:00',3.32),('325','2013-06-08','10:35:00',3.69),('325','2013-06-08','10:40:00',3.81),('325','2013-06-08','10:45:00',3.75),('325','2013-06-08','10:50:00',4.03),('325','2013-06-08','10:55:00',2.23),('325','2013-06-08','11:00:00',1.37),('325','2013-06-08','11:05:00',3.02),('325','2013-06-08','11:10:00',3.87),('325','2013-06-08','11:15:00',4.73),('325','2013-06-08','11:20:00',4),('325','2013-06-08','11:25:00',3.35),('325','2013-06-08','11:30:00',1.05),('325','2013-06-08','11:35:00',3.25),('325','2013-06-08','11:40:00',3.74),('325','2013-06-08','11:45:00',3.46),('325','2013-06-08','11:50:00',4.27),('325','2013-06-08','11:55:00',4.95),('325','2013-06-08','12:00:00',3.66),('325','2013-06-08','12:05:00',1.19),('325','2013-06-08','12:10:00',3.46),('325','2013-06-08','12:15:00',3.8),('325','2013-06-08','12:20:00',2.13),('325','2013-06-08','12:25:00',4.8),('325','2013-06-08','12:30:00',4.76),('325','2013-06-08','12:35:00',4.7),('325','2013-06-08','12:40:00',4.26),('325','2013-06-08','12:45:00',4.72),('325','2013-06-08','12:50:00',4.75),('325','2013-06-08','12:55:00',4.69),('325','2013-06-08','13:00:00',4.73),('325','2013-06-08','13:05:00',4.7),('325','2013-06-08','13:10:00',4.72),('325','2013-06-08','13:15:00',4.72),('325','2013-06-08','13:20:00',4.78),('325','2013-06-08','13:25:00',4.77),('325','2013-06-08','13:30:00',4.85),('325','2013-06-08','13:35:00',4.77),('325','2013-06-08','13:40:00',4.71),('325','2013-06-08','13:45:00',4.62),('325','2013-06-08','13:50:00',4.56),('325','2013-06-08','13:55:00',4.51),('325','2013-06-08','14:00:00',4.48),('325','2013-06-08','14:05:00',4.38),('325','2013-06-08','14:10:00',4.32),('325','2013-06-08','14:15:00',4.27),('325','2013-06-08','14:20:00',4.24),('325','2013-06-08','14:25:00',4.32),('325','2013-06-08','14:30:00',4.46),('325','2013-06-08','14:35:00',4.48),('325','2013-06-08','14:40:00',4.49),('325','2013-06-08','14:45:00',4.46),('325','2013-06-08','14:50:00',4.46),('325','2013-06-08','14:55:00',4.43),('325','2013-06-08','15:00:00',4.39),('325','2013-06-08','15:05:00',4.24),('325','2013-06-08','15:10:00',3.96),('325','2013-06-08','15:15:00',4.16),('325','2013-06-08','15:20:00',4.31),('325','2013-06-08','15:25:00',4.03),('325','2013-06-08','15:30:00',4.11),('325','2013-06-08','15:35:00',4.05),('325','2013-06-08','15:40:00',3.13),('325','2013-06-08','15:45:00',4.31),('325','2013-06-08','15:50:00',4.24),('325','2013-06-08','15:55:00',3.87),('325','2013-06-08','16:00:00',3.93),('325','2013-06-08','16:05:00',3.85),('325','2013-06-08','16:10:00',3.84),('325','2013-06-08','16:15:00',3.85),('325','2013-06-08','16:20:00',3.74),('325','2013-06-08','16:25:00',3.61),('325','2013-06-08','16:30:00',3.46),('325','2013-06-08','16:35:00',3.39),('325','2013-06-08','16:40:00',3.3),('325','2013-06-08','16:45:00',3.23),('325','2013-06-08','16:50:00',2.72),('325','2013-06-08','16:55:00',2.79),('325','2013-06-08','17:00:00',2.97),('325','2013-06-08','17:05:00',2.83),('325','2013-06-08','17:10:00',3.08),('325','2013-06-08','17:15:00',3),('325','2013-06-08','17:20:00',2.84),('325','2013-06-08','17:25:00',2.64),('325','2013-06-08','17:30:00',1.9),('325','2013-06-08','17:35:00',1.45),('325','2013-06-08','17:40:00',2.25),('325','2013-06-08','17:45:00',2.29),('325','2013-06-08','17:50:00',2.13),('325','2013-06-08','17:55:00',2.07),('325','2013-06-08','18:00:00',1.7),('325','2013-06-08','18:05:00',1.48),('325','2013-06-08','18:10:00',1.21),('325','2013-06-08','18:15:00',1.18),('325','2013-06-08','18:20:00',1.08),('325','2013-06-07','08:15:00',1.03),('325','2013-06-07','08:20:00',1.07),('325','2013-06-07','08:25:00',1.15),('325','2013-06-07','08:30:00',1.19),('325','2013-06-07','08:35:00',1.27),('325','2013-06-07','08:40:00',1.31),('325','2013-06-07','08:45:00',1.35),('325','2013-06-07','08:50:00',1.34),('325','2013-06-07','08:55:00',1.32),('325','2013-06-07','09:00:00',1.34),('325','2013-06-07','09:05:00',1.38),('325','2013-06-07','09:10:00',1.4),('325','2013-06-07','09:15:00',1.43),('325','2013-06-07','09:20:00',1.52),('325','2013-06-07','09:25:00',2.68),('325','2013-06-07','09:30:00',2.76),('325','2013-06-07','09:35:00',2.84),('325','2013-06-07','09:40:00',2.88),('325','2013-06-07','09:45:00',2.97),('325','2013-06-07','09:50:00',3),('325','2013-06-07','09:55:00',3.05),('325','2013-06-07','10:00:00',3.13),('325','2013-06-07','10:05:00',3.32),('325','2013-06-07','10:10:00',3.46),('325','2013-06-07','10:15:00',3.53),('325','2013-06-07','10:20:00',3.62),('325','2013-06-07','10:25:00',3.69),('325','2013-06-07','10:30:00',3.77),('325','2013-06-07','10:35:00',3.85),('325','2013-06-07','10:40:00',3.91),('325','2013-06-07','10:45:00',3.93),('325','2013-06-07','10:50:00',3.97),('325','2013-06-07','10:55:00',4.08),('325','2013-06-07','11:00:00',4.15),('325','2013-06-07','11:05:00',4.21),('325','2013-06-07','11:10:00',4.29),('325','2013-06-07','11:15:00',4.3),('325','2013-06-07','11:20:00',4.32),('325','2013-06-07','11:25:00',4.36),('325','2013-06-07','11:30:00',4.4),('325','2013-06-07','11:35:00',4.41),('325','2013-06-07','11:40:00',4.46),('325','2013-06-07','11:45:00',4.51),('325','2013-06-07','11:50:00',4.52),('325','2013-06-07','11:55:00',4.56),('325','2013-06-07','12:00:00',4.57),('325','2013-06-07','12:05:00',4.57),('325','2013-06-07','12:10:00',4.56),('325','2013-06-07','12:15:00',4.56),('325','2013-06-07','12:20:00',4.64),('325','2013-06-07','12:25:00',4.63),('325','2013-06-07','12:30:00',4.66),('325','2013-06-07','12:35:00',4.65),('325','2013-06-07','12:40:00',4.65),('325','2013-06-07','12:45:00',4.69),('325','2013-06-07','12:50:00',4.69),('325','2013-06-07','12:55:00',4.68),('325','2013-06-07','13:00:00',4.67),('325','2013-06-07','13:05:00',4.64),('325','2013-06-07','13:10:00',4.63),('325','2013-06-07','13:15:00',4.62),('325','2013-06-07','13:20:00',4.62),('325','2013-06-07','13:25:00',4.63),('325','2013-06-07','13:30:00',4.6),('325','2013-06-07','13:35:00',4.59),('325','2013-06-07','13:40:00',4.55),('325','2013-06-07','13:45:00',4.48),('325','2013-06-07','13:50:00',4.4),('325','2013-06-07','13:55:00',4.43),('325','2013-06-07','14:00:00',4.4),('325','2013-06-07','14:05:00',4.37),('325','2013-06-07','14:10:00',4.35),('325','2013-06-07','14:15:00',4.34),('325','2013-06-07','14:20:00',4.27),('325','2013-06-07','14:25:00',4.28),('325','2013-06-07','14:30:00',4.21),('325','2013-06-07','14:35:00',4.19),('325','2013-06-07','14:40:00',4.22),('325','2013-06-07','14:45:00',4.24),('325','2013-06-07','14:50:00',4.22),('325','2013-06-07','14:55:00',4.18),('325','2013-06-07','15:00:00',4.19),('325','2013-06-07','15:05:00',4.22),('325','2013-06-07','15:10:00',4.16),('325','2013-06-07','15:15:00',4.13),('325','2013-06-07','15:20:00',4.14),('325','2013-06-07','15:25:00',4.14),('325','2013-06-07','15:30:00',4.1),('325','2013-06-07','15:35:00',4.05),('325','2013-06-07','15:40:00',3.97),('325','2013-06-07','15:45:00',3.94),('325','2013-06-07','15:50:00',3.88),('325','2013-06-07','15:55:00',3.81),('325','2013-06-07','16:00:00',3.75),('325','2013-06-07','16:05:00',3.67),('325','2013-06-07','16:10:00',3.52),('325','2013-06-07','16:15:00',3.36),('325','2013-06-07','16:20:00',3.42),('325','2013-06-07','16:25:00',3.46),('325','2013-06-07','16:30:00',3.42),('325','2013-06-07','16:35:00',3.35),('325','2013-06-07','16:40:00',3.28),('325','2013-06-07','16:45:00',3.22),('325','2013-06-07','16:50:00',3.15),('325','2013-06-07','16:55:00',3.06),('325','2013-06-07','17:00:00',2.91),('325','2013-06-07','17:05:00',2.77);
INSERT INTO `solarlog` VALUES ('325','2013-06-07','17:10:00',2.78),('325','2013-06-07','17:15:00',2.62),('325','2013-06-07','17:20:00',2.54),('325','2013-06-07','17:25:00',2.48),('325','2013-06-07','17:30:00',2.39),('325','2013-06-07','17:35:00',2.31),('325','2013-06-07','17:40:00',2.22),('325','2013-06-07','17:45:00',2.19),('325','2013-06-07','17:50:00',2.1),('325','2013-06-07','17:55:00',1.94),('325','2013-06-07','18:00:00',1.85),('325','2013-06-07','18:05:00',1.77),('325','2013-06-07','18:10:00',1.62),('325','2013-06-07','18:15:00',1.42),('325','2013-06-07','18:20:00',1.24),('325','2013-06-07','18:25:00',1.09),('325','2013-06-07','18:30:00',1.01),('325','2013-06-06','08:20:00',1.07),('325','2013-06-06','08:25:00',1.24),('325','2013-06-06','08:30:00',1.27),('325','2013-06-06','08:35:00',1.33),('325','2013-06-06','08:40:00',1.37),('325','2013-06-06','08:45:00',1.38),('325','2013-06-06','08:50:00',1.43),('325','2013-06-06','08:55:00',1.46),('325','2013-06-06','09:00:00',1.5),('325','2013-06-06','09:05:00',1.55),('325','2013-06-06','09:10:00',1.58),('325','2013-06-06','09:15:00',1.62),('325','2013-06-06','09:20:00',1.67),('325','2013-06-06','09:25:00',2.49),('325','2013-06-06','09:30:00',2.74),('325','2013-06-06','09:35:00',2.78),('325','2013-06-06','09:40:00',2.83),('325','2013-06-06','09:45:00',3.01),('325','2013-06-06','09:50:00',3.1),('325','2013-06-06','09:55:00',3.2),('325','2013-06-06','10:00:00',3.18),('325','2013-06-06','10:05:00',3.21),('325','2013-06-06','10:10:00',3.27),('325','2013-06-06','10:15:00',3.44),('325','2013-06-06','10:20:00',3.52),('325','2013-06-06','10:25:00',3.63),('325','2013-06-06','10:30:00',3.66),('325','2013-06-06','10:35:00',3.72),('325','2013-06-06','10:40:00',3.81),('325','2013-06-06','10:45:00',3.83),('325','2013-06-06','10:50:00',3.89),('325','2013-06-06','10:55:00',4.01),('325','2013-06-06','11:00:00',4.06),('325','2013-06-06','11:05:00',4.12),('325','2013-06-06','11:10:00',4.13),('325','2013-06-06','11:15:00',4.18),('325','2013-06-06','11:20:00',4.23),('325','2013-06-06','11:25:00',4.28),('325','2013-06-06','11:30:00',4.28),('325','2013-06-06','11:35:00',4.29),('325','2013-06-06','11:40:00',4.28),('325','2013-06-06','11:45:00',4.42),('325','2013-06-06','11:50:00',4.43),('325','2013-06-06','11:55:00',4.47),('325','2013-06-06','12:00:00',4.47),('325','2013-06-06','12:05:00',4.46),('325','2013-06-06','12:10:00',4.5),('325','2013-06-06','12:15:00',4.44),('325','2013-06-06','12:20:00',4.46),('325','2013-06-06','12:25:00',4.5),('325','2013-06-06','12:30:00',4.48),('325','2013-06-06','12:35:00',4.44),('325','2013-06-06','12:40:00',4.55),('325','2013-06-06','12:45:00',4.58),('325','2013-06-06','12:50:00',4.62),('325','2013-06-06','12:55:00',4.64),('325','2013-06-06','13:00:00',4.68),('325','2013-06-06','13:05:00',4.67),('325','2013-06-06','13:10:00',4.68),('325','2013-06-06','13:15:00',4.63),('325','2013-06-06','13:20:00',4.59),('325','2013-06-06','13:25:00',4.57),('325','2013-06-06','13:30:00',4.71),('325','2013-06-06','13:35:00',4.05),('325','2013-06-06','13:45:00',1.06),('325','2013-06-06','13:50:00',2.89),('325','2013-06-06','13:55:00',4.47),('325','2013-06-06','14:00:00',4.38),('325','2013-06-06','14:05:00',1.53),('325','2013-06-06','14:10:00',2.73),('325','2013-06-06','14:15:00',1.62),('325','2013-06-06','14:20:00',3.38),('325','2013-06-06','14:25:00',4.68),('325','2013-06-06','14:30:00',4.53),('325','2013-06-06','14:35:00',4.46),('325','2013-06-06','14:40:00',4.46),('325','2013-06-06','14:45:00',3.75),('325','2013-06-06','14:50:00',4.66),('325','2013-06-06','14:55:00',4.46),('325','2013-06-06','15:00:00',4.32),('325','2013-06-06','15:05:00',4.39),('325','2013-06-06','15:10:00',4.37),('325','2013-06-06','15:15:00',4.21),('325','2013-06-06','15:20:00',4.19),('325','2013-06-06','15:25:00',3.78),('325','2013-06-06','15:30:00',3.96),('325','2013-06-06','15:35:00',3.91),('325','2013-06-06','15:40:00',3.97),('325','2013-06-06','15:45:00',3.94),('325','2013-06-06','15:50:00',3.85),('325','2013-06-06','15:55:00',3.77),('325','2013-06-06','16:00:00',3.88),('325','2013-06-06','16:05:00',3.8),('325','2013-06-06','16:10:00',3.68),('325','2013-06-06','16:15:00',3.42),('325','2013-06-06','16:20:00',3.45),('325','2013-06-06','16:25:00',3.35),('325','2013-06-06','16:30:00',3.31),('325','2013-06-06','16:35:00',3.32),('325','2013-06-06','16:40:00',3.24),('325','2013-06-06','16:45:00',3.11),('325','2013-06-06','16:50:00',3.04),('325','2013-06-06','16:55:00',2.93),('325','2013-06-06','17:00:00',2.77),('325','2013-06-06','17:05:00',2.7),('325','2013-06-06','17:10:00',2.66),('325','2013-06-06','17:15:00',2.55),('325','2013-06-06','17:20:00',2.47),('325','2013-06-06','17:25:00',2.43),('325','2013-06-06','17:30:00',2.33),('325','2013-06-06','17:35:00',2.25),('325','2013-06-06','17:40:00',2.15),('325','2013-06-06','17:45:00',2.06),('325','2013-06-06','17:50:00',1.93),('325','2013-06-06','17:55:00',1.79),('325','2013-06-06','18:00:00',1.75),('325','2013-06-06','18:05:00',1.69),('325','2013-06-06','18:10:00',1.56),('325','2013-06-06','18:15:00',1.38),('325','2013-06-06','18:20:00',1.2),('325','2013-06-06','18:25:00',1.07),('325','2013-06-05','07:50:00',1.15),('325','2013-06-05','07:55:00',1.23),('325','2013-06-05','08:00:00',1.14),('325','2013-06-05','08:05:00',1.03),('325','2013-06-05','08:15:00',1.03),('325','2013-06-05','08:20:00',1.04),('325','2013-06-05','08:25:00',1.19),('325','2013-06-05','08:30:00',1.24),('325','2013-06-05','08:35:00',1.31),('325','2013-06-05','08:40:00',1.36),('325','2013-06-05','08:45:00',1.4),('325','2013-06-05','08:50:00',1.4),('325','2013-06-05','08:55:00',1.42),('325','2013-06-05','09:00:00',1.49),('325','2013-06-05','09:05:00',1.61),('325','2013-06-05','09:10:00',1.7),('325','2013-06-05','09:15:00',1.74),('325','2013-06-05','09:20:00',1.3),('325','2013-06-05','09:25:00',2.17),('325','2013-06-05','09:30:00',3.14),('325','2013-06-05','09:35:00',3.33),('325','2013-06-05','09:40:00',3.11),('325','2013-06-05','09:45:00',1.43),('325','2013-06-05','09:50:00',2),('325','2013-06-05','09:55:00',2.81),('325','2013-06-05','10:00:00',2.84),('325','2013-06-05','10:05:00',2.99),('325','2013-06-05','10:10:00',3.43),('325','2013-06-05','10:15:00',2.82),('325','2013-06-05','10:20:00',3.39),('325','2013-06-05','10:25:00',1.58),('325','2013-06-05','10:30:00',1.29),('325','2013-06-05','10:35:00',2.12),('325','2013-06-05','10:40:00',3.15),('325','2013-06-05','10:45:00',4.28),('325','2013-06-05','10:50:00',4.38),('325','2013-06-05','10:55:00',4.02),('325','2013-06-05','11:00:00',1.31),('325','2013-06-05','11:05:00',1.25),('325','2013-06-05','11:10:00',1.11),('325','2013-06-05','11:15:00',1.15),('325','2013-06-05','11:20:00',1.13),('325','2013-06-05','11:25:00',1.22),('325','2013-06-05','11:30:00',2.62),('325','2013-06-05','11:35:00',5.12),('325','2013-06-05','11:40:00',2.25),('325','2013-06-05','11:45:00',1.46),('325','2013-06-05','11:50:00',3.13),('325','2013-06-05','11:55:00',5.17),('325','2013-06-05','12:00:00',5.13),('325','2013-06-05','12:05:00',5.06),('325','2013-06-05','12:10:00',5.09),('325','2013-06-05','12:15:00',5.02),('325','2013-06-05','12:20:00',5.17),('325','2013-06-05','12:25:00',4.48),('325','2013-06-05','12:30:00',4.48),('325','2013-06-05','12:35:00',2.07),('325','2013-06-05','12:40:00',5.56),('325','2013-06-05','12:45:00',4.17),('325','2013-06-05','12:50:00',2.59),('325','2013-06-05','12:55:00',3.35),('325','2013-06-05','13:00:00',4.43),('325','2013-06-05','13:05:00',3.27),('325','2013-06-05','13:10:00',4.7),('325','2013-06-05','13:15:00',4.34),('325','2013-06-05','13:20:00',3.27),('325','2013-06-05','13:25:00',3.96),('325','2013-06-05','13:30:00',5.44),('325','2013-06-05','13:35:00',5.2),('325','2013-06-05','13:40:00',4.96),('325','2013-06-05','13:45:00',4.9),('325','2013-06-05','13:50:00',4.86),('325','2013-06-05','13:55:00',4.84),('325','2013-06-05','14:00:00',4.81),('325','2013-06-05','14:05:00',4.78),('325','2013-06-05','14:10:00',4.74),('325','2013-06-05','14:15:00',4.71),('325','2013-06-05','14:20:00',4.68),('325','2013-06-05','14:25:00',4.64),('325','2013-06-05','14:30:00',4.62),('325','2013-06-05','14:35:00',4.47),('325','2013-06-05','14:40:00',4.61),('325','2013-06-05','14:45:00',4.6),('325','2013-06-05','14:50:00',4.53),('325','2013-06-05','14:55:00',4.51),('325','2013-06-05','15:00:00',4.45),('325','2013-06-05','15:05:00',4.39),('325','2013-06-05','15:10:00',4.36),('325','2013-06-05','15:15:00',4.32),('325','2013-06-05','15:20:00',4.3),('325','2013-06-05','15:25:00',4.25),('325','2013-06-05','15:30:00',4.3),('325','2013-06-05','15:35:00',4.27),('325','2013-06-05','15:40:00',4.02),('325','2013-06-05','15:45:00',4.11),('325','2013-06-05','15:50:00',4.05),('325','2013-06-05','15:55:00',4.01),('325','2013-06-05','16:00:00',3.96),('325','2013-06-05','16:05:00',3.55),('325','2013-06-05','16:10:00',3.84),('325','2013-06-05','16:15:00',3.78),('325','2013-06-05','16:20:00',3.67),('325','2013-06-05','16:25:00',3.6),('325','2013-06-05','16:30:00',3.51),('325','2013-06-05','16:35:00',3.44),('325','2013-06-05','16:40:00',3.38),('325','2013-06-05','16:45:00',3.34),('325','2013-06-05','16:50:00',2.87),('325','2013-06-05','16:55:00',2.87),('325','2013-06-05','17:00:00',1.62),('325','2013-06-05','17:05:00',2.34),('325','2013-06-05','17:10:00',1.72),('325','2013-06-05','17:15:00',1.77),('325','2013-06-05','17:20:00',2.58),('325','2013-06-05','17:25:00',2.62),('325','2013-06-05','17:30:00',1.97),('325','2013-06-05','17:35:00',1.87),('325','2013-06-05','17:40:00',2.33),('325','2013-06-05','17:45:00',2.15),('325','2013-06-05','17:50:00',2),('325','2013-06-05','17:55:00',1.83),('325','2013-06-05','18:00:00',1.39),('325','2013-06-05','18:05:00',1.49),('325','2013-06-05','18:10:00',1.44),('325','2013-06-05','18:25:00',1.07),('325','2013-06-05','18:30:00',1.09),('325','2013-06-05','18:35:00',1.08),('325','2013-06-04','07:50:00',1.07),('325','2013-06-04','07:55:00',1.21),('325','2013-06-04','08:00:00',1.42),('325','2013-06-04','08:05:00',1.54),('325','2013-06-04','08:10:00',1.5),('325','2013-06-04','08:15:00',1.52),('325','2013-06-04','08:20:00',1.52),('325','2013-06-04','08:25:00',1.54),('325','2013-06-04','08:30:00',1.71),('325','2013-06-04','08:35:00',1.81),('325','2013-06-04','08:40:00',1.79),('325','2013-06-04','08:45:00',1.61),('325','2013-06-04','08:50:00',1.41),('325','2013-06-04','08:55:00',1.42),('325','2013-06-04','09:00:00',1.6),('325','2013-06-04','09:05:00',1.7),('325','2013-06-04','09:10:00',2.09),('325','2013-06-04','09:15:00',2.59),('325','2013-06-04','09:20:00',2.67),('325','2013-06-04','09:25:00',2.19),('325','2013-06-04','09:30:00',2.63),('325','2013-06-04','09:35:00',1.9),('325','2013-06-04','09:40:00',1.97),('325','2013-06-04','09:45:00',1.98),('325','2013-06-04','09:50:00',2.04),('325','2013-06-04','09:55:00',1.9),('325','2013-06-04','10:00:00',2.09),('325','2013-06-04','10:05:00',2.9),('325','2013-06-04','10:10:00',2.18),('325','2013-06-04','10:15:00',1.77),('325','2013-06-04','10:20:00',1.97),('325','2013-06-04','10:25:00',1.89),('325','2013-06-04','10:30:00',1.7),('325','2013-06-04','10:35:00',1.74),('325','2013-06-04','10:40:00',1.96),('325','2013-06-04','10:45:00',2.42),('325','2013-06-04','10:50:00',2.99),('325','2013-06-04','10:55:00',2.91),('325','2013-06-04','11:00:00',2.29),('325','2013-06-04','11:05:00',3.01),('325','2013-06-04','11:10:00',3.85),('325','2013-06-04','11:15:00',3.31),('325','2013-06-04','11:20:00',2.43),('325','2013-06-04','11:25:00',3.04),('325','2013-06-04','11:30:00',3.48),('325','2013-06-04','11:35:00',3.08),('325','2013-06-04','11:40:00',3.45),('325','2013-06-04','11:45:00',3.98),('325','2013-06-04','11:50:00',4.72),('325','2013-06-04','11:55:00',3.05),('325','2013-06-04','12:00:00',3.02),('325','2013-06-04','12:05:00',4.25),('325','2013-06-04','12:10:00',2.79),('325','2013-06-04','12:15:00',2.05),('325','2013-06-04','12:20:00',2.41),('325','2013-06-04','12:25:00',2.38),('325','2013-06-04','12:30:00',3.5),('325','2013-06-04','12:35:00',3.97),('325','2013-06-04','12:40:00',2.58),('325','2013-06-04','12:45:00',3.1),('325','2013-06-04','12:50:00',1.96),('325','2013-06-04','12:55:00',1.79),('325','2013-06-04','13:00:00',1.8),('325','2013-06-04','13:05:00',1.62),('325','2013-06-04','13:10:00',1.58),('325','2013-06-04','13:15:00',1.12),('325','2013-06-04','13:20:00',1.23),('325','2013-06-04','13:25:00',1.47),('325','2013-06-04','13:30:00',2.79),('325','2013-06-04','13:35:00',4.52),('325','2013-06-04','13:40:00',3.66),('325','2013-06-04','13:45:00',3.26),('325','2013-06-04','13:50:00',5.1),('325','2013-06-04','13:55:00',3.04),('325','2013-06-04','14:00:00',2.43),('325','2013-06-04','14:05:00',5.02),('325','2013-06-04','14:10:00',5.06),('325','2013-06-04','14:15:00',2.93),('325','2013-06-04','14:20:00',5.04),('325','2013-06-04','14:25:00',1.45),('325','2013-06-04','14:30:00',1.24),('325','2013-06-04','14:35:00',1.55),('325','2013-06-04','14:40:00',2.63),('325','2013-06-04','14:45:00',1.4),('325','2013-06-04','14:50:00',1.4),('325','2013-06-04','14:55:00',3.86),('325','2013-06-04','15:00:00',5.43),('325','2013-06-04','15:05:00',2.41),('325','2013-06-04','15:10:00',1.88),('325','2013-06-04','15:15:00',2.4),('325','2013-06-04','15:20:00',1.26),('325','2013-06-04','17:40:00',1.03),('325','2013-06-03','08:15:00',1.03),('325','2013-06-03','08:20:00',1.13),('325','2013-06-03','08:25:00',1.22),('325','2013-06-03','08:30:00',1.26),('325','2013-06-03','08:35:00',1.34),('325','2013-06-03','08:40:00',1.4),('325','2013-06-03','08:45:00',1.42),('325','2013-06-03','08:50:00',1.44),('325','2013-06-03','08:55:00',1.48),('325','2013-06-03','09:00:00',1.58),('325','2013-06-03','09:05:00',1.64),('325','2013-06-03','09:10:00',1.76),('325','2013-06-03','09:15:00',2.03),('325','2013-06-03','09:20:00',2.4),('325','2013-06-03','09:25:00',2.01),('325','2013-06-03','09:30:00',1.7),('325','2013-06-03','09:35:00',1.75),('325','2013-06-03','09:40:00',2.14),('325','2013-06-03','09:45:00',3.35),('325','2013-06-03','09:50:00',3.68),('325','2013-06-03','09:55:00',3.11),('325','2013-06-03','10:00:00',3.14),('325','2013-06-03','10:05:00',3.58),('325','2013-06-03','10:10:00',2.8),('325','2013-06-03','10:15:00',1.13),('325','2013-06-03','10:30:00',1.1),('325','2013-06-03','10:35:00',1.27),('325','2013-06-03','10:40:00',1.42),('325','2013-06-03','10:45:00',2),('325','2013-06-03','10:50:00',2.32),('325','2013-06-03','10:55:00',2.5),('325','2013-06-03','11:00:00',4.65),('325','2013-06-03','11:05:00',3.28),('325','2013-06-03','11:10:00',1.72),('325','2013-06-03','11:15:00',1.53),('325','2013-06-03','11:20:00',1.79),('325','2013-06-03','11:25:00',1.79),('325','2013-06-03','11:30:00',2.78),('325','2013-06-03','11:35:00',1.52),('325','2013-06-03','11:40:00',1.51),('325','2013-06-03','11:45:00',1.56),('325','2013-06-03','11:50:00',1.74),('325','2013-06-03','11:55:00',1.7),('325','2013-06-03','12:00:00',1.8),('325','2013-06-03','12:05:00',1.33),('325','2013-06-03','12:10:00',1.36),('325','2013-06-03','12:15:00',1.27),('325','2013-06-03','12:20:00',1.4),('325','2013-06-03','12:25:00',1.23),('325','2013-06-03','12:30:00',1.38),('325','2013-06-03','12:35:00',2.47),('325','2013-06-03','12:40:00',5.64),('325','2013-06-03','12:45:00',4.42),('325','2013-06-03','12:50:00',2.48),('325','2013-06-03','12:55:00',3.83),('325','2013-06-03','13:00:00',3.28),('325','2013-06-03','13:05:00',2.33),('325','2013-06-03','13:10:00',2.24),('325','2013-06-03','13:15:00',4.78),('325','2013-06-03','13:20:00',5.68),('325','2013-06-03','13:25:00',5.43),('325','2013-06-03','13:30:00',4.92),('325','2013-06-03','13:35:00',5.02),('325','2013-06-03','13:40:00',5.04),('325','2013-06-03','13:45:00',5.07),('325','2013-06-03','13:50:00',5.13),('325','2013-06-03','13:55:00',2.35),('325','2013-06-03','14:00:00',2.9),('325','2013-06-03','14:05:00',3.94),('325','2013-06-03','14:10:00',2.75),('325','2013-06-03','14:15:00',3.06),('325','2013-06-03','14:20:00',3.55),('325','2013-06-03','14:25:00',2.75),('325','2013-06-03','14:30:00',5.14),('325','2013-06-03','14:35:00',5.25),('325','2013-06-03','14:40:00',3.71),('325','2013-06-03','14:45:00',3.41),('325','2013-06-03','14:50:00',3.03),('325','2013-06-03','14:55:00',3.89),('325','2013-06-03','15:00:00',4.17),('325','2013-06-03','15:05:00',4.73),('325','2013-06-03','15:10:00',4.13),('325','2013-06-03','15:15:00',4.88),('325','2013-06-03','15:20:00',3.55),('325','2013-06-03','15:25:00',4.17),('325','2013-06-03','15:30:00',4.3),('325','2013-06-03','15:35:00',4.28),('325','2013-06-03','15:40:00',4.2),('325','2013-06-03','15:45:00',4.12),('325','2013-06-03','15:50:00',4.1),('325','2013-06-03','15:55:00',4.04),('325','2013-06-03','16:00:00',3.96),('325','2013-06-03','16:05:00',3.9),('325','2013-06-03','16:10:00',3.89),('325','2013-06-03','16:15:00',3.75),('325','2013-06-03','16:20:00',3.4),('325','2013-06-03','16:25:00',3.73),('325','2013-06-03','16:30:00',3.75),('325','2013-06-03','16:35:00',3.63),('325','2013-06-03','16:40:00',3.57),('325','2013-06-03','16:45:00',3.06),('325','2013-06-03','16:50:00',2.53),('325','2013-06-03','16:55:00',2.12),('325','2013-06-03','17:00:00',2.87),('325','2013-06-03','17:05:00',3.32),('325','2013-06-03','17:10:00',2.74),('325','2013-06-03','17:15:00',2.75),('325','2013-06-03','17:20:00',2.37),('325','2013-06-03','17:25:00',1.65),('325','2013-06-02','08:45:00',1.03),('325','2013-06-02','08:50:00',1.05),('325','2013-06-02','09:10:00',1.06),('325','2013-06-02','09:15:00',1.24),('325','2013-06-02','09:20:00',2.15),('325','2013-06-02','09:25:00',3.15),('325','2013-06-02','09:30:00',2.99),('325','2013-06-02','09:35:00',3),('325','2013-06-02','09:40:00',2.94),('325','2013-06-02','09:45:00',2.99),('325','2013-06-02','09:50:00',3.06),('325','2013-06-02','09:55:00',3.1),('325','2013-06-02','10:00:00',3.17),('325','2013-06-02','10:05:00',3.24),('325','2013-06-02','10:10:00',3.34),('325','2013-06-02','10:15:00',3.39),('325','2013-06-02','10:20:00',3.4),('325','2013-06-02','10:25:00',3.36),('325','2013-06-02','10:30:00',3.7),('325','2013-06-02','10:35:00',1.27),('325','2013-06-02','10:40:00',1.23),('325','2013-06-02','10:45:00',4.16),('325','2013-06-02','10:50:00',4.71),('325','2013-06-02','10:55:00',4.72),('325','2013-06-02','11:00:00',4.91),('325','2013-06-02','11:05:00',3.76),('325','2013-06-02','11:10:00',1.63),('325','2013-06-02','11:15:00',4.18),('325','2013-06-02','11:20:00',4.55),('325','2013-06-02','11:25:00',3.31),('325','2013-06-02','11:30:00',2.98),('325','2013-06-02','11:35:00',2.96),('325','2013-06-02','11:40:00',2.15),('325','2013-06-02','11:45:00',1.79),('325','2013-06-02','11:50:00',1.68),('325','2013-06-02','11:55:00',3.41),('325','2013-06-02','12:00:00',1.64),('325','2013-06-02','12:05:00',1.47),('325','2013-06-02','12:10:00',3.87),('325','2013-06-02','12:15:00',2.17),('325','2013-06-02','12:20:00',2.86),('325','2013-06-02','12:25:00',3.39),('325','2013-06-02','12:30:00',4.17),('325','2013-06-02','12:35:00',3.36),('325','2013-06-02','12:40:00',4.43),('325','2013-06-02','12:45:00',2.9),('325','2013-06-02','12:50:00',2.99),('325','2013-06-02','12:55:00',4.86),('325','2013-06-02','13:00:00',4.77),('325','2013-06-02','13:05:00',4.15),('325','2013-06-02','13:10:00',5.09),('325','2013-06-02','13:15:00',5.02),('325','2013-06-02','13:20:00',4.96),('325','2013-06-02','13:25:00',4.9),('325','2013-06-02','13:30:00',4.88),('325','2013-06-02','13:35:00',4.86),('325','2013-06-02','13:40:00',4.82),('325','2013-06-02','13:45:00',4.75),('325','2013-06-02','13:50:00',4.67),('325','2013-06-02','13:55:00',4.6),('325','2013-06-02','14:00:00',4.5),('325','2013-06-02','14:05:00',4.69),('325','2013-06-02','14:10:00',4.73),('325','2013-06-02','14:15:00',4.64),('325','2013-06-02','14:20:00',4.64),('325','2013-06-02','14:25:00',4.67),('325','2013-06-02','14:30:00',4.64),('325','2013-06-02','14:35:00',4.64),('325','2013-06-02','14:40:00',4.6),('325','2013-06-02','14:45:00',4.54),('325','2013-06-02','14:50:00',4.54),('325','2013-06-02','14:55:00',4.45),('325','2013-06-02','15:00:00',4.47),('325','2013-06-02','15:05:00',4.4),('325','2013-06-02','15:10:00',4.4),('325','2013-06-02','15:15:00',4.37),('325','2013-06-02','15:20:00',3.43),('325','2013-06-02','15:25:00',3.73),('325','2013-06-02','15:30:00',3.81),('325','2013-06-02','15:35:00',3.64),('325','2013-06-02','15:40:00',3.39),('325','2013-06-02','15:45:00',3.92),('325','2013-06-02','15:50:00',3.33),('325','2013-06-02','15:55:00',4.22),('325','2013-06-02','16:00:00',4.04),('325','2013-06-02','16:05:00',3.81),('325','2013-06-02','16:10:00',4.07),('325','2013-06-02','16:15:00',3.77),('325','2013-06-02','16:20:00',2.93),('325','2013-06-02','16:25:00',3.71),('325','2013-06-02','16:30:00',3.53),('325','2013-06-02','16:35:00',3.48),('325','2013-06-02','16:40:00',3.47),('325','2013-06-02','16:45:00',2.93),('325','2013-06-02','16:50:00',3.29),('325','2013-06-02','16:55:00',3.16),('325','2013-06-02','17:00:00',2.41),('325','2013-06-02','17:05:00',2.96),('325','2013-06-02','17:10:00',2.88),('325','2013-06-02','17:15:00',2.82),('325','2013-06-02','17:20:00',2.58),('325','2013-06-02','17:25:00',2.55),('325','2013-06-02','17:30:00',2.22),('325','2013-06-02','17:35:00',1.42),('325','2013-06-02','17:40:00',1.11),('325','2013-06-02','17:45:00',1.28),('325','2013-06-02','17:50:00',1.46),('325','2013-06-01','07:55:00',1.05),('325','2013-06-01','08:15:00',1.23),('325','2013-06-01','08:30:00',1.2),('325','2013-06-01','08:35:00',1.08),('325','2013-06-01','10:30:00',1.08),('325','2013-06-01','10:35:00',1.38),('325','2013-06-01','10:40:00',1.05),('325','2013-06-01','10:50:00',2.6),('325','2013-06-01','10:55:00',2.57),('325','2013-06-01','11:50:00',1.53),('325','2013-06-01','11:55:00',1.84),('325','2013-06-01','12:00:00',4.6),('325','2013-06-01','12:05:00',2.97),('325','2013-06-01','12:10:00',2.81),('325','2013-06-01','12:15:00',1.27),('325','2013-06-01','12:20:00',1.07),('325','2013-06-01','12:25:00',1.33),('325','2013-06-01','12:30:00',1.16),('325','2013-06-01','12:40:00',1.32),('325','2013-06-01','12:45:00',1.97),('325','2013-06-01','12:50:00',2.05),('325','2013-06-01','12:55:00',2.19),('325','2013-06-01','13:00:00',2.27),('325','2013-06-01','13:05:00',2.36),('325','2013-06-01','13:10:00',2.6),('325','2013-06-01','13:15:00',2.74),('325','2013-06-01','13:20:00',2.2),('325','2013-06-01','13:25:00',1.87),('325','2013-06-01','13:30:00',1.51),('325','2013-06-01','13:35:00',1.18),('325','2013-06-01','13:40:00',1.07),('325','2013-06-01','13:45:00',1.22),('325','2013-06-01','13:50:00',1.41),('325','2013-06-01','13:55:00',1.64),('325','2013-06-01','14:00:00',2.33),('325','2013-06-01','14:05:00',2.43),('325','2013-06-01','14:10:00',2.4),('325','2013-06-01','14:15:00',2.79),('325','2013-06-01','14:20:00',2.56),('325','2013-06-01','14:25:00',1.56),('325','2013-06-01','14:30:00',1.35),('325','2013-06-01','14:35:00',1.34),('325','2013-06-01','14:40:00',1.25),('325','2013-06-01','14:45:00',1.22),('325','2013-06-01','14:50:00',1.14),('325','2013-06-01','18:30:00',1.01),('325','2013-06-01','18:35:00',1.02),('325','2013-06-01','19:00:00',1.16),('325','2013-05-31','08:05:00',1.02),('325','2013-05-31','08:10:00',1.06),('325','2013-05-31','08:15:00',1.1),('325','2013-05-31','08:20:00',1.15),('325','2013-05-31','08:25:00',1.27),('325','2013-05-31','08:30:00',1.1),('325','2013-05-31','08:35:00',1.32),('325','2013-05-31','08:40:00',1.06),('325','2013-05-31','08:45:00',1.59),('325','2013-05-31','08:50:00',1.73),('325','2013-05-31','08:55:00',1.1),('325','2013-05-31','09:15:00',1.24),('325','2013-05-31','09:25:00',1.03),('325','2013-05-31','09:30:00',1.31),('325','2013-05-31','09:35:00',1.54),('325','2013-05-31','09:40:00',3.15),('325','2013-05-31','09:45:00',3.36),('325','2013-05-31','09:50:00',3.64),('325','2013-05-31','09:55:00',3.29),('325','2013-05-31','10:00:00',3.59),('325','2013-05-31','10:05:00',2.74),('325','2013-05-31','10:10:00',2.15),('325','2013-05-31','10:15:00',3.36),('325','2013-05-31','10:20:00',3.3),('325','2013-05-31','10:25:00',1.35),('325','2013-05-31','10:30:00',2.97),('325','2013-05-31','10:35:00',2.06),('325','2013-05-31','10:40:00',4.47),('325','2013-05-31','10:45:00',4.49),('325','2013-05-31','10:50:00',1.74),('325','2013-05-31','10:55:00',4.06),('325','2013-05-31','11:00:00',1.52),('325','2013-05-31','11:05:00',2.58),('325','2013-05-31','11:10:00',5.47),('325','2013-05-31','11:15:00',4.22),('325','2013-05-31','11:20:00',1.38),('325','2013-05-31','11:25:00',4.08),('325','2013-05-31','11:30:00',3.51),('325','2013-05-31','11:35:00',2.62),('325','2013-05-31','11:45:00',5.29),('325','2013-05-31','11:50:00',3.3),('325','2013-05-31','11:55:00',3.71),('325','2013-05-31','12:00:00',1.76),('325','2013-05-31','12:05:00',5.72),('325','2013-05-31','12:10:00',3.53),('325','2013-05-31','12:15:00',1.73),('325','2013-05-31','12:20:00',2.12),('325','2013-05-31','12:25:00',4.19),('325','2013-05-31','12:30:00',1.78),('325','2013-05-31','12:35:00',2.62),('325','2013-05-31','12:40:00',4.77),('325','2013-05-31','12:45:00',1.78),('325','2013-05-31','12:55:00',1.77),('325','2013-05-31','13:00:00',5.71),('325','2013-05-31','13:05:00',1.59),('325','2013-05-31','13:20:00',1.34),('325','2013-05-31','13:25:00',2.01),('325','2013-05-31','13:30:00',3.93),('325','2013-05-31','13:35:00',5.05),('325','2013-05-31','13:40:00',3),('325','2013-05-31','13:45:00',1.25),('325','2013-05-31','13:55:00',1.67),('325','2013-05-31','14:00:00',1.98),('325','2013-05-31','14:25:00',1.05),('325','2013-05-31','15:00:00',1.08),('325','2013-05-31','15:05:00',1.61),('325','2013-05-31','15:10:00',1.9),('325','2013-05-31','15:15:00',3.12),('325','2013-05-31','15:20:00',5.23),('325','2013-05-31','15:25:00',4.03),('325','2013-05-31','15:30:00',2.61),('325','2013-05-31','15:35:00',2.11),('325','2013-05-31','15:40:00',1.72),('325','2013-05-31','15:45:00',1.66),('325','2013-05-31','15:50:00',2.63),('325','2013-05-31','15:55:00',2.33),('325','2013-05-31','16:00:00',1.49),('325','2013-05-31','16:05:00',1.31),('325','2013-05-31','16:10:00',1),('325','2013-05-31','16:20:00',1.21),('325','2013-05-31','16:25:00',1.44),('325','2013-05-31','16:30:00',1.27),('325','2013-05-31','16:35:00',1.13),('325','2013-05-31','16:40:00',1.32),('325','2013-05-31','16:45:00',1.25),('325','2014-04-01','08:50:00',1.05),('325','2014-04-01','08:55:00',1.12),('325','2014-04-01','09:00:00',1.17),('325','2014-04-01','09:05:00',1.23),('325','2014-04-01','09:10:00',1.28),('325','2014-04-01','09:15:00',1.34),('325','2014-04-01','09:20:00',1.39),('325','2014-04-01','09:25:00',1.45),('325','2014-04-01','09:30:00',1.48),('325','2014-04-01','09:35:00',1.54),('325','2014-04-01','09:40:00',1.6),('325','2014-04-01','09:45:00',1.64),('325','2014-04-01','09:50:00',1.71),('325','2014-04-01','09:55:00',1.76),('325','2014-04-01','10:00:00',1.83),('325','2014-04-01','10:05:00',1.86),('325','2014-04-01','10:10:00',1.92),('325','2014-04-01','10:15:00',2.11),('325','2014-04-01','10:20:00',1.84),('325','2014-04-01','10:25:00',2.88),('325','2014-04-01','10:30:00',3.25),('325','2014-04-01','10:35:00',3.26),('325','2014-04-01','10:40:00',1.08),('325','2014-04-01','10:45:00',3.14),('325','2014-04-01','10:50:00',3.72),('325','2014-04-01','10:55:00',3.73),('325','2014-04-01','11:00:00',3.82),('325','2014-04-01','11:05:00',3.88),('325','2014-04-01','11:10:00',3.91),('325','2014-04-01','11:15:00',3.91),('325','2014-04-01','11:20:00',4.01),('325','2014-04-01','11:25:00',4.12),('325','2014-04-01','11:30:00',4.15),('325','2014-04-01','11:35:00',4.17),('325','2014-04-01','11:40:00',4.21),('325','2014-04-01','11:45:00',4.27),('325','2014-04-01','11:50:00',4.24),('325','2014-04-01','11:55:00',4.33),('325','2014-04-01','12:00:00',4.35),('325','2014-04-01','12:05:00',4.45),('325','2014-04-01','12:10:00',4.48),('325','2014-04-01','12:15:00',4.52),('325','2014-04-01','12:20:00',4.58),('325','2014-04-01','12:25:00',4.62),('325','2014-04-01','12:30:00',4.64),('325','2014-04-01','12:35:00',4.66),('325','2014-04-01','12:40:00',4.68),('325','2014-04-01','12:45:00',4.7),('325','2014-04-01','12:50:00',4.72),('325','2014-04-01','12:55:00',4.68),('325','2014-04-01','13:00:00',4.72),('325','2014-04-01','13:05:00',4.56),('325','2014-04-01','13:10:00',4.74),('325','2014-04-01','13:15:00',4.18),('325','2014-04-01','13:20:00',4.06),('325','2014-04-01','13:25:00',4.69),('325','2014-04-01','13:30:00',4.69),('325','2014-04-01','13:35:00',4.7),('325','2014-04-01','13:40:00',4.83),('325','2014-04-01','13:45:00',4.69),('325','2014-04-01','13:50:00',4.63),('325','2014-04-01','13:55:00',4.65),('325','2014-04-01','14:00:00',4.62),('325','2014-04-01','14:05:00',4.64),('325','2014-04-01','14:10:00',4),('325','2014-04-01','14:15:00',4.67),('325','2014-04-01','14:20:00',3.04),('325','2014-04-01','14:25:00',3.92),('325','2014-04-01','14:30:00',4.08),('325','2014-04-01','14:35:00',4.43),('325','2014-04-01','14:40:00',3.95),('325','2014-04-01','14:45:00',4.7),('325','2014-04-01','14:50:00',4.1),('325','2014-04-01','14:55:00',3.63),('325','2014-04-01','15:00:00',4.4),('325','2014-04-01','15:05:00',4.17),('325','2014-04-01','15:10:00',4.4),('325','2014-04-01','15:15:00',3.25),('325','2014-04-01','15:20:00',1.59),('325','2014-04-01','15:25:00',4.17),('325','2014-04-01','15:30:00',3.8),('325','2014-04-01','15:35:00',2.62),('325','2014-04-01','15:40:00',3.81),('325','2014-04-01','15:45:00',3.11),('325','2014-04-01','15:50:00',3.5),('325','2014-04-01','15:55:00',3.54),('325','2014-04-01','16:00:00',1.64),('325','2014-04-01','16:05:00',3.2),('325','2014-04-01','16:10:00',2.82),('325','2014-04-01','16:15:00',1.97),('325','2014-04-01','16:20:00',2.46),('325','2014-04-01','16:25:00',1.98),('325','2014-04-01','16:30:00',2.93),('325','2014-04-01','16:35:00',3.03),('325','2014-04-01','16:40:00',2.89),('325','2014-04-01','16:45:00',1.47),('325','2014-04-01','16:50:00',1.63),('325','2014-04-01','16:55:00',2.25),('325','2014-04-01','17:00:00',2.52),('325','2014-04-01','17:05:00',2.29),('325','2014-04-01','17:10:00',2.14),('325','2014-04-01','17:15:00',2.2),('325','2014-04-01','17:20:00',2.05),('325','2014-04-01','17:25:00',1.68),('325','2014-04-01','17:30:00',1.8),('325','2014-04-01','17:35:00',1.68),('325','2014-04-01','17:40:00',1.58),('325','2014-04-01','17:45:00',1.37),('325','2014-04-01','17:50:00',1.38),('325','2014-04-01','17:55:00',1.25),('325','2014-04-01','18:00:00',1.14),('325','2014-04-01','18:05:00',1.04),('325','2013-05-30','08:25:00',1.09),('325','2013-05-30','08:40:00',1.45),('325','2013-05-30','08:45:00',1.43),('325','2013-05-30','08:50:00',1.4),('325','2013-05-30','08:55:00',1.39),('325','2013-05-30','09:00:00',1.4),('325','2013-05-30','09:05:00',1.46),('325','2013-05-30','09:10:00',1.62),('325','2013-05-30','09:15:00',1.7),('325','2013-05-30','09:20:00',2.68),('325','2013-05-30','09:25:00',2.96),('325','2013-05-30','09:30:00',3),('325','2013-05-30','09:35:00',3.06),('325','2013-05-30','09:40:00',3.26),('325','2013-05-30','09:45:00',2.58),('325','2013-05-30','09:50:00',3.74),('325','2013-05-30','09:55:00',1.35),('325','2013-05-30','10:00:00',1.29),('325','2013-05-30','10:05:00',1.73),('325','2013-05-30','10:10:00',2.88),('325','2013-05-30','10:15:00',2.59),('325','2013-05-30','10:20:00',3.63),('325','2013-05-30','10:25:00',1.18),('325','2013-05-30','10:30:00',1.8),('325','2013-05-30','10:35:00',2.03),('325','2013-05-30','10:40:00',3.04),('325','2013-05-30','10:45:00',4.84),('325','2013-05-30','10:50:00',3.95),('325','2013-05-30','10:55:00',4),('325','2013-05-30','11:00:00',5.13),('325','2013-05-30','11:05:00',4.6),('325','2013-05-30','11:15:00',2.92),('325','2013-05-30','11:20:00',3.53),('325','2013-05-30','11:25:00',1.7),('325','2013-05-30','11:30:00',4.67),('325','2013-05-30','11:35:00',5.03),('325','2013-05-30','11:40:00',4.8),('325','2013-05-30','11:45:00',4.44),('325','2013-05-30','11:50:00',4.52),('325','2013-05-30','11:55:00',1.89),('325','2013-05-30','12:00:00',5.51),('325','2013-05-30','12:05:00',5.35),('325','2013-05-30','12:10:00',2.55),('325','2013-05-30','12:15:00',4.17),('325','2013-05-30','12:20:00',4.17),('325','2013-05-30','12:25:00',5.82),('325','2013-05-30','12:30:00',3.63),('325','2013-05-30','12:35:00',3.63),('325','2013-05-30','12:40:00',4.88),('325','2013-05-30','12:45:00',3.33),('325','2013-05-30','12:50:00',4.13),('325','2013-05-30','12:55:00',5.77),('325','2013-05-30','13:00:00',4.01),('325','2013-05-30','13:05:00',4.1),('325','2013-05-30','13:10:00',2.73),('325','2013-05-30','13:15:00',2.54),('325','2013-05-30','13:20:00',2.29),('325','2013-05-30','13:25:00',1.87),('325','2013-05-30','13:30:00',2.23),('325','2013-05-30','13:35:00',2.56),('325','2013-05-30','13:40:00',4.72),('325','2013-05-30','13:45:00',4.54),('325','2013-05-30','13:50:00',1.93),('325','2013-05-30','13:55:00',2.39),('325','2013-05-30','14:00:00',5.63),('325','2013-05-30','14:05:00',5.44),('325','2013-05-30','14:10:00',3.62),('325','2013-05-30','14:15:00',4.2),('325','2013-05-30','14:20:00',4.1),('325','2013-05-30','14:25:00',3.69),('325','2013-05-30','14:30:00',4.69),('325','2013-05-30','14:35:00',4.19),('325','2013-05-30','14:40:00',5.14),('325','2013-05-30','14:45:00',5.02),('325','2013-05-30','14:50:00',5.07),('325','2013-05-30','14:55:00',4.59),('325','2013-05-30','15:00:00',5.01),('325','2013-05-30','15:05:00',3.15),('325','2013-05-30','15:10:00',2.04),('325','2013-05-30','15:15:00',4.47),('325','2013-05-30','15:20:00',4.87),('325','2013-05-30','15:25:00',4.45),('325','2013-05-30','15:30:00',4.79),('325','2013-05-30','15:35:00',4.87),('325','2013-05-30','15:40:00',4.52),('325','2013-05-30','15:45:00',4.96),('325','2013-05-30','15:50:00',3.18),('325','2013-05-30','15:55:00',4.43),('325','2013-05-30','16:00:00',3.78),('325','2013-05-30','16:05:00',4.65),('325','2013-05-30','16:10:00',4.32),('325','2013-05-30','16:15:00',4.06),('325','2013-05-30','16:20:00',3.57),('325','2013-05-30','16:25:00',1.91),('325','2013-05-30','16:30:00',1.3),('325','2013-05-30','16:35:00',2.52),('325','2013-05-30','16:40:00',1.04),('325','2013-05-30','16:45:00',3.27),('325','2013-05-30','16:50:00',2.99),('325','2013-05-30','16:55:00',2.17),('325','2013-05-30','17:00:00',1.63),('325','2013-05-30','17:05:00',2.13),('325','2013-05-30','17:15:00',1.04),('325','2013-05-30','17:20:00',1.35),('325','2013-05-30','17:30:00',1.07),('325','2013-05-30','18:00:00',1.05),('325','2013-05-30','18:05:00',1.08),('325','2013-05-30','18:10:00',1.28),('325','2013-05-30','18:35:00',1.23),('325','2013-05-30','18:40:00',1.19),('325','2013-05-30','18:45:00',1.37),('325','2013-05-30','18:50:00',1.22),('325','2013-05-29','08:10:00',1),('325','2013-05-29','08:15:00',1.05),('325','2013-05-29','08:20:00',1.1),('325','2013-05-29','08:25:00',1.17),('325','2013-05-29','08:30:00',1.22),('325','2013-05-29','08:35:00',1.29),('325','2013-05-29','08:40:00',1.35),('325','2013-05-29','08:45:00',1.37),('325','2013-05-29','08:50:00',1.36),('325','2013-05-29','08:55:00',1.36),('325','2013-05-29','09:00:00',1.38),('325','2013-05-29','09:05:00',1.41),('325','2013-05-29','09:10:00',1.44),('325','2013-05-29','09:15:00',1.46),('325','2013-05-29','09:20:00',1.48),('325','2013-05-29','09:25:00',2.61),('325','2013-05-29','09:30:00',2.85),('325','2013-05-29','09:35:00',2.94),('325','2013-05-29','09:40:00',2.97),('325','2013-05-29','09:45:00',3.07),('325','2013-05-29','09:50:00',3.16),('325','2013-05-29','09:55:00',3.19),('325','2013-05-29','10:00:00',3.24),('325','2013-05-29','10:05:00',3.33),('325','2013-05-29','10:10:00',3.4),('325','2013-05-29','10:15:00',3.48),('325','2013-05-29','10:20:00',3.54),('325','2013-05-29','10:25:00',3.58),('325','2013-05-29','10:30:00',3.65),('325','2013-05-29','10:35:00',3.75),('325','2013-05-29','10:40:00',3.94),('325','2013-05-29','10:45:00',4.15),('325','2013-05-29','10:50:00',4.25),('325','2013-05-29','10:55:00',4.25),('325','2013-05-29','11:00:00',4.45),('325','2013-05-29','11:05:00',4.46),('325','2013-05-29','11:10:00',4.26),('325','2013-05-29','11:15:00',3.62),('325','2013-05-29','11:20:00',4.85),('325','2013-05-29','11:25:00',4.61),('325','2013-05-29','11:30:00',5.29),('325','2013-05-29','11:35:00',4.93),('325','2013-05-29','11:40:00',4.58),('325','2013-05-29','11:45:00',3.61),('325','2013-05-29','11:50:00',3.97),('325','2013-05-29','11:55:00',5.04),('325','2013-05-29','12:00:00',2.91),('325','2013-05-29','12:05:00',3.3),('325','2013-05-29','12:10:00',5.41),('325','2013-05-29','12:15:00',4.39),('325','2013-05-29','12:20:00',5.22),('325','2013-05-29','12:25:00',5.18),('325','2013-05-29','12:30:00',5.11),('325','2013-05-29','12:35:00',4.98),('325','2013-05-29','12:40:00',3.78),('325','2013-05-29','12:45:00',5.15),('325','2013-05-29','12:50:00',4.88),('325','2013-05-29','12:55:00',5.07),('325','2013-05-29','13:00:00',5.1),('325','2013-05-29','13:05:00',4.73),('325','2013-05-29','13:10:00',4.59),('325','2013-05-29','13:15:00',4.16),('325','2013-05-29','13:20:00',4.89),('325','2013-05-29','13:25:00',5.67),('325','2013-05-29','13:30:00',5.29),('325','2013-05-29','13:35:00',3.84),('325','2013-05-29','13:40:00',4.98),('325','2013-05-29','13:45:00',4.75),('325','2013-05-29','13:50:00',4.58),('325','2013-05-29','13:55:00',4.32),('325','2013-05-29','14:00:00',4.86),('325','2013-05-29','14:05:00',4.66),('325','2013-05-29','14:10:00',4.75),('325','2013-05-29','14:15:00',4.87),('325','2013-05-29','14:20:00',4.92),('325','2013-05-29','14:25:00',4.39),('325','2013-05-29','14:30:00',4.91),('325','2013-05-29','14:35:00',3.85),('325','2013-05-29','14:40:00',5.01),('325','2013-05-29','14:45:00',4.92),('325','2013-05-29','14:50:00',3.92),('325','2013-05-29','14:55:00',4.57),('325','2013-05-29','15:00:00',4.73),('325','2013-05-29','15:05:00',4.6),('325','2013-05-29','15:10:00',3.35),('325','2013-05-29','15:15:00',3.88),('325','2013-05-29','15:20:00',3.95),('325','2013-05-29','15:25:00',2.88),('325','2013-05-29','15:30:00',3.63),('325','2013-05-29','15:35:00',3.46),('325','2013-05-29','15:40:00',2.95),('325','2013-05-29','15:45:00',3.15),('325','2013-05-29','15:50:00',3.28),('325','2013-05-29','15:55:00',3.09),('325','2013-05-29','16:00:00',2.93),('325','2013-05-29','16:05:00',2.97),('325','2013-05-29','16:10:00',2.54),('325','2013-05-29','16:15:00',2.45),('325','2013-05-29','16:20:00',2.35),('325','2013-05-29','16:25:00',2.53),('325','2013-05-29','16:30:00',2.02),('325','2013-05-29','16:35:00',2.13),('325','2013-05-29','16:40:00',2.6),('325','2013-05-29','16:45:00',2.26),('325','2013-05-29','16:50:00',1.75),('325','2013-05-29','16:55:00',1.56),('325','2013-05-29','17:00:00',1.37),('325','2013-05-29','17:35:00',1.3),('325','2013-05-29','17:40:00',1.8),('325','2013-05-29','17:45:00',1.14),('325','2013-05-29','18:00:00',1.09),('325','2013-05-29','18:05:00',1.34),('325','2013-05-29','18:10:00',1.47),('325','2013-05-29','18:15:00',2.07),('325','2013-05-29','18:20:00',1.47),('325','2013-05-28','08:10:00',1.07),('325','2013-05-28','08:15:00',1.2),('325','2013-05-28','08:20:00',1.29),('325','2013-05-28','08:25:00',1.23),('325','2013-05-28','08:30:00',1.45),('325','2013-05-28','08:35:00',1.43),('325','2013-05-28','08:40:00',1.36),('325','2013-05-28','08:45:00',1.39),('325','2013-05-28','08:50:00',1.54),('325','2013-05-28','08:55:00',1.48),('325','2013-05-28','09:00:00',1.5),('325','2013-05-28','09:05:00',1.64),('325','2013-05-28','09:10:00',1.53),('325','2013-05-28','09:15:00',1.5),('325','2013-05-28','09:20:00',1.63),('325','2013-05-28','09:25:00',1.72),('325','2013-05-28','09:30:00',1.81),('325','2013-05-28','09:35:00',1.96),('325','2013-05-28','09:40:00',1.93),('325','2013-05-28','09:45:00',1.95),('325','2013-05-28','09:50:00',2.16),('325','2013-05-28','09:55:00',2.34),('325','2013-05-28','10:00:00',2.15),('325','2013-05-28','10:05:00',2.3),('325','2013-05-28','10:10:00',2.56),('325','2013-05-28','10:15:00',2.67),('325','2013-05-28','10:20:00',2.78),('325','2013-05-28','10:25:00',2.72),('325','2013-05-28','10:30:00',2.91),('325','2013-05-28','10:35:00',3.11),('325','2013-05-28','10:40:00',2.83),('325','2013-05-28','10:45:00',2.84),('325','2013-05-28','10:50:00',2.88),('325','2013-05-28','10:55:00',2.61),('325','2013-05-28','11:00:00',2.6),('325','2013-05-28','11:05:00',2.55),('325','2013-05-28','11:10:00',2.55),('325','2013-05-28','11:15:00',2.59),('325','2013-05-28','11:20:00',2.34),('325','2013-05-28','11:25:00',2.63),('325','2013-05-28','11:30:00',4.57),('325','2013-05-28','11:35:00',3.29),('325','2013-05-28','11:40:00',4.31),('325','2013-05-28','11:45:00',3.74),('325','2013-05-28','11:50:00',1.15),('325','2013-05-28','11:55:00',1.85),('325','2013-05-28','12:00:00',1.64),('325','2013-05-28','12:05:00',2.11),('325','2013-05-28','12:10:00',2.95),('325','2013-05-28','12:15:00',2.72),('325','2013-05-28','12:20:00',2.44),('325','2013-05-28','12:25:00',2.57),('325','2013-05-28','12:30:00',2.81),('325','2013-05-28','12:35:00',2.73),('325','2013-05-28','12:40:00',2.8),('325','2013-05-28','12:45:00',3.14),('325','2013-05-28','12:50:00',2.81),('325','2013-05-28','12:55:00',2.9),('325','2013-05-28','13:00:00',2.94),('325','2013-05-28','13:05:00',3.22),('325','2013-05-28','13:10:00',3.29),('325','2013-05-28','13:15:00',2.85),('325','2013-05-28','13:20:00',2.99),('325','2013-05-28','13:25:00',1.83),('325','2013-05-28','13:30:00',2.36),('325','2013-05-28','13:35:00',1.96),('325','2013-05-28','13:40:00',2.22),('325','2013-05-28','13:45:00',2.07),('325','2013-05-28','13:50:00',2.63),('325','2013-05-28','13:55:00',2.68),('325','2013-05-28','14:00:00',2.79),('325','2013-05-28','14:05:00',3),('325','2013-05-28','14:10:00',3.87),('325','2013-05-28','14:15:00',4.28),('325','2013-05-28','14:20:00',2.68),('325','2013-05-28','14:25:00',2.92),('325','2013-05-28','14:30:00',3.6),('325','2013-05-28','14:35:00',3.06),('325','2013-05-28','14:40:00',3.45),('325','2013-05-28','14:45:00',4.17),('325','2013-05-28','14:50:00',3.28),('325','2013-05-28','14:55:00',3.14),('325','2013-05-28','15:00:00',2.78),('325','2013-05-28','15:05:00',3.74),('325','2013-05-28','15:10:00',1.85),('325','2013-05-28','15:15:00',2.81),('325','2013-05-28','15:20:00',3.36),('325','2013-05-28','15:25:00',2.47),('325','2013-05-28','15:30:00',1.62),('325','2013-05-28','15:35:00',1.64),('325','2013-05-28','15:40:00',2.97),('325','2013-05-28','15:45:00',3.99),('325','2013-05-28','15:50:00',3.36),('325','2013-05-28','15:55:00',2.27),('325','2013-05-28','16:00:00',1.76),('325','2013-05-28','16:05:00',1.41),('325','2013-05-28','16:10:00',1.48),('325','2013-05-28','16:15:00',1.75),('325','2013-05-28','16:20:00',2.68),('325','2013-05-28','16:25:00',2.34),('325','2013-05-28','16:30:00',2.99),('325','2013-05-28','16:35:00',3.42),('325','2013-05-28','16:40:00',3.19),('325','2013-05-28','16:45:00',3.07),('325','2013-05-28','16:50:00',2.99),('325','2013-05-28','16:55:00',2.89),('325','2013-05-28','17:00:00',2.73),('325','2013-05-28','17:05:00',2.65),('325','2013-05-28','17:10:00',2.61),('325','2013-05-28','17:15:00',2.54),('325','2013-05-28','17:20:00',2.46),('325','2013-05-28','17:25:00',2.32),('325','2013-05-28','17:30:00',2.26),('325','2013-05-28','17:35:00',2.13),('325','2013-05-28','17:40:00',2.04),('325','2013-05-28','17:45:00',1.9),('325','2013-05-28','17:50:00',1.81),('325','2013-05-28','17:55:00',1.76),('325','2013-05-28','18:00:00',1.73),('325','2013-05-28','18:05:00',1.62),('325','2013-05-27','08:05:00',1.08),('325','2013-05-27','08:10:00',1.19),('325','2013-05-27','08:15:00',1.26),('325','2013-05-27','08:25:00',1.17),('325','2013-05-27','08:30:00',1.27),('325','2013-05-27','08:35:00',1.34),('325','2013-05-27','08:40:00',1.42),('325','2013-05-27','08:45:00',1.67),('325','2013-05-27','08:50:00',1.42),('325','2013-05-27','08:55:00',1.43),('325','2013-05-27','09:00:00',1.93),('325','2013-05-27','09:05:00',2.08),('325','2013-05-27','09:10:00',1.92),('325','2013-05-27','09:15:00',1.73),('325','2013-05-27','09:20:00',1.64),('325','2013-05-27','09:25:00',2.54),('325','2013-05-27','09:30:00',3.08),('325','2013-05-27','09:35:00',3.15),('325','2013-05-27','09:40:00',3.23),('325','2013-05-27','09:45:00',2.93),('325','2013-05-27','09:50:00',3.2),('325','2013-05-27','09:55:00',3.72),('325','2013-05-27','10:00:00',3.65),('325','2013-05-27','10:05:00',3.5),('325','2013-05-27','10:10:00',3.8),('325','2013-05-27','10:15:00',3.2),('325','2013-05-27','10:20:00',2.77),('325','2013-05-27','10:25:00',4.22),('325','2013-05-27','10:30:00',1.36),('325','2013-05-27','10:35:00',1.67),('325','2013-05-27','10:40:00',3.13),('325','2013-05-27','10:45:00',2.26),('325','2013-05-27','10:50:00',2.97),('325','2013-05-27','10:55:00',2.05),('325','2013-05-27','11:00:00',4.79),('325','2013-05-27','11:05:00',2.74),('325','2013-05-27','11:10:00',3.48),('325','2013-05-27','11:15:00',1.9),('325','2013-05-27','11:20:00',4.46),('325','2013-05-27','11:25:00',3.06),('325','2013-05-27','11:30:00',3.3),('325','2013-05-27','11:35:00',2),('325','2013-05-27','11:40:00',5.26),('325','2013-05-27','11:45:00',1.71),('325','2013-05-27','11:50:00',1.92),('325','2013-05-27','11:55:00',3.16),('325','2013-05-27','12:00:00',4.94),('325','2013-05-27','12:05:00',2.14),('325','2013-05-27','12:10:00',4.89),('325','2013-05-27','12:15:00',4.37),('325','2013-05-27','12:20:00',5.48),('325','2013-05-27','12:25:00',3.78),('325','2013-05-27','12:30:00',4.77),('325','2013-05-27','12:35:00',4.2),('325','2013-05-27','12:40:00',5.64),('325','2013-05-27','12:45:00',2.6),('325','2013-05-27','12:50:00',5.5),('325','2013-05-27','12:55:00',3.12),('325','2013-05-27','13:00:00',2.09),('325','2013-05-27','13:05:00',3.67),('325','2013-05-27','13:10:00',4.77),('325','2013-05-27','13:15:00',2.63),('325','2013-05-27','13:20:00',5.12),('325','2013-05-27','13:25:00',4.47),('325','2013-05-27','13:30:00',4.88),('325','2013-05-27','13:35:00',4.02),('325','2013-05-27','13:40:00',5.43),('325','2013-05-27','13:45:00',4.61),('325','2013-05-27','13:50:00',5.06),('325','2013-05-27','13:55:00',4.99),('325','2013-05-27','14:00:00',4.86),('325','2013-05-27','14:05:00',4.49),('325','2013-05-27','14:10:00',4.53),('325','2013-05-27','14:15:00',4.18),('325','2013-05-27','14:20:00',3.24),('325','2013-05-27','14:25:00',4.87),('325','2013-05-27','14:30:00',4.47),('325','2013-05-27','14:35:00',2.89),('325','2013-05-27','14:40:00',3.4),('325','2013-05-27','14:45:00',5.05),('325','2013-05-27','14:50:00',4.98),('325','2013-05-27','14:55:00',4.14),('325','2013-05-27','15:00:00',3.13),('325','2013-05-27','15:05:00',3.09),('325','2013-05-27','15:10:00',4.68),('325','2013-05-27','15:15:00',3.28),('325','2013-05-27','15:20:00',4.05),('325','2013-05-27','15:25:00',3.66),('325','2013-05-27','15:30:00',4.17),('325','2013-05-27','15:35:00',4.58),('325','2013-05-27','15:40:00',3.79),('325','2013-05-27','15:45:00',3.42),('325','2013-05-27','15:50:00',4.22),('325','2013-05-27','15:55:00',2.8),('325','2013-05-27','16:00:00',3.45),('325','2013-05-27','16:05:00',2.49),('325','2013-05-27','16:10:00',2.81),('325','2013-05-27','16:15:00',2.65),('325','2013-05-27','16:20:00',4.3),('325','2013-05-27','16:25:00',4.04),('325','2013-05-27','16:30:00',3.72),('325','2013-05-27','16:35:00',3.13),('325','2013-05-27','16:40:00',1.57),('325','2013-05-27','16:45:00',1.41),('325','2013-05-27','16:50:00',1.41),('325','2013-05-27','16:55:00',1.48),('325','2013-05-27','17:00:00',1.56),('325','2013-05-27','17:05:00',1.62),('325','2013-05-27','17:10:00',2.05),('325','2013-05-27','17:15:00',1.58),('325','2013-05-27','17:20:00',1.35),('325','2013-05-27','17:25:00',1.22),('325','2013-05-27','17:30:00',1.19),('325','2013-05-27','17:35:00',1.09),('325','2013-05-27','17:40:00',1.01),('325','2013-05-27','18:20:00',1.3),('325','2013-05-27','18:25:00',1.65),('325','2013-05-27','18:30:00',1.21),('325','2013-05-26','07:50:00',1.44),('325','2013-05-26','08:05:00',1.51),('325','2013-05-26','08:10:00',1.2),('325','2013-05-26','08:20:00',1.03),('325','2013-05-26','08:25:00',1.18),('325','2013-05-26','08:30:00',1.61),('325','2013-05-26','08:35:00',1.34),('325','2013-05-26','08:40:00',1.55),('325','2013-05-26','08:45:00',1.83),('325','2013-05-26','08:50:00',1.9),('325','2013-05-26','08:55:00',1.1),('325','2013-05-26','09:00:00',1.52),('325','2013-05-26','09:10:00',1.91),('325','2013-05-26','09:15:00',1.12),('325','2013-05-26','09:25:00',1.41),('325','2013-05-26','09:40:00',1.57),('325','2013-05-26','09:45:00',1.84),('325','2013-05-26','09:55:00',1.4),('325','2013-05-26','10:05:00',3.44),('325','2013-05-26','10:10:00',3.64),('325','2013-05-26','10:15:00',2.02),('325','2013-05-26','10:20:00',2.52),('325','2013-05-26','10:25:00',3.52),('325','2013-05-26','10:30:00',3.86),('325','2013-05-26','10:35:00',4.26),('325','2013-05-26','10:40:00',4.22),('325','2013-05-26','10:45:00',4.35),('325','2013-05-26','10:50:00',4.6),('325','2013-05-26','10:55:00',4.12),('325','2013-05-26','11:00:00',4.65),('325','2013-05-26','11:05:00',4.71),('325','2013-05-26','11:10:00',4.75),('325','2013-05-26','11:15:00',4.8),('325','2013-05-26','11:20:00',4.84),('325','2013-05-26','11:25:00',4.88),('325','2013-05-26','11:30:00',4.99),('325','2013-05-26','11:35:00',4.86),('325','2013-05-26','11:40:00',4.85),('325','2013-05-26','11:45:00',4.97),('325','2013-05-26','11:50:00',5.1),('325','2013-05-26','11:55:00',5.18),('325','2013-05-26','12:00:00',5.07),('325','2013-05-26','12:05:00',5.15),('325','2013-05-26','12:10:00',4.94),('325','2013-05-26','12:15:00',3.57),('325','2013-05-26','12:20:00',4.65),('325','2013-05-26','12:25:00',4.67),('325','2013-05-26','12:30:00',5.36),('325','2013-05-26','12:35:00',5.3),('325','2013-05-26','12:40:00',4.67),('325','2013-05-26','12:45:00',4.76),('325','2013-05-26','12:50:00',5.21),('325','2013-05-26','12:55:00',5.32),('325','2013-05-26','13:00:00',4.39),('325','2013-05-26','13:05:00',5.2),('325','2013-05-26','13:10:00',5.4),('325','2013-05-26','13:15:00',5.28),('325','2013-05-26','13:20:00',5.32),('325','2013-05-26','13:25:00',5.28),('325','2013-05-26','13:30:00',5.39),('325','2013-05-26','13:35:00',5.27),('325','2013-05-26','13:40:00',5.17),('325','2013-05-26','13:45:00',5.17),('325','2013-05-26','13:50:00',5.17),('325','2013-05-26','13:55:00',5),('325','2013-05-26','14:00:00',5.07),('325','2013-05-26','14:05:00',5.01),('325','2013-05-26','14:10:00',4.98),('325','2013-05-26','14:15:00',4.97),('325','2013-05-26','14:20:00',4.94),('325','2013-05-26','14:25:00',4.92),('325','2013-05-26','14:30:00',4.91),('325','2013-05-26','14:35:00',4.86),('325','2013-05-26','14:40:00',4.86),('325','2013-05-26','14:45:00',4.82),('325','2013-05-26','14:50:00',4.77),('325','2013-05-26','14:55:00',4.75),('325','2013-05-26','15:00:00',4.71),('325','2013-05-26','15:05:00',4.69),('325','2013-05-26','15:10:00',4.62),('325','2013-05-26','15:15:00',4.61),('325','2013-05-26','15:20:00',4.57),('325','2013-05-26','15:25:00',4.52),('325','2013-05-26','15:30:00',4.46),('325','2013-05-26','15:35:00',4.4),('325','2013-05-26','15:40:00',4.34),('325','2013-05-26','15:45:00',4.27),('325','2013-05-26','15:50:00',4.21),('325','2013-05-26','15:55:00',4.17),('325','2013-05-26','16:00:00',4.12),('325','2013-05-26','16:05:00',4.06),('325','2013-05-26','16:10:00',4.02),('325','2013-05-26','16:15:00',3.95),('325','2013-05-26','16:20:00',3.88),('325','2013-05-26','16:25:00',3.81),('325','2013-05-26','16:30:00',3.72),('325','2013-05-26','16:35:00',3.62),('325','2013-05-26','16:40:00',3.54),('325','2013-05-26','16:45:00',3.46),('325','2013-05-26','16:50:00',3.37),('325','2013-05-26','16:55:00',3.22),('325','2013-05-26','17:00:00',3.08),('325','2013-05-26','17:05:00',3.06),('325','2013-05-26','17:10:00',2.96),('325','2013-05-26','17:15:00',2.86),('325','2013-05-26','17:20:00',2.77),('325','2013-05-26','17:25:00',2.68),('325','2013-05-26','17:30:00',2.56),('325','2013-05-26','17:35:00',2.46),('325','2013-05-26','17:40:00',2.37),('325','2013-05-26','17:45:00',2.21),('325','2013-05-26','17:50:00',2.13),('325','2013-05-26','17:55:00',2.03),('325','2013-05-26','18:00:00',1.92),('325','2013-05-26','18:05:00',1.81),('325','2013-05-26','18:10:00',1.71),('325','2013-05-26','18:15:00',1.58),('325','2013-05-26','18:20:00',1.38),('325','2013-05-26','18:25:00',1.2),('325','2013-05-26','18:30:00',1.11),('325','2013-05-25','07:35:00',1.1),('325','2013-05-25','07:55:00',1.08),('325','2013-05-25','08:00:00',1.34),('325','2013-05-25','08:05:00',1.45),('325','2013-05-25','08:10:00',1.01),('325','2013-05-25','08:25:00',1.62),('325','2013-05-25','08:30:00',1.85),('325','2013-05-25','08:35:00',1.09),('325','2013-05-25','08:40:00',1.2),('325','2013-05-25','08:45:00',1.16),('325','2013-05-25','08:50:00',1.48),('325','2013-05-25','08:55:00',1.56),('325','2013-05-25','09:00:00',1.66),('325','2013-05-25','09:05:00',1.82),('325','2013-05-25','09:10:00',1.87),('325','2013-05-25','09:15:00',2.44),('325','2013-05-25','09:20:00',1.46),('325','2013-05-25','09:25:00',1.49),('325','2013-05-25','09:30:00',1.02),('325','2013-05-25','09:35:00',2.24),('325','2013-05-25','09:40:00',3.25),('325','2013-05-25','09:45:00',2.14),('325','2013-05-25','09:50:00',3.41),('325','2013-05-25','09:55:00',2),('325','2013-05-25','10:10:00',1.3),('325','2013-05-25','10:40:00',1.74),('325','2013-05-25','10:45:00',1.45),('325','2013-05-25','10:50:00',1.39),('325','2013-05-25','11:00:00',1.27),('325','2013-05-25','11:05:00',2.29),('325','2013-05-25','11:10:00',4.05),('325','2013-05-25','11:15:00',4.46),('325','2013-05-25','11:20:00',2.67),('325','2013-05-25','11:35:00',2.06),('325','2013-05-25','11:40:00',2.38),('325','2013-05-25','11:45:00',2.7),('325','2013-05-25','11:50:00',1.84),('325','2013-05-25','11:55:00',2),('325','2013-05-25','12:00:00',2.09),('325','2013-05-25','12:05:00',1.5),('325','2013-05-25','12:10:00',1.83),('325','2013-05-25','12:15:00',1.3),('325','2013-05-25','12:20:00',1.78),('325','2013-05-25','12:25:00',2.18),('325','2013-05-25','12:30:00',1.33),('325','2013-05-25','12:35:00',1.74),('325','2013-05-25','12:40:00',2.08),('325','2013-05-25','12:45:00',1.88),('325','2013-05-25','12:50:00',1.42),('325','2013-05-25','12:55:00',1.98),('325','2013-05-25','13:00:00',1.13),('325','2013-05-25','13:05:00',1.93),('325','2013-05-25','13:10:00',1.5),('325','2013-05-25','13:15:00',2.08),('325','2013-05-25','13:20:00',2.23),('325','2013-05-25','13:25:00',4.01),('325','2013-05-25','13:30:00',1.54),('325','2013-05-25','13:35:00',1.55),('325','2013-05-25','13:40:00',2.28),('325','2013-05-25','13:45:00',2.18),('325','2013-05-25','13:50:00',2.69),('325','2013-05-25','13:55:00',4.04),('325','2013-05-25','14:00:00',4.77),('325','2013-05-25','14:05:00',4.14),('325','2013-05-25','14:10:00',5.19),('325','2013-05-25','14:15:00',4.28),('325','2013-05-25','14:20:00',3.87),('325','2013-05-25','14:25:00',2.97),('325','2013-05-25','14:30:00',2.46),('325','2013-05-25','14:35:00',3.06),('325','2013-05-25','14:40:00',1.56),('325','2013-05-25','14:45:00',2.71),('325','2013-05-25','14:50:00',1.78),('325','2013-05-25','14:55:00',2.1),('325','2013-05-25','15:00:00',4.47),('325','2013-05-25','15:05:00',3),('325','2013-05-25','15:10:00',2.63),('325','2013-05-25','15:15:00',2.79),('325','2013-05-25','15:20:00',1.93),('325','2013-05-25','15:25:00',2.08),('325','2013-05-25','15:30:00',3.82),('325','2013-05-25','15:35:00',4.73),('325','2013-05-25','15:40:00',4.62),('325','2013-05-25','15:45:00',4.38),('325','2013-05-25','15:50:00',4.76),('325','2013-05-25','15:55:00',4.16),('325','2013-05-25','16:00:00',2.6),('325','2013-05-25','16:05:00',3.07),('325','2013-05-25','16:10:00',2.09),('325','2013-05-25','16:15:00',1.45),('325','2013-05-25','16:20:00',1.72),('325','2013-05-25','16:25:00',2.3),('325','2013-05-25','16:30:00',3),('325','2013-05-25','16:35:00',3.75),('325','2013-05-25','16:40:00',3.48),('325','2013-05-25','16:45:00',2.62),('325','2013-05-25','16:50:00',1.83),('325','2013-05-25','16:55:00',1.11),('325','2013-05-25','17:05:00',1.9),('325','2013-05-25','17:10:00',3.27),('325','2013-05-25','17:15:00',2.76),('325','2013-05-25','17:20:00',2.11),('325','2013-05-25','17:35:00',1.89),('325','2013-05-25','17:40:00',1.36),('325','2013-05-25','17:45:00',1.27),('325','2013-05-25','17:50:00',1.57),('325','2013-05-25','18:00:00',1),('325','2013-05-24','08:05:00',1.18),('325','2013-05-24','08:10:00',1.49),('325','2013-05-24','08:15:00',1.28),('325','2013-05-24','08:25:00',1.09),('325','2013-05-24','08:30:00',1.56),('325','2013-05-24','08:35:00',1.1),('325','2013-05-24','08:40:00',1),('325','2013-05-24','08:45:00',1.6),('325','2013-05-24','08:50:00',1.57),('325','2013-05-24','08:55:00',1.65),('325','2013-05-24','09:00:00',1.86),('325','2013-05-24','09:05:00',2.01),('325','2013-05-24','09:20:00',1.96),('325','2013-05-24','09:25:00',1.38),('325','2013-05-24','09:30:00',1.57),('325','2013-05-24','09:40:00',1.73),('325','2013-05-24','09:45:00',1.13),('325','2013-05-24','09:50:00',1.41),('325','2013-05-24','09:55:00',3.29),('325','2013-05-24','10:00:00',1.63),('325','2013-05-24','10:20:00',1.53),('325','2013-05-24','10:25:00',2.78),('325','2013-05-24','10:30:00',4.14),('325','2013-05-24','10:35:00',4.09),('325','2013-05-24','10:40:00',3.99),('325','2013-05-24','10:45:00',3.84),('325','2013-05-24','10:50:00',3.51),('325','2013-05-24','10:55:00',4.93),('325','2013-05-24','11:00:00',3.48),('325','2013-05-24','11:05:00',3.78),('325','2013-05-24','11:10:00',4.45),('325','2013-05-24','11:15:00',3.55),('325','2013-05-24','11:20:00',4.97),('325','2013-05-24','11:25:00',5.07),('325','2013-05-24','11:30:00',2.89),('325','2013-05-24','11:35:00',1.43),('325','2013-05-24','11:40:00',1),('325','2013-05-24','11:45:00',4.01),('325','2013-05-24','11:50:00',5.44),('325','2013-05-24','11:55:00',3.14),('325','2013-05-24','12:00:00',3.3),('325','2013-05-24','12:05:00',2.7),('325','2013-05-24','12:10:00',4.16),('325','2013-05-24','12:15:00',2.9),('325','2013-05-24','12:20:00',2.47),('325','2013-05-24','12:25:00',4.11),('325','2013-05-24','12:30:00',5.17),('325','2013-05-24','12:35:00',2.55),('325','2013-05-24','12:40:00',3.08),('325','2013-05-24','12:45:00',3.57),('325','2013-05-24','12:50:00',3.47),('325','2013-05-24','12:55:00',3.08),('325','2013-05-24','13:00:00',2.91),('325','2013-05-24','13:05:00',2.32),('325','2013-05-24','13:10:00',2.76),('325','2013-05-24','13:15:00',3.19),('325','2013-05-24','13:20:00',3.26),('325','2013-05-24','13:25:00',2.38),('325','2013-05-24','13:30:00',2.24),('325','2013-05-24','13:35:00',2.81),('325','2013-05-24','13:40:00',2.21),('325','2013-05-24','13:45:00',1.19),('325','2013-05-24','13:50:00',1.41),('325','2013-05-24','13:55:00',2.6),('325','2013-05-24','14:00:00',2.38),('325','2013-05-24','14:05:00',1.91),('325','2013-05-24','14:10:00',1.79),('325','2013-05-24','14:15:00',4.4),('325','2013-05-24','14:20:00',3.82),('325','2013-05-24','14:25:00',3.28),('325','2013-05-24','14:30:00',2.61),('325','2013-05-24','14:35:00',4.13),('325','2013-05-24','14:40:00',3.57),('325','2013-05-24','14:45:00',2.89),('325','2013-05-24','14:50:00',1.54),('325','2013-05-24','14:55:00',1.82),('325','2013-05-24','15:00:00',3.04),('325','2013-05-24','15:05:00',3.79),('325','2013-05-24','15:10:00',2.39),('325','2013-05-24','15:15:00',4.07),('325','2013-05-24','15:20:00',5.1),('325','2013-05-24','15:25:00',3.95),('325','2013-05-24','15:30:00',5.36),('325','2013-05-24','15:35:00',4.27),('325','2013-05-24','15:40:00',3.66),('325','2013-05-24','15:45:00',4.54),('325','2013-05-24','15:50:00',5.08),('325','2013-05-24','15:55:00',4.25),('325','2013-05-24','16:00:00',2.44),('325','2013-05-24','16:05:00',2.38),('325','2013-05-24','16:10:00',2.54),('325','2013-05-24','16:15:00',2.94),('325','2013-05-24','16:20:00',2.59),('325','2013-05-24','16:25:00',3.57),('325','2013-05-24','16:30:00',3.11),('325','2013-05-24','16:35:00',1.68),('325','2013-05-24','16:50:00',1.58),('325','2013-05-24','16:55:00',1.86),('325','2013-05-24','17:00:00',1.42),('325','2013-05-24','17:05:00',1.02),('325','2013-05-24','17:20:00',1.04),('325','2013-05-24','17:25:00',1.06),('325','2013-05-24','17:30:00',1.15),('325','2013-05-24','17:35:00',1.15),('325','2013-05-23','08:00:00',1.16),('325','2013-05-23','08:05:00',1.25),('325','2013-05-23','08:30:00',1.54),('325','2013-05-23','08:35:00',1.44),('325','2013-05-23','08:40:00',1.76),('325','2013-05-23','08:45:00',1.57),('325','2013-05-23','08:55:00',1.02),('325','2013-05-23','09:00:00',2.16),('325','2013-05-23','09:15:00',1.1),('325','2013-05-23','09:20:00',2.39),('325','2013-05-23','09:25:00',3.19),('325','2013-05-23','09:30:00',2.85),('325','2013-05-23','09:35:00',2.57),('325','2013-05-23','09:40:00',2.28),('325','2013-05-23','09:45:00',2.09),('325','2013-05-23','09:50:00',2.89),('325','2013-05-23','09:55:00',1.61),('325','2013-05-23','10:00:00',1.5),('325','2013-05-23','10:05:00',4.15),('325','2013-05-23','10:10:00',2.69),('325','2013-05-23','10:15:00',4.09),('325','2013-05-23','10:20:00',2.29),('325','2013-05-23','10:25:00',3.87),('325','2013-05-23','10:30:00',3.62),('325','2013-05-23','10:35:00',3.7),('325','2013-05-23','10:40:00',3.83),('325','2013-05-23','10:45:00',4.55),('325','2013-05-23','10:50:00',2.32),('325','2013-05-23','10:55:00',4.33),('325','2013-05-23','11:00:00',2.51),('325','2013-05-23','11:05:00',4.1),('325','2013-05-23','11:10:00',3.41),('325','2013-05-23','11:15:00',2.21),('325','2013-05-23','11:20:00',1.57),('325','2013-05-23','11:25:00',3.58),('325','2013-05-23','11:30:00',3.16),('325','2013-05-23','11:35:00',3.49),('325','2013-05-23','11:40:00',5.37),('325','2013-05-23','11:45:00',2.69),('325','2013-05-23','11:50:00',2.97),('325','2013-05-23','11:55:00',4.64),('325','2013-05-23','12:00:00',5.09),('325','2013-05-23','12:05:00',5.23),('325','2013-05-23','12:10:00',5.32),('325','2013-05-23','12:15:00',3.85),('325','2013-05-23','12:20:00',3.77),('325','2013-05-23','12:25:00',3.23),('325','2013-05-23','12:30:00',3.92),('325','2013-05-23','12:35:00',1.76),('325','2013-05-23','12:40:00',5.49),('325','2013-05-23','12:45:00',3.35),('325','2013-05-23','12:50:00',4.88),('325','2013-05-23','12:55:00',4.55),('325','2013-05-23','13:00:00',4.97),('325','2013-05-23','13:05:00',4.32),('325','2013-05-23','13:10:00',5.4),('325','2013-05-23','13:15:00',4.67),('325','2013-05-23','13:20:00',4.3),('325','2013-05-23','13:25:00',5.54),('325','2013-05-23','13:30:00',4.6),('325','2013-05-23','13:35:00',3.08),('325','2013-05-23','13:40:00',3.33),('325','2013-05-23','13:45:00',3.25),('325','2013-05-23','13:50:00',3.99),('325','2013-05-23','13:55:00',4.23),('325','2013-05-23','14:00:00',4.66),('325','2013-05-23','14:05:00',4.36),('325','2013-05-23','14:10:00',4.72),('325','2013-05-23','14:15:00',4.14),('325','2013-05-23','14:20:00',4.05),('325','2013-05-23','14:25:00',2.75),('325','2013-05-23','14:30:00',2.88),('325','2013-05-23','14:35:00',5.51),('325','2013-05-23','14:40:00',3.15),('325','2013-05-23','14:45:00',2.59),('325','2013-05-23','14:50:00',3.06),('325','2013-05-23','14:55:00',4.05),('325','2013-05-23','15:00:00',4.59),('325','2013-05-23','15:05:00',3.01),('325','2013-05-23','15:10:00',1.55),('325','2013-05-23','15:15:00',1.76),('325','2013-05-23','15:20:00',4.12),('325','2013-05-23','15:25:00',1.79),('325','2013-05-23','15:30:00',4.46),('325','2013-05-23','15:35:00',3.86),('325','2013-05-23','15:40:00',1.83),('325','2013-05-23','15:45:00',3.08),('325','2013-05-23','15:50:00',1.3),('325','2013-05-23','15:55:00',2.3),('325','2013-05-23','16:00:00',3.3),('325','2013-05-23','16:05:00',4.5),('325','2013-05-23','16:10:00',2.2),('325','2013-05-23','16:15:00',3.22),('325','2013-05-23','16:20:00',3.14),('325','2013-05-23','16:25:00',3.34),('325','2013-05-23','16:30:00',3.25),('325','2013-05-23','16:35:00',2.13),('325','2013-05-23','16:40:00',1.45),('325','2013-05-23','16:45:00',2.55),('325','2013-05-23','17:05:00',1.3),('325','2013-05-23','17:10:00',2.69),('325','2013-05-23','17:15:00',1.77),('325','2013-05-23','17:20:00',1.61),('325','2013-05-23','17:25:00',1.04),('325','2013-05-23','17:35:00',1.76),('325','2013-05-23','17:40:00',1.08),('325','2013-05-23','17:50:00',1.05),('325','2013-05-23','17:55:00',1.61),('325','2013-05-23','18:00:00',2.14),('325','2013-05-23','18:05:00',2.55),('325','2013-05-23','18:50:00',1.09),('325','2013-05-22','08:05:00',1.02),('325','2013-05-22','08:10:00',1.06),('325','2013-05-22','08:15:00',1.49),('325','2013-05-22','08:20:00',1.35),('325','2013-05-22','08:25:00',1.33),('325','2013-05-22','08:30:00',1.84),('325','2013-05-22','08:35:00',2),('325','2013-05-22','08:40:00',1.39),('325','2013-05-22','08:45:00',1.43),('325','2013-05-22','09:25:00',1.12),('325','2013-05-22','09:30:00',2.44),('325','2013-05-22','09:35:00',2.73),('325','2013-05-22','09:40:00',2.74),('325','2013-05-22','09:45:00',2.82),('325','2013-05-22','09:50:00',2.91),('325','2013-05-22','09:55:00',2.97),('325','2013-05-22','10:00:00',3.04),('325','2013-05-22','10:05:00',3.09),('325','2013-05-22','10:10:00',3.14),('325','2013-05-22','10:15:00',3.17),('325','2013-05-22','10:20:00',3),('325','2013-05-22','10:25:00',3.45),('325','2013-05-22','10:30:00',3.58),('325','2013-05-22','10:35:00',3.7),('325','2013-05-22','10:40:00',3.91),('325','2013-05-22','10:45:00',3.94),('325','2013-05-22','10:50:00',3.93),('325','2013-05-22','10:55:00',3.98),('325','2013-05-22','11:00:00',4.07),('325','2013-05-22','11:05:00',4.16),('325','2013-05-22','11:10:00',3.48),('325','2013-05-22','11:15:00',4.11),('325','2013-05-22','11:20:00',4.26),('325','2013-05-22','11:25:00',4.13),('325','2013-05-22','11:30:00',3.36),('325','2013-05-22','11:35:00',3.1),('325','2013-05-22','11:40:00',3.94),('325','2013-05-22','11:45:00',4.3),('325','2013-05-22','11:50:00',2.52),('325','2013-05-22','11:55:00',2.24),('325','2013-05-22','12:00:00',3.15),('325','2013-05-22','12:05:00',2.49),('325','2013-05-22','12:10:00',2.44),('325','2013-05-22','12:15:00',3.55),('325','2013-05-22','12:20:00',4.05),('325','2013-05-22','12:25:00',3.44),('325','2013-05-22','12:30:00',2.4),('325','2013-05-22','12:35:00',2.46),('325','2013-05-22','12:40:00',1.61),('325','2013-05-22','13:00:00',1.07),('325','2013-05-22','13:05:00',4.44),('325','2013-05-22','13:10:00',2.88),('325','2013-05-22','13:15:00',3.21),('325','2013-05-22','13:20:00',3.08),('325','2013-05-22','13:25:00',1.17),('325','2013-05-22','13:30:00',2.02),('325','2013-05-22','13:35:00',4.14),('325','2013-05-22','13:40:00',3.13),('325','2013-05-22','13:45:00',2.67),('325','2013-05-22','13:50:00',1.77),('325','2013-05-22','13:55:00',2.23),('325','2013-05-22','14:00:00',3),('325','2013-05-22','14:05:00',3.3),('325','2013-05-22','14:10:00',4.49),('325','2013-05-22','14:15:00',4.61),('325','2013-05-22','14:20:00',4.49),('325','2013-05-22','14:25:00',4.4),('325','2013-05-22','14:30:00',4.37),('325','2013-05-22','14:35:00',4.4),('325','2013-05-22','14:40:00',4.38),('325','2013-05-22','14:45:00',4.35),('325','2013-05-22','14:50:00',4.32),('325','2013-05-22','14:55:00',4.27),('325','2013-05-22','15:00:00',4.23),('325','2013-05-22','15:05:00',4.15),('325','2013-05-22','15:10:00',4.13),('325','2013-05-22','15:15:00',3.79),('325','2013-05-22','15:20:00',3.37),('325','2013-05-22','15:25:00',2.31),('325','2013-05-22','15:30:00',2.16),('325','2013-05-22','15:35:00',2.25),('325','2013-05-22','15:40:00',3.81),('325','2013-05-22','15:45:00',3.04),('325','2013-05-22','15:50:00',3.77),('325','2013-05-22','15:55:00',3.67),('325','2013-05-22','16:00:00',3.61),('325','2013-05-22','16:05:00',3.53),('325','2013-05-22','16:10:00',3.48),('325','2013-05-22','16:15:00',3.42),('325','2013-05-22','16:20:00',3.33),('325','2013-05-22','16:25:00',3.26),('325','2013-05-22','16:30:00',3.14),('325','2013-05-22','16:35:00',2.98),('325','2013-05-22','16:40:00',2.99),('325','2013-05-22','16:45:00',2.9),('325','2013-05-22','16:50:00',1.07),('325','2013-05-22','17:15:00',1.19),('325','2013-05-22','17:20:00',1.42),('325','2013-05-22','17:25:00',1.6),('325','2013-05-22','17:30:00',1.36),('325','2013-05-22','17:35:00',1.82),('325','2013-05-22','17:55:00',1.74),('325','2013-05-22','18:00:00',1.72),('325','2013-05-21','07:40:00',1.04),('325','2013-05-21','08:10:00',1.18),('325','2013-05-21','08:15:00',1.43),('325','2013-05-21','08:20:00',1.41),('325','2013-05-21','08:25:00',1.61),('325','2013-05-21','08:30:00',1.26),('325','2013-05-21','08:35:00',1.29),('325','2013-05-21','08:40:00',1.46),('325','2013-05-21','08:45:00',1.29),('325','2013-05-21','08:50:00',1.44),('325','2013-05-21','08:55:00',1.72),('325','2013-05-21','09:00:00',1.5),('325','2013-05-21','09:05:00',1.37),('325','2013-05-21','09:10:00',1.48),('325','2013-05-21','09:15:00',1.56),('325','2013-05-21','09:20:00',1.95),('325','2013-05-21','09:25:00',2.1),('325','2013-05-21','09:30:00',1.86),('325','2013-05-21','09:35:00',2),('325','2013-05-21','09:40:00',1.96),('325','2013-05-21','09:45:00',1.71),('325','2013-05-21','09:50:00',1.7),('325','2013-05-21','09:55:00',1.89),('325','2013-05-21','10:00:00',2.12),('325','2013-05-21','10:05:00',2.2),('325','2013-05-21','10:10:00',2.29),('325','2013-05-21','10:15:00',2.5),('325','2013-05-21','10:20:00',2.05),('325','2013-05-21','10:25:00',2.03),('325','2013-05-21','10:30:00',1.9),('325','2013-05-21','10:35:00',1.97),('325','2013-05-21','10:40:00',2.2),('325','2013-05-21','10:45:00',3.15),('325','2013-05-21','10:50:00',2.14),('325','2013-05-21','10:55:00',1.71),('325','2013-05-21','11:00:00',2.06),('325','2013-05-21','11:05:00',1.96),('325','2013-05-21','11:10:00',3.17),('325','2013-05-21','11:15:00',3.86),('325','2013-05-21','11:20:00',3.9),('325','2013-05-21','11:25:00',4.1),('325','2013-05-21','11:30:00',3.59),('325','2013-05-21','11:35:00',2.81),('325','2013-05-21','11:40:00',3.03),('325','2013-05-21','11:45:00',3.42),('325','2013-05-21','11:50:00',3.32),('325','2013-05-21','11:55:00',3.69),('325','2013-05-21','12:00:00',3.53),('325','2013-05-21','12:05:00',4.39),('325','2013-05-21','12:10:00',2.98),('325','2013-05-21','12:15:00',3.63),('325','2013-05-21','12:20:00',2.54),('325','2013-05-21','12:25:00',3.45),('325','2013-05-21','12:30:00',4.45),('325','2013-05-21','12:35:00',2.88),('325','2013-05-21','12:40:00',4.62),('325','2013-05-21','12:45:00',4.15),('325','2013-05-21','12:50:00',3.08),('325','2013-05-21','12:55:00',4.91),('325','2013-05-21','13:00:00',4.22),('325','2013-05-21','13:05:00',4.39),('325','2013-05-21','13:10:00',2.84),('325','2013-05-21','13:15:00',3.76),('325','2013-05-21','13:20:00',3.11),('325','2013-05-21','13:25:00',3.14),('325','2013-05-21','13:30:00',3.13),('325','2013-05-21','13:35:00',1.41),('325','2013-05-21','14:05:00',1.21),('325','2013-05-21','14:10:00',1.8),('325','2013-05-21','14:15:00',2.09),('325','2013-05-21','14:20:00',1.76),('325','2013-05-21','14:25:00',2.98),('325','2013-05-21','14:30:00',2.95),('325','2013-05-21','14:35:00',2.21),('325','2013-05-21','14:40:00',1.99),('325','2013-05-21','14:45:00',1.56),('325','2013-05-21','15:15:00',1.23),('325','2013-05-21','15:20:00',1.57),('325','2013-05-21','15:25:00',1.6),('325','2013-05-21','15:30:00',2.67),('325','2013-05-21','15:35:00',1.77),('325','2013-05-21','15:40:00',1.41),('325','2013-05-21','15:45:00',1.44),('325','2013-05-21','15:50:00',1.24),('325','2013-05-21','15:55:00',1.21),('325','2013-05-21','16:00:00',1.2),('325','2013-05-21','16:05:00',1.24),('325','2013-05-21','16:10:00',1.33),('325','2013-05-21','16:15:00',1.11),('325','2013-05-21','16:25:00',1.39),('325','2013-05-21','16:30:00',1.93),('325','2013-05-21','16:35:00',2.22),('325','2013-05-21','16:40:00',2.05),('325','2013-05-21','16:45:00',1.88),('325','2013-05-21','16:50:00',1.12),('325','2014-03-31','08:50:00',1.06),('325','2014-03-31','08:55:00',1.12),('325','2014-03-31','09:00:00',1.17),('325','2014-03-31','09:05:00',1.23),('325','2014-03-31','09:10:00',1.28),('325','2014-03-31','09:15:00',1.32),('325','2014-03-31','09:20:00',1.38),('325','2014-03-31','09:25:00',1.43),('325','2014-03-31','09:30:00',1.47),('325','2014-03-31','09:35:00',1.51),('325','2014-03-31','09:40:00',1.56),('325','2014-03-31','09:45:00',1.6),('325','2014-03-31','09:50:00',1.65),('325','2014-03-31','09:55:00',1.69),('325','2014-03-31','10:00:00',1.72),('325','2014-03-31','10:05:00',1.76),('325','2014-03-31','10:10:00',1.8),('325','2014-03-31','10:15:00',1.84),('325','2014-03-31','10:20:00',1.9),('325','2014-03-31','10:25:00',2.88),('325','2014-03-31','10:30:00',3.26),('325','2014-03-31','10:35:00',3.33),('325','2014-03-31','10:40:00',3.39),('325','2014-03-31','10:45:00',3.48),('325','2014-03-31','10:50:00',3.57),('325','2014-03-31','10:55:00',3.59),('325','2014-03-31','11:00:00',3.65),('325','2014-03-31','11:05:00',3.74),('325','2014-03-31','11:10:00',3.79),('325','2014-03-31','11:15:00',3.83),('325','2014-03-31','11:20:00',3.87),('325','2014-03-31','11:25:00',3.93),('325','2014-03-31','11:30:00',3.93),('325','2014-03-31','11:35:00',3.96),('325','2014-03-31','11:40:00',4),('325','2014-03-31','11:45:00',4.06),('325','2014-03-31','11:50:00',4.12),('325','2014-03-31','11:55:00',4.14),('325','2014-03-31','12:00:00',4.16),('325','2014-03-31','12:05:00',4.18),('325','2014-03-31','12:10:00',4.23),('325','2014-03-31','12:15:00',4.29),('325','2014-03-31','12:20:00',4.29),('325','2014-03-31','12:25:00',4.32),('325','2014-03-31','12:30:00',4.38),('325','2014-03-31','12:35:00',4.4),('325','2014-03-31','12:40:00',4.37),('325','2014-03-31','12:45:00',4.33),('325','2014-03-31','12:50:00',4.35),('325','2014-03-31','12:55:00',4.36),('325','2014-03-31','13:00:00',4.41),('325','2014-03-31','13:05:00',4.44),('325','2014-03-31','13:10:00',4.44),('325','2014-03-31','13:15:00',4.42),('325','2014-03-31','13:20:00',4.42),('325','2014-03-31','13:25:00',4.41),('325','2014-03-31','13:30:00',4.43),('325','2014-03-31','13:35:00',4.43),('325','2014-03-31','13:40:00',4.42),('325','2014-03-31','13:45:00',4.42),('325','2014-03-31','13:50:00',4.41),('325','2014-03-31','13:55:00',4.41),('325','2014-03-31','14:00:00',4.41),('325','2014-03-31','14:05:00',4.4),('325','2014-03-31','14:10:00',4.38),('325','2014-03-31','14:15:00',4.36),('325','2014-03-31','14:20:00',4.33),('325','2014-03-31','14:25:00',4.3),('325','2014-03-31','14:30:00',4.26),('325','2014-03-31','14:35:00',4.24),('325','2014-03-31','14:40:00',4.22),('325','2014-03-31','14:45:00',4.2),('325','2014-03-31','14:50:00',4.15),('325','2014-03-31','14:55:00',4.1),('325','2014-03-31','15:00:00',4.08),('325','2014-03-31','15:05:00',4.03),('325','2014-03-31','15:10:00',3.98),('325','2014-03-31','15:15:00',3.95),('325','2014-03-31','15:20:00',3.89),('325','2014-03-31','15:25:00',3.83),('325','2014-03-31','15:30:00',3.78),('325','2014-03-31','15:35:00',3.72),('325','2014-03-31','15:40:00',3.65),('325','2014-03-31','15:45:00',3.61),('325','2014-03-31','15:50:00',3.51),('325','2014-03-31','15:55:00',3.42),('325','2014-03-31','16:00:00',3.35),('325','2014-03-31','16:05:00',3.25),('325','2014-03-31','16:10:00',3.2),('325','2014-03-31','16:15:00',3.11),('325','2014-03-31','16:20:00',3.04),('325','2014-03-31','16:25:00',2.94),('325','2014-03-31','16:30:00',2.87),('325','2014-03-31','16:35:00',2.78),('325','2014-03-31','16:40:00',2.64),('325','2014-03-31','16:45:00',2.54),('325','2014-03-31','16:50:00',2.49),('325','2014-03-31','16:55:00',2.39),('325','2014-03-31','17:00:00',2.29),('325','2014-03-31','17:05:00',2.2),('325','2014-03-31','17:10:00',2.11),('325','2014-03-31','17:15:00',2),('325','2014-03-31','17:20:00',1.88),('325','2014-03-31','17:25:00',1.76),('325','2014-03-31','17:30:00',1.68),('325','2014-03-31','17:35:00',1.59),('325','2014-03-31','17:40:00',1.49),('325','2014-03-31','17:45:00',1.39),('325','2014-03-31','17:50:00',1.29),('325','2014-03-31','17:55:00',1.19),('325','2014-03-31','18:00:00',1.08),('325','2013-05-20','08:20:00',1.19),('325','2013-05-20','08:45:00',1.95),('325','2013-05-20','08:50:00',1.98),('325','2013-05-20','08:55:00',1.44),('325','2013-05-20','09:00:00',1.74),('325','2013-05-20','09:05:00',1.8),('325','2013-05-20','09:10:00',2.33),('325','2013-05-20','09:15:00',1.15),('325','2013-05-20','09:20:00',1.28),('325','2013-05-20','09:25:00',1.04),('325','2013-05-20','09:30:00',1.35),('325','2013-05-20','09:35:00',1.99),('325','2013-05-20','09:45:00',2.16),('325','2013-05-20','09:50:00',2.37),('325','2013-05-20','10:00:00',1.27),('325','2013-05-20','10:05:00',1.82),('325','2013-05-20','10:10:00',3.08),('325','2013-05-20','10:25:00',2.63),('325','2013-05-20','10:30:00',3.63),('325','2013-05-20','10:35:00',2.5),('325','2013-05-20','10:40:00',2.18),('325','2013-05-20','10:45:00',1.5),('325','2013-05-20','10:50:00',1.55),('325','2013-05-20','10:55:00',1.1),('325','2013-05-20','11:00:00',4.94),('325','2013-05-20','11:05:00',3.29),('325','2013-05-20','11:10:00',4.45),('325','2013-05-20','11:15:00',2.8),('325','2013-05-20','11:20:00',2.89),('325','2013-05-20','11:25:00',3.94),('325','2013-05-20','11:30:00',5.17),('325','2013-05-20','11:35:00',4.37),('325','2013-05-20','11:40:00',2.19),('325','2013-05-20','11:45:00',2.78),('325','2013-05-20','11:50:00',2.22),('325','2013-05-20','11:55:00',4.77),('325','2013-05-20','12:00:00',3.31),('325','2013-05-20','12:05:00',4.62),('325','2013-05-20','12:10:00',2.3),('325','2013-05-20','12:15:00',4.33),('325','2013-05-20','12:20:00',3.5),('325','2013-05-20','12:25:00',2.24),('325','2013-05-20','12:30:00',4.09),('325','2013-05-20','12:35:00',3.19),('325','2013-05-20','12:40:00',4.46),('325','2013-05-20','12:45:00',3.15),('325','2013-05-20','12:50:00',2.3),('325','2013-05-20','12:55:00',3.55),('325','2013-05-20','13:00:00',2.2),('325','2013-05-20','13:05:00',3.92),('325','2013-05-20','13:10:00',3.02),('325','2013-05-20','13:15:00',3.43),('325','2013-05-20','13:20:00',4.46),('325','2013-05-20','13:25:00',5.67),('325','2013-05-20','13:30:00',1.45),('325','2013-05-20','13:35:00',4.91),('325','2013-05-20','13:40:00',1.64),('325','2013-05-20','13:45:00',5.16),('325','2013-05-20','13:50:00',3.51),('325','2013-05-20','13:55:00',5.1),('325','2013-05-20','14:00:00',4.42),('325','2013-05-20','14:05:00',1.11),('325','2013-05-20','14:10:00',4.05),('325','2013-05-20','14:15:00',3.85),('325','2013-05-20','14:20:00',3.03),('325','2013-05-20','14:25:00',4.6),('325','2013-05-20','14:30:00',5.06),('325','2013-05-20','14:35:00',3.93),('325','2013-05-20','14:40:00',2.58),('325','2013-05-20','14:45:00',4.86),('325','2013-05-20','14:50:00',4.4),('325','2013-05-20','14:55:00',5.14),('325','2013-05-20','15:00:00',2.19),('325','2013-05-20','15:05:00',2.94),('325','2013-05-20','15:10:00',4.94),('325','2013-05-20','15:15:00',2.73),('325','2013-05-20','15:20:00',4.9),('325','2013-05-20','15:25:00',4.81),('325','2013-05-20','15:30:00',4.74),('325','2013-05-20','15:35:00',4.46),('325','2013-05-20','15:40:00',2.09),('325','2013-05-20','15:45:00',2.33),('325','2013-05-20','15:50:00',3.02),('325','2013-05-20','15:55:00',3.05),('325','2013-05-20','16:00:00',3.01),('325','2013-05-20','16:05:00',4.32),('325','2013-05-20','16:10:00',4.21),('325','2013-05-20','16:15:00',4.04),('325','2013-05-20','16:20:00',3.84),('325','2013-05-20','16:25:00',3.79),('325','2013-05-20','16:30:00',3.64),('325','2013-05-20','16:35:00',3.51),('325','2013-05-20','16:40:00',3.42),('325','2013-05-20','16:45:00',3.18),('325','2013-05-20','16:50:00',3.13),('325','2013-05-20','16:55:00',2.92),('325','2013-05-20','17:00:00',2.92),('325','2013-05-20','17:05:00',2.84),('325','2013-05-20','17:10:00',2.2),('325','2013-05-20','17:15:00',1.37),('325','2013-05-20','17:20:00',2.32),('325','2013-05-20','17:25:00',2.8),('325','2013-05-20','17:30:00',2.78),('325','2013-05-20','17:35:00',2.31),('325','2013-05-20','17:40:00',2.16),('325','2013-05-20','17:45:00',2.01),('325','2013-05-20','17:50:00',1.94),('325','2013-05-20','17:55:00',1.85),('325','2013-05-20','18:00:00',1.78),('325','2013-05-20','18:05:00',1.78),('325','2013-05-20','18:10:00',1.42),('325','2013-05-20','18:15:00',1.65),('325','2013-05-20','18:20:00',1.39),('325','2013-05-20','18:25:00',1.16),('325','2013-05-19','08:35:00',1.2),('325','2013-05-19','08:45:00',1.12),('325','2013-05-19','08:50:00',1.3),('325','2013-05-19','08:55:00',1.33),('325','2013-05-19','09:00:00',1.29),('325','2013-05-19','09:05:00',1.23),('325','2013-05-19','09:10:00',1.4),('325','2013-05-19','09:15:00',1.36),('325','2013-05-19','09:40:00',1.18),('325','2013-05-19','09:45:00',1.29),('325','2013-05-19','09:55:00',1.21),('325','2013-05-19','10:00:00',1.41),('325','2013-05-19','10:05:00',1.75),('325','2013-05-19','10:10:00',2.38),('325','2013-05-19','10:15:00',2.76),('325','2013-05-19','10:20:00',2.99),('325','2013-05-19','10:25:00',2.67),('325','2013-05-19','10:30:00',3.22),('325','2013-05-19','10:35:00',4.04),('325','2013-05-19','10:40:00',4.13),('325','2013-05-19','10:45:00',4.28),('325','2013-05-19','10:50:00',4.16),('325','2013-05-19','10:55:00',4.44),('325','2013-05-19','11:00:00',4.22),('325','2013-05-19','11:05:00',2.05),('325','2013-05-19','11:10:00',3.69),('325','2013-05-19','11:15:00',4.76),('325','2013-05-19','11:20:00',4.66),('325','2013-05-19','11:25:00',4.76),('325','2013-05-19','11:30:00',4.78),('325','2013-05-19','11:35:00',4.78),('325','2013-05-19','11:40:00',4.85),('325','2013-05-19','11:45:00',4.93),('325','2013-05-19','11:50:00',4.91),('325','2013-05-19','11:55:00',5),('325','2013-05-19','12:00:00',4.94),('325','2013-05-19','12:05:00',4.93),('325','2013-05-19','12:10:00',4.96),('325','2013-05-19','12:15:00',5.16),('325','2013-05-19','12:20:00',4.84),('325','2013-05-19','12:25:00',3.37),('325','2013-05-19','12:30:00',3.18),('325','2013-05-19','12:35:00',3.26),('325','2013-05-19','12:40:00',4.22),('325','2013-05-19','12:45:00',4.51),('325','2013-05-19','12:50:00',3.65),('325','2013-05-19','12:55:00',3.07),('325','2013-05-19','13:00:00',4),('325','2013-05-19','13:05:00',4.38),('325','2013-05-19','13:10:00',3.8),('325','2013-05-19','13:15:00',4.3),('325','2013-05-19','13:20:00',4.02),('325','2013-05-19','13:25:00',5),('325','2013-05-19','13:30:00',4.91),('325','2013-05-19','13:35:00',4.97),('325','2013-05-19','13:40:00',4.91),('325','2013-05-19','13:45:00',4.88),('325','2013-05-19','13:50:00',4.88),('325','2013-05-19','13:55:00',4.83),('325','2013-05-19','14:00:00',4.83),('325','2013-05-19','14:05:00',4.81),('325','2013-05-19','14:10:00',4.81),('325','2013-05-19','14:15:00',4.82),('325','2013-05-19','14:20:00',4.8),('325','2013-05-19','14:25:00',4.81),('325','2013-05-19','14:30:00',4.78),('325','2013-05-19','14:35:00',4.77),('325','2013-05-19','14:40:00',4.77),('325','2013-05-19','14:45:00',4.71),('325','2013-05-19','14:50:00',4.65),('325','2013-05-19','14:55:00',4.64),('325','2013-05-19','15:00:00',4.63),('325','2013-05-19','15:05:00',4.58),('325','2013-05-19','15:10:00',4.49),('325','2013-05-19','15:15:00',4.44),('325','2013-05-19','15:20:00',4.42),('325','2013-05-19','15:25:00',4.4),('325','2013-05-19','15:30:00',4.36),('325','2013-05-19','15:35:00',4.25),('325','2013-05-19','15:40:00',4.19),('325','2013-05-19','15:45:00',4.15),('325','2013-05-19','15:50:00',4.12),('325','2013-05-19','15:55:00',4.07),('325','2013-05-19','16:00:00',4.03),('325','2013-05-19','16:05:00',3.97),('325','2013-05-19','16:10:00',3.86),('325','2013-05-19','16:15:00',3.79),('325','2013-05-19','16:20:00',3.73),('325','2013-05-19','16:25:00',3.67),('325','2013-05-19','16:30:00',3.58),('325','2013-05-19','16:35:00',3.51),('325','2013-05-19','16:40:00',3.44),('325','2013-05-19','16:45:00',3.37),('325','2013-05-19','16:50:00',3.24),('325','2013-05-19','16:55:00',3.12),('325','2013-05-19','17:00:00',3.07),('325','2013-05-19','17:05:00',2.97),('325','2013-05-19','17:10:00',2.87),('325','2013-05-19','17:15:00',2.78),('325','2013-05-19','17:20:00',2.7),('325','2013-05-19','17:25:00',2.57),('325','2013-05-19','17:30:00',2.46),('325','2013-05-19','17:35:00',2.39),('325','2013-05-19','17:40:00',2.25),('325','2013-05-19','17:45:00',2.16),('325','2013-05-19','17:50:00',2.05),('325','2013-05-19','17:55:00',1.94),('325','2013-05-19','18:00:00',1.85),('325','2013-05-19','18:05:00',1.75),('325','2013-05-19','18:10:00',1.65),('325','2013-05-19','18:15:00',1.54),('325','2013-05-19','18:20:00',1.41),('325','2013-05-19','18:25:00',1.22),('325','2013-05-19','18:30:00',1.03),('325','2013-05-18','07:55:00',1.18),('325','2013-05-18','08:00:00',1.35),('325','2013-05-18','08:05:00',1.26),('325','2013-05-18','08:20:00',1.19),('325','2013-05-18','08:25:00',1.68),('325','2013-05-18','08:30:00',1.44),('325','2013-05-18','08:35:00',1.37),('325','2013-05-18','08:40:00',1.9),('325','2013-05-18','08:45:00',1.96),('325','2013-05-18','08:50:00',2.02),('325','2013-05-18','08:55:00',2.18),('325','2013-05-18','09:00:00',2.29),('325','2013-05-18','09:05:00',2.26),('325','2013-05-18','09:10:00',2.46),('325','2013-05-18','09:15:00',2.52),('325','2013-05-18','09:20:00',2.62),('325','2013-05-18','09:25:00',2.73),('325','2013-05-18','09:30:00',2.78),('325','2013-05-18','09:35:00',2.84),('325','2013-05-18','09:40:00',2.91),('325','2013-05-18','09:45:00',2.98),('325','2013-05-18','09:50:00',3.06),('325','2013-05-18','09:55:00',3.12),('325','2013-05-18','10:00:00',3.16),('325','2013-05-18','10:05:00',3.24),('325','2013-05-18','10:10:00',3.28),('325','2013-05-18','10:15:00',3.29),('325','2013-05-18','10:20:00',3.33),('325','2013-05-18','10:25:00',3.4),('325','2013-05-18','10:30:00',3.47),('325','2013-05-18','10:35:00',3.76),('325','2013-05-18','10:40:00',3.87),('325','2013-05-18','10:45:00',3.96),('325','2013-05-18','10:50:00',4.06),('325','2013-05-18','10:55:00',3.87),('325','2013-05-18','11:00:00',4.33),('325','2013-05-18','11:05:00',4.04),('325','2013-05-18','11:10:00',3.84),('325','2013-05-18','11:15:00',4.4),('325','2013-05-18','11:20:00',4.47),('325','2013-05-18','11:25:00',4.5),('325','2013-05-18','11:30:00',3.79),('325','2013-05-18','11:35:00',4.21),('325','2013-05-18','11:40:00',4.38),('325','2013-05-18','11:45:00',4.41),('325','2013-05-18','11:50:00',4.28),('325','2013-05-18','11:55:00',4.08),('325','2013-05-18','12:00:00',4.13),('325','2013-05-18','12:05:00',4.41),('325','2013-05-18','12:10:00',4.34),('325','2013-05-18','12:15:00',4.31),('325','2013-05-18','12:20:00',4.31),('325','2013-05-18','12:25:00',4.39),('325','2013-05-18','12:30:00',3.27),('325','2013-05-18','12:35:00',4.55),('325','2013-05-18','12:40:00',4.51),('325','2013-05-18','12:45:00',4.09),('325','2013-05-18','12:50:00',4.51),('325','2013-05-18','12:55:00',4.3),('325','2013-05-18','13:00:00',4.5),('325','2013-05-18','13:05:00',4.49),('325','2013-05-18','13:10:00',3.59),('325','2013-05-18','13:15:00',4.42),('325','2013-05-18','13:20:00',4.49),('325','2013-05-18','13:25:00',4.5),('325','2013-05-18','13:30:00',4.37),('325','2013-05-18','13:35:00',4.26),('325','2013-05-18','13:40:00',4.52),('325','2013-05-18','13:45:00',4.59),('325','2013-05-18','13:50:00',4.27),('325','2013-05-18','13:55:00',3.48),('325','2013-05-18','14:00:00',3.54),('325','2013-05-18','14:05:00',3.85),('325','2013-05-18','14:10:00',4.69),('325','2013-05-18','14:15:00',4.51),('325','2013-05-18','14:20:00',4.56),('325','2013-05-18','14:25:00',4.36),('325','2013-05-18','14:30:00',4.42),('325','2013-05-18','14:35:00',4.27),('325','2013-05-18','14:40:00',4.61),('325','2013-05-18','14:45:00',4.33),('325','2013-05-18','14:50:00',4.32),('325','2013-05-18','14:55:00',3.72),('325','2013-05-18','15:00:00',4.01),('325','2013-05-18','15:05:00',3.93),('325','2013-05-18','15:10:00',3.85),('325','2013-05-18','15:15:00',3.81),('325','2013-05-18','15:20:00',3.73),('325','2013-05-18','15:25:00',3.68),('325','2013-05-18','15:30:00',3.64),('325','2013-05-18','15:35:00',3.6),('325','2013-05-18','15:40:00',3.56),('325','2013-05-18','15:45:00',3.49),('325','2013-05-18','15:50:00',3.45),('325','2013-05-18','15:55:00',3.4),('325','2013-05-18','16:00:00',3.33),('325','2013-05-18','16:05:00',3.28),('325','2013-05-18','16:10:00',3.21),('325','2013-05-18','16:15:00',3.17),('325','2013-05-18','16:20:00',3.12),('325','2013-05-18','16:25:00',3.05),('325','2013-05-18','16:30:00',2.98),('325','2013-05-18','16:35:00',2.9),('325','2013-05-18','16:40:00',2.83),('325','2013-05-18','16:45:00',2.75),('325','2013-05-18','16:50:00',2.64),('325','2013-05-18','16:55:00',2.53),('325','2013-05-18','17:00:00',2.39),('325','2013-05-18','17:05:00',2.4),('325','2013-05-18','17:10:00',2.33),('325','2013-05-18','17:15:00',2.26),('325','2013-05-18','17:20:00',2.18),('325','2013-05-18','17:25:00',2.09),('325','2013-05-18','17:30:00',1.99),('325','2013-05-18','17:35:00',1.9),('325','2013-05-18','17:40:00',1.8),('325','2013-05-18','17:45:00',1.68),('325','2013-05-18','17:50:00',1.64),('325','2013-05-18','17:55:00',1.56),('325','2013-05-18','18:00:00',1.47),('325','2013-05-18','18:05:00',1.37),('325','2013-05-18','18:10:00',1.3),('325','2013-05-18','18:15:00',1.21),('325','2013-05-18','18:20:00',1.1),('325','2013-05-17','08:05:00',1.03),('325','2013-05-17','08:10:00',1.13),('325','2013-05-17','08:15:00',1.47),('325','2013-05-17','08:20:00',1.85),('325','2013-05-17','08:25:00',1.61),('325','2013-05-17','10:20:00',1),('325','2013-05-17','10:25:00',1.44),('325','2013-05-17','10:30:00',1.66),('325','2013-05-17','10:35:00',1.27),('325','2013-05-17','10:40:00',1.49),('325','2013-05-17','10:45:00',1.61),('325','2013-05-17','10:50:00',2.58),('325','2013-05-17','10:55:00',2.94),('325','2013-05-17','11:00:00',2.27),('325','2013-05-17','11:05:00',2.09),('325','2013-05-17','11:10:00',1.5),('325','2013-05-17','11:15:00',2.46),('325','2013-05-17','11:20:00',2.09),('325','2013-05-17','11:25:00',1.78),('325','2013-05-17','11:30:00',1.82),('325','2013-05-17','11:35:00',2.37),('325','2013-05-17','11:40:00',2.27),('325','2013-05-17','11:45:00',4.87),('325','2013-05-17','11:50:00',4.28),('325','2013-05-17','11:55:00',4.05),('325','2013-05-17','12:00:00',4.2),('325','2013-05-17','12:05:00',4.11),('325','2013-05-17','12:10:00',3.69),('325','2013-05-17','12:15:00',2.84),('325','2013-05-17','12:20:00',4.25),('325','2013-05-17','12:25:00',4.03),('325','2013-05-17','12:30:00',2.35),('325','2013-05-17','12:35:00',3.43),('325','2013-05-17','12:40:00',5.28),('325','2013-05-17','12:45:00',5.33),('325','2013-05-17','12:50:00',5.12),('325','2013-05-17','12:55:00',4.58),('325','2013-05-17','13:00:00',4.45),('325','2013-05-17','13:05:00',4.44),('325','2013-05-17','13:10:00',4.09),('325','2013-05-17','13:15:00',5.07),('325','2013-05-17','13:20:00',4.91),('325','2013-05-17','13:25:00',5),('325','2013-05-17','13:30:00',3.72),('325','2013-05-17','13:35:00',4.98),('325','2013-05-17','13:40:00',4.47),('325','2013-05-17','13:45:00',4.42),('325','2013-05-17','13:50:00',4.57),('325','2013-05-17','13:55:00',5.19),('325','2013-05-17','14:00:00',4.73),('325','2013-05-17','14:05:00',4.59),('325','2013-05-17','14:10:00',4.26),('325','2013-05-17','14:15:00',4.66),('325','2013-05-17','14:20:00',4.95),('325','2013-05-17','14:25:00',4.41),('325','2013-05-17','14:30:00',4.25),('325','2013-05-17','14:35:00',4.52),('325','2013-05-17','14:40:00',2.89),('325','2013-05-17','14:45:00',3.66),('325','2013-05-17','14:50:00',4.82),('325','2013-05-17','14:55:00',2.74),('325','2013-05-17','15:00:00',5.1),('325','2013-05-17','15:05:00',2.28),('325','2013-05-17','15:10:00',1.48),('325','2013-05-17','15:15:00',3.94),('325','2013-05-17','15:20:00',3.29),('325','2013-05-17','15:25:00',1.74),('325','2013-05-17','15:30:00',2.17),('325','2013-05-17','15:35:00',2.57),('325','2013-05-17','15:40:00',2),('325','2013-05-17','15:45:00',2.27),('325','2013-05-17','15:50:00',4.89),('325','2013-05-17','15:55:00',4.64),('325','2013-05-17','16:00:00',4.56),('325','2013-05-17','16:05:00',4.18),('325','2013-05-17','16:10:00',4.27),('325','2013-05-17','16:15:00',3.54),('325','2013-05-17','16:20:00',3.45),('325','2013-05-17','16:25:00',3.73),('325','2013-05-17','16:30:00',3.66),('325','2013-05-17','16:35:00',3.83),('325','2013-05-17','16:40:00',3.77),('325','2013-05-17','16:45:00',3.43),('325','2013-05-17','16:50:00',3.15),('325','2013-05-17','16:55:00',2.96),('325','2013-05-17','17:00:00',2.94),('325','2013-05-17','17:05:00',2.84),('325','2013-05-17','17:10:00',2.75),('325','2013-05-17','17:15:00',2.66),('325','2013-05-17','17:20:00',2.59),('325','2013-05-17','17:25:00',2.51),('325','2013-05-17','17:30:00',2.42),('325','2013-05-17','17:35:00',2.31),('325','2013-05-17','17:40:00',2.19),('325','2013-05-17','17:45:00',2.08),('325','2013-05-17','17:50:00',2.01),('325','2013-05-17','17:55:00',1.88),('325','2013-05-17','18:00:00',1.79),('325','2013-05-17','18:05:00',1.69),('325','2013-05-17','18:10:00',1.58),('325','2013-05-17','18:15:00',1.47),('325','2013-05-17','18:20:00',1.36),('325','2013-05-17','18:25:00',1.19),('325','2013-05-17','18:30:00',1.01),('325','2013-05-16','09:20:00',1.19),('325','2013-05-16','09:25:00',1.52),('325','2013-05-16','09:30:00',1.48),('325','2013-05-16','09:35:00',1.73),('325','2013-05-16','09:40:00',2.02),('325','2013-05-16','09:45:00',2.45),('325','2013-05-16','09:50:00',1.36),('325','2013-05-16','09:55:00',1.35),('325','2013-05-16','10:00:00',1.67),('325','2013-05-16','10:05:00',1.31),('325','2013-05-16','10:10:00',1.29),('325','2013-05-16','10:15:00',1.61),('325','2013-05-16','10:20:00',2.06),('325','2013-05-16','10:25:00',1.85),('325','2013-05-16','10:30:00',2.09),('325','2013-05-16','10:35:00',1.49),('325','2013-05-16','10:40:00',1.44),('325','2013-05-16','10:45:00',1.27),('325','2013-05-16','10:50:00',1.46),('325','2013-05-16','10:55:00',1.67),('325','2013-05-16','11:00:00',4.3),('325','2013-05-16','11:05:00',3.76),('325','2013-05-16','11:10:00',3.26),('325','2013-05-16','11:15:00',2.35),('325','2013-05-16','11:20:00',1.23),('325','2013-05-16','11:25:00',1.26),('325','2013-05-16','11:30:00',1.59),('325','2013-05-16','11:35:00',2.99),('325','2013-05-16','11:40:00',3.87),('325','2013-05-16','11:45:00',3.65),('325','2013-05-16','11:50:00',3.98),('325','2013-05-16','11:55:00',2.8),('325','2013-05-16','12:00:00',1.94),('325','2013-05-16','12:05:00',1.87),('325','2013-05-16','12:10:00',1.86),('325','2013-05-16','12:15:00',2.65),('325','2013-05-16','12:20:00',2.06),('325','2013-05-16','12:25:00',2.18),('325','2013-05-16','12:30:00',3.44),('325','2013-05-16','12:35:00',3.75),('325','2013-05-16','12:40:00',4.92),('325','2013-05-16','12:45:00',3.46),('325','2013-05-16','12:50:00',3.16),('325','2013-05-16','12:55:00',4.27),('325','2013-05-16','13:00:00',4.6),('325','2013-05-16','13:05:00',4.52),('325','2013-05-16','13:10:00',4.36),('325','2013-05-16','13:15:00',4.39),('325','2013-05-16','13:20:00',3.52),('325','2013-05-16','13:25:00',4.48),('325','2013-05-16','13:30:00',4.4),('325','2013-05-16','13:35:00',4.37),('325','2013-05-16','13:40:00',4.31),('325','2013-05-16','13:45:00',4.26),('325','2013-05-16','13:50:00',4.28),('325','2013-05-16','13:55:00',4.23),('325','2013-05-16','14:00:00',4.15),('325','2013-05-16','14:05:00',4.12),('325','2013-05-16','14:10:00',4.11),('325','2013-05-16','14:15:00',4.21),('325','2013-05-16','14:20:00',4.17),('325','2013-05-16','14:25:00',4.1),('325','2013-05-16','14:30:00',4.08),('325','2013-05-16','14:35:00',4.03),('325','2013-05-16','14:40:00',3.98),('325','2013-05-16','14:45:00',3.97),('325','2013-05-16','14:50:00',3.57),('325','2013-05-16','14:55:00',3.59),('325','2013-05-16','15:00:00',3.92),('325','2013-05-16','15:05:00',3.91),('325','2013-05-16','15:10:00',3.58),('325','2013-05-16','15:15:00',3.49),('325','2013-05-16','15:20:00',3.71),('325','2013-05-16','15:25:00',3.65),('325','2013-05-16','15:30:00',3.56),('325','2013-05-16','15:35:00',3.47),('325','2013-05-16','15:40:00',3.56),('325','2013-05-16','15:45:00',3.46),('325','2013-05-16','15:50:00',3.43),('325','2013-05-16','15:55:00',3.4),('325','2013-05-16','16:00:00',3.36),('325','2013-05-16','16:05:00',3.18),('325','2013-05-16','16:10:00',3.22),('325','2013-05-16','16:15:00',2.96),('325','2013-05-16','16:20:00',3.17),('325','2013-05-16','16:25:00',3.04),('325','2013-05-16','16:30:00',3.01),('325','2013-05-16','16:35:00',2.87),('325','2013-05-16','16:40:00',1.77),('325','2013-05-16','16:45:00',1.52),('325','2013-05-16','16:50:00',2.07),('325','2013-05-16','16:55:00',1.95),('325','2013-05-16','17:00:00',1.69),('325','2013-05-16','17:15:00',1.48),('325','2013-05-16','17:20:00',1.63),('325','2013-05-16','17:25:00',1.71),('325','2013-05-16','17:30:00',2.07),('325','2013-05-16','17:35:00',1.89),('325','2013-05-16','17:40:00',1.55),('325','2013-05-16','17:45:00',1.07),('325','2013-05-16','18:50:00',1.02),('325','2013-05-16','18:55:00',1.01),('325','2013-05-16','19:00:00',1.04),('325','2013-05-15','08:35:00',1.1),('325','2013-05-15','08:40:00',1.14),('325','2013-05-15','08:45:00',1.17),('325','2013-05-15','08:50:00',1.25),('325','2013-05-15','08:55:00',1.34),('325','2013-05-15','09:00:00',1.31),('325','2013-05-15','09:05:00',1.41),('325','2013-05-15','09:10:00',1.42),('325','2013-05-15','09:15:00',1.45),('325','2013-05-15','09:20:00',2.05),('325','2013-05-15','09:25:00',2.55),('325','2013-05-15','09:30:00',2.7),('325','2013-05-15','09:35:00',2.76),('325','2013-05-15','09:40:00',2.77),('325','2013-05-15','09:45:00',2.87),('325','2013-05-15','09:50:00',2.98),('325','2013-05-15','09:55:00',3),('325','2013-05-15','10:00:00',3.1),('325','2013-05-15','10:05:00',3.16),('325','2013-05-15','10:10:00',3.23),('325','2013-05-15','10:15:00',3.31),('325','2013-05-15','10:20:00',3.5),('325','2013-05-15','10:25:00',3.64),('325','2013-05-15','10:30:00',3.52),('325','2013-05-15','10:35:00',3.68),('325','2013-05-15','10:40:00',3.82),('325','2013-05-15','10:45:00',3.95),('325','2013-05-15','10:50:00',3.96),('325','2013-05-15','10:55:00',3.84),('325','2013-05-15','11:00:00',3.83),('325','2013-05-15','11:05:00',4.07),('325','2013-05-15','11:10:00',4.1),('325','2013-05-15','11:15:00',4.16),('325','2013-05-15','11:20:00',3.95),('325','2013-05-15','11:25:00',4.18),('325','2013-05-15','11:30:00',4.04),('325','2013-05-15','11:35:00',3.99),('325','2013-05-15','11:40:00',3.34),('325','2013-05-15','11:45:00',3.09),('325','2013-05-15','11:50:00',2.85),('325','2013-05-15','11:55:00',2.09),('325','2013-05-15','12:00:00',2.43),('325','2013-05-15','12:05:00',3.48),('325','2013-05-15','12:10:00',5.1),('325','2013-05-15','12:15:00',4.93),('325','2013-05-15','12:20:00',3.87),('325','2013-05-15','12:25:00',4.15),('325','2013-05-15','12:30:00',3.06),('325','2013-05-15','12:35:00',3.84),('325','2013-05-15','12:40:00',4.89),('325','2013-05-15','12:45:00',2.68),('325','2013-05-15','12:50:00',2.65),('325','2013-05-15','12:55:00',2.96),('325','2013-05-15','13:00:00',2.91),('325','2013-05-15','13:05:00',4.03),('325','2013-05-15','13:10:00',2.94),('325','2013-05-15','13:15:00',2.74),('325','2013-05-15','13:20:00',2.92),('325','2013-05-15','13:25:00',3.01),('325','2013-05-15','13:30:00',2.91),('325','2013-05-15','13:35:00',2.55),('325','2013-05-15','13:40:00',2.81),('325','2013-05-15','13:45:00',2.7),('325','2013-05-15','13:50:00',2.27),('325','2013-05-15','13:55:00',2.24),('325','2013-05-15','14:00:00',1.9),('325','2013-05-15','14:05:00',1.68),('325','2013-05-15','14:10:00',1.81),('325','2013-05-15','14:15:00',1.76),('325','2013-05-15','14:20:00',1.92),('325','2013-05-15','14:25:00',1.72),('325','2013-05-15','14:30:00',1.52),('325','2013-05-15','14:35:00',1.54),('325','2013-05-15','14:40:00',1.71),('325','2013-05-15','14:45:00',1.56),('325','2013-05-15','14:50:00',1.53),('325','2013-05-15','14:55:00',1.55),('325','2013-05-15','15:00:00',1.48),('325','2013-05-15','15:05:00',1.15),('325','2013-05-15','15:45:00',1.26),('325','2013-05-15','15:50:00',1.71),('325','2013-05-15','15:55:00',2.19),('325','2013-05-15','16:00:00',2.03),('325','2013-05-15','16:05:00',1.91),('325','2013-05-15','16:10:00',1.67),('325','2013-05-15','16:15:00',1.48),('325','2013-05-15','16:20:00',1.62),('325','2013-05-15','16:25:00',1.63),('325','2013-05-15','16:30:00',1.41),('325','2013-05-15','16:35:00',1.31),('325','2013-05-15','16:40:00',1.25),('325','2013-05-15','16:45:00',1.22),('325','2013-05-15','16:50:00',1.27),('325','2013-05-15','16:55:00',1.48),('325','2013-05-15','17:00:00',1.84),('325','2013-05-15','17:05:00',2.08),('325','2013-05-15','17:10:00',2.8),('325','2013-05-15','17:15:00',2.91),('325','2013-05-15','17:20:00',1.68),('325','2013-05-15','17:25:00',1.02),('325','2013-05-15','17:30:00',1.09),('325','2013-05-14','08:15:00',1.01),('325','2013-05-14','08:20:00',1.06),('325','2013-05-14','08:25:00',1.11),('325','2013-05-14','08:30:00',1.18),('325','2013-05-14','08:35:00',1.24),('325','2013-05-14','08:40:00',1.3),('325','2013-05-14','08:45:00',1.34),('325','2013-05-14','08:50:00',1.34),('325','2013-05-14','08:55:00',1.33),('325','2013-05-14','09:00:00',1.34),('325','2013-05-14','09:05:00',1.36),('325','2013-05-14','09:10:00',1.38),('325','2013-05-14','09:15:00',1.45),('325','2013-05-14','09:20:00',2.55),('325','2013-05-14','09:25:00',2.81),('325','2013-05-14','09:30:00',2.87),('325','2013-05-14','09:35:00',2.93),('325','2013-05-14','09:40:00',3),('325','2013-05-14','09:45:00',3.07),('325','2013-05-14','09:50:00',3.18),('325','2013-05-14','09:55:00',3.22),('325','2013-05-14','10:00:00',3.3),('325','2013-05-14','10:05:00',3.36),('325','2013-05-14','10:10:00',3.53),('325','2013-05-14','10:15:00',3.64),('325','2013-05-14','10:20:00',3.78),('325','2013-05-14','10:25:00',3.81),('325','2013-05-14','10:30:00',3.83),('325','2013-05-14','10:35:00',3.92),('325','2013-05-14','10:40:00',3.98),('325','2013-05-14','10:45:00',4.11),('325','2013-05-14','10:50:00',4.14),('325','2013-05-14','10:55:00',4.16),('325','2013-05-14','11:00:00',4.21),('325','2013-05-14','11:05:00',4.27),('325','2013-05-14','11:10:00',4.3),('325','2013-05-14','11:15:00',4.29),('325','2013-05-14','11:20:00',4.31),('325','2013-05-14','11:25:00',4.35),('325','2013-05-14','11:30:00',4.36),('325','2013-05-14','11:35:00',4.38),('325','2013-05-14','11:40:00',4.42),('325','2013-05-14','11:45:00',4.46),('325','2013-05-14','11:50:00',4.5),('325','2013-05-14','11:55:00',4.56),('325','2013-05-14','12:00:00',4.56),('325','2013-05-14','12:05:00',4.52),('325','2013-05-14','12:10:00',4.59),('325','2013-05-14','12:15:00',4.63),('325','2013-05-14','12:20:00',4.67),('325','2013-05-14','12:25:00',4.65),('325','2013-05-14','12:30:00',4.64),('325','2013-05-14','12:35:00',4.68),('325','2013-05-14','12:40:00',4.71),('325','2013-05-14','12:45:00',4.71),('325','2013-05-14','12:50:00',4.69),('325','2013-05-14','12:55:00',4.71),('325','2013-05-14','13:00:00',4.69),('325','2013-05-14','13:05:00',4.68),('325','2013-05-14','13:10:00',4.68),('325','2013-05-14','13:15:00',4.69),('325','2013-05-14','13:20:00',4.67),('325','2013-05-14','13:25:00',4.67),('325','2013-05-14','13:30:00',4.64),('325','2013-05-14','13:35:00',4.63),('325','2013-05-14','13:40:00',4.59),('325','2013-05-14','13:45:00',4.53),('325','2013-05-14','13:50:00',4.45),('325','2013-05-14','13:55:00',4.41),('325','2013-05-14','14:00:00',4.31),('325','2013-05-14','14:05:00',4.21),('325','2013-05-14','14:10:00',4.13),('325','2013-05-14','14:15:00',4.45),('325','2013-05-14','14:20:00',4.42),('325','2013-05-14','14:25:00',4.4),('325','2013-05-14','14:30:00',4.37),('325','2013-05-14','14:35:00',4.38),('325','2013-05-14','14:40:00',4.42),('325','2013-05-14','14:45:00',4.47),('325','2013-05-14','14:50:00',4.46),('325','2013-05-14','14:55:00',4.44),('325','2013-05-14','15:00:00',4.41),('325','2013-05-14','15:05:00',4.39),('325','2013-05-14','15:10:00',4.35),('325','2013-05-14','15:15:00',4.33),('325','2013-05-14','15:20:00',4.27),('325','2013-05-14','15:25:00',4.23),('325','2013-05-14','15:30:00',4.19),('325','2013-05-14','15:35:00',4.13),('325','2013-05-14','15:40:00',4.08),('325','2013-05-14','15:45:00',4.03),('325','2013-05-14','15:50:00',3.98),('325','2013-05-14','15:55:00',3.91),('325','2013-05-14','16:00:00',3.86),('325','2013-05-14','16:05:00',3.8),('325','2013-05-14','16:10:00',3.73),('325','2013-05-14','16:15:00',3.65),('325','2013-05-14','16:20:00',3.57),('325','2013-05-14','16:25:00',3.5),('325','2013-05-14','16:30:00',3.42),('325','2013-05-14','16:35:00',3.35),('325','2013-05-14','16:40:00',3.27),('325','2013-05-14','16:45:00',3.18),('325','2013-05-14','16:50:00',3.07),('325','2013-05-14','16:55:00',2.98),('325','2013-05-14','17:00:00',2.89),('325','2013-05-14','17:05:00',2.79),('325','2013-05-14','17:10:00',2.7),('325','2013-05-14','17:15:00',2.61),('325','2013-05-14','17:20:00',2.51),('325','2013-05-14','17:25:00',2.42),('325','2013-05-14','17:30:00',2.32),('325','2013-05-14','17:35:00',2.21),('325','2013-05-14','17:40:00',2.1),('325','2013-05-14','17:45:00',2),('325','2013-05-14','17:50:00',1.89),('325','2013-05-14','17:55:00',1.79),('325','2013-05-14','18:00:00',1.68),('325','2013-05-14','18:05:00',1.58),('325','2013-05-14','18:10:00',1.48),('325','2013-05-14','18:15:00',1.38),('325','2013-05-14','18:20:00',1.27),('325','2013-05-14','18:25:00',1.15),('325','2013-05-13','08:25:00',1.03),('325','2013-05-13','08:30:00',1.08),('325','2013-05-13','08:35:00',1.16),('325','2013-05-13','08:40:00',1.2),('325','2013-05-13','08:45:00',1.22),('325','2013-05-13','08:50:00',1.25),('325','2013-05-13','08:55:00',1.34),('325','2013-05-13','09:00:00',1.47),('325','2013-05-13','09:05:00',1.5),('325','2013-05-13','09:10:00',1.58),('325','2013-05-13','09:15:00',1.68),('325','2013-05-13','09:20:00',2.43),('325','2013-05-13','09:25:00',2.64),('325','2013-05-13','09:30:00',2.68),('325','2013-05-13','09:35:00',2.81),('325','2013-05-13','09:40:00',2.9),('325','2013-05-13','09:45:00',3.07),('325','2013-05-13','09:50:00',3.1),('325','2013-05-13','09:55:00',3.24),('325','2013-05-13','10:00:00',2.56),('325','2013-05-13','10:05:00',3.46),('325','2013-05-13','10:10:00',3.41),('325','2013-05-13','10:15:00',3.47),('325','2013-05-13','10:20:00',3.68),('325','2013-05-13','10:25:00',3.75),('325','2013-05-13','10:30:00',4.01),('325','2013-05-13','10:35:00',2.22),('325','2013-05-13','10:40:00',1.89),('325','2013-05-13','10:50:00',1.86),('325','2013-05-13','10:55:00',1.87),('325','2013-05-13','11:00:00',4.92),('325','2013-05-13','11:05:00',2.55),('325','2013-05-13','11:10:00',2.74),('325','2013-05-13','11:15:00',1.94),('325','2013-05-13','11:20:00',1.67),('325','2013-05-13','11:25:00',1.75),('325','2013-05-13','11:30:00',1.71),('325','2013-05-13','11:35:00',2.91),('325','2013-05-13','11:40:00',4.32),('325','2013-05-13','11:45:00',2.34),('325','2013-05-13','11:50:00',3.3),('325','2013-05-13','11:55:00',1.97),('325','2013-05-13','12:00:00',2.13),('325','2013-05-13','12:05:00',2.2),('325','2013-05-13','12:10:00',4.58),('325','2013-05-13','12:15:00',1.93),('325','2013-05-13','12:20:00',1.29),('325','2013-05-13','12:25:00',1.13),('325','2013-05-13','12:30:00',1.45),('325','2013-05-13','12:35:00',5.67),('325','2013-05-13','12:40:00',5.26),('325','2013-05-13','12:45:00',5.09),('325','2013-05-13','12:50:00',4.74),('325','2013-05-13','12:55:00',3.87),('325','2013-05-13','13:00:00',3.91),('325','2013-05-13','13:05:00',5.42),('325','2013-05-13','13:10:00',4.04),('325','2013-05-13','13:15:00',4.18),('325','2013-05-13','13:20:00',4.79),('325','2013-05-13','13:25:00',4.43),('325','2013-05-13','13:30:00',3.51),('325','2013-05-13','13:35:00',4.49),('325','2013-05-13','13:40:00',4.8),('325','2013-05-13','13:45:00',4.2),('325','2013-05-13','13:50:00',2.93),('325','2013-05-13','13:55:00',3.61),('325','2013-05-13','14:00:00',5.09),('325','2013-05-13','14:05:00',4.91),('325','2013-05-13','14:10:00',4.93),('325','2013-05-13','14:15:00',4.88),('325','2013-05-13','14:20:00',4.76),('325','2013-05-13','14:25:00',4.72),('325','2013-05-13','14:30:00',3.24),('325','2013-05-13','14:35:00',3.94),('325','2013-05-13','14:40:00',2.99),('325','2013-05-13','14:45:00',2.92),('325','2013-05-13','14:50:00',4.93),('325','2013-05-13','14:55:00',4.83),('325','2013-05-13','15:00:00',4.47),('325','2013-05-13','15:05:00',1.57),('325','2013-05-13','15:10:00',1.28),('325','2013-05-13','15:20:00',1.22),('325','2013-05-13','15:40:00',1.31),('325','2013-05-13','15:45:00',1.01),('325','2013-05-13','15:50:00',1.1),('325','2013-05-13','16:00:00',2.31),('325','2013-05-13','16:05:00',2.91),('325','2013-05-13','16:10:00',1.99),('325','2013-05-13','16:15:00',1.32),('325','2013-05-13','16:20:00',1.41),('325','2013-05-13','16:25:00',1.5),('325','2013-05-13','16:30:00',2.5),('325','2013-05-13','16:35:00',1.23),('325','2013-05-13','16:40:00',1.46),('325','2013-05-13','16:45:00',2.81),('325','2013-05-13','16:50:00',3.38),('325','2013-05-13','16:55:00',3.28),('325','2013-05-13','17:00:00',3.14),('325','2013-05-13','17:05:00',3.08),('325','2013-05-13','17:10:00',1.22),('325','2013-05-13','17:15:00',2.53),('325','2013-05-13','17:20:00',3.39),('325','2013-05-13','17:25:00',3.24),('325','2013-05-13','17:30:00',3.11),('325','2013-05-13','17:35:00',2.91),('325','2013-05-13','17:40:00',2.67),('325','2013-05-13','17:45:00',2.46),('325','2013-05-13','17:50:00',2.15),('325','2013-05-13','17:55:00',1.43),('325','2013-05-13','18:00:00',1.99),('325','2013-05-13','18:05:00',1.8),('325','2013-05-13','18:10:00',1.18),('325','2013-05-13','18:15:00',1.6),('325','2013-05-13','18:20:00',1.3),('325','2013-05-12','08:15:00',1.25),('325','2013-05-12','08:20:00',1.17),('325','2013-05-12','08:25:00',1.19),('325','2013-05-12','08:40:00',1.2),('325','2013-05-12','08:45:00',1.69),('325','2013-05-12','08:50:00',1.18),('325','2013-05-12','08:55:00',1.17),('325','2013-05-12','09:00:00',1.48),('325','2013-05-12','09:05:00',1.78),('325','2013-05-12','09:10:00',1.33),('325','2013-05-12','09:15:00',1.21),('325','2013-05-12','09:20:00',1.54),('325','2013-05-12','09:25:00',1.39),('325','2013-05-12','09:30:00',1.24),('325','2013-05-12','09:35:00',1.17),('325','2013-05-12','09:40:00',1.15),('325','2013-05-12','09:45:00',2.55),('325','2013-05-12','09:50:00',3.58),('325','2013-05-12','09:55:00',3.65),('325','2013-05-12','10:00:00',3.33),('325','2013-05-12','10:05:00',1.29),('325','2013-05-12','10:10:00',3.78),('325','2013-05-12','10:15:00',3.87),('325','2013-05-12','10:20:00',3.69),('325','2013-05-12','10:25:00',4.2),('325','2013-05-12','10:30:00',2.59),('325','2013-05-12','10:35:00',1.54),('325','2013-05-12','10:40:00',1.11),('325','2013-05-12','10:45:00',2.94),('325','2013-05-12','10:50:00',2.85),('325','2013-05-12','10:55:00',3.37),('325','2013-05-12','11:00:00',4.22),('325','2013-05-12','11:05:00',4.16),('325','2013-05-12','11:10:00',4.61),('325','2013-05-12','11:15:00',4.47),('325','2013-05-12','11:20:00',4.62),('325','2013-05-12','11:25:00',3.98),('325','2013-05-12','11:30:00',3.06),('325','2013-05-12','11:35:00',4.09),('325','2013-05-12','11:40:00',3.07),('325','2013-05-12','11:45:00',2.2),('325','2013-05-12','11:50:00',1.76),('325','2013-05-12','11:55:00',1.53),('325','2013-05-12','12:00:00',2.97),('325','2013-05-12','12:05:00',3.43),('325','2013-05-12','12:10:00',1.44),('325','2013-05-12','12:15:00',1.26),('325','2013-05-12','12:20:00',1.23),('325','2013-05-12','12:25:00',1.29),('325','2013-05-12','12:30:00',2.15),('325','2013-05-12','12:35:00',5.47),('325','2013-05-12','12:40:00',3.32),('325','2013-05-12','12:45:00',3.24),('325','2013-05-12','12:50:00',5.48),('325','2013-05-12','12:55:00',3.65),('325','2013-05-12','13:00:00',1.6),('325','2013-05-12','13:05:00',4.05),('325','2013-05-12','13:10:00',4.32),('325','2013-05-12','13:15:00',2.05),('325','2013-05-12','13:20:00',4.02),('325','2013-05-12','13:25:00',4.55),('325','2013-05-12','13:30:00',4.48),('325','2013-05-12','13:35:00',4.13),('325','2013-05-12','13:40:00',4.39),('325','2013-05-12','13:45:00',5.41),('325','2013-05-12','13:50:00',5.45),('325','2013-05-12','13:55:00',2.56),('325','2013-05-12','14:00:00',4.79),('325','2013-05-12','14:05:00',5.09),('325','2013-05-12','14:10:00',5.01),('325','2013-05-12','14:15:00',4),('325','2013-05-12','14:20:00',4.37),('325','2013-05-12','14:25:00',3.57),('325','2013-05-12','14:30:00',4.92),('325','2013-05-12','14:35:00',4.92),('325','2013-05-12','14:40:00',4.77),('325','2013-05-12','14:45:00',3.98),('325','2013-05-12','14:50:00',4.49),('325','2013-05-12','14:55:00',3.82),('325','2013-05-12','15:00:00',4.7),('325','2013-05-12','15:05:00',4.67),('325','2013-05-12','15:10:00',3.16),('325','2013-05-12','15:15:00',3.97),('325','2013-05-12','15:20:00',2.52),('325','2013-05-12','15:25:00',4.38),('325','2013-05-12','15:30:00',4.24),('325','2013-05-12','15:35:00',4.15),('325','2013-05-12','15:40:00',4.12),('325','2013-05-12','15:45:00',4.06),('325','2013-05-12','15:50:00',3.98),('325','2013-05-12','15:55:00',3.88),('325','2013-05-12','16:00:00',3.6),('325','2013-05-12','16:05:00',3.73),('325','2013-05-12','16:10:00',3.69),('325','2013-05-12','16:15:00',3.64),('325','2013-05-12','16:20:00',3.54),('325','2013-05-12','16:25:00',3.44),('325','2013-05-12','16:30:00',3.38),('325','2013-05-12','16:35:00',3.33),('325','2013-05-12','16:40:00',3.4),('325','2013-05-12','16:45:00',3.33),('325','2013-05-12','16:50:00',3.1),('325','2013-05-12','16:55:00',3.74),('325','2013-05-12','17:00:00',3.53),('325','2013-05-12','17:05:00',2.99),('325','2013-05-12','17:10:00',3.49),('325','2013-05-12','17:15:00',2.86),('325','2013-05-12','17:20:00',3.16),('325','2013-05-12','17:25:00',2.29),('325','2013-05-12','17:30:00',2.13),('325','2013-05-12','17:35:00',2.98),('325','2013-05-12','17:40:00',1.75),('325','2013-05-12','17:45:00',1.86),('325','2013-05-12','17:50:00',1.39),('325','2013-05-12','18:00:00',2.15),('325','2013-05-12','18:05:00',1.99),('325','2013-05-12','18:10:00',1.99),('325','2013-05-12','18:15:00',1.52),('325','2013-05-12','18:20:00',1.19),('325','2013-05-12','18:25:00',1.39),('325','2013-05-12','18:30:00',1.29),('325','2013-05-12','18:35:00',1.3),('325','2013-05-12','18:40:00',1.06),('325','2013-05-11','08:05:00',1.01),('325','2013-05-11','08:15:00',1.26),('325','2013-05-11','08:20:00',1.11),('325','2013-05-11','09:00:00',1.04),('325','2013-05-11','09:05:00',1.45),('325','2013-05-11','09:10:00',1.22),('325','2013-05-11','09:15:00',1.42),('325','2013-05-11','09:20:00',1.5),('325','2013-05-11','09:25:00',1.64),('325','2013-05-11','09:30:00',2),('325','2013-05-11','09:35:00',1.75),('325','2013-05-11','09:40:00',1.51),('325','2013-05-11','09:45:00',1.57),('325','2013-05-11','09:50:00',2.38),('325','2013-05-11','09:55:00',3.12),('325','2013-05-11','10:00:00',1.64),('325','2013-05-11','10:05:00',1.08),('325','2013-05-11','10:20:00',1.2),('325','2013-05-11','10:25:00',1.06),('325','2013-05-11','10:30:00',1.51),('325','2013-05-11','10:35:00',1.22),('325','2013-05-11','10:45:00',1.18),('325','2013-05-11','10:50:00',1.79),('325','2013-05-11','10:55:00',4.66),('325','2013-05-11','11:00:00',4.83),('325','2013-05-11','11:05:00',1.88),('325','2013-05-11','11:10:00',1.21),('325','2013-05-11','11:25:00',1.24),('325','2013-05-11','11:30:00',3.48),('325','2013-05-11','11:35:00',2.51),('325','2013-05-11','11:40:00',3.7),('325','2013-05-11','11:45:00',5.04),('325','2013-05-11','11:50:00',1.64),('325','2013-05-11','11:55:00',1.16),('325','2013-05-11','12:00:00',1.97),('325','2013-05-11','12:05:00',2.1),('325','2013-05-11','12:10:00',1.47),('325','2013-05-11','12:15:00',1.38),('325','2013-05-11','12:20:00',4.1),('325','2013-05-11','12:25:00',5.5),('325','2013-05-11','12:30:00',1.94),('325','2013-05-11','12:35:00',2.25),('325','2013-05-11','12:40:00',1.97),('325','2013-05-11','12:45:00',1.57),('325','2013-05-11','12:50:00',1.62),('325','2013-05-11','12:55:00',1.56),('325','2013-05-11','13:00:00',2.1),('325','2013-05-11','13:05:00',1.43),('325','2013-05-11','13:25:00',1.07),('325','2013-05-11','13:30:00',1.15),('325','2013-05-11','13:35:00',1.15),('325','2013-05-11','13:50:00',1.12),('325','2013-05-11','13:55:00',1.59),('325','2013-05-11','14:00:00',2.53),('325','2013-05-11','14:05:00',4.04),('325','2013-05-11','14:10:00',2.41),('325','2013-05-11','14:15:00',3.59),('325','2013-05-11','14:20:00',4.68),('325','2013-05-11','14:25:00',3.43),('325','2013-05-11','14:30:00',2.2),('325','2013-05-11','14:35:00',3.2),('325','2013-05-11','14:40:00',3.82),('325','2013-05-11','14:45:00',5.29),('325','2013-05-11','14:50:00',4.67),('325','2013-05-11','14:55:00',4.1),('325','2013-05-11','15:00:00',4.74),('325','2013-05-11','15:05:00',4.38),('325','2013-05-11','15:10:00',4.64),('325','2013-05-11','15:15:00',4.31),('325','2013-05-11','15:20:00',4.46),('325','2013-05-11','15:25:00',4.24),('325','2013-05-11','15:30:00',4.01),('325','2013-05-11','15:35:00',4.17),('325','2013-05-11','15:40:00',4.3),('325','2013-05-11','15:45:00',3.09),('325','2013-05-11','15:50:00',3.95),('325','2013-05-11','15:55:00',4.16),('325','2013-05-11','16:00:00',3.5),('325','2013-05-11','16:05:00',4.05),('325','2013-05-11','16:10:00',3.64),('325','2013-05-11','16:15:00',3.81),('325','2013-05-11','16:20:00',3.82),('325','2013-05-11','16:25:00',3.68),('325','2013-05-11','16:30:00',3.15),('325','2013-05-11','16:35:00',2.49),('325','2013-05-11','16:40:00',3.36),('325','2013-05-11','16:45:00',3.25),('325','2013-05-11','16:50:00',2.86),('325','2013-05-11','16:55:00',3.04),('325','2013-05-11','17:00:00',3.04),('325','2013-05-11','17:05:00',2),('325','2013-05-11','17:10:00',2.47),('325','2013-05-11','17:15:00',1.16),('325','2013-05-11','17:20:00',2.29),('325','2013-05-11','17:25:00',1.89),('325','2013-05-11','17:30:00',2.2),('325','2013-05-11','17:35:00',1.91),('325','2013-05-11','17:40:00',2.11),('325','2013-05-11','17:45:00',2.01),('325','2013-05-11','17:50:00',1.09),('325','2013-05-11','17:55:00',1.32),('325','2013-05-11','18:05:00',1.82),('325','2013-05-11','18:10:00',1.83),('325','2013-05-11','18:20:00',1.14),('325','2013-05-11','18:25:00',1.09),('325','2013-05-11','18:30:00',1.17),('325','2014-03-30','08:30:00',1.02),('325','2014-03-30','08:35:00',1.05),('325','2014-03-30','08:40:00',1.09),('325','2014-03-30','08:45:00',1.09),('325','2014-03-30','08:50:00',1.11),('325','2014-03-30','08:55:00',1.16),('325','2014-03-30','09:00:00',1.2),('325','2014-03-30','09:05:00',1.19),('325','2014-03-30','09:10:00',1.17),('325','2014-03-30','09:15:00',1.25),('325','2014-03-30','09:20:00',1.37),('325','2014-03-30','09:25:00',1.48),('325','2014-03-30','09:30:00',1.6),('325','2014-03-30','09:35:00',1.65),('325','2014-03-30','09:40:00',1.7),('325','2014-03-30','09:45:00',1.77),('325','2014-03-30','09:50:00',1.79),('325','2014-03-30','09:55:00',1.75),('325','2014-03-30','10:00:00',1.83),('325','2014-03-30','10:05:00',1.97),('325','2014-03-30','10:10:00',2),('325','2014-03-30','10:15:00',1.96),('325','2014-03-30','10:20:00',2.01),('325','2014-03-30','10:25:00',2.15),('325','2014-03-30','10:30:00',2.2),('325','2014-03-30','10:35:00',2.25),('325','2014-03-30','10:40:00',2.83),('325','2014-03-30','10:45:00',3.27),('325','2014-03-30','10:50:00',3.3),('325','2014-03-30','10:55:00',3.28),('325','2014-03-30','11:00:00',3.28),('325','2014-03-30','11:05:00',3.32),('325','2014-03-30','11:10:00',3.36),('325','2014-03-30','11:15:00',3.23),('325','2014-03-30','11:20:00',3.22),('325','2014-03-30','11:25:00',3.34),('325','2014-03-30','11:30:00',3.71),('325','2014-03-30','11:35:00',3.65),('325','2014-03-30','11:40:00',3.82),('325','2014-03-30','11:45:00',3.96),('325','2014-03-30','11:50:00',3.97),('325','2014-03-30','11:55:00',4.07),('325','2014-03-30','12:00:00',4.16),('325','2014-03-30','12:05:00',4.35),('325','2014-03-30','12:10:00',4.4),('325','2014-03-30','12:15:00',4.47),('325','2014-03-30','12:20:00',4.4),('325','2014-03-30','12:25:00',4.41),('325','2014-03-30','12:30:00',4.12),('325','2014-03-30','12:35:00',4.08),('325','2014-03-30','12:40:00',4.3),('325','2014-03-30','12:45:00',4.22),('325','2014-03-30','12:50:00',4.28),('325','2014-03-30','12:55:00',4.36),('325','2014-03-30','13:00:00',4.44),('325','2014-03-30','13:05:00',4.52),('325','2014-03-30','13:10:00',4.45),('325','2014-03-30','13:15:00',4.48),('325','2014-03-30','13:20:00',4.49),('325','2014-03-30','13:25:00',4.48),('325','2014-03-30','13:30:00',4.46),('325','2014-03-30','13:35:00',4.5),('325','2014-03-30','13:40:00',4.53),('325','2014-03-30','13:45:00',4.55),('325','2014-03-30','13:50:00',4.49),('325','2014-03-30','13:55:00',4.37),('325','2014-03-30','14:00:00',4.39),('325','2014-03-30','14:05:00',4.29),('325','2014-03-30','14:10:00',4.2),('325','2014-03-30','14:15:00',4.2),('325','2014-03-30','14:20:00',4.3),('325','2014-03-30','14:25:00',4.42),('325','2014-03-30','14:30:00',4.26),('325','2014-03-30','14:35:00',3.64),('325','2014-03-30','14:40:00',3.56),('325','2014-03-30','14:45:00',3.38),('325','2014-03-30','14:50:00',2.53),('325','2014-03-30','14:55:00',1.68),('325','2014-03-30','15:00:00',2.35),('325','2014-03-30','15:05:00',2.62),('325','2014-03-30','15:10:00',2.44),('325','2014-03-30','15:15:00',3.23),('325','2014-03-30','15:20:00',3.38),('325','2014-03-30','15:25:00',3.55),('325','2014-03-30','15:30:00',3.56),('325','2014-03-30','15:35:00',3.46),('325','2014-03-30','15:40:00',3.5),('325','2014-03-30','15:45:00',3.51),('325','2014-03-30','15:50:00',3.46),('325','2014-03-30','15:55:00',3.29),('325','2014-03-30','16:00:00',2.86),('325','2014-03-30','16:05:00',2.89),('325','2014-03-30','16:10:00',2.76),('325','2014-03-30','16:15:00',3.02),('325','2014-03-30','16:20:00',3.08),('325','2014-03-30','16:25:00',3),('325','2014-03-30','16:30:00',2.92),('325','2014-03-30','16:35:00',2.94),('325','2014-03-30','16:40:00',2.67),('325','2014-03-30','16:45:00',2.43),('325','2014-03-30','16:50:00',2.13),('325','2014-03-30','16:55:00',2.03),('325','2014-03-30','17:00:00',2.21),('325','2014-03-30','17:05:00',2.28),('325','2014-03-30','17:10:00',2.33),('325','2014-03-30','17:15:00',2.24),('325','2014-03-30','17:20:00',2.1),('325','2014-03-30','17:25:00',1.83),('325','2014-03-30','17:30:00',1.82),('325','2014-03-30','17:35:00',1.71),('325','2014-03-30','17:40:00',1.53),('325','2014-03-30','17:45:00',1.51),('325','2014-03-30','17:50:00',1.3),('325','2013-05-10','08:00:00',1.09),('325','2013-05-10','08:05:00',1.4),('325','2013-05-10','08:10:00',1.49),('325','2013-05-10','08:15:00',1.55),('325','2013-05-10','08:20:00',1.47),('325','2013-05-10','08:25:00',1.41),('325','2013-05-10','08:30:00',1.39),('325','2013-05-10','08:35:00',1.31),('325','2013-05-10','09:00:00',1.1),('325','2013-05-10','09:05:00',1.53),('325','2013-05-10','09:10:00',1.7),('325','2013-05-10','09:15:00',2.34),('325','2013-05-10','09:20:00',2.37),('325','2013-05-10','09:25:00',2.27),('325','2013-05-10','09:30:00',2.37),('325','2013-05-10','09:35:00',2.72),('325','2013-05-10','09:40:00',2.5),('325','2013-05-10','09:45:00',2.49),('325','2013-05-10','09:50:00',2.87),('325','2013-05-10','09:55:00',1.69),('325','2013-05-10','10:00:00',1.4),('325','2013-05-10','10:05:00',1.41),('325','2013-05-10','10:10:00',1.04),('325','2013-05-10','10:15:00',1.61),('325','2013-05-10','10:20:00',3.95),('325','2013-05-10','10:25:00',3.69),('325','2013-05-10','10:30:00',3.97),('325','2013-05-10','10:35:00',4.03),('325','2013-05-10','10:40:00',4.03),('325','2013-05-10','10:45:00',4.02),('325','2013-05-10','10:50:00',4.12),('325','2013-05-10','10:55:00',4.26),('325','2013-05-10','11:00:00',4.21),('325','2013-05-10','11:05:00',4.15),('325','2013-05-10','11:10:00',4.3),('325','2013-05-10','11:15:00',4.44),('325','2013-05-10','11:20:00',4.59),('325','2013-05-10','11:25:00',3.79),('325','2013-05-10','11:30:00',3.94),('325','2013-05-10','11:35:00',3.01),('325','2013-05-10','11:40:00',4.24),('325','2013-05-10','11:45:00',3.4),('325','2013-05-10','11:50:00',4.09),('325','2013-05-10','11:55:00',3.86),('325','2013-05-10','12:00:00',1.99),('325','2013-05-10','12:05:00',1.96),('325','2013-05-10','12:10:00',2.12),('325','2013-05-10','12:15:00',3.15),('325','2013-05-10','12:20:00',3.06),('325','2013-05-10','12:25:00',2.22),('325','2013-05-10','12:30:00',2.3),('325','2013-05-10','12:35:00',2.62),('325','2013-05-10','12:40:00',4.2),('325','2013-05-10','12:45:00',4.91),('325','2013-05-10','12:50:00',3.14),('325','2013-05-10','12:55:00',4.18),('325','2013-05-10','13:00:00',4.3),('325','2013-05-10','13:05:00',4.85),('325','2013-05-10','13:10:00',5.67),('325','2013-05-10','13:15:00',4.54),('325','2013-05-10','13:20:00',3.53),('325','2013-05-10','13:25:00',3.11),('325','2013-05-10','13:30:00',4.04),('325','2013-05-10','13:35:00',4.12),('325','2013-05-10','13:40:00',4.27),('325','2013-05-10','13:45:00',4.09),('325','2013-05-10','13:50:00',2.34),('325','2013-05-10','13:55:00',2.22),('325','2013-05-10','14:00:00',2.06),('325','2013-05-10','14:05:00',2.29),('325','2013-05-10','14:10:00',2.82),('325','2013-05-10','14:15:00',2.91),('325','2013-05-10','14:20:00',2.71),('325','2013-05-10','14:25:00',2.82),('325','2013-05-10','14:30:00',2.82),('325','2013-05-10','14:35:00',3.32),('325','2013-05-10','14:40:00',2.87),('325','2013-05-10','14:45:00',1.9),('325','2013-05-10','14:50:00',1.43),('325','2013-05-10','14:55:00',1.31),('325','2013-05-10','15:00:00',1.29),('325','2013-05-10','15:05:00',1.53),('325','2013-05-10','15:10:00',2.3),('325','2013-05-10','15:15:00',3.7),('325','2013-05-10','15:20:00',2.58),('325','2013-05-10','15:25:00',2.12),('325','2013-05-10','15:30:00',2.11),('325','2013-05-10','15:35:00',2.18),('325','2013-05-10','15:40:00',2.27),('325','2013-05-10','15:45:00',2.1),('325','2013-05-10','15:50:00',1.88),('325','2013-05-10','15:55:00',1.78),('325','2013-05-10','16:00:00',1.75),('325','2013-05-10','16:05:00',1.68),('325','2013-05-10','16:10:00',1.62),('325','2013-05-10','16:15:00',1.47),('325','2013-05-10','16:20:00',1.38),('325','2013-05-10','16:25:00',1.43),('325','2013-05-10','16:30:00',1.6),('325','2013-05-10','16:35:00',1.64),('325','2013-05-10','16:40:00',1.53),('325','2013-05-10','16:45:00',1.56),('325','2013-05-10','16:50:00',1.39),('325','2013-05-10','16:55:00',1.11),('325','2013-05-10','17:05:00',1.05),('325','2013-05-10','17:10:00',1.48),('325','2013-05-10','17:15:00',1.73),('325','2013-05-10','17:20:00',2.62),('325','2013-05-10','17:25:00',2.42),('325','2013-05-10','17:30:00',2.23),('325','2013-05-10','17:35:00',2.33),('325','2013-05-10','17:40:00',1.47),('325','2013-05-10','17:45:00',1.53),('325','2013-05-10','17:50:00',1.18),('325','2013-05-10','17:55:00',1.07),('325','2013-05-09','08:20:00',1.01),('325','2013-05-09','08:25:00',1.06),('325','2013-05-09','08:30:00',1.12),('325','2013-05-09','08:35:00',1.18),('325','2013-05-09','08:40:00',1.24),('325','2013-05-09','08:45:00',1.3),('325','2013-05-09','08:50:00',1.33),('325','2013-05-09','08:55:00',1.34),('325','2013-05-09','09:00:00',1.35),('325','2013-05-09','09:05:00',1.36),('325','2013-05-09','09:10:00',2.18),('325','2013-05-09','09:15:00',2.35),('325','2013-05-09','09:20:00',2.45),('325','2013-05-09','09:25:00',2.53),('325','2013-05-09','09:30:00',2.62),('325','2013-05-09','09:35:00',2.67),('325','2013-05-09','09:40:00',2.76),('325','2013-05-09','09:45:00',2.84),('325','2013-05-09','09:50:00',3.09),('325','2013-05-09','09:55:00',3.16),('325','2013-05-09','10:00:00',3.2),('325','2013-05-09','10:05:00',3.33),('325','2013-05-09','10:10:00',3.37),('325','2013-05-09','10:15:00',3.4),('325','2013-05-09','10:20:00',3.42),('325','2013-05-09','10:25:00',3.43),('325','2013-05-09','10:30:00',3.51),('325','2013-05-09','10:35:00',3.68),('325','2013-05-09','10:40:00',3.88),('325','2013-05-09','10:45:00',3.97),('325','2013-05-09','10:50:00',4.01),('325','2013-05-09','10:55:00',4.07),('325','2013-05-09','11:00:00',4.1),('325','2013-05-09','11:05:00',4.13),('325','2013-05-09','11:10:00',4.17),('325','2013-05-09','11:15:00',4.22),('325','2013-05-09','11:20:00',4.23),('325','2013-05-09','11:25:00',4.27),('325','2013-05-09','11:30:00',4.31),('325','2013-05-09','11:35:00',4.33),('325','2013-05-09','11:40:00',4.34),('325','2013-05-09','11:45:00',4.44),('325','2013-05-09','11:50:00',4.46),('325','2013-05-09','11:55:00',4.49),('325','2013-05-09','12:00:00',4.52),('325','2013-05-09','12:05:00',4.52),('325','2013-05-09','12:10:00',4.47),('325','2013-05-09','12:15:00',4.46),('325','2013-05-09','12:20:00',4.46),('325','2013-05-09','12:25:00',4.5),('325','2013-05-09','12:30:00',4.52),('325','2013-05-09','12:35:00',4.52),('325','2013-05-09','12:40:00',4.53),('325','2013-05-09','12:45:00',4.65),('325','2013-05-09','12:50:00',4.69),('325','2013-05-09','12:55:00',4.69),('325','2013-05-09','13:00:00',4.61),('325','2013-05-09','13:05:00',4.55),('325','2013-05-09','13:10:00',4.47),('325','2013-05-09','13:15:00',4.46),('325','2013-05-09','13:20:00',4.41),('325','2013-05-09','13:25:00',4.34),('325','2013-05-09','13:30:00',4.39),('325','2013-05-09','13:35:00',4.44),('325','2013-05-09','13:40:00',4.48),('325','2013-05-09','13:45:00',4.65),('325','2013-05-09','13:50:00',4.63),('325','2013-05-09','13:55:00',4.66),('325','2013-05-09','14:00:00',4.23),('325','2013-05-09','14:05:00',1.95),('325','2013-05-09','14:10:00',4.95),('325','2013-05-09','14:15:00',3.78),('325','2013-05-09','14:20:00',2.79),('325','2013-05-09','14:25:00',4.19),('325','2013-05-09','14:30:00',4.64),('325','2013-05-09','14:35:00',4.56),('325','2013-05-09','14:40:00',4.46),('325','2013-05-09','14:45:00',4.42),('325','2013-05-09','14:50:00',4.37),('325','2013-05-09','14:55:00',4.43),('325','2013-05-09','15:00:00',4.36),('325','2013-05-09','15:05:00',4.32),('325','2013-05-09','15:10:00',4.26),('325','2013-05-09','15:15:00',4.2),('325','2013-05-09','15:20:00',4.15),('325','2013-05-09','15:25:00',4.11),('325','2013-05-09','15:30:00',4.05),('325','2013-05-09','15:35:00',4.02),('325','2013-05-09','15:40:00',3.98),('325','2013-05-09','15:45:00',3.95),('325','2013-05-09','15:50:00',3.9),('325','2013-05-09','15:55:00',3.83),('325','2013-05-09','16:00:00',3.76),('325','2013-05-09','16:05:00',3.72),('325','2013-05-09','16:10:00',3.63),('325','2013-05-09','16:15:00',3.53),('325','2013-05-09','16:20:00',3.47),('325','2013-05-09','16:25:00',3.39),('325','2013-05-09','16:30:00',3.33),('325','2013-05-09','16:35:00',3.25),('325','2013-05-09','16:40:00',3.14),('325','2013-05-09','16:45:00',3.04),('325','2013-05-09','16:50:00',2.91),('325','2013-05-09','16:55:00',2.8),('325','2013-05-09','17:00:00',2.76),('325','2013-05-09','17:05:00',2.65),('325','2013-05-09','17:10:00',2.57),('325','2013-05-09','17:15:00',2.49),('325','2013-05-09','17:20:00',2.41),('325','2013-05-09','17:25:00',2.31),('325','2013-05-09','17:30:00',2.21),('325','2013-05-09','17:35:00',2.06),('325','2013-05-09','17:40:00',1.98),('325','2013-05-09','17:45:00',1.89),('325','2013-05-09','17:50:00',1.78),('325','2013-05-09','17:55:00',1.7),('325','2013-05-09','18:00:00',1.58),('325','2013-05-09','18:05:00',1.48),('325','2013-05-09','18:10:00',1.38),('325','2013-05-09','18:15:00',1.3),('325','2013-05-09','18:20:00',1.2),('325','2013-05-09','18:25:00',1.08),('325','2013-05-08','08:20:00',1.03),('325','2013-05-08','08:25:00',1.05),('325','2013-05-08','08:30:00',1.07),('325','2013-05-08','08:35:00',1.22),('325','2013-05-08','08:40:00',1.39),('325','2013-05-08','08:45:00',1.58),('325','2013-05-08','08:50:00',1.39),('325','2013-05-08','08:55:00',1.14),('325','2013-05-08','09:35:00',2.48),('325','2013-05-08','09:40:00',3.03),('325','2013-05-08','09:45:00',2.99),('325','2013-05-08','09:50:00',3.04),('325','2013-05-08','09:55:00',1.95),('325','2013-05-08','10:00:00',1.62),('325','2013-05-08','10:05:00',3.98),('325','2013-05-08','10:10:00',1.91),('325','2013-05-08','10:20:00',1.04),('325','2013-05-08','10:30:00',1.01),('325','2013-05-08','10:35:00',1.01),('325','2013-05-08','10:40:00',1.02),('325','2013-05-08','10:50:00',1.9),('325','2013-05-08','10:55:00',3.13),('325','2013-05-08','11:00:00',2.38),('325','2013-05-08','11:05:00',3.76),('325','2013-05-08','11:10:00',2.61),('325','2013-05-08','11:15:00',1.54),('325','2013-05-08','11:20:00',3.73),('325','2013-05-08','11:25:00',4.67),('325','2013-05-08','11:30:00',4.01),('325','2013-05-08','11:35:00',4.35),('325','2013-05-08','11:40:00',1.92),('325','2013-05-08','11:45:00',2.54),('325','2013-05-08','11:50:00',1.93),('325','2013-05-08','11:55:00',5.08),('325','2013-05-08','12:00:00',1.72),('325','2013-05-08','12:15:00',1.32),('325','2013-05-08','12:20:00',3.21),('325','2013-05-08','12:25:00',2.23),('325','2013-05-08','12:30:00',1.35),('325','2013-05-08','12:35:00',1.92),('325','2013-05-08','12:40:00',1.28),('325','2013-05-08','12:45:00',1.21),('325','2013-05-08','12:50:00',2.85),('325','2013-05-08','12:55:00',2.35),('325','2013-05-08','13:00:00',1.7),('325','2013-05-08','13:05:00',2.22),('325','2013-05-08','13:10:00',5.63),('325','2013-05-08','13:15:00',1.9),('325','2013-05-08','13:20:00',1.3),('325','2013-05-08','13:25:00',2.82),('325','2013-05-08','13:30:00',1.23),('325','2013-05-08','13:35:00',1.15),('325','2013-05-08','13:40:00',3.58),('325','2013-05-08','13:45:00',5.32),('325','2013-05-08','13:50:00',5.45),('325','2013-05-08','13:55:00',4.85),('325','2013-05-08','14:00:00',4.54),('325','2013-05-08','14:05:00',4.49),('325','2013-05-08','14:10:00',1.73),('325','2013-05-08','14:15:00',2.56),('325','2013-05-08','14:20:00',1.88),('325','2013-05-08','14:25:00',2.06),('325','2013-05-08','14:30:00',4.28),('325','2013-05-08','14:35:00',3.21),('325','2013-05-08','14:40:00',4.65),('325','2013-05-08','14:45:00',2.17),('325','2013-05-08','14:50:00',4.68),('325','2013-05-08','14:55:00',3.75),('325','2013-05-08','15:00:00',4.35),('325','2013-05-08','15:05:00',4.45),('325','2013-05-08','15:10:00',4.35),('325','2013-05-08','15:15:00',4.31),('325','2013-05-08','15:20:00',4.23),('325','2013-05-08','15:25:00',4.21),('325','2013-05-08','15:30:00',4.15),('325','2013-05-08','15:35:00',4.08),('325','2013-05-08','15:40:00',4),('325','2013-05-08','15:45:00',3.95),('325','2013-05-08','15:50:00',3.93),('325','2013-05-08','15:55:00',3.87),('325','2013-05-08','16:00:00',3.86),('325','2013-05-08','16:05:00',3.76),('325','2013-05-08','16:10:00',3.29),('325','2013-05-08','16:15:00',3.65),('325','2013-05-08','16:20:00',3.53),('325','2013-05-08','16:25:00',3.49),('325','2013-05-08','16:30:00',3.48),('325','2013-05-08','16:35:00',3.42),('325','2013-05-08','16:40:00',2.36),('325','2013-05-08','16:45:00',3.17),('325','2013-05-08','16:50:00',2.07),('325','2013-05-08','16:55:00',2.79),('325','2013-05-08','17:00:00',3.06),('325','2013-05-08','17:05:00',2.99),('325','2013-05-08','17:10:00',2.87),('325','2013-05-08','17:15:00',2.64),('325','2013-05-08','17:20:00',2.06),('325','2013-05-08','17:25:00',2.46),('325','2013-05-08','17:30:00',2.51),('325','2013-05-08','17:35:00',2.33),('325','2013-05-08','17:40:00',2.13),('325','2013-05-08','17:45:00',2.41),('325','2013-05-08','17:50:00',2.41),('325','2013-05-08','17:55:00',2.31),('325','2013-05-08','18:00:00',1.25),('325','2013-05-08','18:10:00',1.04),('325','2013-05-08','18:15:00',1.69),('325','2013-05-08','18:20:00',1.58),('325','2013-05-08','18:25:00',1.38),('325','2013-05-08','18:30:00',1.15),('325','2013-05-07','08:20:00',1.02),('325','2013-05-07','08:25:00',1.07),('325','2013-05-07','08:30:00',1.12),('325','2013-05-07','08:35:00',1.21),('325','2013-05-07','08:40:00',1.28),('325','2013-05-07','08:45:00',1.37),('325','2013-05-07','08:50:00',1.29),('325','2013-05-07','08:55:00',1.03),('325','2013-05-07','09:05:00',1.13),('325','2013-05-07','09:10:00',1.22),('325','2013-05-07','09:15:00',1.06),('325','2013-05-07','09:20:00',1.6),('325','2013-05-07','09:30:00',1.63),('325','2013-05-07','09:35:00',1.67),('325','2013-05-07','09:40:00',2.08),('325','2013-05-07','09:45:00',1.99),('325','2013-05-07','09:50:00',1.43),('325','2013-05-07','09:55:00',1.19),('325','2013-05-07','10:50:00',1.18),('325','2013-05-07','10:55:00',1.42),('325','2013-05-07','11:00:00',1.54),('325','2013-05-07','11:05:00',1.54),('325','2013-05-07','11:10:00',2.26),('325','2013-05-07','11:15:00',1.52),('325','2013-05-07','11:20:00',3.23),('325','2013-05-07','11:55:00',4.05),('325','2013-05-07','12:00:00',4.48),('325','2013-05-07','12:05:00',5.32),('325','2013-05-07','12:10:00',5.3),('325','2013-05-07','12:15:00',5.32),('325','2013-05-07','12:20:00',5.17),('325','2013-05-07','12:25:00',1.55),('325','2013-05-07','12:30:00',1.02),('325','2013-05-07','13:05:00',1.17),('325','2013-05-07','13:10:00',1.47),('325','2013-05-07','13:15:00',1.55),('325','2013-05-07','13:20:00',1.5),('325','2013-05-07','13:25:00',2.66),('325','2013-05-07','13:30:00',3.25),('325','2013-05-07','13:35:00',5.86),('325','2013-05-07','13:40:00',5.65),('325','2013-05-07','13:45:00',5.34),('325','2013-05-07','13:50:00',5.1),('325','2013-05-07','13:55:00',2.03),('325','2013-05-07','14:00:00',4.53),('325','2013-05-07','14:05:00',4.53),('325','2013-05-07','14:10:00',3.52),('325','2013-05-07','14:15:00',5),('325','2013-05-07','14:20:00',1.63),('325','2013-05-07','14:25:00',3.69),('325','2013-05-07','14:30:00',3.03),('325','2013-05-07','14:35:00',3.14),('325','2013-05-07','14:40:00',4.04),('325','2013-05-07','14:45:00',2.14),('325','2013-05-07','14:50:00',5.15),('325','2013-05-07','14:55:00',3.27),('325','2013-05-07','15:00:00',3.7),('325','2013-05-07','15:05:00',4.56),('325','2013-05-07','15:10:00',4.32),('325','2013-05-07','15:15:00',4.35),('325','2013-05-07','15:20:00',4.79),('325','2013-05-07','15:25:00',3.24),('325','2013-05-07','15:30:00',2.56),('325','2013-05-07','15:35:00',3.95),('325','2013-05-07','15:40:00',3.18),('325','2013-05-07','15:45:00',3.45),('325','2013-05-07','15:50:00',2.04),('325','2013-05-07','15:55:00',2.63),('325','2013-05-07','16:00:00',4.42),('325','2013-05-07','16:05:00',1.44),('325','2013-05-07','16:10:00',2.07),('325','2013-05-07','16:15:00',3.81),('325','2013-05-07','16:20:00',4.46),('325','2013-05-07','16:25:00',4.33),('325','2013-05-07','16:30:00',4.07),('325','2013-05-07','16:35:00',3.99),('325','2013-05-07','16:40:00',3.56),('325','2013-05-07','16:45:00',3.63),('325','2013-05-07','16:50:00',2.85),('325','2013-05-07','16:55:00',2.72),('325','2013-05-07','17:00:00',3.03),('325','2013-05-07','17:05:00',2.85),('325','2013-05-07','17:10:00',1.34),('325','2013-05-07','17:15:00',1.26),('325','2013-05-07','17:20:00',1.36),('325','2013-05-07','17:25:00',1.29),('325','2013-05-07','17:30:00',1.17),('325','2013-05-07','17:35:00',1.07),('325','2013-05-06','08:25:00',1.22),('325','2013-05-06','08:30:00',1.22),('325','2013-05-06','08:35:00',1.15),('325','2013-05-06','08:40:00',1.06),('325','2013-05-06','08:50:00',1.46),('325','2013-05-06','08:55:00',2.09),('325','2013-05-06','09:00:00',2.06),('325','2013-05-06','09:05:00',1.54),('325','2013-05-06','09:10:00',1.36),('325','2013-05-06','09:15:00',1.35),('325','2013-05-06','09:20:00',1.61),('325','2013-05-06','09:25:00',1.3),('325','2013-05-06','09:55:00',1.2),('325','2013-05-06','10:00:00',1.58),('325','2013-05-06','10:05:00',1.14),('325','2013-05-06','10:10:00',1.07),('325','2013-05-06','10:15:00',1.47),('325','2013-05-06','10:20:00',2.66),('325','2013-05-06','10:25:00',2.11),('325','2013-05-06','10:30:00',2.08),('325','2013-05-06','10:35:00',2.09),('325','2013-05-06','10:40:00',1.99),('325','2013-05-06','10:45:00',2.52),('325','2013-05-06','10:50:00',2.08),('325','2013-05-06','10:55:00',1.88),('325','2013-05-06','11:00:00',1.79),('325','2013-05-06','11:05:00',2.04),('325','2013-05-06','11:10:00',2.06),('325','2013-05-06','11:15:00',1.81),('325','2013-05-06','11:20:00',2.25),('325','2013-05-06','11:25:00',2.13),('325','2013-05-06','11:30:00',1.31),('325','2013-05-06','11:35:00',2.09),('325','2013-05-06','11:40:00',2.35),('325','2013-05-06','11:45:00',3.97),('325','2013-05-06','11:50:00',1.97),('325','2013-05-06','11:55:00',1.78),('325','2013-05-06','12:00:00',2.52),('325','2013-05-06','12:05:00',2.2),('325','2013-05-06','12:10:00',2.66),('325','2013-05-06','12:15:00',2.59),('325','2013-05-06','12:20:00',2.52),('325','2013-05-06','12:25:00',4.14),('325','2013-05-06','12:30:00',4.4),('325','2013-05-06','12:35:00',4.08),('325','2013-05-06','12:40:00',2.06),('325','2013-05-06','12:45:00',2.85),('325','2013-05-06','12:50:00',4.63),('325','2013-05-06','12:55:00',2.66),('325','2013-05-06','13:00:00',2.28),('325','2013-05-06','13:05:00',4.7),('325','2013-05-06','13:10:00',3.93),('325','2013-05-06','13:15:00',4.32),('325','2013-05-06','13:20:00',3.68),('325','2013-05-06','13:25:00',4.09),('325','2013-05-06','13:30:00',2.71),('325','2013-05-06','13:35:00',4.01),('325','2013-05-06','13:40:00',3.7),('325','2013-05-06','13:45:00',4.47),('325','2013-05-06','13:50:00',4.9),('325','2013-05-06','13:55:00',5.05),('325','2013-05-06','14:00:00',3.83),('325','2013-05-06','14:05:00',3.86),('325','2013-05-06','14:10:00',2.91),('325','2013-05-06','14:15:00',4.27),('325','2013-05-06','14:20:00',4.99),('325','2013-05-06','14:25:00',2.84),('325','2013-05-06','14:30:00',4.43),('325','2013-05-06','14:35:00',4.51),('325','2013-05-06','14:40:00',3.1),('325','2013-05-06','14:45:00',2.7),('325','2013-05-06','14:50:00',2.71),('325','2013-05-06','14:55:00',5.06),('325','2013-05-06','15:00:00',3.63),('325','2013-05-06','15:05:00',2.92),('325','2013-05-06','15:10:00',3.94),('325','2013-05-06','15:15:00',3.03),('325','2013-05-06','15:20:00',2.48),('325','2013-05-06','15:25:00',2.55),('325','2013-05-06','15:30:00',2.28),('325','2013-05-06','15:35:00',2.59),('325','2013-05-06','15:40:00',1.36),('325','2013-05-06','15:45:00',1.74),('325','2013-05-06','15:50:00',2.42),('325','2013-05-06','15:55:00',1.34),('325','2013-05-06','16:00:00',2.41),('325','2013-05-06','16:05:00',1.65),('325','2013-05-06','16:10:00',1.5),('325','2013-05-06','16:15:00',1.85),('325','2013-05-06','16:20:00',2.39),('325','2013-05-06','16:25:00',2.49),('325','2013-05-06','16:30:00',1.81),('325','2013-05-06','16:35:00',2.57),('325','2013-05-06','16:40:00',2.39),('325','2013-05-06','16:45:00',2.36),('325','2013-05-06','16:50:00',3.32),('325','2013-05-06','16:55:00',2.4),('325','2013-05-06','17:15:00',1.57),('325','2013-05-06','17:20:00',1.02),('325','2013-05-06','17:25:00',1.03),('325','2013-05-06','17:35:00',1.62),('325','2013-05-06','17:40:00',1.8),('325','2013-05-06','17:45:00',1.36),('325','2013-05-06','17:50:00',1.16),('325','2013-05-06','17:55:00',1.58),('325','2013-05-06','18:00:00',1.56),('325','2013-05-06','18:05:00',1.76),('325','2013-05-06','18:15:00',1.46),('325','2013-05-06','18:20:00',1.67),('325','2013-05-06','18:25:00',1.26),('325','2013-05-05','08:15:00',1.03),('325','2013-05-05','08:20:00',1.3),('325','2013-05-05','08:25:00',1.67),('325','2013-05-05','08:30:00',1.79),('325','2013-05-05','08:35:00',1.62),('325','2013-05-05','08:40:00',1.65),('325','2013-05-05','08:45:00',1.39),('325','2013-05-05','08:50:00',1.2),('325','2013-05-05','08:55:00',1.32),('325','2013-05-05','09:00:00',1.36),('325','2013-05-05','09:05:00',1.32),('325','2013-05-05','09:10:00',1.32),('325','2013-05-05','09:15:00',1.23),('325','2013-05-05','09:20:00',1.19),('325','2013-05-05','09:25:00',1.42),('325','2013-05-05','09:30:00',1.8),('325','2013-05-05','09:35:00',1.64),('325','2013-05-05','09:40:00',2.26),('325','2013-05-05','09:45:00',3.06),('325','2013-05-05','09:50:00',3.13),('325','2013-05-05','09:55:00',3.36),('325','2013-05-05','10:00:00',3.25),('325','2013-05-05','10:05:00',2.53),('325','2013-05-05','10:10:00',2.28),('325','2013-05-05','10:15:00',3.22),('325','2013-05-05','10:20:00',3.6),('325','2013-05-05','10:25:00',2.38),('325','2013-05-05','10:30:00',2.81),('325','2013-05-05','10:35:00',3.06),('325','2013-05-05','10:40:00',3.4),('325','2013-05-05','10:45:00',3.21),('325','2013-05-05','10:50:00',1.75),('325','2013-05-05','10:55:00',1.52),('325','2013-05-05','11:00:00',1.58),('325','2013-05-05','11:05:00',1.79),('325','2013-05-05','11:10:00',1.58),('325','2013-05-05','11:15:00',1.83),('325','2013-05-05','11:20:00',3.04),('325','2013-05-05','11:25:00',3.49),('325','2013-05-05','11:30:00',2.84),('325','2013-05-05','11:35:00',3.73),('325','2013-05-05','11:40:00',3.34),('325','2013-05-05','11:45:00',2.78),('325','2013-05-05','11:50:00',3.36),('325','2013-05-05','11:55:00',4.39),('325','2013-05-05','12:00:00',3.29),('325','2013-05-05','12:05:00',3.36),('325','2013-05-05','12:10:00',3.63),('325','2013-05-05','12:15:00',3.67),('325','2013-05-05','12:20:00',3.71),('325','2013-05-05','12:25:00',4.5),('325','2013-05-05','12:30:00',4.04),('325','2013-05-05','12:35:00',4.47),('325','2013-05-05','12:40:00',5.05),('325','2013-05-05','12:45:00',5.11),('325','2013-05-05','12:50:00',4.71),('325','2013-05-05','12:55:00',4.94),('325','2013-05-05','13:00:00',4.9),('325','2013-05-05','13:05:00',4.72),('325','2013-05-05','13:10:00',4.82),('325','2013-05-05','13:15:00',3.3),('325','2013-05-05','13:20:00',3.5),('325','2013-05-05','13:25:00',2.22),('325','2013-05-05','13:30:00',2.1),('325','2013-05-05','13:35:00',4.86),('325','2013-05-05','13:40:00',4.85),('325','2013-05-05','13:45:00',4.75),('325','2013-05-05','13:50:00',4.88),('325','2013-05-05','13:55:00',4.89),('325','2013-05-05','14:00:00',4.44),('325','2013-05-05','14:05:00',4.23),('325','2013-05-05','14:10:00',3.73),('325','2013-05-05','14:15:00',4.25),('325','2013-05-05','14:20:00',4.56),('325','2013-05-05','14:25:00',4.36),('325','2013-05-05','14:30:00',4.24),('325','2013-05-05','14:35:00',4.19),('325','2013-05-05','14:40:00',4.17),('325','2013-05-05','14:45:00',4.17),('325','2013-05-05','14:50:00',4.12),('325','2013-05-05','14:55:00',4.07),('325','2013-05-05','15:00:00',4.02),('325','2013-05-05','15:05:00',3.97),('325','2013-05-05','15:10:00',3.96),('325','2013-05-05','15:15:00',3.93),('325','2013-05-05','15:20:00',3.87),('325','2013-05-05','15:25:00',3.84),('325','2013-05-05','15:30:00',3.81),('325','2013-05-05','15:35:00',3.77),('325','2013-05-05','15:40:00',3.75),('325','2013-05-05','15:45:00',3.7),('325','2013-05-05','15:50:00',3.67),('325','2013-05-05','15:55:00',3.6),('325','2013-05-05','16:00:00',3.54),('325','2013-05-05','16:05:00',3.48),('325','2013-05-05','16:10:00',3.42),('325','2013-05-05','16:15:00',3.35),('325','2013-05-05','16:20:00',3.29),('325','2013-05-05','16:25:00',3.23),('325','2013-05-05','16:30:00',3.15),('325','2013-05-05','16:35:00',3.07),('325','2013-05-05','16:40:00',3),('325','2013-05-05','16:45:00',2.9),('325','2013-05-05','16:50:00',2.77),('325','2013-05-05','16:55:00',2.63),('325','2013-05-05','17:00:00',2.59),('325','2013-05-05','17:05:00',2.51),('325','2013-05-05','17:10:00',2.42),('325','2013-05-05','17:15:00',2.33),('325','2013-05-05','17:20:00',2.24),('325','2013-05-05','17:25:00',2.13),('325','2013-05-05','17:30:00',2.03),('325','2013-05-05','17:35:00',1.88),('325','2013-05-05','17:40:00',1.83),('325','2013-05-05','17:45:00',1.74),('325','2013-05-05','17:50:00',1.64),('325','2013-05-05','17:55:00',1.53),('325','2013-05-05','18:00:00',1.44),('325','2013-05-05','18:05:00',1.34),('325','2013-05-05','18:10:00',1.25),('325','2013-05-05','18:15:00',1.16),('325','2013-05-05','18:20:00',1.08),('325','2013-05-04','08:30:00',1.05),('325','2013-05-04','08:35:00',1.1),('325','2013-05-04','08:40:00',1.16),('325','2013-05-04','08:45:00',1.2),('325','2013-05-04','08:50:00',1.22),('325','2013-05-04','08:55:00',1.33),('325','2013-05-04','09:00:00',1.42),('325','2013-05-04','09:05:00',1.46),('325','2013-05-04','09:10:00',1.78),('325','2013-05-04','09:15:00',2.16),('325','2013-05-04','09:20:00',2.25),('325','2013-05-04','09:25:00',2.34),('325','2013-05-04','09:30:00',2.36),('325','2013-05-04','09:35:00',2.47),('325','2013-05-04','09:40:00',2.6),('325','2013-05-04','09:45:00',2.7),('325','2013-05-04','09:50:00',2.89),('325','2013-05-04','09:55:00',2.97),('325','2013-05-04','10:00:00',3.05),('325','2013-05-04','10:05:00',3.04),('325','2013-05-04','10:10:00',3.1),('325','2013-05-04','10:15:00',3.21),('325','2013-05-04','10:20:00',3.28),('325','2013-05-04','10:25:00',3.32),('325','2013-05-04','10:30:00',3.35),('325','2013-05-04','10:35:00',3.37),('325','2013-05-04','10:40:00',3.37),('325','2013-05-04','10:45:00',3.43),('325','2013-05-04','10:50:00',3.4),('325','2013-05-04','10:55:00',3.57),('325','2013-05-04','11:00:00',3.57),('325','2013-05-04','11:05:00',3.54),('325','2013-05-04','11:10:00',3.36),('325','2013-05-04','11:15:00',3.36),('325','2013-05-04','11:20:00',3.61),('325','2013-05-04','11:25:00',3.61),('325','2013-05-04','11:30:00',3.53),('325','2013-05-04','11:35:00',3.64),('325','2013-05-04','11:40:00',3.59),('325','2013-05-04','11:45:00',3.73),('325','2013-05-04','11:50:00',3.79),('325','2013-05-04','11:55:00',3.84),('325','2013-05-04','12:00:00',3.8),('325','2013-05-04','12:05:00',3.85),('325','2013-05-04','12:10:00',3.88),('325','2013-05-04','12:15:00',3.96),('325','2013-05-04','12:20:00',4.03),('325','2013-05-04','12:25:00',4.07),('325','2013-05-04','12:30:00',4.11),('325','2013-05-04','12:35:00',4.1),('325','2013-05-04','12:40:00',4.12),('325','2013-05-04','12:45:00',4.2),('325','2013-05-04','12:50:00',4.07),('325','2013-05-04','12:55:00',4.07),('325','2013-05-04','13:00:00',3.96),('325','2013-05-04','13:05:00',3.57),('325','2013-05-04','13:10:00',3.88),('325','2013-05-04','13:15:00',4.27),('325','2013-05-04','13:20:00',4.24),('325','2013-05-04','13:25:00',4.03),('325','2013-05-04','13:30:00',4.13),('325','2013-05-04','13:35:00',3.86),('325','2013-05-04','13:40:00',4.02),('325','2013-05-04','13:45:00',4.04),('325','2013-05-04','13:50:00',3.63),('325','2013-05-04','13:55:00',3.69),('325','2013-05-04','14:00:00',4.03),('325','2013-05-04','14:05:00',3.89),('325','2013-05-04','14:10:00',3.72),('325','2013-05-04','14:15:00',3.81),('325','2013-05-04','14:20:00',3.73),('325','2013-05-04','14:25:00',3.5),('325','2013-05-04','14:30:00',3.7),('325','2013-05-04','14:35:00',3.45),('325','2013-05-04','14:40:00',3.64),('325','2013-05-04','14:45:00',3.59),('325','2013-05-04','14:50:00',3.49),('325','2013-05-04','14:55:00',3.6),('325','2013-05-04','15:00:00',3.68),('325','2013-05-04','15:05:00',3.75),('325','2013-05-04','15:10:00',3.54),('325','2013-05-04','15:15:00',3.61),('325','2013-05-04','15:20:00',3.59),('325','2013-05-04','15:25:00',3.61),('325','2013-05-04','15:30:00',3.62),('325','2013-05-04','15:35:00',3.49),('325','2013-05-04','15:40:00',3.61),('325','2013-05-04','15:45:00',3.55),('325','2013-05-04','15:50:00',3.48),('325','2013-05-04','15:55:00',3.42),('325','2013-05-04','16:00:00',3.35),('325','2013-05-04','16:05:00',3.28),('325','2013-05-04','16:10:00',3.23),('325','2013-05-04','16:15:00',3.17),('325','2013-05-04','16:20:00',3.08),('325','2013-05-04','16:25:00',3.03),('325','2013-05-04','16:30:00',2.93),('325','2013-05-04','16:35:00',2.87),('325','2013-05-04','16:40:00',2.81),('325','2013-05-04','16:45:00',2.71),('325','2013-05-04','16:50:00',2.58),('325','2013-05-04','16:55:00',2.45),('325','2013-05-04','17:00:00',2.43),('325','2013-05-04','17:05:00',2.35),('325','2013-05-04','17:10:00',1.81),('325','2013-05-04','17:15:00',2.11),('325','2013-05-04','17:20:00',2.16),('325','2013-05-04','17:25:00',2.06),('325','2013-05-04','17:30:00',1.93),('325','2013-05-04','17:35:00',1.73),('325','2013-05-04','17:40:00',1.62),('325','2013-05-04','17:45:00',1.61),('325','2013-05-04','17:50:00',1.59),('325','2013-05-04','17:55:00',1.51),('325','2013-05-04','18:00:00',1.43),('325','2013-05-04','18:05:00',1.34),('325','2013-05-04','18:10:00',1.12),('325','2013-05-03','08:10:00',1.04),('325','2013-05-03','08:15:00',1.15),('325','2013-05-03','08:20:00',1.17),('325','2013-05-03','08:25:00',1.26),('325','2013-05-03','08:30:00',1.29),('325','2013-05-03','08:35:00',1.27),('325','2013-05-03','08:40:00',1.28),('325','2013-05-03','08:45:00',1.28),('325','2013-05-03','08:50:00',1.22),('325','2013-05-03','08:55:00',1.26),('325','2013-05-03','09:00:00',1.35),('325','2013-05-03','09:05:00',2.04),('325','2013-05-03','09:10:00',2.15),('325','2013-05-03','09:15:00',2.23),('325','2013-05-03','09:20:00',2.32),('325','2013-05-03','09:25:00',2.39),('325','2013-05-03','09:30:00',2.47),('325','2013-05-03','09:35:00',2.52),('325','2013-05-03','09:40:00',2.62),('325','2013-05-03','09:45:00',2.86),('325','2013-05-03','09:50:00',3.08),('325','2013-05-03','09:55:00',3.12),('325','2013-05-03','10:00:00',3.17),('325','2013-05-03','10:05:00',3.23),('325','2013-05-03','10:10:00',3.4),('325','2013-05-03','10:15:00',3.45),('325','2013-05-03','10:20:00',3.5),('325','2013-05-03','10:25:00',3.55),('325','2013-05-03','10:30:00',3.58),('325','2013-05-03','10:35:00',3.65),('325','2013-05-03','10:40:00',3.76),('325','2013-05-03','10:45:00',3.84),('325','2013-05-03','10:50:00',3.88),('325','2013-05-03','10:55:00',3.91),('325','2013-05-03','11:00:00',3.95),('325','2013-05-03','11:05:00',3.97),('325','2013-05-03','11:10:00',3.99),('325','2013-05-03','11:15:00',4.05),('325','2013-05-03','11:20:00',4.1),('325','2013-05-03','11:25:00',4.13),('325','2013-05-03','11:30:00',4.12),('325','2013-05-03','11:35:00',4.18),('325','2013-05-03','11:40:00',4.2),('325','2013-05-03','11:45:00',4.24),('325','2013-05-03','11:50:00',4.3),('325','2013-05-03','11:55:00',4.37),('325','2013-05-03','12:00:00',4.35),('325','2013-05-03','12:05:00',4.29),('325','2013-05-03','12:10:00',4.3),('325','2013-05-03','12:15:00',4.31),('325','2013-05-03','12:20:00',4.32),('325','2013-05-03','12:25:00',4.36),('325','2013-05-03','12:30:00',4.34),('325','2013-05-03','12:35:00',4.34),('325','2013-05-03','12:40:00',4.35),('325','2013-05-03','12:45:00',4.36),('325','2013-05-03','12:50:00',4.49),('325','2013-05-03','12:55:00',4.52),('325','2013-05-03','13:00:00',4.48),('325','2013-05-03','13:05:00',4.41),('325','2013-05-03','13:10:00',4.38),('325','2013-05-03','13:15:00',4.34),('325','2013-05-03','13:20:00',4.26),('325','2013-05-03','13:25:00',4.24),('325','2013-05-03','13:30:00',4.23),('325','2013-05-03','13:35:00',4.2),('325','2013-05-03','13:40:00',4.11),('325','2013-05-03','13:45:00',4.15),('325','2013-05-03','13:50:00',4.2),('325','2013-05-03','13:55:00',4.21),('325','2013-05-03','14:00:00',4.17),('325','2013-05-03','14:05:00',4.07),('325','2013-05-03','14:10:00',4.06),('325','2013-05-03','14:15:00',4.04),('325','2013-05-03','14:20:00',4.18),('325','2013-05-03','14:25:00',4.14),('325','2013-05-03','14:30:00',4.14),('325','2013-05-03','14:35:00',4.14),('325','2013-05-03','14:40:00',4.07),('325','2013-05-03','14:45:00',4.05),('325','2013-05-03','14:50:00',3.98),('325','2013-05-03','14:55:00',4),('325','2013-05-03','15:00:00',4.01),('325','2013-05-03','15:05:00',3.97),('325','2013-05-03','15:10:00',3.95),('325','2013-05-03','15:15:00',3.94),('325','2013-05-03','15:20:00',3.91),('325','2013-05-03','15:25:00',3.87),('325','2013-05-03','15:30:00',3.86),('325','2013-05-03','15:35:00',3.79),('325','2013-05-03','15:40:00',3.75),('325','2013-05-03','15:45:00',3.71),('325','2013-05-03','15:50:00',3.63),('325','2013-05-03','15:55:00',3.57),('325','2013-05-03','16:00:00',3.53),('325','2013-05-03','16:05:00',3.46),('325','2013-05-03','16:10:00',3.42),('325','2013-05-03','16:15:00',3.3),('325','2013-05-03','16:20:00',3.15),('325','2013-05-03','16:25:00',3.14),('325','2013-05-03','16:30:00',3.11),('325','2013-05-03','16:35:00',3.03),('325','2013-05-03','16:40:00',2.95),('325','2013-05-03','16:45:00',2.84),('325','2013-05-03','16:50:00',2.72),('325','2013-05-03','16:55:00',2.62),('325','2013-05-03','17:00:00',2.53),('325','2013-05-03','17:05:00',2.46),('325','2013-05-03','17:10:00',2.34),('325','2013-05-03','17:15:00',2.25),('325','2013-05-03','17:20:00',2.13),('325','2013-05-03','17:25:00',2.02),('325','2013-05-03','17:30:00',1.91),('325','2013-05-03','17:35:00',1.76),('325','2013-05-03','17:40:00',1.68),('325','2013-05-03','17:45:00',1.59),('325','2013-05-03','17:50:00',1.47),('325','2013-05-03','17:55:00',1.4),('325','2013-05-03','18:00:00',1.35),('325','2013-05-03','18:05:00',1.28),('325','2013-05-03','18:10:00',1.19),('325','2013-05-03','18:15:00',1.1),('325','2013-05-03','18:20:00',1.01),('325','2013-05-02','08:55:00',1.29),('325','2013-05-02','09:00:00',1.43),('325','2013-05-02','09:05:00',1.22),('325','2013-05-02','09:25:00',1.75),('325','2013-05-02','09:30:00',2.05),('325','2013-05-02','09:35:00',1.94),('325','2013-05-02','09:40:00',1.56),('325','2013-05-02','09:45:00',2.73),('325','2013-05-02','09:50:00',1.38),('325','2013-05-02','09:55:00',1.09),('325','2013-05-02','10:00:00',1.11),('325','2013-05-02','10:05:00',1.55),('325','2013-05-02','10:10:00',1.4),('325','2013-05-02','10:15:00',1.49),('325','2013-05-02','10:20:00',1.56),('325','2013-05-02','10:25:00',1.84),('325','2013-05-02','10:30:00',2.85),('325','2013-05-02','10:35:00',3.12),('325','2013-05-02','10:40:00',3.56),('325','2013-05-02','10:45:00',3.28),('325','2013-05-02','10:50:00',3.98),('325','2013-05-02','10:55:00',4.3),('325','2013-05-02','11:00:00',4.19),('325','2013-05-02','11:05:00',3.59),('325','2013-05-02','11:10:00',3.39),('325','2013-05-02','11:15:00',3.08),('325','2013-05-02','11:20:00',3.54),('325','2013-05-02','11:25:00',3.98),('325','2013-05-02','11:30:00',4.13),('325','2013-05-02','11:35:00',3.9),('325','2013-05-02','11:40:00',4.14),('325','2013-05-02','11:45:00',4.19),('325','2013-05-02','11:50:00',4.24),('325','2013-05-02','11:55:00',4.26),('325','2013-05-02','12:00:00',4.27),('325','2013-05-02','12:05:00',4.23),('325','2013-05-02','12:10:00',4.22),('325','2013-05-02','12:15:00',4.25),('325','2013-05-02','12:20:00',4.24),('325','2013-05-02','12:25:00',4.25),('325','2013-05-02','12:30:00',4.33),('325','2013-05-02','12:35:00',4.41),('325','2013-05-02','12:40:00',4.47),('325','2013-05-02','12:45:00',4.54),('325','2013-05-02','12:50:00',4.58),('325','2013-05-02','12:55:00',4.64),('325','2013-05-02','13:00:00',4.67),('325','2013-05-02','13:05:00',4.65),('325','2013-05-02','13:10:00',4.69),('325','2013-05-02','13:15:00',4.71),('325','2013-05-02','13:20:00',4.69),('325','2013-05-02','13:25:00',4.7),('325','2013-05-02','13:30:00',4.7),('325','2013-05-02','13:35:00',4.66),('325','2013-05-02','13:40:00',4.64),('325','2013-05-02','13:45:00',4.58),('325','2013-05-02','13:50:00',4.57),('325','2013-05-02','13:55:00',4.51),('325','2013-05-02','14:00:00',4.45),('325','2013-05-02','14:05:00',4.34),('325','2013-05-02','14:10:00',4.35),('325','2013-05-02','14:15:00',4.42),('325','2013-05-02','14:20:00',4.38),('325','2013-05-02','14:25:00',4.37),('325','2013-05-02','14:30:00',4.34),('325','2013-05-02','14:35:00',4.29),('325','2013-05-02','14:40:00',4.25),('325','2013-05-02','14:45:00',4.21),('325','2013-05-02','14:50:00',4.17),('325','2013-05-02','14:55:00',4.13),('325','2013-05-02','15:00:00',4.1),('325','2013-05-02','15:05:00',4.06),('325','2013-05-02','15:10:00',4.01),('325','2013-05-02','15:15:00',3.96),('325','2013-05-02','15:20:00',3.88),('325','2013-05-02','15:25:00',3.84),('325','2013-05-02','15:30:00',3.8),('325','2013-05-02','15:35:00',3.78),('325','2013-05-02','15:40:00',3.73),('325','2013-05-02','15:45:00',3.69),('325','2013-05-02','15:50:00',3.61),('325','2013-05-02','15:55:00',3.56),('325','2013-05-02','16:00:00',3.5),('325','2013-05-02','16:05:00',3.46),('325','2013-05-02','16:10:00',3.38),('325','2013-05-02','16:15:00',3.31),('325','2013-05-02','16:20:00',3.23),('325','2013-05-02','16:25:00',3.16),('325','2013-05-02','16:30:00',3.06),('325','2013-05-02','16:35:00',2.98),('325','2013-05-02','16:40:00',2.92),('325','2013-05-02','16:45:00',2.82),('325','2013-05-02','16:50:00',2.7),('325','2013-05-02','16:55:00',2.56),('325','2013-05-02','17:00:00',2.54),('325','2013-05-02','17:05:00',2.48),('325','2013-05-02','17:10:00',2.4),('325','2013-05-02','17:15:00',2.31),('325','2013-05-02','17:20:00',2.22),('325','2013-05-02','17:25:00',2.13),('325','2013-05-02','17:30:00',2.03),('325','2013-05-02','17:35:00',1.88),('325','2013-05-02','17:40:00',1.82),('325','2013-05-02','17:45:00',1.73),('325','2013-05-02','17:50:00',1.63),('325','2013-05-02','17:55:00',1.53),('325','2013-05-02','18:00:00',1.44),('325','2013-05-02','18:05:00',1.35),('325','2013-05-02','18:10:00',1.25),('325','2013-05-02','18:15:00',1.16),('325','2013-05-02','18:20:00',1.05),('325','2013-05-01','08:25:00',1.05),('325','2013-05-01','08:30:00',1.11),('325','2013-05-01','08:35:00',1.16),('325','2013-05-01','08:40:00',1.21),('325','2013-05-01','08:45:00',1.26),('325','2013-05-01','08:50:00',1.31),('325','2013-05-01','08:55:00',1.39),('325','2013-05-01','09:00:00',1.47),('325','2013-05-01','09:05:00',1.51),('325','2013-05-01','09:10:00',1.61),('325','2013-05-01','09:15:00',1.71),('325','2013-05-01','09:20:00',1.84),('325','2013-05-01','09:25:00',2.02),('325','2013-05-01','09:30:00',2.15),('325','2013-05-01','09:35:00',2.33),('325','2013-05-01','09:40:00',2.46),('325','2013-05-01','09:45:00',2.56),('325','2013-05-01','09:50:00',2.69),('325','2013-05-01','09:55:00',2.76),('325','2013-05-01','10:00:00',2.81),('325','2013-05-01','10:05:00',2.83),('325','2013-05-01','10:10:00',2.96),('325','2013-05-01','10:15:00',3.05),('325','2013-05-01','10:20:00',3.09),('325','2013-05-01','10:25:00',3.15),('325','2013-05-01','10:30:00',3.17),('325','2013-05-01','10:35:00',3.23),('325','2013-05-01','10:40:00',3.39),('325','2013-05-01','10:45:00',3.52),('325','2013-05-01','10:50:00',3.62),('325','2013-05-01','10:55:00',3.7),('325','2013-05-01','11:00:00',3.75),('325','2013-05-01','11:05:00',3.74),('325','2013-05-01','11:10:00',3.79),('325','2013-05-01','11:15:00',3.49),('325','2013-05-01','11:20:00',3.67),('325','2013-05-01','11:25:00',3.61),('325','2013-05-01','11:30:00',3.56),('325','2013-05-01','11:35:00',3.63),('325','2013-05-01','11:40:00',2.8),('325','2013-05-01','11:45:00',2.78),('325','2013-05-01','11:50:00',3.75),('325','2013-05-01','11:55:00',4.28),('325','2013-05-01','12:00:00',4.21),('325','2013-05-01','12:05:00',4.15),('325','2013-05-01','12:10:00',4.17),('325','2013-05-01','12:15:00',4.14),('325','2013-05-01','12:20:00',4.15),('325','2013-05-01','12:25:00',4.18),('325','2013-05-01','12:30:00',4.3),('325','2013-05-01','12:35:00',4.36),('325','2013-05-01','12:40:00',4.48),('325','2013-05-01','12:45:00',4.09),('325','2013-05-01','12:50:00',2.51),('325','2013-05-01','12:55:00',1.67),('325','2013-05-01','13:00:00',1.74),('325','2013-05-01','13:05:00',2.11),('325','2013-05-01','13:10:00',2.45),('325','2013-05-01','13:15:00',4.52),('325','2013-05-01','13:20:00',4.94),('325','2013-05-01','13:25:00',4.46),('325','2013-05-01','13:30:00',3.91),('325','2013-05-01','13:35:00',4.5),('325','2013-05-01','13:40:00',4.8),('325','2013-05-01','13:45:00',4.64),('325','2013-05-01','13:50:00',4.44),('325','2013-05-01','13:55:00',4.31),('325','2013-05-01','14:00:00',4.17),('325','2013-05-01','14:05:00',4.13),('325','2013-05-01','14:10:00',4.07),('325','2013-05-01','14:15:00',3.63),('325','2013-05-01','14:20:00',4.26),('325','2013-05-01','14:25:00',4.27),('325','2013-05-01','14:30:00',4.28),('325','2013-05-01','14:35:00',4.07),('325','2013-05-01','14:40:00',3.85),('325','2013-05-01','14:45:00',3.82),('325','2013-05-01','14:50:00',3.54),('325','2013-05-01','14:55:00',3.17),('325','2013-05-01','15:00:00',3.36),('325','2013-05-01','15:05:00',3.83),('325','2013-05-01','15:10:00',3.84),('325','2013-05-01','15:15:00',3.68),('325','2013-05-01','15:20:00',3.68),('325','2013-05-01','15:25:00',3.59),('325','2013-05-01','15:30:00',2.93),('325','2013-05-01','15:35:00',2.62),('325','2013-05-01','15:40:00',2.62),('325','2013-05-01','15:45:00',2.54),('325','2013-05-01','15:50:00',1.87),('325','2013-05-01','15:55:00',1.89),('325','2013-05-01','16:00:00',2.25),('325','2013-05-01','16:05:00',2.08),('325','2013-05-01','16:10:00',1.89),('325','2013-05-01','16:15:00',1.75),('325','2013-05-01','16:20:00',1.51),('325','2013-05-01','16:25:00',1.21),('325','2013-05-01','16:30:00',1.13),('325','2013-05-01','16:35:00',1.21),('325','2013-05-01','16:40:00',1.28),('325','2013-05-01','16:45:00',1.17),('325','2013-05-01','16:50:00',1.02),('325','2014-03-29','07:50:00',1.05),('325','2014-03-29','07:55:00',1.1),('325','2014-03-29','08:00:00',1.17),('325','2014-03-29','08:05:00',1.23),('325','2014-03-29','08:10:00',1.29),('325','2014-03-29','08:15:00',1.34),('325','2014-03-29','08:20:00',1.38),('325','2014-03-29','08:25:00',1.44),('325','2014-03-29','08:30:00',1.48),('325','2014-03-29','08:35:00',1.52),('325','2014-03-29','08:40:00',1.57),('325','2014-03-29','08:45:00',1.62),('325','2014-03-29','08:50:00',1.67),('325','2014-03-29','08:55:00',1.71),('325','2014-03-29','09:00:00',1.75),('325','2014-03-29','09:05:00',1.79),('325','2014-03-29','09:10:00',1.84),('325','2014-03-29','09:15:00',1.9),('325','2014-03-29','09:20:00',1.95),('325','2014-03-29','09:25:00',2.43),('325','2014-03-29','09:30:00',3.21),('325','2014-03-29','09:35:00',3.29),('325','2014-03-29','09:40:00',3.38),('325','2014-03-29','09:45:00',3.43),('325','2014-03-29','09:50:00',3.53),('325','2014-03-29','09:55:00',3.62),('325','2014-03-29','10:00:00',3.69),('325','2014-03-29','10:05:00',3.78),('325','2014-03-29','10:10:00',3.84),('325','2014-03-29','10:15:00',3.93),('325','2014-03-29','10:20:00',3.94),('325','2014-03-29','10:25:00',4),('325','2014-03-29','10:30:00',4.03),('325','2014-03-29','10:35:00',4.03),('325','2014-03-29','10:40:00',4.07),('325','2014-03-29','10:45:00',4.08),('325','2014-03-29','10:50:00',4.17),('325','2014-03-29','10:55:00',4.2),('325','2014-03-29','11:00:00',4.26),('325','2014-03-29','11:05:00',4.28),('325','2014-03-29','11:10:00',4.29),('325','2014-03-29','11:15:00',4.33),('325','2014-03-29','11:20:00',4.34),('325','2014-03-29','11:25:00',4.38),('325','2014-03-29','11:30:00',4.38),('325','2014-03-29','11:35:00',4.36),('325','2014-03-29','11:40:00',4.24),('325','2014-03-29','11:45:00',4.46),('325','2014-03-29','11:50:00',4.46),('325','2014-03-29','11:55:00',4.44),('325','2014-03-29','12:00:00',4.45),('325','2014-03-29','12:05:00',4.46),('325','2014-03-29','12:10:00',4.44),('325','2014-03-29','12:15:00',4.42),('325','2014-03-29','12:20:00',4.45),('325','2014-03-29','12:25:00',4.46),('325','2014-03-29','12:30:00',4.45),('325','2014-03-29','12:35:00',4.42),('325','2014-03-29','12:40:00',4.4),('325','2014-03-29','12:45:00',4.41),('325','2014-03-29','12:50:00',4.42),('325','2014-03-29','12:55:00',4.35),('325','2014-03-29','13:00:00',4.3),('325','2014-03-29','13:05:00',4.34),('325','2014-03-29','13:10:00',4.27),('325','2014-03-29','13:15:00',4.27),('325','2014-03-29','13:20:00',4.27),('325','2014-03-29','13:25:00',4.19),('325','2014-03-29','13:30:00',4.17),('325','2014-03-29','13:35:00',4.1),('325','2014-03-29','13:40:00',4.06),('325','2014-03-29','13:45:00',4.01),('325','2014-03-29','13:50:00',3.93),('325','2014-03-29','13:55:00',3.91),('325','2014-03-29','14:00:00',3.89),('325','2014-03-29','14:05:00',3.84),('325','2014-03-29','14:10:00',3.83),('325','2014-03-29','14:15:00',3.77),('325','2014-03-29','14:20:00',3.72),('325','2014-03-29','14:25:00',3.62),('325','2014-03-29','14:30:00',3.57),('325','2014-03-29','14:35:00',3.27),('325','2014-03-29','14:40:00',2.2),('325','2014-03-29','14:45:00',3.44),('325','2014-03-29','14:50:00',3.4),('325','2014-03-29','14:55:00',3.34),('325','2014-03-29','15:00:00',3.31),('325','2014-03-29','15:05:00',3.18),('325','2014-03-29','15:10:00',3.1),('325','2014-03-29','15:15:00',3.04),('325','2014-03-29','15:20:00',2.97),('325','2014-03-29','15:25:00',2.83),('325','2014-03-29','15:30:00',2.69),('325','2014-03-29','15:35:00',2.6),('325','2014-03-29','15:40:00',2.52),('325','2014-03-29','15:45:00',2.44),('325','2014-03-29','15:50:00',2.37),('325','2014-03-29','15:55:00',2.27),('325','2014-03-29','16:00:00',2.2),('325','2014-03-29','16:05:00',2.1),('325','2014-03-29','16:10:00',1.97),('325','2014-03-29','16:15:00',1.89),('325','2014-03-29','16:20:00',1.7),('325','2014-03-29','16:25:00',1.66),('325','2014-03-29','16:30:00',1.59),('325','2014-03-29','16:35:00',1.42),('325','2014-03-29','16:40:00',1.24),('325','2014-03-29','16:50:00',1.08),('325','2014-03-29','16:55:00',1.1),('325','2014-03-29','17:00:00',1.01),('325','2013-04-30','08:50:00',1.16),('325','2013-04-30','08:55:00',1.55),('325','2013-04-30','09:00:00',1.46),('325','2013-04-30','09:05:00',1.34),('325','2013-04-30','09:10:00',1.71),('325','2013-04-30','09:15:00',2.02),('325','2013-04-30','09:20:00',2.3),('325','2013-04-30','09:25:00',2.53),('325','2013-04-30','09:30:00',2.5),('325','2013-04-30','09:35:00',2.16),('325','2013-04-30','09:40:00',1.47),('325','2013-04-30','09:45:00',2.2),('325','2013-04-30','09:50:00',2.62),('325','2013-04-30','09:55:00',2.98),('325','2013-04-30','10:00:00',3.41),('325','2013-04-30','10:05:00',2.99),('325','2013-04-30','10:10:00',3.04),('325','2013-04-30','10:15:00',2.15),('325','2013-04-30','10:20:00',2.19),('325','2013-04-30','10:25:00',3.54),('325','2013-04-30','10:30:00',2.64),('325','2013-04-30','10:35:00',1.89),('325','2013-04-30','10:40:00',1.7),('325','2013-04-30','10:45:00',1.38),('325','2013-04-30','10:50:00',1.5),('325','2013-04-30','10:55:00',1.6),('325','2013-04-30','11:00:00',1.71),('325','2013-04-30','11:05:00',1.95),('325','2013-04-30','11:10:00',1.91),('325','2013-04-30','11:15:00',2.06),('325','2013-04-30','11:20:00',2.4),('325','2013-04-30','11:25:00',2.09),('325','2013-04-30','11:30:00',2.17),('325','2013-04-30','11:35:00',2.36),('325','2013-04-30','11:40:00',2.04),('325','2013-04-30','11:45:00',1.7),('325','2013-04-30','11:50:00',1.73),('325','2013-04-30','11:55:00',1.79),('325','2013-04-30','12:00:00',1.83),('325','2013-04-30','12:05:00',1.89),('325','2013-04-30','12:10:00',1.76),('325','2013-04-30','12:15:00',1.61),('325','2013-04-30','12:20:00',1.49),('325','2013-04-30','12:25:00',1.4),('325','2013-04-30','12:30:00',1.5),('325','2013-04-30','12:35:00',3.08),('325','2013-04-30','12:40:00',4.79),('325','2013-04-30','12:45:00',4.85),('325','2013-04-30','12:50:00',4.72),('325','2013-04-30','12:55:00',4.22),('325','2013-04-30','13:00:00',4.5),('325','2013-04-30','13:05:00',4.41),('325','2013-04-30','13:10:00',4.39),('325','2013-04-30','13:15:00',4.3),('325','2013-04-30','13:20:00',4.24),('325','2013-04-30','13:25:00',4.23),('325','2013-04-30','13:30:00',4.26),('325','2013-04-30','13:35:00',4.24),('325','2013-04-30','13:40:00',4.21),('325','2013-04-30','13:45:00',4.16),('325','2013-04-30','13:50:00',4.16),('325','2013-04-30','13:55:00',4.12),('325','2013-04-30','14:00:00',4.07),('325','2013-04-30','14:05:00',4.03),('325','2013-04-30','14:10:00',3.98),('325','2013-04-30','14:15:00',3.93),('325','2013-04-30','14:20:00',3.88),('325','2013-04-30','14:25:00',3.88),('325','2013-04-30','14:30:00',3.86),('325','2013-04-30','14:35:00',3.84),('325','2013-04-30','14:40:00',3.82),('325','2013-04-30','14:45:00',3.8),('325','2013-04-30','14:50:00',3.76),('325','2013-04-30','14:55:00',3.71),('325','2013-04-30','15:00:00',3.67),('325','2013-04-30','15:05:00',3.63),('325','2013-04-30','15:10:00',3.6),('325','2013-04-30','15:15:00',3.59),('325','2013-04-30','15:20:00',3.55),('325','2013-04-30','15:25:00',3.48),('325','2013-04-30','15:30:00',3.48),('325','2013-04-30','15:35:00',3.45),('325','2013-04-30','15:40:00',3.39),('325','2013-04-30','15:45:00',3.34),('325','2013-04-30','15:50:00',3.28),('325','2013-04-30','15:55:00',3.21),('325','2013-04-30','16:00:00',3.14),('325','2013-04-30','16:05:00',3.07),('325','2013-04-30','16:10:00',3.01),('325','2013-04-30','16:15:00',2.94),('325','2013-04-30','16:20:00',2.89),('325','2013-04-30','16:25:00',2.82),('325','2013-04-30','16:30:00',2.73),('325','2013-04-30','16:35:00',2.59),('325','2013-04-30','16:40:00',2.12),('325','2013-04-30','16:45:00',2.31),('325','2013-04-30','16:50:00',2.11),('325','2013-04-30','16:55:00',2.12),('325','2013-04-30','17:00:00',2.13),('325','2013-04-30','17:05:00',1.99),('325','2013-04-30','17:10:00',1.72),('325','2013-04-30','17:20:00',1.61),('325','2013-04-30','17:25:00',1.72),('325','2013-04-30','17:30:00',1.65),('325','2013-04-30','17:35:00',1.57),('325','2013-04-30','17:40:00',1.48),('325','2013-04-30','17:45:00',1.42),('325','2013-04-30','17:50:00',1.33),('325','2013-04-30','17:55:00',1.25),('325','2013-04-30','18:00:00',1.17),('325','2013-04-30','18:05:00',1.08),('325','2013-04-30','18:10:00',1.01),('325','2013-04-29','08:20:00',1.07),('325','2013-04-29','08:25:00',1.22),('325','2013-04-29','08:30:00',1.37),('325','2013-04-29','08:35:00',1.49),('325','2013-04-29','08:40:00',1.46),('325','2013-04-29','08:45:00',1.48),('325','2013-04-29','08:50:00',1.54),('325','2013-04-29','08:55:00',1.52),('325','2013-04-29','09:00:00',1.37),('325','2013-04-29','09:05:00',1.74),('325','2013-04-29','09:10:00',1.89),('325','2013-04-29','09:15:00',2.04),('325','2013-04-29','09:20:00',2.06),('325','2013-04-29','09:25:00',2.13),('325','2013-04-29','09:30:00',2.31),('325','2013-04-29','09:35:00',2.52),('325','2013-04-29','09:40:00',2.56),('325','2013-04-29','09:45:00',2.62),('325','2013-04-29','09:50:00',2.77),('325','2013-04-29','09:55:00',2.69),('325','2013-04-29','10:00:00',2.81),('325','2013-04-29','10:05:00',2.81),('325','2013-04-29','10:10:00',2.71),('325','2013-04-29','10:15:00',2.25),('325','2013-04-29','10:20:00',2.41),('325','2013-04-29','10:25:00',2.82),('325','2013-04-29','10:30:00',3),('325','2013-04-29','10:35:00',3.28),('325','2013-04-29','10:40:00',3.31),('325','2013-04-29','10:45:00',3.33),('325','2013-04-29','10:50:00',3.32),('325','2013-04-29','10:55:00',3.16),('325','2013-04-29','11:00:00',3.56),('325','2013-04-29','11:05:00',3.33),('325','2013-04-29','11:10:00',3.21),('325','2013-04-29','11:15:00',3.11),('325','2013-04-29','11:20:00',3.67),('325','2013-04-29','11:25:00',3.72),('325','2013-04-29','11:30:00',3.84),('325','2013-04-29','11:35:00',3.78),('325','2013-04-29','11:40:00',3.95),('325','2013-04-29','11:45:00',3.72),('325','2013-04-29','11:50:00',4.27),('325','2013-04-29','11:55:00',4.15),('325','2013-04-29','12:00:00',4.33),('325','2013-04-29','12:05:00',4.23),('325','2013-04-29','12:10:00',4.16),('325','2013-04-29','12:15:00',4.2),('325','2013-04-29','12:20:00',4.15),('325','2013-04-29','12:25:00',4.07),('325','2013-04-29','12:30:00',4.23),('325','2013-04-29','12:35:00',4.29),('325','2013-04-29','12:40:00',4.34),('325','2013-04-29','12:45:00',4.37),('325','2013-04-29','12:50:00',4.32),('325','2013-04-29','12:55:00',4.32),('325','2013-04-29','13:00:00',4.41),('325','2013-04-29','13:05:00',4.33),('325','2013-04-29','13:10:00',4.21),('325','2013-04-29','13:15:00',3.75),('325','2013-04-29','13:20:00',4.28),('325','2013-04-29','13:25:00',4.45),('325','2013-04-29','13:30:00',4.31),('325','2013-04-29','13:35:00',4.23),('325','2013-04-29','13:40:00',4.32),('325','2013-04-29','13:45:00',4.27),('325','2013-04-29','13:50:00',4.22),('325','2013-04-29','13:55:00',4.63),('325','2013-04-29','14:00:00',4.2),('325','2013-04-29','14:05:00',4.17),('325','2013-04-29','14:10:00',4.21),('325','2013-04-29','14:15:00',4.3),('325','2013-04-29','14:20:00',4.31),('325','2013-04-29','14:25:00',4.04),('325','2013-04-29','14:30:00',3.91),('325','2013-04-29','14:35:00',3.91),('325','2013-04-29','14:40:00',3.66),('325','2013-04-29','14:45:00',3.89),('325','2013-04-29','14:50:00',3.93),('325','2013-04-29','14:55:00',3.96),('325','2013-04-29','15:00:00',3.8),('325','2013-04-29','15:05:00',3.84),('325','2013-04-29','15:10:00',3.38),('325','2013-04-29','15:15:00',3.57),('325','2013-04-29','15:20:00',3.81),('325','2013-04-29','15:25:00',3.9),('325','2013-04-29','15:30:00',3.76),('325','2013-04-29','15:35:00',3.32),('325','2013-04-29','15:40:00',3.06),('325','2013-04-29','15:45:00',3),('325','2013-04-29','15:50:00',3.12),('325','2013-04-29','15:55:00',3.24),('325','2013-04-29','16:00:00',3.18),('325','2013-04-29','16:05:00',3.42),('325','2013-04-29','16:10:00',3.28),('325','2013-04-29','16:15:00',3.82),('325','2013-04-29','16:20:00',3.47),('325','2013-04-29','16:25:00',2.81),('325','2013-04-29','16:30:00',2.88),('325','2013-04-29','16:35:00',2.94),('325','2013-04-29','16:40:00',3.03),('325','2013-04-29','16:45:00',2.99),('325','2013-04-29','16:50:00',3.07),('325','2013-04-29','16:55:00',3.07),('325','2013-04-29','17:00:00',2.85),('325','2013-04-29','17:05:00',2.52),('325','2013-04-29','17:10:00',2.57),('325','2013-04-29','17:15:00',2.15),('325','2013-04-29','17:20:00',1.77),('325','2013-04-29','17:25:00',1.7),('325','2013-04-29','17:30:00',1.67),('325','2013-04-29','17:35:00',1.54),('325','2013-04-29','17:40:00',1.29),('325','2013-04-29','17:45:00',1.17),('325','2013-04-29','17:50:00',1.47),('325','2013-04-29','17:55:00',1.63),('325','2013-04-29','18:00:00',1.57),('325','2013-04-29','18:05:00',1.75),('325','2013-04-29','18:10:00',1.53),('325','2013-04-29','18:15:00',1.43),('325','2013-04-29','18:20:00',1.18),('325','2013-04-29','18:25:00',1.15),('325','2013-04-29','18:30:00',1.02),('325','2013-04-28','08:30:00',1.01),('325','2013-04-28','08:35:00',1.06),('325','2013-04-28','08:40:00',1.1),('325','2013-04-28','08:45:00',1.13),('325','2013-04-28','08:50:00',1.18),('325','2013-04-28','08:55:00',1.24),('325','2013-04-28','09:00:00',1.49),('325','2013-04-28','09:05:00',2.02),('325','2013-04-28','09:10:00',2.11),('325','2013-04-28','09:15:00',2.24),('325','2013-04-28','09:20:00',2.33),('325','2013-04-28','09:25:00',2.38),('325','2013-04-28','09:30:00',2.48),('325','2013-04-28','09:35:00',2.66),('325','2013-04-28','09:40:00',2.8),('325','2013-04-28','09:45:00',2.97),('325','2013-04-28','09:50:00',3.09),('325','2013-04-28','09:55:00',3.14),('325','2013-04-28','10:00:00',3.21),('325','2013-04-28','10:05:00',3.26),('325','2013-04-28','10:10:00',3.33),('325','2013-04-28','10:15:00',3.39),('325','2013-04-28','10:20:00',3.48),('325','2013-04-28','10:25:00',3.58),('325','2013-04-28','10:30:00',3.47),('325','2013-04-28','10:35:00',3.66),('325','2013-04-28','10:40:00',3.41),('325','2013-04-28','10:45:00',3.84),('325','2013-04-28','10:50:00',3.87),('325','2013-04-28','10:55:00',3.91),('325','2013-04-28','11:00:00',3.95),('325','2013-04-28','11:05:00',3.99),('325','2013-04-28','11:10:00',4.03),('325','2013-04-28','11:15:00',4.08),('325','2013-04-28','11:20:00',4.06),('325','2013-04-28','11:25:00',4.12),('325','2013-04-28','11:30:00',4.13),('325','2013-04-28','11:35:00',4.09),('325','2013-04-28','11:40:00',4.16),('325','2013-04-28','11:45:00',4.04),('325','2013-04-28','11:50:00',4.06),('325','2013-04-28','11:55:00',4.26),('325','2013-04-28','12:00:00',3.76),('325','2013-04-28','12:05:00',3.7),('325','2013-04-28','12:10:00',4.08),('325','2013-04-28','12:15:00',4.16),('325','2013-04-28','12:20:00',4.14),('325','2013-04-28','12:25:00',3.75),('325','2013-04-28','12:30:00',3.65),('325','2013-04-28','12:35:00',3.48),('325','2013-04-28','12:40:00',3.37),('325','2013-04-28','12:45:00',4.37),('325','2013-04-28','12:50:00',4.41),('325','2013-04-28','12:55:00',4.2),('325','2013-04-28','13:00:00',4.26),('325','2013-04-28','13:05:00',4.53),('325','2013-04-28','13:10:00',4.44),('325','2013-04-28','13:15:00',4.13),('325','2013-04-28','13:20:00',4.24),('325','2013-04-28','13:25:00',4.02),('325','2013-04-28','13:30:00',4.09),('325','2013-04-28','13:35:00',3.85),('325','2013-04-28','13:40:00',3.05),('325','2013-04-28','13:45:00',2.14),('325','2013-04-28','13:50:00',1.61),('325','2013-04-28','13:55:00',2.48),('325','2013-04-28','14:00:00',2.86),('325','2013-04-28','14:05:00',3.02),('325','2013-04-28','14:10:00',4.41),('325','2013-04-28','14:15:00',4.37),('325','2013-04-28','14:20:00',3.66),('325','2013-04-28','14:25:00',3.76),('325','2013-04-28','14:30:00',4.13),('325','2013-04-28','14:35:00',4.25),('325','2013-04-28','14:40:00',4.21),('325','2013-04-28','14:45:00',4.15),('325','2013-04-28','14:50:00',4.1),('325','2013-04-28','14:55:00',4.04),('325','2013-04-28','15:00:00',4.01),('325','2013-04-28','15:05:00',4.01),('325','2013-04-28','15:10:00',3.97),('325','2013-04-28','15:15:00',3.88),('325','2013-04-28','15:20:00',3.83),('325','2013-04-28','15:25:00',3.78),('325','2013-04-28','15:30:00',3.74),('325','2013-04-28','15:35:00',3.69),('325','2013-04-28','15:40:00',3.63),('325','2013-04-28','15:45:00',3.61),('325','2013-04-28','15:50:00',3.58),('325','2013-04-28','15:55:00',3.5),('325','2013-04-28','16:00:00',3.45),('325','2013-04-28','16:05:00',3.39),('325','2013-04-28','16:10:00',3.33),('325','2013-04-28','16:15:00',3.25),('325','2013-04-28','16:20:00',3.16),('325','2013-04-28','16:25:00',3.09),('325','2013-04-28','16:30:00',3.02),('325','2013-04-28','16:35:00',2.94),('325','2013-04-28','16:40:00',2.86),('325','2013-04-28','16:45:00',2.77),('325','2013-04-28','16:50:00',2.66),('325','2013-04-28','16:55:00',2.5),('325','2013-04-28','17:00:00',2.49),('325','2013-04-28','17:05:00',2.3),('325','2013-04-28','17:10:00',2.22),('325','2013-04-28','17:15:00',2.27),('325','2013-04-28','17:20:00',2.14),('325','2013-04-28','17:25:00',2.09),('325','2013-04-28','17:30:00',1.76),('325','2013-04-28','17:35:00',1.71),('325','2013-04-28','17:40:00',1.64),('325','2013-04-28','17:45:00',1.66),('325','2013-04-28','17:50:00',1.56),('325','2013-04-28','17:55:00',1.36),('325','2013-04-28','18:00:00',1.35),('325','2013-04-28','18:05:00',1.25),('325','2013-04-28','18:20:00',1.04),('325','2013-04-27','12:50:00',1.09),('325','2013-04-27','12:55:00',1.4),('325','2013-04-27','13:00:00',1.42),('325','2013-04-27','13:05:00',1.04),('325','2013-04-27','13:10:00',1.2),('325','2013-04-27','13:15:00',1.57),('325','2013-04-27','13:20:00',1.61),('325','2013-04-27','13:25:00',1.13),('325','2013-04-27','13:30:00',1.32),('325','2013-04-27','13:35:00',1.64),('325','2013-04-27','13:40:00',1.75),('325','2013-04-27','13:45:00',1.21),('325','2013-04-27','13:50:00',1.16),('325','2013-04-27','14:25:00',1.41),('325','2013-04-27','14:30:00',2.34),('325','2013-04-27','14:35:00',1.87),('325','2013-04-27','14:40:00',1.33),('325','2013-04-27','14:45:00',1.1),('325','2013-04-27','15:00:00',1.18),('325','2013-04-27','15:05:00',1.84),('325','2013-04-27','15:10:00',1.38),('325','2013-04-27','16:40:00',1.12),('325','2013-04-27','16:45:00',1.54),('325','2013-04-27','16:50:00',2.41),('325','2013-04-27','16:55:00',2.2),('325','2013-04-27','17:00:00',2.62),('325','2013-04-27','17:05:00',1.69),('325','2013-04-27','17:20:00',1.25),('325','2013-04-27','17:40:00',1.28),('325','2013-04-27','17:45:00',1.01),('325','2013-04-26','08:25:00',1.02),('325','2013-04-26','08:30:00',1.08),('325','2013-04-26','08:35:00',1.14),('325','2013-04-26','08:40:00',1.22),('325','2013-04-26','08:45:00',1.3),('325','2013-04-26','08:50:00',1.2),('325','2013-04-26','08:55:00',1.18),('325','2013-04-26','09:00:00',1.27),('325','2013-04-26','09:05:00',1.57),('325','2013-04-26','09:10:00',1.47),('325','2013-04-26','09:15:00',1.16),('325','2013-04-26','09:20:00',1.19),('325','2013-04-26','09:25:00',1.75),('325','2013-04-26','09:30:00',1.9),('325','2013-04-26','09:35:00',1.73),('325','2013-04-26','09:40:00',1.82),('325','2013-04-26','09:45:00',2.12),('325','2013-04-26','09:50:00',2.55),('325','2013-04-26','09:55:00',1.63),('325','2013-04-26','10:00:00',2.83),('325','2013-04-26','10:05:00',3.16),('325','2013-04-26','10:10:00',3.15),('325','2013-04-26','10:15:00',3.25),('325','2013-04-26','10:20:00',3.14),('325','2013-04-26','10:25:00',3.16),('325','2013-04-26','10:30:00',3.3),('325','2013-04-26','10:35:00',3.61),('325','2013-04-26','10:40:00',3.72),('325','2013-04-26','10:45:00',3.5),('325','2013-04-26','10:50:00',2.62),('325','2013-04-26','10:55:00',2),('325','2013-04-26','11:00:00',3.58),('325','2013-04-26','11:05:00',3.63),('325','2013-04-26','11:10:00',3.66),('325','2013-04-26','11:15:00',3.09),('325','2013-04-26','11:20:00',2.68),('325','2013-04-26','11:25:00',3.34),('325','2013-04-26','11:30:00',3.38),('325','2013-04-26','11:35:00',3.98),('325','2013-04-26','11:40:00',3.18),('325','2013-04-26','11:45:00',3.54),('325','2013-04-26','11:50:00',2.77),('325','2013-04-26','11:55:00',2.69),('325','2013-04-26','12:00:00',3.36),('325','2013-04-26','12:05:00',2.97),('325','2013-04-26','12:10:00',2.6),('325','2013-04-26','12:15:00',2.79),('325','2013-04-26','12:20:00',3.11),('325','2013-04-26','12:25:00',1.82),('325','2013-04-26','12:30:00',1.86),('325','2013-04-26','12:35:00',2.6),('325','2013-04-26','12:40:00',3.15),('325','2013-04-26','12:45:00',3.08),('325','2013-04-26','12:50:00',2.25),('325','2013-04-26','12:55:00',2.01),('325','2013-04-26','13:00:00',1.39),('325','2013-04-26','13:05:00',1.38),('325','2013-04-26','13:10:00',1.78),('325','2013-04-26','13:15:00',3.07),('325','2013-04-26','13:20:00',1.94),('325','2013-04-26','13:25:00',2.32),('325','2013-04-26','13:30:00',3.68),('325','2013-04-26','13:35:00',2.61),('325','2013-04-26','13:40:00',2.9),('325','2013-04-26','13:45:00',2.68),('325','2013-04-26','13:50:00',3.47),('325','2013-04-26','13:55:00',3.78),('325','2013-04-26','14:00:00',3.42),('325','2013-04-26','14:05:00',3.89),('325','2013-04-26','14:10:00',3.3),('325','2013-04-26','14:15:00',3.67),('325','2013-04-26','14:20:00',3.67),('325','2013-04-26','14:25:00',4.34),('325','2013-04-26','14:30:00',4.24),('325','2013-04-26','14:35:00',2.76),('325','2013-04-26','14:40:00',1.92),('325','2013-04-26','14:45:00',1.67),('325','2013-04-26','14:50:00',4.19),('325','2013-04-26','14:55:00',4.41),('325','2013-04-26','15:00:00',3.96),('325','2013-04-26','15:05:00',2.48),('325','2013-04-26','15:10:00',1.92),('325','2013-04-26','15:15:00',2.29),('325','2013-04-26','15:20:00',1.57),('325','2013-04-26','15:25:00',1.79),('325','2013-04-26','15:30:00',2.64),('325','2013-04-26','15:35:00',1.99),('325','2013-04-26','15:40:00',2.33),('325','2013-04-26','15:45:00',2.71),('325','2013-04-26','15:50:00',2.11),('325','2013-04-26','15:55:00',1.08),('325','2013-04-25','08:15:00',1.07),('325','2013-04-25','08:40:00',1.07),('325','2013-04-25','08:45:00',1.34),('325','2013-04-25','08:50:00',1.69),('325','2013-04-25','08:55:00',1.73),('325','2013-04-25','09:00:00',1.5),('325','2013-04-25','09:05:00',1.26),('325','2013-04-25','09:10:00',1.25),('325','2013-04-25','09:15:00',1.16),('325','2013-04-25','09:20:00',1.21),('325','2013-04-25','09:25:00',1.29),('325','2013-04-25','09:30:00',1.35),('325','2013-04-25','09:35:00',1.58),('325','2013-04-25','09:40:00',2.18),('325','2013-04-25','09:45:00',2.73),('325','2013-04-25','09:50:00',3.11),('325','2013-04-25','09:55:00',3.13),('325','2013-04-25','10:00:00',3.12),('325','2013-04-25','10:05:00',2.86),('325','2013-04-25','10:10:00',2.57),('325','2013-04-25','10:15:00',2.83),('325','2013-04-25','10:20:00',3.06),('325','2013-04-25','10:25:00',3.44),('325','2013-04-25','10:30:00',3.57),('325','2013-04-25','10:35:00',3.62),('325','2013-04-25','10:40:00',3.65),('325','2013-04-25','10:45:00',3.59),('325','2013-04-25','10:50:00',3.73),('325','2013-04-25','10:55:00',3.81),('325','2013-04-25','11:00:00',3.91),('325','2013-04-25','11:05:00',3.95),('325','2013-04-25','11:10:00',4),('325','2013-04-25','11:15:00',4.02),('325','2013-04-25','11:20:00',4.06),('325','2013-04-25','11:25:00',4.11),('325','2013-04-25','11:30:00',4.14),('325','2013-04-25','11:35:00',4.09),('325','2013-04-25','11:40:00',4.23),('325','2013-04-25','11:45:00',4.29),('325','2013-04-25','11:50:00',4.37),('325','2013-04-25','11:55:00',4.36),('325','2013-04-25','12:00:00',4.27),('325','2013-04-25','12:05:00',4.29),('325','2013-04-25','12:10:00',4.37),('325','2013-04-25','12:15:00',4.39),('325','2013-04-25','12:20:00',4.39),('325','2013-04-25','12:25:00',4.38),('325','2013-04-25','12:30:00',4.4),('325','2013-04-25','12:35:00',4.42),('325','2013-04-25','12:40:00',4.43),('325','2013-04-25','12:45:00',4.46),('325','2013-04-25','12:50:00',4.45),('325','2013-04-25','12:55:00',4.46),('325','2013-04-25','13:00:00',4.49),('325','2013-04-25','13:05:00',4.52),('325','2013-04-25','13:10:00',4.41),('325','2013-04-25','13:15:00',4.42),('325','2013-04-25','13:20:00',3.98),('325','2013-04-25','13:25:00',3.64),('325','2013-04-25','13:30:00',2.83),('325','2013-04-25','13:35:00',2.74),('325','2013-04-25','13:40:00',2.48),('325','2013-04-25','13:45:00',2.29),('325','2013-04-25','13:50:00',2.22),('325','2013-04-25','13:55:00',2.44),('325','2013-04-25','14:00:00',2.5),('325','2013-04-25','14:05:00',2.27),('325','2013-04-25','14:10:00',2.5),('325','2013-04-25','14:15:00',2.67),('325','2013-04-25','14:20:00',2.72),('325','2013-04-25','14:25:00',2.76),('325','2013-04-25','14:30:00',3.37),('325','2013-04-25','14:35:00',3.83),('325','2013-04-25','14:40:00',3.62),('325','2013-04-25','14:45:00',3.72),('325','2013-04-25','14:50:00',3.43),('325','2013-04-25','14:55:00',3.55),('325','2013-04-25','15:00:00',3.39),('325','2013-04-25','15:05:00',3.08),('325','2013-04-25','15:10:00',3.14),('325','2013-04-25','15:15:00',3.54),('325','2013-04-25','15:20:00',3.78),('325','2013-04-25','15:25:00',3.8),('325','2013-04-25','15:30:00',3.72),('325','2013-04-25','15:35:00',3.55),('325','2013-04-25','15:40:00',3.25),('325','2013-04-25','15:45:00',3.21),('325','2013-04-25','15:50:00',2.97),('325','2013-04-25','15:55:00',2.91),('325','2013-04-25','16:00:00',2.87),('325','2013-04-25','16:05:00',2.46),('325','2013-04-25','16:10:00',2.47),('325','2013-04-25','16:15:00',2.42),('325','2013-04-25','16:20:00',2.57),('325','2013-04-25','16:25:00',2.23),('325','2013-04-25','16:30:00',2.18),('325','2013-04-25','16:35:00',2.62),('325','2013-04-25','16:40:00',2.29),('325','2013-04-25','16:45:00',2.36),('325','2013-04-25','16:50:00',1.97),('325','2013-04-25','16:55:00',2.02),('325','2013-04-25','17:00:00',1.98),('325','2013-04-25','17:05:00',2.31),('325','2013-04-25','17:10:00',2.38),('325','2013-04-25','17:15:00',2.28),('325','2013-04-25','17:20:00',2.28),('325','2013-04-25','17:25:00',1.87),('325','2013-04-25','17:30:00',1.54),('325','2013-04-25','17:35:00',1.46),('325','2013-04-25','17:40:00',1.44),('325','2013-04-25','17:45:00',1.23),('325','2013-04-25','17:50:00',1.02),('325','2013-04-24','08:25:00',1.04),('325','2013-04-24','08:30:00',1.04),('325','2013-04-24','08:35:00',1.04),('325','2013-04-24','08:40:00',1.08),('325','2013-04-24','08:45:00',1.13),('325','2013-04-24','08:50:00',1.17),('325','2013-04-24','08:55:00',1.25),('325','2013-04-24','09:00:00',1.39),('325','2013-04-24','09:05:00',1.95),('325','2013-04-24','09:10:00',2.27),('325','2013-04-24','09:15:00',1.87),('325','2013-04-24','09:20:00',1.77),('325','2013-04-24','09:25:00',2.45),('325','2013-04-24','09:30:00',2.28),('325','2013-04-24','09:35:00',2.68),('325','2013-04-24','09:40:00',2.58),('325','2013-04-24','09:45:00',2.6),('325','2013-04-24','09:50:00',2.73),('325','2013-04-24','09:55:00',3.03),('325','2013-04-24','10:00:00',3.13),('325','2013-04-24','10:05:00',3.19),('325','2013-04-24','10:10:00',3.44),('325','2013-04-24','10:15:00',3.42),('325','2013-04-24','10:20:00',3.37),('325','2013-04-24','10:25:00',3.36),('325','2013-04-24','10:30:00',3.33),('325','2013-04-24','10:35:00',3.36),('325','2013-04-24','10:40:00',3.79),('325','2013-04-24','10:45:00',3.83),('325','2013-04-24','10:50:00',3.93),('325','2013-04-24','10:55:00',4.04),('325','2013-04-24','11:00:00',4.02),('325','2013-04-24','11:05:00',3.97),('325','2013-04-24','11:10:00',4.28),('325','2013-04-24','11:15:00',4.32),('325','2013-04-24','11:20:00',4.44),('325','2013-04-24','11:25:00',4.3),('325','2013-04-24','11:30:00',4.29),('325','2013-04-24','11:35:00',3.83),('325','2013-04-24','11:40:00',3.2),('325','2013-04-24','11:45:00',2.85),('325','2013-04-24','11:50:00',2.19),('325','2013-04-24','11:55:00',3.4),('325','2013-04-24','12:00:00',3.71),('325','2013-04-24','12:05:00',2.62),('325','2013-04-24','12:10:00',3.22),('325','2013-04-24','12:15:00',4.3),('325','2013-04-24','12:20:00',4.98),('325','2013-04-24','12:25:00',4.2),('325','2013-04-24','12:30:00',4.2),('325','2013-04-24','12:35:00',4.34),('325','2013-04-24','12:40:00',4.1),('325','2013-04-24','12:45:00',4.3),('325','2013-04-24','12:50:00',4.52),('325','2013-04-24','12:55:00',4.35),('325','2013-04-24','13:00:00',4.23),('325','2013-04-24','13:05:00',3.76),('325','2013-04-24','13:10:00',4.84),('325','2013-04-24','13:15:00',4.43),('325','2013-04-24','13:20:00',4.18),('325','2013-04-24','13:25:00',4.38),('325','2013-04-24','13:30:00',3.98),('325','2013-04-24','13:35:00',4.27),('325','2013-04-24','13:40:00',4.77),('325','2013-04-24','13:45:00',3.86),('325','2013-04-24','13:50:00',3.13),('325','2013-04-24','13:55:00',4.58),('325','2013-04-24','14:00:00',4.34),('325','2013-04-24','14:05:00',3.13),('325','2013-04-24','14:10:00',3.33),('325','2013-04-24','14:15:00',4.42),('325','2013-04-24','14:20:00',4.04),('325','2013-04-24','14:25:00',4.12),('325','2013-04-24','14:30:00',3.85),('325','2013-04-24','14:35:00',3.51),('325','2013-04-24','14:40:00',3.32),('325','2013-04-24','14:45:00',3.28),('325','2013-04-24','14:50:00',2.93),('325','2013-04-24','14:55:00',2.58),('325','2013-04-24','15:00:00',2.82),('325','2013-04-24','15:05:00',2.6),('325','2013-04-24','15:10:00',2.37),('325','2013-04-24','15:15:00',2.52),('325','2013-04-24','15:20:00',2.74),('325','2013-04-24','15:25:00',2.19),('325','2013-04-24','15:30:00',1.9),('325','2013-04-24','15:35:00',1.85),('325','2013-04-24','15:40:00',1.83),('325','2013-04-24','15:45:00',1.84),('325','2013-04-24','15:50:00',1.89),('325','2013-04-24','15:55:00',2.5),('325','2013-04-24','16:00:00',2.97),('325','2013-04-24','16:05:00',3.12),('325','2013-04-24','16:10:00',3),('325','2013-04-24','16:15:00',2.89),('325','2013-04-24','16:20:00',3.63),('325','2013-04-24','16:25:00',2.73),('325','2013-04-24','16:30:00',2.3),('325','2013-04-24','16:35:00',2.11),('325','2013-04-24','16:40:00',2.77),('325','2013-04-24','16:45:00',2.78),('325','2013-04-24','16:50:00',2.55),('325','2013-04-24','16:55:00',2.95),('325','2013-04-24','17:00:00',2.86),('325','2013-04-24','17:05:00',2.69),('325','2013-04-24','17:10:00',2.63),('325','2013-04-24','17:15:00',1.84),('325','2013-04-24','17:20:00',1.95),('325','2013-04-24','17:25:00',1.62),('325','2013-04-24','17:30:00',1.08),('325','2013-04-24','17:50:00',1.18),('325','2013-04-24','17:55:00',1.52),('325','2013-04-24','18:00:00',1.15),('325','2013-04-24','18:05:00',1.25),('325','2013-04-23','09:00:00',1.86),('325','2013-04-23','09:05:00',2.03),('325','2013-04-23','09:10:00',2.32),('325','2013-04-23','09:15:00',2.41),('325','2013-04-23','09:20:00',2.53),('325','2013-04-23','09:25:00',2.64),('325','2013-04-23','09:30:00',2.69),('325','2013-04-23','09:35:00',2.71),('325','2013-04-23','09:40:00',2.56),('325','2013-04-23','09:45:00',2.83),('325','2013-04-23','09:50:00',3.27),('325','2013-04-23','09:55:00',3.34),('325','2013-04-23','10:00:00',3.29),('325','2013-04-23','10:05:00',3.39),('325','2013-04-23','10:10:00',3.51),('325','2013-04-23','10:15:00',3.56),('325','2013-04-23','10:20:00',3.59),('325','2013-04-23','10:25:00',3.68),('325','2013-04-23','10:30:00',3.74),('325','2013-04-23','10:35:00',3.85),('325','2013-04-23','10:40:00',3.9),('325','2013-04-23','10:45:00',3.89),('325','2013-04-23','10:50:00',4.05),('325','2013-04-23','10:55:00',4.11),('325','2013-04-23','11:00:00',4.16),('325','2013-04-23','11:05:00',4.16),('325','2013-04-23','11:10:00',4.22),('325','2013-04-23','11:15:00',4.24),('325','2013-04-23','11:20:00',4.28),('325','2013-04-23','11:25:00',4.31),('325','2013-04-23','11:30:00',4.33),('325','2013-04-23','11:35:00',4.35),('325','2013-04-23','11:40:00',4.44),('325','2013-04-23','11:45:00',4.48),('325','2013-04-23','11:50:00',4.51),('325','2013-04-23','11:55:00',4.5),('325','2013-04-23','12:00:00',4.52),('325','2013-04-23','12:05:00',4.52),('325','2013-04-23','12:10:00',4.53),('325','2013-04-23','12:15:00',4.53),('325','2013-04-23','12:20:00',4.55),('325','2013-04-23','12:25:00',4.63),('325','2013-04-23','12:30:00',4.8),('325','2013-04-23','12:35:00',5.03),('325','2013-04-23','12:40:00',5.11),('325','2013-04-23','12:45:00',4.29),('325','2013-04-23','12:50:00',3.08),('325','2013-04-23','12:55:00',3.26),('325','2013-04-23','13:00:00',4.57),('325','2013-04-23','13:05:00',4.57),('325','2013-04-23','13:10:00',3.81),('325','2013-04-23','13:15:00',4.4),('325','2013-04-23','13:20:00',4.14),('325','2013-04-23','13:25:00',3.74),('325','2013-04-23','13:30:00',4.83),('325','2013-04-23','13:35:00',4.9),('325','2013-04-23','13:40:00',4.84),('325','2013-04-23','13:45:00',3.53),('325','2013-04-23','13:50:00',4.46),('325','2013-04-23','13:55:00',4.82),('325','2013-04-23','14:00:00',4.39),('325','2013-04-23','14:05:00',4.89),('325','2013-04-23','14:10:00',4.4),('325','2013-04-23','14:15:00',4.31),('325','2013-04-23','14:20:00',4.2),('325','2013-04-23','14:25:00',3.9),('325','2013-04-23','14:30:00',4.54),('325','2013-04-23','14:35:00',4.27),('325','2013-04-23','14:40:00',4.43),('325','2013-04-23','14:45:00',3.84),('325','2013-04-23','14:50:00',2.38),('325','2013-04-23','14:55:00',2.52),('325','2013-04-23','15:00:00',2.66),('325','2013-04-23','15:05:00',2.82),('325','2013-04-23','15:10:00',3.4),('325','2013-04-23','15:15:00',3.31),('325','2013-04-23','15:20:00',3.08),('325','2013-04-23','15:25:00',2.75),('325','2013-04-23','15:30:00',2.74),('325','2013-04-23','15:35:00',2.59),('325','2013-04-23','15:40:00',2.4),('325','2013-04-23','15:45:00',3.01),('325','2013-04-23','15:50:00',2.13),('325','2013-04-23','15:55:00',2.21),('325','2013-04-23','16:00:00',2.53),('325','2013-04-23','16:05:00',2.9),('325','2013-04-23','16:10:00',2.88),('325','2013-04-23','16:15:00',2.36),('325','2013-04-23','16:20:00',1.58),('325','2013-04-23','16:25:00',1.5),('325','2013-04-23','16:30:00',1.25),('325','2013-04-23','16:35:00',1.18),('325','2013-04-23','16:40:00',1.16),('325','2013-04-23','16:45:00',1.23),('325','2013-04-23','16:50:00',1.09),('325','2013-04-23','16:55:00',1.14),('325','2013-04-23','17:00:00',1.21),('325','2013-04-23','17:05:00',1.26),('325','2013-04-23','17:10:00',1.56),('325','2013-04-23','17:15:00',1.4),('325','2013-04-23','17:20:00',1.03),('325','2013-04-23','17:25:00',1.89),('325','2013-04-23','17:30:00',1.55),('325','2013-04-23','17:35:00',1.12),('325','2014-03-28','07:50:00',1.01),('325','2014-03-28','07:55:00',1.06),('325','2014-03-28','08:00:00',1.1),('325','2014-03-28','08:05:00',1.17),('325','2014-03-28','08:10:00',1.23),('325','2014-03-28','08:15:00',1.28),('325','2014-03-28','08:20:00',1.34),('325','2014-03-28','08:25:00',1.38),('325','2014-03-28','08:30:00',1.43),('325','2014-03-28','08:35:00',1.49),('325','2014-03-28','08:40:00',1.54),('325','2014-03-28','08:45:00',1.58),('325','2014-03-28','08:50:00',1.64),('325','2014-03-28','08:55:00',1.7),('325','2014-03-28','09:00:00',1.76),('325','2014-03-28','09:05:00',1.87),('325','2014-03-28','09:10:00',2),('325','2014-03-28','09:15:00',2.02),('325','2014-03-28','09:20:00',2.03),('325','2014-03-28','09:25:00',2.51),('325','2014-03-28','09:30:00',3.65),('325','2014-03-28','09:35:00',3.28),('325','2014-03-28','09:40:00',1.92),('325','2014-03-28','09:45:00',2.04),('325','2014-03-28','09:50:00',2.71),('325','2014-03-28','09:55:00',4.01),('325','2014-03-28','10:00:00',3.81),('325','2014-03-28','10:05:00',3.96),('325','2014-03-28','10:10:00',3.75),('325','2014-03-28','10:15:00',2.83),('325','2014-03-28','10:20:00',2.79),('325','2014-03-28','10:25:00',3.86),('325','2014-03-28','10:30:00',3.91),('325','2014-03-28','10:35:00',4.01),('325','2014-03-28','10:40:00',3.81),('325','2014-03-28','10:45:00',3.34),('325','2014-03-28','10:50:00',3.7),('325','2014-03-28','10:55:00',4.39),('325','2014-03-28','11:00:00',4.38),('325','2014-03-28','11:05:00',4.14),('325','2014-03-28','11:10:00',2.83),('325','2014-03-28','11:15:00',2.17),('325','2014-03-28','11:20:00',3.21),('325','2014-03-28','11:25:00',2.8),('325','2014-03-28','11:30:00',2.79),('325','2014-03-28','11:35:00',3.23),('325','2014-03-28','11:40:00',1.57),('325','2014-03-28','11:45:00',3.58),('325','2014-03-28','11:50:00',1.67),('325','2014-03-28','11:55:00',1.43),('325','2014-03-28','12:00:00',1.17),('325','2014-03-28','12:05:00',4.84),('325','2014-03-28','12:10:00',4.99),('325','2014-03-28','12:15:00',5.16),('325','2014-03-28','12:20:00',5.17),('325','2014-03-28','12:25:00',1.06),('325','2014-03-28','12:30:00',1.19),('325','2014-03-28','12:35:00',4.46),('325','2014-03-28','12:40:00',4.69),('325','2014-03-28','12:45:00',4.79),('325','2014-03-28','12:50:00',3.59),('325','2014-03-28','12:55:00',1.68),('325','2014-03-28','13:00:00',4.74),('325','2014-03-28','13:05:00',3.18),('325','2014-03-28','13:10:00',1.81),('325','2014-03-28','13:15:00',2.19),('325','2014-03-28','13:20:00',1.96),('325','2014-03-28','13:25:00',1.57),('325','2014-03-28','13:30:00',1.69),('325','2014-03-28','13:35:00',4.78),('325','2014-03-28','13:40:00',4.4),('325','2014-03-28','13:45:00',4.5),('325','2014-03-28','13:50:00',4.27),('325','2014-03-28','13:55:00',4.25),('325','2014-03-28','14:00:00',4.21),('325','2014-03-28','14:05:00',4.13),('325','2014-03-28','14:10:00',4.09),('325','2014-03-28','14:15:00',4.05),('325','2014-03-28','14:20:00',3.99),('325','2014-03-28','14:25:00',3.95),('325','2014-03-28','14:30:00',3.88),('325','2014-03-28','14:35:00',3.83),('325','2014-03-28','14:40:00',3.78),('325','2014-03-28','14:45:00',3.71),('325','2014-03-28','14:50:00',3.65),('325','2014-03-28','14:55:00',3.59),('325','2014-03-28','15:00:00',3.54),('325','2014-03-28','15:05:00',3.45),('325','2014-03-28','15:10:00',3.35),('325','2014-03-28','15:15:00',3.28),('325','2014-03-28','15:20:00',3.19),('325','2014-03-28','15:25:00',3.1),('325','2014-03-28','15:30:00',3.03),('325','2014-03-28','15:35:00',2.94),('325','2014-03-28','15:40:00',2.79),('325','2014-03-28','15:45:00',2.78),('325','2014-03-28','15:50:00',2.76),('325','2014-03-28','15:55:00',2.63),('325','2014-03-28','16:00:00',2.67),('325','2014-03-28','16:05:00',2.7),('325','2014-03-28','16:10:00',2.62),('325','2014-03-28','16:15:00',2.5),('325','2014-03-28','16:20:00',2.16),('325','2014-03-28','16:25:00',1.91),('325','2014-03-28','16:30:00',1.81),('325','2014-03-28','16:45:00',1.27),('325','2014-03-28','16:50:00',1.36),('325','2014-03-28','17:00:00',1.09),('325','2014-03-27','07:55:00',1.1),('325','2014-03-27','08:00:00',1.38),('325','2014-03-27','08:05:00',1.44),('325','2014-03-27','09:15:00',1.01),('325','2014-03-27','10:05:00',1.21),('325','2014-03-27','10:10:00',1.28),('325','2014-03-27','10:15:00',1.3),('325','2014-03-27','10:20:00',1.79),('325','2014-03-27','10:25:00',2.58),('325','2014-03-27','10:30:00',2.22),('325','2014-03-27','10:35:00',1.91),('325','2014-03-27','10:40:00',1.99),('325','2014-03-27','10:45:00',1.05),('325','2014-03-27','11:10:00',2.38),('325','2014-03-27','11:15:00',1.91),('325','2014-03-27','11:20:00',1.01),('325','2014-03-27','11:50:00',1.25),('325','2014-03-27','11:55:00',1.44),('325','2014-03-27','12:00:00',1.1),('325','2014-03-27','12:05:00',1.04),('325','2014-03-27','12:10:00',1.14),('325','2014-03-27','12:20:00',1.05),('325','2014-03-27','13:00:00',1.06),('325','2014-03-27','13:05:00',1.33),('325','2014-03-27','13:10:00',1.82),('325','2014-03-27','13:15:00',2.4),('325','2014-03-27','13:20:00',2.52),('325','2014-03-27','13:25:00',2.52),('325','2014-03-27','13:30:00',2.14),('325','2014-03-27','13:35:00',1.94),('325','2014-03-27','13:40:00',1.84),('325','2014-03-27','13:45:00',1.69),('325','2014-03-27','13:50:00',2.48),('325','2014-03-27','13:55:00',3.1),('325','2014-03-27','14:00:00',2.31),('325','2014-03-27','14:05:00',1),('325','2014-03-27','14:15:00',3.25),('325','2014-03-27','14:20:00',4),('325','2014-03-27','14:25:00',4.6),('325','2014-03-27','14:30:00',3.91),('325','2014-03-27','14:35:00',2.31),('325','2014-03-27','14:40:00',2.04),('325','2014-03-27','14:45:00',1.81),('325','2014-03-27','14:50:00',2.07),('325','2014-03-27','14:55:00',1.83),('325','2014-03-27','15:00:00',4.02),('325','2014-03-27','15:05:00',1.16),('325','2014-03-27','15:20:00',1.07),('325','2014-03-27','15:25:00',2.87),('325','2014-03-27','15:30:00',4.02),('325','2014-03-27','15:35:00',3.37),('325','2014-03-27','15:40:00',1.4),('325','2014-03-27','16:05:00',1.06),('325','2014-03-27','16:10:00',1.23),('325','2014-03-27','16:15:00',1.03),('325','2014-03-27','16:25:00',1.23),('325','2014-03-27','16:30:00',1.37),('325','2014-03-27','16:55:00',1.01),('325','2014-05-01','08:25:00',1),('325','2014-05-01','08:30:00',1.05),('325','2014-05-01','08:35:00',1.1),('325','2014-05-01','08:40:00',1.15),('325','2014-05-01','08:45:00',1.21),('325','2014-05-01','08:50:00',1.45),('325','2014-05-01','08:55:00',1.76),('325','2014-05-01','09:00:00',1.26),('325','2014-05-01','09:10:00',1.85),('325','2014-05-01','09:15:00',1.7),('325','2014-05-01','09:20:00',1.62),('325','2014-05-01','09:25:00',2.6),('325','2014-05-01','09:30:00',2.64),('325','2014-05-01','09:35:00',2.99),('325','2014-05-01','09:40:00',3.26),('325','2014-05-01','09:45:00',2.67),('325','2014-05-01','09:50:00',2.47),('325','2014-05-01','09:55:00',2.25),('325','2014-05-01','10:00:00',1.54),('325','2014-05-01','10:05:00',1.71),('325','2014-05-01','10:10:00',2.23),('325','2014-05-01','10:15:00',3.03),('325','2014-05-01','10:20:00',1.53),('325','2014-05-01','10:25:00',1.35),('325','2014-05-01','10:30:00',3.83),('325','2014-05-01','10:35:00',3.01),('325','2014-05-01','10:40:00',1.65),('325','2014-05-01','10:45:00',4.12),('325','2014-05-01','10:50:00',4.21),('325','2014-05-01','10:55:00',3.84),('325','2014-05-01','11:00:00',2.32),('325','2014-05-01','11:05:00',4.7),('325','2014-05-01','11:10:00',2.92),('325','2014-05-01','11:20:00',3.76),('325','2014-05-01','11:25:00',4.69),('325','2014-05-01','11:30:00',4.8),('325','2014-05-01','11:35:00',4.63),('325','2014-05-01','11:40:00',4.56),('325','2014-05-01','11:45:00',4.91),('325','2014-05-01','11:50:00',5.03),('325','2014-05-01','11:55:00',1.57),('325','2014-05-01','12:00:00',1.68),('325','2014-05-01','12:05:00',5.4),('325','2014-05-01','12:10:00',3.04),('325','2014-05-01','12:15:00',4.67),('325','2014-05-01','12:20:00',5.06),('325','2014-05-01','12:25:00',5.08),('325','2014-05-01','12:30:00',3.79),('325','2014-05-01','12:35:00',5.13),('325','2014-05-01','12:40:00',4.13),('325','2014-05-01','12:45:00',2.08),('325','2014-05-01','12:50:00',4.73),('325','2014-05-01','12:55:00',5.38),('325','2014-05-01','13:00:00',5.32),('325','2014-05-01','13:05:00',5.12),('325','2014-05-01','13:10:00',3.43),('325','2014-05-01','13:15:00',4.45),('325','2014-05-01','13:20:00',4.42),('325','2014-05-01','13:25:00',1.71),('325','2014-05-01','13:30:00',2.13),('325','2014-05-01','13:35:00',2.19),('325','2014-05-01','13:40:00',5.36),('325','2014-05-01','13:45:00',5.32),('325','2014-05-01','13:50:00',4.67),('325','2014-05-01','13:55:00',2.83),('325','2014-05-01','14:00:00',2.7),('325','2014-05-01','14:05:00',5.13),('325','2014-05-01','14:10:00',4.92),('325','2014-05-01','14:15:00',4.81),('325','2014-05-01','14:20:00',4.71),('325','2014-05-01','14:25:00',4.7),('325','2014-05-01','14:30:00',4.49),('325','2014-05-01','14:35:00',4.46),('325','2014-05-01','14:40:00',4.78),('325','2014-05-01','14:45:00',4.79),('325','2014-05-01','14:50:00',4.74),('325','2014-05-01','14:55:00',4.6),('325','2014-05-01','15:00:00',4.42),('325','2014-05-01','15:05:00',4.69),('325','2014-05-01','15:10:00',4.26),('325','2014-05-01','15:15:00',4.36),('325','2014-05-01','15:20:00',4.28),('325','2014-05-01','15:25:00',4.23),('325','2014-05-01','15:30:00',4.13),('325','2014-05-01','15:35:00',4.06),('325','2014-05-01','15:40:00',3.95),('325','2014-05-01','15:45:00',3.77),('325','2014-05-01','15:50:00',3.89),('325','2014-05-01','15:55:00',3.71),('325','2014-05-01','16:00:00',3.72),('325','2014-05-01','16:05:00',3.66),('325','2014-05-01','16:10:00',3.49),('325','2014-05-01','16:15:00',3.46),('325','2014-05-01','16:20:00',3.29),('325','2014-05-01','16:25:00',3),('325','2014-05-01','16:30:00',3.13),('325','2014-05-01','16:35:00',3.19),('325','2014-05-01','16:40:00',2.98),('325','2014-05-01','16:45:00',2.45),('325','2014-05-01','16:50:00',2.26),('325','2014-05-01','16:55:00',2.53),('325','2014-05-01','17:00:00',2.52),('325','2014-05-01','17:05:00',2.39),('325','2014-05-01','17:10:00',2.57),('325','2014-05-01','17:15:00',2.42),('325','2014-05-01','17:20:00',2.33),('325','2014-05-01','17:25:00',2.22),('325','2014-05-01','17:30:00',2.12),('325','2014-05-01','17:35:00',2),('325','2014-05-01','17:40:00',1.9),('325','2014-05-01','17:45:00',1.81),('325','2014-05-01','17:50:00',1.72),('325','2014-05-01','17:55:00',1.64),('325','2014-05-01','18:00:00',1.6),('325','2014-05-01','18:05:00',1.46),('325','2014-05-01','18:10:00',1.31),('325','2014-05-01','18:15:00',1.23),('325','2014-05-01','18:20:00',1.11),('325','2014-05-01','18:25:00',1.02),('325','2014-03-26','07:55:00',1.04),('325','2014-03-26','08:00:00',1.1),('325','2014-03-26','08:05:00',1.18),('325','2014-03-26','08:10:00',1.27),('325','2014-03-26','08:15:00',1.48),('325','2014-03-26','08:20:00',1.6),('325','2014-03-26','08:25:00',1.24),('325','2014-03-26','08:30:00',1.02),('325','2014-03-26','08:40:00',1.07),('325','2014-03-26','08:45:00',1.16),('325','2014-03-26','08:50:00',1.34),('325','2014-03-26','08:55:00',1.2),('325','2014-03-26','09:00:00',1.34),('325','2014-03-26','09:05:00',1.28),('325','2014-03-26','09:10:00',1.51),('325','2014-03-26','09:15:00',1.23),('325','2014-03-26','09:25:00',1.48),('325','2014-03-26','09:30:00',3.01),('325','2014-03-26','09:35:00',3.45),('325','2014-03-26','09:40:00',3.5),('325','2014-03-26','09:45:00',3.54),('325','2014-03-26','09:50:00',3.62),('325','2014-03-26','09:55:00',3.68),('325','2014-03-26','10:00:00',3.58),('325','2014-03-26','10:05:00',2.73),('325','2014-03-26','10:10:00',2.7),('325','2014-03-26','10:15:00',4.27),('325','2014-03-26','10:20:00',2.76),('325','2014-03-26','10:25:00',4.07),('325','2014-03-26','10:30:00',4.14),('325','2014-03-26','10:35:00',1.22),('325','2014-03-26','10:45:00',1.16),('325','2014-03-26','10:50:00',2.34),('325','2014-03-26','10:55:00',5.38),('325','2014-03-26','11:00:00',2.85),('325','2014-03-26','11:05:00',1.2),('325','2014-03-26','11:10:00',1.97),('325','2014-03-26','11:15:00',5.2),('325','2014-03-26','11:20:00',2.14),('325','2014-03-26','11:25:00',1.29),('325','2014-03-26','11:30:00',1.82),('325','2014-03-26','11:35:00',1.79),('325','2014-03-26','11:40:00',2.14),('325','2014-03-26','11:45:00',5.33),('325','2014-03-26','11:50:00',5.17),('325','2014-03-26','11:55:00',5.36),('325','2014-03-26','12:00:00',4.78),('325','2014-03-26','12:05:00',5.13),('325','2014-03-26','12:10:00',4.47),('325','2014-03-26','12:15:00',1.78),('325','2014-03-26','12:20:00',1.95),('325','2014-03-26','12:25:00',1.74),('325','2014-03-26','12:30:00',1.74),('325','2014-03-26','12:35:00',1.61),('325','2014-03-26','12:40:00',2.32),('325','2014-03-26','12:45:00',2.25),('325','2014-03-26','12:50:00',1.6),('325','2014-03-26','12:55:00',1.22),('325','2014-03-26','13:00:00',1.37),('325','2014-03-26','13:05:00',1.72),('325','2014-03-26','13:10:00',1.11),('325','2014-03-26','13:20:00',4.41),('325','2014-03-26','13:25:00',4.92),('325','2014-03-26','13:30:00',2.84),('325','2014-03-26','13:35:00',2.74),('325','2014-03-26','13:40:00',1.28),('325','2014-03-26','13:45:00',1.07),('325','2014-03-26','13:50:00',1.14),('325','2014-03-26','13:55:00',1.53),('325','2014-03-26','14:00:00',3.15),('325','2014-03-26','14:05:00',5.06),('325','2014-03-26','14:10:00',2.56),('325','2014-03-26','14:15:00',1.11),('325','2014-03-26','14:20:00',1.02),('325','2014-03-26','14:40:00',1.18),('325','2014-03-26','14:45:00',2.71),('325','2014-03-26','14:50:00',3.58),('325','2014-03-26','14:55:00',3.82),('325','2014-03-26','15:00:00',3.49),('325','2014-03-26','15:05:00',3.37),('325','2014-03-26','15:10:00',3.48),('325','2014-03-26','15:15:00',3.59),('325','2014-03-26','15:20:00',3.5),('325','2014-03-26','15:25:00',3.49),('325','2014-03-26','15:30:00',3.45),('325','2014-03-26','15:35:00',3.24),('325','2014-03-26','15:40:00',2.67),('325','2014-03-26','15:45:00',2.67),('325','2014-03-26','15:50:00',1.78),('325','2014-03-26','15:55:00',1.59),('325','2014-03-26','16:00:00',1.44),('325','2014-03-26','16:05:00',1.38),('325','2014-03-26','16:10:00',1.58),('325','2014-03-26','16:15:00',1.68),('325','2014-03-26','16:20:00',1.16),('325','2014-03-25','07:25:00',1.08),('325','2014-03-25','07:30:00',1.14),('325','2014-03-25','07:45:00',1.04),('325','2014-03-25','07:50:00',1.13),('325','2014-03-25','07:55:00',1.15),('325','2014-03-25','08:00:00',1.13),('325','2014-03-25','08:05:00',1.17),('325','2014-03-25','08:10:00',1.26),('325','2014-03-25','08:15:00',1.32),('325','2014-03-25','08:20:00',1.24),('325','2014-03-25','08:25:00',1.15),('325','2014-03-25','08:30:00',1.06),('325','2014-03-25','08:35:00',1.1),('325','2014-03-25','08:40:00',1.29),('325','2014-03-25','08:45:00',1.64),('325','2014-03-25','08:50:00',1.71),('325','2014-03-25','08:55:00',1.78),('325','2014-03-25','09:00:00',1.65),('325','2014-03-25','09:05:00',1.66),('325','2014-03-25','09:10:00',1.63),('325','2014-03-25','09:15:00',2.01),('325','2014-03-25','09:20:00',2.22),('325','2014-03-25','09:25:00',2.02),('325','2014-03-25','09:30:00',1.89),('325','2014-03-25','09:35:00',1.8),('325','2014-03-25','09:40:00',1.81),('325','2014-03-25','09:45:00',1.72),('325','2014-03-25','09:50:00',1.8),('325','2014-03-25','09:55:00',2.05),('325','2014-03-25','10:00:00',2.48),('325','2014-03-25','10:05:00',2.71),('325','2014-03-25','10:10:00',2.86),('325','2014-03-25','10:15:00',3.08),('325','2014-03-25','10:20:00',3.06),('325','2014-03-25','10:25:00',3.06),('325','2014-03-25','10:30:00',3.24),('325','2014-03-25','10:35:00',2.64),('325','2014-03-25','10:40:00',2.16),('325','2014-03-25','10:45:00',2),('325','2014-03-25','10:50:00',1.94),('325','2014-03-25','10:55:00',1.95),('325','2014-03-25','11:00:00',2.12),('325','2014-03-25','11:05:00',2.41),('325','2014-03-25','11:10:00',2.69),('325','2014-03-25','11:15:00',3),('325','2014-03-25','11:20:00',3.03),('325','2014-03-25','11:25:00',2.92),('325','2014-03-25','11:30:00',2.85),('325','2014-03-25','11:35:00',2.5),('325','2014-03-25','11:40:00',2.77),('325','2014-03-25','11:45:00',2.11),('325','2014-03-25','11:50:00',2.52),('325','2014-03-25','11:55:00',1.62),('325','2014-03-25','12:00:00',1.08),('325','2014-03-25','12:20:00',1.18),('325','2014-03-25','12:25:00',1.23),('325','2014-03-24','07:45:00',1.13),('325','2014-03-24','08:55:00',1.49),('325','2014-03-24','09:00:00',1.53),('325','2014-03-24','09:20:00',1.14),('325','2014-03-24','09:30:00',1.22),('325','2014-03-24','09:40:00',1.55),('325','2014-03-24','09:45:00',1.02),('325','2014-03-24','10:00:00',2.67),('325','2014-03-24','10:05:00',3.01),('325','2014-03-24','10:10:00',3.8),('325','2014-03-24','10:15:00',2.4),('325','2014-03-24','10:35:00',1.52),('325','2014-03-24','10:40:00',1.06),('325','2014-03-24','10:45:00',2.18),('325','2014-03-24','10:50:00',5.09),('325','2014-03-24','10:55:00',3.84),('325','2014-03-24','11:00:00',2.19),('325','2014-03-24','11:05:00',2.54),('325','2014-03-24','11:10:00',3.28),('325','2014-03-24','11:15:00',3.81),('325','2014-03-24','11:20:00',3.29),('325','2014-03-24','11:25:00',3.57),('325','2014-03-24','11:30:00',3.97),('325','2014-03-24','11:35:00',1.4),('325','2014-03-24','12:30:00',1.21),('325','2014-03-24','12:35:00',2.02),('325','2014-03-24','12:40:00',2.09),('325','2014-03-24','12:45:00',1.75),('325','2014-03-24','12:50:00',1.42),('325','2014-03-24','12:55:00',1.38),('325','2014-03-24','13:00:00',1.41),('325','2014-03-24','13:05:00',1.38),('325','2014-03-24','13:10:00',1.18),('325','2014-03-24','13:15:00',1.03),('325','2014-03-24','13:20:00',1.07),('325','2014-03-24','13:25:00',1.28),('325','2014-03-24','13:30:00',1.47),('325','2014-03-24','13:35:00',1.15),('325','2014-03-24','13:45:00',1.2),('325','2014-03-24','13:50:00',1.34),('325','2014-03-24','13:55:00',1.31),('325','2014-03-24','14:00:00',1.13),('325','2014-03-24','14:05:00',1.06),('325','2014-03-24','14:10:00',1.33),('325','2014-03-24','14:15:00',1.8),('325','2014-03-24','14:20:00',2.28),('325','2014-03-24','14:25:00',2.14),('325','2014-03-24','14:30:00',2.06),('325','2014-03-24','14:35:00',2.6),('325','2014-03-24','14:40:00',3.31),('325','2014-03-24','14:45:00',3.73),('325','2014-03-24','14:50:00',3.76),('325','2014-03-24','14:55:00',3.29),('325','2014-03-24','15:00:00',2.75),('325','2014-03-24','15:05:00',2.6),('325','2014-03-24','15:10:00',2.22),('325','2014-03-24','15:15:00',1.63),('325','2014-03-24','15:20:00',1.83),('325','2014-03-24','15:25:00',1.76),('325','2014-03-24','15:30:00',1.81),('325','2014-03-24','15:35:00',1.66),('325','2014-03-24','15:40:00',1.34),('325','2014-03-24','15:45:00',1.23),('325','2014-03-24','15:50:00',1.4),('325','2014-03-24','15:55:00',1.81),('325','2014-03-24','16:00:00',2.71),('325','2014-03-24','16:05:00',1.45),('325','2014-03-24','16:10:00',1.14),('325','2014-03-23','08:50:00',1.14),('325','2014-03-23','08:55:00',1.33),('325','2014-03-23','09:05:00',1.55),('325','2014-03-23','09:10:00',2.2),('325','2014-03-23','09:15:00',2.19),('325','2014-03-23','09:20:00',1.64),('325','2014-03-23','09:25:00',1.09),('325','2014-03-23','09:30:00',1.47),('325','2014-03-23','09:35:00',1.52),('325','2014-03-23','09:40:00',1.3),('325','2014-03-23','10:25:00',1.25),('325','2014-03-23','10:40:00',1.28),('325','2014-03-23','10:45:00',1.16),('325','2014-03-23','10:50:00',1.36),('325','2014-03-23','10:55:00',1.74),('325','2014-03-23','11:00:00',1.26),('325','2014-03-23','11:05:00',1.1),('325','2014-03-23','11:10:00',1.38),('325','2014-03-23','11:25:00',1.01),('325','2014-03-23','11:35:00',2.01),('325','2014-03-23','11:40:00',3.31),('325','2014-03-23','13:40:00',1.15),('325','2014-03-23','13:45:00',2.5),('325','2014-03-23','13:50:00',1.59),('325','2014-03-23','13:55:00',1.24),('325','2014-03-23','15:05:00',1.05),('325','2014-03-23','15:10:00',1.29),('325','2014-03-23','15:15:00',1.82),('325','2014-03-23','15:20:00',1.76),('325','2014-03-23','15:25:00',1.59),('325','2014-03-23','15:30:00',1.39),('325','2014-03-22','07:40:00',1.12),('325','2014-03-22','07:45:00',1.07),('325','2014-03-22','08:15:00',1.09),('325','2014-03-22','08:20:00',1.27),('325','2014-03-22','08:25:00',1.32),('325','2014-03-22','08:30:00',1.22),('325','2014-03-22','08:40:00',1.75),('325','2014-03-22','08:45:00',1.68),('325','2014-03-22','08:50:00',1.53),('325','2014-03-22','08:55:00',1.72),('325','2014-03-22','09:00:00',1.66),('325','2014-03-22','09:05:00',1.35),('325','2014-03-22','09:10:00',1.46),('325','2014-03-22','09:15:00',1.28),('325','2014-03-22','09:20:00',1.39),('325','2014-03-22','09:25:00',1.67),('325','2014-03-22','09:30:00',1.96),('325','2014-03-22','09:35:00',1.43),('325','2014-03-22','09:40:00',2.71),('325','2014-03-22','09:45:00',3.16),('325','2014-03-22','09:50:00',3.25),('325','2014-03-22','09:55:00',3.42),('325','2014-03-22','10:00:00',3.18),('325','2014-03-22','10:05:00',2.29),('325','2014-03-22','10:10:00',2.25),('325','2014-03-22','10:15:00',1.84),('325','2014-03-22','10:20:00',1.1),('325','2014-03-22','10:30:00',1.08),('325','2014-03-22','10:35:00',1.63),('325','2014-03-22','10:40:00',1.93),('325','2014-03-22','10:45:00',2.84),('325','2014-03-22','10:50:00',1.98),('325','2014-03-22','10:55:00',1.38),('325','2014-03-22','11:00:00',1.05),('325','2014-03-22','11:05:00',1.21),('325','2014-03-22','11:10:00',1.57),('325','2014-03-22','11:15:00',2.14),('325','2014-03-22','11:20:00',4.35),('325','2014-03-22','11:25:00',4.89),('325','2014-03-22','11:30:00',2.52),('325','2014-03-22','11:35:00',2.71),('325','2014-03-22','11:40:00',2.59),('325','2014-03-22','11:45:00',1.62),('325','2014-03-22','11:50:00',2.27),('325','2014-03-22','11:55:00',4.39),('325','2014-03-22','12:00:00',1.76),('325','2014-03-22','12:05:00',1.69),('325','2014-03-22','12:10:00',1.43),('325','2014-03-22','12:15:00',2.36),('325','2014-03-22','12:20:00',4.11),('325','2014-03-22','12:25:00',2.35),('325','2014-03-22','12:30:00',2.42),('325','2014-03-22','12:35:00',3.8),('325','2014-03-22','12:40:00',4.69),('325','2014-03-22','12:45:00',3.55),('325','2014-03-22','12:50:00',3.74),('325','2014-03-22','12:55:00',3.13),('325','2014-03-22','13:00:00',1.74),('325','2014-03-22','13:05:00',4.44),('325','2014-03-22','13:10:00',4.51),('325','2014-03-22','13:15:00',3.6),('325','2014-03-22','13:20:00',4.54),('325','2014-03-22','13:25:00',4),('325','2014-03-22','13:30:00',3.52),('325','2014-03-22','13:35:00',3.87),('325','2014-03-22','13:40:00',3.79),('325','2014-03-22','13:45:00',2.98),('325','2014-03-22','13:50:00',3.61),('325','2014-03-22','13:55:00',3.1),('325','2014-03-22','14:00:00',3.7),('325','2014-03-22','14:05:00',2.97),('325','2014-03-22','14:10:00',3.48),('325','2014-03-22','14:15:00',2.4),('325','2014-03-22','14:20:00',3.51),('325','2014-03-22','14:25:00',3.64),('325','2014-03-22','14:30:00',3.57),('325','2014-03-22','14:35:00',3.51),('325','2014-03-22','14:40:00',3.41),('325','2014-03-22','14:45:00',3.3),('325','2014-03-22','14:50:00',3.26),('325','2014-03-22','14:55:00',3.15),('325','2014-03-22','15:00:00',3.07),('325','2014-03-22','15:05:00',3.06),('325','2014-03-22','15:10:00',2.92),('325','2014-03-22','15:15:00',2.87),('325','2014-03-22','15:20:00',2.81),('325','2014-03-22','15:25:00',1.99),('325','2014-03-22','15:30:00',1.54),('325','2014-03-22','15:35:00',3.1),('325','2014-03-22','15:40:00',3.18),('325','2014-03-22','15:45:00',2.95),('325','2014-03-22','15:50:00',2.84),('325','2014-03-22','15:55:00',2.6),('325','2014-03-22','16:00:00',2.29),('325','2014-03-22','16:05:00',2.05),('325','2014-03-22','16:10:00',1.96),('325','2014-03-22','16:15:00',1.87),('325','2014-03-22','16:20:00',1.75),('325','2014-03-22','16:25:00',1.22),('325','2014-03-21','08:05:00',1.02),('325','2014-03-21','08:10:00',1.08),('325','2014-03-21','08:15:00',1.12),('325','2014-03-21','08:20:00',1.16),('325','2014-03-21','08:25:00',1.23),('325','2014-03-21','08:30:00',1.3),('325','2014-03-21','08:35:00',1.35),('325','2014-03-21','08:40:00',1.39),('325','2014-03-21','08:45:00',1.42),('325','2014-03-21','08:50:00',1.46),('325','2014-03-21','08:55:00',1.52),('325','2014-03-21','09:00:00',1.56),('325','2014-03-21','09:05:00',1.6),('325','2014-03-21','09:10:00',1.67),('325','2014-03-21','09:15:00',1.71),('325','2014-03-21','09:20:00',1.77),('325','2014-03-21','09:25:00',1.75),('325','2014-03-21','09:30:00',1.85),('325','2014-03-21','09:35:00',2.69),('325','2014-03-21','09:40:00',3.06),('325','2014-03-21','09:45:00',3.12),('325','2014-03-21','09:50:00',3.17),('325','2014-03-21','09:55:00',3.17),('325','2014-03-21','10:00:00',3.22),('325','2014-03-21','10:05:00',3.33),('325','2014-03-21','10:10:00',3.43),('325','2014-03-21','10:15:00',3.5),('325','2014-03-21','10:20:00',3.52),('325','2014-03-21','10:25:00',3.6),('325','2014-03-21','10:30:00',3.65),('325','2014-03-21','10:35:00',3.7),('325','2014-03-21','10:40:00',3.68),('325','2014-03-21','10:45:00',3.64),('325','2014-03-21','10:50:00',3.67),('325','2014-03-21','10:55:00',3.72),('325','2014-03-21','11:00:00',3.77),('325','2014-03-21','11:05:00',3.77),('325','2014-03-21','11:10:00',3.89),('325','2014-03-21','11:15:00',3.93),('325','2014-03-21','11:20:00',3.94),('325','2014-03-21','11:25:00',3.89),('325','2014-03-21','11:30:00',2.18),('325','2014-03-21','11:35:00',3.6),('325','2014-03-21','11:40:00',3.92),('325','2014-03-21','11:45:00',4.03),('325','2014-03-21','11:50:00',4.36),('325','2014-03-21','11:55:00',4.23),('325','2014-03-21','12:00:00',3.16),('325','2014-03-21','12:05:00',3.98),('325','2014-03-21','12:10:00',4.16),('325','2014-03-21','12:15:00',4.19),('325','2014-03-21','12:20:00',4.15),('325','2014-03-21','12:25:00',4.1),('325','2014-03-21','12:30:00',4.13),('325','2014-03-21','12:35:00',4.14),('325','2014-03-21','12:40:00',4.2),('325','2014-03-21','12:45:00',4.23),('325','2014-03-21','12:50:00',4.17),('325','2014-03-21','12:55:00',4.13),('325','2014-03-21','13:00:00',4.17),('325','2014-03-21','13:05:00',4.12),('325','2014-03-21','13:10:00',4.13),('325','2014-03-21','13:15:00',4.11),('325','2014-03-21','13:20:00',4.04),('325','2014-03-21','13:25:00',4.01),('325','2014-03-21','13:30:00',4.02),('325','2014-03-21','13:35:00',3.95),('325','2014-03-21','13:40:00',3.94),('325','2014-03-21','13:45:00',3.94),('325','2014-03-21','13:50:00',3.9),('325','2014-03-21','13:55:00',3.88),('325','2014-03-21','14:00:00',3.88),('325','2014-03-21','14:05:00',3.84),('325','2014-03-21','14:10:00',3.78),('325','2014-03-21','14:15:00',3.75),('325','2014-03-21','14:20:00',3.65),('325','2014-03-21','14:25:00',3.6),('325','2014-03-21','14:30:00',3.5),('325','2014-03-21','14:35:00',3.36),('325','2014-03-21','14:40:00',3.34),('325','2014-03-21','14:45:00',3.18),('325','2014-03-21','14:50:00',2.69),('325','2014-03-21','14:55:00',1.13),('325','2014-03-21','15:00:00',1.07),('325','2014-03-21','15:05:00',2.17),('325','2014-03-21','15:10:00',3.45),('325','2014-03-21','15:15:00',3.37),('325','2014-03-21','15:20:00',2.76),('325','2014-03-21','15:25:00',3.33),('325','2014-03-21','15:30:00',3.15),('325','2014-03-21','15:35:00',2.92),('325','2014-03-21','15:40:00',2.91),('325','2014-03-21','15:45:00',2.77),('325','2014-03-21','15:50:00',2.76),('325','2014-03-21','15:55:00',2.71),('325','2014-03-21','16:00:00',2.5),('325','2014-03-21','16:05:00',2.33),('325','2014-03-21','16:10:00',2.16),('325','2014-03-21','16:15:00',1.99),('325','2014-03-21','16:20:00',1.78),('325','2014-03-21','16:25:00',1.64),('325','2014-03-21','16:30:00',1.53),('325','2014-03-21','16:35:00',1.41),('325','2014-03-21','16:40:00',1.32),('325','2014-03-21','16:45:00',1.23),('325','2014-03-21','16:50:00',1.12),('325','2014-03-21','16:55:00',1.01),('325','2014-03-20','07:55:00',1),('325','2014-03-20','08:00:00',1.07),('325','2014-03-20','08:05:00',1.11),('325','2014-03-20','08:10:00',1.14),('325','2014-03-20','08:15:00',1.17),('325','2014-03-20','08:20:00',1.2),('325','2014-03-20','08:25:00',1.26),('325','2014-03-20','08:30:00',1.32),('325','2014-03-20','08:35:00',1.38),('325','2014-03-20','08:40:00',1.45),('325','2014-03-20','08:45:00',1.51),('325','2014-03-20','08:50:00',1.55),('325','2014-03-20','08:55:00',1.59),('325','2014-03-20','09:00:00',1.62),('325','2014-03-20','09:05:00',1.7),('325','2014-03-20','09:10:00',1.76),('325','2014-03-20','09:15:00',1.79),('325','2014-03-20','09:20:00',1.85),('325','2014-03-20','09:25:00',1.87),('325','2014-03-20','09:30:00',1.91),('325','2014-03-20','09:35:00',2.54),('325','2014-03-20','09:40:00',3),('325','2014-03-20','09:45:00',3.05),('325','2014-03-20','09:50:00',3.05),('325','2014-03-20','09:55:00',3.13),('325','2014-03-20','10:00:00',3.32),('325','2014-03-20','10:05:00',3.44),('325','2014-03-20','10:10:00',3.49),('325','2014-03-20','10:15:00',3.49),('325','2014-03-20','10:20:00',3.5),('325','2014-03-20','10:25:00',3.56),('325','2014-03-20','10:30:00',3.58),('325','2014-03-20','10:35:00',3.47),('325','2014-03-20','10:40:00',3.43),('325','2014-03-20','10:45:00',3.52),('325','2014-03-20','10:50:00',3.72),('325','2014-03-20','10:55:00',3.91),('325','2014-03-20','11:00:00',3.94),('325','2014-03-20','11:05:00',3.93),('325','2014-03-20','11:10:00',3.9),('325','2014-03-20','11:15:00',3.71),('325','2014-03-20','11:20:00',3.88),('325','2014-03-20','11:25:00',3.93),('325','2014-03-20','11:30:00',4.02),('325','2014-03-20','11:35:00',4.1),('325','2014-03-20','11:40:00',4.06),('325','2014-03-20','11:45:00',4.02),('325','2014-03-20','11:50:00',4.11),('325','2014-03-20','11:55:00',3.82),('325','2014-03-20','12:00:00',3.62),('325','2014-03-20','12:05:00',3.98),('325','2014-03-20','12:10:00',4.11),('325','2014-03-20','12:15:00',4.13),('325','2014-03-20','12:20:00',4.04),('325','2014-03-20','12:25:00',3.88),('325','2014-03-20','12:30:00',4.02),('325','2014-03-20','12:35:00',4.08),('325','2014-03-20','12:40:00',4.08),('325','2014-03-20','12:45:00',4.16),('325','2014-03-20','12:50:00',4.08),('325','2014-03-20','12:55:00',4.1),('325','2014-03-20','13:00:00',4.05),('325','2014-03-20','13:05:00',4.01),('325','2014-03-20','13:10:00',3.92),('325','2014-03-20','13:15:00',3.87),('325','2014-03-20','13:20:00',3.91),('325','2014-03-20','13:25:00',3.79),('325','2014-03-20','13:30:00',3.88),('325','2014-03-20','13:35:00',3.78),('325','2014-03-20','13:40:00',3.61),('325','2014-03-20','13:45:00',3.47),('325','2014-03-20','13:50:00',3.34),('325','2014-03-20','13:55:00',3.09),('325','2014-03-20','14:00:00',3.29),('325','2014-03-20','14:05:00',3.48),('325','2014-03-20','14:10:00',3.34),('325','2014-03-20','14:15:00',3.19),('325','2014-03-20','14:20:00',3.12),('325','2014-03-20','14:25:00',3.07),('325','2014-03-20','14:30:00',2.64),('325','2014-03-20','14:35:00',2.47),('325','2014-03-20','14:40:00',2.74),('325','2014-03-20','14:45:00',2.68),('325','2014-03-20','14:50:00',2.57),('325','2014-03-20','14:55:00',2.48),('325','2014-03-20','15:00:00',2.27),('325','2014-03-20','15:05:00',2.3),('325','2014-03-20','15:10:00',2.34),('325','2014-03-20','15:15:00',2.23),('325','2014-03-20','15:20:00',2.41),('325','2014-03-20','15:25:00',2.16),('325','2014-03-20','15:30:00',2.05),('325','2014-03-20','15:35:00',1.97),('325','2014-03-20','15:40:00',1.77),('325','2014-03-20','15:45:00',1.77),('325','2014-03-20','15:50:00',1.53),('325','2014-03-20','15:55:00',1.42),('325','2014-03-20','16:00:00',1.22),('325','2014-03-20','16:05:00',1.1),('325','2014-03-20','16:10:00',1.12),('325','2014-03-20','16:15:00',1.07),('325','2014-03-20','16:20:00',1.11),('325','2014-03-20','16:25:00',1.12),('325','2014-03-20','16:30:00',1.04),('325','2014-03-19','09:00:00',1.02),('325','2014-03-19','09:05:00',1.26),('325','2014-03-19','09:10:00',1.37),('325','2014-03-19','09:15:00',1.57),('325','2014-03-19','09:20:00',1.69),('325','2014-03-19','09:25:00',2.49),('325','2014-03-19','09:30:00',2.95),('325','2014-03-19','09:35:00',2.38),('325','2014-03-19','09:40:00',2.55),('325','2014-03-19','09:45:00',2.46),('325','2014-03-19','09:50:00',2.24),('325','2014-03-19','09:55:00',1.7),('325','2014-03-19','10:00:00',1.33),('325','2014-03-19','10:25:00',1.07),('325','2014-03-19','10:30:00',1.39),('325','2014-03-19','10:35:00',2.31),('325','2014-03-19','10:40:00',1.76),('325','2014-03-19','10:45:00',1.73),('325','2014-03-19','10:50:00',1.54),('325','2014-03-19','10:55:00',3.93),('325','2014-03-19','11:00:00',3.68),('325','2014-03-19','11:05:00',3.26),('325','2014-03-19','11:10:00',1.72),('325','2014-03-19','11:15:00',1.77),('325','2014-03-19','11:20:00',1.59),('325','2014-03-19','11:25:00',1.73),('325','2014-03-19','11:30:00',1.79),('325','2014-03-19','11:35:00',2.19),('325','2014-03-19','11:40:00',2),('325','2014-03-19','11:45:00',2.01),('325','2014-03-19','11:50:00',2.22),('325','2014-03-19','11:55:00',2.12),('325','2014-03-19','12:00:00',4.16),('325','2014-03-19','12:05:00',4.64),('325','2014-03-19','12:10:00',4.49),('325','2014-03-19','12:15:00',4.63),('325','2014-03-19','12:20:00',4.53),('325','2014-03-19','12:25:00',2.99),('325','2014-03-19','12:30:00',4.02),('325','2014-03-19','12:35:00',1.73),('325','2014-03-19','12:40:00',2.99),('325','2014-03-19','12:45:00',3.53),('325','2014-03-19','12:50:00',3.98),('325','2014-03-19','12:55:00',3.7),('325','2014-03-19','13:00:00',4.14),('325','2014-03-19','13:05:00',4.03),('325','2014-03-19','13:10:00',3.61),('325','2014-03-19','13:15:00',3.45),('325','2014-03-19','13:20:00',3.66),('325','2014-03-19','13:25:00',3.59),('325','2014-03-19','13:30:00',4.02),('325','2014-03-19','13:35:00',4),('325','2014-03-19','13:40:00',3.88),('325','2014-03-19','13:45:00',3.8),('325','2014-03-19','13:50:00',3.63),('325','2014-03-19','13:55:00',3.78),('325','2014-03-19','14:00:00',3.74),('325','2014-03-19','14:05:00',3.76),('325','2014-03-19','14:10:00',3.66),('325','2014-03-19','14:15:00',3.64),('325','2014-03-19','14:20:00',3.48),('325','2014-03-19','14:25:00',3.49),('325','2014-03-19','14:30:00',3.35),('325','2014-03-19','14:35:00',3.43),('325','2014-03-19','14:40:00',3.36),('325','2014-03-19','14:45:00',3.3),('325','2014-03-19','14:50:00',3.2),('325','2014-03-19','14:55:00',3.14),('325','2014-03-19','15:00:00',3.06),('325','2014-03-19','15:05:00',2.98),('325','2014-03-19','15:10:00',2.93),('325','2014-03-19','15:15:00',2.89),('325','2014-03-19','15:20:00',2.77),('325','2014-03-19','15:25:00',2.74),('325','2014-03-19','15:30:00',2.64),('325','2014-03-19','15:35:00',2.47),('325','2014-03-19','15:40:00',2.41),('325','2014-03-19','15:45:00',2.34),('325','2014-03-19','15:50:00',2.24),('325','2014-03-19','15:55:00',2.2),('325','2014-03-19','16:00:00',2.07),('325','2014-03-19','16:05:00',2.01),('325','2014-03-19','16:10:00',1.93),('325','2014-03-19','16:15:00',1.8),('325','2014-03-19','16:20:00',1.66),('325','2014-03-19','16:25:00',1.54),('325','2014-03-19','16:30:00',1.45),('325','2014-03-19','16:35:00',1.3),('325','2014-03-19','16:40:00',1.2),('325','2014-03-19','16:45:00',1.12),('325','2014-03-18','08:20:00',1.39),('325','2014-03-18','08:25:00',1.07),('325','2014-03-18','08:30:00',1.12),('325','2014-03-18','08:50:00',1.66),('325','2014-03-18','08:55:00',2.18),('325','2014-03-18','09:00:00',1.55),('325','2014-03-18','09:05:00',1.42),('325','2014-03-18','09:10:00',1.51),('325','2014-03-18','09:15:00',1.63),('325','2014-03-18','09:20:00',1.99),('325','2014-03-18','09:25:00',2.32),('325','2014-03-18','09:30:00',1.63),('325','2014-03-18','09:35:00',1.75),('325','2014-03-18','09:40:00',1.06),('325','2014-03-18','09:45:00',1.49),('325','2014-03-18','09:50:00',2.02),('325','2014-03-18','09:55:00',1.57),('325','2014-03-18','10:00:00',3.26),('325','2014-03-18','10:05:00',3.62),('325','2014-03-18','10:10:00',3.84),('325','2014-03-18','10:15:00',3.77),('325','2014-03-18','10:20:00',2.92),('325','2014-03-18','10:25:00',1.93),('325','2014-03-18','10:30:00',3.56),('325','2014-03-18','10:35:00',3.47),('325','2014-03-18','10:40:00',2),('325','2014-03-18','10:45:00',3.17),('325','2014-03-18','10:50:00',4.3),('325','2014-03-18','10:55:00',2.43),('325','2014-03-18','11:00:00',1.8),('325','2014-03-18','11:05:00',2.07),('325','2014-03-18','11:10:00',1.5),('325','2014-03-18','11:15:00',3.16),('325','2014-03-18','11:20:00',4.59),('325','2014-03-18','11:25:00',3.62),('325','2014-03-18','11:30:00',3.98),('325','2014-03-18','11:35:00',5.01),('325','2014-03-18','11:40:00',4.41),('325','2014-03-18','11:45:00',3.75),('325','2014-03-18','11:50:00',2.56),('325','2014-03-18','11:55:00',1.83),('325','2014-03-18','12:00:00',2.36),('325','2014-03-18','12:05:00',3.9),('325','2014-03-18','12:10:00',4.18),('325','2014-03-18','12:15:00',2.09),('325','2014-03-18','12:20:00',1.58),('325','2014-03-18','12:25:00',1.95),('325','2014-03-18','12:30:00',2.61),('325','2014-03-18','12:35:00',2.08),('325','2014-03-18','12:40:00',3.77),('325','2014-03-18','12:45:00',4.57),('325','2014-03-18','12:50:00',4.45),('325','2014-03-18','12:55:00',4.37),('325','2014-03-18','13:00:00',4.27),('325','2014-03-18','13:05:00',4.28),('325','2014-03-18','13:10:00',4.17),('325','2014-03-18','13:15:00',3.95),('325','2014-03-18','13:20:00',3.89),('325','2014-03-18','13:25:00',3.1),('325','2014-03-18','13:30:00',4.1),('325','2014-03-18','13:35:00',4.01),('325','2014-03-18','13:40:00',3.96),('325','2014-03-18','13:45:00',3.91),('325','2014-03-18','13:50:00',3.9),('325','2014-03-18','13:55:00',3.92),('325','2014-03-18','14:00:00',3.85),('325','2014-03-18','14:05:00',3.84),('325','2014-03-18','14:10:00',3.75),('325','2014-03-18','14:15:00',3.7),('325','2014-03-18','14:20:00',3.67),('325','2014-03-18','14:25:00',3.58),('325','2014-03-18','14:30:00',3.54),('325','2014-03-18','14:35:00',3.48),('325','2014-03-18','14:40:00',3.42),('325','2014-03-18','14:45:00',3.35),('325','2014-03-18','14:50:00',3.3),('325','2014-03-18','14:55:00',3.2),('325','2014-03-18','15:00:00',3.14),('325','2014-03-18','15:05:00',3.07),('325','2014-03-18','15:10:00',3.02),('325','2014-03-18','15:15:00',2.93),('325','2014-03-18','15:20:00',2.83),('325','2014-03-18','15:25:00',2.74),('325','2014-03-18','15:30:00',2.68),('325','2014-03-18','15:35:00',2.57),('325','2014-03-18','15:40:00',2.42),('325','2014-03-18','15:45:00',2.34),('325','2014-03-18','15:50:00',2.23),('325','2014-03-18','15:55:00',2.18),('325','2014-03-18','16:00:00',2.08),('325','2014-03-18','16:05:00',2),('325','2014-03-18','16:10:00',1.91),('325','2014-03-18','16:15:00',1.79),('325','2014-03-18','16:20:00',1.65),('325','2014-03-18','16:25:00',1.59),('325','2014-03-18','16:30:00',1.49),('325','2014-03-18','16:35:00',1.39),('325','2014-03-18','16:40:00',1.26),('325','2014-03-18','16:45:00',1.16),('325','2014-03-18','16:50:00',1.03),('325','2014-03-17','09:15:00',1.13),('325','2014-03-17','09:20:00',1.21),('325','2014-03-17','09:25:00',1.54),('325','2014-03-17','09:30:00',1.74),('325','2014-03-17','09:35:00',1.32),('325','2014-03-17','09:40:00',1.23),('325','2014-03-17','09:45:00',1.34),('325','2014-03-17','09:50:00',2.12),('325','2014-03-17','09:55:00',1.79),('325','2014-03-17','10:00:00',1.94),('325','2014-03-17','10:05:00',1.83),('325','2014-03-17','10:10:00',1.58),('325','2014-03-17','10:15:00',1.85),('325','2014-03-17','10:20:00',1.81),('325','2014-03-17','10:25:00',1.67),('325','2014-03-17','10:30:00',1.44),('325','2014-03-17','10:35:00',1.31),('325','2014-03-17','10:40:00',1.5),('325','2014-03-17','10:45:00',1.84),('325','2014-03-17','10:50:00',1.48),('325','2014-03-17','10:55:00',1.43),('325','2014-03-17','11:00:00',1.56),('325','2014-03-17','11:05:00',1.36),('325','2014-03-17','11:10:00',1.91),('325','2014-03-17','11:15:00',1.66),('325','2014-03-17','11:20:00',1.42),('325','2014-03-17','11:25:00',1.92),('325','2014-03-17','11:30:00',1.42),('325','2014-03-17','11:35:00',1.49),('325','2014-03-17','11:40:00',1.33),('325','2014-03-17','11:45:00',1.76),('325','2014-03-17','11:50:00',1.61),('325','2014-03-17','11:55:00',1.75),('325','2014-03-17','12:00:00',1.7),('325','2014-03-17','12:05:00',1.71),('325','2014-03-17','12:10:00',1.43),('325','2014-03-17','12:15:00',2.16),('325','2014-03-17','12:20:00',3.78),('325','2014-03-17','12:25:00',1.5),('325','2014-03-17','12:30:00',2.14),('325','2014-03-17','12:35:00',2.14),('325','2014-03-17','12:40:00',4.63),('325','2014-03-17','12:45:00',4.61),('325','2014-03-17','12:50:00',4.37),('325','2014-03-17','12:55:00',3.54),('325','2014-03-17','13:00:00',1.47),('325','2014-03-17','13:05:00',2.89),('325','2014-03-17','13:10:00',4.3),('325','2014-03-17','13:15:00',4.24),('325','2014-03-17','13:20:00',4.11),('325','2014-03-17','13:25:00',4.19),('325','2014-03-17','13:30:00',3.79),('325','2014-03-17','13:35:00',4.2),('325','2014-03-17','13:40:00',3.42),('325','2014-03-17','13:45:00',1.8),('325','2014-03-17','13:50:00',3.84),('325','2014-03-17','13:55:00',1.98),('325','2014-03-17','14:00:00',4.06),('325','2014-03-17','14:05:00',2.84),('325','2014-03-17','14:10:00',1.69),('325','2014-03-17','14:15:00',3.33),('325','2014-03-17','14:20:00',2.3),('325','2014-03-17','14:25:00',2.73),('325','2014-03-17','14:30:00',1.7),('325','2014-03-17','14:35:00',3.58),('325','2014-03-17','14:40:00',3.3),('325','2014-03-17','14:45:00',1.56),('325','2014-03-17','14:50:00',3.31),('325','2014-03-17','14:55:00',2.57),('325','2014-03-17','15:00:00',2.77),('325','2014-03-17','15:05:00',1.81),('325','2014-03-17','15:10:00',2.46),('325','2014-03-17','15:15:00',2.32),('325','2014-03-17','15:20:00',2.81),('325','2014-03-17','15:25:00',2.7),('325','2014-03-17','15:30:00',2.66),('325','2014-03-17','15:35:00',2.4),('325','2014-03-17','15:40:00',2.12),('325','2014-03-17','15:45:00',2.05),('325','2014-03-17','15:50:00',1.99),('325','2014-03-17','15:55:00',2.07),('325','2014-03-17','16:00:00',2.01),('325','2014-03-17','16:05:00',1.2),('325','2014-03-17','16:15:00',1.32),('325','2014-03-17','16:20:00',1.61),('325','2014-03-17','16:25:00',1.55),('325','2014-03-17','16:30:00',1.44),('325','2014-03-17','16:35:00',1.49),('325','2014-03-17','16:40:00',1.2),('325','2014-03-17','16:45:00',1.2),('325','2014-03-17','16:50:00',1.07),('325','2014-04-30','08:30:00',1.03),('325','2014-04-30','08:35:00',1.09),('325','2014-04-30','08:40:00',1.15),('325','2014-04-30','08:45:00',1.22),('325','2014-04-30','08:50:00',1.3),('325','2014-04-30','08:55:00',1.32),('325','2014-04-30','09:00:00',1.19),('325','2014-04-30','09:05:00',2.09),('325','2014-04-30','09:10:00',1.57),('325','2014-04-30','09:20:00',1.23),('325','2014-04-30','09:25:00',1.88),('325','2014-04-30','09:30:00',2),('325','2014-04-30','09:35:00',2.93),('325','2014-04-30','09:40:00',3.13),('325','2014-04-30','09:45:00',2.88),('325','2014-04-30','09:50:00',2.35),('325','2014-04-30','09:55:00',3.28),('325','2014-04-30','10:00:00',3.61),('325','2014-04-30','10:05:00',3.54),('325','2014-04-30','10:10:00',2.88),('325','2014-04-30','10:15:00',2.45),('325','2014-04-30','10:20:00',1.79),('325','2014-04-30','10:25:00',1.74),('325','2014-04-30','10:30:00',2.12),('325','2014-04-30','10:35:00',2.2),('325','2014-04-30','10:40:00',2.29),('325','2014-04-30','10:45:00',1.7),('325','2014-04-30','10:50:00',2.23),('325','2014-04-30','10:55:00',4.18),('325','2014-04-30','11:00:00',4.75),('325','2014-04-30','11:05:00',3.75),('325','2014-04-30','11:10:00',3.06),('325','2014-04-30','11:15:00',2.09),('325','2014-04-30','11:20:00',2.4),('325','2014-04-30','11:25:00',2.46),('325','2014-04-30','11:30:00',2.43),('325','2014-04-30','11:35:00',3.93),('325','2014-04-30','11:40:00',2.83),('325','2014-04-30','11:45:00',3.83),('325','2014-04-30','11:50:00',4.45),('325','2014-04-30','11:55:00',3.36),('325','2014-04-30','12:00:00',2.5),('325','2014-04-30','12:05:00',1.47),('325','2014-04-30','12:10:00',1.47),('325','2014-04-30','12:15:00',1.86),('325','2014-04-30','12:20:00',1.83),('325','2014-04-30','12:25:00',1.59),('325','2014-04-30','12:30:00',1.97),('325','2014-04-30','12:35:00',1.95),('325','2014-04-30','12:40:00',1.37),('325','2014-04-30','12:45:00',1.43),('325','2014-04-30','12:50:00',2.8),('325','2014-04-30','12:55:00',4.95),('325','2014-04-30','13:00:00',3.85),('325','2014-04-30','13:05:00',3.34),('325','2014-04-30','13:10:00',3.99),('325','2014-04-30','13:15:00',2.44),('325','2014-04-30','13:20:00',2.57),('325','2014-04-30','13:25:00',4.16),('325','2014-04-30','13:30:00',1.87),('325','2014-04-30','13:35:00',2.57),('325','2014-04-30','13:40:00',3.95),('325','2014-04-30','13:45:00',4.32),('325','2014-04-30','13:50:00',3.76),('325','2014-04-30','13:55:00',3.49),('325','2014-04-30','14:00:00',2.15),('325','2014-04-30','14:05:00',1.84),('325','2014-04-30','14:10:00',1.66),('325','2014-04-30','14:15:00',2.08),('325','2014-04-30','14:20:00',4.22),('325','2014-04-30','14:25:00',4.48),('325','2014-04-30','14:30:00',5.28),('325','2014-04-30','14:35:00',3.75),('325','2014-04-30','14:40:00',2.01),('325','2014-04-30','14:45:00',1.52),('325','2014-04-30','14:50:00',1.79),('325','2014-04-30','14:55:00',1.9),('325','2014-04-30','15:00:00',1.62),('325','2014-04-30','15:05:00',1.6),('325','2014-04-30','15:10:00',1.85),('325','2014-04-30','15:15:00',1.39),('325','2014-04-30','15:20:00',1.26),('325','2014-04-30','15:25:00',1.45),('325','2014-04-30','15:30:00',1.82),('325','2014-04-30','15:35:00',3.48),('325','2014-04-30','15:40:00',5.01),('325','2014-04-30','15:45:00',3.58),('325','2014-04-30','15:50:00',4.12),('325','2014-04-30','15:55:00',2.16),('325','2014-04-30','16:00:00',1.36),('325','2014-04-30','16:05:00',2.06),('325','2014-04-30','16:10:00',2.03),('325','2014-04-30','16:15:00',2.53),('325','2014-04-30','16:20:00',1.7),('325','2014-04-30','16:25:00',2.16),('325','2014-04-30','16:30:00',1.94),('325','2014-04-30','16:35:00',1.76),('325','2014-04-30','16:40:00',2.5),('325','2014-04-30','16:45:00',2.6),('325','2014-04-30','16:50:00',3.3),('325','2014-04-30','16:55:00',2.61),('325','2014-04-30','17:00:00',2.21),('325','2014-04-30','17:05:00',1.73),('325','2014-04-30','17:20:00',1.2),('325','2014-04-30','17:35:00',1.1),('325','2014-04-30','17:40:00',1.09),('325','2014-03-16','08:05:00',1.02),('325','2014-03-16','08:10:00',1.05),('325','2014-03-16','08:15:00',1.08),('325','2014-03-16','08:20:00',1.14),('325','2014-03-16','08:25:00',1.2),('325','2014-03-16','08:30:00',1.25),('325','2014-03-16','08:35:00',1.3),('325','2014-03-16','08:40:00',1.34),('325','2014-03-16','08:45:00',1.41),('325','2014-03-16','08:50:00',1.46),('325','2014-03-16','08:55:00',1.51),('325','2014-03-16','09:00:00',1.49),('325','2014-03-16','09:05:00',1.55),('325','2014-03-16','09:10:00',1.64),('325','2014-03-16','09:15:00',1.76),('325','2014-03-16','09:20:00',1.81),('325','2014-03-16','09:25:00',1.8),('325','2014-03-16','09:30:00',1.85),('325','2014-03-16','09:35:00',1.98),('325','2014-03-16','09:40:00',2.58),('325','2014-03-16','09:45:00',2.77),('325','2014-03-16','09:50:00',2.98),('325','2014-03-16','09:55:00',2.97),('325','2014-03-16','10:00:00',2.91),('325','2014-03-16','10:05:00',3.06),('325','2014-03-16','10:10:00',3.14),('325','2014-03-16','10:15:00',3.28),('325','2014-03-16','10:20:00',3.33),('325','2014-03-16','10:25:00',3.29),('325','2014-03-16','10:30:00',3.35),('325','2014-03-16','10:35:00',3.4),('325','2014-03-16','10:40:00',3.43),('325','2014-03-16','10:45:00',3.54),('325','2014-03-16','10:50:00',3.65),('325','2014-03-16','10:55:00',3.69),('325','2014-03-16','11:00:00',3.71),('325','2014-03-16','11:05:00',3.72),('325','2014-03-16','11:10:00',3.71),('325','2014-03-16','11:15:00',3.71),('325','2014-03-16','11:20:00',3.72),('325','2014-03-16','11:25:00',3.84),('325','2014-03-16','11:30:00',3.9),('325','2014-03-16','11:35:00',3.9),('325','2014-03-16','11:40:00',3.91),('325','2014-03-16','11:45:00',3.83),('325','2014-03-16','11:50:00',3.79),('325','2014-03-16','11:55:00',3.79),('325','2014-03-16','12:00:00',3.94),('325','2014-03-16','12:05:00',3.9),('325','2014-03-16','12:10:00',3.84),('325','2014-03-16','12:15:00',3.61),('325','2014-03-16','12:20:00',3.81),('325','2014-03-16','12:25:00',3.92),('325','2014-03-16','12:30:00',3.93),('325','2014-03-16','12:35:00',3.92),('325','2014-03-16','12:40:00',3.9),('325','2014-03-16','12:45:00',3.91),('325','2014-03-16','12:50:00',3.91),('325','2014-03-16','12:55:00',3.87),('325','2014-03-16','13:00:00',3.78),('325','2014-03-16','13:05:00',3.75),('325','2014-03-16','13:10:00',3.67),('325','2014-03-16','13:15:00',3.79),('325','2014-03-16','13:20:00',3.67),('325','2014-03-16','13:25:00',3.79),('325','2014-03-16','13:30:00',3.71),('325','2014-03-16','13:35:00',3.64),('325','2014-03-16','13:40:00',3.77),('325','2014-03-16','13:45:00',3.7),('325','2014-03-16','13:50:00',3.66),('325','2014-03-16','13:55:00',3.64),('325','2014-03-16','14:00:00',3.57),('325','2014-03-16','14:05:00',3.48),('325','2014-03-16','14:10:00',3.42),('325','2014-03-16','14:15:00',3.32),('325','2014-03-16','14:20:00',3.35),('325','2014-03-16','14:25:00',3.29),('325','2014-03-16','14:30:00',3.27),('325','2014-03-16','14:35:00',3.18),('325','2014-03-16','14:40:00',3.12),('325','2014-03-16','14:45:00',3.04),('325','2014-03-16','14:50:00',2.85),('325','2014-03-16','14:55:00',2.84),('325','2014-03-16','15:00:00',2.91),('325','2014-03-16','15:05:00',2.79),('325','2014-03-16','15:10:00',2.54),('325','2014-03-16','15:15:00',2.43),('325','2014-03-16','15:20:00',2.05),('325','2014-03-16','15:25:00',2.35),('325','2014-03-16','15:30:00',2.12),('325','2014-03-16','15:35:00',1.96),('325','2014-03-16','15:40:00',1.56),('325','2014-03-16','15:45:00',1.49),('325','2014-03-16','15:50:00',1.69),('325','2014-03-16','15:55:00',1.57),('325','2014-03-16','16:00:00',1.35),('325','2014-03-16','16:05:00',1.62),('325','2014-03-16','16:10:00',1.7),('325','2014-03-16','16:15:00',1.67),('325','2014-03-16','16:20:00',1.5),('325','2014-03-16','16:25:00',1.44),('325','2014-03-16','16:30:00',1.47),('325','2014-03-16','16:35:00',1.34),('325','2014-03-16','16:40:00',1.16),('325','2014-03-16','16:45:00',1.02),('325','2014-03-15','08:15:00',1.03),('325','2014-03-15','08:20:00',1.09),('325','2014-03-15','08:25:00',1.14),('325','2014-03-15','08:30:00',1.19),('325','2014-03-15','08:35:00',1.25),('325','2014-03-15','08:40:00',1.33),('325','2014-03-15','08:45:00',1.38),('325','2014-03-15','08:50:00',1.44),('325','2014-03-15','08:55:00',1.48),('325','2014-03-15','09:00:00',1.54),('325','2014-03-15','09:05:00',1.59),('325','2014-03-15','09:10:00',1.65),('325','2014-03-15','09:15:00',1.7),('325','2014-03-15','09:20:00',1.75),('325','2014-03-15','09:25:00',1.8),('325','2014-03-15','09:30:00',1.85),('325','2014-03-15','09:35:00',1.88),('325','2014-03-15','09:40:00',2.35),('325','2014-03-15','09:45:00',2.73),('325','2014-03-15','09:50:00',2.8),('325','2014-03-15','09:55:00',2.85),('325','2014-03-15','10:00:00',2.9),('325','2014-03-15','10:05:00',3),('325','2014-03-15','10:10:00',3.08),('325','2014-03-15','10:15:00',3.15),('325','2014-03-15','10:20:00',3.21),('325','2014-03-15','10:25:00',3.2),('325','2014-03-15','10:30:00',3.23),('325','2014-03-15','10:35:00',3.25),('325','2014-03-15','10:40:00',3.37),('325','2014-03-15','10:45:00',3.37),('325','2014-03-15','10:50:00',3.39),('325','2014-03-15','10:55:00',3.43),('325','2014-03-15','11:00:00',3.49),('325','2014-03-15','11:05:00',3.59),('325','2014-03-15','11:10:00',3.62),('325','2014-03-15','11:15:00',3.71),('325','2014-03-15','11:20:00',3.78),('325','2014-03-15','11:25:00',3.83),('325','2014-03-15','11:30:00',3.76),('325','2014-03-15','11:35:00',3.86),('325','2014-03-15','11:40:00',3.85),('325','2014-03-15','11:45:00',3.92),('325','2014-03-15','11:50:00',3.82),('325','2014-03-15','11:55:00',3.83),('325','2014-03-15','12:00:00',3.8),('325','2014-03-15','12:05:00',3.86),('325','2014-03-15','12:10:00',3.92),('325','2014-03-15','12:15:00',3.92),('325','2014-03-15','12:20:00',3.86),('325','2014-03-15','12:25:00',3.95),('325','2014-03-15','12:30:00',4.04),('325','2014-03-15','12:35:00',4.08),('325','2014-03-15','12:40:00',4.01),('325','2014-03-15','12:45:00',3.99),('325','2014-03-15','12:50:00',3.99),('325','2014-03-15','12:55:00',3.92),('325','2014-03-15','13:00:00',3.93),('325','2014-03-15','13:05:00',3.97),('325','2014-03-15','13:10:00',3.93),('325','2014-03-15','13:15:00',3.91),('325','2014-03-15','13:20:00',3.88),('325','2014-03-15','13:25:00',3.86),('325','2014-03-15','13:30:00',3.85),('325','2014-03-15','13:35:00',3.85),('325','2014-03-15','13:40:00',3.82),('325','2014-03-15','13:45:00',3.8),('325','2014-03-15','13:50:00',3.76),('325','2014-03-15','13:55:00',3.74),('325','2014-03-15','14:00:00',3.71),('325','2014-03-15','14:05:00',3.69),('325','2014-03-15','14:10:00',3.62),('325','2014-03-15','14:15:00',3.55),('325','2014-03-15','14:20:00',3.49),('325','2014-03-15','14:25:00',3.43),('325','2014-03-15','14:30:00',3.37),('325','2014-03-15','14:35:00',3.3),('325','2014-03-15','14:40:00',3.21),('325','2014-03-15','14:45:00',3.15),('325','2014-03-15','14:50:00',3.07),('325','2014-03-15','14:55:00',3.05),('325','2014-03-15','15:00:00',2.99),('325','2014-03-15','15:05:00',2.9),('325','2014-03-15','15:10:00',2.81),('325','2014-03-15','15:15:00',2.73),('325','2014-03-15','15:20:00',2.63),('325','2014-03-15','15:25:00',2.55),('325','2014-03-15','15:30:00',2.47),('325','2014-03-15','15:35:00',2.34),('325','2014-03-15','15:40:00',2.21),('325','2014-03-15','15:45:00',2.15),('325','2014-03-15','15:50:00',2.07),('325','2014-03-15','15:55:00',1.97),('325','2014-03-15','16:00:00',1.84),('325','2014-03-15','16:05:00',1.73),('325','2014-03-15','16:10:00',1.63),('325','2014-03-15','16:15:00',1.52),('325','2014-03-15','16:20:00',1.42),('325','2014-03-15','16:25:00',1.29),('325','2014-03-15','16:30:00',1.22),('325','2014-03-15','16:35:00',1.15),('325','2014-03-15','16:40:00',1.04),('325','2014-03-14','08:20:00',1.03),('325','2014-03-14','08:25:00',1.08),('325','2014-03-14','08:30:00',1.14),('325','2014-03-14','08:35:00',1.15),('325','2014-03-14','08:40:00',1.14),('325','2014-03-14','08:45:00',1.04),('325','2014-03-14','08:50:00',1.03),('325','2014-03-14','08:55:00',1.08),('325','2014-03-14','09:00:00',1.17),('325','2014-03-14','09:05:00',1.31),('325','2014-03-14','09:10:00',1.43),('325','2014-03-14','09:15:00',1.48),('325','2014-03-14','09:20:00',1.44),('325','2014-03-14','09:25:00',1.47),('325','2014-03-14','09:30:00',1.47),('325','2014-03-14','09:35:00',1.64),('325','2014-03-14','09:40:00',1.96),('325','2014-03-14','09:45:00',2.18),('325','2014-03-14','09:50:00',2.44),('325','2014-03-14','09:55:00',2.98),('325','2014-03-14','10:00:00',3.56),('325','2014-03-14','10:05:00',3.65),('325','2014-03-14','10:10:00',3.63),('325','2014-03-14','10:15:00',3.59),('325','2014-03-14','10:20:00',3.52),('325','2014-03-14','10:25:00',3.34),('325','2014-03-14','10:30:00',3.35),('325','2014-03-14','10:35:00',3.51),('325','2014-03-14','10:40:00',3.65),('325','2014-03-14','10:45:00',3.19),('325','2014-03-14','10:50:00',2.1),('325','2014-03-14','10:55:00',2.82),('325','2014-03-14','11:00:00',3.42),('325','2014-03-14','11:05:00',3.6),('325','2014-03-14','11:10:00',3.99),('325','2014-03-14','11:15:00',4.1),('325','2014-03-14','11:20:00',3.92),('325','2014-03-14','11:25:00',3.79),('325','2014-03-14','11:30:00',3.81),('325','2014-03-14','11:35:00',3.85),('325','2014-03-14','11:40:00',3.94),('325','2014-03-14','11:45:00',4.02),('325','2014-03-14','11:50:00',4.13),('325','2014-03-14','11:55:00',4.11),('325','2014-03-14','12:00:00',4.13),('325','2014-03-14','12:05:00',4.05),('325','2014-03-14','12:10:00',3.86),('325','2014-03-14','12:15:00',3.78),('325','2014-03-14','12:20:00',3.18),('325','2014-03-14','12:25:00',2.61),('325','2014-03-14','12:30:00',2.47),('325','2014-03-14','12:35:00',2.06),('325','2014-03-14','12:40:00',2.4),('325','2014-03-14','12:45:00',2.63),('325','2014-03-14','12:50:00',3.09),('325','2014-03-14','12:55:00',3.46),('325','2014-03-14','13:00:00',2.27),('325','2014-03-14','13:05:00',2.06),('325','2014-03-14','13:10:00',2.47),('325','2014-03-14','13:15:00',2.64),('325','2014-03-14','13:20:00',3.08),('325','2014-03-14','13:25:00',2.79),('325','2014-03-14','13:30:00',2.56),('325','2014-03-14','13:35:00',2.26),('325','2014-03-14','13:40:00',2.22),('325','2014-03-14','13:45:00',2.31),('325','2014-03-14','13:50:00',2.38),('325','2014-03-14','13:55:00',2.2),('325','2014-03-14','14:00:00',2.58),('325','2014-03-14','14:05:00',2.97),('325','2014-03-14','14:10:00',2.83),('325','2014-03-14','14:15:00',3.12),('325','2014-03-14','14:20:00',3.08),('325','2014-03-14','14:25:00',2.79),('325','2014-03-14','14:30:00',2.74),('325','2014-03-14','14:35:00',2.64),('325','2014-03-14','14:40:00',2.14),('325','2014-03-14','14:45:00',1.74),('325','2014-03-14','14:50:00',1.59),('325','2014-03-14','14:55:00',1.45),('325','2014-03-14','15:00:00',1.34),('325','2014-03-14','15:05:00',1.34),('325','2014-03-14','15:10:00',1.27),('325','2014-03-14','15:15:00',1.23),('325','2014-03-14','15:20:00',1.34),('325','2014-03-14','15:25:00',1.41),('325','2014-03-14','15:30:00',1.45),('325','2014-03-14','15:35:00',1.78),('325','2014-03-14','15:40:00',1.63),('325','2014-03-14','15:45:00',1.36),('325','2014-03-14','15:50:00',1.18),('325','2014-03-14','15:55:00',1.19),('325','2014-03-14','16:00:00',1.1),('325','2014-03-14','16:05:00',1.1),('325','2014-03-13','08:15:00',1.04),('325','2014-03-13','08:20:00',1.09),('325','2014-03-13','08:25:00',1.15),('325','2014-03-13','08:30:00',1.19),('325','2014-03-13','08:35:00',1.24),('325','2014-03-13','08:40:00',1.3),('325','2014-03-13','08:45:00',1.35),('325','2014-03-13','08:50:00',1.39),('325','2014-03-13','08:55:00',1.44),('325','2014-03-13','09:00:00',1.49),('325','2014-03-13','09:05:00',1.53),('325','2014-03-13','09:10:00',1.57),('325','2014-03-13','09:15:00',1.61),('325','2014-03-13','09:20:00',1.65),('325','2014-03-13','09:25:00',1.69),('325','2014-03-13','09:30:00',1.73),('325','2014-03-13','09:35:00',1.78),('325','2014-03-13','09:40:00',2.66),('325','2014-03-13','09:45:00',3.1),('325','2014-03-13','09:50:00',3.23),('325','2014-03-13','09:55:00',3.29),('325','2014-03-13','10:00:00',3.38),('325','2014-03-13','10:05:00',3.46),('325','2014-03-13','10:10:00',3.52),('325','2014-03-13','10:15:00',3.6),('325','2014-03-13','10:20:00',3.64),('325','2014-03-13','10:25:00',3.67),('325','2014-03-13','10:30:00',3.71),('325','2014-03-13','10:35:00',3.76),('325','2014-03-13','10:40:00',3.78),('325','2014-03-13','10:45:00',3.82),('325','2014-03-13','10:50:00',3.87),('325','2014-03-13','10:55:00',3.91),('325','2014-03-13','11:00:00',3.93),('325','2014-03-13','11:05:00',3.97),('325','2014-03-13','11:10:00',4.01),('325','2014-03-13','11:15:00',4.01),('325','2014-03-13','11:20:00',4.07),('325','2014-03-13','11:25:00',4.08),('325','2014-03-13','11:30:00',4.11),('325','2014-03-13','11:35:00',4.1),('325','2014-03-13','11:40:00',4.11),('325','2014-03-13','11:45:00',4.13),('325','2014-03-13','11:50:00',4.13),('325','2014-03-13','11:55:00',4.18),('325','2014-03-13','12:00:00',4.18),('325','2014-03-13','12:05:00',4.19),('325','2014-03-13','12:10:00',4.16),('325','2014-03-13','12:15:00',4.16),('325','2014-03-13','12:20:00',4.13),('325','2014-03-13','12:25:00',4.1),('325','2014-03-13','12:30:00',4.07),('325','2014-03-13','12:35:00',4.08),('325','2014-03-13','12:40:00',4.07),('325','2014-03-13','12:45:00',4.06),('325','2014-03-13','12:50:00',4.03),('325','2014-03-13','12:55:00',4.02),('325','2014-03-13','13:00:00',4),('325','2014-03-13','13:05:00',3.96),('325','2014-03-13','13:10:00',3.93),('325','2014-03-13','13:15:00',3.95),('325','2014-03-13','13:20:00',3.96),('325','2014-03-13','13:25:00',3.96),('325','2014-03-13','13:30:00',3.94),('325','2014-03-13','13:35:00',3.93),('325','2014-03-13','13:40:00',3.88),('325','2014-03-13','13:45:00',3.84),('325','2014-03-13','13:50:00',3.78),('325','2014-03-13','13:55:00',3.73),('325','2014-03-13','14:00:00',3.65),('325','2014-03-13','14:05:00',3.6),('325','2014-03-13','14:10:00',3.56),('325','2014-03-13','14:15:00',3.56),('325','2014-03-13','14:20:00',3.5),('325','2014-03-13','14:25:00',3.43),('325','2014-03-13','14:30:00',3.36),('325','2014-03-13','14:35:00',3.31),('325','2014-03-13','14:40:00',3.25),('325','2014-03-13','14:45:00',3.19),('325','2014-03-13','14:50:00',3.11),('325','2014-03-13','14:55:00',3.03),('325','2014-03-13','15:00:00',2.95),('325','2014-03-13','15:05:00',2.87),('325','2014-03-13','15:10:00',2.8),('325','2014-03-13','15:15:00',2.74),('325','2014-03-13','15:20:00',2.67),('325','2014-03-13','15:25:00',2.59),('325','2014-03-13','15:30:00',2.49),('325','2014-03-13','15:35:00',2.38),('325','2014-03-13','15:40:00',2.29),('325','2014-03-13','15:45:00',2.2),('325','2014-03-13','15:50:00',2.12),('325','2014-03-13','15:55:00',2.02),('325','2014-03-13','16:00:00',1.91),('325','2014-03-13','16:05:00',1.79),('325','2014-03-13','16:10:00',1.7),('325','2014-03-13','16:15:00',1.6),('325','2014-03-13','16:20:00',1.49),('325','2014-03-13','16:25:00',1.41),('325','2014-03-13','16:30:00',1.31),('325','2014-03-13','16:35:00',1.21),('325','2014-03-13','16:40:00',1.12),('325','2014-03-13','16:45:00',1.03),('325','2014-03-12','08:20:00',1.05),('325','2014-03-12','08:25:00',1.11),('325','2014-03-12','08:30:00',1.17),('325','2014-03-12','08:35:00',1.23),('325','2014-03-12','08:40:00',1.28),('325','2014-03-12','08:45:00',1.33),('325','2014-03-12','08:50:00',1.38),('325','2014-03-12','08:55:00',1.43),('325','2014-03-12','09:00:00',1.47),('325','2014-03-12','09:05:00',1.53),('325','2014-03-12','09:10:00',1.57),('325','2014-03-12','09:15:00',1.62),('325','2014-03-12','09:20:00',1.67),('325','2014-03-12','09:25:00',1.72),('325','2014-03-12','09:30:00',1.76),('325','2014-03-12','09:35:00',1.8),('325','2014-03-12','09:40:00',2.53),('325','2014-03-12','09:45:00',3.06),('325','2014-03-12','09:50:00',3.17),('325','2014-03-12','09:55:00',3.24),('325','2014-03-12','10:00:00',3.31),('325','2014-03-12','10:05:00',3.39),('325','2014-03-12','10:10:00',3.47),('325','2014-03-12','10:15:00',3.57),('325','2014-03-12','10:20:00',3.61),('325','2014-03-12','10:25:00',3.66),('325','2014-03-12','10:30:00',3.71),('325','2014-03-12','10:35:00',3.76),('325','2014-03-12','10:40:00',3.82),('325','2014-03-12','10:45:00',3.86),('325','2014-03-12','10:50:00',3.92),('325','2014-03-12','10:55:00',3.95),('325','2014-03-12','11:00:00',3.99),('325','2014-03-12','11:05:00',4.06),('325','2014-03-12','11:10:00',4.13),('325','2014-03-12','11:15:00',4.17),('325','2014-03-12','11:20:00',4.2),('325','2014-03-12','11:25:00',4.21),('325','2014-03-12','11:30:00',4.23),('325','2014-03-12','11:35:00',4.24),('325','2014-03-12','11:40:00',4.26),('325','2014-03-12','11:45:00',4.26),('325','2014-03-12','11:50:00',4.25),('325','2014-03-12','11:55:00',4.25),('325','2014-03-12','12:00:00',4.26),('325','2014-03-12','12:05:00',4.26),('325','2014-03-12','12:10:00',4.24),('325','2014-03-12','12:15:00',4.24),('325','2014-03-12','12:20:00',4.23),('325','2014-03-12','12:25:00',4.23),('325','2014-03-12','12:30:00',4.23),('325','2014-03-12','12:35:00',4.19),('325','2014-03-12','12:40:00',4.2),('325','2014-03-12','12:45:00',4.19),('325','2014-03-12','12:50:00',4.18),('325','2014-03-12','12:55:00',4.16),('325','2014-03-12','13:00:00',4.14),('325','2014-03-12','13:05:00',4.13),('325','2014-03-12','13:10:00',4.11),('325','2014-03-12','13:15:00',4.07),('325','2014-03-12','13:20:00',4.07),('325','2014-03-12','13:25:00',4.01),('325','2014-03-12','13:30:00',3.99),('325','2014-03-12','13:35:00',3.92),('325','2014-03-12','13:40:00',3.89),('325','2014-03-12','13:45:00',3.88),('325','2014-03-12','13:50:00',3.82),('325','2014-03-12','13:55:00',3.76),('325','2014-03-12','14:00:00',3.75),('325','2014-03-12','14:05:00',3.72),('325','2014-03-12','14:10:00',3.68),('325','2014-03-12','14:15:00',3.63),('325','2014-03-12','14:20:00',3.56),('325','2014-03-12','14:25:00',3.49),('325','2014-03-12','14:30:00',3.45),('325','2014-03-12','14:35:00',3.28),('325','2014-03-12','14:40:00',3.22),('325','2014-03-12','14:45:00',3.15),('325','2014-03-12','14:50:00',3.09),('325','2014-03-12','14:55:00',3.05),('325','2014-03-12','15:00:00',2.82),('325','2014-03-12','15:05:00',2.83),('325','2014-03-12','15:10:00',2.76),('325','2014-03-12','15:15:00',2.68),('325','2014-03-12','15:20:00',2.62),('325','2014-03-12','15:25:00',2.52),('325','2014-03-12','15:30:00',2.44),('325','2014-03-12','15:35:00',2.34),('325','2014-03-12','15:40:00',2.23),('325','2014-03-12','15:45:00',2.21),('325','2014-03-12','15:50:00',2.13),('325','2014-03-12','15:55:00',2.03),('325','2014-03-12','16:00:00',1.97),('325','2014-03-12','16:05:00',1.86),('325','2014-03-12','16:10:00',1.74),('325','2014-03-12','16:15:00',1.64),('325','2014-03-12','16:20:00',1.51),('325','2014-03-12','16:25:00',1.41),('325','2014-03-12','16:30:00',1.31),('325','2014-03-12','16:35:00',1.23),('325','2014-03-12','16:40:00',1.14),('325','2014-03-12','16:45:00',1.03),('325','2014-03-11','11:00:00',1.02),('325','2014-03-11','11:05:00',1.07),('325','2014-03-11','11:10:00',1.03),('325','2014-03-11','11:15:00',1.05),('325','2014-03-11','11:45:00',1.02),('325','2014-03-11','12:00:00',1.04),('325','2014-03-11','12:05:00',1.03),('325','2014-03-11','12:10:00',1.07),('325','2014-03-11','12:15:00',1.21),('325','2014-03-11','12:20:00',1.33),('325','2014-03-11','12:25:00',1.22),('325','2014-03-11','12:30:00',1.2),('325','2014-03-11','12:35:00',1.29),('325','2014-03-11','12:40:00',1.42),('325','2014-03-11','12:45:00',1.41),('325','2014-03-11','12:50:00',1.33),('325','2014-03-11','12:55:00',1.24),('325','2014-03-11','13:00:00',1.22),('325','2014-03-11','13:05:00',1.39),('325','2014-03-11','13:10:00',1.35),('325','2014-03-11','13:15:00',1.26),('325','2014-03-11','13:20:00',1.32),('325','2014-03-11','13:25:00',1.17),('325','2014-03-11','13:30:00',1.16),('325','2014-03-11','13:35:00',1.1),('325','2014-03-11','13:40:00',1.11),('325','2014-03-11','13:45:00',1.36),('325','2014-03-11','13:50:00',1.63),('325','2014-03-11','13:55:00',1.95),('325','2014-03-11','14:00:00',2.11),('325','2014-03-11','14:05:00',2.13),('325','2014-03-11','14:10:00',2.74),('325','2014-03-11','14:15:00',2.73),('325','2014-03-11','14:20:00',2.76),('325','2014-03-11','14:25:00',1.96),('325','2014-03-11','14:30:00',1.44),('325','2014-03-11','14:35:00',1.56),('325','2014-03-11','14:40:00',1.46),('325','2014-03-11','14:45:00',1.58),('325','2014-03-11','14:50:00',1.4),('325','2014-03-11','14:55:00',1.38),('325','2014-03-11','15:00:00',1.63),('325','2014-03-11','15:05:00',1.75),('325','2014-03-11','15:10:00',2.02),('325','2014-03-11','15:15:00',1.91),('325','2014-03-11','15:20:00',1.91),('325','2014-03-11','15:25:00',1.48),('325','2014-03-11','15:30:00',1.35),('325','2014-03-11','15:35:00',1.19),('325','2014-03-11','15:40:00',1.11),('325','2014-03-11','15:45:00',1.04),('325','2014-03-11','15:50:00',1.07),('325','2014-03-10','09:05:00',1.07),('325','2014-03-10','09:10:00',1.06),('325','2014-03-10','09:15:00',1),('325','2014-03-10','09:30:00',1),('325','2014-03-10','09:35:00',1.04),('325','2014-03-10','09:40:00',1.11),('325','2014-03-10','09:45:00',1.03),('325','2014-03-10','10:10:00',1),('325','2014-03-10','10:15:00',1.15),('325','2014-03-10','10:30:00',1.02),('325','2014-03-10','10:35:00',1.28),('325','2014-03-10','11:20:00',1.01),('325','2014-03-10','12:50:00',1.1),('325','2014-03-10','12:55:00',1.18),('325','2014-03-10','13:00:00',1.25),('325','2014-03-10','13:05:00',1.29),('325','2014-03-10','13:10:00',1.36),('325','2014-03-10','13:15:00',1.51),('325','2014-03-10','13:20:00',1.53),('325','2014-03-10','13:25:00',1.38),('325','2014-03-10','13:30:00',1.18),('325','2014-03-10','13:50:00',1.19),('325','2014-03-10','13:55:00',1.34),('325','2014-03-10','14:00:00',1.16),('325','2014-03-10','14:05:00',1.85),('325','2014-03-10','14:10:00',2.24),('325','2014-03-10','14:15:00',3.3),('325','2014-03-10','14:20:00',2.28),('325','2014-03-10','14:25:00',1.61),('325','2014-03-10','14:30:00',1.43),('325','2014-03-10','14:35:00',2.06),('325','2014-03-10','14:40:00',2.91),('325','2014-03-10','14:45:00',3.09),('325','2014-03-10','14:50:00',2.99),('325','2014-03-10','14:55:00',1.47),('325','2014-03-10','15:00:00',1.73),('325','2014-03-10','15:05:00',1.73),('325','2014-03-10','15:10:00',1.08),('325','2014-03-10','15:15:00',1.75),('325','2014-03-10','15:20:00',2.04),('325','2014-03-10','15:25:00',2.81),('325','2014-03-10','15:30:00',2.1),('325','2014-03-10','15:35:00',1.58),('325','2014-03-10','15:40:00',1.14),('325','2014-03-10','16:00:00',1.04),('325','2014-03-10','16:05:00',1.12),('325','2014-03-10','16:30:00',1.05),('325','2014-03-09','08:25:00',1.02),('325','2014-03-09','08:55:00',1.15),('325','2014-03-09','09:00:00',1.44),('325','2014-03-09','09:05:00',1.38),('325','2014-03-09','09:15:00',1.64),('325','2014-03-09','09:20:00',1.72),('325','2014-03-09','09:25:00',1.73),('325','2014-03-09','09:30:00',1.87),('325','2014-03-09','09:35:00',2.04),('325','2014-03-09','09:40:00',2.09),('325','2014-03-09','09:45:00',2.59),('325','2014-03-09','09:50:00',3.33),('325','2014-03-09','09:55:00',3.37),('325','2014-03-09','10:00:00',3.4),('325','2014-03-09','10:05:00',3.46),('325','2014-03-09','10:10:00',3.58),('325','2014-03-09','10:15:00',3.66),('325','2014-03-09','10:20:00',3.67),('325','2014-03-09','10:25:00',3.7),('325','2014-03-09','10:30:00',3.78),('325','2014-03-09','10:35:00',3.84),('325','2014-03-09','10:40:00',3.86),('325','2014-03-09','10:45:00',3.91),('325','2014-03-09','10:50:00',4.01),('325','2014-03-09','10:55:00',4.1),('325','2014-03-09','11:00:00',4.31),('325','2014-03-09','11:05:00',4.2),('325','2014-03-09','11:10:00',4.51),('325','2014-03-09','11:15:00',4.64),('325','2014-03-09','11:20:00',3.27),('325','2014-03-09','11:25:00',1.93),('325','2014-03-09','11:30:00',1.37),('325','2014-03-09','11:35:00',2.07),('325','2014-03-09','11:40:00',1.91),('325','2014-03-09','11:45:00',1.75),('325','2014-03-09','11:50:00',3.43),('325','2014-03-09','11:55:00',3.16),('325','2014-03-09','12:00:00',4.27),('325','2014-03-09','12:05:00',4.6),('325','2014-03-09','12:10:00',4.93),('325','2014-03-09','12:15:00',4.84),('325','2014-03-09','12:20:00',4.77),('325','2014-03-09','12:25:00',4.68),('325','2014-03-09','12:30:00',4.73),('325','2014-03-09','12:35:00',4.86),('325','2014-03-09','12:40:00',4.61),('325','2014-03-09','12:45:00',4.5),('325','2014-03-09','12:50:00',4.52),('325','2014-03-09','12:55:00',4.57),('325','2014-03-09','13:00:00',4.65),('325','2014-03-09','13:05:00',4.64),('325','2014-03-09','13:10:00',4.25),('325','2014-03-09','13:15:00',4.41),('325','2014-03-09','13:20:00',4.38),('325','2014-03-09','13:25:00',3.99),('325','2014-03-09','13:30:00',4),('325','2014-03-09','13:35:00',3.8),('325','2014-03-09','13:40:00',1.46),('325','2014-03-09','13:45:00',2.19),('325','2014-03-09','13:50:00',2.64),('325','2014-03-09','13:55:00',1.47),('325','2014-03-09','14:00:00',1.68),('325','2014-03-09','14:05:00',3.67),('325','2014-03-09','14:10:00',3.93),('325','2014-03-09','14:15:00',3.8),('325','2014-03-09','14:20:00',1.89),('325','2014-03-09','14:25:00',3.66),('325','2014-03-09','14:30:00',1.52),('325','2014-03-09','14:35:00',1),('325','2014-03-09','14:45:00',2.26),('325','2014-03-09','14:50:00',1.49),('325','2014-03-09','14:55:00',3.35),('325','2014-03-09','15:00:00',3.13),('325','2014-03-09','15:05:00',2.87),('325','2014-03-09','15:10:00',3.05),('325','2014-03-09','15:15:00',2.92),('325','2014-03-09','15:20:00',2.86),('325','2014-03-09','15:25:00',2.84),('325','2014-03-09','15:30:00',2.76),('325','2014-03-09','15:35:00',2.6),('325','2014-03-09','15:40:00',2.39),('325','2014-03-09','15:45:00',2.29),('325','2014-03-09','15:55:00',1.51),('325','2014-03-09','16:00:00',2.16),('325','2014-03-09','16:05:00',1.96),('325','2014-03-09','16:10:00',1.51),('325','2014-03-09','16:15:00',1.47),('325','2014-03-09','16:20:00',1.05),('325','2014-03-09','16:25:00',1.44),('325','2014-03-09','16:30:00',1.35),('325','2014-03-09','16:35:00',1.3),('325','2014-03-09','16:40:00',1.27),('325','2014-03-09','16:45:00',1.09),('325','2014-03-08','08:25:00',1.06),('325','2014-03-08','08:30:00',1.11),('325','2014-03-08','08:35:00',1.16),('325','2014-03-08','08:40:00',1.23),('325','2014-03-08','08:45:00',1.28),('325','2014-03-08','08:50:00',1.34),('325','2014-03-08','08:55:00',1.38),('325','2014-03-08','09:00:00',1.43),('325','2014-03-08','09:05:00',1.49),('325','2014-03-08','09:10:00',1.54),('325','2014-03-08','09:15:00',1.58),('325','2014-03-08','09:20:00',1.63),('325','2014-03-08','09:25:00',1.68),('325','2014-03-08','09:30:00',1.73),('325','2014-03-08','09:35:00',1.77),('325','2014-03-08','09:40:00',1.82),('325','2014-03-08','09:45:00',2.19),('325','2014-03-08','09:50:00',3.11),('325','2014-03-08','09:55:00',3.21),('325','2014-03-08','10:00:00',3.28),('325','2014-03-08','10:05:00',3.34),('325','2014-03-08','10:10:00',3.42),('325','2014-03-08','10:15:00',3.5),('325','2014-03-08','10:20:00',3.58),('325','2014-03-08','10:25:00',3.63),('325','2014-03-08','10:30:00',3.72),('325','2014-03-08','10:35:00',3.77),('325','2014-03-08','10:40:00',3.8),('325','2014-03-08','10:45:00',3.84),('325','2014-03-08','10:50:00',3.87),('325','2014-03-08','10:55:00',3.92),('325','2014-03-08','11:00:00',3.95),('325','2014-03-08','11:05:00',4.01),('325','2014-03-08','11:10:00',4.07),('325','2014-03-08','11:15:00',4.13),('325','2014-03-08','11:20:00',4.19),('325','2014-03-08','11:25:00',4.3),('325','2014-03-08','11:30:00',4.48),('325','2014-03-08','11:35:00',4.56),('325','2014-03-08','11:40:00',2.4),('325','2014-03-08','11:45:00',2.4),('325','2014-03-08','11:50:00',1.65),('325','2014-03-08','11:55:00',3.16),('325','2014-03-08','12:00:00',2.39),('325','2014-03-08','12:15:00',1.08),('325','2014-03-08','12:20:00',1.27),('325','2014-03-08','12:25:00',1.44),('325','2014-03-08','12:30:00',1.57),('325','2014-03-08','12:35:00',3.64),('325','2014-03-08','12:40:00',2.11),('325','2014-03-08','12:45:00',2.37),('325','2014-03-08','12:50:00',2.02),('325','2014-03-08','12:55:00',3.12),('325','2014-03-08','13:00:00',2.31),('325','2014-03-08','13:05:00',1.75),('325','2014-03-08','13:10:00',1.54),('325','2014-03-08','13:15:00',1.23),('325','2014-03-08','13:20:00',1.03),('325','2014-03-08','13:25:00',1.05),('325','2014-03-08','13:30:00',1.62),('325','2014-03-08','13:35:00',1.8),('325','2014-03-08','13:40:00',2.28),('325','2014-03-08','13:45:00',2.83),('325','2014-03-08','13:50:00',2.68),('325','2014-03-08','13:55:00',1.45),('325','2014-03-08','14:00:00',1.12),('325','2014-03-08','14:05:00',1.09),('325','2014-03-08','14:10:00',1.03),('325','2014-03-08','14:40:00',1.02),('325','2014-03-08','14:55:00',1.05),('325','2014-03-08','15:15:00',1.37),('325','2014-03-08','15:20:00',1.8),('325','2014-03-08','15:25:00',1.51),('325','2014-03-08','15:30:00',1.94),('325','2014-03-08','16:30:00',1.02),('325','2014-03-08','16:35:00',1.41),('325','2014-03-08','16:40:00',1.21),('325','2014-03-08','16:45:00',1.11),('325','2014-03-08','16:50:00',1.01),('325','2014-03-07','11:00:00',1.07),('325','2014-03-07','11:20:00',1.1),('325','2014-03-07','11:25:00',1.09),('325','2014-03-07','11:30:00',1.2),('325','2014-03-07','11:35:00',1.16),('325','2014-03-07','11:45:00',1.74),('325','2014-03-07','11:50:00',4.08),('325','2014-03-07','11:55:00',4.2),('325','2014-03-07','12:00:00',5.13),('325','2014-03-07','12:05:00',4.79),('325','2014-03-07','12:10:00',4.69),('325','2014-03-07','12:15:00',4.56),('325','2014-03-07','12:20:00',4.56),('325','2014-03-07','12:25:00',4.6),('325','2014-03-07','12:30:00',2.13),('325','2014-03-07','12:35:00',3.76),('325','2014-03-07','12:40:00',2.98),('325','2014-03-07','12:50:00',1.58),('325','2014-03-07','13:00:00',3.45),('325','2014-03-07','13:05:00',3.87),('325','2014-03-07','13:10:00',2.07),('325','2014-03-07','13:15:00',1.24),('325','2014-03-07','13:20:00',2.86),('325','2014-03-07','13:25:00',3.72),('325','2014-03-07','13:30:00',3.4),('325','2014-03-07','13:35:00',2.74),('325','2014-03-07','13:40:00',2.65),('325','2014-03-07','13:45:00',2.36),('325','2014-03-07','13:50:00',1.64),('325','2014-03-07','13:55:00',1.28),('325','2014-03-07','14:00:00',1.22),('325','2014-03-07','14:05:00',1.18),('325','2014-03-07','14:10:00',1.19),('325','2014-03-07','14:15:00',1.17),('325','2014-03-07','14:20:00',1.16),('325','2014-03-07','14:25:00',1.13),('325','2014-03-07','14:30:00',1.19),('325','2014-03-07','14:35:00',1.28),('325','2014-03-07','14:40:00',1.39),('325','2014-03-07','14:45:00',1.46),('325','2014-03-07','14:50:00',1.88),('325','2014-03-07','14:55:00',2.69),('325','2014-03-07','15:00:00',3.21),('325','2014-03-07','15:05:00',3.52),('325','2014-03-07','15:10:00',3.61),('325','2014-03-07','15:15:00',3.6),('325','2014-03-07','15:20:00',3.59),('325','2014-03-07','15:25:00',3.42),('325','2014-03-07','15:30:00',3.27),('325','2014-03-07','15:35:00',3.04),('325','2014-03-07','15:40:00',2.65),('325','2014-03-07','15:45:00',2.61),('325','2014-03-07','15:50:00',2.14),('325','2014-03-07','15:55:00',1.81),('325','2014-03-07','16:00:00',2.22),('325','2014-03-07','16:05:00',2.02),('325','2014-03-07','16:10:00',1.93),('325','2014-03-07','16:15:00',1.92),('325','2014-03-07','16:20:00',1.73),('325','2014-03-07','16:25:00',1.6),('325','2014-03-07','16:30:00',1.5),('325','2014-03-07','16:35:00',1.43),('325','2014-03-07','16:40:00',1.45),('325','2014-03-07','16:45:00',1.38),('325','2014-03-07','16:50:00',1.27),('325','2014-03-07','16:55:00',1.18),('325','2014-03-07','17:00:00',1.08),('325','2014-04-29','09:50:00',1.08),('325','2014-04-29','09:55:00',1.2),('325','2014-04-29','10:00:00',1.29),('325','2014-04-29','10:05:00',2.5),('325','2014-04-29','10:10:00',4.1),('325','2014-04-29','10:15:00',3.31),('325','2014-04-29','10:20:00',3.31),('325','2014-04-29','10:25:00',4.24),('325','2014-04-29','10:30:00',4),('325','2014-04-29','10:35:00',4.06),('325','2014-04-29','10:40:00',4.15),('325','2014-04-29','10:45:00',4.23),('325','2014-04-29','10:50:00',4.34),('325','2014-04-29','10:55:00',4.05),('325','2014-04-29','11:00:00',4.32),('325','2014-04-29','11:05:00',4.35),('325','2014-04-29','11:10:00',3.93),('325','2014-04-29','11:15:00',4.96),('325','2014-04-29','11:20:00',2.87),('325','2014-04-29','11:25:00',4.56),('325','2014-04-29','11:30:00',1.82),('325','2014-04-29','11:35:00',2.63),('325','2014-04-29','11:40:00',3.35),('325','2014-04-29','11:45:00',1.44),('325','2014-04-29','11:50:00',1.14),('325','2014-04-29','11:55:00',1.22),('325','2014-04-29','12:00:00',1.67),('325','2014-04-29','12:05:00',1.73),('325','2014-04-29','12:10:00',1.78),('325','2014-04-29','12:15:00',1.68),('325','2014-04-29','12:20:00',2.09),('325','2014-04-29','12:25:00',1.66),('325','2014-04-29','12:30:00',1.49),('325','2014-04-29','12:35:00',1.79),('325','2014-04-29','12:40:00',1.93),('325','2014-04-29','12:45:00',5.72),('325','2014-04-29','12:50:00',2.01),('325','2014-04-29','12:55:00',1.88),('325','2014-04-29','13:00:00',2.74),('325','2014-04-29','13:05:00',3.15),('325','2014-04-29','13:10:00',2.91),('325','2014-04-29','13:15:00',4.51),('325','2014-04-29','13:20:00',3.9),('325','2014-04-29','13:25:00',3.29),('325','2014-04-29','13:30:00',4.34),('325','2014-04-29','13:35:00',2.48),('325','2014-04-29','13:40:00',1.72),('325','2014-04-29','13:45:00',3.03),('325','2014-04-29','13:50:00',3.16),('325','2014-04-29','17:05:00',1.21),('325','2014-04-29','17:10:00',1.12),('325','2014-04-29','17:20:00',1.43),('325','2014-04-29','17:25:00',1.39),('325','2014-04-29','17:30:00',1.91),('325','2014-04-29','17:35:00',1.55),('325','2014-04-29','17:40:00',1.98),('325','2014-04-29','17:45:00',1.53),('325','2014-03-06','08:00:00',1.07),('325','2014-03-06','08:10:00',1.18),('325','2014-03-06','08:15:00',1.51),('325','2014-03-06','08:20:00',1.36),('325','2014-03-06','08:25:00',1.14),('325','2014-03-06','09:15:00',1.04),('325','2014-03-06','09:20:00',1.17),('325','2014-03-06','09:35:00',1.15),('325','2014-03-06','09:40:00',1.26),('325','2014-03-06','09:45:00',1.39),('325','2014-03-06','09:50:00',1.55),('325','2014-03-06','09:55:00',1.85),('325','2014-03-06','10:00:00',2.01),('325','2014-03-06','10:05:00',2.91),('325','2014-03-06','10:10:00',2.89),('325','2014-03-06','10:15:00',3.17),('325','2014-03-06','10:20:00',3.45),('325','2014-03-06','10:25:00',2.79),('325','2014-03-06','10:30:00',1.01),('325','2014-03-06','10:35:00',1.81),('325','2014-03-06','10:40:00',2.74),('325','2014-03-06','10:45:00',1.16),('325','2014-03-06','10:50:00',1.89),('325','2014-03-06','10:55:00',1.81),('325','2014-03-06','11:00:00',3.16),('325','2014-03-06','11:05:00',3.74),('325','2014-03-06','11:10:00',3.17),('325','2014-03-06','11:15:00',2.54),('325','2014-03-06','11:20:00',3.23),('325','2014-03-06','11:25:00',2.21),('325','2014-03-06','11:30:00',1.62),('325','2014-03-06','11:35:00',1.41),('325','2014-03-06','11:40:00',1.82),('325','2014-03-06','11:45:00',4.03),('325','2014-03-06','11:50:00',3.09),('325','2014-03-06','11:55:00',3.34),('325','2014-03-06','12:00:00',1.57),('325','2014-03-06','12:05:00',2.49),('325','2014-03-06','12:10:00',4.77),('325','2014-03-06','12:15:00',3.41),('325','2014-03-06','12:20:00',1.36),('325','2014-03-06','12:25:00',2.27),('325','2014-03-06','12:30:00',2.89),('325','2014-03-06','12:35:00',2.92),('325','2014-03-06','12:40:00',1.47),('325','2014-03-06','12:45:00',1.04),('325','2014-03-06','12:50:00',1.06),('325','2014-03-06','12:55:00',1.36),('325','2014-03-06','13:00:00',1.99),('325','2014-03-06','13:05:00',1.48),('325','2014-03-06','13:10:00',1.31),('325','2014-03-06','13:15:00',1.34),('325','2014-03-06','13:20:00',1.14),('325','2014-03-06','13:25:00',1.03),('325','2014-03-06','13:30:00',1.15),('325','2014-03-06','13:35:00',1.11),('325','2014-03-06','13:40:00',1.19),('325','2014-03-06','13:45:00',1.09),('325','2014-03-06','13:50:00',1.02),('325','2014-03-06','14:05:00',1.12),('325','2014-03-06','14:10:00',1.16),('325','2014-03-06','14:15:00',1.1),('325','2014-03-06','14:20:00',1.35),('325','2014-03-06','14:25:00',1.23),('325','2014-03-06','14:30:00',1.15),('325','2014-03-06','14:35:00',1.71),('325','2014-03-06','14:40:00',1.57),('325','2014-03-06','15:00:00',1.13),('325','2014-03-06','15:05:00',1.41),('325','2014-03-06','15:10:00',1.35),('325','2014-03-05','08:10:00',1.02),('325','2014-03-05','08:15:00',1.15),('325','2014-03-05','08:35:00',1.77),('325','2014-03-05','08:40:00',1.61),('325','2014-03-05','08:45:00',1.66),('325','2014-03-05','08:50:00',1.36),('325','2014-03-05','09:00:00',1.38),('325','2014-03-05','09:05:00',1.69),('325','2014-03-05','09:15:00',1.69),('325','2014-03-05','09:20:00',1.66),('325','2014-03-05','09:25:00',1.65),('325','2014-03-05','09:30:00',1.68),('325','2014-03-05','09:35:00',1.54),('325','2014-03-05','09:40:00',1.79),('325','2014-03-05','09:45:00',1.83),('325','2014-03-05','09:50:00',2.8),('325','2014-03-05','09:55:00',3.24),('325','2014-03-05','10:00:00',3.33),('325','2014-03-05','10:05:00',3.39),('325','2014-03-05','10:10:00',3.49),('325','2014-03-05','10:15:00',3.54),('325','2014-03-05','10:20:00',3.61),('325','2014-03-05','10:25:00',3.66),('325','2014-03-05','10:30:00',3.71),('325','2014-03-05','10:35:00',3.75),('325','2014-03-05','10:40:00',3.78),('325','2014-03-05','10:45:00',3.81),('325','2014-03-05','10:50:00',3.86),('325','2014-03-05','10:55:00',3.9),('325','2014-03-05','11:00:00',3.94),('325','2014-03-05','11:05:00',3.99),('325','2014-03-05','11:10:00',4.05),('325','2014-03-05','11:15:00',4.13),('325','2014-03-05','11:20:00',4.18),('325','2014-03-05','11:25:00',4.19),('325','2014-03-05','11:30:00',4.26),('325','2014-03-05','11:35:00',4.42),('325','2014-03-05','11:40:00',4.33),('325','2014-03-05','11:45:00',4.38),('325','2014-03-05','11:50:00',4.31),('325','2014-03-05','11:55:00',3.67),('325','2014-03-05','12:00:00',3.77),('325','2014-03-05','12:05:00',3.39),('325','2014-03-05','12:10:00',3.22),('325','2014-03-05','12:15:00',1.15),('325','2014-03-05','12:20:00',1.05),('325','2014-03-05','12:25:00',1.15),('325','2014-03-05','12:30:00',1.32),('325','2014-03-05','12:35:00',2.56),('325','2014-03-05','12:40:00',2.17),('325','2014-03-05','12:45:00',1.21),('325','2014-03-05','12:50:00',1.52),('325','2014-03-05','12:55:00',1.63),('325','2014-03-05','13:00:00',2.05),('325','2014-03-05','13:05:00',2.73),('325','2014-03-05','13:10:00',3.87),('325','2014-03-05','13:15:00',2.59),('325','2014-03-05','13:20:00',2.61),('325','2014-03-05','13:25:00',1.84),('325','2014-03-05','13:30:00',1.42),('325','2014-03-05','13:35:00',1.29),('325','2014-03-05','13:40:00',1.65),('325','2014-03-05','13:45:00',1.59),('325','2014-03-05','13:50:00',1.36),('325','2014-03-05','13:55:00',1.17),('325','2014-03-05','14:00:00',1.09),('325','2014-03-05','14:05:00',1.17),('325','2014-03-05','14:10:00',1.07),('325','2014-03-05','14:15:00',1.18),('325','2014-03-05','14:20:00',1.29),('325','2014-03-05','14:25:00',1.5),('325','2014-03-05','14:30:00',1.54),('325','2014-03-05','14:35:00',1.29),('325','2014-03-05','14:40:00',1.89),('325','2014-03-05','14:45:00',3.32),('325','2014-03-05','14:50:00',3.07),('325','2014-03-05','14:55:00',2.37),('325','2014-03-05','15:00:00',1.08),('325','2014-03-05','15:35:00',1.24),('325','2014-03-05','15:40:00',1.71),('325','2014-03-05','15:45:00',2.25),('325','2014-03-05','15:50:00',1.41),('325','2014-03-05','15:55:00',2.03),('325','2014-03-05','16:00:00',3.08),('325','2014-03-05','16:05:00',2.82),('325','2014-03-05','16:10:00',2.42),('325','2014-03-05','16:15:00',1.69),('325','2014-03-04','09:05:00',1.07),('325','2014-03-04','09:10:00',1.35),('325','2014-03-04','09:15:00',1.91),('325','2014-03-04','09:20:00',1.78),('325','2014-03-04','09:30:00',1.01),('325','2014-03-04','09:40:00',1.11),('325','2014-03-04','09:55:00',1.79),('325','2014-03-04','10:00:00',1.26),('325','2014-03-04','10:20:00',1.09),('325','2014-03-04','10:25:00',2.88),('325','2014-03-04','10:30:00',1.77),('325','2014-03-04','10:35:00',4.32),('325','2014-03-04','10:40:00',4.7),('325','2014-03-04','10:45:00',4.45),('325','2014-03-04','10:50:00',1.36),('325','2014-03-04','10:55:00',3.9),('325','2014-03-04','11:00:00',2.28),('325','2014-03-04','11:05:00',2.85),('325','2014-03-04','11:10:00',4.88),('325','2014-03-04','11:15:00',5.16),('325','2014-03-04','11:20:00',2.66),('325','2014-03-04','11:40:00',1.01),('325','2014-03-04','11:45:00',1.98),('325','2014-03-04','11:50:00',5.34),('325','2014-03-04','11:55:00',4.64),('325','2014-03-04','12:00:00',4.49),('325','2014-03-04','12:05:00',4.4),('325','2014-03-04','12:10:00',4.42),('325','2014-03-04','12:15:00',4.38),('325','2014-03-04','12:20:00',4.42),('325','2014-03-04','12:25:00',4.41),('325','2014-03-04','12:30:00',4.32),('325','2014-03-04','12:35:00',4.3),('325','2014-03-04','12:40:00',4.33),('325','2014-03-04','12:45:00',2.37),('325','2014-03-04','12:50:00',3.63),('325','2014-03-04','12:55:00',3.96),('325','2014-03-04','13:00:00',4.32),('325','2014-03-04','13:05:00',2.9),('325','2014-03-04','13:10:00',4.65),('325','2014-03-04','13:15:00',1.96),('325','2014-03-04','13:20:00',1.91),('325','2014-03-04','13:25:00',1.03),('325','2014-03-04','13:30:00',1.08),('325','2014-03-04','13:45:00',1.36),('325','2014-03-04','13:50:00',1.49),('325','2014-03-04','13:55:00',1.1),('325','2014-03-04','14:05:00',2.66),('325','2014-03-04','14:10:00',3.22),('325','2014-03-04','14:15:00',3.63),('325','2014-03-04','14:20:00',2.58),('325','2014-03-04','14:25:00',4),('325','2014-03-04','14:30:00',3.71),('325','2014-03-04','14:35:00',3.52),('325','2014-03-04','14:40:00',3.53),('325','2014-03-04','14:45:00',3.46),('325','2014-03-04','14:50:00',3.68),('325','2014-03-04','14:55:00',2.81),('325','2014-03-04','15:00:00',3.51),('325','2014-03-04','15:05:00',3.2),('325','2014-03-04','15:10:00',2.96),('325','2014-03-04','15:15:00',2.99),('325','2014-03-04','15:20:00',1.4),('325','2014-03-04','15:25:00',2.53),('325','2014-03-04','15:30:00',1.1),('325','2014-03-04','15:35:00',3.07),('325','2014-03-04','15:40:00',2.55),('325','2014-03-04','15:45:00',2.34),('325','2014-03-04','15:50:00',1.9),('325','2014-03-04','16:05:00',1.18),('325','2014-03-04','16:10:00',1.01),('325','2014-03-04','16:20:00',1.12),('325','2014-03-04','16:25:00',1.42),('325','2014-03-04','16:30:00',1.01),('325','2014-03-04','16:40:00',1.12),('325','2014-03-04','16:45:00',1.17),('325','2014-03-04','16:50:00',1.05),('325','2014-03-03','08:25:00',1),('325','2014-03-03','08:30:00',1.05),('325','2014-03-03','08:35:00',1.1),('325','2014-03-03','08:40:00',1.17),('325','2014-03-03','08:45:00',1.23),('325','2014-03-03','08:50:00',1.23),('325','2014-03-03','08:55:00',1.4),('325','2014-03-03','09:00:00',1.44),('325','2014-03-03','09:05:00',1.43),('325','2014-03-03','09:10:00',1.3),('325','2014-03-03','09:15:00',1.42),('325','2014-03-03','09:20:00',1.54),('325','2014-03-03','09:25:00',1.62),('325','2014-03-03','09:30:00',1.67),('325','2014-03-03','09:35:00',1.56),('325','2014-03-03','09:40:00',1.42),('325','2014-03-03','09:45:00',2.01),('325','2014-03-03','09:50:00',2.54),('325','2014-03-03','09:55:00',2.84),('325','2014-03-03','10:00:00',3.1),('325','2014-03-03','10:05:00',3.33),('325','2014-03-03','10:10:00',3.37),('325','2014-03-03','10:15:00',3.42),('325','2014-03-03','10:20:00',3.52),('325','2014-03-03','10:25:00',3.56),('325','2014-03-03','10:30:00',3.6),('325','2014-03-03','10:35:00',3.65),('325','2014-03-03','10:40:00',3.7),('325','2014-03-03','10:45:00',3.75),('325','2014-03-03','10:50:00',3.75),('325','2014-03-03','10:55:00',3.78),('325','2014-03-03','11:00:00',3.86),('325','2014-03-03','11:05:00',3.87),('325','2014-03-03','11:10:00',3.94),('325','2014-03-03','11:15:00',3.98),('325','2014-03-03','11:20:00',4.04),('325','2014-03-03','11:25:00',4.09),('325','2014-03-03','11:30:00',4.12),('325','2014-03-03','11:35:00',2.52),('325','2014-03-03','11:40:00',4.27),('325','2014-03-03','11:45:00',4.23),('325','2014-03-03','11:50:00',4.31),('325','2014-03-03','11:55:00',4.28),('325','2014-03-03','12:00:00',4.28),('325','2014-03-03','12:05:00',4.31),('325','2014-03-03','12:10:00',4.32),('325','2014-03-03','12:15:00',4.31),('325','2014-03-03','12:20:00',4.32),('325','2014-03-03','12:25:00',4.31),('325','2014-03-03','12:30:00',4.31),('325','2014-03-03','12:35:00',4.32),('325','2014-03-03','12:40:00',4.3),('325','2014-03-03','12:45:00',4.29),('325','2014-03-03','12:50:00',4.27),('325','2014-03-03','12:55:00',4.27),('325','2014-03-03','13:00:00',4.22),('325','2014-03-03','13:05:00',4.2),('325','2014-03-03','13:10:00',4.17),('325','2014-03-03','13:15:00',4.16),('325','2014-03-03','13:20:00',4.15),('325','2014-03-03','13:25:00',4.09),('325','2014-03-03','13:30:00',4.11),('325','2014-03-03','13:35:00',4.07),('325','2014-03-03','13:40:00',4.02),('325','2014-03-03','13:45:00',3.98),('325','2014-03-03','13:50:00',3.98),('325','2014-03-03','13:55:00',3.92),('325','2014-03-03','14:00:00',3.87),('325','2014-03-03','14:05:00',3.87),('325','2014-03-03','14:10:00',3.86),('325','2014-03-03','14:15:00',3.81),('325','2014-03-03','14:20:00',3.23),('325','2014-03-03','14:25:00',3.58),('325','2014-03-03','14:30:00',3.59),('325','2014-03-03','14:35:00',3.55),('325','2014-03-03','14:40:00',3.46),('325','2014-03-03','14:45:00',3.36),('325','2014-03-03','14:50:00',3.29),('325','2014-03-03','14:55:00',3.22),('325','2014-03-03','15:00:00',2.71),('325','2014-03-03','15:05:00',3.06),('325','2014-03-03','15:10:00',2.99),('325','2014-03-03','15:15:00',2.91),('325','2014-03-03','15:20:00',2.83),('325','2014-03-03','15:25:00',2.75),('325','2014-03-03','15:30:00',2.66),('325','2014-03-03','15:35:00',2.53),('325','2014-03-03','15:40:00',2.39),('325','2014-03-03','15:45:00',2.33),('325','2014-03-03','15:50:00',2.23),('325','2014-03-03','15:55:00',2.12),('325','2014-03-03','16:00:00',2),('325','2014-03-03','16:05:00',1.91),('325','2014-03-03','16:10:00',1.8),('325','2014-03-03','16:15:00',1.7),('325','2014-03-03','16:20:00',1.57),('325','2014-03-03','16:25:00',1.47),('325','2014-03-03','16:30:00',1.37),('325','2014-03-03','16:35:00',1.27),('325','2014-03-03','16:40:00',1.15),('325','2014-03-03','16:45:00',1.03),('325','2014-03-02','08:10:00',1.37),('325','2014-03-02','08:15:00',1.23),('325','2014-03-02','08:20:00',1.21),('325','2014-03-02','08:25:00',1.09),('325','2014-03-02','08:30:00',1.06),('325','2014-03-02','08:35:00',1.11),('325','2014-03-02','08:40:00',1.18),('325','2014-03-02','08:45:00',1.24),('325','2014-03-02','08:50:00',1.31),('325','2014-03-02','08:55:00',1.36),('325','2014-03-02','09:00:00',1.42),('325','2014-03-02','09:05:00',1.5),('325','2014-03-02','09:10:00',1.62),('325','2014-03-02','09:15:00',1.68),('325','2014-03-02','09:20:00',1.37),('325','2014-03-02','09:25:00',1.91),('325','2014-03-02','09:30:00',2.02),('325','2014-03-02','09:35:00',2.03),('325','2014-03-02','09:40:00',1.79),('325','2014-03-02','09:55:00',1.32),('325','2014-03-02','10:00:00',1.6),('325','2014-03-02','10:05:00',1.66),('325','2014-03-02','10:10:00',1.35),('325','2014-03-02','10:15:00',1.33),('325','2014-03-02','10:20:00',1.39),('325','2014-03-02','10:25:00',1.73),('325','2014-03-02','10:30:00',1.84),('325','2014-03-02','10:35:00',3.43),('325','2014-03-02','10:40:00',3.13),('325','2014-03-02','10:45:00',1.06),('325','2014-03-02','10:50:00',2.22),('325','2014-03-02','10:55:00',2.01),('325','2014-03-02','11:00:00',3.51),('325','2014-03-02','11:05:00',3.35),('325','2014-03-02','11:10:00',1.63),('325','2014-03-02','11:15:00',1.37),('325','2014-03-02','11:20:00',1.93),('325','2014-03-02','11:25:00',2.05),('325','2014-03-02','11:30:00',2.64),('325','2014-03-02','11:35:00',2.96),('325','2014-03-02','11:40:00',2.56),('325','2014-03-02','11:45:00',5.33),('325','2014-03-02','11:50:00',5.05),('325','2014-03-02','11:55:00',4.76),('325','2014-03-02','12:00:00',4.05),('325','2014-03-02','12:05:00',2.43),('325','2014-03-02','12:10:00',1.82),('325','2014-03-02','12:15:00',2.7),('325','2014-03-02','12:20:00',2.37),('325','2014-03-02','12:25:00',2.41),('325','2014-03-02','12:30:00',1.41),('325','2014-03-02','12:35:00',1.14),('325','2014-03-02','12:50:00',1.09),('325','2014-03-02','12:55:00',1.3),('325','2014-03-02','13:00:00',1.42),('325','2014-03-02','13:05:00',1.47),('325','2014-03-02','13:10:00',1.39),('325','2014-03-02','13:15:00',1.2),('325','2014-03-02','13:20:00',1.11),('325','2014-03-02','13:25:00',1.08),('325','2014-03-02','13:30:00',1.06),('325','2014-03-02','13:50:00',1.02),('325','2014-03-02','13:55:00',1.1),('325','2014-03-02','14:00:00',1.3),('325','2014-03-02','14:05:00',1.38),('325','2014-03-02','14:10:00',1.29),('325','2014-03-02','14:15:00',1.24),('325','2014-03-02','14:20:00',1.14),('325','2014-03-02','14:25:00',1.15),('325','2014-03-02','14:30:00',1.21),('325','2014-03-02','14:35:00',1.23),('325','2014-03-02','14:40:00',1.23),('325','2014-03-02','14:45:00',1.29),('325','2014-03-02','14:50:00',1.31),('325','2014-03-02','14:55:00',1.28),('325','2014-03-02','15:00:00',1.34),('325','2014-03-02','15:05:00',1.43),('325','2014-03-02','15:10:00',1.51),('325','2014-03-02','15:15:00',1.5),('325','2014-03-02','15:20:00',1.5),('325','2014-03-02','15:25:00',1.47),('325','2014-03-02','15:30:00',1.53),('325','2014-03-02','15:35:00',1.44),('325','2014-03-02','15:40:00',1.51),('325','2014-03-02','15:45:00',1.25),('325','2014-03-02','15:50:00',1.09),('325','2014-02-28','08:20:00',1.34),('325','2014-02-28','08:35:00',1.54),('325','2014-02-28','09:15:00',1.16),('325','2014-02-28','09:20:00',1.12),('325','2014-02-28','09:25:00',1.35),('325','2014-02-28','09:30:00',1.46),('325','2014-02-28','09:40:00',1.88),('325','2014-02-28','09:45:00',2.16),('325','2014-02-28','09:50:00',2.57),('325','2014-02-28','09:55:00',1.83),('325','2014-02-28','10:00:00',1.13),('325','2014-02-28','10:05:00',1.26),('325','2014-02-28','10:10:00',1.6),('325','2014-02-28','10:15:00',1.26),('325','2014-02-28','10:20:00',2.42),('325','2014-02-28','10:25:00',3.43),('325','2014-02-28','10:30:00',4.2),('325','2014-02-28','10:35:00',2.58),('325','2014-02-28','10:40:00',1.27),('325','2014-02-28','11:15:00',1.12),('325','2014-02-28','11:20:00',1.41),('325','2014-02-28','11:25:00',1.34),('325','2014-02-28','11:30:00',1.07),('325','2014-02-28','11:50:00',1.12),('325','2014-02-28','11:55:00',1.24),('325','2014-02-28','12:00:00',1.61),('325','2014-02-28','12:05:00',2.35),('325','2014-02-28','12:10:00',1.91),('325','2014-02-28','12:15:00',1.07),('325','2014-02-28','12:20:00',1.04),('325','2014-02-28','12:25:00',2.37),('325','2014-02-28','12:30:00',2.26),('325','2014-02-28','12:35:00',4.85),('325','2014-02-28','12:40:00',2.88),('325','2014-02-28','12:45:00',1.49),('325','2014-02-28','12:50:00',3.94),('325','2014-02-28','12:55:00',1.73),('325','2014-02-28','13:00:00',2.9),('325','2014-02-28','13:05:00',1.81),('325','2014-02-28','13:10:00',1.54),('325','2014-02-28','13:45:00',1.39),('325','2014-02-28','13:50:00',5.13),('325','2014-02-28','13:55:00',2.47),('325','2014-02-28','14:00:00',1.42),('325','2014-02-28','14:15:00',1.23),('325','2014-02-28','14:20:00',1.61),('325','2014-02-28','14:25:00',2.39),('325','2014-02-28','14:30:00',2.06),('325','2014-02-28','14:35:00',1.58),('325','2014-02-28','14:40:00',1.45),('325','2014-02-28','14:45:00',1.4),('325','2014-02-28','14:50:00',1.51),('325','2014-02-28','14:55:00',1.65),('325','2014-02-28','15:00:00',2.34),('325','2014-02-28','15:05:00',1.85),('325','2014-02-28','15:25:00',2.92),('325','2014-02-28','15:30:00',2.05),('325','2014-02-28','15:35:00',1.9),('325','2014-02-28','15:40:00',1.98),('325','2014-02-28','15:45:00',1.34),('325','2014-02-28','16:10:00',1.44),('325','2014-02-28','16:15:00',2.29),('325','2014-02-28','16:20:00',1.63),('325','2014-02-28','16:35:00',1.11),('325','2014-02-28','16:40:00',1.45),('325','2014-02-28','16:45:00',1.56),('325','2014-02-28','16:50:00',1.28),('325','2014-02-27','10:40:00',1.19),('325','2014-02-27','10:45:00',1.27),('325','2014-02-27','10:50:00',1.32),('325','2014-02-27','10:55:00',1.44),('325','2014-02-27','11:00:00',1.65),('325','2014-02-27','11:05:00',1.8),('325','2014-02-27','11:10:00',1.67),('325','2014-02-27','11:15:00',1.65),('325','2014-02-27','11:20:00',1.45),('325','2014-02-27','11:25:00',1.76),('325','2014-02-27','11:30:00',2.09),('325','2014-02-27','11:35:00',1.81),('325','2014-02-27','11:40:00',1.49),('325','2014-02-27','11:45:00',1.24),('325','2014-02-27','11:50:00',1.28),('325','2014-02-27','11:55:00',1.32),('325','2014-02-27','12:00:00',1.28),('325','2014-02-27','12:05:00',1.23),('325','2014-02-27','12:10:00',1.14),('325','2014-02-27','12:15:00',1.24),('325','2014-02-27','12:20:00',1.3),('325','2014-02-27','12:25:00',1.31),('325','2014-02-27','12:30:00',1.22),('325','2014-02-27','12:35:00',1.18),('325','2014-02-27','12:40:00',1.16),('325','2014-02-27','12:45:00',1.15),('325','2014-02-27','12:50:00',1.15),('325','2014-02-27','12:55:00',1.2),('325','2014-02-27','13:00:00',1.27),('325','2014-02-27','13:05:00',1.17),('325','2014-02-27','13:10:00',1.24),('325','2014-02-27','13:15:00',1.33),('325','2014-02-27','13:20:00',1.32),('325','2014-02-27','13:25:00',1.4),('325','2014-02-27','13:30:00',1.66),('325','2014-02-27','13:35:00',1.78),('325','2014-02-27','13:40:00',1.84),('325','2014-02-27','13:45:00',1.85),('325','2014-02-27','13:50:00',1.87),('325','2014-02-27','13:55:00',2.18),('325','2014-02-27','14:00:00',2.23),('325','2014-02-27','14:05:00',1.88),('325','2014-02-27','14:10:00',1.72),('325','2014-02-27','14:15:00',1.56),('325','2014-02-27','14:20:00',1.53),('325','2014-02-27','14:25:00',1.51),('325','2014-02-27','14:30:00',1.64),('325','2014-02-27','14:35:00',1.44),('325','2014-02-27','14:40:00',1.27),('325','2014-02-27','14:45:00',1.37),('325','2014-02-27','14:50:00',1.3),('325','2014-02-27','14:55:00',1.21),('325','2014-02-27','15:00:00',1.29),('325','2014-02-27','15:05:00',1.28),('325','2014-02-27','15:10:00',1.35),('325','2014-02-27','15:15:00',1.58),('325','2014-02-27','15:20:00',1.69),('325','2014-02-27','15:25:00',1.45),('325','2014-02-27','15:30:00',1.45),('325','2014-02-27','15:35:00',1.42),('325','2014-02-27','15:40:00',1.08),('325','2014-02-27','16:40:00',1.16),('325','2014-02-27','16:45:00',1.31),('325','2014-02-27','16:50:00',1.33),('325','2014-02-27','16:55:00',1.19),('325','2014-02-26','08:30:00',1.03),('325','2014-02-26','08:35:00',1.12),('325','2014-02-26','08:40:00',1.21),('325','2014-02-26','08:45:00',1.43),('325','2014-02-26','08:50:00',1.19),('325','2014-02-26','08:55:00',1.36),('325','2014-02-26','09:00:00',1.38),('325','2014-02-26','09:05:00',1.38),('325','2014-02-26','09:10:00',1.47),('325','2014-02-26','09:15:00',1.56),('325','2014-02-26','09:20:00',1.68),('325','2014-02-26','09:25:00',1.97),('325','2014-02-26','09:30:00',1.97),('325','2014-02-26','09:35:00',1.8),('325','2014-02-26','09:40:00',1.62),('325','2014-02-26','09:45:00',1.56),('325','2014-02-26','09:50:00',1.74),('325','2014-02-26','09:55:00',1.32),('325','2014-02-26','10:00:00',1.28),('325','2014-02-26','11:00:00',1.06),('325','2014-02-26','11:05:00',1.08),('325','2014-02-26','11:10:00',1.05),('325','2014-02-26','11:50:00',1.22),('325','2014-02-26','11:55:00',1.33),('325','2014-02-26','12:00:00',1.49),('325','2014-02-26','12:05:00',1.36),('325','2014-02-26','12:10:00',1.39),('325','2014-02-26','12:15:00',1.26),('325','2014-02-26','12:20:00',1.97),('325','2014-02-26','12:25:00',3.33),('325','2014-02-26','12:30:00',3.05),('325','2014-02-26','12:35:00',3.2),('325','2014-02-26','12:40:00',4.27),('325','2014-02-26','12:45:00',4.32),('325','2014-02-26','12:50:00',3.76),('325','2014-02-26','12:55:00',4.11),('325','2014-02-26','13:00:00',3.19),('325','2014-02-26','13:05:00',3.26),('325','2014-02-26','13:10:00',3.45),('325','2014-02-26','13:15:00',3.11),('325','2014-02-26','13:20:00',3.06),('325','2014-02-26','13:25:00',2.29),('325','2014-02-26','13:30:00',2.82),('325','2014-02-26','13:35:00',3.31),('325','2014-02-26','13:40:00',2.7),('325','2014-02-26','13:45:00',1.53),('325','2014-02-26','13:50:00',1.45),('325','2014-02-26','13:55:00',3.55),('325','2014-02-26','14:00:00',3.95),('325','2014-02-26','14:05:00',2),('325','2014-02-26','14:10:00',1.28),('325','2014-02-26','14:15:00',2.73),('325','2014-02-26','14:20:00',2.69),('325','2014-02-26','14:25:00',2.82),('325','2014-02-26','14:35:00',3.19),('325','2014-02-26','14:40:00',3.52),('325','2014-02-26','14:45:00',3.4),('325','2014-02-26','14:50:00',3.44),('325','2014-02-26','14:55:00',3.34),('325','2014-02-26','15:00:00',2.82),('325','2014-02-26','15:05:00',2.93),('325','2014-02-26','15:10:00',2.26),('325','2014-02-26','15:15:00',2.41),('325','2014-02-26','15:20:00',1.58),('325','2014-02-26','15:25:00',1.24),('325','2014-02-26','15:30:00',1.47),('325','2014-02-26','15:35:00',1.92),('325','2014-02-26','15:40:00',1.96),('325','2014-02-26','15:45:00',1.43),('325','2014-02-26','15:50:00',1.51),('325','2014-02-26','15:55:00',1.71),('325','2014-02-26','16:00:00',1.96),('325','2014-02-26','16:05:00',1.77),('325','2014-02-26','16:10:00',1.04),('325','2014-02-26','16:15:00',1.07),('325','2014-02-25','08:40:00',1.05),('325','2014-02-25','08:45:00',1.11),('325','2014-02-25','08:50:00',1.16),('325','2014-02-25','08:55:00',1.21),('325','2014-02-25','09:00:00',1.26),('325','2014-02-25','09:05:00',1.32),('325','2014-02-25','09:10:00',1.36),('325','2014-02-25','09:15:00',1.4),('325','2014-02-25','09:20:00',1.44),('325','2014-02-25','09:25:00',1.49),('325','2014-02-25','09:30:00',1.53),('325','2014-02-25','09:35:00',1.57),('325','2014-02-25','09:40:00',1.61),('325','2014-02-25','09:45:00',1.65),('325','2014-02-25','09:50:00',1.69),('325','2014-02-25','09:55:00',2.64),('325','2014-02-25','10:00:00',2.96),('325','2014-02-25','10:05:00',3.05),('325','2014-02-25','10:10:00',3.09),('325','2014-02-25','10:15:00',3.16),('325','2014-02-25','10:20:00',3.23),('325','2014-02-25','10:25:00',3.33),('325','2014-02-25','10:30:00',3.39),('325','2014-02-25','10:35:00',3.42),('325','2014-02-25','10:40:00',3.45),('325','2014-02-25','10:45:00',3.52),('325','2014-02-25','10:50:00',3.55),('325','2014-02-25','10:55:00',3.56),('325','2014-02-25','11:00:00',3.56),('325','2014-02-25','11:05:00',3.59),('325','2014-02-25','11:10:00',3.65),('325','2014-02-25','11:15:00',3.71),('325','2014-02-25','11:20:00',3.71),('325','2014-02-25','11:25:00',3.73),('325','2014-02-25','11:30:00',3.74),('325','2014-02-25','11:35:00',3.76),('325','2014-02-25','11:40:00',3.8),('325','2014-02-25','11:45:00',3.83),('325','2014-02-25','11:50:00',3.84),('325','2014-02-25','11:55:00',3.85),('325','2014-02-25','12:00:00',3.86),('325','2014-02-25','12:05:00',3.87),('325','2014-02-25','12:10:00',3.92),('325','2014-02-25','12:15:00',3.94),('325','2014-02-25','12:20:00',3.95),('325','2014-02-25','12:25:00',3.98),('325','2014-02-25','12:30:00',3.94),('325','2014-02-25','12:35:00',3.92),('325','2014-02-25','12:40:00',3.91),('325','2014-02-25','12:45:00',3.86),('325','2014-02-25','12:50:00',3.86),('325','2014-02-25','12:55:00',3.87),('325','2014-02-25','13:00:00',3.8),('325','2014-02-25','13:05:00',3.57),('325','2014-02-25','13:10:00',3.41),('325','2014-02-25','13:15:00',1.5),('325','2014-02-25','13:25:00',1.08),('325','2014-02-25','13:35:00',1.26),('325','2014-02-25','13:40:00',1.78),('325','2014-02-25','13:45:00',1.34),('325','2014-02-25','13:50:00',1.21),('325','2014-02-25','13:55:00',1.36),('325','2014-02-25','14:00:00',1.46),('325','2014-02-25','14:05:00',1.28),('325','2014-02-25','14:10:00',1.24),('325','2014-02-25','14:15:00',1.3),('325','2014-02-25','14:20:00',1.32),('325','2014-02-25','14:25:00',2.46),('325','2014-02-25','14:30:00',2.2),('325','2014-02-25','14:35:00',2.7),('325','2014-02-25','14:40:00',3.31),('325','2014-02-25','14:45:00',3.28),('325','2014-02-25','14:50:00',2.71),('325','2014-02-25','14:55:00',2.43),('325','2014-02-25','15:00:00',2.61),('325','2014-02-25','15:05:00',2.79),('325','2014-02-25','15:10:00',2.7),('325','2014-02-25','15:15:00',2.57),('325','2014-02-25','15:20:00',2.47),('325','2014-02-25','15:25:00',2.11),('325','2014-02-25','15:30:00',1.98),('325','2014-02-25','15:35:00',1.81),('325','2014-02-25','15:40:00',1.8),('325','2014-02-25','15:45:00',1.23),('325','2014-02-25','15:50:00',1.02),('325','2014-02-25','15:55:00',1.22),('325','2014-02-25','16:05:00',1.16),('325','2014-02-25','16:10:00',1.09),('325','2014-02-25','16:15:00',1.19),('325','2014-02-25','16:20:00',1.21),('325','2014-04-28','08:20:00',1.22),('325','2014-04-28','08:25:00',1.46),('325','2014-04-28','08:30:00',1.09),('325','2014-04-28','08:35:00',1.13),('325','2014-04-28','08:40:00',1.09),('325','2014-04-28','08:45:00',1.03),('325','2014-04-28','08:50:00',1.12),('325','2014-04-28','08:55:00',1.13),('325','2014-04-28','09:05:00',1.49),('325','2014-04-28','09:10:00',2.01),('325','2014-04-28','09:15:00',1.96),('325','2014-04-28','09:20:00',2.04),('325','2014-04-28','09:25:00',1.8),('325','2014-04-28','09:30:00',2.92),('325','2014-04-28','09:35:00',2.63),('325','2014-04-28','09:40:00',2.04),('325','2014-04-28','09:45:00',1.82),('325','2014-04-28','09:50:00',1.4),('325','2014-04-28','09:55:00',1.39),('325','2014-04-28','10:00:00',2.3),('325','2014-04-28','10:05:00',2.42),('325','2014-04-28','10:10:00',2.31),('325','2014-04-28','10:15:00',1.87),('325','2014-04-28','10:20:00',1.42),('325','2014-04-28','10:40:00',1.26),('325','2014-04-28','10:45:00',1.76),('325','2014-04-28','10:50:00',1.91),('325','2014-04-28','10:55:00',1.89),('325','2014-04-28','11:00:00',2.13),('325','2014-04-28','11:05:00',2.61),('325','2014-04-28','11:10:00',2.9),('325','2014-04-28','11:15:00',2.69),('325','2014-04-28','11:20:00',2.32),('325','2014-04-28','11:25:00',1.95),('325','2014-04-28','11:30:00',1.91),('325','2014-04-28','11:35:00',1.63),('325','2014-04-28','11:40:00',1.51),('325','2014-04-28','11:45:00',1.72),('325','2014-04-28','11:50:00',2.07),('325','2014-04-28','11:55:00',2.13),('325','2014-04-28','12:00:00',1.87),('325','2014-04-28','12:05:00',1.57),('325','2014-04-28','12:10:00',2.34),('325','2014-04-28','12:15:00',3.01),('325','2014-04-28','12:20:00',3),('325','2014-04-28','12:25:00',2.95),('325','2014-04-28','12:30:00',3.05),('325','2014-04-28','12:35:00',2.57),('325','2014-04-28','12:40:00',2.15),('325','2014-04-28','12:45:00',2.08),('325','2014-04-28','12:50:00',2.35),('325','2014-04-28','12:55:00',2.34),('325','2014-04-28','13:00:00',2.44),('325','2014-04-28','13:05:00',4.16),('325','2014-04-28','13:10:00',3.08),('325','2014-04-28','13:15:00',2.31),('325','2014-04-28','13:20:00',3.07),('325','2014-04-28','13:25:00',4.2),('325','2014-04-28','13:30:00',5.23),('325','2014-04-28','13:35:00',5.14),('325','2014-04-28','13:40:00',2.53),('325','2014-04-28','13:45:00',5.4),('325','2014-04-28','13:50:00',5),('325','2014-04-28','13:55:00',2.71),('325','2014-04-28','14:00:00',2.55),('325','2014-04-28','14:05:00',5.72),('325','2014-04-28','14:10:00',4.87),('325','2014-04-28','14:15:00',2.96),('325','2014-04-28','14:20:00',4.71),('325','2014-04-28','14:25:00',3.19),('325','2014-04-28','14:30:00',4.33),('325','2014-04-28','14:35:00',2.39),('325','2014-04-28','14:40:00',4.47),('325','2014-04-28','14:45:00',4.28),('325','2014-04-28','14:50:00',4.55),('325','2014-04-28','14:55:00',3.55),('325','2014-04-28','15:00:00',2.47),('325','2014-04-28','15:05:00',3.49),('325','2014-04-28','15:10:00',2.16),('325','2014-04-28','15:15:00',3.16),('325','2014-04-28','15:20:00',2.21),('325','2014-04-28','15:25:00',1.78),('325','2014-04-28','15:30:00',2.08),('325','2014-04-28','15:35:00',3.65),('325','2014-04-28','15:40:00',1.95),('325','2014-04-28','15:45:00',3.43),('325','2014-04-28','15:50:00',2.67),('325','2014-04-28','15:55:00',1.51),('325','2014-04-28','16:00:00',2.73),('325','2014-04-28','16:05:00',3.12),('325','2014-04-28','16:10:00',4.02),('325','2014-04-28','16:15:00',2.25),('325','2014-04-28','16:20:00',1.99),('325','2014-04-28','16:25:00',2.27),('325','2014-04-28','16:30:00',3.11),('325','2014-04-28','16:35:00',2.99),('325','2014-04-28','16:50:00',1.47),('325','2014-04-28','16:55:00',1.95),('325','2014-04-28','17:25:00',1.02),('325','2014-04-28','17:35:00',1.3),('325','2014-04-28','17:40:00',1.33),('325','2014-02-24','08:10:00',1.02),('325','2014-02-24','08:15:00',1.12),('325','2014-02-24','08:20:00',1.17),('325','2014-02-24','08:25:00',1.22),('325','2014-02-24','08:30:00',1.18),('325','2014-02-24','08:35:00',1.19),('325','2014-02-24','08:45:00',1.05),('325','2014-02-24','08:50:00',1.25),('325','2014-02-24','08:55:00',1.29),('325','2014-02-24','09:00:00',1.26),('325','2014-02-24','09:05:00',1.29),('325','2014-02-24','09:10:00',1.33),('325','2014-02-24','09:15:00',1.37),('325','2014-02-24','09:20:00',1.41),('325','2014-02-24','09:25:00',1.46),('325','2014-02-24','09:30:00',1.5),('325','2014-02-24','09:35:00',1.54),('325','2014-02-24','09:40:00',1.57),('325','2014-02-24','09:45:00',1.61),('325','2014-02-24','09:50:00',1.65),('325','2014-02-24','09:55:00',1.9),('325','2014-02-24','10:00:00',2.98),('325','2014-02-24','10:05:00',3.08),('325','2014-02-24','10:10:00',3.15),('325','2014-02-24','10:15:00',3.23),('325','2014-02-24','10:20:00',3.31),('325','2014-02-24','10:25:00',3.41),('325','2014-02-24','10:30:00',3.47),('325','2014-02-24','10:35:00',3.51),('325','2014-02-24','10:40:00',3.54),('325','2014-02-24','10:45:00',3.57),('325','2014-02-24','10:50:00',3.63),('325','2014-02-24','10:55:00',3.66),('325','2014-02-24','11:00:00',3.69),('325','2014-02-24','11:05:00',3.74),('325','2014-02-24','11:10:00',3.79),('325','2014-02-24','11:15:00',3.72),('325','2014-02-24','11:20:00',3.85),('325','2014-02-24','11:25:00',3.95),('325','2014-02-24','11:30:00',4.26),('325','2014-02-24','11:35:00',3.01),('325','2014-02-24','11:40:00',3.02),('325','2014-02-24','11:45:00',3.42),('325','2014-02-24','11:50:00',3.74),('325','2014-02-24','11:55:00',2.82),('325','2014-02-24','12:00:00',2.81),('325','2014-02-24','12:05:00',3.97),('325','2014-02-24','12:10:00',3.93),('325','2014-02-24','12:15:00',3.89),('325','2014-02-24','12:20:00',4.09),('325','2014-02-24','12:25:00',4.06),('325','2014-02-24','12:35:00',3.97),('325','2014-02-24','12:40:00',4.45),('325','2014-02-24','12:45:00',4.37),('325','2014-02-24','12:50:00',4.18),('325','2014-02-24','12:55:00',1.78),('325','2014-02-24','13:00:00',2.41),('325','2014-02-24','13:05:00',1.4),('325','2014-02-24','13:10:00',4.85),('325','2014-02-24','13:15:00',2.03),('325','2014-02-24','13:20:00',1.14),('325','2014-02-24','14:10:00',1.01),('325','2014-02-24','14:15:00',1.03),('325','2014-02-24','14:20:00',1.01),('325','2014-02-24','14:25:00',1.03),('325','2014-02-24','14:30:00',1.08),('325','2014-02-24','14:35:00',1.05),('325','2014-02-24','14:40:00',1.02),('325','2014-02-24','14:45:00',1.08),('325','2014-02-24','14:50:00',1.08),('325','2014-02-24','15:15:00',1.09),('325','2014-02-24','15:20:00',1.27),('325','2014-02-24','15:25:00',1.3),('325','2014-02-24','15:30:00',1.32),('325','2014-02-24','15:35:00',2.69),('325','2014-02-24','15:40:00',2.7),('325','2014-02-24','15:45:00',2.58),('325','2014-02-24','15:50:00',2.55),('325','2014-02-24','15:55:00',2.08),('325','2014-02-24','16:00:00',1.96),('325','2014-02-24','16:05:00',2.33),('325','2014-02-24','16:10:00',2.19),('325','2014-02-24','16:15:00',1.92),('325','2014-02-24','16:20:00',1.65),('325','2014-02-24','16:25:00',1.38),('325','2014-02-23','08:40:00',1.03),('325','2014-02-23','08:45:00',1.08),('325','2014-02-23','08:50:00',1.14),('325','2014-02-23','08:55:00',1.19),('325','2014-02-23','09:00:00',1.26),('325','2014-02-23','09:05:00',1.32),('325','2014-02-23','09:10:00',1.39),('325','2014-02-23','09:15:00',1.46),('325','2014-02-23','09:20:00',1.52),('325','2014-02-23','09:25:00',1.41),('325','2014-02-23','09:30:00',1.42),('325','2014-02-23','09:35:00',1.62),('325','2014-02-23','09:40:00',1.68),('325','2014-02-23','09:45:00',1.72),('325','2014-02-23','09:50:00',1.76),('325','2014-02-23','09:55:00',1.79),('325','2014-02-23','10:00:00',2.82),('325','2014-02-23','10:05:00',2.99),('325','2014-02-23','10:10:00',3.03),('325','2014-02-23','10:15:00',3.1),('325','2014-02-23','10:20:00',3.16),('325','2014-02-23','10:25:00',3.26),('325','2014-02-23','10:30:00',3.36),('325','2014-02-23','10:35:00',3.42),('325','2014-02-23','10:40:00',3.47),('325','2014-02-23','10:45:00',3.51),('325','2014-02-23','10:50:00',3.52),('325','2014-02-23','10:55:00',3.62),('325','2014-02-23','11:00:00',3.64),('325','2014-02-23','11:05:00',3.69),('325','2014-02-23','11:10:00',3.8),('325','2014-02-23','11:15:00',3.84),('325','2014-02-23','11:20:00',3.89),('325','2014-02-23','11:25:00',3.89),('325','2014-02-23','11:30:00',3.91),('325','2014-02-23','11:35:00',3.92),('325','2014-02-23','11:40:00',3.99),('325','2014-02-23','11:45:00',3.99),('325','2014-02-23','11:50:00',3.99),('325','2014-02-23','11:55:00',4.08),('325','2014-02-23','12:00:00',3.5),('325','2014-02-23','12:05:00',2.17),('325','2014-02-23','12:10:00',2.59),('325','2014-02-23','12:15:00',4.55),('325','2014-02-23','12:20:00',3.78),('325','2014-02-23','12:25:00',2.54),('325','2014-02-23','12:30:00',3.42),('325','2014-02-23','12:35:00',4.22),('325','2014-02-23','12:40:00',2.37),('325','2014-02-23','12:45:00',2.71),('325','2014-02-23','12:50:00',2.26),('325','2014-02-23','12:55:00',2.38),('325','2014-02-23','13:00:00',3.12),('325','2014-02-23','13:05:00',4.17),('325','2014-02-23','13:10:00',4.03),('325','2014-02-23','13:15:00',3.96),('325','2014-02-23','13:20:00',3.93),('325','2014-02-23','13:25:00',3.94),('325','2014-02-23','13:30:00',3.84),('325','2014-02-23','13:35:00',3.74),('325','2014-02-23','13:40:00',3.4),('325','2014-02-23','13:45:00',2.88),('325','2014-02-23','13:50:00',1.84),('325','2014-02-23','13:55:00',1.01),('325','2014-02-23','14:00:00',1.98),('325','2014-02-23','14:05:00',3.28),('325','2014-02-23','14:10:00',3.8),('325','2014-02-23','14:15:00',2.48),('325','2014-02-23','14:20:00',2.22),('325','2014-02-23','14:25:00',3.49),('325','2014-02-23','14:30:00',3.97),('325','2014-02-23','14:35:00',3.14),('325','2014-02-23','14:40:00',2.39),('325','2014-02-23','14:45:00',1.6),('325','2014-02-23','14:50:00',1.71),('325','2014-02-23','14:55:00',1.27),('325','2014-02-23','15:00:00',1.35),('325','2014-02-22','09:55:00',1.01),('325','2014-02-22','10:00:00',1.61),('325','2014-02-22','10:05:00',1.54),('325','2014-02-22','10:10:00',2.39),('325','2014-02-22','10:15:00',1.72),('325','2014-02-22','10:20:00',1.43),('325','2014-02-22','10:25:00',2.54),('325','2014-02-22','10:30:00',2.39),('325','2014-02-22','10:35:00',1.85),('325','2014-02-22','10:40:00',1.59),('325','2014-02-22','10:45:00',4.14),('325','2014-02-22','10:50:00',3.58),('325','2014-02-22','10:55:00',1.04),('325','2014-02-22','12:05:00',1.41),('325','2014-02-22','12:10:00',1.66),('325','2014-02-22','12:15:00',1.8),('325','2014-02-22','12:20:00',1.85),('325','2014-02-22','12:25:00',1.57),('325','2014-02-22','12:30:00',1.07),('325','2014-02-22','12:35:00',1.26),('325','2014-02-22','12:40:00',1.58),('325','2014-02-22','12:45:00',3.92),('325','2014-02-22','12:50:00',3.98),('325','2014-02-22','12:55:00',1.72),('325','2014-02-22','13:00:00',1.57),('325','2014-02-22','13:05:00',3.29),('325','2014-02-22','13:10:00',5.29),('325','2014-02-22','13:15:00',3.04),('325','2014-02-22','13:20:00',1.54),('325','2014-02-22','13:30:00',1.47),('325','2014-02-22','13:35:00',2.58),('325','2014-02-22','13:40:00',2.55),('325','2014-02-22','13:45:00',2.1),('325','2014-02-22','13:50:00',2.44),('325','2014-02-22','13:55:00',4.16),('325','2014-02-22','14:00:00',3.99),('325','2014-02-22','14:05:00',3.49),('325','2014-02-22','14:10:00',3.76),('325','2014-02-22','14:15:00',3.73),('325','2014-02-22','14:20:00',3.59),('325','2014-02-22','14:25:00',2.62),('325','2014-02-22','14:30:00',2.68),('325','2014-02-22','14:35:00',2.97),('325','2014-02-22','14:40:00',3.1),('325','2014-02-22','14:45:00',3.45),('325','2014-02-22','14:50:00',2.52),('325','2014-02-22','14:55:00',1.07),('325','2014-02-22','15:00:00',1.9),('325','2014-02-22','15:05:00',2.67),('325','2014-02-22','15:10:00',1.37),('325','2014-02-22','15:15:00',1.93),('325','2014-02-22','15:20:00',1.27),('325','2014-02-22','15:25:00',1.87),('325','2014-02-22','15:30:00',1.85),('325','2014-02-22','15:40:00',1.33),('325','2014-02-22','15:45:00',2.24),('325','2014-02-22','15:50:00',1.86),('325','2014-02-22','16:00:00',1.47),('325','2014-02-22','16:10:00',1.46),('325','2014-02-22','16:15:00',1.47),('325','2014-02-22','16:20:00',1.38),('325','2014-02-22','16:25:00',1.24),('325','2014-02-21','09:40:00',1.05),('325','2014-02-21','09:45:00',1.17),('325','2014-02-21','09:50:00',1.23),('325','2014-02-21','09:55:00',1.17),('325','2014-02-21','10:00:00',1.24),('325','2014-02-21','10:05:00',1.44),('325','2014-02-21','10:10:00',1.31),('325','2014-02-21','10:15:00',1.54),('325','2014-02-21','10:20:00',1.98),('325','2014-02-21','10:25:00',2.52),('325','2014-02-21','10:30:00',2.77),('325','2014-02-21','10:35:00',1.91),('325','2014-02-21','10:40:00',1.85),('325','2014-02-21','10:45:00',1.68),('325','2014-02-21','10:50:00',1.9),('325','2014-02-21','10:55:00',2.62),('325','2014-02-21','11:00:00',2.1),('325','2014-02-21','11:05:00',1.77),('325','2014-02-21','11:10:00',1.64),('325','2014-02-21','11:15:00',1.75),('325','2014-02-21','11:20:00',1.57),('325','2014-02-21','11:25:00',1.6),('325','2014-02-21','11:30:00',1.67),('325','2014-02-21','11:35:00',1.72),('325','2014-02-21','11:40:00',1.91),('325','2014-02-21','11:45:00',1.87),('325','2014-02-21','11:50:00',1.65),('325','2014-02-21','11:55:00',1.62),('325','2014-02-21','12:00:00',3.31),('325','2014-02-21','12:05:00',4.41),('325','2014-02-21','12:10:00',4.23),('325','2014-02-21','12:15:00',4.61),('325','2014-02-21','12:20:00',4.02),('325','2014-02-21','12:25:00',2.66),('325','2014-02-21','12:30:00',1.41),('325','2014-02-21','12:35:00',1.24),('325','2014-02-21','14:45:00',1.03),('325','2014-02-21','14:50:00',1.05),('325','2014-02-21','14:55:00',1.14),('325','2014-02-21','15:00:00',1.31),('325','2014-02-21','15:05:00',1.47),('325','2014-02-21','15:10:00',1.02),('325','2014-02-21','15:25:00',1.05),('325','2014-02-21','15:30:00',1.19),('325','2014-02-21','15:35:00',1.91),('325','2014-02-21','15:40:00',2.06),('325','2014-02-21','15:45:00',1.96),('325','2014-02-21','15:50:00',1.81),('325','2014-02-21','15:55:00',1.71),('325','2014-02-21','16:00:00',1.61),('325','2014-02-21','16:05:00',1.52),('325','2014-02-21','16:10:00',1.41),('325','2014-02-21','16:15:00',1.29),('325','2014-02-21','16:20:00',1.19),('325','2014-02-21','16:25:00',1.09),('325','2014-02-20','11:20:00',1.14),('325','2014-02-20','11:25:00',1.22),('325','2014-02-20','11:30:00',1.22),('325','2014-02-20','12:25:00',1.14),('325','2014-02-20','12:30:00',1.05),('325','2014-02-20','12:35:00',1.11),('325','2014-02-20','12:40:00',1.26),('325','2014-02-20','12:45:00',1.14),('325','2014-02-20','12:50:00',1.12),('325','2014-02-20','12:55:00',1.29),('325','2014-02-20','13:00:00',1.5),('325','2014-02-20','13:15:00',1.26),('325','2014-02-20','13:30:00',1.29),('325','2014-02-20','13:35:00',1.07),('325','2014-02-20','14:00:00',1.01),('325','2014-02-19','09:25:00',1.03),('325','2014-02-19','09:30:00',1.06),('325','2014-02-19','09:35:00',1.19),('325','2014-02-19','09:40:00',1.3),('325','2014-02-19','09:45:00',1.52),('325','2014-02-19','09:50:00',1.42),('325','2014-02-19','09:55:00',1.34),('325','2014-02-19','10:00:00',1.3),('325','2014-02-19','10:05:00',1.31),('325','2014-02-19','10:10:00',1.43),('325','2014-02-19','10:15:00',1.49),('325','2014-02-19','10:20:00',1.35),('325','2014-02-19','10:25:00',1.42),('325','2014-02-19','10:30:00',1.51),('325','2014-02-19','10:35:00',1.6),('325','2014-02-19','10:40:00',1.84),('325','2014-02-19','10:45:00',2),('325','2014-02-19','10:50:00',1.87),('325','2014-02-19','10:55:00',1.64),('325','2014-02-19','11:00:00',1.5),('325','2014-02-19','11:05:00',1.54),('325','2014-02-19','11:10:00',1.74),('325','2014-02-19','11:15:00',1.72),('325','2014-02-19','11:20:00',1.88),('325','2014-02-19','11:25:00',1.72),('325','2014-02-19','11:30:00',1.6),('325','2014-02-19','11:35:00',1.64),('325','2014-02-19','11:40:00',1.53),('325','2014-02-19','11:45:00',1.49),('325','2014-02-19','11:50:00',1.51),('325','2014-02-19','11:55:00',1.35),('325','2014-02-19','12:00:00',1.37),('325','2014-02-19','12:05:00',1.44),('325','2014-02-19','12:10:00',1.42),('325','2014-02-19','12:15:00',1.37),('325','2014-02-19','12:20:00',1.19),('325','2014-02-19','12:25:00',1.47),('325','2014-02-19','12:30:00',1.6),('325','2014-02-19','12:35:00',1.23),('325','2014-02-19','12:40:00',1.18),('325','2014-02-19','12:45:00',1.19),('325','2014-02-19','13:05:00',1.01),('325','2014-02-19','13:10:00',1.02),('325','2014-02-19','13:15:00',1.19),('325','2014-02-19','13:20:00',1.15),('325','2014-02-19','13:25:00',1.66),('325','2014-02-19','13:30:00',1.64),('325','2014-02-19','13:35:00',1.79),('325','2014-02-19','13:40:00',1.67),('325','2014-02-19','13:45:00',2.27),('325','2014-02-19','13:50:00',2.33),('325','2014-02-19','13:55:00',2.06),('325','2014-02-19','14:00:00',1.96),('325','2014-02-19','14:05:00',2.01),('325','2014-02-19','14:10:00',1.53),('325','2014-02-19','14:15:00',1.4),('325','2014-02-19','14:20:00',2.29),('325','2014-02-19','14:25:00',1.75),('325','2014-02-19','14:30:00',1.66),('325','2014-02-19','14:35:00',1.82),('325','2014-02-19','14:40:00',1.46),('325','2014-02-19','14:45:00',1.39),('325','2014-02-19','14:50:00',1.77),('325','2014-02-19','14:55:00',1.47),('325','2014-02-19','15:00:00',1.16),('325','2014-02-19','15:05:00',1.17),('325','2014-02-19','15:10:00',1.21),('325','2014-02-19','15:15:00',1.43),('325','2014-02-19','15:20:00',1.11),('325','2014-02-19','15:25:00',1.24),('325','2014-02-19','15:30:00',1.07),('325','2014-02-19','15:40:00',1.01),('325','2014-02-19','15:45:00',1.07),('325','2014-02-19','15:50:00',1.28),('325','2014-02-19','15:55:00',1.04),('325','2014-02-18','08:55:00',1.06),('325','2014-02-18','09:00:00',1.11),('325','2014-02-18','09:05:00',1.16),('325','2014-02-18','09:10:00',1.21),('325','2014-02-18','09:15:00',1.26),('325','2014-02-18','09:20:00',1.3),('325','2014-02-18','09:25:00',1.34),('325','2014-02-18','09:30:00',1.39),('325','2014-02-18','09:35:00',1.43),('325','2014-02-18','09:40:00',1.47),('325','2014-02-18','09:45:00',1.51),('325','2014-02-18','09:50:00',1.55),('325','2014-02-18','09:55:00',1.58),('325','2014-02-18','10:00:00',1.91),('325','2014-02-18','10:05:00',2.83),('325','2014-02-18','10:10:00',2.9),('325','2014-02-18','10:15:00',2.95),('325','2014-02-18','10:20:00',3.02),('325','2014-02-18','10:25:00',3.1),('325','2014-02-18','10:30:00',3.18),('325','2014-02-18','10:35:00',3.22),('325','2014-02-18','10:40:00',3.27),('325','2014-02-18','10:45:00',3.3),('325','2014-02-18','10:50:00',3.36),('325','2014-02-18','10:55:00',3.42),('325','2014-02-18','11:00:00',3.46),('325','2014-02-18','11:05:00',3.01),('325','2014-02-18','11:10:00',2.93),('325','2014-02-18','11:15:00',2.84),('325','2014-02-18','11:20:00',3.18),('325','2014-02-18','11:25:00',3.55),('325','2014-02-18','11:30:00',3.17),('325','2014-02-18','11:35:00',3.06),('325','2014-02-18','11:40:00',2.43),('325','2014-02-18','11:45:00',2.34),('325','2014-02-18','11:50:00',1.94),('325','2014-02-18','11:55:00',1.65),('325','2014-02-18','12:00:00',1.57),('325','2014-02-18','12:05:00',1.57),('325','2014-02-18','12:10:00',1.85),('325','2014-02-18','12:15:00',1.98),('325','2014-02-18','12:20:00',2),('325','2014-02-18','12:25:00',2.31),('325','2014-02-18','12:30:00',2.51),('325','2014-02-18','12:35:00',1.88),('325','2014-02-18','12:40:00',1.69),('325','2014-02-18','12:45:00',1.6),('325','2014-02-18','12:50:00',1.79),('325','2014-02-18','12:55:00',1.93),('325','2014-02-18','13:00:00',1.44),('325','2014-02-18','13:05:00',1.39),('325','2014-02-18','13:10:00',1.51),('325','2014-02-18','13:15:00',2.06),('325','2014-02-18','13:20:00',2.26),('325','2014-02-18','13:25:00',2.81),('325','2014-02-18','13:30:00',1.94),('325','2014-02-18','13:35:00',1.62),('325','2014-02-18','13:40:00',2.14),('325','2014-02-18','13:45:00',2.39),('325','2014-02-18','13:50:00',1.9),('325','2014-02-18','13:55:00',1.88),('325','2014-02-18','14:00:00',2.07),('325','2014-02-18','14:05:00',3.02),('325','2014-02-18','14:10:00',1.75),('325','2014-02-18','14:15:00',1.36),('325','2014-02-18','14:20:00',1.2),('325','2014-02-18','14:25:00',1.24),('325','2014-02-18','14:30:00',1.58),('325','2014-02-18','14:35:00',1.46),('325','2014-02-18','14:40:00',1.21),('325','2014-02-18','14:45:00',1.12),('325','2014-02-18','14:50:00',1.04),('325','2014-02-18','15:35:00',1.18),('325','2014-02-18','15:40:00',1.41),('325','2014-02-18','15:45:00',1.46),('325','2014-02-18','15:50:00',1.17),('325','2014-02-18','15:55:00',1.05),('325','2014-02-18','16:00:00',1.09),('325','2014-02-18','16:05:00',1.24),('325','2014-02-18','16:10:00',1.02),('325','2014-02-17','08:50:00',1.02),('325','2014-02-17','08:55:00',1.08),('325','2014-02-17','09:00:00',1.13),('325','2014-02-17','09:05:00',1.19),('325','2014-02-17','09:10:00',1.25),('325','2014-02-17','09:15:00',1.31),('325','2014-02-17','09:20:00',1.37),('325','2014-02-17','09:25:00',1.43),('325','2014-02-17','09:30:00',1.49),('325','2014-02-17','09:35:00',1.55),('325','2014-02-17','09:40:00',1.58),('325','2014-02-17','09:45:00',1.62),('325','2014-02-17','09:50:00',1.65),('325','2014-02-17','09:55:00',1.69),('325','2014-02-17','10:00:00',1.74),('325','2014-02-17','10:05:00',2.6),('325','2014-02-17','10:10:00',2.69),('325','2014-02-17','10:15:00',2.72),('325','2014-02-17','10:20:00',2.73),('325','2014-02-17','10:25:00',2.79),('325','2014-02-17','10:30:00',2.87),('325','2014-02-17','10:35:00',2.89),('325','2014-02-17','10:40:00',2.91),('325','2014-02-17','10:45:00',2.93),('325','2014-02-17','10:50:00',2.98),('325','2014-02-17','10:55:00',3.02),('325','2014-02-17','11:00:00',3.04),('325','2014-02-17','11:05:00',3.09),('325','2014-02-17','11:10:00',3.15),('325','2014-02-17','11:15:00',3.21),('325','2014-02-17','11:20:00',3.28),('325','2014-02-17','11:25:00',3.38),('325','2014-02-17','11:30:00',3.44),('325','2014-02-17','11:35:00',3.51),('325','2014-02-17','11:40:00',3.52),('325','2014-02-17','11:45:00',3.54),('325','2014-02-17','11:50:00',3.56),('325','2014-02-17','11:55:00',3.57),('325','2014-02-17','12:00:00',3.59),('325','2014-02-17','12:05:00',3.59),('325','2014-02-17','12:10:00',3.59),('325','2014-02-17','12:15:00',3.57),('325','2014-02-17','12:20:00',3.57),('325','2014-02-17','12:25:00',3.58),('325','2014-02-17','12:30:00',3.58),('325','2014-02-17','12:35:00',3.57),('325','2014-02-17','12:40:00',3.54),('325','2014-02-17','12:45:00',3.53),('325','2014-02-17','12:50:00',3.5),('325','2014-02-17','12:55:00',3.49),('325','2014-02-17','13:00:00',3.48),('325','2014-02-17','13:05:00',3.45),('325','2014-02-17','13:10:00',3.45),('325','2014-02-17','13:15:00',3.44),('325','2014-02-17','13:20:00',3.41),('325','2014-02-17','13:25:00',3.4),('325','2014-02-17','13:30:00',3.39),('325','2014-02-17','13:35:00',3.36),('325','2014-02-17','13:40:00',3.33),('325','2014-02-17','13:45:00',3.24),('325','2014-02-17','13:50:00',3.24),('325','2014-02-17','13:55:00',3.18),('325','2014-02-17','14:00:00',3.12),('325','2014-02-17','14:05:00',3.09),('325','2014-02-17','14:10:00',2.98),('325','2014-02-17','14:15:00',2.87),('325','2014-02-17','14:20:00',2.99),('325','2014-02-17','14:25:00',2.86),('325','2014-02-17','14:30:00',2.76),('325','2014-02-17','14:35:00',2.69),('325','2014-02-17','14:40:00',2.51),('325','2014-02-17','14:45:00',2.68),('325','2014-02-17','14:50:00',2.55),('325','2014-02-17','14:55:00',2.49),('325','2014-02-17','15:00:00',2.34),('325','2014-02-17','15:05:00',2.31),('325','2014-02-17','15:10:00',2.25),('325','2014-02-17','15:15:00',2.27),('325','2014-02-17','15:20:00',2.21),('325','2014-02-17','15:25:00',2.06),('325','2014-02-17','15:30:00',2),('325','2014-02-17','15:35:00',1.86),('325','2014-02-17','15:40:00',1.74),('325','2014-02-17','15:45:00',1.73),('325','2014-02-17','15:50:00',1.62),('325','2014-02-17','15:55:00',1.52),('325','2014-02-17','16:00:00',1.39),('325','2014-02-17','16:05:00',1.33),('325','2014-02-17','16:10:00',1.22),('325','2014-02-17','16:15:00',1.1),('325','2014-02-17','16:20:00',1.02),('325','2014-02-16','08:45:00',1.01),('325','2014-02-16','08:55:00',1.12),('325','2014-02-16','09:00:00',1.18),('325','2014-02-16','09:05:00',1.22),('325','2014-02-16','09:10:00',1.2),('325','2014-02-16','09:15:00',1),('325','2014-02-16','09:20:00',1.32),('325','2014-02-16','09:25:00',1.3),('325','2014-02-16','09:30:00',1.33),('325','2014-02-16','09:35:00',1.16),('325','2014-02-16','09:40:00',1.44),('325','2014-02-16','09:45:00',1.52),('325','2014-02-16','09:50:00',1.58),('325','2014-02-16','09:55:00',1.55),('325','2014-02-16','10:00:00',2.14),('325','2014-02-16','10:05:00',2.79),('325','2014-02-16','10:10:00',2.91),('325','2014-02-16','10:15:00',2.92),('325','2014-02-16','10:20:00',3.03),('325','2014-02-16','10:25:00',3.1),('325','2014-02-16','10:30:00',3.2),('325','2014-02-16','10:35:00',3.31),('325','2014-02-16','10:40:00',3.4),('325','2014-02-16','10:45:00',3.35),('325','2014-02-16','10:50:00',2.87),('325','2014-02-16','10:55:00',3.01),('325','2014-02-16','11:00:00',3.45),('325','2014-02-16','11:05:00',3.52),('325','2014-02-16','11:10:00',3.4),('325','2014-02-16','11:15:00',3.51),('325','2014-02-16','11:20:00',3.36),('325','2014-02-16','11:25:00',3.4),('325','2014-02-16','11:30:00',3.44),('325','2014-02-16','11:35:00',3.62),('325','2014-02-16','11:40:00',3.58),('325','2014-02-16','11:45:00',3.28),('325','2014-02-16','11:50:00',3.61),('325','2014-02-16','11:55:00',3.2),('325','2014-02-16','12:00:00',3.72),('325','2014-02-16','12:05:00',3.69),('325','2014-02-16','12:10:00',3.7),('325','2014-02-16','12:15:00',3.69),('325','2014-02-16','12:20:00',3.7),('325','2014-02-16','12:25:00',3.57),('325','2014-02-16','12:30:00',3.65),('325','2014-02-16','12:35:00',3.62),('325','2014-02-16','12:40:00',3.58),('325','2014-02-16','12:45:00',3.57),('325','2014-02-16','12:50:00',3.59),('325','2014-02-16','12:55:00',3.57),('325','2014-02-16','13:00:00',3.57),('325','2014-02-16','13:05:00',3.57),('325','2014-02-16','13:10:00',3.46),('325','2014-02-16','13:15:00',3.57),('325','2014-02-16','13:20:00',3.48),('325','2014-02-16','13:25:00',3.4),('325','2014-02-16','13:30:00',3.36),('325','2014-02-16','13:35:00',3.33),('325','2014-02-16','13:40:00',3.39),('325','2014-02-16','13:45:00',3.42),('325','2014-02-16','13:50:00',3.39),('325','2014-02-16','13:55:00',3.4),('325','2014-02-16','14:00:00',3.38),('325','2014-02-16','14:05:00',3.34),('325','2014-02-16','14:10:00',3.29),('325','2014-02-16','14:15:00',3.23),('325','2014-02-16','14:20:00',3.21),('325','2014-02-16','14:25:00',3.17),('325','2014-02-16','14:30:00',3.11),('325','2014-02-16','14:35:00',3.04),('325','2014-02-16','14:40:00',2.92),('325','2014-02-16','14:45:00',2.88),('325','2014-02-16','14:50:00',2.81),('325','2014-02-16','14:55:00',2.7),('325','2014-02-16','15:00:00',2.62),('325','2014-02-16','15:05:00',2.61),('325','2014-02-16','15:10:00',2.53),('325','2014-02-16','15:15:00',2.44),('325','2014-02-16','15:20:00',2.33),('325','2014-02-16','15:25:00',2.25),('325','2014-02-16','15:30:00',2.13),('325','2014-02-16','15:35:00',1.84),('325','2014-02-16','15:40:00',1.64),('325','2014-02-16','15:45:00',1.9),('325','2014-02-16','15:50:00',1.46),('325','2014-02-16','16:15:00',1.08),('325','2014-02-16','16:20:00',1.25),('325','2014-02-16','16:25:00',1.4),('325','2014-02-16','16:30:00',1.34),('325','2014-02-16','16:35:00',1.09),('325','2014-02-15','09:00:00',1.08),('325','2014-02-15','09:05:00',1.12),('325','2014-02-15','09:10:00',1.17),('325','2014-02-15','09:15:00',1.21),('325','2014-02-15','09:20:00',1.27),('325','2014-02-15','09:25:00',1.32),('325','2014-02-15','09:30:00',1.35),('325','2014-02-15','09:35:00',1.4),('325','2014-02-15','09:40:00',1.44),('325','2014-02-15','09:45:00',1.48),('325','2014-02-15','09:50:00',1.53),('325','2014-02-15','09:55:00',1.57),('325','2014-02-15','10:00:00',2.13),('325','2014-02-15','10:05:00',2.67),('325','2014-02-15','10:10:00',2.8),('325','2014-02-15','10:15:00',2.85),('325','2014-02-15','10:20:00',2.88),('325','2014-02-15','10:25:00',2.94),('325','2014-02-15','10:30:00',2.99),('325','2014-02-15','10:35:00',3.05),('325','2014-02-15','10:40:00',3.07),('325','2014-02-15','10:45:00',3.17),('325','2014-02-15','10:50:00',3.24),('325','2014-02-15','10:55:00',3.26),('325','2014-02-15','11:00:00',3.27),('325','2014-02-15','11:05:00',3.4),('325','2014-02-15','11:10:00',3.4),('325','2014-02-15','11:15:00',1.58),('325','2014-02-15','11:20:00',1.71),('325','2014-02-15','11:25:00',3.84),('325','2014-02-15','11:30:00',3.78),('325','2014-02-15','11:35:00',2.35),('325','2014-02-15','11:40:00',4.01),('325','2014-02-15','11:45:00',3.36),('325','2014-02-15','11:50:00',3.01),('325','2014-02-15','11:55:00',1.95),('325','2014-02-15','12:00:00',2.36),('325','2014-02-15','12:05:00',1.69),('325','2014-02-15','12:10:00',3.84),('325','2014-02-15','12:15:00',3.09),('325','2014-02-15','12:20:00',3.62),('325','2014-02-15','12:25:00',1.23),('325','2014-02-15','12:30:00',2.82),('325','2014-02-15','12:35:00',4.02),('325','2014-02-15','12:40:00',3.07),('325','2014-02-15','12:45:00',4.27),('325','2014-02-15','12:50:00',4.15),('325','2014-02-15','12:55:00',2.31),('325','2014-02-15','13:00:00',3.92),('325','2014-02-15','13:05:00',3.76),('325','2014-02-15','13:10:00',4.08),('325','2014-02-15','13:15:00',3.54),('325','2014-02-15','13:20:00',3.76),('325','2014-02-15','13:25:00',3.47),('325','2014-02-15','13:30:00',3.63),('325','2014-02-15','13:35:00',3.59),('325','2014-02-15','13:40:00',3.51),('325','2014-02-15','13:45:00',3.46),('325','2014-02-15','13:50:00',3.52),('325','2014-02-15','13:55:00',3.39),('325','2014-02-15','14:00:00',3.31),('325','2014-02-15','14:05:00',3.29),('325','2014-02-15','14:10:00',3.2),('325','2014-02-15','14:15:00',3.15),('325','2014-02-15','14:20:00',3.14),('325','2014-02-15','14:25:00',3.03),('325','2014-02-15','14:30:00',2.53),('325','2014-02-15','14:35:00',2.91),('325','2014-02-15','14:40:00',2.83),('325','2014-02-15','14:45:00',2.79),('325','2014-02-15','14:50:00',2.69),('325','2014-02-15','14:55:00',2.66),('325','2014-02-15','15:00:00',2.6),('325','2014-02-15','15:05:00',2.53),('325','2014-02-15','15:10:00',2.45),('325','2014-02-15','15:15:00',2.36),('325','2014-02-15','15:20:00',2.28),('325','2014-02-15','15:25:00',2.2),('325','2014-02-15','15:30:00',2.08),('325','2014-02-15','15:35:00',1.99),('325','2014-02-15','15:40:00',1.9),('325','2014-02-15','15:45:00',1.83),('325','2014-02-15','15:50:00',1.73),('325','2014-02-15','15:55:00',1.65),('325','2014-02-15','16:00:00',1.55),('325','2014-02-15','16:05:00',1.46),('325','2014-02-15','16:10:00',1.33),('325','2014-02-15','16:15:00',1.24),('325','2014-02-15','16:20:00',1.15),('325','2014-02-15','16:25:00',1.05),('325','2014-04-27','10:00:00',1.23),('325','2014-04-27','10:05:00',1.3),('325','2014-04-27','10:10:00',1.19),('325','2014-04-27','10:15:00',1.2),('325','2014-04-27','10:20:00',1.21),('325','2014-04-27','10:25:00',1.09),('325','2014-04-27','11:00:00',1.02),('325','2014-04-27','11:05:00',1.19),('325','2014-04-27','11:10:00',1.14),('325','2014-04-27','11:15:00',1.16),('325','2014-04-27','11:35:00',1.5),('325','2014-04-27','11:40:00',1.83),('325','2014-04-27','11:45:00',4.14),('325','2014-04-27','11:50:00',3.65),('325','2014-04-27','11:55:00',2.97),('325','2014-04-27','12:00:00',2.68),('325','2014-04-27','12:05:00',3),('325','2014-04-27','12:10:00',3.19),('325','2014-04-27','12:15:00',3.46),('325','2014-04-27','12:20:00',3.08),('325','2014-04-27','12:25:00',2.99),('325','2014-04-27','12:30:00',2.6),('325','2014-04-27','12:35:00',2.77),('325','2014-04-27','12:40:00',2.47),('325','2014-04-27','12:45:00',2.88),('325','2014-04-27','12:50:00',2.16),('325','2014-04-27','12:55:00',2.38),('325','2014-04-27','13:00:00',2.74),('325','2014-04-27','13:05:00',2.2),('325','2014-04-27','13:10:00',1.91),('325','2014-04-27','13:15:00',2),('325','2014-04-27','13:20:00',2.44),('325','2014-04-27','13:25:00',2.21),('325','2014-04-27','13:30:00',2.06),('325','2014-04-27','13:35:00',1.77),('325','2014-04-27','13:40:00',1.72),('325','2014-04-27','13:45:00',1.75),('325','2014-04-27','13:50:00',1.74),('325','2014-04-27','13:55:00',1.69),('325','2014-04-27','14:00:00',2.29),('325','2014-04-27','14:05:00',2.34),('325','2014-04-27','14:10:00',1.57),('325','2014-04-27','14:15:00',1.57),('325','2014-04-27','14:20:00',1.96),('325','2014-04-27','14:25:00',2.32),('325','2014-04-27','14:30:00',2.36),('325','2014-04-27','14:35:00',2.42),('325','2014-04-27','14:40:00',2.56),('325','2014-04-27','14:45:00',2.05),('325','2014-04-27','14:50:00',1.96),('325','2014-04-27','14:55:00',2.14),('325','2014-04-27','15:00:00',2.36),('325','2014-04-27','15:05:00',3.62),('325','2014-04-27','15:10:00',4.3),('325','2014-04-27','15:15:00',3.05),('325','2014-04-27','15:20:00',1.92),('325','2014-04-27','15:25:00',1.13),('325','2014-04-27','15:35:00',1.08),('325','2014-04-27','15:40:00',1.12),('325','2014-02-14','08:50:00',1.01),('325','2014-02-14','08:55:00',1.05),('325','2014-02-14','09:00:00',1.09),('325','2014-02-14','09:05:00',1.13),('325','2014-02-14','09:15:00',1.17),('325','2014-02-14','09:20:00',1.36),('325','2014-02-14','09:25:00',1.57),('325','2014-02-14','09:30:00',1.28),('325','2014-02-14','09:35:00',1.15),('325','2014-02-14','09:45:00',1.07),('325','2014-02-14','09:50:00',1.89),('325','2014-02-14','09:55:00',1.75),('325','2014-02-14','10:00:00',1.77),('325','2014-02-14','10:05:00',2.86),('325','2014-02-14','10:10:00',3),('325','2014-02-14','10:15:00',2.18),('325','2014-02-14','10:20:00',3.23),('325','2014-02-14','10:25:00',3.19),('325','2014-02-14','10:30:00',3.24),('325','2014-02-14','10:35:00',3.04),('325','2014-02-14','10:40:00',3.29),('325','2014-02-14','10:45:00',3.48),('325','2014-02-14','10:50:00',3.48),('325','2014-02-14','10:55:00',3.48),('325','2014-02-14','11:00:00',3.53),('325','2014-02-14','11:05:00',3.58),('325','2014-02-14','11:10:00',3.62),('325','2014-02-14','11:15:00',3.65),('325','2014-02-14','11:20:00',3.71),('325','2014-02-14','11:25:00',3.75),('325','2014-02-14','11:30:00',3.8),('325','2014-02-14','11:35:00',3.79),('325','2014-02-14','11:40:00',3.82),('325','2014-02-14','11:45:00',3.83),('325','2014-02-14','11:50:00',3.83),('325','2014-02-14','11:55:00',3.87),('325','2014-02-14','12:00:00',3.43),('325','2014-02-14','12:05:00',3.9),('325','2014-02-14','12:10:00',3.94),('325','2014-02-14','12:15:00',3.87),('325','2014-02-14','12:20:00',3.9),('325','2014-02-14','12:25:00',3.89),('325','2014-02-14','12:30:00',3.88),('325','2014-02-14','12:35:00',3.89),('325','2014-02-14','12:40:00',3.85),('325','2014-02-14','12:45:00',3.83),('325','2014-02-14','12:50:00',3.8),('325','2014-02-14','12:55:00',3.79),('325','2014-02-14','13:00:00',3.8),('325','2014-02-14','13:05:00',3.79),('325','2014-02-14','13:10:00',3.77),('325','2014-02-14','13:15:00',3.76),('325','2014-02-14','13:20:00',3.71),('325','2014-02-14','13:25:00',3.69),('325','2014-02-14','13:30:00',3.63),('325','2014-02-14','13:35:00',3.62),('325','2014-02-14','13:40:00',3.55),('325','2014-02-14','13:45:00',3.52),('325','2014-02-14','13:50:00',3.49),('325','2014-02-14','13:55:00',3.45),('325','2014-02-14','14:00:00',3.41),('325','2014-02-14','14:05:00',3.36),('325','2014-02-14','14:10:00',3.31),('325','2014-02-14','14:15:00',3.22),('325','2014-02-14','14:20:00',3.16),('325','2014-02-14','14:25:00',3.11),('325','2014-02-14','14:30:00',3.06),('325','2014-02-14','14:35:00',3.01),('325','2014-02-14','14:40:00',2.94),('325','2014-02-14','14:45:00',2.84),('325','2014-02-14','14:50:00',2.77),('325','2014-02-14','14:55:00',2.68),('325','2014-02-14','15:00:00',2.59),('325','2014-02-14','15:05:00',2.55),('325','2014-02-14','15:10:00',2.48),('325','2014-02-14','15:15:00',2.4),('325','2014-02-14','15:20:00',2.31),('325','2014-02-14','15:25:00',2.22),('325','2014-02-14','15:30:00',2.09),('325','2014-02-14','15:35:00',2.01),('325','2014-02-14','15:40:00',1.9),('325','2014-02-14','15:45:00',1.8),('325','2014-02-14','15:50:00',1.7),('325','2014-02-14','15:55:00',1.59),('325','2014-02-14','16:00:00',1.53),('325','2014-02-14','16:05:00',1.43),('325','2014-02-14','16:10:00',1.27),('325','2014-02-14','16:15:00',1.19),('325','2014-02-14','16:20:00',1.1),('325','2014-02-13','08:55:00',1.03),('325','2014-02-13','09:00:00',1.08),('325','2014-02-13','09:05:00',1.15),('325','2014-02-13','09:10:00',1.19),('325','2014-02-13','09:15:00',1.22),('325','2014-02-13','09:20:00',1.28),('325','2014-02-13','09:25:00',1.33),('325','2014-02-13','09:30:00',1.38),('325','2014-02-13','09:35:00',1.42),('325','2014-02-13','09:40:00',1.47),('325','2014-02-13','09:45:00',1.51),('325','2014-02-13','09:50:00',1.53),('325','2014-02-13','09:55:00',1.57),('325','2014-02-13','10:00:00',1.91),('325','2014-02-13','10:05:00',2.71),('325','2014-02-13','10:10:00',2.84),('325','2014-02-13','10:15:00',2.87),('325','2014-02-13','10:20:00',2.93),('325','2014-02-13','10:25:00',3.01),('325','2014-02-13','10:30:00',3.09),('325','2014-02-13','10:35:00',3.15),('325','2014-02-13','10:40:00',3.14),('325','2014-02-13','10:45:00',3.2),('325','2014-02-13','10:50:00',3.28),('325','2014-02-13','10:55:00',3.32),('325','2014-02-13','11:00:00',3.33),('325','2014-02-13','11:05:00',3.36),('325','2014-02-13','11:10:00',3.4),('325','2014-02-13','11:15:00',3.55),('325','2014-02-13','11:20:00',3.71),('325','2014-02-13','11:25:00',3.66),('325','2014-02-13','11:30:00',3.72),('325','2014-02-13','11:35:00',3.89),('325','2014-02-13','11:40:00',2.4),('325','2014-02-13','11:45:00',1.81),('325','2014-02-13','11:50:00',3.52),('325','2014-02-13','11:55:00',3.67),('325','2014-02-13','12:00:00',3.43),('325','2014-02-13','12:05:00',2.35),('325','2014-02-13','12:10:00',1.58),('325','2014-02-13','12:15:00',2.92),('325','2014-02-13','12:20:00',1.77),('325','2014-02-13','12:25:00',3.82),('325','2014-02-13','12:30:00',4.14),('325','2014-02-13','12:35:00',4.31),('325','2014-02-13','12:40:00',2.23),('325','2014-02-13','12:45:00',2.09),('325','2014-02-13','12:50:00',3.05),('325','2014-02-13','12:55:00',4.02),('325','2014-02-13','13:00:00',3.94),('325','2014-02-13','13:05:00',3.86),('325','2014-02-13','13:10:00',3.83),('325','2014-02-13','13:15:00',3.78),('325','2014-02-13','13:20:00',3.76),('325','2014-02-13','13:25:00',3.72),('325','2014-02-13','13:30:00',3.69),('325','2014-02-13','13:35:00',3.64),('325','2014-02-13','13:40:00',3.61),('325','2014-02-13','13:45:00',3.57),('325','2014-02-13','13:50:00',3.56),('325','2014-02-13','13:55:00',3.5),('325','2014-02-13','14:00:00',3.45),('325','2014-02-13','14:05:00',3.4),('325','2014-02-13','14:10:00',3.34),('325','2014-02-13','14:15:00',3.28),('325','2014-02-13','14:20:00',3.25),('325','2014-02-13','14:25:00',3.17),('325','2014-02-13','14:30:00',3.11),('325','2014-02-13','14:35:00',3.09),('325','2014-02-13','14:40:00',1.74),('325','2014-02-13','14:45:00',2.65),('325','2014-02-13','14:50:00',2.79),('325','2014-02-13','14:55:00',2.78),('325','2014-02-13','15:00:00',1.9),('325','2014-02-13','15:05:00',2.81),('325','2014-02-13','15:10:00',2.75),('325','2014-02-13','15:15:00',2.37),('325','2014-02-13','15:20:00',2.53),('325','2014-02-13','15:25:00',1.04),('325','2014-02-13','15:35:00',1.26),('325','2014-02-13','15:40:00',2.15),('325','2014-02-13','15:45:00',1.98),('325','2014-02-13','15:50:00',1.58),('325','2014-02-13','16:10:00',1.4),('325','2014-02-12','09:10:00',1.09),('325','2014-02-12','09:15:00',1.26),('325','2014-02-12','09:20:00',1.14),('325','2014-02-12','09:25:00',1.27),('325','2014-02-12','09:40:00',1.6),('325','2014-02-12','09:45:00',1.79),('325','2014-02-12','09:50:00',2.03),('325','2014-02-12','09:55:00',1.03),('325','2014-02-12','10:00:00',1.18),('325','2014-02-12','10:05:00',1.6),('325','2014-02-12','10:10:00',1.4),('325','2014-02-12','10:15:00',1.16),('325','2014-02-12','10:20:00',1.13),('325','2014-02-12','10:25:00',1.22),('325','2014-02-12','10:30:00',1.52),('325','2014-02-12','10:35:00',1.54),('325','2014-02-12','10:40:00',1.58),('325','2014-02-12','10:45:00',1.88),('325','2014-02-12','10:50:00',1.47),('325','2014-02-12','10:55:00',1.49),('325','2014-02-12','11:00:00',1.6),('325','2014-02-12','11:05:00',2.25),('325','2014-02-12','11:10:00',1.65),('325','2014-02-12','11:15:00',1.54),('325','2014-02-12','11:20:00',1.55),('325','2014-02-12','11:25:00',1.71),('325','2014-02-12','11:30:00',1.93),('325','2014-02-12','11:35:00',2.51),('325','2014-02-12','11:40:00',1.27),('325','2014-02-12','12:05:00',1.06),('325','2014-02-12','12:10:00',1.3),('325','2014-02-12','12:15:00',1.41),('325','2014-02-12','12:20:00',1.4),('325','2014-02-12','12:25:00',1.43),('325','2014-02-12','12:30:00',1.46),('325','2014-02-12','12:35:00',1.4),('325','2014-02-12','12:40:00',1.39),('325','2014-02-12','12:45:00',1.57),('325','2014-02-12','12:50:00',1.73),('325','2014-02-12','12:55:00',1.88),('325','2014-02-12','13:00:00',2.35),('325','2014-02-12','13:05:00',2.35),('325','2014-02-12','13:10:00',2.3),('325','2014-02-12','13:15:00',1.48),('325','2014-02-12','13:20:00',1.47),('325','2014-02-12','13:25:00',2.12),('325','2014-02-12','13:30:00',3.06),('325','2014-02-12','13:35:00',3.41),('325','2014-02-12','13:40:00',4.01),('325','2014-02-12','13:45:00',2.74),('325','2014-02-12','13:50:00',2.37),('325','2014-02-12','13:55:00',3.34),('325','2014-02-12','14:00:00',4.11),('325','2014-02-12','14:05:00',3.74),('325','2014-02-12','14:10:00',3.51),('325','2014-02-12','14:15:00',3.53),('325','2014-02-12','14:20:00',2.58),('325','2014-02-12','14:25:00',1.83),('325','2014-02-12','14:30:00',2.19),('325','2014-02-12','14:35:00',2.74),('325','2014-02-12','14:40:00',1.96),('325','2014-02-12','14:45:00',3.37),('325','2014-02-12','14:50:00',3.13),('325','2014-02-12','14:55:00',2.76),('325','2014-02-12','15:00:00',1.99),('325','2014-02-12','15:10:00',1.69),('325','2014-02-12','15:15:00',2.08),('325','2014-02-12','15:20:00',2.37),('325','2014-02-12','15:25:00',1.62),('325','2014-02-12','15:30:00',2.4),('325','2014-02-12','15:35:00',1.95),('325','2014-02-12','15:40:00',2.03),('325','2014-02-12','15:45:00',1.3),('325','2014-02-12','15:50:00',2.06),('325','2014-02-12','16:00:00',1.26),('325','2014-02-11','09:20:00',1.08),('325','2014-02-11','09:25:00',1.19),('325','2014-02-11','09:30:00',1.2),('325','2014-02-11','09:35:00',1.24),('325','2014-02-11','09:40:00',1.19),('325','2014-02-11','09:45:00',1.21),('325','2014-02-11','09:50:00',1.26),('325','2014-02-11','09:55:00',1.23),('325','2014-02-11','10:00:00',1.12),('325','2014-02-11','10:10:00',1.35),('325','2014-02-11','10:15:00',1.55),('325','2014-02-11','10:20:00',1.83),('325','2014-02-11','10:25:00',1.9),('325','2014-02-11','10:30:00',2.25),('325','2014-02-11','10:35:00',2.62),('325','2014-02-11','10:40:00',2.42),('325','2014-02-11','10:45:00',2.38),('325','2014-02-11','10:50:00',2.52),('325','2014-02-11','10:55:00',2.26),('325','2014-02-11','11:00:00',2.36),('325','2014-02-11','11:05:00',2.14),('325','2014-02-11','11:10:00',2.37),('325','2014-02-11','11:15:00',2.26),('325','2014-02-11','11:20:00',1.51),('325','2014-02-11','11:25:00',1.84),('325','2014-02-11','11:30:00',2.2),('325','2014-02-11','11:35:00',2.15),('325','2014-02-11','11:40:00',1.9),('325','2014-02-11','11:45:00',2.4),('325','2014-02-11','11:50:00',1.39),('325','2014-02-11','11:55:00',1.27),('325','2014-02-11','12:00:00',1.38),('325','2014-02-11','12:05:00',1.83),('325','2014-02-11','12:10:00',1.83),('325','2014-02-11','12:15:00',1.78),('325','2014-02-11','12:20:00',1.86),('325','2014-02-11','12:25:00',2.53),('325','2014-02-11','12:30:00',2.43),('325','2014-02-11','12:35:00',2.18),('325','2014-02-11','12:40:00',1.54),('325','2014-02-11','12:45:00',1.85),('325','2014-02-11','12:50:00',1.42),('325','2014-02-11','12:55:00',1.85),('325','2014-02-11','13:00:00',1.88),('325','2014-02-11','13:05:00',2.47),('325','2014-02-11','13:10:00',3.16),('325','2014-02-11','13:15:00',3.06),('325','2014-02-11','13:20:00',3.53),('325','2014-02-11','13:25:00',3.14),('325','2014-02-11','13:30:00',2.88),('325','2014-02-11','13:35:00',2.69),('325','2014-02-11','13:40:00',3.16),('325','2014-02-11','13:45:00',2.39),('325','2014-02-11','13:50:00',1.83),('325','2014-02-11','13:55:00',1.43),('325','2014-02-11','14:00:00',2.02),('325','2014-02-11','14:05:00',2.49),('325','2014-02-11','14:10:00',1.64),('325','2014-02-11','14:15:00',2.36),('325','2014-02-11','14:20:00',1.72),('325','2014-02-11','14:25:00',1.55),('325','2014-02-11','14:30:00',1.53),('325','2014-02-11','14:35:00',1.44),('325','2014-02-11','14:40:00',1.14),('325','2014-02-11','14:45:00',1.19),('325','2014-02-11','15:10:00',1.03),('325','2014-02-11','15:15:00',1.51),('325','2014-02-11','15:20:00',1.5),('325','2014-02-11','15:25:00',1.22),('325','2014-02-11','16:05:00',1.03),('325','2014-02-11','16:10:00',1.05),('325','2014-02-10','12:55:00',1.02),('325','2014-02-10','13:00:00',1.3),('325','2014-02-10','13:05:00',1.04),('325','2014-02-10','13:55:00',1),('325','2014-02-10','14:00:00',1.01),('325','2014-02-10','14:30:00',1.05),('325','2014-02-10','14:35:00',1.12),('325','2014-02-10','14:40:00',1.16),('325','2014-02-10','14:45:00',1.02),('325','2014-02-09','11:25:00',1.02),('325','2014-02-09','11:30:00',1.13),('325','2014-02-09','11:35:00',1.46),('325','2014-02-09','12:25:00',1.39),('325','2014-02-09','12:30:00',1.5),('325','2014-02-09','12:45:00',2.11),('325','2014-02-09','12:55:00',2.52),('325','2014-02-09','13:00:00',2.26),('325','2014-02-09','13:05:00',3.78),('325','2014-02-09','13:10:00',2),('325','2014-02-09','13:15:00',1.5),('325','2014-02-09','13:25:00',1.06),('325','2014-02-09','13:40:00',1.92),('325','2014-02-09','13:45:00',3.61),('325','2014-02-09','13:50:00',1.68),('325','2014-02-09','13:55:00',2.44),('325','2014-02-09','14:00:00',2.01),('325','2014-02-09','14:05:00',2.55),('325','2014-02-09','14:10:00',1.98),('325','2014-02-09','14:15:00',1.39),('325','2014-02-09','14:20:00',1.16),('325','2014-02-09','14:25:00',1.93),('325','2014-02-09','14:30:00',2.15),('325','2014-02-09','14:35:00',1.98),('325','2014-02-09','14:40:00',1.28),('325','2014-02-09','14:50:00',2.11),('325','2014-02-09','14:55:00',1.05),('325','2014-02-09','15:10:00',1.15),('325','2014-02-09','15:15:00',1.7),('325','2014-02-09','15:20:00',1.94),('325','2014-02-09','15:25:00',1.87),('325','2014-02-09','15:30:00',1.06),('325','2014-02-09','15:35:00',1.36),('325','2014-02-09','15:40:00',1.27),('325','2014-02-09','15:45:00',1.49),('325','2014-02-09','15:50:00',1.49),('325','2014-02-09','15:55:00',1.31),('325','2014-02-09','16:05:00',1.13),('325','2014-02-09','16:10:00',1),('325','2014-02-08','09:45:00',1.06),('325','2014-02-08','09:50:00',1.98),('325','2014-02-08','10:15:00',1.71),('325','2014-02-08','10:20:00',1.11),('325','2014-02-08','10:25:00',1.18),('325','2014-02-08','10:30:00',2.53),('325','2014-02-08','10:35:00',2.46),('325','2014-02-08','10:40:00',1.11),('325','2014-02-08','10:45:00',1.81),('325','2014-02-08','10:50:00',2.52),('325','2014-02-08','10:55:00',2.06),('325','2014-02-08','11:00:00',2.42),('325','2014-02-08','11:05:00',3.68),('325','2014-02-08','11:10:00',2.08),('325','2014-02-08','11:15:00',2.84),('325','2014-02-08','11:30:00',2.74),('325','2014-02-08','11:35:00',3.73),('325','2014-02-08','11:40:00',1.47),('325','2014-02-08','11:50:00',2.68),('325','2014-02-08','11:55:00',3.58),('325','2014-02-08','12:05:00',1.88),('325','2014-02-08','12:10:00',3.27),('325','2014-02-08','12:15:00',2.76),('325','2014-02-08','12:25:00',4.03),('325','2014-02-08','12:30:00',3.28),('325','2014-02-08','12:35:00',3.01),('325','2014-02-08','12:40:00',1.94),('325','2014-02-08','12:45:00',3.93),('325','2014-02-08','12:50:00',3.33),('325','2014-02-08','12:55:00',3.23),('325','2014-02-08','13:00:00',2.31),('325','2014-02-08','13:10:00',3.19),('325','2014-02-08','13:15:00',4.58),('325','2014-02-08','13:20:00',3.87),('325','2014-02-08','13:25:00',2.84),('325','2014-02-08','13:30:00',2.16),('325','2014-02-08','13:35:00',3.01),('325','2014-02-08','13:40:00',3.28),('325','2014-02-08','13:45:00',3.77),('325','2014-02-08','13:50:00',3.39),('325','2014-02-08','13:55:00',3.5),('325','2014-02-08','14:00:00',3.48),('325','2014-02-08','14:05:00',3.46),('325','2014-02-08','14:10:00',3.19),('325','2014-02-08','14:15:00',2.29),('325','2014-02-08','14:20:00',2.36),('325','2014-02-08','14:25:00',2.61),('325','2014-02-08','14:30:00',2.45),('325','2014-02-08','14:35:00',1.57),('325','2014-02-08','14:40:00',1.64),('325','2014-02-08','14:45:00',1.17),('325','2014-02-08','14:50:00',2.95),('325','2014-02-08','14:55:00',2.67),('325','2014-02-08','15:00:00',1.22),('325','2014-02-08','15:15:00',1.27),('325','2014-02-08','15:20:00',2.2),('325','2014-02-08','15:40:00',1.77),('325','2014-02-08','15:45:00',1.99),('325','2014-02-08','15:50:00',1.36),('325','2014-02-08','16:00:00',1.24),('325','2014-02-07','09:05:00',1.04),('325','2014-02-07','09:10:00',1.09),('325','2014-02-07','09:15:00',1.14),('325','2014-02-07','09:20:00',1.18),('325','2014-02-07','09:25:00',1.23),('325','2014-02-07','09:30:00',1.27),('325','2014-02-07','09:35:00',1.31),('325','2014-02-07','09:40:00',1.34),('325','2014-02-07','09:45:00',1.38),('325','2014-02-07','09:50:00',1.42),('325','2014-02-07','09:55:00',1.46),('325','2014-02-07','10:00:00',1.52),('325','2014-02-07','10:05:00',1.62),('325','2014-02-07','10:10:00',2.64),('325','2014-02-07','10:15:00',2.88),('325','2014-02-07','10:20:00',2.93),('325','2014-02-07','10:25:00',2.36),('325','2014-02-07','10:30:00',2.49),('325','2014-02-07','10:35:00',3.24),('325','2014-02-07','10:40:00',1.92),('325','2014-02-07','10:45:00',3.15),('325','2014-02-07','10:50:00',3.09),('325','2014-02-07','10:55:00',2.7),('325','2014-02-07','11:00:00',3.73),('325','2014-02-07','11:05:00',2.84),('325','2014-02-07','11:10:00',3.87),('325','2014-02-07','11:15:00',3.91),('325','2014-02-07','11:20:00',3.67),('325','2014-02-07','11:25:00',1.59),('325','2014-02-07','11:30:00',3.8),('325','2014-02-07','11:35:00',3.79),('325','2014-02-07','11:40:00',3.81),('325','2014-02-07','11:45:00',3.27),('325','2014-02-07','11:50:00',3.63),('325','2014-02-07','11:55:00',3.56),('325','2014-02-07','12:00:00',2.5),('325','2014-02-07','12:05:00',2.79),('325','2014-02-07','12:10:00',2.17),('325','2014-02-07','12:15:00',3.95),('325','2014-02-07','12:20:00',2.86),('325','2014-02-07','12:25:00',1.25),('325','2014-02-07','12:30:00',1.58),('325','2014-02-07','12:40:00',1.85),('325','2014-02-07','12:45:00',2.63),('325','2014-02-07','12:50:00',4.37),('325','2014-02-07','12:55:00',3.79),('325','2014-02-07','13:00:00',1.22),('325','2014-02-07','13:05:00',3.46),('325','2014-02-07','13:10:00',3.31),('325','2014-02-07','13:15:00',1.12),('325','2014-02-07','13:20:00',2.13),('325','2014-02-07','13:25:00',1.01),('325','2014-02-07','13:30:00',1.42),('325','2014-02-07','13:35:00',2.57),('325','2014-02-07','13:40:00',1.4),('325','2014-02-07','13:45:00',3.58),('325','2014-02-07','13:50:00',3.85),('325','2014-02-07','13:55:00',3.73),('325','2014-02-07','14:00:00',3.49),('325','2014-02-07','14:05:00',3.46),('325','2014-02-07','14:10:00',3.39),('325','2014-02-07','14:15:00',3.33),('325','2014-02-07','14:20:00',2.6),('325','2014-02-07','14:25:00',1.42),('325','2014-02-07','14:30:00',1.9),('325','2014-02-07','14:35:00',3.33),('325','2014-02-07','14:40:00',3.05),('325','2014-02-07','14:45:00',2.74),('325','2014-02-07','14:50:00',2.84),('325','2014-02-07','14:55:00',2.72),('325','2014-02-07','15:00:00',2.59),('325','2014-02-07','15:05:00',2.5),('325','2014-02-07','15:10:00',2.39),('325','2014-02-07','15:15:00',2.28),('325','2014-02-07','15:20:00',2.26),('325','2014-02-07','15:25:00',2.02),('325','2014-02-07','15:30:00',1.64),('325','2014-02-07','15:35:00',1.94),('325','2014-02-07','15:40:00',1.84),('325','2014-02-07','15:45:00',1.73),('325','2014-02-07','15:50:00',1.63),('325','2014-02-07','15:55:00',1.53),('325','2014-02-07','16:00:00',1.42),('325','2014-02-07','16:05:00',1.3),('325','2014-02-07','16:10:00',1.21),('325','2014-02-07','16:15:00',1.12),('325','2014-02-07','16:20:00',1.01),('325','2014-02-06','08:55:00',1.15),('325','2014-02-06','09:00:00',1.42),('325','2014-02-06','09:05:00',1.59),('325','2014-02-06','09:10:00',1.48),('325','2014-02-06','09:15:00',1.36),('325','2014-02-06','09:30:00',1.1),('325','2014-02-06','09:35:00',1.4),('325','2014-02-06','09:40:00',1.37),('325','2014-02-06','09:45:00',1.44),('325','2014-02-06','09:50:00',1.47),('325','2014-02-06','09:55:00',1.51),('325','2014-02-06','10:00:00',1.54),('325','2014-02-06','10:05:00',1.59),('325','2014-02-06','10:10:00',2.66),('325','2014-02-06','10:15:00',2.83),('325','2014-02-06','10:20:00',2.88),('325','2014-02-06','10:25:00',2.82),('325','2014-02-06','10:30:00',3.04),('325','2014-02-06','10:35:00',2.62),('325','2014-02-06','10:40:00',2.8),('325','2014-02-06','10:45:00',2.52),('325','2014-02-06','10:50:00',2.43),('325','2014-02-06','10:55:00',3.06),('325','2014-02-06','11:00:00',2.48),('325','2014-02-06','11:05:00',2.24),('325','2014-02-06','11:10:00',1.73),('325','2014-02-06','11:15:00',1.76),('325','2014-02-06','11:20:00',3.86),('325','2014-02-06','11:25:00',2.17),('325','2014-02-06','11:30:00',3.91),('325','2014-02-06','11:35:00',3.73),('325','2014-02-06','11:40:00',3.69),('325','2014-02-06','11:45:00',3.71),('325','2014-02-06','11:50:00',3.74),('325','2014-02-06','11:55:00',3.76),('325','2014-02-06','12:00:00',3.77),('325','2014-02-06','12:05:00',3.84),('325','2014-02-06','12:10:00',3.81),('325','2014-02-06','12:15:00',3.8),('325','2014-02-06','12:20:00',3.8),('325','2014-02-06','12:25:00',3.76),('325','2014-02-06','12:30:00',3.76),('325','2014-02-06','12:35:00',3.38),('325','2014-02-06','12:40:00',3.83),('325','2014-02-06','12:45:00',3.78),('325','2014-02-06','12:50:00',3.73),('325','2014-02-06','12:55:00',3.72),('325','2014-02-06','13:00:00',3.72),('325','2014-02-06','13:05:00',3.06),('325','2014-02-06','13:10:00',3.79),('325','2014-02-06','13:15:00',3.71),('325','2014-02-06','13:20:00',3.69),('325','2014-02-06','13:25:00',1.87),('325','2014-02-06','13:30:00',3.42),('325','2014-02-06','13:35:00',3.58),('325','2014-02-06','13:40:00',3.55),('325','2014-02-06','13:45:00',3.47),('325','2014-02-06','13:50:00',3.48),('325','2014-02-06','13:55:00',3.43),('325','2014-02-06','14:00:00',3.3),('325','2014-02-06','14:05:00',3.03),('325','2014-02-06','14:10:00',2.67),('325','2014-02-06','14:15:00',3.12),('325','2014-02-06','14:20:00',3.1),('325','2014-02-06','14:25:00',3.11),('325','2014-02-06','14:30:00',3.05),('325','2014-02-06','14:35:00',2.96),('325','2014-02-06','14:40:00',2.58),('325','2014-02-06','14:45:00',2.97),('325','2014-02-06','14:50:00',2.8),('325','2014-02-06','14:55:00',2.64),('325','2014-02-06','15:00:00',2.58),('325','2014-02-06','15:05:00',2.49),('325','2014-02-06','15:10:00',2.39),('325','2014-02-06','15:15:00',2.29),('325','2014-02-06','15:20:00',2.24),('325','2014-02-06','15:25:00',2.04),('325','2014-02-06','15:30:00',1.93),('325','2014-02-06','15:35:00',1.86),('325','2014-02-06','15:40:00',1.76),('325','2014-02-06','15:45:00',1.67),('325','2014-02-06','15:50:00',1.57),('325','2014-02-06','15:55:00',1.46),('325','2014-02-06','16:00:00',1.36),('325','2014-02-06','16:05:00',1.25),('325','2014-02-06','16:10:00',1.16),('325','2014-02-06','16:15:00',1.06),('325','2014-02-05','10:10:00',1.01),('325','2014-02-05','10:15:00',1.88),('325','2014-02-05','10:20:00',2.6),('325','2014-02-05','10:25:00',3.17),('325','2014-02-05','10:35:00',1.12),('325','2014-02-05','10:40:00',2.15),('325','2014-02-05','10:45:00',1.44),('325','2014-02-05','10:55:00',1.13),('325','2014-02-05','11:15:00',2.73),('325','2014-02-05','11:20:00',4.3),('325','2014-02-05','11:25:00',2.84),('325','2014-02-05','11:30:00',1.31),('325','2014-02-05','12:55:00',1.39),('325','2014-02-05','13:00:00',1.11),('325','2014-02-05','13:05:00',1.36),('325','2014-02-05','13:10:00',1.86),('325','2014-02-05','13:15:00',1.5),('325','2014-02-05','13:20:00',1.8),('325','2014-02-05','13:25:00',1.91),('325','2014-02-05','13:30:00',1.84),('325','2014-02-05','13:35:00',2.17),('325','2014-02-05','13:40:00',2.26),('325','2014-02-05','13:45:00',2.04),('325','2014-02-05','13:50:00',1.8),('325','2014-02-05','13:55:00',1.21),('325','2014-02-05','14:25:00',1.21),('325','2014-02-05','14:30:00',3.36),('325','2014-02-05','14:35:00',1.85),('325','2014-04-26','09:05:00',1.01),('325','2014-04-26','09:55:00',1.32),('325','2014-04-26','10:00:00',1.44),('325','2014-04-26','10:05:00',1.34),('325','2014-04-26','10:10:00',1.29),('325','2014-04-26','10:15:00',1.34),('325','2014-04-26','10:20:00',1.59),('325','2014-04-26','10:25:00',1.7),('325','2014-04-26','10:30:00',1.92),('325','2014-04-26','10:35:00',2.35),('325','2014-04-26','10:40:00',2.09),('325','2014-04-26','10:45:00',2.21),('325','2014-04-26','10:50:00',2.41),('325','2014-04-26','10:55:00',4.09),('325','2014-04-26','11:00:00',3.95),('325','2014-04-26','11:05:00',3.8),('325','2014-04-26','11:10:00',3.54),('325','2014-04-26','11:15:00',3.12),('325','2014-04-26','11:20:00',3.43),('325','2014-04-26','11:25:00',3.29),('325','2014-04-26','11:30:00',3.41),('325','2014-04-26','11:35:00',3.33),('325','2014-04-26','11:40:00',3.17),('325','2014-04-26','11:45:00',3.39),('325','2014-04-26','11:50:00',3.44),('325','2014-04-26','11:55:00',3.24),('325','2014-04-26','12:00:00',3.28),('325','2014-04-26','12:05:00',3.55),('325','2014-04-26','12:10:00',3.25),('325','2014-04-26','12:15:00',2.17),('325','2014-04-26','12:20:00',2.96),('325','2014-04-26','12:25:00',2.94),('325','2014-04-26','12:30:00',2.56),('325','2014-04-26','12:35:00',3.86),('325','2014-04-26','12:40:00',3.83),('325','2014-04-26','12:45:00',3.18),('325','2014-04-26','12:50:00',3.85),('325','2014-04-26','12:55:00',4.72),('325','2014-04-26','13:00:00',4.71),('325','2014-04-26','13:05:00',3.31),('325','2014-04-26','13:10:00',3.64),('325','2014-04-26','13:15:00',4.66),('325','2014-04-26','13:20:00',4.86),('325','2014-04-26','13:25:00',3.47),('325','2014-04-26','13:30:00',1.72),('325','2014-04-26','13:35:00',2.34),('325','2014-04-26','13:40:00',4.95),('325','2014-04-26','13:45:00',4.76),('325','2014-04-26','13:50:00',4.59),('325','2014-04-26','13:55:00',4.69),('325','2014-04-26','14:00:00',3.38),('325','2014-04-26','14:10:00',1.09),('325','2014-04-26','14:15:00',1.14),('325','2014-04-26','14:35:00',1.54),('325','2014-04-26','14:40:00',2.17),('325','2014-02-04','09:15:00',1.03),('325','2014-02-04','09:20:00',1.14),('325','2014-02-04','09:25:00',1.28),('325','2014-02-04','09:30:00',1.44),('325','2014-02-04','09:35:00',1.2),('325','2014-02-04','09:40:00',1.64),('325','2014-02-04','09:45:00',1.5),('325','2014-02-04','09:50:00',1.54),('325','2014-02-04','09:55:00',1.08),('325','2014-02-04','10:00:00',1.55),('325','2014-02-04','10:05:00',1.85),('325','2014-02-04','10:10:00',2.33),('325','2014-02-04','10:15:00',1.75),('325','2014-02-04','10:20:00',1.38),('325','2014-02-04','10:35:00',1.02),('325','2014-02-04','10:40:00',1.28),('325','2014-02-04','10:45:00',1.53),('325','2014-02-04','10:50:00',2.43),('325','2014-02-04','10:55:00',2.85),('325','2014-02-04','11:00:00',3.79),('325','2014-02-04','11:05:00',2.06),('325','2014-02-04','11:10:00',1.33),('325','2014-02-04','11:15:00',1.16),('325','2014-02-04','11:20:00',1.46),('325','2014-02-04','11:25:00',1.2),('325','2014-02-04','11:30:00',1.25),('325','2014-02-04','11:35:00',1.09),('325','2014-02-04','11:50:00',1.86),('325','2014-02-04','11:55:00',3.09),('325','2014-02-04','12:00:00',3.11),('325','2014-02-04','12:05:00',2.11),('325','2014-02-04','12:10:00',2.36),('325','2014-02-04','12:15:00',1.64),('325','2014-02-04','12:20:00',1.7),('325','2014-02-04','12:25:00',1.31),('325','2014-02-04','12:45:00',1.21),('325','2014-02-04','12:50:00',1.12),('325','2014-02-04','12:55:00',1.12),('325','2014-02-04','13:00:00',1.3),('325','2014-02-04','13:05:00',1.29),('325','2014-02-04','13:10:00',1.24),('325','2014-02-04','13:15:00',1.41),('325','2014-02-04','13:20:00',2.78),('325','2014-02-04','13:25:00',1.91),('325','2014-02-04','13:30:00',1.29),('325','2014-02-04','13:35:00',1.11),('325','2014-02-04','13:40:00',1.04),('325','2014-02-03','09:50:00',1.02),('325','2014-02-03','10:15:00',1.11),('325','2014-02-03','10:20:00',1.03),('325','2014-02-03','10:25:00',1.06),('325','2014-02-03','10:30:00',1.07),('325','2014-02-03','10:35:00',1.08),('325','2014-02-03','10:40:00',1.15),('325','2014-02-03','10:45:00',1.19),('325','2014-02-03','10:50:00',1.16),('325','2014-02-03','10:55:00',1.13),('325','2014-02-03','11:00:00',1.04),('325','2014-02-03','11:10:00',1.01),('325','2014-02-03','11:20:00',1.05),('325','2014-02-03','11:25:00',1.19),('325','2014-02-03','11:30:00',1.32),('325','2014-02-03','11:35:00',1.37),('325','2014-02-03','11:40:00',1.39),('325','2014-02-03','11:45:00',1.43),('325','2014-02-03','11:50:00',1.38),('325','2014-02-03','11:55:00',1.27),('325','2014-02-03','12:00:00',1.13),('325','2014-02-03','12:05:00',1.05),('325','2014-02-03','12:10:00',1.03),('325','2014-02-03','12:15:00',1.11),('325','2014-02-03','12:20:00',1.12),('325','2014-02-03','12:25:00',1.03),('325','2014-02-02','12:00:00',1.02),('325','2014-02-02','12:05:00',1.03),('325','2014-02-01','11:00:00',1.23),('325','2014-02-01','11:05:00',1.05),('325','2014-02-01','11:15:00',1.01),('325','2014-02-01','11:20:00',1.82),('325','2014-02-01','11:25:00',1.37),('325','2014-02-01','11:30:00',1.48),('325','2014-02-01','11:35:00',1.82),('325','2014-02-01','11:55:00',1.63),('325','2014-02-01','12:00:00',1.37),('325','2014-02-01','12:05:00',1.28),('325','2014-02-01','12:10:00',2.32),('325','2014-02-01','12:15:00',1.67),('325','2014-02-01','12:20:00',2.74),('325','2014-02-01','12:25:00',2.16),('325','2014-02-01','12:35:00',1.17),('325','2014-02-01','12:40:00',1.48),('325','2014-02-01','12:45:00',2.36),('325','2014-02-01','12:50:00',2.53),('325','2014-02-01','12:55:00',2.12),('325','2014-02-01','13:00:00',2.01),('325','2014-02-01','13:05:00',1.41),('325','2014-01-30','09:50:00',1.23),('325','2014-01-30','09:55:00',1.65),('325','2014-01-30','10:00:00',1.47),('325','2014-01-30','10:05:00',1.24),('325','2014-01-30','10:10:00',1.69),('325','2014-01-30','10:15:00',2.52),('325','2014-01-30','10:20:00',2.15),('325','2014-01-30','10:25:00',2.57),('325','2014-01-30','10:30:00',2.81),('325','2014-01-30','10:35:00',2.88),('325','2014-01-30','10:40:00',2.95),('325','2014-01-30','10:45:00',2.59),('325','2014-01-30','10:50:00',3.16),('325','2014-01-30','10:55:00',3.64),('325','2014-01-30','11:00:00',3.7),('325','2014-01-30','11:05:00',3.33),('325','2014-01-30','11:10:00',2.88),('325','2014-01-30','11:15:00',3.06),('325','2014-01-30','11:20:00',2.03),('325','2014-01-30','11:25:00',3.15),('325','2014-01-30','11:30:00',2.62),('325','2014-01-30','11:35:00',3.08),('325','2014-01-30','11:40:00',2.6),('325','2014-01-30','11:45:00',3.37),('325','2014-01-30','11:50:00',3.45),('325','2014-01-30','11:55:00',3.43),('325','2014-01-30','12:00:00',2.92),('325','2014-01-30','12:05:00',3.65),('325','2014-01-30','12:10:00',3.81),('325','2014-01-30','12:15:00',3.44),('325','2014-01-30','12:20:00',3.79),('325','2014-01-30','12:25:00',3.11),('325','2014-01-30','12:30:00',2.93),('325','2014-01-30','12:35:00',3.04),('325','2014-01-30','12:40:00',2.94),('325','2014-01-30','12:45:00',3.51),('325','2014-01-30','12:50:00',3.5),('325','2014-01-30','12:55:00',3.41),('325','2014-01-30','13:00:00',3.58),('325','2014-01-30','13:05:00',3.75),('325','2014-01-30','13:10:00',3.22),('325','2014-01-30','13:15:00',3.51),('325','2014-01-30','13:20:00',3.08),('325','2014-01-30','13:25:00',3.27),('325','2014-01-30','13:30:00',2.66),('325','2014-01-30','13:35:00',2.39),('325','2014-01-30','13:40:00',3.03),('325','2014-01-30','13:45:00',3.4),('325','2014-01-30','13:50:00',3.13),('325','2014-01-30','13:55:00',2.77),('325','2014-01-30','14:00:00',2.75),('325','2014-01-30','14:05:00',2.55),('325','2014-01-30','14:10:00',2.56),('325','2014-01-30','14:15:00',2.26),('325','2014-01-30','14:20:00',2.02),('325','2014-01-30','14:25:00',2.17),('325','2014-01-30','14:30:00',2.26),('325','2014-01-30','14:35:00',2.13),('325','2014-01-30','14:40:00',2.47),('325','2014-01-30','14:45:00',2.34),('325','2014-01-30','14:50:00',2.48),('325','2014-01-30','14:55:00',2.37),('325','2014-01-30','15:00:00',2.27),('325','2014-01-30','15:05:00',2.21),('325','2014-01-30','15:10:00',2.11),('325','2014-01-30','15:15:00',2.03),('325','2014-01-30','15:20:00',2.04),('325','2014-01-30','15:25:00',1.97),('325','2014-01-30','15:30:00',1.78),('325','2014-01-30','15:35:00',1.75),('325','2014-01-30','15:40:00',1.54),('325','2014-01-29','09:20:00',1.19),('325','2014-01-29','09:30:00',1.27),('325','2014-01-29','09:35:00',1.77),('325','2014-01-29','09:40:00',1.54),('325','2014-01-29','09:45:00',1.71),('325','2014-01-29','09:50:00',1.59),('325','2014-01-29','09:55:00',1.62),('325','2014-01-29','10:00:00',1.28),('325','2014-01-29','10:05:00',1.31),('325','2014-01-29','10:10:00',1.76),('325','2014-01-29','10:15:00',1.76),('325','2014-01-29','10:20:00',1.33),('325','2014-01-29','10:25:00',2.81),('325','2014-01-29','10:30:00',3.4),('325','2014-01-29','10:35:00',2.62),('325','2014-01-29','10:40:00',2.43),('325','2014-01-29','10:45:00',2.19),('325','2014-01-29','10:50:00',2.26),('325','2014-01-29','10:55:00',1.95),('325','2014-01-29','11:00:00',2.07),('325','2014-01-29','11:05:00',2.35),('325','2014-01-29','11:10:00',1.95),('325','2014-01-29','11:15:00',2.01),('325','2014-01-29','11:20:00',2.2),('325','2014-01-29','11:25:00',2.36),('325','2014-01-29','11:30:00',3.21),('325','2014-01-29','11:35:00',2.32),('325','2014-01-29','11:40:00',1.15),('325','2014-01-29','11:45:00',1.13),('325','2014-01-29','12:45:00',1.37),('325','2014-01-29','12:50:00',3.33),('325','2014-01-29','12:55:00',3.69),('325','2014-01-29','13:00:00',2.41),('325','2014-01-29','13:05:00',1.57),('325','2014-01-29','13:35:00',1.96),('325','2014-01-29','13:40:00',2.96),('325','2014-01-29','13:45:00',3.23),('325','2014-01-29','13:50:00',3.29),('325','2014-01-29','13:55:00',3.19),('325','2014-01-29','14:00:00',1.44),('325','2014-01-29','15:10:00',1.07),('325','2014-01-29','15:15:00',2),('325','2014-01-29','15:20:00',1.1),('325','2014-01-28','09:10:00',1.02),('325','2014-01-28','09:15:00',1.11),('325','2014-01-28','09:20:00',1.13),('325','2014-01-28','09:25:00',1.16),('325','2014-01-28','09:30:00',1.18),('325','2014-01-28','09:35:00',1.28),('325','2014-01-28','09:40:00',1.17),('325','2014-01-28','09:45:00',1.36),('325','2014-01-28','09:50:00',1.51),('325','2014-01-28','09:55:00',1.59),('325','2014-01-28','10:00:00',1.56),('325','2014-01-28','10:05:00',1.48),('325','2014-01-28','10:10:00',1.77),('325','2014-01-28','10:15:00',2.41),('325','2014-01-28','10:20:00',2.62),('325','2014-01-28','10:25:00',2.77),('325','2014-01-28','10:30:00',2.83),('325','2014-01-28','10:35:00',2.97),('325','2014-01-28','10:40:00',3.01),('325','2014-01-28','10:45:00',2.87),('325','2014-01-28','10:50:00',2.45),('325','2014-01-28','10:55:00',2.62),('325','2014-01-28','11:00:00',2.93),('325','2014-01-28','11:05:00',1.78),('325','2014-01-28','11:10:00',2.71),('325','2014-01-28','11:15:00',1.19),('325','2014-01-28','11:25:00',2.83),('325','2014-01-28','11:30:00',1.16),('325','2014-01-28','11:35:00',2.93),('325','2014-01-28','11:40:00',3.88),('325','2014-01-28','11:45:00',2.81),('325','2014-01-28','11:55:00',1.34),('325','2014-01-28','12:00:00',3.18),('325','2014-01-28','12:05:00',3.48),('325','2014-01-28','12:10:00',2.43),('325','2014-01-28','12:15:00',3.04),('325','2014-01-28','12:20:00',1.78),('325','2014-01-28','12:25:00',1.29),('325','2014-01-28','12:30:00',1.26),('325','2014-01-28','12:35:00',1.7),('325','2014-01-28','12:40:00',1.83),('325','2014-01-28','12:45:00',2.94),('325','2014-01-28','12:50:00',2.99),('325','2014-01-28','12:55:00',3.84),('325','2014-01-28','13:00:00',3.96),('325','2014-01-28','13:05:00',3.99),('325','2014-01-28','13:10:00',2.8),('325','2014-01-28','13:15:00',3.34),('325','2014-01-28','13:20:00',3.01),('325','2014-01-28','13:25:00',3.42),('325','2014-01-28','13:30:00',3.45),('325','2014-01-28','13:35:00',3.61),('325','2014-01-28','13:40:00',3.49),('325','2014-01-28','13:45:00',3.38),('325','2014-01-28','13:50:00',3.3),('325','2014-01-28','13:55:00',3.22),('325','2014-01-28','14:00:00',3.16),('325','2014-01-28','14:05:00',3.1),('325','2014-01-28','14:10:00',3.04),('325','2014-01-28','14:15:00',3.02),('325','2014-01-28','14:20:00',2.95),('325','2014-01-28','14:25:00',2.97),('325','2014-01-28','14:30:00',2.92),('325','2014-01-28','14:35:00',2.74),('325','2014-01-28','14:40:00',2.67),('325','2014-01-28','14:45:00',2.62),('325','2014-01-28','14:50:00',2.5),('325','2014-01-28','14:55:00',2.42),('325','2014-01-28','15:00:00',2.33),('325','2014-01-28','15:05:00',2.24),('325','2014-01-28','15:10:00',2.14),('325','2014-01-28','15:15:00',2.05),('325','2014-01-28','15:20:00',1.95),('325','2014-01-28','15:25:00',1.84),('325','2014-01-28','15:30:00',1.75),('325','2014-01-28','15:35:00',1.64),('325','2014-01-28','15:40:00',1.54),('325','2014-01-28','15:45:00',1.45),('325','2014-01-28','15:50:00',1.35),('325','2014-01-28','15:55:00',1.26),('325','2014-01-28','16:00:00',1.17),('325','2014-01-28','16:05:00',1.03),('325','2014-01-27','11:05:00',1.11),('325','2014-01-27','11:20:00',1.07),('325','2014-01-27','11:25:00',1.05),('325','2014-01-26','09:05:00',1.21),('325','2014-01-26','09:30:00',1.41),('325','2014-01-26','09:35:00',1.37),('325','2014-01-26','09:45:00',1.16),('325','2014-01-26','09:50:00',1.36),('325','2014-01-26','09:55:00',1.06),('325','2014-01-26','10:10:00',1.72),('325','2014-01-26','10:15:00',2.01),('325','2014-01-26','10:20:00',1.17),('325','2014-01-26','10:25:00',1.04),('325','2014-01-26','11:25:00',1.15),('325','2014-01-26','12:15:00',1.25),('325','2014-01-26','12:20:00',1.34),('325','2014-01-26','12:25:00',1.49),('325','2014-01-26','12:30:00',3.08),('325','2014-01-26','12:35:00',2.06),('325','2014-01-26','12:40:00',1.3),('325','2014-01-26','12:45:00',1.12),('325','2014-01-26','13:00:00',1.04),('325','2014-01-26','13:05:00',1.2),('325','2014-01-26','13:10:00',1.34),('325','2014-01-26','13:15:00',1.52),('325','2014-01-26','13:20:00',1.63),('325','2014-01-26','13:25:00',1.3),('325','2014-01-26','13:50:00',1.12),('325','2014-01-26','15:45:00',1.49),('3355','2014-05-05','08:40:00',1.02),('3355','2014-05-05','08:45:00',1.07),('3355','2014-05-05','08:50:00',1.12),('3355','2014-05-05','08:55:00',1.16),('3355','2014-05-05','09:00:00',1.2),('3355','2014-05-05','09:05:00',1.25),('3355','2014-05-05','09:10:00',1.29),('3355','2014-05-05','09:15:00',1.34),('3355','2014-05-05','09:20:00',1.39),('3355','2014-05-05','09:25:00',1.44),('3355','2014-05-05','09:30:00',1.49),('3355','2014-05-05','09:35:00',1.54),('3355','2014-05-05','09:40:00',1.58),('3355','2014-05-05','09:45:00',1.62),('3355','2014-05-05','09:50:00',1.67),('3355','2014-05-05','09:55:00',1.71),('3355','2014-05-05','10:00:00',1.75),('3355','2014-05-05','10:05:00',1.79),('3355','2014-05-05','10:10:00',1.82),('3355','2014-05-05','10:15:00',1.85),('3355','2014-05-05','10:20:00',1.87),('3355','2014-05-05','10:25:00',1.91),('3355','2014-05-05','10:30:00',1.94),('3355','2014-05-05','10:35:00',1.98),('3355','2014-05-05','10:40:00',2),('3355','2014-05-05','10:45:00',2.01),('3355','2014-05-05','10:50:00',2.04),('3355','2014-05-05','10:55:00',2.07),('3355','2014-05-05','11:00:00',2.1),('3355','2014-05-05','11:05:00',2.12),('3355','2014-05-05','11:10:00',2.14),('3355','2014-05-05','11:15:00',2.17),('3355','2014-05-05','11:20:00',2.18),('3355','2014-05-05','11:25:00',2.2),('3355','2014-05-05','11:30:00',2.2),('3355','2014-05-05','11:35:00',2.23),('3355','2014-05-05','11:40:00',2.26),('3355','2014-05-05','11:45:00',2.29),('3355','2014-05-05','11:50:00',2.31),('3355','2014-05-05','11:55:00',2.36),('3355','2014-05-05','12:00:00',1.72),('3355','2014-05-05','12:05:00',1.09),('3355','2014-05-05','12:10:00',1.41),('3355','2014-05-05','12:15:00',2.27),('3355','2014-05-05','12:20:00',1.2),('3355','2014-05-05','12:25:00',2.07),('3355','2014-05-05','12:30:00',1.81),('3355','2014-05-05','12:35:00',1.06),('3355','2014-05-05','12:40:00',1.3),('3355','2014-05-05','12:45:00',2.43),('3355','2014-05-05','12:50:00',1.98),('3355','2014-05-05','12:55:00',1.27),('3355','2014-05-05','13:00:00',2.27),('3355','2014-05-05','13:05:00',1.89),('3355','2014-05-05','13:10:00',2.6),('3355','2014-05-05','13:15:00',2.5),('3355','2014-05-05','13:20:00',2.43),('3355','2014-05-05','13:25:00',2.4),('3355','2014-05-05','13:30:00',2.25),('3355','2014-05-05','13:35:00',2.24),('3355','2014-05-05','13:40:00',2.43),('3355','2014-05-05','13:45:00',2.43),('3355','2014-05-05','13:50:00',2.44),('3355','2014-05-05','13:55:00',2.42),('3355','2014-05-05','14:00:00',2.44),('3355','2014-05-05','14:05:00',2.51),('3355','2014-05-05','14:10:00',2.51),('3355','2014-05-05','14:15:00',2.55),('3355','2014-05-05','14:20:00',2.14),('3355','2014-05-05','14:25:00',1.47),('3355','2014-05-05','14:30:00',1.5),('3355','2014-05-05','15:05:00',1.61),('3355','2014-05-05','15:25:00',1.13),('3355','2014-05-05','15:30:00',2.45),('3355','2014-05-05','15:35:00',2.34),('3355','2014-05-05','15:40:00',2.2),('3355','2014-05-05','16:45:00',1.12),('3355','2014-05-05','16:55:00',1.34),('3355','2014-05-05','17:00:00',1.53),('3355','2014-05-05','17:05:00',1.46),('3355','2014-05-05','17:10:00',1.47),('3355','2014-05-05','17:15:00',1.43),('3355','2014-05-05','17:20:00',1.37),('3355','2014-05-05','17:25:00',1.3),('3355','2014-05-05','17:30:00',1.21),('3355','2014-05-05','17:35:00',1.15),('3355','2014-05-05','17:40:00',1.1),('3355','2014-05-05','17:45:00',1.04),('3355','2014-04-26','10:35:00',1.04),('3355','2014-04-26','10:40:00',1.07),('3355','2014-04-26','10:45:00',1.12),('3355','2014-04-26','10:50:00',1.38),('3355','2014-04-26','10:55:00',1.97),('3355','2014-04-26','11:00:00',1.96),('3355','2014-04-26','11:05:00',1.9),('3355','2014-04-26','11:10:00',1.72),('3355','2014-04-26','11:15:00',1.8),('3355','2014-04-26','11:20:00',1.6),('3355','2014-04-26','11:25:00',1.62),('3355','2014-04-26','11:30:00',1.54),('3355','2014-04-26','11:35:00',1.68),('3355','2014-04-26','11:40:00',1.6),('3355','2014-04-26','11:45:00',1.71),('3355','2014-04-26','11:50:00',1.69),('3355','2014-04-26','11:55:00',1.56),('3355','2014-04-26','12:00:00',1.71),('3355','2014-04-26','12:05:00',1.83),('3355','2014-04-26','12:10:00',1.8),('3355','2014-04-26','12:15:00',1.53),('3355','2014-04-26','12:20:00',1.63),('3355','2014-04-26','12:25:00',1.17),('3355','2014-04-26','12:30:00',1.47),('3355','2014-04-26','12:35:00',1.87),('3355','2014-04-26','12:40:00',2),('3355','2014-04-26','12:45:00',2.05),('3355','2014-04-26','12:50:00',2.1),('3355','2014-04-26','12:55:00',2.39),('3355','2014-04-26','13:00:00',2.14),('3355','2014-04-26','13:05:00',1.6),('3355','2014-04-26','13:10:00',1.98),('3355','2014-04-26','13:15:00',2.34),('3355','2014-04-26','13:20:00',2.19),('3355','2014-04-26','13:25:00',1.36),('3355','2014-04-26','13:35:00',1.07),('3355','2014-04-26','13:40:00',2.06),('3355','2014-04-26','13:45:00',2.4),('3355','2014-04-26','13:50:00',2.39),('3355','2014-04-26','13:55:00',2.45),('3355','2014-04-26','14:00:00',2.15),('3355','2014-04-26','14:10:00',1.62),('3355','2014-04-26','14:35:00',1.28),('3355','2014-04-26','14:40:00',1.55),('3355','2014-01-26','09:35:00',1.04),('3355','2014-01-26','10:10:00',1.16),('3355','2014-01-26','10:15:00',1.58),('3355','2014-01-26','12:30:00',1.38),('3355','2014-01-26','12:35:00',1.38),('3355','2014-01-25','09:05:00',1.03),('3355','2014-01-25','09:55:00',1.13),('3355','2014-01-25','10:05:00',1.48),('3355','2014-01-25','10:10:00',1.64),('3355','2014-01-25','10:15:00',1.63),('3355','2014-01-25','10:20:00',1.62),('3355','2014-01-25','10:30:00',1.13),('3355','2014-01-25','10:40:00',1),('3355','2014-01-25','11:30:00',1.57),('3355','2014-01-25','11:35:00',2.2),('3355','2014-01-25','11:40:00',1.05),('3355','2014-01-25','12:10:00',1.01),('3355','2014-01-25','12:15:00',1),('3355','2014-01-25','12:20:00',1.03),('3355','2014-01-25','12:25:00',1.06),('3355','2014-01-25','12:30:00',1.1),('3355','2014-01-25','12:40:00',1),('3355','2014-01-25','12:45:00',1.19),('3355','2014-01-25','12:50:00',1.31),('3355','2014-01-25','12:55:00',1.6),('3355','2014-01-25','13:00:00',1.62),('3355','2014-01-25','13:05:00',1.83),('3355','2014-01-25','13:10:00',1.89),('3355','2014-01-25','13:15:00',1.37),('3355','2014-01-25','13:30:00',1.09),('3355','2014-01-25','13:45:00',1.33),('3355','2014-01-25','14:00:00',1.08),('3355','2014-01-25','14:05:00',1.3),('3355','2014-01-25','14:10:00',1.41),('3355','2014-01-25','14:15:00',1.44),('3355','2014-01-25','14:20:00',1.65),('3355','2014-01-25','14:25:00',1.65),('3355','2014-01-25','14:30:00',1.78),('3355','2014-01-25','14:35:00',1.27),('3355','2014-01-25','14:40:00',1.7),('3355','2014-01-25','14:45:00',1.71),('3355','2014-01-25','14:50:00',1.65),('3355','2014-01-25','14:55:00',1.55),('3355','2014-01-25','15:00:00',1.41),('3355','2014-01-25','15:05:00',1.32),('3355','2014-01-25','15:10:00',1.2),('3355','2014-01-25','15:15:00',1.08),('3355','2014-01-25','15:20:00',1.04),('3355','2014-01-24','10:40:00',1.01),('3355','2014-01-24','10:45:00',1.01),('3355','2014-01-24','11:50:00',2.04),('3355','2014-01-24','11:55:00',2.04),('3355','2014-01-24','12:00:00',1.54),('3355','2014-01-24','12:35:00',1.55),('3355','2014-01-24','12:40:00',1.43),('3355','2014-01-24','12:45:00',1.22),('3355','2014-01-24','13:00:00',1.01),('3355','2014-01-24','13:05:00',1.12),('3355','2014-01-24','13:45:00',1.09),('3355','2014-01-24','13:50:00',1.39),('3355','2014-01-24','13:55:00',1.26),('3355','2014-01-24','14:00:00',1.53),('3355','2014-01-24','14:10:00',1.89),('3355','2014-01-24','14:15:00',1.72),('3355','2014-01-24','14:20:00',1.7),('3355','2014-01-24','14:25:00',1.52),('3355','2014-01-21','11:00:00',1.2),('3355','2014-01-21','12:10:00',1.16),('3355','2014-01-21','12:30:00',1.04),('3355','2014-01-21','12:50:00',1.05),('3355','2014-01-20','11:25:00',1.08),('3355','2014-01-20','11:30:00',1.1),('3355','2014-01-20','11:35:00',1.08),('3355','2014-01-20','11:40:00',1.79),('3355','2014-01-20','11:45:00',1.73),('3355','2014-01-20','11:50:00',1.07),('3355','2014-01-20','13:20:00',2.21),('3355','2014-01-20','13:25:00',2.11),('3355','2014-01-20','13:30:00',1.87),('3355','2014-01-20','13:35:00',1.78),('3355','2014-01-20','13:40:00',1.63),('3355','2014-01-20','13:45:00',1.53),('3355','2014-01-20','14:00:00',1.53),('3355','2014-01-20','14:05:00',1.22),('3355','2014-01-19','14:30:00',1.1),('3355','2014-01-18','10:10:00',1.44),('3355','2014-01-18','10:15:00',1.51),('3355','2014-01-18','10:20:00',1.39),('3355','2014-01-18','11:10:00',1.25),('3355','2014-01-18','11:15:00',1.68),('3355','2014-01-18','11:20:00',1.64),('3355','2014-01-18','11:25:00',1.55),('3355','2014-01-18','11:30:00',1.58),('3355','2014-01-18','11:35:00',1.61),('3355','2014-01-18','11:40:00',1.44),('3355','2014-01-18','11:45:00',1.86),('3355','2014-01-18','11:50:00',2),('3355','2014-01-18','11:55:00',1.97),('3355','2014-01-18','12:00:00',1.87),('3355','2014-01-18','12:05:00',1.46),('3355','2014-01-18','12:10:00',1.74),('3355','2014-01-18','12:15:00',1.67),('3355','2014-01-18','12:20:00',1.66),('3355','2014-01-18','12:25:00',1.7),('3355','2014-01-18','12:30:00',1.71),('3355','2014-01-18','12:35:00',1.7),('3355','2014-01-18','12:40:00',1.73),('3355','2014-01-18','12:45:00',1.71),('3355','2014-01-18','12:50:00',1.64),('3355','2014-01-18','12:55:00',1.81),('3355','2014-01-18','13:00:00',1.18),('3355','2014-01-18','13:05:00',1.08),('3355','2014-01-18','13:10:00',1.4),('3355','2014-01-18','13:15:00',1.73),('3355','2014-01-18','13:20:00',1.05),('3355','2014-01-18','13:30:00',1.56),('3355','2014-01-18','13:40:00',1.33),('3355','2014-01-18','13:45:00',1.65),('3355','2014-01-18','13:50:00',1.04),('3355','2014-01-18','13:55:00',1.59),('3355','2014-01-18','14:00:00',1.51),('3355','2014-01-18','14:05:00',1.35),('3355','2014-01-18','14:10:00',1.38),('3355','2014-01-18','14:15:00',1.33),('3355','2014-01-18','14:20:00',1.41),('3355','2014-01-18','14:25:00',1.35),('3355','2014-01-18','14:30:00',1.3),('3355','2014-01-18','14:35:00',1.28),('3355','2014-01-18','14:40:00',1.24),('3355','2014-01-18','14:45:00',1.21),('3355','2014-01-18','14:50:00',1.11),('3355','2014-01-17','09:40:00',1.06),('3355','2014-01-17','09:45:00',1.05),('3355','2014-01-17','11:30:00',1.33),('3355','2014-01-17','11:35:00',1.03),('3355','2014-01-17','12:05:00',1.14),('3355','2014-04-25','08:55:00',1.02),('3355','2014-04-25','09:00:00',1.19),('3355','2014-04-25','09:05:00',1.22),('3355','2014-04-25','09:10:00',1.29),('3355','2014-04-25','09:15:00',1.39),('3355','2014-04-25','09:20:00',1.48),('3355','2014-04-25','09:25:00',1.51),('3355','2014-04-25','09:30:00',1.43),('3355','2014-04-25','10:40:00',1.2),('3355','2014-04-25','10:45:00',1.77),('3355','2014-04-25','10:50:00',2.04),('3355','2014-04-25','10:55:00',1.97),('3355','2014-04-25','11:00:00',1.98),('3355','2014-04-25','11:05:00',1.9),('3355','2014-04-25','11:10:00',1.62),('3355','2014-04-25','11:15:00',1.45),('3355','2014-04-25','11:20:00',1.95),('3355','2014-04-25','12:05:00',1.21),('3355','2014-04-25','12:10:00',1.03),('3355','2014-04-25','12:20:00',1.36),('3355','2014-04-25','12:25:00',2.22),('3355','2014-04-25','12:30:00',2.44),('3355','2014-04-25','12:35:00',2.3),('3355','2014-04-25','12:40:00',2.34),('3355','2014-04-25','12:45:00',2.51),('3355','2014-04-25','12:50:00',2.29),('3355','2014-04-25','13:05:00',1.66),('3355','2014-04-25','13:15:00',1.81),('3355','2014-04-25','13:45:00',1.11),('3355','2014-04-25','14:20:00',2.13),('3355','2014-04-25','14:25:00',2.75),('3355','2014-04-25','14:30:00',2.38),('3355','2014-04-25','14:35:00',2.33),('3355','2014-04-25','14:40:00',2.08),('3355','2014-04-25','14:45:00',2.28),('3355','2014-04-25','14:50:00',2.18),('3355','2014-04-25','14:55:00',2.2),('3355','2014-04-25','15:00:00',2.2),('3355','2014-04-25','15:05:00',2.15),('3355','2014-04-25','15:10:00',2.14),('3355','2014-04-25','15:15:00',2.11),('3355','2014-04-25','15:20:00',2.04),('3355','2014-04-25','15:25:00',2.03),('3355','2014-04-25','15:30:00',1.92),('3355','2014-04-25','15:35:00',2.02),('3355','2014-04-25','15:40:00',1.99),('3355','2014-04-25','15:45:00',1.93),('3355','2014-04-25','15:50:00',1.9),('3355','2014-04-25','15:55:00',1.88),('3355','2014-04-25','16:00:00',1.88),('3355','2014-04-25','16:05:00',1.82),('3355','2014-04-25','16:10:00',1.72),('3355','2014-04-25','16:15:00',1.69),('3355','2014-04-25','16:20:00',1.57),('3355','2014-04-25','16:25:00',1.57),('3355','2014-04-25','16:30:00',1.63),('3355','2014-04-25','16:35:00',1.61),('3355','2014-04-25','16:40:00',1.61),('3355','2014-04-25','16:45:00',1.56),('3355','2014-04-25','16:50:00',1.47),('3355','2014-04-25','16:55:00',1.26),('3355','2014-04-25','17:00:00',1.14),('3355','2014-04-25','17:05:00',1.29),('3355','2014-04-25','17:10:00',1.14),('3355','2014-04-25','17:15:00',1.17),('3355','2014-01-16','09:30:00',1.05),('3355','2014-01-16','09:35:00',1.07),('3355','2014-01-16','09:40:00',1.14),('3355','2014-01-16','09:45:00',1.03),('3355','2014-01-16','10:30:00',1.09),('3355','2014-01-16','10:35:00',1.45),('3355','2014-01-16','10:40:00',1.45),('3355','2014-01-16','10:45:00',1.01),('3355','2014-01-16','10:50:00',1.08),('3355','2014-01-16','10:55:00',1.23),('3355','2014-01-16','11:00:00',1.23),('3355','2014-01-16','11:05:00',1.24),('3355','2014-01-16','11:10:00',1.28),('3355','2014-01-16','11:15:00',1.32),('3355','2014-01-16','11:20:00',1.17),('3355','2014-01-16','11:25:00',1.2),('3355','2014-01-16','11:30:00',1.06),('3355','2014-01-16','11:35:00',1.04),('3355','2014-01-16','11:50:00',1.02),('3355','2014-01-16','12:10:00',1.03),('3355','2014-01-16','12:35:00',1.05),('3355','2014-01-16','12:40:00',1.12),('3355','2014-01-16','12:45:00',1.16),('3355','2014-01-16','12:50:00',1.25),('3355','2014-01-16','12:55:00',1.31),('3355','2014-01-16','13:00:00',1.32),('3355','2014-01-16','13:05:00',1.42),('3355','2014-01-16','13:10:00',1.34),('3355','2014-01-16','13:15:00',1.29),('3355','2014-01-16','13:25:00',1.34),('3355','2014-01-16','13:30:00',1.38),('3355','2014-01-16','13:35:00',1.28),('3355','2014-01-16','13:50:00',1.17),('3355','2014-01-16','13:55:00',1),('3355','2014-01-15','10:20:00',1.14),('3355','2014-01-15','10:25:00',1.28),('3355','2014-01-15','10:30:00',1.32),('3355','2014-01-15','10:45:00',1.18),('3355','2014-01-15','11:10:00',1.82),('3355','2014-01-15','11:15:00',1.49),('3355','2014-01-15','11:20:00',1.5),('3355','2014-01-15','11:25:00',1.49),('3355','2014-01-15','11:30:00',1.4),('3355','2014-01-15','11:35:00',1.72),('3355','2014-01-15','11:40:00',1.26),('3355','2014-01-15','11:45:00',1.34),('3355','2014-01-15','11:50:00',1.52),('3355','2014-01-15','11:55:00',1.23),('3355','2014-01-15','12:15:00',1.27),('3355','2014-01-15','12:20:00',1.63),('3355','2014-01-15','12:25:00',1.46),('3355','2014-01-15','12:50:00',1.01),('3355','2014-01-15','13:10:00',1.02),('3355','2014-01-15','13:15:00',1.73),('3355','2014-01-15','13:20:00',1.82),('3355','2014-01-15','13:25:00',1.82),('3355','2014-01-15','13:30:00',1.76),('3355','2014-01-15','13:35:00',1.7),('3355','2014-01-15','13:40:00',1.62),('3355','2014-01-15','13:45:00',1.58),('3355','2014-01-15','13:50:00',1.14),('3355','2014-01-15','14:10:00',1.4),('3355','2014-01-15','14:15:00',1.38),('3355','2014-01-15','14:20:00',1.35),('3355','2014-01-15','14:25:00',1.35),('3355','2014-01-15','14:30:00',1.33),('3355','2014-01-15','14:35:00',1.29),('3355','2014-01-15','14:40:00',1.29),('3355','2014-01-15','14:45:00',1.17),('3355','2014-01-15','14:50:00',1.06),('3355','2014-01-15','14:55:00',1.09),('3355','2014-01-14','10:30:00',1.63),('3355','2014-01-14','10:35:00',1.76),('3355','2014-01-14','10:40:00',1.51),('3355','2014-01-14','10:45:00',1.41),('3355','2014-01-13','09:50:00',1.02),('3355','2014-01-13','09:55:00',1.05),('3355','2014-01-13','10:00:00',1.09),('3355','2014-01-13','10:05:00',1.11),('3355','2014-01-13','10:10:00',1.14),('3355','2014-01-13','10:15:00',1.16),('3355','2014-01-13','10:20:00',1.21),('3355','2014-01-13','10:25:00',1.24),('3355','2014-01-13','10:30:00',1.27),('3355','2014-01-13','10:35:00',1.28),('3355','2014-01-13','10:40:00',1.31),('3355','2014-01-13','10:45:00',1.34),('3355','2014-01-13','10:50:00',1.37),('3355','2014-01-13','10:55:00',1.4),('3355','2014-01-13','11:00:00',1.41),('3355','2014-01-13','11:05:00',1.42),('3355','2014-01-13','11:10:00',1.45),('3355','2014-01-13','11:15:00',1.47),('3355','2014-01-13','11:20:00',1.49),('3355','2014-01-13','11:25:00',1.5),('3355','2014-01-13','11:30:00',1.51),('3355','2014-01-13','11:35:00',1.51),('3355','2014-01-13','11:40:00',1.52),('3355','2014-01-13','11:45:00',1.53),('3355','2014-01-13','11:50:00',1.52),('3355','2014-01-13','11:55:00',1.53),('3355','2014-01-13','12:00:00',1.5),('3355','2014-01-13','12:05:00',1.48),('3355','2014-01-13','12:10:00',1.49),('3355','2014-01-13','12:15:00',1.53),('3355','2014-01-13','12:20:00',1.53),('3355','2014-01-13','12:25:00',1.53),('3355','2014-01-13','12:30:00',1.51),('3355','2014-01-13','12:35:00',1.5),('3355','2014-01-13','12:40:00',1.49),('3355','2014-01-13','12:45:00',1.49),('3355','2014-01-13','12:50:00',1.45),('3355','2014-01-13','12:55:00',1.38),('3355','2014-01-13','13:00:00',1.43),('3355','2014-01-13','13:05:00',1.42),('3355','2014-01-13','13:10:00',1.42),('3355','2014-01-13','13:15:00',1.39),('3355','2014-01-13','13:20:00',1.39),('3355','2014-01-13','13:25:00',1.35),('3355','2014-01-13','13:30:00',1.35),('3355','2014-01-13','13:35:00',1.38),('3355','2014-01-13','13:40:00',1.27),('3355','2014-01-13','13:45:00',1.2),('3355','2014-01-13','13:50:00',1.14),('3355','2014-01-13','13:55:00',1.09),('3355','2014-01-13','14:00:00',1.02),('3355','2014-01-13','14:05:00',1.18),('3355','2014-01-13','14:10:00',1.14),('3355','2014-01-13','14:15:00',1.17),('3355','2014-01-13','14:20:00',1.18),('3355','2014-01-13','14:25:00',1.15),('3355','2014-01-13','14:30:00',1.12),('3355','2014-01-13','14:35:00',1.1),('3355','2014-01-13','14:40:00',1.02),('3355','2014-01-12','11:10:00',1.05),('3355','2014-01-12','11:50:00',1.07),('3355','2014-01-12','11:55:00',1.08),('3355','2014-01-11','10:25:00',1.03),('3355','2014-01-11','10:35:00',1.05),('3355','2014-01-11','10:40:00',1.31),('3355','2014-01-11','10:45:00',1.4),('3355','2014-01-11','10:50:00',1.41),('3355','2014-01-11','10:55:00',1.42),('3355','2014-01-11','11:00:00',1.39),('3355','2014-01-11','11:05:00',1.32),('3355','2014-01-11','11:10:00',1.42),('3355','2014-01-11','11:15:00',1.31),('3355','2014-01-11','11:20:00',1.19),('3355','2014-01-11','11:25:00',1.21),('3355','2014-01-11','11:30:00',1.21),('3355','2014-01-11','11:35:00',1.08),('3355','2014-01-11','11:45:00',1),('3355','2014-01-11','11:50:00',1.08),('3355','2014-01-11','11:55:00',1.1),('3355','2014-01-11','12:00:00',1.11),('3355','2014-01-11','12:05:00',1.29),('3355','2014-01-11','12:10:00',1.19),('3355','2014-01-11','12:15:00',1.2),('3355','2014-01-11','12:20:00',1.12),('3355','2014-01-11','12:25:00',1.07),('3355','2014-01-11','12:50:00',1),('3355','2014-01-11','12:55:00',1.26),('3355','2014-01-11','13:00:00',1.19),('3355','2014-01-11','13:05:00',1.15),('3355','2014-01-11','13:10:00',1.19),('3355','2014-01-11','13:15:00',1.34),('3355','2014-01-11','13:20:00',1.15),('3355','2014-01-09','09:50:00',1),('3355','2014-01-09','09:55:00',1.06),('3355','2014-01-09','10:00:00',1.07),('3355','2014-01-09','10:05:00',1.09),('3355','2014-01-09','10:25:00',1.02),('3355','2014-01-09','10:30:00',1.06),('3355','2014-01-09','10:35:00',1.06),('3355','2014-01-09','10:40:00',1.06),('3355','2014-01-09','10:45:00',1.12),('3355','2014-01-09','10:50:00',1.19),('3355','2014-01-08','09:55:00',1.04),('3355','2014-01-08','10:00:00',1.04),('3355','2014-01-08','10:05:00',1.04),('3355','2014-01-08','10:10:00',1.09),('3355','2014-01-08','10:15:00',1.14),('3355','2014-01-08','10:20:00',1.2),('3355','2014-01-08','10:25:00',1.19),('3355','2014-01-08','10:30:00',1.25),('3355','2014-01-08','10:35:00',1.23),('3355','2014-01-08','10:40:00',1.2),('3355','2014-01-08','10:45:00',1.31),('3355','2014-01-08','10:50:00',1.37),('3355','2014-01-08','10:55:00',1.41),('3355','2014-01-08','11:00:00',1.43),('3355','2014-01-08','11:05:00',1.45),('3355','2014-01-08','11:10:00',1.47),('3355','2014-01-08','11:15:00',1.49),('3355','2014-01-08','11:20:00',1.5),('3355','2014-01-08','11:25:00',1.49),('3355','2014-01-08','11:30:00',1.49),('3355','2014-01-08','11:35:00',1.55),('3355','2014-01-08','11:40:00',1.57),('3355','2014-01-08','11:45:00',1.56),('3355','2014-01-08','11:50:00',1.54),('3355','2014-01-08','11:55:00',1.55),('3355','2014-01-08','12:00:00',1.53),('3355','2014-01-08','12:05:00',1.51),('3355','2014-01-08','12:10:00',1.53),('3355','2014-01-08','12:15:00',1.56),('3355','2014-01-08','12:20:00',1.56),('3355','2014-01-08','12:25:00',1.57),('3355','2014-01-08','12:30:00',1.57),('3355','2014-01-08','12:35:00',1.52),('3355','2014-01-08','12:40:00',1.51),('3355','2014-01-08','12:45:00',1.47),('3355','2014-01-08','12:50:00',1.44),('3355','2014-01-08','12:55:00',1.46),('3355','2014-01-08','13:00:00',1.45),('3355','2014-01-08','13:05:00',1.44),('3355','2014-01-08','13:10:00',1.44),('3355','2014-01-08','13:15:00',1.44),('3355','2014-01-08','13:20:00',1.43),('3355','2014-01-08','13:25:00',1.4),('3355','2014-01-08','13:30:00',1.34),('3355','2014-01-08','13:35:00',1.19),('3355','2014-01-08','13:40:00',1.18),('3355','2014-01-08','13:45:00',1.2),('3355','2014-01-08','13:50:00',1.11),('3355','2014-01-08','13:55:00',1.14),('3355','2014-01-08','14:00:00',1.14),('3355','2014-01-08','14:05:00',1.16),('3355','2014-01-08','14:10:00',1.18),('3355','2014-01-08','14:15:00',1.18),('3355','2014-01-08','14:20:00',1.19),('3355','2014-01-08','14:25:00',1.17),('3355','2014-01-08','14:30:00',1.06),('3355','2014-01-07','09:40:00',1.02),('3355','2014-01-07','09:45:00',1.05),('3355','2014-01-07','09:50:00',1.09),('3355','2014-01-07','09:55:00',1.13),('3355','2014-01-07','10:00:00',1.16),('3355','2014-01-07','10:05:00',1.19),('3355','2014-01-07','10:10:00',1.22),('3355','2014-01-07','10:15:00',1.25),('3355','2014-01-07','10:20:00',1.27),('3355','2014-01-07','10:25:00',1.3),('3355','2014-01-07','10:30:00',1.32),('3355','2014-01-07','10:35:00',1.35),('3355','2014-01-07','10:40:00',1.38),('3355','2014-01-07','10:45:00',1.41),('3355','2014-01-07','10:50:00',1.44),('3355','2014-01-07','10:55:00',1.46),('3355','2014-01-07','11:00:00',1.48),('3355','2014-01-07','11:05:00',1.5),('3355','2014-01-07','11:10:00',1.51),('3355','2014-01-07','11:15:00',1.53),('3355','2014-01-07','11:20:00',1.55),('3355','2014-01-07','11:25:00',1.56),('3355','2014-01-07','11:30:00',1.57),('3355','2014-01-07','11:35:00',1.59),('3355','2014-01-07','11:40:00',1.6),('3355','2014-01-07','11:45:00',1.62),('3355','2014-01-07','11:50:00',1.62),('3355','2014-01-07','11:55:00',1.63),('3355','2014-01-07','12:00:00',1.62),('3355','2014-01-07','12:05:00',1.64),('3355','2014-01-07','12:10:00',1.64),('3355','2014-01-07','12:15:00',1.63),('3355','2014-01-07','12:20:00',1.64),('3355','2014-01-07','12:25:00',1.63),('3355','2014-01-07','12:30:00',1.6),('3355','2014-01-07','12:35:00',1.61),('3355','2014-01-07','12:40:00',1.56),('3355','2014-01-07','12:45:00',1.52),('3355','2014-01-07','12:50:00',1.59),('3355','2014-01-07','12:55:00',1.62),('3355','2014-01-07','13:00:00',1.52),('3355','2014-01-07','13:05:00',1.46),('3355','2014-01-07','13:10:00',1.49),('3355','2014-01-07','13:15:00',1.5),('3355','2014-01-07','13:20:00',1.44),('3355','2014-01-07','13:25:00',1.41),('3355','2014-01-07','13:30:00',1.28),('3355','2014-01-07','13:35:00',1.2),('3355','2014-01-07','13:40:00',1.15),('3355','2014-01-07','13:45:00',1.3),('3355','2014-01-07','13:50:00',1.23),('3355','2014-01-07','13:55:00',1.25),('3355','2014-01-07','14:00:00',1.29),('3355','2014-01-07','14:05:00',1.26),('3355','2014-01-07','14:10:00',1.26),('3355','2014-01-07','14:15:00',1.26),('3355','2014-01-07','14:20:00',1.28),('3355','2014-01-07','14:25:00',1.17),('3355','2014-01-07','14:30:00',1.01),('3355','2014-01-07','14:35:00',1.02),('3355','2014-04-24','08:55:00',1.03),('3355','2014-04-24','09:00:00',1.08),('3355','2014-04-24','09:05:00',1.12),('3355','2014-04-24','09:10:00',1.17),('3355','2014-04-24','09:15:00',1.21),('3355','2014-04-24','09:20:00',1.26),('3355','2014-04-24','09:25:00',1.3),('3355','2014-04-24','09:30:00',1.34),('3355','2014-04-24','09:35:00',1.39),('3355','2014-04-24','09:40:00',1.43),('3355','2014-04-24','09:45:00',1.47),('3355','2014-04-24','09:50:00',1.51),('3355','2014-04-24','09:55:00',1.55),('3355','2014-04-24','10:00:00',1.59),('3355','2014-04-24','10:05:00',1.62),('3355','2014-04-24','10:10:00',1.64),('3355','2014-04-24','10:15:00',1.67),('3355','2014-04-24','10:20:00',1.7),('3355','2014-04-24','10:25:00',1.74),('3355','2014-04-24','10:30:00',1.77),('3355','2014-04-24','10:35:00',1.79),('3355','2014-04-24','10:40:00',1.84),('3355','2014-04-24','10:45:00',1.87),('3355','2014-04-24','10:50:00',1.91),('3355','2014-04-24','10:55:00',1.94),('3355','2014-04-24','11:00:00',1.96),('3355','2014-04-24','11:05:00',1.97),('3355','2014-04-24','11:10:00',1.97),('3355','2014-04-24','11:15:00',2.01),('3355','2014-04-24','11:20:00',2.02),('3355','2014-04-24','11:25:00',2.04),('3355','2014-04-24','11:30:00',2.04),('3355','2014-04-24','11:35:00',2.06),('3355','2014-04-24','11:40:00',2.1),('3355','2014-04-24','11:45:00',2.11),('3355','2014-04-24','11:50:00',2),('3355','2014-04-24','11:55:00',2.19),('3355','2014-04-24','12:00:00',2.12),('3355','2014-04-24','12:05:00',2.15),('3355','2014-04-24','12:10:00',2.25),('3355','2014-04-24','12:15:00',1.44),('3355','2014-04-24','12:20:00',1.99),('3355','2014-04-24','12:25:00',2.3),('3355','2014-04-24','12:30:00',2.23),('3355','2014-04-24','12:35:00',1.43),('3355','2014-04-24','12:40:00',2.34),('3355','2014-04-24','12:45:00',1.58),('3355','2014-04-24','12:50:00',2.38),('3355','2014-04-24','12:55:00',2.32),('3355','2014-04-24','13:00:00',2.28),('3355','2014-04-24','13:05:00',2.31),('3355','2014-04-24','13:10:00',2.04),('3355','2014-04-24','13:20:00',2.34),('3355','2014-04-24','13:25:00',2.44),('3355','2014-04-24','13:30:00',2.41),('3355','2014-04-24','13:35:00',2.33),('3355','2014-04-24','13:40:00',1.52),('3355','2014-04-24','13:50:00',2.33),('3355','2014-04-24','13:55:00',2.48),('3355','2014-04-24','14:00:00',2),('3355','2014-04-24','14:05:00',1.72),('3355','2014-04-24','14:10:00',2.13),('3355','2014-04-24','14:15:00',1.74),('3355','2014-04-24','14:20:00',1.77),('3355','2014-04-24','14:25:00',2.27),('3355','2014-04-24','14:30:00',2.52),('3355','2014-04-24','14:35:00',2.41),('3355','2014-04-24','14:40:00',1.78),('3355','2014-04-24','14:45:00',1.95),('3355','2014-04-24','14:55:00',1.88),('3355','2014-04-24','15:00:00',2.63),('3355','2014-04-24','15:05:00',2.56),('3355','2014-04-24','15:10:00',2.37),('3355','2014-04-24','15:15:00',2.12),('3355','2014-04-24','15:20:00',1.59),('3355','2014-04-24','15:25:00',1.27),('3355','2014-04-24','15:30:00',1.33),('3355','2014-04-24','15:35:00',1.61),('3355','2014-04-24','15:40:00',1.25),('3355','2014-04-24','15:45:00',1.13),('3355','2014-04-24','15:50:00',1.39),('3355','2014-04-24','15:55:00',1.52),('3355','2014-04-24','16:00:00',2.09),('3355','2014-04-24','16:05:00',2.14),('3355','2014-04-24','16:10:00',1.79),('3355','2014-04-24','16:15:00',1.92),('3355','2014-04-24','16:20:00',1.72),('3355','2014-04-24','16:25:00',1.3),('3355','2014-04-24','16:30:00',1.72),('3355','2014-04-24','16:35:00',1.01),('3355','2014-04-24','16:40:00',1.2),('3355','2014-04-24','16:45:00',1.32),('3355','2014-01-06','11:40:00',1.59),('3355','2014-01-06','11:45:00',1.69),('3355','2014-01-06','11:50:00',1.42),('3355','2014-01-06','11:55:00',1.3),('3355','2014-01-06','12:05:00',1.6),('3355','2014-01-06','12:10:00',1.66),('3355','2014-01-06','12:15:00',1.62),('3355','2014-01-06','12:20:00',1.63),('3355','2014-01-06','12:25:00',1.62),('3355','2014-01-06','12:30:00',1.6),('3355','2014-01-06','12:35:00',1.6),('3355','2014-01-06','12:40:00',1.61),('3355','2014-01-06','12:45:00',1.62),('3355','2014-01-06','12:50:00',1.61),('3355','2014-01-06','12:55:00',1.6),('3355','2014-01-06','13:00:00',1.59),('3355','2014-01-06','13:05:00',1.57),('3355','2014-01-06','13:10:00',1.57),('3355','2014-01-06','13:15:00',1.61),('3355','2014-01-06','13:20:00',1.6),('3355','2014-01-06','13:25:00',1.53),('3355','2014-01-06','13:30:00',1.31),('3355','2014-01-06','13:35:00',1.26),('3355','2014-01-06','13:40:00',1.14),('3355','2014-01-06','13:45:00',1.27),('3355','2014-01-06','13:50:00',1.29),('3355','2014-01-06','13:55:00',1.26),('3355','2014-01-06','14:20:00',1.26),('3355','2014-01-06','14:40:00',1.13),('3355','2014-01-06','14:45:00',1.21),('3355','2014-01-03','09:40:00',1.13),('3355','2014-01-03','10:20:00',1.46),('3355','2014-01-03','12:55:00',1.21),('3355','2014-01-03','13:35:00',1.04),('3355','2014-01-02','09:50:00',1.01),('3355','2014-01-02','09:55:00',1.06),('3355','2014-01-02','10:00:00',1.12),('3355','2014-01-02','10:05:00',1.16),('3355','2014-01-02','10:10:00',1.17),('3355','2014-01-02','10:15:00',1.19),('3355','2014-01-02','10:20:00',1.21),('3355','2014-01-02','10:25:00',1.26),('3355','2014-01-02','10:30:00',1.29),('3355','2014-01-02','10:35:00',1.27),('3355','2014-01-02','10:40:00',1.3),('3355','2014-01-02','10:45:00',1.32),('3355','2014-01-02','10:50:00',1.36),('3355','2014-01-02','10:55:00',1.42),('3355','2014-01-02','11:00:00',1.3),('3355','2014-01-02','11:05:00',1.41),('3355','2014-01-02','12:55:00',1.84),('3355','2014-01-02','13:00:00',1.36),('3355','2014-01-01','09:30:00',1.08),('3355','2014-01-01','09:50:00',1.28),('3355','2014-01-01','13:35:00',1.09),('3355','2014-01-01','14:00:00',1.13),('3355','2013-12-31','09:30:00',1.01),('3355','2013-12-31','09:35:00',1.06),('3355','2013-12-31','09:40:00',1.13),('3355','2013-12-31','11:25:00',1.09),('3355','2013-12-31','11:30:00',1.38),('3355','2013-12-31','11:40:00',1.03),('3355','2013-12-31','11:50:00',1.38),('3355','2013-12-31','11:55:00',1.32),('3355','2013-12-31','12:00:00',1.74),('3355','2013-12-31','12:05:00',1.7),('3355','2013-12-31','12:10:00',1.69),('3355','2013-12-31','12:15:00',1.68),('3355','2013-12-31','12:20:00',1.68),('3355','2013-12-31','12:25:00',1.66),('3355','2013-12-31','12:30:00',1.63),('3355','2013-12-31','12:35:00',1.64),('3355','2013-12-31','12:40:00',1.64),('3355','2013-12-31','12:45:00',1.63),('3355','2013-12-31','12:50:00',1.61),('3355','2013-12-31','12:55:00',1.61),('3355','2013-12-31','13:00:00',1.6),('3355','2013-12-31','13:05:00',1.59),('3355','2013-12-31','13:10:00',1.56),('3355','2013-12-31','13:15:00',1.48),('3355','2013-12-31','13:20:00',1.4),('3355','2013-12-31','13:25:00',1.31),('3355','2013-12-31','13:30:00',1.36),('3355','2013-12-31','13:35:00',1.39),('3355','2013-12-31','13:40:00',1.35),('3355','2013-12-31','13:45:00',1.32),('3355','2013-12-31','13:50:00',1.26),('3355','2013-12-31','13:55:00',1.28),('3355','2013-12-31','14:00:00',1.28),('3355','2013-12-31','14:05:00',1.29),('3355','2013-12-31','14:10:00',1.29),('3355','2013-12-31','14:15:00',1.21),('3355','2013-12-31','14:20:00',1.04),('3355','2013-12-31','14:25:00',1.12),('3355','2013-12-31','14:30:00',1.06),('3355','2013-12-31','14:35:00',1.05),('3355','2013-12-29','09:40:00',1.03),('3355','2013-12-29','09:45:00',1.06),('3355','2013-12-29','09:50:00',1.03),('3355','2013-12-29','10:15:00',1.24),('3355','2013-12-29','10:20:00',1.35),('3355','2013-12-29','10:25:00',1.13),('3355','2013-12-29','10:30:00',1.4),('3355','2013-12-29','10:40:00',1.6),('3355','2013-12-28','09:40:00',1.02),('3355','2013-12-28','09:45:00',1.06),('3355','2013-12-28','09:50:00',1.1),('3355','2013-12-28','09:55:00',1.14),('3355','2013-12-28','10:00:00',1.18),('3355','2013-12-28','10:05:00',1.21),('3355','2013-12-28','10:10:00',1.24),('3355','2013-12-28','10:15:00',1.27),('3355','2013-12-28','10:20:00',1.29),('3355','2013-12-28','10:25:00',1.32),('3355','2013-12-28','10:30:00',1.35),('3355','2013-12-28','10:35:00',1.39),('3355','2013-12-28','10:40:00',1.4),('3355','2013-12-28','10:45:00',1.42),('3355','2013-12-28','10:50:00',1.44),('3355','2013-12-28','10:55:00',1.46),('3355','2013-12-28','11:00:00',1.48),('3355','2013-12-28','11:05:00',1.5),('3355','2013-12-28','11:10:00',1.52),('3355','2013-12-28','11:15:00',1.54),('3355','2013-12-28','11:20:00',1.55),('3355','2013-12-28','11:25:00',1.57),('3355','2013-12-28','11:30:00',1.57),('3355','2013-12-28','11:35:00',1.59),('3355','2013-12-28','11:40:00',1.6),('3355','2013-12-28','11:45:00',1.61),('3355','2013-12-28','11:50:00',1.62),('3355','2013-12-28','11:55:00',1.62),('3355','2013-12-28','12:00:00',1.62),('3355','2013-12-28','12:05:00',1.61),('3355','2013-12-28','12:10:00',1.6),('3355','2013-12-28','12:15:00',1.61),('3355','2013-12-28','12:20:00',1.61),('3355','2013-12-28','12:25:00',1.59),('3355','2013-12-28','12:30:00',1.58),('3355','2013-12-28','12:35:00',1.58),('3355','2013-12-28','12:40:00',1.58),('3355','2013-12-28','12:45:00',1.56),('3355','2013-12-28','12:50:00',1.56),('3355','2013-12-28','12:55:00',1.54),('3355','2013-12-28','13:00:00',1.54),('3355','2013-12-28','13:05:00',1.5),('3355','2013-12-28','13:10:00',1.34),('3355','2013-12-28','13:15:00',1.29),('3355','2013-12-28','13:20:00',1.29),('3355','2013-12-28','13:25:00',1.27),('3355','2013-12-28','13:30:00',1.28),('3355','2013-12-28','13:35:00',1.22),('3355','2013-12-28','13:40:00',1.02),('3355','2013-12-28','13:45:00',1.01),('3355','2013-12-28','13:55:00',1.18),('3355','2013-12-28','14:00:00',1.17),('3355','2013-12-28','14:05:00',1.16),('3355','2013-12-28','14:10:00',1.13),('3355','2013-12-28','14:15:00',1.02),('3355','2013-12-27','12:15:00',1.25),('3355','2013-12-27','12:45:00',1.23),('3355','2013-12-27','12:50:00',1.42),('3355','2013-12-27','12:55:00',1.5),('3355','2013-12-27','13:00:00',1.51),('3355','2013-12-27','13:05:00',1.35),('3355','2013-12-27','13:30:00',1.18),('3355','2013-12-27','13:35:00',1.41),('3355','2013-12-23','10:00:00',1.05),('3355','2013-12-23','10:05:00',1.13),('3355','2013-12-23','10:10:00',1.12),('3355','2013-12-23','10:15:00',1.08),('3355','2013-12-23','10:20:00',1.21),('3355','2013-12-23','10:25:00',1.2),('3355','2013-12-23','10:30:00',1.12),('3355','2013-12-22','09:40:00',1.18),('3355','2013-12-22','09:45:00',1.23),('3355','2013-12-22','09:50:00',1.32),('3355','2013-12-22','09:55:00',1.33),('3355','2013-12-22','10:00:00',1.33),('3355','2013-12-22','10:05:00',1.35),('3355','2013-12-22','10:10:00',1.37),('3355','2013-12-22','10:15:00',1.35),('3355','2013-12-22','10:20:00',1.31),('3355','2013-12-22','10:25:00',1.31),('3355','2013-12-22','10:30:00',1.38),('3355','2013-12-22','10:35:00',1.3),('3355','2013-12-22','10:40:00',1.21),('3355','2013-12-22','10:45:00',1.29),('3355','2013-12-22','10:50:00',1.28),('3355','2013-12-22','10:55:00',1.21),('3355','2013-12-22','11:00:00',1.06),('3355','2013-12-22','11:05:00',1.12),('3355','2013-12-22','11:10:00',1.48),('3355','2013-12-22','11:15:00',1.46),('3355','2013-12-22','11:20:00',1.31),('3355','2013-12-22','11:25:00',1.36),('3355','2013-12-22','11:30:00',1.29),('3355','2013-12-22','11:35:00',1.26),('3355','2013-12-22','11:40:00',1.36),('3355','2013-12-22','11:45:00',1.28),('3355','2013-12-22','12:35:00',1.02),('3355','2013-12-22','12:50:00',1.13),('3355','2013-12-22','12:55:00',1.44),('3355','2013-12-22','13:00:00',1.43),('3355','2013-12-22','13:05:00',1.58),('3355','2013-12-22','13:10:00',1.55),('3355','2013-12-22','13:15:00',1.11),('3355','2013-12-22','13:30:00',1.02),('3355','2013-12-21','09:45:00',1.01),('3355','2013-12-21','09:50:00',1.05),('3355','2013-12-21','09:55:00',1.09),('3355','2013-12-21','10:00:00',1.12),('3355','2013-12-21','10:05:00',1.15),('3355','2013-12-21','10:10:00',1.18),('3355','2013-12-21','10:15:00',1.22),('3355','2013-12-21','10:20:00',1.24),('3355','2013-12-21','10:25:00',1.27),('3355','2013-12-21','10:30:00',1.3),('3355','2013-12-21','10:35:00',1.33),('3355','2013-12-21','10:40:00',1.35),('3355','2013-12-21','10:45:00',1.37),('3355','2013-12-21','10:50:00',1.39),('3355','2013-12-21','10:55:00',1.41),('3355','2013-12-21','11:00:00',1.44),('3355','2013-12-21','11:05:00',1.46),('3355','2013-12-21','11:10:00',1.48),('3355','2013-12-21','11:15:00',1.5),('3355','2013-12-21','11:20:00',1.51),('3355','2013-12-21','11:25:00',1.53),('3355','2013-12-21','11:30:00',1.55),('3355','2013-12-21','11:35:00',1.56),('3355','2013-12-21','11:40:00',1.57),('3355','2013-12-21','11:45:00',1.58),('3355','2013-12-21','11:50:00',1.58),('3355','2013-12-21','11:55:00',1.6),('3355','2013-12-21','12:00:00',1.6),('3355','2013-12-21','12:05:00',1.6),('3355','2013-12-21','12:10:00',1.61),('3355','2013-12-21','12:15:00',1.6),('3355','2013-12-21','12:20:00',1.6),('3355','2013-12-21','12:25:00',1.6),('3355','2013-12-21','12:30:00',1.6),('3355','2013-12-21','12:35:00',1.59),('3355','2013-12-21','12:40:00',1.58),('3355','2013-12-21','12:45:00',1.57),('3355','2013-12-21','12:50:00',1.57),('3355','2013-12-21','12:55:00',1.56),('3355','2013-12-21','13:00:00',1.52),('3355','2013-12-21','13:05:00',1.32),('3355','2013-12-21','13:10:00',1.29),('3355','2013-12-21','13:15:00',1.25),('3355','2013-12-21','13:20:00',1.36),('3355','2013-12-21','13:25:00',1.35),('3355','2013-12-21','13:30:00',1.3),('3355','2013-12-21','13:35:00',1.22),('3355','2013-12-21','13:40:00',1.19),('3355','2013-12-21','13:45:00',1.24),('3355','2013-12-21','13:50:00',1.23),('3355','2013-12-21','13:55:00',1.23),('3355','2013-12-21','14:00:00',1.23),('3355','2013-12-21','14:05:00',1.18),('3355','2013-12-21','14:10:00',1.09),('3355','2013-12-21','14:15:00',1.05),('3355','2013-12-21','14:20:00',1.06),('3355','2013-12-20','09:50:00',1.01),('3355','2013-12-20','09:55:00',1.03),('3355','2013-12-20','10:00:00',1.06),('3355','2013-12-20','10:05:00',1.11),('3355','2013-12-20','10:10:00',1.14),('3355','2013-12-20','10:15:00',1.15),('3355','2013-12-20','10:20:00',1.18),('3355','2013-12-20','10:25:00',1.22),('3355','2013-12-20','10:30:00',1.23),('3355','2013-12-20','10:35:00',1.25),('3355','2013-12-20','10:40:00',1.29),('3355','2013-12-20','10:45:00',1.31),('3355','2013-12-20','10:50:00',1.32),('3355','2013-12-20','10:55:00',1.35),('3355','2013-12-20','11:00:00',1.37),('3355','2013-12-20','11:05:00',1.39),('3355','2013-12-20','11:10:00',1.39),('3355','2013-12-20','11:15:00',1.41),('3355','2013-12-20','11:20:00',1.43),('3355','2013-12-20','11:25:00',1.45),('3355','2013-12-20','11:30:00',1.46),('3355','2013-12-20','11:35:00',1.47),('3355','2013-12-20','11:40:00',1.48),('3355','2013-12-20','11:45:00',1.49),('3355','2013-12-20','11:50:00',1.48),('3355','2013-12-20','11:55:00',1.5),('3355','2013-12-20','12:00:00',1.5),('3355','2013-12-20','12:05:00',1.49),('3355','2013-12-20','12:10:00',1.5),('3355','2013-12-20','12:15:00',1.5),('3355','2013-12-20','12:20:00',1.49),('3355','2013-12-20','12:25:00',1.48),('3355','2013-12-20','12:30:00',1.5),('3355','2013-12-20','12:35:00',1.48),('3355','2013-12-20','12:40:00',1.46),('3355','2013-12-20','12:45:00',1.46),('3355','2013-12-20','12:50:00',1.43),('3355','2013-12-20','12:55:00',1.41),('3355','2013-12-20','13:00:00',1.39),('3355','2013-12-20','13:05:00',1.24),('3355','2013-12-20','13:10:00',1.21),('3355','2013-12-20','13:15:00',1.13),('3355','2013-12-20','13:20:00',1.12),('3355','2013-12-20','13:25:00',1.17),('3355','2013-12-20','13:30:00',1.12),('3355','2013-12-20','13:35:00',1.04),('3355','2013-12-20','13:50:00',1.06),('3355','2013-12-20','13:55:00',1.03),('3355','2013-12-20','14:00:00',1.02),('3355','2013-12-19','09:55:00',1.25),('3355','2013-12-19','10:00:00',1.17),('3355','2013-12-19','10:05:00',1.11),('3355','2013-12-19','10:10:00',1.16),('3355','2013-12-19','10:15:00',1.18),('3355','2013-12-19','10:50:00',1.45),('3355','2013-12-19','10:55:00',1.04),('3355','2013-12-18','09:45:00',1.04),('3355','2013-12-18','09:50:00',1.08),('3355','2013-12-18','09:55:00',1.12),('3355','2013-12-18','10:00:00',1.15),('3355','2013-12-18','10:05:00',1.18),('3355','2013-12-18','10:10:00',1.22),('3355','2013-12-18','10:15:00',1.26),('3355','2013-12-18','10:20:00',1.29),('3355','2013-12-18','10:25:00',1.32),('3355','2013-12-18','10:30:00',1.34),('3355','2013-12-18','10:35:00',1.37),('3355','2013-12-18','10:40:00',1.38),('3355','2013-12-18','10:45:00',1.4),('3355','2013-12-18','10:50:00',1.41),('3355','2013-12-18','10:55:00',1.43),('3355','2013-12-18','11:00:00',1.45),('3355','2013-12-18','11:05:00',1.47),('3355','2013-12-18','11:10:00',1.49),('3355','2013-12-18','11:15:00',1.5),('3355','2013-12-18','11:20:00',1.5),('3355','2013-12-18','11:25:00',1.51),('3355','2013-12-18','11:30:00',1.51),('3355','2013-12-18','11:35:00',1.53),('3355','2013-12-18','11:40:00',1.54),('3355','2013-12-18','11:45:00',1.54),('3355','2013-12-18','11:50:00',1.55),('3355','2013-12-18','11:55:00',1.55),('3355','2013-12-18','12:00:00',1.55),('3355','2013-12-18','12:05:00',1.55),('3355','2013-12-18','12:10:00',1.55),('3355','2013-12-18','12:15:00',1.55),('3355','2013-12-18','12:20:00',1.56),('3355','2013-12-18','12:25:00',1.55),('3355','2013-12-18','12:30:00',1.56),('3355','2013-12-18','12:35:00',1.55),('3355','2013-12-18','12:40:00',1.54),('3355','2013-12-18','12:45:00',1.51),('3355','2013-12-18','12:50:00',1.51),('3355','2013-12-18','12:55:00',1.52),('3355','2013-12-18','13:00:00',1.45),('3355','2013-12-18','13:05:00',1.29),('3355','2013-12-18','13:10:00',1.23),('3355','2013-12-18','13:15:00',1.27),('3355','2013-12-18','13:20:00',1.2),('3355','2013-12-18','13:25:00',1.29),('3355','2013-12-18','13:30:00',1.23),('3355','2013-12-18','13:35:00',1.07),('3355','2013-12-18','13:40:00',1.04),('3355','2013-12-18','13:50:00',1.15),('3355','2013-12-18','13:55:00',1.13),('3355','2013-12-18','14:00:00',1.16),('3355','2013-12-18','14:05:00',1.1),('3355','2014-04-22','09:00:00',1.03),('3355','2014-04-22','09:05:00',1.16),('3355','2014-04-22','09:10:00',1.12),('3355','2014-04-22','09:15:00',1.08),('3355','2014-04-22','09:20:00',1.21),('3355','2014-04-22','09:25:00',1.31),('3355','2014-04-22','09:30:00',1.35),('3355','2014-04-22','09:35:00',1.44),('3355','2014-04-22','09:40:00',1.4),('3355','2014-04-22','09:45:00',1.5),('3355','2014-04-22','09:50:00',1.32),('3355','2014-04-22','10:15:00',1.13),('3355','2014-04-22','10:20:00',1.64),('3355','2014-04-22','10:25:00',1.16),('3355','2014-04-22','10:30:00',1.81),('3355','2014-04-22','10:35:00',1.96),('3355','2014-04-22','10:40:00',1.8),('3355','2014-04-22','10:45:00',1.86),('3355','2014-04-22','10:50:00',1.97),('3355','2014-04-22','10:55:00',1.65),('3355','2014-04-22','11:00:00',1.05),('3355','2014-04-22','11:05:00',1.3),('3355','2014-04-22','13:20:00',1.26),('3355','2014-04-22','13:25:00',1.44),('3355','2014-04-22','13:30:00',1.62),('3355','2014-04-22','13:35:00',1.42),('3355','2014-04-22','13:40:00',1.82),('3355','2014-04-22','13:45:00',1.83),('3355','2014-04-22','13:50:00',1.58),('3355','2014-04-22','14:10:00',1.81),('3355','2014-04-22','14:15:00',1.89),('3355','2014-04-22','14:20:00',2.1),('3355','2014-04-22','14:25:00',1.5),('3355','2014-04-22','14:30:00',1.1),('3355','2014-04-22','14:35:00',1.3),('3355','2014-04-22','14:40:00',1.76),('3355','2014-04-22','14:45:00',2.26),('3355','2014-04-22','14:50:00',1.78),('3355','2014-04-22','14:55:00',1.54),('3355','2014-04-22','15:35:00',1.44),('3355','2014-04-22','15:40:00',1.31),('3355','2014-04-22','15:45:00',1),('3355','2014-04-22','15:50:00',1.22),('3355','2014-04-22','16:00:00',1.17),('3355','2013-12-17','09:35:00',1.03),('3355','2013-12-17','09:40:00',1.06),('3355','2013-12-17','09:45:00',1.1),('3355','2013-12-17','09:50:00',1.14),('3355','2013-12-17','09:55:00',1.18),('3355','2013-12-17','10:00:00',1.21),('3355','2013-12-17','10:05:00',1.24),('3355','2013-12-17','10:10:00',1.28),('3355','2013-12-17','10:15:00',1.31),('3355','2013-12-17','10:20:00',1.34),('3355','2013-12-17','10:25:00',1.37),('3355','2013-12-17','10:30:00',1.41),('3355','2013-12-17','10:35:00',1.42),('3355','2013-12-17','10:40:00',1.44),('3355','2013-12-17','10:45:00',1.47),('3355','2013-12-17','10:50:00',1.48),('3355','2013-12-17','10:55:00',1.5),('3355','2013-12-17','11:00:00',1.52),('3355','2013-12-17','11:05:00',1.54),('3355','2013-12-17','11:10:00',1.55),('3355','2013-12-17','11:15:00',1.56),('3355','2013-12-17','11:20:00',1.58),('3355','2013-12-17','11:25:00',1.59),('3355','2013-12-17','11:30:00',1.6),('3355','2013-12-17','11:35:00',1.6),('3355','2013-12-17','11:40:00',1.61),('3355','2013-12-17','11:45:00',1.63),('3355','2013-12-17','11:50:00',1.65),('3355','2013-12-17','11:55:00',1.63),('3355','2013-12-17','12:00:00',1.64),('3355','2013-12-17','12:05:00',1.65),('3355','2013-12-17','12:10:00',1.64),('3355','2013-12-17','12:15:00',1.63),('3355','2013-12-17','12:20:00',1.64),('3355','2013-12-17','12:25:00',1.63),('3355','2013-12-17','12:30:00',1.63),('3355','2013-12-17','12:35:00',1.63),('3355','2013-12-17','12:40:00',1.63),('3355','2013-12-17','12:45:00',1.62),('3355','2013-12-17','12:50:00',1.6),('3355','2013-12-17','12:55:00',1.59),('3355','2013-12-17','13:00:00',1.51),('3355','2013-12-17','13:05:00',1.34),('3355','2013-12-17','13:10:00',1.28),('3355','2013-12-17','13:15:00',1.19),('3355','2013-12-17','13:20:00',1.25),('3355','2013-12-17','13:25:00',1.34),('3355','2013-12-17','13:30:00',1.31),('3355','2013-12-17','13:35:00',1.18),('3355','2013-12-17','13:40:00',1.06),('3355','2013-12-17','13:45:00',1.07),('3355','2013-12-17','13:50:00',1.26),('3355','2013-12-17','13:55:00',1.28),('3355','2013-12-17','14:00:00',1.28),('3355','2013-12-17','14:05:00',1.22),('3355','2013-12-17','14:10:00',1.05),('3355','2013-12-16','09:35:00',1.02),('3355','2013-12-16','09:40:00',1.06),('3355','2013-12-16','09:45:00',1.1),('3355','2013-12-16','09:50:00',1.13),('3355','2013-12-16','09:55:00',1.16),('3355','2013-12-16','10:00:00',1.19),('3355','2013-12-16','10:05:00',1.22),('3355','2013-12-16','10:10:00',1.25),('3355','2013-12-16','10:15:00',1.28),('3355','2013-12-16','10:20:00',1.29),('3355','2013-12-16','10:25:00',1.31),('3355','2013-12-16','10:30:00',1.34),('3355','2013-12-16','10:35:00',1.35),('3355','2013-12-16','10:40:00',1.38),('3355','2013-12-16','10:45:00',1.4),('3355','2013-12-16','10:50:00',1.42),('3355','2013-12-16','10:55:00',1.45),('3355','2013-12-16','11:00:00',1.47),('3355','2013-12-16','11:05:00',1.49),('3355','2013-12-16','11:10:00',1.49),('3355','2013-12-16','11:15:00',1.5),('3355','2013-12-16','11:20:00',1.51),('3355','2013-12-16','11:25:00',1.52),('3355','2013-12-16','11:30:00',1.54),('3355','2013-12-16','11:35:00',1.55),('3355','2013-12-16','11:40:00',1.57),('3355','2013-12-16','11:45:00',1.57),('3355','2013-12-16','11:50:00',1.58),('3355','2013-12-16','11:55:00',1.59),('3355','2013-12-16','12:00:00',1.62),('3355','2013-12-16','12:05:00',1.62),('3355','2013-12-16','12:10:00',1.62),('3355','2013-12-16','12:15:00',1.63),('3355','2013-12-16','12:20:00',1.65),('3355','2013-12-16','12:25:00',1.64),('3355','2013-12-16','12:30:00',1.63),('3355','2013-12-16','12:35:00',1.61),('3355','2013-12-16','12:40:00',1.61),('3355','2013-12-16','12:45:00',1.6),('3355','2013-12-16','12:50:00',1.6),('3355','2013-12-16','12:55:00',1.59),('3355','2013-12-16','13:00:00',1.52),('3355','2013-12-16','13:05:00',1.42),('3355','2013-12-16','13:10:00',1.31),('3355','2013-12-16','13:15:00',1.22),('3355','2013-12-16','13:20:00',1.26),('3355','2013-12-16','13:25:00',1.32),('3355','2013-12-16','13:30:00',1.29),('3355','2013-12-16','13:35:00',1.13),('3355','2013-12-16','13:45:00',1.1),('3355','2013-12-16','13:50:00',1.25),('3355','2013-12-16','13:55:00',1.26),('3355','2013-12-16','14:00:00',1.24),('3355','2013-12-16','14:05:00',1.19),('3355','2013-12-16','14:10:00',1.01),('3355','2013-12-16','14:20:00',1.01),('3355','2013-12-14','09:40:00',1.02),('3355','2013-12-14','09:45:00',1.05),('3355','2013-12-14','09:50:00',1.09),('3355','2013-12-14','09:55:00',1.12),('3355','2013-12-14','10:00:00',1.15),('3355','2013-12-14','10:05:00',1.18),('3355','2013-12-14','10:10:00',1.21),('3355','2013-12-14','10:15:00',1.24),('3355','2013-12-14','10:20:00',1.28),('3355','2013-12-14','10:25:00',1.3),('3355','2013-12-14','10:30:00',1.31),('3355','2013-12-14','10:35:00',1.34),('3355','2013-12-14','10:40:00',1.36),('3355','2013-12-14','10:45:00',1.37),('3355','2013-12-14','10:50:00',1.38),('3355','2013-12-14','10:55:00',1.39),('3355','2013-12-14','11:00:00',1.41),('3355','2013-12-14','11:05:00',1.43),('3355','2013-12-14','11:10:00',1.44),('3355','2013-12-14','11:15:00',1.48),('3355','2013-12-14','11:20:00',1.48),('3355','2013-12-14','11:25:00',1.51),('3355','2013-12-14','11:30:00',1.51),('3355','2013-12-14','11:35:00',1.5),('3355','2013-12-14','11:40:00',1.5),('3355','2013-12-14','11:45:00',1.49),('3355','2013-12-14','11:50:00',1.48),('3355','2013-12-14','11:55:00',1.49),('3355','2013-12-14','12:00:00',1.47),('3355','2013-12-14','12:05:00',1.48),('3355','2013-12-14','12:10:00',1.46),('3355','2013-12-14','12:15:00',1.49),('3355','2013-12-14','12:20:00',1.49),('3355','2013-12-14','12:25:00',1.47),('3355','2013-12-14','12:30:00',1.42),('3355','2013-12-14','12:35:00',1.46),('3355','2013-12-14','12:40:00',1.46),('3355','2013-12-14','12:45:00',1.44),('3355','2013-12-14','12:50:00',1.49),('3355','2013-12-14','12:55:00',1.46),('3355','2013-12-14','13:00:00',1.39),('3355','2013-12-14','13:05:00',1.25),('3355','2013-12-14','13:10:00',1.25),('3355','2013-12-14','13:15:00',1.14),('3355','2013-12-14','13:20:00',1.16),('3355','2013-12-14','13:25:00',1.27),('3355','2013-12-14','13:30:00',1.23),('3355','2013-12-14','13:35:00',1.07),('3355','2013-12-14','13:45:00',1.21),('3355','2013-12-14','13:50:00',1.22),('3355','2013-12-14','13:55:00',1.21),('3355','2013-12-14','14:00:00',1.22),('3355','2013-12-14','14:05:00',1.16),('3355','2013-12-13','09:55:00',1.02),('3355','2013-12-13','10:00:00',1.05),('3355','2013-12-13','10:05:00',1.09),('3355','2013-12-13','10:10:00',1.11),('3355','2013-12-13','10:15:00',1.14),('3355','2013-12-13','10:20:00',1.16),('3355','2013-12-13','10:25:00',1.18),('3355','2013-12-13','10:30:00',1.22),('3355','2013-12-13','10:35:00',1.24),('3355','2013-12-13','10:40:00',1.26),('3355','2013-12-13','10:45:00',1.28),('3355','2013-12-13','10:50:00',1.31),('3355','2013-12-13','10:55:00',1.33),('3355','2013-12-13','11:00:00',1.34),('3355','2013-12-13','11:05:00',1.36),('3355','2013-12-13','11:10:00',1.36),('3355','2013-12-13','11:15:00',1.4),('3355','2013-12-13','11:20:00',1.41),('3355','2013-12-13','11:25:00',1.42),('3355','2013-12-13','11:30:00',1.43),('3355','2013-12-13','11:35:00',1.43),('3355','2013-12-13','11:40:00',1.46),('3355','2013-12-13','11:45:00',1.44),('3355','2013-12-13','11:50:00',1.44),('3355','2013-12-13','11:55:00',1.46),('3355','2013-12-13','12:00:00',1.45),('3355','2013-12-13','12:05:00',1.46),('3355','2013-12-13','12:10:00',1.46),('3355','2013-12-13','12:15:00',1.43),('3355','2013-12-13','12:20:00',1.42),('3355','2013-12-13','12:25:00',1.44),('3355','2013-12-13','12:30:00',1.43),('3355','2013-12-13','12:35:00',1.45),('3355','2013-12-13','12:40:00',1.4),('3355','2013-12-13','12:45:00',1.48),('3355','2013-12-13','12:50:00',1.44),('3355','2013-12-13','12:55:00',1.41),('3355','2013-12-13','13:00:00',1.37),('3355','2013-12-13','13:05:00',1.25),('3355','2013-12-13','13:10:00',1.22),('3355','2013-12-13','13:15:00',1.11),('3355','2013-12-13','13:20:00',1.07),('3355','2013-12-13','13:25:00',1.22),('3355','2013-12-13','13:30:00',1.2),('3355','2013-12-13','13:35:00',1.08),('3355','2013-12-13','13:45:00',1.14),('3355','2013-12-13','13:50:00',1.17),('3355','2013-12-13','13:55:00',1.17),('3355','2013-12-13','14:00:00',1.19),('3355','2013-12-13','14:05:00',1.15),('3355','2013-12-12','09:40:00',1.01),('3355','2013-12-12','09:45:00',1.04),('3355','2013-12-12','09:50:00',1.08),('3355','2013-12-12','09:55:00',1.11),('3355','2013-12-12','10:00:00',1.15),('3355','2013-12-12','10:05:00',1.18),('3355','2013-12-12','10:10:00',1.22),('3355','2013-12-12','10:15:00',1.24),('3355','2013-12-12','10:20:00',1.27),('3355','2013-12-12','10:25:00',1.29),('3355','2013-12-12','10:30:00',1.31),('3355','2013-12-12','10:35:00',1.34),('3355','2013-12-12','10:40:00',1.36),('3355','2013-12-12','10:45:00',1.38),('3355','2013-12-12','10:50:00',1.4),('3355','2013-12-12','10:55:00',1.41),('3355','2013-12-12','11:00:00',1.43),('3355','2013-12-12','11:05:00',1.43),('3355','2013-12-12','11:10:00',1.43),('3355','2013-12-12','11:15:00',1.45),('3355','2013-12-12','11:20:00',1.46),('3355','2013-12-12','11:25:00',1.47),('3355','2013-12-12','11:30:00',1.47),('3355','2013-12-12','11:35:00',1.49),('3355','2013-12-12','11:40:00',1.51),('3355','2013-12-12','11:45:00',1.51),('3355','2013-12-12','11:50:00',1.52),('3355','2013-12-12','11:55:00',1.52),('3355','2013-12-12','12:00:00',1.5),('3355','2013-12-12','12:05:00',1.52),('3355','2013-12-12','12:10:00',1.53),('3355','2013-12-12','12:15:00',1.53),('3355','2013-12-12','12:20:00',1.54),('3355','2013-12-12','12:25:00',1.52),('3355','2013-12-12','12:30:00',1.53),('3355','2013-12-12','12:35:00',1.52),('3355','2013-12-12','12:40:00',1.49),('3355','2013-12-12','12:45:00',1.47),('3355','2013-12-12','12:50:00',1.5),('3355','2013-12-12','12:55:00',1.47),('3355','2013-12-12','13:00:00',1.42),('3355','2013-12-12','13:05:00',1.27),('3355','2013-12-12','13:10:00',1.2),('3355','2013-12-12','13:15:00',1.12),('3355','2013-12-12','13:20:00',1.21),('3355','2013-12-12','13:25:00',1.27),('3355','2013-12-12','13:30:00',1.15),('3355','2013-12-12','13:35:00',1.04),('3355','2013-12-12','13:40:00',1.19),('3355','2013-12-12','13:45:00',1.18),('3355','2013-12-12','13:50:00',1.17),('3355','2013-12-12','13:55:00',1.19),('3355','2013-12-12','14:00:00',1.19),('3355','2013-12-12','14:05:00',1.14),('3355','2013-12-11','09:40:00',1.04),('3355','2013-12-11','09:45:00',1.08),('3355','2013-12-11','09:50:00',1.12),('3355','2013-12-11','09:55:00',1.15),('3355','2013-12-11','10:00:00',1.18),('3355','2013-12-11','10:05:00',1.22),('3355','2013-12-11','10:10:00',1.25),('3355','2013-12-11','10:15:00',1.28),('3355','2013-12-11','10:20:00',1.31),('3355','2013-12-11','10:25:00',1.34),('3355','2013-12-11','10:30:00',1.38),('3355','2013-12-11','10:35:00',1.42),('3355','2013-12-11','10:40:00',1.43),('3355','2013-12-11','10:45:00',1.43),('3355','2013-12-11','10:50:00',1.44),('3355','2013-12-11','10:55:00',1.45),('3355','2013-12-11','11:00:00',1.5),('3355','2013-12-11','11:05:00',1.52),('3355','2013-12-11','11:10:00',1.54),('3355','2013-12-11','11:15:00',1.53),('3355','2013-12-11','11:20:00',1.55),('3355','2013-12-11','11:25:00',1.52),('3355','2013-12-11','11:30:00',1.51),('3355','2013-12-11','11:35:00',1.55),('3355','2013-12-11','11:40:00',1.58),('3355','2013-12-11','11:45:00',1.58),('3355','2013-12-11','11:50:00',1.6),('3355','2013-12-11','11:55:00',1.6),('3355','2013-12-11','12:00:00',1.61),('3355','2013-12-11','12:05:00',1.62),('3355','2013-12-11','12:10:00',1.61),('3355','2013-12-11','12:15:00',1.61),('3355','2013-12-11','12:20:00',1.6),('3355','2013-12-11','12:25:00',1.56),('3355','2013-12-11','12:30:00',1.55),('3355','2013-12-11','12:35:00',1.56),('3355','2013-12-11','12:40:00',1.56),('3355','2013-12-11','12:45:00',1.57),('3355','2013-12-11','12:50:00',1.54),('3355','2013-12-11','12:55:00',1.55),('3355','2013-12-11','13:00:00',1.55),('3355','2013-12-11','13:05:00',1.4),('3355','2013-12-11','13:10:00',1.3),('3355','2013-12-11','13:15:00',1.24),('3355','2013-12-11','13:20:00',1.23),('3355','2013-12-11','13:25:00',1.33),('3355','2013-12-11','13:30:00',1.23),('3355','2013-12-11','13:35:00',1.18),('3355','2013-12-11','13:40:00',1.22),('3355','2013-12-11','13:45:00',1.24),('3355','2013-12-11','13:50:00',1.24),('3355','2013-12-11','13:55:00',1.25),('3355','2013-12-11','14:00:00',1.25),('3355','2013-12-11','14:05:00',1.21),('3355','2013-12-11','14:10:00',1.01),('3355','2013-12-10','09:35:00',1.02),('3355','2013-12-10','09:40:00',1.06),('3355','2013-12-10','09:45:00',1.09),('3355','2013-12-10','09:50:00',1.14),('3355','2013-12-10','09:55:00',1.18),('3355','2013-12-10','10:00:00',1.22),('3355','2013-12-10','10:05:00',1.25),('3355','2013-12-10','10:10:00',1.28),('3355','2013-12-10','10:15:00',1.3),('3355','2013-12-10','10:20:00',1.33),('3355','2013-12-10','10:25:00',1.35),('3355','2013-12-10','10:30:00',1.38),('3355','2013-12-10','10:35:00',1.4),('3355','2013-12-10','10:40:00',1.41),('3355','2013-12-10','10:45:00',1.44),('3355','2013-12-10','10:50:00',1.48),('3355','2013-12-10','10:55:00',1.49),('3355','2013-12-10','11:00:00',1.51),('3355','2013-12-10','11:05:00',1.53),('3355','2013-12-10','11:10:00',1.54),('3355','2013-12-10','11:15:00',1.56),('3355','2013-12-10','11:20:00',1.58),('3355','2013-12-10','11:25:00',1.6),('3355','2013-12-10','11:30:00',1.61),('3355','2013-12-10','11:35:00',1.62),('3355','2013-12-10','11:40:00',1.63),('3355','2013-12-10','11:45:00',1.62),('3355','2013-12-10','11:50:00',1.63),('3355','2013-12-10','11:55:00',1.63),('3355','2013-12-10','12:00:00',1.64),('3355','2013-12-10','12:05:00',1.64),('3355','2013-12-10','12:10:00',1.62),('3355','2013-12-10','12:15:00',1.62),('3355','2013-12-10','12:20:00',1.61),('3355','2013-12-10','12:25:00',1.6),('3355','2013-12-10','12:30:00',1.59),('3355','2013-12-10','12:35:00',1.58),('3355','2013-12-10','12:40:00',1.56),('3355','2013-12-10','12:45:00',1.55),('3355','2013-12-10','12:50:00',1.53),('3355','2013-12-10','12:55:00',1.5),('3355','2013-12-10','13:00:00',1.49),('3355','2013-12-10','13:05:00',1.39),('3355','2013-12-10','13:10:00',1.27),('3355','2013-12-10','13:15:00',1.19),('3355','2013-12-10','13:20:00',1.22),('3355','2013-12-10','13:25:00',1.3),('3355','2013-12-10','13:30:00',1.25),('3355','2013-12-10','13:35:00',1.31),('3355','2013-12-10','13:40:00',1.21),('3355','2013-12-10','13:45:00',1.27),('3355','2013-12-10','13:50:00',1.28),('3355','2013-12-10','13:55:00',1.3),('3355','2013-12-10','14:00:00',1.3),('3355','2013-12-10','14:05:00',1.21),('3355','2013-12-10','14:10:00',1.04),('3355','2013-12-10','14:15:00',1),('3355','2013-12-10','14:20:00',1.07),('3355','2013-12-10','14:25:00',1.06),('3355','2013-12-09','09:40:00',1.04),('3355','2013-12-09','09:45:00',1.07),('3355','2013-12-09','09:50:00',1.1),('3355','2013-12-09','09:55:00',1.14),('3355','2013-12-09','10:00:00',1.18),('3355','2013-12-09','10:05:00',1.23),('3355','2013-12-09','10:10:00',1.44),('3355','2013-12-09','10:15:00',1.51),('3355','2013-12-09','10:20:00',1.66),('3355','2013-12-09','10:25:00',1.39),('3355','2013-12-09','12:30:00',1.14),('3355','2013-12-09','12:45:00',1),('3355','2013-12-09','12:55:00',1.06),('3355','2013-12-09','13:00:00',1.38),('3355','2013-12-09','13:05:00',1.22),('3355','2013-12-09','13:15:00',1.07),('3355','2014-04-21','10:05:00',1.25),('3355','2014-04-21','10:10:00',1.8),('3355','2014-04-21','10:15:00',1.77),('3355','2014-04-21','10:20:00',1.73),('3355','2014-04-21','10:25:00',1.75),('3355','2014-04-21','10:30:00',1.76),('3355','2014-04-21','10:35:00',1.77),('3355','2014-04-21','10:40:00',1.81),('3355','2014-04-21','10:45:00',1.83),('3355','2014-04-21','10:50:00',1.86),('3355','2014-04-21','10:55:00',1.88),('3355','2014-04-21','11:00:00',1.9),('3355','2014-04-21','11:05:00',1.93),('3355','2014-04-21','11:10:00',1.95),('3355','2014-04-21','11:15:00',1.97),('3355','2014-04-21','11:20:00',2),('3355','2014-04-21','11:25:00',2.02),('3355','2014-04-21','11:30:00',2.03),('3355','2014-04-21','11:35:00',2.06),('3355','2014-04-21','11:40:00',2.09),('3355','2014-04-21','11:45:00',2.1),('3355','2014-04-21','11:50:00',2.12),('3355','2014-04-21','11:55:00',2.12),('3355','2014-04-21','12:00:00',2.14),('3355','2014-04-21','12:05:00',2.16),('3355','2014-04-21','12:10:00',2.18),('3355','2014-04-21','12:15:00',2.2),('3355','2014-04-21','12:20:00',2.22),('3355','2014-04-21','12:25:00',2.23),('3355','2014-04-21','12:30:00',2.24),('3355','2014-04-21','12:35:00',2.25),('3355','2014-04-21','12:40:00',2.25),('3355','2014-04-21','12:45:00',2.27),('3355','2014-04-21','12:50:00',2.28),('3355','2014-04-21','12:55:00',2.29),('3355','2014-04-21','13:00:00',2.28),('3355','2014-04-21','13:05:00',2.28),('3355','2014-04-21','13:10:00',2.3),('3355','2014-04-21','13:15:00',2.28),('3355','2014-04-21','13:20:00',2.28),('3355','2014-04-21','13:25:00',2.28),('3355','2014-04-21','13:30:00',2.29),('3355','2014-04-21','13:35:00',2.29),('3355','2014-04-21','13:40:00',2.29),('3355','2014-04-21','13:45:00',2.31),('3355','2014-04-21','13:50:00',2.32),('3355','2014-04-21','13:55:00',2.33),('3355','2014-04-21','14:00:00',2.32),('3355','2014-04-21','14:05:00',2.33),('3355','2014-04-21','14:10:00',2.32),('3355','2014-04-21','14:15:00',2.3),('3355','2014-04-21','14:20:00',2.29),('3355','2014-04-21','14:25:00',2.28),('3355','2014-04-21','14:30:00',2.27),('3355','2014-04-21','14:35:00',2.26),('3355','2014-04-21','14:40:00',2.24),('3355','2014-04-21','14:45:00',2.21),('3355','2014-04-21','14:50:00',2.2),('3355','2014-04-21','14:55:00',2.19),('3355','2014-04-21','15:00:00',2.18),('3355','2014-04-21','15:05:00',2.17),('3355','2014-04-21','15:10:00',2.12),('3355','2014-04-21','15:15:00',2.1),('3355','2014-04-21','15:20:00',2.08),('3355','2014-04-21','15:25:00',2.06),('3355','2014-04-21','15:30:00',2.03),('3355','2014-04-21','15:35:00',2),('3355','2014-04-21','15:40:00',1.96),('3355','2014-04-21','15:45:00',1.94),('3355','2014-04-21','15:50:00',1.91),('3355','2014-04-21','15:55:00',1.88),('3355','2014-04-21','16:00:00',1.86),('3355','2014-04-21','16:05:00',1.83),('3355','2014-04-21','16:10:00',1.74),('3355','2014-04-21','16:15:00',1.33),('3355','2014-04-21','16:20:00',1.77),('3355','2014-04-21','16:25:00',1.7),('3355','2014-04-21','16:30:00',1.6),('3355','2014-04-21','16:35:00',1.63),('3355','2014-04-21','16:40:00',1.6),('3355','2014-04-21','16:45:00',1.56),('3355','2014-04-21','16:50:00',1.52),('3355','2014-04-21','16:55:00',1.47),('3355','2014-04-21','17:00:00',1.42),('3355','2014-04-21','17:05:00',1.38),('3355','2014-04-21','17:10:00',1.34),('3355','2014-04-21','17:15:00',1.29),('3355','2014-04-21','17:20:00',1.25),('3355','2014-04-21','17:25:00',1.21),('3355','2014-04-21','17:30:00',1.16),('3355','2014-04-21','17:35:00',1.11),('3355','2014-04-21','17:40:00',1.01),('3355','2014-04-21','17:45:00',1.02),('3355','2013-12-07','09:35:00',1.04),('3355','2013-12-07','09:40:00',1.08),('3355','2013-12-07','09:45:00',1.1),('3355','2013-12-07','09:50:00',1.13),('3355','2013-12-07','09:55:00',1.16),('3355','2013-12-07','10:00:00',1.18),('3355','2013-12-07','10:05:00',1.21),('3355','2013-12-07','10:10:00',1.23),('3355','2013-12-07','10:15:00',1.26),('3355','2013-12-07','10:20:00',1.28),('3355','2013-12-07','10:25:00',1.31),('3355','2013-12-07','10:30:00',1.33),('3355','2013-12-07','10:35:00',1.38),('3355','2013-12-07','10:40:00',1.4),('3355','2013-12-07','10:45:00',1.41),('3355','2013-12-07','10:50:00',1.4),('3355','2013-12-07','10:55:00',1.41),('3355','2013-12-07','11:00:00',1.43),('3355','2013-12-07','11:05:00',1.44),('3355','2013-12-07','11:10:00',1.46),('3355','2013-12-07','11:15:00',1.47),('3355','2013-12-07','11:20:00',1.49),('3355','2013-12-07','11:25:00',1.49),('3355','2013-12-07','11:30:00',1.5),('3355','2013-12-07','11:35:00',1.51),('3355','2013-12-07','11:40:00',1.51),('3355','2013-12-07','11:45:00',1.5),('3355','2013-12-07','11:50:00',1.51),('3355','2013-12-07','11:55:00',1.51),('3355','2013-12-07','12:00:00',1.51),('3355','2013-12-07','12:05:00',1.51),('3355','2013-12-07','12:10:00',1.52),('3355','2013-12-07','12:15:00',1.51),('3355','2013-12-07','12:20:00',1.51),('3355','2013-12-07','12:25:00',1.51),('3355','2013-12-07','12:30:00',1.5),('3355','2013-12-07','12:35:00',1.51),('3355','2013-12-07','12:40:00',1.49),('3355','2013-12-07','12:45:00',1.48),('3355','2013-12-07','12:50:00',1.48),('3355','2013-12-07','12:55:00',1.46),('3355','2013-12-07','13:00:00',1.48),('3355','2013-12-07','13:05:00',1.46),('3355','2013-12-07','13:10:00',1.38),('3355','2013-12-07','13:15:00',1.35),('3355','2013-12-07','13:20:00',1.26),('3355','2013-12-07','13:25:00',1.3),('3355','2013-12-07','13:30:00',1.24),('3355','2013-12-07','13:35:00',1.28),('3355','2013-12-07','13:40:00',1.25),('3355','2013-12-07','13:45:00',1.24),('3355','2013-12-07','13:50:00',1.26),('3355','2013-12-07','13:55:00',1.25),('3355','2013-12-07','14:00:00',1.25),('3355','2013-12-07','14:05:00',1.24),('3355','2013-12-07','14:10:00',1.06),('3355','2013-12-06','11:50:00',1.12),('3355','2013-12-06','11:55:00',1.17),('3355','2013-12-06','12:00:00',1.1),('3355','2013-12-06','12:20:00',1.33),('3355','2013-12-06','12:40:00',1.15),('3355','2013-12-05','09:30:00',1.04),('3355','2013-12-05','09:35:00',1.07),('3355','2013-12-05','09:40:00',1.11),('3355','2013-12-05','09:45:00',1.14),('3355','2013-12-05','09:50:00',1.17),('3355','2013-12-05','09:55:00',1.21),('3355','2013-12-05','10:00:00',1.24),('3355','2013-12-05','10:05:00',1.28),('3355','2013-12-05','10:10:00',1.31),('3355','2013-12-05','10:15:00',1.34),('3355','2013-12-05','10:20:00',1.36),('3355','2013-12-05','10:25:00',1.38),('3355','2013-12-05','10:30:00',1.4),('3355','2013-12-05','10:35:00',1.43),('3355','2013-12-05','10:40:00',1.44),('3355','2013-12-05','10:45:00',1.47),('3355','2013-12-05','10:50:00',1.48),('3355','2013-12-05','10:55:00',1.49),('3355','2013-12-05','11:00:00',1.51),('3355','2013-12-05','11:05:00',1.53),('3355','2013-12-05','11:10:00',1.52),('3355','2013-12-05','11:15:00',1.55),('3355','2013-12-05','11:20:00',1.55),('3355','2013-12-05','11:25:00',1.56),('3355','2013-12-05','11:30:00',1.55),('3355','2013-12-05','11:35:00',1.58),('3355','2013-12-05','11:40:00',1.58),('3355','2013-12-05','11:45:00',1.58),('3355','2013-12-05','11:50:00',1.59),('3355','2013-12-05','11:55:00',1.58),('3355','2013-12-05','12:00:00',1.55),('3355','2013-12-05','12:05:00',1.58),('3355','2013-12-05','12:10:00',1.56),('3355','2013-12-05','12:15:00',1.58),('3355','2013-12-05','12:20:00',1.57),('3355','2013-12-05','12:25:00',1.54),('3355','2013-12-05','12:30:00',1.52),('3355','2013-12-05','12:35:00',1.46),('3355','2013-12-05','12:40:00',1.55),('3355','2013-12-05','12:45:00',1.51),('3355','2013-12-05','12:50:00',1.41),('3355','2013-12-05','12:55:00',1.3),('3355','2013-12-05','13:00:00',1.18),('3355','2013-12-05','13:05:00',1.47),('3355','2013-12-05','13:10:00',1.42),('3355','2013-12-05','13:15:00',1.36),('3355','2013-12-05','13:20:00',1.33),('3355','2013-12-05','13:25:00',1.12),('3355','2013-12-05','13:30:00',1.14),('3355','2013-12-05','13:35:00',1.22),('3355','2013-12-05','13:40:00',1.2),('3355','2013-12-05','13:45:00',1.26),('3355','2013-12-05','13:50:00',1.22),('3355','2013-12-05','13:55:00',1.22),('3355','2013-12-05','14:00:00',1.21),('3355','2013-12-05','14:05:00',1.2),('3355','2013-12-05','14:10:00',1.08),('3355','2013-12-04','09:20:00',1.03),('3355','2013-12-04','09:25:00',1.07),('3355','2013-12-04','09:30:00',1.11),('3355','2013-12-04','09:35:00',1.15),('3355','2013-12-04','09:40:00',1.19),('3355','2013-12-04','09:45:00',1.23),('3355','2013-12-04','09:50:00',1.26),('3355','2013-12-04','09:55:00',1.29),('3355','2013-12-04','10:00:00',1.33),('3355','2013-12-04','10:05:00',1.36),('3355','2013-12-04','10:10:00',1.38),('3355','2013-12-04','10:15:00',1.41),('3355','2013-12-04','10:20:00',1.43),('3355','2013-12-04','10:25:00',1.46),('3355','2013-12-04','10:30:00',1.49),('3355','2013-12-04','10:35:00',1.51),('3355','2013-12-04','10:40:00',1.54),('3355','2013-12-04','10:45:00',1.56),('3355','2013-12-04','10:50:00',1.57),('3355','2013-12-04','10:55:00',1.59),('3355','2013-12-04','11:00:00',1.61),('3355','2013-12-04','11:05:00',1.62),('3355','2013-12-04','11:10:00',1.63),('3355','2013-12-04','11:15:00',1.64),('3355','2013-12-04','11:20:00',1.65),('3355','2013-12-04','11:25:00',1.66),('3355','2013-12-04','11:30:00',1.67),('3355','2013-12-04','11:35:00',1.68),('3355','2013-12-04','11:40:00',1.67),('3355','2013-12-04','11:45:00',1.69),('3355','2013-12-04','11:50:00',1.69),('3355','2013-12-04','11:55:00',1.69),('3355','2013-12-04','12:00:00',1.7),('3355','2013-12-04','12:05:00',1.69),('3355','2013-12-04','12:10:00',1.7),('3355','2013-12-04','12:15:00',1.68),('3355','2013-12-04','12:20:00',1.68),('3355','2013-12-04','12:25:00',1.68),('3355','2013-12-04','12:30:00',1.68),('3355','2013-12-04','12:35:00',1.67),('3355','2013-12-04','12:40:00',1.65),('3355','2013-12-04','12:45:00',1.66),('3355','2013-12-04','12:50:00',1.65),('3355','2013-12-04','12:55:00',1.64),('3355','2013-12-04','13:00:00',1.62),('3355','2013-12-04','13:05:00',1.61),('3355','2013-12-04','13:10:00',1.59),('3355','2013-12-04','13:15:00',1.42),('3355','2013-12-04','13:20:00',1.36),('3355','2013-12-04','13:25:00',1.27),('3355','2013-12-04','13:30:00',1.38),('3355','2013-12-04','13:35:00',1.32),('3355','2013-12-04','13:40:00',1.33),('3355','2013-12-04','13:45:00',1.35),('3355','2013-12-04','13:50:00',1.36),('3355','2013-12-04','13:55:00',1.36),('3355','2013-12-04','14:00:00',1.37),('3355','2013-12-04','14:05:00',1.35),('3355','2013-12-04','14:10:00',1.23),('3355','2013-12-04','14:15:00',1.04),('3355','2013-12-04','14:20:00',1.08),('3355','2013-12-04','14:25:00',1.01),('3355','2013-12-03','09:50:00',1.03),('3355','2013-12-03','10:00:00',1.32),('3355','2013-12-03','10:05:00',1.35),('3355','2013-12-03','10:10:00',1.37),('3355','2013-12-03','10:15:00',1.4),('3355','2013-12-03','10:20:00',1.42),('3355','2013-12-03','10:25:00',1.45),('3355','2013-12-03','10:30:00',1.47),('3355','2013-12-03','10:35:00',1.49),('3355','2013-12-03','10:40:00',1.51),('3355','2013-12-03','10:45:00',1.53),('3355','2013-12-03','10:50:00',1.56),('3355','2013-12-03','10:55:00',1.59),('3355','2013-12-03','11:00:00',1.62),('3355','2013-12-03','11:05:00',1.64),('3355','2013-12-03','11:10:00',1.65),('3355','2013-12-03','11:15:00',1.67),('3355','2013-12-03','11:20:00',1.68),('3355','2013-12-03','11:25:00',1.68),('3355','2013-12-03','11:30:00',1.67),('3355','2013-12-03','11:35:00',1.69),('3355','2013-12-03','11:40:00',1.69),('3355','2013-12-03','11:45:00',1.7),('3355','2013-12-03','11:50:00',1.72),('3355','2013-12-03','11:55:00',1.72),('3355','2013-12-03','12:00:00',1.72),('3355','2013-12-03','12:05:00',1.73),('3355','2013-12-03','12:10:00',1.74),('3355','2013-12-03','12:15:00',1.75),('3355','2013-12-03','12:20:00',1.76),('3355','2013-12-03','12:25:00',1.78),('3355','2013-12-03','12:30:00',1.79),('3355','2013-12-03','12:35:00',1.8),('3355','2013-12-03','12:40:00',1.82),('3355','2013-12-03','12:45:00',1.85),('3355','2013-12-03','12:50:00',1.9),('3355','2013-12-03','12:55:00',1.94),('3355','2013-12-03','13:00:00',1.97),('3355','2013-12-03','13:05:00',2),('3355','2013-12-03','13:10:00',2),('3355','2013-12-03','13:15:00',1.87),('3355','2013-12-03','13:20:00',1.78),('3355','2013-12-03','13:25:00',1.68),('3355','2013-12-03','13:30:00',1.5),('3355','2013-12-03','13:35:00',1.61),('3355','2013-12-03','13:40:00',1.55),('3355','2013-12-03','13:45:00',1.5),('3355','2013-12-03','13:50:00',1.47),('3355','2013-12-03','13:55:00',1.47),('3355','2013-12-03','14:00:00',1.47),('3355','2013-12-03','14:05:00',1.39),('3355','2013-12-03','14:10:00',1.31),('3355','2013-12-03','14:15:00',1.13),('3355','2013-12-03','14:20:00',1),('3355','2013-11-30','09:20:00',1.05),('3355','2013-11-30','09:25:00',1.05),('3355','2013-11-30','09:30:00',1.06),('3355','2013-11-30','09:35:00',1.31),('3355','2013-11-30','09:40:00',1.23),('3355','2013-11-30','09:45:00',1.09),('3355','2013-11-29','09:20:00',1.04),('3355','2013-11-29','09:25:00',1.08),('3355','2013-11-29','09:30:00',1.12),('3355','2013-11-29','09:35:00',1.16),('3355','2013-11-29','09:40:00',1.21),('3355','2013-11-29','09:45:00',1.24),('3355','2013-11-29','09:50:00',1.28),('3355','2013-11-29','09:55:00',1.32),('3355','2013-11-29','10:00:00',1.35),('3355','2013-11-29','10:05:00',1.38),('3355','2013-11-29','10:10:00',1.41),('3355','2013-11-29','10:15:00',1.43),('3355','2013-11-29','10:20:00',1.46),('3355','2013-11-29','10:25:00',1.48),('3355','2013-11-29','10:30:00',1.51),('3355','2013-11-29','10:35:00',1.53),('3355','2013-11-29','10:40:00',1.56),('3355','2013-11-29','10:45:00',1.58),('3355','2013-11-29','10:50:00',1.6),('3355','2013-11-29','10:55:00',1.62),('3355','2013-11-29','11:00:00',1.63),('3355','2013-11-29','11:05:00',1.65),('3355','2013-11-29','11:10:00',1.67),('3355','2013-11-29','11:15:00',1.68),('3355','2013-11-29','11:20:00',1.7),('3355','2013-11-29','11:25:00',1.71),('3355','2013-11-29','11:30:00',1.71),('3355','2013-11-29','11:35:00',1.72),('3355','2013-11-29','11:40:00',1.73),('3355','2013-11-29','11:45:00',1.73),('3355','2013-11-29','11:50:00',1.74),('3355','2013-11-29','11:55:00',1.75),('3355','2013-11-29','12:00:00',1.74),('3355','2013-11-29','12:05:00',1.74),('3355','2013-11-29','12:10:00',1.75),('3355','2013-11-29','12:15:00',1.74),('3355','2013-11-29','12:20:00',1.73),('3355','2013-11-29','12:25:00',1.72),('3355','2013-11-29','12:30:00',1.71),('3355','2013-11-29','12:35:00',1.71),('3355','2013-11-29','12:40:00',1.71),('3355','2013-11-29','12:45:00',1.7),('3355','2013-11-29','12:50:00',1.69),('3355','2013-11-29','12:55:00',1.68),('3355','2013-11-29','13:00:00',1.66),('3355','2013-11-29','13:05:00',1.64),('3355','2013-11-29','13:10:00',1.62),('3355','2013-11-29','13:15:00',1.61),('3355','2013-11-29','13:20:00',1.53),('3355','2013-11-29','13:25:00',1.31),('3355','2013-11-29','13:30:00',1.31),('3355','2013-11-29','13:35:00',1.31),('3355','2013-11-29','13:40:00',1.39),('3355','2013-11-29','13:45:00',1.39),('3355','2013-11-29','13:50:00',1.39),('3355','2013-11-29','13:55:00',1.4),('3355','2013-11-29','14:00:00',1.38),('3355','2013-11-29','14:05:00',1.35),('3355','2013-11-29','14:10:00',1.32),('3355','2013-11-29','14:15:00',1.23),('3355','2013-11-29','14:20:00',1.01),('3355','2013-11-29','14:25:00',1.1),('3355','2013-11-29','14:30:00',1.06),('3355','2013-11-29','14:35:00',1.01),('3355','2014-04-20','08:30:00',1.16),('3355','2014-04-20','08:35:00',1.09),('3355','2014-04-20','08:40:00',1.13),('3355','2014-04-20','09:15:00',1.25),('3355','2014-04-20','09:20:00',1.39),('3355','2014-04-20','09:25:00',1.46),('3355','2014-04-20','09:30:00',1.68),('3355','2014-04-20','09:35:00',1.36),('3355','2014-04-20','09:40:00',1.02),('3355','2014-04-20','10:00:00',1.16),('3355','2014-04-20','10:05:00',1.41),('3355','2014-04-20','10:10:00',1.36),('3355','2014-04-20','10:15:00',1.65),('3355','2014-04-20','10:20:00',1.62),('3355','2014-04-20','10:25:00',1.39),('3355','2014-04-20','10:30:00',1.33),('3355','2014-04-20','10:35:00',1.43),('3355','2014-04-20','10:40:00',1.41),('3355','2014-04-20','10:45:00',1.4),('3355','2014-04-20','10:50:00',1.55),('3355','2014-04-20','10:55:00',1.58),('3355','2014-04-20','11:00:00',1.45),('3355','2014-04-20','11:05:00',1.83),('3355','2014-04-20','11:10:00',1.66),('3355','2014-04-20','11:15:00',1.85),('3355','2014-04-20','11:20:00',2.01),('3355','2014-04-20','11:25:00',1.95),('3355','2014-04-20','11:30:00',2.13),('3355','2014-04-20','11:35:00',2.18),('3355','2014-04-20','11:40:00',1.01),('3355','2014-04-20','11:45:00',1.87),('3355','2014-04-20','11:50:00',1.72),('3355','2014-04-20','11:55:00',1.22),('3355','2014-04-20','12:00:00',1.55),('3355','2014-04-20','12:05:00',2.27),('3355','2014-04-20','12:10:00',1.72),('3355','2014-04-20','12:15:00',1.82),('3355','2014-04-20','12:20:00',1.19),('3355','2014-04-20','12:25:00',2.61),('3355','2014-04-20','12:30:00',2.41),('3355','2014-04-20','12:35:00',2.34),('3355','2014-04-20','12:40:00',2.33),('3355','2014-04-20','12:45:00',2.37),('3355','2014-04-20','12:50:00',2.39),('3355','2014-04-20','12:55:00',2.4),('3355','2014-04-20','13:00:00',2.41),('3355','2014-04-20','13:05:00',2.42),('3355','2014-04-20','13:10:00',2.44),('3355','2014-04-20','13:15:00',2.46),('3355','2014-04-20','13:20:00',2.39),('3355','2014-04-20','13:25:00',2.39),('3355','2014-04-20','13:30:00',2.4),('3355','2014-04-20','13:35:00',2.39),('3355','2014-04-20','13:40:00',2.4),('3355','2014-04-20','13:45:00',2.4),('3355','2014-04-20','13:50:00',2.38),('3355','2014-04-20','13:55:00',2.38),('3355','2014-04-20','14:00:00',2.37),('3355','2014-04-20','14:05:00',2.38),('3355','2014-04-20','14:10:00',2.37),('3355','2014-04-20','14:15:00',2.44),('3355','2014-04-20','14:20:00',1.93),('3355','2014-04-20','14:25:00',1.78),('3355','2014-04-20','14:30:00',1.73),('3355','2014-04-20','14:35:00',1.37),('3355','2014-04-20','14:40:00',1.34),('3355','2014-04-20','14:45:00',1.45),('3355','2014-04-20','14:50:00',1.4),('3355','2014-04-20','14:55:00',1.58),('3355','2014-04-20','15:00:00',1.98),('3355','2014-04-20','15:05:00',2.06),('3355','2014-04-20','15:10:00',2.08),('3355','2014-04-20','15:15:00',2.2),('3355','2014-04-20','15:20:00',2.07),('3355','2014-04-20','15:25:00',2.11),('3355','2014-04-20','15:30:00',2.07),('3355','2014-04-20','15:35:00',2.03),('3355','2014-04-20','15:40:00',2.07),('3355','2014-04-20','15:45:00',1.78),('3355','2014-04-20','15:50:00',1.3),('3355','2014-04-20','15:55:00',2),('3355','2014-04-20','16:00:00',1.92),('3355','2014-04-20','16:05:00',1.89),('3355','2014-04-20','16:10:00',1.86),('3355','2014-04-20','16:15:00',1.85),('3355','2014-04-20','16:20:00',1.86),('3355','2014-04-20','16:25:00',1.49),('3355','2014-04-20','16:30:00',1.82),('3355','2014-04-20','16:35:00',1.67),('3355','2014-04-20','16:40:00',1.75),('3355','2014-04-20','16:45:00',1.47),('3355','2014-04-20','16:50:00',1.51),('3355','2014-04-20','16:55:00',1.59),('3355','2014-04-20','17:00:00',1.5),('3355','2014-04-20','17:05:00',1.43),('3355','2014-04-20','17:10:00',1.36),('3355','2014-04-20','17:15:00',1.3),('3355','2014-04-20','17:20:00',1.26),('3355','2014-04-20','17:25:00',1.21),('3355','2014-04-20','17:30:00',1.16),('3355','2014-04-20','17:35:00',1.11),('3355','2014-04-20','17:40:00',1.06),('3355','2014-04-20','17:45:00',1),('3355','2013-11-27','11:10:00',1.25),('3355','2013-11-27','11:30:00',1.41),('3355','2013-11-27','11:35:00',1.08),('3355','2013-11-27','11:50:00',1.23),('3355','2013-11-27','11:55:00',1.99),('3355','2013-11-27','12:00:00',1.93),('3355','2013-11-27','12:05:00',1.66),('3355','2013-11-27','12:15:00',1.22),('3355','2013-11-27','12:20:00',1.29),('3355','2013-11-27','12:30:00',1.64),('3355','2013-11-27','12:35:00',1.19),('3355','2013-11-26','09:40:00',1.17),('3355','2013-11-26','09:55:00',1.13),('3355','2013-11-26','10:00:00',1.38),('3355','2013-11-26','10:05:00',1.31),('3355','2013-11-26','10:25:00',1.09),('3355','2013-11-26','10:30:00',1.52),('3355','2013-11-26','10:35:00',1.69),('3355','2013-11-26','10:40:00',1.68),('3355','2013-11-26','10:45:00',1.72),('3355','2013-11-26','10:50:00',1.74),('3355','2013-11-26','10:55:00',1.77),('3355','2013-11-26','11:00:00',1.88),('3355','2013-11-26','11:05:00',1.64),('3355','2013-11-26','11:10:00',1.96),('3355','2013-11-26','11:15:00',2.09),('3355','2013-11-26','11:20:00',1.97),('3355','2013-11-26','11:25:00',2),('3355','2013-11-26','11:30:00',2.03),('3355','2013-11-26','11:35:00',2.12),('3355','2013-11-26','11:40:00',2),('3355','2013-11-26','11:45:00',1.93),('3355','2013-11-26','11:50:00',1.78),('3355','2013-11-26','12:20:00',1.92),('3355','2013-11-26','12:25:00',1.89),('3355','2013-11-26','12:30:00',1.85),('3355','2013-11-26','12:35:00',1.84),('3355','2013-11-26','12:40:00',1.84),('3355','2013-11-26','12:45:00',1.83),('3355','2013-11-26','12:50:00',1.82),('3355','2013-11-26','12:55:00',1.82),('3355','2013-11-26','13:00:00',1.81),('3355','2013-11-26','13:05:00',1.8),('3355','2013-11-26','13:10:00',1.78),('3355','2013-11-26','13:15:00',1.77),('3355','2013-11-26','13:20:00',1.75),('3355','2013-11-26','13:25:00',1.73),('3355','2013-11-26','13:30:00',1.53),('3355','2013-11-26','13:35:00',1.43),('3355','2013-11-26','13:40:00',1.46),('3355','2013-11-26','13:45:00',1.56),('3355','2013-11-26','13:50:00',1.59),('3355','2013-11-26','13:55:00',1.62),('3355','2013-11-26','14:00:00',1.54),('3355','2013-11-26','14:05:00',1.02),('3355','2013-11-26','14:10:00',1.86),('3355','2013-11-26','14:15:00',1.9),('3355','2013-11-26','14:20:00',1.49),('3355','2013-11-26','14:40:00',1.06),('3355','2013-11-26','14:45:00',1.09),('3355','2013-11-26','14:50:00',1.19),('3355','2013-11-26','14:55:00',1.21),('3355','2013-11-26','15:00:00',1.09),('3355','2013-11-25','08:55:00',1.06),('3355','2013-11-25','09:00:00',1.17),('3355','2013-11-25','09:05:00',1.22),('3355','2013-11-25','09:10:00',1.24),('3355','2013-11-25','09:15:00',1.31),('3355','2013-11-25','09:20:00',1.33),('3355','2013-11-25','09:25:00',1.07),('3355','2013-11-25','09:30:00',1.09),('3355','2013-11-25','09:35:00',1.36),('3355','2013-11-25','09:40:00',1.48),('3355','2013-11-25','10:00:00',1.01),('3355','2013-11-25','10:05:00',1.02),('3355','2013-11-25','10:10:00',1.07),('3355','2013-11-25','10:15:00',1.08),('3355','2013-11-25','10:25:00',1.14),('3355','2013-11-25','10:30:00',1.17),('3355','2013-11-25','10:35:00',1.15),('3355','2013-11-25','10:40:00',2.01),('3355','2013-11-25','10:45:00',1.75),('3355','2013-11-25','10:50:00',1.75),('3355','2013-11-25','10:55:00',1.32),('3355','2013-11-25','11:00:00',1.74),('3355','2013-11-25','11:05:00',1.8),('3355','2013-11-25','11:10:00',2.04),('3355','2013-11-25','11:15:00',1.47),('3355','2013-11-25','11:20:00',1.03),('3355','2013-11-25','11:55:00',1.05),('3355','2013-11-25','12:10:00',1.03),('3355','2013-11-25','12:40:00',1.61),('3355','2013-11-25','12:45:00',1.86),('3355','2013-11-25','12:50:00',1.42),('3355','2013-11-25','12:55:00',1.55),('3355','2013-11-25','13:00:00',2.04),('3355','2013-11-25','13:05:00',2.15),('3355','2013-11-25','13:10:00',1.53),('3355','2013-11-25','13:15:00',1.33),('3355','2013-11-25','13:20:00',1.45),('3355','2013-11-23','10:40:00',1.66),('3355','2013-11-21','09:45:00',1.31),('3355','2013-11-21','09:50:00',1.13),('3355','2013-11-21','09:55:00',1.01),('3355','2013-11-21','10:05:00',1.55),('3355','2013-11-21','10:10:00',1.36),('3355','2013-11-21','10:15:00',1.51),('3355','2013-11-21','10:20:00',1.49),('3355','2013-11-21','10:25:00',1),('3355','2013-11-21','10:30:00',1.09),('3355','2013-11-21','10:35:00',1.42),('3355','2013-11-21','10:40:00',1.51),('3355','2013-11-21','10:45:00',1.41),('3355','2013-11-21','11:30:00',1.34),('3355','2013-11-21','11:35:00',1.47),('3355','2013-11-21','11:40:00',1.77),('3355','2013-11-21','11:50:00',1.84),('3355','2013-11-21','11:55:00',1.66),('3355','2013-11-21','12:00:00',1.21),('3355','2013-11-21','12:05:00',1.42),('3355','2013-11-21','12:10:00',1.82),('3355','2013-11-21','12:15:00',1.81),('3355','2013-11-21','12:20:00',1.81),('3355','2013-11-21','12:25:00',1.84),('3355','2013-11-21','12:30:00',1.93),('3355','2013-11-21','12:35:00',1.94),('3355','2013-11-21','12:40:00',1.99),('3355','2013-11-21','12:45:00',1.99),('3355','2013-11-21','12:50:00',1.82),('3355','2013-11-21','12:55:00',1.99),('3355','2013-11-21','13:00:00',1.95),('3355','2013-11-21','13:05:00',1.97),('3355','2013-11-21','13:10:00',1.78),('3355','2013-11-21','13:15:00',1.82),('3355','2013-11-21','13:20:00',1.85),('3355','2013-11-21','13:25:00',1.67),('3355','2013-11-21','13:40:00',1.32),('3355','2013-11-21','13:45:00',1.66),('3355','2013-11-21','14:00:00',1.64),('3355','2013-11-21','14:05:00',1.18),('3355','2013-11-20','09:15:00',1.03),('3355','2013-11-20','09:25:00',1.18),('3355','2013-11-20','09:30:00',1.26),('3355','2013-11-20','10:15:00',1.05),('3355','2013-11-20','11:45:00',1.72),('3355','2013-11-20','11:50:00',2.33),('3355','2013-11-20','11:55:00',1.23),('3355','2013-11-20','12:55:00',1.26),('3355','2013-11-20','13:00:00',1.66),('3355','2013-11-20','13:05:00',1.21),('3355','2013-11-20','13:20:00',1.01),('3355','2013-11-20','13:40:00',1.05),('3355','2013-11-19','09:40:00',1.24),('3355','2013-11-19','09:45:00',1.21),('3355','2013-11-19','11:20:00',1.56),('3355','2013-11-19','11:25:00',1.4),('3355','2013-11-19','11:30:00',1.75),('3355','2013-11-19','11:35:00',1.73),('3355','2013-11-19','11:40:00',1.4),('3355','2013-11-19','11:45:00',1.6),('3355','2013-11-19','11:50:00',1.63),('3355','2013-11-19','11:55:00',1.63),('3355','2013-11-19','12:00:00',1.47),('3355','2013-11-19','12:05:00',1.42),('3355','2013-11-19','12:10:00',1.59),('3355','2013-11-19','12:15:00',1.64),('3355','2013-11-19','12:45:00',1.1),('3355','2013-11-19','12:55:00',1.82),('3355','2013-11-19','13:00:00',1.75),('3355','2013-11-19','13:15:00',1.19),('3355','2013-11-19','13:20:00',1.5),('3355','2013-11-19','15:30:00',1.06),('3355','2013-11-18','09:35:00',1.17),('3355','2013-11-18','10:15:00',1.03),('3355','2014-04-19','08:35:00',1.17),('3355','2014-04-19','08:45:00',1.02),('3355','2014-04-19','09:30:00',1.08),('3355','2014-04-19','09:35:00',1.12),('3355','2014-04-19','11:20:00',1.56),('3355','2014-04-19','11:25:00',1.38),('3355','2014-04-19','11:30:00',1.44),('3355','2014-04-19','11:35:00',1.28),('3355','2014-04-19','11:40:00',1.2),('3355','2014-04-19','11:45:00',1.26),('3355','2014-04-19','11:50:00',1.01),('3355','2014-04-19','14:45:00',1.02),('3355','2014-04-19','15:50:00',1.86),('3355','2014-04-19','15:55:00',1.91),('3355','2014-04-19','16:20:00',1.16),('3355','2014-04-19','16:25:00',1.14),('3355','2014-04-19','16:30:00',1.8),('3355','2013-11-17','08:50:00',1.07),('3355','2013-11-17','08:55:00',1.18),('3355','2013-11-17','09:05:00',1.03),('3355','2013-11-17','09:10:00',1.06),('3355','2013-11-17','09:15:00',1.12),('3355','2013-11-17','09:20:00',1.15),('3355','2013-11-17','09:25:00',1.17),('3355','2013-11-17','09:30:00',1.21),('3355','2013-11-17','09:35:00',1.22),('3355','2013-11-17','09:40:00',1.25),('3355','2013-11-17','09:45:00',1.28),('3355','2013-11-17','09:50:00',1.31),('3355','2013-11-17','09:55:00',1.34),('3355','2013-11-17','10:00:00',1.37),('3355','2013-11-17','10:05:00',1.4),('3355','2013-11-17','10:10:00',1.43),('3355','2013-11-17','10:15:00',1.45),('3355','2013-11-17','10:20:00',1.48),('3355','2013-11-17','10:25:00',1.49),('3355','2013-11-17','10:30:00',1.52),('3355','2013-11-17','10:35:00',1.53),('3355','2013-11-17','10:40:00',1.54),('3355','2013-11-17','10:45:00',1.56),('3355','2013-11-17','10:50:00',1.58),('3355','2013-11-17','10:55:00',1.6),('3355','2013-11-17','11:00:00',1.61),('3355','2013-11-17','11:05:00',1.62),('3355','2013-11-17','11:10:00',1.62),('3355','2013-11-17','11:15:00',1.64),('3355','2013-11-17','11:20:00',1.64),('3355','2013-11-17','11:25:00',1.66),('3355','2013-11-17','11:30:00',1.66),('3355','2013-11-17','11:35:00',1.66),('3355','2013-11-17','11:40:00',1.66),('3355','2013-11-17','11:45:00',1.68),('3355','2013-11-17','11:50:00',1.67),('3355','2013-11-17','11:55:00',1.67),('3355','2013-11-17','12:00:00',1.67),('3355','2013-11-17','12:05:00',1.67),('3355','2013-11-17','12:10:00',1.66),('3355','2013-11-17','12:15:00',1.67),('3355','2013-11-17','12:20:00',1.67),('3355','2013-11-17','12:25:00',1.67),('3355','2013-11-17','12:30:00',1.67),('3355','2013-11-17','12:35:00',1.67),('3355','2013-11-17','12:40:00',1.65),('3355','2013-11-17','12:45:00',1.63),('3355','2013-11-17','12:50:00',1.62),('3355','2013-11-17','12:55:00',1.6),('3355','2013-11-17','13:00:00',1.59),('3355','2013-11-17','13:05:00',1.57),('3355','2013-11-17','13:10:00',1.56),('3355','2013-11-17','13:15:00',1.55),('3355','2013-11-17','13:20:00',1.53),('3355','2013-11-17','13:25:00',1.53),('3355','2013-11-17','13:30:00',1.52),('3355','2013-11-17','13:35:00',1.1),('3355','2013-11-17','13:40:00',1.33),('3355','2013-11-17','14:00:00',1.35),('3355','2013-11-17','14:05:00',1.3),('3355','2013-11-17','14:10:00',1.27),('3355','2013-11-17','14:15:00',1.26),('3355','2013-11-17','14:20:00',1.23),('3355','2013-11-17','14:25:00',1.18),('3355','2013-11-17','14:30:00',1.07),('3355','2013-11-17','14:35:00',1.05),('3355','2013-11-15','10:55:00',1.16),('3355','2013-11-15','11:20:00',1.05),('3355','2013-11-15','11:25:00',1.67),('3355','2013-11-15','11:35:00',1.01),('3355','2013-11-15','11:40:00',1.1),('3355','2013-11-15','12:25:00',1.15),('3355','2013-11-15','13:45:00',1.08),('3355','2013-11-15','13:50:00',1.13),('3355','2013-11-14','09:05:00',1.01),('3355','2013-11-14','09:15:00',1.03),('3355','2013-11-14','09:20:00',1.15),('3355','2013-11-14','09:25:00',1.15),('3355','2013-11-14','09:30:00',1.19),('3355','2013-11-14','09:35:00',1.22),('3355','2013-11-14','09:40:00',1.24),('3355','2013-11-14','09:45:00',1.17),('3355','2013-11-14','10:05:00',1.01),('3355','2013-11-14','10:15:00',1.48),('3355','2013-11-14','10:20:00',1.5),('3355','2013-11-14','10:25:00',1.5),('3355','2013-11-14','10:30:00',1.5),('3355','2013-11-14','10:35:00',1.49),('3355','2013-11-14','10:40:00',1.51),('3355','2013-11-14','10:45:00',1.54),('3355','2013-11-14','10:50:00',1.56),('3355','2013-11-14','10:55:00',1.57),('3355','2013-11-14','11:00:00',1.56),('3355','2013-11-14','11:05:00',1.62),('3355','2013-11-14','11:10:00',1.65),('3355','2013-11-14','11:15:00',1.7),('3355','2013-11-14','11:20:00',1.72),('3355','2013-11-14','11:25:00',1.74),('3355','2013-11-14','11:30:00',1.75),('3355','2013-11-14','11:35:00',1.73),('3355','2013-11-14','11:40:00',1.49),('3355','2013-11-14','11:50:00',1.08),('3355','2013-11-14','12:00:00',1.86),('3355','2013-11-14','12:05:00',1.03),('3355','2013-11-13','10:20:00',1.02),('3355','2013-11-13','10:30:00',1.33),('3355','2013-11-13','10:35:00',2.09),('3355','2013-11-13','10:40:00',1.12),('3355','2013-11-13','10:45:00',1.64),('3355','2013-11-13','10:50:00',2.09),('3355','2013-11-13','10:55:00',2.04),('3355','2013-11-13','11:00:00',1.85),('3355','2013-11-13','13:55:00',1.13),('3355','2013-11-13','14:00:00',1.21),('3355','2013-11-13','14:05:00',1.2),('3355','2013-11-13','14:10:00',1.03),('3355','2013-11-13','14:15:00',1.13),('3355','2013-11-13','14:25:00',1.05),('3355','2013-11-12','11:40:00',1.59),('3355','2013-11-12','11:50:00',1),('3355','2013-11-12','12:00:00',1.68),('3355','2013-11-12','12:30:00',2.31),('3355','2013-11-12','12:35:00',1.89),('3355','2013-11-12','12:40:00',1.13),('3355','2013-11-12','12:45:00',1.08),('3355','2013-11-12','12:55:00',1.07),('3355','2013-11-12','13:00:00',1.03),('3355','2013-11-12','13:05:00',1.22),('3355','2013-11-12','13:10:00',1.91),('3355','2013-11-12','13:15:00',2.22),('3355','2013-11-12','13:20:00',1.54),('3355','2013-11-12','13:25:00',1.32),('3355','2013-11-12','13:35:00',1.17),('3355','2013-11-12','13:40:00',1.77),('3355','2013-11-12','13:45:00',1.12),('3355','2013-11-12','14:15:00',1.78),('3355','2013-11-12','14:20:00',1.74),('3355','2013-11-12','14:25:00',1.7),('3355','2013-11-12','14:30:00',1.5),('3355','2013-11-12','14:40:00',1.24),('3355','2013-11-12','14:45:00',1.03),('3355','2013-11-12','14:50:00',1.02),('3355','2013-11-11','10:15:00',1.29),('3355','2013-11-11','10:20:00',1.84),('3355','2013-11-11','11:10:00',1.49),('3355','2013-11-11','11:15:00',1.13),('3355','2013-11-11','11:25:00',1.75),('3355','2013-11-11','11:35:00',1.95),('3355','2013-11-11','11:40:00',2.36),('3355','2013-11-11','11:45:00',2.15),('3355','2013-11-11','11:50:00',2.22),('3355','2013-11-11','11:55:00',2.04),('3355','2013-11-11','12:00:00',1.96),('3355','2013-11-11','12:05:00',1.92),('3355','2013-11-11','12:10:00',1.84),('3355','2013-11-11','12:15:00',1.85),('3355','2013-11-11','12:20:00',1.97),('3355','2013-11-11','12:25:00',1.63),('3355','2013-11-11','12:30:00',1.63),('3355','2013-11-11','12:40:00',1.4),('3355','2013-11-11','13:10:00',1.92),('3355','2013-11-11','14:20:00',1.49),('3355','2013-11-11','14:25:00',1.48),('3355','2013-11-11','14:30:00',1.4),('3355','2013-11-11','14:35:00',1.36),('3355','2013-11-11','14:40:00',1.13),('3355','2013-11-10','08:55:00',1.08),('3355','2013-11-10','09:20:00',1.1),('3355','2013-11-10','09:25:00',1.25),('3355','2013-11-10','09:30:00',1.11),('3355','2013-11-10','09:35:00',1.1),('3355','2013-11-10','09:40:00',1.19),('3355','2013-11-10','09:45:00',1.31),('3355','2013-11-10','09:50:00',1.37),('3355','2013-11-10','09:55:00',1.36),('3355','2013-11-10','10:00:00',1.27),('3355','2013-11-10','10:05:00',1.48),('3355','2013-11-10','10:10:00',1.6),('3355','2013-11-10','10:15:00',1.6),('3355','2013-11-10','10:20:00',1.44),('3355','2013-11-10','10:25:00',1.67),('3355','2013-11-10','10:30:00',1.83),('3355','2013-11-10','10:35:00',1.62),('3355','2013-11-10','10:40:00',1.07),('3355','2013-11-10','10:45:00',1.77),('3355','2013-11-10','10:50:00',1.59),('3355','2013-11-10','10:55:00',1.76),('3355','2013-11-10','11:00:00',1.41),('3355','2013-11-10','11:40:00',1.14),('3355','2013-11-10','11:45:00',1.29),('3355','2013-11-10','12:15:00',1.88),('3355','2013-11-10','12:20:00',1.48),('3355','2013-11-10','12:25:00',1.84),('3355','2013-11-10','12:30:00',1.28),('3355','2013-11-10','12:35:00',1.02),('3355','2013-11-10','12:40:00',1.92),('3355','2013-11-10','12:45:00',2.04),('3355','2013-11-10','12:50:00',2.05),('3355','2013-11-10','12:55:00',1.35),('3355','2013-11-10','13:50:00',1.13),('3355','2013-11-10','13:55:00',1.27),('3355','2013-11-09','09:40:00',1.11),('3355','2013-11-09','09:45:00',1.25),('3355','2013-11-09','09:55:00',1.61),('3355','2013-11-09','10:00:00',1.56),('3355','2013-11-09','10:05:00',1.53),('3355','2013-11-09','10:10:00',1.44),('3355','2013-11-09','10:15:00',1.34),('3355','2013-11-09','10:20:00',1.48),('3355','2013-11-09','10:25:00',1.56),('3355','2013-11-09','10:55:00',1.05),('3355','2013-11-09','11:00:00',1.4),('3355','2013-11-09','11:05:00',1.9),('3355','2013-11-09','11:10:00',1.68),('3355','2013-11-09','11:15:00',1.83),('3355','2013-11-09','11:20:00',1.4),('3355','2013-11-09','11:30:00',1.78),('3355','2013-11-09','11:35:00',1.76),('3355','2013-11-09','11:45:00',1.23),('3355','2013-11-09','11:55:00',1.52),('3355','2013-11-09','12:00:00',1.49),('3355','2013-11-09','12:05:00',2.1),('3355','2013-11-09','12:15:00',1.18),('3355','2013-11-09','12:30:00',1.23),('3355','2013-11-09','12:35:00',1.93),('3355','2013-11-09','12:40:00',1.05),('3355','2013-11-09','12:50:00',1.23),('3355','2013-11-09','12:55:00',1.14),('3355','2013-11-09','13:00:00',1.86),('3355','2013-11-09','13:05:00',1.63),('3355','2013-11-09','13:10:00',1.88),('3355','2013-11-09','13:15:00',1.85),('3355','2013-11-09','13:20:00',1.25),('3355','2013-11-09','13:25:00',1.32),('3355','2013-11-09','13:30:00',1.65),('3355','2013-11-09','13:35:00',1.59),('3355','2013-11-09','13:40:00',1.54),('3355','2013-11-09','13:45:00',1.52),('3355','2013-11-09','13:50:00',1.53),('3355','2013-11-09','13:55:00',1.51),('3355','2013-11-09','14:00:00',1.48),('3355','2013-11-09','14:05:00',1.3),('3355','2013-11-09','14:20:00',1.42),('3355','2013-11-09','14:25:00',1.04),('3355','2013-11-09','14:50:00',1.03),('3355','2013-11-08','09:40:00',1),('3355','2013-11-08','09:50:00',1.27),('3355','2013-11-08','10:10:00',1.32),('3355','2013-11-08','10:15:00',1.29),('3355','2013-11-08','10:55:00',1.29),('3355','2013-11-08','11:00:00',1.15),('3355','2013-11-08','11:30:00',1.48),('3355','2013-11-08','11:35:00',1.6),('3355','2013-11-08','11:40:00',1.98),('3355','2013-11-08','11:45:00',1.94),('3355','2013-11-08','11:50:00',1.9),('3355','2013-11-08','11:55:00',1.97),('3355','2013-11-08','12:00:00',1.86),('3355','2013-11-08','12:05:00',1.13),('3355','2013-11-08','12:10:00',1.8),('3355','2013-11-08','12:15:00',1.5),('3355','2013-11-08','12:40:00',1.92),('3355','2013-11-08','12:45:00',1.86),('3355','2013-11-08','12:50:00',1.44),('3355','2013-11-08','12:55:00',1.93),('3355','2013-11-08','13:00:00',1.83),('3355','2013-11-08','13:05:00',1.76),('3355','2013-11-08','13:10:00',1.78),('3355','2013-11-08','13:15:00',1.68),('3355','2013-11-08','13:25:00',1.16),('3355','2013-11-08','13:35:00',1.29),('3355','2013-11-08','13:40:00',1.66),('3355','2013-11-08','13:45:00',1.59),('3355','2013-11-08','13:50:00',1.33),('3355','2013-11-08','13:55:00',1.51),('3355','2013-11-08','14:00:00',1.48),('3355','2013-11-08','14:05:00',1.46),('3355','2013-11-08','14:10:00',1.43),('3355','2013-11-08','14:15:00',1.41),('3355','2013-11-08','14:20:00',1.34),('3355','2013-11-08','14:25:00',1.13),('3355','2013-11-08','14:30:00',1.31),('3355','2013-11-08','14:35:00',1.29),('3355','2013-11-08','14:40:00',1.22),('3355','2013-11-08','14:45:00',1.19),('3355','2013-11-08','14:50:00',1.16),('3355','2014-04-18','09:05:00',1.32),('3355','2014-04-18','09:10:00',1.63),('3355','2014-04-18','09:15:00',1.49),('3355','2014-04-18','09:20:00',1.39),('3355','2014-04-18','09:30:00',1.59),('3355','2014-04-18','09:50:00',1.55),('3355','2014-04-18','09:55:00',1.4),('3355','2014-04-18','10:00:00',1.39),('3355','2014-04-18','10:45:00',1.48),('3355','2014-04-18','10:50:00',1.5),('3355','2014-04-18','10:55:00',1.58),('3355','2014-04-18','11:10:00',1.2),('3355','2014-04-18','11:15:00',1.56),('3355','2014-04-18','11:20:00',1.01),('3355','2014-04-18','11:50:00',1.02),('3355','2014-04-18','12:05:00',1.51),('3355','2014-04-18','12:10:00',1.64),('3355','2014-04-18','12:15:00',1.8),('3355','2014-04-18','12:20:00',2.22),('3355','2014-04-18','12:25:00',1.8),('3355','2014-04-18','12:30:00',2.49),('3355','2014-04-18','12:35:00',2.35),('3355','2014-04-18','12:40:00',2.49),('3355','2014-04-18','12:45:00',1.91),('3355','2014-04-18','12:50:00',2.09),('3355','2014-04-18','12:55:00',1.42),('3355','2014-04-18','13:00:00',2.58),('3355','2014-04-18','13:05:00',1.78),('3355','2014-04-18','13:10:00',1.37),('3355','2014-04-18','13:15:00',1.33),('3355','2014-04-18','13:20:00',1.2),('3355','2014-04-18','13:55:00',1.13),('3355','2014-04-18','14:00:00',1.04),('3355','2014-04-18','14:25:00',1.09),('3355','2014-04-18','14:30:00',1.22),('3355','2014-04-18','14:35:00',1.37),('3355','2014-04-18','14:40:00',1.25),('3355','2014-04-18','14:45:00',1.52),('3355','2014-04-18','14:50:00',1.78),('3355','2014-04-18','14:55:00',1.22),('3355','2014-04-18','15:00:00',1.86),('3355','2014-04-18','15:05:00',1.6),('3355','2014-04-18','15:10:00',1.23),('3355','2014-04-18','15:15:00',1.4),('3355','2014-04-18','15:20:00',1.09),('3355','2014-04-18','15:25:00',1.16),('3355','2014-04-18','15:30:00',1.68),('3355','2014-04-18','15:35:00',2.52),('3355','2014-04-18','15:40:00',1),('3355','2014-04-18','15:45:00',1.32),('3355','2014-04-18','15:50:00',1.69),('3355','2014-04-18','15:55:00',1.42),('3355','2014-04-18','16:00:00',1.23),('3355','2014-04-18','16:25:00',1.18),('3355','2014-04-18','16:30:00',1.19),('3355','2014-04-18','16:35:00',1.73),('3355','2014-04-18','16:40:00',1.72),('3355','2014-04-18','16:45:00',1.7),('3355','2014-04-18','16:50:00',1.41),('3355','2014-04-18','17:00:00',1.15),('3355','2014-04-18','17:05:00',1.64),('3355','2014-04-18','17:10:00',1.08),('3355','2014-04-18','17:15:00',1.38),('3355','2014-04-18','17:20:00',1.26),('3355','2014-04-18','17:25:00',1.27),('3355','2014-04-18','17:30:00',1.17),('3355','2014-04-18','17:35:00',1.11),('3355','2014-04-18','17:40:00',1.07),('3355','2014-04-18','17:45:00',1.01),('3355','2013-11-07','08:55:00',1.02),('3355','2013-11-07','09:00:00',1.06),('3355','2013-11-07','09:05:00',1.1),('3355','2013-11-07','09:10:00',1.13),('3355','2013-11-07','09:15:00',1.16),('3355','2013-11-07','09:20:00',1.2),('3355','2013-11-07','09:25:00',1.23),('3355','2013-11-07','09:30:00',1.26),('3355','2013-11-07','09:35:00',1.29),('3355','2013-11-07','09:40:00',1.33),('3355','2013-11-07','09:45:00',1.35),('3355','2013-11-07','09:50:00',1.39),('3355','2013-11-07','09:55:00',1.41),('3355','2013-11-07','10:00:00',1.43),('3355','2013-11-07','10:05:00',1.44),('3355','2013-11-07','10:10:00',1.46),('3355','2013-11-07','10:15:00',1.48),('3355','2013-11-07','10:20:00',1.49),('3355','2013-11-07','10:25:00',1.51),('3355','2013-11-07','10:30:00',1.53),('3355','2013-11-07','10:35:00',1.55),('3355','2013-11-07','10:40:00',1.57),('3355','2013-11-07','10:45:00',1.58),('3355','2013-11-07','10:50:00',1.59),('3355','2013-11-07','10:55:00',1.59),('3355','2013-11-07','11:00:00',1.61),('3355','2013-11-07','11:05:00',1.61),('3355','2013-11-07','11:10:00',1.63),('3355','2013-11-07','11:15:00',1.62),('3355','2013-11-07','11:20:00',1.63),('3355','2013-11-07','11:25:00',1.63),('3355','2013-11-07','11:30:00',1.61),('3355','2013-11-07','11:35:00',1.63),('3355','2013-11-07','11:40:00',1.64),('3355','2013-11-07','11:45:00',1.65),('3355','2013-11-07','11:50:00',1.63),('3355','2013-11-07','11:55:00',1.63),('3355','2013-11-07','12:00:00',1.63),('3355','2013-11-07','12:05:00',1.64),('3355','2013-11-07','12:10:00',1.64),('3355','2013-11-07','12:15:00',1.63),('3355','2013-11-07','12:20:00',1.63),('3355','2013-11-07','12:25:00',1.61),('3355','2013-11-07','12:30:00',1.59),('3355','2013-11-07','12:35:00',1.61),('3355','2013-11-07','12:40:00',1.59),('3355','2013-11-07','12:45:00',1.54),('3355','2013-11-07','12:50:00',1.57),('3355','2013-11-07','12:55:00',1.61),('3355','2013-11-07','13:00:00',1.6),('3355','2013-11-07','13:05:00',1.7),('3355','2013-11-07','13:10:00',1.53),('3355','2013-11-07','13:15:00',1.66),('3355','2013-11-07','13:20:00',1.27),('3355','2013-11-07','13:35:00',1.02),('3355','2013-11-07','13:40:00',1.65),('3355','2013-11-07','13:50:00',1.36),('3355','2013-11-07','13:55:00',1.38),('3355','2013-11-07','14:35:00',1.12),('3355','2013-11-07','14:40:00',1.29),('3355','2013-11-07','14:45:00',1.17),('3355','2013-11-07','14:50:00',1.12),('3355','2013-11-07','14:55:00',1.1),('3355','2013-11-07','15:00:00',1),('3355','2013-11-06','08:50:00',1.04),('3355','2013-11-06','09:20:00',1.16),('3355','2013-11-06','09:25:00',1.23),('3355','2013-11-06','09:30:00',1.32),('3355','2013-11-06','09:35:00',1.35),('3355','2013-11-06','09:40:00',1.38),('3355','2013-11-06','09:45:00',1.4),('3355','2013-11-06','09:50:00',1.42),('3355','2013-11-06','09:55:00',1.45),('3355','2013-11-06','10:00:00',1.48),('3355','2013-11-06','10:05:00',1.5),('3355','2013-11-06','10:10:00',1.53),('3355','2013-11-06','10:15:00',1.55),('3355','2013-11-06','10:20:00',1.57),('3355','2013-11-06','10:25:00',1.6),('3355','2013-11-06','10:30:00',1.64),('3355','2013-11-06','10:35:00',1.65),('3355','2013-11-06','10:40:00',1.67),('3355','2013-11-06','10:45:00',1.68),('3355','2013-11-06','10:50:00',1.71),('3355','2013-11-06','10:55:00',1.72),('3355','2013-11-06','11:00:00',1.72),('3355','2013-11-06','11:05:00',1.73),('3355','2013-11-06','11:10:00',1.74),('3355','2013-11-06','11:15:00',1.74),('3355','2013-11-06','11:20:00',1.76),('3355','2013-11-06','11:25:00',1.77),('3355','2013-11-06','11:30:00',1.78),('3355','2013-11-06','11:35:00',1.77),('3355','2013-11-06','11:40:00',1.77),('3355','2013-11-06','11:45:00',1.79),('3355','2013-11-06','11:50:00',1.8),('3355','2013-11-06','11:55:00',1.79),('3355','2013-11-06','12:00:00',1.79),('3355','2013-11-06','12:05:00',1.8),('3355','2013-11-06','12:10:00',1.8),('3355','2013-11-06','12:15:00',1.8),('3355','2013-11-06','12:20:00',1.8),('3355','2013-11-06','12:25:00',1.8),('3355','2013-11-06','12:30:00',1.79),('3355','2013-11-06','12:35:00',1.78),('3355','2013-11-06','12:40:00',1.76),('3355','2013-11-06','12:45:00',1.75),('3355','2013-11-06','12:50:00',1.74),('3355','2013-11-06','12:55:00',1.74),('3355','2013-11-06','13:00:00',1.72),('3355','2013-11-06','13:05:00',1.7),('3355','2013-11-06','13:10:00',1.69),('3355','2013-11-06','13:15:00',1.66),('3355','2013-11-06','13:20:00',1.66),('3355','2013-11-06','13:25:00',1.64),('3355','2013-11-06','13:30:00',1.63),('3355','2013-11-06','13:35:00',1.61),('3355','2013-11-06','13:40:00',1.58),('3355','2013-11-06','13:45:00',1.55),('3355','2013-11-06','13:50:00',1.53),('3355','2013-11-06','13:55:00',1.52),('3355','2013-11-06','14:00:00',1.5),('3355','2013-11-06','14:05:00',1.47),('3355','2013-11-06','14:10:00',1.44),('3355','2013-11-06','14:15:00',1.42),('3355','2013-11-06','14:20:00',1.39),('3355','2013-11-06','14:25:00',1.36),('3355','2013-11-06','14:30:00',1.32),('3355','2013-11-06','14:35:00',1.29),('3355','2013-11-06','14:40:00',1.26),('3355','2013-11-06','14:45:00',1.22),('3355','2013-11-06','14:50:00',1.17),('3355','2013-11-06','14:55:00',1.12),('3355','2013-11-06','15:00:00',1.08),('3355','2013-11-05','08:35:00',1.02),('3355','2013-11-05','08:40:00',1.05),('3355','2013-11-05','10:25:00',1.21),('3355','2013-11-05','10:30:00',1.09),('3355','2013-11-05','10:35:00',1.07),('3355','2013-11-05','10:45:00',1.33),('3355','2013-11-05','12:20:00',1.03),('3355','2013-11-05','12:25:00',1.1),('3355','2013-11-05','13:35:00',1.3),('3355','2013-11-05','13:40:00',1.42),('3355','2013-11-05','13:45:00',1.27),('3355','2013-11-05','14:10:00',1.55),('3355','2013-11-05','14:25:00',1.38),('3355','2013-11-05','14:30:00',1.24),('3355','2013-11-04','09:15:00',1.22),('3355','2013-11-04','09:20:00',1.45),('3355','2013-11-04','09:25:00',1.57),('3355','2013-11-04','10:05:00',1.36),('3355','2013-11-04','10:10:00',1.6),('3355','2013-11-04','10:15:00',1.61),('3355','2013-11-04','10:20:00',1.65),('3355','2013-11-04','10:25:00',1.75),('3355','2013-11-04','10:30:00',1.42),('3355','2013-11-04','10:35:00',1.37),('3355','2013-11-04','10:40:00',1.85),('3355','2013-11-04','10:45:00',1.18),('3355','2013-11-04','11:00:00',1.49),('3355','2013-11-04','11:05:00',2.28),('3355','2013-11-04','11:10:00',1.92),('3355','2013-11-04','11:15:00',2.25),('3355','2013-11-04','11:20:00',1.72),('3355','2013-11-04','11:30:00',1.12),('3355','2013-11-04','11:35:00',1.48),('3355','2013-11-04','11:40:00',1.1),('3355','2013-11-04','11:45:00',1.27),('3355','2013-11-04','11:50:00',2.19),('3355','2013-11-04','11:55:00',1.98),('3355','2013-11-04','12:00:00',1.99),('3355','2013-11-04','12:05:00',1.9),('3355','2013-11-04','12:10:00',1.75),('3355','2013-11-04','12:15:00',1.91),('3355','2013-11-04','12:20:00',1.89),('3355','2013-11-04','12:25:00',1.9),('3355','2013-11-04','12:30:00',1.82),('3355','2013-11-04','12:35:00',1.72),('3355','2013-11-04','12:40:00',1.37),('3355','2013-11-04','12:45:00',1.77),('3355','2013-11-04','12:50:00',1.81),('3355','2013-11-04','12:55:00',1.79),('3355','2013-11-04','13:00:00',1.79),('3355','2013-11-04','13:05:00',1.77),('3355','2013-11-04','13:10:00',1.67),('3355','2013-11-04','13:15:00',1.72),('3355','2013-11-04','13:20:00',1.74),('3355','2013-11-04','13:25:00',1.74),('3355','2013-11-04','13:30:00',1.7),('3355','2013-11-04','13:35:00',1.62),('3355','2013-11-04','13:40:00',1.72),('3355','2013-11-04','13:45:00',1.29),('3355','2013-11-04','13:50:00',1.67),('3355','2013-11-04','13:55:00',1.65),('3355','2013-11-04','14:00:00',1.11),('3355','2013-11-04','14:05:00',1.71),('3355','2013-11-04','14:15:00',1.42),('3355','2013-11-04','14:20:00',1.41),('3355','2013-11-04','14:25:00',1.55),('3355','2013-11-04','14:30:00',1.4),('3355','2013-11-04','14:35:00',1.08),('3355','2013-11-04','14:40:00',1.32),('3355','2013-11-04','14:55:00',1.15),('3355','2013-11-04','15:00:00',1.18),('3355','2013-11-03','09:40:00',1.21),('3355','2013-11-03','09:45:00',1.16),('3355','2013-11-03','10:10:00',1.05),('3355','2013-11-03','10:25:00',1.41),('3355','2013-11-03','10:35:00',1.05),('3355','2013-11-03','11:25:00',1.1),('3355','2013-11-03','11:30:00',1.11),('3355','2013-11-03','11:35:00',1.7),('3355','2013-11-03','11:40:00',1.84),('3355','2013-11-03','11:45:00',1.9),('3355','2013-11-03','11:50:00',1.94),('3355','2013-11-03','11:55:00',2.06),('3355','2013-11-03','12:00:00',1.33),('3355','2013-11-03','12:05:00',2.04),('3355','2013-11-03','12:10:00',2.29),('3355','2013-11-03','12:25:00',1.01),('3355','2013-11-03','12:30:00',1.02),('3355','2013-11-03','13:50:00',1.26),('3355','2013-11-03','14:05:00',1.17),('3355','2013-11-03','14:10:00',1.02),('3355','2013-11-03','14:40:00',1.26),('3355','2013-11-02','09:00:00',1.02),('3355','2013-11-02','09:05:00',1.1),('3355','2013-11-02','09:10:00',1.21),('3355','2013-11-02','09:20:00',1.03),('3355','2013-11-02','09:25:00',1.16),('3355','2013-11-02','09:30:00',1.28),('3355','2013-11-02','09:35:00',1.27),('3355','2013-11-02','09:40:00',1.2),('3355','2013-11-02','09:45:00',1.06),('3355','2013-11-02','09:50:00',1.45),('3355','2013-11-02','09:55:00',1.47),('3355','2013-11-02','10:00:00',1.58),('3355','2013-11-02','10:05:00',1.79),('3355','2013-11-02','11:55:00',1.08),('3355','2013-11-02','12:00:00',1.77),('3355','2013-11-02','12:05:00',2),('3355','2013-11-02','12:10:00',1.77),('3355','2013-11-02','12:15:00',1.56),('3355','2013-11-02','12:20:00',2.14),('3355','2013-11-02','12:25:00',2.05),('3355','2013-11-02','12:30:00',2.11),('3355','2013-11-02','12:35:00',2.05),('3355','2013-11-02','12:40:00',1.84),('3355','2013-11-02','12:45:00',1.59),('3355','2013-11-02','12:50:00',1.63),('3355','2013-11-02','12:55:00',1.86),('3355','2013-11-02','13:00:00',1.8),('3355','2013-11-02','13:05:00',1.85),('3355','2013-11-02','13:10:00',1.94),('3355','2013-11-02','13:15:00',1.9),('3355','2013-11-02','13:30:00',1.12),('3355','2013-11-02','13:35:00',1.9),('3355','2013-11-02','13:40:00',1.88),('3355','2013-11-02','13:45:00',1.54),('3355','2013-11-02','13:50:00',1.94),('3355','2013-11-02','13:55:00',1.87),('3355','2013-11-02','14:00:00',1.74),('3355','2013-11-02','14:05:00',1.53),('3355','2013-11-02','14:10:00',1.46),('3355','2013-11-02','14:15:00',1.41),('3355','2013-11-02','14:20:00',1.36),('3355','2013-11-02','14:25:00',1.32),('3355','2013-11-02','14:30:00',1.3),('3355','2013-11-02','14:35:00',1.27),('3355','2013-11-02','14:40:00',1.23),('3355','2013-11-02','14:45:00',1.18),('3355','2013-11-02','14:50:00',1.15),('3355','2013-11-02','14:55:00',1.12),('3355','2013-11-02','15:00:00',1.01),('3355','2013-11-01','09:05:00',1.05),('3355','2013-11-01','09:10:00',1.1),('3355','2013-11-01','09:15:00',1.13),('3355','2013-11-01','09:20:00',1.16),('3355','2013-11-01','09:25:00',1.2),('3355','2013-11-01','09:30:00',1.23),('3355','2013-11-01','09:35:00',1.26),('3355','2013-11-01','09:40:00',1.3),('3355','2013-11-01','09:45:00',1.33),('3355','2013-11-01','09:50:00',1.37),('3355','2013-11-01','09:55:00',1.4),('3355','2013-11-01','10:00:00',1.42),('3355','2013-11-01','10:05:00',1.46),('3355','2013-11-01','10:10:00',1.49),('3355','2013-11-01','10:15:00',1.49),('3355','2013-11-01','10:20:00',1.52),('3355','2013-11-01','10:25:00',1.55),('3355','2013-11-01','10:30:00',1.54),('3355','2013-11-01','10:35:00',1.55),('3355','2013-11-01','10:40:00',1.6),('3355','2013-11-01','10:45:00',1.56),('3355','2013-11-01','10:50:00',1.56),('3355','2013-11-01','10:55:00',1.56),('3355','2013-11-01','11:00:00',1.6),('3355','2013-11-01','11:05:00',1.55),('3355','2013-11-01','11:10:00',1.38),('3355','2013-11-01','11:15:00',1.47),('3355','2013-11-01','11:20:00',1.68),('3355','2013-11-01','11:25:00',1.78),('3355','2013-11-01','11:30:00',1.8),('3355','2013-11-01','11:35:00',1.75),('3355','2013-11-01','11:40:00',1.67),('3355','2013-11-01','11:45:00',1.48),('3355','2013-11-01','11:50:00',1.73),('3355','2013-11-01','11:55:00',1.81),('3355','2013-11-01','12:00:00',1.82),('3355','2013-11-01','12:05:00',1.79),('3355','2013-11-01','12:10:00',1.64),('3355','2013-11-01','12:15:00',1.67),('3355','2013-11-01','12:30:00',1.57),('3355','2013-11-01','12:35:00',1.24),('3355','2013-10-31','09:55:00',1.1),('3355','2013-10-31','10:00:00',1.01),('3355','2013-10-31','10:20:00',1.01),('3355','2013-10-31','10:25:00',1),('3355','2013-10-31','10:35:00',1),('3355','2013-10-31','10:40:00',1.02),('3355','2013-10-31','10:50:00',1.05),('3355','2013-10-31','10:55:00',1.28),('3355','2013-10-31','11:00:00',1.58),('3355','2013-10-31','11:05:00',1.67),('3355','2013-10-31','11:10:00',1.62),('3355','2013-10-31','11:15:00',1.33),('3355','2013-10-31','11:20:00',1.49),('3355','2013-10-31','11:25:00',1.46),('3355','2013-10-31','11:30:00',1.51),('3355','2013-10-31','11:35:00',1.45),('3355','2013-10-31','11:40:00',1.55),('3355','2013-10-31','11:45:00',1.66),('3355','2013-10-31','11:50:00',1.68),('3355','2013-10-31','11:55:00',1.68),('3355','2013-10-31','12:00:00',1.66),('3355','2013-10-31','12:05:00',1.63),('3355','2013-10-31','12:10:00',1.61),('3355','2013-10-31','12:15:00',1.63),('3355','2013-10-31','12:20:00',1.62),('3355','2013-10-31','12:25:00',1.63),('3355','2013-10-31','12:30:00',1.59),('3355','2013-10-31','12:35:00',1.59),('3355','2013-10-31','12:40:00',1.61),('3355','2013-10-31','12:45:00',1.67),('3355','2013-10-31','12:50:00',1.68),('3355','2013-10-31','12:55:00',1.7),('3355','2013-10-31','13:00:00',1.65),('3355','2013-10-31','13:05:00',1.63),('3355','2013-10-31','13:10:00',1.62),('3355','2013-10-31','13:15:00',1.6),('3355','2013-10-31','13:20:00',1.6),('3355','2013-10-31','13:25:00',1.57),('3355','2013-10-31','13:30:00',1.54),('3355','2013-10-31','13:35:00',1.45),('3355','2013-10-31','13:40:00',1.23),('3355','2013-10-31','13:45:00',1.33),('3355','2013-10-31','13:55:00',1.1),('3355','2013-10-31','14:00:00',1.4),('3355','2013-10-31','14:05:00',1.39),('3355','2013-10-31','14:10:00',1.3),('3355','2013-10-31','14:15:00',1.17),('3355','2013-10-31','14:25:00',1.2),('3355','2013-10-30','09:10:00',1.07),('3355','2013-10-30','09:15:00',1.1),('3355','2013-10-30','09:20:00',1.13),('3355','2013-10-30','09:25:00',1.17),('3355','2013-10-30','09:30:00',1.19),('3355','2013-10-30','09:35:00',1.24),('3355','2013-10-30','09:40:00',1.27),('3355','2013-10-30','09:45:00',1.3),('3355','2013-10-30','09:50:00',1.32),('3355','2013-10-30','09:55:00',1.32),('3355','2013-10-30','10:00:00',1.26),('3355','2013-10-30','10:05:00',1.33),('3355','2013-10-30','10:10:00',1.31),('3355','2013-10-30','10:15:00',1.41),('3355','2013-10-30','10:20:00',1.39),('3355','2013-10-30','10:25:00',1.35),('3355','2013-10-30','10:30:00',1.43),('3355','2013-10-30','10:35:00',1.41),('3355','2013-10-30','10:40:00',1.25),('3355','2013-10-30','10:45:00',1.37),('3355','2013-10-30','11:05:00',1.15),('3355','2013-10-30','11:10:00',1.33),('3355','2013-10-30','11:15:00',1.46),('3355','2013-10-30','11:20:00',1.57),('3355','2013-10-30','11:50:00',1.06),('3355','2013-10-30','12:30:00',1.47),('3355','2013-10-30','12:45:00',1.19),('3355','2013-10-30','12:50:00',1.39),('3355','2013-10-30','12:55:00',1.16),('3355','2013-10-30','13:00:00',1.37),('3355','2013-10-30','13:05:00',1.22),('3355','2013-10-30','13:20:00',1.23),('3355','2013-10-30','13:35:00',1.23),('3355','2013-10-30','13:40:00',1.34),('3355','2013-10-30','13:45:00',1.34),('3355','2013-10-30','13:50:00',1.41),('3355','2013-10-30','13:55:00',1.14),('3355','2013-10-30','14:05:00',1.45),('3355','2013-10-30','14:10:00',1.54),('3355','2013-10-30','14:45:00',1.1),('3355','2013-10-30','14:50:00',1.05),('3355','2013-10-29','08:55:00',1.01),('3355','2013-10-29','09:00:00',1.04),('3355','2013-10-29','09:05:00',1.08),('3355','2013-10-29','09:10:00',1.1),('3355','2013-10-29','09:15:00',1.11),('3355','2013-10-29','09:20:00',1.17),('3355','2013-10-29','09:25:00',1.19),('3355','2013-10-29','09:30:00',1.24),('3355','2013-10-29','09:35:00',1.3),('3355','2013-10-29','09:40:00',1.37),('3355','2013-10-29','09:45:00',1.38),('3355','2013-10-29','09:50:00',1.41),('3355','2013-10-29','09:55:00',1.41),('3355','2013-10-29','10:00:00',1.19),('3355','2013-10-29','10:05:00',1.08),('3355','2013-10-29','10:10:00',1.27),('3355','2013-10-29','10:15:00',1.31),('3355','2013-10-29','10:20:00',1.34),('3355','2013-10-29','10:25:00',1.15),('3355','2013-10-29','10:30:00',1.28),('3355','2013-10-29','10:35:00',1.76),('3355','2013-10-29','10:40:00',1.74),('3355','2013-10-29','10:45:00',1.71),('3355','2013-10-29','10:50:00',1.72),('3355','2013-10-29','10:55:00',1.81),('3355','2013-10-29','11:00:00',1.81),('3355','2013-10-29','11:05:00',1.8),('3355','2013-10-29','11:10:00',1.46),('3355','2013-10-29','11:15:00',1.57),('3355','2013-10-29','11:30:00',1.25),('3355','2013-10-29','11:35:00',1.78),('3355','2013-10-29','11:40:00',1.72),('3355','2013-10-29','11:45:00',1.78),('3355','2013-10-29','11:50:00',1.74),('3355','2013-10-29','11:55:00',1.7),('3355','2013-10-29','12:00:00',1.64),('3355','2013-10-29','12:05:00',1.69),('3355','2013-10-29','12:10:00',1.69),('3355','2013-10-29','12:15:00',1.69),('3355','2013-10-29','12:20:00',1.69),('3355','2013-10-29','12:25:00',1.68),('3355','2013-10-29','12:30:00',1.66),('3355','2013-10-29','12:35:00',1.59),('3355','2013-10-29','12:40:00',1.61),('3355','2013-10-29','12:45:00',1.65),('3355','2013-10-29','12:50:00',1.66),('3355','2013-10-29','12:55:00',1.6),('3355','2013-10-29','13:00:00',1.58),('3355','2013-10-29','13:05:00',1.52),('3355','2013-10-29','13:10:00',1.54),('3355','2013-10-29','13:15:00',1.54),('3355','2013-10-29','13:20:00',1.5),('3355','2013-10-29','13:25:00',1.5),('3355','2013-10-29','13:30:00',1.46),('3355','2013-10-29','13:35:00',1.42),('3355','2013-10-29','13:40:00',1.47),('3355','2013-10-29','13:45:00',1.46),('3355','2013-10-29','13:50:00',1.43),('3355','2013-10-29','13:55:00',1.36),('3355','2013-10-29','14:00:00',1.32),('3355','2013-10-29','14:05:00',1.27),('3355','2013-10-29','14:10:00',1.32),('3355','2013-10-29','14:15:00',1.29),('3355','2013-10-29','14:20:00',1.26),('3355','2013-10-29','14:25:00',1.21),('3355','2013-10-29','14:30:00',1.17),('3355','2013-10-29','14:35:00',1.12),('3355','2013-10-29','14:40:00',1.09),('3355','2013-10-29','14:45:00',1.07),('3355','2013-10-29','14:50:00',1.03),('3355','2014-04-17','09:05:00',1.05),('3355','2014-04-17','09:10:00',1.19),('3355','2014-04-17','09:15:00',1.2),('3355','2014-04-17','09:20:00',1.29),('3355','2014-04-17','09:25:00',1.37),('3355','2014-04-17','09:30:00',1.42),('3355','2014-04-17','09:35:00',1.46),('3355','2014-04-17','09:40:00',1.51),('3355','2014-04-17','09:45:00',1.57),('3355','2014-04-17','09:50:00',1.61),('3355','2014-04-17','09:55:00',1.67),('3355','2014-04-17','10:00:00',1.75),('3355','2014-04-17','10:05:00',1.89),('3355','2014-04-17','10:10:00',1.81),('3355','2014-04-17','10:15:00',1.52),('3355','2014-04-17','10:20:00',1.85),('3355','2014-04-17','10:25:00',2.08),('3355','2014-04-17','10:30:00',2.21),('3355','2014-04-17','10:35:00',2.25),('3355','2014-04-17','10:40:00',2.16),('3355','2014-04-17','10:45:00',1.76),('3355','2014-04-17','10:50:00',1.38),('3355','2014-04-17','10:55:00',1.35),('3355','2014-04-17','11:00:00',1.34),('3355','2014-04-17','11:05:00',2.12),('3355','2014-04-17','11:10:00',1.83),('3355','2014-04-17','11:15:00',1.67),('3355','2014-04-17','11:20:00',1.74),('3355','2014-04-17','11:25:00',1.95),('3355','2014-04-17','11:30:00',1.36),('3355','2014-04-17','11:35:00',1.66),('3355','2014-04-17','11:40:00',1.49),('3355','2014-04-17','11:45:00',1.79),('3355','2014-04-17','11:50:00',1.34),('3355','2014-04-17','11:55:00',1.09),('3355','2014-04-17','12:00:00',1.14),('3355','2014-04-17','12:05:00',1.56),('3355','2014-04-17','12:10:00',1.54),('3355','2014-04-17','12:15:00',1.35),('3355','2014-04-17','12:20:00',1.3),('3355','2014-04-17','12:25:00',1.41),('3355','2014-04-17','12:30:00',1.74),('3355','2014-04-17','12:35:00',2.17),('3355','2014-04-17','12:40:00',2.47),('3355','2014-04-17','12:45:00',2.36),('3355','2014-04-17','12:50:00',2.44),('3355','2014-04-17','12:55:00',2.5),('3355','2014-04-17','13:00:00',2.51),('3355','2014-04-17','13:05:00',1.27),('3355','2014-04-17','13:20:00',1.1),('3355','2014-04-17','13:25:00',2.82),('3355','2014-04-17','13:30:00',2.35),('3355','2014-04-17','14:10:00',1.15),('3355','2014-04-17','14:40:00',1.7),('3355','2014-04-17','15:35:00',1.18),('3355','2013-10-28','09:00:00',1.07),('3355','2013-10-28','09:05:00',1.18),('3355','2013-10-28','09:10:00',1.27),('3355','2013-10-28','09:15:00',1.24),('3355','2013-10-28','09:20:00',1.17),('3355','2013-10-28','09:25:00',1.12),('3355','2013-10-28','09:30:00',1.36),('3355','2013-10-28','09:35:00',1.24),('3355','2013-10-28','09:50:00',1.36),('3355','2013-10-28','10:50:00',1.76),('3355','2013-10-28','10:55:00',1.72),('3355','2013-10-28','11:00:00',1.69),('3355','2013-10-28','11:05:00',1.74),('3355','2013-10-28','11:10:00',1.73),('3355','2013-10-28','11:15:00',1.74),('3355','2013-10-28','11:20:00',1.75),('3355','2013-10-28','11:25:00',1.76),('3355','2013-10-28','11:30:00',1.75),('3355','2013-10-28','11:35:00',1.75),('3355','2013-10-28','11:40:00',1.74),('3355','2013-10-28','11:45:00',1.74),('3355','2013-10-28','11:50:00',1.78),('3355','2013-10-28','11:55:00',1.67),('3355','2013-10-28','12:00:00',1.02),('3355','2013-10-28','12:05:00',1.61),('3355','2013-10-28','12:10:00',1.73),('3355','2013-10-28','12:15:00',1.87),('3355','2013-10-28','12:20:00',1.92),('3355','2013-10-28','12:25:00',1.59),('3355','2013-10-28','12:30:00',1.52),('3355','2013-10-28','12:35:00',2.05),('3355','2013-10-28','12:40:00',1.92),('3355','2013-10-28','12:45:00',1.9),('3355','2013-10-28','12:50:00',1.95),('3355','2013-10-28','12:55:00',1.88),('3355','2013-10-28','13:00:00',1.76),('3355','2013-10-28','13:05:00',1.73),('3355','2013-10-28','13:10:00',1.74),('3355','2013-10-28','13:15:00',1.65),('3355','2013-10-28','13:20:00',1.68),('3355','2013-10-28','13:25:00',1.42),('3355','2013-10-28','13:30:00',1.65),('3355','2013-10-28','13:35:00',1.62),('3355','2013-10-28','13:40:00',1.6),('3355','2013-10-28','13:45:00',1.6),('3355','2013-10-28','13:50:00',1.42),('3355','2013-10-28','13:55:00',1.5),('3355','2013-10-28','14:00:00',1.51),('3355','2013-10-28','14:05:00',1.54),('3355','2013-10-28','14:10:00',1.58),('3355','2013-10-28','14:15:00',1.49),('3355','2013-10-28','14:20:00',1.46),('3355','2013-10-28','14:25:00',1.5),('3355','2013-10-28','14:30:00',1.16),('3355','2013-10-28','14:35:00',1.12),('3355','2013-10-28','14:50:00',1.2),('3355','2013-10-28','14:55:00',1.11),('3355','2013-10-28','15:00:00',1.12),('3355','2013-10-28','15:05:00',1.07),('3355','2013-10-27','11:45:00',1.1),('3355','2013-10-27','11:50:00',1.5),('3355','2013-10-27','12:20:00',1.29),('3355','2013-10-27','12:25:00',1.77),('3355','2013-10-27','12:30:00',1.24),('3355','2013-10-27','12:35:00',1.63),('3355','2013-10-27','12:40:00',1.63),('3355','2013-10-27','12:45:00',1.47),('3355','2013-10-27','12:50:00',1.5),('3355','2013-10-27','12:55:00',1.75),('3355','2013-10-27','13:00:00',1.57),('3355','2013-10-27','13:10:00',1),('3355','2013-10-27','13:30:00',1.47),('3355','2013-10-27','13:35:00',1.52),('3355','2013-10-27','14:40:00',1.24),('3355','2013-10-27','14:45:00',1.19),('3355','2013-10-27','14:50:00',1.02),('3355','2013-10-27','14:55:00',1.12),('3355','2013-10-27','15:00:00',1.1),('3355','2013-10-26','09:55:00',1.02),('3355','2013-10-26','10:00:00',1.05),('3355','2013-10-26','10:05:00',1.09),('3355','2013-10-26','10:10:00',1.13),('3355','2013-10-26','10:15:00',1.17),('3355','2013-10-26','10:20:00',1.2),('3355','2013-10-26','10:25:00',1.24),('3355','2013-10-26','10:30:00',1.26),('3355','2013-10-26','10:35:00',1.3),('3355','2013-10-26','10:40:00',1.33),('3355','2013-10-26','10:45:00',1.35),('3355','2013-10-26','10:50:00',1.39),('3355','2013-10-26','10:55:00',1.42),('3355','2013-10-26','11:00:00',1.45),('3355','2013-10-26','11:05:00',1.48),('3355','2013-10-26','11:10:00',1.49),('3355','2013-10-26','11:15:00',1.53),('3355','2013-10-26','11:20:00',1.54),('3355','2013-10-26','11:25:00',1.56),('3355','2013-10-26','11:30:00',1.58),('3355','2013-10-26','11:35:00',1.6),('3355','2013-10-26','11:40:00',1.61),('3355','2013-10-26','11:45:00',1.63),('3355','2013-10-26','11:50:00',1.64),('3355','2013-10-26','11:55:00',1.65),('3355','2013-10-26','12:00:00',1.67),('3355','2013-10-26','12:05:00',1.66),('3355','2013-10-26','12:10:00',1.66),('3355','2013-10-26','12:15:00',1.64),('3355','2013-10-26','12:20:00',1.7),('3355','2013-10-26','12:25:00',1.7),('3355','2013-10-26','12:30:00',1.73),('3355','2013-10-26','12:35:00',1.65),('3355','2013-10-26','12:40:00',1.69),('3355','2013-10-26','12:45:00',1.68),('3355','2013-10-26','12:50:00',1.72),('3355','2013-10-26','12:55:00',1.19),('3355','2013-10-26','13:00:00',1.6),('3355','2013-10-26','13:05:00',1.67),('3355','2013-10-26','13:10:00',1.72),('3355','2013-10-26','13:15:00',1.64),('3355','2013-10-26','13:20:00',1.59),('3355','2013-10-26','13:25:00',1.66),('3355','2013-10-26','13:30:00',1.3),('3355','2013-10-26','13:35:00',1.54),('3355','2013-10-26','13:40:00',1.68),('3355','2013-10-26','13:45:00',1.64),('3355','2013-10-26','13:50:00',1.64),('3355','2013-10-26','13:55:00',1.64),('3355','2013-10-26','14:00:00',1.56),('3355','2013-10-26','14:05:00',1.47),('3355','2013-10-26','14:10:00',1.54),('3355','2013-10-26','14:15:00',1.44),('3355','2013-10-26','14:35:00',1.12),('3355','2013-10-26','14:40:00',1.42),('3355','2013-10-26','14:45:00',1.33),('3355','2013-10-26','14:50:00',1.35),('3355','2013-10-26','14:55:00',1.28),('3355','2013-10-26','15:00:00',1.31),('3355','2013-10-26','15:05:00',1.33),('3355','2013-10-26','15:10:00',1.28),('3355','2013-10-26','15:15:00',1.21),('3355','2013-10-26','15:20:00',1.2),('3355','2013-10-26','15:25:00',1.16),('3355','2013-10-26','15:30:00',1.1),('3355','2013-10-26','15:35:00',1.1),('3355','2013-10-26','15:40:00',1.1),('3355','2013-10-26','15:45:00',1.03),('3355','2013-10-26','15:50:00',1.06),('3355','2013-10-25','09:55:00',1.04),('3355','2013-10-25','10:00:00',1.08),('3355','2013-10-25','10:05:00',1.12),('3355','2013-10-25','10:10:00',1.15),('3355','2013-10-25','10:15:00',1.19),('3355','2013-10-25','10:20:00',1.23),('3355','2013-10-25','10:25:00',1.26),('3355','2013-10-25','10:30:00',1.3),('3355','2013-10-25','10:35:00',1.33),('3355','2013-10-25','10:40:00',1.36),('3355','2013-10-25','10:45:00',1.39),('3355','2013-10-25','10:50:00',1.42),('3355','2013-10-25','10:55:00',1.43),('3355','2013-10-25','11:00:00',1.48),('3355','2013-10-25','11:05:00',1.48),('3355','2013-10-25','11:10:00',1.49),('3355','2013-10-25','11:15:00',1.54),('3355','2013-10-25','11:20:00',1.57),('3355','2013-10-25','11:25:00',1.6),('3355','2013-10-25','11:30:00',1.58),('3355','2013-10-25','11:35:00',1.59),('3355','2013-10-25','11:40:00',1.65),('3355','2013-10-25','11:45:00',1.65),('3355','2013-10-25','11:50:00',1.66),('3355','2013-10-25','11:55:00',1.69),('3355','2013-10-25','12:00:00',1.73),('3355','2013-10-25','12:05:00',1.74),('3355','2013-10-25','12:10:00',1.74),('3355','2013-10-25','12:15:00',1.74),('3355','2013-10-25','12:20:00',1.75),('3355','2013-10-25','12:25:00',1.77),('3355','2013-10-25','12:30:00',1.78),('3355','2013-10-25','12:35:00',1.78),('3355','2013-10-25','12:40:00',1.78),('3355','2013-10-25','12:45:00',1.78),('3355','2013-10-25','12:50:00',1.77),('3355','2013-10-25','12:55:00',1.76),('3355','2013-10-25','13:00:00',1.76),('3355','2013-10-25','13:05:00',1.76),('3355','2013-10-25','13:10:00',1.77),('3355','2013-10-25','13:15:00',1.76),('3355','2013-10-25','13:20:00',1.77),('3355','2013-10-25','13:25:00',1.76),('3355','2013-10-25','13:30:00',1.72),('3355','2013-10-25','13:35:00',1.71),('3355','2013-10-25','13:40:00',1.72),('3355','2013-10-25','13:45:00',1.72),('3355','2013-10-25','13:50:00',1.68),('3355','2013-10-25','13:55:00',1.69),('3355','2013-10-25','14:00:00',1.69),('3355','2013-10-25','14:05:00',1.66),('3355','2013-10-25','14:10:00',1.66),('3355','2013-10-25','14:15:00',1.65),('3355','2013-10-25','14:20:00',1.64),('3355','2013-10-25','14:25:00',1.62),('3355','2013-10-25','14:30:00',1.6),('3355','2013-10-25','14:35:00',1.58),('3355','2013-10-25','14:40:00',1.54),('3355','2013-10-25','14:45:00',1.53),('3355','2013-10-25','14:50:00',1.53),('3355','2013-10-25','14:55:00',1.5),('3355','2013-10-25','15:00:00',1.47),('3355','2013-10-25','15:05:00',1.44),('3355','2013-10-25','15:10:00',1.42),('3355','2013-10-25','15:15:00',1.39),('3355','2013-10-25','15:20:00',1.33),('3355','2013-10-25','15:25:00',1.31),('3355','2013-10-25','15:30:00',1.27),('3355','2013-10-25','15:35:00',1.22),('3355','2013-10-25','15:40:00',1.19),('3355','2013-10-25','15:45:00',1.14),('3355','2013-10-25','15:50:00',1.11),('3355','2013-10-25','15:55:00',1.07),('3355','2013-10-25','16:00:00',1.05),('3355','2013-10-25','16:05:00',1.01),('3355','2013-10-24','10:45:00',1.18),('3355','2013-10-24','10:50:00',1.01),('3355','2013-10-24','10:55:00',1.27),('3355','2013-10-24','11:00:00',1.47),('3355','2013-10-24','11:05:00',1.74),('3355','2013-10-24','11:10:00',1.86),('3355','2013-10-24','11:15:00',1.36),('3355','2013-10-24','11:25:00',1.2),('3355','2013-10-24','11:30:00',1.04),('3355','2013-10-24','11:55:00',1.52),('3355','2013-10-24','12:00:00',1.08),('3355','2013-10-24','12:40:00',1.03),('3355','2013-10-24','12:45:00',1.31),('3355','2013-10-24','12:50:00',1.45),('3355','2013-10-24','12:55:00',1.35),('3355','2013-10-24','13:00:00',1.93),('3355','2013-10-24','13:05:00',2.12),('3355','2013-10-24','13:10:00',1.85),('3355','2013-10-24','13:15:00',1.38),('3355','2013-10-24','13:20:00',1.58),('3355','2013-10-24','13:25:00',1.16),('3355','2013-10-24','13:50:00',1.08),('3355','2013-10-24','13:55:00',1.03),('3355','2013-10-24','14:00:00',1.26),('3355','2013-10-24','14:05:00',1.15),('3355','2013-10-24','14:50:00',1.37),('3355','2013-10-24','15:10:00',1.36),('3355','2013-10-24','15:35:00',1.57),('3355','2013-10-24','15:40:00',1.4),('3355','2013-10-23','11:05:00',1.29),('3355','2013-10-23','11:10:00',1.15),('3355','2013-10-23','11:15:00',1.07),('3355','2013-10-23','11:20:00',1.27),('3355','2013-10-23','11:25:00',1.64),('3355','2013-10-23','11:30:00',1.6),('3355','2013-10-23','11:35:00',1.51),('3355','2013-10-23','11:40:00',1.28),('3355','2013-10-23','11:45:00',1.67),('3355','2013-10-23','11:50:00',1.66),('3355','2013-10-23','11:55:00',1.6),('3355','2013-10-23','12:00:00',1.69),('3355','2013-10-23','12:05:00',1.67),('3355','2013-10-23','12:10:00',1.66),('3355','2013-10-23','12:15:00',1.68),('3355','2013-10-23','12:20:00',1.54),('3355','2013-10-23','12:25:00',1.64),('3355','2013-10-23','12:30:00',1.65),('3355','2013-10-23','12:35:00',1.65),('3355','2013-10-23','12:40:00',1.61),('3355','2013-10-23','12:45:00',1.64),('3355','2013-10-23','12:50:00',1.52),('3355','2013-10-23','12:55:00',1.15),('3355','2013-10-23','13:00:00',1.58),('3355','2013-10-23','13:05:00',1.56),('3355','2013-10-23','13:10:00',1.59),('3355','2013-10-23','13:15:00',1.59),('3355','2013-10-23','13:20:00',1.67),('3355','2013-10-23','13:25:00',1.66),('3355','2013-10-23','13:30:00',1.61),('3355','2013-10-23','13:35:00',1.6),('3355','2013-10-23','13:40:00',1.63),('3355','2013-10-23','13:45:00',1.64),('3355','2013-10-23','13:50:00',1.25),('3355','2013-10-23','13:55:00',1.1),('3355','2013-10-23','14:05:00',1.22),('3355','2013-10-23','14:10:00',1.6),('3355','2013-10-23','14:15:00',1.49),('3355','2013-10-23','14:20:00',1.57),('3355','2013-10-23','14:25:00',1.52),('3355','2013-10-23','14:30:00',1.49),('3355','2013-10-23','14:35:00',1.39),('3355','2013-10-23','14:40:00',1.34),('3355','2013-10-23','14:45:00',1.37),('3355','2013-10-23','14:50:00',1.19),('3355','2013-10-23','14:55:00',1.47),('3355','2013-10-23','15:00:00',1.38),('3355','2013-10-23','15:05:00',1.39),('3355','2013-10-23','15:10:00',1.33),('3355','2013-10-23','15:15:00',1.35),('3355','2013-10-23','15:20:00',1.35),('3355','2013-10-23','15:25:00',1.35),('3355','2013-10-23','15:30:00',1.31),('3355','2013-10-23','15:35:00',1.23),('3355','2013-10-23','15:40:00',1.28),('3355','2013-10-23','15:45:00',1.26),('3355','2013-10-23','15:50:00',1.12),('3355','2013-10-22','09:55:00',1.03),('3355','2013-10-22','10:00:00',1.06),('3355','2013-10-22','10:05:00',1.1),('3355','2013-10-22','10:10:00',1.13),('3355','2013-10-22','10:15:00',1.16),('3355','2013-10-22','10:20:00',1.21),('3355','2013-10-22','10:25:00',1.25),('3355','2013-10-22','10:30:00',1.28),('3355','2013-10-22','10:35:00',1.31),('3355','2013-10-22','10:40:00',1.33),('3355','2013-10-22','10:45:00',1.36),('3355','2013-10-22','10:50:00',1.4),('3355','2013-10-22','10:55:00',1.43),('3355','2013-10-22','11:00:00',1.45),('3355','2013-10-22','11:05:00',1.46),('3355','2013-10-22','11:10:00',1.48),('3355','2013-10-22','11:15:00',1.51),('3355','2013-10-22','11:20:00',1.52),('3355','2013-10-22','11:25:00',1.52),('3355','2013-10-22','11:30:00',1.54),('3355','2013-10-22','11:35:00',1.56),('3355','2013-10-22','11:40:00',1.58),('3355','2013-10-22','11:45:00',1.61),('3355','2013-10-22','11:50:00',1.63),('3355','2013-10-22','11:55:00',1.6),('3355','2013-10-22','12:00:00',1.62),('3355','2013-10-22','12:05:00',1.63),('3355','2013-10-22','12:10:00',1.64),('3355','2013-10-22','12:15:00',1.64),('3355','2013-10-22','12:20:00',1.64),('3355','2013-10-22','12:25:00',1.64),('3355','2013-10-22','12:30:00',1.62),('3355','2013-10-22','12:35:00',1.62),('3355','2013-10-22','12:40:00',1.48),('3355','2013-10-22','12:45:00',1.57),('3355','2013-10-22','12:50:00',1.68),('3355','2013-10-22','12:55:00',1.68),('3355','2013-10-22','13:00:00',1.67),('3355','2013-10-22','13:05:00',1.73),('3355','2013-10-22','13:10:00',1.7),('3355','2013-10-22','13:15:00',1.68),('3355','2013-10-22','13:20:00',1.57),('3355','2013-10-22','13:25:00',1.7),('3355','2013-10-22','13:30:00',1.59),('3355','2013-10-22','13:35:00',1.51),('3355','2013-10-22','13:40:00',1.62),('3355','2013-10-22','13:45:00',1.54),('3355','2013-10-22','13:50:00',1.67),('3355','2013-10-22','13:55:00',1.56),('3355','2013-10-22','14:00:00',1.52),('3355','2013-10-22','14:05:00',1.3),('3355','2013-10-22','14:15:00',1.18),('3355','2013-10-22','14:20:00',1.63),('3355','2013-10-22','14:45:00',1.04),('3355','2013-10-22','14:50:00',1.32),('3355','2013-10-22','14:55:00',1.35),('3355','2013-10-22','15:00:00',1.34),('3355','2013-10-22','15:05:00',1.35),('3355','2013-10-22','15:10:00',1.33),('3355','2013-10-22','15:15:00',1.27),('3355','2013-10-22','15:20:00',1.22),('3355','2013-10-22','15:25:00',1.22),('3355','2013-10-22','15:30:00',1.18),('3355','2013-10-22','15:35:00',1.18),('3355','2013-10-22','15:40:00',1.14),('3355','2013-10-22','15:45:00',1.06),('3355','2013-10-22','15:55:00',1.03),('3355','2013-10-21','10:05:00',1.09),('3355','2013-10-21','10:10:00',1.2),('3355','2013-10-21','10:15:00',1.23),('3355','2013-10-21','10:20:00',1.24),('3355','2013-10-21','10:25:00',1.29),('3355','2013-10-21','10:30:00',1.29),('3355','2013-10-21','10:35:00',1.3),('3355','2013-10-21','10:40:00',1.28),('3355','2013-10-21','10:45:00',1.3),('3355','2013-10-21','10:50:00',1.39),('3355','2013-10-21','10:55:00',1.39),('3355','2013-10-21','11:00:00',1.49),('3355','2013-10-21','11:05:00',1.46),('3355','2013-10-21','11:10:00',1.24),('3355','2013-10-21','11:15:00',1.62),('3355','2013-10-21','11:20:00',1.57),('3355','2013-10-21','11:25:00',1.61),('3355','2013-10-21','11:30:00',1.64),('3355','2013-10-21','11:35:00',1.65),('3355','2013-10-21','11:40:00',1.63),('3355','2013-10-21','11:45:00',1.7),('3355','2013-10-21','11:50:00',1.71),('3355','2013-10-21','11:55:00',1.71),('3355','2013-10-21','12:00:00',1.73),('3355','2013-10-21','12:05:00',1.75),('3355','2013-10-21','12:10:00',1.78),('3355','2013-10-21','12:15:00',1.77),('3355','2013-10-21','12:20:00',1.76),('3355','2013-10-21','12:25:00',1.79),('3355','2013-10-21','12:30:00',1.72),('3355','2013-10-21','12:35:00',1.72),('3355','2013-10-21','12:40:00',1.79),('3355','2013-10-21','12:45:00',1.8),('3355','2013-10-21','12:50:00',1.8),('3355','2013-10-21','12:55:00',1.79),('3355','2013-10-21','13:00:00',1.78),('3355','2013-10-21','13:05:00',1.77),('3355','2013-10-21','13:10:00',1.67),('3355','2013-10-21','13:15:00',1.73),('3355','2013-10-21','13:20:00',1.73),('3355','2013-10-21','13:25:00',1.74),('3355','2013-10-21','13:30:00',1.78),('3355','2013-10-21','13:35:00',1.78),('3355','2013-10-21','13:40:00',1.75),('3355','2013-10-21','13:45:00',1.75),('3355','2013-10-21','13:50:00',1.72),('3355','2013-10-21','13:55:00',1.66),('3355','2013-10-21','14:00:00',1.63),('3355','2013-10-21','14:05:00',1.68),('3355','2013-10-21','14:10:00',1.67),('3355','2013-10-21','14:15:00',1.67),('3355','2013-10-21','14:20:00',1.64),('3355','2013-10-21','14:25:00',1.63),('3355','2013-10-21','14:30:00',1.58),('3355','2013-10-21','14:35:00',1.57),('3355','2013-10-21','14:40:00',1.48),('3355','2013-10-21','14:45:00',1.46),('3355','2013-10-21','14:50:00',1.42),('3355','2013-10-21','14:55:00',1.41),('3355','2013-10-21','15:00:00',1.44),('3355','2013-10-21','15:05:00',1.44),('3355','2013-10-21','15:10:00',1.39),('3355','2013-10-21','15:15:00',1.38),('3355','2013-10-21','15:20:00',1.37),('3355','2013-10-21','15:25:00',1.32),('3355','2013-10-21','15:30:00',1.28),('3355','2013-10-21','15:35:00',1.19),('3355','2013-10-21','15:40:00',1.22),('3355','2013-10-21','15:45:00',1.18),('3355','2013-10-21','15:50:00',1.13),('3355','2013-10-21','15:55:00',1.1),('3355','2013-10-21','16:00:00',1.07),('3355','2013-10-21','16:05:00',1.02),('3355','2013-10-21','16:10:00',1),('3355','2013-10-20','09:45:00',1.02),('3355','2013-10-20','09:50:00',1.05),('3355','2013-10-20','09:55:00',1.07),('3355','2013-10-20','10:00:00',1.14),('3355','2013-10-20','10:05:00',1.18),('3355','2013-10-20','10:10:00',1.22),('3355','2013-10-20','10:15:00',1.26),('3355','2013-10-20','10:20:00',1.3),('3355','2013-10-20','10:25:00',1.33),('3355','2013-10-20','10:30:00',1.36),('3355','2013-10-20','10:35:00',1.39),('3355','2013-10-20','10:40:00',1.43),('3355','2013-10-20','10:45:00',1.46),('3355','2013-10-20','10:50:00',1.48),('3355','2013-10-20','10:55:00',1.51),('3355','2013-10-20','11:00:00',1.53),('3355','2013-10-20','11:05:00',1.56),('3355','2013-10-20','11:10:00',1.59),('3355','2013-10-20','11:15:00',1.61),('3355','2013-10-20','11:20:00',1.64),('3355','2013-10-20','11:25:00',1.67),('3355','2013-10-20','11:30:00',1.67),('3355','2013-10-20','11:35:00',1.7),('3355','2013-10-20','11:40:00',1.72),('3355','2013-10-20','11:45:00',1.71),('3355','2013-10-20','11:50:00',1.74),('3355','2013-10-20','11:55:00',1.73),('3355','2013-10-20','12:00:00',1.74),('3355','2013-10-20','12:05:00',1.78),('3355','2013-10-20','12:10:00',1.79),('3355','2013-10-20','12:25:00',1.26),('3355','2013-10-20','12:35:00',2.11),('3355','2013-10-20','12:40:00',1.73),('3355','2013-10-20','12:45:00',1.46),('3355','2013-10-20','12:50:00',1.6),('3355','2013-10-20','12:55:00',1.57),('3355','2013-10-20','13:00:00',1.38),('3355','2013-10-20','13:05:00',1.35),('3355','2013-10-20','13:10:00',1.92),('3355','2013-10-20','13:25:00',1.02),('3355','2013-10-20','13:30:00',1.53),('3355','2013-10-20','13:35:00',1.18),('3355','2013-10-20','13:45:00',1.33),('3355','2013-10-19','09:30:00',1.02),('3355','2013-10-19','09:35:00',1.06),('3355','2013-10-19','09:40:00',1.11),('3355','2013-10-19','09:45:00',1.16),('3355','2013-10-19','09:50:00',1.2),('3355','2013-10-19','09:55:00',1.29),('3355','2013-10-19','10:00:00',1.22),('3355','2013-10-19','10:05:00',1.23),('3355','2013-10-19','10:10:00',1.35),('3355','2013-10-19','10:15:00',1.29),('3355','2013-10-19','10:20:00',1.42),('3355','2013-10-19','10:25:00',1.54),('3355','2013-10-19','10:30:00',1.57),('3355','2013-10-19','10:35:00',1.57),('3355','2013-10-19','10:40:00',1.58),('3355','2013-10-19','10:45:00',1.56),('3355','2013-10-19','10:50:00',1.61),('3355','2013-10-19','10:55:00',1.66),('3355','2013-10-19','11:00:00',1.7),('3355','2013-10-19','11:05:00',1.56),('3355','2013-10-19','11:20:00',1.26),('3355','2013-10-19','11:25:00',1.86),('3355','2013-10-19','11:30:00',1.87),('3355','2013-10-19','11:35:00',1.9),('3355','2013-10-19','11:40:00',1.81),('3355','2013-10-19','11:45:00',1.89),('3355','2013-10-19','11:50:00',1.88),('3355','2013-10-19','11:55:00',1.84),('3355','2013-10-19','12:00:00',1.93),('3355','2013-10-19','12:05:00',1.93),('3355','2013-10-19','12:10:00',1.9),('3355','2013-10-19','12:15:00',1.91),('3355','2013-10-19','12:20:00',1.94),('3355','2013-10-19','12:25:00',1.75),('3355','2013-10-19','12:30:00',1.9),('3355','2013-10-19','12:35:00',1.97),('3355','2013-10-19','12:40:00',2.03),('3355','2013-10-19','12:45:00',2.05),('3355','2013-10-19','12:50:00',2.1),('3355','2013-10-19','12:55:00',2.06),('3355','2013-10-19','13:00:00',2.23),('3355','2013-10-19','13:05:00',1.89),('3355','2013-10-19','13:10:00',1.77),('3355','2013-10-19','13:15:00',1.8),('3355','2013-10-19','13:20:00',1.88),('3355','2013-10-19','13:25:00',2.02),('3355','2013-10-19','13:30:00',2.2),('3355','2013-10-19','13:35:00',1.65),('3355','2013-10-19','13:40:00',1.32),('3355','2013-10-19','13:45:00',1.29),('3355','2013-10-19','13:50:00',1.52),('3355','2013-10-19','13:55:00',1.93),('3355','2013-10-19','14:00:00',1.72),('3355','2013-10-19','14:05:00',1.46),('3355','2013-10-19','14:10:00',1.07),('3355','2013-10-19','14:15:00',1.42),('3355','2013-10-19','14:20:00',1.32),('3355','2013-10-19','14:25:00',1.1),('3355','2013-10-19','14:30:00',1.21),('3355','2013-10-19','14:35:00',2.04),('3355','2013-10-19','14:40:00',1.54),('3355','2013-10-19','14:45:00',1.19),('3355','2013-10-19','14:50:00',1.81),('3355','2013-10-19','14:55:00',1.77),('3355','2013-10-19','15:00:00',1.72),('3355','2013-10-19','15:05:00',1.66),('3355','2013-10-19','15:10:00',1.65),('3355','2013-10-19','15:15:00',1.63),('3355','2013-10-19','15:20:00',1.52),('3355','2013-10-19','15:25:00',1.46),('3355','2013-10-19','15:30:00',1.4),('3355','2013-10-19','15:35:00',1.38),('3355','2013-10-19','15:40:00',1.31),('3355','2013-10-19','15:45:00',1.13),('3355','2013-10-19','15:50:00',1.13),('3355','2013-10-19','15:55:00',1.31),('3355','2013-10-19','16:00:00',1.1),('3355','2013-10-19','16:05:00',1.16),('3355','2013-10-19','16:10:00',1.13),('3355','2013-10-19','16:15:00',1.17),('3355','2013-10-19','16:20:00',1.16),('3355','2013-10-19','16:30:00',1.03),('3355','2013-10-19','16:35:00',1.06),('3355','2013-10-19','16:40:00',1.02),('3355','2014-05-04','08:30:00',1.01),('3355','2014-05-04','09:05:00',1.38),('3355','2014-05-04','09:10:00',1.22),('3355','2014-05-04','09:15:00',1.3),('3355','2014-05-04','09:20:00',1.93),('3355','2014-05-04','09:25:00',1.46),('3355','2014-05-04','09:45:00',1.15),('3355','2014-05-04','09:50:00',1.35),('3355','2014-05-04','09:55:00',1.4),('3355','2014-05-04','10:00:00',1.97),('3355','2014-05-04','10:05:00',2.07),('3355','2014-05-04','10:10:00',1.79),('3355','2014-05-04','10:15:00',1.51),('3355','2014-05-04','10:20:00',1.07),('3355','2014-05-04','10:25:00',1.05),('3355','2014-05-04','10:30:00',1.09),('3355','2014-05-04','10:35:00',1.14),('3355','2014-05-04','10:40:00',1.22),('3355','2014-05-04','10:45:00',1.48),('3355','2014-05-04','10:50:00',1.39),('3355','2014-05-04','10:55:00',1.78),('3355','2014-05-04','11:00:00',1.65),('3355','2014-05-04','11:05:00',2.15),('3355','2014-05-04','11:10:00',2.04),('3355','2014-05-04','11:15:00',2.17),('3355','2014-05-04','11:20:00',2.35),('3355','2014-05-04','11:25:00',2),('3355','2014-05-04','11:30:00',2.27),('3355','2014-05-04','11:35:00',2.16),('3355','2014-05-04','11:40:00',1.65),('3355','2014-05-04','11:45:00',2.15),('3355','2014-05-04','11:50:00',1.85),('3355','2014-05-04','11:55:00',1.97),('3355','2014-05-04','12:00:00',1.88),('3355','2014-05-04','12:05:00',1.43),('3355','2014-05-04','12:10:00',1.02),('3355','2014-05-04','12:20:00',1.02),('3355','2014-05-04','12:25:00',1.02),('3355','2014-05-04','12:30:00',2.77),('3355','2014-05-04','12:35:00',2.27),('3355','2014-05-04','12:40:00',2.16),('3355','2014-05-04','12:45:00',1.33),('3355','2014-05-04','12:50:00',1.9),('3355','2014-05-04','12:55:00',1.44),('3355','2014-05-04','13:00:00',1.12),('3355','2014-05-04','13:05:00',1.1),('3355','2014-05-04','13:10:00',1.11),('3355','2014-05-04','13:15:00',1.06),('3355','2014-05-04','13:20:00',1),('3355','2014-05-04','15:00:00',1.01),('3355','2014-05-04','15:05:00',1.61),('3355','2014-05-04','15:10:00',2.23),('3355','2014-05-04','15:15:00',1.7),('3355','2014-04-16','08:55:00',1.06),('3355','2014-04-16','09:00:00',1.11),('3355','2014-04-16','09:05:00',1.17),('3355','2014-04-16','09:10:00',1.22),('3355','2014-04-16','09:15:00',1.25),('3355','2014-04-16','09:20:00',1.31),('3355','2014-04-16','09:25:00',1.38),('3355','2014-04-16','09:30:00',1.27),('3355','2014-04-16','09:50:00',1.2),('3355','2014-04-16','09:55:00',1.8),('3355','2014-04-16','10:00:00',1.74),('3355','2014-04-16','10:05:00',1.77),('3355','2014-04-16','10:10:00',1.82),('3355','2014-04-16','10:15:00',1.86),('3355','2014-04-16','10:20:00',1.9),('3355','2014-04-16','10:25:00',1.93),('3355','2014-04-16','10:30:00',1.97),('3355','2014-04-16','10:35:00',2),('3355','2014-04-16','10:40:00',2.03),('3355','2014-04-16','10:45:00',2.07),('3355','2014-04-16','10:50:00',2.15),('3355','2014-04-16','10:55:00',1.97),('3355','2014-04-16','11:00:00',2.08),('3355','2014-04-16','11:05:00',1.85),('3355','2014-04-16','11:15:00',1.17),('3355','2014-04-16','11:20:00',2.36),('3355','2014-04-16','11:25:00',1.88),('3355','2014-04-16','11:30:00',2.08),('3355','2014-04-16','11:35:00',1.64),('3355','2014-04-16','11:40:00',2.03),('3355','2014-04-16','11:45:00',2.22),('3355','2014-04-16','11:50:00',2.53),('3355','2014-04-16','11:55:00',2.58),('3355','2014-04-16','12:00:00',2.65),('3355','2014-04-16','12:05:00',1.52),('3355','2014-04-16','12:10:00',1.87),('3355','2014-04-16','12:20:00',2.36),('3355','2014-04-16','12:25:00',1.03),('3355','2014-04-16','12:30:00',1.33),('3355','2014-04-16','12:35:00',2.63),('3355','2014-04-16','12:40:00',2.68),('3355','2014-04-16','12:45:00',2.6),('3355','2014-04-16','12:50:00',2.41),('3355','2014-04-16','12:55:00',1.89),('3355','2014-04-16','13:00:00',1.53),('3355','2014-04-16','13:40:00',1.27),('3355','2014-04-16','13:45:00',2.34),('3355','2014-04-16','13:50:00',2.26),('3355','2014-04-16','13:55:00',1.5),('3355','2014-04-16','14:05:00',1.31),('3355','2014-04-16','14:10:00',2.73),('3355','2014-04-16','14:15:00',2.86),('3355','2014-04-16','14:20:00',2.64),('3355','2014-04-16','14:25:00',1.98),('3355','2014-04-16','14:30:00',2.06),('3355','2014-04-16','14:35:00',2.52),('3355','2014-04-16','14:40:00',2.44),('3355','2014-04-16','14:45:00',1.72),('3355','2014-04-16','14:50:00',1.91),('3355','2014-04-16','15:00:00',1.18),('3355','2014-04-16','15:05:00',1.68),('3355','2014-04-16','15:10:00',2.79),('3355','2014-04-16','15:15:00',1.57),('3355','2014-04-16','15:30:00',1.8),('3355','2014-04-16','15:35:00',2.44),('3355','2014-04-16','15:40:00',2.36),('3355','2014-04-16','15:45:00',2.25),('3355','2014-04-16','15:50:00',2.18),('3355','2014-04-16','15:55:00',2.13),('3355','2014-04-16','16:00:00',2.07),('3355','2014-04-16','16:05:00',2.02),('3355','2014-04-16','16:10:00',1.97),('3355','2014-04-16','16:15:00',1.94),('3355','2014-04-16','16:20:00',1.88),('3355','2014-04-16','16:25:00',1.87),('3355','2014-04-16','16:30:00',1.84),('3355','2014-04-16','16:35:00',1.8),('3355','2014-04-16','16:40:00',1.77),('3355','2014-04-16','16:45:00',1.73),('3355','2014-04-16','16:50:00',1.66),('3355','2014-04-16','16:55:00',1.61),('3355','2014-04-16','17:00:00',1.56),('3355','2014-04-16','17:05:00',1.51),('3355','2014-04-16','17:10:00',1.46),('3355','2014-04-16','17:15:00',1.43),('3355','2014-04-16','17:20:00',1.35),('3355','2014-04-16','17:25:00',1.29),('3355','2014-04-16','17:30:00',1.24),('3355','2014-04-16','17:35:00',1.21),('3355','2014-04-16','17:40:00',1.14),('3355','2014-04-16','17:45:00',1.1),('3355','2014-04-16','17:50:00',1.11),('3355','2014-04-16','17:55:00',1.1),('3355','2014-04-16','18:00:00',1),('3355','2013-10-18','09:30:00',1.01),('3355','2013-10-18','09:35:00',1.06),('3355','2013-10-18','09:40:00',1.11),('3355','2013-10-18','09:45:00',1.16),('3355','2013-10-18','09:50:00',1.2),('3355','2013-10-18','09:55:00',1.24),('3355','2013-10-18','10:00:00',1.28),('3355','2013-10-18','10:05:00',1.33),('3355','2013-10-18','10:10:00',1.36),('3355','2013-10-18','10:15:00',1.39),('3355','2013-10-18','10:20:00',1.41),('3355','2013-10-18','10:25:00',1.47),('3355','2013-10-18','10:30:00',1.5),('3355','2013-10-18','10:35:00',1.54),('3355','2013-10-18','10:40:00',1.57),('3355','2013-10-18','10:45:00',1.6),('3355','2013-10-18','10:50:00',1.62),('3355','2013-10-18','10:55:00',1.65),('3355','2013-10-18','11:00:00',1.65),('3355','2013-10-18','11:05:00',1.64),('3355','2013-10-18','11:10:00',1.61),('3355','2013-10-18','11:15:00',1.6),('3355','2013-10-18','11:20:00',1.75),('3355','2013-10-18','11:25:00',1.66),('3355','2013-10-18','11:30:00',1.78),('3355','2013-10-18','11:35:00',1.81),('3355','2013-10-18','11:40:00',1.86),('3355','2013-10-18','11:45:00',1.45),('3355','2013-10-18','11:50:00',1.81),('3355','2013-10-18','11:55:00',1.89),('3355','2013-10-18','12:00:00',1.82),('3355','2013-10-18','12:05:00',1.89),('3355','2013-10-18','12:10:00',1.89),('3355','2013-10-18','12:15:00',1.87),('3355','2013-10-18','12:20:00',1.86),('3355','2013-10-18','12:25:00',1.89),('3355','2013-10-18','12:30:00',1.91),('3355','2013-10-18','12:35:00',1.88),('3355','2013-10-18','12:40:00',1.91),('3355','2013-10-18','12:45:00',1.86),('3355','2013-10-18','12:50:00',1.87),('3355','2013-10-18','12:55:00',1.92),('3355','2013-10-18','13:00:00',1.91),('3355','2013-10-18','13:05:00',1.85),('3355','2013-10-18','13:10:00',1.78),('3355','2013-10-18','13:15:00',1.86),('3355','2013-10-18','13:20:00',1.86),('3355','2013-10-18','13:25:00',1.92),('3355','2013-10-18','13:30:00',1.91),('3355','2013-10-18','13:35:00',1.9),('3355','2013-10-18','13:40:00',1.9),('3355','2013-10-18','13:45:00',1.86),('3355','2013-10-18','13:50:00',1.85),('3355','2013-10-18','13:55:00',1.86),('3355','2013-10-18','14:00:00',1.72),('3355','2013-10-18','14:05:00',1.76),('3355','2013-10-18','14:10:00',1.74),('3355','2013-10-18','14:15:00',1.78),('3355','2013-10-18','14:20:00',1.78),('3355','2013-10-18','14:25:00',1.76),('3355','2013-10-18','14:30:00',1.75),('3355','2013-10-18','14:35:00',1.68),('3355','2013-10-18','14:40:00',1.7),('3355','2013-10-18','14:45:00',1.65),('3355','2013-10-18','14:50:00',1.59),('3355','2013-10-18','14:55:00',1.62),('3355','2013-10-18','15:00:00',1.41),('3355','2013-10-18','15:05:00',1.28),('3355','2013-10-18','15:10:00',1.42),('3355','2013-10-18','15:15:00',1.43),('3355','2013-10-18','15:20:00',1.49),('3355','2013-10-18','15:25:00',1.42),('3355','2013-10-18','15:30:00',1.34),('3355','2013-10-18','15:35:00',1.35),('3355','2013-10-18','15:40:00',1.3),('3355','2013-10-18','15:45:00',1.2),('3355','2013-10-18','15:50:00',1.18),('3355','2013-10-18','15:55:00',1.08),('3355','2013-10-18','16:00:00',1.15),('3355','2013-10-18','16:05:00',1.09),('3355','2013-10-18','16:10:00',1.05),('3355','2013-10-17','09:30:00',1.01),('3355','2013-10-17','09:35:00',1.06),('3355','2013-10-17','09:40:00',1.11),('3355','2013-10-17','09:45:00',1.15),('3355','2013-10-17','09:50:00',1.2),('3355','2013-10-17','09:55:00',1.23),('3355','2013-10-17','10:00:00',1.27),('3355','2013-10-17','10:05:00',1.31),('3355','2013-10-17','10:10:00',1.35),('3355','2013-10-17','10:15:00',1.39),('3355','2013-10-17','10:20:00',1.44),('3355','2013-10-17','10:25:00',1.47),('3355','2013-10-17','10:30:00',1.51),('3355','2013-10-17','10:35:00',1.55),('3355','2013-10-17','10:40:00',1.58),('3355','2013-10-17','10:45:00',1.62),('3355','2013-10-17','10:50:00',1.64),('3355','2013-10-17','10:55:00',1.67),('3355','2013-10-17','11:00:00',1.71),('3355','2013-10-17','11:05:00',1.73),('3355','2013-10-17','11:10:00',1.75),('3355','2013-10-17','11:15:00',1.77),('3355','2013-10-17','11:20:00',1.79),('3355','2013-10-17','11:25:00',1.81),('3355','2013-10-17','11:30:00',1.83),('3355','2013-10-17','11:35:00',1.86),('3355','2013-10-17','11:40:00',1.88),('3355','2013-10-17','11:45:00',1.88),('3355','2013-10-17','11:50:00',1.89),('3355','2013-10-17','11:55:00',1.91),('3355','2013-10-17','12:00:00',1.91),('3355','2013-10-17','12:05:00',1.93),('3355','2013-10-17','12:10:00',1.94),('3355','2013-10-17','12:15:00',1.95),('3355','2013-10-17','12:20:00',1.96),('3355','2013-10-17','12:25:00',1.98),('3355','2013-10-17','12:30:00',1.96),('3355','2013-10-17','12:35:00',1.97),('3355','2013-10-17','12:40:00',1.98),('3355','2013-10-17','12:45:00',2),('3355','2013-10-17','12:50:00',2),('3355','2013-10-17','12:55:00',2.01),('3355','2013-10-17','13:00:00',2.02),('3355','2013-10-17','13:05:00',2.01),('3355','2013-10-17','13:10:00',2),('3355','2013-10-17','13:15:00',1.99),('3355','2013-10-17','13:20:00',2),('3355','2013-10-17','13:25:00',1.99),('3355','2013-10-17','13:30:00',1.98),('3355','2013-10-17','13:35:00',1.97),('3355','2013-10-17','13:40:00',1.95),('3355','2013-10-17','13:45:00',1.94),('3355','2013-10-17','13:50:00',1.94),('3355','2013-10-17','13:55:00',1.93),('3355','2013-10-17','14:00:00',1.93),('3355','2013-10-17','14:05:00',1.92),('3355','2013-10-17','14:10:00',1.9),('3355','2013-10-17','14:15:00',1.89),('3355','2013-10-17','14:20:00',1.87),('3355','2013-10-17','14:25:00',1.86),('3355','2013-10-17','14:30:00',1.84),('3355','2013-10-17','14:35:00',1.8),('3355','2013-10-17','14:40:00',1.78),('3355','2013-10-17','14:45:00',1.78),('3355','2013-10-17','14:50:00',1.75),('3355','2013-10-17','14:55:00',1.72),('3355','2013-10-17','15:00:00',1.7),('3355','2013-10-17','15:05:00',1.67),('3355','2013-10-17','15:10:00',1.65),('3355','2013-10-17','15:15:00',1.62),('3355','2013-10-17','15:20:00',1.59),('3355','2013-10-17','15:25:00',1.56),('3355','2013-10-17','15:30:00',1.53),('3355','2013-10-17','15:35:00',1.49),('3355','2013-10-17','15:40:00',1.45),('3355','2013-10-17','15:45:00',1.41),('3355','2013-10-17','15:50:00',1.38),('3355','2013-10-17','15:55:00',1.34),('3355','2013-10-17','16:00:00',1.3),('3355','2013-10-17','16:05:00',1.24),('3355','2013-10-17','16:10:00',1.21),('3355','2013-10-17','16:15:00',1.17),('3355','2013-10-17','16:20:00',1.14),('3355','2013-10-17','16:25:00',1.1),('3355','2013-10-17','16:30:00',1.05),('3355','2013-10-17','16:35:00',1),('3355','2013-10-16','09:50:00',1.08),('3355','2013-10-16','12:15:00',1.05),('3355','2013-10-16','12:20:00',2.03),('3355','2013-10-16','12:35:00',1.13),('3355','2013-10-16','12:40:00',1.98),('3355','2013-10-16','12:45:00',2.07),('3355','2013-10-16','12:50:00',1.71),('3355','2013-10-16','12:55:00',1.73),('3355','2013-10-16','13:00:00',1.71),('3355','2013-10-16','13:05:00',1.78),('3355','2013-10-16','13:10:00',1.61),('3355','2013-10-16','13:15:00',1.89),('3355','2013-10-16','13:20:00',1.76),('3355','2013-10-16','13:25:00',1.86),('3355','2013-10-16','13:30:00',2.13),('3355','2013-10-16','13:35:00',2),('3355','2013-10-16','13:40:00',2),('3355','2013-10-16','13:45:00',1.98),('3355','2013-10-16','13:50:00',1.96),('3355','2013-10-16','13:55:00',2.06),('3355','2013-10-16','14:00:00',1.72),('3355','2013-10-16','14:05:00',1.22),('3355','2013-10-16','14:10:00',2.14),('3355','2013-10-16','14:15:00',2.02),('3355','2013-10-16','14:20:00',1.56),('3355','2013-10-16','14:25:00',2.03),('3355','2013-10-16','14:30:00',1.95),('3355','2013-10-16','14:35:00',1.79),('3355','2013-10-16','14:40:00',1.47),('3355','2013-10-16','14:45:00',1.89),('3355','2013-10-16','14:50:00',1.57),('3355','2013-10-16','14:55:00',1.62),('3355','2013-10-16','15:00:00',1.6),('3355','2013-10-16','15:05:00',1.66),('3355','2013-10-16','15:10:00',1.62),('3355','2013-10-16','15:15:00',1.67),('3355','2013-10-16','15:20:00',1.57),('3355','2013-10-16','15:25:00',1.49),('3355','2013-10-16','15:40:00',1.58),('3355','2013-10-16','15:45:00',1.45),('3355','2013-10-16','15:50:00',1.37),('3355','2013-10-16','15:55:00',1.35),('3355','2013-10-16','16:00:00',1.3),('3355','2013-10-16','16:05:00',1.27),('3355','2013-10-16','16:10:00',1.05),('3355','2013-10-16','16:15:00',1.18),('3355','2013-10-16','16:20:00',1.13),('3355','2013-10-16','16:25:00',1.08),('3355','2013-10-16','16:30:00',1.01),('3355','2013-10-15','09:45:00',1.01),('3355','2013-10-15','09:50:00',1.16),('3355','2013-10-15','09:55:00',1.22),('3355','2013-10-15','10:00:00',1.23),('3355','2013-10-15','10:05:00',1.33),('3355','2013-10-15','10:10:00',1.06),('3355','2013-10-15','10:30:00',1.09),('3355','2013-10-15','10:40:00',1.05),('3355','2013-10-15','10:45:00',1.23),('3355','2013-10-15','10:50:00',1.25),('3355','2013-10-15','10:55:00',1.05),('3355','2013-10-15','11:00:00',1.04),('3355','2013-10-15','11:05:00',1.08),('3355','2013-10-15','11:10:00',1.45),('3355','2013-10-15','11:15:00',1.58),('3355','2013-10-15','11:20:00',1.6),('3355','2013-10-15','11:25:00',1.51),('3355','2013-10-15','11:30:00',1.57),('3355','2013-10-15','11:35:00',1.36),('3355','2013-10-15','11:40:00',1.06),('3355','2013-10-15','13:10:00',1.02),('3355','2013-10-15','13:15:00',1.02),('3355','2013-10-15','13:20:00',1.49),('3355','2013-10-15','13:25:00',1.79),('3355','2013-10-15','13:30:00',1.14),('3355','2013-10-15','14:20:00',1.15),('3355','2013-10-15','14:25:00',1.24),('3355','2013-10-15','14:30:00',1.31),('3355','2013-10-15','14:45:00',1.1),('3355','2013-10-15','14:50:00',1.38),('3355','2013-10-15','14:55:00',1.24),('3355','2013-10-14','09:35:00',1.01),('3355','2013-10-14','09:55:00',1.09),('3355','2013-10-14','10:00:00',1.06),('3355','2013-10-14','10:05:00',1.18),('3355','2013-10-14','10:10:00',1.22),('3355','2013-10-14','10:15:00',1.33),('3355','2013-10-14','10:20:00',1.35),('3355','2013-10-14','10:25:00',1.38),('3355','2013-10-14','10:30:00',1.41),('3355','2013-10-14','10:35:00',1.43),('3355','2013-10-14','10:40:00',1.42),('3355','2013-10-14','10:45:00',1.46),('3355','2013-10-14','10:50:00',1.53),('3355','2013-10-14','10:55:00',1.56),('3355','2013-10-14','11:00:00',1.6),('3355','2013-10-14','11:05:00',1.59),('3355','2013-10-14','11:10:00',1.66),('3355','2013-10-14','11:15:00',1.66),('3355','2013-10-14','11:20:00',1.66),('3355','2013-10-14','11:25:00',1.69),('3355','2013-10-14','11:30:00',1.74),('3355','2013-10-14','11:35:00',1.7),('3355','2013-10-14','11:40:00',1.72),('3355','2013-10-14','11:45:00',1.73),('3355','2013-10-14','11:50:00',1.74),('3355','2013-10-14','11:55:00',1.76),('3355','2013-10-14','12:00:00',1.78),('3355','2013-10-14','12:05:00',1.79),('3355','2013-10-14','12:10:00',1.83),('3355','2013-10-14','12:15:00',1.82),('3355','2013-10-14','12:20:00',1.7),('3355','2013-10-14','12:25:00',1.77),('3355','2013-10-14','12:30:00',1.87),('3355','2013-10-14','12:35:00',1.86),('3355','2013-10-14','12:40:00',1.85),('3355','2013-10-14','12:45:00',1.87),('3355','2013-10-14','12:50:00',1.86),('3355','2013-10-14','12:55:00',1.87),('3355','2013-10-14','13:00:00',1.87),('3355','2013-10-14','13:05:00',1.87),('3355','2013-10-14','13:10:00',1.86),('3355','2013-10-14','13:15:00',1.85),('3355','2013-10-14','13:20:00',1.86),('3355','2013-10-14','13:25:00',1.85),('3355','2013-10-14','13:30:00',1.84),('3355','2013-10-14','13:35:00',1.83),('3355','2013-10-14','13:40:00',1.82),('3355','2013-10-14','13:45:00',1.81),('3355','2013-10-14','13:50:00',1.8),('3355','2013-10-14','13:55:00',1.8),('3355','2013-10-14','14:00:00',1.79),('3355','2013-10-14','14:05:00',1.78),('3355','2013-10-14','14:10:00',1.77),('3355','2013-10-14','14:15:00',1.76),('3355','2013-10-14','14:20:00',1.74),('3355','2013-10-14','14:25:00',1.73),('3355','2013-10-14','14:30:00',1.72),('3355','2013-10-14','14:35:00',1.7),('3355','2013-10-14','14:40:00',1.66),('3355','2013-10-14','14:45:00',1.65),('3355','2013-10-14','14:50:00',1.64),('3355','2013-10-14','14:55:00',1.61),('3355','2013-10-14','15:00:00',1.59),('3355','2013-10-14','15:05:00',1.57),('3355','2013-10-14','15:10:00',1.52),('3355','2013-10-14','15:15:00',1.48),('3355','2013-10-14','15:20:00',1.46),('3355','2013-10-14','15:25:00',1.42),('3355','2013-10-14','15:30:00',1.38),('3355','2013-10-14','15:35:00',1.33),('3355','2013-10-14','15:40:00',1.23),('3355','2013-10-14','15:45:00',1),('3355','2013-10-13','09:40:00',1.15),('3355','2013-10-13','09:45:00',1.44),('3355','2013-10-13','09:50:00',1.42),('3355','2013-10-13','09:55:00',1.48),('3355','2013-10-13','10:00:00',1.17),('3355','2013-10-13','10:10:00',1.08),('3355','2013-10-13','10:15:00',1.29),('3355','2013-10-13','10:20:00',1.06),('3355','2013-10-13','10:25:00',1.16),('3355','2013-10-13','10:30:00',1.46),('3355','2013-10-13','10:35:00',1.71),('3355','2013-10-13','10:40:00',1.78),('3355','2013-10-13','10:45:00',1.82),('3355','2013-10-13','10:50:00',1.49),('3355','2013-10-13','10:55:00',1.2),('3355','2013-10-13','11:00:00',1.55),('3355','2013-10-13','11:05:00',1.69),('3355','2013-10-13','11:10:00',1.63),('3355','2013-10-13','11:15:00',1.8),('3355','2013-10-13','11:20:00',1.73),('3355','2013-10-13','11:25:00',1.7),('3355','2013-10-13','11:30:00',1.75),('3355','2013-10-13','11:35:00',1.75),('3355','2013-10-13','11:40:00',1.76),('3355','2013-10-13','11:45:00',1.77),('3355','2013-10-13','11:50:00',1.79),('3355','2013-10-13','11:55:00',1.79),('3355','2013-10-13','12:00:00',1.81),('3355','2013-10-13','12:05:00',1.82),('3355','2013-10-13','12:10:00',1.83),('3355','2013-10-13','12:15:00',1.85),('3355','2013-10-13','12:20:00',1.81),('3355','2013-10-13','12:25:00',1.75),('3355','2013-10-13','12:30:00',1.87),('3355','2013-10-13','12:35:00',1.9),('3355','2013-10-13','12:40:00',1.9),('3355','2013-10-13','12:45:00',1.87),('3355','2013-10-13','12:50:00',1.85),('3355','2013-10-13','12:55:00',1.86),('3355','2013-10-13','13:00:00',1.87),('3355','2013-10-13','13:05:00',1.87),('3355','2013-10-13','13:10:00',1.88),('3355','2013-10-13','13:15:00',1.91),('3355','2013-10-13','13:20:00',1.92),('3355','2013-10-13','13:25:00',1.67),('3355','2013-10-13','13:30:00',1.39),('3355','2013-10-13','13:35:00',1.59),('3355','2013-10-13','13:40:00',1.03),('3355','2013-10-13','13:45:00',1.1),('3355','2013-10-13','13:50:00',1.22),('3355','2013-10-13','13:55:00',1.41),('3355','2013-10-13','14:00:00',1.85),('3355','2013-10-13','14:05:00',1.84),('3355','2013-10-13','14:10:00',1.8),('3355','2013-10-13','14:15:00',1.68),('3355','2013-10-13','14:20:00',1.83),('3355','2013-10-13','14:25:00',1.85),('3355','2013-10-13','14:30:00',1.67),('3355','2013-10-13','14:35:00',1.37),('3355','2013-10-13','14:40:00',1.62),('3355','2013-10-13','14:45:00',1.29),('3355','2013-10-13','14:50:00',1),('3355','2013-10-13','14:55:00',1.23),('3355','2013-10-13','15:00:00',1.47),('3355','2013-10-13','15:05:00',1.36),('3355','2013-10-13','15:15:00',1.08),('3355','2013-10-13','15:20:00',1.24),('3355','2013-10-13','15:25:00',1.41),('3355','2013-10-13','15:30:00',1),('3355','2013-10-13','16:05:00',1.04),('3355','2013-10-13','16:25:00',1.14),('3355','2013-10-13','16:30:00',1.12),('3355','2013-10-12','11:40:00',1.64),('3355','2013-10-12','12:25:00',2.1),('3355','2013-10-12','12:30:00',1.59),('3355','2013-10-12','12:35:00',1.84),('3355','2013-10-12','12:40:00',1.83),('3355','2013-10-12','12:45:00',1.72),('3355','2013-10-12','12:50:00',1.57),('3355','2013-10-12','12:55:00',1.39),('3355','2013-10-12','13:00:00',1.04),('3355','2013-10-12','13:30:00',2.25),('3355','2013-10-11','09:45:00',1.22),('3355','2013-10-11','09:50:00',1.03),('3355','2013-10-11','09:55:00',1.27),('3355','2013-10-11','10:00:00',1.3),('3355','2013-10-11','10:05:00',1.33),('3355','2013-10-11','10:10:00',1.38),('3355','2013-10-11','10:15:00',1.03),('3355','2013-10-11','10:20:00',1.11),('3355','2013-10-11','10:35:00',1.32),('3355','2013-10-11','11:05:00',1.49),('3355','2013-10-11','11:10:00',1.41),('3355','2013-10-11','11:50:00',1.39),('3355','2013-10-11','12:00:00',1.6),('3355','2013-10-11','12:05:00',2.35),('3355','2013-10-11','12:10:00',1.11),('3355','2013-10-11','13:05:00',1.35),('3355','2013-10-11','13:10:00',1.15),('3355','2013-10-11','13:20:00',1.4),('3355','2013-10-11','13:25:00',2.45),('3355','2013-10-11','13:45:00',2.02),('3355','2013-10-11','16:00:00',1.02),('3355','2013-10-11','16:35:00',1.07),('3355','2013-10-10','09:35:00',1.06),('3355','2013-10-10','10:20:00',1.47),('3355','2013-10-10','10:25:00',1.39),('3355','2013-10-10','10:30:00',1.26),('3355','2013-10-10','10:45:00',1.33),('3355','2013-10-10','11:20:00',1.08),('3355','2013-10-10','11:25:00',2.15),('3355','2013-10-10','11:30:00',1.16),('3355','2013-10-10','11:40:00',1.26),('3355','2013-10-10','11:45:00',1.73),('3355','2013-10-10','11:55:00',2.02),('3355','2013-10-10','12:25:00',1.39),('3355','2013-10-10','12:30:00',1.49),('3355','2013-10-10','12:35:00',2.41),('3355','2013-10-10','12:40:00',2.05),('3355','2013-10-10','12:45:00',2.05),('3355','2013-10-10','12:50:00',1.39),('3355','2013-10-10','13:00:00',1.42),('3355','2013-10-10','13:05:00',2),('3355','2013-10-10','13:20:00',1.18),('3355','2013-10-10','13:25:00',1.01),('3355','2013-10-10','13:40:00',1.7),('3355','2013-10-10','13:45:00',1.69),('3355','2013-10-10','13:50:00',2.05),('3355','2013-10-10','13:55:00',2.09),('3355','2013-10-10','14:00:00',1.95),('3355','2013-10-10','14:05:00',1.03),('3355','2013-10-10','14:10:00',1.64),('3355','2013-10-10','14:15:00',1.33),('3355','2013-10-10','14:20:00',2.21),('3355','2013-10-10','14:25:00',1.5),('3355','2013-10-10','14:30:00',1.45),('3355','2013-10-10','14:35:00',1.46),('3355','2013-10-10','14:40:00',2.08),('3355','2013-10-10','14:45:00',1.44),('3355','2013-10-10','14:50:00',1.66),('3355','2013-10-10','14:55:00',1.94),('3355','2013-10-10','15:00:00',1.89),('3355','2013-10-10','15:05:00',1.87),('3355','2013-10-10','15:10:00',1.84),('3355','2013-10-10','15:15:00',1.45),('3355','2013-10-10','15:20:00',1.39),('3355','2013-10-10','15:30:00',1.24),('3355','2013-10-10','16:15:00',1.44),('3355','2013-10-10','16:20:00',1.02),('3355','2013-10-10','16:25:00',1.17),('3355','2013-10-10','16:45:00',1.06),('3355','2013-10-09','09:25:00',1.02),('3355','2013-10-09','09:30:00',1.06),('3355','2013-10-09','09:35:00',1.1),('3355','2013-10-09','09:40:00',1.16),('3355','2013-10-09','09:45:00',1.22),('3355','2013-10-09','09:50:00',1.27),('3355','2013-10-09','09:55:00',1.33),('3355','2013-10-09','10:00:00',1.41),('3355','2013-10-09','10:05:00',1.53),('3355','2013-10-09','10:10:00',1.61),('3355','2013-10-09','10:15:00',1.05),('3355','2013-10-09','10:40:00',1.29),('3355','2013-10-09','10:45:00',1.37),('3355','2013-10-09','10:50:00',1.32),('3355','2013-10-09','10:55:00',1.11),('3355','2013-10-09','11:00:00',1.38),('3355','2013-10-09','11:05:00',1.94),('3355','2013-10-09','11:10:00',2.14),('3355','2013-10-09','11:15:00',2.13),('3355','2013-10-09','11:20:00',1.93),('3355','2013-10-09','11:25:00',1.78),('3355','2013-10-09','11:30:00',2.05),('3355','2013-10-09','11:35:00',2.17),('3355','2013-10-09','11:40:00',1.44),('3355','2013-10-09','11:45:00',1.57),('3355','2013-10-09','11:50:00',1.85),('3355','2013-10-09','11:55:00',1.84),('3355','2013-10-09','12:00:00',1.58),('3355','2013-10-09','12:10:00',1.27),('3355','2013-10-09','12:20:00',1.22),('3355','2013-10-09','12:25:00',1.95),('3355','2013-10-09','12:30:00',1.68),('3355','2013-10-09','12:35:00',1.33),('3355','2013-10-09','13:15:00',1.12),('3355','2013-10-09','13:20:00',1.23),('3355','2013-10-09','13:25:00',1.24),('3355','2013-10-09','13:30:00',1.12),('3355','2013-10-09','13:40:00',1.71),('3355','2013-10-09','13:45:00',1.8),('3355','2013-10-09','13:50:00',1.42),('3355','2013-10-09','13:55:00',2.41),('3355','2013-10-09','14:00:00',1.75),('3355','2013-10-09','15:05:00',1.81),('3355','2013-10-09','15:10:00',1.79),('3355','2013-10-09','15:15:00',1.94),('3355','2013-10-09','15:20:00',1.66),('3355','2013-10-09','15:30:00',1.37),('3355','2013-10-09','15:40:00',1.62),('3355','2013-10-09','15:50:00',1.37),('3355','2013-10-09','16:40:00',1.27),('3355','2014-04-15','09:25:00',1.07),('3355','2014-04-15','09:50:00',1.4),('3355','2014-04-15','10:30:00',1.75),('3355','2014-04-15','10:35:00',1.65),('3355','2014-04-15','10:40:00',1.21),('3355','2014-04-15','10:45:00',1.82),('3355','2014-04-15','10:50:00',1.42),('3355','2014-04-15','11:05:00',2.02),('3355','2014-04-15','11:10:00',1.65),('3355','2014-04-15','11:15:00',1.04),('3355','2014-04-15','12:20:00',1.17),('3355','2014-04-15','13:20:00',1.72),('3355','2014-04-15','13:25:00',1.06),('3355','2014-04-15','13:30:00',1.29),('3355','2014-04-15','13:35:00',1.38),('3355','2014-04-15','13:40:00',1.84),('3355','2014-04-15','14:05:00',2.04),('3355','2014-04-15','14:10:00',1.92),('3355','2014-04-15','14:15:00',2.18),('3355','2014-04-15','14:20:00',1.29),('3355','2014-04-15','14:25:00',2.28),('3355','2014-04-15','14:30:00',1.08),('3355','2014-04-15','14:35:00',1.43),('3355','2014-04-15','15:25:00',1.04),('3355','2013-10-08','11:10:00',1.56),('3355','2013-10-08','11:15:00',2.32),('3355','2013-10-08','11:20:00',1.97),('3355','2013-10-08','11:25:00',1.15),('3355','2013-10-08','11:30:00',1.69),('3355','2013-10-08','11:35:00',1.42),('3355','2013-10-08','12:30:00',1.71),('3355','2013-10-08','12:35:00',1.08),('3355','2013-10-08','12:40:00',2.27),('3355','2013-10-08','12:45:00',1.76),('3355','2013-10-08','12:50:00',2.33),('3355','2013-10-08','12:55:00',2.24),('3355','2013-10-08','13:00:00',1.95),('3355','2013-10-08','13:05:00',2.24),('3355','2013-10-08','13:10:00',1.39),('3355','2013-10-08','13:15:00',1.94),('3355','2013-10-08','13:20:00',1.01),('3355','2013-10-08','13:25:00',2.25),('3355','2013-10-08','13:30:00',1.3),('3355','2013-10-08','14:10:00',1.33),('3355','2013-10-08','14:15:00',1.44),('3355','2013-10-08','14:20:00',1.62),('3355','2013-10-08','14:25:00',1.62),('3355','2013-10-08','14:30:00',1.64),('3355','2013-10-08','14:45:00',1.83),('3355','2013-10-08','14:50:00',1.98),('3355','2013-10-08','14:55:00',1.87),('3355','2013-10-08','15:00:00',1.84),('3355','2013-10-08','15:05:00',1.9),('3355','2013-10-08','15:10:00',1.84),('3355','2013-10-08','15:15:00',1.76),('3355','2013-10-08','15:20:00',1.58),('3355','2013-10-08','15:25:00',1.16),('3355','2013-10-08','15:30:00',2.05),('3355','2013-10-08','15:35:00',1.84),('3355','2013-10-08','15:40:00',1.44),('3355','2013-10-08','15:45:00',1.01),('3355','2013-10-08','15:50:00',1.58),('3355','2013-10-08','16:05:00',1.12),('3355','2013-10-07','09:25:00',1.02),('3355','2013-10-07','09:30:00',1.06),('3355','2013-10-07','09:35:00',1.11),('3355','2013-10-07','09:40:00',1.15),('3355','2013-10-07','09:45:00',1.19),('3355','2013-10-07','09:50:00',1.23),('3355','2013-10-07','09:55:00',1.28),('3355','2013-10-07','10:00:00',1.32),('3355','2013-10-07','10:05:00',1.36),('3355','2013-10-07','10:10:00',1.39),('3355','2013-10-07','10:15:00',1.43),('3355','2013-10-07','10:20:00',1.46),('3355','2013-10-07','10:25:00',1.52),('3355','2013-10-07','10:30:00',1.56),('3355','2013-10-07','10:35:00',1.62),('3355','2013-10-07','10:40:00',1.62),('3355','2013-10-07','10:45:00',1.6),('3355','2013-10-07','10:50:00',1.61),('3355','2013-10-07','10:55:00',1.69),('3355','2013-10-07','11:00:00',1.29),('3355','2013-10-07','11:05:00',1.76),('3355','2013-10-07','11:10:00',1.43),('3355','2013-10-07','11:15:00',1.75),('3355','2013-10-07','11:20:00',1.81),('3355','2013-10-07','11:25:00',1.84),('3355','2013-10-07','11:30:00',1.85),('3355','2013-10-07','11:35:00',1.87),('3355','2013-10-07','11:40:00',1.89),('3355','2013-10-07','11:45:00',1.9),('3355','2013-10-07','11:50:00',1.92),('3355','2013-10-07','11:55:00',1.95),('3355','2013-10-07','12:00:00',1.95),('3355','2013-10-07','12:05:00',2.03),('3355','2013-10-07','12:10:00',2.09),('3355','2013-10-07','12:15:00',2.22),('3355','2013-10-07','12:20:00',1.17),('3355','2013-10-07','12:25:00',2.28),('3355','2013-10-07','12:30:00',2.16),('3355','2013-10-07','12:35:00',1.9),('3355','2013-10-07','12:40:00',2.15),('3355','2013-10-07','12:45:00',2.14),('3355','2013-10-07','12:50:00',2.12),('3355','2013-10-07','12:55:00',2.16),('3355','2013-10-07','13:00:00',2.17),('3355','2013-10-07','13:05:00',2.12),('3355','2013-10-07','13:10:00',2.14),('3355','2013-10-07','13:15:00',2.13),('3355','2013-10-07','13:20:00',2.05),('3355','2013-10-07','13:25:00',1.3),('3355','2013-10-07','13:30:00',1.63),('3355','2013-10-07','13:35:00',2.04),('3355','2013-10-07','13:50:00',1.21),('3355','2013-10-07','13:55:00',2.53),('3355','2013-10-07','14:00:00',2.41),('3355','2013-10-07','14:10:00',1.08),('3355','2013-10-07','14:25:00',2.05),('3355','2013-10-07','14:30:00',1.01),('3355','2013-10-07','14:40:00',1.37),('3355','2013-10-07','14:45:00',2.15),('3355','2013-10-07','14:50:00',2.14),('3355','2013-10-07','14:55:00',2.09),('3355','2013-10-07','15:00:00',1.18),('3355','2013-10-07','15:10:00',1.8),('3355','2013-10-07','15:30:00',1.77),('3355','2013-10-07','15:35:00',1.96),('3355','2013-10-07','15:50:00',1.21),('3355','2013-10-07','15:55:00',1.47),('3355','2013-10-07','16:10:00',1.08),('3355','2013-10-07','16:15:00',1.45),('3355','2013-10-07','16:20:00',1.41),('3355','2013-10-07','16:25:00',1.33),('3355','2013-10-07','16:30:00',1.29),('3355','2013-10-07','16:35:00',1.24),('3355','2013-10-07','16:40:00',1.21),('3355','2013-10-07','16:45:00',1.17),('3355','2013-10-07','16:50:00',1.09),('3355','2013-10-07','16:55:00',1),('3355','2013-10-06','09:50:00',1.11),('3355','2013-10-06','09:55:00',1.33),('3355','2013-10-06','10:00:00',1.57),('3355','2013-10-06','10:05:00',1.61),('3355','2013-10-06','10:10:00',1.59),('3355','2013-10-06','10:15:00',1.46),('3355','2013-10-06','10:20:00',1.46),('3355','2013-10-06','10:25:00',1.64),('3355','2013-10-06','10:30:00',1.61),('3355','2013-10-06','10:35:00',1.61),('3355','2013-10-06','10:40:00',1.39),('3355','2013-10-06','10:45:00',1.15),('3355','2013-10-06','10:50:00',1.22),('3355','2013-10-06','10:55:00',1.4),('3355','2013-10-06','11:00:00',1.44),('3355','2013-10-06','11:05:00',1.54),('3355','2013-10-06','11:10:00',1.59),('3355','2013-10-06','11:15:00',1.45),('3355','2013-10-06','11:20:00',1.49),('3355','2013-10-06','11:25:00',1.67),('3355','2013-10-06','11:30:00',1.63),('3355','2013-10-06','11:35:00',1.6),('3355','2013-10-06','11:40:00',1.6),('3355','2013-10-06','11:45:00',1.17),('3355','2013-10-06','11:50:00',1.25),('3355','2013-10-06','11:55:00',1.44),('3355','2013-10-06','12:00:00',1.48),('3355','2013-10-06','12:05:00',1.5),('3355','2013-10-06','12:10:00',1.9),('3355','2013-10-06','12:15:00',1.84),('3355','2013-10-06','12:20:00',1.48),('3355','2013-10-06','12:25:00',1.48),('3355','2013-10-06','12:30:00',1.52),('3355','2013-10-06','12:35:00',1.57),('3355','2013-10-06','12:40:00',1.38),('3355','2013-10-06','12:45:00',1.43),('3355','2013-10-06','12:50:00',1.63),('3355','2013-10-06','12:55:00',1.88),('3355','2013-10-06','13:00:00',1.92),('3355','2013-10-06','13:05:00',1.87),('3355','2013-10-06','13:10:00',1.54),('3355','2013-10-06','13:15:00',1.19),('3355','2013-10-06','13:20:00',1.94),('3355','2013-10-06','13:50:00',2.12),('3355','2013-10-06','13:55:00',1.29),('3355','2013-10-06','14:05:00',1.04),('3355','2013-10-06','14:10:00',1.22),('3355','2013-10-06','14:15:00',1.18),('3355','2013-10-06','14:35:00',1.05),('3355','2013-10-06','14:40:00',1.02),('3355','2013-10-06','14:50:00',1.1),('3355','2013-10-06','14:55:00',1.38),('3355','2013-10-06','15:00:00',1.07),('3355','2013-10-04','09:55:00',1.43),('3355','2013-10-04','10:00:00',1.11),('3355','2013-10-04','10:25:00',1.12),('3355','2013-10-04','10:30:00',1.06),('3355','2013-10-04','10:40:00',1.43),('3355','2013-10-04','10:45:00',1.14),('3355','2013-10-04','10:55:00',1.54),('3355','2013-10-04','11:00:00',1.28),('3355','2013-10-04','11:15:00',1.78),('3355','2013-10-04','11:20:00',1.58),('3355','2013-10-04','11:25:00',1.63),('3355','2013-10-04','11:30:00',2.1),('3355','2013-10-04','11:35:00',2),('3355','2013-10-04','11:40:00',2.05),('3355','2013-10-04','11:45:00',2.02),('3355','2013-10-04','11:50:00',2),('3355','2013-10-04','11:55:00',1.99),('3355','2013-10-04','12:00:00',2),('3355','2013-10-04','12:05:00',2.02),('3355','2013-10-04','12:10:00',2.04),('3355','2013-10-04','12:15:00',1.97),('3355','2013-10-04','12:20:00',1.9),('3355','2013-10-04','12:25:00',2.07),('3355','2013-10-04','12:30:00',2.04),('3355','2013-10-04','12:35:00',1.79),('3355','2013-10-04','12:40:00',2.05),('3355','2013-10-04','12:45:00',2.06),('3355','2013-10-04','12:50:00',1.97),('3355','2013-10-04','12:55:00',2),('3355','2013-10-04','13:00:00',2.02),('3355','2013-10-04','13:05:00',2.05),('3355','2013-10-04','13:10:00',2.05),('3355','2013-10-04','13:15:00',2.18),('3355','2013-10-04','13:20:00',2.12),('3355','2013-10-04','13:25:00',1.99),('3355','2013-10-04','13:30:00',2.11),('3355','2013-10-04','13:35:00',1.73),('3355','2013-10-04','13:40:00',2.05),('3355','2013-10-04','13:45:00',1.99),('3355','2013-10-04','13:50:00',1.98),('3355','2013-10-04','13:55:00',1.98),('3355','2013-10-04','14:00:00',1.98),('3355','2013-10-04','14:05:00',1.97),('3355','2013-10-04','14:10:00',1.81),('3355','2013-10-04','14:15:00',1.65),('3355','2013-10-04','14:20:00',1.74),('3355','2013-10-04','14:25:00',1.91),('3355','2013-10-04','14:30:00',1.69),('3355','2013-10-04','14:35:00',1.22),('3355','2013-10-04','14:45:00',1.06),('3355','2013-10-04','14:50:00',1.43),('3355','2013-10-04','14:55:00',1.5),('3355','2013-10-04','15:00:00',1.28),('3355','2013-10-04','15:05:00',1.47),('3355','2013-10-04','15:10:00',1.27),('3355','2013-10-04','15:25:00',1.22),('3355','2013-10-04','15:30:00',1.63),('3355','2013-10-03','09:20:00',1.05),('3355','2013-10-03','09:25:00',1.1),('3355','2013-10-03','09:30:00',1.15),('3355','2013-10-03','09:35:00',1.2),('3355','2013-10-03','09:40:00',1.25),('3355','2013-10-03','09:45:00',1.3),('3355','2013-10-03','09:50:00',1.35),('3355','2013-10-03','09:55:00',1.39),('3355','2013-10-03','10:00:00',1.44),('3355','2013-10-03','10:05:00',1.49),('3355','2013-10-03','10:10:00',1.52),('3355','2013-10-03','10:15:00',1.57),('3355','2013-10-03','10:20:00',1.61),('3355','2013-10-03','10:25:00',1.64),('3355','2013-10-03','10:30:00',1.68),('3355','2013-10-03','10:35:00',1.71),('3355','2013-10-03','10:40:00',1.75),('3355','2013-10-03','10:45:00',1.79),('3355','2013-10-03','10:50:00',1.81),('3355','2013-10-03','10:55:00',1.84),('3355','2013-10-03','11:00:00',1.86),('3355','2013-10-03','11:05:00',1.89),('3355','2013-10-03','11:10:00',1.92),('3355','2013-10-03','11:15:00',1.95),('3355','2013-10-03','11:20:00',1.97),('3355','2013-10-03','11:25:00',1.99),('3355','2013-10-03','11:30:00',2),('3355','2013-10-03','11:35:00',2.04),('3355','2013-10-03','11:40:00',2.06),('3355','2013-10-03','11:45:00',2.07),('3355','2013-10-03','11:50:00',2.09),('3355','2013-10-03','11:55:00',2.11),('3355','2013-10-03','12:00:00',2.12),('3355','2013-10-03','12:05:00',2.14),('3355','2013-10-03','12:10:00',2.15),('3355','2013-10-03','12:15:00',2.14),('3355','2013-10-03','12:20:00',2.15),('3355','2013-10-03','12:25:00',2.16),('3355','2013-10-03','12:30:00',2.17),('3355','2013-10-03','12:35:00',2.17),('3355','2013-10-03','12:40:00',2.17),('3355','2013-10-03','12:45:00',2.17),('3355','2013-10-03','12:50:00',2.17),('3355','2013-10-03','12:55:00',2.18),('3355','2013-10-03','13:00:00',2.15),('3355','2013-10-03','13:05:00',2.13),('3355','2013-10-03','13:10:00',2.18),('3355','2013-10-03','13:15:00',2.17),('3355','2013-10-03','13:20:00',2.17),('3355','2013-10-03','13:25:00',2.17),('3355','2013-10-03','13:30:00',2.17),('3355','2013-10-03','13:35:00',2.17),('3355','2013-10-03','13:40:00',2.16),('3355','2013-10-03','13:45:00',2.13),('3355','2013-10-03','13:50:00',2.13),('3355','2013-10-03','13:55:00',2.14),('3355','2013-10-03','14:00:00',2.14),('3355','2013-10-03','14:05:00',2.13),('3355','2013-10-03','14:10:00',2.11),('3355','2013-10-03','14:15:00',2.09),('3355','2013-10-03','14:20:00',2.08),('3355','2013-10-03','14:25:00',2.07),('3355','2013-10-03','14:30:00',2.05),('3355','2013-10-03','14:35:00',2.04),('3355','2013-10-03','14:40:00',2.01),('3355','2013-10-03','14:45:00',1.99),('3355','2013-10-03','14:50:00',1.98),('3355','2013-10-03','14:55:00',1.95),('3355','2013-10-03','15:00:00',1.93),('3355','2013-10-03','15:05:00',1.89),('3355','2013-10-03','15:10:00',1.86),('3355','2013-10-03','15:15:00',1.84),('3355','2013-10-03','15:20:00',1.81),('3355','2013-10-03','15:25:00',1.77),('3355','2013-10-03','15:30:00',1.75),('3355','2013-10-03','15:35:00',1.72),('3355','2013-10-03','15:40:00',1.67),('3355','2013-10-03','15:45:00',1.64),('3355','2013-10-03','15:50:00',1.61),('3355','2013-10-03','15:55:00',1.57),('3355','2013-10-03','16:00:00',1.53),('3355','2013-10-03','16:05:00',1.49),('3355','2013-10-03','16:10:00',1.45),('3355','2013-10-03','16:15:00',1.4),('3355','2013-10-03','16:20:00',1.36),('3355','2013-10-03','16:25:00',1.31),('3355','2013-10-03','16:30:00',1.27),('3355','2013-10-03','16:35:00',1.23),('3355','2013-10-03','16:40:00',1.17),('3355','2013-10-03','16:45:00',1.13),('3355','2013-10-03','16:50:00',1.07),('3355','2013-10-03','16:55:00',1.02),('3355','2013-10-02','09:25:00',1.04),('3355','2013-10-02','09:30:00',1.09),('3355','2013-10-02','09:35:00',1.14),('3355','2013-10-02','09:40:00',1.18),('3355','2013-10-02','09:45:00',1.23),('3355','2013-10-02','09:50:00',1.27),('3355','2013-10-02','09:55:00',1.31),('3355','2013-10-02','10:00:00',1.35),('3355','2013-10-02','10:05:00',1.38),('3355','2013-10-02','10:10:00',1.42),('3355','2013-10-02','10:15:00',1.46),('3355','2013-10-02','10:20:00',1.5),('3355','2013-10-02','10:25:00',1.54),('3355','2013-10-02','10:30:00',1.58),('3355','2013-10-02','10:35:00',1.61),('3355','2013-10-02','10:40:00',1.66),('3355','2013-10-02','10:45:00',1.7),('3355','2013-10-02','10:50:00',1.73),('3355','2013-10-02','10:55:00',1.76),('3355','2013-10-02','11:00:00',1.79),('3355','2013-10-02','11:05:00',1.82),('3355','2013-10-02','11:10:00',1.84),('3355','2013-10-02','11:15:00',1.87),('3355','2013-10-02','11:20:00',1.89),('3355','2013-10-02','11:25:00',1.91),('3355','2013-10-02','11:30:00',1.93),('3355','2013-10-02','11:35:00',1.95),('3355','2013-10-02','11:40:00',1.97),('3355','2013-10-02','11:45:00',1.98),('3355','2013-10-02','11:50:00',2),('3355','2013-10-02','11:55:00',2.01),('3355','2013-10-02','12:00:00',2.02),('3355','2013-10-02','12:05:00',2.03),('3355','2013-10-02','12:10:00',2.05),('3355','2013-10-02','12:15:00',2.07),('3355','2013-10-02','12:20:00',2.07),('3355','2013-10-02','12:25:00',2.07),('3355','2013-10-02','12:30:00',2.08),('3355','2013-10-02','12:35:00',2.09),('3355','2013-10-02','12:40:00',2.09),('3355','2013-10-02','12:45:00',2.1),('3355','2013-10-02','12:50:00',2.12),('3355','2013-10-02','12:55:00',2.12),('3355','2013-10-02','13:00:00',2.12),('3355','2013-10-02','13:05:00',2.13),('3355','2013-10-02','13:10:00',2.12),('3355','2013-10-02','13:15:00',2.12),('3355','2013-10-02','13:20:00',2.13),('3355','2013-10-02','13:25:00',2.13),('3355','2013-10-02','13:30:00',2.12),('3355','2013-10-02','13:35:00',2.11),('3355','2013-10-02','13:40:00',2.09),('3355','2013-10-02','13:45:00',2.08),('3355','2013-10-02','13:50:00',2.08),('3355','2013-10-02','13:55:00',2.08),('3355','2013-10-02','14:00:00',2.08),('3355','2013-10-02','14:05:00',2.07),('3355','2013-10-02','14:10:00',2.05),('3355','2013-10-02','14:15:00',2.03),('3355','2013-10-02','14:20:00',2.01),('3355','2013-10-02','14:25:00',2),('3355','2013-10-02','14:30:00',1.99),('3355','2013-10-02','14:35:00',1.97),('3355','2013-10-02','14:40:00',1.94),('3355','2013-10-02','14:45:00',1.93),('3355','2013-10-02','14:50:00',1.92),('3355','2013-10-02','14:55:00',1.9),('3355','2013-10-02','15:00:00',1.87),('3355','2013-10-02','15:05:00',1.84),('3355','2013-10-02','15:10:00',1.82),('3355','2013-10-02','15:15:00',1.79),('3355','2013-10-02','15:20:00',1.76),('3355','2013-10-02','15:25:00',1.72),('3355','2013-10-02','15:30:00',1.69),('3355','2013-10-02','15:35:00',1.67),('3355','2013-10-02','15:40:00',1.64),('3355','2013-10-02','15:45:00',1.61),('3355','2013-10-02','15:50:00',1.57),('3355','2013-10-02','15:55:00',1.52),('3355','2013-10-02','16:00:00',1.49),('3355','2013-10-02','16:05:00',1.45),('3355','2013-10-02','16:10:00',1.4),('3355','2013-10-02','16:15:00',1.36),('3355','2013-10-02','16:20:00',1.32),('3355','2013-10-02','16:25:00',1.28),('3355','2013-10-02','16:30:00',1.24),('3355','2013-10-02','16:35:00',1.2),('3355','2013-10-02','16:40:00',1.15),('3355','2013-10-02','16:45:00',1.09),('3355','2013-10-02','16:50:00',1.04),('3355','2013-10-01','09:25:00',1.04),('3355','2013-10-01','09:30:00',1.09),('3355','2013-10-01','09:35:00',1.12),('3355','2013-10-01','09:40:00',1.16),('3355','2013-10-01','09:45:00',1.21),('3355','2013-10-01','09:50:00',1.25),('3355','2013-10-01','09:55:00',1.29),('3355','2013-10-01','10:00:00',1.32),('3355','2013-10-01','10:05:00',1.37),('3355','2013-10-01','10:10:00',1.41),('3355','2013-10-01','10:15:00',1.45),('3355','2013-10-01','10:20:00',1.49),('3355','2013-10-01','10:25:00',1.52),('3355','2013-10-01','10:30:00',1.58),('3355','2013-10-01','10:35:00',1.6),('3355','2013-10-01','10:40:00',1.63),('3355','2013-10-01','10:45:00',1.66),('3355','2013-10-01','10:50:00',1.69),('3355','2013-10-01','10:55:00',1.72),('3355','2013-10-01','11:00:00',1.73),('3355','2013-10-01','11:05:00',1.82),('3355','2013-10-01','11:10:00',1.96),('3355','2013-10-01','11:15:00',1.56),('3355','2013-10-01','11:30:00',2.05),('3355','2013-10-01','11:35:00',1.62),('3355','2013-10-01','11:40:00',1.72),('3355','2013-10-01','11:45:00',2.07),('3355','2013-10-01','11:50:00',2.07),('3355','2013-10-01','11:55:00',2.09),('3355','2013-10-01','12:00:00',2.04),('3355','2013-10-01','12:05:00',2.03),('3355','2013-10-01','12:10:00',1.95),('3355','2013-10-01','12:15:00',2.04),('3355','2013-10-01','12:20:00',2.1),('3355','2013-10-01','12:25:00',2.17),('3355','2013-10-01','12:30:00',2.2),('3355','2013-10-01','12:35:00',2.22),('3355','2013-10-01','12:40:00',1.14),('3355','2013-10-01','12:45:00',1.69),('3355','2013-10-01','12:50:00',2.17),('3355','2013-10-01','12:55:00',2.16),('3355','2013-10-01','13:00:00',2.15),('3355','2013-10-01','13:05:00',2.16),('3355','2013-10-01','13:20:00',1.61),('3355','2013-10-01','13:25:00',2.31),('3355','2013-10-01','13:30:00',2.35),('3355','2013-10-01','13:35:00',2.13),('3355','2013-10-01','13:40:00',2.13),('3355','2013-10-01','13:45:00',1.29),('3355','2013-10-01','13:50:00',1.34),('3355','2013-10-01','13:55:00',1.67),('3355','2013-10-01','14:00:00',2.11),('3355','2013-10-01','14:05:00',2.06),('3355','2013-10-01','14:10:00',2.03),('3355','2013-10-01','14:15:00',2),('3355','2013-10-01','14:20:00',1.98),('3355','2013-10-01','14:25:00',1.96),('3355','2013-10-01','14:30:00',1.96),('3355','2013-10-01','14:35:00',1.92),('3355','2013-10-01','14:40:00',1.94),('3355','2013-10-01','14:45:00',1.92),('3355','2013-10-01','14:50:00',1.94),('3355','2013-10-01','14:55:00',1.91),('3355','2013-10-01','15:00:00',1.88),('3355','2013-10-01','15:05:00',1.83),('3355','2013-10-01','15:10:00',1.8),('3355','2013-10-01','15:15:00',1.77),('3355','2013-10-01','15:20:00',1.76),('3355','2013-10-01','15:25:00',1.73),('3355','2013-10-01','15:30:00',1.71),('3355','2013-10-01','15:35:00',1.67),('3355','2013-10-01','15:40:00',1.64),('3355','2013-10-01','15:45:00',1.6),('3355','2013-10-01','15:50:00',1.57),('3355','2013-10-01','15:55:00',1.54),('3355','2013-10-01','16:00:00',1.48),('3355','2013-10-01','16:05:00',1.46),('3355','2013-10-01','16:10:00',1.41),('3355','2013-10-01','16:15:00',1.37),('3355','2013-10-01','16:20:00',1.33),('3355','2013-10-01','16:25:00',1.28),('3355','2013-10-01','16:30:00',1.24),('3355','2013-10-01','16:35:00',1.19),('3355','2013-10-01','16:40:00',1.15),('3355','2013-10-01','16:45:00',1.09),('3355','2013-10-01','16:50:00',1.04),('3355','2013-10-01','16:55:00',1.01),('3355','2013-09-30','10:40:00',1.14),('3355','2013-09-30','10:45:00',1.74),('3355','2013-09-30','10:50:00',1.83),('3355','2013-09-30','10:55:00',1.68),('3355','2013-09-30','11:00:00',1.11),('3355','2013-09-30','11:05:00',1.62),('3355','2013-09-30','11:10:00',1.18),('3355','2013-09-30','11:15:00',1.67),('3355','2013-09-30','11:20:00',1.4),('3355','2013-09-30','11:25:00',1.52),('3355','2013-09-30','11:40:00',1.39),('3355','2013-09-30','11:45:00',1.17),('3355','2013-09-30','12:15:00',2.12),('3355','2013-09-30','12:20:00',2.23),('3355','2013-09-30','12:25:00',2.22),('3355','2013-09-30','12:30:00',2.16),('3355','2013-09-30','12:35:00',2.16),('3355','2013-09-30','12:40:00',2.25),('3355','2013-09-30','12:45:00',1.72),('3355','2013-09-30','12:50:00',2.27),('3355','2013-09-30','12:55:00',2.2),('3355','2013-09-30','13:00:00',2.22),('3355','2013-09-30','13:05:00',2.24),('3355','2013-09-30','13:10:00',2.29),('3355','2013-09-30','13:15:00',2.24),('3355','2013-09-30','13:20:00',2.32),('3355','2013-09-30','13:25:00',2.44),('3355','2013-09-30','13:30:00',2.45),('3355','2013-09-30','13:35:00',2.04),('3355','2013-09-30','13:40:00',2.11),('3355','2013-09-30','13:45:00',2.05),('3355','2013-09-30','13:50:00',1.54),('3355','2013-09-30','13:55:00',1.17),('3355','2013-09-30','14:00:00',1.11),('3355','2013-09-30','14:30:00',1.35),('3355','2013-09-30','14:35:00',1.57),('3355','2013-09-30','14:40:00',2.17),('3355','2013-09-30','14:45:00',2.07),('3355','2013-09-30','14:50:00',1.68),('3355','2013-09-30','14:55:00',1.66),('3355','2013-09-30','15:05:00',1),('3355','2013-09-30','15:10:00',2.22),('3355','2013-09-30','15:15:00',1.59),('3355','2013-09-30','15:25:00',1.39),('3355','2013-09-30','15:30:00',1.54),('3355','2013-09-30','15:35:00',1.36),('3355','2013-09-30','15:40:00',1.95),('3355','2013-09-30','15:45:00',1.46),('3355','2013-09-30','16:20:00',1.3),('3355','2013-09-30','16:40:00',1.05),('3355','2013-09-30','16:45:00',1.11),('3355','2013-09-29','10:10:00',1.03),('3355','2013-09-29','10:15:00',1.32),('3355','2013-09-29','10:20:00',1.2),('3355','2013-09-29','10:25:00',1.07),('3355','2013-09-29','10:30:00',1.21),('3355','2013-09-29','10:35:00',1.34),('3355','2013-09-29','10:40:00',1.43),('3355','2013-09-29','10:45:00',1.49),('3355','2013-09-29','10:50:00',1.55),('3355','2013-09-29','10:55:00',1.53),('3355','2013-09-29','11:00:00',1.55),('3355','2013-09-29','11:05:00',1.52),('3355','2013-09-29','11:10:00',1.51),('3355','2013-09-29','11:15:00',1.63),('3355','2013-09-29','11:20:00',1.64),('3355','2013-09-29','11:25:00',1.51),('3355','2013-09-29','11:30:00',1.65),('3355','2013-09-29','11:35:00',1.64),('3355','2013-09-29','11:40:00',1.7),('3355','2013-09-29','11:45:00',1.74),('3355','2013-09-29','11:50:00',1.85),('3355','2013-09-29','11:55:00',1.83),('3355','2013-09-29','12:00:00',1.79),('3355','2013-09-29','12:05:00',1.86),('3355','2013-09-29','12:10:00',1.77),('3355','2013-09-29','12:15:00',1.98),('3355','2013-09-29','12:20:00',1.7),('3355','2013-09-29','12:25:00',1.01),('3355','2013-09-29','12:30:00',1.07),('3355','2013-09-29','12:35:00',1.08),('3355','2013-09-29','13:30:00',1.3),('3355','2013-09-29','13:55:00',1.23),('3355','2013-09-29','14:00:00',1.22),('3355','2013-09-29','14:05:00',1.56),('3355','2013-09-29','14:20:00',1.15),('3355','2014-04-14','09:00:00',1.03),('3355','2014-04-14','09:05:00',1.09),('3355','2014-04-14','09:10:00',1.14),('3355','2014-04-14','09:15:00',1.19),('3355','2014-04-14','09:20:00',1.23),('3355','2014-04-14','09:25:00',1.28),('3355','2014-04-14','09:30:00',1.33),('3355','2014-04-14','09:35:00',1.37),('3355','2014-04-14','09:40:00',1.42),('3355','2014-04-14','09:45:00',1.45),('3355','2014-04-14','09:50:00',1.5),('3355','2014-04-14','09:55:00',1.54),('3355','2014-04-14','10:00:00',1.58),('3355','2014-04-14','10:05:00',1.63),('3355','2014-04-14','10:10:00',1.68),('3355','2014-04-14','10:15:00',1.72),('3355','2014-04-14','10:20:00',1.75),('3355','2014-04-14','10:25:00',1.78),('3355','2014-04-14','10:30:00',1.82),('3355','2014-04-14','10:35:00',1.85),('3355','2014-04-14','10:40:00',1.88),('3355','2014-04-14','10:45:00',1.91),('3355','2014-04-14','10:50:00',1.94),('3355','2014-04-14','10:55:00',1.97),('3355','2014-04-14','11:00:00',1.99),('3355','2014-04-14','11:05:00',2.03),('3355','2014-04-14','11:10:00',2.04),('3355','2014-04-14','11:15:00',2.07),('3355','2014-04-14','11:20:00',2.09),('3355','2014-04-14','11:25:00',2.1),('3355','2014-04-14','11:30:00',2.12),('3355','2014-04-14','11:35:00',2.16),('3355','2014-04-14','11:40:00',2.18),('3355','2014-04-14','11:45:00',2.18),('3355','2014-04-14','11:50:00',2.2),('3355','2014-04-14','11:55:00',2.22),('3355','2014-04-14','12:00:00',2.23),('3355','2014-04-14','12:05:00',2.24),('3355','2014-04-14','12:10:00',2.25),('3355','2014-04-14','12:15:00',2.27),('3355','2014-04-14','12:20:00',2.29),('3355','2014-04-14','12:25:00',2.29),('3355','2014-04-14','12:30:00',2.3),('3355','2014-04-14','12:35:00',2.31),('3355','2014-04-14','12:40:00',2.32),('3355','2014-04-14','12:45:00',2.34),('3355','2014-04-14','12:50:00',2.34),('3355','2014-04-14','12:55:00',2.35),('3355','2014-04-14','13:00:00',2.36),('3355','2014-04-14','13:05:00',2.36),('3355','2014-04-14','13:10:00',2.37),('3355','2014-04-14','13:15:00',2.34),('3355','2014-04-14','13:20:00',2.37),('3355','2014-04-14','13:25:00',2.36),('3355','2014-04-14','13:30:00',2.37),('3355','2014-04-14','13:35:00',2.37),('3355','2014-04-14','13:40:00',2.38),('3355','2014-04-14','13:45:00',2.37),('3355','2014-04-14','13:50:00',2.36),('3355','2014-04-14','13:55:00',2.36),('3355','2014-04-14','14:00:00',2.35),('3355','2014-04-14','14:05:00',2.34),('3355','2014-04-14','14:10:00',2.34),('3355','2014-04-14','14:15:00',2.34),('3355','2014-04-14','14:20:00',2.35),('3355','2014-04-14','14:25:00',2.34),('3355','2014-04-14','14:30:00',2.33),('3355','2014-04-14','14:35:00',2.3),('3355','2014-04-14','14:40:00',2.29),('3355','2014-04-14','14:45:00',2.28),('3355','2014-04-14','14:50:00',2.27),('3355','2014-04-14','14:55:00',2.26),('3355','2014-04-14','15:00:00',2.23),('3355','2014-04-14','15:05:00',2.22),('3355','2014-04-14','15:10:00',2.2),('3355','2014-04-14','15:15:00',2.17),('3355','2014-04-14','15:20:00',2.15),('3355','2014-04-14','15:25:00',2.13),('3355','2014-04-14','15:30:00',2.11),('3355','2014-04-14','15:35:00',2.08),('3355','2014-04-14','15:40:00',2.06),('3355','2014-04-14','15:45:00',2.03),('3355','2014-04-14','15:50:00',2),('3355','2014-04-14','15:55:00',1.96),('3355','2014-04-14','16:00:00',1.94),('3355','2014-04-14','16:05:00',1.9),('3355','2014-04-14','16:10:00',1.86),('3355','2014-04-14','16:15:00',1.82),('3355','2014-04-14','16:20:00',1.79),('3355','2014-04-14','16:25:00',1.75),('3355','2014-04-14','16:30:00',1.71),('3355','2014-04-14','16:35:00',1.67),('3355','2014-04-14','16:40:00',1.63),('3355','2014-04-14','16:45:00',1.59),('3355','2014-04-14','16:50:00',1.54),('3355','2014-04-14','16:55:00',1.5),('3355','2014-04-14','17:00:00',1.45),('3355','2014-04-14','17:05:00',1.39),('3355','2014-04-14','17:10:00',1.35),('3355','2014-04-14','17:15:00',1.3),('3355','2014-04-14','17:20:00',1.25),('3355','2014-04-14','17:25:00',1.21),('3355','2014-04-14','17:30:00',1.14),('3355','2014-04-14','17:35:00',1.08),('3355','2014-04-14','17:40:00',1.02),('3355','2013-09-28','09:25:00',1.01),('3355','2013-09-28','09:30:00',1.05),('3355','2013-09-28','09:40:00',1.14),('3355','2013-09-28','09:45:00',1.15),('3355','2013-09-28','09:50:00',1),('3355','2013-09-28','09:55:00',1.08),('3355','2013-09-28','10:00:00',1.42),('3355','2013-09-28','10:05:00',1.2),('3355','2013-09-28','10:10:00',1.06),('3355','2013-09-28','10:35:00',1.16),('3355','2013-09-28','10:40:00',1.63),('3355','2013-09-28','10:45:00',1.23),('3355','2013-09-28','10:50:00',1.29),('3355','2013-09-28','11:00:00',1.99),('3355','2013-09-28','11:05:00',1.44),('3355','2013-09-28','11:10:00',1.08),('3355','2013-09-28','11:15:00',1.91),('3355','2013-09-28','11:25:00',1.77),('3355','2013-09-28','11:30:00',1.97),('3355','2013-09-28','11:35:00',2.03),('3355','2013-09-28','11:40:00',2),('3355','2013-09-28','12:00:00',1.55),('3355','2013-09-28','12:05:00',2.15),('3355','2013-09-28','12:10:00',1.75),('3355','2013-09-28','12:15:00',1.16),('3355','2013-09-28','12:20:00',1.63),('3355','2013-09-28','12:25:00',1.3),('3355','2013-09-28','12:35:00',1.32),('3355','2013-09-28','12:50:00',1.95),('3355','2013-09-28','12:55:00',2.36),('3355','2013-09-28','13:00:00',2.29),('3355','2013-09-28','13:05:00',2.16),('3355','2013-09-28','13:10:00',1.14),('3355','2013-09-28','13:25:00',1.56),('3355','2013-09-28','13:30:00',2.08),('3355','2013-09-28','13:35:00',1.09),('3355','2013-09-28','13:40:00',1.04),('3355','2013-09-28','13:45:00',1.07),('3355','2013-09-28','13:50:00',1.21),('3355','2013-09-28','14:00:00',1.17),('3355','2013-09-28','14:05:00',1.27),('3355','2013-09-28','14:20:00',1.7),('3355','2013-09-28','14:25:00',2.24),('3355','2013-09-28','14:30:00',1.94),('3355','2013-09-28','14:35:00',1.92),('3355','2013-09-28','14:40:00',2.15),('3355','2013-09-28','14:45:00',2.13),('3355','2013-09-28','14:50:00',2),('3355','2013-09-28','14:55:00',1.88),('3355','2013-09-28','15:00:00',1.98),('3355','2013-09-28','15:05:00',2.04),('3355','2013-09-28','15:10:00',1.92),('3355','2013-09-28','15:15:00',1.86),('3355','2013-09-28','15:20:00',1.93),('3355','2013-09-28','15:25:00',1.9),('3355','2013-09-28','15:30:00',1.85),('3355','2013-09-28','15:35:00',1.71),('3355','2013-09-28','15:40:00',1.72),('3355','2013-09-28','15:45:00',1.54),('3355','2013-09-28','15:55:00',1.11),('3355','2013-09-28','16:00:00',1.53),('3355','2013-09-28','16:05:00',1.45),('3355','2013-09-28','16:10:00',1.55),('3355','2013-09-28','16:15:00',1.51),('3355','2013-09-28','16:20:00',1.39),('3355','2013-09-28','16:25:00',1.23),('3355','2013-09-28','16:30:00',1.15),('3355','2013-09-28','16:35:00',1.15),('3355','2013-09-28','16:40:00',1.12),('3355','2013-09-28','16:45:00',1.05),('3355','2013-09-28','16:50:00',1),('3355','2013-09-27','09:55:00',1.26),('3355','2013-09-27','10:05:00',1.19),('3355','2013-09-27','10:15:00',1.01),('3355','2013-09-27','10:20:00',1.38),('3355','2013-09-27','10:25:00',1.11),('3355','2013-09-27','10:55:00',1.24),('3355','2013-09-27','11:00:00',1.65),('3355','2013-09-27','11:05:00',1.45),('3355','2013-09-27','11:10:00',1.58),('3355','2013-09-27','11:20:00',1.04),('3355','2013-09-27','12:00:00',1.7),('3355','2013-09-27','12:05:00',1.53),('3355','2013-09-27','12:10:00',2),('3355','2013-09-27','12:15:00',1.65),('3355','2013-09-27','12:50:00',1.04),('3355','2013-09-27','12:55:00',2.06),('3355','2013-09-27','13:00:00',2.05),('3355','2013-09-27','13:05:00',2.02),('3355','2013-09-27','13:10:00',2.15),('3355','2013-09-27','13:15:00',1.91),('3355','2013-09-27','13:20:00',1.78),('3355','2013-09-27','13:25:00',1.48),('3355','2013-09-27','14:00:00',1.43),('3355','2013-09-27','14:10:00',1.4),('3355','2013-09-27','14:15:00',2),('3355','2013-09-27','14:20:00',1.4),('3355','2013-09-27','14:25:00',2),('3355','2013-09-27','14:30:00',1.88),('3355','2013-09-27','14:35:00',1.89),('3355','2013-09-27','14:40:00',1.92),('3355','2013-09-27','14:45:00',1.9),('3355','2013-09-27','14:50:00',1.88),('3355','2013-09-27','14:55:00',1.54),('3355','2013-09-27','15:00:00',1.87),('3355','2013-09-27','15:05:00',1.52),('3355','2013-09-27','15:10:00',1.14),('3355','2013-09-27','15:15:00',1.78),('3355','2013-09-27','15:20:00',1.59),('3355','2013-09-27','15:25:00',1.64),('3355','2013-09-27','15:30:00',1.69),('3355','2013-09-27','15:35:00',1.65),('3355','2013-09-27','15:40:00',1.63),('3355','2013-09-27','15:45:00',1.48),('3355','2013-09-27','15:50:00',1.62),('3355','2013-09-27','15:55:00',1.54),('3355','2013-09-27','16:00:00',1.38),('3355','2013-09-27','16:05:00',1.24),('3355','2013-09-27','16:15:00',1.26),('3355','2013-09-27','16:20:00',1.15),('3355','2013-09-27','16:25:00',1.27),('3355','2013-09-27','16:30:00',1.22),('3355','2013-09-27','16:35:00',1.15),('3355','2013-09-27','16:40:00',1.15),('3355','2013-09-27','16:45:00',1.12),('3355','2013-09-26','09:20:00',1.01),('3355','2013-09-26','09:25:00',1.05),('3355','2013-09-26','09:30:00',1.09),('3355','2013-09-26','09:35:00',1.13),('3355','2013-09-26','09:40:00',1.18),('3355','2013-09-26','09:45:00',1.23),('3355','2013-09-26','09:50:00',1.27),('3355','2013-09-26','09:55:00',1.29),('3355','2013-09-26','10:00:00',1.34),('3355','2013-09-26','10:05:00',1.39),('3355','2013-09-26','10:10:00',1.42),('3355','2013-09-26','10:15:00',1.43),('3355','2013-09-26','10:20:00',1.48),('3355','2013-09-26','10:25:00',1.47),('3355','2013-09-26','10:30:00',1.51),('3355','2013-09-26','10:35:00',1.54),('3355','2013-09-26','10:40:00',1.55),('3355','2013-09-26','10:45:00',1.66),('3355','2013-09-26','10:50:00',1.65),('3355','2013-09-26','10:55:00',1.68),('3355','2013-09-26','11:00:00',1.68),('3355','2013-09-26','11:05:00',1.68),('3355','2013-09-26','11:10:00',1.72),('3355','2013-09-26','11:15:00',1.59),('3355','2013-09-26','11:20:00',1.64),('3355','2013-09-26','11:25:00',1.81),('3355','2013-09-26','11:30:00',1.84),('3355','2013-09-26','11:35:00',1.89),('3355','2013-09-26','11:40:00',1.59),('3355','2013-09-26','11:45:00',1.85),('3355','2013-09-26','11:50:00',1.91),('3355','2013-09-26','11:55:00',1.52),('3355','2013-09-26','12:00:00',1.82),('3355','2013-09-26','12:05:00',1.58),('3355','2013-09-26','12:10:00',1.01),('3355','2013-09-26','12:55:00',1.12),('3355','2013-09-26','13:00:00',1.69),('3355','2013-09-26','13:05:00',1.55),('3355','2013-09-26','13:15:00',1.4),('3355','2013-09-26','13:20:00',1.98),('3355','2013-09-26','13:25:00',2.28),('3355','2013-09-26','13:30:00',1.07),('3355','2013-09-26','13:35:00',1.01),('3355','2013-09-26','13:55:00',1.19),('3355','2013-09-26','14:00:00',1.24),('3355','2013-09-26','14:05:00',1.55),('3355','2013-09-26','14:10:00',1.93),('3355','2013-09-26','14:15:00',2.07),('3355','2013-09-26','14:20:00',1.66),('3355','2013-09-26','14:35:00',1.49),('3355','2013-09-26','14:40:00',1),('3355','2013-09-26','14:45:00',1.41),('3355','2013-09-26','14:50:00',2.24),('3355','2013-09-26','14:55:00',2.01),('3355','2013-09-26','15:10:00',1.21),('3355','2013-09-26','15:20:00',1),('3355','2013-09-26','15:25:00',1.7),('3355','2013-09-26','15:40:00',1.17),('3355','2013-09-26','15:50:00',1.25),('3355','2013-09-26','15:55:00',1.62),('3355','2013-09-26','16:00:00',1.51),('3355','2013-09-26','16:05:00',1.45),('3355','2013-09-26','16:10:00',1.45),('3355','2013-09-26','16:15:00',1.38),('3355','2013-09-26','16:20:00',1.34),('3355','2013-09-26','16:25:00',1.28),('3355','2013-09-26','16:30:00',1.26),('3355','2013-09-26','16:35:00',1.2),('3355','2013-09-26','16:40:00',1.16),('3355','2013-09-26','16:45:00',1.1),('3355','2013-09-26','16:50:00',1.05),('3355','2013-09-26','16:55:00',1.01),('3355','2013-09-25','09:35:00',1.08),('3355','2013-09-25','09:40:00',1.1),('3355','2013-09-25','09:50:00',1.16),('3355','2013-09-25','09:55:00',1.17),('3355','2013-09-25','10:00:00',1.39),('3355','2013-09-25','10:50:00',1.42),('3355','2013-09-25','10:55:00',2.03),('3355','2013-09-25','11:00:00',1.92),('3355','2013-09-25','11:05:00',1.84),('3355','2013-09-25','11:10:00',1.61),('3355','2013-09-25','11:30:00',2.03),('3355','2013-09-25','11:35:00',2.01),('3355','2013-09-25','11:40:00',1.98),('3355','2013-09-25','11:45:00',1.96),('3355','2013-09-25','11:50:00',1.24),('3355','2013-09-25','12:20:00',1.31),('3355','2013-09-25','12:35:00',1.08),('3355','2013-09-25','12:40:00',1.74),('3355','2013-09-25','12:45:00',1.06),('3355','2013-09-25','13:40:00',2.2),('3355','2013-09-25','13:45:00',2.36),('3355','2013-09-25','13:50:00',2.44),('3355','2013-09-25','13:55:00',2.4),('3355','2013-09-25','14:30:00',1.72),('3355','2013-09-25','14:35:00',2.21),('3355','2013-09-25','14:40:00',2.34),('3355','2013-09-25','14:45:00',1.28),('3355','2013-09-25','14:50:00',1.6),('3355','2013-09-25','14:55:00',2.22),('3355','2013-09-25','15:00:00',1.96),('3355','2013-09-25','15:05:00',1.81),('3355','2013-09-25','15:10:00',1.98),('3355','2013-09-25','15:15:00',1.96),('3355','2013-09-25','15:20:00',1.9),('3355','2013-09-25','15:25:00',1.72),('3355','2013-09-25','15:30:00',1.85),('3355','2013-09-25','15:35:00',1.64),('3355','2013-09-25','15:40:00',1.88),('3355','2013-09-25','15:45:00',1.68),('3355','2013-09-25','15:50:00',1.68),('3355','2013-09-25','15:55:00',1.67),('3355','2013-09-25','16:00:00',1.62),('3355','2013-09-25','16:05:00',1.57),('3355','2013-09-25','16:10:00',1.53),('3355','2013-09-25','16:15:00',1.43),('3355','2013-09-25','16:20:00',1.44),('3355','2013-09-25','16:25:00',1.35),('3355','2013-09-25','16:30:00',1.35),('3355','2013-09-25','16:35:00',1.3),('3355','2013-09-25','16:40:00',1.26),('3355','2013-09-25','16:45:00',1.21),('3355','2013-09-25','16:50:00',1.16),('3355','2013-09-25','16:55:00',1.09),('3355','2013-09-25','17:00:00',1.05),('3355','2013-09-25','17:05:00',1),('3355','2013-09-24','09:15:00',1.01),('3355','2013-09-24','09:20:00',1.06),('3355','2013-09-24','09:25:00',1.11),('3355','2013-09-24','09:30:00',1.16),('3355','2013-09-24','09:35:00',1.2),('3355','2013-09-24','09:40:00',1.24),('3355','2013-09-24','09:45:00',1.28),('3355','2013-09-24','09:50:00',1.32),('3355','2013-09-24','09:55:00',1.36),('3355','2013-09-24','10:00:00',1.4),('3355','2013-09-24','10:05:00',1.43),('3355','2013-09-24','10:10:00',1.47),('3355','2013-09-24','10:15:00',1.52),('3355','2013-09-24','10:20:00',1.56),('3355','2013-09-24','10:25:00',1.59),('3355','2013-09-24','10:30:00',1.63),('3355','2013-09-24','10:35:00',1.66),('3355','2013-09-24','10:40:00',1.69),('3355','2013-09-24','10:45:00',1.71),('3355','2013-09-24','10:50:00',1.74),('3355','2013-09-24','10:55:00',1.77),('3355','2013-09-24','11:00:00',1.79),('3355','2013-09-24','11:05:00',1.81),('3355','2013-09-24','11:10:00',1.83),('3355','2013-09-24','11:15:00',1.85),('3355','2013-09-24','11:20:00',1.87),('3355','2013-09-24','11:25:00',1.9),('3355','2013-09-24','11:30:00',1.91),('3355','2013-09-24','11:35:00',1.92),('3355','2013-09-24','11:40:00',1.93),('3355','2013-09-24','11:45:00',1.95),('3355','2013-09-24','11:50:00',1.97),('3355','2013-09-24','11:55:00',1.99),('3355','2013-09-24','12:00:00',2.01),('3355','2013-09-24','12:05:00',2.01),('3355','2013-09-24','12:10:00',2.01),('3355','2013-09-24','12:15:00',2.03),('3355','2013-09-24','12:20:00',2.02),('3355','2013-09-24','12:25:00',2.02),('3355','2013-09-24','12:30:00',2.01),('3355','2013-09-24','12:35:00',2),('3355','2013-09-24','12:40:00',2.07),('3355','2013-09-24','12:45:00',2.07),('3355','2013-09-24','12:50:00',2.08),('3355','2013-09-24','12:55:00',2.09),('3355','2013-09-24','13:00:00',2.08),('3355','2013-09-24','13:05:00',2.09),('3355','2013-09-24','13:10:00',2.09),('3355','2013-09-24','13:15:00',2.09),('3355','2013-09-24','13:20:00',2.09),('3355','2013-09-24','13:25:00',2.08),('3355','2013-09-24','13:30:00',2.08),('3355','2013-09-24','13:35:00',2.07),('3355','2013-09-24','13:40:00',2.09),('3355','2013-09-24','13:45:00',2.09),('3355','2013-09-24','13:50:00',2.07),('3355','2013-09-24','13:55:00',2.07),('3355','2013-09-24','14:00:00',2.05),('3355','2013-09-24','14:05:00',2.04),('3355','2013-09-24','14:10:00',2.03),('3355','2013-09-24','14:15:00',2.02),('3355','2013-09-24','14:20:00',2.02),('3355','2013-09-24','14:25:00',2.01),('3355','2013-09-24','14:30:00',1.99),('3355','2013-09-24','14:35:00',1.96),('3355','2013-09-24','14:40:00',1.95),('3355','2013-09-24','14:45:00',1.93),('3355','2013-09-24','14:50:00',1.92),('3355','2013-09-24','14:55:00',1.91),('3355','2013-09-24','15:00:00',1.86),('3355','2013-09-24','15:05:00',1.86),('3355','2013-09-24','15:10:00',1.84),('3355','2013-09-24','15:15:00',1.8),('3355','2013-09-24','15:20:00',1.8),('3355','2013-09-24','15:25:00',1.79),('3355','2013-09-24','15:30:00',1.76),('3355','2013-09-24','15:35:00',1.73),('3355','2013-09-24','15:40:00',1.7),('3355','2013-09-24','15:45:00',1.68),('3355','2013-09-24','15:50:00',1.65),('3355','2013-09-24','15:55:00',1.61),('3355','2013-09-24','16:00:00',1.57),('3355','2013-09-24','16:05:00',1.54),('3355','2013-09-24','16:10:00',1.49),('3355','2013-09-24','16:15:00',1.46),('3355','2013-09-24','16:20:00',1.44),('3355','2013-09-24','16:25:00',1.37),('3355','2013-09-24','16:30:00',1.34),('3355','2013-09-24','16:35:00',1.29),('3355','2013-09-24','16:40:00',1.24),('3355','2013-09-24','16:45:00',1.21),('3355','2013-09-24','16:50:00',1.17),('3355','2013-09-24','16:55:00',1.13),('3355','2013-09-24','17:00:00',1.09),('3355','2013-09-24','17:05:00',1.03),('3355','2013-09-23','09:15:00',1.03),('3355','2013-09-23','09:20:00',1.08),('3355','2013-09-23','09:25:00',1.13),('3355','2013-09-23','09:30:00',1.17),('3355','2013-09-23','09:35:00',1.22),('3355','2013-09-23','09:40:00',1.27),('3355','2013-09-23','09:45:00',1.31),('3355','2013-09-23','09:50:00',1.35),('3355','2013-09-23','09:55:00',1.39),('3355','2013-09-23','10:00:00',1.43),('3355','2013-09-23','10:05:00',1.46),('3355','2013-09-23','10:10:00',1.5),('3355','2013-09-23','10:15:00',1.54),('3355','2013-09-23','10:20:00',1.57),('3355','2013-09-23','10:25:00',1.6),('3355','2013-09-23','10:30:00',1.64),('3355','2013-09-23','10:35:00',1.67),('3355','2013-09-23','10:40:00',1.7),('3355','2013-09-23','10:45:00',1.73),('3355','2013-09-23','10:50:00',1.76),('3355','2013-09-23','10:55:00',1.78),('3355','2013-09-23','11:00:00',1.81),('3355','2013-09-23','11:05:00',1.85),('3355','2013-09-23','11:10:00',1.88),('3355','2013-09-23','11:15:00',1.91),('3355','2013-09-23','11:20:00',1.93),('3355','2013-09-23','11:25:00',1.96),('3355','2013-09-23','11:30:00',1.98),('3355','2013-09-23','11:35:00',2),('3355','2013-09-23','11:40:00',2.02),('3355','2013-09-23','11:45:00',2.03),('3355','2013-09-23','11:50:00',2.04),('3355','2013-09-23','11:55:00',2.06),('3355','2013-09-23','12:00:00',2.09),('3355','2013-09-23','12:05:00',2.12),('3355','2013-09-23','12:10:00',2.14),('3355','2013-09-23','12:15:00',2.14),('3355','2013-09-23','12:20:00',2.13),('3355','2013-09-23','12:25:00',2.13),('3355','2013-09-23','12:30:00',2.12),('3355','2013-09-23','12:35:00',2.12),('3355','2013-09-23','12:40:00',2.13),('3355','2013-09-23','12:45:00',2.13),('3355','2013-09-23','12:50:00',2.12),('3355','2013-09-23','12:55:00',2.15),('3355','2013-09-23','13:00:00',2.15),('3355','2013-09-23','13:05:00',2.14),('3355','2013-09-23','13:10:00',2.13),('3355','2013-09-23','13:15:00',2.13),('3355','2013-09-23','13:20:00',2.11),('3355','2013-09-23','13:25:00',2.13),('3355','2013-09-23','13:30:00',2.14),('3355','2013-09-23','13:35:00',2.13),('3355','2013-09-23','13:40:00',2.13),('3355','2013-09-23','13:45:00',2.12),('3355','2013-09-23','13:50:00',2.11),('3355','2013-09-23','13:55:00',2.09),('3355','2013-09-23','14:00:00',2.06),('3355','2013-09-23','14:05:00',2.04),('3355','2013-09-23','14:10:00',2.05),('3355','2013-09-23','14:15:00',2.05),('3355','2013-09-23','14:20:00',2.01),('3355','2013-09-23','14:25:00',2.02),('3355','2013-09-23','14:30:00',2.07),('3355','2013-09-23','14:35:00',1.91),('3355','2013-09-23','14:40:00',1.99),('3355','2013-09-23','14:45:00',1.94),('3355','2013-09-23','14:50:00',1.93),('3355','2013-09-23','14:55:00',1.92),('3355','2013-09-23','15:00:00',1.86),('3355','2013-09-23','15:05:00',1.9),('3355','2013-09-23','15:10:00',1.66),('3355','2013-09-23','15:15:00',1.85),('3355','2013-09-23','15:20:00',1.79),('3355','2013-09-23','15:25:00',1.76),('3355','2013-09-23','15:30:00',1.74),('3355','2013-09-23','15:35:00',1.7),('3355','2013-09-23','15:40:00',1.66),('3355','2013-09-23','15:45:00',1.62),('3355','2013-09-23','15:50:00',1.62),('3355','2013-09-23','15:55:00',1.5),('3355','2013-09-23','16:00:00',1.37),('3355','2013-09-23','16:05:00',1.51),('3355','2013-09-23','16:15:00',1.47),('3355','2013-09-23','16:25:00',1.41),('3355','2013-09-23','16:35:00',1.12),('3355','2013-09-23','16:40:00',1.21),('3355','2013-09-23','16:45:00',1.18),('3355','2013-09-23','16:50:00',1.11),('3355','2013-09-23','16:55:00',1.08),('3355','2013-09-23','17:00:00',1.04),('3355','2013-09-22','09:15:00',1.02),('3355','2013-09-22','09:20:00',1.07),('3355','2013-09-22','09:25:00',1.12),('3355','2013-09-22','09:30:00',1.17),('3355','2013-09-22','09:35:00',1.21),('3355','2013-09-22','09:40:00',1.25),('3355','2013-09-22','09:45:00',1.3),('3355','2013-09-22','09:50:00',1.34),('3355','2013-09-22','09:55:00',1.39),('3355','2013-09-22','10:00:00',1.43),('3355','2013-09-22','10:05:00',1.47),('3355','2013-09-22','10:10:00',1.51),('3355','2013-09-22','10:15:00',1.55),('3355','2013-09-22','10:20:00',1.58),('3355','2013-09-22','10:25:00',1.62),('3355','2013-09-22','10:30:00',1.66),('3355','2013-09-22','10:35:00',1.7),('3355','2013-09-22','10:40:00',1.72),('3355','2013-09-22','10:45:00',1.75),('3355','2013-09-22','10:50:00',1.78),('3355','2013-09-22','10:55:00',1.8),('3355','2013-09-22','11:00:00',1.83),('3355','2013-09-22','11:05:00',1.86),('3355','2013-09-22','11:10:00',1.87),('3355','2013-09-22','11:15:00',1.9),('3355','2013-09-22','11:20:00',1.92),('3355','2013-09-22','11:25:00',1.94),('3355','2013-09-22','11:30:00',1.97),('3355','2013-09-22','11:35:00',2),('3355','2013-09-22','11:40:00',2.03),('3355','2013-09-22','11:45:00',2.05),('3355','2013-09-22','11:50:00',2.07),('3355','2013-09-22','11:55:00',2.1),('3355','2013-09-22','12:00:00',2.11),('3355','2013-09-22','12:05:00',2.12),('3355','2013-09-22','12:10:00',2.14),('3355','2013-09-22','12:15:00',2.14),('3355','2013-09-22','12:20:00',2.15),('3355','2013-09-22','12:25:00',2.16),('3355','2013-09-22','12:30:00',2.16),('3355','2013-09-22','12:35:00',2.16),('3355','2013-09-22','12:40:00',2.19),('3355','2013-09-22','12:45:00',2.16),('3355','2013-09-22','12:50:00',2.2),('3355','2013-09-22','12:55:00',2.23),('3355','2013-09-22','13:00:00',2.21),('3355','2013-09-22','13:05:00',2.21),('3355','2013-09-22','13:10:00',2.15),('3355','2013-09-22','13:15:00',2.03),('3355','2013-09-22','13:20:00',2.18),('3355','2013-09-22','13:25:00',2.16),('3355','2013-09-22','13:30:00',2.15),('3355','2013-09-22','13:35:00',2.16),('3355','2013-09-22','13:40:00',2.16),('3355','2013-09-22','13:45:00',2.15),('3355','2013-09-22','13:50:00',2.16),('3355','2013-09-22','13:55:00',2.09),('3355','2013-09-22','14:00:00',2.12),('3355','2013-09-22','14:05:00',2.14),('3355','2013-09-22','14:10:00',2.15),('3355','2013-09-22','14:15:00',2.14),('3355','2013-09-22','14:20:00',1.74),('3355','2013-09-22','14:25:00',2.01),('3355','2013-09-22','14:30:00',2.22),('3355','2013-09-22','14:35:00',2.09),('3355','2013-09-22','14:40:00',1.4),('3355','2013-09-22','14:45:00',1.88),('3355','2013-09-22','14:50:00',2.04),('3355','2013-09-22','14:55:00',2.01),('3355','2013-09-22','15:00:00',2.02),('3355','2013-09-22','15:05:00',2.06),('3355','2013-09-22','15:10:00',2.02),('3355','2013-09-22','15:15:00',2.06),('3355','2013-09-22','15:20:00',2.13),('3355','2013-09-22','15:25:00',1.27),('3355','2013-09-22','15:40:00',1.43),('3355','2013-09-22','15:45:00',1.79),('3355','2013-09-22','15:50:00',1.75),('3355','2013-09-22','15:55:00',1.72),('3355','2013-09-22','16:00:00',1.83),('3355','2013-09-22','16:05:00',1.82),('3355','2013-09-22','16:10:00',1.79),('3355','2013-09-22','16:15:00',1.78),('3355','2013-09-22','16:20:00',1.11),('3355','2013-09-22','16:45:00',1.17),('3355','2013-09-22','17:05:00',1.1),('3355','2013-09-21','09:20:00',1.04),('3355','2013-09-21','09:25:00',1.09),('3355','2013-09-21','09:30:00',1.14),('3355','2013-09-21','09:35:00',1.19),('3355','2013-09-21','09:40:00',1.23),('3355','2013-09-21','09:45:00',1.28),('3355','2013-09-21','09:50:00',1.32),('3355','2013-09-21','09:55:00',1.35),('3355','2013-09-21','10:00:00',1.4),('3355','2013-09-21','10:05:00',1.44),('3355','2013-09-21','10:10:00',1.48),('3355','2013-09-21','10:15:00',1.52),('3355','2013-09-21','10:20:00',1.56),('3355','2013-09-21','10:25:00',1.59),('3355','2013-09-21','10:30:00',1.61),('3355','2013-09-21','10:35:00',1.64),('3355','2013-09-21','10:40:00',1.67),('3355','2013-09-21','10:45:00',1.7),('3355','2013-09-21','10:50:00',1.73),('3355','2013-09-21','10:55:00',1.77),('3355','2013-09-21','11:00:00',1.8),('3355','2013-09-21','11:05:00',1.82),('3355','2013-09-21','11:10:00',1.84),('3355','2013-09-21','11:15:00',1.87),('3355','2013-09-21','11:20:00',1.9),('3355','2013-09-21','11:25:00',1.92),('3355','2013-09-21','11:30:00',1.94),('3355','2013-09-21','11:35:00',1.95),('3355','2013-09-21','11:40:00',1.97),('3355','2013-09-21','11:45:00',1.99),('3355','2013-09-21','11:50:00',2.01),('3355','2013-09-21','11:55:00',1.98),('3355','2013-09-21','12:00:00',2.02),('3355','2013-09-21','12:05:00',2.05),('3355','2013-09-21','12:10:00',2.06),('3355','2013-09-21','12:15:00',2.06),('3355','2013-09-21','12:20:00',2.08),('3355','2013-09-21','12:25:00',1.86),('3355','2013-09-21','12:30:00',2.14),('3355','2013-09-21','12:35:00',2.11),('3355','2013-09-21','12:40:00',1.97),('3355','2013-09-21','12:45:00',2.05),('3355','2013-09-21','12:50:00',2.1),('3355','2013-09-21','12:55:00',2.12),('3355','2013-09-21','13:00:00',2.13),('3355','2013-09-21','13:05:00',2.08),('3355','2013-09-21','13:10:00',2.14),('3355','2013-09-21','13:15:00',2.17),('3355','2013-09-21','13:20:00',1.81),('3355','2013-09-21','13:25:00',2.02),('3355','2013-09-21','13:30:00',2.06),('3355','2013-09-21','13:35:00',2.09),('3355','2013-09-21','13:40:00',1.85),('3355','2013-09-21','13:45:00',1.84),('3355','2013-09-21','13:50:00',1.91),('3355','2013-09-21','13:55:00',1.94),('3355','2013-09-21','14:00:00',1.95),('3355','2013-09-21','14:05:00',2.07),('3355','2013-09-21','14:10:00',1.98),('3355','2013-09-21','14:15:00',2.08),('3355','2013-09-21','14:20:00',2.07),('3355','2013-09-21','14:25:00',2.04),('3355','2013-09-21','14:30:00',2.02),('3355','2013-09-21','14:35:00',2),('3355','2013-09-21','14:40:00',1.98),('3355','2013-09-21','14:45:00',1.95),('3355','2013-09-21','14:50:00',1.94),('3355','2013-09-21','14:55:00',1.91),('3355','2013-09-21','15:00:00',1.89),('3355','2013-09-21','15:05:00',1.88),('3355','2013-09-21','15:10:00',1.83),('3355','2013-09-21','15:15:00',1.82),('3355','2013-09-21','15:20:00',1.81),('3355','2013-09-21','15:25:00',1.78),('3355','2013-09-21','15:30:00',1.75),('3355','2013-09-21','15:35:00',1.73),('3355','2013-09-21','15:40:00',1.59),('3355','2013-09-21','15:45:00',1.17),('3355','2013-09-21','15:50:00',1.55),('3355','2013-09-21','15:55:00',1.61),('3355','2013-09-21','16:00:00',1.25),('3355','2013-09-21','16:20:00',1.06),('3355','2013-09-20','10:05:00',1.32),('3355','2013-09-20','10:10:00',1.24),('3355','2013-09-20','10:15:00',1.44),('3355','2013-09-20','10:20:00',1.87),('3355','2013-09-20','10:25:00',1.47),('3355','2013-09-20','10:30:00',1.39),('3355','2013-09-20','10:35:00',1.84),('3355','2013-09-20','10:40:00',1.76),('3355','2013-09-20','10:45:00',2.15),('3355','2013-09-20','10:50:00',1.85),('3355','2013-09-20','10:55:00',1.45),('3355','2013-09-20','11:00:00',1.05),('3355','2013-09-20','11:05:00',1.03),('3355','2013-09-20','11:10:00',1.05),('3355','2013-09-20','11:15:00',1.72),('3355','2013-09-20','11:20:00',1.34),('3355','2013-09-20','11:25:00',1.35),('3355','2013-09-20','11:30:00',1.17),('3355','2013-09-20','11:35:00',1.85),('3355','2013-09-20','11:40:00',1.45),('3355','2013-09-20','11:45:00',2.34),('3355','2013-09-20','11:50:00',2.19),('3355','2013-09-20','11:55:00',2.1),('3355','2013-09-20','12:00:00',2.09),('3355','2013-09-20','12:05:00',2.09),('3355','2013-09-20','12:10:00',2.12),('3355','2013-09-20','12:15:00',2.16),('3355','2013-09-20','12:20:00',2.22),('3355','2013-09-20','12:25:00',2.12),('3355','2013-09-20','12:30:00',2.26),('3355','2013-09-20','12:35:00',1.62),('3355','2013-09-20','12:40:00',1.81),('3355','2013-09-20','12:45:00',1.36),('3355','2013-09-20','12:50:00',1.77),('3355','2013-09-20','12:55:00',2.25),('3355','2013-09-20','13:00:00',2.07),('3355','2013-09-20','13:05:00',1.91),('3355','2013-09-20','13:10:00',2.14),('3355','2013-09-20','13:15:00',1.59),('3355','2013-09-20','13:20:00',1.36),('3355','2013-09-20','13:25:00',2.06),('3355','2013-09-20','13:30:00',2.27),('3355','2013-09-20','13:35:00',1.49),('3355','2013-09-20','13:40:00',2.02),('3355','2013-09-20','13:45:00',2.17),('3355','2013-09-20','13:50:00',2.12),('3355','2013-09-20','13:55:00',1.95),('3355','2013-09-20','14:00:00',2.11),('3355','2013-09-20','14:05:00',2.15),('3355','2013-09-20','14:10:00',2.06),('3355','2013-09-20','14:15:00',1.25),('3355','2013-09-20','14:25:00',1.77),('3355','2013-09-20','14:30:00',2.23),('3355','2013-09-20','14:35:00',2.2),('3355','2013-09-20','14:40:00',2.13),('3355','2013-09-20','14:46:00',2.12),('3355','2013-09-20','14:50:00',2.14),('3355','2013-09-20','14:55:00',2.11),('3355','2013-09-20','15:00:00',1.51),('3355','2013-09-20','15:05:00',1.04),('3355','2013-09-20','15:10:00',1.72),('3355','2013-09-20','15:15:00',1.87),('3355','2013-09-20','15:20:00',1.72),('3355','2013-09-20','15:25:00',1.32),('3355','2013-09-20','15:30:00',1.66),('3355','2013-09-20','15:35:00',1.07),('3355','2013-09-20','15:40:00',1.37),('3355','2013-09-20','15:45:00',1.83),('3355','2013-09-20','15:50:00',1.79),('3355','2013-09-20','15:55:00',1.82),('3355','2013-09-20','16:00:00',1.09),('3355','2013-09-20','16:10:00',1.18),('3355','2013-09-20','16:15:00',1.55),('3355','2013-09-20','16:50:00',1.36),('3355','2013-09-20','16:55:00',1.39),('3355','2013-09-20','17:00:00',1.26),('3355','2013-09-20','17:05:00',1.37),('3355','2013-09-20','17:10:00',1.33),('3355','2013-09-20','17:15:00',1.27),('3355','2013-09-20','17:20:00',1.21),('3355','2013-09-20','17:25:00',1.04),('3355','2013-09-19','10:10:00',1.23),('3355','2013-09-19','10:15:00',1.18),('3355','2013-09-19','10:35:00',1.3),('3355','2013-09-19','10:40:00',1.29),('3355','2013-09-19','10:45:00',1.6),('3355','2013-09-19','10:50:00',1),('3355','2013-09-19','10:55:00',1.39),('3355','2013-09-19','11:00:00',2.05),('3355','2013-09-19','11:05:00',2.28),('3355','2013-09-19','11:10:00',1.28),('3355','2013-09-19','11:20:00',1.3),('3355','2013-09-19','11:30:00',1.7),('3355','2013-09-19','11:35:00',1.22),('3355','2013-09-19','11:40:00',1.49),('3355','2013-09-19','11:45:00',1.51),('3355','2013-09-19','11:50:00',2.08),('3355','2013-09-19','11:55:00',2.2),('3355','2013-09-19','12:10:00',1.19),('3355','2013-09-19','12:15:00',1.4),('3355','2013-09-19','12:20:00',1.89),('3355','2013-09-19','12:25:00',2.47),('3355','2013-09-19','12:30:00',2.26),('3355','2013-09-19','12:35:00',2.25),('3355','2013-09-19','12:40:00',2.27),('3355','2013-09-19','12:45:00',1.74),('3355','2013-09-19','12:50:00',2.38),('3355','2013-09-19','12:55:00',2.31),('3355','2013-09-19','13:00:00',2.31),('3355','2013-09-19','13:05:00',2.32),('3355','2013-09-19','13:10:00',2.41),('3355','2013-09-19','13:15:00',2.44),('3355','2013-09-19','13:20:00',2.34),('3355','2013-09-19','13:25:00',1.69),('3355','2013-09-19','13:30:00',2.21),('3355','2013-09-19','13:35:00',2.36),('3355','2013-09-19','13:40:00',2.46),('3355','2013-09-19','13:45:00',2.51),('3355','2013-09-19','13:50:00',2.34),('3355','2013-09-19','13:55:00',1.11),('3355','2013-09-19','14:05:00',1.55),('3355','2013-09-19','14:10:00',2.31),('3355','2013-09-19','14:15:00',2.21),('3355','2013-09-19','14:20:00',2.17),('3355','2013-09-19','14:25:00',2.13),('3355','2013-09-19','14:30:00',2.12),('3355','2013-09-19','14:35:00',2.1),('3355','2013-09-19','14:40:00',2.05),('3355','2013-09-19','14:45:00',1.99),('3355','2013-09-19','14:50:00',2.03),('3355','2013-09-19','14:55:00',1.97),('3355','2013-09-19','15:00:00',2.06),('3355','2013-09-19','15:05:00',1.83),('3355','2013-09-19','15:10:00',1.66),('3355','2013-09-19','15:15:00',1.8),('3355','2013-09-19','15:20:00',1.88),('3355','2013-09-19','15:25:00',1.87),('3355','2013-09-19','15:30:00',1.8),('3355','2013-09-19','15:35:00',1.15),('3355','2013-09-19','15:40:00',1.55),('3355','2013-09-19','15:45:00',1.88),('3355','2013-09-19','15:50:00',1.76),('3355','2013-09-19','15:55:00',1.6),('3355','2013-09-19','16:00:00',1.63),('3355','2013-09-19','16:05:00',1.62),('3355','2013-09-19','16:10:00',1.29),('3355','2013-09-19','16:15:00',1.42),('3355','2013-09-19','16:20:00',1.58),('3355','2013-09-19','16:25:00',1.55),('3355','2013-09-19','16:30:00',1.2),('3355','2013-09-19','16:35:00',1.08),('3355','2013-09-19','16:50:00',1.17),('3355','2013-09-19','16:55:00',1.25),('3355','2013-09-19','17:00:00',1.1),('3355','2013-09-19','17:05:00',1.04),('3355','2013-09-19','17:10:00',1.03),('3355','2014-04-13','09:30:00',1.02),('3355','2014-04-13','10:00:00',1.38),('3355','2014-04-13','10:05:00',1.93),('3355','2014-04-13','10:10:00',1.08),('3355','2014-04-13','10:15:00',1.2),('3355','2014-04-13','10:20:00',1.53),('3355','2014-04-13','10:30:00',1.73),('3355','2014-04-13','10:35:00',1.92),('3355','2014-04-13','10:40:00',1.86),('3355','2014-04-13','10:45:00',1.95),('3355','2014-04-13','10:50:00',1.94),('3355','2014-04-13','10:55:00',1.96),('3355','2014-04-13','11:00:00',1.99),('3355','2014-04-13','11:05:00',2.02),('3355','2014-04-13','11:10:00',1.97),('3355','2014-04-13','11:15:00',1.8),('3355','2014-04-13','11:20:00',2.47),('3355','2014-04-13','11:25:00',1.51),('3355','2014-04-13','11:30:00',1.01),('3355','2014-04-13','11:35:00',1.35),('3355','2014-04-13','11:40:00',1.84),('3355','2014-04-13','11:45:00',1.78),('3355','2014-04-13','11:50:00',2.02),('3355','2014-04-13','11:55:00',1.59),('3355','2014-04-13','12:00:00',1.23),('3355','2014-04-13','13:10:00',1.11),('3355','2014-04-13','13:15:00',1.03),('3355','2014-04-13','13:20:00',1.25),('3355','2014-04-13','13:25:00',1.65),('3355','2014-04-13','13:30:00',2.16),('3355','2014-04-13','13:35:00',2.26),('3355','2014-04-13','13:40:00',2.42),('3355','2014-04-13','13:45:00',1.2),('3355','2014-04-13','13:50:00',1.84),('3355','2014-04-13','13:55:00',1.79),('3355','2014-04-13','14:00:00',2.22),('3355','2014-04-13','14:05:00',1.75),('3355','2014-04-13','14:10:00',1.96),('3355','2014-04-13','14:15:00',2.13),('3355','2014-04-13','14:45:00',1),('3355','2014-04-13','14:50:00',2.2),('3355','2014-04-13','15:00:00',1.84),('3355','2014-04-13','15:05:00',2.11),('3355','2014-04-13','15:10:00',2.17),('3355','2014-04-13','15:15:00',1.97),('3355','2014-04-13','15:20:00',1.92),('3355','2014-04-13','15:25:00',2.01),('3355','2014-04-13','15:30:00',2),('3355','2014-04-13','15:35:00',1.31),('3355','2014-04-13','15:50:00',1.13),('3355','2014-04-13','15:55:00',1.21),('3355','2014-04-13','16:00:00',2.07),('3355','2014-04-13','16:05:00',1.66),('3355','2014-04-13','16:40:00',1.66),('3355','2014-04-13','16:45:00',1.89),('3355','2014-04-13','16:50:00',1.36),('3355','2014-04-13','16:55:00',1.48),('3355','2014-04-13','17:00:00',1.44),('3355','2014-04-13','17:05:00',1.01),('3355','2013-09-18','09:20:00',1.13),('3355','2013-09-18','09:35:00',1.1),('3355','2013-09-18','09:55:00',1.21),('3355','2013-09-18','10:00:00',1.4),('3355','2013-09-18','10:05:00',1.65),('3355','2013-09-18','10:10:00',1.55),('3355','2013-09-18','10:15:00',1.56),('3355','2013-09-18','10:20:00',1.55),('3355','2013-09-18','10:25:00',1.58),('3355','2013-09-18','10:30:00',1.61),('3355','2013-09-18','10:35:00',1.63),('3355','2013-09-18','10:40:00',1.67),('3355','2013-09-18','10:45:00',1.69),('3355','2013-09-18','10:50:00',1.37),('3355','2013-09-18','10:55:00',1.55),('3355','2013-09-18','11:00:00',1.73),('3355','2013-09-18','11:05:00',1.7),('3355','2013-09-18','11:10:00',1.83),('3355','2013-09-18','11:15:00',1.12),('3355','2013-09-18','11:25:00',1.28),('3355','2013-09-18','11:30:00',2.18),('3355','2013-09-18','11:35:00',2.04),('3355','2013-09-18','11:40:00',1.5),('3355','2013-09-18','11:45:00',1.37),('3355','2013-09-18','11:50:00',2.12),('3355','2013-09-18','11:55:00',2.13),('3355','2013-09-18','12:00:00',2.14),('3355','2013-09-18','12:05:00',2.13),('3355','2013-09-18','12:10:00',2.23),('3355','2013-09-18','12:15:00',2.22),('3355','2013-09-18','12:20:00',2.23),('3355','2013-09-18','12:25:00',2.28),('3355','2013-09-18','12:30:00',1.44),('3355','2013-09-18','12:35:00',1.88),('3355','2013-09-18','12:40:00',2.4),('3355','2013-09-18','12:45:00',1.63),('3355','2013-09-18','12:50:00',1.32),('3355','2013-09-18','12:55:00',2.29),('3355','2013-09-18','13:00:00',1.63),('3355','2013-09-18','13:05:00',1.72),('3355','2013-09-18','13:10:00',2.31),('3355','2013-09-18','13:15:00',2.3),('3355','2013-09-18','13:20:00',2.3),('3355','2013-09-18','13:25:00',2.2),('3355','2013-09-18','13:30:00',2.3),('3355','2013-09-18','13:35:00',2.25),('3355','2013-09-18','13:40:00',2.25),('3355','2013-09-18','13:45:00',2.26),('3355','2013-09-18','13:50:00',2.29),('3355','2013-09-18','13:55:00',2.11),('3355','2013-09-18','14:00:00',2.03),('3355','2013-09-18','14:05:00',2.15),('3355','2013-09-18','14:10:00',1.89),('3355','2013-09-18','14:15:00',2.19),('3355','2013-09-18','14:20:00',2.18),('3355','2013-09-18','14:25:00',2.15),('3355','2013-09-18','14:30:00',2.12),('3355','2013-09-18','14:35:00',2.1),('3355','2013-09-18','14:40:00',2.08),('3355','2013-09-18','14:45:00',2.06),('3355','2013-09-18','14:50:00',1.28),('3355','2013-09-18','14:55:00',2.05),('3355','2013-09-18','15:00:00',2.03),('3355','2013-09-18','15:05:00',1.99),('3355','2013-09-18','15:15:00',1.13),('3355','2013-09-18','15:20:00',1.63),('3355','2013-09-18','15:25:00',1.45),('3355','2013-09-18','15:30:00',1.97),('3355','2013-09-18','15:35:00',1.91),('3355','2013-09-18','15:40:00',1.89),('3355','2013-09-18','15:45:00',1.78),('3355','2013-09-18','15:50:00',1.55),('3355','2013-09-18','15:55:00',1.06),('3355','2013-09-18','16:00:00',1.8),('3355','2013-09-18','16:05:00',1.8),('3355','2013-09-18','16:10:00',1.71),('3355','2013-09-18','16:15:00',1.6),('3355','2013-09-18','16:20:00',1.55),('3355','2013-09-18','16:25:00',1.37),('3355','2013-09-18','16:30:00',1.33),('3355','2013-09-18','16:35:00',1.25),('3355','2013-09-18','16:40:00',1.24),('3355','2013-09-18','16:45:00',1.26),('3355','2013-09-18','16:50:00',1.14),('3355','2013-09-18','16:55:00',1.07),('3355','2013-09-18','17:00:00',1.16),('3355','2013-09-18','17:05:00',1.02),('3355','2013-09-18','17:10:00',1.04),('3355','2013-09-17','09:45:00',1.22),('3355','2013-09-17','10:00:00',1.19),('3355','2013-09-17','10:25:00',1.41),('3355','2013-09-17','10:30:00',1.83),('3355','2013-09-17','10:35:00',1.06),('3355','2013-09-17','10:40:00',1.13),('3355','2013-09-17','10:50:00',2.07),('3355','2013-09-17','10:55:00',1.56),('3355','2013-09-17','11:00:00',1.2),('3355','2013-09-17','11:05:00',1.22),('3355','2013-09-17','11:10:00',1.76),('3355','2013-09-17','11:15:00',1.6),('3355','2013-09-17','11:20:00',1.31),('3355','2013-09-17','11:35:00',1.74),('3355','2013-09-17','11:40:00',1.97),('3355','2013-09-17','11:45:00',1.83),('3355','2013-09-17','11:50:00',1.76),('3355','2013-09-17','11:55:00',1.41),('3355','2013-09-17','12:00:00',2.05),('3355','2013-09-17','12:05:00',1.44),('3355','2013-09-17','12:15:00',1.23),('3355','2013-09-17','12:25:00',2.05),('3355','2013-09-17','12:30:00',1.81),('3355','2013-09-17','12:35:00',1.29),('3355','2013-09-17','12:40:00',1.81),('3355','2013-09-17','12:45:00',1.91),('3355','2013-09-17','12:50:00',1.77),('3355','2013-09-17','12:55:00',1.33),('3355','2013-09-17','13:00:00',1.35),('3355','2013-09-17','13:10:00',1.34),('3355','2013-09-17','13:15:00',1.92),('3355','2013-09-17','13:20:00',1.33),('3355','2013-09-17','13:25:00',1.23),('3355','2013-09-17','13:30:00',1.03),('3355','2013-09-17','13:40:00',1.27),('3355','2013-09-17','14:00:00',1.1),('3355','2013-09-17','14:25:00',1.06),('3355','2013-09-17','14:55:00',1.86),('3355','2013-09-17','15:00:00',2.03),('3355','2013-09-17','15:05:00',1.55),('3355','2013-09-17','15:10:00',1.53),('3355','2013-09-17','15:15:00',1.59),('3355','2013-09-17','15:20:00',1.75),('3355','2013-09-17','15:25:00',1.64),('3355','2013-09-17','15:30:00',1.45),('3355','2013-09-17','15:50:00',1.09),('3355','2013-09-17','15:55:00',1.29),('3355','2013-09-17','16:05:00',1.11),('3355','2013-09-17','17:05:00',1.01),('3355','2013-09-16','09:15:00',1.11),('3355','2013-09-16','09:25:00',1.11),('3355','2013-09-16','09:35:00',1.02),('3355','2013-09-16','09:40:00',1.29),('3355','2013-09-16','09:45:00',1.32),('3355','2013-09-16','09:50:00',1.34),('3355','2013-09-16','09:55:00',1.42),('3355','2013-09-16','10:00:00',1.45),('3355','2013-09-16','10:05:00',1.51),('3355','2013-09-16','10:10:00',1.64),('3355','2013-09-16','10:25:00',1.06),('3355','2013-09-16','10:30:00',1.46),('3355','2013-09-16','10:35:00',1.87),('3355','2013-09-16','10:40:00',1.99),('3355','2013-09-16','10:45:00',2.12),('3355','2013-09-16','10:50:00',1.59),('3355','2013-09-16','11:20:00',1.8),('3355','2013-09-16','11:25:00',1.39),('3355','2013-09-16','11:30:00',2.15),('3355','2013-09-16','11:35:00',2.11),('3355','2013-09-16','11:40:00',2.13),('3355','2013-09-16','11:45:00',2),('3355','2013-09-16','11:50:00',1.27),('3355','2013-09-16','11:55:00',2.23),('3355','2013-09-16','12:00:00',2.27),('3355','2013-09-16','12:05:00',2.35),('3355','2013-09-16','12:10:00',2.49),('3355','2013-09-16','12:15:00',2.23),('3355','2013-09-16','12:20:00',2.22),('3355','2013-09-16','12:25:00',2.2),('3355','2013-09-16','12:30:00',2.21),('3355','2013-09-16','12:35:00',2.23),('3355','2013-09-16','12:40:00',2.29),('3355','2013-09-16','12:45:00',2.42),('3355','2013-09-16','12:50:00',1.22),('3355','2013-09-16','12:55:00',1.95),('3355','2013-09-16','13:00:00',1.94),('3355','2013-09-16','13:05:00',1.87),('3355','2013-09-16','13:10:00',2.29),('3355','2013-09-16','13:15:00',2.02),('3355','2013-09-16','13:20:00',2.26),('3355','2013-09-16','13:25:00',2.25),('3355','2013-09-16','13:30:00',2.22),('3355','2013-09-16','13:35:00',2.23),('3355','2013-09-16','13:40:00',2.23),('3355','2013-09-16','13:45:00',2.22),('3355','2013-09-16','13:50:00',2.24),('3355','2013-09-16','13:55:00',2.29),('3355','2013-09-16','14:00:00',2.27),('3355','2013-09-16','14:05:00',2.15),('3355','2013-09-16','14:10:00',2.19),('3355','2013-09-16','14:15:00',2.16),('3355','2013-09-16','14:20:00',2.14),('3355','2013-09-16','14:25:00',2.13),('3355','2013-09-16','14:30:00',2.12),('3355','2013-09-16','14:35:00',2.11),('3355','2013-09-16','14:40:00',2.08),('3355','2013-09-16','14:45:00',2.05),('3355','2013-09-16','14:50:00',1.98),('3355','2013-09-16','14:55:00',1.96),('3355','2013-09-16','15:00:00',2.01),('3355','2013-09-16','15:05:00',2.01),('3355','2013-09-16','15:10:00',1.99),('3355','2013-09-16','15:15:00',1.96),('3355','2013-09-16','15:20:00',1.93),('3355','2013-09-16','15:25:00',1.91),('3355','2013-09-16','15:30:00',1.89),('3355','2013-09-16','15:35:00',1.86),('3355','2013-09-16','15:40:00',1.84),('3355','2013-09-16','15:45:00',1.82),('3355','2013-09-16','15:50:00',1.78),('3355','2013-09-16','15:55:00',1.74),('3355','2013-09-16','16:00:00',1.73),('3355','2013-09-16','16:05:00',1.32),('3355','2013-09-16','16:10:00',1.65),('3355','2013-09-16','16:15:00',1.61),('3355','2013-09-16','16:20:00',1.58),('3355','2013-09-16','16:25:00',1.53),('3355','2013-09-16','16:30:00',1.48),('3355','2013-09-16','16:35:00',1.44),('3355','2013-09-16','16:40:00',1.41),('3355','2013-09-16','16:45:00',1.37),('3355','2013-09-16','16:50:00',1.32),('3355','2013-09-16','16:55:00',1.27),('3355','2013-09-16','17:00:00',1.22),('3355','2013-09-16','17:05:00',1.18),('3355','2013-09-16','17:10:00',1.12),('3355','2013-09-16','17:15:00',1.07),('3355','2013-09-16','17:20:00',1.01),('3355','2013-09-15','09:15:00',1.07),('3355','2013-09-15','09:20:00',1.06),('3355','2013-09-15','09:25:00',1.11),('3355','2013-09-15','09:30:00',1.14),('3355','2013-09-15','09:35:00',1.23),('3355','2013-09-15','09:40:00',1.27),('3355','2013-09-15','09:45:00',1.29),('3355','2013-09-15','09:50:00',1.34),('3355','2013-09-15','09:55:00',1.38),('3355','2013-09-15','10:00:00',1.45),('3355','2013-09-15','10:05:00',1.49),('3355','2013-09-15','10:10:00',1.5),('3355','2013-09-15','10:15:00',1.47),('3355','2013-09-15','10:20:00',1.51),('3355','2013-09-15','10:25:00',1.58),('3355','2013-09-15','10:30:00',1.49),('3355','2013-09-15','10:35:00',1.22),('3355','2013-09-15','11:05:00',2.08),('3355','2013-09-15','11:10:00',2.04),('3355','2013-09-15','11:35:00',1.86),('3355','2013-09-15','11:40:00',1.06),('3355','2013-09-15','11:50:00',1.15),('3355','2013-09-15','13:50:00',1.07),('3355','2013-09-15','15:15:00',1.53),('3355','2013-09-15','15:20:00',1.26),('3355','2013-09-14','09:15:00',1.04),('3355','2013-09-14','09:20:00',1.08),('3355','2013-09-14','09:25:00',1.13),('3355','2013-09-14','09:30:00',1.18),('3355','2013-09-14','09:35:00',1.21),('3355','2013-09-14','09:40:00',1.25),('3355','2013-09-14','09:45:00',1.3),('3355','2013-09-14','09:50:00',1.28),('3355','2013-09-14','09:55:00',1.34),('3355','2013-09-14','10:00:00',1.38),('3355','2013-09-14','10:05:00',1.45),('3355','2013-09-14','10:10:00',1.36),('3355','2013-09-14','10:15:00',1.42),('3355','2013-09-14','10:20:00',1.53),('3355','2013-09-14','10:25:00',1.6),('3355','2013-09-14','10:30:00',1.6),('3355','2013-09-14','10:35:00',1.62),('3355','2013-09-14','10:40:00',1.75),('3355','2013-09-14','10:45:00',1.91),('3355','2013-09-14','10:50:00',1.81),('3355','2013-09-14','10:55:00',1.98),('3355','2013-09-14','11:00:00',2.06),('3355','2013-09-14','11:05:00',1.53),('3355','2013-09-14','11:30:00',2.1),('3355','2013-09-14','11:35:00',1.87),('3355','2013-09-14','11:40:00',1.25),('3355','2013-09-14','11:45:00',1.93),('3355','2013-09-14','11:50:00',1.81),('3355','2013-09-14','11:55:00',2.26),('3355','2013-09-14','12:00:00',1.92),('3355','2013-09-14','12:05:00',2.18),('3355','2013-09-14','12:10:00',1.28),('3355','2013-09-14','12:15:00',1.87),('3355','2013-09-14','12:40:00',2.07),('3355','2013-09-14','13:15:00',1.29),('3355','2013-09-14','13:20:00',2.39),('3355','2013-09-14','13:25:00',1.41),('3355','2013-09-14','13:30:00',2.49),('3355','2013-09-14','13:35:00',1.27),('3355','2013-09-14','13:45:00',1.05),('3355','2013-09-14','13:50:00',1.28),('3355','2013-09-14','13:55:00',2.52),('3355','2013-09-14','14:00:00',2.45),('3355','2013-09-14','14:05:00',2.26),('3355','2013-09-14','14:10:00',2.23),('3355','2013-09-14','14:15:00',2.2),('3355','2013-09-14','14:20:00',2.04),('3355','2013-09-14','14:25:00',2.13),('3355','2013-09-14','14:30:00',2.18),('3355','2013-09-14','14:35:00',2.06),('3355','2013-09-14','14:40:00',2.11),('3355','2013-09-14','14:45:00',2.04),('3355','2013-09-14','14:50:00',2.07),('3355','2013-09-14','14:55:00',2.04),('3355','2013-09-14','15:00:00',2.03),('3355','2013-09-14','15:05:00',1.98),('3355','2013-09-14','15:10:00',1.96),('3355','2013-09-14','15:15:00',1.94),('3355','2013-09-14','15:20:00',1.93),('3355','2013-09-14','15:25:00',1.93),('3355','2013-09-14','15:30:00',1.64),('3355','2013-09-14','15:35:00',1.86),('3355','2013-09-14','15:40:00',1.81),('3355','2013-09-14','15:45:00',1.79),('3355','2013-09-14','15:50:00',1.76),('3355','2013-09-14','15:55:00',1.72),('3355','2013-09-14','16:00:00',1.69),('3355','2013-09-14','16:05:00',1.64),('3355','2013-09-14','16:10:00',1.6),('3355','2013-09-14','16:15:00',1.58),('3355','2013-09-14','16:20:00',1.55),('3355','2013-09-14','16:25:00',1.49),('3355','2013-09-14','16:30:00',1.48),('3355','2013-09-14','16:35:00',1.43),('3355','2013-09-14','16:40:00',1.38),('3355','2013-09-14','16:45:00',1.34),('3355','2013-09-14','16:50:00',1.3),('3355','2013-09-14','16:55:00',1.25),('3355','2013-09-14','17:00:00',1.1),('3355','2013-09-14','17:05:00',1.17),('3355','2013-09-14','17:10:00',1.04),('3355','2013-09-14','17:15:00',1),('3355','2013-09-13','09:55:00',1.43),('3355','2013-09-13','10:00:00',1.42),('3355','2013-09-13','10:15:00',1.81),('3355','2013-09-13','10:20:00',1.94),('3355','2013-09-13','10:25:00',1.2),('3355','2013-09-13','10:35:00',1.8),('3355','2013-09-13','10:40:00',1.74),('3355','2013-09-13','10:45:00',1.77),('3355','2013-09-13','10:50:00',1.79),('3355','2013-09-13','10:55:00',1.81),('3355','2013-09-13','11:00:00',1.84),('3355','2013-09-13','11:05:00',1.87),('3355','2013-09-13','11:10:00',1.89),('3355','2013-09-13','11:15:00',1.92),('3355','2013-09-13','11:20:00',1.95),('3355','2013-09-13','11:25:00',1.96),('3355','2013-09-13','11:30:00',1.98),('3355','2013-09-13','11:35:00',2),('3355','2013-09-13','11:40:00',2.02),('3355','2013-09-13','11:45:00',2.05),('3355','2013-09-13','11:50:00',2.06),('3355','2013-09-13','11:55:00',2.07),('3355','2013-09-13','12:00:00',2.08),('3355','2013-09-13','12:05:00',2.12),('3355','2013-09-13','12:10:00',2.13),('3355','2013-09-13','12:15:00',2.13),('3355','2013-09-13','12:20:00',2.15),('3355','2013-09-13','12:25:00',2.19),('3355','2013-09-13','12:30:00',2.23),('3355','2013-09-13','12:35:00',2.2),('3355','2013-09-13','12:40:00',2.21),('3355','2013-09-13','12:45:00',2.2),('3355','2013-09-13','12:50:00',2.22),('3355','2013-09-13','12:55:00',2.22),('3355','2013-09-13','13:00:00',2.2),('3355','2013-09-13','13:05:00',2.19),('3355','2013-09-13','13:10:00',2.18),('3355','2013-09-13','13:15:00',2.17),('3355','2013-09-13','13:20:00',2.18),('3355','2013-09-13','13:25:00',2.18),('3355','2013-09-13','13:30:00',2.18),('3355','2013-09-13','13:35:00',2.17),('3355','2013-09-13','13:40:00',2.17),('3355','2013-09-13','13:45:00',2.17),('3355','2013-09-13','13:50:00',2.16),('3355','2013-09-13','13:55:00',2.15),('3355','2013-09-13','14:00:00',2.14),('3355','2013-09-13','14:05:00',2.15),('3355','2013-09-13','14:10:00',2.13),('3355','2013-09-13','14:15:00',2.1),('3355','2013-09-13','14:20:00',2.08),('3355','2013-09-13','14:25:00',2.09),('3355','2013-09-13','14:30:00',2.1),('3355','2013-09-13','14:35:00',2.08),('3355','2013-09-13','14:40:00',2.07),('3355','2013-09-13','14:45:00',2.05),('3355','2013-09-13','14:50:00',2.08),('3355','2013-09-13','14:55:00',1.75),('3355','2013-09-13','15:00:00',1.98),('3355','2013-09-13','15:05:00',1.96),('3355','2013-09-13','15:10:00',1.97),('3355','2013-09-13','15:15:00',1.97),('3355','2013-09-13','15:20:00',1.93),('3355','2013-09-13','15:25:00',1.89),('3355','2013-09-13','15:30:00',1.88),('3355','2013-09-13','15:35:00',1.86),('3355','2013-09-13','15:40:00',1.83),('3355','2013-09-13','15:45:00',1.8),('3355','2013-09-13','15:50:00',1.77),('3355','2013-09-13','15:55:00',1.73),('3355','2013-09-13','16:00:00',1.7),('3355','2013-09-13','16:05:00',1.67),('3355','2013-09-13','16:10:00',1.64),('3355','2013-09-13','16:15:00',1.6),('3355','2013-09-13','16:20:00',1.56),('3355','2013-09-13','16:25:00',1.53),('3355','2013-09-13','16:30:00',1.48),('3355','2013-09-13','16:35:00',1.45),('3355','2013-09-13','16:40:00',1.4),('3355','2013-09-13','16:45:00',1.35),('3355','2013-09-13','16:50:00',1.31),('3355','2013-09-13','16:55:00',1.26),('3355','2013-09-13','17:00:00',1.2),('3355','2013-09-13','17:05:00',1.16),('3355','2013-09-13','17:10:00',1.11),('3355','2013-09-13','17:15:00',1.06),('3355','2013-09-13','17:20:00',1.01),('3355','2013-09-12','09:15:00',1.04),('3355','2013-09-12','09:20:00',1.03),('3355','2013-09-12','09:25:00',1.15),('3355','2013-09-12','09:30:00',1.24),('3355','2013-09-12','09:35:00',1.04),('3355','2013-09-12','09:45:00',1.07),('3355','2013-09-12','09:50:00',1.29),('3355','2013-09-12','10:55:00',1.06),('3355','2013-09-12','11:00:00',1.2),('3355','2013-09-12','11:05:00',1.67),('3355','2013-09-12','11:10:00',1.26),('3355','2013-09-12','11:15:00',1.49),('3355','2013-09-12','11:45:00',1.38),('3355','2013-09-12','11:55:00',1.33),('3355','2013-09-12','12:00:00',1.78),('3355','2013-09-12','12:05:00',2.15),('3355','2013-09-12','12:10:00',1.78),('3355','2013-09-12','12:15:00',1.5),('3355','2013-09-12','12:35:00',1.5),('3355','2013-09-12','12:40:00',1.98),('3355','2013-09-12','12:50:00',1.05),('3355','2013-09-12','12:55:00',1.1),('3355','2013-09-12','13:00:00',2.27),('3355','2013-09-12','13:05:00',1.52),('3355','2013-09-12','13:10:00',1.85),('3355','2013-09-12','13:15:00',2.32),('3355','2013-09-12','13:20:00',2.56),('3355','2013-09-12','13:25:00',2.58),('3355','2013-09-12','13:30:00',2.03),('3355','2013-09-12','13:35:00',1.84),('3355','2013-09-12','13:40:00',1.44),('3355','2013-09-12','13:45:00',1.91),('3355','2013-09-12','13:50:00',2.33),('3355','2013-09-12','13:55:00',2.28),('3355','2013-09-12','14:00:00',2.31),('3355','2013-09-12','14:05:00',2.17),('3355','2013-09-12','14:10:00',1.77),('3355','2013-09-12','14:15:00',2.25),('3355','2013-09-12','14:20:00',2.21),('3355','2013-09-12','14:25:00',2.28),('3355','2013-09-12','14:30:00',2.22),('3355','2013-09-12','14:35:00',1.82),('3355','2013-09-12','14:40:00',1.52),('3355','2013-09-12','14:45:00',2.2),('3355','2013-09-12','14:50:00',2.13),('3355','2013-09-12','14:55:00',2.1),('3355','2013-09-12','15:00:00',2.08),('3355','2013-09-12','15:05:00',1.64),('3355','2013-09-12','15:10:00',1.79),('3355','2013-09-12','15:15:00',1.74),('3355','2013-09-12','15:20:00',1.98),('3355','2013-09-12','15:25:00',1.86),('3355','2013-09-12','15:30:00',1.94),('3355','2013-09-12','15:35:00',1.9),('3355','2013-09-12','15:40:00',1.86),('3355','2013-09-12','15:45:00',1.87),('3355','2013-09-12','15:50:00',1.83),('3355','2013-09-12','15:55:00',1.79),('3355','2013-09-12','16:00:00',1.8),('3355','2013-09-12','16:05:00',1.56),('3355','2013-09-12','16:10:00',1.36),('3355','2013-09-12','16:15:00',1.22),('3355','2013-09-12','16:20:00',1.22),('3355','2013-09-12','16:25:00',1.27),('3355','2013-09-12','16:40:00',1.06),('3355','2013-09-12','16:45:00',1.56),('3355','2013-09-12','16:55:00',1.05),('3355','2013-09-12','17:05:00',1.16),('3355','2013-09-12','17:15:00',1.19),('3355','2013-09-11','09:00:00',1.02),('3355','2013-09-11','09:10:00',1.04),('3355','2013-09-11','09:15:00',1.02),('3355','2013-09-11','09:20:00',1.08),('3355','2013-09-11','09:25:00',1.09),('3355','2013-09-11','10:05:00',1.48),('3355','2013-09-11','10:20:00',1.66),('3355','2013-09-11','10:25:00',1.34),('3355','2013-09-11','10:30:00',1.24),('3355','2013-09-11','10:35:00',1.66),('3355','2013-09-11','10:40:00',1.94),('3355','2013-09-11','10:45:00',1.51),('3355','2013-09-11','10:50:00',1.61),('3355','2013-09-11','10:55:00',1.05),('3355','2013-09-11','11:05:00',1.53),('3355','2013-09-11','11:10:00',2.06),('3355','2013-09-11','11:15:00',1.44),('3355','2013-09-11','11:20:00',2.15),('3355','2013-09-11','11:25:00',1.89),('3355','2013-09-11','11:35:00',1.6),('3355','2013-09-11','11:40:00',1.27),('3355','2013-09-11','11:45:00',2.17),('3355','2013-09-11','11:50:00',2.17),('3355','2013-09-11','11:55:00',2.02),('3355','2013-09-11','12:00:00',1.53),('3355','2013-09-11','12:05:00',2.04),('3355','2013-09-11','12:10:00',1.2),('3355','2013-09-11','12:15:00',1.42),('3355','2013-09-11','12:20:00',1.37),('3355','2013-09-11','12:25:00',1.18),('3355','2013-09-11','12:30:00',2.27),('3355','2013-09-11','12:35:00',1.27),('3355','2013-09-11','12:45:00',1.62),('3355','2013-09-11','12:50:00',2.2),('3355','2013-09-11','12:55:00',2.19),('3355','2013-09-11','13:00:00',1.96),('3355','2013-09-11','13:05:00',2.33),('3355','2013-09-11','13:10:00',2.32),('3355','2013-09-11','13:15:00',2.38),('3355','2013-09-11','13:20:00',2.43),('3355','2013-09-11','13:25:00',2.31),('3355','2013-09-11','13:30:00',2.17),('3355','2013-09-11','13:35:00',1.08),('3355','2013-09-11','13:40:00',2.09),('3355','2013-09-11','13:45:00',1.25),('3355','2013-09-11','13:50:00',2.38),('3355','2013-09-11','13:55:00',1.49),('3355','2013-09-11','14:00:00',1.76),('3355','2013-09-11','14:05:00',2.31),('3355','2013-09-11','14:10:00',1.25),('3355','2013-09-11','14:15:00',2.1),('3355','2013-09-11','14:20:00',1.61),('3355','2013-09-11','14:25:00',2.23),('3355','2013-09-11','14:30:00',2.2),('3355','2013-09-11','14:35:00',1.89),('3355','2013-09-11','14:40:00',1.01),('3355','2013-09-11','14:45:00',2.07),('3355','2013-09-11','14:50:00',1.83),('3355','2013-09-11','14:55:00',1.57),('3355','2013-09-11','15:00:00',1.75),('3355','2013-09-11','15:05:00',2.07),('3355','2013-09-11','15:10:00',1.47),('3355','2013-09-11','15:15:00',1.91),('3355','2013-09-11','15:20:00',2.23),('3355','2013-09-11','15:25:00',1.18),('3355','2013-09-11','15:30:00',1.35),('3355','2013-09-11','15:45:00',1.45),('3355','2013-09-11','15:50:00',1.73),('3355','2013-09-11','15:55:00',1.75),('3355','2013-09-11','16:00:00',1.78),('3355','2013-09-11','16:05:00',1.39),('3355','2013-09-11','16:10:00',1.77),('3355','2013-09-11','16:15:00',1.72),('3355','2013-09-11','16:20:00',1.62),('3355','2013-09-11','16:25:00',1.17),('3355','2013-09-11','16:30:00',1.44),('3355','2013-09-11','16:35:00',1.15),('3355','2013-09-11','16:45:00',1.48),('3355','2013-09-11','16:50:00',1.37),('3355','2013-09-11','16:55:00',1.19),('3355','2013-09-11','17:05:00',1.23),('3355','2013-09-11','17:10:00',1.17),('3355','2013-09-11','17:15:00',1.1),('3355','2013-09-11','17:20:00',1.06),('3355','2013-09-11','17:25:00',1.01),('3355','2013-09-10','09:05:00',1.02),('3355','2013-09-10','09:10:00',1.19),('3355','2013-09-10','09:15:00',1.02),('3355','2013-09-10','09:30:00',1.3),('3355','2013-09-10','09:35:00',1.52),('3355','2013-09-10','10:45:00',1.07),('3355','2013-09-10','13:45:00',1.55),('3355','2013-09-10','13:50:00',1),('3355','2013-09-10','14:25:00',1.18),('3355','2013-09-10','14:30:00',1.09),('3355','2013-09-10','14:45:00',1.01),('3355','2013-09-10','14:50:00',1.17),('3355','2013-09-10','14:55:00',1.09),('3355','2013-09-10','15:00:00',1.34),('3355','2013-09-10','15:05:00',1.3),('3355','2013-09-10','15:20:00',1.14),('3355','2013-09-10','15:25:00',1),('3355','2013-09-10','15:30:00',1.15),('3355','2013-09-10','15:35:00',1.04),('3355','2013-09-09','10:50:00',1.33),('3355','2013-09-09','10:55:00',1.31),('3355','2013-09-09','11:00:00',1.45),('3355','2013-09-09','11:05:00',1.17),('3355','2013-09-09','11:15:00',1.03),('3355','2013-09-09','11:20:00',1.12),('3355','2013-09-09','11:25:00',1.47),('3355','2013-09-09','11:30:00',1.18),('3355','2013-09-09','11:35:00',1.09),('3355','2013-09-09','11:40:00',1.37),('3355','2013-09-09','11:45:00',1.88),('3355','2013-09-09','11:50:00',1.92),('3355','2013-09-09','11:55:00',1.38),('3355','2013-09-09','12:00:00',1.46),('3355','2013-09-09','12:05:00',1.8),('3355','2013-09-09','12:10:00',1.41),('3355','2013-09-09','13:05:00',1.27),('3355','2013-09-09','13:10:00',1.72),('3355','2013-09-09','13:15:00',1.69),('3355','2013-09-09','13:25:00',1.22),('3355','2013-09-09','13:30:00',1.26),('3355','2013-09-09','13:35:00',2.2),('3355','2013-09-09','13:40:00',2.09),('3355','2013-09-09','13:45:00',2.11),('3355','2013-09-09','13:50:00',2.11),('3355','2013-09-09','13:55:00',2.21),('3355','2013-09-09','14:00:00',2.05),('3355','2013-09-09','14:05:00',1.92),('3355','2013-09-09','14:10:00',1.71),('3355','2013-09-09','14:15:00',1.47),('3355','2013-09-09','14:20:00',1.23),('3355','2013-09-09','14:35:00',2.07),('3355','2013-09-09','14:40:00',1.59),('3355','2013-09-09','14:50:00',1.63),('3355','2013-09-09','14:55:00',1.78),('3355','2013-09-09','15:00:00',1.55),('3355','2013-09-09','15:05:00',1.35),('3355','2013-09-09','15:10:00',1.83),('3355','2013-09-09','15:20:00',1.07),('3355','2013-09-09','15:30:00',1.55),('3355','2013-09-09','15:35:00',1.3),('3355','2013-09-09','15:40:00',1.23),('3355','2013-09-09','16:15:00',1.23),('3355','2013-09-09','16:20:00',1.06),('3355','2013-09-09','16:45:00',1.27),('3355','2014-04-12','09:25:00',1.22),('3355','2014-04-12','10:30:00',1.06),('3355','2014-04-12','10:35:00',1.18),('3355','2014-04-12','10:40:00',1.38),('3355','2014-04-12','10:45:00',1.38),('3355','2014-04-12','10:50:00',1.34),('3355','2014-04-12','10:55:00',1.02),('3355','2014-04-12','11:00:00',1.46),('3355','2014-04-12','11:05:00',1.71),('3355','2014-04-12','11:10:00',2.11),('3355','2014-04-12','11:15:00',2.25),('3355','2014-04-12','11:20:00',2.14),('3355','2014-04-12','11:25:00',2.01),('3355','2014-04-12','11:30:00',1.77),('3355','2014-04-12','11:35:00',1.9),('3355','2014-04-12','11:40:00',2.05),('3355','2014-04-12','11:45:00',2.09),('3355','2014-04-12','11:50:00',1.81),('3355','2014-04-12','11:55:00',1.06),('3355','2014-04-12','12:00:00',1.04),('3355','2014-04-12','12:05:00',1.1),('3355','2014-04-12','12:30:00',1.51),('3355','2014-04-12','12:35:00',1.38),('3355','2014-04-12','12:40:00',1.57),('3355','2014-04-12','12:45:00',1.77),('3355','2014-04-12','12:50:00',1.74),('3355','2014-04-12','12:55:00',1.11),('3355','2014-04-12','13:10:00',1.52),('3355','2014-04-12','13:15:00',2.2),('3355','2014-04-12','13:20:00',2.38),('3355','2014-04-12','13:25:00',2.38),('3355','2014-04-12','13:30:00',1.85),('3355','2014-04-12','14:05:00',1.07),('3355','2014-04-12','14:10:00',1.72),('3355','2014-04-12','14:15:00',2.25),('3355','2014-04-12','14:20:00',1.59),('3355','2014-04-12','14:25:00',2.31),('3355','2014-04-12','14:30:00',1.89),('3355','2014-04-12','14:35:00',1.53),('3355','2014-04-12','14:40:00',1.52),('3355','2014-04-12','14:45:00',1.58),('3355','2014-04-12','14:50:00',2.17),('3355','2014-04-12','14:55:00',2.12),('3355','2014-04-12','15:00:00',1.96),('3355','2014-04-12','15:05:00',2.03),('3355','2014-04-12','15:10:00',2.04),('3355','2014-04-12','15:15:00',2.07),('3355','2014-04-12','15:20:00',1.76),('3355','2014-04-12','15:25:00',1.62),('3355','2014-04-12','15:30:00',1.12),('3355','2014-04-12','15:35:00',1.47),('3355','2014-04-12','15:40:00',1.71),('3355','2014-04-12','15:45:00',1.79),('3355','2014-04-12','15:50:00',2.03),('3355','2014-04-12','15:55:00',1.96),('3355','2014-04-12','16:00:00',1.95),('3355','2014-04-12','16:05:00',1.94),('3355','2014-04-12','16:10:00',1.92),('3355','2014-04-12','16:15:00',1.77),('3355','2014-04-12','16:20:00',1.9),('3355','2014-04-12','16:25:00',1.73),('3355','2014-04-12','16:30:00',1.67),('3355','2014-04-12','16:35:00',1.62),('3355','2014-04-12','16:40:00',1.1),('3355','2014-04-12','16:45:00',1.02),('3355','2014-04-12','16:55:00',1.07),('3355','2014-04-12','17:00:00',1.43),('3355','2014-04-12','17:05:00',1.32),('3355','2014-04-12','17:10:00',1.3),('3355','2014-04-12','17:15:00',1.22),('3355','2014-04-12','17:25:00',1.03),('3355','2014-04-12','17:50:00',1.01),('3355','2013-09-08','09:35:00',1.21),('3355','2013-09-08','09:45:00',1.13),('3355','2013-09-08','09:50:00',1.25),('3355','2013-09-08','09:55:00',1.28),('3355','2013-09-08','10:00:00',1.33),('3355','2013-09-08','10:05:00',1.37),('3355','2013-09-08','10:10:00',1.36),('3355','2013-09-08','10:15:00',1.42),('3355','2013-09-08','10:20:00',1.46),('3355','2013-09-08','10:25:00',1.49),('3355','2013-09-08','10:30:00',1.48),('3355','2013-09-08','10:35:00',1.54),('3355','2013-09-08','10:40:00',1.58),('3355','2013-09-08','10:45:00',1.61),('3355','2013-09-08','10:50:00',1.65),('3355','2013-09-08','10:55:00',1.68),('3355','2013-09-08','11:00:00',1.71),('3355','2013-09-08','11:05:00',1.7),('3355','2013-09-08','11:10:00',1.7),('3355','2013-09-08','11:15:00',1.73),('3355','2013-09-08','11:20:00',1.51),('3355','2013-09-08','11:25:00',1.72),('3355','2013-09-08','11:30:00',1.81),('3355','2013-09-08','11:35:00',1.84),('3355','2013-09-08','11:40:00',1.85),('3355','2013-09-08','11:45:00',1.87),('3355','2013-09-08','11:50:00',1.84),('3355','2013-09-08','11:55:00',1.86),('3355','2013-09-08','12:00:00',1.83),('3355','2013-09-08','12:05:00',1.82),('3355','2013-09-08','12:10:00',1.84),('3355','2013-09-08','12:15:00',1.9),('3355','2013-09-08','12:20:00',1.91),('3355','2013-09-08','12:25:00',1.92),('3355','2013-09-08','12:30:00',1.93),('3355','2013-09-08','12:35:00',1.98),('3355','2013-09-08','12:40:00',1.88),('3355','2013-09-08','12:45:00',1.82),('3355','2013-09-08','12:50:00',1.93),('3355','2013-09-08','12:55:00',1.96),('3355','2013-09-08','13:00:00',1.96),('3355','2013-09-08','13:05:00',1.99),('3355','2013-09-08','13:10:00',1.99),('3355','2013-09-08','13:15:00',1.95),('3355','2013-09-08','13:20:00',1.93),('3355','2013-09-08','13:25:00',1.89),('3355','2013-09-08','13:30:00',1.78),('3355','2013-09-08','13:35:00',1.75),('3355','2013-09-08','13:40:00',1.38),('3355','2013-09-08','13:45:00',1.13),('3355','2013-09-08','13:50:00',1.4),('3355','2013-09-08','13:55:00',1.51),('3355','2013-09-08','14:00:00',1.8),('3355','2013-09-08','14:05:00',1.86),('3355','2013-09-08','14:10:00',1.98),('3355','2013-09-08','14:15:00',1.81),('3355','2013-09-08','14:20:00',1.82),('3355','2013-09-08','14:25:00',2.16),('3355','2013-09-08','14:30:00',1.91),('3355','2013-09-08','14:35:00',2.03),('3355','2013-09-08','14:40:00',1.98),('3355','2013-09-08','14:45:00',1.96),('3355','2013-09-08','14:50:00',1.95),('3355','2013-09-08','14:55:00',1.91),('3355','2013-09-08','15:00:00',1.92),('3355','2013-09-08','15:05:00',1.68),('3355','2013-09-08','15:10:00',1.01),('3355','2013-09-08','15:15:00',1.4),('3355','2013-09-08','15:20:00',1.82),('3355','2013-09-08','15:25:00',1.84),('3355','2013-09-08','15:30:00',1.88),('3355','2013-09-08','15:35:00',1.81),('3355','2013-09-08','15:40:00',1.69),('3355','2013-09-08','15:45:00',1.7),('3355','2013-09-08','15:50:00',1.73),('3355','2013-09-08','15:55:00',1.39),('3355','2013-09-08','16:00:00',1.42),('3355','2013-09-08','16:05:00',1.44),('3355','2013-09-08','16:10:00',1.36),('3355','2013-09-08','16:15:00',1.39),('3355','2013-09-08','16:20:00',1.39),('3355','2013-09-08','16:25:00',1.38),('3355','2013-09-08','16:30:00',1.29),('3355','2013-09-08','16:35:00',1.31),('3355','2013-09-08','16:40:00',1.14),('3355','2013-09-08','17:05:00',1.17),('3355','2013-09-08','17:10:00',1.16),('3355','2013-09-08','17:15:00',1.05),('3355','2013-09-07','09:20:00',1.03),('3355','2013-09-07','09:25:00',1.08),('3355','2013-09-07','09:30:00',1.13),('3355','2013-09-07','09:35:00',1.16),('3355','2013-09-07','09:40:00',1.19),('3355','2013-09-07','09:45:00',1.23),('3355','2013-09-07','09:50:00',1.28),('3355','2013-09-07','09:55:00',1.32),('3355','2013-09-07','10:00:00',1.36),('3355','2013-09-07','10:05:00',1.39),('3355','2013-09-07','10:10:00',1.43),('3355','2013-09-07','10:15:00',1.46),('3355','2013-09-07','10:20:00',1.5),('3355','2013-09-07','10:25:00',1.54),('3355','2013-09-07','10:30:00',1.57),('3355','2013-09-07','10:35:00',1.58),('3355','2013-09-07','10:40:00',1.59),('3355','2013-09-07','10:45:00',1.61),('3355','2013-09-07','10:50:00',1.65),('3355','2013-09-07','10:55:00',1.67),('3355','2013-09-07','11:00:00',1.71),('3355','2013-09-07','11:05:00',1.73),('3355','2013-09-07','11:10:00',1.74),('3355','2013-09-07','11:15:00',1.79),('3355','2013-09-07','11:20:00',1.82),('3355','2013-09-07','11:25:00',1.84),('3355','2013-09-07','11:30:00',1.85),('3355','2013-09-07','11:35:00',1.88),('3355','2013-09-07','11:40:00',1.91),('3355','2013-09-07','11:45:00',1.91),('3355','2013-09-07','11:50:00',1.93),('3355','2013-09-07','11:55:00',1.94),('3355','2013-09-07','12:00:00',1.96),('3355','2013-09-07','12:05:00',1.97),('3355','2013-09-07','12:10:00',1.97),('3355','2013-09-07','12:15:00',1.98),('3355','2013-09-07','12:20:00',1.99),('3355','2013-09-07','12:25:00',2),('3355','2013-09-07','12:30:00',2),('3355','2013-09-07','12:35:00',2.02),('3355','2013-09-07','12:40:00',1.99),('3355','2013-09-07','12:45:00',1.99),('3355','2013-09-07','12:50:00',2.03),('3355','2013-09-07','12:55:00',2.05),('3355','2013-09-07','13:00:00',2.05),('3355','2013-09-07','13:05:00',2.03),('3355','2013-09-07','13:10:00',2.04),('3355','2013-09-07','13:15:00',1.95),('3355','2013-09-07','13:20:00',2.02),('3355','2013-09-07','13:25:00',2.03),('3355','2013-09-07','13:30:00',2.06),('3355','2013-09-07','13:35:00',2.08),('3355','2013-09-07','13:40:00',2.09),('3355','2013-09-07','13:45:00',1.84),('3355','2013-09-07','13:55:00',1.99),('3355','2013-09-07','14:00:00',2.09),('3355','2013-09-07','14:05:00',1.92),('3355','2013-09-07','14:10:00',2.07),('3355','2013-09-07','14:15:00',2.06),('3355','2013-09-07','14:20:00',2.05),('3355','2013-09-07','14:25:00',1.99),('3355','2013-09-07','14:30:00',1.92),('3355','2013-09-07','14:35:00',1.99),('3355','2013-09-07','14:40:00',1.97),('3355','2013-09-07','14:45:00',1.98),('3355','2013-09-07','14:50:00',1.96),('3355','2013-09-07','14:55:00',1.94),('3355','2013-09-07','15:00:00',1.93),('3355','2013-09-07','15:05:00',1.91),('3355','2013-09-07','15:10:00',1.87),('3355','2013-09-07','15:15:00',1.88),('3355','2013-09-07','15:20:00',1.84),('3355','2013-09-07','15:25:00',1.83),('3355','2013-09-07','15:30:00',1.81),('3355','2013-09-07','15:35:00',1.78),('3355','2013-09-07','15:40:00',1.74),('3355','2013-09-07','15:45:00',1.71),('3355','2013-09-07','15:50:00',1.68),('3355','2013-09-07','15:55:00',1.65),('3355','2013-09-07','16:00:00',1.62),('3355','2013-09-07','16:05:00',1.59),('3355','2013-09-07','16:10:00',1.55),('3355','2013-09-07','16:15:00',1.51),('3355','2013-09-07','16:20:00',1.47),('3355','2013-09-07','16:25:00',1.43),('3355','2013-09-07','16:30:00',1.39),('3355','2013-09-07','16:35:00',1.35),('3355','2013-09-07','16:40:00',1.32),('3355','2013-09-07','16:45:00',1.29),('3355','2013-09-07','16:50:00',1.24),('3355','2013-09-07','16:55:00',1.2),('3355','2013-09-07','17:00:00',1.15),('3355','2013-09-07','17:05:00',1.11),('3355','2013-09-07','17:10:00',1.05),('3355','2013-09-06','09:15:00',1.01),('3355','2013-09-06','09:20:00',1.06),('3355','2013-09-06','09:25:00',1.1),('3355','2013-09-06','09:30:00',1.14),('3355','2013-09-06','09:35:00',1.17),('3355','2013-09-06','09:40:00',1.22),('3355','2013-09-06','09:45:00',1.27),('3355','2013-09-06','09:50:00',1.31),('3355','2013-09-06','09:55:00',1.34),('3355','2013-09-06','10:00:00',1.38),('3355','2013-09-06','10:05:00',1.41),('3355','2013-09-06','10:10:00',1.44),('3355','2013-09-06','10:15:00',1.48),('3355','2013-09-06','10:20:00',1.51),('3355','2013-09-06','10:25:00',1.55),('3355','2013-09-06','10:30:00',1.59),('3355','2013-09-06','10:35:00',1.61),('3355','2013-09-06','10:40:00',1.66),('3355','2013-09-06','10:45:00',1.67),('3355','2013-09-06','10:50:00',1.7),('3355','2013-09-06','10:55:00',1.74),('3355','2013-09-06','11:00:00',1.76),('3355','2013-09-06','11:05:00',1.78),('3355','2013-09-06','11:10:00',1.8),('3355','2013-09-06','11:15:00',1.83),('3355','2013-09-06','11:20:00',1.87),('3355','2013-09-06','11:25:00',1.88),('3355','2013-09-06','11:30:00',1.89),('3355','2013-09-06','11:35:00',1.9),('3355','2013-09-06','11:40:00',1.92),('3355','2013-09-06','11:45:00',1.93),('3355','2013-09-06','11:50:00',1.95),('3355','2013-09-06','11:55:00',1.96),('3355','2013-09-06','12:00:00',1.96),('3355','2013-09-06','12:05:00',1.98),('3355','2013-09-06','12:10:00',1.99),('3355','2013-09-06','12:15:00',2.01),('3355','2013-09-06','12:20:00',2.05),('3355','2013-09-06','12:25:00',2.06),('3355','2013-09-06','12:30:00',2.07),('3355','2013-09-06','12:35:00',2.05),('3355','2013-09-06','12:40:00',2.02),('3355','2013-09-06','12:45:00',2.03),('3355','2013-09-06','12:50:00',2.04),('3355','2013-09-06','12:55:00',2.05),('3355','2013-09-06','13:00:00',2.07),('3355','2013-09-06','13:05:00',2.08),('3355','2013-09-06','13:10:00',2.07),('3355','2013-09-06','13:15:00',2.06),('3355','2013-09-06','13:20:00',2.07),('3355','2013-09-06','13:25:00',2.06),('3355','2013-09-06','13:30:00',2.02),('3355','2013-09-06','16:20:00',1.45),('3355','2013-09-06','16:25:00',1.44),('3355','2013-09-06','16:30:00',1.41),('3355','2013-09-06','16:35:00',1.38),('3355','2013-09-06','16:40:00',1.34),('3355','2013-09-06','16:45:00',1.29),('3355','2013-09-06','16:50:00',1.23),('3355','2013-09-06','16:55:00',1.21),('3355','2013-09-06','17:00:00',1.16),('3355','2013-09-06','17:05:00',1.1),('3355','2013-09-06','17:10:00',1.07),('3355','2013-09-06','17:15:00',1.02),('3355','2013-09-05','09:10:00',1.04),('3355','2013-09-05','09:15:00',1.08),('3355','2013-09-05','09:20:00',1.13),('3355','2013-09-05','09:25:00',1.18),('3355','2013-09-05','09:30:00',1.21),('3355','2013-09-05','09:35:00',1.26),('3355','2013-09-05','09:40:00',1.29),('3355','2013-09-05','09:45:00',1.34),('3355','2013-09-05','09:50:00',1.38),('3355','2013-09-05','09:55:00',1.42),('3355','2013-09-05','10:00:00',1.46),('3355','2013-09-05','10:05:00',1.49),('3355','2013-09-05','10:10:00',1.53),('3355','2013-09-05','10:15:00',1.56),('3355','2013-09-05','10:20:00',1.59),('3355','2013-09-05','10:25:00',1.62),('3355','2013-09-05','10:30:00',1.66),('3355','2013-09-05','10:35:00',1.68),('3355','2013-09-05','10:40:00',1.71),('3355','2013-09-05','10:45:00',1.74),('3355','2013-09-05','10:50:00',1.76),('3355','2013-09-05','10:55:00',1.78),('3355','2013-09-05','11:00:00',1.81),('3355','2013-09-05','11:05:00',1.84),('3355','2013-09-05','11:10:00',1.86),('3355','2013-09-05','11:15:00',1.88),('3355','2013-09-05','11:20:00',1.9),('3355','2013-09-05','11:25:00',1.92),('3355','2013-09-05','11:30:00',1.93),('3355','2013-09-05','11:35:00',1.94),('3355','2013-09-05','11:40:00',1.94),('3355','2013-09-05','11:45:00',1.94),('3355','2013-09-05','11:50:00',2),('3355','2013-09-05','11:55:00',2.02),('3355','2013-09-05','12:00:00',2.02),('3355','2013-09-05','12:05:00',2.04),('3355','2013-09-05','12:10:00',2.05),('3355','2013-09-05','12:15:00',2.07),('3355','2013-09-05','12:20:00',2.08),('3355','2013-09-05','12:25:00',2.07),('3355','2013-09-05','12:30:00',2.07),('3355','2013-09-05','12:35:00',2.09),('3355','2013-09-05','12:40:00',2.09),('3355','2013-09-05','12:45:00',2.1),('3355','2013-09-05','12:50:00',2.1),('3355','2013-09-05','12:55:00',2.1),('3355','2013-09-05','13:00:00',2.11),('3355','2013-09-05','13:05:00',2.12),('3355','2013-09-05','13:10:00',2.12),('3355','2013-09-05','13:15:00',2.11),('3355','2013-09-05','13:20:00',2.11),('3355','2013-09-05','13:25:00',2.13),('3355','2013-09-05','13:30:00',2.13),('3355','2013-09-05','13:35:00',2.13),('3355','2013-09-05','13:40:00',2.13),('3355','2013-09-05','13:45:00',2.13),('3355','2013-09-05','13:50:00',2.12),('3355','2013-09-05','13:55:00',2.09),('3355','2013-09-05','14:00:00',2.08),('3355','2013-09-05','14:05:00',2.08),('3355','2013-09-05','14:10:00',2.07),('3355','2013-09-05','14:15:00',2.05),('3355','2013-09-05','14:20:00',2.05),('3355','2013-09-05','14:25:00',2.03),('3355','2013-09-05','14:30:00',2.02),('3355','2013-09-05','14:35:00',1.99),('3355','2013-09-05','14:40:00',1.96),('3355','2013-09-05','14:45:00',1.94),('3355','2013-09-05','14:50:00',1.95),('3355','2013-09-05','14:55:00',1.94),('3355','2013-09-05','15:00:00',1.95),('3355','2013-09-05','15:05:00',1.95),('3355','2013-09-05','15:10:00',1.93),('3355','2013-09-05','15:15:00',1.89),('3355','2013-09-05','15:20:00',1.87),('3355','2013-09-05','15:25:00',1.85),('3355','2013-09-05','15:30:00',1.82),('3355','2013-09-05','15:35:00',1.79),('3355','2013-09-05','15:40:00',1.77),('3355','2013-09-05','15:45:00',1.73),('3355','2013-09-05','15:50:00',1.71),('3355','2013-09-05','15:55:00',1.7),('3355','2013-09-05','16:00:00',1.68),('3355','2013-09-05','16:05:00',1.64),('3355','2013-09-05','16:10:00',1.62),('3355','2013-09-05','16:15:00',1.6),('3355','2013-09-05','16:20:00',1.57),('3355','2013-09-05','16:25:00',1.53),('3355','2013-09-05','16:30:00',1.51),('3355','2013-09-05','16:35:00',1.49),('3355','2013-09-05','16:40:00',1.48),('3355','2013-09-05','16:45:00',1.45),('3355','2013-09-05','16:50:00',1.26),('3355','2013-09-04','09:10:00',1.04),('3355','2013-09-04','09:15:00',1.09),('3355','2013-09-04','09:20:00',1.15),('3355','2013-09-04','09:25:00',1.19),('3355','2013-09-04','09:30:00',1.23),('3355','2013-09-04','09:35:00',1.28),('3355','2013-09-04','09:40:00',1.33),('3355','2013-09-04','09:45:00',1.38),('3355','2013-09-04','09:50:00',1.42),('3355','2013-09-04','09:55:00',1.46),('3355','2013-09-04','10:00:00',1.49),('3355','2013-09-04','10:05:00',1.53),('3355','2013-09-04','10:10:00',1.57),('3355','2013-09-04','10:15:00',1.6),('3355','2013-09-04','10:20:00',1.64),('3355','2013-09-04','10:25:00',1.66),('3355','2013-09-04','10:30:00',1.7),('3355','2013-09-04','10:35:00',1.73),('3355','2013-09-04','10:40:00',1.76),('3355','2013-09-04','10:45:00',1.78),('3355','2013-09-04','10:50:00',1.81),('3355','2013-09-04','10:55:00',1.85),('3355','2013-09-04','11:00:00',1.87),('3355','2013-09-04','11:05:00',1.91),('3355','2013-09-04','11:10:00',1.92),('3355','2013-09-04','11:15:00',1.94),('3355','2013-09-04','11:20:00',1.96),('3355','2013-09-04','11:25:00',1.98),('3355','2013-09-04','11:30:00',2),('3355','2013-09-04','11:35:00',2.02),('3355','2013-09-04','11:40:00',2.04),('3355','2013-09-04','11:45:00',2.06),('3355','2013-09-04','11:50:00',2.09),('3355','2013-09-04','11:55:00',2.11),('3355','2013-09-04','12:00:00',2.11),('3355','2013-09-04','12:05:00',2.11),('3355','2013-09-04','12:10:00',2.12),('3355','2013-09-04','12:15:00',2.13),('3355','2013-09-04','12:20:00',2.15),('3355','2013-09-04','12:25:00',2.15),('3355','2013-09-04','12:30:00',2.17),('3355','2013-09-04','12:35:00',2.19),('3355','2013-09-04','12:40:00',2.2),('3355','2013-09-04','12:45:00',2.2),('3355','2013-09-04','12:50:00',2.19),('3355','2013-09-04','12:55:00',2.21),('3355','2013-09-04','13:00:00',2.2),('3355','2013-09-04','13:05:00',2.21),('3355','2013-09-04','13:10:00',2.2),('3355','2013-09-04','13:15:00',2.19),('3355','2013-09-04','13:20:00',2.19),('3355','2013-09-04','13:25:00',2.2),('3355','2013-09-04','13:30:00',2.2),('3355','2013-09-04','13:35:00',2.2),('3355','2013-09-04','13:40:00',2.2),('3355','2013-09-04','13:45:00',2.19),('3355','2013-09-04','13:50:00',2.19),('3355','2013-09-04','13:55:00',2.17),('3355','2013-09-04','14:00:00',2.17),('3355','2013-09-04','14:05:00',2.17),('3355','2013-09-04','14:10:00',2.16),('3355','2013-09-04','14:15:00',2.15),('3355','2013-09-04','14:20:00',2.13),('3355','2013-09-04','14:25:00',2.13),('3355','2013-09-04','14:30:00',2.12),('3355','2013-09-04','14:35:00',2.1),('3355','2013-09-04','14:40:00',2.09),('3355','2013-09-04','14:45:00',2.07),('3355','2013-09-04','14:50:00',2.06),('3355','2013-09-04','14:55:00',2.04),('3355','2013-09-04','15:00:00',2.02),('3355','2013-09-04','15:05:00',2.01),('3355','2013-09-04','15:10:00',1.98),('3355','2013-09-04','15:15:00',1.97),('3355','2013-09-04','15:20:00',1.95),('3355','2013-09-04','15:25:00',1.92),('3355','2013-09-04','15:30:00',1.89),('3355','2013-09-04','15:35:00',1.85),('3355','2013-09-04','15:40:00',1.84),('3355','2013-09-04','15:45:00',1.82),('3355','2013-09-04','15:50:00',1.78),('3355','2013-09-04','15:55:00',1.74),('3355','2013-09-04','16:00:00',1.71),('3355','2013-09-04','16:05:00',1.67),('3355','2013-09-04','16:10:00',1.63),('3355','2013-09-04','16:15:00',1.61),('3355','2013-09-04','16:20:00',1.57),('3355','2013-09-04','16:25:00',1.55),('3355','2013-09-04','16:30:00',1.51),('3355','2013-09-04','16:35:00',1.47),('3355','2013-09-04','16:40:00',1.42),('3355','2013-09-04','16:45:00',1.39),('3355','2013-09-04','16:50:00',1.35),('3355','2013-09-04','16:55:00',1.31),('3355','2013-09-04','17:00:00',1.26),('3355','2013-09-04','17:05:00',1.22),('3355','2013-09-04','17:10:00',1.18),('3355','2013-09-04','17:15:00',1.13),('3355','2013-09-04','17:20:00',1.09),('3355','2013-09-04','17:25:00',1.04),('3355','2013-09-03','09:15:00',1.01),('3355','2013-09-03','09:20:00',1.06),('3355','2013-09-03','09:25:00',1.11),('3355','2013-09-03','09:30:00',1.15),('3355','2013-09-03','09:35:00',1.19),('3355','2013-09-03','09:40:00',1.23),('3355','2013-09-03','09:45:00',1.28),('3355','2013-09-03','09:50:00',1.32),('3355','2013-09-03','09:55:00',1.35),('3355','2013-09-03','10:00:00',1.38),('3355','2013-09-03','10:05:00',1.42),('3355','2013-09-03','10:10:00',1.45),('3355','2013-09-03','10:15:00',1.49),('3355','2013-09-03','10:20:00',1.53),('3355','2013-09-03','10:25:00',1.57),('3355','2013-09-03','10:30:00',1.6),('3355','2013-09-03','10:35:00',1.65),('3355','2013-09-03','10:40:00',1.7),('3355','2013-09-03','10:45:00',1.74),('3355','2013-09-03','10:50:00',1.75),('3355','2013-09-03','10:55:00',1.77),('3355','2013-09-03','11:00:00',1.79),('3355','2013-09-03','11:05:00',1.81),('3355','2013-09-03','11:10:00',1.84),('3355','2013-09-03','11:15:00',1.86),('3355','2013-09-03','11:20:00',1.88),('3355','2013-09-03','11:25:00',1.91),('3355','2013-09-03','11:30:00',1.92),('3355','2013-09-03','11:35:00',1.93),('3355','2013-09-03','11:40:00',1.95),('3355','2013-09-03','11:45:00',1.96),('3355','2013-09-03','11:50:00',1.98),('3355','2013-09-03','11:55:00',2.01),('3355','2013-09-03','12:00:00',2.02),('3355','2013-09-03','12:05:00',2.05),('3355','2013-09-03','12:10:00',2.07),('3355','2013-09-03','12:15:00',2.08),('3355','2013-09-03','12:20:00',2.09),('3355','2013-09-03','12:25:00',2.11),('3355','2013-09-03','12:30:00',2.12),('3355','2013-09-03','12:35:00',2.12),('3355','2013-09-03','12:40:00',2.13),('3355','2013-09-03','12:45:00',2.14),('3355','2013-09-03','12:50:00',2.13),('3355','2013-09-03','12:55:00',2.14),('3355','2013-09-03','13:00:00',2.15),('3355','2013-09-03','13:05:00',2.15),('3355','2013-09-03','13:10:00',2.14),('3355','2013-09-03','13:15:00',2.14),('3355','2013-09-03','13:20:00',2.14),('3355','2013-09-03','13:25:00',2.12),('3355','2013-09-03','13:30:00',2.14),('3355','2013-09-03','13:35:00',2.14),('3355','2013-09-03','13:40:00',2.11),('3355','2013-09-03','13:45:00',2.13),('3355','2013-09-03','13:50:00',2.13),('3355','2013-09-03','13:55:00',2.11),('3355','2013-09-03','14:00:00',2.07),('3355','2013-09-03','14:05:00',2.06),('3355','2013-09-03','14:10:00',2.06),('3355','2013-09-03','14:15:00',2.07),('3355','2013-09-03','14:20:00',2.06),('3355','2013-09-03','14:25:00',2.05),('3355','2013-09-03','14:30:00',2.04),('3355','2013-09-03','14:35:00',2.05),('3355','2013-09-03','14:40:00',2.04),('3355','2013-09-03','14:45:00',2.03),('3355','2013-09-03','14:50:00',2.02),('3355','2013-09-03','14:55:00',1.99),('3355','2013-09-03','15:00:00',1.97),('3355','2013-09-03','15:05:00',1.93),('3355','2013-09-03','15:10:00',1.93),('3355','2013-09-03','15:15:00',1.92),('3355','2013-09-03','15:20:00',1.88),('3355','2013-09-03','15:25:00',1.86),('3355','2013-09-03','15:30:00',1.82),('3355','2013-09-03','15:35:00',1.79),('3355','2013-09-03','15:40:00',1.77),('3355','2013-09-03','15:45:00',1.76),('3355','2013-09-03','15:50:00',1.74),('3355','2013-09-03','15:55:00',1.72),('3355','2013-09-03','16:00:00',1.69),('3355','2013-09-03','16:05:00',1.65),('3355','2013-09-03','16:10:00',1.61),('3355','2013-09-03','16:15:00',1.58),('3355','2013-09-03','16:20:00',1.55),('3355','2013-09-03','16:25:00',1.52),('3355','2013-09-03','16:30:00',1.49),('3355','2013-09-03','16:35:00',1.45),('3355','2013-09-03','16:40:00',1.41),('3355','2013-09-03','16:45:00',1.37),('3355','2013-09-03','16:50:00',1.34),('3355','2013-09-03','16:55:00',1.31),('3355','2013-09-03','17:00:00',1.26),('3355','2013-09-03','17:05:00',1.22),('3355','2013-09-03','17:10:00',1.17),('3355','2013-09-03','17:15:00',1.12),('3355','2013-09-03','17:20:00',1.09),('3355','2013-09-03','17:25:00',1.03),('3355','2013-09-02','09:15:00',1.04),('3355','2013-09-02','09:20:00',1.09),('3355','2013-09-02','09:25:00',1.14),('3355','2013-09-02','09:30:00',1.18),('3355','2013-09-02','09:35:00',1.23),('3355','2013-09-02','09:40:00',1.27),('3355','2013-09-02','09:45:00',1.3),('3355','2013-09-02','09:50:00',1.35),('3355','2013-09-02','09:55:00',1.38),('3355','2013-09-02','10:00:00',1.42),('3355','2013-09-02','10:05:00',1.46),('3355','2013-09-02','10:10:00',1.5),('3355','2013-09-02','10:15:00',1.54),('3355','2013-09-02','10:20:00',1.58),('3355','2013-09-02','10:25:00',1.6),('3355','2013-09-02','10:30:00',1.63),('3355','2013-09-02','10:35:00',1.66),('3355','2013-09-02','10:40:00',1.69),('3355','2013-09-02','10:45:00',1.72),('3355','2013-09-02','10:50:00',1.74),('3355','2013-09-02','10:55:00',1.78),('3355','2013-09-02','11:00:00',1.8),('3355','2013-09-02','11:05:00',1.83),('3355','2013-09-02','11:10:00',1.85),('3355','2013-09-02','11:15:00',1.87),('3355','2013-09-02','11:20:00',1.89),('3355','2013-09-02','11:25:00',1.92),('3355','2013-09-02','11:30:00',1.94),('3355','2013-09-02','11:35:00',1.96),('3355','2013-09-02','11:40:00',1.97),('3355','2013-09-02','11:45:00',1.98),('3355','2013-09-02','11:50:00',2.01),('3355','2013-09-02','11:55:00',2.01),('3355','2013-09-02','12:00:00',2.02),('3355','2013-09-02','12:05:00',2.04),('3355','2013-09-02','12:10:00',2.05),('3355','2013-09-02','12:15:00',2.07),('3355','2013-09-02','12:20:00',2.08),('3355','2013-09-02','12:25:00',2.07),('3355','2013-09-02','12:30:00',2.07),('3355','2013-09-02','12:35:00',2.08),('3355','2013-09-02','12:40:00',2.09),('3355','2013-09-02','12:45:00',2.08),('3355','2013-09-02','12:50:00',2.09),('3355','2013-09-02','12:55:00',2.09),('3355','2013-09-02','13:00:00',2.12),('3355','2013-09-02','13:05:00',2.12),('3355','2013-09-02','13:10:00',2.11),('3355','2013-09-02','13:15:00',2.13),('3355','2013-09-02','13:20:00',2.14),('3355','2013-09-02','13:25:00',2.13),('3355','2013-09-02','13:30:00',2.12),('3355','2013-09-02','13:35:00',2.1),('3355','2013-09-02','13:40:00',2.09),('3355','2013-09-02','13:45:00',1.91),('3355','2013-09-02','14:00:00',2.24),('3355','2013-09-02','14:05:00',2.15),('3355','2013-09-02','14:10:00',2.01),('3355','2013-09-02','14:15:00',2.09),('3355','2013-09-02','14:20:00',2.08),('3355','2013-09-02','14:25:00',2.07),('3355','2013-09-02','14:30:00',2.1),('3355','2013-09-02','14:35:00',2.06),('3355','2013-09-02','14:40:00',2.06),('3355','2013-09-02','14:45:00',2.08),('3355','2013-09-02','14:50:00',2.09),('3355','2013-09-02','14:55:00',2),('3355','2013-09-02','15:00:00',1.78),('3355','2013-09-02','15:05:00',1.78),('3355','2013-09-02','15:10:00',1.38),('3355','2013-09-02','15:15:00',1.97),('3355','2013-09-02','15:20:00',1.89),('3355','2013-09-02','15:25:00',1.51),('3355','2013-09-02','15:35:00',1.79),('3355','2013-09-02','15:40:00',1.85),('3355','2013-09-02','15:45:00',1.83),('3355','2013-09-02','15:50:00',1.79),('3355','2013-09-02','15:55:00',1.77),('3355','2013-09-02','16:00:00',1.71),('3355','2013-09-02','16:05:00',1.65),('3355','2013-09-02','16:10:00',1.63),('3355','2013-09-02','16:15:00',1.63),('3355','2013-09-02','16:20:00',1.61),('3355','2013-09-02','16:25:00',1.56),('3355','2013-09-02','16:30:00',1.51),('3355','2013-09-02','16:35:00',1.44),('3355','2013-09-02','16:40:00',1.38),('3355','2013-09-02','16:45:00',1.34),('3355','2013-09-02','16:50:00',1.3),('3355','2013-09-02','16:55:00',1.23),('3355','2013-09-02','17:00:00',1.18),('3355','2013-09-02','17:05:00',1.16),('3355','2013-09-02','17:10:00',1.11),('3355','2013-09-02','17:15:00',1.08),('3355','2013-09-02','17:20:00',1.02),('3355','2013-09-01','09:10:00',1.02),('3355','2013-09-01','09:15:00',1.07),('3355','2013-09-01','09:20:00',1.11),('3355','2013-09-01','09:25:00',1.16),('3355','2013-09-01','09:30:00',1.21),('3355','2013-09-01','09:35:00',1.25),('3355','2013-09-01','09:40:00',1.29),('3355','2013-09-01','09:45:00',1.33),('3355','2013-09-01','09:50:00',1.37),('3355','2013-09-01','09:55:00',1.4),('3355','2013-09-01','10:00:00',1.44),('3355','2013-09-01','10:05:00',1.47),('3355','2013-09-01','10:10:00',1.51),('3355','2013-09-01','10:15:00',1.54),('3355','2013-09-01','10:20:00',1.58),('3355','2013-09-01','10:25:00',1.61),('3355','2013-09-01','10:30:00',1.64),('3355','2013-09-01','10:35:00',1.67),('3355','2013-09-01','10:40:00',1.7),('3355','2013-09-01','10:45:00',1.73),('3355','2013-09-01','10:50:00',1.74),('3355','2013-09-01','10:55:00',1.77),('3355','2013-09-01','11:00:00',1.81),('3355','2013-09-01','11:05:00',1.85),('3355','2013-09-01','11:10:00',1.86),('3355','2013-09-01','11:15:00',1.87),('3355','2013-09-01','11:20:00',1.89),('3355','2013-09-01','11:25:00',1.91),('3355','2013-09-01','11:30:00',1.93),('3355','2013-09-01','11:35:00',1.97),('3355','2013-09-01','11:40:00',1.99),('3355','2013-09-01','11:45:00',2.01),('3355','2013-09-01','11:50:00',2.02),('3355','2013-09-01','11:55:00',2.04),('3355','2013-09-01','12:00:00',2.04),('3355','2013-09-01','12:05:00',1.97),('3355','2013-09-01','12:10:00',2.05),('3355','2013-09-01','12:15:00',2.06),('3355','2013-09-01','12:20:00',2.09),('3355','2013-09-01','12:25:00',2.04),('3355','2013-09-01','12:30:00',2.09),('3355','2013-09-01','12:35:00',2.1),('3355','2013-09-01','12:40:00',2.11),('3355','2013-09-01','12:45:00',2.1),('3355','2013-09-01','12:50:00',2.11),('3355','2013-09-01','12:55:00',2.11),('3355','2013-09-01','13:00:00',2.14),('3355','2013-09-01','13:05:00',2.14),('3355','2013-09-01','13:10:00',2.15),('3355','2013-09-01','13:15:00',1.85),('3355','2013-09-01','13:20:00',2.17),('3355','2013-09-01','13:25:00',2.18),('3355','2013-09-01','13:30:00',2.17),('3355','2013-09-01','13:35:00',2.16),('3355','2013-09-01','13:40:00',2.15),('3355','2013-09-01','13:45:00',2.14),('3355','2013-09-01','13:50:00',1.88),('3355','2013-09-01','13:55:00',1.9),('3355','2013-09-01','14:00:00',1.72),('3355','2013-09-01','14:05:00',1.64),('3355','2013-09-01','14:10:00',1.93),('3355','2013-09-01','14:15:00',1.98),('3355','2013-09-01','14:20:00',1.87),('3355','2013-09-01','14:25:00',1.8),('3355','2013-09-01','14:30:00',1.87),('3355','2013-09-01','14:35:00',1.82),('3355','2013-09-01','14:40:00',1.84),('3355','2013-09-01','14:45:00',1.87),('3355','2013-09-01','14:50:00',1.89),('3355','2013-09-01','14:55:00',1.83),('3355','2013-09-01','15:00:00',1.83),('3355','2013-09-01','15:05:00',1.82),('3355','2013-09-01','15:10:00',1.76),('3355','2013-09-01','15:15:00',1.7),('3355','2013-09-01','15:20:00',1.63),('3355','2013-09-01','15:25:00',1.48),('3355','2013-09-01','15:30:00',1.18),('3355','2013-09-01','15:35:00',1.36),('3355','2013-09-01','15:40:00',1.58),('3355','2013-09-01','15:45:00',1.35),('3355','2013-09-01','15:50:00',1.02),('3355','2013-09-01','15:55:00',1.3),('3355','2013-09-01','16:00:00',1.39),('3355','2013-09-01','16:05:00',1.54),('3355','2013-09-01','16:10:00',1.65),('3355','2013-09-01','16:15:00',1.54),('3355','2013-09-01','16:20:00',1.48),('3355','2013-09-01','16:25:00',1.4),('3355','2013-09-01','16:30:00',1.58),('3355','2013-09-01','16:35:00',1.48),('3355','2013-09-01','16:40:00',1.45),('3355','2013-09-01','16:45:00',1.38),('3355','2013-09-01','16:50:00',1.28),('3355','2013-09-01','16:55:00',1.19),('3355','2013-08-31','09:00:00',1.05),('3355','2013-08-31','09:20:00',1.11),('3355','2013-08-31','09:25:00',1.23),('3355','2013-08-31','09:30:00',1.27),('3355','2013-08-31','09:35:00',1.33),('3355','2013-08-31','09:40:00',1.37),('3355','2013-08-31','09:45:00',1.3),('3355','2013-08-31','09:50:00',1.32),('3355','2013-08-31','09:55:00',1.41),('3355','2013-08-31','10:00:00',1.51),('3355','2013-08-31','10:05:00',1.51),('3355','2013-08-31','10:10:00',1.59),('3355','2013-08-31','10:15:00',1.59),('3355','2013-08-31','10:20:00',1.62),('3355','2013-08-31','10:25:00',1.64),('3355','2013-08-31','10:30:00',1.69),('3355','2013-08-31','10:35:00',1.75),('3355','2013-08-31','10:40:00',1.76),('3355','2013-08-31','10:45:00',1.79),('3355','2013-08-31','10:50:00',1.85),('3355','2013-08-31','10:55:00',1.87),('3355','2013-08-31','11:00:00',1.91),('3355','2013-08-31','11:05:00',1.93),('3355','2013-08-31','11:10:00',1.95),('3355','2013-08-31','11:15:00',1.98),('3355','2013-08-31','11:20:00',2),('3355','2013-08-31','11:25:00',2.02),('3355','2013-08-31','11:30:00',2.03),('3355','2013-08-31','11:35:00',2.06),('3355','2013-08-31','11:40:00',2.09),('3355','2013-08-31','11:45:00',2.12),('3355','2013-08-31','11:50:00',2.13),('3355','2013-08-31','11:55:00',2.13),('3355','2013-08-31','12:00:00',1.81),('3355','2013-08-31','12:05:00',1.46),('3355','2013-08-31','12:10:00',1.82),('3355','2013-08-31','12:15:00',2.14),('3355','2013-08-31','12:20:00',2.14),('3355','2013-08-31','12:25:00',2.12),('3355','2013-08-31','12:30:00',2.15),('3355','2013-08-31','12:35:00',2.14),('3355','2013-08-31','12:40:00',2.17),('3355','2013-08-31','12:45:00',2.15),('3355','2013-08-31','12:50:00',2.15),('3355','2013-08-31','12:55:00',2.17),('3355','2013-08-31','13:00:00',2.18),('3355','2013-08-31','13:05:00',2.2),('3355','2013-08-31','13:10:00',2.18),('3355','2013-08-31','13:15:00',2.18),('3355','2013-08-31','13:20:00',2.19),('3355','2013-08-31','13:25:00',2.18),('3355','2013-08-31','13:30:00',2.18),('3355','2013-08-31','13:35:00',2.17),('3355','2013-08-31','13:40:00',2.15),('3355','2013-08-31','13:45:00',2.15),('3355','2013-08-31','13:50:00',2.15),('3355','2013-08-31','13:55:00',2.13),('3355','2013-08-31','14:00:00',2.15),('3355','2013-08-31','14:05:00',2.14),('3355','2013-08-31','14:10:00',2.12),('3355','2013-08-31','14:15:00',2.1),('3355','2013-08-31','14:20:00',2.08),('3355','2013-08-31','14:25:00',2.06),('3355','2013-08-31','14:30:00',2.05),('3355','2013-08-31','14:35:00',1.97),('3355','2013-08-31','14:40:00',1.98),('3355','2013-08-31','14:45:00',1.98),('3355','2013-08-31','14:50:00',1.99),('3355','2013-08-31','14:55:00',1.94),('3355','2013-08-31','15:00:00',1.93),('3355','2013-08-31','15:05:00',1.94),('3355','2013-08-31','15:10:00',1.92),('3355','2013-08-31','15:15:00',1.89),('3355','2013-08-31','15:20:00',1.85),('3355','2013-08-31','15:25:00',1.82),('3355','2013-08-31','15:30:00',1.81),('3355','2013-08-31','15:35:00',1.77),('3355','2013-08-31','15:40:00',1.78),('3355','2013-08-31','15:45:00',1.75),('3355','2013-08-31','15:50:00',1.71),('3355','2013-08-31','15:55:00',1.68),('3355','2013-08-31','16:00:00',1.65),('3355','2013-08-31','16:05:00',1.62),('3355','2013-08-31','16:10:00',1.61),('3355','2013-08-31','16:15:00',1.58),('3355','2013-08-31','16:20:00',1.54),('3355','2013-08-31','16:25:00',1.51),('3355','2013-08-31','16:30:00',1.44),('3355','2013-08-31','16:35:00',1.45),('3355','2013-08-31','16:40:00',1.41),('3355','2013-08-31','16:45:00',1.34),('3355','2013-08-31','16:50:00',1.3),('3355','2013-08-31','16:55:00',1.27),('3355','2013-08-31','17:00:00',1.21),('3355','2013-08-31','17:05:00',1.21),('3355','2013-08-31','17:10:00',1.18),('3355','2013-08-31','17:15:00',1.13),('3355','2013-08-31','17:20:00',1.06),('3355','2013-08-31','17:25:00',1.01),('3355','2013-08-30','10:00:00',1.01),('3355','2013-08-30','10:05:00',1.02),('3355','2013-08-30','10:10:00',1.01),('3355','2013-08-30','10:15:00',1.06),('3355','2013-08-30','10:20:00',1.14),('3355','2013-08-30','10:25:00',1.05),('3355','2013-08-30','10:30:00',1.17),('3355','2013-08-30','10:35:00',1.12),('3355','2013-08-30','10:40:00',1.06),('3355','2013-08-30','10:45:00',1.03),('3355','2013-08-30','10:50:00',1.09),('3355','2013-08-30','10:55:00',1.04),('3355','2013-08-30','11:00:00',1.09),('3355','2013-08-30','11:05:00',1.17),('3355','2013-08-30','11:10:00',1.22),('3355','2013-08-30','11:15:00',1.25),('3355','2013-08-30','11:20:00',1.24),('3355','2013-08-30','11:25:00',1.28),('3355','2013-08-30','11:30:00',1.37),('3355','2013-08-30','11:35:00',1.31),('3355','2013-08-30','11:40:00',1.42),('3355','2013-08-30','11:45:00',1.38),('3355','2013-08-30','11:50:00',1.62),('3355','2013-08-30','11:55:00',1.43),('3355','2013-08-30','12:00:00',1.29),('3355','2013-08-30','12:05:00',1.09),('3355','2013-08-30','12:10:00',1.18),('3355','2013-08-30','12:15:00',1.3),('3355','2013-08-30','12:20:00',1.41),('3355','2013-08-30','12:25:00',1.6),('3355','2013-08-30','12:30:00',1.76),('3355','2013-08-30','12:35:00',1.7),('3355','2013-08-30','12:40:00',1.64),('3355','2013-08-30','12:45:00',1.71),('3355','2013-08-30','12:50:00',1.69),('3355','2013-08-30','12:55:00',1.58),('3355','2013-08-30','13:00:00',1.53),('3355','2013-08-30','13:05:00',1.52),('3355','2013-08-30','13:10:00',1.54),('3355','2013-08-30','13:15:00',1.48),('3355','2013-08-30','13:20:00',1.72),('3355','2013-08-30','13:25:00',2),('3355','2013-08-30','13:30:00',2.15),('3355','2013-08-30','13:35:00',2),('3355','2013-08-30','13:40:00',2.14),('3355','2013-08-30','13:45:00',1.93),('3355','2013-08-30','13:50:00',1.94),('3355','2013-08-30','13:55:00',2.11),('3355','2013-08-30','14:00:00',2.18),('3355','2013-08-30','14:05:00',2.11),('3355','2013-08-30','14:10:00',2.13),('3355','2013-08-30','14:15:00',2.14),('3355','2013-08-30','14:20:00',2.09),('3355','2013-08-30','14:25:00',2.14),('3355','2013-08-30','14:30:00',2.1),('3355','2013-08-30','14:35:00',2.13),('3355','2013-08-30','14:40:00',2.07),('3355','2013-08-30','14:45:00',1.68),('3355','2013-08-30','14:50:00',1.37),('3355','2013-08-30','14:55:00',1.6),('3355','2013-08-30','15:00:00',1.4),('3355','2013-08-30','15:05:00',1.27),('3355','2013-08-30','15:10:00',1.28),('3355','2013-08-30','15:15:00',1.57),('3355','2013-08-30','15:20:00',1.37),('3355','2013-08-30','15:25:00',1.21),('3355','2013-08-30','15:30:00',1.17),('3355','2013-08-30','15:40:00',1.01),('3355','2013-08-30','15:45:00',1.2),('3355','2013-08-30','15:50:00',1.31),('3355','2013-08-30','15:55:00',1.32),('3355','2013-08-30','16:00:00',1.24),('3355','2013-08-30','16:05:00',1.09),('3355','2013-08-30','16:40:00',1.38),('3355','2013-08-30','16:45:00',1.42),('3355','2013-08-30','16:50:00',1.33),('3355','2014-04-11','09:00:00',1.01),('3355','2014-04-11','09:05:00',1.05),('3355','2014-04-11','09:10:00',1.08),('3355','2014-04-11','09:15:00',1.13),('3355','2014-04-11','09:20:00',1.17),('3355','2014-04-11','09:25:00',1.23),('3355','2014-04-11','09:30:00',1.28),('3355','2014-04-11','09:35:00',1.32),('3355','2014-04-11','09:40:00',1.37),('3355','2014-04-11','09:45:00',1.41),('3355','2014-04-11','09:50:00',1.45),('3355','2014-04-11','09:55:00',1.48),('3355','2014-04-11','10:00:00',1.53),('3355','2014-04-11','10:05:00',1.58),('3355','2014-04-11','10:10:00',1.64),('3355','2014-04-11','10:15:00',1.69),('3355','2014-04-11','10:20:00',1.71),('3355','2014-04-11','10:25:00',1.75),('3355','2014-04-11','10:30:00',1.78),('3355','2014-04-11','10:35:00',1.81),('3355','2014-04-11','10:40:00',1.82),('3355','2014-04-11','10:45:00',1.88),('3355','2014-04-11','10:50:00',1.93),('3355','2014-04-11','10:55:00',1.97),('3355','2014-04-11','11:00:00',2.01),('3355','2014-04-11','11:05:00',2.03),('3355','2014-04-11','11:10:00',2.06),('3355','2014-04-11','11:15:00',2.07),('3355','2014-04-11','11:20:00',2.06),('3355','2014-04-11','11:25:00',2.1),('3355','2014-04-11','11:30:00',2.12),('3355','2014-04-11','11:35:00',2.13),('3355','2014-04-11','11:40:00',2.13),('3355','2014-04-11','11:45:00',2.22),('3355','2014-04-11','11:50:00',2.24),('3355','2014-04-11','11:55:00',2.3),('3355','2014-04-11','12:00:00',2.37),('3355','2014-04-11','12:05:00',2.28),('3355','2014-04-11','12:10:00',2.41),('3355','2014-04-11','12:15:00',2.38),('3355','2014-04-11','12:20:00',2.27),('3355','2014-04-11','12:25:00',1.61),('3355','2014-04-11','12:30:00',2.4),('3355','2014-04-11','12:35:00',2.42),('3355','2014-04-11','12:40:00',2.48),('3355','2014-04-11','12:45:00',2.57),('3355','2014-04-11','12:50:00',2.25),('3355','2014-04-11','12:55:00',2.46),('3355','2014-04-11','13:00:00',2.46),('3355','2014-04-11','13:05:00',1.56),('3355','2014-04-11','13:10:00',2.4),('3355','2014-04-11','13:15:00',2.05),('3355','2014-04-11','13:20:00',1.26),('3355','2014-04-11','13:25:00',2.09),('3355','2014-04-11','13:30:00',2.22),('3355','2014-04-11','13:35:00',1.31),('3355','2014-04-11','13:40:00',1.97),('3355','2014-04-11','13:45:00',1.65),('3355','2014-04-11','13:50:00',2.3),('3355','2014-04-11','13:55:00',1.85),('3355','2014-04-11','14:00:00',2.11),('3355','2014-04-11','14:05:00',1.78),('3355','2014-04-11','14:10:00',1.67),('3355','2014-04-11','14:15:00',1.6),('3355','2014-04-11','14:20:00',1),('3355','2014-04-11','14:25:00',1.58),('3355','2014-04-11','14:30:00',2.42),('3355','2014-04-11','14:35:00',2.58),('3355','2014-04-11','14:40:00',2.54),('3355','2014-04-11','14:45:00',2.15),('3355','2014-04-11','14:50:00',2.17),('3355','2014-04-11','14:55:00',1.49),('3355','2014-04-11','15:00:00',1.25),('3355','2014-04-11','15:05:00',1.38),('3355','2014-04-11','15:10:00',1.91),('3355','2014-04-11','15:15:00',2.24),('3355','2014-04-11','15:20:00',2.05),('3355','2014-04-11','15:25:00',1.88),('3355','2014-04-11','15:30:00',2.11),('3355','2014-04-11','15:35:00',2.09),('3355','2014-04-11','15:40:00',2.04),('3355','2014-04-11','15:45:00',1.99),('3355','2014-04-11','15:50:00',1.96),('3355','2014-04-11','15:55:00',1.69),('3355','2014-04-11','16:00:00',1.91),('3355','2014-04-11','16:05:00',1.86),('3355','2014-04-11','16:10:00',1.83),('3355','2014-04-11','16:15:00',1.77),('3355','2014-04-11','16:20:00',1.72),('3355','2014-04-11','16:25:00',1.7),('3355','2014-04-11','16:30:00',1.67),('3355','2014-04-11','16:35:00',1.58),('3355','2014-04-11','16:40:00',1.43),('3355','2014-04-11','16:45:00',1.56),('3355','2014-04-11','16:50:00',1.55),('3355','2014-04-11','17:00:00',1.45),('3355','2014-04-11','17:10:00',1.34),('3355','2014-04-11','17:25:00',1.17),('3355','2014-04-11','17:30:00',1.17),('3355','2014-04-11','17:35:00',1.14),('3355','2014-04-11','17:40:00',1.08),('3355','2013-08-29','11:10:00',1.16),('3355','2013-08-29','11:15:00',1.48),('3355','2013-08-29','11:20:00',1.36),('3355','2013-08-29','11:50:00',1.03),('3355','2013-08-29','12:05:00',1.14),('3355','2013-08-29','12:10:00',1.35),('3355','2013-08-29','12:15:00',1.68),('3355','2013-08-29','12:20:00',1.41),('3355','2013-08-29','12:25:00',1.47),('3355','2013-08-29','12:30:00',1.47),('3355','2013-08-29','12:35:00',1.81),('3355','2013-08-29','12:40:00',2.39),('3355','2013-08-29','12:45:00',2.45),('3355','2013-08-29','12:50:00',1.56),('3355','2013-08-29','12:55:00',2.07),('3355','2013-08-29','13:00:00',1.55),('3355','2013-08-29','13:05:00',1.34),('3355','2013-08-29','13:10:00',1.34),('3355','2013-08-29','13:15:00',1.3),('3355','2013-08-29','13:20:00',1.28),('3355','2013-08-29','13:25:00',1.1),('3355','2013-08-29','14:00:00',1.26),('3355','2013-08-29','15:30:00',1.2),('3355','2013-08-29','15:35:00',1.39),('3355','2013-08-29','15:40:00',1.17),('3355','2013-08-29','15:45:00',1.41),('3355','2013-08-29','15:50:00',1.67),('3355','2013-08-29','15:55:00',1.7),('3355','2013-08-29','16:00:00',1.96),('3355','2013-08-29','16:05:00',1.88),('3355','2013-08-29','16:10:00',1.89),('3355','2013-08-29','16:15:00',1.76),('3355','2013-08-29','16:20:00',1.68),('3355','2013-08-29','16:25:00',1.62),('3355','2013-08-29','16:30:00',1.57),('3355','2013-08-29','16:35:00',1.54),('3355','2013-08-29','16:40:00',1.5),('3355','2013-08-29','16:45:00',1.46),('3355','2013-08-29','16:50:00',1.42),('3355','2013-08-29','16:55:00',1.37),('3355','2013-08-29','17:00:00',1.34),('3355','2013-08-29','17:05:00',1.29),('3355','2013-08-29','17:10:00',1.25),('3355','2013-08-29','17:15:00',1.2),('3355','2013-08-29','17:20:00',1.15),('3355','2013-08-29','17:25:00',1.1),('3355','2013-08-29','17:30:00',1.05),('3355','2013-08-29','17:35:00',1),('3355','2013-08-28','09:35:00',1.1),('3355','2013-08-28','09:40:00',1.26),('3355','2013-08-28','09:45:00',1.38),('3355','2013-08-28','09:50:00',1.42),('3355','2013-08-28','09:55:00',1.43),('3355','2013-08-28','10:00:00',1.45),('3355','2013-08-28','10:05:00',1.5),('3355','2013-08-28','10:10:00',1.58),('3355','2013-08-28','10:15:00',1.29),('3355','2013-08-28','10:20:00',1.74),('3355','2013-08-28','10:25:00',1.65),('3355','2013-08-28','10:40:00',1.2),('3355','2013-08-28','10:45:00',1.05),('3355','2013-08-28','10:50:00',1.89),('3355','2013-08-28','10:55:00',1.96),('3355','2013-08-28','11:00:00',1.41),('3355','2013-08-28','11:05:00',1.03),('3355','2013-08-28','11:10:00',1.97),('3355','2013-08-28','11:15:00',1.23),('3355','2013-08-28','11:20:00',2.15),('3355','2013-08-28','11:25:00',2.08),('3355','2013-08-28','11:30:00',2.11),('3355','2013-08-28','11:35:00',2.13),('3355','2013-08-28','11:40:00',2.22),('3355','2013-08-28','11:45:00',2.13),('3355','2013-08-28','11:50:00',1.29),('3355','2013-08-28','11:55:00',1.89),('3355','2013-08-28','12:05:00',2.22),('3355','2013-08-28','12:10:00',2.32),('3355','2013-08-28','12:15:00',1.13),('3355','2013-08-28','12:20:00',2.31),('3355','2013-08-28','12:25:00',2.28),('3355','2013-08-28','12:30:00',2.26),('3355','2013-08-28','12:35:00',2.24),('3355','2013-08-28','12:40:00',2.26),('3355','2013-08-28','12:45:00',2.34),('3355','2013-08-28','12:50:00',2.31),('3355','2013-08-28','12:55:00',2.3),('3355','2013-08-28','13:00:00',2.32),('3355','2013-08-28','13:05:00',2.17),('3355','2013-08-28','13:10:00',2.36),('3355','2013-08-28','13:15:00',2.37),('3355','2013-08-28','13:20:00',2.32),('3355','2013-08-28','13:25:00',2.32),('3355','2013-08-28','13:30:00',2.28),('3355','2013-08-28','13:35:00',2.31),('3355','2013-08-28','13:40:00',2.35),('3355','2013-08-28','13:45:00',2.34),('3355','2013-08-28','13:50:00',2.34),('3355','2013-08-28','13:55:00',2.17),('3355','2013-08-28','14:00:00',2.04),('3355','2013-08-28','14:05:00',2.29),('3355','2013-08-28','14:10:00',1.96),('3355','2013-08-28','14:15:00',2.32),('3355','2013-08-28','14:20:00',2.26),('3355','2013-08-28','14:25:00',2.2),('3355','2013-08-28','14:30:00',2),('3355','2013-08-28','14:35:00',1.86),('3355','2013-08-28','14:40:00',2.32),('3355','2013-08-28','14:45:00',2.22),('3355','2013-08-28','14:50:00',2.19),('3355','2013-08-28','14:55:00',2.17),('3355','2013-08-28','15:00:00',2.15),('3355','2013-08-28','15:05:00',1.95),('3355','2013-08-28','15:10:00',1.93),('3355','2013-08-28','15:15:00',2.15),('3355','2013-08-28','15:20:00',2.11),('3355','2013-08-28','15:25:00',2.07),('3355','2013-08-28','15:30:00',1.34),('3355','2013-08-28','15:35:00',2.14),('3355','2013-08-28','15:40:00',1.44),('3355','2013-08-28','15:55:00',1.02),('3355','2013-08-28','16:00:00',1.97),('3355','2013-08-28','16:05:00',1.76),('3355','2013-08-28','16:10:00',1.76),('3355','2013-08-28','16:15:00',1.58),('3355','2013-08-28','16:25:00',1.85),('3355','2013-08-28','16:30:00',1.7),('3355','2013-08-28','16:35:00',1.66),('3355','2013-08-28','16:40:00',1.62),('3355','2013-08-28','16:45:00',1.55),('3355','2013-08-28','16:50:00',1.47),('3355','2013-08-28','16:55:00',1.26),('3355','2013-08-28','17:00:00',1.41),('3355','2013-08-28','17:05:00',1.33),('3355','2013-08-28','17:10:00',1.13),('3355','2013-08-28','17:15:00',1.11),('3355','2013-08-27','09:25:00',1.01),('3355','2013-08-27','09:30:00',1.13),('3355','2013-08-27','10:05:00',1.21),('3355','2013-08-27','10:10:00',1.48),('3355','2013-08-27','10:15:00',1.54),('3355','2013-08-27','10:20:00',1.6),('3355','2013-08-27','10:25:00',1.6),('3355','2013-08-27','10:30:00',1.64),('3355','2013-08-27','10:35:00',1.67),('3355','2013-08-27','10:40:00',1.64),('3355','2013-08-27','10:45:00',1.72),('3355','2013-08-27','10:50:00',1.71),('3355','2013-08-27','10:55:00',1.79),('3355','2013-08-27','11:00:00',1.78),('3355','2013-08-27','11:05:00',1.82),('3355','2013-08-27','11:10:00',1.85),('3355','2013-08-27','11:15:00',1.84),('3355','2013-08-27','11:20:00',1.83),('3355','2013-08-27','11:25:00',1.81),('3355','2013-08-27','11:30:00',1.87),('3355','2013-08-27','11:35:00',1.93),('3355','2013-08-27','11:40:00',1.81),('3355','2013-08-27','11:45:00',2.25),('3355','2013-08-27','11:50:00',1.74),('3355','2013-08-27','11:55:00',1.99),('3355','2013-08-27','12:00:00',2.16),('3355','2013-08-27','12:05:00',2.02),('3355','2013-08-27','12:10:00',1.82),('3355','2013-08-27','12:15:00',1.84),('3355','2013-08-27','12:20:00',2.06),('3355','2013-08-27','12:25:00',1.54),('3355','2013-08-27','12:30:00',1.87),('3355','2013-08-27','12:35:00',1.48),('3355','2013-08-27','12:40:00',2.3),('3355','2013-08-27','12:45:00',1.73),('3355','2013-08-27','12:50:00',1.29),('3355','2013-08-27','12:55:00',1.24),('3355','2013-08-27','13:10:00',1.38),('3355','2013-08-27','13:15:00',1.36),('3355','2013-08-27','13:20:00',1.12),('3355','2013-08-27','13:30:00',1.24),('3355','2013-08-27','13:35:00',1.01),('3355','2013-08-27','13:40:00',1.18),('3355','2013-08-27','13:45:00',1.43),('3355','2013-08-27','13:50:00',2.23),('3355','2013-08-27','13:55:00',1.77),('3355','2013-08-27','14:00:00',2.37),('3355','2013-08-27','14:05:00',1.64),('3355','2013-08-27','14:15:00',1.38),('3355','2013-08-27','14:20:00',1.41),('3355','2013-08-27','16:10:00',1.61),('3355','2013-08-27','16:15:00',1.78),('3355','2013-08-27','16:20:00',1.06),('3355','2013-08-27','17:10:00',1.42),('3355','2013-08-26','09:10:00',1.02),('3355','2013-08-26','09:15:00',1.06),('3355','2013-08-26','09:20:00',1.11),('3355','2013-08-26','09:25:00',1.13),('3355','2013-08-26','09:30:00',1.19),('3355','2013-08-26','09:35:00',1.23),('3355','2013-08-26','09:40:00',1.29),('3355','2013-08-26','09:45:00',1.33),('3355','2013-08-26','09:50:00',1.36),('3355','2013-08-26','09:55:00',1.41),('3355','2013-08-26','10:00:00',1.44),('3355','2013-08-26','10:05:00',1.47),('3355','2013-08-26','10:10:00',1.51),('3355','2013-08-26','10:15:00',1.54),('3355','2013-08-26','10:20:00',1.57),('3355','2013-08-26','10:25:00',1.61),('3355','2013-08-26','10:30:00',1.66),('3355','2013-08-26','10:35:00',1.67),('3355','2013-08-26','10:40:00',1.69),('3355','2013-08-26','10:45:00',1.74),('3355','2013-08-26','10:50:00',1.76),('3355','2013-08-26','10:55:00',1.81),('3355','2013-08-26','11:00:00',1.83),('3355','2013-08-26','11:05:00',1.85),('3355','2013-08-26','11:10:00',1.86),('3355','2013-08-26','11:15:00',1.89),('3355','2013-08-26','11:20:00',1.91),('3355','2013-08-26','11:25:00',1.91),('3355','2013-08-26','11:30:00',1.93),('3355','2013-08-26','11:35:00',1.99),('3355','2013-08-26','11:40:00',1.99),('3355','2013-08-26','11:45:00',1.99),('3355','2013-08-26','11:50:00',2.01),('3355','2013-08-26','11:55:00',2.04),('3355','2013-08-26','12:00:00',2.04),('3355','2013-08-26','12:05:00',2.05),('3355','2013-08-26','12:10:00',2.07),('3355','2013-08-26','12:15:00',2.08),('3355','2013-08-26','12:20:00',2.07),('3355','2013-08-26','12:25:00',2.08),('3355','2013-08-26','12:30:00',2.07),('3355','2013-08-26','12:35:00',2.08),('3355','2013-08-26','12:40:00',2.11),('3355','2013-08-26','12:45:00',2.14),('3355','2013-08-26','12:50:00',2.15),('3355','2013-08-26','12:55:00',2.15),('3355','2013-08-26','13:00:00',2.23),('3355','2013-08-26','13:05:00',2.37),('3355','2013-08-26','13:10:00',2.29),('3355','2013-08-26','13:15:00',1.19),('3355','2013-08-26','13:20:00',1.3),('3355','2013-08-26','13:25:00',1.6),('3355','2013-08-26','13:30:00',1.52),('3355','2013-08-26','13:35:00',2.19),('3355','2013-08-26','13:40:00',2.18),('3355','2013-08-26','13:45:00',2.19),('3355','2013-08-26','13:50:00',2.23),('3355','2013-08-26','13:55:00',1.72),('3355','2013-08-26','14:00:00',1.41),('3355','2013-08-26','14:05:00',1.92),('3355','2013-08-26','14:10:00',1.36),('3355','2013-08-26','14:15:00',2.08),('3355','2013-08-26','14:20:00',2.11),('3355','2013-08-26','14:25:00',2.08),('3355','2013-08-26','14:30:00',2.11),('3355','2013-08-26','14:35:00',2.01),('3355','2013-08-26','14:40:00',1.82),('3355','2013-08-26','14:45:00',1.43),('3355','2013-08-26','14:50:00',1.23),('3355','2013-08-26','14:55:00',1.1),('3355','2013-08-26','15:00:00',1.05),('3355','2013-08-26','16:00:00',1.36),('3355','2013-08-26','16:05:00',1.86),('3355','2013-08-26','16:10:00',1.68),('3355','2013-08-26','16:15:00',1.58),('3355','2013-08-26','16:20:00',1.56),('3355','2013-08-26','16:25:00',1.51),('3355','2013-08-26','16:30:00',1.47),('3355','2013-08-26','16:35:00',1.44),('3355','2013-08-26','16:40:00',1.41),('3355','2013-08-26','16:45:00',1.4),('3355','2013-08-26','16:50:00',1.3),('3355','2013-08-26','16:55:00',1.26),('3355','2013-08-26','17:00:00',1.25),('3355','2013-08-26','17:05:00',1.12),('3355','2013-08-26','17:10:00',1.15),('3355','2013-08-26','17:15:00',1.11),('3355','2013-08-25','09:20:00',1.01),('3355','2013-08-25','09:25:00',1.06),('3355','2013-08-25','09:35:00',1.16),('3355','2013-08-25','09:40:00',1.54),('3355','2013-08-25','09:45:00',1.62),('3355','2013-08-25','09:50:00',1.51),('3355','2013-08-25','09:55:00',1.62),('3355','2013-08-25','10:00:00',1.29),('3355','2013-08-25','15:30:00',1.16),('3355','2013-08-25','15:35:00',1.74),('3355','2013-08-25','15:40:00',1.92),('3355','2013-08-25','15:45:00',2.15),('3355','2013-08-25','15:50:00',1.62),('3355','2013-08-25','15:55:00',1.38),('3355','2013-08-25','16:00:00',1.94),('3355','2013-08-25','16:05:00',1.86),('3355','2013-08-25','16:10:00',1.78),('3355','2013-08-25','16:15:00',1.73),('3355','2013-08-25','16:20:00',1.67),('3355','2013-08-25','16:25:00',1.64),('3355','2013-08-25','16:30:00',1.61),('3355','2013-08-25','16:35:00',1.33),('3355','2013-08-25','16:40:00',1.19),('3355','2013-08-25','16:50:00',1.1),('3355','2013-08-25','16:55:00',1.58),('3355','2013-08-25','17:00:00',1.45),('3355','2013-08-25','17:05:00',1.36),('3355','2013-08-25','17:10:00',1.3),('3355','2013-08-25','17:15:00',1.2),('3355','2013-08-25','17:20:00',1.14),('3355','2013-08-25','17:25:00',1.09),('3355','2013-08-25','17:30:00',1.03),('3355','2013-08-24','09:20:00',1.18),('3355','2013-08-24','09:25:00',1.08),('3355','2013-08-24','09:35:00',1.31),('3355','2013-08-24','09:40:00',1.34),('3355','2013-08-24','09:45:00',1.35),('3355','2013-08-24','09:50:00',1.39),('3355','2013-08-24','10:10:00',1.45),('3355','2013-08-24','10:15:00',1.56),('3355','2013-08-24','10:20:00',1.59),('3355','2013-08-24','10:25:00',1.62),('3355','2013-08-24','10:30:00',1.64),('3355','2013-08-24','10:35:00',1.67),('3355','2013-08-24','10:40:00',1.71),('3355','2013-08-24','10:45:00',1.74),('3355','2013-08-24','10:50:00',1.69),('3355','2013-08-24','10:55:00',1.82),('3355','2013-08-24','11:00:00',1.81),('3355','2013-08-24','11:05:00',1.8),('3355','2013-08-24','11:10:00',1.89),('3355','2013-08-24','11:15:00',1.89),('3355','2013-08-24','11:20:00',1.89),('3355','2013-08-24','11:25:00',1.92),('3355','2013-08-24','11:30:00',1.92),('3355','2013-08-24','11:35:00',1.97),('3355','2013-08-24','11:40:00',1.97),('3355','2013-08-24','11:45:00',1.99),('3355','2013-08-24','11:50:00',2.02),('3355','2013-08-24','11:55:00',2),('3355','2013-08-24','12:00:00',2.05),('3355','2013-08-24','12:05:00',2.06),('3355','2013-08-24','12:10:00',2.08),('3355','2013-08-24','12:15:00',2.1),('3355','2013-08-24','12:20:00',2.1),('3355','2013-08-24','12:25:00',2.12),('3355','2013-08-24','12:30:00',2.09),('3355','2013-08-24','12:35:00',2.12),('3355','2013-08-24','12:40:00',2.12),('3355','2013-08-24','12:45:00',2.1),('3355','2013-08-24','12:50:00',2.12),('3355','2013-08-24','12:55:00',2.14),('3355','2013-08-24','13:00:00',2.12),('3355','2013-08-24','13:05:00',2.13),('3355','2013-08-24','13:10:00',2.14),('3355','2013-08-24','13:15:00',2.15),('3355','2013-08-24','13:20:00',2.17),('3355','2013-08-24','13:25:00',2.17),('3355','2013-08-24','13:30:00',2.17),('3355','2013-08-24','13:35:00',2.18),('3355','2013-08-24','13:40:00',2.18),('3355','2013-08-24','13:45:00',2.17),('3355','2013-08-24','13:50:00',2.16),('3355','2013-08-24','13:55:00',2.14),('3355','2013-08-24','14:00:00',2.14),('3355','2013-08-24','14:05:00',2.14),('3355','2013-08-24','14:10:00',2.14),('3355','2013-08-24','14:15:00',2.11),('3355','2013-08-24','14:20:00',2.12),('3355','2013-08-24','14:25:00',2.1),('3355','2013-08-24','14:30:00',2.1),('3355','2013-08-24','14:35:00',2.1),('3355','2013-08-24','14:40:00',2.08),('3355','2013-08-24','14:45:00',2.06),('3355','2013-08-24','14:50:00',2.04),('3355','2013-08-24','14:55:00',2.02),('3355','2013-08-24','15:00:00',2.01),('3355','2013-08-24','15:05:00',1.99),('3355','2013-08-24','15:10:00',1.96),('3355','2013-08-24','15:15:00',1.93),('3355','2013-08-24','15:20:00',1.91),('3355','2013-08-24','15:25:00',1.91),('3355','2013-08-24','15:30:00',1.89),('3355','2013-08-24','15:35:00',1.85),('3355','2013-08-24','15:40:00',1.83),('3355','2013-08-24','15:45:00',1.79),('3355','2013-08-24','15:50:00',1.78),('3355','2013-08-24','15:55:00',1.75),('3355','2013-08-24','16:00:00',1.72),('3355','2013-08-24','16:05:00',1.7),('3355','2013-08-24','16:10:00',1.67),('3355','2013-08-24','16:15:00',1.64),('3355','2013-08-24','16:20:00',1.61),('3355','2013-08-24','16:25:00',1.58),('3355','2013-08-24','16:30:00',1.54),('3355','2013-08-24','16:35:00',1.49),('3355','2013-08-24','16:40:00',1.46),('3355','2013-08-24','16:45:00',1.42),('3355','2013-08-24','16:50:00',1.38),('3355','2013-08-24','16:55:00',1.34),('3355','2013-08-24','17:00:00',1.31),('3355','2013-08-24','17:05:00',1.27),('3355','2013-08-24','17:10:00',1.23),('3355','2013-08-24','17:15:00',1.19),('3355','2013-08-24','17:20:00',1.15),('3355','2013-08-24','17:25:00',1.1),('3355','2013-08-24','17:30:00',1.05),('3355','2013-08-24','17:35:00',1.01),('3355','2013-08-23','09:20:00',1.02),('3355','2013-08-23','09:25:00',1.05),('3355','2013-08-23','09:30:00',1.09),('3355','2013-08-23','09:35:00',1.12),('3355','2013-08-23','09:40:00',1.15),('3355','2013-08-23','09:45:00',1.19),('3355','2013-08-23','09:50:00',1.22),('3355','2013-08-23','09:55:00',1.27),('3355','2013-08-23','10:00:00',1.31),('3355','2013-08-23','10:05:00',1.33),('3355','2013-08-23','10:10:00',1.37),('3355','2013-08-23','10:15:00',1.4),('3355','2013-08-23','10:20:00',1.44),('3355','2013-08-23','10:25:00',1.47),('3355','2013-08-23','10:30:00',1.48),('3355','2013-08-23','10:35:00',1.5),('3355','2013-08-23','10:40:00',1.49),('3355','2013-08-23','10:45:00',1.58),('3355','2013-08-23','10:50:00',1.61),('3355','2013-08-23','10:55:00',1.58),('3355','2013-08-23','11:00:00',1.64),('3355','2013-08-23','11:05:00',1.7),('3355','2013-08-23','11:10:00',1.7),('3355','2013-08-23','11:15:00',1.66),('3355','2013-08-23','11:20:00',1.5),('3355','2013-08-23','11:25:00',1.86),('3355','2013-08-23','11:30:00',1.25),('3355','2013-08-23','11:35:00',1.36),('3355','2013-08-23','11:40:00',1.69),('3355','2013-08-23','11:45:00',1.25),('3355','2013-08-23','11:50:00',2),('3355','2013-08-23','11:55:00',1.98),('3355','2013-08-23','12:00:00',2.06),('3355','2013-08-23','12:05:00',1.69),('3355','2013-08-23','13:15:00',1.63),('3355','2013-08-23','13:25:00',1.81),('3355','2013-08-23','13:30:00',2.26),('3355','2013-08-23','13:35:00',2.25),('3355','2013-08-23','13:40:00',2.23),('3355','2013-08-23','13:45:00',2.19),('3355','2013-08-23','13:50:00',2.2),('3355','2013-08-23','13:55:00',2.07),('3355','2013-08-23','14:00:00',1.5),('3355','2013-08-23','14:05:00',2.1),('3355','2013-08-23','14:10:00',2.24),('3355','2013-08-23','14:15:00',2.2),('3355','2013-08-23','14:20:00',1.88),('3355','2013-08-23','14:25:00',1.96),('3355','2013-08-23','14:30:00',2.12),('3355','2013-08-23','14:35:00',2.08),('3355','2013-08-23','14:40:00',2.06),('3355','2013-08-23','14:45:00',2.05),('3355','2013-08-23','14:50:00',2.02),('3355','2013-08-23','14:55:00',2),('3355','2013-08-23','15:00:00',1.95),('3355','2013-08-23','15:05:00',1.84),('3355','2013-08-23','15:10:00',1.93),('3355','2013-08-23','15:15:00',1.9),('3355','2013-08-23','15:20:00',1.88),('3355','2013-08-23','15:25:00',1.88),('3355','2013-08-23','15:30:00',1.93),('3355','2013-08-23','15:35:00',1.81),('3355','2013-08-23','15:40:00',1.79),('3355','2013-08-23','15:45:00',1.8),('3355','2013-08-23','15:50:00',1.67),('3355','2013-08-23','15:55:00',1.74),('3355','2013-08-23','16:00:00',1.67),('3355','2013-08-23','16:05:00',1.58),('3355','2013-08-23','16:10:00',1.46),('3355','2013-08-23','16:15:00',1.45),('3355','2013-08-23','16:20:00',1.66),('3355','2013-08-23','16:25:00',1.6),('3355','2013-08-23','16:30:00',1.56),('3355','2013-08-23','16:35:00',1.54),('3355','2013-08-23','16:40:00',1.51),('3355','2013-08-23','16:45:00',1.47),('3355','2013-08-23','16:50:00',1.43),('3355','2013-08-23','16:55:00',1.37),('3355','2013-08-23','17:00:00',1.31),('3355','2013-08-23','17:05:00',1.26),('3355','2013-08-23','17:10:00',1.21),('3355','2013-08-23','17:15:00',1.16),('3355','2013-08-23','17:20:00',1.1),('3355','2013-08-23','17:25:00',1.07),('3355','2013-08-23','17:30:00',1),('3355','2013-08-22','09:10:00',1.06),('3355','2013-08-22','09:15:00',1.12),('3355','2013-08-22','09:20:00',1.2),('3355','2013-08-22','09:25:00',1.17),('3355','2013-08-22','09:50:00',1.09),('3355','2013-08-22','09:55:00',1.38),('3355','2013-08-22','10:00:00',1.51),('3355','2013-08-22','10:05:00',1.51),('3355','2013-08-22','10:10:00',1.53),('3355','2013-08-22','10:15:00',1.52),('3355','2013-08-22','10:20:00',1.54),('3355','2013-08-22','10:25:00',1.56),('3355','2013-08-22','10:30:00',1.6),('3355','2013-08-22','10:35:00',1.62),('3355','2013-08-22','10:40:00',1.65),('3355','2013-08-22','10:45:00',1.67),('3355','2013-08-22','10:50:00',1.7),('3355','2013-08-22','10:55:00',1.72),('3355','2013-08-22','11:00:00',1.75),('3355','2013-08-22','11:05:00',1.78),('3355','2013-08-22','11:10:00',1.78),('3355','2013-08-22','11:15:00',1.8),('3355','2013-08-22','11:20:00',1.81),('3355','2013-08-22','11:25:00',1.83),('3355','2013-08-22','11:30:00',1.86),('3355','2013-08-22','11:35:00',1.88),('3355','2013-08-22','11:40:00',1.89),('3355','2013-08-22','11:45:00',1.91),('3355','2013-08-22','11:50:00',1.93),('3355','2013-08-22','11:55:00',1.94),('3355','2013-08-22','12:00:00',1.96),('3355','2013-08-22','12:05:00',1.97),('3355','2013-08-22','12:10:00',1.99),('3355','2013-08-22','12:15:00',1.99),('3355','2013-08-22','12:20:00',2),('3355','2013-08-22','12:25:00',2.01),('3355','2013-08-22','12:30:00',2.02),('3355','2013-08-22','12:35:00',2.02),('3355','2013-08-22','12:40:00',2.03),('3355','2013-08-22','12:45:00',2.03),('3355','2013-08-22','12:50:00',2.04),('3355','2013-08-22','12:55:00',2.04),('3355','2013-08-22','13:00:00',2.03),('3355','2013-08-22','13:05:00',1.97),('3355','2013-08-22','13:10:00',1.97),('3355','2013-08-22','13:15:00',2),('3355','2013-08-22','13:20:00',2.02),('3355','2013-08-22','13:25:00',1.98),('3355','2013-08-22','13:30:00',2.01),('3355','2013-08-22','13:35:00',2.01),('3355','2013-08-22','13:40:00',2.02),('3355','2013-08-22','13:45:00',2.04),('3355','2013-08-22','13:50:00',2.03),('3355','2013-08-22','13:55:00',2.01),('3355','2013-08-22','14:00:00',2),('3355','2013-08-22','14:05:00',2),('3355','2013-08-22','14:10:00',1.99),('3355','2013-08-22','14:15:00',2),('3355','2013-08-22','14:20:00',2),('3355','2013-08-22','14:25:00',2.03),('3355','2013-08-22','14:30:00',2.03),('3355','2013-08-22','14:35:00',1.99),('3355','2013-08-22','14:40:00',1.97),('3355','2013-08-22','14:45:00',1.93),('3355','2013-08-22','14:50:00',1.92),('3355','2013-08-22','14:55:00',1.23),('3355','2013-08-22','15:00:00',1.93),('3355','2013-08-22','15:05:00',1.94),('3355','2013-08-22','15:10:00',1.9),('3355','2013-08-22','15:15:00',1.89),('3355','2013-08-22','15:20:00',1.86),('3355','2013-08-22','15:25:00',1.82),('3355','2013-08-22','15:30:00',1.8),('3355','2013-08-22','15:35:00',1.78),('3355','2013-08-22','15:40:00',1.76),('3355','2013-08-22','15:45:00',1.74),('3355','2013-08-22','15:50:00',1.72),('3355','2013-08-22','15:55:00',1.69),('3355','2013-08-22','16:00:00',1.65),('3355','2013-08-22','16:05:00',1.6),('3355','2013-08-22','16:10:00',1.57),('3355','2013-08-22','16:15:00',1.55),('3355','2013-08-22','16:20:00',1.52),('3355','2013-08-22','16:25:00',1.5),('3355','2013-08-22','16:30:00',1.47),('3355','2013-08-22','16:35:00',1.42),('3355','2013-08-22','16:40:00',1.38),('3355','2013-08-22','16:45:00',1.33),('3355','2013-08-22','16:50:00',1.3),('3355','2013-08-22','16:55:00',1.27),('3355','2013-08-22','17:00:00',1.2),('3355','2013-08-22','17:05:00',1.17),('3355','2013-08-22','17:10:00',1.13),('3355','2013-08-22','17:15:00',1.08),('3355','2013-08-22','17:20:00',1.03),('3355','2013-08-21','09:15:00',1.25),('3355','2013-08-21','09:20:00',1.21),('3355','2013-08-21','09:50:00',1.64),('3355','2013-08-21','09:55:00',1.78),('3355','2013-08-21','10:00:00',1.66),('3355','2013-08-21','10:05:00',1.43),('3355','2013-08-21','10:10:00',1.07),('3355','2013-08-21','10:15:00',1.1),('3355','2013-08-21','10:30:00',1.08),('3355','2013-08-21','10:35:00',1.76),('3355','2013-08-21','10:40:00',1.51),('3355','2013-08-21','10:45:00',1.24),('3355','2013-08-21','10:50:00',1.12),('3355','2013-08-21','11:00:00',1.16),('3355','2013-08-21','11:15:00',1.21),('3355','2013-08-21','11:20:00',2.11),('3355','2013-08-21','11:25:00',1.36),('3355','2013-08-21','11:30:00',1.46),('3355','2013-08-21','11:35:00',2.11),('3355','2013-08-21','11:40:00',2.14),('3355','2013-08-21','11:45:00',2.1),('3355','2013-08-21','11:50:00',1.6),('3355','2013-08-21','11:55:00',2.04),('3355','2013-08-21','12:00:00',2.15),('3355','2013-08-21','12:05:00',2.15),('3355','2013-08-21','12:10:00',2.16),('3355','2013-08-21','12:15:00',2.17),('3355','2013-08-21','12:20:00',1.98),('3355','2013-08-21','12:25:00',1.58),('3355','2013-08-21','12:30:00',1.95),('3355','2013-08-21','12:35:00',1.78),('3355','2013-08-21','12:40:00',1.92),('3355','2013-08-21','12:45:00',2.08),('3355','2013-08-21','12:50:00',2.03),('3355','2013-08-21','12:55:00',1.95),('3355','2013-08-21','13:00:00',2.04),('3355','2013-08-21','13:05:00',2.09),('3355','2013-08-21','13:10:00',2.12),('3355','2013-08-21','13:15:00',2.15),('3355','2013-08-21','13:20:00',2.14),('3355','2013-08-21','13:25:00',2.15),('3355','2013-08-21','13:30:00',2.16),('3355','2013-08-21','13:35:00',2.13),('3355','2013-08-21','13:40:00',2.09),('3355','2013-08-21','13:45:00',2.01),('3355','2013-08-21','13:50:00',2.01),('3355','2013-08-21','13:55:00',2.01),('3355','2013-08-21','14:00:00',2.01),('3355','2013-08-21','14:05:00',2.09),('3355','2013-08-21','14:10:00',2.1),('3355','2013-08-21','14:15:00',2.11),('3355','2013-08-21','14:20:00',1.81),('3355','2013-08-21','14:25:00',1.6),('3355','2013-08-21','14:30:00',1.89),('3355','2013-08-21','14:35:00',1.84),('3355','2013-08-21','14:40:00',1.9),('3355','2013-08-21','14:45:00',1.9),('3355','2013-08-21','14:50:00',1.8),('3355','2013-08-21','14:55:00',1.81),('3355','2013-08-21','15:00:00',1.88),('3355','2013-08-21','15:05:00',1.89),('3355','2013-08-21','15:10:00',1.83),('3355','2013-08-21','15:15:00',1.82),('3355','2013-08-21','15:20:00',1.77),('3355','2013-08-21','15:25:00',1.76),('3355','2013-08-21','15:30:00',1.71),('3355','2013-08-21','15:35:00',1.65),('3355','2013-08-21','15:40:00',1.58),('3355','2013-08-21','15:45:00',1.59),('3355','2013-08-21','15:50:00',1.62),('3355','2013-08-21','15:55:00',1.54),('3355','2013-08-21','16:00:00',1.43),('3355','2013-08-21','16:05:00',1.38),('3355','2013-08-21','16:10:00',1.37),('3355','2013-08-21','16:15:00',1.4),('3355','2013-08-21','16:20:00',1.51),('3355','2013-08-21','16:25:00',1.44),('3355','2013-08-21','16:30:00',1.51),('3355','2013-08-21','16:35:00',1.49),('3355','2013-08-21','16:40:00',1.44),('3355','2013-08-21','16:45:00',1.39),('3355','2013-08-21','16:50:00',1.36),('3355','2013-08-21','16:55:00',1.32),('3355','2013-08-21','17:00:00',1.29),('3355','2013-08-21','17:05:00',1.27),('3355','2013-08-21','17:10:00',1.24),('3355','2013-08-21','17:15:00',1.23),('3355','2013-08-21','17:20:00',1.2),('3355','2013-08-21','17:25:00',1.16),('3355','2013-08-21','17:30:00',1.1),('3355','2013-08-21','17:35:00',1.07),('3355','2013-08-21','17:40:00',1.03),('3355','2013-08-20','09:30:00',1.15),('3355','2013-08-20','09:35:00',1.1),('3355','2013-08-20','09:40:00',1.44),('3355','2013-08-20','09:45:00',1.49),('3355','2013-08-20','09:50:00',1.19),('3355','2013-08-20','09:55:00',1.23),('3355','2013-08-20','10:10:00',1.61),('3355','2013-08-20','10:20:00',1.09),('3355','2013-08-20','10:50:00',1.35),('3355','2013-08-20','10:55:00',1.45),('3355','2013-08-20','11:20:00',2.12),('3355','2013-08-20','11:25:00',2.03),('3355','2013-08-20','11:40:00',2.18),('3355','2013-08-20','11:45:00',2.09),('3355','2013-08-20','11:50:00',2.44),('3355','2013-08-20','11:55:00',2.35),('3355','2013-08-20','13:30:00',1.05),('3355','2013-08-20','13:35:00',1.3),('3355','2013-08-20','13:40:00',2.17),('3355','2013-08-20','13:45:00',2.38),('3355','2013-08-20','13:50:00',2.35),('3355','2013-08-20','13:55:00',2.28),('3355','2013-08-20','14:00:00',2.22),('3355','2013-08-20','14:05:00',2.23),('3355','2013-08-20','14:10:00',2.24),('3355','2013-08-20','14:15:00',2.21),('3355','2013-08-20','14:20:00',2.16),('3355','2013-08-20','14:25:00',2.11),('3355','2013-08-20','14:30:00',1.6),('3355','2013-08-20','14:35:00',2.32),('3355','2013-08-20','14:40:00',2.32),('3355','2013-08-20','14:45:00',2.12),('3355','2013-08-20','14:50:00',2.18),('3355','2013-08-20','14:55:00',1.64),('3355','2013-08-20','15:00:00',1.77),('3355','2013-08-20','15:05:00',2.01),('3355','2013-08-20','15:10:00',2.18),('3355','2013-08-20','15:15:00',2.14),('3355','2013-08-20','15:20:00',2.09),('3355','2013-08-20','15:25:00',2.03),('3355','2013-08-20','15:30:00',2.09),('3355','2013-08-20','15:35:00',2.08),('3355','2013-08-20','15:40:00',2.1),('3355','2013-08-20','15:45:00',2.19),('3355','2013-08-20','15:50:00',1.87),('3355','2013-08-20','15:55:00',2.23),('3355','2013-08-20','16:00:00',1.92),('3355','2013-08-20','16:05:00',1.97),('3355','2013-08-20','16:10:00',2.07),('3355','2013-08-20','16:15:00',2.03),('3355','2013-08-20','16:20:00',2),('3355','2013-08-20','16:25:00',1.91),('3355','2013-08-20','16:30:00',1.76),('3355','2013-08-20','16:35:00',1.81),('3355','2013-08-20','16:40:00',1.85),('3355','2013-08-20','16:45:00',1.77),('3355','2013-08-20','16:50:00',1.62),('3355','2013-08-20','16:55:00',1.56),('3355','2013-08-20','17:00:00',1.45),('3355','2013-08-20','17:05:00',1.37),('3355','2013-08-20','17:10:00',1.31),('3355','2013-08-20','17:15:00',1.24),('3355','2013-08-20','17:20:00',1.21),('3355','2013-08-20','17:25:00',1.17),('3355','2013-08-20','17:30:00',1.11),('3355','2013-08-20','17:35:00',1.08),('3355','2014-04-10','09:00:00',1.03),('3355','2014-04-10','09:05:00',1.09),('3355','2014-04-10','09:10:00',1.14),('3355','2014-04-10','09:15:00',1.18),('3355','2014-04-10','09:20:00',1.19),('3355','2014-04-10','09:25:00',1.29),('3355','2014-04-10','09:30:00',1.35),('3355','2014-04-10','09:35:00',1.4),('3355','2014-04-10','09:40:00',1.43),('3355','2014-04-10','09:45:00',1.47),('3355','2014-04-10','09:50:00',1.53),('3355','2014-04-10','09:55:00',1.57),('3355','2014-04-10','10:00:00',1.61),('3355','2014-04-10','10:05:00',1.65),('3355','2014-04-10','10:10:00',1.7),('3355','2014-04-10','10:15:00',1.7),('3355','2014-04-10','10:20:00',1.75),('3355','2014-04-10','10:25:00',1.78),('3355','2014-04-10','10:30:00',1.81),('3355','2014-04-10','10:35:00',1.88),('3355','2014-04-10','10:40:00',1.91),('3355','2014-04-10','10:45:00',1.92),('3355','2014-04-10','10:50:00',1.9),('3355','2014-04-10','10:55:00',1.94),('3355','2014-04-10','11:00:00',1.98),('3355','2014-04-10','11:05:00',2.04),('3355','2014-04-10','11:10:00',2),('3355','2014-04-10','11:15:00',2.09),('3355','2014-04-10','11:20:00',2.12),('3355','2014-04-10','11:25:00',2.17),('3355','2014-04-10','11:30:00',2.18),('3355','2014-04-10','11:35:00',2.22),('3355','2014-04-10','11:40:00',2.16),('3355','2014-04-10','11:45:00',2.21),('3355','2014-04-10','11:50:00',2.14),('3355','2014-04-10','11:55:00',2.24),('3355','2014-04-10','12:00:00',2.21),('3355','2014-04-10','12:05:00',2.09),('3355','2014-04-10','12:10:00',2.18),('3355','2014-04-10','12:15:00',2.21),('3355','2014-04-10','12:20:00',2.22),('3355','2014-04-10','12:25:00',2.19),('3355','2014-04-10','12:30:00',2.22),('3355','2014-04-10','12:35:00',2.32),('3355','2014-04-10','12:40:00',2.31),('3355','2014-04-10','12:45:00',2.31),('3355','2014-04-10','12:50:00',2.26),('3355','2014-04-10','12:55:00',2.24),('3355','2014-04-10','13:00:00',2.24),('3355','2014-04-10','13:05:00',2.15),('3355','2014-04-10','13:10:00',2.16),('3355','2014-04-10','13:15:00',2.25),('3355','2014-04-10','13:20:00',2.21),('3355','2014-04-10','13:25:00',2.38),('3355','2014-04-10','13:30:00',2.31),('3355','2014-04-10','13:35:00',2.37),('3355','2014-04-10','13:40:00',2.28),('3355','2014-04-10','13:45:00',2.37),('3355','2014-04-10','13:50:00',2.34),('3355','2014-04-10','13:55:00',2.32),('3355','2014-04-10','14:00:00',2.32),('3355','2014-04-10','14:05:00',2.32),('3355','2014-04-10','14:10:00',2.31),('3355','2014-04-10','14:15:00',2.29),('3355','2014-04-10','14:20:00',2.3),('3355','2014-04-10','14:25:00',2.3),('3355','2014-04-10','14:30:00',2.3),('3355','2014-04-10','14:35:00',2.29),('3355','2014-04-10','14:40:00',2.28),('3355','2014-04-10','14:45:00',2.07),('3355','2014-04-10','14:50:00',2.28),('3355','2014-04-10','14:55:00',2.22),('3355','2014-04-10','15:00:00',2.2),('3355','2014-04-10','15:05:00',2.17),('3355','2014-04-10','15:10:00',2.15),('3355','2014-04-10','15:15:00',2.14),('3355','2014-04-10','15:20:00',2.12),('3355','2014-04-10','15:25:00',2.08),('3355','2014-04-10','15:30:00',1.91),('3355','2014-04-10','15:35:00',1.88),('3355','2014-04-10','15:40:00',1.94),('3355','2014-04-10','15:45:00',1.88),('3355','2014-04-10','15:50:00',1.91),('3355','2014-04-10','15:55:00',1.86),('3355','2014-04-10','16:00:00',1.79),('3355','2014-04-10','16:05:00',1.84),('3355','2014-04-10','16:10:00',1.82),('3355','2014-04-10','16:15:00',1.88),('3355','2014-04-10','16:20:00',1.75),('3355','2014-04-10','16:25:00',1.8),('3355','2014-04-10','16:30:00',1.74),('3355','2014-04-10','16:35:00',1.72),('3355','2014-04-10','16:40:00',1.68),('3355','2014-04-10','16:45:00',1.68),('3355','2014-04-10','16:50:00',1.59),('3355','2014-04-10','16:55:00',1.54),('3355','2014-04-10','17:00:00',1.48),('3355','2014-04-10','17:05:00',1.44),('3355','2014-04-10','17:10:00',1.36),('3355','2014-04-10','17:15:00',1.29),('3355','2014-04-10','17:20:00',1.28),('3355','2014-04-10','17:25:00',1.21),('3355','2014-04-10','17:30:00',1.15),('3355','2014-04-10','17:35:00',1.08),('3355','2014-04-10','17:40:00',1.02),('3355','2013-08-19','09:10:00',1.04),('3355','2013-08-19','09:15:00',1.07),('3355','2013-08-19','09:20:00',1.12),('3355','2013-08-19','09:25:00',1.15),('3355','2013-08-19','09:30:00',1.2),('3355','2013-08-19','09:35:00',1.24),('3355','2013-08-19','09:40:00',1.28),('3355','2013-08-19','09:45:00',1.32),('3355','2013-08-19','09:50:00',1.36),('3355','2013-08-19','09:55:00',1.4),('3355','2013-08-19','10:00:00',1.44),('3355','2013-08-19','10:05:00',1.46),('3355','2013-08-19','10:10:00',1.5),('3355','2013-08-19','10:15:00',1.53),('3355','2013-08-19','10:20:00',1.56),('3355','2013-08-19','10:25:00',1.59),('3355','2013-08-19','10:30:00',1.62),('3355','2013-08-19','10:35:00',1.66),('3355','2013-08-19','10:40:00',1.69),('3355','2013-08-19','10:45:00',1.71),('3355','2013-08-19','10:50:00',1.72),('3355','2013-08-19','10:55:00',1.75),('3355','2013-08-19','11:00:00',1.79),('3355','2013-08-19','11:05:00',1.8),('3355','2013-08-19','11:10:00',1.81),('3355','2013-08-19','11:15:00',1.83),('3355','2013-08-19','11:20:00',1.85),('3355','2013-08-19','11:25:00',1.86),('3355','2013-08-19','11:30:00',1.9),('3355','2013-08-19','11:35:00',1.87),('3355','2013-08-19','11:40:00',1.92),('3355','2013-08-19','11:45:00',1.95),('3355','2013-08-19','11:50:00',1.95),('3355','2013-08-19','11:55:00',1.96),('3355','2013-08-19','12:00:00',1.98),('3355','2013-08-19','12:05:00',1.98),('3355','2013-08-19','12:10:00',2.02),('3355','2013-08-19','12:15:00',2.03),('3355','2013-08-19','12:20:00',2.06),('3355','2013-08-19','12:25:00',2.05),('3355','2013-08-19','12:30:00',2.04),('3355','2013-08-19','12:35:00',2.08),('3355','2013-08-19','12:40:00',2.09),('3355','2013-08-19','12:45:00',2.08),('3355','2013-08-19','12:50:00',2.13),('3355','2013-08-19','12:55:00',2.12),('3355','2013-08-19','13:00:00',2.12),('3355','2013-08-19','13:05:00',2.14),('3355','2013-08-19','13:10:00',2.15),('3355','2013-08-19','13:15:00',2.16),('3355','2013-08-19','13:20:00',2.17),('3355','2013-08-19','13:25:00',2.15),('3355','2013-08-19','13:30:00',2.16),('3355','2013-08-19','13:35:00',2.16),('3355','2013-08-19','13:40:00',2.16),('3355','2013-08-19','13:45:00',2.15),('3355','2013-08-19','13:50:00',2.15),('3355','2013-08-19','13:55:00',2.16),('3355','2013-08-19','14:00:00',2.15),('3355','2013-08-19','14:05:00',2.14),('3355','2013-08-19','14:10:00',2.14),('3355','2013-08-19','14:15:00',2.14),('3355','2013-08-19','14:20:00',2.14),('3355','2013-08-19','14:25:00',2.13),('3355','2013-08-19','14:30:00',2.11),('3355','2013-08-19','14:35:00',2.11),('3355','2013-08-19','14:40:00',2.1),('3355','2013-08-19','14:45:00',2.1),('3355','2013-08-19','14:50:00',2.09),('3355','2013-08-19','14:55:00',2.07),('3355','2013-08-19','15:00:00',2.03),('3355','2013-08-19','15:05:00',2.02),('3355','2013-08-19','15:10:00',2),('3355','2013-08-19','15:15:00',1.99),('3355','2013-08-19','15:20:00',1.97),('3355','2013-08-19','15:25:00',1.97),('3355','2013-08-19','15:30:00',1.93),('3355','2013-08-19','15:35:00',1.91),('3355','2013-08-19','15:40:00',1.89),('3355','2013-08-19','15:45:00',1.86),('3355','2013-08-19','15:50:00',1.84),('3355','2013-08-19','15:55:00',1.81),('3355','2013-08-19','16:00:00',1.77),('3355','2013-08-19','16:05:00',1.75),('3355','2013-08-19','16:10:00',1.73),('3355','2013-08-19','16:15:00',1.69),('3355','2013-08-19','16:20:00',1.65),('3355','2013-08-19','16:25:00',1.61),('3355','2013-08-19','16:30:00',1.58),('3355','2013-08-19','16:35:00',1.56),('3355','2013-08-19','16:40:00',1.53),('3355','2013-08-19','16:45:00',1.49),('3355','2013-08-19','16:50:00',1.46),('3355','2013-08-19','16:55:00',1.42),('3355','2013-08-19','17:00:00',1.38),('3355','2013-08-19','17:05:00',1.33),('3355','2013-08-19','17:10:00',1.29),('3355','2013-08-19','17:15:00',1.24),('3355','2013-08-19','17:20:00',1.2),('3355','2013-08-19','17:25:00',1.15),('3355','2013-08-19','17:30:00',1.1),('3355','2013-08-19','17:35:00',1.07),('3355','2013-08-19','17:40:00',1.02),('3355','2013-08-18','09:05:00',1),('3355','2013-08-18','09:10:00',1.05),('3355','2013-08-18','09:15:00',1.1),('3355','2013-08-18','09:20:00',1.14),('3355','2013-08-18','09:25:00',1.19),('3355','2013-08-18','09:30:00',1.23),('3355','2013-08-18','09:35:00',1.27),('3355','2013-08-18','09:40:00',1.34),('3355','2013-08-18','09:45:00',1.29),('3355','2013-08-18','09:50:00',1.35),('3355','2013-08-18','09:55:00',1.04),('3355','2013-08-18','10:00:00',1.46),('3355','2013-08-18','10:05:00',1.3),('3355','2013-08-18','10:10:00',1.36),('3355','2013-08-18','10:15:00',1.56),('3355','2013-08-18','10:20:00',1.58),('3355','2013-08-18','10:25:00',1.61),('3355','2013-08-18','10:30:00',1.62),('3355','2013-08-18','10:35:00',1.65),('3355','2013-08-18','10:40:00',1.67),('3355','2013-08-18','10:45:00',1.69),('3355','2013-08-18','10:50:00',1.71),('3355','2013-08-18','10:55:00',1.74),('3355','2013-08-18','11:00:00',1.77),('3355','2013-08-18','11:05:00',1.79),('3355','2013-08-18','11:10:00',1.8),('3355','2013-08-18','11:15:00',1.81),('3355','2013-08-18','11:20:00',1.85),('3355','2013-08-18','11:25:00',1.87),('3355','2013-08-18','11:30:00',1.87),('3355','2013-08-18','11:35:00',1.9),('3355','2013-08-18','11:40:00',1.94),('3355','2013-08-18','11:45:00',1.95),('3355','2013-08-18','11:50:00',1.96),('3355','2013-08-18','11:55:00',1.97),('3355','2013-08-18','12:00:00',1.98),('3355','2013-08-18','12:05:00',2.03),('3355','2013-08-18','12:10:00',2.05),('3355','2013-08-18','12:15:00',2),('3355','2013-08-18','12:20:00',2.07),('3355','2013-08-18','12:25:00',2.11),('3355','2013-08-18','12:30:00',2.15),('3355','2013-08-18','12:35:00',2),('3355','2013-08-18','13:00:00',1.29),('3355','2013-08-18','13:05:00',2.04),('3355','2013-08-18','13:10:00',1.96),('3355','2013-08-18','13:15:00',1.95),('3355','2013-08-18','13:20:00',2.1),('3355','2013-08-18','13:25:00',2.13),('3355','2013-08-18','13:30:00',2.15),('3355','2013-08-18','13:35:00',2.16),('3355','2013-08-18','13:40:00',2.17),('3355','2013-08-18','13:45:00',2.15),('3355','2013-08-18','13:50:00',2.15),('3355','2013-08-18','13:55:00',2.13),('3355','2013-08-18','14:00:00',2.14),('3355','2013-08-18','14:05:00',2.16),('3355','2013-08-18','14:10:00',2.11),('3355','2013-08-18','14:15:00',2.1),('3355','2013-08-18','14:20:00',2.1),('3355','2013-08-18','14:25:00',2.09),('3355','2013-08-18','14:30:00',2.1),('3355','2013-08-18','14:35:00',2.11),('3355','2013-08-18','14:40:00',2.08),('3355','2013-08-18','14:45:00',2.08),('3355','2013-08-18','14:50:00',2.05),('3355','2013-08-18','14:55:00',2.04),('3355','2013-08-18','15:00:00',2.03),('3355','2013-08-18','15:05:00',2.01),('3355','2013-08-18','15:10:00',1.98),('3355','2013-08-18','15:15:00',1.97),('3355','2013-08-18','15:20:00',1.95),('3355','2013-08-18','15:25:00',1.93),('3355','2013-08-18','15:30:00',1.91),('3355','2013-08-18','15:35:00',1.89),('3355','2013-08-18','15:40:00',1.87),('3355','2013-08-18','15:45:00',1.85),('3355','2013-08-18','15:50:00',1.82),('3355','2013-08-18','15:55:00',1.79),('3355','2013-08-18','16:00:00',1.76),('3355','2013-08-18','16:05:00',1.74),('3355','2013-08-18','16:10:00',1.71),('3355','2013-08-18','16:15:00',1.68),('3355','2013-08-18','16:20:00',1.65),('3355','2013-08-18','16:25:00',1.62),('3355','2013-08-18','16:30:00',1.58),('3355','2013-08-18','16:35:00',1.56),('3355','2013-08-18','16:40:00',1.51),('3355','2013-08-18','16:45:00',1.48),('3355','2013-08-18','16:50:00',1.45),('3355','2013-08-18','16:55:00',1.41),('3355','2013-08-18','17:00:00',1.37),('3355','2013-08-18','17:05:00',1.33),('3355','2013-08-18','17:10:00',1.29),('3355','2013-08-18','17:15:00',1.25),('3355','2013-08-18','17:20:00',1.21),('3355','2013-08-18','17:25:00',1.17),('3355','2013-08-18','17:30:00',1.13),('3355','2013-08-18','17:35:00',1.08),('3355','2013-08-18','17:40:00',1.03),('3355','2013-08-17','09:10:00',1.04),('3355','2013-08-17','09:15:00',1.08),('3355','2013-08-17','09:20:00',1.13),('3355','2013-08-17','09:25:00',1.17),('3355','2013-08-17','09:30:00',1.22),('3355','2013-08-17','09:35:00',1.26),('3355','2013-08-17','09:40:00',1.3),('3355','2013-08-17','09:45:00',1.34),('3355','2013-08-17','09:50:00',1.37),('3355','2013-08-17','09:55:00',1.41),('3355','2013-08-17','10:00:00',1.44),('3355','2013-08-17','10:05:00',1.48),('3355','2013-08-17','10:10:00',1.51),('3355','2013-08-17','10:15:00',1.55),('3355','2013-08-17','10:20:00',1.58),('3355','2013-08-17','10:25:00',1.6),('3355','2013-08-17','10:30:00',1.62),('3355','2013-08-17','10:35:00',1.67),('3355','2013-08-17','10:40:00',1.69),('3355','2013-08-17','10:45:00',1.71),('3355','2013-08-17','10:50:00',1.74),('3355','2013-08-17','10:55:00',1.77),('3355','2013-08-17','11:00:00',1.79),('3355','2013-08-17','11:05:00',1.81),('3355','2013-08-17','11:10:00',1.84),('3355','2013-08-17','11:15:00',1.86),('3355','2013-08-17','11:20:00',1.87),('3355','2013-08-17','11:25:00',1.88),('3355','2013-08-17','11:30:00',1.91),('3355','2013-08-17','11:35:00',1.92),('3355','2013-08-17','11:40:00',1.92),('3355','2013-08-17','11:45:00',1.95),('3355','2013-08-17','11:50:00',1.99),('3355','2013-08-17','11:55:00',2.03),('3355','2013-08-17','12:00:00',1.99),('3355','2013-08-17','12:05:00',2),('3355','2013-08-17','12:10:00',1.98),('3355','2013-08-17','12:15:00',2.03),('3355','2013-08-17','12:20:00',2.08),('3355','2013-08-17','12:25:00',1.78),('3355','2013-08-17','12:30:00',1.82),('3355','2013-08-17','12:40:00',2.05),('3355','2013-08-17','12:45:00',2.13),('3355','2013-08-17','12:50:00',2.12),('3355','2013-08-17','12:55:00',2.13),('3355','2013-08-17','13:00:00',2.14),('3355','2013-08-17','13:05:00',2.12),('3355','2013-08-17','13:10:00',2.15),('3355','2013-08-17','13:15:00',2.19),('3355','2013-08-17','13:20:00',2.18),('3355','2013-08-17','13:25:00',2.2),('3355','2013-08-17','13:30:00',2.21),('3355','2013-08-17','13:35:00',2.15),('3355','2013-08-17','13:40:00',1.5),('3355','2013-08-17','13:50:00',2.14),('3355','2013-08-17','14:05:00',2.07),('3355','2013-08-17','14:10:00',2.19),('3355','2013-08-17','14:20:00',1.75),('3355','2013-08-17','14:25:00',2.22),('3355','2013-08-17','14:30:00',2.15),('3355','2013-08-17','14:35:00',2.09),('3355','2013-08-17','14:40:00',2.11),('3355','2013-08-17','14:45:00',2.07),('3355','2013-08-17','14:50:00',2.05),('3355','2013-08-17','14:55:00',2.03),('3355','2013-08-17','15:00:00',2.04),('3355','2013-08-17','15:05:00',2.01),('3355','2013-08-17','15:10:00',1.99),('3355','2013-08-17','15:15:00',1.96),('3355','2013-08-17','15:20:00',1.95),('3355','2013-08-17','15:25:00',1.93),('3355','2013-08-17','15:30:00',1.91),('3355','2013-08-17','15:35:00',1.89),('3355','2013-08-17','15:40:00',1.87),('3355','2013-08-17','15:45:00',1.84),('3355','2013-08-17','15:50:00',1.83),('3355','2013-08-17','15:55:00',1.81),('3355','2013-08-17','16:00:00',1.77),('3355','2013-08-17','16:05:00',1.74),('3355','2013-08-17','16:10:00',1.73),('3355','2013-08-17','16:15:00',1.71),('3355','2013-08-17','16:20:00',1.66),('3355','2013-08-17','16:25:00',1.64),('3355','2013-08-17','16:30:00',1.58),('3355','2013-08-17','16:35:00',1.57),('3355','2013-08-17','16:40:00',1.56),('3355','2013-08-17','16:45:00',1.52),('3355','2013-08-17','16:50:00',1.44),('3355','2013-08-17','16:55:00',1.43),('3355','2013-08-17','17:00:00',1.4),('3355','2013-08-17','17:05:00',1.34),('3355','2013-08-17','17:10:00',1.31),('3355','2013-08-17','17:15:00',1.11),('3355','2013-08-17','17:20:00',1.19),('3355','2013-08-17','17:25:00',1.18),('3355','2013-08-17','17:30:00',1.18),('3355','2013-08-17','17:35:00',1.14),('3355','2013-08-17','17:40:00',1.1),('3355','2013-08-17','17:45:00',1.05),('3355','2013-08-16','09:05:00',1.02),('3355','2013-08-16','09:10:00',1.07),('3355','2013-08-16','09:15:00',1.11),('3355','2013-08-16','09:20:00',1.16),('3355','2013-08-16','09:25:00',1.2),('3355','2013-08-16','09:30:00',1.25),('3355','2013-08-16','09:35:00',1.29),('3355','2013-08-16','09:40:00',1.33),('3355','2013-08-16','09:45:00',1.38),('3355','2013-08-16','09:50:00',1.42),('3355','2013-08-16','09:55:00',1.45),('3355','2013-08-16','10:00:00',1.49),('3355','2013-08-16','10:05:00',1.53),('3355','2013-08-16','10:10:00',1.56),('3355','2013-08-16','10:15:00',1.59),('3355','2013-08-16','10:20:00',1.62),('3355','2013-08-16','10:25:00',1.66),('3355','2013-08-16','10:30:00',1.69),('3355','2013-08-16','10:35:00',1.72),('3355','2013-08-16','10:40:00',1.74),('3355','2013-08-16','10:45:00',1.76),('3355','2013-08-16','10:50:00',1.79),('3355','2013-08-16','10:55:00',1.82),('3355','2013-08-16','11:00:00',1.84),('3355','2013-08-16','11:05:00',1.87),('3355','2013-08-16','11:10:00',1.89),('3355','2013-08-16','11:15:00',1.92),('3355','2013-08-16','11:20:00',1.92),('3355','2013-08-16','11:25:00',1.94),('3355','2013-08-16','11:30:00',1.96),('3355','2013-08-16','11:35:00',1.99),('3355','2013-08-16','11:40:00',2),('3355','2013-08-16','11:45:00',2.01),('3355','2013-08-16','11:50:00',2.02),('3355','2013-08-16','11:55:00',2.03),('3355','2013-08-16','12:00:00',2.05),('3355','2013-08-16','12:05:00',2.05),('3355','2013-08-16','12:10:00',2.06),('3355','2013-08-16','12:15:00',2.08),('3355','2013-08-16','12:20:00',2.09),('3355','2013-08-16','12:25:00',2.1),('3355','2013-08-16','12:30:00',2.11),('3355','2013-08-16','12:35:00',2.11),('3355','2013-08-16','12:40:00',2.12),('3355','2013-08-16','12:45:00',2.13),('3355','2013-08-16','12:50:00',2.13),('3355','2013-08-16','12:55:00',2.13),('3355','2013-08-16','13:00:00',2.13),('3355','2013-08-16','13:05:00',2.13),('3355','2013-08-16','13:10:00',2.15),('3355','2013-08-16','13:15:00',2.14),('3355','2013-08-16','13:20:00',2.13),('3355','2013-08-16','13:25:00',2.12),('3355','2013-08-16','13:30:00',2.12),('3355','2013-08-16','13:35:00',2.12),('3355','2013-08-16','13:40:00',2.11),('3355','2013-08-16','13:45:00',2.11),('3355','2013-08-16','13:50:00',2.11),('3355','2013-08-16','13:55:00',2.11),('3355','2013-08-16','14:00:00',2.11),('3355','2013-08-16','14:05:00',2.12),('3355','2013-08-16','14:10:00',2.1),('3355','2013-08-16','14:15:00',2.1),('3355','2013-08-16','14:20:00',2.1),('3355','2013-08-16','14:25:00',2.08),('3355','2013-08-16','14:30:00',2.07),('3355','2013-08-16','14:35:00',2.07),('3355','2013-08-16','14:40:00',2.04),('3355','2013-08-16','14:45:00',2.01),('3355','2013-08-16','14:50:00',2),('3355','2013-08-16','14:55:00',1.99),('3355','2013-08-16','15:00:00',1.98),('3355','2013-08-16','15:05:00',1.95),('3355','2013-08-16','15:10:00',1.95),('3355','2013-08-16','15:15:00',1.95),('3355','2013-08-16','15:20:00',1.91),('3355','2013-08-16','15:25:00',1.91),('3355','2013-08-16','15:30:00',1.9),('3355','2013-08-16','15:35:00',1.88),('3355','2013-08-16','15:40:00',1.86),('3355','2013-08-16','15:45:00',1.83),('3355','2013-08-16','15:50:00',1.82),('3355','2013-08-16','15:55:00',1.79),('3355','2013-08-16','16:00:00',1.77),('3355','2013-08-16','16:05:00',1.74),('3355','2013-08-16','16:10:00',1.71),('3355','2013-08-16','16:15:00',1.69),('3355','2013-08-16','16:20:00',1.66),('3355','2013-08-16','16:25:00',1.63),('3355','2013-08-16','16:30:00',1.6),('3355','2013-08-16','16:35:00',1.56),('3355','2013-08-16','16:40:00',1.53),('3355','2013-08-16','16:45:00',1.49),('3355','2013-08-16','16:50:00',1.45),('3355','2013-08-16','16:55:00',1.41),('3355','2013-08-16','17:00:00',1.37),('3355','2013-08-16','17:05:00',1.34),('3355','2013-08-16','17:10:00',1.3),('3355','2013-08-16','17:15:00',1.25),('3355','2013-08-16','17:20:00',1.21),('3355','2013-08-16','17:25:00',1.16),('3355','2013-08-16','17:30:00',1.12),('3355','2013-08-16','17:35:00',1.07),('3355','2013-08-16','17:40:00',1.02),('3355','2013-08-15','09:20:00',1.24),('3355','2013-08-15','09:25:00',1.22),('3355','2013-08-15','09:30:00',1.25),('3355','2013-08-15','09:35:00',1.29),('3355','2013-08-15','09:40:00',1.33),('3355','2013-08-15','09:45:00',1.37),('3355','2013-08-15','09:50:00',1.42),('3355','2013-08-15','09:55:00',1.46),('3355','2013-08-15','10:00:00',1.49),('3355','2013-08-15','10:05:00',1.53),('3355','2013-08-15','10:10:00',1.56),('3355','2013-08-15','10:15:00',1.6),('3355','2013-08-15','10:20:00',1.64),('3355','2013-08-15','10:25:00',1.68),('3355','2013-08-15','10:30:00',1.71),('3355','2013-08-15','10:35:00',1.72),('3355','2013-08-15','10:40:00',1.75),('3355','2013-08-15','10:45:00',1.75),('3355','2013-08-15','10:50:00',1.72),('3355','2013-08-15','10:55:00',1.71),('3355','2013-08-15','11:00:00',1.57),('3355','2013-08-15','11:05:00',1.3),('3355','2013-08-15','11:10:00',1.37),('3355','2013-08-15','11:15:00',1.54),('3355','2013-08-15','11:20:00',1.67),('3355','2013-08-15','11:25:00',1.84),('3355','2013-08-15','11:30:00',1.96),('3355','2013-08-15','11:35:00',2.05),('3355','2013-08-15','11:40:00',2.1),('3355','2013-08-15','11:45:00',2.18),('3355','2013-08-15','11:50:00',2.2),('3355','2013-08-15','11:55:00',2.18),('3355','2013-08-15','12:00:00',2.2),('3355','2013-08-15','12:05:00',2.19),('3355','2013-08-15','12:10:00',2.17),('3355','2013-08-15','12:15:00',2.18),('3355','2013-08-15','12:20:00',2.18),('3355','2013-08-15','12:25:00',2.19),('3355','2013-08-15','12:30:00',2.18),('3355','2013-08-15','12:35:00',2.2),('3355','2013-08-15','12:40:00',2.18),('3355','2013-08-15','12:45:00',2.19),('3355','2013-08-15','12:50:00',2.16),('3355','2013-08-15','12:55:00',2.1),('3355','2013-08-15','13:00:00',2.15),('3355','2013-08-15','13:05:00',2.08),('3355','2013-08-15','13:10:00',2.07),('3355','2013-08-15','13:15:00',2.03),('3355','2013-08-15','13:20:00',2.14),('3355','2013-08-15','13:25:00',2.18),('3355','2013-08-15','13:30:00',2.18),('3355','2013-08-15','13:35:00',2.18),('3355','2013-08-15','13:40:00',2.16),('3355','2013-08-15','13:45:00',2.14),('3355','2013-08-15','13:50:00',2.13),('3355','2013-08-15','13:55:00',2.14),('3355','2013-08-15','14:00:00',2.16),('3355','2013-08-15','14:05:00',2.14),('3355','2013-08-15','14:10:00',2.12),('3355','2013-08-15','14:15:00',2.13),('3355','2013-08-15','14:20:00',2.11),('3355','2013-08-15','14:25:00',2.03),('3355','2013-08-15','14:30:00',2.03),('3355','2013-08-15','14:35:00',2.08),('3355','2013-08-15','14:40:00',2.05),('3355','2013-08-15','14:45:00',2.02),('3355','2013-08-15','14:50:00',2.02),('3355','2013-08-15','14:55:00',2),('3355','2013-08-15','15:00:00',1.99),('3355','2013-08-15','15:05:00',1.96),('3355','2013-08-15','15:10:00',1.94),('3355','2013-08-15','15:15:00',1.92),('3355','2013-08-15','15:20:00',1.89),('3355','2013-08-15','15:25:00',1.86),('3355','2013-08-15','15:30:00',1.85),('3355','2013-08-15','15:35:00',1.85),('3355','2013-08-15','15:40:00',1.81),('3355','2013-08-15','15:45:00',1.78),('3355','2013-08-15','15:50:00',1.75),('3355','2013-08-15','15:55:00',1.75),('3355','2013-08-15','16:00:00',1.71),('3355','2013-08-15','16:05:00',1.67),('3355','2013-08-15','16:10:00',1.64),('3355','2013-08-15','16:15:00',1.62),('3355','2013-08-15','16:20:00',1.6),('3355','2013-08-15','16:25:00',1.54),('3355','2013-08-15','16:30:00',1.46),('3355','2013-08-15','16:35:00',1.46),('3355','2013-08-15','16:40:00',1.46),('3355','2013-08-15','16:45:00',1.41),('3355','2013-08-15','16:50:00',1.39),('3355','2013-08-15','16:55:00',1.34),('3355','2013-08-15','17:00:00',1.31),('3355','2013-08-15','17:05:00',1.27),('3355','2013-08-15','17:10:00',1.22),('3355','2013-08-15','17:15:00',1.22),('3355','2013-08-15','17:20:00',1.16),('3355','2013-08-15','17:25:00',1.1),('3355','2013-08-15','17:30:00',1.08),('3355','2013-08-15','17:35:00',1.03),('3355','2013-08-14','09:05:00',1.02),('3355','2013-08-14','09:10:00',1.07),('3355','2013-08-14','09:15:00',1.11),('3355','2013-08-14','09:20:00',1.17),('3355','2013-08-14','09:25:00',1.14),('3355','2013-08-14','09:30:00',1.27),('3355','2013-08-14','09:35:00',1.3),('3355','2013-08-14','09:40:00',1.06),('3355','2013-08-14','10:05:00',1.25),('3355','2013-08-14','10:10:00',1.46),('3355','2013-08-14','10:15:00',1.25),('3355','2013-08-14','10:30:00',1.24),('3355','2013-08-14','10:35:00',1.84),('3355','2013-08-14','10:40:00',1.89),('3355','2013-08-14','10:45:00',1.83),('3355','2013-08-14','10:50:00',1.55),('3355','2013-08-14','10:55:00',1.6),('3355','2013-08-14','11:00:00',1.83),('3355','2013-08-14','11:05:00',1.95),('3355','2013-08-14','11:10:00',1.44),('3355','2013-08-14','11:15:00',1.88),('3355','2013-08-14','11:20:00',1.73),('3355','2013-08-14','11:25:00',1.34),('3355','2013-08-14','11:30:00',1.94),('3355','2013-08-14','11:35:00',2),('3355','2013-08-14','11:40:00',2.02),('3355','2013-08-14','11:45:00',1.89),('3355','2013-08-14','11:50:00',1.97),('3355','2013-08-14','11:55:00',1.02),('3355','2013-08-14','12:05:00',1.41),('3355','2013-08-14','12:10:00',1.83),('3355','2013-08-14','12:15:00',1.7),('3355','2013-08-14','12:55:00',1.26),('3355','2013-08-14','13:30:00',1.54),('3355','2013-08-14','13:35:00',1.01),('3355','2013-08-14','13:40:00',1.24),('3355','2013-08-14','13:45:00',2.44),('3355','2013-08-14','13:50:00',2.06),('3355','2013-08-14','13:55:00',2.17),('3355','2013-08-14','14:00:00',1.11),('3355','2013-08-14','14:05:00',2.46),('3355','2013-08-14','14:10:00',2.34),('3355','2013-08-14','14:15:00',2.26),('3355','2013-08-14','14:20:00',2.23),('3355','2013-08-14','14:25:00',2.25),('3355','2013-08-14','14:30:00',2.08),('3355','2013-08-14','14:35:00',2.21),('3355','2013-08-14','14:40:00',2.16),('3355','2013-08-14','14:45:00',2.12),('3355','2013-08-14','14:50:00',2.08),('3355','2013-08-14','14:55:00',2.08),('3355','2013-08-14','15:00:00',2.07),('3355','2013-08-14','15:05:00',2.05),('3355','2013-08-14','15:10:00',2.04),('3355','2013-08-14','15:15:00',2.08),('3355','2013-08-14','15:20:00',2.05),('3355','2013-08-14','15:25:00',1.98),('3355','2013-08-14','15:30:00',1.93),('3355','2013-08-14','15:35:00',1.91),('3355','2013-08-14','15:40:00',1.9),('3355','2013-08-14','15:45:00',1.87),('3355','2013-08-14','15:50:00',1.85),('3355','2013-08-14','15:55:00',1.81),('3355','2013-08-14','16:00:00',1.78),('3355','2013-08-14','16:05:00',1.77),('3355','2013-08-14','16:10:00',1.76),('3355','2013-08-14','16:15:00',1.72),('3355','2013-08-14','16:20:00',1.72),('3355','2013-08-14','16:25:00',1.66),('3355','2013-08-14','16:30:00',1.64),('3355','2013-08-14','16:35:00',1.61),('3355','2013-08-14','16:40:00',1.57),('3355','2013-08-14','16:45:00',1.53),('3355','2013-08-14','16:50:00',1.5),('3355','2013-08-14','16:55:00',1.46),('3355','2013-08-14','17:00:00',1.41),('3355','2013-08-14','17:05:00',1.37),('3355','2013-08-14','17:10:00',1.33),('3355','2013-08-14','17:15:00',1.29),('3355','2013-08-14','17:20:00',1.24),('3355','2013-08-14','17:25:00',1.19),('3355','2013-08-14','17:30:00',1.16),('3355','2013-08-14','17:35:00',1.1),('3355','2013-08-14','17:40:00',1.06),('3355','2013-08-14','17:45:00',1.01),('3355','2013-08-13','09:05:00',1.02),('3355','2013-08-13','09:10:00',1.06),('3355','2013-08-13','09:15:00',1.1),('3355','2013-08-13','09:20:00',1.13),('3355','2013-08-13','09:25:00',1.2),('3355','2013-08-13','09:30:00',1.25),('3355','2013-08-13','09:35:00',1.26),('3355','2013-08-13','09:40:00',1.25),('3355','2013-08-13','09:45:00',1.32),('3355','2013-08-13','09:50:00',1.37),('3355','2013-08-13','09:55:00',1.41),('3355','2013-08-13','10:00:00',1.42),('3355','2013-08-13','10:05:00',1.46),('3355','2013-08-13','10:10:00',1.28),('3355','2013-08-13','10:15:00',1.5),('3355','2013-08-13','10:20:00',1.58),('3355','2013-08-13','10:25:00',1.61),('3355','2013-08-13','10:30:00',1.63),('3355','2013-08-13','10:35:00',1.64),('3355','2013-08-13','10:40:00',1.71),('3355','2013-08-13','10:45:00',1.74),('3355','2013-08-13','10:50:00',1.76),('3355','2013-08-13','10:55:00',1.79),('3355','2013-08-13','11:00:00',1.82),('3355','2013-08-13','11:05:00',1.85),('3355','2013-08-13','11:10:00',1.87),('3355','2013-08-13','11:15:00',1.85),('3355','2013-08-13','11:20:00',1.87),('3355','2013-08-13','11:25:00',1.91),('3355','2013-08-13','11:30:00',1.94),('3355','2013-08-13','11:35:00',1.93),('3355','2013-08-13','11:40:00',1.96),('3355','2013-08-13','11:45:00',1.95),('3355','2013-08-13','11:50:00',2),('3355','2013-08-13','11:55:00',2.06),('3355','2013-08-13','12:00:00',2.05),('3355','2013-08-13','12:05:00',2.09),('3355','2013-08-13','12:10:00',2.14),('3355','2013-08-13','12:15:00',2.08),('3355','2013-08-13','12:20:00',2.08),('3355','2013-08-13','12:25:00',2.22),('3355','2013-08-13','12:30:00',2.22),('3355','2013-08-13','12:35:00',2.19),('3355','2013-08-13','12:40:00',2.25),('3355','2013-08-13','12:45:00',1.79),('3355','2013-08-13','12:55:00',2.08),('3355','2013-08-13','13:00:00',1.67),('3355','2013-08-13','13:15:00',1.29),('3355','2013-08-13','13:20:00',2.49),('3355','2013-08-13','13:25:00',2.41),('3355','2013-08-13','13:30:00',2.34),('3355','2013-08-13','13:35:00',2.3),('3355','2013-08-13','13:40:00',1.8),('3355','2013-08-13','13:50:00',1.17),('3355','2013-08-13','13:55:00',2.13),('3355','2013-08-13','14:00:00',1.99),('3355','2013-08-13','14:05:00',1.22),('3355','2013-08-13','14:10:00',2.42),('3355','2013-08-13','14:15:00',2.41),('3355','2013-08-13','14:20:00',2.25),('3355','2013-08-13','14:25:00',1.21),('3355','2013-08-13','14:30:00',1.01),('3355','2013-08-13','14:35:00',2.36),('3355','2013-08-13','14:50:00',2),('3355','2013-08-13','14:55:00',2.36),('3355','2013-08-13','15:00:00',2.08),('3355','2013-08-13','15:05:00',1.98),('3355','2013-08-13','15:10:00',1.82),('3355','2013-08-13','15:15:00',1.66),('3355','2013-08-13','15:20:00',2.07),('3355','2013-08-13','15:25:00',2.02),('3355','2013-08-13','15:30:00',1.91),('3355','2013-08-13','15:35:00',1.97),('3355','2013-08-13','15:40:00',1.99),('3355','2013-08-13','15:45:00',1.9),('3355','2013-08-13','15:50:00',1.86),('3355','2013-08-13','15:55:00',1.82),('3355','2013-08-13','16:00:00',1.79),('3355','2013-08-13','16:05:00',1.77),('3355','2013-08-13','16:10:00',1.74),('3355','2013-08-13','16:15:00',1.71),('3355','2013-08-13','16:20:00',1.68),('3355','2013-08-13','16:25:00',1.65),('3355','2013-08-13','16:30:00',1.62),('3355','2013-08-13','16:35:00',1.59),('3355','2013-08-13','16:40:00',1.55),('3355','2013-08-13','16:45:00',1.51),('3355','2013-08-13','16:50:00',1.47),('3355','2013-08-13','16:55:00',1.44),('3355','2013-08-13','17:00:00',1.4),('3355','2013-08-13','17:05:00',1.37),('3355','2013-08-13','17:10:00',1.33),('3355','2013-08-13','17:15:00',1.29),('3355','2013-08-13','17:20:00',1.24),('3355','2013-08-13','17:25:00',1.2),('3355','2013-08-13','17:30:00',1.15),('3355','2013-08-13','17:35:00',1.11),('3355','2013-08-13','17:40:00',1.06),('3355','2013-08-13','17:45:00',1.01),('3355','2013-08-12','09:10:00',1.04),('3355','2013-08-12','09:15:00',1.09),('3355','2013-08-12','09:20:00',1.14),('3355','2013-08-12','09:25:00',1.17),('3355','2013-08-12','09:30:00',1.22),('3355','2013-08-12','09:35:00',1.25),('3355','2013-08-12','09:40:00',1.29),('3355','2013-08-12','09:45:00',1.33),('3355','2013-08-12','09:50:00',1.37),('3355','2013-08-12','09:55:00',1.4),('3355','2013-08-12','10:00:00',1.44),('3355','2013-08-12','10:05:00',1.47),('3355','2013-08-12','10:10:00',1.5),('3355','2013-08-12','10:15:00',1.53),('3355','2013-08-12','10:20:00',1.57),('3355','2013-08-12','10:25:00',1.6),('3355','2013-08-12','10:30:00',1.63),('3355','2013-08-12','10:35:00',1.66),('3355','2013-08-12','10:40:00',1.69),('3355','2013-08-12','10:45:00',1.72),('3355','2013-08-12','10:50:00',1.74),('3355','2013-08-12','10:55:00',1.76),('3355','2013-08-12','11:00:00',1.78),('3355','2013-08-12','11:05:00',1.8),('3355','2013-08-12','11:10:00',1.82),('3355','2013-08-12','11:15:00',1.86),('3355','2013-08-12','11:20:00',1.84),('3355','2013-08-12','11:25:00',1.85),('3355','2013-08-12','11:30:00',1.85),('3355','2013-08-12','11:35:00',1.92),('3355','2013-08-12','11:40:00',1.97),('3355','2013-08-12','11:45:00',1.98),('3355','2013-08-12','11:50:00',2.01),('3355','2013-08-12','11:55:00',1.99),('3355','2013-08-12','12:00:00',2.08),('3355','2013-08-12','12:05:00',2.1),('3355','2013-08-12','12:10:00',2.13),('3355','2013-08-12','12:15:00',2.01),('3355','2013-08-12','12:20:00',1.77),('3355','2013-08-12','12:25:00',1.25),('3355','2013-08-12','12:50:00',1.49),('3355','2013-08-12','12:55:00',1.09),('3355','2013-08-12','13:50:00',1.47),('3355','2013-08-12','13:55:00',1.41),('3355','2013-08-12','14:10:00',1.12),('3355','2013-08-12','14:50:00',1.16),('3355','2013-08-12','14:55:00',2.38),('3355','2013-08-12','15:00:00',2.27),('3355','2013-08-12','15:05:00',2.18),('3355','2013-08-12','15:10:00',2.12),('3355','2013-08-12','15:15:00',2.06),('3355','2013-08-12','15:20:00',1.97),('3355','2013-08-12','15:25:00',2.02),('3355','2013-08-12','15:30:00',1.96),('3355','2013-08-12','15:35:00',1.9),('3355','2013-08-12','15:40:00',1.91),('3355','2013-08-12','15:45:00',1.85),('3355','2013-08-12','15:50:00',1.86),('3355','2013-08-12','15:55:00',1.84),('3355','2013-08-12','16:00:00',1.79),('3355','2013-08-12','16:05:00',1.77),('3355','2013-08-12','16:10:00',1.75),('3355','2013-08-12','16:15:00',1.71),('3355','2013-08-12','16:20:00',1.65),('3355','2013-08-12','16:25:00',1.62),('3355','2013-08-12','16:30:00',1.59),('3355','2013-08-12','16:35:00',1.56),('3355','2013-08-12','16:40:00',1.53),('3355','2013-08-12','16:45:00',1.48),('3355','2013-08-12','16:50:00',1.47),('3355','2013-08-12','16:55:00',1.37),('3355','2013-08-12','17:00:00',1.36),('3355','2013-08-12','17:05:00',1.34),('3355','2013-08-12','17:10:00',1.3),('3355','2013-08-12','17:15:00',1.25),('3355','2013-08-12','17:20:00',1.21),('3355','2013-08-12','17:25:00',1.17),('3355','2013-08-12','17:30:00',1.13),('3355','2013-08-12','17:35:00',1.09),('3355','2013-08-12','17:40:00',1.04),('3355','2013-08-11','09:05:00',1.02),('3355','2013-08-11','09:10:00',1.07),('3355','2013-08-11','09:15:00',1.1),('3355','2013-08-11','09:20:00',1.16),('3355','2013-08-11','09:25:00',1.2),('3355','2013-08-11','09:30:00',1.24),('3355','2013-08-11','09:35:00',1.28),('3355','2013-08-11','09:40:00',1.32),('3355','2013-08-11','09:45:00',1.37),('3355','2013-08-11','09:50:00',1.4),('3355','2013-08-11','09:55:00',1.44),('3355','2013-08-11','10:00:00',1.48),('3355','2013-08-11','10:05:00',1.52),('3355','2013-08-11','10:10:00',1.56),('3355','2013-08-11','10:15:00',1.6),('3355','2013-08-11','10:20:00',1.63),('3355','2013-08-11','10:25:00',1.66),('3355','2013-08-11','10:30:00',1.7),('3355','2013-08-11','10:35:00',1.71),('3355','2013-08-11','10:40:00',1.74),('3355','2013-08-11','10:45:00',1.77),('3355','2013-08-11','10:50:00',1.8),('3355','2013-08-11','10:55:00',1.82),('3355','2013-08-11','11:00:00',1.85),('3355','2013-08-11','11:05:00',1.87),('3355','2013-08-11','11:10:00',1.9),('3355','2013-08-11','11:15:00',1.91),('3355','2013-08-11','11:20:00',1.94),('3355','2013-08-11','11:25:00',1.96),('3355','2013-08-11','11:30:00',1.97),('3355','2013-08-11','11:35:00',1.99),('3355','2013-08-11','11:40:00',2.01),('3355','2013-08-11','11:45:00',2.01),('3355','2013-08-11','11:50:00',2.04),('3355','2013-08-11','11:55:00',2.04),('3355','2013-08-11','12:00:00',2.05),('3355','2013-08-11','12:05:00',2.07),('3355','2013-08-11','12:10:00',2.08),('3355','2013-08-11','12:15:00',2.08),('3355','2013-08-11','12:20:00',2.09),('3355','2013-08-11','12:25:00',2.1),('3355','2013-08-11','12:30:00',2.12),('3355','2013-08-11','12:35:00',2.13),('3355','2013-08-11','12:40:00',2.12),('3355','2013-08-11','12:45:00',2.11),('3355','2013-08-11','12:50:00',2.12),('3355','2013-08-11','12:55:00',2.15),('3355','2013-08-11','13:00:00',2.16),('3355','2013-08-11','13:05:00',2.14),('3355','2013-08-11','13:10:00',2.14),('3355','2013-08-11','13:15:00',2.16),('3355','2013-08-11','13:20:00',2.15),('3355','2013-08-11','13:25:00',2.16),('3355','2013-08-11','13:30:00',2.16),('3355','2013-08-11','13:35:00',2.14),('3355','2013-08-11','13:40:00',2.13),('3355','2013-08-11','13:45:00',2.13),('3355','2013-08-11','13:50:00',2.12),('3355','2013-08-11','13:55:00',2.12),('3355','2013-08-11','14:00:00',2.12),('3355','2013-08-11','14:05:00',2.11),('3355','2013-08-11','14:10:00',2.11),('3355','2013-08-11','14:15:00',2.05),('3355','2013-08-11','14:20:00',2.04),('3355','2013-08-11','14:25:00',2.04),('3355','2013-08-11','14:30:00',2.05),('3355','2013-08-11','14:35:00',2.05),('3355','2013-08-11','14:40:00',2.06),('3355','2013-08-11','14:45:00',2.04),('3355','2013-08-11','14:50:00',2),('3355','2013-08-11','14:55:00',1.98),('3355','2013-08-11','15:00:00',2.02),('3355','2013-08-11','15:05:00',2),('3355','2013-08-11','15:10:00',1.97),('3355','2013-08-11','15:15:00',1.93),('3355','2013-08-11','15:20:00',1.92),('3355','2013-08-11','15:25:00',1.91),('3355','2013-08-11','15:30:00',1.9),('3355','2013-08-11','15:35:00',1.84),('3355','2013-08-11','15:40:00',1.85),('3355','2013-08-11','15:45:00',1.82),('3355','2013-08-11','15:50:00',1.82),('3355','2013-08-11','15:55:00',1.8),('3355','2013-08-11','16:00:00',1.77),('3355','2013-08-11','16:05:00',1.74),('3355','2013-08-11','16:10:00',1.71),('3355','2013-08-11','16:15:00',1.68),('3355','2013-08-11','16:20:00',1.65),('3355','2013-08-11','16:25:00',1.61),('3355','2013-08-11','16:30:00',1.59),('3355','2013-08-11','16:35:00',1.56),('3355','2013-08-11','16:40:00',1.52),('3355','2013-08-11','16:45:00',1.48),('3355','2013-08-11','16:50:00',1.45),('3355','2013-08-11','16:55:00',1.41),('3355','2013-08-11','17:00:00',1.37),('3355','2013-08-11','17:05:00',1.33),('3355','2013-08-11','17:10:00',1.29),('3355','2013-08-11','17:15:00',1.25),('3355','2013-08-11','17:20:00',1.21),('3355','2013-08-11','17:25:00',1.17),('3355','2013-08-11','17:30:00',1.13),('3355','2013-08-11','17:35:00',1.09),('3355','2013-08-11','17:40:00',1.04),('3355','2013-08-10','09:05:00',1.04),('3355','2013-08-10','09:10:00',1.09),('3355','2013-08-10','09:15:00',1.14),('3355','2013-08-10','09:20:00',1.18),('3355','2013-08-10','09:25:00',1.23),('3355','2013-08-10','09:30:00',1.01),('3355','2013-08-10','09:35:00',1.3),('3355','2013-08-10','09:40:00',1.34),('3355','2013-08-10','09:45:00',1.38),('3355','2013-08-10','09:50:00',1.42),('3355','2013-08-10','09:55:00',1.45),('3355','2013-08-10','10:00:00',1.49),('3355','2013-08-10','10:05:00',1.52),('3355','2013-08-10','10:10:00',1.55),('3355','2013-08-10','10:15:00',1.59),('3355','2013-08-10','10:20:00',1.62),('3355','2013-08-10','10:25:00',1.65),('3355','2013-08-10','10:30:00',1.69),('3355','2013-08-10','10:35:00',1.72),('3355','2013-08-10','10:40:00',1.74),('3355','2013-08-10','10:45:00',1.77),('3355','2013-08-10','10:50:00',1.8),('3355','2013-08-10','10:55:00',1.83),('3355','2013-08-10','11:00:00',1.88),('3355','2013-08-10','11:05:00',1.9),('3355','2013-08-10','11:10:00',1.94),('3355','2013-08-10','11:15:00',1.17),('3355','2013-08-10','11:20:00',1.71),('3355','2013-08-10','11:25:00',1.08),('3355','2013-08-10','11:30:00',1.59),('3355','2013-08-10','11:35:00',2.06),('3355','2013-08-10','11:40:00',2.04),('3355','2013-08-10','11:45:00',2.04),('3355','2013-08-10','11:50:00',2.05),('3355','2013-08-10','11:55:00',2.05),('3355','2013-08-10','12:00:00',2.08),('3355','2013-08-10','12:05:00',2.08),('3355','2013-08-10','12:10:00',2.09),('3355','2013-08-10','12:15:00',2.09),('3355','2013-08-10','12:20:00',2.11),('3355','2013-08-10','12:25:00',2.14),('3355','2013-08-10','12:30:00',2.14),('3355','2013-08-10','12:35:00',2.15),('3355','2013-08-10','12:40:00',2.17),('3355','2013-08-10','12:45:00',2.2),('3355','2013-08-10','12:50:00',2.23),('3355','2013-08-10','12:55:00',2.24),('3355','2013-08-10','13:00:00',2.22),('3355','2013-08-10','13:05:00',2.2),('3355','2013-08-10','13:10:00',2.22),('3355','2013-08-10','13:15:00',2.25),('3355','2013-08-10','13:20:00',2.28),('3355','2013-08-10','13:25:00',2.27),('3355','2013-08-10','13:30:00',2.13),('3355','2013-08-10','13:35:00',2.1),('3355','2013-08-10','13:50:00',2.37),('3355','2013-08-10','13:55:00',2.29),('3355','2013-08-10','14:00:00',1.73),('3355','2013-08-10','14:05:00',1.31),('3355','2013-08-10','14:10:00',2.53),('3355','2013-08-10','14:15:00',2.17),('3355','2013-08-10','14:20:00',1.03),('3355','2013-08-10','15:55:00',1.04),('3355','2013-08-10','16:00:00',1.04),('3355','2013-08-10','16:05:00',1.96),('3355','2013-08-10','16:10:00',1.07),('3355','2013-08-10','16:15:00',1.04),('3355','2013-08-10','16:20:00',1.25),('3355','2013-08-10','16:35:00',1.86),('3355','2013-08-10','16:40:00',1.71),('3355','2013-08-10','16:45:00',1.66),('3355','2013-08-10','16:50:00',1.57),('3355','2013-08-10','16:55:00',1.47),('3355','2013-08-10','17:00:00',1.39),('3355','2014-04-09','09:55:00',1.52),('3355','2014-04-09','10:00:00',1.52),('3355','2014-04-09','10:05:00',1.54),('3355','2014-04-09','10:10:00',1.6),('3355','2014-04-09','10:15:00',1.68),('3355','2014-04-09','10:20:00',1.7),('3355','2014-04-09','10:25:00',1.78),('3355','2014-04-09','10:30:00',1.88),('3355','2014-04-09','10:35:00',2.05),('3355','2014-04-09','10:40:00',1.26),('3355','2014-04-09','11:00:00',1.97),('3355','2014-04-09','11:05:00',2.19),('3355','2014-04-09','11:10:00',2.21),('3355','2014-04-09','11:15:00',2.3),('3355','2014-04-09','11:20:00',2.11),('3355','2014-04-09','11:25:00',1.02),('3355','2014-04-09','11:40:00',1.74),('3355','2014-04-09','11:45:00',2.55),('3355','2014-04-09','11:50:00',2.39),('3355','2014-04-09','11:55:00',2.52),('3355','2014-04-09','12:00:00',2.5),('3355','2014-04-09','12:05:00',2.35),('3355','2014-04-09','12:10:00',1.01),('3355','2014-04-09','14:10:00',1.5),('3355','2014-04-09','14:20:00',1.47),('3355','2014-04-09','14:30:00',1.1),('3355','2014-04-09','14:35:00',2.48),('3355','2014-04-09','14:40:00',1.55),('3355','2014-04-09','14:50:00',1.05),('3355','2014-04-09','14:55:00',1.32),('3355','2014-04-09','15:00:00',1.24),('3355','2014-04-09','15:05:00',2.25),('3355','2014-04-09','15:10:00',2.11),('3355','2014-04-09','15:15:00',2.01),('3355','2014-04-09','15:20:00',1.89),('3355','2014-04-09','15:25:00',1.26),('3355','2014-04-09','15:30:00',2.15),('3355','2014-04-09','15:35:00',1.43),('3355','2014-04-09','15:45:00',1.23),('3355','2014-04-09','15:50:00',1.25),('3355','2014-04-09','16:05:00',1.11),('3355','2014-04-09','16:10:00',1.02),('3355','2014-04-09','16:15:00',1.85),('3355','2014-04-09','16:20:00',1.86),('3355','2014-04-09','16:25:00',1.76),('3355','2014-04-09','16:30:00',1.5),('3355','2014-04-09','16:50:00',1.27),('3355','2014-04-09','17:05:00',1.45),('3355','2014-04-09','17:10:00',1.42),('3355','2014-04-09','17:15:00',1.22),('3355','2014-04-09','17:20:00',1.22),('3355','2014-04-09','17:25:00',1.24),('3355','2013-08-09','09:10:00',1.08),('3355','2013-08-09','09:30:00',1.22),('3355','2013-08-09','09:35:00',1.29),('3355','2013-08-09','09:45:00',1.16),('3355','2013-08-09','09:50:00',1.34),('3355','2013-08-09','09:55:00',1.02),('3355','2013-08-09','10:00:00',1.03),('3355','2013-08-09','10:05:00',1.13),('3355','2013-08-09','10:10:00',1.36),('3355','2013-08-09','10:15:00',1.4),('3355','2013-08-09','10:20:00',1.42),('3355','2013-08-09','10:25:00',1.28),('3355','2013-08-09','10:30:00',1.45),('3355','2013-08-09','10:35:00',1.57),('3355','2013-08-09','10:40:00',1.6),('3355','2013-08-09','10:45:00',1.57),('3355','2013-08-09','10:50:00',1.6),('3355','2013-08-09','10:55:00',1.66),('3355','2013-08-09','11:00:00',1.68),('3355','2013-08-09','11:05:00',1.7),('3355','2013-08-09','11:10:00',1.73),('3355','2013-08-09','11:15:00',1.76),('3355','2013-08-09','11:20:00',1.76),('3355','2013-08-09','11:25:00',1.78),('3355','2013-08-09','11:30:00',1.82),('3355','2013-08-09','11:35:00',1.83),('3355','2013-08-09','11:40:00',1.83),('3355','2013-08-09','11:45:00',1.84),('3355','2013-08-09','11:50:00',1.86),('3355','2013-08-09','11:55:00',1.9),('3355','2013-08-09','12:00:00',1.9),('3355','2013-08-09','12:05:00',1.9),('3355','2013-08-09','12:10:00',1.93),('3355','2013-08-09','12:15:00',1.96),('3355','2013-08-09','12:20:00',2.03),('3355','2013-08-09','12:25:00',1.97),('3355','2013-08-09','12:30:00',1.3),('3355','2013-08-09','12:35:00',1.74),('3355','2013-08-09','12:40:00',2.04),('3355','2013-08-09','12:45:00',1.52),('3355','2013-08-09','12:50:00',1.34),('3355','2013-08-09','12:55:00',1.52),('3355','2013-08-09','13:25:00',1.18),('3355','2013-08-09','15:10:00',1.55),('3355','2013-08-09','15:15:00',1.38),('3355','2013-08-09','15:35:00',1.16),('3355','2013-08-09','15:45:00',1.79),('3355','2013-08-09','15:50:00',1.19),('3355','2013-08-09','15:55:00',1.25),('3355','2013-08-09','16:55:00',1.08),('3355','2013-08-09','17:05:00',1.08),('3355','2013-08-08','09:15:00',1.01),('3355','2013-08-08','09:20:00',1.07),('3355','2013-08-08','09:25:00',1.11),('3355','2013-08-08','09:30:00',1.15),('3355','2013-08-08','09:35:00',1.19),('3355','2013-08-08','09:40:00',1.22),('3355','2013-08-08','09:45:00',1.26),('3355','2013-08-08','09:50:00',1.31),('3355','2013-08-08','09:55:00',1.34),('3355','2013-08-08','10:00:00',1.37),('3355','2013-08-08','10:05:00',1.41),('3355','2013-08-08','10:10:00',1.43),('3355','2013-08-08','10:15:00',1.47),('3355','2013-08-08','10:20:00',1.49),('3355','2013-08-08','10:25:00',1.51),('3355','2013-08-08','10:30:00',1.55),('3355','2013-08-08','10:35:00',1.58),('3355','2013-08-08','10:40:00',1.61),('3355','2013-08-08','10:45:00',1.63),('3355','2013-08-08','10:50:00',1.65),('3355','2013-08-08','10:55:00',1.68),('3355','2013-08-08','11:00:00',1.7),('3355','2013-08-08','11:05:00',1.72),('3355','2013-08-08','11:10:00',1.74),('3355','2013-08-08','11:15:00',1.76),('3355','2013-08-08','11:20:00',1.78),('3355','2013-08-08','11:25:00',1.78),('3355','2013-08-08','11:30:00',1.81),('3355','2013-08-08','11:35:00',1.82),('3355','2013-08-08','11:40:00',1.83),('3355','2013-08-08','11:45:00',1.85),('3355','2013-08-08','11:50:00',1.86),('3355','2013-08-08','11:55:00',1.87),('3355','2013-08-08','12:00:00',1.89),('3355','2013-08-08','12:05:00',1.89),('3355','2013-08-08','12:10:00',1.91),('3355','2013-08-08','12:15:00',1.91),('3355','2013-08-08','12:20:00',1.94),('3355','2013-08-08','12:25:00',1.95),('3355','2013-08-08','12:30:00',1.96),('3355','2013-08-08','12:35:00',1.94),('3355','2013-08-08','12:40:00',1.97),('3355','2013-08-08','12:45:00',1.98),('3355','2013-08-08','12:50:00',2.01),('3355','2013-08-08','12:55:00',2.02),('3355','2013-08-08','13:00:00',2.02),('3355','2013-08-08','13:05:00',1.97),('3355','2013-08-08','13:10:00',2.02),('3355','2013-08-08','13:15:00',2.03),('3355','2013-08-08','13:20:00',2.02),('3355','2013-08-08','13:25:00',2.05),('3355','2013-08-08','13:30:00',2.05),('3355','2013-08-08','13:35:00',2.03),('3355','2013-08-08','13:40:00',2.02),('3355','2013-08-08','13:45:00',2.02),('3355','2013-08-08','13:50:00',2.03),('3355','2013-08-08','13:55:00',2.01),('3355','2013-08-08','14:00:00',2.02),('3355','2013-08-08','14:05:00',2.03),('3355','2013-08-08','14:10:00',2.02),('3355','2013-08-08','14:15:00',2.01),('3355','2013-08-08','14:20:00',1.96),('3355','2013-08-08','14:25:00',1.96),('3355','2013-08-08','14:30:00',1.96),('3355','2013-08-08','14:35:00',1.95),('3355','2013-08-08','14:40:00',1.93),('3355','2013-08-08','14:45:00',1.92),('3355','2013-08-08','14:50:00',1.91),('3355','2013-08-08','14:55:00',1.87),('3355','2013-08-08','15:00:00',1.86),('3355','2013-08-08','15:05:00',1.85),('3355','2013-08-08','15:10:00',1.83),('3355','2013-08-08','15:15:00',1.8),('3355','2013-08-08','15:20:00',1.8),('3355','2013-08-08','15:25:00',1.78),('3355','2013-08-08','15:30:00',1.76),('3355','2013-08-08','15:35:00',1.74),('3355','2013-08-08','15:40:00',1.73),('3355','2013-08-08','15:45:00',1.71),('3355','2013-08-08','15:50:00',1.68),('3355','2013-08-08','15:55:00',1.66),('3355','2013-08-08','16:00:00',1.64),('3355','2013-08-08','16:05:00',1.63),('3355','2013-08-08','16:10:00',1.61),('3355','2013-08-08','16:15:00',1.58),('3355','2013-08-08','16:20:00',1.57),('3355','2013-08-08','16:25:00',1.55),('3355','2013-08-08','16:30:00',1.51),('3355','2013-08-08','16:35:00',1.48),('3355','2013-08-08','16:40:00',1.46),('3355','2013-08-08','16:45:00',1.41),('3355','2013-08-08','16:50:00',1.38),('3355','2013-08-08','16:55:00',1.34),('3355','2013-08-08','17:00:00',1.3),('3355','2013-08-08','17:05:00',1.26),('3355','2013-08-08','17:10:00',1.21),('3355','2013-08-08','17:15:00',1.18),('3355','2013-08-08','17:20:00',1.12),('3355','2013-08-08','17:25:00',1.09),('3355','2013-08-08','17:30:00',1.06),('3355','2013-08-08','17:35:00',1.02),('3355','2013-08-07','09:10:00',1.01),('3355','2013-08-07','09:15:00',1.04),('3355','2013-08-07','09:20:00',1.1),('3355','2013-08-07','09:25:00',1.14),('3355','2013-08-07','09:30:00',1.18),('3355','2013-08-07','09:35:00',1.22),('3355','2013-08-07','09:40:00',1.26),('3355','2013-08-07','09:45:00',1.29),('3355','2013-08-07','09:50:00',1.3),('3355','2013-08-07','09:55:00',1.35),('3355','2013-08-07','10:00:00',1.37),('3355','2013-08-07','10:05:00',1.42),('3355','2013-08-07','10:10:00',1.45),('3355','2013-08-07','10:15:00',1.49),('3355','2013-08-07','10:20:00',1.5),('3355','2013-08-07','10:25:00',1.53),('3355','2013-08-07','10:30:00',1.58),('3355','2013-08-07','10:35:00',1.6),('3355','2013-08-07','10:40:00',1.62),('3355','2013-08-07','10:45:00',1.64),('3355','2013-08-07','10:50:00',1.68),('3355','2013-08-07','10:55:00',1.71),('3355','2013-08-07','11:00:00',1.73),('3355','2013-08-07','11:05:00',1.74),('3355','2013-08-07','11:10:00',1.76),('3355','2013-08-07','11:15:00',1.78),('3355','2013-08-07','11:20:00',1.79),('3355','2013-08-07','11:25:00',1.81),('3355','2013-08-07','11:30:00',1.83),('3355','2013-08-07','11:35:00',1.85),('3355','2013-08-07','11:40:00',1.86),('3355','2013-08-07','11:45:00',1.88),('3355','2013-08-07','11:50:00',1.89),('3355','2013-08-07','11:55:00',1.89),('3355','2013-08-07','12:00:00',1.9),('3355','2013-08-07','12:05:00',1.92),('3355','2013-08-07','12:10:00',1.93),('3355','2013-08-07','12:15:00',1.96),('3355','2013-08-07','12:20:00',1.95),('3355','2013-08-07','12:25:00',1.96),('3355','2013-08-07','12:30:00',1.96),('3355','2013-08-07','12:35:00',1.98),('3355','2013-08-07','12:40:00',1.95),('3355','2013-08-07','12:45:00',1.95),('3355','2013-08-07','12:50:00',1.99),('3355','2013-08-07','12:55:00',2.01),('3355','2013-08-07','13:00:00',2),('3355','2013-08-07','13:05:00',1.97),('3355','2013-08-07','13:10:00',1.99),('3355','2013-08-07','13:15:00',1.96),('3355','2013-08-07','13:20:00',2.02),('3355','2013-08-07','13:25:00',1.99),('3355','2013-08-07','13:30:00',2.03),('3355','2013-08-07','13:35:00',2.03),('3355','2013-08-07','13:40:00',2.03),('3355','2013-08-07','13:45:00',2.06),('3355','2013-08-07','13:50:00',2.02),('3355','2013-08-07','13:55:00',2.04),('3355','2013-08-07','14:00:00',2.04),('3355','2013-08-07','14:05:00',2.02),('3355','2013-08-07','14:10:00',2.01),('3355','2013-08-07','14:15:00',1.99),('3355','2013-08-07','14:20:00',1.95),('3355','2013-08-07','14:25:00',1.96),('3355','2013-08-07','14:30:00',1.93),('3355','2013-08-07','14:35:00',1.91),('3355','2013-08-07','14:40:00',1.89),('3355','2013-08-07','14:45:00',1.95),('3355','2013-08-07','14:50:00',1.93),('3355','2013-08-07','14:55:00',1.92),('3355','2013-08-07','15:00:00',1.89),('3355','2013-08-07','15:05:00',1.88),('3355','2013-08-07','15:10:00',1.86),('3355','2013-08-07','15:15:00',1.85),('3355','2013-08-07','15:20:00',1.84),('3355','2013-08-07','15:25:00',1.84),('3355','2013-08-07','15:30:00',1.78),('3355','2013-08-07','15:35:00',1.78),('3355','2013-08-07','15:40:00',1.76),('3355','2013-08-07','15:45:00',1.75),('3355','2013-08-07','15:50:00',1.72),('3355','2013-08-07','15:55:00',1.7),('3355','2013-08-07','16:00:00',1.67),('3355','2013-08-07','16:05:00',1.64),('3355','2013-08-07','16:10:00',1.59),('3355','2013-08-07','16:15:00',1.56),('3355','2013-08-07','16:20:00',1.55),('3355','2013-08-07','16:25:00',1.54),('3355','2013-08-07','16:30:00',1.51),('3355','2013-08-07','16:35:00',1.48),('3355','2013-08-07','16:40:00',1.45),('3355','2013-08-07','16:45:00',1.43),('3355','2013-08-07','16:50:00',1.4),('3355','2013-08-07','16:55:00',1.37),('3355','2013-08-07','17:00:00',1.34),('3355','2013-08-07','17:05:00',1.3),('3355','2013-08-07','17:10:00',1.25),('3355','2013-08-07','17:15:00',1.2),('3355','2013-08-07','17:20:00',1.17),('3355','2013-08-07','17:25:00',1.15),('3355','2013-08-07','17:30:00',1.09),('3355','2013-08-07','17:35:00',1.03),('3355','2013-08-06','09:15:00',1.03),('3355','2013-08-06','09:20:00',1.07),('3355','2013-08-06','09:25:00',1.11),('3355','2013-08-06','09:30:00',1.15),('3355','2013-08-06','09:35:00',1.19),('3355','2013-08-06','09:40:00',1.23),('3355','2013-08-06','09:45:00',1.26),('3355','2013-08-06','09:50:00',1.3),('3355','2013-08-06','09:55:00',1.34),('3355','2013-08-06','10:00:00',1.37),('3355','2013-08-06','10:05:00',1.41),('3355','2013-08-06','10:10:00',1.43),('3355','2013-08-06','10:15:00',1.47),('3355','2013-08-06','10:20:00',1.5),('3355','2013-08-06','10:25:00',1.53),('3355','2013-08-06','10:30:00',1.57),('3355','2013-08-06','10:35:00',1.59),('3355','2013-08-06','10:40:00',1.6),('3355','2013-08-06','10:45:00',1.63),('3355','2013-08-06','10:50:00',1.65),('3355','2013-08-06','10:55:00',1.67),('3355','2013-08-06','11:00:00',1.71),('3355','2013-08-06','11:05:00',1.73),('3355','2013-08-06','11:10:00',1.74),('3355','2013-08-06','11:15:00',1.78),('3355','2013-08-06','11:20:00',1.8),('3355','2013-08-06','11:25:00',1.8),('3355','2013-08-06','11:30:00',1.82),('3355','2013-08-06','11:35:00',1.85),('3355','2013-08-06','11:40:00',1.88),('3355','2013-08-06','11:45:00',1.87),('3355','2013-08-06','11:50:00',1.86),('3355','2013-08-06','11:55:00',1.88),('3355','2013-08-06','12:00:00',1.91),('3355','2013-08-06','12:05:00',1.91),('3355','2013-08-06','12:10:00',1.94),('3355','2013-08-06','12:15:00',1.93),('3355','2013-08-06','12:20:00',1.94),('3355','2013-08-06','12:25:00',1.95),('3355','2013-08-06','12:30:00',1.94),('3355','2013-08-06','12:35:00',1.96),('3355','2013-08-06','12:40:00',1.97),('3355','2013-08-06','12:45:00',1.95),('3355','2013-08-06','12:50:00',1.97),('3355','2013-08-06','12:55:00',1.99),('3355','2013-08-06','13:00:00',1.99),('3355','2013-08-06','13:05:00',1.99),('3355','2013-08-06','13:10:00',2),('3355','2013-08-06','13:15:00',2.02),('3355','2013-08-06','13:20:00',2.02),('3355','2013-08-06','13:25:00',2.04),('3355','2013-08-06','13:30:00',2.05),('3355','2013-08-06','13:35:00',2.06),('3355','2013-08-06','13:40:00',2.07),('3355','2013-08-06','13:45:00',2.07),('3355','2013-08-06','13:50:00',2.08),('3355','2013-08-06','13:55:00',2.09),('3355','2013-08-06','14:00:00',2.09),('3355','2013-08-06','14:05:00',2.1),('3355','2013-08-06','14:10:00',2.09),('3355','2013-08-06','14:15:00',2.09),('3355','2013-08-06','14:20:00',2.08),('3355','2013-08-06','14:25:00',2.07),('3355','2013-08-06','14:30:00',2.06),('3355','2013-08-06','14:35:00',2.04),('3355','2013-08-06','14:40:00',2.03),('3355','2013-08-06','14:45:00',2.02),('3355','2013-08-06','14:50:00',2.02),('3355','2013-08-06','14:55:00',2),('3355','2013-08-06','15:00:00',1.99),('3355','2013-08-06','15:05:00',1.98),('3355','2013-08-06','15:10:00',1.97),('3355','2013-08-06','15:15:00',1.94),('3355','2013-08-06','15:20:00',1.93),('3355','2013-08-06','15:25:00',1.92),('3355','2013-08-06','15:30:00',1.89),('3355','2013-08-06','15:35:00',1.88),('3355','2013-08-06','15:40:00',1.85),('3355','2013-08-06','15:45:00',1.83),('3355','2013-08-06','15:50:00',1.8),('3355','2013-08-06','15:55:00',1.77),('3355','2013-08-06','16:00:00',1.75),('3355','2013-08-06','16:05:00',1.72),('3355','2013-08-06','16:10:00',1.69),('3355','2013-08-06','16:15:00',1.66),('3355','2013-08-06','16:20:00',1.63),('3355','2013-08-06','16:25:00',1.6),('3355','2013-08-06','16:30:00',1.56),('3355','2013-08-06','16:35:00',1.54),('3355','2013-08-06','16:40:00',1.5),('3355','2013-08-06','16:45:00',1.47),('3355','2013-08-06','16:50:00',1.43),('3355','2013-08-06','16:55:00',1.4),('3355','2013-08-06','17:00:00',1.36),('3355','2013-08-06','17:05:00',1.33),('3355','2013-08-06','17:10:00',1.29),('3355','2013-08-06','17:15:00',1.23),('3355','2013-08-06','17:20:00',1.2),('3355','2013-08-06','17:25:00',1.16),('3355','2013-08-06','17:30:00',1.12),('3355','2013-08-06','17:35:00',1.07),('3355','2013-08-06','17:40:00',1.02),('3355','2013-08-05','09:10:00',1.02),('3355','2013-08-05','09:15:00',1.05),('3355','2013-08-05','09:20:00',1.09),('3355','2013-08-05','09:25:00',1.13),('3355','2013-08-05','09:30:00',1.17),('3355','2013-08-05','09:35:00',1.21),('3355','2013-08-05','09:40:00',1.24),('3355','2013-08-05','09:45:00',1.28),('3355','2013-08-05','09:50:00',1.31),('3355','2013-08-05','09:55:00',1.34),('3355','2013-08-05','10:00:00',1.38),('3355','2013-08-05','10:05:00',1.41),('3355','2013-08-05','10:10:00',1.45),('3355','2013-08-05','10:15:00',1.49),('3355','2013-08-05','10:20:00',1.52),('3355','2013-08-05','10:25:00',1.54),('3355','2013-08-05','10:30:00',1.58),('3355','2013-08-05','10:35:00',1.6),('3355','2013-08-05','10:40:00',1.63),('3355','2013-08-05','10:45:00',1.66),('3355','2013-08-05','10:50:00',1.69),('3355','2013-08-05','10:55:00',1.7),('3355','2013-08-05','11:00:00',1.74),('3355','2013-08-05','11:05:00',1.75),('3355','2013-08-05','11:10:00',1.79),('3355','2013-08-05','11:15:00',1.8),('3355','2013-08-05','11:20:00',1.83),('3355','2013-08-05','11:25:00',1.85),('3355','2013-08-05','11:30:00',1.86),('3355','2013-08-05','11:35:00',1.87),('3355','2013-08-05','11:40:00',1.9),('3355','2013-08-05','11:45:00',1.91),('3355','2013-08-05','11:50:00',1.94),('3355','2013-08-05','11:55:00',1.93),('3355','2013-08-05','12:00:00',1.95),('3355','2013-08-05','12:05:00',1.96),('3355','2013-08-05','12:10:00',1.97),('3355','2013-08-05','12:15:00',2),('3355','2013-08-05','12:20:00',2),('3355','2013-08-05','12:25:00',2.01),('3355','2013-08-05','12:30:00',2.01),('3355','2013-08-05','12:35:00',2.02),('3355','2013-08-05','12:40:00',2.03),('3355','2013-08-05','12:45:00',2.03),('3355','2013-08-05','12:50:00',2.03),('3355','2013-08-05','12:55:00',2.02),('3355','2013-08-05','13:00:00',2.03),('3355','2013-08-05','13:05:00',2.04),('3355','2013-08-05','13:10:00',2.05),('3355','2013-08-05','13:15:00',2.05),('3355','2013-08-05','13:20:00',2.05),('3355','2013-08-05','13:25:00',2.05),('3355','2013-08-05','13:30:00',2.05),('3355','2013-08-05','13:35:00',2.06),('3355','2013-08-05','13:40:00',2.06),('3355','2013-08-05','13:45:00',2.04),('3355','2013-08-05','13:50:00',2.01),('3355','2013-08-05','13:55:00',2),('3355','2013-08-05','14:00:00',2.02),('3355','2013-08-05','14:05:00',2.03),('3355','2013-08-05','14:10:00',2.02),('3355','2013-08-05','14:15:00',2.01),('3355','2013-08-05','14:20:00',2),('3355','2013-08-05','14:25:00',1.99),('3355','2013-08-05','14:30:00',1.98),('3355','2013-08-05','14:35:00',1.98),('3355','2013-08-05','14:40:00',1.97),('3355','2013-08-05','14:45:00',1.96),('3355','2013-08-05','14:50:00',1.94),('3355','2013-08-05','14:55:00',1.93),('3355','2013-08-05','15:00:00',1.92),('3355','2013-08-05','15:05:00',1.92),('3355','2013-08-05','15:10:00',1.91),('3355','2013-08-05','15:15:00',1.9),('3355','2013-08-05','15:20:00',1.88),('3355','2013-08-05','15:25:00',1.87),('3355','2013-08-05','15:30:00',1.85),('3355','2013-08-05','15:35:00',1.84),('3355','2013-08-05','15:40:00',1.82),('3355','2013-08-05','15:45:00',1.8),('3355','2013-08-05','15:50:00',1.77),('3355','2013-08-05','15:55:00',1.75),('3355','2013-08-05','16:00:00',1.74),('3355','2013-08-05','16:05:00',1.72),('3355','2013-08-05','16:10:00',1.68),('3355','2013-08-05','16:15:00',1.65),('3355','2013-08-05','16:20:00',1.61),('3355','2013-08-05','16:25:00',1.58),('3355','2013-08-05','16:30:00',1.55),('3355','2013-08-05','16:35:00',1.53),('3355','2013-08-05','16:40:00',1.49),('3355','2013-08-05','16:45:00',1.45),('3355','2013-08-05','16:50:00',1.41),('3355','2013-08-05','16:55:00',1.38),('3355','2013-08-05','17:00:00',1.35),('3355','2013-08-05','17:05:00',1.31),('3355','2013-08-05','17:10:00',1.27),('3355','2013-08-05','17:15:00',1.22),('3355','2013-08-05','17:20:00',1.18),('3355','2013-08-05','17:25:00',1.14),('3355','2013-08-05','17:30:00',1.1),('3355','2013-08-05','17:35:00',1.06),('3355','2013-08-05','17:40:00',1.01),('3355','2013-08-04','09:05:00',1.03),('3355','2013-08-04','09:10:00',1.07),('3355','2013-08-04','09:15:00',1.11),('3355','2013-08-04','09:20:00',1.15),('3355','2013-08-04','09:25:00',1.19),('3355','2013-08-04','09:30:00',1.23),('3355','2013-08-04','09:35:00',1.28),('3355','2013-08-04','09:40:00',1.31),('3355','2013-08-04','09:45:00',1.35),('3355','2013-08-04','09:50:00',1.39),('3355','2013-08-04','09:55:00',1.42),('3355','2013-08-04','10:00:00',1.46),('3355','2013-08-04','10:05:00',1.49),('3355','2013-08-04','10:10:00',1.52),('3355','2013-08-04','10:15:00',1.55),('3355','2013-08-04','10:20:00',1.59),('3355','2013-08-04','10:25:00',1.62),('3355','2013-08-04','10:30:00',1.65),('3355','2013-08-04','10:35:00',1.68),('3355','2013-08-04','10:40:00',1.71),('3355','2013-08-04','10:45:00',1.73),('3355','2013-08-04','10:50:00',1.4),('3355','2013-08-04','10:55:00',1.77),('3355','2013-08-04','11:00:00',1.79),('3355','2013-08-04','11:05:00',1.81),('3355','2013-08-04','11:10:00',1.82),('3355','2013-08-04','11:15:00',1.84),('3355','2013-08-04','11:20:00',1.86),('3355','2013-08-04','11:25:00',1.88),('3355','2013-08-04','11:30:00',1.91),('3355','2013-08-04','11:35:00',1.93),('3355','2013-08-04','11:40:00',1.95),('3355','2013-08-04','11:45:00',1.96),('3355','2013-08-04','11:50:00',1.97),('3355','2013-08-04','11:55:00',2),('3355','2013-08-04','12:00:00',2.01),('3355','2013-08-04','12:05:00',2.02),('3355','2013-08-04','12:10:00',2.02),('3355','2013-08-04','12:15:00',2.03),('3355','2013-08-04','12:20:00',2.05),('3355','2013-08-04','12:25:00',2.04),('3355','2013-08-04','12:30:00',2.04),('3355','2013-08-04','12:35:00',2.06),('3355','2013-08-04','12:40:00',2.08),('3355','2013-08-04','12:45:00',2.09),('3355','2013-08-04','12:50:00',2.09),('3355','2013-08-04','12:55:00',2.09),('3355','2013-08-04','13:00:00',2.09),('3355','2013-08-04','13:05:00',2.09),('3355','2013-08-04','13:10:00',2.06),('3355','2013-08-04','13:15:00',2.08),('3355','2013-08-04','13:20:00',2.08),('3355','2013-08-04','13:25:00',2.08),('3355','2013-08-04','13:30:00',2.09),('3355','2013-08-04','13:35:00',2.11),('3355','2013-08-04','13:40:00',2.14),('3355','2013-08-04','13:45:00',2.14),('3355','2013-08-04','13:50:00',2.15),('3355','2013-08-04','13:55:00',2.15),('3355','2013-08-04','14:00:00',2.15),('3355','2013-08-04','14:05:00',2.15),('3355','2013-08-04','14:10:00',2.13),('3355','2013-08-04','14:15:00',2.13),('3355','2013-08-04','14:20:00',2.1),('3355','2013-08-04','14:25:00',2.1),('3355','2013-08-04','14:30:00',2.1),('3355','2013-08-04','14:35:00',2.08),('3355','2013-08-04','14:40:00',2.06),('3355','2013-08-04','14:45:00',2.06),('3355','2013-08-04','14:50:00',2.04),('3355','2013-08-04','14:55:00',2.03),('3355','2013-08-04','15:00:00',2.02),('3355','2013-08-04','15:05:00',2),('3355','2013-08-04','15:10:00',1.98),('3355','2013-08-04','15:15:00',1.96),('3355','2013-08-04','15:20:00',1.95),('3355','2013-08-04','15:25:00',1.93),('3355','2013-08-04','15:30:00',1.89),('3355','2013-08-04','15:35:00',1.9),('3355','2013-08-04','15:40:00',1.86),('3355','2013-08-04','15:45:00',1.84),('3355','2013-08-04','15:50:00',1.8),('3355','2013-08-04','15:55:00',1.79),('3355','2013-08-04','16:00:00',1.77),('3355','2013-08-04','16:05:00',1.74),('3355','2013-08-04','16:10:00',1.72),('3355','2013-08-04','16:15:00',1.71),('3355','2013-08-04','16:20:00',1.68),('3355','2013-08-04','16:25:00',1.65),('3355','2013-08-04','16:30:00',1.61),('3355','2013-08-04','16:35:00',1.57),('3355','2013-08-04','16:40:00',1.54),('3355','2013-08-04','16:45:00',1.51),('3355','2013-08-04','16:50:00',1.47),('3355','2013-08-04','16:55:00',1.44),('3355','2013-08-04','17:00:00',1.39),('3355','2013-08-04','17:05:00',1.36),('3355','2013-08-04','17:10:00',1.33),('3355','2013-08-04','17:15:00',1.28),('3355','2013-08-04','17:20:00',1.24),('3355','2013-08-04','17:25:00',1.19),('3355','2013-08-04','17:30:00',1.14),('3355','2013-08-04','17:35:00',1.1),('3355','2013-08-04','17:40:00',1.06),('3355','2013-08-04','17:45:00',1.01),('3355','2013-08-03','09:05:00',1.02),('3355','2013-08-03','09:10:00',1.06),('3355','2013-08-03','09:15:00',1.11),('3355','2013-08-03','09:20:00',1.15),('3355','2013-08-03','09:25:00',1.19),('3355','2013-08-03','09:30:00',1.24),('3355','2013-08-03','09:35:00',1.27),('3355','2013-08-03','09:40:00',1.31),('3355','2013-08-03','09:45:00',1.34),('3355','2013-08-03','09:50:00',1.38),('3355','2013-08-03','09:55:00',1.42),('3355','2013-08-03','10:00:00',1.44),('3355','2013-08-03','10:05:00',1.48),('3355','2013-08-03','10:10:00',1.51),('3355','2013-08-03','10:15:00',1.55),('3355','2013-08-03','10:20:00',1.58),('3355','2013-08-03','10:25:00',1.62),('3355','2013-08-03','10:30:00',1.65),('3355','2013-08-03','10:35:00',1.68),('3355','2013-08-03','10:40:00',1.7),('3355','2013-08-03','10:45:00',1.73),('3355','2013-08-03','10:50:00',1.75),('3355','2013-08-03','10:55:00',1.77),('3355','2013-08-03','11:00:00',1.8),('3355','2013-08-03','11:05:00',1.83),('3355','2013-08-03','11:10:00',1.82),('3355','2013-08-03','11:15:00',1.84),('3355','2013-08-03','11:20:00',1.87),('3355','2013-08-03','11:25:00',1.87),('3355','2013-08-03','11:30:00',1.87),('3355','2013-08-03','11:35:00',1.92),('3355','2013-08-03','11:40:00',1.93),('3355','2013-08-03','11:45:00',1.94),('3355','2013-08-03','11:50:00',1.97),('3355','2013-08-03','11:55:00',2.01),('3355','2013-08-03','12:00:00',2),('3355','2013-08-03','12:05:00',2),('3355','2013-08-03','12:10:00',2.01),('3355','2013-08-03','12:15:00',2.03),('3355','2013-08-03','12:20:00',2.04),('3355','2013-08-03','12:25:00',2.03),('3355','2013-08-03','12:30:00',2.07),('3355','2013-08-03','12:35:00',2.06),('3355','2013-08-03','12:40:00',2.05),('3355','2013-08-03','12:45:00',2.07),('3355','2013-08-03','12:50:00',2.06),('3355','2013-08-03','12:55:00',2.05),('3355','2013-08-03','13:00:00',2.07),('3355','2013-08-03','13:05:00',2.04),('3355','2013-08-03','13:10:00',2.05),('3355','2013-08-03','13:15:00',2.06),('3355','2013-08-03','13:20:00',2.04),('3355','2013-08-03','13:25:00',2.03),('3355','2013-08-03','13:30:00',2.02),('3355','2013-08-03','13:35:00',1.99),('3355','2013-08-03','13:40:00',2.03),('3355','2013-08-03','13:45:00',2.06),('3355','2013-08-03','13:50:00',2.06),('3355','2013-08-03','13:55:00',2.06),('3355','2013-08-03','14:00:00',2.06),('3355','2013-08-03','14:05:00',2.05),('3355','2013-08-03','14:10:00',1.99),('3355','2013-08-03','14:15:00',1.97),('3355','2013-08-03','14:20:00',2),('3355','2013-08-03','14:25:00',1.98),('3355','2013-08-03','14:30:00',1.98),('3355','2013-08-03','14:35:00',2.03),('3355','2013-08-03','14:40:00',2),('3355','2013-08-03','14:45:00',2.02),('3355','2013-08-03','14:50:00',2.01),('3355','2013-08-03','14:55:00',2),('3355','2013-08-03','15:00:00',1.99),('3355','2013-08-03','15:05:00',1.95),('3355','2013-08-03','15:10:00',1.94),('3355','2013-08-03','15:15:00',1.92),('3355','2013-08-03','15:20:00',1.92),('3355','2013-08-03','15:25:00',1.91),('3355','2013-08-03','15:30:00',1.91),('3355','2013-08-03','15:35:00',1.89),('3355','2013-08-03','15:40:00',1.86),('3355','2013-08-03','15:45:00',1.84),('3355','2013-08-03','15:50:00',1.82),('3355','2013-08-03','15:55:00',1.79),('3355','2013-08-03','16:00:00',1.75),('3355','2013-08-03','16:05:00',1.72),('3355','2013-08-03','16:10:00',1.68),('3355','2013-08-03','16:15:00',1.65),('3355','2013-08-03','16:20:00',1.62),('3355','2013-08-03','16:25:00',1.59),('3355','2013-08-03','16:30:00',1.57),('3355','2013-08-03','16:35:00',1.54),('3355','2013-08-03','16:40:00',1.51),('3355','2013-08-03','16:45:00',1.48),('3355','2013-08-03','16:50:00',1.45),('3355','2013-08-03','16:55:00',1.42),('3355','2013-08-03','17:00:00',1.34),('3355','2013-08-03','17:05:00',1.33),('3355','2013-08-03','17:10:00',1.3),('3355','2013-08-03','17:15:00',1.25),('3355','2013-08-03','17:20:00',1.22),('3355','2013-08-03','17:25:00',1.17),('3355','2013-08-03','17:30:00',1.13),('3355','2013-08-03','17:35:00',1.1),('3355','2013-08-03','17:40:00',1.05),('3355','2013-08-03','17:45:00',1),('3355','2013-08-02','09:00:00',1.01),('3355','2013-08-02','09:05:00',1.05),('3355','2013-08-02','09:10:00',1.1),('3355','2013-08-02','09:15:00',1.14),('3355','2013-08-02','09:20:00',1.18),('3355','2013-08-02','09:25:00',1.23),('3355','2013-08-02','09:30:00',1.27),('3355','2013-08-02','09:35:00',1.31),('3355','2013-08-02','09:40:00',1.34),('3355','2013-08-02','09:45:00',1.38),('3355','2013-08-02','09:50:00',1.41),('3355','2013-08-02','09:55:00',1.45),('3355','2013-08-02','10:00:00',1.48),('3355','2013-08-02','10:05:00',1.51),('3355','2013-08-02','10:10:00',1.55),('3355','2013-08-02','10:15:00',1.58),('3355','2013-08-02','10:20:00',1.61),('3355','2013-08-02','10:25:00',1.64),('3355','2013-08-02','10:30:00',1.67),('3355','2013-08-02','10:35:00',1.7),('3355','2013-08-02','10:40:00',1.72),('3355','2013-08-02','10:45:00',1.75),('3355','2013-08-02','10:50:00',1.77),('3355','2013-08-02','10:55:00',1.8),('3355','2013-08-02','11:00:00',1.82),('3355','2013-08-02','11:05:00',1.84),('3355','2013-08-02','11:10:00',1.85),('3355','2013-08-02','11:15:00',1.88),('3355','2013-08-02','11:20:00',1.91),('3355','2013-08-02','11:25:00',1.93),('3355','2013-08-02','11:30:00',1.94),('3355','2013-08-02','11:35:00',1.95),('3355','2013-08-02','11:40:00',1.97),('3355','2013-08-02','11:45:00',1.98),('3355','2013-08-02','11:50:00',2),('3355','2013-08-02','11:55:00',2.02),('3355','2013-08-02','12:00:00',2.04),('3355','2013-08-02','12:05:00',2.04),('3355','2013-08-02','12:10:00',2.06),('3355','2013-08-02','12:15:00',2.06),('3355','2013-08-02','12:20:00',2.07),('3355','2013-08-02','12:25:00',2.08),('3355','2013-08-02','12:30:00',2.08),('3355','2013-08-02','12:35:00',2.1),('3355','2013-08-02','12:40:00',2.09),('3355','2013-08-02','12:45:00',2.1),('3355','2013-08-02','12:50:00',2.08),('3355','2013-08-02','12:55:00',2.09),('3355','2013-08-02','13:00:00',2.09),('3355','2013-08-02','13:05:00',2.13),('3355','2013-08-02','13:10:00',2.15),('3355','2013-08-02','13:15:00',2.16),('3355','2013-08-02','13:20:00',2.11),('3355','2013-08-02','13:25:00',2.12),('3355','2013-08-02','13:30:00',2.11),('3355','2013-08-02','13:35:00',2.12),('3355','2013-08-02','13:40:00',2.1),('3355','2013-08-02','13:45:00',2.11),('3355','2013-08-02','13:50:00',2.11),('3355','2013-08-02','13:55:00',2.1),('3355','2013-08-02','14:00:00',2.11),('3355','2013-08-02','14:05:00',2.1),('3355','2013-08-02','14:10:00',2.08),('3355','2013-08-02','14:15:00',2.06),('3355','2013-08-02','14:20:00',2.05),('3355','2013-08-02','14:25:00',2.02),('3355','2013-08-02','14:30:00',2.03),('3355','2013-08-02','14:35:00',2.04),('3355','2013-08-02','14:40:00',2.06),('3355','2013-08-02','14:45:00',2.04),('3355','2013-08-02','14:50:00',2.04),('3355','2013-08-02','14:55:00',2.03),('3355','2013-08-02','15:00:00',2.02),('3355','2013-08-02','15:05:00',2.02),('3355','2013-08-02','15:10:00',1.99),('3355','2013-08-02','15:15:00',1.95),('3355','2013-08-02','15:20:00',1.97),('3355','2013-08-02','15:25:00',1.96),('3355','2013-08-02','15:30:00',1.94),('3355','2013-08-02','15:35:00',1.92),('3355','2013-08-02','15:40:00',1.9),('3355','2013-08-02','15:45:00',1.88),('3355','2013-08-02','15:50:00',1.84),('3355','2013-08-02','15:55:00',1.81),('3355','2013-08-02','16:00:00',1.79),('3355','2013-08-02','16:05:00',1.77),('3355','2013-08-02','16:10:00',1.75),('3355','2013-08-02','16:15:00',1.72),('3355','2013-08-02','16:20:00',1.68),('3355','2013-08-02','16:25:00',1.63),('3355','2013-08-02','16:30:00',1.62),('3355','2013-08-02','16:35:00',1.6),('3355','2013-08-02','16:40:00',1.56),('3355','2013-08-02','16:45:00',1.53),('3355','2013-08-02','16:50:00',1.5),('3355','2013-08-02','16:55:00',1.46),('3355','2013-08-02','17:00:00',1.42),('3355','2013-08-02','17:05:00',1.37),('3355','2013-08-02','17:10:00',1.33),('3355','2013-08-02','17:15:00',1.3),('3355','2013-08-02','17:20:00',1.27),('3355','2013-08-02','17:25:00',1.23),('3355','2013-08-02','17:30:00',1.18),('3355','2013-08-02','17:35:00',1.13),('3355','2013-08-02','17:40:00',1.09),('3355','2013-08-02','17:45:00',1.04),('3355','2013-08-01','09:00:00',1.03),('3355','2013-08-01','09:05:00',1.08),('3355','2013-08-01','09:10:00',1.13),('3355','2013-08-01','09:15:00',1.18),('3355','2013-08-01','09:20:00',1.22),('3355','2013-08-01','09:25:00',1.26),('3355','2013-08-01','09:30:00',1.3),('3355','2013-08-01','09:35:00',1.35),('3355','2013-08-01','09:40:00',1.39),('3355','2013-08-01','09:45:00',1.43),('3355','2013-08-01','09:50:00',1.47),('3355','2013-08-01','09:55:00',1.5),('3355','2013-08-01','10:00:00',1.53),('3355','2013-08-01','10:05:00',1.56),('3355','2013-08-01','10:10:00',1.6),('3355','2013-08-01','10:15:00',1.63),('3355','2013-08-01','10:20:00',1.67),('3355','2013-08-01','10:25:00',1.7),('3355','2013-08-01','10:30:00',1.73),('3355','2013-08-01','10:35:00',1.75),('3355','2013-08-01','10:40:00',1.77),('3355','2013-08-01','10:45:00',1.81),('3355','2013-08-01','10:50:00',1.83),('3355','2013-08-01','10:55:00',1.86),('3355','2013-08-01','11:00:00',1.88),('3355','2013-08-01','11:05:00',1.92),('3355','2013-08-01','11:10:00',1.95),('3355','2013-08-01','11:15:00',1.98),('3355','2013-08-01','11:20:00',2),('3355','2013-08-01','11:25:00',2.02),('3355','2013-08-01','11:30:00',2.03),('3355','2013-08-01','11:35:00',2.06),('3355','2013-08-01','11:40:00',2.07),('3355','2013-08-01','11:45:00',2.1),('3355','2013-08-01','11:50:00',2.12),('3355','2013-08-01','11:55:00',2.12),('3355','2013-08-01','12:00:00',2.13),('3355','2013-08-01','12:05:00',2.14),('3355','2013-08-01','12:10:00',2.15),('3355','2013-08-01','12:15:00',2.16),('3355','2013-08-01','12:20:00',2.17),('3355','2013-08-01','12:25:00',2.18),('3355','2013-08-01','12:30:00',2.19),('3355','2013-08-01','12:35:00',2.21),('3355','2013-08-01','12:40:00',2.22),('3355','2013-08-01','12:45:00',2.21),('3355','2013-08-01','12:50:00',2.23),('3355','2013-08-01','12:55:00',2.22),('3355','2013-08-01','13:00:00',2.22),('3355','2013-08-01','13:05:00',2.24),('3355','2013-08-01','13:10:00',2.24),('3355','2013-08-01','13:15:00',2.1),('3355','2013-08-01','13:20:00',2.26),('3355','2013-08-01','13:25:00',2.25),('3355','2013-08-01','13:30:00',2.24),('3355','2013-08-01','13:35:00',2.11),('3355','2013-08-01','13:40:00',2.24),('3355','2013-08-01','13:45:00',2.07),('3355','2013-08-01','13:50:00',2.28),('3355','2013-08-01','13:55:00',2.19),('3355','2013-08-01','14:00:00',2.13),('3355','2013-08-01','14:05:00',2.2),('3355','2013-08-01','14:10:00',2.12),('3355','2013-08-01','14:15:00',2.01),('3355','2013-08-01','14:20:00',2.11),('3355','2013-08-01','14:25:00',2.14),('3355','2013-08-01','14:30:00',2.15),('3355','2013-08-01','14:35:00',1.65),('3355','2013-08-01','14:40:00',2.15),('3355','2013-08-01','14:45:00',2.15),('3355','2013-08-01','14:50:00',2.1),('3355','2013-08-01','14:55:00',2.09),('3355','2013-08-01','15:00:00',2.05),('3355','2013-08-01','15:05:00',2),('3355','2013-08-01','15:10:00',2.07),('3355','2013-08-01','15:15:00',1.6),('3355','2013-08-01','15:20:00',1.28),('3355','2013-08-01','15:25:00',2.04),('3355','2013-08-01','15:30:00',1.99),('3355','2013-08-01','15:35:00',1.99),('3355','2013-08-01','15:40:00',1.16),('3355','2013-08-01','15:45:00',1.9),('3355','2013-08-01','15:50:00',1.89),('3355','2013-08-01','15:55:00',1.89),('3355','2013-08-01','16:00:00',1.87),('3355','2013-08-01','16:05:00',1.82),('3355','2013-08-01','16:10:00',1.78),('3355','2013-08-01','16:15:00',1.76),('3355','2013-08-01','16:20:00',1.73),('3355','2013-08-01','16:25:00',1.7),('3355','2013-08-01','16:30:00',1.66),('3355','2013-08-01','16:35:00',1.64),('3355','2013-08-01','16:40:00',1.6),('3355','2013-08-01','16:45:00',1.56),('3355','2013-08-01','16:50:00',1.53),('3355','2013-08-01','16:55:00',1.5),('3355','2013-08-01','17:00:00',1.45),('3355','2013-08-01','17:05:00',1.42),('3355','2013-08-01','17:10:00',1.38),('3355','2013-08-01','17:15:00',1.34),('3355','2013-08-01','17:20:00',1.29),('3355','2013-08-01','17:25:00',1.25),('3355','2013-08-01','17:30:00',1.21),('3355','2013-08-01','17:35:00',1.17),('3355','2013-08-01','17:40:00',1.13),('3355','2013-08-01','17:45:00',1.08),('3355','2013-08-01','17:50:00',1.03),('3355','2013-07-31','08:55:00',1.01),('3355','2013-07-31','09:00:00',1.05),('3355','2013-07-31','09:05:00',1.1),('3355','2013-07-31','09:10:00',1.14),('3355','2013-07-31','09:15:00',1.19),('3355','2013-07-31','09:20:00',1.23),('3355','2013-07-31','09:25:00',1.27),('3355','2013-07-31','09:30:00',1.31),('3355','2013-07-31','09:35:00',1.35),('3355','2013-07-31','09:40:00',1.39),('3355','2013-07-31','09:45:00',1.44),('3355','2013-07-31','09:50:00',1.48),('3355','2013-07-31','09:55:00',1.51),('3355','2013-07-31','10:00:00',1.55),('3355','2013-07-31','10:05:00',1.58),('3355','2013-07-31','10:10:00',1.6),('3355','2013-07-31','10:15:00',1.63),('3355','2013-07-31','10:20:00',1.67),('3355','2013-07-31','10:25:00',1.71),('3355','2013-07-31','10:30:00',1.74),('3355','2013-07-31','10:35:00',1.78),('3355','2013-07-31','10:40:00',1.82),('3355','2013-07-31','10:45:00',1.85),('3355','2013-07-31','10:50:00',1.89),('3355','2013-07-31','10:55:00',1.91),('3355','2013-07-31','11:00:00',1.93),('3355','2013-07-31','11:05:00',1.95),('3355','2013-07-31','11:10:00',1.97),('3355','2013-07-31','11:15:00',1.99),('3355','2013-07-31','11:20:00',2),('3355','2013-07-31','11:25:00',2.02),('3355','2013-07-31','11:30:00',2.04),('3355','2013-07-31','11:35:00',2.06),('3355','2013-07-31','11:40:00',2.08),('3355','2013-07-31','11:45:00',2.11),('3355','2013-07-31','11:50:00',2.12),('3355','2013-07-31','11:55:00',2.14),('3355','2013-07-31','12:00:00',2.16),('3355','2013-07-31','12:05:00',2.16),('3355','2013-07-31','12:10:00',2.17),('3355','2013-07-31','12:15:00',2.2),('3355','2013-07-31','12:20:00',2.21),('3355','2013-07-31','12:25:00',2.22),('3355','2013-07-31','12:30:00',2.22),('3355','2013-07-31','12:35:00',2.21),('3355','2013-07-31','12:40:00',2.23),('3355','2013-07-31','12:45:00',2.08),('3355','2013-07-31','12:50:00',1.83),('3355','2013-07-31','12:55:00',2.26),('3355','2013-07-31','13:05:00',2.38),('3355','2013-07-31','13:10:00',2.29),('3355','2013-07-31','13:15:00',2.27),('3355','2013-07-31','13:20:00',2.15),('3355','2013-07-31','13:25:00',1.9),('3355','2013-07-31','13:30:00',1.97),('3355','2013-07-31','13:35:00',2.12),('3355','2013-07-31','13:40:00',2.11),('3355','2013-07-31','13:45:00',2.24),('3355','2013-07-31','13:50:00',1.84),('3355','2013-07-31','13:55:00',1.39),('3355','2013-07-31','14:00:00',1.63),('3355','2013-07-31','14:05:00',2.33),('3355','2013-07-31','14:10:00',2.3),('3355','2013-07-31','14:15:00',2.26),('3355','2013-07-31','14:20:00',2.29),('3355','2013-07-31','14:25:00',2.23),('3355','2013-07-31','14:30:00',2.19),('3355','2013-07-31','14:35:00',2.17),('3355','2013-07-31','14:40:00',2.2),('3355','2013-07-31','14:45:00',2.18),('3355','2013-07-31','14:50:00',1.18),('3355','2013-07-31','15:05:00',2.22),('3355','2013-07-31','15:10:00',2.13),('3355','2013-07-31','15:15:00',1.56),('3355','2013-07-31','15:20:00',2.13),('3355','2013-07-31','15:25:00',1.86),('3355','2013-07-31','15:30:00',2.04),('3355','2013-07-31','15:35:00',1.85),('3355','2013-07-31','15:40:00',1.33),('3355','2013-07-31','15:45:00',1.95),('3355','2013-07-31','15:50:00',1.91),('3355','2013-07-31','15:55:00',1.86),('3355','2013-07-31','16:00:00',1.83),('3355','2013-07-31','16:05:00',1.84),('3355','2013-07-31','16:10:00',1.82),('3355','2013-07-31','16:15:00',1.79),('3355','2013-07-31','16:20:00',1.78),('3355','2013-07-31','16:25:00',1.53),('3355','2013-07-31','16:30:00',1.15),('3355','2013-07-31','16:40:00',1.62),('3355','2013-07-31','16:45:00',1.56),('3355','2013-07-31','16:50:00',1.54),('3355','2013-07-31','16:55:00',1.49),('3355','2013-07-31','17:00:00',1.47),('3355','2013-07-31','17:05:00',1.42),('3355','2013-07-31','17:10:00',1.34),('3355','2013-07-31','17:15:00',1),('3355','2013-07-31','17:20:00',1.28),('3355','2013-07-31','17:25:00',1.25),('3355','2013-07-31','17:30:00',1.19),('3355','2013-07-31','17:35:00',1.14),('3355','2013-07-31','17:40:00',1.11),('3355','2013-07-31','17:45:00',1.04),('3355','2013-07-31','17:50:00',1.02),('3355','2014-04-08','09:10:00',1),('3355','2014-04-08','09:15:00',1.06),('3355','2014-04-08','09:20:00',1.1),('3355','2014-04-08','09:25:00',1.16),('3355','2014-04-08','09:30:00',1.21),('3355','2014-04-08','09:35:00',1.24),('3355','2014-04-08','09:40:00',1.27),('3355','2014-04-08','09:45:00',1.31),('3355','2014-04-08','09:50:00',1.36),('3355','2014-04-08','09:55:00',1.37),('3355','2014-04-08','10:00:00',1.41),('3355','2014-04-08','10:05:00',1.43),('3355','2014-04-08','10:10:00',1.45),('3355','2014-04-08','10:15:00',1.55),('3355','2014-04-08','10:20:00',1.6),('3355','2014-04-08','10:25:00',1.63),('3355','2014-04-08','10:30:00',1.63),('3355','2014-04-08','10:35:00',1.67),('3355','2014-04-08','10:40:00',1.73),('3355','2014-04-08','10:45:00',1.77),('3355','2014-04-08','10:50:00',1.8),('3355','2014-04-08','10:55:00',1.84),('3355','2014-04-08','11:00:00',1.85),('3355','2014-04-08','11:05:00',1.89),('3355','2014-04-08','11:10:00',1.89),('3355','2014-04-08','11:15:00',1.91),('3355','2014-04-08','11:20:00',1.95),('3355','2014-04-08','11:25:00',1.76),('3355','2014-04-08','11:30:00',1.94),('3355','2014-04-08','11:35:00',1.93),('3355','2014-04-08','11:40:00',1.98),('3355','2014-04-08','11:45:00',2.03),('3355','2014-04-08','11:50:00',2.02),('3355','2014-04-08','11:55:00',2.01),('3355','2014-04-08','12:00:00',2.11),('3355','2014-04-08','12:05:00',2.04),('3355','2014-04-08','12:10:00',1.99),('3355','2014-04-08','12:15:00',1.95),('3355','2014-04-08','12:20:00',1.95),('3355','2014-04-08','12:25:00',1.95),('3355','2014-04-08','12:30:00',2.13),('3355','2014-04-08','12:35:00',2.26),('3355','2014-04-08','12:40:00',1.98),('3355','2014-04-08','12:45:00',1.81),('3355','2014-04-08','12:50:00',2.04),('3355','2014-04-08','12:55:00',2.2),('3355','2014-04-08','13:00:00',2.13),('3355','2014-04-08','13:05:00',2.24),('3355','2014-04-08','13:10:00',2.29),('3355','2014-04-08','13:15:00',2.31),('3355','2014-04-08','13:20:00',2.3),('3355','2014-04-08','13:25:00',2.27),('3355','2014-04-08','13:30:00',2.3),('3355','2014-04-08','13:35:00',2.31),('3355','2014-04-08','13:40:00',2.31),('3355','2014-04-08','13:45:00',2.28),('3355','2014-04-08','13:50:00',2.29),('3355','2014-04-08','13:55:00',2.3),('3355','2014-04-08','14:00:00',2.3),('3355','2014-04-08','14:05:00',2.29),('3355','2014-04-08','14:10:00',2.28),('3355','2014-04-08','14:15:00',2.27),('3355','2014-04-08','14:20:00',2.17),('3355','2014-04-08','14:25:00',2.21),('3355','2014-04-08','14:30:00',2.23),('3355','2014-04-08','14:35:00',2.13),('3355','2014-04-08','14:40:00',2.01),('3355','2014-04-08','14:45:00',1.85),('3355','2014-04-08','14:50:00',2.14),('3355','2014-04-08','14:55:00',2.17),('3355','2014-04-08','15:00:00',2.13),('3355','2014-04-08','15:05:00',2.08),('3355','2014-04-08','15:10:00',2.08),('3355','2014-04-08','15:15:00',2.07),('3355','2014-04-08','15:20:00',2.03),('3355','2014-04-08','15:25:00',2.02),('3355','2014-04-08','15:30:00',1.98),('3355','2014-04-08','15:35:00',1.95),('3355','2014-04-08','15:40:00',1.93),('3355','2014-04-08','15:45:00',1.81),('3355','2014-04-08','15:50:00',1.84),('3355','2014-04-08','15:55:00',1.83),('3355','2014-04-08','16:00:00',1.77),('3355','2014-04-08','16:05:00',1.73),('3355','2014-04-08','16:10:00',1.67),('3355','2014-04-08','16:15:00',1.56),('3355','2014-04-08','16:20:00',1.45),('3355','2014-04-08','16:25:00',1.56),('3355','2014-04-08','16:30:00',1.61),('3355','2014-04-08','16:35:00',1.6),('3355','2014-04-08','16:40:00',1.49),('3355','2014-04-08','16:45:00',1.4),('3355','2014-04-08','16:50:00',1.44),('3355','2014-04-08','16:55:00',1.32),('3355','2014-04-08','17:00:00',1.21),('3355','2014-04-08','17:05:00',1.29),('3355','2014-04-08','17:10:00',1.21),('3355','2014-04-08','17:15:00',1.18),('3355','2014-04-08','17:20:00',1.14),('3355','2014-04-08','17:25:00',1.06),('3355','2013-07-30','09:00:00',1.05),('3355','2013-07-30','09:05:00',1.1),('3355','2013-07-30','09:10:00',1.06),('3355','2013-07-30','09:15:00',1.15),('3355','2013-07-30','09:20:00',1.26),('3355','2013-07-30','09:25:00',1.33),('3355','2013-07-30','09:30:00',1.36),('3355','2013-07-30','09:35:00',1.43),('3355','2013-07-30','09:40:00',1.5),('3355','2013-07-30','09:45:00',1.53),('3355','2013-07-30','09:50:00',1.57),('3355','2013-07-30','09:55:00',1.59),('3355','2013-07-30','10:00:00',1.6),('3355','2013-07-30','10:05:00',1.64),('3355','2013-07-30','10:10:00',1.68),('3355','2013-07-30','10:15:00',1.68),('3355','2013-07-30','10:20:00',1.73),('3355','2013-07-30','10:25:00',1.72),('3355','2013-07-30','10:30:00',1.74),('3355','2013-07-30','10:35:00',1.43),('3355','2013-07-30','10:40:00',1.78),('3355','2013-07-30','10:45:00',1.83),('3355','2013-07-30','10:50:00',1.83),('3355','2013-07-30','10:55:00',1.84),('3355','2013-07-30','11:00:00',1.88),('3355','2013-07-30','11:05:00',1.92),('3355','2013-07-30','11:10:00',1.99),('3355','2013-07-30','11:15:00',2.01),('3355','2013-07-30','11:20:00',1.84),('3355','2013-07-30','11:40:00',2.12),('3355','2013-07-30','11:45:00',2.11),('3355','2013-07-30','11:50:00',2.09),('3355','2013-07-30','11:55:00',2.07),('3355','2013-07-30','12:00:00',2.1),('3355','2013-07-30','12:05:00',2.11),('3355','2013-07-30','12:10:00',2.11),('3355','2013-07-30','12:15:00',2.1),('3355','2013-07-30','12:20:00',2.07),('3355','2013-07-30','12:25:00',2.09),('3355','2013-07-30','12:30:00',2.15),('3355','2013-07-30','12:35:00',2.2),('3355','2013-07-30','12:40:00',2.17),('3355','2013-07-30','12:50:00',2.29),('3355','2013-07-30','12:55:00',2.34),('3355','2013-07-30','13:00:00',2.28),('3355','2013-07-30','13:05:00',1.43),('3355','2013-07-30','13:10:00',1.46),('3355','2013-07-30','13:15:00',1.5),('3355','2013-07-30','13:20:00',2.28),('3355','2013-07-30','13:25:00',2.3),('3355','2013-07-30','13:30:00',2.33),('3355','2013-07-30','13:35:00',2.22),('3355','2013-07-30','13:40:00',2.01),('3355','2013-07-30','13:45:00',2.24),('3355','2013-07-30','13:50:00',2.29),('3355','2013-07-30','13:55:00',2.35),('3355','2013-07-30','14:00:00',2.28),('3355','2013-07-30','14:05:00',2.32),('3355','2013-07-30','14:10:00',1.91),('3355','2013-07-30','14:15:00',2.3),('3355','2013-07-30','14:20:00',2.18),('3355','2013-07-30','14:25:00',2.18),('3355','2013-07-30','14:30:00',2.18),('3355','2013-07-30','14:35:00',2.16),('3355','2013-07-30','14:40:00',2.11),('3355','2013-07-30','14:45:00',2.1),('3355','2013-07-30','14:50:00',2.13),('3355','2013-07-30','14:55:00',2.11),('3355','2013-07-30','15:00:00',2.06),('3355','2013-07-30','15:05:00',2.01),('3355','2013-07-30','15:10:00',1.99),('3355','2013-07-30','15:15:00',1.99),('3355','2013-07-30','15:20:00',1.93),('3355','2013-07-30','15:25:00',1.89),('3355','2013-07-30','15:30:00',1.91),('3355','2013-07-30','15:35:00',1.91),('3355','2013-07-30','15:40:00',1.89),('3355','2013-07-30','15:45:00',1.86),('3355','2013-07-30','15:50:00',1.85),('3355','2013-07-30','15:55:00',1.82),('3355','2013-07-30','16:00:00',1.79),('3355','2013-07-30','16:05:00',1.77),('3355','2013-07-30','16:10:00',1.74),('3355','2013-07-30','16:15:00',1.71),('3355','2013-07-30','16:20:00',1.71),('3355','2013-07-30','16:25:00',1.66),('3355','2013-07-30','16:30:00',1.62),('3355','2013-07-30','16:35:00',1.6),('3355','2013-07-30','16:40:00',1.58),('3355','2013-07-30','16:45:00',1.53),('3355','2013-07-30','16:50:00',1.5),('3355','2013-07-30','16:55:00',1.46),('3355','2013-07-30','17:00:00',1.43),('3355','2013-07-30','17:05:00',1.39),('3355','2013-07-30','17:10:00',1.34),('3355','2013-07-30','17:15:00',1.3),('3355','2013-07-30','17:20:00',1.27),('3355','2013-07-30','17:25:00',1.23),('3355','2013-07-30','17:30:00',1.18),('3355','2013-07-30','17:35:00',1.15),('3355','2013-07-30','17:40:00',1.11),('3355','2013-07-30','17:45:00',1.05),('3355','2013-07-29','09:10:00',1.02),('3355','2013-07-29','09:15:00',1.06),('3355','2013-07-29','09:20:00',1.11),('3355','2013-07-29','09:25:00',1.13),('3355','2013-07-29','09:30:00',1.17),('3355','2013-07-29','09:35:00',1.22),('3355','2013-07-29','09:40:00',1.28),('3355','2013-07-29','09:45:00',1.31),('3355','2013-07-29','09:50:00',1.34),('3355','2013-07-29','09:55:00',1.38),('3355','2013-07-29','10:00:00',1.42),('3355','2013-07-29','10:05:00',1.46),('3355','2013-07-29','10:10:00',1.49),('3355','2013-07-29','10:15:00',1.52),('3355','2013-07-29','10:20:00',1.57),('3355','2013-07-29','10:25:00',1.59),('3355','2013-07-29','10:30:00',1.61),('3355','2013-07-29','10:35:00',1.65),('3355','2013-07-29','10:40:00',1.69),('3355','2013-07-29','10:45:00',1.7),('3355','2013-07-29','10:50:00',1.71),('3355','2013-07-29','10:55:00',1.75),('3355','2013-07-29','11:00:00',1.78),('3355','2013-07-29','11:05:00',1.78),('3355','2013-07-29','11:10:00',1.77),('3355','2013-07-29','11:15:00',1.81),('3355','2013-07-29','11:20:00',1.85),('3355','2013-07-29','11:25:00',1.86),('3355','2013-07-29','11:30:00',1.87),('3355','2013-07-29','11:35:00',1.9),('3355','2013-07-29','11:40:00',1.9),('3355','2013-07-29','11:45:00',1.92),('3355','2013-07-29','11:50:00',1.94),('3355','2013-07-29','11:55:00',1.95),('3355','2013-07-29','12:00:00',1.97),('3355','2013-07-29','12:05:00',1.96),('3355','2013-07-29','12:10:00',1.97),('3355','2013-07-29','12:15:00',1.98),('3355','2013-07-29','12:20:00',2.02),('3355','2013-07-29','12:25:00',2),('3355','2013-07-29','12:30:00',2.03),('3355','2013-07-29','12:35:00',2.05),('3355','2013-07-29','12:40:00',2.06),('3355','2013-07-29','12:45:00',2.06),('3355','2013-07-29','12:50:00',2.06),('3355','2013-07-29','12:55:00',2.03),('3355','2013-07-29','13:00:00',2.03),('3355','2013-07-29','13:05:00',2.07),('3355','2013-07-29','13:10:00',2.08),('3355','2013-07-29','13:15:00',2.08),('3355','2013-07-29','13:20:00',2.09),('3355','2013-07-29','13:25:00',2.12),('3355','2013-07-29','13:30:00',2.15),('3355','2013-07-29','13:35:00',2.15),('3355','2013-07-29','13:40:00',2.15),('3355','2013-07-29','13:45:00',2.16),('3355','2013-07-29','13:50:00',2.16),('3355','2013-07-29','13:55:00',2.16),('3355','2013-07-29','14:00:00',2.15),('3355','2013-07-29','14:05:00',2.15),('3355','2013-07-29','14:10:00',2.14),('3355','2013-07-29','14:15:00',2.14),('3355','2013-07-29','14:20:00',2.14),('3355','2013-07-29','14:25:00',2.11),('3355','2013-07-29','14:30:00',2.1),('3355','2013-07-29','14:35:00',2.1),('3355','2013-07-29','14:40:00',2.08),('3355','2013-07-29','14:45:00',2.07),('3355','2013-07-29','14:50:00',2.04),('3355','2013-07-29','14:55:00',2.03),('3355','2013-07-29','15:00:00',2.03),('3355','2013-07-29','15:05:00',2.02),('3355','2013-07-29','15:10:00',2),('3355','2013-07-29','15:15:00',1.98),('3355','2013-07-29','15:20:00',1.95),('3355','2013-07-29','15:25:00',1.93),('3355','2013-07-29','15:30:00',1.92),('3355','2013-07-29','15:35:00',1.91),('3355','2013-07-29','15:40:00',1.91),('3355','2013-07-29','15:45:00',1.94),('3355','2013-07-29','15:50:00',1.67),('3355','2013-07-29','15:55:00',1.12),('3355','2013-07-29','16:05:00',1.48),('3355','2013-07-29','16:10:00',1.6),('3355','2013-07-29','16:15:00',1.41),('3355','2013-07-29','16:20:00',1.44),('3355','2013-07-29','16:25:00',1.24),('3355','2013-07-29','16:30:00',1.74),('3355','2013-07-29','16:35:00',1.6),('3355','2013-07-29','16:40:00',1.18),('3355','2013-07-29','16:45:00',1.67),('3355','2013-07-29','16:50:00',1.58),('3355','2013-07-29','16:55:00',1.02),('3355','2013-07-29','17:20:00',1.15),('3355','2013-07-29','17:25:00',1.23),('3355','2013-07-29','17:45:00',1.08),('3355','2013-07-29','17:50:00',1.01),('3355','2013-07-28','09:05:00',1.01),('3355','2013-07-28','09:10:00',1.06),('3355','2013-07-28','09:15:00',1.1),('3355','2013-07-28','09:20:00',1.14),('3355','2013-07-28','09:25:00',1.17),('3355','2013-07-28','09:30:00',1.23),('3355','2013-07-28','09:35:00',1.27),('3355','2013-07-28','09:40:00',1.28),('3355','2013-07-28','09:45:00',1.32),('3355','2013-07-28','09:50:00',1.35),('3355','2013-07-28','09:55:00',1.39),('3355','2013-07-28','10:00:00',1.43),('3355','2013-07-28','10:05:00',1.45),('3355','2013-07-28','10:10:00',1.5),('3355','2013-07-28','10:15:00',1.52),('3355','2013-07-28','10:20:00',1.54),('3355','2013-07-28','10:25:00',1.56),('3355','2013-07-28','10:30:00',1.59),('3355','2013-07-28','10:35:00',1.64),('3355','2013-07-28','10:40:00',1.67),('3355','2013-07-28','10:45:00',1.69),('3355','2013-07-28','10:50:00',1.72),('3355','2013-07-28','10:55:00',1.74),('3355','2013-07-28','11:00:00',1.78),('3355','2013-07-28','11:05:00',1.8),('3355','2013-07-28','11:10:00',1.82),('3355','2013-07-28','11:15:00',1.84),('3355','2013-07-28','11:20:00',1.85),('3355','2013-07-28','11:25:00',1.86),('3355','2013-07-28','11:30:00',1.88),('3355','2013-07-28','11:35:00',1.88),('3355','2013-07-28','11:40:00',1.9),('3355','2013-07-28','11:45:00',1.91),('3355','2013-07-28','11:50:00',1.91),('3355','2013-07-28','11:55:00',1.96),('3355','2013-07-28','12:00:00',1.97),('3355','2013-07-28','12:05:00',2.02),('3355','2013-07-28','12:10:00',2),('3355','2013-07-28','12:15:00',1.98),('3355','2013-07-28','12:20:00',1.99),('3355','2013-07-28','12:25:00',1.99),('3355','2013-07-28','12:30:00',2.03),('3355','2013-07-28','12:35:00',2.08),('3355','2013-07-28','12:40:00',2.09),('3355','2013-07-28','12:45:00',2.09),('3355','2013-07-28','12:50:00',2.05),('3355','2013-07-28','12:55:00',2.03),('3355','2013-07-28','13:00:00',2.05),('3355','2013-07-28','13:05:00',2.02),('3355','2013-07-28','13:10:00',2.04),('3355','2013-07-28','13:15:00',2.13),('3355','2013-07-28','13:20:00',2.14),('3355','2013-07-28','13:25:00',2.09),('3355','2013-07-28','13:30:00',2.11),('3355','2013-07-28','13:35:00',2.16),('3355','2013-07-28','13:40:00',2.15),('3355','2013-07-28','13:45:00',2.12),('3355','2013-07-28','13:50:00',2.13),('3355','2013-07-28','13:55:00',2.11),('3355','2013-07-28','14:00:00',2.1),('3355','2013-07-28','14:05:00',2.1),('3355','2013-07-28','14:10:00',2.09),('3355','2013-07-28','14:15:00',2.09),('3355','2013-07-28','14:20:00',2.09),('3355','2013-07-28','14:25:00',2.07),('3355','2013-07-28','14:30:00',2.06),('3355','2013-07-28','14:35:00',2.05),('3355','2013-07-28','14:40:00',2.04),('3355','2013-07-28','14:45:00',2.03),('3355','2013-07-28','14:50:00',2.01),('3355','2013-07-28','14:55:00',2),('3355','2013-07-28','15:00:00',1.97),('3355','2013-07-28','15:05:00',1.96),('3355','2013-07-28','15:10:00',1.95),('3355','2013-07-28','15:15:00',1.95),('3355','2013-07-28','15:20:00',1.9),('3355','2013-07-28','15:25:00',1.89),('3355','2013-07-28','15:30:00',1.88),('3355','2013-07-28','15:35:00',1.84),('3355','2013-07-28','15:40:00',1.83),('3355','2013-07-28','15:45:00',1.84),('3355','2013-07-28','15:50:00',1.81),('3355','2013-07-28','15:55:00',1.78),('3355','2013-07-28','16:00:00',1.76),('3355','2013-07-28','16:05:00',1.75),('3355','2013-07-28','16:10:00',1.74),('3355','2013-07-28','16:15:00',1.71),('3355','2013-07-28','16:20:00',1.68),('3355','2013-07-28','16:25:00',1.67),('3355','2013-07-28','16:30:00',1.64),('3355','2013-07-28','16:35:00',1.61),('3355','2013-07-28','16:40:00',1.57),('3355','2013-07-28','16:45:00',1.54),('3355','2013-07-28','16:50:00',1.51),('3355','2013-07-28','16:55:00',1.47),('3355','2013-07-28','17:00:00',1.43),('3355','2013-07-28','17:05:00',1.39),('3355','2013-07-28','17:10:00',1.35),('3355','2013-07-28','17:15:00',1.32),('3355','2013-07-28','17:20:00',1.29),('3355','2013-07-28','17:25:00',1.24),('3355','2013-07-28','17:30:00',1.2),('3355','2013-07-28','17:35:00',1.15),('3355','2013-07-28','17:40:00',1.11),('3355','2013-07-28','17:45:00',1.08),('3355','2013-07-28','17:50:00',1.02),('3355','2013-07-27','09:05:00',1.03),('3355','2013-07-27','09:10:00',1.08),('3355','2013-07-27','09:15:00',1.13),('3355','2013-07-27','09:20:00',1.16),('3355','2013-07-27','09:25:00',1.21),('3355','2013-07-27','09:30:00',1.25),('3355','2013-07-27','09:35:00',1.28),('3355','2013-07-27','09:40:00',1.32),('3355','2013-07-27','09:45:00',1.36),('3355','2013-07-27','09:50:00',1.4),('3355','2013-07-27','09:55:00',1.44),('3355','2013-07-27','10:00:00',1.48),('3355','2013-07-27','10:05:00',1.51),('3355','2013-07-27','10:10:00',1.54),('3355','2013-07-27','10:15:00',1.57),('3355','2013-07-27','10:20:00',1.6),('3355','2013-07-27','10:25:00',1.63),('3355','2013-07-27','10:30:00',1.66),('3355','2013-07-27','10:35:00',1.68),('3355','2013-07-27','10:40:00',1.72),('3355','2013-07-27','10:45:00',1.73),('3355','2013-07-27','10:50:00',1.76),('3355','2013-07-27','10:55:00',1.78),('3355','2013-07-27','11:00:00',1.79),('3355','2013-07-27','11:05:00',1.81),('3355','2013-07-27','11:10:00',1.82),('3355','2013-07-27','11:15:00',1.83),('3355','2013-07-27','11:20:00',1.89),('3355','2013-07-27','11:25:00',1.92),('3355','2013-07-27','11:30:00',1.94),('3355','2013-07-27','11:35:00',1.95),('3355','2013-07-27','11:40:00',1.95),('3355','2013-07-27','11:45:00',1.97),('3355','2013-07-27','11:50:00',1.98),('3355','2013-07-27','11:55:00',1.99),('3355','2013-07-27','12:00:00',2.01),('3355','2013-07-27','12:05:00',2.03),('3355','2013-07-27','12:10:00',2.04),('3355','2013-07-27','12:15:00',2.06),('3355','2013-07-27','12:20:00',2.07),('3355','2013-07-27','12:25:00',2.05),('3355','2013-07-27','12:30:00',2.02),('3355','2013-07-27','12:35:00',2.01),('3355','2013-07-27','12:40:00',2.02),('3355','2013-07-27','12:45:00',2.06),('3355','2013-07-27','12:50:00',2.03),('3355','2013-07-27','12:55:00',2.08),('3355','2013-07-27','13:00:00',2.1),('3355','2013-07-27','13:05:00',2.14),('3355','2013-07-27','13:10:00',2.15),('3355','2013-07-27','13:15:00',2.13),('3355','2013-07-27','13:20:00',2.1),('3355','2013-07-27','13:25:00',2.17),('3355','2013-07-27','13:30:00',2.16),('3355','2013-07-27','13:35:00',2.11),('3355','2013-07-27','13:40:00',2.19),('3355','2013-07-27','13:45:00',2.22),('3355','2013-07-27','13:50:00',2.2),('3355','2013-07-27','13:55:00',2.18),('3355','2013-07-27','14:00:00',1.99),('3355','2013-07-27','14:05:00',2.14),('3355','2013-07-27','14:10:00',2.17),('3355','2013-07-27','14:15:00',2.07),('3355','2013-07-27','14:20:00',2.11),('3355','2013-07-27','14:25:00',2.09),('3355','2013-07-27','14:30:00',2.07),('3355','2013-07-27','14:35:00',2.07),('3355','2013-07-27','14:40:00',2.09),('3355','2013-07-27','14:45:00',2.07),('3355','2013-07-27','14:50:00',2.03),('3355','2013-07-27','14:55:00',2.01),('3355','2013-07-27','15:00:00',2),('3355','2013-07-27','15:05:00',1.98),('3355','2013-07-27','15:10:00',1.98),('3355','2013-07-27','15:15:00',1.96),('3355','2013-07-27','15:20:00',1.96),('3355','2013-07-27','15:25:00',1.93),('3355','2013-07-27','15:30:00',1.92),('3355','2013-07-27','15:35:00',1.91),('3355','2013-07-27','15:40:00',1.88),('3355','2013-07-27','15:45:00',1.86),('3355','2013-07-27','15:50:00',1.84),('3355','2013-07-27','15:55:00',1.81),('3355','2013-07-27','16:00:00',1.78),('3355','2013-07-27','16:05:00',1.76),('3355','2013-07-27','16:10:00',1.74),('3355','2013-07-27','16:15:00',1.71),('3355','2013-07-27','16:20:00',1.68),('3355','2013-07-27','16:25:00',1.66),('3355','2013-07-27','16:30:00',1.64),('3355','2013-07-27','16:35:00',1.62),('3355','2013-07-27','16:40:00',1.58),('3355','2013-07-27','16:45:00',1.55),('3355','2013-07-27','16:50:00',1.51),('3355','2013-07-27','16:55:00',1.47),('3355','2013-07-27','17:00:00',1.42),('3355','2013-07-27','17:05:00',1.38),('3355','2013-07-27','17:10:00',1.35),('3355','2013-07-27','17:15:00',1.31),('3355','2013-07-27','17:20:00',1.28),('3355','2013-07-27','17:25:00',1.24),('3355','2013-07-27','17:30:00',1.2),('3355','2013-07-27','17:35:00',1.15),('3355','2013-07-27','17:40:00',1.1),('3355','2013-07-27','17:45:00',1.05),('3355','2013-07-27','17:50:00',1.02),('3355','2013-07-26','09:05:00',1.02),('3355','2013-07-26','09:10:00',1.06),('3355','2013-07-26','09:15:00',1.1),('3355','2013-07-26','09:20:00',1.12),('3355','2013-07-26','09:25:00',1.18),('3355','2013-07-26','09:30:00',1.23),('3355','2013-07-26','09:35:00',1.27),('3355','2013-07-26','09:40:00',1.3),('3355','2013-07-26','09:45:00',1.34),('3355','2013-07-26','09:50:00',1.36),('3355','2013-07-26','09:55:00',1.37),('3355','2013-07-26','10:00:00',1.43),('3355','2013-07-26','10:05:00',1.47),('3355','2013-07-26','10:10:00',1.49),('3355','2013-07-26','10:15:00',1.49),('3355','2013-07-26','10:20:00',1.55),('3355','2013-07-26','10:25:00',1.58),('3355','2013-07-26','10:30:00',1.63),('3355','2013-07-26','10:35:00',1.66),('3355','2013-07-26','10:40:00',1.69),('3355','2013-07-26','10:45:00',1.73),('3355','2013-07-26','10:50:00',1.74),('3355','2013-07-26','10:55:00',1.77),('3355','2013-07-26','11:00:00',1.78),('3355','2013-07-26','11:05:00',1.76),('3355','2013-07-26','11:10:00',1.66),('3355','2013-07-26','11:15:00',1.82),('3355','2013-07-26','11:20:00',1.85),('3355','2013-07-26','11:25:00',1.9),('3355','2013-07-26','11:30:00',1.93),('3355','2013-07-26','11:35:00',1.89),('3355','2013-07-26','11:40:00',1.29),('3355','2013-07-26','11:45:00',1.86),('3355','2013-07-26','11:50:00',2.02),('3355','2013-07-26','11:55:00',2.05),('3355','2013-07-26','12:00:00',2.02),('3355','2013-07-26','12:05:00',1.68),('3355','2013-07-26','12:15:00',1.86),('3355','2013-07-26','12:25:00',2.09),('3355','2013-07-26','12:30:00',1.91),('3355','2013-07-26','12:35:00',1.07),('3355','2013-07-26','12:40:00',2.23),('3355','2013-07-26','12:45:00',1.33),('3355','2013-07-26','12:50:00',1.51),('3355','2013-07-26','12:55:00',2.3),('3355','2013-07-26','13:00:00',1.32),('3355','2013-07-26','13:25:00',2.22),('3355','2013-07-26','13:30:00',2.36),('3355','2013-07-26','13:35:00',2.21),('3355','2013-07-26','13:40:00',2.17),('3355','2013-07-26','13:45:00',2.26),('3355','2013-07-26','13:50:00',2.19),('3355','2013-07-26','13:55:00',2),('3355','2013-07-26','14:00:00',2.2),('3355','2013-07-26','14:05:00',2.19),('3355','2013-07-26','14:10:00',2.19),('3355','2013-07-26','14:15:00',2.24),('3355','2013-07-26','14:20:00',2.2),('3355','2013-07-26','14:25:00',2.2),('3355','2013-07-26','14:30:00',2.12),('3355','2013-07-26','14:35:00',2.11),('3355','2013-07-26','14:40:00',2.14),('3355','2013-07-26','14:45:00',2.08),('3355','2013-07-26','14:50:00',2.09),('3355','2013-07-26','14:55:00',2.04),('3355','2013-07-26','15:00:00',2.06),('3355','2013-07-26','15:05:00',2.03),('3355','2013-07-26','15:10:00',2.01),('3355','2013-07-26','15:15:00',2.01),('3355','2013-07-26','15:20:00',1.97),('3355','2013-07-26','15:25:00',1.93),('3355','2013-07-26','15:30:00',1.92),('3355','2013-07-26','15:35:00',1.93),('3355','2013-07-26','15:40:00',1.91),('3355','2013-07-26','15:45:00',1.9),('3355','2013-07-26','15:50:00',1.88),('3355','2013-07-26','15:55:00',1.83),('3355','2013-07-26','16:00:00',1.8),('3355','2013-07-26','16:05:00',1.79),('3355','2013-07-26','16:10:00',1.75),('3355','2013-07-26','16:15:00',1.72),('3355','2013-07-26','16:20:00',1.71),('3355','2013-07-26','16:25:00',1.68),('3355','2013-07-26','16:30:00',1.65),('3355','2013-07-26','16:35:00',1.61),('3355','2013-07-26','16:40:00',1.58),('3355','2013-07-26','16:45:00',1.55),('3355','2013-07-26','16:50:00',1.5),('3355','2013-07-26','16:55:00',1.46),('3355','2013-07-26','17:00:00',1.43),('3355','2013-07-26','17:05:00',1.39),('3355','2013-07-26','17:10:00',1.35),('3355','2013-07-26','17:15:00',1.3),('3355','2013-07-26','17:20:00',1.26),('3355','2013-07-26','17:25:00',1.23),('3355','2013-07-26','17:30:00',1.16),('3355','2013-07-26','17:35:00',1.13),('3355','2013-07-26','17:40:00',1.09),('3355','2013-07-26','17:45:00',1.04),('3355','2013-07-25','09:05:00',1.04),('3355','2013-07-25','09:10:00',1.09),('3355','2013-07-25','09:15:00',1.15),('3355','2013-07-25','09:20:00',1.23),('3355','2013-07-25','09:40:00',1.21),('3355','2013-07-25','09:45:00',1.57),('3355','2013-07-25','09:50:00',1.03),('3355','2013-07-25','10:20:00',1.73),('3355','2013-07-25','10:25:00',1.77),('3355','2013-07-25','10:30:00',1.79),('3355','2013-07-25','10:35:00',1.79),('3355','2013-07-25','10:40:00',1.52),('3355','2013-07-25','10:45:00',1.63),('3355','2013-07-25','10:50:00',1.27),('3355','2013-07-25','10:55:00',1.5),('3355','2013-07-25','11:00:00',1.1),('3355','2013-07-25','11:10:00',1.2),('3355','2013-07-25','11:15:00',1.99),('3355','2013-07-25','11:20:00',1.96),('3355','2013-07-25','11:25:00',1.97),('3355','2013-07-25','11:30:00',1.92),('3355','2013-07-25','11:35:00',1.98),('3355','2013-07-25','11:40:00',1.85),('3355','2013-07-25','11:45:00',1.95),('3355','2013-07-25','11:50:00',1.88),('3355','2013-07-25','12:00:00',1.84),('3355','2013-07-25','12:05:00',2.17),('3355','2013-07-25','12:15:00',1.43),('3355','2013-07-25','12:20:00',1.28),('3355','2013-07-25','12:25:00',1.05),('3355','2013-07-25','12:35:00',1.5),('3355','2013-07-25','13:05:00',1.7),('3355','2013-07-25','13:10:00',1.39),('3355','2013-07-25','13:15:00',1.67),('3355','2013-07-25','13:20:00',2.24),('3355','2013-07-25','13:25:00',2.27),('3355','2013-07-25','13:30:00',2.3),('3355','2013-07-25','13:35:00',2.23),('3355','2013-07-25','13:40:00',2.21),('3355','2013-07-25','13:45:00',2.2),('3355','2013-07-25','13:50:00',2.22),('3355','2013-07-25','13:55:00',2.19),('3355','2013-07-25','14:00:00',2.2),('3355','2013-07-25','14:05:00',2.2),('3355','2013-07-25','14:10:00',2.23),('3355','2013-07-25','14:15:00',2.24),('3355','2013-07-25','14:20:00',2.24),('3355','2013-07-25','14:25:00',2.24),('3355','2013-07-25','14:30:00',2.2),('3355','2013-07-25','14:35:00',2.2),('3355','2013-07-25','14:40:00',2.17),('3355','2013-07-25','14:45:00',2.17),('3355','2013-07-25','14:50:00',2.16),('3355','2013-07-25','14:55:00',2.15),('3355','2013-07-25','15:00:00',2.14),('3355','2013-07-25','15:05:00',2.13),('3355','2013-07-25','15:10:00',2.09),('3355','2013-07-25','15:15:00',2.06),('3355','2013-07-25','15:20:00',2.05),('3355','2013-07-25','15:25:00',2.03),('3355','2013-07-25','15:30:00',2.03),('3355','2013-07-25','15:35:00',2),('3355','2013-07-25','15:40:00',1.98),('3355','2013-07-25','15:45:00',1.97),('3355','2013-07-25','15:50:00',1.93),('3355','2013-07-25','15:55:00',1.9),('3355','2013-07-25','16:00:00',1.88),('3355','2013-07-25','16:05:00',1.86),('3355','2013-07-25','16:10:00',1.83),('3355','2013-07-25','16:15:00',1.8),('3355','2013-07-25','16:20:00',1.77),('3355','2013-07-25','16:25:00',1.74),('3355','2013-07-25','16:30:00',1.7),('3355','2013-07-25','16:35:00',1.66),('3355','2013-07-25','16:40:00',1.64),('3355','2013-07-25','16:45:00',1.61),('3355','2013-07-25','16:50:00',1.58),('3355','2013-07-25','16:55:00',1.54),('3355','2013-07-25','17:00:00',1.49),('3355','2013-07-25','17:05:00',1.48),('3355','2013-07-25','17:10:00',1.42),('3355','2013-07-25','17:15:00',1.38),('3355','2013-07-25','17:20:00',1.34),('3355','2013-07-25','17:25:00',1.29),('3355','2013-07-25','17:30:00',1.26),('3355','2013-07-25','17:35:00',1.22),('3355','2013-07-25','17:40:00',1.17),('3355','2013-07-25','17:45:00',1.14),('3355','2013-07-25','17:50:00',1.07),('3355','2013-07-25','17:55:00',1.02),('3355','2013-07-24','09:05:00',1.11),('3355','2013-07-24','09:10:00',1.23),('3355','2013-07-24','09:35:00',1.31),('3355','2013-07-24','09:40:00',1.14),('3355','2013-07-24','09:45:00',1.01),('3355','2013-07-24','10:25:00',1.01),('3355','2013-07-24','10:30:00',1.66),('3355','2013-07-24','10:35:00',1.72),('3355','2013-07-24','10:40:00',1.87),('3355','2013-07-24','10:45:00',1.99),('3355','2013-07-24','10:55:00',1.35),('3355','2013-07-24','11:00:00',1.6),('3355','2013-07-24','11:05:00',1.12),('3355','2013-07-24','11:10:00',2.01),('3355','2013-07-24','11:15:00',1.67),('3355','2013-07-24','11:20:00',1.32),('3355','2013-07-24','11:25:00',1.95),('3355','2013-07-24','11:30:00',2.06),('3355','2013-07-24','11:35:00',2.09),('3355','2013-07-24','11:40:00',2.06),('3355','2013-07-24','11:45:00',2.04),('3355','2013-07-24','11:50:00',2.02),('3355','2013-07-24','11:55:00',2.08),('3355','2013-07-24','12:00:00',2.16),('3355','2013-07-24','12:05:00',1.81),('3355','2013-07-24','12:15:00',1.12),('3355','2013-07-24','12:20:00',1.7),('3355','2013-07-24','12:25:00',1.37),('3355','2013-07-24','12:45:00',1.08),('3355','2013-07-24','12:50:00',1.23),('3355','2013-07-24','13:00:00',1.05),('3355','2013-07-24','13:05:00',2.44),('3355','2013-07-24','13:10:00',2.34),('3355','2013-07-24','13:15:00',2.22),('3355','2013-07-24','13:20:00',1.07),('3355','2013-07-24','13:35:00',1.51),('3355','2013-07-24','13:55:00',2.1),('3355','2013-07-24','14:00:00',1.27),('3355','2013-07-24','14:05:00',2.34),('3355','2013-07-24','14:10:00',1.39),('3355','2013-07-24','14:15:00',2.4),('3355','2013-07-24','14:20:00',2.07),('3355','2013-07-24','14:25:00',1.85),('3355','2013-07-24','14:30:00',2.03),('3355','2013-07-24','14:35:00',1.61),('3355','2013-07-24','14:40:00',2.26),('3355','2013-07-24','14:45:00',2.29),('3355','2013-07-24','14:50:00',2.27),('3355','2013-07-24','14:55:00',2.23),('3355','2013-07-24','15:00:00',2.18),('3355','2013-07-24','15:05:00',2.18),('3355','2013-07-24','15:10:00',2.13),('3355','2013-07-24','15:15:00',2.12),('3355','2013-07-24','15:20:00',2.11),('3355','2013-07-24','15:25:00',2.1),('3355','2013-07-24','15:30:00',1.98),('3355','2013-07-24','15:35:00',1.92),('3355','2013-07-24','15:40:00',1.99),('3355','2013-07-24','15:45:00',1.93),('3355','2013-07-24','15:50:00',1.9),('3355','2013-07-24','15:55:00',1.89),('3355','2013-07-24','16:00:00',1.89),('3355','2013-07-24','16:05:00',1.84),('3355','2013-07-24','16:10:00',1.79),('3355','2013-07-24','16:15:00',1.8),('3355','2013-07-24','16:20:00',1.84),('3355','2013-07-24','16:25:00',1.8),('3355','2013-07-24','16:30:00',1.76),('3355','2013-07-24','16:35:00',1.73),('3355','2013-07-24','16:40:00',1.69),('3355','2013-07-24','16:45:00',1.63),('3355','2013-07-24','16:50:00',1.58),('3355','2013-07-24','16:55:00',1.64),('3355','2013-07-24','17:00:00',1.62),('3355','2013-07-24','17:05:00',1.5),('3355','2013-07-24','17:10:00',1.01),('3355','2013-07-24','17:15:00',1.32),('3355','2013-07-24','17:20:00',1.39),('3355','2013-07-24','17:25:00',1.33),('3355','2013-07-24','17:30:00',1.28),('3355','2013-07-24','17:35:00',1.22),('3355','2013-07-24','17:40:00',1.16),('3355','2013-07-24','17:45:00',1.12),('3355','2013-07-24','17:50:00',1.05),('3355','2013-07-24','17:55:00',1.01),('3355','2013-07-23','08:55:00',1.02),('3355','2013-07-23','09:00:00',1.06),('3355','2013-07-23','09:05:00',1.11),('3355','2013-07-23','09:10:00',1.15),('3355','2013-07-23','09:15:00',1.18),('3355','2013-07-23','09:20:00',1.21),('3355','2013-07-23','09:25:00',1.24),('3355','2013-07-23','09:30:00',1.28),('3355','2013-07-23','09:35:00',1.32),('3355','2013-07-23','09:40:00',1.35),('3355','2013-07-23','09:45:00',1.38),('3355','2013-07-23','09:50:00',1.41),('3355','2013-07-23','09:55:00',1.43),('3355','2013-07-23','10:00:00',1.48),('3355','2013-07-23','10:05:00',1.53),('3355','2013-07-23','10:10:00',1.55),('3355','2013-07-23','10:15:00',1.58),('3355','2013-07-23','10:20:00',1.6),('3355','2013-07-23','10:25:00',1.64),('3355','2013-07-23','10:30:00',1.72),('3355','2013-07-23','10:35:00',1.74),('3355','2013-07-23','10:40:00',1.78),('3355','2013-07-23','10:45:00',1.78),('3355','2013-07-23','10:50:00',1.8),('3355','2013-07-23','10:55:00',1.83),('3355','2013-07-23','11:00:00',1.86),('3355','2013-07-23','11:05:00',1.88),('3355','2013-07-23','11:10:00',1.91),('3355','2013-07-23','11:15:00',1.94),('3355','2013-07-23','11:20:00',1.97),('3355','2013-07-23','11:25:00',1.98),('3355','2013-07-23','11:30:00',1.99),('3355','2013-07-23','11:35:00',2),('3355','2013-07-23','11:40:00',2.01),('3355','2013-07-23','11:45:00',2.01),('3355','2013-07-23','11:50:00',2.03),('3355','2013-07-23','11:55:00',2.04),('3355','2013-07-23','12:00:00',2.09),('3355','2013-07-23','12:05:00',2.08),('3355','2013-07-23','12:10:00',2.12),('3355','2013-07-23','12:15:00',2.14),('3355','2013-07-23','12:20:00',2.14),('3355','2013-07-23','12:25:00',2.15),('3355','2013-07-23','12:30:00',2.17),('3355','2013-07-23','12:35:00',2.15),('3355','2013-07-23','12:40:00',2.17),('3355','2013-07-23','12:45:00',2.15),('3355','2013-07-23','12:50:00',1.55),('3355','2013-07-23','12:55:00',1.63),('3355','2013-07-23','13:00:00',1.59),('3355','2013-07-23','13:10:00',1.07),('3355','2013-07-23','13:15:00',1.06),('3355','2013-07-23','13:30:00',1.49),('3355','2013-07-23','13:35:00',2.36),('3355','2013-07-23','13:40:00',2.3),('3355','2013-07-23','13:45:00',2.16),('3355','2013-07-23','13:50:00',2.2),('3355','2013-07-23','13:55:00',1.85),('3355','2013-07-23','14:00:00',2.36),('3355','2013-07-23','14:05:00',1.24),('3355','2013-07-23','14:40:00',1.78),('3355','2013-07-23','14:45:00',1.81),('3355','2013-07-23','14:50:00',1.9),('3355','2013-07-23','14:55:00',2.06),('3355','2013-07-23','15:00:00',2.35),('3355','2013-07-23','15:05:00',2.34),('3355','2013-07-23','15:10:00',2.08),('3355','2013-07-23','15:15:00',1.97),('3355','2013-07-23','15:20:00',2.07),('3355','2013-07-23','15:25:00',1.97),('3355','2013-07-23','15:30:00',1.97),('3355','2013-07-23','15:35:00',1.92),('3355','2013-07-23','15:40:00',1.98),('3355','2013-07-23','15:45:00',1.92),('3355','2013-07-23','15:50:00',1.92),('3355','2013-07-23','15:55:00',1.91),('3355','2013-07-23','16:00:00',1.86),('3355','2013-07-23','16:05:00',1.81),('3355','2013-07-23','16:10:00',1.79),('3355','2013-07-23','16:15:00',1.74),('3355','2013-07-23','16:20:00',1.74),('3355','2013-07-23','16:25:00',1.73),('3355','2013-07-23','16:30:00',1.69),('3355','2013-07-23','16:35:00',1.65),('3355','2013-07-23','16:40:00',1.61),('3355','2013-07-23','16:45:00',1.57),('3355','2013-07-23','16:50:00',1.53),('3355','2013-07-23','16:55:00',1.49),('3355','2013-07-23','17:00:00',1.45),('3355','2013-07-23','17:05:00',1.42),('3355','2013-07-23','17:10:00',1.4),('3355','2013-07-23','17:15:00',1.36),('3355','2013-07-23','17:20:00',1.34),('3355','2013-07-23','17:25:00',1.3),('3355','2013-07-23','17:30:00',1.26),('3355','2013-07-23','17:35:00',1.22),('3355','2013-07-23','17:40:00',1.17),('3355','2013-07-23','17:45:00',1.13),('3355','2013-07-23','17:50:00',1.09),('3355','2013-07-23','17:55:00',1.05),('3355','2013-07-23','18:00:00',1),('3355','2013-07-22','08:55:00',1),('3355','2013-07-22','09:00:00',1.05),('3355','2013-07-22','09:05:00',1.09),('3355','2013-07-22','09:10:00',1.14),('3355','2013-07-22','09:15:00',1.18),('3355','2013-07-22','09:20:00',1.22),('3355','2013-07-22','09:25:00',1.25),('3355','2013-07-22','09:30:00',1.29),('3355','2013-07-22','09:35:00',1.33),('3355','2013-07-22','09:40:00',1.37),('3355','2013-07-22','09:45:00',1.41),('3355','2013-07-22','09:50:00',1.45),('3355','2013-07-22','09:55:00',1.48),('3355','2013-07-22','10:00:00',1.51),('3355','2013-07-22','10:05:00',1.54),('3355','2013-07-22','10:10:00',1.58),('3355','2013-07-22','10:15:00',1.62),('3355','2013-07-22','10:20:00',1.65),('3355','2013-07-22','10:25:00',1.67),('3355','2013-07-22','10:30:00',1.7),('3355','2013-07-22','10:35:00',1.73),('3355','2013-07-22','10:40:00',1.76),('3355','2013-07-22','10:45:00',1.78),('3355','2013-07-22','10:50:00',1.8),('3355','2013-07-22','10:55:00',1.83),('3355','2013-07-22','11:00:00',1.86),('3355','2013-07-22','11:05:00',1.89),('3355','2013-07-22','11:10:00',1.9),('3355','2013-07-22','11:15:00',1.9),('3355','2013-07-22','11:20:00',1.91),('3355','2013-07-22','11:25:00',1.95),('3355','2013-07-22','11:30:00',1.97),('3355','2013-07-22','11:35:00',1.99),('3355','2013-07-22','11:40:00',2.01),('3355','2013-07-22','11:45:00',2.03),('3355','2013-07-22','11:50:00',2.04),('3355','2013-07-22','11:55:00',2.03),('3355','2013-07-22','12:00:00',2.06),('3355','2013-07-22','12:05:00',2.07),('3355','2013-07-22','12:10:00',2.09),('3355','2013-07-22','12:15:00',2.09),('3355','2013-07-22','12:20:00',2.1),('3355','2013-07-22','12:25:00',2.11),('3355','2013-07-22','12:30:00',2.13),('3355','2013-07-22','12:35:00',2.13),('3355','2013-07-22','12:40:00',2.13),('3355','2013-07-22','12:45:00',2.13),('3355','2013-07-22','12:50:00',2.15),('3355','2013-07-22','12:55:00',2.16),('3355','2013-07-22','13:00:00',2.17),('3355','2013-07-22','13:05:00',2.18),('3355','2013-07-22','13:10:00',2.17),('3355','2013-07-22','13:15:00',2.15),('3355','2013-07-22','13:20:00',2.16),('3355','2013-07-22','13:25:00',2.14),('3355','2013-07-22','13:30:00',2.14),('3355','2013-07-22','13:35:00',2.13),('3355','2013-07-22','13:40:00',2.19),('3355','2013-07-22','13:45:00',2.17),('3355','2013-07-22','13:50:00',2.16),('3355','2013-07-22','13:55:00',2.14),('3355','2013-07-22','14:00:00',2.13),('3355','2013-07-22','14:05:00',2.14),('3355','2013-07-22','14:10:00',2.11),('3355','2013-07-22','14:15:00',2.12),('3355','2013-07-22','14:20:00',2.12),('3355','2013-07-22','14:25:00',2.11),('3355','2013-07-22','14:30:00',2.1),('3355','2013-07-22','14:35:00',2.11),('3355','2013-07-22','14:40:00',2.1),('3355','2013-07-22','14:45:00',2.09),('3355','2013-07-22','14:50:00',2.07),('3355','2013-07-22','14:55:00',2.05),('3355','2013-07-22','15:00:00',1.79),('3355','2013-07-22','15:05:00',2.06),('3355','2013-07-22','15:10:00',2.03),('3355','2013-07-22','15:15:00',2.01),('3355','2013-07-22','15:20:00',1.95),('3355','2013-07-22','15:25:00',1.99),('3355','2013-07-22','15:30:00',1.97),('3355','2013-07-22','15:35:00',1.24),('3355','2013-07-22','15:40:00',1.61),('3355','2013-07-22','15:45:00',1.99),('3355','2013-07-22','15:50:00',1.96),('3355','2013-07-22','15:55:00',1.83),('3355','2013-07-22','16:00:00',1.56),('3355','2013-07-22','16:05:00',1.18),('3355','2013-07-22','16:20:00',1.66),('3355','2013-07-22','16:25:00',1.89),('3355','2013-07-22','16:30:00',1.77),('3355','2013-07-22','16:35:00',1.67),('3355','2013-07-22','16:40:00',1.59),('3355','2013-07-22','16:45:00',1.56),('3355','2013-07-22','16:50:00',1.52),('3355','2013-07-22','16:55:00',1.51),('3355','2013-07-22','17:00:00',1.45),('3355','2013-07-22','17:05:00',1.43),('3355','2013-07-22','17:10:00',1.4),('3355','2013-07-22','17:15:00',1.36),('3355','2013-07-22','17:20:00',1.31),('3355','2013-07-22','17:25:00',1.22),('3355','2013-07-22','17:30:00',1.19),('3355','2013-07-22','17:35:00',1.2),('3355','2013-07-22','17:40:00',1.1),('3355','2013-07-22','17:45:00',1.01),('3355','2013-07-22','17:50:00',1),('3355','2013-07-21','09:00:00',1),('3355','2013-07-21','09:05:00',1.04),('3355','2013-07-21','09:10:00',1.09),('3355','2013-07-21','09:15:00',1.13),('3355','2013-07-21','09:20:00',1.17),('3355','2013-07-21','09:25:00',1.21),('3355','2013-07-21','09:30:00',1.24),('3355','2013-07-21','09:35:00',1.28),('3355','2013-07-21','09:40:00',1.32),('3355','2013-07-21','09:45:00',1.35),('3355','2013-07-21','09:50:00',1.39),('3355','2013-07-21','09:55:00',1.42),('3355','2013-07-21','10:00:00',1.46),('3355','2013-07-21','10:05:00',1.5),('3355','2013-07-21','10:10:00',1.53),('3355','2013-07-21','10:15:00',1.56),('3355','2013-07-21','10:20:00',1.59),('3355','2013-07-21','10:25:00',1.62),('3355','2013-07-21','10:30:00',1.64),('3355','2013-07-21','10:35:00',1.68),('3355','2013-07-21','10:40:00',1.71),('3355','2013-07-21','10:45:00',1.74),('3355','2013-07-21','10:50:00',1.77),('3355','2013-07-21','10:55:00',1.8),('3355','2013-07-21','11:00:00',1.82),('3355','2013-07-21','11:05:00',1.84),('3355','2013-07-21','11:10:00',1.85),('3355','2013-07-21','11:15:00',1.88),('3355','2013-07-21','11:20:00',1.89),('3355','2013-07-21','11:25:00',1.91),('3355','2013-07-21','11:30:00',1.95),('3355','2013-07-21','11:35:00',1.97),('3355','2013-07-21','11:40:00',2.05),('3355','2013-07-21','11:45:00',2.05),('3355','2013-07-21','11:50:00',2.01),('3355','2013-07-21','11:55:00',2.02),('3355','2013-07-21','12:00:00',2.04),('3355','2013-07-21','12:05:00',2.06),('3355','2013-07-21','12:10:00',2.1),('3355','2013-07-21','12:15:00',2.17),('3355','2013-07-21','12:20:00',2.23),('3355','2013-07-21','12:25:00',2.26),('3355','2013-07-21','12:30:00',2.32),('3355','2013-07-21','12:35:00',2.4),('3355','2013-07-21','12:40:00',2.45),('3355','2013-07-21','12:45:00',2.15),('3355','2013-07-21','12:50:00',2.07),('3355','2013-07-21','12:55:00',2.04),('3355','2013-07-21','13:00:00',2.28),('3355','2013-07-21','13:05:00',2.34),('3355','2013-07-21','13:10:00',2.52),('3355','2013-07-21','13:15:00',2.45),('3355','2013-07-21','13:20:00',2.23),('3355','2013-07-21','13:25:00',2.38),('3355','2013-07-21','13:30:00',2.27),('3355','2013-07-21','13:35:00',1.8),('3355','2013-07-21','13:40:00',1.61),('3355','2013-07-21','14:45:00',1.21),('3355','2013-07-21','14:50:00',1.59),('3355','2013-07-21','15:15:00',2.23),('3355','2013-07-21','15:20:00',2.58),('3355','2013-07-21','15:40:00',1.96),('3355','2013-07-21','15:45:00',1.67),('3355','2013-07-21','15:55:00',1.05),('3355','2014-04-07','11:05:00',1.03),('3355','2014-04-07','11:10:00',1.18),('3355','2014-04-07','11:15:00',1.3),('3355','2014-04-07','11:20:00',1.17),('3355','2014-04-07','11:25:00',1.13),('3355','2014-04-07','11:30:00',1.13),('3355','2014-04-07','11:35:00',1.1),('3355','2014-04-07','11:40:00',1.06),('3355','2014-04-07','12:00:00',1.03),('3355','2014-04-07','12:05:00',1.27),('3355','2014-04-07','12:10:00',1.47),('3355','2014-04-07','12:15:00',1.9),('3355','2014-04-07','12:20:00',2.35),('3355','2014-04-07','12:25:00',2.26),('3355','2014-04-07','12:30:00',1.46),('3355','2014-04-07','12:35:00',1.33),('3355','2014-04-07','12:40:00',1.61),('3355','2014-04-07','12:45:00',2.22),('3355','2014-04-07','12:50:00',2.25),('3355','2014-04-07','12:55:00',2.22),('3355','2014-04-07','13:00:00',2.23),('3355','2014-04-07','13:05:00',2.21),('3355','2014-04-07','13:10:00',2.21),('3355','2014-04-07','13:15:00',2.21),('3355','2014-04-07','13:20:00',2.22),('3355','2014-04-07','13:25:00',2.2),('3355','2014-04-07','13:30:00',2.19),('3355','2014-04-07','13:35:00',2.18),('3355','2014-04-07','13:40:00',2.19),('3355','2014-04-07','13:45:00',2.2),('3355','2014-04-07','13:50:00',2.19),('3355','2014-04-07','13:55:00',2.18),('3355','2014-04-07','14:00:00',2.15),('3355','2014-04-07','14:05:00',2.16),('3355','2014-04-07','14:10:00',2.15),('3355','2014-04-07','14:15:00',2.15),('3355','2014-04-07','14:20:00',2.15),('3355','2014-04-07','14:25:00',2.22),('3355','2014-04-07','14:30:00',2.2),('3355','2014-04-07','14:35:00',2.14),('3355','2014-04-07','14:40:00',2.13),('3355','2014-04-07','14:45:00',2.08),('3355','2014-04-07','14:50:00',1.98),('3355','2014-04-07','14:55:00',1.7),('3355','2014-04-07','15:00:00',2.02),('3355','2014-04-07','15:05:00',2.1),('3355','2014-04-07','15:10:00',2.06),('3355','2014-04-07','15:15:00',1.33),('3355','2014-04-07','15:20:00',2.04),('3355','2014-04-07','15:25:00',2.03),('3355','2014-04-07','15:30:00',1.97),('3355','2014-04-07','15:35:00',2),('3355','2014-04-07','15:40:00',1.97),('3355','2014-04-07','15:45:00',2.01),('3355','2014-04-07','15:50:00',2.09),('3355','2014-04-07','15:55:00',1.9),('3355','2014-04-07','16:00:00',1.17),('3355','2014-04-07','16:10:00',1.83),('3355','2014-04-07','16:15:00',1.72),('3355','2014-04-07','16:20:00',1.59),('3355','2014-04-07','16:25:00',1.56),('3355','2014-04-07','16:30:00',1.52),('3355','2014-04-07','16:35:00',1.24),('3355','2014-04-07','16:45:00',1.22),('3355','2014-04-07','16:50:00',1.22),('3355','2014-04-07','16:55:00',1.48),('3355','2014-04-07','17:00:00',1.49),('3355','2014-04-07','17:05:00',1.29),('3355','2014-04-07','17:15:00',1.08),('3355','2013-07-20','08:55:00',1.02),('3355','2013-07-20','09:00:00',1.08),('3355','2013-07-20','09:05:00',1.13),('3355','2013-07-20','09:10:00',1.2),('3355','2013-07-20','09:15:00',1.25),('3355','2013-07-20','09:20:00',1.28),('3355','2013-07-20','09:25:00',1.27),('3355','2013-07-20','09:30:00',1.27),('3355','2013-07-20','09:35:00',1.3),('3355','2013-07-20','09:40:00',1.28),('3355','2013-07-20','09:45:00',1.42),('3355','2013-07-20','09:50:00',1.4),('3355','2013-07-20','09:55:00',1.42),('3355','2013-07-20','10:00:00',1.5),('3355','2013-07-20','10:05:00',1.51),('3355','2013-07-20','10:10:00',1.56),('3355','2013-07-20','10:15:00',1.6),('3355','2013-07-20','10:20:00',1.63),('3355','2013-07-20','10:25:00',1.66),('3355','2013-07-20','10:30:00',1.7),('3355','2013-07-20','10:35:00',1.73),('3355','2013-07-20','10:40:00',1.75),('3355','2013-07-20','10:45:00',1.78),('3355','2013-07-20','10:50:00',1.81),('3355','2013-07-20','10:55:00',1.83),('3355','2013-07-20','11:00:00',1.86),('3355','2013-07-20','11:05:00',1.85),('3355','2013-07-20','11:10:00',1.91),('3355','2013-07-20','11:15:00',1.92),('3355','2013-07-20','11:20:00',1.93),('3355','2013-07-20','11:25:00',1.93),('3355','2013-07-20','11:30:00',1.94),('3355','2013-07-20','11:35:00',1.98),('3355','2013-07-20','11:40:00',2.02),('3355','2013-07-20','11:45:00',2.02),('3355','2013-07-20','11:50:00',2.07),('3355','2013-07-20','11:55:00',2.09),('3355','2013-07-20','12:00:00',2.06),('3355','2013-07-20','12:05:00',2.09),('3355','2013-07-20','12:10:00',2.12),('3355','2013-07-20','12:15:00',2.15),('3355','2013-07-20','12:20:00',2.05),('3355','2013-07-20','12:30:00',1.88),('3355','2013-07-20','12:35:00',2.19),('3355','2013-07-20','12:40:00',2.19),('3355','2013-07-20','12:45:00',2.22),('3355','2013-07-20','12:50:00',2.2),('3355','2013-07-20','12:55:00',2.24),('3355','2013-07-20','13:00:00',2.28),('3355','2013-07-20','13:05:00',2.27),('3355','2013-07-20','13:10:00',2.25),('3355','2013-07-20','13:15:00',2.27),('3355','2013-07-20','13:20:00',1.05),('3355','2013-07-20','13:25:00',1.13),('3355','2013-07-20','13:30:00',2.36),('3355','2013-07-20','13:35:00',2.32),('3355','2013-07-20','13:40:00',2.33),('3355','2013-07-20','13:45:00',2.3),('3355','2013-07-20','13:50:00',2.28),('3355','2013-07-20','14:05:00',2.33),('3355','2013-07-20','14:10:00',2.33),('3355','2013-07-20','14:15:00',1.5),('3355','2013-07-20','14:20:00',1.68),('3355','2013-07-20','14:25:00',2.29),('3355','2013-07-20','14:30:00',2.24),('3355','2013-07-20','14:35:00',1.97),('3355','2013-07-20','14:40:00',2.12),('3355','2013-07-20','14:50:00',1.89),('3355','2013-07-20','14:55:00',1.25),('3355','2013-07-20','15:05:00',1.89),('3355','2013-07-20','15:10:00',2.21),('3355','2013-07-20','15:15:00',2.12),('3355','2013-07-20','15:20:00',2.07),('3355','2013-07-20','15:25:00',2.02),('3355','2013-07-20','15:30:00',2),('3355','2013-07-20','15:35:00',1.97),('3355','2013-07-20','15:40:00',1.94),('3355','2013-07-20','15:45:00',1.91),('3355','2013-07-20','15:50:00',1.88),('3355','2013-07-20','15:55:00',1.86),('3355','2013-07-20','16:00:00',1.84),('3355','2013-07-20','16:05:00',1.78),('3355','2013-07-20','16:10:00',1.78),('3355','2013-07-20','16:15:00',1.77),('3355','2013-07-20','16:20:00',1.75),('3355','2013-07-20','16:25:00',1.72),('3355','2013-07-20','16:30:00',1.69),('3355','2013-07-20','16:35:00',1.65),('3355','2013-07-20','16:40:00',1.61),('3355','2013-07-20','16:45:00',1.56),('3355','2013-07-20','16:50:00',1.51),('3355','2013-07-20','16:55:00',1.48),('3355','2013-07-20','17:00:00',1.45),('3355','2013-07-20','17:05:00',1.42),('3355','2013-07-20','17:10:00',1.37),('3355','2013-07-20','17:15:00',1.34),('3355','2013-07-20','17:20:00',1.31),('3355','2013-07-20','17:25:00',1.27),('3355','2013-07-20','17:30:00',1.23),('3355','2013-07-20','17:35:00',1.2),('3355','2013-07-20','17:40:00',1.15),('3355','2013-07-20','17:45:00',1.11),('3355','2013-07-20','17:50:00',1.05),('3355','2013-07-20','17:55:00',1),('3355','2013-07-19','09:00:00',1),('3355','2013-07-19','09:05:00',1.04),('3355','2013-07-19','09:10:00',1.09),('3355','2013-07-19','09:15:00',1.13),('3355','2013-07-19','09:20:00',1.17),('3355','2013-07-19','09:25:00',1.2),('3355','2013-07-19','09:30:00',1.24),('3355','2013-07-19','09:35:00',1.29),('3355','2013-07-19','09:40:00',1.31),('3355','2013-07-19','09:45:00',1.32),('3355','2013-07-19','09:50:00',1.37),('3355','2013-07-19','09:55:00',1.41),('3355','2013-07-19','10:00:00',1.44),('3355','2013-07-19','10:05:00',1.47),('3355','2013-07-19','10:10:00',1.49),('3355','2013-07-19','10:15:00',1.52),('3355','2013-07-19','10:20:00',1.54),('3355','2013-07-19','10:25:00',1.6),('3355','2013-07-19','10:30:00',1.6),('3355','2013-07-19','10:35:00',1.65),('3355','2013-07-19','10:40:00',1.67),('3355','2013-07-19','10:45:00',1.7),('3355','2013-07-19','10:50:00',1.72),('3355','2013-07-19','10:55:00',1.75),('3355','2013-07-19','11:00:00',1.79),('3355','2013-07-19','11:05:00',1.8),('3355','2013-07-19','11:10:00',1.81),('3355','2013-07-19','11:15:00',1.82),('3355','2013-07-19','11:20:00',1.86),('3355','2013-07-19','11:25:00',1.88),('3355','2013-07-19','11:30:00',1.87),('3355','2013-07-19','11:35:00',1.88),('3355','2013-07-19','11:40:00',1.91),('3355','2013-07-19','11:45:00',1.97),('3355','2013-07-19','11:50:00',2.03),('3355','2013-07-19','11:55:00',2.02),('3355','2013-07-19','12:00:00',1.68),('3355','2013-07-19','12:05:00',1.11),('3355','2013-07-19','12:10:00',2.05),('3355','2013-07-19','12:15:00',2.09),('3355','2013-07-19','12:20:00',2.11),('3355','2013-07-19','12:25:00',1.68),('3355','2013-07-19','12:30:00',1.96),('3355','2013-07-19','12:35:00',1.98),('3355','2013-07-19','12:40:00',1.89),('3355','2013-07-19','12:45:00',2.1),('3355','2013-07-19','12:50:00',2.14),('3355','2013-07-19','12:55:00',1.46),('3355','2013-07-19','13:00:00',1.09),('3355','2013-07-19','13:05:00',1.87),('3355','2013-07-19','13:10:00',2.24),('3355','2013-07-19','13:15:00',1.61),('3355','2013-07-19','13:25:00',1.51),('3355','2013-07-19','13:30:00',2.4),('3355','2013-07-19','13:35:00',2.3),('3355','2013-07-19','13:40:00',2.29),('3355','2013-07-19','13:45:00',2.29),('3355','2013-07-19','13:50:00',2.22),('3355','2013-07-19','13:55:00',2.1),('3355','2013-07-19','14:00:00',1.79),('3355','2013-07-19','14:05:00',2.32),('3355','2013-07-19','14:10:00',1.74),('3355','2013-07-19','14:15:00',2.17),('3355','2013-07-19','14:20:00',2.3),('3355','2013-07-19','14:25:00',2.18),('3355','2013-07-19','14:30:00',2.31),('3355','2013-07-19','14:35:00',2.31),('3355','2013-07-19','14:40:00',1.92),('3355','2013-07-19','14:45:00',1.72),('3355','2013-07-19','14:50:00',2.18),('3355','2013-07-19','14:55:00',1.78),('3355','2013-07-19','15:00:00',2.22),('3355','2013-07-19','15:05:00',2.15),('3355','2013-07-19','15:10:00',2.15),('3355','2013-07-19','15:15:00',1.16),('3355','2013-07-19','15:20:00',1.85),('3355','2013-07-19','15:25:00',1.52),('3355','2013-07-19','15:30:00',2.13),('3355','2013-07-19','15:35:00',2.02),('3355','2013-07-19','15:40:00',2.07),('3355','2013-07-19','15:45:00',2.03),('3355','2013-07-19','15:50:00',1.98),('3355','2013-07-19','15:55:00',1.93),('3355','2013-07-19','16:00:00',1.9),('3355','2013-07-19','16:05:00',1.88),('3355','2013-07-19','16:10:00',1.86),('3355','2013-07-19','16:15:00',1.85),('3355','2013-07-19','16:20:00',1.81),('3355','2013-07-19','16:25:00',1.78),('3355','2013-07-19','16:30:00',1.75),('3355','2013-07-19','16:35:00',1.74),('3355','2013-07-19','16:40:00',1.71),('3355','2013-07-19','16:45:00',1.68),('3355','2013-07-19','16:50:00',1.64),('3355','2013-07-19','16:55:00',1.66),('3355','2013-07-19','17:00:00',1.38),('3355','2013-07-19','17:05:00',1.38),('3355','2013-07-19','17:10:00',1.53),('3355','2013-07-19','17:15:00',1.4),('3355','2013-07-19','17:20:00',1.24),('3355','2013-07-19','17:25:00',1.1),('3355','2013-07-19','17:30:00',1.19),('3355','2013-07-19','17:35:00',1.12),('3355','2013-07-18','08:55:00',1.01),('3355','2013-07-18','09:00:00',1.05),('3355','2013-07-18','09:05:00',1.09),('3355','2013-07-18','09:10:00',1.13),('3355','2013-07-18','09:15:00',1.16),('3355','2013-07-18','09:20:00',1.22),('3355','2013-07-18','09:25:00',1.25),('3355','2013-07-18','09:30:00',1.29),('3355','2013-07-18','09:35:00',1.33),('3355','2013-07-18','09:40:00',1.37),('3355','2013-07-18','09:45:00',1.4),('3355','2013-07-18','09:50:00',1.44),('3355','2013-07-18','09:55:00',1.47),('3355','2013-07-18','10:00:00',1.5),('3355','2013-07-18','10:05:00',1.53),('3355','2013-07-18','10:10:00',1.57),('3355','2013-07-18','10:15:00',1.61),('3355','2013-07-18','10:20:00',1.63),('3355','2013-07-18','10:25:00',1.66),('3355','2013-07-18','10:30:00',1.71),('3355','2013-07-18','10:35:00',1.73),('3355','2013-07-18','10:40:00',1.76),('3355','2013-07-18','10:45:00',1.77),('3355','2013-07-18','10:50:00',1.8),('3355','2013-07-18','10:55:00',1.83),('3355','2013-07-18','11:00:00',1.84),('3355','2013-07-18','11:05:00',1.87),('3355','2013-07-18','11:10:00',1.89),('3355','2013-07-18','11:15:00',1.9),('3355','2013-07-18','11:20:00',1.94),('3355','2013-07-18','11:25:00',1.96),('3355','2013-07-18','11:30:00',1.97),('3355','2013-07-18','11:35:00',1.98),('3355','2013-07-18','11:40:00',1.99),('3355','2013-07-18','11:45:00',2),('3355','2013-07-18','11:50:00',2.01),('3355','2013-07-18','11:55:00',2.03),('3355','2013-07-18','12:00:00',2.05),('3355','2013-07-18','12:05:00',2.06),('3355','2013-07-18','12:10:00',2.06),('3355','2013-07-18','12:15:00',2.06),('3355','2013-07-18','12:20:00',2.09),('3355','2013-07-18','12:25:00',2.05),('3355','2013-07-18','12:30:00',1.13),('3355','2013-07-18','12:35:00',1.48),('3355','2013-07-18','12:40:00',1.89),('3355','2013-07-18','12:45:00',1.89),('3355','2013-07-18','12:50:00',1.08),('3355','2013-07-18','12:55:00',1.72),('3355','2013-07-18','13:00:00',2.29),('3355','2013-07-18','13:05:00',2.23),('3355','2013-07-18','13:10:00',2.2),('3355','2013-07-18','13:15:00',2.15),('3355','2013-07-18','13:20:00',2),('3355','2013-07-18','13:25:00',2.04),('3355','2013-07-18','13:30:00',2.29),('3355','2013-07-18','13:35:00',2.15),('3355','2013-07-18','13:40:00',2.19),('3355','2013-07-18','13:45:00',2.29),('3355','2013-07-18','13:50:00',2.27),('3355','2013-07-18','13:55:00',2.18),('3355','2013-07-18','14:00:00',2.2),('3355','2013-07-18','14:05:00',2.19),('3355','2013-07-18','14:10:00',2.15),('3355','2013-07-18','14:15:00',2.16),('3355','2013-07-18','14:20:00',2.22),('3355','2013-07-18','14:25:00',2.17),('3355','2013-07-18','14:30:00',2.14),('3355','2013-07-18','14:35:00',2.17),('3355','2013-07-18','14:40:00',2.18),('3355','2013-07-18','14:45:00',2.12),('3355','2013-07-18','14:50:00',2.11),('3355','2013-07-18','14:55:00',2.08),('3355','2013-07-18','15:00:00',2.06),('3355','2013-07-18','15:05:00',2.08),('3355','2013-07-18','15:10:00',2.07),('3355','2013-07-18','15:15:00',2.04),('3355','2013-07-18','15:20:00',2.04),('3355','2013-07-18','15:25:00',2.03),('3355','2013-07-18','15:30:00',2.01),('3355','2013-07-18','15:35:00',1.97),('3355','2013-07-18','15:40:00',1.96),('3355','2013-07-18','15:45:00',1.93),('3355','2013-07-18','15:50:00',1.92),('3355','2013-07-18','15:55:00',1.88),('3355','2013-07-18','16:00:00',1.85),('3355','2013-07-18','16:05:00',1.82),('3355','2013-07-18','16:10:00',1.79),('3355','2013-07-18','16:15:00',1.77),('3355','2013-07-18','16:20:00',1.73),('3355','2013-07-18','16:25:00',1.7),('3355','2013-07-18','16:30:00',1.66),('3355','2013-07-18','16:35:00',1.64),('3355','2013-07-18','16:40:00',1.6),('3355','2013-07-18','16:45:00',1.56),('3355','2013-07-18','16:50:00',1.53),('3355','2013-07-18','16:55:00',1.49),('3355','2013-07-18','17:00:00',1.45),('3355','2013-07-18','17:05:00',1.4),('3355','2013-07-18','17:10:00',1.36),('3355','2013-07-18','17:15:00',1.3),('3355','2013-07-18','17:20:00',1.27),('3355','2013-07-18','17:25:00',1.26),('3355','2013-07-18','17:30:00',1.19),('3355','2013-07-18','17:35:00',1.13),('3355','2013-07-18','17:40:00',1.1),('3355','2013-07-17','08:55:00',1.05),('3355','2013-07-17','09:00:00',1.1),('3355','2013-07-17','09:05:00',1.15),('3355','2013-07-17','09:10:00',1.2),('3355','2013-07-17','09:15:00',1.24),('3355','2013-07-17','09:20:00',1.28),('3355','2013-07-17','09:25:00',1.32),('3355','2013-07-17','09:30:00',1.36),('3355','2013-07-17','09:35:00',1.39),('3355','2013-07-17','09:40:00',1.44),('3355','2013-07-17','09:45:00',1.48),('3355','2013-07-17','09:50:00',1.52),('3355','2013-07-17','09:55:00',1.54),('3355','2013-07-17','10:00:00',1.57),('3355','2013-07-17','10:05:00',1.6),('3355','2013-07-17','10:10:00',1.63),('3355','2013-07-17','10:15:00',1.67),('3355','2013-07-17','10:20:00',1.7),('3355','2013-07-17','10:25:00',1.73),('3355','2013-07-17','10:30:00',1.76),('3355','2013-07-17','10:35:00',1.78),('3355','2013-07-17','10:40:00',1.8),('3355','2013-07-17','10:45:00',1.85),('3355','2013-07-17','10:50:00',1.87),('3355','2013-07-17','10:55:00',1.89),('3355','2013-07-17','11:00:00',1.91),('3355','2013-07-17','11:05:00',1.94),('3355','2013-07-17','11:10:00',1.97),('3355','2013-07-17','11:15:00',1.98),('3355','2013-07-17','11:20:00',2),('3355','2013-07-17','11:25:00',2.03),('3355','2013-07-17','11:30:00',2.04),('3355','2013-07-17','11:35:00',2.06),('3355','2013-07-17','11:40:00',2.06),('3355','2013-07-17','11:45:00',2.08),('3355','2013-07-17','11:50:00',2.09),('3355','2013-07-17','11:55:00',2.12),('3355','2013-07-17','12:00:00',2.13),('3355','2013-07-17','12:05:00',2.14),('3355','2013-07-17','12:10:00',2.16),('3355','2013-07-17','12:15:00',2.15),('3355','2013-07-17','12:20:00',2.18),('3355','2013-07-17','12:25:00',2.19),('3355','2013-07-17','12:30:00',2.19),('3355','2013-07-17','12:35:00',2.2),('3355','2013-07-17','12:40:00',2.19),('3355','2013-07-17','12:45:00',2.21),('3355','2013-07-17','12:50:00',2.21),('3355','2013-07-17','12:55:00',2.23),('3355','2013-07-17','13:00:00',2.21),('3355','2013-07-17','13:05:00',2.2),('3355','2013-07-17','13:10:00',2.22),('3355','2013-07-17','13:15:00',2.21),('3355','2013-07-17','13:20:00',2.19),('3355','2013-07-17','13:25:00',2.18),('3355','2013-07-17','13:30:00',2.19),('3355','2013-07-17','13:35:00',2.17),('3355','2013-07-17','13:40:00',2.18),('3355','2013-07-17','13:45:00',2.2),('3355','2013-07-17','13:50:00',2.2),('3355','2013-07-17','13:55:00',2.19),('3355','2013-07-17','14:00:00',2.2),('3355','2013-07-17','14:05:00',2.19),('3355','2013-07-17','14:10:00',2.17),('3355','2013-07-17','14:15:00',2.16),('3355','2013-07-17','14:20:00',2.15),('3355','2013-07-17','14:25:00',2.12),('3355','2013-07-17','14:30:00',2.11),('3355','2013-07-17','14:35:00',2.11),('3355','2013-07-17','14:40:00',2.22),('3355','2013-07-17','14:45:00',2.19),('3355','2013-07-17','14:50:00',2.12),('3355','2013-07-17','14:55:00',2.07),('3355','2013-07-17','15:00:00',2.05),('3355','2013-07-17','15:05:00',2.08),('3355','2013-07-17','15:10:00',2.1),('3355','2013-07-17','15:15:00',2.06),('3355','2013-07-17','15:20:00',2.05),('3355','2013-07-17','15:25:00',2),('3355','2013-07-17','15:30:00',1.99),('3355','2013-07-17','15:35:00',1.97),('3355','2013-07-17','15:40:00',1.65),('3355','2013-07-17','15:45:00',1.93),('3355','2013-07-17','15:50:00',1.9),('3355','2013-07-17','15:55:00',1.91),('3355','2013-07-17','16:00:00',1.88),('3355','2013-07-17','16:05:00',1.84),('3355','2013-07-17','16:10:00',1.83),('3355','2013-07-17','16:15:00',1.8),('3355','2013-07-17','16:20:00',1.76),('3355','2013-07-17','16:25:00',1.72),('3355','2013-07-17','16:30:00',1.69),('3355','2013-07-17','16:35:00',1.64),('3355','2013-07-17','16:40:00',1.63),('3355','2013-07-17','16:45:00',1.6),('3355','2013-07-17','16:50:00',1.52),('3355','2013-07-17','16:55:00',1.46),('3355','2013-07-17','17:00:00',1.49),('3355','2013-07-17','17:05:00',1.48),('3355','2013-07-17','17:10:00',1.47),('3355','2013-07-17','17:15:00',1.38),('3355','2013-07-17','17:20:00',1.34),('3355','2013-07-17','17:25:00',1.25),('3355','2013-07-17','17:30:00',1.24),('3355','2013-07-17','17:35:00',1.19),('3355','2013-07-17','17:40:00',1.13),('3355','2013-07-17','17:45:00',1.1),('3355','2013-07-17','17:50:00',1.08),('3355','2013-07-16','08:55:00',1.01),('3355','2013-07-16','09:00:00',1.05),('3355','2013-07-16','09:05:00',1.09),('3355','2013-07-16','09:10:00',1.13),('3355','2013-07-16','09:15:00',1.17),('3355','2013-07-16','09:20:00',1.21),('3355','2013-07-16','09:25:00',1.26),('3355','2013-07-16','09:30:00',1.29),('3355','2013-07-16','09:35:00',1.33),('3355','2013-07-16','09:40:00',1.37),('3355','2013-07-16','09:45:00',1.42),('3355','2013-07-16','09:50:00',1.46),('3355','2013-07-16','09:55:00',1.5),('3355','2013-07-16','10:00:00',1.53),('3355','2013-07-16','10:05:00',1.58),('3355','2013-07-16','10:10:00',1.62),('3355','2013-07-16','10:15:00',1.65),('3355','2013-07-16','10:20:00',1.66),('3355','2013-07-16','10:25:00',1.69),('3355','2013-07-16','10:30:00',1.73),('3355','2013-07-16','10:35:00',1.75),('3355','2013-07-16','10:40:00',1.79),('3355','2013-07-16','10:45:00',1.8),('3355','2013-07-16','10:50:00',1.83),('3355','2013-07-16','10:55:00',1.86),('3355','2013-07-16','11:00:00',1.88),('3355','2013-07-16','11:05:00',1.91),('3355','2013-07-16','11:10:00',1.94),('3355','2013-07-16','11:15:00',1.95),('3355','2013-07-16','11:20:00',1.97),('3355','2013-07-16','11:25:00',1.99),('3355','2013-07-16','11:30:00',2.02),('3355','2013-07-16','11:35:00',2.03),('3355','2013-07-16','11:40:00',2.05),('3355','2013-07-16','11:45:00',2.07),('3355','2013-07-16','11:50:00',2.09),('3355','2013-07-16','11:55:00',2.11),('3355','2013-07-16','12:00:00',2.12),('3355','2013-07-16','12:05:00',2.12),('3355','2013-07-16','12:10:00',2.13),('3355','2013-07-16','12:15:00',2.15),('3355','2013-07-16','12:20:00',2.15),('3355','2013-07-16','12:25:00',2.16),('3355','2013-07-16','12:30:00',2.16),('3355','2013-07-16','12:35:00',2.16),('3355','2013-07-16','12:40:00',2.16),('3355','2013-07-16','12:45:00',2.16),('3355','2013-07-16','12:50:00',2.17),('3355','2013-07-16','12:55:00',2.16),('3355','2013-07-16','13:00:00',2.15),('3355','2013-07-16','13:05:00',2.18),('3355','2013-07-16','13:10:00',2.19),('3355','2013-07-16','13:15:00',2.2),('3355','2013-07-16','13:20:00',2.18),('3355','2013-07-16','13:25:00',2.17),('3355','2013-07-16','13:30:00',2.17),('3355','2013-07-16','13:35:00',2.18),('3355','2013-07-16','13:40:00',2.18),('3355','2013-07-16','13:45:00',2.21),('3355','2013-07-16','13:50:00',2.26),('3355','2013-07-16','13:55:00',2.21),('3355','2013-07-16','14:00:00',2.16),('3355','2013-07-16','14:05:00',2.15),('3355','2013-07-16','14:10:00',2.14),('3355','2013-07-16','14:15:00',2.13),('3355','2013-07-16','14:25:00',1.9),('3355','2013-07-16','14:30:00',2.23),('3355','2013-07-16','14:35:00',2.19),('3355','2013-07-16','14:40:00',2.17),('3355','2013-07-16','14:45:00',2.14),('3355','2013-07-16','14:50:00',2.14),('3355','2013-07-16','14:55:00',2.13),('3355','2013-07-16','15:00:00',2.12),('3355','2013-07-16','15:05:00',2.07),('3355','2013-07-16','15:10:00',2.04),('3355','2013-07-16','15:15:00',2.02),('3355','2013-07-16','15:20:00',2.02),('3355','2013-07-16','15:25:00',1.99),('3355','2013-07-16','15:30:00',2),('3355','2013-07-16','15:35:00',2.01),('3355','2013-07-16','15:40:00',1.97),('3355','2013-07-16','15:45:00',1.27),('3355','2013-07-16','15:50:00',1.88),('3355','2013-07-16','15:55:00',1.3),('3355','2013-07-16','16:00:00',1.36),('3355','2013-07-16','16:10:00',1.71),('3355','2013-07-16','16:15:00',1.66),('3355','2013-07-16','16:20:00',1.27),('3355','2013-07-16','16:25:00',1.16),('3355','2013-07-16','17:00:00',1.5),('3355','2013-07-16','17:05:00',1.54),('3355','2013-07-16','17:10:00',1.54),('3355','2013-07-16','17:15:00',1.51),('3355','2013-07-16','17:20:00',1.14),('3355','2013-07-16','17:45:00',1.21),('3355','2013-07-16','17:50:00',1.12),('3355','2013-07-15','08:50:00',1),('3355','2013-07-15','08:55:00',1.06),('3355','2013-07-15','09:00:00',1.1),('3355','2013-07-15','09:05:00',1.14),('3355','2013-07-15','09:10:00',1.19),('3355','2013-07-15','09:15:00',1.23),('3355','2013-07-15','09:20:00',1.27),('3355','2013-07-15','09:25:00',1.31),('3355','2013-07-15','09:30:00',1.35),('3355','2013-07-15','09:35:00',1.39),('3355','2013-07-15','09:40:00',1.42),('3355','2013-07-15','09:45:00',1.46),('3355','2013-07-15','09:50:00',1.5),('3355','2013-07-15','09:55:00',1.53),('3355','2013-07-15','10:00:00',1.55),('3355','2013-07-15','10:05:00',1.58),('3355','2013-07-15','10:10:00',1.62),('3355','2013-07-15','10:15:00',1.65),('3355','2013-07-15','10:20:00',1.68),('3355','2013-07-15','10:25:00',1.71),('3355','2013-07-15','10:30:00',1.74),('3355','2013-07-15','10:35:00',1.75),('3355','2013-07-15','10:40:00',1.78),('3355','2013-07-15','10:45:00',1.8),('3355','2013-07-15','10:50:00',1.84),('3355','2013-07-15','10:55:00',1.86),('3355','2013-07-15','11:00:00',1.88),('3355','2013-07-15','11:05:00',1.92),('3355','2013-07-15','11:10:00',1.94),('3355','2013-07-15','11:15:00',1.96),('3355','2013-07-15','11:20:00',1.99),('3355','2013-07-15','11:25:00',2),('3355','2013-07-15','11:30:00',2.01),('3355','2013-07-15','11:35:00',2.02),('3355','2013-07-15','11:40:00',2.03),('3355','2013-07-15','11:45:00',2.03),('3355','2013-07-15','11:50:00',2.06),('3355','2013-07-15','11:55:00',2.07),('3355','2013-07-15','12:00:00',2.11),('3355','2013-07-15','12:05:00',2.11),('3355','2013-07-15','12:10:00',2.11),('3355','2013-07-15','12:15:00',2.13),('3355','2013-07-15','12:20:00',2.15),('3355','2013-07-15','12:25:00',2.15),('3355','2013-07-15','12:30:00',2.16),('3355','2013-07-15','12:35:00',2.15),('3355','2013-07-15','12:40:00',2.16),('3355','2013-07-15','12:45:00',2.16),('3355','2013-07-15','12:50:00',2.18),('3355','2013-07-15','12:55:00',2.19),('3355','2013-07-15','13:00:00',2.19),('3355','2013-07-15','13:05:00',2.07),('3355','2013-07-15','13:10:00',2.24),('3355','2013-07-15','13:15:00',2.2),('3355','2013-07-15','13:20:00',2.19),('3355','2013-07-15','13:25:00',2.26),('3355','2013-07-15','13:30:00',2.31),('3355','2013-07-15','13:35:00',1.79),('3355','2013-07-15','13:50:00',2.46),('3355','2013-07-15','13:55:00',2.4),('3355','2013-07-15','14:00:00',2.38),('3355','2013-07-15','14:05:00',1.38),('3355','2013-07-15','14:20:00',1.71),('3355','2013-07-15','14:25:00',2.33),('3355','2013-07-15','14:30:00',1.46),('3355','2013-07-15','14:35:00',1.77),('3355','2013-07-15','14:40:00',2.27),('3355','2013-07-15','14:45:00',2.23),('3355','2013-07-15','14:50:00',2.22),('3355','2013-07-15','14:55:00',2.21),('3355','2013-07-15','15:00:00',2.18),('3355','2013-07-15','15:05:00',2.15),('3355','2013-07-15','15:10:00',2.13),('3355','2013-07-15','15:15:00',1.87),('3355','2013-07-15','15:20:00',1.96),('3355','2013-07-15','15:25:00',1.9),('3355','2013-07-15','15:30:00',1.76),('3355','2013-07-15','15:35:00',1.17),('3355','2013-07-15','15:40:00',2.05),('3355','2013-07-15','15:45:00',1.94),('3355','2013-07-15','15:50:00',1.97),('3355','2013-07-15','15:55:00',1.91),('3355','2013-07-15','16:00:00',1.86),('3355','2013-07-15','16:05:00',1.85),('3355','2013-07-15','16:10:00',1.81),('3355','2013-07-15','16:15:00',1.78),('3355','2013-07-15','16:20:00',1.72),('3355','2013-07-15','16:25:00',1.68),('3355','2013-07-15','16:30:00',1.64),('3355','2013-07-15','16:35:00',1.64),('3355','2013-07-15','16:40:00',1.6),('3355','2013-07-15','16:45:00',1.57),('3355','2013-07-15','16:50:00',1.53),('3355','2013-07-15','16:55:00',1.51),('3355','2013-07-15','17:00:00',1.47),('3355','2013-07-15','17:05:00',1.44),('3355','2013-07-15','17:10:00',1.39),('3355','2013-07-15','17:15:00',1.36),('3355','2013-07-15','17:20:00',1.32),('3355','2013-07-15','17:25:00',1.28),('3355','2013-07-15','17:30:00',1.23),('3355','2013-07-15','17:35:00',1.19),('3355','2013-07-15','17:40:00',1.14),('3355','2013-07-15','17:45:00',1.09),('3355','2013-07-15','17:50:00',1.03),('3355','2013-07-14','09:25:00',1.1),('3355','2013-07-14','09:30:00',1.11),('3355','2013-07-14','10:20:00',1.23),('3355','2013-07-14','10:25:00',1.34),('3355','2013-07-14','10:30:00',1.37),('3355','2013-07-14','10:35:00',1.87),('3355','2013-07-14','10:40:00',1.96),('3355','2013-07-14','10:45:00',1.62),('3355','2013-07-14','10:50:00',2.02),('3355','2013-07-14','10:55:00',1.86),('3355','2013-07-14','11:00:00',2.07),('3355','2013-07-14','11:05:00',1.63),('3355','2013-07-14','11:10:00',1.9),('3355','2013-07-14','11:15:00',1.91),('3355','2013-07-14','11:20:00',2.28),('3355','2013-07-14','11:25:00',2.14),('3355','2013-07-14','11:30:00',2.26),('3355','2013-07-14','11:35:00',2.22),('3355','2013-07-14','11:40:00',2.17),('3355','2013-07-14','11:45:00',2.01),('3355','2013-07-14','11:50:00',1.12),('3355','2013-07-14','12:10:00',1.12),('3355','2013-07-14','12:15:00',2.05),('3355','2013-07-14','12:20:00',2.37),('3355','2013-07-14','12:25:00',1.57),('3355','2013-07-14','12:35:00',1.64),('3355','2013-07-14','12:40:00',2.29),('3355','2013-07-14','12:45:00',2.39),('3355','2013-07-14','12:50:00',2.29),('3355','2013-07-14','13:00:00',1.05),('3355','2013-07-14','13:05:00',2.5),('3355','2013-07-14','13:10:00',2.4),('3355','2013-07-14','13:15:00',2.36),('3355','2013-07-14','13:20:00',1.65),('3355','2013-07-14','13:25:00',2.43),('3355','2013-07-14','13:30:00',2.23),('3355','2013-07-14','13:35:00',2.32),('3355','2013-07-14','13:40:00',2.32),('3355','2013-07-14','13:45:00',2.3),('3355','2013-07-14','13:50:00',2.31),('3355','2013-07-14','13:55:00',2.3),('3355','2013-07-14','14:00:00',2.3),('3355','2013-07-14','14:05:00',2.32),('3355','2013-07-14','14:10:00',2.29),('3355','2013-07-14','14:15:00',2.28),('3355','2013-07-14','14:20:00',2.26),('3355','2013-07-14','14:25:00',2.26),('3355','2013-07-14','14:30:00',2.26),('3355','2013-07-14','14:35:00',2.22),('3355','2013-07-14','14:40:00',2.19),('3355','2013-07-14','14:45:00',2.17),('3355','2013-07-14','14:50:00',2.16),('3355','2013-07-14','14:55:00',2.17),('3355','2013-07-14','15:00:00',2.12),('3355','2013-07-14','15:05:00',2.12),('3355','2013-07-14','15:10:00',2.09),('3355','2013-07-14','15:15:00',2.08),('3355','2013-07-14','15:20:00',2.06),('3355','2013-07-14','15:25:00',2.03),('3355','2013-07-14','15:30:00',2.01),('3355','2013-07-14','15:35:00',1.99),('3355','2013-07-14','15:40:00',1.97),('3355','2013-07-14','15:45:00',1.94),('3355','2013-07-14','15:50:00',1.82),('3355','2013-07-14','15:55:00',1.92),('3355','2013-07-14','16:00:00',1.86),('3355','2013-07-14','16:05:00',1.87),('3355','2013-07-14','16:10:00',1.85),('3355','2013-07-14','16:15:00',1.82),('3355','2013-07-14','16:20:00',1.8),('3355','2013-07-14','16:25:00',1.58),('3355','2013-07-14','16:30:00',1.27),('3355','2013-07-14','16:35:00',1.68),('3355','2013-07-14','16:40:00',1.67),('3355','2013-07-14','16:45:00',1.6),('3355','2013-07-14','16:50:00',1.64),('3355','2013-07-14','16:55:00',1.47),('3355','2013-07-14','17:00:00',1.09),('3355','2013-07-14','17:05:00',1.25),('3355','2013-07-14','17:10:00',1),('3355','2013-07-14','17:15:00',1.38),('3355','2013-07-14','17:25:00',1.15),('3355','2013-07-14','17:30:00',1.42),('3355','2013-07-14','17:35:00',1.25),('3355','2013-07-13','09:00:00',1.04),('3355','2013-07-13','09:05:00',1.09),('3355','2013-07-13','09:10:00',1.13),('3355','2013-07-13','09:15:00',1.17),('3355','2013-07-13','09:20:00',1.21),('3355','2013-07-13','09:25:00',1.27),('3355','2013-07-13','09:30:00',1.3),('3355','2013-07-13','09:35:00',1.32),('3355','2013-07-13','09:40:00',1.38),('3355','2013-07-13','09:45:00',1.36),('3355','2013-07-13','09:50:00',1.42),('3355','2013-07-13','09:55:00',1.47),('3355','2013-07-13','10:00:00',1.53),('3355','2013-07-13','10:05:00',1.58),('3355','2013-07-13','10:10:00',1.59),('3355','2013-07-13','10:15:00',1.64),('3355','2013-07-13','10:20:00',1.68),('3355','2013-07-13','10:25:00',1.73),('3355','2013-07-13','10:30:00',1.74),('3355','2013-07-13','10:35:00',1.71),('3355','2013-07-13','10:40:00',1.66),('3355','2013-07-13','10:45:00',1.45),('3355','2013-07-13','10:55:00',1.49),('3355','2013-07-13','11:00:00',2.01),('3355','2013-07-13','11:05:00',2.02),('3355','2013-07-13','11:10:00',1.69),('3355','2013-07-13','11:15:00',2.11),('3355','2013-07-13','11:20:00',1.7),('3355','2013-07-13','11:25:00',1.04),('3355','2013-07-13','11:30:00',2.05),('3355','2013-07-13','11:35:00',2.12),('3355','2013-07-13','11:40:00',2.08),('3355','2013-07-13','11:45:00',1.32),('3355','2013-07-13','11:55:00',1.82),('3355','2013-07-13','12:00:00',2.1),('3355','2013-07-13','12:10:00',1.91),('3355','2013-07-13','12:15:00',2.02),('3355','2013-07-13','12:25:00',2.09),('3355','2013-07-13','12:30:00',1.84),('3355','2013-07-13','12:35:00',1.74),('3355','2013-07-13','12:40:00',2.29),('3355','2013-07-13','12:45:00',2.34),('3355','2013-07-13','12:50:00',2.18),('3355','2013-07-13','12:55:00',2.21),('3355','2013-07-13','13:05:00',2.17),('3355','2013-07-13','13:10:00',2.42),('3355','2013-07-13','13:15:00',1.86),('3355','2013-07-13','13:20:00',2.35),('3355','2013-07-13','13:25:00',2.31),('3355','2013-07-13','13:30:00',2.25),('3355','2013-07-13','13:35:00',2.29),('3355','2013-07-13','13:40:00',2.29),('3355','2013-07-13','13:45:00',2.26),('3355','2013-07-13','13:50:00',2.28),('3355','2013-07-13','13:55:00',2.27),('3355','2013-07-13','14:00:00',2.28),('3355','2013-07-13','14:05:00',2.27),('3355','2013-07-13','14:10:00',2.26),('3355','2013-07-13','14:15:00',2.25),('3355','2013-07-13','14:20:00',2.24),('3355','2013-07-13','14:25:00',2.23),('3355','2013-07-13','14:30:00',2.23),('3355','2013-07-13','14:35:00',2.21),('3355','2013-07-13','14:40:00',2.2),('3355','2013-07-13','14:45:00',2.19),('3355','2013-07-13','14:50:00',2.2),('3355','2013-07-13','14:55:00',2.18),('3355','2013-07-13','15:00:00',2.18),('3355','2013-07-13','15:05:00',2.19),('3355','2013-07-13','15:10:00',2.17),('3355','2013-07-13','15:15:00',2.15),('3355','2013-07-13','15:20:00',2.05),('3355','2013-07-13','15:25:00',2.11),('3355','2013-07-13','15:30:00',2.07),('3355','2013-07-13','15:35:00',2.1),('3355','2013-07-13','15:40:00',2.07),('3355','2013-07-13','15:45:00',2.04),('3355','2013-07-13','15:50:00',2),('3355','2013-07-13','15:55:00',1.98),('3355','2013-07-13','16:00:00',1.96),('3355','2013-07-13','16:05:00',1.92),('3355','2013-07-13','16:10:00',1.89),('3355','2013-07-13','16:15:00',1.85),('3355','2013-07-13','16:20:00',1.81),('3355','2013-07-13','16:25:00',1.82),('3355','2013-07-13','16:30:00',1.79),('3355','2013-07-13','16:35:00',1.74),('3355','2013-07-13','16:40:00',1.71),('3355','2013-07-13','16:45:00',1.66),('3355','2013-07-13','16:50:00',1.62),('3355','2013-07-13','16:55:00',1.59),('3355','2013-07-13','17:00:00',1.55),('3355','2013-07-13','17:05:00',1.48),('3355','2013-07-13','17:10:00',1.47),('3355','2013-07-13','17:15:00',1.42),('3355','2013-07-13','17:20:00',1.34),('3355','2013-07-13','17:25:00',1.35),('3355','2013-07-13','17:30:00',1.28),('3355','2013-07-13','17:35:00',1.23),('3355','2013-07-13','17:40:00',1.21),('3355','2013-07-13','17:45:00',1.17),('3355','2013-07-13','17:50:00',1.11),('3355','2013-07-13','17:55:00',1.11),('3355','2013-07-13','18:00:00',1.02),('3355','2013-07-12','09:25:00',1.27),('3355','2013-07-12','09:35:00',1.01),('3355','2013-07-12','09:45:00',1.35),('3355','2013-07-12','09:50:00',1.44),('3355','2013-07-12','09:55:00',1.44),('3355','2013-07-12','10:00:00',1.23),('3355','2013-07-12','10:05:00',1.5),('3355','2013-07-12','10:10:00',1.56),('3355','2013-07-12','10:15:00',1.34),('3355','2013-07-12','10:30:00',1.14),('3355','2013-07-12','10:35:00',1.29),('3355','2013-07-12','10:55:00',1.52),('3355','2013-07-12','11:00:00',2.19),('3355','2013-07-12','11:05:00',1.12),('3355','2013-07-12','11:15:00',1.76),('3355','2013-07-12','11:25:00',1.67),('3355','2013-07-12','11:30:00',2.08),('3355','2013-07-12','11:35:00',2),('3355','2013-07-12','11:45:00',1.18),('3355','2013-07-12','11:55:00',2.26),('3355','2013-07-12','12:00:00',2.29),('3355','2013-07-12','12:05:00',2.36),('3355','2013-07-12','12:10:00',1.45),('3355','2013-07-12','12:15:00',1.32),('3355','2013-07-12','12:20:00',2.41),('3355','2013-07-12','12:25:00',2.39),('3355','2013-07-12','12:30:00',1.82),('3355','2013-07-12','12:35:00',2.51),('3355','2013-07-12','12:40:00',1.04),('3355','2013-07-12','12:45:00',2.37),('3355','2013-07-12','12:50:00',1.25),('3355','2013-07-12','12:55:00',2.27),('3355','2013-07-12','13:00:00',2.25),('3355','2013-07-12','13:05:00',2.37),('3355','2013-07-12','13:10:00',2.32),('3355','2013-07-12','13:15:00',2.25),('3355','2013-07-12','13:20:00',2.31),('3355','2013-07-12','13:25:00',2.3),('3355','2013-07-12','13:30:00',2.32),('3355','2013-07-12','13:35:00',2.32),('3355','2013-07-12','13:40:00',2.31),('3355','2013-07-12','13:45:00',2.29),('3355','2013-07-12','13:50:00',1.55),('3355','2013-07-12','13:55:00',2.35),('3355','2013-07-12','14:00:00',2.37),('3355','2013-07-12','14:05:00',2.17),('3355','2013-07-12','14:10:00',1.86),('3355','2013-07-12','14:15:00',1.66),('3355','2013-07-12','14:20:00',2.47),('3355','2013-07-12','14:25:00',2.34),('3355','2013-07-12','14:30:00',2.26),('3355','2013-07-12','14:35:00',2.19),('3355','2013-07-12','14:40:00',2.16),('3355','2013-07-12','14:45:00',2.14),('3355','2013-07-12','14:50:00',2.14),('3355','2013-07-12','14:55:00',2.16),('3355','2013-07-12','15:00:00',2.12),('3355','2013-07-12','15:05:00',2.11),('3355','2013-07-12','15:10:00',2.13),('3355','2013-07-12','15:15:00',2.1),('3355','2013-07-12','15:20:00',2.07),('3355','2013-07-12','15:25:00',2.05),('3355','2013-07-12','15:30:00',2.02),('3355','2013-07-12','15:35:00',1.99),('3355','2013-07-12','15:40:00',2.01),('3355','2013-07-12','15:45:00',1.97),('3355','2013-07-12','15:50:00',1.94),('3355','2013-07-12','15:55:00',1.88),('3355','2013-07-12','16:00:00',1.88),('3355','2013-07-12','16:05:00',1.84),('3355','2013-07-12','16:10:00',1.82),('3355','2013-07-12','16:15:00',1.79),('3355','2013-07-12','16:20:00',1.76),('3355','2013-07-12','16:25:00',1.74),('3355','2013-07-12','16:30:00',1.69),('3355','2013-07-12','16:35:00',1.67),('3355','2013-07-12','16:40:00',1.65),('3355','2013-07-12','16:45:00',1.62),('3355','2013-07-12','16:50:00',1.58),('3355','2013-07-12','16:55:00',1.53),('3355','2013-07-12','17:00:00',1.49),('3355','2013-07-12','17:05:00',1.45),('3355','2013-07-12','17:10:00',1.41),('3355','2013-07-12','17:15:00',1.38),('3355','2013-07-12','17:20:00',1.33),('3355','2013-07-12','17:25:00',1.27),('3355','2013-07-12','17:30:00',1.24),('3355','2013-07-12','17:35:00',1.2),('3355','2013-07-12','17:40:00',1.16),('3355','2013-07-12','17:45:00',1.1),('3355','2013-07-12','17:50:00',1.05),('3355','2013-07-12','17:55:00',1.01),('3355','2013-07-11','09:00:00',1.07),('3355','2013-07-11','09:05:00',1.11),('3355','2013-07-11','09:10:00',1.13),('3355','2013-07-11','09:15:00',1.2),('3355','2013-07-11','09:20:00',1.29),('3355','2013-07-11','09:25:00',1.3),('3355','2013-07-11','09:30:00',1.27),('3355','2013-07-11','09:40:00',1.45),('3355','2013-07-11','09:45:00',1.5),('3355','2013-07-11','09:50:00',1.01),('3355','2013-07-11','10:05:00',1.24),('3355','2013-07-11','10:10:00',1.25),('3355','2013-07-11','10:15:00',1.7),('3355','2013-07-11','10:20:00',1.73),('3355','2013-07-11','10:25:00',1.62),('3355','2013-07-11','10:30:00',1.58),('3355','2013-07-11','10:50:00',1.72),('3355','2013-07-11','10:55:00',2.03),('3355','2013-07-11','11:00:00',1.91),('3355','2013-07-11','11:10:00',1.89),('3355','2013-07-11','11:15:00',1.8),('3355','2013-07-11','11:20:00',1.84),('3355','2013-07-11','11:25:00',1.83),('3355','2013-07-11','11:30:00',2.14),('3355','2013-07-11','11:35:00',2.07),('3355','2013-07-11','11:40:00',1.8),('3355','2013-07-11','11:45:00',1.93),('3355','2013-07-11','11:50:00',1.88),('3355','2013-07-11','11:55:00',1.75),('3355','2013-07-11','12:05:00',1.55),('3355','2013-07-11','12:20:00',2.42),('3355','2013-07-11','12:25:00',2.37),('3355','2013-07-11','12:30:00',2.37),('3355','2013-07-11','12:35:00',2.43),('3355','2013-07-11','12:40:00',2.38),('3355','2013-07-11','12:45:00',2.31),('3355','2013-07-11','12:50:00',1.79),('3355','2013-07-11','12:55:00',2.37),('3355','2013-07-11','13:00:00',1.87),('3355','2013-07-11','13:10:00',1.86),('3355','2013-07-11','13:15:00',2.45),('3355','2013-07-11','13:20:00',2.38),('3355','2013-07-11','13:25:00',2.37),('3355','2013-07-11','13:30:00',2.38),('3355','2013-07-11','13:35:00',2.45),('3355','2013-07-11','13:40:00',2.33),('3355','2013-07-11','13:45:00',2.31),('3355','2013-07-11','13:50:00',1.47),('3355','2013-07-11','14:00:00',1.42),('3355','2013-07-11','14:05:00',2.28),('3355','2013-07-11','14:10:00',2.19),('3355','2013-07-11','14:15:00',2.4),('3355','2013-07-11','14:20:00',2.09),('3355','2013-07-11','14:25:00',2.28),('3355','2013-07-11','14:30:00',1.83),('3355','2013-07-11','14:35:00',2.3),('3355','2013-07-11','14:40:00',2.26),('3355','2013-07-11','14:45:00',2.29),('3355','2013-07-11','14:50:00',2.2),('3355','2013-07-11','14:55:00',1.31),('3355','2013-07-11','15:00:00',2.05),('3355','2013-07-11','15:05:00',1.83),('3355','2013-07-11','15:10:00',1.24),('3355','2013-07-11','15:15:00',1.56),('3355','2013-07-11','15:20:00',1.57),('3355','2013-07-11','15:25:00',1.41),('3355','2013-07-11','15:30:00',1.72),('3355','2013-07-11','15:35:00',2.03),('3355','2013-07-11','15:40:00',1.6),('3355','2013-07-11','15:45:00',1.38),('3355','2013-07-11','15:50:00',1.59),('3355','2013-07-11','16:00:00',1.37),('3355','2013-07-11','16:05:00',1.62),('3355','2013-07-11','16:10:00',1.83),('3355','2013-07-11','16:15:00',1.67),('3355','2013-07-11','16:20:00',1.99),('3355','2013-07-11','16:25:00',1.75),('3355','2013-07-11','16:30:00',2),('3355','2013-07-11','16:35:00',1.33),('3355','2013-07-11','16:40:00',1.78),('3355','2013-07-11','16:45:00',1.38),('3355','2013-07-11','16:50:00',1.78),('3355','2013-07-11','16:55:00',1.48),('3355','2013-07-11','17:00:00',1.34),('3355','2013-07-11','17:05:00',1.62),('3355','2013-07-11','17:10:00',1.56),('3355','2013-07-11','17:15:00',1.28),('3355','2013-07-11','17:20:00',1.33),('3355','2013-07-11','17:30:00',1.26),('3355','2013-07-11','17:35:00',1.33),('3355','2013-07-11','17:45:00',1.22),('3355','2013-07-11','17:55:00',1.06),('3355','2014-05-03','08:45:00',1.08),('3355','2014-05-03','08:50:00',1.21),('3355','2014-05-03','08:55:00',1.28),('3355','2014-05-03','09:00:00',1.47),('3355','2014-05-03','09:05:00',1.49),('3355','2014-05-03','09:20:00',1.44),('3355','2014-05-03','09:25:00',1.63),('3355','2014-05-03','09:30:00',1.46),('3355','2014-05-03','09:35:00',1.16),('3355','2014-05-03','09:45:00',1.26),('3355','2014-05-03','09:55:00',1.88),('3355','2014-05-03','10:00:00',1.86),('3355','2014-05-03','10:05:00',1.88),('3355','2014-05-03','10:10:00',1.95),('3355','2014-05-03','10:15:00',1.95),('3355','2014-05-03','10:20:00',1.72),('3355','2014-05-03','10:25:00',1.04),('3355','2014-05-03','10:45:00',1.26),('3355','2014-05-03','10:55:00',1.39),('3355','2014-05-03','11:00:00',1.04),('3355','2014-05-03','11:05:00',1.93),('3355','2014-05-03','11:10:00',2.44),('3355','2014-05-03','11:20:00',1.46),('3355','2014-05-03','11:25:00',1.96),('3355','2014-05-03','11:30:00',2.32),('3355','2014-05-03','11:35:00',1.39),('3355','2014-05-03','11:40:00',1.55),('3355','2014-05-03','11:45:00',1.24),('3355','2014-05-03','11:50:00',1.18),('3355','2014-05-03','11:55:00',1.26),('3355','2014-05-03','12:00:00',1.05),('3355','2014-05-03','12:35:00',1.16),('3355','2014-05-03','12:40:00',1.02),('3355','2014-05-03','12:45:00',1.05),('3355','2014-05-03','12:50:00',1.06),('3355','2014-05-03','12:55:00',1.09),('3355','2014-05-03','13:00:00',1.09),('3355','2014-05-03','13:05:00',1.05),('3355','2014-05-03','13:10:00',1.63),('3355','2014-05-03','13:15:00',1.39),('3355','2014-05-03','13:20:00',1.53),('3355','2014-05-03','13:25:00',1.63),('3355','2014-05-03','13:30:00',1.63),('3355','2014-05-03','13:35:00',1.11),('3355','2014-05-03','14:10:00',1.07),('3355','2014-05-03','14:15:00',1.26),('3355','2014-05-03','14:20:00',1.52),('3355','2014-05-03','14:25:00',2.09),('3355','2014-05-03','14:30:00',1.06),('3355','2014-04-06','09:05:00',1.06),('3355','2014-04-06','09:10:00',1.1),('3355','2014-04-06','09:15:00',1.17),('3355','2014-04-06','09:20:00',1),('3355','2014-04-06','09:25:00',1.02),('3355','2014-04-06','09:35:00',1.22),('3355','2014-04-06','09:40:00',1.34),('3355','2014-04-06','09:45:00',1.78),('3355','2014-04-06','09:50:00',1.86),('3355','2014-04-06','09:55:00',1.78),('3355','2014-04-06','10:00:00',1.75),('3355','2014-04-06','10:05:00',1.49),('3355','2014-04-06','10:10:00',1.65),('3355','2014-04-06','10:15:00',1.41),('3355','2014-04-06','10:45:00',1.73),('3355','2014-04-06','10:50:00',1.67),('3355','2014-04-06','11:00:00',1.3),('3355','2014-04-06','11:05:00',1.03),('3355','2014-04-06','11:10:00',1.77),('3355','2014-04-06','11:15:00',1.82),('3355','2014-04-06','11:20:00',2.23),('3355','2014-04-06','11:25:00',2.22),('3355','2014-04-06','11:30:00',2.29),('3355','2014-04-06','11:35:00',2.42),('3355','2014-04-06','11:40:00',2.38),('3355','2014-04-06','11:45:00',2.33),('3355','2014-04-06','11:50:00',2.36),('3355','2014-04-06','11:55:00',2.43),('3355','2014-04-06','12:00:00',2.33),('3355','2014-04-06','12:05:00',2.31),('3355','2014-04-06','12:10:00',2.31),('3355','2014-04-06','12:15:00',2.39),('3355','2014-04-06','12:20:00',1.84),('3355','2014-04-06','12:25:00',2.08),('3355','2014-04-06','12:30:00',1.86),('3355','2014-04-06','12:35:00',1.94),('3355','2014-04-06','12:40:00',1.98),('3355','2014-04-06','12:45:00',1.66),('3355','2014-04-06','12:55:00',2.03),('3355','2014-04-06','13:00:00',2.5),('3355','2014-04-06','13:05:00',2.08),('3355','2014-04-06','13:10:00',2.69),('3355','2014-04-06','13:15:00',2.27),('3355','2014-04-06','13:30:00',2.36),('3355','2014-04-06','13:40:00',1.8),('3355','2014-04-06','13:45:00',2.59),('3355','2014-04-06','13:50:00',2.28),('3355','2014-04-06','13:55:00',2.43),('3355','2014-04-06','14:00:00',2.38),('3355','2014-04-06','14:05:00',2.36),('3355','2014-04-06','14:10:00',2.4),('3355','2014-04-06','14:15:00',2.42),('3355','2014-04-06','14:20:00',2.18),('3355','2014-04-06','14:25:00',1.41),('3355','2014-04-06','14:35:00',1.61),('3355','2014-04-06','14:40:00',2.14),('3355','2014-04-06','14:45:00',2.61),('3355','2014-04-06','14:50:00',2),('3355','2014-04-06','14:55:00',1.23),('3355','2014-04-06','15:00:00',1.39),('3355','2014-04-06','15:10:00',1.76),('3355','2014-04-06','15:15:00',1.61),('3355','2014-04-06','15:55:00',2.37),('3355','2014-04-06','16:00:00',1.61),('3355','2014-04-06','16:35:00',1.27),('3355','2014-04-06','16:40:00',1.18),('3355','2014-04-06','16:45:00',1.85),('3355','2014-04-06','16:50:00',1.76),('3355','2014-04-06','17:25:00',1.22),('3355','2014-04-06','17:30:00',1.12),('3355','2014-04-06','17:35:00',1.01),('3355','2013-07-10','08:25:00',1.1),('3355','2013-07-10','08:30:00',1.11),('3355','2013-07-10','08:35:00',1.24),('3355','2013-07-10','08:40:00',1.13),('3355','2013-07-10','08:45:00',1.1),('3355','2013-07-10','08:50:00',1.11),('3355','2013-07-10','08:55:00',1.09),('3355','2013-07-10','09:00:00',1.12),('3355','2013-07-10','09:05:00',1.18),('3355','2013-07-10','09:10:00',1.24),('3355','2013-07-10','09:15:00',1.3),('3355','2013-07-10','09:20:00',1.32),('3355','2013-07-10','09:25:00',1.34),('3355','2013-07-10','09:30:00',1.37),('3355','2013-07-10','09:35:00',1.38),('3355','2013-07-10','09:40:00',1.42),('3355','2013-07-10','09:45:00',1.45),('3355','2013-07-10','09:50:00',1.47),('3355','2013-07-10','09:55:00',1.48),('3355','2013-07-10','10:00:00',1.45),('3355','2013-07-10','10:05:00',1.56),('3355','2013-07-10','10:10:00',1.6),('3355','2013-07-10','10:15:00',1.63),('3355','2013-07-10','10:20:00',1.67),('3355','2013-07-10','10:25:00',1.68),('3355','2013-07-10','10:30:00',1.7),('3355','2013-07-10','10:35:00',1.74),('3355','2013-07-10','10:40:00',1.8),('3355','2013-07-10','10:45:00',1.82),('3355','2013-07-10','10:50:00',1.86),('3355','2013-07-10','10:55:00',1.87),('3355','2013-07-10','11:00:00',1.88),('3355','2013-07-10','11:05:00',1.89),('3355','2013-07-10','11:10:00',1.91),('3355','2013-07-10','11:15:00',1.94),('3355','2013-07-10','11:20:00',1.94),('3355','2013-07-10','11:25:00',1.92),('3355','2013-07-10','11:30:00',1.98),('3355','2013-07-10','11:35:00',1.99),('3355','2013-07-10','11:40:00',2.02),('3355','2013-07-10','11:45:00',2.04),('3355','2013-07-10','11:50:00',2.06),('3355','2013-07-10','11:55:00',2.08),('3355','2013-07-10','12:00:00',2.1),('3355','2013-07-10','12:05:00',2.14),('3355','2013-07-10','12:10:00',2.13),('3355','2013-07-10','12:15:00',2.11),('3355','2013-07-10','12:20:00',2.15),('3355','2013-07-10','12:25:00',2.16),('3355','2013-07-10','12:30:00',2.17),('3355','2013-07-10','12:35:00',2.22),('3355','2013-07-10','12:40:00',2.2),('3355','2013-07-10','12:45:00',2.19),('3355','2013-07-10','12:50:00',2.2),('3355','2013-07-10','12:55:00',2.2),('3355','2013-07-10','13:00:00',2.21),('3355','2013-07-10','13:05:00',2.22),('3355','2013-07-10','13:10:00',2.25),('3355','2013-07-10','13:15:00',2.26),('3355','2013-07-10','13:20:00',2.25),('3355','2013-07-10','13:25:00',2.25),('3355','2013-07-10','13:30:00',2.25),('3355','2013-07-10','13:35:00',2.25),('3355','2013-07-10','13:40:00',2.26),('3355','2013-07-10','13:45:00',2.27),('3355','2013-07-10','13:50:00',2.28),('3355','2013-07-10','13:55:00',2.27),('3355','2013-07-10','14:00:00',2.29),('3355','2013-07-10','14:05:00',2.29),('3355','2013-07-10','14:10:00',2.28),('3355','2013-07-10','14:15:00',2.27),('3355','2013-07-10','14:20:00',2.25),('3355','2013-07-10','14:25:00',2.24),('3355','2013-07-10','14:30:00',2.23),('3355','2013-07-10','14:35:00',2.22),('3355','2013-07-10','14:40:00',2.22),('3355','2013-07-10','14:45:00',2.21),('3355','2013-07-10','14:50:00',2.19),('3355','2013-07-10','14:55:00',2.18),('3355','2013-07-10','15:00:00',2.18),('3355','2013-07-10','15:05:00',2.16),('3355','2013-07-10','15:10:00',2.13),('3355','2013-07-10','15:15:00',2.12),('3355','2013-07-10','15:20:00',2.09),('3355','2013-07-10','15:25:00',2.07),('3355','2013-07-10','15:30:00',2.06),('3355','2013-07-10','15:35:00',2.05),('3355','2013-07-10','15:40:00',2.02),('3355','2013-07-10','15:45:00',1.98),('3355','2013-07-10','15:50:00',1.96),('3355','2013-07-10','15:55:00',1.94),('3355','2013-07-10','16:00:00',1.92),('3355','2013-07-10','16:05:00',1.89),('3355','2013-07-10','16:10:00',1.85),('3355','2013-07-10','16:15:00',1.83),('3355','2013-07-10','16:20:00',1.79),('3355','2013-07-10','16:25:00',1.76),('3355','2013-07-10','16:30:00',1.72),('3355','2013-07-10','16:35:00',1.69),('3355','2013-07-10','16:40:00',1.65),('3355','2013-07-10','16:45:00',1.62),('3355','2013-07-10','16:50:00',1.59),('3355','2013-07-10','16:55:00',1.58),('3355','2013-07-10','17:00:00',1.58),('3355','2013-07-10','17:05:00',1.45),('3355','2013-07-10','17:10:00',1.35),('3355','2013-07-10','17:35:00',1.35),('3355','2013-07-10','17:40:00',1.09),('3355','2013-07-10','17:45:00',1.16),('3355','2013-07-10','17:50:00',1.09),('3355','2013-07-10','17:55:00',1.02),('3355','2013-07-09','08:55:00',1.04),('3355','2013-07-09','09:00:00',1.08),('3355','2013-07-09','09:05:00',1.12),('3355','2013-07-09','09:10:00',1.16),('3355','2013-07-09','09:15:00',1.2),('3355','2013-07-09','09:20:00',1.24),('3355','2013-07-09','09:25:00',1.28),('3355','2013-07-09','09:30:00',1.32),('3355','2013-07-09','09:35:00',1.37),('3355','2013-07-09','09:40:00',1.4),('3355','2013-07-09','09:45:00',1.45),('3355','2013-07-09','09:50:00',1.48),('3355','2013-07-09','09:55:00',1.51),('3355','2013-07-09','10:00:00',1.53),('3355','2013-07-09','10:05:00',1.57),('3355','2013-07-09','10:10:00',1.6),('3355','2013-07-09','10:15:00',1.63),('3355','2013-07-09','10:20:00',1.66),('3355','2013-07-09','10:25:00',1.69),('3355','2013-07-09','10:30:00',1.72),('3355','2013-07-09','10:35:00',1.74),('3355','2013-07-09','10:40:00',1.76),('3355','2013-07-09','10:45:00',1.79),('3355','2013-07-09','10:50:00',1.83),('3355','2013-07-09','10:55:00',1.87),('3355','2013-07-09','11:00:00',1.9),('3355','2013-07-09','11:05:00',1.85),('3355','2013-07-09','11:10:00',1.69),('3355','2013-07-09','11:15:00',1.74),('3355','2013-07-09','11:20:00',1.69),('3355','2013-07-09','11:25:00',1.57),('3355','2013-07-09','11:35:00',1.18),('3355','2013-07-09','11:40:00',1.64),('3355','2013-07-09','11:45:00',2.07),('3355','2013-07-09','11:50:00',2.34),('3355','2013-07-09','11:55:00',2.32),('3355','2013-07-09','12:00:00',2.31),('3355','2013-07-09','12:05:00',2.28),('3355','2013-07-09','12:10:00',2.22),('3355','2013-07-09','12:15:00',2.15),('3355','2013-07-09','12:20:00',2.11),('3355','2013-07-09','12:25:00',2.11),('3355','2013-07-09','12:30:00',2.13),('3355','2013-07-09','12:35:00',2.13),('3355','2013-07-09','12:40:00',2.16),('3355','2013-07-09','12:45:00',2.17),('3355','2013-07-09','12:50:00',2.21),('3355','2013-07-09','12:55:00',2.21),('3355','2013-07-09','13:00:00',2.21),('3355','2013-07-09','13:05:00',2.21),('3355','2013-07-09','13:10:00',2.27),('3355','2013-07-09','13:15:00',2.31),('3355','2013-07-09','13:20:00',2.31),('3355','2013-07-09','13:25:00',2.26),('3355','2013-07-09','13:30:00',2.31),('3355','2013-07-09','13:35:00',2.16),('3355','2013-07-09','13:40:00',2.11),('3355','2013-07-09','13:45:00',1.81),('3355','2013-07-09','13:50:00',1.67),('3355','2013-07-09','13:55:00',1.61),('3355','2013-07-09','14:00:00',1.66),('3355','2013-07-09','14:05:00',1.62),('3355','2013-07-09','14:10:00',1.83),('3355','2013-07-09','14:15:00',1.9),('3355','2013-07-09','14:20:00',1.56),('3355','2013-07-09','14:25:00',1.21),('3355','2013-07-08','08:55:00',1.03),('3355','2013-07-08','09:00:00',1.07),('3355','2013-07-08','09:05:00',1.11),('3355','2013-07-08','09:10:00',1.14),('3355','2013-07-08','09:15:00',1.17),('3355','2013-07-08','09:20:00',1.19),('3355','2013-07-08','09:25:00',1.22),('3355','2013-07-08','09:30:00',1.29),('3355','2013-07-08','09:35:00',1.37),('3355','2013-07-08','09:40:00',1.41),('3355','2013-07-08','09:45:00',1.43),('3355','2013-07-08','09:50:00',1.44),('3355','2013-07-08','09:55:00',1.5),('3355','2013-07-08','10:00:00',1.54),('3355','2013-07-08','10:05:00',1.57),('3355','2013-07-08','10:10:00',1.59),('3355','2013-07-08','10:15:00',1.64),('3355','2013-07-08','10:20:00',1.67),('3355','2013-07-08','10:25:00',1.7),('3355','2013-07-08','10:30:00',1.74),('3355','2013-07-08','10:35:00',1.76),('3355','2013-07-08','10:40:00',1.78),('3355','2013-07-08','10:45:00',1.79),('3355','2013-07-08','10:50:00',1.81),('3355','2013-07-08','10:55:00',1.84),('3355','2013-07-08','11:00:00',1.86),('3355','2013-07-08','11:05:00',1.9),('3355','2013-07-08','11:10:00',1.93),('3355','2013-07-08','11:15:00',1.96),('3355','2013-07-08','11:20:00',1.99),('3355','2013-07-08','11:25:00',2.02),('3355','2013-07-08','11:30:00',2.06),('3355','2013-07-08','11:35:00',2.08),('3355','2013-07-08','11:40:00',1.96),('3355','2013-07-08','11:45:00',2.09),('3355','2013-07-08','11:50:00',2.11),('3355','2013-07-08','11:55:00',2.07),('3355','2013-07-08','12:00:00',2.11),('3355','2013-07-08','12:05:00',2.16),('3355','2013-07-08','12:10:00',2.19),('3355','2013-07-08','12:15:00',2.22),('3355','2013-07-08','12:20:00',2.29),('3355','2013-07-08','12:25:00',2.24),('3355','2013-07-08','12:30:00',2.09),('3355','2013-07-08','12:35:00',2.24),('3355','2013-07-08','12:40:00',2.21),('3355','2013-07-08','12:45:00',2.21),('3355','2013-07-08','12:50:00',2.22),('3355','2013-07-08','12:55:00',2.26),('3355','2013-07-08','13:00:00',2.31),('3355','2013-07-08','13:05:00',2.34),('3355','2013-07-08','13:10:00',2.45),('3355','2013-07-08','13:15:00',2.41),('3355','2013-07-08','13:20:00',1.68),('3355','2013-07-07','08:55:00',1.08),('3355','2013-07-07','09:00:00',1.1),('3355','2013-07-07','09:05:00',1.06),('3355','2013-07-07','09:10:00',1.09),('3355','2013-07-07','09:15:00',1.08),('3355','2013-07-07','09:25:00',1.11),('3355','2013-07-07','09:30:00',1.38),('3355','2013-07-07','09:35:00',1.42),('3355','2013-07-07','09:40:00',1.31),('3355','2013-07-07','09:45:00',1.58),('3355','2013-07-07','09:50:00',1.59),('3355','2013-07-07','09:55:00',1.6),('3355','2013-07-07','10:00:00',1.62),('3355','2013-07-07','10:05:00',1.56),('3355','2013-07-07','10:10:00',1.65),('3355','2013-07-07','10:15:00',1.58),('3355','2013-07-07','10:20:00',1.61),('3355','2013-07-07','10:25:00',1.49),('3355','2013-07-07','10:30:00',1.63),('3355','2013-07-07','10:35:00',1.88),('3355','2013-07-07','10:40:00',1.69),('3355','2013-07-07','10:45:00',1.84),('3355','2013-07-07','10:50:00',1.89),('3355','2013-07-07','10:55:00',1.89),('3355','2013-07-07','11:00:00',1.92),('3355','2013-07-07','11:05:00',1.96),('3355','2013-07-07','11:10:00',1.98),('3355','2013-07-07','11:15:00',1.97),('3355','2013-07-07','11:20:00',1.87),('3355','2013-07-07','11:25:00',1.68),('3355','2013-07-07','11:30:00',1.78),('3355','2013-07-07','11:35:00',1.74),('3355','2013-07-07','11:40:00',1.82),('3355','2013-07-07','11:45:00',1.37),('3355','2013-07-07','11:50:00',1.47),('3355','2013-07-07','12:00:00',1.49),('3355','2013-07-07','12:05:00',2.06),('3355','2013-07-07','12:10:00',2.11),('3355','2013-07-07','12:15:00',2.25),('3355','2013-07-07','12:20:00',2.18),('3355','2013-07-07','12:25:00',2.05),('3355','2013-07-07','12:30:00',2.07),('3355','2013-07-07','12:35:00',2.21),('3355','2013-07-07','12:40:00',2.26),('3355','2013-07-07','12:45:00',2.26),('3355','2013-07-07','12:50:00',2.2),('3355','2013-07-07','12:55:00',2.3),('3355','2013-07-07','13:00:00',2.23),('3355','2013-07-07','13:05:00',2.27),('3355','2013-07-07','13:10:00',2.29),('3355','2013-07-07','13:15:00',2.24),('3355','2013-07-07','13:20:00',2.25),('3355','2013-07-07','13:25:00',1.5),('3355','2013-07-07','13:30:00',2.21),('3355','2013-07-07','13:35:00',2.32),('3355','2013-07-07','13:40:00',2.33),('3355','2013-07-07','13:45:00',2.4),('3355','2013-07-07','13:50:00',2.31),('3355','2013-07-07','13:55:00',1.36),('3355','2013-07-07','14:00:00',1.84),('3355','2013-07-07','14:05:00',2.2),('3355','2013-07-07','14:10:00',1.07),('3355','2013-07-07','14:15:00',1.17),('3355','2013-07-06','08:50:00',1.01),('3355','2013-07-06','08:55:00',1.05),('3355','2013-07-06','09:00:00',1.1),('3355','2013-07-06','09:05:00',1.15),('3355','2013-07-06','09:10:00',1.19),('3355','2013-07-06','09:15:00',1.23),('3355','2013-07-06','09:20:00',1.27),('3355','2013-07-06','09:25:00',1.31),('3355','2013-07-06','09:30:00',1.34),('3355','2013-07-06','09:35:00',1.37),('3355','2013-07-06','09:40:00',1.41),('3355','2013-07-06','09:45:00',1.45),('3355','2013-07-06','09:50:00',1.49),('3355','2013-07-06','09:55:00',1.52),('3355','2013-07-06','10:00:00',1.56),('3355','2013-07-06','10:05:00',1.6),('3355','2013-07-06','10:10:00',1.64),('3355','2013-07-06','10:15:00',1.67),('3355','2013-07-06','10:20:00',1.7),('3355','2013-07-06','10:25:00',1.72),('3355','2013-07-06','10:30:00',1.75),('3355','2013-07-06','10:35:00',1.78),('3355','2013-07-06','10:40:00',1.81),('3355','2013-07-06','10:45:00',1.83),('3355','2013-07-06','10:50:00',1.88),('3355','2013-07-06','10:55:00',1.91),('3355','2013-07-06','11:00:00',1.92),('3355','2013-07-06','11:05:00',1.94),('3355','2013-07-06','11:10:00',1.95),('3355','2013-07-06','11:15:00',1.97),('3355','2013-07-06','11:20:00',2),('3355','2013-07-06','11:25:00',2.03),('3355','2013-07-06','11:30:00',2.01),('3355','2013-07-06','11:35:00',2.03),('3355','2013-07-06','11:40:00',2.04),('3355','2013-07-06','11:45:00',2.07),('3355','2013-07-06','11:50:00',2.09),('3355','2013-07-06','11:55:00',2.11),('3355','2013-07-06','12:00:00',2.12),('3355','2013-07-06','12:05:00',2.15),('3355','2013-07-06','12:10:00',2.17),('3355','2013-07-06','12:15:00',2.16),('3355','2013-07-06','12:20:00',2.18),('3355','2013-07-06','12:25:00',2.19),('3355','2013-07-06','12:30:00',2.22),('3355','2013-07-06','12:35:00',2.2),('3355','2013-07-06','12:40:00',2.21),('3355','2013-07-06','12:45:00',2.23),('3355','2013-07-06','12:50:00',2.22),('3355','2013-07-06','12:55:00',2.24),('3355','2013-07-06','13:00:00',2.25),('3355','2013-07-06','13:05:00',2.27),('3355','2013-07-06','13:10:00',2.28),('3355','2013-07-06','13:15:00',2.28),('3355','2013-07-06','13:20:00',2.27),('3355','2013-07-06','13:25:00',2.25),('3355','2013-07-06','13:30:00',2.28),('3355','2013-07-06','13:35:00',2.25),('3355','2013-07-06','13:40:00',2.27),('3355','2013-07-06','13:45:00',2.26),('3355','2013-07-06','13:50:00',2.24),('3355','2013-07-06','13:55:00',2.24),('3355','2013-07-06','14:00:00',2.25),('3355','2013-07-06','14:05:00',2.25),('3355','2013-07-06','14:10:00',2.24),('3355','2013-07-06','14:15:00',1.6),('3355','2013-07-06','14:20:00',2.04),('3355','2013-07-06','14:25:00',2.25),('3355','2013-07-06','14:30:00',2.21),('3355','2013-07-06','14:35:00',2.21),('3355','2013-07-06','14:40:00',2.19),('3355','2013-07-06','14:45:00',2.18),('3355','2013-07-06','14:50:00',2.08),('3355','2013-07-06','14:55:00',2.21),('3355','2013-07-06','15:00:00',2.04),('3355','2013-07-06','15:05:00',1.6),('3355','2013-07-06','15:10:00',2.2),('3355','2013-07-06','15:15:00',2.13),('3355','2013-07-06','15:20:00',2.1),('3355','2013-07-06','15:25:00',2.11),('3355','2013-07-06','15:30:00',2.1),('3355','2013-07-06','15:35:00',1.01),('3355','2013-07-05','08:50:00',1.02),('3355','2013-07-05','08:55:00',1.06),('3355','2013-07-05','09:00:00',1.1),('3355','2013-07-05','09:05:00',1.15),('3355','2013-07-05','09:10:00',1.18),('3355','2013-07-05','09:15:00',1.23),('3355','2013-07-05','09:20:00',1.27),('3355','2013-07-05','09:25:00',1.32),('3355','2013-07-05','09:30:00',1.35),('3355','2013-07-05','09:35:00',1.4),('3355','2013-07-05','09:40:00',1.43),('3355','2013-07-05','09:45:00',1.46),('3355','2013-07-05','09:50:00',1.5),('3355','2013-07-05','09:55:00',1.53),('3355','2013-07-05','10:00:00',1.56),('3355','2013-07-05','10:05:00',1.6),('3355','2013-07-05','10:10:00',1.63),('3355','2013-07-05','10:15:00',1.66),('3355','2013-07-05','10:20:00',1.69),('3355','2013-07-05','10:25:00',1.72),('3355','2013-07-05','10:30:00',1.76),('3355','2013-07-05','10:35:00',1.78),('3355','2013-07-05','10:40:00',1.79),('3355','2013-07-05','10:45:00',1.81),('3355','2013-07-05','10:50:00',1.84),('3355','2013-07-05','10:55:00',1.87),('3355','2013-07-05','11:00:00',1.89),('3355','2013-07-05','11:05:00',1.9),('3355','2013-07-05','11:10:00',1.93),('3355','2013-07-05','11:15:00',1.95),('3355','2013-07-05','11:20:00',1.95),('3355','2013-07-05','11:25:00',1.99),('3355','2013-07-05','11:30:00',2.01),('3355','2013-07-05','11:35:00',2.03),('3355','2013-07-05','11:40:00',2.04),('3355','2013-07-05','11:45:00',2.05),('3355','2013-07-05','11:50:00',2.07),('3355','2013-07-05','11:55:00',2.08),('3355','2013-07-05','12:00:00',2.09),('3355','2013-07-05','12:05:00',2.11),('3355','2013-07-05','12:10:00',2.11),('3355','2013-07-05','12:15:00',2.12),('3355','2013-07-05','12:20:00',2.16),('3355','2013-07-05','12:25:00',1.01),('3355','2013-07-05','12:30:00',2.22),('3355','2013-07-05','12:35:00',2.17),('3355','2013-07-05','12:40:00',2.12),('3355','2013-07-05','12:45:00',2.05),('3355','2013-07-05','12:50:00',2.2),('3355','2013-07-05','12:55:00',2.23),('3355','2013-07-05','13:00:00',2.22),('3355','2013-07-05','13:05:00',1.03),('3355','2013-07-05','13:10:00',2.27),('3355','2013-07-05','13:15:00',2.21),('3355','2013-07-05','13:20:00',2.04),('3355','2013-07-05','13:25:00',1.82),('3355','2013-07-05','13:30:00',2.2),('3355','2013-07-05','13:35:00',2.26),('3355','2013-07-05','13:40:00',2.22),('3355','2013-07-05','13:45:00',2.29),('3355','2013-07-05','13:50:00',2.24),('3355','2013-07-05','13:55:00',2.27),('3355','2013-07-05','14:00:00',2.29),('3355','2013-07-05','14:05:00',2.25),('3355','2013-07-05','14:10:00',2.22),('3355','2013-07-05','14:15:00',2.22),('3355','2013-07-05','14:20:00',2.19),('3355','2013-07-05','14:25:00',2.23),('3355','2013-07-05','14:30:00',2.06),('3355','2013-07-05','14:35:00',2.2),('3355','2013-07-05','14:40:00',2.19),('3355','2013-07-05','14:45:00',1.69),('3355','2013-07-05','14:50:00',2.18),('3355','2013-07-05','14:55:00',2.12),('3355','2013-07-05','15:00:00',1.88),('3355','2013-07-05','15:05:00',1.65),('3355','2013-07-05','15:10:00',2.17),('3355','2013-07-05','15:15:00',1.81),('3355','2013-07-05','15:20:00',1.88),('3355','2013-07-05','15:25:00',1.18),('3355','2013-07-05','15:30:00',1.64),('3355','2013-07-05','15:35:00',2.07),('3355','2013-07-05','15:40:00',2.01),('3355','2013-07-05','15:45:00',2.03),('3355','2013-07-05','15:50:00',1.99),('3355','2013-07-05','15:55:00',1.92),('3355','2013-07-05','16:00:00',1.89),('3355','2013-07-05','16:05:00',1.88),('3355','2013-07-05','16:10:00',1.82),('3355','2013-07-05','16:15:00',1.8),('3355','2013-07-05','16:20:00',1.78),('3355','2013-07-05','16:25:00',1.75),('3355','2013-07-05','16:30:00',1.72),('3355','2013-07-05','16:35:00',1.7),('3355','2013-07-05','16:40:00',1.65),('3355','2013-07-05','16:45:00',1.65),('3355','2013-07-05','16:50:00',1.58),('3355','2013-07-05','16:55:00',1.49),('3355','2013-07-05','17:00:00',1.32),('3355','2013-07-05','17:05:00',1.46),('3355','2013-07-05','17:10:00',1.46),('3355','2013-07-05','17:15:00',1.45),('3355','2013-07-05','17:20:00',1.42),('3355','2013-07-05','17:25:00',1.36),('3355','2013-07-05','17:30:00',1.3),('3355','2013-07-05','17:35:00',1.21),('3355','2013-07-05','17:40:00',1.15),('3355','2013-07-05','17:45:00',1.09),('3355','2013-07-05','17:50:00',1.06),('3355','2013-07-05','17:55:00',1.05),('3355','2013-07-05','18:00:00',1.02),('3355','2013-07-04','12:10:00',1.09),('3355','2013-07-04','12:15:00',1.37),('3355','2013-07-04','12:20:00',1.4),('3355','2013-07-04','12:25:00',2.11),('3355','2013-07-04','12:30:00',1.6),('3355','2013-07-04','12:35:00',1.49),('3355','2013-07-04','13:20:00',1.02),('3355','2013-07-04','13:25:00',1.47),('3355','2013-07-04','13:30:00',1.12),('3355','2013-07-04','13:35:00',1.14),('3355','2013-07-04','13:40:00',1.79),('3355','2013-07-04','13:45:00',1.19),('3355','2013-07-04','13:50:00',2.01),('3355','2013-07-04','13:55:00',1.64),('3355','2013-07-04','14:00:00',1.18),('3355','2013-07-04','14:05:00',1.13),('3355','2013-07-04','14:10:00',1.13),('3355','2013-07-04','14:15:00',1.13),('3355','2013-07-04','14:20:00',1.35),('3355','2013-07-04','14:35:00',1.06),('3355','2013-07-04','14:40:00',1.73),('3355','2013-07-04','14:45:00',2.38),('3355','2013-07-04','14:50:00',1.65),('3355','2013-07-04','14:55:00',1.45),('3355','2013-07-04','15:00:00',2.31),('3355','2013-07-04','15:05:00',2.02),('3355','2013-07-04','15:10:00',1.91),('3355','2013-07-04','15:15:00',2.4),('3355','2013-07-04','15:20:00',2.3),('3355','2013-07-04','15:25:00',2.24),('3355','2013-07-04','15:30:00',1.39),('3355','2013-07-04','15:35:00',1.63),('3355','2013-07-04','15:40:00',1.47),('3355','2013-07-04','15:45:00',1.68),('3355','2013-07-04','15:50:00',1.41),('3355','2013-07-04','15:55:00',1.21),('3355','2013-07-04','16:00:00',1.26),('3355','2013-07-04','16:05:00',1.26),('3355','2013-07-04','16:10:00',1.1),('3355','2013-07-04','16:25:00',1.04),('3355','2013-07-04','16:30:00',1.09),('3355','2013-07-04','16:35:00',1.13),('3355','2013-07-04','17:15:00',1.46),('3355','2013-07-04','17:20:00',1.39),('3355','2013-07-04','17:25:00',1.37),('3355','2013-07-04','17:30:00',1.23),('3355','2013-07-04','17:35:00',1.32),('3355','2013-07-04','17:40:00',1.35),('3355','2013-07-04','17:45:00',1.28),('3355','2013-07-04','17:50:00',1.24),('3355','2013-07-04','17:55:00',1.22),('3355','2013-07-04','18:00:00',1.18),('3355','2013-07-04','18:05:00',1.15),('3355','2013-07-04','18:10:00',1.11),('3355','2013-07-04','18:15:00',1.03),('3355','2013-07-03','08:45:00',1.02),('3355','2013-07-03','08:50:00',1.06),('3355','2013-07-03','08:55:00',1.09),('3355','2013-07-03','09:00:00',1.14),('3355','2013-07-03','09:05:00',1.18),('3355','2013-07-03','09:10:00',1.22),('3355','2013-07-03','09:15:00',1.26),('3355','2013-07-03','09:20:00',1.31),('3355','2013-07-03','09:25:00',1.34),('3355','2013-07-03','09:30:00',1.36),('3355','2013-07-03','09:35:00',1.41),('3355','2013-07-03','09:40:00',1.46),('3355','2013-07-03','09:45:00',1.49),('3355','2013-07-03','09:50:00',1.51),('3355','2013-07-03','09:55:00',1.55),('3355','2013-07-03','10:00:00',1.6),('3355','2013-07-03','10:05:00',1.61),('3355','2013-07-03','10:10:00',1.64),('3355','2013-07-03','10:15:00',1.66),('3355','2013-07-03','10:20:00',1.69),('3355','2013-07-03','10:25:00',1.75),('3355','2013-07-03','10:30:00',1.76),('3355','2013-07-03','10:35:00',1.76),('3355','2013-07-03','10:40:00',1.81),('3355','2013-07-03','10:45:00',1.84),('3355','2013-07-03','10:50:00',1.87),('3355','2013-07-03','10:55:00',1.88),('3355','2013-07-03','11:00:00',1.9),('3355','2013-07-03','11:05:00',1.93),('3355','2013-07-03','11:10:00',1.93),('3355','2013-07-03','11:15:00',1.99),('3355','2013-07-03','11:20:00',2.03),('3355','2013-07-03','11:25:00',2.06),('3355','2013-07-03','11:30:00',2.07),('3355','2013-07-03','11:35:00',2.05),('3355','2013-07-03','11:40:00',2.05),('3355','2013-07-03','11:45:00',2.08),('3355','2013-07-03','11:50:00',2.16),('3355','2013-07-03','11:55:00',2.13),('3355','2013-07-03','12:00:00',2.14),('3355','2013-07-03','12:05:00',2.17),('3355','2013-07-03','12:10:00',2.2),('3355','2013-07-03','12:15:00',2.22),('3355','2013-07-03','12:20:00',2.2),('3355','2013-07-03','12:25:00',2.22),('3355','2013-07-03','12:30:00',2.21),('3355','2013-07-03','12:35:00',2.25),('3355','2013-07-03','12:40:00',2.26),('3355','2013-07-03','12:45:00',2.28),('3355','2013-07-03','12:50:00',2.29),('3355','2013-07-03','12:55:00',2.29),('3355','2013-07-03','13:00:00',2.3),('3355','2013-07-03','13:05:00',2.32),('3355','2013-07-03','13:10:00',2.32),('3355','2013-07-03','13:15:00',2.33),('3355','2013-07-03','13:20:00',2.33),('3355','2013-07-03','13:25:00',2.3),('3355','2013-07-03','13:30:00',2.31),('3355','2013-07-03','13:35:00',2.32),('3355','2013-07-03','13:40:00',2.31),('3355','2013-07-03','13:45:00',2.31),('3355','2013-07-03','13:50:00',2.31),('3355','2013-07-03','13:55:00',2.29),('3355','2013-07-03','14:00:00',2.29),('3355','2013-07-03','14:05:00',2.3),('3355','2013-07-03','14:10:00',2.3),('3355','2013-07-03','14:15:00',2.29),('3355','2013-07-03','14:20:00',2.28),('3355','2013-07-03','14:25:00',2.28),('3355','2013-07-03','14:30:00',2.29),('3355','2013-07-03','14:35:00',2.26),('3355','2013-07-03','14:40:00',2.26),('3355','2013-07-03','14:45:00',2.25),('3355','2013-07-03','14:50:00',2.24),('3355','2013-07-03','14:55:00',2.23),('3355','2013-07-03','15:00:00',2.21),('3355','2013-07-03','15:05:00',2.2),('3355','2013-07-03','15:10:00',2.18),('3355','2013-07-03','15:15:00',2.17),('3355','2013-07-03','15:20:00',2.15),('3355','2013-07-03','15:25:00',2.13),('3355','2013-07-03','15:30:00',2.11),('3355','2013-07-03','15:35:00',2.08),('3355','2013-07-03','15:40:00',2.07),('3355','2013-07-03','15:45:00',2.03),('3355','2013-07-03','15:50:00',2.02),('3355','2013-07-03','15:55:00',1.99),('3355','2013-07-03','16:00:00',1.95),('3355','2013-07-03','16:05:00',1.94),('3355','2013-07-03','16:10:00',1.92),('3355','2013-07-03','16:15:00',1.88),('3355','2013-07-03','16:20:00',1.85),('3355','2013-07-03','16:25:00',1.82),('3355','2013-07-03','16:30:00',1.79),('3355','2013-07-03','16:35:00',1.77),('3355','2013-07-03','16:40:00',1.73),('3355','2013-07-03','16:45:00',1.7),('3355','2013-07-03','16:50:00',1.65),('3355','2013-07-03','16:55:00',1.62),('3355','2013-07-03','17:00:00',1.58),('3355','2013-07-03','17:05:00',1.55),('3355','2013-07-03','17:10:00',1.51),('3355','2013-07-03','17:15:00',1.47),('3355','2013-07-03','17:20:00',1.43),('3355','2013-07-03','17:25:00',1.39),('3355','2013-07-03','17:30:00',1.35),('3355','2013-07-03','17:35:00',1.31),('3355','2013-07-03','17:40:00',1.27),('3355','2013-07-03','17:45:00',1.22),('3355','2013-07-03','17:50:00',1.18),('3355','2013-07-03','17:55:00',1.13),('3355','2013-07-03','18:00:00',1.08),('3355','2013-07-03','18:05:00',1.02),('3355','2013-07-02','08:45:00',1),('3355','2013-07-02','08:50:00',1.05),('3355','2013-07-02','08:55:00',1.08),('3355','2013-07-02','09:00:00',1.12),('3355','2013-07-02','09:05:00',1.18),('3355','2013-07-02','09:10:00',1.22),('3355','2013-07-02','09:15:00',1.26),('3355','2013-07-02','09:20:00',1.3),('3355','2013-07-02','09:25:00',1.34),('3355','2013-07-02','09:30:00',1.37),('3355','2013-07-02','09:35:00',1.41),('3355','2013-07-02','09:40:00',1.45),('3355','2013-07-02','09:45:00',1.49),('3355','2013-07-02','09:50:00',1.51),('3355','2013-07-02','09:55:00',1.55),('3355','2013-07-02','10:00:00',1.59),('3355','2013-07-02','10:05:00',1.61),('3355','2013-07-02','10:10:00',1.63),('3355','2013-07-02','10:15:00',1.66),('3355','2013-07-02','10:20:00',1.69),('3355','2013-07-02','10:25:00',1.73),('3355','2013-07-02','10:30:00',1.77),('3355','2013-07-02','10:35:00',1.79),('3355','2013-07-02','10:40:00',1.81),('3355','2013-07-02','10:45:00',1.83),('3355','2013-07-02','10:50:00',1.84),('3355','2013-07-02','10:55:00',1.86),('3355','2013-07-02','11:00:00',1.87),('3355','2013-07-02','11:05:00',1.88),('3355','2013-07-02','11:10:00',1.92),('3355','2013-07-02','11:15:00',1.94),('3355','2013-07-02','11:20:00',1.95),('3355','2013-07-02','11:25:00',1.97),('3355','2013-07-02','11:30:00',2.02),('3355','2013-07-02','11:35:00',2.05),('3355','2013-07-02','11:40:00',2.04),('3355','2013-07-02','11:45:00',2.05),('3355','2013-07-02','11:50:00',2.07),('3355','2013-07-02','11:55:00',2.1),('3355','2013-07-02','12:00:00',2.08),('3355','2013-07-02','12:05:00',2.06),('3355','2013-07-02','12:10:00',2.1),('3355','2013-07-02','12:15:00',2.13),('3355','2013-07-02','12:20:00',2.13),('3355','2013-07-02','12:25:00',2.14),('3355','2013-07-02','12:30:00',2.16),('3355','2013-07-02','12:35:00',2.19),('3355','2013-07-02','12:40:00',2.22),('3355','2013-07-02','12:45:00',2.26),('3355','2013-07-02','12:50:00',2.27),('3355','2013-07-02','12:55:00',1.84),('3355','2013-07-02','13:00:00',1.24),('3355','2013-07-02','13:05:00',1.93),('3355','2013-07-02','13:10:00',1.77),('3355','2013-07-02','13:15:00',2.35),('3355','2013-07-02','13:20:00',2.36),('3355','2013-07-02','13:25:00',2.37),('3355','2013-07-02','13:30:00',2.32),('3355','2013-07-02','13:35:00',2.25),('3355','2013-07-02','13:40:00',2.34),('3355','2013-07-02','13:45:00',2.27),('3355','2013-07-02','13:50:00',2.16),('3355','2013-07-02','13:55:00',2.18),('3355','2013-07-02','14:00:00',2.23),('3355','2013-07-02','14:05:00',2.22),('3355','2013-07-02','14:10:00',2.22),('3355','2013-07-02','14:15:00',2.21),('3355','2013-07-02','14:20:00',2.21),('3355','2013-07-02','14:25:00',2.21),('3355','2013-07-02','14:30:00',2.2),('3355','2013-07-02','14:35:00',2.19),('3355','2013-07-02','14:40:00',2.18),('3355','2013-07-02','14:45:00',2.16),('3355','2013-07-02','14:50:00',2.16),('3355','2013-07-02','14:55:00',2.13),('3355','2013-07-02','15:00:00',2.12),('3355','2013-07-02','15:05:00',2.13),('3355','2013-07-02','15:10:00',2.12),('3355','2013-07-02','15:15:00',2.1),('3355','2013-07-02','15:20:00',2.09),('3355','2013-07-02','15:25:00',2.08),('3355','2013-07-02','15:30:00',2.04),('3355','2013-07-02','15:35:00',2.04),('3355','2013-07-02','15:40:00',2.03),('3355','2013-07-02','15:45:00',1.98),('3355','2013-07-02','15:50:00',1.96),('3355','2013-07-02','15:55:00',1.94),('3355','2013-07-02','16:00:00',1.92),('3355','2013-07-02','16:05:00',1.9),('3355','2013-07-02','16:10:00',1.86),('3355','2013-07-02','16:15:00',1.84),('3355','2013-07-02','16:20:00',1.81),('3355','2013-07-02','16:25:00',1.77),('3355','2013-07-02','16:30:00',1.74),('3355','2013-07-02','16:35:00',1.7),('3355','2013-07-02','16:40:00',1.67),('3355','2013-07-02','16:45:00',1.63),('3355','2013-07-02','16:50:00',1.59),('3355','2013-07-02','16:55:00',1.55),('3355','2013-07-02','17:00:00',1.54),('3355','2013-07-02','17:05:00',1.5),('3355','2013-07-02','17:10:00',1.45),('3355','2013-07-02','17:15:00',1.42),('3355','2013-07-02','17:20:00',1.37),('3355','2013-07-02','17:25:00',1.33),('3355','2013-07-02','17:30:00',1.28),('3355','2013-07-02','17:35:00',1.25),('3355','2013-07-02','17:40:00',1.2),('3355','2013-07-02','17:45:00',1.16),('3355','2013-07-02','17:50:00',1.11),('3355','2013-07-02','17:55:00',1.06),('3355','2013-07-02','18:00:00',1.01),('3355','2013-07-01','08:45:00',1.03),('3355','2013-07-01','08:50:00',1.07),('3355','2013-07-01','08:55:00',1.12),('3355','2013-07-01','09:00:00',1.16),('3355','2013-07-01','09:05:00',1.2),('3355','2013-07-01','09:10:00',1.25),('3355','2013-07-01','09:15:00',1.3),('3355','2013-07-01','09:20:00',1.34),('3355','2013-07-01','09:25:00',1.37),('3355','2013-07-01','09:30:00',1.42),('3355','2013-07-01','09:35:00',1.46),('3355','2013-07-01','09:40:00',1.49),('3355','2013-07-01','09:45:00',1.53),('3355','2013-07-01','09:50:00',1.57),('3355','2013-07-01','09:55:00',1.6),('3355','2013-07-01','10:00:00',1.62),('3355','2013-07-01','10:05:00',1.65),('3355','2013-07-01','10:10:00',1.69),('3355','2013-07-01','10:15:00',1.72),('3355','2013-07-01','10:20:00',1.76),('3355','2013-07-01','10:25:00',1.79),('3355','2013-07-01','10:30:00',1.82),('3355','2013-07-01','10:35:00',1.85),('3355','2013-07-01','10:40:00',1.89),('3355','2013-07-01','10:45:00',1.92),('3355','2013-07-01','10:50:00',1.93),('3355','2013-07-01','10:55:00',1.95),('3355','2013-07-01','11:00:00',1.97),('3355','2013-07-01','11:05:00',2.01),('3355','2013-07-01','11:10:00',2.04),('3355','2013-07-01','11:15:00',2.06),('3355','2013-07-01','11:20:00',2.06),('3355','2013-07-01','11:25:00',2.08),('3355','2013-07-01','11:30:00',2.11),('3355','2013-07-01','11:35:00',2.13),('3355','2013-07-01','11:40:00',2.14),('3355','2013-07-01','11:45:00',2.15),('3355','2013-07-01','11:50:00',2.17),('3355','2013-07-01','11:55:00',2.18),('3355','2013-07-01','12:00:00',2.19),('3355','2013-07-01','12:05:00',2.19),('3355','2013-07-01','12:10:00',2.18),('3355','2013-07-01','12:15:00',2.19),('3355','2013-07-01','12:20:00',2.21),('3355','2013-07-01','12:25:00',2.22),('3355','2013-07-01','12:30:00',2.22),('3355','2013-07-01','12:35:00',2.24),('3355','2013-07-01','12:40:00',2.25),('3355','2013-07-01','12:45:00',2.26),('3355','2013-07-01','12:50:00',2.25),('3355','2013-07-01','12:55:00',2.26),('3355','2013-07-01','13:00:00',2.27),('3355','2013-07-01','13:05:00',2.28),('3355','2013-07-01','13:10:00',2.29),('3355','2013-07-01','13:15:00',2.27),('3355','2013-07-01','13:20:00',2.27),('3355','2013-07-01','13:25:00',2.29),('3355','2013-07-01','13:30:00',2.29),('3355','2013-07-01','13:35:00',2.28),('3355','2013-07-01','13:40:00',2.27),('3355','2013-07-01','13:45:00',2.23),('3355','2013-07-01','13:50:00',2.23),('3355','2013-07-01','13:55:00',2.26),('3355','2013-07-01','14:00:00',2.25),('3355','2013-07-01','14:05:00',2.28),('3355','2013-07-01','14:10:00',2.27),('3355','2013-07-01','14:15:00',2.28),('3355','2013-07-01','14:20:00',2.25),('3355','2013-07-01','14:25:00',2.23),('3355','2013-07-01','14:30:00',2.2),('3355','2013-07-01','14:35:00',2.22),('3355','2013-07-01','14:40:00',2.21),('3355','2013-07-01','14:45:00',2.2),('3355','2013-07-01','14:50:00',2.16),('3355','2013-07-01','14:55:00',2.15),('3355','2013-07-01','15:00:00',2.14),('3355','2013-07-01','15:05:00',2.1),('3355','2013-07-01','15:10:00',2.1),('3355','2013-07-01','15:15:00',2.09),('3355','2013-07-01','15:20:00',2.08),('3355','2013-07-01','15:25:00',2.05),('3355','2013-07-01','15:30:00',2.03),('3355','2013-07-01','15:35:00',1.99),('3355','2013-07-01','15:40:00',1.97),('3355','2013-07-01','15:45:00',1.97),('3355','2013-07-01','15:50:00',1.94),('3355','2013-07-01','15:55:00',1.92),('3355','2013-07-01','16:00:00',1.88),('3355','2013-07-01','16:05:00',1.87),('3355','2013-07-01','16:10:00',1.84),('3355','2013-07-01','16:15:00',1.8),('3355','2013-07-01','16:20:00',1.76),('3355','2013-07-01','16:25:00',1.72),('3355','2013-07-01','16:30:00',1.69),('3355','2013-07-01','16:35:00',1.67),('3355','2013-07-01','16:40:00',1.64),('3355','2013-07-01','16:45:00',1.6),('3355','2013-07-01','16:50:00',1.58),('3355','2013-07-01','16:55:00',1.55),('3355','2013-07-01','17:00:00',1.52),('3355','2013-07-01','17:05:00',1.49),('3355','2013-07-01','17:10:00',1.45),('3355','2013-07-01','17:15:00',1.41),('3355','2013-07-01','17:20:00',1.36),('3355','2013-07-01','17:25:00',1.31),('3355','2013-07-01','17:30:00',1.27),('3355','2013-07-01','17:35:00',1.22),('3355','2013-07-01','17:40:00',1.18),('3355','2013-07-01','17:45:00',1.15),('3355','2013-07-01','17:50:00',1.11),('3355','2013-07-01','17:55:00',1.07),('3355','2014-04-05','09:25:00',1.37),('3355','2014-04-05','09:30:00',1.76),('3355','2014-04-05','09:35:00',1.69),('3355','2014-04-05','09:40:00',1.64),('3355','2014-04-05','09:55:00',1.24),('3355','2014-04-05','10:00:00',1.22),('3355','2014-04-05','10:05:00',1.3),('3355','2014-04-05','10:10:00',1.12),('3355','2014-04-05','10:20:00',1.17),('3355','2014-04-05','10:25:00',1.42),('3355','2014-04-05','10:30:00',1.44),('3355','2014-04-05','10:35:00',1.72),('3355','2014-04-05','10:40:00',1.78),('3355','2014-04-05','10:45:00',1.56),('3355','2014-04-05','10:50:00',1.33),('3355','2014-04-05','10:55:00',1.64),('3355','2014-04-05','11:00:00',1.93),('3355','2014-04-05','11:05:00',2.08),('3355','2014-04-05','11:10:00',2.14),('3355','2014-04-05','11:15:00',2.26),('3355','2014-04-05','11:20:00',2.18),('3355','2014-04-05','11:25:00',1.33),('3355','2014-04-05','11:30:00',1.11),('3355','2014-04-05','11:35:00',1.62),('3355','2014-04-05','11:40:00',2.07),('3355','2014-04-05','11:45:00',2.29),('3355','2014-04-05','11:50:00',2.42),('3355','2014-04-05','11:55:00',2.18),('3355','2014-04-05','12:00:00',1.6),('3355','2014-04-05','12:05:00',1.66),('3355','2014-04-05','12:10:00',1.87),('3355','2014-04-05','12:15:00',1.96),('3355','2014-04-05','12:20:00',1.82),('3355','2014-04-05','12:25:00',1.38),('3355','2014-04-05','12:30:00',1.52),('3355','2014-04-05','12:35:00',1.63),('3355','2014-04-05','12:40:00',2.47),('3355','2014-04-05','12:45:00',2.73),('3355','2014-04-05','12:50:00',2.58),('3355','2014-04-05','12:55:00',1.99),('3355','2014-04-05','13:00:00',2.23),('3355','2014-04-05','13:05:00',2.02),('3355','2014-04-05','13:10:00',2.21),('3355','2014-04-05','13:15:00',1.16),('3355','2014-04-05','13:20:00',2.2),('3355','2014-04-05','13:25:00',2.17),('3355','2014-04-05','13:30:00',2.23),('3355','2014-04-05','13:35:00',2.66),('3355','2014-04-05','13:40:00',1.89),('3355','2014-04-05','13:45:00',1.14),('3355','2014-04-05','13:50:00',2),('3355','2014-04-05','13:55:00',2.28),('3355','2014-04-05','14:00:00',1.74),('3355','2014-04-05','14:05:00',2.81),('3355','2014-04-05','14:10:00',1.16),('3355','2014-04-05','14:25:00',1.37),('3355','2014-04-05','14:55:00',2.31),('3355','2014-04-05','15:00:00',1.38),('3355','2014-04-05','15:05:00',2.15),('3355','2014-04-05','15:15:00',1.51),('3355','2014-04-05','15:20:00',2.45),('3355','2014-04-05','15:25:00',1.66),('3355','2014-04-05','15:40:00',1.86),('3355','2014-04-05','16:15:00',1.74),('3355','2014-04-05','16:20:00',1.88),('3355','2014-04-05','16:25:00',1.79),('3355','2014-04-05','16:30:00',1.21),('3355','2014-04-05','16:35:00',1.61),('3355','2014-04-05','16:45:00',1.27),('3355','2014-04-05','16:55:00',1.11),('3355','2014-04-05','17:00:00',1.31),('3355','2014-04-05','17:05:00',1.26),('3355','2014-04-05','17:10:00',1.09),('3355','2013-06-30','08:40:00',1.02),('3355','2013-06-30','08:45:00',1.07),('3355','2013-06-30','08:50:00',1.12),('3355','2013-06-30','08:55:00',1.16),('3355','2013-06-30','09:00:00',1.2),('3355','2013-06-30','09:05:00',1.25),('3355','2013-06-30','09:10:00',1.29),('3355','2013-06-30','09:15:00',1.34),('3355','2013-06-30','09:20:00',1.37),('3355','2013-06-30','09:25:00',1.41),('3355','2013-06-30','09:30:00',1.46),('3355','2013-06-30','09:35:00',1.5),('3355','2013-06-30','09:40:00',1.53),('3355','2013-06-30','09:45:00',1.58),('3355','2013-06-30','09:50:00',1.61),('3355','2013-06-30','09:55:00',1.64),('3355','2013-06-30','10:00:00',1.67),('3355','2013-06-30','10:05:00',1.71),('3355','2013-06-30','10:10:00',1.73),('3355','2013-06-30','10:15:00',1.76),('3355','2013-06-30','10:20:00',1.8),('3355','2013-06-30','10:25:00',1.83),('3355','2013-06-30','10:30:00',1.86),('3355','2013-06-30','10:35:00',1.89),('3355','2013-06-30','10:40:00',1.91),('3355','2013-06-30','10:45:00',1.94),('3355','2013-06-30','10:50:00',1.96),('3355','2013-06-30','10:55:00',1.98),('3355','2013-06-30','11:00:00',2.01),('3355','2013-06-30','11:05:00',2.03),('3355','2013-06-30','11:10:00',2.05),('3355','2013-06-30','11:15:00',2.05),('3355','2013-06-30','11:20:00',2.06),('3355','2013-06-30','11:25:00',2.09),('3355','2013-06-30','11:30:00',2.12),('3355','2013-06-30','11:35:00',2.13),('3355','2013-06-30','11:40:00',2.14),('3355','2013-06-30','11:45:00',2.16),('3355','2013-06-30','11:50:00',2.18),('3355','2013-06-30','11:55:00',2.2),('3355','2013-06-30','12:00:00',2.21),('3355','2013-06-30','12:05:00',2.22),('3355','2013-06-30','12:10:00',2.23),('3355','2013-06-30','12:15:00',2.24),('3355','2013-06-30','12:20:00',2.25),('3355','2013-06-30','12:25:00',2.26),('3355','2013-06-30','12:30:00',2.28),('3355','2013-06-30','12:35:00',2.27),('3355','2013-06-30','12:40:00',2.28),('3355','2013-06-30','12:45:00',2.31),('3355','2013-06-30','12:50:00',2.32),('3355','2013-06-30','12:55:00',2.32),('3355','2013-06-30','13:00:00',2.3),('3355','2013-06-30','13:05:00',2.33),('3355','2013-06-30','13:10:00',2.34),('3355','2013-06-30','13:15:00',2.32),('3355','2013-06-30','13:20:00',2.31),('3355','2013-06-30','13:25:00',2.33),('3355','2013-06-30','13:30:00',2.33),('3355','2013-06-30','13:35:00',2.3),('3355','2013-06-30','13:40:00',2.31),('3355','2013-06-30','13:45:00',2.33),('3355','2013-06-30','13:50:00',2.34),('3355','2013-06-30','13:55:00',2.3),('3355','2013-06-30','14:00:00',2.24),('3355','2013-06-30','14:05:00',2.31),('3355','2013-06-30','14:10:00',2.29),('3355','2013-06-30','14:15:00',2.26),('3355','2013-06-30','14:20:00',2.25),('3355','2013-06-30','14:25:00',2.24),('3355','2013-06-30','14:30:00',2.23),('3355','2013-06-30','14:35:00',2.23),('3355','2013-06-30','14:40:00',2.22),('3355','2013-06-30','14:45:00',2.22),('3355','2013-06-30','14:50:00',2.21),('3355','2013-06-30','14:55:00',2.2),('3355','2013-06-30','15:00:00',2.19),('3355','2013-06-30','15:05:00',2.15),('3355','2013-06-30','15:10:00',2.15),('3355','2013-06-30','15:15:00',2.14),('3355','2013-06-30','15:20:00',2.13),('3355','2013-06-30','15:25:00',2.1),('3355','2013-06-30','15:30:00',2.08),('3355','2013-06-30','15:35:00',2.08),('3355','2013-06-30','15:40:00',2.06),('3355','2013-06-30','15:45:00',2.04),('3355','2013-06-30','15:50:00',2.02),('3355','2013-06-30','15:55:00',1.98),('3355','2013-06-30','16:00:00',1.95),('3355','2013-06-30','16:05:00',1.93),('3355','2013-06-30','16:10:00',1.92),('3355','2013-06-30','16:15:00',1.91),('3355','2013-06-30','16:20:00',1.92),('3355','2013-06-30','16:25:00',1.94),('3355','2013-06-30','16:30:00',1.94),('3355','2013-06-30','16:35:00',1.66),('3355','2013-06-30','16:40:00',1.68),('3355','2013-06-30','16:45:00',1.68),('3355','2013-06-30','16:50:00',1.65),('3355','2013-06-30','16:55:00',1.59),('3355','2013-06-30','17:00:00',1.54),('3355','2013-06-30','17:05:00',1.51),('3355','2013-06-30','17:10:00',1.48),('3355','2013-06-30','17:15:00',1.43),('3355','2013-06-30','17:20:00',1.39),('3355','2013-06-30','17:25:00',1.33),('3355','2013-06-30','17:30:00',1.27),('3355','2013-06-30','17:35:00',1.22),('3355','2013-06-30','17:40:00',1.2),('3355','2013-06-30','17:45:00',1.15),('3355','2013-06-30','17:50:00',1.11),('3355','2013-06-30','17:55:00',1.06),('3355','2013-06-30','18:00:00',1.01),('3355','2013-06-29','08:35:00',1.02),('3355','2013-06-29','08:50:00',1.12),('3355','2013-06-29','08:55:00',1.15),('3355','2013-06-29','09:00:00',1.18),('3355','2013-06-29','09:05:00',1.22),('3355','2013-06-29','09:10:00',1.27),('3355','2013-06-29','09:15:00',1.31),('3355','2013-06-29','09:20:00',1.35),('3355','2013-06-29','09:25:00',1.39),('3355','2013-06-29','09:30:00',1.4),('3355','2013-06-29','09:35:00',1.47),('3355','2013-06-29','09:40:00',1.51),('3355','2013-06-29','09:45:00',1.54),('3355','2013-06-29','09:50:00',1.58),('3355','2013-06-29','09:55:00',1.62),('3355','2013-06-29','10:00:00',1.65),('3355','2013-06-29','10:05:00',1.68),('3355','2013-06-29','10:10:00',1.72),('3355','2013-06-29','10:15:00',1.75),('3355','2013-06-29','10:20:00',1.77),('3355','2013-06-29','10:25:00',1.81),('3355','2013-06-29','10:30:00',1.85),('3355','2013-06-29','10:35:00',1.87),('3355','2013-06-29','10:40:00',1.9),('3355','2013-06-29','10:45:00',1.95),('3355','2013-06-29','10:50:00',1.97),('3355','2013-06-29','10:55:00',1.98),('3355','2013-06-29','11:00:00',2.02),('3355','2013-06-29','11:05:00',2.06),('3355','2013-06-29','11:10:00',2.11),('3355','2013-06-29','11:15:00',2.15),('3355','2013-06-29','11:20:00',1.57),('3355','2013-06-29','11:25:00',2.1),('3355','2013-06-29','11:30:00',2.33),('3355','2013-06-29','11:35:00',2.3),('3355','2013-06-29','11:40:00',2.41),('3355','2013-06-29','11:55:00',2.54),('3355','2013-06-29','12:00:00',1.91),('3355','2013-06-29','12:05:00',2.33),('3355','2013-06-29','12:10:00',2.38),('3355','2013-06-29','12:15:00',2.41),('3355','2013-06-29','12:25:00',2.23),('3355','2013-06-29','12:30:00',2.44),('3355','2013-06-29','12:35:00',2.43),('3355','2013-06-29','12:40:00',2.43),('3355','2013-06-29','12:45:00',2.52),('3355','2013-06-29','12:50:00',1.74),('3355','2013-06-29','12:55:00',1.3),('3355','2013-06-29','13:00:00',1.86),('3355','2013-06-29','13:05:00',1.37),('3355','2013-06-29','13:10:00',2.29),('3355','2013-06-29','13:15:00',2.65),('3355','2013-06-29','13:20:00',1.68),('3355','2013-06-29','13:25:00',2.66),('3355','2013-06-29','13:30:00',1.24),('3355','2013-06-29','13:45:00',1.16),('3355','2013-06-29','13:50:00',2.24),('3355','2013-06-29','13:55:00',1.32),('3355','2013-06-29','14:00:00',2.54),('3355','2013-06-29','14:05:00',1.85),('3355','2013-06-29','14:10:00',2.17),('3355','2013-06-29','14:15:00',2.68),('3355','2013-06-29','14:20:00',2.69),('3355','2013-06-29','14:25:00',1.51),('3355','2013-06-29','14:30:00',2.71),('3355','2013-06-29','14:35:00',2.52),('3355','2013-06-29','14:40:00',2.51),('3355','2013-06-29','14:45:00',2.57),('3355','2013-06-29','14:50:00',2.37),('3355','2013-06-29','15:00:00',1.16),('3355','2013-06-29','15:05:00',1.54),('3355','2013-06-29','16:50:00',1.43),('3355','2013-06-29','17:30:00',1.5),('3355','2013-06-29','17:35:00',1.47),('3355','2013-06-29','17:45:00',1.14),('3355','2013-06-29','17:50:00',1.2),('3355','2013-06-29','17:55:00',1.13),('3355','2013-06-29','18:00:00',1.06),('3355','2013-06-29','18:05:00',1.02),('3355','2013-06-28','08:45:00',1.02),('3355','2013-06-28','08:50:00',1.08),('3355','2013-06-28','08:55:00',1.12),('3355','2013-06-28','09:00:00',1.15),('3355','2013-06-28','09:05:00',1.22),('3355','2013-06-28','09:10:00',1.34),('3355','2013-06-28','09:35:00',1.58),('3355','2013-06-28','09:40:00',1.41),('3355','2013-06-28','09:45:00',1.03),('3355','2013-06-28','09:55:00',1.82),('3355','2013-06-28','10:00:00',1.77),('3355','2013-06-28','10:05:00',1.67),('3355','2013-06-28','10:10:00',1.49),('3355','2013-06-28','10:15:00',1.64),('3355','2013-06-28','10:20:00',2.09),('3355','2013-06-28','10:35:00',1.7),('3355','2013-06-28','10:40:00',2.14),('3355','2013-06-28','10:50:00',2.28),('3355','2013-06-28','11:00:00',1),('3355','2013-06-28','11:05:00',2.1),('3355','2013-06-28','11:10:00',1.6),('3355','2013-06-28','11:25:00',1.45),('3355','2013-06-28','11:30:00',1.72),('3355','2013-06-28','11:35:00',1.92),('3355','2013-06-28','11:40:00',1.09),('3355','2013-06-28','11:45:00',1.99),('3355','2013-06-28','11:50:00',2.38),('3355','2013-06-28','11:55:00',2.34),('3355','2013-06-28','12:00:00',1.97),('3355','2013-06-28','12:05:00',2.37),('3355','2013-06-28','12:10:00',2.02),('3355','2013-06-28','12:15:00',2.48),('3355','2013-06-28','12:20:00',2.4),('3355','2013-06-28','12:25:00',2.26),('3355','2013-06-28','12:30:00',2.02),('3355','2013-06-28','12:35:00',2.18),('3355','2013-06-28','12:40:00',2.51),('3355','2013-06-28','12:45:00',2.38),('3355','2013-06-28','12:50:00',1.35),('3355','2013-06-28','12:55:00',2.41),('3355','2013-06-28','13:00:00',1.5),('3355','2013-06-28','13:05:00',2.21),('3355','2013-06-28','13:10:00',2.26),('3355','2013-06-28','13:15:00',2.46),('3355','2013-06-28','13:20:00',2.35),('3355','2013-06-28','13:25:00',2.39),('3355','2013-06-28','13:30:00',1.88),('3355','2013-06-28','13:35:00',2.04),('3355','2013-06-28','13:40:00',2.27),('3355','2013-06-28','13:45:00',2.17),('3355','2013-06-28','13:50:00',2.19),('3355','2013-06-28','13:55:00',2.44),('3355','2013-06-28','14:00:00',2.16),('3355','2013-06-28','14:05:00',2.16),('3355','2013-06-28','14:10:00',2.16),('3355','2013-06-28','14:15:00',2.21),('3355','2013-06-28','14:20:00',2.01),('3355','2013-06-28','14:25:00',2.57),('3355','2013-06-28','14:30:00',2.24),('3355','2013-06-28','14:35:00',2.04),('3355','2013-06-28','14:40:00',1.82),('3355','2013-06-28','14:45:00',1.62),('3355','2013-06-28','14:50:00',2.32),('3355','2013-06-28','14:55:00',2.04),('3355','2013-06-28','15:00:00',1.93),('3355','2013-06-28','15:05:00',2.29),('3355','2013-06-28','15:10:00',1.47),('3355','2013-06-28','15:15:00',1.13),('3355','2013-06-28','15:25:00',1.7),('3355','2013-06-28','15:30:00',1.9),('3355','2013-06-28','15:35:00',2.4),('3355','2013-06-28','15:40:00',1.57),('3355','2013-06-28','15:45:00',1.11),('3355','2013-06-28','15:50:00',1.99),('3355','2013-06-28','15:55:00',1.36),('3355','2013-06-28','16:00:00',1.67),('3355','2013-06-28','16:05:00',1.86),('3355','2013-06-28','16:10:00',1.79),('3355','2013-06-28','16:15:00',1.78),('3355','2013-06-28','16:20:00',1.01),('3355','2013-06-28','16:35:00',1.35),('3355','2013-06-28','17:00:00',1.5),('3355','2013-06-28','17:05:00',1.57),('3355','2013-06-28','17:10:00',1.52),('3355','2013-06-28','17:15:00',1.35),('3355','2013-06-28','17:20:00',1.39),('3355','2013-06-28','17:25:00',1.38),('3355','2013-06-28','17:30:00',1.15),('3355','2013-06-28','17:35:00',1.27),('3355','2013-06-28','17:40:00',1.22),('3355','2013-06-28','17:45:00',1.19),('3355','2013-06-28','17:50:00',1.16),('3355','2013-06-28','17:55:00',1.1),('3355','2013-06-28','18:00:00',1.04),('3355','2013-06-28','18:05:00',1),('3355','2013-06-27','08:45:00',1.04),('3355','2013-06-27','08:50:00',1.07),('3355','2013-06-27','08:55:00',1.13),('3355','2013-06-27','09:00:00',1.19),('3355','2013-06-27','09:05:00',1.23),('3355','2013-06-27','09:10:00',1.27),('3355','2013-06-27','09:15:00',1.32),('3355','2013-06-27','09:20:00',1.37),('3355','2013-06-27','09:25:00',1.4),('3355','2013-06-27','09:30:00',1.44),('3355','2013-06-27','09:35:00',1.49),('3355','2013-06-27','09:40:00',1.52),('3355','2013-06-27','09:45:00',1.56),('3355','2013-06-27','09:50:00',1.61),('3355','2013-06-27','09:55:00',1.65),('3355','2013-06-27','10:00:00',1.7),('3355','2013-06-27','10:05:00',1.79),('3355','2013-06-27','10:10:00',1.75),('3355','2013-06-27','10:15:00',1.85),('3355','2013-06-27','10:20:00',1.81),('3355','2013-06-27','10:25:00',1.82),('3355','2013-06-27','10:30:00',1.88),('3355','2013-06-27','10:35:00',1.94),('3355','2013-06-27','10:40:00',2.01),('3355','2013-06-27','10:45:00',2.07),('3355','2013-06-27','10:50:00',2.06),('3355','2013-06-27','10:55:00',2.08),('3355','2013-06-27','11:00:00',2.06),('3355','2013-06-27','11:05:00',1.96),('3355','2013-06-27','11:10:00',1.41),('3355','2013-06-27','11:15:00',2.19),('3355','2013-06-27','11:20:00',2.17),('3355','2013-06-27','11:25:00',2.16),('3355','2013-06-27','11:30:00',2.2),('3355','2013-06-27','11:35:00',2.06),('3355','2013-06-27','11:40:00',2.19),('3355','2013-06-27','11:45:00',1.68),('3355','2013-06-27','12:00:00',1.03),('3355','2013-06-27','12:40:00',1.26),('3355','2013-06-27','12:50:00',1),('3355','2013-06-27','14:20:00',1.92),('3355','2013-06-27','14:25:00',2.18),('3355','2013-06-27','14:30:00',1.89),('3355','2013-06-27','14:35:00',1.91),('3355','2013-06-27','14:40:00',1.8),('3355','2013-06-27','14:45:00',1),('3355','2013-06-27','14:50:00',1.26),('3355','2013-06-27','14:55:00',2.27),('3355','2013-06-27','15:00:00',2.2),('3355','2013-06-27','15:05:00',2.14),('3355','2013-06-27','15:10:00',2.12),('3355','2013-06-27','15:15:00',2.11),('3355','2013-06-27','15:20:00',2.08),('3355','2013-06-27','15:25:00',2.1),('3355','2013-06-27','15:30:00',2.08),('3355','2013-06-27','15:35:00',2.05),('3355','2013-06-27','15:40:00',2.03),('3355','2013-06-27','15:45:00',2.01),('3355','2013-06-27','15:50:00',1.98),('3355','2013-06-27','15:55:00',1.95),('3355','2013-06-27','16:00:00',1.89),('3355','2013-06-27','16:05:00',1.86),('3355','2013-06-27','16:10:00',1.83),('3355','2013-06-27','16:15:00',1.82),('3355','2013-06-27','16:20:00',1.79),('3355','2013-06-27','16:25:00',1.77),('3355','2013-06-27','16:30:00',1.74),('3355','2013-06-27','16:35:00',1.62),('3355','2013-06-27','16:40:00',1.61),('3355','2013-06-27','16:45:00',1.63),('3355','2013-06-27','16:50:00',1.59),('3355','2013-06-27','16:55:00',1.55),('3355','2013-06-27','17:00:00',1.51),('3355','2013-06-27','17:05:00',1.47),('3355','2013-06-27','17:10:00',1.4),('3355','2013-06-27','17:15:00',1.34),('3355','2013-06-27','17:20:00',1.37),('3355','2013-06-27','17:25:00',1.35),('3355','2013-06-27','17:30:00',1.3),('3355','2013-06-27','17:35:00',1.26),('3355','2013-06-27','17:50:00',1.04),('3355','2013-06-27','17:55:00',1.05),('3355','2013-06-26','08:45:00',1.03),('3355','2013-06-26','08:50:00',1.08),('3355','2013-06-26','08:55:00',1.11),('3355','2013-06-26','09:00:00',1.15),('3355','2013-06-26','09:05:00',1.2),('3355','2013-06-26','09:10:00',1.24),('3355','2013-06-26','09:15:00',1.28),('3355','2013-06-26','09:20:00',1.32),('3355','2013-06-26','09:25:00',1.37),('3355','2013-06-26','09:30:00',1.41),('3355','2013-06-26','09:35:00',1.45),('3355','2013-06-26','09:40:00',1.49),('3355','2013-06-26','09:45:00',1.51),('3355','2013-06-26','09:50:00',1.54),('3355','2013-06-26','09:55:00',1.57),('3355','2013-06-26','10:00:00',1.61),('3355','2013-06-26','10:05:00',1.65),('3355','2013-06-26','10:10:00',1.67),('3355','2013-06-26','10:15:00',1.72),('3355','2013-06-26','10:20:00',1.74),('3355','2013-06-26','10:25:00',1.77),('3355','2013-06-26','10:30:00',1.79),('3355','2013-06-26','10:35:00',1.83),('3355','2013-06-26','10:40:00',1.86),('3355','2013-06-26','10:45:00',1.89),('3355','2013-06-26','10:50:00',1.91),('3355','2013-06-26','10:55:00',1.93),('3355','2013-06-26','11:00:00',1.96),('3355','2013-06-26','11:05:00',1.99),('3355','2013-06-26','11:10:00',2.01),('3355','2013-06-26','11:15:00',2.02),('3355','2013-06-26','11:20:00',2.03),('3355','2013-06-26','11:25:00',2.04),('3355','2013-06-26','11:30:00',2.05),('3355','2013-06-26','11:35:00',2.08),('3355','2013-06-26','11:40:00',2.12),('3355','2013-06-26','11:45:00',2.14),('3355','2013-06-26','11:50:00',2.15),('3355','2013-06-26','11:55:00',2.18),('3355','2013-06-26','12:00:00',2.15),('3355','2013-06-26','12:05:00',2.15),('3355','2013-06-26','12:10:00',2.18),('3355','2013-06-26','12:15:00',2.18),('3355','2013-06-26','12:20:00',2.12),('3355','2013-06-26','12:25:00',2.17),('3355','2013-06-26','12:30:00',2.14),('3355','2013-06-26','12:35:00',2.1),('3355','2013-06-26','12:40:00',2.24),('3355','2013-06-26','12:45:00',2.25),('3355','2013-06-26','12:50:00',2.24),('3355','2013-06-26','12:55:00',1.41),('3355','2013-06-26','13:10:00',2.07),('3355','2013-06-26','13:15:00',2.52),('3355','2013-06-26','13:20:00',2.46),('3355','2013-06-26','13:25:00',1.7),('3355','2013-06-26','14:00:00',1.51),('3355','2013-06-26','14:05:00',1.27),('3355','2013-06-26','14:15:00',1.5),('3355','2013-06-26','14:20:00',2.28),('3355','2013-06-26','14:25:00',1.26),('3355','2013-06-26','14:30:00',1.26),('3355','2013-06-26','14:45:00',1.67),('3355','2013-06-26','14:55:00',1.48),('3355','2013-06-26','15:00:00',2.29),('3355','2013-06-26','15:05:00',2.22),('3355','2013-06-26','15:10:00',2.17),('3355','2013-06-26','15:15:00',2.13),('3355','2013-06-26','15:20:00',2.09),('3355','2013-06-26','15:25:00',2.07),('3355','2013-06-26','15:30:00',2.06),('3355','2013-06-26','15:35:00',2.08),('3355','2013-06-26','15:40:00',2.03),('3355','2013-06-26','15:45:00',2),('3355','2013-06-26','15:50:00',1.6),('3355','2013-06-26','15:55:00',1.53),('3355','2013-06-26','16:00:00',1.97),('3355','2013-06-26','16:05:00',1.91),('3355','2013-06-26','16:10:00',1.89),('3355','2013-06-26','16:15:00',1.88),('3355','2013-06-26','16:20:00',1.84),('3355','2013-06-26','16:25:00',1.8),('3355','2013-06-26','16:30:00',1.78),('3355','2013-06-26','16:35:00',1.73),('3355','2013-06-26','16:40:00',1.67),('3355','2013-06-26','16:45:00',1.64),('3355','2013-06-26','16:50:00',1.61),('3355','2013-06-26','16:55:00',1.58),('3355','2013-06-26','17:00:00',1.55),('3355','2013-06-26','17:05:00',1.52),('3355','2013-06-26','17:10:00',1.48),('3355','2013-06-26','17:15:00',1.41),('3355','2013-06-26','17:20:00',1.37),('3355','2013-06-26','17:25:00',1.33),('3355','2013-06-26','17:30:00',1.29),('3355','2013-06-26','17:35:00',1.26),('3355','2013-06-26','17:40:00',1.21),('3355','2013-06-26','17:45:00',1.15),('3355','2013-06-26','17:50:00',1.11),('3355','2013-06-26','17:55:00',1.06),('3355','2013-06-26','18:00:00',1.04),('3355','2013-06-26','18:05:00',1.06),('3355','2013-06-26','18:10:00',1.01),('3355','2013-06-25','08:40:00',1.01),('3355','2013-06-25','08:45:00',1.07),('3355','2013-06-25','08:50:00',1.09),('3355','2013-06-25','08:55:00',1.14),('3355','2013-06-25','09:00:00',1.2),('3355','2013-06-25','09:05:00',1.24),('3355','2013-06-25','09:10:00',1.28),('3355','2013-06-25','09:15:00',1.33),('3355','2013-06-25','09:20:00',1.35),('3355','2013-06-25','09:25:00',1.43),('3355','2013-06-25','09:30:00',1.47),('3355','2013-06-25','09:35:00',1.38),('3355','2013-06-25','09:50:00',1.83),('3355','2013-06-25','09:55:00',1.86),('3355','2013-06-25','10:00:00',1.8),('3355','2013-06-25','10:10:00',1.21),('3355','2013-06-25','10:15:00',2.02),('3355','2013-06-25','10:20:00',1.37),('3355','2013-06-25','10:30:00',1.93),('3355','2013-06-25','10:40:00',1.89),('3355','2013-06-25','10:45:00',2.13),('3355','2013-06-25','10:50:00',2.11),('3355','2013-06-25','10:55:00',2.14),('3355','2013-06-25','11:00:00',2.01),('3355','2013-06-25','11:05:00',2.23),('3355','2013-06-25','11:10:00',2.29),('3355','2013-06-25','11:15:00',2.08),('3355','2013-06-25','11:20:00',2.34),('3355','2013-06-25','11:25:00',1.23),('3355','2013-06-25','11:30:00',1.51),('3355','2013-06-25','11:35:00',2.2),('3355','2013-06-25','11:40:00',2.43),('3355','2013-06-25','11:45:00',2.41),('3355','2013-06-25','11:50:00',2.37),('3355','2013-06-25','11:55:00',2.18),('3355','2013-06-25','12:00:00',1.84),('3355','2013-06-25','12:05:00',1.66),('3355','2013-06-25','12:55:00',1.05),('3355','2013-06-25','13:00:00',2.23),('3355','2013-06-25','13:05:00',2.59),('3355','2013-06-25','13:10:00',1.79),('3355','2013-06-25','13:15:00',1.71),('3355','2013-06-25','13:20:00',2.48),('3355','2013-06-25','13:25:00',2.44),('3355','2013-06-25','13:30:00',2.09),('3355','2013-06-25','13:35:00',1.89),('3355','2013-06-25','13:40:00',2.23),('3355','2013-06-25','13:45:00',2.4),('3355','2013-06-25','13:50:00',1.84),('3355','2013-06-25','13:55:00',1.92),('3355','2013-06-25','14:00:00',1.81),('3355','2013-06-25','14:05:00',2.49),('3355','2013-06-25','14:10:00',1.79),('3355','2013-06-25','14:15:00',1.21),('3355','2013-06-25','14:20:00',2.49),('3355','2013-06-25','14:25:00',2.37),('3355','2013-06-25','14:30:00',2.27),('3355','2013-06-25','14:35:00',2.29),('3355','2013-06-25','14:40:00',1.93),('3355','2013-06-25','14:45:00',2.32),('3355','2013-06-25','14:50:00',2.28),('3355','2013-06-25','14:55:00',2.24),('3355','2013-06-25','15:00:00',2.22),('3355','2013-06-25','15:05:00',2.19),('3355','2013-06-25','15:10:00',2.18),('3355','2013-06-25','15:15:00',2.19),('3355','2013-06-25','15:20:00',2.14),('3355','2013-06-25','15:25:00',2.1),('3355','2013-06-25','15:30:00',2.07),('3355','2013-06-25','15:35:00',2.05),('3355','2013-06-25','15:40:00',2.02),('3355','2013-06-25','15:45:00',1.99),('3355','2013-06-25','15:50:00',1.97),('3355','2013-06-25','15:55:00',1.94),('3355','2013-06-25','16:00:00',1.92),('3355','2013-06-25','16:05:00',1.9),('3355','2013-06-25','16:10:00',1.87),('3355','2013-06-25','16:15:00',1.84),('3355','2013-06-25','16:20:00',1.81),('3355','2013-06-25','16:25:00',1.78),('3355','2013-06-25','16:30:00',1.75),('3355','2013-06-25','16:35:00',1.71),('3355','2013-06-25','16:40:00',1.68),('3355','2013-06-25','16:45:00',1.65),('3355','2013-06-25','16:50:00',1.62),('3355','2013-06-25','16:55:00',1.57),('3355','2013-06-25','17:00:00',1.53),('3355','2013-06-25','17:05:00',1.49),('3355','2013-06-25','17:10:00',1.45),('3355','2013-06-25','17:15:00',1.42),('3355','2013-06-25','17:20:00',1.38),('3355','2013-06-25','17:25:00',1.33),('3355','2013-06-25','17:30:00',1.29),('3355','2013-06-25','17:35:00',1.25),('3355','2013-06-25','17:40:00',1.2),('3355','2013-06-25','17:45:00',1.15),('3355','2013-06-25','17:50:00',1.11),('3355','2013-06-25','17:55:00',1.07),('3355','2013-06-25','18:00:00',1.02),('3355','2013-06-24','08:45:00',1.1),('3355','2013-06-24','08:50:00',1.17),('3355','2013-06-24','08:55:00',1.23),('3355','2013-06-24','09:00:00',1.36),('3355','2013-06-24','09:05:00',1.37),('3355','2013-06-24','09:15:00',1.35),('3355','2013-06-24','09:20:00',1.47),('3355','2013-06-24','09:25:00',1.4),('3355','2013-06-24','09:30:00',1.75),('3355','2013-06-24','09:35:00',1.28),('3355','2013-06-24','09:45:00',1.12),('3355','2013-06-24','09:50:00',1.77),('3355','2013-06-24','09:55:00',1.7),('3355','2013-06-24','10:00:00',1.74),('3355','2013-06-24','10:05:00',1.77),('3355','2013-06-24','10:10:00',1.84),('3355','2013-06-24','10:15:00',1.61),('3355','2013-06-24','10:20:00',1.61),('3355','2013-06-24','10:25:00',2.09),('3355','2013-06-24','10:30:00',1.5),('3355','2013-06-24','10:35:00',1.97),('3355','2013-06-24','10:40:00',1.14),('3355','2013-06-24','10:50:00',1.87),('3355','2013-06-24','10:55:00',1.41),('3355','2013-06-24','11:00:00',2.24),('3355','2013-06-24','11:05:00',2.36),('3355','2013-06-24','11:10:00',1.21),('3355','2013-06-24','11:20:00',2.53),('3355','2013-06-24','11:30:00',1.28),('3355','2013-06-24','11:50:00',1.92),('3355','2013-06-24','11:55:00',1.14),('3355','2013-06-24','12:00:00',2.03),('3355','2013-06-24','12:05:00',2.16),('3355','2013-06-24','12:10:00',1.75),('3355','2013-06-24','12:15:00',1.96),('3355','2013-06-24','12:20:00',2.02),('3355','2013-06-24','12:25:00',2.57),('3355','2013-06-24','12:30:00',1.65),('3355','2013-06-24','12:35:00',2.48),('3355','2013-06-24','12:40:00',2.63),('3355','2013-06-24','12:45:00',1.28),('3355','2013-06-24','12:50:00',2.12),('3355','2013-06-24','12:55:00',2.75),('3355','2013-06-24','13:00:00',1.71),('3355','2013-06-24','13:05:00',2.3),('3355','2013-06-24','13:10:00',2.42),('3355','2013-06-24','13:15:00',1.76),('3355','2013-06-24','13:20:00',1.29),('3355','2013-06-24','13:25:00',2.05),('3355','2013-06-24','13:30:00',2.78),('3355','2013-06-24','13:35:00',2.21),('3355','2013-06-24','13:40:00',2.27),('3355','2013-06-24','13:45:00',2.32),('3355','2013-06-24','13:50:00',2.48),('3355','2013-06-24','13:55:00',2.44),('3355','2013-06-24','14:00:00',2.4),('3355','2013-06-24','14:05:00',2.43),('3355','2013-06-24','14:10:00',2.43),('3355','2013-06-24','14:15:00',2.41),('3355','2013-06-24','14:20:00',2.4),('3355','2013-06-24','14:25:00',2.4),('3355','2013-06-24','14:30:00',2.33),('3355','2013-06-24','14:35:00',2.4),('3355','2013-06-24','14:40:00',2.39),('3355','2013-06-24','14:45:00',2.42),('3355','2013-06-24','14:50:00',1.68),('3355','2013-06-24','14:55:00',2.24),('3355','2013-06-24','15:00:00',1.84),('3355','2013-06-24','15:05:00',1.7),('3355','2013-06-24','15:10:00',2),('3355','2013-06-24','15:15:00',2.51),('3355','2013-06-24','15:20:00',1.91),('3355','2013-06-24','15:25:00',1.54),('3355','2013-06-24','15:30:00',1.54),('3355','2013-06-24','15:35:00',1.94),('3355','2013-06-24','15:45:00',2.27),('3355','2013-06-24','15:50:00',1.65),('3355','2013-06-24','15:55:00',1.93),('3355','2013-06-24','16:00:00',2.34),('3355','2013-06-24','16:05:00',2.09),('3355','2013-06-24','16:10:00',1.87),('3355','2013-06-24','16:15:00',2.18),('3355','2013-06-24','16:20:00',1.29),('3355','2013-06-24','16:25:00',1.46),('3355','2013-06-24','16:30:00',1.29),('3355','2013-06-24','16:35:00',1.74),('3355','2013-06-24','16:40:00',1.19),('3355','2013-06-24','16:45:00',1.11),('3355','2013-06-24','17:05:00',1.21),('3355','2013-06-24','17:15:00',1.69),('3355','2013-06-24','17:20:00',1.07),('3355','2013-06-24','17:25:00',1.26),('3355','2013-06-24','17:30:00',1.16),('3355','2013-06-24','18:00:00',1.22),('3355','2013-06-24','18:05:00',1.17),('3355','2013-06-23','09:25:00',1.23),('3355','2013-06-23','09:30:00',1.41),('3355','2013-06-23','09:35:00',1.5),('3355','2013-06-23','09:40:00',1.66),('3355','2013-06-23','09:45:00',1.24),('3355','2013-06-23','10:00:00',1.79),('3355','2013-06-23','10:05:00',1.81),('3355','2013-06-23','10:10:00',1.93),('3355','2013-06-23','10:15:00',1.79),('3355','2013-06-23','10:20:00',1.22),('3355','2013-06-23','10:25:00',1.68),('3355','2013-06-23','10:40:00',1.99),('3355','2013-06-23','10:45:00',1.94),('3355','2013-06-23','10:50:00',1.92),('3355','2013-06-23','10:55:00',1.9),('3355','2013-06-23','11:00:00',1.94),('3355','2013-06-23','11:05:00',1.97),('3355','2013-06-23','11:10:00',2),('3355','2013-06-23','11:15:00',2),('3355','2013-06-23','11:20:00',2.05),('3355','2013-06-23','11:25:00',2.08),('3355','2013-06-23','11:30:00',2.07),('3355','2013-06-23','11:35:00',2.05),('3355','2013-06-23','11:40:00',2.04),('3355','2013-06-23','11:45:00',2.07),('3355','2013-06-23','11:50:00',2.14),('3355','2013-06-23','11:55:00',2.16),('3355','2013-06-23','12:00:00',1.92),('3355','2013-06-23','12:05:00',2.24),('3355','2013-06-23','12:10:00',2.26),('3355','2013-06-23','12:15:00',2.22),('3355','2013-06-23','12:20:00',2.26),('3355','2013-06-23','12:25:00',2.29),('3355','2013-06-23','12:30:00',2.28),('3355','2013-06-23','12:35:00',2.27),('3355','2013-06-23','12:40:00',2.27),('3355','2013-06-23','12:45:00',2.29),('3355','2013-06-23','12:50:00',2.29),('3355','2013-06-23','12:55:00',2.31),('3355','2013-06-23','13:00:00',2.31),('3355','2013-06-23','13:05:00',2.31),('3355','2013-06-23','13:10:00',2.32),('3355','2013-06-23','13:15:00',2.33),('3355','2013-06-23','13:20:00',2.32),('3355','2013-06-23','13:25:00',2.33),('3355','2013-06-23','13:30:00',2.31),('3355','2013-06-23','13:35:00',2.33),('3355','2013-06-23','13:40:00',2.34),('3355','2013-06-23','13:45:00',2.33),('3355','2013-06-23','13:50:00',2.33),('3355','2013-06-23','13:55:00',2.34),('3355','2013-06-23','14:00:00',2.33),('3355','2013-06-23','14:05:00',2.31),('3355','2013-06-23','14:10:00',2.31),('3355','2013-06-23','14:15:00',2.31),('3355','2013-06-23','14:20:00',2.3),('3355','2013-06-23','14:25:00',2.3),('3355','2013-06-23','14:30:00',2.31),('3355','2013-06-23','14:35:00',2.28),('3355','2013-06-23','14:40:00',2.28),('3355','2013-06-23','14:45:00',2.26),('3355','2013-06-23','14:50:00',2.26),('3355','2013-06-23','14:55:00',2.24),('3355','2013-06-23','15:00:00',2.24),('3355','2013-06-23','15:05:00',2.22),('3355','2013-06-23','15:10:00',2.18),('3355','2013-06-23','15:15:00',2.17),('3355','2013-06-23','15:20:00',2.14),('3355','2013-06-23','15:25:00',2.14),('3355','2013-06-23','15:30:00',2.11),('3355','2013-06-23','15:35:00',2.09),('3355','2013-06-23','15:40:00',2.06),('3355','2013-06-23','15:45:00',2.03),('3355','2013-06-23','15:50:00',2.01),('3355','2013-06-23','15:55:00',1.99),('3355','2013-06-23','16:00:00',1.96),('3355','2013-06-23','16:05:00',1.92),('3355','2013-06-23','16:10:00',1.89),('3355','2013-06-23','16:15:00',1.85),('3355','2013-06-23','16:20:00',1.83),('3355','2013-06-23','16:25:00',1.8),('3355','2013-06-23','16:30:00',1.77),('3355','2013-06-23','16:35:00',1.74),('3355','2013-06-23','16:40:00',1.7),('3355','2013-06-23','16:45:00',1.68),('3355','2013-06-23','16:50:00',1.65),('3355','2013-06-23','16:55:00',1.59),('3355','2013-06-23','17:00:00',1.56),('3355','2013-06-23','17:05:00',1.53),('3355','2013-06-23','17:10:00',1.49),('3355','2013-06-23','17:15:00',1.46),('3355','2013-06-23','17:20:00',1.41),('3355','2013-06-23','17:25:00',1.39),('3355','2013-06-23','17:30:00',1.33),('3355','2013-06-23','17:35:00',1.29),('3355','2013-06-23','17:40:00',1.23),('3355','2013-06-23','17:45:00',1.21),('3355','2013-06-23','17:50:00',1.16),('3355','2013-06-23','17:55:00',1.11),('3355','2013-06-23','18:00:00',1.05),('3355','2013-06-23','18:05:00',1.01),('3355','2013-06-22','08:50:00',1.04),('3355','2013-06-22','08:55:00',1.08),('3355','2013-06-22','09:00:00',1.11),('3355','2013-06-22','09:05:00',1.14),('3355','2013-06-22','09:10:00',1.18),('3355','2013-06-22','09:15:00',1.22),('3355','2013-06-22','09:20:00',1.26),('3355','2013-06-22','09:25:00',1.3),('3355','2013-06-22','09:30:00',1.33),('3355','2013-06-22','09:35:00',1.38),('3355','2013-06-22','09:40:00',1.41),('3355','2013-06-22','09:45:00',1.45),('3355','2013-06-22','09:50:00',1.48),('3355','2013-06-22','09:55:00',1.52),('3355','2013-06-22','10:00:00',1.54),('3355','2013-06-22','10:05:00',1.59),('3355','2013-06-22','10:10:00',1.62),('3355','2013-06-22','10:15:00',1.65),('3355','2013-06-22','10:20:00',1.69),('3355','2013-06-22','10:25:00',1.74),('3355','2013-06-22','10:30:00',1.74),('3355','2013-06-22','10:35:00',1.77),('3355','2013-06-22','10:40:00',1.8),('3355','2013-06-22','10:45:00',1.84),('3355','2013-06-22','10:50:00',1.86),('3355','2013-06-22','10:55:00',1.89),('3355','2013-06-22','11:00:00',1.91),('3355','2013-06-22','11:05:00',1.93),('3355','2013-06-22','11:10:00',1.95),('3355','2013-06-22','11:15:00',1.97),('3355','2013-06-22','11:20:00',1.99),('3355','2013-06-22','11:25:00',2.01),('3355','2013-06-22','11:30:00',2.02),('3355','2013-06-22','11:35:00',2.05),('3355','2013-06-22','11:40:00',2.07),('3355','2013-06-22','11:45:00',2.08),('3355','2013-06-22','11:50:00',2.1),('3355','2013-06-22','11:55:00',2.1),('3355','2013-06-22','12:00:00',2.12),('3355','2013-06-22','12:05:00',2.11),('3355','2013-06-22','12:10:00',2.07),('3355','2013-06-22','12:15:00',2.15),('3355','2013-06-22','12:20:00',2.16),('3355','2013-06-22','12:25:00',2.14),('3355','2013-06-22','12:30:00',2.18),('3355','2013-06-22','12:35:00',2.2),('3355','2013-06-22','12:40:00',2.22),('3355','2013-06-22','12:45:00',2.19),('3355','2013-06-22','12:50:00',2.16),('3355','2013-06-22','12:55:00',2.15),('3355','2013-06-22','13:00:00',2.14),('3355','2013-06-22','13:05:00',2.15),('3355','2013-06-22','13:10:00',2.11),('3355','2013-06-22','13:15:00',2.09),('3355','2013-06-22','13:20:00',2.03),('3355','2013-06-22','13:25:00',2.06),('3355','2013-06-22','13:30:00',2.28),('3355','2013-06-22','13:35:00',2.32),('3355','2013-06-22','13:40:00',2.17),('3355','2013-06-22','13:45:00',2.15),('3355','2013-06-22','13:50:00',2.29),('3355','2013-06-22','13:55:00',1.95),('3355','2013-06-22','14:00:00',1.19),('3355','2013-06-22','14:05:00',2.49),('3355','2013-06-22','14:10:00',2.37),('3355','2013-06-22','14:15:00',2.35),('3355','2013-06-22','14:20:00',1.95),('3355','2013-06-22','14:25:00',2.32),('3355','2013-06-22','14:30:00',1.8),('3355','2013-06-22','14:35:00',1.27),('3355','2013-06-22','14:45:00',1),('3355','2013-06-22','14:50:00',1.91),('3355','2013-06-22','14:55:00',2.03),('3355','2013-06-22','15:00:00',2.09),('3355','2013-06-22','15:05:00',1.85),('3355','2013-06-22','15:10:00',1.99),('3355','2013-06-22','15:15:00',2.23),('3355','2013-06-22','15:20:00',2.07),('3355','2013-06-22','15:25:00',1.92),('3355','2013-06-22','15:30:00',1.27),('3355','2013-06-22','15:35:00',1.14),('3355','2013-06-22','15:45:00',1.36),('3355','2013-06-22','15:50:00',1.43),('3355','2013-06-22','15:55:00',1.33),('3355','2013-06-22','16:00:00',1.12),('3355','2013-06-22','16:20:00',1.05),('3355','2013-06-22','17:10:00',1.04),('3355','2013-06-22','17:15:00',1.59),('3355','2013-06-22','17:20:00',1.54),('3355','2013-06-22','17:25:00',1.55),('3355','2013-06-22','17:30:00',1.23),('3355','2013-06-22','17:35:00',1.1),('3355','2013-06-22','17:40:00',1.24),('3355','2013-06-22','17:45:00',1.22),('3355','2013-06-22','17:50:00',1.13),('3355','2013-06-22','17:55:00',1.09),('3355','2013-06-22','18:00:00',1.02),('3355','2013-06-21','08:55:00',1.03),('3355','2013-06-21','09:00:00',1.08),('3355','2013-06-21','09:05:00',1.11),('3355','2013-06-21','09:10:00',1.15),('3355','2013-06-21','09:15:00',1.18),('3355','2013-06-21','09:20:00',1.22),('3355','2013-06-21','09:25:00',1.24),('3355','2013-06-21','09:30:00',1.28),('3355','2013-06-21','09:35:00',1.32),('3355','2013-06-21','09:40:00',1.35),('3355','2013-06-21','09:45:00',1.38),('3355','2013-06-21','09:50:00',1.4),('3355','2013-06-21','09:55:00',1.43),('3355','2013-06-21','10:00:00',1.48),('3355','2013-06-21','10:05:00',1.51),('3355','2013-06-21','10:10:00',1.54),('3355','2013-06-21','10:15:00',1.54),('3355','2013-06-21','10:20:00',1.57),('3355','2013-06-21','10:25:00',1.59),('3355','2013-06-21','10:30:00',1.64),('3355','2013-06-21','10:35:00',1.66),('3355','2013-06-21','10:40:00',1.68),('3355','2013-06-21','10:45:00',1.71),('3355','2013-06-21','10:50:00',1.74),('3355','2013-06-21','10:55:00',1.76),('3355','2013-06-21','11:00:00',1.79),('3355','2013-06-21','11:05:00',1.8),('3355','2013-06-21','11:10:00',1.8),('3355','2013-06-21','11:15:00',1.83),('3355','2013-06-21','11:20:00',1.88),('3355','2013-06-21','11:25:00',1.91),('3355','2013-06-21','11:30:00',1.94),('3355','2013-06-21','11:35:00',1.93),('3355','2013-06-21','11:40:00',1.94),('3355','2013-06-21','11:45:00',1.95),('3355','2013-06-21','11:50:00',2),('3355','2013-06-21','11:55:00',2),('3355','2013-06-21','12:00:00',1.98),('3355','2013-06-21','12:05:00',2.02),('3355','2013-06-21','12:10:00',2.03),('3355','2013-06-21','12:15:00',2.03),('3355','2013-06-21','12:20:00',2.02),('3355','2013-06-21','12:25:00',2.02),('3355','2013-06-21','12:30:00',2.06),('3355','2013-06-21','12:35:00',2.05),('3355','2013-06-21','12:40:00',2.07),('3355','2013-06-21','12:45:00',2.05),('3355','2013-06-21','12:50:00',2.04),('3355','2013-06-21','12:55:00',2.02),('3355','2013-06-21','13:00:00',2.03),('3355','2013-06-21','13:05:00',2.07),('3355','2013-06-21','13:10:00',2.05),('3355','2013-06-21','13:15:00',2.07),('3355','2013-06-21','13:20:00',2.08),('3355','2013-06-21','13:25:00',2.06),('3355','2013-06-21','13:30:00',2.09),('3355','2013-06-21','13:35:00',2.13),('3355','2013-06-21','13:40:00',2.1),('3355','2013-06-21','13:45:00',2.1),('3355','2013-06-21','13:50:00',2.11),('3355','2013-06-21','13:55:00',2.1),('3355','2013-06-21','14:00:00',2.1),('3355','2013-06-21','14:05:00',2.1),('3355','2013-06-21','14:10:00',2.12),('3355','2013-06-21','14:15:00',2.11),('3355','2013-06-21','14:20:00',2.11),('3355','2013-06-21','14:25:00',2.12),('3355','2013-06-21','14:30:00',2.12),('3355','2013-06-21','14:35:00',2.13),('3355','2013-06-21','14:40:00',2.11),('3355','2013-06-21','14:45:00',2.1),('3355','2013-06-21','14:50:00',2.1),('3355','2013-06-21','14:55:00',2.08),('3355','2013-06-21','15:00:00',2.07),('3355','2013-06-21','15:05:00',2.06),('3355','2013-06-21','15:10:00',2.03),('3355','2013-06-21','15:15:00',2.02),('3355','2013-06-21','15:20:00',2.01),('3355','2013-06-21','15:25:00',1.99),('3355','2013-06-21','15:30:00',1.97),('3355','2013-06-21','15:35:00',1.96),('3355','2013-06-21','15:40:00',1.94),('3355','2013-06-21','15:45:00',1.92),('3355','2013-06-21','15:50:00',1.89),('3355','2013-06-21','15:55:00',1.86),('3355','2013-06-21','16:00:00',1.85),('3355','2013-06-21','16:05:00',1.82),('3355','2013-06-21','16:10:00',1.8),('3355','2013-06-21','16:15:00',1.77),('3355','2013-06-21','16:20:00',1.74),('3355','2013-06-21','16:25:00',1.71),('3355','2013-06-21','16:30:00',1.68),('3355','2013-06-21','16:35:00',1.65),('3355','2013-06-21','16:40:00',1.61),('3355','2013-06-21','16:45:00',1.57),('3355','2013-06-21','16:50:00',1.55),('3355','2013-06-21','16:55:00',1.52),('3355','2013-06-21','17:00:00',1.48),('3355','2013-06-21','17:05:00',1.44),('3355','2013-06-21','17:10:00',1.41),('3355','2013-06-21','17:15:00',1.37),('3355','2013-06-21','17:20:00',1.33),('3355','2013-06-21','17:25:00',1.28),('3355','2013-06-21','17:30:00',1.24),('3355','2013-06-21','17:35:00',1.2),('3355','2013-06-21','17:40:00',1.16),('3355','2013-06-21','17:45:00',1.12),('3355','2013-06-21','17:50:00',1.07),('3355','2013-06-21','17:55:00',1.01),('3355','2014-04-04','13:25:00',1.57),('3355','2014-04-04','13:30:00',1.26),('3355','2014-04-04','13:35:00',1.85),('3355','2014-04-04','13:40:00',2.15),('3355','2014-04-04','13:45:00',1.97),('3355','2014-04-04','13:50:00',1.91),('3355','2014-04-04','13:55:00',1.45),('3355','2014-04-04','14:00:00',1.11),('3355','2014-04-04','14:05:00',2.31),('3355','2014-04-04','14:10:00',1.25),('3355','2014-04-04','14:15:00',2.39),('3355','2014-04-04','14:20:00',1.72),('3355','2014-04-04','14:25:00',1.81),('3355','2014-04-04','14:35:00',1.79),('3355','2014-04-04','14:45:00',1.81),('3355','2014-04-04','14:50:00',1.86),('3355','2014-04-04','14:55:00',1.83),('3355','2014-04-04','15:00:00',2.33),('3355','2014-04-04','15:05:00',2.32),('3355','2014-04-04','15:10:00',2.34),('3355','2014-04-04','15:15:00',1.92),('3355','2014-04-04','15:20:00',1.21),('3355','2014-04-04','15:25:00',1.04),('3355','2014-04-04','15:40:00',1.46),('3355','2014-04-04','15:45:00',1.27),('3355','2014-04-04','15:50:00',1.06),('3355','2014-04-04','15:55:00',1.67),('3355','2014-04-04','16:00:00',1.57),('3355','2014-04-04','16:10:00',1.03),('3355','2014-04-04','16:30:00',1.26),('3355','2014-04-04','16:45:00',1.63),('3355','2014-04-04','16:50:00',1.86),('3355','2014-04-04','16:55:00',1.25),('3355','2014-04-04','17:00:00',1.08),('3355','2014-04-04','17:05:00',1.22),('3355','2014-04-04','17:10:00',1.27),('3355','2014-04-04','17:15:00',1.38),('3355','2014-04-04','17:20:00',1.29),('3355','2014-04-04','17:25:00',1.07),('3355','2014-04-04','17:30:00',1.21),('3355','2013-06-20','08:50:00',1),('3355','2013-06-20','08:55:00',1.05),('3355','2013-06-20','09:00:00',1.1),('3355','2013-06-20','09:05:00',1.14),('3355','2013-06-20','09:10:00',1.18),('3355','2013-06-20','09:15:00',1.21),('3355','2013-06-20','09:20:00',1.25),('3355','2013-06-20','09:25:00',1.28),('3355','2013-06-20','09:30:00',1.32),('3355','2013-06-20','09:35:00',1.35),('3355','2013-06-20','09:40:00',1.39),('3355','2013-06-20','09:45:00',1.42),('3355','2013-06-20','09:50:00',1.46),('3355','2013-06-20','09:55:00',1.49),('3355','2013-06-20','10:00:00',1.53),('3355','2013-06-20','10:05:00',1.56),('3355','2013-06-20','10:10:00',1.58),('3355','2013-06-20','10:15:00',1.61),('3355','2013-06-20','10:20:00',1.65),('3355','2013-06-20','10:25:00',1.68),('3355','2013-06-20','10:30:00',1.71),('3355','2013-06-20','10:35:00',1.73),('3355','2013-06-20','10:40:00',1.76),('3355','2013-06-20','10:45:00',1.77),('3355','2013-06-20','10:50:00',1.78),('3355','2013-06-20','10:55:00',1.8),('3355','2013-06-20','11:00:00',1.85),('3355','2013-06-20','11:05:00',1.85),('3355','2013-06-20','11:10:00',1.88),('3355','2013-06-20','11:15:00',1.9),('3355','2013-06-20','11:20:00',1.87),('3355','2013-06-20','11:25:00',1.87),('3355','2013-06-20','11:30:00',1.93),('3355','2013-06-20','11:35:00',1.96),('3355','2013-06-20','11:40:00',1.98),('3355','2013-06-20','11:45:00',2),('3355','2013-06-20','11:50:00',2.02),('3355','2013-06-20','11:55:00',1.99),('3355','2013-06-20','12:00:00',1.99),('3355','2013-06-20','12:05:00',1.99),('3355','2013-06-20','12:10:00',2),('3355','2013-06-20','12:15:00',1.95),('3355','2013-06-20','12:20:00',1.93),('3355','2013-06-20','12:25:00',1.99),('3355','2013-06-20','12:30:00',1.98),('3355','2013-06-20','12:35:00',2.13),('3355','2013-06-20','12:40:00',1.57),('3355','2013-06-20','12:45:00',1.7),('3355','2013-06-20','12:50:00',2.11),('3355','2013-06-20','12:55:00',1.33),('3355','2013-06-20','13:00:00',1.75),('3355','2013-06-20','13:05:00',2.04),('3355','2013-06-20','13:10:00',2.19),('3355','2013-06-20','13:15:00',2.16),('3355','2013-06-20','13:20:00',2.13),('3355','2013-06-20','13:25:00',1.66),('3355','2013-06-20','13:30:00',2.03),('3355','2013-06-20','13:35:00',2.12),('3355','2013-06-20','13:40:00',2.14),('3355','2013-06-20','13:45:00',2.15),('3355','2013-06-20','13:50:00',2.16),('3355','2013-06-20','13:55:00',2.12),('3355','2013-06-20','14:00:00',2.14),('3355','2013-06-20','14:05:00',2.19),('3355','2013-06-20','14:10:00',2.19),('3355','2013-06-20','14:15:00',2.19),('3355','2013-06-20','14:20:00',2.2),('3355','2013-06-20','14:25:00',2.18),('3355','2013-06-20','14:30:00',2.17),('3355','2013-06-20','14:35:00',2.19),('3355','2013-06-20','14:40:00',2.19),('3355','2013-06-20','14:45:00',2.18),('3355','2013-06-20','14:50:00',2.18),('3355','2013-06-20','14:55:00',2.17),('3355','2013-06-20','15:00:00',2.15),('3355','2013-06-20','15:05:00',2.13),('3355','2013-06-20','15:10:00',2.11),('3355','2013-06-20','15:15:00',2.09),('3355','2013-06-20','15:20:00',2.07),('3355','2013-06-20','15:25:00',2.03),('3355','2013-06-20','15:30:00',2.02),('3355','2013-06-20','15:35:00',1.99),('3355','2013-06-20','15:40:00',1.98),('3355','2013-06-20','15:45:00',1.96),('3355','2013-06-20','15:50:00',1.92),('3355','2013-06-20','15:55:00',1.9),('3355','2013-06-20','16:00:00',1.87),('3355','2013-06-20','16:05:00',1.85),('3355','2013-06-20','16:10:00',1.84),('3355','2013-06-20','16:15:00',1.81),('3355','2013-06-20','16:20:00',1.78),('3355','2013-06-20','16:25:00',1.74),('3355','2013-06-20','16:30:00',1.72),('3355','2013-06-20','16:35:00',1.68),('3355','2013-06-20','16:40:00',1.64),('3355','2013-06-20','16:45:00',1.61),('3355','2013-06-20','16:50:00',1.57),('3355','2013-06-20','16:55:00',1.53),('3355','2013-06-20','17:00:00',1.49),('3355','2013-06-20','17:05:00',1.45),('3355','2013-06-20','17:10:00',1.41),('3355','2013-06-20','17:15:00',1.38),('3355','2013-06-20','17:20:00',1.34),('3355','2013-06-20','17:25:00',1.29),('3355','2013-06-20','17:30:00',1.26),('3355','2013-06-20','17:35:00',1.21),('3355','2013-06-20','17:40:00',1.18),('3355','2013-06-20','17:45:00',1.14),('3355','2013-06-20','17:50:00',1.1),('3355','2013-06-20','17:55:00',1.05),('3355','2013-06-19','08:55:00',1.02),('3355','2013-06-19','09:00:00',1.07),('3355','2013-06-19','09:05:00',1.12),('3355','2013-06-19','09:10:00',1.16),('3355','2013-06-19','09:15:00',1.19),('3355','2013-06-19','09:20:00',1.23),('3355','2013-06-19','09:25:00',1.26),('3355','2013-06-19','09:30:00',1.3),('3355','2013-06-19','09:35:00',1.34),('3355','2013-06-19','09:40:00',1.37),('3355','2013-06-19','09:45:00',1.4),('3355','2013-06-19','09:50:00',1.43),('3355','2013-06-19','09:55:00',1.47),('3355','2013-06-19','10:00:00',1.49),('3355','2013-06-19','10:05:00',1.51),('3355','2013-06-19','10:10:00',1.55),('3355','2013-06-19','10:15:00',1.58),('3355','2013-06-19','10:20:00',1.6),('3355','2013-06-19','10:25:00',1.62),('3355','2013-06-19','10:30:00',1.65),('3355','2013-06-19','10:35:00',1.67),('3355','2013-06-19','10:40:00',1.69),('3355','2013-06-19','10:45:00',1.72),('3355','2013-06-19','10:50:00',1.75),('3355','2013-06-19','10:55:00',1.76),('3355','2013-06-19','11:00:00',1.78),('3355','2013-06-19','11:05:00',1.79),('3355','2013-06-19','11:10:00',1.82),('3355','2013-06-19','11:15:00',1.84),('3355','2013-06-19','11:20:00',1.85),('3355','2013-06-19','11:25:00',1.88),('3355','2013-06-19','11:30:00',1.9),('3355','2013-06-19','11:35:00',1.9),('3355','2013-06-19','11:40:00',1.91),('3355','2013-06-19','11:45:00',1.89),('3355','2013-06-19','11:50:00',1.94),('3355','2013-06-19','11:55:00',1.93),('3355','2013-06-19','12:00:00',1.97),('3355','2013-06-19','12:05:00',1.97),('3355','2013-06-19','12:10:00',1.99),('3355','2013-06-19','12:15:00',1.97),('3355','2013-06-19','12:20:00',1.96),('3355','2013-06-19','12:25:00',1.94),('3355','2013-06-19','12:30:00',1.92),('3355','2013-06-19','12:35:00',2.07),('3355','2013-06-19','12:40:00',2.09),('3355','2013-06-19','12:45:00',2.09),('3355','2013-06-19','12:50:00',2.07),('3355','2013-06-19','12:55:00',2.1),('3355','2013-06-19','13:00:00',2.1),('3355','2013-06-19','13:05:00',2.11),('3355','2013-06-19','13:10:00',2.1),('3355','2013-06-19','13:15:00',2.11),('3355','2013-06-19','13:20:00',2.11),('3355','2013-06-19','13:25:00',2.14),('3355','2013-06-19','13:30:00',2.16),('3355','2013-06-19','13:35:00',2.14),('3355','2013-06-19','13:40:00',2.15),('3355','2013-06-19','13:45:00',2.15),('3355','2013-06-19','13:50:00',2.14),('3355','2013-06-19','13:55:00',2.17),('3355','2013-06-19','14:00:00',2.16),('3355','2013-06-19','14:05:00',2.17),('3355','2013-06-19','14:10:00',2.15),('3355','2013-06-19','14:15:00',2.13),('3355','2013-06-19','14:20:00',2.13),('3355','2013-06-19','14:25:00',2.13),('3355','2013-06-19','14:30:00',2.11),('3355','2013-06-19','14:35:00',2.1),('3355','2013-06-19','14:40:00',2.07),('3355','2013-06-19','14:45:00',2.06),('3355','2013-06-19','14:50:00',2.03),('3355','2013-06-19','14:55:00',2.02),('3355','2013-06-19','15:00:00',2.03),('3355','2013-06-19','15:05:00',2.02),('3355','2013-06-19','15:10:00',2),('3355','2013-06-19','15:15:00',1.97),('3355','2013-06-19','15:20:00',1.95),('3355','2013-06-19','15:25:00',1.94),('3355','2013-06-19','15:30:00',1.92),('3355','2013-06-19','15:35:00',1.9),('3355','2013-06-19','15:40:00',1.88),('3355','2013-06-19','15:45:00',1.85),('3355','2013-06-19','15:50:00',1.82),('3355','2013-06-19','15:55:00',1.79),('3355','2013-06-19','16:00:00',1.77),('3355','2013-06-19','16:05:00',1.74),('3355','2013-06-19','16:10:00',1.72),('3355','2013-06-19','16:15:00',1.69),('3355','2013-06-19','16:20:00',1.66),('3355','2013-06-19','16:25:00',1.63),('3355','2013-06-19','16:30:00',1.6),('3355','2013-06-19','16:35:00',1.58),('3355','2013-06-19','16:40:00',1.54),('3355','2013-06-19','16:45:00',1.52),('3355','2013-06-19','16:50:00',1.48),('3355','2013-06-19','16:55:00',1.46),('3355','2013-06-19','17:00:00',1.42),('3355','2013-06-19','17:05:00',1.37),('3355','2013-06-19','17:10:00',1.35),('3355','2013-06-19','17:15:00',1.31),('3355','2013-06-19','17:20:00',1.3),('3355','2013-06-19','17:25:00',1.27),('3355','2013-06-19','17:30:00',1.22),('3355','2013-06-19','17:35:00',1.17),('3355','2013-06-19','17:40:00',1.13),('3355','2013-06-19','17:45:00',1.1),('3355','2013-06-19','17:50:00',1.05),('3355','2013-06-18','08:55:00',1),('3355','2013-06-18','09:00:00',1.06),('3355','2013-06-18','09:05:00',1.09),('3355','2013-06-18','09:10:00',1.14),('3355','2013-06-18','09:15:00',1.17),('3355','2013-06-18','09:20:00',1.21),('3355','2013-06-18','09:25:00',1.25),('3355','2013-06-18','09:30:00',1.28),('3355','2013-06-18','09:35:00',1.33),('3355','2013-06-18','09:40:00',1.36),('3355','2013-06-18','09:45:00',1.39),('3355','2013-06-18','09:50:00',1.42),('3355','2013-06-18','09:55:00',1.44),('3355','2013-06-18','10:00:00',1.47),('3355','2013-06-18','10:05:00',1.48),('3355','2013-06-18','10:10:00',1.54),('3355','2013-06-18','10:15:00',1.56),('3355','2013-06-18','10:20:00',1.59),('3355','2013-06-18','10:25:00',1.63),('3355','2013-06-18','10:30:00',1.65),('3355','2013-06-18','10:35:00',1.67),('3355','2013-06-18','10:40:00',1.7),('3355','2013-06-18','10:45:00',1.71),('3355','2013-06-18','10:50:00',1.72),('3355','2013-06-18','10:55:00',1.75),('3355','2013-06-18','11:00:00',1.77),('3355','2013-06-18','11:05:00',1.81),('3355','2013-06-18','11:10:00',1.86),('3355','2013-06-18','11:15:00',1.87),('3355','2013-06-18','11:20:00',1.88),('3355','2013-06-18','11:25:00',1.88),('3355','2013-06-18','11:30:00',1.88),('3355','2013-06-18','11:35:00',1.89),('3355','2013-06-18','11:40:00',1.91),('3355','2013-06-18','11:45:00',1.93),('3355','2013-06-18','11:50:00',1.93),('3355','2013-06-18','11:55:00',1.91),('3355','2013-06-18','12:00:00',1.9),('3355','2013-06-18','12:05:00',1.95),('3355','2013-06-18','12:10:00',1.95),('3355','2013-06-18','12:15:00',1.93),('3355','2013-06-18','12:20:00',1.93),('3355','2013-06-18','12:25:00',1.97),('3355','2013-06-18','12:30:00',1.97),('3355','2013-06-18','12:35:00',1.9),('3355','2013-06-18','12:40:00',1.7),('3355','2013-06-18','12:45:00',1.48),('3355','2013-06-18','12:50:00',1.79),('3355','2013-06-18','12:55:00',2.1),('3355','2013-06-18','13:00:00',2.04),('3355','2013-06-18','13:05:00',1.78),('3355','2013-06-18','13:10:00',2.16),('3355','2013-06-18','13:15:00',2.09),('3355','2013-06-18','13:20:00',2.2),('3355','2013-06-18','13:25:00',2.03),('3355','2013-06-18','13:30:00',2.17),('3355','2013-06-18','13:35:00',2.09),('3355','2013-06-18','13:40:00',2.05),('3355','2013-06-18','13:45:00',2.09),('3355','2013-06-18','13:50:00',2.11),('3355','2013-06-18','13:55:00',2.16),('3355','2013-06-18','14:00:00',2.17),('3355','2013-06-18','14:05:00',2.17),('3355','2013-06-18','14:10:00',2.16),('3355','2013-06-18','14:15:00',2.14),('3355','2013-06-18','14:20:00',2.1),('3355','2013-06-18','14:25:00',2.12),('3355','2013-06-18','14:30:00',2.09),('3355','2013-06-18','14:35:00',2.11),('3355','2013-06-18','14:40:00',2.11),('3355','2013-06-18','14:45:00',2.08),('3355','2013-06-18','14:50:00',2.07),('3355','2013-06-18','14:55:00',2.06),('3355','2013-06-18','15:00:00',2.05),('3355','2013-06-18','15:05:00',2.03),('3355','2013-06-18','15:10:00',2.02),('3355','2013-06-18','15:15:00',2),('3355','2013-06-18','15:20:00',1.97),('3355','2013-06-18','15:25:00',1.96),('3355','2013-06-18','15:30:00',1.93),('3355','2013-06-18','15:35:00',1.92),('3355','2013-06-18','15:40:00',1.91),('3355','2013-06-18','15:45:00',1.9),('3355','2013-06-18','15:50:00',1.89),('3355','2013-06-18','15:55:00',1.86),('3355','2013-06-18','16:00:00',1.85),('3355','2013-06-18','16:05:00',1.84),('3355','2013-06-18','16:10:00',1.82),('3355','2013-06-18','16:15:00',1.8),('3355','2013-06-18','16:20:00',1.79),('3355','2013-06-18','16:25:00',1.69),('3355','2013-06-18','16:30:00',1.66),('3355','2013-06-18','16:35:00',1.58),('3355','2013-06-18','16:40:00',1.59),('3355','2013-06-18','16:45:00',1.53),('3355','2013-06-18','16:50:00',1.51),('3355','2013-06-18','16:55:00',1.48),('3355','2013-06-18','17:00:00',1.44),('3355','2013-06-18','17:05:00',1.4),('3355','2013-06-18','17:10:00',1.37),('3355','2013-06-18','17:15:00',1.34),('3355','2013-06-18','17:20:00',1.31),('3355','2013-06-18','17:25:00',1.26),('3355','2013-06-18','17:30:00',1.22),('3355','2013-06-18','17:35:00',1.18),('3355','2013-06-18','17:40:00',1.13),('3355','2013-06-18','17:45:00',1.09),('3355','2013-06-18','17:50:00',1.03),('3355','2013-06-17','08:50:00',1.04),('3355','2013-06-17','08:55:00',1.08),('3355','2013-06-17','09:00:00',1.12),('3355','2013-06-17','09:05:00',1.16),('3355','2013-06-17','09:10:00',1.2),('3355','2013-06-17','09:15:00',1.23),('3355','2013-06-17','09:20:00',1.28),('3355','2013-06-17','09:25:00',1.32),('3355','2013-06-17','09:30:00',1.35),('3355','2013-06-17','09:35:00',1.39),('3355','2013-06-17','09:40:00',1.42),('3355','2013-06-17','09:45:00',1.46),('3355','2013-06-17','09:50:00',1.49),('3355','2013-06-17','09:55:00',1.52),('3355','2013-06-17','10:00:00',1.54),('3355','2013-06-17','10:05:00',1.58),('3355','2013-06-17','10:10:00',1.61),('3355','2013-06-17','10:15:00',1.63),('3355','2013-06-17','10:20:00',1.66),('3355','2013-06-17','10:25:00',1.68),('3355','2013-06-17','10:30:00',1.72),('3355','2013-06-17','10:35:00',1.75),('3355','2013-06-17','10:40:00',1.77),('3355','2013-06-17','10:45:00',1.79),('3355','2013-06-17','10:50:00',1.81),('3355','2013-06-17','10:55:00',1.83),('3355','2013-06-17','11:00:00',1.86),('3355','2013-06-17','11:05:00',1.87),('3355','2013-06-17','11:10:00',1.88),('3355','2013-06-17','11:15:00',1.89),('3355','2013-06-17','11:20:00',1.91),('3355','2013-06-17','11:25:00',1.92),('3355','2013-06-17','11:30:00',1.93),('3355','2013-06-17','11:35:00',1.94),('3355','2013-06-17','11:40:00',1.93),('3355','2013-06-17','11:45:00',1.97),('3355','2013-06-17','11:50:00',1.99),('3355','2013-06-17','11:55:00',2),('3355','2013-06-17','12:00:00',2),('3355','2013-06-17','12:05:00',2),('3355','2013-06-17','12:10:00',2.03),('3355','2013-06-17','12:15:00',2.05),('3355','2013-06-17','12:20:00',2.07),('3355','2013-06-17','12:25:00',2.06),('3355','2013-06-17','12:30:00',2.04),('3355','2013-06-17','12:35:00',2.05),('3355','2013-06-17','12:40:00',2.05),('3355','2013-06-17','12:45:00',2.05),('3355','2013-06-17','12:50:00',2.07),('3355','2013-06-17','12:55:00',2.09),('3355','2013-06-17','13:00:00',2.12),('3355','2013-06-17','13:05:00',2.13),('3355','2013-06-17','13:10:00',2.15),('3355','2013-06-17','13:15:00',2.16),('3355','2013-06-17','13:20:00',2.15),('3355','2013-06-17','13:25:00',2.15),('3355','2013-06-17','13:30:00',2.16),('3355','2013-06-17','13:35:00',2.14),('3355','2013-06-17','13:40:00',2.14),('3355','2013-06-17','13:45:00',2.15),('3355','2013-06-17','13:50:00',2.14),('3355','2013-06-17','13:55:00',2.14),('3355','2013-06-17','14:00:00',2.14),('3355','2013-06-17','14:05:00',2.14),('3355','2013-06-17','14:10:00',2.13),('3355','2013-06-17','14:15:00',2.13),('3355','2013-06-17','14:20:00',2.11),('3355','2013-06-17','14:25:00',2.11),('3355','2013-06-17','14:30:00',2.1),('3355','2013-06-17','14:35:00',2.09),('3355','2013-06-17','14:40:00',2.09),('3355','2013-06-17','14:45:00',2.08),('3355','2013-06-17','14:50:00',2.06),('3355','2013-06-17','14:55:00',2.06),('3355','2013-06-17','15:00:00',2.04),('3355','2013-06-17','15:05:00',2.03),('3355','2013-06-17','15:10:00',2),('3355','2013-06-17','15:15:00',1.98),('3355','2013-06-17','15:20:00',1.97),('3355','2013-06-17','15:25:00',1.95),('3355','2013-06-17','15:30:00',1.93),('3355','2013-06-17','15:35:00',1.91),('3355','2013-06-17','15:40:00',1.89),('3355','2013-06-17','15:45:00',1.87),('3355','2013-06-17','15:50:00',1.84),('3355','2013-06-17','15:55:00',1.82),('3355','2013-06-17','16:00:00',1.8),('3355','2013-06-17','16:05:00',1.77),('3355','2013-06-17','16:10:00',1.75),('3355','2013-06-17','16:15:00',1.73),('3355','2013-06-17','16:20:00',1.7),('3355','2013-06-17','16:25:00',1.67),('3355','2013-06-17','16:30:00',1.63),('3355','2013-06-17','16:35:00',1.6),('3355','2013-06-17','16:40:00',1.57),('3355','2013-06-17','16:45:00',1.54),('3355','2013-06-17','16:50:00',1.51),('3355','2013-06-17','16:55:00',1.49),('3355','2013-06-17','17:00:00',1.46),('3355','2013-06-17','17:05:00',1.42),('3355','2013-06-17','17:10:00',1.38),('3355','2013-06-17','17:15:00',1.34),('3355','2013-06-17','17:20:00',1.31),('3355','2013-06-17','17:25:00',1.28),('3355','2013-06-17','17:30:00',1.25),('3355','2013-06-17','17:35:00',1.21),('3355','2013-06-17','17:40:00',1.17),('3355','2013-06-17','17:45:00',1.12),('3355','2013-06-17','17:50:00',1.08),('3355','2013-06-17','17:55:00',1.03),('3355','2013-06-16','08:50:00',1.03),('3355','2013-06-16','08:55:00',1.09),('3355','2013-06-16','09:00:00',1.14),('3355','2013-06-16','09:05:00',1.18),('3355','2013-06-16','09:10:00',1.23),('3355','2013-06-16','09:15:00',1.28),('3355','2013-06-16','09:20:00',1.31),('3355','2013-06-16','09:25:00',1.34),('3355','2013-06-16','09:30:00',1.37),('3355','2013-06-16','09:35:00',1.4),('3355','2013-06-16','09:40:00',1.43),('3355','2013-06-16','09:45:00',1.47),('3355','2013-06-16','09:50:00',1.51),('3355','2013-06-16','09:55:00',1.53),('3355','2013-06-16','10:00:00',1.56),('3355','2013-06-16','10:05:00',1.6),('3355','2013-06-16','10:10:00',1.61),('3355','2013-06-16','10:15:00',1.64),('3355','2013-06-16','10:20:00',1.67),('3355','2013-06-16','10:25:00',1.72),('3355','2013-06-16','10:30:00',1.75),('3355','2013-06-16','10:35:00',1.79),('3355','2013-06-16','10:40:00',1.8),('3355','2013-06-16','10:45:00',1.82),('3355','2013-06-16','10:50:00',1.83),('3355','2013-06-16','10:55:00',1.86),('3355','2013-06-16','11:00:00',1.89),('3355','2013-06-16','11:05:00',1.89),('3355','2013-06-16','11:10:00',1.92),('3355','2013-06-16','11:15:00',1.95),('3355','2013-06-16','11:20:00',1.97),('3355','2013-06-16','11:25:00',1.99),('3355','2013-06-16','11:30:00',2),('3355','2013-06-16','11:35:00',2.02),('3355','2013-06-16','11:40:00',2.05),('3355','2013-06-16','11:45:00',2.04),('3355','2013-06-16','11:50:00',2.06),('3355','2013-06-16','11:55:00',2.08),('3355','2013-06-16','12:00:00',2.09),('3355','2013-06-16','12:05:00',2.12),('3355','2013-06-16','12:10:00',2.13),('3355','2013-06-16','12:15:00',2.14),('3355','2013-06-16','12:20:00',2.16),('3355','2013-06-16','12:25:00',2.16),('3355','2013-06-16','12:30:00',2.18),('3355','2013-06-16','12:35:00',2.19),('3355','2013-06-16','12:40:00',2.18),('3355','2013-06-16','12:45:00',2.18),('3355','2013-06-16','12:50:00',2.18),('3355','2013-06-16','12:55:00',2.16),('3355','2013-06-16','13:00:00',2.16),('3355','2013-06-16','13:05:00',2.19),('3355','2013-06-16','13:10:00',2.23),('3355','2013-06-16','13:15:00',2.24),('3355','2013-06-16','13:20:00',2.24),('3355','2013-06-16','13:25:00',2.25),('3355','2013-06-16','13:30:00',2.25),('3355','2013-06-16','13:35:00',2.26),('3355','2013-06-16','13:40:00',2.26),('3355','2013-06-16','13:45:00',2.25),('3355','2013-06-16','13:50:00',2.24),('3355','2013-06-16','13:55:00',2.24),('3355','2013-06-16','14:00:00',2.23),('3355','2013-06-16','14:05:00',2.21),('3355','2013-06-16','14:10:00',2.21),('3355','2013-06-16','14:15:00',2.22),('3355','2013-06-16','14:20:00',2.22),('3355','2013-06-16','14:25:00',2.2),('3355','2013-06-16','14:30:00',2.19),('3355','2013-06-16','14:35:00',2.18),('3355','2013-06-16','14:40:00',2.15),('3355','2013-06-16','14:45:00',2.14),('3355','2013-06-16','14:50:00',2.12),('3355','2013-06-16','14:55:00',2.11),('3355','2013-06-16','15:00:00',2.1),('3355','2013-06-16','15:05:00',2.09),('3355','2013-06-16','15:10:00',2.07),('3355','2013-06-16','15:15:00',2.06),('3355','2013-06-16','15:20:00',2.05),('3355','2013-06-16','15:25:00',2.03),('3355','2013-06-16','15:30:00',2.01),('3355','2013-06-16','15:35:00',1.98),('3355','2013-06-16','15:40:00',1.96),('3355','2013-06-16','15:45:00',1.93),('3355','2013-06-16','15:50:00',1.91),('3355','2013-06-16','15:55:00',1.89),('3355','2013-06-16','16:00:00',1.86),('3355','2013-06-16','16:05:00',1.83),('3355','2013-06-16','16:10:00',1.81),('3355','2013-06-16','16:15:00',1.79),('3355','2013-06-16','16:20:00',1.75),('3355','2013-06-16','16:25:00',1.73),('3355','2013-06-16','16:30:00',1.7),('3355','2013-06-16','16:35:00',1.67),('3355','2013-06-16','16:40:00',1.63),('3355','2013-06-16','16:45:00',1.6),('3355','2013-06-16','16:50:00',1.56),('3355','2013-06-16','16:55:00',1.52),('3355','2013-06-16','17:00:00',1.48),('3355','2013-06-16','17:05:00',1.44),('3355','2013-06-16','17:10:00',1.4),('3355','2013-06-16','17:15:00',1.36),('3355','2013-06-16','17:20:00',1.32),('3355','2013-06-16','17:25:00',1.28),('3355','2013-06-16','17:30:00',1.24),('3355','2013-06-16','17:35:00',1.19),('3355','2013-06-16','17:40:00',1.16),('3355','2013-06-16','17:45:00',1.11),('3355','2013-06-16','17:50:00',1.07),('3355','2013-06-16','17:55:00',1.01),('3355','2013-06-15','08:45:00',1.01),('3355','2013-06-15','08:55:00',1.07),('3355','2013-06-15','09:00:00',1.09),('3355','2013-06-15','09:10:00',1.22),('3355','2013-06-15','09:15:00',1.25),('3355','2013-06-15','09:20:00',1.3),('3355','2013-06-15','09:25:00',1.3),('3355','2013-06-15','09:30:00',1.38),('3355','2013-06-15','09:35:00',1.43),('3355','2013-06-15','09:40:00',1.4),('3355','2013-06-15','09:45:00',1.46),('3355','2013-06-15','09:50:00',1.45),('3355','2013-06-15','09:55:00',1.54),('3355','2013-06-15','10:00:00',1.6),('3355','2013-06-15','10:05:00',1.65),('3355','2013-06-15','10:10:00',1.66),('3355','2013-06-15','10:20:00',1.19),('3355','2013-06-15','10:25:00',1.12),('3355','2013-06-15','10:30:00',1.28),('3355','2013-06-15','10:35:00',1.87),('3355','2013-06-15','10:40:00',1.22),('3355','2013-06-15','10:45:00',1.56),('3355','2013-06-15','10:50:00',1.6),('3355','2013-06-15','10:55:00',1.72),('3355','2013-06-15','11:00:00',1.49),('3355','2013-06-15','11:05:00',1.2),('3355','2013-06-15','11:10:00',1.54),('3355','2013-06-15','11:15:00',2.14),('3355','2013-06-15','11:20:00',2.14),('3355','2013-06-15','11:25:00',1.56),('3355','2013-06-15','11:30:00',1.57),('3355','2013-06-15','11:35:00',2.22),('3355','2013-06-15','11:40:00',2.02),('3355','2013-06-15','11:45:00',2.17),('3355','2013-06-15','11:50:00',1.13),('3355','2013-06-15','11:55:00',2.25),('3355','2013-06-15','12:00:00',2.23),('3355','2013-06-15','12:05:00',2.22),('3355','2013-06-15','12:10:00',2.09),('3355','2013-06-15','12:15:00',2.28),('3355','2013-06-15','12:20:00',2.25),('3355','2013-06-15','12:25:00',2.21),('3355','2013-06-15','12:30:00',2.24),('3355','2013-06-15','12:35:00',2.26),('3355','2013-06-15','12:40:00',2.22),('3355','2013-06-15','12:45:00',2.24),('3355','2013-06-15','12:50:00',2.23),('3355','2013-06-15','12:55:00',2.24),('3355','2013-06-15','13:00:00',2.25),('3355','2013-06-15','13:05:00',2.23),('3355','2013-06-15','13:10:00',2.25),('3355','2013-06-15','13:15:00',2.24),('3355','2013-06-15','13:20:00',2.25),('3355','2013-06-15','13:25:00',2.24),('3355','2013-06-15','13:30:00',2.24),('3355','2013-06-15','13:35:00',2.2),('3355','2013-06-15','13:40:00',2.23),('3355','2013-06-15','13:45:00',2.23),('3355','2013-06-15','13:50:00',2.23),('3355','2013-06-15','13:55:00',2.21),('3355','2013-06-15','14:00:00',2.21),('3355','2013-06-15','14:05:00',2.21),('3355','2013-06-15','14:10:00',2.22),('3355','2013-06-15','14:15:00',2.2),('3355','2013-06-15','14:20:00',2.2),('3355','2013-06-15','14:25:00',2.2),('3355','2013-06-15','14:30:00',2.17),('3355','2013-06-15','14:35:00',2.17),('3355','2013-06-15','14:40:00',2.16),('3355','2013-06-15','14:45:00',2.13),('3355','2013-06-15','14:50:00',2.13),('3355','2013-06-15','14:55:00',2.13),('3355','2013-06-15','15:00:00',2.08),('3355','2013-06-15','15:05:00',2.06),('3355','2013-06-15','15:10:00',2.05),('3355','2013-06-15','15:15:00',2.04),('3355','2013-06-15','15:20:00',2.05),('3355','2013-06-15','15:25:00',2.04),('3355','2013-06-15','15:30:00',2.03),('3355','2013-06-15','15:35:00',1.99),('3355','2013-06-15','15:40:00',1.97),('3355','2013-06-15','15:45:00',1.95),('3355','2013-06-15','15:50:00',1.92),('3355','2013-06-15','15:55:00',1.9),('3355','2013-06-15','16:00:00',1.87),('3355','2013-06-15','16:05:00',1.84),('3355','2013-06-15','16:10:00',1.8),('3355','2013-06-15','16:15:00',1.78),('3355','2013-06-15','16:20:00',1.74),('3355','2013-06-15','16:25:00',1.71),('3355','2013-06-15','16:30:00',1.68),('3355','2013-06-15','16:35:00',1.64),('3355','2013-06-15','16:40:00',1.62),('3355','2013-06-15','16:45:00',1.59),('3355','2013-06-15','16:50:00',1.55),('3355','2013-06-15','16:55:00',1.51),('3355','2013-06-15','17:00:00',1.48),('3355','2013-06-15','17:05:00',1.43),('3355','2013-06-15','17:10:00',1.4),('3355','2013-06-15','17:15:00',1.37),('3355','2013-06-15','17:20:00',1.32),('3355','2013-06-15','17:25:00',1.28),('3355','2013-06-15','17:30:00',1.23),('3355','2013-06-15','17:35:00',1.19),('3355','2013-06-15','17:40:00',1.16),('3355','2013-06-15','17:45:00',1.1),('3355','2013-06-15','17:50:00',1.04),('3355','2013-06-14','08:40:00',1.01),('3355','2013-06-14','08:45:00',1.07),('3355','2013-06-14','08:50:00',1.11),('3355','2013-06-14','08:55:00',1.15),('3355','2013-06-14','09:00:00',1.2),('3355','2013-06-14','09:05:00',1.24),('3355','2013-06-14','09:10:00',1.28),('3355','2013-06-14','09:15:00',1.32),('3355','2013-06-14','09:20:00',1.36),('3355','2013-06-14','09:25:00',1.39),('3355','2013-06-14','09:30:00',1.41),('3355','2013-06-14','09:35:00',1.47),('3355','2013-06-14','09:40:00',1.51),('3355','2013-06-14','09:45:00',1.55),('3355','2013-06-14','09:50:00',1.59),('3355','2013-06-14','09:55:00',1.62),('3355','2013-06-14','10:00:00',1.65),('3355','2013-06-14','10:05:00',1.68),('3355','2013-06-14','10:10:00',1.69),('3355','2013-06-14','10:15:00',1.72),('3355','2013-06-14','10:20:00',1.76),('3355','2013-06-14','10:25:00',1.76),('3355','2013-06-14','10:30:00',1.81),('3355','2013-06-14','10:35:00',1.88),('3355','2013-06-14','10:40:00',1.9),('3355','2013-06-14','10:45:00',1.92),('3355','2013-06-14','10:50:00',1.91),('3355','2013-06-14','10:55:00',1.91),('3355','2013-06-14','11:00:00',1.91),('3355','2013-06-14','11:05:00',1.93),('3355','2013-06-14','11:10:00',1.99),('3355','2013-06-14','11:15:00',2.01),('3355','2013-06-14','11:20:00',2.01),('3355','2013-06-14','11:25:00',1.98),('3355','2013-06-14','11:30:00',2.09),('3355','2013-06-14','11:35:00',2.1),('3355','2013-06-14','11:40:00',2.1),('3355','2013-06-14','11:45:00',2.11),('3355','2013-06-14','11:50:00',2.12),('3355','2013-06-14','11:55:00',2.14),('3355','2013-06-14','12:00:00',2.15),('3355','2013-06-14','12:05:00',2.14),('3355','2013-06-14','12:10:00',2.15),('3355','2013-06-14','12:15:00',2.15),('3355','2013-06-14','12:20:00',2.17),('3355','2013-06-14','12:25:00',2.18),('3355','2013-06-14','12:30:00',2.16),('3355','2013-06-14','12:35:00',2.18),('3355','2013-06-14','12:40:00',2.18),('3355','2013-06-14','12:45:00',2.21),('3355','2013-06-14','12:50:00',2.19),('3355','2013-06-14','12:55:00',2.18),('3355','2013-06-14','13:00:00',2.19),('3355','2013-06-14','13:05:00',2.22),('3355','2013-06-14','13:10:00',2.2),('3355','2013-06-14','13:15:00',1.19),('3355','2013-06-14','13:20:00',2.3),('3355','2013-06-14','13:25:00',2.34),('3355','2013-06-14','13:30:00',2.28),('3355','2013-06-14','13:35:00',2.23),('3355','2013-06-14','13:40:00',2.23),('3355','2013-06-14','13:45:00',2.26),('3355','2013-06-14','13:50:00',2.26),('3355','2013-06-14','13:55:00',2.26),('3355','2013-06-14','14:00:00',2.25),('3355','2013-06-14','14:05:00',2.25),('3355','2013-06-14','14:10:00',2.26),('3355','2013-06-14','14:15:00',2.23),('3355','2013-06-14','14:20:00',2.21),('3355','2013-06-14','14:25:00',2.21),('3355','2013-06-14','14:30:00',2.23),('3355','2013-06-14','14:35:00',2.19),('3355','2013-06-14','14:40:00',2.17),('3355','2013-06-14','14:45:00',2.16),('3355','2013-06-14','14:50:00',2.13),('3355','2013-06-14','14:55:00',2.14),('3355','2013-06-14','15:00:00',2.14),('3355','2013-06-14','15:05:00',2.13),('3355','2013-06-14','15:10:00',2.11),('3355','2013-06-14','15:15:00',2.09),('3355','2013-06-14','15:20:00',2.08),('3355','2013-06-14','15:25:00',2.06),('3355','2013-06-14','15:30:00',2.05),('3355','2013-06-14','15:35:00',2.02),('3355','2013-06-14','15:40:00',2),('3355','2013-06-14','15:45:00',1.98),('3355','2013-06-14','15:50:00',1.96),('3355','2013-06-14','15:55:00',1.93),('3355','2013-06-14','16:00:00',1.9),('3355','2013-06-14','16:05:00',1.87),('3355','2013-06-14','16:10:00',1.85),('3355','2013-06-14','16:15:00',1.81),('3355','2013-06-14','16:20:00',1.79),('3355','2013-06-14','16:25:00',1.75),('3355','2013-06-14','16:30:00',1.71),('3355','2013-06-14','16:35:00',1.67),('3355','2013-06-14','16:40:00',1.62),('3355','2013-06-14','16:45:00',1.6),('3355','2013-06-14','16:50:00',1.57),('3355','2013-06-14','16:55:00',1.54),('3355','2013-06-14','17:00:00',1.5),('3355','2013-06-14','17:05:00',1.42),('3355','2013-06-14','17:10:00',1.4),('3355','2013-06-14','17:15:00',1.39),('3355','2013-06-14','17:20:00',1.34),('3355','2013-06-14','17:25:00',1.3),('3355','2013-06-14','17:30:00',1.23),('3355','2013-06-14','17:35:00',1.2),('3355','2013-06-14','17:40:00',1.18),('3355','2013-06-14','17:45:00',1.13),('3355','2013-06-14','17:50:00',1.09),('3355','2013-06-14','17:55:00',1.04),('3355','2013-06-13','08:40:00',1.03),('3355','2013-06-13','08:45:00',1.08),('3355','2013-06-13','08:50:00',1.12),('3355','2013-06-13','08:55:00',1.17),('3355','2013-06-13','09:00:00',1.21),('3355','2013-06-13','09:05:00',1.25),('3355','2013-06-13','09:10:00',1.3),('3355','2013-06-13','09:15:00',1.34),('3355','2013-06-13','09:20:00',1.38),('3355','2013-06-13','09:25:00',1.43),('3355','2013-06-13','09:30:00',1.47),('3355','2013-06-13','09:35:00',1.5),('3355','2013-06-13','09:40:00',1.54),('3355','2013-06-13','09:45:00',1.57),('3355','2013-06-13','09:50:00',1.6),('3355','2013-06-13','09:55:00',1.64),('3355','2013-06-13','10:00:00',1.68),('3355','2013-06-13','10:05:00',1.71),('3355','2013-06-13','10:10:00',1.73),('3355','2013-06-13','10:15:00',1.77),('3355','2013-06-13','10:20:00',1.8),('3355','2013-06-13','10:25:00',1.83),('3355','2013-06-13','10:30:00',1.87),('3355','2013-06-13','10:35:00',1.89),('3355','2013-06-13','10:40:00',1.91),('3355','2013-06-13','10:45:00',1.95),('3355','2013-06-13','10:50:00',1.97),('3355','2013-06-13','10:55:00',2),('3355','2013-06-13','11:00:00',2.01),('3355','2013-06-13','11:05:00',2.04),('3355','2013-06-13','11:10:00',2.06),('3355','2013-06-13','11:15:00',2.08),('3355','2013-06-13','11:20:00',2.1),('3355','2013-06-13','11:25:00',2.12),('3355','2013-06-13','11:30:00',2.14),('3355','2013-06-13','11:35:00',2.17),('3355','2013-06-13','11:40:00',2.19),('3355','2013-06-13','11:45:00',2.21),('3355','2013-06-13','11:50:00',2.21),('3355','2013-06-13','11:55:00',2.21),('3355','2013-06-13','12:00:00',2.23),('3355','2013-06-13','12:05:00',2.26),('3355','2013-06-13','12:10:00',2.25),('3355','2013-06-13','12:15:00',2.27),('3355','2013-06-13','12:20:00',2.28),('3355','2013-06-13','12:25:00',2.3),('3355','2013-06-13','12:30:00',2.31),('3355','2013-06-13','12:35:00',2.32),('3355','2013-06-13','12:40:00',2.32),('3355','2013-06-13','12:45:00',2.32),('3355','2013-06-13','12:50:00',2.32),('3355','2013-06-13','12:55:00',2.32),('3355','2013-06-13','13:00:00',2.31),('3355','2013-06-13','13:05:00',2.33),('3355','2013-06-13','13:10:00',2.31),('3355','2013-06-13','13:15:00',2.31),('3355','2013-06-13','13:20:00',2.18),('3355','2013-06-13','13:25:00',2.31),('3355','2013-06-13','13:30:00',2.3),('3355','2013-06-13','13:35:00',2.3),('3355','2013-06-13','13:40:00',2.3),('3355','2013-06-13','13:45:00',2.3),('3355','2013-06-13','13:50:00',2.29),('3355','2013-06-13','13:55:00',2.29),('3355','2013-06-13','14:00:00',2.28),('3355','2013-06-13','14:05:00',2.28),('3355','2013-06-13','14:10:00',2.26),('3355','2013-06-13','14:15:00',2.27),('3355','2013-06-13','14:20:00',2.24),('3355','2013-06-13','14:25:00',2.27),('3355','2013-06-13','14:30:00',1.77),('3355','2013-06-13','14:35:00',1.95),('3355','2013-06-13','14:40:00',2.26),('3355','2013-06-13','14:45:00',2.23),('3355','2013-06-13','14:50:00',2.17),('3355','2013-06-13','14:55:00',2.15),('3355','2013-06-13','15:00:00',2.15),('3355','2013-06-13','15:05:00',2.13),('3355','2013-06-13','15:10:00',2.11),('3355','2013-06-13','15:15:00',2.09),('3355','2013-06-13','15:20:00',2.07),('3355','2013-06-13','15:25:00',2.04),('3355','2013-06-13','15:30:00',2.03),('3355','2013-06-13','15:35:00',2.03),('3355','2013-06-13','15:40:00',2.01),('3355','2013-06-13','15:45:00',1.98),('3355','2013-06-13','15:50:00',1.95),('3355','2013-06-13','15:55:00',1.93),('3355','2013-06-13','16:00:00',1.89),('3355','2013-06-13','16:05:00',1.86),('3355','2013-06-13','16:10:00',1.83),('3355','2013-06-13','16:15:00',1.8),('3355','2013-06-13','16:20:00',1.77),('3355','2013-06-13','16:25:00',1.73),('3355','2013-06-13','16:30:00',1.71),('3355','2013-06-13','16:35:00',1.67),('3355','2013-06-13','16:40:00',1.63),('3355','2013-06-13','16:45:00',1.6),('3355','2013-06-13','16:50:00',1.55),('3355','2013-06-13','16:55:00',1.5),('3355','2013-06-13','17:00:00',1.47),('3355','2013-06-13','17:05:00',1.43),('3355','2013-06-13','17:10:00',1.4),('3355','2013-06-13','17:15:00',1.38),('3355','2013-06-13','17:20:00',1.34),('3355','2013-06-13','17:25:00',1.3),('3355','2013-06-13','17:30:00',1.26),('3355','2013-06-13','17:35:00',1.22),('3355','2013-06-13','17:40:00',1.17),('3355','2013-06-13','17:45:00',1.13),('3355','2013-06-13','17:50:00',1.09),('3355','2013-06-13','17:55:00',1.04),('3355','2013-06-12','08:35:00',1),('3355','2013-06-12','08:40:00',1.05),('3355','2013-06-12','08:45:00',1.1),('3355','2013-06-12','08:50:00',1.14),('3355','2013-06-12','08:55:00',1.19),('3355','2013-06-12','09:00:00',1.23),('3355','2013-06-12','09:05:00',1.28),('3355','2013-06-12','09:10:00',1.33),('3355','2013-06-12','09:15:00',1.37),('3355','2013-06-12','09:20:00',1.41),('3355','2013-06-12','09:25:00',1.45),('3355','2013-06-12','09:30:00',1.49),('3355','2013-06-12','09:35:00',1.53),('3355','2013-06-12','09:40:00',1.57),('3355','2013-06-12','09:45:00',1.6),('3355','2013-06-12','09:50:00',1.65),('3355','2013-06-12','09:55:00',1.68),('3355','2013-06-12','10:00:00',1.7),('3355','2013-06-12','10:05:00',1.73),('3355','2013-06-12','10:10:00',1.77),('3355','2013-06-12','10:15:00',1.8),('3355','2013-06-12','10:20:00',1.84),('3355','2013-06-12','10:25:00',1.86),('3355','2013-06-12','10:30:00',1.88),('3355','2013-06-12','10:35:00',1.89),('3355','2013-06-12','10:40:00',1.92),('3355','2013-06-12','10:45:00',1.95),('3355','2013-06-12','10:50:00',1.99),('3355','2013-06-12','10:55:00',2.02),('3355','2013-06-12','11:00:00',2.06),('3355','2013-06-12','11:05:00',2.07),('3355','2013-06-12','11:10:00',2.09),('3355','2013-06-12','11:15:00',2.12),('3355','2013-06-12','11:20:00',2.13),('3355','2013-06-12','11:25:00',2.14),('3355','2013-06-12','11:30:00',2.16),('3355','2013-06-12','11:35:00',2.17),('3355','2013-06-12','11:40:00',2.2),('3355','2013-06-12','11:45:00',2.2),('3355','2013-06-12','11:50:00',2.21),('3355','2013-06-12','11:55:00',2.25),('3355','2013-06-12','12:00:00',2.24),('3355','2013-06-12','12:05:00',2.27),('3355','2013-06-12','12:10:00',2.25),('3355','2013-06-12','12:15:00',2.28),('3355','2013-06-12','12:20:00',2.3),('3355','2013-06-12','12:25:00',2.26),('3355','2013-06-12','12:30:00',2.45),('3355','2013-06-12','12:35:00',2.39),('3355','2013-06-12','12:45:00',1.68),('3355','2013-06-12','12:50:00',2.48),('3355','2013-06-12','12:55:00',2.38),('3355','2013-06-12','13:00:00',2.23),('3355','2013-06-12','13:05:00',2.18),('3355','2013-06-12','13:10:00',2.36),('3355','2013-06-12','13:15:00',2.32),('3355','2013-06-12','13:20:00',2.3),('3355','2013-06-12','13:25:00',2.31),('3355','2013-06-12','13:30:00',2.32),('3355','2013-06-12','13:35:00',2.33),('3355','2013-06-12','13:40:00',2.33),('3355','2013-06-12','13:45:00',2.35),('3355','2013-06-12','13:50:00',2.34),('3355','2013-06-12','13:55:00',2.36),('3355','2013-06-12','14:00:00',2.39),('3355','2013-06-12','14:05:00',1.81),('3355','2013-06-12','14:10:00',2.19),('3355','2013-06-12','14:15:00',2.23),('3355','2013-06-12','14:20:00',1.21),('3355','2013-06-12','14:30:00',2.51),('3355','2013-06-12','14:35:00',2.35),('3355','2013-06-12','14:40:00',2.26),('3355','2013-06-12','14:45:00',2.29),('3355','2013-06-12','14:50:00',2.32),('3355','2013-06-12','14:55:00',2.4),('3355','2013-06-12','15:00:00',2.38),('3355','2013-06-12','15:05:00',2.27),('3355','2013-06-12','15:10:00',2.27),('3355','2013-06-12','15:15:00',1.9),('3355','2013-06-12','15:20:00',2.23),('3355','2013-06-12','15:25:00',2.13),('3355','2013-06-12','15:30:00',2.13),('3355','2013-06-12','15:35:00',2.12),('3355','2013-06-12','15:40:00',2.09),('3355','2013-06-12','15:45:00',2.08),('3355','2013-06-12','15:50:00',2.03),('3355','2013-06-12','15:55:00',2.03),('3355','2013-06-12','16:00:00',1.95),('3355','2013-06-12','16:05:00',1.78),('3355','2013-06-12','16:10:00',1.94),('3355','2013-06-12','16:15:00',1.9),('3355','2013-06-12','16:20:00',1.83),('3355','2013-06-12','16:25:00',1.81),('3355','2013-06-12','16:30:00',1.77),('3355','2013-06-12','16:35:00',1.74),('3355','2013-06-12','16:40:00',1.7),('3355','2013-06-12','16:45:00',1.4),('3355','2013-06-12','16:50:00',1.64),('3355','2013-06-12','16:55:00',1.59),('3355','2013-06-12','17:00:00',1.53),('3355','2013-06-12','17:05:00',1.51),('3355','2013-06-12','17:10:00',1.48),('3355','2013-06-12','17:15:00',1.44),('3355','2013-06-12','17:20:00',1.38),('3355','2013-06-12','17:25:00',1.33),('3355','2013-06-12','17:30:00',1.3),('3355','2013-06-12','17:35:00',1.27),('3355','2013-06-12','17:40:00',1.24),('3355','2013-06-12','17:45:00',1.16),('3355','2013-06-12','18:05:00',1.02),('3355','2013-06-11','08:50:00',1.25),('3355','2013-06-11','08:55:00',1.36),('3355','2013-06-11','09:00:00',1),('3355','2013-06-11','09:15:00',1.21),('3355','2013-06-11','09:20:00',1.5),('3355','2013-06-11','09:25:00',1.63),('3355','2013-06-11','09:30:00',1.41),('3355','2013-06-11','09:35:00',1.63),('3355','2013-06-11','09:55:00',1.84),('3355','2013-06-11','10:00:00',1.86),('3355','2013-06-11','10:05:00',1.59),('3355','2013-06-11','10:10:00',1.66),('3355','2013-06-11','10:15:00',1.81),('3355','2013-06-11','10:20:00',1.92),('3355','2013-06-11','10:25:00',1.96),('3355','2013-06-11','10:30:00',1.56),('3355','2013-06-11','10:35:00',2),('3355','2013-06-11','10:40:00',2.05),('3355','2013-06-11','10:45:00',1.88),('3355','2013-06-11','10:50:00',2.07),('3355','2013-06-11','10:55:00',1.54),('3355','2013-06-11','11:00:00',1.18),('3355','2013-06-11','11:05:00',2.28),('3355','2013-06-11','11:10:00',1.05),('3355','2013-06-11','11:15:00',1.58),('3355','2013-06-11','11:20:00',2.26),('3355','2013-06-11','11:25:00',2.24),('3355','2013-06-11','11:30:00',2.27),('3355','2013-06-11','11:35:00',2.22),('3355','2013-06-11','11:40:00',2.25),('3355','2013-06-11','11:45:00',2.26),('3355','2013-06-11','11:50:00',2.3),('3355','2013-06-11','11:55:00',2.32),('3355','2013-06-11','12:00:00',2.34),('3355','2013-06-11','12:05:00',2.4),('3355','2013-06-11','12:10:00',2.37),('3355','2013-06-11','12:15:00',2.35),('3355','2013-06-11','12:20:00',2.37),('3355','2013-06-11','12:25:00',2.37),('3355','2013-06-11','12:30:00',2.38),('3355','2013-06-11','12:35:00',2.37),('3355','2013-06-11','12:40:00',2.4),('3355','2013-06-11','12:45:00',2.41),('3355','2013-06-11','12:50:00',2.42),('3355','2013-06-11','12:55:00',2.44),('3355','2013-06-11','13:00:00',2.43),('3355','2013-06-11','13:05:00',2.45),('3355','2013-06-11','13:10:00',2.45),('3355','2013-06-11','13:15:00',2.23),('3355','2013-06-11','13:20:00',2.46),('3355','2013-06-11','13:25:00',2.45),('3355','2013-06-11','13:30:00',2.45),('3355','2013-06-11','13:35:00',2.46),('3355','2013-06-11','13:40:00',2.47),('3355','2013-06-11','13:45:00',2.46),('3355','2013-06-11','13:50:00',1.75),('3355','2013-06-11','13:55:00',2.4),('3355','2013-06-11','14:00:00',2.46),('3355','2013-06-11','14:05:00',2.44),('3355','2013-06-11','14:10:00',2.4),('3355','2013-06-11','14:15:00',2.38),('3355','2013-06-11','14:20:00',2.36),('3355','2013-06-11','14:25:00',2.36),('3355','2013-06-11','14:30:00',2.37),('3355','2013-06-11','14:35:00',2.36),('3355','2013-06-11','14:40:00',2.33),('3355','2013-06-11','14:45:00',2.32),('3355','2013-06-11','14:50:00',2.29),('3355','2013-06-11','14:55:00',2.28),('3355','2013-06-11','15:00:00',2.27),('3355','2013-06-11','15:05:00',2.26),('3355','2013-06-11','15:10:00',2.24),('3355','2013-06-11','15:15:00',2.21),('3355','2013-06-11','15:20:00',2.2),('3355','2013-06-11','15:25:00',2.16),('3355','2013-06-11','15:30:00',2.15),('3355','2013-06-11','15:35:00',2.16),('3355','2013-06-11','15:40:00',2.15),('3355','2013-06-11','15:45:00',2.06),('3355','2013-06-11','15:50:00',2.07),('3355','2013-06-11','15:55:00',1.99),('3355','2013-06-11','16:00:00',2.03),('3355','2013-06-11','16:05:00',1.99),('3355','2013-06-11','16:10:00',1.96),('3355','2013-06-11','16:15:00',1.93),('3355','2013-06-11','16:20:00',1.89),('3355','2013-06-11','16:25:00',1.85),('3355','2013-06-11','16:30:00',1.82),('3355','2013-06-11','16:35:00',1.79),('3355','2013-06-11','16:40:00',1.8),('3355','2013-06-11','16:45:00',1.87),('3355','2013-06-11','16:50:00',1.88),('3355','2013-06-11','16:55:00',1.82),('3355','2013-06-11','17:00:00',1.7),('3355','2013-06-11','17:05:00',1.29),('3355','2014-04-03','09:40:00',1),('3355','2014-04-03','10:00:00',1.14),('3355','2014-04-03','10:05:00',1.35),('3355','2014-04-03','10:10:00',1.45),('3355','2014-04-03','10:15:00',1.64),('3355','2014-04-03','10:20:00',1.71),('3355','2014-04-03','10:25:00',1.52),('3355','2014-04-03','10:30:00',1.41),('3355','2014-04-03','10:35:00',1.55),('3355','2014-04-03','10:40:00',1.25),('3355','2014-04-03','10:45:00',1.31),('3355','2014-04-03','10:50:00',1.1),('3355','2014-04-03','10:55:00',1.16),('3355','2014-04-03','11:00:00',1.11),('3355','2014-04-03','11:50:00',1.17),('3355','2014-04-03','11:55:00',1.32),('3355','2014-04-03','12:00:00',1.24),('3355','2014-04-03','12:05:00',1.24),('3355','2014-04-03','12:10:00',1.19),('3355','2014-04-03','12:15:00',1.17),('3355','2014-04-03','12:20:00',1.3),('3355','2014-04-03','12:25:00',1.55),('3355','2014-04-03','12:30:00',2.14),('3355','2014-04-03','12:35:00',2.04),('3355','2014-04-03','12:40:00',2.32),('3355','2014-04-03','12:45:00',1.34),('3355','2014-04-03','12:50:00',1.47),('3355','2014-04-03','12:55:00',1.48),('3355','2014-04-03','13:00:00',1.43),('3355','2014-04-03','13:05:00',1.91),('3355','2014-04-03','13:10:00',1.26),('3355','2014-04-03','13:15:00',2.55),('3355','2014-04-03','13:20:00',1.73),('3355','2014-04-03','13:25:00',1.53),('3355','2014-04-03','13:30:00',1.54),('3355','2014-04-03','13:35:00',2.47),('3355','2014-04-03','13:40:00',2.29),('3355','2014-04-03','13:45:00',1.32),('3355','2014-04-03','13:50:00',1.14),('3355','2014-04-03','13:55:00',1.42),('3355','2014-04-03','14:00:00',2.11),('3355','2014-04-03','14:05:00',2.01),('3355','2014-04-03','14:10:00',1.51),('3355','2014-04-03','14:15:00',1.99),('3355','2014-04-03','14:20:00',2.14),('3355','2014-04-03','14:25:00',2.16),('3355','2014-04-03','14:30:00',2.2),('3355','2014-04-03','14:35:00',2.25),('3355','2014-04-03','14:40:00',2.2),('3355','2014-04-03','14:45:00',2.14),('3355','2014-04-03','14:50:00',2.1),('3355','2014-04-03','14:55:00',2.07),('3355','2014-04-03','15:00:00',2.06),('3355','2014-04-03','15:05:00',2.03),('3355','2014-04-03','15:10:00',2.02),('3355','2014-04-03','15:15:00',2.01),('3355','2014-04-03','15:20:00',2),('3355','2014-04-03','15:25:00',2),('3355','2014-04-03','15:30:00',1.97),('3355','2014-04-03','15:35:00',1.94),('3355','2014-04-03','15:40:00',1.91),('3355','2014-04-03','15:45:00',1.9),('3355','2014-04-03','15:50:00',1.89),('3355','2014-04-03','15:55:00',1.88),('3355','2014-04-03','16:00:00',1.86),('3355','2014-04-03','16:05:00',1.82),('3355','2014-04-03','16:10:00',1.82),('3355','2014-04-03','16:15:00',1.75),('3355','2014-04-03','16:20:00',1.73),('3355','2014-04-03','16:25:00',1.68),('3355','2014-04-03','16:30:00',1.64),('3355','2014-04-03','16:35:00',1.6),('3355','2014-04-03','16:40:00',1.56),('3355','2014-04-03','16:45:00',1.46),('3355','2014-04-03','16:50:00',1.12),('3355','2013-06-10','08:20:00',1.01),('3355','2013-06-10','09:35:00',1.76),('3355','2013-06-10','09:40:00',1.13),('3355','2013-06-10','09:45:00',1.72),('3355','2013-06-10','09:50:00',1.19),('3355','2013-06-10','10:00:00',1.2),('3355','2013-06-10','10:05:00',1.44),('3355','2013-06-10','10:10:00',1.66),('3355','2013-06-10','10:15:00',1.8),('3355','2013-06-10','10:20:00',1.51),('3355','2013-06-10','10:25:00',1.59),('3355','2013-06-10','10:55:00',1.25),('3355','2013-06-10','11:00:00',1.5),('3355','2013-06-10','11:05:00',1.02),('3355','2013-06-10','11:10:00',1.17),('3355','2013-06-10','11:15:00',2.13),('3355','2013-06-10','11:20:00',1.57),('3355','2013-06-10','11:25:00',2.3),('3355','2013-06-10','11:30:00',2.34),('3355','2013-06-10','11:35:00',2.53),('3355','2013-06-10','11:40:00',1.7),('3355','2013-06-10','11:45:00',2.16),('3355','2013-06-10','11:50:00',1.18),('3355','2013-06-10','11:55:00',1.23),('3355','2013-06-10','12:00:00',2.56),('3355','2013-06-10','12:05:00',1.36),('3355','2013-06-10','12:10:00',2.37),('3355','2013-06-10','12:15:00',2.43),('3355','2013-06-10','12:20:00',2.42),('3355','2013-06-10','12:25:00',2.39),('3355','2013-06-10','12:30:00',2.28),('3355','2013-06-10','12:35:00',1.89),('3355','2013-06-10','12:40:00',1.77),('3355','2013-06-10','12:45:00',2.03),('3355','2013-06-10','12:50:00',1.74),('3355','2013-06-10','12:55:00',1.09),('3355','2013-06-10','13:00:00',1.21),('3355','2013-06-10','13:05:00',2.57),('3355','2013-06-10','13:10:00',1.65),('3355','2013-06-10','13:15:00',1.63),('3355','2013-06-10','13:20:00',1.82),('3355','2013-06-10','13:25:00',1.44),('3355','2013-06-10','13:30:00',1.47),('3355','2013-06-10','13:35:00',2.31),('3355','2013-06-10','13:40:00',1.94),('3355','2013-06-10','13:45:00',1.49),('3355','2013-06-10','13:50:00',1.39),('3355','2013-06-10','13:55:00',1.8),('3355','2013-06-10','14:00:00',2.64),('3355','2013-06-10','14:05:00',2.46),('3355','2013-06-10','14:10:00',2.47),('3355','2013-06-10','14:15:00',2.34),('3355','2013-06-10','14:20:00',2.37),('3355','2013-06-10','14:25:00',2.41),('3355','2013-06-10','14:30:00',2.37),('3355','2013-06-10','14:35:00',2.37),('3355','2013-06-10','14:40:00',2.08),('3355','2013-06-10','14:45:00',2.39),('3355','2013-06-10','14:50:00',2.33),('3355','2013-06-10','14:55:00',2.3),('3355','2013-06-10','15:00:00',2.29),('3355','2013-06-10','15:05:00',2.27),('3355','2013-06-10','15:10:00',2.24),('3355','2013-06-10','15:15:00',2.22),('3355','2013-06-10','15:20:00',2.21),('3355','2013-06-10','15:25:00',2.18),('3355','2013-06-10','15:30:00',2.17),('3355','2013-06-10','15:35:00',2.16),('3355','2013-06-10','15:40:00',2.14),('3355','2013-06-10','15:45:00',2.12),('3355','2013-06-10','15:50:00',2.09),('3355','2013-06-10','15:55:00',2.06),('3355','2013-06-10','16:00:00',2.03),('3355','2013-06-10','16:05:00',2),('3355','2013-06-10','16:10:00',1.97),('3355','2013-06-10','16:15:00',1.94),('3355','2013-06-10','16:20:00',1.9),('3355','2013-06-10','16:25:00',1.87),('3355','2013-06-10','16:30:00',1.84),('3355','2013-06-10','16:35:00',1.81),('3355','2013-06-10','16:40:00',1.77),('3355','2013-06-10','16:45:00',1.73),('3355','2013-06-10','16:50:00',1.7),('3355','2013-06-10','16:55:00',1.66),('3355','2013-06-10','17:00:00',1.62),('3355','2013-06-10','17:05:00',1.59),('3355','2013-06-10','17:10:00',1.55),('3355','2013-06-10','17:15:00',1.5),('3355','2013-06-10','17:20:00',1.46),('3355','2013-06-10','17:25:00',1.42),('3355','2013-06-10','17:30:00',1.37),('3355','2013-06-10','17:35:00',1.33),('3355','2013-06-10','17:40:00',1.28),('3355','2013-06-10','17:45:00',1.23),('3355','2013-06-10','17:50:00',1.18),('3355','2013-06-10','17:55:00',1.13),('3355','2013-06-10','18:00:00',1.09),('3355','2013-06-10','18:05:00',1.03),('3355','2013-06-09','08:45:00',1.02),('3355','2013-06-09','08:50:00',1.07),('3355','2013-06-09','08:55:00',1.13),('3355','2013-06-09','09:00:00',1.17),('3355','2013-06-09','09:05:00',1.2),('3355','2013-06-09','09:10:00',1.27),('3355','2013-06-09','09:15:00',1.31),('3355','2013-06-09','09:20:00',1.33),('3355','2013-06-09','09:25:00',1.37),('3355','2013-06-09','09:30:00',1.4),('3355','2013-06-09','09:35:00',1.45),('3355','2013-06-09','09:40:00',1.49),('3355','2013-06-09','09:45:00',1.53),('3355','2013-06-09','09:50:00',1.56),('3355','2013-06-09','09:55:00',1.6),('3355','2013-06-09','10:00:00',1.63),('3355','2013-06-09','10:05:00',1.66),('3355','2013-06-09','10:10:00',1.69),('3355','2013-06-09','10:15:00',1.72),('3355','2013-06-09','10:20:00',1.73),('3355','2013-06-09','10:25:00',1.76),('3355','2013-06-09','10:30:00',1.81),('3355','2013-06-09','10:35:00',1.84),('3355','2013-06-09','10:40:00',1.86),('3355','2013-06-09','10:45:00',1.88),('3355','2013-06-09','10:50:00',1.91),('3355','2013-06-09','10:55:00',1.94),('3355','2013-06-09','11:00:00',1.96),('3355','2013-06-09','11:05:00',1.97),('3355','2013-06-09','11:10:00',1.96),('3355','2013-06-09','11:15:00',1.99),('3355','2013-06-09','11:20:00',2.04),('3355','2013-06-09','11:25:00',2.03),('3355','2013-06-09','11:30:00',2.05),('3355','2013-06-09','11:35:00',2.06),('3355','2013-06-09','11:40:00',2.06),('3355','2013-06-09','11:45:00',2.11),('3355','2013-06-09','11:50:00',2.14),('3355','2013-06-09','11:55:00',2.13),('3355','2013-06-09','12:00:00',2.13),('3355','2013-06-09','12:05:00',2.16),('3355','2013-06-09','12:10:00',2.01),('3355','2013-06-09','12:15:00',2.04),('3355','2013-06-09','12:20:00',2.19),('3355','2013-06-09','12:25:00',2.18),('3355','2013-06-09','12:30:00',2.19),('3355','2013-06-09','12:35:00',2.19),('3355','2013-06-09','12:40:00',2.23),('3355','2013-06-09','12:45:00',2.22),('3355','2013-06-09','12:50:00',2.27),('3355','2013-06-09','12:55:00',2.15),('3355','2013-06-09','13:00:00',2.03),('3355','2013-06-09','13:05:00',2.35),('3355','2013-06-09','13:10:00',1.73),('3355','2013-06-09','13:15:00',1.11),('3355','2013-06-09','13:20:00',2.34),('3355','2013-06-09','13:25:00',2.25),('3355','2013-06-09','13:30:00',2.33),('3355','2013-06-09','13:35:00',2.34),('3355','2013-06-09','13:40:00',2.4),('3355','2013-06-09','13:45:00',2.43),('3355','2013-06-09','13:50:00',2.52),('3355','2013-06-09','13:55:00',2.62),('3355','2013-06-09','14:00:00',1.6),('3355','2013-06-09','14:05:00',2.45),('3355','2013-06-09','14:10:00',2.45),('3355','2013-06-09','14:15:00',1.49),('3355','2013-06-09','14:20:00',1.12),('3355','2013-06-09','14:35:00',2.01),('3355','2013-06-09','14:40:00',1.79),('3355','2013-06-09','14:45:00',2.18),('3355','2013-06-09','14:50:00',2.14),('3355','2013-06-09','14:55:00',2.21),('3355','2013-06-09','15:00:00',2.2),('3355','2013-06-09','15:05:00',2.1),('3355','2013-06-09','15:10:00',2.13),('3355','2013-06-09','15:15:00',2.04),('3355','2013-06-09','15:20:00',2.05),('3355','2013-06-09','15:25:00',2.08),('3355','2013-06-09','15:30:00',1.92),('3355','2013-06-09','15:35:00',2),('3355','2013-06-09','15:40:00',1.64),('3355','2013-06-09','15:45:00',1.69),('3355','2013-06-09','15:50:00',1.82),('3355','2013-06-09','15:55:00',2.03),('3355','2013-06-09','16:00:00',1.35),('3355','2013-06-09','16:05:00',1.77),('3355','2013-06-09','16:10:00',1.72),('3355','2013-06-09','16:15:00',1.03),('3355','2013-06-09','16:25:00',1.17),('3355','2013-06-08','08:40:00',1.01),('3355','2013-06-08','08:45:00',1.05),('3355','2013-06-08','08:50:00',1.1),('3355','2013-06-08','08:55:00',1.14),('3355','2013-06-08','09:00:00',1.19),('3355','2013-06-08','09:05:00',1.23),('3355','2013-06-08','09:10:00',1.25),('3355','2013-06-08','09:15:00',1.29),('3355','2013-06-08','09:20:00',1.35),('3355','2013-06-08','09:25:00',1.4),('3355','2013-06-08','09:30:00',1.44),('3355','2013-06-08','09:35:00',1.46),('3355','2013-06-08','09:40:00',1.48),('3355','2013-06-08','09:45:00',1.52),('3355','2013-06-08','09:50:00',1.52),('3355','2013-06-08','09:55:00',1.58),('3355','2013-06-08','10:00:00',1.65),('3355','2013-06-08','10:05:00',1.68),('3355','2013-06-08','10:10:00',1.29),('3355','2013-06-08','10:15:00',1.6),('3355','2013-06-08','10:20:00',1.74),('3355','2013-06-08','10:25:00',1.81),('3355','2013-06-08','10:30:00',1.87),('3355','2013-06-08','10:35:00',1.87),('3355','2013-06-08','10:40:00',1.91),('3355','2013-06-08','10:45:00',1.95),('3355','2013-06-08','10:50:00',1.96),('3355','2013-06-08','11:00:00',1.18),('3355','2013-06-08','11:10:00',2.21),('3355','2013-06-08','11:15:00',1.93),('3355','2013-06-08','11:20:00',2.28),('3355','2013-06-08','11:25:00',2.31),('3355','2013-06-08','11:30:00',2.29),('3355','2013-06-08','11:35:00',2.08),('3355','2013-06-08','11:40:00',2.3),('3355','2013-06-08','11:45:00',2.21),('3355','2013-06-08','11:50:00',2.28),('3355','2013-06-08','11:55:00',2.33),('3355','2013-06-08','12:00:00',1.4),('3355','2013-06-08','12:05:00',1.13),('3355','2013-06-08','12:15:00',1.43),('3355','2013-06-08','12:20:00',2.37),('3355','2013-06-08','12:35:00',1.62),('3355','2013-06-08','12:40:00',2.42),('3355','2013-06-08','12:45:00',2.41),('3355','2013-06-08','12:55:00',1.92),('3355','2013-06-08','13:00:00',2.46),('3355','2013-06-08','13:05:00',2.46),('3355','2013-06-08','13:10:00',2.28),('3355','2013-06-08','13:15:00',2.43),('3355','2013-06-08','13:20:00',1.78),('3355','2013-06-08','13:25:00',2.46),('3355','2013-06-08','13:30:00',2.47),('3355','2013-06-08','13:35:00',2.43),('3355','2013-06-08','13:40:00',2.41),('3355','2013-06-08','13:45:00',2.39),('3355','2013-06-08','13:50:00',2.38),('3355','2013-06-08','13:55:00',2.38),('3355','2013-06-08','14:00:00',2.35),('3355','2013-06-08','14:05:00',2.34),('3355','2013-06-08','14:10:00',2.34),('3355','2013-06-08','14:15:00',2.34),('3355','2013-06-08','14:20:00',2.33),('3355','2013-06-08','14:25:00',2.32),('3355','2013-06-08','14:30:00',2.31),('3355','2013-06-08','14:35:00',2.28),('3355','2013-06-08','14:40:00',2.28),('3355','2013-06-08','14:45:00',2.28),('3355','2013-06-08','14:50:00',2.29),('3355','2013-06-08','14:55:00',2.27),('3355','2013-06-08','15:00:00',2.26),('3355','2013-06-08','15:05:00',2.17),('3355','2013-06-08','15:10:00',2.05),('3355','2013-06-08','15:15:00',2.09),('3355','2013-06-08','15:20:00',2.19),('3355','2013-06-08','15:25:00',2.06),('3355','2013-06-08','15:30:00',2.08),('3355','2013-06-08','15:35:00',2.19),('3355','2013-06-08','15:40:00',2.11),('3355','2013-06-08','15:45:00',2.16),('3355','2013-06-08','15:50:00',2.11),('3355','2013-06-08','15:55:00',2),('3355','2013-06-08','16:00:00',2.01),('3355','2013-06-08','16:05:00',1.99),('3355','2013-06-08','16:10:00',1.95),('3355','2013-06-08','16:15:00',1.97),('3355','2013-06-08','16:20:00',1.93),('3355','2013-06-08','16:25:00',1.85),('3355','2013-06-08','16:30:00',1.76),('3355','2013-06-08','16:35:00',1.72),('3355','2013-06-08','16:40:00',1.7),('3355','2013-06-08','16:45:00',1.66),('3355','2013-06-08','16:50:00',1.43),('3355','2013-06-08','16:55:00',1.42),('3355','2013-06-08','17:00:00',1.55),('3355','2013-06-08','17:05:00',1.29),('3355','2013-06-08','17:10:00',1.59),('3355','2013-06-08','17:15:00',1.59),('3355','2013-06-08','17:20:00',1.49),('3355','2013-06-08','17:25:00',1.39),('3355','2013-06-08','17:40:00',1.05),('3355','2013-06-08','17:45:00',1.22),('3355','2013-06-08','17:50:00',1.08),('3355','2013-06-08','17:55:00',1.16),('3355','2013-06-07','08:35:00',1.01),('3355','2013-06-07','08:40:00',1.06),('3355','2013-06-07','08:45:00',1.11),('3355','2013-06-07','08:50:00',1.16),('3355','2013-06-07','08:55:00',1.21),('3355','2013-06-07','09:00:00',1.25),('3355','2013-06-07','09:05:00',1.29),('3355','2013-06-07','09:10:00',1.34),('3355','2013-06-07','09:15:00',1.38),('3355','2013-06-07','09:20:00',1.42),('3355','2013-06-07','09:25:00',1.47),('3355','2013-06-07','09:30:00',1.51),('3355','2013-06-07','09:35:00',1.55),('3355','2013-06-07','09:40:00',1.59),('3355','2013-06-07','09:45:00',1.64),('3355','2013-06-07','09:50:00',1.67),('3355','2013-06-07','09:55:00',1.71),('3355','2013-06-07','10:00:00',1.74),('3355','2013-06-07','10:05:00',1.77),('3355','2013-06-07','10:10:00',1.8),('3355','2013-06-07','10:15:00',1.83),('3355','2013-06-07','10:20:00',1.86),('3355','2013-06-07','10:25:00',1.9),('3355','2013-06-07','10:30:00',1.93),('3355','2013-06-07','10:35:00',1.95),('3355','2013-06-07','10:40:00',1.98),('3355','2013-06-07','10:45:00',2),('3355','2013-06-07','10:50:00',2.02),('3355','2013-06-07','10:55:00',2.04),('3355','2013-06-07','11:00:00',2.07),('3355','2013-06-07','11:05:00',2.1),('3355','2013-06-07','11:10:00',2.12),('3355','2013-06-07','11:15:00',2.13),('3355','2013-06-07','11:20:00',2.14),('3355','2013-06-07','11:25:00',2.16),('3355','2013-06-07','11:30:00',2.2),('3355','2013-06-07','11:35:00',2.21),('3355','2013-06-07','11:40:00',2.22),('3355','2013-06-07','11:45:00',2.23),('3355','2013-06-07','11:50:00',2.25),('3355','2013-06-07','11:55:00',2.26),('3355','2013-06-07','12:00:00',2.26),('3355','2013-06-07','12:05:00',2.28),('3355','2013-06-07','12:10:00',2.29),('3355','2013-06-07','12:15:00',2.31),('3355','2013-06-07','12:20:00',2.31),('3355','2013-06-07','12:25:00',2.3),('3355','2013-06-07','12:30:00',2.31),('3355','2013-06-07','12:35:00',2.3),('3355','2013-06-07','12:40:00',2.32),('3355','2013-06-07','12:45:00',2.34),('3355','2013-06-07','12:50:00',2.34),('3355','2013-06-07','12:55:00',2.34),('3355','2013-06-07','13:00:00',2.36),('3355','2013-06-07','13:05:00',2.34),('3355','2013-06-07','13:10:00',2.34),('3355','2013-06-07','13:15:00',2.34),('3355','2013-06-07','13:20:00',2.34),('3355','2013-06-07','13:25:00',2.34),('3355','2013-06-07','13:30:00',2.34),('3355','2013-06-07','13:35:00',2.33),('3355','2013-06-07','13:40:00',2.32),('3355','2013-06-07','13:45:00',2.3),('3355','2013-06-07','13:50:00',2.3),('3355','2013-06-07','13:55:00',2.3),('3355','2013-06-07','14:00:00',2.29),('3355','2013-06-07','14:05:00',2.27),('3355','2013-06-07','14:10:00',2.26),('3355','2013-06-07','14:15:00',2.26),('3355','2013-06-07','14:20:00',2.23),('3355','2013-06-07','14:25:00',2.21),('3355','2013-06-07','14:30:00',2.2),('3355','2013-06-07','14:35:00',2.19),('3355','2013-06-07','14:40:00',2.19),('3355','2013-06-07','14:45:00',2.19),('3355','2013-06-07','14:50:00',2.18),('3355','2013-06-07','14:55:00',2.17),('3355','2013-06-07','15:00:00',2.16),('3355','2013-06-07','15:05:00',2.17),('3355','2013-06-07','15:10:00',2.17),('3355','2013-06-07','15:15:00',2.13),('3355','2013-06-07','15:20:00',2.1),('3355','2013-06-07','15:25:00',2.12),('3355','2013-06-07','15:30:00',2.11),('3355','2013-06-07','15:35:00',2.08),('3355','2013-06-07','15:40:00',2.04),('3355','2013-06-07','15:45:00',2.02),('3355','2013-06-07','15:50:00',1.99),('3355','2013-06-07','15:55:00',1.96),('3355','2013-06-07','16:00:00',1.94),('3355','2013-06-07','16:05:00',1.9),('3355','2013-06-07','16:10:00',1.83),('3355','2013-06-07','16:15:00',1.75),('3355','2013-06-07','16:20:00',1.74),('3355','2013-06-07','16:25:00',1.75),('3355','2013-06-07','16:30:00',1.75),('3355','2013-06-07','16:35:00',1.72),('3355','2013-06-07','16:40:00',1.69),('3355','2013-06-07','16:45:00',1.66),('3355','2013-06-07','16:50:00',1.62),('3355','2013-06-07','16:55:00',1.59),('3355','2013-06-07','17:00:00',1.54),('3355','2013-06-07','17:05:00',1.5),('3355','2013-06-07','17:10:00',1.44),('3355','2013-06-07','17:15:00',1.39),('3355','2013-06-07','17:20:00',1.32),('3355','2013-06-07','17:25:00',1.3),('3355','2013-06-07','17:30:00',1.26),('3355','2013-06-07','17:35:00',1.23),('3355','2013-06-07','17:40:00',1.19),('3355','2013-06-07','17:45:00',1.19),('3355','2013-06-07','17:50:00',1.14),('3355','2013-06-07','17:55:00',1.07),('3355','2013-06-07','18:00:00',1.01),('3355','2013-06-06','08:35:00',1),('3355','2013-06-06','08:40:00',1.04),('3355','2013-06-06','08:45:00',1.08),('3355','2013-06-06','08:50:00',1.13),('3355','2013-06-06','08:55:00',1.19),('3355','2013-06-06','09:00:00',1.23),('3355','2013-06-06','09:05:00',1.26),('3355','2013-06-06','09:10:00',1.31),('3355','2013-06-06','09:15:00',1.36),('3355','2013-06-06','09:20:00',1.41),('3355','2013-06-06','09:25:00',1.43),('3355','2013-06-06','09:30:00',1.46),('3355','2013-06-06','09:35:00',1.51),('3355','2013-06-06','09:40:00',1.19),('3355','2013-06-06','09:45:00',1.56),('3355','2013-06-06','09:50:00',1.63),('3355','2013-06-06','09:55:00',1.69),('3355','2013-06-06','10:00:00',1.69),('3355','2013-06-06','10:05:00',1.73),('3355','2013-06-06','10:10:00',1.77),('3355','2013-06-06','10:15:00',1.8),('3355','2013-06-06','10:20:00',1.83),('3355','2013-06-06','10:25:00',1.87),('3355','2013-06-06','10:30:00',1.88),('3355','2013-06-06','10:35:00',1.87),('3355','2013-06-06','10:40:00',1.93),('3355','2013-06-06','10:45:00',1.97),('3355','2013-06-06','10:50:00',2),('3355','2013-06-06','10:55:00',2.03),('3355','2013-06-06','11:00:00',2.06),('3355','2013-06-06','11:05:00',2.08),('3355','2013-06-06','11:10:00',2.09),('3355','2013-06-06','11:15:00',2.12),('3355','2013-06-06','11:20:00',2.1),('3355','2013-06-06','11:25:00',2.13),('3355','2013-06-06','11:30:00',2.16),('3355','2013-06-06','11:35:00',2.16),('3355','2013-06-06','11:40:00',2.19),('3355','2013-06-06','11:45:00',2.17),('3355','2013-06-06','11:50:00',2.16),('3355','2013-06-06','11:55:00',2.13),('3355','2013-06-06','12:00:00',2.19),('3355','2013-06-06','12:05:00',1.9),('3355','2013-06-06','12:10:00',2.21),('3355','2013-06-06','12:15:00',2.25),('3355','2013-06-06','12:20:00',2.23),('3355','2013-06-06','12:25:00',2.27),('3355','2013-06-06','12:30:00',2.27),('3355','2013-06-06','12:35:00',2.26),('3355','2013-06-06','12:40:00',2.25),('3355','2013-06-06','12:45:00',2.23),('3355','2013-06-06','12:50:00',2.22),('3355','2013-06-06','12:55:00',2.32),('3355','2013-06-06','13:00:00',2.35),('3355','2013-06-06','13:05:00',2.31),('3355','2013-06-06','13:10:00',2.36),('3355','2013-06-06','13:15:00',2.38),('3355','2013-06-06','13:20:00',2.41),('3355','2013-06-06','13:25:00',2.39),('3355','2013-06-06','13:30:00',2.38),('3355','2013-06-06','13:35:00',2.35),('3355','2013-06-06','13:40:00',2.35),('3355','2013-06-06','13:45:00',2.21),('3355','2013-06-06','13:50:00',2.37),('3355','2013-06-06','13:55:00',2.35),('3355','2013-06-06','14:00:00',2.34),('3355','2013-06-06','14:05:00',2.32),('3355','2013-06-06','14:10:00',2.22),('3355','2013-06-06','14:15:00',2.35),('3355','2013-06-06','14:20:00',1.9),('3355','2013-06-06','14:25:00',1.02),('3355','2013-06-06','14:30:00',2.34),('3355','2013-06-06','14:35:00',1.04),('3355','2013-06-06','14:40:00',1.5),('3355','2013-06-06','14:45:00',1.74),('3355','2013-06-06','14:50:00',1.67),('3355','2013-06-06','14:55:00',2.31),('3355','2013-06-06','15:00:00',2.23),('3355','2013-06-06','15:05:00',2.26),('3355','2013-06-06','15:10:00',1.98),('3355','2013-06-06','15:15:00',2.22),('3355','2013-06-06','15:20:00',2.22),('3355','2013-06-06','15:25:00',2.14),('3355','2013-06-06','15:30:00',1.91),('3355','2013-06-06','15:35:00',2.09),('3355','2013-06-06','15:40:00',2.07),('3355','2013-06-06','15:45:00',2.07),('3355','2013-06-06','15:50:00',1.96),('3355','2013-06-06','15:55:00',1.92),('3355','2013-06-06','16:00:00',1.75),('3355','2013-06-06','16:05:00',1.52),('3355','2013-06-06','16:10:00',1.84),('3355','2013-06-06','16:15:00',1.8),('3355','2013-06-06','16:20:00',1.74),('3355','2013-06-06','16:25:00',1.75),('3355','2013-06-06','16:30:00',1.76),('3355','2013-06-06','16:35:00',1.74),('3355','2013-06-06','16:40:00',1.69),('3355','2013-06-06','16:45:00',1.59),('3355','2013-06-06','16:50:00',1.55),('3355','2013-06-06','16:55:00',1.54),('3355','2013-06-06','17:00:00',1.48),('3355','2013-06-06','17:05:00',1.44),('3355','2013-06-06','17:10:00',1.4),('3355','2013-06-06','17:15:00',1.38),('3355','2013-06-06','17:20:00',1.33),('3355','2013-06-06','17:25:00',1.27),('3355','2013-06-06','17:30:00',1.24),('3355','2013-06-06','17:35:00',1.2),('3355','2013-06-06','17:40:00',1.15),('3355','2013-06-06','17:45:00',1.1),('3355','2013-06-06','17:50:00',1.05),('3355','2013-06-05','08:40:00',1.03),('3355','2013-06-05','08:45:00',1.1),('3355','2013-06-05','08:50:00',1.13),('3355','2013-06-05','08:55:00',1.18),('3355','2013-06-05','09:00:00',1.23),('3355','2013-06-05','09:05:00',1.3),('3355','2013-06-05','09:10:00',1.38),('3355','2013-06-05','09:15:00',1.42),('3355','2013-06-05','09:20:00',1.47),('3355','2013-06-05','09:25:00',1.57),('3355','2013-06-05','09:30:00',1.59),('3355','2013-06-05','09:35:00',1.77),('3355','2013-06-05','09:40:00',1.88),('3355','2013-06-05','09:45:00',1.89),('3355','2013-06-05','09:50:00',1.02),('3355','2013-06-05','09:55:00',1),('3355','2013-06-05','10:00:00',1.08),('3355','2013-06-05','10:05:00',2.07),('3355','2013-06-05','10:10:00',2.07),('3355','2013-06-05','10:15:00',2.07),('3355','2013-06-05','10:45:00',2.03),('3355','2013-06-05','10:55:00',1.13),('3355','2013-06-05','11:00:00',2.19),('3355','2013-06-05','11:05:00',1.29),('3355','2013-06-05','11:40:00',1.28),('3355','2013-06-05','11:45:00',1.17),('3355','2013-06-05','11:50:00',1.32),('3355','2013-06-05','11:55:00',2.34),('3355','2013-06-05','12:00:00',2.52),('3355','2013-06-05','12:05:00',1.82),('3355','2013-06-05','12:10:00',2.57),('3355','2013-06-05','12:15:00',2.61),('3355','2013-06-05','12:20:00',2.69),('3355','2013-06-05','12:25:00',2.63),('3355','2013-06-05','12:30:00',2.21),('3355','2013-06-05','12:35:00',1.6),('3355','2013-06-05','12:40:00',2.04),('3355','2013-06-05','12:45:00',2.73),('3355','2013-06-05','12:50:00',1.91),('3355','2013-06-05','13:00:00',1.72),('3355','2013-06-05','13:05:00',2.81),('3355','2013-06-05','13:10:00',1.68),('3355','2013-06-05','13:15:00',1.06),('3355','2013-06-05','13:20:00',1.38),('3355','2013-06-05','13:25:00',2.15),('3355','2013-06-05','13:30:00',2.3),('3355','2013-06-05','13:35:00',2.81),('3355','2013-06-05','13:40:00',2.66),('3355','2013-06-05','13:45:00',2.6),('3355','2013-06-05','13:50:00',2.51),('3355','2013-06-05','13:55:00',2.5),('3355','2013-06-05','14:00:00',2.46),('3355','2013-06-05','14:05:00',2.38),('3355','2013-06-05','14:10:00',2.37),('3355','2013-06-05','14:15:00',2.4),('3355','2013-06-05','14:20:00',2.4),('3355','2013-06-05','14:25:00',2.34),('3355','2013-06-05','14:30:00',2.37),('3355','2013-06-05','14:35:00',2.36),('3355','2013-06-05','14:40:00',2.35),('3355','2013-06-05','14:45:00',2.36),('3355','2013-06-05','14:50:00',2.35),('3355','2013-06-05','14:55:00',2.34),('3355','2013-06-05','15:00:00',2.28),('3355','2013-06-05','15:05:00',2.23),('3355','2013-06-05','15:10:00',2.22),('3355','2013-06-05','15:15:00',2.21),('3355','2013-06-05','15:20:00',2.19),('3355','2013-06-05','15:25:00',2.18),('3355','2013-06-05','15:30:00',2.19),('3355','2013-06-05','15:35:00',2.22),('3355','2013-06-05','15:40:00',2.2),('3355','2013-06-05','15:45:00',2.07),('3355','2013-06-05','15:50:00',2.09),('3355','2013-06-05','15:55:00',2.06),('3355','2013-06-05','16:00:00',2.05),('3355','2013-06-05','16:05:00',2.02),('3355','2013-06-05','16:10:00',1.96),('3355','2013-06-05','16:15:00',1.94),('3355','2013-06-05','16:20:00',1.9),('3355','2013-06-05','16:25:00',1.85),('3355','2013-06-05','16:30:00',1.84),('3355','2013-06-05','16:35:00',1.78),('3355','2013-06-05','16:40:00',1.75),('3355','2013-06-05','16:45:00',1.71),('3355','2013-06-05','16:50:00',1.68),('3355','2013-06-05','16:55:00',1.64),('3355','2013-06-05','17:00:00',1.6),('3355','2013-06-05','17:05:00',1.22),('3355','2013-06-05','17:10:00',1.53),('3355','2013-06-05','17:30:00',1.31),('3355','2013-06-05','17:35:00',1.32),('3355','2013-06-05','17:45:00',1.16),('3355','2013-06-05','17:50:00',1.11),('3355','2013-06-05','17:55:00',1.04),('3355','2013-06-04','08:10:00',1),('3355','2013-06-04','08:15:00',1.04),('3355','2013-06-04','08:20:00',1.07),('3355','2013-06-04','08:25:00',1.07),('3355','2013-06-04','08:35:00',1.28),('3355','2013-06-04','08:40:00',1.05),('3355','2013-06-04','08:45:00',1.05),('3355','2013-06-04','09:10:00',1.14),('3355','2013-06-04','09:15:00',1.3),('3355','2013-06-04','09:20:00',1.66),('3355','2013-06-04','09:25:00',1.72),('3355','2013-06-04','09:30:00',1.54),('3355','2013-06-04','09:35:00',1.36),('3355','2013-06-04','10:00:00',1.02),('3355','2013-06-04','10:05:00',1.25),('3355','2013-06-04','10:10:00',1.47),('3355','2013-06-04','10:15:00',1.51),('3355','2013-06-04','10:20:00',1.01),('3355','2013-06-04','10:45:00',1.11),('3355','2013-06-04','10:50:00',1.51),('3355','2013-06-04','10:55:00',1.81),('3355','2013-06-04','11:00:00',1.21),('3355','2013-06-04','11:05:00',1.41),('3355','2013-06-04','11:10:00',1.67),('3355','2013-06-04','11:15:00',1.77),('3355','2013-06-04','11:20:00',1.15),('3355','2013-06-04','11:25:00',1.48),('3355','2013-06-04','11:30:00',1.88),('3355','2013-06-04','11:35:00',1.65),('3355','2013-06-04','11:40:00',1.59),('3355','2013-06-04','11:45:00',2.12),('3355','2013-06-04','11:50:00',2.5),('3355','2013-06-04','11:55:00',2.4),('3355','2013-06-04','12:00:00',2.1),('3355','2013-06-04','12:05:00',1.79),('3355','2013-06-04','12:10:00',1.39),('3355','2013-06-04','12:15:00',1.51),('3355','2013-06-04','12:20:00',1.23),('3355','2013-06-04','12:25:00',1.15),('3355','2013-06-04','12:30:00',1.23),('3355','2013-06-04','12:35:00',2.17),('3355','2013-06-04','12:40:00',1.36),('3355','2013-06-04','12:45:00',1.64),('3355','2013-06-04','12:50:00',1.73),('3355','2013-06-04','12:55:00',1.11),('3355','2013-06-04','13:00:00',1.27),('3355','2013-06-04','13:05:00',1.23),('3355','2013-06-04','13:35:00',1.79),('3355','2013-06-04','13:40:00',1.62),('3355','2013-06-04','13:45:00',1.91),('3355','2013-06-04','13:50:00',2.83),('3355','2013-06-04','13:55:00',1.97),('3355','2013-06-04','14:05:00',1.63),('3355','2013-06-04','14:10:00',2.8),('3355','2013-06-04','14:15:00',2.55),('3355','2013-06-04','14:20:00',1.94),('3355','2013-06-04','14:25:00',1.54),('3355','2013-06-04','14:40:00',1.5),('3355','2013-06-04','14:55:00',1.63),('3355','2013-06-04','15:00:00',2.89),('3355','2013-06-04','15:05:00',2.79),('3355','2013-06-04','15:10:00',1.12),('3355','2013-06-03','08:35:00',1.01),('3355','2013-06-03','08:40:00',1.06),('3355','2013-06-03','08:45:00',1.09),('3355','2013-06-03','08:50:00',1.15),('3355','2013-06-03','08:55:00',1.19),('3355','2013-06-03','09:00:00',1.23),('3355','2013-06-03','09:05:00',1.21),('3355','2013-06-03','09:10:00',1.29),('3355','2013-06-03','09:15:00',1.51),('3355','2013-06-03','09:20:00',1.25),('3355','2013-06-03','09:25:00',1.33),('3355','2013-06-03','09:30:00',1.15),('3355','2013-06-03','09:40:00',1.21),('3355','2013-06-03','09:45:00',1.42),('3355','2013-06-03','09:50:00',1.65),('3355','2013-06-03','09:55:00',1.7),('3355','2013-06-03','10:00:00',1.83),('3355','2013-06-03','10:05:00',2.12),('3355','2013-06-03','10:10:00',1.55),('3355','2013-06-03','10:15:00',1.15),('3355','2013-06-03','10:20:00',1.6),('3355','2013-06-03','10:25:00',1.17),('3355','2013-06-03','10:50:00',1.01),('3355','2013-06-03','10:55:00',1.11),('3355','2013-06-03','11:00:00',1.03),('3355','2013-06-03','11:05:00',1.22),('3355','2013-06-03','11:45:00',1.01),('3355','2013-06-03','11:55:00',1.15),('3355','2013-06-03','12:00:00',1.44),('3355','2013-06-03','12:05:00',1.96),('3355','2013-06-03','12:10:00',1.01),('3355','2013-06-03','12:30:00',1.08),('3355','2013-06-03','12:35:00',2.25),('3355','2013-06-03','12:40:00',1.83),('3355','2013-06-03','12:45:00',1.26),('3355','2013-06-03','12:50:00',1.24),('3355','2013-06-03','12:55:00',1.45),('3355','2013-06-03','13:00:00',1.07),('3355','2013-06-03','13:05:00',1),('3355','2013-06-03','13:10:00',1.09),('3355','2013-06-03','13:15:00',2.09),('3355','2013-06-03','13:20:00',2.79),('3355','2013-06-03','13:25:00',1.64),('3355','2013-06-03','13:30:00',2.29),('3355','2013-06-03','13:35:00',2.61),('3355','2013-06-03','13:40:00',1.95),('3355','2013-06-03','13:45:00',1.13),('3355','2013-06-03','13:50:00',2.15),('3355','2013-06-03','13:55:00',1.69),('3355','2013-06-03','14:00:00',2.46),('3355','2013-06-03','14:05:00',1.67),('3355','2013-06-03','14:10:00',1.17),('3355','2013-06-03','14:15:00',1.64),('3355','2013-06-03','14:20:00',1.05),('3355','2013-06-03','14:25:00',2.05),('3355','2013-06-03','14:30:00',2.63),('3355','2013-06-03','14:35:00',2.57),('3355','2013-06-03','14:40:00',1.65),('3355','2013-06-03','14:45:00',1.87),('3355','2013-06-03','14:50:00',1.56),('3355','2013-06-03','14:55:00',2.28),('3355','2013-06-03','15:00:00',2.07),('3355','2013-06-03','15:05:00',1.7),('3355','2013-06-03','15:10:00',2.31),('3355','2013-06-03','15:15:00',1.96),('3355','2013-06-03','15:20:00',1.8),('3355','2013-06-03','15:25:00',2.25),('3355','2013-06-03','15:30:00',2.19),('3355','2013-06-03','15:35:00',2.15),('3355','2013-06-03','15:40:00',2.12),('3355','2013-06-03','15:45:00',2.09),('3355','2013-06-03','15:50:00',2.08),('3355','2013-06-03','15:55:00',2.04),('3355','2013-06-03','16:00:00',2),('3355','2013-06-03','16:05:00',2),('3355','2013-06-03','16:10:00',1.98),('3355','2013-06-03','16:15:00',1.93),('3355','2013-06-03','16:20:00',1.84),('3355','2013-06-03','16:25:00',1.89),('3355','2013-06-03','16:30:00',1.91),('3355','2013-06-03','16:35:00',1.79),('3355','2013-06-03','16:40:00',1.8),('3355','2013-06-03','16:45:00',1.56),('3355','2013-06-03','16:50:00',1.2),('3355','2013-06-03','16:55:00',1.02),('3355','2013-06-03','17:00:00',1.19),('3355','2013-06-03','17:05:00',1.5),('3355','2013-06-03','17:10:00',1.44),('3355','2013-06-03','17:15:00',1.45),('3355','2013-06-03','17:20:00',1.24),('3355','2013-06-02','09:25:00',1.72),('3355','2013-06-02','09:30:00',1.64),('3355','2013-06-02','09:35:00',1.63),('3355','2013-06-02','09:40:00',1.63),('3355','2013-06-02','09:45:00',1.65),('3355','2013-06-02','09:50:00',1.69),('3355','2013-06-02','09:55:00',1.72),('3355','2013-06-02','10:00:00',1.77),('3355','2013-06-02','10:05:00',1.8),('3355','2013-06-02','10:10:00',1.84),('3355','2013-06-02','10:15:00',1.87),('3355','2013-06-02','10:20:00',1.9),('3355','2013-06-02','10:25:00',1.93),('3355','2013-06-02','10:30:00',2),('3355','2013-06-02','10:35:00',2.14),('3355','2013-06-02','10:40:00',2.17),('3355','2013-06-02','10:45:00',2.03),('3355','2013-06-02','10:50:00',1.83),('3355','2013-06-02','10:55:00',1.42),('3355','2013-06-02','11:00:00',2.31),('3355','2013-06-02','11:05:00',2.3),('3355','2013-06-02','11:10:00',2.44),('3355','2013-06-02','11:15:00',1.26),('3355','2013-06-02','11:20:00',2.42),('3355','2013-06-02','11:25:00',1.52),('3355','2013-06-02','11:30:00',1.66),('3355','2013-06-02','11:35:00',1.2),('3355','2013-06-02','11:55:00',1.67),('3355','2013-06-02','12:00:00',2.47),('3355','2013-06-02','12:05:00',1.32),('3355','2013-06-02','12:10:00',1.12),('3355','2013-06-02','12:15:00',2.46),('3355','2013-06-02','12:20:00',1.38),('3355','2013-06-02','12:30:00',1.06),('3355','2013-06-02','12:35:00',1.51),('3355','2013-06-02','12:40:00',2.46),('3355','2013-06-02','12:45:00',1.98),('3355','2013-06-02','12:50:00',1.27),('3355','2013-06-02','12:55:00',1.19),('3355','2013-06-02','13:00:00',1.56),('3355','2013-06-02','13:15:00',2.37),('3355','2013-06-02','13:20:00',2.64),('3355','2013-06-02','13:25:00',2.52),('3355','2013-06-02','13:30:00',2.48),('3355','2013-06-02','13:35:00',2.48),('3355','2013-06-02','13:40:00',2.46),('3355','2013-06-02','13:45:00',2.43),('3355','2013-06-02','13:50:00',2.43),('3355','2013-06-02','13:55:00',2.42),('3355','2013-06-02','14:00:00',2.42),('3355','2013-06-02','14:05:00',2.4),('3355','2013-06-02','14:10:00',2.44),('3355','2013-06-02','14:15:00',2.35),('3355','2013-06-02','14:20:00',2.4),('3355','2013-06-02','14:25:00',2.4),('3355','2013-06-02','14:30:00',2.38),('3355','2013-06-02','14:35:00',2.35),('3355','2013-06-02','14:40:00',2.34),('3355','2013-06-02','14:45:00',2.31),('3355','2013-06-02','14:50:00',2.31),('3355','2013-06-02','14:55:00',2.3),('3355','2013-06-02','15:00:00',2.29),('3355','2013-06-02','15:05:00',2.28),('3355','2013-06-02','15:10:00',2.23),('3355','2013-06-02','15:15:00',2.23),('3355','2013-06-02','15:20:00',2.21),('3355','2013-06-02','15:25:00',1.96),('3355','2013-06-02','15:30:00',2.21),('3355','2013-06-02','15:35:00',1.68),('3355','2013-06-02','15:40:00',1.57),('3355','2013-06-02','15:45:00',1.9),('3355','2013-06-02','15:50:00',2.11),('3355','2013-06-02','15:55:00',1.55),('3355','2013-06-02','16:00:00',2.14),('3355','2013-06-02','16:05:00',2.03),('3355','2013-06-02','16:10:00',1.82),('3355','2013-06-02','16:15:00',1.66),('3355','2013-06-02','16:20:00',1.94),('3355','2013-06-02','16:25:00',1.83),('3355','2013-06-02','16:30:00',1.85),('3355','2013-06-02','16:35:00',1.7),('3355','2013-06-02','16:40:00',1.78),('3355','2013-06-02','16:45:00',1.82),('3355','2013-06-02','16:50:00',1.66),('3355','2013-06-02','16:55:00',1.68),('3355','2013-06-02','17:00:00',1.64),('3355','2013-06-02','17:05:00',1.46),('3355','2013-06-02','17:10:00',1.51),('3355','2013-06-02','17:15:00',1.48),('3355','2013-06-02','17:20:00',1.42),('3355','2013-06-02','17:25:00',1.39),('3355','2013-06-02','17:35:00',1.09),('3355','2013-06-01','10:55:00',1.48),('3355','2013-06-01','11:55:00',1.04),('3355','2013-06-01','12:00:00',1.33),('3355','2013-06-01','12:05:00',1.99),('3355','2013-06-01','12:10:00',1.92),('3355','2013-06-01','13:00:00',1.21),('3355','2013-06-01','13:05:00',1.3),('3355','2013-06-01','13:10:00',1.35),('3355','2013-06-01','13:15:00',1.52),('3355','2013-06-01','13:20:00',1.28),('3355','2013-06-01','14:00:00',1.07),('3355','2013-06-01','14:05:00',1.35),('3355','2013-06-01','14:10:00',1.32),('3355','2013-06-01','14:15:00',1.38),('3355','2013-06-01','14:20:00',1.43),('3355','2014-04-02','10:00:00',1.04),('3355','2014-04-02','10:25:00',1.8),('3355','2014-04-02','10:30:00',1.68),('3355','2014-04-02','10:55:00',1.6),('3355','2014-04-02','11:00:00',1.99),('3355','2014-04-02','11:05:00',1.91),('3355','2014-04-02','11:10:00',1.6),('3355','2014-04-02','11:20:00',1.91),('3355','2014-04-02','11:25:00',2.23),('3355','2014-04-02','11:30:00',2.13),('3355','2014-04-02','11:35:00',1.66),('3355','2014-04-02','11:40:00',1.66),('3355','2014-04-02','11:45:00',1.18),('3355','2014-04-02','11:50:00',1.82),('3355','2014-04-02','11:55:00',1.34),('3355','2014-04-02','12:00:00',2.13),('3355','2014-04-02','12:05:00',2.57),('3355','2014-04-02','12:20:00',1.39),('3355','2014-04-02','12:25:00',2.52),('3355','2014-04-02','12:35:00',2.05),('3355','2014-04-02','12:40:00',2.52),('3355','2014-04-02','12:45:00',2.46),('3355','2014-04-02','12:50:00',2.35),('3355','2014-04-02','12:55:00',2.58),('3355','2014-04-02','13:00:00',1.74),('3355','2014-04-02','13:10:00',1.87),('3355','2014-04-02','13:15:00',2.17),('3355','2014-04-02','13:20:00',1.81),('3355','2014-04-02','13:25:00',2.38),('3355','2014-04-02','13:30:00',2.48),('3355','2014-04-02','13:35:00',2.5),('3355','2014-04-02','13:40:00',2.59),('3355','2014-04-02','13:45:00',2.47),('3355','2014-04-02','13:50:00',2.38),('3355','2014-04-02','13:55:00',2.36),('3355','2014-04-02','14:00:00',2.36),('3355','2014-04-02','14:05:00',2.31),('3355','2014-04-02','14:10:00',2.36),('3355','2014-04-02','14:15:00',2.34),('3355','2014-04-02','14:20:00',2.31),('3355','2014-04-02','14:25:00',2.3),('3355','2014-04-02','14:30:00',2.29),('3355','2014-04-02','14:35:00',2.24),('3355','2014-04-02','14:40:00',2.28),('3355','2014-04-02','14:45:00',2.29),('3355','2014-04-02','14:50:00',1.22),('3355','2014-04-02','14:55:00',2),('3355','2014-04-02','15:00:00',1.91),('3355','2014-04-02','15:05:00',2.17),('3355','2014-04-02','15:10:00',2.01),('3355','2014-04-02','15:15:00',2.02),('3355','2014-04-02','15:20:00',2.03),('3355','2014-04-02','15:25:00',1.99),('3355','2014-04-02','15:30:00',1.89),('3355','2014-04-02','15:35:00',1.83),('3355','2014-04-02','15:40:00',1.93),('3355','2014-04-02','15:45:00',1.95),('3355','2014-04-02','15:50:00',1.93),('3355','2014-04-02','15:55:00',1.7),('3355','2014-04-02','16:00:00',1.76),('3355','2014-04-02','16:05:00',1.76),('3355','2014-04-02','16:10:00',1.73),('3355','2014-04-02','16:15:00',1.7),('3355','2014-04-02','16:20:00',1.64),('3355','2014-04-02','16:25:00',1.62),('3355','2014-04-02','16:30:00',1.62),('3355','2014-04-02','16:35:00',1.56),('3355','2014-04-02','16:40:00',1.52),('3355','2014-04-02','16:45:00',1.47),('3355','2014-04-02','16:50:00',1.35),('3355','2014-04-02','16:55:00',1.33),('3355','2014-04-02','17:00:00',1.38),('3355','2014-04-02','17:05:00',1.24),('3355','2014-04-02','17:10:00',1.18),('3355','2014-04-02','17:15:00',1.05),('3355','2014-04-02','17:20:00',1.05),('3355','2014-04-02','17:25:00',1.01),('3355','2013-05-31','08:30:00',1.07),('3355','2013-05-31','08:40:00',1.27),('3355','2013-05-31','08:50:00',1.24),('3355','2013-05-31','09:35:00',1.37),('3355','2013-05-31','09:40:00',1.33),('3355','2013-05-31','09:45:00',1.64),('3355','2013-05-31','09:50:00',1.79),('3355','2013-05-31','09:55:00',1.96),('3355','2013-05-31','10:00:00',1.97),('3355','2013-05-31','10:05:00',1.02),('3355','2013-05-31','10:10:00',1.06),('3355','2013-05-31','10:15:00',1.54),('3355','2013-05-31','10:20:00',1.84),('3355','2013-05-31','10:30:00',1.12),('3355','2013-05-31','10:35:00',1.54),('3355','2013-05-31','10:40:00',1.65),('3355','2013-05-31','10:45:00',2.05),('3355','2013-05-31','10:50:00',1.58),('3355','2013-05-31','10:55:00',2.16),('3355','2013-05-31','11:10:00',2.77),('3355','2013-05-31','11:15:00',2.5),('3355','2013-05-31','11:25:00',1),('3355','2013-05-31','11:30:00',2.01),('3355','2013-05-31','11:35:00',1.38),('3355','2013-05-31','11:45:00',1.78),('3355','2013-05-31','11:50:00',2.39),('3355','2013-05-31','11:55:00',1.28),('3355','2013-05-31','12:00:00',1.57),('3355','2013-05-31','12:05:00',2.43),('3355','2013-05-31','12:10:00',2.37),('3355','2013-05-31','12:25:00',1.88),('3355','2013-05-31','12:40:00',2.04),('3355','2013-05-31','12:45:00',1.49),('3355','2013-05-31','13:00:00',2.09),('3355','2013-05-31','13:05:00',1.26),('3355','2013-05-31','13:30:00',2.02),('3355','2013-05-31','13:35:00',2.7),('3355','2013-05-31','13:40:00',1.22),('3355','2013-05-31','14:00:00',1.22),('3355','2013-05-31','15:10:00',1),('3355','2013-05-31','15:15:00',1.31),('3355','2013-05-31','15:20:00',2.85),('3355','2013-05-31','15:25:00',1.91),('3355','2013-05-31','15:30:00',1.61),('3355','2013-05-31','15:35:00',1.17),('3355','2013-05-31','15:50:00',1.27),('3355','2013-05-31','15:55:00',1.19),('3355','2013-05-30','08:40:00',1.12),('3355','2013-05-30','08:45:00',1.18),('3355','2013-05-30','08:50:00',1.22),('3355','2013-05-30','08:55:00',1.27),('3355','2013-05-30','09:00:00',1.32),('3355','2013-05-30','09:05:00',1.29),('3355','2013-05-30','09:10:00',1.18),('3355','2013-05-30','09:15:00',1.47),('3355','2013-05-30','09:20:00',1.52),('3355','2013-05-30','09:25:00',1.55),('3355','2013-05-30','09:30:00',1.49),('3355','2013-05-30','09:35:00',1.58),('3355','2013-05-30','09:40:00',1.71),('3355','2013-05-30','09:45:00',1.7),('3355','2013-05-30','09:50:00',1.61),('3355','2013-05-30','09:55:00',1.51),('3355','2013-05-30','10:10:00',1.77),('3355','2013-05-30','10:15:00',1.05),('3355','2013-05-30','10:20:00',2.23),('3355','2013-05-30','10:40:00',1.63),('3355','2013-05-30','10:45:00',1.68),('3355','2013-05-30','10:50:00',2.25),('3355','2013-05-30','10:55:00',1.77),('3355','2013-05-30','11:00:00',2.3),('3355','2013-05-30','11:05:00',2.56),('3355','2013-05-30','11:10:00',1.35),('3355','2013-05-30','11:20:00',2.35),('3355','2013-05-30','11:25:00',1.18),('3355','2013-05-30','11:30:00',1.83),('3355','2013-05-30','11:35:00',2.77),('3355','2013-05-30','11:40:00',2.71),('3355','2013-05-30','11:45:00',2.23),('3355','2013-05-30','11:50:00',2.76),('3355','2013-05-30','12:00:00',2.05),('3355','2013-05-30','12:05:00',2.8),('3355','2013-05-30','12:10:00',1.51),('3355','2013-05-30','12:15:00',2.03),('3355','2013-05-30','12:20:00',2.56),('3355','2013-05-30','12:25:00',1.76),('3355','2013-05-30','12:30:00',2.16),('3355','2013-05-30','12:35:00',1.87),('3355','2013-05-30','12:40:00',2.22),('3355','2013-05-30','12:45:00',1.03),('3355','2013-05-30','12:50:00',2.67),('3355','2013-05-30','12:55:00',2.73),('3355','2013-05-30','13:00:00',1.99),('3355','2013-05-30','13:05:00',1.85),('3355','2013-05-30','13:10:00',1.27),('3355','2013-05-30','13:15:00',1.62),('3355','2013-05-30','13:25:00',1.11),('3355','2013-05-30','13:30:00',1.49),('3355','2013-05-30','13:40:00',2.47),('3355','2013-05-30','13:45:00',2.26),('3355','2013-05-30','13:50:00',1.06),('3355','2013-05-30','14:00:00',1.78),('3355','2013-05-30','14:05:00',2.73),('3355','2013-05-30','14:10:00',1.77),('3355','2013-05-30','14:15:00',2.45),('3355','2013-05-30','14:20:00',2.13),('3355','2013-05-30','14:25:00',1.91),('3355','2013-05-30','14:30:00',2.58),('3355','2013-05-30','14:35:00',1.94),('3355','2013-05-30','14:40:00',2.61),('3355','2013-05-30','14:45:00',2.57),('3355','2013-05-30','14:50:00',2.59),('3355','2013-05-30','14:55:00',2.5),('3355','2013-05-30','15:00:00',2.41),('3355','2013-05-30','15:05:00',2.29),('3355','2013-05-30','15:10:00',1.05),('3355','2013-05-30','15:15:00',2.44),('3355','2013-05-30','15:20:00',2.52),('3355','2013-05-30','15:25:00',2.44),('3355','2013-05-30','15:30:00',2.27),('3355','2013-05-30','15:35:00',1.82),('3355','2013-05-30','15:40:00',2.57),('3355','2013-05-30','15:45:00',2.54),('3355','2013-05-30','15:50:00',1.37),('3355','2013-05-30','15:55:00',1.75),('3355','2013-05-30','16:00:00',2.42),('3355','2013-05-30','16:05:00',2.05),('3355','2013-05-30','16:10:00',2.25),('3355','2013-05-30','16:15:00',2.13),('3355','2013-05-30','16:20:00',1.96),('3355','2013-05-30','16:25:00',1.4),('3355','2013-05-30','16:30:00',1.16),('3355','2013-05-30','16:35:00',1.2),('3355','2013-05-30','16:45:00',1.3),('3355','2013-05-30','16:50:00',1.54),('3355','2013-05-30','16:55:00',1.47),('3355','2013-05-30','17:00:00',1.23),('3355','2013-05-30','17:05:00',1.09),('3355','2013-05-29','08:35:00',1.03),('3355','2013-05-29','08:40:00',1.08),('3355','2013-05-29','08:45:00',1.13),('3355','2013-05-29','08:50:00',1.18),('3355','2013-05-29','08:55:00',1.23),('3355','2013-05-29','09:00:00',1.28),('3355','2013-05-29','09:05:00',1.33),('3355','2013-05-29','09:10:00',1.37),('3355','2013-05-29','09:15:00',1.41),('3355','2013-05-29','09:20:00',1.45),('3355','2013-05-29','09:25:00',1.49),('3355','2013-05-29','09:30:00',1.53),('3355','2013-05-29','09:35:00',1.57),('3355','2013-05-29','09:40:00',1.63),('3355','2013-05-29','09:45:00',1.67),('3355','2013-05-29','09:50:00',1.72),('3355','2013-05-29','09:55:00',1.75),('3355','2013-05-29','10:00:00',1.78),('3355','2013-05-29','10:05:00',1.82),('3355','2013-05-29','10:10:00',1.85),('3355','2013-05-29','10:15:00',1.89),('3355','2013-05-29','10:20:00',1.93),('3355','2013-05-29','10:25:00',1.97),('3355','2013-05-29','10:30:00',2),('3355','2013-05-29','10:35:00',2.05),('3355','2013-05-29','10:40:00',2.08),('3355','2013-05-29','10:45:00',2.1),('3355','2013-05-29','10:50:00',2.13),('3355','2013-05-29','10:55:00',2.15),('3355','2013-05-29','11:00:00',2.18),('3355','2013-05-29','11:05:00',1.96),('3355','2013-05-29','11:10:00',2.27),('3355','2013-05-29','11:15:00',1.5),('3355','2013-05-29','11:20:00',2.41),('3355','2013-05-29','11:25:00',2.46),('3355','2013-05-29','11:30:00',2.14),('3355','2013-05-29','11:35:00',2.54),('3355','2013-05-29','11:40:00',2.35),('3355','2013-05-29','11:45:00',2.22),('3355','2013-05-29','11:50:00',1.68),('3355','2013-05-29','11:55:00',2.02),('3355','2013-05-29','12:00:00',2.09),('3355','2013-05-29','12:05:00',1.43),('3355','2013-05-29','12:10:00',1.85),('3355','2013-05-29','12:15:00',2.24),('3355','2013-05-29','12:20:00',1.91),('3355','2013-05-29','12:25:00',2.6),('3355','2013-05-29','12:30:00',2.54),('3355','2013-05-29','12:35:00',2.52),('3355','2013-05-29','12:40:00',2.6),('3355','2013-05-29','12:45:00',2.15),('3355','2013-05-29','12:50:00',2.37),('3355','2013-05-29','12:55:00',2.47),('3355','2013-05-29','13:00:00',2.56),('3355','2013-05-29','13:05:00',2.35),('3355','2013-05-29','13:10:00',2.23),('3355','2013-05-29','13:15:00',2.36),('3355','2013-05-29','13:20:00',2.17),('3355','2013-05-29','13:25:00',2.7),('3355','2013-05-29','13:30:00',2.59),('3355','2013-05-29','13:35:00',2.46),('3355','2013-05-29','13:40:00',2.72),('3355','2013-05-29','13:45:00',2.41),('3355','2013-05-29','13:50:00',2.16),('3355','2013-05-29','13:55:00',2.16),('3355','2013-05-29','14:00:00',2.53),('3355','2013-05-29','14:05:00',2.51),('3355','2013-05-29','14:10:00',2.42),('3355','2013-05-29','14:15:00',2.51),('3355','2013-05-29','14:20:00',2.51),('3355','2013-05-29','14:25:00',2.47),('3355','2013-05-29','14:30:00',2.52),('3355','2013-05-29','14:35:00',1.59),('3355','2013-05-29','14:40:00',2.22),('3355','2013-05-29','14:45:00',2.53),('3355','2013-05-29','14:50:00',2.57),('3355','2013-05-29','14:55:00',2.45),('3355','2013-05-29','15:00:00',2.08),('3355','2013-05-29','15:05:00',2.5),('3355','2013-05-29','15:10:00',2.17),('3355','2013-05-29','15:15:00',1.31),('3355','2013-05-29','15:20:00',1.68),('3355','2013-05-29','15:25:00',1.72),('3355','2013-05-29','15:30:00',1.55),('3355','2013-05-29','15:35:00',1.66),('3355','2013-05-29','15:40:00',1.44),('3355','2013-05-29','15:45:00',1.74),('3355','2013-05-29','15:50:00',1.75),('3355','2013-05-29','15:55:00',1.7),('3355','2013-05-29','16:00:00',1.45),('3355','2013-05-29','16:05:00',1.51),('3355','2013-05-29','16:10:00',1.24),('3355','2013-05-29','16:15:00',1.15),('3355','2013-05-29','16:20:00',1.14),('3355','2013-05-29','16:25:00',1.12),('3355','2013-05-29','16:30:00',1.05),('3355','2013-05-29','16:40:00',1.13),('3355','2013-05-29','16:45:00',1.03),('3355','2013-05-29','18:15:00',1.09),('3355','2013-05-28','09:25:00',1.1),('3355','2013-05-28','09:30:00',1.18),('3355','2013-05-28','09:35:00',1.23),('3355','2013-05-28','09:40:00',1.18),('3355','2013-05-28','09:45:00',1.09),('3355','2013-05-28','09:50:00',1.11),('3355','2013-05-28','09:55:00',1.23),('3355','2013-05-28','10:00:00',1.14),('3355','2013-05-28','10:05:00',1.2),('3355','2013-05-28','10:10:00',1.34),('3355','2013-05-28','10:15:00',1.38),('3355','2013-05-28','10:20:00',1.48),('3355','2013-05-28','10:25:00',1.43),('3355','2013-05-28','10:30:00',1.59),('3355','2013-05-28','10:35:00',1.62),('3355','2013-05-28','10:40:00',1.45),('3355','2013-05-28','10:45:00',1.4),('3355','2013-05-28','10:50:00',1.52),('3355','2013-05-28','10:55:00',1.3),('3355','2013-05-28','11:00:00',1.29),('3355','2013-05-28','11:05:00',1.27),('3355','2013-05-28','11:10:00',1.41),('3355','2013-05-28','11:15:00',1.03),('3355','2013-05-28','11:20:00',1.26),('3355','2013-05-28','11:25:00',1.01),('3355','2013-05-28','11:30:00',1.87),('3355','2013-05-28','11:35:00',1.55),('3355','2013-05-28','11:40:00',2.1),('3355','2013-05-28','11:45:00',1.95),('3355','2013-05-28','12:10:00',1.63),('3355','2013-05-28','12:15:00',1.53),('3355','2013-05-28','12:20:00',1.26),('3355','2013-05-28','12:25:00',1.31),('3355','2013-05-28','12:30:00',1.47),('3355','2013-05-28','12:35:00',1.41),('3355','2013-05-28','12:40:00',1.43),('3355','2013-05-28','12:45:00',1.64),('3355','2013-05-28','12:50:00',1.46),('3355','2013-05-28','12:55:00',1.45),('3355','2013-05-28','13:00:00',1.51),('3355','2013-05-28','13:05:00',1.6),('3355','2013-05-28','13:10:00',1.66),('3355','2013-05-28','13:15:00',1.58),('3355','2013-05-28','13:20:00',1.8),('3355','2013-05-28','13:25:00',1.03),('3355','2013-05-28','13:30:00',1.17),('3355','2013-05-28','13:40:00',1.04),('3355','2013-05-28','13:45:00',1.02),('3355','2013-05-28','13:50:00',1.61),('3355','2013-05-28','13:55:00',1.59),('3355','2013-05-28','14:00:00',1.42),('3355','2013-05-28','14:05:00',1.51),('3355','2013-05-28','14:10:00',2.06),('3355','2013-05-28','14:15:00',2.2),('3355','2013-05-28','14:20:00',1.41),('3355','2013-05-28','14:25:00',1.6),('3355','2013-05-28','14:30:00',1.84),('3355','2013-05-28','14:35:00',1.73),('3355','2013-05-28','14:40:00',1.89),('3355','2013-05-28','14:45:00',2.11),('3355','2013-05-28','14:50:00',1.52),('3355','2013-05-28','14:55:00',1.34),('3355','2013-05-28','15:00:00',1.24),('3355','2013-05-28','15:05:00',2.12),('3355','2013-05-28','15:15:00',1.54),('3355','2013-05-28','15:20:00',1.81),('3355','2013-05-28','15:25:00',1.15),('3355','2013-05-28','15:40:00',1.49),('3355','2013-05-28','15:45:00',2.14),('3355','2013-05-28','15:50:00',1.76),('3355','2013-05-28','15:55:00',1.35),('3355','2013-05-28','16:20:00',1.26),('3355','2013-05-28','16:25:00',1.27),('3355','2013-05-28','16:30:00',1.33),('3355','2013-05-28','16:35:00',1.76),('3355','2013-05-28','16:40:00',1.64),('3355','2013-05-28','16:45:00',1.58),('3355','2013-05-28','16:50:00',1.54),('3355','2013-05-28','16:55:00',1.5),('3355','2013-05-28','17:00:00',1.48),('3355','2013-05-28','17:05:00',1.44),('3355','2013-05-28','17:10:00',1.39),('3355','2013-05-28','17:15:00',1.36),('3355','2013-05-28','17:20:00',1.31),('3355','2013-05-28','17:25:00',1.25),('3355','2013-05-28','17:30:00',1.22),('3355','2013-05-28','17:35:00',1.17),('3355','2013-05-28','17:45:00',1.07),('3355','2013-05-27','08:30:00',1.01),('3355','2013-05-27','08:35:00',1.06),('3355','2013-05-27','08:40:00',1.11),('3355','2013-05-27','08:45:00',1.17),('3355','2013-05-27','08:50:00',1.39),('3355','2013-05-27','08:55:00',1.41),('3355','2013-05-27','09:00:00',1.44),('3355','2013-05-27','09:05:00',1.54),('3355','2013-05-27','09:10:00',1.39),('3355','2013-05-27','09:15:00',1.28),('3355','2013-05-27','09:20:00',1.42),('3355','2013-05-27','09:30:00',1.51),('3355','2013-05-27','09:35:00',1.68),('3355','2013-05-27','09:40:00',1.71),('3355','2013-05-27','09:45:00',1.76),('3355','2013-05-27','09:50:00',1.71),('3355','2013-05-27','09:55:00',1.93),('3355','2013-05-27','10:00:00',1.94),('3355','2013-05-27','10:05:00',1.95),('3355','2013-05-27','10:10:00',1.96),('3355','2013-05-27','10:15:00',2.02),('3355','2013-05-27','10:20:00',1.83),('3355','2013-05-27','10:25:00',1.06),('3355','2013-05-27','10:30:00',1.76),('3355','2013-05-27','10:45:00',1.53),('3355','2013-05-27','10:50:00',1.44),('3355','2013-05-27','10:55:00',1.22),('3355','2013-05-27','11:00:00',1.46),('3355','2013-05-27','11:05:00',2.55),('3355','2013-05-27','11:10:00',2.2),('3355','2013-05-27','11:15:00',1.46),('3355','2013-05-27','11:20:00',1.43),('3355','2013-05-27','11:25:00',2.8),('3355','2013-05-27','11:30:00',1.2),('3355','2013-05-27','11:35:00',1.48),('3355','2013-05-27','11:40:00',1.47),('3355','2013-05-27','11:45:00',2),('3355','2013-05-27','11:50:00',1.33),('3355','2013-05-27','11:55:00',1.43),('3355','2013-05-27','12:00:00',2.27),('3355','2013-05-27','12:05:00',1.79),('3355','2013-05-27','12:10:00',1.8),('3355','2013-05-27','12:15:00',2.53),('3355','2013-05-27','12:20:00',2.29),('3355','2013-05-27','12:25:00',2.74),('3355','2013-05-27','12:30:00',2.58),('3355','2013-05-27','12:35:00',2.08),('3355','2013-05-27','12:40:00',2.22),('3355','2013-05-27','12:45:00',2.81),('3355','2013-05-27','12:50:00',2.66),('3355','2013-05-27','12:55:00',2.68),('3355','2013-05-27','13:00:00',2.72),('3355','2013-05-27','13:10:00',2.03),('3355','2013-05-27','13:15:00',1.86),('3355','2013-05-27','13:20:00',1.56),('3355','2013-05-27','13:25:00',2.67),('3355','2013-05-27','13:30:00',2.61),('3355','2013-05-27','13:35:00',2.1),('3355','2013-05-27','13:40:00',2.65),('3355','2013-05-27','13:45:00',2.7),('3355','2013-05-27','13:50:00',1.85),('3355','2013-05-27','13:55:00',1.71),('3355','2013-05-27','14:00:00',2.42),('3355','2013-05-27','14:05:00',2.56),('3355','2013-05-27','14:10:00',2.21),('3355','2013-05-27','14:15:00',2.12),('3355','2013-05-27','14:20:00',1.8),('3355','2013-05-27','14:25:00',2.44),('3355','2013-05-27','14:30:00',1.64),('3355','2013-05-27','14:35:00',2.45),('3355','2013-05-27','14:45:00',2.34),('3355','2013-05-27','14:50:00',2.59);
INSERT INTO `solarlog` VALUES ('3355','2013-05-27','14:55:00',2.13),('3355','2013-05-27','15:00:00',1.63),('3355','2013-05-27','15:05:00',1.43),('3355','2013-05-27','15:10:00',2.39),('3355','2013-05-27','15:15:00',1.65),('3355','2013-05-27','15:20:00',1.99),('3355','2013-05-27','15:25:00',1.88),('3355','2013-05-27','15:30:00',2.01),('3355','2013-05-27','15:35:00',2.33),('3355','2013-05-27','15:40:00',1.9),('3355','2013-05-27','15:45:00',1.71),('3355','2013-05-27','15:50:00',2.19),('3355','2013-05-27','15:55:00',1.43),('3355','2013-05-27','16:00:00',1.72),('3355','2013-05-27','16:05:00',1.25),('3355','2013-05-27','16:10:00',1.52),('3355','2013-05-27','16:15:00',1.3),('3355','2013-05-27','16:20:00',2.13),('3355','2013-05-27','16:25:00',2.09),('3355','2013-05-27','16:30:00',1.89),('3355','2013-05-27','16:35:00',1.72),('3355','2013-05-27','18:25:00',1.03),('3355','2013-05-26','08:30:00',1.03),('3355','2013-05-26','08:40:00',1.06),('3355','2013-05-26','08:45:00',1.21),('3355','2013-05-26','08:50:00',1.47),('3355','2013-05-26','09:15:00',1.03),('3355','2013-05-26','09:45:00',1.25),('3355','2013-05-26','10:05:00',1.34),('3355','2013-05-26','10:10:00',2.14),('3355','2013-05-26','10:15:00',1.44),('3355','2013-05-26','10:20:00',1.54),('3355','2013-05-26','10:25:00',1.42),('3355','2013-05-26','10:30:00',1.99),('3355','2013-05-26','10:35:00',1.95),('3355','2013-05-26','10:40:00',2.18),('3355','2013-05-26','10:45:00',2.21),('3355','2013-05-26','10:50:00',2.25),('3355','2013-05-26','10:55:00',2.18),('3355','2013-05-26','11:00:00',2.21),('3355','2013-05-26','11:05:00',2.33),('3355','2013-05-26','11:10:00',2.34),('3355','2013-05-26','11:15:00',2.36),('3355','2013-05-26','11:20:00',2.4),('3355','2013-05-26','11:25:00',2.41),('3355','2013-05-26','11:30:00',2.45),('3355','2013-05-26','11:35:00',2.4),('3355','2013-05-26','11:40:00',2.49),('3355','2013-05-26','11:45:00',2.55),('3355','2013-05-26','11:50:00',2.49),('3355','2013-05-26','11:55:00',2.59),('3355','2013-05-26','12:00:00',2.52),('3355','2013-05-26','12:05:00',2.54),('3355','2013-05-26','12:10:00',2.35),('3355','2013-05-26','12:15:00',2.33),('3355','2013-05-26','12:20:00',1.79),('3355','2013-05-26','12:25:00',2.32),('3355','2013-05-26','12:30:00',2.7),('3355','2013-05-26','12:35:00',2.67),('3355','2013-05-26','12:40:00',2.4),('3355','2013-05-26','12:45:00',1.98),('3355','2013-05-26','12:50:00',2.69),('3355','2013-05-26','12:55:00',2.65),('3355','2013-05-26','13:00:00',2.52),('3355','2013-05-26','13:05:00',2.33),('3355','2013-05-26','13:10:00',2.64),('3355','2013-05-26','13:15:00',2.46),('3355','2013-05-26','13:20:00',2.72),('3355','2013-05-26','13:25:00',2.66),('3355','2013-05-26','13:30:00',2.69),('3355','2013-05-26','13:35:00',2.68),('3355','2013-05-26','13:40:00',2.63),('3355','2013-05-26','13:45:00',2.63),('3355','2013-05-26','13:50:00',2.56),('3355','2013-05-26','13:55:00',2.56),('3355','2013-05-26','14:00:00',2.59),('3355','2013-05-26','14:05:00',2.59),('3355','2013-05-26','14:10:00',2.57),('3355','2013-05-26','14:15:00',2.55),('3355','2013-05-26','14:20:00',2.54),('3355','2013-05-26','14:25:00',2.52),('3355','2013-05-26','14:30:00',2.53),('3355','2013-05-26','14:35:00',2.5),('3355','2013-05-26','14:40:00',2.48),('3355','2013-05-26','14:45:00',2.46),('3355','2013-05-26','14:50:00',2.46),('3355','2013-05-26','14:55:00',2.44),('3355','2013-05-26','15:00:00',2.41),('3355','2013-05-26','15:05:00',2.41),('3355','2013-05-26','15:10:00',2.39),('3355','2013-05-26','15:15:00',2.38),('3355','2013-05-26','15:20:00',2.35),('3355','2013-05-26','15:25:00',2.33),('3355','2013-05-26','15:30:00',2.31),('3355','2013-05-26','15:35:00',2.28),('3355','2013-05-26','15:40:00',2.25),('3355','2013-05-26','15:45:00',2.21),('3355','2013-05-26','15:50:00',2.18),('3355','2013-05-26','15:55:00',2.16),('3355','2013-05-26','16:00:00',2.13),('3355','2013-05-26','16:05:00',2.1),('3355','2013-05-26','16:10:00',2.07),('3355','2013-05-26','16:15:00',2.03),('3355','2013-05-26','16:20:00',1.99),('3355','2013-05-26','16:25:00',1.96),('3355','2013-05-26','16:30:00',1.93),('3355','2013-05-26','16:35:00',1.88),('3355','2013-05-26','16:40:00',1.83),('3355','2013-05-26','16:45:00',1.8),('3355','2013-05-26','16:50:00',1.76),('3355','2013-05-26','16:55:00',1.72),('3355','2013-05-26','17:00:00',1.68),('3355','2013-05-26','17:05:00',1.64),('3355','2013-05-26','17:10:00',1.57),('3355','2013-05-26','17:15:00',1.53),('3355','2013-05-26','17:20:00',1.49),('3355','2013-05-26','17:25:00',1.44),('3355','2013-05-26','17:30:00',1.39),('3355','2013-05-26','17:35:00',1.34),('3355','2013-05-26','17:40:00',1.29),('3355','2013-05-26','17:45:00',1.24),('3355','2013-05-26','17:50:00',1.19),('3355','2013-05-26','17:55:00',1.14),('3355','2013-05-26','18:00:00',1.08),('3355','2013-05-26','18:05:00',1.02),('3355','2013-05-25','08:05:00',1.01),('3355','2013-05-25','08:25:00',1.12),('3355','2013-05-25','08:30:00',1.39),('3355','2013-05-25','09:05:00',1.67),('3355','2013-05-25','09:10:00',1.56),('3355','2013-05-25','09:15:00',1.88),('3355','2013-05-25','09:35:00',1.21),('3355','2013-05-25','09:40:00',2.08),('3355','2013-05-25','09:45:00',1.47),('3355','2013-05-25','09:50:00',1.79),('3355','2013-05-25','09:55:00',1.29),('3355','2013-05-25','11:05:00',1.14),('3355','2013-05-25','11:10:00',2.39),('3355','2013-05-25','11:15:00',2.17),('3355','2013-05-25','11:20:00',1.52),('3355','2013-05-25','11:45:00',1.29),('3355','2013-05-25','11:55:00',1.01),('3355','2013-05-25','12:45:00',1.05),('3355','2013-05-25','12:55:00',1.36),('3355','2013-05-25','13:20:00',1.1),('3355','2013-05-25','13:25:00',1.45),('3355','2013-05-25','13:30:00',1.16),('3355','2013-05-25','13:40:00',1.1),('3355','2013-05-25','13:45:00',1.04),('3355','2013-05-25','13:50:00',1.38),('3355','2013-05-25','13:55:00',1.62),('3355','2013-05-25','14:00:00',2.2),('3355','2013-05-25','14:05:00',2.68),('3355','2013-05-25','14:10:00',2.6),('3355','2013-05-25','14:15:00',2.57),('3355','2013-05-25','14:20:00',1.97),('3355','2013-05-25','14:25:00',2.07),('3355','2013-05-25','14:30:00',2.1),('3355','2013-05-25','14:35:00',1.1),('3355','2013-05-25','14:45:00',1.01),('3355','2013-05-25','14:50:00',1.03),('3355','2013-05-25','15:00:00',1.64),('3355','2013-05-25','15:05:00',1.67),('3355','2013-05-25','15:10:00',1.02),('3355','2013-05-25','15:15:00',1.6),('3355','2013-05-25','15:25:00',1.41),('3355','2013-05-25','15:30:00',1.52),('3355','2013-05-25','15:35:00',2.46),('3355','2013-05-25','15:40:00',2.11),('3355','2013-05-25','15:45:00',2.12),('3355','2013-05-25','15:50:00',2.42),('3355','2013-05-25','15:55:00',2.5),('3355','2013-05-25','16:00:00',1.82),('3355','2013-05-25','16:10:00',1.6),('3355','2013-05-25','16:30:00',1.38),('3355','2013-05-25','16:35:00',1.41),('3355','2013-05-25','16:40:00',1.49),('3355','2013-05-25','16:45:00',1.66),('3355','2013-05-25','16:50:00',1.28),('3355','2013-05-25','17:10:00',1.77),('3355','2013-05-25','17:15:00',1.1),('3355','2013-05-25','17:20:00',1.03),('3355','2013-05-25','17:25:00',1.11),('3355','2013-05-24','08:50:00',1.11),('3355','2013-05-24','08:55:00',1.28),('3355','2013-05-24','09:00:00',1.38),('3355','2013-05-24','09:05:00',1.62),('3355','2013-05-24','09:20:00',1.15),('3355','2013-05-24','09:55:00',1.28),('3355','2013-05-24','10:00:00',1.41),('3355','2013-05-24','10:25:00',1.22),('3355','2013-05-24','10:30:00',2.25),('3355','2013-05-24','10:35:00',2.05),('3355','2013-05-24','10:40:00',1.74),('3355','2013-05-24','10:45:00',1.85),('3355','2013-05-24','10:50:00',1.48),('3355','2013-05-24','10:55:00',2.39),('3355','2013-05-24','11:00:00',1.7),('3355','2013-05-24','11:05:00',1.66),('3355','2013-05-24','11:10:00',2.18),('3355','2013-05-24','11:15:00',2.05),('3355','2013-05-24','11:20:00',2.45),('3355','2013-05-24','11:25:00',2.52),('3355','2013-05-24','11:30:00',1.71),('3355','2013-05-24','11:45:00',1.26),('3355','2013-05-24','11:50:00',2.69),('3355','2013-05-24','11:55:00',2.09),('3355','2013-05-24','12:00:00',1),('3355','2013-05-24','12:05:00',1.71),('3355','2013-05-24','12:10:00',1.84),('3355','2013-05-24','12:15:00',1.22),('3355','2013-05-24','12:20:00',1.15),('3355','2013-05-24','12:25:00',2.29),('3355','2013-05-24','12:30:00',2.34),('3355','2013-05-24','12:35:00',1.14),('3355','2013-05-24','12:40:00',1.48),('3355','2013-05-24','12:45:00',1.98),('3355','2013-05-24','12:50:00',1.62),('3355','2013-05-24','12:55:00',1.3),('3355','2013-05-24','13:00:00',1.24),('3355','2013-05-24','13:05:00',1.11),('3355','2013-05-24','13:10:00',1.42),('3355','2013-05-24','13:15:00',1.61),('3355','2013-05-24','13:20:00',1.84),('3355','2013-05-24','13:25:00',1.47),('3355','2013-05-24','13:30:00',1.05),('3355','2013-05-24','13:35:00',2.1),('3355','2013-05-24','13:40:00',1.45),('3355','2013-05-24','13:55:00',1.97),('3355','2013-05-24','14:00:00',1.69),('3355','2013-05-24','14:05:00',1.29),('3355','2013-05-24','14:15:00',1.97),('3355','2013-05-24','14:20:00',1.96),('3355','2013-05-24','14:25:00',2.03),('3355','2013-05-24','14:30:00',1.65),('3355','2013-05-24','14:35:00',1.73),('3355','2013-05-24','14:40:00',1.44),('3355','2013-05-24','14:45:00',1.56),('3355','2013-05-24','15:00:00',1.23),('3355','2013-05-24','15:05:00',2.21),('3355','2013-05-24','15:10:00',1.65),('3355','2013-05-24','15:15:00',1.76),('3355','2013-05-24','15:20:00',2.37),('3355','2013-05-24','15:25:00',1.87),('3355','2013-05-24','15:30:00',1.83),('3355','2013-05-24','15:35:00',1.5),('3355','2013-05-24','15:40:00',1.53),('3355','2013-05-24','15:45:00',2.11),('3355','2013-05-24','15:50:00',2.17),('3355','2013-05-24','15:55:00',2.67),('3355','2013-05-24','16:00:00',1.3),('3355','2013-05-24','16:05:00',1.12),('3355','2013-05-24','16:10:00',1.16),('3355','2013-05-24','16:15:00',1.48),('3355','2013-05-24','16:20:00',1.03),('3355','2013-05-24','16:25:00',1.35),('3355','2013-05-24','16:30:00',1.83),('3355','2013-05-24','16:55:00',1.18),('3355','2013-05-23','08:35:00',1.12),('3355','2013-05-23','08:40:00',1.05),('3355','2013-05-23','09:00:00',1.29),('3355','2013-05-23','09:25:00',1.68),('3355','2013-05-23','09:30:00',1.88),('3355','2013-05-23','09:35:00',1.37),('3355','2013-05-23','09:40:00',1.32),('3355','2013-05-23','09:45:00',1.11),('3355','2013-05-23','09:50:00',1.77),('3355','2013-05-23','10:05:00',1.47),('3355','2013-05-23','10:10:00',1.98),('3355','2013-05-23','10:15:00',1.77),('3355','2013-05-23','10:20:00',1.45),('3355','2013-05-23','10:25:00',1.97),('3355','2013-05-23','10:30:00',2.11),('3355','2013-05-23','10:35:00',1.77),('3355','2013-05-23','10:40:00',1.98),('3355','2013-05-23','10:45:00',2.28),('3355','2013-05-23','10:50:00',2.15),('3355','2013-05-23','10:55:00',2.34),('3355','2013-05-23','11:00:00',1.94),('3355','2013-05-23','11:05:00',1.79),('3355','2013-05-23','11:10:00',1.24),('3355','2013-05-23','11:20:00',1.06),('3355','2013-05-23','11:25:00',1.19),('3355','2013-05-23','11:30:00',1.92),('3355','2013-05-23','11:35:00',2.13),('3355','2013-05-23','11:40:00',2.43),('3355','2013-05-23','11:45:00',1.38),('3355','2013-05-23','11:50:00',2.47),('3355','2013-05-23','11:55:00',2.78),('3355','2013-05-23','12:00:00',2.44),('3355','2013-05-23','12:05:00',2.57),('3355','2013-05-23','12:10:00',2.6),('3355','2013-05-23','12:15:00',2.39),('3355','2013-05-23','12:20:00',1.72),('3355','2013-05-23','12:25:00',2.62),('3355','2013-05-23','12:30:00',2.17),('3355','2013-05-23','12:40:00',2.17),('3355','2013-05-23','12:45:00',2.18),('3355','2013-05-23','12:50:00',1.73),('3355','2013-05-23','12:55:00',2.28),('3355','2013-05-23','13:00:00',2.78),('3355','2013-05-23','13:05:00',1.73),('3355','2013-05-23','13:10:00',2.21),('3355','2013-05-23','13:15:00',2.05),('3355','2013-05-23','13:20:00',1.98),('3355','2013-05-23','13:25:00',1.23),('3355','2013-05-23','13:30:00',1.86),('3355','2013-05-23','13:35:00',1.21),('3355','2013-05-23','13:45:00',2.31),('3355','2013-05-23','13:50:00',1.49),('3355','2013-05-23','13:55:00',2.13),('3355','2013-05-23','14:00:00',2.35),('3355','2013-05-23','14:05:00',2.41),('3355','2013-05-23','14:10:00',2.84),('3355','2013-05-23','14:15:00',1.56),('3355','2013-05-23','14:20:00',2.77),('3355','2013-05-23','14:25:00',2.6),('3355','2013-05-23','14:35:00',2.61),('3355','2013-05-23','14:40:00',2.33),('3355','2013-05-23','14:45:00',1.3),('3355','2013-05-23','14:50:00',1.28),('3355','2013-05-23','14:55:00',1.68),('3355','2013-05-23','15:00:00',1.91),('3355','2013-05-23','15:05:00',1.47),('3355','2013-05-23','15:20:00',1.77),('3355','2013-05-23','15:30:00',1.44),('3355','2013-05-23','15:35:00',1.77),('3355','2013-05-23','15:40:00',1.17),('3355','2013-05-23','15:45:00',1.41),('3355','2013-05-23','16:00:00',2.06),('3355','2013-05-23','16:05:00',2.01),('3355','2013-05-23','16:10:00',1.44),('3355','2013-05-23','16:15:00',1.3),('3355','2013-05-23','16:20:00',1.87),('3355','2013-05-23','16:25:00',1.71),('3355','2013-05-23','16:30:00',1.91),('3355','2013-05-23','16:35:00',1.11),('3355','2013-05-23','16:40:00',1.03),('3355','2013-05-23','17:10:00',1.3),('3355','2013-05-23','17:15:00',1.07),('3355','2013-05-23','18:05:00',1.34),('3355','2013-05-22','08:30:00',1.06),('3355','2013-05-22','08:35:00',1.28),('3355','2013-05-22','09:30:00',1.41),('3355','2013-05-22','09:35:00',1.53),('3355','2013-05-22','09:40:00',1.52),('3355','2013-05-22','09:45:00',1.54),('3355','2013-05-22','09:50:00',1.57),('3355','2013-05-22','09:55:00',1.6),('3355','2013-05-22','10:00:00',1.64),('3355','2013-05-22','10:05:00',1.68),('3355','2013-05-22','10:10:00',1.72),('3355','2013-05-22','10:15:00',1.75),('3355','2013-05-22','10:20:00',1.74),('3355','2013-05-22','10:25:00',1.87),('3355','2013-05-22','10:30:00',1.85),('3355','2013-05-22','10:35:00',1.88),('3355','2013-05-22','10:40:00',1.95),('3355','2013-05-22','10:45:00',1.95),('3355','2013-05-22','10:50:00',1.94),('3355','2013-05-22','10:55:00',1.96),('3355','2013-05-22','11:00:00',2.02),('3355','2013-05-22','11:05:00',2.09),('3355','2013-05-22','11:10:00',1.97),('3355','2013-05-22','11:15:00',1.92),('3355','2013-05-22','11:20:00',2.14),('3355','2013-05-22','11:25:00',2.21),('3355','2013-05-22','11:30:00',1.8),('3355','2013-05-22','11:35:00',1.76),('3355','2013-05-22','11:40:00',1.9),('3355','2013-05-22','11:45:00',2.19),('3355','2013-05-22','11:50:00',1.34),('3355','2013-05-22','11:55:00',1.15),('3355','2013-05-22','12:00:00',1.65),('3355','2013-05-22','12:05:00',1.27),('3355','2013-05-22','12:10:00',1.2),('3355','2013-05-22','12:15:00',1.7),('3355','2013-05-22','12:20:00',2.45),('3355','2013-05-22','12:25:00',1.59),('3355','2013-05-22','12:30:00',1.23),('3355','2013-05-22','12:35:00',1.3),('3355','2013-05-22','13:05:00',2.68),('3355','2013-05-22','13:10:00',1.21),('3355','2013-05-22','13:15:00',1.26),('3355','2013-05-22','13:20:00',1.18),('3355','2013-05-22','13:35:00',1.8),('3355','2013-05-22','13:40:00',1.71),('3355','2013-05-22','13:45:00',1.29),('3355','2013-05-22','13:50:00',1.32),('3355','2013-05-22','13:55:00',1.25),('3355','2013-05-22','14:00:00',1.46),('3355','2013-05-22','14:05:00',1.97),('3355','2013-05-22','14:10:00',2.12),('3355','2013-05-22','14:15:00',2.38),('3355','2013-05-22','14:20:00',2.31),('3355','2013-05-22','14:25:00',2.28),('3355','2013-05-22','14:30:00',2.27),('3355','2013-05-22','14:35:00',2.26),('3355','2013-05-22','14:40:00',2.23),('3355','2013-05-22','14:45:00',2.22),('3355','2013-05-22','14:50:00',2.2),('3355','2013-05-22','14:55:00',2.16),('3355','2013-05-22','15:00:00',2.16),('3355','2013-05-22','15:05:00',2.14),('3355','2013-05-22','15:10:00',2.12),('3355','2013-05-22','15:15:00',2.11),('3355','2013-05-22','15:20:00',2.03),('3355','2013-05-22','15:25:00',1.04),('3355','2013-05-22','15:30:00',1.09),('3355','2013-05-22','15:35:00',1.14),('3355','2013-05-22','15:45:00',1.52),('3355','2013-05-22','15:50:00',1.97),('3355','2013-05-22','15:55:00',1.91),('3355','2013-05-22','16:00:00',1.88),('3355','2013-05-22','16:05:00',1.84),('3355','2013-05-22','16:10:00',1.78),('3355','2013-05-22','16:15:00',1.77),('3355','2013-05-22','16:20:00',1.74),('3355','2013-05-22','16:25:00',1.71),('3355','2013-05-22','16:30:00',1.66),('3355','2013-05-22','16:35:00',1.61),('3355','2013-05-22','16:40:00',1.57),('3355','2013-05-22','16:45:00',1.3),('3355','2013-05-22','16:50:00',1.1),('3355','2013-05-22','17:25:00',1.18),('3355','2014-04-01','09:15:00',1.03),('3355','2014-04-01','09:20:00',1.08),('3355','2014-04-01','09:25:00',1.12),('3355','2014-04-01','09:30:00',1.17),('3355','2014-04-01','09:35:00',1.22),('3355','2014-04-01','09:40:00',1.24),('3355','2014-04-01','09:45:00',1.32),('3355','2014-04-01','09:50:00',1.38),('3355','2014-04-01','09:55:00',1.42),('3355','2014-04-01','10:00:00',1.16),('3355','2014-04-01','10:05:00',1.19),('3355','2014-04-01','10:10:00',1.54),('3355','2014-04-01','10:15:00',1.54),('3355','2014-04-01','10:20:00',1.65),('3355','2014-04-01','10:25:00',1.73),('3355','2014-04-01','10:30:00',1.82),('3355','2014-04-01','10:35:00',1.74),('3355','2014-04-01','10:40:00',1.74),('3355','2014-04-01','10:45:00',1.89),('3355','2014-04-01','10:50:00',1.82),('3355','2014-04-01','10:55:00',1.93),('3355','2014-04-01','11:00:00',1.93),('3355','2014-04-01','11:05:00',1.97),('3355','2014-04-01','11:10:00',1.98),('3355','2014-04-01','11:15:00',2),('3355','2014-04-01','11:20:00',2.02),('3355','2014-04-01','11:25:00',2.03),('3355','2014-04-01','11:30:00',2.09),('3355','2014-04-01','11:35:00',2.13),('3355','2014-04-01','11:40:00',2.16),('3355','2014-04-01','11:45:00',2.17),('3355','2014-04-01','11:50:00',2.21),('3355','2014-04-01','11:55:00',2.2),('3355','2014-04-01','12:00:00',2.18),('3355','2014-04-01','12:05:00',2.26),('3355','2014-04-01','12:10:00',2.28),('3355','2014-04-01','12:15:00',2.29),('3355','2014-04-01','12:20:00',2.3),('3355','2014-04-01','12:25:00',2.33),('3355','2014-04-01','12:30:00',2.35),('3355','2014-04-01','12:35:00',2.38),('3355','2014-04-01','12:40:00',2.38),('3355','2014-04-01','12:45:00',2.39),('3355','2014-04-01','12:50:00',2.41),('3355','2014-04-01','12:55:00',2.4),('3355','2014-04-01','13:00:00',2.42),('3355','2014-04-01','13:05:00',2.43),('3355','2014-04-01','13:10:00',1.97),('3355','2014-04-01','13:15:00',2.46),('3355','2014-04-01','13:20:00',2.09),('3355','2014-04-01','13:25:00',2.42),('3355','2014-04-01','13:30:00',2.4),('3355','2014-04-01','13:35:00',2.42),('3355','2014-04-01','13:40:00',2.45),('3355','2014-04-01','13:45:00',2.44),('3355','2014-04-01','13:50:00',2.4),('3355','2014-04-01','13:55:00',2.41),('3355','2014-04-01','14:00:00',2.37),('3355','2014-04-01','14:05:00',2.39),('3355','2014-04-01','14:10:00',2.38),('3355','2014-04-01','14:15:00',1.66),('3355','2014-04-01','14:20:00',2.32),('3355','2014-04-01','14:25:00',2.32),('3355','2014-04-01','14:30:00',1.77),('3355','2014-04-01','14:35:00',2.33),('3355','2014-04-01','14:40:00',1.91),('3355','2014-04-01','14:45:00',2.32),('3355','2014-04-01','14:50:00',2.43),('3355','2014-04-01','14:55:00',1.9),('3355','2014-04-01','15:00:00',2.37),('3355','2014-04-01','15:05:00',2.21),('3355','2014-04-01','15:10:00',1.94),('3355','2014-04-01','15:15:00',2.36),('3355','2014-04-01','15:20:00',2.22),('3355','2014-04-01','15:25:00',1.81),('3355','2014-04-01','15:30:00',1.8),('3355','2014-04-01','15:35:00',1.68),('3355','2014-04-01','15:40:00',1.71),('3355','2014-04-01','15:45:00',1.59),('3355','2014-04-01','15:50:00',2.14),('3355','2014-04-01','15:55:00',1.79),('3355','2014-04-01','16:00:00',1.18),('3355','2014-04-01','16:05:00',1.53),('3355','2014-04-01','16:10:00',1.51),('3355','2014-04-01','16:15:00',1.51),('3355','2014-04-01','16:25:00',1.25),('3355','2014-04-01','16:30:00',1.42),('3355','2014-04-01','16:35:00',1.74),('3355','2014-04-01','16:40:00',1.7),('3355','2014-04-01','16:45:00',1.22),('3355','2014-04-01','16:55:00',1.26),('3355','2014-04-01','17:00:00',1.45),('3355','2014-04-01','17:05:00',1.26),('3355','2014-04-01','17:10:00',1.1),('3355','2014-04-01','17:15:00',1.27),('3355','2014-04-01','17:20:00',1.22),('3355','2014-04-01','17:25:00',1.16),('3355','2014-04-01','17:30:00',1.09),('3355','2014-04-01','17:35:00',1),('3355','2013-05-21','09:20:00',1.16),('3355','2013-05-21','09:25:00',1.31),('3355','2013-05-21','09:30:00',1.03),('3355','2013-05-21','09:35:00',1.09),('3355','2013-05-21','09:40:00',1.06),('3355','2013-05-21','10:00:00',1.05),('3355','2013-05-21','10:05:00',1.19),('3355','2013-05-21','10:10:00',1.25),('3355','2013-05-21','10:15:00',1.17),('3355','2013-05-21','10:20:00',1.15),('3355','2013-05-21','10:25:00',1.01),('3355','2013-05-21','10:35:00',1.01),('3355','2013-05-21','10:40:00',1.14),('3355','2013-05-21','10:45:00',1.62),('3355','2013-05-21','10:50:00',1.14),('3355','2013-05-21','11:00:00',1.07),('3355','2013-05-21','11:10:00',1.65),('3355','2013-05-21','11:15:00',2.1),('3355','2013-05-21','11:20:00',1.55),('3355','2013-05-21','11:25:00',1.95),('3355','2013-05-21','11:30:00',1.41),('3355','2013-05-21','11:35:00',1.68),('3355','2013-05-21','11:40:00',1.52),('3355','2013-05-21','11:45:00',1.79),('3355','2013-05-21','11:50:00',1.29),('3355','2013-05-21','11:55:00',1.92),('3355','2013-05-21','12:00:00',1.83),('3355','2013-05-21','12:05:00',1.9),('3355','2013-05-21','12:10:00',1.53),('3355','2013-05-21','12:15:00',1.88),('3355','2013-05-21','12:20:00',1.29),('3355','2013-05-21','12:25:00',1.69),('3355','2013-05-21','12:30:00',2.15),('3355','2013-05-21','12:35:00',1.34),('3355','2013-05-21','12:40:00',2.19),('3355','2013-05-21','12:45:00',2.19),('3355','2013-05-21','12:50:00',1.37),('3355','2013-05-21','12:55:00',2.21),('3355','2013-05-21','13:00:00',2.16),('3355','2013-05-21','13:05:00',2.36),('3355','2013-05-21','13:10:00',1.47),('3355','2013-05-21','13:15:00',2.23),('3355','2013-05-21','13:20:00',1.76),('3355','2013-05-21','13:25:00',1.75),('3355','2013-05-21','13:30:00',1.71),('3355','2013-05-21','14:15:00',1.05),('3355','2013-05-21','14:25:00',1.39),('3355','2013-05-21','14:30:00',1.22),('3355','2013-05-21','14:35:00',1.07),('3355','2013-05-21','14:40:00',1.03),('3355','2013-05-21','15:30:00',1.19),('3355','2013-05-21','16:35:00',1.04),('3355','2013-05-21','16:40:00',1.15),('3355','2013-05-21','16:45:00',1.02),('3355','2013-05-20','08:50:00',1.08),('3355','2013-05-20','08:55:00',1.35),('3355','2013-05-20','09:00:00',1.49),('3355','2013-05-20','09:05:00',1.53),('3355','2013-05-20','09:10:00',1.65),('3355','2013-05-20','09:15:00',1.21),('3355','2013-05-20','09:20:00',1.33),('3355','2013-05-20','09:35:00',1.1),('3355','2013-05-20','09:50:00',1.14),('3355','2013-05-20','10:35:00',1.02),('3355','2013-05-20','10:50:00',1.27),('3355','2013-05-20','10:55:00',1.54),('3355','2013-05-20','11:00:00',1.4),('3355','2013-05-20','11:05:00',2.28),('3355','2013-05-20','11:10:00',2.6),('3355','2013-05-20','11:15:00',2.56),('3355','2013-05-20','11:20:00',2.19),('3355','2013-05-20','11:25:00',2.04),('3355','2013-05-20','11:30:00',1.34),('3355','2013-05-20','11:35:00',1.79),('3355','2013-05-20','11:55:00',1.63),('3355','2013-05-20','12:00:00',1.51),('3355','2013-05-20','12:05:00',1.29),('3355','2013-05-20','12:10:00',2.54),('3355','2013-05-20','12:15:00',1.23),('3355','2013-05-20','12:20:00',1.52),('3355','2013-05-20','12:25:00',1.55),('3355','2013-05-20','12:30:00',1.54),('3355','2013-05-20','12:40:00',2.65),('3355','2013-05-20','12:45:00',2.88),('3355','2013-05-20','12:50:00',1.17),('3355','2013-05-20','13:00:00',1.4),('3355','2013-05-20','13:05:00',1.95),('3355','2013-05-20','13:20:00',1.31),('3355','2013-05-20','13:25:00',1.71),('3355','2013-05-20','13:30:00',1.86),('3355','2013-05-20','13:35:00',1.36),('3355','2013-05-20','13:40:00',1.78),('3355','2013-05-20','13:50:00',2.8),('3355','2013-05-20','13:55:00',1.58),('3355','2013-05-20','14:00:00',2.73),('3355','2013-05-20','14:05:00',1.48),('3355','2013-05-20','14:15:00',2.72),('3355','2013-05-20','14:20:00',1.59),('3355','2013-05-20','14:25:00',1.15),('3355','2013-05-20','14:30:00',1.46),('3355','2013-05-20','14:50:00',2.67),('3355','2013-05-20','14:55:00',1.31),('3355','2013-05-20','15:00:00',2),('3355','2013-05-20','15:10:00',2.22),('3355','2013-05-20','15:15:00',1.94),('3355','2013-05-20','15:20:00',1.27),('3355','2013-05-20','15:25:00',1.87),('3355','2013-05-20','15:30:00',1.01),('3355','2013-05-20','15:35:00',1.97),('3355','2013-05-20','15:40:00',1.68),('3355','2013-05-20','15:50:00',1.91),('3355','2013-05-20','16:00:00',1.52),('3355','2013-05-20','16:05:00',1.65),('3355','2013-05-20','16:10:00',1.35),('3355','2013-05-20','16:15:00',1.69),('3355','2013-05-20','16:20:00',2.07),('3355','2013-05-20','16:25:00',1.98),('3355','2013-05-20','16:30:00',1.92),('3355','2013-05-20','16:35:00',1.84),('3355','2013-05-20','16:40:00',1.82),('3355','2013-05-20','16:45:00',1.7),('3355','2013-05-20','16:50:00',1.66),('3355','2013-05-20','16:55:00',1.62),('3355','2013-05-20','17:00:00',1.57),('3355','2013-05-20','17:05:00',1.62),('3355','2013-05-20','17:10:00',1.09),('3355','2013-05-20','17:20:00',1.11),('3355','2013-05-20','17:25:00',1.47),('3355','2013-05-20','17:30:00',1.55),('3355','2013-05-20','17:35:00',1.29),('3355','2013-05-20','17:40:00',1.19),('3355','2013-05-20','17:45:00',1.14),('3355','2013-05-20','17:50:00',1.09),('3355','2013-05-20','17:55:00',1.03),('3355','2013-05-20','18:00:00',1),('3355','2013-05-20','18:05:00',1.04),('3355','2013-05-19','10:10:00',1.05),('3355','2013-05-19','10:15:00',1.77),('3355','2013-05-19','10:20:00',1.32),('3355','2013-05-19','10:25:00',1.42),('3355','2013-05-19','10:30:00',1.52),('3355','2013-05-19','10:40:00',1.05),('3355','2013-05-19','10:45:00',1.16),('3355','2013-05-19','11:00:00',1.02),('3355','2013-05-19','11:05:00',1.81),('3355','2013-05-19','11:10:00',1.51),('3355','2013-05-19','11:15:00',1.69),('3355','2013-05-19','11:20:00',2.36),('3355','2013-05-19','11:25:00',2.41),('3355','2013-05-19','11:30:00',2.37),('3355','2013-05-19','11:35:00',2.38),('3355','2013-05-19','11:40:00',2.47),('3355','2013-05-19','11:45:00',2.49),('3355','2013-05-19','11:50:00',2.48),('3355','2013-05-19','11:55:00',2.49),('3355','2013-05-19','12:00:00',2.5),('3355','2013-05-19','12:05:00',2.49),('3355','2013-05-19','12:10:00',2.5),('3355','2013-05-19','12:15:00',2.51),('3355','2013-05-19','12:20:00',2.64),('3355','2013-05-19','12:25:00',2.85),('3355','2013-05-19','12:30:00',2.42),('3355','2013-05-19','12:35:00',2.79),('3355','2013-05-19','12:40:00',2.78),('3355','2013-05-19','12:45:00',2.66),('3355','2013-05-19','12:50:00',1.95),('3355','2013-05-19','12:55:00',1.59),('3355','2013-05-19','13:00:00',2.26),('3355','2013-05-19','13:05:00',2.23),('3355','2013-05-19','13:10:00',2.02),('3355','2013-05-19','13:15:00',2),('3355','2013-05-19','13:20:00',2.26),('3355','2013-05-19','13:25:00',2.31),('3355','2013-05-19','13:30:00',2.54),('3355','2013-05-19','13:35:00',2.53),('3355','2013-05-19','13:40:00',2.5),('3355','2013-05-19','13:45:00',2.5),('3355','2013-05-19','13:50:00',2.5),('3355','2013-05-19','13:55:00',2.5),('3355','2013-05-19','14:00:00',2.49),('3355','2013-05-19','14:05:00',2.48),('3355','2013-05-19','14:10:00',2.46),('3355','2013-05-19','14:15:00',2.47),('3355','2013-05-19','14:20:00',2.46),('3355','2013-05-19','14:25:00',2.46),('3355','2013-05-19','14:30:00',2.46),('3355','2013-05-19','14:35:00',2.44),('3355','2013-05-19','14:40:00',2.43),('3355','2013-05-19','14:45:00',2.4),('3355','2013-05-19','14:50:00',2.39),('3355','2013-05-19','14:55:00',2.37),('3355','2013-05-19','15:00:00',2.37),('3355','2013-05-19','15:05:00',2.36),('3355','2013-05-19','15:10:00',2.32),('3355','2013-05-19','15:15:00',2.3),('3355','2013-05-19','15:20:00',2.27),('3355','2013-05-19','15:25:00',2.27),('3355','2013-05-19','15:30:00',2.24),('3355','2013-05-19','15:35:00',2.22),('3355','2013-05-19','15:40:00',2.16),('3355','2013-05-19','15:45:00',2.13),('3355','2013-05-19','15:50:00',2.11),('3355','2013-05-19','15:55:00',2.1),('3355','2013-05-19','16:00:00',2.05),('3355','2013-05-19','16:05:00',2.04),('3355','2013-05-19','16:10:00',2),('3355','2013-05-19','16:15:00',1.97),('3355','2013-05-19','16:20:00',1.93),('3355','2013-05-19','16:25:00',1.92),('3355','2013-05-19','16:30:00',1.86),('3355','2013-05-19','16:35:00',1.83),('3355','2013-05-19','16:40:00',1.8),('3355','2013-05-19','16:45:00',1.76),('3355','2013-05-19','16:50:00',1.72),('3355','2013-05-19','16:55:00',1.68),('3355','2013-05-19','17:00:00',1.64),('3355','2013-05-19','17:05:00',1.6),('3355','2013-05-19','17:10:00',1.55),('3355','2013-05-19','17:15:00',1.51),('3355','2013-05-19','17:20:00',1.47),('3355','2013-05-19','17:25:00',1.41),('3355','2013-05-19','17:30:00',1.36),('3355','2013-05-19','17:35:00',1.32),('3355','2013-05-19','17:40:00',1.27),('3355','2013-05-19','17:45:00',1.21),('3355','2013-05-19','17:50:00',1.17),('3355','2013-05-19','17:55:00',1.11),('3355','2013-05-19','18:00:00',1.05),('3355','2013-05-19','18:05:00',1.01),('3355','2013-05-18','08:25:00',1.22),('3355','2013-05-18','08:30:00',1.1),('3355','2013-05-18','08:40:00',1.07),('3355','2013-05-18','08:45:00',1.09),('3355','2013-05-18','08:50:00',1.14),('3355','2013-05-18','08:55:00',1.19),('3355','2013-05-18','09:00:00',1.25),('3355','2013-05-18','09:05:00',1.27),('3355','2013-05-18','09:10:00',1.34),('3355','2013-05-18','09:15:00',1.39),('3355','2013-05-18','09:20:00',1.42),('3355','2013-05-18','09:25:00',1.45),('3355','2013-05-18','09:30:00',1.5),('3355','2013-05-18','09:35:00',1.54),('3355','2013-05-18','09:40:00',1.57),('3355','2013-05-18','09:45:00',1.61),('3355','2013-05-18','09:50:00',1.64),('3355','2013-05-18','09:55:00',1.69),('3355','2013-05-18','10:00:00',1.72),('3355','2013-05-18','10:05:00',1.75),('3355','2013-05-18','10:10:00',1.8),('3355','2013-05-18','10:15:00',1.82),('3355','2013-05-18','10:20:00',1.85),('3355','2013-05-18','10:25:00',1.87),('3355','2013-05-18','10:30:00',1.9),('3355','2013-05-18','10:35:00',1.91),('3355','2013-05-18','10:40:00',1.94),('3355','2013-05-18','10:45:00',1.97),('3355','2013-05-18','10:50:00',2),('3355','2013-05-18','10:55:00',2.06),('3355','2013-05-18','11:00:00',2.15),('3355','2013-05-18','11:05:00',2.17),('3355','2013-05-18','11:10:00',1.7),('3355','2013-05-18','11:15:00',2.23),('3355','2013-05-18','11:20:00',2.25),('3355','2013-05-18','11:25:00',2.12),('3355','2013-05-18','11:30:00',2.25),('3355','2013-05-18','11:35:00',2.05),('3355','2013-05-18','11:40:00',2.17),('3355','2013-05-18','11:45:00',2.16),('3355','2013-05-18','11:50:00',2.13),('3355','2013-05-18','11:55:00',2.16),('3355','2013-05-18','12:00:00',2.31),('3355','2013-05-18','12:05:00',2.16),('3355','2013-05-18','12:10:00',2.2),('3355','2013-05-18','12:15:00',2.21),('3355','2013-05-18','12:20:00',2.24),('3355','2013-05-18','12:25:00',2.25),('3355','2013-05-18','12:30:00',1.75),('3355','2013-05-18','12:35:00',2.31),('3355','2013-05-18','12:40:00',2.29),('3355','2013-05-18','12:45:00',2.19),('3355','2013-05-18','12:50:00',2.27),('3355','2013-05-18','12:55:00',2.25),('3355','2013-05-18','13:00:00',2.24),('3355','2013-05-18','13:05:00',2.26),('3355','2013-05-18','13:10:00',2.28),('3355','2013-05-18','13:15:00',2.27),('3355','2013-05-18','13:20:00',2.27),('3355','2013-05-18','13:25:00',2.27),('3355','2013-05-18','13:30:00',2.3),('3355','2013-05-18','13:35:00',2.09),('3355','2013-05-18','13:40:00',2.33),('3355','2013-05-18','13:45:00',2.4),('3355','2013-05-18','13:50:00',2.02),('3355','2013-05-18','13:55:00',1.89),('3355','2013-05-18','14:00:00',1.93),('3355','2013-05-18','14:05:00',1.82),('3355','2013-05-18','14:10:00',2.38),('3355','2013-05-18','14:15:00',2.36),('3355','2013-05-18','14:20:00',2.29),('3355','2013-05-18','14:25:00',2.22),('3355','2013-05-18','14:30:00',2.27),('3355','2013-05-18','14:35:00',2),('3355','2013-05-18','14:40:00',2.34),('3355','2013-05-18','14:45:00',2.23),('3355','2013-05-18','14:50:00',1.81),('3355','2013-05-18','14:55:00',1.9),('3355','2013-05-18','15:00:00',1.98),('3355','2013-05-18','15:05:00',2.03),('3355','2013-05-18','15:10:00',1.99),('3355','2013-05-18','15:15:00',1.96),('3355','2013-05-18','15:20:00',1.93),('3355','2013-05-18','15:25:00',1.91),('3355','2013-05-18','15:30:00',1.89),('3355','2013-05-18','15:35:00',1.87),('3355','2013-05-18','15:40:00',1.84),('3355','2013-05-18','15:45:00',1.79),('3355','2013-05-18','15:50:00',1.77),('3355','2013-05-18','15:55:00',1.74),('3355','2013-05-18','16:00:00',1.71),('3355','2013-05-18','16:05:00',1.69),('3355','2013-05-18','16:10:00',1.66),('3355','2013-05-18','16:15:00',1.61),('3355','2013-05-18','16:20:00',1.59),('3355','2013-05-18','16:25:00',1.55),('3355','2013-05-18','16:30:00',1.52),('3355','2013-05-18','16:35:00',1.48),('3355','2013-05-18','16:40:00',1.45),('3355','2013-05-18','16:45:00',1.42),('3355','2013-05-18','16:50:00',1.37),('3355','2013-05-18','16:55:00',1.33),('3355','2013-05-18','17:00:00',1.3),('3355','2013-05-18','17:05:00',1.26),('3355','2013-05-18','17:10:00',1.23),('3355','2013-05-18','17:15:00',1.19),('3355','2013-05-18','17:20:00',1.15),('3355','2013-05-18','17:25:00',1.11),('3355','2013-05-18','17:30:00',1.04),('3355','2013-05-17','08:20:00',1.06),('3355','2013-05-17','10:50:00',1.3),('3355','2013-05-17','10:55:00',1.56),('3355','2013-05-17','11:00:00',1.19),('3355','2013-05-17','11:05:00',1.16),('3355','2013-05-17','11:15:00',1.01),('3355','2013-05-17','11:20:00',1.08),('3355','2013-05-17','11:30:00',1.24),('3355','2013-05-17','11:35:00',1.94),('3355','2013-05-17','11:55:00',1.1),('3355','2013-05-17','12:05:00',1.58),('3355','2013-05-17','12:10:00',1.71),('3355','2013-05-17','12:15:00',1.63),('3355','2013-05-17','12:20:00',1.01),('3355','2013-05-17','12:25:00',2.03),('3355','2013-05-17','12:30:00',1.54),('3355','2013-05-17','12:35:00',1.49),('3355','2013-05-17','12:40:00',2.6),('3355','2013-05-17','12:45:00',2.08),('3355','2013-05-17','12:50:00',2.49),('3355','2013-05-17','12:55:00',2.53),('3355','2013-05-17','13:00:00',2.08),('3355','2013-05-17','13:05:00',2.15),('3355','2013-05-17','13:10:00',1.9),('3355','2013-05-17','13:15:00',2.41),('3355','2013-05-17','13:20:00',2.41),('3355','2013-05-17','13:25:00',2.29),('3355','2013-05-17','13:30:00',1.56),('3355','2013-05-17','13:35:00',2.23),('3355','2013-05-17','13:40:00',2.01),('3355','2013-05-17','13:45:00',2.52),('3355','2013-05-17','13:50:00',2.52),('3355','2013-05-17','13:55:00',2.29),('3355','2013-05-17','14:00:00',2.06),('3355','2013-05-17','14:05:00',1.42),('3355','2013-05-17','14:10:00',2.12),('3355','2013-05-17','14:15:00',2.36),('3355','2013-05-17','14:20:00',2.63),('3355','2013-05-17','14:25:00',2.09),('3355','2013-05-17','14:30:00',2.14),('3355','2013-05-17','14:35:00',2.04),('3355','2013-05-17','14:40:00',1.34),('3355','2013-05-17','14:45:00',2.36),('3355','2013-05-17','14:50:00',1.52),('3355','2013-05-17','14:55:00',1.78),('3355','2013-05-17','15:00:00',2.03),('3355','2013-05-17','15:05:00',1.56),('3355','2013-05-17','15:10:00',1.04),('3355','2013-05-17','15:15:00',1.6),('3355','2013-05-17','15:20:00',1.32),('3355','2013-05-17','15:25:00',1.93),('3355','2013-05-17','15:30:00',1.73),('3355','2013-05-17','15:35:00',1.99),('3355','2013-05-17','15:40:00',1.99),('3355','2013-05-17','15:45:00',1.11),('3355','2013-05-17','15:50:00',1.39),('3355','2013-05-17','15:55:00',1.61),('3355','2013-05-17','16:15:00',1.86),('3355','2013-05-17','16:20:00',1.94),('3355','2013-05-17','16:25:00',1.89),('3355','2013-05-17','16:30:00',1.82),('3355','2013-05-17','16:35:00',1.72),('3355','2013-05-17','16:40:00',1.97),('3355','2013-05-17','16:45:00',1.76),('3355','2013-05-17','16:50:00',1.7),('3355','2013-05-17','16:55:00',1.61),('3355','2013-05-17','17:00:00',1.57),('3355','2013-05-17','17:05:00',1.53),('3355','2013-05-17','17:10:00',1.49),('3355','2013-05-17','17:15:00',1.45),('3355','2013-05-17','17:20:00',1.41),('3355','2013-05-17','17:25:00',1.35),('3355','2013-05-17','17:30:00',1.31),('3355','2013-05-17','17:35:00',1.26),('3355','2013-05-17','17:40:00',1.21),('3355','2013-05-17','17:45:00',1.16),('3355','2013-05-17','17:50:00',1.11),('3355','2013-05-17','17:55:00',1.06),('3355','2013-05-17','18:00:00',1.03),('3355','2013-05-16','09:40:00',1.08),('3355','2013-05-16','09:45:00',1.33),('3355','2013-05-16','10:20:00',1.15),('3355','2013-05-16','10:25:00',1.39),('3355','2013-05-16','10:30:00',1.05),('3355','2013-05-16','10:55:00',1.02),('3355','2013-05-16','11:00:00',2.18),('3355','2013-05-16','11:05:00',1.85),('3355','2013-05-16','11:10:00',1.44),('3355','2013-05-16','11:35:00',1.3),('3355','2013-05-16','11:40:00',2.19),('3355','2013-05-16','11:45:00',2.11),('3355','2013-05-16','11:50:00',1.94),('3355','2013-05-16','11:55:00',1.22),('3355','2013-05-16','12:15:00',1.53),('3355','2013-05-16','12:20:00',1.06),('3355','2013-05-16','12:25:00',1.26),('3355','2013-05-16','12:30:00',1.74),('3355','2013-05-16','12:35:00',1.88),('3355','2013-05-16','12:40:00',1.79),('3355','2013-05-16','12:45:00',1.73),('3355','2013-05-16','12:50:00',1.47),('3355','2013-05-16','12:55:00',2.44),('3355','2013-05-16','13:00:00',2.28),('3355','2013-05-16','13:05:00',2),('3355','2013-05-16','13:10:00',2.27),('3355','2013-05-16','13:15:00',2.17),('3355','2013-05-16','13:20:00',2.33),('3355','2013-05-16','13:25:00',2.27),('3355','2013-05-16','13:30:00',2.24),('3355','2013-05-16','13:35:00',2.23),('3355','2013-05-16','13:40:00',2.2),('3355','2013-05-16','13:45:00',2.2),('3355','2013-05-16','13:50:00',2.18),('3355','2013-05-16','13:55:00',2.2),('3355','2013-05-16','14:00:00',2.18),('3355','2013-05-16','14:05:00',2.18),('3355','2013-05-16','14:10:00',2.16),('3355','2013-05-16','14:15:00',2.13),('3355','2013-05-16','14:20:00',2.14),('3355','2013-05-16','14:25:00',2.08),('3355','2013-05-16','14:30:00',2.08),('3355','2013-05-16','14:35:00',2.05),('3355','2013-05-16','14:40:00',2.04),('3355','2013-05-16','14:45:00',2.04),('3355','2013-05-16','14:50:00',1.93),('3355','2013-05-16','14:55:00',1.71),('3355','2013-05-16','15:00:00',1.96),('3355','2013-05-16','15:05:00',1.99),('3355','2013-05-16','15:10:00',1.97),('3355','2013-05-16','15:15:00',1.75),('3355','2013-05-16','15:20:00',1.89),('3355','2013-05-16','15:25:00',1.89),('3355','2013-05-16','15:30:00',1.84),('3355','2013-05-16','15:35:00',1.78),('3355','2013-05-16','15:40:00',1.83),('3355','2013-05-16','15:45:00',1.77),('3355','2013-05-16','15:50:00',1.76),('3355','2013-05-16','15:55:00',1.75),('3355','2013-05-16','16:00:00',1.73),('3355','2013-05-16','16:05:00',1.66),('3355','2013-05-16','16:10:00',1.64),('3355','2013-05-16','16:15:00',1.55),('3355','2013-05-16','16:20:00',1.61),('3355','2013-05-16','16:25:00',1.54),('3355','2013-05-16','16:30:00',1.54),('3355','2013-05-16','16:35:00',1.48),('3355','2013-05-16','16:50:00',1.18),('3355','2013-05-16','17:35:00',1.06),('3355','2013-05-15','08:40:00',1.02),('3355','2013-05-15','08:45:00',1.07),('3355','2013-05-15','08:50:00',1.13),('3355','2013-05-15','08:55:00',1.17),('3355','2013-05-15','09:00:00',1.14),('3355','2013-05-15','09:05:00',1.25),('3355','2013-05-15','09:10:00',1.24),('3355','2013-05-15','09:15:00',1.3),('3355','2013-05-15','09:20:00',1.3),('3355','2013-05-15','09:25:00',1.08),('3355','2013-05-15','09:30:00',1.44),('3355','2013-05-15','09:35:00',1.49),('3355','2013-05-15','09:40:00',1.48),('3355','2013-05-15','09:45:00',1.53),('3355','2013-05-15','09:50:00',1.59),('3355','2013-05-15','09:55:00',1.6),('3355','2013-05-15','10:00:00',1.65),('3355','2013-05-15','10:05:00',1.69),('3355','2013-05-15','10:10:00',1.75),('3355','2013-05-15','10:15:00',1.71),('3355','2013-05-15','10:20:00',1.79),('3355','2013-05-15','10:25:00',1.84),('3355','2013-05-15','10:30:00',1.79),('3355','2013-05-15','10:35:00',1.84),('3355','2013-05-15','10:40:00',1.91),('3355','2013-05-15','10:45:00',1.94),('3355','2013-05-15','10:50:00',1.95),('3355','2013-05-15','10:55:00',1.89),('3355','2013-05-15','11:00:00',1.92),('3355','2013-05-15','11:05:00',2.03),('3355','2013-05-15','11:10:00',2.02),('3355','2013-05-15','11:15:00',2.07),('3355','2013-05-15','11:20:00',1.97),('3355','2013-05-15','11:25:00',2.05),('3355','2013-05-15','11:30:00',2.17),('3355','2013-05-15','11:35:00',2.03),('3355','2013-05-15','11:40:00',1.78),('3355','2013-05-15','11:45:00',1.56),('3355','2013-05-15','11:50:00',1.45),('3355','2013-05-15','11:55:00',1.03),('3355','2013-05-15','12:00:00',1.12),('3355','2013-05-15','12:05:00',1.85),('3355','2013-05-15','12:10:00',2.45),('3355','2013-05-15','12:15:00',2.37),('3355','2013-05-15','12:20:00',1.43),('3355','2013-05-15','12:25:00',1.84),('3355','2013-05-15','12:30:00',1.54),('3355','2013-05-15','12:35:00',1.49),('3355','2013-05-15','12:40:00',2.56),('3355','2013-05-15','12:45:00',1.35),('3355','2013-05-15','12:50:00',1.34),('3355','2013-05-15','12:55:00',1.51),('3355','2013-05-15','13:00:00',1.56),('3355','2013-05-15','13:05:00',1.7),('3355','2013-05-15','13:10:00',1.67),('3355','2013-05-15','13:15:00',1.24),('3355','2013-05-15','13:20:00',1.52),('3355','2013-05-15','13:25:00',1.44),('3355','2013-05-15','13:30:00',1.52),('3355','2013-05-15','13:35:00',1.34),('3355','2013-05-15','13:40:00',1.39),('3355','2013-05-15','13:45:00',1.39),('3355','2013-05-15','13:50:00',1.16),('3355','2013-05-15','13:55:00',1.11),('3355','2013-05-15','15:55:00',1.04),('3355','2013-05-15','16:00:00',1.04),('3355','2013-05-15','17:05:00',1.1),('3355','2013-05-15','17:10:00',1.06),('3355','2013-05-15','17:15:00',1.48),('3355','2013-05-15','17:20:00',1.27),('3355','2013-05-14','08:35:00',1.03),('3355','2013-05-14','08:40:00',1.08),('3355','2013-05-14','08:45:00',1.13),('3355','2013-05-14','08:50:00',1.17),('3355','2013-05-14','08:55:00',1.23),('3355','2013-05-14','09:00:00',1.27),('3355','2013-05-14','09:05:00',1.32),('3355','2013-05-14','09:10:00',1.36),('3355','2013-05-14','09:15:00',1.41),('3355','2013-05-14','09:20:00',1.45),('3355','2013-05-14','09:25:00',1.49),('3355','2013-05-14','09:30:00',1.53),('3355','2013-05-14','09:35:00',1.57),('3355','2013-05-14','09:40:00',1.61),('3355','2013-05-14','09:45:00',1.64),('3355','2013-05-14','09:50:00',1.69),('3355','2013-05-14','09:55:00',1.73),('3355','2013-05-14','10:00:00',1.76),('3355','2013-05-14','10:05:00',1.8),('3355','2013-05-14','10:10:00',1.82),('3355','2013-05-14','10:15:00',1.85),('3355','2013-05-14','10:20:00',1.9),('3355','2013-05-14','10:25:00',1.91),('3355','2013-05-14','10:30:00',1.94),('3355','2013-05-14','10:35:00',1.96),('3355','2013-05-14','10:40:00',1.99),('3355','2013-05-14','10:45:00',2.01),('3355','2013-05-14','10:50:00',2.05),('3355','2013-05-14','10:55:00',2.07),('3355','2013-05-14','11:00:00',2.09),('3355','2013-05-14','11:05:00',2.11),('3355','2013-05-14','11:10:00',2.13),('3355','2013-05-14','11:15:00',2.14),('3355','2013-05-14','11:20:00',2.15),('3355','2013-05-14','11:25:00',2.16),('3355','2013-05-14','11:30:00',2.2),('3355','2013-05-14','11:35:00',2.22),('3355','2013-05-14','11:40:00',2.22),('3355','2013-05-14','11:45:00',2.25),('3355','2013-05-14','11:50:00',2.26),('3355','2013-05-14','11:55:00',2.28),('3355','2013-05-14','12:00:00',2.28),('3355','2013-05-14','12:05:00',2.29),('3355','2013-05-14','12:10:00',2.29),('3355','2013-05-14','12:15:00',2.3),('3355','2013-05-14','12:20:00',2.31),('3355','2013-05-14','12:25:00',2.34),('3355','2013-05-14','12:30:00',2.36),('3355','2013-05-14','12:35:00',2.35),('3355','2013-05-14','12:40:00',2.35),('3355','2013-05-14','12:45:00',2.35),('3355','2013-05-14','12:50:00',2.35),('3355','2013-05-14','12:55:00',2.36),('3355','2013-05-14','13:00:00',2.36),('3355','2013-05-14','13:05:00',2.35),('3355','2013-05-14','13:10:00',2.37),('3355','2013-05-14','13:15:00',2.37),('3355','2013-05-14','13:20:00',2.36),('3355','2013-05-14','13:25:00',2.34),('3355','2013-05-14','13:30:00',2.34),('3355','2013-05-14','13:35:00',2.34),('3355','2013-05-14','13:40:00',2.34),('3355','2013-05-14','13:45:00',2.33),('3355','2013-05-14','13:50:00',2.32),('3355','2013-05-14','13:55:00',2.3),('3355','2013-05-14','14:00:00',2.31),('3355','2013-05-14','14:05:00',2.31),('3355','2013-05-14','14:10:00',2.3),('3355','2013-05-14','14:15:00',2.29),('3355','2013-05-14','14:20:00',2.27),('3355','2013-05-14','14:25:00',2.25),('3355','2013-05-14','14:30:00',2.24),('3355','2013-05-14','14:35:00',2.23),('3355','2013-05-14','14:40:00',2.23),('3355','2013-05-14','14:45:00',2.24),('3355','2013-05-14','14:50:00',2.25),('3355','2013-05-14','14:55:00',2.24),('3355','2013-05-14','15:00:00',2.24),('3355','2013-05-14','15:05:00',2.24),('3355','2013-05-14','15:10:00',2.23),('3355','2013-05-14','15:15:00',2.21),('3355','2013-05-14','15:20:00',2.19),('3355','2013-05-14','15:25:00',2.18),('3355','2013-05-14','15:30:00',2.15),('3355','2013-05-14','15:35:00',2.12),('3355','2013-05-14','15:40:00',2.09),('3355','2013-05-14','15:45:00',2.07),('3355','2013-05-14','15:50:00',2.04),('3355','2013-05-14','15:55:00',2.01),('3355','2013-05-14','16:00:00',1.98),('3355','2013-05-14','16:05:00',1.95),('3355','2013-05-14','16:10:00',1.92),('3355','2013-05-14','16:15:00',1.89),('3355','2013-05-14','16:20:00',1.85),('3355','2013-05-14','16:25:00',1.82),('3355','2013-05-14','16:30:00',1.77),('3355','2013-05-14','16:35:00',1.74),('3355','2013-05-14','16:40:00',1.7),('3355','2013-05-14','16:45:00',1.66),('3355','2013-05-14','16:50:00',1.63),('3355','2013-05-14','16:55:00',1.59),('3355','2013-05-14','17:00:00',1.54),('3355','2013-05-14','17:05:00',1.5),('3355','2013-05-14','17:10:00',1.45),('3355','2013-05-14','17:15:00',1.41),('3355','2013-05-14','17:20:00',1.36),('3355','2013-05-14','17:25:00',1.31),('3355','2013-05-14','17:30:00',1.26),('3355','2013-05-14','17:35:00',1.21),('3355','2013-05-14','17:40:00',1.16),('3355','2013-05-14','17:45:00',1.12),('3355','2013-05-14','17:50:00',1.07),('3355','2013-05-14','17:55:00',1),('3355','2013-05-13','08:45:00',1.04),('3355','2013-05-13','08:50:00',1.09),('3355','2013-05-13','08:55:00',1.14),('3355','2013-05-13','09:00:00',1.18),('3355','2013-05-13','09:05:00',1.22),('3355','2013-05-13','09:10:00',1.27),('3355','2013-05-13','09:15:00',1.31),('3355','2013-05-13','09:20:00',1.38),('3355','2013-05-13','09:25:00',1.41),('3355','2013-05-13','09:30:00',1.46),('3355','2013-05-13','09:35:00',1.49),('3355','2013-05-13','09:40:00',1.54),('3355','2013-05-13','09:45:00',1.57),('3355','2013-05-13','09:50:00',1.66),('3355','2013-05-13','09:55:00',1.72),('3355','2013-05-13','10:00:00',1.75),('3355','2013-05-13','10:05:00',1.78),('3355','2013-05-13','10:10:00',1.82),('3355','2013-05-13','10:15:00',1.92),('3355','2013-05-13','10:20:00',1.96),('3355','2013-05-13','10:25:00',1.46),('3355','2013-05-13','10:30:00',1.95),('3355','2013-05-13','10:45:00',1.86),('3355','2013-05-13','10:50:00',1.89),('3355','2013-05-13','10:55:00',1.08),('3355','2013-05-13','11:00:00',1.6),('3355','2013-05-13','11:05:00',1.27),('3355','2013-05-13','11:15:00',1.44),('3355','2013-05-13','11:25:00',1.09),('3355','2013-05-13','11:30:00',1.56),('3355','2013-05-13','11:35:00',1.34),('3355','2013-05-13','11:40:00',1.14),('3355','2013-05-13','11:45:00',1.44),('3355','2013-05-13','12:10:00',1.48),('3355','2013-05-13','12:15:00',1.68),('3355','2013-05-13','12:30:00',1.71),('3355','2013-05-13','12:35:00',2.02),('3355','2013-05-13','12:40:00',1.15),('3355','2013-05-13','12:45:00',1.4),('3355','2013-05-13','12:50:00',1.53),('3355','2013-05-13','12:55:00',2.7),('3355','2013-05-13','13:00:00',2.66),('3355','2013-05-13','13:05:00',1.53),('3355','2013-05-13','13:10:00',2.28),('3355','2013-05-13','13:15:00',2.64),('3355','2013-05-13','13:20:00',2.23),('3355','2013-05-13','13:25:00',2.64),('3355','2013-05-13','13:30:00',2.64),('3355','2013-05-13','13:35:00',2.08),('3355','2013-05-13','13:40:00',1.49),('3355','2013-05-13','14:05:00',1.48),('3355','2013-05-13','14:10:00',2.73),('3355','2013-05-13','14:15:00',2.59),('3355','2013-05-13','14:20:00',2.42),('3355','2013-05-13','14:25:00',1.1),('3355','2013-05-13','14:35:00',2.21),('3355','2013-05-13','14:40:00',2.52),('3355','2013-05-13','14:45:00',1.69),('3355','2013-05-13','14:55:00',2.55),('3355','2013-05-13','15:00:00',2.37),('3355','2013-05-13','15:05:00',1.31),('3355','2013-05-13','16:10:00',1.11),('3355','2013-05-13','16:40:00',1.06),('3355','2013-05-13','16:45:00',1.49),('3355','2013-05-13','16:50:00',2.01),('3355','2013-05-13','16:55:00',1.85),('3355','2013-05-13','17:00:00',1.73),('3355','2013-05-13','17:05:00',1.47),('3355','2013-05-13','17:10:00',1.17),('3355','2013-05-13','17:15:00',1.66),('3355','2013-05-13','17:20:00',1.76),('3355','2013-05-13','17:25:00',1.6),('3355','2013-05-13','17:30:00',1.23),('3355','2013-05-13','17:35:00',1.39),('3355','2013-05-13','17:40:00',1.26),('3355','2013-05-13','17:45:00',1.12),('3355','2013-05-13','17:50:00',1.02),('3355','2013-05-12','09:25:00',1.09),('3355','2013-05-12','09:30:00',1.55),('3355','2013-05-12','09:40:00',1.12),('3355','2013-05-12','09:45:00',2.01),('3355','2013-05-12','09:50:00',1.84),('3355','2013-05-12','09:55:00',1.82),('3355','2013-05-12','10:00:00',1.75),('3355','2013-05-12','10:05:00',1.12),('3355','2013-05-12','10:55:00',2.46),('3355','2013-05-12','11:00:00',1.13),('3355','2013-05-12','11:15:00',1.01),('3355','2013-05-12','11:20:00',1.43),('3355','2013-05-12','11:25:00',1.57),('3355','2013-05-12','11:30:00',2.54),('3355','2013-05-12','11:35:00',1.96),('3355','2013-05-12','11:40:00',2.47),('3355','2013-05-12','11:45:00',2.52),('3355','2013-05-12','11:50:00',2.27),('3355','2013-05-12','11:55:00',1.97),('3355','2013-05-12','12:00:00',1.19),('3355','2013-05-12','12:05:00',1.55),('3355','2013-05-12','12:10:00',2.75),('3355','2013-05-12','12:15:00',1.55),('3355','2013-05-12','12:45:00',1.49),('3355','2013-05-12','12:50:00',2.83),('3355','2013-05-12','12:55:00',1.08),('3355','2013-05-12','13:10:00',1.32),('3355','2013-05-12','13:15:00',1.45),('3355','2013-05-12','13:25:00',1.26),('3355','2013-05-12','13:30:00',2.36),('3355','2013-05-12','13:35:00',2.55),('3355','2013-05-12','13:40:00',1.96),('3355','2013-05-12','13:45:00',2.79),('3355','2013-05-12','13:50:00',1.64),('3355','2013-05-12','13:55:00',2.17),('3355','2013-05-12','14:00:00',1.29),('3355','2013-05-12','14:05:00',2.81),('3355','2013-05-12','14:10:00',1.7),('3355','2013-05-12','14:15:00',2.39),('3355','2013-05-12','14:20:00',2.56),('3355','2013-05-12','14:25:00',2.54),('3355','2013-05-12','14:30:00',2.5),('3355','2013-05-12','14:35:00',2.39),('3355','2013-05-12','14:40:00',2.14),('3355','2013-05-12','14:45:00',2.42),('3355','2013-05-12','14:50:00',2.21),('3355','2013-05-12','14:55:00',2.39),('3355','2013-05-12','15:00:00',2.38),('3355','2013-05-12','15:05:00',2.35),('3355','2013-05-12','15:10:00',2.36),('3355','2013-05-12','15:15:00',2.35),('3355','2013-05-12','15:20:00',2.04),('3355','2013-05-12','15:25:00',1.78),('3355','2013-05-12','15:30:00',1.85),('3355','2013-05-12','15:35:00',2.15),('3355','2013-05-12','15:40:00',2.11),('3355','2013-05-12','15:45:00',2.07),('3355','2013-05-12','15:50:00',2.02),('3355','2013-05-12','15:55:00',2),('3355','2013-05-12','16:00:00',1.96),('3355','2013-05-12','16:05:00',1.92),('3355','2013-05-12','16:10:00',1.89),('3355','2013-05-12','16:15:00',1.86),('3355','2013-05-12','16:20:00',1.84),('3355','2013-05-12','16:25:00',1.79),('3355','2013-05-12','16:30:00',1.76),('3355','2013-05-12','16:35:00',1.74),('3355','2013-05-12','16:40:00',1.75),('3355','2013-05-12','16:45:00',1.82),('3355','2013-05-12','16:50:00',1.76),('3355','2013-05-12','16:55:00',1.85),('3355','2013-05-12','17:00:00',1.94),('3355','2013-05-12','17:05:00',1.71),('3355','2013-05-12','17:10:00',1.7),('3355','2013-05-12','17:15:00',1.79),('3355','2013-05-12','17:20:00',1.64),('3355','2013-05-12','17:25:00',1.3),('3355','2013-05-12','17:30:00',1.31),('3355','2013-05-12','17:40:00',1.16),('3355','2014-03-31','09:15:00',1.04),('3355','2014-03-31','09:20:00',1.09),('3355','2014-03-31','09:25:00',1.14),('3355','2014-03-31','09:30:00',1.19),('3355','2014-03-31','09:35:00',1.24),('3355','2014-03-31','09:40:00',1.28),('3355','2014-03-31','09:45:00',1.32),('3355','2014-03-31','09:50:00',1.36),('3355','2014-03-31','09:55:00',1.4),('3355','2014-03-31','10:00:00',1.44),('3355','2014-03-31','10:05:00',1.49),('3355','2014-03-31','10:10:00',1.53),('3355','2014-03-31','10:15:00',1.57),('3355','2014-03-31','10:20:00',1.61),('3355','2014-03-31','10:25:00',1.64),('3355','2014-03-31','10:30:00',1.66),('3355','2014-03-31','10:35:00',1.7),('3355','2014-03-31','10:40:00',1.73),('3355','2014-03-31','10:45:00',1.77),('3355','2014-03-31','10:50:00',1.81),('3355','2014-03-31','10:55:00',1.85),('3355','2014-03-31','11:00:00',1.87),('3355','2014-03-31','11:05:00',1.9),('3355','2014-03-31','11:10:00',1.92),('3355','2014-03-31','11:15:00',1.95),('3355','2014-03-31','11:20:00',1.98),('3355','2014-03-31','11:25:00',2),('3355','2014-03-31','11:30:00',2),('3355','2014-03-31','11:35:00',2.02),('3355','2014-03-31','11:40:00',2.05),('3355','2014-03-31','11:45:00',2.06),('3355','2014-03-31','11:50:00',2.07),('3355','2014-03-31','11:55:00',2.1),('3355','2014-03-31','12:00:00',2.15),('3355','2014-03-31','12:05:00',2.15),('3355','2014-03-31','12:10:00',2.15),('3355','2014-03-31','12:15:00',2.15),('3355','2014-03-31','12:20:00',2.18),('3355','2014-03-31','12:25:00',2.19),('3355','2014-03-31','12:30:00',2.2),('3355','2014-03-31','12:35:00',2.21),('3355','2014-03-31','12:40:00',2.23),('3355','2014-03-31','12:45:00',2.24),('3355','2014-03-31','12:50:00',2.22),('3355','2014-03-31','12:55:00',2.22),('3355','2014-03-31','13:00:00',2.23),('3355','2014-03-31','13:05:00',2.25),('3355','2014-03-31','13:10:00',2.26),('3355','2014-03-31','13:15:00',2.25),('3355','2014-03-31','13:20:00',2.26),('3355','2014-03-31','13:25:00',2.26),('3355','2014-03-31','13:30:00',2.27),('3355','2014-03-31','13:35:00',2.28),('3355','2014-03-31','13:40:00',2.28),('3355','2014-03-31','13:45:00',2.28),('3355','2014-03-31','13:50:00',2.28),('3355','2014-03-31','13:55:00',2.27),('3355','2014-03-31','14:00:00',2.26),('3355','2014-03-31','14:05:00',2.26),('3355','2014-03-31','14:10:00',2.25),('3355','2014-03-31','14:15:00',2.25),('3355','2014-03-31','14:20:00',2.25),('3355','2014-03-31','14:25:00',2.24),('3355','2014-03-31','14:30:00',2.24),('3355','2014-03-31','14:35:00',2.22),('3355','2014-03-31','14:40:00',2.2),('3355','2014-03-31','14:45:00',2.2),('3355','2014-03-31','14:50:00',2.18),('3355','2014-03-31','14:55:00',2.15),('3355','2014-03-31','15:00:00',2.15),('3355','2014-03-31','15:05:00',2.13),('3355','2014-03-31','15:10:00',2.12),('3355','2014-03-31','15:15:00',2.09),('3355','2014-03-31','15:20:00',2.06),('3355','2014-03-31','15:25:00',2.02),('3355','2014-03-31','15:30:00',2),('3355','2014-03-31','15:35:00',1.97),('3355','2014-03-31','15:40:00',1.94),('3355','2014-03-31','15:45:00',1.92),('3355','2014-03-31','15:50:00',1.88),('3355','2014-03-31','15:55:00',1.84),('3355','2014-03-31','16:00:00',1.81),('3355','2014-03-31','16:05:00',1.77),('3355','2014-03-31','16:10:00',1.73),('3355','2014-03-31','16:15:00',1.69),('3355','2014-03-31','16:20:00',1.66),('3355','2014-03-31','16:25:00',1.62),('3355','2014-03-31','16:30:00',1.58),('3355','2014-03-31','16:35:00',1.53),('3355','2014-03-31','16:40:00',1.49),('3355','2014-03-31','16:45:00',1.45),('3355','2014-03-31','16:50:00',1.42),('3355','2014-03-31','16:55:00',1.36),('3355','2014-03-31','17:00:00',1.32),('3355','2014-03-31','17:05:00',1.26),('3355','2014-03-31','17:10:00',1.23),('3355','2014-03-31','17:15:00',1.17),('3355','2014-03-31','17:20:00',1.11),('3355','2014-03-31','17:25:00',1.06),('3355','2014-03-31','17:30:00',1),('3355','2013-05-11','09:35:00',1.52),('3355','2013-05-11','09:40:00',1.19),('3355','2013-05-11','09:45:00',1.54),('3355','2013-05-11','10:55:00',1.81),('3355','2013-05-11','11:00:00',1.35),('3355','2013-05-11','11:05:00',1.42),('3355','2013-05-11','11:35:00',1.43),('3355','2013-05-11','11:40:00',1.21),('3355','2013-05-11','11:45:00',2.05),('3355','2013-05-11','11:50:00',1.4),('3355','2013-05-11','12:25:00',2.27),('3355','2013-05-11','12:30:00',1.88),('3355','2013-05-11','12:40:00',1.05),('3355','2013-05-11','12:45:00',1.18),('3355','2013-05-11','12:50:00',1.26),('3355','2013-05-11','14:05:00',1.39),('3355','2013-05-11','14:10:00',1.87),('3355','2013-05-11','14:15:00',1.59),('3355','2013-05-11','14:20:00',2.58),('3355','2013-05-11','14:25:00',2.58),('3355','2013-05-11','14:30:00',1.87),('3355','2013-05-11','14:35:00',1.52),('3355','2013-05-11','14:40:00',2.68),('3355','2013-05-11','14:45:00',2.28),('3355','2013-05-11','14:50:00',2.53),('3355','2013-05-11','14:55:00',2.44),('3355','2013-05-11','15:00:00',2.36),('3355','2013-05-11','15:05:00',2.33),('3355','2013-05-11','15:10:00',2.04),('3355','2013-05-11','15:15:00',2.33),('3355','2013-05-11','15:20:00',2),('3355','2013-05-11','15:25:00',2.25),('3355','2013-05-11','15:30:00',2.21),('3355','2013-05-11','15:35:00',2.19),('3355','2013-05-11','15:40:00',2.17),('3355','2013-05-11','15:45:00',2.08),('3355','2013-05-11','15:50:00',2.23),('3355','2013-05-11','15:55:00',2.12),('3355','2013-05-11','16:00:00',1.15),('3355','2013-05-11','16:05:00',1.84),('3355','2013-05-11','16:10:00',1.79),('3355','2013-05-11','16:15:00',1.67),('3355','2013-05-11','16:20:00',1.63),('3355','2013-05-11','16:25:00',1.8),('3355','2013-05-11','16:30:00',1.89),('3355','2013-05-11','16:35:00',1.83),('3355','2013-05-11','16:40:00',1.6),('3355','2013-05-11','16:45:00',1.72),('3355','2013-05-11','16:50:00',1.62),('3355','2013-05-11','16:55:00',1.6),('3355','2013-05-11','17:00:00',1.44),('3355','2013-05-11','17:05:00',1.57),('3355','2013-05-11','17:10:00',1.48),('3355','2013-05-11','17:15:00',1.12),('3355','2013-05-11','17:20:00',1.37),('3355','2013-05-11','17:25:00',1.02),('3355','2013-05-11','17:35:00',1.3),('3355','2013-05-11','17:40:00',1.05),('3355','2013-05-11','17:45:00',1.3),('3355','2013-05-11','17:55:00',1.09),('3355','2013-05-11','18:10:00',1.11),('3355','2013-05-10','08:15:00',1.02),('3355','2013-05-10','09:05:00',1.11),('3355','2013-05-10','09:10:00',1.33),('3355','2013-05-10','09:15:00',1.38),('3355','2013-05-10','09:20:00',1.34),('3355','2013-05-10','09:25:00',1.26),('3355','2013-05-10','09:30:00',1.15),('3355','2013-05-10','09:35:00',1.46),('3355','2013-05-10','09:40:00',1.37),('3355','2013-05-10','09:45:00',1.33),('3355','2013-05-10','09:50:00',1.69),('3355','2013-05-10','09:55:00',1.71),('3355','2013-05-10','10:00:00',1.5),('3355','2013-05-10','10:05:00',1.76),('3355','2013-05-10','10:10:00',1.39),('3355','2013-05-10','10:15:00',1.29),('3355','2013-05-10','10:20:00',1.96),('3355','2013-05-10','10:30:00',1.05),('3355','2013-05-10','10:35:00',1.63),('3355','2013-05-10','10:40:00',2.06),('3355','2013-05-10','10:45:00',2.07),('3355','2013-05-10','10:50:00',2.13),('3355','2013-05-10','10:55:00',2.09),('3355','2013-05-10','11:00:00',2.15),('3355','2013-05-10','11:05:00',2.13),('3355','2013-05-10','11:10:00',2.08),('3355','2013-05-10','11:15:00',1.98),('3355','2013-05-10','11:20:00',2.31),('3355','2013-05-10','11:25:00',2.07),('3355','2013-05-10','11:30:00',1.78),('3355','2013-05-10','11:35:00',2.13),('3355','2013-05-10','11:40:00',1.7),('3355','2013-05-10','11:45:00',1.12),('3355','2013-05-10','11:50:00',1.53),('3355','2013-05-10','11:55:00',2.05),('3355','2013-05-10','12:00:00',2.29),('3355','2013-05-10','12:05:00',1.87),('3355','2013-05-10','12:10:00',1.61),('3355','2013-05-10','12:15:00',1.29),('3355','2013-05-10','12:20:00',1.49),('3355','2013-05-10','12:25:00',1.23),('3355','2013-05-10','12:30:00',1.13),('3355','2013-05-10','12:35:00',1.13),('3355','2013-05-10','12:40:00',2.01),('3355','2013-05-10','12:45:00',2.5),('3355','2013-05-10','12:50:00',1.97),('3355','2013-05-10','12:55:00',1.6),('3355','2013-05-10','13:00:00',2.31),('3355','2013-05-10','13:05:00',1.93),('3355','2013-05-10','13:10:00',2.09),('3355','2013-05-10','13:15:00',2.65),('3355','2013-05-10','13:20:00',1.82),('3355','2013-05-10','13:25:00',1.67),('3355','2013-05-10','13:30:00',1.8),('3355','2013-05-10','13:35:00',2.4),('3355','2013-05-10','13:40:00',2.34),('3355','2013-05-10','13:45:00',2.18),('3355','2013-05-10','13:50:00',1.38),('3355','2013-05-10','13:55:00',1.16),('3355','2013-05-10','14:00:00',1.06),('3355','2013-05-10','14:05:00',1.08),('3355','2013-05-10','14:10:00',1.28),('3355','2013-05-10','14:15:00',1.41),('3355','2013-05-10','14:20:00',1.42),('3355','2013-05-10','14:25:00',1.38),('3355','2013-05-10','14:30:00',1.4),('3355','2013-05-10','14:35:00',1.74),('3355','2013-05-10','14:40:00',1.56),('3355','2013-05-10','14:45:00',1.18),('3355','2013-05-10','15:15:00',1.5),('3355','2013-05-10','15:20:00',1.68),('3355','2013-05-10','15:25:00',1.14),('3355','2013-05-10','15:30:00',1.04),('3355','2013-05-10','15:35:00',1.09),('3355','2013-05-10','15:40:00',1.13),('3355','2013-05-10','15:45:00',1.09),('3355','2013-05-10','17:20:00',1.19),('3355','2013-05-10','17:25:00',1.16),('3355','2013-05-10','17:35:00',1.28),('3355','2013-05-09','08:40:00',1),('3355','2013-05-09','08:45:00',1.06),('3355','2013-05-09','08:50:00',1.1),('3355','2013-05-09','08:55:00',1.14),('3355','2013-05-09','09:00:00',1.2),('3355','2013-05-09','09:05:00',1.24),('3355','2013-05-09','09:10:00',1.29),('3355','2013-05-09','09:15:00',1.34),('3355','2013-05-09','09:20:00',1.38),('3355','2013-05-09','09:25:00',1.43),('3355','2013-05-09','09:30:00',1.47),('3355','2013-05-09','09:35:00',1.52),('3355','2013-05-09','09:40:00',1.56),('3355','2013-05-09','09:45:00',1.6),('3355','2013-05-09','09:50:00',1.64),('3355','2013-05-09','09:55:00',1.67),('3355','2013-05-09','10:00:00',1.71),('3355','2013-05-09','10:05:00',1.74),('3355','2013-05-09','10:10:00',1.77),('3355','2013-05-09','10:15:00',1.81),('3355','2013-05-09','10:20:00',1.84),('3355','2013-05-09','10:25:00',1.87),('3355','2013-05-09','10:30:00',1.9),('3355','2013-05-09','10:35:00',1.93),('3355','2013-05-09','10:40:00',1.95),('3355','2013-05-09','10:45:00',1.97),('3355','2013-05-09','10:50:00',1.99),('3355','2013-05-09','10:55:00',2.02),('3355','2013-05-09','11:00:00',2.03),('3355','2013-05-09','11:05:00',2.07),('3355','2013-05-09','11:10:00',2.1),('3355','2013-05-09','11:15:00',2.12),('3355','2013-05-09','11:20:00',2.13),('3355','2013-05-09','11:25:00',2.14),('3355','2013-05-09','11:30:00',2.15),('3355','2013-05-09','11:35:00',2.16),('3355','2013-05-09','11:40:00',2.18),('3355','2013-05-09','11:45:00',2.19),('3355','2013-05-09','11:50:00',2.2),('3355','2013-05-09','11:55:00',2.21),('3355','2013-05-09','12:00:00',2.24),('3355','2013-05-09','12:05:00',2.27),('3355','2013-05-09','12:10:00',2.28),('3355','2013-05-09','12:15:00',2.3),('3355','2013-05-09','12:20:00',2.28),('3355','2013-05-09','12:25:00',1.43),('3355','2013-05-09','12:30:00',2.16),('3355','2013-05-09','12:35:00',2.35),('3355','2013-05-09','12:40:00',1.7),('3355','2013-05-09','12:45:00',1.5),('3355','2013-05-09','12:50:00',2.37),('3355','2013-05-09','12:55:00',2.37),('3355','2013-05-09','13:00:00',2.34),('3355','2013-05-09','13:05:00',2.33),('3355','2013-05-09','13:10:00',2.35),('3355','2013-05-09','13:15:00',2.34),('3355','2013-05-09','13:20:00',2.36),('3355','2013-05-09','13:25:00',2.35),('3355','2013-05-09','13:30:00',2.36),('3355','2013-05-09','13:35:00',2.35),('3355','2013-05-09','13:40:00',2.37),('3355','2013-05-09','13:45:00',2.39),('3355','2013-05-09','13:50:00',2.35),('3355','2013-05-09','13:55:00',2.24),('3355','2013-05-09','14:00:00',2.3),('3355','2013-05-09','14:05:00',2.36),('3355','2013-05-09','14:10:00',1.89),('3355','2013-05-09','14:15:00',1.68),('3355','2013-05-09','14:20:00',2.22),('3355','2013-05-09','14:25:00',1.88),('3355','2013-05-09','14:30:00',2.11),('3355','2013-05-09','14:35:00',2.28),('3355','2013-05-09','14:40:00',2.28),('3355','2013-05-09','14:45:00',2.26),('3355','2013-05-09','14:50:00',2.25),('3355','2013-05-09','14:55:00',2.26),('3355','2013-05-09','15:00:00',2.23),('3355','2013-05-09','15:05:00',2.19),('3355','2013-05-09','15:10:00',2.16),('3355','2013-05-09','15:15:00',2.15),('3355','2013-05-09','15:20:00',2.12),('3355','2013-05-09','15:25:00',2.1),('3355','2013-05-09','15:30:00',2.1),('3355','2013-05-09','15:35:00',2.08),('3355','2013-05-09','15:40:00',2.06),('3355','2013-05-09','15:45:00',2.03),('3355','2013-05-09','15:50:00',2.01),('3355','2013-05-09','15:55:00',1.97),('3355','2013-05-09','16:00:00',1.93),('3355','2013-05-09','16:05:00',1.91),('3355','2013-05-09','16:10:00',1.87),('3355','2013-05-09','16:15:00',1.84),('3355','2013-05-09','16:20:00',1.81),('3355','2013-05-09','16:25:00',1.77),('3355','2013-05-09','16:30:00',1.72),('3355','2013-05-09','16:35:00',1.69),('3355','2013-05-09','16:40:00',1.64),('3355','2013-05-09','16:45:00',1.59),('3355','2013-05-09','16:50:00',1.54),('3355','2013-05-09','16:55:00',1.51),('3355','2013-05-09','17:00:00',1.47),('3355','2013-05-09','17:05:00',1.43),('3355','2013-05-09','17:10:00',1.39),('3355','2013-05-09','17:15:00',1.33),('3355','2013-05-09','17:20:00',1.3),('3355','2013-05-09','17:25:00',1.26),('3355','2013-05-09','17:30:00',1.21),('3355','2013-05-09','17:35:00',1.16),('3355','2013-05-09','17:40:00',1.12),('3355','2013-05-09','17:45:00',1.05),('3355','2013-05-09','17:50:00',1.01),('3355','2013-05-08','08:40:00',1),('3355','2013-05-08','08:45:00',1.09),('3355','2013-05-08','08:50:00',1.3),('3355','2013-05-08','08:55:00',1.47),('3355','2013-05-08','09:00:00',1.56),('3355','2013-05-08','09:05:00',1.66),('3355','2013-05-08','09:10:00',1.53),('3355','2013-05-08','09:15:00',1.47),('3355','2013-05-08','09:45:00',1.26),('3355','2013-05-08','10:05:00',1.62),('3355','2013-05-08','10:10:00',1.66),('3355','2013-05-08','10:20:00',1.05),('3355','2013-05-08','10:25:00',1.06),('3355','2013-05-08','10:30:00',1.06),('3355','2013-05-08','11:05:00',1.28),('3355','2013-05-08','11:10:00',2.03),('3355','2013-05-08','11:15:00',2.38),('3355','2013-05-08','11:20:00',2.25),('3355','2013-05-08','11:25:00',2.19),('3355','2013-05-08','11:30:00',2.36),('3355','2013-05-08','11:35:00',2.44),('3355','2013-05-08','11:40:00',2.46),('3355','2013-05-08','11:45:00',1.65),('3355','2013-05-08','11:50:00',1.08),('3355','2013-05-08','12:00:00',2.26),('3355','2013-05-08','12:05:00',1.8),('3355','2013-05-08','12:50:00',1.98),('3355','2013-05-08','13:00:00',2.47),('3355','2013-05-08','13:05:00',2.07),('3355','2013-05-08','13:10:00',2.13),('3355','2013-05-08','13:15:00',1.61),('3355','2013-05-08','13:45:00',2.33),('3355','2013-05-08','13:50:00',2.43),('3355','2013-05-08','13:55:00',1.91),('3355','2013-05-08','14:00:00',2.31),('3355','2013-05-08','14:20:00',1.34),('3355','2013-05-08','14:30:00',1.7),('3355','2013-05-08','14:35:00',1.65),('3355','2013-05-08','14:40:00',1.17),('3355','2013-05-08','14:50:00',1.3),('3355','2013-05-08','14:55:00',1.96),('3355','2013-05-08','15:00:00',2.16),('3355','2013-05-08','15:05:00',2.3),('3355','2013-05-08','15:10:00',1.89),('3355','2013-05-08','15:15:00',1.82),('3355','2013-05-08','15:20:00',2.24),('3355','2013-05-08','15:25:00',2.19),('3355','2013-05-08','15:30:00',2.16),('3355','2013-05-08','15:35:00',2.1),('3355','2013-05-08','15:40:00',2.07),('3355','2013-05-08','15:45:00',2.04),('3355','2013-05-08','15:50:00',2.02),('3355','2013-05-08','15:55:00',1.98),('3355','2013-05-08','16:00:00',1.97),('3355','2013-05-08','16:05:00',1.93),('3355','2013-05-08','16:10:00',1.91),('3355','2013-05-08','16:15:00',1.86),('3355','2013-05-08','16:20:00',1.82),('3355','2013-05-08','16:25:00',1.78),('3355','2013-05-08','16:30:00',1.8),('3355','2013-05-08','16:35:00',1.75),('3355','2013-05-08','16:40:00',1.68),('3355','2013-05-08','16:45:00',1.5),('3355','2013-05-08','16:50:00',1.71),('3355','2013-05-08','16:55:00',1.55),('3355','2013-05-08','17:00:00',1.41),('3355','2013-05-08','17:05:00',1.75),('3355','2013-05-08','17:10:00',1.59),('3355','2013-05-08','17:15:00',1.51),('3355','2013-05-08','17:20:00',1.44),('3355','2013-05-08','17:25:00',1.12),('3355','2013-05-08','17:30:00',1.42),('3355','2013-05-08','17:35:00',1.4),('3355','2013-05-08','17:40:00',1.35),('3355','2013-05-08','17:45:00',1.36),('3355','2013-05-08','17:50:00',1.36),('3355','2013-05-08','17:55:00',1.05),('3355','2013-05-07','08:45:00',1.07),('3355','2013-05-07','08:50:00',1.06),('3355','2013-05-07','08:55:00',1.24),('3355','2013-05-07','09:00:00',1.31),('3355','2013-05-07','09:05:00',1.47),('3355','2013-05-07','09:10:00',1.51),('3355','2013-05-07','09:15:00',1.63),('3355','2013-05-07','09:35:00',1.69),('3355','2013-05-07','09:40:00',1.36),('3355','2013-05-07','09:55:00',1.13),('3355','2013-05-07','10:00:00',1.05),('3355','2013-05-07','11:20:00',1.16),('3355','2013-05-07','11:25:00',1.72),('3355','2013-05-07','12:30:00',1.99),('3355','2013-05-07','13:30:00',1.58),('3355','2013-05-07','13:35:00',2.03),('3355','2013-05-07','13:40:00',2.05),('3355','2013-05-07','13:45:00',2.03),('3355','2013-05-07','13:50:00',2.67),('3355','2013-05-07','13:55:00',2.59),('3355','2013-05-07','14:00:00',2.38),('3355','2013-05-07','14:05:00',2.51),('3355','2013-05-07','14:10:00',2.51),('3355','2013-05-07','14:15:00',2.52),('3355','2013-05-07','14:20:00',2.5),('3355','2013-05-07','14:25:00',2.54),('3355','2013-05-07','14:30:00',2.4),('3355','2013-05-07','14:35:00',2.66),('3355','2013-05-07','14:40:00',2.34),('3355','2013-05-07','14:45:00',2.36),('3355','2013-05-07','14:50:00',2.3),('3355','2013-05-07','14:55:00',1.74),('3355','2013-05-07','15:00:00',2.66),('3355','2013-05-07','15:05:00',2.41),('3355','2013-05-07','15:10:00',2.01),('3355','2013-05-07','15:15:00',1.97),('3355','2013-05-07','15:20:00',2.06),('3355','2013-05-07','15:25:00',1.6),('3355','2013-05-07','15:30:00',1.71),('3355','2013-05-07','15:35:00',1.91),('3355','2013-05-07','16:00:00',1.84),('3355','2013-05-07','16:05:00',1.78),('3355','2013-05-07','16:15:00',1.66),('3355','2013-05-07','16:20:00',2.33),('3355','2013-05-07','16:25:00',2.33),('3355','2013-05-07','16:30:00',2.19),('3355','2013-05-07','16:35:00',2.16),('3355','2013-05-07','16:40:00',2.17),('3355','2013-05-07','16:45:00',1.55),('3355','2013-05-07','16:50:00',1.9),('3355','2013-05-07','16:55:00',1.62),('3355','2013-05-07','17:00:00',1.68),('3355','2013-05-07','17:05:00',1.72),('3355','2013-05-07','17:10:00',1.26),('3355','2013-05-06','10:30:00',1),('3355','2013-05-06','10:45:00',1.56),('3355','2013-05-06','10:50:00',1.31),('3355','2013-05-06','10:55:00',1.09),('3355','2013-05-06','11:00:00',1.14),('3355','2013-05-06','11:05:00',1.1),('3355','2013-05-06','11:10:00',1.05),('3355','2013-05-06','11:20:00',1.17),('3355','2013-05-06','11:25:00',1.17),('3355','2013-05-06','11:30:00',1.19),('3355','2013-05-06','11:40:00',2.17),('3355','2013-05-06','11:45:00',2.02),('3355','2013-05-06','11:50:00',1.52),('3355','2013-05-06','12:00:00',1.13),('3355','2013-05-06','12:05:00',1.09),('3355','2013-05-06','12:10:00',2.04),('3355','2013-05-06','12:15:00',1.24),('3355','2013-05-06','12:20:00',1.37),('3355','2013-05-06','12:25:00',1.8),('3355','2013-05-06','12:30:00',2.23),('3355','2013-05-06','12:35:00',1.89),('3355','2013-05-06','12:40:00',1.95),('3355','2013-05-06','12:45:00',1.16),('3355','2013-05-06','12:50:00',1.43),('3355','2013-05-06','12:55:00',2.11),('3355','2013-05-06','13:00:00',1.03),('3355','2013-05-06','13:05:00',1.23),('3355','2013-05-06','13:10:00',2.49),('3355','2013-05-06','13:15:00',2.13),('3355','2013-05-06','13:20:00',2.49),('3355','2013-05-06','13:25:00',1.75),('3355','2013-05-06','13:30:00',1.98),('3355','2013-05-06','13:35:00',1.35),('3355','2013-05-06','13:40:00',2.86),('3355','2013-05-06','13:45:00',1.88),('3355','2013-05-06','13:50:00',2.56),('3355','2013-05-06','13:55:00',2.58),('3355','2013-05-06','14:00:00',2.65),('3355','2013-05-06','14:05:00',2.3),('3355','2013-05-06','14:10:00',1.59),('3355','2013-05-06','14:15:00',1.76),('3355','2013-05-06','14:20:00',2.25),('3355','2013-05-06','14:25:00',1.79),('3355','2013-05-06','14:30:00',1.72),('3355','2013-05-06','14:35:00',2.69),('3355','2013-05-06','14:40:00',2.39),('3355','2013-05-06','14:45:00',1.63),('3355','2013-05-06','14:50:00',1.73),('3355','2013-05-06','14:55:00',2.42),('3355','2013-05-06','15:00:00',1.37),('3355','2013-05-06','15:05:00',1.06),('3355','2013-05-06','15:10:00',1.43),('3355','2013-05-06','15:15:00',1.42),('3355','2013-05-06','15:20:00',1.55),('3355','2013-05-06','15:30:00',1.68),('3355','2013-05-06','15:35:00',1.23),('3355','2013-05-06','15:40:00',1.64),('3355','2013-05-06','15:55:00',1.29),('3355','2013-05-06','16:25:00',1.44),('3355','2013-05-06','16:30:00',1.75),('3355','2013-05-06','16:35:00',1.1),('3355','2013-05-06','16:40:00',1.72),('3355','2013-05-06','16:45:00',1.41),('3355','2013-05-06','16:50:00',1.19),('3355','2013-05-06','16:55:00',1.45),('3355','2013-05-06','17:35:00',1.1),('3355','2013-05-05','08:25:00',1.05),('3355','2013-05-05','08:30:00',1.06),('3355','2013-05-05','08:35:00',1.02),('3355','2013-05-05','08:40:00',1.05),('3355','2013-05-05','09:25:00',1.03),('3355','2013-05-05','09:40:00',1.29),('3355','2013-05-05','09:45:00',1.31),('3355','2013-05-05','09:55:00',1.76),('3355','2013-05-05','10:00:00',1.15),('3355','2013-05-05','10:05:00',1.08),('3355','2013-05-05','10:10:00',1.11),('3355','2013-05-05','10:20:00',1.27),('3355','2013-05-05','10:25:00',1.26),('3355','2013-05-05','10:30:00',1.32),('3355','2013-05-05','10:35:00',1.27),('3355','2013-05-05','10:40:00',1.32),('3355','2013-05-05','10:45:00',1.36),('3355','2013-05-05','10:50:00',1.08),('3355','2013-05-05','11:05:00',1.04),('3355','2013-05-05','11:20:00',1.25),('3355','2013-05-05','11:25:00',1.69),('3355','2013-05-05','11:30:00',1.56),('3355','2013-05-05','11:35:00',1.96),('3355','2013-05-05','11:40:00',1.91),('3355','2013-05-05','11:45:00',1.67),('3355','2013-05-05','11:50:00',1.48),('3355','2013-05-05','11:55:00',1.59),('3355','2013-05-05','12:00:00',1.31),('3355','2013-05-05','12:05:00',1.41),('3355','2013-05-05','12:10:00',1.41),('3355','2013-05-05','12:15:00',1.39),('3355','2013-05-05','12:20:00',1.74),('3355','2013-05-05','12:25:00',1.87),('3355','2013-05-05','12:30:00',1.98),('3355','2013-05-05','12:35:00',2.36),('3355','2013-05-05','12:40:00',1.89),('3355','2013-05-05','12:45:00',1.87),('3355','2013-05-05','12:50:00',1.79),('3355','2013-05-05','12:55:00',2.24),('3355','2013-05-05','13:00:00',1.99),('3355','2013-05-05','13:05:00',2.34),('3355','2013-05-05','13:10:00',2.06),('3355','2013-05-05','13:15:00',2.52),('3355','2013-05-05','13:20:00',2.01),('3355','2013-05-05','13:25:00',1.27),('3355','2013-05-05','13:35:00',1.82),('3355','2013-05-05','13:40:00',2.44),('3355','2013-05-05','13:45:00',2.41),('3355','2013-05-05','13:50:00',2.4),('3355','2013-05-05','13:55:00',2.41),('3355','2013-05-05','14:00:00',2.45),('3355','2013-05-05','14:05:00',2.52),('3355','2013-05-05','14:10:00',1.9),('3355','2013-05-05','14:15:00',1.69),('3355','2013-05-05','14:20:00',2.2),('3355','2013-05-05','14:25:00',2.24),('3355','2013-05-05','14:30:00',2.17),('3355','2013-05-05','14:35:00',2.16),('3355','2013-05-05','14:40:00',2.14),('3355','2013-05-05','14:45:00',2.13),('3355','2013-05-05','14:50:00',2.11),('3355','2013-05-05','14:55:00',2.09),('3355','2013-05-05','15:00:00',2.08),('3355','2013-05-05','15:05:00',2.05),('3355','2013-05-05','15:10:00',2.04),('3355','2013-05-05','15:15:00',2.03),('3355','2013-05-05','15:20:00',1.99),('3355','2013-05-05','15:25:00',1.99),('3355','2013-05-05','15:30:00',1.98),('3355','2013-05-05','15:35:00',1.95),('3355','2013-05-05','15:40:00',1.92),('3355','2013-05-05','15:45:00',1.89),('3355','2013-05-05','15:50:00',1.87),('3355','2013-05-05','15:55:00',1.84),('3355','2013-05-05','16:00:00',1.81),('3355','2013-05-05','16:05:00',1.78),('3355','2013-05-05','16:10:00',1.75),('3355','2013-05-05','16:15:00',1.73),('3355','2013-05-05','16:20:00',1.7),('3355','2013-05-05','16:25:00',1.65),('3355','2013-05-05','16:30:00',1.62),('3355','2013-05-05','16:35:00',1.59),('3355','2013-05-05','16:40:00',1.55),('3355','2013-05-05','16:45:00',1.5),('3355','2013-05-05','16:50:00',1.47),('3355','2013-05-05','16:55:00',1.42),('3355','2013-05-05','17:00:00',1.38),('3355','2013-05-05','17:05:00',1.33),('3355','2013-05-05','17:10:00',1.29),('3355','2013-05-05','17:15:00',1.26),('3355','2013-05-05','17:20:00',1.21),('3355','2013-05-05','17:25:00',1.15),('3355','2013-05-05','17:30:00',1.11),('3355','2013-05-05','17:35:00',1.05),('3355','2013-05-05','17:40:00',1.01),('3355','2013-05-04','08:55:00',1.03),('3355','2013-05-04','09:00:00',1.07),('3355','2013-05-04','09:05:00',1.12),('3355','2013-05-04','09:10:00',1.17),('3355','2013-05-04','09:15:00',1.19),('3355','2013-05-04','09:20:00',1.26),('3355','2013-05-04','09:25:00',1.29),('3355','2013-05-04','09:30:00',1.32),('3355','2013-05-04','09:35:00',1.37),('3355','2013-05-04','09:40:00',1.42),('3355','2013-05-04','09:45:00',1.47),('3355','2013-05-04','09:50:00',1.51),('3355','2013-05-04','09:55:00',1.55),('3355','2013-05-04','10:00:00',1.59),('3355','2013-05-04','10:05:00',1.62),('3355','2013-05-04','10:10:00',1.67),('3355','2013-05-04','10:15:00',1.7),('3355','2013-05-04','10:20:00',1.72),('3355','2013-05-04','10:25:00',1.77),('3355','2013-05-04','10:30:00',1.8),('3355','2013-05-04','10:35:00',1.83),('3355','2013-05-04','10:40:00',1.83),('3355','2013-05-04','10:45:00',1.83),('3355','2013-05-04','10:50:00',1.83),('3355','2013-05-04','10:55:00',1.8),('3355','2013-05-04','11:00:00',1.83),('3355','2013-05-04','11:05:00',1.84),('3355','2013-05-04','11:10:00',1.77),('3355','2013-05-04','11:15:00',1.7),('3355','2013-05-04','11:20:00',1.82),('3355','2013-05-04','11:25:00',1.88),('3355','2013-05-04','11:30:00',1.8),('3355','2013-05-04','11:35:00',1.85),('3355','2013-05-04','11:40:00',1.8),('3355','2013-05-04','11:45:00',1.86),('3355','2013-05-04','11:50:00',1.86),('3355','2013-05-04','11:55:00',1.87),('3355','2013-05-04','12:00:00',1.81),('3355','2013-05-04','12:05:00',1.89),('3355','2013-05-04','12:10:00',1.94),('3355','2013-05-04','12:15:00',1.97),('3355','2013-05-04','12:20:00',2.03),('3355','2013-05-04','12:25:00',2.06),('3355','2013-05-04','12:30:00',2.07),('3355','2013-05-04','12:35:00',2.1),('3355','2013-05-04','12:40:00',2.1),('3355','2013-05-04','12:45:00',2.11),('3355','2013-05-04','12:50:00',2.05),('3355','2013-05-04','12:55:00',2),('3355','2013-05-04','13:00:00',1.97),('3355','2013-05-04','13:05:00',1.79),('3355','2013-05-04','13:10:00',1.94),('3355','2013-05-04','13:15:00',2.2),('3355','2013-05-04','13:20:00',2.24),('3355','2013-05-04','13:25:00',2.09),('3355','2013-05-04','13:30:00',2.14),('3355','2013-05-04','13:35:00',2.08),('3355','2013-05-04','13:40:00',2.09),('3355','2013-05-04','13:45:00',2.08),('3355','2013-05-04','13:50:00',1.84),('3355','2013-05-04','13:55:00',1.98),('3355','2013-05-04','14:00:00',1.94),('3355','2013-05-04','14:05:00',2.04),('3355','2013-05-04','14:10:00',1.94),('3355','2013-05-04','14:15:00',2),('3355','2013-05-04','14:20:00',2.02),('3355','2013-05-04','14:25:00',1.87),('3355','2013-05-04','14:30:00',1.94),('3355','2013-05-04','14:35:00',1.84),('3355','2013-05-04','14:40:00',1.92),('3355','2013-05-04','14:45:00',1.9),('3355','2013-05-04','14:50:00',1.8),('3355','2013-05-04','14:55:00',1.85),('3355','2013-05-04','15:00:00',1.89),('3355','2013-05-04','15:05:00',1.92),('3355','2013-05-04','15:10:00',1.8),('3355','2013-05-04','15:15:00',1.85),('3355','2013-05-04','15:20:00',1.9),('3355','2013-05-04','15:25:00',1.92),('3355','2013-05-04','15:30:00',1.9),('3355','2013-05-04','15:35:00',1.82),('3355','2013-05-04','15:40:00',1.78),('3355','2013-05-04','15:45:00',1.81),('3355','2013-05-04','15:50:00',1.8),('3355','2013-05-04','15:55:00',1.77),('3355','2013-05-04','16:00:00',1.72),('3355','2013-05-04','16:05:00',1.7),('3355','2013-05-04','16:10:00',1.68),('3355','2013-05-04','16:15:00',1.64),('3355','2013-05-04','16:20:00',1.61),('3355','2013-05-04','16:25:00',1.57),('3355','2013-05-04','16:30:00',1.54),('3355','2013-05-04','16:35:00',1.51),('3355','2013-05-04','16:40:00',1.47),('3355','2013-05-04','16:45:00',1.43),('3355','2013-05-04','16:50:00',1.38),('3355','2013-05-04','16:55:00',1.34),('3355','2013-05-04','17:00:00',1.31),('3355','2013-05-04','17:05:00',1.23),('3355','2013-05-04','17:15:00',1.11),('3355','2013-05-04','17:20:00',1.16),('3355','2013-05-04','17:25:00',1.11),('3355','2013-05-04','17:30:00',1.04),('3355','2013-05-03','08:45:00',1.02),('3355','2013-05-03','08:50:00',1.01),('3355','2013-05-03','08:55:00',1.03),('3355','2013-05-03','09:00:00',1.1),('3355','2013-05-03','09:05:00',1.18),('3355','2013-05-03','09:10:00',1.2),('3355','2013-05-03','09:15:00',1.24),('3355','2013-05-03','09:20:00',1.27),('3355','2013-05-03','09:25:00',1.34),('3355','2013-05-03','09:30:00',1.36),('3355','2013-05-03','09:35:00',1.41),('3355','2013-05-03','09:40:00',1.46),('3355','2013-05-03','09:45:00',1.51),('3355','2013-05-03','09:50:00',1.54),('3355','2013-05-03','09:55:00',1.58),('3355','2013-05-03','10:00:00',1.62),('3355','2013-05-03','10:05:00',1.65),('3355','2013-05-03','10:10:00',1.69),('3355','2013-05-03','10:15:00',1.73),('3355','2013-05-03','10:20:00',1.76),('3355','2013-05-03','10:25:00',1.79),('3355','2013-05-03','10:30:00',1.82),('3355','2013-05-03','10:35:00',1.84),('3355','2013-05-03','10:40:00',1.86),('3355','2013-05-03','10:45:00',1.88),('3355','2013-05-03','10:50:00',1.9),('3355','2013-05-03','10:55:00',1.93),('3355','2013-05-03','11:00:00',1.95),('3355','2013-05-03','11:05:00',1.98),('3355','2013-05-03','11:10:00',2),('3355','2013-05-03','11:15:00',2.02),('3355','2013-05-03','11:20:00',2.03),('3355','2013-05-03','11:25:00',2.08),('3355','2013-05-03','11:30:00',2.1),('3355','2013-05-03','11:35:00',2.11),('3355','2013-05-03','11:40:00',2.12),('3355','2013-05-03','11:45:00',2.12),('3355','2013-05-03','11:50:00',2.14),('3355','2013-05-03','11:55:00',2.15),('3355','2013-05-03','12:00:00',2.16),('3355','2013-05-03','12:05:00',2.18),('3355','2013-05-03','12:10:00',2.19),('3355','2013-05-03','12:15:00',2.21),('3355','2013-05-03','12:20:00',2.21),('3355','2013-05-03','12:25:00',2.21),('3355','2013-05-03','12:30:00',2.21),('3355','2013-05-03','12:35:00',2.2),('3355','2013-05-03','12:40:00',2.22),('3355','2013-05-03','12:45:00',2.22),('3355','2013-05-03','12:50:00',2.26),('3355','2013-05-03','12:55:00',2.25),('3355','2013-05-03','13:00:00',2.23),('3355','2013-05-03','13:05:00',2.23),('3355','2013-05-03','13:10:00',2.23),('3355','2013-05-03','13:15:00',2.24),('3355','2013-05-03','13:20:00',2.24),('3355','2013-05-03','13:25:00',2.25),('3355','2013-05-03','13:30:00',2.22),('3355','2013-05-03','13:35:00',2.18),('3355','2013-05-03','13:40:00',2.13),('3355','2013-05-03','13:45:00',2.12),('3355','2013-05-03','13:50:00',2.13),('3355','2013-05-03','13:55:00',2.16),('3355','2013-05-03','14:00:00',2.15),('3355','2013-05-03','14:05:00',2.06),('3355','2013-05-03','14:10:00',2.1),('3355','2013-05-03','14:15:00',2.03),('3355','2013-05-03','14:20:00',2.07),('3355','2013-05-03','14:25:00',2.09),('3355','2013-05-03','14:30:00',2.05),('3355','2013-05-03','14:35:00',2.09),('3355','2013-05-03','14:40:00',2.06),('3355','2013-05-03','14:45:00',2.04),('3355','2013-05-03','14:50:00',2.04),('3355','2013-05-03','14:55:00',2.05),('3355','2013-05-03','15:00:00',2.06),('3355','2013-05-03','15:05:00',2.04),('3355','2013-05-03','15:10:00',2.04),('3355','2013-05-03','15:15:00',2.01),('3355','2013-05-03','15:20:00',2),('3355','2013-05-03','15:25:00',1.98),('3355','2013-05-03','15:30:00',1.96),('3355','2013-05-03','15:35:00',1.94),('3355','2013-05-03','15:40:00',1.92),('3355','2013-05-03','15:45:00',1.9),('3355','2013-05-03','15:50:00',1.85),('3355','2013-05-03','15:55:00',1.82),('3355','2013-05-03','16:00:00',1.82),('3355','2013-05-03','16:05:00',1.8),('3355','2013-05-03','16:10:00',1.75),('3355','2013-05-03','16:15:00',1.71),('3355','2013-05-03','16:20:00',1.65),('3355','2013-05-03','16:25:00',1.6),('3355','2013-05-03','16:30:00',1.61),('3355','2013-05-03','16:35:00',1.59),('3355','2013-05-03','16:40:00',1.54),('3355','2013-05-03','16:45:00',1.49),('3355','2013-05-03','16:50:00',1.45),('3355','2013-05-03','16:55:00',1.41),('3355','2013-05-03','17:00:00',1.37),('3355','2013-05-03','17:05:00',1.31),('3355','2013-05-03','17:10:00',1.27),('3355','2013-05-03','17:15:00',1.21),('3355','2013-05-03','17:20:00',1.16),('3355','2013-05-03','17:25:00',1.09),('3355','2013-05-03','17:30:00',1.04),('3355','2013-05-02','09:35:00',1.16),('3355','2013-05-02','09:45:00',1.25),('3355','2013-05-02','10:25:00',1.09),('3355','2013-05-02','10:30:00',1.72),('3355','2013-05-02','10:35:00',1.25),('3355','2013-05-02','10:40:00',1.93),('3355','2013-05-02','10:45:00',1.41),('3355','2013-05-02','10:50:00',1.7),('3355','2013-05-02','10:55:00',2.05),('3355','2013-05-02','11:00:00',2.12),('3355','2013-05-02','11:05:00',2.09),('3355','2013-05-02','11:10:00',1.49),('3355','2013-05-02','11:15:00',1.56),('3355','2013-05-02','11:20:00',1.47),('3355','2013-05-02','11:25:00',2.09),('3355','2013-05-02','11:30:00',2.12),('3355','2013-05-02','11:35:00',2.1),('3355','2013-05-02','11:40:00',2.08),('3355','2013-05-02','11:45:00',2.09),('3355','2013-05-02','11:50:00',2.09),('3355','2013-05-02','11:55:00',2.1),('3355','2013-05-02','12:00:00',2.1),('3355','2013-05-02','12:05:00',2.1),('3355','2013-05-02','12:10:00',2.1),('3355','2013-05-02','12:15:00',2.13),('3355','2013-05-02','12:20:00',2.13),('3355','2013-05-02','12:25:00',2.14),('3355','2013-05-02','12:30:00',2.17),('3355','2013-05-02','12:35:00',2.2),('3355','2013-05-02','12:40:00',2.23),('3355','2013-05-02','12:45:00',2.23),('3355','2013-05-02','12:50:00',2.24),('3355','2013-05-02','12:55:00',2.26),('3355','2013-05-02','13:00:00',2.27),('3355','2013-05-02','13:05:00',2.28),('3355','2013-05-02','13:10:00',2.31),('3355','2013-05-02','13:15:00',2.32),('3355','2013-05-02','13:20:00',2.32),('3355','2013-05-02','13:25:00',2.31),('3355','2013-05-02','13:30:00',2.32),('3355','2013-05-02','13:35:00',2.31),('3355','2013-05-02','13:40:00',2.3),('3355','2013-05-02','13:45:00',2.32),('3355','2013-05-02','13:50:00',2.3),('3355','2013-05-02','13:55:00',2.3),('3355','2013-05-02','14:00:00',2.28),('3355','2013-05-02','14:05:00',2.26),('3355','2013-05-02','14:10:00',2.25),('3355','2013-05-02','14:15:00',2.25),('3355','2013-05-02','14:20:00',2.22),('3355','2013-05-02','14:25:00',2.2),('3355','2013-05-02','14:30:00',2.19),('3355','2013-05-02','14:35:00',2.18),('3355','2013-05-02','14:40:00',2.17),('3355','2013-05-02','14:45:00',2.15),('3355','2013-05-02','14:50:00',2.12),('3355','2013-05-02','14:55:00',2.12),('3355','2013-05-02','15:00:00',2.1),('3355','2013-05-02','15:05:00',2.08),('3355','2013-05-02','15:10:00',2.06),('3355','2013-05-02','15:15:00',2.05),('3355','2013-05-02','15:20:00',2.02),('3355','2013-05-02','15:25:00',1.99),('3355','2013-05-02','15:30:00',1.94),('3355','2013-05-02','15:35:00',1.9),('3355','2013-05-02','15:40:00',1.88),('3355','2013-05-02','15:45:00',1.86),('3355','2013-05-02','15:50:00',1.85),('3355','2013-05-02','15:55:00',1.81),('3355','2013-05-02','16:00:00',1.77),('3355','2013-05-02','16:05:00',1.77),('3355','2013-05-02','16:10:00',1.75),('3355','2013-05-02','16:15:00',1.72),('3355','2013-05-02','16:20:00',1.68),('3355','2013-05-02','16:25:00',1.65),('3355','2013-05-02','16:30:00',1.61),('3355','2013-05-02','16:35:00',1.56),('3355','2013-05-02','16:40:00',1.53),('3355','2013-05-02','16:45:00',1.49),('3355','2013-05-02','16:50:00',1.45),('3355','2013-05-02','16:55:00',1.41),('3355','2013-05-02','17:00:00',1.37),('3355','2013-05-02','17:05:00',1.33),('3355','2013-05-02','17:10:00',1.29),('3355','2013-05-02','17:15:00',1.25),('3355','2013-05-02','17:20:00',1.21),('3355','2013-05-02','17:25:00',1.16),('3355','2013-05-02','17:30:00',1.11),('3355','2013-05-02','17:35:00',1.06),('3355','2013-05-02','17:40:00',1.02),('3355','2014-03-30','09:30:00',1),('3355','2014-03-30','09:35:00',1.14),('3355','2014-03-30','09:40:00',1.18),('3355','2014-03-30','09:45:00',1.22),('3355','2014-03-30','09:50:00',1.24),('3355','2014-03-30','09:55:00',1.22),('3355','2014-03-30','10:00:00',1.23),('3355','2014-03-30','10:05:00',1.43),('3355','2014-03-30','10:10:00',1.46),('3355','2014-03-30','10:15:00',1.43),('3355','2014-03-30','10:20:00',1.49),('3355','2014-03-30','10:25:00',1.54),('3355','2014-03-30','10:30:00',1.59),('3355','2014-03-30','10:35:00',1.64),('3355','2014-03-30','10:40:00',1.69),('3355','2014-03-30','10:45:00',1.69),('3355','2014-03-30','10:50:00',1.71),('3355','2014-03-30','10:55:00',1.75),('3355','2014-03-30','11:00:00',1.76),('3355','2014-03-30','11:05:00',1.68),('3355','2014-03-30','11:10:00',1.74),('3355','2014-03-30','11:15:00',1.72),('3355','2014-03-30','11:20:00',1.72),('3355','2014-03-30','11:25:00',1.77),('3355','2014-03-30','11:30:00',1.9),('3355','2014-03-30','11:35:00',1.87),('3355','2014-03-30','11:40:00',1.95),('3355','2014-03-30','11:45:00',2.02),('3355','2014-03-30','11:50:00',2.06),('3355','2014-03-30','11:55:00',2.12),('3355','2014-03-30','12:00:00',2.13),('3355','2014-03-30','12:05:00',2.2),('3355','2014-03-30','12:10:00',2.27),('3355','2014-03-30','12:15:00',2.26),('3355','2014-03-30','12:20:00',2.24),('3355','2014-03-30','12:25:00',2.24),('3355','2014-03-30','12:30:00',2.09),('3355','2014-03-30','12:35:00',2.08),('3355','2014-03-30','12:40:00',2.24),('3355','2014-03-30','12:45:00',2.17),('3355','2014-03-30','12:50:00',2.22),('3355','2014-03-30','12:55:00',2.24),('3355','2014-03-30','13:00:00',2.3),('3355','2014-03-30','13:05:00',2.31),('3355','2014-03-30','13:10:00',2.31),('3355','2014-03-30','13:15:00',2.31),('3355','2014-03-30','13:20:00',2.31),('3355','2014-03-30','13:25:00',2.32),('3355','2014-03-30','13:30:00',2.31),('3355','2014-03-30','13:35:00',2.34),('3355','2014-03-30','13:40:00',2.32),('3355','2014-03-30','13:45:00',2.34),('3355','2014-03-30','13:50:00',2.34),('3355','2014-03-30','13:55:00',2.29),('3355','2014-03-30','14:00:00',2.28),('3355','2014-03-30','14:05:00',2.3),('3355','2014-03-30','14:10:00',2.24),('3355','2014-03-30','14:15:00',2.24),('3355','2014-03-30','14:20:00',2.27),('3355','2014-03-30','14:25:00',2.3),('3355','2014-03-30','14:30:00',2.33),('3355','2014-03-30','14:35:00',2.3),('3355','2014-03-30','14:40:00',2.17),('3355','2014-03-30','14:45:00',2.01),('3355','2014-03-30','14:50:00',1.82),('3355','2014-03-30','14:55:00',1.53),('3355','2014-03-30','15:00:00',1.22),('3355','2014-03-30','15:20:00',1.06),('3355','2014-03-30','15:25:00',1.77),('3355','2014-03-30','15:30:00',1.89),('3355','2014-03-30','15:35:00',1.87),('3355','2014-03-30','15:40:00',1.9),('3355','2014-03-30','15:45:00',1.88),('3355','2014-03-30','15:50:00',1.88),('3355','2014-03-30','15:55:00',1.83),('3355','2014-03-30','16:00:00',1.77),('3355','2014-03-30','16:05:00',1.62),('3355','2014-03-30','16:10:00',1.61),('3355','2014-03-30','16:15:00',1.56),('3355','2014-03-30','16:20:00',1.67),('3355','2014-03-30','16:25:00',1.67),('3355','2014-03-30','16:30:00',1.63),('3355','2014-03-30','16:35:00',1.64),('3355','2014-03-30','16:40:00',1.55),('3355','2014-03-30','16:45:00',1.39),('3355','2014-03-30','16:50:00',1.29),('3355','2014-03-30','16:55:00',1.05),('3355','2014-03-30','17:00:00',1.06),('3355','2014-03-30','17:05:00',1.21),('3355','2014-03-30','17:10:00',1.27),('3355','2014-03-30','17:15:00',1.29),('3355','2014-03-30','17:20:00',1.24),('3355','2014-03-30','17:25:00',1.12),('3355','2014-03-30','17:30:00',1.09),('3355','2014-03-30','17:35:00',1.04),('3355','2013-05-01','09:00:00',1.04),('3355','2013-05-01','09:05:00',1.08),('3355','2013-05-01','09:10:00',1.12),('3355','2013-05-01','09:15:00',1.16),('3355','2013-05-01','09:20:00',1.19),('3355','2013-05-01','09:25:00',1.22),('3355','2013-05-01','09:30:00',1.25),('3355','2013-05-01','09:35:00',1.28),('3355','2013-05-01','09:40:00',1.33),('3355','2013-05-01','09:45:00',1.36),('3355','2013-05-01','09:50:00',1.4),('3355','2013-05-01','09:55:00',1.43),('3355','2013-05-01','10:00:00',1.47),('3355','2013-05-01','10:05:00',1.48),('3355','2013-05-01','10:10:00',1.54),('3355','2013-05-01','10:15:00',1.59),('3355','2013-05-01','10:20:00',1.62),('3355','2013-05-01','10:25:00',1.64),('3355','2013-05-01','10:30:00',1.67),('3355','2013-05-01','10:35:00',1.7),('3355','2013-05-01','10:40:00',1.77),('3355','2013-05-01','10:45:00',1.86),('3355','2013-05-01','10:50:00',1.88),('3355','2013-05-01','10:55:00',1.9),('3355','2013-05-01','11:00:00',1.92),('3355','2013-05-01','11:05:00',1.94),('3355','2013-05-01','11:10:00',1.97),('3355','2013-05-01','11:15:00',1.86),('3355','2013-05-01','11:20:00',1.77),('3355','2013-05-01','11:25:00',1.74),('3355','2013-05-01','11:30:00',1.71),('3355','2013-05-01','11:35:00',1.81),('3355','2013-05-01','11:40:00',1.62),('3355','2013-05-01','11:45:00',1.53),('3355','2013-05-01','11:50:00',1.76),('3355','2013-05-01','11:55:00',2.12),('3355','2013-05-01','12:00:00',2.1),('3355','2013-05-01','12:05:00',2.07),('3355','2013-05-01','12:10:00',2.07),('3355','2013-05-01','12:15:00',2.07),('3355','2013-05-01','12:20:00',2.09),('3355','2013-05-01','12:25:00',2.1),('3355','2013-05-01','12:30:00',2.14),('3355','2013-05-01','12:35:00',2.17),('3355','2013-05-01','12:40:00',2.21),('3355','2013-05-01','12:45:00',2.01),('3355','2013-05-01','12:50:00',1.95),('3355','2013-05-01','13:00:00',1.01),('3355','2013-05-01','13:10:00',1.32),('3355','2013-05-01','13:15:00',2.39),('3355','2013-05-01','13:20:00',2.48),('3355','2013-05-01','13:25:00',2.11),('3355','2013-05-01','13:30:00',1.44),('3355','2013-05-01','13:35:00',1.61),('3355','2013-05-01','13:40:00',2.35),('3355','2013-05-01','13:45:00',2.37),('3355','2013-05-01','13:50:00',2.26),('3355','2013-05-01','13:55:00',2.2),('3355','2013-05-01','14:00:00',2.16),('3355','2013-05-01','14:05:00',2.1),('3355','2013-05-01','14:10:00',2.1),('3355','2013-05-01','14:15:00',1.78),('3355','2013-05-01','14:20:00',2.19),('3355','2013-05-01','14:25:00',2.21),('3355','2013-05-01','14:30:00',2.22),('3355','2013-05-01','14:35:00',2.15),('3355','2013-05-01','14:40:00',1.92),('3355','2013-05-01','14:45:00',2.05),('3355','2013-05-01','14:50:00',1.69),('3355','2013-05-01','14:55:00',1.59),('3355','2013-05-01','15:00:00',1.74),('3355','2013-05-01','15:05:00',1.88),('3355','2013-05-01','15:10:00',1.93),('3355','2013-05-01','15:15:00',1.87),('3355','2013-05-01','15:20:00',1.78),('3355','2013-05-01','15:25:00',1.89),('3355','2013-05-01','15:30:00',1.55),('3355','2013-05-01','15:35:00',1.33),('3355','2013-05-01','15:40:00',1.32),('3355','2013-05-01','15:45:00',1.3),('3355','2013-05-01','16:00:00',1.13),('3355','2013-05-01','16:05:00',1.1),('3355','2013-04-30','09:10:00',1.1),('3355','2013-04-30','09:15:00',1.3),('3355','2013-04-30','09:20:00',1.31),('3355','2013-04-30','09:25:00',1.4),('3355','2013-04-30','09:30:00',1.39),('3355','2013-04-30','09:35:00',1.16),('3355','2013-04-30','09:45:00',1),('3355','2013-04-30','09:50:00',1.33),('3355','2013-04-30','09:55:00',1.47),('3355','2013-04-30','10:00:00',1.72),('3355','2013-04-30','10:05:00',1.72),('3355','2013-04-30','10:10:00',1.46),('3355','2013-04-30','10:15:00',1.34),('3355','2013-04-30','10:20:00',1.26),('3355','2013-04-30','10:25:00',1.18),('3355','2013-04-30','10:30:00',1.06),('3355','2013-04-30','10:35:00',1.04),('3355','2013-04-30','11:20:00',1.13),('3355','2013-04-30','11:25:00',1.05),('3355','2013-04-30','11:30:00',1.02),('3355','2013-04-30','11:35:00',1.06),('3355','2013-04-30','11:40:00',1.04),('3355','2013-04-30','12:35:00',1.24),('3355','2013-04-30','12:40:00',2.26),('3355','2013-04-30','12:45:00',2.46),('3355','2013-04-30','12:50:00',2.37),('3355','2013-04-30','12:55:00',2.04),('3355','2013-04-30','13:00:00',2.21),('3355','2013-04-30','13:05:00',2.18),('3355','2013-04-30','13:10:00',2.24),('3355','2013-04-30','13:15:00',2.22),('3355','2013-04-30','13:20:00',2.2),('3355','2013-04-30','13:25:00',2.19),('3355','2013-04-30','13:30:00',2.17),('3355','2013-04-30','13:35:00',2.18),('3355','2013-04-30','13:40:00',2.16),('3355','2013-04-30','13:45:00',2.15),('3355','2013-04-30','13:50:00',2.13),('3355','2013-04-30','13:55:00',2.11),('3355','2013-04-30','14:00:00',2.1),('3355','2013-04-30','14:05:00',2.09),('3355','2013-04-30','14:10:00',2.09),('3355','2013-04-30','14:15:00',2.08),('3355','2013-04-30','14:20:00',2.08),('3355','2013-04-30','14:25:00',2.07),('3355','2013-04-30','14:30:00',2.06),('3355','2013-04-30','14:35:00',2.04),('3355','2013-04-30','14:40:00',2.01),('3355','2013-04-30','14:45:00',1.98),('3355','2013-04-30','14:50:00',1.95),('3355','2013-04-30','14:55:00',1.92),('3355','2013-04-30','15:00:00',1.91),('3355','2013-04-30','15:05:00',1.89),('3355','2013-04-30','15:10:00',1.87),('3355','2013-04-30','15:15:00',1.85),('3355','2013-04-30','15:20:00',1.82),('3355','2013-04-30','15:25:00',1.8),('3355','2013-04-30','15:30:00',1.77),('3355','2013-04-30','15:35:00',1.77),('3355','2013-04-30','15:40:00',1.74),('3355','2013-04-30','15:45:00',1.7),('3355','2013-04-30','15:50:00',1.67),('3355','2013-04-30','15:55:00',1.63),('3355','2013-04-30','16:00:00',1.6),('3355','2013-04-30','16:05:00',1.57),('3355','2013-04-30','16:10:00',1.54),('3355','2013-04-30','16:15:00',1.51),('3355','2013-04-30','16:20:00',1.49),('3355','2013-04-30','16:25:00',1.45),('3355','2013-04-30','16:30:00',1.43),('3355','2013-04-30','16:35:00',1.36),('3355','2013-04-30','16:40:00',1.09),('3355','2013-04-30','16:45:00',1.17),('3355','2013-04-30','16:50:00',1.05),('3355','2013-04-30','16:55:00',1.2),('3355','2013-04-30','17:00:00',1.11),('3355','2013-04-30','17:05:00',1.12),('3355','2013-04-29','08:50:00',1.04),('3355','2013-04-29','08:55:00',1.05),('3355','2013-04-29','09:05:00',1.12),('3355','2013-04-29','09:10:00',1.25),('3355','2013-04-29','09:15:00',1.33),('3355','2013-04-29','09:20:00',1.26),('3355','2013-04-29','09:25:00',1.24),('3355','2013-04-29','09:30:00',1.22),('3355','2013-04-29','09:35:00',1.32),('3355','2013-04-29','09:40:00',1.34),('3355','2013-04-29','09:45:00',1.4),('3355','2013-04-29','09:50:00',1.5),('3355','2013-04-29','09:55:00',1.4),('3355','2013-04-29','10:00:00',1.46),('3355','2013-04-29','10:05:00',1.44),('3355','2013-04-29','10:10:00',1.43),('3355','2013-04-29','10:15:00',1.23),('3355','2013-04-29','10:20:00',1.16),('3355','2013-04-29','10:25:00',1.44),('3355','2013-04-29','10:30:00',1.42),('3355','2013-04-29','10:35:00',1.72),('3355','2013-04-29','10:40:00',1.74),('3355','2013-04-29','10:45:00',1.77),('3355','2013-04-29','10:50:00',1.7),('3355','2013-04-29','10:55:00',1.59),('3355','2013-04-29','11:00:00',1.78),('3355','2013-04-29','11:05:00',1.73),('3355','2013-04-29','11:10:00',1.72),('3355','2013-04-29','11:15:00',1.58),('3355','2013-04-29','11:20:00',1.81),('3355','2013-04-29','11:25:00',1.88),('3355','2013-04-29','11:30:00',1.99),('3355','2013-04-29','11:35:00',1.9),('3355','2013-04-29','11:40:00',1.92),('3355','2013-04-29','11:45:00',1.9),('3355','2013-04-29','11:50:00',2.06),('3355','2013-04-29','11:55:00',2.03),('3355','2013-04-29','12:00:00',2.13),('3355','2013-04-29','12:05:00',2.13),('3355','2013-04-29','12:10:00',2.05),('3355','2013-04-29','12:15:00',2.06),('3355','2013-04-29','12:20:00',2.09),('3355','2013-04-29','12:25:00',2.06),('3355','2013-04-29','12:30:00',2.09),('3355','2013-04-29','12:35:00',2.14),('3355','2013-04-29','12:40:00',2.19),('3355','2013-04-29','12:45:00',2.21),('3355','2013-04-29','12:50:00',2.2),('3355','2013-04-29','12:55:00',2.12),('3355','2013-04-29','13:00:00',2.17),('3355','2013-04-29','13:05:00',2.16),('3355','2013-04-29','13:10:00',2.13),('3355','2013-04-29','13:15:00',1.99),('3355','2013-04-29','13:20:00',2.11),('3355','2013-04-29','13:25:00',2.24),('3355','2013-04-29','13:30:00',2.19),('3355','2013-04-29','13:35:00',2.18),('3355','2013-04-29','13:40:00',2.16),('3355','2013-04-29','13:45:00',2.13),('3355','2013-04-29','13:50:00',2.1),('3355','2013-04-29','13:55:00',2.21),('3355','2013-04-29','14:00:00',2.08),('3355','2013-04-29','14:05:00',2.13),('3355','2013-04-29','14:10:00',2.12),('3355','2013-04-29','14:15:00',2.16),('3355','2013-04-29','14:20:00',2.15),('3355','2013-04-29','14:25:00',2.11),('3355','2013-04-29','14:30:00',2.02),('3355','2013-04-29','14:35:00',1.96),('3355','2013-04-29','14:40:00',1.86),('3355','2013-04-29','14:45:00',2.02),('3355','2013-04-29','14:50:00',1.95),('3355','2013-04-29','14:55:00',2.02),('3355','2013-04-29','15:00:00',1.94),('3355','2013-04-29','15:05:00',2.05),('3355','2013-04-29','15:10:00',1.94),('3355','2013-04-29','15:15:00',1.78),('3355','2013-04-29','15:20:00',1.87),('3355','2013-04-29','15:25:00',1.97),('3355','2013-04-29','15:30:00',1.93),('3355','2013-04-29','15:35:00',1.72),('3355','2013-04-29','15:40:00',1.56),('3355','2013-04-29','15:45:00',1.49),('3355','2013-04-29','15:50:00',1.53),('3355','2013-04-29','15:55:00',1.63),('3355','2013-04-29','16:00:00',1.59),('3355','2013-04-29','16:05:00',1.71),('3355','2013-04-29','16:10:00',1.58),('3355','2013-04-29','16:15:00',1.85),('3355','2013-04-29','16:20:00',1.82),('3355','2013-04-29','16:25:00',1.4),('3355','2013-04-29','16:30:00',1.47),('3355','2013-04-29','16:35:00',1.48),('3355','2013-04-29','16:40:00',1.57),('3355','2013-04-29','16:45:00',1.54),('3355','2013-04-29','16:50:00',1.58),('3355','2013-04-29','16:55:00',1.65),('3355','2013-04-29','17:00:00',1.52),('3355','2013-04-29','17:05:00',1.31),('3355','2013-04-29','17:10:00',1.36),('3355','2013-04-29','17:15:00',1.2),('3355','2013-04-28','08:50:00',1.01),('3355','2013-04-28','08:55:00',1.06),('3355','2013-04-28','09:00:00',1.1),('3355','2013-04-28','09:05:00',1.15),('3355','2013-04-28','09:10:00',1.2),('3355','2013-04-28','09:15:00',1.24),('3355','2013-04-28','09:20:00',1.3),('3355','2013-04-28','09:25:00',1.34),('3355','2013-04-28','09:30:00',1.38),('3355','2013-04-28','09:35:00',1.43),('3355','2013-04-28','09:40:00',1.47),('3355','2013-04-28','09:45:00',1.52),('3355','2013-04-28','09:50:00',1.56),('3355','2013-04-28','09:55:00',1.6),('3355','2013-04-28','10:00:00',1.63),('3355','2013-04-28','10:05:00',1.65),('3355','2013-04-28','10:10:00',1.69),('3355','2013-04-28','10:15:00',1.68),('3355','2013-04-28','10:20:00',1.75),('3355','2013-04-28','10:25:00',1.82),('3355','2013-04-28','10:30:00',1.8),('3355','2013-04-28','10:35:00',1.85),('3355','2013-04-28','10:40:00',1.67),('3355','2013-04-28','10:45:00',1.92),('3355','2013-04-28','10:50:00',1.93),('3355','2013-04-28','10:55:00',1.95),('3355','2013-04-28','11:00:00',1.98),('3355','2013-04-28','11:05:00',2),('3355','2013-04-28','11:10:00',2.04),('3355','2013-04-28','11:15:00',2.06),('3355','2013-04-28','11:20:00',2.05),('3355','2013-04-28','11:25:00',2.08),('3355','2013-04-28','11:30:00',2.11),('3355','2013-04-28','11:35:00',2.06),('3355','2013-04-28','11:40:00',2.09),('3355','2013-04-28','11:45:00',2),('3355','2013-04-28','11:50:00',2.05),('3355','2013-04-28','11:55:00',2.12),('3355','2013-04-28','12:00:00',1.89),('3355','2013-04-28','12:05:00',1.87),('3355','2013-04-28','12:10:00',2.07),('3355','2013-04-28','12:15:00',2.14),('3355','2013-04-28','12:20:00',2.09),('3355','2013-04-28','12:25:00',1.88),('3355','2013-04-28','12:30:00',1.79),('3355','2013-04-28','12:35:00',1.56),('3355','2013-04-28','12:40:00',1.63),('3355','2013-04-28','12:45:00',2.14),('3355','2013-04-28','12:50:00',2.23),('3355','2013-04-28','12:55:00',2.05),('3355','2013-04-28','13:00:00',2.12),('3355','2013-04-28','13:05:00',2.31),('3355','2013-04-28','13:10:00',2.24),('3355','2013-04-28','13:15:00',2.04),('3355','2013-04-28','13:20:00',2.13),('3355','2013-04-28','13:25:00',2.08),('3355','2013-04-28','13:30:00',2.22),('3355','2013-04-28','13:35:00',2.22),('3355','2013-04-28','13:40:00',2.36),('3355','2013-04-28','13:45:00',1.92),('3355','2013-04-28','13:50:00',2.03),('3355','2013-04-28','13:55:00',2.31),('3355','2013-04-28','14:00:00',2.26),('3355','2013-04-28','14:05:00',2.23),('3355','2013-04-28','14:10:00',2.15),('3355','2013-04-28','14:15:00',2.12),('3355','2013-04-28','14:20:00',2.21),('3355','2013-04-28','14:25:00',2.17),('3355','2013-04-28','14:30:00',2.15),('3355','2013-04-28','14:35:00',2.16),('3355','2013-04-28','14:40:00',2.14),('3355','2013-04-28','14:45:00',2.11),('3355','2013-04-28','14:50:00',2.09),('3355','2013-04-28','14:55:00',2.07),('3355','2013-04-28','15:00:00',2.05),('3355','2013-04-28','15:05:00',2.03),('3355','2013-04-28','15:10:00',2.03),('3355','2013-04-28','15:15:00',2),('3355','2013-04-28','15:20:00',1.98),('3355','2013-04-28','15:25:00',1.95),('3355','2013-04-28','15:30:00',1.93),('3355','2013-04-28','15:35:00',1.91),('3355','2013-04-28','15:40:00',1.89),('3355','2013-04-28','15:45:00',1.87),('3355','2013-04-28','15:50:00',1.84),('3355','2013-04-28','15:55:00',1.81),('3355','2013-04-28','16:00:00',1.78),('3355','2013-04-28','16:05:00',1.75),('3355','2013-04-28','16:10:00',1.71),('3355','2013-04-28','16:15:00',1.68),('3355','2013-04-28','16:20:00',1.65),('3355','2013-04-28','16:25:00',1.61),('3355','2013-04-28','16:30:00',1.58),('3355','2013-04-28','16:35:00',1.54),('3355','2013-04-28','16:40:00',1.5),('3355','2013-04-28','16:45:00',1.47),('3355','2013-04-28','16:50:00',1.43),('3355','2013-04-28','16:55:00',1.39),('3355','2013-04-28','17:00:00',1.35),('3355','2013-04-28','17:05:00',1.26),('3355','2013-04-28','17:10:00',1.18),('3355','2013-04-28','17:15:00',1.24),('3355','2013-04-28','17:20:00',1.18),('3355','2013-04-28','17:25:00',1.15),('3355','2013-04-27','13:40:00',1.03),('3355','2013-04-27','14:30:00',1.19),('3355','2013-04-27','15:05:00',1.01),('3355','2013-04-27','16:55:00',1.3),('3355','2013-04-27','17:00:00',1.6),('3355','2013-04-26','09:40:00',1.11),('3355','2013-04-26','09:45:00',1.4),('3355','2013-04-26','09:50:00',1.31),('3355','2013-04-26','10:05:00',1.28),('3355','2013-04-26','10:10:00',1.59),('3355','2013-04-26','10:15:00',1.6),('3355','2013-04-26','10:20:00',1.62),('3355','2013-04-26','10:25:00',1.27),('3355','2013-04-26','10:30:00',1.78),('3355','2013-04-26','10:35:00',1.84),('3355','2013-04-26','10:40:00',1.71),('3355','2013-04-26','10:45:00',1.52),('3355','2013-04-26','10:50:00',1.04),('3355','2013-04-26','10:55:00',1.46),('3355','2013-04-26','11:00:00',1.58),('3355','2013-04-26','11:05:00',1.85),('3355','2013-04-26','11:10:00',1.61),('3355','2013-04-26','11:15:00',1.98),('3355','2013-04-26','11:20:00',1.52),('3355','2013-04-26','11:25:00',1.67),('3355','2013-04-26','11:30:00',1.68),('3355','2013-04-26','11:35:00',1.89),('3355','2013-04-26','11:40:00',1.79),('3355','2013-04-26','11:45:00',1.77),('3355','2013-04-26','11:50:00',1.46),('3355','2013-04-26','11:55:00',1.35),('3355','2013-04-26','12:00:00',1.59),('3355','2013-04-26','12:05:00',1.33),('3355','2013-04-26','12:10:00',1.22),('3355','2013-04-26','12:15:00',1.45),('3355','2013-04-26','12:20:00',1.3),('3355','2013-04-26','12:25:00',1.03),('3355','2013-04-26','12:35:00',1.29),('3355','2013-04-26','12:40:00',1.74),('3355','2013-04-26','12:45:00',1.91),('3355','2013-04-26','12:50:00',1.12),('3355','2013-04-26','12:55:00',1.05),('3355','2013-04-26','13:15:00',1.17),('3355','2013-04-26','13:25:00',1.07),('3355','2013-04-26','13:30:00',1.39),('3355','2013-04-26','13:35:00',1.2),('3355','2013-04-26','13:40:00',1.51),('3355','2013-04-26','13:45:00',1.24),('3355','2013-04-26','13:50:00',1.47),('3355','2013-04-26','13:55:00',1.48),('3355','2013-04-26','14:00:00',1.58),('3355','2013-04-26','14:05:00',1.86),('3355','2013-04-26','14:10:00',2.04),('3355','2013-04-26','14:15:00',1.91),('3355','2013-04-26','14:20:00',1.87),('3355','2013-04-26','14:25:00',1.77),('3355','2013-04-26','14:30:00',2.14),('3355','2013-04-26','14:35:00',1.67),('3355','2013-04-26','14:45:00',1.03),('3355','2013-04-26','14:50:00',2.11),('3355','2013-04-26','14:55:00',2.27),('3355','2013-04-26','15:00:00',2.14),('3355','2013-04-26','15:05:00',1.56),('3355','2013-04-26','15:30:00',1.13),('3355','2013-04-26','15:35:00',1.02),('3355','2013-04-26','15:40:00',1.06),('3355','2013-04-26','15:45:00',1.1),('3355','2013-04-26','15:50:00',1.01),('3355','2013-04-25','08:50:00',1.01),('3355','2013-04-25','08:55:00',1.19),('3355','2013-04-25','09:00:00',1.04),('3355','2013-04-25','09:40:00',1.08),('3355','2013-04-25','09:45:00',1.34),('3355','2013-04-25','09:50:00',1.58),('3355','2013-04-25','09:55:00',1.59),('3355','2013-04-25','10:00:00',1.62),('3355','2013-04-25','10:05:00',1.56),('3355','2013-04-25','10:10:00',1.41),('3355','2013-04-25','10:15:00',1.44),('3355','2013-04-25','10:20:00',1.68),('3355','2013-04-25','10:25:00',1.73),('3355','2013-04-25','10:30:00',1.8),('3355','2013-04-25','10:35:00',1.83),('3355','2013-04-25','10:40:00',1.84),('3355','2013-04-25','10:45:00',1.77),('3355','2013-04-25','10:50:00',1.8),('3355','2013-04-25','10:55:00',1.92),('3355','2013-04-25','11:00:00',1.95),('3355','2013-04-25','11:05:00',1.98),('3355','2013-04-25','11:10:00',2),('3355','2013-04-25','11:15:00',2.01),('3355','2013-04-25','11:20:00',2.03),('3355','2013-04-25','11:25:00',2.06),('3355','2013-04-25','11:30:00',2.08),('3355','2013-04-25','11:35:00',2.11),('3355','2013-04-25','11:40:00',2.13),('3355','2013-04-25','11:45:00',2.15),('3355','2013-04-25','11:50:00',2.18),('3355','2013-04-25','11:55:00',2.14),('3355','2013-04-25','12:00:00',2.11),('3355','2013-04-25','12:05:00',2.11),('3355','2013-04-25','12:10:00',2.16),('3355','2013-04-25','12:15:00',2.19),('3355','2013-04-25','12:20:00',2.2),('3355','2013-04-25','12:25:00',2.2),('3355','2013-04-25','12:30:00',2.2),('3355','2013-04-25','12:35:00',2.22),('3355','2013-04-25','12:40:00',2.21),('3355','2013-04-25','12:45:00',2.22),('3355','2013-04-25','12:50:00',2.21),('3355','2013-04-25','12:55:00',2.23),('3355','2013-04-25','13:00:00',2.26),('3355','2013-04-25','13:05:00',2.3),('3355','2013-04-25','13:10:00',2.29),('3355','2013-04-25','13:15:00',2.08),('3355','2013-04-25','13:20:00',1.99),('3355','2013-04-25','13:25:00',1.88),('3355','2013-04-25','13:30:00',1.56),('3355','2013-04-25','13:35:00',1.56),('3355','2013-04-25','13:40:00',1.29),('3355','2013-04-25','13:45:00',1.18),('3355','2013-04-25','13:50:00',1.1),('3355','2013-04-25','13:55:00',1.16),('3355','2013-04-25','14:00:00',1.23),('3355','2013-04-25','14:05:00',1.11),('3355','2013-04-25','14:10:00',1.24),('3355','2013-04-25','14:15:00',1.28),('3355','2013-04-25','14:20:00',1.3),('3355','2013-04-25','14:25:00',1.32),('3355','2013-04-25','14:30:00',1.56),('3355','2013-04-25','14:35:00',1.87),('3355','2013-04-25','14:40:00',1.91),('3355','2013-04-25','14:45:00',1.88),('3355','2013-04-25','14:50:00',1.74),('3355','2013-04-25','14:55:00',1.78),('3355','2013-04-25','15:00:00',1.76),('3355','2013-04-25','15:05:00',1.59),('3355','2013-04-25','15:10:00',1.59),('3355','2013-04-25','15:15:00',1.78),('3355','2013-04-25','15:20:00',1.86),('3355','2013-04-25','15:25:00',1.96),('3355','2013-04-25','15:30:00',1.93),('3355','2013-04-25','15:35:00',1.8),('3355','2013-04-25','15:40:00',1.72),('3355','2013-04-25','15:45:00',1.58),('3355','2013-04-25','15:50:00',1.49),('3355','2013-04-25','15:55:00',1.46),('3355','2013-04-25','16:00:00',1.48),('3355','2013-04-25','16:05:00',1.21),('3355','2013-04-25','16:10:00',1.27),('3355','2013-04-25','16:15:00',1.21),('3355','2013-04-25','16:20:00',1.24),('3355','2013-04-25','16:25:00',1.11),('3355','2013-04-25','16:30:00',1.04),('3355','2013-04-25','16:35:00',1.33),('3355','2013-04-25','16:40:00',1.17),('3355','2013-04-25','16:45:00',1.12),('3355','2013-04-25','16:55:00',1.08),('3355','2013-04-25','17:05:00',1.25),('3355','2013-04-25','17:10:00',1.36),('3355','2013-04-25','17:15:00',1.25),('3355','2013-04-25','17:20:00',1.21),('3355','2013-04-25','17:25:00',1.02),('3355','2013-04-24','09:00:00',1.05),('3355','2013-04-24','09:05:00',1.15),('3355','2013-04-24','09:10:00',1.1),('3355','2013-04-24','09:15:00',1.17),('3355','2013-04-24','09:20:00',1.06),('3355','2013-04-24','09:25:00',1.26),('3355','2013-04-24','09:30:00',1.55),('3355','2013-04-24','09:35:00',1.41),('3355','2013-04-24','09:40:00',1.33),('3355','2013-04-24','09:45:00',1.3),('3355','2013-04-24','09:50:00',1.38),('3355','2013-04-24','09:55:00',1.59),('3355','2013-04-24','10:00:00',1.66),('3355','2013-04-24','10:05:00',1.71),('3355','2013-04-24','10:10:00',1.73),('3355','2013-04-24','10:15:00',1.74),('3355','2013-04-24','10:20:00',1.72),('3355','2013-04-24','10:25:00',1.71),('3355','2013-04-24','10:30:00',1.7),('3355','2013-04-24','10:35:00',1.7),('3355','2013-04-24','10:40:00',1.88),('3355','2013-04-24','10:45:00',1.93),('3355','2013-04-24','10:50:00',1.95),('3355','2013-04-24','10:55:00',2),('3355','2013-04-24','11:00:00',2.03),('3355','2013-04-24','11:05:00',1.98),('3355','2013-04-24','11:10:00',2.11),('3355','2013-04-24','11:15:00',2.17),('3355','2013-04-24','11:20:00',2.21),('3355','2013-04-24','11:25:00',2.22),('3355','2013-04-24','11:30:00',2.17),('3355','2013-04-24','11:35:00',1.92),('3355','2013-04-24','11:40:00',1.36),('3355','2013-04-24','11:45:00',1.62),('3355','2013-04-24','11:50:00',1.11),('3355','2013-04-24','11:55:00',1.56),('3355','2013-04-24','12:00:00',1.97),('3355','2013-04-24','12:05:00',1.24),('3355','2013-04-24','12:10:00',1.45),('3355','2013-04-24','12:15:00',2.12),('3355','2013-04-24','12:20:00',2.47),('3355','2013-04-24','12:25:00',2.16),('3355','2013-04-24','12:30:00',2.09),('3355','2013-04-24','12:35:00',2.15),('3355','2013-04-24','12:40:00',2.02),('3355','2013-04-24','12:45:00',2.08),('3355','2013-04-24','12:50:00',2.24),('3355','2013-04-24','12:55:00',2.17),('3355','2013-04-24','13:00:00',2.13),('3355','2013-04-24','13:05:00',1.83),('3355','2013-04-24','13:10:00',2.4),('3355','2013-04-24','13:15:00',2.21),('3355','2013-04-24','13:20:00',2.13),('3355','2013-04-24','13:25:00',2.18),('3355','2013-04-24','13:30:00',2.08),('3355','2013-04-24','13:35:00',2.11),('3355','2013-04-24','13:40:00',2.36),('3355','2013-04-24','13:45:00',2.07),('3355','2013-04-24','13:50:00',1.4),('3355','2013-04-24','13:55:00',2.26),('3355','2013-04-24','14:00:00',2.29),('3355','2013-04-24','14:05:00',1.6),('3355','2013-04-24','14:10:00',1.52),('3355','2013-04-24','14:15:00',2.29),('3355','2013-04-24','14:20:00',2.06),('3355','2013-04-24','14:25:00',2.13),('3355','2013-04-24','14:30:00',2.02),('3355','2013-04-24','14:35:00',1.78),('3355','2013-04-24','14:40:00',1.72),('3355','2013-04-24','14:45:00',1.65),('3355','2013-04-24','14:50:00',1.48),('3355','2013-04-24','14:55:00',1.3),('3355','2013-04-24','15:00:00',1.43),('3355','2013-04-24','15:05:00',1.3),('3355','2013-04-24','15:10:00',1.23),('3355','2013-04-24','15:15:00',1.29),('3355','2013-04-24','15:20:00',1.36),('3355','2013-04-24','15:25:00',1.16),('3355','2013-04-24','15:55:00',1.16),('3355','2013-04-24','16:00:00',1.52),('3355','2013-04-24','16:05:00',1.57),('3355','2013-04-24','16:10:00',1.56),('3355','2013-04-24','16:15:00',1.43),('3355','2013-04-24','16:20:00',1.88),('3355','2013-04-24','16:25:00',1.45),('3355','2013-04-24','16:30:00',1.27),('3355','2013-04-24','16:35:00',1.01),('3355','2013-04-24','16:40:00',1.43),('3355','2013-04-24','16:45:00',1.48),('3355','2013-04-24','16:50:00',1.3),('3355','2013-04-24','16:55:00',1.56),('3355','2013-04-24','17:00:00',1.6),('3355','2013-04-24','17:05:00',1.49),('3355','2013-04-24','17:10:00',1.44),('3355','2013-04-24','17:15:00',1.1),('3355','2013-04-23','08:50:00',1.05),('3355','2013-04-23','08:55:00',1.1),('3355','2013-04-23','09:00:00',1.15),('3355','2013-04-23','09:05:00',1.2),('3355','2013-04-23','09:10:00',1.26),('3355','2013-04-23','09:15:00',1.31),('3355','2013-04-23','09:20:00',1.35),('3355','2013-04-23','09:25:00',1.4),('3355','2013-04-23','09:30:00',1.45),('3355','2013-04-23','09:35:00',1.5),('3355','2013-04-23','09:40:00',1.41),('3355','2013-04-23','09:45:00',1.37),('3355','2013-04-23','09:50:00',1.66),('3355','2013-04-23','09:55:00',1.69),('3355','2013-04-23','10:00:00',1.7),('3355','2013-04-23','10:05:00',1.73),('3355','2013-04-23','10:10:00',1.78),('3355','2013-04-23','10:15:00',1.81),('3355','2013-04-23','10:20:00',1.85),('3355','2013-04-23','10:25:00',1.87),('3355','2013-04-23','10:30:00',1.91),('3355','2013-04-23','10:35:00',1.94),('3355','2013-04-23','10:40:00',1.97),('3355','2013-04-23','10:45:00',1.96),('3355','2013-04-23','10:50:00',1.98),('3355','2013-04-23','10:55:00',2.04),('3355','2013-04-23','11:00:00',2.08),('3355','2013-04-23','11:05:00',2.09),('3355','2013-04-23','11:10:00',2.1),('3355','2013-04-23','11:15:00',2.12),('3355','2013-04-23','11:20:00',2.15),('3355','2013-04-23','11:25:00',2.18),('3355','2013-04-23','11:30:00',2.2),('3355','2013-04-23','11:35:00',2.2),('3355','2013-04-23','11:40:00',2.21),('3355','2013-04-23','11:45:00',2.23),('3355','2013-04-23','11:50:00',2.24),('3355','2013-04-23','11:55:00',2.25),('3355','2013-04-23','12:00:00',2.26),('3355','2013-04-23','12:05:00',2.23),('3355','2013-04-23','12:10:00',2.27),('3355','2013-04-23','12:15:00',2.26),('3355','2013-04-23','12:20:00',2.27),('3355','2013-04-23','12:25:00',2.26),('3355','2013-04-23','12:35:00',1.83),('3355','2013-04-23','12:40:00',1.28),('3355','2013-04-23','12:50:00',1.81),('3355','2013-04-23','13:00:00',1.98),('3355','2013-04-23','13:05:00',1.33),('3355','2013-04-23','13:15:00',2.44),('3355','2013-04-23','13:20:00',2.31),('3355','2013-04-23','13:25:00',2.54),('3355','2013-04-23','13:30:00',2.42),('3355','2013-04-23','13:35:00',2.46),('3355','2013-04-23','13:40:00',2.43),('3355','2013-04-23','13:45:00',1.72),('3355','2013-04-23','13:50:00',2.15),('3355','2013-04-23','13:55:00',2.27),('3355','2013-04-23','14:00:00',1.12),('3355','2013-04-23','14:05:00',2.57),('3355','2013-04-23','14:10:00',1.66),('3355','2013-04-23','14:15:00',2.21),('3355','2013-04-23','14:20:00',2.18),('3355','2013-04-23','14:25:00',2.01),('3355','2013-04-23','15:05:00',1.35),('3355','2013-04-23','15:10:00',1.62),('3355','2013-04-23','15:15:00',1.65),('3355','2013-04-23','15:20:00',1.5),('3355','2013-04-23','15:25:00',1.38),('3355','2013-04-23','15:30:00',1.35),('3355','2013-04-23','15:35:00',1.3),('3355','2013-04-23','15:40:00',1.16),('3355','2013-04-23','15:45:00',1.2),('3355','2013-04-23','15:50:00',1.01),('3355','2013-04-23','17:15:00',1.27),('3355','2013-04-23','17:20:00',1.27),('3355','2013-04-23','17:25:00',1.05),('3355','2013-04-22','10:35:00',1.17),('3355','2013-04-22','10:40:00',2.03),('3355','2013-04-22','10:45:00',2.62),('3355','2013-04-22','10:50:00',1.24),('3355','2013-04-22','10:55:00',1.18),('3355','2013-04-22','11:00:00',1.09),('3355','2013-04-22','11:05:00',1.03),('3355','2013-04-22','11:10:00',1.18),('3355','2013-04-22','11:25:00',1.01),('3355','2013-04-22','11:30:00',1.65),('3355','2013-04-22','11:35:00',1.86),('3355','2013-04-22','11:40:00',2.01),('3355','2013-04-22','11:55:00',2.31),('3355','2013-04-22','12:00:00',1.5),('3355','2013-04-22','12:05:00',1.75),('3355','2013-04-22','12:10:00',2.65),('3355','2013-04-22','12:15:00',1.89),('3355','2013-04-22','12:20:00',2.23),('3355','2013-04-22','12:25:00',1.32),('3355','2013-04-22','12:30:00',1.52),('3355','2013-04-22','12:35:00',1.63),('3355','2013-04-22','12:40:00',2.45),('3355','2013-04-22','12:45:00',2.39),('3355','2013-04-22','12:50:00',2.53),('3355','2013-04-22','12:55:00',2.55),('3355','2013-04-22','13:00:00',2.55),('3355','2013-04-22','13:05:00',2.65),('3355','2013-04-22','13:10:00',2.66),('3355','2013-04-22','13:15:00',2.52),('3355','2013-04-22','13:20:00',2.24),('3355','2013-04-22','13:25:00',1.3),('3355','2013-04-22','13:30:00',1.66),('3355','2013-04-22','13:35:00',1.42),('3355','2013-04-22','13:40:00',1.65),('3355','2013-04-22','13:45:00',2.45),('3355','2013-04-22','14:20:00',2.37),('3355','2013-04-22','14:25:00',2.29),('3355','2013-04-22','14:30:00',2.64),('3355','2013-04-22','14:35:00',1.46),('3355','2013-04-22','14:45:00',2.52),('3355','2013-04-22','14:50:00',2.57),('3355','2013-04-22','14:55:00',2.23),('3355','2013-04-22','15:00:00',1.85),('3355','2013-04-22','15:05:00',2.5),('3355','2013-04-22','15:10:00',1.15),('3355','2013-04-22','15:30:00',1.22),('3355','2013-04-22','15:40:00',1.24),('3355','2013-04-22','15:45:00',1.93),('3355','2013-04-22','15:50:00',1.44),('3355','2014-03-29','08:15:00',1),('3355','2014-03-29','08:20:00',1.06),('3355','2014-03-29','08:25:00',1.1),('3355','2014-03-29','08:30:00',1.15),('3355','2014-03-29','08:35:00',1.2),('3355','2014-03-29','08:40:00',1.24),('3355','2014-03-29','08:45:00',1.29),('3355','2014-03-29','08:50:00',1.33),('3355','2014-03-29','08:55:00',1.36),('3355','2014-03-29','09:00:00',1.41),('3355','2014-03-29','09:05:00',1.45),('3355','2014-03-29','09:10:00',1.5),('3355','2014-03-29','09:15:00',1.54),('3355','2014-03-29','09:20:00',1.58),('3355','2014-03-29','09:25:00',1.63),('3355','2014-03-29','09:30:00',1.65),('3355','2014-03-29','09:35:00',1.7),('3355','2014-03-29','09:40:00',1.74),('3355','2014-03-29','09:45:00',1.77),('3355','2014-03-29','09:50:00',1.82),('3355','2014-03-29','09:55:00',1.87),('3355','2014-03-29','10:00:00',1.9),('3355','2014-03-29','10:05:00',1.93),('3355','2014-03-29','10:10:00',1.96),('3355','2014-03-29','10:15:00',1.99),('3355','2014-03-29','10:20:00',2.02),('3355','2014-03-29','10:25:00',2.04),('3355','2014-03-29','10:30:00',2.05),('3355','2014-03-29','10:35:00',2.08),('3355','2014-03-29','10:40:00',2.08),('3355','2014-03-29','10:45:00',2.11),('3355','2014-03-29','10:50:00',2.14),('3355','2014-03-29','10:55:00',2.16),('3355','2014-03-29','11:00:00',2.17),('3355','2014-03-29','11:05:00',2.18),('3355','2014-03-29','11:10:00',2.21),('3355','2014-03-29','11:15:00',2.23),('3355','2014-03-29','11:20:00',2.22),('3355','2014-03-29','11:25:00',2.24),('3355','2014-03-29','11:30:00',2.22),('3355','2014-03-29','11:35:00',2.24),('3355','2014-03-29','11:40:00',2.2),('3355','2014-03-29','11:45:00',2.29),('3355','2014-03-29','11:50:00',2.28),('3355','2014-03-29','11:55:00',2.26),('3355','2014-03-29','12:00:00',2.26),('3355','2014-03-29','12:05:00',2.27),('3355','2014-03-29','12:10:00',2.28),('3355','2014-03-29','12:15:00',2.29),('3355','2014-03-29','12:20:00',2.31),('3355','2014-03-29','12:25:00',2.3),('3355','2014-03-29','12:30:00',2.32),('3355','2014-03-29','12:35:00',2.31),('3355','2014-03-29','12:40:00',2.28),('3355','2014-03-29','12:45:00',2.3),('3355','2014-03-29','12:50:00',2.3),('3355','2014-03-29','12:55:00',2.3),('3355','2014-03-29','13:00:00',2.29),('3355','2014-03-29','13:05:00',2.28),('3355','2014-03-29','13:10:00',2.27),('3355','2014-03-29','13:15:00',2.24),('3355','2014-03-29','13:20:00',2.24),('3355','2014-03-29','13:25:00',2.19),('3355','2014-03-29','13:30:00',2.18),('3355','2014-03-29','13:35:00',2.15),('3355','2014-03-29','13:40:00',2.12),('3355','2014-03-29','13:45:00',2.09),('3355','2014-03-29','13:50:00',2.09),('3355','2014-03-29','13:55:00',2.06),('3355','2014-03-29','14:00:00',2.05),('3355','2014-03-29','14:05:00',2.05),('3355','2014-03-29','14:10:00',2.03),('3355','2014-03-29','14:15:00',1.99),('3355','2014-03-29','14:20:00',1.85),('3355','2014-03-29','14:25:00',1.95),('3355','2014-03-29','14:30:00',1.89),('3355','2014-03-29','14:35:00',1.84),('3355','2014-03-29','14:40:00',1.83),('3355','2014-03-29','14:45:00',1.79),('3355','2014-03-29','14:50:00',1.78),('3355','2014-03-29','14:55:00',1.81),('3355','2014-03-29','15:00:00',1.76),('3355','2014-03-29','15:05:00',1.72),('3355','2014-03-29','15:10:00',1.61),('3355','2014-03-29','15:15:00',1.63),('3355','2014-03-29','15:20:00',1.62),('3355','2014-03-29','15:25:00',1.57),('3355','2014-03-29','15:30:00',1.49),('3355','2014-03-29','15:35:00',1.42),('3355','2014-03-29','15:40:00',1.41),('3355','2014-03-29','15:45:00',1.38),('3355','2014-03-29','15:50:00',1.34),('3355','2014-03-29','15:55:00',1.3),('3355','2014-03-29','16:00:00',1.26),('3355','2014-03-29','16:05:00',1.2),('3355','2014-03-29','16:10:00',1.15),('3355','2014-03-29','16:15:00',1.11),('3355','2014-03-29','16:20:00',1.01),('3355','2013-04-21','09:10:00',1.22),('3355','2013-04-21','09:15:00',1.33),('3355','2013-04-21','09:30:00',1.53),('3355','2013-04-21','09:35:00',1.58),('3355','2013-04-21','09:40:00',1.57),('3355','2013-04-21','09:45:00',1.71),('3355','2013-04-21','09:50:00',1.86),('3355','2013-04-21','09:55:00',1.59),('3355','2013-04-21','10:00:00',1.55),('3355','2013-04-21','10:05:00',1.37),('3355','2013-04-21','10:10:00',1.07),('3355','2013-04-21','10:20:00',1.44),('3355','2013-04-21','10:25:00',1.79),('3355','2013-04-21','10:30:00',1.65),('3355','2013-04-21','10:35:00',1.27),('3355','2013-04-21','10:40:00',1.76),('3355','2013-04-21','10:45:00',1.59),('3355','2013-04-21','10:50:00',2.03),('3355','2013-04-21','10:55:00',1.86),('3355','2013-04-21','11:00:00',1.95),('3355','2013-04-21','11:05:00',2),('3355','2013-04-21','11:10:00',2.43),('3355','2013-04-21','11:15:00',1.59),('3355','2013-04-21','11:20:00',1.71),('3355','2013-04-21','11:25:00',1.77),('3355','2013-04-21','11:30:00',1.61),('3355','2013-04-21','11:35:00',1.68),('3355','2013-04-21','11:40:00',2.04),('3355','2013-04-21','11:45:00',2.03),('3355','2013-04-21','11:50:00',1.8),('3355','2013-04-21','11:55:00',1.77),('3355','2013-04-21','12:00:00',1.38),('3355','2013-04-21','12:05:00',1.34),('3355','2013-04-21','12:10:00',1.3),('3355','2013-04-21','12:15:00',1.22),('3355','2013-04-21','12:20:00',1.12),('3355','2013-04-21','12:25:00',1.07),('3355','2013-04-21','12:30:00',1.18),('3355','2013-04-21','12:35:00',1.2),('3355','2013-04-21','12:40:00',1.22),('3355','2013-04-21','12:45:00',1.22),('3355','2013-04-21','12:50:00',1.13),('3355','2013-04-21','12:55:00',1.11),('3355','2013-04-21','13:00:00',1.27),('3355','2013-04-21','13:05:00',1.47),('3355','2013-04-21','13:10:00',1.49),('3355','2013-04-21','13:15:00',1.42),('3355','2013-04-21','13:20:00',1.31),('3355','2013-04-21','13:25:00',1.25),('3355','2013-04-21','13:30:00',1.9),('3355','2013-04-21','13:35:00',2.12),('3355','2013-04-21','13:40:00',1.64),('3355','2013-04-21','13:45:00',1.69),('3355','2013-04-21','13:50:00',1.34),('3355','2013-04-21','13:55:00',2.39),('3355','2013-04-21','14:00:00',2.61),('3355','2013-04-21','14:05:00',2.25),('3355','2013-04-21','14:10:00',2.46),('3355','2013-04-21','14:15:00',2.14),('3355','2013-04-21','14:20:00',2.72),('3355','2013-04-21','14:25:00',2.24),('3355','2013-04-21','14:30:00',2.19),('3355','2013-04-21','14:35:00',2.18),('3355','2013-04-21','14:40:00',2.54),('3355','2013-04-21','14:45:00',2.12),('3355','2013-04-21','14:50:00',1.27),('3355','2013-04-21','14:55:00',1.2),('3355','2013-04-21','15:00:00',1.76),('3355','2013-04-21','15:05:00',2.54),('3355','2013-04-21','15:10:00',2.44),('3355','2013-04-21','15:15:00',1.98),('3355','2013-04-21','15:20:00',1.29),('3355','2013-04-21','15:25:00',1.1),('3355','2013-04-20','09:00:00',1.12),('3355','2013-04-20','09:05:00',1.15),('3355','2013-04-20','09:10:00',1.14),('3355','2013-04-20','09:15:00',1.16),('3355','2013-04-20','09:20:00',1.34),('3355','2013-04-20','09:25:00',1.29),('3355','2013-04-20','10:50:00',1.28),('3355','2013-04-20','10:55:00',1.16),('3355','2013-04-20','11:00:00',1.35),('3355','2013-04-20','11:10:00',1.18),('3355','2013-04-20','11:15:00',2.41),('3355','2013-04-20','11:20:00',1.34),('3355','2013-04-20','11:25:00',1.46),('3355','2013-04-20','11:30:00',2.42),('3355','2013-04-20','11:35:00',1.81),('3355','2013-04-20','11:40:00',1.36),('3355','2013-04-20','11:45:00',1.41),('3355','2013-04-20','11:55:00',2.35),('3355','2013-04-20','12:00:00',2.38),('3355','2013-04-20','12:10:00',2.15),('3355','2013-04-20','12:15:00',1.48),('3355','2013-04-20','12:20:00',1.4),('3355','2013-04-20','12:25:00',1.7),('3355','2013-04-20','12:30:00',2.63),('3355','2013-04-20','12:35:00',2.03),('3355','2013-04-20','13:55:00',2.67),('3355','2013-04-20','14:00:00',1.37),('3355','2013-04-20','14:30:00',2.26),('3355','2013-04-20','14:35:00',2.24),('3355','2013-04-20','14:40:00',2.23),('3355','2013-04-20','14:45:00',2.24),('3355','2013-04-20','14:50:00',2.25),('3355','2013-04-20','14:55:00',2.26),('3355','2013-04-20','15:00:00',2.24),('3355','2013-04-20','15:05:00',2.21),('3355','2013-04-20','15:10:00',1.31),('3355','2013-04-20','15:15:00',1.67),('3355','2013-04-20','15:20:00',1.54),('3355','2013-04-20','15:25:00',1.97),('3355','2013-04-20','15:30:00',1.26),('3355','2013-04-20','16:15:00',1.21),('3355','2013-04-20','16:20:00',1.21),('3355','2013-04-20','16:25:00',1.49),('3355','2013-04-20','16:30:00',1.7),('3355','2013-04-20','16:35:00',1.58),('3355','2013-04-20','16:40:00',1.72),('3355','2013-04-20','16:45:00',1.79),('3355','2013-04-20','16:50:00',1.62),('3355','2013-04-20','16:55:00',1.56),('3355','2013-04-20','17:00:00',1.48),('3355','2013-04-20','17:05:00',1.42),('3355','2013-04-20','17:10:00',1.39),('3355','2013-04-20','17:15:00',1.28),('3355','2013-04-20','17:20:00',1.17),('3355','2013-04-20','17:25:00',1.13),('3355','2013-04-20','17:30:00',1.19),('3355','2013-04-20','17:35:00',1.28),('3355','2013-04-20','17:40:00',1.18),('3355','2013-04-20','17:55:00',1.05),('3355','2013-04-18','09:05:00',1.08),('3355','2013-04-18','09:15:00',1.14),('3355','2013-04-18','09:20:00',1.23),('3355','2013-04-18','09:25:00',1.29),('3355','2013-04-18','09:30:00',1.32),('3355','2013-04-18','09:35:00',1.36),('3355','2013-04-18','09:40:00',1.53),('3355','2013-04-18','09:45:00',1.38),('3355','2013-04-18','09:50:00',1.22),('3355','2013-04-18','09:55:00',1.27),('3355','2013-04-18','10:00:00',1.54),('3355','2013-04-18','10:05:00',1.64),('3355','2013-04-18','10:10:00',1.71),('3355','2013-04-18','10:15:00',1.76),('3355','2013-04-18','10:20:00',1.79),('3355','2013-04-18','10:25:00',1.77),('3355','2013-04-18','10:30:00',1.83),('3355','2013-04-18','10:35:00',1.86),('3355','2013-04-18','10:40:00',1.89),('3355','2013-04-18','10:45:00',1.92),('3355','2013-04-18','10:50:00',1.95),('3355','2013-04-18','10:55:00',1.97),('3355','2013-04-18','11:00:00',1.99),('3355','2013-04-18','11:05:00',2.03),('3355','2013-04-18','11:10:00',2.04),('3355','2013-04-18','11:15:00',2.07),('3355','2013-04-18','11:20:00',2.09),('3355','2013-04-18','11:25:00',2.11),('3355','2013-04-18','11:30:00',2.12),('3355','2013-04-18','11:35:00',2.15),('3355','2013-04-18','11:40:00',2.15),('3355','2013-04-18','11:45:00',2.15),('3355','2013-04-18','11:50:00',2.16),('3355','2013-04-18','11:55:00',2.2),('3355','2013-04-18','12:00:00',2.19),('3355','2013-04-18','12:05:00',2.23),('3355','2013-04-18','12:10:00',2.26),('3355','2013-04-18','12:15:00',2.28),('3355','2013-04-18','12:20:00',2.29),('3355','2013-04-18','12:25:00',2.31),('3355','2013-04-18','12:30:00',2.3),('3355','2013-04-18','12:35:00',2.33),('3355','2013-04-18','12:40:00',2.33),('3355','2013-04-18','12:45:00',2.33),('3355','2013-04-18','12:50:00',2.34),('3355','2013-04-18','12:55:00',2.33),('3355','2013-04-18','13:00:00',2.34),('3355','2013-04-18','13:05:00',2.35),('3355','2013-04-18','13:10:00',2.36),('3355','2013-04-18','13:15:00',2.36),('3355','2013-04-18','13:20:00',2.34),('3355','2013-04-18','13:25:00',2.35),('3355','2013-04-18','13:30:00',2.36),('3355','2013-04-18','13:35:00',2.35),('3355','2013-04-18','13:40:00',2.35),('3355','2013-04-18','13:45:00',2.34),('3355','2013-04-18','13:50:00',2.34),('3355','2013-04-18','13:55:00',2.35),('3355','2013-04-18','14:00:00',2.34),('3355','2013-04-18','14:05:00',2.32),('3355','2013-04-18','14:10:00',2.33),('3355','2013-04-18','14:15:00',2.32),('3355','2013-04-18','14:20:00',2.31),('3355','2013-04-18','14:25:00',2.3),('3355','2013-04-18','14:50:00',2.21),('3355','2013-04-18','14:55:00',2.2),('3355','2014-03-28','08:15:00',1.04),('3355','2014-03-28','08:20:00',1.1),('3355','2014-03-28','08:25:00',1.14),('3355','2014-03-28','08:30:00',1.19),('3355','2014-03-28','08:35:00',1.24),('3355','2014-03-28','08:40:00',1.29),('3355','2014-03-28','08:45:00',1.34),('3355','2014-03-28','08:50:00',1.39),('3355','2014-03-28','08:55:00',1.45),('3355','2014-03-28','09:00:00',1.47),('3355','2014-03-28','09:05:00',1.56),('3355','2014-03-28','09:10:00',1.67),('3355','2014-03-28','09:15:00',1.67),('3355','2014-03-28','09:20:00',1.44),('3355','2014-03-28','09:25:00',1.72),('3355','2014-03-28','09:30:00',1.85),('3355','2014-03-28','09:35:00',1.7),('3355','2014-03-28','09:40:00',1.15),('3355','2014-03-28','09:50:00',1.15),('3355','2014-03-28','09:55:00',1.78),('3355','2014-03-28','10:00:00',2.06),('3355','2014-03-28','10:05:00',1.99),('3355','2014-03-28','10:10:00',1.58),('3355','2014-03-28','10:15:00',1.55),('3355','2014-03-28','10:20:00',1.47),('3355','2014-03-28','10:25:00',1.96),('3355','2014-03-28','10:30:00',2.08),('3355','2014-03-28','10:35:00',1.9),('3355','2014-03-28','10:40:00',1.97),('3355','2014-03-28','10:45:00',1.58),('3355','2014-03-28','10:50:00',2.07),('3355','2014-03-28','10:55:00',2.24),('3355','2014-03-28','11:00:00',2.25),('3355','2014-03-28','11:05:00',2.25),('3355','2014-03-28','11:10:00',1.72),('3355','2014-03-28','11:15:00',2.29),('3355','2014-03-28','11:20:00',2.28),('3355','2014-03-28','11:25:00',1.59),('3355','2014-03-28','11:30:00',1.51),('3355','2014-03-28','11:35:00',2.62),('3355','2014-03-28','11:40:00',1.13),('3355','2014-03-28','12:10:00',2.65),('3355','2014-03-28','12:15:00',2.7),('3355','2014-03-28','12:20:00',2.49),('3355','2014-03-28','12:25:00',1),('3355','2014-03-28','12:30:00',1.25),('3355','2014-03-28','12:35:00',2.1),('3355','2014-03-28','12:40:00',1.83),('3355','2014-03-28','12:45:00',2.5),('3355','2014-03-28','12:50:00',2.45),('3355','2014-03-28','12:55:00',2.58),('3355','2014-03-28','13:00:00',2.15),('3355','2014-03-28','13:05:00',1.45),('3355','2014-03-28','13:20:00',2.57),('3355','2014-03-28','13:25:00',1.59),('3355','2014-03-28','13:35:00',2.47),('3355','2014-03-28','13:40:00',2.13),('3355','2014-03-28','13:45:00',2.34),('3355','2014-03-28','13:50:00',2.28),('3355','2014-03-28','13:55:00',2.19),('3355','2014-03-28','14:00:00',2.24),('3355','2014-03-28','14:05:00',2.2),('3355','2014-03-28','14:10:00',2.13),('3355','2014-03-28','14:15:00',2.15),('3355','2014-03-28','14:20:00',2.13),('3355','2014-03-28','14:25:00',2.1),('3355','2014-03-28','14:30:00',2.07),('3355','2014-03-28','14:35:00',2.06),('3355','2014-03-28','14:40:00',2.03),('3355','2014-03-28','14:45:00',2),('3355','2014-03-28','14:50:00',1.97),('3355','2014-03-28','14:55:00',1.93),('3355','2014-03-28','15:00:00',1.93),('3355','2014-03-28','15:05:00',1.89),('3355','2014-03-28','15:10:00',1.84),('3355','2014-03-28','15:15:00',1.8),('3355','2014-03-28','15:20:00',1.76),('3355','2014-03-28','15:25:00',1.71),('3355','2014-03-28','15:30:00',1.68),('3355','2014-03-28','15:35:00',1.64),('3355','2014-03-28','15:40:00',1.6),('3355','2014-03-28','15:45:00',1.6),('3355','2014-03-28','15:50:00',1.57),('3355','2014-03-28','15:55:00',1.51),('3355','2014-03-28','16:00:00',1.54),('3355','2014-03-28','16:05:00',1.56),('3355','2014-03-28','16:10:00',1.52),('3355','2014-03-28','16:15:00',1.48),('3355','2014-03-28','16:20:00',1.31),('3355','2014-03-28','16:25:00',1.15),('3355','2014-05-02','10:10:00',1.04),('3355','2014-05-02','13:05:00',1.01),('3355','2014-05-02','13:10:00',1.1),('3355','2014-05-02','13:15:00',1.17),('3355','2014-05-02','13:20:00',1.73),('3355','2014-05-02','13:25:00',1.61),('3355','2014-05-02','13:30:00',1.31),('3355','2014-05-02','13:35:00',1.23),('3355','2014-05-02','13:40:00',1.26),('3355','2014-05-02','13:45:00',1.25),('3355','2014-05-02','14:35:00',1.04),('3355','2014-05-02','14:40:00',1.43),('3355','2014-05-02','14:45:00',1.24),('3355','2014-05-02','14:55:00',1.02),('3355','2014-05-02','15:00:00',1.78),('3355','2014-05-02','15:05:00',1.32),('3355','2014-05-02','15:10:00',1.68),('3355','2014-05-02','15:15:00',2.34),('3355','2014-05-02','15:35:00',1.41),('3355','2014-05-02','15:40:00',2.22),('3355','2014-05-02','16:20:00',1.58),('3355','2014-03-27','10:30:00',1.22),('3355','2014-03-27','10:35:00',1.06),('3355','2014-03-27','10:40:00',1.32),('3355','2014-03-27','11:10:00',1.37),('3355','2014-03-27','11:15:00',2.6),('3355','2014-03-27','11:20:00',1.3),('3355','2014-03-27','13:15:00',1.09),('3355','2014-03-27','13:20:00',1.21),('3355','2014-03-27','13:25:00',1.32),('3355','2014-03-27','13:30:00',1.14),('3355','2014-03-27','13:35:00',1.06),('3355','2014-03-27','13:50:00',1.15),('3355','2014-03-27','13:55:00',1.47),('3355','2014-03-27','14:00:00',1.42),('3355','2014-03-27','14:15:00',1.19),('3355','2014-03-27','14:20:00',1.9),('3355','2014-03-27','14:25:00',2.07),('3355','2014-03-27','14:30:00',1.74),('3355','2014-03-27','14:35:00',1.4),('3355','2014-03-27','14:50:00',1.12),('3355','2014-03-27','14:55:00',1.52),('3355','2014-03-27','15:00:00',1.03),('3355','2014-03-27','15:25:00',1.3),('3355','2014-03-27','15:30:00',1.39),('3355','2014-03-26','08:15:00',1.1),('3355','2014-03-26','08:20:00',1.22),('3355','2014-03-26','09:30:00',1.84),('3355','2014-03-26','09:35:00',1.78),('3355','2014-03-26','09:40:00',1.8),('3355','2014-03-26','09:45:00',1.83),('3355','2014-03-26','09:50:00',1.86),('3355','2014-03-26','09:55:00',1.93),('3355','2014-03-26','10:00:00',1.7),('3355','2014-03-26','10:05:00',1.94),('3355','2014-03-26','10:10:00',1.91),('3355','2014-03-26','10:15:00',2.17),('3355','2014-03-26','10:20:00',2.23),('3355','2014-03-26','10:25:00',2.23),('3355','2014-03-26','10:30:00',2.03),('3355','2014-03-26','10:35:00',1.87),('3355','2014-03-26','10:45:00',1.7),('3355','2014-03-26','10:50:00',1.88),('3355','2014-03-26','10:55:00',1.83),('3355','2014-03-26','11:00:00',2.37),('3355','2014-03-26','11:05:00',2.07),('3355','2014-03-26','11:10:00',2.32),('3355','2014-03-26','11:15:00',2.53),('3355','2014-03-26','11:20:00',1.49),('3355','2014-03-26','11:35:00',1.03),('3355','2014-03-26','11:40:00',1.01),('3355','2014-03-26','11:45:00',1.2),('3355','2014-03-26','11:50:00',1.85),('3355','2014-03-26','11:55:00',1.96),('3355','2014-03-26','12:00:00',2.71),('3355','2014-03-26','12:05:00',2.37),('3355','2014-03-26','12:10:00',1.87),('3355','2014-03-26','12:45:00',1.19),('3355','2014-03-26','13:25:00',2.38),('3355','2014-03-26','13:30:00',2.43),('3355','2014-03-26','13:35:00',1.38),('3355','2014-03-26','13:40:00',1.31),('3355','2014-03-26','14:00:00',1.05),('3355','2014-03-26','14:05:00',2),('3355','2014-03-26','14:10:00',2.14),('3355','2014-03-26','14:50:00',1.93),('3355','2014-03-26','14:55:00',2.02),('3355','2014-03-26','15:00:00',1.71),('3355','2014-03-26','15:05:00',1.86),('3355','2014-03-26','15:10:00',1.9),('3355','2014-03-26','15:15:00',1.98),('3355','2014-03-26','15:20:00',1.82),('3355','2014-03-26','15:25:00',1.9),('3355','2014-03-26','15:30:00',1.91),('3355','2014-03-26','15:35:00',1.86),('3355','2014-03-26','15:40:00',1.39),('3355','2014-03-26','15:45:00',1.54),('3355','2014-03-26','15:50:00',1.14),('3355','2014-03-26','15:55:00',1.14),('3355','2014-03-25','08:50:00',1.01),('3355','2014-03-25','08:55:00',1.07),('3355','2014-03-25','09:15:00',1.25),('3355','2014-03-25','09:20:00',1.37),('3355','2014-03-25','09:25:00',1.2),('3355','2014-03-25','09:30:00',1.07),('3355','2014-03-25','09:40:00',1.01),('3355','2014-03-25','09:55:00',1.1),('3355','2014-03-25','10:00:00',1.29),('3355','2014-03-25','10:05:00',1.38),('3355','2014-03-25','10:10:00',1.48),('3355','2014-03-25','10:15:00',1.6),('3355','2014-03-25','10:20:00',1.63),('3355','2014-03-25','10:25:00',1.51),('3355','2014-03-25','10:30:00',1.68),('3355','2014-03-25','10:35:00',1.41),('3355','2014-03-25','10:40:00',1.16),('3355','2014-03-25','10:45:00',1.05),('3355','2014-03-25','10:50:00',1.02),('3355','2014-03-25','10:55:00',1.02),('3355','2014-03-25','11:00:00',1.1),('3355','2014-03-25','11:05:00',1.26),('3355','2014-03-25','11:10:00',1.41),('3355','2014-03-25','11:15:00',1.64),('3355','2014-03-25','11:20:00',1.72),('3355','2014-03-25','11:25:00',1.7),('3355','2014-03-25','11:30:00',1.21),('3355','2014-03-25','11:35:00',1.71),('3355','2014-03-25','11:40:00',1.24),('3355','2014-03-25','11:45:00',1.22),('3355','2014-03-25','11:50:00',1.06),('3355','2014-03-24','09:20:00',1.15),('3355','2014-03-24','10:00:00',1),('3355','2014-03-24','10:05:00',1.22),('3355','2014-03-24','10:10:00',1.74),('3355','2014-03-24','10:15:00',1.62),('3355','2014-03-24','10:50:00',2.61),('3355','2014-03-24','10:55:00',2.3),('3355','2014-03-24','11:05:00',1.45),('3355','2014-03-24','11:10:00',1.44),('3355','2014-03-24','11:15:00',1.6),('3355','2014-03-24','11:20:00',1.14),('3355','2014-03-24','11:25:00',1.45),('3355','2014-03-24','11:30:00',1.91),('3355','2014-03-24','11:35:00',1.06),('3355','2014-03-24','12:40:00',1.1),('3355','2014-03-24','14:20:00',1.16),('3355','2014-03-24','14:25:00',1.14),('3355','2014-03-24','14:35:00',1.28),('3355','2014-03-24','14:40:00',1.66),('3355','2014-03-24','14:45:00',1.94),('3355','2014-03-24','14:50:00',2.08),('3355','2014-03-24','14:55:00',1.83),('3355','2014-03-24','15:00:00',1.62),('3355','2014-03-24','15:05:00',1.44),('3355','2014-03-24','15:10:00',1.27),('3355','2014-03-24','15:30:00',1.05),('3355','2014-03-24','16:00:00',1.72),('3355','2014-03-23','09:10:00',1.37),('3355','2014-03-23','09:15:00',1.39),('3355','2014-03-23','11:40:00',1.53),('3355','2014-03-23','13:45:00',1.17),('3355','2014-03-23','13:50:00',1.11),('3355','2014-03-23','15:15:00',1.08),('3355','2014-03-23','15:25:00',1.06),('3355','2014-03-22','08:45:00',1.23),('3355','2014-03-22','09:00:00',1.12),('3355','2014-03-22','09:30:00',1.18),('3355','2014-03-22','09:45:00',1.63),('3355','2014-03-22','09:50:00',1.66),('3355','2014-03-22','09:55:00',1.71),('3355','2014-03-22','10:00:00',1.75),('3355','2014-03-22','10:05:00',1.81),('3355','2014-03-22','10:10:00',2.07),('3355','2014-03-22','10:15:00',1.09),('3355','2014-03-22','10:40:00',1.18),('3355','2014-03-22','10:45:00',1.53),('3355','2014-03-22','10:50:00',1.88),('3355','2014-03-22','11:20:00',1.41),('3355','2014-03-22','11:25:00',2.15),('3355','2014-03-22','11:30:00',1.75),('3355','2014-03-22','11:40:00',1.22),('3355','2014-03-22','11:45:00',1.16),('3355','2014-03-22','11:50:00',1.23),('3355','2014-03-22','11:55:00',1.64),('3355','2014-03-22','12:00:00',1.52),('3355','2014-03-22','12:05:00',1.11),('3355','2014-03-22','12:15:00',1.63),('3355','2014-03-22','12:20:00',2.56),('3355','2014-03-22','12:25:00',1.95),('3355','2014-03-22','12:35:00',1.4),('3355','2014-03-22','12:40:00',1.23),('3355','2014-03-22','12:45:00',1.71),('3355','2014-03-22','12:50:00',2.07),('3355','2014-03-22','12:55:00',1.32),('3355','2014-03-22','13:00:00',1.61),('3355','2014-03-22','13:05:00',1.01),('3355','2014-03-22','13:10:00',2.07),('3355','2014-03-22','13:15:00',1.96),('3355','2014-03-22','13:20:00',1.95),('3355','2014-03-22','13:25:00',1.53),('3355','2014-03-22','13:30:00',1.76),('3355','2014-03-22','13:35:00',1.84),('3355','2014-03-22','13:40:00',1.83),('3355','2014-03-22','13:45:00',1.99),('3355','2014-03-22','13:50:00',1.04),('3355','2014-03-22','14:00:00',2.18),('3355','2014-03-22','14:05:00',1.49),('3355','2014-03-22','14:10:00',2.12),('3355','2014-03-22','14:15:00',1.94),('3355','2014-03-22','14:20:00',1.96),('3355','2014-03-22','14:25:00',1.9),('3355','2014-03-22','14:30:00',1.86),('3355','2014-03-22','14:35:00',1.85),('3355','2014-03-22','14:40:00',1.81),('3355','2014-03-22','14:45:00',1.78),('3355','2014-03-22','14:50:00',1.76),('3355','2014-03-22','14:55:00',1.72),('3355','2014-03-22','15:00:00',1.67),('3355','2014-03-22','15:05:00',1.66),('3355','2014-03-22','15:10:00',1.6),('3355','2014-03-22','15:15:00',1.53),('3355','2014-03-22','15:20:00',1.55),('3355','2014-03-22','15:25:00',1.31),('3355','2014-03-22','15:40:00',1.04),('3355','2014-03-22','15:50:00',1.42),('3355','2014-03-22','15:55:00',1.58),('3355','2014-03-22','16:00:00',1.23),('3355','2014-03-22','16:05:00',1.24),('3355','2014-03-22','16:10:00',1.17),('3355','2014-03-21','08:35:00',1.03),('3355','2014-03-21','08:40:00',1.08),('3355','2014-03-21','08:45:00',1.12),('3355','2014-03-21','08:50:00',1.17),('3355','2014-03-21','08:55:00',1.23),('3355','2014-03-21','09:00:00',1.28),('3355','2014-03-21','09:05:00',1.3),('3355','2014-03-21','09:10:00',1.36),('3355','2014-03-21','09:15:00',1.41),('3355','2014-03-21','09:20:00',1.47),('3355','2014-03-21','09:25:00',1.42),('3355','2014-03-21','09:30:00',1.51),('3355','2014-03-21','09:35:00',1.54),('3355','2014-03-21','09:40:00',1.58),('3355','2014-03-21','09:45:00',1.62),('3355','2014-03-21','09:50:00',1.66),('3355','2014-03-21','09:55:00',1.69),('3355','2014-03-21','10:00:00',1.7),('3355','2014-03-21','10:05:00',1.72),('3355','2014-03-21','10:10:00',1.75),('3355','2014-03-21','10:15:00',1.79),('3355','2014-03-21','10:20:00',1.8),('3355','2014-03-21','10:25:00',1.83),('3355','2014-03-21','10:30:00',1.89),('3355','2014-03-21','10:35:00',1.88),('3355','2014-03-21','10:40:00',1.92),('3355','2014-03-21','10:45:00',1.91),('3355','2014-03-21','10:50:00',1.91),('3355','2014-03-21','10:55:00',1.95),('3355','2014-03-21','11:00:00',1.99),('3355','2014-03-21','11:05:00',1.96),('3355','2014-03-21','11:10:00',1.94),('3355','2014-03-21','11:15:00',1.93),('3355','2014-03-21','11:20:00',1.92),('3355','2014-03-21','11:25:00',1.81),('3355','2014-03-21','11:30:00',1.12),('3355','2014-03-21','11:35:00',1.4),('3355','2014-03-21','11:50:00',1.74),('3355','2014-03-21','11:55:00',2.25),('3355','2014-03-21','12:00:00',1.58),('3355','2014-03-21','12:05:00',2.07),('3355','2014-03-21','12:10:00',2.14),('3355','2014-03-21','12:15:00',2.25),('3355','2014-03-21','12:20:00',2.22),('3355','2014-03-21','12:25:00',2.14),('3355','2014-03-21','12:30:00',2.12),('3355','2014-03-21','12:35:00',2.13),('3355','2014-03-21','12:40:00',2.13),('3355','2014-03-21','12:45:00',2.14),('3355','2014-03-21','12:50:00',2.12),('3355','2014-03-21','12:55:00',2.14),('3355','2014-03-21','13:00:00',2.11),('3355','2014-03-21','13:05:00',2.13),('3355','2014-03-21','13:10:00',2.11),('3355','2014-03-21','13:15:00',2.12),('3355','2014-03-21','13:20:00',2.11),('3355','2014-03-21','13:25:00',2.09),('3355','2014-03-21','13:30:00',2.09),('3355','2014-03-21','13:35:00',2.06),('3355','2014-03-21','13:40:00',2.06),('3355','2014-03-21','13:45:00',2.05),('3355','2014-03-21','13:50:00',2.05),('3355','2014-03-21','13:55:00',2.02),('3355','2014-03-21','14:00:00',2.02),('3355','2014-03-21','14:05:00',2.01),('3355','2014-03-21','14:10:00',2),('3355','2014-03-21','14:15:00',1.98),('3355','2014-03-21','14:20:00',1.96),('3355','2014-03-21','14:25:00',1.93),('3355','2014-03-21','14:30:00',1.87),('3355','2014-03-21','14:35:00',1.78),('3355','2014-03-21','14:40:00',1.8),('3355','2014-03-21','14:45:00',1.77),('3355','2014-03-21','14:50:00',1.42),('3355','2014-03-21','15:10:00',1.82),('3355','2014-03-21','15:15:00',1.9),('3355','2014-03-21','15:20:00',1.78),('3355','2014-03-21','15:25:00',1.74),('3355','2014-03-21','15:30:00',1.78),('3355','2014-03-21','15:35:00',1.66),('3355','2014-03-21','15:40:00',1.66),('3355','2014-03-21','15:45:00',1.61),('3355','2014-03-21','15:50:00',1.58),('3355','2014-03-21','15:55:00',1.46),('3355','2014-03-21','16:00:00',1.42),('3355','2014-03-21','16:05:00',1.31),('3355','2014-03-21','16:10:00',1.24),('3355','2014-03-21','16:15:00',1.14),('3355','2014-03-21','16:20:00',1.06),('3355','2014-03-20','08:35:00',1.03),('3355','2014-03-20','08:40:00',1.1),('3355','2014-03-20','08:45:00',1.16),('3355','2014-03-20','08:50:00',1.2),('3355','2014-03-20','08:55:00',1.23),('3355','2014-03-20','09:00:00',1.26),('3355','2014-03-20','09:05:00',1.31),('3355','2014-03-20','09:10:00',1.38),('3355','2014-03-20','09:15:00',1.4),('3355','2014-03-20','09:20:00',1.45),('3355','2014-03-20','09:25:00',1.47),('3355','2014-03-20','09:30:00',1.49),('3355','2014-03-20','09:35:00',1.56),('3355','2014-03-20','09:40:00',1.56),('3355','2014-03-20','09:45:00',1.6),('3355','2014-03-20','09:50:00',1.6),('3355','2014-03-20','09:55:00',1.62),('3355','2014-03-20','10:00:00',1.7),('3355','2014-03-20','10:05:00',1.77),('3355','2014-03-20','10:10:00',1.81),('3355','2014-03-20','10:15:00',1.77),('3355','2014-03-20','10:20:00',1.82),('3355','2014-03-20','10:25:00',1.84),('3355','2014-03-20','10:30:00',1.86),('3355','2014-03-20','10:35:00',1.83),('3355','2014-03-20','10:40:00',1.79),('3355','2014-03-20','10:45:00',1.77),('3355','2014-03-20','10:50:00',1.91),('3355','2014-03-20','10:55:00',2.01),('3355','2014-03-20','11:00:00',2.03),('3355','2014-03-20','11:05:00',2.02),('3355','2014-03-20','11:10:00',2.01),('3355','2014-03-20','11:15:00',1.92),('3355','2014-03-20','11:20:00',1.99),('3355','2014-03-20','11:25:00',2.02),('3355','2014-03-20','11:30:00',2.08),('3355','2014-03-20','11:35:00',2.15),('3355','2014-03-20','11:40:00',2.1),('3355','2014-03-20','11:45:00',2.13),('3355','2014-03-20','11:50:00',2.1),('3355','2014-03-20','11:55:00',2.02),('3355','2014-03-20','12:00:00',1.86),('3355','2014-03-20','12:05:00',2.03),('3355','2014-03-20','12:10:00',2.12),('3355','2014-03-20','12:15:00',2.13),('3355','2014-03-20','12:20:00',2.06),('3355','2014-03-20','12:25:00',1.96),('3355','2014-03-20','12:30:00',2.06),('3355','2014-03-20','12:35:00',2.1),('3355','2014-03-20','12:40:00',2.09),('3355','2014-03-20','12:45:00',2.17),('3355','2014-03-20','12:50:00',2.15),('3355','2014-03-20','12:55:00',2.1),('3355','2014-03-20','13:00:00',2.12),('3355','2014-03-20','13:05:00',2.09),('3355','2014-03-20','13:10:00',2.05),('3355','2014-03-20','13:15:00',2.07),('3355','2014-03-20','13:20:00',2.07),('3355','2014-03-20','13:25:00',2.02),('3355','2014-03-20','13:30:00',2.06),('3355','2014-03-20','13:35:00',2.02),('3355','2014-03-20','13:40:00',1.87),('3355','2014-03-20','13:45:00',1.82),('3355','2014-03-20','13:50:00',1.77),('3355','2014-03-20','13:55:00',1.69),('3355','2014-03-20','14:00:00',1.68),('3355','2014-03-20','14:05:00',1.83),('3355','2014-03-20','14:10:00',1.77),('3355','2014-03-20','14:15:00',1.71),('3355','2014-03-20','14:20:00',1.71),('3355','2014-03-20','14:25:00',1.72),('3355','2014-03-20','14:30:00',1.48),('3355','2014-03-20','14:35:00',1.36),('3355','2014-03-20','14:40:00',1.52),('3355','2014-03-20','14:45:00',1.51),('3355','2014-03-20','14:50:00',1.43),('3355','2014-03-20','14:55:00',1.38),('3355','2014-03-20','15:00:00',1.26),('3355','2014-03-20','15:05:00',1.24),('3355','2014-03-20','15:10:00',1.27),('3355','2014-03-20','15:15:00',1.17),('3355','2014-03-20','15:20:00',1.25),('3355','2014-03-20','15:25:00',1.17),('3355','2014-03-20','15:30:00',1.1),('3355','2014-03-20','15:35:00',1.09),('3355','2014-03-19','09:25:00',1.24),('3355','2014-03-19','09:35:00',1.35),('3355','2014-03-19','09:40:00',1.47),('3355','2014-03-19','09:45:00',1.56),('3355','2014-03-19','09:50:00',1.88),('3355','2014-03-19','09:55:00',1.61),('3355','2014-03-19','10:40:00',1.17),('3355','2014-03-19','10:45:00',1.72),('3355','2014-03-19','10:50:00',1.55),('3355','2014-03-19','11:05:00',1.24),('3355','2014-03-19','11:10:00',2.21),('3355','2014-03-19','11:15:00',1.14),('3355','2014-03-19','11:20:00',1.03),('3355','2014-03-19','11:25:00',1.14),('3355','2014-03-19','11:30:00',1.2),('3355','2014-03-19','11:35:00',1.37),('3355','2014-03-19','11:40:00',1.06),('3355','2014-03-19','11:45:00',1.08),('3355','2014-03-19','12:05:00',1.9),('3355','2014-03-19','12:10:00',2.4),('3355','2014-03-19','12:15:00',2.42),('3355','2014-03-19','12:20:00',2.41),('3355','2014-03-19','12:25:00',2.29),('3355','2014-03-19','12:30:00',2.34),('3355','2014-03-19','12:35:00',2.27),('3355','2014-03-19','12:40:00',2.3),('3355','2014-03-19','12:45:00',2.22),('3355','2014-03-19','12:50:00',2.07),('3355','2014-03-19','12:55:00',1.65),('3355','2014-03-19','13:00:00',1.91),('3355','2014-03-19','13:05:00',1.91),('3355','2014-03-19','13:10:00',2.22),('3355','2014-03-19','13:15:00',2.18),('3355','2014-03-19','13:20:00',1.61),('3355','2014-03-19','13:25:00',1.44),('3355','2014-03-19','13:30:00',2.08),('3355','2014-03-19','13:35:00',2.12),('3355','2014-03-19','13:40:00',2.03),('3355','2014-03-19','13:45:00',2.11),('3355','2014-03-19','13:50:00',2.07),('3355','2014-03-19','13:55:00',2.03),('3355','2014-03-19','14:00:00',1.97),('3355','2014-03-19','14:05:00',1.99),('3355','2014-03-19','14:10:00',1.97),('3355','2014-03-19','14:15:00',1.91),('3355','2014-03-19','14:20:00',1.89),('3355','2014-03-19','14:25:00',1.86),('3355','2014-03-19','14:30:00',1.8),('3355','2014-03-19','14:35:00',1.84),('3355','2014-03-19','14:40:00',1.8),('3355','2014-03-19','14:45:00',1.77),('3355','2014-03-19','14:50:00',1.74),('3355','2014-03-19','14:55:00',1.7),('3355','2014-03-19','15:00:00',1.66),('3355','2014-03-19','15:05:00',1.63),('3355','2014-03-19','15:10:00',1.59),('3355','2014-03-19','15:15:00',1.59),('3355','2014-03-19','15:20:00',1.52),('3355','2014-03-19','15:25:00',1.51),('3355','2014-03-19','15:30:00',1.47),('3355','2014-03-19','15:35:00',1.39),('3355','2014-03-19','15:40:00',1.39),('3355','2014-03-19','15:45:00',1.35),('3355','2014-03-19','15:50:00',1.29),('3355','2014-03-19','15:55:00',1.26),('3355','2014-03-19','16:00:00',1.2),('3355','2014-03-19','16:05:00',1.15),('3355','2014-03-19','16:10:00',1.13),('3355','2014-03-19','16:15:00',1.06),('3355','2014-03-19','16:20:00',1.01),('3355','2014-03-18','08:55:00',1.25),('3355','2014-03-18','09:00:00',1.32),('3355','2014-03-18','09:15:00',1.25),('3355','2014-03-18','09:20:00',1.74),('3355','2014-03-18','09:25:00',1.69),('3355','2014-03-18','09:50:00',1.01),('3355','2014-03-18','09:55:00',1.05),('3355','2014-03-18','10:00:00',1.38),('3355','2014-03-18','10:05:00',1.55),('3355','2014-03-18','10:10:00',1.96),('3355','2014-03-18','10:15:00',1.89),('3355','2014-03-18','10:20:00',1.7),('3355','2014-03-18','10:25:00',2.3),('3355','2014-03-18','10:30:00',1.85),('3355','2014-03-18','10:35:00',1.79),('3355','2014-03-18','10:40:00',2.36),('3355','2014-03-18','10:45:00',1.61),('3355','2014-03-18','10:50:00',1.91),('3355','2014-03-18','10:55:00',1.17),('3355','2014-03-18','11:00:00',1.99),('3355','2014-03-18','11:05:00',1.72),('3355','2014-03-18','11:10:00',1.67),('3355','2014-03-18','11:30:00',1.13),('3355','2014-03-18','11:35:00',2.16),('3355','2014-03-18','11:40:00',1.66),('3355','2014-03-18','11:45:00',1.33),('3355','2014-03-18','11:50:00',1.16),('3355','2014-03-18','12:15:00',1.02),('3355','2014-03-18','12:20:00',1.39),('3355','2014-03-18','12:25:00',1.33),('3355','2014-03-18','12:35:00',1.84),('3355','2014-03-18','12:40:00',2.1),('3355','2014-03-18','12:45:00',1.41),('3355','2014-03-18','12:50:00',1.59),('3355','2014-03-18','12:55:00',1.74),('3355','2014-03-18','13:00:00',2.16),('3355','2014-03-18','13:05:00',2.32),('3355','2014-03-18','13:10:00',2.23),('3355','2014-03-18','13:15:00',2.2),('3355','2014-03-18','13:20:00',2.18),('3355','2014-03-18','13:25:00',2.12),('3355','2014-03-18','13:30:00',2.04),('3355','2014-03-18','13:35:00',2.07),('3355','2014-03-18','13:40:00',2.09),('3355','2014-03-18','13:45:00',2.09),('3355','2014-03-18','13:50:00',2.04),('3355','2014-03-18','13:55:00',2.04),('3355','2014-03-18','14:00:00',2.03),('3355','2014-03-18','14:05:00',1.99),('3355','2014-03-18','14:10:00',2),('3355','2014-03-18','14:15:00',1.98),('3355','2014-03-18','14:20:00',1.96),('3355','2014-03-18','14:25:00',1.94),('3355','2014-03-18','14:30:00',1.91),('3355','2014-03-18','14:35:00',1.89),('3355','2014-03-18','14:40:00',1.86),('3355','2014-03-18','14:45:00',1.81),('3355','2014-03-18','14:50:00',1.79),('3355','2014-03-18','14:55:00',1.77),('3355','2014-03-18','15:00:00',1.73),('3355','2014-03-18','15:05:00',1.67),('3355','2014-03-18','15:10:00',1.64),('3355','2014-03-18','15:15:00',1.61),('3355','2014-03-18','15:20:00',1.59),('3355','2014-03-18','15:25:00',1.54),('3355','2014-03-18','15:30:00',1.49),('3355','2014-03-18','15:35:00',1.45),('3355','2014-03-18','15:40:00',1.4),('3355','2014-03-18','15:45:00',1.35),('3355','2014-03-18','15:50:00',1.3),('3355','2014-03-18','15:55:00',1.24),('3355','2014-03-18','16:00:00',1.22),('3355','2014-03-18','16:05:00',1.19),('3355','2014-03-18','16:10:00',1.13),('3355','2014-03-18','16:15:00',1.08),('3355','2014-03-18','16:20:00',1.03),('3355','2014-05-01','08:45:00',1.03),('3355','2014-05-01','08:50:00',1.11),('3355','2014-05-01','08:55:00',1.3),('3355','2014-05-01','09:25:00',1.05),('3355','2014-05-01','09:30:00',1.5),('3355','2014-05-01','09:35:00',1.57),('3355','2014-05-01','09:40:00',1.47),('3355','2014-05-01','10:05:00',1.43),('3355','2014-05-01','10:10:00',2.29),('3355','2014-05-01','10:15:00',1.41),('3355','2014-05-01','10:20:00',1.44),('3355','2014-05-01','10:25:00',2.04),('3355','2014-05-01','10:30:00',1.71),('3355','2014-05-01','10:40:00',1.14),('3355','2014-05-01','10:45:00',1.18),('3355','2014-05-01','10:50:00',2.27),('3355','2014-05-01','10:55:00',2.35),('3355','2014-05-01','11:00:00',2.49),('3355','2014-05-01','11:05:00',1.97),('3355','2014-05-01','11:10:00',1.25),('3355','2014-05-01','11:15:00',1.21),('3355','2014-05-01','11:20:00',1.79),('3355','2014-05-01','11:25:00',2.53),('3355','2014-05-01','11:30:00',1.72),('3355','2014-05-01','11:35:00',2.31),('3355','2014-05-01','11:40:00',2.48),('3355','2014-05-01','11:45:00',2.32),('3355','2014-05-01','11:50:00',2.05),('3355','2014-05-01','11:55:00',2.19),('3355','2014-05-01','12:00:00',2.54),('3355','2014-05-01','12:05:00',2.58),('3355','2014-05-01','12:10:00',2.49),('3355','2014-05-01','12:15:00',2.34),('3355','2014-05-01','12:20:00',1.88),('3355','2014-05-01','12:30:00',1.35),('3355','2014-05-01','12:35:00',2.72),('3355','2014-05-01','12:40:00',2.67),('3355','2014-05-01','12:45:00',2.59),('3355','2014-05-01','12:50:00',2.03),('3355','2014-05-01','13:00:00',2.6),('3355','2014-05-01','13:05:00',2.61),('3355','2014-05-01','13:10:00',2.62),('3355','2014-05-01','13:15:00',2.54),('3355','2014-05-01','13:20:00',2.56),('3355','2014-05-01','13:25:00',2.03),('3355','2014-05-01','13:30:00',1.43),('3355','2014-05-01','13:35:00',2.73),('3355','2014-05-01','13:40:00',2.39),('3355','2014-05-01','13:45:00',2.7),('3355','2014-05-01','13:50:00',2.75),('3355','2014-05-01','13:55:00',2.23),('3355','2014-05-01','14:00:00',1.12),('3355','2014-05-01','14:05:00',2.7),('3355','2014-05-01','14:10:00',2.56),('3355','2014-05-01','14:15:00',2.58),('3355','2014-05-01','14:20:00',2.51),('3355','2014-05-01','14:25:00',2.58),('3355','2014-05-01','14:30:00',2.43),('3355','2014-05-01','14:35:00',2.27),('3355','2014-05-01','14:40:00',2.43),('3355','2014-05-01','14:45:00',2.54),('3355','2014-05-01','14:50:00',2.47),('3355','2014-05-01','14:55:00',2.44),('3355','2014-05-01','15:00:00',2.51),('3355','2014-05-01','15:05:00',2.42),('3355','2014-05-01','15:10:00',1.29),('3355','2014-05-01','15:15:00',2.19),('3355','2014-05-01','15:20:00',2.28),('3355','2014-05-01','15:25:00',2.25),('3355','2014-05-01','15:30:00',2.17),('3355','2014-05-01','15:35:00',2.15),('3355','2014-05-01','15:40:00',2.11),('3355','2014-05-01','15:45:00',2.09),('3355','2014-05-01','15:50:00',2.03),('3355','2014-05-01','15:55:00',2.01),('3355','2014-05-01','16:00:00',1.99),('3355','2014-05-01','16:05:00',2),('3355','2014-05-01','16:10:00',1.89),('3355','2014-05-01','16:15:00',1.88),('3355','2014-05-01','16:20:00',1.82),('3355','2014-05-01','16:25:00',1.64),('3355','2014-05-01','16:30:00',1.71),('3355','2014-05-01','16:35:00',1.73),('3355','2014-05-01','16:40:00',1.65),('3355','2014-05-01','16:45:00',1.4),('3355','2014-05-01','16:50:00',1.34),('3355','2014-05-01','16:55:00',1.34),('3355','2014-05-01','17:00:00',1.35),('3355','2014-05-01','17:05:00',1.38),('3355','2014-05-01','17:10:00',1.47),('3355','2014-05-01','17:15:00',1.39),('3355','2014-05-01','17:20:00',1.34),('3355','2014-05-01','17:25:00',1.28),('3355','2014-05-01','17:30:00',1.23),('3355','2014-05-01','17:35:00',1.19),('3355','2014-05-01','17:40:00',1.13),('3355','2014-05-01','17:45:00',1.08),('3355','2014-05-01','17:50:00',1.03),('3355','2014-03-17','09:55:00',1),('3355','2014-03-17','10:00:00',1.04),('3355','2014-03-17','10:10:00',1),('3355','2014-03-17','10:20:00',1.12),('3355','2014-03-17','11:50:00',1.02),('3355','2014-03-17','12:05:00',1.49),('3355','2014-03-17','12:15:00',1.17),('3355','2014-03-17','12:25:00',1.84),('3355','2014-03-17','12:30:00',1.08),('3355','2014-03-17','12:35:00',1.3),('3355','2014-03-17','12:40:00',1.21),('3355','2014-03-17','12:45:00',1.39),('3355','2014-03-17','12:55:00',1.98),('3355','2014-03-17','13:00:00',2.3),('3355','2014-03-17','13:05:00',1.9),('3355','2014-03-17','13:10:00',1.77),('3355','2014-03-17','13:15:00',2.19),('3355','2014-03-17','13:20:00',2.2),('3355','2014-03-17','13:25:00',2.2),('3355','2014-03-17','13:30:00',1.47),('3355','2014-03-17','13:35:00',1.82),('3355','2014-03-17','13:40:00',2.13),('3355','2014-03-17','13:45:00',2.17),('3355','2014-03-17','13:50:00',1.79),('3355','2014-03-17','13:55:00',1.72),('3355','2014-03-17','14:00:00',1.68),('3355','2014-03-17','14:05:00',1.37),('3355','2014-03-17','14:10:00',1.34),('3355','2014-03-17','14:20:00',1.22),('3355','2014-03-17','14:25:00',1.08),('3355','2014-03-17','14:30:00',1.53),('3355','2014-03-17','14:35:00',1.93),('3355','2014-03-17','14:40:00',1.58),('3355','2014-03-17','14:45:00',1.71),('3355','2014-03-17','14:50:00',1.81),('3355','2014-03-17','14:55:00',1.76),('3355','2014-03-17','15:00:00',1.72),('3355','2014-03-17','15:05:00',1.62),('3355','2014-03-17','15:10:00',1.6),('3355','2014-03-17','15:15:00',1.6),('3355','2014-03-17','15:25:00',1.32),('3355','2014-03-17','15:30:00',1.44),('3355','2014-03-17','15:35:00',1.38),('3355','2014-03-17','15:40:00',1.3),('3355','2014-03-17','15:45:00',1.11),('3355','2014-03-17','15:50:00',1.25),('3355','2014-03-17','15:55:00',1.16),('3355','2014-03-17','16:00:00',1.16),('3355','2014-03-17','16:05:00',1.09),('3355','2014-03-16','08:50:00',1.03),('3355','2014-03-16','08:55:00',1.04),('3355','2014-03-16','09:00:00',1.05),('3355','2014-03-16','09:05:00',1.1),('3355','2014-03-16','09:10:00',1.17),('3355','2014-03-16','09:15:00',1.27),('3355','2014-03-16','09:20:00',1.29),('3355','2014-03-16','09:25:00',1.29),('3355','2014-03-16','09:30:00',1.32),('3355','2014-03-16','09:35:00',1.32),('3355','2014-03-16','09:40:00',1.34),('3355','2014-03-16','09:45:00',1.43),('3355','2014-03-16','09:50:00',1.54),('3355','2014-03-16','09:55:00',1.56),('3355','2014-03-16','10:00:00',1.59),('3355','2014-03-16','10:05:00',1.59),('3355','2014-03-16','10:10:00',1.64),('3355','2014-03-16','10:15:00',1.68),('3355','2014-03-16','10:20:00',1.65),('3355','2014-03-16','10:25:00',1.66),('3355','2014-03-16','10:30:00',1.72),('3355','2014-03-16','10:35:00',1.77),('3355','2014-03-16','10:40:00',1.82),('3355','2014-03-16','10:45:00',1.84),('3355','2014-03-16','10:50:00',1.84),('3355','2014-03-16','10:55:00',1.85),('3355','2014-03-16','11:00:00',1.79),('3355','2014-03-16','11:05:00',1.75),('3355','2014-03-16','11:10:00',1.81),('3355','2014-03-16','11:15:00',1.86),('3355','2014-03-16','11:20:00',1.94),('3355','2014-03-16','11:25:00',1.98),('3355','2014-03-16','11:30:00',2),('3355','2014-03-16','11:35:00',2.03),('3355','2014-03-16','11:40:00',2.03),('3355','2014-03-16','11:45:00',2.01),('3355','2014-03-16','11:50:00',2.02),('3355','2014-03-16','11:55:00',2),('3355','2014-03-16','12:00:00',2.02),('3355','2014-03-16','12:05:00',1.99),('3355','2014-03-16','12:10:00',2.01),('3355','2014-03-16','12:15:00',1.99),('3355','2014-03-16','12:20:00',2.02),('3355','2014-03-16','12:25:00',1.99),('3355','2014-03-16','12:30:00',2),('3355','2014-03-16','12:35:00',2.01),('3355','2014-03-16','12:40:00',2.03),('3355','2014-03-16','12:45:00',2.03),('3355','2014-03-16','12:50:00',1.99),('3355','2014-03-16','12:55:00',1.96),('3355','2014-03-16','13:00:00',1.94),('3355','2014-03-16','13:05:00',1.97),('3355','2014-03-16','13:10:00',1.96),('3355','2014-03-16','13:15:00',1.97),('3355','2014-03-16','13:20:00',1.92),('3355','2014-03-16','13:25:00',1.95),('3355','2014-03-16','13:30:00',1.95),('3355','2014-03-16','13:35:00',1.9),('3355','2014-03-16','13:40:00',1.96),('3355','2014-03-16','13:45:00',1.91),('3355','2014-03-16','13:50:00',1.87),('3355','2014-03-16','13:55:00',1.91),('3355','2014-03-16','14:00:00',1.88),('3355','2014-03-16','14:05:00',1.85),('3355','2014-03-16','14:10:00',1.81),('3355','2014-03-16','14:15:00',1.78),('3355','2014-03-16','14:20:00',1.79),('3355','2014-03-16','14:25:00',1.76),('3355','2014-03-16','14:30:00',1.75),('3355','2014-03-16','14:35:00',1.7),('3355','2014-03-16','14:40:00',1.68),('3355','2014-03-16','14:45:00',1.62),('3355','2014-03-16','14:50:00',1.52),('3355','2014-03-16','14:55:00',1.52),('3355','2014-03-16','15:00:00',1.62),('3355','2014-03-16','15:05:00',1.51),('3355','2014-03-16','15:10:00',1.4),('3355','2014-03-16','15:15:00',1.29),('3355','2014-03-16','15:20:00',1.12),('3355','2014-03-16','15:25:00',1.24),('3355','2014-03-16','15:30:00',1.19),('3355','2014-03-16','15:35:00',1.06),('3355','2014-03-15','08:55:00',1.03),('3355','2014-03-15','09:00:00',1.07),('3355','2014-03-15','09:05:00',1.11),('3355','2014-03-15','09:10:00',1.16),('3355','2014-03-15','09:15:00',1.21),('3355','2014-03-15','09:20:00',1.26),('3355','2014-03-15','09:25:00',1.29),('3355','2014-03-15','09:30:00',1.33),('3355','2014-03-15','09:35:00',1.36),('3355','2014-03-15','09:40:00',1.4),('3355','2014-03-15','09:45:00',1.43),('3355','2014-03-15','09:50:00',1.44),('3355','2014-03-15','09:55:00',1.48),('3355','2014-03-15','10:00:00',1.52),('3355','2014-03-15','10:05:00',1.54),('3355','2014-03-15','10:10:00',1.57),('3355','2014-03-15','10:15:00',1.59),('3355','2014-03-15','10:20:00',1.6),('3355','2014-03-15','10:25:00',1.64),('3355','2014-03-15','10:30:00',1.68),('3355','2014-03-15','10:35:00',1.69),('3355','2014-03-15','10:40:00',1.72),('3355','2014-03-15','10:45:00',1.77),('3355','2014-03-15','10:50:00',1.82),('3355','2014-03-15','10:55:00',1.78),('3355','2014-03-15','11:00:00',1.78),('3355','2014-03-15','11:05:00',1.8),('3355','2014-03-15','11:10:00',1.84),('3355','2014-03-15','11:15:00',1.83),('3355','2014-03-15','11:20:00',1.89),('3355','2014-03-15','11:25:00',1.92),('3355','2014-03-15','11:30:00',1.97),('3355','2014-03-15','11:35:00',1.96),('3355','2014-03-15','11:40:00',1.99),('3355','2014-03-15','11:45:00',1.98),('3355','2014-03-15','11:50:00',2),('3355','2014-03-15','11:55:00',1.98),('3355','2014-03-15','12:00:00',2),('3355','2014-03-15','12:05:00',2),('3355','2014-03-15','12:10:00',1.98),('3355','2014-03-15','12:15:00',2.01),('3355','2014-03-15','12:20:00',2.04),('3355','2014-03-15','12:25:00',2.03),('3355','2014-03-15','12:30:00',2.04),('3355','2014-03-15','12:35:00',2.08),('3355','2014-03-15','12:40:00',2.08),('3355','2014-03-15','12:45:00',2.08),('3355','2014-03-15','12:50:00',2.08),('3355','2014-03-15','12:55:00',2.07),('3355','2014-03-15','13:00:00',2.04),('3355','2014-03-15','13:05:00',2.07),('3355','2014-03-15','13:10:00',2.07),('3355','2014-03-15','13:15:00',2.05),('3355','2014-03-15','13:20:00',2.04),('3355','2014-03-15','13:25:00',2.02),('3355','2014-03-15','13:30:00',2.01),('3355','2014-03-15','13:35:00',2.03),('3355','2014-03-15','13:40:00',2),('3355','2014-03-15','13:45:00',2),('3355','2014-03-15','13:50:00',1.98),('3355','2014-03-15','13:55:00',1.98),('3355','2014-03-15','14:00:00',1.97),('3355','2014-03-15','14:05:00',1.96),('3355','2014-03-15','14:10:00',1.93),('3355','2014-03-15','14:15:00',1.9),('3355','2014-03-15','14:20:00',1.87),('3355','2014-03-15','14:25:00',1.85),('3355','2014-03-15','14:30:00',1.82),('3355','2014-03-15','14:35:00',1.79),('3355','2014-03-15','14:40:00',1.75),('3355','2014-03-15','14:45:00',1.71),('3355','2014-03-15','14:50:00',1.68),('3355','2014-03-15','14:55:00',1.65),('3355','2014-03-15','15:00:00',1.62),('3355','2014-03-15','15:05:00',1.6),('3355','2014-03-15','15:10:00',1.55),('3355','2014-03-15','15:15:00',1.52),('3355','2014-03-15','15:20:00',1.47),('3355','2014-03-15','15:25:00',1.42),('3355','2014-03-15','15:30:00',1.38),('3355','2014-03-15','15:35:00',1.34),('3355','2014-03-15','15:40:00',1.28),('3355','2014-03-15','15:45:00',1.24),('3355','2014-03-15','15:50:00',1.19),('3355','2014-03-15','15:55:00',1.14),('3355','2014-03-15','16:00:00',1.09),('3355','2014-03-14','09:35:00',1.01),('3355','2014-03-14','09:40:00',1.26),('3355','2014-03-14','09:45:00',1.46),('3355','2014-03-14','09:50:00',1.71),('3355','2014-03-14','09:55:00',1.77),('3355','2014-03-14','10:00:00',1.89),('3355','2014-03-14','10:05:00',1.88),('3355','2014-03-14','10:10:00',1.84),('3355','2014-03-14','10:15:00',1.81),('3355','2014-03-14','10:20:00',1.76),('3355','2014-03-14','10:25:00',1.75),('3355','2014-03-14','10:30:00',1.69),('3355','2014-03-14','10:35:00',1.8),('3355','2014-03-14','10:40:00',1.84),('3355','2014-03-14','10:45:00',1.68),('3355','2014-03-14','10:50:00',1.01),('3355','2014-03-14','10:55:00',1.47),('3355','2014-03-14','11:00:00',1.82),('3355','2014-03-14','11:05:00',1.89),('3355','2014-03-14','11:10:00',2.05),('3355','2014-03-14','11:15:00',2.07),('3355','2014-03-14','11:20:00',2.01),('3355','2014-03-14','11:25:00',1.97),('3355','2014-03-14','11:30:00',1.99),('3355','2014-03-14','11:35:00',2.03),('3355','2014-03-14','11:40:00',2.04),('3355','2014-03-14','11:45:00',2.07),('3355','2014-03-14','11:50:00',2.09),('3355','2014-03-14','11:55:00',2.1),('3355','2014-03-14','12:00:00',2.12),('3355','2014-03-14','12:05:00',2.13),('3355','2014-03-14','12:10:00',2.02),('3355','2014-03-14','12:15:00',1.91),('3355','2014-03-14','12:20:00',1.59),('3355','2014-03-14','12:25:00',1.35),('3355','2014-03-14','12:30:00',1.25),('3355','2014-03-14','12:35:00',1.08),('3355','2014-03-14','12:40:00',1.3),('3355','2014-03-14','12:45:00',1.45),('3355','2014-03-14','12:50:00',1.74),('3355','2014-03-14','12:55:00',1.69),('3355','2014-03-14','13:00:00',1.23),('3355','2014-03-14','13:05:00',1.09),('3355','2014-03-14','13:10:00',1.32),('3355','2014-03-14','13:15:00',1.59),('3355','2014-03-14','13:20:00',1.59),('3355','2014-03-14','13:25:00',1.48),('3355','2014-03-14','13:30:00',1.36),('3355','2014-03-14','13:35:00',1.24),('3355','2014-03-14','13:40:00',1.12),('3355','2014-03-14','13:45:00',1.15),('3355','2014-03-14','13:50:00',1.07),('3355','2014-03-14','13:55:00',1.14),('3355','2014-03-14','14:00:00',1.33),('3355','2014-03-14','14:05:00',1.49),('3355','2014-03-14','14:10:00',1.49),('3355','2014-03-14','14:15:00',1.56),('3355','2014-03-14','14:20:00',1.63),('3355','2014-03-14','14:25:00',1.61),('3355','2014-03-14','14:30:00',1.5),('3355','2014-03-14','14:35:00',1.38),('3355','2014-03-14','14:40:00',1.15),('3355','2014-03-13','08:35:00',1.02),('3355','2014-03-13','08:40:00',1.07),('3355','2014-03-13','08:45:00',1.12),('3355','2014-03-13','08:50:00',1.17),('3355','2014-03-13','08:55:00',1.22),('3355','2014-03-13','09:00:00',1.27),('3355','2014-03-13','09:05:00',1.32),('3355','2014-03-13','09:10:00',1.36),('3355','2014-03-13','09:15:00',1.4),('3355','2014-03-13','09:20:00',1.44),('3355','2014-03-13','09:25:00',1.48),('3355','2014-03-13','09:30:00',1.52),('3355','2014-03-13','09:35:00',1.57),('3355','2014-03-13','09:40:00',1.61),('3355','2014-03-13','09:45:00',1.65),('3355','2014-03-13','09:50:00',1.69),('3355','2014-03-13','09:55:00',1.73),('3355','2014-03-13','10:00:00',1.76),('3355','2014-03-13','10:05:00',1.79),('3355','2014-03-13','10:10:00',1.82),('3355','2014-03-13','10:15:00',1.85),('3355','2014-03-13','10:20:00',1.87),('3355','2014-03-13','10:25:00',1.89),('3355','2014-03-13','10:30:00',1.92),('3355','2014-03-13','10:35:00',1.93),('3355','2014-03-13','10:40:00',1.95),('3355','2014-03-13','10:45:00',1.97),('3355','2014-03-13','10:50:00',1.99),('3355','2014-03-13','10:55:00',2.01),('3355','2014-03-13','11:00:00',2.02),('3355','2014-03-13','11:05:00',2.04),('3355','2014-03-13','11:10:00',2.06),('3355','2014-03-13','11:15:00',2.07),('3355','2014-03-13','11:20:00',2.09),('3355','2014-03-13','11:25:00',2.1),('3355','2014-03-13','11:30:00',2.11),('3355','2014-03-13','11:35:00',2.11),('3355','2014-03-13','11:40:00',2.12),('3355','2014-03-13','11:45:00',2.15),('3355','2014-03-13','11:50:00',2.15),('3355','2014-03-13','11:55:00',2.17),('3355','2014-03-13','12:00:00',2.15),('3355','2014-03-13','12:05:00',2.14),('3355','2014-03-13','12:10:00',2.14),('3355','2014-03-13','12:15:00',2.13),('3355','2014-03-13','12:20:00',2.14),('3355','2014-03-13','12:25:00',2.15),('3355','2014-03-13','12:30:00',2.16),('3355','2014-03-13','12:35:00',2.15),('3355','2014-03-13','12:40:00',2.13),('3355','2014-03-13','12:45:00',2.13),('3355','2014-03-13','12:50:00',2.12),('3355','2014-03-13','12:55:00',2.11),('3355','2014-03-13','13:00:00',2.1),('3355','2014-03-13','13:05:00',2.09),('3355','2014-03-13','13:10:00',2.08),('3355','2014-03-13','13:15:00',2.04),('3355','2014-03-13','13:20:00',2.07),('3355','2014-03-13','13:25:00',2.07),('3355','2014-03-13','13:30:00',2.08),('3355','2014-03-13','13:35:00',2.07),('3355','2014-03-13','13:40:00',2.04),('3355','2014-03-13','13:45:00',2.01),('3355','2014-03-13','13:50:00',1.99),('3355','2014-03-13','13:55:00',1.96),('3355','2014-03-13','14:00:00',1.94),('3355','2014-03-13','14:05:00',1.93),('3355','2014-03-13','14:10:00',1.92),('3355','2014-03-13','14:15:00',1.9),('3355','2014-03-13','14:20:00',1.87),('3355','2014-03-13','14:25:00',1.84),('3355','2014-03-13','14:30:00',1.81),('3355','2014-03-13','14:35:00',1.79),('3355','2014-03-13','14:40:00',1.77),('3355','2014-03-13','14:45:00',1.73),('3355','2014-03-13','14:50:00',1.7),('3355','2014-03-13','14:55:00',1.67),('3355','2014-03-13','15:00:00',1.63),('3355','2014-03-13','15:05:00',1.6),('3355','2014-03-13','15:10:00',1.56),('3355','2014-03-13','15:15:00',1.53),('3355','2014-03-13','15:20:00',1.48),('3355','2014-03-13','15:25:00',1.44),('3355','2014-03-13','15:30:00',1.41),('3355','2014-03-13','15:35:00',1.36),('3355','2014-03-13','15:40:00',1.31),('3355','2014-03-13','15:45:00',1.28),('3355','2014-03-13','15:50:00',1.23),('3355','2014-03-13','15:55:00',1.18),('3355','2014-03-13','16:00:00',1.13),('3355','2014-03-13','16:05:00',1.07),('3355','2014-03-13','16:10:00',1.02),('3355','2014-03-12','08:35:00',1),('3355','2014-03-12','08:40:00',1.06),('3355','2014-03-12','08:45:00',1.11),('3355','2014-03-12','08:50:00',1.16),('3355','2014-03-12','08:55:00',1.21),('3355','2014-03-12','09:00:00',1.25),('3355','2014-03-12','09:05:00',1.29),('3355','2014-03-12','09:10:00',1.34),('3355','2014-03-12','09:15:00',1.39),('3355','2014-03-12','09:20:00',1.43),('3355','2014-03-12','09:25:00',1.47),('3355','2014-03-12','09:30:00',1.51),('3355','2014-03-12','09:35:00',1.55),('3355','2014-03-12','09:40:00',1.58),('3355','2014-03-12','09:45:00',1.62),('3355','2014-03-12','09:50:00',1.66),('3355','2014-03-12','09:55:00',1.7),('3355','2014-03-12','10:00:00',1.74),('3355','2014-03-12','10:05:00',1.78),('3355','2014-03-12','10:10:00',1.81),('3355','2014-03-12','10:15:00',1.83),('3355','2014-03-12','10:20:00',1.86),('3355','2014-03-12','10:25:00',1.89),('3355','2014-03-12','10:30:00',1.91),('3355','2014-03-12','10:35:00',1.94),('3355','2014-03-12','10:40:00',1.97),('3355','2014-03-12','10:45:00',2),('3355','2014-03-12','10:50:00',2.02),('3355','2014-03-12','10:55:00',2.04),('3355','2014-03-12','11:00:00',2.06),('3355','2014-03-12','11:05:00',2.09),('3355','2014-03-12','11:10:00',2.1),('3355','2014-03-12','11:15:00',2.13),('3355','2014-03-12','11:20:00',2.15),('3355','2014-03-12','11:25:00',2.16),('3355','2014-03-12','11:30:00',2.17),('3355','2014-03-12','11:35:00',2.18),('3355','2014-03-12','11:40:00',2.2),('3355','2014-03-12','11:45:00',2.2),('3355','2014-03-12','11:50:00',2.21),('3355','2014-03-12','11:55:00',2.22),('3355','2014-03-12','12:00:00',2.21),('3355','2014-03-12','12:05:00',2.22),('3355','2014-03-12','12:10:00',2.21),('3355','2014-03-12','12:15:00',2.22),('3355','2014-03-12','12:20:00',2.21),('3355','2014-03-12','12:25:00',2.2),('3355','2014-03-12','12:30:00',2.2),('3355','2014-03-12','12:35:00',2.2),('3355','2014-03-12','12:40:00',2.19),('3355','2014-03-12','12:45:00',2.2),('3355','2014-03-12','12:50:00',2.19),('3355','2014-03-12','12:55:00',2.18),('3355','2014-03-12','13:00:00',2.18),('3355','2014-03-12','13:05:00',2.17),('3355','2014-03-12','13:10:00',2.14),('3355','2014-03-12','13:15:00',2.14),('3355','2014-03-12','13:20:00',2.13),('3355','2014-03-12','13:25:00',2.12),('3355','2014-03-12','13:30:00',2.09),('3355','2014-03-12','13:35:00',2.09),('3355','2014-03-12','13:40:00',2.07),('3355','2014-03-12','13:45:00',2.05),('3355','2014-03-12','13:50:00',2.04),('3355','2014-03-12','13:55:00',2.03),('3355','2014-03-12','14:00:00',2.02),('3355','2014-03-12','14:05:00',2.01),('3355','2014-03-12','14:10:00',1.96),('3355','2014-03-12','14:15:00',1.95),('3355','2014-03-12','14:20:00',1.91),('3355','2014-03-12','14:25:00',1.9),('3355','2014-03-12','14:30:00',1.87),('3355','2014-03-12','14:35:00',1.81),('3355','2014-03-12','14:40:00',1.76),('3355','2014-03-12','14:45:00',1.72),('3355','2014-03-12','14:50:00',1.7),('3355','2014-03-12','14:55:00',1.62),('3355','2014-03-12','15:00:00',1.6),('3355','2014-03-12','15:05:00',1.58),('3355','2014-03-12','15:10:00',1.54),('3355','2014-03-12','15:15:00',1.49),('3355','2014-03-12','15:20:00',1.47),('3355','2014-03-12','15:25:00',1.43),('3355','2014-03-12','15:30:00',1.37),('3355','2014-03-12','15:35:00',1.32),('3355','2014-03-12','15:40:00',1.29),('3355','2014-03-12','15:45:00',1.25),('3355','2014-03-12','15:50:00',1.22),('3355','2014-03-12','15:55:00',1.19),('3355','2014-03-12','16:00:00',1.15),('3355','2014-03-12','16:05:00',1.07),('3355','2014-03-12','16:10:00',1.02),('3355','2014-03-11','13:55:00',1.03),('3355','2014-03-11','14:00:00',1.05),('3355','2014-03-11','14:05:00',1.14),('3355','2014-03-11','14:10:00',1.51),('3355','2014-03-11','14:15:00',1.37),('3355','2014-03-11','14:20:00',1.13),('3355','2014-03-11','14:25:00',1.06),('3355','2014-03-11','15:10:00',1.06),('3355','2014-03-10','14:10:00',1.02),('3355','2014-03-10','14:15:00',1.5),('3355','2014-03-10','14:35:00',1.37),('3355','2014-03-10','14:40:00',1.68),('3355','2014-03-10','14:45:00',1.05),('3355','2014-03-10','14:50:00',1.25),('3355','2014-03-10','15:20:00',1.42),('3355','2014-03-10','15:25:00',1.25),('3355','2014-03-09','09:20:00',1.45),('3355','2014-03-09','09:25:00',1.53),('3355','2014-03-09','09:35:00',1.24),('3355','2014-03-09','09:40:00',1.72),('3355','2014-03-09','09:45:00',1.75),('3355','2014-03-09','09:50:00',1.77),('3355','2014-03-09','09:55:00',1.77),('3355','2014-03-09','10:00:00',1.79),('3355','2014-03-09','10:05:00',1.83),('3355','2014-03-09','10:10:00',1.89),('3355','2014-03-09','10:15:00',1.89),('3355','2014-03-09','10:20:00',1.89),('3355','2014-03-09','10:25:00',1.76),('3355','2014-03-09','10:30:00',1.98),('3355','2014-03-09','10:35:00',2),('3355','2014-03-09','10:40:00',2.02),('3355','2014-03-09','10:45:00',2.04),('3355','2014-03-09','10:50:00',2.08),('3355','2014-03-09','10:55:00',2.15),('3355','2014-03-09','11:00:00',2.08),('3355','2014-03-09','11:05:00',2.34),('3355','2014-03-09','11:10:00',2.16),('3355','2014-03-09','11:15:00',2.47),('3355','2014-03-09','11:20:00',2.39),('3355','2014-03-09','11:25:00',2.34),('3355','2014-03-09','11:30:00',1.42),('3355','2014-03-09','11:35:00',2.2),('3355','2014-03-09','11:40:00',1.31),('3355','2014-03-09','11:45:00',1.34),('3355','2014-03-09','11:50:00',1.81),('3355','2014-03-09','11:55:00',2.46),('3355','2014-03-09','12:00:00',2.28),('3355','2014-03-09','12:05:00',2.59),('3355','2014-03-09','12:10:00',2.55),('3355','2014-03-09','12:15:00',2.51),('3355','2014-03-09','12:20:00',2.48),('3355','2014-03-09','12:25:00',2.45),('3355','2014-03-09','12:30:00',2.46),('3355','2014-03-09','12:35:00',2.52),('3355','2014-03-09','12:40:00',2.45),('3355','2014-03-09','12:45:00',2.42),('3355','2014-03-09','12:50:00',2.43),('3355','2014-03-09','12:55:00',2.43),('3355','2014-03-09','13:00:00',2.46),('3355','2014-03-09','13:05:00',2.46),('3355','2014-03-09','13:10:00',2.45),('3355','2014-03-09','13:15:00',2.3),('3355','2014-03-09','13:20:00',2.25),('3355','2014-03-09','13:25:00',2.29),('3355','2014-03-09','13:30:00',2.26),('3355','2014-03-09','13:35:00',1.53),('3355','2014-03-09','13:55:00',2.11),('3355','2014-03-09','14:00:00',2.22),('3355','2014-03-09','14:05:00',2.12),('3355','2014-03-09','14:10:00',2.09),('3355','2014-03-09','14:15:00',1.89),('3355','2014-03-09','14:20:00',2.11),('3355','2014-03-09','14:40:00',1.8),('3355','2014-03-09','14:45:00',2),('3355','2014-03-09','14:50:00',1.87),('3355','2014-03-09','14:55:00',1.82),('3355','2014-03-09','15:00:00',1.76),('3355','2014-03-09','15:05:00',1.22),('3355','2014-03-09','15:10:00',1.71),('3355','2014-03-09','15:15:00',1.64),('3355','2014-03-09','15:20:00',1.6),('3355','2014-03-09','15:25:00',1.58),('3355','2014-03-09','15:30:00',1.56),('3355','2014-03-09','15:35:00',1.48),('3355','2014-03-09','15:40:00',1.41),('3355','2014-03-09','15:55:00',1.31),('3355','2014-03-09','16:00:00',1.23),('3355','2014-03-09','16:05:00',1.12),('3355','2014-03-08','08:40:00',1.01),('3355','2014-03-08','08:45:00',1.06),('3355','2014-03-08','08:50:00',1.11),('3355','2014-03-08','08:55:00',1.16),('3355','2014-03-08','09:00:00',1.21),('3355','2014-03-08','09:05:00',1.26),('3355','2014-03-08','09:10:00',1.31),('3355','2014-03-08','09:15:00',1.35),('3355','2014-03-08','09:20:00',1.4),('3355','2014-03-08','09:25:00',1.44),('3355','2014-03-08','09:30:00',1.49),('3355','2014-03-08','09:35:00',1.54),('3355','2014-03-08','09:40:00',1.58),('3355','2014-03-08','09:45:00',1.61),('3355','2014-03-08','09:50:00',1.65),('3355','2014-03-08','09:55:00',1.68),('3355','2014-03-08','10:00:00',1.72),('3355','2014-03-08','10:05:00',1.75),('3355','2014-03-08','10:10:00',1.78),('3355','2014-03-08','10:15:00',1.82),('3355','2014-03-08','10:20:00',1.85),('3355','2014-03-08','10:25:00',1.88),('3355','2014-03-08','10:30:00',1.92),('3355','2014-03-08','10:35:00',1.96),('3355','2014-03-08','10:40:00',1.98),('3355','2014-03-08','10:45:00',2),('3355','2014-03-08','10:50:00',2.01),('3355','2014-03-08','10:55:00',2.03),('3355','2014-03-08','11:00:00',2.05),('3355','2014-03-08','11:05:00',2.07),('3355','2014-03-08','11:10:00',2.09),('3355','2014-03-08','11:15:00',2.13),('3355','2014-03-08','11:20:00',2.17),('3355','2014-03-08','11:25:00',2.24),('3355','2014-03-08','11:30:00',2.32),('3355','2014-03-08','11:35:00',1.59),('3355','2014-03-08','11:40:00',1.07),('3355','2014-03-08','11:55:00',2.05),('3355','2014-03-08','12:30:00',1.39),('3355','2014-03-08','12:35:00',2.02),('3355','2014-03-08','12:40:00',1.08),('3355','2014-03-08','12:45:00',1.15),('3355','2014-03-08','12:50:00',1.62),('3355','2014-03-08','12:55:00',2.28),('3355','2014-03-08','13:30:00',1.28),('3355','2014-03-08','13:40:00',1.74),('3355','2014-03-08','13:45:00',1.55),('3355','2014-03-08','15:20:00',1.1),('3355','2014-03-08','15:25:00',1.24),('3355','2014-04-30','08:50:00',1.06),('3355','2014-04-30','08:55:00',1.12),('3355','2014-04-30','09:00:00',1.15),('3355','2014-04-30','09:05:00',1.23),('3355','2014-04-30','09:10:00',1.36),('3355','2014-04-30','09:15:00',1.53),('3355','2014-04-30','09:20:00',1.11),('3355','2014-04-30','09:35:00',1.01),('3355','2014-04-30','09:40:00',1.56),('3355','2014-04-30','09:45:00',1.5),('3355','2014-04-30','09:50:00',1.08),('3355','2014-04-30','09:55:00',1.31),('3355','2014-04-30','10:00:00',1.72),('3355','2014-04-30','10:05:00',1.82),('3355','2014-04-30','10:15:00',1.59),('3355','2014-04-30','10:20:00',1.03),('3355','2014-04-30','10:35:00',1.16),('3355','2014-04-30','10:40:00',1.18),('3355','2014-04-30','10:55:00',1.84),('3355','2014-04-30','11:00:00',2.56),('3355','2014-04-30','11:05:00',1.85),('3355','2014-04-30','11:10:00',1.65),('3355','2014-04-30','11:15:00',1.49),('3355','2014-04-30','11:25:00',1.31),('3355','2014-04-30','11:30:00',1.25),('3355','2014-04-30','11:35:00',1.1),('3355','2014-04-30','11:40:00',1.5),('3355','2014-04-30','11:50:00',1.61),('3355','2014-04-30','11:55:00',1.35),('3355','2014-04-30','12:00:00',2.13),('3355','2014-04-30','12:15:00',1.02),('3355','2014-04-30','12:20:00',1.03),('3355','2014-04-30','12:55:00',2.07),('3355','2014-04-30','13:00:00',2.64),('3355','2014-04-30','13:05:00',1.75),('3355','2014-04-30','13:10:00',1.7),('3355','2014-04-30','13:15:00',1.49),('3355','2014-04-30','13:20:00',1.19),('3355','2014-04-30','13:25:00',1.31),('3355','2014-04-30','13:30:00',1.26),('3355','2014-04-30','13:35:00',1.07),('3355','2014-04-30','13:40:00',1.67),('3355','2014-04-30','13:45:00',1.74),('3355','2014-04-30','13:50:00',1.41),('3355','2014-04-30','13:55:00',2.48),('3355','2014-04-30','14:00:00',1.46),('3355','2014-04-30','14:05:00',1.26),('3355','2014-04-30','14:20:00',1.52),('3355','2014-04-30','14:25:00',1.92),('3355','2014-04-30','14:30:00',2.49),('3355','2014-04-30','14:35:00',2.34),('3355','2014-04-30','14:40:00',1.38),('3355','2014-04-30','15:35:00',1.44),('3355','2014-04-30','15:40:00',1.81),('3355','2014-04-30','15:45:00',2.27),('3355','2014-04-30','15:50:00',2.51),('3355','2014-04-30','15:55:00',1.87),('3355','2014-04-30','16:05:00',1.34),('3355','2014-04-30','16:15:00',1.62),('3355','2014-04-30','16:20:00',1.33),('3355','2014-04-30','16:30:00',1.72),('3355','2014-04-30','16:40:00',1.21),('3355','2014-04-30','16:50:00',1.01),('3355','2014-04-30','16:55:00',1.44),('3355','2014-04-30','17:00:00',1.12),('3355','2014-04-30','17:05:00',1.64),('3355','2014-04-30','17:15:00',1.29),('3355','2014-03-07','11:45:00',1.16),('3355','2014-03-07','11:50:00',1.6),('3355','2014-03-07','11:55:00',2.09),('3355','2014-03-07','12:00:00',2.61),('3355','2014-03-07','12:05:00',2.26),('3355','2014-03-07','12:10:00',2.56),('3355','2014-03-07','12:15:00',2.44),('3355','2014-03-07','12:20:00',2.47),('3355','2014-03-07','12:25:00',2.46),('3355','2014-03-07','12:30:00',2.51),('3355','2014-03-07','12:35:00',2.42),('3355','2014-03-07','12:40:00',1.96),('3355','2014-03-07','12:45:00',2.24),('3355','2014-03-07','12:50:00',1.22),('3355','2014-03-07','13:05:00',1.47),('3355','2014-03-07','13:20:00',1.59),('3355','2014-03-07','13:25:00',1.59),('3355','2014-03-07','13:30:00',1.01),('3355','2014-03-07','13:35:00',1.79),('3355','2014-03-07','13:40:00',1.83),('3355','2014-03-07','13:45:00',1.35),('3355','2014-03-07','14:55:00',1.2),('3355','2014-03-07','15:00:00',1.57),('3355','2014-03-07','15:05:00',1.83),('3355','2014-03-07','15:10:00',1.85),('3355','2014-03-07','15:15:00',1.9),('3355','2014-03-07','15:20:00',1.99),('3355','2014-03-07','15:25:00',1.93),('3355','2014-03-07','15:30:00',1.87),('3355','2014-03-07','15:35:00',1.76),('3355','2014-03-07','15:40:00',1.67),('3355','2014-03-07','16:05:00',1.24),('3355','2014-03-07','16:10:00',1.22),('3355','2014-03-07','16:15:00',1.21),('3355','2014-03-07','16:20:00',1.13),('3355','2014-03-07','16:25:00',1.06),('3355','2014-03-06','09:50:00',1.01),('3355','2014-03-06','10:05:00',1.25),('3355','2014-03-06','10:10:00',1.71),('3355','2014-03-06','10:15:00',1.9),('3355','2014-03-06','10:20:00',1.59),('3355','2014-03-06','10:25:00',1.27),('3355','2014-03-06','10:45:00',1.3),('3355','2014-03-06','10:55:00',1.03),('3355','2014-03-06','11:00:00',1),('3355','2014-03-06','11:05:00',1.57),('3355','2014-03-06','11:15:00',1.57),('3355','2014-03-06','11:30:00',1.08),('3355','2014-03-06','11:40:00',1.05),('3355','2014-03-06','11:45:00',1.86),('3355','2014-03-06','11:50:00',1.8),('3355','2014-03-06','11:55:00',2.07),('3355','2014-03-06','12:05:00',1.94),('3355','2014-03-06','12:10:00',2.63),('3355','2014-03-06','12:15:00',2.19),('3355','2014-03-06','12:20:00',1.67),('3355','2014-03-06','12:25:00',2.59),('3355','2014-03-06','12:30:00',2.61),('3355','2014-03-06','12:35:00',1.31),('3355','2014-03-06','16:25:00',1.05),('3355','2014-03-05','08:30:00',1.05),('3355','2014-03-05','08:35:00',1.07),('3355','2014-03-05','08:40:00',1.25),('3355','2014-03-05','09:00:00',1.43),('3355','2014-03-05','09:15:00',1.09),('3355','2014-03-05','09:20:00',1.46),('3355','2014-03-05','09:25:00',1.48),('3355','2014-03-05','09:30:00',1.52),('3355','2014-03-05','09:35:00',1.57),('3355','2014-03-05','09:40:00',1.6),('3355','2014-03-05','09:45:00',1.63),('3355','2014-03-05','09:50:00',1.66),('3355','2014-03-05','09:55:00',1.7),('3355','2014-03-05','10:00:00',1.74),('3355','2014-03-05','10:05:00',1.78),('3355','2014-03-05','10:10:00',1.83),('3355','2014-03-05','10:15:00',1.84),('3355','2014-03-05','10:20:00',1.86),('3355','2014-03-05','10:25:00',1.89),('3355','2014-03-05','10:30:00',1.91),('3355','2014-03-05','10:35:00',1.94),('3355','2014-03-05','10:40:00',1.96),('3355','2014-03-05','10:45:00',1.98),('3355','2014-03-05','10:50:00',2),('3355','2014-03-05','10:55:00',2.03),('3355','2014-03-05','11:00:00',2.06),('3355','2014-03-05','11:05:00',2.11),('3355','2014-03-05','11:10:00',2.12),('3355','2014-03-05','11:15:00',2.14),('3355','2014-03-05','11:20:00',2.15),('3355','2014-03-05','11:25:00',2.17),('3355','2014-03-05','11:30:00',2.22),('3355','2014-03-05','11:35:00',2.31),('3355','2014-03-05','11:40:00',2.3),('3355','2014-03-05','11:45:00',2.26),('3355','2014-03-05','11:50:00',2.23),('3355','2014-03-05','11:55:00',1.91),('3355','2014-03-05','12:00:00',1.93),('3355','2014-03-05','12:05:00',1.82),('3355','2014-03-05','12:35:00',1.06),('3355','2014-03-05','13:00:00',1.11),('3355','2014-03-05','13:05:00',1.52),('3355','2014-03-05','13:10:00',1.85),('3355','2014-03-05','13:15:00',1.71),('3355','2014-03-05','13:20:00',1.18),('3355','2014-03-05','14:50:00',1.2),('3355','2014-03-05','15:40:00',1.33),('3355','2014-03-05','15:45:00',1.11),('3355','2014-03-05','15:55:00',1.45),('3355','2014-03-05','16:00:00',1.78),('3355','2014-03-05','16:05:00',1.62),('3355','2014-03-05','16:10:00',1.39),('3355','2014-03-04','09:20:00',1.51),('3355','2014-03-04','09:45:00',1.17),('3355','2014-03-04','09:55:00',1.08),('3355','2014-03-04','10:25:00',1.98),('3355','2014-03-04','10:30:00',1.67),('3355','2014-03-04','10:35:00',1.7),('3355','2014-03-04','10:40:00',2.28),('3355','2014-03-04','10:45:00',2.26),('3355','2014-03-04','10:55:00',1.33),('3355','2014-03-04','11:00:00',1.42),('3355','2014-03-04','11:10:00',1.61),('3355','2014-03-04','11:15:00',2.62),('3355','2014-03-04','11:20:00',2.05),('3355','2014-03-04','11:45:00',1.14),('3355','2014-03-04','11:50:00',2.78),('3355','2014-03-04','11:55:00',2.42),('3355','2014-03-04','12:00:00',2.33),('3355','2014-03-04','12:05:00',2.29),('3355','2014-03-04','12:10:00',2.28),('3355','2014-03-04','12:15:00',2.27),('3355','2014-03-04','12:20:00',2.27),('3355','2014-03-04','12:25:00',2.27),('3355','2014-03-04','12:30:00',2.24),('3355','2014-03-04','12:35:00',2.25),('3355','2014-03-04','12:40:00',2.27),('3355','2014-03-04','12:45:00',2.27),('3355','2014-03-04','12:50:00',1.72),('3355','2014-03-04','12:55:00',1.96),('3355','2014-03-04','13:00:00',1.97),('3355','2014-03-04','13:05:00',2.24),('3355','2014-03-04','13:10:00',2.45),('3355','2014-03-04','13:15:00',2.04),('3355','2014-03-04','14:10:00',1.77),('3355','2014-03-04','14:15:00',1.45),('3355','2014-03-04','14:20:00',1.22),('3355','2014-03-04','14:25:00',2.24),('3355','2014-03-04','14:30:00',2.05),('3355','2014-03-04','14:35:00',1.96),('3355','2014-03-04','14:40:00',1.93),('3355','2014-03-04','14:45:00',1.92),('3355','2014-03-04','14:50:00',1.84),('3355','2014-03-04','15:00:00',1.03),('3355','2014-03-04','15:05:00',1.77),('3355','2014-03-04','15:10:00',1.73),('3355','2014-03-04','15:15:00',1.68),('3355','2014-03-04','15:20:00',1.03),('3355','2014-03-04','15:25:00',1.46),('3355','2014-03-04','15:35:00',1.61),('3355','2014-03-04','15:40:00',1.59),('3355','2014-03-04','15:45:00',1.17),('3355','2014-03-04','15:50:00',1.13),('3355','2014-03-03','08:40:00',1.01),('3355','2014-03-03','08:45:00',1.05),('3355','2014-03-03','08:50:00',1.05),('3355','2014-03-03','08:55:00',1.19),('3355','2014-03-03','09:00:00',1.24),('3355','2014-03-03','09:05:00',1.26),('3355','2014-03-03','09:10:00',1.26),('3355','2014-03-03','09:15:00',1.25),('3355','2014-03-03','09:20:00',1.36),('3355','2014-03-03','09:25:00',1.43),('3355','2014-03-03','09:30:00',1.41),('3355','2014-03-03','09:35:00',1.29),('3355','2014-03-03','09:40:00',1.2),('3355','2014-03-03','09:45:00',1.2),('3355','2014-03-03','09:50:00',1.24),('3355','2014-03-03','09:55:00',1.45),('3355','2014-03-03','10:00:00',1.62),('3355','2014-03-03','10:05:00',1.73),('3355','2014-03-03','10:10:00',1.76),('3355','2014-03-03','10:15:00',1.78),('3355','2014-03-03','10:20:00',1.82),('3355','2014-03-03','10:25:00',1.86),('3355','2014-03-03','10:30:00',1.88),('3355','2014-03-03','10:35:00',1.9),('3355','2014-03-03','10:40:00',1.92),('3355','2014-03-03','10:45:00',1.93),('3355','2014-03-03','10:50:00',1.95),('3355','2014-03-03','10:55:00',1.97),('3355','2014-03-03','11:00:00',2.01),('3355','2014-03-03','11:05:00',2.02),('3355','2014-03-03','11:10:00',2.03),('3355','2014-03-03','11:15:00',2.05),('3355','2014-03-03','11:20:00',2.07),('3355','2014-03-03','11:25:00',2.11),('3355','2014-03-03','11:30:00',2.08),('3355','2014-03-03','11:35:00',1.89),('3355','2014-03-03','11:40:00',1.51),('3355','2014-03-03','11:45:00',2.23),('3355','2014-03-03','11:50:00',2.23),('3355','2014-03-03','11:55:00',2.25),('3355','2014-03-03','12:00:00',2.24),('3355','2014-03-03','12:05:00',2.25),('3355','2014-03-03','12:10:00',2.27),('3355','2014-03-03','12:15:00',2.26),('3355','2014-03-03','12:20:00',2.26),('3355','2014-03-03','12:25:00',2.27),('3355','2014-03-03','12:30:00',2.26),('3355','2014-03-03','12:35:00',2.27),('3355','2014-03-03','12:40:00',2.28),('3355','2014-03-03','12:45:00',2.25),('3355','2014-03-03','12:50:00',2.25),('3355','2014-03-03','12:55:00',2.24),('3355','2014-03-03','13:00:00',2.25),('3355','2014-03-03','13:05:00',2.23),('3355','2014-03-03','13:10:00',2.22),('3355','2014-03-03','13:15:00',2.2),('3355','2014-03-03','13:20:00',2.19),('3355','2014-03-03','13:25:00',2.19),('3355','2014-03-03','13:30:00',2.18),('3355','2014-03-03','13:35:00',2.17),('3355','2014-03-03','13:40:00',2.15),('3355','2014-03-03','13:45:00',2.14),('3355','2014-03-03','13:50:00',2.12),('3355','2014-03-03','13:55:00',2.11),('3355','2014-03-03','14:00:00',2.1),('3355','2014-03-03','14:05:00',2.08),('3355','2014-03-03','14:10:00',2.07),('3355','2014-03-03','14:15:00',2.08),('3355','2014-03-03','14:20:00',2.04),('3355','2014-03-03','14:25:00',1.81),('3355','2014-03-03','14:30:00',1.91),('3355','2014-03-03','14:35:00',1.96),('3355','2014-03-03','14:40:00',1.91),('3355','2014-03-03','14:45:00',1.87),('3355','2014-03-03','14:50:00',1.83),('3355','2014-03-03','14:55:00',1.79),('3355','2014-03-03','15:00:00',1.75),('3355','2014-03-03','15:05:00',1.71),('3355','2014-03-03','15:10:00',1.69),('3355','2014-03-03','15:15:00',1.65),('3355','2014-03-03','15:20:00',1.61),('3355','2014-03-03','15:25:00',1.58),('3355','2014-03-03','15:30:00',1.53),('3355','2014-03-03','15:35:00',1.48),('3355','2014-03-03','15:40:00',1.44),('3355','2014-03-03','15:45:00',1.39),('3355','2014-03-03','15:50:00',1.32),('3355','2014-03-03','15:55:00',1.27),('3355','2014-03-03','16:00:00',1.22),('3355','2014-03-03','16:05:00',1.17),('3355','2014-03-03','16:10:00',1.12),('3355','2014-03-03','16:15:00',1.08),('3355','2014-03-03','16:20:00',1.03),('3355','2014-03-02','08:45:00',1.05),('3355','2014-03-02','08:50:00',1.11),('3355','2014-03-02','08:55:00',1.17),('3355','2014-03-02','09:00:00',1.22),('3355','2014-03-02','09:05:00',1.28),('3355','2014-03-02','09:10:00',1.36),('3355','2014-03-02','09:15:00',1.4),('3355','2014-03-02','09:20:00',1.14),('3355','2014-03-02','09:25:00',1.35),('3355','2014-03-02','09:30:00',1.61),('3355','2014-03-02','09:35:00',1.63),('3355','2014-03-02','09:40:00',1.58),('3355','2014-03-02','10:00:00',1.11),('3355','2014-03-02','10:40:00',1.32),('3355','2014-03-02','11:00:00',1.18),('3355','2014-03-02','11:05:00',1.66),('3355','2014-03-02','11:25:00',1.05),('3355','2014-03-02','11:30:00',1.06),('3355','2014-03-02','11:35:00',1.54),('3355','2014-03-02','11:40:00',2.22),('3355','2014-03-02','11:45:00',1.97),('3355','2014-03-02','11:50:00',2.64),('3355','2014-03-02','11:55:00',2.54),('3355','2014-03-02','12:00:00',1.47),('3355','2014-03-02','12:05:00',1),('3355','2014-03-02','12:10:00',1.13),('3355','2014-03-02','12:15:00',1.93),('3355','2014-03-02','12:20:00',1.42),('3355','2014-03-02','12:25:00',1.02),('3355','2014-02-28','08:35:00',1.02),('3355','2014-02-28','09:45:00',1.64),('3355','2014-02-28','09:50:00',1.91),('3355','2014-02-28','09:55:00',1.79),('3355','2014-02-28','10:25:00',2.04),('3355','2014-02-28','10:30:00',2.16),('3355','2014-02-28','10:35:00',1.68),('3355','2014-02-28','10:40:00',1.2),('3355','2014-02-28','12:05:00',1.12),('3355','2014-02-28','12:10:00',1.27),('3355','2014-02-28','12:30:00',1.28),('3355','2014-02-28','12:35:00',1.48),('3355','2014-02-28','12:40:00',1.89),('3355','2014-02-28','12:50:00',1.38),('3355','2014-02-28','12:55:00',1.04),('3355','2014-02-28','13:00:00',1.37),('3355','2014-02-28','13:05:00',1.07),('3355','2014-02-28','13:50:00',1.89),('3355','2014-02-28','13:55:00',2.48),('3355','2014-02-28','14:00:00',1.04),('3355','2014-02-28','14:20:00',1.04),('3355','2014-02-28','14:25:00',1.17),('3355','2014-02-28','15:00:00',1.22),('3355','2014-02-28','15:25:00',1.1),('3355','2014-02-28','15:30:00',1.34),('3355','2014-02-28','15:35:00',1.59),('3355','2014-02-28','15:40:00',1.31),('3355','2014-02-28','16:15:00',1.34),('3355','2014-02-28','16:20:00',1.16),('3355','2014-02-28','16:45:00',1.03),('3355','2014-02-27','11:30:00',1.07),('3355','2014-02-27','11:35:00',1.02),('3355','2014-02-27','13:55:00',1.12),('3355','2014-02-27','14:00:00',1.09),('3355','2014-02-26','08:45:00',1.07),('3355','2014-02-26','08:50:00',1.06),('3355','2014-02-26','08:55:00',1.06),('3355','2014-02-26','09:00:00',1.11),('3355','2014-02-26','09:05:00',1.13),('3355','2014-02-26','09:10:00',1.15),('3355','2014-02-26','09:15:00',1.26),('3355','2014-02-26','09:20:00',1.3),('3355','2014-02-26','09:25:00',1.39),('3355','2014-02-26','09:30:00',1.31),('3355','2014-02-26','09:35:00',1.36),('3355','2014-02-26','09:45:00',1.27),('3355','2014-02-26','09:50:00',1.43),('3355','2014-02-26','12:10:00',1.82),('3355','2014-02-26','12:30:00',1.11),('3355','2014-02-26','12:45:00',1.73),('3355','2014-02-26','12:50:00',1.56),('3355','2014-02-26','12:55:00',1.05),('3355','2014-02-26','13:00:00',1.21),('3355','2014-02-26','13:05:00',1.91),('3355','2014-02-26','13:10:00',1.77),('3355','2014-02-26','13:15:00',1.74),('3355','2014-02-26','13:20:00',1.87),('3355','2014-02-26','13:25:00',1.8),('3355','2014-02-26','13:30:00',2.21),('3355','2014-02-26','13:35:00',2.12),('3355','2014-02-26','13:40:00',1.88),('3355','2014-02-26','13:45:00',1.95),('3355','2014-02-26','13:50:00',1.33),('3355','2014-02-26','14:00:00',2.01),('3355','2014-02-26','14:05:00',2.13),('3355','2014-02-26','14:15:00',1.27),('3355','2014-02-26','14:20:00',1.85),('3355','2014-02-26','14:25:00',2.06),('3355','2014-02-26','14:30:00',1.13),('3355','2014-02-26','14:40:00',1.61),('3355','2014-02-26','14:45:00',1.9),('3355','2014-02-26','14:50:00',1.11),('3355','2014-02-26','14:55:00',1.69),('3355','2014-02-26','15:00:00',1.78),('3355','2014-02-26','15:05:00',1.66),('3355','2014-02-26','15:10:00',1.52),('3355','2014-02-26','15:15:00',1.34),('3355','2014-02-26','15:20:00',1.2),('3355','2014-02-26','15:35:00',1.08),('3355','2014-02-26','16:00:00',1.15),('3355','2014-02-26','16:05:00',1.08),('3355','2014-04-29','10:10:00',1.47),('3355','2014-04-29','10:15:00',1.68),('3355','2014-04-29','10:20:00',1.75),('3355','2014-04-29','10:25:00',1.82),('3355','2014-04-29','10:30:00',2.11),('3355','2014-04-29','10:35:00',2.07),('3355','2014-04-29','10:40:00',2.09),('3355','2014-04-29','10:45:00',2.1),('3355','2014-04-29','10:50:00',2.15),('3355','2014-04-29','10:55:00',2.07),('3355','2014-04-29','11:00:00',2.1),('3355','2014-04-29','11:05:00',2.1),('3355','2014-04-29','11:10:00',2.16),('3355','2014-04-29','11:15:00',1.86),('3355','2014-04-29','11:20:00',2.1),('3355','2014-04-29','11:25:00',1.75),('3355','2014-04-29','11:30:00',2.21),('3355','2014-04-29','11:35:00',2.13),('3355','2014-04-29','11:40:00',2.01),('3355','2014-04-29','11:45:00',2.07),('3355','2014-04-29','12:05:00',1.16),('3355','2014-04-29','12:10:00',1.32),('3355','2014-04-29','12:15:00',2.4),('3355','2014-04-29','12:20:00',1.06),('3355','2014-04-29','12:25:00',1.61),('3355','2014-04-29','12:30:00',1.64),('3355','2014-04-29','12:35:00',1.53),('3355','2014-04-29','12:40:00',2.17),('3355','2014-04-29','12:45:00',1.57),('3355','2014-04-29','12:50:00',2.76),('3355','2014-04-29','12:55:00',1.82),('3355','2014-04-29','13:00:00',1.13),('3355','2014-04-29','13:15:00',1.16),('3355','2014-04-29','13:20:00',2.38),('3355','2014-04-29','13:25:00',2.25),('3355','2014-04-29','13:30:00',1.28),('3355','2014-04-29','13:35:00',1.13),('3355','2014-04-29','17:25:00',1.04),('3355','2014-04-29','17:35:00',1.11),('3355','2014-04-29','17:40:00',1.06),('3355','2014-04-29','17:45:00',1.13),('3355','2014-02-25','08:55:00',1.03),('3355','2014-02-25','09:00:00',1.08),('3355','2014-02-25','09:05:00',1.13),('3355','2014-02-25','09:10:00',1.17),('3355','2014-02-25','09:15:00',1.24),('3355','2014-02-25','09:20:00',1.26),('3355','2014-02-25','09:25:00',1.3),('3355','2014-02-25','09:30:00',1.35),('3355','2014-02-25','09:35:00',1.39),('3355','2014-02-25','09:40:00',1.43),('3355','2014-02-25','09:45:00',1.48),('3355','2014-02-25','09:50:00',1.5),('3355','2014-02-25','09:55:00',1.54),('3355','2014-02-25','10:00:00',1.56),('3355','2014-02-25','10:05:00',1.6),('3355','2014-02-25','10:10:00',1.63),('3355','2014-02-25','10:15:00',1.69),('3355','2014-02-25','10:20:00',1.71),('3355','2014-02-25','10:25:00',1.72),('3355','2014-02-25','10:30:00',1.75),('3355','2014-02-25','10:35:00',1.77),('3355','2014-02-25','10:40:00',1.8),('3355','2014-02-25','10:45:00',1.82),('3355','2014-02-25','10:50:00',1.83),('3355','2014-02-25','10:55:00',1.84),('3355','2014-02-25','11:00:00',1.87),('3355','2014-02-25','11:05:00',1.88),('3355','2014-02-25','11:10:00',1.9),('3355','2014-02-25','11:15:00',1.92),('3355','2014-02-25','11:20:00',1.94),('3355','2014-02-25','11:25:00',1.96),('3355','2014-02-25','11:30:00',1.96),('3355','2014-02-25','11:35:00',1.96),('3355','2014-02-25','11:40:00',2),('3355','2014-02-25','11:45:00',1.98),('3355','2014-02-25','11:50:00',2.01),('3355','2014-02-25','11:55:00',2.02),('3355','2014-02-25','12:00:00',2.01),('3355','2014-02-25','12:05:00',2.04),('3355','2014-02-25','12:10:00',2.05),('3355','2014-02-25','12:15:00',2.05),('3355','2014-02-25','12:20:00',2.05),('3355','2014-02-25','12:25:00',2.01),('3355','2014-02-25','12:30:00',2),('3355','2014-02-25','12:35:00',2.02),('3355','2014-02-25','12:40:00',2.04),('3355','2014-02-25','12:45:00',2.06),('3355','2014-02-25','12:50:00',2.11),('3355','2014-02-25','12:55:00',2.09),('3355','2014-02-25','13:00:00',2.02),('3355','2014-02-25','13:05:00',2.03),('3355','2014-02-25','13:10:00',2.07),('3355','2014-02-25','13:15:00',1.67),('3355','2014-02-25','13:20:00',1.12),('3355','2014-02-25','14:35:00',1.5),('3355','2014-02-25','14:40:00',1.75),('3355','2014-02-25','14:45:00',1.83),('3355','2014-02-25','14:50:00',1.75),('3355','2014-02-25','14:55:00',1.41),('3355','2014-02-25','15:00:00',1.56),('3355','2014-02-25','15:05:00',1.48),('3355','2014-02-25','15:10:00',1.5),('3355','2014-02-25','15:15:00',1.41),('3355','2014-02-25','15:20:00',1.4),('3355','2014-02-25','15:25:00',1.23),('3355','2014-02-25','15:30:00',1.09),('3355','2014-02-25','15:35:00',1),('3355','2014-02-25','15:40:00',1.15),('3355','2014-02-24','08:35:00',1.03),('3355','2014-02-24','08:40:00',1.1),('3355','2014-02-24','08:45:00',1.14),('3355','2014-02-24','08:50:00',1.08),('3355','2014-02-24','08:55:00',1.06),('3355','2014-02-24','09:00:00',1.08),('3355','2014-02-24','09:05:00',1.11),('3355','2014-02-24','09:10:00',1.16),('3355','2014-02-24','09:15:00',1.22),('3355','2014-02-24','09:20:00',1.26),('3355','2014-02-24','09:25:00',1.32),('3355','2014-02-24','09:30:00',1.36),('3355','2014-02-24','09:35:00',1.39),('3355','2014-02-24','09:40:00',1.43),('3355','2014-02-24','09:45:00',1.48),('3355','2014-02-24','09:50:00',1.51),('3355','2014-02-24','09:55:00',1.55),('3355','2014-02-24','10:00:00',1.59),('3355','2014-02-24','10:05:00',1.63),('3355','2014-02-24','10:10:00',1.66),('3355','2014-02-24','10:15:00',1.7),('3355','2014-02-24','10:20:00',1.73),('3355','2014-02-24','10:25:00',1.76),('3355','2014-02-24','10:30:00',1.79),('3355','2014-02-24','10:35:00',1.81),('3355','2014-02-24','10:40:00',1.84),('3355','2014-02-24','10:45:00',1.87),('3355','2014-02-24','10:50:00',1.9),('3355','2014-02-24','10:55:00',1.91),('3355','2014-02-24','11:00:00',1.93),('3355','2014-02-24','11:05:00',1.96),('3355','2014-02-24','11:10:00',1.98),('3355','2014-02-24','11:15:00',1.99),('3355','2014-02-24','11:20:00',2),('3355','2014-02-24','11:25:00',2.08),('3355','2014-02-24','11:30:00',2.21),('3355','2014-02-24','11:35:00',1.65),('3355','2014-02-24','11:40:00',2.2),('3355','2014-02-24','11:45:00',2.37),('3355','2014-02-24','11:50:00',1.77),('3355','2014-02-24','11:55:00',1.62),('3355','2014-02-24','12:00:00',1.84),('3355','2014-02-24','12:05:00',1.34),('3355','2014-02-24','12:10:00',1.89),('3355','2014-02-24','12:15:00',1.84),('3355','2014-02-24','12:20:00',1.93),('3355','2014-02-24','12:25:00',2.23),('3355','2014-02-24','12:30:00',2.06),('3355','2014-02-24','12:40:00',1.86),('3355','2014-02-24','12:50:00',2.24),('3355','2014-02-24','12:55:00',2.17),('3355','2014-02-24','13:10:00',2.48),('3355','2014-02-24','13:15:00',2.58),('3355','2014-02-24','15:35:00',1.55),('3355','2014-02-24','15:40:00',1.66),('3355','2014-02-24','15:45:00',1.58),('3355','2014-02-24','15:50:00',1.48),('3355','2014-02-24','15:55:00',1.12),('3355','2014-02-24','16:00:00',1.32),('3355','2014-02-24','16:05:00',1.36),('3355','2014-02-24','16:10:00',1.26),('3355','2014-02-24','16:15:00',1.18),('3355','2014-02-24','16:20:00',1.01),('3355','2014-02-23','09:55:00',1.52),('3355','2014-02-23','10:00:00',1.53),('3355','2014-02-23','10:05:00',1.58),('3355','2014-02-23','10:10:00',1.6),('3355','2014-02-23','10:15:00',1.62),('3355','2014-02-23','10:20:00',1.67),('3355','2014-02-23','10:25:00',1.71),('3355','2014-02-23','10:30:00',1.74),('3355','2014-02-23','10:35:00',1.76),('3355','2014-02-23','10:40:00',1.8),('3355','2014-02-23','10:45:00',1.84),('3355','2014-02-23','10:50:00',1.84),('3355','2014-02-23','10:55:00',1.58),('3355','2014-02-23','11:00:00',1.79),('3355','2014-02-23','11:05:00',1.95),('3355','2014-02-23','11:10:00',1.97),('3355','2014-02-23','11:15:00',1.98),('3355','2014-02-23','11:20:00',1.97),('3355','2014-02-23','11:25:00',1.97),('3355','2014-02-23','11:30:00',2.08),('3355','2014-02-23','11:35:00',2.08),('3355','2014-02-23','11:40:00',2.14),('3355','2014-02-23','11:45:00',2.13),('3355','2014-02-23','11:50:00',2.06),('3355','2014-02-23','11:55:00',1.87),('3355','2014-02-23','12:00:00',1.88),('3355','2014-02-23','12:05:00',2.23),('3355','2014-02-23','12:10:00',1.89),('3355','2014-02-23','12:15:00',2.3),('3355','2014-02-23','12:20:00',2.17),('3355','2014-02-23','12:25:00',1.36),('3355','2014-02-23','12:30:00',1.49),('3355','2014-02-23','12:35:00',2.37),('3355','2014-02-23','12:40:00',1.41),('3355','2014-02-23','12:45:00',1.29),('3355','2014-02-23','12:55:00',1.24),('3355','2014-02-23','13:00:00',1.36),('3355','2014-02-23','13:05:00',2.15),('3355','2014-02-23','13:10:00',2.16),('3355','2014-02-23','13:15:00',2.12),('3355','2014-02-23','13:20:00',2.11),('3355','2014-02-23','13:25:00',2.11),('3355','2014-02-23','13:30:00',2.06),('3355','2014-02-23','13:40:00',2.01),('3355','2014-02-23','13:45:00',1.87),('3355','2014-02-23','13:50:00',1.67),('3355','2014-02-23','14:00:00',1.8),('3355','2014-02-23','14:05:00',1.86),('3355','2014-02-23','14:10:00',2.03),('3355','2014-02-23','14:15:00',1.57),('3355','2014-02-23','14:20:00',1.03),('3355','2014-02-23','14:25:00',1.43),('3355','2014-02-23','14:30:00',1.71),('3355','2014-02-23','14:35:00',1.19),('3355','2014-02-22','10:05:00',1.36),('3355','2014-02-22','10:10:00',1.02),('3355','2014-02-22','10:15:00',1.24),('3355','2014-02-22','10:30:00',1.71),('3355','2014-02-22','10:45:00',1.53),('3355','2014-02-22','10:50:00',2.11),('3355','2014-02-22','12:15:00',1.26),('3355','2014-02-22','12:25:00',1.05),('3355','2014-02-22','12:45:00',2.04),('3355','2014-02-22','12:50:00',1.8),('3355','2014-02-22','13:10:00',2.28),('3355','2014-02-22','13:15:00',1.51),('3355','2014-02-22','13:40:00',1.31),('3355','2014-02-22','13:55:00',1.92),('3355','2014-02-22','14:00:00',2.16),('3355','2014-02-22','14:05:00',1.66),('3355','2014-02-22','14:10:00',1.85),('3355','2014-02-22','14:15:00',1.5),('3355','2014-02-22','14:20:00',1.98),('3355','2014-02-22','14:25:00',1.75),('3355','2014-02-22','14:30:00',1.72),('3355','2014-02-22','14:40:00',1.52),('3355','2014-02-22','14:45:00',1.9),('3355','2014-02-22','14:50:00',1.88),('3355','2014-02-22','15:05:00',1.18),('3355','2014-02-22','15:30:00',1.23),('3355','2014-02-22','15:35:00',1.45),('3355','2014-02-22','15:45:00',1.17),('3355','2014-02-22','15:50:00',1.24),('3355','2014-02-22','15:55:00',1.09),('3355','2014-02-22','16:00:00',1.13),('3355','2014-02-21','10:20:00',1.08),('3355','2014-02-21','10:25:00',1.36),('3355','2014-02-21','10:30:00',1.58),('3355','2014-02-21','10:35:00',1.26),('3355','2014-02-21','10:40:00',1.05),('3355','2014-02-21','10:45:00',1.01),('3355','2014-02-21','10:55:00',1.19),('3355','2014-02-21','11:00:00',1.06),('3355','2014-02-21','11:25:00',1.29),('3355','2014-02-21','11:30:00',2.19),('3355','2014-02-21','11:35:00',1.58),('3355','2014-02-21','11:40:00',2.05),('3355','2014-02-21','11:45:00',2.03),('3355','2014-02-21','11:55:00',2.28),('3355','2014-02-21','12:00:00',2.46),('3355','2014-02-21','12:05:00',2.39),('3355','2014-02-21','12:10:00',1.9),('3355','2014-02-21','15:05:00',1.05),('3355','2014-02-21','15:30:00',1.35),('3355','2014-02-21','15:35:00',1.26),('3355','2014-02-21','15:40:00',1.19),('3355','2014-02-21','15:45:00',1.16),('3355','2014-02-21','15:50:00',1.1),('3355','2014-02-21','15:55:00',1.04),('3355','2014-02-19','10:45:00',1.06),('3355','2014-02-18','09:05:00',1.02),('3355','2014-02-18','09:10:00',1.06),('3355','2014-02-18','09:15:00',1.1),('3355','2014-02-18','09:20:00',1.15),('3355','2014-02-18','09:25:00',1.19),('3355','2014-02-18','09:30:00',1.24),('3355','2014-02-18','09:35:00',1.28),('3355','2014-02-18','09:40:00',1.32),('3355','2014-02-18','09:45:00',1.35),('3355','2014-02-18','09:50:00',1.4),('3355','2014-02-18','09:55:00',1.44),('3355','2014-02-18','10:00:00',1.48),('3355','2014-02-18','10:05:00',1.51),('3355','2014-02-18','10:10:00',1.54),('3355','2014-02-18','10:15:00',1.56),('3355','2014-02-18','10:20:00',1.59),('3355','2014-02-18','10:25:00',1.62),('3355','2014-02-18','10:30:00',1.63),('3355','2014-02-18','10:35:00',1.65),('3355','2014-02-18','10:40:00',1.68),('3355','2014-02-18','10:45:00',1.71),('3355','2014-02-18','10:50:00',1.74),('3355','2014-02-18','10:55:00',1.77),('3355','2014-02-18','11:00:00',1.8),('3355','2014-02-18','11:05:00',1.54),('3355','2014-02-18','11:10:00',1.49),('3355','2014-02-18','11:15:00',1.43),('3355','2014-02-18','11:20:00',1.66),('3355','2014-02-18','11:25:00',1.87),('3355','2014-02-18','11:30:00',1.74),('3355','2014-02-18','11:35:00',1.55),('3355','2014-02-18','11:40:00',1.28),('3355','2014-02-18','11:45:00',1.29),('3355','2014-02-18','11:50:00',1.08),('3355','2014-02-18','12:15:00',1.05),('3355','2014-02-18','12:20:00',1.01),('3355','2014-02-18','12:25:00',1.19),('3355','2014-02-18','12:30:00',1.36),('3355','2014-02-18','12:35:00',1.01),('3355','2014-02-18','12:55:00',1.03),('3355','2014-02-18','13:15:00',1.05),('3355','2014-02-18','13:20:00',1.15),('3355','2014-02-18','13:25:00',1.38),('3355','2014-02-18','13:40:00',1.05),('3355','2014-02-18','13:45:00',1.27),('3355','2014-02-18','14:00:00',1.12),('3355','2014-02-18','14:05:00',1.63),('3355','2014-02-17','09:15:00',1.02),('3355','2014-02-17','09:20:00',1.06),('3355','2014-02-17','09:25:00',1.11),('3355','2014-02-17','09:30:00',1.16),('3355','2014-02-17','09:35:00',1.2),('3355','2014-02-17','09:40:00',1.23),('3355','2014-02-17','09:45:00',1.26),('3355','2014-02-17','09:50:00',1.29),('3355','2014-02-17','09:55:00',1.32),('3355','2014-02-17','10:00:00',1.35),('3355','2014-02-17','10:05:00',1.4),('3355','2014-02-17','10:10:00',1.43),('3355','2014-02-17','10:15:00',1.45),('3355','2014-02-17','10:20:00',1.46),('3355','2014-02-17','10:25:00',1.48),('3355','2014-02-17','10:30:00',1.51),('3355','2014-02-17','10:35:00',1.52),('3355','2014-02-17','10:40:00',1.53),('3355','2014-02-17','10:45:00',1.54),('3355','2014-02-17','10:50:00',1.55),('3355','2014-02-17','10:55:00',1.59),('3355','2014-02-17','11:00:00',1.59),('3355','2014-02-17','11:05:00',1.62),('3355','2014-02-17','11:10:00',1.65),('3355','2014-02-17','11:15:00',1.67),('3355','2014-02-17','11:20:00',1.71),('3355','2014-02-17','11:25:00',1.74),('3355','2014-02-17','11:30:00',1.78),('3355','2014-02-17','11:35:00',1.81),('3355','2014-02-17','11:40:00',1.83),('3355','2014-02-17','11:45:00',1.84),('3355','2014-02-17','11:50:00',1.85),('3355','2014-02-17','11:55:00',1.85),('3355','2014-02-17','12:00:00',1.86),('3355','2014-02-17','12:05:00',1.88),('3355','2014-02-17','12:10:00',1.87),('3355','2014-02-17','12:15:00',1.87),('3355','2014-02-17','12:20:00',1.87),('3355','2014-02-17','12:25:00',1.87),('3355','2014-02-17','12:30:00',1.87),('3355','2014-02-17','12:35:00',1.87),('3355','2014-02-17','12:40:00',1.86),('3355','2014-02-17','12:45:00',1.85),('3355','2014-02-17','12:50:00',1.85),('3355','2014-02-17','12:55:00',1.85),('3355','2014-02-17','13:00:00',1.85),('3355','2014-02-17','13:05:00',1.83),('3355','2014-02-17','13:10:00',1.82),('3355','2014-02-17','13:15:00',1.8),('3355','2014-02-17','13:20:00',1.79),('3355','2014-02-17','13:25:00',1.79),('3355','2014-02-17','13:30:00',1.79),('3355','2014-02-17','13:35:00',1.79),('3355','2014-02-17','13:40:00',1.77),('3355','2014-02-17','13:45:00',1.73),('3355','2014-02-17','13:50:00',1.73),('3355','2014-02-17','13:55:00',1.71),('3355','2014-02-17','14:00:00',1.67),('3355','2014-02-17','14:05:00',1.67),('3355','2014-02-17','14:10:00',1.6),('3355','2014-02-17','14:15:00',1.55),('3355','2014-02-17','14:20:00',1.61),('3355','2014-02-17','14:25:00',1.55),('3355','2014-02-17','14:30:00',1.51),('3355','2014-02-17','14:35:00',1.47),('3355','2014-02-17','14:40:00',1.34),('3355','2014-02-17','14:45:00',1.47),('3355','2014-02-17','14:50:00',1.38),('3355','2014-02-17','14:55:00',1.38),('3355','2014-02-17','15:00:00',1.3),('3355','2014-02-17','15:05:00',1.28),('3355','2014-02-17','15:10:00',1.25),('3355','2014-02-17','15:15:00',1.27),('3355','2014-02-17','15:20:00',1.24),('3355','2014-02-17','15:25:00',1.16),('3355','2014-02-17','15:30:00',1.14),('3355','2014-02-17','15:35:00',1.09),('3355','2014-02-17','15:40:00',1.01),('3355','2014-02-17','15:45:00',1.01),('3355','2014-02-16','09:05:00',1.04),('3355','2014-02-16','09:10:00',1.02),('3355','2014-02-16','09:20:00',1.08),('3355','2014-02-16','09:25:00',1.14),('3355','2014-02-16','09:30:00',1.19),('3355','2014-02-16','09:35:00',1),('3355','2014-02-16','09:40:00',1.26),('3355','2014-02-16','09:45:00',1.35),('3355','2014-02-16','09:50:00',1.39),('3355','2014-02-16','09:55:00',1.37),('3355','2014-02-16','10:00:00',1.33),('3355','2014-02-16','10:05:00',1.5),('3355','2014-02-16','10:10:00',1.55),('3355','2014-02-16','10:15:00',1.58),('3355','2014-02-16','10:20:00',1.61),('3355','2014-02-16','10:25:00',1.65),('3355','2014-02-16','10:30:00',1.67),('3355','2014-02-16','10:35:00',1.74),('3355','2014-02-16','10:40:00',1.79),('3355','2014-02-16','10:45:00',1.77),('3355','2014-02-16','10:50:00',1.61),('3355','2014-02-16','10:55:00',1.5),('3355','2014-02-16','11:00:00',1.79),('3355','2014-02-16','11:05:00',1.84),('3355','2014-02-16','11:10:00',1.77),('3355','2014-02-16','11:15:00',1.82),('3355','2014-02-16','11:20:00',1.79),('3355','2014-02-16','11:25:00',1.73),('3355','2014-02-16','11:30:00',1.79),('3355','2014-02-16','11:35:00',1.9),('3355','2014-02-16','11:40:00',1.9),('3355','2014-02-16','11:45:00',1.69),('3355','2014-02-16','11:50:00',1.91),('3355','2014-02-16','11:55:00',1.64),('3355','2014-02-16','12:00:00',1.95),('3355','2014-02-16','12:05:00',1.93),('3355','2014-02-16','12:10:00',1.94),('3355','2014-02-16','12:15:00',1.94),('3355','2014-02-16','12:20:00',1.95),('3355','2014-02-16','12:25:00',1.91),('3355','2014-02-16','12:30:00',1.95),('3355','2014-02-16','12:35:00',1.94),('3355','2014-02-16','12:40:00',1.93),('3355','2014-02-16','12:45:00',1.91),('3355','2014-02-16','12:50:00',1.92),('3355','2014-02-16','12:55:00',1.94),('3355','2014-02-16','13:00:00',1.92),('3355','2014-02-16','13:05:00',1.92),('3355','2014-02-16','13:10:00',1.87),('3355','2014-02-16','13:15:00',1.89),('3355','2014-02-16','13:20:00',1.92),('3355','2014-02-16','13:25:00',1.89),('3355','2014-02-16','13:30:00',1.84),('3355','2014-02-16','13:35:00',1.84),('3355','2014-02-16','13:40:00',1.82),('3355','2014-02-16','13:45:00',1.84),('3355','2014-02-16','13:50:00',1.82),('3355','2014-02-16','13:55:00',1.82),('3355','2014-02-16','14:00:00',1.82),('3355','2014-02-16','14:05:00',1.81),('3355','2014-02-16','14:10:00',1.8),('3355','2014-02-16','14:15:00',1.77),('3355','2014-02-16','14:20:00',1.75),('3355','2014-02-16','14:25:00',1.74),('3355','2014-02-16','14:30:00',1.7),('3355','2014-02-16','14:35:00',1.68),('3355','2014-02-16','14:40:00',1.62),('3355','2014-02-16','14:45:00',1.62),('3355','2014-02-16','14:50:00',1.58),('3355','2014-02-16','14:55:00',1.56),('3355','2014-02-16','15:00:00',1.51),('3355','2014-02-16','15:05:00',1.5),('3355','2014-02-16','15:10:00',1.45),('3355','2014-02-16','15:15:00',1.41),('3355','2014-02-16','15:20:00',1.36),('3355','2014-02-16','15:25:00',1.31),('3355','2014-02-16','15:30:00',1.27),('3355','2014-02-16','15:35:00',1.13),('3355','2014-02-16','15:45:00',1.17),('3355','2014-04-28','09:15:00',1.48),('3355','2014-04-28','09:20:00',1.48),('3355','2014-04-28','09:25:00',1.16),('3355','2014-04-28','09:30:00',1.19),('3355','2014-04-28','09:40:00',1.08),('3355','2014-04-28','09:50:00',1.29),('3355','2014-04-28','10:05:00',1.17),('3355','2014-04-28','10:10:00',1.26),('3355','2014-04-28','10:15:00',1.21),('3355','2014-04-28','10:20:00',1.03),('3355','2014-04-28','10:50:00',1.08),('3355','2014-04-28','11:05:00',1.23),('3355','2014-04-28','11:10:00',1.4),('3355','2014-04-28','11:15:00',1.34),('3355','2014-04-28','11:20:00',1.31),('3355','2014-04-28','11:30:00',1.08),('3355','2014-04-28','11:35:00',1.04),('3355','2014-04-28','11:55:00',1.08),('3355','2014-04-28','12:15:00',1.45),('3355','2014-04-28','12:20:00',1.68),('3355','2014-04-28','12:25:00',1.54),('3355','2014-04-28','12:30:00',1.45),('3355','2014-04-28','12:35:00',1.34),('3355','2014-04-28','12:40:00',1.21),('3355','2014-04-28','12:45:00',1.04),('3355','2014-04-28','12:50:00',1.29),('3355','2014-04-28','12:55:00',1.2),('3355','2014-04-28','13:00:00',1.22),('3355','2014-04-28','13:05:00',1.39),('3355','2014-04-28','13:10:00',2.2),('3355','2014-04-28','13:15:00',1.31),('3355','2014-04-28','13:20:00',1.18),('3355','2014-04-28','13:25:00',1.35),('3355','2014-04-28','13:30:00',2.38),('3355','2014-04-28','13:35:00',2.16),('3355','2014-04-28','13:40:00',2.14),('3355','2014-04-28','13:45:00',1.07),('3355','2014-04-28','13:50:00',2.34),('3355','2014-04-28','13:55:00',1.92),('3355','2014-04-28','14:05:00',1.25),('3355','2014-04-28','14:10:00',1.8),('3355','2014-04-28','14:15:00',2.08),('3355','2014-04-28','14:20:00',2.3),('3355','2014-04-28','14:25:00',1.57),('3355','2014-04-28','14:30:00',1.32),('3355','2014-04-28','14:35:00',2.32),('3355','2014-04-28','14:40:00',2.43),('3355','2014-04-28','14:45:00',1.58),('3355','2014-04-28','14:50:00',1.3),('3355','2014-04-28','14:55:00',2.17),('3355','2014-04-28','15:00:00',1.49),('3355','2014-04-28','15:05:00',1.65),('3355','2014-04-28','15:10:00',1.84),('3355','2014-04-28','15:15:00',1.4),('3355','2014-04-28','15:20:00',1.02),('3355','2014-04-28','15:25:00',1.24),('3355','2014-04-28','15:30:00',1.13),('3355','2014-04-28','15:35:00',1.6),('3355','2014-04-28','15:40:00',1.41),('3355','2014-04-28','15:50:00',2.07),('3355','2014-04-28','16:00:00',1.48),('3355','2014-04-28','16:05:00',1.96),('3355','2014-04-28','16:10:00',2.15),('3355','2014-04-28','16:15:00',1.68),('3355','2014-04-28','16:20:00',1.21),('3355','2014-04-28','16:30:00',2),('3355','2014-04-28','16:35:00',1.85),('3355','2014-02-15','09:15:00',1.03),('3355','2014-02-15','09:20:00',1.1),('3355','2014-02-15','09:25:00',1.15),('3355','2014-02-15','09:30:00',1.19),('3355','2014-02-15','09:35:00',1.24),('3355','2014-02-15','09:40:00',1.28),('3355','2014-02-15','09:45:00',1.31),('3355','2014-02-15','09:50:00',1.34),('3355','2014-02-15','09:55:00',1.39),('3355','2014-02-15','10:00:00',1.42),('3355','2014-02-15','10:05:00',1.46),('3355','2014-02-15','10:10:00',1.48),('3355','2014-02-15','10:15:00',1.52),('3355','2014-02-15','10:20:00',1.54),('3355','2014-02-15','10:25:00',1.57),('3355','2014-02-15','10:30:00',1.58),('3355','2014-02-15','10:35:00',1.6),('3355','2014-02-15','10:40:00',1.63),('3355','2014-02-15','10:45:00',1.64),('3355','2014-02-15','10:50:00',1.67),('3355','2014-02-15','10:55:00',1.72),('3355','2014-02-15','11:00:00',1.78),('3355','2014-02-15','11:05:00',1.84),('3355','2014-02-15','11:10:00',1.78),('3355','2014-02-15','11:15:00',1.75),('3355','2014-02-15','11:20:00',1.88),('3355','2014-02-15','11:35:00',1.94),('3355','2014-02-15','11:40:00',1.66),('3355','2014-02-15','11:45:00',2.03),('3355','2014-02-15','11:50:00',1.59),('3355','2014-02-15','11:55:00',2.01),('3355','2014-02-15','12:00:00',1.04),('3355','2014-02-15','12:05:00',1.68),('3355','2014-02-15','12:10:00',1.7),('3355','2014-02-15','12:15:00',2.01),('3355','2014-02-15','12:20:00',2.21),('3355','2014-02-15','12:25:00',2.12),('3355','2014-02-15','12:30:00',2.1),('3355','2014-02-15','12:35:00',2.05),('3355','2014-02-15','12:40:00',2.22),('3355','2014-02-15','12:45:00',2.28),('3355','2014-02-15','12:50:00',2.24),('3355','2014-02-15','12:55:00',2.04),('3355','2014-02-15','13:00:00',2.1),('3355','2014-02-15','13:05:00',2.08),('3355','2014-02-15','13:10:00',2.07),('3355','2014-02-15','13:15:00',2.03),('3355','2014-02-15','13:20:00',1.99),('3355','2014-02-15','13:25:00',1.91),('3355','2014-02-15','13:30:00',1.9),('3355','2014-02-15','13:35:00',1.88),('3355','2014-02-15','13:40:00',1.87),('3355','2014-02-15','13:45:00',1.84),('3355','2014-02-15','13:50:00',1.84),('3355','2014-02-15','13:55:00',1.79),('3355','2014-02-15','14:00:00',1.78),('3355','2014-02-15','14:05:00',1.77),('3355','2014-02-15','14:10:00',1.73),('3355','2014-02-15','14:15:00',1.72),('3355','2014-02-15','14:20:00',1.7),('3355','2014-02-15','14:25:00',1.66),('3355','2014-02-15','14:30:00',1.64),('3355','2014-02-15','14:35:00',1.62),('3355','2014-02-15','14:40:00',1.6),('3355','2014-02-15','14:45:00',1.56),('3355','2014-02-15','14:50:00',1.53),('3355','2014-02-15','14:55:00',1.48),('3355','2014-02-15','15:00:00',1.41),('3355','2014-02-15','15:05:00',1.39),('3355','2014-02-15','15:10:00',1.33),('3355','2014-02-15','15:15:00',1.33),('3355','2014-02-15','15:20:00',1.3),('3355','2014-02-15','15:25:00',1.26),('3355','2014-02-15','15:30:00',1.22),('3355','2014-02-15','15:35:00',1.19),('3355','2014-02-15','15:40:00',1.16),('3355','2014-02-15','15:45:00',1.12),('3355','2014-02-15','15:50:00',1.07),('3355','2014-02-15','15:55:00',1.02),('3355','2014-02-14','09:30:00',1.01),('3355','2014-02-14','09:50:00',1.11),('3355','2014-02-14','09:55:00',1.45),('3355','2014-02-14','10:00:00',1.3),('3355','2014-02-14','10:05:00',1.52),('3355','2014-02-14','10:10:00',1.62),('3355','2014-02-14','10:15:00',1.19),('3355','2014-02-14','10:20:00',1.52),('3355','2014-02-14','10:25:00',1.46),('3355','2014-02-14','10:30:00',1.71),('3355','2014-02-14','10:35:00',1.67),('3355','2014-02-14','10:40:00',1.7),('3355','2014-02-14','10:45:00',1.75),('3355','2014-02-14','10:50:00',1.8),('3355','2014-02-14','10:55:00',1.82),('3355','2014-02-14','11:00:00',1.84),('3355','2014-02-14','11:05:00',1.87),('3355','2014-02-14','11:10:00',1.89),('3355','2014-02-14','11:15:00',1.9),('3355','2014-02-14','11:20:00',1.93),('3355','2014-02-14','11:25:00',1.95),('3355','2014-02-14','11:30:00',1.97),('3355','2014-02-14','11:35:00',2),('3355','2014-02-14','11:40:00',1.93),('3355','2014-02-14','11:45:00',2.01),('3355','2014-02-14','11:50:00',1.9),('3355','2014-02-14','11:55:00',2.01),('3355','2014-02-14','12:00:00',2.03),('3355','2014-02-14','12:05:00',2.04),('3355','2014-02-14','12:10:00',2),('3355','2014-02-14','12:15:00',2.05),('3355','2014-02-14','12:20:00',2.04),('3355','2014-02-14','12:25:00',2.06),('3355','2014-02-14','12:30:00',2.06),('3355','2014-02-14','12:35:00',2.04),('3355','2014-02-14','12:40:00',2.03),('3355','2014-02-14','12:45:00',2.02),('3355','2014-02-14','12:50:00',2.02),('3355','2014-02-14','12:55:00',2.03),('3355','2014-02-14','13:00:00',2.02),('3355','2014-02-14','13:05:00',2.01),('3355','2014-02-14','13:10:00',2),('3355','2014-02-14','13:15:00',1.99),('3355','2014-02-14','13:20:00',1.99),('3355','2014-02-14','13:25:00',1.96),('3355','2014-02-14','13:30:00',1.94),('3355','2014-02-14','13:35:00',1.93),('3355','2014-02-14','13:40:00',1.94),('3355','2014-02-14','13:45:00',1.9),('3355','2014-02-14','13:50:00',1.89),('3355','2014-02-14','13:55:00',1.87),('3355','2014-02-14','14:00:00',1.85),('3355','2014-02-14','14:05:00',1.82),('3355','2014-02-14','14:10:00',1.8),('3355','2014-02-14','14:15:00',1.77),('3355','2014-02-14','14:20:00',1.75),('3355','2014-02-14','14:25:00',1.73),('3355','2014-02-14','14:30:00',1.71),('3355','2014-02-14','14:35:00',1.68),('3355','2014-02-14','14:40:00',1.64),('3355','2014-02-14','14:45:00',1.6),('3355','2014-02-14','14:50:00',1.56),('3355','2014-02-14','14:55:00',1.52),('3355','2014-02-14','15:00:00',1.48),('3355','2014-02-14','15:05:00',1.45),('3355','2014-02-14','15:10:00',1.42),('3355','2014-02-14','15:15:00',1.39),('3355','2014-02-14','15:20:00',1.34),('3355','2014-02-14','15:25:00',1.3),('3355','2014-02-14','15:30:00',1.26),('3355','2014-02-14','15:35:00',1.21),('3355','2014-02-14','15:40:00',1.16),('3355','2014-02-14','15:45:00',1.11),('3355','2014-02-14','15:50:00',1.06),('3355','2014-02-13','09:10:00',1.04),('3355','2014-02-13','09:15:00',1.08),('3355','2014-02-13','09:20:00',1.13),('3355','2014-02-13','09:25:00',1.18),('3355','2014-02-13','09:30:00',1.21),('3355','2014-02-13','09:35:00',1.26),('3355','2014-02-13','09:40:00',1.3),('3355','2014-02-13','09:45:00',1.33),('3355','2014-02-13','09:50:00',1.36),('3355','2014-02-13','09:55:00',1.4),('3355','2014-02-13','10:00:00',1.44),('3355','2014-02-13','10:05:00',1.48),('3355','2014-02-13','10:10:00',1.51),('3355','2014-02-13','10:15:00',1.54),('3355','2014-02-13','10:20:00',1.56),('3355','2014-02-13','10:25:00',1.58),('3355','2014-02-13','10:30:00',1.62),('3355','2014-02-13','10:35:00',1.65),('3355','2014-02-13','10:40:00',1.67),('3355','2014-02-13','10:45:00',1.66),('3355','2014-02-13','10:50:00',1.69),('3355','2014-02-13','10:55:00',1.72),('3355','2014-02-13','11:00:00',1.74),('3355','2014-02-13','11:05:00',1.75),('3355','2014-02-13','11:10:00',1.82),('3355','2014-02-13','11:15:00',1.86),('3355','2014-02-13','11:20:00',1.86),('3355','2014-02-13','11:25:00',1.79),('3355','2014-02-13','11:30:00',1.62),('3355','2014-02-13','11:35:00',1.84),('3355','2014-02-13','11:40:00',1.28),('3355','2014-02-13','11:45:00',1.98),('3355','2014-02-13','11:55:00',1.87),('3355','2014-02-13','12:00:00',1.03),('3355','2014-02-13','12:10:00',1.58),('3355','2014-02-13','12:15:00',1.42),('3355','2014-02-13','12:20:00',1.34),('3355','2014-02-13','12:30:00',2.16),('3355','2014-02-13','12:35:00',2.34),('3355','2014-02-13','12:40:00',2.25),('3355','2014-02-13','12:55:00',1.13),('3355','2014-02-13','13:00:00',1.1),('3355','2014-02-13','13:05:00',2.14),('3355','2014-02-13','13:10:00',2.09),('3355','2014-02-13','13:15:00',2.05),('3355','2014-02-13','13:20:00',2.03),('3355','2014-02-13','13:25:00',2.01),('3355','2014-02-13','13:30:00',2),('3355','2014-02-13','13:35:00',1.98),('3355','2014-02-13','13:40:00',1.96),('3355','2014-02-13','13:45:00',1.96),('3355','2014-02-13','13:50:00',1.94),('3355','2014-02-13','13:55:00',1.93),('3355','2014-02-13','14:00:00',1.9),('3355','2014-02-13','14:05:00',1.87),('3355','2014-02-13','14:10:00',1.85),('3355','2014-02-13','14:15:00',1.82),('3355','2014-02-13','14:20:00',1.78),('3355','2014-02-13','14:25:00',1.76),('3355','2014-02-13','14:30:00',1.73),('3355','2014-02-13','14:35:00',1.71),('3355','2014-02-13','14:40:00',1.68),('3355','2014-02-13','14:45:00',1.62),('3355','2014-02-13','14:55:00',1.65),('3355','2014-02-13','15:00:00',1.66),('3355','2014-02-13','15:05:00',1.25),('3355','2014-02-13','15:10:00',1.54),('3355','2014-02-13','15:15:00',1.28),('3355','2014-02-13','15:20:00',1.44),('3355','2014-02-13','15:25:00',1.41),('3355','2014-02-13','15:40:00',1.06),('3355','2014-02-13','15:45:00',1.22),('3355','2014-02-12','09:15:00',1.11),('3355','2014-02-12','09:20:00',1.08),('3355','2014-02-12','09:45:00',1.23),('3355','2014-02-12','09:50:00',1.08),('3355','2014-02-12','10:35:00',1.17),('3355','2014-02-12','10:45:00',1.19),('3355','2014-02-12','11:05:00',1.57),('3355','2014-02-12','11:20:00',1.08),('3355','2014-02-12','11:30:00',1.15),('3355','2014-02-12','11:35:00',1.12),('3355','2014-02-12','13:00:00',1.04),('3355','2014-02-12','13:30:00',1.3),('3355','2014-02-12','13:35:00',2.12),('3355','2014-02-12','13:40:00',1.98),('3355','2014-02-12','13:45:00',1.49),('3355','2014-02-12','13:50:00',1.72),('3355','2014-02-12','13:55:00',1.45),('3355','2014-02-12','14:00:00',1.99),('3355','2014-02-12','14:05:00',2.02),('3355','2014-02-12','14:10:00',1.93),('3355','2014-02-12','14:15:00',1.98),('3355','2014-02-12','14:20:00',1.8),('3355','2014-02-12','14:25:00',1.86),('3355','2014-02-12','14:35:00',1.5),('3355','2014-02-12','14:40:00',1.17),('3355','2014-02-12','14:45:00',1.2),('3355','2014-02-12','14:50:00',1.8),('3355','2014-02-12','14:55:00',1.71),('3355','2014-02-12','15:00:00',1.07),('3355','2014-02-12','15:20:00',1.16),('3355','2014-02-12','15:25:00',1.01),('3355','2014-02-12','15:35:00',1.24),('3355','2014-02-12','15:40:00',1.25),('3355','2014-02-12','15:50:00',1.18),('3355','2014-02-11','10:20:00',1.05),('3355','2014-02-11','10:25:00',1.1),('3355','2014-02-11','10:30:00',1.19),('3355','2014-02-11','10:35:00',1.4),('3355','2014-02-11','10:40:00',1.43),('3355','2014-02-11','10:45:00',1.24),('3355','2014-02-11','10:50:00',1.27),('3355','2014-02-11','10:55:00',1.12),('3355','2014-02-11','11:00:00',1.25),('3355','2014-02-11','11:05:00',1.29),('3355','2014-02-11','11:10:00',1.08),('3355','2014-02-11','11:25:00',1.2),('3355','2014-02-11','11:30:00',1.45),('3355','2014-02-11','11:35:00',1.46),('3355','2014-02-11','11:40:00',1.04),('3355','2014-02-11','11:50:00',1.26),('3355','2014-02-11','12:25:00',1.31),('3355','2014-02-11','12:30:00',1.27),('3355','2014-02-11','12:35:00',1.07),('3355','2014-02-11','13:00:00',1),('3355','2014-02-11','13:05:00',1.25),('3355','2014-02-11','13:10:00',1.54),('3355','2014-02-11','13:15:00',1.51),('3355','2014-02-11','13:20:00',1.86),('3355','2014-02-11','13:25:00',1.7),('3355','2014-02-11','13:30:00',1.51),('3355','2014-02-11','13:35:00',1.43),('3355','2014-02-11','13:40:00',1.72),('3355','2014-02-11','13:45:00',1.33),('3355','2014-02-11','14:00:00',1.08),('3355','2014-02-11','14:05:00',1.15),('3355','2014-02-11','14:15:00',1.09),('3355','2014-02-09','12:45:00',1.22),('3355','2014-02-09','13:00:00',1.6),('3355','2014-02-09','13:05:00',1.45),('3355','2014-02-09','13:10:00',1.42),('3355','2014-02-09','13:40:00',1.02),('3355','2014-02-09','13:45:00',1.89),('3355','2014-02-09','13:50:00',1.09),('3355','2014-02-09','13:55:00',1.62),('3355','2014-02-09','14:00:00',1.02),('3355','2014-02-09','14:05:00',1.55),('3355','2014-02-09','14:10:00',1.32),('3355','2014-02-09','14:30:00',1.55),('3355','2014-02-09','14:35:00',1.24),('3355','2014-02-09','14:50:00',1.11),('3355','2014-02-09','15:15:00',1.02),('3355','2014-02-09','15:20:00',1.13),('3355','2014-02-09','15:25:00',1.15),('3355','2014-02-08','10:20:00',1.01),('3355','2014-02-08','10:35:00',1.54),('3355','2014-02-08','10:40:00',1.01),('3355','2014-02-08','10:50:00',1.11),('3355','2014-02-08','10:55:00',1.74),('3355','2014-02-08','11:00:00',1.08),('3355','2014-02-08','11:05:00',1.9),('3355','2014-02-08','11:10:00',1.56),('3355','2014-02-08','11:20:00',1.03),('3355','2014-02-08','11:35:00',2.01),('3355','2014-02-08','11:40:00',1.62),('3355','2014-02-08','11:55:00',2.18),('3355','2014-02-08','12:00:00',1.49),('3355','2014-02-08','12:15:00',2.31),('3355','2014-02-08','12:30:00',2.28),('3355','2014-02-08','12:35:00',1.38),('3355','2014-02-08','12:40:00',1.48),('3355','2014-02-08','12:45:00',1.42),('3355','2014-02-08','12:50:00',2.06),('3355','2014-02-08','12:55:00',2.04),('3355','2014-02-08','13:00:00',1.06),('3355','2014-02-08','13:15:00',2.38),('3355','2014-02-08','13:20:00',2.38),('3355','2014-02-08','13:25:00',2.01),('3355','2014-02-08','13:30:00',2.01),('3355','2014-02-08','13:35:00',1.01),('3355','2014-02-08','13:40:00',1.73),('3355','2014-02-08','13:45:00',2.09),('3355','2014-02-08','13:50:00',1.88),('3355','2014-02-08','13:55:00',1.82),('3355','2014-02-08','14:00:00',1.89),('3355','2014-02-08','14:05:00',1.89),('3355','2014-02-08','14:10:00',1.31),('3355','2014-02-08','14:20:00',1.52),('3355','2014-02-08','14:25:00',1.03),('3355','2014-02-08','14:30:00',1.92),('3355','2014-02-08','14:35:00',1.12),('3355','2014-02-08','14:40:00',1.54),('3355','2014-02-08','14:55:00',1.58),('3355','2014-02-08','15:20:00',1.41),('3355','2014-02-08','15:45:00',1.19),('3355','2014-02-08','15:50:00',1.08),('3355','2014-02-07','09:20:00',1.04),('3355','2014-02-07','09:25:00',1.09),('3355','2014-02-07','09:30:00',1.13),('3355','2014-02-07','09:35:00',1.17),('3355','2014-02-07','09:40:00',1.22),('3355','2014-02-07','09:45:00',1.25),('3355','2014-02-07','09:50:00',1.29),('3355','2014-02-07','09:55:00',1.32),('3355','2014-02-07','10:00:00',1.35),('3355','2014-02-07','10:05:00',1.38),('3355','2014-02-07','10:10:00',1.41),('3355','2014-02-07','10:15:00',1.46),('3355','2014-02-07','10:20:00',1.5),('3355','2014-02-07','10:25:00',1.52),('3355','2014-02-07','10:30:00',1.58),('3355','2014-02-07','10:35:00',1.45),('3355','2014-02-07','10:40:00',1.65),('3355','2014-02-07','10:45:00',1.73),('3355','2014-02-07','10:50:00',1.37),('3355','2014-02-07','10:55:00',1.39),('3355','2014-02-07','11:00:00',1.59),('3355','2014-02-07','11:05:00',1.19),('3355','2014-02-07','11:10:00',1.21),('3355','2014-02-07','11:15:00',1.88),('3355','2014-02-07','11:20:00',1.97),('3355','2014-02-07','11:25:00',1.98),('3355','2014-02-07','11:30:00',1.91),('3355','2014-02-07','11:35:00',1.88),('3355','2014-02-07','11:40:00',1.93),('3355','2014-02-07','11:45:00',2.02),('3355','2014-02-07','11:50:00',2.06),('3355','2014-02-07','11:55:00',1.98),('3355','2014-02-07','12:00:00',2.2),('3355','2014-02-07','12:05:00',1.98),('3355','2014-02-07','12:10:00',2.11),('3355','2014-02-07','12:15:00',1.16),('3355','2014-02-07','12:25:00',2.29),('3355','2014-02-07','12:30:00',1.58),('3355','2014-02-07','12:50:00',1.05),('3355','2014-02-07','12:55:00',1.76),('3355','2014-02-07','13:00:00',1.41),('3355','2014-02-07','13:05:00',1.66),('3355','2014-02-07','13:10:00',2.37),('3355','2014-02-07','13:15:00',2.27),('3355','2014-02-07','13:25:00',1.12),('3355','2014-02-07','13:30:00',1.39),('3355','2014-02-07','13:35:00',1.3),('3355','2014-02-07','13:45:00',1.52),('3355','2014-02-07','13:50:00',1.71),('3355','2014-02-07','13:55:00',1.79),('3355','2014-02-07','14:00:00',1.66),('3355','2014-02-07','14:05:00',1.95),('3355','2014-02-07','14:10:00',1.63),('3355','2014-02-07','14:15:00',1.23),('3355','2014-02-07','14:40:00',1.21),('3355','2014-02-07','14:45:00',1.5),('3355','2014-02-07','14:50:00',1.5),('3355','2014-02-07','14:55:00',1.51),('3355','2014-02-07','15:00:00',1.46),('3355','2014-02-07','15:05:00',1.44),('3355','2014-02-07','15:10:00',1.41),('3355','2014-02-07','15:15:00',1.33),('3355','2014-02-07','15:25:00',1.26),('3355','2014-02-07','15:30:00',1.21),('3355','2014-02-07','15:35:00',1.16),('3355','2014-02-07','15:40:00',1.12),('3355','2014-02-07','15:45:00',1.03),('3355','2014-02-06','09:00:00',1.05),('3355','2014-02-06','09:05:00',1.16),('3355','2014-02-06','09:30:00',1.03),('3355','2014-02-06','09:35:00',1.21),('3355','2014-02-06','09:40:00',1.25),('3355','2014-02-06','09:45:00',1.28),('3355','2014-02-06','09:50:00',1.32),('3355','2014-02-06','09:55:00',1.35),('3355','2014-02-06','10:00:00',1.38),('3355','2014-02-06','10:05:00',1.42),('3355','2014-02-06','10:10:00',1.46),('3355','2014-02-06','10:15:00',1.49),('3355','2014-02-06','10:20:00',1.52),('3355','2014-02-06','10:25:00',1.55),('3355','2014-02-06','10:30:00',1.6),('3355','2014-02-06','10:35:00',1.7),('3355','2014-02-06','10:40:00',1.25),('3355','2014-02-06','10:45:00',1.52),('3355','2014-02-06','10:55:00',1.12),('3355','2014-02-06','11:00:00',1.43),('3355','2014-02-06','11:25:00',1.98),('3355','2014-02-06','11:30:00',1.88),('3355','2014-02-06','11:35:00',1.95),('3355','2014-02-06','11:40:00',1.94),('3355','2014-02-06','11:45:00',1.95),('3355','2014-02-06','11:50:00',1.97),('3355','2014-02-06','11:55:00',1.97),('3355','2014-02-06','12:00:00',2),('3355','2014-02-06','12:05:00',2.05),('3355','2014-02-06','12:10:00',2.05),('3355','2014-02-06','12:15:00',1.99),('3355','2014-02-06','12:20:00',2.01),('3355','2014-02-06','12:25:00',2.01),('3355','2014-02-06','12:30:00',2.02),('3355','2014-02-06','12:35:00',1.84),('3355','2014-02-06','12:40:00',1.98),('3355','2014-02-06','12:45:00',1.79),('3355','2014-02-06','12:50:00',1.99),('3355','2014-02-06','12:55:00',1.99),('3355','2014-02-06','13:00:00',1.99),('3355','2014-02-06','13:05:00',1.46),('3355','2014-02-06','13:10:00',2.06),('3355','2014-02-06','13:15:00',2.04),('3355','2014-02-06','13:20:00',2.07),('3355','2014-02-06','13:25:00',1.88),('3355','2014-02-06','13:30:00',1.45),('3355','2014-02-06','13:35:00',1.93),('3355','2014-02-06','13:40:00',1.93),('3355','2014-02-06','13:45:00',1.9),('3355','2014-02-06','13:50:00',1.92),('3355','2014-02-06','13:55:00',1.63),('3355','2014-02-06','14:00:00',1.85),('3355','2014-02-06','14:05:00',1.69),('3355','2014-02-06','14:10:00',1.78),('3355','2014-02-06','14:15:00',1.75),('3355','2014-02-06','14:20:00',1.72),('3355','2014-02-06','14:25:00',1.72),('3355','2014-02-06','14:30:00',1.18),('3355','2014-02-06','14:40:00',1.53),('3355','2014-02-06','14:45:00',1.18),('3355','2014-02-06','14:50:00',1.01),('3355','2014-02-06','14:55:00',1.56),('3355','2014-02-06','15:00:00',1.48),('3355','2014-02-06','15:05:00',1.42),('3355','2014-02-06','15:10:00',1.38),('3355','2014-02-06','15:15:00',1.37),('3355','2014-02-06','15:20:00',1.35),('3355','2014-02-06','15:25:00',1.24),('3355','2014-02-06','15:30:00',1.18),('3355','2014-02-06','15:35:00',1.14),('3355','2014-02-06','15:40:00',1.02),('3355','2014-02-06','15:45:00',1.01),('3355','2014-04-27','11:45:00',1.77),('3355','2014-04-27','11:50:00',1.45),('3355','2014-04-27','11:55:00',1.32),('3355','2014-04-27','12:00:00',1.38),('3355','2014-04-27','12:05:00',1.47),('3355','2014-04-27','12:10:00',1.77),('3355','2014-04-27','12:15:00',1.65),('3355','2014-04-27','12:20:00',1.41),('3355','2014-04-27','12:25:00',1.53),('3355','2014-04-27','12:30:00',1.41),('3355','2014-04-27','12:35:00',1.44),('3355','2014-04-27','12:40:00',1.29),('3355','2014-04-27','12:45:00',1.45),('3355','2014-04-27','12:50:00',1.17),('3355','2014-04-27','13:00:00',1.07),('3355','2014-04-27','13:05:00',1.12),('3355','2014-04-27','13:20:00',1.32),('3355','2014-04-27','13:25:00',1.25),('3355','2014-04-27','13:30:00',1.11),('3355','2014-04-27','14:05:00',1.34),('3355','2014-04-27','14:25:00',1.21),('3355','2014-04-27','14:30:00',1.29),('3355','2014-04-27','14:35:00',1.23),('3355','2014-04-27','14:40:00',1.24),('3355','2014-04-27','14:45:00',1.08),('3355','2014-04-27','14:50:00',1.02),('3355','2014-04-27','14:55:00',1.1),('3355','2014-04-27','15:00:00',1.17),('3355','2014-04-27','15:05:00',1.68),('3355','2014-04-27','15:10:00',2.37),('3355','2014-04-27','15:15:00',1.75),('3355','2014-04-27','15:20:00',1.05),('3355','2014-02-05','10:20:00',1.59),('3355','2014-02-05','10:25:00',1.65),('3355','2014-02-05','11:15:00',1.45),('3355','2014-02-05','11:20:00',1.74),('3355','2014-02-05','11:25:00',1.52),('3355','2014-02-05','13:25:00',1.01),('3355','2014-02-05','13:30:00',1.01),('3355','2014-02-05','13:35:00',1.19),('3355','2014-02-05','13:40:00',1.14),('3355','2014-02-05','13:45:00',1.19),('3355','2014-02-05','14:35:00',1.07),('3355','2014-02-04','09:25:00',1.37),('3355','2014-02-04','09:30:00',1.31),('3355','2014-02-04','09:35:00',1.48),('3355','2014-02-04','09:40:00',1.33),('3355','2014-02-04','09:45:00',1.27),('3355','2014-02-04','09:50:00',1.06),('3355','2014-02-04','09:55:00',1.29),('3355','2014-02-04','10:00:00',1.46),('3355','2014-02-04','10:05:00',1.2),('3355','2014-02-04','10:15:00',1.18),('3355','2014-02-04','10:50:00',1.36),('3355','2014-02-04','10:55:00',1.57),('3355','2014-02-04','11:55:00',2.01),('3355','2014-02-04','12:00:00',2.22),('3355','2014-02-01','11:20:00',1.06),('3355','2014-02-01','11:30:00',1.28),('3355','2014-02-01','11:35:00',1.16),('3355','2014-02-01','11:55:00',1.1),('3355','2014-02-01','12:10:00',1.21),('3355','2014-02-01','12:20:00',1.34),('3355','2014-02-01','12:40:00',1.1),('3355','2014-02-01','12:45:00',1.39),('3355','2014-02-01','12:50:00',1.18),('3355','2014-01-30','09:55:00',1.19),('3355','2014-01-30','10:00:00',1.13),('3355','2014-01-30','10:10:00',1.08),('3355','2014-01-30','10:15:00',1.33),('3355','2014-01-30','10:20:00',1.16),('3355','2014-01-30','10:25:00',1.33),('3355','2014-01-30','10:30:00',1.44),('3355','2014-01-30','10:35:00',1.45),('3355','2014-01-30','10:40:00',1.44),('3355','2014-01-30','10:45:00',1.31),('3355','2014-01-30','10:50:00',1.61),('3355','2014-01-30','10:55:00',1.9),('3355','2014-01-30','11:00:00',1.83),('3355','2014-01-30','11:05:00',1.74),('3355','2014-01-30','11:10:00',1.73),('3355','2014-01-30','11:15:00',1.67),('3355','2014-01-30','11:20:00',1.56),('3355','2014-01-30','11:25:00',1.68),('3355','2014-01-30','11:30:00',1.42),('3355','2014-01-30','11:35:00',1.34),('3355','2014-01-30','11:45:00',1.55),('3355','2014-01-30','11:55:00',1.94),('3355','2014-01-30','12:05:00',1.54),('3355','2014-01-30','12:20:00',1.66),('3355','2014-01-30','12:25:00',1.55),('3355','2014-01-30','12:30:00',1.18),('3355','2014-01-30','12:35:00',1.43),('3355','2014-01-30','12:40:00',1.27),('3355','2014-01-30','12:45:00',1.77),('3355','2014-01-30','12:50:00',1.43),('3355','2014-01-30','12:55:00',1.57),('3355','2014-01-30','13:05:00',1.54),('3355','2014-01-30','13:10:00',1.09),('3355','2014-01-30','13:15:00',1.57),('3355','2014-01-30','13:20:00',1.23),('3355','2014-01-30','13:25:00',1.81),('3355','2014-01-30','13:30:00',1.52),('3355','2014-01-30','13:35:00',1.34),('3355','2014-01-30','13:40:00',1.55),('3355','2014-01-30','13:45:00',1.78),('3355','2014-01-30','13:50:00',1.66),('3355','2014-01-30','13:55:00',1.54),('3355','2014-01-30','14:00:00',1.51),('3355','2014-01-30','14:05:00',1.45),('3355','2014-01-30','14:10:00',1.42),('3355','2014-01-30','14:15:00',1.22),('3355','2014-01-30','14:20:00',1.08),('3355','2014-01-30','14:25:00',1.16),('3355','2014-01-30','14:30:00',1.25),('3355','2014-01-30','14:35:00',1.21),('3355','2014-01-30','14:40:00',1.37),('3355','2014-01-30','14:45:00',1.31),('3355','2014-01-30','14:50:00',1.37),('3355','2014-01-30','14:55:00',1.32),('3355','2014-01-30','15:00:00',1.3),('3355','2014-01-30','15:05:00',1.27),('3355','2014-01-30','15:10:00',1.21),('3355','2014-01-30','15:15:00',1.1),('3355','2014-01-30','15:20:00',1.15),('3355','2014-01-30','15:25:00',1.09),('3355','2014-01-29','09:35:00',1.03),('3355','2014-01-29','09:45:00',1.09),('3355','2014-01-29','10:25:00',1.45),('3355','2014-01-29','10:30:00',1.55),('3355','2014-01-29','10:35:00',1.23),('3355','2014-01-29','10:40:00',1.13),('3355','2014-01-29','10:45:00',1.1),('3355','2014-01-29','10:50:00',1.03),('3355','2014-01-29','11:05:00',1.14),('3355','2014-01-29','11:10:00',1.03),('3355','2014-01-29','11:15:00',1.04),('3355','2014-01-29','11:20:00',1.09),('3355','2014-01-29','11:25:00',1.02),('3355','2014-01-29','11:30:00',1.49),('3355','2014-01-29','11:35:00',1.5),('3355','2014-01-29','11:40:00',1.41),('3355','2014-01-29','12:50:00',1.54),('3355','2014-01-29','12:55:00',1.98),('3355','2014-01-29','13:00:00',1.73),('3355','2014-01-29','13:40:00',1.3),('3355','2014-01-29','13:50:00',1.17),('3355','2014-01-29','13:55:00',1.39),('3355','2014-01-28','09:50:00',1.09),('3355','2014-01-28','09:55:00',1.16),('3355','2014-01-28','10:00:00',1.28),('3355','2014-01-28','10:05:00',1.27),('3355','2014-01-28','10:10:00',1.27),('3355','2014-01-28','10:15:00',1.28),('3355','2014-01-28','10:20:00',1.33),('3355','2014-01-28','10:25:00',1.44),('3355','2014-01-28','10:30:00',1.45),('3355','2014-01-28','10:35:00',1.51),('3355','2014-01-28','10:40:00',1.54),('3355','2014-01-28','10:45:00',1.33),('3355','2014-01-28','10:50:00',1.56),('3355','2014-01-28','10:55:00',1.52),('3355','2014-01-28','11:00:00',1.46),('3355','2014-01-28','11:05:00',1.73),('3355','2014-01-28','11:15:00',1.19),('3355','2014-01-28','11:30:00',1.25),('3355','2014-01-28','11:35:00',1.26),('3355','2014-01-28','11:40:00',1.87),('3355','2014-01-28','11:45:00',1.53),('3355','2014-01-28','12:05:00',1.89),('3355','2014-01-28','12:10:00',1.33),('3355','2014-01-28','12:15:00',1.69),('3355','2014-01-28','12:20:00',1.2),('3355','2014-01-28','12:40:00',1.06),('3355','2014-01-28','12:50:00',1.83),('3355','2014-01-28','12:55:00',1.71),('3355','2014-01-28','13:00:00',1.79),('3355','2014-01-28','13:05:00',2.2),('3355','2014-01-28','13:10:00',1.49),('3355','2014-01-28','13:15:00',1.54),('3355','2014-01-28','13:20:00',1.6),('3355','2014-01-28','13:25:00',1.75),('3355','2014-01-28','13:30:00',1.77),('3355','2014-01-28','13:35:00',1.96),('3355','2014-01-28','13:40:00',1.89),('3355','2014-01-28','13:45:00',1.84),('3355','2014-01-28','13:50:00',1.8),('3355','2014-01-28','13:55:00',1.77),('3355','2014-01-28','14:00:00',1.76),('3355','2014-01-28','14:05:00',1.71),('3355','2014-01-28','14:10:00',1.68),('3355','2014-01-28','14:15:00',1.66),('3355','2014-01-28','14:20:00',1.62),('3355','2014-01-28','14:25:00',1.65),('3355','2014-01-28','14:30:00',1.55),('3355','2014-01-28','14:35:00',1.45),('3355','2014-01-28','14:40:00',1.37),('3355','2014-01-28','14:45:00',1.49),('3355','2014-01-28','14:50:00',1.15),('3355','2014-01-28','14:55:00',1.39),('3355','2014-01-28','15:00:00',1.35),('3355','2014-01-28','15:05:00',1.31),('3355','2014-01-28','15:10:00',1.26),('3355','2014-01-28','15:15:00',1.17),('3355','2014-01-28','15:20:00',1.11),('3355','2014-01-28','15:25:00',1.01),('5815','2014-05-04','08:35:00',1.04),('5815','2014-05-04','08:40:00',1.1),('5815','2014-05-04','08:45:00',1.15),('5815','2014-05-04','08:50:00',1.2),('5815','2014-05-04','08:55:00',1.26),('5815','2014-05-04','09:00:00',1.3),('5815','2014-05-04','09:05:00',1.34),('5815','2014-05-04','09:10:00',1.38),('5815','2014-05-04','09:15:00',1.44),('5815','2014-05-04','09:20:00',1.47),('5815','2014-05-04','09:25:00',1.55),('5815','2014-05-04','09:30:00',1.6),('5815','2014-05-04','09:35:00',1.65),('5815','2014-05-04','09:40:00',1.69),('5815','2014-05-04','09:45:00',1.73),('5815','2014-05-04','09:50:00',1.78),('5815','2014-05-04','09:55:00',1.83),('5815','2014-05-04','10:00:00',1.87),('5815','2014-05-04','10:05:00',1.91),('5815','2014-05-04','10:10:00',1.95),('5815','2014-05-04','10:15:00',1.97),('5815','2014-05-04','10:20:00',1.98),('5815','2014-05-04','10:25:00',2.02),('5815','2014-05-04','10:30:00',2.06),('5815','2014-05-04','10:35:00',2.12),('5815','2014-05-04','10:40:00',2.13),('5815','2014-05-04','10:45:00',2.15),('5815','2014-05-04','10:50:00',2.18),('5815','2014-05-04','10:55:00',2.18),('5815','2014-05-04','11:00:00',2.15),('5815','2014-05-04','11:05:00',2.19),('5815','2014-05-04','11:10:00',2.23),('5815','2014-05-04','11:15:00',2.24),('5815','2014-05-04','11:20:00',2.25),('5815','2014-05-04','11:25:00',2.25),('5815','2014-05-04','11:30:00',2.28),('5815','2014-05-04','11:35:00',2.3),('5815','2014-05-04','11:40:00',2.35),('5815','2014-05-04','11:45:00',2.34),('5815','2014-05-04','11:50:00',2.39),('5815','2014-05-04','11:55:00',2.51),('5815','2014-05-04','12:00:00',1.81),('5815','2014-05-04','12:05:00',1.34),('5815','2014-05-04','12:10:00',1.73),('5815','2014-05-04','12:15:00',1.48),('5815','2014-05-04','12:20:00',1.36),('5815','2014-05-04','12:25:00',2.15),('5815','2014-05-04','12:30:00',2.32),('5815','2014-05-04','12:35:00',1.08),('5815','2014-05-04','12:40:00',1.07),('5815','2014-05-04','12:45:00',2.89),('5815','2014-05-04','12:50:00',1.98),('5815','2014-05-04','12:55:00',1.55),('5815','2014-05-04','13:00:00',1.53),('5815','2014-05-04','13:05:00',2.64),('5815','2014-05-04','13:10:00',2.68),('5815','2014-05-04','13:15:00',2.63),('5815','2014-05-04','13:20:00',2.55),('5815','2014-05-04','13:25:00',2.54),('5815','2014-05-04','13:30:00',2.54),('5815','2014-05-04','13:35:00',2.53),('5815','2014-05-04','13:40:00',2.52),('5815','2014-05-04','13:45:00',2.52),('5815','2014-05-04','13:50:00',2.52),('5815','2014-05-04','13:55:00',2.53),('5815','2014-05-04','14:00:00',2.53),('5815','2014-05-04','14:05:00',2.61),('5815','2014-05-04','14:10:00',2.64),('5815','2014-05-04','14:15:00',2.63),('5815','2014-05-04','14:20:00',2.82),('5815','2014-05-04','14:25:00',2.45),('5815','2014-05-04','14:30:00',1.31),('5815','2014-05-04','15:25:00',1.8),('5815','2014-05-04','15:30:00',2.48),('5815','2014-05-04','15:35:00',1.55),('5815','2014-05-04','15:40:00',1.99),('5815','2014-05-04','16:05:00',1.37),('5815','2014-05-04','16:40:00',1.15),('5815','2014-05-04','16:45:00',1.05),('5815','2014-05-04','16:55:00',1.29),('5815','2014-05-04','17:00:00',1.54),('5815','2014-05-04','17:05:00',1.41),('5815','2014-05-04','17:10:00',1.4),('5815','2014-05-04','17:15:00',1.37),('5815','2014-05-04','17:20:00',1.31),('5815','2014-05-04','17:25:00',1.23),('5815','2014-05-04','17:30:00',1.14),('5815','2014-05-04','17:35:00',1.09),('5815','2014-05-04','17:40:00',1.03),('5815','2014-04-25','10:30:00',1.2),('5815','2014-04-25','10:35:00',1.11),('5815','2014-04-25','10:40:00',1.04),('5815','2014-04-25','10:45:00',1.12),('5815','2014-04-25','10:50:00',1.35),('5815','2014-04-25','10:55:00',1.87),('5815','2014-04-25','11:00:00',2.08),('5815','2014-04-25','11:05:00',1.86),('5815','2014-04-25','11:10:00',1.96),('5815','2014-04-25','11:15:00',1.86),('5815','2014-04-25','11:20:00',1.81),('5815','2014-04-25','11:25:00',1.8),('5815','2014-04-25','11:30:00',1.81),('5815','2014-04-25','11:35:00',1.77),('5815','2014-04-25','11:40:00',1.73),('5815','2014-04-25','11:45:00',1.88),('5815','2014-04-25','11:50:00',1.88),('5815','2014-04-25','11:55:00',1.58),('5815','2014-04-25','12:00:00',1.86),('5815','2014-04-25','12:05:00',1.86),('5815','2014-04-25','12:10:00',1.88),('5815','2014-04-25','12:15:00',1.69),('5815','2014-04-25','12:20:00',1.62),('5815','2014-04-25','12:25:00',1.1),('5815','2014-04-25','12:30:00',1.44),('5815','2014-04-25','12:35:00',1.98),('5815','2014-04-25','12:40:00',1.83),('5815','2014-04-25','12:45:00',2),('5815','2014-04-25','12:50:00',2.44),('5815','2014-04-25','12:55:00',2.54),('5815','2014-04-25','13:00:00',2.37),('5815','2014-04-25','13:05:00',1.99),('5815','2014-04-25','13:10:00',1.8),('5815','2014-04-25','13:15:00',2.58),('5815','2014-04-25','13:20:00',2.1),('5815','2014-04-25','13:25:00',1.33),('5815','2014-04-25','13:35:00',1.87),('5815','2014-04-25','13:40:00',2.61),('5815','2014-04-25','13:45:00',2.48),('5815','2014-04-25','13:50:00',2.45),('5815','2014-04-25','13:55:00',2.63),('5815','2014-04-25','14:00:00',1.76),('5815','2014-04-25','14:10:00',2.29),('5815','2014-04-25','14:35:00',1.38),('5815','2014-04-25','14:40:00',1.31),('5815','2014-04-24','08:50:00',1.05),('5815','2014-04-24','08:55:00',1.11),('5815','2014-04-24','09:00:00',1.23),('5815','2014-04-24','09:05:00',1.17),('5815','2014-04-24','09:10:00',1.38),('5815','2014-04-24','09:15:00',1.35),('5815','2014-04-24','10:35:00',1.39),('5815','2014-04-24','10:40:00',2.23),('5815','2014-04-24','10:45:00',2.28),('5815','2014-04-24','10:50:00',2.06),('5815','2014-04-24','10:55:00',1.44),('5815','2014-04-24','11:00:00',2.11),('5815','2014-04-24','11:05:00',1.43),('5815','2014-04-24','11:15:00',1.03),('5815','2014-04-24','11:20:00',2.41),('5815','2014-04-24','11:25:00',2.08),('5815','2014-04-24','11:35:00',2.44),('5815','2014-04-24','11:40:00',1.51),('5815','2014-04-24','11:45:00',1.23),('5815','2014-04-24','12:00:00',1.05),('5815','2014-04-24','12:15:00',1.62),('5815','2014-04-24','12:20:00',2.59),('5815','2014-04-24','12:25:00',1.81),('5815','2014-04-24','12:30:00',1.42),('5815','2014-04-24','12:35:00',2.24),('5815','2014-04-24','12:40:00',2.41),('5815','2014-04-24','12:45:00',2.36),('5815','2014-04-24','12:50:00',1.63),('5815','2014-04-24','12:55:00',1.37),('5815','2014-04-24','13:05:00',1.7),('5815','2014-04-24','13:15:00',1.49),('5815','2014-04-24','13:20:00',1.29),('5815','2014-04-24','13:25:00',1.26),('5815','2014-04-24','13:30:00',1.27),('5815','2014-04-24','13:40:00',1.74),('5815','2014-04-24','13:45:00',1.29),('5815','2014-04-24','14:20:00',1.77),('5815','2014-04-24','14:25:00',1.76),('5815','2014-04-24','14:30:00',2.2),('5815','2014-04-24','14:35:00',2.43),('5815','2014-04-24','14:40:00',2.42),('5815','2014-04-24','14:45:00',2.41),('5815','2014-04-24','14:50:00',2.4),('5815','2014-04-24','14:55:00',2.32),('5815','2014-04-24','15:00:00',2.31),('5815','2014-04-24','15:05:00',2.27),('5815','2014-04-24','15:10:00',2.23),('5815','2014-04-24','15:15:00',2.22),('5815','2014-04-24','15:20:00',2.13),('5815','2014-04-24','15:25:00',2.12),('5815','2014-04-24','15:30:00',2.06),('5815','2014-04-24','15:35:00',2.06),('5815','2014-04-24','15:40:00',2.07),('5815','2014-04-24','15:45:00',2),('5815','2014-04-24','15:50:00',1.97),('5815','2014-04-24','15:55:00',1.96),('5815','2014-04-24','16:00:00',1.95),('5815','2014-04-24','16:05:00',1.85),('5815','2014-04-24','16:10:00',1.82),('5815','2014-04-24','16:15:00',1.74),('5815','2014-04-24','16:20:00',1.61),('5815','2014-04-24','16:25:00',1.6),('5815','2014-04-24','16:30:00',1.68),('5815','2014-04-24','16:35:00',1.66),('5815','2014-04-24','16:40:00',1.67),('5815','2014-04-24','16:45:00',1.61),('5815','2014-04-24','16:50:00',1.5),('5815','2014-04-24','16:55:00',1.3),('5815','2014-04-24','17:00:00',1.14),('5815','2014-04-24','17:05:00',1.31),('5815','2014-04-24','17:10:00',1.19),('5815','2014-04-24','17:15:00',1.12),('5815','2014-01-11','11:10:00',1.14),('5815','2014-01-11','11:15:00',1.01),('5815','2014-01-11','11:20:00',1.01),('5815','2014-01-11','11:30:00',1),('5815','2014-01-11','11:45:00',1.2),('5815','2014-01-11','11:50:00',1.22),('5815','2014-01-11','11:55:00',1.2),('5815','2014-01-10','10:00:00',1.15),('5815','2014-01-10','10:25:00',1.22),('5815','2014-01-10','10:30:00',1.17),('5815','2014-01-10','10:35:00',1.22),('5815','2014-01-10','10:40:00',1.51),('5815','2014-01-10','10:45:00',1.61),('5815','2014-01-10','10:50:00',1.64),('5815','2014-01-10','10:55:00',1.62),('5815','2014-01-10','11:00:00',1.58),('5815','2014-01-10','11:05:00',1.53),('5815','2014-01-10','11:10:00',1.63),('5815','2014-01-10','11:15:00',1.52),('5815','2014-01-10','11:20:00',1.37),('5815','2014-01-10','11:25:00',1.36),('5815','2014-01-10','11:30:00',1.38),('5815','2014-01-10','11:35:00',1.26),('5815','2014-01-10','11:40:00',1.14),('5815','2014-01-10','11:45:00',1.17),('5815','2014-01-10','11:50:00',1.26),('5815','2014-01-10','11:55:00',1.25),('5815','2014-01-10','12:00:00',1.26),('5815','2014-01-10','12:05:00',1.4),('5815','2014-01-10','12:10:00',1.32),('5815','2014-01-10','12:15:00',1.36),('5815','2014-01-10','12:20:00',1.29),('5815','2014-01-10','12:25:00',1.19),('5815','2014-01-10','12:30:00',1.06),('5815','2014-01-10','12:50:00',1.18),('5815','2014-01-10','12:55:00',1.42),('5815','2014-01-10','13:00:00',1.41),('5815','2014-01-10','13:05:00',1.28),('5815','2014-01-10','13:10:00',1.29),('5815','2014-01-10','13:15:00',1.49),('5815','2014-01-10','13:20:00',1.28),('5815','2014-01-10','13:25:00',1.01),('5815','2014-01-08','09:35:00',1.05),('5815','2014-01-08','09:40:00',1),('5815','2014-01-08','09:45:00',1.12),('5815','2014-01-08','09:50:00',1.24),('5815','2014-01-08','09:55:00',1.24),('5815','2014-01-08','10:00:00',1.26),('5815','2014-01-08','10:05:00',1.26),('5815','2014-01-08','10:10:00',1.02),('5815','2014-01-08','10:15:00',1.11),('5815','2014-01-08','10:20:00',1.14),('5815','2014-01-08','10:25:00',1.18),('5815','2014-01-08','10:30:00',1.24),('5815','2014-01-08','10:35:00',1.23),('5815','2014-01-08','10:40:00',1.25),('5815','2014-01-08','10:45:00',1.27),('5815','2014-01-08','10:50:00',1.35),('5815','2014-01-07','09:30:00',1.01),('5815','2014-01-07','09:35:00',1.04),('5815','2014-01-07','09:40:00',1.14),('5815','2014-01-07','09:45:00',1.18),('5815','2014-01-07','09:50:00',1.19),('5815','2014-01-07','09:55:00',1.24),('5815','2014-01-07','10:00:00',1.27),('5815','2014-01-07','10:05:00',1.26),('5815','2014-01-07','10:10:00',1.26),('5815','2014-01-07','10:15:00',1.31),('5815','2014-01-07','10:20:00',1.41),('5815','2014-01-07','10:25:00',1.47),('5815','2014-01-07','10:30:00',1.47),('5815','2014-01-07','10:35:00',1.39),('5815','2014-01-07','10:40:00',1.39),('5815','2014-01-07','10:45:00',1.53),('5815','2014-01-07','10:50:00',1.6),('5815','2014-01-07','10:55:00',1.63),('5815','2014-01-07','11:00:00',1.64),('5815','2014-01-07','11:05:00',1.65),('5815','2014-01-07','11:10:00',1.68),('5815','2014-01-07','11:15:00',1.7),('5815','2014-01-07','11:20:00',1.7),('5815','2014-01-07','11:25:00',1.71),('5815','2014-01-07','11:30:00',1.72),('5815','2014-01-07','11:35:00',1.77),('5815','2014-01-07','11:40:00',1.79),('5815','2014-01-07','11:45:00',1.75),('5815','2014-01-07','11:50:00',1.76),('5815','2014-01-07','11:55:00',1.74),('5815','2014-01-07','12:00:00',1.74),('5815','2014-01-07','12:05:00',1.75),('5815','2014-01-07','12:10:00',1.73),('5815','2014-01-07','12:15:00',1.76),('5815','2014-01-07','12:20:00',1.76),('5815','2014-01-07','12:25:00',1.74),('5815','2014-01-07','12:30:00',1.75),('5815','2014-01-07','12:35:00',1.73),('5815','2014-01-07','12:40:00',1.69),('5815','2014-01-07','12:45:00',1.62),('5815','2014-01-07','12:50:00',1.6),('5815','2014-01-07','12:55:00',1.61),('5815','2014-01-07','13:00:00',1.65),('5815','2014-01-07','13:05:00',1.66),('5815','2014-01-07','13:10:00',1.62),('5815','2014-01-07','13:15:00',1.61),('5815','2014-01-07','13:20:00',1.59),('5815','2014-01-07','13:25:00',1.59),('5815','2014-01-07','13:30:00',1.53),('5815','2014-01-07','13:35:00',1.52),('5815','2014-01-07','13:40:00',1.49),('5815','2014-01-07','13:45:00',1.49),('5815','2014-01-07','13:50:00',1.42),('5815','2014-01-07','13:55:00',1.41),('5815','2014-01-07','14:00:00',1.39),('5815','2014-01-07','14:05:00',1.4),('5815','2014-01-07','14:10:00',1.37),('5815','2014-01-07','14:15:00',1.36),('5815','2014-01-07','14:20:00',1.35),('5815','2014-01-07','14:25:00',1.34),('5815','2014-01-07','14:30:00',1.33),('5815','2014-01-07','14:35:00',1.32),('5815','2014-01-07','14:40:00',1.2),('5815','2014-01-07','14:45:00',1.17),('5815','2014-01-07','14:50:00',1.15),('5815','2014-04-23','08:45:00',1.02),('5815','2014-04-23','08:50:00',1.06),('5815','2014-04-23','08:55:00',1.12),('5815','2014-04-23','09:00:00',1.17),('5815','2014-04-23','09:05:00',1.22),('5815','2014-04-23','09:10:00',1.26),('5815','2014-04-23','09:15:00',1.31),('5815','2014-04-23','09:20:00',1.35),('5815','2014-04-23','09:25:00',1.4),('5815','2014-04-23','09:30:00',1.45),('5815','2014-04-23','09:35:00',1.5),('5815','2014-04-23','09:40:00',1.54),('5815','2014-04-23','09:45:00',1.59),('5815','2014-04-23','09:50:00',1.63),('5815','2014-04-23','09:55:00',1.66),('5815','2014-04-23','10:00:00',1.69),('5815','2014-04-23','10:05:00',1.74),('5815','2014-04-23','10:10:00',1.77),('5815','2014-04-23','10:15:00',1.82),('5815','2014-04-23','10:20:00',1.84),('5815','2014-04-23','10:25:00',1.86),('5815','2014-04-23','10:30:00',1.9),('5815','2014-04-23','10:35:00',1.92),('5815','2014-04-23','10:40:00',1.96),('5815','2014-04-23','10:45:00',1.99),('5815','2014-04-23','10:50:00',2.01),('5815','2014-04-23','10:55:00',2.04),('5815','2014-04-23','11:00:00',2.09),('5815','2014-04-23','11:05:00',2.14),('5815','2014-04-23','11:10:00',2.14),('5815','2014-04-23','11:15:00',2.16),('5815','2014-04-23','11:20:00',2.16),('5815','2014-04-23','11:25:00',2.17),('5815','2014-04-23','11:30:00',2.19),('5815','2014-04-23','11:35:00',2.2),('5815','2014-04-23','11:40:00',2.23),('5815','2014-04-23','11:45:00',2.22),('5815','2014-04-23','11:50:00',2.25),('5815','2014-04-23','11:55:00',2.28),('5815','2014-04-23','12:00:00',2.28),('5815','2014-04-23','12:05:00',2.32),('5815','2014-04-23','12:10:00',2.36),('5815','2014-04-23','12:15:00',2.44),('5815','2014-04-23','12:20:00',2.42),('5815','2014-04-23','12:25:00',2.36),('5815','2014-04-23','12:30:00',2.44),('5815','2014-04-23','12:35:00',2.43),('5815','2014-04-23','12:40:00',2.43),('5815','2014-04-23','12:45:00',2.45),('5815','2014-04-23','12:50:00',2.47),('5815','2014-04-23','12:55:00',2.38),('5815','2014-04-23','13:00:00',2.34),('5815','2014-04-23','13:05:00',2.4),('5815','2014-04-23','13:10:00',2.5),('5815','2014-04-23','13:15:00',2.52),('5815','2014-04-23','13:20:00',2.54),('5815','2014-04-23','13:25:00',2.49),('5815','2014-04-23','13:30:00',2.51),('5815','2014-04-23','13:35:00',2.49),('5815','2014-04-23','13:45:00',2.5),('5815','2014-04-23','13:55:00',1.3),('5815','2014-04-23','14:00:00',2.04),('5815','2014-04-23','14:05:00',1.04),('5815','2014-04-23','14:10:00',2.32),('5815','2014-04-23','14:15:00',1.5),('5815','2014-04-23','14:20:00',1.93),('5815','2014-04-23','14:25:00',1.85),('5815','2014-04-23','14:30:00',2.65),('5815','2014-04-23','14:35:00',2.59),('5815','2014-04-23','14:40:00',1.76),('5815','2014-04-23','14:45:00',2.14),('5815','2014-04-23','14:55:00',2.05),('5815','2014-04-23','15:00:00',2.77),('5815','2014-04-23','15:05:00',2.7),('5815','2014-04-23','15:10:00',2.32),('5815','2014-04-23','15:15:00',2.33),('5815','2014-04-23','15:20:00',1.42),('5815','2014-04-23','15:25:00',1.28),('5815','2014-04-23','15:30:00',1.45),('5815','2014-04-23','15:35:00',1.59),('5815','2014-04-23','15:40:00',1.26),('5815','2014-04-23','15:45:00',1.16),('5815','2014-04-23','15:50:00',1.51),('5815','2014-04-23','15:55:00',1.44),('5815','2014-04-23','16:00:00',2.22),('5815','2014-04-23','16:05:00',2.19),('5815','2014-04-23','16:10:00',1.67),('5815','2014-04-23','16:15:00',1.79),('5815','2014-04-23','16:20:00',1.77),('5815','2014-04-23','16:25:00',1.48),('5815','2014-04-23','16:30:00',1.9),('5815','2014-04-23','16:35:00',1.08),('5815','2014-04-23','16:40:00',1.14),('5815','2014-04-23','16:45:00',1.23),('5815','2014-04-23','16:55:00',1.02),('5815','2014-01-05','11:40:00',2.04),('5815','2014-01-05','11:45:00',1.87),('5815','2014-01-05','11:50:00',1.85),('5815','2014-01-05','11:55:00',1.79),('5815','2014-01-05','12:00:00',1.84),('5815','2014-01-05','12:05:00',1.89),('5815','2014-01-05','12:10:00',1.83),('5815','2014-01-05','12:15:00',1.81),('5815','2014-01-05','12:20:00',1.79),('5815','2014-01-05','12:25:00',1.81),('5815','2014-01-05','12:30:00',1.8),('5815','2014-01-05','12:35:00',1.79),('5815','2014-01-05','12:40:00',1.8),('5815','2014-01-05','12:45:00',1.79),('5815','2014-01-05','12:50:00',1.81),('5815','2014-01-05','12:55:00',1.78),('5815','2014-01-05','13:00:00',1.77),('5815','2014-01-05','13:05:00',1.74),('5815','2014-01-05','13:10:00',1.75),('5815','2014-01-05','13:15:00',1.8),('5815','2014-01-05','13:20:00',1.77),('5815','2014-01-05','13:25:00',1.76),('5815','2014-01-05','13:30:00',1.66),('5815','2014-01-05','13:35:00',1.64),('5815','2014-01-05','13:40:00',1.61),('5815','2014-01-05','13:45:00',1.59),('5815','2014-01-05','13:50:00',1.58),('5815','2014-01-05','13:55:00',1.54),('5815','2014-01-05','14:00:00',1.27),('5815','2014-01-05','14:20:00',1.59),('5815','2014-01-05','14:40:00',1.36),('5815','2014-01-05','14:45:00',1.49),('5815','2014-01-05','14:50:00',1.22),('5815','2014-01-05','15:05:00',1.08),('5815','2014-01-05','15:10:00',1.04),('5815','2014-01-02','09:30:00',1),('5815','2014-01-02','09:35:00',1.18),('5815','2014-01-02','09:40:00',1.35),('5815','2014-01-02','09:45:00',1.35),('5815','2014-01-02','10:00:00',1.02),('5815','2014-01-02','10:05:00',1.21),('5815','2014-01-02','10:20:00',1.42),('5815','2014-01-02','12:05:00',1.01),('5815','2014-01-02','12:10:00',1.07),('5815','2014-01-02','12:45:00',1.15),('5815','2014-01-02','12:55:00',1.36),('5815','2014-01-02','13:10:00',1.04),('5815','2014-01-02','13:35:00',1.04),('5815','2014-01-01','09:20:00',1.02),('5815','2014-01-01','09:25:00',1.06),('5815','2014-01-01','09:30:00',1.08),('5815','2014-01-01','09:35:00',1.13),('5815','2014-01-01','09:40:00',1.16),('5815','2014-01-01','09:45:00',1.2),('5815','2014-01-01','09:50:00',1.23),('5815','2014-01-01','09:55:00',1.26),('5815','2014-01-01','10:00:00',1.32),('5815','2014-01-01','10:05:00',1.39),('5815','2014-01-01','10:10:00',1.4),('5815','2014-01-01','10:15:00',1.39),('5815','2014-01-01','10:20:00',1.4),('5815','2014-01-01','10:25:00',1.47),('5815','2014-01-01','10:30:00',1.5),('5815','2014-01-01','10:35:00',1.53),('5815','2014-01-01','10:40:00',1.52),('5815','2014-01-01','10:45:00',1.55),('5815','2014-01-01','10:50:00',1.59),('5815','2014-01-01','10:55:00',1.66),('5815','2014-01-01','11:00:00',1.65),('5815','2014-01-01','11:05:00',1.66),('5815','2014-01-01','11:10:00',1.31),('5815','2014-01-01','11:40:00',1.01),('5815','2014-01-01','12:55:00',1.41),('5815','2014-01-01','13:00:00',1.12),('5815','2014-01-01','13:40:00',1.33),('5815','2013-12-31','09:10:00',1.14),('5815','2013-12-31','09:30:00',1.28),('5815','2013-12-31','09:40:00',1.01),('5815','2013-12-31','09:45:00',1.14),('5815','2013-12-31','09:50:00',1.45),('5815','2013-12-31','13:35:00',1.14),('5815','2013-12-31','13:40:00',2.04),('5815','2013-12-31','14:00:00',1.34),('5815','2013-12-31','15:10:00',1.14),('5815','2013-12-31','15:15:00',1.06),('5815','2013-12-30','09:20:00',1.1),('5815','2013-12-30','09:25:00',1.15),('5815','2013-12-30','09:30:00',1.25),('5815','2013-12-30','09:35:00',1.3),('5815','2013-12-30','09:40:00',1.3),('5815','2013-12-30','09:45:00',1.35),('5815','2013-12-30','09:50:00',1.22),('5815','2013-12-30','11:10:00',1.32),('5815','2013-12-30','11:15:00',1.51),('5815','2013-12-30','11:20:00',1.28),('5815','2013-12-30','11:25:00',1.46),('5815','2013-12-30','11:30:00',1.49),('5815','2013-12-30','11:40:00',1.68),('5815','2013-12-30','11:50:00',1.17),('5815','2013-12-30','11:55:00',1.93),('5815','2013-12-30','12:00:00',1.98),('5815','2013-12-30','12:05:00',1.94),('5815','2013-12-30','12:10:00',1.93),('5815','2013-12-30','12:15:00',1.92),('5815','2013-12-30','12:20:00',1.91),('5815','2013-12-30','12:25:00',1.89),('5815','2013-12-30','12:30:00',1.88),('5815','2013-12-30','12:35:00',1.82),('5815','2013-12-30','12:40:00',1.84),('5815','2013-12-30','12:45:00',1.84),('5815','2013-12-30','12:50:00',1.82),('5815','2013-12-30','12:55:00',1.81),('5815','2013-12-30','13:00:00',1.81),('5815','2013-12-30','13:05:00',1.8),('5815','2013-12-30','13:10:00',1.78),('5815','2013-12-30','13:15:00',1.76),('5815','2013-12-30','13:20:00',1.75),('5815','2013-12-30','13:25:00',1.74),('5815','2013-12-30','13:30:00',1.72),('5815','2013-12-30','13:35:00',1.69),('5815','2013-12-30','13:40:00',1.66),('5815','2013-12-30','13:45:00',1.64),('5815','2013-12-30','13:50:00',1.6),('5815','2013-12-30','13:55:00',1.57),('5815','2013-12-30','14:00:00',1.55),('5815','2013-12-30','14:05:00',1.52),('5815','2013-12-30','14:10:00',1.49),('5815','2013-12-30','14:15:00',1.46),('5815','2013-12-30','14:20:00',1.43),('5815','2013-12-30','14:25:00',1.4),('5815','2013-12-30','14:30:00',1.36),('5815','2013-12-30','14:35:00',1.31),('5815','2013-12-30','14:40:00',1.28),('5815','2013-12-30','14:45:00',1.23),('5815','2013-12-30','14:50:00',1.18),('5815','2013-12-30','14:55:00',1.14),('5815','2013-12-30','15:00:00',1.09),('5815','2013-12-30','15:05:00',1.05),('5815','2013-12-30','15:10:00',1),('5815','2013-12-28','09:20:00',1.1),('5815','2013-12-28','09:25:00',1.12),('5815','2013-12-28','09:30:00',1.17),('5815','2013-12-28','09:35:00',1.19),('5815','2013-12-28','09:40:00',1.26),('5815','2013-12-28','09:45:00',1.29),('5815','2013-12-28','09:50:00',1.24),('5815','2013-12-28','09:55:00',1.04),('5815','2013-12-28','10:00:00',1.12),('5815','2013-12-28','10:05:00',1.22),('5815','2013-12-28','10:15:00',1.49),('5815','2013-12-28','10:20:00',1.59),('5815','2013-12-28','10:25:00',1.36),('5815','2013-12-28','10:30:00',1.67),('5815','2013-12-28','10:35:00',1.79),('5815','2013-12-28','10:40:00',1.95),('5815','2013-12-27','09:15:00',1.02),('5815','2013-12-27','09:20:00',1.07),('5815','2013-12-27','09:25:00',1.13),('5815','2013-12-27','09:30:00',1.17),('5815','2013-12-27','09:35:00',1.21),('5815','2013-12-27','09:40:00',1.24),('5815','2013-12-27','09:45:00',1.29),('5815','2013-12-27','09:50:00',1.33),('5815','2013-12-27','09:55:00',1.37),('5815','2013-12-27','10:00:00',1.4),('5815','2013-12-27','10:05:00',1.42),('5815','2013-12-27','10:10:00',1.45),('5815','2013-12-27','10:15:00',1.48),('5815','2013-12-27','10:20:00',1.51),('5815','2013-12-27','10:25:00',1.55),('5815','2013-12-27','10:30:00',1.58),('5815','2013-12-27','10:35:00',1.61),('5815','2013-12-27','10:40:00',1.63),('5815','2013-12-27','10:45:00',1.64),('5815','2013-12-27','10:50:00',1.66),('5815','2013-12-27','10:55:00',1.68),('5815','2013-12-27','11:00:00',1.71),('5815','2013-12-27','11:05:00',1.73),('5815','2013-12-27','11:10:00',1.74),('5815','2013-12-27','11:15:00',1.75),('5815','2013-12-27','11:20:00',1.77),('5815','2013-12-27','11:25:00',1.79),('5815','2013-12-27','11:30:00',1.79),('5815','2013-12-27','11:35:00',1.8),('5815','2013-12-27','11:40:00',1.81),('5815','2013-12-27','11:45:00',1.8),('5815','2013-12-27','11:50:00',1.82),('5815','2013-12-27','11:55:00',1.82),('5815','2013-12-27','12:00:00',1.81),('5815','2013-12-27','12:05:00',1.79),('5815','2013-12-27','12:10:00',1.82),('5815','2013-12-27','12:15:00',1.83),('5815','2013-12-27','12:20:00',1.82),('5815','2013-12-27','12:25:00',1.8),('5815','2013-12-27','12:30:00',1.78),('5815','2013-12-27','12:35:00',1.77),('5815','2013-12-27','12:40:00',1.76),('5815','2013-12-27','12:45:00',1.76),('5815','2013-12-27','12:50:00',1.74),('5815','2013-12-27','12:55:00',1.73),('5815','2013-12-27','13:00:00',1.7),('5815','2013-12-27','13:05:00',1.7),('5815','2013-12-27','13:10:00',1.68),('5815','2013-12-27','13:15:00',1.65),('5815','2013-12-27','13:20:00',1.63),('5815','2013-12-27','13:25:00',1.6),('5815','2013-12-27','13:30:00',1.58),('5815','2013-12-27','13:35:00',1.56),('5815','2013-12-27','13:40:00',1.54),('5815','2013-12-27','13:45:00',1.49),('5815','2013-12-27','13:50:00',1.47),('5815','2013-12-27','13:55:00',1.45),('5815','2013-12-27','14:00:00',1.4),('5815','2013-12-27','14:05:00',1.38),('5815','2013-12-27','14:10:00',1.34),('5815','2013-12-27','14:15:00',1.3),('5815','2013-12-27','14:20:00',1.23),('5815','2013-12-27','14:25:00',1.22),('5815','2013-12-27','14:30:00',1.16),('5815','2013-12-27','14:35:00',1.13),('5815','2013-12-27','14:40:00',1.08),('5815','2013-12-26','12:15:00',1.59),('5815','2013-12-26','12:40:00',1.07),('5815','2013-12-26','12:45:00',1.43),('5815','2013-12-26','12:50:00',1.68),('5815','2013-12-26','12:55:00',1.72),('5815','2013-12-26','13:00:00',1.72),('5815','2013-12-26','13:05:00',1.52),('5815','2013-12-26','13:30:00',1.54),('5815','2013-12-26','13:35:00',1.58),('5815','2013-12-24','10:35:00',1.02),('5815','2013-12-24','10:40:00',1.05),('5815','2013-12-24','10:50:00',1.03),('5815','2013-12-24','11:20:00',1),('5815','2013-12-24','11:25:00',1.15),('5815','2013-12-24','11:30:00',1.09),('5815','2013-12-24','11:40:00',1.25),('5815','2013-12-24','11:45:00',1.31),('5815','2013-12-24','11:55:00',1.57),('5815','2013-12-24','12:00:00',1.76),('5815','2013-12-24','12:20:00',1.1),('5815','2013-12-24','12:35:00',1.04),('5815','2013-12-23','09:30:00',1.05),('5815','2013-12-23','09:35:00',1.12),('5815','2013-12-23','09:40:00',1.17),('5815','2013-12-23','09:45:00',1.2),('5815','2013-12-23','09:50:00',1.19),('5815','2013-12-23','09:55:00',1.23),('5815','2013-12-23','10:00:00',1.22),('5815','2013-12-23','10:05:00',1.24),('5815','2013-12-23','10:10:00',1.32),('5815','2013-12-23','10:15:00',1.38),('5815','2013-12-23','10:20:00',1.39),('5815','2013-12-23','10:25:00',1.41),('5815','2013-12-23','10:30:00',1.44),('5815','2013-12-23','10:35:00',1.47),('5815','2013-12-23','10:40:00',1.5),('5815','2013-12-23','10:45:00',1.54),('5815','2013-12-23','10:50:00',1.55),('5815','2013-12-23','10:55:00',1.55),('5815','2013-12-23','11:00:00',1.57),('5815','2013-12-23','11:05:00',1.59),('5815','2013-12-23','11:10:00',1.57),('5815','2013-12-23','11:15:00',1.6),('5815','2013-12-23','11:20:00',1.63),('5815','2013-12-23','11:25:00',1.65),('5815','2013-12-23','11:30:00',1.66),('5815','2013-12-23','11:35:00',1.67),('5815','2013-12-23','11:40:00',1.68),('5815','2013-12-23','11:45:00',1.69),('5815','2013-12-23','11:50:00',1.68),('5815','2013-12-23','11:55:00',1.66),('5815','2013-12-23','12:00:00',1.63),('5815','2013-12-23','12:05:00',1.64),('5815','2013-12-23','12:10:00',1.63),('5815','2013-12-23','12:15:00',1.63),('5815','2013-12-23','12:20:00',1.64),('5815','2013-12-23','12:25:00',1.63),('5815','2013-12-23','12:30:00',1.61),('5815','2013-12-23','12:35:00',1.59),('5815','2013-12-23','12:40:00',1.56),('5815','2013-12-23','12:45:00',1.55),('5815','2013-12-23','12:50:00',1.56),('5815','2013-12-23','12:55:00',1.56),('5815','2013-12-23','13:00:00',1.52),('5815','2013-12-23','13:05:00',1.51),('5815','2013-12-23','13:10:00',1.49),('5815','2013-12-23','13:15:00',1.46),('5815','2013-12-23','13:20:00',1.44),('5815','2013-12-23','13:25:00',1.42),('5815','2013-12-23','13:30:00',1.4),('5815','2013-12-23','13:35:00',1.38),('5815','2013-12-23','13:40:00',1.34),('5815','2013-12-23','13:45:00',1.3),('5815','2013-12-23','13:50:00',1.28),('5815','2013-12-23','13:55:00',1.24),('5815','2013-12-23','14:00:00',1.2),('5815','2013-12-23','14:05:00',1.17),('5815','2013-12-23','14:10:00',1.16),('5815','2013-12-23','14:15:00',1.12),('5815','2013-12-23','14:20:00',1.09),('5815','2013-12-23','14:25:00',1.03),('5815','2013-12-22','09:55:00',1.05),('5815','2013-12-22','10:00:00',1.24),('5815','2013-12-22','10:05:00',1.36),('5815','2013-12-22','10:10:00',1.43),('5815','2013-12-22','10:15:00',1.31),('5815','2013-12-22','10:20:00',1.42),('5815','2013-12-22','10:25:00',1.38),('5815','2013-12-22','10:30:00',1.29),('5815','2013-12-22','10:35:00',1.31),('5815','2013-12-22','10:40:00',1.35),('5815','2013-12-22','10:45:00',1.36),('5815','2013-12-22','10:50:00',1.36),('5815','2013-12-22','10:55:00',1.41),('5815','2013-12-22','11:00:00',1.62),('5815','2013-12-22','11:05:00',1.73),('5815','2013-12-22','11:10:00',1.76),('5815','2013-12-22','11:15:00',1.77),('5815','2013-12-22','11:20:00',1.69),('5815','2013-12-22','11:25:00',1.75),('5815','2013-12-22','11:30:00',1.65),('5815','2013-12-22','11:35:00',1.72),('5815','2013-12-22','11:40:00',1.77),('5815','2013-12-22','11:45:00',1.55),('5815','2013-12-22','11:50:00',1.58),('5815','2013-12-22','11:55:00',1.62),('5815','2013-12-22','12:00:00',1.67),('5815','2013-12-22','12:05:00',1.73),('5815','2013-12-22','12:10:00',1.7),('5815','2013-12-22','12:15:00',1.66),('5815','2013-12-22','12:20:00',1.66),('5815','2013-12-22','12:25:00',1.67),('5815','2013-12-22','12:30:00',1.77),('5815','2013-12-22','12:35:00',1.76),('5815','2013-12-22','12:40:00',1.75),('5815','2013-12-22','12:45:00',1.74),('5815','2013-12-22','12:50:00',1.73),('5815','2013-12-22','12:55:00',1.73),('5815','2013-12-22','13:00:00',1.72),('5815','2013-12-22','13:05:00',1.69),('5815','2013-12-22','13:10:00',1.67),('5815','2013-12-22','13:15:00',1.64),('5815','2013-12-22','13:20:00',1.54),('5815','2013-12-22','13:25:00',1.33),('5815','2013-12-22','13:30:00',1.57),('5815','2013-12-22','13:40:00',1.22),('5815','2013-12-22','13:45:00',1.12),('5815','2013-12-22','13:50:00',1.05),('5815','2013-12-22','13:55:00',1.24),('5815','2013-12-22','14:00:00',1.45),('5815','2013-12-22','14:05:00',1.42),('5815','2013-12-22','14:10:00',1.4),('5815','2013-12-22','14:15:00',1.34),('5815','2013-12-22','14:20:00',1.26),('5815','2013-12-22','14:25:00',1.23),('5815','2013-12-22','14:30:00',1.11),('5815','2013-12-22','14:35:00',1.12),('5815','2013-12-22','14:40:00',1.09),('5815','2013-12-22','14:45:00',1.07),('5815','2013-12-22','14:50:00',1.04),('5815','2013-12-21','09:35:00',1.02),('5815','2013-12-21','09:40:00',1.41),('5815','2013-12-21','09:45:00',1.44),('5815','2013-12-21','09:50:00',1.53),('5815','2013-12-21','09:55:00',1.54),('5815','2013-12-21','10:00:00',1.55),('5815','2013-12-21','10:05:00',1.57),('5815','2013-12-21','10:10:00',1.59),('5815','2013-12-21','10:15:00',1.56),('5815','2013-12-21','10:20:00',1.51),('5815','2013-12-21','10:25:00',1.53),('5815','2013-12-21','10:30:00',1.6),('5815','2013-12-21','10:35:00',1.52),('5815','2013-12-21','10:40:00',1.43),('5815','2013-12-21','10:45:00',1.48),('5815','2013-12-21','10:50:00',1.55),('5815','2013-12-21','10:55:00',1.44),('5815','2013-12-21','11:00:00',1.27),('5815','2013-12-21','11:05:00',1.24),('5815','2013-12-21','11:10:00',1.69),('5815','2013-12-21','11:15:00',1.67),('5815','2013-12-21','11:20:00',1.52),('5815','2013-12-21','11:25:00',1.55),('5815','2013-12-21','11:30:00',1.47),('5815','2013-12-21','11:35:00',1.45),('5815','2013-12-21','11:40:00',1.57),('5815','2013-12-21','11:45:00',1.47),('5815','2013-12-21','11:50:00',1.1),('5815','2013-12-21','12:35:00',1.11),('5815','2013-12-21','12:40:00',1.07),('5815','2013-12-21','12:50:00',1.22),('5815','2013-12-21','12:55:00',1.55),('5815','2013-12-21','13:00:00',1.5),('5815','2013-12-21','13:05:00',1.85),('5815','2013-12-21','13:10:00',1.88),('5815','2013-12-21','13:15:00',1.43),('5815','2013-12-21','13:20:00',1.39),('5815','2013-12-21','13:25:00',1.41),('5815','2013-12-21','13:30:00',1.33),('5815','2013-12-21','13:35:00',1.27),('5815','2013-12-21','13:40:00',1.01),('5815','2013-12-21','13:45:00',1.19),('5815','2013-12-21','13:50:00',1.14),('5815','2013-12-21','14:10:00',1.14),('5815','2013-12-20','09:20:00',1.01),('5815','2013-12-20','09:25:00',1.05),('5815','2013-12-20','09:30:00',1.09),('5815','2013-12-20','09:35:00',1.14),('5815','2013-12-20','09:40:00',1.17),('5815','2013-12-20','09:45:00',1.21),('5815','2013-12-20','09:50:00',1.25),('5815','2013-12-20','09:55:00',1.3),('5815','2013-12-20','10:00:00',1.34),('5815','2013-12-20','10:05:00',1.38),('5815','2013-12-20','10:10:00',1.41),('5815','2013-12-20','10:15:00',1.43),('5815','2013-12-20','10:20:00',1.46),('5815','2013-12-20','10:25:00',1.48),('5815','2013-12-20','10:30:00',1.53),('5815','2013-12-20','10:35:00',1.56),('5815','2013-12-20','10:40:00',1.57),('5815','2013-12-20','10:45:00',1.6),('5815','2013-12-20','10:50:00',1.62),('5815','2013-12-20','10:55:00',1.64),('5815','2013-12-20','11:00:00',1.67),('5815','2013-12-20','11:05:00',1.7),('5815','2013-12-20','11:10:00',1.71),('5815','2013-12-20','11:15:00',1.73),('5815','2013-12-20','11:20:00',1.75),('5815','2013-12-20','11:25:00',1.77),('5815','2013-12-20','11:30:00',1.79),('5815','2013-12-20','11:35:00',1.79),('5815','2013-12-20','11:40:00',1.8),('5815','2013-12-20','11:45:00',1.8),('5815','2013-12-20','11:50:00',1.81),('5815','2013-12-20','11:55:00',1.81),('5815','2013-12-20','12:00:00',1.82),('5815','2013-12-20','12:05:00',1.83),('5815','2013-12-20','12:10:00',1.82),('5815','2013-12-20','12:15:00',1.81),('5815','2013-12-20','12:20:00',1.81),('5815','2013-12-20','12:25:00',1.8),('5815','2013-12-20','12:30:00',1.81),('5815','2013-12-20','12:35:00',1.8),('5815','2013-12-20','12:40:00',1.79),('5815','2013-12-20','12:45:00',1.78),('5815','2013-12-20','12:50:00',1.78),('5815','2013-12-20','12:55:00',1.76),('5815','2013-12-20','13:00:00',1.74),('5815','2013-12-20','13:05:00',1.73),('5815','2013-12-20','13:10:00',1.71),('5815','2013-12-20','13:15:00',1.68),('5815','2013-12-20','13:20:00',1.66),('5815','2013-12-20','13:25:00',1.65),('5815','2013-12-20','13:30:00',1.62),('5815','2013-12-20','13:35:00',1.59),('5815','2013-12-20','13:40:00',1.55),('5815','2013-12-20','13:45:00',1.54),('5815','2013-12-20','13:50:00',1.52),('5815','2013-12-20','13:55:00',1.49),('5815','2013-12-20','14:00:00',1.46),('5815','2013-12-20','14:05:00',1.42),('5815','2013-12-20','14:10:00',1.39),('5815','2013-12-20','14:15:00',1.38),('5815','2013-12-20','14:20:00',1.36),('5815','2013-12-20','14:25:00',1.32),('5815','2013-12-20','14:30:00',1.28),('5815','2013-12-20','14:35:00',1.24),('5815','2013-12-20','14:40:00',1.18),('5815','2013-12-20','14:45:00',1.15),('5815','2013-12-20','14:50:00',1.08),('5815','2013-12-20','14:55:00',1.04),('5815','2013-12-19','09:25:00',1.03),('5815','2013-12-19','09:30:00',1.07),('5815','2013-12-19','09:35:00',1.11),('5815','2013-12-19','09:40:00',1.15),('5815','2013-12-19','09:45:00',1.19),('5815','2013-12-19','09:50:00',1.22),('5815','2013-12-19','09:55:00',1.25),('5815','2013-12-19','10:00:00',1.28),('5815','2013-12-19','10:05:00',1.32),('5815','2013-12-19','10:10:00',1.34),('5815','2013-12-19','10:15:00',1.36),('5815','2013-12-19','10:20:00',1.39),('5815','2013-12-19','10:25:00',1.43),('5815','2013-12-19','10:30:00',1.44),('5815','2013-12-19','10:35:00',1.47),('5815','2013-12-19','10:40:00',1.5),('5815','2013-12-19','10:45:00',1.52),('5815','2013-12-19','10:50:00',1.55),('5815','2013-12-19','10:55:00',1.57),('5815','2013-12-19','11:00:00',1.58),('5815','2013-12-19','11:05:00',1.59),('5815','2013-12-19','11:10:00',1.6),('5815','2013-12-19','11:15:00',1.62),('5815','2013-12-19','11:20:00',1.63),('5815','2013-12-19','11:25:00',1.64),('5815','2013-12-19','11:30:00',1.65),('5815','2013-12-19','11:35:00',1.65),('5815','2013-12-19','11:40:00',1.67),('5815','2013-12-19','11:45:00',1.68),('5815','2013-12-19','11:50:00',1.7),('5815','2013-12-19','11:55:00',1.71),('5815','2013-12-19','12:00:00',1.69),('5815','2013-12-19','12:05:00',1.68),('5815','2013-12-19','12:10:00',1.71),('5815','2013-12-19','12:15:00',1.7),('5815','2013-12-19','12:20:00',1.69),('5815','2013-12-19','12:25:00',1.66),('5815','2013-12-19','12:30:00',1.67),('5815','2013-12-19','12:35:00',1.66),('5815','2013-12-19','12:40:00',1.65),('5815','2013-12-19','12:45:00',1.62),('5815','2013-12-19','12:50:00',1.6),('5815','2013-12-19','12:55:00',1.6),('5815','2013-12-19','13:00:00',1.6),('5815','2013-12-19','13:05:00',1.59),('5815','2013-12-19','13:10:00',1.58),('5815','2013-12-19','13:15:00',1.54),('5815','2013-12-19','13:20:00',1.49),('5815','2013-12-19','13:25:00',1.48),('5815','2013-12-19','13:30:00',1.46),('5815','2013-12-19','13:35:00',1.43),('5815','2013-12-19','13:40:00',1.39),('5815','2013-12-19','13:45:00',1.38),('5815','2013-12-19','13:50:00',1.31),('5815','2013-12-19','13:55:00',1.26),('5815','2013-12-19','14:00:00',1.17),('5815','2013-12-18','09:25:00',1.12),('5815','2013-12-18','09:55:00',1.4),('5815','2013-12-18','10:00:00',1.3),('5815','2013-12-18','10:05:00',1.33),('5815','2013-12-18','10:10:00',1.37),('5815','2013-12-18','10:15:00',1.41),('5815','2013-12-18','10:20:00',1.15),('5815','2013-12-18','10:45:00',1.16),('5815','2013-12-18','10:50:00',1.68),('5815','2013-12-18','11:15:00',1.37),('5815','2013-12-18','14:35:00',1.26),('5815','2013-12-18','14:40:00',1.1),('5815','2013-12-18','14:45:00',1.04),('5815','2013-12-17','09:20:00',1.04),('5815','2013-12-17','09:25:00',1.09),('5815','2013-12-17','09:30:00',1.13),('5815','2013-12-17','09:35:00',1.17),('5815','2013-12-17','09:40:00',1.2),('5815','2013-12-17','09:45:00',1.26),('5815','2013-12-17','09:50:00',1.29),('5815','2013-12-17','09:55:00',1.32),('5815','2013-12-17','10:00:00',1.36),('5815','2013-12-17','10:05:00',1.4),('5815','2013-12-17','10:10:00',1.44),('5815','2013-12-17','10:15:00',1.47),('5815','2013-12-17','10:20:00',1.5),('5815','2013-12-17','10:25:00',1.53),('5815','2013-12-17','10:30:00',1.57),('5815','2013-12-17','10:35:00',1.59),('5815','2013-12-17','10:40:00',1.6),('5815','2013-12-17','10:45:00',1.62),('5815','2013-12-17','10:50:00',1.64),('5815','2013-12-17','10:55:00',1.65),('5815','2013-12-17','11:00:00',1.66),('5815','2013-12-17','11:05:00',1.68),('5815','2013-12-17','11:10:00',1.69),('5815','2013-12-17','11:15:00',1.71),('5815','2013-12-17','11:20:00',1.71),('5815','2013-12-17','11:25:00',1.71),('5815','2013-12-17','11:30:00',1.73),('5815','2013-12-17','11:35:00',1.73),('5815','2013-12-17','11:40:00',1.74),('5815','2013-12-17','11:45:00',1.74),('5815','2013-12-17','11:50:00',1.74),('5815','2013-12-17','11:55:00',1.75),('5815','2013-12-17','12:00:00',1.75),('5815','2013-12-17','12:05:00',1.76),('5815','2013-12-17','12:10:00',1.76),('5815','2013-12-17','12:15:00',1.77),('5815','2013-12-17','12:20:00',1.76),('5815','2013-12-17','12:25:00',1.75),('5815','2013-12-17','12:30:00',1.76),('5815','2013-12-17','12:35:00',1.75),('5815','2013-12-17','12:40:00',1.73),('5815','2013-12-17','12:45:00',1.72),('5815','2013-12-17','12:50:00',1.7),('5815','2013-12-17','12:55:00',1.69),('5815','2013-12-17','13:00:00',1.66),('5815','2013-12-17','13:05:00',1.65),('5815','2013-12-17','13:10:00',1.63),('5815','2013-12-17','13:15:00',1.6),('5815','2013-12-17','13:20:00',1.59),('5815','2013-12-17','13:25:00',1.56),('5815','2013-12-17','13:30:00',1.53),('5815','2013-12-17','13:35:00',1.5),('5815','2013-12-17','13:40:00',1.49),('5815','2013-12-17','13:45:00',1.44),('5815','2013-12-17','13:50:00',1.42),('5815','2013-12-17','13:55:00',1.36),('5815','2013-12-17','14:00:00',1.36),('5815','2013-12-17','14:05:00',1.33),('5815','2013-12-17','14:10:00',1.29),('5815','2013-12-17','14:15:00',1.28),('5815','2013-12-17','14:20:00',1.23),('5815','2013-12-17','14:25:00',1.21),('5815','2013-12-17','14:30:00',1.18),('5815','2013-12-17','14:35:00',1.14),('5815','2013-12-17','14:40:00',1.11),('5815','2013-12-17','14:45:00',1.05),('5815','2013-12-17','14:50:00',1.02),('5815','2014-04-21','08:45:00',1.01),('5815','2014-04-21','08:50:00',1.04),('5815','2014-04-21','08:55:00',1.08),('5815','2014-04-21','09:00:00',1.14),('5815','2014-04-21','09:05:00',1.24),('5815','2014-04-21','09:10:00',1.2),('5815','2014-04-21','09:15:00',1.2),('5815','2014-04-21','09:20:00',1.28),('5815','2014-04-21','09:25:00',1.12),('5815','2014-04-21','09:30:00',1),('5815','2014-04-21','09:35:00',1.33),('5815','2014-04-21','09:40:00',1.54),('5815','2014-04-21','09:45:00',1.65),('5815','2014-04-21','09:50:00',1.39),('5815','2014-04-21','10:10:00',1.04),('5815','2014-04-21','10:15:00',1.11),('5815','2014-04-21','10:20:00',1.67),('5815','2014-04-21','10:25:00',1.26),('5815','2014-04-21','10:30:00',1.84),('5815','2014-04-21','10:35:00',2.01),('5815','2014-04-21','10:40:00',1.85),('5815','2014-04-21','10:45:00',1.98),('5815','2014-04-21','10:50:00',2.32),('5815','2014-04-21','10:55:00',1.7),('5815','2014-04-21','11:00:00',1.11),('5815','2014-04-21','11:05:00',1.24),('5815','2014-04-21','13:20:00',1.27),('5815','2014-04-21','13:25:00',1.46),('5815','2014-04-21','13:30:00',1.63),('5815','2014-04-21','13:35:00',1.48),('5815','2014-04-21','13:40:00',1.84),('5815','2014-04-21','13:45:00',1.85),('5815','2014-04-21','13:50:00',1.63),('5815','2014-04-21','14:10:00',2.02),('5815','2014-04-21','14:15:00',1.84),('5815','2014-04-21','14:20:00',2.02),('5815','2014-04-21','14:25:00',1.66),('5815','2014-04-21','14:30:00',1.13),('5815','2014-04-21','14:35:00',1.31),('5815','2014-04-21','14:40:00',1.83),('5815','2014-04-21','14:45:00',2.24),('5815','2014-04-21','14:50:00',2.05),('5815','2014-04-21','14:55:00',1.62),('5815','2014-04-21','15:35:00',1.46),('5815','2014-04-21','15:40:00',1.29),('5815','2014-04-21','15:45:00',1.06),('5815','2014-04-21','15:50:00',1.24),('5815','2014-04-21','15:55:00',1.02),('5815','2014-04-21','16:00:00',1.2),('5815','2014-04-21','16:40:00',1.01),('5815','2013-12-16','09:05:00',1),('5815','2013-12-16','09:10:00',1.05),('5815','2013-12-16','09:15:00',1.09),('5815','2013-12-16','09:20:00',1.13),('5815','2013-12-16','09:25:00',1.17),('5815','2013-12-16','09:30:00',1.21),('5815','2013-12-16','09:35:00',1.25),('5815','2013-12-16','09:40:00',1.3),('5815','2013-12-16','09:45:00',1.34),('5815','2013-12-16','09:50:00',1.38),('5815','2013-12-16','09:55:00',1.42),('5815','2013-12-16','10:00:00',1.45),('5815','2013-12-16','10:05:00',1.49),('5815','2013-12-16','10:10:00',1.49),('5815','2013-12-16','10:15:00',1.53),('5815','2013-12-16','10:20:00',1.56),('5815','2013-12-16','10:25:00',1.59),('5815','2013-12-16','10:30:00',1.62),('5815','2013-12-16','10:35:00',1.64),('5815','2013-12-16','10:40:00',1.66),('5815','2013-12-16','10:45:00',1.68),('5815','2013-12-16','10:50:00',1.68),('5815','2013-12-16','10:55:00',1.71),('5815','2013-12-16','11:00:00',1.73),('5815','2013-12-16','11:05:00',1.74),('5815','2013-12-16','11:10:00',1.76),('5815','2013-12-16','11:15:00',1.78),('5815','2013-12-16','11:20:00',1.79),('5815','2013-12-16','11:25:00',1.79),('5815','2013-12-16','11:30:00',1.81),('5815','2013-12-16','11:35:00',1.82),('5815','2013-12-16','11:40:00',1.83),('5815','2013-12-16','11:45:00',1.84),('5815','2013-12-16','11:50:00',1.85),('5815','2013-12-16','11:55:00',1.84),('5815','2013-12-16','12:00:00',1.83),('5815','2013-12-16','12:05:00',1.83),('5815','2013-12-16','12:10:00',1.83),('5815','2013-12-16','12:15:00',1.84),('5815','2013-12-16','12:20:00',1.84),('5815','2013-12-16','12:25:00',1.83),('5815','2013-12-16','12:30:00',1.84),('5815','2013-12-16','12:35:00',1.85),('5815','2013-12-16','12:40:00',1.82),('5815','2013-12-16','12:45:00',1.8),('5815','2013-12-16','12:50:00',1.79),('5815','2013-12-16','12:55:00',1.74),('5815','2013-12-16','13:00:00',1.76),('5815','2013-12-16','13:05:00',1.75),('5815','2013-12-16','13:10:00',1.72),('5815','2013-12-16','13:15:00',1.69),('5815','2013-12-16','13:20:00',1.67),('5815','2013-12-16','13:25:00',1.64),('5815','2013-12-16','13:30:00',1.62),('5815','2013-12-16','13:35:00',1.62),('5815','2013-12-16','13:40:00',1.6),('5815','2013-12-16','13:45:00',1.57),('5815','2013-12-16','13:50:00',1.53),('5815','2013-12-16','13:55:00',1.5),('5815','2013-12-16','14:00:00',1.47),('5815','2013-12-16','14:05:00',1.43),('5815','2013-12-16','14:10:00',1.38),('5815','2013-12-16','14:15:00',1.35),('5815','2013-12-16','14:20:00',1.32),('5815','2013-12-16','14:25:00',1.29),('5815','2013-12-16','14:30:00',1.25),('5815','2013-12-16','14:35:00',1.23),('5815','2013-12-16','14:40:00',1.18),('5815','2013-12-16','14:45:00',1.13),('5815','2013-12-16','14:50:00',1.08),('5815','2013-12-16','14:55:00',1.05),('5815','2013-12-16','15:00:00',1),('5815','2013-12-15','09:10:00',1.02),('5815','2013-12-15','09:15:00',1.07),('5815','2013-12-15','09:20:00',1.1),('5815','2013-12-15','09:25:00',1.16),('5815','2013-12-15','09:30:00',1.2),('5815','2013-12-15','09:35:00',1.24),('5815','2013-12-15','09:40:00',1.28),('5815','2013-12-15','09:45:00',1.32),('5815','2013-12-15','09:50:00',1.36),('5815','2013-12-15','09:55:00',1.38),('5815','2013-12-15','10:00:00',1.41),('5815','2013-12-15','10:05:00',1.45),('5815','2013-12-15','10:10:00',1.47),('5815','2013-12-15','10:15:00',1.5),('5815','2013-12-15','10:20:00',1.52),('5815','2013-12-15','10:25:00',1.53),('5815','2013-12-15','10:30:00',1.56),('5815','2013-12-15','10:35:00',1.58),('5815','2013-12-15','10:40:00',1.6),('5815','2013-12-15','10:45:00',1.63),('5815','2013-12-15','10:50:00',1.65),('5815','2013-12-15','10:55:00',1.68),('5815','2013-12-15','11:00:00',1.7),('5815','2013-12-15','11:05:00',1.71),('5815','2013-12-15','11:10:00',1.72),('5815','2013-12-15','11:15:00',1.73),('5815','2013-12-15','11:20:00',1.74),('5815','2013-12-15','11:25:00',1.76),('5815','2013-12-15','11:30:00',1.79),('5815','2013-12-15','11:35:00',1.79),('5815','2013-12-15','11:40:00',1.79),('5815','2013-12-15','11:45:00',1.8),('5815','2013-12-15','11:50:00',1.81),('5815','2013-12-15','11:55:00',1.82),('5815','2013-12-15','12:00:00',1.84),('5815','2013-12-15','12:05:00',1.84),('5815','2013-12-15','12:10:00',1.84),('5815','2013-12-15','12:15:00',1.84),('5815','2013-12-15','12:20:00',1.85),('5815','2013-12-15','12:25:00',1.83),('5815','2013-12-15','12:30:00',1.82),('5815','2013-12-15','12:35:00',1.82),('5815','2013-12-15','12:40:00',1.82),('5815','2013-12-15','12:45:00',1.81),('5815','2013-12-15','12:50:00',1.79),('5815','2013-12-15','12:55:00',1.78),('5815','2013-12-15','13:00:00',1.78),('5815','2013-12-15','13:05:00',1.77),('5815','2013-12-15','13:10:00',1.73),('5815','2013-12-15','13:15:00',1.7),('5815','2013-12-15','13:20:00',1.67),('5815','2013-12-15','13:25:00',1.64),('5815','2013-12-15','13:30:00',1.63),('5815','2013-12-15','13:35:00',1.59),('5815','2013-12-15','13:40:00',1.58),('5815','2013-12-15','13:45:00',1.56),('5815','2013-12-15','13:50:00',1.54),('5815','2013-12-15','13:55:00',1.49),('5815','2013-12-15','14:00:00',1.43),('5815','2013-12-15','14:05:00',1.43),('5815','2013-12-15','14:10:00',1.38),('5815','2013-12-15','14:15:00',1.36),('5815','2013-12-15','14:20:00',1.32),('5815','2013-12-15','14:25:00',1.28),('5815','2013-12-15','14:30:00',1.25),('5815','2013-12-15','14:35:00',1.21),('5815','2013-12-15','14:40:00',1.17),('5815','2013-12-15','14:45:00',1.12),('5815','2013-12-15','14:50:00',1.07),('5815','2013-12-15','14:55:00',1.02),('5815','2013-12-13','09:15:00',1.02),('5815','2013-12-13','09:20:00',1.07),('5815','2013-12-13','09:25:00',1.12),('5815','2013-12-13','09:30:00',1.16),('5815','2013-12-13','09:35:00',1.2),('5815','2013-12-13','09:40:00',1.24),('5815','2013-12-13','09:45:00',1.28),('5815','2013-12-13','09:50:00',1.31),('5815','2013-12-13','09:55:00',1.33),('5815','2013-12-13','10:00:00',1.36),('5815','2013-12-13','10:05:00',1.39),('5815','2013-12-13','10:10:00',1.42),('5815','2013-12-13','10:15:00',1.46),('5815','2013-12-13','10:20:00',1.49),('5815','2013-12-13','10:25:00',1.48),('5815','2013-12-13','10:30:00',1.52),('5815','2013-12-13','10:35:00',1.56),('5815','2013-12-13','10:40:00',1.57),('5815','2013-12-13','10:45:00',1.59),('5815','2013-12-13','10:50:00',1.61),('5815','2013-12-13','10:55:00',1.61),('5815','2013-12-13','11:00:00',1.62),('5815','2013-12-13','11:05:00',1.63),('5815','2013-12-13','11:10:00',1.67),('5815','2013-12-13','11:15:00',1.67),('5815','2013-12-13','11:20:00',1.69),('5815','2013-12-13','11:25:00',1.69),('5815','2013-12-13','11:30:00',1.7),('5815','2013-12-13','11:35:00',1.7),('5815','2013-12-13','11:40:00',1.73),('5815','2013-12-13','11:45:00',1.72),('5815','2013-12-13','11:50:00',1.7),('5815','2013-12-13','11:55:00',1.68),('5815','2013-12-13','12:00:00',1.67),('5815','2013-12-13','12:05:00',1.67),('5815','2013-12-13','12:10:00',1.67),('5815','2013-12-13','12:15:00',1.69),('5815','2013-12-13','12:20:00',1.68),('5815','2013-12-13','12:25:00',1.67),('5815','2013-12-13','12:30:00',1.62),('5815','2013-12-13','12:35:00',1.61),('5815','2013-12-13','12:40:00',1.61),('5815','2013-12-13','12:45:00',1.59),('5815','2013-12-13','12:50:00',1.64),('5815','2013-12-13','12:55:00',1.61),('5815','2013-12-13','13:00:00',1.6),('5815','2013-12-13','13:05:00',1.58),('5815','2013-12-13','13:10:00',1.56),('5815','2013-12-13','13:15:00',1.56),('5815','2013-12-13','13:20:00',1.57),('5815','2013-12-13','13:25:00',1.57),('5815','2013-12-13','13:30:00',1.52),('5815','2013-12-13','13:35:00',1.49),('5815','2013-12-13','13:40:00',1.51),('5815','2013-12-13','13:45:00',1.52),('5815','2013-12-13','13:50:00',1.49),('5815','2013-12-13','13:55:00',1.46),('5815','2013-12-13','14:00:00',1.41),('5815','2013-12-13','14:05:00',1.4),('5815','2013-12-13','14:10:00',1.35),('5815','2013-12-13','14:15:00',1.32),('5815','2013-12-13','14:20:00',1.28),('5815','2013-12-13','14:25:00',1.25),('5815','2013-12-13','14:30:00',1.22),('5815','2013-12-13','14:35:00',1.18),('5815','2013-12-13','14:40:00',1.13),('5815','2013-12-13','14:45:00',1.08),('5815','2013-12-13','14:50:00',1.01),('5815','2013-12-12','09:25:00',1.01),('5815','2013-12-12','09:30:00',1.03),('5815','2013-12-12','09:35:00',1.06),('5815','2013-12-12','09:40:00',1.1),('5815','2013-12-12','09:45:00',1.15),('5815','2013-12-12','09:50:00',1.19),('5815','2013-12-12','09:55:00',1.23),('5815','2013-12-12','10:00:00',1.24),('5815','2013-12-12','10:05:00',1.28),('5815','2013-12-12','10:10:00',1.31),('5815','2013-12-12','10:15:00',1.34),('5815','2013-12-12','10:20:00',1.38),('5815','2013-12-12','10:25:00',1.39),('5815','2013-12-12','10:30:00',1.43),('5815','2013-12-12','10:35:00',1.46),('5815','2013-12-12','10:40:00',1.48),('5815','2013-12-12','10:45:00',1.5),('5815','2013-12-12','10:50:00',1.51),('5815','2013-12-12','10:55:00',1.55),('5815','2013-12-12','11:00:00',1.56),('5815','2013-12-12','11:05:00',1.58),('5815','2013-12-12','11:10:00',1.56),('5815','2013-12-12','11:15:00',1.59),('5815','2013-12-12','11:20:00',1.63),('5815','2013-12-12','11:25:00',1.63),('5815','2013-12-12','11:30:00',1.63),('5815','2013-12-12','11:35:00',1.63),('5815','2013-12-12','11:40:00',1.63),('5815','2013-12-12','11:45:00',1.66),('5815','2013-12-12','11:50:00',1.66),('5815','2013-12-12','11:55:00',1.66),('5815','2013-12-12','12:00:00',1.7),('5815','2013-12-12','12:05:00',1.68),('5815','2013-12-12','12:10:00',1.65),('5815','2013-12-12','12:15:00',1.64),('5815','2013-12-12','12:20:00',1.6),('5815','2013-12-12','12:25:00',1.66),('5815','2013-12-12','12:30:00',1.66),('5815','2013-12-12','12:35:00',1.63),('5815','2013-12-12','12:40:00',1.62),('5815','2013-12-12','12:45:00',1.64),('5815','2013-12-12','12:50:00',1.61),('5815','2013-12-12','12:55:00',1.58),('5815','2013-12-12','13:00:00',1.6),('5815','2013-12-12','13:05:00',1.6),('5815','2013-12-12','13:10:00',1.57),('5815','2013-12-12','13:15:00',1.57),('5815','2013-12-12','13:20:00',1.5),('5815','2013-12-12','13:25:00',1.54),('5815','2013-12-12','13:30:00',1.55),('5815','2013-12-12','13:35:00',1.51),('5815','2013-12-12','13:40:00',1.45),('5815','2013-12-12','13:45:00',1.45),('5815','2013-12-12','13:50:00',1.43),('5815','2013-12-12','13:55:00',1.4),('5815','2013-12-12','14:00:00',1.37),('5815','2013-12-12','14:05:00',1.34),('5815','2013-12-12','14:10:00',1.32),('5815','2013-12-12','14:15:00',1.31),('5815','2013-12-12','14:20:00',1.26),('5815','2013-12-12','14:25:00',1.25),('5815','2013-12-12','14:30:00',1.2),('5815','2013-12-12','14:35:00',1.17),('5815','2013-12-12','14:40:00',1.1),('5815','2013-12-12','14:45:00',1.06),('5815','2013-12-12','14:50:00',1.04),('5815','2013-12-12','14:55:00',1.01),('5815','2013-12-11','09:20:00',1.03),('5815','2013-12-11','09:25:00',1.08),('5815','2013-12-11','09:30:00',1.13),('5815','2013-12-11','09:35:00',1.18),('5815','2013-12-11','09:40:00',1.22),('5815','2013-12-11','09:45:00',1.25),('5815','2013-12-11','09:50:00',1.28),('5815','2013-12-11','09:55:00',1.31),('5815','2013-12-11','10:00:00',1.35),('5815','2013-12-11','10:05:00',1.35),('5815','2013-12-11','10:10:00',1.42),('5815','2013-12-11','10:15:00',1.45),('5815','2013-12-11','10:20:00',1.47),('5815','2013-12-11','10:25:00',1.5),('5815','2013-12-11','10:30:00',1.52),('5815','2013-12-11','10:35:00',1.55),('5815','2013-12-11','10:40:00',1.57),('5815','2013-12-11','10:45:00',1.59),('5815','2013-12-11','10:50:00',1.61),('5815','2013-12-11','10:55:00',1.62),('5815','2013-12-11','11:00:00',1.63),('5815','2013-12-11','11:05:00',1.65),('5815','2013-12-11','11:10:00',1.65),('5815','2013-12-11','11:15:00',1.66),('5815','2013-12-11','11:20:00',1.67),('5815','2013-12-11','11:25:00',1.68),('5815','2013-12-11','11:30:00',1.7),('5815','2013-12-11','11:35:00',1.72),('5815','2013-12-11','11:40:00',1.71),('5815','2013-12-11','11:45:00',1.7),('5815','2013-12-11','11:50:00',1.69),('5815','2013-12-11','11:55:00',1.69),('5815','2013-12-11','12:00:00',1.71),('5815','2013-12-11','12:05:00',1.72),('5815','2013-12-11','12:10:00',1.72),('5815','2013-12-11','12:15:00',1.71),('5815','2013-12-11','12:20:00',1.7),('5815','2013-12-11','12:25:00',1.71),('5815','2013-12-11','12:30:00',1.71),('5815','2013-12-11','12:35:00',1.69),('5815','2013-12-11','12:40:00',1.67),('5815','2013-12-11','12:45:00',1.67),('5815','2013-12-11','12:50:00',1.69),('5815','2013-12-11','12:55:00',1.61),('5815','2013-12-11','13:00:00',1.62),('5815','2013-12-11','13:05:00',1.59),('5815','2013-12-11','13:10:00',1.59),('5815','2013-12-11','13:15:00',1.59),('5815','2013-12-11','13:20:00',1.59),('5815','2013-12-11','13:25:00',1.54),('5815','2013-12-11','13:30:00',1.5),('5815','2013-12-11','13:35:00',1.54),('5815','2013-12-11','13:40:00',1.49),('5815','2013-12-11','13:45:00',1.46),('5815','2013-12-11','13:50:00',1.46),('5815','2013-12-11','13:55:00',1.43),('5815','2013-12-11','14:00:00',1.37),('5815','2013-12-11','14:05:00',1.35),('5815','2013-12-11','14:10:00',1.31),('5815','2013-12-11','14:15:00',1.27),('5815','2013-12-11','14:20:00',1.24),('5815','2013-12-11','14:25:00',1.2),('5815','2013-12-11','14:30:00',1.14),('5815','2013-12-11','14:35:00',1.1),('5815','2013-12-11','14:40:00',1.08),('5815','2013-12-11','14:45:00',1.03),('5815','2013-12-10','09:15:00',1.04),('5815','2013-12-10','09:20:00',1.07),('5815','2013-12-10','09:25:00',1.13),('5815','2013-12-10','09:30:00',1.18),('5815','2013-12-10','09:35:00',1.22),('5815','2013-12-10','09:40:00',1.27),('5815','2013-12-10','09:45:00',1.31),('5815','2013-12-10','09:50:00',1.34),('5815','2013-12-10','09:55:00',1.38),('5815','2013-12-10','10:00:00',1.41),('5815','2013-12-10','10:05:00',1.44),('5815','2013-12-10','10:10:00',1.48),('5815','2013-12-10','10:15:00',1.51),('5815','2013-12-10','10:20:00',1.54),('5815','2013-12-10','10:25:00',1.57),('5815','2013-12-10','10:30:00',1.62),('5815','2013-12-10','10:35:00',1.66),('5815','2013-12-10','10:40:00',1.67),('5815','2013-12-10','10:45:00',1.66),('5815','2013-12-10','10:50:00',1.62),('5815','2013-12-10','10:55:00',1.68),('5815','2013-12-10','11:00:00',1.72),('5815','2013-12-10','11:05:00',1.75),('5815','2013-12-10','11:10:00',1.76),('5815','2013-12-10','11:15:00',1.76),('5815','2013-12-10','11:20:00',1.77),('5815','2013-12-10','11:25:00',1.73),('5815','2013-12-10','11:30:00',1.75),('5815','2013-12-10','11:35:00',1.78),('5815','2013-12-10','11:40:00',1.8),('5815','2013-12-10','11:45:00',1.8),('5815','2013-12-10','11:50:00',1.82),('5815','2013-12-10','11:55:00',1.83),('5815','2013-12-10','12:00:00',1.83),('5815','2013-12-10','12:05:00',1.82),('5815','2013-12-10','12:10:00',1.82),('5815','2013-12-10','12:15:00',1.83),('5815','2013-12-10','12:20:00',1.81),('5815','2013-12-10','12:25:00',1.75),('5815','2013-12-10','12:30:00',1.74),('5815','2013-12-10','12:35:00',1.75),('5815','2013-12-10','12:40:00',1.75),('5815','2013-12-10','12:45:00',1.75),('5815','2013-12-10','12:50:00',1.73),('5815','2013-12-10','12:55:00',1.73),('5815','2013-12-10','13:00:00',1.74),('5815','2013-12-10','13:05:00',1.71),('5815','2013-12-10','13:10:00',1.67),('5815','2013-12-10','13:15:00',1.64),('5815','2013-12-10','13:20:00',1.63),('5815','2013-12-10','13:25:00',1.62),('5815','2013-12-10','13:30:00',1.61),('5815','2013-12-10','13:35:00',1.57),('5815','2013-12-10','13:40:00',1.56),('5815','2013-12-10','13:45:00',1.53),('5815','2013-12-10','13:50:00',1.5),('5815','2013-12-10','13:55:00',1.47),('5815','2013-12-10','14:00:00',1.43),('5815','2013-12-10','14:05:00',1.42),('5815','2013-12-10','14:10:00',1.4),('5815','2013-12-10','14:15:00',1.36),('5815','2013-12-10','14:20:00',1.32),('5815','2013-12-10','14:25:00',1.29),('5815','2013-12-10','14:30:00',1.26),('5815','2013-12-10','14:35:00',1.21),('5815','2013-12-10','14:40:00',1.16),('5815','2013-12-10','14:45:00',1.11),('5815','2013-12-10','14:50:00',1.05),('5815','2013-12-10','14:55:00',1.02),('5815','2013-12-09','09:10:00',1.03),('5815','2013-12-09','09:15:00',1.07),('5815','2013-12-09','09:20:00',1.13),('5815','2013-12-09','09:25:00',1.18),('5815','2013-12-09','09:30:00',1.21),('5815','2013-12-09','09:35:00',1.24),('5815','2013-12-09','09:40:00',1.28),('5815','2013-12-09','09:45:00',1.32),('5815','2013-12-09','09:50:00',1.35),('5815','2013-12-09','09:55:00',1.39),('5815','2013-12-09','10:00:00',1.43),('5815','2013-12-09','10:05:00',1.47),('5815','2013-12-09','10:10:00',1.49),('5815','2013-12-09','10:15:00',1.52),('5815','2013-12-09','10:20:00',1.52),('5815','2013-12-09','10:25:00',1.55),('5815','2013-12-09','10:30:00',1.58),('5815','2013-12-09','10:35:00',1.61),('5815','2013-12-09','10:40:00',1.63),('5815','2013-12-09','10:45:00',1.65),('5815','2013-12-09','10:50:00',1.68),('5815','2013-12-09','10:55:00',1.7),('5815','2013-12-09','11:00:00',1.72),('5815','2013-12-09','11:05:00',1.74),('5815','2013-12-09','11:10:00',1.74),('5815','2013-12-09','11:15:00',1.77),('5815','2013-12-09','11:20:00',1.78),('5815','2013-12-09','11:25:00',1.8),('5815','2013-12-09','11:30:00',1.78),('5815','2013-12-09','11:35:00',1.83),('5815','2013-12-09','11:40:00',1.83),('5815','2013-12-09','11:45:00',1.84),('5815','2013-12-09','11:50:00',1.84),('5815','2013-12-09','11:55:00',1.84),('5815','2013-12-09','12:00:00',1.83),('5815','2013-12-09','12:05:00',1.82),('5815','2013-12-09','12:10:00',1.81),('5815','2013-12-09','12:15:00',1.81),('5815','2013-12-09','12:20:00',1.8),('5815','2013-12-09','12:25:00',1.78),('5815','2013-12-09','12:30:00',1.77),('5815','2013-12-09','12:35:00',1.73),('5815','2013-12-09','12:40:00',1.73),('5815','2013-12-09','12:45:00',1.72),('5815','2013-12-09','12:50:00',1.71),('5815','2013-12-09','12:55:00',1.67),('5815','2013-12-09','13:00:00',1.64),('5815','2013-12-09','13:05:00',1.67),('5815','2013-12-09','13:10:00',1.66),('5815','2013-12-09','13:15:00',1.62),('5815','2013-12-09','13:20:00',1.6),('5815','2013-12-09','13:25:00',1.59),('5815','2013-12-09','13:30:00',1.59),('5815','2013-12-09','13:35:00',1.6),('5815','2013-12-09','13:40:00',1.59),('5815','2013-12-09','13:45:00',1.56),('5815','2013-12-09','13:50:00',1.54),('5815','2013-12-09','13:55:00',1.51),('5815','2013-12-09','14:00:00',1.48),('5815','2013-12-09','14:05:00',1.45),('5815','2013-12-09','14:10:00',1.41),('5815','2013-12-09','14:15:00',1.38),('5815','2013-12-09','14:20:00',1.32),('5815','2013-12-09','14:25:00',1.34),('5815','2013-12-09','14:30:00',1.3),('5815','2013-12-09','14:35:00',1.26),('5815','2013-12-09','14:40:00',1.22),('5815','2013-12-09','14:45:00',1.16),('5815','2013-12-09','14:50:00',1.13),('5815','2013-12-09','14:55:00',1.08),('5815','2013-12-09','15:00:00',1.03),('5815','2013-12-08','09:35:00',1.17),('5815','2013-12-08','09:40:00',1.26),('5815','2013-12-08','09:45:00',1.27),('5815','2013-12-08','09:50:00',1.31),('5815','2013-12-08','09:55:00',1.35),('5815','2013-12-08','10:00:00',1.37),('5815','2013-12-08','10:05:00',1.45),('5815','2013-12-08','10:10:00',1.7),('5815','2013-12-08','10:15:00',1.67),('5815','2013-12-08','10:20:00',1.86),('5815','2013-12-08','10:25:00',1.15),('5815','2013-12-08','12:30:00',1.31),('5815','2013-12-08','12:45:00',1.08),('5815','2013-12-08','12:55:00',1.17),('5815','2013-12-08','13:00:00',1.69),('5815','2013-12-08','13:05:00',1.49),('5815','2013-12-08','13:10:00',1.15),('5815','2013-12-08','13:20:00',1.1),('5815','2013-12-07','11:20:00',1.07),('5815','2013-12-07','13:15:00',1.15),('5815','2013-12-07','13:20:00',1.12),('5815','2014-04-20','10:05:00',1.31),('5815','2014-04-20','10:10:00',1.78),('5815','2014-04-20','10:15:00',1.91),('5815','2014-04-20','10:20:00',1.86),('5815','2014-04-20','10:25:00',1.88),('5815','2014-04-20','10:30:00',1.89),('5815','2014-04-20','10:35:00',1.91),('5815','2014-04-20','10:40:00',1.94),('5815','2014-04-20','10:45:00',1.93),('5815','2014-04-20','10:50:00',1.99),('5815','2014-04-20','10:55:00',2.02),('5815','2014-04-20','11:00:00',2.04),('5815','2014-04-20','11:05:00',2.07),('5815','2014-04-20','11:10:00',2.09),('5815','2014-04-20','11:15:00',2.11),('5815','2014-04-20','11:20:00',2.13),('5815','2014-04-20','11:25:00',2.15),('5815','2014-04-20','11:30:00',2.18),('5815','2014-04-20','11:35:00',2.2),('5815','2014-04-20','11:40:00',2.22),('5815','2014-04-20','11:45:00',2.25),('5815','2014-04-20','11:50:00',2.28),('5815','2014-04-20','11:55:00',2.29),('5815','2014-04-20','12:00:00',2.28),('5815','2014-04-20','12:05:00',2.3),('5815','2014-04-20','12:10:00',2.33),('5815','2014-04-20','12:15:00',2.34),('5815','2014-04-20','12:20:00',2.37),('5815','2014-04-20','12:25:00',2.39),('5815','2014-04-20','12:30:00',2.4),('5815','2014-04-20','12:35:00',2.41),('5815','2014-04-20','12:40:00',2.43),('5815','2014-04-20','12:45:00',2.44),('5815','2014-04-20','12:50:00',2.45),('5815','2014-04-20','12:55:00',2.45),('5815','2014-04-20','13:00:00',2.43),('5815','2014-04-20','13:05:00',2.43),('5815','2014-04-20','13:10:00',2.45),('5815','2014-04-20','13:15:00',2.44),('5815','2014-04-20','13:20:00',2.43),('5815','2014-04-20','13:25:00',2.43),('5815','2014-04-20','13:30:00',2.42),('5815','2014-04-20','13:35:00',2.42),('5815','2014-04-20','13:40:00',2.41),('5815','2014-04-20','13:45:00',2.44),('5815','2014-04-20','13:50:00',2.46),('5815','2014-04-20','13:55:00',2.46),('5815','2014-04-20','14:00:00',2.46),('5815','2014-04-20','14:05:00',2.45),('5815','2014-04-20','14:10:00',2.42),('5815','2014-04-20','14:15:00',2.42),('5815','2014-04-20','14:20:00',2.41),('5815','2014-04-20','14:25:00',2.4),('5815','2014-04-20','14:30:00',2.39),('5815','2014-04-20','14:35:00',2.36),('5815','2014-04-20','14:40:00',2.35),('5815','2014-04-20','14:45:00',2.33),('5815','2014-04-20','14:50:00',2.31),('5815','2014-04-20','14:55:00',2.29),('5815','2014-04-20','15:00:00',2.27),('5815','2014-04-20','15:05:00',2.24),('5815','2014-04-20','15:10:00',2.22),('5815','2014-04-20','15:15:00',2.19),('5815','2014-04-20','15:20:00',2.16),('5815','2014-04-20','15:25:00',2.14),('5815','2014-04-20','15:30:00',2.11),('5815','2014-04-20','15:35:00',2.08),('5815','2014-04-20','15:40:00',2.04),('5815','2014-04-20','15:45:00',2.01),('5815','2014-04-20','15:50:00',1.97),('5815','2014-04-20','15:55:00',1.95),('5815','2014-04-20','16:00:00',1.91),('5815','2014-04-20','16:05:00',1.88),('5815','2014-04-20','16:10:00',1.75),('5815','2014-04-20','16:15:00',1.41),('5815','2014-04-20','16:20:00',1.79),('5815','2014-04-20','16:25:00',1.72),('5815','2014-04-20','16:30:00',1.64),('5815','2014-04-20','16:35:00',1.63),('5815','2014-04-20','16:40:00',1.62),('5815','2014-04-20','16:45:00',1.59),('5815','2014-04-20','16:50:00',1.54),('5815','2014-04-20','16:55:00',1.48),('5815','2014-04-20','17:00:00',1.43),('5815','2014-04-20','17:05:00',1.39),('5815','2014-04-20','17:10:00',1.34),('5815','2014-04-20','17:15:00',1.29),('5815','2014-04-20','17:20:00',1.24),('5815','2014-04-20','17:25:00',1.18),('5815','2014-04-20','17:30:00',1.14),('5815','2014-04-20','17:35:00',1.07),('5815','2013-12-06','09:10:00',1.01),('5815','2013-12-06','09:15:00',1.07),('5815','2013-12-06','09:20:00',1.11),('5815','2013-12-06','09:25:00',1.15),('5815','2013-12-06','09:30:00',1.18),('5815','2013-12-06','09:35:00',1.24),('5815','2013-12-06','09:40:00',1.28),('5815','2013-12-06','09:45:00',1.3),('5815','2013-12-06','09:50:00',1.34),('5815','2013-12-06','09:55:00',1.36),('5815','2013-12-06','10:00:00',1.41),('5815','2013-12-06','10:05:00',1.44),('5815','2013-12-06','10:10:00',1.46),('5815','2013-12-06','10:15:00',1.49),('5815','2013-12-06','10:20:00',1.5),('5815','2013-12-06','10:25:00',1.54),('5815','2013-12-06','10:30:00',1.56),('5815','2013-12-06','10:35:00',1.59),('5815','2013-12-06','10:40:00',1.62),('5815','2013-12-06','10:45:00',1.62),('5815','2013-12-06','10:50:00',1.61),('5815','2013-12-06','10:55:00',1.61),('5815','2013-12-06','11:00:00',1.63),('5815','2013-12-06','11:05:00',1.66),('5815','2013-12-06','11:10:00',1.67),('5815','2013-12-06','11:15:00',1.68),('5815','2013-12-06','11:20:00',1.7),('5815','2013-12-06','11:25:00',1.71),('5815','2013-12-06','11:30:00',1.72),('5815','2013-12-06','11:35:00',1.7),('5815','2013-12-06','11:40:00',1.71),('5815','2013-12-06','11:45:00',1.71),('5815','2013-12-06','11:50:00',1.71),('5815','2013-12-06','11:55:00',1.71),('5815','2013-12-06','12:00:00',1.7),('5815','2013-12-06','12:05:00',1.7),('5815','2013-12-06','12:10:00',1.71),('5815','2013-12-06','12:15:00',1.7),('5815','2013-12-06','12:20:00',1.7),('5815','2013-12-06','12:25:00',1.7),('5815','2013-12-06','12:30:00',1.69),('5815','2013-12-06','12:35:00',1.69),('5815','2013-12-06','12:40:00',1.68),('5815','2013-12-06','12:45:00',1.67),('5815','2013-12-06','12:50:00',1.66),('5815','2013-12-06','12:55:00',1.62),('5815','2013-12-06','13:00:00',1.65),('5815','2013-12-06','13:05:00',1.64),('5815','2013-12-06','13:10:00',1.63),('5815','2013-12-06','13:15:00',1.62),('5815','2013-12-06','13:20:00',1.61),('5815','2013-12-06','13:25:00',1.58),('5815','2013-12-06','13:30:00',1.55),('5815','2013-12-06','13:35:00',1.55),('5815','2013-12-06','13:40:00',1.53),('5815','2013-12-06','13:45:00',1.51),('5815','2013-12-06','13:50:00',1.5),('5815','2013-12-06','13:55:00',1.45),('5815','2013-12-06','14:00:00',1.42),('5815','2013-12-06','14:05:00',1.39),('5815','2013-12-06','14:10:00',1.35),('5815','2013-12-06','14:15:00',1.3),('5815','2013-12-06','14:20:00',1.26),('5815','2013-12-06','14:25:00',1.22),('5815','2013-12-06','14:30:00',1.16),('5815','2013-12-06','14:35:00',1.12),('5815','2013-12-06','14:40:00',1.07),('5815','2013-12-06','14:45:00',1.04),('5815','2013-12-05','11:40:00',1.1),('5815','2013-12-05','11:45:00',1.01),('5815','2013-12-05','11:50:00',1.22),('5815','2013-12-05','11:55:00',1.08),('5815','2013-12-05','12:05:00',1.01),('5815','2013-12-05','12:10:00',1.06),('5815','2013-12-05','12:20:00',1.16),('5815','2013-12-05','12:35:00',1.38),('5815','2013-12-05','12:40:00',1.25),('5815','2013-12-04','09:05:00',1.02),('5815','2013-12-04','09:10:00',1.07),('5815','2013-12-04','09:15:00',1.11),('5815','2013-12-04','09:20:00',1.16),('5815','2013-12-04','09:25:00',1.21),('5815','2013-12-04','09:30:00',1.24),('5815','2013-12-04','09:35:00',1.28),('5815','2013-12-04','09:40:00',1.31),('5815','2013-12-04','09:45:00',1.33),('5815','2013-12-04','09:50:00',1.38),('5815','2013-12-04','09:55:00',1.42),('5815','2013-12-04','10:00:00',1.44),('5815','2013-12-04','10:05:00',1.47),('5815','2013-12-04','10:10:00',1.51),('5815','2013-12-04','10:15:00',1.54),('5815','2013-12-04','10:20:00',1.56),('5815','2013-12-04','10:25:00',1.58),('5815','2013-12-04','10:30:00',1.62),('5815','2013-12-04','10:35:00',1.64),('5815','2013-12-04','10:40:00',1.65),('5815','2013-12-04','10:45:00',1.66),('5815','2013-12-04','10:50:00',1.68),('5815','2013-12-04','10:55:00',1.69),('5815','2013-12-04','11:00:00',1.71),('5815','2013-12-04','11:05:00',1.73),('5815','2013-12-04','11:10:00',1.7),('5815','2013-12-04','11:15:00',1.73),('5815','2013-12-04','11:20:00',1.77),('5815','2013-12-04','11:25:00',1.78),('5815','2013-12-04','11:30:00',1.8),('5815','2013-12-04','11:35:00',1.77),('5815','2013-12-04','11:40:00',1.78),('5815','2013-12-04','11:45:00',1.78),('5815','2013-12-04','11:50:00',1.77),('5815','2013-12-04','11:55:00',1.78),('5815','2013-12-04','12:00:00',1.8),('5815','2013-12-04','12:05:00',1.79),('5815','2013-12-04','12:10:00',1.76),('5815','2013-12-04','12:15:00',1.74),('5815','2013-12-04','12:20:00',1.79),('5815','2013-12-04','12:25:00',1.71),('5815','2013-12-04','12:30:00',1.72),('5815','2013-12-04','12:35:00',1.76),('5815','2013-12-04','12:40:00',1.73),('5815','2013-12-04','12:45:00',1.58),('5815','2013-12-04','12:50:00',1.56),('5815','2013-12-04','12:55:00',1.58),('5815','2013-12-04','13:00:00',1.44),('5815','2013-12-04','13:05:00',1.21),('5815','2013-12-04','13:10:00',1.46),('5815','2013-12-04','13:15:00',1.69),('5815','2013-12-04','13:20:00',1.64),('5815','2013-12-04','13:25:00',1.47),('5815','2013-12-04','13:35:00',1.46),('5815','2013-12-04','13:40:00',1.44),('5815','2013-12-04','13:45:00',1.51),('5815','2013-12-04','13:50:00',1.47),('5815','2013-12-04','13:55:00',1.39),('5815','2013-12-04','14:00:00',1.38),('5815','2013-12-04','14:05:00',1.34),('5815','2013-12-04','14:10:00',1.32),('5815','2013-12-04','14:15:00',1.26),('5815','2013-12-04','14:20:00',1.23),('5815','2013-12-04','14:25:00',1.23),('5815','2013-12-04','14:30:00',1.17),('5815','2013-12-04','14:35:00',1.14),('5815','2013-12-04','14:40:00',1.1),('5815','2013-12-04','14:45:00',1.03),('5815','2013-12-04','14:50:00',1.02),('5815','2013-12-03','08:55:00',1.03),('5815','2013-12-03','09:00:00',1.08),('5815','2013-12-03','09:05:00',1.13),('5815','2013-12-03','09:10:00',1.17),('5815','2013-12-03','09:15:00',1.21),('5815','2013-12-03','09:20:00',1.26),('5815','2013-12-03','09:25:00',1.3),('5815','2013-12-03','09:30:00',1.33),('5815','2013-12-03','09:35:00',1.38),('5815','2013-12-03','09:40:00',1.42),('5815','2013-12-03','09:45:00',1.46),('5815','2013-12-03','09:50:00',1.49),('5815','2013-12-03','09:55:00',1.52),('5815','2013-12-03','10:00:00',1.55),('5815','2013-12-03','10:05:00',1.58),('5815','2013-12-03','10:10:00',1.61),('5815','2013-12-03','10:15:00',1.63),('5815','2013-12-03','10:20:00',1.66),('5815','2013-12-03','10:25:00',1.69),('5815','2013-12-03','10:30:00',1.71),('5815','2013-12-03','10:35:00',1.73),('5815','2013-12-03','10:40:00',1.75),('5815','2013-12-03','10:45:00',1.77),('5815','2013-12-03','10:50:00',1.79),('5815','2013-12-03','10:55:00',1.81),('5815','2013-12-03','11:00:00',1.81),('5815','2013-12-03','11:05:00',1.83),('5815','2013-12-03','11:10:00',1.84),('5815','2013-12-03','11:15:00',1.85),('5815','2013-12-03','11:20:00',1.85),('5815','2013-12-03','11:25:00',1.86),('5815','2013-12-03','11:30:00',1.87),('5815','2013-12-03','11:35:00',1.88),('5815','2013-12-03','11:40:00',1.88),('5815','2013-12-03','11:45:00',1.89),('5815','2013-12-03','11:50:00',1.89),('5815','2013-12-03','11:55:00',1.9),('5815','2013-12-03','12:00:00',1.9),('5815','2013-12-03','12:05:00',1.89),('5815','2013-12-03','12:10:00',1.89),('5815','2013-12-03','12:15:00',1.85),('5815','2013-12-03','12:20:00',1.88),('5815','2013-12-03','12:25:00',1.88),('5815','2013-12-03','12:30:00',1.87),('5815','2013-12-03','12:35:00',1.85),('5815','2013-12-03','12:40:00',1.85),('5815','2013-12-03','12:45:00',1.84),('5815','2013-12-03','12:50:00',1.82),('5815','2013-12-03','12:55:00',1.81),('5815','2013-12-03','13:00:00',1.8),('5815','2013-12-03','13:05:00',1.79),('5815','2013-12-03','13:10:00',1.76),('5815','2013-12-03','13:15:00',1.74),('5815','2013-12-03','13:20:00',1.72),('5815','2013-12-03','13:25:00',1.7),('5815','2013-12-03','13:30:00',1.68),('5815','2013-12-03','13:35:00',1.66),('5815','2013-12-03','13:40:00',1.62),('5815','2013-12-03','13:45:00',1.6),('5815','2013-12-03','13:50:00',1.58),('5815','2013-12-03','13:55:00',1.55),('5815','2013-12-03','14:00:00',1.52),('5815','2013-12-03','14:05:00',1.49),('5815','2013-12-03','14:10:00',1.47),('5815','2013-12-03','14:15:00',1.42),('5815','2013-12-03','14:20:00',1.39),('5815','2013-12-03','14:25:00',1.34),('5815','2013-12-03','14:30:00',1.3),('5815','2013-12-03','14:35:00',1.28),('5815','2013-12-03','14:40:00',1.25),('5815','2013-12-03','14:45:00',1.2),('5815','2013-12-03','14:50:00',1.15),('5815','2013-12-03','14:55:00',1.11),('5815','2013-12-03','15:00:00',1.05),('5815','2013-12-03','15:05:00',1),('5815','2013-12-02','09:40:00',1.04),('5815','2013-12-02','09:45:00',1.14),('5815','2013-12-02','09:50:00',1.26),('5815','2013-12-02','09:55:00',1.25),('5815','2013-12-02','10:00:00',1.56),('5815','2013-12-02','10:05:00',1.56),('5815','2013-12-02','10:10:00',1.61),('5815','2013-12-02','10:15:00',1.63),('5815','2013-12-02','10:20:00',1.65),('5815','2013-12-02','10:25:00',1.68),('5815','2013-12-02','10:30:00',1.7),('5815','2013-12-02','10:35:00',1.72),('5815','2013-12-02','10:40:00',1.74),('5815','2013-12-02','10:45:00',1.75),('5815','2013-12-02','10:50:00',1.78),('5815','2013-12-02','10:55:00',1.79),('5815','2013-12-02','11:00:00',1.84),('5815','2013-12-02','11:05:00',1.87),('5815','2013-12-02','11:10:00',1.89),('5815','2013-12-02','11:15:00',1.9),('5815','2013-12-02','11:20:00',1.91),('5815','2013-12-02','11:25:00',1.9),('5815','2013-12-02','11:30:00',1.9),('5815','2013-12-02','11:35:00',1.9),('5815','2013-12-02','11:40:00',1.91),('5815','2013-12-02','11:45:00',1.92),('5815','2013-12-02','11:50:00',1.92),('5815','2013-12-02','11:55:00',1.93),('5815','2013-12-02','12:00:00',1.93),('5815','2013-12-02','12:05:00',1.94),('5815','2013-12-02','12:10:00',1.91),('5815','2013-12-02','12:15:00',1.95),('5815','2013-12-02','12:20:00',1.95),('5815','2013-12-02','12:25:00',1.96),('5815','2013-12-02','12:30:00',1.97),('5815','2013-12-02','12:35:00',1.99),('5815','2013-12-02','12:40:00',2),('5815','2013-12-02','12:45:00',2.03),('5815','2013-12-02','12:50:00',2.08),('5815','2013-12-02','12:55:00',2.12),('5815','2013-12-02','13:00:00',2.14),('5815','2013-12-02','13:05:00',2.18),('5815','2013-12-02','13:10:00',2.17),('5815','2013-12-02','13:15:00',2.08),('5815','2013-12-02','13:20:00',2.07),('5815','2013-12-02','13:25:00',1.98),('5815','2013-12-02','13:30:00',1.94),('5815','2013-12-02','13:35:00',1.89),('5815','2013-12-02','13:40:00',1.8),('5815','2013-12-02','13:45:00',1.76),('5815','2013-12-02','13:50:00',1.72),('5815','2013-12-02','13:55:00',1.65),('5815','2013-12-02','14:00:00',1.63),('5815','2013-12-02','14:05:00',1.55),('5815','2013-12-02','14:10:00',1.47),('5815','2013-12-02','14:15:00',1.39),('5815','2013-12-02','14:20:00',1.18),('5815','2013-12-02','14:25:00',1.1),('5815','2013-12-02','14:30:00',1.21),('5815','2013-12-02','14:35:00',1.27),('5815','2013-12-02','14:40:00',1.23),('5815','2013-12-02','14:45:00',1.18),('5815','2013-12-02','14:50:00',1.13),('5815','2013-12-02','14:55:00',1.06),('5815','2013-12-02','15:00:00',1.02),('5815','2013-11-29','09:15:00',1.09),('5815','2013-11-29','09:20:00',1.22),('5815','2013-11-29','09:25:00',1.2),('5815','2013-11-29','09:30:00',1.11),('5815','2013-11-29','09:35:00',1.26),('5815','2013-11-29','09:40:00',1.43),('5815','2013-11-29','09:45:00',1.19),('5815','2013-11-28','08:55:00',1.03),('5815','2013-11-28','09:00:00',1.08),('5815','2013-11-28','09:05:00',1.13),('5815','2013-11-28','09:10:00',1.17),('5815','2013-11-28','09:15:00',1.22),('5815','2013-11-28','09:20:00',1.27),('5815','2013-11-28','09:25:00',1.3),('5815','2013-11-28','09:30:00',1.35),('5815','2013-11-28','09:35:00',1.39),('5815','2013-11-28','09:40:00',1.44),('5815','2013-11-28','09:45:00',1.47),('5815','2013-11-28','09:50:00',1.51),('5815','2013-11-28','09:55:00',1.55),('5815','2013-11-28','10:00:00',1.57),('5815','2013-11-28','10:05:00',1.61),('5815','2013-11-28','10:10:00',1.64),('5815','2013-11-28','10:15:00',1.66),('5815','2013-11-28','10:20:00',1.69),('5815','2013-11-28','10:25:00',1.71),('5815','2013-11-28','10:30:00',1.74),('5815','2013-11-28','10:35:00',1.76),('5815','2013-11-28','10:40:00',1.77),('5815','2013-11-28','10:45:00',1.81),('5815','2013-11-28','10:50:00',1.83),('5815','2013-11-28','10:55:00',1.85),('5815','2013-11-28','11:00:00',1.86),('5815','2013-11-28','11:05:00',1.88),('5815','2013-11-28','11:10:00',1.89),('5815','2013-11-28','11:15:00',1.9),('5815','2013-11-28','11:20:00',1.92),('5815','2013-11-28','11:25:00',1.93),('5815','2013-11-28','11:30:00',1.94),('5815','2013-11-28','11:35:00',1.94),('5815','2013-11-28','11:40:00',1.95),('5815','2013-11-28','11:45:00',1.95),('5815','2013-11-28','11:50:00',1.95),('5815','2013-11-28','11:55:00',1.95),('5815','2013-11-28','12:00:00',1.96),('5815','2013-11-28','12:05:00',1.95),('5815','2013-11-28','12:10:00',1.93),('5815','2013-11-28','12:15:00',1.94),('5815','2013-11-28','12:20:00',1.93),('5815','2013-11-28','12:25:00',1.92),('5815','2013-11-28','12:30:00',1.92),('5815','2013-11-28','12:35:00',1.91),('5815','2013-11-28','12:40:00',1.91),('5815','2013-11-28','12:45:00',1.9),('5815','2013-11-28','12:50:00',1.89),('5815','2013-11-28','12:55:00',1.88),('5815','2013-11-28','13:00:00',1.85),('5815','2013-11-28','13:05:00',1.83),('5815','2013-11-28','13:10:00',1.82),('5815','2013-11-28','13:15:00',1.79),('5815','2013-11-28','13:20:00',1.77),('5815','2013-11-28','13:25:00',1.73),('5815','2013-11-28','13:30:00',1.71),('5815','2013-11-28','13:35:00',1.69),('5815','2013-11-28','13:40:00',1.67),('5815','2013-11-28','13:45:00',1.64),('5815','2013-11-28','13:50:00',1.62),('5815','2013-11-28','13:55:00',1.57),('5815','2013-11-28','14:00:00',1.54),('5815','2013-11-28','14:05:00',1.5),('5815','2013-11-28','14:10:00',1.47),('5815','2013-11-28','14:15:00',1.43),('5815','2013-11-28','14:20:00',1.39),('5815','2013-11-28','14:25:00',1.35),('5815','2013-11-28','14:30:00',1.31),('5815','2013-11-28','14:35:00',1.27),('5815','2013-11-28','14:40:00',1.21),('5815','2013-11-28','14:45:00',1.17),('5815','2013-11-28','14:50:00',1.13),('5815','2013-11-28','14:55:00',1.06),('5815','2013-11-28','15:00:00',1.03),('5815','2014-04-19','08:25:00',1.15),('5815','2014-04-19','08:30:00',1.23),('5815','2014-04-19','08:35:00',1.24),('5815','2014-04-19','08:40:00',1.03),('5815','2014-04-19','08:50:00',1.11),('5815','2014-04-19','09:15:00',1.36),('5815','2014-04-19','09:20:00',1.5),('5815','2014-04-19','09:25:00',1.64),('5815','2014-04-19','09:30:00',1.87),('5815','2014-04-19','09:35:00',1.7),('5815','2014-04-19','09:55:00',1.05),('5815','2014-04-19','10:00:00',1.25),('5815','2014-04-19','10:05:00',1.78),('5815','2014-04-19','10:10:00',1.44),('5815','2014-04-19','10:15:00',1.57),('5815','2014-04-19','10:20:00',1.62),('5815','2014-04-19','10:25:00',1.48),('5815','2014-04-19','10:30:00',1.4),('5815','2014-04-19','10:35:00',1.49),('5815','2014-04-19','10:40:00',1.46),('5815','2014-04-19','10:45:00',1.46),('5815','2014-04-19','10:50:00',1.64),('5815','2014-04-19','10:55:00',1.79),('5815','2014-04-19','11:00:00',1.95),('5815','2014-04-19','11:05:00',1.92),('5815','2014-04-19','11:10:00',1.79),('5815','2014-04-19','11:15:00',1.96),('5815','2014-04-19','11:20:00',1.95),('5815','2014-04-19','11:25:00',1.85),('5815','2014-04-19','11:30:00',2.4),('5815','2014-04-19','11:35:00',2.52),('5815','2014-04-19','11:40:00',1.9),('5815','2014-04-19','11:45:00',2.23),('5815','2014-04-19','11:50:00',2.17),('5815','2014-04-19','12:00:00',1.72),('5815','2014-04-19','12:05:00',1.51),('5815','2014-04-19','12:10:00',1.93),('5815','2014-04-19','12:15:00',2.05),('5815','2014-04-19','12:25:00',2.08),('5815','2014-04-19','12:30:00',2.67),('5815','2014-04-19','12:35:00',2.52),('5815','2014-04-19','12:40:00',2.52),('5815','2014-04-19','12:45:00',2.53),('5815','2014-04-19','12:50:00',2.56),('5815','2014-04-19','12:55:00',2.58),('5815','2014-04-19','13:00:00',2.61),('5815','2014-04-19','13:05:00',2.61),('5815','2014-04-19','13:10:00',2.68),('5815','2014-04-19','13:15:00',2.6),('5815','2014-04-19','13:20:00',2.56),('5815','2014-04-19','13:25:00',2.55),('5815','2014-04-19','13:30:00',2.56),('5815','2014-04-19','13:35:00',2.57),('5815','2014-04-19','13:40:00',2.57),('5815','2014-04-19','13:45:00',2.56),('5815','2014-04-19','13:50:00',2.55),('5815','2014-04-19','13:55:00',2.53),('5815','2014-04-19','14:00:00',2.52),('5815','2014-04-19','14:05:00',2.52),('5815','2014-04-19','14:10:00',2.53),('5815','2014-04-19','14:15:00',2.61),('5815','2014-04-19','14:20:00',2.16),('5815','2014-04-19','14:25:00',1.85),('5815','2014-04-19','14:30:00',1.8),('5815','2014-04-19','14:35:00',1.43),('5815','2014-04-19','14:40:00',1.41),('5815','2014-04-19','14:45:00',1.52),('5815','2014-04-19','14:50:00',1.45),('5815','2014-04-19','14:55:00',1.65),('5815','2014-04-19','15:00:00',2.08),('5815','2014-04-19','15:05:00',2.24),('5815','2014-04-19','15:10:00',2.14),('5815','2014-04-19','15:15:00',2.31),('5815','2014-04-19','15:20:00',2.21),('5815','2014-04-19','15:25:00',2.21),('5815','2014-04-19','15:30:00',2.18),('5815','2014-04-19','15:35:00',2.15),('5815','2014-04-19','15:40:00',2.16),('5815','2014-04-19','15:45:00',1.95),('5815','2014-04-19','15:50:00',1.5),('5815','2014-04-19','15:55:00',2.09),('5815','2014-04-19','16:00:00',2),('5815','2014-04-19','16:05:00',1.97),('5815','2014-04-19','16:10:00',1.94),('5815','2014-04-19','16:15:00',1.92),('5815','2014-04-19','16:20:00',1.93),('5815','2014-04-19','16:25:00',1.59),('5815','2014-04-19','16:30:00',1.88),('5815','2014-04-19','16:35:00',1.66),('5815','2014-04-19','16:40:00',1.63),('5815','2014-04-19','16:45:00',1.43),('5815','2014-04-19','16:50:00',1.64),('5815','2014-04-19','16:55:00',1.62),('5815','2014-04-19','17:00:00',1.53),('5815','2014-04-19','17:05:00',1.46),('5815','2014-04-19','17:10:00',1.37),('5815','2014-04-19','17:15:00',1.31),('5815','2014-04-19','17:20:00',1.25),('5815','2014-04-19','17:25:00',1.2),('5815','2014-04-19','17:30:00',1.14),('5815','2014-04-19','17:35:00',1.06),('5815','2013-11-26','11:10:00',1.13),('5815','2013-11-26','11:30:00',1.28),('5815','2013-11-26','11:35:00',1.32),('5815','2013-11-26','11:50:00',1.23),('5815','2013-11-26','11:55:00',2.07),('5815','2013-11-26','12:00:00',2.17),('5815','2013-11-26','12:05:00',1.7),('5815','2013-11-26','12:15:00',1.36),('5815','2013-11-26','12:20:00',2),('5815','2013-11-26','12:30:00',1.55),('5815','2013-11-26','12:35:00',1.06),('5815','2013-11-25','09:40:00',1.3),('5815','2013-11-25','09:50:00',1.02),('5815','2013-11-25','09:55:00',1.29),('5815','2013-11-25','10:00:00',1.19),('5815','2013-11-25','10:05:00',1.47),('5815','2013-11-25','10:25:00',1.22),('5815','2013-11-25','10:30:00',1.76),('5815','2013-11-25','10:35:00',1.94),('5815','2013-11-25','10:40:00',1.94),('5815','2013-11-25','10:45:00',1.95),('5815','2013-11-25','10:50:00',1.99),('5815','2013-11-25','10:55:00',2.02),('5815','2013-11-25','11:00:00',2.14),('5815','2013-11-25','11:05:00',1.62),('5815','2013-11-25','11:10:00',2.2),('5815','2013-11-25','11:15:00',2.4),('5815','2013-11-25','11:20:00',2.27),('5815','2013-11-25','11:25:00',2.28),('5815','2013-11-25','11:30:00',2.31),('5815','2013-11-25','11:35:00',2.33),('5815','2013-11-25','11:40:00',2.22),('5815','2013-11-25','11:45:00',2.08),('5815','2013-11-25','11:50:00',1.87),('5815','2013-11-25','12:05:00',1.01),('5815','2013-11-25','12:15:00',1.05),('5815','2013-11-25','12:20:00',2.16),('5815','2013-11-25','12:25:00',2.1),('5815','2013-11-25','12:30:00',2.06),('5815','2013-11-25','12:35:00',2.06),('5815','2013-11-25','12:40:00',2.07),('5815','2013-11-25','12:45:00',2.05),('5815','2013-11-25','12:50:00',2.04),('5815','2013-11-25','12:55:00',2.04),('5815','2013-11-25','13:00:00',2.02),('5815','2013-11-25','13:05:00',2),('5815','2013-11-25','13:10:00',1.99),('5815','2013-11-25','13:15:00',1.97),('5815','2013-11-25','13:20:00',1.95),('5815','2013-11-25','13:25:00',1.92),('5815','2013-11-25','13:30:00',1.89),('5815','2013-11-25','13:35:00',1.86),('5815','2013-11-25','13:40:00',1.84),('5815','2013-11-25','13:45:00',1.82),('5815','2013-11-25','13:50:00',1.83),('5815','2013-11-25','13:55:00',1.77),('5815','2013-11-25','14:00:00',1.67),('5815','2013-11-25','14:05:00',1.26),('5815','2013-11-25','14:10:00',1.97),('5815','2013-11-25','14:15:00',2.05),('5815','2013-11-25','14:20:00',1.78),('5815','2013-11-25','14:25:00',1.08),('5815','2013-11-25','14:30:00',1.06),('5815','2013-11-25','14:35:00',1.27),('5815','2013-11-25','14:40:00',1.35),('5815','2013-11-25','14:45:00',1.39),('5815','2013-11-25','14:50:00',1.53),('5815','2013-11-25','14:55:00',1.57),('5815','2013-11-25','15:00:00',1.48),('5815','2013-11-25','15:05:00',1.34),('5815','2013-11-25','15:10:00',1.18),('5815','2013-11-25','15:15:00',1.09),('5815','2013-11-25','15:20:00',1.02),('5815','2013-11-24','08:40:00',1.02),('5815','2013-11-24','08:45:00',1.11),('5815','2013-11-24','08:50:00',1.19),('5815','2013-11-24','08:55:00',1.29),('5815','2013-11-24','09:00:00',1.41),('5815','2013-11-24','09:05:00',1.46),('5815','2013-11-24','09:10:00',1.48),('5815','2013-11-24','09:15:00',1.54),('5815','2013-11-24','09:20:00',1.62),('5815','2013-11-24','09:25:00',1.67),('5815','2013-11-24','09:30:00',1.51),('5815','2013-11-24','09:35:00',1.48),('5815','2013-11-24','09:40:00',1.27),('5815','2013-11-24','10:15:00',1.02),('5815','2013-11-24','10:20:00',1.08),('5815','2013-11-24','10:25:00',1.07),('5815','2013-11-24','10:30:00',1.51),('5815','2013-11-24','10:35:00',2.29),('5815','2013-11-24','10:40:00',2.18),('5815','2013-11-24','10:45:00',1.96),('5815','2013-11-24','10:50:00',1.71),('5815','2013-11-24','10:55:00',1.69),('5815','2013-11-24','11:00:00',1.92),('5815','2013-11-24','11:05:00',2.04),('5815','2013-11-24','11:10:00',2.29),('5815','2013-11-24','11:15:00',1.23),('5815','2013-11-24','11:20:00',1.04),('5815','2013-11-24','11:50:00',1.12),('5815','2013-11-24','11:55:00',1.37),('5815','2013-11-24','12:10:00',1.37),('5815','2013-11-24','12:15:00',1.07),('5815','2013-11-24','12:40:00',1.97),('5815','2013-11-24','12:45:00',2.02),('5815','2013-11-24','12:50:00',1.41),('5815','2013-11-24','12:55:00',1.78),('5815','2013-11-24','13:00:00',2.28),('5815','2013-11-24','13:05:00',2.25),('5815','2013-11-24','13:10:00',1.34),('5815','2013-11-24','13:15:00',1.36),('5815','2013-11-24','13:20:00',1.46),('5815','2013-11-23','10:25:00',1.05),('5815','2013-11-23','10:30:00',1.1),('5815','2013-11-22','10:30:00',1.09),('5815','2013-11-22','10:40:00',1.73),('5815','2013-11-20','09:45:00',1.41),('5815','2013-11-20','09:50:00',1.37),('5815','2013-11-20','09:55:00',1.2),('5815','2013-11-20','10:00:00',1.01),('5815','2013-11-20','10:05:00',1.7),('5815','2013-11-20','10:10:00',1.57),('5815','2013-11-20','10:15:00',1.76),('5815','2013-11-20','10:20:00',1.76),('5815','2013-11-20','10:25:00',1.24),('5815','2013-11-20','10:30:00',1.53),('5815','2013-11-20','10:35:00',1.77),('5815','2013-11-20','10:40:00',1.87),('5815','2013-11-20','10:45:00',1.46),('5815','2013-11-20','11:25:00',1.39),('5815','2013-11-20','11:30:00',1.97),('5815','2013-11-20','11:35:00',1.2),('5815','2013-11-20','11:40:00',2.04),('5815','2013-11-20','11:45:00',1.57),('5815','2013-11-20','11:50:00',2.04),('5815','2013-11-20','11:55:00',2.02),('5815','2013-11-20','12:00:00',1.41),('5815','2013-11-20','12:05:00',1.98),('5815','2013-11-20','12:10:00',2.05),('5815','2013-11-20','12:15:00',2.05),('5815','2013-11-20','12:20:00',2.04),('5815','2013-11-20','12:25:00',2.08),('5815','2013-11-20','12:30:00',2.17),('5815','2013-11-20','12:35:00',2.2),('5815','2013-11-20','12:40:00',2.27),('5815','2013-11-20','12:45:00',2.14),('5815','2013-11-20','12:50:00',2.07),('5815','2013-11-20','12:55:00',2.27),('5815','2013-11-20','13:00:00',2.23),('5815','2013-11-20','13:05:00',1.93),('5815','2013-11-20','13:10:00',1.25),('5815','2013-11-20','13:15:00',1.92),('5815','2013-11-20','13:20:00',2.02),('5815','2013-11-20','13:25:00',1.66),('5815','2013-11-20','13:40:00',1.23),('5815','2013-11-20','13:45:00',1.9),('5815','2013-11-20','13:55:00',1.66),('5815','2013-11-20','14:00:00',1.74),('5815','2013-11-20','14:40:00',1.34),('5815','2013-11-20','14:45:00',1.28),('5815','2013-11-20','14:50:00',1.2),('5815','2013-11-20','14:55:00',1),('5815','2013-11-20','15:00:00',1.11),('5815','2013-11-20','15:05:00',1.05),('5815','2013-11-20','15:10:00',1),('5815','2013-11-19','09:15:00',1.26),('5815','2013-11-19','09:20:00',1.27),('5815','2013-11-19','09:25:00',1.42),('5815','2013-11-19','09:30:00',1.46),('5815','2013-11-19','10:00:00',1.07),('5815','2013-11-19','10:15:00',1.21),('5815','2013-11-19','11:45:00',2.11),('5815','2013-11-19','11:50:00',2.19),('5815','2013-11-19','12:20:00',1.66),('5815','2013-11-19','12:55:00',1.11),('5815','2013-11-19','13:00:00',1.5),('5815','2013-11-19','13:05:00',1.31),('5815','2013-11-19','13:20:00',1.05),('5815','2013-11-19','13:40:00',1.27),('5815','2013-11-19','13:50:00',1.46),('5815','2013-11-19','14:45:00',1.02),('5815','2013-11-19','15:10:00',1.13),('5815','2013-11-18','09:40:00',1.41),('5815','2013-11-18','09:45:00',1.39),('5815','2013-11-18','10:05:00',1.01),('5815','2013-11-18','11:20:00',1.64),('5815','2013-11-18','11:25:00',1.46),('5815','2013-11-18','11:30:00',1.75),('5815','2013-11-18','11:35:00',1.83),('5815','2013-11-18','11:40:00',1.8),('5815','2013-11-18','11:45:00',1.78),('5815','2013-11-18','11:50:00',1.8),('5815','2013-11-18','11:55:00',1.82),('5815','2013-11-18','12:00:00',1.71),('5815','2013-11-18','12:05:00',1.65),('5815','2013-11-18','12:10:00',1.83),('5815','2013-11-18','12:15:00',1.85),('5815','2013-11-18','12:20:00',1.15),('5815','2013-11-18','12:45:00',1.46),('5815','2013-11-18','12:55:00',2.12),('5815','2013-11-18','13:00:00',1.73),('5815','2013-11-18','13:15:00',1.38),('5815','2013-11-18','13:20:00',1.76),('5815','2013-11-18','15:30:00',1.19),('5815','2013-11-17','09:20:00',1.04),('5815','2013-11-17','09:25:00',1.08),('5815','2013-11-17','09:30:00',1.01),('5815','2013-11-17','09:35:00',1.35),('5815','2013-11-17','09:40:00',1.07),('5815','2013-11-17','10:15:00',1.11),('5815','2013-11-17','12:25:00',1.03),('5815','2014-04-18','08:35:00',1.21),('5815','2014-04-18','08:40:00',1.13),('5815','2014-04-18','08:45:00',1.03),('5815','2014-04-18','09:30:00',1.18),('5815','2014-04-18','09:35:00',1.2),('5815','2014-04-18','11:20:00',1.78),('5815','2014-04-18','11:25:00',1.51),('5815','2014-04-18','11:30:00',1.53),('5815','2014-04-18','11:35:00',1.34),('5815','2014-04-18','11:40:00',1.58),('5815','2014-04-18','11:45:00',1.18),('5815','2014-04-18','14:45:00',1.03),('5815','2014-04-18','15:50:00',1.52),('5815','2014-04-18','15:55:00',1.92),('5815','2014-04-18','16:00:00',1.04),('5815','2014-04-18','16:20:00',1.07),('5815','2014-04-18','16:25:00',1.08),('5815','2014-04-18','16:30:00',1.67),('5815','2013-11-16','08:55:00',1.41),('5815','2013-11-16','09:00:00',1.31),('5815','2013-11-16','09:05:00',1.25),('5815','2013-11-16','09:10:00',1.27),('5815','2013-11-16','09:15:00',1.3),('5815','2013-11-16','09:20:00',1.14),('5815','2013-11-16','09:25:00',1.4),('5815','2013-11-16','09:30:00',1.43),('5815','2013-11-16','09:35:00',1.44),('5815','2013-11-16','09:40:00',1.48),('5815','2013-11-16','09:45:00',1.49),('5815','2013-11-16','09:50:00',1.53),('5815','2013-11-16','09:55:00',1.56),('5815','2013-11-16','10:00:00',1.59),('5815','2013-11-16','10:05:00',1.62),('5815','2013-11-16','10:10:00',1.65),('5815','2013-11-16','10:15:00',1.68),('5815','2013-11-16','10:20:00',1.69),('5815','2013-11-16','10:25:00',1.71),('5815','2013-11-16','10:30:00',1.73),('5815','2013-11-16','10:35:00',1.74),('5815','2013-11-16','10:40:00',1.76),('5815','2013-11-16','10:45:00',1.78),('5815','2013-11-16','10:50:00',1.79),('5815','2013-11-16','10:55:00',1.8),('5815','2013-11-16','11:00:00',1.8),('5815','2013-11-16','11:05:00',1.82),('5815','2013-11-16','11:10:00',1.83),('5815','2013-11-16','11:15:00',1.84),('5815','2013-11-16','11:20:00',1.85),('5815','2013-11-16','11:25:00',1.85),('5815','2013-11-16','11:30:00',1.85),('5815','2013-11-16','11:35:00',1.86),('5815','2013-11-16','11:40:00',1.87),('5815','2013-11-16','11:45:00',1.87),('5815','2013-11-16','11:50:00',1.87),('5815','2013-11-16','11:55:00',1.88),('5815','2013-11-16','12:00:00',1.84),('5815','2013-11-16','12:05:00',1.85),('5815','2013-11-16','12:10:00',1.85),('5815','2013-11-16','12:15:00',1.85),('5815','2013-11-16','12:20:00',1.85),('5815','2013-11-16','12:25:00',1.84),('5815','2013-11-16','12:30:00',1.82),('5815','2013-11-16','12:35:00',1.83),('5815','2013-11-16','12:40:00',1.82),('5815','2013-11-16','12:45:00',1.81),('5815','2013-11-16','12:50:00',1.79),('5815','2013-11-16','12:55:00',1.77),('5815','2013-11-16','13:00:00',1.76),('5815','2013-11-16','13:05:00',1.72),('5815','2013-11-16','13:10:00',1.73),('5815','2013-11-16','13:15:00',1.72),('5815','2013-11-16','13:20:00',1.7),('5815','2013-11-16','13:25:00',1.68),('5815','2013-11-16','13:30:00',1.43),('5815','2013-11-16','13:35:00',1.48),('5815','2013-11-16','14:00:00',1.09),('5815','2013-11-16','14:05:00',1.32),('5815','2013-11-16','14:10:00',1.42),('5815','2013-11-16','14:15:00',1.4),('5815','2013-11-16','14:20:00',1.37),('5815','2013-11-16','14:25:00',1.32),('5815','2013-11-16','14:30:00',1.23),('5815','2013-11-16','14:35:00',1.2),('5815','2013-11-16','14:40:00',1.12),('5815','2013-11-16','14:45:00',1.15),('5815','2013-11-16','14:50:00',1.14),('5815','2013-11-16','14:55:00',1.08),('5815','2013-11-14','10:55:00',1.18),('5815','2013-11-14','11:20:00',1.05),('5815','2013-11-14','11:25:00',1.71),('5815','2013-11-14','11:30:00',1),('5815','2013-11-14','11:35:00',1.03),('5815','2013-11-14','11:40:00',1.19),('5815','2013-11-14','12:25:00',1.19),('5815','2013-11-14','12:30:00',1.04),('5815','2013-11-14','12:55:00',1.04),('5815','2013-11-14','13:45:00',1.07),('5815','2013-11-14','13:50:00',1.13),('5815','2013-11-13','09:20:00',1.37),('5815','2013-11-13','09:25:00',1.37),('5815','2013-11-13','09:30:00',1.39),('5815','2013-11-13','09:35:00',1.43),('5815','2013-11-13','09:40:00',1.45),('5815','2013-11-13','09:45:00',1.44),('5815','2013-11-13','09:50:00',1.17),('5815','2013-11-13','10:05:00',1.23),('5815','2013-11-13','10:15:00',1.68),('5815','2013-11-13','10:20:00',1.71),('5815','2013-11-13','10:25:00',1.7),('5815','2013-11-13','10:30:00',1.7),('5815','2013-11-13','10:35:00',1.7),('5815','2013-11-13','10:40:00',1.73),('5815','2013-11-13','10:45:00',1.74),('5815','2013-11-13','10:50:00',1.76),('5815','2013-11-13','10:55:00',1.75),('5815','2013-11-13','11:00:00',1.75),('5815','2013-11-13','11:05:00',1.82),('5815','2013-11-13','11:10:00',1.87),('5815','2013-11-13','11:15:00',1.91),('5815','2013-11-13','11:20:00',1.92),('5815','2013-11-13','11:25:00',1.95),('5815','2013-11-13','11:30:00',1.96),('5815','2013-11-13','11:35:00',1.9),('5815','2013-11-13','11:40:00',1.64),('5815','2013-11-13','11:45:00',1.06),('5815','2013-11-13','11:50:00',1.13),('5815','2013-11-13','11:55:00',1.69),('5815','2013-11-13','12:00:00',1.37),('5815','2013-11-13','12:15:00',1.05),('5815','2013-11-12','10:30:00',1.05),('5815','2013-11-12','10:35:00',2.02),('5815','2013-11-12','10:40:00',1.82),('5815','2013-11-12','10:45:00',1.75),('5815','2013-11-12','10:50:00',2.31),('5815','2013-11-12','10:55:00',2.16),('5815','2013-11-12','11:00:00',2.12),('5815','2013-11-12','13:55:00',1.18),('5815','2013-11-12','14:00:00',1.35),('5815','2013-11-12','14:05:00',1.31),('5815','2013-11-12','14:10:00',1.13),('5815','2013-11-12','14:15:00',1.22),('5815','2013-11-12','14:20:00',1.07),('5815','2013-11-12','14:25:00',1.12),('5815','2013-11-12','14:30:00',1.06),('5815','2013-11-11','11:40:00',1.7),('5815','2013-11-11','11:45:00',1.01),('5815','2013-11-11','12:00:00',1.86),('5815','2013-11-11','12:30:00',2.49),('5815','2013-11-11','12:35:00',1.9),('5815','2013-11-11','12:40:00',1.18),('5815','2013-11-11','12:45:00',1.12),('5815','2013-11-11','12:55:00',1.17),('5815','2013-11-11','13:00:00',1.15),('5815','2013-11-11','13:05:00',1.35),('5815','2013-11-11','13:10:00',1.63),('5815','2013-11-11','13:15:00',2.48),('5815','2013-11-11','13:20:00',1.9),('5815','2013-11-11','13:25:00',1.49),('5815','2013-11-11','13:30:00',1.12),('5815','2013-11-11','13:35:00',1.45),('5815','2013-11-11','13:40:00',2.22),('5815','2013-11-11','13:45:00',1.15),('5815','2013-11-11','14:10:00',1.09),('5815','2013-11-11','14:15:00',1.86),('5815','2013-11-11','14:20:00',1.88),('5815','2013-11-11','14:25:00',1.81),('5815','2013-11-11','14:30:00',1.46),('5815','2013-11-11','14:35:00',1.16),('5815','2013-11-11','14:40:00',1.53),('5815','2013-11-11','14:45:00',1.31),('5815','2013-11-11','14:50:00',1.11),('5815','2013-11-10','10:15:00',1.26),('5815','2013-11-10','10:20:00',1.99),('5815','2013-11-10','10:25:00',1.05),('5815','2013-11-10','11:10:00',1.48),('5815','2013-11-10','11:15:00',1.23),('5815','2013-11-10','11:20:00',1.05),('5815','2013-11-10','11:25:00',2.19),('5815','2013-11-10','11:35:00',1.83),('5815','2013-11-10','11:40:00',2.4),('5815','2013-11-10','11:45:00',2.41),('5815','2013-11-10','11:50:00',2.46),('5815','2013-11-10','11:55:00',2.28),('5815','2013-11-10','12:00:00',2.17),('5815','2013-11-10','12:05:00',2.13),('5815','2013-11-10','12:10:00',2.11),('5815','2013-11-10','12:15:00',2.12),('5815','2013-11-10','12:20:00',2.01),('5815','2013-11-10','12:25:00',1.69),('5815','2013-11-10','12:30:00',2.1),('5815','2013-11-10','12:35:00',1.15),('5815','2013-11-10','12:40:00',1.5),('5815','2013-11-10','12:45:00',1.16),('5815','2013-11-10','13:10:00',2),('5815','2013-11-10','13:15:00',1.39),('5815','2013-11-10','13:35:00',1.11),('5815','2013-11-10','13:40:00',1.19),('5815','2013-11-10','14:15:00',1.3),('5815','2013-11-10','14:20:00',1.63),('5815','2013-11-10','14:25:00',1.6),('5815','2013-11-10','14:30:00',1.52),('5815','2013-11-10','14:35:00',1.47),('5815','2013-11-10','14:40:00',1.25),('5815','2013-11-09','08:50:00',1.01),('5815','2013-11-09','08:55:00',1.25),('5815','2013-11-09','09:15:00',1.01),('5815','2013-11-09','09:20:00',1.32),('5815','2013-11-09','09:25:00',1.46),('5815','2013-11-09','09:30:00',1.3),('5815','2013-11-09','09:35:00',1.31),('5815','2013-11-09','09:40:00',1.39),('5815','2013-11-09','09:45:00',1.53),('5815','2013-11-09','09:50:00',1.59),('5815','2013-11-09','09:55:00',1.66),('5815','2013-11-09','10:00:00',1.61),('5815','2013-11-09','10:05:00',1.79),('5815','2013-11-09','10:10:00',1.83),('5815','2013-11-09','10:15:00',1.83),('5815','2013-11-09','10:20:00',1.68),('5815','2013-11-09','10:25:00',1.88),('5815','2013-11-09','10:30:00',2.01),('5815','2013-11-09','10:35:00',1.81),('5815','2013-11-09','10:40:00',1.49),('5815','2013-11-09','10:45:00',1.46),('5815','2013-11-09','10:50:00',1.61),('5815','2013-11-09','10:55:00',1.65),('5815','2013-11-09','11:00:00',1.53),('5815','2013-11-09','11:05:00',1.19),('5815','2013-11-09','11:45:00',1.29),('5815','2013-11-09','11:50:00',1.01),('5815','2013-11-09','12:10:00',1.21),('5815','2013-11-09','12:15:00',2.06),('5815','2013-11-09','12:20:00',2.09),('5815','2013-11-09','12:25:00',1.92),('5815','2013-11-09','12:30:00',1.42),('5815','2013-11-09','12:35:00',1.17),('5815','2013-11-09','12:40:00',2.11),('5815','2013-11-09','12:45:00',2.2),('5815','2013-11-09','12:50:00',2.15),('5815','2013-11-09','13:50:00',1.42),('5815','2013-11-09','13:55:00',1.47),('5815','2013-11-08','09:40:00',1.73),('5815','2013-11-08','09:45:00',1.13),('5815','2013-11-08','09:50:00',1.63),('5815','2013-11-08','09:55:00',1.84),('5815','2013-11-08','10:00:00',1.76),('5815','2013-11-08','10:05:00',1.63),('5815','2013-11-08','10:10:00',1.55),('5815','2013-11-08','10:15:00',1.48),('5815','2013-11-08','10:20:00',1.66),('5815','2013-11-08','10:25:00',1.82),('5815','2013-11-08','10:55:00',1.25),('5815','2013-11-08','11:00:00',1.46),('5815','2013-11-08','11:05:00',2.21),('5815','2013-11-08','11:10:00',1.93),('5815','2013-11-08','11:15:00',2.47),('5815','2013-11-08','11:20:00',1.8),('5815','2013-11-08','11:30:00',1.89),('5815','2013-11-08','11:35:00',1.94),('5815','2013-11-08','11:40:00',1.65),('5815','2013-11-08','11:45:00',1.38),('5815','2013-11-08','11:55:00',1.4),('5815','2013-11-08','12:00:00',1.59),('5815','2013-11-08','12:05:00',1.83),('5815','2013-11-08','12:10:00',1.32),('5815','2013-11-08','12:15:00',1.38),('5815','2013-11-08','12:30:00',1.38),('5815','2013-11-08','12:35:00',1.98),('5815','2013-11-08','12:40:00',1.17),('5815','2013-11-08','12:45:00',1.03),('5815','2013-11-08','12:50:00',1.78),('5815','2013-11-08','12:55:00',1.67),('5815','2013-11-08','13:00:00',2.2),('5815','2013-11-08','13:05:00',1.96),('5815','2013-11-08','13:10:00',2.05),('5815','2013-11-08','13:15:00',2.07),('5815','2013-11-08','13:20:00',1.39),('5815','2013-11-08','13:25:00',1.52),('5815','2013-11-08','13:30:00',1.92),('5815','2013-11-08','13:35:00',1.85),('5815','2013-11-08','13:40:00',1.7),('5815','2013-11-08','13:45:00',1.72),('5815','2013-11-08','13:50:00',1.7),('5815','2013-11-08','13:55:00',1.69),('5815','2013-11-08','14:00:00',1.52),('5815','2013-11-08','14:05:00',1.46),('5815','2013-11-08','14:10:00',1.01),('5815','2013-11-08','14:20:00',1.6),('5815','2013-11-08','14:25:00',1.3),('5815','2013-11-08','14:40:00',1.14),('5815','2013-11-08','14:50:00',1.12),('5815','2013-11-07','09:20:00',1.27),('5815','2013-11-07','09:25:00',1.3),('5815','2013-11-07','09:30:00',1.41),('5815','2013-11-07','09:35:00',1.49),('5815','2013-11-07','09:40:00',1.12),('5815','2013-11-07','09:50:00',1.29),('5815','2013-11-07','10:05:00',1.17),('5815','2013-11-07','10:10:00',1.75),('5815','2013-11-07','10:50:00',1.53),('5815','2013-11-07','10:55:00',1.45),('5815','2013-11-07','11:25:00',1.84),('5815','2013-11-07','11:30:00',2.28),('5815','2013-11-07','11:35:00',2.23),('5815','2013-11-07','11:40:00',2.16),('5815','2013-11-07','11:45:00',2.14),('5815','2013-11-07','11:50:00',2.15),('5815','2013-11-07','11:55:00',2.01),('5815','2013-11-07','12:00:00',1.11),('5815','2013-11-07','12:05:00',2.03),('5815','2013-11-07','12:10:00',1.99),('5815','2013-11-07','12:15:00',1.72),('5815','2013-11-07','12:40:00',1.78),('5815','2013-11-07','12:45:00',1.26),('5815','2013-11-07','12:50:00',1.81),('5815','2013-11-07','12:55:00',2.11),('5815','2013-11-07','13:00:00',2.05),('5815','2013-11-07','13:05:00',1.96),('5815','2013-11-07','13:10:00',1.97),('5815','2013-11-07','13:15:00',2.01),('5815','2013-11-07','13:20:00',1.33),('5815','2013-11-07','13:25:00',1.98),('5815','2013-11-07','13:30:00',1.23),('5815','2013-11-07','13:35:00',1.69),('5815','2013-11-07','13:40:00',1.8),('5815','2013-11-07','13:45:00',1.73),('5815','2013-11-07','13:50:00',1.71),('5815','2013-11-07','13:55:00',1.66),('5815','2013-11-07','14:00:00',1.68),('5815','2013-11-07','14:05:00',1.62),('5815','2013-11-07','14:10:00',1.58),('5815','2013-11-07','14:15:00',1.4),('5815','2013-11-07','14:25:00',1.19),('5815','2013-11-07','14:35:00',1.36),('5815','2013-11-07','14:40:00',1.25),('5815','2013-11-07','14:45:00',1.31),('5815','2013-11-07','14:50:00',1.28),('5815','2013-11-07','14:55:00',1.01),('5815','2013-11-07','15:05:00',1.06),('5815','2013-11-07','15:10:00',1.07),('5815','2013-11-07','15:15:00',1.01),('5815','2014-04-17','09:05:00',1.4),('5815','2014-04-17','09:10:00',1.75),('5815','2014-04-17','09:15:00',1.61),('5815','2014-04-17','09:20:00',1.47),('5815','2014-04-17','09:25:00',1.07),('5815','2014-04-17','09:30:00',1.71),('5815','2014-04-17','09:50:00',1.63),('5815','2014-04-17','09:55:00',1.58),('5815','2014-04-17','10:00:00',1.42),('5815','2014-04-17','10:45:00',1.51),('5815','2014-04-17','10:50:00',1.71),('5815','2014-04-17','10:55:00',1.67),('5815','2014-04-17','11:00:00',1),('5815','2014-04-17','11:10:00',1.28),('5815','2014-04-17','11:15:00',1.53),('5815','2014-04-17','11:20:00',1.02),('5815','2014-04-17','11:50:00',1.06),('5815','2014-04-17','12:00:00',1),('5815','2014-04-17','12:05:00',1.63),('5815','2014-04-17','12:10:00',1.92),('5815','2014-04-17','12:15:00',1.78),('5815','2014-04-17','12:20:00',2.31),('5815','2014-04-17','12:25:00',1.77),('5815','2014-04-17','12:30:00',2.67),('5815','2014-04-17','12:35:00',2.48),('5815','2014-04-17','12:40:00',2.56),('5815','2014-04-17','12:45:00',2.16),('5815','2014-04-17','12:50:00',2.17),('5815','2014-04-17','12:55:00',1.57),('5815','2014-04-17','13:00:00',2.69),('5815','2014-04-17','13:05:00',1.9),('5815','2014-04-17','13:10:00',1.52),('5815','2014-04-17','13:15:00',1.43),('5815','2014-04-17','13:20:00',1.29),('5815','2014-04-17','13:55:00',1.22),('5815','2014-04-17','14:00:00',1.08),('5815','2014-04-17','14:25:00',1.12),('5815','2014-04-17','14:30:00',1.26),('5815','2014-04-17','14:35:00',1.45),('5815','2014-04-17','14:40:00',1.36),('5815','2014-04-17','14:45:00',1.7),('5815','2014-04-17','14:50:00',1.96),('5815','2014-04-17','14:55:00',1.28),('5815','2014-04-17','15:00:00',2.42),('5815','2014-04-17','15:05:00',1.42),('5815','2014-04-17','15:10:00',1.28),('5815','2014-04-17','15:15:00',1.43),('5815','2014-04-17','15:20:00',1.21),('5815','2014-04-17','15:25:00',1.28),('5815','2014-04-17','15:30:00',1.72),('5815','2014-04-17','15:35:00',2.24),('5815','2014-04-17','15:40:00',1.07),('5815','2014-04-17','15:45:00',1.39),('5815','2014-04-17','15:50:00',1.67),('5815','2014-04-17','15:55:00',1.46),('5815','2014-04-17','16:00:00',1.27),('5815','2014-04-17','16:25:00',1.1),('5815','2014-04-17','16:30:00',1.25),('5815','2014-04-17','16:35:00',1.48),('5815','2014-04-17','16:40:00',1.74),('5815','2014-04-17','16:45:00',1.72),('5815','2014-04-17','16:50:00',1.65),('5815','2014-04-17','16:55:00',1.08),('5815','2014-04-17','17:00:00',1.32),('5815','2014-04-17','17:05:00',1.66),('5815','2014-04-17','17:10:00',1.19),('5815','2014-04-17','17:15:00',1.32),('5815','2014-04-17','17:20:00',1.22),('5815','2014-04-17','17:25:00',1.25),('5815','2014-04-17','17:30:00',1.15),('5815','2014-04-17','17:35:00',1.02),('5815','2013-11-06','08:35:00',1.03),('5815','2013-11-06','08:40:00',1.07),('5815','2013-11-06','08:45:00',1.12),('5815','2013-11-06','08:50:00',1.17),('5815','2013-11-06','08:55:00',1.21),('5815','2013-11-06','09:00:00',1.25),('5815','2013-11-06','09:05:00',1.29),('5815','2013-11-06','09:10:00',1.32),('5815','2013-11-06','09:15:00',1.36),('5815','2013-11-06','09:20:00',1.4),('5815','2013-11-06','09:25:00',1.44),('5815','2013-11-06','09:30:00',1.47),('5815','2013-11-06','09:35:00',1.5),('5815','2013-11-06','09:40:00',1.52),('5815','2013-11-06','09:45:00',1.56),('5815','2013-11-06','09:50:00',1.58),('5815','2013-11-06','09:55:00',1.61),('5815','2013-11-06','10:00:00',1.62),('5815','2013-11-06','10:05:00',1.63),('5815','2013-11-06','10:10:00',1.66),('5815','2013-11-06','10:15:00',1.68),('5815','2013-11-06','10:20:00',1.69),('5815','2013-11-06','10:25:00',1.71),('5815','2013-11-06','10:30:00',1.73),('5815','2013-11-06','10:35:00',1.75),('5815','2013-11-06','10:40:00',1.75),('5815','2013-11-06','10:45:00',1.73),('5815','2013-11-06','10:50:00',1.77),('5815','2013-11-06','10:55:00',1.77),('5815','2013-11-06','11:00:00',1.8),('5815','2013-11-06','11:05:00',1.8),('5815','2013-11-06','11:10:00',1.81),('5815','2013-11-06','11:15:00',1.81),('5815','2013-11-06','11:20:00',1.81),('5815','2013-11-06','11:25:00',1.81),('5815','2013-11-06','11:30:00',1.76),('5815','2013-11-06','11:35:00',1.72),('5815','2013-11-06','11:40:00',1.81),('5815','2013-11-06','11:45:00',1.83),('5815','2013-11-06','11:50:00',1.81),('5815','2013-11-06','11:55:00',1.78),('5815','2013-11-06','12:00:00',1.79),('5815','2013-11-06','12:05:00',1.79),('5815','2013-11-06','12:10:00',1.74),('5815','2013-11-06','12:15:00',1.76),('5815','2013-11-06','12:20:00',1.78),('5815','2013-11-06','12:25:00',1.77),('5815','2013-11-06','12:30:00',1.74),('5815','2013-11-06','12:35:00',1.76),('5815','2013-11-06','12:40:00',1.73),('5815','2013-11-06','12:45:00',1.71),('5815','2013-11-06','12:50:00',1.7),('5815','2013-11-06','12:55:00',1.77),('5815','2013-11-06','13:00:00',1.8),('5815','2013-11-06','13:05:00',1.88),('5815','2013-11-06','13:10:00',1.34),('5815','2013-11-06','13:20:00',1.04),('5815','2013-11-06','13:40:00',1.64),('5815','2013-11-06','13:50:00',1.05),('5815','2013-11-06','13:55:00',1.69),('5815','2013-11-06','14:10:00',1.05),('5815','2013-11-06','14:25:00',1.34),('5815','2013-11-06','14:35:00',1.24),('5815','2013-11-06','14:40:00',1.38),('5815','2013-11-06','14:45:00',1.28),('5815','2013-11-06','14:50:00',1.24),('5815','2013-11-06','14:55:00',1.21),('5815','2013-11-06','15:00:00',1.16),('5815','2013-11-06','15:05:00',1.11),('5815','2013-11-06','15:10:00',1.06),('5815','2013-11-05','08:35:00',1.09),('5815','2013-11-05','08:40:00',1.11),('5815','2013-11-05','08:45:00',1.17),('5815','2013-11-05','08:50:00',1.25),('5815','2013-11-05','08:55:00',1.16),('5815','2013-11-05','09:15:00',1.15),('5815','2013-11-05','09:20:00',1.37),('5815','2013-11-05','09:25:00',1.42),('5815','2013-11-05','09:30:00',1.52),('5815','2013-11-05','09:35:00',1.55),('5815','2013-11-05','09:40:00',1.57),('5815','2013-11-05','09:45:00',1.59),('5815','2013-11-05','09:50:00',1.61),('5815','2013-11-05','09:55:00',1.64),('5815','2013-11-05','10:00:00',1.68),('5815','2013-11-05','10:05:00',1.7),('5815','2013-11-05','10:10:00',1.72),('5815','2013-11-05','10:15:00',1.74),('5815','2013-11-05','10:20:00',1.78),('5815','2013-11-05','10:25:00',1.81),('5815','2013-11-05','10:30:00',1.83),('5815','2013-11-05','10:35:00',1.85),('5815','2013-11-05','10:40:00',1.86),('5815','2013-11-05','10:45:00',1.88),('5815','2013-11-05','10:50:00',1.89),('5815','2013-11-05','10:55:00',1.9),('5815','2013-11-05','11:00:00',1.91),('5815','2013-11-05','11:05:00',1.92),('5815','2013-11-05','11:10:00',1.9),('5815','2013-11-05','11:15:00',1.94),('5815','2013-11-05','11:20:00',1.94),('5815','2013-11-05','11:25:00',1.96),('5815','2013-11-05','11:30:00',1.95),('5815','2013-11-05','11:35:00',1.94),('5815','2013-11-05','11:40:00',1.97),('5815','2013-11-05','11:45:00',1.97),('5815','2013-11-05','11:50:00',1.98),('5815','2013-11-05','11:55:00',1.97),('5815','2013-11-05','12:00:00',1.98),('5815','2013-11-05','12:05:00',1.99),('5815','2013-11-05','12:10:00',1.97),('5815','2013-11-05','12:15:00',1.96),('5815','2013-11-05','12:20:00',1.97),('5815','2013-11-05','12:25:00',1.96),('5815','2013-11-05','12:30:00',1.96),('5815','2013-11-05','12:35:00',1.95),('5815','2013-11-05','12:40:00',1.94),('5815','2013-11-05','12:45:00',1.92),('5815','2013-11-05','12:50:00',1.93),('5815','2013-11-05','12:55:00',1.91),('5815','2013-11-05','13:00:00',1.88),('5815','2013-11-05','13:05:00',1.87),('5815','2013-11-05','13:10:00',1.85),('5815','2013-11-05','13:15:00',1.81),('5815','2013-11-05','13:20:00',1.81),('5815','2013-11-05','13:25:00',1.8),('5815','2013-11-05','13:30:00',1.78),('5815','2013-11-05','13:35:00',1.75),('5815','2013-11-05','13:40:00',1.72),('5815','2013-11-05','13:45:00',1.68),('5815','2013-11-05','13:50:00',1.68),('5815','2013-11-05','13:55:00',1.63),('5815','2013-11-05','14:00:00',1.65),('5815','2013-11-05','14:05:00',1.62),('5815','2013-11-05','14:10:00',1.58),('5815','2013-11-05','14:15:00',1.54),('5815','2013-11-05','14:20:00',1.51),('5815','2013-11-05','14:25:00',1.47),('5815','2013-11-05','14:30:00',1.43),('5815','2013-11-05','14:35:00',1.4),('5815','2013-11-05','14:40:00',1.36),('5815','2013-11-05','14:45:00',1.32),('5815','2013-11-05','14:50:00',1.27),('5815','2013-11-05','14:55:00',1.23),('5815','2013-11-05','15:00:00',1.18),('5815','2013-11-05','15:05:00',1.13),('5815','2013-11-05','15:10:00',1.08),('5815','2013-11-05','15:15:00',1.04),('5815','2013-11-04','08:35:00',1.15),('5815','2013-11-04','08:40:00',1.18),('5815','2013-11-04','10:25:00',1.34),('5815','2013-11-04','10:30:00',1.09),('5815','2013-11-04','10:35:00',1.23),('5815','2013-11-04','10:40:00',1.21),('5815','2013-11-04','10:45:00',1.2),('5815','2013-11-04','12:20:00',1.02),('5815','2013-11-04','12:25:00',1.07),('5815','2013-11-04','13:35:00',1.35),('5815','2013-11-04','13:40:00',1.55),('5815','2013-11-04','13:45:00',1.52),('5815','2013-11-04','14:00:00',1.57),('5815','2013-11-04','14:05:00',1.69),('5815','2013-11-04','14:10:00',1.93),('5815','2013-11-04','14:15:00',1.43),('5815','2013-11-04','14:35:00',1.16),('5815','2013-11-03','09:10:00',1.3),('5815','2013-11-03','09:15:00',1.53),('5815','2013-11-03','09:20:00',1.61),('5815','2013-11-03','09:25:00',1.82),('5815','2013-11-03','09:30:00',1.07),('5815','2013-11-03','10:05:00',1.54),('5815','2013-11-03','10:10:00',1.81),('5815','2013-11-03','10:15:00',1.84),('5815','2013-11-03','10:20:00',1.86),('5815','2013-11-03','10:25:00',2.04),('5815','2013-11-03','10:30:00',1.98),('5815','2013-11-03','10:35:00',1.37),('5815','2013-11-03','10:40:00',2.03),('5815','2013-11-03','10:45:00',1.33),('5815','2013-11-03','10:50:00',1.05),('5815','2013-11-03','11:00:00',1.18),('5815','2013-11-03','11:05:00',2.35),('5815','2013-11-03','11:10:00',1.14),('5815','2013-11-03','11:15:00',1.91),('5815','2013-11-03','11:20:00',1.19),('5815','2013-11-03','11:30:00',1.43),('5815','2013-11-03','11:35:00',1.85),('5815','2013-11-03','11:40:00',1.21),('5815','2013-11-03','11:45:00',1.47),('5815','2013-11-03','11:50:00',2.49),('5815','2013-11-03','11:55:00',2.26),('5815','2013-11-03','12:00:00',1.9),('5815','2013-11-03','12:05:00',1.99),('5815','2013-11-03','12:10:00',1.99),('5815','2013-11-03','12:15:00',1.67),('5815','2013-11-03','12:20:00',2.11),('5815','2013-11-03','12:25:00',2.1),('5815','2013-11-03','12:30:00',2.09),('5815','2013-11-03','12:35:00',2.13),('5815','2013-11-03','12:40:00',1.8),('5815','2013-11-03','12:45:00',1.81),('5815','2013-11-03','12:50:00',1.79),('5815','2013-11-03','12:55:00',2.01),('5815','2013-11-03','13:00:00',1.98),('5815','2013-11-03','13:05:00',1.98),('5815','2013-11-03','13:10:00',1.88),('5815','2013-11-03','13:15:00',1.79),('5815','2013-11-03','13:20:00',1.7),('5815','2013-11-03','13:25:00',1.86),('5815','2013-11-03','13:30:00',1.9),('5815','2013-11-03','13:35:00',1.9),('5815','2013-11-03','13:40:00',1.84),('5815','2013-11-03','13:45:00',1.61),('5815','2013-11-03','13:50:00',1.86),('5815','2013-11-03','13:55:00',1.67),('5815','2013-11-03','14:00:00',1.4),('5815','2013-11-03','14:05:00',1.7),('5815','2013-11-03','14:10:00',1.39),('5815','2013-11-03','14:15:00',1.63),('5815','2013-11-03','14:20:00',1.73),('5815','2013-11-03','14:25:00',1.06),('5815','2013-11-03','14:30:00',1.53),('5815','2013-11-03','14:35:00',1.41),('5815','2013-11-03','14:40:00',1.49),('5815','2013-11-03','14:45:00',1.19),('5815','2013-11-03','14:50:00',1.27),('5815','2013-11-03','15:00:00',1.29),('5815','2013-11-03','15:20:00',1.01),('5815','2013-11-02','09:40:00',1.54),('5815','2013-11-02','09:45:00',1.23),('5815','2013-11-02','10:10:00',1.36),('5815','2013-11-02','10:20:00',1.3),('5815','2013-11-02','10:25:00',1.57),('5815','2013-11-02','10:30:00',1.81),('5815','2013-11-02','10:35:00',1.48),('5815','2013-11-02','11:25:00',1.39),('5815','2013-11-02','11:30:00',1.14),('5815','2013-11-02','11:35:00',1.81),('5815','2013-11-02','11:40:00',2.06),('5815','2013-11-02','11:45:00',2.18),('5815','2013-11-02','11:50:00',2.24),('5815','2013-11-02','11:55:00',2.18),('5815','2013-11-02','12:00:00',1.09),('5815','2013-11-02','12:05:00',1.81),('5815','2013-11-02','12:10:00',1.97),('5815','2013-11-02','12:20:00',1.01),('5815','2013-11-02','13:45:00',1.31),('5815','2013-11-02','14:05:00',1.73),('5815','2013-11-02','14:10:00',1.36),('5815','2013-11-02','14:15:00',1.32),('5815','2013-11-02','14:20:00',1.25),('5815','2013-11-02','14:25:00',1.53),('5815','2013-11-02','14:40:00',1.39),('5815','2013-11-02','14:45:00',1.22),('5815','2013-11-01','08:40:00',1.03),('5815','2013-11-01','08:45:00',1.08),('5815','2013-11-01','08:50:00',1.11),('5815','2013-11-01','08:55:00',1.16),('5815','2013-11-01','09:00:00',1.21),('5815','2013-11-01','09:05:00',1.3),('5815','2013-11-01','09:10:00',1.39),('5815','2013-11-01','09:20:00',1.15),('5815','2013-11-01','09:25:00',1.49),('5815','2013-11-01','09:30:00',1.44),('5815','2013-11-01','09:35:00',1.48),('5815','2013-11-01','09:40:00',1.43),('5815','2013-11-01','09:45:00',1.15),('5815','2013-11-01','09:50:00',1.63),('5815','2013-11-01','09:55:00',1.67),('5815','2013-11-01','10:00:00',1.8),('5815','2013-11-01','10:05:00',1.99),('5815','2013-11-01','10:10:00',1.05),('5815','2013-11-01','12:00:00',2.22),('5815','2013-11-01','12:05:00',2.38),('5815','2013-11-01','12:10:00',2.14),('5815','2013-11-01','12:15:00',2.41),('5815','2013-11-01','12:20:00',2.19),('5815','2013-11-01','12:25:00',2.28),('5815','2013-11-01','12:30:00',2.4),('5815','2013-11-01','12:35:00',2.32),('5815','2013-11-01','12:40:00',1.95),('5815','2013-11-01','12:45:00',1.65),('5815','2013-11-01','12:50:00',1.73),('5815','2013-11-01','12:55:00',2.17),('5815','2013-11-01','13:00:00',1.88),('5815','2013-11-01','13:05:00',2.12),('5815','2013-11-01','13:10:00',2.16),('5815','2013-11-01','13:15:00',1.38),('5815','2013-11-01','13:30:00',1.14),('5815','2013-11-01','13:35:00',1.16),('5815','2013-11-01','13:40:00',1.95),('5815','2013-11-01','13:45:00',1.76),('5815','2013-11-01','13:50:00',2.16),('5815','2013-11-01','13:55:00',2.06),('5815','2013-11-01','14:00:00',1.9),('5815','2013-11-01','14:05:00',1.75),('5815','2013-11-01','14:10:00',1.66),('5815','2013-11-01','14:15:00',1.58),('5815','2013-11-01','14:20:00',1.52),('5815','2013-11-01','14:25:00',1.48),('5815','2013-11-01','14:30:00',1.44),('5815','2013-11-01','14:35:00',1.41),('5815','2013-11-01','14:40:00',1.37),('5815','2013-11-01','14:45:00',1.3),('5815','2013-11-01','14:50:00',1.27),('5815','2013-11-01','14:55:00',1.23),('5815','2013-11-01','15:00:00',1.16),('5815','2013-11-01','15:05:00',1.01),('5815','2013-11-01','15:10:00',1.07),('5815','2013-10-31','08:40:00',1.03),('5815','2013-10-31','08:45:00',1.06),('5815','2013-10-31','08:50:00',1.02),('5815','2013-10-31','08:55:00',1.08),('5815','2013-10-31','09:00:00',1.12),('5815','2013-10-31','09:05:00',1.25),('5815','2013-10-31','09:10:00',1.3),('5815','2013-10-31','09:15:00',1.31),('5815','2013-10-31','09:20:00',1.36),('5815','2013-10-31','09:25:00',1.4),('5815','2013-10-31','09:30:00',1.43),('5815','2013-10-31','09:35:00',1.46),('5815','2013-10-31','09:40:00',1.5),('5815','2013-10-31','09:45:00',1.54),('5815','2013-10-31','09:50:00',1.57),('5815','2013-10-31','09:55:00',1.61),('5815','2013-10-31','10:00:00',1.64),('5815','2013-10-31','10:05:00',1.66),('5815','2013-10-31','10:10:00',1.69),('5815','2013-10-31','10:15:00',1.71),('5815','2013-10-31','10:20:00',1.74),('5815','2013-10-31','10:25:00',1.77),('5815','2013-10-31','10:30:00',1.75),('5815','2013-10-31','10:35:00',1.75),('5815','2013-10-31','10:40:00',1.79),('5815','2013-10-31','10:45:00',1.76),('5815','2013-10-31','10:50:00',1.77),('5815','2013-10-31','10:55:00',1.75),('5815','2013-10-31','11:00:00',1.81),('5815','2013-10-31','11:05:00',1.74),('5815','2013-10-31','11:10:00',1.52),('5815','2013-10-31','11:15:00',1.53),('5815','2013-10-31','11:20:00',1.81),('5815','2013-10-31','11:25:00',1.97),('5815','2013-10-31','11:30:00',1.97),('5815','2013-10-31','11:35:00',1.92),('5815','2013-10-31','11:40:00',1.81),('5815','2013-10-31','11:45:00',1.67),('5815','2013-10-31','11:50:00',1.93),('5815','2013-10-31','11:55:00',1.99),('5815','2013-10-31','12:00:00',1.99),('5815','2013-10-31','12:05:00',1.95),('5815','2013-10-31','12:10:00',1.83),('5815','2013-10-31','12:15:00',1.81),('5815','2013-10-31','12:20:00',1.47),('5815','2013-10-31','12:30:00',1.25),('5815','2013-10-31','12:35:00',1.6),('5815','2013-10-30','08:40:00',1.08),('5815','2013-10-30','08:45:00',1.09),('5815','2013-10-30','08:50:00',1.03),('5815','2013-10-30','09:00:00',1.13),('5815','2013-10-30','09:05:00',1.05),('5815','2013-10-30','09:35:00',1.24),('5815','2013-10-30','09:40:00',1.14),('5815','2013-10-30','09:45:00',1.2),('5815','2013-10-30','09:50:00',1.28),('5815','2013-10-30','09:55:00',1.25),('5815','2013-10-30','10:00:00',1.24),('5815','2013-10-30','10:05:00',1.11),('5815','2013-10-30','10:20:00',1.06),('5815','2013-10-30','10:25:00',1.15),('5815','2013-10-30','10:30:00',1.1),('5815','2013-10-30','10:35:00',1.14),('5815','2013-10-30','10:40:00',1.19),('5815','2013-10-30','10:45:00',1.15),('5815','2013-10-30','10:50:00',1.17),('5815','2013-10-30','10:55:00',1.36),('5815','2013-10-30','11:00:00',1.69),('5815','2013-10-30','11:05:00',1.84),('5815','2013-10-30','11:10:00',1.78),('5815','2013-10-30','11:15:00',1.31),('5815','2013-10-30','11:20:00',1.77),('5815','2013-10-30','11:25:00',1.6),('5815','2013-10-30','11:30:00',1.67),('5815','2013-10-30','11:35:00',1.62),('5815','2013-10-30','11:40:00',1.73),('5815','2013-10-30','11:45:00',1.85),('5815','2013-10-30','11:50:00',1.86),('5815','2013-10-30','11:55:00',1.87),('5815','2013-10-30','12:00:00',1.83),('5815','2013-10-30','12:05:00',1.79),('5815','2013-10-30','12:10:00',1.75),('5815','2013-10-30','12:15:00',1.81),('5815','2013-10-30','12:20:00',1.77),('5815','2013-10-30','12:25:00',1.79),('5815','2013-10-30','12:30:00',1.76),('5815','2013-10-30','12:35:00',1.72),('5815','2013-10-30','12:40:00',1.76),('5815','2013-10-30','12:45:00',1.81),('5815','2013-10-30','12:50:00',1.82),('5815','2013-10-30','12:55:00',1.85),('5815','2013-10-30','13:00:00',1.83),('5815','2013-10-30','13:05:00',1.79),('5815','2013-10-30','13:10:00',1.77),('5815','2013-10-30','13:15:00',1.75),('5815','2013-10-30','13:20:00',1.74),('5815','2013-10-30','13:25:00',1.71),('5815','2013-10-30','13:30:00',1.66),('5815','2013-10-30','13:35:00',1.63),('5815','2013-10-30','13:40:00',1.5),('5815','2013-10-30','13:45:00',1.5),('5815','2013-10-30','13:50:00',1.29),('5815','2013-10-30','13:55:00',1.07),('5815','2013-10-30','14:00:00',1.52),('5815','2013-10-30','14:05:00',1.48),('5815','2013-10-30','14:10:00',1.38),('5815','2013-10-30','14:15:00',1.35),('5815','2013-10-30','14:20:00',1.17),('5815','2013-10-30','14:25:00',1.3),('5815','2013-10-30','14:30:00',1.03),('5815','2013-10-29','08:45:00',1.02),('5815','2013-10-29','08:50:00',1.04),('5815','2013-10-29','08:55:00',1.04),('5815','2013-10-29','09:00:00',1.1),('5815','2013-10-29','09:05:00',1.17),('5815','2013-10-29','09:10:00',1.25),('5815','2013-10-29','09:15:00',1.28),('5815','2013-10-29','09:20:00',1.3),('5815','2013-10-29','09:25:00',1.35),('5815','2013-10-29','09:30:00',1.4),('5815','2013-10-29','09:35:00',1.44),('5815','2013-10-29','09:40:00',1.44),('5815','2013-10-29','09:45:00',1.49),('5815','2013-10-29','09:50:00',1.47),('5815','2013-10-29','09:55:00',1.5),('5815','2013-10-29','10:00:00',1.4),('5815','2013-10-29','10:05:00',1.46),('5815','2013-10-29','10:10:00',1.5),('5815','2013-10-29','10:15:00',1.62),('5815','2013-10-29','10:20:00',1.6),('5815','2013-10-29','10:25:00',1.54),('5815','2013-10-29','10:30:00',1.47),('5815','2013-10-29','10:35:00',1.54),('5815','2013-10-29','10:40:00',1.58),('5815','2013-10-29','10:45:00',1.52),('5815','2013-10-29','10:50:00',1.51),('5815','2013-10-29','11:00:00',1.2),('5815','2013-10-29','11:05:00',1.47),('5815','2013-10-29','11:10:00',1.83),('5815','2013-10-29','11:15:00',1.86),('5815','2013-10-29','11:20:00',1.64),('5815','2013-10-29','11:50:00',1.45),('5815','2013-10-29','12:30:00',1.49),('5815','2013-10-29','12:45:00',1.15),('5815','2013-10-29','12:55:00',1.51),('5815','2013-10-29','13:00:00',1.46),('5815','2013-10-29','13:30:00',1.06),('5815','2013-10-29','13:45:00',1.22),('5815','2013-10-29','13:50:00',1.17),('5815','2013-10-29','14:05:00',1.42),('5815','2013-10-29','14:10:00',1.59),('5815','2013-10-29','14:15:00',1.27),('5815','2013-10-29','14:40:00',1.26),('5815','2013-10-29','14:45:00',1.21),('5815','2013-10-29','14:50:00',1.12),('5815','2013-10-28','08:50:00',1.16),('5815','2013-10-28','08:55:00',1.17),('5815','2013-10-28','09:00:00',1.22),('5815','2013-10-28','09:05:00',1.26),('5815','2013-10-28','09:10:00',1.29),('5815','2013-10-28','09:15:00',1.32),('5815','2013-10-28','09:20:00',1.38),('5815','2013-10-28','09:25:00',1.4),('5815','2013-10-28','09:30:00',1.45),('5815','2013-10-28','09:35:00',1.47),('5815','2013-10-28','09:40:00',1.5),('5815','2013-10-28','09:45:00',1.49),('5815','2013-10-28','09:50:00',1.29),('5815','2013-10-28','09:55:00',1.53),('5815','2013-10-28','10:00:00',1.65),('5815','2013-10-28','10:05:00',1.74),('5815','2013-10-28','10:10:00',1.68),('5815','2013-10-28','10:15:00',1.49),('5815','2013-10-28','10:20:00',1.47),('5815','2013-10-28','10:25:00',1.77),('5815','2013-10-28','10:30:00',1.93),('5815','2013-10-28','10:35:00',1.88),('5815','2013-10-28','10:40:00',1.89),('5815','2013-10-28','10:45:00',1.91),('5815','2013-10-28','10:50:00',1.98),('5815','2013-10-28','10:55:00',1.81),('5815','2013-10-28','11:00:00',1.09),('5815','2013-10-28','11:05:00',1.22),('5815','2013-10-28','11:15:00',1.56),('5815','2013-10-28','11:20:00',1.94),('5815','2013-10-28','11:25:00',1.86),('5815','2013-10-28','11:30:00',1.99),('5815','2013-10-28','11:35:00',1.99),('5815','2013-10-28','11:40:00',1.97),('5815','2013-10-28','11:45:00',1.86),('5815','2013-10-28','11:50:00',1.85),('5815','2013-10-28','11:55:00',1.85),('5815','2013-10-28','12:00:00',1.79),('5815','2013-10-28','12:05:00',1.91),('5815','2013-10-28','12:10:00',1.87),('5815','2013-10-28','12:15:00',1.86),('5815','2013-10-28','12:20:00',1.87),('5815','2013-10-28','12:25:00',1.87),('5815','2013-10-28','12:30:00',1.85),('5815','2013-10-28','12:35:00',1.79),('5815','2013-10-28','12:40:00',1.83),('5815','2013-10-28','12:45:00',1.87),('5815','2013-10-28','12:50:00',1.85),('5815','2013-10-28','12:55:00',1.8),('5815','2013-10-28','13:00:00',1.75),('5815','2013-10-28','13:05:00',1.7),('5815','2013-10-28','13:10:00',1.74),('5815','2013-10-28','13:15:00',1.72),('5815','2013-10-28','13:20:00',1.7),('5815','2013-10-28','13:25:00',1.65),('5815','2013-10-28','13:30:00',1.65),('5815','2013-10-28','13:35:00',1.63),('5815','2013-10-28','13:40:00',1.62),('5815','2013-10-28','13:45:00',1.61),('5815','2013-10-28','13:50:00',1.58),('5815','2013-10-28','13:55:00',1.5),('5815','2013-10-28','14:00:00',1.47),('5815','2013-10-28','14:05:00',1.45),('5815','2013-10-28','14:10:00',1.49),('5815','2013-10-28','14:15:00',1.46),('5815','2013-10-28','14:20:00',1.43),('5815','2013-10-28','14:25:00',1.35),('5815','2013-10-28','14:30:00',1.29),('5815','2013-10-28','14:35:00',1.24),('5815','2013-10-28','14:40:00',1.2),('5815','2013-10-28','14:45:00',1.18),('5815','2013-10-28','14:50:00',1.15),('5815','2013-10-28','14:55:00',1.09),('5815','2013-10-28','15:00:00',1.03),('5815','2014-04-16','08:45:00',1.02),('5815','2014-04-16','08:50:00',1.12),('5815','2014-04-16','09:00:00',1.01),('5815','2014-04-16','09:05:00',1.17),('5815','2014-04-16','09:10:00',1.3),('5815','2014-04-16','09:15:00',1.32),('5815','2014-04-16','09:20:00',1.43),('5815','2014-04-16','09:25:00',1.5),('5815','2014-04-16','09:30:00',1.55),('5815','2014-04-16','09:35:00',1.6),('5815','2014-04-16','09:40:00',1.65),('5815','2014-04-16','09:45:00',1.7),('5815','2014-04-16','09:50:00',1.75),('5815','2014-04-16','09:55:00',1.8),('5815','2014-04-16','10:00:00',1.87),('5815','2014-04-16','10:05:00',2.02),('5815','2014-04-16','10:10:00',1.88),('5815','2014-04-16','10:15:00',1.66),('5815','2014-04-16','10:20:00',1.98),('5815','2014-04-16','10:25:00',2.25),('5815','2014-04-16','10:30:00',2.34),('5815','2014-04-16','10:35:00',2.42),('5815','2014-04-16','10:40:00',2.29),('5815','2014-04-16','10:45:00',1.83),('5815','2014-04-16','10:50:00',1.4),('5815','2014-04-16','10:55:00',1.42),('5815','2014-04-16','11:00:00',1.47),('5815','2014-04-16','11:05:00',2.18),('5815','2014-04-16','11:10:00',1.84),('5815','2014-04-16','11:15:00',1.77),('5815','2014-04-16','11:20:00',1.85),('5815','2014-04-16','11:25:00',2.02),('5815','2014-04-16','11:30:00',1.39),('5815','2014-04-16','11:35:00',1.66),('5815','2014-04-16','11:40:00',1.65),('5815','2014-04-16','11:45:00',1.85),('5815','2014-04-16','11:50:00',1.41),('5815','2014-04-16','11:55:00',1.13),('5815','2014-04-16','12:00:00',1.25),('5815','2014-04-16','12:05:00',1.63),('5815','2014-04-16','12:10:00',1.64),('5815','2014-04-16','12:15:00',1.4),('5815','2014-04-16','12:20:00',1.38),('5815','2014-04-16','12:25:00',1.55),('5815','2014-04-16','12:30:00',1.81),('5815','2014-04-16','12:35:00',2.36),('5815','2014-04-16','12:40:00',2.58),('5815','2014-04-16','12:45:00',2.47),('5815','2014-04-16','12:50:00',2.56),('5815','2014-04-16','12:55:00',2.6),('5815','2014-04-16','13:00:00',2.23),('5815','2014-04-16','13:05:00',1.49),('5815','2014-04-16','13:20:00',2.5),('5815','2014-04-16','13:25:00',2.92),('5815','2014-04-16','13:30:00',2.01),('5815','2014-04-16','14:10:00',1.52),('5815','2014-04-16','14:35:00',1.03),('5815','2014-04-16','14:40:00',1.92),('5815','2014-04-16','15:35:00',1.19),('5815','2013-10-27','08:55:00',1.13),('5815','2013-10-27','09:00:00',1.26),('5815','2013-10-27','09:05:00',1.38),('5815','2013-10-27','09:10:00',1.45),('5815','2013-10-27','09:15:00',1.15),('5815','2013-10-27','09:25:00',1.46),('5815','2013-10-27','09:30:00',1.6),('5815','2013-10-27','09:35:00',1.27),('5815','2013-10-27','09:50:00',1.4),('5815','2013-10-27','09:55:00',1.06),('5815','2013-10-27','10:50:00',1.92),('5815','2013-10-27','10:55:00',1.91),('5815','2013-10-27','11:00:00',1.92),('5815','2013-10-27','11:05:00',1.92),('5815','2013-10-27','11:10:00',1.94),('5815','2013-10-27','11:15:00',1.96),('5815','2013-10-27','11:20:00',1.96),('5815','2013-10-27','11:25:00',1.97),('5815','2013-10-27','11:30:00',1.95),('5815','2013-10-27','11:35:00',1.94),('5815','2013-10-27','11:40:00',1.9),('5815','2013-10-27','11:45:00',1.94),('5815','2013-10-27','11:50:00',1.96),('5815','2013-10-27','11:55:00',1.96),('5815','2013-10-27','12:00:00',1.78),('5815','2013-10-27','12:05:00',1.93),('5815','2013-10-27','12:10:00',1.46),('5815','2013-10-27','12:15:00',2.07),('5815','2013-10-27','12:20:00',2.11),('5815','2013-10-27','12:25:00',2.1),('5815','2013-10-27','12:30:00',1.87),('5815','2013-10-27','12:35:00',2.11),('5815','2013-10-27','12:40:00',2.13),('5815','2013-10-27','12:45:00',2.07),('5815','2013-10-27','12:50:00',2.09),('5815','2013-10-27','12:55:00',2.01),('5815','2013-10-27','13:00:00',1.93),('5815','2013-10-27','13:05:00',1.9),('5815','2013-10-27','13:10:00',1.92),('5815','2013-10-27','13:15:00',1.88),('5815','2013-10-27','13:20:00',1.84),('5815','2013-10-27','13:25:00',1.85),('5815','2013-10-27','13:30:00',1.81),('5815','2013-10-27','13:35:00',1.79),('5815','2013-10-27','13:40:00',1.73),('5815','2013-10-27','13:45:00',1.38),('5815','2013-10-27','13:50:00',1.73),('5815','2013-10-27','13:55:00',1.71),('5815','2013-10-27','14:00:00',1.71),('5815','2013-10-27','14:05:00',1.27),('5815','2013-10-27','14:10:00',1.7),('5815','2013-10-27','14:15:00',1.67),('5815','2013-10-27','14:20:00',1.61),('5815','2013-10-27','14:25:00',1.65),('5815','2013-10-27','14:30:00',1.51),('5815','2013-10-27','14:35:00',1.43),('5815','2013-10-27','14:40:00',1.15),('5815','2013-10-27','14:45:00',1.31),('5815','2013-10-27','14:50:00',1.29),('5815','2013-10-27','14:55:00',1.22),('5815','2013-10-27','15:00:00',1.19),('5815','2013-10-27','15:05:00',1.16),('5815','2013-10-27','15:10:00',1.1),('5815','2013-10-27','15:15:00',1.02),('5815','2013-10-26','11:40:00',1.61),('5815','2013-10-26','11:45:00',1.75),('5815','2013-10-26','11:50:00',1.36),('5815','2013-10-26','12:20:00',1.54),('5815','2013-10-26','12:25:00',1.94),('5815','2013-10-26','12:30:00',1.69),('5815','2013-10-26','12:35:00',1.74),('5815','2013-10-26','12:40:00',1.43),('5815','2013-10-26','12:50:00',1.06),('5815','2013-10-26','13:00:00',1.47),('5815','2013-10-26','13:10:00',1.37),('5815','2013-10-26','13:25:00',1.04),('5815','2013-10-26','13:30:00',1.58),('5815','2013-10-26','13:35:00',1.22),('5815','2013-10-26','13:40:00',1.43),('5815','2013-10-26','14:35:00',1.28),('5815','2013-10-26','14:40:00',1.33),('5815','2013-10-26','14:45:00',1.1),('5815','2013-10-26','14:50:00',1.05),('5815','2013-10-26','14:55:00',1.16),('5815','2013-10-26','15:00:00',1.12),('5815','2013-10-26','15:15:00',1),('5815','2013-10-25','09:35:00',1.01),('5815','2013-10-25','09:40:00',1.06),('5815','2013-10-25','09:45:00',1.11),('5815','2013-10-25','09:50:00',1.16),('5815','2013-10-25','09:55:00',1.2),('5815','2013-10-25','10:00:00',1.24),('5815','2013-10-25','10:05:00',1.29),('5815','2013-10-25','10:10:00',1.32),('5815','2013-10-25','10:15:00',1.36),('5815','2013-10-25','10:20:00',1.39),('5815','2013-10-25','10:25:00',1.42),('5815','2013-10-25','10:30:00',1.45),('5815','2013-10-25','10:35:00',1.48),('5815','2013-10-25','10:40:00',1.52),('5815','2013-10-25','10:45:00',1.54),('5815','2013-10-25','10:50:00',1.58),('5815','2013-10-25','10:55:00',1.61),('5815','2013-10-25','11:00:00',1.65),('5815','2013-10-25','11:05:00',1.67),('5815','2013-10-25','11:10:00',1.69),('5815','2013-10-25','11:15:00',1.71),('5815','2013-10-25','11:20:00',1.73),('5815','2013-10-25','11:25:00',1.75),('5815','2013-10-25','11:30:00',1.77),('5815','2013-10-25','11:35:00',1.79),('5815','2013-10-25','11:40:00',1.8),('5815','2013-10-25','11:45:00',1.82),('5815','2013-10-25','11:50:00',1.84),('5815','2013-10-25','11:55:00',1.83),('5815','2013-10-25','12:00:00',1.86),('5815','2013-10-25','12:05:00',1.86),('5815','2013-10-25','12:10:00',1.87),('5815','2013-10-25','12:15:00',1.84),('5815','2013-10-25','12:20:00',1.89),('5815','2013-10-25','12:25:00',1.86),('5815','2013-10-25','12:30:00',1.9),('5815','2013-10-25','12:35:00',1.93),('5815','2013-10-25','12:40:00',1.9),('5815','2013-10-25','12:45:00',1.88),('5815','2013-10-25','12:50:00',1.9),('5815','2013-10-25','12:55:00',1.89),('5815','2013-10-25','13:00:00',1.91),('5815','2013-10-25','13:05:00',1.9),('5815','2013-10-25','13:10:00',1.88),('5815','2013-10-25','13:15:00',1.75),('5815','2013-10-25','13:20:00',1.71),('5815','2013-10-25','13:25:00',1.81),('5815','2013-10-25','13:30:00',1.72),('5815','2013-10-25','13:35:00',1.82),('5815','2013-10-25','13:40:00',1.91),('5815','2013-10-25','13:45:00',1.8),('5815','2013-10-25','13:50:00',1.63),('5815','2013-10-25','13:55:00',1.76),('5815','2013-10-25','14:00:00',1.73),('5815','2013-10-25','14:05:00',1.62),('5815','2013-10-25','14:10:00',1.59),('5815','2013-10-25','14:15:00',1.67),('5815','2013-10-25','14:20:00',1.54),('5815','2013-10-25','14:25:00',1.11),('5815','2013-10-25','14:40:00',1.53),('5815','2013-10-25','14:45:00',1.54),('5815','2013-10-25','14:50:00',1.53),('5815','2013-10-25','14:55:00',1.47),('5815','2013-10-25','15:00:00',1.41),('5815','2013-10-25','15:05:00',1.31),('5815','2013-10-25','15:10:00',1.36),('5815','2013-10-25','15:15:00',1.23),('5815','2013-10-25','15:20:00',1.23),('5815','2013-10-25','15:25:00',1.22),('5815','2013-10-25','15:30:00',1.2),('5815','2013-10-25','15:35:00',1.2),('5815','2013-10-25','15:40:00',1.2),('5815','2013-10-25','15:45:00',1.05),('5815','2013-10-25','15:50:00',1.12),('5815','2013-10-25','15:55:00',1.01),('5815','2013-10-24','09:35:00',1.03),('5815','2013-10-24','09:40:00',1.08),('5815','2013-10-24','09:45:00',1.12),('5815','2013-10-24','09:50:00',1.17),('5815','2013-10-24','09:55:00',1.21),('5815','2013-10-24','10:00:00',1.25),('5815','2013-10-24','10:05:00',1.3),('5815','2013-10-24','10:10:00',1.34),('5815','2013-10-24','10:15:00',1.37),('5815','2013-10-24','10:20:00',1.41),('5815','2013-10-24','10:25:00',1.45),('5815','2013-10-24','10:30:00',1.49),('5815','2013-10-24','10:35:00',1.53),('5815','2013-10-24','10:40:00',1.55),('5815','2013-10-24','10:45:00',1.58),('5815','2013-10-24','10:50:00',1.61),('5815','2013-10-24','10:55:00',1.63),('5815','2013-10-24','11:00:00',1.66),('5815','2013-10-24','11:05:00',1.66),('5815','2013-10-24','11:10:00',1.7),('5815','2013-10-24','11:15:00',1.73),('5815','2013-10-24','11:20:00',1.74),('5815','2013-10-24','11:25:00',1.76),('5815','2013-10-24','11:30:00',1.77),('5815','2013-10-24','11:35:00',1.78),('5815','2013-10-24','11:40:00',1.79),('5815','2013-10-24','11:45:00',1.83),('5815','2013-10-24','11:50:00',1.85),('5815','2013-10-24','11:55:00',1.88),('5815','2013-10-24','12:00:00',1.89),('5815','2013-10-24','12:05:00',1.91),('5815','2013-10-24','12:10:00',1.92),('5815','2013-10-24','12:15:00',1.92),('5815','2013-10-24','12:20:00',1.94),('5815','2013-10-24','12:25:00',1.94),('5815','2013-10-24','12:30:00',1.95),('5815','2013-10-24','12:35:00',1.96),('5815','2013-10-24','12:40:00',1.96),('5815','2013-10-24','12:45:00',1.95),('5815','2013-10-24','12:50:00',1.94),('5815','2013-10-24','12:55:00',1.94),('5815','2013-10-24','13:00:00',1.97),('5815','2013-10-24','13:05:00',1.96),('5815','2013-10-24','13:10:00',1.94),('5815','2013-10-24','13:15:00',1.92),('5815','2013-10-24','13:20:00',1.92),('5815','2013-10-24','13:25:00',1.87),('5815','2013-10-24','13:30:00',1.86),('5815','2013-10-24','13:35:00',1.87),('5815','2013-10-24','13:40:00',1.89),('5815','2013-10-24','13:45:00',1.86),('5815','2013-10-24','13:50:00',1.86),('5815','2013-10-24','13:55:00',1.87),('5815','2013-10-24','14:00:00',1.84),('5815','2013-10-24','14:05:00',1.83),('5815','2013-10-24','14:10:00',1.82),('5815','2013-10-24','14:15:00',1.81),('5815','2013-10-24','14:20:00',1.79),('5815','2013-10-24','14:25:00',1.76),('5815','2013-10-24','14:30:00',1.72),('5815','2013-10-24','14:35:00',1.7),('5815','2013-10-24','14:40:00',1.7),('5815','2013-10-24','14:45:00',1.69),('5815','2013-10-24','14:50:00',1.67),('5815','2013-10-24','14:55:00',1.64),('5815','2013-10-24','15:00:00',1.58),('5815','2013-10-24','15:05:00',1.57),('5815','2013-10-24','15:10:00',1.54),('5815','2013-10-24','15:15:00',1.51),('5815','2013-10-24','15:20:00',1.47),('5815','2013-10-24','15:25:00',1.44),('5815','2013-10-24','15:30:00',1.37),('5815','2013-10-24','15:35:00',1.34),('5815','2013-10-24','15:40:00',1.27),('5815','2013-10-24','15:45:00',1.25),('5815','2013-10-24','15:50:00',1.2),('5815','2013-10-24','15:55:00',1.19),('5815','2013-10-24','16:00:00',1.15),('5815','2013-10-24','16:05:00',1.11),('5815','2013-10-24','16:10:00',1.06),('5815','2013-10-24','16:15:00',1.02),('5815','2013-10-23','10:45:00',1.57),('5815','2013-10-23','10:50:00',1.28),('5815','2013-10-23','10:55:00',1.55),('5815','2013-10-23','11:00:00',1.82),('5815','2013-10-23','11:05:00',1.92),('5815','2013-10-23','11:10:00',2.09),('5815','2013-10-23','11:25:00',1.51),('5815','2013-10-23','11:30:00',1.19),('5815','2013-10-23','11:50:00',1.06),('5815','2013-10-23','11:55:00',1.95),('5815','2013-10-23','12:00:00',1.09),('5815','2013-10-23','12:40:00',1.15),('5815','2013-10-23','12:45:00',1.26),('5815','2013-10-23','12:50:00',1.34),('5815','2013-10-23','12:55:00',1.37),('5815','2013-10-23','13:00:00',1.69),('5815','2013-10-23','13:05:00',2.27),('5815','2013-10-23','13:10:00',1.83),('5815','2013-10-23','13:15:00',1.43),('5815','2013-10-23','13:20:00',1.48),('5815','2013-10-23','13:25:00',1.53),('5815','2013-10-23','13:55:00',1.17),('5815','2013-10-23','14:00:00',1.38),('5815','2013-10-23','14:05:00',1.24),('5815','2013-10-23','14:35:00',1.13),('5815','2013-10-23','14:40:00',1.15),('5815','2013-10-23','14:45:00',1.2),('5815','2013-10-23','14:50:00',1.58),('5815','2013-10-23','15:10:00',1.53),('5815','2013-10-23','15:15:00',1.11),('5815','2013-10-23','15:35:00',1.54),('5815','2013-10-23','15:40:00',1.58),('5815','2013-10-23','15:45:00',1.19),('5815','2013-10-22','11:10:00',1.02),('5815','2013-10-22','11:15:00',1.77),('5815','2013-10-22','11:20:00',1.61),('5815','2013-10-22','11:25:00',1.77),('5815','2013-10-22','11:30:00',1.45),('5815','2013-10-22','11:35:00',1.75),('5815','2013-10-22','11:40:00',1.86),('5815','2013-10-22','11:45:00',1.81),('5815','2013-10-22','11:50:00',1.76),('5815','2013-10-22','11:55:00',1.79),('5815','2013-10-22','12:00:00',1.86),('5815','2013-10-22','12:05:00',1.84),('5815','2013-10-22','12:10:00',1.76),('5815','2013-10-22','12:15:00',1.82),('5815','2013-10-22','12:20:00',1.81),('5815','2013-10-22','12:25:00',1.85),('5815','2013-10-22','12:30:00',1.83),('5815','2013-10-22','12:35:00',1.81),('5815','2013-10-22','12:40:00',1.83),('5815','2013-10-22','12:45:00',1.67),('5815','2013-10-22','12:50:00',1.56),('5815','2013-10-22','12:55:00',1.33),('5815','2013-10-22','13:00:00',1.87),('5815','2013-10-22','13:05:00',1.83),('5815','2013-10-22','13:10:00',1.82),('5815','2013-10-22','13:15:00',1.85),('5815','2013-10-22','13:20:00',1.85),('5815','2013-10-22','13:25:00',1.86),('5815','2013-10-22','13:30:00',1.87),('5815','2013-10-22','13:35:00',1.86),('5815','2013-10-22','13:40:00',1.86),('5815','2013-10-22','13:45:00',1.85),('5815','2013-10-22','13:50:00',1.72),('5815','2013-10-22','13:55:00',1.28),('5815','2013-10-22','14:00:00',1.6),('5815','2013-10-22','14:05:00',1.64),('5815','2013-10-22','14:10:00',1.62),('5815','2013-10-22','14:15:00',1.76),('5815','2013-10-22','14:20:00',1.68),('5815','2013-10-22','14:25:00',1.61),('5815','2013-10-22','14:30:00',1.64),('5815','2013-10-22','14:35:00',1.59),('5815','2013-10-22','14:40:00',1.45),('5815','2013-10-22','14:45:00',1.45),('5815','2013-10-22','14:50:00',1.37),('5815','2013-10-22','14:55:00',1.52),('5815','2013-10-22','15:00:00',1.42),('5815','2013-10-22','15:05:00',1.49),('5815','2013-10-22','15:10:00',1.43),('5815','2013-10-22','15:15:00',1.46),('5815','2013-10-22','15:20:00',1.47),('5815','2013-10-22','15:25:00',1.47),('5815','2013-10-22','15:30:00',1.43),('5815','2013-10-22','15:35:00',1.34),('5815','2013-10-22','15:40:00',1.41),('5815','2013-10-22','15:45:00',1.35),('5815','2013-10-22','15:50:00',1.22),('5815','2013-10-21','09:35:00',1.02),('5815','2013-10-21','09:40:00',1.07),('5815','2013-10-21','09:45:00',1.11),('5815','2013-10-21','09:50:00',1.15),('5815','2013-10-21','09:55:00',1.19),('5815','2013-10-21','10:00:00',1.22),('5815','2013-10-21','10:05:00',1.26),('5815','2013-10-21','10:10:00',1.3),('5815','2013-10-21','10:15:00',1.35),('5815','2013-10-21','10:20:00',1.38),('5815','2013-10-21','10:25:00',1.39),('5815','2013-10-21','10:30:00',1.45),('5815','2013-10-21','10:35:00',1.48),('5815','2013-10-21','10:40:00',1.51),('5815','2013-10-21','10:45:00',1.55),('5815','2013-10-21','10:50:00',1.59),('5815','2013-10-21','10:55:00',1.59),('5815','2013-10-21','11:00:00',1.61),('5815','2013-10-21','11:05:00',1.65),('5815','2013-10-21','11:10:00',1.66),('5815','2013-10-21','11:15:00',1.69),('5815','2013-10-21','11:20:00',1.73),('5815','2013-10-21','11:25:00',1.73),('5815','2013-10-21','11:30:00',1.73),('5815','2013-10-21','11:35:00',1.75),('5815','2013-10-21','11:40:00',1.74),('5815','2013-10-21','11:45:00',1.74),('5815','2013-10-21','11:50:00',1.75),('5815','2013-10-21','11:55:00',1.78),('5815','2013-10-21','12:00:00',1.81),('5815','2013-10-21','12:05:00',1.83),('5815','2013-10-21','12:10:00',1.82),('5815','2013-10-21','12:15:00',1.82),('5815','2013-10-21','12:20:00',1.85),('5815','2013-10-21','12:25:00',1.87),('5815','2013-10-21','12:30:00',1.84),('5815','2013-10-21','12:35:00',1.85),('5815','2013-10-21','12:40:00',1.87),('5815','2013-10-21','12:45:00',1.87),('5815','2013-10-21','12:50:00',1.88),('5815','2013-10-21','12:55:00',1.82),('5815','2013-10-21','13:00:00',1.29),('5815','2013-10-21','13:05:00',1.72),('5815','2013-10-21','13:10:00',1.8),('5815','2013-10-21','13:15:00',1.8),('5815','2013-10-21','13:20:00',1.83),('5815','2013-10-21','13:25:00',1.84),('5815','2013-10-21','13:30:00',1.84),('5815','2013-10-21','13:35:00',1.75),('5815','2013-10-21','13:40:00',1.82),('5815','2013-10-21','13:45:00',1.81),('5815','2013-10-21','13:50:00',1.74),('5815','2013-10-21','13:55:00',1.72),('5815','2013-10-21','14:00:00',1.67),('5815','2013-10-21','14:05:00',1.76),('5815','2013-10-21','14:10:00',1.73),('5815','2013-10-21','14:15:00',1.64),('5815','2013-10-21','14:20:00',1.13),('5815','2013-10-21','14:25:00',1.52),('5815','2013-10-21','14:45:00',1.06),('5815','2013-10-21','14:50:00',1.42),('5815','2013-10-21','14:55:00',1.52),('5815','2013-10-21','15:00:00',1.44),('5815','2013-10-21','15:05:00',1.44),('5815','2013-10-21','15:10:00',1.46),('5815','2013-10-21','15:15:00',1.41),('5815','2013-10-21','15:20:00',1.36),('5815','2013-10-21','15:25:00',1.33),('5815','2013-10-21','15:30:00',1.26),('5815','2013-10-21','15:35:00',1.24),('5815','2013-10-21','15:40:00',1.22),('5815','2013-10-21','15:45:00',1.19),('5815','2013-10-21','15:50:00',1.15),('5815','2013-10-21','15:55:00',1.09),('5815','2013-10-21','16:00:00',1.01),('5815','2013-10-20','09:25:00',1),('5815','2013-10-20','09:40:00',1.08),('5815','2013-10-20','09:50:00',1.01),('5815','2013-10-20','09:55:00',1.12),('5815','2013-10-20','10:00:00',1.13),('5815','2013-10-20','10:05:00',1.25),('5815','2013-10-20','10:10:00',1.36),('5815','2013-10-20','10:15:00',1.41),('5815','2013-10-20','10:20:00',1.4),('5815','2013-10-20','10:25:00',1.47),('5815','2013-10-20','10:30:00',1.45),('5815','2013-10-20','10:35:00',1.46),('5815','2013-10-20','10:40:00',1.44),('5815','2013-10-20','10:45:00',1.49),('5815','2013-10-20','10:50:00',1.56),('5815','2013-10-20','10:55:00',1.57),('5815','2013-10-20','11:00:00',1.66),('5815','2013-10-20','11:05:00',1.57),('5815','2013-10-20','11:10:00',1.4),('5815','2013-10-20','11:15:00',1.77),('5815','2013-10-20','11:20:00',1.78),('5815','2013-10-20','11:25:00',1.76),('5815','2013-10-20','11:30:00',1.8),('5815','2013-10-20','11:35:00',1.82),('5815','2013-10-20','11:40:00',1.81),('5815','2013-10-20','11:45:00',1.89),('5815','2013-10-20','11:50:00',1.89),('5815','2013-10-20','11:55:00',1.9),('5815','2013-10-20','12:00:00',1.93),('5815','2013-10-20','12:05:00',1.95),('5815','2013-10-20','12:10:00',1.95),('5815','2013-10-20','12:15:00',1.94),('5815','2013-10-20','12:20:00',1.94),('5815','2013-10-20','12:25:00',1.96),('5815','2013-10-20','12:30:00',1.88),('5815','2013-10-20','12:35:00',1.91),('5815','2013-10-20','12:40:00',1.97),('5815','2013-10-20','12:45:00',1.98),('5815','2013-10-20','12:50:00',1.96),('5815','2013-10-20','12:55:00',1.95),('5815','2013-10-20','13:00:00',1.94),('5815','2013-10-20','13:05:00',1.91),('5815','2013-10-20','13:10:00',1.81),('5815','2013-10-20','13:15:00',1.86),('5815','2013-10-20','13:20:00',1.88),('5815','2013-10-20','13:25:00',1.87),('5815','2013-10-20','13:30:00',1.94),('5815','2013-10-20','13:35:00',1.93),('5815','2013-10-20','13:40:00',1.89),('5815','2013-10-20','13:45:00',1.86),('5815','2013-10-20','13:50:00',1.86),('5815','2013-10-20','13:55:00',1.83),('5815','2013-10-20','14:00:00',1.77),('5815','2013-10-20','14:05:00',1.84),('5815','2013-10-20','14:10:00',1.82),('5815','2013-10-20','14:15:00',1.8),('5815','2013-10-20','14:20:00',1.79),('5815','2013-10-20','14:25:00',1.76),('5815','2013-10-20','14:30:00',1.73),('5815','2013-10-20','14:35:00',1.74),('5815','2013-10-20','14:40:00',1.65),('5815','2013-10-20','14:45:00',1.59),('5815','2013-10-20','14:50:00',1.56),('5815','2013-10-20','14:55:00',1.55),('5815','2013-10-20','15:00:00',1.58),('5815','2013-10-20','15:05:00',1.55),('5815','2013-10-20','15:10:00',1.51),('5815','2013-10-20','15:15:00',1.48),('5815','2013-10-20','15:20:00',1.5),('5815','2013-10-20','15:25:00',1.44),('5815','2013-10-20','15:30:00',1.34),('5815','2013-10-20','15:35:00',1.28),('5815','2013-10-20','15:40:00',1.31),('5815','2013-10-20','15:45:00',1.28),('5815','2013-10-20','15:50:00',1.23),('5815','2013-10-20','15:55:00',1.19),('5815','2013-10-20','16:00:00',1.16),('5815','2013-10-20','16:05:00',1.11),('5815','2013-10-20','16:10:00',1.08),('5815','2013-10-20','16:15:00',1.03),('5815','2013-10-19','09:25:00',1.01),('5815','2013-10-19','09:30:00',1.04),('5815','2013-10-19','09:35:00',1.09),('5815','2013-10-19','09:40:00',1.14),('5815','2013-10-19','09:45:00',1.18),('5815','2013-10-19','09:50:00',1.22),('5815','2013-10-19','09:55:00',1.24),('5815','2013-10-19','10:00:00',1.31),('5815','2013-10-19','10:05:00',1.36),('5815','2013-10-19','10:10:00',1.41),('5815','2013-10-19','10:15:00',1.44),('5815','2013-10-19','10:20:00',1.47),('5815','2013-10-19','10:25:00',1.51),('5815','2013-10-19','10:30:00',1.54),('5815','2013-10-19','10:35:00',1.57),('5815','2013-10-19','10:40:00',1.6),('5815','2013-10-19','10:45:00',1.64),('5815','2013-10-19','10:50:00',1.66),('5815','2013-10-19','10:55:00',1.68),('5815','2013-10-19','11:00:00',1.71),('5815','2013-10-19','11:05:00',1.74),('5815','2013-10-19','11:10:00',1.77),('5815','2013-10-19','11:15:00',1.78),('5815','2013-10-19','11:20:00',1.8),('5815','2013-10-19','11:25:00',1.83),('5815','2013-10-19','11:30:00',1.86),('5815','2013-10-19','11:35:00',1.88),('5815','2013-10-19','11:40:00',1.9),('5815','2013-10-19','11:45:00',1.91),('5815','2013-10-19','11:50:00',1.93),('5815','2013-10-19','11:55:00',1.91),('5815','2013-10-19','12:00:00',1.94),('5815','2013-10-19','12:05:00',1.96),('5815','2013-10-19','12:10:00',1.99),('5815','2013-10-19','12:15:00',1.32),('5815','2013-10-19','12:30:00',1.82),('5815','2013-10-19','12:35:00',1.57),('5815','2013-10-19','12:40:00',1.76),('5815','2013-10-19','12:50:00',1.09),('5815','2013-10-19','12:55:00',1.76),('5815','2013-10-19','13:00:00',1.71),('5815','2013-10-19','13:05:00',1.59),('5815','2013-10-19','13:10:00',2.3),('5815','2013-10-19','13:15:00',1.4),('5815','2013-10-19','13:25:00',1.04),('5815','2013-10-19','13:30:00',1.48),('5815','2013-10-19','13:35:00',1.52),('5815','2013-10-19','13:45:00',1.55),('5815','2013-10-19','13:55:00',1.09),('5815','2013-10-18','09:15:00',1.13),('5815','2013-10-18','09:20:00',1.15),('5815','2013-10-18','09:25:00',1.17),('5815','2013-10-18','09:30:00',1.2),('5815','2013-10-18','09:35:00',1.23),('5815','2013-10-18','09:40:00',1.29),('5815','2013-10-18','09:45:00',1.36),('5815','2013-10-18','09:50:00',1.41),('5815','2013-10-18','09:55:00',1.47),('5815','2013-10-18','10:00:00',1.48),('5815','2013-10-18','10:05:00',1.4),('5815','2013-10-18','10:10:00',1.51),('5815','2013-10-18','10:15:00',1.5),('5815','2013-10-18','10:20:00',1.61),('5815','2013-10-18','10:25:00',1.74),('5815','2013-10-18','10:30:00',1.76),('5815','2013-10-18','10:35:00',1.78),('5815','2013-10-18','10:40:00',1.78),('5815','2013-10-18','10:45:00',1.77),('5815','2013-10-18','10:50:00',1.82),('5815','2013-10-18','10:55:00',1.87),('5815','2013-10-18','11:00:00',1.89),('5815','2013-10-18','11:05:00',1.69),('5815','2013-10-18','11:10:00',1.1),('5815','2013-10-18','11:20:00',1.35),('5815','2013-10-18','11:25:00',2.15),('5815','2013-10-18','11:30:00',2.09),('5815','2013-10-18','11:35:00',2.09),('5815','2013-10-18','11:40:00',1.98),('5815','2013-10-18','11:45:00',2.05),('5815','2013-10-18','11:50:00',2.01),('5815','2013-10-18','11:55:00',2.05),('5815','2013-10-18','12:00:00',2.13),('5815','2013-10-18','12:05:00',2.13),('5815','2013-10-18','12:10:00',2.09),('5815','2013-10-18','12:15:00',2.09),('5815','2013-10-18','12:20:00',2.13),('5815','2013-10-18','12:25:00',1.92),('5815','2013-10-18','12:30:00',2.08),('5815','2013-10-18','12:35:00',2.14),('5815','2013-10-18','12:40:00',2.18),('5815','2013-10-18','12:45:00',2.23),('5815','2013-10-18','12:50:00',2.28),('5815','2013-10-18','12:55:00',2.19),('5815','2013-10-18','13:00:00',2.37),('5815','2013-10-18','13:05:00',1.85),('5815','2013-10-18','13:10:00',1.93),('5815','2013-10-18','13:15:00',1.97),('5815','2013-10-18','13:20:00',1.94),('5815','2013-10-18','13:25:00',2.16),('5815','2013-10-18','13:30:00',2.19),('5815','2013-10-18','13:35:00',1.87),('5815','2013-10-18','13:40:00',1.69),('5815','2013-10-18','13:45:00',1.73),('5815','2013-10-18','13:50:00',1.81),('5815','2013-10-18','13:55:00',2.25),('5815','2013-10-18','14:00:00',1.86),('5815','2013-10-18','14:05:00',1.6),('5815','2013-10-18','14:10:00',1.22),('5815','2013-10-18','14:15:00',1.54),('5815','2013-10-18','14:20:00',1.39),('5815','2013-10-18','14:25:00',1.39),('5815','2013-10-18','14:30:00',1.61),('5815','2013-10-18','14:35:00',2.2),('5815','2013-10-18','14:40:00',1.67),('5815','2013-10-18','14:45:00',1.35),('5815','2013-10-18','14:50:00',1.97),('5815','2013-10-18','14:55:00',1.91),('5815','2013-10-18','15:00:00',1.85),('5815','2013-10-18','15:05:00',1.8),('5815','2013-10-18','15:10:00',1.78),('5815','2013-10-18','15:15:00',1.76),('5815','2013-10-18','15:20:00',1.65),('5815','2013-10-18','15:25:00',1.59),('5815','2013-10-18','15:30:00',1.52),('5815','2013-10-18','15:35:00',1.51),('5815','2013-10-18','15:40:00',1.4),('5815','2013-10-18','15:45:00',1.19),('5815','2013-10-18','15:50:00',1.25),('5815','2013-10-18','15:55:00',1.41),('5815','2013-10-18','16:00:00',1.19),('5815','2013-10-18','16:05:00',1.27),('5815','2013-10-18','16:10:00',1.21),('5815','2013-10-18','16:15:00',1.28),('5815','2013-10-18','16:20:00',1.21),('5815','2013-10-18','16:30:00',1.09),('5815','2013-10-18','16:35:00',1.14),('5815','2013-10-18','16:40:00',1.09),('5815','2014-05-03','08:30:00',1.09),('5815','2014-05-03','08:35:00',1.07),('5815','2014-05-03','09:05:00',1.28),('5815','2014-05-03','09:10:00',1.04),('5815','2014-05-03','09:15:00',1.34),('5815','2014-05-03','09:20:00',2),('5815','2014-05-03','09:25:00',1.52),('5815','2014-05-03','09:40:00',1.09),('5815','2014-05-03','09:45:00',1.38),('5815','2014-05-03','09:50:00',1.38),('5815','2014-05-03','09:55:00',1.53),('5815','2014-05-03','10:00:00',2.07),('5815','2014-05-03','10:05:00',1.99),('5815','2014-05-03','10:10:00',2.1),('5815','2014-05-03','10:15:00',1.51),('5815','2014-05-03','10:20:00',1.09),('5815','2014-05-03','10:25:00',1.06),('5815','2014-05-03','10:30:00',1.1),('5815','2014-05-03','10:35:00',1.16),('5815','2014-05-03','10:40:00',1.21),('5815','2014-05-03','10:45:00',1.69),('5815','2014-05-03','10:50:00',1.64),('5815','2014-05-03','10:55:00',1.53),('5815','2014-05-03','11:00:00',1.49),('5815','2014-05-03','11:05:00',2.18),('5815','2014-05-03','11:10:00',2.4),('5815','2014-05-03','11:15:00',2.39),('5815','2014-05-03','11:20:00',2.22),('5815','2014-05-03','11:25:00',1.95),('5815','2014-05-03','11:30:00',2.24),('5815','2014-05-03','11:35:00',2.22),('5815','2014-05-03','11:40:00',1.73),('5815','2014-05-03','11:45:00',2.55),('5815','2014-05-03','11:50:00',1.62),('5815','2014-05-03','11:55:00',2.03),('5815','2014-05-03','12:00:00',1.82),('5815','2014-05-03','12:05:00',1.67),('5815','2014-05-03','12:10:00',1.46),('5815','2014-05-03','12:20:00',1.02),('5815','2014-05-03','12:25:00',1.82),('5815','2014-05-03','12:30:00',2.95),('5815','2014-05-03','12:35:00',2.81),('5815','2014-05-03','12:40:00',2.85),('5815','2014-05-03','12:45:00',1.96),('5815','2014-05-03','12:50:00',1.37),('5815','2014-05-03','12:55:00',1.33),('5815','2014-05-03','13:00:00',1.39),('5815','2014-05-03','13:05:00',1.31),('5815','2014-05-03','13:10:00',1.34),('5815','2014-05-03','13:15:00',1.15),('5815','2014-05-03','13:20:00',1.03),('5815','2014-05-03','15:00:00',1.07),('5815','2014-05-03','15:05:00',1.82),('5815','2014-05-03','15:10:00',1.84),('5815','2014-05-03','15:15:00',1.58),('5815','2014-04-15','08:50:00',1.12),('5815','2014-04-15','08:55:00',1.17),('5815','2014-04-15','09:00:00',1.23),('5815','2014-04-15','09:05:00',1.29),('5815','2014-04-15','09:10:00',1.34),('5815','2014-04-15','09:15:00',1.38),('5815','2014-04-15','09:20:00',1.43),('5815','2014-04-15','09:25:00',1.51),('5815','2014-04-15','09:50:00',1.36),('5815','2014-04-15','09:55:00',1.94),('5815','2014-04-15','10:00:00',1.9),('5815','2014-04-15','10:05:00',1.92),('5815','2014-04-15','10:10:00',1.96),('5815','2014-04-15','10:15:00',2.01),('5815','2014-04-15','10:20:00',2.05),('5815','2014-04-15','10:25:00',2.08),('5815','2014-04-15','10:30:00',2.12),('5815','2014-04-15','10:35:00',2.15),('5815','2014-04-15','10:40:00',2.19),('5815','2014-04-15','10:45:00',2.22),('5815','2014-04-15','10:50:00',2.3),('5815','2014-04-15','10:55:00',2.08),('5815','2014-04-15','11:00:00',2.25),('5815','2014-04-15','11:05:00',1.82),('5815','2014-04-15','11:15:00',1.34),('5815','2014-04-15','11:20:00',2.64),('5815','2014-04-15','11:25:00',1.73),('5815','2014-04-15','11:30:00',2.24),('5815','2014-04-15','11:35:00',1.6),('5815','2014-04-15','11:40:00',2.24),('5815','2014-04-15','11:45:00',2.49),('5815','2014-04-15','11:50:00',2.86),('5815','2014-04-15','11:55:00',2.73),('5815','2014-04-15','12:00:00',2.8),('5815','2014-04-15','12:05:00',1.04),('5815','2014-04-15','12:10:00',2.48),('5815','2014-04-15','12:15:00',2.62),('5815','2014-04-15','12:20:00',2.23),('5815','2014-04-15','12:30:00',1.7),('5815','2014-04-15','12:35:00',2.76),('5815','2014-04-15','12:40:00',2.83),('5815','2014-04-15','12:45:00',2.77),('5815','2014-04-15','12:50:00',2.8),('5815','2014-04-15','12:55:00',1.93),('5815','2014-04-15','13:00:00',1.54),('5815','2014-04-15','13:40:00',1.21),('5815','2014-04-15','13:45:00',2.57),('5815','2014-04-15','13:50:00',2.46),('5815','2014-04-15','13:55:00',1.45),('5815','2014-04-15','14:00:00',1.04),('5815','2014-04-15','14:05:00',1.97),('5815','2014-04-15','14:10:00',2.81),('5815','2014-04-15','14:15:00',2.95),('5815','2014-04-15','14:20:00',2.59),('5815','2014-04-15','14:25:00',2.25),('5815','2014-04-15','14:30:00',2.31),('5815','2014-04-15','14:35:00',2.6),('5815','2014-04-15','14:40:00',2.55),('5815','2014-04-15','14:45:00',1.69),('5815','2014-04-15','14:50:00',2.03),('5815','2014-04-15','15:00:00',1.02),('5815','2014-04-15','15:05:00',1.94),('5815','2014-04-15','15:10:00',2.85),('5815','2014-04-15','15:15:00',1.6),('5815','2014-04-15','15:30:00',2.21),('5815','2014-04-15','15:35:00',2.49),('5815','2014-04-15','15:40:00',2.42),('5815','2014-04-15','15:45:00',2.33),('5815','2014-04-15','15:50:00',2.27),('5815','2014-04-15','15:55:00',2.21),('5815','2014-04-15','16:00:00',2.14),('5815','2014-04-15','16:05:00',2.08),('5815','2014-04-15','16:10:00',2.03),('5815','2014-04-15','16:15:00',2),('5815','2014-04-15','16:20:00',1.98),('5815','2014-04-15','16:25:00',1.91),('5815','2014-04-15','16:30:00',1.86),('5815','2014-04-15','16:35:00',1.83),('5815','2014-04-15','16:40:00',1.79),('5815','2014-04-15','16:45:00',1.75),('5815','2014-04-15','16:50:00',1.68),('5815','2014-04-15','16:55:00',1.62),('5815','2014-04-15','17:00:00',1.57),('5815','2014-04-15','17:05:00',1.51),('5815','2014-04-15','17:10:00',1.46),('5815','2014-04-15','17:15:00',1.41),('5815','2014-04-15','17:20:00',1.34),('5815','2014-04-15','17:25:00',1.27),('5815','2014-04-15','17:30:00',1.22),('5815','2014-04-15','17:35:00',1.03),('5815','2014-04-15','17:40:00',1.03),('5815','2014-04-15','17:45:00',1.03),('5815','2014-04-15','17:50:00',1.02),('5815','2013-10-17','09:15:00',1.01),('5815','2013-10-17','09:20:00',1.1),('5815','2013-10-17','09:25:00',1.13),('5815','2013-10-17','09:30:00',1.2),('5815','2013-10-17','09:35:00',1.25),('5815','2013-10-17','09:40:00',1.3),('5815','2013-10-17','09:45:00',1.35),('5815','2013-10-17','09:50:00',1.37),('5815','2013-10-17','09:55:00',1.43),('5815','2013-10-17','10:00:00',1.46),('5815','2013-10-17','10:05:00',1.51),('5815','2013-10-17','10:10:00',1.54),('5815','2013-10-17','10:15:00',1.58),('5815','2013-10-17','10:20:00',1.6),('5815','2013-10-17','10:25:00',1.65),('5815','2013-10-17','10:30:00',1.68),('5815','2013-10-17','10:35:00',1.72),('5815','2013-10-17','10:40:00',1.76),('5815','2013-10-17','10:45:00',1.78),('5815','2013-10-17','10:50:00',1.8),('5815','2013-10-17','10:55:00',1.84),('5815','2013-10-17','11:00:00',1.83),('5815','2013-10-17','11:05:00',1.82),('5815','2013-10-17','11:10:00',1.8),('5815','2013-10-17','11:15:00',1.67),('5815','2013-10-17','11:20:00',1.89),('5815','2013-10-17','11:25:00',1.74),('5815','2013-10-17','11:30:00',1.96),('5815','2013-10-17','11:35:00',1.98),('5815','2013-10-17','11:40:00',2.04),('5815','2013-10-17','11:45:00',1.99),('5815','2013-10-17','11:50:00',2.01),('5815','2013-10-17','11:55:00',2.06),('5815','2013-10-17','12:00:00',1.98),('5815','2013-10-17','12:05:00',2.06),('5815','2013-10-17','12:10:00',2.07),('5815','2013-10-17','12:15:00',2.04),('5815','2013-10-17','12:20:00',2.03),('5815','2013-10-17','12:25:00',2.08),('5815','2013-10-17','12:30:00',2.1),('5815','2013-10-17','12:35:00',2.03),('5815','2013-10-17','12:40:00',2.09),('5815','2013-10-17','12:45:00',2.03),('5815','2013-10-17','12:50:00',2.01),('5815','2013-10-17','12:55:00',2.07),('5815','2013-10-17','13:00:00',2.05),('5815','2013-10-17','13:05:00',2.01),('5815','2013-10-17','13:10:00',1.94),('5815','2013-10-17','13:15:00',2.03),('5815','2013-10-17','13:20:00',2.04),('5815','2013-10-17','13:25:00',2.11),('5815','2013-10-17','13:30:00',2.09),('5815','2013-10-17','13:35:00',2.06),('5815','2013-10-17','13:40:00',2.06),('5815','2013-10-17','13:45:00',2.02),('5815','2013-10-17','13:50:00',2.02),('5815','2013-10-17','13:55:00',2.01),('5815','2013-10-17','14:00:00',1.85),('5815','2013-10-17','14:05:00',1.91),('5815','2013-10-17','14:10:00',1.9),('5815','2013-10-17','14:15:00',1.94),('5815','2013-10-17','14:20:00',1.93),('5815','2013-10-17','14:25:00',1.92),('5815','2013-10-17','14:30:00',1.89),('5815','2013-10-17','14:35:00',1.83),('5815','2013-10-17','14:40:00',1.83),('5815','2013-10-17','14:45:00',1.79),('5815','2013-10-17','14:50:00',1.73),('5815','2013-10-17','14:55:00',1.74),('5815','2013-10-17','15:00:00',1.57),('5815','2013-10-17','15:05:00',1.42),('5815','2013-10-17','15:10:00',1.52),('5815','2013-10-17','15:15:00',1.54),('5815','2013-10-17','15:20:00',1.61),('5815','2013-10-17','15:25:00',1.54),('5815','2013-10-17','15:30:00',1.48),('5815','2013-10-17','15:35:00',1.47),('5815','2013-10-17','15:40:00',1.41),('5815','2013-10-17','15:45:00',1.28),('5815','2013-10-17','15:50:00',1.3),('5815','2013-10-17','15:55:00',1.21),('5815','2013-10-17','16:00:00',1.26),('5815','2013-10-17','16:05:00',1.18),('5815','2013-10-17','16:10:00',1.14),('5815','2013-10-17','16:15:00',1.03),('5815','2013-10-16','09:15:00',1.05),('5815','2013-10-16','09:20:00',1.1),('5815','2013-10-16','09:25:00',1.15),('5815','2013-10-16','09:30:00',1.19),('5815','2013-10-16','09:35:00',1.24),('5815','2013-10-16','09:40:00',1.29),('5815','2013-10-16','09:45:00',1.33),('5815','2013-10-16','09:50:00',1.38),('5815','2013-10-16','09:55:00',1.42),('5815','2013-10-16','10:00:00',1.46),('5815','2013-10-16','10:05:00',1.5),('5815','2013-10-16','10:10:00',1.54),('5815','2013-10-16','10:15:00',1.58),('5815','2013-10-16','10:20:00',1.62),('5815','2013-10-16','10:25:00',1.66),('5815','2013-10-16','10:30:00',1.7),('5815','2013-10-16','10:35:00',1.73),('5815','2013-10-16','10:40:00',1.76),('5815','2013-10-16','10:45:00',1.8),('5815','2013-10-16','10:50:00',1.81),('5815','2013-10-16','10:55:00',1.85),('5815','2013-10-16','11:00:00',1.87),('5815','2013-10-16','11:05:00',1.9),('5815','2013-10-16','11:10:00',1.92),('5815','2013-10-16','11:15:00',1.94),('5815','2013-10-16','11:20:00',1.96),('5815','2013-10-16','11:25:00',1.99),('5815','2013-10-16','11:30:00',2.02),('5815','2013-10-16','11:35:00',2.05),('5815','2013-10-16','11:40:00',2.07),('5815','2013-10-16','11:45:00',2.06),('5815','2013-10-16','11:50:00',2.07),('5815','2013-10-16','11:55:00',2.09),('5815','2013-10-16','12:00:00',2.09),('5815','2013-10-16','12:05:00',2.09),('5815','2013-10-16','12:10:00',2.12),('5815','2013-10-16','12:15:00',2.14),('5815','2013-10-16','12:20:00',2.13),('5815','2013-10-16','12:25:00',2.14),('5815','2013-10-16','12:30:00',2.16),('5815','2013-10-16','12:35:00',2.16),('5815','2013-10-16','12:40:00',2.16),('5815','2013-10-16','12:45:00',2.18),('5815','2013-10-16','12:50:00',2.18),('5815','2013-10-16','12:55:00',2.18),('5815','2013-10-16','13:00:00',2.16),('5815','2013-10-16','13:05:00',2.15),('5815','2013-10-16','13:10:00',2.14),('5815','2013-10-16','13:15:00',2.15),('5815','2013-10-16','13:20:00',2.17),('5815','2013-10-16','13:25:00',2.15),('5815','2013-10-16','13:30:00',2.13),('5815','2013-10-16','13:35:00',2.1),('5815','2013-10-16','13:40:00',2.1),('5815','2013-10-16','13:45:00',2.09),('5815','2013-10-16','13:50:00',2.07),('5815','2013-10-16','13:55:00',2.08),('5815','2013-10-16','14:00:00',2.07),('5815','2013-10-16','14:05:00',2.05),('5815','2013-10-16','14:10:00',2.04),('5815','2013-10-16','14:15:00',2.02),('5815','2013-10-16','14:20:00',1.99),('5815','2013-10-16','14:25:00',1.97),('5815','2013-10-16','14:30:00',1.95),('5815','2013-10-16','14:35:00',1.93),('5815','2013-10-16','14:40:00',1.91),('5815','2013-10-16','14:45:00',1.89),('5815','2013-10-16','14:50:00',1.85),('5815','2013-10-16','14:55:00',1.83),('5815','2013-10-16','15:00:00',1.81),('5815','2013-10-16','15:05:00',1.78),('5815','2013-10-16','15:10:00',1.76),('5815','2013-10-16','15:15:00',1.74),('5815','2013-10-16','15:20:00',1.7),('5815','2013-10-16','15:25:00',1.68),('5815','2013-10-16','15:30:00',1.64),('5815','2013-10-16','15:35:00',1.59),('5815','2013-10-16','15:40:00',1.53),('5815','2013-10-16','15:45:00',1.49),('5815','2013-10-16','15:50:00',1.46),('5815','2013-10-16','15:55:00',1.42),('5815','2013-10-16','16:00:00',1.37),('5815','2013-10-16','16:05:00',1.32),('5815','2013-10-16','16:10:00',1.28),('5815','2013-10-16','16:15:00',1.24),('5815','2013-10-16','16:20:00',1.19),('5815','2013-10-16','16:25:00',1.15),('5815','2013-10-16','16:30:00',1.11),('5815','2013-10-16','16:35:00',1.06),('5815','2013-10-16','16:40:00',1),('5815','2013-10-15','09:50:00',1.03),('5815','2013-10-15','12:20:00',1.76),('5815','2013-10-15','12:40:00',2.29),('5815','2013-10-15','12:45:00',2.35),('5815','2013-10-15','12:50:00',2.25),('5815','2013-10-15','12:55:00',1.93),('5815','2013-10-15','13:00:00',1.51),('5815','2013-10-15','13:05:00',2.04),('5815','2013-10-15','13:10:00',2.28),('5815','2013-10-15','13:15:00',1.59),('5815','2013-10-15','13:20:00',1.5),('5815','2013-10-15','13:25:00',2.13),('5815','2013-10-15','13:30:00',1.83),('5815','2013-10-15','13:35:00',2.12),('5815','2013-10-15','13:40:00',2.21),('5815','2013-10-15','13:45:00',2.16),('5815','2013-10-15','13:50:00',2.12),('5815','2013-10-15','13:55:00',2.25),('5815','2013-10-15','14:00:00',1.88),('5815','2013-10-15','14:05:00',1.44),('5815','2013-10-15','14:10:00',1.97),('5815','2013-10-15','14:15:00',1.33),('5815','2013-10-15','14:20:00',2.01),('5815','2013-10-15','14:25:00',1.01),('5815','2013-10-15','14:30:00',1.62),('5815','2013-10-15','14:35:00',1.63),('5815','2013-10-15','14:40:00',1.58),('5815','2013-10-15','14:45:00',2.04),('5815','2013-10-15','14:50:00',1.96),('5815','2013-10-15','14:55:00',1.68),('5815','2013-10-15','15:00:00',1.85),('5815','2013-10-15','15:05:00',1.86),('5815','2013-10-15','15:10:00',1.83),('5815','2013-10-15','15:15:00',1.81),('5815','2013-10-15','15:20:00',1.77),('5815','2013-10-15','15:25:00',1.42),('5815','2013-10-15','15:35:00',1.43),('5815','2013-10-15','15:40:00',1.69),('5815','2013-10-15','15:45:00',1.53),('5815','2013-10-15','15:50:00',1.48),('5815','2013-10-15','15:55:00',1.44),('5815','2013-10-15','16:00:00',1.41),('5815','2013-10-15','16:05:00',1.36),('5815','2013-10-15','16:10:00',1.28),('5815','2013-10-15','16:15:00',1.25),('5815','2013-10-15','16:20:00',1.2),('5815','2013-10-15','16:25:00',1.16),('5815','2013-10-15','16:30:00',1.08),('5815','2013-10-15','16:35:00',1.04),('5815','2013-10-15','16:40:00',1.01),('5815','2013-10-14','09:45:00',1.18),('5815','2013-10-14','09:50:00',1.34),('5815','2013-10-14','09:55:00',1.4),('5815','2013-10-14','10:00:00',1.39),('5815','2013-10-14','10:05:00',1.49),('5815','2013-10-14','10:10:00',1.18),('5815','2013-10-14','10:30:00',1.21),('5815','2013-10-14','10:40:00',1.19),('5815','2013-10-14','10:45:00',1.36),('5815','2013-10-14','10:50:00',1.34),('5815','2013-10-14','10:55:00',1.13),('5815','2013-10-14','11:00:00',1.13),('5815','2013-10-14','11:05:00',1.18),('5815','2013-10-14','11:10:00',1.6),('5815','2013-10-14','11:15:00',1.7),('5815','2013-10-14','11:20:00',1.72),('5815','2013-10-14','11:25:00',1.64),('5815','2013-10-14','11:30:00',1.68),('5815','2013-10-14','11:35:00',1.44),('5815','2013-10-14','11:40:00',1.13),('5815','2013-10-14','13:10:00',1.08),('5815','2013-10-14','13:15:00',1.11),('5815','2013-10-14','13:20:00',1.62),('5815','2013-10-14','13:25:00',1.93),('5815','2013-10-14','13:30:00',1.21),('5815','2013-10-14','13:35:00',1.01),('5815','2013-10-14','14:15:00',1.02),('5815','2013-10-14','14:20:00',1.2),('5815','2013-10-14','14:25:00',1.34),('5815','2013-10-14','14:30:00',1.36),('5815','2013-10-14','14:40:00',1.24),('5815','2013-10-14','14:45:00',1.39),('5815','2013-10-14','14:50:00',1.51),('5815','2013-10-14','14:55:00',1.31),('5815','2013-10-13','09:25:00',1.05),('5815','2013-10-13','09:30:00',1.16),('5815','2013-10-13','09:35:00',1.13),('5815','2013-10-13','09:50:00',1.06),('5815','2013-10-13','09:55:00',1.26),('5815','2013-10-13','10:00:00',1.22),('5815','2013-10-13','10:05:00',1.35),('5815','2013-10-13','10:10:00',1.42),('5815','2013-10-13','10:15:00',1.5),('5815','2013-10-13','10:20:00',1.53),('5815','2013-10-13','10:25:00',1.56),('5815','2013-10-13','10:30:00',1.58),('5815','2013-10-13','10:35:00',1.6),('5815','2013-10-13','10:40:00',1.58),('5815','2013-10-13','10:45:00',1.63),('5815','2013-10-13','10:50:00',1.7),('5815','2013-10-13','10:55:00',1.72),('5815','2013-10-13','11:00:00',1.76),('5815','2013-10-13','11:05:00',1.73),('5815','2013-10-13','11:10:00',1.82),('5815','2013-10-13','11:15:00',1.83),('5815','2013-10-13','11:20:00',1.83),('5815','2013-10-13','11:25:00',1.88),('5815','2013-10-13','11:30:00',1.92),('5815','2013-10-13','11:35:00',1.88),('5815','2013-10-13','11:40:00',1.9),('5815','2013-10-13','11:45:00',1.87),('5815','2013-10-13','11:50:00',1.9),('5815','2013-10-13','11:55:00',1.92),('5815','2013-10-13','12:00:00',1.93),('5815','2013-10-13','12:05:00',1.94),('5815','2013-10-13','12:10:00',1.98),('5815','2013-10-13','12:15:00',1.97),('5815','2013-10-13','12:20:00',1.83),('5815','2013-10-13','12:25:00',1.92),('5815','2013-10-13','12:30:00',2.05),('5815','2013-10-13','12:35:00',2.03),('5815','2013-10-13','12:40:00',2.03),('5815','2013-10-13','12:45:00',2.01),('5815','2013-10-13','12:50:00',2.02),('5815','2013-10-13','12:55:00',2.02),('5815','2013-10-13','13:00:00',2.02),('5815','2013-10-13','13:05:00',2.02),('5815','2013-10-13','13:10:00',2.03),('5815','2013-10-13','13:15:00',2.02),('5815','2013-10-13','13:20:00',2.02),('5815','2013-10-13','13:25:00',2.01),('5815','2013-10-13','13:30:00',2),('5815','2013-10-13','13:35:00',1.98),('5815','2013-10-13','13:40:00',1.98),('5815','2013-10-13','13:45:00',1.97),('5815','2013-10-13','13:50:00',1.95),('5815','2013-10-13','13:55:00',1.94),('5815','2013-10-13','14:00:00',1.92),('5815','2013-10-13','14:05:00',1.92),('5815','2013-10-13','14:10:00',1.91),('5815','2013-10-13','14:15:00',1.89),('5815','2013-10-13','14:20:00',1.87),('5815','2013-10-13','14:25:00',1.86),('5815','2013-10-13','14:30:00',1.84),('5815','2013-10-13','14:35:00',1.81),('5815','2013-10-13','14:40:00',1.79),('5815','2013-10-13','14:45:00',1.78),('5815','2013-10-13','14:50:00',1.77),('5815','2013-10-13','14:55:00',1.74),('5815','2013-10-13','15:00:00',1.71),('5815','2013-10-13','15:05:00',1.66),('5815','2013-10-13','15:10:00',1.63),('5815','2013-10-13','15:15:00',1.59),('5815','2013-10-13','15:20:00',1.56),('5815','2013-10-13','15:25:00',1.52),('5815','2013-10-13','15:30:00',1.48),('5815','2013-10-13','15:35:00',1.43),('5815','2013-10-13','15:40:00',1.25),('5815','2013-10-13','15:45:00',1.16),('5815','2013-10-13','15:50:00',1.05),('5815','2013-10-13','16:00:00',1.03),('5815','2013-10-12','09:15:00',1.01),('5815','2013-10-12','09:20:00',1.1),('5815','2013-10-12','09:25:00',1.03),('5815','2013-10-12','09:40:00',1.14),('5815','2013-10-12','09:45:00',1.61),('5815','2013-10-12','09:50:00',1.58),('5815','2013-10-12','09:55:00',1.64),('5815','2013-10-12','10:00:00',1.33),('5815','2013-10-12','10:10:00',1.18),('5815','2013-10-12','10:15:00',1.41),('5815','2013-10-12','10:20:00',1.16),('5815','2013-10-12','10:25:00',1.25),('5815','2013-10-12','10:30:00',1.59),('5815','2013-10-12','10:35:00',1.89),('5815','2013-10-12','10:40:00',1.96),('5815','2013-10-12','10:45:00',1.99),('5815','2013-10-12','10:50:00',1.83),('5815','2013-10-12','10:55:00',1.29),('5815','2013-10-12','11:00:00',1.69),('5815','2013-10-12','11:05:00',1.8),('5815','2013-10-12','11:10:00',1.92),('5815','2013-10-12','11:15:00',1.97),('5815','2013-10-12','11:20:00',1.91),('5815','2013-10-12','11:25:00',1.89),('5815','2013-10-12','11:30:00',1.93),('5815','2013-10-12','11:35:00',1.92),('5815','2013-10-12','11:40:00',1.93),('5815','2013-10-12','11:45:00',1.94),('5815','2013-10-12','11:50:00',1.96),('5815','2013-10-12','11:55:00',1.97),('5815','2013-10-12','12:00:00',1.99),('5815','2013-10-12','12:05:00',2),('5815','2013-10-12','12:10:00',2.01),('5815','2013-10-12','12:15:00',2.03),('5815','2013-10-12','12:20:00',2.02),('5815','2013-10-12','12:25:00',1.94),('5815','2013-10-12','12:30:00',2.02),('5815','2013-10-12','12:35:00',2.07),('5815','2013-10-12','12:40:00',2.06),('5815','2013-10-12','12:45:00',2.02),('5815','2013-10-12','12:50:00',2.01),('5815','2013-10-12','12:55:00',2.04),('5815','2013-10-12','13:00:00',2.04),('5815','2013-10-12','13:05:00',2.03),('5815','2013-10-12','13:10:00',2.05),('5815','2013-10-12','13:15:00',2.08),('5815','2013-10-12','13:20:00',2.08),('5815','2013-10-12','13:25:00',1.88),('5815','2013-10-12','13:30:00',1.51),('5815','2013-10-12','13:35:00',1.89),('5815','2013-10-12','13:40:00',1.18),('5815','2013-10-12','13:45:00',1.29),('5815','2013-10-12','13:50:00',1.38),('5815','2013-10-12','13:55:00',1.54),('5815','2013-10-12','14:00:00',1.96),('5815','2013-10-12','14:05:00',2.01),('5815','2013-10-12','14:10:00',1.97),('5815','2013-10-12','14:15:00',1.82),('5815','2013-10-12','14:20:00',1.98),('5815','2013-10-12','14:25:00',1.99),('5815','2013-10-12','14:30:00',1.87),('5815','2013-10-12','14:35:00',1.41),('5815','2013-10-12','14:40:00',1.73),('5815','2013-10-12','14:45:00',1.44),('5815','2013-10-12','14:50:00',1.11),('5815','2013-10-12','14:55:00',1.31),('5815','2013-10-12','15:00:00',1.57),('5815','2013-10-12','15:05:00',1.51),('5815','2013-10-12','15:10:00',1.04),('5815','2013-10-12','15:15:00',1.09),('5815','2013-10-12','15:20:00',1.32),('5815','2013-10-12','15:25:00',1.42),('5815','2013-10-12','15:30:00',1.06),('5815','2013-10-12','16:05:00',1.11),('5815','2013-10-12','16:25:00',1.15),('5815','2013-10-12','16:30:00',1.18),('5815','2013-10-12','16:35:00',1.06),('5815','2013-10-11','11:35:00',1),('5815','2013-10-11','11:40:00',1.79),('5815','2013-10-11','12:20:00',1.02),('5815','2013-10-11','12:25:00',2.22),('5815','2013-10-11','12:30:00',1.63),('5815','2013-10-11','12:35:00',1.96),('5815','2013-10-11','12:40:00',1.91),('5815','2013-10-11','12:45:00',1.75),('5815','2013-10-11','12:50:00',1.93),('5815','2013-10-11','12:55:00',1.65),('5815','2013-10-11','13:00:00',1.14),('5815','2013-10-11','13:30:00',2.01),('5815','2013-10-11','16:15:00',1.08),('5815','2013-10-10','09:45:00',1.38),('5815','2013-10-10','09:50:00',1.41),('5815','2013-10-10','09:55:00',1.44),('5815','2013-10-10','10:00:00',1.48),('5815','2013-10-10','10:05:00',1.49),('5815','2013-10-10','10:10:00',1.56),('5815','2013-10-10','10:15:00',1.38),('5815','2013-10-10','10:20:00',1.43),('5815','2013-10-10','10:25:00',1.05),('5815','2013-10-10','10:30:00',1.37),('5815','2013-10-10','10:35:00',1.93),('5815','2013-10-10','11:05:00',1.53),('5815','2013-10-10','11:10:00',1.72),('5815','2013-10-10','11:40:00',1.15),('5815','2013-10-10','11:45:00',1.01),('5815','2013-10-10','11:50:00',1.24),('5815','2013-10-10','11:55:00',1.05),('5815','2013-10-10','12:00:00',1.47),('5815','2013-10-10','12:05:00',2.46),('5815','2013-10-10','12:10:00',1.07),('5815','2013-10-10','12:30:00',1.13),('5815','2013-10-10','13:05:00',1.54),('5815','2013-10-10','13:20:00',1.13),('5815','2013-10-10','13:25:00',2.17),('5815','2013-10-10','13:40:00',1.61),('5815','2013-10-10','13:45:00',2.27),('5815','2013-10-10','16:00:00',1.35),('5815','2013-10-10','16:35:00',1.09),('5815','2013-10-09','09:15:00',1.04),('5815','2013-10-09','09:20:00',1.1),('5815','2013-10-09','09:25:00',1.09),('5815','2013-10-09','09:30:00',1.12),('5815','2013-10-09','09:35:00',1.02),('5815','2013-10-09','09:40:00',1.07),('5815','2013-10-09','09:45:00',1.01),('5815','2013-10-09','10:15:00',1.16),('5815','2013-10-09','10:20:00',1.61),('5815','2013-10-09','10:25:00',1.59),('5815','2013-10-09','10:30:00',1.64),('5815','2013-10-09','10:45:00',1.15),('5815','2013-10-09','11:25:00',1.95),('5815','2013-10-09','11:30:00',1.43),('5815','2013-10-09','11:55:00',2.01),('5815','2013-10-09','12:00:00',2.17),('5815','2013-10-09','12:05:00',1.56),('5815','2013-10-09','12:25:00',1.83),('5815','2013-10-09','12:35:00',2.23),('5815','2013-10-09','12:40:00',2.51),('5815','2013-10-09','12:45:00',1.89),('5815','2013-10-09','12:50:00',1.7),('5815','2013-10-09','13:00:00',1.73),('5815','2013-10-09','13:05:00',2.47),('5815','2013-10-09','13:10:00',1.58),('5815','2013-10-09','13:15:00',1.06),('5815','2013-10-09','13:25:00',1.61),('5815','2013-10-09','13:30:00',1.57),('5815','2013-10-09','13:35:00',1.37),('5815','2013-10-09','13:40:00',1.26),('5815','2013-10-09','13:45:00',2.17),('5815','2013-10-09','13:50:00',2.21),('5815','2013-10-09','13:55:00',2.27),('5815','2013-10-09','14:00:00',2.24),('5815','2013-10-09','14:05:00',1.56),('5815','2013-10-09','14:10:00',1.27),('5815','2013-10-09','14:15:00',1.16),('5815','2013-10-09','14:20:00',2.29),('5815','2013-10-09','14:25:00',2.19),('5815','2013-10-09','14:30:00',1.58),('5815','2013-10-09','14:35:00',1.26),('5815','2013-10-09','14:40:00',2.26),('5815','2013-10-09','14:45:00',2.07),('5815','2013-10-09','14:50:00',2.1),('5815','2013-10-09','14:55:00',2.08),('5815','2013-10-09','15:00:00',1.89),('5815','2013-10-09','15:05:00',2.08),('5815','2013-10-09','15:10:00',1.98),('5815','2013-10-09','15:15:00',2),('5815','2013-10-09','15:20:00',1.48),('5815','2013-10-09','15:25:00',1.26),('5815','2013-10-09','15:30:00',1.07),('5815','2013-10-09','16:15:00',1.18),('5815','2013-10-09','16:20:00',1.23),('5815','2013-10-09','16:25:00',1.29),('5815','2013-10-09','16:30:00',1.1),('5815','2013-10-09','16:45:00',1.11),('5815','2013-10-09','16:50:00',1.04),('5815','2013-10-08','09:10:00',1.04),('5815','2013-10-08','09:15:00',1.03),('5815','2013-10-08','09:25:00',1.19),('5815','2013-10-08','09:30:00',1.23),('5815','2013-10-08','09:35:00',1.28),('5815','2013-10-08','09:40:00',1.34),('5815','2013-10-08','09:45:00',1.4),('5815','2013-10-08','09:50:00',1.44),('5815','2013-10-08','09:55:00',1.51),('5815','2013-10-08','10:00:00',1.59),('5815','2013-10-08','10:05:00',1.64),('5815','2013-10-08','10:10:00',1.75),('5815','2013-10-08','10:35:00',1.12),('5815','2013-10-08','10:45:00',1.22),('5815','2013-10-08','10:50:00',2.25),('5815','2013-10-08','10:55:00',1.09),('5815','2013-10-08','11:00:00',1.72),('5815','2013-10-08','11:05:00',1.87),('5815','2013-10-08','11:10:00',2.39),('5815','2013-10-08','11:15:00',2.32),('5815','2013-10-08','11:20:00',2.15),('5815','2013-10-08','11:25:00',1.78),('5815','2013-10-08','11:30:00',2.3),('5815','2013-10-08','11:35:00',2.45),('5815','2013-10-08','11:40:00',1.96),('5815','2013-10-08','11:45:00',1.69),('5815','2013-10-08','11:50:00',2.01),('5815','2013-10-08','11:55:00',2.1),('5815','2013-10-08','12:00:00',1.73),('5815','2013-10-08','12:10:00',1.41),('5815','2013-10-08','12:15:00',1.32),('5815','2013-10-08','12:20:00',1.83),('5815','2013-10-08','12:25:00',2.2),('5815','2013-10-08','13:15:00',1.02),('5815','2013-10-08','13:20:00',1.13),('5815','2013-10-08','13:25:00',1.24),('5815','2013-10-08','13:30:00',1.24),('5815','2013-10-08','13:35:00',1.32),('5815','2013-10-08','13:40:00',2.09),('5815','2013-10-08','13:45:00',1.79),('5815','2013-10-08','13:50:00',1.79),('5815','2013-10-08','13:55:00',2.58),('5815','2013-10-08','14:00:00',2.36),('5815','2013-10-08','14:10:00',1.29),('5815','2013-10-08','14:55:00',1.68),('5815','2013-10-08','15:00:00',1.22),('5815','2013-10-08','15:05:00',1.84),('5815','2013-10-08','15:10:00',2.07),('5815','2013-10-08','15:15:00',1.89),('5815','2013-10-08','15:20:00',1.77),('5815','2013-10-08','15:25:00',1.74),('5815','2013-10-08','15:30:00',1.31),('5815','2013-10-08','15:35:00',1.08),('5815','2013-10-08','15:40:00',1.43),('5815','2013-10-08','15:50:00',1.22),('5815','2013-10-08','16:20:00',1.11),('5815','2013-10-08','16:30:00',1.55),('5815','2013-10-08','16:40:00',1.15),('5815','2014-04-14','09:05:00',1.07),('5815','2014-04-14','09:15:00',1.07),('5815','2014-04-14','09:25:00',1.28),('5815','2014-04-14','09:30:00',1.23),('5815','2014-04-14','09:50:00',1.75),('5815','2014-04-14','10:15:00',1.27),('5815','2014-04-14','10:30:00',1.02),('5815','2014-04-14','10:35:00',1.95),('5815','2014-04-14','10:40:00',1.14),('5815','2014-04-14','10:45:00',1.67),('5815','2014-04-14','10:50:00',1.42),('5815','2014-04-14','11:05:00',1.93),('5815','2014-04-14','11:10:00',1.84),('5815','2014-04-14','12:20:00',1.07),('5815','2014-04-14','13:20:00',1.59),('5815','2014-04-14','13:25:00',1.02),('5815','2014-04-14','13:30:00',1.67),('5815','2014-04-14','13:35:00',1.42),('5815','2014-04-14','13:40:00',1.68),('5815','2014-04-14','14:00:00',1.12),('5815','2014-04-14','14:05:00',1.63),('5815','2014-04-14','14:15:00',1.97),('5815','2014-04-14','14:20:00',1.73),('5815','2014-04-14','14:25:00',2.19),('5815','2014-04-14','14:30:00',1.59),('5815','2014-04-14','14:35:00',1.3),('5815','2014-04-14','15:25:00',1.33),('5815','2013-10-07','11:10:00',1.61),('5815','2013-10-07','11:15:00',2.4),('5815','2013-10-07','11:20:00',2.2),('5815','2013-10-07','11:25:00',1.16),('5815','2013-10-07','11:30:00',1.81),('5815','2013-10-07','11:35:00',1.56),('5815','2013-10-07','12:30:00',2.05),('5815','2013-10-07','12:35:00',1.15),('5815','2013-10-07','12:40:00',2.72),('5815','2013-10-07','12:45:00',2.41),('5815','2013-10-07','12:50:00',2.45),('5815','2013-10-07','12:55:00',2.43),('5815','2013-10-07','13:00:00',2.1),('5815','2013-10-07','13:05:00',2.21),('5815','2013-10-07','13:10:00',1.45),('5815','2013-10-07','13:15:00',2.3),('5815','2013-10-07','13:20:00',1.06),('5815','2013-10-07','13:25:00',1.93),('5815','2013-10-07','13:30:00',1.18),('5815','2013-10-07','14:10:00',1.33),('5815','2013-10-07','14:15:00',1.4),('5815','2013-10-07','14:20:00',1.71),('5815','2013-10-07','14:25:00',1.7),('5815','2013-10-07','14:30:00',1.79),('5815','2013-10-07','14:45:00',1.88),('5815','2013-10-07','14:50:00',2.14),('5815','2013-10-07','14:55:00',2.02),('5815','2013-10-07','15:00:00',1.98),('5815','2013-10-07','15:05:00',1.99),('5815','2013-10-07','15:10:00',1.97),('5815','2013-10-07','15:15:00',1.8),('5815','2013-10-07','15:20:00',1.61),('5815','2013-10-07','15:25:00',1.4),('5815','2013-10-07','15:30:00',2.06),('5815','2013-10-07','15:35:00',1.98),('5815','2013-10-07','15:40:00',1.67),('5815','2013-10-07','15:45:00',1.11),('5815','2013-10-07','15:50:00',1.41),('5815','2013-10-07','15:55:00',1.13),('5815','2013-10-06','09:05:00',1.08),('5815','2013-10-06','09:10:00',1.05),('5815','2013-10-06','09:15:00',1.09),('5815','2013-10-06','09:20:00',1.13),('5815','2013-10-06','09:25:00',1.17),('5815','2013-10-06','09:30:00',1.22),('5815','2013-10-06','09:35:00',1.27),('5815','2013-10-06','09:40:00',1.32),('5815','2013-10-06','09:45:00',1.36),('5815','2013-10-06','09:50:00',1.4),('5815','2013-10-06','09:55:00',1.44),('5815','2013-10-06','10:00:00',1.47),('5815','2013-10-06','10:05:00',1.53),('5815','2013-10-06','10:10:00',1.55),('5815','2013-10-06','10:15:00',1.58),('5815','2013-10-06','10:20:00',1.64),('5815','2013-10-06','10:25:00',1.68),('5815','2013-10-06','10:30:00',1.72),('5815','2013-10-06','10:35:00',1.8),('5815','2013-10-06','10:40:00',1.8),('5815','2013-10-06','10:45:00',1.84),('5815','2013-10-06','10:50:00',1.86),('5815','2013-10-06','10:55:00',1.65),('5815','2013-10-06','11:00:00',1.72),('5815','2013-10-06','11:05:00',1.95),('5815','2013-10-06','11:10:00',1.59),('5815','2013-10-06','11:15:00',1.66),('5815','2013-10-06','11:20:00',1.93),('5815','2013-10-06','11:25:00',2.02),('5815','2013-10-06','11:30:00',2.02),('5815','2013-10-06','11:35:00',2.05),('5815','2013-10-06','11:40:00',2.07),('5815','2013-10-06','11:45:00',2.07),('5815','2013-10-06','11:50:00',2.08),('5815','2013-10-06','11:55:00',2.12),('5815','2013-10-06','12:00:00',2.12),('5815','2013-10-06','12:05:00',1.79),('5815','2013-10-06','12:10:00',2.31),('5815','2013-10-06','12:15:00',1.73),('5815','2013-10-06','12:20:00',1.7),('5815','2013-10-06','12:25:00',2.21),('5815','2013-10-06','12:30:00',2.42),('5815','2013-10-06','12:35:00',2.24),('5815','2013-10-06','12:40:00',2.34),('5815','2013-10-06','12:45:00',2.35),('5815','2013-10-06','12:50:00',2.34),('5815','2013-10-06','12:55:00',2.39),('5815','2013-10-06','13:00:00',2.05),('5815','2013-10-06','13:05:00',2.35),('5815','2013-10-06','13:10:00',2.35),('5815','2013-10-06','13:15:00',1.42),('5815','2013-10-06','13:20:00',2.11),('5815','2013-10-06','13:25:00',2.13),('5815','2013-10-06','13:30:00',2.3),('5815','2013-10-06','13:40:00',1.09),('5815','2013-10-06','13:50:00',1.54),('5815','2013-10-06','13:55:00',2.42),('5815','2013-10-06','14:00:00',2.61),('5815','2013-10-06','14:05:00',1.44),('5815','2013-10-06','14:25:00',1.92),('5815','2013-10-06','14:35:00',1.17),('5815','2013-10-06','14:40:00',1.29),('5815','2013-10-06','14:45:00',1.94),('5815','2013-10-06','14:50:00',2.31),('5815','2013-10-06','14:55:00',2.3),('5815','2013-10-06','15:00:00',1.61),('5815','2013-10-06','15:05:00',1.18),('5815','2013-10-06','15:10:00',1.82),('5815','2013-10-06','15:25:00',1.4),('5815','2013-10-06','15:30:00',1.24),('5815','2013-10-06','15:40:00',1.19),('5815','2013-10-06','15:45:00',1.61),('5815','2013-10-06','15:50:00',1.19),('5815','2013-10-06','15:55:00',1.86),('5815','2013-10-06','16:10:00',1.25),('5815','2013-10-06','16:15:00',1.57),('5815','2013-10-06','16:20:00',1.49),('5815','2013-10-06','16:25:00',1.1),('5815','2013-10-06','16:30:00',1.37),('5815','2013-10-06','16:35:00',1.08),('5815','2013-10-06','16:40:00',1.25),('5815','2013-10-06','16:45:00',1.19),('5815','2013-10-06','16:50:00',1.12),('5815','2013-10-06','16:55:00',1),('5815','2013-10-05','09:50:00',1.23),('5815','2013-10-05','09:55:00',1.47),('5815','2013-10-05','10:00:00',1.71),('5815','2013-10-05','10:05:00',1.75),('5815','2013-10-05','10:10:00',1.7),('5815','2013-10-05','10:15:00',1.58),('5815','2013-10-05','10:20:00',1.59),('5815','2013-10-05','10:25:00',1.78),('5815','2013-10-05','10:30:00',1.74),('5815','2013-10-05','10:35:00',1.73),('5815','2013-10-05','10:40:00',1.47),('5815','2013-10-05','10:45:00',1.19),('5815','2013-10-05','10:50:00',1.31),('5815','2013-10-05','10:55:00',1.46),('5815','2013-10-05','11:00:00',1.51),('5815','2013-10-05','11:05:00',1.68),('5815','2013-10-05','11:10:00',1.76),('5815','2013-10-05','11:15:00',1.7),('5815','2013-10-05','11:20:00',1.7),('5815','2013-10-05','11:25:00',1.82),('5815','2013-10-05','11:30:00',1.76),('5815','2013-10-05','11:35:00',1.74),('5815','2013-10-05','11:40:00',1.51),('5815','2013-10-05','11:45:00',1.14),('5815','2013-10-05','11:50:00',1.22),('5815','2013-10-05','11:55:00',1.61),('5815','2013-10-05','12:00:00',1.65),('5815','2013-10-05','12:05:00',1.67),('5815','2013-10-05','12:10:00',2.06),('5815','2013-10-05','12:15:00',2.01),('5815','2013-10-05','12:20:00',1.74),('5815','2013-10-05','12:25:00',1.52),('5815','2013-10-05','12:30:00',1.63),('5815','2013-10-05','12:35:00',1.71),('5815','2013-10-05','12:40:00',1.46),('5815','2013-10-05','12:45:00',1.45),('5815','2013-10-05','12:50:00',1.71),('5815','2013-10-05','12:55:00',2.04),('5815','2013-10-05','13:00:00',2.11),('5815','2013-10-05','13:05:00',2.03),('5815','2013-10-05','13:10:00',1.58),('5815','2013-10-05','13:20:00',1.91),('5815','2013-10-05','13:50:00',2.1),('5815','2013-10-05','13:55:00',1.36),('5815','2013-10-05','14:00:00',1.13),('5815','2013-10-05','14:05:00',2.14),('5815','2013-10-05','14:10:00',2.17),('5815','2013-10-05','14:15:00',1.44),('5815','2013-10-05','14:20:00',1.16),('5815','2013-10-05','14:30:00',1.07),('5815','2013-10-05','14:50:00',1.11),('5815','2013-10-05','14:55:00',1.52),('5815','2013-10-05','15:00:00',1.3),('5815','2013-10-03','09:55:00',1.56),('5815','2013-10-03','10:00:00',1.22),('5815','2013-10-03','10:15:00',1.06),('5815','2013-10-03','10:25:00',1.32),('5815','2013-10-03','10:30:00',1.14),('5815','2013-10-03','10:40:00',1.66),('5815','2013-10-03','10:45:00',1.41),('5815','2013-10-03','10:50:00',1.01),('5815','2013-10-03','10:55:00',1.59),('5815','2013-10-03','11:00:00',1.44),('5815','2013-10-03','11:05:00',1.01),('5815','2013-10-03','11:15:00',2.08),('5815','2013-10-03','11:20:00',1.76),('5815','2013-10-03','11:25:00',1.77),('5815','2013-10-03','11:30:00',2.27),('5815','2013-10-03','11:35:00',2.27),('5815','2013-10-03','11:40:00',2.24),('5815','2013-10-03','11:45:00',2.2),('5815','2013-10-03','11:50:00',2.16),('5815','2013-10-03','11:55:00',2.16),('5815','2013-10-03','12:00:00',2.15),('5815','2013-10-03','12:05:00',2.18),('5815','2013-10-03','12:10:00',2.21),('5815','2013-10-03','12:15:00',2),('5815','2013-10-03','12:20:00',2.12),('5815','2013-10-03','12:25:00',2.25),('5815','2013-10-03','12:30:00',2.04),('5815','2013-10-03','12:35:00',1.97),('5815','2013-10-03','12:40:00',2.2),('5815','2013-10-03','12:45:00',2.21),('5815','2013-10-03','12:50:00',2.12),('5815','2013-10-03','12:55:00',2.15),('5815','2013-10-03','13:00:00',2.17),('5815','2013-10-03','13:05:00',2.19),('5815','2013-10-03','13:10:00',2.19),('5815','2013-10-03','13:15:00',2.3),('5815','2013-10-03','13:20:00',2.26),('5815','2013-10-03','13:25:00',2.13),('5815','2013-10-03','13:30:00',2.26),('5815','2013-10-03','13:35:00',1.63),('5815','2013-10-03','13:40:00',2.18),('5815','2013-10-03','13:45:00',2.14),('5815','2013-10-03','13:50:00',2.12),('5815','2013-10-03','13:55:00',2.12),('5815','2013-10-03','14:00:00',2.11),('5815','2013-10-03','14:05:00',2.09),('5815','2013-10-03','14:10:00',1.93),('5815','2013-10-03','14:15:00',1.76),('5815','2013-10-03','14:20:00',1.84),('5815','2013-10-03','14:25:00',2.02),('5815','2013-10-03','14:30:00',1.76),('5815','2013-10-03','14:35:00',1.26),('5815','2013-10-03','14:40:00',1.04),('5815','2013-10-03','14:45:00',1.12),('5815','2013-10-03','14:50:00',1.53),('5815','2013-10-03','14:55:00',1.59),('5815','2013-10-03','15:00:00',1.37),('5815','2013-10-03','15:05:00',1.55),('5815','2013-10-03','15:10:00',1.37),('5815','2013-10-03','15:15:00',1.07),('5815','2013-10-03','15:25:00',1.35),('5815','2013-10-03','15:30:00',1.67),('5815','2013-10-03','15:35:00',1.02),('5815','2013-10-02','09:05:00',1.05),('5815','2013-10-02','09:10:00',1.11),('5815','2013-10-02','09:15:00',1.17),('5815','2013-10-02','09:20:00',1.22),('5815','2013-10-02','09:25:00',1.28),('5815','2013-10-02','09:30:00',1.33),('5815','2013-10-02','09:35:00',1.38),('5815','2013-10-02','09:40:00',1.43),('5815','2013-10-02','09:45:00',1.48),('5815','2013-10-02','09:50:00',1.53),('5815','2013-10-02','09:55:00',1.57),('5815','2013-10-02','10:00:00',1.62),('5815','2013-10-02','10:05:00',1.67),('5815','2013-10-02','10:10:00',1.71),('5815','2013-10-02','10:15:00',1.76),('5815','2013-10-02','10:20:00',1.79),('5815','2013-10-02','10:25:00',1.83),('5815','2013-10-02','10:30:00',1.87),('5815','2013-10-02','10:35:00',1.88),('5815','2013-10-02','10:40:00',1.93),('5815','2013-10-02','10:45:00',1.97),('5815','2013-10-02','10:50:00',1.99),('5815','2013-10-02','10:55:00',2.03),('5815','2013-10-02','11:00:00',2.05),('5815','2013-10-02','11:05:00',2.07),('5815','2013-10-02','11:10:00',2.1),('5815','2013-10-02','11:15:00',2.13),('5815','2013-10-02','11:20:00',2.15),('5815','2013-10-02','11:25:00',2.18),('5815','2013-10-02','11:30:00',2.19),('5815','2013-10-02','11:35:00',2.22),('5815','2013-10-02','11:40:00',2.24),('5815','2013-10-02','11:45:00',2.25),('5815','2013-10-02','11:50:00',2.27),('5815','2013-10-02','11:55:00',2.31),('5815','2013-10-02','12:00:00',2.31),('5815','2013-10-02','12:05:00',2.31),('5815','2013-10-02','12:10:00',2.33),('5815','2013-10-02','12:15:00',2.32),('5815','2013-10-02','12:20:00',2.32),('5815','2013-10-02','12:25:00',2.34),('5815','2013-10-02','12:30:00',2.36),('5815','2013-10-02','12:35:00',2.37),('5815','2013-10-02','12:40:00',2.36),('5815','2013-10-02','12:45:00',2.36),('5815','2013-10-02','12:50:00',2.37),('5815','2013-10-02','12:55:00',2.37),('5815','2013-10-02','13:00:00',2.35),('5815','2013-10-02','13:05:00',2.33),('5815','2013-10-02','13:10:00',2.34),('5815','2013-10-02','13:15:00',2.33),('5815','2013-10-02','13:20:00',2.32),('5815','2013-10-02','13:25:00',2.32),('5815','2013-10-02','13:30:00',2.33),('5815','2013-10-02','13:35:00',2.32),('5815','2013-10-02','13:40:00',2.31),('5815','2013-10-02','13:45:00',2.3),('5815','2013-10-02','13:50:00',2.28),('5815','2013-10-02','13:55:00',2.29),('5815','2013-10-02','14:00:00',2.28),('5815','2013-10-02','14:05:00',2.28),('5815','2013-10-02','14:10:00',2.26),('5815','2013-10-02','14:15:00',2.24),('5815','2013-10-02','14:20:00',2.22),('5815','2013-10-02','14:25:00',2.2),('5815','2013-10-02','14:30:00',2.18),('5815','2013-10-02','14:35:00',2.15),('5815','2013-10-02','14:40:00',2.13),('5815','2013-10-02','14:45:00',2.11),('5815','2013-10-02','14:50:00',2.08),('5815','2013-10-02','14:55:00',2.06),('5815','2013-10-02','15:00:00',2.03),('5815','2013-10-02','15:05:00',2),('5815','2013-10-02','15:10:00',1.97),('5815','2013-10-02','15:15:00',1.94),('5815','2013-10-02','15:20:00',1.91),('5815','2013-10-02','15:25:00',1.88),('5815','2013-10-02','15:30:00',1.84),('5815','2013-10-02','15:35:00',1.8),('5815','2013-10-02','15:40:00',1.76),('5815','2013-10-02','15:45:00',1.72),('5815','2013-10-02','15:50:00',1.68),('5815','2013-10-02','15:55:00',1.64),('5815','2013-10-02','16:00:00',1.6),('5815','2013-10-02','16:05:00',1.53),('5815','2013-10-02','16:10:00',1.51),('5815','2013-10-02','16:15:00',1.46),('5815','2013-10-02','16:20:00',1.42),('5815','2013-10-02','16:25:00',1.37),('5815','2013-10-02','16:30:00',1.32),('5815','2013-10-02','16:35:00',1.26),('5815','2013-10-02','16:40:00',1.21),('5815','2013-10-02','16:45:00',1.16),('5815','2013-10-02','16:50:00',1.11),('5815','2013-10-02','16:55:00',1.05),('5815','2013-10-01','09:10:00',1.05),('5815','2013-10-01','09:15:00',1.11),('5815','2013-10-01','09:20:00',1.16),('5815','2013-10-01','09:25:00',1.21),('5815','2013-10-01','09:30:00',1.26),('5815','2013-10-01','09:35:00',1.31),('5815','2013-10-01','09:40:00',1.35),('5815','2013-10-01','09:45:00',1.4),('5815','2013-10-01','09:50:00',1.44),('5815','2013-10-01','09:55:00',1.48),('5815','2013-10-01','10:00:00',1.52),('5815','2013-10-01','10:05:00',1.55),('5815','2013-10-01','10:10:00',1.59),('5815','2013-10-01','10:15:00',1.63),('5815','2013-10-01','10:20:00',1.68),('5815','2013-10-01','10:25:00',1.72),('5815','2013-10-01','10:30:00',1.75),('5815','2013-10-01','10:35:00',1.79),('5815','2013-10-01','10:40:00',1.84),('5815','2013-10-01','10:45:00',1.87),('5815','2013-10-01','10:50:00',1.91),('5815','2013-10-01','10:55:00',1.94),('5815','2013-10-01','11:00:00',1.97),('5815','2013-10-01','11:05:00',1.99),('5815','2013-10-01','11:10:00',2.02),('5815','2013-10-01','11:15:00',2.04),('5815','2013-10-01','11:20:00',2.07),('5815','2013-10-01','11:25:00',2.08),('5815','2013-10-01','11:30:00',2.1),('5815','2013-10-01','11:35:00',2.12),('5815','2013-10-01','11:40:00',2.15),('5815','2013-10-01','11:45:00',2.17),('5815','2013-10-01','11:50:00',2.17),('5815','2013-10-01','11:55:00',2.19),('5815','2013-10-01','12:00:00',2.21),('5815','2013-10-01','12:05:00',2.17),('5815','2013-10-01','12:10:00',2.23),('5815','2013-10-01','12:15:00',2.24),('5815','2013-10-01','12:20:00',2.24),('5815','2013-10-01','12:25:00',2.24),('5815','2013-10-01','12:30:00',2.24),('5815','2013-10-01','12:35:00',2.26),('5815','2013-10-01','12:40:00',2.26),('5815','2013-10-01','12:45:00',2.27),('5815','2013-10-01','12:50:00',2.28),('5815','2013-10-01','12:55:00',2.28),('5815','2013-10-01','13:00:00',2.27),('5815','2013-10-01','13:05:00',2.28),('5815','2013-10-01','13:10:00',2.27),('5815','2013-10-01','13:15:00',2.27),('5815','2013-10-01','13:20:00',2.26),('5815','2013-10-01','13:25:00',2.27),('5815','2013-10-01','13:30:00',2.27),('5815','2013-10-01','13:35:00',2.25),('5815','2013-10-01','13:40:00',2.26),('5815','2013-10-01','13:45:00',2.25),('5815','2013-10-01','13:50:00',2.24),('5815','2013-10-01','13:55:00',2.21),('5815','2013-10-01','14:00:00',2.21),('5815','2013-10-01','14:05:00',2.19),('5815','2013-10-01','14:10:00',2.18),('5815','2013-10-01','14:15:00',2.17),('5815','2013-10-01','14:20:00',2.14),('5815','2013-10-01','14:25:00',2.13),('5815','2013-10-01','14:30:00',2.11),('5815','2013-10-01','14:35:00',2.1),('5815','2013-10-01','14:40:00',2.07),('5815','2013-10-01','14:45:00',2.05),('5815','2013-10-01','14:50:00',2.03),('5815','2013-10-01','14:55:00',2.01),('5815','2013-10-01','15:00:00',1.99),('5815','2013-10-01','15:05:00',1.96),('5815','2013-10-01','15:10:00',1.92),('5815','2013-10-01','15:15:00',1.89),('5815','2013-10-01','15:20:00',1.86),('5815','2013-10-01','15:25:00',1.82),('5815','2013-10-01','15:30:00',1.79),('5815','2013-10-01','15:35:00',1.76),('5815','2013-10-01','15:40:00',1.73),('5815','2013-10-01','15:45:00',1.69),('5815','2013-10-01','15:50:00',1.63),('5815','2013-10-01','15:55:00',1.59),('5815','2013-10-01','16:00:00',1.56),('5815','2013-10-01','16:05:00',1.52),('5815','2013-10-01','16:10:00',1.47),('5815','2013-10-01','16:15:00',1.43),('5815','2013-10-01','16:20:00',1.38),('5815','2013-10-01','16:25:00',1.33),('5815','2013-10-01','16:30:00',1.29),('5815','2013-10-01','16:35:00',1.24),('5815','2013-10-01','16:40:00',1.18),('5815','2013-10-01','16:45:00',1.12),('5815','2013-10-01','16:50:00',1.07),('5815','2013-10-01','16:55:00',1.02),('5815','2013-09-30','09:05:00',1),('5815','2013-09-30','09:10:00',1.05),('5815','2013-09-30','09:15:00',1.11),('5815','2013-09-30','09:20:00',1.15),('5815','2013-09-30','09:25:00',1.19),('5815','2013-09-30','09:30:00',1.24),('5815','2013-09-30','09:35:00',1.28),('5815','2013-09-30','09:40:00',1.32),('5815','2013-09-30','09:45:00',1.37),('5815','2013-09-30','09:50:00',1.41),('5815','2013-09-30','09:55:00',1.46),('5815','2013-09-30','10:00:00',1.5),('5815','2013-09-30','10:05:00',1.54),('5815','2013-09-30','10:10:00',1.58),('5815','2013-09-30','10:15:00',1.62),('5815','2013-09-30','10:20:00',1.66),('5815','2013-09-30','10:25:00',1.69),('5815','2013-09-30','10:30:00',1.74),('5815','2013-09-30','10:35:00',1.78),('5815','2013-09-30','10:40:00',1.8),('5815','2013-09-30','10:45:00',1.82),('5815','2013-09-30','10:50:00',1.85),('5815','2013-09-30','10:55:00',1.87),('5815','2013-09-30','11:00:00',1.93),('5815','2013-09-30','11:05:00',1.21),('5815','2013-09-30','11:10:00',2.16),('5815','2013-09-30','11:15:00',1.55),('5815','2013-09-30','11:20:00',2.08),('5815','2013-09-30','11:25:00',1.66),('5815','2013-09-30','11:30:00',2.15),('5815','2013-09-30','11:35:00',1.58),('5815','2013-09-30','11:40:00',2.21),('5815','2013-09-30','11:45:00',2.26),('5815','2013-09-30','11:50:00',2.27),('5815','2013-09-30','11:55:00',2.23),('5815','2013-09-30','12:00:00',1.97),('5815','2013-09-30','12:10:00',1.83),('5815','2013-09-30','12:15:00',2.23),('5815','2013-09-30','12:20:00',2.33),('5815','2013-09-30','12:25:00',2.24),('5815','2013-09-30','12:30:00',2.4),('5815','2013-09-30','12:35:00',2.41),('5815','2013-09-30','12:40:00',1.63),('5815','2013-09-30','12:45:00',2.03),('5815','2013-09-30','12:50:00',2.35),('5815','2013-09-30','12:55:00',2.3),('5815','2013-09-30','13:00:00',2.15),('5815','2013-09-30','13:05:00',2.37),('5815','2013-09-30','13:20:00',2.48),('5815','2013-09-30','13:25:00',2.47),('5815','2013-09-30','13:30:00',1.8),('5815','2013-09-30','13:35:00',2.07),('5815','2013-09-30','13:40:00',1.04),('5815','2013-09-30','13:45:00',1.68),('5815','2013-09-30','13:55:00',1.17),('5815','2013-09-30','14:00:00',2.29),('5815','2013-09-30','14:05:00',2.22),('5815','2013-09-30','14:10:00',2.18),('5815','2013-09-30','14:15:00',2.16),('5815','2013-09-30','14:20:00',2.13),('5815','2013-09-30','14:25:00',2.11),('5815','2013-09-30','14:30:00',2.1),('5815','2013-09-30','14:35:00',2.09),('5815','2013-09-30','14:40:00',2.06),('5815','2013-09-30','14:45:00',2.08),('5815','2013-09-30','14:50:00',2.08),('5815','2013-09-30','14:55:00',2.05),('5815','2013-09-30','15:00:00',2.03),('5815','2013-09-30','15:05:00',1.95),('5815','2013-09-30','15:10:00',1.91),('5815','2013-09-30','15:15:00',1.88),('5815','2013-09-30','15:20:00',1.86),('5815','2013-09-30','15:25:00',1.83),('5815','2013-09-30','15:30:00',1.8),('5815','2013-09-30','15:35:00',1.76),('5815','2013-09-30','15:40:00',1.72),('5815','2013-09-30','15:45:00',1.68),('5815','2013-09-30','15:50:00',1.65),('5815','2013-09-30','15:55:00',1.61),('5815','2013-09-30','16:00:00',1.57),('5815','2013-09-30','16:05:00',1.52),('5815','2013-09-30','16:10:00',1.47),('5815','2013-09-30','16:15:00',1.43),('5815','2013-09-30','16:20:00',1.39),('5815','2013-09-30','16:25:00',1.35),('5815','2013-09-30','16:30:00',1.29),('5815','2013-09-30','16:35:00',1.24),('5815','2013-09-30','16:40:00',1.19),('5815','2013-09-30','16:45:00',1.13),('5815','2013-09-30','16:50:00',1.08),('5815','2013-09-30','16:55:00',1.03),('5815','2013-09-29','10:40:00',1.26),('5815','2013-09-29','10:45:00',1.92),('5815','2013-09-29','10:50:00',2.02),('5815','2013-09-29','10:55:00',1.85),('5815','2013-09-29','11:00:00',1.64),('5815','2013-09-29','11:05:00',1.87),('5815','2013-09-29','11:10:00',1.95),('5815','2013-09-29','11:15:00',1.56),('5815','2013-09-29','11:20:00',1.53),('5815','2013-09-29','11:25:00',1.78),('5815','2013-09-29','11:35:00',1.09),('5815','2013-09-29','11:40:00',1.95),('5815','2013-09-29','11:45:00',1.22),('5815','2013-09-29','11:50:00',1.08),('5815','2013-09-29','12:00:00',1.05),('5815','2013-09-29','12:05:00',1.91),('5815','2013-09-29','12:10:00',1.63),('5815','2013-09-29','12:15:00',2.36),('5815','2013-09-29','12:20:00',2.43),('5815','2013-09-29','12:25:00',2.45),('5815','2013-09-29','12:30:00',2.36),('5815','2013-09-29','12:35:00',2.31),('5815','2013-09-29','12:40:00',2.38),('5815','2013-09-29','12:45:00',1.73),('5815','2013-09-29','12:50:00',2.44),('5815','2013-09-29','12:55:00',2.4),('5815','2013-09-29','13:00:00',2.4),('5815','2013-09-29','13:05:00',1.84),('5815','2013-09-29','13:10:00',2.47),('5815','2013-09-29','13:15:00',2.05),('5815','2013-09-29','13:20:00',2.58),('5815','2013-09-29','13:25:00',2.7),('5815','2013-09-29','13:30:00',2.69),('5815','2013-09-29','13:35:00',2.11),('5815','2013-09-29','13:40:00',1.56),('5815','2013-09-29','13:50:00',1.84),('5815','2013-09-29','13:55:00',1.46),('5815','2013-09-29','14:30:00',1.43),('5815','2013-09-29','14:35:00',1.8),('5815','2013-09-29','14:40:00',2.31),('5815','2013-09-29','14:45:00',1.65),('5815','2013-09-29','14:50:00',2.12),('5815','2013-09-29','14:55:00',1.31),('5815','2013-09-29','15:00:00',1.66),('5815','2013-09-29','15:05:00',1.37),('5815','2013-09-29','15:10:00',1.73),('5815','2013-09-29','15:15:00',1.16),('5815','2013-09-29','15:25:00',2.06),('5815','2013-09-29','15:30:00',1.4),('5815','2013-09-29','15:35:00',1.27),('5815','2013-09-29','15:40:00',2.04),('5815','2013-09-29','15:45:00',1.14),('5815','2013-09-29','16:15:00',1.1),('5815','2013-09-29','16:45:00',1),('5815','2013-09-28','10:10:00',1.13),('5815','2013-09-28','10:15:00',1.45),('5815','2013-09-28','10:20:00',1.25),('5815','2013-09-28','10:25:00',1.17),('5815','2013-09-28','10:30:00',1.39),('5815','2013-09-28','10:35:00',1.52),('5815','2013-09-28','10:40:00',1.67),('5815','2013-09-28','10:45:00',1.6),('5815','2013-09-28','10:50:00',1.68),('5815','2013-09-28','10:55:00',1.67),('5815','2013-09-28','11:00:00',1.71),('5815','2013-09-28','11:05:00',1.65),('5815','2013-09-28','11:10:00',1.64),('5815','2013-09-28','11:15:00',1.77),('5815','2013-09-28','11:20:00',1.79),('5815','2013-09-28','11:25:00',1.69),('5815','2013-09-28','11:30:00',1.82),('5815','2013-09-28','11:35:00',1.78),('5815','2013-09-28','11:40:00',1.88),('5815','2013-09-28','11:45:00',1.87),('5815','2013-09-28','11:50:00',2.02),('5815','2013-09-28','11:55:00',2),('5815','2013-09-28','12:00:00',1.87),('5815','2013-09-28','12:05:00',2.02),('5815','2013-09-28','12:10:00',1.96),('5815','2013-09-28','12:15:00',2.15),('5815','2013-09-28','12:20:00',1.77),('5815','2013-09-28','12:25:00',1.19),('5815','2013-09-28','12:30:00',1.2),('5815','2013-09-28','12:35:00',1.15),('5815','2013-09-28','13:30:00',1.33),('5815','2013-09-28','13:55:00',1.31),('5815','2013-09-28','14:00:00',1.19),('5815','2013-09-28','14:05:00',1.42),('5815','2013-09-28','14:15:00',1.02),('5815','2013-09-28','14:20:00',1.38),('5815','2013-09-27','09:15:00',1.03),('5815','2013-09-27','09:20:00',1.08),('5815','2013-09-27','09:25:00',1.14),('5815','2013-09-27','09:30:00',1.19),('5815','2013-09-27','09:35:00',1.24),('5815','2013-09-27','09:40:00',1.29),('5815','2013-09-27','09:45:00',1.34),('5815','2013-09-27','09:50:00',1.4),('5815','2013-09-27','09:55:00',1.48),('5815','2013-09-27','10:35:00',1.51),('5815','2013-09-27','10:40:00',1.32),('5815','2013-09-27','10:45:00',1.52),('5815','2013-09-27','10:50:00',1.84),('5815','2013-09-27','10:55:00',2.05),('5815','2013-09-27','11:20:00',1.43),('5815','2013-09-27','11:25:00',2.17),('5815','2013-09-27','11:30:00',2.25),('5815','2013-09-27','11:35:00',1.87),('5815','2013-09-27','11:40:00',1.27),('5815','2013-09-27','12:05:00',2.19),('5815','2013-09-27','12:10:00',2.33),('5815','2013-09-27','12:15:00',1.82),('5815','2013-09-27','12:20:00',1.12),('5815','2013-09-27','12:25:00',2.24),('5815','2013-09-27','12:35:00',1.34),('5815','2013-09-27','12:40:00',2.02),('5815','2013-09-27','12:50:00',1.81),('5815','2013-09-27','12:55:00',2.33),('5815','2013-09-27','13:00:00',1.03),('5815','2013-09-27','13:05:00',2.22),('5815','2013-09-27','13:30:00',1.87),('5815','2013-09-27','13:35:00',1.02),('5815','2013-09-27','13:50:00',1.31),('5815','2013-09-27','14:20:00',1.23),('5815','2013-09-27','14:25:00',2.43),('5815','2013-09-27','14:30:00',1.73),('5815','2013-09-27','14:35:00',1.48),('5815','2013-09-27','14:40:00',2.28),('5815','2013-09-27','14:45:00',2.15),('5815','2013-09-27','14:50:00',1.93),('5815','2013-09-27','15:00:00',1.79),('5815','2013-09-27','15:05:00',2.03),('5815','2013-09-27','15:10:00',1.38),('5815','2013-09-27','15:15:00',2.04),('5815','2013-09-27','15:20:00',1.89),('5815','2013-09-27','15:25:00',2),('5815','2013-09-27','15:30:00',1.97),('5815','2013-09-27','15:35:00',1.82),('5815','2013-09-27','15:40:00',1.81),('5815','2013-09-27','15:45:00',1.66),('5815','2013-09-27','15:55:00',1.17),('5815','2013-09-27','16:00:00',1.64),('5815','2013-09-27','16:05:00',1.53),('5815','2013-09-27','16:10:00',1.62),('5815','2013-09-27','16:15:00',1.52),('5815','2013-09-27','16:20:00',1.21),('5815','2013-09-27','16:25:00',1.33),('5815','2013-09-27','16:30:00',1.2),('5815','2013-09-27','16:35:00',1.19),('5815','2013-09-27','16:40:00',1.15),('5815','2013-09-27','16:45:00',1.09),('5815','2013-09-27','16:50:00',1.05),('5815','2013-09-27','16:55:00',1),('5815','2013-09-26','10:05:00',1.22),('5815','2013-09-26','10:10:00',1.21),('5815','2013-09-26','10:20:00',1.25),('5815','2013-09-26','10:25:00',1),('5815','2013-09-26','10:30:00',1.26),('5815','2013-09-26','10:50:00',1.71),('5815','2013-09-26','10:55:00',1.78),('5815','2013-09-26','11:00:00',1.86),('5815','2013-09-26','11:05:00',1.87),('5815','2013-09-26','11:10:00',1.72),('5815','2013-09-26','11:15:00',1.91),('5815','2013-09-26','11:20:00',1.9),('5815','2013-09-26','11:25:00',1.73),('5815','2013-09-26','11:30:00',1.74),('5815','2013-09-26','11:45:00',1.36),('5815','2013-09-26','12:00:00',1.83),('5815','2013-09-26','12:05:00',1.11),('5815','2013-09-26','12:10:00',1.73),('5815','2013-09-26','12:15:00',1.69),('5815','2013-09-26','12:45:00',1.01),('5815','2013-09-26','12:50:00',2.14),('5815','2013-09-26','12:55:00',2.17),('5815','2013-09-26','13:00:00',2.18),('5815','2013-09-26','13:05:00',2.19),('5815','2013-09-26','13:10:00',2.16),('5815','2013-09-26','13:20:00',2.04),('5815','2013-09-26','13:25:00',1.8),('5815','2013-09-26','13:45:00',1.6),('5815','2013-09-26','14:05:00',1.95),('5815','2013-09-26','14:10:00',1.73),('5815','2013-09-26','14:15:00',1.97),('5815','2013-09-26','14:20:00',2.26),('5815','2013-09-26','14:25:00',2.18),('5815','2013-09-26','14:30:00',2.16),('5815','2013-09-26','14:35:00',2.09),('5815','2013-09-26','14:40:00',2.11),('5815','2013-09-26','14:45:00',2.03),('5815','2013-09-26','14:50:00',1.91),('5815','2013-09-26','14:55:00',1.86),('5815','2013-09-26','15:00:00',1.49),('5815','2013-09-26','15:05:00',1.53),('5815','2013-09-26','15:10:00',1.35),('5815','2013-09-26','15:15:00',1.89),('5815','2013-09-26','15:20:00',1.18),('5815','2013-09-26','15:25:00',1.76),('5815','2013-09-26','15:30:00',1.86),('5815','2013-09-26','15:35:00',1.48),('5815','2013-09-26','15:40:00',1.74),('5815','2013-09-26','15:50:00',1.68),('5815','2013-09-26','15:55:00',1.64),('5815','2013-09-26','16:00:00',1.3),('5815','2013-09-26','16:05:00',1.3),('5815','2013-09-26','16:20:00',1.43),('5815','2013-09-26','16:25:00',1.35),('5815','2013-09-26','16:30:00',1.05),('5815','2013-09-26','16:35:00',1.24),('5815','2013-09-26','16:40:00',1.18),('5815','2013-09-26','16:45:00',1.12),('5815','2013-09-26','16:50:00',1.1),('5815','2013-09-25','09:10:00',1.05),('5815','2013-09-25','09:15:00',1.1),('5815','2013-09-25','09:20:00',1.16),('5815','2013-09-25','09:25:00',1.2),('5815','2013-09-25','09:30:00',1.25),('5815','2013-09-25','09:35:00',1.29),('5815','2013-09-25','09:40:00',1.32),('5815','2013-09-25','09:45:00',1.37),('5815','2013-09-25','09:50:00',1.4),('5815','2013-09-25','09:55:00',1.44),('5815','2013-09-25','10:00:00',1.49),('5815','2013-09-25','10:05:00',1.52),('5815','2013-09-25','10:10:00',1.54),('5815','2013-09-25','10:15:00',1.6),('5815','2013-09-25','10:20:00',1.62),('5815','2013-09-25','10:25:00',1.65),('5815','2013-09-25','10:30:00',1.65),('5815','2013-09-25','10:35:00',1.7),('5815','2013-09-25','10:40:00',1.72),('5815','2013-09-25','10:45:00',1.56),('5815','2013-09-25','10:50:00',1.81),('5815','2013-09-25','10:55:00',1.84),('5815','2013-09-25','11:00:00',1.86),('5815','2013-09-25','11:05:00',1.84),('5815','2013-09-25','11:10:00',1.9),('5815','2013-09-25','11:15:00',1.91),('5815','2013-09-25','11:20:00',1.95),('5815','2013-09-25','11:25:00',1.99),('5815','2013-09-25','11:30:00',2),('5815','2013-09-25','11:35:00',2.05),('5815','2013-09-25','11:40:00',1.85),('5815','2013-09-25','11:45:00',1.61),('5815','2013-09-25','11:50:00',2.05),('5815','2013-09-25','11:55:00',1.91),('5815','2013-09-25','12:00:00',1.49),('5815','2013-09-25','12:05:00',1.73),('5815','2013-09-25','12:20:00',1.04),('5815','2013-09-25','12:40:00',1.04),('5815','2013-09-25','12:45:00',1.14),('5815','2013-09-25','12:55:00',1.2),('5815','2013-09-25','13:00:00',1.91),('5815','2013-09-25','13:05:00',1.25),('5815','2013-09-25','13:15:00',1.86),('5815','2013-09-25','13:20:00',2.38),('5815','2013-09-25','13:25:00',1.88),('5815','2013-09-25','13:30:00',1.34),('5815','2013-09-25','13:35:00',1.21),('5815','2013-09-25','13:55:00',1.12),('5815','2013-09-25','14:00:00',1.23),('5815','2013-09-25','14:05:00',1.65),('5815','2013-09-25','14:10:00',2.35),('5815','2013-09-25','14:15:00',2.28),('5815','2013-09-25','14:20:00',2.09),('5815','2013-09-25','14:25:00',1.38),('5815','2013-09-25','14:30:00',1.15),('5815','2013-09-25','14:35:00',1.28),('5815','2013-09-25','14:40:00',1.45),('5815','2013-09-25','14:45:00',1.57),('5815','2013-09-25','14:50:00',2.36),('5815','2013-09-25','14:55:00',1.58),('5815','2013-09-25','15:25:00',1.69),('5815','2013-09-25','15:35:00',1.17),('5815','2013-09-25','15:45:00',1.64),('5815','2013-09-25','15:50:00',1.81),('5815','2013-09-25','15:55:00',1.66),('5815','2013-09-25','16:00:00',1.58),('5815','2013-09-25','16:05:00',1.52),('5815','2013-09-25','16:10:00',1.51),('5815','2013-09-25','16:15:00',1.42),('5815','2013-09-25','16:20:00',1.39),('5815','2013-09-25','16:25:00',1.38),('5815','2013-09-25','16:30:00',1.32),('5815','2013-09-25','16:35:00',1.26),('5815','2013-09-25','16:40:00',1.21),('5815','2013-09-25','16:45:00',1.15),('5815','2013-09-25','16:50:00',1.09),('5815','2013-09-25','16:55:00',1.05),('5815','2013-09-24','09:10:00',1.04),('5815','2013-09-24','09:15:00',1.03),('5815','2013-09-24','09:30:00',1.08),('5815','2013-09-24','09:35:00',1.01),('5815','2013-09-24','09:40:00',1.34),('5815','2013-09-24','09:45:00',1.31),('5815','2013-09-24','09:50:00',1.11),('5815','2013-09-24','10:00:00',1.63),('5815','2013-09-24','10:05:00',1.2),('5815','2013-09-24','10:45:00',1.64),('5815','2013-09-24','10:50:00',2.11),('5815','2013-09-24','10:55:00',2.24),('5815','2013-09-24','11:00:00',1.63),('5815','2013-09-24','11:25:00',1.09),('5815','2013-09-24','11:30:00',2.16),('5815','2013-09-24','11:35:00',2.18),('5815','2013-09-24','11:40:00',2.07),('5815','2013-09-24','11:45:00',2.16),('5815','2013-09-24','11:50:00',1.56),('5815','2013-09-24','11:55:00',1.19),('5815','2013-09-24','12:00:00',1.49),('5815','2013-09-24','12:15:00',2.11),('5815','2013-09-24','12:20:00',2.26),('5815','2013-09-24','12:25:00',2.27),('5815','2013-09-24','12:30:00',1.62),('5815','2013-09-24','12:35:00',2.32),('5815','2013-09-24','12:40:00',2.35),('5815','2013-09-24','13:35:00',1.95),('5815','2013-09-24','13:40:00',1.56),('5815','2013-09-24','13:45:00',2.5),('5815','2013-09-24','13:50:00',2.42),('5815','2013-09-24','13:55:00',2.5),('5815','2013-09-24','14:35:00',1.01),('5815','2013-09-24','14:40:00',1.7),('5815','2013-09-24','14:45:00',1.78),('5815','2013-09-24','14:50:00',1.28),('5815','2013-09-24','14:55:00',2.07),('5815','2013-09-24','15:00:00',1.59),('5815','2013-09-24','15:05:00',2.2),('5815','2013-09-24','15:10:00',2.12),('5815','2013-09-24','15:15:00',2.06),('5815','2013-09-24','15:20:00',2.01),('5815','2013-09-24','15:25:00',1.86),('5815','2013-09-24','15:30:00',1.84),('5815','2013-09-24','15:35:00',1.69),('5815','2013-09-24','15:40:00',1.99),('5815','2013-09-24','15:45:00',1.78),('5815','2013-09-24','15:50:00',1.78),('5815','2013-09-24','15:55:00',1.74),('5815','2013-09-24','16:00:00',1.7),('5815','2013-09-24','16:05:00',1.64),('5815','2013-09-24','16:10:00',1.59),('5815','2013-09-24','16:15:00',1.53),('5815','2013-09-24','16:20:00',1.49),('5815','2013-09-24','16:30:00',1.16),('5815','2013-09-24','16:35:00',1.37),('5815','2013-09-24','16:40:00',1.3),('5815','2013-09-24','16:45:00',1.22),('5815','2013-09-24','16:50:00',1.19),('5815','2013-09-24','16:55:00',1.13),('5815','2013-09-24','17:00:00',1.07),('5815','2013-09-23','09:05:00',1.04),('5815','2013-09-23','09:10:00',1.1),('5815','2013-09-23','09:15:00',1.15),('5815','2013-09-23','09:20:00',1.2),('5815','2013-09-23','09:25:00',1.25),('5815','2013-09-23','09:30:00',1.3),('5815','2013-09-23','09:35:00',1.35),('5815','2013-09-23','09:40:00',1.39),('5815','2013-09-23','09:45:00',1.43),('5815','2013-09-23','09:50:00',1.47),('5815','2013-09-23','09:55:00',1.51),('5815','2013-09-23','10:00:00',1.54),('5815','2013-09-23','10:05:00',1.59),('5815','2013-09-23','10:10:00',1.64),('5815','2013-09-23','10:15:00',1.68),('5815','2013-09-23','10:20:00',1.72),('5815','2013-09-23','10:25:00',1.75),('5815','2013-09-23','10:30:00',1.79),('5815','2013-09-23','10:35:00',1.81),('5815','2013-09-23','10:40:00',1.83),('5815','2013-09-23','10:45:00',1.87),('5815','2013-09-23','10:50:00',1.9),('5815','2013-09-23','10:55:00',1.92),('5815','2013-09-23','11:00:00',1.95),('5815','2013-09-23','11:05:00',1.98),('5815','2013-09-23','11:10:00',1.99),('5815','2013-09-23','11:15:00',2),('5815','2013-09-23','11:20:00',2.01),('5815','2013-09-23','11:25:00',2.03),('5815','2013-09-23','11:30:00',2.05),('5815','2013-09-23','11:35:00',2.08),('5815','2013-09-23','11:40:00',2.1),('5815','2013-09-23','11:45:00',2.1),('5815','2013-09-23','11:50:00',2.12),('5815','2013-09-23','11:55:00',2.14),('5815','2013-09-23','12:00:00',2.15),('5815','2013-09-23','12:05:00',2.16),('5815','2013-09-23','12:10:00',2.17),('5815','2013-09-23','12:15:00',2.18),('5815','2013-09-23','12:20:00',2.21),('5815','2013-09-23','12:25:00',2.2),('5815','2013-09-23','12:30:00',2.19),('5815','2013-09-23','12:35:00',2.2),('5815','2013-09-23','12:40:00',2.22),('5815','2013-09-23','12:45:00',2.25),('5815','2013-09-23','12:50:00',2.25),('5815','2013-09-23','12:55:00',2.23),('5815','2013-09-23','13:00:00',2.22),('5815','2013-09-23','13:05:00',2.25),('5815','2013-09-23','13:10:00',2.22),('5815','2013-09-23','13:15:00',2.24),('5815','2013-09-23','13:20:00',2.25),('5815','2013-09-23','13:25:00',2.25),('5815','2013-09-23','13:30:00',2.25),('5815','2013-09-23','13:35:00',2.23),('5815','2013-09-23','13:40:00',2.23),('5815','2013-09-23','13:45:00',2.24),('5815','2013-09-23','13:50:00',2.24),('5815','2013-09-23','13:55:00',2.21),('5815','2013-09-23','14:00:00',2.19),('5815','2013-09-23','14:05:00',2.19),('5815','2013-09-23','14:10:00',2.18),('5815','2013-09-23','14:15:00',2.17),('5815','2013-09-23','14:20:00',2.15),('5815','2013-09-23','14:25:00',2.12),('5815','2013-09-23','14:30:00',2.13),('5815','2013-09-23','14:35:00',2.1),('5815','2013-09-23','14:40:00',2.08),('5815','2013-09-23','14:45:00',2.05),('5815','2013-09-23','14:50:00',2.02),('5815','2013-09-23','14:55:00',2),('5815','2013-09-23','15:00:00',1.96),('5815','2013-09-23','15:05:00',1.95),('5815','2013-09-23','15:10:00',1.95),('5815','2013-09-23','15:15:00',1.91),('5815','2013-09-23','15:20:00',1.9),('5815','2013-09-23','15:25:00',1.9),('5815','2013-09-23','15:30:00',1.87),('5815','2013-09-23','15:35:00',1.82),('5815','2013-09-23','15:40:00',1.78),('5815','2013-09-23','15:45:00',1.75),('5815','2013-09-23','15:50:00',1.72),('5815','2013-09-23','15:55:00',1.66),('5815','2013-09-23','16:00:00',1.64),('5815','2013-09-23','16:05:00',1.6),('5815','2013-09-23','16:10:00',1.56),('5815','2013-09-23','16:15:00',1.53),('5815','2013-09-23','16:20:00',1.48),('5815','2013-09-23','16:25:00',1.43),('5815','2013-09-23','16:30:00',1.39),('5815','2013-09-23','16:35:00',1.34),('5815','2013-09-23','16:40:00',1.28),('5815','2013-09-23','16:45:00',1.24),('5815','2013-09-23','16:50:00',1.18),('5815','2013-09-23','16:55:00',1.15),('5815','2013-09-23','17:00:00',1.1),('5815','2013-09-22','09:00:00',1.02),('5815','2013-09-22','09:05:00',1.08),('5815','2013-09-22','09:10:00',1.13),('5815','2013-09-22','09:15:00',1.18),('5815','2013-09-22','09:20:00',1.24),('5815','2013-09-22','09:25:00',1.29),('5815','2013-09-22','09:30:00',1.34),('5815','2013-09-22','09:35:00',1.38),('5815','2013-09-22','09:40:00',1.4),('5815','2013-09-22','09:45:00',1.47),('5815','2013-09-22','09:50:00',1.51),('5815','2013-09-22','09:55:00',1.55),('5815','2013-09-22','10:00:00',1.59),('5815','2013-09-22','10:05:00',1.63),('5815','2013-09-22','10:10:00',1.67),('5815','2013-09-22','10:15:00',1.69),('5815','2013-09-22','10:20:00',1.73),('5815','2013-09-22','10:25:00',1.76),('5815','2013-09-22','10:30:00',1.79),('5815','2013-09-22','10:35:00',1.82),('5815','2013-09-22','10:40:00',1.85),('5815','2013-09-22','10:45:00',1.88),('5815','2013-09-22','10:50:00',1.92),('5815','2013-09-22','10:55:00',1.92),('5815','2013-09-22','11:00:00',1.96),('5815','2013-09-22','11:05:00',2),('5815','2013-09-22','11:10:00',2.02),('5815','2013-09-22','11:15:00',2.06),('5815','2013-09-22','11:20:00',2.09),('5815','2013-09-22','11:25:00',2.11),('5815','2013-09-22','11:30:00',2.13),('5815','2013-09-22','11:35:00',2.14),('5815','2013-09-22','11:40:00',2.15),('5815','2013-09-22','11:45:00',2.17),('5815','2013-09-22','11:50:00',2.18),('5815','2013-09-22','11:55:00',2.2),('5815','2013-09-22','12:00:00',2.22),('5815','2013-09-22','12:05:00',2.25),('5815','2013-09-22','12:10:00',2.28),('5815','2013-09-22','12:15:00',2.29),('5815','2013-09-22','12:20:00',2.27),('5815','2013-09-22','12:25:00',2.25),('5815','2013-09-22','12:30:00',2.25),('5815','2013-09-22','12:35:00',2.25),('5815','2013-09-22','12:40:00',2.26),('5815','2013-09-22','12:45:00',2.27),('5815','2013-09-22','12:50:00',2.27),('5815','2013-09-22','12:55:00',2.28),('5815','2013-09-22','13:00:00',2.27),('5815','2013-09-22','13:05:00',2.28),('5815','2013-09-22','13:10:00',2.28),('5815','2013-09-22','13:15:00',2.27),('5815','2013-09-22','13:20:00',2.25),('5815','2013-09-22','13:25:00',2.26),('5815','2013-09-22','13:30:00',2.26),('5815','2013-09-22','13:35:00',2.25),('5815','2013-09-22','13:40:00',2.22),('5815','2013-09-22','13:45:00',2.22),('5815','2013-09-22','13:50:00',2.21),('5815','2013-09-22','13:55:00',2.19),('5815','2013-09-22','14:00:00',2.16),('5815','2013-09-22','14:05:00',2.13),('5815','2013-09-22','14:10:00',2.13),('5815','2013-09-22','14:15:00',2.13),('5815','2013-09-22','14:20:00',2.11),('5815','2013-09-22','14:25:00',2.11),('5815','2013-09-22','14:30:00',2.15),('5815','2013-09-22','14:35:00',2.11),('5815','2013-09-22','14:40:00',2.07),('5815','2013-09-22','14:45:00',2.03),('5815','2013-09-22','14:50:00',2),('5815','2013-09-22','14:55:00',2.01),('5815','2013-09-22','15:00:00',1.97),('5815','2013-09-22','15:05:00',1.52),('5815','2013-09-22','15:10:00',1.31),('5815','2013-09-22','15:15:00',1.95),('5815','2013-09-22','15:20:00',1.89),('5815','2013-09-22','15:25:00',1.85),('5815','2013-09-22','15:30:00',1.81),('5815','2013-09-22','15:35:00',1.8),('5815','2013-09-22','15:40:00',1.76),('5815','2013-09-22','15:45:00',1.72),('5815','2013-09-22','15:50:00',1.67),('5815','2013-09-22','15:55:00',1.39),('5815','2013-09-22','16:00:00',1.57),('5815','2013-09-22','16:05:00',1.56),('5815','2013-09-22','16:10:00',1.3),('5815','2013-09-22','16:15:00',1.32),('5815','2013-09-22','16:20:00',1.28),('5815','2013-09-22','16:25:00',1.14),('5815','2013-09-22','16:30:00',1.3),('5815','2013-09-22','16:35:00',1.27),('5815','2013-09-22','16:40:00',1.24),('5815','2013-09-22','16:45:00',1.2),('5815','2013-09-22','16:50:00',1.15),('5815','2013-09-22','16:55:00',1.1),('5815','2013-09-22','17:00:00',1.05),('5815','2013-09-21','09:05:00',1.05),('5815','2013-09-21','09:10:00',1.11),('5815','2013-09-21','09:15:00',1.17),('5815','2013-09-21','09:20:00',1.22),('5815','2013-09-21','09:25:00',1.27),('5815','2013-09-21','09:30:00',1.32),('5815','2013-09-21','09:35:00',1.37),('5815','2013-09-21','09:40:00',1.4),('5815','2013-09-21','09:45:00',1.45),('5815','2013-09-21','09:50:00',1.49),('5815','2013-09-21','09:55:00',1.54),('5815','2013-09-21','10:00:00',1.59),('5815','2013-09-21','10:05:00',1.64),('5815','2013-09-21','10:10:00',1.68),('5815','2013-09-21','10:15:00',1.72),('5815','2013-09-21','10:20:00',1.76),('5815','2013-09-21','10:25:00',1.79),('5815','2013-09-21','10:30:00',1.8),('5815','2013-09-21','10:35:00',1.87),('5815','2013-09-21','10:40:00',1.9),('5815','2013-09-21','10:45:00',1.92),('5815','2013-09-21','10:50:00',1.94),('5815','2013-09-21','10:55:00',1.96),('5815','2013-09-21','11:00:00',1.99),('5815','2013-09-21','11:05:00',2),('5815','2013-09-21','11:10:00',2.02),('5815','2013-09-21','11:15:00',2.05),('5815','2013-09-21','11:20:00',2.09),('5815','2013-09-21','11:25:00',2.11),('5815','2013-09-21','11:30:00',2.14),('5815','2013-09-21','11:35:00',2.18),('5815','2013-09-21','11:40:00',2.21),('5815','2013-09-21','11:45:00',2.23),('5815','2013-09-21','11:50:00',2.24),('5815','2013-09-21','11:55:00',2.26),('5815','2013-09-21','12:00:00',2.26),('5815','2013-09-21','12:05:00',2.29),('5815','2013-09-21','12:10:00',2.3),('5815','2013-09-21','12:15:00',2.3),('5815','2013-09-21','12:20:00',2.32),('5815','2013-09-21','12:25:00',2.32),('5815','2013-09-21','12:30:00',2.32),('5815','2013-09-21','12:35:00',2.33),('5815','2013-09-21','12:40:00',2.34),('5815','2013-09-21','12:45:00',2.32),('5815','2013-09-21','12:50:00',2.35),('5815','2013-09-21','12:55:00',2.38),('5815','2013-09-21','13:00:00',2.35),('5815','2013-09-21','13:05:00',2.35),('5815','2013-09-21','13:10:00',2.39),('5815','2013-09-21','13:15:00',2.34),('5815','2013-09-21','13:20:00',2.33),('5815','2013-09-21','13:25:00',2.33),('5815','2013-09-21','13:30:00',2.31),('5815','2013-09-21','13:35:00',2.3),('5815','2013-09-21','13:40:00',2.29),('5815','2013-09-21','13:45:00',2.29),('5815','2013-09-21','13:50:00',2.3),('5815','2013-09-21','13:55:00',2.15),('5815','2013-09-21','14:00:00',2.27),('5815','2013-09-21','14:05:00',2.29),('5815','2013-09-21','14:10:00',2.23),('5815','2013-09-21','14:15:00',2.27),('5815','2013-09-21','14:20:00',1.51),('5815','2013-09-21','14:25:00',2.08),('5815','2013-09-21','14:30:00',2.31),('5815','2013-09-21','14:35:00',2.21),('5815','2013-09-21','14:40:00',1.67),('5815','2013-09-21','14:45:00',1.92),('5815','2013-09-21','14:50:00',2.14),('5815','2013-09-21','14:55:00',2.12),('5815','2013-09-21','15:00:00',2.13),('5815','2013-09-21','15:05:00',2.18),('5815','2013-09-21','15:10:00',2.1),('5815','2013-09-21','15:15:00',2.2),('5815','2013-09-21','15:20:00',2.2),('5815','2013-09-21','15:40:00',1.46),('5815','2013-09-21','15:45:00',1.92),('5815','2013-09-21','15:50:00',1.82),('5815','2013-09-21','15:55:00',1.79),('5815','2013-09-21','16:00:00',1.91),('5815','2013-09-21','16:05:00',1.9),('5815','2013-09-21','16:10:00',2),('5815','2013-09-21','16:15:00',1.56),('5815','2013-09-21','16:45:00',1.09),('5815','2013-09-21','17:05:00',1.07),('5815','2013-09-20','09:05:00',1.04),('5815','2013-09-20','09:10:00',1.09),('5815','2013-09-20','09:15:00',1.15),('5815','2013-09-20','09:20:00',1.2),('5815','2013-09-20','09:25:00',1.24),('5815','2013-09-20','09:30:00',1.29),('5815','2013-09-20','09:35:00',1.34),('5815','2013-09-20','09:40:00',1.37),('5815','2013-09-20','09:45:00',1.42),('5815','2013-09-20','09:50:00',1.46),('5815','2013-09-20','09:55:00',1.51),('5815','2013-09-20','10:00:00',1.55),('5815','2013-09-20','10:05:00',1.6),('5815','2013-09-20','10:10:00',1.63),('5815','2013-09-20','10:15:00',1.67),('5815','2013-09-20','10:20:00',1.7),('5815','2013-09-20','10:25:00',1.72),('5815','2013-09-20','10:30:00',1.77),('5815','2013-09-20','10:35:00',1.8),('5815','2013-09-20','10:40:00',1.84),('5815','2013-09-20','10:45:00',1.86),('5815','2013-09-20','10:50:00',1.89),('5815','2013-09-20','10:55:00',1.92),('5815','2013-09-20','11:00:00',1.95),('5815','2013-09-20','11:05:00',1.96),('5815','2013-09-20','11:10:00',1.99),('5815','2013-09-20','11:15:00',2.01),('5815','2013-09-20','11:20:00',2.03),('5815','2013-09-20','11:25:00',2.06),('5815','2013-09-20','11:30:00',2.07),('5815','2013-09-20','11:35:00',2.09),('5815','2013-09-20','11:40:00',2.12),('5815','2013-09-20','11:45:00',2.14),('5815','2013-09-20','11:50:00',2.17),('5815','2013-09-20','11:55:00',2.12),('5815','2013-09-20','12:00:00',2.18),('5815','2013-09-20','12:05:00',2.2),('5815','2013-09-20','12:10:00',2.22),('5815','2013-09-20','12:15:00',2.24),('5815','2013-09-20','12:20:00',2.25),('5815','2013-09-20','12:25:00',2.05),('5815','2013-09-20','12:30:00',2.31),('5815','2013-09-20','12:35:00',2.29),('5815','2013-09-20','12:40:00',2.08),('5815','2013-09-20','12:45:00',2.08),('5815','2013-09-20','12:50:00',2.26),('5815','2013-09-20','12:55:00',2.28),('5815','2013-09-20','13:00:00',2.27),('5815','2013-09-20','13:05:00',2.19),('5815','2013-09-20','13:10:00',2.28),('5815','2013-09-20','13:15:00',2.28),('5815','2013-09-20','13:20:00',1.82),('5815','2013-09-20','13:25:00',2.08),('5815','2013-09-20','13:30:00',2.17),('5815','2013-09-20','13:35:00',2.21),('5815','2013-09-20','13:40:00',1.96),('5815','2013-09-20','13:45:00',1.94),('5815','2013-09-20','13:50:00',2.02),('5815','2013-09-20','13:55:00',2.08),('5815','2013-09-20','14:00:00',2.02),('5815','2013-09-20','14:05:00',2.15),('5815','2013-09-20','14:10:00',2.09),('5815','2013-09-20','14:15:00',2.17),('5815','2013-09-20','14:20:00',2.18),('5815','2013-09-20','14:25:00',2.12),('5815','2013-09-20','14:30:00',2.11),('5815','2013-09-20','14:35:00',2.09),('5815','2013-09-20','14:40:00',2.06),('5815','2013-09-20','14:45:00',2.04),('5815','2013-09-20','14:50:00',2.03),('5815','2013-09-20','14:55:00',2.01),('5815','2013-09-20','15:00:00',1.98),('5815','2013-09-20','15:05:00',1.96),('5815','2013-09-20','15:10:00',1.87),('5815','2013-09-20','15:15:00',1.89),('5815','2013-09-20','15:20:00',1.88),('5815','2013-09-20','15:25:00',1.84),('5815','2013-09-20','15:30:00',1.8),('5815','2013-09-20','15:35:00',1.8),('5815','2013-09-20','15:40:00',1.66),('5815','2013-09-20','15:45:00',1.27),('5815','2013-09-20','15:50:00',1.46),('5815','2013-09-20','15:55:00',1.66),('5815','2013-09-20','16:00:00',1.33),('5815','2013-09-20','16:10:00',1.03),('5815','2013-09-20','16:20:00',1.11),('5815','2013-09-19','09:25:00',1.11),('5815','2013-09-19','10:05:00',1.02),('5815','2013-09-19','10:10:00',1.93),('5815','2013-09-19','10:15:00',1.12),('5815','2013-09-19','10:20:00',1.84),('5815','2013-09-19','10:25:00',1.07),('5815','2013-09-19','10:30:00',1.08),('5815','2013-09-19','10:35:00',1.47),('5815','2013-09-19','10:40:00',1.26),('5815','2013-09-19','10:45:00',1.34),('5815','2013-09-19','10:50:00',1.41),('5815','2013-09-19','10:55:00',1.49),('5815','2013-09-19','11:00:00',1.41),('5815','2013-09-19','11:05:00',1.11),('5815','2013-09-19','11:10:00',1.13),('5815','2013-09-19','11:15:00',1.43),('5815','2013-09-19','11:20:00',1.47),('5815','2013-09-19','11:25:00',1.31),('5815','2013-09-19','11:30:00',1.63),('5815','2013-09-19','11:35:00',1.55),('5815','2013-09-19','11:40:00',1.81),('5815','2013-09-19','11:45:00',2.34),('5815','2013-09-19','11:50:00',2.36),('5815','2013-09-19','11:55:00',2.3),('5815','2013-09-19','12:00:00',2.25),('5815','2013-09-19','12:05:00',2.26),('5815','2013-09-19','12:10:00',2.27),('5815','2013-09-19','12:15:00',2.31),('5815','2013-09-19','12:20:00',2.35),('5815','2013-09-19','12:25:00',2.37),('5815','2013-09-19','12:30:00',1.94),('5815','2013-09-19','12:35:00',2.12),('5815','2013-09-19','12:40:00',1.77),('5815','2013-09-19','12:45:00',2.3),('5815','2013-09-19','12:50:00',1.93),('5815','2013-09-19','12:55:00',2.38),('5815','2013-09-19','13:00:00',2.15),('5815','2013-09-19','13:05:00',2.02),('5815','2013-09-19','13:10:00',2.2),('5815','2013-09-19','13:15:00',2.15),('5815','2013-09-19','13:20:00',2.09),('5815','2013-09-19','13:25:00',2.44),('5815','2013-09-19','13:30:00',2.35),('5815','2013-09-19','13:35:00',1.45),('5815','2013-09-19','13:40:00',2.07),('5815','2013-09-19','13:45:00',2.33),('5815','2013-09-19','13:50:00',2.26),('5815','2013-09-19','13:55:00',2.08),('5815','2013-09-19','14:00:00',2.25),('5815','2013-09-19','14:05:00',2.28),('5815','2013-09-19','14:10:00',1.65),('5815','2013-09-19','14:15:00',2.21),('5815','2013-09-19','14:20:00',1.54),('5815','2013-09-19','14:25:00',1.04),('5815','2013-09-19','14:30:00',2.38),('5815','2013-09-19','14:35:00',2.3),('5815','2013-09-19','14:40:00',2.25),('5815','2013-09-19','14:45:00',2.24),('5815','2013-09-19','14:50:00',2.23),('5815','2013-09-19','14:55:00',2.19),('5815','2013-09-19','15:00:00',1.92),('5815','2013-09-19','15:05:00',1.15),('5815','2013-09-19','15:10:00',1.94),('5815','2013-09-19','15:15:00',1.58),('5815','2013-09-19','15:20:00',1.74),('5815','2013-09-19','15:25:00',1.3),('5815','2013-09-19','15:30:00',1.02),('5815','2013-09-19','15:45:00',1.95),('5815','2013-09-19','15:50:00',1.88),('5815','2013-09-19','15:55:00',1.92),('5815','2013-09-19','16:00:00',1.14),('5815','2013-09-19','16:10:00',1.65),('5815','2013-09-19','16:15:00',1.72),('5815','2013-09-19','16:55:00',1.32),('5815','2013-09-19','17:00:00',1.37),('5815','2013-09-19','17:05:00',1.42),('5815','2013-09-19','17:10:00',1.31),('5815','2013-09-18','09:15:00',1.09),('5815','2013-09-18','10:05:00',1.03),('5815','2013-09-18','10:10:00',1.52),('5815','2013-09-18','10:15:00',1.58),('5815','2013-09-18','10:35:00',1.47),('5815','2013-09-18','10:40:00',2),('5815','2013-09-18','10:45:00',1.38),('5815','2013-09-18','10:55:00',1.35),('5815','2013-09-18','11:00:00',2.15),('5815','2013-09-18','11:05:00',2.06),('5815','2013-09-18','11:15:00',1.21),('5815','2013-09-18','11:20:00',1.36),('5815','2013-09-18','11:30:00',2.51),('5815','2013-09-18','11:35:00',1.73),('5815','2013-09-18','11:40:00',2.11),('5815','2013-09-18','11:45:00',1.42),('5815','2013-09-18','11:50:00',2.29),('5815','2013-09-18','11:55:00',2.26),('5815','2013-09-18','12:00:00',1.65),('5815','2013-09-18','12:05:00',1.02),('5815','2013-09-18','12:10:00',1.95),('5815','2013-09-18','12:15:00',2.22),('5815','2013-09-18','12:20:00',1.91),('5815','2013-09-18','12:25:00',2.66),('5815','2013-09-18','12:30:00',2.58),('5815','2013-09-18','12:35:00',2.41),('5815','2013-09-18','12:40:00',2.42),('5815','2013-09-18','12:45:00',1.12),('5815','2013-09-18','12:50:00',2.49),('5815','2013-09-18','12:55:00',2.5),('5815','2013-09-18','13:00:00',2.52),('5815','2013-09-18','13:05:00',2.53),('5815','2013-09-18','13:10:00',2.64),('5815','2013-09-18','13:15:00',2.45),('5815','2013-09-18','13:20:00',2.4),('5815','2013-09-18','13:25:00',1.41),('5815','2013-09-18','13:30:00',2.48),('5815','2013-09-18','13:35:00',2.55),('5815','2013-09-18','13:40:00',2.46),('5815','2013-09-18','13:45:00',2.31),('5815','2013-09-18','14:05:00',1.66),('5815','2013-09-18','14:10:00',2.12),('5815','2013-09-18','14:15:00',2.37),('5815','2013-09-18','14:20:00',2.34),('5815','2013-09-18','14:25:00',2.17),('5815','2013-09-18','14:30:00',2.26),('5815','2013-09-18','14:35:00',2.22),('5815','2013-09-18','14:40:00',2.2),('5815','2013-09-18','14:45:00',2.18),('5815','2013-09-18','14:50:00',2.18),('5815','2013-09-18','14:55:00',1.62),('5815','2013-09-18','15:00:00',2.22),('5815','2013-09-18','15:05:00',2.17),('5815','2013-09-18','15:10:00',1.87),('5815','2013-09-18','15:15:00',1.79),('5815','2013-09-18','15:20:00',2.06),('5815','2013-09-18','15:25:00',1.91),('5815','2013-09-18','15:30:00',1.48),('5815','2013-09-18','15:35:00',1.09),('5815','2013-09-18','15:40:00',1.64),('5815','2013-09-18','15:45:00',1.83),('5815','2013-09-18','15:50:00',1.84),('5815','2013-09-18','15:55:00',1.67),('5815','2013-09-18','16:00:00',1.72),('5815','2013-09-18','16:05:00',1.68),('5815','2013-09-18','16:10:00',1.19),('5815','2013-09-18','16:15:00',1.08),('5815','2013-09-18','16:20:00',1.61),('5815','2013-09-18','16:25:00',1.52),('5815','2013-09-18','16:30:00',1.31),('5815','2013-09-18','17:00:00',1.15),('5815','2013-09-18','17:05:00',1.09),('5815','2013-09-18','17:10:00',1.03),('5815','2013-09-17','09:20:00',1.31),('5815','2013-09-17','09:25:00',1.04),('5815','2013-09-17','09:30:00',1.04),('5815','2013-09-17','09:35:00',1.11),('5815','2013-09-17','09:40:00',1.5),('5815','2013-09-17','09:45:00',1.15),('5815','2013-09-17','10:00:00',1.01),('5815','2013-09-17','10:05:00',1.93),('5815','2013-09-17','10:10:00',1.81),('5815','2013-09-17','10:15:00',1.7),('5815','2013-09-17','10:20:00',1.68),('5815','2013-09-17','10:25:00',1.73),('5815','2013-09-17','10:30:00',1.74),('5815','2013-09-17','10:35:00',1.79),('5815','2013-09-17','10:40:00',1.81),('5815','2013-09-17','10:45:00',1.69),('5815','2013-09-17','10:50:00',1.74),('5815','2013-09-17','10:55:00',1.4),('5815','2013-09-17','11:00:00',1.37),('5815','2013-09-17','11:05:00',1.86),('5815','2013-09-17','11:10:00',1.21),('5815','2013-09-17','11:15:00',1.78),('5815','2013-09-17','11:20:00',1.34),('5815','2013-09-17','11:25:00',1.78),('5815','2013-09-17','11:30:00',2.24),('5815','2013-09-17','11:35:00',2.16),('5815','2013-09-17','11:40:00',1.1),('5815','2013-09-17','11:45:00',1.13),('5815','2013-09-17','11:50:00',2.09),('5815','2013-09-17','11:55:00',2.36),('5815','2013-09-17','12:00:00',2.35),('5815','2013-09-17','12:05:00',1.66),('5815','2013-09-17','12:10:00',2.42),('5815','2013-09-17','12:15:00',2.47),('5815','2013-09-17','12:20:00',2.34),('5815','2013-09-17','12:25:00',2.3),('5815','2013-09-17','12:30:00',2.28),('5815','2013-09-17','12:35:00',1.21),('5815','2013-09-17','12:40:00',2.65),('5815','2013-09-17','12:45:00',2.42),('5815','2013-09-17','12:50:00',2.5),('5815','2013-09-17','12:55:00',2.49),('5815','2013-09-17','13:00:00',2.48),('5815','2013-09-17','13:05:00',1.4),('5815','2013-09-17','13:10:00',2.51),('5815','2013-09-17','13:15:00',1.29),('5815','2013-09-17','13:20:00',2.53),('5815','2013-09-17','13:25:00',2.34),('5815','2013-09-17','13:30:00',2.48),('5815','2013-09-17','13:35:00',2.44),('5815','2013-09-17','13:40:00',2.41),('5815','2013-09-17','13:45:00',2.41),('5815','2013-09-17','13:50:00',2.23),('5815','2013-09-17','13:55:00',1.79),('5815','2013-09-17','14:00:00',2.46),('5815','2013-09-17','14:05:00',2.31),('5815','2013-09-17','14:10:00',2.36),('5815','2013-09-17','14:15:00',2.35),('5815','2013-09-17','14:20:00',2.32),('5815','2013-09-17','14:25:00',2.3),('5815','2013-09-17','14:30:00',2.26),('5815','2013-09-17','14:35:00',2.24),('5815','2013-09-17','14:40:00',2.24),('5815','2013-09-17','14:45:00',2.21),('5815','2013-09-17','14:50:00',2.2),('5815','2013-09-17','14:55:00',2.2),('5815','2013-09-17','15:00:00',2.14),('5815','2013-09-17','15:05:00',2.15),('5815','2013-09-17','15:10:00',1.03),('5815','2013-09-17','15:15:00',1.46),('5815','2013-09-17','15:20:00',2.13),('5815','2013-09-17','15:25:00',2.09),('5815','2013-09-17','15:30:00',2.06),('5815','2013-09-17','15:35:00',2.04),('5815','2013-09-17','15:40:00',2.01),('5815','2013-09-17','15:45:00',1.82),('5815','2013-09-17','15:50:00',1.33),('5815','2013-09-17','15:55:00',1.3),('5815','2013-09-17','16:00:00',1.33),('5815','2013-09-17','16:05:00',1.49),('5815','2013-09-17','16:10:00',1.8),('5815','2013-09-17','16:15:00',1.7),('5815','2013-09-17','16:20:00',1.62),('5815','2013-09-17','16:25:00',1.41),('5815','2013-09-17','16:30:00',1.33),('5815','2013-09-17','16:35:00',1.31),('5815','2013-09-17','16:40:00',1.31),('5815','2013-09-17','16:45:00',1.26),('5815','2013-09-17','16:50:00',1.14),('5815','2013-09-17','16:55:00',1.12),('5815','2013-09-17','17:00:00',1.17),('5815','2013-09-17','17:05:00',1.02),('5815','2013-09-17','17:10:00',1),('5815','2013-09-16','09:45:00',1.37),('5815','2013-09-16','10:00:00',1.25),('5815','2013-09-16','10:05:00',1.05),('5815','2013-09-16','10:10:00',1.14),('5815','2013-09-16','10:25:00',1.23),('5815','2013-09-16','10:30:00',1.74),('5815','2013-09-16','10:40:00',1.09),('5815','2013-09-16','10:45:00',1.43),('5815','2013-09-16','10:50:00',2.27),('5815','2013-09-16','10:55:00',1.62),('5815','2013-09-16','11:00:00',1.2),('5815','2013-09-16','11:10:00',1.97),('5815','2013-09-16','11:15:00',1.68),('5815','2013-09-16','11:20:00',1.41),('5815','2013-09-16','11:25:00',1.08),('5815','2013-09-16','11:30:00',1.06),('5815','2013-09-16','11:35:00',1.96),('5815','2013-09-16','11:40:00',2.22),('5815','2013-09-16','11:45:00',2.22),('5815','2013-09-16','11:50:00',1.91),('5815','2013-09-16','11:55:00',1.8),('5815','2013-09-16','12:00:00',2.02),('5815','2013-09-16','12:05:00',1.92),('5815','2013-09-16','12:10:00',1.05),('5815','2013-09-16','12:15:00',1.37),('5815','2013-09-16','12:20:00',1.23),('5815','2013-09-16','12:25:00',2.36),('5815','2013-09-16','12:30:00',2.19),('5815','2013-09-16','12:35:00',1.3),('5815','2013-09-16','12:40:00',1.95),('5815','2013-09-16','12:45:00',1.96),('5815','2013-09-16','12:50:00',1.73),('5815','2013-09-16','12:55:00',1.38),('5815','2013-09-16','13:00:00',1.57),('5815','2013-09-16','13:10:00',1.37),('5815','2013-09-16','13:15:00',2.02),('5815','2013-09-16','13:20:00',1.37),('5815','2013-09-16','13:25:00',1.19),('5815','2013-09-16','13:30:00',1.05),('5815','2013-09-16','13:35:00',1.04),('5815','2013-09-16','13:40:00',1.53),('5815','2013-09-16','13:45:00',1.09),('5815','2013-09-16','14:25:00',1.11),('5815','2013-09-16','14:55:00',1.86),('5815','2013-09-16','15:00:00',2.18),('5815','2013-09-16','15:05:00',1.71),('5815','2013-09-16','15:10:00',1.66),('5815','2013-09-16','15:15:00',1.47),('5815','2013-09-16','15:20:00',1.73),('5815','2013-09-16','15:25:00',1.72),('5815','2013-09-16','15:30:00',1.33),('5815','2013-09-16','15:50:00',1.13),('5815','2013-09-16','15:55:00',1.41),('5815','2013-09-16','16:05:00',1.03),('5815','2013-09-16','16:10:00',1.04),('5815','2013-09-16','16:15:00',1.18),('5815','2013-09-15','09:10:00',1.23),('5815','2013-09-15','09:20:00',1.02),('5815','2013-09-15','09:25:00',1.17),('5815','2013-09-15','09:30:00',1.21),('5815','2013-09-15','09:35:00',1.32),('5815','2013-09-15','09:40:00',1.36),('5815','2013-09-15','09:45:00',1.43),('5815','2013-09-15','09:50:00',1.48),('5815','2013-09-15','09:55:00',1.55),('5815','2013-09-15','10:00:00',1.6),('5815','2013-09-15','10:05:00',1.65),('5815','2013-09-15','10:10:00',1.72),('5815','2013-09-15','10:20:00',1.23),('5815','2013-09-15','10:30:00',1.63),('5815','2013-09-15','10:35:00',2.07),('5815','2013-09-15','10:40:00',1.86),('5815','2013-09-15','10:45:00',2.3),('5815','2013-09-15','10:50:00',1.09),('5815','2013-09-15','11:05:00',1.54),('5815','2013-09-15','11:10:00',1.31),('5815','2013-09-15','11:15:00',1.08),('5815','2013-09-15','11:20:00',1.44),('5815','2013-09-15','11:25:00',1.08),('5815','2013-09-15','11:30:00',2.3),('5815','2013-09-15','11:35:00',2.3),('5815','2013-09-15','11:40:00',2.34),('5815','2013-09-15','11:45:00',1.29),('5815','2013-09-15','11:50:00',1.62),('5815','2013-09-15','11:55:00',2.41),('5815','2013-09-15','12:00:00',2.46),('5815','2013-09-15','12:05:00',2.23),('5815','2013-09-15','12:10:00',1.88),('5815','2013-09-15','12:15:00',1.89),('5815','2013-09-15','12:20:00',2.43),('5815','2013-09-15','12:25:00',2.39),('5815','2013-09-15','12:30:00',2.38),('5815','2013-09-15','12:35:00',2.4),('5815','2013-09-15','12:40:00',2.46),('5815','2013-09-15','12:45:00',2.6),('5815','2013-09-15','12:50:00',1.63),('5815','2013-09-15','12:55:00',1.84),('5815','2013-09-15','13:00:00',1.48),('5815','2013-09-15','13:05:00',2.29),('5815','2013-09-15','13:10:00',2.22),('5815','2013-09-15','13:15:00',2.38),('5815','2013-09-15','13:20:00',2.45),('5815','2013-09-15','13:25:00',2.4),('5815','2013-09-15','13:30:00',2.37),('5815','2013-09-15','13:35:00',2.4),('5815','2013-09-15','13:40:00',2.41),('5815','2013-09-15','13:45:00',2.37),('5815','2013-09-15','13:50:00',2.38),('5815','2013-09-15','13:55:00',2.45),('5815','2013-09-15','14:00:00',2.39),('5815','2013-09-15','14:05:00',2.01),('5815','2013-09-15','14:10:00',2.33),('5815','2013-09-15','14:15:00',2.3),('5815','2013-09-15','14:20:00',2.25),('5815','2013-09-15','14:25:00',2.25),('5815','2013-09-15','14:30:00',2.24),('5815','2013-09-15','14:35:00',2.23),('5815','2013-09-15','14:40:00',2.19),('5815','2013-09-15','14:45:00',2.17),('5815','2013-09-15','14:50:00',2.16),('5815','2013-09-15','14:55:00',2.15),('5815','2013-09-15','15:00:00',2.12),('5815','2013-09-15','15:05:00',2.09),('5815','2013-09-15','15:10:00',2.09),('5815','2013-09-15','15:15:00',2.07),('5815','2013-09-15','15:20:00',2.05),('5815','2013-09-15','15:25:00',2.01),('5815','2013-09-15','15:30:00',1.98),('5815','2013-09-15','15:35:00',1.95),('5815','2013-09-15','15:40:00',1.92),('5815','2013-09-15','15:45:00',1.89),('5815','2013-09-15','15:50:00',1.84),('5815','2013-09-15','15:55:00',1.8),('5815','2013-09-15','16:00:00',1.78),('5815','2013-09-15','16:10:00',1.64),('5815','2013-09-15','16:15:00',1.67),('5815','2013-09-15','16:20:00',1.62),('5815','2013-09-15','16:25:00',1.58),('5815','2013-09-15','16:30:00',1.54),('5815','2013-09-15','16:35:00',1.49),('5815','2013-09-15','16:40:00',1.44),('5815','2013-09-15','16:45:00',1.4),('5815','2013-09-15','16:50:00',1.34),('5815','2013-09-15','16:55:00',1.29),('5815','2013-09-15','17:00:00',1.24),('5815','2013-09-15','17:05:00',1.18),('5815','2013-09-15','17:10:00',1.11),('5815','2013-09-14','09:05:00',1.03),('5815','2013-09-14','09:10:00',1.12),('5815','2013-09-14','09:15:00',1.23),('5815','2013-09-14','09:20:00',1.2),('5815','2013-09-14','09:25:00',1.26),('5815','2013-09-14','09:30:00',1.3),('5815','2013-09-14','09:35:00',1.38),('5815','2013-09-14','09:40:00',1.42),('5815','2013-09-14','09:45:00',1.43),('5815','2013-09-14','09:50:00',1.5),('5815','2013-09-14','09:55:00',1.52),('5815','2013-09-14','10:00:00',1.6),('5815','2013-09-14','10:05:00',1.64),('5815','2013-09-14','10:10:00',1.65),('5815','2013-09-14','10:15:00',1.57),('5815','2013-09-14','10:20:00',1.67),('5815','2013-09-14','10:25:00',1.73),('5815','2013-09-14','10:30:00',1.63),('5815','2013-09-14','10:35:00',1.54),('5815','2013-09-14','10:55:00',1.36),('5815','2013-09-14','11:00:00',1.33),('5815','2013-09-14','11:05:00',2.21),('5815','2013-09-14','11:10:00',1.65),('5815','2013-09-14','11:35:00',1.62),('5815','2013-09-14','11:50:00',1.74),('5815','2013-09-14','11:55:00',1.16),('5815','2013-09-14','13:45:00',1.29),('5815','2013-09-14','13:50:00',1.49),('5815','2013-09-14','15:15:00',1.44),('5815','2013-09-14','15:20:00',1.22),('5815','2013-09-13','09:00:00',1.02),('5815','2013-09-13','09:05:00',1.07),('5815','2013-09-13','09:10:00',1.12),('5815','2013-09-13','09:15:00',1.17),('5815','2013-09-13','09:20:00',1.22),('5815','2013-09-13','09:25:00',1.27),('5815','2013-09-13','09:30:00',1.33),('5815','2013-09-13','09:35:00',1.36),('5815','2013-09-13','09:40:00',1.4),('5815','2013-09-13','09:45:00',1.45),('5815','2013-09-13','09:50:00',1.47),('5815','2013-09-13','09:55:00',1.54),('5815','2013-09-13','10:00:00',1.51),('5815','2013-09-13','10:05:00',1.17),('5815','2013-09-13','10:10:00',1.5),('5815','2013-09-13','10:15:00',1.5),('5815','2013-09-13','10:20:00',1.68),('5815','2013-09-13','10:25:00',1.76),('5815','2013-09-13','10:30:00',1.77),('5815','2013-09-13','10:35:00',1.84),('5815','2013-09-13','10:40:00',1.92),('5815','2013-09-13','10:45:00',2.03),('5815','2013-09-13','10:50:00',2.21),('5815','2013-09-13','10:55:00',2.09),('5815','2013-09-13','11:00:00',2.24),('5815','2013-09-13','11:05:00',1.18),('5815','2013-09-13','11:25:00',1.29),('5815','2013-09-13','11:30:00',2.29),('5815','2013-09-13','11:35:00',2.26),('5815','2013-09-13','11:40:00',2.33),('5815','2013-09-13','11:45:00',2.26),('5815','2013-09-13','11:50:00',2.14),('5815','2013-09-13','11:55:00',1.94),('5815','2013-09-13','12:00:00',1.07),('5815','2013-09-13','12:05:00',1.87),('5815','2013-09-13','12:10:00',1.1),('5815','2013-09-13','12:15:00',1.15),('5815','2013-09-13','12:40:00',1.65),('5815','2013-09-13','13:15:00',2.26),('5815','2013-09-13','13:20:00',2.57),('5815','2013-09-13','13:25:00',2.17),('5815','2013-09-13','13:30:00',2.6),('5815','2013-09-13','13:35:00',1.77),('5815','2013-09-13','13:45:00',1.46),('5815','2013-09-13','13:50:00',1.38),('5815','2013-09-13','13:55:00',2.22),('5815','2013-09-13','14:00:00',2.61),('5815','2013-09-13','14:05:00',2.41),('5815','2013-09-13','14:10:00',2.35),('5815','2013-09-13','14:15:00',2.32),('5815','2013-09-13','14:20:00',2.34),('5815','2013-09-13','14:25:00',2.23),('5815','2013-09-13','14:30:00',2.28),('5815','2013-09-13','14:35:00',2.26),('5815','2013-09-13','14:40:00',2.23),('5815','2013-09-13','14:45:00',2.21),('5815','2013-09-13','14:50:00',2.18),('5815','2013-09-13','14:55:00',2.15),('5815','2013-09-13','15:00:00',2.11),('5815','2013-09-13','15:05:00',2.11),('5815','2013-09-13','15:10:00',2.06),('5815','2013-09-13','15:15:00',2.05),('5815','2013-09-13','15:20:00',2.02),('5815','2013-09-13','15:25:00',2.01),('5815','2013-09-13','15:30:00',1.98),('5815','2013-09-13','15:35:00',1.93),('5815','2013-09-13','15:40:00',1.92),('5815','2013-09-13','15:45:00',1.86),('5815','2013-09-13','15:50:00',1.83),('5815','2013-09-13','15:55:00',1.8),('5815','2013-09-13','16:00:00',1.76),('5815','2013-09-13','16:05:00',1.73),('5815','2013-09-13','16:10:00',1.67),('5815','2013-09-13','16:15:00',1.62),('5815','2013-09-13','16:20:00',1.6),('5815','2013-09-13','16:25:00',1.54),('5815','2013-09-13','16:30:00',1.52),('5815','2013-09-13','16:35:00',1.47),('5815','2013-09-13','16:40:00',1.43),('5815','2013-09-13','16:45:00',1.38),('5815','2013-09-13','16:50:00',1.32),('5815','2013-09-13','16:55:00',1.28),('5815','2013-09-13','17:00:00',1.23),('5815','2013-09-13','17:05:00',1.15),('5815','2013-09-13','17:10:00',1.14),('5815','2013-09-13','17:15:00',1.02),('5815','2013-09-12','09:55:00',1.05),('5815','2013-09-12','10:00:00',1.55),('5815','2013-09-12','10:10:00',1.09),('5815','2013-09-12','10:15:00',2.1),('5815','2013-09-12','10:20:00',1.91),('5815','2013-09-12','10:30:00',1.2),('5815','2013-09-12','10:35:00',2.05),('5815','2013-09-12','10:40:00',1.91),('5815','2013-09-12','10:45:00',1.92),('5815','2013-09-12','10:50:00',1.94),('5815','2013-09-12','10:55:00',1.96),('5815','2013-09-12','11:00:00',2),('5815','2013-09-12','11:05:00',2.03),('5815','2013-09-12','11:10:00',2.06),('5815','2013-09-12','11:15:00',2.08),('5815','2013-09-12','11:20:00',2.06),('5815','2013-09-12','11:25:00',2.12),('5815','2013-09-12','11:30:00',2.13),('5815','2013-09-12','11:35:00',2.16),('5815','2013-09-12','11:40:00',2.18),('5815','2013-09-12','11:45:00',2.19),('5815','2013-09-12','11:50:00',2.21),('5815','2013-09-12','11:55:00',2.22),('5815','2013-09-12','12:00:00',2.24),('5815','2013-09-12','12:05:00',2.27),('5815','2013-09-12','12:10:00',2.28),('5815','2013-09-12','12:15:00',2.3),('5815','2013-09-12','12:20:00',2.31),('5815','2013-09-12','12:25:00',2.34),('5815','2013-09-12','12:30:00',1.34),('5815','2013-09-12','12:35:00',2.4),('5815','2013-09-12','12:40:00',2.4),('5815','2013-09-12','12:45:00',2.39),('5815','2013-09-12','12:50:00',2.36),('5815','2013-09-12','12:55:00',2.36),('5815','2013-09-12','13:00:00',2.36),('5815','2013-09-12','13:05:00',2.37),('5815','2013-09-12','13:10:00',2.36),('5815','2013-09-12','13:15:00',2.36),('5815','2013-09-12','13:20:00',2.37),('5815','2013-09-12','13:25:00',2.36),('5815','2013-09-12','13:30:00',2.34),('5815','2013-09-12','13:35:00',2.31),('5815','2013-09-12','13:40:00',2.3),('5815','2013-09-12','13:45:00',2.3),('5815','2013-09-12','13:50:00',2.3),('5815','2013-09-12','13:55:00',2.28),('5815','2013-09-12','14:00:00',2.28),('5815','2013-09-12','14:05:00',2.28),('5815','2013-09-12','14:10:00',2.28),('5815','2013-09-12','14:15:00',2.26),('5815','2013-09-12','14:20:00',2.25),('5815','2013-09-12','14:25:00',2.24),('5815','2013-09-12','14:30:00',2.24),('5815','2013-09-12','14:35:00',2.22),('5815','2013-09-12','14:40:00',2.17),('5815','2013-09-12','14:45:00',2.17),('5815','2013-09-12','14:50:00',2.16),('5815','2013-09-12','14:55:00',2.13),('5815','2013-09-12','15:00:00',2.07),('5815','2013-09-12','15:05:00',2.07),('5815','2013-09-12','15:10:00',2.07),('5815','2013-09-12','15:15:00',2.07),('5815','2013-09-12','15:20:00',2.02),('5815','2013-09-12','15:25:00',2),('5815','2013-09-12','15:30:00',1.96),('5815','2013-09-12','15:35:00',1.91),('5815','2013-09-12','15:40:00',1.91),('5815','2013-09-12','15:45:00',1.88),('5815','2013-09-12','15:50:00',1.85),('5815','2013-09-12','15:55:00',1.81),('5815','2013-09-12','16:00:00',1.77),('5815','2013-09-12','16:05:00',1.74),('5815','2013-09-12','16:10:00',1.69),('5815','2013-09-12','16:15:00',1.66),('5815','2013-09-12','16:20:00',1.62),('5815','2013-09-12','16:25:00',1.57),('5815','2013-09-12','16:30:00',1.52),('5815','2013-09-12','16:35:00',1.49),('5815','2013-09-12','16:40:00',1.44),('5815','2013-09-12','16:45:00',1.39),('5815','2013-09-12','16:50:00',1.34),('5815','2013-09-12','16:55:00',1.28),('5815','2013-09-12','17:00:00',1.22),('5815','2013-09-12','17:05:00',1.17),('5815','2013-09-12','17:10:00',1.12),('5815','2013-09-11','09:00:00',1.03),('5815','2013-09-11','09:15:00',1.12),('5815','2013-09-11','09:20:00',1.15),('5815','2013-09-11','09:25:00',1.3),('5815','2013-09-11','09:30:00',1.39),('5815','2013-09-11','09:35:00',1.29),('5815','2013-09-11','09:40:00',1.12),('5815','2013-09-11','09:45:00',1.34),('5815','2013-09-11','09:50:00',1.14),('5815','2013-09-11','10:55:00',1),('5815','2013-09-11','11:00:00',1.27),('5815','2013-09-11','11:05:00',2.09),('5815','2013-09-11','11:10:00',1.52),('5815','2013-09-11','11:15:00',1.77),('5815','2013-09-11','11:45:00',1.05),('5815','2013-09-11','11:55:00',1.77),('5815','2013-09-11','12:00:00',1.9),('5815','2013-09-11','12:05:00',2.31),('5815','2013-09-11','12:10:00',2.25),('5815','2013-09-11','12:15:00',2.03),('5815','2013-09-11','12:25:00',1),('5815','2013-09-11','12:35:00',1.63),('5815','2013-09-11','12:40:00',2.37),('5815','2013-09-11','12:50:00',1.88),('5815','2013-09-11','12:55:00',1.06),('5815','2013-09-11','13:00:00',2.35),('5815','2013-09-11','13:05:00',1.96),('5815','2013-09-11','13:10:00',1.81),('5815','2013-09-11','13:15:00',2.1),('5815','2013-09-11','13:20:00',2.49),('5815','2013-09-11','13:25:00',2.83),('5815','2013-09-11','13:30:00',2.4),('5815','2013-09-11','13:35:00',1.93),('5815','2013-09-11','13:40:00',1.81),('5815','2013-09-11','13:45:00',2.45),('5815','2013-09-11','13:50:00',2.56),('5815','2013-09-11','13:55:00',2.45),('5815','2013-09-11','14:00:00',2.37),('5815','2013-09-11','14:05:00',2.24),('5815','2013-09-11','14:10:00',1.89),('5815','2013-09-11','14:15:00',2.44),('5815','2013-09-11','14:20:00',2.25),('5815','2013-09-11','14:25:00',2.45),('5815','2013-09-11','14:30:00',2.42),('5815','2013-09-11','14:35:00',1.82),('5815','2013-09-11','14:40:00',1.79),('5815','2013-09-11','14:45:00',2.33),('5815','2013-09-11','14:50:00',2.27),('5815','2013-09-11','14:55:00',2.24),('5815','2013-09-11','15:00:00',2.22),('5815','2013-09-11','15:05:00',2.21),('5815','2013-09-11','15:10:00',1.73),('5815','2013-09-11','15:15:00',1.97),('5815','2013-09-11','15:20:00',2.09),('5815','2013-09-11','15:25:00',1.84),('5815','2013-09-11','15:30:00',2.05),('5815','2013-09-11','15:35:00',2),('5815','2013-09-11','15:40:00',1.91),('5815','2013-09-11','15:45:00',1.96),('5815','2013-09-11','15:50:00',1.9),('5815','2013-09-11','15:55:00',1.77),('5815','2013-09-11','16:00:00',1.85),('5815','2013-09-11','16:05:00',1.4),('5815','2013-09-11','16:10:00',1.52),('5815','2013-09-11','16:15:00',1.64),('5815','2013-09-11','16:20:00',1.14),('5815','2013-09-11','16:25:00',1.35),('5815','2013-09-11','16:45:00',1.59),('5815','2013-09-11','16:55:00',1.19),('5815','2013-09-11','17:05:00',1.34),('5815','2013-09-11','17:15:00',1.12),('5815','2013-09-10','09:05:00',1.18),('5815','2013-09-10','09:10:00',1.29),('5815','2013-09-10','09:15:00',1.09),('5815','2013-09-10','09:20:00',1.46),('5815','2013-09-10','09:25:00',1.07),('5815','2013-09-10','10:15:00',1.09),('5815','2013-09-10','10:20:00',1.78),('5815','2013-09-10','10:25:00',1.07),('5815','2013-09-10','10:30:00',1.77),('5815','2013-09-10','10:35:00',1.58),('5815','2013-09-10','10:40:00',1.67),('5815','2013-09-10','10:50:00',1.66),('5815','2013-09-10','10:55:00',1.06),('5815','2013-09-10','11:05:00',1.26),('5815','2013-09-10','11:10:00',1.66),('5815','2013-09-10','11:15:00',1.55),('5815','2013-09-10','11:20:00',2.26),('5815','2013-09-10','11:25:00',1.8),('5815','2013-09-10','11:35:00',1.51),('5815','2013-09-10','11:40:00',1.58),('5815','2013-09-10','11:45:00',2.31),('5815','2013-09-10','11:50:00',2.37),('5815','2013-09-10','11:55:00',2.43),('5815','2013-09-10','12:00:00',1.38),('5815','2013-09-10','12:05:00',2.36),('5815','2013-09-10','12:10:00',1.77),('5815','2013-09-10','12:15:00',1.37),('5815','2013-09-10','12:20:00',1.91),('5815','2013-09-10','12:25:00',1.85),('5815','2013-09-10','12:30:00',2.44),('5815','2013-09-10','12:35:00',2.19),('5815','2013-09-10','12:50:00',2.18),('5815','2013-09-10','12:55:00',2.11),('5815','2013-09-10','13:00:00',1.85),('5815','2013-09-10','13:05:00',2.46),('5815','2013-09-10','13:10:00',2.5),('5815','2013-09-10','13:15:00',2.61),('5815','2013-09-10','13:20:00',2.14),('5815','2013-09-10','13:25:00',2.47),('5815','2013-09-10','13:30:00',2.26),('5815','2013-09-10','13:35:00',1.03),('5815','2013-09-10','13:40:00',1.78),('5815','2013-09-10','13:45:00',1.05),('5815','2013-09-10','13:50:00',2.18),('5815','2013-09-10','13:55:00',1.96),('5815','2013-09-10','14:00:00',1.65),('5815','2013-09-10','14:05:00',2.52),('5815','2013-09-10','14:10:00',2.3),('5815','2013-09-10','14:15:00',2.45),('5815','2013-09-10','14:20:00',1.33),('5815','2013-09-10','14:25:00',2.43),('5815','2013-09-10','14:30:00',1.48),('5815','2013-09-10','14:35:00',2.26),('5815','2013-09-10','14:45:00',1.98),('5815','2013-09-10','14:50:00',2.43),('5815','2013-09-10','14:55:00',2.24),('5815','2013-09-10','15:00:00',1.07),('5815','2013-09-10','15:05:00',2.39),('5815','2013-09-10','15:10:00',1.05),('5815','2013-09-10','15:15:00',2.14),('5815','2013-09-10','15:20:00',1.59),('5815','2013-09-10','15:25:00',1.99),('5815','2013-09-10','15:30:00',1.82),('5815','2013-09-10','15:35:00',1.02),('5815','2013-09-10','15:45:00',1.88),('5815','2013-09-10','15:50:00',2),('5815','2013-09-10','15:55:00',1.46),('5815','2013-09-10','16:00:00',1.56),('5815','2013-09-10','16:05:00',1.88),('5815','2013-09-10','16:10:00',1.64),('5815','2013-09-10','16:15:00',1.76),('5815','2013-09-10','16:20:00',1.69),('5815','2013-09-10','16:25:00',1.61),('5815','2013-09-10','16:35:00',1.33),('5815','2013-09-10','16:45:00',1.54),('5815','2013-09-10','16:50:00',1.39),('5815','2013-09-10','16:55:00',1.28),('5815','2013-09-10','17:00:00',1.16),('5815','2013-09-10','17:05:00',1.23),('5815','2013-09-10','17:10:00',1.17),('5815','2013-09-10','17:15:00',1.08),('5815','2013-09-10','17:20:00',1.02),('5815','2013-09-09','09:10:00',1.27),('5815','2013-09-09','09:15:00',1.09),('5815','2013-09-09','09:30:00',1.4),('5815','2013-09-09','09:35:00',1.57),('5815','2013-09-09','10:45:00',1.15),('5815','2013-09-09','13:45:00',1.59),('5815','2013-09-09','13:50:00',1.06),('5815','2013-09-09','14:25:00',1.25),('5815','2013-09-09','14:30:00',1.17),('5815','2013-09-09','14:40:00',1.01),('5815','2013-09-09','14:45:00',1.05),('5815','2013-09-09','14:50:00',1.24),('5815','2013-09-09','14:55:00',1.18),('5815','2013-09-09','15:00:00',1.39),('5815','2013-09-09','15:05:00',1.36),('5815','2013-09-09','15:10:00',1.02),('5815','2013-09-09','15:20:00',1.23),('5815','2013-09-09','15:25:00',1.07),('5815','2013-09-09','15:30:00',1.21),('5815','2013-09-09','15:35:00',1.13),('5815','2013-09-08','10:10:00',1),('5815','2013-09-08','10:40:00',1.01),('5815','2013-09-08','10:45:00',1.11),('5815','2013-09-08','10:50:00',1.47),('5815','2013-09-08','10:55:00',1.43),('5815','2013-09-08','11:00:00',1.55),('5815','2013-09-08','11:05:00',1.19),('5815','2013-09-08','11:15:00',1.19),('5815','2013-09-08','11:20:00',1.41),('5815','2013-09-08','11:25:00',1.58),('5815','2013-09-08','11:30:00',1.25),('5815','2013-09-08','11:35:00',1.22),('5815','2013-09-08','11:40:00',1.87),('5815','2013-09-08','11:45:00',1.94),('5815','2013-09-08','11:50:00',1.5),('5815','2013-09-08','11:55:00',1.85),('5815','2013-09-08','12:00:00',1.66),('5815','2013-09-08','12:05:00',1.86),('5815','2013-09-08','12:10:00',1.73),('5815','2013-09-08','12:15:00',1.3),('5815','2013-09-08','13:05:00',1.31),('5815','2013-09-08','13:10:00',1.5),('5815','2013-09-08','13:15:00',1.94),('5815','2013-09-08','13:20:00',1.61),('5815','2013-09-08','13:25:00',1.41),('5815','2013-09-08','13:30:00',1.68),('5815','2013-09-08','13:35:00',2.14),('5815','2013-09-08','13:40:00',2.17),('5815','2013-09-08','13:45:00',2.21),('5815','2013-09-08','13:50:00',2.41),('5815','2013-09-08','13:55:00',2.44),('5815','2013-09-08','14:00:00',2.22),('5815','2013-09-08','14:05:00',2.11),('5815','2013-09-08','14:10:00',2.24),('5815','2013-09-08','14:15:00',1.65),('5815','2013-09-08','14:20:00',1.16),('5815','2013-09-08','14:25:00',1.07),('5815','2013-09-08','14:30:00',1.04),('5815','2013-09-08','14:35:00',2.24),('5815','2013-09-08','14:40:00',2.19),('5815','2013-09-08','14:45:00',1.16),('5815','2013-09-08','14:50:00',1.94),('5815','2013-09-08','14:55:00',1.98),('5815','2013-09-08','15:00:00',1.61),('5815','2013-09-08','15:05:00',1.49),('5815','2013-09-08','15:10:00',1.73),('5815','2013-09-08','15:20:00',1.25),('5815','2013-09-08','15:30:00',1.73),('5815','2013-09-08','15:35:00',1.39),('5815','2013-09-08','15:40:00',1.5),('5815','2013-09-08','16:15:00',1.28),('5815','2013-09-08','16:20:00',1.03),('5815','2013-09-08','16:45:00',1.33),('5815','2013-09-07','09:30:00',1.13),('5815','2013-09-07','09:35:00',1.33),('5815','2013-09-07','09:40:00',1.31),('5815','2013-09-07','09:45:00',1.3),('5815','2013-09-07','09:50:00',1.36),('5815','2013-09-07','09:55:00',1.4),('5815','2013-09-07','10:00:00',1.42),('5815','2013-09-07','10:05:00',1.48),('5815','2013-09-07','10:10:00',1.52),('5815','2013-09-07','10:15:00',1.54),('5815','2013-09-07','10:20:00',1.61),('5815','2013-09-07','10:25:00',1.64),('5815','2013-09-07','10:30:00',1.67),('5815','2013-09-07','10:35:00',1.71),('5815','2013-09-07','10:40:00',1.69),('5815','2013-09-07','10:45:00',1.75),('5815','2013-09-07','10:50:00',1.78),('5815','2013-09-07','10:55:00',1.82),('5815','2013-09-07','11:00:00',1.85),('5815','2013-09-07','11:05:00',1.85),('5815','2013-09-07','11:10:00',1.86),('5815','2013-09-07','11:15:00',1.88),('5815','2013-09-07','11:20:00',1.88),('5815','2013-09-07','11:25:00',1.88),('5815','2013-09-07','11:30:00',1.93),('5815','2013-09-07','11:35:00',1.92),('5815','2013-09-07','11:40:00',1.95),('5815','2013-09-07','11:45:00',1.96),('5815','2013-09-07','11:50:00',1.95),('5815','2013-09-07','11:55:00',1.92),('5815','2013-09-07','12:00:00',1.94),('5815','2013-09-07','12:05:00',1.95),('5815','2013-09-07','12:10:00',1.98),('5815','2013-09-07','12:15:00',2.05),('5815','2013-09-07','12:20:00',2.08),('5815','2013-09-07','12:25:00',2.03),('5815','2013-09-07','12:30:00',2.05),('5815','2013-09-07','12:35:00',2.12),('5815','2013-09-07','12:40:00',2.06),('5815','2013-09-07','12:45:00',2.01),('5815','2013-09-07','12:50:00',2.05),('5815','2013-09-07','12:55:00',2.09),('5815','2013-09-07','13:00:00',2.07),('5815','2013-09-07','13:05:00',2.1),('5815','2013-09-07','13:10:00',2.12),('5815','2013-09-07','13:15:00',2.07),('5815','2013-09-07','13:20:00',2.05),('5815','2013-09-07','13:25:00',1.96),('5815','2013-09-07','13:30:00',1.84),('5815','2013-09-07','13:35:00',1.87),('5815','2013-09-07','13:40:00',1.44),('5815','2013-09-07','13:45:00',1.23),('5815','2013-09-07','13:50:00',1.41),('5815','2013-09-07','13:55:00',1.51),('5815','2013-09-07','14:00:00',1.9),('5815','2013-09-07','14:05:00',1.97),('5815','2013-09-07','14:10:00',2.05),('5815','2013-09-07','14:15:00',1.88),('5815','2013-09-07','14:20:00',1.71),('5815','2013-09-07','14:25:00',2.28),('5815','2013-09-07','14:30:00',1.97),('5815','2013-09-07','14:35:00',2.18),('5815','2013-09-07','14:40:00',2.05),('5815','2013-09-07','14:45:00',2.1),('5815','2013-09-07','14:50:00',2.07),('5815','2013-09-07','14:55:00',2.02),('5815','2013-09-07','15:00:00',2.01),('5815','2013-09-07','15:05:00',1.73),('5815','2013-09-07','15:10:00',1.06),('5815','2013-09-07','15:15:00',1.52),('5815','2013-09-07','15:20:00',1.89),('5815','2013-09-07','15:25:00',1.94),('5815','2013-09-07','15:30:00',1.95),('5815','2013-09-07','15:35:00',1.89),('5815','2013-09-07','15:40:00',1.75),('5815','2013-09-07','15:45:00',1.77),('5815','2013-09-07','15:50:00',1.79),('5815','2013-09-07','15:55:00',1.45),('5815','2013-09-07','16:00:00',1.49),('5815','2013-09-07','16:05:00',1.45),('5815','2013-09-07','16:10:00',1.35),('5815','2013-09-07','16:15:00',1.46),('5815','2013-09-07','16:20:00',1.42),('5815','2013-09-07','16:25:00',1.43),('5815','2013-09-07','16:30:00',1.33),('5815','2013-09-07','16:35:00',1.34),('5815','2013-09-07','16:40:00',1.15),('5815','2013-09-07','17:05:00',1.21),('5815','2013-09-07','17:10:00',1.16),('5815','2013-09-07','17:15:00',1.06),('5815','2013-09-06','09:05:00',1.01),('5815','2013-09-06','09:10:00',1.06),('5815','2013-09-06','09:15:00',1.11),('5815','2013-09-06','09:20:00',1.15),('5815','2013-09-06','09:25:00',1.19),('5815','2013-09-06','09:30:00',1.25),('5815','2013-09-06','09:35:00',1.29),('5815','2013-09-06','09:40:00',1.31),('5815','2013-09-06','09:45:00',1.37),('5815','2013-09-06','09:50:00',1.4),('5815','2013-09-06','09:55:00',1.45),('5815','2013-09-06','10:00:00',1.48),('5815','2013-09-06','10:05:00',1.51),('5815','2013-09-06','10:10:00',1.55),('5815','2013-09-06','10:15:00',1.56),('5815','2013-09-06','10:20:00',1.61),('5815','2013-09-06','10:25:00',1.65),('5815','2013-09-06','10:30:00',1.68),('5815','2013-09-06','10:35:00',1.71),('5815','2013-09-06','10:40:00',1.74),('5815','2013-09-06','10:45:00',1.77),('5815','2013-09-06','10:50:00',1.8),('5815','2013-09-06','10:55:00',1.81),('5815','2013-09-06','11:00:00',1.83),('5815','2013-09-06','11:05:00',1.85),('5815','2013-09-06','11:10:00',1.89),('5815','2013-09-06','11:15:00',1.93),('5815','2013-09-06','11:20:00',1.95),('5815','2013-09-06','11:25:00',2.01),('5815','2013-09-06','11:30:00',2.03),('5815','2013-09-06','11:35:00',2.04),('5815','2013-09-06','11:40:00',2.04),('5815','2013-09-06','11:45:00',2.07),('5815','2013-09-06','11:50:00',2.06),('5815','2013-09-06','11:55:00',2.06),('5815','2013-09-06','12:00:00',2.07),('5815','2013-09-06','12:05:00',2.1),('5815','2013-09-06','12:10:00',2.12),('5815','2013-09-06','12:15:00',2.11),('5815','2013-09-06','12:20:00',2.12),('5815','2013-09-06','12:25:00',2.14),('5815','2013-09-06','12:30:00',2.13),('5815','2013-09-06','12:35:00',2.15),('5815','2013-09-06','12:40:00',2.14),('5815','2013-09-06','12:45:00',2.13),('5815','2013-09-06','12:50:00',2.19),('5815','2013-09-06','12:55:00',2.2),('5815','2013-09-06','13:00:00',2.2),('5815','2013-09-06','13:05:00',2.19),('5815','2013-09-06','13:10:00',2.19),('5815','2013-09-06','13:15:00',2.17),('5815','2013-09-06','13:20:00',2.17),('5815','2013-09-06','13:25:00',2.16),('5815','2013-09-06','13:30:00',2.16),('5815','2013-09-06','13:35:00',2.17),('5815','2013-09-06','13:40:00',2.22),('5815','2013-09-06','13:45:00',2.21),('5815','2013-09-06','13:50:00',2.21),('5815','2013-09-06','13:55:00',2.15),('5815','2013-09-06','14:00:00',1.24),('5815','2013-09-06','14:05:00',2.17),('5815','2013-09-06','14:10:00',2.2),('5815','2013-09-06','14:15:00',2.21),('5815','2013-09-06','14:20:00',2.15),('5815','2013-09-06','14:25:00',2.11),('5815','2013-09-06','14:30:00',2.12),('5815','2013-09-06','14:35:00',2.13),('5815','2013-09-06','14:40:00',2.1),('5815','2013-09-06','14:45:00',2.11),('5815','2013-09-06','14:50:00',2.08),('5815','2013-09-06','14:55:00',2.05),('5815','2013-09-06','15:00:00',2.05),('5815','2013-09-06','15:05:00',2.03),('5815','2013-09-06','15:10:00',1.95),('5815','2013-09-06','15:15:00',1.97),('5815','2013-09-06','15:20:00',1.94),('5815','2013-09-06','15:25:00',1.91),('5815','2013-09-06','15:30:00',1.89),('5815','2013-09-06','15:35:00',1.87),('5815','2013-09-06','15:40:00',1.82),('5815','2013-09-06','15:45:00',1.78),('5815','2013-09-06','15:50:00',1.75),('5815','2013-09-06','15:55:00',1.72),('5815','2013-09-06','16:00:00',1.68),('5815','2013-09-06','16:05:00',1.65),('5815','2013-09-06','16:10:00',1.61),('5815','2013-09-06','16:15:00',1.57),('5815','2013-09-06','16:20:00',1.53),('5815','2013-09-06','16:25:00',1.47),('5815','2013-09-06','16:30:00',1.44),('5815','2013-09-06','16:35:00',1.4),('5815','2013-09-06','16:40:00',1.35),('5815','2013-09-06','16:45:00',1.3),('5815','2013-09-06','16:50:00',1.26),('5815','2013-09-06','16:55:00',1.22),('5815','2013-09-06','17:00:00',1.17),('5815','2013-09-06','17:05:00',1.12),('5815','2013-09-06','17:10:00',1.07),('5815','2013-09-06','17:15:00',1.02),('5815','2013-09-05','09:05:00',1.04),('5815','2013-09-05','09:10:00',1.08),('5815','2013-09-05','09:15:00',1.13),('5815','2013-09-05','09:20:00',1.17),('5815','2013-09-05','09:25:00',1.21),('5815','2013-09-05','09:30:00',1.26),('5815','2013-09-05','09:35:00',1.3),('5815','2013-09-05','09:40:00',1.34),('5815','2013-09-05','09:45:00',1.39),('5815','2013-09-05','09:50:00',1.44),('5815','2013-09-05','09:55:00',1.47),('5815','2013-09-05','10:00:00',1.5),('5815','2013-09-05','10:05:00',1.54),('5815','2013-09-05','10:10:00',1.59),('5815','2013-09-05','10:15:00',1.61),('5815','2013-09-05','10:20:00',1.65),('5815','2013-09-05','10:25:00',1.68),('5815','2013-09-05','10:30:00',1.72),('5815','2013-09-05','10:35:00',1.74),('5815','2013-09-05','10:40:00',1.77),('5815','2013-09-05','10:45:00',1.8),('5815','2013-09-05','10:50:00',1.83),('5815','2013-09-05','10:55:00',1.86),('5815','2013-09-05','11:00:00',1.88),('5815','2013-09-05','11:05:00',1.9),('5815','2013-09-05','11:10:00',1.9),('5815','2013-09-05','11:15:00',1.96),('5815','2013-09-05','11:20:00',1.97),('5815','2013-09-05','11:25:00',1.98),('5815','2013-09-05','11:30:00',2.01),('5815','2013-09-05','11:35:00',2.03),('5815','2013-09-05','11:40:00',2.06),('5815','2013-09-05','11:45:00',2.06),('5815','2013-09-05','11:50:00',2.08),('5815','2013-09-05','11:55:00',2.1),('5815','2013-09-05','12:00:00',2.1),('5815','2013-09-05','12:05:00',2.1),('5815','2013-09-05','12:10:00',2.1),('5815','2013-09-05','12:15:00',2.13),('5815','2013-09-05','12:20:00',2.15),('5815','2013-09-05','12:25:00',2.16),('5815','2013-09-05','12:30:00',2.18),('5815','2013-09-05','12:35:00',2.19),('5815','2013-09-05','12:40:00',2.16),('5815','2013-09-05','12:45:00',2.15),('5815','2013-09-05','12:50:00',2.17),('5815','2013-09-05','12:55:00',2.2),('5815','2013-09-05','13:00:00',2.19),('5815','2013-09-05','13:05:00',2.18),('5815','2013-09-05','13:10:00',2.19),('5815','2013-09-05','13:15:00',2.18),('5815','2013-09-05','13:20:00',2.18),('5815','2013-09-05','13:25:00',2.16),('5815','2013-09-05','13:30:00',2.17),('5815','2013-09-05','13:35:00',2.17),('5815','2013-09-05','13:40:00',2.18),('5815','2013-09-05','13:45:00',1.95),('5815','2013-09-05','13:50:00',1.92),('5815','2013-09-05','13:55:00',2.11),('5815','2013-09-05','14:00:00',2.12),('5815','2013-09-05','14:05:00',2.1),('5815','2013-09-05','14:10:00',2.12),('5815','2013-09-05','14:15:00',2.13),('5815','2013-09-05','14:20:00',2.13),('5815','2013-09-05','14:25:00',2.11),('5815','2013-09-05','14:30:00',2.08),('5815','2013-09-05','14:35:00',2.05),('5815','2013-09-05','14:40:00',1.96),('5815','2013-09-05','14:45:00',2),('5815','2013-09-05','14:50:00',2.04),('5815','2013-09-05','14:55:00',2.04),('5815','2013-09-05','15:00:00',2),('5815','2013-09-05','15:05:00',1.96),('5815','2013-09-05','15:10:00',1.92),('5815','2013-09-05','15:15:00',1.92),('5815','2013-09-05','15:20:00',1.9),('5815','2013-09-05','15:25:00',1.87),('5815','2013-09-05','15:30:00',1.86),('5815','2013-09-05','15:35:00',1.82),('5815','2013-09-05','15:40:00',1.79),('5815','2013-09-05','15:45:00',1.77),('5815','2013-09-05','15:50:00',1.74),('5815','2013-09-05','15:55:00',1.72),('5815','2013-09-05','16:00:00',1.68),('5815','2013-09-05','16:05:00',1.63),('5815','2013-09-05','16:10:00',1.59),('5815','2013-09-05','16:15:00',1.55),('5815','2013-09-05','16:20:00',1.52),('5815','2013-09-05','16:25:00',1.49),('5815','2013-09-05','16:30:00',1.45),('5815','2013-09-05','16:35:00',1.41),('5815','2013-09-05','16:40:00',1.35),('5815','2013-09-05','16:45:00',1.33),('5815','2013-09-05','16:50:00',1.26),('5815','2013-09-05','16:55:00',1.23),('5815','2013-09-05','17:00:00',1.18),('5815','2013-09-05','17:05:00',1.11),('5815','2013-09-05','17:10:00',1.08),('5815','2013-09-05','17:15:00',1.02),('5815','2013-09-04','08:55:00',1.01),('5815','2013-09-04','09:00:00',1.06),('5815','2013-09-04','09:05:00',1.11),('5815','2013-09-04','09:10:00',1.16),('5815','2013-09-04','09:15:00',1.2),('5815','2013-09-04','09:20:00',1.25),('5815','2013-09-04','09:25:00',1.3),('5815','2013-09-04','09:30:00',1.34),('5815','2013-09-04','09:35:00',1.38),('5815','2013-09-04','09:40:00',1.42),('5815','2013-09-04','09:45:00',1.47),('5815','2013-09-04','09:50:00',1.51),('5815','2013-09-04','09:55:00',1.55),('5815','2013-09-04','10:00:00',1.59),('5815','2013-09-04','10:05:00',1.63),('5815','2013-09-04','10:10:00',1.65),('5815','2013-09-04','10:15:00',1.69),('5815','2013-09-04','10:20:00',1.69),('5815','2013-09-04','10:25:00',1.75),('5815','2013-09-04','10:30:00',1.78),('5815','2013-09-04','10:35:00',1.82),('5815','2013-09-04','10:40:00',1.84),('5815','2013-09-04','10:45:00',1.87),('5815','2013-09-04','10:50:00',1.9),('5815','2013-09-04','10:55:00',1.93),('5815','2013-09-04','11:00:00',1.94),('5815','2013-09-04','11:05:00',1.98),('5815','2013-09-04','11:10:00',2),('5815','2013-09-04','11:15:00',2.01),('5815','2013-09-04','11:20:00',2.04),('5815','2013-09-04','11:25:00',2.07),('5815','2013-09-04','11:30:00',2.08),('5815','2013-09-04','11:35:00',2.07),('5815','2013-09-04','11:40:00',2.06),('5815','2013-09-04','11:45:00',2.07),('5815','2013-09-04','11:50:00',2.14),('5815','2013-09-04','11:55:00',2.16),('5815','2013-09-04','12:00:00',2.16),('5815','2013-09-04','12:05:00',2.19),('5815','2013-09-04','12:10:00',2.2),('5815','2013-09-04','12:15:00',2.21),('5815','2013-09-04','12:20:00',2.2),('5815','2013-09-04','12:25:00',2.22),('5815','2013-09-04','12:30:00',2.21),('5815','2013-09-04','12:35:00',2.21),('5815','2013-09-04','12:40:00',2.23),('5815','2013-09-04','12:45:00',2.24),('5815','2013-09-04','12:50:00',2.25),('5815','2013-09-04','12:55:00',2.27),('5815','2013-09-04','13:00:00',2.27),('5815','2013-09-04','13:05:00',2.26),('5815','2013-09-04','13:10:00',2.22),('5815','2013-09-04','13:15:00',2.25),('5815','2013-09-04','13:20:00',2.25),('5815','2013-09-04','13:25:00',2.25),('5815','2013-09-04','13:30:00',2.24),('5815','2013-09-04','13:35:00',2.28),('5815','2013-09-04','13:40:00',2.29),('5815','2013-09-04','13:45:00',2.25),('5815','2013-09-04','13:50:00',2.23),('5815','2013-09-04','13:55:00',2.21),('5815','2013-09-04','14:00:00',2.19),('5815','2013-09-04','14:05:00',2.18),('5815','2013-09-04','14:10:00',2.19),('5815','2013-09-04','14:15:00',2.2),('5815','2013-09-04','14:20:00',2.18),('5815','2013-09-04','14:25:00',2.14),('5815','2013-09-04','14:30:00',2.11),('5815','2013-09-04','14:35:00',2.09),('5815','2013-09-04','14:40:00',2.05),('5815','2013-09-04','14:45:00',2.03),('5815','2013-09-04','14:50:00',2.03),('5815','2013-09-04','14:55:00',2.03),('5815','2013-09-04','15:00:00',2.03),('5815','2013-09-04','15:05:00',2.04),('5815','2013-09-04','15:10:00',2.03),('5815','2013-09-04','15:15:00',2.01),('5815','2013-09-04','15:20:00',2),('5815','2013-09-04','15:25:00',1.97),('5815','2013-09-04','15:30:00',1.94),('5815','2013-09-04','15:35:00',1.9),('5815','2013-09-04','15:40:00',1.86),('5815','2013-09-04','15:45:00',1.83),('5815','2013-09-04','15:50:00',1.8),('5815','2013-09-04','15:55:00',1.76),('5815','2013-09-04','16:00:00',1.76),('5815','2013-09-04','16:05:00',1.73),('5815','2013-09-04','16:10:00',1.69),('5815','2013-09-04','16:15:00',1.66),('5815','2013-09-04','16:20:00',1.62),('5815','2013-09-04','16:25:00',1.59),('5815','2013-09-04','16:30:00',1.55),('5815','2013-09-04','16:35:00',1.53),('5815','2013-09-04','16:40:00',1.51),('5815','2013-09-04','16:45:00',1.49),('5815','2013-09-04','16:50:00',1.34),('5815','2013-09-04','16:55:00',1.07),('5815','2013-09-03','09:00:00',1.05),('5815','2013-09-03','09:05:00',1.1),('5815','2013-09-03','09:10:00',1.16),('5815','2013-09-03','09:15:00',1.21),('5815','2013-09-03','09:20:00',1.26),('5815','2013-09-03','09:25:00',1.32),('5815','2013-09-03','09:30:00',1.36),('5815','2013-09-03','09:35:00',1.41),('5815','2013-09-03','09:40:00',1.46),('5815','2013-09-03','09:45:00',1.51),('5815','2013-09-03','09:50:00',1.54),('5815','2013-09-03','09:55:00',1.59),('5815','2013-09-03','10:00:00',1.63),('5815','2013-09-03','10:05:00',1.67),('5815','2013-09-03','10:10:00',1.71),('5815','2013-09-03','10:15:00',1.73),('5815','2013-09-03','10:20:00',1.76),('5815','2013-09-03','10:25:00',1.79),('5815','2013-09-03','10:30:00',1.83),('5815','2013-09-03','10:35:00',1.87),('5815','2013-09-03','10:40:00',1.89),('5815','2013-09-03','10:45:00',1.92),('5815','2013-09-03','10:50:00',1.95),('5815','2013-09-03','10:55:00',1.98),('5815','2013-09-03','11:00:00',2),('5815','2013-09-03','11:05:00',2.01),('5815','2013-09-03','11:10:00',2.06),('5815','2013-09-03','11:15:00',2.07),('5815','2013-09-03','11:20:00',2.09),('5815','2013-09-03','11:25:00',2.11),('5815','2013-09-03','11:30:00',2.13),('5815','2013-09-03','11:35:00',2.15),('5815','2013-09-03','11:40:00',2.18),('5815','2013-09-03','11:45:00',2.19),('5815','2013-09-03','11:50:00',2.22),('5815','2013-09-03','11:55:00',2.23),('5815','2013-09-03','12:00:00',2.24),('5815','2013-09-03','12:05:00',2.26),('5815','2013-09-03','12:10:00',2.26),('5815','2013-09-03','12:15:00',2.26),('5815','2013-09-03','12:20:00',2.27),('5815','2013-09-03','12:25:00',2.29),('5815','2013-09-03','12:30:00',2.29),('5815','2013-09-03','12:35:00',2.3),('5815','2013-09-03','12:40:00',2.32),('5815','2013-09-03','12:45:00',2.31),('5815','2013-09-03','12:50:00',2.31),('5815','2013-09-03','12:55:00',2.32),('5815','2013-09-03','13:00:00',2.3),('5815','2013-09-03','13:05:00',2.3),('5815','2013-09-03','13:10:00',2.3),('5815','2013-09-03','13:15:00',2.3),('5815','2013-09-03','13:20:00',2.31),('5815','2013-09-03','13:25:00',2.31),('5815','2013-09-03','13:30:00',2.31),('5815','2013-09-03','13:35:00',2.31),('5815','2013-09-03','13:40:00',2.31),('5815','2013-09-03','13:45:00',2.29),('5815','2013-09-03','13:50:00',2.28),('5815','2013-09-03','13:55:00',2.29),('5815','2013-09-03','14:00:00',2.26),('5815','2013-09-03','14:05:00',2.27),('5815','2013-09-03','14:10:00',2.28),('5815','2013-09-03','14:15:00',2.27),('5815','2013-09-03','14:20:00',2.24),('5815','2013-09-03','14:25:00',2.23),('5815','2013-09-03','14:30:00',2.22),('5815','2013-09-03','14:35:00',2.19),('5815','2013-09-03','14:40:00',2.17),('5815','2013-09-03','14:45:00',2.15),('5815','2013-09-03','14:50:00',2.14),('5815','2013-09-03','14:55:00',2.12),('5815','2013-09-03','15:00:00',2.09),('5815','2013-09-03','15:05:00',2.07),('5815','2013-09-03','15:10:00',2.04),('5815','2013-09-03','15:15:00',2.03),('5815','2013-09-03','15:20:00',2),('5815','2013-09-03','15:25:00',1.93),('5815','2013-09-03','15:30:00',1.94),('5815','2013-09-03','15:35:00',1.91),('5815','2013-09-03','15:40:00',1.88),('5815','2013-09-03','15:45:00',1.85),('5815','2013-09-03','15:50:00',1.82),('5815','2013-09-03','15:55:00',1.78),('5815','2013-09-03','16:00:00',1.74),('5815','2013-09-03','16:05:00',1.7),('5815','2013-09-03','16:10:00',1.67),('5815','2013-09-03','16:15:00',1.64),('5815','2013-09-03','16:20:00',1.6),('5815','2013-09-03','16:25:00',1.56),('5815','2013-09-03','16:30:00',1.53),('5815','2013-09-03','16:35:00',1.48),('5815','2013-09-03','16:40:00',1.44),('5815','2013-09-03','16:45:00',1.4),('5815','2013-09-03','16:50:00',1.35),('5815','2013-09-03','16:55:00',1.3),('5815','2013-09-03','17:00:00',1.26),('5815','2013-09-03','17:05:00',1.21),('5815','2013-09-03','17:10:00',1.16),('5815','2013-09-03','17:15:00',1.12),('5815','2013-09-03','17:20:00',1.05),('5815','2013-09-02','09:05:00',1.02),('5815','2013-09-02','09:10:00',1.07),('5815','2013-09-02','09:15:00',1.13),('5815','2013-09-02','09:20:00',1.18),('5815','2013-09-02','09:25:00',1.23),('5815','2013-09-02','09:30:00',1.27),('5815','2013-09-02','09:35:00',1.31),('5815','2013-09-02','09:40:00',1.35),('5815','2013-09-02','09:45:00',1.4),('5815','2013-09-02','09:50:00',1.44),('5815','2013-09-02','09:55:00',1.48),('5815','2013-09-02','10:00:00',1.51),('5815','2013-09-02','10:05:00',1.55),('5815','2013-09-02','10:10:00',1.59),('5815','2013-09-02','10:15:00',1.63),('5815','2013-09-02','10:20:00',1.66),('5815','2013-09-02','10:25:00',1.7),('5815','2013-09-02','10:30:00',1.74),('5815','2013-09-02','10:35:00',1.8),('5815','2013-09-02','10:40:00',1.84),('5815','2013-09-02','10:45:00',1.86),('5815','2013-09-02','10:50:00',1.88),('5815','2013-09-02','10:55:00',1.9),('5815','2013-09-02','11:00:00',1.92),('5815','2013-09-02','11:05:00',1.94),('5815','2013-09-02','11:10:00',1.97),('5815','2013-09-02','11:15:00',1.99),('5815','2013-09-02','11:20:00',2.02),('5815','2013-09-02','11:25:00',2.04),('5815','2013-09-02','11:30:00',2.06),('5815','2013-09-02','11:35:00',2.08),('5815','2013-09-02','11:40:00',2.08),('5815','2013-09-02','11:45:00',2.1),('5815','2013-09-02','11:50:00',2.13),('5815','2013-09-02','11:55:00',2.11),('5815','2013-09-02','12:00:00',2.15),('5815','2013-09-02','12:05:00',2.18),('5815','2013-09-02','12:10:00',2.19),('5815','2013-09-02','12:15:00',2.21),('5815','2013-09-02','12:20:00',2.22),('5815','2013-09-02','12:25:00',2.23),('5815','2013-09-02','12:30:00',2.24),('5815','2013-09-02','12:35:00',2.25),('5815','2013-09-02','12:40:00',2.26),('5815','2013-09-02','12:45:00',2.26),('5815','2013-09-02','12:50:00',2.25),('5815','2013-09-02','12:55:00',2.26),('5815','2013-09-02','13:00:00',2.27),('5815','2013-09-02','13:05:00',2.28),('5815','2013-09-02','13:10:00',2.26),('5815','2013-09-02','13:15:00',2.25),('5815','2013-09-02','13:20:00',2.26),('5815','2013-09-02','13:25:00',2.26),('5815','2013-09-02','13:30:00',2.27),('5815','2013-09-02','13:35:00',2.27),('5815','2013-09-02','13:40:00',2.23),('5815','2013-09-02','13:45:00',2.26),('5815','2013-09-02','13:50:00',2.24),('5815','2013-09-02','13:55:00',2.21),('5815','2013-09-02','14:00:00',2.18),('5815','2013-09-02','14:05:00',2.15),('5815','2013-09-02','14:10:00',2.17),('5815','2013-09-02','14:15:00',2.18),('5815','2013-09-02','14:20:00',2.17),('5815','2013-09-02','14:25:00',2.17),('5815','2013-09-02','14:30:00',2.16),('5815','2013-09-02','14:35:00',2.14),('5815','2013-09-02','14:40:00',2.1),('5815','2013-09-02','14:45:00',2.1),('5815','2013-09-02','14:50:00',2.1),('5815','2013-09-02','14:55:00',2.07),('5815','2013-09-02','15:00:00',2.04),('5815','2013-09-02','15:05:00',2.01),('5815','2013-09-02','15:10:00',2.01),('5815','2013-09-02','15:15:00',1.99),('5815','2013-09-02','15:20:00',1.96),('5815','2013-09-02','15:25:00',1.93),('5815','2013-09-02','15:30:00',1.89),('5815','2013-09-02','15:35:00',1.87),('5815','2013-09-02','15:40:00',1.83),('5815','2013-09-02','15:45:00',1.79),('5815','2013-09-02','15:50:00',1.77),('5815','2013-09-02','15:55:00',1.76),('5815','2013-09-02','16:00:00',1.74),('5815','2013-09-02','16:05:00',1.7),('5815','2013-09-02','16:10:00',1.64),('5815','2013-09-02','16:15:00',1.6),('5815','2013-09-02','16:20:00',1.58),('5815','2013-09-02','16:25:00',1.54),('5815','2013-09-02','16:30:00',1.5),('5815','2013-09-02','16:35:00',1.47),('5815','2013-09-02','16:40:00',1.42),('5815','2013-09-02','16:45:00',1.39),('5815','2013-09-02','16:50:00',1.35),('5815','2013-09-02','16:55:00',1.3),('5815','2013-09-02','17:00:00',1.26),('5815','2013-09-02','17:05:00',1.21),('5815','2013-09-02','17:10:00',1.16),('5815','2013-09-02','17:15:00',1.11),('5815','2013-09-02','17:20:00',1.06),('5815','2013-09-01','09:00:00',1.01),('5815','2013-09-01','09:05:00',1.05),('5815','2013-09-01','09:10:00',1.11),('5815','2013-09-01','09:15:00',1.16),('5815','2013-09-01','09:20:00',1.21),('5815','2013-09-01','09:25:00',1.26),('5815','2013-09-01','09:30:00',1.3),('5815','2013-09-01','09:35:00',1.35),('5815','2013-09-01','09:40:00',1.39),('5815','2013-09-01','09:45:00',1.43),('5815','2013-09-01','09:50:00',1.47),('5815','2013-09-01','09:55:00',1.5),('5815','2013-09-01','10:00:00',1.54),('5815','2013-09-01','10:05:00',1.59),('5815','2013-09-01','10:10:00',1.63),('5815','2013-09-01','10:15:00',1.67),('5815','2013-09-01','10:20:00',1.69),('5815','2013-09-01','10:25:00',1.74),('5815','2013-09-01','10:30:00',1.77),('5815','2013-09-01','10:35:00',1.8),('5815','2013-09-01','10:40:00',1.83),('5815','2013-09-01','10:45:00',1.85),('5815','2013-09-01','10:50:00',1.87),('5815','2013-09-01','10:55:00',1.9),('5815','2013-09-01','11:00:00',1.93),('5815','2013-09-01','11:05:00',1.95),('5815','2013-09-01','11:10:00',1.98),('5815','2013-09-01','11:15:00',2.01),('5815','2013-09-01','11:20:00',2.03),('5815','2013-09-01','11:25:00',2.04),('5815','2013-09-01','11:30:00',2.07),('5815','2013-09-01','11:35:00',2.06),('5815','2013-09-01','11:40:00',2.09),('5815','2013-09-01','11:45:00',2.11),('5815','2013-09-01','11:50:00',2.11),('5815','2013-09-01','11:55:00',2.13),('5815','2013-09-01','12:00:00',2.15),('5815','2013-09-01','12:05:00',2.18),('5815','2013-09-01','12:10:00',2.19),('5815','2013-09-01','12:15:00',2.19),('5815','2013-09-01','12:20:00',2.21),('5815','2013-09-01','12:25:00',2.21),('5815','2013-09-01','12:30:00',2.21),('5815','2013-09-01','12:35:00',2.22),('5815','2013-09-01','12:40:00',2.22),('5815','2013-09-01','12:45:00',2.21),('5815','2013-09-01','12:50:00',2.23),('5815','2013-09-01','12:55:00',2.23),('5815','2013-09-01','13:00:00',2.26),('5815','2013-09-01','13:05:00',2.26),('5815','2013-09-01','13:10:00',2.25),('5815','2013-09-01','13:15:00',2.26),('5815','2013-09-01','13:20:00',2.25),('5815','2013-09-01','13:25:00',2.24),('5815','2013-09-01','13:30:00',2.22),('5815','2013-09-01','13:35:00',2.2),('5815','2013-09-01','13:40:00',2.17),('5815','2013-09-01','13:45:00',2.15),('5815','2013-09-01','13:50:00',1.95),('5815','2013-09-01','13:55:00',2.25),('5815','2013-09-01','14:00:00',2.22),('5815','2013-09-01','14:05:00',1.89),('5815','2013-09-01','14:10:00',2.01),('5815','2013-09-01','14:15:00',2.24),('5815','2013-09-01','14:20:00',2.2),('5815','2013-09-01','14:25:00',2.21),('5815','2013-09-01','14:30:00',2.21),('5815','2013-09-01','14:35:00',2.16),('5815','2013-09-01','14:40:00',2.17),('5815','2013-09-01','14:45:00',2.18),('5815','2013-09-01','14:50:00',2.16),('5815','2013-09-01','14:55:00',1.27),('5815','2013-09-01','15:00:00',2.06),('5815','2013-09-01','15:05:00',2.03),('5815','2013-09-01','15:10:00',1.95),('5815','2013-09-01','15:15:00',2.05),('5815','2013-09-01','15:20:00',1.16),('5815','2013-09-01','15:25:00',1.92),('5815','2013-09-01','15:30:00',1.16),('5815','2013-09-01','15:35:00',1),('5815','2013-09-01','15:40:00',1.96),('5815','2013-09-01','15:45:00',1.9),('5815','2013-09-01','15:50:00',1.87),('5815','2013-09-01','15:55:00',1.84),('5815','2013-09-01','16:00:00',1.77),('5815','2013-09-01','16:05:00',1.7),('5815','2013-09-01','16:10:00',1.68),('5815','2013-09-01','16:15:00',1.68),('5815','2013-09-01','16:20:00',1.66),('5815','2013-09-01','16:25:00',1.6),('5815','2013-09-01','16:30:00',1.56),('5815','2013-09-01','16:35:00',1.49),('5815','2013-09-01','16:40:00',1.43),('5815','2013-09-01','16:45:00',1.39),('5815','2013-09-01','16:50:00',1.31),('5815','2013-09-01','16:55:00',1.27),('5815','2013-09-01','17:00:00',1.2),('5815','2013-09-01','17:05:00',1.16),('5815','2013-09-01','17:10:00',1.12),('5815','2013-09-01','17:15:00',1.08),('5815','2013-09-01','17:20:00',1.02),('5815','2013-08-31','09:00:00',1.03),('5815','2013-08-31','09:05:00',1.08),('5815','2013-08-31','09:10:00',1.13),('5815','2013-08-31','09:15:00',1.18),('5815','2013-08-31','09:20:00',1.22),('5815','2013-08-31','09:25:00',1.27),('5815','2013-08-31','09:30:00',1.32),('5815','2013-08-31','09:35:00',1.37),('5815','2013-08-31','09:40:00',1.41),('5815','2013-08-31','09:45:00',1.45),('5815','2013-08-31','09:50:00',1.5),('5815','2013-08-31','09:55:00',1.53),('5815','2013-08-31','10:00:00',1.57),('5815','2013-08-31','10:05:00',1.6),('5815','2013-08-31','10:10:00',1.63),('5815','2013-08-31','10:15:00',1.67),('5815','2013-08-31','10:20:00',1.7),('5815','2013-08-31','10:25:00',1.74),('5815','2013-08-31','10:30:00',1.77),('5815','2013-08-31','10:35:00',1.79),('5815','2013-08-31','10:40:00',1.83),('5815','2013-08-31','10:45:00',1.86),('5815','2013-08-31','10:50:00',1.88),('5815','2013-08-31','10:55:00',1.92),('5815','2013-08-31','11:00:00',1.95),('5815','2013-08-31','11:05:00',1.98),('5815','2013-08-31','11:10:00',2),('5815','2013-08-31','11:15:00',2.01),('5815','2013-08-31','11:20:00',2.02),('5815','2013-08-31','11:25:00',2.04),('5815','2013-08-31','11:30:00',2.08),('5815','2013-08-31','11:35:00',2.09),('5815','2013-08-31','11:40:00',2.12),('5815','2013-08-31','11:45:00',2.14),('5815','2013-08-31','11:50:00',2.16),('5815','2013-08-31','11:55:00',2.18),('5815','2013-08-31','12:00:00',2.19),('5815','2013-08-31','12:05:00',2.15),('5815','2013-08-31','12:10:00',2.18),('5815','2013-08-31','12:15:00',2.2),('5815','2013-08-31','12:20:00',2.24),('5815','2013-08-31','12:25:00',2.2),('5815','2013-08-31','12:30:00',2.24),('5815','2013-08-31','12:35:00',2.23),('5815','2013-08-31','12:40:00',2.24),('5815','2013-08-31','12:45:00',2.23),('5815','2013-08-31','12:50:00',2.23),('5815','2013-08-31','12:55:00',2.23),('5815','2013-08-31','13:00:00',2.25),('5815','2013-08-31','13:05:00',2.23),('5815','2013-08-31','13:10:00',2.25),('5815','2013-08-31','13:15:00',2.18),('5815','2013-08-31','13:20:00',2.28),('5815','2013-08-31','13:25:00',2.27),('5815','2013-08-31','13:30:00',2.29),('5815','2013-08-31','13:35:00',2.28),('5815','2013-08-31','13:40:00',2.27),('5815','2013-08-31','13:45:00',2.2),('5815','2013-08-31','13:50:00',1.93),('5815','2013-08-31','13:55:00',2.07),('5815','2013-08-31','14:00:00',1.77),('5815','2013-08-31','14:05:00',1.78),('5815','2013-08-31','14:10:00',2.03),('5815','2013-08-31','14:15:00',2.08),('5815','2013-08-31','14:20:00',1.85),('5815','2013-08-31','14:25:00',1.89),('5815','2013-08-31','14:30:00',1.94),('5815','2013-08-31','14:35:00',1.94),('5815','2013-08-31','14:40:00',1.94),('5815','2013-08-31','14:45:00',1.98),('5815','2013-08-31','14:50:00',1.96),('5815','2013-08-31','14:55:00',1.9),('5815','2013-08-31','15:00:00',1.9),('5815','2013-08-31','15:05:00',1.89),('5815','2013-08-31','15:10:00',1.86),('5815','2013-08-31','15:15:00',1.78),('5815','2013-08-31','15:20:00',1.71),('5815','2013-08-31','15:25:00',1.58),('5815','2013-08-31','15:30:00',1.29),('5815','2013-08-31','15:35:00',1.44),('5815','2013-08-31','15:40:00',1.63),('5815','2013-08-31','15:45:00',1.54),('5815','2013-08-31','15:50:00',1.21),('5815','2013-08-31','15:55:00',1.26),('5815','2013-08-31','16:00:00',1.51),('5815','2013-08-31','16:05:00',1.55),('5815','2013-08-31','16:10:00',1.65),('5815','2013-08-31','16:15:00',1.59),('5815','2013-08-31','16:20:00',1.54),('5815','2013-08-31','16:25:00',1.47),('5815','2013-08-31','16:30:00',1.61),('5815','2013-08-31','16:35:00',1.53),('5815','2013-08-31','16:40:00',1.49),('5815','2013-08-31','16:45:00',1.41),('5815','2013-08-31','16:50:00',1.33),('5815','2013-08-31','16:55:00',1.21),('5815','2013-08-31','17:00:00',1.01),('5815','2013-08-30','08:50:00',1.01),('5815','2013-08-30','08:55:00',1.11),('5815','2013-08-30','09:00:00',1.17),('5815','2013-08-30','09:05:00',1.07),('5815','2013-08-30','09:15:00',1.08),('5815','2013-08-30','09:20:00',1.24),('5815','2013-08-30','09:25:00',1.36),('5815','2013-08-30','09:30:00',1.39),('5815','2013-08-30','09:35:00',1.45),('5815','2013-08-30','09:40:00',1.48),('5815','2013-08-30','09:45:00',1.4),('5815','2013-08-30','09:50:00',1.43),('5815','2013-08-30','09:55:00',1.56),('5815','2013-08-30','10:00:00',1.64),('5815','2013-08-30','10:05:00',1.62),('5815','2013-08-30','10:10:00',1.71),('5815','2013-08-30','10:15:00',1.71),('5815','2013-08-30','10:20:00',1.75),('5815','2013-08-30','10:25:00',1.78),('5815','2013-08-30','10:30:00',1.81),('5815','2013-08-30','10:35:00',1.87),('5815','2013-08-30','10:40:00',1.88),('5815','2013-08-30','10:45:00',1.92),('5815','2013-08-30','10:50:00',1.97),('5815','2013-08-30','10:55:00',2),('5815','2013-08-30','11:00:00',2.04),('5815','2013-08-30','11:05:00',2.07),('5815','2013-08-30','11:10:00',2.09),('5815','2013-08-30','11:15:00',2.1),('5815','2013-08-30','11:20:00',2.13),('5815','2013-08-30','11:25:00',2.15),('5815','2013-08-30','11:30:00',2.17),('5815','2013-08-30','11:35:00',2.2),('5815','2013-08-30','11:40:00',2.21),('5815','2013-08-30','11:45:00',2.21),('5815','2013-08-30','11:50:00',2.24),('5815','2013-08-30','11:55:00',2.26),('5815','2013-08-30','12:00:00',2.27),('5815','2013-08-30','12:05:00',2.14),('5815','2013-08-30','12:10:00',2.28),('5815','2013-08-30','12:15:00',2.29),('5815','2013-08-30','12:20:00',2.26),('5815','2013-08-30','12:25:00',2.28),('5815','2013-08-30','12:30:00',2.28),('5815','2013-08-30','12:35:00',2.28),('5815','2013-08-30','12:40:00',2.29),('5815','2013-08-30','12:45:00',2.29),('5815','2013-08-30','12:50:00',2.28),('5815','2013-08-30','12:55:00',2.32),('5815','2013-08-30','13:00:00',2.3),('5815','2013-08-30','13:05:00',2.32),('5815','2013-08-30','13:10:00',2.3),('5815','2013-08-30','13:15:00',2.27),('5815','2013-08-30','13:20:00',2.29),('5815','2013-08-30','13:25:00',2.3),('5815','2013-08-30','13:30:00',2.29),('5815','2013-08-30','13:35:00',2.3),('5815','2013-08-30','13:40:00',2.3),('5815','2013-08-30','13:45:00',2.26),('5815','2013-08-30','13:50:00',2.27),('5815','2013-08-30','13:55:00',2.24),('5815','2013-08-30','14:00:00',2.25),('5815','2013-08-30','14:05:00',2.25),('5815','2013-08-30','14:10:00',2.24),('5815','2013-08-30','14:15:00',2.21),('5815','2013-08-30','14:20:00',2.17),('5815','2013-08-30','14:25:00',2.16),('5815','2013-08-30','14:30:00',2.15),('5815','2013-08-30','14:35:00',2.05),('5815','2013-08-30','14:40:00',2.09),('5815','2013-08-30','14:45:00',2.04),('5815','2013-08-30','14:50:00',2.08),('5815','2013-08-30','14:55:00',2.02),('5815','2013-08-30','15:00:00',2.02),('5815','2013-08-30','15:05:00',2.02),('5815','2013-08-30','15:10:00',2),('5815','2013-08-30','15:15:00',1.95),('5815','2013-08-30','15:20:00',1.92),('5815','2013-08-30','15:25:00',1.88),('5815','2013-08-30','15:30:00',1.87),('5815','2013-08-30','15:35:00',1.82),('5815','2013-08-30','15:40:00',1.82),('5815','2013-08-30','15:45:00',1.8),('5815','2013-08-30','15:50:00',1.77),('5815','2013-08-30','15:55:00',1.72),('5815','2013-08-30','16:00:00',1.69),('5815','2013-08-30','16:05:00',1.67),('5815','2013-08-30','16:10:00',1.64),('5815','2013-08-30','16:15:00',1.6),('5815','2013-08-30','16:20:00',1.56),('5815','2013-08-30','16:25:00',1.53),('5815','2013-08-30','16:30:00',1.46),('5815','2013-08-30','16:35:00',1.47),('5815','2013-08-30','16:40:00',1.42),('5815','2013-08-30','16:45:00',1.35),('5815','2013-08-30','16:50:00',1.31),('5815','2013-08-30','16:55:00',1.28),('5815','2013-08-30','17:00:00',1.23),('5815','2013-08-30','17:05:00',1.21),('5815','2013-08-30','17:10:00',1.18),('5815','2013-08-30','17:15:00',1.11),('5815','2013-08-30','17:20:00',1.05),('5815','2013-08-29','09:45:00',1.01),('5815','2013-08-29','09:50:00',1.01),('5815','2013-08-29','09:55:00',1.05),('5815','2013-08-29','10:00:00',1.09),('5815','2013-08-29','10:05:00',1.06),('5815','2013-08-29','10:10:00',1.07),('5815','2013-08-29','10:15:00',1.15),('5815','2013-08-29','10:20:00',1.2),('5815','2013-08-29','10:25:00',1.1),('5815','2013-08-29','10:30:00',1.24),('5815','2013-08-29','10:35:00',1.18),('5815','2013-08-29','10:40:00',1.13),('5815','2013-08-29','10:45:00',1.08),('5815','2013-08-29','10:50:00',1.15),('5815','2013-08-29','10:55:00',1.1),('5815','2013-08-29','11:00:00',1.14),('5815','2013-08-29','11:05:00',1.23),('5815','2013-08-29','11:10:00',1.27),('5815','2013-08-29','11:15:00',1.31),('5815','2013-08-29','11:20:00',1.31),('5815','2013-08-29','11:25:00',1.36),('5815','2013-08-29','11:30:00',1.14),('5815','2013-08-29','11:35:00',1.38),('5815','2013-08-29','11:40:00',1.5),('5815','2013-08-29','11:45:00',1.47),('5815','2013-08-29','11:50:00',1.73),('5815','2013-08-29','11:55:00',1.5),('5815','2013-08-29','12:00:00',1.36),('5815','2013-08-29','12:05:00',1.14),('5815','2013-08-29','12:10:00',1.25),('5815','2013-08-29','12:15:00',1.37),('5815','2013-08-29','12:20:00',1.47),('5815','2013-08-29','12:25:00',1.72),('5815','2013-08-29','12:30:00',1.86),('5815','2013-08-29','12:35:00',1.8),('5815','2013-08-29','12:40:00',1.74),('5815','2013-08-29','12:45:00',1.81),('5815','2013-08-29','12:50:00',1.75),('5815','2013-08-29','12:55:00',1.65),('5815','2013-08-29','13:00:00',1.6),('5815','2013-08-29','13:05:00',1.57),('5815','2013-08-29','13:10:00',1.59),('5815','2013-08-29','13:15:00',1.63),('5815','2013-08-29','13:20:00',1.79),('5815','2013-08-29','13:25:00',2.08),('5815','2013-08-29','13:30:00',2.27),('5815','2013-08-29','13:35:00',2.1),('5815','2013-08-29','13:40:00',2.24),('5815','2013-08-29','13:45:00',2.05),('5815','2013-08-29','13:50:00',2.05),('5815','2013-08-29','13:55:00',2.22),('5815','2013-08-29','14:00:00',2.28),('5815','2013-08-29','14:05:00',2.22),('5815','2013-08-29','14:10:00',2.24),('5815','2013-08-29','14:15:00',2.2),('5815','2013-08-29','14:20:00',2.24),('5815','2013-08-29','14:25:00',2.22),('5815','2013-08-29','14:30:00',2.19),('5815','2013-08-29','14:35:00',2.22),('5815','2013-08-29','14:40:00',2.14),('5815','2013-08-29','14:45:00',1.8),('5815','2013-08-29','14:50:00',1.47),('5815','2013-08-29','14:55:00',1.68),('5815','2013-08-29','15:00:00',1.46),('5815','2013-08-29','15:05:00',1.34),('5815','2013-08-29','15:10:00',1.29),('5815','2013-08-29','15:15:00',1.64),('5815','2013-08-29','15:20:00',1.44),('5815','2013-08-29','15:25:00',1.3),('5815','2013-08-29','15:30:00',1.16),('5815','2013-08-29','15:35:00',1.01),('5815','2013-08-29','15:40:00',1.08),('5815','2013-08-29','15:45:00',1.27),('5815','2013-08-29','15:50:00',1.37),('5815','2013-08-29','15:55:00',1.34),('5815','2013-08-29','16:00:00',1.26),('5815','2013-08-29','16:05:00',1.11),('5815','2013-08-29','16:35:00',1.26),('5815','2013-08-29','16:45:00',1.14),('5815','2013-08-29','16:50:00',1.38),('5815','2013-08-29','16:55:00',1.18),('5815','2013-08-28','11:10:00',1.19),('5815','2013-08-28','11:15:00',1.42),('5815','2013-08-28','11:20:00',1.38),('5815','2013-08-28','11:25:00',1.02),('5815','2013-08-28','11:45:00',1.01),('5815','2013-08-28','11:50:00',1.06),('5815','2013-08-28','11:55:00',1.02),('5815','2013-08-28','12:00:00',1.01),('5815','2013-08-28','12:05:00',1.15),('5815','2013-08-28','12:10:00',1.44),('5815','2013-08-28','12:15:00',1.74),('5815','2013-08-28','12:20:00',1.52),('5815','2013-08-28','12:25:00',1.57),('5815','2013-08-28','12:30:00',1.51),('5815','2013-08-28','12:35:00',1.83),('5815','2013-08-28','12:40:00',2.46),('5815','2013-08-28','12:45:00',2.58),('5815','2013-08-28','12:50:00',1.62),('5815','2013-08-28','12:55:00',1.88),('5815','2013-08-28','13:00:00',1.6),('5815','2013-08-28','13:05:00',1.4),('5815','2013-08-28','13:10:00',1.4),('5815','2013-08-28','13:15:00',1.34),('5815','2013-08-28','13:20:00',1.36),('5815','2013-08-28','13:25:00',1.16),('5815','2013-08-28','13:30:00',1.03),('5815','2013-08-28','14:00:00',1.31),('5815','2013-08-28','15:30:00',1.31),('5815','2013-08-28','15:35:00',1.4),('5815','2013-08-28','15:40:00',1.25),('5815','2013-08-28','15:45:00',1.36),('5815','2013-08-28','15:50:00',1.73),('5815','2013-08-28','15:55:00',2.05),('5815','2013-08-28','16:00:00',2),('5815','2013-08-28','16:05:00',1.95),('5815','2013-08-28','16:10:00',1.96),('5815','2013-08-28','16:15:00',1.8),('5815','2013-08-28','16:20:00',1.72),('5815','2013-08-28','16:25:00',1.66),('5815','2013-08-28','16:30:00',1.57),('5815','2013-08-28','16:35:00',1.57),('5815','2013-08-28','16:40:00',1.52),('5815','2013-08-28','16:45:00',1.47),('5815','2013-08-28','16:50:00',1.43),('5815','2013-08-28','16:55:00',1.38),('5815','2013-08-28','17:00:00',1.32),('5815','2013-08-28','17:05:00',1.29),('5815','2013-08-28','17:10:00',1.23),('5815','2013-08-28','17:15:00',1.19),('5815','2013-08-28','17:20:00',1.13),('5815','2013-08-28','17:25:00',1.08),('5815','2013-08-27','09:35:00',1.41),('5815','2013-08-27','09:40:00',1.47),('5815','2013-08-27','09:45:00',1.5),('5815','2013-08-27','09:50:00',1.54),('5815','2013-08-27','09:55:00',1.55),('5815','2013-08-27','10:00:00',1.57),('5815','2013-08-27','10:05:00',1.63),('5815','2013-08-27','10:15:00',1.74),('5815','2013-08-27','10:20:00',1.81),('5815','2013-08-27','10:25:00',1.25),('5815','2013-08-27','10:30:00',1.39),('5815','2013-08-27','10:35:00',1.18),('5815','2013-08-27','10:40:00',1.78),('5815','2013-08-27','10:45:00',1.41),('5815','2013-08-27','10:50:00',2.01),('5815','2013-08-27','10:55:00',2.07),('5815','2013-08-27','11:00:00',1.7),('5815','2013-08-27','11:05:00',1.19),('5815','2013-08-27','11:10:00',1.41),('5815','2013-08-27','11:15:00',1.93),('5815','2013-08-27','11:20:00',1.86),('5815','2013-08-27','11:25:00',2.25),('5815','2013-08-27','11:30:00',2.29),('5815','2013-08-27','11:35:00',2.27),('5815','2013-08-27','11:40:00',2.43),('5815','2013-08-27','11:45:00',2.03),('5815','2013-08-27','11:50:00',1.14),('5815','2013-08-27','11:55:00',2.01),('5815','2013-08-27','12:00:00',1.02),('5815','2013-08-27','12:05:00',1.95),('5815','2013-08-27','12:10:00',2.41),('5815','2013-08-27','12:15:00',2.47),('5815','2013-08-27','12:20:00',2.41),('5815','2013-08-27','12:25:00',2.32),('5815','2013-08-27','12:30:00',2.41),('5815','2013-08-27','12:35:00',2.4),('5815','2013-08-27','12:40:00',2.37),('5815','2013-08-27','12:45:00',2.5),('5815','2013-08-27','12:50:00',2.49),('5815','2013-08-27','12:55:00',2.45),('5815','2013-08-27','13:00:00',2.47),('5815','2013-08-27','13:05:00',2.16),('5815','2013-08-27','13:10:00',2.38),('5815','2013-08-27','13:15:00',2.5),('5815','2013-08-27','13:20:00',2.48),('5815','2013-08-27','13:25:00',2.51),('5815','2013-08-27','13:30:00',2.51),('5815','2013-08-27','13:35:00',2.46),('5815','2013-08-27','13:40:00',2.48),('5815','2013-08-27','13:45:00',2.35),('5815','2013-08-27','13:50:00',2.36),('5815','2013-08-27','13:55:00',2.41),('5815','2013-08-27','14:00:00',2.21),('5815','2013-08-27','14:05:00',2.45),('5815','2013-08-27','14:10:00',2.26),('5815','2013-08-27','14:15:00',2.45),('5815','2013-08-27','14:20:00',2.39),('5815','2013-08-27','14:25:00',2.39),('5815','2013-08-27','14:30:00',2.2),('5815','2013-08-27','14:35:00',1.87),('5815','2013-08-27','14:40:00',1.77),('5815','2013-08-27','14:45:00',2.38),('5815','2013-08-27','14:50:00',2.26),('5815','2013-08-27','14:55:00',2.28),('5815','2013-08-27','15:00:00',2.25),('5815','2013-08-27','15:05:00',2.24),('5815','2013-08-27','15:10:00',2.25),('5815','2013-08-27','15:15:00',2.21),('5815','2013-08-27','15:20:00',2.19),('5815','2013-08-27','15:25:00',2.14),('5815','2013-08-27','15:30:00',1.5),('5815','2013-08-27','15:35:00',1.42),('5815','2013-08-27','15:40:00',1.62),('5815','2013-08-27','15:45:00',1.07),('5815','2013-08-27','15:50:00',1.8),('5815','2013-08-27','15:55:00',1.46),('5815','2013-08-27','16:00:00',1.9),('5815','2013-08-27','16:05:00',1.82),('5815','2013-08-27','16:10:00',1.98),('5815','2013-08-27','16:15:00',1.85),('5815','2013-08-27','16:25:00',1.88),('5815','2013-08-27','16:30:00',1.75),('5815','2013-08-27','16:35:00',1.44),('5815','2013-08-27','16:40:00',1.66),('5815','2013-08-27','16:45:00',1.57),('5815','2013-08-27','16:50:00',1.49),('5815','2013-08-27','16:55:00',1.3),('5815','2013-08-27','17:00:00',1.42),('5815','2013-08-27','17:05:00',1.33),('5815','2013-08-26','09:25:00',1.14),('5815','2013-08-26','09:30:00',1.26),('5815','2013-08-26','10:00:00',1.07),('5815','2013-08-26','10:05:00',1.3),('5815','2013-08-26','10:10:00',1.58),('5815','2013-08-26','10:15:00',1.64),('5815','2013-08-26','10:20:00',1.72),('5815','2013-08-26','10:25:00',1.75),('5815','2013-08-26','10:30:00',1.77),('5815','2013-08-26','10:35:00',1.82),('5815','2013-08-26','10:40:00',1.8),('5815','2013-08-26','10:45:00',1.86),('5815','2013-08-26','10:50:00',1.88),('5815','2013-08-26','10:55:00',1.89),('5815','2013-08-26','11:00:00',1.92),('5815','2013-08-26','11:05:00',1.97),('5815','2013-08-26','11:10:00',1.97),('5815','2013-08-26','11:15:00',1.97),('5815','2013-08-26','11:20:00',1.91),('5815','2013-08-26','11:25:00',2.01),('5815','2013-08-26','11:30:00',2.04),('5815','2013-08-26','11:35:00',2.07),('5815','2013-08-26','11:40:00',2.03),('5815','2013-08-26','11:45:00',2.3),('5815','2013-08-26','11:50:00',2.13),('5815','2013-08-26','11:55:00',2.19),('5815','2013-08-26','12:00:00',2.31),('5815','2013-08-26','12:05:00',2.32),('5815','2013-08-26','12:10:00',1.95),('5815','2013-08-26','12:15:00',1.97),('5815','2013-08-26','12:20:00',2.18),('5815','2013-08-26','12:25:00',2.05),('5815','2013-08-26','12:30:00',2.24),('5815','2013-08-26','12:35:00',2.36),('5815','2013-08-26','12:40:00',2.19),('5815','2013-08-26','12:45:00',1.82),('5815','2013-08-26','12:50:00',1.39),('5815','2013-08-26','12:55:00',1.25),('5815','2013-08-26','13:10:00',1.37),('5815','2013-08-26','13:15:00',1.02),('5815','2013-08-26','13:20:00',1.05),('5815','2013-08-26','13:25:00',1.1),('5815','2013-08-26','13:30:00',1.42),('5815','2013-08-26','13:35:00',1.07),('5815','2013-08-26','13:40:00',1.07),('5815','2013-08-26','13:45:00',1.18),('5815','2013-08-26','13:50:00',2.31),('5815','2013-08-26','13:55:00',1.84),('5815','2013-08-26','14:00:00',2.04),('5815','2013-08-26','14:05:00',1.27),('5815','2013-08-26','14:10:00',1.16),('5815','2013-08-26','14:15:00',1.99),('5815','2013-08-26','14:20:00',1.49),('5815','2013-08-26','16:10:00',1.76),('5815','2013-08-26','16:15:00',1.88),('5815','2013-08-26','16:25:00',1.04),('5815','2013-08-26','17:10:00',1.45),('5815','2013-08-25','09:00:00',1.03),('5815','2013-08-25','09:05:00',1.07),('5815','2013-08-25','09:10:00',1.13),('5815','2013-08-25','09:15:00',1.17),('5815','2013-08-25','09:20:00',1.22),('5815','2013-08-25','09:25:00',1.26),('5815','2013-08-25','09:30:00',1.31),('5815','2013-08-25','09:35:00',1.36),('5815','2013-08-25','09:40:00',1.4),('5815','2013-08-25','09:45:00',1.44),('5815','2013-08-25','09:50:00',1.48),('5815','2013-08-25','09:55:00',1.51),('5815','2013-08-25','10:00:00',1.54),('5815','2013-08-25','10:05:00',1.59),('5815','2013-08-25','10:10:00',1.62),('5815','2013-08-25','10:15:00',1.65),('5815','2013-08-25','10:20:00',1.7),('5815','2013-08-25','10:25:00',1.75),('5815','2013-08-25','10:30:00',1.78),('5815','2013-08-25','10:35:00',1.81),('5815','2013-08-25','10:40:00',1.83),('5815','2013-08-25','10:45:00',1.87),('5815','2013-08-25','10:50:00',1.89),('5815','2013-08-25','10:55:00',1.95),('5815','2013-08-25','11:00:00',1.98),('5815','2013-08-25','11:05:00',2),('5815','2013-08-25','11:10:00',2.01),('5815','2013-08-25','11:15:00',2),('5815','2013-08-25','11:20:00',2.06),('5815','2013-08-25','11:25:00',2.08),('5815','2013-08-25','11:30:00',2.08),('5815','2013-08-25','11:35:00',2.13),('5815','2013-08-25','11:40:00',2.15),('5815','2013-08-25','11:45:00',2.15),('5815','2013-08-25','11:50:00',2.15),('5815','2013-08-25','11:55:00',2.16),('5815','2013-08-25','12:00:00',2.19),('5815','2013-08-25','12:05:00',2.2),('5815','2013-08-25','12:10:00',2.22),('5815','2013-08-25','12:15:00',2.23),('5815','2013-08-25','12:20:00',2.24),('5815','2013-08-25','12:25:00',2.23),('5815','2013-08-25','12:30:00',2.2),('5815','2013-08-25','12:35:00',2.22),('5815','2013-08-25','12:40:00',2.24),('5815','2013-08-25','12:45:00',2.27),('5815','2013-08-25','12:50:00',2.29),('5815','2013-08-25','12:55:00',1.82),('5815','2013-08-25','13:00:00',2.4),('5815','2013-08-25','13:05:00',2.64),('5815','2013-08-25','13:10:00',2.39),('5815','2013-08-25','13:15:00',1.61),('5815','2013-08-25','13:20:00',1.81),('5815','2013-08-25','13:25:00',1.61),('5815','2013-08-25','13:30:00',1.66),('5815','2013-08-25','13:35:00',2.25),('5815','2013-08-25','13:40:00',2.31),('5815','2013-08-25','13:45:00',2.32),('5815','2013-08-25','13:50:00',2.42),('5815','2013-08-25','13:55:00',1.9),('5815','2013-08-25','14:00:00',1.81),('5815','2013-08-25','14:05:00',2.28),('5815','2013-08-25','14:10:00',1.41),('5815','2013-08-25','14:15:00',2.35),('5815','2013-08-25','14:20:00',2.25),('5815','2013-08-25','14:25:00',2.21),('5815','2013-08-25','14:30:00',2.2),('5815','2013-08-25','14:35:00',2.15),('5815','2013-08-25','14:40:00',1.97),('5815','2013-08-25','14:45:00',1.6),('5815','2013-08-25','14:50:00',1.28),('5815','2013-08-25','14:55:00',1.15),('5815','2013-08-25','15:00:00',1.09),('5815','2013-08-25','16:00:00',1.17),('5815','2013-08-25','16:05:00',1.96),('5815','2013-08-25','16:10:00',1.74),('5815','2013-08-25','16:15:00',1.62),('5815','2013-08-25','16:20:00',1.63),('5815','2013-08-25','16:25:00',1.56),('5815','2013-08-25','16:30:00',1.52),('5815','2013-08-25','16:35:00',1.49),('5815','2013-08-25','16:40:00',1.46),('5815','2013-08-25','16:45:00',1.42),('5815','2013-08-25','16:50:00',1.33),('5815','2013-08-25','16:55:00',1.29),('5815','2013-08-25','17:00:00',1.27),('5815','2013-08-25','17:05:00',1.16),('5815','2013-08-25','17:10:00',1.15),('5815','2013-08-25','17:15:00',1.11),('5815','2013-08-24','09:20:00',1.08),('5815','2013-08-24','09:25:00',1.06),('5815','2013-08-24','09:30:00',1.2),('5815','2013-08-24','09:35:00',1.06),('5815','2013-08-24','09:40:00',1.6),('5815','2013-08-24','09:45:00',1.74),('5815','2013-08-24','09:50:00',1.63),('5815','2013-08-24','09:55:00',1.81),('5815','2013-08-24','10:00:00',1.34),('5815','2013-08-24','15:30:00',1.24),('5815','2013-08-24','15:35:00',1.88),('5815','2013-08-24','15:40:00',2.05),('5815','2013-08-24','15:45:00',2.11),('5815','2013-08-24','15:50:00',1.82),('5815','2013-08-24','15:55:00',1.06),('5815','2013-08-24','16:00:00',2.05),('5815','2013-08-24','16:05:00',1.92),('5815','2013-08-24','16:10:00',1.83),('5815','2013-08-24','16:15:00',1.77),('5815','2013-08-24','16:20:00',1.72),('5815','2013-08-24','16:25:00',1.68),('5815','2013-08-24','16:30:00',1.63),('5815','2013-08-24','16:35:00',1.57),('5815','2013-08-24','16:40:00',1.26),('5815','2013-08-24','16:50:00',1.13),('5815','2013-08-24','16:55:00',1.6),('5815','2013-08-24','17:00:00',1.45),('5815','2013-08-24','17:05:00',1.37),('5815','2013-08-24','17:10:00',1.31),('5815','2013-08-24','17:15:00',1.21),('5815','2013-08-24','17:20:00',1.15),('5815','2013-08-24','17:25:00',1.09),('5815','2013-08-24','17:30:00',1.02),('5815','2013-08-23','09:00:00',1.03),('5815','2013-08-23','09:05:00',1.06),('5815','2013-08-23','09:10:00',1.16),('5815','2013-08-23','09:15:00',1.03),('5815','2013-08-23','09:20:00',1.22),('5815','2013-08-23','09:25:00',1.05),('5815','2013-08-23','09:30:00',1.02),('5815','2013-08-23','09:40:00',1.45),('5815','2013-08-23','09:50:00',1.22),('5815','2013-08-23','09:55:00',1.26),('5815','2013-08-23','10:00:00',1.61),('5815','2013-08-23','10:05:00',1.62),('5815','2013-08-23','10:10:00',1.66),('5815','2013-08-23','10:15:00',1.68),('5815','2013-08-23','10:20:00',1.71),('5815','2013-08-23','10:25:00',1.73),('5815','2013-08-23','10:30:00',1.75),('5815','2013-08-23','10:35:00',1.78),('5815','2013-08-23','10:40:00',1.84),('5815','2013-08-23','10:45:00',1.87),('5815','2013-08-23','10:50:00',1.73),('5815','2013-08-23','10:55:00',1.68),('5815','2013-08-23','11:00:00',1.96),('5815','2013-08-23','11:05:00',1.98),('5815','2013-08-23','11:10:00',2.02),('5815','2013-08-23','11:15:00',2.03),('5815','2013-08-23','11:20:00',2.07),('5815','2013-08-23','11:25:00',2.08),('5815','2013-08-23','11:30:00',2.06),('5815','2013-08-23','11:35:00',2.12),('5815','2013-08-23','11:40:00',2.13),('5815','2013-08-23','11:45:00',2.14),('5815','2013-08-23','11:50:00',2.18),('5815','2013-08-23','11:55:00',2.17),('5815','2013-08-23','12:00:00',2.14),('5815','2013-08-23','12:05:00',2.17),('5815','2013-08-23','12:10:00',2.2),('5815','2013-08-23','12:15:00',2.24),('5815','2013-08-23','12:20:00',2.24),('5815','2013-08-23','12:25:00',2.25),('5815','2013-08-23','12:30:00',2.24),('5815','2013-08-23','12:35:00',2.25),('5815','2013-08-23','12:40:00',2.26),('5815','2013-08-23','12:45:00',2.27),('5815','2013-08-23','12:50:00',2.28),('5815','2013-08-23','12:55:00',2.26),('5815','2013-08-23','13:00:00',2.24),('5815','2013-08-23','13:05:00',2.27),('5815','2013-08-23','13:10:00',2.3),('5815','2013-08-23','13:15:00',2.29),('5815','2013-08-23','13:20:00',2.3),('5815','2013-08-23','13:25:00',2.32),('5815','2013-08-23','13:30:00',2.33),('5815','2013-08-23','13:35:00',2.32),('5815','2013-08-23','13:40:00',2.31),('5815','2013-08-23','13:45:00',2.3),('5815','2013-08-23','13:50:00',2.32),('5815','2013-08-23','13:55:00',2.29),('5815','2013-08-23','14:00:00',2.27),('5815','2013-08-23','14:05:00',2.27),('5815','2013-08-23','14:10:00',2.27),('5815','2013-08-23','14:15:00',2.25),('5815','2013-08-23','14:20:00',2.25),('5815','2013-08-23','14:25:00',2.22),('5815','2013-08-23','14:30:00',2.21),('5815','2013-08-23','14:35:00',2.21),('5815','2013-08-23','14:40:00',2.18),('5815','2013-08-23','14:45:00',2.12),('5815','2013-08-23','14:50:00',2.14),('5815','2013-08-23','14:55:00',2.13),('5815','2013-08-23','15:00:00',2.1),('5815','2013-08-23','15:05:00',2.09),('5815','2013-08-23','15:10:00',2.07),('5815','2013-08-23','15:15:00',2.04),('5815','2013-08-23','15:20:00',2),('5815','2013-08-23','15:25:00',1.98),('5815','2013-08-23','15:30:00',1.96),('5815','2013-08-23','15:35:00',1.93),('5815','2013-08-23','15:40:00',1.89),('5815','2013-08-23','15:45:00',1.86),('5815','2013-08-23','15:50:00',1.83),('5815','2013-08-23','15:55:00',1.8),('5815','2013-08-23','16:00:00',1.77),('5815','2013-08-23','16:05:00',1.75),('5815','2013-08-23','16:10:00',1.72),('5815','2013-08-23','16:15:00',1.67),('5815','2013-08-23','16:20:00',1.64),('5815','2013-08-23','16:25:00',1.6),('5815','2013-08-23','16:30:00',1.55),('5815','2013-08-23','16:35:00',1.52),('5815','2013-08-23','16:40:00',1.48),('5815','2013-08-23','16:45:00',1.43),('5815','2013-08-23','16:50:00',1.39),('5815','2013-08-23','16:55:00',1.36),('5815','2013-08-23','17:00:00',1.29),('5815','2013-08-23','17:05:00',1.26),('5815','2013-08-23','17:10:00',1.22),('5815','2013-08-23','17:15:00',1.18),('5815','2013-08-23','17:20:00',1.13),('5815','2013-08-23','17:25:00',1.08),('5815','2013-08-23','17:30:00',1.02),('5815','2013-08-22','09:10:00',1),('5815','2013-08-22','09:15:00',1.05),('5815','2013-08-22','09:20:00',1.1),('5815','2013-08-22','09:25:00',1.14),('5815','2013-08-22','09:30:00',1.18),('5815','2013-08-22','09:35:00',1.22),('5815','2013-08-22','09:40:00',1.24),('5815','2013-08-22','09:45:00',1.28),('5815','2013-08-22','09:50:00',1.33),('5815','2013-08-22','09:55:00',1.36),('5815','2013-08-22','10:00:00',1.41),('5815','2013-08-22','10:05:00',1.44),('5815','2013-08-22','10:10:00',1.45),('5815','2013-08-22','10:15:00',1.5),('5815','2013-08-22','10:20:00',1.55),('5815','2013-08-22','10:25:00',1.58),('5815','2013-08-22','10:30:00',1.59),('5815','2013-08-22','10:35:00',1.64),('5815','2013-08-22','10:40:00',1.64),('5815','2013-08-22','10:45:00',1.69),('5815','2013-08-22','10:50:00',1.71),('5815','2013-08-22','10:55:00',1.71),('5815','2013-08-22','11:00:00',1.75),('5815','2013-08-22','11:05:00',1.84),('5815','2013-08-22','11:10:00',1.85),('5815','2013-08-22','11:15:00',1.58),('5815','2013-08-22','11:20:00',1.3),('5815','2013-08-22','11:25:00',1.73),('5815','2013-08-22','11:30:00',2.03),('5815','2013-08-22','11:35:00',1.51),('5815','2013-08-22','11:40:00',1.41),('5815','2013-08-22','11:45:00',1.9),('5815','2013-08-22','11:50:00',2.03),('5815','2013-08-22','11:55:00',2.06),('5815','2013-08-22','12:00:00',1.74),('5815','2013-08-22','12:05:00',1.35),('5815','2013-08-22','12:15:00',1.02),('5815','2013-08-22','13:15:00',1.41),('5815','2013-08-22','13:25:00',1.48),('5815','2013-08-22','13:30:00',2.46),('5815','2013-08-22','13:35:00',2.17),('5815','2013-08-22','13:40:00',1.63),('5815','2013-08-22','13:45:00',2.24),('5815','2013-08-22','13:50:00',1.37),('5815','2013-08-22','13:55:00',1.9),('5815','2013-08-22','14:00:00',2.5),('5815','2013-08-22','14:05:00',2.35),('5815','2013-08-22','14:10:00',2.33),('5815','2013-08-22','14:15:00',2.34),('5815','2013-08-22','14:20:00',1.98),('5815','2013-08-22','14:25:00',1.88),('5815','2013-08-22','14:30:00',2.14),('5815','2013-08-22','14:35:00',2.23),('5815','2013-08-22','14:40:00',2.22),('5815','2013-08-22','14:45:00',2.17),('5815','2013-08-22','14:50:00',2.12),('5815','2013-08-22','14:55:00',2.04),('5815','2013-08-22','15:00:00',1.99),('5815','2013-08-22','15:05:00',1.93),('5815','2013-08-22','15:10:00',1.97),('5815','2013-08-22','15:15:00',1.99),('5815','2013-08-22','15:20:00',1.95),('5815','2013-08-22','15:25:00',1.96),('5815','2013-08-22','15:30:00',2.02),('5815','2013-08-22','15:35:00',1.88),('5815','2013-08-22','15:40:00',1.85),('5815','2013-08-22','15:45:00',1.85),('5815','2013-08-22','15:50:00',1.73),('5815','2013-08-22','15:55:00',1.77),('5815','2013-08-22','16:00:00',1.7),('5815','2013-08-22','16:05:00',1.61),('5815','2013-08-22','16:10:00',1.38),('5815','2013-08-22','16:15:00',1.46),('5815','2013-08-22','16:20:00',1.7),('5815','2013-08-22','16:25:00',1.53),('5815','2013-08-22','16:30:00',1.49),('5815','2013-08-22','16:35:00',1.57),('5815','2013-08-22','16:40:00',1.54),('5815','2013-08-22','16:45:00',1.48),('5815','2013-08-22','16:50:00',1.43),('5815','2013-08-22','16:55:00',1.36),('5815','2013-08-22','17:00:00',1.31),('5815','2013-08-22','17:05:00',1.24),('5815','2013-08-22','17:10:00',1.19),('5815','2013-08-22','17:15:00',1.13),('5815','2013-08-22','17:20:00',1.08),('5815','2013-08-22','17:25:00',1.03),('5815','2013-08-21','09:00:00',1),('5815','2013-08-21','09:05:00',1.09),('5815','2013-08-21','09:10:00',1.15),('5815','2013-08-21','09:15:00',1.21),('5815','2013-08-21','09:20:00',1.29),('5815','2013-08-21','09:25:00',1.23),('5815','2013-08-21','09:30:00',1.05),('5815','2013-08-21','09:45:00',1.01),('5815','2013-08-21','09:50:00',1.19),('5815','2013-08-21','09:55:00',1.37),('5815','2013-08-21','10:00:00',1.62),('5815','2013-08-21','10:05:00',1.63),('5815','2013-08-21','10:10:00',1.65),('5815','2013-08-21','10:15:00',1.64),('5815','2013-08-21','10:20:00',1.65),('5815','2013-08-21','10:25:00',1.68),('5815','2013-08-21','10:30:00',1.71),('5815','2013-08-21','10:35:00',1.73),('5815','2013-08-21','10:40:00',1.77),('5815','2013-08-21','10:45:00',1.79),('5815','2013-08-21','10:50:00',1.81),('5815','2013-08-21','10:55:00',1.84),('5815','2013-08-21','11:00:00',1.86),('5815','2013-08-21','11:05:00',1.88),('5815','2013-08-21','11:10:00',1.91),('5815','2013-08-21','11:15:00',1.93),('5815','2013-08-21','11:20:00',1.94),('5815','2013-08-21','11:25:00',1.96),('5815','2013-08-21','11:30:00',1.99),('5815','2013-08-21','11:35:00',2.01),('5815','2013-08-21','11:40:00',2.03),('5815','2013-08-21','11:45:00',2.04),('5815','2013-08-21','11:50:00',2.05),('5815','2013-08-21','11:55:00',2.07),('5815','2013-08-21','12:00:00',2.08),('5815','2013-08-21','12:05:00',2.09),('5815','2013-08-21','12:10:00',2.1),('5815','2013-08-21','12:15:00',2.11),('5815','2013-08-21','12:20:00',2.13),('5815','2013-08-21','12:25:00',2.12),('5815','2013-08-21','12:30:00',2.13),('5815','2013-08-21','12:35:00',2.14),('5815','2013-08-21','12:40:00',2.15),('5815','2013-08-21','12:45:00',2.16),('5815','2013-08-21','12:50:00',2.16),('5815','2013-08-21','12:55:00',2.16),('5815','2013-08-21','13:00:00',2.02),('5815','2013-08-21','13:05:00',2.05),('5815','2013-08-21','13:10:00',2.09),('5815','2013-08-21','13:15:00',2.1),('5815','2013-08-21','13:20:00',2.08),('5815','2013-08-21','13:25:00',2.12),('5815','2013-08-21','13:30:00',2.12),('5815','2013-08-21','13:35:00',2.13),('5815','2013-08-21','13:40:00',2.14),('5815','2013-08-21','13:45:00',2.15),('5815','2013-08-21','13:50:00',2.14),('5815','2013-08-21','13:55:00',2.12),('5815','2013-08-21','14:00:00',2.11),('5815','2013-08-21','14:05:00',2.12),('5815','2013-08-21','14:10:00',2.12),('5815','2013-08-21','14:15:00',2.11),('5815','2013-08-21','14:20:00',2.12),('5815','2013-08-21','14:25:00',2.14),('5815','2013-08-21','14:30:00',2.09),('5815','2013-08-21','14:35:00',2.09),('5815','2013-08-21','14:40:00',1.84),('5815','2013-08-21','14:45:00',2.07),('5815','2013-08-21','14:50:00',2.03),('5815','2013-08-21','14:55:00',1.79),('5815','2013-08-21','15:00:00',1.98),('5815','2013-08-21','15:05:00',1.99),('5815','2013-08-21','15:10:00',1.97),('5815','2013-08-21','15:15:00',1.97),('5815','2013-08-21','15:20:00',1.93),('5815','2013-08-21','15:25:00',1.89),('5815','2013-08-21','15:30:00',1.89),('5815','2013-08-21','15:35:00',1.85),('5815','2013-08-21','15:40:00',1.84),('5815','2013-08-21','15:45:00',1.81),('5815','2013-08-21','15:50:00',1.78),('5815','2013-08-21','15:55:00',1.75),('5815','2013-08-21','16:00:00',1.72),('5815','2013-08-21','16:05:00',1.65),('5815','2013-08-21','16:10:00',1.63),('5815','2013-08-21','16:15:00',1.6),('5815','2013-08-21','16:20:00',1.55),('5815','2013-08-21','16:25:00',1.53),('5815','2013-08-21','16:30:00',1.49),('5815','2013-08-21','16:35:00',1.46),('5815','2013-08-21','16:40:00',1.41),('5815','2013-08-21','16:45:00',1.35),('5815','2013-08-21','16:50:00',1.31),('5815','2013-08-21','16:55:00',1.27),('5815','2013-08-21','17:00:00',1.22),('5815','2013-08-21','17:05:00',1.19),('5815','2013-08-21','17:10:00',1.13),('5815','2013-08-21','17:15:00',1.07),('5815','2013-08-21','17:20:00',1.03),('5815','2013-08-20','09:15:00',1.26),('5815','2013-08-20','09:20:00',1.43),('5815','2013-08-20','09:50:00',1.66),('5815','2013-08-20','09:55:00',1.92),('5815','2013-08-20','10:00:00',1.79),('5815','2013-08-20','10:05:00',1.38),('5815','2013-08-20','10:10:00',1.22),('5815','2013-08-20','10:15:00',1.48),('5815','2013-08-20','10:20:00',1.08),('5815','2013-08-20','10:25:00',1.05),('5815','2013-08-20','10:30:00',1.01),('5815','2013-08-20','10:35:00',1.89),('5815','2013-08-20','10:40:00',1.7),('5815','2013-08-20','10:45:00',1.56),('5815','2013-08-20','10:50:00',1.37),('5815','2013-08-20','10:55:00',1.03),('5815','2013-08-20','11:00:00',1.29),('5815','2013-08-20','11:05:00',1.1),('5815','2013-08-20','11:15:00',1.27),('5815','2013-08-20','11:20:00',2.01),('5815','2013-08-20','11:25:00',1.57),('5815','2013-08-20','11:30:00',1.55),('5815','2013-08-20','11:35:00',2.17),('5815','2013-08-20','11:40:00',2.27),('5815','2013-08-20','11:45:00',2.27),('5815','2013-08-20','11:50:00',1.83),('5815','2013-08-20','11:55:00',2.12),('5815','2013-08-20','12:00:00',2.31),('5815','2013-08-20','12:05:00',2.31),('5815','2013-08-20','12:10:00',2.3),('5815','2013-08-20','12:15:00',2.27),('5815','2013-08-20','12:20:00',2.25),('5815','2013-08-20','12:25:00',1.48),('5815','2013-08-20','12:30:00',2.28),('5815','2013-08-20','12:35:00',2.09),('5815','2013-08-20','12:40:00',2.05),('5815','2013-08-20','12:45:00',2.23),('5815','2013-08-20','12:50:00',2.15),('5815','2013-08-20','12:55:00',2.07),('5815','2013-08-20','13:00:00',2.14),('5815','2013-08-20','13:05:00',2.19),('5815','2013-08-20','13:10:00',2.22),('5815','2013-08-20','13:15:00',2.24),('5815','2013-08-20','13:20:00',2.24),('5815','2013-08-20','13:25:00',2.26),('5815','2013-08-20','13:30:00',2.24),('5815','2013-08-20','13:35:00',2.23),('5815','2013-08-20','13:40:00',2.25),('5815','2013-08-20','13:45:00',2.19),('5815','2013-08-20','13:50:00',2.13),('5815','2013-08-20','13:55:00',2.12),('5815','2013-08-20','14:00:00',2.21),('5815','2013-08-20','14:05:00',2.18),('5815','2013-08-20','14:10:00',2.2),('5815','2013-08-20','14:15:00',2.23),('5815','2013-08-20','14:20:00',2.13),('5815','2013-08-20','14:25:00',1.76),('5815','2013-08-20','14:30:00',1.95),('5815','2013-08-20','14:35:00',1.9),('5815','2013-08-20','14:40:00',1.94),('5815','2013-08-20','14:45:00',1.96),('5815','2013-08-20','14:50:00',1.9),('5815','2013-08-20','14:55:00',1.87),('5815','2013-08-20','15:00:00',1.89),('5815','2013-08-20','15:05:00',1.95),('5815','2013-08-20','15:10:00',1.89),('5815','2013-08-20','15:15:00',1.84),('5815','2013-08-20','15:20:00',1.83),('5815','2013-08-20','15:25:00',1.85),('5815','2013-08-20','15:30:00',1.75),('5815','2013-08-20','15:35:00',1.68),('5815','2013-08-20','15:40:00',1.6),('5815','2013-08-20','15:45:00',1.65),('5815','2013-08-20','15:50:00',1.69),('5815','2013-08-20','15:55:00',1.54),('5815','2013-08-20','16:00:00',1.46),('5815','2013-08-20','16:05:00',1.47),('5815','2013-08-20','16:10:00',1.41),('5815','2013-08-20','16:15:00',1.47),('5815','2013-08-20','16:20:00',1.5),('5815','2013-08-20','16:25:00',1.48),('5815','2013-08-20','16:30:00',1.54),('5815','2013-08-20','16:35:00',1.48),('5815','2013-08-20','16:40:00',1.45),('5815','2013-08-20','16:45:00',1.41),('5815','2013-08-20','16:50:00',1.36),('5815','2013-08-20','16:55:00',1.33),('5815','2013-08-20','17:00:00',1.3),('5815','2013-08-20','17:05:00',1.26),('5815','2013-08-20','17:10:00',1.23),('5815','2013-08-20','17:15:00',1.21),('5815','2013-08-20','17:20:00',1.19),('5815','2013-08-20','17:25:00',1.15),('5815','2013-08-20','17:30:00',1.08),('5815','2013-08-20','17:35:00',1.05),('5815','2013-08-19','09:30:00',1.3),('5815','2013-08-19','09:35:00',1.34),('5815','2013-08-19','09:40:00',1.58),('5815','2013-08-19','09:45:00',1.69),('5815','2013-08-19','09:50:00',1.59),('5815','2013-08-19','09:55:00',1.04),('5815','2013-08-19','10:00:00',1.93),('5815','2013-08-19','10:05:00',1.01),('5815','2013-08-19','10:10:00',1.04),('5815','2013-08-19','10:15:00',1.43),('5815','2013-08-19','10:50:00',1.19),('5815','2013-08-19','10:55:00',1.58),('5815','2013-08-19','11:20:00',2.28),('5815','2013-08-19','11:25:00',2.25),('5815','2013-08-19','11:30:00',1.06),('5815','2013-08-19','11:40:00',1.87),('5815','2013-08-19','11:45:00',2.38),('5815','2013-08-19','11:50:00',1.64),('5815','2013-08-19','11:55:00',2.53),('5815','2013-08-19','12:00:00',1.36),('5815','2013-08-19','12:50:00',1.06),('5815','2013-08-19','12:55:00',1.03),('5815','2013-08-19','13:30:00',1.08),('5815','2013-08-19','13:35:00',1.38),('5815','2013-08-19','13:40:00',2.17),('5815','2013-08-19','13:45:00',2.13),('5815','2013-08-19','13:50:00',2.45),('5815','2013-08-19','13:55:00',2.42),('5815','2013-08-19','14:00:00',2.38),('5815','2013-08-19','14:05:00',2.37),('5815','2013-08-19','14:10:00',2.33),('5815','2013-08-19','14:15:00',2.31),('5815','2013-08-19','14:20:00',2.3),('5815','2013-08-19','14:25:00',2.22),('5815','2013-08-19','14:30:00',1.79),('5815','2013-08-19','14:35:00',2.1),('5815','2013-08-19','14:40:00',2.12),('5815','2013-08-19','14:45:00',2.12),('5815','2013-08-19','14:50:00',2.28),('5815','2013-08-19','14:55:00',1.91),('5815','2013-08-19','15:00:00',2.31),('5815','2013-08-19','15:05:00',2.19),('5815','2013-08-19','15:10:00',2.28),('5815','2013-08-19','15:15:00',2.17),('5815','2013-08-19','15:20:00',2.19),('5815','2013-08-19','15:25:00',2.18),('5815','2013-08-19','15:30:00',2.15),('5815','2013-08-19','15:35:00',2.14),('5815','2013-08-19','15:40:00',2.17),('5815','2013-08-19','15:45:00',2.23),('5815','2013-08-19','15:50:00',2.22),('5815','2013-08-19','15:55:00',2.34),('5815','2013-08-19','16:00:00',2.19),('5815','2013-08-19','16:05:00',2.09),('5815','2013-08-19','16:10:00',2.13),('5815','2013-08-19','16:15:00',2.08),('5815','2013-08-19','16:20:00',2.05),('5815','2013-08-19','16:25:00',1.9),('5815','2013-08-19','16:30:00',1.72),('5815','2013-08-19','16:35:00',1.81),('5815','2013-08-19','16:40:00',1.86),('5815','2013-08-19','16:45:00',1.76),('5815','2013-08-19','16:50:00',1.57),('5815','2013-08-19','16:55:00',1.54),('5815','2013-08-19','17:00:00',1.46),('5815','2013-08-19','17:05:00',1.36),('5815','2013-08-19','17:10:00',1.29),('5815','2013-08-19','17:15:00',1.23),('5815','2013-08-19','17:20:00',1.21),('5815','2013-08-19','17:25:00',1.14),('5815','2013-08-19','17:30:00',1.09),('5815','2013-08-19','17:35:00',1.05),('5815','2013-08-18','09:00:00',1.04),('5815','2013-08-18','09:05:00',1.08),('5815','2013-08-18','09:10:00',1.12),('5815','2013-08-18','09:15:00',1.17),('5815','2013-08-18','09:20:00',1.22),('5815','2013-08-18','09:25:00',1.26),('5815','2013-08-18','09:30:00',1.3),('5815','2013-08-18','09:35:00',1.35),('5815','2013-08-18','09:40:00',1.39),('5815','2013-08-18','09:45:00',1.43),('5815','2013-08-18','09:50:00',1.46),('5815','2013-08-18','09:55:00',1.5),('5815','2013-08-18','10:00:00',1.54),('5815','2013-08-18','10:05:00',1.57),('5815','2013-08-18','10:10:00',1.61),('5815','2013-08-18','10:15:00',1.65),('5815','2013-08-18','10:20:00',1.68),('5815','2013-08-18','10:25:00',1.69),('5815','2013-08-18','10:30:00',1.73),('5815','2013-08-18','10:35:00',1.75),('5815','2013-08-18','10:40:00',1.79),('5815','2013-08-18','10:45:00',1.82),('5815','2013-08-18','10:50:00',1.86),('5815','2013-08-18','10:55:00',1.89),('5815','2013-08-18','11:00:00',1.9),('5815','2013-08-18','11:05:00',1.92),('5815','2013-08-18','11:10:00',1.95),('5815','2013-08-18','11:15:00',1.97),('5815','2013-08-18','11:20:00',1.98),('5815','2013-08-18','11:25:00',2),('5815','2013-08-18','11:30:00',2.02),('5815','2013-08-18','11:35:00',2.04),('5815','2013-08-18','11:40:00',2.05),('5815','2013-08-18','11:45:00',2.06),('5815','2013-08-18','11:50:00',2.1),('5815','2013-08-18','11:55:00',2.09),('5815','2013-08-18','12:00:00',2.09),('5815','2013-08-18','12:05:00',2.1),('5815','2013-08-18','12:10:00',2.16),('5815','2013-08-18','12:15:00',2.16),('5815','2013-08-18','12:20:00',2.19),('5815','2013-08-18','12:25:00',2.19),('5815','2013-08-18','12:30:00',2.2),('5815','2013-08-18','12:35:00',2.2),('5815','2013-08-18','12:40:00',2.22),('5815','2013-08-18','12:45:00',2.22),('5815','2013-08-18','12:50:00',2.23),('5815','2013-08-18','12:55:00',2.24),('5815','2013-08-18','13:00:00',2.26),('5815','2013-08-18','13:05:00',2.26),('5815','2013-08-18','13:10:00',2.27),('5815','2013-08-18','13:15:00',2.26),('5815','2013-08-18','13:20:00',2.28),('5815','2013-08-18','13:25:00',2.27),('5815','2013-08-18','13:30:00',2.3),('5815','2013-08-18','13:35:00',2.29),('5815','2013-08-18','13:40:00',2.29),('5815','2013-08-18','13:45:00',2.28),('5815','2013-08-18','13:50:00',2.27),('5815','2013-08-18','13:55:00',2.27),('5815','2013-08-18','14:00:00',2.27),('5815','2013-08-18','14:05:00',2.25),('5815','2013-08-18','14:10:00',2.24),('5815','2013-08-18','14:15:00',2.22),('5815','2013-08-18','14:20:00',2.23),('5815','2013-08-18','14:25:00',2.23),('5815','2013-08-18','14:30:00',2.24),('5815','2013-08-18','14:35:00',2.22),('5815','2013-08-18','14:40:00',2.17),('5815','2013-08-18','14:45:00',2.19),('5815','2013-08-18','14:50:00',2.17),('5815','2013-08-18','14:55:00',2.15),('5815','2013-08-18','15:00:00',2.14),('5815','2013-08-18','15:05:00',2.13),('5815','2013-08-18','15:10:00',2.11),('5815','2013-08-18','15:15:00',2.08),('5815','2013-08-18','15:20:00',2.05),('5815','2013-08-18','15:25:00',2.03),('5815','2013-08-18','15:30:00',2.01),('5815','2013-08-18','15:35:00',1.98),('5815','2013-08-18','15:40:00',1.96),('5815','2013-08-18','15:45:00',1.93),('5815','2013-08-18','15:50:00',1.9),('5815','2013-08-18','15:55:00',1.88),('5815','2013-08-18','16:00:00',1.85),('5815','2013-08-18','16:05:00',1.79),('5815','2013-08-18','16:10:00',1.74),('5815','2013-08-18','16:15:00',1.68),('5815','2013-08-18','16:20:00',1.68),('5815','2013-08-18','16:25:00',1.66),('5815','2013-08-18','16:30:00',1.61),('5815','2013-08-18','16:35:00',1.57),('5815','2013-08-18','16:40:00',1.53),('5815','2013-08-18','16:45:00',1.49),('5815','2013-08-18','16:50:00',1.46),('5815','2013-08-18','16:55:00',1.42),('5815','2013-08-18','17:00:00',1.38),('5815','2013-08-18','17:05:00',1.32),('5815','2013-08-18','17:10:00',1.28),('5815','2013-08-18','17:15:00',1.23),('5815','2013-08-18','17:20:00',1.18),('5815','2013-08-18','17:25:00',1.12),('5815','2013-08-18','17:30:00',1.08),('5815','2013-08-18','17:35:00',1.03),('5815','2013-08-17','08:55:00',1),('5815','2013-08-17','09:00:00',1.05),('5815','2013-08-17','09:05:00',1.09),('5815','2013-08-17','09:10:00',1.14),('5815','2013-08-17','09:15:00',1.19),('5815','2013-08-17','09:20:00',1.24),('5815','2013-08-17','09:25:00',1.27),('5815','2013-08-17','09:30:00',1.33),('5815','2013-08-17','09:35:00',1.37),('5815','2013-08-17','09:40:00',1.43),('5815','2013-08-17','09:45:00',1.35),('5815','2013-08-17','09:50:00',1.51),('5815','2013-08-17','09:55:00',1.11),('5815','2013-08-17','10:00:00',1.57),('5815','2013-08-17','10:05:00',1.34),('5815','2013-08-17','10:10:00',1.4),('5815','2013-08-17','10:15:00',1.67),('5815','2013-08-17','10:20:00',1.69),('5815','2013-08-17','10:25:00',1.72),('5815','2013-08-17','10:30:00',1.74),('5815','2013-08-17','10:35:00',1.76),('5815','2013-08-17','10:40:00',1.79),('5815','2013-08-17','10:45:00',1.82),('5815','2013-08-17','10:50:00',1.83),('5815','2013-08-17','10:55:00',1.87),('5815','2013-08-17','11:00:00',1.88),('5815','2013-08-17','11:05:00',1.92),('5815','2013-08-17','11:10:00',1.93),('5815','2013-08-17','11:15:00',1.94),('5815','2013-08-17','11:20:00',1.97),('5815','2013-08-17','11:25:00',2),('5815','2013-08-17','11:30:00',2.02),('5815','2013-08-17','11:35:00',2.02),('5815','2013-08-17','11:40:00',2.05),('5815','2013-08-17','11:45:00',2.07),('5815','2013-08-17','11:50:00',2.07),('5815','2013-08-17','11:55:00',2.08),('5815','2013-08-17','12:00:00',2.08),('5815','2013-08-17','12:05:00',2.1),('5815','2013-08-17','12:10:00',2.13),('5815','2013-08-17','12:15:00',2.09),('5815','2013-08-17','12:20:00',2.17),('5815','2013-08-17','12:25:00',2.26),('5815','2013-08-17','12:30:00',2.22),('5815','2013-08-17','12:35:00',2.03),('5815','2013-08-17','12:40:00',1.46),('5815','2013-08-17','12:45:00',1.2),('5815','2013-08-17','12:55:00',1.61),('5815','2013-08-17','13:05:00',2.35),('5815','2013-08-17','13:10:00',2.39),('5815','2013-08-17','13:15:00',2.21),('5815','2013-08-17','13:20:00',2.17),('5815','2013-08-17','13:25:00',2.31),('5815','2013-08-17','13:30:00',2.23),('5815','2013-08-17','13:35:00',2.24),('5815','2013-08-17','13:40:00',2.29),('5815','2013-08-17','13:45:00',2.27),('5815','2013-08-17','13:50:00',2.27),('5815','2013-08-17','13:55:00',1.9),('5815','2013-08-17','14:00:00',2.27),('5815','2013-08-17','14:05:00',2.28),('5815','2013-08-17','14:10:00',2.24),('5815','2013-08-17','14:15:00',2.23),('5815','2013-08-17','14:20:00',2.21),('5815','2013-08-17','14:25:00',2.2),('5815','2013-08-17','14:30:00',2.2),('5815','2013-08-17','14:35:00',2.19),('5815','2013-08-17','14:40:00',2.18),('5815','2013-08-17','14:45:00',2.17),('5815','2013-08-17','14:50:00',2.15),('5815','2013-08-17','14:55:00',2.14),('5815','2013-08-17','15:00:00',2.11),('5815','2013-08-17','15:05:00',2.1),('5815','2013-08-17','15:10:00',2.08),('5815','2013-08-17','15:15:00',2.05),('5815','2013-08-17','15:20:00',2.03),('5815','2013-08-17','15:25:00',2.01),('5815','2013-08-17','15:30:00',1.97),('5815','2013-08-17','15:35:00',1.96),('5815','2013-08-17','15:40:00',1.94),('5815','2013-08-17','15:45:00',1.9),('5815','2013-08-17','15:50:00',1.87),('5815','2013-08-17','15:55:00',1.84),('5815','2013-08-17','16:00:00',1.82),('5815','2013-08-17','16:05:00',1.79),('5815','2013-08-17','16:10:00',1.74),('5815','2013-08-17','16:15:00',1.71),('5815','2013-08-17','16:20:00',1.67),('5815','2013-08-17','16:25:00',1.65),('5815','2013-08-17','16:30:00',1.61),('5815','2013-08-17','16:35:00',1.57),('5815','2013-08-17','16:40:00',1.53),('5815','2013-08-17','16:45:00',1.48),('5815','2013-08-17','16:50:00',1.45),('5815','2013-08-17','16:55:00',1.41),('5815','2013-08-17','17:00:00',1.37),('5815','2013-08-17','17:05:00',1.33),('5815','2013-08-17','17:10:00',1.28),('5815','2013-08-17','17:15:00',1.23),('5815','2013-08-17','17:20:00',1.19),('5815','2013-08-17','17:25:00',1.14),('5815','2013-08-17','17:30:00',1.09),('5815','2013-08-17','17:35:00',1.04),('5815','2013-08-16','09:00:00',1.04),('5815','2013-08-16','09:05:00',1.09),('5815','2013-08-16','09:10:00',1.13),('5815','2013-08-16','09:15:00',1.17),('5815','2013-08-16','09:20:00',1.23),('5815','2013-08-16','09:25:00',1.27),('5815','2013-08-16','09:30:00',1.32),('5815','2013-08-16','09:35:00',1.36),('5815','2013-08-16','09:40:00',1.4),('5815','2013-08-16','09:45:00',1.44),('5815','2013-08-16','09:50:00',1.48),('5815','2013-08-16','09:55:00',1.52),('5815','2013-08-16','10:00:00',1.56),('5815','2013-08-16','10:05:00',1.59),('5815','2013-08-16','10:10:00',1.63),('5815','2013-08-16','10:15:00',1.67),('5815','2013-08-16','10:20:00',1.69),('5815','2013-08-16','10:25:00',1.72),('5815','2013-08-16','10:30:00',1.75),('5815','2013-08-16','10:35:00',1.78),('5815','2013-08-16','10:40:00',1.81),('5815','2013-08-16','10:45:00',1.84),('5815','2013-08-16','10:50:00',1.88),('5815','2013-08-16','10:55:00',1.9),('5815','2013-08-16','11:00:00',1.91),('5815','2013-08-16','11:05:00',1.93),('5815','2013-08-16','11:10:00',1.96),('5815','2013-08-16','11:15:00',1.97),('5815','2013-08-16','11:20:00',1.99),('5815','2013-08-16','11:25:00',2.02),('5815','2013-08-16','11:30:00',2.04),('5815','2013-08-16','11:35:00',2.02),('5815','2013-08-16','11:40:00',2.09),('5815','2013-08-16','11:45:00',2.1),('5815','2013-08-16','11:50:00',2.11),('5815','2013-08-16','11:55:00',2.17),('5815','2013-08-16','12:00:00',2.14),('5815','2013-08-16','12:05:00',2.15),('5815','2013-08-16','12:10:00',2.14),('5815','2013-08-16','12:15:00',2.07),('5815','2013-08-16','12:20:00',2.17),('5815','2013-08-16','12:25:00',2.2),('5815','2013-08-16','12:30:00',2.24),('5815','2013-08-16','12:35:00',2.22),('5815','2013-08-16','12:40:00',2.11),('5815','2013-08-16','12:45:00',2.21),('5815','2013-08-16','12:50:00',2.27),('5815','2013-08-16','12:55:00',2.25),('5815','2013-08-16','13:00:00',2.21),('5815','2013-08-16','13:05:00',2.09),('5815','2013-08-16','13:10:00',2.3),('5815','2013-08-16','13:15:00',2.29),('5815','2013-08-16','13:20:00',2.26),('5815','2013-08-16','13:25:00',2.33),('5815','2013-08-16','13:30:00',1.45),('5815','2013-08-16','13:35:00',1.99),('5815','2013-08-16','13:40:00',1.02),('5815','2013-08-16','14:00:00',1.28),('5815','2013-08-16','14:05:00',1.87),('5815','2013-08-16','14:10:00',1.83),('5815','2013-08-16','14:15:00',2.32),('5815','2013-08-16','14:20:00',2.24),('5815','2013-08-16','14:25:00',2.28),('5815','2013-08-16','14:30:00',2.21),('5815','2013-08-16','14:35:00',2.21),('5815','2013-08-16','14:40:00',2.16),('5815','2013-08-16','14:45:00',2.16),('5815','2013-08-16','14:50:00',2.17),('5815','2013-08-16','14:55:00',2.12),('5815','2013-08-16','15:00:00',2.12),('5815','2013-08-16','15:05:00',2.11),('5815','2013-08-16','15:10:00',2.07),('5815','2013-08-16','15:15:00',2.05),('5815','2013-08-16','15:20:00',2.04),('5815','2013-08-16','15:25:00',2),('5815','2013-08-16','15:30:00',1.99),('5815','2013-08-16','15:35:00',1.99),('5815','2013-08-16','15:40:00',1.95),('5815','2013-08-16','15:45:00',1.9),('5815','2013-08-16','15:50:00',1.88),('5815','2013-08-16','15:55:00',1.85),('5815','2013-08-16','16:00:00',1.83),('5815','2013-08-16','16:05:00',1.79),('5815','2013-08-16','16:10:00',1.76),('5815','2013-08-16','16:15:00',1.74),('5815','2013-08-16','16:20:00',1.71),('5815','2013-08-16','16:25:00',1.67),('5815','2013-08-16','16:30:00',1.65),('5815','2013-08-16','16:35:00',1.62),('5815','2013-08-16','16:40:00',1.56),('5815','2013-08-16','16:45:00',1.51),('5815','2013-08-16','16:50:00',1.43),('5815','2013-08-16','16:55:00',1.45),('5815','2013-08-16','17:00:00',1.4),('5815','2013-08-16','17:05:00',1.33),('5815','2013-08-16','17:10:00',1.3),('5815','2013-08-16','17:15:00',1.11),('5815','2013-08-16','17:20:00',1.21),('5815','2013-08-16','17:25:00',1.15),('5815','2013-08-16','17:30:00',1.16),('5815','2013-08-16','17:35:00',1.1),('5815','2013-08-16','17:40:00',1.04),('5815','2013-08-15','08:55:00',1.01),('5815','2013-08-15','09:00:00',1.06),('5815','2013-08-15','09:05:00',1.11),('5815','2013-08-15','09:10:00',1.16),('5815','2013-08-15','09:15:00',1.21),('5815','2013-08-15','09:20:00',1.27),('5815','2013-08-15','09:25:00',1.31),('5815','2013-08-15','09:30:00',1.36),('5815','2013-08-15','09:35:00',1.4),('5815','2013-08-15','09:40:00',1.45),('5815','2013-08-15','09:45:00',1.49),('5815','2013-08-15','09:50:00',1.54),('5815','2013-08-15','09:55:00',1.57),('5815','2013-08-15','10:00:00',1.61),('5815','2013-08-15','10:05:00',1.65),('5815','2013-08-15','10:10:00',1.68),('5815','2013-08-15','10:15:00',1.72),('5815','2013-08-15','10:20:00',1.75),('5815','2013-08-15','10:25:00',1.78),('5815','2013-08-15','10:30:00',1.82),('5815','2013-08-15','10:35:00',1.85),('5815','2013-08-15','10:40:00',1.87),('5815','2013-08-15','10:45:00',1.89),('5815','2013-08-15','10:50:00',1.92),('5815','2013-08-15','10:55:00',1.95),('5815','2013-08-15','11:00:00',1.96),('5815','2013-08-15','11:05:00',1.98),('5815','2013-08-15','11:10:00',2),('5815','2013-08-15','11:15:00',2.01),('5815','2013-08-15','11:20:00',2.04),('5815','2013-08-15','11:25:00',2.05),('5815','2013-08-15','11:30:00',2.07),('5815','2013-08-15','11:35:00',2.1),('5815','2013-08-15','11:40:00',2.1),('5815','2013-08-15','11:45:00',2.12),('5815','2013-08-15','11:50:00',2.13),('5815','2013-08-15','11:55:00',2.14),('5815','2013-08-15','12:00:00',2.16),('5815','2013-08-15','12:05:00',2.17),('5815','2013-08-15','12:10:00',2.19),('5815','2013-08-15','12:15:00',2.21),('5815','2013-08-15','12:20:00',2.22),('5815','2013-08-15','12:25:00',2.22),('5815','2013-08-15','12:30:00',2.22),('5815','2013-08-15','12:35:00',2.21),('5815','2013-08-15','12:40:00',2.22),('5815','2013-08-15','12:45:00',2.23),('5815','2013-08-15','12:50:00',2.23),('5815','2013-08-15','12:55:00',2.24),('5815','2013-08-15','13:00:00',2.24),('5815','2013-08-15','13:05:00',2.25),('5815','2013-08-15','13:10:00',2.25),('5815','2013-08-15','13:15:00',2.25),('5815','2013-08-15','13:20:00',2.23),('5815','2013-08-15','13:25:00',2.23),('5815','2013-08-15','13:30:00',2.22),('5815','2013-08-15','13:35:00',2.22),('5815','2013-08-15','13:40:00',2.22),('5815','2013-08-15','13:45:00',2.22),('5815','2013-08-15','13:50:00',2.2),('5815','2013-08-15','13:55:00',2.21),('5815','2013-08-15','14:00:00',2.21),('5815','2013-08-15','14:05:00',2.22),('5815','2013-08-15','14:10:00',2.21),('5815','2013-08-15','14:15:00',2.21),('5815','2013-08-15','14:20:00',2.18),('5815','2013-08-15','14:25:00',2.17),('5815','2013-08-15','14:30:00',2.15),('5815','2013-08-15','14:35:00',2.12),('5815','2013-08-15','14:40:00',2.1),('5815','2013-08-15','14:45:00',2.09),('5815','2013-08-15','14:50:00',2.08),('5815','2013-08-15','14:55:00',2.08),('5815','2013-08-15','15:00:00',2.05),('5815','2013-08-15','15:05:00',2),('5815','2013-08-15','15:10:00',2.03),('5815','2013-08-15','15:15:00',2.02),('5815','2013-08-15','15:20:00',1.98),('5815','2013-08-15','15:25:00',1.97),('5815','2013-08-15','15:30:00',1.97),('5815','2013-08-15','15:35:00',1.95),('5815','2013-08-15','15:40:00',1.91),('5815','2013-08-15','15:45:00',1.9),('5815','2013-08-15','15:50:00',1.87),('5815','2013-08-15','15:55:00',1.85),('5815','2013-08-15','16:00:00',1.82),('5815','2013-08-15','16:05:00',1.79),('5815','2013-08-15','16:10:00',1.76),('5815','2013-08-15','16:15:00',1.72),('5815','2013-08-15','16:20:00',1.68),('5815','2013-08-15','16:25:00',1.65),('5815','2013-08-15','16:30:00',1.61),('5815','2013-08-15','16:35:00',1.58),('5815','2013-08-15','16:40:00',1.55),('5815','2013-08-15','16:45:00',1.52),('5815','2013-08-15','16:50:00',1.47),('5815','2013-08-15','16:55:00',1.43),('5815','2013-08-15','17:00:00',1.38),('5815','2013-08-15','17:05:00',1.33),('5815','2013-08-15','17:10:00',1.28),('5815','2013-08-15','17:15:00',1.23),('5815','2013-08-15','17:20:00',1.18),('5815','2013-08-15','17:25:00',1.13),('5815','2013-08-15','17:30:00',1.07),('5815','2013-08-15','17:35:00',1.02),('5815','2013-08-14','08:55:00',1.03),('5815','2013-08-14','09:00:00',1.09),('5815','2013-08-14','09:05:00',1.05),('5815','2013-08-14','09:20:00',1.24),('5815','2013-08-14','09:25:00',1.31),('5815','2013-08-14','09:30:00',1.35),('5815','2013-08-14','09:35:00',1.4),('5815','2013-08-14','09:40:00',1.44),('5815','2013-08-14','09:45:00',1.48),('5815','2013-08-14','09:50:00',1.53),('5815','2013-08-14','09:55:00',1.57),('5815','2013-08-14','10:00:00',1.61),('5815','2013-08-14','10:05:00',1.64),('5815','2013-08-14','10:10:00',1.68),('5815','2013-08-14','10:15:00',1.72),('5815','2013-08-14','10:20:00',1.75),('5815','2013-08-14','10:25:00',1.79),('5815','2013-08-14','10:30:00',1.82),('5815','2013-08-14','10:35:00',1.84),('5815','2013-08-14','10:40:00',1.87),('5815','2013-08-14','10:45:00',1.87),('5815','2013-08-14','10:50:00',1.85),('5815','2013-08-14','10:55:00',1.84),('5815','2013-08-14','11:00:00',1.8),('5815','2013-08-14','11:05:00',1.55),('5815','2013-08-14','11:10:00',1.38),('5815','2013-08-14','11:15:00',1.48),('5815','2013-08-14','11:20:00',1.7),('5815','2013-08-14','11:25:00',1.88),('5815','2013-08-14','11:30:00',2.11),('5815','2013-08-14','11:35:00',2.21),('5815','2013-08-14','11:40:00',2.26),('5815','2013-08-14','11:45:00',2.31),('5815','2013-08-14','11:50:00',2.32),('5815','2013-08-14','11:55:00',2.33),('5815','2013-08-14','12:00:00',2.32),('5815','2013-08-14','12:05:00',2.31),('5815','2013-08-14','12:10:00',2.29),('5815','2013-08-14','12:15:00',2.31),('5815','2013-08-14','12:20:00',2.3),('5815','2013-08-14','12:25:00',2.31),('5815','2013-08-14','12:30:00',2.31),('5815','2013-08-14','12:35:00',2.32),('5815','2013-08-14','12:40:00',2.29),('5815','2013-08-14','12:45:00',2.32),('5815','2013-08-14','12:50:00',2.28),('5815','2013-08-14','12:55:00',2.18),('5815','2013-08-14','13:00:00',2.2),('5815','2013-08-14','13:05:00',2.2),('5815','2013-08-14','13:10:00',2.18),('5815','2013-08-14','13:15:00',2.14),('5815','2013-08-14','13:20:00',2.15),('5815','2013-08-14','13:25:00',2.25),('5815','2013-08-14','13:30:00',2.29),('5815','2013-08-14','13:35:00',2.29),('5815','2013-08-14','13:40:00',2.26),('5815','2013-08-14','13:45:00',2.25),('5815','2013-08-14','13:50:00',2.23),('5815','2013-08-14','13:55:00',2.2),('5815','2013-08-14','14:00:00',2.23),('5815','2013-08-14','14:05:00',2.23),('5815','2013-08-14','14:10:00',2.22),('5815','2013-08-14','14:15:00',2.22),('5815','2013-08-14','14:20:00',2.19),('5815','2013-08-14','14:25:00',2.14),('5815','2013-08-14','14:30:00',2.11),('5815','2013-08-14','14:35:00',2.16),('5815','2013-08-14','14:40:00',2.13),('5815','2013-08-14','14:45:00',2.09),('5815','2013-08-14','14:50:00',2.08),('5815','2013-08-14','14:55:00',2.05),('5815','2013-08-14','15:00:00',2.04),('5815','2013-08-14','15:05:00',2.04),('5815','2013-08-14','15:10:00',2.02),('5815','2013-08-14','15:15:00',1.99),('5815','2013-08-14','15:20:00',1.94),('5815','2013-08-14','15:25:00',1.91),('5815','2013-08-14','15:30:00',1.92),('5815','2013-08-14','15:35:00',1.9),('5815','2013-08-14','15:40:00',1.86),('5815','2013-08-14','15:45:00',1.81),('5815','2013-08-14','15:50:00',1.79),('5815','2013-08-14','15:55:00',1.78),('5815','2013-08-14','16:00:00',1.73),('5815','2013-08-14','16:05:00',1.68),('5815','2013-08-14','16:10:00',1.56),('5815','2013-08-14','16:15:00',1.62),('5815','2013-08-14','16:20:00',1.62),('5815','2013-08-14','16:25:00',1.56),('5815','2013-08-14','16:30:00',1.5),('5815','2013-08-14','16:35:00',1.48),('5815','2013-08-14','16:40:00',1.45),('5815','2013-08-14','16:45:00',1.41),('5815','2013-08-14','16:50:00',1.39),('5815','2013-08-14','16:55:00',1.32),('5815','2013-08-14','17:00:00',1.31),('5815','2013-08-14','17:05:00',1.27),('5815','2013-08-14','17:10:00',1.23),('5815','2013-08-14','17:15:00',1.19),('5815','2013-08-14','17:20:00',1.16),('5815','2013-08-14','17:25:00',1.09),('5815','2013-08-14','17:30:00',1.05),('5815','2013-08-13','09:00:00',1.04),('5815','2013-08-13','09:05:00',1.09),('5815','2013-08-13','09:10:00',1.15),('5815','2013-08-13','09:15:00',1.21),('5815','2013-08-13','09:20:00',1.25),('5815','2013-08-13','09:25:00',1.22),('5815','2013-08-13','09:30:00',1.35),('5815','2013-08-13','09:35:00',1.44),('5815','2013-08-13','09:40:00',1.44),('5815','2013-08-13','10:05:00',1.23),('5815','2013-08-13','10:10:00',1.44),('5815','2013-08-13','10:15:00',1.55),('5815','2013-08-13','10:20:00',1.51),('5815','2013-08-13','10:25:00',1.76),('5815','2013-08-13','10:30:00',1.89),('5815','2013-08-13','10:35:00',1.93),('5815','2013-08-13','10:40:00',1.99),('5815','2013-08-13','10:45:00',1.45),('5815','2013-08-13','10:50:00',1.49),('5815','2013-08-13','11:00:00',1.44),('5815','2013-08-13','11:05:00',2.04),('5815','2013-08-13','11:20:00',1.73),('5815','2013-08-13','11:25:00',1.76),('5815','2013-08-13','11:30:00',2.13),('5815','2013-08-13','11:35:00',2.16),('5815','2013-08-13','11:40:00',2.2),('5815','2013-08-13','11:45:00',1.54),('5815','2013-08-13','12:05:00',1.13),('5815','2013-08-13','12:10:00',1.15),('5815','2013-08-13','12:15:00',1.24),('5815','2013-08-13','12:20:00',1.15),('5815','2013-08-13','12:35:00',1.23),('5815','2013-08-13','12:55:00',1.18),('5815','2013-08-13','13:30:00',1.07),('5815','2013-08-13','13:40:00',1.44),('5815','2013-08-13','13:45:00',2.04),('5815','2013-08-13','13:50:00',2.52),('5815','2013-08-13','13:55:00',1.77),('5815','2013-08-13','14:05:00',2.43),('5815','2013-08-13','14:10:00',1.28),('5815','2013-08-13','14:15:00',2.46),('5815','2013-08-13','14:20:00',2.41),('5815','2013-08-13','14:25:00',2.41),('5815','2013-08-13','14:30:00',2.35),('5815','2013-08-13','14:35:00',2.34),('5815','2013-08-13','14:40:00',2.27),('5815','2013-08-13','14:45:00',2.22),('5815','2013-08-13','14:50:00',2.23),('5815','2013-08-13','14:55:00',1.57),('5815','2013-08-13','15:00:00',2.15),('5815','2013-08-13','15:05:00',2.14),('5815','2013-08-13','15:10:00',2.08),('5815','2013-08-13','15:15:00',2.09),('5815','2013-08-13','15:20:00',2.11),('5815','2013-08-13','15:25:00',2.11),('5815','2013-08-13','15:30:00',2.02),('5815','2013-08-13','15:35:00',1.97),('5815','2013-08-13','15:40:00',1.96),('5815','2013-08-13','15:45:00',1.93),('5815','2013-08-13','15:50:00',1.91),('5815','2013-08-13','15:55:00',1.87),('5815','2013-08-13','16:00:00',1.86),('5815','2013-08-13','16:05:00',1.84),('5815','2013-08-13','16:10:00',1.81),('5815','2013-08-13','16:15:00',1.77),('5815','2013-08-13','16:20:00',1.75),('5815','2013-08-13','16:25:00',1.7),('5815','2013-08-13','16:30:00',1.65),('5815','2013-08-13','16:35:00',1.62),('5815','2013-08-13','16:40:00',1.58),('5815','2013-08-13','16:45:00',1.52),('5815','2013-08-13','16:50:00',1.51),('5815','2013-08-13','16:55:00',1.46),('5815','2013-08-13','17:00:00',1.41),('5815','2013-08-13','17:05:00',1.35),('5815','2013-08-13','17:10:00',1.3),('5815','2013-08-13','17:15:00',1.26),('5815','2013-08-13','17:20:00',1.2),('5815','2013-08-13','17:25:00',1.16),('5815','2013-08-13','17:30:00',1.1),('5815','2013-08-13','17:35:00',1.05),('5815','2013-08-12','08:55:00',1.01),('5815','2013-08-12','09:00:00',1.06),('5815','2013-08-12','09:05:00',1.11),('5815','2013-08-12','09:10:00',1.15),('5815','2013-08-12','09:15:00',1.21),('5815','2013-08-12','09:20:00',1.24),('5815','2013-08-12','09:25:00',1.25),('5815','2013-08-12','09:30:00',1.27),('5815','2013-08-12','09:35:00',1.36),('5815','2013-08-12','09:40:00',1.44),('5815','2013-08-12','09:45:00',1.18),('5815','2013-08-12','09:50:00',1.51),('5815','2013-08-12','09:55:00',1.54),('5815','2013-08-12','10:00:00',1.41),('5815','2013-08-12','10:05:00',1.06),('5815','2013-08-12','10:10:00',1.64),('5815','2013-08-12','10:15:00',1.73),('5815','2013-08-12','10:20:00',1.71),('5815','2013-08-12','10:25:00',1.76),('5815','2013-08-12','10:30:00',1.78),('5815','2013-08-12','10:35:00',1.82),('5815','2013-08-12','10:40:00',1.84),('5815','2013-08-12','10:45:00',1.87),('5815','2013-08-12','10:50:00',1.9),('5815','2013-08-12','10:55:00',1.91),('5815','2013-08-12','11:00:00',1.92),('5815','2013-08-12','11:05:00',1.98),('5815','2013-08-12','11:10:00',1.96),('5815','2013-08-12','11:15:00',1.96),('5815','2013-08-12','11:20:00',1.98),('5815','2013-08-12','11:25:00',2.02),('5815','2013-08-12','11:30:00',2.05),('5815','2013-08-12','11:35:00',2.03),('5815','2013-08-12','11:40:00',2.07),('5815','2013-08-12','11:45:00',2.08),('5815','2013-08-12','11:50:00',2.12),('5815','2013-08-12','11:55:00',2.18),('5815','2013-08-12','12:00:00',2.22),('5815','2013-08-12','12:05:00',2.24),('5815','2013-08-12','12:10:00',2.25),('5815','2013-08-12','12:15:00',2.28),('5815','2013-08-12','12:20:00',2.3),('5815','2013-08-12','12:25:00',2.32),('5815','2013-08-12','12:30:00',2.34),('5815','2013-08-12','12:35:00',1.92),('5815','2013-08-12','12:40:00',2.26),('5815','2013-08-12','12:45:00',1.13),('5815','2013-08-12','12:50:00',1.99),('5815','2013-08-12','12:55:00',2.23),('5815','2013-08-12','13:15:00',1.11),('5815','2013-08-12','13:20:00',2.69),('5815','2013-08-12','13:25:00',2.58),('5815','2013-08-12','13:30:00',2.55),('5815','2013-08-12','13:35:00',2.48),('5815','2013-08-12','13:40:00',2.48),('5815','2013-08-12','13:45:00',2.49),('5815','2013-08-12','13:50:00',2.53),('5815','2013-08-12','13:55:00',2.52),('5815','2013-08-12','14:00:00',2.39),('5815','2013-08-12','14:05:00',2.46),('5815','2013-08-12','14:10:00',1.86),('5815','2013-08-12','14:15:00',2.38),('5815','2013-08-12','14:20:00',2.42),('5815','2013-08-12','14:25:00',1.92),('5815','2013-08-12','14:35:00',2.37),('5815','2013-08-12','14:40:00',1.62),('5815','2013-08-12','14:45:00',1.09),('5815','2013-08-12','14:50:00',2.27),('5815','2013-08-12','14:55:00',2.41),('5815','2013-08-12','15:00:00',2.01),('5815','2013-08-12','15:05:00',1.75),('5815','2013-08-12','15:10:00',1.41),('5815','2013-08-12','15:15:00',1.85),('5815','2013-08-12','15:20:00',2.1),('5815','2013-08-12','15:25:00',2.1),('5815','2013-08-12','15:30:00',2.04),('5815','2013-08-12','15:35:00',2.03),('5815','2013-08-12','15:40:00',2),('5815','2013-08-12','15:45:00',1.96),('5815','2013-08-12','15:50:00',1.91),('5815','2013-08-12','15:55:00',1.88),('5815','2013-08-12','16:00:00',1.86),('5815','2013-08-12','16:05:00',1.81),('5815','2013-08-12','16:10:00',1.77),('5815','2013-08-12','16:15:00',1.75),('5815','2013-08-12','16:20:00',1.72),('5815','2013-08-12','16:25:00',1.68),('5815','2013-08-12','16:30:00',1.64),('5815','2013-08-12','16:35:00',1.58),('5815','2013-08-12','16:40:00',1.57),('5815','2013-08-12','16:45:00',1.53),('5815','2013-08-12','16:50:00',1.49),('5815','2013-08-12','16:55:00',1.44),('5815','2013-08-12','17:00:00',1.39),('5815','2013-08-12','17:05:00',1.35),('5815','2013-08-12','17:10:00',1.31),('5815','2013-08-12','17:15:00',1.26),('5815','2013-08-12','17:20:00',1.2),('5815','2013-08-12','17:25:00',1.16),('5815','2013-08-12','17:30:00',1.07),('5815','2013-08-12','17:35:00',1.04),('5815','2013-08-11','09:00:00',1.04),('5815','2013-08-11','09:05:00',1.09),('5815','2013-08-11','09:10:00',1.13),('5815','2013-08-11','09:15:00',1.18),('5815','2013-08-11','09:20:00',1.22),('5815','2013-08-11','09:25:00',1.27),('5815','2013-08-11','09:30:00',1.31),('5815','2013-08-11','09:35:00',1.35),('5815','2013-08-11','09:40:00',1.39),('5815','2013-08-11','09:45:00',1.43),('5815','2013-08-11','09:50:00',1.47),('5815','2013-08-11','09:55:00',1.51),('5815','2013-08-11','10:00:00',1.53),('5815','2013-08-11','10:05:00',1.57),('5815','2013-08-11','10:10:00',1.6),('5815','2013-08-11','10:15:00',1.63),('5815','2013-08-11','10:20:00',1.67),('5815','2013-08-11','10:25:00',1.7),('5815','2013-08-11','10:30:00',1.73),('5815','2013-08-11','10:35:00',1.75),('5815','2013-08-11','10:40:00',1.79),('5815','2013-08-11','10:45:00',1.82),('5815','2013-08-11','10:50:00',1.86),('5815','2013-08-11','10:55:00',1.88),('5815','2013-08-11','11:00:00',1.86),('5815','2013-08-11','11:05:00',1.91),('5815','2013-08-11','11:10:00',1.92),('5815','2013-08-11','11:15:00',1.93),('5815','2013-08-11','11:20:00',1.93),('5815','2013-08-11','11:25:00',1.97),('5815','2013-08-11','11:30:00',1.99),('5815','2013-08-11','11:35:00',1.95),('5815','2013-08-11','11:40:00',2.04),('5815','2013-08-11','11:45:00',2.09),('5815','2013-08-11','11:50:00',2.11),('5815','2013-08-11','11:55:00',2.15),('5815','2013-08-11','12:00:00',2.2),('5815','2013-08-11','12:05:00',2.25),('5815','2013-08-11','12:10:00',2.18),('5815','2013-08-11','12:15:00',1.76),('5815','2013-08-11','12:45:00',1.81),('5815','2013-08-11','12:50:00',1.03),('5815','2013-08-11','13:25:00',1.25),('5815','2013-08-11','13:50:00',1.43),('5815','2013-08-11','13:55:00',2.24),('5815','2013-08-11','14:50:00',1.2),('5815','2013-08-11','14:55:00',2.51),('5815','2013-08-11','15:00:00',2.26),('5815','2013-08-11','15:05:00',1.93),('5815','2013-08-11','15:10:00',2.25),('5815','2013-08-11','15:15:00',2.19),('5815','2013-08-11','15:20:00',1.72),('5815','2013-08-11','15:25:00',1.95),('5815','2013-08-11','15:30:00',2.09),('5815','2013-08-11','15:35:00',1.97),('5815','2013-08-11','15:40:00',1.98),('5815','2013-08-11','15:45:00',1.93),('5815','2013-08-11','15:50:00',1.91),('5815','2013-08-11','15:55:00',1.88),('5815','2013-08-11','16:00:00',1.84),('5815','2013-08-11','16:05:00',1.8),('5815','2013-08-11','16:10:00',1.78),('5815','2013-08-11','16:15:00',1.73),('5815','2013-08-11','16:20:00',1.7),('5815','2013-08-11','16:25:00',1.66),('5815','2013-08-11','16:30:00',1.61),('5815','2013-08-11','16:35:00',1.57),('5815','2013-08-11','16:40:00',1.55),('5815','2013-08-11','16:45:00',1.5),('5815','2013-08-11','16:50:00',1.46),('5815','2013-08-11','16:55:00',1.42),('5815','2013-08-11','17:00:00',1.39),('5815','2013-08-11','17:05:00',1.34),('5815','2013-08-11','17:10:00',1.29),('5815','2013-08-11','17:15:00',1.23),('5815','2013-08-11','17:20:00',1.17),('5815','2013-08-11','17:25:00',1.14),('5815','2013-08-11','17:30:00',1.06),('5815','2013-08-11','17:35:00',1.03),('5815','2013-08-10','08:55:00',1.01),('5815','2013-08-10','09:00:00',1.06),('5815','2013-08-10','09:05:00',1.11),('5815','2013-08-10','09:10:00',1.16),('5815','2013-08-10','09:15:00',1.2),('5815','2013-08-10','09:20:00',1.25),('5815','2013-08-10','09:25:00',1.29),('5815','2013-08-10','09:30:00',1.34),('5815','2013-08-10','09:35:00',1.38),('5815','2013-08-10','09:40:00',1.42),('5815','2013-08-10','09:45:00',1.47),('5815','2013-08-10','09:50:00',1.5),('5815','2013-08-10','09:55:00',1.55),('5815','2013-08-10','10:00:00',1.59),('5815','2013-08-10','10:05:00',1.62),('5815','2013-08-10','10:10:00',1.66),('5815','2013-08-10','10:15:00',1.7),('5815','2013-08-10','10:20:00',1.73),('5815','2013-08-10','10:25:00',1.76),('5815','2013-08-10','10:30:00',1.79),('5815','2013-08-10','10:35:00',1.81),('5815','2013-08-10','10:40:00',1.84),('5815','2013-08-10','10:45:00',1.87),('5815','2013-08-10','10:50:00',1.89),('5815','2013-08-10','10:55:00',1.92),('5815','2013-08-10','11:00:00',1.95),('5815','2013-08-10','11:05:00',1.97),('5815','2013-08-10','11:10:00',1.97),('5815','2013-08-10','11:15:00',1.97),('5815','2013-08-10','11:20:00',2),('5815','2013-08-10','11:25:00',2.03),('5815','2013-08-10','11:30:00',2.03),('5815','2013-08-10','11:35:00',2.03),('5815','2013-08-10','11:40:00',2.09),('5815','2013-08-10','11:45:00',2.1),('5815','2013-08-10','11:50:00',2.14),('5815','2013-08-10','11:55:00',2.15),('5815','2013-08-10','12:00:00',2.17),('5815','2013-08-10','12:05:00',2.18),('5815','2013-08-10','12:10:00',2.19),('5815','2013-08-10','12:15:00',2.19),('5815','2013-08-10','12:20:00',2.21),('5815','2013-08-10','12:25:00',2.22),('5815','2013-08-10','12:30:00',2.23),('5815','2013-08-10','12:35:00',2.23),('5815','2013-08-10','12:40:00',2.24),('5815','2013-08-10','12:45:00',2.25),('5815','2013-08-10','12:50:00',2.25),('5815','2013-08-10','12:55:00',2.25),('5815','2013-08-10','13:00:00',2.22),('5815','2013-08-10','13:05:00',2.24),('5815','2013-08-10','13:10:00',2.23),('5815','2013-08-10','13:15:00',2.23),('5815','2013-08-10','13:20:00',2.24),('5815','2013-08-10','13:25:00',2.24),('5815','2013-08-10','13:30:00',2.23),('5815','2013-08-10','13:35:00',2.22),('5815','2013-08-10','13:40:00',2.25),('5815','2013-08-10','13:45:00',2.23),('5815','2013-08-10','13:50:00',2.22),('5815','2013-08-10','13:55:00',2.2),('5815','2013-08-10','14:00:00',2.21),('5815','2013-08-10','14:05:00',2.21),('5815','2013-08-10','14:10:00',2.22),('5815','2013-08-10','14:15:00',2.16),('5815','2013-08-10','14:20:00',2.17),('5815','2013-08-10','14:25:00',2.14),('5815','2013-08-10','14:30:00',2.12),('5815','2013-08-10','14:35:00',2.11),('5815','2013-08-10','14:40:00',2.12),('5815','2013-08-10','14:45:00',2.1),('5815','2013-08-10','14:50:00',2.06),('5815','2013-08-10','14:55:00',2.06),('5815','2013-08-10','15:00:00',2.08),('5815','2013-08-10','15:05:00',2.05),('5815','2013-08-10','15:10:00',2.01),('5815','2013-08-10','15:15:00',1.99),('5815','2013-08-10','15:20:00',2),('5815','2013-08-10','15:25:00',2.03),('5815','2013-08-10','15:30:00',1.4),('5815','2013-08-10','15:35:00',1.93),('5815','2013-08-10','15:40:00',1.91),('5815','2013-08-10','15:45:00',1.88),('5815','2013-08-10','15:50:00',1.89),('5815','2013-08-10','15:55:00',1.87),('5815','2013-08-10','16:00:00',1.82),('5815','2013-08-10','16:05:00',1.78),('5815','2013-08-10','16:10:00',1.75),('5815','2013-08-10','16:15:00',1.71),('5815','2013-08-10','16:20:00',1.68),('5815','2013-08-10','16:25:00',1.64),('5815','2013-08-10','16:30:00',1.6),('5815','2013-08-10','16:35:00',1.57),('5815','2013-08-10','16:40:00',1.53),('5815','2013-08-10','16:45:00',1.48),('5815','2013-08-10','16:50:00',1.45),('5815','2013-08-10','16:55:00',1.41),('5815','2013-08-10','17:00:00',1.37),('5815','2013-08-10','17:05:00',1.33),('5815','2013-08-10','17:10:00',1.29),('5815','2013-08-10','17:15:00',1.2),('5815','2013-08-10','17:20:00',1.16),('5815','2013-08-10','17:25:00',1.13),('5815','2013-08-10','17:30:00',1.05),('5815','2013-08-10','17:35:00',1.03),('5815','2013-08-09','08:55:00',1.03),('5815','2013-08-09','09:00:00',1.08),('5815','2013-08-09','09:05:00',1.13),('5815','2013-08-09','09:10:00',1.17),('5815','2013-08-09','09:15:00',1.23),('5815','2013-08-09','09:20:00',1.27),('5815','2013-08-09','09:25:00',1.32),('5815','2013-08-09','09:30:00',1.36),('5815','2013-08-09','09:35:00',1.4),('5815','2013-08-09','09:40:00',1.43),('5815','2013-08-09','09:45:00',1.48),('5815','2013-08-09','09:50:00',1.5),('5815','2013-08-09','09:55:00',1.55),('5815','2013-08-09','10:00:00',1.6),('5815','2013-08-09','10:05:00',1.62),('5815','2013-08-09','10:15:00',1.7),('5815','2013-08-09','10:20:00',1.7),('5815','2013-08-09','10:25:00',1.76),('5815','2013-08-09','10:30:00',1.78),('5815','2013-08-09','10:35:00',1.81),('5815','2013-08-09','10:40:00',1.85),('5815','2013-08-09','10:45:00',1.88),('5815','2013-08-09','10:50:00',1.92),('5815','2013-08-09','10:55:00',1.95),('5815','2013-08-09','11:00:00',2),('5815','2013-08-09','11:05:00',2),('5815','2013-08-09','11:10:00',1.73),('5815','2013-08-09','11:15:00',1.79),('5815','2013-08-09','11:20:00',1.33),('5815','2013-08-09','11:25:00',1.49),('5815','2013-08-09','11:30:00',1.81),('5815','2013-08-09','11:35:00',2.12),('5815','2013-08-09','11:40:00',2.12),('5815','2013-08-09','11:45:00',2.14),('5815','2013-08-09','11:50:00',2.16),('5815','2013-08-09','11:55:00',2.16),('5815','2013-08-09','12:00:00',2.19),('5815','2013-08-09','12:05:00',2.19),('5815','2013-08-09','12:10:00',2.21),('5815','2013-08-09','12:15:00',2.21),('5815','2013-08-09','12:20:00',2.22),('5815','2013-08-09','12:25:00',2.23),('5815','2013-08-09','12:30:00',2.22),('5815','2013-08-09','12:35:00',2.24),('5815','2013-08-09','12:40:00',2.26),('5815','2013-08-09','12:45:00',2.3),('5815','2013-08-09','12:50:00',2.35),('5815','2013-08-09','12:55:00',2.36),('5815','2013-08-09','13:00:00',2.33),('5815','2013-08-09','13:05:00',2.27),('5815','2013-08-09','13:10:00',2.33),('5815','2013-08-09','13:15:00',2.37),('5815','2013-08-09','13:20:00',2.32),('5815','2013-08-09','13:25:00',2.44),('5815','2013-08-09','13:30:00',2.06),('5815','2013-08-09','13:35:00',1.52),('5815','2013-08-09','13:45:00',1.04),('5815','2013-08-09','13:50:00',2.46),('5815','2013-08-09','13:55:00',2.4),('5815','2013-08-09','14:00:00',2.51),('5815','2013-08-09','14:05:00',1.98),('5815','2013-08-09','14:10:00',2.52),('5815','2013-08-09','14:15:00',2.1),('5815','2013-08-09','14:20:00',1.06),('5815','2013-08-09','15:55:00',1.08),('5815','2013-08-09','16:00:00',1.2),('5815','2013-08-09','16:05:00',2.13),('5815','2013-08-09','16:10:00',1.09),('5815','2013-08-09','16:15:00',1.23),('5815','2013-08-09','16:20:00',1.32),('5815','2013-08-09','16:30:00',1.06),('5815','2013-08-09','16:35:00',1.87),('5815','2013-08-09','16:40:00',1.71),('5815','2013-08-09','16:45:00',1.66),('5815','2013-08-09','16:50:00',1.56),('5815','2013-08-09','16:55:00',1.45),('5815','2013-08-09','17:00:00',1.33),('5815','2013-08-08','09:05:00',1.05),('5815','2013-08-08','09:10:00',1.13),('5815','2013-08-08','09:15:00',1),('5815','2013-08-08','09:30:00',1.16),('5815','2013-08-08','09:35:00',1.42),('5815','2013-08-08','09:40:00',1.14),('5815','2013-08-08','09:45:00',1.43),('5815','2013-08-08','09:50:00',1.44),('5815','2013-08-08','10:00:00',1.07),('5815','2013-08-08','10:05:00',1.29),('5815','2013-08-08','10:10:00',1.5),('5815','2013-08-08','10:15:00',1.53),('5815','2013-08-08','10:20:00',1.53),('5815','2013-08-08','10:25:00',1.56),('5815','2013-08-08','10:30:00',1.62),('5815','2013-08-08','10:35:00',1.63),('5815','2013-08-08','10:40:00',1.71),('5815','2013-08-08','10:45:00',1.67),('5815','2013-08-08','10:50:00',1.73),('5815','2013-08-08','10:55:00',1.75),('5815','2013-08-08','11:00:00',1.77),('5815','2013-08-08','11:05:00',1.79),('5815','2013-08-08','11:10:00',1.8),('5815','2013-08-08','11:15:00',1.81),('5815','2013-08-08','11:20:00',1.85),('5815','2013-08-08','11:25:00',1.88),('5815','2013-08-08','11:30:00',1.89),('5815','2013-08-08','11:35:00',1.88),('5815','2013-08-08','11:40:00',1.9),('5815','2013-08-08','11:45:00',1.94),('5815','2013-08-08','11:50:00',1.97),('5815','2013-08-08','11:55:00',1.99),('5815','2013-08-08','12:00:00',1.99),('5815','2013-08-08','12:05:00',1.99),('5815','2013-08-08','12:10:00',2.03),('5815','2013-08-08','12:15:00',2.06),('5815','2013-08-08','12:20:00',2.15),('5815','2013-08-08','12:25:00',2.06),('5815','2013-08-08','12:30:00',1.5),('5815','2013-08-08','12:35:00',1.79),('5815','2013-08-08','12:40:00',2.25),('5815','2013-08-08','12:45:00',1.71),('5815','2013-08-08','12:50:00',1.38),('5815','2013-08-08','12:55:00',1.48),('5815','2013-08-08','13:25:00',1.2),('5815','2013-08-08','13:30:00',1.13),('5815','2013-08-08','15:10:00',1.59),('5815','2013-08-08','15:15:00',1.46),('5815','2013-08-08','15:35:00',1.17),('5815','2013-08-08','15:45:00',1.66),('5815','2013-08-08','15:50:00',1.2),('5815','2013-08-08','15:55:00',1.19),('5815','2013-08-08','16:55:00',1.19),('5815','2013-08-08','17:05:00',1.11),('5815','2013-08-07','09:05:00',1.01),('5815','2013-08-07','09:10:00',1.06),('5815','2013-08-07','09:15:00',1.11),('5815','2013-08-07','09:20:00',1.15),('5815','2013-08-07','09:25:00',1.19),('5815','2013-08-07','09:30:00',1.23),('5815','2013-08-07','09:35:00',1.28),('5815','2013-08-07','09:40:00',1.32),('5815','2013-08-07','09:45:00',1.36),('5815','2013-08-07','09:50:00',1.39),('5815','2013-08-07','09:55:00',1.41),('5815','2013-08-07','10:00:00',1.47),('5815','2013-08-07','10:05:00',1.5),('5815','2013-08-07','10:10:00',1.54),('5815','2013-08-07','10:15:00',1.57),('5815','2013-08-07','10:20:00',1.59),('5815','2013-08-07','10:25:00',1.62),('5815','2013-08-07','10:30:00',1.66),('5815','2013-08-07','10:35:00',1.68),('5815','2013-08-07','10:40:00',1.7),('5815','2013-08-07','10:45:00',1.73),('5815','2013-08-07','10:50:00',1.76),('5815','2013-08-07','10:55:00',1.79),('5815','2013-08-07','11:00:00',1.8),('5815','2013-08-07','11:05:00',1.82),('5815','2013-08-07','11:10:00',1.82),('5815','2013-08-07','11:15:00',1.82),('5815','2013-08-07','11:20:00',1.84),('5815','2013-08-07','11:25:00',1.87),('5815','2013-08-07','11:30:00',1.87),('5815','2013-08-07','11:35:00',1.9),('5815','2013-08-07','11:40:00',1.95),('5815','2013-08-07','11:45:00',1.96),('5815','2013-08-07','11:50:00',1.98),('5815','2013-08-07','11:55:00',1.98),('5815','2013-08-07','12:00:00',2),('5815','2013-08-07','12:05:00',2),('5815','2013-08-07','12:10:00',2),('5815','2013-08-07','12:15:00',2.03),('5815','2013-08-07','12:20:00',2.04),('5815','2013-08-07','12:25:00',2.07),('5815','2013-08-07','12:30:00',2.1),('5815','2013-08-07','12:35:00',2.12),('5815','2013-08-07','12:40:00',2.1),('5815','2013-08-07','12:45:00',2.08),('5815','2013-08-07','12:50:00',2.11),('5815','2013-08-07','12:55:00',2.13),('5815','2013-08-07','13:00:00',2.14),('5815','2013-08-07','13:05:00',2.16),('5815','2013-08-07','13:10:00',2.16),('5815','2013-08-07','13:15:00',2.16),('5815','2013-08-07','13:20:00',2.16),('5815','2013-08-07','13:25:00',2.17),('5815','2013-08-07','13:30:00',2.16),('5815','2013-08-07','13:35:00',2.15),('5815','2013-08-07','13:40:00',2.14),('5815','2013-08-07','13:45:00',2.12),('5815','2013-08-07','13:50:00',2.14),('5815','2013-08-07','13:55:00',2.11),('5815','2013-08-07','14:00:00',2.12),('5815','2013-08-07','14:05:00',2.12),('5815','2013-08-07','14:10:00',2.11),('5815','2013-08-07','14:15:00',2.08),('5815','2013-08-07','14:20:00',2.07),('5815','2013-08-07','14:25:00',2.06),('5815','2013-08-07','14:30:00',2.05),('5815','2013-08-07','14:35:00',2.04),('5815','2013-08-07','14:40:00',2.03),('5815','2013-08-07','14:45:00',2.01),('5815','2013-08-07','14:50:00',2),('5815','2013-08-07','14:55:00',1.97),('5815','2013-08-07','15:00:00',1.96),('5815','2013-08-07','15:05:00',1.92),('5815','2013-08-07','15:10:00',1.9),('5815','2013-08-07','15:15:00',1.9),('5815','2013-08-07','15:20:00',1.88),('5815','2013-08-07','15:25:00',1.85),('5815','2013-08-07','15:30:00',1.81),('5815','2013-08-07','15:35:00',1.79),('5815','2013-08-07','15:40:00',1.77),('5815','2013-08-07','15:45:00',1.76),('5815','2013-08-07','15:50:00',1.73),('5815','2013-08-07','15:55:00',1.7),('5815','2013-08-07','16:00:00',1.68),('5815','2013-08-07','16:05:00',1.66),('5815','2013-08-07','16:10:00',1.63),('5815','2013-08-07','16:15:00',1.6),('5815','2013-08-07','16:20:00',1.58),('5815','2013-08-07','16:25:00',1.56),('5815','2013-08-07','16:30:00',1.53),('5815','2013-08-07','16:35:00',1.49),('5815','2013-08-07','16:40:00',1.46),('5815','2013-08-07','16:45:00',1.41),('5815','2013-08-07','16:50:00',1.37),('5815','2013-08-07','16:55:00',1.33),('5815','2013-08-07','17:00:00',1.27),('5815','2013-08-07','17:05:00',1.23),('5815','2013-08-07','17:15:00',1.13),('5815','2013-08-07','17:20:00',1.09),('5815','2013-08-07','17:25:00',1.04),('5815','2013-08-06','09:05:00',1.03),('5815','2013-08-06','09:10:00',1.09),('5815','2013-08-06','09:15:00',1.13),('5815','2013-08-06','09:20:00',1.18),('5815','2013-08-06','09:25:00',1.21),('5815','2013-08-06','09:30:00',1.26),('5815','2013-08-06','09:35:00',1.3),('5815','2013-08-06','09:40:00',1.33),('5815','2013-08-06','09:45:00',1.35),('5815','2013-08-06','09:50:00',1.4),('5815','2013-08-06','09:55:00',1.44),('5815','2013-08-06','10:00:00',1.49),('5815','2013-08-06','10:05:00',1.5),('5815','2013-08-06','10:10:00',1.55),('5815','2013-08-06','10:15:00',1.58),('5815','2013-08-06','10:20:00',1.62),('5815','2013-08-06','10:25:00',1.65),('5815','2013-08-06','10:30:00',1.67),('5815','2013-08-06','10:35:00',1.68),('5815','2013-08-06','10:40:00',1.73),('5815','2013-08-06','10:45:00',1.77),('5815','2013-08-06','10:50:00',1.8),('5815','2013-08-06','10:55:00',1.81),('5815','2013-08-06','11:00:00',1.83),('5815','2013-08-06','11:05:00',1.84),('5815','2013-08-06','11:10:00',1.81),('5815','2013-08-06','11:15:00',1.83),('5815','2013-08-06','11:20:00',1.85),('5815','2013-08-06','11:25:00',1.87),('5815','2013-08-06','11:30:00',1.89),('5815','2013-08-06','11:35:00',1.93),('5815','2013-08-06','11:40:00',1.95),('5815','2013-08-06','11:45:00',1.97),('5815','2013-08-06','11:50:00',1.99),('5815','2013-08-06','11:55:00',1.99),('5815','2013-08-06','12:00:00',2.02),('5815','2013-08-06','12:05:00',2.03),('5815','2013-08-06','12:10:00',2.03),('5815','2013-08-06','12:15:00',2.05),('5815','2013-08-06','12:20:00',2.06),('5815','2013-08-06','12:25:00',2.05),('5815','2013-08-06','12:30:00',2.05),('5815','2013-08-06','12:35:00',2.09),('5815','2013-08-06','12:40:00',2.07),('5815','2013-08-06','12:45:00',2.07),('5815','2013-08-06','12:50:00',2.09),('5815','2013-08-06','12:55:00',2.09),('5815','2013-08-06','13:00:00',2.1),('5815','2013-08-06','13:05:00',2.13),('5815','2013-08-06','13:10:00',2.15),('5815','2013-08-06','13:15:00',2.13),('5815','2013-08-06','13:20:00',2.15),('5815','2013-08-06','13:25:00',2.12),('5815','2013-08-06','13:30:00',2.14),('5815','2013-08-06','13:35:00',2.07),('5815','2013-08-06','13:40:00',2.13),('5815','2013-08-06','13:45:00',2.15),('5815','2013-08-06','13:50:00',2.13),('5815','2013-08-06','13:55:00',2.15),('5815','2013-08-06','14:00:00',2.13),('5815','2013-08-06','14:05:00',2.14),('5815','2013-08-06','14:10:00',2.15),('5815','2013-08-06','14:15:00',2.07),('5815','2013-08-06','14:20:00',2.08),('5815','2013-08-06','14:25:00',2.04),('5815','2013-08-06','14:30:00',2.02),('5815','2013-08-06','14:35:00',2.02),('5815','2013-08-06','14:40:00',2.03),('5815','2013-08-06','14:45:00',2.06),('5815','2013-08-06','14:50:00',2.03),('5815','2013-08-06','14:55:00',2.01),('5815','2013-08-06','15:00:00',1.99),('5815','2013-08-06','15:05:00',1.95),('5815','2013-08-06','15:10:00',1.95),('5815','2013-08-06','15:15:00',1.93),('5815','2013-08-06','15:20:00',1.91),('5815','2013-08-06','15:25:00',1.88),('5815','2013-08-06','15:30:00',1.87),('5815','2013-08-06','15:35:00',1.84),('5815','2013-08-06','15:40:00',1.82),('5815','2013-08-06','15:45:00',1.79),('5815','2013-08-06','15:50:00',1.76),('5815','2013-08-06','15:55:00',1.74),('5815','2013-08-06','16:00:00',1.69),('5815','2013-08-06','16:05:00',1.68),('5815','2013-08-06','16:10:00',1.64),('5815','2013-08-06','16:15:00',1.61),('5815','2013-08-06','16:20:00',1.58),('5815','2013-08-06','16:25:00',1.54),('5815','2013-08-06','16:30:00',1.53),('5815','2013-08-06','16:35:00',1.51),('5815','2013-08-06','16:40:00',1.46),('5815','2013-08-06','16:45:00',1.43),('5815','2013-08-06','16:50:00',1.4),('5815','2013-08-06','16:55:00',1.35),('5815','2013-08-06','17:00:00',1.28),('5815','2013-08-06','17:05:00',1.25),('5815','2013-08-06','17:10:00',1.19),('5815','2013-08-06','17:15:00',1.14),('5815','2013-08-06','17:20:00',1.09),('5815','2013-08-06','17:25:00',1.07),('5815','2013-08-06','17:30:00',1.03),('5815','2013-08-05','09:05:00',1.02),('5815','2013-08-05','09:10:00',1.07),('5815','2013-08-05','09:15:00',1.11),('5815','2013-08-05','09:20:00',1.16),('5815','2013-08-05','09:25:00',1.19),('5815','2013-08-05','09:30:00',1.23),('5815','2013-08-05','09:35:00',1.28),('5815','2013-08-05','09:40:00',1.32),('5815','2013-08-05','09:45:00',1.36),('5815','2013-08-05','09:50:00',1.38),('5815','2013-08-05','09:55:00',1.42),('5815','2013-08-05','10:00:00',1.46),('5815','2013-08-05','10:05:00',1.5),('5815','2013-08-05','10:10:00',1.52),('5815','2013-08-05','10:15:00',1.56),('5815','2013-08-05','10:20:00',1.6),('5815','2013-08-05','10:25:00',1.62),('5815','2013-08-05','10:30:00',1.65),('5815','2013-08-05','10:35:00',1.67),('5815','2013-08-05','10:40:00',1.7),('5815','2013-08-05','10:45:00',1.72),('5815','2013-08-05','10:50:00',1.75),('5815','2013-08-05','10:55:00',1.77),('5815','2013-08-05','11:00:00',1.79),('5815','2013-08-05','11:05:00',1.82),('5815','2013-08-05','11:10:00',1.81),('5815','2013-08-05','11:15:00',1.83),('5815','2013-08-05','11:20:00',1.85),('5815','2013-08-05','11:25:00',1.86),('5815','2013-08-05','11:30:00',1.88),('5815','2013-08-05','11:35:00',1.9),('5815','2013-08-05','11:40:00',1.94),('5815','2013-08-05','11:45:00',1.96),('5815','2013-08-05','11:50:00',1.97),('5815','2013-08-05','11:55:00',1.99),('5815','2013-08-05','12:00:00',2.02),('5815','2013-08-05','12:05:00',2.02),('5815','2013-08-05','12:10:00',2.04),('5815','2013-08-05','12:15:00',2.05),('5815','2013-08-05','12:20:00',2.06),('5815','2013-08-05','12:25:00',2.04),('5815','2013-08-05','12:30:00',2.06),('5815','2013-08-05','12:35:00',2.07),('5815','2013-08-05','12:40:00',2.07),('5815','2013-08-05','12:45:00',2.05),('5815','2013-08-05','12:50:00',2.05),('5815','2013-08-05','12:55:00',2.07),('5815','2013-08-05','13:00:00',2.1),('5815','2013-08-05','13:05:00',2.12),('5815','2013-08-05','13:10:00',2.11),('5815','2013-08-05','13:15:00',2.14),('5815','2013-08-05','13:20:00',2.13),('5815','2013-08-05','13:25:00',2.16),('5815','2013-08-05','13:30:00',2.16),('5815','2013-08-05','13:35:00',2.18),('5815','2013-08-05','13:40:00',2.17),('5815','2013-08-05','13:45:00',2.18),('5815','2013-08-05','13:50:00',2.19),('5815','2013-08-05','13:55:00',2.19),('5815','2013-08-05','14:00:00',2.2),('5815','2013-08-05','14:05:00',2.19),('5815','2013-08-05','14:10:00',2.19),('5815','2013-08-05','14:15:00',2.19),('5815','2013-08-05','14:20:00',2.17),('5815','2013-08-05','14:25:00',2.16),('5815','2013-08-05','14:30:00',2.17),('5815','2013-08-05','14:35:00',2.14),('5815','2013-08-05','14:40:00',2.12),('5815','2013-08-05','14:45:00',2.11),('5815','2013-08-05','14:50:00',2.1),('5815','2013-08-05','14:55:00',2.09),('5815','2013-08-05','15:00:00',2.08),('5815','2013-08-05','15:05:00',2.07),('5815','2013-08-05','15:10:00',2.04),('5815','2013-08-05','15:15:00',2.02),('5815','2013-08-05','15:20:00',2),('5815','2013-08-05','15:25:00',1.97),('5815','2013-08-05','15:30:00',1.95),('5815','2013-08-05','15:35:00',1.93),('5815','2013-08-05','15:40:00',1.88),('5815','2013-08-05','15:45:00',1.87),('5815','2013-08-05','15:50:00',1.85),('5815','2013-08-05','15:55:00',1.82),('5815','2013-08-05','16:00:00',1.78),('5815','2013-08-05','16:05:00',1.75),('5815','2013-08-05','16:10:00',1.72),('5815','2013-08-05','16:15:00',1.68),('5815','2013-08-05','16:20:00',1.65),('5815','2013-08-05','16:25:00',1.61),('5815','2013-08-05','16:30:00',1.59),('5815','2013-08-05','16:35:00',1.55),('5815','2013-08-05','16:40:00',1.5),('5815','2013-08-05','16:45:00',1.45),('5815','2013-08-05','16:50:00',1.43),('5815','2013-08-05','16:55:00',1.37),('5815','2013-08-05','17:00:00',1.31),('5815','2013-08-05','17:05:00',1.28),('5815','2013-08-05','17:10:00',1.23),('5815','2013-08-05','17:15:00',1.18),('5815','2013-08-05','17:20:00',1.13),('5815','2013-08-05','17:25:00',1.08),('5815','2013-08-05','17:30:00',1.04),('5815','2013-08-04','09:00:00',1.01),('5815','2013-08-04','09:05:00',1.06),('5815','2013-08-04','09:10:00',1.1),('5815','2013-08-04','09:15:00',1.14),('5815','2013-08-04','09:20:00',1.18),('5815','2013-08-04','09:25:00',1.22),('5815','2013-08-04','09:30:00',1.26),('5815','2013-08-04','09:35:00',1.3),('5815','2013-08-04','09:40:00',1.33),('5815','2013-08-04','09:45:00',1.37),('5815','2013-08-04','09:50:00',1.4),('5815','2013-08-04','09:55:00',1.45),('5815','2013-08-04','10:00:00',1.48),('5815','2013-08-04','10:05:00',1.52),('5815','2013-08-04','10:10:00',1.56),('5815','2013-08-04','10:15:00',1.59),('5815','2013-08-04','10:20:00',1.62),('5815','2013-08-04','10:25:00',1.64),('5815','2013-08-04','10:30:00',1.68),('5815','2013-08-04','10:35:00',1.71),('5815','2013-08-04','10:40:00',1.74),('5815','2013-08-04','10:45:00',1.77),('5815','2013-08-04','10:50:00',1.8),('5815','2013-08-04','10:55:00',1.83),('5815','2013-08-04','11:00:00',1.84),('5815','2013-08-04','11:05:00',1.87),('5815','2013-08-04','11:10:00',1.85),('5815','2013-08-04','11:15:00',1.87),('5815','2013-08-04','11:20:00',1.9),('5815','2013-08-04','11:25:00',1.92),('5815','2013-08-04','11:30:00',1.93),('5815','2013-08-04','11:35:00',1.96),('5815','2013-08-04','11:40:00',1.95),('5815','2013-08-04','11:45:00',2.04),('5815','2013-08-04','11:50:00',2.04),('5815','2013-08-04','11:55:00',2.04),('5815','2013-08-04','12:00:00',2.05),('5815','2013-08-04','12:05:00',2.07),('5815','2013-08-04','12:10:00',2.09),('5815','2013-08-04','12:15:00',2.08),('5815','2013-08-04','12:20:00',2.1),('5815','2013-08-04','12:25:00',2.11),('5815','2013-08-04','12:30:00',2.12),('5815','2013-08-04','12:35:00',2.12),('5815','2013-08-04','12:40:00',2.15),('5815','2013-08-04','12:45:00',2.18),('5815','2013-08-04','12:50:00',2.16),('5815','2013-08-04','12:55:00',2.16),('5815','2013-08-04','13:00:00',2.18),('5815','2013-08-04','13:05:00',2.19),('5815','2013-08-04','13:10:00',1.67),('5815','2013-08-04','13:15:00',2.14),('5815','2013-08-04','13:20:00',2.16),('5815','2013-08-04','13:25:00',2.16),('5815','2013-08-04','13:30:00',2.15),('5815','2013-08-04','13:35:00',2.16),('5815','2013-08-04','13:40:00',2.15),('5815','2013-08-04','13:45:00',2.16),('5815','2013-08-04','13:50:00',2.16),('5815','2013-08-04','13:55:00',2.11),('5815','2013-08-04','14:00:00',2.11),('5815','2013-08-04','14:05:00',2.14),('5815','2013-08-04','14:10:00',2.11),('5815','2013-08-04','14:15:00',2.1),('5815','2013-08-04','14:20:00',2.11),('5815','2013-08-04','14:25:00',2.07),('5815','2013-08-04','14:30:00',2.08),('5815','2013-08-04','14:35:00',2.07),('5815','2013-08-04','14:40:00',2.06),('5815','2013-08-04','14:45:00',2.06),('5815','2013-08-04','14:50:00',2.03),('5815','2013-08-04','14:55:00',2.02),('5815','2013-08-04','15:00:00',2),('5815','2013-08-04','15:05:00',2),('5815','2013-08-04','15:10:00',1.99),('5815','2013-08-04','15:15:00',1.98),('5815','2013-08-04','15:20:00',1.96),('5815','2013-08-04','15:25:00',1.94),('5815','2013-08-04','15:30:00',1.92),('5815','2013-08-04','15:35:00',1.9),('5815','2013-08-04','15:40:00',1.86),('5815','2013-08-04','15:45:00',1.83),('5815','2013-08-04','15:50:00',1.79),('5815','2013-08-04','15:55:00',1.76),('5815','2013-08-04','16:00:00',1.76),('5815','2013-08-04','16:05:00',1.76),('5815','2013-08-04','16:10:00',1.71),('5815','2013-08-04','16:15:00',1.66),('5815','2013-08-04','16:20:00',1.62),('5815','2013-08-04','16:25:00',1.59),('5815','2013-08-04','16:30:00',1.56),('5815','2013-08-04','16:35:00',1.53),('5815','2013-08-04','16:40:00',1.48),('5815','2013-08-04','16:45:00',1.44),('5815','2013-08-04','16:50:00',1.41),('5815','2013-08-04','16:55:00',1.34),('5815','2013-08-04','17:00:00',1.29),('5815','2013-08-04','17:05:00',1.25),('5815','2013-08-04','17:10:00',1.22),('5815','2013-08-04','17:15:00',1.13),('5815','2013-08-04','17:20:00',1.07),('5815','2013-08-04','17:25:00',1.05),('5815','2013-08-03','08:55:00',1.01),('5815','2013-08-03','09:00:00',1.06),('5815','2013-08-03','09:05:00',1.1),('5815','2013-08-03','09:10:00',1.15),('5815','2013-08-03','09:15:00',1.19),('5815','2013-08-03','09:20:00',1.23),('5815','2013-08-03','09:25:00',1.28),('5815','2013-08-03','09:30:00',1.33),('5815','2013-08-03','09:35:00',1.34),('5815','2013-08-03','09:40:00',1.4),('5815','2013-08-03','09:45:00',1.45),('5815','2013-08-03','09:50:00',1.48),('5815','2013-08-03','09:55:00',1.51),('5815','2013-08-03','10:00:00',1.55),('5815','2013-08-03','10:05:00',1.59),('5815','2013-08-03','10:10:00',1.61),('5815','2013-08-03','10:15:00',1.65),('5815','2013-08-03','10:20:00',1.69),('5815','2013-08-03','10:25:00',1.73),('5815','2013-08-03','10:30:00',1.75),('5815','2013-08-03','10:35:00',1.78),('5815','2013-08-03','10:40:00',1.8),('5815','2013-08-03','10:45:00',1.83),('5815','2013-08-03','10:50:00',1.86),('5815','2013-08-03','10:55:00',1.88),('5815','2013-08-03','11:00:00',1.89),('5815','2013-08-03','11:05:00',1.89),('5815','2013-08-03','11:10:00',1.85),('5815','2013-08-03','11:15:00',1.9),('5815','2013-08-03','11:20:00',1.93),('5815','2013-08-03','11:25:00',1.97),('5815','2013-08-03','11:30:00',1.99),('5815','2013-08-03','11:35:00',2.01),('5815','2013-08-03','11:40:00',2.05),('5815','2013-08-03','11:45:00',2.07),('5815','2013-08-03','11:50:00',2.07),('5815','2013-08-03','11:55:00',2.09),('5815','2013-08-03','12:00:00',2.1),('5815','2013-08-03','12:05:00',2.11),('5815','2013-08-03','12:10:00',2.13),('5815','2013-08-03','12:15:00',2.12),('5815','2013-08-03','12:20:00',2.14),('5815','2013-08-03','12:25:00',2.14),('5815','2013-08-03','12:30:00',2.15),('5815','2013-08-03','12:35:00',2.17),('5815','2013-08-03','12:40:00',2.18),('5815','2013-08-03','12:45:00',2.18),('5815','2013-08-03','12:50:00',2.2),('5815','2013-08-03','12:55:00',2.16),('5815','2013-08-03','13:00:00',2.18),('5815','2013-08-03','13:05:00',2.21),('5815','2013-08-03','13:10:00',2.19),('5815','2013-08-03','13:15:00',2.19),('5815','2013-08-03','13:20:00',2.19),('5815','2013-08-03','13:25:00',2.17),('5815','2013-08-03','13:30:00',2.19),('5815','2013-08-03','13:35:00',2.22),('5815','2013-08-03','13:40:00',2.23),('5815','2013-08-03','13:45:00',2.24),('5815','2013-08-03','13:50:00',2.25),('5815','2013-08-03','13:55:00',2.22),('5815','2013-08-03','14:00:00',2.23),('5815','2013-08-03','14:05:00',2.24),('5815','2013-08-03','14:10:00',2.22),('5815','2013-08-03','14:15:00',2.22),('5815','2013-08-03','14:20:00',2.2),('5815','2013-08-03','14:25:00',2.19),('5815','2013-08-03','14:30:00',2.17),('5815','2013-08-03','14:35:00',2.17),('5815','2013-08-03','14:40:00',2.17),('5815','2013-08-03','14:45:00',2.15),('5815','2013-08-03','14:50:00',2.13),('5815','2013-08-03','14:55:00',2.11),('5815','2013-08-03','15:00:00',2.09),('5815','2013-08-03','15:05:00',2.08),('5815','2013-08-03','15:10:00',2.06),('5815','2013-08-03','15:15:00',2.05),('5815','2013-08-03','15:20:00',2.03),('5815','2013-08-03','15:25:00',1.97),('5815','2013-08-03','15:30:00',1.95),('5815','2013-08-03','15:35:00',1.96),('5815','2013-08-03','15:40:00',1.92),('5815','2013-08-03','15:45:00',1.89),('5815','2013-08-03','15:50:00',1.86),('5815','2013-08-03','15:55:00',1.83),('5815','2013-08-03','16:00:00',1.8),('5815','2013-08-03','16:05:00',1.77),('5815','2013-08-03','16:10:00',1.74),('5815','2013-08-03','16:15:00',1.71),('5815','2013-08-03','16:20:00',1.69),('5815','2013-08-03','16:25:00',1.66),('5815','2013-08-03','16:30:00',1.62),('5815','2013-08-03','16:35:00',1.56),('5815','2013-08-03','16:40:00',1.51),('5815','2013-08-03','16:45:00',1.47),('5815','2013-08-03','16:50:00',1.44),('5815','2013-08-03','16:55:00',1.38),('5815','2013-08-03','17:00:00',1.32),('5815','2013-08-03','17:05:00',1.29),('5815','2013-08-03','17:10:00',1.27),('5815','2013-08-03','17:15:00',1.22),('5815','2013-08-03','17:20:00',1.17),('5815','2013-08-03','17:25:00',1.11),('5815','2013-08-03','17:30:00',1),('5815','2013-08-02','08:55:00',1),('5815','2013-08-02','09:00:00',1.06),('5815','2013-08-02','09:05:00',1.1),('5815','2013-08-02','09:10:00',1.14),('5815','2013-08-02','09:15:00',1.19),('5815','2013-08-02','09:20:00',1.23),('5815','2013-08-02','09:25:00',1.28),('5815','2013-08-02','09:30:00',1.31),('5815','2013-08-02','09:35:00',1.35),('5815','2013-08-02','09:40:00',1.39),('5815','2013-08-02','09:45:00',1.43),('5815','2013-08-02','09:50:00',1.46),('5815','2013-08-02','09:55:00',1.51),('5815','2013-08-02','10:00:00',1.54),('5815','2013-08-02','10:05:00',1.57),('5815','2013-08-02','10:10:00',1.61),('5815','2013-08-02','10:15:00',1.65),('5815','2013-08-02','10:20:00',1.68),('5815','2013-08-02','10:25:00',1.71),('5815','2013-08-02','10:30:00',1.73),('5815','2013-08-02','10:35:00',1.74),('5815','2013-08-02','10:40:00',1.8),('5815','2013-08-02','10:45:00',1.85),('5815','2013-08-02','10:50:00',1.87),('5815','2013-08-02','10:55:00',1.9),('5815','2013-08-02','11:00:00',1.92),('5815','2013-08-02','11:05:00',1.91),('5815','2013-08-02','11:10:00',1.86),('5815','2013-08-02','11:15:00',1.88),('5815','2013-08-02','11:20:00',1.89),('5815','2013-08-02','11:25:00',1.95),('5815','2013-08-02','11:30:00',1.97),('5815','2013-08-02','11:35:00',2),('5815','2013-08-02','11:40:00',2.01),('5815','2013-08-02','11:45:00',2.03),('5815','2013-08-02','11:50:00',2.05),('5815','2013-08-02','11:55:00',2.06),('5815','2013-08-02','12:00:00',2.07),('5815','2013-08-02','12:05:00',2.11),('5815','2013-08-02','12:10:00',2.11),('5815','2013-08-02','12:15:00',2.13),('5815','2013-08-02','12:20:00',2.14),('5815','2013-08-02','12:25:00',2.15),('5815','2013-08-02','12:30:00',2.17),('5815','2013-08-02','12:35:00',2.15),('5815','2013-08-02','12:40:00',2.17),('5815','2013-08-02','12:45:00',2.17),('5815','2013-08-02','12:50:00',2.18),('5815','2013-08-02','12:55:00',2.2),('5815','2013-08-02','13:00:00',2.18),('5815','2013-08-02','13:05:00',2.15),('5815','2013-08-02','13:10:00',2.14),('5815','2013-08-02','13:15:00',2.13),('5815','2013-08-02','13:20:00',2.11),('5815','2013-08-02','13:25:00',1.69),('5815','2013-08-02','13:30:00',2.12),('5815','2013-08-02','13:35:00',2.09),('5815','2013-08-02','13:40:00',2.15),('5815','2013-08-02','13:45:00',2.17),('5815','2013-08-02','13:50:00',2.16),('5815','2013-08-02','13:55:00',2.17),('5815','2013-08-02','14:00:00',2.19),('5815','2013-08-02','14:05:00',2.16),('5815','2013-08-02','14:10:00',2.1),('5815','2013-08-02','14:15:00',2.06),('5815','2013-08-02','14:20:00',2.02),('5815','2013-08-02','14:25:00',2.04),('5815','2013-08-02','14:30:00',2.08),('5815','2013-08-02','14:35:00',2.12),('5815','2013-08-02','14:40:00',2.1),('5815','2013-08-02','14:45:00',2.11),('5815','2013-08-02','14:50:00',2.1),('5815','2013-08-02','14:55:00',2.09),('5815','2013-08-02','15:00:00',2.07),('5815','2013-08-02','15:05:00',2.03),('5815','2013-08-02','15:10:00',2.02),('5815','2013-08-02','15:15:00',1.99),('5815','2013-08-02','15:20:00',2),('5815','2013-08-02','15:25:00',1.99),('5815','2013-08-02','15:30:00',1.97),('5815','2013-08-02','15:35:00',1.92),('5815','2013-08-02','15:40:00',1.92),('5815','2013-08-02','15:45:00',1.89),('5815','2013-08-02','15:50:00',1.88),('5815','2013-08-02','15:55:00',1.84),('5815','2013-08-02','16:00:00',1.8),('5815','2013-08-02','16:05:00',1.76),('5815','2013-08-02','16:10:00',1.71),('5815','2013-08-02','16:15:00',1.66),('5815','2013-08-02','16:20:00',1.62),('5815','2013-08-02','16:25:00',1.61),('5815','2013-08-02','16:30:00',1.59),('5815','2013-08-02','16:35:00',1.53),('5815','2013-08-02','16:40:00',1.48),('5815','2013-08-02','16:45:00',1.45),('5815','2013-08-02','16:50:00',1.42),('5815','2013-08-02','16:55:00',1.35),('5815','2013-08-02','17:00:00',1.28),('5815','2013-08-02','17:05:00',1.23),('5815','2013-08-02','17:10:00',1.24),('5815','2013-08-02','17:15:00',1.2),('5815','2013-08-02','17:20:00',1.16),('5815','2013-08-02','17:25:00',1.1),('5815','2013-08-02','17:30:00',1.01),('5815','2013-08-01','08:55:00',1.04),('5815','2013-08-01','09:00:00',1.09),('5815','2013-08-01','09:05:00',1.13),('5815','2013-08-01','09:10:00',1.18),('5815','2013-08-01','09:15:00',1.23),('5815','2013-08-01','09:20:00',1.27),('5815','2013-08-01','09:25:00',1.31),('5815','2013-08-01','09:30:00',1.35),('5815','2013-08-01','09:35:00',1.4),('5815','2013-08-01','09:40:00',1.43),('5815','2013-08-01','09:45:00',1.47),('5815','2013-08-01','09:50:00',1.5),('5815','2013-08-01','09:55:00',1.53),('5815','2013-08-01','10:00:00',1.56),('5815','2013-08-01','10:05:00',1.61),('5815','2013-08-01','10:10:00',1.64),('5815','2013-08-01','10:15:00',1.67),('5815','2013-08-01','10:20:00',1.67),('5815','2013-08-01','10:25:00',1.73),('5815','2013-08-01','10:30:00',1.77),('5815','2013-08-01','10:35:00',1.8),('5815','2013-08-01','10:40:00',1.82),('5815','2013-08-01','10:45:00',1.85),('5815','2013-08-01','10:50:00',1.88),('5815','2013-08-01','10:55:00',1.89),('5815','2013-08-01','11:00:00',1.91),('5815','2013-08-01','11:05:00',1.9),('5815','2013-08-01','11:10:00',1.9),('5815','2013-08-01','11:15:00',1.92),('5815','2013-08-01','11:20:00',1.95),('5815','2013-08-01','11:25:00',1.97),('5815','2013-08-01','11:30:00',1.99),('5815','2013-08-01','11:35:00',2),('5815','2013-08-01','11:40:00',2.02),('5815','2013-08-01','11:45:00',2.05),('5815','2013-08-01','11:50:00',2.06),('5815','2013-08-01','11:55:00',2.09),('5815','2013-08-01','12:00:00',2.1),('5815','2013-08-01','12:05:00',2.11),('5815','2013-08-01','12:10:00',2.12),('5815','2013-08-01','12:15:00',2.13),('5815','2013-08-01','12:20:00',2.14),('5815','2013-08-01','12:25:00',2.14),('5815','2013-08-01','12:30:00',2.15),('5815','2013-08-01','12:35:00',2.18),('5815','2013-08-01','12:40:00',2.18),('5815','2013-08-01','12:45:00',2.19),('5815','2013-08-01','12:50:00',2.18),('5815','2013-08-01','12:55:00',2.18),('5815','2013-08-01','13:00:00',2.2),('5815','2013-08-01','13:05:00',2.21),('5815','2013-08-01','13:10:00',2.24),('5815','2013-08-01','13:15:00',2.24),('5815','2013-08-01','13:20:00',2.22),('5815','2013-08-01','13:25:00',2.2),('5815','2013-08-01','13:30:00',2.22),('5815','2013-08-01','13:35:00',2.22),('5815','2013-08-01','13:40:00',2.2),('5815','2013-08-01','13:45:00',2.18),('5815','2013-08-01','13:50:00',2.18),('5815','2013-08-01','13:55:00',2.19),('5815','2013-08-01','14:00:00',2.18),('5815','2013-08-01','14:05:00',2.17),('5815','2013-08-01','14:10:00',2.16),('5815','2013-08-01','14:15:00',2.16),('5815','2013-08-01','14:20:00',2.11),('5815','2013-08-01','14:25:00',2.08),('5815','2013-08-01','14:30:00',2.13),('5815','2013-08-01','14:35:00',2.13),('5815','2013-08-01','14:40:00',2.12),('5815','2013-08-01','14:45:00',2.14),('5815','2013-08-01','14:50:00',2.13),('5815','2013-08-01','14:55:00',2.13),('5815','2013-08-01','15:00:00',2.12),('5815','2013-08-01','15:05:00',2.1),('5815','2013-08-01','15:10:00',2.06),('5815','2013-08-01','15:15:00',2.01),('5815','2013-08-01','15:20:00',2.02),('5815','2013-08-01','15:25:00',2.02),('5815','2013-08-01','15:30:00',2),('5815','2013-08-01','15:35:00',1.98),('5815','2013-08-01','15:40:00',1.97),('5815','2013-08-01','15:45:00',1.95),('5815','2013-08-01','15:50:00',1.91),('5815','2013-08-01','15:55:00',1.86),('5815','2013-08-01','16:00:00',1.83),('5815','2013-08-01','16:05:00',1.81),('5815','2013-08-01','16:10:00',1.77),('5815','2013-08-01','16:15:00',1.71),('5815','2013-08-01','16:20:00',1.68),('5815','2013-08-01','16:25:00',1.65),('5815','2013-08-01','16:30:00',1.63),('5815','2013-08-01','16:35:00',1.57),('5815','2013-08-01','16:40:00',1.53),('5815','2013-08-01','16:45:00',1.5),('5815','2013-08-01','16:50:00',1.48),('5815','2013-08-01','16:55:00',1.39),('5815','2013-08-01','17:00:00',1.31),('5815','2013-08-01','17:05:00',1.25),('5815','2013-08-01','17:10:00',1.27),('5815','2013-08-01','17:15:00',1.24),('5815','2013-08-01','17:20:00',1.18),('5815','2013-08-01','17:25:00',1.15),('5815','2013-08-01','17:30:00',1.05),('5815','2013-08-01','17:40:00',1.01),('5815','2013-07-31','08:50:00',1.01),('5815','2013-07-31','08:55:00',1.06),('5815','2013-07-31','09:00:00',1.11),('5815','2013-07-31','09:05:00',1.15),('5815','2013-07-31','09:10:00',1.21),('5815','2013-07-31','09:15:00',1.25),('5815','2013-07-31','09:20:00',1.3),('5815','2013-07-31','09:25:00',1.34),('5815','2013-07-31','09:30:00',1.38),('5815','2013-07-31','09:35:00',1.43),('5815','2013-07-31','09:40:00',1.47),('5815','2013-07-31','09:45:00',1.51),('5815','2013-07-31','09:50:00',1.54),('5815','2013-07-31','09:55:00',1.59),('5815','2013-07-31','10:00:00',1.63),('5815','2013-07-31','10:05:00',1.67),('5815','2013-07-31','10:10:00',1.71),('5815','2013-07-31','10:15:00',1.74),('5815','2013-07-31','10:20:00',1.77),('5815','2013-07-31','10:25:00',1.8),('5815','2013-07-31','10:30:00',1.84),('5815','2013-07-31','10:35:00',1.86),('5815','2013-07-31','10:40:00',1.88),('5815','2013-07-31','10:45:00',1.92),('5815','2013-07-31','10:50:00',1.96),('5815','2013-07-31','10:55:00',1.97),('5815','2013-07-31','11:00:00',1.99),('5815','2013-07-31','11:05:00',1.99),('5815','2013-07-31','11:10:00',2.01),('5815','2013-07-31','11:15:00',2.03),('5815','2013-07-31','11:20:00',2.04),('5815','2013-07-31','11:25:00',2.08),('5815','2013-07-31','11:30:00',2.1),('5815','2013-07-31','11:35:00',2.11),('5815','2013-07-31','11:40:00',2.13),('5815','2013-07-31','11:45:00',2.16),('5815','2013-07-31','11:50:00',2.17),('5815','2013-07-31','11:55:00',2.17),('5815','2013-07-31','12:00:00',2.19),('5815','2013-07-31','12:05:00',2.21),('5815','2013-07-31','12:10:00',2.22),('5815','2013-07-31','12:15:00',2.25),('5815','2013-07-31','12:20:00',2.25),('5815','2013-07-31','12:25:00',2.25),('5815','2013-07-31','12:30:00',2.28),('5815','2013-07-31','12:35:00',2.3),('5815','2013-07-31','12:40:00',2.32),('5815','2013-07-31','12:45:00',2.31),('5815','2013-07-31','12:50:00',2.32),('5815','2013-07-31','12:55:00',2.31),('5815','2013-07-31','13:00:00',2.31),('5815','2013-07-31','13:05:00',2.3),('5815','2013-07-31','13:10:00',2.31),('5815','2013-07-31','13:15:00',2.26),('5815','2013-07-31','13:20:00',2.33),('5815','2013-07-31','13:25:00',2.35),('5815','2013-07-31','13:30:00',2.21),('5815','2013-07-31','13:35:00',2.32),('5815','2013-07-31','13:40:00',2.33),('5815','2013-07-31','13:45:00',2.3),('5815','2013-07-31','13:50:00',2.22),('5815','2013-07-31','13:55:00',2.28),('5815','2013-07-31','14:00:00',2.19),('5815','2013-07-31','14:05:00',2.29),('5815','2013-07-31','14:10:00',2.22),('5815','2013-07-31','14:15:00',2.25),('5815','2013-07-31','14:20:00',2.16),('5815','2013-07-31','14:25:00',2.21),('5815','2013-07-31','14:30:00',2.2),('5815','2013-07-31','14:35:00',1.77),('5815','2013-07-31','14:40:00',2.1),('5815','2013-07-31','14:45:00',1.82),('5815','2013-07-31','14:50:00',1.89),('5815','2013-07-31','14:55:00',2.16),('5815','2013-07-31','15:00:00',2.12),('5815','2013-07-31','15:05:00',2.13),('5815','2013-07-31','15:10:00',1.79),('5815','2013-07-31','15:15:00',1.93),('5815','2013-07-31','15:20:00',2.12),('5815','2013-07-31','15:25:00',2.06),('5815','2013-07-31','15:30:00',2.02),('5815','2013-07-31','15:35:00',1.72),('5815','2013-07-31','15:40:00',1.28),('5815','2013-07-31','15:45:00',1.97),('5815','2013-07-31','15:50:00',1.93),('5815','2013-07-31','15:55:00',1.92),('5815','2013-07-31','16:00:00',1.89),('5815','2013-07-31','16:05:00',1.82),('5815','2013-07-31','16:10:00',1.75),('5815','2013-07-31','16:15:00',1.72),('5815','2013-07-31','16:20:00',1.69),('5815','2013-07-31','16:25:00',1.68),('5815','2013-07-31','16:30:00',1.63),('5815','2013-07-31','16:35:00',1.58),('5815','2013-07-31','16:40:00',1.55),('5815','2013-07-31','16:45:00',1.5),('5815','2013-07-31','16:50:00',1.46),('5815','2013-07-31','16:55:00',1.39),('5815','2013-07-31','17:00:00',1.31),('5815','2013-07-31','17:05:00',1.29),('5815','2013-07-31','17:10:00',1.3),('5815','2013-07-31','17:15:00',1.26),('5815','2013-07-31','17:20:00',1.22),('5815','2013-07-31','17:25:00',1.15),('5815','2013-07-31','17:30:00',1.06),('5815','2013-07-31','17:40:00',1.03),('5815','2013-07-30','08:50:00',1.03),('5815','2013-07-30','08:55:00',1.08),('5815','2013-07-30','09:00:00',1.12),('5815','2013-07-30','09:05:00',1.17),('5815','2013-07-30','09:10:00',1.22),('5815','2013-07-30','09:15:00',1.26),('5815','2013-07-30','09:20:00',1.31),('5815','2013-07-30','09:25:00',1.35),('5815','2013-07-30','09:30:00',1.4),('5815','2013-07-30','09:35:00',1.42),('5815','2013-07-30','09:40:00',1.47),('5815','2013-07-30','09:45:00',1.52),('5815','2013-07-30','09:50:00',1.56),('5815','2013-07-30','09:55:00',1.6),('5815','2013-07-30','10:00:00',1.63),('5815','2013-07-30','10:05:00',1.67),('5815','2013-07-30','10:10:00',1.7),('5815','2013-07-30','10:15:00',1.75),('5815','2013-07-30','10:20:00',1.77),('5815','2013-07-30','10:25:00',1.79),('5815','2013-07-30','10:30:00',1.82),('5815','2013-07-30','10:35:00',1.87),('5815','2013-07-30','10:40:00',1.9),('5815','2013-07-30','10:45:00',1.94),('5815','2013-07-30','10:50:00',1.96),('5815','2013-07-30','10:55:00',1.99),('5815','2013-07-30','11:00:00',2.03),('5815','2013-07-30','11:05:00',2),('5815','2013-07-30','11:10:00',2.02),('5815','2013-07-30','11:15:00',2.04),('5815','2013-07-30','11:20:00',2.06),('5815','2013-07-30','11:25:00',2.08),('5815','2013-07-30','11:30:00',2.09),('5815','2013-07-30','11:35:00',2.11),('5815','2013-07-30','11:40:00',2.13),('5815','2013-07-30','11:45:00',2.15),('5815','2013-07-30','11:50:00',2.18),('5815','2013-07-30','11:55:00',2.2),('5815','2013-07-30','12:00:00',2.2),('5815','2013-07-30','12:05:00',2.21),('5815','2013-07-30','12:10:00',2.21),('5815','2013-07-30','12:15:00',2.23),('5815','2013-07-30','12:20:00',2.22),('5815','2013-07-30','12:25:00',2.3),('5815','2013-07-30','12:30:00',2.3),('5815','2013-07-30','12:35:00',2.32),('5815','2013-07-30','12:40:00',2.34),('5815','2013-07-30','12:45:00',1.69),('5815','2013-07-30','12:50:00',1.78),('5815','2013-07-30','12:55:00',2.42),('5815','2013-07-30','13:00:00',1.03),('5815','2013-07-30','13:05:00',2.48),('5815','2013-07-30','13:10:00',2.28),('5815','2013-07-30','13:15:00',2.38),('5815','2013-07-30','13:20:00',2.17),('5815','2013-07-30','13:25:00',2.32),('5815','2013-07-30','13:30:00',2.36),('5815','2013-07-30','13:35:00',2.3),('5815','2013-07-30','13:40:00',2.4),('5815','2013-07-30','13:45:00',2.44),('5815','2013-07-30','13:50:00',2),('5815','2013-07-30','13:55:00',1.2),('5815','2013-07-30','14:00:00',2.05),('5815','2013-07-30','14:05:00',2.4),('5815','2013-07-30','14:10:00',1.93),('5815','2013-07-30','14:15:00',2.17),('5815','2013-07-30','14:20:00',2.38),('5815','2013-07-30','14:25:00',2.34),('5815','2013-07-30','14:30:00',2.28),('5815','2013-07-30','14:35:00',2.25),('5815','2013-07-30','14:40:00',2.26),('5815','2013-07-30','14:45:00',2.24),('5815','2013-07-30','14:50:00',1.76),('5815','2013-07-30','15:00:00',1.2),('5815','2013-07-30','15:05:00',2.13),('5815','2013-07-30','15:10:00',1.59),('5815','2013-07-30','15:15:00',1.14),('5815','2013-07-30','15:20:00',2.04),('5815','2013-07-30','15:25:00',1.9),('5815','2013-07-30','15:30:00',2.11),('5815','2013-07-30','15:35:00',1.75),('5815','2013-07-30','15:40:00',2.02),('5815','2013-07-30','15:45:00',1.97),('5815','2013-07-30','15:50:00',1.93),('5815','2013-07-30','15:55:00',1.88),('5815','2013-07-30','16:00:00',1.84),('5815','2013-07-30','16:05:00',1.82),('5815','2013-07-30','16:10:00',1.79),('5815','2013-07-30','16:15:00',1.76),('5815','2013-07-30','16:20:00',1.62),('5815','2013-07-30','16:25:00',1.7),('5815','2013-07-30','16:40:00',1.52),('5815','2013-07-30','16:45:00',1.48),('5815','2013-07-30','16:50:00',1.48),('5815','2013-07-30','16:55:00',1.4),('5815','2013-07-30','17:00:00',1.19),('5815','2013-07-30','17:05:00',1.35),('5815','2013-07-30','17:10:00',1.27),('5815','2013-07-30','17:20:00',1.21),('5815','2013-07-30','17:25:00',1.17),('5815','2013-07-30','17:30:00',1.06),('5815','2013-07-30','17:35:00',1.03),('5815','2013-07-30','17:40:00',1.02),('5815','2013-07-29','08:50:00',1.01),('5815','2013-07-29','08:55:00',1.08),('5815','2013-07-29','09:00:00',1.13),('5815','2013-07-29','09:05:00',1.17),('5815','2013-07-29','09:10:00',1.19),('5815','2013-07-29','09:15:00',1.28),('5815','2013-07-29','09:20:00',1.37),('5815','2013-07-29','09:25:00',1.43),('5815','2013-07-29','09:30:00',1.48),('5815','2013-07-29','09:35:00',1.54),('5815','2013-07-29','09:40:00',1.57),('5815','2013-07-29','09:45:00',1.62),('5815','2013-07-29','09:50:00',1.63),('5815','2013-07-29','09:55:00',1.65),('5815','2013-07-29','10:00:00',1.64),('5815','2013-07-29','10:05:00',1.72),('5815','2013-07-29','10:10:00',1.76),('5815','2013-07-29','10:15:00',1.45),('5815','2013-07-29','10:20:00',1.6),('5815','2013-07-29','10:25:00',1.86),('5815','2013-07-29','10:30:00',1.88),('5815','2013-07-29','10:35:00',1.91),('5815','2013-07-29','10:40:00',1.9),('5815','2013-07-29','10:45:00',1.93),('5815','2013-07-29','10:50:00',1.93),('5815','2013-07-29','10:55:00',1.95),('5815','2013-07-29','11:00:00',1.99),('5815','2013-07-29','11:05:00',2.01),('5815','2013-07-29','11:10:00',2.02),('5815','2013-07-29','11:15:00',2.06),('5815','2013-07-29','11:20:00',2),('5815','2013-07-29','11:25:00',1.98),('5815','2013-07-29','11:30:00',1.97),('5815','2013-07-29','11:35:00',1.12),('5815','2013-07-29','11:40:00',1.89),('5815','2013-07-29','11:45:00',2.17),('5815','2013-07-29','11:50:00',2.18),('5815','2013-07-29','11:55:00',2.16),('5815','2013-07-29','12:00:00',2.18),('5815','2013-07-29','12:05:00',2.17),('5815','2013-07-29','12:10:00',2.2),('5815','2013-07-29','12:15:00',2.18),('5815','2013-07-29','12:20:00',2.17),('5815','2013-07-29','12:25:00',2.15),('5815','2013-07-29','12:30:00',2.21),('5815','2013-07-29','12:35:00',2.33),('5815','2013-07-29','12:40:00',2.25),('5815','2013-07-29','12:45:00',1.87),('5815','2013-07-29','12:50:00',2.41),('5815','2013-07-29','12:55:00',2.44),('5815','2013-07-29','13:00:00',1.34),('5815','2013-07-29','13:05:00',1.4),('5815','2013-07-29','13:10:00',2.49),('5815','2013-07-29','13:15:00',2.47),('5815','2013-07-29','13:20:00',1.66),('5815','2013-07-29','13:25:00',1.22),('5815','2013-07-29','13:30:00',2.04),('5815','2013-07-29','13:35:00',2.49),('5815','2013-07-29','13:40:00',2.39),('5815','2013-07-29','13:45:00',2.4),('5815','2013-07-29','13:50:00',2.48),('5815','2013-07-29','13:55:00',2.47),('5815','2013-07-29','14:00:00',2.24),('5815','2013-07-29','14:05:00',2.46),('5815','2013-07-29','14:10:00',2.46),('5815','2013-07-29','14:15:00',2.32),('5815','2013-07-29','14:20:00',2.28),('5815','2013-07-29','14:25:00',2.3),('5815','2013-07-29','14:30:00',1.71),('5815','2013-07-29','14:35:00',2.19),('5815','2013-07-29','14:40:00',2.21),('5815','2013-07-29','14:45:00',2.22),('5815','2013-07-29','14:50:00',2.23),('5815','2013-07-29','14:55:00',2.2),('5815','2013-07-29','15:00:00',2.16),('5815','2013-07-29','15:05:00',2.12),('5815','2013-07-29','15:10:00',1.99),('5815','2013-07-29','15:15:00',2.07),('5815','2013-07-29','15:20:00',2.07),('5815','2013-07-29','15:25:00',2.02),('5815','2013-07-29','15:30:00',1.99),('5815','2013-07-29','15:35:00',1.97),('5815','2013-07-29','15:40:00',1.96),('5815','2013-07-29','15:45:00',1.91),('5815','2013-07-29','15:50:00',1.89),('5815','2013-07-29','15:55:00',1.86),('5815','2013-07-29','16:00:00',1.83),('5815','2013-07-29','16:05:00',1.78),('5815','2013-07-29','16:10:00',1.72),('5815','2013-07-29','16:15:00',1.68),('5815','2013-07-29','16:20:00',1.67),('5815','2013-07-29','16:25:00',1.65),('5815','2013-07-29','16:30:00',1.59),('5815','2013-07-29','16:35:00',1.54),('5815','2013-07-29','16:40:00',1.51),('5815','2013-07-29','16:45:00',1.49),('5815','2013-07-29','16:50:00',1.44),('5815','2013-07-29','16:55:00',1.39),('5815','2013-07-29','17:00:00',1.37),('5815','2013-07-29','17:05:00',1.32),('5815','2013-07-29','17:10:00',1.27),('5815','2013-07-29','17:15:00',1.24),('5815','2013-07-29','17:20:00',1.2),('5815','2013-07-29','17:25:00',1.15),('5815','2013-07-29','17:30:00',1.07),('5815','2013-07-28','09:05:00',1.06),('5815','2013-07-28','09:10:00',1.1),('5815','2013-07-28','09:15:00',1.13),('5815','2013-07-28','09:20:00',1.18),('5815','2013-07-28','09:25:00',1.22),('5815','2013-07-28','09:30:00',1.26),('5815','2013-07-28','09:35:00',1.31),('5815','2013-07-28','09:40:00',1.36),('5815','2013-07-28','09:45:00',1.4),('5815','2013-07-28','09:50:00',1.43),('5815','2013-07-28','09:55:00',1.47),('5815','2013-07-28','10:00:00',1.52),('5815','2013-07-28','10:05:00',1.56),('5815','2013-07-28','10:10:00',1.59),('5815','2013-07-28','10:15:00',1.61),('5815','2013-07-28','10:20:00',1.66),('5815','2013-07-28','10:25:00',1.7),('5815','2013-07-28','10:30:00',1.71),('5815','2013-07-28','10:35:00',1.77),('5815','2013-07-28','10:40:00',1.81),('5815','2013-07-28','10:45:00',1.81),('5815','2013-07-28','10:50:00',1.84),('5815','2013-07-28','10:55:00',1.86),('5815','2013-07-28','11:00:00',1.89),('5815','2013-07-28','11:05:00',1.88),('5815','2013-07-28','11:10:00',1.82),('5815','2013-07-28','11:15:00',1.83),('5815','2013-07-28','11:20:00',1.88),('5815','2013-07-28','11:25:00',1.9),('5815','2013-07-28','11:30:00',1.93),('5815','2013-07-28','11:35:00',1.94),('5815','2013-07-28','11:40:00',1.97),('5815','2013-07-28','11:45:00',2),('5815','2013-07-28','11:50:00',2),('5815','2013-07-28','11:55:00',2),('5815','2013-07-28','12:00:00',2.03),('5815','2013-07-28','12:05:00',2.02),('5815','2013-07-28','12:10:00',2.04),('5815','2013-07-28','12:15:00',2.06),('5815','2013-07-28','12:20:00',2.06),('5815','2013-07-28','12:25:00',2.1),('5815','2013-07-28','12:30:00',2.13),('5815','2013-07-28','12:35:00',2.15),('5815','2013-07-28','12:40:00',2.16),('5815','2013-07-28','12:45:00',2.15),('5815','2013-07-28','12:50:00',2.15),('5815','2013-07-28','12:55:00',2.13),('5815','2013-07-28','13:00:00',2.11),('5815','2013-07-28','13:05:00',2.18),('5815','2013-07-28','13:10:00',2.18),('5815','2013-07-28','13:15:00',2.18),('5815','2013-07-28','13:20:00',2.23),('5815','2013-07-28','13:25:00',2.24),('5815','2013-07-28','13:30:00',2.24),('5815','2013-07-28','13:35:00',2.21),('5815','2013-07-28','13:40:00',2.27),('5815','2013-07-28','13:45:00',2.28),('5815','2013-07-28','13:50:00',2.26),('5815','2013-07-28','13:55:00',2.25),('5815','2013-07-28','14:00:00',2.25),('5815','2013-07-28','14:05:00',2.24),('5815','2013-07-28','14:10:00',2.24),('5815','2013-07-28','14:15:00',2.23),('5815','2013-07-28','14:20:00',2.23),('5815','2013-07-28','14:25:00',2.21),('5815','2013-07-28','14:30:00',2.18),('5815','2013-07-28','14:35:00',2.18),('5815','2013-07-28','14:40:00',2.16),('5815','2013-07-28','14:45:00',2.15),('5815','2013-07-28','14:50:00',2.11),('5815','2013-07-28','14:55:00',2.11),('5815','2013-07-28','15:00:00',2.09),('5815','2013-07-28','15:05:00',2.08),('5815','2013-07-28','15:10:00',2.06),('5815','2013-07-28','15:15:00',2.04),('5815','2013-07-28','15:20:00',2.02),('5815','2013-07-28','15:25:00',2),('5815','2013-07-28','15:30:00',1.97),('5815','2013-07-28','15:35:00',1.95),('5815','2013-07-28','15:40:00',1.97),('5815','2013-07-28','15:45:00',1.97),('5815','2013-07-28','15:50:00',1.74),('5815','2013-07-28','15:55:00',1.11),('5815','2013-07-28','16:05:00',1.46),('5815','2013-07-28','16:10:00',1.66),('5815','2013-07-28','16:15:00',1.62),('5815','2013-07-28','16:20:00',1.45),('5815','2013-07-28','16:25:00',1.35),('5815','2013-07-28','16:30:00',1.72),('5815','2013-07-28','16:35:00',1.61),('5815','2013-07-28','16:40:00',1.26),('5815','2013-07-28','16:45:00',1.62),('5815','2013-07-28','16:50:00',1.54),('5815','2013-07-28','17:20:00',1.15),('5815','2013-07-28','17:25:00',1.13),('5815','2013-07-28','17:45:00',1.02),('5815','2013-07-27','09:00:00',1.03),('5815','2013-07-27','09:05:00',1.08),('5815','2013-07-27','09:10:00',1.12),('5815','2013-07-27','09:15:00',1.17),('5815','2013-07-27','09:20:00',1.21),('5815','2013-07-27','09:25:00',1.24),('5815','2013-07-27','09:30:00',1.3),('5815','2013-07-27','09:35:00',1.34),('5815','2013-07-27','09:40:00',1.39),('5815','2013-07-27','09:45:00',1.42),('5815','2013-07-27','09:50:00',1.46),('5815','2013-07-27','09:55:00',1.49),('5815','2013-07-27','10:00:00',1.52),('5815','2013-07-27','10:05:00',1.55),('5815','2013-07-27','10:10:00',1.58),('5815','2013-07-27','10:15:00',1.61),('5815','2013-07-27','10:20:00',1.64),('5815','2013-07-27','10:25:00',1.67),('5815','2013-07-27','10:30:00',1.68),('5815','2013-07-27','10:35:00',1.71),('5815','2013-07-27','10:40:00',1.77),('5815','2013-07-27','10:45:00',1.79),('5815','2013-07-27','10:50:00',1.81),('5815','2013-07-27','10:55:00',1.83),('5815','2013-07-27','11:00:00',1.84),('5815','2013-07-27','11:05:00',1.83),('5815','2013-07-27','11:10:00',1.82),('5815','2013-07-27','11:15:00',1.85),('5815','2013-07-27','11:20:00',1.91),('5815','2013-07-27','11:25:00',1.93),('5815','2013-07-27','11:30:00',1.93),('5815','2013-07-27','11:35:00',1.95),('5815','2013-07-27','11:40:00',1.94),('5815','2013-07-27','11:45:00',1.95),('5815','2013-07-27','11:50:00',1.96),('5815','2013-07-27','11:55:00',1.98),('5815','2013-07-27','12:00:00',2.03),('5815','2013-07-27','12:05:00',2.07),('5815','2013-07-27','12:10:00',2.04),('5815','2013-07-27','12:15:00',2.07),('5815','2013-07-27','12:20:00',2.01),('5815','2013-07-27','12:25:00',2.06),('5815','2013-07-27','12:30:00',2.1),('5815','2013-07-27','12:35:00',2.18),('5815','2013-07-27','12:40:00',2.18),('5815','2013-07-27','12:45:00',2.15),('5815','2013-07-27','12:50:00',2.14),('5815','2013-07-27','12:55:00',2.13),('5815','2013-07-27','13:00:00',2.16),('5815','2013-07-27','13:05:00',2.14),('5815','2013-07-27','13:10:00',2.05),('5815','2013-07-27','13:15:00',2.19),('5815','2013-07-27','13:20:00',2.2),('5815','2013-07-27','13:25:00',2.19),('5815','2013-07-27','13:30:00',2.17),('5815','2013-07-27','13:35:00',2.21),('5815','2013-07-27','13:40:00',2.21),('5815','2013-07-27','13:45:00',2.19),('5815','2013-07-27','13:50:00',2.26),('5815','2013-07-27','13:55:00',2.23),('5815','2013-07-27','14:00:00',2.21),('5815','2013-07-27','14:05:00',2.21),('5815','2013-07-27','14:10:00',2.2),('5815','2013-07-27','14:15:00',2.19),('5815','2013-07-27','14:20:00',2.18),('5815','2013-07-27','14:25:00',2.16),('5815','2013-07-27','14:30:00',2.15),('5815','2013-07-27','14:35:00',2.12),('5815','2013-07-27','14:40:00',2.15),('5815','2013-07-27','14:45:00',2.12),('5815','2013-07-27','14:50:00',2.1),('5815','2013-07-27','14:55:00',2.07),('5815','2013-07-27','15:00:00',2.05),('5815','2013-07-27','15:05:00',2.03),('5815','2013-07-27','15:10:00',2),('5815','2013-07-27','15:15:00',2.01),('5815','2013-07-27','15:20:00',1.99),('5815','2013-07-27','15:25:00',1.95),('5815','2013-07-27','15:30:00',1.94),('5815','2013-07-27','15:35:00',1.92),('5815','2013-07-27','15:40:00',1.88),('5815','2013-07-27','15:45:00',1.88),('5815','2013-07-27','15:50:00',1.85),('5815','2013-07-27','15:55:00',1.83),('5815','2013-07-27','16:00:00',1.79),('5815','2013-07-27','16:05:00',1.76),('5815','2013-07-27','16:10:00',1.73),('5815','2013-07-27','16:15:00',1.69),('5815','2013-07-27','16:20:00',1.68),('5815','2013-07-27','16:25:00',1.65),('5815','2013-07-27','16:30:00',1.61),('5815','2013-07-27','16:35:00',1.57),('5815','2013-07-27','16:40:00',1.54),('5815','2013-07-27','16:45:00',1.5),('5815','2013-07-27','16:50:00',1.45),('5815','2013-07-27','16:55:00',1.38),('5815','2013-07-27','17:00:00',1.29),('5815','2013-07-27','17:05:00',1.33),('5815','2013-07-27','17:10:00',1.3),('5815','2013-07-27','17:15:00',1.26),('5815','2013-07-27','17:20:00',1.22),('5815','2013-07-27','17:25:00',1.16),('5815','2013-07-27','17:30:00',1.09),('5815','2013-07-27','17:35:00',1.05),('5815','2013-07-27','17:40:00',1.04),('5815','2013-07-26','08:55:00',1.01),('5815','2013-07-26','09:00:00',1.05),('5815','2013-07-26','09:05:00',1.1),('5815','2013-07-26','09:10:00',1.14),('5815','2013-07-26','09:15:00',1.19),('5815','2013-07-26','09:20:00',1.25),('5815','2013-07-26','09:25:00',1.3),('5815','2013-07-26','09:30:00',1.31),('5815','2013-07-26','09:35:00',1.35),('5815','2013-07-26','09:40:00',1.4),('5815','2013-07-26','09:45:00',1.44),('5815','2013-07-26','09:50:00',1.48),('5815','2013-07-26','09:55:00',1.52),('5815','2013-07-26','10:00:00',1.56),('5815','2013-07-26','10:05:00',1.59),('5815','2013-07-26','10:10:00',1.63),('5815','2013-07-26','10:15:00',1.66),('5815','2013-07-26','10:20:00',1.7),('5815','2013-07-26','10:25:00',1.73),('5815','2013-07-26','10:30:00',1.76),('5815','2013-07-26','10:35:00',1.78),('5815','2013-07-26','10:40:00',1.8),('5815','2013-07-26','10:45:00',1.83),('5815','2013-07-26','10:50:00',1.85),('5815','2013-07-26','10:55:00',1.88),('5815','2013-07-26','11:00:00',1.89),('5815','2013-07-26','11:05:00',1.89),('5815','2013-07-26','11:10:00',1.86),('5815','2013-07-26','11:15:00',1.89),('5815','2013-07-26','11:20:00',1.93),('5815','2013-07-26','11:25:00',1.97),('5815','2013-07-26','11:30:00',1.99),('5815','2013-07-26','11:35:00',2.02),('5815','2013-07-26','11:40:00',2.01),('5815','2013-07-26','11:45:00',2.05),('5815','2013-07-26','11:50:00',2.04),('5815','2013-07-26','11:55:00',2.05),('5815','2013-07-26','12:00:00',2.05),('5815','2013-07-26','12:05:00',2.07),('5815','2013-07-26','12:10:00',2.08),('5815','2013-07-26','12:15:00',2.09),('5815','2013-07-26','12:20:00',2.14),('5815','2013-07-26','12:25:00',2.15),('5815','2013-07-26','12:30:00',2.14),('5815','2013-07-26','12:35:00',2.2),('5815','2013-07-26','12:40:00',2.2),('5815','2013-07-26','12:45:00',2.16),('5815','2013-07-26','12:50:00',2.15),('5815','2013-07-26','12:55:00',2.18),('5815','2013-07-26','13:00:00',2.19),('5815','2013-07-26','13:05:00',2.27),('5815','2013-07-26','13:10:00',2.25),('5815','2013-07-26','13:15:00',2.26),('5815','2013-07-26','13:20:00',2.28),('5815','2013-07-26','13:25:00',2.3),('5815','2013-07-26','13:30:00',2.34),('5815','2013-07-26','13:35:00',2.13),('5815','2013-07-26','13:40:00',2.11),('5815','2013-07-26','13:45:00',2.32),('5815','2013-07-26','13:50:00',2.33),('5815','2013-07-26','13:55:00',2.34),('5815','2013-07-26','14:00:00',2.23),('5815','2013-07-26','14:05:00',2.27),('5815','2013-07-26','14:10:00',1.79),('5815','2013-07-26','14:15:00',2.04),('5815','2013-07-26','14:20:00',2.26),('5815','2013-07-26','14:25:00',2.22),('5815','2013-07-26','14:30:00',2.2),('5815','2013-07-26','14:35:00',2.19),('5815','2013-07-26','14:40:00',2.18),('5815','2013-07-26','14:45:00',2.17),('5815','2013-07-26','14:50:00',2.13),('5815','2013-07-26','14:55:00',2.1),('5815','2013-07-26','15:00:00',2.08),('5815','2013-07-26','15:05:00',2.05),('5815','2013-07-26','15:10:00',2.09),('5815','2013-07-26','15:15:00',2.04),('5815','2013-07-26','15:20:00',2.02),('5815','2013-07-26','15:25:00',1.99),('5815','2013-07-26','15:30:00',1.97),('5815','2013-07-26','15:35:00',1.94),('5815','2013-07-26','15:40:00',1.92),('5815','2013-07-26','15:45:00',1.9),('5815','2013-07-26','15:50:00',1.88),('5815','2013-07-26','15:55:00',1.84),('5815','2013-07-26','16:00:00',1.8),('5815','2013-07-26','16:05:00',1.75),('5815','2013-07-26','16:10:00',1.73),('5815','2013-07-26','16:15:00',1.69),('5815','2013-07-26','16:20:00',1.66),('5815','2013-07-26','16:25:00',1.63),('5815','2013-07-26','16:30:00',1.59),('5815','2013-07-26','16:35:00',1.57),('5815','2013-07-26','16:40:00',1.53),('5815','2013-07-26','16:45:00',1.49),('5815','2013-07-26','16:50:00',1.45),('5815','2013-07-26','16:55:00',1.38),('5815','2013-07-26','17:00:00',1.31),('5815','2013-07-26','17:05:00',1.33),('5815','2013-07-26','17:10:00',1.29),('5815','2013-07-26','17:15:00',1.25),('5815','2013-07-26','17:20:00',1.21),('5815','2013-07-26','17:25:00',1.16),('5815','2013-07-26','17:30:00',1.1),('5815','2013-07-26','17:35:00',1.07),('5815','2013-07-26','17:40:00',1.03),('5815','2013-07-25','09:00:00',1.03),('5815','2013-07-25','09:05:00',1.08),('5815','2013-07-25','09:10:00',1.13),('5815','2013-07-25','09:15:00',1.16),('5815','2013-07-25','09:20:00',1.21),('5815','2013-07-25','09:25:00',1.24),('5815','2013-07-25','09:30:00',1.26),('5815','2013-07-25','09:35:00',1.3),('5815','2013-07-25','09:40:00',1.35),('5815','2013-07-25','09:45:00',1.37),('5815','2013-07-25','09:50:00',1.08),('5815','2013-07-25','09:55:00',1.48),('5815','2013-07-25','10:00:00',1.51),('5815','2013-07-25','10:05:00',1.58),('5815','2013-07-25','10:10:00',1.57),('5815','2013-07-25','10:15:00',1.63),('5815','2013-07-25','10:20:00',1.66),('5815','2013-07-25','10:25:00',1.69),('5815','2013-07-25','10:30:00',1.72),('5815','2013-07-25','10:35:00',1.75),('5815','2013-07-25','10:40:00',1.79),('5815','2013-07-25','10:45:00',1.82),('5815','2013-07-25','10:50:00',1.84),('5815','2013-07-25','10:55:00',1.86),('5815','2013-07-25','11:00:00',1.89),('5815','2013-07-25','11:05:00',1.88),('5815','2013-07-25','11:10:00',1.86),('5815','2013-07-25','11:15:00',1.87),('5815','2013-07-25','11:20:00',1.48),('5815','2013-07-25','11:25:00',1.85),('5815','2013-07-25','11:30:00',1.9),('5815','2013-07-25','11:35:00',1.86),('5815','2013-07-25','11:40:00',1.97),('5815','2013-07-25','11:45:00',2.02),('5815','2013-07-25','11:50:00',2.06),('5815','2013-07-25','11:55:00',2.07),('5815','2013-07-25','12:00:00',2.05),('5815','2013-07-25','12:05:00',2.06),('5815','2013-07-25','12:15:00',1.56),('5815','2013-07-25','12:20:00',1.17),('5815','2013-07-25','12:25:00',2.2),('5815','2013-07-25','12:30:00',2.2),('5815','2013-07-25','12:35:00',2.23),('5815','2013-07-25','12:40:00',2.3),('5815','2013-07-25','12:45:00',2.35),('5815','2013-07-25','12:50:00',2.35),('5815','2013-07-25','12:55:00',2.26),('5815','2013-07-25','13:00:00',1.54),('5815','2013-07-25','13:15:00',1.06),('5815','2013-07-25','13:20:00',1.63),('5815','2013-07-25','13:25:00',2.21),('5815','2013-07-25','13:30:00',2.49),('5815','2013-07-25','13:35:00',2.37),('5815','2013-07-25','13:40:00',2.33),('5815','2013-07-25','13:45:00',2.35),('5815','2013-07-25','13:50:00',2.31),('5815','2013-07-25','13:55:00',2.15),('5815','2013-07-25','14:00:00',2.31),('5815','2013-07-25','14:05:00',2.37),('5815','2013-07-25','14:10:00',2.28),('5815','2013-07-25','14:15:00',2.26),('5815','2013-07-25','14:20:00',2.28),('5815','2013-07-25','14:25:00',2.26),('5815','2013-07-25','14:30:00',2.23),('5815','2013-07-25','14:35:00',2.2),('5815','2013-07-25','14:40:00',2.22),('5815','2013-07-25','14:45:00',2.11),('5815','2013-07-25','14:50:00',2.15),('5815','2013-07-25','14:55:00',2.12),('5815','2013-07-25','15:00:00',2.14),('5815','2013-07-25','15:05:00',2.1),('5815','2013-07-25','15:10:00',2.1),('5815','2013-07-25','15:15:00',2.07),('5815','2013-07-25','15:20:00',2.04),('5815','2013-07-25','15:25:00',1.99),('5815','2013-07-25','15:30:00',1.98),('5815','2013-07-25','15:35:00',1.97),('5815','2013-07-25','15:40:00',1.96),('5815','2013-07-25','15:45:00',1.96),('5815','2013-07-25','15:50:00',1.93),('5815','2013-07-25','15:55:00',1.88),('5815','2013-07-25','16:00:00',1.81),('5815','2013-07-25','16:05:00',1.76),('5815','2013-07-25','16:10:00',1.71),('5815','2013-07-25','16:15:00',1.68),('5815','2013-07-25','16:20:00',1.66),('5815','2013-07-25','16:25:00',1.64),('5815','2013-07-25','16:30:00',1.61),('5815','2013-07-25','16:35:00',1.57),('5815','2013-07-25','16:40:00',1.54),('5815','2013-07-25','16:45:00',1.51),('5815','2013-07-25','16:50:00',1.45),('5815','2013-07-25','16:55:00',1.39),('5815','2013-07-25','17:00:00',1.32),('5815','2013-07-25','17:05:00',1.33),('5815','2013-07-25','17:10:00',1.29),('5815','2013-07-25','17:15:00',1.23),('5815','2013-07-25','17:20:00',1.2),('5815','2013-07-25','17:25:00',1.15),('5815','2013-07-25','17:30:00',1.07),('5815','2013-07-25','17:35:00',1.03),('5815','2013-07-24','09:00:00',1.04),('5815','2013-07-24','09:05:00',1.07),('5815','2013-07-24','09:15:00',1.18),('5815','2013-07-24','09:20:00',1.27),('5815','2013-07-24','09:25:00',1.09),('5815','2013-07-24','10:10:00',1.05),('5815','2013-07-24','10:15:00',1.77),('5815','2013-07-24','10:20:00',1.81),('5815','2013-07-24','10:25:00',1.85),('5815','2013-07-24','10:30:00',1.86),('5815','2013-07-24','10:35:00',1.73),('5815','2013-07-24','10:40:00',1.66),('5815','2013-07-24','10:45:00',1.7),('5815','2013-07-24','10:50:00',1.85),('5815','2013-07-24','10:55:00',1.98),('5815','2013-07-24','11:00:00',1.98),('5815','2013-07-24','11:05:00',1.39),('5815','2013-07-24','11:10:00',1.49),('5815','2013-07-24','11:15:00',1.95),('5815','2013-07-24','11:20:00',1.84),('5815','2013-07-24','11:25:00',1.78),('5815','2013-07-24','11:30:00',1.84),('5815','2013-07-24','11:35:00',2.02),('5815','2013-07-24','11:40:00',2.08),('5815','2013-07-24','11:45:00',2.24),('5815','2013-07-24','11:50:00',2.3),('5815','2013-07-24','11:55:00',1.65),('5815','2013-07-24','12:00:00',1.7),('5815','2013-07-24','12:05:00',2.2),('5815','2013-07-24','12:10:00',2.23),('5815','2013-07-24','12:15:00',1.89),('5815','2013-07-24','12:20:00',1.53),('5815','2013-07-24','12:25:00',1.96),('5815','2013-07-24','12:35:00',1.27),('5815','2013-07-24','12:55:00',1.09),('5815','2013-07-24','13:00:00',2.09),('5815','2013-07-24','13:05:00',1.36),('5815','2013-07-24','13:20:00',1.8),('5815','2013-07-24','13:25:00',2.45),('5815','2013-07-24','13:30:00',2.4),('5815','2013-07-24','13:35:00',2.26),('5815','2013-07-24','13:40:00',2.28),('5815','2013-07-24','13:45:00',2.3),('5815','2013-07-24','13:50:00',2.3),('5815','2013-07-24','13:55:00',2.29),('5815','2013-07-24','14:00:00',2.31),('5815','2013-07-24','14:05:00',2.32),('5815','2013-07-24','14:10:00',2.33),('5815','2013-07-24','14:15:00',2.32),('5815','2013-07-24','14:20:00',2.34),('5815','2013-07-24','14:25:00',2.33),('5815','2013-07-24','14:30:00',2.3),('5815','2013-07-24','14:35:00',2.28),('5815','2013-07-24','14:40:00',2.25),('5815','2013-07-24','14:45:00',2.2),('5815','2013-07-24','14:50:00',2.18),('5815','2013-07-24','14:55:00',2.18),('5815','2013-07-24','15:00:00',2.18),('5815','2013-07-24','15:05:00',2.18),('5815','2013-07-24','15:10:00',2.16),('5815','2013-07-24','15:15:00',2.12),('5815','2013-07-24','15:20:00',2.11),('5815','2013-07-24','15:25:00',2.06),('5815','2013-07-24','15:30:00',2.05),('5815','2013-07-24','15:35:00',2.03),('5815','2013-07-24','15:40:00',2.02),('5815','2013-07-24','15:45:00',2.02),('5815','2013-07-24','15:50:00',2),('5815','2013-07-24','15:55:00',1.96),('5815','2013-07-24','16:00:00',1.87),('5815','2013-07-24','16:05:00',1.81),('5815','2013-07-24','16:10:00',1.77),('5815','2013-07-24','16:15:00',1.73),('5815','2013-07-24','16:20:00',1.73),('5815','2013-07-24','16:25:00',1.7),('5815','2013-07-24','16:30:00',1.66),('5815','2013-07-24','16:35:00',1.65),('5815','2013-07-24','16:40:00',1.62),('5815','2013-07-24','16:45:00',1.57),('5815','2013-07-24','16:50:00',1.51),('5815','2013-07-24','16:55:00',1.45),('5815','2013-07-24','17:00:00',1.37),('5815','2013-07-24','17:05:00',1.4),('5815','2013-07-24','17:10:00',1.35),('5815','2013-07-24','17:15:00',1.31),('5815','2013-07-24','17:20:00',1.26),('5815','2013-07-24','17:25:00',1.2),('5815','2013-07-24','17:30:00',1.15),('5815','2013-07-24','17:35:00',1.1),('5815','2013-07-24','17:40:00',1.02),('5815','2013-07-23','09:10:00',1.19),('5815','2013-07-23','09:15:00',1.08),('5815','2013-07-23','09:35:00',1.04),('5815','2013-07-23','09:40:00',1.01),('5815','2013-07-23','09:45:00',1.06),('5815','2013-07-23','09:50:00',1.04),('5815','2013-07-23','10:25:00',1.39),('5815','2013-07-23','10:30:00',1.83),('5815','2013-07-23','10:35:00',1.88),('5815','2013-07-23','10:40:00',2),('5815','2013-07-23','10:45:00',1.99),('5815','2013-07-23','10:50:00',1.44),('5815','2013-07-23','10:55:00',1.33),('5815','2013-07-23','11:10:00',2.06),('5815','2013-07-23','11:15:00',2.08),('5815','2013-07-23','11:20:00',2.11),('5815','2013-07-23','11:25:00',2.12),('5815','2013-07-23','11:30:00',2.12),('5815','2013-07-23','11:35:00',2.19),('5815','2013-07-23','11:40:00',2.1),('5815','2013-07-23','11:45:00',2.12),('5815','2013-07-23','11:50:00',2.14),('5815','2013-07-23','11:55:00',2.15),('5815','2013-07-23','12:00:00',2.23),('5815','2013-07-23','12:05:00',2.34),('5815','2013-07-23','12:10:00',1.9),('5815','2013-07-23','12:20:00',1.54),('5815','2013-07-23','12:25:00',2.45),('5815','2013-07-23','12:30:00',1.42),('5815','2013-07-23','12:40:00',1.25),('5815','2013-07-23','12:45:00',2.4),('5815','2013-07-23','12:50:00',1.21),('5815','2013-07-23','13:00:00',2.38),('5815','2013-07-23','13:05:00',2.21),('5815','2013-07-23','13:15:00',1.53),('5815','2013-07-23','13:25:00',2.19),('5815','2013-07-23','13:30:00',1.09),('5815','2013-07-23','13:35:00',2.53),('5815','2013-07-23','13:40:00',2.03),('5815','2013-07-23','13:45:00',2.28),('5815','2013-07-23','13:50:00',1.83),('5815','2013-07-23','13:55:00',2.48),('5815','2013-07-23','14:00:00',2.45),('5815','2013-07-23','14:05:00',2.44),('5815','2013-07-23','14:10:00',2.42),('5815','2013-07-23','14:15:00',2.42),('5815','2013-07-23','14:20:00',2.38),('5815','2013-07-23','14:25:00',2.28),('5815','2013-07-23','14:30:00',2.36),('5815','2013-07-23','14:35:00',1.78),('5815','2013-07-23','14:40:00',2.35),('5815','2013-07-23','14:45:00',2.28),('5815','2013-07-23','14:50:00',2.33),('5815','2013-07-23','14:55:00',2.31),('5815','2013-07-23','15:00:00',2.22),('5815','2013-07-23','15:05:00',2.24),('5815','2013-07-23','15:10:00',2.18),('5815','2013-07-23','15:15:00',2.18),('5815','2013-07-23','15:20:00',2.16),('5815','2013-07-23','15:25:00',2.12),('5815','2013-07-23','15:30:00',1.97),('5815','2013-07-23','15:35:00',1.98),('5815','2013-07-23','15:40:00',2.02),('5815','2013-07-23','15:45:00',1.97),('5815','2013-07-23','15:50:00',1.93),('5815','2013-07-23','15:55:00',1.96),('5815','2013-07-23','16:00:00',1.88),('5815','2013-07-23','16:05:00',1.8),('5815','2013-07-23','16:10:00',1.74),('5815','2013-07-23','16:15:00',1.6),('5815','2013-07-23','16:20:00',1.82),('5815','2013-07-23','16:25:00',1.72),('5815','2013-07-23','16:30:00',1.75),('5815','2013-07-23','16:35:00',1.62),('5815','2013-07-23','16:40:00',1.65),('5815','2013-07-23','16:45:00',1.51),('5815','2013-07-23','16:50:00',1.5),('5815','2013-07-23','16:55:00',1.56),('5815','2013-07-23','17:00:00',1.51),('5815','2013-07-23','17:05:00',1.29),('5815','2013-07-23','17:15:00',1.33),('5815','2013-07-23','17:20:00',1.3),('5815','2013-07-23','17:25:00',1.25),('5815','2013-07-23','17:30:00',1.17),('5815','2013-07-23','17:35:00',1.12),('5815','2013-07-23','17:40:00',1.05),('5815','2013-07-23','17:45:00',1.01),('5815','2013-07-22','08:50:00',1.03),('5815','2013-07-22','08:55:00',1.08),('5815','2013-07-22','09:00:00',1.13),('5815','2013-07-22','09:05:00',1.18),('5815','2013-07-22','09:10:00',1.21),('5815','2013-07-22','09:15:00',1.26),('5815','2013-07-22','09:20:00',1.3),('5815','2013-07-22','09:25:00',1.33),('5815','2013-07-22','09:30:00',1.36),('5815','2013-07-22','09:35:00',1.41),('5815','2013-07-22','09:40:00',1.44),('5815','2013-07-22','09:45:00',1.47),('5815','2013-07-22','09:50:00',1.5),('5815','2013-07-22','09:55:00',1.53),('5815','2013-07-22','10:00:00',1.55),('5815','2013-07-22','10:05:00',1.6),('5815','2013-07-22','10:10:00',1.63),('5815','2013-07-22','10:15:00',1.66),('5815','2013-07-22','10:20:00',1.7),('5815','2013-07-22','10:25:00',1.74),('5815','2013-07-22','10:30:00',1.78),('5815','2013-07-22','10:35:00',1.84),('5815','2013-07-22','10:40:00',1.86),('5815','2013-07-22','10:45:00',1.9),('5815','2013-07-22','10:50:00',1.91),('5815','2013-07-22','10:55:00',1.93),('5815','2013-07-22','11:00:00',1.96),('5815','2013-07-22','11:05:00',1.94),('5815','2013-07-22','11:10:00',1.92),('5815','2013-07-22','11:15:00',2),('5815','2013-07-22','11:20:00',2.02),('5815','2013-07-22','11:25:00',2.04),('5815','2013-07-22','11:30:00',2.07),('5815','2013-07-22','11:35:00',2.1),('5815','2013-07-22','11:40:00',2.1),('5815','2013-07-22','11:45:00',2.14),('5815','2013-07-22','11:50:00',2.09),('5815','2013-07-22','11:55:00',2.09),('5815','2013-07-22','12:00:00',2.16),('5815','2013-07-22','12:05:00',2.18),('5815','2013-07-22','12:10:00',2.2),('5815','2013-07-22','12:15:00',2.23),('5815','2013-07-22','12:20:00',2.22),('5815','2013-07-22','12:25:00',2.25),('5815','2013-07-22','12:30:00',2.27),('5815','2013-07-22','12:35:00',2.24),('5815','2013-07-22','12:40:00',2.27),('5815','2013-07-22','12:45:00',1.61),('5815','2013-07-22','12:50:00',1.63),('5815','2013-07-22','12:55:00',1.46),('5815','2013-07-22','13:10:00',1.6),('5815','2013-07-22','13:15:00',1.74),('5815','2013-07-22','13:30:00',1.57),('5815','2013-07-22','13:35:00',2.46),('5815','2013-07-22','13:40:00',2.43),('5815','2013-07-22','13:45:00',2.33),('5815','2013-07-22','13:50:00',1.52),('5815','2013-07-22','13:55:00',1.6),('5815','2013-07-22','14:00:00',2.42),('5815','2013-07-22','14:05:00',1.3),('5815','2013-07-22','14:40:00',2.24),('5815','2013-07-22','14:45:00',1.63),('5815','2013-07-22','14:50:00',2.34),('5815','2013-07-22','14:55:00',2.42),('5815','2013-07-22','15:00:00',1.55),('5815','2013-07-22','15:05:00',2.5),('5815','2013-07-22','15:10:00',2.36),('5815','2013-07-22','15:15:00',2.19),('5815','2013-07-22','15:20:00',2.2),('5815','2013-07-22','15:25:00',2.1),('5815','2013-07-22','15:30:00',2.06),('5815','2013-07-22','15:35:00',1.42),('5815','2013-07-22','15:40:00',2),('5815','2013-07-22','15:45:00',1.96),('5815','2013-07-22','15:50:00',1.95),('5815','2013-07-22','15:55:00',1.92),('5815','2013-07-22','16:00:00',1.85),('5815','2013-07-22','16:05:00',1.79),('5815','2013-07-22','16:10:00',1.73),('5815','2013-07-22','16:15:00',1.71),('5815','2013-07-22','16:20:00',1.72),('5815','2013-07-22','16:25:00',1.68),('5815','2013-07-22','16:30:00',1.63),('5815','2013-07-22','16:35:00',1.54),('5815','2013-07-22','16:40:00',1.49),('5815','2013-07-22','16:45:00',1.51),('5815','2013-07-22','16:50:00',1.46),('5815','2013-07-22','16:55:00',1.42),('5815','2013-07-22','17:00:00',1.39),('5815','2013-07-22','17:05:00',1.35),('5815','2013-07-22','17:10:00',1.33),('5815','2013-07-22','17:15:00',1.31),('5815','2013-07-22','17:20:00',1.26),('5815','2013-07-22','17:25:00',1.22),('5815','2013-07-22','17:30:00',1.16),('5815','2013-07-22','17:35:00',1.11),('5815','2013-07-22','17:40:00',1.09),('5815','2013-07-22','17:45:00',1.05),('5815','2013-07-22','17:50:00',1),('5815','2013-07-21','08:50:00',1.02),('5815','2013-07-21','08:55:00',1.07),('5815','2013-07-21','09:00:00',1.12),('5815','2013-07-21','09:05:00',1.16),('5815','2013-07-21','09:10:00',1.21),('5815','2013-07-21','09:15:00',1.25),('5815','2013-07-21','09:20:00',1.29),('5815','2013-07-21','09:25:00',1.33),('5815','2013-07-21','09:30:00',1.37),('5815','2013-07-21','09:35:00',1.41),('5815','2013-07-21','09:40:00',1.45),('5815','2013-07-21','09:45:00',1.5),('5815','2013-07-21','09:50:00',1.53),('5815','2013-07-21','09:55:00',1.57),('5815','2013-07-21','10:00:00',1.6),('5815','2013-07-21','10:05:00',1.64),('5815','2013-07-21','10:10:00',1.67),('5815','2013-07-21','10:15:00',1.71),('5815','2013-07-21','10:20:00',1.74),('5815','2013-07-21','10:25:00',1.77),('5815','2013-07-21','10:30:00',1.81),('5815','2013-07-21','10:35:00',1.83),('5815','2013-07-21','10:40:00',1.86),('5815','2013-07-21','10:45:00',1.88),('5815','2013-07-21','10:50:00',1.91),('5815','2013-07-21','10:55:00',1.93),('5815','2013-07-21','11:00:00',1.94),('5815','2013-07-21','11:05:00',1.9),('5815','2013-07-21','11:10:00',1.89),('5815','2013-07-21','11:15:00',1.95),('5815','2013-07-21','11:20:00',1.96),('5815','2013-07-21','11:25:00',1.98),('5815','2013-07-21','11:30:00',2),('5815','2013-07-21','11:35:00',2.02),('5815','2013-07-21','11:40:00',2.04),('5815','2013-07-21','11:45:00',2.07),('5815','2013-07-21','11:50:00',2.05),('5815','2013-07-21','11:55:00',2.05),('5815','2013-07-21','12:00:00',2.07),('5815','2013-07-21','12:05:00',2.09),('5815','2013-07-21','12:10:00',2.11),('5815','2013-07-21','12:15:00',2.12),('5815','2013-07-21','12:20:00',2.13),('5815','2013-07-21','12:25:00',2.17),('5815','2013-07-21','12:30:00',2.21),('5815','2013-07-21','12:35:00',2.21),('5815','2013-07-21','12:40:00',2.2),('5815','2013-07-21','12:45:00',2.19),('5815','2013-07-21','12:50:00',2.18),('5815','2013-07-21','12:55:00',2.2),('5815','2013-07-21','13:00:00',2.24),('5815','2013-07-21','13:05:00',2.24),('5815','2013-07-21','13:10:00',2.22),('5815','2013-07-21','13:15:00',1.86),('5815','2013-07-21','13:20:00',2.24),('5815','2013-07-21','13:25:00',2.24),('5815','2013-07-21','13:30:00',2.23),('5815','2013-07-21','13:35:00',2.24),('5815','2013-07-21','13:40:00',2.26),('5815','2013-07-21','13:45:00',2.21),('5815','2013-07-21','13:50:00',2.23),('5815','2013-07-21','13:55:00',2.19),('5815','2013-07-21','14:00:00',2.2),('5815','2013-07-21','14:05:00',2.16),('5815','2013-07-21','14:10:00',2.19),('5815','2013-07-21','14:15:00',1.89),('5815','2013-07-21','14:20:00',2.1),('5815','2013-07-21','14:25:00',2.19),('5815','2013-07-21','14:30:00',2.16),('5815','2013-07-21','14:35:00',2.16),('5815','2013-07-21','14:40:00',2.14),('5815','2013-07-21','14:45:00',2.13),('5815','2013-07-21','14:50:00',2.11),('5815','2013-07-21','14:55:00',2.05),('5815','2013-07-21','15:00:00',2.03),('5815','2013-07-21','15:05:00',1.91),('5815','2013-07-21','15:10:00',2.06),('5815','2013-07-21','15:15:00',2.05),('5815','2013-07-21','15:20:00',2.01),('5815','2013-07-21','15:25:00',1.97),('5815','2013-07-21','15:40:00',1.93),('5815','2013-07-21','15:45:00',2.05),('5815','2013-07-21','15:50:00',2),('5815','2013-07-21','15:55:00',2.08),('5815','2013-07-21','16:00:00',1.88),('5815','2013-07-21','16:05:00',1.06),('5815','2013-07-21','16:15:00',1.56),('5815','2013-07-21','16:20:00',1.89),('5815','2013-07-21','16:25:00',1.85),('5815','2013-07-21','16:30:00',1.72),('5815','2013-07-21','16:35:00',1.62),('5815','2013-07-21','16:40:00',1.52),('5815','2013-07-21','16:45:00',1.51),('5815','2013-07-21','16:50:00',1.47),('5815','2013-07-21','16:55:00',1.41),('5815','2013-07-21','17:00:00',1.4),('5815','2013-07-21','17:05:00',1.38),('5815','2013-07-21','17:10:00',1.34),('5815','2013-07-21','17:15:00',1.29),('5815','2013-07-21','17:20:00',1.25),('5815','2013-07-21','17:25:00',1.17),('5815','2013-07-21','17:30:00',1.15),('5815','2013-07-21','17:35:00',1.14),('5815','2013-07-21','17:40:00',1.06),('5815','2013-07-20','08:55:00',1.01),('5815','2013-07-20','09:00:00',1.07),('5815','2013-07-20','09:05:00',1.11),('5815','2013-07-20','09:10:00',1.15),('5815','2013-07-20','09:15:00',1.19),('5815','2013-07-20','09:20:00',1.24),('5815','2013-07-20','09:25:00',1.29),('5815','2013-07-20','09:30:00',1.32),('5815','2013-07-20','09:35:00',1.36),('5815','2013-07-20','09:40:00',1.4),('5815','2013-07-20','09:45:00',1.44),('5815','2013-07-20','09:50:00',1.47),('5815','2013-07-20','09:55:00',1.51),('5815','2013-07-20','10:00:00',1.55),('5815','2013-07-20','10:05:00',1.59),('5815','2013-07-20','10:10:00',1.61),('5815','2013-07-20','10:15:00',1.66),('5815','2013-07-20','10:20:00',1.69),('5815','2013-07-20','10:25:00',1.72),('5815','2013-07-20','10:30:00',1.73),('5815','2013-07-20','10:35:00',1.76),('5815','2013-07-20','10:40:00',1.8),('5815','2013-07-20','10:45:00',1.83),('5815','2013-07-20','10:50:00',1.86),('5815','2013-07-20','10:55:00',1.86),('5815','2013-07-20','11:00:00',1.9),('5815','2013-07-20','11:05:00',1.85),('5815','2013-07-20','11:10:00',1.82),('5815','2013-07-20','11:15:00',1.93),('5815','2013-07-20','11:20:00',1.94),('5815','2013-07-20','11:25:00',1.97),('5815','2013-07-20','11:30:00',1.98),('5815','2013-07-20','11:35:00',2),('5815','2013-07-20','11:40:00',2.08),('5815','2013-07-20','11:45:00',1.83),('5815','2013-07-20','11:50:00',2.11),('5815','2013-07-20','11:55:00',2.08),('5815','2013-07-20','12:00:00',2.1),('5815','2013-07-20','12:05:00',2.01),('5815','2013-07-20','12:10:00',2.15),('5815','2013-07-20','12:15:00',2.25),('5815','2013-07-20','12:20:00',2.31),('5815','2013-07-20','12:25:00',2.39),('5815','2013-07-20','12:30:00',2.41),('5815','2013-07-20','12:35:00',2.34),('5815','2013-07-20','12:40:00',2.41),('5815','2013-07-20','12:45:00',2),('5815','2013-07-20','12:50:00',2.55),('5815','2013-07-20','12:55:00',2.66),('5815','2013-07-20','13:00:00',2.56),('5815','2013-07-20','13:05:00',2.62),('5815','2013-07-20','13:10:00',2.47),('5815','2013-07-20','13:15:00',2.21),('5815','2013-07-20','13:20:00',1.9),('5815','2013-07-20','13:25:00',2.51),('5815','2013-07-20','13:30:00',2.38),('5815','2013-07-20','13:35:00',1.22),('5815','2013-07-20','14:45:00',1.25),('5815','2013-07-20','14:50:00',1.32),('5815','2013-07-20','14:55:00',1.05),('5815','2013-07-20','15:15:00',1.87),('5815','2013-07-20','15:20:00',1.8),('5815','2013-07-20','15:40:00',2.34),('5815','2013-07-20','15:45:00',1.19),('5815','2013-07-20','15:50:00',1.35),('5815','2013-07-20','15:55:00',1.27),('5815','2013-07-19','08:50:00',1.04),('5815','2013-07-19','08:55:00',1.09),('5815','2013-07-19','09:00:00',1.15),('5815','2013-07-19','09:05:00',1.2),('5815','2013-07-19','09:10:00',1.27),('5815','2013-07-19','09:15:00',1.33),('5815','2013-07-19','09:20:00',1.36),('5815','2013-07-19','09:25:00',1.35),('5815','2013-07-19','09:30:00',1.36),('5815','2013-07-19','09:35:00',1.4),('5815','2013-07-19','09:40:00',1.4),('5815','2013-07-19','09:45:00',1.48),('5815','2013-07-19','09:50:00',1.45),('5815','2013-07-19','09:55:00',1.49),('5815','2013-07-19','10:00:00',1.59),('5815','2013-07-19','10:05:00',1.61),('5815','2013-07-19','10:10:00',1.66),('5815','2013-07-19','10:15:00',1.69),('5815','2013-07-19','10:20:00',1.72),('5815','2013-07-19','10:25:00',1.76),('5815','2013-07-19','10:30:00',1.78),('5815','2013-07-19','10:35:00',1.82),('5815','2013-07-19','10:40:00',1.85),('5815','2013-07-19','10:45:00',1.87),('5815','2013-07-19','10:50:00',1.92),('5815','2013-07-19','10:55:00',1.93),('5815','2013-07-19','11:00:00',1.95),('5815','2013-07-19','11:05:00',1.9),('5815','2013-07-19','11:10:00',1.9),('5815','2013-07-19','11:15:00',1.96),('5815','2013-07-19','11:20:00',1.98),('5815','2013-07-19','11:25:00',1.98),('5815','2013-07-19','11:30:00',2.01),('5815','2013-07-19','11:35:00',2.01),('5815','2013-07-19','11:40:00',2.06),('5815','2013-07-19','11:45:00',2.09),('5815','2013-07-19','11:50:00',2.09),('5815','2013-07-19','11:55:00',2.12),('5815','2013-07-19','12:00:00',2.16),('5815','2013-07-19','12:05:00',2.18),('5815','2013-07-19','12:10:00',2.21),('5815','2013-07-19','12:15:00',2.18),('5815','2013-07-19','12:20:00',2.01),('5815','2013-07-19','12:25:00',2.2),('5815','2013-07-19','12:30:00',2.22),('5815','2013-07-19','12:35:00',2.18),('5815','2013-07-19','12:40:00',2.21),('5815','2013-07-19','12:45:00',2.3),('5815','2013-07-19','12:50:00',2.27),('5815','2013-07-19','12:55:00',2.26),('5815','2013-07-19','13:00:00',2.36),('5815','2013-07-19','13:05:00',2.34),('5815','2013-07-19','13:10:00',2.27),('5815','2013-07-19','13:15:00',2.1),('5815','2013-07-19','13:20:00',2.09),('5815','2013-07-19','13:25:00',2.33),('5815','2013-07-19','13:30:00',2.4),('5815','2013-07-19','13:35:00',2.4),('5815','2013-07-19','13:40:00',2.42),('5815','2013-07-19','13:45:00',2.41),('5815','2013-07-19','13:50:00',1.67),('5815','2013-07-19','14:00:00',2),('5815','2013-07-19','14:05:00',2.46),('5815','2013-07-19','14:10:00',2.25),('5815','2013-07-19','14:15:00',1.9),('5815','2013-07-19','14:20:00',1.32),('5815','2013-07-19','14:25:00',2.41),('5815','2013-07-19','14:30:00',2.33),('5815','2013-07-19','14:35:00',1.61),('5815','2013-07-19','14:40:00',2.08),('5815','2013-07-19','14:50:00',1.75),('5815','2013-07-19','15:05:00',2.3),('5815','2013-07-19','15:10:00',2.22),('5815','2013-07-19','15:15:00',2.15),('5815','2013-07-19','15:20:00',2.1),('5815','2013-07-19','15:25:00',2.04),('5815','2013-07-19','15:30:00',2),('5815','2013-07-19','15:35:00',1.97),('5815','2013-07-19','15:40:00',1.94),('5815','2013-07-19','15:45:00',1.96),('5815','2013-07-19','15:50:00',1.91),('5815','2013-07-19','15:55:00',1.87),('5815','2013-07-19','16:00:00',1.8),('5815','2013-07-19','16:05:00',1.77),('5815','2013-07-19','16:10:00',1.75),('5815','2013-07-19','16:15:00',1.74),('5815','2013-07-19','16:20:00',1.72),('5815','2013-07-19','16:25:00',1.69),('5815','2013-07-19','16:30:00',1.65),('5815','2013-07-19','16:35:00',1.62),('5815','2013-07-19','16:40:00',1.57),('5815','2013-07-19','16:45:00',1.52),('5815','2013-07-19','16:50:00',1.47),('5815','2013-07-19','16:55:00',1.42),('5815','2013-07-19','17:00:00',1.39),('5815','2013-07-19','17:05:00',1.35),('5815','2013-07-19','17:10:00',1.31),('5815','2013-07-19','17:15:00',1.28),('5815','2013-07-19','17:20:00',1.24),('5815','2013-07-19','17:25:00',1.19),('5815','2013-07-19','17:30:00',1.15),('5815','2013-07-19','17:35:00',1.12),('5815','2013-07-19','17:40:00',1.06),('5815','2013-07-19','17:45:00',1.02),('5815','2013-07-18','08:55:00',1.03),('5815','2013-07-18','09:00:00',1.07),('5815','2013-07-18','09:05:00',1.11),('5815','2013-07-18','09:10:00',1.14),('5815','2013-07-18','09:15:00',1.19),('5815','2013-07-18','09:20:00',1.23),('5815','2013-07-18','09:25:00',1.27),('5815','2013-07-18','09:30:00',1.31),('5815','2013-07-18','09:35:00',1.36),('5815','2013-07-18','09:40:00',1.4),('5815','2013-07-18','09:45:00',1.43),('5815','2013-07-18','09:50:00',1.46),('5815','2013-07-18','09:55:00',1.49),('5815','2013-07-18','10:00:00',1.53),('5815','2013-07-18','10:05:00',1.55),('5815','2013-07-18','10:10:00',1.58),('5815','2013-07-18','10:15:00',1.61),('5815','2013-07-18','10:20:00',1.63),('5815','2013-07-18','10:25:00',1.71),('5815','2013-07-18','10:30:00',1.68),('5815','2013-07-18','10:35:00',1.77),('5815','2013-07-18','10:40:00',1.73),('5815','2013-07-18','10:45:00',1.78),('5815','2013-07-18','10:50:00',1.82),('5815','2013-07-18','10:55:00',1.84),('5815','2013-07-18','11:00:00',1.86),('5815','2013-07-18','11:05:00',1.82),('5815','2013-07-18','11:10:00',1.83),('5815','2013-07-18','11:15:00',1.87),('5815','2013-07-18','11:20:00',1.9),('5815','2013-07-18','11:25:00',1.93),('5815','2013-07-18','11:30:00',1.94),('5815','2013-07-18','11:35:00',1.92),('5815','2013-07-18','11:40:00',1.94),('5815','2013-07-18','11:45:00',2.08),('5815','2013-07-18','11:50:00',2.04),('5815','2013-07-18','11:55:00',1.99),('5815','2013-07-18','12:00:00',1.47),('5815','2013-07-18','12:05:00',1.87),('5815','2013-07-18','12:10:00',2.14),('5815','2013-07-18','12:15:00',2.21),('5815','2013-07-18','12:20:00',2.19),('5815','2013-07-18','12:25:00',2.21),('5815','2013-07-18','12:30:00',2.22),('5815','2013-07-18','12:35:00',2.2),('5815','2013-07-18','12:40:00',2.2),('5815','2013-07-18','12:45:00',2.17),('5815','2013-07-18','12:50:00',2.23),('5815','2013-07-18','12:55:00',1.6),('5815','2013-07-18','13:00:00',1.76),('5815','2013-07-18','13:05:00',2.32),('5815','2013-07-18','13:10:00',2.32),('5815','2013-07-18','13:15:00',1.21),('5815','2013-07-18','13:25:00',1.74),('5815','2013-07-18','13:30:00',2.51),('5815','2013-07-18','13:35:00',2.41),('5815','2013-07-18','13:40:00',2.38),('5815','2013-07-18','13:45:00',2.37),('5815','2013-07-18','13:50:00',2.38),('5815','2013-07-18','13:55:00',2.39),('5815','2013-07-18','14:00:00',2.42),('5815','2013-07-18','14:05:00',2.39),('5815','2013-07-18','14:10:00',1.94),('5815','2013-07-18','14:15:00',2.23),('5815','2013-07-18','14:20:00',1.89),('5815','2013-07-18','14:25:00',1.95),('5815','2013-07-18','14:30:00',2.23),('5815','2013-07-18','14:35:00',2.39),('5815','2013-07-18','14:40:00',2.11),('5815','2013-07-18','14:45:00',2.27),('5815','2013-07-18','14:50:00',2.06),('5815','2013-07-18','14:55:00',2.2),('5815','2013-07-18','15:00:00',2.03),('5815','2013-07-18','15:05:00',2.25),('5815','2013-07-18','15:10:00',2.17),('5815','2013-07-18','15:15:00',1.85),('5815','2013-07-18','15:20:00',1.69),('5815','2013-07-18','15:25:00',1.68),('5815','2013-07-18','15:30:00',2.17),('5815','2013-07-18','15:35:00',2.09),('5815','2013-07-18','15:40:00',1.82),('5815','2013-07-18','15:45:00',2.02),('5815','2013-07-18','15:50:00',2.01),('5815','2013-07-18','15:55:00',1.89),('5815','2013-07-18','16:00:00',1.92),('5815','2013-07-18','16:05:00',1.87),('5815','2013-07-18','16:10:00',1.78),('5815','2013-07-18','16:15:00',1.8),('5815','2013-07-18','16:20:00',1.79),('5815','2013-07-18','16:25:00',1.77),('5815','2013-07-18','16:30:00',1.74),('5815','2013-07-18','16:35:00',1.67),('5815','2013-07-18','16:40:00',1.65),('5815','2013-07-18','16:45:00',1.64),('5815','2013-07-18','16:50:00',1.5),('5815','2013-07-18','16:55:00',1.6),('5815','2013-07-18','17:00:00',1.13),('5815','2013-07-18','17:05:00',1.57),('5815','2013-07-18','17:10:00',1.51),('5815','2013-07-18','17:15:00',1.25),('5815','2013-07-18','17:25:00',1.1),('5815','2013-07-18','17:30:00',1.13),('5815','2013-07-18','17:35:00',1.03),('5815','2013-07-17','08:50:00',1.02),('5815','2013-07-17','08:55:00',1.07),('5815','2013-07-17','09:00:00',1.11),('5815','2013-07-17','09:05:00',1.16),('5815','2013-07-17','09:10:00',1.19),('5815','2013-07-17','09:15:00',1.23),('5815','2013-07-17','09:20:00',1.29),('5815','2013-07-17','09:25:00',1.32),('5815','2013-07-17','09:30:00',1.37),('5815','2013-07-17','09:35:00',1.41),('5815','2013-07-17','09:40:00',1.45),('5815','2013-07-17','09:45:00',1.48),('5815','2013-07-17','09:50:00',1.53),('5815','2013-07-17','09:55:00',1.56),('5815','2013-07-17','10:00:00',1.59),('5815','2013-07-17','10:05:00',1.6),('5815','2013-07-17','10:10:00',1.67),('5815','2013-07-17','10:15:00',1.7),('5815','2013-07-17','10:20:00',1.72),('5815','2013-07-17','10:25:00',1.76),('5815','2013-07-17','10:30:00',1.8),('5815','2013-07-17','10:35:00',1.84),('5815','2013-07-17','10:40:00',1.87),('5815','2013-07-17','10:45:00',1.89),('5815','2013-07-17','10:50:00',1.92),('5815','2013-07-17','10:55:00',1.93),('5815','2013-07-17','11:00:00',1.94),('5815','2013-07-17','11:05:00',1.9),('5815','2013-07-17','11:10:00',1.94),('5815','2013-07-17','11:15:00',1.97),('5815','2013-07-17','11:20:00',1.99),('5815','2013-07-17','11:25:00',1.99),('5815','2013-07-17','11:30:00',2.01),('5815','2013-07-17','11:35:00',2.02),('5815','2013-07-17','11:40:00',2.05),('5815','2013-07-17','11:45:00',2.06),('5815','2013-07-17','11:50:00',2.03),('5815','2013-07-17','11:55:00',2.08),('5815','2013-07-17','12:00:00',2.11),('5815','2013-07-17','12:05:00',2.09),('5815','2013-07-17','12:10:00',2.11),('5815','2013-07-17','12:15:00',2.13),('5815','2013-07-17','12:20:00',2.14),('5815','2013-07-17','12:25:00',2.17),('5815','2013-07-17','12:30:00',2.18),('5815','2013-07-17','12:35:00',2.31),('5815','2013-07-17','12:40:00',2.38),('5815','2013-07-17','12:45:00',1.62),('5815','2013-07-17','12:55:00',2),('5815','2013-07-17','13:00:00',2.36),('5815','2013-07-17','13:05:00',2.26),('5815','2013-07-17','13:10:00',2.24),('5815','2013-07-17','13:15:00',2.26),('5815','2013-07-17','13:20:00',2.37),('5815','2013-07-17','13:25:00',2.37),('5815','2013-07-17','13:30:00',2.4),('5815','2013-07-17','13:35:00',2.26),('5815','2013-07-17','13:40:00',1.92),('5815','2013-07-17','13:45:00',2.36),('5815','2013-07-17','13:50:00',2.33),('5815','2013-07-17','13:55:00',2.21),('5815','2013-07-17','14:00:00',2.28),('5815','2013-07-17','14:05:00',2.24),('5815','2013-07-17','14:10:00',2.26),('5815','2013-07-17','14:15:00',2.12),('5815','2013-07-17','14:20:00',2.28),('5815','2013-07-17','14:25:00',2.26),('5815','2013-07-17','14:30:00',2.22),('5815','2013-07-17','14:35:00',2.22),('5815','2013-07-17','14:40:00',2.2),('5815','2013-07-17','14:45:00',2.18),('5815','2013-07-17','14:50:00',2.15),('5815','2013-07-17','14:55:00',2.11),('5815','2013-07-17','15:00:00',2.09),('5815','2013-07-17','15:05:00',2.11),('5815','2013-07-17','15:10:00',2.11),('5815','2013-07-17','15:15:00',2.07),('5815','2013-07-17','15:20:00',2.05),('5815','2013-07-17','15:25:00',2.06),('5815','2013-07-17','15:30:00',2.01),('5815','2013-07-17','15:35:00',1.96),('5815','2013-07-17','15:40:00',1.95),('5815','2013-07-17','15:45:00',1.95),('5815','2013-07-17','15:50:00',1.94),('5815','2013-07-17','15:55:00',1.9),('5815','2013-07-17','16:00:00',1.82),('5815','2013-07-17','16:05:00',1.76),('5815','2013-07-17','16:10:00',1.76),('5815','2013-07-17','16:15:00',1.72),('5815','2013-07-17','16:20:00',1.69),('5815','2013-07-17','16:25:00',1.66),('5815','2013-07-17','16:30:00',1.62),('5815','2013-07-17','16:35:00',1.6),('5815','2013-07-17','16:40:00',1.56),('5815','2013-07-17','16:45:00',1.51),('5815','2013-07-17','16:50:00',1.46),('5815','2013-07-17','16:55:00',1.41),('5815','2013-07-17','17:00:00',1.29),('5815','2013-07-17','17:05:00',1.23),('5815','2013-07-17','17:10:00',1.23),('5815','2013-07-17','17:15:00',1.23),('5815','2013-07-17','17:20:00',1.1),('5815','2013-07-17','17:25:00',1.16),('5815','2013-07-17','17:30:00',1.08),('5815','2013-07-17','17:35:00',1.05),('5815','2013-07-16','08:45:00',1.02),('5815','2013-07-16','08:50:00',1.05),('5815','2013-07-16','08:55:00',1.11),('5815','2013-07-16','09:00:00',1.17),('5815','2013-07-16','09:05:00',1.22),('5815','2013-07-16','09:10:00',1.27),('5815','2013-07-16','09:15:00',1.32),('5815','2013-07-16','09:20:00',1.36),('5815','2013-07-16','09:25:00',1.4),('5815','2013-07-16','09:30:00',1.44),('5815','2013-07-16','09:35:00',1.47),('5815','2013-07-16','09:40:00',1.51),('5815','2013-07-16','09:45:00',1.56),('5815','2013-07-16','09:50:00',1.6),('5815','2013-07-16','09:55:00',1.62),('5815','2013-07-16','10:00:00',1.66),('5815','2013-07-16','10:05:00',1.68),('5815','2013-07-16','10:10:00',1.72),('5815','2013-07-16','10:15:00',1.75),('5815','2013-07-16','10:20:00',1.78),('5815','2013-07-16','10:25:00',1.82),('5815','2013-07-16','10:30:00',1.85),('5815','2013-07-16','10:35:00',1.88),('5815','2013-07-16','10:40:00',1.9),('5815','2013-07-16','10:45:00',1.94),('5815','2013-07-16','10:50:00',1.97),('5815','2013-07-16','10:55:00',1.99),('5815','2013-07-16','11:00:00',2.01),('5815','2013-07-16','11:05:00',1.98),('5815','2013-07-16','11:10:00',2),('5815','2013-07-16','11:15:00',2.02),('5815','2013-07-16','11:20:00',2.03),('5815','2013-07-16','11:25:00',2.06),('5815','2013-07-16','11:30:00',2.08),('5815','2013-07-16','11:35:00',2.09),('5815','2013-07-16','11:40:00',2.11),('5815','2013-07-16','11:45:00',2.12),('5815','2013-07-16','11:50:00',2.15),('5815','2013-07-16','11:55:00',2.17),('5815','2013-07-16','12:00:00',2.17),('5815','2013-07-16','12:05:00',2.18),('5815','2013-07-16','12:10:00',2.19),('5815','2013-07-16','12:15:00',2.17),('5815','2013-07-16','12:20:00',2.19),('5815','2013-07-16','12:25:00',2.21),('5815','2013-07-16','12:30:00',2.23),('5815','2013-07-16','12:35:00',2.24),('5815','2013-07-16','12:40:00',2.21),('5815','2013-07-16','12:45:00',2.22),('5815','2013-07-16','12:50:00',2.23),('5815','2013-07-16','12:55:00',2.26),('5815','2013-07-16','13:00:00',2.28),('5815','2013-07-16','13:05:00',2.27),('5815','2013-07-16','13:10:00',2.26),('5815','2013-07-16','13:15:00',2.27),('5815','2013-07-16','13:20:00',2.26),('5815','2013-07-16','13:25:00',2.27),('5815','2013-07-16','13:30:00',2.26),('5815','2013-07-16','13:35:00',2.24),('5815','2013-07-16','13:40:00',2.25),('5815','2013-07-16','13:45:00',2.25),('5815','2013-07-16','13:50:00',2.24),('5815','2013-07-16','13:55:00',2.24),('5815','2013-07-16','14:00:00',2.24),('5815','2013-07-16','14:05:00',2.23),('5815','2013-07-16','14:10:00',2.22),('5815','2013-07-16','14:15:00',2.25),('5815','2013-07-16','14:20:00',2.21),('5815','2013-07-16','14:25:00',2.21),('5815','2013-07-16','14:30:00',2.19),('5815','2013-07-16','14:35:00',2.16),('5815','2013-07-16','14:40:00',2.27),('5815','2013-07-16','14:45:00',2.19),('5815','2013-07-16','14:50:00',2.12),('5815','2013-07-16','14:55:00',2.09),('5815','2013-07-16','15:00:00',2.14),('5815','2013-07-16','15:05:00',2.13),('5815','2013-07-16','15:10:00',2.09),('5815','2013-07-16','15:15:00',2.1),('5815','2013-07-16','15:20:00',2.07),('5815','2013-07-16','15:25:00',2.02),('5815','2013-07-16','15:30:00',1.97),('5815','2013-07-16','15:35:00',1.96),('5815','2013-07-16','15:40:00',1.61),('5815','2013-07-16','15:45:00',1.96),('5815','2013-07-16','15:50:00',1.94),('5815','2013-07-16','15:55:00',1.9),('5815','2013-07-16','16:00:00',1.85),('5815','2013-07-16','16:05:00',1.78),('5815','2013-07-16','16:10:00',1.78),('5815','2013-07-16','16:15:00',1.74),('5815','2013-07-16','16:20:00',1.69),('5815','2013-07-16','16:25:00',1.66),('5815','2013-07-16','16:30:00',1.64),('5815','2013-07-16','16:35:00',1.62),('5815','2013-07-16','16:40:00',1.56),('5815','2013-07-16','16:45:00',1.56),('5815','2013-07-16','16:50:00',1.51),('5815','2013-07-16','16:55:00',1.43),('5815','2013-07-16','17:00:00',1.21),('5815','2013-07-16','17:05:00',1.38),('5815','2013-07-16','17:10:00',1.37),('5815','2013-07-16','17:15:00',1.32),('5815','2013-07-16','17:20:00',1.26),('5815','2013-07-16','17:25:00',1.18),('5815','2013-07-16','17:30:00',1.12),('5815','2013-07-16','17:35:00',1.08),('5815','2013-07-15','08:50:00',1.03),('5815','2013-07-15','08:55:00',1.08),('5815','2013-07-15','09:00:00',1.11),('5815','2013-07-15','09:05:00',1.15),('5815','2013-07-15','09:10:00',1.2),('5815','2013-07-15','09:15:00',1.24),('5815','2013-07-15','09:20:00',1.28),('5815','2013-07-15','09:25:00',1.33),('5815','2013-07-15','09:30:00',1.37),('5815','2013-07-15','09:35:00',1.4),('5815','2013-07-15','09:40:00',1.44),('5815','2013-07-15','09:45:00',1.5),('5815','2013-07-15','09:50:00',1.54),('5815','2013-07-15','09:55:00',1.58),('5815','2013-07-15','10:00:00',1.62),('5815','2013-07-15','10:05:00',1.66),('5815','2013-07-15','10:10:00',1.7),('5815','2013-07-15','10:15:00',1.72),('5815','2013-07-15','10:20:00',1.74),('5815','2013-07-15','10:25:00',1.78),('5815','2013-07-15','10:30:00',1.81),('5815','2013-07-15','10:35:00',1.84),('5815','2013-07-15','10:40:00',1.87),('5815','2013-07-15','10:45:00',1.89),('5815','2013-07-15','10:50:00',1.92),('5815','2013-07-15','10:55:00',1.95),('5815','2013-07-15','11:00:00',1.96),('5815','2013-07-15','11:05:00',1.9),('5815','2013-07-15','11:10:00',1.96),('5815','2013-07-15','11:15:00',1.98),('5815','2013-07-15','11:20:00',2),('5815','2013-07-15','11:25:00',2.02),('5815','2013-07-15','11:30:00',2.02),('5815','2013-07-15','11:35:00',2.03),('5815','2013-07-15','11:40:00',2.09),('5815','2013-07-15','11:45:00',2.11),('5815','2013-07-15','11:50:00',2.1),('5815','2013-07-15','11:55:00',2.14),('5815','2013-07-15','12:00:00',2.16),('5815','2013-07-15','12:05:00',2.16),('5815','2013-07-15','12:10:00',2.18),('5815','2013-07-15','12:15:00',2.19),('5815','2013-07-15','12:20:00',2.19),('5815','2013-07-15','12:25:00',2.21),('5815','2013-07-15','12:30:00',2.22),('5815','2013-07-15','12:35:00',2.22),('5815','2013-07-15','12:40:00',2.19),('5815','2013-07-15','12:45:00',2.16),('5815','2013-07-15','12:50:00',2.19),('5815','2013-07-15','12:55:00',2.2),('5815','2013-07-15','13:00:00',2.21),('5815','2013-07-15','13:05:00',2.23),('5815','2013-07-15','13:10:00',2.23),('5815','2013-07-15','13:15:00',2.26),('5815','2013-07-15','13:20:00',2.26),('5815','2013-07-15','13:25:00',2.29),('5815','2013-07-15','13:30:00',2.26),('5815','2013-07-15','13:35:00',2.25),('5815','2013-07-15','13:40:00',2.24),('5815','2013-07-15','13:45:00',2.3),('5815','2013-07-15','13:50:00',2.26),('5815','2013-07-15','13:55:00',2.19),('5815','2013-07-15','14:00:00',2.21),('5815','2013-07-15','14:05:00',2.24),('5815','2013-07-15','14:10:00',2.06),('5815','2013-07-15','14:15:00',1.61),('5815','2013-07-15','14:20:00',1.15),('5815','2013-07-15','14:25:00',2.32),('5815','2013-07-15','14:30:00',2.25),('5815','2013-07-15','14:35:00',2.23),('5815','2013-07-15','14:40:00',2.19),('5815','2013-07-15','14:45:00',2.17),('5815','2013-07-15','14:50:00',2.17),('5815','2013-07-15','14:55:00',2.17),('5815','2013-07-15','15:00:00',2.15),('5815','2013-07-15','15:05:00',2.11),('5815','2013-07-15','15:10:00',2.05),('5815','2013-07-15','15:15:00',2.03),('5815','2013-07-15','15:20:00',2.02),('5815','2013-07-15','15:25:00',1.97),('5815','2013-07-15','15:30:00',2.01),('5815','2013-07-15','15:35:00',1.98),('5815','2013-07-15','15:40:00',1.92),('5815','2013-07-15','15:45:00',1.4),('5815','2013-07-15','15:50:00',1.95),('5815','2013-07-15','15:55:00',1.85),('5815','2013-07-15','16:00:00',1.1),('5815','2013-07-15','16:10:00',1.71),('5815','2013-07-15','16:15:00',1.6),('5815','2013-07-15','16:20:00',1.24),('5815','2013-07-15','17:00:00',1.45),('5815','2013-07-15','17:05:00',1.43),('5815','2013-07-15','17:10:00',1.5),('5815','2013-07-15','17:15:00',1.38),('5815','2013-07-15','17:20:00',1.3),('5815','2013-07-15','17:45:00',1.12),('5815','2013-07-15','17:50:00',1.04),('5815','2013-07-14','08:45:00',1.02),('5815','2013-07-14','08:50:00',1.06),('5815','2013-07-14','08:55:00',1.11),('5815','2013-07-14','09:00:00',1.16),('5815','2013-07-14','09:05:00',1.2),('5815','2013-07-14','09:10:00',1.26),('5815','2013-07-14','09:15:00',1.3),('5815','2013-07-14','09:20:00',1.34),('5815','2013-07-14','09:25:00',1.38),('5815','2013-07-14','09:30:00',1.42),('5815','2013-07-14','09:35:00',1.46),('5815','2013-07-14','09:40:00',1.5),('5815','2013-07-14','09:45:00',1.53),('5815','2013-07-14','09:50:00',1.57),('5815','2013-07-14','09:55:00',1.61),('5815','2013-07-14','10:00:00',1.63),('5815','2013-07-14','10:05:00',1.66),('5815','2013-07-14','10:10:00',1.7),('5815','2013-07-14','10:15:00',1.73),('5815','2013-07-14','10:20:00',1.73),('5815','2013-07-14','10:25:00',1.79),('5815','2013-07-14','10:30:00',1.81),('5815','2013-07-14','10:35:00',1.85),('5815','2013-07-14','10:40:00',1.88),('5815','2013-07-14','10:45:00',1.91),('5815','2013-07-14','10:50:00',1.93),('5815','2013-07-14','10:55:00',1.96),('5815','2013-07-14','11:00:00',1.99),('5815','2013-07-14','11:05:00',1.96),('5815','2013-07-14','11:10:00',1.99),('5815','2013-07-14','11:15:00',2),('5815','2013-07-14','11:20:00',2.02),('5815','2013-07-14','11:25:00',2.04),('5815','2013-07-14','11:30:00',2.05),('5815','2013-07-14','11:35:00',2.07),('5815','2013-07-14','11:40:00',2.12),('5815','2013-07-14','11:45:00',2.11),('5815','2013-07-14','11:50:00',2.06),('5815','2013-07-14','11:55:00',2.12),('5815','2013-07-14','12:00:00',2.13),('5815','2013-07-14','12:05:00',2.12),('5815','2013-07-14','12:10:00',2.13),('5815','2013-07-14','12:15:00',2.17),('5815','2013-07-14','12:20:00',2.18),('5815','2013-07-14','12:25:00',2.19),('5815','2013-07-14','12:30:00',2.23),('5815','2013-07-14','12:35:00',2.22),('5815','2013-07-14','12:40:00',2.18),('5815','2013-07-14','12:45:00',2.18),('5815','2013-07-14','12:50:00',2.2),('5815','2013-07-14','12:55:00',2.21),('5815','2013-07-14','13:00:00',1.89),('5815','2013-07-14','13:05:00',2.09),('5815','2013-07-14','13:10:00',2.06),('5815','2013-07-14','13:15:00',2.25),('5815','2013-07-14','13:20:00',2.27),('5815','2013-07-14','13:25:00',2.4),('5815','2013-07-14','13:30:00',2.39),('5815','2013-07-14','13:35:00',1.51),('5815','2013-07-14','13:45:00',1.26),('5815','2013-07-14','13:50:00',2.54),('5815','2013-07-14','13:55:00',2.46),('5815','2013-07-14','14:00:00',2.46),('5815','2013-07-14','14:05:00',1.45),('5815','2013-07-14','14:20:00',2.08),('5815','2013-07-14','14:25:00',2.35),('5815','2013-07-14','14:30:00',1.95),('5815','2013-07-14','14:35:00',2.28),('5815','2013-07-14','14:40:00',2.27),('5815','2013-07-14','14:45:00',2.21),('5815','2013-07-14','14:50:00',2.21),('5815','2013-07-14','14:55:00',2.21),('5815','2013-07-14','15:00:00',2.21),('5815','2013-07-14','15:05:00',2.18),('5815','2013-07-14','15:10:00',2.12),('5815','2013-07-14','15:15:00',2.11),('5815','2013-07-14','15:20:00',2.05),('5815','2013-07-14','15:25:00',2.02),('5815','2013-07-14','15:30:00',2.01),('5815','2013-07-14','15:35:00',1.95),('5815','2013-07-14','15:40:00',2.03),('5815','2013-07-14','15:45:00',1.94),('5815','2013-07-14','15:50:00',2.04),('5815','2013-07-14','15:55:00',1.81),('5815','2013-07-14','16:00:00',1.85),('5815','2013-07-14','16:05:00',1.82),('5815','2013-07-14','16:10:00',1.8),('5815','2013-07-14','16:15:00',1.78),('5815','2013-07-14','16:20:00',1.69),('5815','2013-07-14','16:25:00',1.65),('5815','2013-07-14','16:30:00',1.62),('5815','2013-07-14','16:35:00',1.61),('5815','2013-07-14','16:40:00',1.57),('5815','2013-07-14','16:45:00',1.52),('5815','2013-07-14','16:50:00',1.48),('5815','2013-07-14','16:55:00',1.44),('5815','2013-07-14','17:00:00',1.37),('5815','2013-07-14','17:05:00',1.37),('5815','2013-07-14','17:10:00',1.32),('5815','2013-07-14','17:15:00',1.29),('5815','2013-07-14','17:20:00',1.23),('5815','2013-07-14','17:25:00',1.21),('5815','2013-07-14','17:30:00',1.17),('5815','2013-07-14','17:35:00',1.1),('5815','2013-07-14','17:40:00',1.02),('5815','2013-07-13','08:20:00',1.13),('5815','2013-07-13','09:25:00',1.25),('5815','2013-07-13','09:30:00',1.2),('5815','2013-07-13','10:15:00',1),('5815','2013-07-13','10:20:00',1.28),('5815','2013-07-13','10:25:00',1.53),('5815','2013-07-13','10:30:00',1.36),('5815','2013-07-13','10:35:00',1.84),('5815','2013-07-13','10:40:00',1.95),('5815','2013-07-13','10:45:00',1.8),('5815','2013-07-13','10:50:00',2.1),('5815','2013-07-13','10:55:00',1.8),('5815','2013-07-13','11:00:00',2.18),('5815','2013-07-13','11:05:00',2.1),('5815','2013-07-13','11:10:00',1.5),('5815','2013-07-13','11:15:00',1.74),('5815','2013-07-13','11:20:00',2.37),('5815','2013-07-13','11:25:00',2.19),('5815','2013-07-13','11:30:00',2.28),('5815','2013-07-13','11:35:00',2.17),('5815','2013-07-13','11:40:00',2.13),('5815','2013-07-13','11:45:00',2.4),('5815','2013-07-13','11:50:00',1.9),('5815','2013-07-13','12:10:00',2.02),('5815','2013-07-13','12:15:00',1.9),('5815','2013-07-13','12:20:00',1.24),('5815','2013-07-13','12:25:00',1.26),('5815','2013-07-13','12:45:00',1.84),('5815','2013-07-13','12:50:00',1.56),('5815','2013-07-13','12:55:00',2.02),('5815','2013-07-13','13:00:00',2.52),('5815','2013-07-13','13:05:00',2.53),('5815','2013-07-13','13:10:00',2.45),('5815','2013-07-13','13:15:00',2.46),('5815','2013-07-13','13:20:00',2.52),('5815','2013-07-13','13:25:00',2.43),('5815','2013-07-13','13:30:00',2.41),('5815','2013-07-13','13:35:00',2.4),('5815','2013-07-13','13:40:00',2.37),('5815','2013-07-13','13:45:00',2.37),('5815','2013-07-13','13:50:00',2.38),('5815','2013-07-13','13:55:00',2.38),('5815','2013-07-13','14:00:00',2.38),('5815','2013-07-13','14:05:00',2.38),('5815','2013-07-13','14:10:00',2.37),('5815','2013-07-13','14:15:00',2.4),('5815','2013-07-13','14:20:00',2.36),('5815','2013-07-13','14:25:00',2.32),('5815','2013-07-13','14:30:00',2.3),('5815','2013-07-13','14:35:00',2.25),('5815','2013-07-13','14:40:00',2.21),('5815','2013-07-13','14:45:00',2.19),('5815','2013-07-13','14:50:00',2.23),('5815','2013-07-13','14:55:00',2.23),('5815','2013-07-13','15:00:00',2.19),('5815','2013-07-13','15:05:00',2.18),('5815','2013-07-13','15:10:00',2.14),('5815','2013-07-13','15:15:00',2.1),('5815','2013-07-13','15:20:00',2.07),('5815','2013-07-13','15:25:00',2.04),('5815','2013-07-13','15:30:00',2.02),('5815','2013-07-13','15:35:00',2),('5815','2013-07-13','15:40:00',1.98),('5815','2013-07-13','15:45:00',1.98),('5815','2013-07-13','15:50:00',1.96),('5815','2013-07-13','15:55:00',1.94),('5815','2013-07-13','16:00:00',1.84),('5815','2013-07-13','16:05:00',1.81),('5815','2013-07-13','16:10:00',1.79),('5815','2013-07-13','16:15:00',1.78),('5815','2013-07-13','16:20:00',1.63),('5815','2013-07-13','16:25:00',1.67),('5815','2013-07-13','16:30:00',1.36),('5815','2013-07-13','16:35:00',1.37),('5815','2013-07-13','16:40:00',1.56),('5815','2013-07-13','16:45:00',1.52),('5815','2013-07-13','16:50:00',1.53),('5815','2013-07-13','16:55:00',1.57),('5815','2013-07-13','17:00:00',1.39),('5815','2013-07-13','17:05:00',1.13),('5815','2013-07-13','17:10:00',1.12),('5815','2013-07-13','17:15:00',1.04),('5815','2013-07-13','17:25:00',1.04),('5815','2013-07-13','17:30:00',1.08),('5815','2013-07-13','17:35:00',1.13),('5815','2013-07-12','08:50:00',1.02),('5815','2013-07-12','08:55:00',1.05),('5815','2013-07-12','09:00:00',1.11),('5815','2013-07-12','09:05:00',1.16),('5815','2013-07-12','09:10:00',1.2),('5815','2013-07-12','09:15:00',1.25),('5815','2013-07-12','09:20:00',1.28),('5815','2013-07-12','09:25:00',1.34),('5815','2013-07-12','09:30:00',1.36),('5815','2013-07-12','09:35:00',1.41),('5815','2013-07-12','09:40:00',1.45),('5815','2013-07-12','09:45:00',1.5),('5815','2013-07-12','09:50:00',1.55),('5815','2013-07-12','09:55:00',1.57),('5815','2013-07-12','10:00:00',1.58),('5815','2013-07-12','10:05:00',1.62),('5815','2013-07-12','10:10:00',1.68),('5815','2013-07-12','10:15:00',1.66),('5815','2013-07-12','10:20:00',1.72),('5815','2013-07-12','10:25:00',1.81),('5815','2013-07-12','10:30:00',1.84),('5815','2013-07-12','10:35:00',1.83),('5815','2013-07-12','10:40:00',1.81),('5815','2013-07-12','10:45:00',1.88),('5815','2013-07-12','10:50:00',1.89),('5815','2013-07-12','10:55:00',1.99),('5815','2013-07-12','11:00:00',1.98),('5815','2013-07-12','11:05:00',2.06),('5815','2013-07-12','11:10:00',2.13),('5815','2013-07-12','11:15:00',1.41),('5815','2013-07-12','11:25:00',1.17),('5815','2013-07-12','11:30:00',2.15),('5815','2013-07-12','11:35:00',2.18),('5815','2013-07-12','11:40:00',1.91),('5815','2013-07-12','11:50:00',2.14),('5815','2013-07-12','11:55:00',1.72),('5815','2013-07-12','12:00:00',1.52),('5815','2013-07-12','12:05:00',1.94),('5815','2013-07-12','12:10:00',2.23),('5815','2013-07-12','12:15:00',1.12),('5815','2013-07-12','12:20:00',1.12),('5815','2013-07-12','12:25:00',1.53),('5815','2013-07-12','12:35:00',2.44),('5815','2013-07-12','12:40:00',2.45),('5815','2013-07-12','12:45:00',1.43),('5815','2013-07-12','12:50:00',1.66),('5815','2013-07-12','12:55:00',2.39),('5815','2013-07-12','13:00:00',2.39),('5815','2013-07-12','13:05:00',2.43),('5815','2013-07-12','13:10:00',1.87),('5815','2013-07-12','13:15:00',1.98),('5815','2013-07-12','13:20:00',2.46),('5815','2013-07-12','13:25:00',2.43),('5815','2013-07-12','13:30:00',2.36),('5815','2013-07-12','13:35:00',2.35),('5815','2013-07-12','13:40:00',2.34),('5815','2013-07-12','13:45:00',2.31),('5815','2013-07-12','13:50:00',2.32),('5815','2013-07-12','13:55:00',2.33),('5815','2013-07-12','14:00:00',2.31),('5815','2013-07-12','14:05:00',2.32),('5815','2013-07-12','14:10:00',2.32),('5815','2013-07-12','14:15:00',2.32),('5815','2013-07-12','14:20:00',2.29),('5815','2013-07-12','14:25:00',2.26),('5815','2013-07-12','14:30:00',2.26),('5815','2013-07-12','14:35:00',2.25),('5815','2013-07-12','14:40:00',2.23),('5815','2013-07-12','14:45:00',2.23),('5815','2013-07-12','14:50:00',2.21),('5815','2013-07-12','14:55:00',2.22),('5815','2013-07-12','15:00:00',2.21),('5815','2013-07-12','15:05:00',2.21),('5815','2013-07-12','15:10:00',2.16),('5815','2013-07-12','15:15:00',2.15),('5815','2013-07-12','15:20:00',2.04),('5815','2013-07-12','15:25:00',2.13),('5815','2013-07-12','15:30:00',2.07),('5815','2013-07-12','15:35:00',2.06),('5815','2013-07-12','15:40:00',2.04),('5815','2013-07-12','15:45:00',2.03),('5815','2013-07-12','15:50:00',2.03),('5815','2013-07-12','15:55:00',1.99),('5815','2013-07-12','16:00:00',1.89),('5815','2013-07-12','16:05:00',1.84),('5815','2013-07-12','16:10:00',1.87),('5815','2013-07-12','16:15:00',1.81),('5815','2013-07-12','16:20:00',1.73),('5815','2013-07-12','16:25:00',1.78),('5815','2013-07-12','16:30:00',1.74),('5815','2013-07-12','16:35:00',1.71),('5815','2013-07-12','16:40:00',1.66),('5815','2013-07-12','16:45:00',1.6),('5815','2013-07-12','16:50:00',1.53),('5815','2013-07-12','16:55:00',1.48),('5815','2013-07-12','17:00:00',1.4),('5815','2013-07-12','17:05:00',1.32),('5815','2013-07-12','17:10:00',1.39),('5815','2013-07-12','17:15:00',1.36),('5815','2013-07-12','17:20:00',1.27),('5815','2013-07-12','17:25:00',1.27),('5815','2013-07-12','17:30:00',1.17),('5815','2013-07-12','17:35:00',1.11),('5815','2013-07-12','17:40:00',1.1),('5815','2013-07-12','17:45:00',1.08),('5815','2013-07-12','17:50:00',1.01),('5815','2013-07-12','17:55:00',1.03),('5815','2013-07-11','09:20:00',1.1),('5815','2013-07-11','09:25:00',1.3),('5815','2013-07-11','09:40:00',1.01),('5815','2013-07-11','09:45:00',1.53),('5815','2013-07-11','09:50:00',1.52),('5815','2013-07-11','09:55:00',1.58),('5815','2013-07-11','10:00:00',1.59),('5815','2013-07-11','10:05:00',1.61),('5815','2013-07-11','10:15:00',1.48),('5815','2013-07-11','10:30:00',1.17),('5815','2013-07-11','10:35:00',1.11),('5815','2013-07-11','10:55:00',1.11),('5815','2013-07-11','11:00:00',2.26),('5815','2013-07-11','11:05:00',1.06),('5815','2013-07-11','11:15:00',1.54),('5815','2013-07-11','11:25:00',2.05),('5815','2013-07-11','11:30:00',2.33),('5815','2013-07-11','11:35:00',2.13),('5815','2013-07-11','11:40:00',1.53),('5815','2013-07-11','11:45:00',1.91),('5815','2013-07-11','11:50:00',2),('5815','2013-07-11','11:55:00',1.82),('5815','2013-07-11','12:00:00',2.33),('5815','2013-07-11','12:05:00',1.35),('5815','2013-07-11','12:10:00',2.29),('5815','2013-07-11','12:15:00',1.38),('5815','2013-07-11','12:20:00',2.41),('5815','2013-07-11','12:25:00',1.56),('5815','2013-07-11','12:30:00',2.31),('5815','2013-07-11','12:35:00',2.17),('5815','2013-07-11','12:40:00',1.66),('5815','2013-07-11','12:45:00',2.05),('5815','2013-07-11','12:50:00',1.59),('5815','2013-07-11','12:55:00',2.44),('5815','2013-07-11','13:00:00',2.37),('5815','2013-07-11','13:05:00',2.43),('5815','2013-07-11','13:10:00',2.4),('5815','2013-07-11','13:15:00',2.42),('5815','2013-07-11','13:20:00',2.41),('5815','2013-07-11','13:25:00',2.41),('5815','2013-07-11','13:30:00',2.42),('5815','2013-07-11','13:35:00',2.41),('5815','2013-07-11','13:40:00',2.41),('5815','2013-07-11','13:45:00',2.39),('5815','2013-07-11','13:50:00',2.44),('5815','2013-07-11','13:55:00',2.39),('5815','2013-07-11','14:00:00',1.94),('5815','2013-07-11','14:05:00',1.96),('5815','2013-07-11','14:10:00',1.83),('5815','2013-07-11','14:15:00',2.11),('5815','2013-07-11','14:20:00',2.56),('5815','2013-07-11','14:25:00',2.47),('5815','2013-07-11','14:30:00',1.55),('5815','2013-07-11','14:35:00',1.77),('5815','2013-07-11','14:40:00',2.26),('5815','2013-07-11','14:45:00',2.21),('5815','2013-07-11','14:50:00',2.19),('5815','2013-07-11','14:55:00',2.18),('5815','2013-07-11','15:00:00',2.09),('5815','2013-07-11','15:05:00',2.17),('5815','2013-07-11','15:10:00',2.07),('5815','2013-07-11','15:15:00',1.73),('5815','2013-07-11','15:20:00',2.11),('5815','2013-07-11','15:25:00',2.06),('5815','2013-07-11','15:30:00',1.93),('5815','2013-07-11','15:35:00',1.69),('5815','2013-07-11','15:40:00',2.05),('5815','2013-07-11','15:45:00',1.77),('5815','2013-07-11','15:50:00',1.88),('5815','2013-07-11','15:55:00',1.93),('5815','2013-07-11','16:00:00',1.84),('5815','2013-07-11','16:05:00',1.81),('5815','2013-07-11','16:10:00',1.79),('5815','2013-07-11','16:15:00',1.74),('5815','2013-07-11','16:20:00',1.71),('5815','2013-07-11','16:25:00',1.7),('5815','2013-07-11','16:30:00',1.66),('5815','2013-07-11','16:35:00',1.6),('5815','2013-07-11','16:40:00',1.59),('5815','2013-07-11','16:45:00',1.55),('5815','2013-07-11','16:50:00',1.5),('5815','2013-07-11','16:55:00',1.46),('5815','2013-07-11','17:00:00',1.37),('5815','2013-07-11','17:05:00',1.35),('5815','2013-07-11','17:10:00',1.35),('5815','2013-07-11','17:15:00',1.29),('5815','2013-07-11','17:20:00',1.26),('5815','2013-07-11','17:25:00',1.18),('5815','2013-07-11','17:30:00',1.11),('5815','2013-07-11','17:35:00',1.08),('5815','2013-07-11','17:40:00',1.04),('5815','2013-07-11','17:45:00',1.01),('5815','2013-07-10','08:50:00',1.01),('5815','2013-07-10','08:55:00',1.08),('5815','2013-07-10','09:00:00',1.13),('5815','2013-07-10','09:05:00',1.19),('5815','2013-07-10','09:10:00',1.2),('5815','2013-07-10','09:15:00',1.25),('5815','2013-07-10','09:20:00',1.22),('5815','2013-07-10','09:25:00',1.43),('5815','2013-07-10','09:30:00',1.47),('5815','2013-07-10','09:35:00',1.39),('5815','2013-07-10','09:40:00',1.33),('5815','2013-07-10','09:45:00',1.61),('5815','2013-07-10','09:50:00',1.23),('5815','2013-07-10','09:55:00',1.15),('5815','2013-07-10','10:00:00',1.35),('5815','2013-07-10','10:15:00',1.78),('5815','2013-07-10','10:20:00',1.8),('5815','2013-07-10','10:25:00',1.82),('5815','2013-07-10','10:30:00',1.96),('5815','2013-07-10','10:35:00',1.11),('5815','2013-07-10','10:45:00',1.55),('5815','2013-07-10','10:50:00',1.97),('5815','2013-07-10','10:55:00',2.11),('5815','2013-07-10','11:00:00',1.78),('5815','2013-07-10','11:05:00',1.59),('5815','2013-07-10','11:10:00',2.01),('5815','2013-07-10','11:15:00',1.19),('5815','2013-07-10','11:20:00',1.52),('5815','2013-07-10','11:25:00',1.3),('5815','2013-07-10','11:30:00',1.66),('5815','2013-07-10','11:35:00',1.74),('5815','2013-07-10','11:40:00',2.46),('5815','2013-07-10','11:45:00',2.31),('5815','2013-07-10','11:50:00',1.48),('5815','2013-07-10','12:00:00',1.97),('5815','2013-07-10','12:15:00',1.22),('5815','2013-07-10','12:20:00',2.43),('5815','2013-07-10','12:25:00',2.36),('5815','2013-07-10','12:30:00',2.13),('5815','2013-07-10','12:35:00',2.35),('5815','2013-07-10','12:40:00',1.64),('5815','2013-07-10','12:45:00',1.11),('5815','2013-07-10','12:50:00',1.55),('5815','2013-07-10','12:55:00',2.18),('5815','2013-07-10','13:00:00',2.5),('5815','2013-07-10','13:05:00',2.02),('5815','2013-07-10','13:10:00',2.34),('5815','2013-07-10','13:15:00',2.42),('5815','2013-07-10','13:20:00',2.45),('5815','2013-07-10','13:25:00',2.46),('5815','2013-07-10','13:30:00',2.5),('5815','2013-07-10','13:35:00',2.33),('5815','2013-07-10','13:40:00',2.47),('5815','2013-07-10','13:45:00',2.19),('5815','2013-07-10','13:50:00',1.8),('5815','2013-07-10','13:55:00',1.91),('5815','2013-07-10','14:00:00',2.2),('5815','2013-07-10','14:05:00',2.11),('5815','2013-07-10','14:10:00',2.43),('5815','2013-07-10','14:15:00',2.43),('5815','2013-07-10','14:20:00',2.38),('5815','2013-07-10','14:25:00',2.09),('5815','2013-07-10','14:30:00',2.13),('5815','2013-07-10','14:35:00',2.34),('5815','2013-07-10','14:40:00',2.3),('5815','2013-07-10','14:45:00',2.25),('5815','2013-07-10','14:50:00',2.29),('5815','2013-07-10','14:55:00',1.69),('5815','2013-07-10','15:00:00',2.41),('5815','2013-07-10','15:05:00',1.31),('5815','2013-07-10','15:10:00',1.13),('5815','2013-07-10','15:15:00',2.18),('5815','2013-07-10','15:20:00',1.39),('5815','2013-07-10','15:25:00',1.54),('5815','2013-07-10','15:30:00',1.74),('5815','2013-07-10','15:35:00',2.21),('5815','2013-07-10','15:40:00',1.62),('5815','2013-07-10','15:45:00',1.84),('5815','2013-07-10','15:50:00',1.55),('5815','2013-07-10','15:55:00',1.18),('5815','2013-07-10','16:00:00',1.42),('5815','2013-07-10','16:05:00',1.47),('5815','2013-07-10','16:10:00',1.59),('5815','2013-07-10','16:15:00',1.24),('5815','2013-07-10','16:20:00',1.11),('5815','2013-07-10','16:25:00',1.28),('5815','2013-07-10','16:30:00',1.61),('5815','2013-07-10','16:40:00',1.59),('5815','2013-07-10','16:45:00',1.24),('5815','2013-07-10','16:50:00',1.53),('5815','2013-07-10','16:55:00',1.59),('5815','2013-07-10','17:00:00',1.38),('5815','2013-07-10','17:05:00',1.18),('5815','2013-07-10','17:10:00',1.05),('5815','2013-07-10','17:20:00',1.02),('5815','2013-07-10','17:30:00',1.2),('5815','2013-07-10','17:35:00',1.14),('5815','2013-07-10','17:40:00',1.11),('5815','2013-07-10','17:45:00',1.02),('5815','2013-07-10','18:05:00',1.03),('5815','2014-05-02','08:50:00',1.22),('5815','2014-05-02','08:55:00',1.39),('5815','2014-05-02','09:00:00',1.64),('5815','2014-05-02','09:05:00',1.81),('5815','2014-05-02','09:10:00',1.17),('5815','2014-05-02','09:20:00',1.35),('5815','2014-05-02','09:25:00',1.78),('5815','2014-05-02','09:30:00',1.06),('5815','2014-05-02','09:35:00',1.72),('5815','2014-05-02','09:40:00',1.03),('5815','2014-05-02','09:45:00',1.6),('5815','2014-05-02','09:55:00',1.66),('5815','2014-05-02','10:00:00',1.99),('5815','2014-05-02','10:05:00',2.01),('5815','2014-05-02','10:10:00',2.05),('5815','2014-05-02','10:15:00',2.21),('5815','2014-05-02','10:20:00',1.71),('5815','2014-05-02','10:25:00',1.85),('5815','2014-05-02','10:30:00',1.39),('5815','2014-05-02','10:45:00',1.1),('5815','2014-05-02','10:55:00',1.16),('5815','2014-05-02','11:05:00',1.76),('5815','2014-05-02','11:10:00',2.95),('5815','2014-05-02','11:15:00',1.08),('5815','2014-05-02','11:20:00',1.46),('5815','2014-05-02','11:25:00',1.8),('5815','2014-05-02','11:30:00',2.66),('5815','2014-05-02','11:35:00',1.72),('5815','2014-05-02','11:40:00',1.62),('5815','2014-05-02','11:45:00',1.58),('5815','2014-05-02','11:50:00',1.33),('5815','2014-05-02','11:55:00',1.45),('5815','2014-05-02','12:00:00',1.24),('5815','2014-05-02','12:05:00',1.03),('5815','2014-05-02','12:35:00',1.15),('5815','2014-05-02','12:40:00',1.04),('5815','2014-05-02','12:45:00',1.07),('5815','2014-05-02','12:50:00',1.09),('5815','2014-05-02','12:55:00',1.12),('5815','2014-05-02','13:00:00',1.15),('5815','2014-05-02','13:05:00',1.09),('5815','2014-05-02','13:10:00',1.65),('5815','2014-05-02','13:15:00',1.65),('5815','2014-05-02','13:20:00',1.46),('5815','2014-05-02','13:25:00',1.8),('5815','2014-05-02','13:30:00',1.73),('5815','2014-05-02','13:35:00',1.39),('5815','2014-05-02','13:40:00',1.04),('5815','2014-05-02','13:45:00',1.02),('5815','2014-05-02','13:50:00',1.02),('5815','2014-05-02','13:55:00',1.03),('5815','2014-05-02','14:00:00',1),('5815','2014-05-02','14:05:00',1),('5815','2014-05-02','14:10:00',1.09),('5815','2014-05-02','14:15:00',1.22),('5815','2014-05-02','14:20:00',1.39),('5815','2014-05-02','14:25:00',1.62),('5815','2014-05-02','14:30:00',1.34),('5815','2013-07-09','08:25:00',1.1),('5815','2013-07-09','08:30:00',1.07),('5815','2013-07-09','08:35:00',1.17),('5815','2013-07-09','08:40:00',1.23),('5815','2013-07-09','08:45:00',1.17),('5815','2013-07-09','08:50:00',1.17),('5815','2013-07-09','08:55:00',1.15),('5815','2013-07-09','09:00:00',1.18),('5815','2013-07-09','09:05:00',1.26),('5815','2013-07-09','09:10:00',1.32),('5815','2013-07-09','09:15:00',1.36),('5815','2013-07-09','09:20:00',1.39),('5815','2013-07-09','09:25:00',1.38),('5815','2013-07-09','09:30:00',1.44),('5815','2013-07-09','09:35:00',1.46),('5815','2013-07-09','09:40:00',1.48),('5815','2013-07-09','09:45:00',1.51),('5815','2013-07-09','09:50:00',1.56),('5815','2013-07-09','09:55:00',1.63),('5815','2013-07-09','10:00:00',1.54),('5815','2013-07-09','10:05:00',1.67),('5815','2013-07-09','10:10:00',1.69),('5815','2013-07-09','10:15:00',1.73),('5815','2013-07-09','10:20:00',1.77),('5815','2013-07-09','10:25:00',1.81),('5815','2013-07-09','10:30:00',1.83),('5815','2013-07-09','10:35:00',1.86),('5815','2013-07-09','10:40:00',1.89),('5815','2013-07-09','10:45:00',1.91),('5815','2013-07-09','10:50:00',1.91),('5815','2013-07-09','10:55:00',1.93),('5815','2013-07-09','11:00:00',1.96),('5815','2013-07-09','11:05:00',1.93),('5815','2013-07-09','11:10:00',1.91),('5815','2013-07-09','11:15:00',1.93),('5815','2013-07-09','11:20:00',2),('5815','2013-07-09','11:25:00',2.02),('5815','2013-07-09','11:30:00',2.03),('5815','2013-07-09','11:35:00',2.02),('5815','2013-07-09','11:40:00',2.03),('5815','2013-07-09','11:45:00',2.04),('5815','2013-07-09','11:50:00',2.09),('5815','2013-07-09','11:55:00',2.15),('5815','2013-07-09','12:00:00',2.14),('5815','2013-07-09','12:05:00',2.16),('5815','2013-07-09','12:10:00',2.16),('5815','2013-07-09','12:15:00',2.16),('5815','2013-07-09','12:20:00',2.2),('5815','2013-07-09','12:25:00',2.23),('5815','2013-07-09','12:30:00',2.23),('5815','2013-07-09','12:35:00',2.21),('5815','2013-07-09','12:40:00',2.2),('5815','2013-07-09','12:45:00',2.23),('5815','2013-07-09','12:50:00',2.25),('5815','2013-07-09','12:55:00',2.26),('5815','2013-07-09','13:00:00',2.27),('5815','2013-07-09','13:05:00',2.28),('5815','2013-07-09','13:10:00',2.31),('5815','2013-07-09','13:15:00',2.29),('5815','2013-07-09','13:20:00',2.33),('5815','2013-07-09','13:25:00',2.35),('5815','2013-07-09','13:30:00',2.32),('5815','2013-07-09','13:35:00',2.3),('5815','2013-07-09','13:40:00',2.29),('5815','2013-07-09','13:45:00',2.3),('5815','2013-07-09','13:50:00',2.34),('5815','2013-07-09','13:55:00',2.31),('5815','2013-07-09','14:00:00',2.31),('5815','2013-07-09','14:05:00',2.32),('5815','2013-07-09','14:10:00',2.32),('5815','2013-07-09','14:15:00',2.34),('5815','2013-07-09','14:20:00',2.27),('5815','2013-07-09','14:25:00',2.25),('5815','2013-07-09','14:30:00',2.25),('5815','2013-07-09','14:35:00',2.25),('5815','2013-07-09','14:40:00',2.23),('5815','2013-07-09','14:45:00',2.22),('5815','2013-07-09','14:50:00',2.2),('5815','2013-07-09','14:55:00',2.2),('5815','2013-07-09','15:00:00',2.2),('5815','2013-07-09','15:05:00',2.22),('5815','2013-07-09','15:10:00',2.15),('5815','2013-07-09','15:15:00',2.12),('5815','2013-07-09','15:20:00',2.1),('5815','2013-07-09','15:25:00',2.08),('5815','2013-07-09','15:30:00',2.06),('5815','2013-07-09','15:35:00',2.05),('5815','2013-07-09','15:40:00',2.02),('5815','2013-07-09','15:45:00',2.02),('5815','2013-07-09','15:50:00',2),('5815','2013-07-09','15:55:00',1.95),('5815','2013-07-09','16:00:00',1.88),('5815','2013-07-09','16:05:00',1.87),('5815','2013-07-09','16:10:00',1.82),('5815','2013-07-09','16:15:00',1.77),('5815','2013-07-09','16:20:00',1.75),('5815','2013-07-09','16:25:00',1.71),('5815','2013-07-09','16:30:00',1.66),('5815','2013-07-09','16:35:00',1.63),('5815','2013-07-09','16:40:00',1.6),('5815','2013-07-09','16:45:00',1.57),('5815','2013-07-09','16:50:00',1.51),('5815','2013-07-09','16:55:00',1.5),('5815','2013-07-09','17:00:00',1.51),('5815','2013-07-09','17:05:00',1.37),('5815','2013-07-09','17:10:00',1.18),('5815','2013-07-09','17:35:00',1.21),('5815','2013-07-08','08:45:00',1),('5815','2013-07-08','08:50:00',1.05),('5815','2013-07-08','08:55:00',1.1),('5815','2013-07-08','09:00:00',1.15),('5815','2013-07-08','09:05:00',1.19),('5815','2013-07-08','09:10:00',1.22),('5815','2013-07-08','09:15:00',1.27),('5815','2013-07-08','09:20:00',1.31),('5815','2013-07-08','09:25:00',1.35),('5815','2013-07-08','09:30:00',1.39),('5815','2013-07-08','09:35:00',1.43),('5815','2013-07-08','09:40:00',1.48),('5815','2013-07-08','09:45:00',1.52),('5815','2013-07-08','09:50:00',1.56),('5815','2013-07-08','09:55:00',1.6),('5815','2013-07-08','10:00:00',1.63),('5815','2013-07-08','10:05:00',1.66),('5815','2013-07-08','10:10:00',1.71),('5815','2013-07-08','10:15:00',1.73),('5815','2013-07-08','10:20:00',1.77),('5815','2013-07-08','10:25:00',1.79),('5815','2013-07-08','10:30:00',1.81),('5815','2013-07-08','10:35:00',1.84),('5815','2013-07-08','10:40:00',1.85),('5815','2013-07-08','10:45:00',1.89),('5815','2013-07-08','10:50:00',1.9),('5815','2013-07-08','10:55:00',1.96),('5815','2013-07-08','11:00:00',1.98),('5815','2013-07-08','11:05:00',1.83),('5815','2013-07-08','11:10:00',1.74),('5815','2013-07-08','11:15:00',1.64),('5815','2013-07-08','11:20:00',1.72),('5815','2013-07-08','11:25:00',1.76),('5815','2013-07-08','11:30:00',1.2),('5815','2013-07-08','11:35:00',1.39),('5815','2013-07-08','11:40:00',1.51),('5815','2013-07-08','11:45:00',2.09),('5815','2013-07-08','11:50:00',2.4),('5815','2013-07-08','11:55:00',2.38),('5815','2013-07-08','12:00:00',2.38),('5815','2013-07-08','12:05:00',2.23),('5815','2013-07-08','12:10:00',1.6),('5815','2013-07-08','12:15:00',2.21),('5815','2013-07-08','12:20:00',2.19),('5815','2013-07-08','12:25:00',2.16),('5815','2013-07-08','12:30:00',2.19),('5815','2013-07-08','12:35:00',2.2),('5815','2013-07-08','12:40:00',2.19),('5815','2013-07-08','12:45:00',2.17),('5815','2013-07-08','12:50:00',2.21),('5815','2013-07-08','12:55:00',2.24),('5815','2013-07-08','13:00:00',2.24),('5815','2013-07-08','13:05:00',2.13),('5815','2013-07-08','13:10:00',2.35),('5815','2013-07-08','13:15:00',2.39),('5815','2013-07-08','13:20:00',2.37),('5815','2013-07-08','13:25:00',2.41),('5815','2013-07-08','13:30:00',2.43),('5815','2013-07-08','13:35:00',2.28),('5815','2013-07-08','13:40:00',2.28),('5815','2013-07-08','13:45:00',1.89),('5815','2013-07-08','13:50:00',1.78),('5815','2013-07-08','13:55:00',1.79),('5815','2013-07-08','14:00:00',1.76),('5815','2013-07-08','14:05:00',1.76),('5815','2013-07-08','14:10:00',1.95),('5815','2013-07-08','14:15:00',1.96),('5815','2013-07-08','14:20:00',1.47),('5815','2013-07-08','14:25:00',1.17),('5815','2013-07-07','08:50:00',1.04),('5815','2013-07-07','08:55:00',1.09),('5815','2013-07-07','09:00:00',1.13),('5815','2013-07-07','09:05:00',1.17),('5815','2013-07-07','09:10:00',1.22),('5815','2013-07-07','09:15:00',1.26),('5815','2013-07-07','09:20:00',1.3),('5815','2013-07-07','09:25:00',1.32),('5815','2013-07-07','09:30:00',1.39),('5815','2013-07-07','09:35:00',1.45),('5815','2013-07-07','09:40:00',1.49),('5815','2013-07-07','09:45:00',1.51),('5815','2013-07-07','09:50:00',1.52),('5815','2013-07-07','09:55:00',1.58),('5815','2013-07-07','10:00:00',1.62),('5815','2013-07-07','10:05:00',1.65),('5815','2013-07-07','10:10:00',1.66),('5815','2013-07-07','10:15:00',1.71),('5815','2013-07-07','10:20:00',1.74),('5815','2013-07-07','10:25:00',1.78),('5815','2013-07-07','10:30:00',1.75),('5815','2013-07-07','10:35:00',1.84),('5815','2013-07-07','10:40:00',1.85),('5815','2013-07-07','10:45:00',1.86),('5815','2013-07-07','10:50:00',1.88),('5815','2013-07-07','10:55:00',1.9),('5815','2013-07-07','11:00:00',1.92),('5815','2013-07-07','11:05:00',1.91),('5815','2013-07-07','11:10:00',1.95),('5815','2013-07-07','11:15:00',1.98),('5815','2013-07-07','11:20:00',2.03),('5815','2013-07-07','11:25:00',2.06),('5815','2013-07-07','11:30:00',2.09),('5815','2013-07-07','11:35:00',2.13),('5815','2013-07-07','11:40:00',2.01),('5815','2013-07-07','11:45:00',2.14),('5815','2013-07-07','11:50:00',2.12),('5815','2013-07-07','11:55:00',2.12),('5815','2013-07-07','12:00:00',2.12),('5815','2013-07-07','12:05:00',2.17),('5815','2013-07-07','12:10:00',2.21),('5815','2013-07-07','12:15:00',2.23),('5815','2013-07-07','12:20:00',2.32),('5815','2013-07-07','12:25:00',2.25),('5815','2013-07-07','12:30:00',2.19),('5815','2013-07-07','12:35:00',2.26),('5815','2013-07-07','12:40:00',2.22),('5815','2013-07-07','12:45:00',2.23),('5815','2013-07-07','12:50:00',2.24),('5815','2013-07-07','12:55:00',2.27),('5815','2013-07-07','13:00:00',2.07),('5815','2013-07-07','13:05:00',2.42),('5815','2013-07-07','13:10:00',2.56),('5815','2013-07-07','13:15:00',1.95),('5815','2013-07-07','13:20:00',1.37),('5815','2013-07-06','08:50:00',1),('5815','2013-07-06','08:55:00',1.19),('5815','2013-07-06','09:00:00',1.19),('5815','2013-07-06','09:05:00',1.11),('5815','2013-07-06','09:10:00',1.11),('5815','2013-07-06','09:15:00',1.08),('5815','2013-07-06','09:25:00',1.17),('5815','2013-07-06','09:30:00',1.42),('5815','2013-07-06','09:35:00',1.5),('5815','2013-07-06','09:40:00',1.4),('5815','2013-07-06','09:45:00',1.66),('5815','2013-07-06','09:50:00',1.67),('5815','2013-07-06','09:55:00',1.71),('5815','2013-07-06','10:00:00',1.71),('5815','2013-07-06','10:05:00',1.63),('5815','2013-07-06','10:10:00',1.72),('5815','2013-07-06','10:15:00',1.61),('5815','2013-07-06','10:20:00',1.76),('5815','2013-07-06','10:25:00',1.71),('5815','2013-07-06','10:30:00',1.7),('5815','2013-07-06','10:35:00',1.97),('5815','2013-07-06','10:40:00',1.81),('5815','2013-07-06','10:45:00',1.97),('5815','2013-07-06','10:50:00',1.99),('5815','2013-07-06','10:55:00',1.99),('5815','2013-07-06','11:00:00',2),('5815','2013-07-06','11:05:00',1.97),('5815','2013-07-06','11:10:00',1.98),('5815','2013-07-06','11:15:00',1.89),('5815','2013-07-06','11:20:00',1.91),('5815','2013-07-06','11:25:00',1.73),('5815','2013-07-06','11:30:00',1.82),('5815','2013-07-06','11:35:00',1.82),('5815','2013-07-06','11:40:00',1.84),('5815','2013-07-06','11:45:00',1.57),('5815','2013-07-06','11:50:00',1.46),('5815','2013-07-06','11:55:00',1.12),('5815','2013-07-06','12:00:00',1.67),('5815','2013-07-06','12:05:00',2.09),('5815','2013-07-06','12:10:00',2.12),('5815','2013-07-06','12:15:00',2.28),('5815','2013-07-06','12:20:00',2.21),('5815','2013-07-06','12:25:00',2.1),('5815','2013-07-06','12:30:00',2.16),('5815','2013-07-06','12:35:00',2.28),('5815','2013-07-06','12:40:00',2.31),('5815','2013-07-06','12:45:00',2.28),('5815','2013-07-06','12:50:00',2.24),('5815','2013-07-06','12:55:00',2.33),('5815','2013-07-06','13:00:00',2.3),('5815','2013-07-06','13:05:00',2.3),('5815','2013-07-06','13:10:00',2.3),('5815','2013-07-06','13:15:00',2.28),('5815','2013-07-06','13:20:00',2.3),('5815','2013-07-06','13:25:00',2.25),('5815','2013-07-06','13:30:00',2.16),('5815','2013-07-06','13:35:00',2.34),('5815','2013-07-06','13:40:00',1.6),('5815','2013-07-06','13:45:00',2.44),('5815','2013-07-06','13:50:00',2.44),('5815','2013-07-06','13:55:00',2.15),('5815','2013-07-06','14:00:00',1.94),('5815','2013-07-06','14:05:00',2.07),('5815','2013-07-06','14:10:00',1.27),('5815','2013-07-06','14:15:00',1.05),('5815','2013-07-05','08:45:00',1.02),('5815','2013-07-05','08:50:00',1.06),('5815','2013-07-05','08:55:00',1.11),('5815','2013-07-05','09:00:00',1.16),('5815','2013-07-05','09:05:00',1.2),('5815','2013-07-05','09:10:00',1.24),('5815','2013-07-05','09:15:00',1.28),('5815','2013-07-05','09:20:00',1.34),('5815','2013-07-05','09:25:00',1.38),('5815','2013-07-05','09:30:00',1.41),('5815','2013-07-05','09:35:00',1.44),('5815','2013-07-05','09:40:00',1.48),('5815','2013-07-05','09:45:00',1.52),('5815','2013-07-05','09:50:00',1.56),('5815','2013-07-05','09:55:00',1.61),('5815','2013-07-05','10:00:00',1.64),('5815','2013-07-05','10:05:00',1.69),('5815','2013-07-05','10:10:00',1.72),('5815','2013-07-05','10:15:00',1.75),('5815','2013-07-05','10:20:00',1.78),('5815','2013-07-05','10:25:00',1.81),('5815','2013-07-05','10:30:00',1.84),('5815','2013-07-05','10:35:00',1.87),('5815','2013-07-05','10:40:00',1.89),('5815','2013-07-05','10:45:00',1.91),('5815','2013-07-05','10:50:00',1.97),('5815','2013-07-05','10:55:00',1.99),('5815','2013-07-05','11:00:00',2),('5815','2013-07-05','11:05:00',1.96),('5815','2013-07-05','11:10:00',1.94),('5815','2013-07-05','11:15:00',1.97),('5815','2013-07-05','11:20:00',2.02),('5815','2013-07-05','11:25:00',2.05),('5815','2013-07-05','11:30:00',2.05),('5815','2013-07-05','11:35:00',2.06),('5815','2013-07-05','11:40:00',2.07),('5815','2013-07-05','11:45:00',2.08),('5815','2013-07-05','11:50:00',2.05),('5815','2013-07-05','11:55:00',2.04),('5815','2013-07-05','12:00:00',2.08),('5815','2013-07-05','12:05:00',2.16),('5815','2013-07-05','12:10:00',2.19),('5815','2013-07-05','12:15:00',2.19),('5815','2013-07-05','12:20:00',2.22),('5815','2013-07-05','12:25:00',2.21),('5815','2013-07-05','12:30:00',2.28),('5815','2013-07-05','12:35:00',2.23),('5815','2013-07-05','12:40:00',2.23),('5815','2013-07-05','12:45:00',2.24),('5815','2013-07-05','12:50:00',2.25),('5815','2013-07-05','12:55:00',2.26),('5815','2013-07-05','13:00:00',2.27),('5815','2013-07-05','13:05:00',2.29),('5815','2013-07-05','13:10:00',2.31),('5815','2013-07-05','13:15:00',2.32),('5815','2013-07-05','13:20:00',2.33),('5815','2013-07-05','13:25:00',2.32),('5815','2013-07-05','13:30:00',2.31),('5815','2013-07-05','13:35:00',2.27),('5815','2013-07-05','13:40:00',2.29),('5815','2013-07-05','13:45:00',2.28),('5815','2013-07-05','13:50:00',2.25),('5815','2013-07-05','13:55:00',2.27),('5815','2013-07-05','14:00:00',2.29),('5815','2013-07-05','14:05:00',2.3),('5815','2013-07-05','14:10:00',2.28),('5815','2013-07-05','14:15:00',2.18),('5815','2013-07-05','14:20:00',2.34),('5815','2013-07-05','14:25:00',2.26),('5815','2013-07-05','14:30:00',2.21),('5815','2013-07-05','14:35:00',2.22),('5815','2013-07-05','14:40:00',2.2),('5815','2013-07-05','14:45:00',2.17),('5815','2013-07-05','14:50:00',2.16),('5815','2013-07-05','14:55:00',1.95),('5815','2013-07-05','15:00:00',2.21),('5815','2013-07-05','15:05:00',2.21),('5815','2013-07-05','15:10:00',2.16),('5815','2013-07-05','15:15:00',2.11),('5815','2013-07-05','15:20:00',2.1),('5815','2013-07-05','15:25:00',2.1),('5815','2013-07-05','15:30:00',1.87),('5815','2013-07-04','08:45:00',1.03),('5815','2013-07-04','08:50:00',1.08),('5815','2013-07-04','08:55:00',1.12),('5815','2013-07-04','09:00:00',1.15),('5815','2013-07-04','09:05:00',1.2),('5815','2013-07-04','09:10:00',1.24),('5815','2013-07-04','09:15:00',1.28),('5815','2013-07-04','09:20:00',1.34),('5815','2013-07-04','09:25:00',1.38),('5815','2013-07-04','09:30:00',1.43),('5815','2013-07-04','09:35:00',1.47),('5815','2013-07-04','09:40:00',1.51),('5815','2013-07-04','09:45:00',1.54),('5815','2013-07-04','09:50:00',1.57),('5815','2013-07-04','09:55:00',1.61),('5815','2013-07-04','10:00:00',1.64),('5815','2013-07-04','10:05:00',1.67),('5815','2013-07-04','10:10:00',1.71),('5815','2013-07-04','10:15:00',1.75),('5815','2013-07-04','10:20:00',1.77),('5815','2013-07-04','10:25:00',1.8),('5815','2013-07-04','10:30:00',1.83),('5815','2013-07-04','10:35:00',1.86),('5815','2013-07-04','10:40:00',1.88),('5815','2013-07-04','10:45:00',1.9),('5815','2013-07-04','10:50:00',1.93),('5815','2013-07-04','10:55:00',1.95),('5815','2013-07-04','11:00:00',1.96),('5815','2013-07-04','11:05:00',1.92),('5815','2013-07-04','11:10:00',1.96),('5815','2013-07-04','11:15:00',1.98),('5815','2013-07-04','11:20:00',2),('5815','2013-07-04','11:25:00',2.02),('5815','2013-07-04','11:30:00',2.05),('5815','2013-07-04','11:35:00',2.05),('5815','2013-07-04','11:40:00',2.1),('5815','2013-07-04','11:45:00',2.06),('5815','2013-07-04','11:50:00',2.11),('5815','2013-07-04','11:55:00',2.1),('5815','2013-07-04','12:00:00',2.11),('5815','2013-07-04','12:05:00',2.12),('5815','2013-07-04','12:10:00',2.13),('5815','2013-07-04','12:15:00',2.16),('5815','2013-07-04','12:20:00',2.17),('5815','2013-07-04','12:25:00',1.36),('5815','2013-07-04','12:30:00',2.05),('5815','2013-07-04','12:35:00',1.7),('5815','2013-07-04','12:40:00',2.23),('5815','2013-07-04','12:45:00',2.29),('5815','2013-07-04','12:50:00',2.14),('5815','2013-07-04','12:55:00',2),('5815','2013-07-04','13:00:00',2.27),('5815','2013-07-04','13:05:00',1.55),('5815','2013-07-04','13:10:00',2.33),('5815','2013-07-04','13:15:00',2.1),('5815','2013-07-04','13:20:00',2.05),('5815','2013-07-04','13:25:00',2.18),('5815','2013-07-04','13:30:00',2.09),('5815','2013-07-04','13:35:00',2.32),('5815','2013-07-04','13:40:00',2.33),('5815','2013-07-04','13:45:00',2.28),('5815','2013-07-04','13:50:00',2.27),('5815','2013-07-04','13:55:00',2.29),('5815','2013-07-04','14:00:00',2.27),('5815','2013-07-04','14:05:00',2.02),('5815','2013-07-04','14:10:00',1.97),('5815','2013-07-04','14:15:00',2.3),('5815','2013-07-04','14:20:00',2.17),('5815','2013-07-04','14:25:00',2.24),('5815','2013-07-04','14:30:00',2.17),('5815','2013-07-04','14:35:00',2.09),('5815','2013-07-04','14:40:00',2.18),('5815','2013-07-04','14:45:00',1.86),('5815','2013-07-04','14:50:00',2.15),('5815','2013-07-04','14:55:00',2.13),('5815','2013-07-04','15:00:00',2.02),('5815','2013-07-04','15:05:00',2.16),('5815','2013-07-04','15:10:00',2.14),('5815','2013-07-04','15:15:00',1.75),('5815','2013-07-04','15:20:00',1.62),('5815','2013-07-04','15:25:00',1.59),('5815','2013-07-04','15:30:00',1.94),('5815','2013-07-04','15:35:00',2.03),('5815','2013-07-04','15:40:00',1.98),('5815','2013-07-04','15:45:00',2.03),('5815','2013-07-04','15:50:00',2.01),('5815','2013-07-04','15:55:00',1.92),('5815','2013-07-04','16:00:00',1.82),('5815','2013-07-04','16:05:00',1.78),('5815','2013-07-04','16:10:00',1.71),('5815','2013-07-04','16:15:00',1.71),('5815','2013-07-04','16:20:00',1.74),('5815','2013-07-04','16:25:00',1.7),('5815','2013-07-04','16:30:00',1.65),('5815','2013-07-04','16:35:00',1.56),('5815','2013-07-04','16:40:00',1.57),('5815','2013-07-04','16:45:00',1.58),('5815','2013-07-04','16:50:00',1.5),('5815','2013-07-04','16:55:00',1.34),('5815','2013-07-04','17:00:00',1.42),('5815','2013-07-04','17:05:00',1.38),('5815','2013-07-04','17:10:00',1.38),('5815','2013-07-04','17:15:00',1.36),('5815','2013-07-04','17:20:00',1.32),('5815','2013-07-04','17:25:00',1.26),('5815','2013-07-04','17:30:00',1.2),('5815','2013-07-04','17:35:00',1.07),('5815','2013-07-03','12:10:00',1.21),('5815','2013-07-03','12:15:00',1.66),('5815','2013-07-03','12:20:00',1.47),('5815','2013-07-03','12:25:00',1.73),('5815','2013-07-03','12:30:00',1.67),('5815','2013-07-03','12:35:00',1.28),('5815','2013-07-03','13:20:00',1.04),('5815','2013-07-03','13:25:00',1.19),('5815','2013-07-03','13:30:00',1.1),('5815','2013-07-03','13:35:00',1.14),('5815','2013-07-03','13:40:00',1.36),('5815','2013-07-03','13:45:00',1.21),('5815','2013-07-03','13:50:00',1.74),('5815','2013-07-03','13:55:00',1.51),('5815','2013-07-03','14:00:00',1.22),('5815','2013-07-03','14:05:00',1.18),('5815','2013-07-03','14:10:00',1.16),('5815','2013-07-03','14:15:00',1.2),('5815','2013-07-03','14:20:00',1.23),('5815','2013-07-03','14:25:00',1.04),('5815','2013-07-03','14:35:00',1.03),('5815','2013-07-03','14:40:00',1.73),('5815','2013-07-03','14:45:00',2.49),('5815','2013-07-03','14:50:00',1.32),('5815','2013-07-03','14:55:00',1.37),('5815','2013-07-03','15:00:00',2.47),('5815','2013-07-03','15:05:00',2.24),('5815','2013-07-03','15:10:00',1.65),('5815','2013-07-03','15:15:00',2.46),('5815','2013-07-03','15:20:00',2.35),('5815','2013-07-03','15:25:00',2.27),('5815','2013-07-03','15:30:00',1.53),('5815','2013-07-03','15:35:00',1.75),('5815','2013-07-03','15:40:00',1.8),('5815','2013-07-03','15:45:00',1.74),('5815','2013-07-03','15:50:00',1.29),('5815','2013-07-03','15:55:00',1.37),('5815','2013-07-03','16:00:00',1.45),('5815','2013-07-03','16:05:00',1.25),('5815','2013-07-03','16:10:00',1.17),('5815','2013-07-03','16:15:00',1.05),('5815','2013-07-03','16:20:00',1.05),('5815','2013-07-03','16:25:00',1.12),('5815','2013-07-03','16:30:00',1.11),('5815','2013-07-03','16:35:00',1.08),('5815','2013-07-03','17:10:00',1.15),('5815','2013-07-03','17:15:00',1.43),('5815','2013-07-03','17:20:00',1.47),('5815','2013-07-03','17:25:00',1.37),('5815','2013-07-03','17:30:00',1.15),('5815','2013-07-03','17:35:00',1.13),('5815','2013-07-03','17:40:00',1.21),('5815','2013-07-03','17:45:00',1.17),('5815','2013-07-03','17:50:00',1.13),('5815','2013-07-03','17:55:00',1.08),('5815','2013-07-03','18:00:00',1.06),('5815','2013-07-03','18:05:00',1.05),('5815','2013-07-02','08:40:00',1.02),('5815','2013-07-02','08:45:00',1.07),('5815','2013-07-02','08:50:00',1.12),('5815','2013-07-02','08:55:00',1.17),('5815','2013-07-02','09:00:00',1.2),('5815','2013-07-02','09:05:00',1.25),('5815','2013-07-02','09:10:00',1.3),('5815','2013-07-02','09:15:00',1.33),('5815','2013-07-02','09:20:00',1.38),('5815','2013-07-02','09:25:00',1.42),('5815','2013-07-02','09:30:00',1.46),('5815','2013-07-02','09:35:00',1.48),('5815','2013-07-02','09:40:00',1.51),('5815','2013-07-02','09:45:00',1.57),('5815','2013-07-02','09:50:00',1.61),('5815','2013-07-02','09:55:00',1.63),('5815','2013-07-02','10:00:00',1.68),('5815','2013-07-02','10:05:00',1.7),('5815','2013-07-02','10:10:00',1.7),('5815','2013-07-02','10:15:00',1.73),('5815','2013-07-02','10:20:00',1.74),('5815','2013-07-02','10:25:00',1.81),('5815','2013-07-02','10:30:00',1.87),('5815','2013-07-02','10:35:00',1.88),('5815','2013-07-02','10:40:00',1.89),('5815','2013-07-02','10:45:00',1.96),('5815','2013-07-02','10:50:00',1.98),('5815','2013-07-02','10:55:00',1.99),('5815','2013-07-02','11:00:00',2.01),('5815','2013-07-02','11:05:00',1.96),('5815','2013-07-02','11:10:00',1.96),('5815','2013-07-02','11:15:00',2.03),('5815','2013-07-02','11:20:00',2.06),('5815','2013-07-02','11:25:00',2.08),('5815','2013-07-02','11:30:00',2.08),('5815','2013-07-02','11:35:00',2.09),('5815','2013-07-02','11:40:00',2.1),('5815','2013-07-02','11:45:00',2.12),('5815','2013-07-02','11:50:00',2.1),('5815','2013-07-02','11:55:00',2.09),('5815','2013-07-02','12:00:00',2.21),('5815','2013-07-02','12:05:00',2.25),('5815','2013-07-02','12:10:00',2.21),('5815','2013-07-02','12:15:00',2.26),('5815','2013-07-02','12:20:00',2.28),('5815','2013-07-02','12:25:00',2.28),('5815','2013-07-02','12:30:00',2.32),('5815','2013-07-02','12:35:00',2.29),('5815','2013-07-02','12:40:00',2.27),('5815','2013-07-02','12:45:00',2.29),('5815','2013-07-02','12:50:00',2.32),('5815','2013-07-02','12:55:00',2.32),('5815','2013-07-02','13:00:00',2.34),('5815','2013-07-02','13:05:00',2.36),('5815','2013-07-02','13:10:00',2.37),('5815','2013-07-02','13:15:00',2.36),('5815','2013-07-02','13:20:00',2.37),('5815','2013-07-02','13:25:00',2.35),('5815','2013-07-02','13:30:00',2.32),('5815','2013-07-02','13:35:00',2.32),('5815','2013-07-02','13:40:00',2.32),('5815','2013-07-02','13:45:00',2.35),('5815','2013-07-02','13:50:00',2.34),('5815','2013-07-02','13:55:00',2.32),('5815','2013-07-02','14:00:00',2.31),('5815','2013-07-02','14:05:00',2.3),('5815','2013-07-02','14:10:00',2.3),('5815','2013-07-02','14:15:00',2.33),('5815','2013-07-02','14:20:00',2.31),('5815','2013-07-02','14:25:00',2.28),('5815','2013-07-02','14:30:00',2.3),('5815','2013-07-02','14:35:00',2.28),('5815','2013-07-02','14:40:00',2.26),('5815','2013-07-02','14:45:00',2.25),('5815','2013-07-02','14:50:00',2.24),('5815','2013-07-02','14:55:00',2.22),('5815','2013-07-02','15:00:00',2.2),('5815','2013-07-02','15:05:00',2.22),('5815','2013-07-02','15:10:00',2.15),('5815','2013-07-02','15:15:00',2.15),('5815','2013-07-02','15:20:00',2.13),('5815','2013-07-02','15:25:00',2.11),('5815','2013-07-02','15:30:00',2.1),('5815','2013-07-02','15:35:00',2.08),('5815','2013-07-02','15:40:00',2.04),('5815','2013-07-02','15:45:00',2.06),('5815','2013-07-02','15:50:00',2.04),('5815','2013-07-02','15:55:00',1.98),('5815','2013-07-02','16:00:00',1.92),('5815','2013-07-02','16:05:00',1.89),('5815','2013-07-02','16:10:00',1.87),('5815','2013-07-02','16:15:00',1.82),('5815','2013-07-02','16:20:00',1.8),('5815','2013-07-02','16:25:00',1.77),('5815','2013-07-02','16:30:00',1.73),('5815','2013-07-02','16:35:00',1.7),('5815','2013-07-02','16:40:00',1.66),('5815','2013-07-02','16:45:00',1.62),('5815','2013-07-02','16:50:00',1.58),('5815','2013-07-02','16:55:00',1.54),('5815','2013-07-02','17:00:00',1.49),('5815','2013-07-02','17:05:00',1.44),('5815','2013-07-02','17:10:00',1.42),('5815','2013-07-02','17:15:00',1.37),('5815','2013-07-02','17:20:00',1.32),('5815','2013-07-02','17:25:00',1.28),('5815','2013-07-02','17:30:00',1.2),('5815','2013-07-02','17:35:00',1.17),('5815','2013-07-02','17:40:00',1.12),('5815','2013-07-02','17:45:00',1.07),('5815','2013-07-02','17:50:00',1.04),('5815','2013-07-01','08:40:00',1),('5815','2013-07-01','08:45:00',1.05),('5815','2013-07-01','08:50:00',1.09),('5815','2013-07-01','08:55:00',1.14),('5815','2013-07-01','09:00:00',1.18),('5815','2013-07-01','09:05:00',1.24),('5815','2013-07-01','09:10:00',1.27),('5815','2013-07-01','09:15:00',1.33),('5815','2013-07-01','09:20:00',1.37),('5815','2013-07-01','09:25:00',1.41),('5815','2013-07-01','09:30:00',1.46),('5815','2013-07-01','09:35:00',1.48),('5815','2013-07-01','09:40:00',1.52),('5815','2013-07-01','09:45:00',1.56),('5815','2013-07-01','09:50:00',1.59),('5815','2013-07-01','09:55:00',1.62),('5815','2013-07-01','10:00:00',1.66),('5815','2013-07-01','10:05:00',1.71),('5815','2013-07-01','10:10:00',1.73),('5815','2013-07-01','10:15:00',1.75),('5815','2013-07-01','10:20:00',1.78),('5815','2013-07-01','10:25:00',1.81),('5815','2013-07-01','10:30:00',1.85),('5815','2013-07-01','10:35:00',1.89),('5815','2013-07-01','10:40:00',1.91),('5815','2013-07-01','10:45:00',1.93),('5815','2013-07-01','10:50:00',1.94),('5815','2013-07-01','10:55:00',1.96),('5815','2013-07-01','11:00:00',1.97),('5815','2013-07-01','11:05:00',1.92),('5815','2013-07-01','11:10:00',1.92),('5815','2013-07-01','11:15:00',1.96),('5815','2013-07-01','11:20:00',1.97),('5815','2013-07-01','11:25:00',1.99),('5815','2013-07-01','11:30:00',2.02),('5815','2013-07-01','11:35:00',2.05),('5815','2013-07-01','11:40:00',2.09),('5815','2013-07-01','11:45:00',2.03),('5815','2013-07-01','11:50:00',1.99),('5815','2013-07-01','11:55:00',2),('5815','2013-07-01','12:00:00',2.09),('5815','2013-07-01','12:05:00',2.06),('5815','2013-07-01','12:10:00',2.14),('5815','2013-07-01','12:15:00',2.14),('5815','2013-07-01','12:20:00',2.12),('5815','2013-07-01','12:25:00',2.08),('5815','2013-07-01','12:30:00',2.2),('5815','2013-07-01','12:35:00',2.22),('5815','2013-07-01','12:40:00',2.25),('5815','2013-07-01','12:45:00',2.27),('5815','2013-07-01','12:50:00',2.28),('5815','2013-07-01','12:55:00',1.05),('5815','2013-07-01','13:00:00',1.87),('5815','2013-07-01','13:10:00',2.4),('5815','2013-07-01','13:15:00',2.44),('5815','2013-07-01','13:20:00',2.4),('5815','2013-07-01','13:25:00',2.45),('5815','2013-07-01','13:30:00',2.38),('5815','2013-07-01','13:35:00',2.34),('5815','2013-07-01','13:40:00',2.36),('5815','2013-07-01','13:45:00',2.19),('5815','2013-07-01','13:50:00',2.19),('5815','2013-07-01','13:55:00',2.24),('5815','2013-07-01','14:00:00',2.23),('5815','2013-07-01','14:05:00',2.23),('5815','2013-07-01','14:10:00',2.23),('5815','2013-07-01','14:15:00',2.27),('5815','2013-07-01','14:20:00',2.24),('5815','2013-07-01','14:25:00',2.21),('5815','2013-07-01','14:30:00',2.22),('5815','2013-07-01','14:35:00',2.22),('5815','2013-07-01','14:40:00',2.18),('5815','2013-07-01','14:45:00',2.18),('5815','2013-07-01','14:50:00',2.17),('5815','2013-07-01','14:55:00',2.16),('5815','2013-07-01','15:00:00',2.17),('5815','2013-07-01','15:05:00',2.17),('5815','2013-07-01','15:10:00',2.12),('5815','2013-07-01','15:15:00',2.09),('5815','2013-07-01','15:20:00',2.09),('5815','2013-07-01','15:25:00',2.07),('5815','2013-07-01','15:30:00',2.05),('5815','2013-07-01','15:35:00',2.03),('5815','2013-07-01','15:40:00',2.01),('5815','2013-07-01','15:45:00',2),('5815','2013-07-01','15:50:00',1.99),('5815','2013-07-01','15:55:00',1.92),('5815','2013-07-01','16:00:00',1.88),('5815','2013-07-01','16:05:00',1.86),('5815','2013-07-01','16:10:00',1.83),('5815','2013-07-01','16:15:00',1.79),('5815','2013-07-01','16:20:00',1.76),('5815','2013-07-01','16:25:00',1.72),('5815','2013-07-01','16:30:00',1.68),('5815','2013-07-01','16:35:00',1.64),('5815','2013-07-01','16:40:00',1.6),('5815','2013-07-01','16:45:00',1.55),('5815','2013-07-01','16:50:00',1.51),('5815','2013-07-01','16:55:00',1.49),('5815','2013-07-01','17:00:00',1.46),('5815','2013-07-01','17:05:00',1.41),('5815','2013-07-01','17:10:00',1.33),('5815','2013-07-01','17:15:00',1.32),('5815','2013-07-01','17:20:00',1.28),('5815','2013-07-01','17:25:00',1.24),('5815','2013-07-01','17:30:00',1.18),('5815','2013-07-01','17:35:00',1.07),('5815','2013-07-01','17:45:00',1.01),('5815','2013-06-30','08:40:00',1.03),('5815','2013-06-30','08:45:00',1.08),('5815','2013-06-30','08:50:00',1.13),('5815','2013-06-30','08:55:00',1.17),('5815','2013-06-30','09:00:00',1.22),('5815','2013-06-30','09:05:00',1.27),('5815','2013-06-30','09:10:00',1.3),('5815','2013-06-30','09:15:00',1.36),('5815','2013-06-30','09:20:00',1.41),('5815','2013-06-30','09:25:00',1.45),('5815','2013-06-30','09:30:00',1.51),('5815','2013-06-30','09:35:00',1.54),('5815','2013-06-30','09:40:00',1.57),('5815','2013-06-30','09:45:00',1.61),('5815','2013-06-30','09:50:00',1.64),('5815','2013-06-30','09:55:00',1.68),('5815','2013-06-30','10:00:00',1.7),('5815','2013-06-30','10:05:00',1.74),('5815','2013-06-30','10:10:00',1.78),('5815','2013-06-30','10:15:00',1.83),('5815','2013-06-30','10:20:00',1.85),('5815','2013-06-30','10:25:00',1.88),('5815','2013-06-30','10:30:00',1.91),('5815','2013-06-30','10:35:00',1.94),('5815','2013-06-30','10:40:00',1.98),('5815','2013-06-30','10:45:00',2),('5815','2013-06-30','10:50:00',2.02),('5815','2013-06-30','10:55:00',2.04),('5815','2013-06-30','11:00:00',2.06),('5815','2013-06-30','11:05:00',2.02),('5815','2013-06-30','11:10:00',2.03),('5815','2013-06-30','11:15:00',2.09),('5815','2013-06-30','11:20:00',2.11),('5815','2013-06-30','11:25:00',2.13),('5815','2013-06-30','11:30:00',2.15),('5815','2013-06-30','11:35:00',2.15),('5815','2013-06-30','11:40:00',2.16),('5815','2013-06-30','11:45:00',2.14),('5815','2013-06-30','11:50:00',2.11),('5815','2013-06-30','11:55:00',2.11),('5815','2013-06-30','12:00:00',2.23),('5815','2013-06-30','12:05:00',2.22),('5815','2013-06-30','12:10:00',2.22),('5815','2013-06-30','12:15:00',2.24),('5815','2013-06-30','12:20:00',2.23),('5815','2013-06-30','12:25:00',2.24),('5815','2013-06-30','12:30:00',2.29),('5815','2013-06-30','12:35:00',2.27),('5815','2013-06-30','12:40:00',2.27),('5815','2013-06-30','12:45:00',2.28),('5815','2013-06-30','12:50:00',2.3),('5815','2013-06-30','12:55:00',2.32),('5815','2013-06-30','13:00:00',2.31),('5815','2013-06-30','13:05:00',2.3),('5815','2013-06-30','13:10:00',2.31),('5815','2013-06-30','13:15:00',2.32),('5815','2013-06-30','13:20:00',2.36),('5815','2013-06-30','13:25:00',2.36),('5815','2013-06-30','13:30:00',2.31),('5815','2013-06-30','13:35:00',2.28),('5815','2013-06-30','13:40:00',2.26),('5815','2013-06-30','13:45:00',2.26),('5815','2013-06-30','13:50:00',2.28),('5815','2013-06-30','13:55:00',2.26),('5815','2013-06-30','14:00:00',2.28),('5815','2013-06-30','14:05:00',2.32),('5815','2013-06-30','14:10:00',2.35),('5815','2013-06-30','14:15:00',2.34),('5815','2013-06-30','14:20:00',2.3),('5815','2013-06-30','14:25:00',2.27),('5815','2013-06-30','14:30:00',2.25),('5815','2013-06-30','14:35:00',2.23),('5815','2013-06-30','14:40:00',2.23),('5815','2013-06-30','14:45:00',2.21),('5815','2013-06-30','14:50:00',2.19),('5815','2013-06-30','14:55:00',2.17),('5815','2013-06-30','15:00:00',2.18),('5815','2013-06-30','15:05:00',2.14),('5815','2013-06-30','15:10:00',2.1),('5815','2013-06-30','15:15:00',2.09),('5815','2013-06-30','15:20:00',2.07),('5815','2013-06-30','15:25:00',2.05),('5815','2013-06-30','15:30:00',2.02),('5815','2013-06-30','15:35:00',2),('5815','2013-06-30','15:40:00',1.96),('5815','2013-06-30','15:45:00',1.99),('5815','2013-06-30','15:50:00',1.97),('5815','2013-06-30','15:55:00',1.91),('5815','2013-06-30','16:00:00',1.86),('5815','2013-06-30','16:05:00',1.83),('5815','2013-06-30','16:10:00',1.81),('5815','2013-06-30','16:15:00',1.74),('5815','2013-06-30','16:20:00',1.71),('5815','2013-06-30','16:25:00',1.68),('5815','2013-06-30','16:30:00',1.65),('5815','2013-06-30','16:35:00',1.61),('5815','2013-06-30','16:40:00',1.57),('5815','2013-06-30','16:45:00',1.54),('5815','2013-06-30','16:50:00',1.52),('5815','2013-06-30','16:55:00',1.49),('5815','2013-06-30','17:00:00',1.46),('5815','2013-06-30','17:05:00',1.4),('5815','2013-06-30','17:10:00',1.33),('5815','2013-06-30','17:15:00',1.31),('5815','2013-06-30','17:20:00',1.26),('5815','2013-06-30','17:25:00',1.22),('5815','2013-06-30','17:30:00',1.15),('5815','2013-06-30','17:35:00',1.05),('5815','2013-06-30','17:45:00',1.02),('5815','2013-06-29','08:35:00',1.02),('5815','2013-06-29','08:40:00',1.07),('5815','2013-06-29','08:45:00',1.12),('5815','2013-06-29','08:50:00',1.17),('5815','2013-06-29','08:55:00',1.22),('5815','2013-06-29','09:00:00',1.26),('5815','2013-06-29','09:05:00',1.31),('5815','2013-06-29','09:10:00',1.34),('5815','2013-06-29','09:15:00',1.4),('5815','2013-06-29','09:20:00',1.44),('5815','2013-06-29','09:25:00',1.48),('5815','2013-06-29','09:30:00',1.53),('5815','2013-06-29','09:35:00',1.57),('5815','2013-06-29','09:40:00',1.61),('5815','2013-06-29','09:45:00',1.65),('5815','2013-06-29','09:50:00',1.68),('5815','2013-06-29','09:55:00',1.72),('5815','2013-06-29','10:00:00',1.76),('5815','2013-06-29','10:05:00',1.79),('5815','2013-06-29','10:10:00',1.81),('5815','2013-06-29','10:15:00',1.85),('5815','2013-06-29','10:20:00',1.88),('5815','2013-06-29','10:25:00',1.91),('5815','2013-06-29','10:30:00',1.95),('5815','2013-06-29','10:35:00',1.98),('5815','2013-06-29','10:40:00',1.98),('5815','2013-06-29','10:45:00',2.03),('5815','2013-06-29','10:50:00',2.05),('5815','2013-06-29','10:55:00',2.07),('5815','2013-06-29','11:00:00',2.08),('5815','2013-06-29','11:05:00',2.04),('5815','2013-06-29','11:10:00',2.05),('5815','2013-06-29','11:15:00',2.08),('5815','2013-06-29','11:20:00',2.11),('5815','2013-06-29','11:25:00',2.13),('5815','2013-06-29','11:30:00',2.13),('5815','2013-06-29','11:35:00',2.16),('5815','2013-06-29','11:40:00',2.2),('5815','2013-06-29','11:45:00',2.15),('5815','2013-06-29','11:50:00',2.11),('5815','2013-06-29','11:55:00',2.14),('5815','2013-06-29','12:00:00',2.23),('5815','2013-06-29','12:05:00',2.27),('5815','2013-06-29','12:10:00',2.29),('5815','2013-06-29','12:15:00',2.27),('5815','2013-06-29','12:20:00',2.29),('5815','2013-06-29','12:25:00',2.33),('5815','2013-06-29','12:30:00',2.36),('5815','2013-06-29','12:35:00',2.33),('5815','2013-06-29','12:40:00',2.31),('5815','2013-06-29','12:45:00',2.35),('5815','2013-06-29','12:50:00',2.37),('5815','2013-06-29','12:55:00',2.35),('5815','2013-06-29','13:00:00',2.36),('5815','2013-06-29','13:05:00',2.35),('5815','2013-06-29','13:10:00',2.35),('5815','2013-06-29','13:15:00',2.37),('5815','2013-06-29','13:20:00',2.4),('5815','2013-06-29','13:25:00',2.41),('5815','2013-06-29','13:30:00',2.38),('5815','2013-06-29','13:35:00',2.36),('5815','2013-06-29','13:40:00',2.35),('5815','2013-06-29','13:45:00',2.36),('5815','2013-06-29','13:50:00',2.38),('5815','2013-06-29','13:55:00',2.07),('5815','2013-06-29','14:00:00',2.38),('5815','2013-06-29','14:05:00',2.36),('5815','2013-06-29','14:10:00',2.36),('5815','2013-06-29','14:15:00',2.34),('5815','2013-06-29','14:20:00',2.29),('5815','2013-06-29','14:25:00',2.26),('5815','2013-06-29','14:30:00',2.25),('5815','2013-06-29','14:35:00',2.26),('5815','2013-06-29','14:40:00',2.26),('5815','2013-06-29','14:45:00',2.26),('5815','2013-06-29','14:50:00',2.25),('5815','2013-06-29','14:55:00',2.23),('5815','2013-06-29','15:00:00',2.22),('5815','2013-06-29','15:05:00',2.2),('5815','2013-06-29','15:10:00',2.16),('5815','2013-06-29','15:15:00',2.14),('5815','2013-06-29','15:20:00',2.14),('5815','2013-06-29','15:25:00',2.1),('5815','2013-06-29','15:30:00',2.09),('5815','2013-06-29','15:35:00',2.08),('5815','2013-06-29','15:40:00',2.07),('5815','2013-06-29','15:45:00',2.08),('5815','2013-06-29','15:50:00',2.07),('5815','2013-06-29','15:55:00',2),('5815','2013-06-29','16:00:00',1.92),('5815','2013-06-29','16:05:00',1.84),('5815','2013-06-29','16:10:00',1.8),('5815','2013-06-29','16:15:00',1.87),('5815','2013-06-29','16:20:00',1.89),('5815','2013-06-29','16:25:00',1.89),('5815','2013-06-29','16:30:00',1.64),('5815','2013-06-29','16:35:00',1.7),('5815','2013-06-29','16:40:00',1.65),('5815','2013-06-29','16:45:00',1.63),('5815','2013-06-29','16:50:00',1.58),('5815','2013-06-29','16:55:00',1.53),('5815','2013-06-29','17:00:00',1.47),('5815','2013-06-29','17:05:00',1.43),('5815','2013-06-29','17:10:00',1.38),('5815','2013-06-29','17:15:00',1.35),('5815','2013-06-29','17:20:00',1.3),('5815','2013-06-29','17:25:00',1.24),('5815','2013-06-29','17:30:00',1.18),('5815','2013-06-29','17:35:00',1.08),('5815','2013-06-29','17:45:00',1.03),('5815','2013-06-29','17:50:00',1.01),('5815','2013-06-28','08:10:00',1.03),('5815','2013-06-28','08:30:00',1.03),('5815','2013-06-28','08:35:00',1.06),('5815','2013-06-28','08:45:00',1.01),('5815','2013-06-28','08:50:00',1.17),('5815','2013-06-28','08:55:00',1.21),('5815','2013-06-28','09:00:00',1.24),('5815','2013-06-28','09:05:00',1.28),('5815','2013-06-28','09:10:00',1.33),('5815','2013-06-28','09:15:00',1.38),('5815','2013-06-28','09:20:00',1.41),('5815','2013-06-28','09:25:00',1.45),('5815','2013-06-28','09:30:00',1.48),('5815','2013-06-28','09:35:00',1.55),('5815','2013-06-28','09:40:00',1.58),('5815','2013-06-28','09:45:00',1.61),('5815','2013-06-28','09:50:00',1.66),('5815','2013-06-28','09:55:00',1.69),('5815','2013-06-28','10:00:00',1.73),('5815','2013-06-28','10:05:00',1.77),('5815','2013-06-28','10:10:00',1.81),('5815','2013-06-28','10:15:00',1.82),('5815','2013-06-28','10:20:00',1.86),('5815','2013-06-28','10:25:00',1.89),('5815','2013-06-28','10:30:00',1.92),('5815','2013-06-28','10:35:00',1.95),('5815','2013-06-28','10:40:00',1.98),('5815','2013-06-28','10:45:00',2.03),('5815','2013-06-28','10:50:00',2.04),('5815','2013-06-28','10:55:00',2.11),('5815','2013-06-28','11:00:00',2.12),('5815','2013-06-28','11:05:00',2.12),('5815','2013-06-28','11:10:00',2.14),('5815','2013-06-28','11:15:00',2.18),('5815','2013-06-28','11:20:00',1.3),('5815','2013-06-28','11:25:00',2.36),('5815','2013-06-28','11:30:00',2.4),('5815','2013-06-28','11:35:00',2.15),('5815','2013-06-28','11:40:00',2),('5815','2013-06-28','11:50:00',1.63),('5815','2013-06-28','11:55:00',2.52),('5815','2013-06-28','12:00:00',1.82),('5815','2013-06-28','12:05:00',2.4),('5815','2013-06-28','12:10:00',2.44),('5815','2013-06-28','12:15:00',1.85),('5815','2013-06-28','12:25:00',2.58),('5815','2013-06-28','12:30:00',2.36),('5815','2013-06-28','12:35:00',2.48),('5815','2013-06-28','12:40:00',2.41),('5815','2013-06-28','12:45:00',2.6),('5815','2013-06-28','12:50:00',1.22),('5815','2013-06-28','12:55:00',1.88),('5815','2013-06-28','13:00:00',1.74),('5815','2013-06-28','13:05:00',1.36),('5815','2013-06-28','13:10:00',2.7),('5815','2013-06-28','13:15:00',2.55),('5815','2013-06-28','13:20:00',1.41),('5815','2013-06-28','13:25:00',2.22),('5815','2013-06-28','13:45:00',1.77),('5815','2013-06-28','13:50:00',2.55),('5815','2013-06-28','13:55:00',2.04),('5815','2013-06-28','14:00:00',2.48),('5815','2013-06-28','14:05:00',1.84),('5815','2013-06-28','14:10:00',2.24),('5815','2013-06-28','14:15:00',2.71),('5815','2013-06-28','14:20:00',2.44),('5815','2013-06-28','14:25:00',1.52),('5815','2013-06-28','14:30:00',2.73),('5815','2013-06-28','14:35:00',2.57),('5815','2013-06-28','14:40:00',2.53),('5815','2013-06-28','14:45:00',2.54),('5815','2013-06-28','14:50:00',2.04),('5815','2013-06-28','15:00:00',1.24),('5815','2013-06-28','15:05:00',1.8),('5815','2013-06-28','15:10:00',1.28),('5815','2013-06-28','16:50:00',1.41),('5815','2013-06-28','17:30:00',1.29),('5815','2013-06-28','17:35:00',1.23),('5815','2013-06-28','17:45:00',1.06),('5815','2013-06-28','17:50:00',1.08),('5815','2013-06-27','08:35:00',1),('5815','2013-06-27','08:40:00',1.05),('5815','2013-06-27','08:45:00',1.08),('5815','2013-06-27','08:50:00',1.14),('5815','2013-06-27','08:55:00',1.18),('5815','2013-06-27','09:00:00',1.22),('5815','2013-06-27','09:05:00',1.26),('5815','2013-06-27','09:10:00',1.37),('5815','2013-06-27','09:15:00',1.31),('5815','2013-06-27','09:35:00',1.67),('5815','2013-06-27','09:40:00',1.66),('5815','2013-06-27','09:45:00',1.01),('5815','2013-06-27','09:55:00',1.19),('5815','2013-06-27','10:00:00',1.87),('5815','2013-06-27','10:05:00',1.15),('5815','2013-06-27','10:10:00',1.94),('5815','2013-06-27','10:15:00',1.88),('5815','2013-06-27','10:20:00',2.08),('5815','2013-06-27','10:25:00',1.74),('5815','2013-06-27','10:35:00',1.6),('5815','2013-06-27','10:40:00',2.35),('5815','2013-06-27','10:45:00',2.23),('5815','2013-06-27','10:50:00',2.27),('5815','2013-06-27','10:55:00',1.4),('5815','2013-06-27','11:00:00',1.45),('5815','2013-06-27','11:05:00',2.48),('5815','2013-06-27','11:10:00',1.71),('5815','2013-06-27','11:25:00',1.37),('5815','2013-06-27','11:30:00',2.47),('5815','2013-06-27','11:35:00',2.2),('5815','2013-06-27','11:40:00',2.46),('5815','2013-06-27','11:45:00',2.09),('5815','2013-06-27','11:50:00',2.48),('5815','2013-06-27','11:55:00',1.83),('5815','2013-06-27','12:00:00',1.38),('5815','2013-06-27','12:05:00',1.64),('5815','2013-06-27','12:10:00',1.69),('5815','2013-06-27','12:15:00',2.6),('5815','2013-06-27','12:20:00',2.5),('5815','2013-06-27','12:25:00',2.53),('5815','2013-06-27','12:30:00',2.41),('5815','2013-06-27','12:35:00',2.52),('5815','2013-06-27','12:40:00',2.01),('5815','2013-06-27','12:45:00',2.34),('5815','2013-06-27','12:50:00',2.49),('5815','2013-06-27','12:55:00',2.47),('5815','2013-06-27','13:00:00',2.24),('5815','2013-06-27','13:05:00',2.48),('5815','2013-06-27','13:10:00',2.02),('5815','2013-06-27','13:15:00',2.58),('5815','2013-06-27','13:20:00',2.49),('5815','2013-06-27','13:25:00',2.45),('5815','2013-06-27','13:30:00',2.51),('5815','2013-06-27','13:35:00',2.5),('5815','2013-06-27','13:40:00',2.48),('5815','2013-06-27','13:45:00',2.33),('5815','2013-06-27','13:50:00',2.56),('5815','2013-06-27','13:55:00',2.52),('5815','2013-06-27','14:00:00',2.33),('5815','2013-06-27','14:05:00',2.32),('5815','2013-06-27','14:10:00',2.43),('5815','2013-06-27','14:15:00',2.08),('5815','2013-06-27','14:20:00',2.46),('5815','2013-06-27','14:25:00',2.43),('5815','2013-06-27','14:30:00',2.15),('5815','2013-06-27','14:35:00',2.27),('5815','2013-06-27','14:40:00',2.1),('5815','2013-06-27','14:45:00',1.91),('5815','2013-06-27','14:50:00',2.48),('5815','2013-06-27','14:55:00',2.12),('5815','2013-06-27','15:00:00',1.89),('5815','2013-06-27','15:05:00',2.32),('5815','2013-06-27','15:10:00',2.13),('5815','2013-06-27','15:15:00',2.19),('5815','2013-06-27','15:20:00',1.04),('5815','2013-06-27','15:25:00',2.2),('5815','2013-06-27','15:30:00',1.57),('5815','2013-06-27','15:35:00',1.13),('5815','2013-06-27','15:40:00',2.06),('5815','2013-06-27','15:45:00',1.36),('5815','2013-06-27','15:50:00',2.36),('5815','2013-06-27','15:55:00',2.22),('5815','2013-06-27','16:00:00',1.37),('5815','2013-06-27','16:05:00',2.15),('5815','2013-06-27','16:10:00',1.46),('5815','2013-06-27','16:15:00',2.04),('5815','2013-06-27','16:20:00',1.17),('5815','2013-06-27','16:25:00',1.4),('5815','2013-06-27','16:35:00',1.17),('5815','2013-06-27','16:40:00',1.61),('5815','2013-06-27','16:55:00',1.03),('5815','2013-06-27','17:05:00',1.5),('5815','2013-06-27','17:10:00',1.43),('5815','2013-06-27','17:15:00',1.36),('5815','2013-06-27','17:20:00',1.3),('5815','2013-06-27','17:25:00',1.26),('5815','2013-06-27','17:35:00',1.05),('5815','2013-06-27','17:40:00',1.1),('5815','2013-06-27','17:45:00',1.06),('5815','2013-06-27','17:50:00',1.05),('5815','2013-06-26','08:40:00',1.03),('5815','2013-06-26','08:45:00',1.08),('5815','2013-06-26','08:50:00',1.12),('5815','2013-06-26','08:55:00',1.18),('5815','2013-06-26','09:00:00',1.24),('5815','2013-06-26','09:05:00',1.28),('5815','2013-06-26','09:10:00',1.32),('5815','2013-06-26','09:15:00',1.37),('5815','2013-06-26','09:20:00',1.43),('5815','2013-06-26','09:25:00',1.47),('5815','2013-06-26','09:30:00',1.52),('5815','2013-06-26','09:35:00',1.56),('5815','2013-06-26','09:40:00',1.59),('5815','2013-06-26','09:45:00',1.63),('5815','2013-06-26','09:50:00',1.7),('5815','2013-06-26','09:55:00',1.73),('5815','2013-06-26','10:00:00',1.62),('5815','2013-06-26','10:05:00',1.88),('5815','2013-06-26','10:10:00',1.55),('5815','2013-06-26','10:15:00',1.8),('5815','2013-06-26','10:20:00',1.89),('5815','2013-06-26','10:25:00',1.91),('5815','2013-06-26','10:30:00',1.96),('5815','2013-06-26','10:35:00',2.04),('5815','2013-06-26','10:40:00',2.09),('5815','2013-06-26','10:45:00',2.19),('5815','2013-06-26','10:50:00',2.18),('5815','2013-06-26','10:55:00',2.17),('5815','2013-06-26','11:00:00',1.53),('5815','2013-06-26','11:05:00',2.21),('5815','2013-06-26','11:10:00',2.17),('5815','2013-06-26','11:15:00',2.17),('5815','2013-06-26','11:20:00',2.17),('5815','2013-06-26','11:25:00',2.18),('5815','2013-06-26','11:30:00',2.26),('5815','2013-06-26','11:35:00',2.17),('5815','2013-06-26','11:45:00',2.25),('5815','2013-06-26','11:50:00',1.52),('5815','2013-06-26','12:00:00',1.19),('5815','2013-06-26','12:10:00',1.24),('5815','2013-06-26','12:35:00',2.1),('5815','2013-06-26','12:40:00',1.39),('5815','2013-06-26','13:15:00',1.54),('5815','2013-06-26','13:20:00',1.81),('5815','2013-06-26','13:25:00',1.19),('5815','2013-06-26','13:35:00',1.88),('5815','2013-06-26','14:15:00',1.06),('5815','2013-06-26','14:20:00',1.12),('5815','2013-06-26','14:25:00',1.2),('5815','2013-06-26','14:30:00',2.55),('5815','2013-06-26','14:35:00',2.42),('5815','2013-06-26','14:40:00',2.37),('5815','2013-06-26','14:45:00',2.03),('5815','2013-06-26','14:50:00',1.9),('5815','2013-06-26','14:55:00',2.18),('5815','2013-06-26','15:00:00',2.19),('5815','2013-06-26','15:05:00',2.15),('5815','2013-06-26','15:10:00',2.12),('5815','2013-06-26','15:15:00',2.09),('5815','2013-06-26','15:20:00',2.08),('5815','2013-06-26','15:25:00',2.09),('5815','2013-06-26','15:30:00',2.08),('5815','2013-06-26','15:35:00',2.04),('5815','2013-06-26','15:40:00',2.01),('5815','2013-06-26','15:45:00',2.02),('5815','2013-06-26','15:50:00',1.99),('5815','2013-06-26','15:55:00',1.93),('5815','2013-06-26','16:00:00',1.85),('5815','2013-06-26','16:05:00',1.82),('5815','2013-06-26','16:10:00',1.79),('5815','2013-06-26','16:15:00',1.76),('5815','2013-06-26','16:20:00',1.74),('5815','2013-06-26','16:25:00',1.72),('5815','2013-06-26','16:30:00',1.68),('5815','2013-06-26','16:35:00',1.54),('5815','2013-06-26','16:40:00',1.55),('5815','2013-06-26','16:45:00',1.56),('5815','2013-06-26','16:50:00',1.5),('5815','2013-06-26','16:55:00',1.49),('5815','2013-06-26','17:00:00',1.45),('5815','2013-06-26','17:05:00',1.4),('5815','2013-06-26','17:10:00',1.31),('5815','2013-06-26','17:15:00',1.24),('5815','2013-06-26','17:20:00',1.27),('5815','2013-06-26','17:25:00',1.25),('5815','2013-06-26','17:30:00',1.18),('5815','2013-06-26','17:35:00',1.1),('5815','2013-06-25','08:40:00',1.03),('5815','2013-06-25','08:45:00',1.08),('5815','2013-06-25','08:50:00',1.12),('5815','2013-06-25','08:55:00',1.17),('5815','2013-06-25','09:00:00',1.21),('5815','2013-06-25','09:05:00',1.26),('5815','2013-06-25','09:10:00',1.3),('5815','2013-06-25','09:15:00',1.34),('5815','2013-06-25','09:20:00',1.37),('5815','2013-06-25','09:25:00',1.43),('5815','2013-06-25','09:30:00',1.48),('5815','2013-06-25','09:35:00',1.52),('5815','2013-06-25','09:40:00',1.54),('5815','2013-06-25','09:45:00',1.58),('5815','2013-06-25','09:50:00',1.61),('5815','2013-06-25','09:55:00',1.64),('5815','2013-06-25','10:00:00',1.69),('5815','2013-06-25','10:05:00',1.74),('5815','2013-06-25','10:10:00',1.77),('5815','2013-06-25','10:15:00',1.8),('5815','2013-06-25','10:20:00',1.84),('5815','2013-06-25','10:25:00',1.86),('5815','2013-06-25','10:30:00',1.87),('5815','2013-06-25','10:35:00',1.91),('5815','2013-06-25','10:40:00',1.95),('5815','2013-06-25','10:45:00',1.98),('5815','2013-06-25','10:50:00',2),('5815','2013-06-25','10:55:00',2.02),('5815','2013-06-25','11:00:00',2.04),('5815','2013-06-25','11:05:00',2.01),('5815','2013-06-25','11:10:00',2),('5815','2013-06-25','11:15:00',2.07),('5815','2013-06-25','11:20:00',2.08),('5815','2013-06-25','11:25:00',2.09),('5815','2013-06-25','11:30:00',2.12),('5815','2013-06-25','11:35:00',2.15),('5815','2013-06-25','11:40:00',2.16),('5815','2013-06-25','11:45:00',2.16),('5815','2013-06-25','11:50:00',2.17),('5815','2013-06-25','11:55:00',2.19),('5815','2013-06-25','12:00:00',2.22),('5815','2013-06-25','12:05:00',2.22),('5815','2013-06-25','12:10:00',2.22),('5815','2013-06-25','12:15:00',2.17),('5815','2013-06-25','12:20:00',2.16),('5815','2013-06-25','12:25:00',2.22),('5815','2013-06-25','12:30:00',2.29),('5815','2013-06-25','12:35:00',2.26),('5815','2013-06-25','12:40:00',2.3),('5815','2013-06-25','12:45:00',2.28),('5815','2013-06-25','12:50:00',1.17),('5815','2013-06-25','13:15:00',2.12),('5815','2013-06-25','13:20:00',2.62),('5815','2013-06-25','13:25:00',1.77),('5815','2013-06-25','13:55:00',1.47),('5815','2013-06-25','14:00:00',1.45),('5815','2013-06-25','14:10:00',1.25),('5815','2013-06-25','14:15:00',2.59),('5815','2013-06-25','14:20:00',2.41),('5815','2013-06-25','14:25:00',2.11),('5815','2013-06-25','14:30:00',1.99),('5815','2013-06-25','14:35:00',2.33),('5815','2013-06-25','14:45:00',1.99),('5815','2013-06-25','14:50:00',2.43),('5815','2013-06-25','14:55:00',2.18),('5815','2013-06-25','15:00:00',2.24),('5815','2013-06-25','15:05:00',2.2),('5815','2013-06-25','15:10:00',2.14),('5815','2013-06-25','15:15:00',2.13),('5815','2013-06-25','15:20:00',2.1),('5815','2013-06-25','15:25:00',2.08),('5815','2013-06-25','15:30:00',2.05),('5815','2013-06-25','15:35:00',2.07),('5815','2013-06-25','15:40:00',2.02),('5815','2013-06-25','15:45:00',2.04),('5815','2013-06-25','15:50:00',2.03),('5815','2013-06-25','15:55:00',1.86),('5815','2013-06-25','16:00:00',1.9),('5815','2013-06-25','16:05:00',1.86),('5815','2013-06-25','16:10:00',1.84),('5815','2013-06-25','16:15:00',1.82),('5815','2013-06-25','16:20:00',1.78),('5815','2013-06-25','16:25:00',1.75),('5815','2013-06-25','16:30:00',1.72),('5815','2013-06-25','16:35:00',1.67),('5815','2013-06-25','16:40:00',1.61),('5815','2013-06-25','16:45:00',1.55),('5815','2013-06-25','16:50:00',1.53),('5815','2013-06-25','16:55:00',1.51),('5815','2013-06-25','17:00:00',1.49),('5815','2013-06-25','17:05:00',1.43),('5815','2013-06-25','17:10:00',1.38),('5815','2013-06-25','17:15:00',1.33),('5815','2013-06-25','17:20:00',1.29),('5815','2013-06-25','17:25:00',1.24),('5815','2013-06-25','17:30:00',1.19),('5815','2013-06-25','17:35:00',1.08),('5815','2013-06-25','17:45:00',1.03),('5815','2013-06-25','17:50:00',1.01),('5815','2013-06-25','18:10:00',1.02),('5815','2013-06-24','08:35:00',1.01),('5815','2013-06-24','08:40:00',1.06),('5815','2013-06-24','08:45:00',1.11),('5815','2013-06-24','08:50:00',1.15),('5815','2013-06-24','08:55:00',1.2),('5815','2013-06-24','09:00:00',1.25),('5815','2013-06-24','09:05:00',1.3),('5815','2013-06-24','09:10:00',1.34),('5815','2013-06-24','09:15:00',1.4),('5815','2013-06-24','09:20:00',1.38),('5815','2013-06-24','09:25:00',1.51),('5815','2013-06-24','09:30:00',1.55),('5815','2013-06-24','09:35:00',1.64),('5815','2013-06-24','09:40:00',1.67),('5815','2013-06-24','09:45:00',1.72),('5815','2013-06-24','09:50:00',1.82),('5815','2013-06-24','09:55:00',1.89),('5815','2013-06-24','10:00:00',1.94),('5815','2013-06-24','10:05:00',1.14),('5815','2013-06-24','10:10:00',1.35),('5815','2013-06-24','10:15:00',2.09),('5815','2013-06-24','10:20:00',2.08),('5815','2013-06-24','10:25:00',1.37),('5815','2013-06-24','10:30:00',2.17),('5815','2013-06-24','10:35:00',2.2),('5815','2013-06-24','10:40:00',2.18),('5815','2013-06-24','10:45:00',2.1),('5815','2013-06-24','10:50:00',2.16),('5815','2013-06-24','10:55:00',1.97),('5815','2013-06-24','11:10:00',1.91),('5815','2013-06-24','11:15:00',1.36),('5815','2013-06-24','11:20:00',2.2),('5815','2013-06-24','11:30:00',1.21),('5815','2013-06-24','11:35:00',1.86),('5815','2013-06-24','11:40:00',2.28),('5815','2013-06-24','11:45:00',2.31),('5815','2013-06-24','11:50:00',1.76),('5815','2013-06-24','11:55:00',1.66),('5815','2013-06-24','12:00:00',1.97),('5815','2013-06-24','12:05:00',1.68),('5815','2013-06-24','12:10:00',1.57),('5815','2013-06-24','12:15:00',1.72),('5815','2013-06-24','12:20:00',1.11),('5815','2013-06-24','12:55:00',1.56),('5815','2013-06-24','13:00:00',2.66),('5815','2013-06-24','13:05:00',2.57),('5815','2013-06-24','13:10:00',2.58),('5815','2013-06-24','13:15:00',2.39),('5815','2013-06-24','13:20:00',2.54),('5815','2013-06-24','13:25:00',2.49),('5815','2013-06-24','13:30:00',2.52),('5815','2013-06-24','13:35:00',2.2),('5815','2013-06-24','13:40:00',1.74),('5815','2013-06-24','13:45:00',2.58),('5815','2013-06-24','13:50:00',2.17),('5815','2013-06-24','13:55:00',2.5),('5815','2013-06-24','14:00:00',1.99),('5815','2013-06-24','14:05:00',2.46),('5815','2013-06-24','14:10:00',2.55),('5815','2013-06-24','14:15:00',1.83),('5815','2013-06-24','14:20:00',2.34),('5815','2013-06-24','14:25:00',2.37),('5815','2013-06-24','14:30:00',2.34),('5815','2013-06-24','14:35:00',2.29),('5815','2013-06-24','14:40:00',2.15),('5815','2013-06-24','14:45:00',1.93),('5815','2013-06-24','14:50:00',2.3),('5815','2013-06-24','14:55:00',2.25),('5815','2013-06-24','15:00:00',2.23),('5815','2013-06-24','15:05:00',2.19),('5815','2013-06-24','15:10:00',2.14),('5815','2013-06-24','15:15:00',2.15),('5815','2013-06-24','15:20:00',2.09),('5815','2013-06-24','15:25:00',2.07),('5815','2013-06-24','15:30:00',2.06),('5815','2013-06-24','15:35:00',2.03),('5815','2013-06-24','15:40:00',2.01),('5815','2013-06-24','15:45:00',2.02),('5815','2013-06-24','15:50:00',1.97),('5815','2013-06-24','15:55:00',1.91),('5815','2013-06-24','16:00:00',1.89),('5815','2013-06-24','16:05:00',1.86),('5815','2013-06-24','16:10:00',1.83),('5815','2013-06-24','16:15:00',1.79),('5815','2013-06-24','16:20:00',1.76),('5815','2013-06-24','16:25:00',1.72),('5815','2013-06-24','16:30:00',1.69),('5815','2013-06-24','16:35:00',1.64),('5815','2013-06-24','16:40:00',1.59),('5815','2013-06-24','16:45:00',1.57),('5815','2013-06-24','16:50:00',1.54),('5815','2013-06-24','16:55:00',1.5),('5815','2013-06-24','17:00:00',1.47),('5815','2013-06-24','17:05:00',1.41),('5815','2013-06-24','17:10:00',1.35),('5815','2013-06-24','17:15:00',1.33),('5815','2013-06-24','17:20:00',1.29),('5815','2013-06-24','17:25:00',1.23),('5815','2013-06-24','17:30:00',1.18),('5815','2013-06-24','17:35:00',1.07),('5815','2013-06-24','17:40:00',1.04),('5815','2013-06-24','17:45:00',1.02),('5815','2013-06-23','08:50:00',1.23),('5815','2013-06-23','08:55:00',1.29),('5815','2013-06-23','09:00:00',1.11),('5815','2013-06-23','09:05:00',1.21),('5815','2013-06-23','09:15:00',1.33),('5815','2013-06-23','09:20:00',1.51),('5815','2013-06-23','09:25:00',1.52),('5815','2013-06-23','09:30:00',1.53),('5815','2013-06-23','09:40:00',1.12),('5815','2013-06-23','09:45:00',1.14),('5815','2013-06-23','09:50:00',1.41),('5815','2013-06-23','09:55:00',1.81),('5815','2013-06-23','10:00:00',1.84),('5815','2013-06-23','10:05:00',1.86),('5815','2013-06-23','10:10:00',1.94),('5815','2013-06-23','10:15:00',2.09),('5815','2013-06-23','10:20:00',1.36),('5815','2013-06-23','10:25:00',2.18),('5815','2013-06-23','10:30:00',1.26),('5815','2013-06-23','10:35:00',1.72),('5815','2013-06-23','10:40:00',1.28),('5815','2013-06-23','10:45:00',1.39),('5815','2013-06-23','10:50:00',1.8),('5815','2013-06-23','10:55:00',1.79),('5815','2013-06-23','11:00:00',2.43),('5815','2013-06-23','11:05:00',2.03),('5815','2013-06-23','11:10:00',2.14),('5815','2013-06-23','11:15:00',1.2),('5815','2013-06-23','11:20:00',1.87),('5815','2013-06-23','11:50:00',1.53),('5815','2013-06-23','11:55:00',2.05),('5815','2013-06-23','12:00:00',1.98),('5815','2013-06-23','12:05:00',2.18),('5815','2013-06-23','12:10:00',2.41),('5815','2013-06-23','12:15:00',2.14),('5815','2013-06-23','12:20:00',2.23),('5815','2013-06-23','12:25:00',1.48),('5815','2013-06-23','12:30:00',1.49),('5815','2013-06-23','12:35:00',2.66),('5815','2013-06-23','12:40:00',2.74),('5815','2013-06-23','12:45:00',1.32),('5815','2013-06-23','12:50:00',2.85),('5815','2013-06-23','12:55:00',2.8),('5815','2013-06-23','13:00:00',2.63),('5815','2013-06-23','13:05:00',2.71),('5815','2013-06-23','13:10:00',2.27),('5815','2013-06-23','13:15:00',1.82),('5815','2013-06-23','13:20:00',1.41),('5815','2013-06-23','13:25:00',2.36),('5815','2013-06-23','13:30:00',2.46),('5815','2013-06-23','13:35:00',2.25),('5815','2013-06-23','13:40:00',2.41),('5815','2013-06-23','13:45:00',2.58),('5815','2013-06-23','13:50:00',2.49),('5815','2013-06-23','13:55:00',2.45),('5815','2013-06-23','14:00:00',2.44),('5815','2013-06-23','14:05:00',2.45),('5815','2013-06-23','14:10:00',2.47),('5815','2013-06-23','14:15:00',2.45),('5815','2013-06-23','14:20:00',2.41),('5815','2013-06-23','14:25:00',2.41),('5815','2013-06-23','14:30:00',2.42),('5815','2013-06-23','14:35:00',2.38),('5815','2013-06-23','14:40:00',2.4),('5815','2013-06-23','14:45:00',2.43),('5815','2013-06-23','14:50:00',2.25),('5815','2013-06-23','14:55:00',2.58),('5815','2013-06-23','15:00:00',2.58),('5815','2013-06-23','15:05:00',1.83),('5815','2013-06-23','15:10:00',1.16),('5815','2013-06-23','15:15:00',2.14),('5815','2013-06-23','15:20:00',2.33),('5815','2013-06-23','15:25:00',2.12),('5815','2013-06-23','15:30:00',1.57),('5815','2013-06-23','15:35:00',1.96),('5815','2013-06-23','15:40:00',1.31),('5815','2013-06-23','15:45:00',2.12),('5815','2013-06-23','15:50:00',1.52),('5815','2013-06-23','15:55:00',1.72),('5815','2013-06-23','16:00:00',2.08),('5815','2013-06-23','16:05:00',2.05),('5815','2013-06-23','16:10:00',2.02),('5815','2013-06-23','16:15:00',2.14),('5815','2013-06-23','16:20:00',1.66),('5815','2013-06-23','16:25:00',1.4),('5815','2013-06-23','16:30:00',1.9),('5815','2013-06-23','16:35:00',1.54),('5815','2013-06-23','16:40:00',1.1),('5815','2013-06-23','16:45:00',1.25),('5815','2013-06-23','16:50:00',1.15),('5815','2013-06-23','17:05:00',1.1),('5815','2013-06-23','17:10:00',1.31),('5815','2013-06-23','17:15:00',1.64),('5815','2013-06-23','17:20:00',1.46),('5815','2013-06-23','17:30:00',1.28),('5815','2013-06-23','17:50:00',1.11),('5815','2013-06-23','18:00:00',1.06),('5815','2013-06-22','09:25:00',1.35),('5815','2013-06-22','09:30:00',1.54),('5815','2013-06-22','09:35:00',1.58),('5815','2013-06-22','09:40:00',1.79),('5815','2013-06-22','09:45:00',1.26),('5815','2013-06-22','10:00:00',1.68),('5815','2013-06-22','10:05:00',1.9),('5815','2013-06-22','10:10:00',1.52),('5815','2013-06-22','10:15:00',1.86),('5815','2013-06-22','10:20:00',1.37),('5815','2013-06-22','10:45:00',2.09),('5815','2013-06-22','10:50:00',1.13),('5815','2013-06-22','10:55:00',2.07),('5815','2013-06-22','11:00:00',1.99),('5815','2013-06-22','11:05:00',1.97),('5815','2013-06-22','11:10:00',2.04),('5815','2013-06-22','11:15:00',2.05),('5815','2013-06-22','11:20:00',2.15),('5815','2013-06-22','11:25:00',2.1),('5815','2013-06-22','11:30:00',2.1),('5815','2013-06-22','11:35:00',2.17),('5815','2013-06-22','11:40:00',2.11),('5815','2013-06-22','11:45:00',2.12),('5815','2013-06-22','11:50:00',2.19),('5815','2013-06-22','11:55:00',2.22),('5815','2013-06-22','12:00:00',1.55),('5815','2013-06-22','12:05:00',1.57),('5815','2013-06-22','12:10:00',2.35),('5815','2013-06-22','12:15:00',2.31),('5815','2013-06-22','12:20:00',2.33),('5815','2013-06-22','12:25:00',2.29),('5815','2013-06-22','12:30:00',2.31),('5815','2013-06-22','12:35:00',2.28),('5815','2013-06-22','12:40:00',2.28),('5815','2013-06-22','12:45:00',2.29),('5815','2013-06-22','12:50:00',2.33),('5815','2013-06-22','12:55:00',2.34),('5815','2013-06-22','13:00:00',2.36),('5815','2013-06-22','13:05:00',2.36),('5815','2013-06-22','13:10:00',2.36),('5815','2013-06-22','13:15:00',2.36),('5815','2013-06-22','13:20:00',2.35),('5815','2013-06-22','13:25:00',2.35),('5815','2013-06-22','13:30:00',2.36),('5815','2013-06-22','13:35:00',2.37),('5815','2013-06-22','13:40:00',2.38),('5815','2013-06-22','13:45:00',2.38),('5815','2013-06-22','13:50:00',2.37),('5815','2013-06-22','13:55:00',2.36),('5815','2013-06-22','14:00:00',2.33),('5815','2013-06-22','14:05:00',2.34),('5815','2013-06-22','14:10:00',2.34),('5815','2013-06-22','14:15:00',2.34),('5815','2013-06-22','14:20:00',2.3),('5815','2013-06-22','14:25:00',2.29),('5815','2013-06-22','14:30:00',2.3),('5815','2013-06-22','14:35:00',2.3),('5815','2013-06-22','14:40:00',2.29),('5815','2013-06-22','14:45:00',2.28),('5815','2013-06-22','14:50:00',2.27),('5815','2013-06-22','14:55:00',2.26),('5815','2013-06-22','15:00:00',2.26),('5815','2013-06-22','15:05:00',2.22),('5815','2013-06-22','15:10:00',2.15),('5815','2013-06-22','15:15:00',2.15),('5815','2013-06-22','15:20:00',2.16),('5815','2013-06-22','15:25:00',2.14),('5815','2013-06-22','15:30:00',2.09),('5815','2013-06-22','15:35:00',2.06),('5815','2013-06-22','15:40:00',2.05),('5815','2013-06-22','15:45:00',2.06),('5815','2013-06-22','15:50:00',2.04),('5815','2013-06-22','15:55:00',1.95),('5815','2013-06-22','16:00:00',1.89),('5815','2013-06-22','16:05:00',1.91),('5815','2013-06-22','16:10:00',1.86),('5815','2013-06-22','16:15:00',1.82),('5815','2013-06-22','16:20:00',1.78),('5815','2013-06-22','16:25:00',1.75),('5815','2013-06-22','16:30:00',1.72),('5815','2013-06-22','16:35:00',1.68),('5815','2013-06-22','16:40:00',1.65),('5815','2013-06-22','16:45:00',1.58),('5815','2013-06-22','16:50:00',1.57),('5815','2013-06-22','16:55:00',1.53),('5815','2013-06-22','17:00:00',1.5),('5815','2013-06-22','17:05:00',1.42),('5815','2013-06-22','17:10:00',1.36),('5815','2013-06-22','17:15:00',1.31),('5815','2013-06-22','17:20:00',1.23),('5815','2013-06-22','17:30:00',1.21),('5815','2013-06-22','17:35:00',1.13),('5815','2013-06-22','17:40:00',1.1),('5815','2013-06-22','17:50:00',1.04),('5815','2013-06-21','08:45:00',1.04),('5815','2013-06-21','08:50:00',1.08),('5815','2013-06-21','08:55:00',1.13),('5815','2013-06-21','09:00:00',1.18),('5815','2013-06-21','09:05:00',1.21),('5815','2013-06-21','09:10:00',1.25),('5815','2013-06-21','09:15:00',1.29),('5815','2013-06-21','09:20:00',1.33),('5815','2013-06-21','09:25:00',1.37),('5815','2013-06-21','09:30:00',1.4),('5815','2013-06-21','09:35:00',1.44),('5815','2013-06-21','09:40:00',1.48),('5815','2013-06-21','09:45:00',1.52),('5815','2013-06-21','09:50:00',1.54),('5815','2013-06-21','09:55:00',1.59),('5815','2013-06-21','10:00:00',1.64),('5815','2013-06-21','10:05:00',1.68),('5815','2013-06-21','10:10:00',1.72),('5815','2013-06-21','10:15:00',1.75),('5815','2013-06-21','10:20:00',1.78),('5815','2013-06-21','10:25:00',1.81),('5815','2013-06-21','10:30:00',1.83),('5815','2013-06-21','10:35:00',1.86),('5815','2013-06-21','10:40:00',1.89),('5815','2013-06-21','10:45:00',1.94),('5815','2013-06-21','10:50:00',1.96),('5815','2013-06-21','10:55:00',1.97),('5815','2013-06-21','11:00:00',1.98),('5815','2013-06-21','11:05:00',1.96),('5815','2013-06-21','11:10:00',1.99),('5815','2013-06-21','11:15:00',2.01),('5815','2013-06-21','11:20:00',2.04),('5815','2013-06-21','11:25:00',2.07),('5815','2013-06-21','11:30:00',2.07),('5815','2013-06-21','11:35:00',2.13),('5815','2013-06-21','11:40:00',2.11),('5815','2013-06-21','11:45:00',2.05),('5815','2013-06-21','11:50:00',2.05),('5815','2013-06-21','11:55:00',2.15),('5815','2013-06-21','12:00:00',2.16),('5815','2013-06-21','12:05:00',2.13),('5815','2013-06-21','12:10:00',2.09),('5815','2013-06-21','12:15:00',2.19),('5815','2013-06-21','12:20:00',2.2),('5815','2013-06-21','12:25:00',2.2),('5815','2013-06-21','12:30:00',2.22),('5815','2013-06-21','12:35:00',2.21),('5815','2013-06-21','12:40:00',2.26),('5815','2013-06-21','12:45:00',2.25),('5815','2013-06-21','12:50:00',2.21),('5815','2013-06-21','12:55:00',2.19),('5815','2013-06-21','13:00:00',2.16),('5815','2013-06-21','13:05:00',2.17),('5815','2013-06-21','13:10:00',2.16),('5815','2013-06-21','13:15:00',2.13),('5815','2013-06-21','13:20:00',2.07),('5815','2013-06-21','13:25:00',2.15),('5815','2013-06-21','13:30:00',2.35),('5815','2013-06-21','13:35:00',2.36),('5815','2013-06-21','13:40:00',2.19),('5815','2013-06-21','13:45:00',2.18),('5815','2013-06-21','13:50:00',2.34),('5815','2013-06-21','13:55:00',1.85),('5815','2013-06-21','14:00:00',1.24),('5815','2013-06-21','14:05:00',2.53),('5815','2013-06-21','14:10:00',2.43),('5815','2013-06-21','14:15:00',2.41),('5815','2013-06-21','14:20:00',1.92),('5815','2013-06-21','14:25:00',2.35),('5815','2013-06-21','14:30:00',1.72),('5815','2013-06-21','14:35:00',1.32),('5815','2013-06-21','14:45:00',1.12),('5815','2013-06-21','14:50:00',1.8),('5815','2013-06-21','14:55:00',2.27),('5815','2013-06-21','15:00:00',2.13),('5815','2013-06-21','15:05:00',1.89),('5815','2013-06-21','15:10:00',1.99),('5815','2013-06-21','15:15:00',2.22),('5815','2013-06-21','15:20:00',2.05),('5815','2013-06-21','15:25:00',1.93),('5815','2013-06-21','15:30:00',1.3),('5815','2013-06-21','15:35:00',1.2),('5815','2013-06-21','15:40:00',1.15),('5815','2013-06-21','15:45:00',1.5),('5815','2013-06-21','15:50:00',1.48),('5815','2013-06-21','15:55:00',1.38),('5815','2013-06-21','16:00:00',1.15),('5815','2013-06-21','16:20:00',1.05),('5815','2013-06-21','17:10:00',1.02),('5815','2013-06-21','17:15:00',1.54),('5815','2013-06-21','17:20:00',1.47),('5815','2013-06-21','17:25:00',1.48),('5815','2013-06-21','17:30:00',1.28),('5815','2013-06-21','17:40:00',1.11),('5815','2013-06-21','17:45:00',1.14),('5815','2013-06-21','17:50:00',1.05),('5815','2013-06-21','17:55:00',1.01),('5815','2013-06-20','08:45:00',1.01),('5815','2013-06-20','08:50:00',1.06),('5815','2013-06-20','08:55:00',1.1),('5815','2013-06-20','09:00:00',1.14),('5815','2013-06-20','09:05:00',1.17),('5815','2013-06-20','09:10:00',1.2),('5815','2013-06-20','09:15:00',1.24),('5815','2013-06-20','09:20:00',1.27),('5815','2013-06-20','09:25:00',1.31),('5815','2013-06-20','09:30:00',1.34),('5815','2013-06-20','09:35:00',1.38),('5815','2013-06-20','09:40:00',1.41),('5815','2013-06-20','09:45:00',1.45),('5815','2013-06-20','09:50:00',1.5),('5815','2013-06-20','09:55:00',1.52),('5815','2013-06-20','10:00:00',1.54),('5815','2013-06-20','10:05:00',1.57),('5815','2013-06-20','10:10:00',1.58),('5815','2013-06-20','10:15:00',1.64),('5815','2013-06-20','10:20:00',1.67),('5815','2013-06-20','10:25:00',1.68),('5815','2013-06-20','10:30:00',1.72),('5815','2013-06-20','10:35:00',1.75),('5815','2013-06-20','10:40:00',1.75),('5815','2013-06-20','10:45:00',1.77),('5815','2013-06-20','10:50:00',1.82),('5815','2013-06-20','10:55:00',1.84),('5815','2013-06-20','11:00:00',1.85),('5815','2013-06-20','11:05:00',1.82),('5815','2013-06-20','11:10:00',1.81),('5815','2013-06-20','11:15:00',1.88),('5815','2013-06-20','11:20:00',1.91),('5815','2013-06-20','11:25:00',1.94),('5815','2013-06-20','11:30:00',1.97),('5815','2013-06-20','11:35:00',1.99),('5815','2013-06-20','11:40:00',1.99),('5815','2013-06-20','11:45:00',1.94),('5815','2013-06-20','11:50:00',1.95),('5815','2013-06-20','11:55:00',2.02),('5815','2013-06-20','12:00:00',2.05),('5815','2013-06-20','12:05:00',2.06),('5815','2013-06-20','12:10:00',2.07),('5815','2013-06-20','12:15:00',2.07),('5815','2013-06-20','12:20:00',2.06),('5815','2013-06-20','12:25:00',2.09),('5815','2013-06-20','12:30:00',2.15),('5815','2013-06-20','12:35:00',2.1),('5815','2013-06-20','12:40:00',2.08),('5815','2013-06-20','12:45:00',2.11),('5815','2013-06-20','12:50:00',2.08),('5815','2013-06-20','12:55:00',2.05),('5815','2013-06-20','13:00:00',2.08),('5815','2013-06-20','13:05:00',2.05),('5815','2013-06-20','13:10:00',2.07),('5815','2013-06-20','13:15:00',2.11),('5815','2013-06-20','13:20:00',2.14),('5815','2013-06-20','13:25:00',2.15),('5815','2013-06-20','13:30:00',2.15),('5815','2013-06-20','13:35:00',2.17),('5815','2013-06-20','13:40:00',2.16),('5815','2013-06-20','13:45:00',2.14),('5815','2013-06-20','13:50:00',2.15),('5815','2013-06-20','13:55:00',2.17),('5815','2013-06-20','14:00:00',2.15),('5815','2013-06-20','14:05:00',2.18),('5815','2013-06-20','14:10:00',2.17),('5815','2013-06-20','14:15:00',2.17),('5815','2013-06-20','14:20:00',2.14),('5815','2013-06-20','14:25:00',2.14),('5815','2013-06-20','14:30:00',2.16),('5815','2013-06-20','14:35:00',2.16),('5815','2013-06-20','14:40:00',2.14),('5815','2013-06-20','14:45:00',2.14),('5815','2013-06-20','14:50:00',2.12),('5815','2013-06-20','14:55:00',2.1),('5815','2013-06-20','15:00:00',2.11),('5815','2013-06-20','15:05:00',2.07),('5815','2013-06-20','15:10:00',2.03),('5815','2013-06-20','15:15:00',2.02),('5815','2013-06-20','15:20:00',2),('5815','2013-06-20','15:25:00',1.98),('5815','2013-06-20','15:30:00',1.96),('5815','2013-06-20','15:35:00',1.94),('5815','2013-06-20','15:40:00',1.9),('5815','2013-06-20','15:45:00',1.93),('5815','2013-06-20','15:50:00',1.9),('5815','2013-06-20','15:55:00',1.83),('5815','2013-06-20','16:00:00',1.8),('5815','2013-06-20','16:05:00',1.78),('5815','2013-06-20','16:10:00',1.75),('5815','2013-06-20','16:15:00',1.72),('5815','2013-06-20','16:20:00',1.69),('5815','2013-06-20','16:25:00',1.67),('5815','2013-06-20','16:30:00',1.63),('5815','2013-06-20','16:35:00',1.59),('5815','2013-06-20','16:40:00',1.55),('5815','2013-06-20','16:45:00',1.52),('5815','2013-06-20','16:50:00',1.47),('5815','2013-06-20','16:55:00',1.45),('5815','2013-06-20','17:00:00',1.41),('5815','2013-06-20','17:05:00',1.34),('5815','2013-06-20','17:10:00',1.3),('5815','2013-06-20','17:15:00',1.28),('5815','2013-06-20','17:20:00',1.24),('5815','2013-06-20','17:25:00',1.2),('5815','2013-06-20','17:30:00',1.13),('5815','2013-06-19','08:45:00',1.02),('5815','2013-06-19','08:50:00',1.07),('5815','2013-06-19','08:55:00',1.11),('5815','2013-06-19','09:00:00',1.15),('5815','2013-06-19','09:05:00',1.19),('5815','2013-06-19','09:10:00',1.24),('5815','2013-06-19','09:15:00',1.27),('5815','2013-06-19','09:20:00',1.31),('5815','2013-06-19','09:25:00',1.35),('5815','2013-06-19','09:30:00',1.39),('5815','2013-06-19','09:35:00',1.43),('5815','2013-06-19','09:40:00',1.46),('5815','2013-06-19','09:45:00',1.48),('5815','2013-06-19','09:50:00',1.53),('5815','2013-06-19','09:55:00',1.56),('5815','2013-06-19','10:00:00',1.61),('5815','2013-06-19','10:05:00',1.64),('5815','2013-06-19','10:10:00',1.67),('5815','2013-06-19','10:15:00',1.69),('5815','2013-06-19','10:20:00',1.72),('5815','2013-06-19','10:25:00',1.75),('5815','2013-06-19','10:30:00',1.78),('5815','2013-06-19','10:35:00',1.82),('5815','2013-06-19','10:40:00',1.83),('5815','2013-06-19','10:45:00',1.86),('5815','2013-06-19','10:50:00',1.87),('5815','2013-06-19','10:55:00',1.88),('5815','2013-06-19','12:05:00',1.98),('5815','2013-06-19','12:10:00',2.01),('5815','2013-06-19','12:15:00',2.03),('5815','2013-06-19','12:20:00',2.01),('5815','2013-06-19','12:25:00',2.04),('5815','2013-06-19','12:30:00',2),('5815','2013-06-19','12:35:00',2.11),('5815','2013-06-19','12:40:00',2.1),('5815','2013-06-19','12:45:00',2.05),('5815','2013-06-19','12:50:00',2.15),('5815','2013-06-19','12:55:00',1.97),('5815','2013-06-19','13:00:00',1.12),('5815','2013-06-19','13:05:00',1.7),('5815','2013-06-19','13:10:00',2.26),('5815','2013-06-19','13:15:00',2.23),('5815','2013-06-19','13:20:00',2.18),('5815','2013-06-19','13:25:00',2.1),('5815','2013-06-19','13:30:00',1.86),('5815','2013-06-19','13:35:00',2.12),('5815','2013-06-19','13:40:00',2.15),('5815','2013-06-19','13:45:00',2.16),('5815','2013-06-19','13:50:00',2.15),('5815','2013-06-19','13:55:00',2.16),('5815','2013-06-19','14:00:00',2.18),('5815','2013-06-19','14:05:00',2.19),('5815','2013-06-19','14:10:00',2.26),('5815','2013-06-19','14:15:00',2.23),('5815','2013-06-19','14:20:00',2.2),('5815','2013-06-19','14:25:00',2.2),('5815','2013-06-19','14:30:00',2.18),('5815','2013-06-19','14:35:00',2.19),('5815','2013-06-19','14:40:00',2.21),('5815','2013-06-19','14:45:00',2.19),('5815','2013-06-19','14:50:00',2.19),('5815','2013-06-19','14:55:00',2.17),('5815','2013-06-19','15:00:00',2.15),('5815','2013-06-19','15:05:00',2.11),('5815','2013-06-19','15:10:00',2.09),('5815','2013-06-19','15:15:00',2.08),('5815','2013-06-19','15:20:00',2.02),('5815','2013-06-19','15:25:00',2.04),('5815','2013-06-19','15:30:00',2.01),('5815','2013-06-19','15:35:00',1.98),('5815','2013-06-19','15:40:00',1.96),('5815','2013-06-19','15:45:00',1.98),('5815','2013-06-19','15:50:00',1.93),('5815','2013-06-19','15:55:00',1.84),('5815','2013-06-19','16:00:00',1.74),('5815','2013-06-19','16:05:00',1.72),('5815','2013-06-19','16:10:00',1.79),('5815','2013-06-19','16:15:00',1.75),('5815','2013-06-19','16:20:00',1.71),('5815','2013-06-19','16:25:00',1.69),('5815','2013-06-19','16:30:00',1.66),('5815','2013-06-19','16:35:00',1.61),('5815','2013-06-19','16:40:00',1.56),('5815','2013-06-19','16:45:00',1.51),('5815','2013-06-19','16:50:00',1.47),('5815','2013-06-19','16:55:00',1.46),('5815','2013-06-19','17:00:00',1.43),('5815','2013-06-19','17:05:00',1.36),('5815','2013-06-19','17:10:00',1.33),('5815','2013-06-19','17:15:00',1.28),('5815','2013-06-19','17:20:00',1.24),('5815','2013-06-19','17:25:00',1.21),('5815','2013-06-19','17:30:00',1.13),('5815','2013-06-19','17:35:00',1.01),('5815','2013-06-19','17:40:00',1.04),('5815','2013-06-19','17:45:00',1.01),('5815','2013-06-18','08:45:00',1),('5815','2013-06-18','08:50:00',1.05),('5815','2013-06-18','08:55:00',1.09),('5815','2013-06-18','09:00:00',1.13),('5815','2013-06-18','09:05:00',1.17),('5815','2013-06-18','09:10:00',1.22),('5815','2013-06-18','09:15:00',1.26),('5815','2013-06-18','09:20:00',1.3),('5815','2013-06-18','09:25:00',1.33),('5815','2013-06-18','09:30:00',1.37),('5815','2013-06-18','09:35:00',1.39),('5815','2013-06-18','09:40:00',1.44),('5815','2013-06-18','09:45:00',1.48),('5815','2013-06-18','09:50:00',1.5),('5815','2013-06-18','09:55:00',1.54),('5815','2013-06-18','10:00:00',1.57),('5815','2013-06-18','10:05:00',1.6),('5815','2013-06-18','10:10:00',1.63),('5815','2013-06-18','10:15:00',1.67),('5815','2013-06-18','10:20:00',1.7),('5815','2013-06-18','10:25:00',1.72),('5815','2013-06-18','10:30:00',1.73),('5815','2013-06-18','10:35:00',1.75),('5815','2013-06-18','10:40:00',1.78),('5815','2013-06-18','10:45:00',1.83),('5815','2013-06-18','10:50:00',1.84),('5815','2013-06-18','10:55:00',1.85),('5815','2013-06-18','11:00:00',1.84),('5815','2013-06-18','11:05:00',1.85),('5815','2013-06-18','11:10:00',1.86),('5815','2013-06-18','11:15:00',1.87),('5815','2013-06-18','11:20:00',1.89),('5815','2013-06-18','11:25:00',1.91),('5815','2013-06-18','11:30:00',1.93),('5815','2013-06-18','11:35:00',1.97),('5815','2013-06-18','11:40:00',1.97),('5815','2013-06-18','11:45:00',1.97),('5815','2013-06-18','11:50:00',1.96),('5815','2013-06-18','11:55:00',1.95),('5815','2013-06-18','12:00:00',1.99),('5815','2013-06-18','12:05:00',1.98),('5815','2013-06-18','12:10:00',2.03),('5815','2013-06-18','12:15:00',2.02),('5815','2013-06-18','12:20:00',2.04),('5815','2013-06-18','12:25:00',2.06),('5815','2013-06-18','12:30:00',2.09),('5815','2013-06-18','12:35:00',2.07),('5815','2013-06-18','12:40:00',2.09),('5815','2013-06-18','12:45:00',2.12),('5815','2013-06-18','12:50:00',2.12),('5815','2013-06-18','12:55:00',2.12),('5815','2013-06-18','13:00:00',2.1),('5815','2013-06-18','13:05:00',2.1),('5815','2013-06-18','13:10:00',2.1),('5815','2013-06-18','13:15:00',2.12),('5815','2013-06-18','13:20:00',2.1),('5815','2013-06-18','13:25:00',2.16),('5815','2013-06-18','13:30:00',2.16),('5815','2013-06-18','13:35:00',2.15),('5815','2013-06-18','13:40:00',2.16),('5815','2013-06-18','13:45:00',2.16),('5815','2013-06-18','13:50:00',2.14),('5815','2013-06-18','13:55:00',2.18),('5815','2013-06-18','14:00:00',2.19),('5815','2013-06-18','14:05:00',2.18),('5815','2013-06-18','14:10:00',2.19),('5815','2013-06-18','14:15:00',2.17),('5815','2013-06-18','14:20:00',2.12),('5815','2013-06-18','14:25:00',2.12),('5815','2013-06-18','14:30:00',2.1),('5815','2013-06-18','14:35:00',2.07),('5815','2013-06-18','14:40:00',2.06),('5815','2013-06-18','14:45:00',2.05),('5815','2013-06-18','14:50:00',2.04),('5815','2013-06-18','14:55:00',2.02),('5815','2013-06-18','15:00:00',2),('5815','2013-06-18','15:05:00',1.99),('5815','2013-06-18','15:10:00',1.96),('5815','2013-06-18','15:15:00',1.95),('5815','2013-06-18','15:20:00',1.94),('5815','2013-06-18','15:25:00',1.92),('5815','2013-06-18','15:30:00',1.9),('5815','2013-06-18','15:35:00',1.87),('5815','2013-06-18','15:40:00',1.86),('5815','2013-06-18','15:45:00',1.88),('5815','2013-06-18','15:50:00',1.82),('5815','2013-06-18','15:55:00',1.74),('5815','2013-06-18','16:00:00',1.66),('5815','2013-06-18','16:05:00',1.66),('5815','2013-06-18','16:10:00',1.67),('5815','2013-06-18','16:15:00',1.64),('5815','2013-06-18','16:20:00',1.61),('5815','2013-06-18','16:25:00',1.57),('5815','2013-06-18','16:30:00',1.55),('5815','2013-06-18','16:35:00',1.51),('5815','2013-06-18','16:40:00',1.47),('5815','2013-06-18','16:45:00',1.44),('5815','2013-06-18','16:50:00',1.41),('5815','2013-06-18','16:55:00',1.39),('5815','2013-06-18','17:00:00',1.36),('5815','2013-06-18','17:05:00',1.29),('5815','2013-06-18','17:10:00',1.27),('5815','2013-06-18','17:15:00',1.23),('5815','2013-06-18','17:20:00',1.21),('5815','2013-06-18','17:25:00',1.18),('5815','2013-06-18','17:30:00',1.1),('5815','2013-06-17','08:50:00',1.04),('5815','2013-06-17','08:55:00',1.08),('5815','2013-06-17','09:00:00',1.11),('5815','2013-06-17','09:05:00',1.16),('5815','2013-06-17','09:10:00',1.2),('5815','2013-06-17','09:15:00',1.24),('5815','2013-06-17','09:20:00',1.29),('5815','2013-06-17','09:25:00',1.33),('5815','2013-06-17','09:30:00',1.36),('5815','2013-06-17','09:35:00',1.39),('5815','2013-06-17','09:40:00',1.43),('5815','2013-06-17','09:45:00',1.45),('5815','2013-06-17','09:50:00',1.48),('5815','2013-06-17','09:55:00',1.51),('5815','2013-06-17','10:00:00',1.55),('5815','2013-06-17','10:05:00',1.56),('5815','2013-06-17','10:10:00',1.61),('5815','2013-06-17','10:15:00',1.65),('5815','2013-06-17','10:20:00',1.68),('5815','2013-06-17','10:25:00',1.7),('5815','2013-06-17','10:30:00',1.71),('5815','2013-06-17','10:35:00',1.72),('5815','2013-06-17','10:40:00',1.76),('5815','2013-06-17','10:45:00',1.8),('5815','2013-06-17','10:50:00',1.82),('5815','2013-06-17','10:55:00',1.85),('5815','2013-06-17','11:00:00',1.85),('5815','2013-06-17','11:05:00',1.85),('5815','2013-06-17','11:10:00',1.88),('5815','2013-06-17','11:15:00',1.89),('5815','2013-06-17','11:20:00',1.88),('5815','2013-06-17','11:25:00',1.93),('5815','2013-06-17','11:30:00',1.97),('5815','2013-06-17','11:35:00',1.98),('5815','2013-06-17','11:40:00',1.92),('5815','2013-06-17','11:45:00',1.89),('5815','2013-06-17','11:50:00',1.91),('5815','2013-06-17','11:55:00',1.97),('5815','2013-06-17','12:00:00',1.96),('5815','2013-06-17','12:05:00',1.97),('5815','2013-06-17','12:10:00',1.97),('5815','2013-06-17','12:15:00',1.97),('5815','2013-06-17','12:20:00',1.97),('5815','2013-06-17','12:25:00',2.02),('5815','2013-06-17','12:30:00',2.03),('5815','2013-06-17','12:35:00',2.01),('5815','2013-06-17','12:40:00',2),('5815','2013-06-17','12:45:00',1.57),('5815','2013-06-17','12:55:00',2.06),('5815','2013-06-17','13:00:00',2.16),('5815','2013-06-17','13:05:00',1.23),('5815','2013-06-17','13:10:00',1.5),('5815','2013-06-17','13:15:00',2.23),('5815','2013-06-17','13:20:00',2.27),('5815','2013-06-17','13:25:00',2.28),('5815','2013-06-17','13:30:00',1.45),('5815','2013-06-17','13:35:00',2.14),('5815','2013-06-17','13:40:00',2.18),('5815','2013-06-17','13:45:00',2.15),('5815','2013-06-17','13:50:00',2.18),('5815','2013-06-17','13:55:00',2.21),('5815','2013-06-17','14:00:00',2.2),('5815','2013-06-17','14:05:00',2.22),('5815','2013-06-17','14:10:00',2.21),('5815','2013-06-17','14:15:00',2.19),('5815','2013-06-17','14:20:00',2.13),('5815','2013-06-17','14:25:00',2.12),('5815','2013-06-17','14:30:00',2.11),('5815','2013-06-17','14:35:00',2.11),('5815','2013-06-17','14:40:00',2.14),('5815','2013-06-17','14:45:00',2.09),('5815','2013-06-17','14:50:00',2.09),('5815','2013-06-17','14:55:00',2.09),('5815','2013-06-17','15:00:00',2.11),('5815','2013-06-17','15:05:00',2.04),('5815','2013-06-17','15:10:00',2.02),('5815','2013-06-17','15:15:00',2),('5815','2013-06-17','15:20:00',1.96),('5815','2013-06-17','15:25:00',1.94),('5815','2013-06-17','15:30:00',1.91),('5815','2013-06-17','15:35:00',1.91),('5815','2013-06-17','15:40:00',1.89),('5815','2013-06-17','15:45:00',1.93),('5815','2013-06-17','15:50:00',1.88),('5815','2013-06-17','15:55:00',1.83),('5815','2013-06-17','16:00:00',1.76),('5815','2013-06-17','16:05:00',1.71),('5815','2013-06-17','16:10:00',1.76),('5815','2013-06-17','16:15:00',1.77),('5815','2013-06-17','16:20:00',1.74),('5815','2013-06-17','16:25:00',1.62),('5815','2013-06-17','16:30:00',1.54),('5815','2013-06-17','16:35:00',1.55),('5815','2013-06-17','16:40:00',1.53),('5815','2013-06-17','16:45:00',1.47),('5815','2013-06-17','16:50:00',1.43),('5815','2013-06-17','16:55:00',1.42),('5815','2013-06-17','17:00:00',1.38),('5815','2013-06-17','17:05:00',1.31),('5815','2013-06-17','17:10:00',1.28),('5815','2013-06-17','17:15:00',1.25),('5815','2013-06-17','17:20:00',1.22),('5815','2013-06-17','17:25:00',1.17),('5815','2013-06-17','17:30:00',1.08),('5815','2013-06-16','08:45:00',1.04),('5815','2013-06-16','08:50:00',1.08),('5815','2013-06-16','08:55:00',1.13),('5815','2013-06-16','09:00:00',1.18),('5815','2013-06-16','09:05:00',1.22),('5815','2013-06-16','09:10:00',1.26),('5815','2013-06-16','09:15:00',1.3),('5815','2013-06-16','09:20:00',1.34),('5815','2013-06-16','09:25:00',1.38),('5815','2013-06-16','09:30:00',1.42),('5815','2013-06-16','09:35:00',1.46),('5815','2013-06-16','09:40:00',1.49),('5815','2013-06-16','09:45:00',1.53),('5815','2013-06-16','09:50:00',1.57),('5815','2013-06-16','09:55:00',1.61),('5815','2013-06-16','10:00:00',1.63),('5815','2013-06-16','10:05:00',1.65),('5815','2013-06-16','10:10:00',1.69),('5815','2013-06-16','10:15:00',1.72),('5815','2013-06-16','10:20:00',1.75),('5815','2013-06-16','10:25:00',1.77),('5815','2013-06-16','10:30:00',1.8),('5815','2013-06-16','10:35:00',1.82),('5815','2013-06-16','10:40:00',1.85),('5815','2013-06-16','10:45:00',1.88),('5815','2013-06-16','10:50:00',1.9),('5815','2013-06-16','10:55:00',1.92),('5815','2013-06-16','11:00:00',1.9),('5815','2013-06-16','11:05:00',1.89),('5815','2013-06-16','11:10:00',1.91),('5815','2013-06-16','11:15:00',1.93),('5815','2013-06-16','11:20:00',1.96),('5815','2013-06-16','11:25:00',1.97),('5815','2013-06-16','11:30:00',2.01),('5815','2013-06-16','11:35:00',2.03),('5815','2013-06-16','11:40:00',1.99),('5815','2013-06-16','11:45:00',1.96),('5815','2013-06-16','11:50:00',1.94),('5815','2013-06-16','11:55:00',2.03),('5815','2013-06-16','12:00:00',2.02),('5815','2013-06-16','12:05:00',2.03),('5815','2013-06-16','12:10:00',2.05),('5815','2013-06-16','12:15:00',2.06),('5815','2013-06-16','12:20:00',2.08),('5815','2013-06-16','12:25:00',2.11),('5815','2013-06-16','12:30:00',2.09),('5815','2013-06-16','12:35:00',2.06),('5815','2013-06-16','12:40:00',2.09),('5815','2013-06-16','12:45:00',2.09),('5815','2013-06-16','12:50:00',2.13),('5815','2013-06-16','12:55:00',2.14),('5815','2013-06-16','13:00:00',2.18),('5815','2013-06-16','13:05:00',2.19),('5815','2013-06-16','13:10:00',2.21),('5815','2013-06-16','13:15:00',2.21),('5815','2013-06-16','13:20:00',2.19),('5815','2013-06-16','13:25:00',2.19),('5815','2013-06-16','13:30:00',2.18),('5815','2013-06-16','13:35:00',2.15),('5815','2013-06-16','13:40:00',2.16),('5815','2013-06-16','13:45:00',2.16),('5815','2013-06-16','13:50:00',2.15),('5815','2013-06-16','13:55:00',2.14),('5815','2013-06-16','14:00:00',2.15),('5815','2013-06-16','14:05:00',2.16),('5815','2013-06-16','14:10:00',2.15),('5815','2013-06-16','14:15:00',2.14),('5815','2013-06-16','14:20:00',2.12),('5815','2013-06-16','14:25:00',2.11),('5815','2013-06-16','14:30:00',2.12),('5815','2013-06-16','14:35:00',2.11),('5815','2013-06-16','14:40:00',2.1),('5815','2013-06-16','14:45:00',2.08),('5815','2013-06-16','14:50:00',2.07),('5815','2013-06-16','14:55:00',2.07),('5815','2013-06-16','15:00:00',2.06),('5815','2013-06-16','15:05:00',2.01),('5815','2013-06-16','15:10:00',2),('5815','2013-06-16','15:15:00',1.97),('5815','2013-06-16','15:20:00',1.96),('5815','2013-06-16','15:25:00',1.94),('5815','2013-06-16','15:30:00',1.93),('5815','2013-06-16','15:35:00',1.91),('5815','2013-06-16','15:40:00',1.87),('5815','2013-06-16','15:45:00',1.9),('5815','2013-06-16','15:50:00',1.85),('5815','2013-06-16','15:55:00',1.8),('5815','2013-06-16','16:00:00',1.77),('5815','2013-06-16','16:05:00',1.75),('5815','2013-06-16','16:10:00',1.72),('5815','2013-06-16','16:15:00',1.7),('5815','2013-06-16','16:20:00',1.66),('5815','2013-06-16','16:25:00',1.63),('5815','2013-06-16','16:30:00',1.59),('5815','2013-06-16','16:35:00',1.56),('5815','2013-06-16','16:40:00',1.52),('5815','2013-06-16','16:45:00',1.48),('5815','2013-06-16','16:50:00',1.45),('5815','2013-06-16','16:55:00',1.42),('5815','2013-06-16','17:00:00',1.39),('5815','2013-06-16','17:05:00',1.32),('5815','2013-06-16','17:10:00',1.29),('5815','2013-06-16','17:15:00',1.26),('5815','2013-06-16','17:20:00',1.22),('5815','2013-06-16','17:25:00',1.19),('5815','2013-06-16','17:30:00',1.12),('5815','2013-06-16','17:45:00',1.01),('5815','2013-06-15','08:40:00',1.01),('5815','2013-06-15','08:45:00',1.07),('5815','2013-06-15','08:50:00',1.09),('5815','2013-06-15','08:55:00',1.15),('5815','2013-06-15','09:00:00',1.2),('5815','2013-06-15','09:05:00',1.24),('5815','2013-06-15','09:10:00',1.28),('5815','2013-06-15','09:15:00',1.33),('5815','2013-06-15','09:20:00',1.37),('5815','2013-06-15','09:25:00',1.41),('5815','2013-06-15','09:30:00',1.45),('5815','2013-06-15','09:35:00',1.5),('5815','2013-06-15','09:40:00',1.53),('5815','2013-06-15','09:45:00',1.56),('5815','2013-06-15','09:50:00',1.6),('5815','2013-06-15','09:55:00',1.63),('5815','2013-06-15','10:00:00',1.65),('5815','2013-06-15','10:05:00',1.67),('5815','2013-06-15','10:10:00',1.7),('5815','2013-06-15','10:15:00',1.75),('5815','2013-06-15','10:20:00',1.77),('5815','2013-06-15','10:25:00',1.79),('5815','2013-06-15','10:30:00',1.83),('5815','2013-06-15','10:35:00',1.86),('5815','2013-06-15','10:40:00',1.89),('5815','2013-06-15','10:45:00',1.91),('5815','2013-06-15','10:50:00',1.93),('5815','2013-06-15','10:55:00',1.94),('5815','2013-06-15','11:00:00',1.93),('5815','2013-06-15','11:05:00',1.91),('5815','2013-06-15','11:10:00',1.95),('5815','2013-06-15','11:15:00',1.97),('5815','2013-06-15','11:20:00',1.98),('5815','2013-06-15','11:25:00',2.01),('5815','2013-06-15','11:30:00',2.04),('5815','2013-06-15','11:35:00',2.08),('5815','2013-06-15','11:40:00',2.06),('5815','2013-06-15','11:45:00',2.07),('5815','2013-06-15','11:50:00',2.09),('5815','2013-06-15','11:55:00',2.12),('5815','2013-06-15','12:00:00',2.14),('5815','2013-06-15','12:05:00',2.15),('5815','2013-06-15','12:10:00',2.17),('5815','2013-06-15','12:15:00',2.17),('5815','2013-06-15','12:20:00',2.19),('5815','2013-06-15','12:25:00',2.25),('5815','2013-06-15','12:30:00',2.21),('5815','2013-06-15','12:35:00',2.17),('5815','2013-06-15','12:40:00',2.2),('5815','2013-06-15','12:45:00',2.19),('5815','2013-06-15','12:50:00',2.19),('5815','2013-06-15','12:55:00',2.22),('5815','2013-06-15','13:00:00',2.23),('5815','2013-06-15','13:05:00',2.24),('5815','2013-06-15','13:10:00',2.27),('5815','2013-06-15','13:15:00',2.27),('5815','2013-06-15','13:20:00',2.28),('5815','2013-06-15','13:25:00',2.28),('5815','2013-06-15','13:30:00',2.26),('5815','2013-06-15','13:35:00',2.26),('5815','2013-06-15','13:40:00',2.27),('5815','2013-06-15','13:45:00',2.27),('5815','2013-06-15','13:50:00',2.26),('5815','2013-06-15','13:55:00',2.26),('5815','2013-06-15','14:00:00',2.27),('5815','2013-06-15','14:05:00',2.26),('5815','2013-06-15','14:10:00',2.28),('5815','2013-06-15','14:15:00',2.25),('5815','2013-06-15','14:20:00',2.2),('5815','2013-06-15','14:25:00',2.2),('5815','2013-06-15','14:30:00',2.19),('5815','2013-06-15','14:35:00',2.17),('5815','2013-06-15','14:40:00',2.16),('5815','2013-06-15','14:45:00',2.15),('5815','2013-06-15','14:50:00',2.13),('5815','2013-06-15','14:55:00',2.11),('5815','2013-06-15','15:00:00',2.1),('5815','2013-06-15','15:05:00',2.09),('5815','2013-06-15','15:10:00',2.06),('5815','2013-06-15','15:15:00',2.05),('5815','2013-06-15','15:20:00',2.03),('5815','2013-06-15','15:25:00',2.02),('5815','2013-06-15','15:30:00',1.99),('5815','2013-06-15','15:35:00',1.96),('5815','2013-06-15','15:40:00',1.96),('5815','2013-06-15','15:45:00',1.96),('5815','2013-06-15','15:50:00',1.91),('5815','2013-06-15','15:55:00',1.85),('5815','2013-06-15','16:00:00',1.83),('5815','2013-06-15','16:05:00',1.8),('5815','2013-06-15','16:10:00',1.78),('5815','2013-06-15','16:15:00',1.75),('5815','2013-06-15','16:20:00',1.71),('5815','2013-06-15','16:25:00',1.68),('5815','2013-06-15','16:30:00',1.65),('5815','2013-06-15','16:35:00',1.61),('5815','2013-06-15','16:40:00',1.56),('5815','2013-06-15','16:45:00',1.52),('5815','2013-06-15','16:50:00',1.47),('5815','2013-06-15','16:55:00',1.46),('5815','2013-06-15','17:00:00',1.41),('5815','2013-06-15','17:05:00',1.33),('5815','2013-06-15','17:10:00',1.3),('5815','2013-06-15','17:15:00',1.27),('5815','2013-06-15','17:20:00',1.23),('5815','2013-06-15','17:25:00',1.19),('5815','2013-06-15','17:30:00',1.1),('5815','2013-06-15','17:40:00',1.01),('5815','2013-06-14','08:40:00',1.01),('5815','2013-06-14','08:45:00',1.07),('5815','2013-06-14','08:50:00',1.11),('5815','2013-06-14','08:55:00',1.09),('5815','2013-06-14','09:00:00',1.14),('5815','2013-06-14','09:05:00',1.23),('5815','2013-06-14','09:10:00',1.27),('5815','2013-06-14','09:15:00',1.32),('5815','2013-06-14','09:20:00',1.37),('5815','2013-06-14','09:25:00',1.37),('5815','2013-06-14','09:30:00',1.43),('5815','2013-06-14','09:35:00',1.39),('5815','2013-06-14','09:40:00',1.49),('5815','2013-06-14','09:45:00',1.43),('5815','2013-06-14','09:50:00',1.58),('5815','2013-06-14','09:55:00',1.62),('5815','2013-06-14','10:00:00',1.27),('5815','2013-06-14','10:10:00',1.07),('5815','2013-06-14','10:15:00',1.33),('5815','2013-06-14','10:20:00',1.68),('5815','2013-06-14','10:25:00',1.62),('5815','2013-06-14','10:30:00',1.8),('5815','2013-06-14','10:35:00',1.93),('5815','2013-06-14','10:40:00',1.93),('5815','2013-06-14','10:45:00',1.88),('5815','2013-06-14','10:50:00',1.99),('5815','2013-06-14','10:55:00',2.02),('5815','2013-06-14','11:00:00',1.26),('5815','2013-06-14','11:05:00',1.05),('5815','2013-06-14','11:10:00',1.8),('5815','2013-06-14','11:15:00',1.93),('5815','2013-06-14','11:20:00',1.97),('5815','2013-06-14','11:25:00',2),('5815','2013-06-14','11:30:00',1.56),('5815','2013-06-14','11:35:00',1.68),('5815','2013-06-14','11:40:00',1.41),('5815','2013-06-14','11:45:00',1),('5815','2013-06-14','11:50:00',1.13),('5815','2013-06-14','11:55:00',2.28),('5815','2013-06-14','12:00:00',2.22),('5815','2013-06-14','12:05:00',1.98),('5815','2013-06-14','12:10:00',2.24),('5815','2013-06-14','12:15:00',2.28),('5815','2013-06-14','12:20:00',2.29),('5815','2013-06-14','12:25:00',2.29),('5815','2013-06-14','12:30:00',2.29),('5815','2013-06-14','12:35:00',2.27),('5815','2013-06-14','12:40:00',2.29),('5815','2013-06-14','12:45:00',2.28),('5815','2013-06-14','12:50:00',2.28),('5815','2013-06-14','12:55:00',2.28),('5815','2013-06-14','13:00:00',2.3),('5815','2013-06-14','13:05:00',2.28),('5815','2013-06-14','13:10:00',2.26),('5815','2013-06-14','13:15:00',2.29),('5815','2013-06-14','13:20:00',2.27),('5815','2013-06-14','13:25:00',2.27),('5815','2013-06-14','13:30:00',2.28),('5815','2013-06-14','13:35:00',2.26),('5815','2013-06-14','13:40:00',2.27),('5815','2013-06-14','13:45:00',2.28),('5815','2013-06-14','13:50:00',2.29),('5815','2013-06-14','13:55:00',2.25),('5815','2013-06-14','14:00:00',2.24),('5815','2013-06-14','14:05:00',2.23),('5815','2013-06-14','14:10:00',2.25),('5815','2013-06-14','14:15:00',2.24),('5815','2013-06-14','14:20:00',2.2),('5815','2013-06-14','14:25:00',2.19),('5815','2013-06-14','14:30:00',2.19),('5815','2013-06-14','14:35:00',2.17),('5815','2013-06-14','14:40:00',2.15),('5815','2013-06-14','14:45:00',2.17),('5815','2013-06-14','14:50:00',2.12),('5815','2013-06-14','14:55:00',2.15),('5815','2013-06-14','15:00:00',2.14),('5815','2013-06-14','15:05:00',2.07),('5815','2013-06-14','15:10:00',2.07),('5815','2013-06-14','15:15:00',2.06),('5815','2013-06-14','15:20:00',2.04),('5815','2013-06-14','15:25:00',2.02),('5815','2013-06-14','15:30:00',2.01),('5815','2013-06-14','15:35:00',1.98),('5815','2013-06-14','15:40:00',1.97),('5815','2013-06-14','15:45:00',1.97),('5815','2013-06-14','15:50:00',1.91),('5815','2013-06-14','15:55:00',1.85),('5815','2013-06-14','16:00:00',1.84),('5815','2013-06-14','16:05:00',1.8),('5815','2013-06-14','16:10:00',1.77),('5815','2013-06-14','16:15:00',1.74),('5815','2013-06-14','16:20:00',1.7),('5815','2013-06-14','16:25:00',1.67),('5815','2013-06-14','16:30:00',1.63),('5815','2013-06-14','16:35:00',1.6),('5815','2013-06-14','16:40:00',1.55),('5815','2013-06-14','16:45:00',1.52),('5815','2013-06-14','16:50:00',1.47),('5815','2013-06-14','16:55:00',1.45),('5815','2013-06-14','17:00:00',1.41),('5815','2013-06-14','17:05:00',1.33),('5815','2013-06-14','17:10:00',1.3),('5815','2013-06-14','17:15:00',1.26),('5815','2013-06-14','17:20:00',1.22),('5815','2013-06-14','17:25:00',1.17),('5815','2013-06-14','17:30:00',1.09),('5815','2013-06-13','08:35:00',1.01),('5815','2013-06-13','08:40:00',1.06),('5815','2013-06-13','08:45:00',1.12),('5815','2013-06-13','08:50:00',1.16),('5815','2013-06-13','08:55:00',1.21),('5815','2013-06-13','09:00:00',1.25),('5815','2013-06-13','09:05:00',1.3),('5815','2013-06-13','09:10:00',1.34),('5815','2013-06-13','09:15:00',1.38),('5815','2013-06-13','09:20:00',1.42),('5815','2013-06-13','09:25:00',1.46),('5815','2013-06-13','09:30:00',1.49),('5815','2013-06-13','09:35:00',1.54),('5815','2013-06-13','09:40:00',1.59),('5815','2013-06-13','09:45:00',1.63),('5815','2013-06-13','09:50:00',1.68),('5815','2013-06-13','09:55:00',1.72),('5815','2013-06-13','10:00:00',1.75),('5815','2013-06-13','10:05:00',1.76),('5815','2013-06-13','10:10:00',1.77),('5815','2013-06-13','10:15:00',1.81),('5815','2013-06-13','10:20:00',1.85),('5815','2013-06-13','10:25:00',1.85),('5815','2013-06-13','10:30:00',1.91),('5815','2013-06-13','10:35:00',1.96),('5815','2013-06-13','10:40:00',1.97),('5815','2013-06-13','10:45:00',2.01),('5815','2013-06-13','10:50:00',2.01),('5815','2013-06-13','10:55:00',1.99),('5815','2013-06-13','11:00:00',1.94),('5815','2013-06-13','11:05:00',1.94),('5815','2013-06-13','11:10:00',2.03),('5815','2013-06-13','11:15:00',2.07),('5815','2013-06-13','11:20:00',2.04),('5815','2013-06-13','11:25:00',2.02),('5815','2013-06-13','11:30:00',2.12),('5815','2013-06-13','11:35:00',2.16),('5815','2013-06-13','11:40:00',2.1),('5815','2013-06-13','11:45:00',2.04),('5815','2013-06-13','11:50:00',2.08),('5815','2013-06-13','11:55:00',2.16),('5815','2013-06-13','12:00:00',2.17),('5815','2013-06-13','12:05:00',2.17),('5815','2013-06-13','12:10:00',2.21),('5815','2013-06-13','12:15:00',2.21),('5815','2013-06-13','12:20:00',2.2),('5815','2013-06-13','12:25:00',2.25),('5815','2013-06-13','12:30:00',2.21),('5815','2013-06-13','12:35:00',2.17),('5815','2013-06-13','12:40:00',2.22),('5815','2013-06-13','12:45:00',2.22),('5815','2013-06-13','12:50:00',2.19),('5815','2013-06-13','12:55:00',2.21),('5815','2013-06-13','13:00:00',2.24),('5815','2013-06-13','13:05:00',2.25),('5815','2013-06-13','13:10:00',1.62),('5815','2013-06-13','13:15:00',1.08),('5815','2013-06-13','13:20:00',1.38),('5815','2013-06-13','13:30:00',1.9),('5815','2013-06-13','13:35:00',1.99),('5815','2013-06-13','13:40:00',2.29),('5815','2013-06-13','13:45:00',2.24),('5815','2013-06-13','13:50:00',2.26),('5815','2013-06-13','13:55:00',2.28),('5815','2013-06-13','14:00:00',2.26),('5815','2013-06-13','14:05:00',2.29),('5815','2013-06-13','14:10:00',2.32),('5815','2013-06-13','14:15:00',2.27),('5815','2013-06-13','14:20:00',2.21),('5815','2013-06-13','14:25:00',2.21),('5815','2013-06-13','14:30:00',2.21),('5815','2013-06-13','14:35:00',2.23),('5815','2013-06-13','14:40:00',2.21),('5815','2013-06-13','14:45:00',2.17),('5815','2013-06-13','14:50:00',2.15),('5815','2013-06-13','14:55:00',2.15),('5815','2013-06-13','15:00:00',2.14),('5815','2013-06-13','15:05:00',2.12),('5815','2013-06-13','15:10:00',2.12),('5815','2013-06-13','15:15:00',2.09),('5815','2013-06-13','15:20:00',2.07),('5815','2013-06-13','15:25:00',2.04),('5815','2013-06-13','15:30:00',2.01),('5815','2013-06-13','15:35:00',1.99),('5815','2013-06-13','15:40:00',2),('5815','2013-06-13','15:45:00',2),('5815','2013-06-13','15:50:00',1.94),('5815','2013-06-13','15:55:00',1.89),('5815','2013-06-13','16:00:00',1.86),('5815','2013-06-13','16:05:00',1.83),('5815','2013-06-13','16:10:00',1.8),('5815','2013-06-13','16:15:00',1.77),('5815','2013-06-13','16:20:00',1.75),('5815','2013-06-13','16:25:00',1.7),('5815','2013-06-13','16:30:00',1.65),('5815','2013-06-13','16:35:00',1.62),('5815','2013-06-13','16:40:00',1.57),('5815','2013-06-13','16:45:00',1.54),('5815','2013-06-13','16:50:00',1.49),('5815','2013-06-13','16:55:00',1.46),('5815','2013-06-13','17:00:00',1.43),('5815','2013-06-13','17:05:00',1.32),('5815','2013-06-13','17:10:00',1.33),('5815','2013-06-13','17:15:00',1.31),('5815','2013-06-13','17:20:00',1.26),('5815','2013-06-13','17:25:00',1.2),('5815','2013-06-13','17:30:00',1.09),('5815','2013-06-13','17:40:00',1.03),('5815','2013-06-13','17:45:00',1),('5815','2013-06-12','08:35:00',1.02),('5815','2013-06-12','08:40:00',1.08),('5815','2013-06-12','08:45:00',1.12),('5815','2013-06-12','08:50:00',1.17),('5815','2013-06-12','08:55:00',1.22),('5815','2013-06-12','09:00:00',1.27),('5815','2013-06-12','09:05:00',1.32),('5815','2013-06-12','09:10:00',1.36),('5815','2013-06-12','09:15:00',1.41),('5815','2013-06-12','09:20:00',1.45),('5815','2013-06-12','09:25:00',1.5),('5815','2013-06-12','09:30:00',1.54),('5815','2013-06-12','09:35:00',1.57),('5815','2013-06-12','09:40:00',1.62),('5815','2013-06-12','09:45:00',1.65),('5815','2013-06-12','09:50:00',1.69),('5815','2013-06-12','09:55:00',1.73),('5815','2013-06-12','10:00:00',1.77),('5815','2013-06-12','10:05:00',1.8),('5815','2013-06-12','10:10:00',1.83),('5815','2013-06-12','10:15:00',1.86),('5815','2013-06-12','10:20:00',1.89),('5815','2013-06-12','10:25:00',1.92),('5815','2013-06-12','10:30:00',1.95),('5815','2013-06-12','10:35:00',1.97),('5815','2013-06-12','10:40:00',2),('5815','2013-06-12','10:45:00',2.05),('5815','2013-06-12','10:50:00',2.06),('5815','2013-06-12','10:55:00',2.07),('5815','2013-06-12','11:00:00',2.04),('5815','2013-06-12','11:05:00',2.03),('5815','2013-06-12','11:10:00',2.08),('5815','2013-06-12','11:15:00',2.1),('5815','2013-06-12','11:20:00',2.13),('5815','2013-06-12','11:25:00',2.15),('5815','2013-06-12','11:30:00',2.16),('5815','2013-06-12','11:35:00',2.18),('5815','2013-06-12','11:40:00',2.15),('5815','2013-06-12','11:45:00',2.11),('5815','2013-06-12','11:50:00',2.1),('5815','2013-06-12','11:55:00',2.23),('5815','2013-06-12','12:00:00',2.24),('5815','2013-06-12','12:05:00',2.27),('5815','2013-06-12','12:10:00',2.28),('5815','2013-06-12','12:15:00',2.28),('5815','2013-06-12','12:20:00',2.29),('5815','2013-06-12','12:25:00',2.33),('5815','2013-06-12','12:30:00',2.29),('5815','2013-06-12','12:35:00',2.25),('5815','2013-06-12','12:40:00',2.31),('5815','2013-06-12','12:45:00',2.32),('5815','2013-06-12','12:50:00',2.31),('5815','2013-06-12','12:55:00',2.31),('5815','2013-06-12','13:00:00',2.32),('5815','2013-06-12','13:05:00',2.32),('5815','2013-06-12','13:10:00',2.32),('5815','2013-06-12','13:15:00',2.33),('5815','2013-06-12','13:20:00',2.32),('5815','2013-06-12','13:25:00',2.32),('5815','2013-06-12','13:30:00',2.29),('5815','2013-06-12','13:35:00',2.29),('5815','2013-06-12','13:40:00',2.32),('5815','2013-06-12','13:45:00',2.31),('5815','2013-06-12','13:50:00',2.29),('5815','2013-06-12','13:55:00',2.27),('5815','2013-06-12','14:00:00',2.28),('5815','2013-06-12','14:05:00',2.27),('5815','2013-06-12','14:10:00',2.3),('5815','2013-06-12','14:15:00',2.27),('5815','2013-06-12','14:20:00',2.22),('5815','2013-06-12','14:25:00',2.28),('5815','2013-06-12','14:30:00',1.21),('5815','2013-06-12','14:35:00',2.27),('5815','2013-06-12','14:40:00',2.27),('5815','2013-06-12','14:45:00',2.21),('5815','2013-06-12','14:50:00',2.14),('5815','2013-06-12','14:55:00',2.15),('5815','2013-06-12','15:00:00',2.14),('5815','2013-06-12','15:05:00',2.1),('5815','2013-06-12','15:10:00',2.06),('5815','2013-06-12','15:15:00',2.04),('5815','2013-06-12','15:20:00',2.03),('5815','2013-06-12','15:25:00',2.01),('5815','2013-06-12','15:30:00',1.98),('5815','2013-06-12','15:35:00',1.97),('5815','2013-06-12','15:40:00',1.99),('5815','2013-06-12','15:45:00',1.97),('5815','2013-06-12','15:50:00',1.92),('5815','2013-06-12','15:55:00',1.87),('5815','2013-06-12','16:00:00',1.84),('5815','2013-06-12','16:05:00',1.81),('5815','2013-06-12','16:10:00',1.78),('5815','2013-06-12','16:15:00',1.75),('5815','2013-06-12','16:20:00',1.72),('5815','2013-06-12','16:25:00',1.68),('5815','2013-06-12','16:30:00',1.65),('5815','2013-06-12','16:35:00',1.6),('5815','2013-06-12','16:40:00',1.54),('5815','2013-06-12','16:45:00',1.52),('5815','2013-06-12','16:50:00',1.48),('5815','2013-06-12','16:55:00',1.46),('5815','2013-06-12','17:00:00',1.39),('5815','2013-06-12','17:05:00',1.33),('5815','2013-06-12','17:10:00',1.31),('5815','2013-06-12','17:15:00',1.29),('5815','2013-06-12','17:20:00',1.24),('5815','2013-06-12','17:25:00',1.2),('5815','2013-06-12','17:30:00',1.1),('5815','2013-06-12','17:40:00',1),('5815','2013-06-12','17:45:00',1.01),('5815','2013-06-11','08:35:00',1.05),('5815','2013-06-11','08:40:00',1.1),('5815','2013-06-11','08:45:00',1.15),('5815','2013-06-11','08:50:00',1.2),('5815','2013-06-11','08:55:00',1.24),('5815','2013-06-11','09:00:00',1.29),('5815','2013-06-11','09:05:00',1.34),('5815','2013-06-11','09:10:00',1.39),('5815','2013-06-11','09:15:00',1.43),('5815','2013-06-11','09:20:00',1.48),('5815','2013-06-11','09:25:00',1.51),('5815','2013-06-11','09:30:00',1.56),('5815','2013-06-11','09:35:00',1.6),('5815','2013-06-11','09:40:00',1.63),('5815','2013-06-11','09:45:00',1.67),('5815','2013-06-11','09:50:00',1.71),('5815','2013-06-11','09:55:00',1.75),('5815','2013-06-11','10:00:00',1.77),('5815','2013-06-11','10:05:00',1.81),('5815','2013-06-11','10:10:00',1.84),('5815','2013-06-11','10:15:00',1.88),('5815','2013-06-11','10:20:00',1.91),('5815','2013-06-11','10:25:00',1.93),('5815','2013-06-11','10:30:00',1.95),('5815','2013-06-11','10:35:00',1.97),('5815','2013-06-11','10:40:00',2),('5815','2013-06-11','10:45:00',2.05),('5815','2013-06-11','10:50:00',2.09),('5815','2013-06-11','10:55:00',2.09),('5815','2013-06-11','11:00:00',2.08),('5815','2013-06-11','11:05:00',2.06),('5815','2013-06-11','11:10:00',2.11),('5815','2013-06-11','11:15:00',2.14),('5815','2013-06-11','11:20:00',2.15),('5815','2013-06-11','11:25:00',2.17),('5815','2013-06-11','11:30:00',2.2),('5815','2013-06-11','11:35:00',2.2),('5815','2013-06-11','11:40:00',2.23),('5815','2013-06-11','11:45:00',2.21),('5815','2013-06-11','11:50:00',2.25),('5815','2013-06-11','11:55:00',2.27),('5815','2013-06-11','12:00:00',2.29),('5815','2013-06-11','12:05:00',2.3),('5815','2013-06-11','12:10:00',2.29),('5815','2013-06-11','12:15:00',2.32),('5815','2013-06-11','12:20:00',2.33),('5815','2013-06-11','12:25:00',2.34),('5815','2013-06-11','12:30:00',2.39),('5815','2013-06-11','12:35:00',2.16),('5815','2013-06-11','12:40:00',1.32),('5815','2013-06-11','12:45:00',1.67),('5815','2013-06-11','12:50:00',2.57),('5815','2013-06-11','12:55:00',2.02),('5815','2013-06-11','13:00:00',2.15),('5815','2013-06-11','13:05:00',2.39),('5815','2013-06-11','13:10:00',2.36),('5815','2013-06-11','13:15:00',2.33),('5815','2013-06-11','13:20:00',2.32),('5815','2013-06-11','13:25:00',2.34),('5815','2013-06-11','13:30:00',2.33),('5815','2013-06-11','13:35:00',2.32),('5815','2013-06-11','13:40:00',2.3),('5815','2013-06-11','13:45:00',2.35),('5815','2013-06-11','13:50:00',2.34),('5815','2013-06-11','13:55:00',2.38),('5815','2013-06-11','14:00:00',2.42),('5815','2013-06-11','14:05:00',1.49),('5815','2013-06-11','14:10:00',2.15),('5815','2013-06-11','14:15:00',2.17),('5815','2013-06-11','14:20:00',1.33),('5815','2013-06-11','14:25:00',1.03),('5815','2013-06-11','14:30:00',2.48),('5815','2013-06-11','14:35:00',2.41),('5815','2013-06-11','14:40:00',2.24),('5815','2013-06-11','14:45:00',2.06),('5815','2013-06-11','14:50:00',2.34),('5815','2013-06-11','14:55:00',2.41),('5815','2013-06-11','15:00:00',2.4),('5815','2013-06-11','15:05:00',2.17),('5815','2013-06-11','15:10:00',2.16),('5815','2013-06-11','15:15:00',1.5),('5815','2013-06-11','15:20:00',2.21),('5815','2013-06-11','15:25:00',2.1),('5815','2013-06-11','15:30:00',2.09),('5815','2013-06-11','15:35:00',2.09),('5815','2013-06-11','15:40:00',2.08),('5815','2013-06-11','15:45:00',2.07),('5815','2013-06-11','15:50:00',1.99),('5815','2013-06-11','15:55:00',1.98),('5815','2013-06-11','16:00:00',1.75),('5815','2013-06-11','16:05:00',1.87),('5815','2013-06-11','16:10:00',1.89),('5815','2013-06-11','16:15:00',1.86),('5815','2013-06-11','16:20:00',1.78),('5815','2013-06-11','16:25:00',1.68),('5815','2013-06-11','16:30:00',1.72),('5815','2013-06-11','16:35:00',1.66),('5815','2013-06-11','16:40:00',1.66),('5815','2013-06-11','16:45:00',1.41),('5815','2013-06-11','16:50:00',1.58),('5815','2013-06-11','16:55:00',1.49),('5815','2013-06-11','17:00:00',1.44),('5815','2013-06-11','17:05:00',1.42),('5815','2013-06-11','17:10:00',1.39),('5815','2013-06-11','17:15:00',1.33),('5815','2013-06-11','17:20:00',1.28),('5815','2013-06-11','17:25:00',1.23),('5815','2013-06-11','17:30:00',1.13),('5815','2013-06-11','17:40:00',1.03),('5815','2013-06-10','08:20:00',1.02),('5815','2013-06-10','08:25:00',1.03),('5815','2013-06-10','08:30:00',1.07),('5815','2013-06-10','08:35:00',1.1),('5815','2013-06-10','08:40:00',1.2),('5815','2013-06-10','08:45:00',1.21),('5815','2013-06-10','08:50:00',1.27),('5815','2013-06-10','08:55:00',1.35),('5815','2013-06-10','09:00:00',1.39),('5815','2013-06-10','09:05:00',1.43),('5815','2013-06-10','09:10:00',1.45),('5815','2013-06-10','09:15:00',1.52),('5815','2013-06-10','09:20:00',1.55),('5815','2013-06-10','09:25:00',1.68),('5815','2013-06-10','09:30:00',1.73),('5815','2013-06-10','09:35:00',1.7),('5815','2013-06-10','09:50:00',1.45),('5815','2013-06-10','09:55:00',1.7),('5815','2013-06-10','10:00:00',1.2),('5815','2013-06-10','10:05:00',1.58),('5815','2013-06-10','10:15:00',1.98),('5815','2013-06-10','10:20:00',2.02),('5815','2013-06-10','10:25:00',1.85),('5815','2013-06-10','10:30:00',2.08),('5815','2013-06-10','10:35:00',2.05),('5815','2013-06-10','10:40:00',1.57),('5815','2013-06-10','10:45:00',1.97),('5815','2013-06-10','10:50:00',2.19),('5815','2013-06-10','10:55:00',2.23),('5815','2013-06-10','11:00:00',2.21),('5815','2013-06-10','11:05:00',2.19),('5815','2013-06-10','11:10:00',1.76),('5815','2013-06-10','11:15:00',1.9),('5815','2013-06-10','11:20:00',2.3),('5815','2013-06-10','11:25:00',1.5),('5815','2013-06-10','11:30:00',1.99),('5815','2013-06-10','11:35:00',2.31),('5815','2013-06-10','11:40:00',2.29),('5815','2013-06-10','11:45:00',2.29),('5815','2013-06-10','11:50:00',2.32),('5815','2013-06-10','11:55:00',2.33),('5815','2013-06-10','12:00:00',2.06),('5815','2013-06-10','12:05:00',1.47),('5815','2013-06-10','12:10:00',2.42),('5815','2013-06-10','12:15:00',2.39),('5815','2013-06-10','12:20:00',2.37),('5815','2013-06-10','12:25:00',2.4),('5815','2013-06-10','12:30:00',2.44),('5815','2013-06-10','12:35:00',2.45),('5815','2013-06-10','12:40:00',2.45),('5815','2013-06-10','12:45:00',2.44),('5815','2013-06-10','12:50:00',2.44),('5815','2013-06-10','12:55:00',2.47),('5815','2013-06-10','13:00:00',2.48),('5815','2013-06-10','13:05:00',2.49),('5815','2013-06-10','13:10:00',2.49),('5815','2013-06-10','13:15:00',2.5),('5815','2013-06-10','13:20:00',2.48),('5815','2013-06-10','13:25:00',2.47),('5815','2013-06-10','13:30:00',2.45),('5815','2013-06-10','13:35:00',2.45),('5815','2013-06-10','13:40:00',2.49),('5815','2013-06-10','13:45:00',2.5),('5815','2013-06-10','13:50:00',2.38),('5815','2013-06-10','13:55:00',2.51),('5815','2013-06-10','14:00:00',2.48),('5815','2013-06-10','14:05:00',2.45),('5815','2013-06-10','14:10:00',2.45),('5815','2013-06-10','14:15:00',2.39),('5815','2013-06-10','14:20:00',2.35),('5815','2013-06-10','14:25:00',2.35),('5815','2013-06-10','14:30:00',2.35),('5815','2013-06-10','14:35:00',2.35),('5815','2013-06-10','14:40:00',2.32),('5815','2013-06-10','14:45:00',2.32),('5815','2013-06-10','14:50:00',2.3),('5815','2013-06-10','14:55:00',2.27),('5815','2013-06-10','15:00:00',2.26),('5815','2013-06-10','15:05:00',2.2),('5815','2013-06-10','15:10:00',2.18),('5815','2013-06-10','15:15:00',2.19),('5815','2013-06-10','15:20:00',2.16),('5815','2013-06-10','15:25:00',2.11),('5815','2013-06-10','15:30:00',2.09),('5815','2013-06-10','15:35:00',2.07),('5815','2013-06-10','15:40:00',2.02),('5815','2013-06-10','15:45:00',1.55),('5815','2013-06-10','15:50:00',1.97),('5815','2013-06-10','15:55:00',1.79),('5815','2013-06-10','16:00:00',1.97),('5815','2013-06-10','16:05:00',1.95),('5815','2013-06-10','16:10:00',1.9),('5815','2013-06-10','16:15:00',1.87),('5815','2013-06-10','16:20:00',1.82),('5815','2013-06-10','16:25:00',1.78),('5815','2013-06-10','16:30:00',1.75),('5815','2013-06-10','16:35:00',1.72),('5815','2013-06-10','16:40:00',1.73),('5815','2013-06-10','16:45:00',1.79),('5815','2013-06-10','16:50:00',1.78),('5815','2013-06-10','16:55:00',1.75),('5815','2013-06-10','17:00:00',1.64),('5815','2013-06-10','17:05:00',1.33),('5815','2013-06-09','08:20:00',1.01),('5815','2013-06-09','09:20:00',1.32),('5815','2013-06-09','09:30:00',1.12),('5815','2013-06-09','09:35:00',1.74),('5815','2013-06-09','09:40:00',1.32),('5815','2013-06-09','09:45:00',2.01),('5815','2013-06-09','09:50:00',1.16),('5815','2013-06-09','09:55:00',1.07),('5815','2013-06-09','10:00:00',1.2),('5815','2013-06-09','10:05:00',1.32),('5815','2013-06-09','10:10:00',1.73),('5815','2013-06-09','10:15:00',1.6),('5815','2013-06-09','10:20:00',1.13),('5815','2013-06-09','10:50:00',1.05),('5815','2013-06-09','10:55:00',1.33),('5815','2013-06-09','11:00:00',1.88),('5815','2013-06-09','11:05:00',1.67),('5815','2013-06-09','11:10:00',1.6),('5815','2013-06-09','11:15:00',2.32),('5815','2013-06-09','11:20:00',2.37),('5815','2013-06-09','11:25:00',2.27),('5815','2013-06-09','11:30:00',2.44),('5815','2013-06-09','11:35:00',2.51),('5815','2013-06-09','11:40:00',1.62),('5815','2013-06-09','11:45:00',1.77),('5815','2013-06-09','11:50:00',1.42),('5815','2013-06-09','11:55:00',1.75),('5815','2013-06-09','12:00:00',2.58),('5815','2013-06-09','12:05:00',1.19),('5815','2013-06-09','12:10:00',1.57),('5815','2013-06-09','12:15:00',1.6),('5815','2013-06-09','12:20:00',1.98),('5815','2013-06-09','12:25:00',2.58),('5815','2013-06-09','12:30:00',2.55),('5815','2013-06-09','12:35:00',2.63),('5815','2013-06-09','12:40:00',2.26),('5815','2013-06-09','12:45:00',2.71),('5815','2013-06-09','12:50:00',1.14),('5815','2013-06-09','12:55:00',2.47),('5815','2013-06-09','13:00:00',2.81),('5815','2013-06-09','13:05:00',2.49),('5815','2013-06-09','13:10:00',2.29),('5815','2013-06-09','13:15:00',1.62),('5815','2013-06-09','13:20:00',1.28),('5815','2013-06-09','13:25:00',1.34),('5815','2013-06-09','13:30:00',1.04),('5815','2013-06-09','13:35:00',2.08),('5815','2013-06-09','13:40:00',2.14),('5815','2013-06-09','13:45:00',2.59),('5815','2013-06-09','13:50:00',2.77),('5815','2013-06-09','13:55:00',2.22),('5815','2013-06-09','14:00:00',2.6),('5815','2013-06-09','14:05:00',2.58),('5815','2013-06-09','14:10:00',2.57),('5815','2013-06-09','14:15:00',2.45),('5815','2013-06-09','14:20:00',2.17),('5815','2013-06-09','14:25:00',2.37),('5815','2013-06-09','14:30:00',2.39),('5815','2013-06-09','14:35:00',2.37),('5815','2013-06-09','14:40:00',2.34),('5815','2013-06-09','14:45:00',2.35),('5815','2013-06-09','14:50:00',2.32),('5815','2013-06-09','14:55:00',2.3),('5815','2013-06-09','15:00:00',2.28),('5815','2013-06-09','15:05:00',2.23),('5815','2013-06-09','15:10:00',2.23),('5815','2013-06-09','15:15:00',2.22),('5815','2013-06-09','15:20:00',2.21),('5815','2013-06-09','15:25:00',2.18),('5815','2013-06-09','15:30:00',2.16),('5815','2013-06-09','15:35:00',2.14),('5815','2013-06-09','15:40:00',2.13),('5815','2013-06-09','15:45:00',2.14),('5815','2013-06-09','15:50:00',2.06),('5815','2013-06-09','15:55:00',2.02),('5815','2013-06-09','16:00:00',2),('5815','2013-06-09','16:05:00',1.96),('5815','2013-06-09','16:10:00',1.92),('5815','2013-06-09','16:15:00',1.89),('5815','2013-06-09','16:20:00',1.85),('5815','2013-06-09','16:25:00',1.81),('5815','2013-06-09','16:30:00',1.78),('5815','2013-06-09','16:35:00',1.73),('5815','2013-06-09','16:40:00',1.68),('5815','2013-06-09','16:45:00',1.63),('5815','2013-06-09','16:50:00',1.6),('5815','2013-06-09','16:55:00',1.56),('5815','2013-06-09','17:00:00',1.51),('5815','2013-06-09','17:05:00',1.47),('5815','2013-06-09','17:10:00',1.41),('5815','2013-06-09','17:15:00',1.38),('5815','2013-06-09','17:20:00',1.34),('5815','2013-06-09','17:25:00',1.29),('5815','2013-06-09','17:30:00',1.15),('5815','2013-06-09','17:35:00',1),('5815','2013-06-09','17:40:00',1.1),('5815','2013-06-09','17:45:00',1.08),('5815','2013-06-09','17:50:00',1.03),('5815','2013-06-08','08:40:00',1.04),('5815','2013-06-08','08:45:00',1.1),('5815','2013-06-08','08:50:00',1.14),('5815','2013-06-08','08:55:00',1.17),('5815','2013-06-08','09:00:00',1.23),('5815','2013-06-08','09:05:00',1.28),('5815','2013-06-08','09:10:00',1.33),('5815','2013-06-08','09:15:00',1.37),('5815','2013-06-08','09:20:00',1.33),('5815','2013-06-08','09:25:00',1.42),('5815','2013-06-08','09:30:00',1.47),('5815','2013-06-08','09:35:00',1.53),('5815','2013-06-08','09:40:00',1.57),('5815','2013-06-08','09:45:00',1.61),('5815','2013-06-08','09:50:00',1.65),('5815','2013-06-08','09:55:00',1.67),('5815','2013-06-08','10:00:00',1.71),('5815','2013-06-08','10:05:00',1.75),('5815','2013-06-08','10:10:00',1.78),('5815','2013-06-08','10:15:00',1.82),('5815','2013-06-08','10:20:00',1.86),('5815','2013-06-08','10:25:00',1.88),('5815','2013-06-08','10:30:00',1.88),('5815','2013-06-08','10:35:00',1.95),('5815','2013-06-08','10:40:00',1.98),('5815','2013-06-08','10:45:00',1.97),('5815','2013-06-08','10:50:00',2.01),('5815','2013-06-08','10:55:00',2.01),('5815','2013-06-08','11:00:00',1.97),('5815','2013-06-08','11:05:00',1.98),('5815','2013-06-08','11:10:00',2.01),('5815','2013-06-08','11:15:00',2.01),('5815','2013-06-08','11:20:00',2.05),('5815','2013-06-08','11:25:00',2.11),('5815','2013-06-08','11:30:00',2.12),('5815','2013-06-08','11:35:00',2.13),('5815','2013-06-08','11:40:00',2.11),('5815','2013-06-08','11:45:00',2.15),('5815','2013-06-08','11:50:00',2.17),('5815','2013-06-08','11:55:00',2.19),('5815','2013-06-08','12:00:00',2.2),('5815','2013-06-08','12:05:00',2.2),('5815','2013-06-08','12:10:00',2),('5815','2013-06-08','12:15:00',2.11),('5815','2013-06-08','12:20:00',2.2),('5815','2013-06-08','12:25:00',2.19),('5815','2013-06-08','12:30:00',2.19),('5815','2013-06-08','12:35:00',2.16),('5815','2013-06-08','12:40:00',2.22),('5815','2013-06-08','12:45:00',2.2),('5815','2013-06-08','12:50:00',2.17),('5815','2013-06-08','12:55:00',1.99),('5815','2013-06-08','13:00:00',2.07),('5815','2013-06-08','13:05:00',1.52),('5815','2013-06-08','13:10:00',2.2),('5815','2013-06-08','13:20:00',1.14),('5815','2013-06-08','13:25:00',2.57),('5815','2013-06-08','13:30:00',2.42),('5815','2013-06-08','13:35:00',2.39),('5815','2013-06-08','13:40:00',2.45),('5815','2013-06-08','13:45:00',2.47),('5815','2013-06-08','13:50:00',2.57),('5815','2013-06-08','13:55:00',2.46),('5815','2013-06-08','14:00:00',2.24),('5815','2013-06-08','14:05:00',2.46),('5815','2013-06-08','14:10:00',2.53),('5815','2013-06-08','14:15:00',1.64),('5815','2013-06-08','14:20:00',1.25),('5815','2013-06-08','14:35:00',1.9),('5815','2013-06-08','14:40:00',2.04),('5815','2013-06-08','14:45:00',1.96),('5815','2013-06-08','14:50:00',2.17),('5815','2013-06-08','14:55:00',2.26),('5815','2013-06-08','15:00:00',2.23),('5815','2013-06-08','15:05:00',2.12),('5815','2013-06-08','15:10:00',2.09),('5815','2013-06-08','15:15:00',2.03),('5815','2013-06-08','15:20:00',2.05),('5815','2013-06-08','15:25:00',2.07),('5815','2013-06-08','15:30:00',1.97),('5815','2013-06-08','15:35:00',2.06),('5815','2013-06-08','15:40:00',1.67),('5815','2013-06-08','15:45:00',1.67),('5815','2013-06-08','15:50:00',1.82),('5815','2013-06-08','15:55:00',2.02),('5815','2013-06-08','16:00:00',1.29),('5815','2013-06-08','16:05:00',1.75),('5815','2013-06-08','16:10:00',1.78),('5815','2013-06-08','16:15:00',1.05),('5815','2013-06-08','16:25:00',1.27),('5815','2013-06-07','08:35:00',1.01),('5815','2013-06-07','08:40:00',1.06),('5815','2013-06-07','08:45:00',1.11),('5815','2013-06-07','08:50:00',1.16),('5815','2013-06-07','08:55:00',1.2),('5815','2013-06-07','09:00:00',1.24),('5815','2013-06-07','09:05:00',1.3),('5815','2013-06-07','09:10:00',1.35),('5815','2013-06-07','09:15:00',1.38),('5815','2013-06-07','09:20:00',1.41),('5815','2013-06-07','09:25:00',1.45),('5815','2013-06-07','09:30:00',1.5),('5815','2013-06-07','09:35:00',1.52),('5815','2013-06-07','09:40:00',1.57),('5815','2013-06-07','09:45:00',1.58),('5815','2013-06-07','09:50:00',1.61),('5815','2013-06-07','09:55:00',1.62),('5815','2013-06-07','10:00:00',1.65),('5815','2013-06-07','10:05:00',1.74),('5815','2013-06-07','10:10:00',1.83),('5815','2013-06-07','10:15:00',1.86),('5815','2013-06-07','10:20:00',1.87),('5815','2013-06-07','10:25:00',1.9),('5815','2013-06-07','10:30:00',1.92),('5815','2013-06-07','10:35:00',1.96),('5815','2013-06-07','10:40:00',2.01),('5815','2013-06-07','10:45:00',1.97),('5815','2013-06-07','10:50:00',2.09),('5815','2013-06-07','10:55:00',1.75),('5815','2013-06-07','11:05:00',2.2),('5815','2013-06-07','11:10:00',2.33),('5815','2013-06-07','11:15:00',2.27),('5815','2013-06-07','11:20:00',2.28),('5815','2013-06-07','11:25:00',2.35),('5815','2013-06-07','11:30:00',2.14),('5815','2013-06-07','11:35:00',1.35),('5815','2013-06-07','11:40:00',2.35),('5815','2013-06-07','11:45:00',2.26),('5815','2013-06-07','11:50:00',2.29),('5815','2013-06-07','11:55:00',2.06),('5815','2013-06-07','12:05:00',1.53),('5815','2013-06-07','12:15:00',1.82),('5815','2013-06-07','12:20:00',2.5),('5815','2013-06-07','12:35:00',1.77),('5815','2013-06-07','12:40:00',2.42),('5815','2013-06-07','12:45:00',2.44),('5815','2013-06-07','12:50:00',2.44),('5815','2013-06-07','12:55:00',2.44),('5815','2013-06-07','13:00:00',1.29),('5815','2013-06-07','13:05:00',2.45),('5815','2013-06-07','13:10:00',2.5),('5815','2013-06-07','13:15:00',2.53),('5815','2013-06-07','13:20:00',2.52),('5815','2013-06-07','13:25:00',2.42),('5815','2013-06-07','13:30:00',2.42),('5815','2013-06-07','13:35:00',2.44),('5815','2013-06-07','13:40:00',2.46),('5815','2013-06-07','13:45:00',2.41),('5815','2013-06-07','13:50:00',2.39),('5815','2013-06-07','13:55:00',2.39),('5815','2013-06-07','14:00:00',2.38),('5815','2013-06-07','14:05:00',2.39),('5815','2013-06-07','14:10:00',2.42),('5815','2013-06-07','14:15:00',2.37),('5815','2013-06-07','14:20:00',2.33),('5815','2013-06-07','14:25:00',2.33),('5815','2013-06-07','14:30:00',2.33),('5815','2013-06-07','14:35:00',2.31),('5815','2013-06-07','14:40:00',2.29),('5815','2013-06-07','14:45:00',2.28),('5815','2013-06-07','14:50:00',2.28),('5815','2013-06-07','14:55:00',2.28),('5815','2013-06-07','15:00:00',2.29),('5815','2013-06-07','15:05:00',2.18),('5815','2013-06-07','15:10:00',2.01),('5815','2013-06-07','15:15:00',2.12),('5815','2013-06-07','15:20:00',2.18),('5815','2013-06-07','15:25:00',2.06),('5815','2013-06-07','15:30:00',2.11),('5815','2013-06-07','15:35:00',2.2),('5815','2013-06-07','15:40:00',2.19),('5815','2013-06-07','15:45:00',2.22),('5815','2013-06-07','15:50:00',2.17),('5815','2013-06-07','15:55:00',1.96),('5815','2013-06-07','16:00:00',1.87),('5815','2013-06-07','16:05:00',1.82),('5815','2013-06-07','16:10:00',1.89),('5815','2013-06-07','16:15:00',1.94),('5815','2013-06-07','16:20:00',1.89),('5815','2013-06-07','16:25:00',1.8),('5815','2013-06-07','16:30:00',1.71),('5815','2013-06-07','16:35:00',1.66),('5815','2013-06-07','16:40:00',1.61),('5815','2013-06-07','16:45:00',1.58),('5815','2013-06-07','16:50:00',1.38),('5815','2013-06-07','16:55:00',1.38),('5815','2013-06-07','17:00:00',1.47),('5815','2013-06-07','17:05:00',1.08),('5815','2013-06-07','17:10:00',1.49),('5815','2013-06-07','17:15:00',1.48),('5815','2013-06-07','17:20:00',1.4),('5815','2013-06-07','17:25:00',1.29),('5815','2013-06-07','17:45:00',1.11),('5815','2013-06-07','17:55:00',1.02),('5815','2013-06-06','08:30:00',1.01),('5815','2013-06-06','08:35:00',1.06),('5815','2013-06-06','08:40:00',1.11),('5815','2013-06-06','08:45:00',1.17),('5815','2013-06-06','08:50:00',1.22),('5815','2013-06-06','08:55:00',1.27),('5815','2013-06-06','09:00:00',1.32),('5815','2013-06-06','09:05:00',1.36),('5815','2013-06-06','09:10:00',1.41),('5815','2013-06-06','09:15:00',1.45),('5815','2013-06-06','09:20:00',1.49),('5815','2013-06-06','09:25:00',1.54),('5815','2013-06-06','09:30:00',1.59),('5815','2013-06-06','09:35:00',1.63),('5815','2013-06-06','09:40:00',1.68),('5815','2013-06-06','09:45:00',1.73),('5815','2013-06-06','09:50:00',1.76),('5815','2013-06-06','09:55:00',1.8),('5815','2013-06-06','10:00:00',1.83),('5815','2013-06-06','10:05:00',1.86),('5815','2013-06-06','10:10:00',1.9),('5815','2013-06-06','10:15:00',1.93),('5815','2013-06-06','10:20:00',1.96),('5815','2013-06-06','10:25:00',2),('5815','2013-06-06','10:30:00',2.03),('5815','2013-06-06','10:35:00',2.03),('5815','2013-06-06','10:40:00',2.07),('5815','2013-06-06','10:45:00',2.09),('5815','2013-06-06','10:50:00',2.12),('5815','2013-06-06','10:55:00',2.11),('5815','2013-06-06','11:00:00',2.06),('5815','2013-06-06','11:05:00',2.08),('5815','2013-06-06','11:10:00',2.15),('5815','2013-06-06','11:15:00',2.16),('5815','2013-06-06','11:20:00',2.18),('5815','2013-06-06','11:25:00',2.2),('5815','2013-06-06','11:30:00',2.21),('5815','2013-06-06','11:35:00',2.24),('5815','2013-06-06','11:40:00',2.19),('5815','2013-06-06','11:45:00',2.14),('5815','2013-06-06','11:50:00',2.19),('5815','2013-06-06','11:55:00',2.28),('5815','2013-06-06','12:00:00',2.3),('5815','2013-06-06','12:05:00',2.31),('5815','2013-06-06','12:10:00',2.32),('5815','2013-06-06','12:15:00',2.33),('5815','2013-06-06','12:20:00',2.33),('5815','2013-06-06','12:25:00',2.38),('5815','2013-06-06','12:30:00',2.33),('5815','2013-06-06','12:35:00',2.31),('5815','2013-06-06','12:40:00',2.38),('5815','2013-06-06','12:45:00',2.36),('5815','2013-06-06','12:50:00',2.36),('5815','2013-06-06','12:55:00',2.36),('5815','2013-06-06','13:00:00',2.36),('5815','2013-06-06','13:05:00',2.35),('5815','2013-06-06','13:10:00',2.35),('5815','2013-06-06','13:15:00',2.35),('5815','2013-06-06','13:20:00',2.33),('5815','2013-06-06','13:25:00',2.35),('5815','2013-06-06','13:30:00',2.35),('5815','2013-06-06','13:35:00',2.32),('5815','2013-06-06','13:40:00',2.31),('5815','2013-06-06','13:45:00',2.3),('5815','2013-06-06','13:50:00',2.3),('5815','2013-06-06','13:55:00',2.29),('5815','2013-06-06','14:00:00',2.29),('5815','2013-06-06','14:05:00',2.29),('5815','2013-06-06','14:10:00',2.28),('5815','2013-06-06','14:15:00',2.24),('5815','2013-06-06','14:20:00',2.2),('5815','2013-06-06','14:25:00',2.2),('5815','2013-06-06','14:30:00',2.21),('5815','2013-06-06','14:35:00',2.2),('5815','2013-06-06','14:40:00',2.2),('5815','2013-06-06','14:45:00',2.21),('5815','2013-06-06','14:50:00',2.19),('5815','2013-06-06','14:55:00',2.18),('5815','2013-06-06','15:00:00',2.18),('5815','2013-06-06','15:05:00',2.15),('5815','2013-06-06','15:10:00',2.16),('5815','2013-06-06','15:15:00',2.12),('5815','2013-06-06','15:20:00',2.08),('5815','2013-06-06','15:25:00',2.07),('5815','2013-06-06','15:30:00',2.08),('5815','2013-06-06','15:35:00',2.07),('5815','2013-06-06','15:40:00',2.06),('5815','2013-06-06','15:45:00',2.06),('5815','2013-06-06','15:50:00',1.99),('5815','2013-06-06','15:55:00',1.94),('5815','2013-06-06','16:00:00',1.92),('5815','2013-06-06','16:05:00',1.87),('5815','2013-06-06','16:10:00',1.84),('5815','2013-06-06','16:15:00',1.79),('5815','2013-06-06','16:20:00',1.74),('5815','2013-06-06','16:25:00',1.72),('5815','2013-06-06','16:30:00',1.67),('5815','2013-06-06','16:35:00',1.62),('5815','2013-06-06','16:40:00',1.61),('5815','2013-06-06','16:45:00',1.57),('5815','2013-06-06','16:50:00',1.53),('5815','2013-06-06','16:55:00',1.48),('5815','2013-06-06','17:00:00',1.41),('5815','2013-06-06','17:05:00',1.36),('5815','2013-06-06','17:10:00',1.34),('5815','2013-06-06','17:15:00',1.3),('5815','2013-06-06','17:20:00',1.25),('5815','2013-06-06','17:25:00',1.21),('5815','2013-06-06','17:30:00',1.1),('5815','2013-06-06','17:35:00',1.01),('5815','2013-06-06','17:40:00',1.09),('5815','2013-06-06','17:45:00',1.08),('5815','2013-06-06','17:50:00',1.03),('5815','2013-06-05','08:30:00',1.01),('5815','2013-06-05','08:35:00',1.06),('5815','2013-06-05','08:40:00',1.09),('5815','2013-06-05','08:45:00',1.13),('5815','2013-06-05','08:50:00',1.18),('5815','2013-06-05','08:55:00',1.24),('5815','2013-06-05','09:00:00',1.28),('5815','2013-06-05','09:05:00',1.32),('5815','2013-06-05','09:10:00',1.38),('5815','2013-06-05','09:15:00',1.42),('5815','2013-06-05','09:20:00',1.45),('5815','2013-06-05','09:25:00',1.51),('5815','2013-06-05','09:30:00',1.53),('5815','2013-06-05','09:35:00',1.59),('5815','2013-06-05','09:40:00',1.65),('5815','2013-06-05','09:45:00',1.69),('5815','2013-06-05','09:50:00',1.71),('5815','2013-06-05','09:55:00',1.71),('5815','2013-06-05','10:00:00',1.77),('5815','2013-06-05','10:05:00',1.82),('5815','2013-06-05','10:10:00',1.85),('5815','2013-06-05','10:15:00',1.89),('5815','2013-06-05','10:20:00',1.94),('5815','2013-06-05','10:25:00',1.97),('5815','2013-06-05','10:30:00',1.98),('5815','2013-06-05','10:35:00',1.99),('5815','2013-06-05','10:40:00',2),('5815','2013-06-05','10:45:00',2.07),('5815','2013-06-05','10:50:00',2.08),('5815','2013-06-05','10:55:00',2.08),('5815','2013-06-05','11:00:00',2.04),('5815','2013-06-05','11:05:00',2.08),('5815','2013-06-05','11:10:00',2.1),('5815','2013-06-05','11:15:00',2.13),('5815','2013-06-05','11:20:00',2.12),('5815','2013-06-05','11:25:00',2.15),('5815','2013-06-05','11:30:00',2.16),('5815','2013-06-05','11:35:00',2.17),('5815','2013-06-05','11:40:00',2.18),('5815','2013-06-05','11:45:00',2.11),('5815','2013-06-05','11:50:00',2.13),('5815','2013-06-05','11:55:00',2.17),('5815','2013-06-05','12:00:00',2.19),('5815','2013-06-05','12:05:00',2.26),('5815','2013-06-05','12:10:00',2.29),('5815','2013-06-05','12:15:00',2.29),('5815','2013-06-05','12:20:00',2.29),('5815','2013-06-05','12:25:00',2.33),('5815','2013-06-05','12:30:00',2.3),('5815','2013-06-05','12:35:00',2.28),('5815','2013-06-05','12:40:00',2.33),('5815','2013-06-05','12:45:00',2.34),('5815','2013-06-05','12:50:00',2.34),('5815','2013-06-05','12:55:00',2.35),('5815','2013-06-05','13:00:00',2.36),('5815','2013-06-05','13:05:00',2.38),('5815','2013-06-05','13:10:00',2.38),('5815','2013-06-05','13:15:00',2.41),('5815','2013-06-05','13:20:00',2.45),('5815','2013-06-05','13:25:00',2.41),('5815','2013-06-05','13:30:00',2.44),('5815','2013-06-05','13:35:00',2.39),('5815','2013-06-05','13:40:00',2.4),('5815','2013-06-05','13:45:00',2.39),('5815','2013-06-05','13:50:00',2.35),('5815','2013-06-05','13:55:00',2.35),('5815','2013-06-05','14:00:00',2.39),('5815','2013-06-05','14:05:00',2.4),('5815','2013-06-05','14:10:00',2.39),('5815','2013-06-05','14:15:00',2.09),('5815','2013-06-05','14:20:00',2.26),('5815','2013-06-05','14:25:00',2.02),('5815','2013-06-05','14:30:00',2.3),('5815','2013-06-05','14:35:00',2.31),('5815','2013-06-05','14:40:00',2.36),('5815','2013-06-05','14:45:00',1.66),('5815','2013-06-05','14:50:00',1.83),('5815','2013-06-05','14:55:00',2.51),('5815','2013-06-05','15:00:00',2.38),('5815','2013-06-05','15:05:00',2.26),('5815','2013-06-05','15:10:00',2.19),('5815','2013-06-05','15:15:00',2.03),('5815','2013-06-05','15:20:00',2.19),('5815','2013-06-05','15:25:00',2.14),('5815','2013-06-05','15:30:00',2.06),('5815','2013-06-05','15:35:00',2.02),('5815','2013-06-05','15:40:00',2.09),('5815','2013-06-05','15:45:00',2.08),('5815','2013-06-05','15:50:00',1.99),('5815','2013-06-05','15:55:00',1.85),('5815','2013-06-05','16:00:00',1.9),('5815','2013-06-05','16:05:00',1.9),('5815','2013-06-05','16:10:00',1.77),('5815','2013-06-05','16:15:00',1.75),('5815','2013-06-05','16:20:00',1.68),('5815','2013-06-05','16:25:00',1.67),('5815','2013-06-05','16:30:00',1.61),('5815','2013-06-05','16:35:00',1.57),('5815','2013-06-05','16:40:00',1.64),('5815','2013-06-05','16:45:00',1.54),('5815','2013-06-05','16:50:00',1.5),('5815','2013-06-05','16:55:00',1.44),('5815','2013-06-05','17:00:00',1.4),('5815','2013-06-05','17:05:00',1.31),('5815','2013-06-05','17:10:00',1.31),('5815','2013-06-05','17:15:00',1.26),('5815','2013-06-05','17:20:00',1.24),('5815','2013-06-05','17:25:00',1.18),('5815','2013-06-05','17:30:00',1.08),('5815','2013-06-05','17:40:00',1.04),('5815','2013-06-04','08:30:00',1),('5815','2013-06-04','08:35:00',1.05),('5815','2013-06-04','08:40:00',1.1),('5815','2013-06-04','08:45:00',1.16),('5815','2013-06-04','08:50:00',1.19),('5815','2013-06-04','08:55:00',1.27),('5815','2013-06-04','09:00:00',1.27),('5815','2013-06-04','09:05:00',1.35),('5815','2013-06-04','09:10:00',1.39),('5815','2013-06-04','09:15:00',1.46),('5815','2013-06-04','09:20:00',1.6),('5815','2013-06-04','09:25:00',1.52),('5815','2013-06-04','09:30:00',1.66),('5815','2013-06-04','09:35:00',1.77),('5815','2013-06-04','09:40:00',1.88),('5815','2013-06-04','09:45:00',1.73),('5815','2013-06-04','09:50:00',1.65),('5815','2013-06-04','09:55:00',1.05),('5815','2013-06-04','10:00:00',1.03),('5815','2013-06-04','10:05:00',2.02),('5815','2013-06-04','10:25:00',1.55),('5815','2013-06-04','10:35:00',1.89),('5815','2013-06-04','10:40:00',1.48),('5815','2013-06-04','10:45:00',1.88),('5815','2013-06-04','10:50:00',1.98),('5815','2013-06-04','10:55:00',2.24),('5815','2013-06-04','11:00:00',2.23),('5815','2013-06-04','11:05:00',2.31),('5815','2013-06-04','11:35:00',1.02),('5815','2013-06-04','11:40:00',1.24),('5815','2013-06-04','11:45:00',2.37),('5815','2013-06-04','11:50:00',1.8),('5815','2013-06-04','11:55:00',1.94),('5815','2013-06-04','12:05:00',1.59),('5815','2013-06-04','12:10:00',2.64),('5815','2013-06-04','12:15:00',1.34),('5815','2013-06-04','12:20:00',2.51),('5815','2013-06-04','12:25:00',2.79),('5815','2013-06-04','12:30:00',2.67),('5815','2013-06-04','12:35:00',2.15),('5815','2013-06-04','12:40:00',2.16),('5815','2013-06-04','12:45:00',1.91),('5815','2013-06-04','12:50:00',1.98),('5815','2013-06-04','13:00:00',1.15),('5815','2013-06-04','13:05:00',1.82),('5815','2013-06-04','13:10:00',1.39),('5815','2013-06-04','13:15:00',1.2),('5815','2013-06-04','13:20:00',1.55),('5815','2013-06-04','13:25:00',2.31),('5815','2013-06-04','13:30:00',1.77),('5815','2013-06-04','13:35:00',2.84),('5815','2013-06-04','13:40:00',2.72),('5815','2013-06-04','13:45:00',2.64),('5815','2013-06-04','13:50:00',2.54),('5815','2013-06-04','13:55:00',2.52),('5815','2013-06-04','14:00:00',2.49),('5815','2013-06-04','14:05:00',2.49),('5815','2013-06-04','14:10:00',2.45),('5815','2013-06-04','14:15:00',2.44),('5815','2013-06-04','14:20:00',2.42),('5815','2013-06-04','14:25:00',2.39),('5815','2013-06-04','14:30:00',2.37),('5815','2013-06-04','14:35:00',2.33),('5815','2013-06-04','14:40:00',2.34),('5815','2013-06-04','14:45:00',2.37),('5815','2013-06-04','14:50:00',2.34),('5815','2013-06-04','14:55:00',2.34),('5815','2013-06-04','15:00:00',2.28),('5815','2013-06-04','15:05:00',2.21),('5815','2013-06-04','15:10:00',2.21),('5815','2013-06-04','15:15:00',2.21),('5815','2013-06-04','15:20:00',2.11),('5815','2013-06-04','15:25:00',2.2),('5815','2013-06-04','15:30:00',2.17),('5815','2013-06-04','15:35:00',2.04),('5815','2013-06-04','15:40:00',2.16),('5815','2013-06-04','15:45:00',2.1),('5815','2013-06-04','15:50:00',2.08),('5815','2013-06-04','15:55:00',2.03),('5815','2013-06-04','16:00:00',2),('5815','2013-06-04','16:05:00',1.98),('5815','2013-06-04','16:10:00',1.91),('5815','2013-06-04','16:15:00',1.89),('5815','2013-06-04','16:20:00',1.85),('5815','2013-06-04','16:25:00',1.8),('5815','2013-06-04','16:30:00',1.75),('5815','2013-06-04','16:35:00',1.72),('5815','2013-06-04','16:40:00',1.67),('5815','2013-06-04','16:45:00',1.62),('5815','2013-06-04','16:50:00',1.6),('5815','2013-06-04','16:55:00',1.55),('5815','2013-06-04','17:00:00',1.51),('5815','2013-06-04','17:05:00',1.41),('5815','2013-06-04','17:10:00',1.18),('5815','2013-06-04','17:15:00',1.04),('5815','2013-06-04','17:25:00',1.1),('5815','2013-06-04','17:30:00',1.22),('5815','2013-06-04','17:35:00',1.02),('5815','2013-06-04','17:40:00',1.02),('5815','2013-06-04','17:45:00',1.05),('5815','2013-06-03','08:10:00',1.04),('5815','2013-06-03','08:15:00',1.08),('5815','2013-06-03','08:20:00',1.11),('5815','2013-06-03','08:25:00',1),('5815','2013-06-03','08:35:00',1.28),('5815','2013-06-03','08:40:00',1.22),('5815','2013-06-03','08:45:00',1.05),('5815','2013-06-03','09:05:00',1.01),('5815','2013-06-03','09:10:00',1.21),('5815','2013-06-03','09:15:00',1.49),('5815','2013-06-03','09:20:00',1.48),('5815','2013-06-03','09:25:00',1.96),('5815','2013-06-03','09:30:00',1.64),('5815','2013-06-03','09:35:00',1.51),('5815','2013-06-03','09:45:00',1),('5815','2013-06-03','10:00:00',1.11),('5815','2013-06-03','10:05:00',1.18),('5815','2013-06-03','10:10:00',1.81),('5815','2013-06-03','10:15:00',1.64),('5815','2013-06-03','10:20:00',1.06),('5815','2013-06-03','10:40:00',1),('5815','2013-06-03','10:45:00',1.16),('5815','2013-06-03','10:50:00',1.57),('5815','2013-06-03','10:55:00',1.9),('5815','2013-06-03','11:00:00',1.28),('5815','2013-06-03','11:05:00',1.5),('5815','2013-06-03','11:10:00',1.76),('5815','2013-06-03','11:15:00',1.74),('5815','2013-06-03','11:20:00',1.25),('5815','2013-06-03','11:25:00',1.63),('5815','2013-06-03','11:30:00',1.94),('5815','2013-06-03','11:35:00',1.61),('5815','2013-06-03','11:40:00',1.72),('5815','2013-06-03','11:45:00',2.26),('5815','2013-06-03','11:50:00',2.49),('5815','2013-06-03','11:55:00',2.21),('5815','2013-06-03','12:00:00',1.84),('5815','2013-06-03','12:05:00',1.66),('5815','2013-06-03','12:10:00',1.35),('5815','2013-06-03','12:15:00',1.44),('5815','2013-06-03','12:20:00',1.06),('5815','2013-06-03','12:25:00',1.16),('5815','2013-06-03','12:30:00',1.6),('5815','2013-06-03','12:35:00',2.2),('5815','2013-06-03','12:40:00',1.44),('5815','2013-06-03','12:45:00',1.65),('5815','2013-06-03','12:50:00',1.41),('5815','2013-06-03','12:55:00',1.03),('5815','2013-06-03','13:00:00',1.2),('5815','2013-06-03','13:30:00',1.03),('5815','2013-06-03','13:35:00',2.36),('5815','2013-06-03','13:40:00',2.12),('5815','2013-06-03','13:45:00',2.94),('5815','2013-06-03','13:50:00',2.91),('5815','2013-06-03','13:55:00',1.56),('5815','2013-06-03','14:00:00',1.06),('5815','2013-06-03','14:05:00',2.33),('5815','2013-06-03','14:10:00',2.86),('5815','2013-06-03','14:15:00',2.58),('5815','2013-06-03','14:20:00',1.97),('5815','2013-06-03','14:25:00',1.43),('5815','2013-06-03','14:35:00',1.05),('5815','2013-06-03','14:40:00',1.42),('5815','2013-06-03','14:55:00',1.94),('5815','2013-06-03','15:00:00',2.95),('5815','2013-06-03','15:05:00',2.87),('5815','2013-06-03','15:10:00',1.46),('5815','2013-06-02','08:30:00',1.01),('5815','2013-06-02','08:35:00',1.07),('5815','2013-06-02','08:40:00',1.11),('5815','2013-06-02','08:45:00',1.17),('5815','2013-06-02','08:50:00',1.2),('5815','2013-06-02','08:55:00',1.21),('5815','2013-06-02','09:00:00',1.29),('5815','2013-06-02','09:05:00',1.37),('5815','2013-06-02','09:10:00',1.45),('5815','2013-06-02','09:15:00',1.56),('5815','2013-06-02','09:20:00',1.32),('5815','2013-06-02','09:25:00',1.45),('5815','2013-06-02','09:30:00',1.41),('5815','2013-06-02','09:35:00',1.02),('5815','2013-06-02','09:40:00',1.16),('5815','2013-06-02','09:45:00',1.35),('5815','2013-06-02','09:50:00',1.96),('5815','2013-06-02','09:55:00',2.08),('5815','2013-06-02','10:00:00',2.24),('5815','2013-06-02','10:05:00',2.29),('5815','2013-06-02','10:10:00',1.94),('5815','2013-06-02','10:15:00',1.34),('5815','2013-06-02','10:50:00',1.87),('5815','2013-06-02','10:55:00',2.68),('5815','2013-06-02','11:00:00',1.3),('5815','2013-06-02','11:45:00',1.44),('5815','2013-06-02','12:05:00',2.16),('5815','2013-06-02','12:40:00',2.37),('5815','2013-06-02','12:45:00',1.41),('5815','2013-06-02','12:50:00',1.57),('5815','2013-06-02','12:55:00',1.52),('5815','2013-06-02','13:00:00',1.15),('5815','2013-06-02','13:05:00',1.01),('5815','2013-06-02','13:10:00',1.06),('5815','2013-06-02','13:15:00',1.4),('5815','2013-06-02','13:20:00',2.66),('5815','2013-06-02','13:25:00',1.9),('5815','2013-06-02','13:30:00',2.13),('5815','2013-06-02','13:35:00',2.42),('5815','2013-06-02','13:40:00',2.75),('5815','2013-06-02','13:45:00',1.35),('5815','2013-06-02','13:50:00',2.93),('5815','2013-06-02','13:55:00',1.81),('5815','2013-06-02','14:00:00',2.52),('5815','2013-06-02','14:05:00',2.57),('5815','2013-06-02','14:10:00',1.38),('5815','2013-06-02','14:15:00',1.37),('5815','2013-06-02','14:20:00',1.1),('5815','2013-06-02','14:25:00',1.76),('5815','2013-06-02','14:30:00',2.67),('5815','2013-06-02','14:35:00',2.77),('5815','2013-06-02','14:40:00',2.08),('5815','2013-06-02','14:45:00',2.15),('5815','2013-06-02','14:50:00',2),('5815','2013-06-02','14:55:00',2.11),('5815','2013-06-02','15:00:00',2.14),('5815','2013-06-02','15:05:00',1.85),('5815','2013-06-02','15:10:00',2.24),('5815','2013-06-02','15:15:00',1.4),('5815','2013-06-02','15:20:00',1.91),('5815','2013-06-02','15:25:00',2.25),('5815','2013-06-02','15:30:00',2.19),('5815','2013-06-02','15:35:00',2.17),('5815','2013-06-02','15:40:00',2.18),('5815','2013-06-02','15:45:00',2.15),('5815','2013-06-02','15:50:00',2.09),('5815','2013-06-02','15:55:00',2.03),('5815','2013-06-02','16:00:00',2.02),('5815','2013-06-02','16:05:00',1.98),('5815','2013-06-02','16:10:00',1.95),('5815','2013-06-02','16:15:00',1.85),('5815','2013-06-02','16:20:00',1.82),('5815','2013-06-02','16:25:00',1.81),('5815','2013-06-02','16:30:00',1.86),('5815','2013-06-02','16:35:00',1.74),('5815','2013-06-02','16:40:00',1.73),('5815','2013-06-02','16:45:00',1.48),('5815','2013-06-02','16:50:00',1.13),('5815','2013-06-02','16:55:00',1.03),('5815','2013-06-02','17:00:00',1.32),('5815','2013-06-02','17:05:00',1.49),('5815','2013-06-02','17:10:00',1.65),('5815','2013-06-02','17:15:00',1.39),('5815','2013-06-02','17:20:00',1.18),('5815','2013-06-01','09:25:00',1.78),('5815','2013-06-01','09:30:00',1.71),('5815','2013-06-01','09:35:00',1.7),('5815','2013-06-01','09:40:00',1.71),('5815','2013-06-01','09:45:00',1.73),('5815','2013-06-01','09:50:00',1.77),('5815','2013-06-01','09:55:00',1.81),('5815','2013-06-01','10:00:00',1.82),('5815','2013-06-01','10:05:00',1.9),('5815','2013-06-01','10:10:00',1.94),('5815','2013-06-01','10:15:00',1.96),('5815','2013-06-01','10:20:00',2),('5815','2013-06-01','10:25:00',2.05),('5815','2013-06-01','10:30:00',2.11),('5815','2013-06-01','10:35:00',2.23),('5815','2013-06-01','10:40:00',2.28),('5815','2013-06-01','10:45:00',1.91),('5815','2013-06-01','11:00:00',2.25),('5815','2013-06-01','11:05:00',2.13),('5815','2013-06-01','11:10:00',2.29),('5815','2013-06-01','11:15:00',1.81),('5815','2013-06-01','11:20:00',2.06),('5815','2013-06-01','11:25:00',1.31),('5815','2013-06-01','11:30:00',2.37),('5815','2013-06-01','11:35:00',1.37),('5815','2013-06-01','11:50:00',1.02),('5815','2013-06-01','11:55:00',2.69),('5815','2013-06-01','12:00:00',2.32),('5815','2013-06-01','12:05:00',1.51),('5815','2013-06-01','12:10:00',2.12),('5815','2013-06-01','12:15:00',2.64),('5815','2013-06-01','12:20:00',1.45),('5815','2013-06-01','12:25:00',1.32),('5815','2013-06-01','12:30:00',2.12),('5815','2013-06-01','12:35:00',2.79),('5815','2013-06-01','12:40:00',1.86),('5815','2013-06-01','12:45:00',2.39),('5815','2013-06-01','12:50:00',1.34),('5815','2013-06-01','13:00:00',1.62),('5815','2013-06-01','13:05:00',1.49),('5815','2013-06-01','13:15:00',2.87),('5815','2013-06-01','13:20:00',2.64),('5815','2013-06-01','13:25:00',2.53),('5815','2013-06-01','13:30:00',2.51),('5815','2013-06-01','13:35:00',2.5),('5815','2013-06-01','13:40:00',2.48),('5815','2013-06-01','13:45:00',2.45),('5815','2013-06-01','13:50:00',2.44),('5815','2013-06-01','13:55:00',2.44),('5815','2013-06-01','14:00:00',2.46),('5815','2013-06-01','14:05:00',2.48),('5815','2013-06-01','14:10:00',2.47),('5815','2013-06-01','14:15:00',2.45),('5815','2013-06-01','14:20:00',2.36),('5815','2013-06-01','14:25:00',2.39),('5815','2013-06-01','14:30:00',2.4),('5815','2013-06-01','14:35:00',2.36),('5815','2013-06-01','14:40:00',2.35),('5815','2013-06-01','14:45:00',2.34),('5815','2013-06-01','14:50:00',2.29),('5815','2013-06-01','14:55:00',2.3),('5815','2013-06-01','15:00:00',2.28),('5815','2013-06-01','15:05:00',2.24),('5815','2013-06-01','15:10:00',2.21),('5815','2013-06-01','15:15:00',2.23),('5815','2013-06-01','15:20:00',2.22),('5815','2013-06-01','15:25:00',2),('5815','2013-06-01','15:30:00',1.94),('5815','2013-06-01','15:35:00',1.95),('5815','2013-06-01','15:40:00',1.64),('5815','2013-06-01','15:45:00',1.8),('5815','2013-06-01','15:50:00',2.12),('5815','2013-06-01','15:55:00',1.85),('5815','2013-06-01','16:00:00',1.76),('5815','2013-06-01','16:05:00',1.97),('5815','2013-06-01','16:10:00',1.95),('5815','2013-06-01','16:15:00',2),('5815','2013-06-01','16:20:00',1.84),('5815','2013-06-01','16:25:00',1.88),('5815','2013-06-01','16:30:00',1.8),('5815','2013-06-01','16:35:00',1.74),('5815','2013-06-01','16:40:00',1.71),('5815','2013-06-01','16:45:00',1.57),('5815','2013-06-01','16:50:00',1.55),('5815','2013-06-01','16:55:00',1.59),('5815','2013-06-01','17:00:00',1.43),('5815','2013-06-01','17:05:00',1.23),('5815','2013-06-01','17:10:00',1.46),('5815','2013-06-01','17:15:00',1.21),('5815','2013-06-01','17:20:00',1.33),('5815','2013-06-01','17:25:00',1.26),('5815','2013-06-01','17:30:00',1.19),('5815','2013-06-01','17:35:00',1.03),('5815','2013-05-31','10:50:00',1.06),('5815','2013-05-31','10:55:00',1.22),('5815','2013-05-31','11:55:00',1.04),('5815','2013-05-31','12:00:00',1.16),('5815','2013-05-31','12:05:00',1.65),('5815','2013-05-31','12:10:00',1.71),('5815','2013-05-31','12:50:00',1.06),('5815','2013-05-31','12:55:00',1.01),('5815','2013-05-31','13:00:00',1.19),('5815','2013-05-31','13:05:00',1.3),('5815','2013-05-31','13:10:00',1.36),('5815','2013-05-31','13:15:00',1.47),('5815','2013-05-31','13:20:00',1.33),('5815','2013-05-31','13:25:00',1.01),('5815','2013-05-31','14:00:00',1.1),('5815','2013-05-31','14:05:00',1.37),('5815','2013-05-31','14:10:00',1.34),('5815','2013-05-31','14:15:00',1.4),('5815','2013-05-31','14:20:00',1.57),('5815','2013-05-30','08:30:00',1.12),('5815','2013-05-30','08:40:00',1.34),('5815','2013-05-30','08:45:00',1.35),('5815','2013-05-30','08:50:00',1.55),('5815','2013-05-30','09:15:00',1),('5815','2013-05-30','09:35:00',1.07),('5815','2013-05-30','09:40:00',1),('5815','2013-05-30','09:45:00',1.98),('5815','2013-05-30','09:50:00',1.98),('5815','2013-05-30','09:55:00',2.06),('5815','2013-05-30','10:00:00',1.99),('5815','2013-05-30','10:05:00',1.84),('5815','2013-05-30','10:10:00',1.38),('5815','2013-05-30','10:15:00',1.25),('5815','2013-05-30','10:20:00',1.79),('5815','2013-05-30','10:35:00',1.22),('5815','2013-05-30','10:40:00',1.83),('5815','2013-05-30','10:45:00',2.6),('5815','2013-05-30','10:50:00',1.56),('5815','2013-05-30','10:55:00',1.77),('5815','2013-05-30','11:05:00',1.14),('5815','2013-05-30','11:10:00',2.27),('5815','2013-05-30','11:15:00',2.23),('5815','2013-05-30','11:20:00',1.03),('5815','2013-05-30','11:25:00',1.7),('5815','2013-05-30','11:30:00',2.68),('5815','2013-05-30','11:35:00',1.04),('5815','2013-05-30','11:45:00',1.99),('5815','2013-05-30','11:50:00',2.15),('5815','2013-05-30','11:55:00',1.45),('5815','2013-05-30','12:00:00',1.81),('5815','2013-05-30','12:05:00',2.53),('5815','2013-05-30','12:10:00',2.1),('5815','2013-05-30','12:25:00',2.08),('5815','2013-05-30','12:30:00',1.05),('5815','2013-05-30','12:40:00',2.55),('5815','2013-05-30','12:45:00',1.53),('5815','2013-05-30','13:00:00',2.58),('5815','2013-05-30','13:05:00',1.35),('5815','2013-05-30','13:25:00',1.08),('5815','2013-05-30','13:30:00',1.85),('5815','2013-05-30','13:35:00',2.68),('5815','2013-05-30','13:40:00',1.66),('5815','2013-05-30','14:00:00',1.52),('5815','2013-05-30','15:15:00',1.42),('5815','2013-05-30','15:20:00',2.59),('5815','2013-05-30','15:25:00',2.02),('5815','2013-05-30','15:30:00',1.67),('5815','2013-05-30','15:35:00',1.23),('5815','2013-05-30','15:40:00',1.02),('5815','2013-05-30','15:50:00',1.28),('5815','2013-05-30','15:55:00',1.25),('5815','2013-05-29','08:40:00',1.15),('5815','2013-05-29','08:45:00',1.25),('5815','2013-05-29','08:50:00',1.28),('5815','2013-05-29','08:55:00',1.33),('5815','2013-05-29','09:00:00',1.39),('5815','2013-05-29','09:05:00',1.44),('5815','2013-05-29','09:10:00',1.5),('5815','2013-05-29','09:15:00',1.52),('5815','2013-05-29','09:20:00',1.61),('5815','2013-05-29','09:25:00',1.72),('5815','2013-05-29','09:30:00',1.79),('5815','2013-05-29','09:35:00',1.76),('5815','2013-05-29','09:40:00',1.84),('5815','2013-05-29','09:45:00',1.72),('5815','2013-05-29','09:50:00',2.05),('5815','2013-05-29','09:55:00',1.59),('5815','2013-05-29','10:10:00',2.18),('5815','2013-05-29','10:20:00',2.07),('5815','2013-05-29','10:45:00',2.14),('5815','2013-05-29','10:50:00',2.52),('5815','2013-05-29','10:55:00',2.43),('5815','2013-05-29','11:00:00',2.32),('5815','2013-05-29','11:05:00',2.19),('5815','2013-05-29','11:10:00',1.23),('5815','2013-05-29','11:20:00',2.61),('5815','2013-05-29','11:25:00',1.5),('5815','2013-05-29','11:30:00',1.46),('5815','2013-05-29','11:35:00',2.39),('5815','2013-05-29','11:40:00',2.76),('5815','2013-05-29','11:45:00',1.86),('5815','2013-05-29','11:50:00',2.72),('5815','2013-05-29','12:00:00',1.44),('5815','2013-05-29','12:05:00',2.79),('5815','2013-05-29','12:10:00',2.5),('5815','2013-05-29','12:15:00',1.91),('5815','2013-05-29','12:20:00',2.76),('5815','2013-05-29','12:25:00',2.02),('5815','2013-05-29','12:30:00',2.32),('5815','2013-05-29','12:35:00',2.2),('5815','2013-05-29','12:40:00',2.23),('5815','2013-05-29','12:45:00',1.17),('5815','2013-05-29','12:50:00',2.12),('5815','2013-05-29','12:55:00',2.59),('5815','2013-05-29','13:00:00',2.18),('5815','2013-05-29','13:05:00',1.15),('5815','2013-05-29','13:10:00',1.14),('5815','2013-05-29','13:15:00',1.52),('5815','2013-05-29','13:20:00',1.2),('5815','2013-05-29','13:25:00',1.21),('5815','2013-05-29','13:30:00',1.53),('5815','2013-05-29','13:40:00',1.96),('5815','2013-05-29','13:45:00',2.02),('5815','2013-05-29','13:55:00',1.12),('5815','2013-05-29','14:00:00',2.56),('5815','2013-05-29','14:05:00',2.94),('5815','2013-05-29','14:10:00',2.21),('5815','2013-05-29','14:15:00',1.21),('5815','2013-05-29','14:20:00',2.58),('5815','2013-05-29','14:25:00',1.25),('5815','2013-05-29','14:30:00',2.7),('5815','2013-05-29','14:35:00',2.17),('5815','2013-05-29','14:40:00',2.61),('5815','2013-05-29','14:45:00',2.58),('5815','2013-05-29','14:50:00',2.63),('5815','2013-05-29','14:55:00',2.57),('5815','2013-05-29','15:00:00',2.53),('5815','2013-05-29','15:05:00',2.52),('5815','2013-05-29','15:15:00',2.35),('5815','2013-05-29','15:20:00',2.48),('5815','2013-05-29','15:25:00',2.42),('5815','2013-05-29','15:30:00',2.46),('5815','2013-05-29','15:35:00',2.56),('5815','2013-05-29','15:40:00',2.52),('5815','2013-05-29','15:45:00',1.98),('5815','2013-05-29','15:50:00',2.27),('5815','2013-05-29','15:55:00',1.66),('5815','2013-05-29','16:00:00',2.44),('5815','2013-05-29','16:05:00',1.99),('5815','2013-05-29','16:10:00',2.19),('5815','2013-05-29','16:15:00',2.08),('5815','2013-05-29','16:20:00',1.85),('5815','2013-05-29','16:25:00',1.51),('5815','2013-05-29','16:45:00',1.11),('5815','2013-05-29','16:50:00',1.38),('5815','2013-05-29','16:55:00',1.36),('5815','2013-05-29','17:05:00',1.12),('5815','2013-05-28','08:30:00',1.03),('5815','2013-05-28','08:35:00',1.09),('5815','2013-05-28','08:40:00',1.13),('5815','2013-05-28','08:45:00',1.19),('5815','2013-05-28','08:50:00',1.24),('5815','2013-05-28','08:55:00',1.3),('5815','2013-05-28','09:00:00',1.36),('5815','2013-05-28','09:05:00',1.4),('5815','2013-05-28','09:10:00',1.45),('5815','2013-05-28','09:15:00',1.5),('5815','2013-05-28','09:20:00',1.54),('5815','2013-05-28','09:25:00',1.55),('5815','2013-05-28','09:30:00',1.63),('5815','2013-05-28','09:35:00',1.67),('5815','2013-05-28','09:40:00',1.72),('5815','2013-05-28','09:45:00',1.77),('5815','2013-05-28','09:50:00',1.8),('5815','2013-05-28','09:55:00',1.85),('5815','2013-05-28','10:00:00',1.87),('5815','2013-05-28','10:05:00',1.92),('5815','2013-05-28','10:10:00',1.95),('5815','2013-05-28','10:15:00',1.97),('5815','2013-05-28','10:20:00',2.03),('5815','2013-05-28','10:25:00',2.08),('5815','2013-05-28','10:30:00',2.11),('5815','2013-05-28','10:35:00',2.15),('5815','2013-05-28','10:40:00',2.16),('5815','2013-05-28','10:45:00',2.22),('5815','2013-05-28','10:50:00',2.23),('5815','2013-05-28','10:55:00',2.22),('5815','2013-05-28','11:00:00',2.25),('5815','2013-05-28','11:05:00',2.3),('5815','2013-05-28','11:10:00',2.34),('5815','2013-05-28','11:15:00',1.87),('5815','2013-05-28','11:20:00',2.09),('5815','2013-05-28','11:25:00',1.4),('5815','2013-05-28','11:30:00',2.53),('5815','2013-05-28','11:35:00',2.49),('5815','2013-05-28','11:40:00',2.11),('5815','2013-05-28','11:45:00',2.29),('5815','2013-05-28','11:50:00',2.11),('5815','2013-05-28','11:55:00',2.07),('5815','2013-05-28','12:00:00',2.54),('5815','2013-05-28','12:05:00',2.07),('5815','2013-05-28','12:10:00',1.93),('5815','2013-05-28','12:15:00',2.04),('5815','2013-05-28','12:20:00',2.67),('5815','2013-05-28','12:25:00',2.46),('5815','2013-05-28','12:30:00',2.56),('5815','2013-05-28','12:35:00',2.57),('5815','2013-05-28','12:40:00',2.6),('5815','2013-05-28','12:45:00',2.45),('5815','2013-05-28','12:50:00',2.52),('5815','2013-05-28','12:55:00',2.54),('5815','2013-05-28','13:00:00',2.62),('5815','2013-05-28','13:05:00',2.69),('5815','2013-05-28','13:10:00',2.2),('5815','2013-05-28','13:15:00',2.71),('5815','2013-05-28','13:20:00',2.86),('5815','2013-05-28','13:25:00',2.86),('5815','2013-05-28','13:30:00',2.85),('5815','2013-05-28','13:35:00',2.39),('5815','2013-05-28','13:40:00',2.62),('5815','2013-05-28','13:45:00',2.52),('5815','2013-05-28','13:50:00',2.3),('5815','2013-05-28','13:55:00',2.15),('5815','2013-05-28','14:00:00',2.55),('5815','2013-05-28','14:05:00',2.57),('5815','2013-05-28','14:10:00',2.47),('5815','2013-05-28','14:15:00',2.53),('5815','2013-05-28','14:20:00',2.55),('5815','2013-05-28','14:25:00',2.16),('5815','2013-05-28','14:30:00',2.51),('5815','2013-05-28','14:35:00',2.04),('5815','2013-05-28','14:40:00',2.6),('5815','2013-05-28','14:45:00',2.55),('5815','2013-05-28','14:50:00',2.32),('5815','2013-05-28','14:55:00',2.44),('5815','2013-05-28','15:00:00',2.53),('5815','2013-05-28','15:05:00',2.56),('5815','2013-05-28','15:10:00',2.48),('5815','2013-05-28','15:15:00',1.57),('5815','2013-05-28','15:20:00',1.78),('5815','2013-05-28','15:25:00',1.53),('5815','2013-05-28','15:30:00',1.62),('5815','2013-05-28','15:35:00',1.79),('5815','2013-05-28','15:40:00',1.8),('5815','2013-05-28','15:45:00',1.72),('5815','2013-05-28','15:50:00',1.66),('5815','2013-05-28','15:55:00',1.71),('5815','2013-05-28','16:00:00',1.55),('5815','2013-05-28','16:05:00',1.52),('5815','2013-05-28','16:10:00',1.26),('5815','2013-05-28','16:15:00',1.18),('5815','2013-05-28','16:20:00',1.16),('5815','2013-05-28','16:25:00',1.22),('5815','2013-05-28','16:30:00',1.15),('5815','2013-05-28','16:35:00',1.05),('5815','2013-05-28','16:40:00',1.23),('5815','2013-05-28','16:45:00',1.05),('5815','2013-05-27','09:25:00',1.13),('5815','2013-05-27','09:30:00',1.22),('5815','2013-05-27','09:35:00',1.31),('5815','2013-05-27','09:40:00',1.24),('5815','2013-05-27','09:45:00',1.15),('5815','2013-05-27','09:50:00',1.18),('5815','2013-05-27','09:55:00',1.25),('5815','2013-05-27','10:00:00',1.17),('5815','2013-05-27','10:05:00',1.23),('5815','2013-05-27','10:10:00',1.38),('5815','2013-05-27','10:15:00',1.43),('5815','2013-05-27','10:20:00',1.52),('5815','2013-05-27','10:25:00',1.49),('5815','2013-05-27','10:30:00',1.64),('5815','2013-05-27','10:35:00',1.7),('5815','2013-05-27','10:40:00',1.53),('5815','2013-05-27','10:45:00',1.41),('5815','2013-05-27','10:50:00',1.55),('5815','2013-05-27','10:55:00',1.37),('5815','2013-05-27','11:00:00',1.35),('5815','2013-05-27','11:05:00',1.32),('5815','2013-05-27','11:10:00',1.47),('5815','2013-05-27','11:15:00',1.11),('5815','2013-05-27','11:20:00',1.25),('5815','2013-05-27','11:25:00',1.12),('5815','2013-05-27','11:30:00',1.96),('5815','2013-05-27','11:35:00',1.75),('5815','2013-05-27','11:40:00',1.95),('5815','2013-05-27','11:45:00',2.05),('5815','2013-05-27','12:05:00',1.01),('5815','2013-05-27','12:10:00',1.6),('5815','2013-05-27','12:15:00',1.53),('5815','2013-05-27','12:20:00',1.27),('5815','2013-05-27','12:25:00',1.32),('5815','2013-05-27','12:30:00',1.49),('5815','2013-05-27','12:35:00',1.45),('5815','2013-05-27','12:40:00',1.46),('5815','2013-05-27','12:45:00',1.67),('5815','2013-05-27','12:50:00',1.5),('5815','2013-05-27','12:55:00',1.5),('5815','2013-05-27','13:00:00',1.54),('5815','2013-05-27','13:05:00',1.65),('5815','2013-05-27','13:10:00',1.73),('5815','2013-05-27','13:15:00',1.53),('5815','2013-05-27','13:20:00',2.03),('5815','2013-05-27','13:25:00',1.07),('5815','2013-05-27','13:30:00',1.22),('5815','2013-05-27','13:35:00',1),('5815','2013-05-27','13:40:00',1.12),('5815','2013-05-27','13:45:00',1.05),('5815','2013-05-27','13:50:00',1.52),('5815','2013-05-27','13:55:00',1.6),('5815','2013-05-27','14:00:00',1.48),('5815','2013-05-27','14:05:00',1.53),('5815','2013-05-27','14:10:00',2.2),('5815','2013-05-27','14:15:00',2.32),('5815','2013-05-27','14:20:00',1.39),('5815','2013-05-27','14:25:00',1.61),('5815','2013-05-27','14:30:00',1.97),('5815','2013-05-27','14:35:00',1.68),('5815','2013-05-27','14:40:00',1.91),('5815','2013-05-27','14:45:00',2.21),('5815','2013-05-27','14:50:00',1.68),('5815','2013-05-27','14:55:00',1.52),('5815','2013-05-27','15:00:00',1.27),('5815','2013-05-27','15:05:00',2.13),('5815','2013-05-27','15:10:00',1.02),('5815','2013-05-27','15:15:00',1.44),('5815','2013-05-27','15:20:00',1.82),('5815','2013-05-27','15:25:00',1.23),('5815','2013-05-27','15:40:00',1.23),('5815','2013-05-27','15:45:00',2.18),('5815','2013-05-27','15:50:00',1.8),('5815','2013-05-27','15:55:00',1.43),('5815','2013-05-27','16:20:00',1.22),('5815','2013-05-27','16:25:00',1.21),('5815','2013-05-27','16:30:00',1.22),('5815','2013-05-27','16:35:00',1.7),('5815','2013-05-27','16:40:00',1.57),('5815','2013-05-27','16:45:00',1.52),('5815','2013-05-27','16:50:00',1.47),('5815','2013-05-27','16:55:00',1.43),('5815','2013-05-27','17:00:00',1.4),('5815','2013-05-27','17:05:00',1.35),('5815','2013-05-27','17:10:00',1.3),('5815','2013-05-27','17:15:00',1.28),('5815','2013-05-27','17:20:00',1.22),('5815','2013-05-27','17:25:00',1.15),('5815','2013-05-27','17:30:00',1.06),('5815','2013-05-27','17:35:00',1.04),('5815','2013-05-26','08:25:00',1.01),('5815','2013-05-26','08:30:00',1.06),('5815','2013-05-26','08:35:00',1.11),('5815','2013-05-26','08:40:00',1.17),('5815','2013-05-26','08:45:00',1.32),('5815','2013-05-26','08:50:00',1.44),('5815','2013-05-26','09:00:00',1.3),('5815','2013-05-26','09:05:00',1.63),('5815','2013-05-26','09:10:00',1.51),('5815','2013-05-26','09:20:00',1.36),('5815','2013-05-26','09:25:00',1.55),('5815','2013-05-26','09:30:00',1.75),('5815','2013-05-26','09:35:00',1.76),('5815','2013-05-26','09:40:00',1.78),('5815','2013-05-26','09:45:00',1.85),('5815','2013-05-26','09:50:00',1.24),('5815','2013-05-26','09:55:00',1.42),('5815','2013-05-26','10:00:00',2.06),('5815','2013-05-26','10:05:00',1.81),('5815','2013-05-26','10:10:00',2.04),('5815','2013-05-26','10:15:00',2.15),('5815','2013-05-26','10:20:00',1.88),('5815','2013-05-26','10:25:00',1.39),('5815','2013-05-26','10:30:00',1.33),('5815','2013-05-26','10:45:00',1.74),('5815','2013-05-26','10:50:00',1.63),('5815','2013-05-26','10:55:00',1.43),('5815','2013-05-26','11:00:00',1.8),('5815','2013-05-26','11:05:00',1.8),('5815','2013-05-26','11:10:00',1.86),('5815','2013-05-26','11:15:00',1.13),('5815','2013-05-26','11:20:00',1.88),('5815','2013-05-26','11:25:00',2.59),('5815','2013-05-26','11:30:00',1.91),('5815','2013-05-26','11:35:00',2.27),('5815','2013-05-26','11:40:00',1.41),('5815','2013-05-26','11:45:00',2.8),('5815','2013-05-26','11:50:00',1.3),('5815','2013-05-26','11:55:00',1.1),('5815','2013-05-26','12:00:00',2.57),('5815','2013-05-26','12:05:00',2.42),('5815','2013-05-26','12:10:00',1.53),('5815','2013-05-26','12:15:00',2.39),('5815','2013-05-26','12:20:00',1.79),('5815','2013-05-26','12:25:00',2.07),('5815','2013-05-26','12:30:00',2.03),('5815','2013-05-26','12:35:00',1.43),('5815','2013-05-26','12:40:00',1.96),('5815','2013-05-26','12:45:00',2.93),('5815','2013-05-26','12:50:00',2.75),('5815','2013-05-26','12:55:00',2.63),('5815','2013-05-26','13:00:00',1.66),('5815','2013-05-26','13:05:00',2.38),('5815','2013-05-26','13:10:00',2.69),('5815','2013-05-26','13:15:00',2.42),('5815','2013-05-26','13:20:00',2.66),('5815','2013-05-26','13:25:00',2.12),('5815','2013-05-26','13:30:00',2.71),('5815','2013-05-26','13:35:00',2.38),('5815','2013-05-26','13:40:00',2.56),('5815','2013-05-26','13:45:00',2.81),('5815','2013-05-26','13:50:00',2.36),('5815','2013-05-26','13:55:00',1.74),('5815','2013-05-26','14:00:00',2.65),('5815','2013-05-26','14:05:00',2.64),('5815','2013-05-26','14:10:00',2.55),('5815','2013-05-26','14:15:00',2.35),('5815','2013-05-26','14:20:00',2.36),('5815','2013-05-26','14:25:00',2.16),('5815','2013-05-26','14:30:00',2.3),('5815','2013-05-26','14:35:00',2.56),('5815','2013-05-26','14:45:00',2.61),('5815','2013-05-26','14:50:00',2.61),('5815','2013-05-26','14:55:00',2.13),('5815','2013-05-26','15:00:00',1.64),('5815','2013-05-26','15:05:00',1.55),('5815','2013-05-26','15:10:00',2.46),('5815','2013-05-26','15:15:00',1.69),('5815','2013-05-26','15:20:00',1.96),('5815','2013-05-26','15:25:00',1.93),('5815','2013-05-26','15:30:00',2.11),('5815','2013-05-26','15:35:00',2.38),('5815','2013-05-26','15:40:00',1.9),('5815','2013-05-26','15:45:00',1.75),('5815','2013-05-26','15:50:00',2.19),('5815','2013-05-26','15:55:00',1.46),('5815','2013-05-26','16:00:00',1.78),('5815','2013-05-26','16:05:00',1.3),('5815','2013-05-26','16:10:00',1.52),('5815','2013-05-26','16:15:00',1.35),('5815','2013-05-26','16:20:00',2.08),('5815','2013-05-26','16:25:00',1.96),('5815','2013-05-26','16:30:00',1.84),('5815','2013-05-26','16:35:00',1.71),('5815','2013-05-26','17:10:00',1.01),('5815','2013-05-25','08:05:00',1.01),('5815','2013-05-25','08:10:00',1.02),('5815','2013-05-25','08:30:00',1.13),('5815','2013-05-25','08:35:00',1.22),('5815','2013-05-25','08:40:00',1.2),('5815','2013-05-25','08:45:00',1.11),('5815','2013-05-25','08:50:00',1.27),('5815','2013-05-25','09:00:00',1.39),('5815','2013-05-25','09:15:00',1.48),('5815','2013-05-25','09:45:00',1.15),('5815','2013-05-25','10:05:00',1.68),('5815','2013-05-25','10:10:00',2.25),('5815','2013-05-25','10:15:00',1.65),('5815','2013-05-25','10:20:00',2.02),('5815','2013-05-25','10:25:00',1.65),('5815','2013-05-25','10:30:00',1.96),('5815','2013-05-25','10:35:00',1.88),('5815','2013-05-25','10:40:00',2.3),('5815','2013-05-25','10:45:00',2.32),('5815','2013-05-25','10:50:00',2.34),('5815','2013-05-25','10:55:00',2.13),('5815','2013-05-25','11:00:00',2.25),('5815','2013-05-25','11:05:00',2.39),('5815','2013-05-25','11:10:00',2.4),('5815','2013-05-25','11:15:00',2.41),('5815','2013-05-25','11:20:00',2.44),('5815','2013-05-25','11:25:00',2.47),('5815','2013-05-25','11:30:00',2.44),('5815','2013-05-25','11:35:00',2.53),('5815','2013-05-25','11:40:00',2.57),('5815','2013-05-25','11:45:00',2.6),('5815','2013-05-25','11:50:00',2.56),('5815','2013-05-25','11:55:00',2.53),('5815','2013-05-25','12:00:00',2.53),('5815','2013-05-25','12:05:00',2.63),('5815','2013-05-25','12:10:00',2.68),('5815','2013-05-25','12:15:00',2.56),('5815','2013-05-25','12:20:00',2.22),('5815','2013-05-25','12:25:00',2.23),('5815','2013-05-25','12:30:00',2.74),('5815','2013-05-25','12:35:00',2.68),('5815','2013-05-25','12:40:00',2.44),('5815','2013-05-25','12:45:00',1.9),('5815','2013-05-25','12:50:00',2.72),('5815','2013-05-25','12:55:00',2.72),('5815','2013-05-25','13:00:00',2.74),('5815','2013-05-25','13:05:00',2.68),('5815','2013-05-25','13:10:00',2.64),('5815','2013-05-25','13:15:00',2.59),('5815','2013-05-25','13:20:00',2.61),('5815','2013-05-25','13:25:00',2.71),('5815','2013-05-25','13:30:00',2.7),('5815','2013-05-25','13:35:00',2.7),('5815','2013-05-25','13:40:00',2.69),('5815','2013-05-25','13:45:00',2.68),('5815','2013-05-25','13:50:00',2.24),('5815','2013-05-25','13:55:00',2.64),('5815','2013-05-25','14:00:00',2.61),('5815','2013-05-25','14:05:00',2.66),('5815','2013-05-25','14:10:00',2.62),('5815','2013-05-25','14:15:00',2.55),('5815','2013-05-25','14:20:00',2.56),('5815','2013-05-25','14:25:00',2.52),('5815','2013-05-25','14:30:00',2.5),('5815','2013-05-25','14:35:00',2.49),('5815','2013-05-25','14:40:00',2.49),('5815','2013-05-25','14:45:00',2.48),('5815','2013-05-25','14:50:00',2.48),('5815','2013-05-25','14:55:00',2.49),('5815','2013-05-25','15:00:00',2.42),('5815','2013-05-25','15:05:00',2.39),('5815','2013-05-25','15:10:00',2.39),('5815','2013-05-25','15:15:00',2.35),('5815','2013-05-25','15:20:00',2.33),('5815','2013-05-25','15:25:00',2.29),('5815','2013-05-25','15:30:00',2.26),('5815','2013-05-25','15:35:00',2.27),('5815','2013-05-25','15:40:00',2.28),('5815','2013-05-25','15:45:00',2.21),('5815','2013-05-25','15:50:00',2.13),('5815','2013-05-25','15:55:00',2.1),('5815','2013-05-25','16:00:00',2.08),('5815','2013-05-25','16:05:00',2.04),('5815','2013-05-25','16:10:00',2.01),('5815','2013-05-25','16:15:00',1.98),('5815','2013-05-25','16:20:00',1.94),('5815','2013-05-25','16:25:00',1.9),('5815','2013-05-25','16:30:00',1.86),('5815','2013-05-25','16:35:00',1.8),('5815','2013-05-25','16:40:00',1.73),('5815','2013-05-25','16:45:00',1.66),('5815','2013-05-25','16:50:00',1.6),('5815','2013-05-25','16:55:00',1.6),('5815','2013-05-25','17:00:00',1.56),('5815','2013-05-25','17:05:00',1.52),('5815','2013-05-25','17:10:00',1.47),('5815','2013-05-25','17:15:00',1.41),('5815','2013-05-25','17:20:00',1.35),('5815','2013-05-25','17:25:00',1.3),('5815','2013-05-25','17:30:00',1.17),('5815','2013-05-25','17:35:00',1.18),('5815','2013-05-25','17:40:00',1.14),('5815','2013-05-25','17:45:00',1.09),('5815','2013-05-25','17:50:00',1.03),('5815','2013-05-24','08:05:00',1.1),('5815','2013-05-24','08:25:00',1.17),('5815','2013-05-24','08:30:00',1.3),('5815','2013-05-24','08:55:00',1.39),('5815','2013-05-24','09:00:00',1.02),('5815','2013-05-24','09:05:00',1.58),('5815','2013-05-24','09:10:00',1.28),('5815','2013-05-24','09:15:00',1.6),('5815','2013-05-24','09:20:00',1.02),('5815','2013-05-24','09:35:00',1.24),('5815','2013-05-24','09:40:00',2.02),('5815','2013-05-24','09:45:00',1.44),('5815','2013-05-24','09:50:00',1.92),('5815','2013-05-24','09:55:00',1.31),('5815','2013-05-24','11:05:00',1.05),('5815','2013-05-24','11:10:00',2.41),('5815','2013-05-24','11:15:00',2.03),('5815','2013-05-24','11:20:00',1.58),('5815','2013-05-24','11:40:00',1.44),('5815','2013-05-24','11:45:00',1.27),('5815','2013-05-24','11:55:00',1.14),('5815','2013-05-24','12:25:00',1.12),('5815','2013-05-24','12:45:00',1.05),('5815','2013-05-24','12:55:00',1.07),('5815','2013-05-24','13:05:00',1.15),('5815','2013-05-24','13:20:00',1.49),('5815','2013-05-24','13:25:00',1.38),('5815','2013-05-24','13:30:00',1.19),('5815','2013-05-24','13:40:00',1.12),('5815','2013-05-24','13:45:00',1.25),('5815','2013-05-24','13:50:00',1.39),('5815','2013-05-24','13:55:00',1.9),('5815','2013-05-24','14:00:00',2.16),('5815','2013-05-24','14:05:00',2.65),('5815','2013-05-24','14:10:00',2.49),('5815','2013-05-24','14:15:00',2.75),('5815','2013-05-24','14:20:00',2.26),('5815','2013-05-24','14:25:00',1.03),('5815','2013-05-24','14:30:00',1.69),('5815','2013-05-24','14:35:00',1.04),('5815','2013-05-24','14:40:00',1.26),('5815','2013-05-24','14:45:00',1.23),('5815','2013-05-24','14:50:00',1.65),('5815','2013-05-24','14:55:00',1.23),('5815','2013-05-24','15:00:00',2.04),('5815','2013-05-24','15:05:00',1.92),('5815','2013-05-24','15:10:00',1.25),('5815','2013-05-24','15:15:00',1.56),('5815','2013-05-24','15:25:00',1.57),('5815','2013-05-24','15:30:00',2.08),('5815','2013-05-24','15:35:00',2.55),('5815','2013-05-24','15:40:00',2.49),('5815','2013-05-24','15:45:00',2.25),('5815','2013-05-24','15:50:00',2.22),('5815','2013-05-24','15:55:00',2.27),('5815','2013-05-24','16:00:00',1.96),('5815','2013-05-24','16:10:00',1.29),('5815','2013-05-24','16:25:00',1.07),('5815','2013-05-24','16:30:00',1.77),('5815','2013-05-24','16:35:00',1.67),('5815','2013-05-24','16:40:00',1.92),('5815','2013-05-24','16:45:00',1.4),('5815','2013-05-24','17:10:00',1.66),('5815','2013-05-24','17:15:00',1.43),('5815','2013-05-24','17:20:00',1.28),('5815','2013-05-23','08:15:00',1.01),('5815','2013-05-23','08:30:00',1.05),('5815','2013-05-23','08:45:00',1.26),('5815','2013-05-23','08:50:00',1.3),('5815','2013-05-23','08:55:00',1.36),('5815','2013-05-23','09:00:00',1.44),('5815','2013-05-23','09:05:00',1.6),('5815','2013-05-23','09:20:00',1.05),('5815','2013-05-23','09:30:00',1.65),('5815','2013-05-23','09:55:00',1.31),('5815','2013-05-23','10:00:00',1.72),('5815','2013-05-23','10:25:00',1.15),('5815','2013-05-23','10:30:00',2.14),('5815','2013-05-23','10:35:00',2.27),('5815','2013-05-23','10:40:00',2.24),('5815','2013-05-23','10:45:00',2.25),('5815','2013-05-23','10:50:00',2.21),('5815','2013-05-23','10:55:00',2.48),('5815','2013-05-23','11:00:00',2.17),('5815','2013-05-23','11:05:00',2.17),('5815','2013-05-23','11:10:00',2.07),('5815','2013-05-23','11:15:00',1.93),('5815','2013-05-23','11:20:00',2.43),('5815','2013-05-23','11:25:00',2.58),('5815','2013-05-23','11:30:00',2.06),('5815','2013-05-23','11:45:00',1.45),('5815','2013-05-23','11:50:00',2.89),('5815','2013-05-23','11:55:00',2.24),('5815','2013-05-23','12:00:00',1.09),('5815','2013-05-23','12:05:00',1.63),('5815','2013-05-23','12:10:00',2.26),('5815','2013-05-23','12:15:00',1.71),('5815','2013-05-23','12:20:00',1.18),('5815','2013-05-23','12:25:00',2.15),('5815','2013-05-23','12:30:00',2.54),('5815','2013-05-23','12:35:00',1.22),('5815','2013-05-23','12:40:00',1.57),('5815','2013-05-23','12:45:00',1.54),('5815','2013-05-23','12:50:00',1.8),('5815','2013-05-23','12:55:00',1.54),('5815','2013-05-23','13:00:00',1.37),('5815','2013-05-23','13:05:00',1.16),('5815','2013-05-23','13:10:00',1.41),('5815','2013-05-23','13:15:00',1.74),('5815','2013-05-23','13:20:00',1.9),('5815','2013-05-23','13:25:00',1.43),('5815','2013-05-23','13:30:00',1.04),('5815','2013-05-23','13:35:00',2.12),('5815','2013-05-23','13:40:00',1.59),('5815','2013-05-23','13:55:00',1.68),('5815','2013-05-23','14:00:00',1.38),('5815','2013-05-23','14:05:00',1.36),('5815','2013-05-23','14:15:00',2.44),('5815','2013-05-23','14:20:00',2.12),('5815','2013-05-23','14:25:00',1.54),('5815','2013-05-23','14:30:00',1.56),('5815','2013-05-23','14:35:00',1.71),('5815','2013-05-23','14:40:00',1.62),('5815','2013-05-23','14:45:00',1.54),('5815','2013-05-23','14:55:00',1.07),('5815','2013-05-23','15:00:00',1.24),('5815','2013-05-23','15:05:00',1.94),('5815','2013-05-23','15:10:00',1.74),('5815','2013-05-23','15:15:00',1.34),('5815','2013-05-23','15:20:00',2.77),('5815','2013-05-23','15:25:00',2.06),('5815','2013-05-23','15:30:00',1.84),('5815','2013-05-23','15:35:00',1.6),('5815','2013-05-23','15:40:00',1.85),('5815','2013-05-23','15:45:00',2.36),('5815','2013-05-23','15:50:00',2.66),('5815','2013-05-23','15:55:00',2.62),('5815','2013-05-23','16:00:00',1.35),('5815','2013-05-23','16:05:00',1.17),('5815','2013-05-23','16:10:00',1.26),('5815','2013-05-23','16:15:00',1.5),('5815','2013-05-23','16:20:00',1.19),('5815','2013-05-23','16:25:00',1.49),('5815','2013-05-23','16:30:00',1.86),('5815','2013-05-23','16:55:00',1),('5815','2013-05-22','08:35:00',1.03),('5815','2013-05-22','08:40:00',1.16),('5815','2013-05-22','08:45:00',1.24),('5815','2013-05-22','09:00:00',1.52),('5815','2013-05-22','09:05:00',1),('5815','2013-05-22','09:20:00',1.21),('5815','2013-05-22','09:25:00',1.65),('5815','2013-05-22','09:30:00',1.97),('5815','2013-05-22','09:35:00',1.26),('5815','2013-05-22','09:40:00',1.37),('5815','2013-05-22','09:50:00',1.98),('5815','2013-05-22','09:55:00',1.05),('5815','2013-05-22','10:05:00',2.07),('5815','2013-05-22','10:10:00',1.64),('5815','2013-05-22','10:15:00',2.03),('5815','2013-05-22','10:20:00',1.62),('5815','2013-05-22','10:25:00',2.1),('5815','2013-05-22','10:30:00',1.95),('5815','2013-05-22','10:35:00',2.1),('5815','2013-05-22','10:40:00',2.1),('5815','2013-05-22','10:45:00',2.45),('5815','2013-05-22','10:50:00',2.29),('5815','2013-05-22','10:55:00',1.7),('5815','2013-05-22','11:00:00',1.68),('5815','2013-05-22','11:05:00',1.64),('5815','2013-05-22','11:10:00',1.63),('5815','2013-05-22','11:15:00',1.45),('5815','2013-05-22','11:20:00',1.16),('5815','2013-05-22','11:25:00',1.46),('5815','2013-05-22','11:30:00',1.63),('5815','2013-05-22','11:35:00',2.02),('5815','2013-05-22','11:40:00',2.54),('5815','2013-05-22','11:45:00',1.99),('5815','2013-05-22','11:50:00',1.57),('5815','2013-05-22','11:55:00',2.08),('5815','2013-05-22','12:00:00',2.5),('5815','2013-05-22','12:05:00',2.61),('5815','2013-05-22','12:10:00',2.68),('5815','2013-05-22','12:15:00',2.46),('5815','2013-05-22','12:20:00',1.86),('5815','2013-05-22','12:25:00',2.27),('5815','2013-05-22','12:30:00',2.17),('5815','2013-05-22','12:35:00',1.42),('5815','2013-05-22','12:40:00',2.39),('5815','2013-05-22','12:45:00',1.9),('5815','2013-05-22','12:50:00',1.82),('5815','2013-05-22','12:55:00',2.26),('5815','2013-05-22','13:00:00',2.77),('5815','2013-05-22','13:05:00',1.63),('5815','2013-05-22','13:10:00',2.71),('5815','2013-05-22','13:15:00',2.37),('5815','2013-05-22','13:20:00',2),('5815','2013-05-22','13:25:00',2.3),('5815','2013-05-22','13:30:00',2.32),('5815','2013-05-22','13:35:00',1.29),('5815','2013-05-22','13:40:00',1.1),('5815','2013-05-22','13:45:00',2.03),('5815','2013-05-22','13:50:00',1.72),('5815','2013-05-22','13:55:00',2.32),('5815','2013-05-22','14:00:00',2.6),('5815','2013-05-22','14:05:00',2.81),('5815','2013-05-22','14:10:00',1.9),('5815','2013-05-22','14:15:00',2.53),('5815','2013-05-22','14:20:00',2.59),('5815','2013-05-22','14:25:00',1.69),('5815','2013-05-22','14:35:00',2.83),('5815','2013-05-22','14:40:00',1.97),('5815','2013-05-22','14:45:00',1.37),('5815','2013-05-22','14:50:00',1.17),('5815','2013-05-22','14:55:00',2.1),('5815','2013-05-22','15:00:00',2.26),('5815','2013-05-22','15:05:00',2.35),('5815','2013-05-22','15:20:00',2.22),('5815','2013-05-22','15:30:00',1.4),('5815','2013-05-22','15:35:00',1.8),('5815','2013-05-22','15:40:00',1.25),('5815','2013-05-22','15:45:00',1.63),('5815','2013-05-22','16:00:00',1.82),('5815','2013-05-22','16:05:00',2.24),('5815','2013-05-22','16:10:00',1.48),('5815','2013-05-22','16:15:00',1.38),('5815','2013-05-22','16:20:00',2),('5815','2013-05-22','16:25:00',1.3),('5815','2013-05-22','16:30:00',1.77),('5815','2013-05-22','16:45:00',1.14),('5815','2013-05-22','17:10:00',1.36),('5815','2013-05-22','17:15:00',1.16),('5815','2013-05-22','18:05:00',1.28),('5815','2013-05-21','08:15:00',1.03),('5815','2013-05-21','08:20:00',1.01),('5815','2013-05-21','08:30:00',1.11),('5815','2013-05-21','08:35:00',1.32),('5815','2013-05-21','09:30:00',1.44),('5815','2013-05-21','09:35:00',1.6),('5815','2013-05-21','09:40:00',1.6),('5815','2013-05-21','09:45:00',1.62),('5815','2013-05-21','09:50:00',1.66),('5815','2013-05-21','09:55:00',1.7),('5815','2013-05-21','10:00:00',1.73),('5815','2013-05-21','10:05:00',1.78),('5815','2013-05-21','10:10:00',1.82),('5815','2013-05-21','10:15:00',1.85),('5815','2013-05-21','10:20:00',1.85),('5815','2013-05-21','10:25:00',1.95),('5815','2013-05-21','10:30:00',1.95),('5815','2013-05-21','10:35:00',1.94),('5815','2013-05-21','10:40:00',2.06),('5815','2013-05-21','10:45:00',2.05),('5815','2013-05-21','10:50:00',2.04),('5815','2013-05-21','10:55:00',2.03),('5815','2013-05-21','11:00:00',2.07),('5815','2013-05-21','11:05:00',2.12),('5815','2013-05-21','11:10:00',1.99),('5815','2013-05-21','11:15:00',1.91),('5815','2013-05-21','11:20:00',2.2),('5815','2013-05-21','11:25:00',2.33),('5815','2013-05-21','11:30:00',1.99),('5815','2013-05-21','11:35:00',1.96),('5815','2013-05-21','11:40:00',1.85),('5815','2013-05-21','11:45:00',2.39),('5815','2013-05-21','11:50:00',1.46),('5815','2013-05-21','11:55:00',1.14),('5815','2013-05-21','12:00:00',1.72),('5815','2013-05-21','12:05:00',1.32),('5815','2013-05-21','12:10:00',1.25),('5815','2013-05-21','12:15:00',1.62),('5815','2013-05-21','12:20:00',2.2),('5815','2013-05-21','12:25:00',1.78),('5815','2013-05-21','12:30:00',1.33),('5815','2013-05-21','12:35:00',1.29),('5815','2013-05-21','13:05:00',2.43),('5815','2013-05-21','13:10:00',1.31),('5815','2013-05-21','13:15:00',1.27),('5815','2013-05-21','13:20:00',1.36),('5815','2013-05-21','13:30:00',1.02),('5815','2013-05-21','13:35:00',1.83),('5815','2013-05-21','13:40:00',1.97),('5815','2013-05-21','13:45:00',1.33),('5815','2013-05-21','13:50:00',1.31),('5815','2013-05-21','13:55:00',1.47),('5815','2013-05-21','14:00:00',1.45),('5815','2013-05-21','14:05:00',2.03),('5815','2013-05-21','14:10:00',2.21),('5815','2013-05-21','14:15:00',2.46),('5815','2013-05-21','14:20:00',2.37),('5815','2013-05-21','14:25:00',2.35),('5815','2013-05-21','14:30:00',2.3),('5815','2013-05-21','14:35:00',2.28),('5815','2013-05-21','14:40:00',2.28),('5815','2013-05-21','14:45:00',2.26),('5815','2013-05-21','14:50:00',2.25),('5815','2013-05-21','14:55:00',2.24),('5815','2013-05-21','15:00:00',2.21),('5815','2013-05-21','15:05:00',2.15),('5815','2013-05-21','15:10:00',2.15),('5815','2013-05-21','15:15:00',2.1),('5815','2013-05-21','15:20:00',1.98),('5815','2013-05-21','15:25:00',1.19),('5815','2013-05-21','15:30:00',1.05),('5815','2013-05-21','15:35:00',1.05),('5815','2013-05-21','15:45:00',1.4),('5815','2013-05-21','15:50:00',1.97),('5815','2013-05-21','15:55:00',1.86),('5815','2013-05-21','16:00:00',1.82),('5815','2013-05-21','16:05:00',1.79),('5815','2013-05-21','16:10:00',1.77),('5815','2013-05-21','16:15:00',1.72),('5815','2013-05-21','16:20:00',1.7),('5815','2013-05-21','16:25:00',1.66),('5815','2013-05-21','16:30:00',1.61),('5815','2013-05-21','16:35:00',1.56),('5815','2013-05-21','16:40:00',1.52),('5815','2013-05-21','16:45:00',1.25),('5815','2013-05-21','17:25:00',1.12),('5815','2013-05-20','08:25:00',1.01),('5815','2013-05-20','09:20:00',1.17),('5815','2013-05-20','09:25:00',1.35),('5815','2013-05-20','09:30:00',1.07),('5815','2013-05-20','09:35:00',1.07),('5815','2013-05-20','09:40:00',1.1),('5815','2013-05-20','09:55:00',1.04),('5815','2013-05-20','10:00:00',1.12),('5815','2013-05-20','10:05:00',1.23),('5815','2013-05-20','10:10:00',1.25),('5815','2013-05-20','10:15:00',1.27),('5815','2013-05-20','10:20:00',1.21),('5815','2013-05-20','10:25:00',1.08),('5815','2013-05-20','10:30:00',1),('5815','2013-05-20','10:35:00',1.02),('5815','2013-05-20','10:40:00',1.16),('5815','2013-05-20','10:45:00',1.69),('5815','2013-05-20','10:50:00',1.2),('5815','2013-05-20','11:00:00',1.06),('5815','2013-05-20','11:10:00',1.6),('5815','2013-05-20','11:15:00',2.3),('5815','2013-05-20','11:20:00',1.7),('5815','2013-05-20','11:25:00',2.26),('5815','2013-05-20','11:30:00',1.57),('5815','2013-05-20','11:35:00',1.43),('5815','2013-05-20','11:40:00',1.48),('5815','2013-05-20','11:45:00',2.04),('5815','2013-05-20','11:50:00',1.49),('5815','2013-05-20','11:55:00',2.11),('5815','2013-05-20','12:00:00',1.74),('5815','2013-05-20','12:05:00',2.06),('5815','2013-05-20','12:10:00',1.6),('5815','2013-05-20','12:15:00',1.76),('5815','2013-05-20','12:20:00',1.32),('5815','2013-05-20','12:25:00',1.81),('5815','2013-05-20','12:30:00',2.26),('5815','2013-05-20','12:35:00',1.35),('5815','2013-05-20','12:40:00',2.29),('5815','2013-05-20','12:45:00',2.28),('5815','2013-05-20','12:50:00',1.42),('5815','2013-05-20','12:55:00',2.52),('5815','2013-05-20','13:00:00',2.3),('5815','2013-05-20','13:05:00',2.48),('5815','2013-05-20','13:10:00',1.48),('5815','2013-05-20','13:15:00',2.12),('5815','2013-05-20','13:20:00',1.61),('5815','2013-05-20','13:25:00',1.88),('5815','2013-05-20','13:30:00',1.69),('5815','2013-05-20','14:15:00',1.12),('5815','2013-05-20','14:20:00',1),('5815','2013-05-20','14:25:00',1.32),('5815','2013-05-20','14:30:00',1.43),('5815','2013-05-20','14:35:00',1.11),('5815','2013-05-20','14:40:00',1.04),('5815','2013-05-20','15:30:00',1.28),('5815','2013-05-20','16:30:00',1.04),('5815','2013-05-20','16:35:00',1.12),('5815','2013-05-20','16:40:00',1.17),('5815','2013-05-20','16:45:00',1.1),('5815','2013-05-19','08:50:00',1.43),('5815','2013-05-19','08:55:00',1.43),('5815','2013-05-19','09:00:00',1.58),('5815','2013-05-19','09:05:00',1.41),('5815','2013-05-19','09:10:00',1.71),('5815','2013-05-19','09:15:00',1.3),('5815','2013-05-19','09:50:00',1.88),('5815','2013-05-19','10:30:00',1.51),('5815','2013-05-19','10:35:00',1.42),('5815','2013-05-19','10:55:00',1.01),('5815','2013-05-19','11:00:00',1.87),('5815','2013-05-19','11:05:00',2.43),('5815','2013-05-19','11:10:00',2.27),('5815','2013-05-19','11:15:00',2.43),('5815','2013-05-19','11:20:00',1.82),('5815','2013-05-19','11:25:00',1.98),('5815','2013-05-19','11:30:00',2.06),('5815','2013-05-19','11:35:00',1.98),('5815','2013-05-19','11:40:00',1.06),('5815','2013-05-19','11:50:00',1.03),('5815','2013-05-19','11:55:00',2.09),('5815','2013-05-19','12:00:00',1.59),('5815','2013-05-19','12:05:00',2.89),('5815','2013-05-19','12:10:00',1.95),('5815','2013-05-19','12:15:00',1.08),('5815','2013-05-19','12:20:00',1.49),('5815','2013-05-19','12:25:00',1.1),('5815','2013-05-19','12:30:00',1.11),('5815','2013-05-19','12:35:00',1.89),('5815','2013-05-19','12:40:00',1.72),('5815','2013-05-19','12:45:00',2.7),('5815','2013-05-19','12:50:00',1.37),('5815','2013-05-19','12:55:00',1.21),('5815','2013-05-19','13:00:00',1.11),('5815','2013-05-19','13:05:00',1.85),('5815','2013-05-19','13:10:00',1.21),('5815','2013-05-19','13:15:00',1.43),('5815','2013-05-19','13:20:00',2.72),('5815','2013-05-19','13:25:00',2.2),('5815','2013-05-19','13:30:00',2.12),('5815','2013-05-19','13:35:00',1.46),('5815','2013-05-19','13:40:00',1.78),('5815','2013-05-19','13:45:00',1.48),('5815','2013-05-19','13:50:00',2.81),('5815','2013-05-19','13:55:00',1.97),('5815','2013-05-19','14:00:00',2.81),('5815','2013-05-19','14:05:00',1.74),('5815','2013-05-19','14:15:00',2.62),('5815','2013-05-19','14:20:00',1.99),('5815','2013-05-19','14:25:00',1.41),('5815','2013-05-19','14:30:00',2.74),('5815','2013-05-19','14:35:00',2.01),('5815','2013-05-19','14:45:00',1.54),('5815','2013-05-19','14:50:00',2.8),('5815','2013-05-19','14:55:00',2.55),('5815','2013-05-19','15:00:00',2.16),('5815','2013-05-19','15:10:00',2.19),('5815','2013-05-19','15:15:00',2.31),('5815','2013-05-19','15:20:00',1.56),('5815','2013-05-19','15:25:00',2.54),('5815','2013-05-19','15:30:00',1.8),('5815','2013-05-19','15:35:00',2.41),('5815','2013-05-19','15:40:00',1.65),('5815','2013-05-19','15:45:00',1.31),('5815','2013-05-19','15:50:00',1.68),('5815','2013-05-19','16:00:00',1.25),('5815','2013-05-19','16:05:00',1.9),('5815','2013-05-19','16:10:00',2.03),('5815','2013-05-19','16:15:00',2.13),('5815','2013-05-19','16:20:00',1.99),('5815','2013-05-19','16:25:00',1.93),('5815','2013-05-19','16:30:00',1.88),('5815','2013-05-19','16:35:00',1.8),('5815','2013-05-19','16:40:00',1.75),('5815','2013-05-19','16:45:00',1.58),('5815','2013-05-19','16:50:00',1.56),('5815','2013-05-19','16:55:00',1.54),('5815','2013-05-19','17:00:00',1.47),('5815','2013-05-19','17:05:00',1.5),('5815','2013-05-19','17:10:00',1.11),('5815','2013-05-19','17:20:00',1.12),('5815','2013-05-19','17:25:00',1.36),('5815','2013-05-19','17:30:00',1.44),('5815','2013-05-19','17:35:00',1.19),('5815','2013-05-19','17:40:00',1.08),('5815','2013-05-19','17:45:00',1.03),('5815','2013-05-18','10:10:00',1.07),('5815','2013-05-18','10:15:00',1.61),('5815','2013-05-18','10:20:00',1.68),('5815','2013-05-18','10:25:00',1.24),('5815','2013-05-18','10:30:00',1.5),('5815','2013-05-18','10:35:00',1.32),('5815','2013-05-18','10:40:00',1.07),('5815','2013-05-18','10:45:00',1.6),('5815','2013-05-18','10:50:00',1.03),('5815','2013-05-18','10:55:00',1.16),('5815','2013-05-18','11:00:00',1.09),('5815','2013-05-18','11:05:00',1.74),('5815','2013-05-18','11:10:00',1.49),('5815','2013-05-18','11:15:00',2.03),('5815','2013-05-18','11:20:00',2.45),('5815','2013-05-18','11:25:00',2.39),('5815','2013-05-18','11:30:00',2.46),('5815','2013-05-18','11:35:00',2.47),('5815','2013-05-18','11:40:00',2.54),('5815','2013-05-18','11:45:00',2.55),('5815','2013-05-18','11:50:00',2.54),('5815','2013-05-18','11:55:00',2.57),('5815','2013-05-18','12:00:00',2.59),('5815','2013-05-18','12:05:00',2.57),('5815','2013-05-18','12:10:00',2.58),('5815','2013-05-18','12:15:00',2.61),('5815','2013-05-18','12:20:00',2.77),('5815','2013-05-18','12:25:00',2.94),('5815','2013-05-18','12:30:00',2.34),('5815','2013-05-18','12:35:00',2.84),('5815','2013-05-18','12:40:00',2.86),('5815','2013-05-18','12:45:00',2.76),('5815','2013-05-18','12:50:00',2.18),('5815','2013-05-18','12:55:00',1.71),('5815','2013-05-18','13:00:00',2.56),('5815','2013-05-18','13:05:00',2.74),('5815','2013-05-18','13:10:00',2.38),('5815','2013-05-18','13:15:00',2.28),('5815','2013-05-18','13:20:00',2.65),('5815','2013-05-18','13:25:00',2.35),('5815','2013-05-18','13:30:00',2.62),('5815','2013-05-18','13:35:00',2.61),('5815','2013-05-18','13:40:00',2.57),('5815','2013-05-18','13:45:00',2.55),('5815','2013-05-18','13:50:00',2.54),('5815','2013-05-18','13:55:00',2.57),('5815','2013-05-18','14:00:00',2.58),('5815','2013-05-18','14:05:00',2.58),('5815','2013-05-18','14:10:00',2.59),('5815','2013-05-18','14:15:00',2.56),('5815','2013-05-18','14:20:00',2.53),('5815','2013-05-18','14:25:00',2.51),('5815','2013-05-18','14:30:00',2.5),('5815','2013-05-18','14:35:00',2.47),('5815','2013-05-18','14:40:00',2.45),('5815','2013-05-18','14:45:00',2.45),('5815','2013-05-18','14:50:00',2.44),('5815','2013-05-18','14:55:00',2.43),('5815','2013-05-18','15:00:00',2.43),('5815','2013-05-18','15:05:00',2.4),('5815','2013-05-18','15:10:00',2.36),('5815','2013-05-18','15:15:00',2.32),('5815','2013-05-18','15:20:00',2.27),('5815','2013-05-18','15:25:00',2.25),('5815','2013-05-18','15:30:00',2.23),('5815','2013-05-18','15:35:00',2.25),('5815','2013-05-18','15:40:00',2.22),('5815','2013-05-18','15:45:00',2.17),('5815','2013-05-18','15:50:00',2.08),('5815','2013-05-18','15:55:00',2.08),('5815','2013-05-18','16:00:00',2.03),('5815','2013-05-18','16:05:00',1.99),('5815','2013-05-18','16:10:00',1.96),('5815','2013-05-18','16:15:00',1.91),('5815','2013-05-18','16:20:00',1.88),('5815','2013-05-18','16:25:00',1.85),('5815','2013-05-18','16:30:00',1.81),('5815','2013-05-18','16:35:00',1.77),('5815','2013-05-18','16:40:00',1.71),('5815','2013-05-18','16:45:00',1.62),('5815','2013-05-18','16:50:00',1.51),('5815','2013-05-18','16:55:00',1.59),('5815','2013-05-18','17:00:00',1.54),('5815','2013-05-18','17:05:00',1.5),('5815','2013-05-18','17:10:00',1.45),('5815','2013-05-18','17:15:00',1.39),('5815','2013-05-18','17:20:00',1.32),('5815','2013-05-18','17:25:00',1.27),('5815','2013-05-18','17:30:00',1.18),('5815','2013-05-18','17:35:00',1.12),('5815','2013-05-18','17:40:00',1.12),('5815','2013-05-18','17:45:00',1.06),('5815','2013-05-17','08:25:00',1.25),('5815','2013-05-17','08:30:00',1.16),('5815','2013-05-17','08:35:00',1.02),('5815','2013-05-17','08:40:00',1.14),('5815','2013-05-17','08:45:00',1.15),('5815','2013-05-17','08:50:00',1.2),('5815','2013-05-17','08:55:00',1.25),('5815','2013-05-17','09:00:00',1.3),('5815','2013-05-17','09:05:00',1.33),('5815','2013-05-17','09:10:00',1.42),('5815','2013-05-17','09:15:00',1.46),('5815','2013-05-17','09:20:00',1.49),('5815','2013-05-17','09:25:00',1.54),('5815','2013-05-17','09:30:00',1.55),('5815','2013-05-17','09:35:00',1.62),('5815','2013-05-17','09:40:00',1.66),('5815','2013-05-17','09:45:00',1.7),('5815','2013-05-17','09:50:00',1.73),('5815','2013-05-17','09:55:00',1.78),('5815','2013-05-17','10:00:00',1.82),('5815','2013-05-17','10:05:00',1.84),('5815','2013-05-17','10:10:00',1.88),('5815','2013-05-17','10:15:00',1.9),('5815','2013-05-17','10:20:00',1.94),('5815','2013-05-17','10:25:00',1.97),('5815','2013-05-17','10:30:00',1.99),('5815','2013-05-17','10:35:00',2),('5815','2013-05-17','10:40:00',2.04),('5815','2013-05-17','10:45:00',2.06),('5815','2013-05-17','10:50:00',2.09),('5815','2013-05-17','10:55:00',2.01),('5815','2013-05-17','11:00:00',2.15),('5815','2013-05-17','11:05:00',2.11),('5815','2013-05-17','11:10:00',1.77),('5815','2013-05-17','11:15:00',2.34),('5815','2013-05-17','11:20:00',2.26),('5815','2013-05-17','11:25:00',2.31),('5815','2013-05-17','11:30:00',2.3),('5815','2013-05-17','11:35:00',2.14),('5815','2013-05-17','11:40:00',2.26),('5815','2013-05-17','11:45:00',2.13),('5815','2013-05-17','11:50:00',2.14),('5815','2013-05-17','11:55:00',2.25),('5815','2013-05-17','12:00:00',2.26),('5815','2013-05-17','12:05:00',2.22),('5815','2013-05-17','12:10:00',2.26),('5815','2013-05-17','12:15:00',2.24),('5815','2013-05-17','12:20:00',2.31),('5815','2013-05-17','12:25:00',2.37),('5815','2013-05-17','12:30:00',1.91),('5815','2013-05-17','12:35:00',2.39),('5815','2013-05-17','12:40:00',2.36),('5815','2013-05-17','12:45:00',2.29),('5815','2013-05-17','12:50:00',2.31),('5815','2013-05-17','12:55:00',2.33),('5815','2013-05-17','13:00:00',2.34),('5815','2013-05-17','13:05:00',2.3),('5815','2013-05-17','13:10:00',2.36),('5815','2013-05-17','13:15:00',2.37),('5815','2013-05-17','13:20:00',2.37),('5815','2013-05-17','13:25:00',2.37),('5815','2013-05-17','13:30:00',2.4),('5815','2013-05-17','13:35:00',2.11),('5815','2013-05-17','13:40:00',2.32),('5815','2013-05-17','13:45:00',2.48),('5815','2013-05-17','13:50:00',2.19),('5815','2013-05-17','13:55:00',2.02),('5815','2013-05-17','14:00:00',1.66),('5815','2013-05-17','14:05:00',1.75),('5815','2013-05-17','14:10:00',2.56),('5815','2013-05-17','14:15:00',2.43),('5815','2013-05-17','14:20:00',2.4),('5815','2013-05-17','14:25:00',2.34),('5815','2013-05-17','14:30:00',2.34),('5815','2013-05-17','14:35:00',2.23),('5815','2013-05-17','14:40:00',2.42),('5815','2013-05-17','14:45:00',2.27),('5815','2013-05-17','14:50:00',2.08),('5815','2013-05-17','14:55:00',1.87),('5815','2013-05-17','15:00:00',2.1),('5815','2013-05-17','15:05:00',2.08),('5815','2013-05-17','15:10:00',2.04),('5815','2013-05-17','15:15:00',2),('5815','2013-05-17','15:20:00',1.97),('5815','2013-05-17','15:25:00',1.95),('5815','2013-05-17','15:30:00',1.92),('5815','2013-05-17','15:35:00',1.9),('5815','2013-05-17','15:40:00',1.87),('5815','2013-05-17','15:45:00',1.84),('5815','2013-05-17','15:50:00',1.79),('5815','2013-05-17','15:55:00',1.75),('5815','2013-05-17','16:00:00',1.72),('5815','2013-05-17','16:05:00',1.69),('5815','2013-05-17','16:10:00',1.65),('5815','2013-05-17','16:15:00',1.63),('5815','2013-05-17','16:20:00',1.58),('5815','2013-05-17','16:25:00',1.52),('5815','2013-05-17','16:30:00',1.48),('5815','2013-05-17','16:35:00',1.44),('5815','2013-05-17','16:40:00',1.41),('5815','2013-05-17','16:45:00',1.39),('5815','2013-05-17','16:50:00',1.32),('5815','2013-05-17','16:55:00',1.28),('5815','2013-05-17','17:00:00',1.25),('5815','2013-05-17','17:05:00',1.22),('5815','2013-05-17','17:10:00',1.16),('5815','2013-05-17','17:15:00',1.12),('5815','2013-05-17','17:20:00',1.11),('5815','2013-05-17','17:25:00',1.07),('5815','2013-05-17','17:30:00',1.02),('5815','2013-05-16','08:20:00',1.16),('5815','2013-05-16','10:50:00',1.62),('5815','2013-05-16','10:55:00',2.02),('5815','2013-05-16','11:00:00',1.28),('5815','2013-05-16','11:05:00',1.23),('5815','2013-05-16','11:15:00',1.38),('5815','2013-05-16','11:20:00',1.22),('5815','2013-05-16','11:30:00',1.04),('5815','2013-05-16','11:35:00',1.42),('5815','2013-05-16','11:50:00',1.48),('5815','2013-05-16','11:55:00',1.39),('5815','2013-05-16','12:00:00',1.29),('5815','2013-05-16','12:05:00',1.43),('5815','2013-05-16','12:10:00',1.82),('5815','2013-05-16','12:15:00',1.34),('5815','2013-05-16','12:20:00',1.39),('5815','2013-05-16','12:25:00',1.56),('5815','2013-05-16','12:30:00',1.37),('5815','2013-05-16','12:35:00',1.75),('5815','2013-05-16','12:40:00',2.13),('5815','2013-05-16','12:45:00',2.51),('5815','2013-05-16','12:50:00',2.62),('5815','2013-05-16','12:55:00',2.54),('5815','2013-05-16','13:00:00',2.06),('5815','2013-05-16','13:05:00',2.49),('5815','2013-05-16','13:10:00',1.83),('5815','2013-05-16','13:15:00',2.08),('5815','2013-05-16','13:20:00',2.77),('5815','2013-05-16','13:25:00',2.66),('5815','2013-05-16','13:30:00',1.92),('5815','2013-05-16','13:35:00',2.67),('5815','2013-05-16','13:40:00',2.09),('5815','2013-05-16','13:45:00',2.56),('5815','2013-05-16','13:50:00',2.44),('5815','2013-05-16','13:55:00',2.69),('5815','2013-05-16','14:00:00',1.94),('5815','2013-05-16','14:05:00',1.27),('5815','2013-05-16','14:10:00',2.54),('5815','2013-05-16','14:15:00',2.49),('5815','2013-05-16','14:20:00',2.7),('5815','2013-05-16','14:25:00',2.25),('5815','2013-05-16','14:30:00',2.39),('5815','2013-05-16','14:35:00',2.22),('5815','2013-05-16','14:40:00',1.59),('5815','2013-05-16','14:45:00',1.74),('5815','2013-05-16','14:50:00',1.82),('5815','2013-05-16','14:55:00',1.24),('5815','2013-05-16','15:00:00',2.24),('5815','2013-05-16','15:05:00',1.68),('5815','2013-05-16','15:10:00',1.07),('5815','2013-05-16','15:15:00',1.42),('5815','2013-05-16','15:20:00',1.64),('5815','2013-05-16','15:25:00',1.98),('5815','2013-05-16','15:30:00',1.1),('5815','2013-05-16','15:35:00',1.67),('5815','2013-05-16','15:40:00',2.37),('5815','2013-05-16','15:50:00',1.64),('5815','2013-05-16','15:55:00',1.82),('5815','2013-05-16','16:00:00',2.02),('5815','2013-05-16','16:05:00',1.17),('5815','2013-05-16','16:15:00',1.63),('5815','2013-05-16','16:20:00',1.93),('5815','2013-05-16','16:25:00',1.84),('5815','2013-05-16','16:30:00',1.98),('5815','2013-05-16','16:35:00',1.85),('5815','2013-05-16','16:40:00',1.79),('5815','2013-05-16','16:45:00',1.75),('5815','2013-05-16','16:50:00',1.5),('5815','2013-05-16','16:55:00',1.38),('5815','2013-05-16','17:00:00',1.45),('5815','2013-05-16','17:05:00',1.44),('5815','2013-05-16','17:10:00',1.39),('5815','2013-05-16','17:15:00',1.32),('5815','2013-05-16','17:20:00',1.27),('5815','2013-05-16','17:25:00',1.23),('5815','2013-05-16','17:30:00',1.21),('5815','2013-05-16','17:35:00',1.16),('5815','2013-05-16','17:40:00',1.09),('5815','2013-05-16','17:45:00',1.03),('5815','2013-05-15','09:40:00',1.14),('5815','2013-05-15','09:45:00',1.39),('5815','2013-05-15','10:20:00',1.13),('5815','2013-05-15','10:25:00',1.2),('5815','2013-05-15','10:30:00',1.05),('5815','2013-05-15','11:00:00',2.16),('5815','2013-05-15','11:05:00',2),('5815','2013-05-15','11:10:00',1.65),('5815','2013-05-15','11:15:00',1.13),('5815','2013-05-15','11:35:00',1.76),('5815','2013-05-15','11:40:00',2.28),('5815','2013-05-15','11:45:00',2.25),('5815','2013-05-15','11:50:00',2.16),('5815','2013-05-15','11:55:00',1.43),('5815','2013-05-15','12:15:00',1.54),('5815','2013-05-15','12:20:00',1.09),('5815','2013-05-15','12:25:00',1.25),('5815','2013-05-15','12:30:00',1.72),('5815','2013-05-15','12:35:00',1.91),('5815','2013-05-15','12:40:00',2.21),('5815','2013-05-15','12:45:00',2.08),('5815','2013-05-15','12:50:00',1.56),('5815','2013-05-15','12:55:00',2.42),('5815','2013-05-15','13:00:00',2.35),('5815','2013-05-15','13:05:00',2.18),('5815','2013-05-15','13:10:00',2.33),('5815','2013-05-15','13:15:00',1.94),('5815','2013-05-15','13:20:00',1.91),('5815','2013-05-15','13:25:00',2.4),('5815','2013-05-15','13:30:00',2.34),('5815','2013-05-15','13:35:00',2.33),('5815','2013-05-15','13:40:00',2.28),('5815','2013-05-15','13:45:00',2.28),('5815','2013-05-15','13:50:00',2.28),('5815','2013-05-15','13:55:00',2.29),('5815','2013-05-15','14:00:00',2.28),('5815','2013-05-15','14:05:00',2.28),('5815','2013-05-15','14:10:00',2.27),('5815','2013-05-15','14:15:00',2.23),('5815','2013-05-15','14:20:00',2.23),('5815','2013-05-15','14:25:00',2.15),('5815','2013-05-15','14:30:00',2.15),('5815','2013-05-15','14:35:00',2.12),('5815','2013-05-15','14:40:00',2.12),('5815','2013-05-15','14:45:00',2.11),('5815','2013-05-15','14:50:00',1.99),('5815','2013-05-15','14:55:00',1.68),('5815','2013-05-15','15:00:00',2.03),('5815','2013-05-15','15:05:00',2.05),('5815','2013-05-15','15:10:00',2.03),('5815','2013-05-15','15:15:00',1.82),('5815','2013-05-15','15:20:00',1.88),('5815','2013-05-15','15:25:00',1.93),('5815','2013-05-15','15:30:00',1.88),('5815','2013-05-15','15:35:00',1.83),('5815','2013-05-15','15:40:00',1.87),('5815','2013-05-15','15:45:00',1.82),('5815','2013-05-15','15:50:00',1.81),('5815','2013-05-15','15:55:00',1.78),('5815','2013-05-15','16:00:00',1.75),('5815','2013-05-15','16:05:00',1.67),('5815','2013-05-15','16:10:00',1.66),('5815','2013-05-15','16:15:00',1.56),('5815','2013-05-15','16:20:00',1.62),('5815','2013-05-15','16:25:00',1.55),('5815','2013-05-15','16:30:00',1.55),('5815','2013-05-15','16:35:00',1.5),('5815','2013-05-15','16:50:00',1.06),('5815','2013-05-14','08:35:00',1.03),('5815','2013-05-14','08:40:00',1.09),('5815','2013-05-14','08:45:00',1.14),('5815','2013-05-14','08:50:00',1.2),('5815','2013-05-14','08:55:00',1.26),('5815','2013-05-14','09:00:00',1.22),('5815','2013-05-14','09:05:00',1.32),('5815','2013-05-14','09:10:00',1.33),('5815','2013-05-14','09:15:00',1.37),('5815','2013-05-14','09:20:00',1.39),('5815','2013-05-14','09:25:00',1.44),('5815','2013-05-14','09:30:00',1.53),('5815','2013-05-14','09:35:00',1.58),('5815','2013-05-14','09:40:00',1.58),('5815','2013-05-14','09:45:00',1.64),('5815','2013-05-14','09:50:00',1.7),('5815','2013-05-14','09:55:00',1.71),('5815','2013-05-14','10:00:00',1.77),('5815','2013-05-14','10:05:00',1.82),('5815','2013-05-14','10:10:00',1.83),('5815','2013-05-14','10:15:00',1.82),('5815','2013-05-14','10:20:00',1.91),('5815','2013-05-14','10:25:00',1.95),('5815','2013-05-14','10:30:00',1.9),('5815','2013-05-14','10:35:00',1.95),('5815','2013-05-14','10:40:00',2),('5815','2013-05-14','10:45:00',2.05),('5815','2013-05-14','10:50:00',2.05),('5815','2013-05-14','10:55:00',1.96),('5815','2013-05-14','11:00:00',1.91),('5815','2013-05-14','11:05:00',1.98),('5815','2013-05-14','11:10:00',2.07),('5815','2013-05-14','11:15:00',2.11),('5815','2013-05-14','11:20:00',2.04),('5815','2013-05-14','11:25:00',2.12),('5815','2013-05-14','11:30:00',2.14),('5815','2013-05-14','11:35:00',2.16),('5815','2013-05-14','11:40:00',1.94),('5815','2013-05-14','11:45:00',1.78),('5815','2013-05-14','11:50:00',1.5),('5815','2013-05-14','11:55:00',1.13),('5815','2013-05-14','12:00:00',1.24),('5815','2013-05-14','12:05:00',1.82),('5815','2013-05-14','12:10:00',2.43),('5815','2013-05-14','12:15:00',2.69),('5815','2013-05-14','12:20:00',1.59),('5815','2013-05-14','12:25:00',2.06),('5815','2013-05-14','12:30:00',1.53),('5815','2013-05-14','12:35:00',1.64),('5815','2013-05-14','12:40:00',2.69),('5815','2013-05-14','12:45:00',1.42),('5815','2013-05-14','12:50:00',1.39),('5815','2013-05-14','12:55:00',1.53),('5815','2013-05-14','13:00:00',1.58),('5815','2013-05-14','13:05:00',1.85),('5815','2013-05-14','13:10:00',1.64),('5815','2013-05-14','13:15:00',1.32),('5815','2013-05-14','13:20:00',1.51),('5815','2013-05-14','13:25:00',1.49),('5815','2013-05-14','13:30:00',1.52),('5815','2013-05-14','13:35:00',1.36),('5815','2013-05-14','13:40:00',1.39),('5815','2013-05-14','13:45:00',1.45),('5815','2013-05-14','13:50:00',1.18),('5815','2013-05-14','13:55:00',1.16),('5815','2013-05-14','14:00:00',1.01),('5815','2013-05-14','15:55:00',1.05),('5815','2013-05-14','16:00:00',1.06),('5815','2013-05-14','17:05:00',1.11),('5815','2013-05-14','17:10:00',1.13),('5815','2013-05-14','17:15:00',1.57),('5815','2013-05-14','17:20:00',1.01),('5815','2013-05-13','08:30:00',1.04),('5815','2013-05-13','08:35:00',1.1),('5815','2013-05-13','08:40:00',1.15),('5815','2013-05-13','08:45:00',1.2),('5815','2013-05-13','08:50:00',1.25),('5815','2013-05-13','08:55:00',1.31),('5815','2013-05-13','09:00:00',1.36),('5815','2013-05-13','09:05:00',1.41),('5815','2013-05-13','09:10:00',1.46),('5815','2013-05-13','09:15:00',1.5),('5815','2013-05-13','09:20:00',1.54),('5815','2013-05-13','09:25:00',1.59),('5815','2013-05-13','09:30:00',1.63),('5815','2013-05-13','09:35:00',1.67),('5815','2013-05-13','09:40:00',1.7),('5815','2013-05-13','09:45:00',1.75),('5815','2013-05-13','09:50:00',1.8),('5815','2013-05-13','09:55:00',1.82),('5815','2013-05-13','10:00:00',1.86),('5815','2013-05-13','10:05:00',1.89),('5815','2013-05-13','10:10:00',1.93),('5815','2013-05-13','10:15:00',1.97),('5815','2013-05-13','10:20:00',1.99),('5815','2013-05-13','10:25:00',2.01),('5815','2013-05-13','10:30:00',2.04),('5815','2013-05-13','10:35:00',2.07),('5815','2013-05-13','10:40:00',2.1),('5815','2013-05-13','10:45:00',2.12),('5815','2013-05-13','10:50:00',2.11),('5815','2013-05-13','10:55:00',2.11),('5815','2013-05-13','11:00:00',2.04),('5815','2013-05-13','11:05:00',2.08),('5815','2013-05-13','11:10:00',2.17),('5815','2013-05-13','11:15:00',2.18),('5815','2013-05-13','11:20:00',2.2),('5815','2013-05-13','11:25:00',2.21),('5815','2013-05-13','11:30:00',2.23),('5815','2013-05-13','11:35:00',2.24),('5815','2013-05-13','11:40:00',2.24),('5815','2013-05-13','11:45:00',2.23),('5815','2013-05-13','11:50:00',2.26),('5815','2013-05-13','11:55:00',2.29),('5815','2013-05-13','12:00:00',2.3),('5815','2013-05-13','12:05:00',2.31),('5815','2013-05-13','12:10:00',2.34),('5815','2013-05-13','12:15:00',2.35),('5815','2013-05-13','12:20:00',2.37),('5815','2013-05-13','12:25:00',2.42),('5815','2013-05-13','12:30:00',2.41),('5815','2013-05-13','12:35:00',2.4),('5815','2013-05-13','12:40:00',2.38),('5815','2013-05-13','12:45:00',2.41),('5815','2013-05-13','12:50:00',2.42),('5815','2013-05-13','12:55:00',2.44),('5815','2013-05-13','13:00:00',2.43),('5815','2013-05-13','13:05:00',2.43),('5815','2013-05-13','13:10:00',2.46),('5815','2013-05-13','13:15:00',2.46),('5815','2013-05-13','13:20:00',2.45),('5815','2013-05-13','13:25:00',2.44),('5815','2013-05-13','13:30:00',2.46),('5815','2013-05-13','13:35:00',2.45),('5815','2013-05-13','13:40:00',2.46),('5815','2013-05-13','13:45:00',2.42),('5815','2013-05-13','13:50:00',2.41),('5815','2013-05-13','13:55:00',2.38),('5815','2013-05-13','14:00:00',2.37),('5815','2013-05-13','14:05:00',2.38),('5815','2013-05-13','14:10:00',2.37),('5815','2013-05-13','14:15:00',2.36),('5815','2013-05-13','14:20:00',2.35),('5815','2013-05-13','14:25:00',2.32),('5815','2013-05-13','14:30:00',2.3),('5815','2013-05-13','14:35:00',2.28),('5815','2013-05-13','14:40:00',2.26),('5815','2013-05-13','14:45:00',2.27),('5815','2013-05-13','14:50:00',2.3),('5815','2013-05-13','14:55:00',2.33),('5815','2013-05-13','15:00:00',2.32),('5815','2013-05-13','15:05:00',2.31),('5815','2013-05-13','15:10:00',2.29),('5815','2013-05-13','15:15:00',2.26),('5815','2013-05-13','15:20:00',2.22),('5815','2013-05-13','15:25:00',2.19),('5815','2013-05-13','15:30:00',2.2),('5815','2013-05-13','15:35:00',2.17),('5815','2013-05-13','15:40:00',2.14),('5815','2013-05-13','15:45:00',2.1),('5815','2013-05-13','15:50:00',2.06),('5815','2013-05-13','15:55:00',2),('5815','2013-05-13','16:00:00',1.94),('5815','2013-05-13','16:05:00',1.89),('5815','2013-05-13','16:10:00',1.89),('5815','2013-05-13','16:15:00',1.85),('5815','2013-05-13','16:20:00',1.79),('5815','2013-05-13','16:25:00',1.78),('5815','2013-05-13','16:30:00',1.74),('5815','2013-05-13','16:35:00',1.69),('5815','2013-05-13','16:40:00',1.64),('5815','2013-05-13','16:45:00',1.54),('5815','2013-05-13','16:50:00',1.55),('5815','2013-05-13','16:55:00',1.51),('5815','2013-05-13','17:00:00',1.46),('5815','2013-05-13','17:05:00',1.41),('5815','2013-05-13','17:10:00',1.37),('5815','2013-05-13','17:15:00',1.3),('5815','2013-05-13','17:20:00',1.2),('5815','2013-05-13','17:25:00',1.2),('5815','2013-05-13','17:30:00',1.15),('5815','2013-05-13','17:35:00',1.12),('5815','2013-05-13','17:40:00',1.04),('5815','2013-05-12','08:35:00',1.01),('5815','2013-05-12','08:40:00',1.06),('5815','2013-05-12','08:45:00',1.11),('5815','2013-05-12','08:50:00',1.17),('5815','2013-05-12','08:55:00',1.21),('5815','2013-05-12','09:00:00',1.25),('5815','2013-05-12','09:05:00',1.32),('5815','2013-05-12','09:10:00',1.37),('5815','2013-05-12','09:15:00',1.4),('5815','2013-05-12','09:20:00',1.43),('5815','2013-05-12','09:25:00',1.5),('5815','2013-05-12','09:30:00',1.54),('5815','2013-05-12','09:35:00',1.57),('5815','2013-05-12','09:40:00',1.62),('5815','2013-05-12','09:45:00',1.69),('5815','2013-05-12','09:50:00',1.73),('5815','2013-05-12','09:55:00',1.82),('5815','2013-05-12','10:00:00',1.79),('5815','2013-05-12','10:05:00',1.24),('5815','2013-05-12','10:10:00',1.81),('5815','2013-05-12','10:15:00',2.04),('5815','2013-05-12','10:20:00',1.4),('5815','2013-05-12','10:25:00',1.51),('5815','2013-05-12','10:30:00',2.11),('5815','2013-05-12','10:45:00',2.15),('5815','2013-05-12','10:50:00',2.38),('5815','2013-05-12','10:55:00',1.49),('5815','2013-05-12','11:00:00',1.48),('5815','2013-05-12','11:05:00',1.21),('5815','2013-05-12','11:15:00',1.26),('5815','2013-05-12','11:30:00',1.15),('5815','2013-05-12','11:35:00',1.92),('5815','2013-05-12','11:40:00',1.29),('5815','2013-05-12','11:45:00',1.51),('5815','2013-05-12','11:55:00',1),('5815','2013-05-12','12:10:00',1.84),('5815','2013-05-12','12:15:00',1.37),('5815','2013-05-12','12:25:00',1.45),('5815','2013-05-12','12:30:00',2.48),('5815','2013-05-12','12:35:00',1.71),('5815','2013-05-12','12:40:00',1.1),('5815','2013-05-12','12:45:00',1.17),('5815','2013-05-12','12:50:00',2.08),('5815','2013-05-12','12:55:00',2.75),('5815','2013-05-12','13:00:00',2.42),('5815','2013-05-12','13:05:00',2.46),('5815','2013-05-12','13:10:00',2.64),('5815','2013-05-12','13:15:00',2.77),('5815','2013-05-12','13:20:00',2.55),('5815','2013-05-12','13:25:00',2.7),('5815','2013-05-12','13:30:00',2.73),('5815','2013-05-12','13:35:00',2.42),('5815','2013-05-12','13:40:00',1.35),('5815','2013-05-12','13:45:00',1.25),('5815','2013-05-12','14:05:00',2.81),('5815','2013-05-12','14:10:00',2.76),('5815','2013-05-12','14:15:00',2.64),('5815','2013-05-12','14:20:00',2.52),('5815','2013-05-12','14:25:00',1.73),('5815','2013-05-12','14:30:00',1.36),('5815','2013-05-12','14:35:00',2.54),('5815','2013-05-12','14:40:00',2.54),('5815','2013-05-12','14:45:00',1.03),('5815','2013-05-12','14:50:00',1.49),('5815','2013-05-12','14:55:00',2.6),('5815','2013-05-12','15:00:00',2.01),('5815','2013-05-12','15:05:00',1.18),('5815','2013-05-12','16:30:00',1.16),('5815','2013-05-12','16:40:00',1.29),('5815','2013-05-12','16:45:00',1.53),('5815','2013-05-12','16:50:00',1.97),('5815','2013-05-12','16:55:00',1.78),('5815','2013-05-12','17:00:00',1.65),('5815','2013-05-12','17:05:00',1.35),('5815','2013-05-12','17:10:00',1.14),('5815','2013-05-12','17:15:00',1.67),('5815','2013-05-12','17:20:00',1.66),('5815','2013-05-12','17:25:00',1.38),('5815','2013-05-12','17:30:00',1.05),('5815','2013-05-12','17:35:00',1.31),('5815','2013-05-12','17:40:00',1.19),('5815','2013-05-12','17:45:00',1.16),('5815','2013-05-12','17:50:00',1.03),('5815','2013-05-11','08:15:00',1.04),('5815','2013-05-11','09:30:00',1.45),('5815','2013-05-11','09:45:00',1.24),('5815','2013-05-11','09:50:00',1.63),('5815','2013-05-11','09:55:00',1.81),('5815','2013-05-11','10:00:00',1.93),('5815','2013-05-11','10:05:00',1.46),('5815','2013-05-11','10:15:00',1.43),('5815','2013-05-11','10:45:00',1.93),('5815','2013-05-11','10:50:00',1.35),('5815','2013-05-11','10:55:00',2.51),('5815','2013-05-11','11:00:00',2.32),('5815','2013-05-11','11:15:00',2.19),('5815','2013-05-11','11:20:00',2.5),('5815','2013-05-11','11:25:00',2.51),('5815','2013-05-11','11:30:00',2.64),('5815','2013-05-11','11:35:00',2.52),('5815','2013-05-11','11:40:00',2.53),('5815','2013-05-11','11:45:00',2.67),('5815','2013-05-11','11:50:00',1.49),('5815','2013-05-11','11:55:00',2.69),('5815','2013-05-11','12:00:00',2.08),('5815','2013-05-11','12:05:00',2.08),('5815','2013-05-11','12:10:00',2.26),('5815','2013-05-11','12:15:00',1.36),('5815','2013-05-11','12:40:00',1.18),('5815','2013-05-11','12:45:00',1.48),('5815','2013-05-11','12:50:00',2.9),('5815','2013-05-11','12:55:00',2.03),('5815','2013-05-11','13:00:00',2.29),('5815','2013-05-11','13:10:00',1.82),('5815','2013-05-11','13:15:00',2.5),('5815','2013-05-11','13:20:00',1.08),('5815','2013-05-11','13:25:00',1.21),('5815','2013-05-11','13:30:00',1.97),('5815','2013-05-11','13:35:00',2.65),('5815','2013-05-11','13:40:00',2.74),('5815','2013-05-11','13:45:00',2.12),('5815','2013-05-11','13:50:00',2.42),('5815','2013-05-11','13:55:00',2.38),('5815','2013-05-11','14:00:00',1.61),('5815','2013-05-11','14:05:00',2.88),('5815','2013-05-11','14:10:00',2.01),('5815','2013-05-11','14:15:00',2.28),('5815','2013-05-11','14:20:00',2.73),('5815','2013-05-11','14:25:00',2.65),('5815','2013-05-11','14:30:00',2.61),('5815','2013-05-11','14:35:00',2.59),('5815','2013-05-11','14:40:00',2.55),('5815','2013-05-11','14:45:00',2.47),('5815','2013-05-11','14:50:00',2.5),('5815','2013-05-11','14:55:00',2.49),('5815','2013-05-11','15:00:00',2.11),('5815','2013-05-11','15:05:00',2.46),('5815','2013-05-11','15:10:00',2.35),('5815','2013-05-11','15:15:00',1.93),('5815','2013-05-11','15:20:00',2.08),('5815','2013-05-11','15:25:00',2.33),('5815','2013-05-11','15:30:00',2.2),('5815','2013-05-11','15:35:00',2.21),('5815','2013-05-11','15:40:00',2.18),('5815','2013-05-11','15:45:00',2.14),('5815','2013-05-11','15:50:00',2.08),('5815','2013-05-11','15:55:00',2.01),('5815','2013-05-11','16:00:00',1.96),('5815','2013-05-11','16:05:00',1.77),('5815','2013-05-11','16:10:00',1.86),('5815','2013-05-11','16:15:00',1.86),('5815','2013-05-11','16:20:00',1.8),('5815','2013-05-11','16:25:00',1.72),('5815','2013-05-11','16:30:00',1.68),('5815','2013-05-11','16:35:00',1.67),('5815','2013-05-11','16:40:00',1.7),('5815','2013-05-11','16:45:00',1.77),('5815','2013-05-11','16:50:00',1.75),('5815','2013-05-11','16:55:00',1.56),('5815','2013-05-11','17:00:00',1.87),('5815','2013-05-11','17:05:00',1.61),('5815','2013-05-11','17:10:00',1.59),('5815','2013-05-11','17:15:00',1.73),('5815','2013-05-11','17:20:00',1.5),('5815','2013-05-11','17:25:00',1.27),('5815','2013-05-11','17:30:00',1.27),('5815','2013-05-11','17:35:00',1.06),('5815','2013-05-10','09:30:00',1.3),('5815','2013-05-10','09:40:00',1),('5815','2013-05-10','09:45:00',1.22),('5815','2013-05-10','10:55:00',1.43),('5815','2013-05-10','11:00:00',2.23),('5815','2013-05-10','11:05:00',1.81),('5815','2013-05-10','11:35:00',1.45),('5815','2013-05-10','11:40:00',1.18),('5815','2013-05-10','11:45:00',1.84),('5815','2013-05-10','11:50:00',1.83),('5815','2013-05-10','12:05:00',1.04),('5815','2013-05-10','12:25:00',2.89),('5815','2013-05-10','12:30:00',2.05),('5815','2013-05-10','12:35:00',1.32),('5815','2013-05-10','12:40:00',1.08),('5815','2013-05-10','12:45:00',1.13),('5815','2013-05-10','12:50:00',1.01),('5815','2013-05-10','14:00:00',1.21),('5815','2013-05-10','14:05:00',1.6),('5815','2013-05-10','14:10:00',1.87),('5815','2013-05-10','14:15:00',1.24),('5815','2013-05-10','14:20:00',2.43),('5815','2013-05-10','14:25:00',2.17),('5815','2013-05-10','14:30:00',1.92),('5815','2013-05-10','14:35:00',1.65),('5815','2013-05-10','14:40:00',1.68),('5815','2013-05-10','14:45:00',2),('5815','2013-05-10','14:50:00',2.58),('5815','2013-05-10','14:55:00',2.56),('5815','2013-05-10','15:00:00',2.44),('5815','2013-05-10','15:05:00',2.34),('5815','2013-05-10','15:10:00',2.35),('5815','2013-05-10','15:15:00',2.4),('5815','2013-05-10','15:20:00',2.39),('5815','2013-05-10','15:25:00',2.31),('5815','2013-05-10','15:30:00',2.27),('5815','2013-05-10','15:35:00',2.22),('5815','2013-05-10','15:40:00',2.23),('5815','2013-05-10','15:45:00',2.22),('5815','2013-05-10','15:50:00',1.7),('5815','2013-05-10','15:55:00',2.14),('5815','2013-05-10','16:00:00',1.84),('5815','2013-05-10','16:05:00',2.01),('5815','2013-05-10','16:10:00',2),('5815','2013-05-10','16:15:00',1.23),('5815','2013-05-10','16:20:00',1.97),('5815','2013-05-10','16:25:00',1.89),('5815','2013-05-10','16:30:00',1.75),('5815','2013-05-10','16:35:00',1.57),('5815','2013-05-10','16:40:00',1.65),('5815','2013-05-10','16:45:00',1.64),('5815','2013-05-10','16:50:00',1.34),('5815','2013-05-10','16:55:00',1.41),('5815','2013-05-10','17:00:00',1.45),('5815','2013-05-10','17:05:00',1.46),('5815','2013-05-10','17:10:00',1.37),('5815','2013-05-10','17:15:00',1.28),('5815','2013-05-10','17:20:00',1.15),('5815','2013-05-10','17:25:00',1.32),('5815','2013-05-10','17:30:00',1.06),('5815','2013-05-10','17:35:00',1.05),('5815','2013-05-10','17:45:00',1.06),('5815','2013-05-09','08:10:00',1),('5815','2013-05-09','08:15:00',1.06),('5815','2013-05-09','08:20:00',1),('5815','2013-05-09','08:30:00',1),('5815','2013-05-09','08:35:00',1.01),('5815','2013-05-09','09:05:00',1.23),('5815','2013-05-09','09:10:00',1.41),('5815','2013-05-09','09:15:00',1.48),('5815','2013-05-09','09:20:00',1.44),('5815','2013-05-09','09:25:00',1.27),('5815','2013-05-09','09:30:00',1.29),('5815','2013-05-09','09:35:00',1.59),('5815','2013-05-09','09:40:00',1.55),('5815','2013-05-09','09:45:00',1.43),('5815','2013-05-09','09:50:00',1.48),('5815','2013-05-09','09:55:00',1.7),('5815','2013-05-09','10:00:00',1.38),('5815','2013-05-09','10:05:00',1.65),('5815','2013-05-09','10:10:00',1.68),('5815','2013-05-09','10:15:00',1.83),('5815','2013-05-09','10:20:00',1.01),('5815','2013-05-09','10:25:00',1.41),('5815','2013-05-09','10:30:00',1.61),('5815','2013-05-09','10:40:00',1.75),('5815','2013-05-09','10:45:00',2.26),('5815','2013-05-09','10:50:00',2.31),('5815','2013-05-09','10:55:00',2.18),('5815','2013-05-09','11:00:00',2.06),('5815','2013-05-09','11:05:00',2.21),('5815','2013-05-09','11:10:00',2.19),('5815','2013-05-09','11:15:00',2),('5815','2013-05-09','11:20:00',2.39),('5815','2013-05-09','11:25:00',2.18),('5815','2013-05-09','11:30:00',1.96),('5815','2013-05-09','11:35:00',2.18),('5815','2013-05-09','11:40:00',2.36),('5815','2013-05-09','11:45:00',1.81),('5815','2013-05-09','11:50:00',1.97),('5815','2013-05-09','11:55:00',2.27),('5815','2013-05-09','12:00:00',2.26),('5815','2013-05-09','12:05:00',1.92),('5815','2013-05-09','12:10:00',1.34),('5815','2013-05-09','12:15:00',1.24),('5815','2013-05-09','12:20:00',1.46),('5815','2013-05-09','12:25:00',1.32),('5815','2013-05-09','12:30:00',1.21),('5815','2013-05-09','12:35:00',1.44),('5815','2013-05-09','12:40:00',2.04),('5815','2013-05-09','12:45:00',2.65),('5815','2013-05-09','12:50:00',2.2),('5815','2013-05-09','12:55:00',1.89),('5815','2013-05-09','13:00:00',2.26),('5815','2013-05-09','13:05:00',2.15),('5815','2013-05-09','13:10:00',2.56),('5815','2013-05-09','13:15:00',2.72),('5815','2013-05-09','13:20:00',1.97),('5815','2013-05-09','13:25:00',1.72),('5815','2013-05-09','13:30:00',1.83),('5815','2013-05-09','13:35:00',2.02),('5815','2013-05-09','13:40:00',2.66),('5815','2013-05-09','13:45:00',2.4),('5815','2013-05-09','13:50:00',1.41),('5815','2013-05-09','13:55:00',1.21),('5815','2013-05-09','14:00:00',1.1),('5815','2013-05-09','14:05:00',1.12),('5815','2013-05-09','14:10:00',1.35),('5815','2013-05-09','14:15:00',1.45),('5815','2013-05-09','14:20:00',1.49),('5815','2013-05-09','14:25:00',1.46),('5815','2013-05-09','14:30:00',1.46),('5815','2013-05-09','14:35:00',1.84),('5815','2013-05-09','14:40:00',1.63),('5815','2013-05-09','14:45:00',1.19),('5815','2013-05-09','15:15:00',1.73),('5815','2013-05-09','15:20:00',1.63),('5815','2013-05-09','15:25:00',1.17),('5815','2013-05-09','15:30:00',1.09),('5815','2013-05-09','15:35:00',1.11),('5815','2013-05-09','15:40:00',1.14),('5815','2013-05-09','15:45:00',1.12),('5815','2013-05-09','15:50:00',1.02),('5815','2013-05-09','17:20:00',1.13),('5815','2013-05-09','17:25:00',1.11),('5815','2013-05-09','17:35:00',1.17),('5815','2013-05-08','08:35:00',1.02),('5815','2013-05-08','08:40:00',1.08),('5815','2013-05-08','08:45:00',1.13),('5815','2013-05-08','08:50:00',1.17),('5815','2013-05-08','08:55:00',1.21),('5815','2013-05-08','09:00:00',1.27),('5815','2013-05-08','09:05:00',1.33),('5815','2013-05-08','09:10:00',1.38),('5815','2013-05-08','09:15:00',1.43),('5815','2013-05-08','09:20:00',1.47),('5815','2013-05-08','09:25:00',1.53),('5815','2013-05-08','09:30:00',1.56),('5815','2013-05-08','09:35:00',1.61),('5815','2013-05-08','09:40:00',1.64),('5815','2013-05-08','09:45:00',1.68),('5815','2013-05-08','09:50:00',1.73),('5815','2013-05-08','09:55:00',1.77),('5815','2013-05-08','10:00:00',1.81),('5815','2013-05-08','10:05:00',1.84),('5815','2013-05-08','10:10:00',1.88),('5815','2013-05-08','10:15:00',1.91),('5815','2013-05-08','10:20:00',1.94),('5815','2013-05-08','10:25:00',1.97),('5815','2013-05-08','10:30:00',2),('5815','2013-05-08','10:35:00',2.03),('5815','2013-05-08','10:40:00',2.07),('5815','2013-05-08','10:45:00',2.09),('5815','2013-05-08','10:50:00',2.1),('5815','2013-05-08','10:55:00',2.09),('5815','2013-05-08','11:00:00',2.05),('5815','2013-05-08','11:05:00',2.07),('5815','2013-05-08','11:10:00',2.1),('5815','2013-05-08','11:15:00',2.16),('5815','2013-05-08','11:20:00',2.17),('5815','2013-05-08','11:25:00',2.17),('5815','2013-05-08','11:30:00',2.2),('5815','2013-05-08','11:35:00',2.21),('5815','2013-05-08','11:40:00',2.21),('5815','2013-05-08','11:45:00',2.24),('5815','2013-05-08','11:50:00',2.26),('5815','2013-05-08','11:55:00',2.29),('5815','2013-05-08','12:00:00',2.3),('5815','2013-05-08','12:05:00',2.32),('5815','2013-05-08','12:10:00',2.37),('5815','2013-05-08','12:15:00',2.38),('5815','2013-05-08','12:20:00',2.39),('5815','2013-05-08','12:25:00',2.43),('5815','2013-05-08','12:30:00',2.33),('5815','2013-05-08','12:35:00',2.28),('5815','2013-05-08','12:40:00',2.47),('5815','2013-05-08','12:45:00',2.46),('5815','2013-05-08','12:50:00',2.47),('5815','2013-05-08','12:55:00',2.44),('5815','2013-05-08','13:00:00',2.42),('5815','2013-05-08','13:05:00',2.41),('5815','2013-05-08','13:10:00',2.42),('5815','2013-05-08','13:15:00',2.45),('5815','2013-05-08','13:20:00',2.47),('5815','2013-05-08','13:25:00',2.45),('5815','2013-05-08','13:30:00',2.44),('5815','2013-05-08','13:35:00',2.44),('5815','2013-05-08','13:40:00',2.46),('5815','2013-05-08','13:45:00',2.48),('5815','2013-05-08','13:50:00',2.46),('5815','2013-05-08','13:55:00',2.37),('5815','2013-05-08','14:00:00',1.92),('5815','2013-05-08','14:05:00',2.3),('5815','2013-05-08','14:10:00',1.86),('5815','2013-05-08','14:15:00',1.89),('5815','2013-05-08','14:20:00',2.27),('5815','2013-05-08','14:25:00',1.91),('5815','2013-05-08','14:30:00',2.18),('5815','2013-05-08','14:35:00',2.4),('5815','2013-05-08','14:40:00',2.37),('5815','2013-05-08','14:45:00',2.35),('5815','2013-05-08','14:50:00',2.3),('5815','2013-05-08','14:55:00',2.14),('5815','2013-05-08','15:00:00',2.32),('5815','2013-05-08','15:05:00',2.28),('5815','2013-05-08','15:10:00',2.27),('5815','2013-05-08','15:15:00',2.22),('5815','2013-05-08','15:20:00',2.18),('5815','2013-05-08','15:25:00',2.15),('5815','2013-05-08','15:30:00',2.16),('5815','2013-05-08','15:35:00',2.15),('5815','2013-05-08','15:40:00',2.12),('5815','2013-05-08','15:45:00',2.09),('5815','2013-05-08','15:55:00',2.05),('5815','2013-05-08','16:00:00',1.95),('5815','2013-05-08','16:05:00',1.9),('5815','2013-05-08','16:10:00',1.88),('5815','2013-05-08','16:15:00',1.86),('5815','2013-05-08','16:20:00',1.8),('5815','2013-05-08','16:25:00',1.72),('5815','2013-05-08','16:30:00',1.68),('5815','2013-05-08','16:35:00',1.64),('5815','2013-05-08','16:40:00',1.61),('5815','2013-05-08','16:45:00',1.55),('5815','2013-05-08','16:50:00',1.49),('5815','2013-05-08','16:55:00',1.45),('5815','2013-05-08','17:00:00',1.41),('5815','2013-05-08','17:05:00',1.36),('5815','2013-05-08','17:10:00',1.32),('5815','2013-05-08','17:15:00',1.25),('5815','2013-05-08','17:20:00',1.16),('5815','2013-05-08','17:25:00',1.18),('5815','2013-05-08','17:30:00',1.12),('5815','2013-05-08','17:35:00',1.08),('5815','2013-05-08','17:40:00',1.01),('5815','2013-05-07','08:45:00',1.07),('5815','2013-05-07','08:50:00',1.24),('5815','2013-05-07','08:55:00',1.45),('5815','2013-05-07','09:00:00',1.45),('5815','2013-05-07','09:05:00',1.68),('5815','2013-05-07','09:10:00',1.61),('5815','2013-05-07','09:15:00',1.1),('5815','2013-05-07','09:20:00',1.37),('5815','2013-05-07','09:40:00',1.08),('5815','2013-05-07','09:45:00',1.16),('5815','2013-05-07','10:10:00',1.81),('5815','2013-05-07','10:15:00',1.18),('5815','2013-05-07','11:05:00',2.48),('5815','2013-05-07','11:10:00',2.38),('5815','2013-05-07','11:15:00',2.35),('5815','2013-05-07','11:20:00',2.26),('5815','2013-05-07','11:25:00',2.34),('5815','2013-05-07','11:30:00',2.45),('5815','2013-05-07','11:35:00',2.35),('5815','2013-05-07','11:40:00',1.96),('5815','2013-05-07','11:45:00',1.14),('5815','2013-05-07','12:00:00',2.26),('5815','2013-05-07','12:05:00',1.77),('5815','2013-05-07','12:20:00',1.55),('5815','2013-05-07','12:25:00',2.79),('5815','2013-05-07','12:45:00',1),('5815','2013-05-07','12:55:00',1.41),('5815','2013-05-07','13:00:00',1.98),('5815','2013-05-07','13:05:00',2.92),('5815','2013-05-07','13:10:00',2.95),('5815','2013-05-07','13:15:00',1.8),('5815','2013-05-07','13:45:00',2.93),('5815','2013-05-07','13:50:00',2.86),('5815','2013-05-07','13:55:00',2.5),('5815','2013-05-07','14:00:00',2.24),('5815','2013-05-07','14:05:00',1.84),('5815','2013-05-07','14:10:00',1.98),('5815','2013-05-07','14:30:00',1.04),('5815','2013-05-07','14:40:00',2.58),('5815','2013-05-07','14:45:00',1.77),('5815','2013-05-07','14:50:00',1.89),('5815','2013-05-07','14:55:00',2.5),('5815','2013-05-07','15:00:00',2.3),('5815','2013-05-07','15:05:00',2.35),('5815','2013-05-07','15:10:00',1.91),('5815','2013-05-07','15:15:00',2.36),('5815','2013-05-07','15:20:00',2.27),('5815','2013-05-07','15:25:00',2.25),('5815','2013-05-07','15:30:00',2.21),('5815','2013-05-07','15:35:00',2.14),('5815','2013-05-07','15:40:00',2.11),('5815','2013-05-07','15:45:00',2.08),('5815','2013-05-07','15:50:00',2.04),('5815','2013-05-07','15:55:00',2.01),('5815','2013-05-07','16:00:00',1.99),('5815','2013-05-07','16:05:00',1.94),('5815','2013-05-07','16:10:00',1.93),('5815','2013-05-07','16:15:00',1.9),('5815','2013-05-07','16:20:00',1.84),('5815','2013-05-07','16:25:00',1.72),('5815','2013-05-07','16:30:00',1.78),('5815','2013-05-07','16:35:00',1.75),('5815','2013-05-07','16:40:00',1.72),('5815','2013-05-07','16:50:00',1.44),('5815','2013-05-07','16:55:00',1.66),('5815','2013-05-07','17:00:00',1.7),('5815','2013-05-07','17:05:00',1.36),('5815','2013-05-07','17:10:00',1.54),('5815','2013-05-07','17:15:00',1.45),('5815','2013-05-07','17:20:00',1.08),('5815','2013-05-07','17:25:00',1.26),('5815','2013-05-07','17:30:00',1.33),('5815','2013-05-07','17:35:00',1.31),('5815','2013-05-07','17:40:00',1.26),('5815','2013-05-07','17:45:00',1.28),('5815','2013-05-07','17:50:00',1.25),('5815','2013-05-06','08:35:00',1.05),('5815','2013-05-06','08:40:00',1.08),('5815','2013-05-06','08:45:00',1.14),('5815','2013-05-06','08:50:00',1.13),('5815','2013-05-06','08:55:00',1.1),('5815','2013-05-06','09:00:00',1.45),('5815','2013-05-06','09:05:00',1.59),('5815','2013-05-06','09:10:00',1.31),('5815','2013-05-06','09:15:00',1.39),('5815','2013-05-06','09:35:00',1.18),('5815','2013-05-06','09:40:00',1.2),('5815','2013-05-06','09:50:00',1.27),('5815','2013-05-06','11:20:00',1.84),('5815','2013-05-06','11:25:00',1.75),('5815','2013-05-06','12:05:00',1.04),('5815','2013-05-06','12:15:00',2.26),('5815','2013-05-06','12:25:00',1.25),('5815','2013-05-06','12:30:00',2.91),('5815','2013-05-06','13:40:00',2.19),('5815','2013-05-06','13:45:00',2.65),('5815','2013-05-06','13:50:00',2.82),('5815','2013-05-06','13:55:00',2.76),('5815','2013-05-06','14:00:00',2.71),('5815','2013-05-06','14:05:00',2.67),('5815','2013-05-06','14:10:00',2.68),('5815','2013-05-06','14:15:00',2.68),('5815','2013-05-06','14:20:00',2.62),('5815','2013-05-06','14:25:00',1.66),('5815','2013-05-06','14:30:00',2.72),('5815','2013-05-06','14:35:00',1.75),('5815','2013-05-06','14:40:00',2.9),('5815','2013-05-06','14:45:00',2.31),('5815','2013-05-06','14:50:00',2.12),('5815','2013-05-06','14:55:00',2.56),('5815','2013-05-06','15:00:00',1.87),('5815','2013-05-06','15:05:00',2.59),('5815','2013-05-06','15:10:00',2.02),('5815','2013-05-06','15:15:00',2.25),('5815','2013-05-06','15:20:00',1.97),('5815','2013-05-06','15:25:00',1.36),('5815','2013-05-06','15:30:00',1.26),('5815','2013-05-06','15:35:00',1.76),('5815','2013-05-06','15:40:00',1.22),('5815','2013-05-06','15:45:00',1.49),('5815','2013-05-06','15:55:00',1.04),('5815','2013-05-06','16:00:00',1.85),('5815','2013-05-06','16:05:00',1.51),('5815','2013-05-06','16:15:00',1.03),('5815','2013-05-06','16:20:00',2.42),('5815','2013-05-06','16:25:00',2.34),('5815','2013-05-06','16:30:00',2.18),('5815','2013-05-06','16:35:00',2.12),('5815','2013-05-06','16:40:00',2.15),('5815','2013-05-06','16:45:00',1.55),('5815','2013-05-06','16:50:00',1.61),('5815','2013-05-06','16:55:00',1.46),('5815','2013-05-06','17:00:00',1.56),('5815','2013-05-06','17:05:00',1.52),('5815','2013-05-06','17:10:00',1.2),('5815','2013-05-05','09:00:00',1.03),('5815','2013-05-05','10:20:00',1.08),('5815','2013-05-05','10:45:00',1.42),('5815','2013-05-05','10:50:00',1.44),('5815','2013-05-05','10:55:00',1.15),('5815','2013-05-05','11:00:00',1.14),('5815','2013-05-05','11:05:00',1.14),('5815','2013-05-05','11:10:00',1.09),('5815','2013-05-05','11:20:00',1.25),('5815','2013-05-05','11:25:00',1.2),('5815','2013-05-05','11:30:00',1.16),('5815','2013-05-05','11:40:00',1.69),('5815','2013-05-05','11:45:00',2.19),('5815','2013-05-05','11:50:00',1.84),('5815','2013-05-05','12:05:00',1.12),('5815','2013-05-05','12:10:00',2.57),('5815','2013-05-05','12:15:00',1.78),('5815','2013-05-05','12:20:00',1.49),('5815','2013-05-05','12:25:00',1.55),('5815','2013-05-05','12:30:00',2.18),('5815','2013-05-05','12:35:00',2.05),('5815','2013-05-05','12:40:00',1.6),('5815','2013-05-05','12:45:00',1.36),('5815','2013-05-05','12:50:00',1.54),('5815','2013-05-05','12:55:00',2.4),('5815','2013-05-05','13:05:00',1.82),('5815','2013-05-05','13:10:00',2.5),('5815','2013-05-05','13:15:00',2.11),('5815','2013-05-05','13:20:00',2.05),('5815','2013-05-05','13:25:00',1.5),('5815','2013-05-05','13:30:00',2.15),('5815','2013-05-05','13:35:00',1.44),('5815','2013-05-05','13:40:00',2.19),('5815','2013-05-05','13:45:00',2.77),('5815','2013-05-05','13:50:00',2.45),('5815','2013-05-05','13:55:00',2.52),('5815','2013-05-05','14:00:00',1.81),('5815','2013-05-05','14:05:00',2.85),('5815','2013-05-05','14:10:00',1.49),('5815','2013-05-05','14:15:00',1.86),('5815','2013-05-05','14:20:00',2.19),('5815','2013-05-05','14:25:00',1.59),('5815','2013-05-05','14:30:00',2.1),('5815','2013-05-05','14:35:00',2.13),('5815','2013-05-05','14:40:00',1.12),('5815','2013-05-05','14:45:00',2.1),('5815','2013-05-05','14:50:00',1.1),('5815','2013-05-05','14:55:00',2.04),('5815','2013-05-05','15:00:00',2.58),('5815','2013-05-05','15:05:00',1.62),('5815','2013-05-05','15:10:00',2.22),('5815','2013-05-05','15:15:00',1.39),('5815','2013-05-05','15:20:00',1.04),('5815','2013-05-05','15:25:00',2),('5815','2013-05-05','15:30:00',1.29),('5815','2013-05-05','15:40:00',1.01),('5815','2013-05-05','15:55:00',1.26),('5815','2013-05-05','16:00:00',1.15),('5815','2013-05-05','16:25:00',1.24),('5815','2013-05-05','16:30:00',1.31),('5815','2013-05-05','16:35:00',1.21),('5815','2013-05-05','16:40:00',1.64),('5815','2013-05-05','16:45:00',1.69),('5815','2013-05-05','16:50:00',1.33),('5815','2013-05-05','16:55:00',1.69),('5815','2013-05-04','08:25:00',1.13),('5815','2013-05-04','08:30:00',1.16),('5815','2013-05-04','08:35:00',1.02),('5815','2013-05-04','08:40:00',1.11),('5815','2013-05-04','09:25:00',1.03),('5815','2013-05-04','09:30:00',1.13),('5815','2013-05-04','09:40:00',1.21),('5815','2013-05-04','09:45:00',1.57),('5815','2013-05-04','09:50:00',1.16),('5815','2013-05-04','09:55:00',1.92),('5815','2013-05-04','10:00:00',1.34),('5815','2013-05-04','10:05:00',1.27),('5815','2013-05-04','10:10:00',1.23),('5815','2013-05-04','10:15:00',1.05),('5815','2013-05-04','10:20:00',1.75),('5815','2013-05-04','10:25:00',1.33),('5815','2013-05-04','10:30:00',1.46),('5815','2013-05-04','10:35:00',1.38),('5815','2013-05-04','10:40:00',1.33),('5815','2013-05-04','10:45:00',1.37),('5815','2013-05-04','10:50:00',1.06),('5815','2013-05-04','11:05:00',1.03),('5815','2013-05-04','11:20:00',1.3),('5815','2013-05-04','11:25:00',1.88),('5815','2013-05-04','11:30:00',1.54),('5815','2013-05-04','11:35:00',2.06),('5815','2013-05-04','11:40:00',1.81),('5815','2013-05-04','11:45:00',1.67),('5815','2013-05-04','11:50:00',1.49),('5815','2013-05-04','11:55:00',2),('5815','2013-05-04','12:00:00',1.44),('5815','2013-05-04','12:05:00',1.49),('5815','2013-05-04','12:10:00',1.36),('5815','2013-05-04','12:15:00',1.62),('5815','2013-05-04','12:20:00',1.77),('5815','2013-05-04','12:25:00',1.96),('5815','2013-05-04','12:30:00',2.08),('5815','2013-05-04','12:35:00',2.27),('5815','2013-05-04','12:40:00',2.01),('5815','2013-05-04','12:45:00',1.99),('5815','2013-05-04','12:50:00',1.95),('5815','2013-05-04','12:55:00',2.27),('5815','2013-05-04','13:00:00',2.41),('5815','2013-05-04','13:05:00',2.57),('5815','2013-05-04','13:10:00',2.53),('5815','2013-05-04','13:15:00',2.62),('5815','2013-05-04','13:20:00',2.21),('5815','2013-05-04','13:25:00',1.29),('5815','2013-05-04','13:35:00',2.21),('5815','2013-05-04','13:40:00',2.46),('5815','2013-05-04','13:45:00',2.53),('5815','2013-05-04','13:50:00',2.53),('5815','2013-05-04','13:55:00',2.53),('5815','2013-05-04','14:00:00',2.57),('5815','2013-05-04','14:05:00',2.64),('5815','2013-05-04','14:10:00',1.97),('5815','2013-05-04','14:15:00',1.71),('5815','2013-05-04','14:20:00',2.3),('5815','2013-05-04','14:25:00',2.33),('5815','2013-05-04','14:30:00',2.27),('5815','2013-05-04','14:35:00',2.24),('5815','2013-05-04','14:40:00',2.21),('5815','2013-05-04','14:45:00',2.22),('5815','2013-05-04','14:50:00',2.2),('5815','2013-05-04','14:55:00',2.17),('5815','2013-05-04','15:00:00',2.14),('5815','2013-05-04','15:05:00',2.13),('5815','2013-05-04','15:10:00',2.1),('5815','2013-05-04','15:15:00',2.09),('5815','2013-05-04','15:20:00',2.06),('5815','2013-05-04','15:25:00',2.04),('5815','2013-05-04','15:30:00',2.01),('5815','2013-05-04','15:35:00',2),('5815','2013-05-04','15:40:00',1.96),('5815','2013-05-04','15:45:00',1.94),('5815','2013-05-04','15:50:00',1.92),('5815','2013-05-04','15:55:00',1.88),('5815','2013-05-04','16:00:00',1.85),('5815','2013-05-04','16:05:00',1.82),('5815','2013-05-04','16:10:00',1.78),('5815','2013-05-04','16:15:00',1.76),('5815','2013-05-04','16:20:00',1.72),('5815','2013-05-04','16:25:00',1.69),('5815','2013-05-04','16:30:00',1.64),('5815','2013-05-04','16:35:00',1.59),('5815','2013-05-04','16:40:00',1.56),('5815','2013-05-04','16:45:00',1.51),('5815','2013-05-04','16:50:00',1.44),('5815','2013-05-04','16:55:00',1.39),('5815','2013-05-04','17:00:00',1.35),('5815','2013-05-04','17:05:00',1.28),('5815','2013-05-04','17:10:00',1.21),('5815','2013-05-04','17:15:00',1.19),('5815','2013-05-04','17:20:00',1.12),('5815','2013-05-04','17:25:00',1.02),('5815','2013-05-04','17:30:00',1.03),('5815','2013-05-04','17:35:00',1),('5815','2013-05-03','08:45:00',1.02),('5815','2013-05-03','08:50:00',1.07),('5815','2013-05-03','08:55:00',1.12),('5815','2013-05-03','09:00:00',1.16),('5815','2013-05-03','09:05:00',1.22),('5815','2013-05-03','09:10:00',1.25),('5815','2013-05-03','09:15:00',1.29),('5815','2013-05-03','09:20:00',1.36),('5815','2013-05-03','09:25:00',1.39),('5815','2013-05-03','09:30:00',1.42),('5815','2013-05-03','09:35:00',1.47),('5815','2013-05-03','09:40:00',1.52),('5815','2013-05-03','09:45:00',1.58),('5815','2013-05-03','09:50:00',1.63),('5815','2013-05-03','09:55:00',1.66),('5815','2013-05-03','10:00:00',1.72),('5815','2013-05-03','10:05:00',1.74),('5815','2013-05-03','10:10:00',1.78),('5815','2013-05-03','10:15:00',1.82),('5815','2013-05-03','10:20:00',1.87),('5815','2013-05-03','10:25:00',1.89),('5815','2013-05-03','10:30:00',1.93),('5815','2013-05-03','10:35:00',1.95),('5815','2013-05-03','10:40:00',1.95),('5815','2013-05-03','10:45:00',1.96),('5815','2013-05-03','10:50:00',1.95),('5815','2013-05-03','10:55:00',1.94),('5815','2013-05-03','11:00:00',1.93),('5815','2013-05-03','11:05:00',1.94),('5815','2013-05-03','11:10:00',1.87),('5815','2013-05-03','11:15:00',1.78),('5815','2013-05-03','11:20:00',1.91),('5815','2013-05-03','11:25:00',2),('5815','2013-05-03','11:30:00',1.89),('5815','2013-05-03','11:35:00',1.98),('5815','2013-05-03','11:40:00',1.92),('5815','2013-05-03','11:45:00',1.96),('5815','2013-05-03','11:50:00',1.99),('5815','2013-05-03','11:55:00',1.94),('5815','2013-05-03','12:00:00',1.94),('5815','2013-05-03','12:05:00',2.02),('5815','2013-05-03','12:10:00',2.04),('5815','2013-05-03','12:15:00',2.08),('5815','2013-05-03','12:20:00',2.13),('5815','2013-05-03','12:25:00',2.18),('5815','2013-05-03','12:30:00',2.19),('5815','2013-05-03','12:35:00',2.23),('5815','2013-05-03','12:40:00',2.22),('5815','2013-05-03','12:45:00',2.24),('5815','2013-05-03','12:50:00',2.18),('5815','2013-05-03','12:55:00',2.13),('5815','2013-05-03','13:00:00',2.1),('5815','2013-05-03','13:05:00',1.95),('5815','2013-05-03','13:10:00',2),('5815','2013-05-03','13:15:00',2.29),('5815','2013-05-03','13:20:00',2.35),('5815','2013-05-03','13:25:00',2.24),('5815','2013-05-03','13:30:00',2.22),('5815','2013-05-03','13:35:00',2.15),('5815','2013-05-03','13:40:00',2.19),('5815','2013-05-03','13:45:00',2.18),('5815','2013-05-03','13:50:00',1.92),('5815','2013-05-03','13:55:00',2.04),('5815','2013-05-03','14:00:00',2.09),('5815','2013-05-03','14:05:00',2.16),('5815','2013-05-03','14:10:00',2.05),('5815','2013-05-03','14:15:00',2.07),('5815','2013-05-03','14:20:00',2.11),('5815','2013-05-03','14:25:00',1.91),('5815','2013-05-03','14:30:00',2.03),('5815','2013-05-03','14:35:00',1.9),('5815','2013-05-03','14:40:00',1.98),('5815','2013-05-03','14:45:00',1.97),('5815','2013-05-03','14:50:00',1.85),('5815','2013-05-03','14:55:00',1.91),('5815','2013-05-03','15:00:00',1.94),('5815','2013-05-03','15:05:00',2.02),('5815','2013-05-03','15:10:00',1.87),('5815','2013-05-03','15:15:00',1.92),('5815','2013-05-03','15:20:00',1.94),('5815','2013-05-03','15:25:00',1.97),('5815','2013-05-03','15:30:00',1.94),('5815','2013-05-03','15:35:00',1.86),('5815','2013-05-03','15:40:00',1.81),('5815','2013-05-03','15:45:00',1.85),('5815','2013-05-03','15:50:00',1.84),('5815','2013-05-03','15:55:00',1.81),('5815','2013-05-03','16:00:00',1.77),('5815','2013-05-03','16:05:00',1.75),('5815','2013-05-03','16:10:00',1.71),('5815','2013-05-03','16:15:00',1.67),('5815','2013-05-03','16:20:00',1.62),('5815','2013-05-03','16:25:00',1.59),('5815','2013-05-03','16:30:00',1.55),('5815','2013-05-03','16:35:00',1.51),('5815','2013-05-03','16:40:00',1.47),('5815','2013-05-03','16:45:00',1.42),('5815','2013-05-03','16:50:00',1.35),('5815','2013-05-03','16:55:00',1.3),('5815','2013-05-03','17:00:00',1.29),('5815','2013-05-03','17:05:00',1.21),('5815','2013-05-03','17:15:00',1.05),('5815','2013-05-03','17:20:00',1.07),('5815','2013-05-02','08:35:00',1.02),('5815','2013-05-02','08:40:00',1.05),('5815','2013-05-02','08:45:00',1.1),('5815','2013-05-02','08:50:00',1.09),('5815','2013-05-02','08:55:00',1.1),('5815','2013-05-02','09:00:00',1.19),('5815','2013-05-02','09:05:00',1.27),('5815','2013-05-02','09:10:00',1.29),('5815','2013-05-02','09:15:00',1.34),('5815','2013-05-02','09:20:00',1.39),('5815','2013-05-02','09:25:00',1.43),('5815','2013-05-02','09:30:00',1.47),('5815','2013-05-02','09:35:00',1.53),('5815','2013-05-02','09:40:00',1.58),('5815','2013-05-02','09:45:00',1.61),('5815','2013-05-02','09:50:00',1.66),('5815','2013-05-02','09:55:00',1.69),('5815','2013-05-02','10:00:00',1.74),('5815','2013-05-02','10:05:00',1.77),('5815','2013-05-02','10:10:00',1.82),('5815','2013-05-02','10:15:00',1.84),('5815','2013-05-02','10:20:00',1.88),('5815','2013-05-02','10:25:00',1.9),('5815','2013-05-02','10:30:00',1.94),('5815','2013-05-02','10:35:00',1.95),('5815','2013-05-02','10:40:00',1.96),('5815','2013-05-02','10:45:00',2.01),('5815','2013-05-02','10:50:00',2.03),('5815','2013-05-02','10:55:00',2.05),('5815','2013-05-02','11:00:00',2.04),('5815','2013-05-02','11:05:00',2.02),('5815','2013-05-02','11:10:00',2.07),('5815','2013-05-02','11:15:00',2.08),('5815','2013-05-02','11:20:00',2.12),('5815','2013-05-02','11:25:00',2.15),('5815','2013-05-02','11:30:00',2.16),('5815','2013-05-02','11:35:00',2.2),('5815','2013-05-02','11:40:00',2.22),('5815','2013-05-02','11:45:00',2.23),('5815','2013-05-02','11:50:00',2.25),('5815','2013-05-02','11:55:00',2.26),('5815','2013-05-02','12:00:00',2.26),('5815','2013-05-02','12:05:00',2.27),('5815','2013-05-02','12:10:00',2.3),('5815','2013-05-02','12:15:00',2.31),('5815','2013-05-02','12:20:00',2.32),('5815','2013-05-02','12:25:00',2.33),('5815','2013-05-02','12:30:00',2.33),('5815','2013-05-02','12:35:00',2.31),('5815','2013-05-02','12:40:00',2.31),('5815','2013-05-02','12:45:00',2.31),('5815','2013-05-02','12:50:00',2.34),('5815','2013-05-02','12:55:00',2.38),('5815','2013-05-02','13:00:00',2.35),('5815','2013-05-02','13:05:00',2.34),('5815','2013-05-02','13:10:00',2.35),('5815','2013-05-02','13:15:00',2.34),('5815','2013-05-02','13:20:00',2.38),('5815','2013-05-02','13:25:00',2.37),('5815','2013-05-02','13:30:00',2.35),('5815','2013-05-02','13:35:00',2.32),('5815','2013-05-02','13:40:00',2.23),('5815','2013-05-02','13:45:00',2.23),('5815','2013-05-02','13:50:00',2.2),('5815','2013-05-02','13:55:00',2.25),('5815','2013-05-02','14:00:00',2.23),('5815','2013-05-02','14:05:00',2.13),('5815','2013-05-02','14:10:00',2.15),('5815','2013-05-02','14:15:00',2.1),('5815','2013-05-02','14:20:00',2.16),('5815','2013-05-02','14:25:00',2.15),('5815','2013-05-02','14:30:00',2.17),('5815','2013-05-02','14:35:00',2.2),('5815','2013-05-02','14:40:00',2.15),('5815','2013-05-02','14:45:00',2.14),('5815','2013-05-02','14:50:00',2.14),('5815','2013-05-02','14:55:00',2.13),('5815','2013-05-02','15:00:00',2.12),('5815','2013-05-02','15:05:00',2.1),('5815','2013-05-02','15:10:00',2.12),('5815','2013-05-02','15:15:00',2.11),('5815','2013-05-02','15:20:00',2.07),('5815','2013-05-02','15:25:00',2.05),('5815','2013-05-02','15:30:00',2.03),('5815','2013-05-02','15:35:00',2.01),('5815','2013-05-02','15:40:00',1.98),('5815','2013-05-02','15:45:00',1.96),('5815','2013-05-02','15:50:00',1.91),('5815','2013-05-02','15:55:00',1.87),('5815','2013-05-02','16:00:00',1.86),('5815','2013-05-02','16:05:00',1.82),('5815','2013-05-02','16:10:00',1.79),('5815','2013-05-02','16:15:00',1.74),('5815','2013-05-02','16:20:00',1.68),('5815','2013-05-02','16:25:00',1.63),('5815','2013-05-02','16:30:00',1.63),('5815','2013-05-02','16:35:00',1.58),('5815','2013-05-02','16:40:00',1.55),('5815','2013-05-02','16:45:00',1.49),('5815','2013-05-02','16:50:00',1.43),('5815','2013-05-02','16:55:00',1.37),('5815','2013-05-02','17:00:00',1.36),('5815','2013-05-02','17:05:00',1.28),('5815','2013-05-02','17:10:00',1.23),('5815','2013-05-02','17:15:00',1.18),('5815','2013-05-02','17:20:00',1.08),('5815','2013-05-02','17:25:00',1.03),('5815','2013-05-01','09:35:00',1.15),('5815','2013-05-01','09:45:00',1.4),('5815','2013-05-01','10:25:00',1.04),('5815','2013-05-01','10:30:00',1.65),('5815','2013-05-01','10:35:00',1.43),('5815','2013-05-01','10:40:00',2.02),('5815','2013-05-01','10:45:00',1.64),('5815','2013-05-01','10:50:00',1.86),('5815','2013-05-01','10:55:00',2.17),('5815','2013-05-01','11:00:00',2.25),('5815','2013-05-01','11:05:00',2.1),('5815','2013-05-01','11:10:00',1.68),('5815','2013-05-01','11:15:00',1.61),('5815','2013-05-01','11:20:00',1.45),('5815','2013-05-01','11:25:00',2.2),('5815','2013-05-01','11:30:00',2.24),('5815','2013-05-01','11:35:00',2.23),('5815','2013-05-01','11:40:00',2.19),('5815','2013-05-01','11:45:00',2.2),('5815','2013-05-01','11:50:00',2.21),('5815','2013-05-01','11:55:00',2.22),('5815','2013-05-01','12:00:00',2.22),('5815','2013-05-01','12:05:00',2.21),('5815','2013-05-01','12:10:00',2.2),('5815','2013-05-01','12:15:00',2.23),('5815','2013-05-01','12:20:00',2.26),('5815','2013-05-01','12:25:00',2.26),('5815','2013-05-01','12:30:00',2.31),('5815','2013-05-01','12:35:00',2.35),('5815','2013-05-01','12:40:00',2.38),('5815','2013-05-01','12:45:00',2.39),('5815','2013-05-01','12:50:00',2.4),('5815','2013-05-01','12:55:00',2.42),('5815','2013-05-01','13:00:00',2.45),('5815','2013-05-01','13:05:00',2.45),('5815','2013-05-01','13:10:00',2.48),('5815','2013-05-01','13:15:00',2.48),('5815','2013-05-01','13:20:00',2.48),('5815','2013-05-01','13:25:00',2.48),('5815','2013-05-01','13:30:00',2.48),('5815','2013-05-01','13:35:00',2.48),('5815','2013-05-01','13:40:00',2.47),('5815','2013-05-01','13:45:00',2.45),('5815','2013-05-01','13:50:00',2.43),('5815','2013-05-01','13:55:00',2.43),('5815','2013-05-01','14:00:00',2.41),('5815','2013-05-01','14:05:00',2.37),('5815','2013-05-01','14:10:00',2.37),('5815','2013-05-01','14:15:00',2.36),('5815','2013-05-01','14:20:00',2.35),('5815','2013-05-01','14:25:00',2.33),('5815','2013-05-01','14:30:00',2.31),('5815','2013-05-01','14:35:00',2.29),('5815','2013-05-01','14:40:00',2.28),('5815','2013-05-01','14:45:00',2.25),('5815','2013-05-01','14:50:00',2.26),('5815','2013-05-01','14:55:00',2.23),('5815','2013-05-01','15:00:00',2.21),('5815','2013-05-01','15:05:00',2.18),('5815','2013-05-01','15:10:00',2.17),('5815','2013-05-01','15:15:00',2.13),('5815','2013-05-01','15:20:00',2.1),('5815','2013-05-01','15:25:00',2.08),('5815','2013-05-01','15:30:00',2.03),('5815','2013-05-01','15:35:00',1.97),('5815','2013-05-01','15:40:00',1.96),('5815','2013-05-01','15:45:00',1.92),('5815','2013-05-01','15:50:00',1.9),('5815','2013-05-01','15:55:00',1.87),('5815','2013-05-01','16:00:00',1.83),('5815','2013-05-01','16:05:00',1.81),('5815','2013-05-01','16:10:00',1.78),('5815','2013-05-01','16:15:00',1.74),('5815','2013-05-01','16:20:00',1.72),('5815','2013-05-01','16:25:00',1.67),('5815','2013-05-01','16:30:00',1.62),('5815','2013-05-01','16:35:00',1.57),('5815','2013-05-01','16:40:00',1.53),('5815','2013-05-01','16:45:00',1.49),('5815','2013-05-01','16:50:00',1.44),('5815','2013-05-01','16:55:00',1.39),('5815','2013-05-01','17:00:00',1.36),('5815','2013-05-01','17:05:00',1.3),('5815','2013-05-01','17:10:00',1.23),('5815','2013-05-01','17:15:00',1.21),('5815','2013-05-01','17:20:00',1.13),('5815','2013-05-01','17:25:00',1.05),('5815','2013-05-01','17:30:00',1.03),('5815','2013-05-01','17:35:00',1),('5815','2013-04-30','08:50:00',1.01),('5815','2013-04-30','08:55:00',1.06),('5815','2013-04-30','09:00:00',1.12),('5815','2013-04-30','09:05:00',1.17),('5815','2013-04-30','09:10:00',1.2),('5815','2013-04-30','09:15:00',1.25),('5815','2013-04-30','09:20:00',1.28),('5815','2013-04-30','09:25:00',1.31),('5815','2013-04-30','09:30:00',1.34),('5815','2013-04-30','09:35:00',1.37),('5815','2013-04-30','09:40:00',1.42),('5815','2013-04-30','09:45:00',1.46),('5815','2013-04-30','09:50:00',1.5),('5815','2013-04-30','09:55:00',1.53),('5815','2013-04-30','10:00:00',1.57),('5815','2013-04-30','10:05:00',1.58),('5815','2013-04-30','10:10:00',1.63),('5815','2013-04-30','10:15:00',1.68),('5815','2013-04-30','10:20:00',1.72),('5815','2013-04-30','10:25:00',1.75),('5815','2013-04-30','10:30:00',1.78),('5815','2013-04-30','10:35:00',1.81),('5815','2013-04-30','10:40:00',1.85),('5815','2013-04-30','10:45:00',1.98),('5815','2013-04-30','10:50:00',2),('5815','2013-04-30','10:55:00',2.01),('5815','2013-04-30','11:00:00',2),('5815','2013-04-30','11:05:00',2.02),('5815','2013-04-30','11:10:00',2.05),('5815','2013-04-30','11:15:00',1.94),('5815','2013-04-30','11:20:00',1.96),('5815','2013-04-30','11:25:00',1.91),('5815','2013-04-30','11:30:00',1.89),('5815','2013-04-30','11:35:00',1.96),('5815','2013-04-30','11:40:00',1.63),('5815','2013-04-30','11:45:00',1.51),('5815','2013-04-30','11:50:00',1.83),('5815','2013-04-30','11:55:00',2.23),('5815','2013-04-30','12:00:00',2.22),('5815','2013-04-30','12:05:00',2.2),('5815','2013-04-30','12:10:00',2.2),('5815','2013-04-30','12:15:00',2.19),('5815','2013-04-30','12:20:00',2.19),('5815','2013-04-30','12:25:00',2.22),('5815','2013-04-30','12:30:00',2.25),('5815','2013-04-30','12:35:00',2.28),('5815','2013-04-30','12:40:00',2.33),('5815','2013-04-30','12:45:00',2.23),('5815','2013-04-30','12:50:00',1.85),('5815','2013-04-30','13:05:00',1),('5815','2013-04-30','13:10:00',1.21),('5815','2013-04-30','13:15:00',2.1),('5815','2013-04-30','13:20:00',2.69),('5815','2013-04-30','13:25:00',2.16),('5815','2013-04-30','13:30:00',1.41),('5815','2013-04-30','13:35:00',1.86),('5815','2013-04-30','13:40:00',2.14),('5815','2013-04-30','13:45:00',2.56),('5815','2013-04-30','13:50:00',2.41),('5815','2013-04-30','13:55:00',2.34),('5815','2013-04-30','14:00:00',2.27),('5815','2013-04-30','14:05:00',2.21),('5815','2013-04-30','14:10:00',2.21),('5815','2013-04-30','14:15:00',1.94),('5815','2013-04-30','14:20:00',2.3),('5815','2013-04-30','14:25:00',2.31),('5815','2013-04-30','14:30:00',2.32),('5815','2013-04-30','14:35:00',2.27),('5815','2013-04-30','14:40:00',2),('5815','2013-04-30','14:45:00',2.14),('5815','2013-04-30','14:50:00',1.84),('5815','2013-04-30','14:55:00',1.71),('5815','2013-04-30','15:00:00',1.74),('5815','2013-04-30','15:05:00',2.02),('5815','2013-04-30','15:10:00',2.03),('5815','2013-04-30','15:15:00',1.96),('5815','2013-04-30','15:20:00',1.87),('5815','2013-04-30','15:25:00',1.93),('5815','2013-04-30','15:30:00',1.62),('5815','2013-04-30','15:35:00',1.38),('5815','2013-04-30','15:40:00',1.37),('5815','2013-04-30','15:45:00',1.33),('5815','2013-04-30','15:50:00',1.01),('5815','2013-04-30','16:00:00',1.14),('5815','2013-04-30','16:05:00',1.12),('5815','2013-04-29','09:10:00',1.13),('5815','2013-04-29','09:15:00',1.39),('5815','2013-04-29','09:20:00',1.39),('5815','2013-04-29','09:25:00',1.5),('5815','2013-04-29','09:30:00',1.48),('5815','2013-04-29','09:35:00',1.26),('5815','2013-04-29','09:45:00',1.03),('5815','2013-04-29','09:50:00',1.4),('5815','2013-04-29','09:55:00',1.56),('5815','2013-04-29','10:00:00',1.8),('5815','2013-04-29','10:05:00',1.89),('5815','2013-04-29','10:10:00',1.55),('5815','2013-04-29','10:15:00',1.35),('5815','2013-04-29','10:20:00',1.23),('5815','2013-04-29','10:25:00',1.33),('5815','2013-04-29','10:30:00',1.14),('5815','2013-04-29','10:35:00',1.07),('5815','2013-04-29','11:15:00',1.01),('5815','2013-04-29','11:20:00',1.17),('5815','2013-04-29','11:25:00',1.07),('5815','2013-04-29','11:30:00',1.05),('5815','2013-04-29','11:35:00',1.1),('5815','2013-04-29','11:40:00',1.09),('5815','2013-04-29','12:35:00',1.23),('5815','2013-04-29','12:40:00',2.36),('5815','2013-04-29','12:45:00',2.58),('5815','2013-04-29','12:50:00',2.46),('5815','2013-04-29','12:55:00',2.23),('5815','2013-04-29','13:00:00',2.32),('5815','2013-04-29','13:05:00',2.28),('5815','2013-04-29','13:10:00',2.35),('5815','2013-04-29','13:15:00',2.31),('5815','2013-04-29','13:20:00',2.28),('5815','2013-04-29','13:25:00',2.28),('5815','2013-04-29','13:30:00',2.26),('5815','2013-04-29','13:35:00',2.24),('5815','2013-04-29','13:40:00',2.24),('5815','2013-04-29','13:45:00',2.22),('5815','2013-04-29','13:50:00',2.2),('5815','2013-04-29','13:55:00',2.18),('5815','2013-04-29','14:00:00',2.17),('5815','2013-04-29','14:05:00',2.15),('5815','2013-04-29','14:10:00',2.14),('5815','2013-04-29','14:15:00',2.13),('5815','2013-04-29','14:20:00',2.13),('5815','2013-04-29','14:25:00',2.12),('5815','2013-04-29','14:30:00',2.1),('5815','2013-04-29','14:35:00',2.09),('5815','2013-04-29','14:40:00',2.07),('5815','2013-04-29','14:45:00',2.05),('5815','2013-04-29','14:50:00',2.03),('5815','2013-04-29','14:55:00',1.99),('5815','2013-04-29','15:00:00',1.97),('5815','2013-04-29','15:05:00',1.91),('5815','2013-04-29','15:10:00',1.92),('5815','2013-04-29','15:15:00',1.9),('5815','2013-04-29','15:20:00',1.88),('5815','2013-04-29','15:25:00',1.85),('5815','2013-04-29','15:30:00',1.82),('5815','2013-04-29','15:35:00',1.82),('5815','2013-04-29','15:40:00',1.79),('5815','2013-04-29','15:45:00',1.76),('5815','2013-04-29','15:50:00',1.71),('5815','2013-04-29','15:55:00',1.68),('5815','2013-04-29','16:00:00',1.65),('5815','2013-04-29','16:05:00',1.61),('5815','2013-04-29','16:10:00',1.58),('5815','2013-04-29','16:15:00',1.55),('5815','2013-04-29','16:20:00',1.5),('5815','2013-04-29','16:25:00',1.47),('5815','2013-04-29','16:30:00',1.44),('5815','2013-04-29','16:35:00',1.38),('5815','2013-04-29','16:40:00',1.19),('5815','2013-04-29','16:45:00',1.22),('5815','2013-04-29','16:50:00',1.01),('5815','2013-04-29','16:55:00',1.16),('5815','2013-04-29','17:00:00',1.11),('5815','2013-04-29','17:05:00',1.11),('5815','2013-04-28','08:35:00',1.04),('5815','2013-04-28','08:40:00',1.07),('5815','2013-04-28','08:45:00',1.04),('5815','2013-04-28','08:50:00',1.13),('5815','2013-04-28','08:55:00',1.14),('5815','2013-04-28','09:05:00',1.18),('5815','2013-04-28','09:10:00',1.34),('5815','2013-04-28','09:15:00',1.42),('5815','2013-04-28','09:20:00',1.36),('5815','2013-04-28','09:25:00',1.32),('5815','2013-04-28','09:30:00',1.32),('5815','2013-04-28','09:35:00',1.42),('5815','2013-04-28','09:40:00',1.43),('5815','2013-04-28','09:45:00',1.48),('5815','2013-04-28','09:50:00',1.59),('5815','2013-04-28','09:55:00',1.48),('5815','2013-04-28','10:00:00',1.55),('5815','2013-04-28','10:05:00',1.56),('5815','2013-04-28','10:10:00',1.54),('5815','2013-04-28','10:15:00',1.31),('5815','2013-04-28','10:20:00',1.24),('5815','2013-04-28','10:25:00',1.55),('5815','2013-04-28','10:30:00',1.52),('5815','2013-04-28','10:35:00',1.82),('5815','2013-04-28','10:40:00',1.84),('5815','2013-04-28','10:45:00',1.87),('5815','2013-04-28','10:50:00',1.8),('5815','2013-04-28','10:55:00',1.68),('5815','2013-04-28','11:00:00',1.87),('5815','2013-04-28','11:05:00',1.84),('5815','2013-04-28','11:10:00',1.77),('5815','2013-04-28','11:15:00',1.65),('5815','2013-04-28','11:20:00',1.93),('5815','2013-04-28','11:25:00',2),('5815','2013-04-28','11:30:00',2.09),('5815','2013-04-28','11:35:00',2.01),('5815','2013-04-28','11:40:00',2.03),('5815','2013-04-28','11:45:00',2),('5815','2013-04-28','11:50:00',2.18),('5815','2013-04-28','11:55:00',2.18),('5815','2013-04-28','12:00:00',2.25),('5815','2013-04-28','12:05:00',2.27),('5815','2013-04-28','12:10:00',2.19),('5815','2013-04-28','12:15:00',2.19),('5815','2013-04-28','12:20:00',2.23),('5815','2013-04-28','12:25:00',2.17),('5815','2013-04-28','12:30:00',2.2),('5815','2013-04-28','12:35:00',2.27),('5815','2013-04-28','12:40:00',2.34),('5815','2013-04-28','12:45:00',2.35),('5815','2013-04-28','12:50:00',2.36),('5815','2013-04-28','12:55:00',2.29),('5815','2013-04-28','13:00:00',2.35),('5815','2013-04-28','13:05:00',2.32),('5815','2013-04-28','13:10:00',2.24),('5815','2013-04-28','13:15:00',2.13),('5815','2013-04-28','13:20:00',2.26),('5815','2013-04-28','13:25:00',2.38),('5815','2013-04-28','13:30:00',2.35),('5815','2013-04-28','13:35:00',2.3),('5815','2013-04-28','13:40:00',2.34),('5815','2013-04-28','13:45:00',2.3),('5815','2013-04-28','13:50:00',2.21),('5815','2013-04-28','13:55:00',2.42),('5815','2013-04-28','14:00:00',2.25),('5815','2013-04-28','14:05:00',2.24),('5815','2013-04-28','14:10:00',2.28),('5815','2013-04-28','14:15:00',2.32),('5815','2013-04-28','14:20:00',2.32),('5815','2013-04-28','14:25:00',2.25),('5815','2013-04-28','14:30:00',2.15),('5815','2013-04-28','14:35:00',2.09),('5815','2013-04-28','14:40:00',1.99),('5815','2013-04-28','14:45:00',2.15),('5815','2013-04-28','14:50:00',2.07),('5815','2013-04-28','14:55:00',2.11),('5815','2013-04-28','15:00:00',2.03),('5815','2013-04-28','15:05:00',2.15),('5815','2013-04-28','15:10:00',1.97),('5815','2013-04-28','15:15:00',1.82),('5815','2013-04-28','15:20:00',1.93),('5815','2013-04-28','15:25:00',2.07),('5815','2013-04-28','15:30:00',2.02),('5815','2013-04-28','15:35:00',1.8),('5815','2013-04-28','15:40:00',1.63),('5815','2013-04-28','15:45:00',1.56),('5815','2013-04-28','15:50:00',1.58),('5815','2013-04-28','15:55:00',1.69),('5815','2013-04-28','16:00:00',1.64),('5815','2013-04-28','16:05:00',1.76),('5815','2013-04-28','16:10:00',1.65),('5815','2013-04-28','16:15:00',1.91),('5815','2013-04-28','16:20:00',1.87),('5815','2013-04-28','16:25:00',1.42),('5815','2013-04-28','16:30:00',1.5),('5815','2013-04-28','16:35:00',1.5),('5815','2013-04-28','16:40:00',1.6),('5815','2013-04-28','16:45:00',1.57),('5815','2013-04-28','16:50:00',1.61),('5815','2013-04-28','16:55:00',1.67),('5815','2013-04-28','17:00:00',1.55),('5815','2013-04-28','17:05:00',1.34),('5815','2013-04-28','17:10:00',1.37),('5815','2013-04-28','17:15:00',1.2),('5815','2013-04-27','08:45:00',1.05),('5815','2013-04-27','08:50:00',1.1),('5815','2013-04-27','08:55:00',1.14),('5815','2013-04-27','09:00:00',1.2),('5815','2013-04-27','09:05:00',1.24),('5815','2013-04-27','09:10:00',1.3),('5815','2013-04-27','09:15:00',1.35),('5815','2013-04-27','09:20:00',1.39),('5815','2013-04-27','09:25:00',1.43),('5815','2013-04-27','09:30:00',1.48),('5815','2013-04-27','09:35:00',1.53),('5815','2013-04-27','09:40:00',1.56),('5815','2013-04-27','09:45:00',1.62),('5815','2013-04-27','09:50:00',1.66),('5815','2013-04-27','09:55:00',1.7),('5815','2013-04-27','10:00:00',1.73),('5815','2013-04-27','10:05:00',1.75),('5815','2013-04-27','10:10:00',1.81),('5815','2013-04-27','10:15:00',1.79),('5815','2013-04-27','10:20:00',1.86),('5815','2013-04-27','10:25:00',1.92),('5815','2013-04-27','10:30:00',1.89),('5815','2013-04-27','10:35:00',1.95),('5815','2013-04-27','10:40:00',1.78),('5815','2013-04-27','10:45:00',2.04),('5815','2013-04-27','10:50:00',2.05),('5815','2013-04-27','10:55:00',2.06),('5815','2013-04-27','11:00:00',2.08),('5815','2013-04-27','11:05:00',2.07),('5815','2013-04-27','11:10:00',2.12),('5815','2013-04-27','11:15:00',2.14),('5815','2013-04-27','11:20:00',2.16),('5815','2013-04-27','11:25:00',2.2),('5815','2013-04-27','11:30:00',2.23),('5815','2013-04-27','11:35:00',2.18),('5815','2013-04-27','11:40:00',2.21),('5815','2013-04-27','11:45:00',2.15),('5815','2013-04-27','11:50:00',2.16),('5815','2013-04-27','11:55:00',2.25),('5815','2013-04-27','12:00:00',1.98),('5815','2013-04-27','12:05:00',1.95),('5815','2013-04-27','12:10:00',2.15),('5815','2013-04-27','12:15:00',2.27),('5815','2013-04-27','12:20:00',2.21),('5815','2013-04-27','12:25:00',1.97),('5815','2013-04-27','12:30:00',1.92),('5815','2013-04-27','12:35:00',1.72),('5815','2013-04-27','12:40:00',1.73),('5815','2013-04-27','12:45:00',2.22),('5815','2013-04-27','12:50:00',2.33),('5815','2013-04-27','12:55:00',2.15),('5815','2013-04-27','13:00:00',2.23),('5815','2013-04-27','13:05:00',2.39),('5815','2013-04-27','13:10:00',2.37),('5815','2013-04-27','13:15:00',2.21),('5815','2013-04-27','13:20:00',2.22),('5815','2013-04-27','13:25:00',2.23),('5815','2013-04-27','13:30:00',2.36),('5815','2013-04-27','13:35:00',2.33),('5815','2013-04-27','13:40:00',2.44),('5815','2013-04-27','13:45:00',2.41),('5815','2013-04-27','13:50:00',2.36),('5815','2013-04-27','13:55:00',2.2),('5815','2013-04-27','14:00:00',2.31),('5815','2013-04-27','14:05:00',2.32),('5815','2013-04-27','14:10:00',2.25),('5815','2013-04-27','14:15:00',2.29),('5815','2013-04-27','14:20:00',2.12),('5815','2013-04-27','14:25:00',2.07),('5815','2013-04-27','14:30:00',2.22),('5815','2013-04-27','14:35:00',2.23),('5815','2013-04-27','14:40:00',2.2),('5815','2013-04-27','14:45:00',2.18),('5815','2013-04-27','14:50:00',2.16),('5815','2013-04-27','14:55:00',2.12),('5815','2013-04-27','15:00:00',2.12),('5815','2013-04-27','15:05:00',2.1),('5815','2013-04-27','15:10:00',2.09),('5815','2013-04-27','15:15:00',2.1),('5815','2013-04-27','15:20:00',2.07),('5815','2013-04-27','15:25:00',2.03),('5815','2013-04-27','15:30:00',2),('5815','2013-04-27','15:35:00',1.96),('5815','2013-04-27','15:40:00',1.93),('5815','2013-04-27','15:45:00',1.92),('5815','2013-04-27','15:50:00',1.89),('5815','2013-04-27','15:55:00',1.86),('5815','2013-04-27','16:00:00',1.82),('5815','2013-04-27','16:05:00',1.79),('5815','2013-04-27','16:10:00',1.76),('5815','2013-04-27','16:15:00',1.71),('5815','2013-04-27','16:20:00',1.68),('5815','2013-04-27','16:25:00',1.62),('5815','2013-04-27','16:30:00',1.59),('5815','2013-04-27','16:35:00',1.55),('5815','2013-04-27','16:40:00',1.51),('5815','2013-04-27','16:45:00',1.47),('5815','2013-04-27','16:50:00',1.43),('5815','2013-04-27','16:55:00',1.39),('5815','2013-04-27','17:00:00',1.34),('5815','2013-04-27','17:05:00',1.25),('5815','2013-04-27','17:10:00',1.17),('5815','2013-04-27','17:15:00',1.21),('5815','2013-04-27','17:20:00',1.15),('5815','2013-04-27','17:25:00',1.09),('5815','2013-04-26','14:30:00',1.21),('5815','2013-04-26','14:35:00',1.09),('5815','2013-04-26','16:50:00',1.07),('5815','2013-04-26','16:55:00',1.05),('5815','2013-04-26','17:00:00',1.48),('5815','2013-04-26','17:05:00',1.08),('5815','2013-04-25','09:10:00',1.03),('5815','2013-04-25','09:40:00',1.2),('5815','2013-04-25','09:45:00',1.42),('5815','2013-04-25','09:50:00',1.43),('5815','2013-04-25','10:05:00',1.21),('5815','2013-04-25','10:10:00',1.63),('5815','2013-04-25','10:15:00',1.73),('5815','2013-04-25','10:20:00',1.77),('5815','2013-04-25','10:25:00',1.42),('5815','2013-04-25','10:30:00',1.79),('5815','2013-04-25','10:35:00',1.95),('5815','2013-04-25','10:40:00',1.96),('5815','2013-04-25','10:45:00',1.71),('5815','2013-04-25','10:50:00',1.12),('5815','2013-04-25','10:55:00',1.56),('5815','2013-04-25','11:00:00',1.69),('5815','2013-04-25','11:05:00',1.95),('5815','2013-04-25','11:10:00',1.74),('5815','2013-04-25','11:15:00',2.01),('5815','2013-04-25','11:20:00',1.69),('5815','2013-04-25','11:25:00',1.72),('5815','2013-04-25','11:30:00',1.72),('5815','2013-04-25','11:35:00',1.91),('5815','2013-04-25','11:40:00',1.97),('5815','2013-04-25','11:45:00',1.97),('5815','2013-04-25','11:50:00',1.57),('5815','2013-04-25','11:55:00',1.46),('5815','2013-04-25','12:00:00',1.56),('5815','2013-04-25','12:05:00',1.49),('5815','2013-04-25','12:10:00',1.29),('5815','2013-04-25','12:15:00',1.39),('5815','2013-04-25','12:20:00',1.37),('5815','2013-04-25','12:25:00',1.17),('5815','2013-04-25','12:35:00',1.23),('5815','2013-04-25','12:40:00',1.86),('5815','2013-04-25','12:45:00',2.14),('5815','2013-04-25','12:50:00',1.33),('5815','2013-04-25','12:55:00',1.12),('5815','2013-04-25','13:15:00',1.27),('5815','2013-04-25','13:25:00',1.08),('5815','2013-04-25','13:30:00',1.39),('5815','2013-04-25','13:35:00',1.26),('5815','2013-04-25','13:40:00',1.51),('5815','2013-04-25','13:45:00',1.25),('5815','2013-04-25','13:50:00',1.71),('5815','2013-04-25','13:55:00',1.45),('5815','2013-04-25','14:00:00',1.55),('5815','2013-04-25','14:05:00',2.01),('5815','2013-04-25','14:10:00',1.9),('5815','2013-04-25','14:15:00',2.1),('5815','2013-04-25','14:20:00',1.84),('5815','2013-04-25','14:25:00',2.1),('5815','2013-04-25','14:30:00',2.25),('5815','2013-04-25','14:35:00',1.76),('5815','2013-04-25','14:40:00',1.05),('5815','2013-04-25','14:50:00',2.1),('5815','2013-04-25','14:55:00',2.37),('5815','2013-04-25','15:00:00',2.2),('5815','2013-04-25','15:05:00',1.84),('5815','2013-04-25','15:30:00',1.18),('5815','2013-04-25','15:35:00',1.04),('5815','2013-04-25','15:40:00',1.04),('5815','2013-04-25','15:45:00',1.18),('5815','2013-04-25','15:50:00',1.04),('5815','2013-04-24','08:50:00',1.05),('5815','2013-04-24','08:55:00',1.27),('5815','2013-04-24','09:00:00',1.1),('5815','2013-04-24','09:40:00',1.23),('5815','2013-04-24','09:45:00',1.45),('5815','2013-04-24','09:50:00',1.7),('5815','2013-04-24','09:55:00',1.71),('5815','2013-04-24','10:00:00',1.73),('5815','2013-04-24','10:05:00',1.65),('5815','2013-04-24','10:10:00',1.52),('5815','2013-04-24','10:15:00',1.59),('5815','2013-04-24','10:20:00',1.81),('5815','2013-04-24','10:25:00',1.86),('5815','2013-04-24','10:30:00',1.91),('5815','2013-04-24','10:35:00',1.95),('5815','2013-04-24','10:40:00',1.96),('5815','2013-04-24','10:45:00',1.9),('5815','2013-04-24','10:50:00',1.99),('5815','2013-04-24','10:55:00',2.04),('5815','2013-04-24','11:00:00',2.08),('5815','2013-04-24','11:05:00',2.12),('5815','2013-04-24','11:10:00',2.13),('5815','2013-04-24','11:15:00',2.14),('5815','2013-04-24','11:20:00',2.16),('5815','2013-04-24','11:25:00',2.18),('5815','2013-04-24','11:30:00',2.16),('5815','2013-04-24','11:35:00',2.24),('5815','2013-04-24','11:40:00',2.25),('5815','2013-04-24','11:45:00',2.28),('5815','2013-04-24','11:50:00',2.3),('5815','2013-04-24','11:55:00',2.28),('5815','2013-04-24','12:00:00',2.24),('5815','2013-04-24','12:05:00',2.25),('5815','2013-04-24','12:10:00',2.29),('5815','2013-04-24','12:15:00',2.3),('5815','2013-04-24','12:20:00',2.31),('5815','2013-04-24','12:25:00',2.31),('5815','2013-04-24','12:30:00',2.32),('5815','2013-04-24','12:35:00',2.32),('5815','2013-04-24','12:40:00',2.32),('5815','2013-04-24','12:45:00',2.33),('5815','2013-04-24','12:50:00',2.33),('5815','2013-04-24','12:55:00',2.35),('5815','2013-04-24','13:00:00',2.37),('5815','2013-04-24','13:05:00',2.41),('5815','2013-04-24','13:10:00',2.35),('5815','2013-04-24','13:15:00',2.29),('5815','2013-04-24','13:20:00',2.16),('5815','2013-04-24','13:25:00',2.17),('5815','2013-04-24','13:30:00',1.71),('5815','2013-04-24','13:35:00',1.66),('5815','2013-04-24','13:40:00',1.36),('5815','2013-04-24','13:45:00',1.22),('5815','2013-04-24','13:50:00',1.13),('5815','2013-04-24','13:55:00',1.19),('5815','2013-04-24','14:00:00',1.28),('5815','2013-04-24','14:05:00',1.16),('5815','2013-04-24','14:10:00',1.26),('5815','2013-04-24','14:15:00',1.33),('5815','2013-04-24','14:20:00',1.38),('5815','2013-04-24','14:25:00',1.4),('5815','2013-04-24','14:30:00',1.66),('5815','2013-04-24','14:35:00',2),('5815','2013-04-24','14:40:00',1.93),('5815','2013-04-24','14:45:00',1.97),('5815','2013-04-24','14:50:00',1.79),('5815','2013-04-24','14:55:00',1.9),('5815','2013-04-24','15:00:00',1.81),('5815','2013-04-24','15:05:00',1.67),('5815','2013-04-24','15:10:00',1.6),('5815','2013-04-24','15:15:00',1.84),('5815','2013-04-24','15:20:00',1.96),('5815','2013-04-24','15:25:00',2),('5815','2013-04-24','15:30:00',1.97),('5815','2013-04-24','15:35:00',1.86),('5815','2013-04-24','15:40:00',1.76),('5815','2013-04-24','15:45:00',1.65),('5815','2013-04-24','15:50:00',1.56),('5815','2013-04-24','15:55:00',1.51),('5815','2013-04-24','16:00:00',1.54),('5815','2013-04-24','16:05:00',1.29),('5815','2013-04-24','16:10:00',1.29),('5815','2013-04-24','16:15:00',1.25),('5815','2013-04-24','16:20:00',1.3),('5815','2013-04-24','16:25:00',1.18),('5815','2013-04-24','16:30:00',1.08),('5815','2013-04-24','16:35:00',1.37),('5815','2013-04-24','16:40:00',1.15),('5815','2013-04-24','16:45:00',1.24),('5815','2013-04-24','16:50:00',1.04),('5815','2013-04-24','16:55:00',1.07),('5815','2013-04-24','17:00:00',1.02),('5815','2013-04-24','17:05:00',1.19),('5815','2013-04-24','17:10:00',1.33),('5815','2013-04-24','17:15:00',1.22),('5815','2013-04-24','17:20:00',1.2),('5815','2013-04-24','17:25:00',1.01),('5815','2013-04-23','08:55:00',1.04),('5815','2013-04-23','09:00:00',1.14),('5815','2013-04-23','09:05:00',1.28),('5815','2013-04-23','09:10:00',1.31),('5815','2013-04-23','09:15:00',1.26),('5815','2013-04-23','09:20:00',1.07),('5815','2013-04-23','09:25:00',1.22),('5815','2013-04-23','09:30:00',1.49),('5815','2013-04-23','09:35:00',1.54),('5815','2013-04-23','09:40:00',1.45),('5815','2013-04-23','09:45:00',1.45),('5815','2013-04-23','09:50:00',1.53),('5815','2013-04-23','09:55:00',1.77),('5815','2013-04-23','10:00:00',1.77),('5815','2013-04-23','10:05:00',1.83),('5815','2013-04-23','10:10:00',1.84),('5815','2013-04-23','10:15:00',1.84),('5815','2013-04-23','10:20:00',1.85),('5815','2013-04-23','10:25:00',1.84),('5815','2013-04-23','10:30:00',1.83),('5815','2013-04-23','10:35:00',1.8),('5815','2013-04-23','10:40:00',1.98),('5815','2013-04-23','10:45:00',2.06),('5815','2013-04-23','10:50:00',2.04),('5815','2013-04-23','10:55:00',2.13),('5815','2013-04-23','11:00:00',2.17),('5815','2013-04-23','11:05:00',2.11),('5815','2013-04-23','11:10:00',2.23),('5815','2013-04-23','11:15:00',2.31),('5815','2013-04-23','11:20:00',2.36),('5815','2013-04-23','11:25:00',2.45),('5815','2013-04-23','11:30:00',2.34),('5815','2013-04-23','11:35:00',1.95),('5815','2013-04-23','11:40:00',1.37),('5815','2013-04-23','11:45:00',1.58),('5815','2013-04-23','11:50:00',1.15),('5815','2013-04-23','11:55:00',1.5),('5815','2013-04-23','12:00:00',1.93),('5815','2013-04-23','12:05:00',1.36),('5815','2013-04-23','12:10:00',1.62),('5815','2013-04-23','12:15:00',2.16),('5815','2013-04-23','12:20:00',2.62),('5815','2013-04-23','12:25:00',2.24),('5815','2013-04-23','12:30:00',2.21),('5815','2013-04-23','12:35:00',2.24),('5815','2013-04-23','12:40:00',2.07),('5815','2013-04-23','12:45:00',2.22),('5815','2013-04-23','12:50:00',2.38),('5815','2013-04-23','12:55:00',2.25),('5815','2013-04-23','13:00:00',2.14),('5815','2013-04-23','13:05:00',1.89),('5815','2013-04-23','13:10:00',2.53),('5815','2013-04-23','13:15:00',2.2),('5815','2013-04-23','13:20:00',2.21),('5815','2013-04-23','13:25:00',2.21),('5815','2013-04-23','13:30:00',2.09),('5815','2013-04-23','13:35:00',1.97),('5815','2013-04-23','13:40:00',2.52),('5815','2013-04-23','13:45:00',2.03),('5815','2013-04-23','13:50:00',1.49),('5815','2013-04-23','13:55:00',2.29),('5815','2013-04-23','14:00:00',2.29),('5815','2013-04-23','14:05:00',1.64),('5815','2013-04-23','14:10:00',1.57),('5815','2013-04-23','14:15:00',2.36),('5815','2013-04-23','14:20:00',2.05),('5815','2013-04-23','14:25:00',2.19),('5815','2013-04-23','14:30:00',2.09),('5815','2013-04-23','14:35:00',1.8),('5815','2013-04-23','14:40:00',1.69),('5815','2013-04-23','14:45:00',1.7),('5815','2013-04-23','14:50:00',1.48),('5815','2013-04-23','14:55:00',1.34),('5815','2013-04-23','15:00:00',1.48),('5815','2013-04-23','15:05:00',1.35),('5815','2013-04-23','15:10:00',1.26),('5815','2013-04-23','15:15:00',1.34),('5815','2013-04-23','15:20:00',1.39),('5815','2013-04-23','15:25:00',1.17),('5815','2013-04-23','15:55:00',1.21),('5815','2013-04-23','16:00:00',1.48),('5815','2013-04-23','16:05:00',1.56),('5815','2013-04-23','16:10:00',1.56),('5815','2013-04-23','16:15:00',1.5),('5815','2013-04-23','16:20:00',1.99),('5815','2013-04-23','16:25:00',1.47),('5815','2013-04-23','16:30:00',1.26),('5815','2013-04-23','16:35:00',1.01),('5815','2013-04-23','16:40:00',1.41),('5815','2013-04-23','16:45:00',1.47),('5815','2013-04-23','16:50:00',1.3),('5815','2013-04-23','16:55:00',1.55),('5815','2013-04-23','17:00:00',1.57),('5815','2013-04-23','17:05:00',1.47),('5815','2013-04-23','17:10:00',1.42),('5815','2013-04-23','17:15:00',1.07),('5815','2013-04-22','08:40:00',1.03),('5815','2013-04-22','08:45:00',1.09),('5815','2013-04-22','08:50:00',1.15),('5815','2013-04-22','08:55:00',1.2),('5815','2013-04-22','09:00:00',1.25),('5815','2013-04-22','09:05:00',1.3),('5815','2013-04-22','09:10:00',1.35),('5815','2013-04-22','09:15:00',1.41),('5815','2013-04-22','09:20:00',1.47),('5815','2013-04-22','09:25:00',1.51),('5815','2013-04-22','09:30:00',1.55),('5815','2013-04-22','09:35:00',1.61),('5815','2013-04-22','09:40:00',1.55),('5815','2013-04-22','09:45:00',1.42),('5815','2013-04-22','09:50:00',1.75),('5815','2013-04-22','09:55:00',1.79),('5815','2013-04-22','10:00:00',1.82),('5815','2013-04-22','10:05:00',1.86),('5815','2013-04-22','10:10:00',1.89),('5815','2013-04-22','10:15:00',1.93),('5815','2013-04-22','10:20:00',1.97),('5815','2013-04-22','10:25:00',2),('5815','2013-04-22','10:30:00',2.02),('5815','2013-04-22','10:35:00',2.05),('5815','2013-04-22','10:40:00',2.06),('5815','2013-04-22','10:45:00',2.05),('5815','2013-04-22','10:50:00',2.09),('5815','2013-04-22','10:55:00',2.15),('5815','2013-04-22','11:00:00',2.19),('5815','2013-04-22','11:05:00',2.19),('5815','2013-04-22','11:10:00',2.23),('5815','2013-04-22','11:15:00',2.26),('5815','2013-04-22','11:20:00',2.28),('5815','2013-04-22','11:25:00',2.31),('5815','2013-04-22','11:30:00',2.32),('5815','2013-04-22','11:35:00',2.32),('5815','2013-04-22','11:40:00',2.33),('5815','2013-04-22','11:45:00',2.34),('5815','2013-04-22','11:50:00',2.36),('5815','2013-04-22','11:55:00',2.36),('5815','2013-04-22','12:00:00',2.37),('5815','2013-04-22','12:05:00',2.37),('5815','2013-04-22','12:10:00',2.37),('5815','2013-04-22','12:15:00',2.39),('5815','2013-04-22','12:20:00',2.38),('5815','2013-04-22','12:25:00',2.38),('5815','2013-04-22','12:30:00',1.23),('5815','2013-04-22','12:40:00',1.6),('5815','2013-04-22','12:50:00',2.02),('5815','2013-04-22','12:55:00',1.35),('5815','2013-04-22','13:00:00',1.49),('5815','2013-04-22','13:05:00',2.09),('5815','2013-04-22','13:15:00',2.2),('5815','2013-04-22','13:20:00',2.44),('5815','2013-04-22','13:25:00',2.63),('5815','2013-04-22','13:30:00',2.48),('5815','2013-04-22','13:35:00',2.53),('5815','2013-04-22','13:40:00',2.6),('5815','2013-04-22','13:45:00',1.85),('5815','2013-04-22','13:50:00',2.22),('5815','2013-04-22','13:55:00',2.51),('5815','2013-04-22','14:00:00',1.69),('5815','2013-04-22','14:05:00',2.26),('5815','2013-04-22','14:10:00',1.79),('5815','2013-04-22','14:15:00',2.22),('5815','2013-04-22','14:20:00',2.31),('5815','2013-04-22','14:25:00',2.11),('5815','2013-04-22','14:30:00',2.43),('5815','2013-04-22','14:35:00',2.41),('5815','2013-04-22','14:40:00',2.39),('5815','2013-04-22','14:45:00',1.99),('5815','2013-04-22','14:50:00',1.29),('5815','2013-04-22','14:55:00',1.34),('5815','2013-04-22','15:00:00',1.34),('5815','2013-04-22','15:05:00',1.37),('5815','2013-04-22','15:10:00',1.61),('5815','2013-04-22','15:15:00',1.74),('5815','2013-04-22','15:20:00',1.59),('5815','2013-04-22','15:25:00',1.45),('5815','2013-04-22','15:30:00',1.43),('5815','2013-04-22','15:35:00',1.44),('5815','2013-04-22','15:40:00',1.2),('5815','2013-04-22','15:45:00',1.4),('5815','2013-04-22','15:50:00',1.06),('5815','2013-04-22','17:15:00',1.14),('5815','2013-04-22','17:20:00',1.1),('5815','2013-04-21','10:35:00',1.13),('5815','2013-04-21','10:40:00',1.96),('5815','2013-04-21','10:45:00',2.75),('5815','2013-04-21','10:50:00',1.35),('5815','2013-04-21','10:55:00',1.2),('5815','2013-04-21','11:00:00',1.13),('5815','2013-04-21','11:05:00',1.06),('5815','2013-04-21','11:10:00',1.35),('5815','2013-04-21','11:25:00',1.04),('5815','2013-04-21','11:30:00',1.65),('5815','2013-04-21','11:35:00',2.05),('5815','2013-04-21','11:40:00',2.33),('5815','2013-04-21','11:45:00',1.17),('5815','2013-04-21','11:55:00',2.03),('5815','2013-04-21','12:00:00',1.88),('5815','2013-04-21','12:05:00',1.9),('5815','2013-04-21','12:10:00',2.36),('5815','2013-04-21','12:15:00',1.89),('5815','2013-04-21','12:20:00',1.86),('5815','2013-04-21','12:25:00',1.73),('5815','2013-04-21','12:30:00',1.34),('5815','2013-04-21','12:35:00',1.29),('5815','2013-04-21','12:40:00',2.46),('5815','2013-04-21','12:45:00',2.3),('5815','2013-04-21','12:50:00',2.68),('5815','2013-04-21','12:55:00',2.64),('5815','2013-04-21','13:00:00',2.66),('5815','2013-04-21','13:05:00',2.61),('5815','2013-04-21','13:10:00',2.15),('5815','2013-04-21','13:15:00',2.51),('5815','2013-04-21','13:20:00',2.44),('5815','2013-04-21','13:25:00',1.38),('5815','2013-04-21','13:30:00',2.16),('5815','2013-04-21','13:35:00',1.53),('5815','2013-04-21','13:40:00',1.23),('5815','2013-04-21','13:45:00',2.48),('5815','2013-04-21','13:55:00',1.44),('5815','2013-04-21','14:10:00',1.17),('5815','2013-04-21','14:20:00',1.82),('5815','2013-04-21','14:25:00',1.49),('5815','2013-04-21','14:30:00',2.41),('5815','2013-04-21','14:35:00',1.91),('5815','2013-04-21','14:40:00',2.63),('5815','2013-04-21','14:45:00',2.68),('5815','2013-04-21','14:50:00',2.67),('5815','2013-04-21','14:55:00',2.65),('5815','2013-04-21','15:00:00',1.74),('5815','2013-04-21','15:05:00',1.58),('5815','2013-04-21','15:10:00',1.46),('5815','2013-04-21','15:25:00',1.11),('5815','2013-04-21','15:30:00',1.14),('5815','2013-04-21','15:45:00',1.87),('5815','2013-04-21','15:50:00',1.84),('5815','2013-04-20','08:50:00',1.34),('5815','2013-04-20','08:55:00',1.34),('5815','2013-04-20','09:05:00',1.03),('5815','2013-04-20','09:10:00',1.22),('5815','2013-04-20','09:15:00',1.35),('5815','2013-04-20','09:20:00',1.03),('5815','2013-04-20','09:25:00',1.15),('5815','2013-04-20','09:30:00',1.64),('5815','2013-04-20','09:35:00',1.68),('5815','2013-04-20','09:40:00',1.73),('5815','2013-04-20','09:45:00',1.78),('5815','2013-04-20','09:50:00',2.1),('5815','2013-04-20','09:55:00',1.97),('5815','2013-04-20','10:00:00',1.72),('5815','2013-04-20','10:05:00',1.34),('5815','2013-04-20','10:10:00',1.12),('5815','2013-04-20','10:20:00',1.65),('5815','2013-04-20','10:25:00',1.99),('5815','2013-04-20','10:30:00',1.72),('5815','2013-04-20','10:35:00',1.18),('5815','2013-04-20','10:40:00',1.49),('5815','2013-04-20','10:45:00',1.33),('5815','2013-04-20','10:50:00',2.23),('5815','2013-04-20','10:55:00',1.9),('5815','2013-04-20','11:00:00',2.28),('5815','2013-04-20','11:05:00',1.93),('5815','2013-04-20','11:10:00',2.3),('5815','2013-04-20','11:15:00',1.9),('5815','2013-04-20','11:20:00',1.79),('5815','2013-04-20','11:25:00',1.92),('5815','2013-04-20','11:30:00',1.74),('5815','2013-04-20','11:35:00',1.55),('5815','2013-04-20','11:40:00',1.92),('5815','2013-04-20','11:45:00',2.1),('5815','2013-04-20','11:50:00',1.81),('5815','2013-04-20','11:55:00',1.77),('5815','2013-04-20','12:00:00',1.49),('5815','2013-04-20','12:05:00',1.42),('5815','2013-04-20','12:10:00',1.42),('5815','2013-04-20','12:15:00',1.26),('5815','2013-04-20','12:20:00',1.15),('5815','2013-04-20','12:25:00',1.08),('5815','2013-04-20','12:30:00',1.19),('5815','2013-04-20','12:35:00',1.23),('5815','2013-04-20','12:40:00',1.23),('5815','2013-04-20','12:45:00',1.24),('5815','2013-04-20','12:50:00',1.15),('5815','2013-04-20','12:55:00',1.11),('5815','2013-04-20','13:00:00',1.28),('5815','2013-04-20','13:05:00',1.5),('5815','2013-04-20','13:10:00',1.55),('5815','2013-04-20','13:15:00',1.44),('5815','2013-04-20','13:20:00',1.35),('5815','2013-04-20','13:25:00',1.27),('5815','2013-04-20','13:30:00',1.84),('5815','2013-04-20','13:35:00',2.33),('5815','2013-04-20','13:40:00',1.63),('5815','2013-04-20','13:45:00',1.68),('5815','2013-04-20','13:50:00',1.54),('5815','2013-04-20','13:55:00',2.17),('5815','2013-04-20','14:00:00',2.77),('5815','2013-04-20','14:05:00',2.19),('5815','2013-04-20','14:10:00',2.33),('5815','2013-04-20','14:15:00',2.08),('5815','2013-04-20','14:20:00',2.71),('5815','2013-04-20','14:25:00',2.19),('5815','2013-04-20','14:30:00',2.36),('5815','2013-04-20','14:35:00',2.42),('5815','2013-04-20','14:40:00',2.65),('5815','2013-04-20','14:45:00',2.34),('5815','2013-04-20','14:50:00',1.27),('5815','2013-04-20','14:55:00',1.16),('5815','2013-04-20','15:00:00',1.58),('5815','2013-04-20','15:05:00',2.39),('5815','2013-04-20','15:10:00',2.54),('5815','2013-04-20','15:15:00',1.96),('5815','2013-04-20','15:20:00',1.23),('5815','2013-04-20','15:25:00',1.12),('5815','2013-04-19','08:50:00',1.03),('5815','2013-04-19','08:55:00',1.04),('5815','2013-04-19','09:00:00',1.19),('5815','2013-04-19','09:05:00',1.26),('5815','2013-04-19','09:10:00',1.22),('5815','2013-04-19','09:15:00',1.18),('5815','2013-04-19','09:20:00',1.45),('5815','2013-04-19','09:25:00',1.35),('5815','2013-04-19','09:30:00',1.24),('5815','2013-04-19','09:35:00',1.01),('5815','2013-04-19','10:50:00',1.37),('5815','2013-04-19','10:55:00',1.25),('5815','2013-04-19','11:00:00',1.67),('5815','2013-04-19','11:05:00',1.58),('5815','2013-04-19','11:15:00',2.27),('5815','2013-04-19','11:20:00',2.03),('5815','2013-04-19','11:25:00',1.03),('5815','2013-04-19','11:30:00',2.57),('5815','2013-04-19','11:35:00',2.27),('5815','2013-04-19','11:40:00',1.04),('5815','2013-04-19','11:45:00',1.7),('5815','2013-04-19','11:50:00',1.52),('5815','2013-04-19','11:55:00',2.35),('5815','2013-04-19','12:00:00',2.64),('5815','2013-04-19','12:05:00',1.47),('5815','2013-04-19','12:10:00',2.46),('5815','2013-04-19','12:15:00',2.56),('5815','2013-04-19','12:20:00',1.51),('5815','2013-04-19','12:25:00',2.1),('5815','2013-04-19','12:30:00',1.29),('5815','2013-04-19','12:35:00',2.6),('5815','2013-04-19','12:40:00',1.17),('5815','2013-04-19','12:45:00',2.58),('5815','2013-04-19','12:50:00',2.71),('5815','2013-04-19','12:55:00',2.72),('5815','2013-04-19','13:00:00',1.01),('5815','2013-04-19','13:05:00',1.4),('5815','2013-04-19','13:10:00',2.68),('5815','2013-04-19','13:15:00',2.55),('5815','2013-04-19','13:20:00',1.15),('5815','2013-04-19','13:25:00',2.04),('5815','2013-04-19','13:30:00',1.89),('5815','2013-04-19','13:35:00',1.12),('5815','2013-04-19','13:40:00',2.61),('5815','2013-04-19','13:45:00',1.37),('5815','2013-04-19','13:50:00',1.34),('5815','2013-04-19','13:55:00',1.82),('5815','2013-04-19','14:00:00',1.68),('5815','2013-04-19','14:05:00',2.42),('5815','2013-04-19','14:10:00',2.67),('5815','2013-04-19','14:15:00',2.29),('5815','2013-04-19','14:20:00',2.4),('5815','2013-04-19','14:25:00',2.43),('5815','2013-04-19','14:30:00',2.4),('5815','2013-04-19','14:35:00',2.35),('5815','2013-04-19','14:40:00',2.34),('5815','2013-04-19','14:45:00',2.34),('5815','2013-04-19','14:50:00',2.38),('5815','2013-04-19','14:55:00',2.37),('5815','2013-04-19','15:00:00',2.35),('5815','2013-04-19','15:05:00',2.31),('5815','2013-04-19','15:10:00',1.67),('5815','2013-04-19','15:15:00',1.64),('5815','2013-04-19','15:20:00',1.45),('5815','2013-04-19','15:25:00',2.01),('5815','2013-04-19','15:30:00',1.37),('5815','2013-04-19','16:15:00',1.3),('5815','2013-04-19','16:20:00',1.32),('5815','2013-04-19','16:25:00',1.41),('5815','2013-04-19','16:30:00',1.74),('5815','2013-04-19','16:35:00',1.72),('5815','2013-04-19','16:40:00',1.52),('5815','2013-04-19','16:45:00',1.55),('5815','2013-04-19','16:50:00',1.6),('5815','2013-04-19','16:55:00',1.55),('5815','2013-04-19','17:00:00',1.46),('5815','2013-04-19','17:05:00',1.41),('5815','2013-04-19','17:10:00',1.36),('5815','2013-04-19','17:15:00',1.27),('5815','2013-04-19','17:20:00',1.03),('5815','2013-04-19','17:25:00',1.2),('5815','2013-04-19','17:30:00',1.2),('5815','2013-04-19','17:35:00',1.19),('5815','2013-04-18','08:50:00',1.02),('5815','2013-04-18','08:55:00',1.09),('5815','2013-04-18','09:00:00',1.13),('5815','2013-04-18','09:05:00',1.15),('5815','2013-04-18','09:10:00',1.22),('5815','2013-04-18','09:15:00',1.26),('5815','2013-04-18','09:20:00',1.31),('5815','2013-04-18','09:25:00',1.34),('5815','2013-04-18','09:30:00',1.41),('5815','2013-04-18','09:35:00',1.46),('5815','2013-04-18','09:40:00',1.5),('5815','2013-04-18','09:45:00',1.53),('5815','2013-04-18','09:50:00',1.55),('5815','2013-04-18','09:55:00',1.59),('5815','2013-04-18','10:00:00',1.64),('5815','2013-04-18','10:05:00',1.68),('5815','2013-04-18','10:10:00',1.71),('5815','2013-04-18','10:15:00',1.77),('5815','2013-04-18','10:20:00',1.37),('5815','2013-04-18','10:25:00',1.74),('5815','2013-04-18','10:30:00',1.6),('5815','2013-04-18','10:35:00',1.68),('5815','2013-04-18','10:40:00',1.92),('5815','2013-04-18','10:45:00',1.92),('5815','2013-04-18','10:50:00',1.97),('5815','2013-04-18','10:55:00',1.96),('5815','2013-04-18','11:00:00',1.99),('5815','2013-04-18','11:05:00',2.01),('5815','2013-04-18','11:10:00',2.03),('5815','2013-04-18','11:15:00',2.06),('5815','2013-04-18','11:20:00',2.07),('5815','2013-04-18','11:25:00',2.09),('5815','2013-04-18','11:30:00',2.11),('5815','2013-04-18','11:35:00',2.15),('5815','2013-04-18','11:40:00',2.17),('5815','2013-04-18','11:45:00',2.2),('5815','2013-04-18','11:50:00',2.21),('5815','2013-04-18','11:55:00',2.22),('5815','2013-04-18','12:00:00',2.23),('5815','2013-04-18','12:05:00',2.24),('5815','2013-04-18','12:10:00',2.25),('5815','2013-04-18','12:15:00',2.28),('5815','2013-04-18','12:20:00',2.28),('5815','2013-04-18','12:25:00',2.28),('5815','2013-04-18','12:30:00',2.26),('5815','2013-04-18','12:35:00',2.24),('5815','2013-04-18','12:40:00',2.29),('5815','2013-04-18','12:45:00',2.31),('5815','2013-04-18','12:50:00',2.32),('5815','2013-04-18','12:55:00',2.29),('5815','2013-04-18','13:00:00',2.33),('5815','2013-04-18','13:05:00',2.33),('5815','2013-04-18','13:10:00',2.33),('5815','2013-04-18','13:15:00',2.36),('5815','2013-04-18','13:20:00',2.34),('5815','2013-04-18','13:25:00',2.35),('5815','2013-04-18','13:30:00',2.4),('5815','2013-04-18','13:35:00',2.34),('5815','2013-04-18','13:40:00',2.33),('5815','2013-04-18','13:45:00',2.32),('5815','2013-04-18','13:50:00',2.32),('5815','2013-04-18','13:55:00',2.27),('5815','2013-04-18','14:00:00',2.29),('5815','2013-04-18','14:05:00',2.27),('5815','2013-04-18','14:10:00',2.28),('5815','2013-04-18','14:15:00',2.25),('5815','2013-04-18','14:20:00',2.22),('5815','2013-04-18','14:25:00',2.2),('5815','2013-04-18','14:30:00',2.22),('5815','2013-04-18','14:35:00',2.18),('5815','2013-04-18','14:40:00',2.16),('5815','2013-04-18','14:45:00',2.14),('5815','2013-04-18','14:50:00',2.17),('5815','2013-04-18','14:55:00',2.17),('5815','2013-04-18','15:00:00',2.14),('5815','2013-04-18','15:05:00',2.13),('5815','2013-04-18','15:10:00',2.08),('5815','2013-04-18','15:15:00',2.02),('5815','2013-04-18','15:20:00',2.01),('5815','2013-04-18','15:25:00',2.01),('5815','2013-04-18','15:30:00',1.96),('5815','2013-04-18','15:35:00',1.93),('5815','2013-04-18','15:40:00',1.92),('5815','2013-04-18','15:45:00',1.89),('5815','2013-04-18','15:50:00',1.86),('5815','2013-04-18','15:55:00',1.84),('5815','2013-04-18','16:00:00',1.8),('5815','2013-04-18','16:05:00',1.77),('5815','2013-04-18','16:10:00',1.71),('5815','2013-04-18','16:15:00',1.66),('5815','2013-04-18','16:20:00',1.63),('5815','2013-04-18','16:25:00',1.61),('5815','2013-04-18','16:30:00',1.55),('5815','2013-04-18','16:35:00',1.51),('5815','2013-04-18','16:40:00',1.47),('5815','2013-04-18','16:45:00',1.42),('5815','2013-04-18','16:50:00',1.38),('5815','2013-04-18','16:55:00',1.33),('5815','2013-04-18','17:00:00',1.27),('5815','2013-04-18','17:05:00',1.22),('5815','2013-04-18','17:10:00',1.16),('5815','2013-04-18','17:15:00',1.11),('5815','2013-04-18','17:20:00',1.06),('5815','2013-04-18','17:25:00',1.01),('5815','2013-04-17','09:05:00',1.11),('5815','2013-04-17','09:10:00',1.11),('5815','2013-04-17','09:15:00',1.14),('5815','2013-04-17','09:20:00',1.26),('5815','2013-04-17','09:25:00',1.31),('5815','2013-04-17','09:30:00',1.36),('5815','2013-04-17','09:35:00',1.46),('5815','2013-04-17','09:40:00',1.65),('5815','2013-04-17','09:45:00',1.48),('5815','2013-04-17','09:50:00',1.3),('5815','2013-04-17','09:55:00',1.34),('5815','2013-04-17','10:00:00',1.61),('5815','2013-04-17','10:05:00',1.74),('5815','2013-04-17','10:10:00',1.78),('5815','2013-04-17','10:15:00',1.86),('5815','2013-04-17','10:20:00',1.89),('5815','2013-04-17','10:25:00',1.88),('5815','2013-04-17','10:30:00',1.93),('5815','2013-04-17','10:35:00',1.95),('5815','2013-04-17','10:40:00',1.98),('5815','2013-04-17','10:45:00',2),('5815','2013-04-17','10:50:00',2.04),('5815','2013-04-17','10:55:00',2.07),('5815','2013-04-17','11:00:00',2.09),('5815','2013-04-17','11:05:00',2.11),('5815','2013-04-17','11:10:00',2.13),('5815','2013-04-17','11:15:00',2.15),('5815','2013-04-17','11:20:00',2.2),('5815','2013-04-17','11:25:00',2.22),('5815','2013-04-17','11:30:00',2.23),('5815','2013-04-17','11:35:00',2.25),('5815','2013-04-17','11:40:00',2.24),('5815','2013-04-17','11:45:00',2.23),('5815','2013-04-17','11:50:00',2.25),('5815','2013-04-17','11:55:00',2.3),('5815','2013-04-17','12:00:00',2.28),('5815','2013-04-17','12:05:00',2.37),('5815','2013-04-17','12:10:00',2.38),('5815','2013-04-17','12:15:00',2.36),('5815','2013-04-17','12:20:00',2.39),('5815','2013-04-17','12:25:00',2.41),('5815','2013-04-17','12:30:00',2.42),('5815','2013-04-17','12:35:00',2.42),('5815','2013-04-17','12:40:00',2.45),('5815','2013-04-17','12:45:00',2.43),('5815','2013-04-17','12:50:00',2.44),('5815','2013-04-17','12:55:00',2.46),('5815','2013-04-17','13:00:00',2.47),('5815','2013-04-17','13:05:00',2.46),('5815','2013-04-17','13:10:00',2.46),('5815','2013-04-17','13:15:00',2.46),('5815','2013-04-17','13:20:00',2.44),('5815','2013-04-17','13:25:00',2.45),('5815','2013-04-17','13:30:00',2.45),('5815','2013-04-17','13:35:00',2.45),('5815','2013-04-17','13:40:00',2.43),('5815','2013-04-17','13:45:00',2.44),('5815','2013-04-17','13:50:00',2.45),('5815','2013-04-17','13:55:00',2.44),('5815','2013-04-17','14:00:00',2.41),('5815','2013-04-17','14:05:00',2.43),('5815','2013-04-17','14:10:00',2.41),('5815','2013-04-17','14:15:00',2.4),('5815','2013-04-17','14:20:00',2.4),('5815','2013-04-17','14:25:00',2.4),('5815','2013-04-17','14:30:00',2.37),('5815','2013-04-17','14:35:00',2.35),('5815','2013-04-17','14:40:00',2.34),('5815','2013-04-17','14:45:00',2.32),('5815','2013-04-17','14:50:00',2.27),('5815','2013-04-17','14:55:00',2.26),('5815','2013-04-17','15:00:00',2.23),('5815','2013-04-17','15:05:00',2.22),('5815','2013-04-17','15:10:00',2.2),('5815','2013-04-17','15:15:00',2.18),('5815','2013-04-17','15:20:00',2.15),('5815','2013-04-17','15:25:00',2.12),('5815','2013-04-17','15:30:00',2.09),('5815','2013-04-17','15:35:00',2.07),('5815','2013-04-17','15:40:00',2.03),('5815','2013-04-17','15:45:00',1.99),('5815','2013-04-17','15:50:00',1.96),('5815','2013-04-17','15:55:00',1.91),('5815','2013-04-17','16:00:00',1.88),('5815','2013-04-17','16:05:00',1.83),('5815','2013-04-17','16:10:00',1.82),('5815','2013-04-17','16:15:00',1.78),('5815','2013-04-17','16:20:00',1.72),('5815','2013-04-17','16:25:00',1.68),('5815','2013-04-17','16:30:00',1.64),('5815','2013-04-17','16:35:00',1.59),('5815','2013-04-17','16:40:00',1.55),('5815','2013-04-17','16:45:00',1.52),('5815','2013-04-17','16:50:00',1.47),('5815','2013-04-17','16:55:00',1.42),('5815','2013-04-17','17:00:00',1.36),('5815','2013-04-17','17:05:00',1.3),('5815','2013-04-17','17:10:00',1.25),('5815','2013-04-17','17:15:00',1.21),('5815','2013-04-17','17:20:00',1.15),('5815','2013-04-17','17:25:00',1.09),('5815','2013-04-17','17:30:00',1.05),('5815','2013-04-16','08:50:00',1.05),('5815','2013-04-16','08:55:00',1.11),('5815','2013-04-16','09:00:00',1.16),('5815','2013-04-16','09:05:00',1.21),('5815','2013-04-16','09:10:00',1.27),('5815','2013-04-16','09:15:00',1.32),('5815','2013-04-16','09:20:00',1.37),('5815','2013-04-16','09:25:00',1.42),('5815','2013-04-16','09:30:00',1.47),('5815','2013-04-16','09:35:00',1.51),('5815','2013-04-16','09:40:00',1.54),('5815','2013-04-16','09:45:00',1.59),('5815','2013-04-16','09:50:00',1.63),('5815','2013-04-16','09:55:00',1.67),('5815','2013-04-16','10:00:00',1.72),('5815','2013-04-16','10:05:00',1.77),('5815','2013-04-16','10:10:00',1.8),('5815','2013-04-16','10:15:00',1.84),('5815','2013-04-16','10:20:00',1.88),('5815','2013-04-16','10:25:00',1.91),('5815','2013-04-16','10:30:00',1.94),('5815','2013-04-16','10:35:00',1.97),('5815','2013-04-16','10:40:00',2.01),('5815','2013-04-16','10:45:00',2.04),('5815','2013-04-16','10:50:00',2.06),('5815','2013-04-16','10:55:00',2.08),('5815','2013-04-16','11:00:00',2.14),('5815','2013-04-16','11:05:00',2.16),('5815','2013-04-16','11:10:00',2.17),('5815','2013-04-16','11:15:00',2.19),('5815','2013-04-16','11:20:00',2.21),('5815','2013-04-16','11:25:00',2.22),('5815','2013-04-16','11:30:00',2.23),('5815','2013-04-16','11:35:00',2.25),('5815','2013-04-16','11:40:00',2.28),('5815','2013-04-16','11:45:00',2.3),('5815','2013-04-16','11:50:00',2.33),('5815','2013-04-16','11:55:00',2.33),('5815','2013-04-16','12:00:00',2.33),('5815','2013-04-16','12:05:00',2.36),('5815','2013-04-16','12:10:00',2.36),('5815','2013-04-16','12:15:00',2.37),('5815','2013-04-16','12:20:00',2.37),('5815','2013-04-16','12:25:00',2.39),('5815','2013-04-16','12:30:00',2.42),('5815','2013-04-16','12:35:00',2.41),('5815','2013-04-16','12:40:00',2.41),('5815','2013-04-16','12:45:00',2.43),('5815','2013-04-16','12:50:00',2.42),('5815','2013-04-16','12:55:00',2.43),('5815','2013-04-16','13:00:00',2.41),('5815','2013-04-16','13:05:00',2.39),('5815','2013-04-16','13:10:00',2.41),('5815','2013-04-16','13:15:00',2.43),('5815','2013-04-16','13:20:00',2.44),('5815','2013-04-16','13:25:00',2.46),('5815','2013-04-16','13:30:00',2.44),('5815','2013-04-16','13:35:00',2.41),('5815','2013-04-16','13:40:00',2.45),('5815','2013-04-16','13:45:00',2.3),('5815','2013-04-16','13:50:00',2.31),('5815','2013-04-16','13:55:00',2.51),('5815','2013-04-16','14:00:00',2.42),('5815','2013-04-16','14:05:00',2.61),('5815','2013-04-16','14:10:00',2.56),('5815','2013-04-16','14:15:00',2.24),('5815','2013-04-16','14:20:00',2.24),('5815','2013-04-16','14:25:00',2.25),('5815','2013-04-16','14:30:00',2.15),('5815','2013-04-16','14:35:00',2.5),('5815','2013-04-16','14:40:00',2.42),('5815','2013-04-16','14:45:00',2.04),('5815','2013-04-16','14:50:00',2.42),('5815','2013-04-16','14:55:00',2.5),('5815','2013-04-16','15:00:00',2.47),('5815','2013-04-16','15:05:00',2.51),('5815','2013-04-16','15:10:00',2.56),('5815','2013-04-16','15:15:00',2.34),('5815','2013-04-16','15:20:00',1.23),('5815','2013-04-16','15:25:00',1.39),('5815','2013-04-16','15:30:00',2.13),('5815','2013-04-16','15:35:00',2.23),('5815','2013-04-16','15:40:00',2.2),('5815','2013-04-16','15:45:00',2.19),('5815','2013-04-16','15:50:00',2.17),('5815','2013-04-16','15:55:00',2.18),('5815','2013-04-16','16:00:00',2.1),('5815','2013-04-16','16:05:00',1.57),('5815','2013-04-16','16:10:00',2),('5815','2013-04-16','16:15:00',1.93),('5815','2013-04-16','16:20:00',1.85),('5815','2013-04-16','16:25:00',1.8),('5815','2013-04-16','16:30:00',1.76),('5815','2013-04-16','16:35:00',1.75),('5815','2013-04-16','16:40:00',1.61),('5815','2013-04-16','16:45:00',1.67),('5815','2013-04-16','16:50:00',1.55),('5815','2013-04-16','16:55:00',1.48),('5815','2013-04-16','17:00:00',1.42),('5815','2013-04-16','17:05:00',1.36),('5815','2013-04-16','17:10:00',1.3),('5815','2013-04-16','17:15:00',1.24),('5815','2013-04-16','17:20:00',1.19),('5815','2013-04-16','17:25:00',1.13),('5815','2013-04-16','17:30:00',1.07),('5815','2013-04-15','11:15:00',1.03),('5815','2013-04-15','11:20:00',1.06),('5815','2013-04-15','11:25:00',1.05),('5815','2013-04-15','11:30:00',1.03),('5815','2013-04-15','11:35:00',1.02),('5815','2013-04-15','11:40:00',1.14),('5815','2013-04-15','11:45:00',1.36),('5815','2013-04-15','11:50:00',1.47),('5815','2013-04-15','11:55:00',1.54),('5815','2013-04-15','12:00:00',1.79),('5815','2013-04-15','12:05:00',2.29),('5815','2013-04-15','12:10:00',2.35),('5815','2013-04-15','12:15:00',2.75),('5815','2013-04-15','12:20:00',2.19),('5815','2013-04-15','12:25:00',1.93),('5815','2013-04-15','12:30:00',2.28),('5815','2013-04-15','12:35:00',2.49),('5815','2013-04-15','12:40:00',2.46),('5815','2013-04-15','12:45:00',2.12),('5815','2013-04-15','12:50:00',1.84),('5815','2013-04-15','12:55:00',2.4),('5815','2013-04-15','13:00:00',2.46),('5815','2013-04-15','13:05:00',2.33),('5815','2013-04-15','13:10:00',2.36),('5815','2013-04-15','13:15:00',2.39),('5815','2013-04-15','13:20:00',2.41),('5815','2013-04-15','13:25:00',2.43),('5815','2013-04-15','13:30:00',2.43),('5815','2013-04-15','13:35:00',2.43),('5815','2013-04-15','13:40:00',2.4),('5815','2013-04-15','13:45:00',2.36),('5815','2013-04-15','13:50:00',2.35),('5815','2013-04-15','13:55:00',2.27),('5815','2013-04-15','14:00:00',2.26),('5815','2013-04-15','14:05:00',2.35),('5815','2013-04-15','14:10:00',2.36),('5815','2013-04-15','14:15:00',2.28),('5815','2013-04-15','14:20:00',2.32),('5815','2013-04-15','14:25:00',1.83),('5815','2013-04-15','14:30:00',1.95),('5815','2013-04-15','14:35:00',1.96),('5815','2013-04-15','14:40:00',2.21),('5815','2013-04-15','14:45:00',2.3),('5815','2013-04-15','14:50:00',2.2),('5815','2013-04-15','14:55:00',2.15),('5815','2013-04-15','15:00:00',2.22),('5815','2013-04-15','15:05:00',2.19),('5815','2013-04-15','15:10:00',2.17),('5815','2013-04-15','15:15:00',2.14),('5815','2013-04-15','15:20:00',2.13),('5815','2013-04-15','15:25:00',2.06),('5815','2013-04-15','15:30:00',2),('5815','2013-04-15','15:35:00',2.03),('5815','2013-04-15','15:40:00',2),('5815','2013-04-15','15:45:00',1.96),('5815','2013-04-15','15:50:00',1.95),('5815','2013-04-15','15:55:00',1.9),('5815','2013-04-15','16:00:00',1.8),('5815','2013-04-15','16:05:00',1.82),('5815','2013-04-15','16:10:00',1.78),('5815','2013-04-15','16:15:00',1.71),('5815','2013-04-15','16:20:00',1.72),('5815','2013-04-15','16:25:00',1.68),('5815','2013-04-15','16:30:00',1.64),('5815','2013-04-15','16:35:00',1.61),('5815','2013-04-15','16:40:00',1.69),('5815','2013-04-15','16:45:00',1.69),('5815','2013-04-15','16:50:00',1.55),('5815','2013-04-15','16:55:00',1.33),('5815','2013-04-15','17:00:00',1.4),('5815','2013-04-15','17:05:00',1.4),('5815','2013-04-15','17:10:00',1.39),('5815','2013-04-15','17:15:00',1.33),('5815','2013-04-15','17:20:00',1.29),('5815','2013-04-15','17:25:00',1.24),('5815','2013-04-15','17:30:00',1.2),('5815','2013-04-15','17:35:00',1.12),('5815','2013-04-14','08:45:00',1),('5815','2013-04-14','08:50:00',1.06),('5815','2013-04-14','08:55:00',1.12),('5815','2013-04-14','09:00:00',1.17),('5815','2013-04-14','09:05:00',1.23),('5815','2013-04-14','09:10:00',1.28),('5815','2013-04-14','09:15:00',1.33),('5815','2013-04-14','09:20:00',1.38),('5815','2013-04-14','09:25:00',1.42),('5815','2013-04-14','09:30:00',1.46),('5815','2013-04-14','09:35:00',1.51),('5815','2013-04-14','09:40:00',1.56),('5815','2013-04-14','09:45:00',1.59),('5815','2013-04-14','09:50:00',1.64),('5815','2013-04-14','09:55:00',1.68),('5815','2013-04-14','10:00:00',1.72),('5815','2013-04-14','10:05:00',1.75),('5815','2013-04-14','10:10:00',1.79),('5815','2013-04-14','10:15:00',1.83),('5815','2013-04-14','10:20:00',1.87),('5815','2013-04-14','10:25:00',1.89),('5815','2013-04-14','10:30:00',1.93),('5815','2013-04-14','10:35:00',1.96),('5815','2013-04-14','10:40:00',1.99),('5815','2013-04-14','10:45:00',2.03),('5815','2013-04-14','10:50:00',2.06),('5815','2013-04-14','10:55:00',2.09),('5815','2013-04-14','11:00:00',2.11),('5815','2013-04-14','11:05:00',2.15),('5815','2013-04-14','11:10:00',2.17),('5815','2013-04-14','11:15:00',2.2),('5815','2013-04-14','11:20:00',2.2),('5815','2013-04-14','11:25:00',2.22),('5815','2013-04-14','11:30:00',2.24),('5815','2013-04-14','11:35:00',2.26),('5815','2013-04-14','11:40:00',2.28),('5815','2013-04-14','11:45:00',2.31),('5815','2013-04-14','11:50:00',2.31),('5815','2013-04-14','11:55:00',2.32),('5815','2013-04-14','12:00:00',2.33),('5815','2013-04-14','12:05:00',2.33),('5815','2013-04-14','12:10:00',2.36),('5815','2013-04-14','12:15:00',2.37),('5815','2013-04-14','12:20:00',2.37),('5815','2013-04-14','12:25:00',2.38),('5815','2013-04-14','12:30:00',2.4),('5815','2013-04-14','12:35:00',2.41),('5815','2013-04-14','12:40:00',2.41),('5815','2013-04-14','12:45:00',2.41),('5815','2013-04-14','12:50:00',2.4),('5815','2013-04-14','12:55:00',2.39),('5815','2013-04-14','13:00:00',2.4),('5815','2013-04-14','13:05:00',2.4),('5815','2013-04-14','13:10:00',2.44),('5815','2013-04-14','13:15:00',2.44),('5815','2013-04-14','13:20:00',2.41),('5815','2013-04-14','13:25:00',2.39),('5815','2013-04-14','13:30:00',2.38),('5815','2013-04-14','13:35:00',2.41),('5815','2013-04-14','13:40:00',2.41),('5815','2013-04-14','13:45:00',2.32),('5815','2013-04-14','13:50:00',2.37),('5815','2013-04-14','13:55:00',2.42),('5815','2013-04-14','14:00:00',2.44),('5815','2013-04-14','14:05:00',2.42),('5815','2013-04-14','14:10:00',2.44),('5815','2013-04-14','14:15:00',2.45),('5815','2013-04-14','14:20:00',2.44),('5815','2013-04-14','14:25:00',2.42),('5815','2013-04-14','14:30:00',2.4),('5815','2013-04-14','14:35:00',2.38),('5815','2013-04-14','14:40:00',2.36),('5815','2013-04-14','14:45:00',2.35),('5815','2013-04-14','14:50:00',2.33),('5815','2013-04-14','14:55:00',2.3),('5815','2013-04-14','15:00:00',2.28),('5815','2013-04-14','15:05:00',2.27),('5815','2013-04-14','15:10:00',2.24),('5815','2013-04-14','15:15:00',2.22),('5815','2013-04-14','15:20:00',2.19),('5815','2013-04-14','15:25:00',2.16),('5815','2013-04-14','15:30:00',2.14),('5815','2013-04-14','15:35:00',2.11),('5815','2013-04-14','15:40:00',2.08),('5815','2013-04-14','15:45:00',2.05),('5815','2013-04-14','15:50:00',2.01),('5815','2013-04-14','15:55:00',1.97),('5815','2013-04-14','16:00:00',1.93),('5815','2013-04-14','16:05:00',1.89),('5815','2013-04-14','16:10:00',1.85),('5815','2013-04-14','16:15:00',1.81),('5815','2013-04-14','16:20:00',1.77),('5815','2013-04-14','16:25:00',1.73),('5815','2013-04-14','16:30:00',1.67),('5815','2013-04-14','16:35:00',1.64),('5815','2013-04-14','16:40:00',1.59),('5815','2013-04-14','16:45:00',1.54),('5815','2013-04-14','16:50:00',1.49),('5815','2013-04-14','16:55:00',1.45),('5815','2013-04-14','17:00:00',1.39),('5815','2013-04-14','17:05:00',1.34),('5815','2013-04-14','17:10:00',1.29),('5815','2013-04-14','17:15:00',1.23),('5815','2013-04-14','17:20:00',1.19),('5815','2013-04-14','17:25:00',1.14),('5815','2013-04-14','17:30:00',1.07),('5815','2013-04-13','08:50:00',1),('5815','2013-04-13','08:55:00',1.06),('5815','2013-04-13','09:00:00',1.11),('5815','2013-04-13','09:05:00',1.16),('5815','2013-04-13','09:10:00',1.2),('5815','2013-04-13','09:15:00',1.24),('5815','2013-04-13','09:20:00',1.3),('5815','2013-04-13','09:25:00',1.35),('5815','2013-04-13','09:30:00',1.39),('5815','2013-04-13','09:35:00',1.45),('5815','2013-04-13','09:40:00',1.49),('5815','2013-04-13','09:45:00',1.54),('5815','2013-04-13','09:50:00',1.59),('5815','2013-04-13','09:55:00',1.63),('5815','2013-04-13','10:00:00',1.68),('5815','2013-04-13','10:05:00',1.72),('5815','2013-04-13','10:10:00',1.76),('5815','2013-04-13','10:15:00',1.8),('5815','2013-04-13','10:20:00',1.82),('5815','2013-04-13','10:25:00',1.85),('5815','2013-04-13','10:30:00',1.86),('5815','2013-04-13','10:35:00',1.92),('5815','2013-04-13','10:40:00',1.95),('5815','2013-04-13','10:45:00',1.98),('5815','2013-04-13','10:50:00',2.01),('5815','2013-04-13','10:55:00',2.03),('5815','2013-04-13','11:00:00',2.07),('5815','2013-04-13','11:05:00',2.09),('5815','2013-04-13','11:10:00',2.13),('5815','2013-04-13','11:15:00',2.14),('5815','2013-04-13','11:20:00',2.16),('5815','2013-04-13','11:25:00',2.16),('5815','2013-04-13','11:30:00',2.18),('5815','2013-04-13','11:35:00',2.22),('5815','2013-04-13','11:40:00',2.25),('5815','2013-04-13','11:45:00',2.24),('5815','2013-04-13','11:50:00',2.25),('5815','2013-04-13','11:55:00',2.28),('5815','2013-04-13','12:00:00',2.28),('5815','2013-04-13','12:05:00',2.29),('5815','2013-04-13','12:10:00',2.32),('5815','2013-04-13','12:15:00',2.32),('5815','2013-04-13','12:20:00',2.33),('5815','2013-04-13','12:25:00',2.34),('5815','2013-04-13','12:30:00',2.36),('5815','2013-04-13','12:35:00',2.37),('5815','2013-04-13','12:40:00',2.41),('5815','2013-04-13','12:45:00',2.42),('5815','2013-04-13','12:50:00',2.45),('5815','2013-04-13','12:55:00',2.48),('5815','2013-04-13','13:00:00',1.72),('5815','2013-04-13','13:05:00',1.97),('5815','2013-04-13','13:10:00',2.52),('5815','2013-04-13','13:15:00',2.46),('5815','2013-04-13','13:20:00',2.47),('5815','2013-04-13','13:25:00',2.45),('5815','2013-04-13','13:30:00',2.4),('5815','2013-04-13','13:35:00',2.41),('5815','2013-04-13','13:40:00',2.41),('5815','2013-04-13','13:45:00',2.4),('5815','2013-04-13','13:50:00',2.36),('5815','2013-04-13','13:55:00',2.33),('5815','2013-04-13','14:00:00',2.29),('5815','2013-04-13','14:05:00',2.37),('5815','2013-04-13','14:10:00',2.37),('5815','2013-04-13','14:15:00',2.34),('5815','2013-04-13','14:20:00',2.31),('5815','2013-04-13','14:25:00',2.28),('5815','2013-04-13','14:30:00',2.28),('5815','2013-04-13','14:35:00',2.32),('5815','2013-04-13','14:40:00',2.34),('5815','2013-04-13','14:45:00',2.38),('5815','2013-04-13','14:50:00',2.37),('5815','2013-04-13','14:55:00',2.31),('5815','2013-04-13','15:00:00',2.27),('5815','2013-04-13','15:05:00',2.25),('5815','2013-04-13','15:10:00',2.13),('5815','2013-04-13','15:15:00',2.11),('5815','2013-04-13','15:20:00',1.91),('5815','2013-04-13','15:25:00',1.81),('5815','2013-04-13','15:30:00',2.04),('5815','2013-04-13','15:35:00',2.13),('5815','2013-04-13','15:40:00',2.16),('5815','2013-04-13','15:45:00',2.11),('5815','2013-04-13','15:50:00',2.04),('5815','2013-04-13','15:55:00',1.24),('5815','2013-04-13','16:00:00',1.9),('5815','2013-04-13','16:05:00',1.87),('5815','2013-04-13','16:10:00',1.83),('5815','2013-04-13','16:15:00',1.73),('5815','2013-04-13','16:20:00',1.71),('5815','2013-04-13','16:25:00',1.72),('5815','2013-04-13','16:30:00',1.66),('5815','2013-04-13','16:35:00',1.59),('5815','2013-04-13','16:40:00',1.53),('5815','2013-04-13','16:45:00',1.48),('5815','2013-04-13','16:50:00',1.46),('5815','2013-04-13','16:55:00',1.39),('5815','2013-04-13','17:00:00',1.35),('5815','2013-04-13','17:05:00',1.3),('5815','2013-04-13','17:10:00',1.26),('5815','2013-04-13','17:15:00',1.2),('5815','2013-04-13','17:20:00',1.15),('5815','2013-04-13','17:25:00',1.08),('5815','2013-04-13','17:30:00',1.02),('5815','2013-04-12','09:05:00',1.02),('5815','2013-04-12','09:10:00',1.03),('5815','2013-04-12','09:15:00',1.31),('5815','2013-04-12','09:20:00',1.44),('5815','2013-04-12','09:25:00',1.24),('5815','2013-04-12','09:30:00',1.43),('5815','2013-04-12','09:35:00',1.41),('5815','2013-04-12','09:40:00',1.31),('5815','2013-04-12','09:45:00',1.54),('5815','2013-04-12','09:50:00',1.58),('5815','2013-04-12','09:55:00',1.66),('5815','2013-04-12','10:00:00',1.69),('5815','2013-04-12','10:05:00',1.74),('5815','2013-04-12','10:10:00',1.84),('5815','2013-04-12','10:15:00',2.04),('5815','2013-04-12','10:20:00',1.96),('5815','2013-04-12','10:25:00',1.55),('5815','2013-04-12','10:30:00',1.8),('5815','2013-04-12','10:35:00',1.41),('5815','2013-04-12','10:40:00',1.21),('5815','2013-04-12','10:45:00',1.93),('5815','2013-04-12','10:55:00',1.53),('5815','2013-04-12','11:00:00',1.39),('5815','2013-04-12','11:05:00',1.48),('5815','2013-04-12','11:10:00',1.2),('5815','2013-04-12','11:15:00',1.53),('5815','2013-04-12','11:20:00',2.11),('5815','2013-04-12','11:25:00',1.02),('5815','2013-04-12','11:35:00',2.58),('5815','2013-04-12','11:40:00',2.27),('5815','2013-04-12','11:45:00',1.89),('5815','2013-04-12','11:50:00',2.57),('5815','2013-04-12','11:55:00',1.35),('5815','2013-04-12','12:00:00',2.62),('5815','2013-04-12','12:05:00',2.55),('5815','2013-04-12','12:10:00',2.6),('5815','2013-04-12','12:15:00',2.58),('5815','2013-04-12','12:20:00',2.51),('5815','2013-04-12','12:25:00',2.42),('5815','2013-04-12','12:30:00',2.31),('5815','2013-04-12','12:35:00',2.58),('5815','2013-04-12','12:40:00',2.6),('5815','2013-04-12','12:45:00',2.55),('5815','2013-04-12','12:50:00',2.44),('5815','2013-04-12','12:55:00',2.52),('5815','2013-04-12','13:00:00',2.3),('5815','2013-04-12','13:05:00',2.54),('5815','2013-04-12','13:10:00',2.59),('5815','2013-04-12','13:15:00',2.49),('5815','2013-04-12','13:20:00',2.34),('5815','2013-04-12','13:25:00',2.51),('5815','2013-04-12','13:30:00',2.48),('5815','2013-04-12','13:35:00',1.36),('5815','2013-04-12','13:40:00',1.17),('5815','2013-04-12','13:45:00',2.12),('5815','2013-04-12','13:50:00',1.68),('5815','2013-04-12','13:55:00',1.12),('5815','2013-04-12','14:00:00',1.19),('5815','2013-04-12','14:05:00',1.41),('5815','2013-04-12','14:20:00',1.97),('5815','2013-04-12','14:25:00',2.2),('5815','2013-04-12','14:30:00',2.15),('5815','2013-04-12','14:35:00',2.3),('5815','2013-04-12','14:40:00',2.23),('5815','2013-04-12','14:45:00',2.24),('5815','2013-04-12','14:50:00',2.15),('5815','2013-04-12','14:55:00',2.18),('5815','2013-04-12','15:00:00',2.01),('5815','2013-04-12','15:05:00',1.81),('5815','2013-04-12','15:10:00',1.61),('5815','2013-04-12','15:15:00',1.82),('5815','2013-04-12','15:20:00',1.73),('5815','2013-04-12','15:25:00',1.61),('5815','2013-04-12','15:30:00',1.64),('5815','2013-04-12','15:35:00',1.58),('5815','2013-04-12','15:40:00',1.67),('5815','2013-04-12','15:45:00',1.7),('5815','2013-04-12','15:50:00',1.67),('5815','2013-04-12','15:55:00',1.63),('5815','2013-04-12','16:00:00',1.63),('5815','2013-04-12','16:05:00',1.53),('5815','2013-04-12','16:10:00',1.44),('5815','2013-04-12','16:15:00',1.49),('5815','2013-04-12','16:20:00',1.41),('5815','2013-04-12','16:25:00',1.3),('5815','2013-04-12','16:30:00',1.26),('5815','2013-04-12','16:35:00',1.16),('5815','2013-04-12','16:40:00',1.1),('5815','2013-04-12','16:45:00',1.07),('5815','2013-04-12','16:50:00',1.1),('5815','2013-04-12','17:10:00',1.13),('5815','2013-04-12','17:15:00',1.23),('5815','2013-04-12','17:20:00',1.03),('5815','2013-04-12','17:25:00',1.18),('5815','2013-04-12','17:30:00',1),('5815','2013-04-11','09:15:00',1.23),('5815','2013-04-11','09:20:00',1.06),('5815','2013-04-11','09:30:00',1.02),('5815','2013-04-11','10:25:00',1.03),('5815','2013-04-11','10:45:00',2.09),('5815','2013-04-11','10:50:00',1.69),('5815','2013-04-11','10:55:00',2.54),('5815','2013-04-11','11:00:00',1.07),('5815','2013-04-11','11:15:00',1.28),('5815','2013-04-11','11:20:00',2.61),('5815','2013-04-11','11:25:00',2.55),('5815','2013-04-11','11:30:00',1.87),('5815','2013-04-11','11:35:00',2.24),('5815','2013-04-11','11:40:00',2.57),('5815','2013-04-11','11:45:00',2.03),('5815','2013-04-11','11:50:00',1.86),('5815','2013-04-11','11:55:00',2.51),('5815','2013-04-11','12:00:00',2.49),('5815','2013-04-11','12:05:00',2.38),('5815','2013-04-11','12:10:00',2.35),('5815','2013-04-11','12:15:00',2.46),('5815','2013-04-11','12:20:00',2.55),('5815','2013-04-11','12:25:00',2.53),('5815','2013-04-11','12:30:00',2.51);
INSERT INTO `solarlog` VALUES ('5815','2013-04-11','12:35:00',2.46),('5815','2013-04-11','12:40:00',2.38),('5815','2013-04-11','12:45:00',2.39),('5815','2013-04-11','12:50:00',2.39),('5815','2013-04-11','12:55:00',2.49),('5815','2013-04-11','13:00:00',2.53),('5815','2013-04-11','13:05:00',2.49),('5815','2013-04-11','13:10:00',2.47),('5815','2013-04-11','13:15:00',2.48),('5815','2013-04-11','13:20:00',2.49),('5815','2013-04-11','13:25:00',2.47),('5815','2013-04-11','13:30:00',2.45),('5815','2013-04-11','13:35:00',2.46),('5815','2013-04-11','13:40:00',2.43),('5815','2013-04-11','13:45:00',2.48),('5815','2013-04-11','13:50:00',2.48),('5815','2013-04-11','13:55:00',2.47),('5815','2013-04-11','14:00:00',2.47),('5815','2013-04-11','14:05:00',2.46),('5815','2013-04-11','14:10:00',2.45),('5815','2013-04-11','14:15:00',2.42),('5815','2013-04-11','14:20:00',2.4),('5815','2013-04-11','14:25:00',2.39),('5815','2013-04-11','14:30:00',2.37),('5815','2013-04-11','14:35:00',2.35),('5815','2013-04-11','14:40:00',2.33),('5815','2013-04-11','14:45:00',2.31),('5815','2013-04-11','14:50:00',2.29),('5815','2013-04-11','14:55:00',2.28),('5815','2013-04-11','15:00:00',2.27),('5815','2013-04-11','15:05:00',2.24),('5815','2013-04-11','15:10:00',2.2),('5815','2013-04-11','15:15:00',2.17),('5815','2013-04-11','15:20:00',2.15),('5815','2013-04-11','15:25:00',2.12),('5815','2013-04-11','15:30:00',2.09),('5815','2013-04-11','15:35:00',2.06),('5815','2013-04-11','15:40:00',2.03),('5815','2013-04-11','15:45:00',2.01),('5815','2013-04-11','15:50:00',1.97),('5815','2013-04-11','15:55:00',1.92),('5815','2013-04-11','16:00:00',1.89),('5815','2013-04-11','16:05:00',1.85),('5815','2013-04-11','16:10:00',1.83),('5815','2013-04-11','16:15:00',1.64),('5815','2013-04-11','16:20:00',1.66),('5815','2013-04-11','16:25:00',1.69),('5815','2013-04-11','16:30:00',1.09),('5815','2013-04-11','16:45:00',1.54),('5815','2013-04-11','16:50:00',1.43),('5815','2013-04-11','16:55:00',1.39),('5815','2013-04-11','17:00:00',1.32),('5815','2013-04-11','17:05:00',1.27),('5815','2013-04-11','17:10:00',1.21),('5815','2013-04-11','17:15:00',1.16),('5815','2013-04-11','17:20:00',1.12),('5815','2013-04-11','17:25:00',1.06),('5815','2013-04-10','08:55:00',1.04),('5815','2013-04-10','09:00:00',1.09),('5815','2013-04-10','09:05:00',1.14),('5815','2013-04-10','09:10:00',1.18),('5815','2013-04-10','09:15:00',1.24),('5815','2013-04-10','09:20:00',1.29),('5815','2013-04-10','09:25:00',1.34),('5815','2013-04-10','09:30:00',1.36),('5815','2013-04-10','09:35:00',1.41),('5815','2013-04-10','09:40:00',1.48),('5815','2013-04-10','09:45:00',1.54),('5815','2013-04-10','09:50:00',1.6),('5815','2013-04-10','09:55:00',1.42),('5815','2013-04-10','10:15:00',1.28),('5815','2013-04-10','10:20:00',1.91),('5815','2013-04-10','10:25:00',1.9),('5815','2013-04-10','10:30:00',1.94),('5815','2013-04-10','10:35:00',2.1),('5815','2013-04-10','10:40:00',2.16),('5815','2013-04-10','10:45:00',2.28),('5815','2013-04-10','10:50:00',1.12),('5815','2013-04-10','11:05:00',2.22),('5815','2013-04-10','11:10:00',2.28),('5815','2013-04-10','11:15:00',2.29),('5815','2013-04-10','11:20:00',1.8),('5815','2013-04-10','11:30:00',1.73),('5815','2013-04-10','11:35:00',2.4),('5815','2013-04-10','11:40:00',1.06),('5815','2013-04-10','12:00:00',2.45),('5815','2013-04-10','12:05:00',2.59),('5815','2013-04-10','12:10:00',2.51),('5815','2013-04-10','12:20:00',1.17),('5815','2013-04-10','12:25:00',2.73),('5815','2013-04-10','12:30:00',2.65),('5815','2013-04-10','12:35:00',2.61),('5815','2013-04-10','12:40:00',2.65),('5815','2013-04-10','12:45:00',2.66),('5815','2013-04-10','12:50:00',2.62),('5815','2013-04-10','12:55:00',2.27),('5815','2013-04-10','13:00:00',2.32),('5815','2013-04-10','13:05:00',2.38),('5815','2013-04-10','13:10:00',1.9),('5815','2013-04-10','13:15:00',2.61),('5815','2013-04-10','13:20:00',1.78),('5815','2013-04-10','13:25:00',2.25),('5815','2013-04-10','13:30:00',2.58),('5815','2013-04-10','13:35:00',2.54),('5815','2013-04-10','13:40:00',2.55),('5815','2013-04-10','13:45:00',2.52),('5815','2013-04-10','13:50:00',2.5),('5815','2013-04-10','13:55:00',2.54),('5815','2013-04-10','14:00:00',2.53),('5815','2013-04-10','14:05:00',2.46),('5815','2013-04-10','14:10:00',2.52),('5815','2013-04-10','14:15:00',2.5),('5815','2013-04-10','14:20:00',2.48),('5815','2013-04-10','14:25:00',2.45),('5815','2013-04-10','14:30:00',2.4),('5815','2013-04-10','14:35:00',2.25),('5815','2013-04-10','14:40:00',2.33),('5815','2013-04-10','14:45:00',2.45),('5815','2013-04-10','14:50:00',2.38),('5815','2013-04-10','14:55:00',2.35),('5815','2013-04-10','15:00:00',2.33),('5815','2013-04-10','15:05:00',2.29),('5815','2013-04-10','15:10:00',2.24),('5815','2013-04-10','15:15:00',2.22),('5815','2013-04-10','15:20:00',2.15),('5815','2013-04-10','15:25:00',2.16),('5815','2013-04-10','15:30:00',2.14),('5815','2013-04-10','15:35:00',2.11),('5815','2013-04-10','15:40:00',2.07),('5815','2013-04-10','15:45:00',2.04),('5815','2013-04-10','15:50:00',1.99),('5815','2013-04-10','15:55:00',1.97),('5815','2013-04-10','16:00:00',1.93),('5815','2013-04-10','16:05:00',1.9),('5815','2013-04-10','16:10:00',1.86),('5815','2013-04-10','16:15:00',1.82),('5815','2013-04-10','16:20:00',1.79),('5815','2013-04-10','16:25:00',1.74),('5815','2013-04-10','16:30:00',1.69),('5815','2013-04-10','16:35:00',1.65),('5815','2013-04-10','16:40:00',1.6),('5815','2013-04-10','16:45:00',1.55),('5815','2013-04-10','16:50:00',1.49),('5815','2013-04-10','16:55:00',1.46),('5815','2013-04-10','17:00:00',1.41),('5815','2013-04-10','17:05:00',1.35),('5815','2013-04-10','17:10:00',1.3),('5815','2013-04-10','17:15:00',1.25),('5815','2013-04-10','17:20:00',1.2),('5815','2013-04-10','17:25:00',1.13),('5815','2013-04-09','09:00:00',1.09),('5815','2013-04-09','09:05:00',1.18),('5815','2013-04-09','09:10:00',1.24),('5815','2013-04-09','09:15:00',1.21),('5815','2013-04-09','09:20:00',1.22),('5815','2013-04-09','09:25:00',1.37),('5815','2013-04-09','09:30:00',1.41),('5815','2013-04-09','09:35:00',1.49),('5815','2013-04-09','09:40:00',1.52),('5815','2013-04-09','09:45:00',1.59),('5815','2013-04-09','09:50:00',1.65),('5815','2013-04-09','09:55:00',1.72),('5815','2013-04-09','10:00:00',1.74),('5815','2013-04-09','10:05:00',1.84),('5815','2013-04-09','10:10:00',1.95),('5815','2013-04-09','10:15:00',2.01),('5815','2013-04-09','10:20:00',2.03),('5815','2013-04-09','10:25:00',2.06),('5815','2013-04-09','10:30:00',2.07),('5815','2013-04-09','10:35:00',2.09),('5815','2013-04-09','10:40:00',2.11),('5815','2013-04-09','10:45:00',2.17),('5815','2013-04-09','10:50:00',2.06),('5815','2013-04-09','10:55:00',2.05),('5815','2013-04-09','11:00:00',2.04),('5815','2013-04-09','11:05:00',2.05),('5815','2013-04-09','11:10:00',2.08),('5815','2013-04-09','11:15:00',2.03),('5815','2013-04-09','11:20:00',2.24),('5815','2013-04-09','11:25:00',2.33),('5815','2013-04-09','11:30:00',2.33),('5815','2013-04-09','11:35:00',2.35),('5815','2013-04-09','11:40:00',2.38),('5815','2013-04-09','11:45:00',2.41),('5815','2013-04-09','11:50:00',2.42),('5815','2013-04-09','11:55:00',2.17),('5815','2013-04-09','12:00:00',2.46),('5815','2013-04-09','12:05:00',2.49),('5815','2013-04-09','12:10:00',2.5),('5815','2013-04-09','12:15:00',2.53),('5815','2013-04-09','12:20:00',2.54),('5815','2013-04-09','12:25:00',2.58),('5815','2013-04-09','12:30:00',2.62),('5815','2013-04-09','12:35:00',2.6),('5815','2013-04-09','12:40:00',2.55),('5815','2013-04-09','12:45:00',2.57),('5815','2013-04-09','12:50:00',2.62),('5815','2013-04-09','12:55:00',2.49),('5815','2013-04-09','13:00:00',2.59),('5815','2013-04-09','13:05:00',2.56),('5815','2013-04-09','13:10:00',2.42),('5815','2013-04-09','13:15:00',1.89),('5815','2013-04-09','13:20:00',2.85),('5815','2013-04-09','13:25:00',1.57),('5815','2013-04-09','13:30:00',1.69),('5815','2013-04-09','13:35:00',2.44),('5815','2013-04-09','13:40:00',2.09),('5815','2013-04-09','13:45:00',2.72),('5815','2013-04-09','13:50:00',2.04),('5815','2013-04-09','13:55:00',2.25),('5815','2013-04-09','14:00:00',1.99),('5815','2013-04-09','14:05:00',2.63),('5815','2013-04-09','14:10:00',2.57),('5815','2013-04-09','14:15:00',2.58),('5815','2013-04-09','14:20:00',2.56),('5815','2013-04-09','14:25:00',2.57),('5815','2013-04-09','14:30:00',2.54),('5815','2013-04-09','14:35:00',2.53),('5815','2013-04-09','14:40:00',2.51),('5815','2013-04-09','14:45:00',2.28),('5815','2013-04-09','14:50:00',2.34),('5815','2013-04-09','14:55:00',2.28),('5815','2013-04-09','15:00:00',2.47),('5815','2013-04-09','15:05:00',2.43),('5815','2013-04-09','15:10:00',2.36),('5815','2013-04-09','15:15:00',1.93),('5815','2013-04-09','15:20:00',1.69),('5815','2013-04-09','15:25:00',2.3),('5815','2013-04-09','15:30:00',2.16),('5815','2013-04-09','15:35:00',1.86),('5815','2013-04-09','15:40:00',2.14),('5815','2013-04-09','15:45:00',2.09),('5815','2013-04-09','15:50:00',2.18),('5815','2013-04-09','15:55:00',1.74),('5815','2013-04-09','16:00:00',2),('5815','2013-04-09','16:05:00',1.58),('5815','2013-04-09','16:10:00',1.78),('5815','2013-04-09','16:15:00',1.67),('5815','2013-04-09','16:20:00',1.8),('5815','2013-04-09','16:25:00',1.47),('5815','2013-04-09','16:30:00',1.7),('5815','2013-04-09','16:40:00',1.52),('5815','2013-04-09','16:45:00',1.44),('5815','2013-04-09','16:50:00',1.39),('5815','2013-04-09','17:00:00',1.54),('5815','2013-04-09','17:05:00',1.16),('5815','2013-04-09','17:15:00',1.15),('5815','2013-04-09','17:20:00',1.29),('5815','2013-04-08','09:55:00',1.69),('5815','2013-04-08','10:00:00',1.04),('5815','2013-04-08','10:15:00',1.16),('5815','2013-04-08','10:20:00',1.07),('5815','2013-04-08','10:35:00',1.83),('5815','2013-04-08','10:40:00',1.19),('5815','2013-04-08','10:45:00',1.8),('5815','2013-04-08','10:50:00',2.39),('5815','2013-04-08','10:55:00',1.94),('5815','2013-04-08','11:00:00',1.85),('5815','2013-04-08','11:05:00',2.06),('5815','2013-04-08','11:10:00',2.45),('5815','2013-04-08','11:15:00',1.43),('5815','2013-04-08','11:25:00',2.31),('5815','2013-04-08','11:30:00',2.73),('5815','2013-04-08','11:35:00',2.14),('5815','2013-04-08','11:45:00',1.79),('5815','2013-04-08','11:50:00',2.57),('5815','2013-04-08','11:55:00',1.38),('5815','2013-04-08','12:00:00',2.77),('5815','2013-04-08','12:05:00',2.65),('5815','2013-04-08','12:10:00',2.67),('5815','2013-04-08','12:15:00',2.67),('5815','2013-04-08','12:20:00',1.91),('5815','2013-04-08','12:25:00',2.45),('5815','2013-04-08','12:30:00',2.65),('5815','2013-04-08','12:35:00',2.44),('5815','2013-04-08','12:40:00',2.65),('5815','2013-04-08','12:45:00',2.62),('5815','2013-04-08','12:50:00',2.72),('5815','2013-04-08','12:55:00',2.66),('5815','2013-04-08','13:00:00',2.71),('5815','2013-04-08','13:05:00',2.78),('5815','2013-04-08','13:10:00',2.87),('5815','2013-04-08','13:15:00',2.8),('5815','2013-04-08','13:20:00',1.77),('5815','2013-04-08','13:25:00',2.58),('5815','2013-04-08','13:30:00',2.21),('5815','2013-04-08','13:40:00',1.35),('5815','2013-04-08','13:50:00',1.94),('5815','2013-04-08','13:55:00',2.54),('5815','2013-04-08','14:00:00',2.45),('5815','2013-04-08','14:05:00',2.27),('5815','2013-04-08','14:10:00',1.89),('5815','2013-04-08','14:15:00',2.2),('5815','2013-04-08','14:20:00',1.26),('5815','2013-04-08','14:25:00',1.6),('5815','2013-04-08','14:30:00',2.19),('5815','2013-04-08','14:35:00',2.28),('5815','2013-04-08','14:40:00',2.39),('5815','2013-04-08','14:45:00',2.21),('5815','2013-04-08','14:50:00',2.15),('5815','2013-04-08','14:55:00',2.17),('5815','2013-04-08','15:00:00',1.73),('5815','2013-04-08','15:05:00',1.82),('5815','2013-04-08','15:10:00',2.4),('5815','2013-04-08','15:15:00',1.65),('5815','2013-04-08','15:20:00',2.31),('5815','2013-04-08','15:25:00',2.39),('5815','2013-04-08','15:30:00',2.11),('5815','2013-04-08','15:35:00',1.47),('5815','2013-04-08','15:40:00',2.27),('5815','2013-04-08','15:45:00',1.72),('5815','2013-04-08','15:50:00',2.04),('5815','2013-04-08','15:55:00',1.82),('5815','2013-04-08','16:00:00',1.7),('5815','2013-04-08','16:05:00',1.81),('5815','2013-04-08','16:10:00',1.8),('5815','2013-04-08','16:15:00',1.26),('5815','2013-04-08','16:50:00',1.26),('5815','2013-04-08','16:55:00',1.4),('5815','2013-04-07','09:10:00',1.05),('5815','2013-04-07','09:20:00',1.15),('5815','2013-04-07','09:30:00',1.4),('5815','2013-04-07','09:35:00',1.56),('5815','2013-04-07','09:40:00',1.64),('5815','2013-04-07','09:45:00',1.65),('5815','2013-04-07','09:50:00',1.23),('5815','2013-04-07','10:00:00',1.73),('5815','2013-04-07','10:05:00',1.85),('5815','2013-04-07','10:10:00',1.79),('5815','2013-04-07','10:15:00',1.86),('5815','2013-04-07','10:20:00',1.86),('5815','2013-04-07','10:25:00',1.86),('5815','2013-04-07','10:30:00',1.9),('5815','2013-04-07','10:35:00',1.83),('5815','2013-04-07','10:40:00',1.99),('5815','2013-04-07','10:45:00',2.07),('5815','2013-04-07','10:50:00',2.12),('5815','2013-04-07','10:55:00',2.05),('5815','2013-04-07','11:00:00',2.17),('5815','2013-04-07','11:05:00',1.93),('5815','2013-04-07','11:10:00',1.64),('5815','2013-04-07','11:15:00',1.67),('5815','2013-04-07','11:20:00',1.38),('5815','2013-04-07','11:25:00',1.16),('5815','2013-04-07','11:30:00',1.26),('5815','2013-04-07','11:35:00',1.62),('5815','2013-04-07','11:40:00',1.83),('5815','2013-04-07','11:45:00',1.65),('5815','2013-04-07','11:50:00',1.56),('5815','2013-04-07','11:55:00',1.32),('5815','2013-04-07','12:00:00',1.27),('5815','2013-04-07','12:05:00',1.19),('5815','2013-04-07','12:10:00',1.26),('5815','2013-04-07','12:15:00',1.52),('5815','2013-04-07','12:20:00',1.53),('5815','2013-04-07','12:25:00',1.58),('5815','2013-04-07','12:30:00',1.72),('5815','2013-04-07','12:35:00',1.62),('5815','2013-04-07','12:40:00',1.22),('5815','2013-04-07','12:45:00',1.31),('5815','2013-04-07','12:50:00',1.64),('5815','2013-04-07','12:55:00',1.84),('5815','2013-04-07','13:00:00',1.26),('5815','2013-04-07','13:05:00',1.35),('5815','2013-04-07','13:10:00',1.63),('5815','2013-04-07','13:15:00',1.72),('5815','2013-04-07','13:20:00',2.18),('5815','2013-04-07','13:25:00',1.93),('5815','2013-04-07','13:30:00',1.69),('5815','2013-04-07','13:35:00',1.85),('5815','2013-04-07','13:40:00',2.15),('5815','2013-04-07','13:45:00',1.74),('5815','2013-04-07','13:50:00',1.79),('5815','2013-04-07','13:55:00',2.33),('5815','2013-04-07','14:00:00',2.32),('5815','2013-04-07','14:05:00',1.9),('5815','2013-04-07','14:10:00',1.99),('5815','2013-04-07','14:15:00',2.24),('5815','2013-04-07','14:20:00',2.04),('5815','2013-04-07','14:25:00',2.37),('5815','2013-04-07','14:30:00',2.32),('5815','2013-04-07','14:35:00',2.21),('5815','2013-04-07','14:40:00',2.15),('5815','2013-04-07','14:45:00',2.21),('5815','2013-04-07','14:50:00',2.23),('5815','2013-04-07','14:55:00',2.36),('5815','2013-04-07','15:00:00',1.86),('5815','2013-04-07','15:05:00',1.86),('5815','2013-04-07','15:10:00',1.73),('5815','2013-04-07','15:15:00',1.86),('5815','2013-04-07','15:20:00',1.59),('5815','2013-04-07','15:25:00',2.16),('5815','2013-04-07','15:30:00',2.24),('5815','2013-04-07','15:35:00',2.14),('5815','2013-04-07','15:40:00',2.09),('5815','2013-04-07','15:45:00',2.04),('5815','2013-04-07','15:50:00',2.01),('5815','2013-04-07','15:55:00',1.98),('5815','2013-04-07','16:00:00',1.94),('5815','2013-04-07','16:05:00',1.85),('5815','2013-04-07','16:10:00',1.7),('5815','2013-04-07','16:15:00',1.82),('5815','2013-04-07','16:20:00',1.81),('5815','2013-04-07','16:25:00',1.73),('5815','2013-04-07','16:30:00',1.69),('5815','2013-04-07','16:35:00',1.64),('5815','2013-04-07','16:40:00',1.59),('5815','2013-04-07','16:45:00',1.56),('5815','2013-04-07','16:50:00',1.52),('5815','2013-04-07','16:55:00',1.46),('5815','2013-04-07','17:00:00',1.42),('5815','2013-04-07','17:05:00',1.38),('5815','2013-04-07','17:10:00',1.3),('5815','2013-04-07','17:15:00',1.25),('5815','2013-04-07','17:20:00',1.16),('5815','2013-04-07','17:25:00',1.18),('5815','2013-04-06','09:45:00',1.07),('5815','2013-04-06','09:50:00',1.15),('5815','2013-04-06','09:55:00',1.28),('5815','2013-04-06','10:00:00',1.5),('5815','2013-04-06','10:05:00',1.54),('5815','2013-04-06','10:10:00',1.54),('5815','2013-04-06','10:15:00',1.56),('5815','2013-04-06','10:20:00',1.63),('5815','2013-04-06','10:25:00',1.6),('5815','2013-04-06','10:30:00',1.42),('5815','2013-04-06','10:35:00',1.58),('5815','2013-04-06','10:40:00',1.54),('5815','2013-04-06','10:45:00',1.53),('5815','2013-04-06','10:50:00',1.49),('5815','2013-04-06','10:55:00',1.33),('5815','2013-04-06','11:00:00',1.19),('5815','2013-04-06','11:05:00',1.03),('5815','2013-04-06','11:10:00',1.25),('5815','2013-04-06','11:15:00',1.73),('5815','2013-04-06','11:20:00',1.98),('5815','2013-04-06','11:25:00',2.17),('5815','2013-04-06','11:30:00',2.06),('5815','2013-04-06','11:35:00',1.94),('5815','2013-04-06','11:40:00',1.73),('5815','2013-04-06','11:45:00',1.38),('5815','2013-04-06','11:50:00',1.32),('5815','2013-04-06','11:55:00',1.39),('5815','2013-04-06','12:00:00',1.45),('5815','2013-04-06','12:05:00',1.41),('5815','2013-04-06','12:10:00',1.54),('5815','2013-04-06','12:15:00',1.48),('5815','2013-04-06','12:20:00',1.62),('5815','2013-04-06','12:25:00',1.78),('5815','2013-04-06','12:30:00',1.51),('5815','2013-04-06','12:35:00',1.65),('5815','2013-04-06','12:40:00',1.62),('5815','2013-04-06','12:45:00',1.41),('5815','2013-04-06','12:50:00',1.47),('5815','2013-04-06','12:55:00',1.6),('5815','2013-04-06','13:00:00',1.86),('5815','2013-04-06','13:05:00',2.05),('5815','2013-04-06','13:10:00',2),('5815','2013-04-06','13:15:00',1.77),('5815','2013-04-06','13:20:00',1.65),('5815','2013-04-06','13:25:00',1.9),('5815','2013-04-06','13:30:00',1.96),('5815','2013-04-06','13:35:00',1.77),('5815','2013-04-06','13:40:00',1.9),('5815','2013-04-06','13:45:00',2.11),('5815','2013-04-06','13:50:00',1.94),('5815','2013-04-06','13:55:00',1.82),('5815','2013-04-06','14:00:00',2.16),('5815','2013-04-06','14:05:00',1.94),('5815','2013-04-06','14:10:00',1.49),('5815','2013-04-06','14:15:00',1.36),('5815','2013-04-06','14:20:00',1.21),('5815','2013-04-06','14:25:00',1.42),('5815','2013-04-06','14:30:00',1.48),('5815','2013-04-06','14:35:00',1.35),('5815','2013-04-06','14:40:00',1.13),('5815','2013-04-06','14:45:00',1.26),('5815','2013-04-06','14:50:00',1.42),('5815','2013-04-06','14:55:00',1.35),('5815','2013-04-06','15:00:00',1.38),('5815','2013-04-06','15:05:00',1.77),('5815','2013-04-06','15:10:00',1.75),('5815','2013-04-06','15:15:00',1.73),('5815','2013-04-06','15:20:00',1.75),('5815','2013-04-06','15:25:00',1.87),('5815','2013-04-06','15:30:00',1.78),('5815','2013-04-06','15:35:00',1.66),('5815','2013-04-06','15:40:00',1.68),('5815','2013-04-06','15:45:00',1.56),('5815','2013-04-06','15:50:00',1.45),('5815','2013-04-06','15:55:00',1.56),('5815','2013-04-06','16:00:00',1.44),('5815','2013-04-06','16:05:00',1.29),('5815','2013-04-06','16:10:00',1.08),('5815','2013-04-06','16:45:00',1.29),('5815','2013-04-06','16:50:00',1.39),('5815','2013-04-06','16:55:00',1.25),('5815','2013-04-06','17:00:00',1.18),('5815','2013-04-06','17:20:00',1.04),('5815','2013-04-06','17:30:00',1.02),('5815','2013-04-06','17:35:00',1.01),('5815','2013-04-05','08:55:00',1),('5815','2013-04-05','09:00:00',1.05),('5815','2013-04-05','09:05:00',1.12),('5815','2013-04-05','09:10:00',1.17),('5815','2013-04-05','09:15:00',1.23),('5815','2013-04-05','09:20:00',1.28),('5815','2013-04-05','09:25:00',1.33),('5815','2013-04-05','09:30:00',1.37),('5815','2013-04-05','09:35:00',1.39),('5815','2013-04-05','09:40:00',1.46),('5815','2013-04-05','09:45:00',1.49),('5815','2013-04-05','09:50:00',1.53),('5815','2013-04-05','09:55:00',1.58),('5815','2013-04-05','10:00:00',1.63),('5815','2013-04-05','10:05:00',1.66),('5815','2013-04-05','10:10:00',1.69),('5815','2013-04-05','10:15:00',1.7),('5815','2013-04-05','10:20:00',1.78),('5815','2013-04-05','10:25:00',1.82),('5815','2013-04-05','10:30:00',1.89),('5815','2013-04-05','10:35:00',1.9),('5815','2013-04-05','10:40:00',1.93),('5815','2013-04-05','10:45:00',1.95),('5815','2013-04-05','10:50:00',1.99),('5815','2013-04-05','10:55:00',2.03),('5815','2013-04-05','11:00:00',2.06),('5815','2013-04-05','11:05:00',2.1),('5815','2013-04-05','11:10:00',2.14),('5815','2013-04-05','11:15:00',2.13),('5815','2013-04-05','11:20:00',2.18),('5815','2013-04-05','11:25:00',2.23),('5815','2013-04-05','11:30:00',2.24),('5815','2013-04-05','11:35:00',2.28),('5815','2013-04-05','11:40:00',2.32),('5815','2013-04-05','11:45:00',2.32),('5815','2013-04-05','11:50:00',2.33),('5815','2013-04-05','11:55:00',2.34),('5815','2013-04-05','12:00:00',2.32),('5815','2013-04-05','12:05:00',2.35),('5815','2013-04-05','12:10:00',2.34),('5815','2013-04-05','12:15:00',2.35),('5815','2013-04-05','12:20:00',2.25),('5815','2013-04-05','12:25:00',2.04),('5815','2013-04-05','12:30:00',2.31),('5815','2013-04-05','12:35:00',2.49),('5815','2013-04-05','12:40:00',2.46),('5815','2013-04-05','12:45:00',2.46),('5815','2013-04-05','12:50:00',2.46),('5815','2013-04-05','12:55:00',2.48),('5815','2013-04-05','13:00:00',2.46),('5815','2013-04-05','13:05:00',2.47),('5815','2013-04-05','13:10:00',2.46),('5815','2013-04-05','13:15:00',1.91),('5815','2013-04-05','13:20:00',1.48),('5815','2013-04-05','13:30:00',1.61),('5815','2013-04-05','13:35:00',2.65),('5815','2013-04-05','13:40:00',2.81),('5815','2013-04-05','13:45:00',2.79),('5815','2013-04-05','13:50:00',2.62),('5815','2013-04-05','13:55:00',2.61),('5815','2013-04-05','14:00:00',2.44),('5815','2013-04-05','14:05:00',2.56),('5815','2013-04-05','14:10:00',1.09),('5815','2013-04-05','14:15:00',2.65),('5815','2013-04-05','14:20:00',1.17),('5815','2013-04-05','14:25:00',1.85),('5815','2013-04-05','14:30:00',2.1),('5815','2013-04-05','14:35:00',2.42),('5815','2013-04-05','14:40:00',2.43),('5815','2013-04-05','14:45:00',2.3),('5815','2013-04-05','14:50:00',2.32),('5815','2013-04-05','14:55:00',1.91),('5815','2013-04-05','15:00:00',2.27),('5815','2013-04-05','15:05:00',2.26),('5815','2013-04-05','15:10:00',1.98),('5815','2013-04-05','15:15:00',2.15),('5815','2013-04-05','15:20:00',2.13),('5815','2013-04-05','15:25:00',2.11),('5815','2013-04-05','15:30:00',2.03),('5815','2013-04-05','15:35:00',2),('5815','2013-04-05','15:40:00',1.99),('5815','2013-04-05','15:45:00',1.8),('5815','2013-04-05','15:50:00',1.77),('5815','2013-04-05','15:55:00',1.91),('5815','2013-04-05','16:00:00',1.73),('5815','2013-04-05','16:05:00',1.85),('5815','2013-04-05','16:10:00',1.86),('5815','2013-04-05','16:15:00',1.71),('5815','2013-04-05','16:20:00',1.41),('5815','2013-04-05','16:25:00',1.17),('5815','2013-04-05','16:30:00',1.44),('5815','2013-04-05','16:35:00',1.38),('5815','2013-04-05','16:40:00',1.07),('5815','2013-04-05','16:45:00',1.44),('5815','2013-04-05','16:50:00',1.39),('5815','2013-04-05','16:55:00',1.22),('5815','2013-04-05','17:00:00',1.22),('5815','2013-04-05','17:05:00',1.07),('5815','2013-04-04','09:05:00',1.31),('5815','2013-04-04','09:15:00',1.28),('5815','2013-04-04','09:20:00',1.13),('5815','2013-04-04','09:40:00',1.24),('5815','2013-04-04','09:45:00',1.21),('5815','2013-04-04','10:10:00',1.24),('5815','2013-04-04','10:15:00',1.83),('5815','2013-04-04','10:25:00',1.39),('5815','2013-04-04','10:30:00',1.49),('5815','2013-04-04','10:35:00',1.31),('5815','2013-04-04','10:40:00',2),('5815','2013-04-04','10:45:00',1.34),('5815','2013-04-04','10:50:00',1.28),('5815','2013-04-04','10:55:00',1.37),('5815','2013-04-04','11:00:00',1.42),('5815','2013-04-04','11:05:00',1.93),('5815','2013-04-04','11:10:00',2.39),('5815','2013-04-04','11:15:00',2.42),('5815','2013-04-04','11:20:00',1.68),('5815','2013-04-04','11:25:00',1.87),('5815','2013-04-04','11:30:00',1.83),('5815','2013-04-04','11:35:00',2.45),('5815','2013-04-04','11:40:00',2.23),('5815','2013-04-04','11:45:00',2.22),('5815','2013-04-04','11:50:00',1.64),('5815','2013-04-04','11:55:00',2.19),('5815','2013-04-04','12:00:00',2.68),('5815','2013-04-04','12:05:00',2.04),('5815','2013-04-04','12:10:00',2.02),('5815','2013-04-04','12:15:00',1.17),('5815','2013-04-04','12:25:00',1.14),('5815','2013-04-04','12:45:00',1.96),('5815','2013-04-04','12:50:00',2.53),('5815','2013-04-04','12:55:00',2.53),('5815','2013-04-04','13:00:00',1.69),('5815','2013-04-04','13:05:00',2.32),('5815','2013-04-04','13:10:00',1.61),('5815','2013-04-04','13:15:00',1.63),('5815','2013-04-04','13:20:00',1.33),('5815','2013-04-04','13:25:00',1.75),('5815','2013-04-04','13:30:00',1.49),('5815','2013-04-04','13:35:00',1.95),('5815','2013-04-04','13:40:00',2.76),('5815','2013-04-04','13:45:00',1.71),('5815','2013-04-04','13:50:00',2.87),('5815','2013-04-04','13:55:00',2.36),('5815','2013-04-04','14:00:00',1.6),('5815','2013-04-04','14:05:00',2.83),('5815','2013-04-04','14:10:00',2.19),('5815','2013-04-04','14:15:00',2.23),('5815','2013-04-04','14:20:00',2.54),('5815','2013-04-04','14:25:00',2.4),('5815','2013-04-04','14:30:00',2.47),('5815','2013-04-04','14:35:00',2.44),('5815','2013-04-04','14:40:00',2.43),('5815','2013-04-04','14:45:00',2.29),('5815','2013-04-04','14:50:00',1.39),('5815','2013-04-04','14:55:00',2.69),('5815','2013-04-04','15:00:00',2.24),('5815','2013-04-04','15:05:00',2.2),('5815','2013-04-04','15:10:00',2.05),('5815','2013-04-04','15:25:00',1.24),('5815','2013-04-04','15:30:00',1.01),('5815','2013-04-04','15:50:00',1.02),('5815','2013-04-04','16:00:00',1.02),('5815','2013-04-04','16:15:00',1.37),('5815','2013-04-04','16:20:00',1.15),('5815','2013-04-04','16:25:00',1.14),('5815','2013-04-04','16:45:00',1.17),('5815','2013-04-04','16:50:00',1.84),('5815','2013-04-04','17:10:00',1.1),('5815','2013-04-04','17:15:00',1.21),('5815','2013-04-04','17:30:00',1.26),('5815','2013-04-03','09:00:00',1.08),('5815','2013-04-03','09:35:00',1.38),('5815','2013-04-03','09:40:00',1.3),('5815','2013-04-03','09:45:00',1.11),('5815','2013-04-03','10:05:00',1.36),('5815','2013-04-03','10:10:00',1.3),('5815','2013-04-03','10:25:00',1.76),('5815','2013-04-03','10:30:00',1.83),('5815','2013-04-03','10:35:00',1.15),('5815','2013-04-03','10:40:00',2.23),('5815','2013-04-03','10:45:00',1.24),('5815','2013-04-03','10:50:00',1.33),('5815','2013-04-03','10:55:00',2.03),('5815','2013-04-03','11:00:00',1.25),('5815','2013-04-03','11:40:00',1.59),('5815','2013-04-03','11:45:00',1.91),('5815','2013-04-03','11:50:00',2.21),('5815','2013-04-03','11:55:00',2.32),('5815','2013-04-03','12:00:00',2.32),('5815','2013-04-03','12:05:00',2.27),('5815','2013-04-03','12:10:00',2.33),('5815','2013-04-03','12:15:00',2.28),('5815','2013-04-03','12:20:00',2.08),('5815','2013-04-03','12:25:00',1.81),('5815','2013-04-03','12:30:00',1.72),('5815','2013-04-03','12:35:00',1.42),('5815','2013-04-03','12:40:00',2.16),('5815','2013-04-03','12:45:00',1.54),('5815','2013-04-03','12:50:00',2.12),('5815','2013-04-03','12:55:00',2.29),('5815','2013-04-03','13:00:00',2.21),('5815','2013-04-03','13:05:00',2.26),('5815','2013-04-03','13:10:00',2.35),('5815','2013-04-03','13:15:00',2.45),('5815','2013-04-03','13:20:00',2.38),('5815','2013-04-03','13:25:00',2.44),('5815','2013-04-03','13:30:00',2.4),('5815','2013-04-03','13:35:00',2.23),('5815','2013-04-03','13:40:00',1.9),('5815','2013-04-03','13:45:00',1.91),('5815','2013-04-03','13:50:00',1.86),('5815','2013-04-03','13:55:00',1.4),('5815','2013-04-03','14:00:00',1.47),('5815','2013-04-03','14:05:00',1.98),('5815','2013-04-03','14:10:00',2.3),('5815','2013-04-03','14:15:00',2.3),('5815','2013-04-03','14:20:00',2.26),('5815','2013-04-03','14:25:00',2.21),('5815','2013-04-03','14:30:00',2.2),('5815','2013-04-03','14:35:00',2.18),('5815','2013-04-03','14:40:00',2.18),('5815','2013-04-03','14:45:00',2.15),('5815','2013-04-03','14:50:00',2.14),('5815','2013-04-03','14:55:00',2.15),('5815','2013-04-03','15:00:00',2.11),('5815','2013-04-03','15:05:00',2.05),('5815','2013-04-03','15:10:00',1.94),('5815','2013-04-03','15:15:00',1.9),('5815','2013-04-03','15:20:00',1.94),('5815','2013-04-03','15:25:00',1.96),('5815','2013-04-03','15:30:00',1.94),('5815','2013-04-03','15:35:00',1.91),('5815','2013-04-03','15:40:00',1.86),('5815','2013-04-03','15:45:00',1.82),('5815','2013-04-03','15:50:00',1.75),('5815','2013-04-03','15:55:00',1.73),('5815','2013-04-03','16:00:00',1.71),('5815','2013-04-03','16:05:00',1.68),('5815','2013-04-03','16:10:00',1.55),('5815','2013-04-03','16:15:00',1.52),('5815','2013-04-03','16:20:00',1.36),('5815','2013-04-03','16:25:00',1.37),('5815','2013-04-03','16:30:00',1.07),('5815','2013-04-03','16:35:00',1.16),('5815','2013-04-03','16:40:00',1.11),('5815','2013-04-03','16:45:00',1.09),('5815','2013-04-03','16:55:00',1.12),('5815','2013-04-03','17:00:00',1.02),('5815','2013-04-03','17:05:00',1.02),('5815','2013-04-02','09:05:00',1.2),('5815','2013-04-02','09:10:00',1.25),('5815','2013-04-02','09:15:00',1.32),('5815','2013-04-02','09:20:00',1.4),('5815','2013-04-02','09:30:00',1.07),('5815','2013-04-02','09:40:00',1.69),('5815','2013-04-02','09:45:00',1.23),('5815','2013-04-02','09:50:00',1.74),('5815','2013-04-02','09:55:00',1.97),('5815','2013-04-02','10:00:00',2.04),('5815','2013-04-02','10:20:00',1.59),('5815','2013-04-02','10:25:00',1.99),('5815','2013-04-02','10:30:00',1.37),('5815','2013-04-02','10:35:00',1.23),('5815','2013-04-02','10:55:00',1.84),('5815','2013-04-02','11:05:00',2.49),('5815','2013-04-02','11:10:00',1.31),('5815','2013-04-02','11:15:00',1.7),('5815','2013-04-02','11:20:00',1.22),('5815','2013-04-02','11:25:00',1.55),('5815','2013-04-02','11:30:00',1.05),('5815','2013-04-02','11:40:00',1.33),('5815','2013-04-02','11:50:00',1.51),('5815','2013-04-02','11:55:00',1.3),('5815','2013-04-02','12:00:00',2.13),('5815','2013-04-02','12:05:00',1.66),('5815','2013-04-02','12:10:00',2.75),('5815','2013-04-02','12:20:00',2.09),('5815','2013-04-02','12:25:00',1.78),('5815','2013-04-02','12:30:00',2.47),('5815','2013-04-02','12:35:00',2.11),('5815','2013-04-02','12:40:00',2.16),('5815','2013-04-02','12:45:00',2.43),('5815','2013-04-02','12:50:00',2.59),('5815','2013-04-02','12:55:00',2.48),('5815','2013-04-02','13:00:00',2.63),('5815','2013-04-02','13:05:00',1.79),('5815','2013-04-02','13:10:00',1.4),('5815','2013-04-02','13:15:00',2.61),('5815','2013-04-02','13:20:00',1.77),('5815','2013-04-02','13:25:00',1.54),('5815','2013-04-02','13:30:00',1.46),('5815','2013-04-02','13:35:00',2.1),('5815','2013-04-02','13:40:00',1.91),('5815','2013-04-02','13:45:00',2.14),('5815','2013-04-02','13:50:00',1.82),('5815','2013-04-02','13:55:00',2.41),('5815','2013-04-02','14:00:00',2.3),('5815','2013-04-02','14:05:00',1.67),('5815','2013-04-02','14:10:00',1.47),('5815','2013-04-02','14:15:00',2.14),('5815','2013-04-02','14:20:00',1.62),('5815','2013-04-02','14:25:00',2.25),('5815','2013-04-02','14:30:00',1.92),('5815','2013-04-02','14:35:00',2.36),('5815','2013-04-02','14:40:00',2.48),('5815','2013-04-02','14:45:00',2.02),('5815','2013-04-02','14:55:00',1.34),('5815','2013-04-02','15:00:00',2.67),('5815','2013-04-02','15:05:00',2.4),('5815','2013-04-02','15:10:00',2.63),('5815','2013-04-02','15:15:00',2.32),('5815','2013-04-02','15:20:00',2.19),('5815','2013-04-02','15:25:00',2.46),('5815','2013-04-02','15:30:00',2.32),('5815','2013-04-02','15:35:00',2.33),('5815','2013-04-02','15:40:00',2.16),('5815','2013-04-02','15:45:00',1.92),('5815','2013-04-02','15:50:00',2.14),('5815','2013-04-02','15:55:00',2.01),('5815','2013-04-02','16:00:00',2.18),('5815','2013-04-02','16:05:00',2.09),('5815','2013-04-02','16:10:00',1.98),('5815','2013-04-02','16:15:00',1.96),('5815','2013-04-02','16:20:00',1.89),('5815','2013-04-02','16:25:00',1.86),('5815','2013-04-02','16:30:00',1.76),('5815','2013-04-02','16:35:00',1.55),('5815','2013-04-02','16:40:00',1.72),('5815','2013-04-02','16:45:00',1.63),('5815','2013-04-02','16:50:00',1.59),('5815','2013-04-02','16:55:00',1.52),('5815','2013-04-02','17:00:00',1.49),('5815','2013-04-02','17:05:00',1.43),('5815','2013-04-02','17:10:00',1.37),('5815','2013-04-02','17:15:00',1.32),('5815','2013-04-02','17:20:00',1.23),('5815','2013-04-02','17:25:00',1.13),('5815','2013-04-02','17:35:00',1.04),('5815','2013-04-01','08:45:00',1.01),('5815','2013-04-01','09:00:00',1.06),('5815','2013-04-01','09:05:00',1.12),('5815','2013-04-01','09:10:00',1.2),('5815','2013-04-01','09:15:00',1.3),('5815','2013-04-01','09:20:00',1.15),('5815','2013-04-01','09:30:00',1.56),('5815','2013-04-01','09:35:00',1.47),('5815','2013-04-01','09:40:00',1.06),('5815','2013-04-01','09:45:00',1.61),('5815','2013-04-01','09:50:00',1.1),('5815','2013-04-01','09:55:00',1.08),('5815','2013-04-01','10:00:00',1.22),('5815','2013-04-01','10:20:00',1.1),('5815','2013-04-01','10:25:00',1.07),('5815','2013-04-01','10:45:00',1.72),('5815','2013-04-01','10:50:00',2.26),('5815','2013-04-01','10:55:00',1.04),('5815','2013-04-01','11:05:00',1.49),('5815','2013-04-01','11:10:00',1.46),('5815','2013-04-01','12:05:00',1.27),('5815','2013-04-01','12:10:00',1.37),('5815','2013-04-01','12:15:00',1.59),('5815','2013-04-01','12:40:00',1.39),('5815','2013-04-01','12:45:00',1.19),('5815','2013-04-01','12:50:00',1.26),('5815','2013-04-01','12:55:00',1.26),('5815','2013-04-01','13:00:00',1.25),('5815','2013-04-01','13:05:00',1.37),('5815','2013-04-01','13:10:00',1.93),('5815','2013-04-01','13:15:00',1.37),('5815','2013-04-01','13:20:00',1.07),('5815','2013-04-01','13:25:00',1.85),('5815','2013-04-01','13:30:00',1.6),('5815','2013-04-01','13:35:00',1.06),('5815','2013-04-01','13:40:00',1.38),('5815','2013-04-01','13:45:00',1.49),('5815','2013-04-01','13:50:00',1.22),('5815','2013-04-01','14:00:00',1.47),('5815','2013-04-01','14:05:00',1.27),('5815','2013-04-01','14:10:00',1.97),('5815','2013-04-01','14:15:00',1.49),('5815','2013-04-01','14:20:00',2.2),('5815','2013-04-01','14:25:00',2.73),('5815','2013-04-01','14:30:00',2.07),('5815','2013-04-01','14:35:00',1.13),('5815','2013-04-01','14:40:00',1.3),('5815','2013-04-01','14:45:00',1.38),('5815','2013-04-01','14:50:00',1.26),('5815','2014-05-01','08:20:00',1.28),('5815','2014-05-01','09:30:00',1.01),('5815','2014-05-01','09:35:00',1.03),('5815','2014-05-01','10:00:00',1.03),('5815','2014-05-01','10:10:00',1.05),('5815','2014-05-01','13:10:00',1.04),('5815','2014-05-01','13:15:00',1.21),('5815','2014-05-01','13:20:00',1.77),('5815','2014-05-01','13:25:00',1.55),('5815','2014-05-01','13:30:00',1.4),('5815','2014-05-01','13:35:00',1.27),('5815','2014-05-01','13:40:00',1.57),('5815','2014-05-01','13:45:00',1.2),('5815','2014-05-01','14:40:00',1.92),('5815','2014-05-01','14:45:00',1.34),('5815','2014-05-01','14:55:00',1.03),('5815','2014-05-01','15:00:00',1.34),('5815','2014-05-01','15:05:00',1.2),('5815','2014-05-01','15:10:00',1.87),('5815','2014-05-01','15:15:00',2.7),('5815','2014-05-01','15:20:00',1.19),('5815','2014-05-01','15:25:00',1.06),('5815','2014-05-01','15:35:00',1.33),('5815','2014-05-01','15:40:00',2.03),('5815','2014-05-01','16:05:00',1.12),('5815','2014-05-01','16:20:00',1.7),('5815','2013-03-31','09:00:00',1.06),('5815','2013-03-31','09:05:00',1.13),('5815','2013-03-31','09:10:00',1.23),('5815','2013-03-31','09:15:00',1.29),('5815','2013-03-31','09:20:00',1.08),('5815','2013-03-31','09:25:00',1.25),('5815','2013-03-31','09:30:00',1.47),('5815','2013-03-31','09:40:00',1.53),('5815','2013-03-31','09:45:00',1.11),('5815','2013-03-31','09:50:00',1.46),('5815','2013-03-31','09:55:00',1.5),('5815','2013-03-31','10:00:00',1.65),('5815','2013-03-31','10:05:00',1.76),('5815','2013-03-31','10:10:00',1.6),('5815','2013-03-31','10:15:00',1.37),('5815','2013-03-31','10:20:00',1.76),('5815','2013-03-31','10:25:00',1.6),('5815','2013-03-31','10:30:00',1.44),('5815','2013-03-31','10:40:00',1.23),('5815','2013-03-31','10:45:00',2.16),('5815','2013-03-31','10:50:00',1.43),('5815','2013-03-31','11:10:00',1.36),('5815','2013-03-31','11:15:00',1.91),('5815','2013-03-31','11:20:00',1.43),('5815','2013-03-31','11:25:00',1.58),('5815','2013-03-31','11:35:00',1.1),('5815','2013-03-31','11:40:00',1.75),('5815','2013-03-31','11:45:00',1.84),('5815','2013-03-31','11:50:00',1.54),('5815','2013-03-31','11:55:00',1.24),('5815','2013-03-31','12:00:00',1.73),('5815','2013-03-31','12:05:00',1.1),('5815','2013-03-31','12:10:00',1.29),('5815','2013-03-31','12:15:00',1.19),('5815','2013-03-31','12:25:00',1.03),('5815','2013-03-31','12:30:00',1.45),('5815','2013-03-31','12:35:00',1.35),('5815','2013-03-31','12:40:00',1.33),('5815','2013-03-31','12:45:00',1.5),('5815','2013-03-31','12:50:00',1.58),('5815','2013-03-31','12:55:00',1.79),('5815','2013-03-31','13:00:00',1.7),('5815','2013-03-31','13:05:00',1.88),('5815','2013-03-31','13:10:00',1.75),('5815','2013-03-31','13:15:00',1.68),('5815','2013-03-31','13:20:00',1.65),('5815','2013-03-31','13:25:00',1.52),('5815','2013-03-31','13:30:00',1.78),('5815','2013-03-31','13:35:00',1.52),('5815','2013-03-31','13:40:00',1.81),('5815','2013-03-31','13:45:00',2.13),('5815','2013-03-31','13:50:00',2.39),('5815','2013-03-31','13:55:00',2.47),('5815','2013-03-31','14:00:00',1.39),('5815','2013-03-31','14:05:00',1),('5815','2013-03-31','14:10:00',1.28),('5815','2013-03-31','14:15:00',1.46),('5815','2013-03-31','14:20:00',1.48),('5815','2013-03-31','14:25:00',2.47),('5815','2013-03-31','14:30:00',1.8),('5815','2013-03-31','14:35:00',1.31),('5815','2013-03-31','14:40:00',1.16),('5815','2013-03-31','14:45:00',1.11),('5815','2013-03-31','14:50:00',1.2),('5815','2013-03-31','14:55:00',1.31),('5815','2013-03-31','15:00:00',1.13),('5815','2013-03-31','15:05:00',1.11),('5815','2013-03-31','15:10:00',1.13),('5815','2013-03-31','15:15:00',1.23),('5815','2013-03-31','15:20:00',1.28),('5815','2013-03-31','15:25:00',1.31),('5815','2013-03-31','15:30:00',1.15),('5815','2013-03-31','15:35:00',1.48),('5815','2013-03-31','15:40:00',1.38),('5815','2013-03-31','15:45:00',1.39),('5815','2013-03-31','15:50:00',1.65),('5815','2013-03-31','15:55:00',1.29),('5815','2013-03-31','16:00:00',1.13),('5815','2013-03-30','09:20:00',1.22),('5815','2013-03-30','09:25:00',1.6),('5815','2013-03-30','09:30:00',1.33),('5815','2013-03-30','09:35:00',1.25),('5815','2013-03-30','09:45:00',1.6),('5815','2013-03-30','09:55:00',1.07),('5815','2013-03-30','10:00:00',1.47),('5815','2013-03-30','10:20:00',1.14),('5815','2013-03-30','10:25:00',1.62),('5815','2013-03-30','10:30:00',1.42),('5815','2013-03-30','10:35:00',1.53),('5815','2013-03-30','10:50:00',1.09),('5815','2013-03-30','12:35:00',1.57),('5815','2013-03-30','12:40:00',1.88),('5815','2013-03-30','12:45:00',1.02),('5815','2013-03-30','12:55:00',1.08),('5815','2013-03-30','13:00:00',1.35),('5815','2013-03-30','13:05:00',1.15),('5815','2013-03-30','13:10:00',1.46),('5815','2013-03-30','13:15:00',1.72),('5815','2013-03-30','13:20:00',2.2),('5815','2013-03-30','13:25:00',1.92),('5815','2013-03-30','13:45:00',1.07),('5815','2013-03-30','13:50:00',1.1),('5815','2013-03-30','14:00:00',1.14),('5815','2013-03-30','14:05:00',1.98),('5815','2013-03-30','14:10:00',1.37),('5815','2013-03-30','14:15:00',1.65),('5815','2013-03-30','14:20:00',1.04),('5815','2013-03-30','14:30:00',1.28),('5815','2013-03-30','14:35:00',2.37),('5815','2013-03-30','14:40:00',2.53),('5815','2013-03-30','14:45:00',2.36),('5815','2013-03-30','14:50:00',2.28),('5815','2013-03-30','14:55:00',1.53),('5815','2013-03-30','15:00:00',1.75),('5815','2013-03-30','15:05:00',1.2),('5815','2013-03-30','15:10:00',1.81),('5815','2013-03-30','15:15:00',1.51),('5815','2013-03-30','15:20:00',2.26),('5815','2013-03-30','15:25:00',1.93),('5815','2013-03-30','15:30:00',1.73),('5815','2013-03-30','15:35:00',1.51),('5815','2013-03-30','15:40:00',2.31),('5815','2013-03-30','15:45:00',1.72),('5815','2013-03-30','16:00:00',1.34),('5815','2013-03-30','16:15:00',1.23),('5815','2013-03-30','16:20:00',1.01),('5815','2013-03-30','17:05:00',1.49),('5815','2013-03-30','17:10:00',1.08),('5815','2013-03-29','09:05:00',1.11),('5815','2013-03-29','09:20:00',1.95),('5815','2013-03-29','09:25:00',1.53),('5815','2013-03-29','09:35:00',1.03),('5815','2013-03-29','10:10:00',1),('5815','2013-03-29','10:35:00',1.09),('5815','2013-03-29','10:40:00',1.4),('5815','2013-03-29','10:45:00',1.97),('5815','2013-03-29','10:50:00',1.95),('5815','2013-03-29','10:55:00',1.39),('5815','2013-03-29','11:00:00',1.91),('5815','2013-03-29','11:05:00',2.37),('5815','2013-03-29','11:10:00',2.71),('5815','2013-03-29','11:15:00',2.46),('5815','2013-03-29','11:20:00',2.95),('5815','2013-03-29','11:25:00',2.72),('5815','2013-03-29','11:30:00',1.96),('5815','2013-03-29','11:35:00',1.81),('5815','2013-03-29','11:40:00',1.22),('5815','2013-03-29','11:45:00',1.89),('5815','2013-03-29','11:50:00',2.45),('5815','2013-03-29','11:55:00',2.15),('5815','2013-03-29','12:00:00',2.7),('5815','2013-03-29','12:05:00',1.52),('5815','2013-03-29','12:10:00',1.14),('5815','2013-03-29','12:15:00',1.07),('5815','2013-03-29','12:20:00',1.1),('5815','2013-03-29','13:15:00',1.39),('5815','2013-03-29','13:20:00',1.87),('5815','2013-03-29','13:50:00',1.56),('5815','2013-03-29','13:55:00',1.76),('5815','2013-03-29','14:00:00',1.61),('5815','2013-03-29','14:05:00',1.43),('5815','2013-03-29','14:20:00',1.16),('5815','2013-03-29','14:35:00',1.01),('5815','2013-03-28','08:10:00',1.15),('5815','2013-03-28','08:15:00',1.15),('5815','2013-03-28','08:20:00',1.2),('5815','2013-03-28','08:25:00',1.25),('5815','2013-03-28','08:30:00',1.3),('5815','2013-03-28','08:35:00',1.37),('5815','2013-03-28','08:40:00',1.42),('5815','2013-03-28','08:45:00',1.42),('5815','2013-03-28','08:50:00',1.42),('5815','2013-03-28','08:55:00',1.41),('5815','2013-03-28','09:00:00',1.38),('5815','2013-03-28','09:05:00',1.5),('5815','2013-03-28','09:10:00',1.56),('5815','2013-03-28','09:15:00',1.76),('5815','2013-03-28','09:20:00',1.86),('5815','2013-03-28','09:25:00',1.73),('5815','2013-03-28','09:30:00',1.96),('5815','2013-03-28','09:35:00',2),('5815','2013-03-28','09:40:00',1.9),('5815','2013-03-28','09:45:00',1.81),('5815','2013-03-28','09:50:00',1.99),('5815','2013-03-28','09:55:00',1.92),('5815','2013-03-28','10:00:00',1.98),('5815','2013-03-28','10:05:00',1.71),('5815','2013-03-28','10:10:00',1.56),('5815','2013-03-28','10:15:00',1.91),('5815','2013-03-28','10:20:00',1.79),('5815','2013-03-28','10:25:00',1.83),('5815','2013-03-28','10:30:00',1.79),('5815','2013-03-28','10:35:00',1.56),('5815','2013-03-28','10:40:00',1.79),('5815','2013-03-28','10:45:00',1.15),('5815','2013-03-28','10:50:00',1.64),('5815','2013-03-28','10:55:00',1.67),('5815','2013-03-28','11:00:00',2.36),('5815','2013-03-28','11:05:00',2.36),('5815','2013-03-28','11:10:00',2.66),('5815','2013-03-28','11:15:00',1.89),('5815','2013-03-28','11:20:00',1.16),('5815','2013-03-28','11:25:00',1.3),('5815','2013-03-28','11:30:00',2.6),('5815','2013-03-28','11:35:00',1.88),('5815','2013-03-28','11:40:00',2.59),('5815','2013-03-28','11:45:00',2.56),('5815','2013-03-28','11:50:00',2.57),('5815','2013-03-28','11:55:00',2.57),('5815','2013-03-28','12:00:00',2.57),('5815','2013-03-28','12:05:00',2.63),('5815','2013-03-28','12:10:00',2.59),('5815','2013-03-28','12:15:00',2.42),('5815','2013-03-28','12:20:00',2.6),('5815','2013-03-28','12:25:00',2.44),('5815','2013-03-28','12:30:00',2.3),('5815','2013-03-28','12:35:00',2.42),('5815','2013-03-28','12:40:00',2.56),('5815','2013-03-28','12:45:00',2.2),('5815','2013-03-28','12:50:00',2.01),('5815','2013-03-28','12:55:00',1.83),('5815','2013-03-28','13:00:00',2.26),('5815','2013-03-28','13:05:00',1.55),('5815','2013-03-28','13:10:00',2.34),('5815','2013-03-28','13:15:00',2.04),('5815','2013-03-28','13:20:00',2.12),('5815','2013-03-28','13:25:00',2.65),('5815','2013-03-28','13:30:00',2.33),('5815','2013-03-28','13:35:00',2.01),('5815','2013-03-28','13:40:00',2.04),('5815','2013-03-28','13:45:00',1.93),('5815','2013-03-28','13:50:00',2.07),('5815','2013-03-28','13:55:00',2.04),('5815','2013-03-28','14:00:00',2.1),('5815','2013-03-28','14:05:00',1.81),('5815','2013-03-28','14:10:00',1.42),('5815','2013-03-28','14:15:00',1.45),('5815','2013-03-28','14:20:00',1.45),('5815','2013-03-28','14:25:00',1.45),('5815','2013-03-28','14:30:00',1.22),('5815','2013-03-28','14:35:00',1.22),('5815','2013-03-28','14:40:00',1.17),('5815','2013-03-28','14:45:00',1.09),('5815','2013-03-28','14:50:00',1.01),('5815','2013-03-27','09:15:00',1.69),('5815','2013-03-27','11:55:00',1.11),('5815','2013-03-27','12:50:00',1.72),('5815','2013-03-27','12:55:00',2.03),('5815','2013-03-27','13:00:00',1.88),('5815','2013-03-27','13:05:00',2.42),('5815','2013-03-27','13:10:00',1.88),('5815','2013-03-27','13:15:00',2.06),('5815','2013-03-27','13:20:00',2.3),('5815','2013-03-27','13:25:00',2.12),('5815','2013-03-27','13:30:00',2.18),('5815','2013-03-27','13:35:00',1.66),('5815','2013-03-27','13:40:00',1.42),('5815','2013-03-27','13:45:00',1.2),('5815','2013-03-27','13:50:00',1.91),('5815','2013-03-27','14:00:00',1.09),('5815','2013-03-27','14:05:00',1.49),('5815','2013-03-27','14:10:00',1.11),('5815','2013-03-27','14:30:00',1.02),('5815','2013-03-27','15:10:00',1.13),('5815','2013-03-27','15:15:00',1.49),('5815','2013-03-27','15:25:00',1.26),('5815','2013-03-27','15:35:00',1.36),('5815','2013-03-27','15:40:00',1.11),('5815','2013-03-27','15:45:00',1.34),('5815','2013-03-27','15:55:00',1.67),('5815','2013-03-26','08:30:00',1.05),('5815','2013-03-26','08:35:00',1.06),('5815','2013-03-26','09:20:00',1.16),('5815','2013-03-26','09:50:00',1.28),('5815','2013-03-26','09:55:00',1.1),('5815','2013-03-26','10:15:00',1.04),('5815','2013-03-26','10:25:00',1.01),('5815','2013-03-26','10:30:00',1.27),('5815','2013-03-26','10:35:00',1.04),('5815','2013-03-26','10:40:00',1.05),('5815','2013-03-26','10:45:00',1.29),('5815','2013-03-26','10:50:00',1.12),('5815','2013-03-26','10:55:00',1.08),('5815','2013-03-26','11:20:00',1.05),('5815','2013-03-26','11:30:00',1.14),('5815','2013-03-26','11:35:00',1.07),('5815','2013-03-26','11:40:00',1.03),('5815','2013-03-26','11:55:00',1.48),('5815','2013-03-26','12:00:00',1.69),('5815','2013-03-26','12:05:00',1.64),('5815','2013-03-26','12:10:00',1.47),('5815','2013-03-26','12:15:00',1.07),('5815','2013-03-26','12:20:00',1.08),('5815','2013-03-26','12:30:00',1.72),('5815','2013-03-26','12:35:00',2.57),('5815','2013-03-26','12:40:00',2.27),('5815','2013-03-26','12:45:00',2.82),('5815','2013-03-26','12:50:00',1.62),('5815','2013-03-26','12:55:00',1.51),('5815','2013-03-26','13:10:00',1.31),('5815','2013-03-26','13:15:00',1.09),('5815','2013-03-26','13:30:00',1.02),('5815','2013-03-26','13:35:00',1.27),('5815','2013-03-26','13:40:00',1.1),('5815','2013-03-26','13:45:00',1.26),('5815','2013-03-26','13:50:00',1.42),('5815','2013-03-26','13:55:00',1.45),('5815','2013-03-26','14:15:00',1.02),('5815','2013-03-26','14:20:00',1.28),('5815','2013-03-26','14:25:00',1),('5815','2013-03-26','14:40:00',1.23),('5815','2013-03-26','14:45:00',1.27),('5815','2013-03-26','15:10:00',1.01),('5815','2013-03-25','07:55:00',1.21),('5815','2013-03-25','09:55:00',1.38),('5815','2013-03-25','11:10:00',1.44),('5815','2013-03-25','11:15:00',1),('5815','2013-03-25','12:25:00',1.39),('5815','2013-03-25','12:30:00',1.29),('5815','2013-03-25','12:35:00',1.63),('5815','2013-03-25','12:45:00',1.74),('5815','2013-03-25','12:50:00',1.15),('5815','2013-03-25','13:05:00',1.4),('5815','2013-03-25','13:10:00',1.22),('5815','2013-03-25','13:15:00',1.2),('5815','2013-03-25','13:25:00',1.29),('5815','2013-03-25','13:35:00',1.1),('5815','2013-03-25','13:40:00',1.32),('5815','2013-03-25','13:45:00',1.16),('5815','2013-03-24','08:25:00',1),('5815','2013-03-24','09:20:00',1.32),('5815','2013-03-24','09:25:00',1.78),('5815','2013-03-24','09:50:00',1.65),('5815','2013-03-24','09:55:00',2.3),('5815','2013-03-24','10:00:00',1.44),('5815','2013-03-24','10:25:00',1.27),('5815','2013-03-24','10:30:00',1.5),('5815','2013-03-24','10:45:00',1.4),('5815','2013-03-24','10:50:00',1.16),('5815','2013-03-24','10:55:00',1.37),('5815','2013-03-24','11:00:00',1.28),('5815','2013-03-24','11:05:00',1.1),('5815','2013-03-24','11:10:00',1.05),('5815','2013-03-24','11:15:00',1.06),('5815','2013-03-24','11:20:00',2.21),('5815','2013-03-24','11:25:00',2.09),('5815','2013-03-24','11:30:00',1.69),('5815','2013-03-24','11:35:00',1.45),('5815','2013-03-24','11:55:00',1.56),('5815','2013-03-24','12:00:00',2.43),('5815','2013-03-24','12:05:00',2.02),('5815','2013-03-24','12:10:00',2.17),('5815','2013-03-24','12:15:00',2.34),('5815','2013-03-24','12:20:00',1.7),('5815','2013-03-24','12:25:00',2.17),('5815','2013-03-24','12:30:00',2.39),('5815','2013-03-24','12:35:00',1.8),('5815','2013-03-24','12:40:00',1.44),('5815','2013-03-24','12:45:00',1.57),('5815','2013-03-24','12:50:00',1.78),('5815','2013-03-24','12:55:00',1.74),('5815','2013-03-24','13:00:00',1.36),('5815','2013-03-24','13:05:00',2.64),('5815','2013-03-24','13:10:00',2.35),('5815','2013-03-24','13:15:00',2.29),('5815','2013-03-24','13:20:00',2.57),('5815','2013-03-24','13:25:00',1.58),('5815','2013-03-24','13:30:00',1.21),('5815','2013-03-24','13:45:00',1.11),('5815','2013-03-24','13:50:00',1.28),('5815','2013-03-24','13:55:00',1.09),('5815','2013-03-24','14:10:00',1.56),('5815','2013-03-24','14:15:00',1.21),('5815','2013-03-24','14:20:00',1.34),('5815','2013-03-24','14:25:00',1.68),('5815','2013-03-24','14:30:00',2.31),('5815','2013-03-24','14:35:00',1.62),('5815','2013-03-24','14:50:00',1.07),('5815','2013-03-24','14:55:00',1.62),('5815','2013-03-24','15:00:00',1.46),('5815','2013-03-24','15:05:00',1.42),('5815','2013-03-24','15:10:00',1.29),('5815','2013-03-24','15:15:00',1.13),('5815','2013-03-24','15:20:00',1.55),('5815','2013-03-24','15:25:00',2),('5815','2013-03-24','15:30:00',1.36),('5815','2013-03-24','15:35:00',1.73),('5815','2013-03-24','15:40:00',1.12),('5815','2013-03-24','16:00:00',1.13),('5815','2013-03-23','08:10:00',1.02),('5815','2013-03-23','08:15:00',1.09),('5815','2013-03-23','08:20:00',1.15),('5815','2013-03-23','08:25:00',1.2),('5815','2013-03-23','08:30:00',1.25),('5815','2013-03-23','08:35:00',1.3),('5815','2013-03-23','08:40:00',1.35),('5815','2013-03-23','08:45:00',1.39),('5815','2013-03-23','08:50:00',1.42),('5815','2013-03-23','08:55:00',1.46),('5815','2013-03-23','09:00:00',1.5),('5815','2013-03-23','09:05:00',1.56),('5815','2013-03-23','09:10:00',1.6),('5815','2013-03-23','09:15:00',1.65),('5815','2013-03-23','09:20:00',1.7),('5815','2013-03-23','09:25:00',1.73),('5815','2013-03-23','09:30:00',1.77),('5815','2013-03-23','09:35:00',1.79),('5815','2013-03-23','09:40:00',1.83),('5815','2013-03-23','09:45:00',1.86),('5815','2013-03-23','09:50:00',1.91),('5815','2013-03-23','09:55:00',1.93),('5815','2013-03-23','10:00:00',1.97),('5815','2013-03-23','10:05:00',2.01),('5815','2013-03-23','10:10:00',2.04),('5815','2013-03-23','10:15:00',2.07),('5815','2013-03-23','10:20:00',2.1),('5815','2013-03-23','10:25:00',2.11),('5815','2013-03-23','10:30:00',2.15),('5815','2013-03-23','10:35:00',2.15),('5815','2013-03-23','10:40:00',2.15),('5815','2013-03-23','10:45:00',2.17),('5815','2013-03-23','10:50:00',2.18),('5815','2013-03-23','10:55:00',2.2),('5815','2013-03-23','11:00:00',2.22),('5815','2013-03-23','11:05:00',2.25),('5815','2013-03-23','11:10:00',2.26),('5815','2013-03-23','11:15:00',2.26),('5815','2013-03-23','11:20:00',2.26),('5815','2013-03-23','11:25:00',2.27),('5815','2013-03-23','11:30:00',2.3),('5815','2013-03-23','11:35:00',2.3),('5815','2013-03-23','11:40:00',2.3),('5815','2013-03-23','11:45:00',2.32),('5815','2013-03-23','11:50:00',2.33),('5815','2013-03-23','11:55:00',2.3),('5815','2013-03-23','12:00:00',2.36),('5815','2013-03-23','12:05:00',2.37),('5815','2013-03-23','12:10:00',2.39),('5815','2013-03-23','12:15:00',2.42),('5815','2013-03-23','12:20:00',2.46),('5815','2013-03-23','12:25:00',2.49),('5815','2013-03-23','12:30:00',2.48),('5815','2013-03-23','12:35:00',2.49),('5815','2013-03-23','12:40:00',2.49),('5815','2013-03-23','12:45:00',2.48),('5815','2013-03-23','12:50:00',2.48),('5815','2013-03-23','12:55:00',2.46),('5815','2013-03-23','13:00:00',2.45),('5815','2013-03-23','13:05:00',2.46),('5815','2013-03-23','13:10:00',2.42),('5815','2013-03-23','13:15:00',2.44),('5815','2013-03-23','13:20:00',2.43),('5815','2013-03-23','13:25:00',2.39),('5815','2013-03-23','13:30:00',2.37),('5815','2013-03-23','13:35:00',2.36),('5815','2013-03-23','13:40:00',2.34),('5815','2013-03-23','13:45:00',2.32),('5815','2013-03-23','13:50:00',2.31),('5815','2013-03-23','13:55:00',2.29),('5815','2013-03-23','14:00:00',2.27),('5815','2013-03-23','14:05:00',2.24),('5815','2013-03-23','14:10:00',2.19),('5815','2013-03-23','14:15:00',2.17),('5815','2013-03-23','14:20:00',2.14),('5815','2013-03-23','14:25:00',2.09),('5815','2013-03-23','14:30:00',2.05),('5815','2013-03-23','14:35:00',1.97),('5815','2013-03-23','14:40:00',1.93),('5815','2013-03-23','14:45:00',1.93),('5815','2013-03-23','14:50:00',1.85),('5815','2013-03-23','14:55:00',1.82),('5815','2013-03-23','15:00:00',1.77),('5815','2013-03-23','15:05:00',1.73),('5815','2013-03-23','15:10:00',1.63),('5815','2013-03-23','15:15:00',1.77),('5815','2013-03-23','15:20:00',1.7),('5815','2013-03-23','15:25:00',1.62),('5815','2013-03-23','15:30:00',1.46),('5815','2013-03-23','15:35:00',1.43),('5815','2013-03-23','15:40:00',1.42),('5815','2013-03-23','15:45:00',1.23),('5815','2013-03-22','08:05:00',1),('5815','2013-03-22','08:10:00',1.05),('5815','2013-03-22','08:15:00',1.11),('5815','2013-03-22','08:20:00',1.16),('5815','2013-03-22','08:25:00',1.21),('5815','2013-03-22','08:30:00',1.23),('5815','2013-03-22','08:35:00',1.29),('5815','2013-03-22','08:40:00',1.36),('5815','2013-03-22','08:45:00',1.41),('5815','2013-03-22','08:50:00',1.45),('5815','2013-03-22','08:55:00',1.54),('5815','2013-03-22','09:00:00',1.57),('5815','2013-03-22','09:05:00',1.62),('5815','2013-03-22','09:10:00',1.63),('5815','2013-03-22','09:15:00',1.7),('5815','2013-03-22','09:20:00',1.7),('5815','2013-03-22','09:25:00',1.77),('5815','2013-03-22','09:30:00',1.83),('5815','2013-03-22','09:35:00',1.82),('5815','2013-03-22','09:40:00',1.77),('5815','2013-03-22','09:45:00',1.9),('5815','2013-03-22','09:50:00',1.94),('5815','2013-03-22','09:55:00',2.01),('5815','2013-03-22','10:00:00',2.03),('5815','2013-03-22','10:05:00',2.05),('5815','2013-03-22','10:10:00',2.09),('5815','2013-03-22','10:15:00',2.07),('5815','2013-03-22','10:20:00',2.06),('5815','2013-03-22','10:25:00',2.04),('5815','2013-03-22','10:30:00',2.18),('5815','2013-03-22','10:35:00',2.21),('5815','2013-03-22','10:40:00',2.2),('5815','2013-03-22','10:45:00',2.2),('5815','2013-03-22','10:50:00',2.18),('5815','2013-03-22','10:55:00',2.13),('5815','2013-03-22','11:00:00',2.09),('5815','2013-03-22','11:05:00',1.95),('5815','2013-03-22','11:10:00',1.68),('5815','2013-03-22','11:15:00',1.82),('5815','2013-03-22','11:20:00',2.22),('5815','2013-03-22','11:25:00',2.21),('5815','2013-03-22','11:30:00',2.22),('5815','2013-03-22','11:35:00',2.33),('5815','2013-03-22','11:40:00',2.33),('5815','2013-03-22','11:45:00',2.34),('5815','2013-03-22','11:50:00',2.25),('5815','2013-03-22','11:55:00',2.36),('5815','2013-03-22','12:00:00',2.37),('5815','2013-03-22','12:05:00',2.35),('5815','2013-03-22','12:10:00',2.33),('5815','2013-03-22','12:15:00',2.37),('5815','2013-03-22','12:20:00',2.37),('5815','2013-03-22','12:25:00',2.38),('5815','2013-03-22','12:30:00',2.41),('5815','2013-03-22','12:35:00',2.41),('5815','2013-03-22','12:40:00',2.29),('5815','2013-03-22','12:45:00',2.35),('5815','2013-03-22','12:50:00',2.4),('5815','2013-03-22','12:55:00',2.37),('5815','2013-03-22','13:00:00',1.78),('5815','2013-03-22','13:05:00',2.31),('5815','2013-03-22','13:10:00',2.35),('5815','2013-03-22','13:15:00',2.25),('5815','2013-03-22','13:20:00',2.31),('5815','2013-03-22','13:25:00',2.31),('5815','2013-03-22','13:30:00',2.22),('5815','2013-03-22','13:35:00',2.06),('5815','2013-03-22','13:40:00',2.24),('5815','2013-03-22','13:45:00',1.78),('5815','2013-03-22','13:50:00',2.18),('5815','2013-03-22','13:55:00',2.19),('5815','2013-03-22','14:00:00',2.16),('5815','2013-03-22','14:05:00',2.15),('5815','2013-03-22','14:10:00',2.12),('5815','2013-03-22','14:15:00',2.06),('5815','2013-03-22','14:20:00',2.11),('5815','2013-03-22','14:25:00',2.08),('5815','2013-03-22','14:30:00',2.09),('5815','2013-03-22','14:35:00',2.03),('5815','2013-03-22','14:40:00',1.97),('5815','2013-03-22','14:45:00',1.84),('5815','2013-03-22','14:50:00',1.82),('5815','2013-03-22','14:55:00',1.83),('5815','2013-03-22','15:00:00',1.77),('5815','2013-03-22','15:05:00',1.66),('5815','2013-03-22','15:10:00',1.74),('5815','2013-03-22','15:15:00',1.62),('5815','2013-03-22','15:20:00',1.64),('5815','2013-03-22','15:25:00',1.63),('5815','2013-03-22','15:30:00',1.48),('5815','2013-03-22','15:35:00',1.48),('5815','2013-03-22','15:40:00',1.38),('5815','2013-03-22','15:45:00',1.3),('5815','2013-03-22','15:50:00',1.21),('5815','2013-03-22','15:55:00',1.17),('5815','2013-03-22','16:00:00',1.1),('5815','2013-03-22','16:10:00',1.25),('5815','2013-03-22','16:15:00',1.13),('5815','2013-03-21','08:10:00',1.04),('5815','2013-03-21','08:15:00',1.1),('5815','2013-03-21','08:20:00',1.16),('5815','2013-03-21','08:25:00',1.22),('5815','2013-03-21','08:30:00',1.27),('5815','2013-03-21','08:35:00',1.32),('5815','2013-03-21','08:40:00',1.38),('5815','2013-03-21','08:45:00',1.42),('5815','2013-03-21','08:50:00',1.46),('5815','2013-03-21','08:55:00',1.52),('5815','2013-03-21','09:00:00',1.56),('5815','2013-03-21','09:05:00',1.61),('5815','2013-03-21','09:10:00',1.65),('5815','2013-03-21','09:15:00',1.7),('5815','2013-03-21','09:20:00',1.71),('5815','2013-03-21','09:25:00',1.77),('5815','2013-03-21','09:30:00',1.81),('5815','2013-03-21','09:35:00',1.86),('5815','2013-03-21','09:40:00',1.92),('5815','2013-03-21','09:45:00',1.94),('5815','2013-03-21','09:50:00',2),('5815','2013-03-21','09:55:00',2),('5815','2013-03-21','10:00:00',2.05),('5815','2013-03-21','10:05:00',2.02),('5815','2013-03-21','10:10:00',2.09),('5815','2013-03-21','10:15:00',2.12),('5815','2013-03-21','10:20:00',2.11),('5815','2013-03-21','10:25:00',2.17),('5815','2013-03-21','10:30:00',2.24),('5815','2013-03-21','10:35:00',2.28),('5815','2013-03-21','10:40:00',2.33),('5815','2013-03-21','10:45:00',2.35),('5815','2013-03-21','10:50:00',2.37),('5815','2013-03-21','10:55:00',2.38),('5815','2013-03-21','11:00:00',2.37),('5815','2013-03-21','11:05:00',2.39),('5815','2013-03-21','11:10:00',2.42),('5815','2013-03-21','11:15:00',2.43),('5815','2013-03-21','11:20:00',2.44),('5815','2013-03-21','11:25:00',2.45),('5815','2013-03-21','11:30:00',2.47),('5815','2013-03-21','11:35:00',2.51),('5815','2013-03-21','11:40:00',2.49),('5815','2013-03-21','11:45:00',2.55),('5815','2013-03-21','11:50:00',2.53),('5815','2013-03-21','11:55:00',2.55),('5815','2013-03-21','12:00:00',2.56),('5815','2013-03-21','12:05:00',2.57),('5815','2013-03-21','12:10:00',2.56),('5815','2013-03-21','12:15:00',2.56),('5815','2013-03-21','12:20:00',2.55),('5815','2013-03-21','12:25:00',2.54),('5815','2013-03-21','12:30:00',2.55),('5815','2013-03-21','12:35:00',2.57),('5815','2013-03-21','12:40:00',2.59),('5815','2013-03-21','12:45:00',2.57),('5815','2013-03-21','12:50:00',2.49),('5815','2013-03-21','12:55:00',2.33),('5815','2013-03-21','13:00:00',2.57),('5815','2013-03-21','13:05:00',2.48),('5815','2013-03-21','13:10:00',2.56),('5815','2013-03-21','13:15:00',2.54),('5815','2013-03-21','13:20:00',2.5),('5815','2013-03-21','13:25:00',2.41),('5815','2013-03-21','13:30:00',2.36),('5815','2013-03-21','13:35:00',2.42),('5815','2013-03-21','13:40:00',2.04),('5815','2013-03-21','13:45:00',2.12),('5815','2013-03-21','13:50:00',2.46),('5815','2013-03-21','13:55:00',2.41),('5815','2013-03-21','14:00:00',2.36),('5815','2013-03-21','14:05:00',2.34),('5815','2013-03-21','14:10:00',2.31),('5815','2013-03-21','14:15:00',2.3),('5815','2013-03-21','14:20:00',2.26),('5815','2013-03-21','14:25:00',2.21),('5815','2013-03-21','14:30:00',2.19),('5815','2013-03-21','14:35:00',2.15),('5815','2013-03-21','14:40:00',2.1),('5815','2013-03-21','14:45:00',2.08),('5815','2013-03-21','14:50:00',2.06),('5815','2013-03-21','14:55:00',2.02),('5815','2013-03-21','15:00:00',2),('5815','2013-03-21','15:05:00',1.96),('5815','2013-03-21','15:10:00',1.75),('5815','2013-03-21','15:15:00',1.45),('5815','2013-03-21','15:20:00',1.44),('5815','2013-03-21','15:25:00',1.54),('5815','2013-03-21','15:30:00',1.42),('5815','2013-03-21','15:35:00',1.57),('5815','2013-03-21','15:40:00',1.5),('5815','2013-03-21','15:45:00',1.34),('5815','2013-03-21','15:50:00',1.44),('5815','2013-03-21','15:55:00',1.26),('5815','2013-03-21','16:10:00',1.05),('5815','2013-03-21','16:15:00',1.24),('5815','2013-03-20','08:15:00',1.17),('5815','2013-03-20','08:20:00',1.21),('5815','2013-03-20','08:25:00',1.21),('5815','2013-03-20','08:30:00',1.34),('5815','2013-03-20','08:35:00',1.39),('5815','2013-03-20','08:40:00',1.44),('5815','2013-03-20','08:45:00',1.51),('5815','2013-03-20','08:50:00',1.54),('5815','2013-03-20','08:55:00',1.6),('5815','2013-03-20','09:00:00',1.67),('5815','2013-03-20','09:05:00',1.77),('5815','2013-03-20','09:10:00',2),('5815','2013-03-20','09:15:00',1.22),('5815','2013-03-20','09:20:00',1.6),('5815','2013-03-20','09:25:00',1.98),('5815','2013-03-20','09:30:00',1.98),('5815','2013-03-20','09:35:00',1.99),('5815','2013-03-20','09:40:00',2.02),('5815','2013-03-20','09:45:00',2.07),('5815','2013-03-20','09:50:00',1.82),('5815','2013-03-20','09:55:00',2.18),('5815','2013-03-20','10:00:00',2.21),('5815','2013-03-20','10:05:00',2.23),('5815','2013-03-20','10:10:00',2.26),('5815','2013-03-20','10:15:00',2.28),('5815','2013-03-20','10:20:00',2.31),('5815','2013-03-20','10:25:00',2.32),('5815','2013-03-20','10:30:00',2.34),('5815','2013-03-20','10:35:00',2.38),('5815','2013-03-20','10:40:00',2.41),('5815','2013-03-20','10:45:00',2.39),('5815','2013-03-20','10:50:00',2.41),('5815','2013-03-20','10:55:00',1.67),('5815','2013-03-20','11:00:00',2.51),('5815','2013-03-20','11:05:00',2.5),('5815','2013-03-20','11:10:00',2.54),('5815','2013-03-20','11:15:00',2.56),('5815','2013-03-20','11:20:00',2.58),('5815','2013-03-20','11:25:00',2.6),('5815','2013-03-20','11:30:00',2.62),('5815','2013-03-20','11:35:00',2.63),('5815','2013-03-20','11:40:00',2.63),('5815','2013-03-20','11:45:00',2.64),('5815','2013-03-20','11:50:00',2.67),('5815','2013-03-20','11:55:00',2.67),('5815','2013-03-20','12:00:00',2.68),('5815','2013-03-20','12:05:00',2.69),('5815','2013-03-20','12:10:00',2.7),('5815','2013-03-20','12:15:00',2.69),('5815','2013-03-20','12:20:00',2.69),('5815','2013-03-20','12:25:00',2.69),('5815','2013-03-20','12:30:00',2.68),('5815','2013-03-20','12:35:00',2.7),('5815','2013-03-20','12:40:00',2.69),('5815','2013-03-20','12:45:00',2.68),('5815','2013-03-20','12:50:00',2.66),('5815','2013-03-20','12:55:00',2.64),('5815','2013-03-20','13:00:00',2.64),('5815','2013-03-20','13:05:00',2.61),('5815','2013-03-20','13:10:00',2.6),('5815','2013-03-20','13:15:00',2.58),('5815','2013-03-20','13:20:00',2.57),('5815','2013-03-20','13:25:00',2.57),('5815','2013-03-20','13:30:00',2.53),('5815','2013-03-20','13:35:00',2.53),('5815','2013-03-20','13:40:00',2.52),('5815','2013-03-20','13:45:00',2.48),('5815','2013-03-20','13:50:00',2.47),('5815','2013-03-20','13:55:00',2.44),('5815','2013-03-20','14:00:00',2.41),('5815','2013-03-20','14:05:00',2.37),('5815','2013-03-20','14:10:00',2.34),('5815','2013-03-20','14:15:00',2.3),('5815','2013-03-20','14:20:00',2.28),('5815','2013-03-20','14:25:00',2.26),('5815','2013-03-20','14:30:00',2.22),('5815','2013-03-20','14:35:00',2.18),('5815','2013-03-20','14:40:00',2.14),('5815','2013-03-20','14:45:00',2.09),('5815','2013-03-20','14:50:00',2.08),('5815','2013-03-20','14:55:00',2.05),('5815','2013-03-20','15:00:00',1.99),('5815','2013-03-20','15:05:00',1.97),('5815','2013-03-20','15:10:00',1.92),('5815','2013-03-20','15:15:00',1.88),('5815','2013-03-20','15:20:00',1.83),('5815','2013-03-20','15:25:00',1.78),('5815','2013-03-20','15:30:00',1.74),('5815','2013-03-20','15:35:00',1.69),('5815','2013-03-20','15:40:00',1.64),('5815','2013-03-20','15:45:00',1.58),('5815','2013-03-20','15:50:00',1.53),('5815','2013-03-20','15:55:00',1.48),('5815','2013-03-20','16:00:00',1.42),('5815','2013-03-20','16:05:00',1.37),('5815','2013-03-20','16:10:00',1.31),('5815','2013-03-20','16:15:00',1.24),('5815','2013-03-20','16:20:00',1.19),('5815','2013-03-20','16:25:00',1.05),('5815','2013-03-19','08:10:00',1.02),('5815','2013-03-19','08:15:00',1.09),('5815','2013-03-19','08:20:00',1.14),('5815','2013-03-19','08:25:00',1.21),('5815','2013-03-19','08:30:00',1.27),('5815','2013-03-19','08:35:00',1.28),('5815','2013-03-19','08:40:00',1.22),('5815','2013-03-19','08:45:00',1.35),('5815','2013-03-19','08:50:00',1.42),('5815','2013-03-19','08:55:00',1.4),('5815','2013-03-19','09:00:00',1.37),('5815','2013-03-19','09:05:00',1.83),('5815','2013-03-19','09:10:00',1.46),('5815','2013-03-19','09:15:00',1.64),('5815','2013-03-19','09:20:00',1.65),('5815','2013-03-19','09:25:00',1.68),('5815','2013-03-19','09:30:00',1.83),('5815','2013-03-19','09:35:00',1.78),('5815','2013-03-19','09:40:00',1.88),('5815','2013-03-19','09:45:00',1.93),('5815','2013-03-19','09:50:00',1.96),('5815','2013-03-19','09:55:00',1.95),('5815','2013-03-19','10:00:00',2.02),('5815','2013-03-19','10:05:00',2.05),('5815','2013-03-19','10:10:00',1.99),('5815','2013-03-19','10:15:00',1.55),('5815','2013-03-19','10:20:00',1.68),('5815','2013-03-19','10:25:00',1.47),('5815','2013-03-19','10:30:00',1.87),('5815','2013-03-19','10:35:00',2.1),('5815','2013-03-19','10:40:00',1.93),('5815','2013-03-19','10:45:00',1.36),('5815','2013-03-19','10:50:00',1.98),('5815','2013-03-19','10:55:00',1.78),('5815','2013-03-19','11:00:00',1.69),('5815','2013-03-19','11:05:00',1.79),('5815','2013-03-19','11:10:00',1.69),('5815','2013-03-19','11:15:00',1.41),('5815','2013-03-19','11:20:00',1.62),('5815','2013-03-19','11:25:00',1.58),('5815','2013-03-19','11:30:00',1.43),('5815','2013-03-19','11:35:00',1.57),('5815','2013-03-19','11:40:00',1.3),('5815','2013-03-19','11:45:00',1.21),('5815','2013-03-19','11:50:00',1.13),('5815','2013-03-19','11:55:00',1.28),('5815','2013-03-19','12:00:00',1.22),('5815','2013-03-19','12:05:00',1.4),('5815','2013-03-19','12:10:00',1.12),('5815','2013-03-19','13:00:00',1.04),('5815','2013-03-19','13:45:00',1.15),('5815','2013-03-19','14:20:00',1.21),('5815','2013-03-19','14:25:00',1.1),('5815','2013-03-18','08:15:00',1.09),('5815','2013-03-18','08:20:00',1.14),('5815','2013-03-18','08:25:00',1.18),('5815','2013-03-18','08:30:00',1.1),('5815','2013-03-18','08:35:00',1.33),('5815','2013-03-18','08:40:00',1.37),('5815','2013-03-18','08:45:00',1.44),('5815','2013-03-18','08:50:00',1.51),('5815','2013-03-18','08:55:00',1.54),('5815','2013-03-18','09:00:00',1.6),('5815','2013-03-18','09:05:00',1.52),('5815','2013-03-18','09:10:00',1.71),('5815','2013-03-18','09:15:00',1.68),('5815','2013-03-18','09:20:00',1.45),('5815','2013-03-18','09:25:00',1.63),('5815','2013-03-18','09:30:00',1.9),('5815','2013-03-18','09:35:00',1.94),('5815','2013-03-18','09:40:00',2.01),('5815','2013-03-18','09:45:00',2.11),('5815','2013-03-18','09:50:00',2.1),('5815','2013-03-18','09:55:00',1.68),('5815','2013-03-18','10:00:00',2.28),('5815','2013-03-18','10:05:00',1.8),('5815','2013-03-18','10:10:00',2.09),('5815','2013-03-18','10:15:00',2.24),('5815','2013-03-18','10:20:00',2.28),('5815','2013-03-18','10:25:00',2.34),('5815','2013-03-18','10:30:00',2.35),('5815','2013-03-18','10:35:00',2.37),('5815','2013-03-18','10:40:00',2.38),('5815','2013-03-18','10:45:00',2.41),('5815','2013-03-18','10:50:00',2.46),('5815','2013-03-18','10:55:00',2.42),('5815','2013-03-18','11:00:00',2.52),('5815','2013-03-18','11:05:00',2.52),('5815','2013-03-18','11:10:00',2.52),('5815','2013-03-18','11:15:00',2.58),('5815','2013-03-18','11:20:00',2.58),('5815','2013-03-18','11:25:00',2.59),('5815','2013-03-18','11:30:00',2.56),('5815','2013-03-18','11:35:00',1.66),('5815','2013-03-18','11:40:00',2.24),('5815','2013-03-18','11:45:00',2.42),('5815','2013-03-18','11:50:00',2.61),('5815','2013-03-18','11:55:00',2.69),('5815','2013-03-18','12:00:00',2.66),('5815','2013-03-18','12:05:00',2.6),('5815','2013-03-18','12:10:00',2.64),('5815','2013-03-18','12:15:00',2.53),('5815','2013-03-18','12:20:00',2.65),('5815','2013-03-18','12:25:00',2.61),('5815','2013-03-18','12:30:00',2.62),('5815','2013-03-18','12:35:00',2.61),('5815','2013-03-18','12:40:00',2.61),('5815','2013-03-18','12:45:00',2.64),('5815','2013-03-18','12:50:00',2.54),('5815','2013-03-18','12:55:00',2.53),('5815','2013-03-18','13:00:00',2.6),('5815','2013-03-18','13:05:00',2.58),('5815','2013-03-18','13:10:00',2.56),('5815','2013-03-18','13:15:00',2.54),('5815','2013-03-18','13:20:00',2.52),('5815','2013-03-18','13:25:00',2.49),('5815','2013-03-18','13:30:00',2.5),('5815','2013-03-18','13:35:00',2.47),('5815','2013-03-18','13:40:00',2.44),('5815','2013-03-18','13:45:00',2.45),('5815','2013-03-18','13:50:00',2.42),('5815','2013-03-18','13:55:00',2.39),('5815','2013-03-18','14:00:00',2.38),('5815','2013-03-18','14:05:00',2.35),('5815','2013-03-18','14:10:00',2.33),('5815','2013-03-18','14:15:00',2.31),('5815','2013-03-18','14:20:00',2.28),('5815','2013-03-18','14:25:00',2.24),('5815','2013-03-18','14:30:00',2.19),('5815','2013-03-18','14:35:00',2.16),('5815','2013-03-18','14:40:00',2.14),('5815','2013-03-18','14:45:00',2.11),('5815','2013-03-18','14:50:00',2.06),('5815','2013-03-18','14:55:00',2),('5815','2013-03-18','15:00:00',1.97),('5815','2013-03-18','15:05:00',1.94),('5815','2013-03-18','15:10:00',1.89),('5815','2013-03-18','15:15:00',1.85),('5815','2013-03-18','15:20:00',1.82),('5815','2013-03-18','15:25:00',1.78),('5815','2013-03-18','15:30:00',1.72),('5815','2013-03-18','15:35:00',1.69),('5815','2013-03-18','15:40:00',1.64),('5815','2013-03-18','15:45:00',1.58),('5815','2013-03-18','15:50:00',1.53),('5815','2013-03-18','15:55:00',1.48),('5815','2013-03-18','16:00:00',1.41),('5815','2013-03-18','16:05:00',1.36),('5815','2013-03-18','16:10:00',1.29),('5815','2013-03-18','16:15:00',1.23),('5815','2013-03-18','16:20:00',1.17),('5815','2013-03-18','16:25:00',1.05),('5815','2013-03-18','16:30:00',1.04),('5815','2013-03-17','10:25:00',1.14),('5815','2013-03-17','10:30:00',1.1),('5815','2013-03-17','11:20:00',1),('5815','2013-03-17','11:25:00',1.06),('5815','2013-03-17','11:30:00',1.33),('5815','2013-03-17','11:35:00',1.12),('5815','2013-03-17','11:40:00',1.01),('5815','2013-03-17','12:05:00',1.5),('5815','2013-03-17','12:10:00',1.41),('5815','2013-03-17','12:15:00',1.66),('5815','2013-03-17','12:20:00',1.65),('5815','2013-03-17','12:25:00',1.08),('5815','2013-03-17','12:30:00',1.99),('5815','2013-03-17','12:35:00',2.08),('5815','2013-03-17','12:40:00',1.83),('5815','2013-03-17','12:45:00',1.53),('5815','2013-03-17','12:50:00',2.17),('5815','2013-03-17','12:55:00',2.26),('5815','2013-03-17','13:00:00',1.56),('5815','2013-03-17','13:40:00',1.07),('5815','2013-03-17','14:05:00',1.52),('5815','2013-03-17','14:10:00',1.48),('5815','2013-03-16','09:15:00',1.06),('5815','2013-03-16','09:55:00',1.06),('5815','2013-03-16','10:00:00',1.17),('5815','2013-03-16','10:15:00',1.04),('5815','2013-03-16','10:20:00',1.05),('5815','2013-03-16','10:25:00',1.1),('5815','2013-03-16','10:30:00',1.08),('5815','2013-03-16','10:35:00',1.02),('5815','2013-03-16','10:45:00',1.02),('5815','2013-03-16','12:15:00',1.05),('5815','2013-03-16','12:20:00',1.31),('5815','2013-03-16','12:25:00',2.02),('5815','2013-03-16','12:30:00',2.34),('5815','2013-03-16','12:35:00',1.53),('5815','2013-03-16','12:40:00',1.72),('5815','2013-03-16','12:45:00',1.48),('5815','2013-03-16','12:50:00',1.28),('5815','2013-03-16','13:00:00',1.16),('5815','2013-03-16','13:05:00',1.29),('5815','2013-03-16','13:10:00',1.43),('5815','2013-03-16','13:15:00',1.39),('5815','2013-03-16','13:20:00',1.15),('5815','2013-03-16','13:25:00',1.01),('5815','2013-03-16','13:30:00',1.56),('5815','2013-03-16','13:35:00',1.84),('5815','2013-03-16','13:40:00',1.19),('5815','2013-03-16','13:45:00',1.05),('5815','2013-03-16','13:55:00',1.2),('5815','2013-03-16','14:00:00',1.25),('5815','2013-03-16','14:05:00',1.2),('5815','2013-03-16','14:10:00',1.46),('5815','2013-03-16','14:15:00',1.68),('5815','2013-03-16','14:20:00',1.45),('5815','2013-03-16','14:25:00',1.54),('5815','2013-03-16','14:30:00',1.4),('5815','2013-03-16','14:35:00',1.14),('5815','2013-03-16','15:10:00',1.28),('5815','2013-03-16','15:15:00',1.12),('5815','2013-03-16','15:20:00',1.17),('5815','2013-03-16','15:25:00',1.17),('5815','2013-03-16','15:45:00',1.04),('5815','2013-03-15','08:20:00',1.17),('5815','2013-03-15','08:25:00',1.32),('5815','2013-03-15','08:30:00',1.31),('5815','2013-03-15','08:35:00',1.37),('5815','2013-03-15','08:40:00',1.41),('5815','2013-03-15','08:45:00',1.28),('5815','2013-03-15','08:50:00',1.53),('5815','2013-03-15','08:55:00',1.64),('5815','2013-03-15','09:00:00',1.59),('5815','2013-03-15','09:05:00',1.38),('5815','2013-03-15','09:10:00',1.34),('5815','2013-03-15','09:15:00',1.8),('5815','2013-03-15','09:20:00',1.89),('5815','2013-03-15','09:25:00',1.85),('5815','2013-03-15','09:30:00',1.93),('5815','2013-03-15','09:35:00',2.02),('5815','2013-03-15','09:40:00',2.1),('5815','2013-03-15','09:45:00',2.13),('5815','2013-03-15','09:50:00',2.12),('5815','2013-03-15','09:55:00',2.18),('5815','2013-03-15','10:00:00',1.73),('5815','2013-03-15','10:05:00',1.13),('5815','2013-03-15','10:10:00',1.65),('5815','2013-03-15','10:15:00',1.61),('5815','2013-03-15','10:20:00',1.13),('5815','2013-03-15','10:25:00',1.43),('5815','2013-03-15','10:30:00',1.24),('5815','2013-03-15','10:40:00',1.72),('5815','2013-03-15','10:45:00',2.45),('5815','2013-03-15','10:50:00',2.44),('5815','2013-03-15','10:55:00',2.33),('5815','2013-03-15','11:00:00',2.46),('5815','2013-03-15','11:05:00',2.46),('5815','2013-03-15','11:10:00',2.48),('5815','2013-03-15','11:15:00',2.5),('5815','2013-03-15','11:20:00',2.49),('5815','2013-03-15','11:25:00',2.51),('5815','2013-03-15','11:30:00',2.49),('5815','2013-03-15','11:35:00',2.5),('5815','2013-03-15','11:40:00',2.53),('5815','2013-03-15','11:45:00',2.53),('5815','2013-03-15','11:50:00',2.55),('5815','2013-03-15','11:55:00',2.54),('5815','2013-03-15','12:00:00',2.55),('5815','2013-03-15','12:05:00',2.54),('5815','2013-03-15','12:10:00',2.53),('5815','2013-03-15','12:15:00',2.54),('5815','2013-03-15','12:20:00',2.53),('5815','2013-03-15','12:25:00',2.55),('5815','2013-03-15','12:30:00',2.55),('5815','2013-03-15','12:35:00',2.54),('5815','2013-03-15','12:40:00',2.52),('5815','2013-03-15','12:45:00',2.53),('5815','2013-03-15','12:50:00',2.51),('5815','2013-03-15','12:55:00',2.5),('5815','2013-03-15','13:00:00',2.45),('5815','2013-03-15','13:05:00',2.48),('5815','2013-03-15','13:10:00',2.46),('5815','2013-03-15','13:15:00',2.47),('5815','2013-03-15','13:20:00',1.11),('5815','2013-03-15','13:30:00',1.27),('5815','2013-03-15','13:35:00',2.57),('5815','2013-03-15','13:40:00',2.48),('5815','2013-03-15','13:45:00',2.44),('5815','2013-03-15','13:50:00',2.45),('5815','2013-03-15','13:55:00',2.2),('5815','2013-03-15','14:00:00',2.42),('5815','2013-03-15','14:05:00',2.37),('5815','2013-03-15','14:10:00',1.17),('5815','2013-03-15','14:15:00',1.79),('5815','2013-03-15','14:20:00',1.52),('5815','2013-03-15','14:30:00',2.25),('5815','2013-03-15','14:35:00',2.23),('5815','2013-03-15','16:05:00',1.01),('5815','2013-03-15','16:10:00',1),('5815','2013-03-14','11:35:00',1.1),('5815','2013-03-14','11:40:00',1.3),('5815','2013-03-14','11:45:00',1.22),('5815','2013-03-14','11:50:00',1.12),('5815','2013-03-14','11:55:00',1.16),('5815','2013-03-14','12:00:00',1.03),('5815','2013-03-14','12:05:00',1.03),('5815','2013-03-14','12:10:00',1.08),('5815','2013-03-14','12:35:00',1.11),('5815','2013-03-14','12:40:00',1),('5815','2013-03-13','13:50:00',1.12),('5815','2013-03-13','13:55:00',1.36),('5815','2013-03-13','14:00:00',1.09),('5815','2013-03-13','14:05:00',1.14),('5815','2013-03-12','10:15:00',1.29),('5815','2013-03-12','10:25:00',1.04),('5815','2013-03-12','10:30:00',2.16),('5815','2013-03-12','10:35:00',1.48),('5815','2013-03-12','10:40:00',1.62),('5815','2013-03-11','08:25:00',1.02),('5815','2013-03-11','08:30:00',1.12),('5815','2013-03-11','08:35:00',1.1),('5815','2013-03-11','08:40:00',1.2),('5815','2013-03-11','08:45:00',1.4),('5815','2013-03-11','08:50:00',1.01),('5815','2013-03-11','09:05:00',1.55),('5815','2013-03-11','09:10:00',1.59),('5815','2013-03-11','09:15:00',1.62),('5815','2013-03-11','09:20:00',1.66),('5815','2013-03-11','09:25:00',1.71),('5815','2013-03-11','09:30:00',1.77),('5815','2013-03-11','09:35:00',1.82),('5815','2013-03-11','09:40:00',1.81),('5815','2013-03-11','09:45:00',1.91),('5815','2013-03-11','09:50:00',1.29),('5815','2013-03-11','09:55:00',2.11),('5815','2013-03-11','10:00:00',1.97),('5815','2013-03-11','10:05:00',2.14),('5815','2013-03-11','10:10:00',1.7),('5815','2013-03-11','10:15:00',1.64),('5815','2013-03-11','10:20:00',2.05),('5815','2013-03-11','10:25:00',2.08),('5815','2013-03-11','10:30:00',2.34),('5815','2013-03-11','10:35:00',1.44),('5815','2013-03-11','10:40:00',1.8),('5815','2013-03-11','10:45:00',1.16),('5815','2013-03-11','10:50:00',2.14),('5815','2013-03-11','10:55:00',2.19),('5815','2013-03-11','11:00:00',2.15),('5815','2013-03-11','11:05:00',2.68),('5815','2013-03-11','11:10:00',1.94),('5815','2013-03-11','11:15:00',2.11),('5815','2013-03-11','11:20:00',2.53),('5815','2013-03-11','11:25:00',1.19),('5815','2013-03-11','11:40:00',1.21),('5815','2013-03-11','11:45:00',1.29),('5815','2013-03-11','11:50:00',1.55),('5815','2013-03-11','11:55:00',2.28),('5815','2013-03-11','12:10:00',2.24),('5815','2013-03-11','12:15:00',2.59),('5815','2013-03-11','12:20:00',1.02),('5815','2013-03-11','12:25:00',1.93),('5815','2013-03-11','12:30:00',2.74),('5815','2013-03-11','12:35:00',1.93),('5815','2013-03-11','12:40:00',2.36),('5815','2013-03-11','12:55:00',1.13),('5815','2013-03-11','13:00:00',2.09),('5815','2013-03-11','13:05:00',1.41),('5815','2013-03-11','13:10:00',1.51),('5815','2013-03-11','13:15:00',1.39),('5815','2013-03-11','13:20:00',1.99),('5815','2013-03-11','13:25:00',1.27),('5815','2013-03-11','14:00:00',1.21),('5815','2013-03-11','14:05:00',1.56),('5815','2013-03-11','14:10:00',1.67),('5815','2013-03-10','08:20:00',1.01),('5815','2013-03-10','08:25:00',1.07),('5815','2013-03-10','08:30:00',1.13),('5815','2013-03-10','08:35:00',1.2),('5815','2013-03-10','08:40:00',1.25),('5815','2013-03-10','08:45:00',1.3),('5815','2013-03-10','08:50:00',1.36),('5815','2013-03-10','08:55:00',1.41),('5815','2013-03-10','09:00:00',1.44),('5815','2013-03-10','09:05:00',1.51),('5815','2013-03-10','09:10:00',1.51),('5815','2013-03-10','09:15:00',1.61),('5815','2013-03-10','09:20:00',1.38),('5815','2013-03-10','09:25:00',1.22),('5815','2013-03-10','09:35:00',1.48),('5815','2013-03-10','09:40:00',2.01),('5815','2013-03-10','09:45:00',1.78),('5815','2013-03-10','10:40:00',1.18),('5815','2013-03-10','10:45:00',1.43),('5815','2013-03-10','10:50:00',1.68),('5815','2013-03-10','10:55:00',1.01),('5815','2013-03-10','11:30:00',1.38),('5815','2013-03-10','11:35:00',1.62),('5815','2013-03-10','11:40:00',1.22),('5815','2013-03-10','11:45:00',1.49),('5815','2013-03-10','11:50:00',1.51),('5815','2013-03-10','11:55:00',1.11),('5815','2013-03-10','12:00:00',1),('5815','2013-03-10','12:10:00',1.05),('5815','2013-03-10','12:50:00',1.23),('5815','2013-03-10','12:55:00',2.43),('5815','2013-03-10','13:00:00',1.64),('5815','2013-03-10','13:05:00',1.24),('5815','2013-03-10','13:10:00',1.66),('5815','2013-03-10','13:15:00',2.2),('5815','2013-03-10','13:20:00',2.24),('5815','2013-03-10','13:25:00',2.53),('5815','2013-03-10','13:30:00',2.55),('5815','2013-03-10','13:35:00',2.41),('5815','2013-03-10','13:40:00',2.35),('5815','2013-03-10','13:45:00',1.8),('5815','2013-03-10','13:50:00',1.32),('5815','2013-03-10','13:55:00',1.38),('5815','2013-03-10','14:25:00',1.21),('5815','2013-03-10','15:30:00',1.18),('5815','2013-03-10','15:45:00',1.67),('5815','2013-03-10','15:50:00',1.34),('5815','2013-03-10','15:55:00',1.34),('5815','2013-03-10','16:00:00',1.36),('5815','2013-03-10','16:05:00',1.22),('5815','2013-03-09','08:20:00',1.02),('5815','2013-03-09','08:25:00',1.07),('5815','2013-03-09','08:30:00',1.13),('5815','2013-03-09','08:35:00',1.19),('5815','2013-03-09','08:40:00',1.24),('5815','2013-03-09','08:45:00',1.31),('5815','2013-03-09','08:50:00',1.35),('5815','2013-03-09','08:55:00',1.4),('5815','2013-03-09','09:00:00',1.47),('5815','2013-03-09','09:05:00',1.52),('5815','2013-03-09','09:10:00',1.56),('5815','2013-03-09','09:15:00',1.6),('5815','2013-03-09','09:20:00',1.65),('5815','2013-03-09','09:25:00',1.69),('5815','2013-03-09','09:30:00',1.75),('5815','2013-03-09','09:35:00',1.79),('5815','2013-03-09','09:40:00',1.84),('5815','2013-03-09','09:45:00',1.83),('5815','2013-03-09','09:50:00',1.11),('5815','2013-03-09','09:55:00',2.11),('5815','2013-03-09','10:00:00',1.05),('5815','2013-03-09','10:05:00',1.65),('5815','2013-03-09','10:10:00',1.49),('5815','2013-03-09','10:15:00',1.26),('5815','2013-03-09','10:20:00',2.05),('5815','2013-03-09','10:25:00',1.93),('5815','2013-03-09','10:30:00',2.18),('5815','2013-03-09','10:35:00',2.07),('5815','2013-03-09','10:40:00',1.81),('5815','2013-03-09','10:45:00',2.31),('5815','2013-03-09','10:50:00',2.19),('5815','2013-03-09','10:55:00',1.39),('5815','2013-03-09','11:00:00',2.14),('5815','2013-03-09','11:05:00',1.91),('5815','2013-03-09','11:10:00',1.93),('5815','2013-03-09','11:15:00',1.71),('5815','2013-03-09','11:20:00',1.2),('5815','2013-03-09','11:25:00',1.72),('5815','2013-03-09','11:30:00',1.39),('5815','2013-03-09','11:50:00',1.69),('5815','2013-03-09','11:55:00',2.31),('5815','2013-03-09','12:00:00',2.39),('5815','2013-03-09','12:05:00',2.49),('5815','2013-03-09','12:10:00',2.19),('5815','2013-03-09','12:15:00',2.43),('5815','2013-03-09','12:20:00',1.26),('5815','2013-03-09','12:25:00',2.32),('5815','2013-03-09','12:45:00',2.73),('5815','2013-03-09','12:50:00',2.48),('5815','2013-03-09','12:55:00',2.56),('5815','2013-03-09','13:00:00',2.47),('5815','2013-03-09','13:05:00',2.43),('5815','2013-03-09','13:10:00',2.32),('5815','2013-03-09','13:15:00',2.44),('5815','2013-03-09','13:20:00',2.46),('5815','2013-03-09','13:25:00',2.15),('5815','2013-03-09','13:30:00',2.11),('5815','2013-03-09','13:35:00',1.95),('5815','2013-03-09','13:40:00',1.15),('5815','2013-03-09','13:45:00',1.23),('5815','2013-03-09','13:50:00',1.05),('5815','2013-03-09','14:05:00',1.06),('5815','2013-03-09','14:10:00',1.17),('5815','2013-03-09','14:15:00',1.55),('5815','2013-03-09','14:20:00',1.42),('5815','2013-03-09','14:35:00',1.92),('5815','2013-03-09','14:40:00',1.66),('5815','2013-03-08','08:25:00',1.04),('5815','2013-03-08','08:30:00',1.11),('5815','2013-03-08','08:35:00',1.17),('5815','2013-03-08','08:40:00',1.1),('5815','2013-03-08','08:55:00',1.18),('5815','2013-03-08','09:30:00',1.21),('5815','2013-03-08','09:35:00',1.5),('5815','2013-03-08','09:40:00',2),('5815','2013-03-08','09:45:00',2.18),('5815','2013-03-08','09:50:00',1.57),('5815','2013-03-08','09:55:00',1.39),('5815','2013-03-08','10:00:00',1),('5815','2013-03-08','10:20:00',1.16),('5815','2013-03-08','10:45:00',1.21),('5815','2013-03-08','10:50:00',2),('5815','2013-03-08','10:55:00',2.52),('5815','2013-03-08','11:00:00',1.68),('5815','2013-03-08','11:05:00',2.34),('5815','2013-03-08','11:10:00',2.52),('5815','2013-03-08','11:15:00',2.52),('5815','2013-03-08','11:20:00',2.55),('5815','2013-03-08','11:25:00',2.09),('5815','2013-03-08','11:30:00',2.59),('5815','2013-03-08','11:35:00',2.52),('5815','2013-03-08','11:40:00',2.53),('5815','2013-03-08','11:45:00',2.57),('5815','2013-03-08','11:50:00',2.49),('5815','2013-03-08','11:55:00',2.5),('5815','2013-03-08','12:00:00',2.5),('5815','2013-03-08','12:05:00',1.4),('5815','2013-03-08','12:45:00',1.14),('5815','2013-03-08','12:50:00',1.52),('5815','2013-03-08','12:55:00',1.66),('5815','2013-03-08','13:00:00',2.57),('5815','2013-03-08','13:05:00',2.48),('5815','2013-03-08','13:10:00',2.46),('5815','2013-03-08','13:15:00',2.35),('5815','2013-03-08','13:20:00',2.28),('5815','2013-03-08','13:25:00',1.49),('5815','2013-03-08','13:30:00',2.24),('5815','2013-03-08','13:35:00',1.66),('5815','2013-03-08','13:40:00',2.15),('5815','2013-03-08','13:45:00',2.44),('5815','2013-03-08','13:50:00',2.41),('5815','2013-03-08','13:55:00',1.13),('5815','2013-03-08','14:00:00',1.01),('5815','2013-03-08','14:10:00',2.42),('5815','2013-03-08','14:15:00',2),('5815','2013-03-08','14:20:00',2.16),('5815','2013-03-08','14:25:00',2.11),('5815','2013-03-08','14:30:00',2.08),('5815','2013-03-08','14:35:00',2.05),('5815','2013-03-08','14:40:00',2),('5815','2013-03-08','14:45:00',1.98),('5815','2013-03-08','14:50:00',1.93),('5815','2013-03-08','14:55:00',1.88),('5815','2013-03-08','15:00:00',1.86),('5815','2013-03-08','15:05:00',1.82),('5815','2013-03-08','15:10:00',1.78),('5815','2013-03-08','15:15:00',1.75),('5815','2013-03-08','15:20:00',1.7),('5815','2013-03-08','15:25:00',1.64),('5815','2013-03-08','15:30:00',1.59),('5815','2013-03-08','15:35:00',1.55),('5815','2013-03-08','15:40:00',1.52),('5815','2013-03-08','15:45:00',1.48),('5815','2013-03-08','15:50:00',1.42),('5815','2013-03-08','15:55:00',1.33),('5815','2013-03-08','16:00:00',1.19),('5815','2013-03-08','16:05:00',1.18),('5815','2013-03-08','16:15:00',1.07),('5815','2013-03-07','09:35:00',1.22),('5815','2013-03-07','09:45:00',1.41),('5815','2013-03-07','09:50:00',1.49),('5815','2013-03-07','09:55:00',1.25),('5815','2013-03-07','10:10:00',1.2),('5815','2013-03-07','10:15:00',1.1),('5815','2013-03-07','10:20:00',1.34),('5815','2013-03-07','10:35:00',1.23),('5815','2013-03-07','10:40:00',1.06),('5815','2013-03-07','11:40:00',1.24),('5815','2013-03-07','12:00:00',1.28),('5815','2013-03-07','12:40:00',1.16),('5815','2013-03-07','12:45:00',1.33),('5815','2013-03-07','12:50:00',1.33),('5815','2013-03-07','12:55:00',1.13),('5815','2013-03-07','13:00:00',1.24),('5815','2013-03-07','13:05:00',1.24),('5815','2013-03-07','13:30:00',1.02),('5815','2013-03-06','11:40:00',1.05),('5815','2013-03-06','11:45:00',1.38),('5815','2013-03-06','11:50:00',1.18),('5815','2013-03-06','12:45:00',1.15),('5815','2013-03-06','12:50:00',1.01),('5815','2013-03-06','13:20:00',1.19),('5815','2013-03-06','13:25:00',1.07),('5815','2013-03-04','08:30:00',1.21),('5815','2013-03-04','08:35:00',1.1),('5815','2013-03-04','08:40:00',1.12),('5815','2013-03-04','09:45:00',1),('5815','2013-03-04','09:50:00',1.03),('5815','2013-03-04','10:05:00',1.06),('5815','2013-03-04','10:10:00',1.13),('5815','2013-03-04','10:15:00',1.09),('5815','2013-03-04','10:20:00',1.23),('5815','2013-03-04','10:25:00',1.18),('5815','2013-03-04','10:30:00',1.1),('5815','2013-03-04','10:35:00',1.31),('5815','2013-03-04','10:40:00',1.36),('5815','2013-03-04','10:45:00',1.45),('5815','2013-03-04','10:50:00',1.56),('5815','2013-03-04','10:55:00',1.6),('5815','2013-03-04','11:00:00',1.53),('5815','2013-03-04','11:05:00',1.59),('5815','2013-03-04','11:10:00',1.65),('5815','2013-03-04','11:15:00',1.6),('5815','2013-03-04','11:20:00',1.53),('5815','2013-03-04','11:25:00',1.49),('5815','2013-03-04','11:30:00',1.5),('5815','2013-03-04','11:35:00',1.65),('5815','2013-03-04','11:40:00',1.85),('5815','2013-03-04','11:45:00',1.78),('5815','2013-03-04','11:50:00',1.83),('5815','2013-03-04','11:55:00',1.87),('5815','2013-03-04','12:00:00',1.93),('5815','2013-03-04','12:05:00',2.02),('5815','2013-03-04','12:10:00',2.05),('5815','2013-03-04','12:15:00',1.67),('5815','2013-03-04','12:20:00',1.91),('5815','2013-03-04','12:25:00',1.94),('5815','2013-03-04','12:30:00',1.62),('5815','2013-03-04','12:35:00',1.75),('5815','2013-03-04','12:40:00',1.61),('5815','2013-03-04','12:45:00',1.59),('5815','2013-03-04','12:50:00',1.36),('5815','2013-03-04','12:55:00',1.23),('5815','2013-03-04','13:15:00',1.06),('5815','2013-03-04','13:20:00',1.02),('5815','2013-03-03','08:30:00',1.01),('5815','2013-03-03','08:35:00',1.07),('5815','2013-03-03','08:40:00',1.12),('5815','2013-03-03','08:45:00',1.18),('5815','2013-03-03','08:50:00',1.23),('5815','2013-03-03','08:55:00',1.28),('5815','2013-03-03','09:00:00',1.32),('5815','2013-03-03','09:05:00',1.37),('5815','2013-03-03','09:10:00',1.42),('5815','2013-03-03','09:15:00',1.46),('5815','2013-03-03','09:20:00',1.52),('5815','2013-03-03','09:25:00',1.56),('5815','2013-03-03','09:30:00',1.61),('5815','2013-03-03','09:35:00',1.66),('5815','2013-03-03','09:40:00',1.7),('5815','2013-03-03','09:45:00',1.75),('5815','2013-03-03','09:50:00',1.79),('5815','2013-03-03','09:55:00',1.82),('5815','2013-03-03','10:00:00',1.86),('5815','2013-03-03','10:05:00',1.89),('5815','2013-03-03','10:10:00',1.92),('5815','2013-03-03','10:15:00',1.94),('5815','2013-03-03','10:20:00',1.96),('5815','2013-03-03','10:25:00',2.01),('5815','2013-03-03','10:30:00',2.04),('5815','2013-03-03','10:35:00',2.06),('5815','2013-03-03','10:40:00',2.07),('5815','2013-03-03','10:45:00',2.1),('5815','2013-03-03','10:50:00',2.12),('5815','2013-03-03','10:55:00',2.15),('5815','2013-03-03','11:00:00',2.13),('5815','2013-03-03','11:05:00',2.14),('5815','2013-03-03','11:10:00',2.19),('5815','2013-03-03','11:15:00',2.22),('5815','2013-03-03','11:20:00',2.24),('5815','2013-03-03','11:25:00',2.23),('5815','2013-03-03','11:30:00',2.23),('5815','2013-03-03','11:35:00',2.24),('5815','2013-03-03','11:40:00',2.28),('5815','2013-03-03','11:45:00',2.29),('5815','2013-03-03','11:50:00',2.25),('5815','2013-03-03','11:55:00',2.24),('5815','2013-03-03','12:00:00',2.29),('5815','2013-03-03','12:05:00',2.24),('5815','2013-03-03','12:10:00',2.22),('5815','2013-03-03','12:15:00',2.28),('5815','2013-03-03','12:20:00',2.32),('5815','2013-03-03','12:25:00',2.34),('5815','2013-03-03','12:30:00',2.34),('5815','2013-03-03','12:35:00',2.31),('5815','2013-03-03','12:40:00',2.27),('5815','2013-03-03','12:45:00',2.28),('5815','2013-03-03','12:50:00',2.3),('5815','2013-03-03','12:55:00',2.27),('5815','2013-03-03','13:00:00',2.24),('5815','2013-03-03','13:05:00',2.2),('5815','2013-03-03','13:10:00',2.25),('5815','2013-03-03','13:15:00',2.23),('5815','2013-03-03','13:20:00',2.22),('5815','2013-03-03','13:25:00',2.25),('5815','2013-03-03','13:30:00',1.77),('5815','2013-03-03','13:35:00',1.53),('5815','2013-03-03','13:40:00',1.88),('5815','2013-03-03','13:45:00',1.96),('5815','2013-03-03','13:50:00',2.07),('5815','2013-03-03','13:55:00',2.08),('5815','2013-03-03','14:00:00',2.03),('5815','2013-03-03','14:05:00',2.01),('5815','2013-03-03','14:10:00',1.99),('5815','2013-03-03','14:15:00',1.96),('5815','2013-03-03','14:20:00',1.91),('5815','2013-03-03','14:25:00',1.87),('5815','2013-03-03','14:30:00',1.81),('5815','2013-03-03','14:35:00',1.77),('5815','2013-03-03','14:40:00',1.8),('5815','2013-03-03','14:45:00',1.75),('5815','2013-03-03','14:50:00',1.7),('5815','2013-03-03','14:55:00',1.68),('5815','2013-03-03','15:00:00',1.65),('5815','2013-03-03','15:05:00',1.61),('5815','2013-03-03','15:10:00',1.56),('5815','2013-03-03','15:15:00',1.52),('5815','2013-03-03','15:20:00',1.48),('5815','2013-03-03','15:25:00',1.42),('5815','2013-03-03','15:30:00',1.41),('5815','2013-03-03','15:35:00',1.36),('5815','2013-03-03','15:40:00',1.3),('5815','2013-03-03','15:45:00',1.26),('5815','2013-03-03','15:50:00',1.2),('5815','2013-03-03','15:55:00',1.16),('5815','2013-03-03','16:00:00',1.12),('5815','2013-03-03','16:05:00',1.07),('5815','2013-03-03','16:10:00',1.02),('5815','2013-03-02','08:30:00',1.08),('5815','2013-03-02','08:35:00',1.14),('5815','2013-03-02','08:40:00',1.2),('5815','2013-03-02','08:45:00',1.25),('5815','2013-03-02','08:50:00',1.31),('5815','2013-03-02','08:55:00',1.36),('5815','2013-03-02','09:00:00',1.41),('5815','2013-03-02','09:05:00',1.46),('5815','2013-03-02','09:10:00',1.5),('5815','2013-03-02','09:15:00',1.55),('5815','2013-03-02','09:20:00',1.59),('5815','2013-03-02','09:25:00',1.64),('5815','2013-03-02','09:30:00',1.69),('5815','2013-03-02','09:35:00',1.72),('5815','2013-03-02','09:40:00',1.75),('5815','2013-03-02','09:45:00',1.81),('5815','2013-03-02','09:50:00',1.86),('5815','2013-03-02','09:55:00',1.92),('5815','2013-03-02','10:00:00',1.96),('5815','2013-03-02','10:05:00',1.99),('5815','2013-03-02','10:10:00',2.02),('5815','2013-03-02','10:15:00',2.05),('5815','2013-03-02','10:20:00',2.09),('5815','2013-03-02','10:25:00',2.12),('5815','2013-03-02','10:30:00',2.15),('5815','2013-03-02','10:35:00',2.17),('5815','2013-03-02','10:40:00',2.19),('5815','2013-03-02','10:45:00',2.21),('5815','2013-03-02','10:50:00',2.22),('5815','2013-03-02','10:55:00',2.23),('5815','2013-03-02','11:00:00',2.25),('5815','2013-03-02','11:05:00',2.26),('5815','2013-03-02','11:10:00',2.27),('5815','2013-03-02','11:15:00',2.28),('5815','2013-03-02','11:20:00',2.29),('5815','2013-03-02','11:25:00',2.31),('5815','2013-03-02','11:30:00',2.32),('5815','2013-03-02','11:35:00',2.33),('5815','2013-03-02','11:40:00',2.35),('5815','2013-03-02','11:45:00',2.35),('5815','2013-03-02','11:50:00',2.36),('5815','2013-03-02','11:55:00',2.36),('5815','2013-03-02','12:00:00',2.37),('5815','2013-03-02','12:05:00',2.36),('5815','2013-03-02','12:10:00',2.36),('5815','2013-03-02','12:15:00',2.38),('5815','2013-03-02','12:20:00',2.38),('5815','2013-03-02','12:25:00',2.36),('5815','2013-03-02','12:30:00',2.37),('5815','2013-03-02','12:35:00',2.36),('5815','2013-03-02','12:40:00',2.37),('5815','2013-03-02','12:45:00',2.37),('5815','2013-03-02','12:50:00',2.36),('5815','2013-03-02','12:55:00',2.34),('5815','2013-03-02','13:00:00',2.33),('5815','2013-03-02','13:05:00',2.35),('5815','2013-03-02','13:10:00',2.34),('5815','2013-03-02','13:15:00',2.32),('5815','2013-03-02','13:20:00',2.3),('5815','2013-03-02','13:25:00',2.28),('5815','2013-03-02','13:30:00',2.27),('5815','2013-03-02','13:35:00',2.26),('5815','2013-03-02','13:40:00',2.23),('5815','2013-03-02','13:45:00',2.2),('5815','2013-03-02','13:50:00',2.19),('5815','2013-03-02','13:55:00',2.17),('5815','2013-03-02','14:00:00',2.16),('5815','2013-03-02','14:05:00',2.14),('5815','2013-03-02','14:10:00',2.12),('5815','2013-03-02','14:15:00',2.11),('5815','2013-03-02','14:20:00',2.08),('5815','2013-03-02','14:25:00',2.05),('5815','2013-03-02','14:30:00',2.02),('5815','2013-03-02','14:35:00',1.99),('5815','2013-03-02','14:40:00',1.96),('5815','2013-03-02','14:45:00',1.91),('5815','2013-03-02','14:50:00',1.88),('5815','2013-03-02','14:55:00',1.83),('5815','2013-03-02','15:00:00',1.8),('5815','2013-03-02','15:05:00',1.77),('5815','2013-03-02','15:10:00',1.72),('5815','2013-03-02','15:15:00',1.7),('5815','2013-03-02','15:20:00',1.66),('5815','2013-03-02','15:25:00',1.62),('5815','2013-03-02','15:30:00',1.57),('5815','2013-03-02','15:35:00',1.53),('5815','2013-03-02','15:40:00',1.47),('5815','2013-03-02','15:45:00',1.42),('5815','2013-03-02','15:50:00',1.36),('5815','2013-03-02','15:55:00',1.31),('5815','2013-03-02','16:00:00',1.26),('5815','2013-03-02','16:05:00',1.19),('5815','2013-03-02','16:10:00',1.14),('5815','2013-03-02','16:15:00',1.09),('5815','2013-02-28','08:55:00',1.02),('5815','2013-02-28','09:00:00',1.09),('5815','2013-02-28','09:05:00',1.23),('5815','2013-02-28','09:10:00',1.24),('5815','2013-02-28','09:15:00',1.25),('5815','2013-02-28','09:20:00',1.29),('5815','2013-02-28','09:25:00',1.31),('5815','2013-02-28','09:30:00',1.48),('5815','2013-02-28','09:35:00',1.41),('5815','2013-02-28','09:40:00',1.46),('5815','2013-02-28','09:45:00',1.57),('5815','2013-02-28','09:50:00',1.59),('5815','2013-02-28','09:55:00',1.56),('5815','2013-02-28','10:00:00',1.6),('5815','2013-02-28','10:05:00',1.59),('5815','2013-02-28','10:10:00',1.56),('5815','2013-02-28','10:15:00',1.42),('5815','2013-02-28','10:20:00',1.29),('5815','2013-02-28','10:25:00',1.35),('5815','2013-02-28','10:30:00',1.47),('5815','2013-02-28','10:35:00',1.66),('5815','2013-02-28','10:40:00',1.47),('5815','2013-02-28','10:45:00',1.38),('5815','2013-02-28','10:50:00',1.3),('5815','2013-02-28','10:55:00',1.22),('5815','2013-02-28','11:00:00',1.07),('5815','2013-02-28','11:35:00',1.01),('5815','2013-02-27','08:40:00',1.02),('5815','2013-02-27','08:45:00',1.08),('5815','2013-02-27','08:50:00',1.15),('5815','2013-02-27','08:55:00',1.21),('5815','2013-02-27','09:00:00',1.26),('5815','2013-02-27','09:05:00',1.3),('5815','2013-02-27','09:10:00',1.34),('5815','2013-02-27','09:15:00',1.38),('5815','2013-02-27','09:20:00',1.44),('5815','2013-02-27','09:25:00',1.48),('5815','2013-02-27','09:30:00',1.52),('5815','2013-02-27','09:35:00',1.56),('5815','2013-02-27','09:40:00',1.58),('5815','2013-02-27','09:45:00',1.65),('5815','2013-02-27','09:50:00',1.57),('5815','2013-02-27','09:55:00',1.72),('5815','2013-02-27','10:00:00',1.76),('5815','2013-02-27','10:05:00',1.79),('5815','2013-02-27','10:10:00',1.8),('5815','2013-02-27','10:15:00',1.83),('5815','2013-02-27','10:20:00',1.87),('5815','2013-02-27','10:25:00',1.88),('5815','2013-02-27','10:30:00',1.87),('5815','2013-02-27','10:35:00',1.95),('5815','2013-02-27','10:40:00',1.97),('5815','2013-02-27','10:45:00',1.99),('5815','2013-02-27','10:50:00',2.01),('5815','2013-02-27','10:55:00',2.04),('5815','2013-02-27','11:00:00',2.08),('5815','2013-02-27','11:05:00',2.12),('5815','2013-02-27','11:10:00',2.12),('5815','2013-02-27','11:15:00',2.13),('5815','2013-02-27','11:20:00',2.15),('5815','2013-02-27','11:25:00',2.19),('5815','2013-02-27','11:30:00',2.2),('5815','2013-02-27','11:35:00',2.2),('5815','2013-02-27','11:40:00',2.21),('5815','2013-02-27','11:45:00',2.22),('5815','2013-02-27','11:50:00',2.24),('5815','2013-02-27','11:55:00',2.25),('5815','2013-02-27','12:00:00',2.2),('5815','2013-02-27','12:05:00',2.19),('5815','2013-02-27','12:10:00',2.25),('5815','2013-02-27','12:15:00',2.26),('5815','2013-02-27','12:20:00',2.25),('5815','2013-02-27','12:25:00',2.22),('5815','2013-02-27','12:30:00',2.2),('5815','2013-02-27','12:35:00',2.25),('5815','2013-02-27','12:40:00',2.25),('5815','2013-02-27','12:45:00',2.18),('5815','2013-02-27','12:50:00',2.17),('5815','2013-02-27','12:55:00',2.21),('5815','2013-02-27','13:00:00',2.11),('5815','2013-02-27','13:05:00',2.23),('5815','2013-02-27','13:10:00',2.18),('5815','2013-02-27','13:15:00',2.21),('5815','2013-02-27','13:20:00',2.24),('5815','2013-02-27','13:25:00',2.23),('5815','2013-02-27','13:30:00',2.15),('5815','2013-02-27','13:35:00',2.09),('5815','2013-02-27','13:40:00',1.61),('5815','2013-02-27','13:45:00',1.94),('5815','2013-02-27','13:50:00',2.15),('5815','2013-02-27','13:55:00',2.09),('5815','2013-02-27','14:00:00',2.05),('5815','2013-02-27','14:05:00',2.01),('5815','2013-02-27','14:10:00',1.99),('5815','2013-02-27','14:15:00',1.94),('5815','2013-02-27','14:20:00',1.45),('5815','2013-02-27','14:25:00',1.32),('5815','2013-02-27','14:30:00',1.81),('5815','2013-02-27','14:35:00',1.69),('5815','2013-02-27','14:40:00',1.76),('5815','2013-02-27','14:45:00',1.75),('5815','2013-02-27','14:50:00',1.71),('5815','2013-02-27','14:55:00',1.68),('5815','2013-02-27','15:00:00',1.62),('5815','2013-02-27','15:05:00',1.57),('5815','2013-02-27','15:10:00',1.5),('5815','2013-02-27','15:15:00',1.47),('5815','2013-02-27','15:20:00',1.43),('5815','2013-02-27','15:25:00',1.31),('5815','2013-02-27','15:30:00',1.25),('5815','2013-02-27','15:35:00',1.23),('5815','2013-02-27','15:40:00',1.2),('5815','2013-02-27','15:45:00',1.17),('5815','2013-02-27','15:50:00',1.12),('5815','2013-02-27','15:55:00',1.08),('5815','2013-02-27','16:00:00',1.01),('5815','2013-02-26','08:45:00',1.04),('5815','2013-02-26','08:50:00',1.11),('5815','2013-02-26','08:55:00',1.16),('5815','2013-02-26','09:00:00',1.21),('5815','2013-02-26','09:05:00',1.26),('5815','2013-02-26','09:10:00',1.31),('5815','2013-02-26','09:15:00',1.36),('5815','2013-02-26','09:20:00',1.41),('5815','2013-02-26','09:25:00',1.45),('5815','2013-02-26','09:30:00',1.5),('5815','2013-02-26','09:35:00',1.54),('5815','2013-02-26','09:40:00',1.58),('5815','2013-02-26','09:45:00',1.62),('5815','2013-02-26','09:50:00',1.64),('5815','2013-02-26','09:55:00',1.69),('5815','2013-02-26','10:00:00',1.73),('5815','2013-02-26','10:05:00',1.76),('5815','2013-02-26','10:10:00',1.8),('5815','2013-02-26','10:15:00',1.85),('5815','2013-02-26','10:20:00',1.88),('5815','2013-02-26','10:25:00',1.89),('5815','2013-02-26','10:30:00',1.92),('5815','2013-02-26','10:35:00',1.97),('5815','2013-02-26','10:40:00',1.98),('5815','2013-02-26','10:45:00',2),('5815','2013-02-26','10:50:00',2.06),('5815','2013-02-26','10:55:00',2.08),('5815','2013-02-26','11:00:00',2.11),('5815','2013-02-26','11:05:00',2.12),('5815','2013-02-26','11:10:00',2.17),('5815','2013-02-26','11:15:00',2.15),('5815','2013-02-26','11:20:00',2.14),('5815','2013-02-26','11:25:00',2.21),('5815','2013-02-26','11:30:00',1.94),('5815','2013-02-26','11:35:00',1.85),('5815','2013-02-26','11:40:00',1.97),('5815','2013-02-26','11:45:00',2.27),('5815','2013-02-26','11:50:00',2.33),('5815','2013-02-26','11:55:00',2.35),('5815','2013-02-26','12:00:00',2.32),('5815','2013-02-26','12:05:00',2.31),('5815','2013-02-26','12:10:00',2.34),('5815','2013-02-26','12:15:00',2.4),('5815','2013-02-26','12:20:00',2.39),('5815','2013-02-26','12:25:00',2.33),('5815','2013-02-26','12:30:00',2.29),('5815','2013-02-26','12:35:00',2.29),('5815','2013-02-26','12:40:00',2.33),('5815','2013-02-26','12:45:00',2.33),('5815','2013-02-26','12:50:00',2.29),('5815','2013-02-26','12:55:00',2.25),('5815','2013-02-26','13:00:00',2.27),('5815','2013-02-26','13:05:00',2.32),('5815','2013-02-26','13:10:00',2.32),('5815','2013-02-26','13:15:00',2.21),('5815','2013-02-26','13:20:00',1.17),('5815','2013-02-26','13:25:00',1.06),('5815','2013-02-26','13:30:00',1.77),('5815','2013-02-26','13:35:00',2.26),('5815','2013-02-26','13:40:00',2.15),('5815','2013-02-26','13:45:00',2.15),('5815','2013-02-26','13:50:00',1.64),('5815','2013-02-26','13:55:00',1.41),('5815','2013-02-26','14:00:00',1.53),('5815','2013-02-26','14:05:00',1.37),('5815','2013-02-26','14:10:00',1.89),('5815','2013-02-26','14:15:00',1.08),('5815','2013-02-26','14:20:00',1.91),('5815','2013-02-26','14:25:00',1.96),('5815','2013-02-26','14:30:00',1.92),('5815','2013-02-26','14:35:00',1.9),('5815','2013-02-26','14:40:00',1.87),('5815','2013-02-26','14:45:00',1.83),('5815','2013-02-26','14:50:00',1.33),('5815','2013-02-26','14:55:00',1.67),('5815','2013-02-26','15:00:00',1.68),('5815','2013-02-26','15:05:00',1.68),('5815','2013-02-26','15:10:00',1.62),('5815','2013-02-26','15:15:00',1.27),('5815','2013-02-26','15:20:00',1.49),('5815','2013-02-26','15:25:00',1.46),('5815','2013-02-26','15:30:00',1.39),('5815','2013-02-26','15:35:00',1.36),('5815','2013-02-26','15:40:00',1.26),('5815','2013-02-26','15:45:00',1.25),('5815','2013-02-26','15:50:00',1.22),('5815','2013-02-26','15:55:00',1.17),('5815','2013-02-26','16:00:00',1.13),('5815','2013-02-26','16:05:00',1.07),('5815','2013-02-26','16:10:00',1.02),('5815','2013-02-25','09:40:00',1.09),('5815','2013-02-25','09:45:00',1.09),('5815','2013-02-25','09:50:00',1.11),('5815','2013-02-25','09:55:00',1.22),('5815','2013-02-25','10:00:00',1.18),('5815','2013-02-25','10:05:00',1.2),('5815','2013-02-25','10:10:00',1.43),('5815','2013-02-25','10:15:00',1.66),('5815','2013-02-25','10:20:00',1.94),('5815','2013-02-25','10:25:00',2.13),('5815','2013-02-25','10:30:00',2.04),('5815','2013-02-25','10:35:00',1.8),('5815','2013-02-25','10:40:00',1.27),('5815','2013-02-25','10:55:00',1.05),('5815','2013-02-25','11:00:00',1.16),('5815','2013-02-25','11:05:00',1.22),('5815','2013-02-25','11:10:00',1.26),('5815','2013-02-25','11:15:00',1.14),('5815','2013-02-25','11:50:00',1.1),('5815','2013-02-25','11:55:00',1.03),('5815','2013-02-25','12:00:00',1.03),('5815','2013-02-24','10:50:00',1.67),('5815','2013-02-24','10:55:00',2.3),('5815','2013-02-24','11:00:00',2.73),('5815','2013-02-24','11:05:00',1.56),('5815','2013-02-24','11:10:00',1.07),('5815','2013-02-24','11:30:00',1.12),('5815','2013-02-24','11:50:00',1.19),('5815','2013-02-24','11:55:00',2.77),('5815','2013-02-24','12:00:00',1.8),('5815','2013-02-24','12:05:00',1.39),('5815','2013-02-24','12:10:00',1.09),('5815','2013-02-24','12:15:00',1.51),('5815','2013-02-24','12:20:00',2.42),('5815','2013-02-24','12:25:00',2.69),('5815','2013-02-24','12:30:00',2.32),('5815','2013-02-24','12:35:00',1.63),('5815','2013-02-24','12:40:00',2.42),('5815','2013-02-24','12:45:00',2.47),('5815','2013-02-24','12:50:00',2.36),('5815','2013-02-24','12:55:00',2.34),('5815','2013-02-24','13:00:00',2.46),('5815','2013-02-24','13:05:00',1.86),('5815','2013-02-24','13:10:00',2.32),('5815','2013-02-24','13:15:00',1.57),('5815','2013-02-24','13:20:00',1.24),('5815','2013-02-23','14:05:00',1.05),('5815','2013-02-23','14:10:00',1.12),('5815','2013-02-23','15:10:00',1.3),('5815','2013-02-23','15:25:00',1.21),('5815','2013-02-23','15:40:00',1.05),('5815','2013-02-23','16:00:00',1.3),('5815','2013-02-22','08:15:00',1.02),('5815','2013-02-19','08:45:00',1.06),('5815','2013-02-19','08:50:00',1.12),('5815','2013-02-19','08:55:00',1.19),('5815','2013-02-19','09:00:00',1.25),('5815','2013-02-19','09:15:00',1.01),('5815','2013-02-19','09:30:00',1.6),('5815','2013-02-19','09:35:00',1.21),('5815','2013-02-19','09:55:00',1.37),('5815','2013-02-19','10:10:00',1.16),('5815','2013-02-19','10:50:00',1.71),('5815','2013-02-19','10:55:00',2.11),('5815','2013-02-19','11:10:00',2.18),('5815','2013-02-19','11:15:00',2.33),('5815','2013-02-19','11:25:00',2.02),('5815','2013-02-19','11:30:00',1.41),('5815','2013-02-19','11:35:00',1.99),('5815','2013-02-19','11:40:00',2.45),('5815','2013-02-19','11:45:00',2.35),('5815','2013-02-19','11:50:00',2.68),('5815','2013-02-19','11:55:00',1.73),('5815','2013-02-19','12:00:00',2.28),('5815','2013-02-19','12:05:00',1.19),('5815','2013-02-19','12:10:00',1.98),('5815','2013-02-19','12:15:00',1.56),('5815','2013-02-19','12:25:00',1.36),('5815','2013-02-19','12:30:00',2.87),('5815','2013-02-19','12:35:00',2.22),('5815','2013-02-19','12:40:00',1.76),('5815','2013-02-19','13:00:00',1.09),('5815','2013-02-19','13:05:00',2.34),('5815','2013-02-19','13:10:00',1.93),('5815','2013-02-19','13:15:00',2.67),('5815','2013-02-19','13:20:00',1.57),('5815','2013-02-19','13:30:00',1.87),('5815','2013-02-19','15:20:00',1.27),('5815','2013-02-19','15:25:00',1.63),('5815','2013-02-19','15:30:00',1.2),('5815','2013-02-19','16:05:00',1.26),('5815','2013-02-19','16:10:00',1.14),('5815','2013-02-19','16:15:00',1.13),('5815','2013-02-19','16:20:00',1.01),('5815','2013-02-18','08:45:00',1.05),('5815','2013-02-18','08:50:00',1.11),('5815','2013-02-18','08:55:00',1.14),('5815','2013-02-18','09:00:00',1.2),('5815','2013-02-18','09:05:00',1.25),('5815','2013-02-18','09:10:00',1.3),('5815','2013-02-18','09:15:00',1.36),('5815','2013-02-18','09:20:00',1.41),('5815','2013-02-18','09:25:00',1.46),('5815','2013-02-18','09:30:00',1.5),('5815','2013-02-18','09:35:00',1.54),('5815','2013-02-18','09:40:00',1.57),('5815','2013-02-18','09:45:00',1.62),('5815','2013-02-18','09:50:00',1.66),('5815','2013-02-18','09:55:00',1.69),('5815','2013-02-18','10:00:00',1.73),('5815','2013-02-18','10:05:00',1.76),('5815','2013-02-18','10:10:00',1.79),('5815','2013-02-18','10:15:00',1.84),('5815','2013-02-18','10:20:00',1.87),('5815','2013-02-18','10:25:00',1.91),('5815','2013-02-18','10:30:00',1.94),('5815','2013-02-18','10:35:00',1.96),('5815','2013-02-18','10:40:00',1.98),('5815','2013-02-18','10:45:00',2),('5815','2013-02-18','10:50:00',2.03),('5815','2013-02-18','10:55:00',2.03),('5815','2013-02-18','11:00:00',2.07),('5815','2013-02-18','11:05:00',2.11),('5815','2013-02-18','11:10:00',2.11),('5815','2013-02-18','11:15:00',2.15),('5815','2013-02-18','11:20:00',2.17),('5815','2013-02-18','11:25:00',2.19),('5815','2013-02-18','11:30:00',2.18),('5815','2013-02-18','11:35:00',2.21),('5815','2013-02-18','11:40:00',2.17),('5815','2013-02-18','11:45:00',2.22),('5815','2013-02-18','11:50:00',2.25),('5815','2013-02-18','11:55:00',2.24),('5815','2013-02-18','12:00:00',2.24),('5815','2013-02-18','12:05:00',2.26),('5815','2013-02-18','12:10:00',2.24),('5815','2013-02-18','12:15:00',2.23),('5815','2013-02-18','12:20:00',2.23),('5815','2013-02-18','12:25:00',2.24),('5815','2013-02-18','12:30:00',2.24),('5815','2013-02-18','12:35:00',2.23),('5815','2013-02-18','12:40:00',2.24),('5815','2013-02-18','12:45:00',2.23),('5815','2013-02-18','12:50:00',2.25),('5815','2013-02-18','12:55:00',2.25),('5815','2013-02-18','13:00:00',2.23),('5815','2013-02-18','13:05:00',2.22),('5815','2013-02-18','13:10:00',2.19),('5815','2013-02-18','13:15:00',2.17),('5815','2013-02-18','13:20:00',2.13),('5815','2013-02-18','13:25:00',2.19),('5815','2013-02-18','13:30:00',2.18),('5815','2013-02-18','13:35:00',2.17),('5815','2013-02-18','13:40:00',2.14),('5815','2013-02-18','13:45:00',2.13),('5815','2013-02-18','13:50:00',2.11),('5815','2013-02-18','13:55:00',2.05),('5815','2013-02-18','14:00:00',1.99),('5815','2013-02-18','14:05:00',1.97),('5815','2013-02-18','14:10:00',1.98),('5815','2013-02-18','14:15:00',1.97),('5815','2013-02-18','14:20:00',1.87),('5815','2013-02-18','14:25:00',1.82),('5815','2013-02-18','14:30:00',1.83),('5815','2013-02-18','14:35:00',1.77),('5815','2013-02-18','14:40:00',1.76),('5815','2013-02-18','14:45:00',1.73),('5815','2013-02-18','14:50:00',1.74),('5815','2013-02-18','14:55:00',1.68),('5815','2013-02-18','15:00:00',1.64),('5815','2013-02-18','15:05:00',1.59),('5815','2013-02-18','15:10:00',1.57),('5815','2013-02-18','15:15:00',1.53),('5815','2013-02-18','15:20:00',1.48),('5815','2013-02-18','15:25:00',1.43),('5815','2013-02-18','15:30:00',1.37),('5815','2013-02-18','15:35:00',1.3),('5815','2013-02-18','15:40:00',1.26),('5815','2013-02-18','15:45:00',1.21),('5815','2013-02-18','15:50:00',1.16),('5815','2013-02-18','15:55:00',1.12),('5815','2013-02-18','16:00:00',1.06),('5815','2013-02-18','16:05:00',1.01),('5815','2013-02-17','08:50:00',1.01),('5815','2013-02-17','08:55:00',1.08),('5815','2013-02-17','09:00:00',1.12),('5815','2013-02-17','09:05:00',1.19),('5815','2013-02-17','09:10:00',1.24),('5815','2013-02-17','09:15:00',1.27),('5815','2013-02-17','09:20:00',1.44),('5815','2013-02-17','09:25:00',1.53),('5815','2013-02-17','09:30:00',1.47),('5815','2013-02-17','13:15:00',1.1),('5815','2013-02-17','13:25:00',1.18),('5815','2013-02-17','13:30:00',1),('5815','2013-02-16','09:00:00',1.09),('5815','2013-02-16','09:05:00',1.11),('5815','2013-02-16','09:10:00',1.18),('5815','2013-02-16','09:15:00',1.23),('5815','2013-02-16','09:20:00',1.32),('5815','2013-02-16','09:25:00',1.35),('5815','2013-02-16','09:30:00',1.38),('5815','2013-02-16','09:35:00',1.43),('5815','2013-02-16','09:40:00',1.47),('5815','2013-02-16','09:45:00',1.52),('5815','2013-02-16','09:50:00',1.57),('5815','2013-02-16','09:55:00',1.61),('5815','2013-02-16','10:00:00',1.65),('5815','2013-02-16','10:05:00',1.68),('5815','2013-02-16','10:10:00',1.71),('5815','2013-02-16','10:15:00',1.76),('5815','2013-02-16','10:20:00',1.79),('5815','2013-02-16','10:25:00',1.81),('5815','2013-02-16','10:30:00',1.86),('5815','2013-02-16','10:35:00',1.89),('5815','2013-02-16','10:40:00',1.9),('5815','2013-02-16','10:45:00',1.88),('5815','2013-02-16','10:50:00',1.95),('5815','2013-02-16','10:55:00',1.97),('5815','2013-02-16','11:00:00',1.99),('5815','2013-02-16','11:05:00',2.02),('5815','2013-02-16','11:10:00',2.02),('5815','2013-02-16','11:15:00',2.06),('5815','2013-02-16','11:20:00',2.07),('5815','2013-02-16','11:25:00',2.07),('5815','2013-02-16','11:30:00',2.1),('5815','2013-02-16','11:35:00',2.1),('5815','2013-02-16','11:40:00',2.11),('5815','2013-02-16','11:45:00',2.12),('5815','2013-02-16','11:50:00',2.13),('5815','2013-02-16','11:55:00',2.14),('5815','2013-02-16','12:00:00',2.14),('5815','2013-02-16','12:05:00',2.15),('5815','2013-02-16','12:10:00',2.18),('5815','2013-02-16','12:15:00',2.18),('5815','2013-02-16','12:20:00',2.19),('5815','2013-02-16','12:25:00',2.19),('5815','2013-02-16','12:30:00',2.18),('5815','2013-02-16','12:35:00',2.18),('5815','2013-02-16','12:40:00',2.17),('5815','2013-02-16','12:45:00',2.14),('5815','2013-02-16','12:50:00',2.1),('5815','2013-02-16','12:55:00',2.08),('5815','2013-02-16','13:00:00',2.1),('5815','2013-02-16','13:05:00',2.09),('5815','2013-02-16','13:10:00',2.07),('5815','2013-02-16','13:15:00',2.06),('5815','2013-02-16','13:20:00',2.01),('5815','2013-02-16','13:25:00',2.01),('5815','2013-02-16','13:30:00',2.01),('5815','2013-02-16','13:35:00',2),('5815','2013-02-16','13:40:00',1.96),('5815','2013-02-16','13:45:00',1.92),('5815','2013-02-16','13:50:00',1.82),('5815','2013-02-16','13:55:00',1.83),('5815','2013-02-16','14:10:00',1.74),('5815','2013-02-16','14:15:00',1.84),('5815','2013-02-16','14:30:00',1.75),('5815','2013-02-16','14:35:00',1.49),('5815','2013-02-16','14:40:00',1.06),('5815','2013-02-16','15:10:00',1.67),('5815','2013-02-16','15:15:00',1.66),('5815','2013-02-16','15:20:00',1.63),('5815','2013-02-16','15:25:00',1.57),('5815','2013-02-16','15:30:00',1.24),('5815','2013-02-16','15:35:00',1.36),('5815','2013-02-16','15:40:00',1.39),('5815','2013-02-16','15:45:00',1.31),('5815','2013-02-16','15:50:00',1.24),('5815','2013-02-16','15:55:00',1.19),('5815','2013-02-16','16:00:00',1.12),('5815','2013-02-16','16:05:00',1.04),('5815','2013-02-15','09:15:00',1.32),('5815','2013-02-15','09:20:00',1.38),('5815','2013-02-15','09:25:00',1.41),('5815','2013-02-15','09:30:00',1.45),('5815','2013-02-15','09:35:00',1.49),('5815','2013-02-15','09:40:00',1.52),('5815','2013-02-15','09:45:00',1.56),('5815','2013-02-15','09:50:00',1.62),('5815','2013-02-15','09:55:00',1.64),('5815','2013-02-15','10:00:00',1.66),('5815','2013-02-15','10:05:00',1.71),('5815','2013-02-15','10:10:00',1.76),('5815','2013-02-15','10:15:00',1.78),('5815','2013-02-15','10:20:00',1.83),('5815','2013-02-15','10:25:00',1.84),('5815','2013-02-15','10:30:00',1.89),('5815','2013-02-15','10:35:00',1.94),('5815','2013-02-15','10:40:00',2.02),('5815','2013-02-15','10:45:00',2.05),('5815','2013-02-15','10:50:00',2.05),('5815','2013-02-15','10:55:00',2.06),('5815','2013-02-15','11:00:00',2.07),('5815','2013-02-15','11:05:00',2.01),('5815','2013-02-15','11:10:00',2.14),('5815','2013-02-15','11:15:00',2.15),('5815','2013-02-15','11:20:00',2.05),('5815','2013-02-15','11:25:00',2.12),('5815','2013-02-15','11:30:00',2.17),('5815','2013-02-15','11:35:00',2.19),('5815','2013-02-15','11:40:00',2.19),('5815','2013-02-15','11:45:00',2.22),('5815','2013-02-15','11:50:00',2.24),('5815','2013-02-15','11:55:00',2.25),('5815','2013-02-15','12:00:00',2.22),('5815','2013-02-15','12:05:00',2.23),('5815','2013-02-15','12:10:00',2.24),('5815','2013-02-15','12:15:00',2.23),('5815','2013-02-15','12:20:00',2.24),('5815','2013-02-15','12:25:00',2.23),('5815','2013-02-15','12:30:00',2.23),('5815','2013-02-15','12:35:00',2.23),('5815','2013-02-15','12:40:00',2.24),('5815','2013-02-15','12:45:00',2.25),('5815','2013-02-15','12:50:00',2.27),('5815','2013-02-15','12:55:00',2.26),('5815','2013-02-15','13:00:00',2.23),('5815','2013-02-15','13:05:00',2.22),('5815','2013-02-15','13:10:00',2.2),('5815','2013-02-15','13:15:00',2.19),('5815','2013-02-15','13:20:00',2.17),('5815','2013-02-15','13:25:00',2.15),('5815','2013-02-15','13:30:00',2.14),('5815','2013-02-15','13:35:00',2.13),('5815','2013-02-15','13:40:00',2.14),('5815','2013-02-15','13:45:00',2.12),('5815','2013-02-15','13:50:00',2.11),('5815','2013-02-15','13:55:00',2.09),('5815','2013-02-15','14:00:00',2.04),('5815','2013-02-15','14:05:00',2.03),('5815','2013-02-15','14:10:00',2.01),('5815','2013-02-15','14:15:00',1.99),('5815','2013-02-15','14:20:00',1.74),('5815','2013-02-15','14:25:00',1.14),('5815','2013-02-15','15:30:00',1.39),('5815','2013-02-15','15:35:00',1.37),('5815','2013-02-15','15:40:00',1.37),('5815','2013-02-15','15:45:00',1.51),('5815','2013-02-15','15:50:00',1.42),('5815','2013-02-14','10:05:00',1.08),('5815','2013-02-14','10:25:00',1.43),('5815','2013-02-14','10:30:00',1.1),('5815','2013-02-14','10:35:00',1.72),('5815','2013-02-14','10:44:00',1.82),('5815','2013-02-14','10:45:00',1.92),('5815','2013-02-14','10:50:00',1.99),('5815','2013-02-14','10:55:00',1.2),('5815','2013-02-14','11:00:00',1.08),('5815','2013-02-14','11:05:00',1.14),('5815','2013-02-14','11:10:00',1.33),('5815','2013-02-14','11:15:00',1.61),('5815','2013-02-14','11:20:00',2.18),('5815','2013-02-14','11:25:00',2.22),('5815','2013-02-14','11:30:00',2.21),('5815','2013-02-14','11:35:00',1.85),('5815','2013-02-14','11:40:00',1.28),('5815','2013-02-14','11:45:00',1.3),('5815','2013-02-14','11:50:00',2.27),('5815','2013-02-14','11:55:00',2.19),('5815','2013-02-14','12:00:00',1.81),('5815','2013-02-14','12:05:00',1.78),('5815','2013-02-14','12:10:00',1.91),('5815','2013-02-14','12:15:00',1.83),('5815','2013-02-14','12:20:00',2.46),('5815','2013-02-14','12:25:00',2.12),('5815','2013-02-14','12:31:00',2.13),('5815','2013-02-14','12:35:00',2.26),('5815','2013-02-14','12:40:00',2.23),('5815','2013-02-14','12:45:00',2.25),('5815','2013-02-14','12:50:00',2.25),('5815','2013-02-14','12:55:00',2.26),('5815','2013-02-14','13:00:00',2.24),('5815','2013-02-14','13:05:00',2.25),('5815','2013-02-14','13:10:00',2.26),('5815','2013-02-14','13:15:00',2.23),('5815','2013-02-14','13:20:00',2.04),('5815','2013-02-14','13:25:00',1.84),('5815','2013-02-14','13:30:00',1.55),('5815','2013-02-14','13:35:00',1.68),('5815','2013-02-14','13:40:00',2.17),('5815','2013-02-14','13:45:00',1.74),('5815','2013-02-14','13:50:00',1.82),('5815','2013-02-14','13:55:00',2.05),('5815','2013-02-14','14:00:00',1.42),('5815','2013-02-14','14:05:00',1.78),('5815','2013-02-14','14:10:00',2.39),('5815','2013-02-14','14:15:00',1.52),('5815','2013-02-14','14:20:00',1.76),('5815','2013-02-14','14:25:00',1.29),('5815','2013-02-14','14:32:00',1.38),('5815','2013-02-14','14:35:00',1.98),('5815','2013-02-14','14:40:00',1.85),('5815','2013-02-14','14:45:00',1.6),('5815','2013-02-14','15:00:00',1.13),('5815','2013-02-14','15:15:00',1.16),('5815','2013-02-14','15:25:00',1.11),('5815','2013-02-14','15:30:00',1.29),('5815','2013-02-13','08:45:00',1.03),('5815','2013-02-13','08:50:00',1.09),('5815','2013-02-13','08:55:00',1.14),('5815','2013-02-13','09:00:00',1.2),('5815','2013-02-13','09:05:00',1.25),('5815','2013-02-13','09:10:00',1.3),('5815','2013-02-13','09:15:00',1.35),('5815','2013-02-13','09:20:00',1.41),('5815','2013-02-13','09:25:00',1.46),('5815','2013-02-13','09:30:00',1.51),('5815','2013-02-13','09:35:00',1.55),('5815','2013-02-13','09:40:00',1.6),('5815','2013-02-13','09:45:00',1.64),('5815','2013-02-13','09:50:00',1.67),('5815','2013-02-13','09:55:00',1.73),('5815','2013-02-13','10:00:00',1.77),('5815','2013-02-13','10:05:00',1.81),('5815','2013-02-13','10:10:00',1.85),('5815','2013-02-13','10:15:00',1.88),('5815','2013-02-13','10:20:00',1.92),('5815','2013-02-13','10:25:00',1.95),('5815','2013-02-13','10:30:00',1.98),('5815','2013-02-13','10:35:00',2),('5815','2013-02-13','10:40:00',2.03),('5815','2013-02-13','10:45:00',2.06),('5815','2013-02-13','10:50:00',2.09),('5815','2013-02-13','10:55:00',2.12),('5815','2013-02-13','11:00:00',2.14),('5815','2013-02-13','11:05:00',2.15),('5815','2013-02-13','11:10:00',2.17),('5815','2013-02-13','11:15:00',2.19),('5815','2013-02-13','11:20:00',2.2),('5815','2013-02-13','11:25:00',2.22),('5815','2013-02-13','11:30:00',2.23),('5815','2013-02-13','11:35:00',2.24),('5815','2013-02-13','11:40:00',2.24),('5815','2013-02-13','11:45:00',2.26),('5815','2013-02-13','11:50:00',2.27),('5815','2013-02-13','11:55:00',2.29),('5815','2013-02-13','12:00:00',2.29),('5815','2013-02-13','12:05:00',2.3),('5815','2013-02-13','12:10:00',2.29),('5815','2013-02-13','12:15:00',2.29),('5815','2013-02-13','12:20:00',2.29),('5815','2013-02-13','12:25:00',2.3),('5815','2013-02-13','12:30:00',2.29),('5815','2013-02-13','12:35:00',2.27),('5815','2013-02-13','12:40:00',2.29),('5815','2013-02-13','12:45:00',2.27),('5815','2013-02-13','12:50:00',2.26),('5815','2013-02-13','12:55:00',2.26),('5815','2013-02-13','13:00:00',2.25),('5815','2013-02-13','13:05:00',2.24),('5815','2013-02-13','13:10:00',2.24),('5815','2013-02-13','13:15:00',2.23),('5815','2013-02-13','13:20:00',2.21),('5815','2013-02-13','13:25:00',2.18),('5815','2013-02-13','13:30:00',2.16),('5815','2013-02-13','13:35:00',2.16),('5815','2013-02-13','13:40:00',2.15),('5815','2013-02-13','13:45:00',2.13),('5815','2013-02-13','13:50:00',2.11),('5815','2013-02-13','13:55:00',2.08),('5815','2013-02-13','14:00:00',2.05),('5815','2013-02-13','14:05:00',2),('5815','2013-02-13','14:10:00',2),('5815','2013-02-13','14:15:00',1.97),('5815','2013-02-13','14:20:00',1.95),('5815','2013-02-13','14:25:00',1.91),('5815','2013-02-13','14:30:00',1.88),('5815','2013-02-13','14:35:00',1.85),('5815','2013-02-13','14:40:00',1.83),('5815','2013-02-13','14:45:00',1.83),('5815','2013-02-13','14:50:00',1.77),('5815','2013-02-13','14:55:00',1.7),('5815','2013-02-13','15:00:00',1.65),('5815','2013-02-13','15:05:00',1.61),('5815','2013-02-13','15:10:00',1.56),('5815','2013-02-13','15:15:00',1.52),('5815','2013-02-13','15:20:00',1.46),('5815','2013-02-13','15:25:00',1.42),('5815','2013-02-13','15:30:00',1.38),('5815','2013-02-13','15:35:00',1.31),('5815','2013-02-13','15:40:00',1.26),('5815','2013-02-13','15:45:00',1.22),('5815','2013-02-13','15:50:00',1.17),('5815','2013-02-13','15:55:00',1.12),('5815','2013-02-13','16:00:00',1.05),('5815','2013-02-12','09:35:00',1.03),('5815','2013-02-12','09:40:00',1.39),('5815','2013-02-12','09:45:00',1.56),('5815','2013-02-12','09:50:00',1.54),('5815','2013-02-12','09:55:00',1.57),('5815','2013-02-12','10:00:00',1.42),('5815','2013-02-12','10:05:00',1.59),('5815','2013-02-12','10:10:00',1.69),('5815','2013-02-12','10:15:00',1.79),('5815','2013-02-12','10:20:00',1.82),('5815','2013-02-12','10:25:00',1.91),('5815','2013-02-12','10:30:00',1.96),('5815','2013-02-12','10:35:00',1.95),('5815','2013-02-12','10:40:00',2.03),('5815','2013-02-12','10:45:00',2.14),('5815','2013-02-12','10:50:00',2.15),('5815','2013-02-12','10:55:00',2.12),('5815','2013-02-12','11:00:00',2.12),('5815','2013-02-12','11:05:00',2.03),('5815','2013-02-12','11:10:00',2.08),('5815','2013-02-12','11:15:00',2.1),('5815','2013-02-12','11:20:00',2.07),('5815','2013-02-12','11:25:00',1.78),('5815','2013-02-12','11:30:00',1.55),('5815','2013-02-12','11:35:00',1.29),('5815','2013-02-12','11:50:00',1.07),('5815','2013-02-12','12:15:00',1.66),('5815','2013-02-12','12:20:00',1.04),('5815','2013-02-12','12:25:00',1.35),('5815','2013-02-12','12:50:00',1.29),('5815','2013-02-12','12:55:00',1.42),('5815','2013-02-12','13:00:00',1.59),('5815','2013-02-12','13:05:00',1.73),('5815','2013-02-12','13:10:00',1.51),('5815','2013-02-12','13:15:00',1.19),('5815','2013-02-12','13:20:00',2.17),('5815','2013-02-12','13:25:00',2.24),('5815','2013-02-12','13:30:00',2.33),('5815','2013-02-12','13:35:00',2.24),('5815','2013-02-12','13:40:00',2.07),('5815','2013-02-12','13:45:00',1.91),('5815','2013-02-12','13:50:00',1.65),('5815','2013-02-12','13:55:00',1.72),('5815','2013-02-12','14:00:00',2.06),('5815','2013-02-12','14:05:00',2.1),('5815','2013-02-12','14:10:00',1.69),('5815','2013-02-12','14:15:00',1.85),('5815','2013-02-12','14:20:00',1.63),('5815','2013-02-12','14:25:00',1.76),('5815','2013-02-12','14:30:00',1.83),('5815','2013-02-12','14:35:00',1.91),('5815','2013-02-12','14:40:00',1.86),('5815','2013-02-12','14:45:00',1.79),('5815','2013-02-12','14:50:00',1.77),('5815','2013-02-12','14:55:00',1.72),('5815','2013-02-12','15:00:00',1.66),('5815','2013-02-12','15:05:00',1.61),('5815','2013-02-12','15:10:00',1.57),('5815','2013-02-12','15:15:00',1.52),('5815','2013-02-12','15:20:00',1.47),('5815','2013-02-12','15:25:00',1.45),('5815','2013-02-12','15:30:00',1.41),('5815','2013-02-12','15:35:00',1.36),('5815','2013-02-12','15:40:00',1.33),('5815','2013-02-12','15:45:00',1.27),('5815','2013-02-12','15:50:00',1.19),('5815','2013-02-12','15:55:00',1.14),('5815','2013-02-12','16:00:00',1.09),('5815','2013-02-12','16:05:00',1.01),('5815','2013-02-10','14:30:00',1.18),('5815','2013-02-09','10:00:00',1.56),('5815','2013-02-09','10:05:00',1.82),('5815','2013-02-09','10:10:00',1.78),('5815','2013-02-09','10:15:00',1.85),('5815','2013-02-09','10:20:00',1.88),('5815','2013-02-09','10:25:00',1.92),('5815','2013-02-09','10:30:00',1.95),('5815','2013-02-09','10:35:00',1.97),('5815','2013-02-09','10:40:00',1.99),('5815','2013-02-09','10:45:00',2.02),('5815','2013-02-09','10:50:00',2.05),('5815','2013-02-09','10:55:00',2.07),('5815','2013-02-09','11:00:00',2.1),('5815','2013-02-09','11:05:00',2.11),('5815','2013-02-09','11:10:00',2.12),('5815','2013-02-09','11:15:00',2.13),('5815','2013-02-09','11:20:00',2.14),('5815','2013-02-09','11:25:00',2.15),('5815','2013-02-09','11:30:00',2.18),('5815','2013-02-09','11:35:00',2.19),('5815','2013-02-09','11:40:00',2.21),('5815','2013-02-09','11:45:00',2.22),('5815','2013-02-09','11:50:00',2.24),('5815','2013-02-09','11:55:00',2.26),('5815','2013-02-09','12:00:00',2.28),('5815','2013-02-09','12:05:00',2.25),('5815','2013-02-09','12:10:00',2.3),('5815','2013-02-09','12:15:00',2.3),('5815','2013-02-09','12:20:00',2.29),('5815','2013-02-09','12:25:00',2.29),('5815','2013-02-09','12:30:00',2.29),('5815','2013-02-09','12:35:00',2.28),('5815','2013-02-09','12:40:00',2.27),('5815','2013-02-09','12:45:00',2.27),('5815','2013-02-09','12:50:00',2.29),('5815','2013-02-09','12:55:00',2.27),('5815','2013-02-09','13:00:00',2.23),('5815','2013-02-09','13:05:00',2.2),('5815','2013-02-09','13:10:00',2.2),('5815','2013-02-09','13:15:00',2.18),('5815','2013-02-09','13:20:00',2.18),('5815','2013-02-09','13:25:00',2.17),('5815','2013-02-09','13:30:00',2.15),('5815','2013-02-09','13:35:00',2.1),('5815','2013-02-09','13:40:00',2.07),('5815','2013-02-09','13:45:00',2.05),('5815','2013-02-09','13:50:00',2.04),('5815','2013-02-09','13:55:00',2.01),('5815','2013-02-09','14:00:00',1.97),('5815','2013-02-09','14:05:00',1.96),('5815','2013-02-09','14:10:00',1.92),('5815','2013-02-09','14:15:00',1.91),('5815','2013-02-09','14:20:00',1.87),('5815','2013-02-09','14:25:00',1.8),('5815','2013-02-09','14:30:00',1.8),('5815','2013-02-09','14:35:00',1.8),('5815','2013-02-09','14:40:00',1.37),('5815','2013-02-09','14:45:00',1.77),('5815','2013-02-09','14:50:00',1.67),('5815','2013-02-09','14:55:00',1.62),('5815','2013-02-09','15:00:00',1.12),('5815','2013-02-09','15:10:00',1.52),('5815','2013-02-09','15:25:00',1.31),('5815','2013-02-09','15:35:00',1.18),('5815','2013-02-08','13:15:00',1.1),('5815','2013-02-08','13:20:00',1.23),('5815','2013-02-08','13:25:00',1.33),('5815','2013-02-08','13:30:00',1.61),('5815','2013-02-08','13:35:00',1.6),('5815','2013-02-08','13:40:00',1.71),('5815','2013-02-08','13:45:00',1.88),('5815','2013-02-08','13:50:00',2.04),('5815','2013-02-08','13:55:00',1.97),('5815','2013-02-08','14:00:00',2.04),('5815','2013-02-08','14:05:00',1.9),('5815','2013-02-08','14:10:00',1.4),('5815','2013-02-08','14:15:00',1.87),('5815','2013-02-08','14:20:00',2.09),('5815','2013-02-08','14:25:00',2.22),('5815','2013-02-08','14:30:00',2.04),('5815','2013-02-08','14:35:00',1.91),('5815','2013-02-08','14:40:00',1.79),('5815','2013-02-08','14:45:00',1.7),('5815','2013-02-08','14:50:00',1.66),('5815','2013-02-08','14:55:00',1.67),('5815','2013-02-08','15:00:00',1.59),('5815','2013-02-08','15:05:00',1.52),('5815','2013-02-08','15:10:00',1.49),('5815','2013-02-08','15:15:00',1.42),('5815','2013-02-08','15:20:00',1.37),('5815','2013-02-08','15:25:00',1.25),('5815','2013-02-08','15:30:00',1.22),('5815','2013-02-08','15:35:00',1.18),('5815','2013-02-08','15:50:00',1.02),('5815','2013-02-07','09:35:00',1.32),('5815','2013-02-07','09:40:00',1.66),('5815','2013-02-07','09:45:00',1.57),('5815','2013-02-07','09:50:00',1.86),('5815','2013-02-07','09:55:00',1.9),('5815','2013-02-07','10:00:00',1.98),('5815','2013-02-07','10:05:00',2.1),('5815','2013-02-07','10:10:00',2.15),('5815','2013-02-07','10:15:00',2.25),('5815','2013-02-07','10:20:00',2.2),('5815','2013-02-07','10:25:00',2.17),('5815','2013-02-07','10:30:00',2.25),('5815','2013-02-07','10:35:00',1.09),('5815','2013-02-07','10:40:00',1.59),('5815','2013-02-07','10:45:00',2.25),('5815','2013-02-07','10:50:00',2.28),('5815','2013-02-07','10:55:00',2.23),('5815','2013-02-07','11:00:00',2.16),('5815','2013-02-07','11:05:00',2.17),('5815','2013-02-07','11:10:00',2.17),('5815','2013-02-07','11:15:00',2.17),('5815','2013-02-07','11:20:00',2.18),('5815','2013-02-07','11:25:00',2.19),('5815','2013-02-07','11:30:00',2.19),('5815','2013-02-07','11:35:00',2.19),('5815','2013-02-07','11:40:00',2.21),('5815','2013-02-07','11:45:00',2.23),('5815','2013-02-07','11:50:00',2.23),('5815','2013-02-07','11:55:00',2.24),('5815','2013-02-07','12:00:00',2.24),('5815','2013-02-07','12:05:00',2.25),('5815','2013-02-07','12:10:00',2.25),('5815','2013-02-07','12:15:00',2.24),('5815','2013-02-07','12:20:00',2.25),('5815','2013-02-07','12:25:00',2.26),('5815','2013-02-07','12:30:00',2.26),('5815','2013-02-07','12:35:00',2.27),('5815','2013-02-07','12:40:00',2.33),('5815','2013-02-07','12:45:00',2.26),('5815','2013-02-07','12:50:00',1.82),('5815','2013-02-07','12:55:00',1.27),('5815','2013-02-07','13:00:00',1.16),('5815','2013-02-07','13:05:00',1.07),('5815','2013-02-07','13:10:00',1.16),('5815','2013-02-07','13:15:00',1.14),('5815','2013-02-07','13:20:00',1.17),('5815','2013-02-07','13:25:00',1.11),('5815','2013-02-07','13:30:00',1.08),('5815','2013-02-07','13:35:00',1.45),('5815','2013-02-07','13:40:00',1.23),('5815','2013-02-07','14:30:00',1.14),('5815','2013-02-07','14:35:00',1.13),('5815','2013-02-07','14:40:00',2.09),('5815','2013-02-07','14:45:00',2.18),('5815','2013-02-07','14:50:00',1.28),('5815','2013-02-07','14:55:00',1.72),('5815','2013-02-07','15:00:00',1.69),('5815','2013-02-07','15:05:00',1.97),('5815','2013-02-07','15:10:00',1.96),('5815','2013-02-07','15:15:00',1.79),('5815','2013-02-07','15:20:00',1.35),('5815','2013-02-07','15:25:00',1.5),('5815','2013-02-07','15:30:00',1.39),('5815','2013-02-07','15:35:00',1.32),('5815','2013-02-07','15:40:00',1.27),('5815','2013-02-07','15:45:00',1.22),('5815','2013-02-07','15:50:00',1.15),('5815','2013-02-07','15:55:00',1.08),('5815','2013-02-07','16:00:00',1.02),('5815','2013-02-06','11:00:00',1.36),('5815','2013-02-06','12:25:00',1.67),('5815','2013-02-06','12:30:00',1.34),('5815','2013-02-06','14:05:00',1.09),('5815','2013-02-06','14:10:00',1.87),('5815','2013-02-06','14:15:00',1.78),('5815','2013-02-06','14:20:00',1.72),('5815','2013-02-06','14:35:00',1.16),('5815','2013-02-06','14:45:00',1.32),('5815','2013-02-06','15:00:00',1.07),('5815','2013-02-06','15:05:00',1.57),('5815','2013-02-06','15:10:00',1.68),('5815','2013-02-06','15:15:00',1.32),('5815','2013-02-05','09:10:00',1.01),('5815','2013-02-05','09:40:00',1.04),('5815','2013-02-05','10:05:00',1.06),('5815','2013-02-05','10:35:00',1.15),('5815','2013-02-05','10:55:00',1.42),('5815','2013-02-05','11:00:00',1.12),('5815','2013-02-05','11:20:00',1.14),('5815','2013-02-05','11:25:00',1.57),('5815','2013-02-05','11:30:00',1.01),('5815','2013-02-05','13:50:00',1.07),('5815','2013-02-05','14:35:00',1.59),('5815','2013-02-04','09:00:00',1.04),('5815','2013-02-04','09:05:00',1.08),('5815','2013-02-04','09:10:00',1.14),('5815','2013-02-04','09:15:00',1.19),('5815','2013-02-04','09:20:00',1.25),('5815','2013-02-04','09:25:00',1.3),('5815','2013-02-04','09:30:00',1.33),('5815','2013-02-04','09:35:00',1.39),('5815','2013-02-04','09:40:00',1.44),('5815','2013-02-04','09:45:00',1.47),('5815','2013-02-04','09:50:00',1.51),('5815','2013-02-04','09:55:00',1.56),('5815','2013-02-04','10:00:00',1.57),('5815','2013-02-04','10:05:00',1.61),('5815','2013-02-04','10:10:00',1.52),('5815','2013-02-04','10:15:00',1.54),('5815','2013-02-04','10:20:00',1.72),('5815','2013-02-04','10:25:00',1.76),('5815','2013-02-04','10:30:00',1.79),('5815','2013-02-04','10:35:00',1.81),('5815','2013-02-04','10:40:00',1.83),('5815','2013-02-04','10:45:00',1.85),('5815','2013-02-04','10:50:00',1.85),('5815','2013-02-04','10:55:00',1.86),('5815','2013-02-04','11:00:00',1.88),('5815','2013-02-04','11:05:00',1.89),('5815','2013-02-04','11:10:00',1.94),('5815','2013-02-04','11:15:00',1.96),('5815','2013-02-04','11:20:00',1.97),('5815','2013-02-04','11:25:00',1.98),('5815','2013-02-04','11:30:00',1.95),('5815','2013-02-04','11:35:00',1.88),('5815','2013-02-04','11:40:00',1.63),('5815','2013-02-04','11:45:00',1.36),('5815','2013-02-04','11:50:00',1.09),('5815','2013-02-04','12:10:00',1.43),('5815','2013-02-04','12:40:00',1),('5815','2013-02-04','12:45:00',1.08),('5815','2013-02-04','12:50:00',1.32),('5815','2013-02-04','14:25:00',1.01),('5815','2013-02-04','14:30:00',1.05),('5815','2013-02-04','14:40:00',1.2),('5815','2013-02-03','09:00:00',1.11),('5815','2013-02-03','09:05:00',1.19),('5815','2013-02-03','09:10:00',1.26),('5815','2013-02-03','09:15:00',1.29),('5815','2013-02-03','09:20:00',1.29),('5815','2013-02-03','09:25:00',1.3),('5815','2013-02-03','09:30:00',1.41),('5815','2013-02-03','09:35:00',1.41),('5815','2013-02-03','09:40:00',1.44),('5815','2013-02-03','09:45:00',1.3),('5815','2013-02-03','09:50:00',1.56),('5815','2013-02-03','09:55:00',1.67),('5815','2013-02-03','10:00:00',1.72),('5815','2013-02-03','10:05:00',1.75),('5815','2013-02-03','10:10:00',1.81),('5815','2013-02-03','10:15:00',1.87),('5815','2013-02-03','10:20:00',1.77),('5815','2013-02-03','10:25:00',1.85),('5815','2013-02-03','10:30:00',1.76),('5815','2013-02-03','10:35:00',1.68),('5815','2013-02-03','10:40:00',1.79),('5815','2013-02-03','10:45:00',1.95),('5815','2013-02-03','10:50:00',2),('5815','2013-02-03','10:55:00',2),('5815','2013-02-03','11:00:00',2.01),('5815','2013-02-03','11:05:00',2.06),('5815','2013-02-03','11:10:00',2.07),('5815','2013-02-03','11:15:00',2.09),('5815','2013-02-03','11:20:00',2.1),('5815','2013-02-03','11:25:00',2.11),('5815','2013-02-03','11:30:00',2.12),('5815','2013-02-03','11:35:00',2.12),('5815','2013-02-03','11:40:00',2.14),('5815','2013-02-03','11:45:00',2.14),('5815','2013-02-03','11:50:00',2.15),('5815','2013-02-03','11:55:00',2.16),('5815','2013-02-03','12:00:00',2.13),('5815','2013-02-03','12:05:00',2.18),('5815','2013-02-03','12:10:00',2.19),('5815','2013-02-03','12:15:00',2.17),('5815','2013-02-03','12:20:00',2.17),('5815','2013-02-03','12:25:00',2.17),('5815','2013-02-03','12:30:00',2.18),('5815','2013-02-03','12:35:00',2.17),('5815','2013-02-03','12:40:00',2.18),('5815','2013-02-03','12:45:00',2.16),('5815','2013-02-03','12:50:00',2.14),('5815','2013-02-03','12:55:00',2.16),('5815','2013-02-03','13:00:00',2.17),('5815','2013-02-03','13:05:00',2.16),('5815','2013-02-03','13:10:00',2.15),('5815','2013-02-03','13:15:00',2.12),('5815','2013-02-03','13:20:00',2.12),('5815','2013-02-03','13:25:00',2.1),('5815','2013-02-03','13:30:00',2.09),('5815','2013-02-03','13:35:00',2.07),('5815','2013-02-03','13:40:00',2.04),('5815','2013-02-03','13:45:00',2.01),('5815','2013-02-03','13:50:00',2.01),('5815','2013-02-03','13:55:00',1.99),('5815','2013-02-03','14:00:00',1.97),('5815','2013-02-03','14:05:00',1.95),('5815','2013-02-03','14:10:00',1.92),('5815','2013-02-03','14:15:00',1.9),('5815','2013-02-03','14:20:00',1.87),('5815','2013-02-03','14:25:00',1.84),('5815','2013-02-03','14:30:00',1.82),('5815','2013-02-03','14:35:00',1.81),('5815','2013-02-03','14:40:00',1.76),('5815','2013-02-03','14:45:00',1.7),('5815','2013-02-03','14:50:00',1.66),('5815','2013-02-03','14:55:00',1.61),('5815','2013-02-03','15:00:00',1.57),('5815','2013-02-03','15:05:00',1.53),('5815','2013-02-03','15:10:00',1.49),('5815','2013-02-03','15:15:00',1.44),('5815','2013-02-03','15:20:00',1.39),('5815','2013-02-03','15:25:00',1.36),('5815','2013-02-03','15:30:00',1.31),('5815','2013-02-03','15:35:00',1.25),('5815','2013-02-03','15:40:00',1.2),('5815','2013-02-03','15:45:00',1.14),('5815','2013-02-03','15:50:00',1.09),('5815','2013-02-03','15:55:00',1.03),('5815','2013-02-02','10:00:00',1.21),('5815','2013-02-01','10:55:00',1.07),('5815','2013-02-01','11:00:00',1.26),('5815','2013-02-01','11:05:00',1.12),('5815','2013-02-01','11:10:00',1.2),('5815','2013-02-01','11:15:00',1.17),('5815','2013-02-01','11:20:00',1.15),('5815','2013-02-01','11:25:00',1.25),('5815','2013-02-01','11:30:00',1.22),('5815','2013-02-01','11:35:00',1.04),('5815','2013-02-01','11:40:00',1.02),('5815','2013-02-01','12:55:00',1.43),('5815','2013-02-01','13:00:00',1.2),('5815','2013-02-01','13:05:00',1.26),('5815','2013-02-01','13:10:00',1.11),('5815','2013-02-01','13:15:00',1.35),('5815','2013-02-01','13:20:00',1.19),('5815','2013-02-01','13:25:00',1.01),('5815','2013-02-01','13:35:00',1.3),('5815','2013-02-01','13:40:00',1.68),('5815','2013-02-01','13:45:00',1.21),('5815','2013-02-01','13:50:00',1.23),('5815','2013-01-31','09:05:00',1.03),('5815','2013-01-31','09:10:00',1.16),('5815','2013-01-31','09:25:00',1.05),('5815','2013-01-31','09:40:00',1.05),('5815','2013-01-31','10:00:00',1.09),('5815','2013-01-31','10:20:00',1.24),('5815','2013-01-31','10:50:00',1.38),('5815','2013-01-31','10:55:00',2.09),('5815','2013-01-31','11:00:00',2),('5815','2013-01-31','11:05:00',1.85),('5815','2013-01-31','11:10:00',1.97),('5815','2013-01-31','11:15:00',1.25),('5815','2013-01-31','11:20:00',1.52),('5815','2013-01-31','11:25:00',1.07),('5815','2013-01-31','11:40:00',1.64),('5815','2013-01-31','11:45:00',1.01),('5815','2013-01-31','11:50:00',1.11),('5815','2013-01-31','12:10:00',1.04),('5815','2013-01-31','12:15:00',1.16),('5815','2013-01-31','12:20:00',2.36),('5815','2013-01-31','12:25:00',2.2),('5815','2013-01-31','12:40:00',1.74),('5815','2013-01-31','12:45:00',1.81),('5815','2013-01-31','12:50:00',2.08),('5815','2013-01-31','12:55:00',2.35),('5815','2013-01-31','13:00:00',2.27),('5815','2013-01-31','13:05:00',1.37),('5815','2013-01-31','13:10:00',2.14),('5815','2013-01-31','13:15:00',2.01),('5815','2013-01-31','13:20:00',2.01),('5815','2013-01-31','13:25:00',1.38),('5815','2013-01-31','13:30:00',1.34),('5815','2013-01-31','13:35:00',1.49),('5815','2013-01-31','13:40:00',1.52),('5815','2013-01-31','13:45:00',1.56),('5815','2013-01-31','13:50:00',1.29),('5815','2013-01-31','14:15:00',1.19),('5815','2013-01-31','14:20:00',1.68),('5815','2013-01-31','14:25:00',1.78),('5815','2013-01-31','14:30:00',1.77),('5815','2013-01-31','14:35:00',1.7),('5815','2013-01-31','14:40:00',1.54),('5815','2013-01-31','15:10:00',1.42),('5815','2013-01-31','15:20:00',1.29),('5815','2013-01-30','09:25:00',1.21),('5815','2013-01-30','09:30:00',1.37),('5815','2013-01-30','09:35:00',1.31),('5815','2013-01-30','09:40:00',1.35),('5815','2013-01-30','09:45:00',1.27),('5815','2013-01-30','09:50:00',1.37),('5815','2013-01-30','09:55:00',1.51),('5815','2013-01-30','10:00:00',1.51),('5815','2013-01-30','10:05:00',1.52),('5815','2013-01-30','10:10:00',1.54),('5815','2013-01-30','10:15:00',1.6),('5815','2013-01-30','10:20:00',1.65),('5815','2013-01-30','10:25:00',1.58),('5815','2013-01-30','10:30:00',1.55),('5815','2013-01-30','10:35:00',1.79),('5815','2013-01-30','10:40:00',1.86),('5815','2013-01-30','10:45:00',1.87),('5815','2013-01-30','10:50:00',1.62),('5815','2013-01-30','11:00:00',2),('5815','2013-01-30','11:05:00',2.11),('5815','2013-01-30','11:10:00',2.1),('5815','2013-01-30','11:15:00',2.09),('5815','2013-01-30','11:20:00',2.11),('5815','2013-01-30','11:25:00',2.01),('5815','2013-01-30','11:30:00',1.94),('5815','2013-01-30','11:35:00',1.99),('5815','2013-01-30','11:40:00',1.99),('5815','2013-01-30','11:45:00',1.97),('5815','2013-01-30','11:50:00',1.97),('5815','2013-01-30','11:55:00',1.96),('5815','2013-01-30','12:00:00',1.97),('5815','2013-01-30','12:05:00',2),('5815','2013-01-30','12:10:00',1.59),('5815','2013-01-30','12:15:00',1.96),('5815','2013-01-30','12:20:00',2.01),('5815','2013-01-30','12:25:00',2.01),('5815','2013-01-30','12:30:00',2.01),('5815','2013-01-30','12:35:00',2.01),('5815','2013-01-30','12:40:00',2),('5815','2013-01-30','12:45:00',2),('5815','2013-01-30','12:50:00',1.99),('5815','2013-01-30','12:55:00',1.95),('5815','2013-01-30','13:00:00',1.96),('5815','2013-01-30','13:05:00',1.95),('5815','2013-01-30','13:10:00',1.94),('5815','2013-01-30','13:15:00',1.91),('5815','2013-01-30','13:20:00',1.88),('5815','2013-01-30','13:25:00',1.87),('5815','2013-01-30','13:30:00',1.83),('5815','2013-01-30','13:35:00',1.82),('5815','2013-01-30','13:40:00',1.77),('5815','2013-01-30','13:45:00',1.71),('5815','2013-01-30','13:50:00',1.81),('5815','2013-01-30','13:55:00',1.81),('5815','2013-01-30','14:00:00',1.77),('5815','2013-01-30','14:05:00',1.7),('5815','2013-01-30','14:10:00',1.67),('5815','2013-01-30','14:15:00',1.63),('5815','2013-01-30','14:20:00',1.66),('5815','2013-01-30','14:25:00',1.62),('5815','2013-01-30','14:30:00',1.58),('5815','2013-01-30','14:35:00',1.57),('5815','2013-01-30','14:40:00',1.53),('5815','2013-01-30','14:45:00',1.47),('5815','2013-01-30','14:50:00',1.41),('5815','2013-01-30','14:55:00',1.38),('5815','2013-01-30','15:00:00',1.32),('5815','2013-01-30','15:05:00',1.3),('5815','2013-01-30','15:10:00',1.27),('5815','2013-01-30','15:15:00',1.26),('5815','2013-01-30','15:20:00',1.22),('5815','2013-01-30','15:25:00',1.16),('5815','2013-01-30','15:30:00',1.12),('5815','2013-01-30','15:35:00',1.09),('5815','2013-01-30','15:40:00',1.03),('5815','2013-01-29','10:45:00',1.28),('5815','2013-01-29','10:50:00',1.7),('5815','2013-01-29','10:55:00',1.75),('5815','2013-01-29','11:00:00',1.82),('5815','2013-01-29','11:05:00',1.77),('5815','2013-01-29','11:10:00',1.79),('5815','2013-01-29','11:15:00',1.83),('5815','2013-01-29','11:20:00',1.85),('5815','2013-01-29','11:25:00',1.9),('5815','2013-01-29','11:30:00',1.91),('5815','2013-01-29','11:35:00',1.92),('5815','2013-01-29','11:40:00',1.63),('5815','2013-01-29','11:45:00',1.97),('5815','2013-01-29','11:50:00',1.98),('5815','2013-01-29','11:55:00',1.91),('5815','2013-01-29','12:00:00',2),('5815','2013-01-29','12:05:00',2.01),('5815','2013-01-29','12:10:00',1.25),('5815','2013-01-29','12:15:00',1.65),('5815','2013-01-29','12:20:00',1.18),('5815','2013-01-29','12:40:00',1.12),('5815','2013-01-29','12:55:00',2.23),('5815','2013-01-29','13:00:00',2.2),('5815','2013-01-29','13:05:00',2.21),('5815','2013-01-29','13:10:00',2.1),('5815','2013-01-29','13:15:00',1.99),('5815','2013-01-29','13:20:00',2.04),('5815','2013-01-29','13:25:00',2.12),('5815','2013-01-29','13:30:00',1.86),('5815','2013-01-29','13:35:00',1.92),('5815','2013-01-29','13:40:00',1.04),('5815','2013-01-29','13:45:00',1.07),('5815','2013-01-29','13:50:00',1.61),('5815','2013-01-29','13:55:00',1.33),('5815','2013-01-29','14:00:00',1.47),('5815','2013-01-29','14:05:00',1.01),('5815','2013-01-29','14:10:00',1.62),('5815','2013-01-29','14:20:00',1.24),('5815','2013-01-29','14:25:00',1.48),('5815','2013-01-29','14:40:00',1.14),('5815','2013-01-29','14:45:00',1.2),('5815','2013-01-28','09:05:00',1.02),('5815','2013-01-28','09:10:00',1.08),('5815','2013-01-28','09:15:00',1.12),('5815','2013-01-28','09:20:00',1.17),('5815','2013-01-28','09:25:00',1.22),('5815','2013-01-28','09:30:00',1.26),('5815','2013-01-28','09:35:00',1.3),('5815','2013-01-28','09:40:00',1.35),('5815','2013-01-28','09:45:00',1.41),('5815','2013-01-28','09:50:00',1.45),('5815','2013-01-28','09:55:00',1.48),('5815','2013-01-28','10:00:00',1.52),('5815','2013-01-28','10:05:00',1.58),('5815','2013-01-28','10:10:00',1.62),('5815','2013-01-28','10:15:00',1.66),('5815','2013-01-28','10:20:00',1.69),('5815','2013-01-28','10:25:00',1.74),('5815','2013-01-28','10:30:00',1.76),('5815','2013-01-28','10:35:00',1.79),('5815','2013-01-28','10:40:00',1.83),('5815','2013-01-28','10:45:00',1.84),('5815','2013-01-28','10:50:00',1.86),('5815','2013-01-28','10:55:00',1.88),('5815','2013-01-28','11:00:00',1.87),('5815','2013-01-28','11:05:00',1.89),('5815','2013-01-28','11:10:00',1.9),('5815','2013-01-28','11:15:00',1.94),('5815','2013-01-28','11:20:00',1.96),('5815','2013-01-28','11:25:00',1.95),('5815','2013-01-28','11:30:00',1.94),('5815','2013-01-28','11:35:00',2.01),('5815','2013-01-28','11:40:00',2.05),('5815','2013-01-28','11:45:00',2.05),('5815','2013-01-28','11:50:00',2.05),('5815','2013-01-28','11:55:00',2.04),('5815','2013-01-28','12:00:00',2.02),('5815','2013-01-28','12:05:00',2.03),('5815','2013-01-28','12:10:00',2.06),('5815','2013-01-28','12:15:00',2.05),('5815','2013-01-28','12:20:00',2.04),('5815','2013-01-28','12:25:00',2.06),('5815','2013-01-28','12:30:00',2.05),('5815','2013-01-28','12:35:00',2.02),('5815','2013-01-28','12:40:00',2.02),('5815','2013-01-28','12:45:00',2),('5815','2013-01-28','12:50:00',1.99),('5815','2013-01-28','12:55:00',2.02),('5815','2013-01-28','13:00:00',2.02),('5815','2013-01-28','13:05:00',1.99),('5815','2013-01-28','13:10:00',1.98),('5815','2013-01-28','13:15:00',1.96),('5815','2013-01-28','13:20:00',1.96),('5815','2013-01-28','13:25:00',1.95),('5815','2013-01-28','13:30:00',1.93),('5815','2013-01-28','13:35:00',1.89),('5815','2013-01-28','13:40:00',1.88),('5815','2013-01-28','13:45:00',1.86),('5815','2013-01-28','13:50:00',1.83),('5815','2013-01-28','13:55:00',1.8),('5815','2013-01-28','14:00:00',1.78),('5815','2013-01-28','14:05:00',1.73),('5815','2013-01-28','14:10:00',1.7),('5815','2013-01-28','14:15:00',1.72),('5815','2013-01-28','14:20:00',1.74),('5815','2013-01-28','14:25:00',1.71),('5815','2013-01-28','14:30:00',1.68),('5815','2013-01-28','14:35:00',1.62),('5815','2013-01-28','14:40:00',1.58),('5815','2013-01-28','14:45:00',1.56),('5815','2013-01-28','14:50:00',1.51),('5815','2013-01-28','14:55:00',1.47),('5815','2013-01-28','15:00:00',1.42),('5815','2013-01-28','15:05:00',1.38),('5815','2013-01-28','15:10:00',1.31),('5815','2013-01-28','15:15:00',1.27),('5815','2013-01-28','15:20:00',1.22),('5815','2013-01-28','15:25:00',1.17),('5815','2013-01-28','15:30:00',1.1),('5815','2013-01-28','15:35:00',1.05),('5815','2013-01-28','15:40:00',1.01),('5815','2013-01-26','09:10:00',1.03),('5815','2013-01-26','09:15:00',1.08),('5815','2013-01-26','09:20:00',1.14),('5815','2013-01-26','09:25:00',1.2),('5815','2013-01-26','09:30:00',1.24),('5815','2013-01-26','09:35:00',1.29),('5815','2013-01-26','09:40:00',1.34),('5815','2013-01-26','09:45:00',1.38),('5815','2013-01-26','09:50:00',1.43),('5815','2013-01-26','09:55:00',1.47),('5815','2013-01-26','10:00:00',1.5),('5815','2013-01-26','10:05:00',1.52),('5815','2013-01-26','10:10:00',1.57),('5815','2013-01-26','10:15:00',1.61),('5815','2013-01-26','10:20:00',1.64),('5815','2013-01-26','10:25:00',1.67),('5815','2013-01-26','10:30:00',1.71),('5815','2013-01-26','10:35:00',1.73),('5815','2013-01-26','10:40:00',1.75),('5815','2013-01-26','10:45:00',1.78),('5815','2013-01-26','10:50:00',1.81),('5815','2013-01-26','10:55:00',1.84),('5815','2013-01-26','11:00:00',1.85),('5815','2013-01-26','11:05:00',1.87),('5815','2013-01-26','11:10:00',1.89),('5815','2013-01-26','11:15:00',1.91),('5815','2013-01-26','11:20:00',1.94),('5815','2013-01-26','11:25:00',1.95),('5815','2013-01-26','11:30:00',1.96),('5815','2013-01-26','11:35:00',1.97),('5815','2013-01-26','11:40:00',1.97),('5815','2013-01-26','11:45:00',1.98),('5815','2013-01-26','11:50:00',1.99),('5815','2013-01-26','11:55:00',2.01),('5815','2013-01-26','12:00:00',2.02),('5815','2013-01-26','12:05:00',2.02),('5815','2013-01-26','12:10:00',2.02),('5815','2013-01-26','12:15:00',2.02),('5815','2013-01-26','12:20:00',2.03),('5815','2013-01-26','12:25:00',2.02),('5815','2013-01-26','12:30:00',2.02),('5815','2013-01-26','12:35:00',2.02),('5815','2013-01-26','12:40:00',2),('5815','2013-01-26','12:45:00',1.97),('5815','2013-01-26','12:50:00',1.98),('5815','2013-01-26','12:55:00',2.03),('5815','2013-01-26','13:00:00',2.01),('5815','2013-01-26','13:05:00',2),('5815','2013-01-26','13:10:00',1.97),('5815','2013-01-26','13:15:00',1.94),('5815','2013-01-26','13:20:00',1.89),('5815','2013-01-26','13:25:00',1.9),('5815','2013-01-26','13:30:00',1.88),('5815','2013-01-26','13:35:00',1.86),('5815','2013-01-26','13:40:00',1.82),('5815','2013-01-26','13:45:00',1.78),('5815','2013-01-26','13:50:00',1.77),('5815','2013-01-26','13:55:00',1.76),('5815','2013-01-26','14:00:00',1.76),('5815','2013-01-26','14:05:00',1.73),('5815','2013-01-26','14:10:00',1.68),('5815','2013-01-26','14:15:00',1.65),('5815','2013-01-26','14:20:00',1.62),('5815','2013-01-26','14:25:00',1.58),('5815','2013-01-26','14:30:00',1.56),('5815','2013-01-26','14:35:00',1.51),('5815','2013-01-26','14:40:00',1.47),('5815','2013-01-26','14:45:00',1.43),('5815','2013-01-26','14:50:00',1.42),('5815','2013-01-26','14:55:00',1.4),('5815','2013-01-26','15:00:00',1.33),('5815','2013-01-26','15:05:00',1.29),('5815','2013-01-26','15:10:00',1.23),('5815','2013-01-26','15:15:00',1.17),('5815','2013-01-26','15:20:00',1.12),('5815','2013-01-26','15:25:00',1.08),('5815','2013-01-26','15:30:00',1.05),('5815','2013-01-24','09:00:00',1.04),('5815','2013-01-24','09:15:00',1.14),('5815','2013-01-24','09:20:00',1.22),('5815','2013-01-24','09:25:00',1.3),('5815','2013-01-24','09:30:00',1.36),('5815','2013-01-24','09:35:00',1.34),('5815','2013-01-24','09:40:00',1.25),('5815','2013-01-24','09:45:00',1.31),('5815','2013-01-24','09:50:00',1.57),('5815','2013-01-24','09:55:00',1.63),('5815','2013-01-24','10:00:00',1.67),('5815','2013-01-24','10:05:00',1.71),('5815','2013-01-24','10:10:00',1.69),('5815','2013-01-24','10:15:00',1.7),('5815','2013-01-24','10:20:00',1.74),('5815','2013-01-24','10:25:00',1.78),('5815','2013-01-24','10:30:00',1.76),('5815','2013-01-24','10:35:00',1.43),('5815','2013-01-24','10:40:00',1.96),('5815','2013-01-24','10:45:00',1.77),('5815','2013-01-24','10:50:00',1.43),('5815','2013-01-24','10:55:00',2.04),('5815','2013-01-24','11:00:00',1.19),('5815','2013-01-24','11:05:00',1.83),('5815','2013-01-24','11:10:00',1.97),('5815','2013-01-24','11:15:00',2.04),('5815','2013-01-24','11:20:00',2.01),('5815','2013-01-24','11:25:00',2),('5815','2013-01-24','11:30:00',2.03),('5815','2013-01-24','11:35:00',2.06),('5815','2013-01-24','11:40:00',2.07),('5815','2013-01-24','11:45:00',2.07),('5815','2013-01-24','11:50:00',2.12),('5815','2013-01-24','11:55:00',2.11),('5815','2013-01-24','12:00:00',2.09),('5815','2013-01-24','12:05:00',2.09),('5815','2013-01-24','12:10:00',2.12),('5815','2013-01-24','12:15:00',2.13),('5815','2013-01-24','12:20:00',2.14),('5815','2013-01-24','12:25:00',2.16),('5815','2013-01-24','12:30:00',2.16),('5815','2013-01-24','12:35:00',1.87),('5815','2013-01-24','12:40:00',1.88),('5815','2013-01-24','12:45:00',2.01),('5815','2013-01-24','12:50:00',2.07),('5815','2013-01-24','12:55:00',2.03),('5815','2013-01-24','13:00:00',2.05),('5815','2013-01-24','13:05:00',2.02),('5815','2013-01-24','13:10:00',2),('5815','2013-01-24','13:15:00',2),('5815','2013-01-24','13:20:00',2),('5815','2013-01-24','13:25:00',2.02),('5815','2013-01-24','13:30:00',2.06),('5815','2013-01-24','13:35:00',2.04),('5815','2013-01-24','13:40:00',2),('5815','2013-01-24','13:45:00',1.96),('5815','2013-01-24','13:50:00',1.91),('5815','2013-01-24','13:55:00',1.87),('5815','2013-01-24','14:00:00',1.81),('5815','2013-01-24','14:05:00',1.76),('5815','2013-01-24','14:10:00',1.61),('5815','2013-01-24','14:15:00',1.55),('5815','2013-01-24','14:20:00',1.45),('5815','2013-01-24','14:25:00',1.47),('5815','2013-01-24','14:30:00',1.4),('5815','2013-01-24','14:35:00',1.31),('5815','2013-01-24','14:40:00',1.28),('5815','2013-01-24','14:45:00',1.23),('5815','2013-01-24','14:50:00',1.22),('5815','2013-01-24','14:55:00',1.21),('5815','2013-01-24','15:00:00',1.11),('5815','2013-01-24','15:05:00',1.05),('5815','2013-01-24','15:10:00',1.04),('5815','2013-01-24','15:35:00',1.01),('5815','2013-01-23','09:55:00',1.47),('5815','2013-01-23','10:00:00',1.53),('5815','2013-01-23','10:05:00',1.57),('5815','2013-01-23','10:10:00',1.73),('5815','2013-01-23','10:15:00',1.71),('5815','2013-01-23','10:20:00',1.76),('5815','2013-01-23','10:25:00',1.77),('5815','2013-01-23','10:30:00',1.8),('5815','2013-01-23','10:35:00',1.82),('5815','2013-01-23','10:40:00',1.86),('5815','2013-01-23','10:45:00',1.9),('5815','2013-01-23','10:50:00',1.97),('5815','2013-01-23','10:55:00',1.87),('5815','2013-01-23','11:00:00',1.06),('5815','2013-01-23','14:20:00',1.13),('5815','2013-01-23','14:25:00',2.21),('5815','2013-01-23','14:30:00',1.98),('5815','2013-01-23','14:35:00',1.42),('5815','2013-01-23','14:45:00',1.36),('5815','2013-01-23','14:50:00',1.48),('5815','2013-01-23','14:55:00',1.55),('5815','2013-01-23','15:00:00',1.17),('5815','2013-01-23','15:20:00',1.02),('5815','2013-01-23','15:25:00',1.05),('5815','2013-01-23','15:30:00',1.09),('5815','2013-01-22','09:55:00',1.02),('5815','2013-01-22','10:30:00',1.28),('5815','2013-01-22','10:35:00',1.81),('5815','2013-01-22','10:45:00',1.1),('5815','2013-01-22','10:50:00',1.43),('5815','2013-01-22','10:55:00',1.24),('5815','2013-01-21','09:30:00',1.23),('5815','2013-01-21','09:35:00',1.4),('5815','2013-01-21','09:40:00',1.05),('5815','2013-01-21','09:45:00',1.71),('5815','2013-01-21','09:50:00',1.14),('5815','2013-01-21','09:55:00',1.3),('5815','2013-01-21','10:05:00',1.59),('5815','2013-01-21','10:10:00',1.71),('5815','2013-01-21','10:15:00',1.6),('5815','2013-01-21','10:20:00',1.49),('5815','2013-01-21','10:25:00',1.65),('5815','2013-01-21','10:30:00',1.85),('5815','2013-01-21','10:35:00',1.91),('5815','2013-01-21','10:40:00',2.17),('5815','2013-01-21','10:45:00',1.74),('5815','2013-01-21','10:50:00',1.45),('5815','2013-01-21','11:15:00',1.21),('5815','2013-01-21','11:20:00',1.2),('5815','2013-01-21','11:50:00',1.57),('5815','2013-01-21','12:10:00',1.52),('5815','2013-01-21','12:15:00',1.69),('5815','2013-01-21','12:20:00',1.03),('5815','2013-01-21','12:25:00',1.72),('5815','2013-01-21','12:40:00',2.28),('5815','2013-01-21','13:00:00',1.6),('5815','2013-01-21','13:05:00',1.89),('5815','2013-01-21','13:10:00',1.31),('5815','2013-01-21','13:20:00',1.7),('5815','2013-01-21','14:15:00',1.17),('5815','2013-01-21','14:25:00',1.49),('5815','2013-01-21','14:45:00',1.15),('5815','2013-01-20','11:55:00',2.26),('5815','2013-01-20','12:00:00',2.04),('5815','2013-01-20','12:05:00',1.99),('5815','2013-01-20','12:10:00',2.08),('5815','2013-01-20','12:15:00',1.75),('5815','2013-01-20','13:05:00',1.25),('5815','2013-01-20','13:10:00',1),('5815','2013-01-20','13:30:00',1.64),('5815','2013-01-20','13:35:00',2.21),('5815','2013-01-20','13:40:00',1.72),('5815','2013-01-20','13:55:00',1.38),('5815','2013-01-20','14:00:00',1.95),('5815','2013-01-20','14:05:00',1.97),('5815','2013-01-20','14:10:00',1.68),('5815','2013-01-20','14:15:00',1.5),('5815','2013-01-20','14:20:00',1.48),('5815','2013-01-20','14:25:00',1.91),('5815','2013-01-19','11:15:00',1.02),('5815','2013-01-19','11:25:00',1.08),('5815','2013-01-19','11:30:00',1.49),('5815','2013-01-19','11:35:00',1.11),('5815','2013-01-17','10:15:00',1.49),('5815','2013-01-17','10:20:00',1.58),('5815','2013-01-17','12:50:00',1.36),('5815','2013-01-17','12:55:00',1.24),('5815','2013-01-17','13:00:00',1.38),('5815','2013-01-17','13:05:00',1.25),('5815','2013-01-17','13:10:00',1.21),('5815','2013-01-17','13:15:00',1.39),('5815','2013-01-17','13:20:00',1.12),('5815','2013-01-17','13:35:00',1.05),('5815','2013-01-17','13:40:00',1.6),('5815','2013-01-17','13:45:00',1.73),('5815','2013-01-17','13:50:00',2.07),('5815','2013-01-17','13:55:00',1.99),('5815','2013-01-17','14:00:00',1.36),('5815','2013-01-17','14:05:00',1.54),('5815','2013-01-17','14:10:00',1.43),('5815','2013-01-17','14:20:00',1.13),('5815','2013-01-16','10:25:00',1),('5815','2013-01-16','10:30:00',1.09),('5815','2013-01-16','10:55:00',1.13),('5815','2013-01-16','11:10:00',1.22),('5815','2013-01-16','11:15:00',1.18),('5815','2013-01-16','11:20:00',1.11),('5815','2013-01-16','11:55:00',1.04),('5815','2013-01-16','12:00:00',1.18),('5815','2013-01-16','12:05:00',1.15),('5815','2013-01-16','12:10:00',1.07),('5815','2013-01-16','12:15:00',1.31),('5815','2013-01-16','12:20:00',1.12),('5815','2013-01-16','12:25:00',1.03),('5815','2013-01-16','12:35:00',1.03),('5815','2013-01-16','12:40:00',1.11),('5815','2013-01-16','13:00:00',1.04),('5815','2013-01-16','13:35:00',1.09),('5815','2013-01-16','13:40:00',1.41),('5815','2013-01-16','13:45:00',1.57),('5815','2013-01-16','13:50:00',1.43),('5815','2013-01-16','14:35:00',1.1),('5815','2013-01-15','09:25:00',1.12),('5815','2013-01-15','09:30:00',1.22),('5815','2013-01-15','09:35:00',1.29),('5815','2013-01-15','09:40:00',1.39),('5815','2013-01-15','10:35:00',1.2),('5815','2013-01-15','10:40:00',1.45),('5815','2013-01-15','10:45:00',1.62),('5815','2013-01-15','10:55:00',1.45),('5815','2013-01-15','12:15:00',2.2),('5815','2013-01-15','12:20:00',2.22),('5815','2013-01-15','13:05:00',1.13),('5815','2013-01-15','13:10:00',2.25),('5815','2013-01-15','13:15:00',2.52),('5815','2013-01-15','13:20:00',2.07),('5815','2013-01-15','13:25:00',1.2),('5815','2013-01-15','13:55:00',1.56),('5815','2013-01-15','14:00:00',1.13),('5815','2013-01-14','14:05:00',1.52),('5815','2013-01-14','14:10:00',1.88),('5815','2013-01-14','14:15:00',1.92),('5815','2013-01-14','14:20:00',1.91),('5815','2013-01-14','14:25:00',1.51),('5815','2013-01-14','14:35:00',1.24),('5815','2013-01-14','14:45:00',1.35),('5815','2013-01-14','14:50:00',1.31),('5815','2013-01-14','14:55:00',1.41),('5815','2013-01-14','15:00:00',1.39),('5815','2013-01-14','15:05:00',1.28),('5815','2013-01-14','15:10:00',1.11),('5815','2013-01-13','15:15:00',1.01),('5815','2013-01-12','09:15:00',1.07),('5815','2013-01-12','09:20:00',1.14),('5815','2013-01-12','09:25:00',1.12),('5815','2013-01-12','09:30:00',1.17),('5815','2013-01-12','09:35:00',1.22),('5815','2013-01-12','09:55:00',1.21),('5815','2013-01-12','10:00:00',1.25),('5815','2013-01-12','10:05:00',1.34),('5815','2013-01-12','10:25:00',1.02),('5815','2013-01-12','10:30:00',1.16),('5815','2013-01-11','09:20:00',1.02),('5815','2013-01-11','09:25:00',1.08),('5815','2013-01-11','09:30:00',1.12),('5815','2013-01-11','09:35:00',1.16),('5815','2013-01-11','09:40:00',1.21),('5815','2013-01-11','09:45:00',1.25),('5815','2013-01-11','09:50:00',1.3),('5815','2013-01-11','09:55:00',1.33),('5815','2013-01-11','10:00:00',1.38),('5815','2013-01-11','10:05:00',1.43),('5815','2013-01-11','10:10:00',1.44),('5815','2013-01-11','10:15:00',1.45),('5815','2013-01-11','10:20:00',1.48),('5815','2013-01-11','10:25:00',1.53),('5815','2013-01-11','10:30:00',1.57),('5815','2013-01-11','10:35:00',1.58),('5815','2013-01-11','10:40:00',1.62),('5815','2013-01-11','10:45:00',1.64),('5815','2013-01-11','10:50:00',1.65),('5815','2013-01-11','10:55:00',1.66),('5815','2013-01-11','11:00:00',1.63),('5815','2013-01-11','11:05:00',1.73),('5815','2013-01-11','11:10:00',1.72),('5815','2013-01-11','11:15:00',1.74),('5815','2013-01-11','11:20:00',1.75),('5815','2013-01-11','11:25:00',1.78),('5815','2013-01-11','11:30:00',1.78),('5815','2013-01-11','11:35:00',1.79),('5815','2013-01-11','11:40:00',1.79),('5815','2013-01-11','11:45:00',1.8),('5815','2013-01-11','11:50:00',1.82),('5815','2013-01-11','11:55:00',1.84),('5815','2013-01-11','12:00:00',1.84),('5815','2013-01-11','12:05:00',1.84),('5815','2013-01-11','12:10:00',1.82),('5815','2013-01-11','12:15:00',1.81),('5815','2013-01-11','12:20:00',1.8),('5815','2013-01-11','12:25:00',1.77),('5815','2013-01-11','12:30:00',1.8),('5815','2013-01-11','12:35:00',1.56),('5815','2013-01-11','12:40:00',1.36),('5815','2013-01-11','12:50:00',1.26),('5815','2013-01-11','12:55:00',1.25),('5815','2013-01-11','13:00:00',1.6),('5815','2013-01-11','13:05:00',1.73),('5815','2013-01-11','13:10:00',1.55),('5815','2013-01-11','13:25:00',1.41),('5815','2013-01-11','13:30:00',1.7),('5815','2013-01-11','13:35:00',1.66),('5815','2013-01-11','13:50:00',1.09),('5815','2013-01-11','13:55:00',1.71),('5815','2013-01-11','14:00:00',1.16),('5815','2013-01-11','14:10:00',1.6),('5815','2013-01-11','14:15:00',1.6),('5815','2013-01-11','14:20:00',1.47),('5815','2013-01-11','14:25:00',1.43),('5815','2013-01-11','14:30:00',1.36),('5815','2013-01-11','14:35:00',1.33),('5815','2013-01-11','14:40:00',1.32),('5815','2013-01-11','14:45:00',1.28),('5815','2013-01-11','14:50:00',1.2),('5815','2013-01-11','14:55:00',1.17),('5815','2013-01-11','15:00:00',1.12),('5815','2013-01-11','15:05:00',1.06),('5815','2013-01-10','10:15:00',1.16),('5815','2013-01-10','10:25:00',1.53),('5815','2013-01-10','10:30:00',1.54),('5815','2013-01-10','10:35:00',1.56),('5815','2013-01-10','10:40:00',1.58),('5815','2013-01-10','10:45:00',1.6),('5815','2013-01-10','10:50:00',1.64),('5815','2013-01-10','10:55:00',1.66),('5815','2013-01-10','11:00:00',1.69),('5815','2013-01-10','11:05:00',1.7),('5815','2013-01-10','11:10:00',1.7),('5815','2013-01-10','11:15:00',1.68),('5815','2013-01-10','11:20:00',1.7),('5815','2013-01-10','11:25:00',1.27),('5815','2013-01-10','13:10:00',1.02),('5815','2013-01-10','13:35:00',1.46),('5815','2013-01-10','13:40:00',1.17),('5815','2013-01-10','13:45:00',1.49),('5815','2013-01-10','14:50:00',1.18),('5815','2013-01-10','14:55:00',1.13),('5815','2013-01-10','15:00:00',1.16),('5815','2013-01-10','15:05:00',1.16),('5815','2013-01-08','11:15:00',1.34),('5815','2013-01-08','11:20:00',1.07),('5815','2013-01-08','13:10:00',1.4),('5815','2013-01-07','08:55:00',1.02),('5815','2013-01-07','09:00:00',1.06),('5815','2013-01-07','09:05:00',1.08),('5815','2013-01-07','09:20:00',1.08),('5815','2013-01-07','09:25:00',1.16),('5815','2013-01-07','09:30:00',1.03),('5815','2013-01-07','09:40:00',1.22),('5815','2013-01-07','09:45:00',1.41),('5815','2013-01-07','09:50:00',1.47),('5815','2013-01-07','09:55:00',1.43),('5815','2013-01-07','10:00:00',1.3),('5815','2013-01-07','10:05:00',1.29),('5815','2013-01-07','10:10:00',1.34),('5815','2013-01-07','10:15:00',1.38),('5815','2013-01-07','10:20:00',1.31),('5815','2013-01-07','10:25:00',1.41),('5815','2013-01-07','10:30:00',1.41),('5815','2013-01-07','10:35:00',1.53),('5815','2013-01-07','10:40:00',1.63),('5815','2013-01-07','10:45:00',1.59),('5815','2013-01-07','10:50:00',1.64),('5815','2013-01-07','10:55:00',1.66),('5815','2013-01-07','11:00:00',1.63),('5815','2013-01-07','11:05:00',1.71),('5815','2013-01-07','11:10:00',1.73),('5815','2013-01-07','11:15:00',1.73),('5815','2013-01-07','11:20:00',1.73),('5815','2013-01-07','11:25:00',1.75),('5815','2013-01-07','11:30:00',1.77),('5815','2013-01-07','11:35:00',1.79),('5815','2013-01-07','11:40:00',1.73),('5815','2013-01-07','11:45:00',2.01),('5815','2013-01-07','11:50:00',1.47),('5815','2013-01-07','11:55:00',1.08),('5815','2013-01-07','12:45:00',1.11),('5815','2013-01-07','12:50:00',1.54),('5815','2013-01-07','12:55:00',1.08),('5815','2013-01-06','09:25:00',1.04),('5815','2013-01-06','09:30:00',1.07),('5815','2013-01-06','09:35:00',1.12),('5815','2013-01-06','09:40:00',1.15),('5815','2013-01-06','09:45:00',1.21),('5815','2013-01-06','09:50:00',1.25),('5815','2013-01-06','09:55:00',1.3),('5815','2013-01-06','10:00:00',1.34),('5815','2013-01-06','10:05:00',1.4),('5815','2013-01-06','10:10:00',1.45),('5815','2013-01-06','10:15:00',1.49),('5815','2013-01-06','10:20:00',1.51),('5815','2013-01-06','10:25:00',1.55),('5815','2013-01-06','10:30:00',1.57),('5815','2013-01-06','10:35:00',1.58),('5815','2013-01-06','10:40:00',1.59),('5815','2013-01-06','10:45:00',1.6),('5815','2013-01-06','10:50:00',1.62),('5815','2013-01-06','10:55:00',1.6),('5815','2013-01-06','11:00:00',1.64),('5815','2013-01-06','11:05:00',1.64),('5815','2013-01-06','11:10:00',1.69),('5815','2013-01-06','11:15:00',1.72),('5815','2013-01-06','11:20:00',1.72),('5815','2013-01-06','11:25:00',1.74),('5815','2013-01-06','11:30:00',1.75),('5815','2013-01-06','11:35:00',1.76),('5815','2013-01-06','11:40:00',1.76),('5815','2013-01-06','11:45:00',1.77),('5815','2013-01-06','11:50:00',1.79),('5815','2013-01-06','11:55:00',1.81),('5815','2013-01-06','12:00:00',1.81),('5815','2013-01-06','12:05:00',1.81),('5815','2013-01-06','12:10:00',1.82),('5815','2013-01-06','12:15:00',1.81),('5815','2013-01-06','12:20:00',1.8),('5815','2013-01-06','12:25:00',1.81),('5815','2013-01-06','12:30:00',1.8),('5815','2013-01-06','12:35:00',1.79),('5815','2013-01-06','12:40:00',1.79),('5815','2013-01-06','12:45:00',1.78),('5815','2013-01-06','12:50:00',1.76),('5815','2013-01-06','12:55:00',1.76),('5815','2013-01-06','13:00:00',1.75),('5815','2013-01-06','13:05:00',1.73),('5815','2013-01-06','13:10:00',1.71),('5815','2013-01-06','13:15:00',1.68),('5815','2013-01-06','13:20:00',1.68),('5815','2013-01-06','13:25:00',1.67),('5815','2013-01-06','13:30:00',1.64),('5815','2013-01-06','13:35:00',1.63),('5815','2013-01-06','13:40:00',1.6),('5815','2013-01-06','13:45:00',1.59),('5815','2013-01-06','13:50:00',1.56),('5815','2013-01-06','13:55:00',1.55),('5815','2013-01-06','14:00:00',1.54),('5815','2013-01-06','14:05:00',1.51),('5815','2013-01-06','14:10:00',1.47),('5815','2013-01-06','14:15:00',1.44),('5815','2013-01-06','14:20:00',1.44),('5815','2013-01-06','14:25:00',1.39),('5815','2013-01-06','14:30:00',1.35),('5815','2013-01-06','14:35:00',1.32),('5815','2013-01-06','14:40:00',1.29),('5815','2013-01-06','14:45:00',1.25),('5815','2013-01-06','14:50:00',1.23),('5815','2013-01-06','14:55:00',1.15),('5815','2013-01-06','15:00:00',1.09),('5815','2013-01-06','15:05:00',1.06),('5815','2013-01-06','15:10:00',1.02),('5815','2013-01-05','09:15:00',1.01),('5815','2013-01-05','09:20:00',1.06),('5815','2013-01-05','09:25:00',1.11),('5815','2013-01-05','09:30:00',1.15),('5815','2013-01-05','09:35:00',1.19),('5815','2013-01-05','09:40:00',1.23),('5815','2013-01-05','09:45:00',1.27),('5815','2013-01-05','09:50:00',1.32),('5815','2013-01-05','09:55:00',1.33),('5815','2013-01-05','10:00:00',1.37),('5815','2013-01-05','10:05:00',1.39),('5815','2013-01-05','10:10:00',1.43),('5815','2013-01-05','10:15:00',1.47),('5815','2013-01-05','10:20:00',1.48),('5815','2013-01-05','10:25:00',1.54),('5815','2013-01-05','10:30:00',1.57),('5815','2013-01-05','10:35:00',1.6),('5815','2013-01-05','10:40:00',1.63),('5815','2013-01-05','10:45:00',1.65),('5815','2013-01-05','10:50:00',1.66),('5815','2013-01-05','10:55:00',1.68),('5815','2013-01-05','11:00:00',1.69),('5815','2013-01-05','11:05:00',1.71),('5815','2013-01-05','11:10:00',1.73),('5815','2013-01-05','11:15:00',1.74),('5815','2013-01-05','11:20:00',1.76),('5815','2013-01-05','11:25:00',1.78),('5815','2013-01-05','11:30:00',1.77),('5815','2013-01-05','11:35:00',1.8),('5815','2013-01-05','11:40:00',1.8),('5815','2013-01-05','11:45:00',1.81),('5815','2013-01-05','11:50:00',1.82),('5815','2013-01-05','11:55:00',1.83),('5815','2013-01-05','12:00:00',1.84),('5815','2013-01-05','12:05:00',1.85),('5815','2013-01-05','12:10:00',1.84),('5815','2013-01-05','12:15:00',1.84),('5815','2013-01-05','12:20:00',1.84),('5815','2013-01-05','12:25:00',1.81),('5815','2013-01-05','12:30:00',1.81),('5815','2013-01-05','12:35:00',1.79),('5815','2013-01-05','12:40:00',1.8),('5815','2013-01-05','12:45:00',1.79),('5815','2013-01-05','12:50:00',1.81),('5815','2013-01-05','12:55:00',1.81),('5815','2013-01-05','13:00:00',1.78),('5815','2013-01-05','13:05:00',1.81),('5815','2013-01-05','13:10:00',1.8),('5815','2013-01-05','13:15:00',1.77),('5815','2013-01-05','13:20:00',1.75),('5815','2013-01-05','13:25:00',1.74),('5815','2013-01-05','13:30:00',1.72),('5815','2013-01-05','13:35:00',1.71),('5815','2013-01-05','13:40:00',1.69),('5815','2013-01-05','13:45:00',1.66),('5815','2013-01-05','13:50:00',1.63),('5815','2013-01-05','13:55:00',1.58),('5815','2013-01-05','14:00:00',1.6),('5815','2013-01-05','14:05:00',1.49),('5815','2013-01-05','14:10:00',1.33),('5815','2013-01-05','14:15:00',1.07),('5815','2013-01-05','14:20:00',1.32),('5815','2013-01-05','14:25:00',1.34),('5815','2013-01-05','14:30:00',1.35),('5815','2013-01-05','14:35:00',1.29),('5815','2013-01-05','14:40:00',1.24),('5815','2013-01-05','14:45:00',1.23),('5815','2013-01-05','14:50:00',1.17),('5815','2013-01-05','14:55:00',1.1),('5815','2013-01-05','15:00:00',1.05),('5815','2013-01-05','15:05:00',1.01),('5815','2013-01-04','10:55:00',1.44),('5815','2013-01-04','11:00:00',1.21),('5815','2013-01-04','11:05:00',1.45),('5815','2013-01-04','11:10:00',1.4),('5815','2013-01-04','11:15:00',1.19),('5815','2013-01-04','11:20:00',1.57),('5815','2013-01-04','11:25:00',1.62),('5815','2013-01-04','11:30:00',1.6),('5815','2013-01-04','11:35:00',1.46),('5815','2013-01-04','11:40:00',1.31),('5815','2013-01-04','11:45:00',1.3),('5815','2013-01-04','11:50:00',1.13),('5815','2013-01-04','11:55:00',1.02),('5815','2013-01-04','12:35:00',1.04),('5815','2013-01-04','12:40:00',1.27),('5815','2013-01-04','12:45:00',1.41),('5815','2013-01-04','13:30:00',1.14),('5815','2013-01-04','13:35:00',1.01),('5815','2013-01-04','14:05:00',1.05),('5815','2013-01-03','09:55:00',1.22),('5815','2013-01-03','10:00:00',1.43),('5815','2013-01-03','10:05:00',1.46),('5815','2013-01-03','10:10:00',1.24),('5815','2013-01-03','10:15:00',1.46),('5815','2013-01-03','10:20:00',1.21),('5815','2013-01-03','10:25:00',1.54),('5815','2013-01-03','10:30:00',1.58),('5815','2013-01-03','10:35:00',1.6),('5815','2013-01-03','10:40:00',1.64),('5815','2013-01-03','10:45:00',1.7),('5815','2013-01-03','10:50:00',1.77),('5815','2013-01-03','10:55:00',1.78),('5815','2013-01-03','11:00:00',1.55),('5815','2013-01-03','11:45:00',1.17),('5815','2013-01-03','11:50:00',1.74),('5815','2013-01-03','11:55:00',1.99),('5815','2013-01-03','12:00:00',1.99),('5815','2013-01-03','12:05:00',1.7),('5815','2013-01-03','12:10:00',1.34),('5815','2013-01-03','12:30:00',1.34),('5815','2013-01-03','12:35:00',1.25),('5815','2013-01-03','12:40:00',1.77),('5815','2013-01-03','12:45:00',1.88),('5815','2013-01-03','12:50:00',1.87),('5815','2013-01-03','12:55:00',1.86),('5815','2013-01-03','13:00:00',1.8),('5815','2013-01-03','13:05:00',1.74),('5815','2013-01-03','13:10:00',1.73),('5815','2013-01-03','13:15:00',1.52),('5815','2013-01-03','13:20:00',1.69),('5815','2013-01-03','13:25:00',1.66),('5815','2013-01-03','13:30:00',1.64),('5815','2013-01-03','13:35:00',1.6),('5815','2013-01-03','13:40:00',1.58),('5815','2013-01-03','13:45:00',1.53),('5815','2013-01-03','13:50:00',1.47),('5815','2013-01-03','13:55:00',1.45),('5815','2013-01-03','14:00:00',1.42),('5815','2013-01-03','14:05:00',1.41),('5815','2013-01-03','14:10:00',1.41),('5815','2013-01-03','14:15:00',1.37),('5815','2013-01-03','14:20:00',1.32),('5815','2013-01-03','14:25:00',1.28),('5815','2013-01-03','14:30:00',1.23),('5815','2013-01-03','14:35:00',1.21),('5815','2013-01-03','14:40:00',1.19),('5815','2013-01-03','14:45:00',1.15),('5815','2013-01-03','14:50:00',1.08),('5815','2013-01-03','14:55:00',1.08),('5815','2013-01-03','15:00:00',1.04),('5815','2013-01-02','09:20:00',1.05),('5815','2013-01-02','09:25:00',1.09),('5815','2013-01-02','09:30:00',1.14),('5815','2013-01-02','09:35:00',1.19),('5815','2013-01-02','09:40:00',1.27),('5815','2013-01-02','09:45:00',1.37),('5815','2013-01-02','09:50:00',1.47),('5815','2013-01-02','09:55:00',1.56),('5815','2013-01-02','10:00:00',1.64),('5815','2013-01-02','10:05:00',1.58),('5815','2013-01-02','10:10:00',1.68),('5815','2013-01-02','10:15:00',1.8),('5815','2013-01-02','10:20:00',1.38),('5815','2013-01-02','10:25:00',1.31),('5815','2013-01-02','10:30:00',1.23),('5815','2013-01-02','10:35:00',1.33),('5815','2013-01-02','10:40:00',1.16),('5815','2013-01-02','10:45:00',1.06),('5815','2013-01-02','10:50:00',1.02),('5815','2013-01-02','11:00:00',1.05),('5815','2013-01-02','11:05:00',1.03),('5815','2013-01-02','11:35:00',1.68),('5815','2013-01-02','11:40:00',1.93),('5815','2013-01-02','11:45:00',1.92),('5815','2013-01-02','11:50:00',1.88),('5815','2013-01-02','11:55:00',1.86),('5815','2013-01-02','12:00:00',1.85),('5815','2013-01-02','12:05:00',1.85),('5815','2013-01-02','12:10:00',1.85),('5815','2013-01-02','12:15:00',1.84),('5815','2013-01-02','12:20:00',1.84),('5815','2013-01-02','12:25:00',1.84),('5815','2013-01-02','12:30:00',1.84),('5815','2013-01-02','12:35:00',1.84),('5815','2013-01-02','12:40:00',1.83),('5815','2013-01-02','12:45:00',1.82),('5815','2013-01-02','12:50:00',1.8),('5815','2013-01-02','12:55:00',1.8),('5815','2013-01-02','13:00:00',1.78),('5815','2013-01-02','13:05:00',1.77),('5815','2013-01-02','13:10:00',1.75),('5815','2013-01-02','13:15:00',1.73),('5815','2013-01-02','13:20:00',1.72),('5815','2013-01-02','13:25:00',1.7),('5815','2013-01-02','13:30:00',1.67),('5815','2013-01-02','13:35:00',1.66),('5815','2013-01-02','13:40:00',1.64),('5815','2013-01-02','13:45:00',1.62),('5815','2013-01-02','13:50:00',1.6),('5815','2013-01-02','13:55:00',1.57),('5815','2013-01-02','14:00:00',1.55),('5815','2013-01-02','14:05:00',1.52),('5815','2013-01-02','14:10:00',1.5),('5815','2013-01-02','14:15:00',1.47),('5815','2013-01-02','14:20:00',1.44),('5815','2013-01-02','14:25:00',1.4),('5815','2013-01-02','14:30:00',1.36),('5815','2013-01-02','14:35:00',1.3),('5815','2013-01-02','14:40:00',1.28),('5815','2013-01-02','14:45:00',1.24),('5815','2013-01-02','14:50:00',1.2),('5815','2013-01-02','14:55:00',1.16),('5815','2013-01-02','15:00:00',1.11),('5815','2013-01-02','15:05:00',1.05),('5815','2013-01-02','15:10:00',1),('5815','2012-12-31','09:25:00',1.04),('5815','2012-12-31','09:30:00',1.08),('5815','2012-12-31','09:35:00',1.12),('5815','2012-12-31','09:40:00',1.16),('5815','2012-12-31','09:45:00',1.2),('5815','2012-12-31','09:50:00',1.24),('5815','2012-12-31','09:55:00',1.28),('5815','2012-12-31','10:00:00',1.29),('5815','2012-12-31','10:05:00',1.33),('5815','2012-12-31','10:10:00',1.37),('5815','2012-12-31','10:15:00',1.4),('5815','2012-12-31','10:20:00',1.44),('5815','2012-12-31','10:25:00',1.47),('5815','2012-12-31','10:30:00',1.5),('5815','2012-12-31','10:35:00',1.53),('5815','2012-12-31','10:40:00',1.57),('5815','2012-12-31','10:45:00',1.49),('5815','2012-12-31','10:50:00',1.39),('5815','2012-12-31','11:05:00',1.72),('5815','2012-12-31','11:10:00',1.76),('5815','2012-12-31','11:15:00',1.74),('5815','2012-12-31','11:20:00',1.32),('5815','2012-12-31','11:25:00',1.48),('5815','2012-12-31','11:30:00',1.9),('5815','2012-12-31','11:45:00',1.56),('5815','2012-12-31','11:50:00',1.72),('5815','2012-12-31','11:55:00',1.68),('5815','2012-12-30','09:20:00',1.1),('5815','2012-12-30','09:25:00',1.21),('5815','2012-12-30','09:30:00',1.04),('5815','2012-12-30','10:10:00',1.19),('5815','2012-12-30','10:15:00',1.62),('5815','2012-12-30','10:20:00',1.63),('5815','2012-12-30','10:25:00',1.63),('5815','2012-12-30','10:30:00',1.64),('5815','2012-12-30','10:35:00',1.65),('5815','2012-12-30','10:40:00',1.68),('5815','2012-12-30','10:45:00',1.67),('5815','2012-12-30','10:50:00',1.66),('5815','2012-12-30','10:55:00',1.69),('5815','2012-12-30','11:00:00',1.72),('5815','2012-12-30','11:05:00',1.73),('5815','2012-12-30','11:10:00',1.69),('5815','2012-12-30','11:15:00',1.69),('5815','2012-12-30','11:20:00',1.76),('5815','2012-12-30','11:25:00',1.8),('5815','2012-12-30','11:30:00',1.82),('5815','2012-12-30','11:35:00',1.82),('5815','2012-12-30','11:40:00',1.85),('5815','2012-12-30','11:45:00',1.85),('5815','2012-12-30','11:50:00',1.85),('5815','2012-12-30','11:55:00',1.86),('5815','2012-12-30','12:00:00',1.89),('5815','2012-12-30','12:05:00',1.91),('5815','2012-12-30','12:10:00',1.91),('5815','2012-12-30','12:15:00',1.91),('5815','2012-12-30','12:20:00',1.9),('5815','2012-12-30','12:25:00',1.89),('5815','2012-12-30','12:30:00',1.88),('5815','2012-12-30','12:35:00',1.88),('5815','2012-12-30','12:40:00',1.87),('5815','2012-12-30','12:45:00',1.85),('5815','2012-12-30','12:50:00',1.83),('5815','2012-12-30','12:55:00',1.84),('5815','2012-12-30','13:00:00',1.82),('5815','2012-12-30','13:05:00',1.81),('5815','2012-12-30','13:10:00',1.8),('5815','2012-12-30','13:15:00',1.78),('5815','2012-12-30','13:20:00',1.76),('5815','2012-12-30','13:25:00',1.75),('5815','2012-12-30','13:30:00',1.72),('5815','2012-12-30','13:35:00',1.7),('5815','2012-12-30','13:40:00',1.67),('5815','2012-12-30','13:45:00',1.64),('5815','2012-12-30','13:50:00',1.61),('5815','2012-12-30','13:55:00',1.59),('5815','2012-12-30','14:00:00',1.57),('5815','2012-12-30','14:05:00',1.53),('5815','2012-12-30','14:10:00',1.5),('5815','2012-12-30','14:15:00',1.46),('5815','2012-12-30','14:20:00',1.41),('5815','2012-12-30','14:25:00',1.39),('5815','2012-12-30','14:30:00',1.37),('5815','2012-12-30','14:35:00',1.33),('5815','2012-12-30','14:40:00',1.29),('5815','2012-12-30','14:45:00',1.25),('5815','2012-12-30','14:50:00',1.21),('5815','2012-12-30','14:55:00',1.16),('5815','2012-12-30','15:00:00',1.1),('5815','2012-12-30','15:05:00',1.06),('5815','2012-12-30','15:10:00',1.01),('5815','2012-12-29','09:15:00',1.02),('5815','2012-12-29','09:20:00',1.07),('5815','2012-12-29','09:25:00',1.12),('5815','2012-12-29','09:30:00',1.16),('5815','2012-12-29','09:35:00',1.2),('5815','2012-12-29','09:40:00',1.25),('5815','2012-12-29','09:45:00',1.29),('5815','2012-12-29','09:50:00',1.31),('5815','2012-12-29','09:55:00',1.35),('5815','2012-12-29','10:00:00',1.39),('5815','2012-12-29','10:05:00',1.43),('5815','2012-12-29','10:10:00',1.47),('5815','2012-12-29','10:15:00',1.49),('5815','2012-12-29','10:20:00',1.53),('5815','2012-12-29','10:25:00',1.56),('5815','2012-12-29','10:30:00',1.59),('5815','2012-12-29','10:35:00',1.62),('5815','2012-12-29','10:40:00',1.64),('5815','2012-12-29','10:45:00',1.67),('5815','2012-12-29','10:50:00',1.68),('5815','2012-12-29','10:55:00',1.7),('5815','2012-12-29','11:00:00',1.71),('5815','2012-12-29','11:05:00',1.73),('5815','2012-12-29','11:10:00',1.75),('5815','2012-12-29','11:15:00',1.77),('5815','2012-12-29','11:20:00',1.78),('5815','2012-12-29','11:25:00',1.78),('5815','2012-12-29','11:30:00',1.79),('5815','2012-12-29','11:35:00',1.82),('5815','2012-12-29','11:40:00',1.82),('5815','2012-12-29','11:45:00',1.84),('5815','2012-12-29','11:50:00',1.84),('5815','2012-12-29','11:55:00',1.84),('5815','2012-12-29','12:00:00',1.84),('5815','2012-12-29','12:05:00',1.84),('5815','2012-12-29','12:10:00',1.84),('5815','2012-12-29','12:15:00',1.84),('5815','2012-12-29','12:20:00',1.83),('5815','2012-12-29','12:25:00',1.83),('5815','2012-12-29','12:30:00',1.83),('5815','2012-12-29','12:35:00',1.81),('5815','2012-12-29','12:40:00',1.81),('5815','2012-12-29','12:45:00',1.78),('5815','2012-12-29','12:50:00',1.78),('5815','2012-12-29','12:55:00',1.79),('5815','2012-12-29','13:00:00',1.78),('5815','2012-12-29','13:05:00',1.81),('5815','2012-12-29','13:10:00',1.8),('5815','2012-12-29','13:15:00',1.79),('5815','2012-12-29','13:20:00',1.76),('5815','2012-12-29','13:25:00',1.75),('5815','2012-12-29','13:30:00',1.73),('5815','2012-12-29','13:35:00',1.71),('5815','2012-12-29','13:40:00',1.69),('5815','2012-12-29','13:45:00',1.67),('5815','2012-12-29','13:50:00',1.65),('5815','2012-12-29','13:55:00',1.62),('5815','2012-12-29','14:00:00',1.61),('5815','2012-12-29','14:05:00',1.57),('5815','2012-12-29','14:10:00',1.53),('5815','2012-12-29','14:15:00',1.5),('5815','2012-12-29','14:20:00',1.47),('5815','2012-12-29','14:25:00',1.43),('5815','2012-12-29','14:30:00',1.39),('5815','2012-12-29','14:35:00',1.36),('5815','2012-12-29','14:40:00',1.31),('5815','2012-12-29','14:45:00',1.27),('5815','2012-12-29','14:50:00',1.22),('5815','2012-12-29','14:55:00',1.17),('5815','2012-12-29','15:00:00',1.12),('5815','2012-12-29','15:05:00',1.06),('5815','2012-12-29','15:10:00',1.01),('5815','2012-12-28','09:15:00',1.04),('5815','2012-12-28','09:20:00',1.09),('5815','2012-12-28','09:25:00',1.12),('5815','2012-12-28','09:30:00',1.16),('5815','2012-12-28','09:35:00',1.2),('5815','2012-12-28','09:40:00',1.25),('5815','2012-12-28','09:45:00',1.3),('5815','2012-12-28','09:50:00',1.35),('5815','2012-12-28','09:55:00',1.39),('5815','2012-12-28','10:00:00',1.44),('5815','2012-12-28','10:05:00',1.47),('5815','2012-12-28','10:10:00',1.5),('5815','2012-12-28','10:15:00',1.54),('5815','2012-12-28','10:20:00',1.57),('5815','2012-12-28','10:25:00',1.6),('5815','2012-12-28','10:30:00',1.63),('5815','2012-12-28','10:35:00',1.65),('5815','2012-12-28','10:40:00',1.68),('5815','2012-12-28','10:45:00',1.7),('5815','2012-12-28','10:50:00',1.73),('5815','2012-12-28','10:55:00',1.76),('5815','2012-12-28','11:00:00',1.75),('5815','2012-12-28','11:05:00',1.79),('5815','2012-12-28','11:10:00',1.79),('5815','2012-12-28','11:15:00',1.82),('5815','2012-12-28','11:20:00',1.84),('5815','2012-12-28','11:25:00',1.86),('5815','2012-12-28','11:30:00',1.85),('5815','2012-12-28','11:35:00',1.87),('5815','2012-12-28','11:40:00',1.86),('5815','2012-12-28','11:45:00',1.87),('5815','2012-12-28','11:50:00',1.88),('5815','2012-12-28','11:55:00',1.88),('5815','2012-12-28','12:00:00',1.89),('5815','2012-12-28','12:05:00',1.91),('5815','2012-12-28','12:10:00',1.92),('5815','2012-12-28','12:15:00',1.89),('5815','2012-12-28','12:20:00',1.88),('5815','2012-12-28','12:25:00',1.86),('5815','2012-12-28','12:30:00',1.85),('5815','2012-12-28','12:35:00',1.87),('5815','2012-12-28','12:40:00',1.88),('5815','2012-12-28','12:45:00',1.85),('5815','2012-12-28','12:50:00',1.82),('5815','2012-12-28','12:55:00',1.82),('5815','2012-12-28','13:00:00',1.82),('5815','2012-12-28','13:05:00',1.82),('5815','2012-12-28','13:10:00',1.81),('5815','2012-12-28','13:15:00',1.81),('5815','2012-12-28','13:20:00',1.79),('5815','2012-12-28','13:25:00',1.76),('5815','2012-12-28','13:30:00',1.74),('5815','2012-12-28','13:35:00',1.73),('5815','2012-12-28','13:40:00',1.71),('5815','2012-12-28','13:45:00',1.66),('5815','2012-12-28','13:50:00',1.66),('5815','2012-12-28','13:55:00',1.63),('5815','2012-12-28','14:00:00',1.61),('5815','2012-12-28','14:05:00',1.58),('5815','2012-12-28','14:10:00',1.54),('5815','2012-12-28','14:15:00',1.52),('5815','2012-12-28','14:20:00',1.5),('5815','2012-12-28','14:25:00',1.46),('5815','2012-12-28','14:30:00',1.41),('5815','2012-12-28','14:35:00',1.37),('5815','2012-12-28','14:40:00',1.33),('5815','2012-12-28','14:45:00',1.3),('5815','2012-12-28','14:50:00',1.26),('5815','2012-12-28','14:55:00',1.21),('5815','2012-12-28','15:00:00',1.17),('5815','2012-12-28','15:05:00',1.12),('5815','2012-12-28','15:10:00',1.07),('5815','2012-12-28','15:15:00',1.01),('5815','2012-12-27','09:25:00',1.02),('5815','2012-12-27','09:30:00',1.07),('5815','2012-12-27','09:35:00',1.11),('5815','2012-12-27','09:40:00',1.16),('5815','2012-12-27','09:45:00',1.19),('5815','2012-12-27','09:50:00',1.17),('5815','2012-12-27','09:55:00',1.26),('5815','2012-12-27','10:00:00',1.29),('5815','2012-12-27','10:05:00',1.33),('5815','2012-12-27','10:10:00',1.39),('5815','2012-12-27','10:15:00',1.44),('5815','2012-12-27','10:20:00',1.46),('5815','2012-12-27','10:25:00',1.5),('5815','2012-12-27','10:30:00',1.52),('5815','2012-12-27','10:35:00',1.57),('5815','2012-12-27','10:40:00',1.57),('5815','2012-12-27','10:45:00',1.61),('5815','2012-12-27','10:50:00',1.63),('5815','2012-12-27','10:55:00',1.65),('5815','2012-12-27','11:00:00',1.68),('5815','2012-12-27','11:05:00',1.73),('5815','2012-12-27','11:10:00',1.64),('5815','2012-12-27','11:15:00',1.49),('5815','2012-12-27','11:20:00',1.76),('5815','2012-12-27','11:25:00',1.78),('5815','2012-12-27','11:30:00',1.78),('5815','2012-12-27','11:35:00',1.81),('5815','2012-12-27','11:40:00',1.81),('5815','2012-12-27','11:45:00',1.85),('5815','2012-12-27','11:50:00',1.74),('5815','2012-12-27','11:55:00',1.85),('5815','2012-12-27','12:00:00',1.85),('5815','2012-12-27','12:05:00',1.85),('5815','2012-12-27','12:10:00',1.83),('5815','2012-12-27','12:15:00',1.83),('5815','2012-12-27','12:20:00',1.82),('5815','2012-12-27','12:25:00',1.82),('5815','2012-12-27','12:30:00',1.8),('5815','2012-12-27','12:35:00',1.78),('5815','2012-12-27','12:40:00',1.54),('5815','2012-12-27','12:45:00',1.75),('5815','2012-12-27','12:50:00',1.8),('5815','2012-12-27','12:55:00',1.76),('5815','2012-12-27','13:00:00',1.71),('5815','2012-12-27','13:05:00',1.72),('5815','2012-12-27','13:10:00',1.67),('5815','2012-12-27','13:15:00',1.67),('5815','2012-12-27','13:20:00',1.65),('5815','2012-12-27','13:25:00',1.64),('5815','2012-12-27','13:30:00',1.62),('5815','2012-12-27','13:35:00',1.59),('5815','2012-12-27','13:40:00',1.57),('5815','2012-12-27','13:45:00',1.56),('5815','2012-12-27','13:50:00',1.54),('5815','2012-12-27','13:55:00',1.51),('5815','2012-12-27','14:00:00',1.48),('5815','2012-12-27','14:05:00',1.42),('5815','2012-12-27','14:10:00',1.36),('5815','2012-12-27','14:15:00',1.18),('5815','2012-12-27','14:20:00',1.34),('5815','2012-12-27','14:25:00',1.3),('5815','2012-12-27','14:30:00',1.25),('5815','2012-12-27','14:35:00',1.16),('5815','2012-12-27','14:45:00',1.12),('5815','2012-12-27','14:50:00',1.08),('5815','2012-12-27','14:55:00',1.04),('5815','2012-12-27','15:00:00',1.02),('5815','2012-12-26','09:40:00',1.17),('5815','2012-12-26','09:45:00',1.23),('5815','2012-12-26','09:50:00',1.27),('5815','2012-12-26','10:15:00',1.05),('5815','2012-12-26','10:20:00',1.34),('5815','2012-12-26','10:25:00',1.42),('5815','2012-12-26','10:30:00',1.38),('5815','2012-12-26','10:35:00',1.45),('5815','2012-12-26','10:40:00',1.49),('5815','2012-12-26','10:45:00',1.49),('5815','2012-12-26','10:50:00',1.53),('5815','2012-12-26','10:55:00',1.45),('5815','2012-12-26','11:00:00',1.48),('5815','2012-12-26','11:05:00',1.37),('5815','2012-12-26','11:50:00',1.08),('5815','2012-12-26','11:55:00',1.7),('5815','2012-12-26','12:00:00',1.76),('5815','2012-12-26','12:05:00',1.85),('5815','2012-12-26','12:10:00',1.95),('5815','2012-12-26','12:15:00',1.78),('5815','2012-12-26','12:25:00',1.69),('5815','2012-12-26','12:30:00',1.77),('5815','2012-12-26','12:35:00',1.77),('5815','2012-12-26','12:40:00',1.77),('5815','2012-12-26','12:45:00',1.79),('5815','2012-12-26','12:55:00',1.82),('5815','2012-12-26','13:00:00',1.85),('5815','2012-12-26','13:05:00',1.4),('5815','2012-12-26','14:15:00',1.18),('5815','2012-12-26','14:20:00',1.34),('5815','2012-12-26','14:25:00',1.34),('5815','2012-12-26','14:30:00',1.29),('5815','2012-12-26','14:35:00',1.26),('5815','2012-12-26','14:40:00',1.21),('5815','2012-12-26','14:45:00',1.09),('5815','2012-12-26','15:00:00',1.07),('5815','2012-12-26','15:05:00',1.01),('5815','2012-12-25','09:20:00',1.04),('5815','2012-12-25','09:25:00',1.07),('5815','2012-12-25','09:30:00',1.1),('5815','2012-12-25','09:35:00',1.13),('5815','2012-12-25','09:40:00',1.17),('5815','2012-12-25','09:45:00',1.21),('5815','2012-12-25','09:50:00',1.25),('5815','2012-12-25','09:55:00',1.29),('5815','2012-12-25','10:00:00',1.32),('5815','2012-12-25','10:05:00',1.35),('5815','2012-12-25','10:10:00',1.38),('5815','2012-12-25','10:15:00',1.4),('5815','2012-12-25','10:20:00',1.42),('5815','2012-12-25','10:25:00',1.43),('5815','2012-12-25','10:30:00',1.46),('5815','2012-12-25','10:35:00',1.48),('5815','2012-12-25','10:40:00',1.51),('5815','2012-12-25','10:45:00',1.52),('5815','2012-12-25','10:50:00',1.53),('5815','2012-12-25','10:55:00',1.56),('5815','2012-12-25','11:00:00',1.57),('5815','2012-12-25','11:05:00',1.6),('5815','2012-12-25','11:10:00',1.6),('5815','2012-12-25','11:15:00',1.62),('5815','2012-12-25','11:20:00',1.63),('5815','2012-12-25','11:25:00',1.65),('5815','2012-12-25','11:30:00',1.64),('5815','2012-12-25','11:35:00',1.67),('5815','2012-12-25','11:40:00',1.69),('5815','2012-12-25','11:45:00',1.69),('5815','2012-12-25','11:50:00',1.71),('5815','2012-12-25','11:55:00',1.75),('5815','2012-12-25','12:00:00',1.79),('5815','2012-12-25','12:05:00',1.8),('5815','2012-12-25','12:10:00',1.79),('5815','2012-12-25','12:15:00',1.81),('5815','2012-12-25','12:20:00',1.82),('5815','2012-12-25','12:25:00',1.83),('5815','2012-12-25','12:30:00',1.83),('5815','2012-12-25','12:35:00',1.81),('5815','2012-12-25','12:40:00',1.83),('5815','2012-12-25','12:45:00',1.8),('5815','2012-12-25','12:50:00',1.77),('5815','2012-12-25','12:55:00',1.78),('5815','2012-12-25','13:00:00',1.8),('5815','2012-12-25','13:05:00',1.78),('5815','2012-12-25','13:10:00',1.8),('5815','2012-12-25','13:15:00',1.77),('5815','2012-12-25','13:20:00',1.83),('5815','2012-12-25','13:25:00',1.84),('5815','2012-12-25','13:30:00',1.96),('5815','2012-12-25','13:35:00',1.89),('5815','2012-12-25','13:40:00',1.87),('5815','2012-12-25','13:45:00',1.8),('5815','2012-12-25','13:50:00',1.54),('5815','2012-12-25','13:55:00',1.56),('5815','2012-12-25','14:00:00',1.42),('5815','2012-12-25','14:05:00',1.54),('5815','2012-12-22','09:15:00',1),('5815','2012-12-22','09:20:00',1.04),('5815','2012-12-22','09:25:00',1.11),('5815','2012-12-22','09:30:00',1.12),('5815','2012-12-22','09:35:00',1.18),('5815','2012-12-22','09:40:00',1.23),('5815','2012-12-22','09:45:00',1.26),('5815','2012-12-22','09:50:00',1.29),('5815','2012-12-22','09:55:00',1.31),('5815','2012-12-22','10:00:00',1.33),('5815','2012-12-22','10:05:00',1.38),('5815','2012-12-22','10:10:00',1.41),('5815','2012-12-22','10:15:00',1.43),('5815','2012-12-22','10:20:00',1.47),('5815','2012-12-22','10:25:00',1.49),('5815','2012-12-22','10:30:00',1.48),('5815','2012-12-22','10:35:00',1.54),('5815','2012-12-22','10:40:00',1.56),('5815','2012-12-22','10:45:00',1.59),('5815','2012-12-22','10:50:00',1.6),('5815','2012-12-22','10:55:00',1.52),('5815','2012-12-22','11:00:00',1.63),('5815','2012-12-22','11:05:00',1.65),('5815','2012-12-22','11:10:00',1.65),('5815','2012-12-22','11:15:00',1.67),('5815','2012-12-22','11:20:00',1.73),('5815','2012-12-22','11:25:00',1.58),('5815','2012-12-22','11:30:00',1.68),('5815','2012-12-22','11:35:00',1.76),('5815','2012-12-22','11:40:00',1.76),('5815','2012-12-22','11:45:00',1.73),('5815','2012-12-22','11:50:00',1.77),('5815','2012-12-22','11:55:00',1.65),('5815','2012-12-22','12:00:00',1.54),('5815','2012-12-22','12:05:00',1.56),('5815','2012-12-22','12:10:00',1.57),('5815','2012-12-22','12:15:00',1.27),('5815','2012-12-22','12:20:00',1.19),('5815','2012-12-22','12:35:00',1.03),('5815','2012-12-22','12:50:00',1.15),('5815','2012-12-22','12:55:00',1.53),('5815','2012-12-22','13:00:00',1.6),('5815','2012-12-22','13:05:00',1.36),('5815','2012-12-22','13:10:00',1.58),('5815','2012-12-22','13:40:00',1.19),('5815','2012-12-22','13:45:00',1.13),('5815','2012-12-22','13:50:00',1.01),('5815','2012-12-22','14:00:00',1.42),('5815','2012-12-22','14:05:00',1.21),('5815','2012-12-22','14:10:00',1.17),('5815','2012-12-22','14:15:00',1.21),('5815','2012-12-22','14:40:00',1.05),('5815','2012-12-22','14:45:00',1.11),('5815','2014-04-30','08:35:00',1.01),('5815','2014-04-30','08:40:00',1.06),('5815','2014-04-30','08:45:00',1.12),('5815','2014-04-30','08:50:00',1.22),('5815','2014-04-30','08:55:00',1.4),('5815','2014-04-30','09:10:00',1.06),('5815','2014-04-30','09:25:00',1.02),('5815','2014-04-30','09:30:00',1.66),('5815','2014-04-30','09:35:00',1.48),('5815','2014-04-30','09:45:00',1.05),('5815','2014-04-30','10:00:00',1.01),('5815','2014-04-30','10:05:00',1.54),('5815','2014-04-30','10:10:00',1.68),('5815','2014-04-30','10:15:00',1.81),('5815','2014-04-30','10:20:00',1.7),('5815','2014-04-30','10:25:00',2.11),('5815','2014-04-30','10:30:00',1.53),('5815','2014-04-30','10:45:00',2.38),('5815','2014-04-30','10:50:00',2.39),('5815','2014-04-30','10:55:00',1.86),('5815','2014-04-30','11:00:00',1.9),('5815','2014-04-30','11:15:00',1.64),('5815','2014-04-30','11:20:00',2.62),('5815','2014-04-30','11:25:00',1.95),('5815','2014-04-30','11:30:00',2.56),('5815','2014-04-30','11:35:00',1.91),('5815','2014-04-30','11:40:00',2.19),('5815','2014-04-30','11:45:00',2.56),('5815','2014-04-30','11:50:00',1.2),('5815','2014-04-30','11:55:00',2.41),('5815','2014-04-30','12:00:00',2.16),('5815','2014-04-30','12:05:00',2.8),('5815','2014-04-30','12:10:00',2.32),('5815','2014-04-30','12:15:00',1.79),('5815','2014-04-30','12:20:00',1.43),('5815','2014-04-30','12:25:00',2.39),('5815','2014-04-30','12:30:00',2.79),('5815','2014-04-30','12:35:00',2.77),('5815','2014-04-30','12:40:00',2.75),('5815','2014-04-30','12:45:00',2.69),('5815','2014-04-30','12:50:00',2.74),('5815','2014-04-30','12:55:00',2.7),('5815','2014-04-30','13:00:00',2.8),('5815','2014-04-30','13:05:00',2.73),('5815','2014-04-30','13:10:00',2.79),('5815','2014-04-30','13:15:00',2.75),('5815','2014-04-30','13:25:00',2.52),('5815','2014-04-30','13:30:00',2.93),('5815','2014-04-30','13:35:00',2.82),('5815','2014-04-30','13:40:00',2.57),('5815','2014-04-30','13:45:00',1.77),('5815','2014-04-30','13:50:00',1.47),('5815','2014-04-30','14:10:00',2.89),('5815','2014-04-30','14:15:00',2.79),('5815','2014-04-30','14:20:00',2.5),('5815','2014-04-30','14:25:00',2.73),('5815','2014-04-30','14:30:00',2.52),('5815','2014-04-30','14:35:00',2.52),('5815','2014-04-30','14:40:00',2.62),('5815','2014-04-30','14:45:00',1.94),('5815','2014-04-30','14:50:00',2.38),('5815','2014-04-30','14:55:00',2.54),('5815','2014-04-30','15:00:00',2.35),('5815','2014-04-30','15:05:00',2.65),('5815','2014-04-30','15:10:00',1.81),('5815','2014-04-30','15:15:00',2.42),('5815','2014-04-30','15:20:00',2.39),('5815','2014-04-30','15:25:00',2.34),('5815','2014-04-30','15:30:00',2.27),('5815','2014-04-30','15:35:00',2.21),('5815','2014-04-30','15:40:00',2.15),('5815','2014-04-30','15:45:00',2.18),('5815','2014-04-30','15:50:00',2.08),('5815','2014-04-30','15:55:00',2.07),('5815','2014-04-30','16:00:00',2.03),('5815','2014-04-30','16:05:00',2.03),('5815','2014-04-30','16:10:00',1.97),('5815','2014-04-30','16:15:00',1.91),('5815','2014-04-30','16:20:00',1.85),('5815','2014-04-30','16:25:00',1.66),('5815','2014-04-30','16:30:00',1.75),('5815','2014-04-30','16:35:00',1.74),('5815','2014-04-30','16:40:00',1.64),('5815','2014-04-30','16:45:00',1.4),('5815','2014-04-30','16:50:00',1.37),('5815','2014-04-30','16:55:00',1.43),('5815','2014-04-30','17:00:00',1.26),('5815','2014-04-30','17:05:00',1.41),('5815','2014-04-30','17:10:00',1.4),('5815','2014-04-30','17:15:00',1.31),('5815','2014-04-30','17:20:00',1.25),('5815','2014-04-30','17:25:00',1.15),('5815','2014-04-30','17:30:00',1.15),('5815','2014-04-30','17:35:00',1.11),('5815','2014-04-30','17:40:00',1.06),('5815','2012-12-21','10:25:00',1.4),('5815','2012-12-21','10:30:00',1.81),('5815','2012-12-21','10:35:00',1.9),('5815','2012-12-21','10:40:00',1.86),('5815','2012-12-21','10:45:00',1.82),('5815','2012-12-21','10:50:00',1.8),('5815','2012-12-21','10:55:00',1.83),('5815','2012-12-21','11:00:00',1.13),('5815','2012-12-21','11:50:00',1.48),('5815','2012-12-21','12:00:00',1.27),('5815','2012-12-21','12:50:00',1.18),('5815','2012-12-21','13:00:00',1.37),('5815','2012-12-21','13:05:00',1.94),('5815','2012-12-21','13:10:00',2.1),('5815','2012-12-21','13:15:00',2.08),('5815','2012-12-21','13:20:00',2.06),('5815','2012-12-21','13:25:00',2.01),('5815','2012-12-21','13:30:00',1.71),('5815','2012-12-21','13:35:00',1.79),('5815','2012-12-21','13:40:00',1.63),('5815','2012-12-21','14:15:00',1.03),('5815','2012-12-21','14:20:00',1.07),('5815','2012-12-21','15:00:00',1.01),('5815','2014-04-29','08:40:00',1.02),('5815','2014-04-29','08:45:00',1.07),('5815','2014-04-29','08:50:00',1.1),('5815','2014-04-29','08:55:00',1.2),('5815','2014-04-29','09:00:00',1.24),('5815','2014-04-29','09:05:00',1.37),('5815','2014-04-29','09:10:00',1.43),('5815','2014-04-29','09:15:00',1.61),('5815','2014-04-29','09:20:00',1.49),('5815','2014-04-29','09:25:00',1.27),('5815','2014-04-29','09:35:00',1.57),('5815','2014-04-29','09:40:00',1.63),('5815','2014-04-29','09:45:00',1.78),('5815','2014-04-29','09:50:00',1.57),('5815','2014-04-29','09:55:00',1.22),('5815','2014-04-29','10:00:00',2.01),('5815','2014-04-29','10:05:00',1.92),('5815','2014-04-29','10:10:00',1.36),('5815','2014-04-29','10:15:00',1.66),('5815','2014-04-29','10:20:00',1.29),('5815','2014-04-29','10:25:00',1),('5815','2014-04-29','10:35:00',1.26),('5815','2014-04-29','10:40:00',1.34),('5815','2014-04-29','10:55:00',2.05),('5815','2014-04-29','11:00:00',1.38),('5815','2014-04-29','11:05:00',2.18),('5815','2014-04-29','11:10:00',1.95),('5815','2014-04-29','11:15:00',1.55),('5815','2014-04-29','11:20:00',1),('5815','2014-04-29','11:25:00',1.46),('5815','2014-04-29','11:30:00',1.22),('5815','2014-04-29','11:35:00',1.14),('5815','2014-04-29','11:40:00',1.13),('5815','2014-04-29','11:45:00',1.25),('5815','2014-04-29','11:50:00',1.84),('5815','2014-04-29','11:55:00',1.26),('5815','2014-04-29','12:00:00',1.78),('5815','2014-04-29','12:20:00',1.29),('5815','2014-04-29','12:45:00',1.13),('5815','2014-04-29','12:55:00',2.08),('5815','2014-04-29','13:00:00',2.59),('5815','2014-04-29','13:05:00',2.24),('5815','2014-04-29','13:10:00',2.86),('5815','2014-04-29','13:15:00',1.34),('5815','2014-04-29','13:20:00',1.09),('5815','2014-04-29','13:25:00',1.35),('5815','2014-04-29','13:30:00',1.28),('5815','2014-04-29','13:35:00',1.05),('5815','2014-04-29','13:40:00',2.06),('5815','2014-04-29','13:45:00',1.68),('5815','2014-04-29','13:50:00',2.45),('5815','2014-04-29','13:55:00',2.89),('5815','2014-04-29','14:00:00',1.29),('5815','2014-04-29','14:05:00',1.08),('5815','2014-04-29','14:15:00',1.05),('5815','2014-04-29','14:20:00',1.83),('5815','2014-04-29','14:25:00',1.76),('5815','2014-04-29','14:30:00',2.45),('5815','2014-04-29','14:35:00',2.52),('5815','2014-04-29','14:40:00',1.3),('5815','2014-04-29','14:55:00',1.05),('5815','2014-04-29','15:30:00',1.1),('5815','2014-04-29','15:35:00',1.33),('5815','2014-04-29','15:40:00',2.2),('5815','2014-04-29','15:45:00',2.26),('5815','2014-04-29','15:50:00',1.6),('5815','2014-04-29','15:55:00',1.95),('5815','2014-04-29','16:05:00',1.4),('5815','2014-04-29','16:15:00',1.07),('5815','2014-04-29','16:30:00',1.34),('5815','2014-04-29','16:40:00',1.19),('5815','2014-04-29','16:45:00',1.43),('5815','2014-04-29','16:50:00',1.77),('5815','2014-04-29','16:55:00',1.55),('5815','2014-04-29','17:05:00',1.74),('5815','2014-04-28','10:05:00',1.06),('5815','2014-04-28','10:10:00',1.5),('5815','2014-04-28','10:15:00',2.08),('5815','2014-04-28','10:20:00',2.15),('5815','2014-04-28','10:25:00',2.18),('5815','2014-04-28','10:30:00',2.23),('5815','2014-04-28','10:35:00',2.21),('5815','2014-04-28','10:40:00',2.25),('5815','2014-04-28','10:45:00',2.27),('5815','2014-04-28','10:50:00',2.31),('5815','2014-04-27','09:15:00',1.22),('5815','2014-04-27','09:20:00',1.41),('5815','2014-04-27','09:30:00',1.7),('5815','2014-04-27','09:35:00',1.1),('5815','2014-04-27','09:40:00',1.12),('5815','2014-04-27','09:45:00',1.23),('5815','2014-04-27','09:50:00',1.92),('5815','2014-04-27','10:05:00',1.13),('5815','2014-04-27','10:10:00',1.27),('5815','2014-04-27','10:15:00',1.21),('5815','2014-04-27','10:20:00',1.13),('5815','2014-04-27','10:50:00',1.1),('5815','2014-04-27','10:55:00',1.13),('5815','2014-04-27','11:00:00',1.02),('5815','2014-04-27','11:05:00',1.32),('5815','2014-04-27','11:10:00',1.47),('5815','2014-04-27','11:15:00',1.34),('5815','2014-04-27','11:20:00',1.41),('5815','2014-04-27','11:30:00',1.04),('5815','2014-04-27','11:35:00',1.01),('5815','2014-04-27','11:55:00',1.06),('5815','2014-04-27','12:00:00',1),('5815','2014-04-27','12:10:00',1.01),('5815','2014-04-27','12:15:00',1.64),('5815','2014-04-27','12:20:00',1.69),('5815','2014-04-27','12:25:00',1.6),('5815','2014-04-27','12:30:00',1.5),('5815','2014-04-27','12:35:00',1.38),('5815','2014-04-27','12:40:00',1.23),('5815','2014-04-27','12:45:00',1.07),('5815','2014-04-27','12:50:00',1.26),('5815','2014-04-27','12:55:00',1.26),('5815','2014-04-27','13:00:00',1.31),('5815','2014-04-27','13:05:00',1.53),('5815','2014-04-27','13:10:00',2.07),('5815','2014-04-27','13:15:00',1.38),('5815','2014-04-27','13:20:00',1.26),('5815','2014-04-27','13:25:00',1.52),('5815','2014-04-27','13:30:00',2.55),('5815','2014-04-27','13:35:00',1.74),('5815','2014-04-27','13:40:00',2.46),('5815','2014-04-27','13:45:00',1.25),('5815','2014-04-27','13:50:00',2.62),('5815','2014-04-27','13:55:00',2.29),('5815','2014-04-27','14:00:00',1.68),('5815','2014-04-27','14:05:00',1.09),('5815','2014-04-27','14:10:00',2.73),('5815','2014-04-27','14:15:00',2.4),('5815','2014-04-27','14:20:00',2.06),('5815','2014-04-27','14:25:00',1.85),('5815','2014-04-27','14:30:00',2.04),('5815','2014-04-27','14:35:00',2.51),('5815','2014-04-27','14:40:00',1.76),('5815','2014-04-27','14:45:00',1.54),('5815','2014-04-27','14:50:00',1.21),('5815','2014-04-27','14:55:00',1.48),('5815','2014-04-27','15:00:00',1.24),('5815','2014-04-27','15:05:00',1.72),('5815','2014-04-27','15:10:00',1.81),('5815','2014-04-27','15:15:00',1.71),('5815','2014-04-27','15:20:00',1.99),('5815','2014-04-27','15:25:00',1.38),('5815','2014-04-27','15:35:00',1.01),('5815','2014-04-27','15:40:00',1.64),('5815','2014-04-27','15:50:00',2.16),('5815','2014-04-27','16:00:00',2.11),('5815','2014-04-27','16:05:00',2.27),('5815','2014-04-27','16:10:00',1.86),('5815','2014-04-27','16:15:00',1.03),('5815','2014-04-27','16:20:00',1.72),('5815','2014-04-27','16:25:00',1.1),('5815','2014-04-27','16:30:00',1.51),('5815','2014-04-27','16:35:00',1.05),('5815','2014-04-27','16:55:00',1.41),('5815','2014-04-26','11:45:00',1.78),('5815','2014-04-26','11:50:00',1.68),('5815','2014-04-26','11:55:00',1.37),('5815','2014-04-26','12:00:00',1.42),('5815','2014-04-26','12:05:00',1.52),('5815','2014-04-26','12:10:00',1.72),('5815','2014-04-26','12:15:00',1.67),('5815','2014-04-26','12:20:00',1.56),('5815','2014-04-26','12:25:00',1.64),('5815','2014-04-26','12:30:00',1.49),('5815','2014-04-26','12:35:00',1.49),('5815','2014-04-26','12:40:00',1.36),('5815','2014-04-26','12:45:00',1.48),('5815','2014-04-26','12:50:00',1.29),('5815','2014-04-26','13:00:00',1.11),('5815','2014-04-26','13:05:00',1.17),('5815','2014-04-26','13:20:00',1.34),('5815','2014-04-26','13:25:00',1.27),('5815','2014-04-26','13:30:00',1.12),('5815','2014-04-26','14:05:00',1.31),('5815','2014-04-26','14:25:00',1.24),('5815','2014-04-26','14:30:00',1.31),('5815','2014-04-26','14:35:00',1.25),('5815','2014-04-26','14:40:00',1.29),('5815','2014-04-26','14:45:00',1.13),('5815','2014-04-26','14:50:00',1.05),('5815','2014-04-26','14:55:00',1.13),('5815','2014-04-26','15:00:00',1.19),('5815','2014-04-26','15:05:00',1.68),('5815','2014-04-26','15:10:00',2.21),('5815','2014-04-26','15:15:00',1.73),('5815','2014-04-26','15:20:00',1.1),('5819','2014-05-05','07:25:00',1.04),('5819','2014-05-05','07:40:00',1.1),('5819','2014-05-05','07:45:00',1.38),('5819','2014-05-05','07:50:00',1.48),('5819','2014-05-05','07:55:00',1.57),('5819','2014-05-05','08:00:00',1.65),('5819','2014-05-05','08:05:00',1.74),('5819','2014-05-05','08:10:00',1.84),('5819','2014-05-05','08:15:00',1.94),('5819','2014-05-05','08:20:00',2.03),('5819','2014-05-05','08:25:00',2.11),('5819','2014-05-05','08:30:00',2.19),('5819','2014-05-05','08:35:00',2.3),('5819','2014-05-05','08:40:00',2.38),('5819','2014-05-05','08:45:00',2.45),('5819','2014-05-05','08:50:00',2.52),('5819','2014-05-05','08:55:00',2.59),('5819','2014-05-05','09:00:00',2.63),('5819','2014-05-05','09:05:00',2.69),('5819','2014-05-05','09:10:00',2.73),('5819','2014-05-05','09:15:00',2.83),('5819','2014-05-05','09:20:00',2.87),('5819','2014-05-05','09:25:00',2.98),('5819','2014-05-05','09:30:00',3.07),('5819','2014-05-05','09:35:00',3.12),('5819','2014-05-05','09:40:00',3.18),('5819','2014-05-05','09:45:00',3.23),('5819','2014-05-05','09:50:00',3.3),('5819','2014-05-05','09:55:00',3.36),('5819','2014-05-05','10:00:00',3.41),('5819','2014-05-05','10:05:00',3.47),('5819','2014-05-05','10:10:00',3.51),('5819','2014-05-05','10:15:00',3.52),('5819','2014-05-05','10:20:00',3.52),('5819','2014-05-05','10:25:00',3.58),('5819','2014-05-05','10:30:00',3.64),('5819','2014-05-05','10:35:00',3.73),('5819','2014-05-05','10:40:00',3.72),('5819','2014-05-05','10:45:00',3.75),('5819','2014-05-05','10:50:00',3.79),('5819','2014-05-05','10:55:00',3.8),('5819','2014-05-05','11:00:00',3.85),('5819','2014-05-05','11:05:00',3.88),('5819','2014-05-05','11:10:00',3.91),('5819','2014-05-05','11:15:00',3.9),('5819','2014-05-05','11:20:00',3.91),('5819','2014-05-05','11:25:00',3.94),('5819','2014-05-05','11:30:00',3.92),('5819','2014-05-05','11:35:00',3.95),('5819','2014-05-05','11:40:00',3.98),('5819','2014-05-05','11:45:00',4.01),('5819','2014-05-05','11:50:00',4.03),('5819','2014-05-05','11:55:00',4.19),('5819','2014-05-05','12:00:00',2.92),('5819','2014-05-05','12:05:00',2.16),('5819','2014-05-05','12:10:00',2.79),('5819','2014-05-05','12:15:00',2.53),('5819','2014-05-05','12:20:00',2.27),('5819','2014-05-05','12:25:00',3.55),('5819','2014-05-05','12:30:00',3.9),('5819','2014-05-05','12:35:00',1.78),('5819','2014-05-05','12:40:00',1.83),('5819','2014-05-05','12:45:00',4.83),('5819','2014-05-05','12:50:00',3.25),('5819','2014-05-05','12:55:00',2.58),('5819','2014-05-05','13:00:00',2.46),('5819','2014-05-05','13:05:00',4.14),('5819','2014-05-05','13:10:00',4.2),('5819','2014-05-05','13:15:00',4.11),('5819','2014-05-05','13:20:00',3.97),('5819','2014-05-05','13:25:00',3.97),('5819','2014-05-05','13:30:00',3.98),('5819','2014-05-05','13:35:00',3.97),('5819','2014-05-05','13:40:00',3.92),('5819','2014-05-05','13:45:00',3.91),('5819','2014-05-05','13:50:00',3.92),('5819','2014-05-05','13:55:00',3.92),('5819','2014-05-05','14:00:00',3.91),('5819','2014-05-05','14:05:00',4.03),('5819','2014-05-05','14:10:00',4.07),('5819','2014-05-05','14:15:00',4.11),('5819','2014-05-05','14:20:00',4.38),('5819','2014-05-05','14:25:00',3.8),('5819','2014-05-05','14:30:00',2.12),('5819','2014-05-05','14:35:00',1.49),('5819','2014-05-05','14:40:00',1.24),('5819','2014-05-05','14:45:00',1.09),('5819','2014-05-05','14:50:00',1.13),('5819','2014-05-05','14:55:00',1.53),('5819','2014-05-05','15:00:00',1.38),('5819','2014-05-05','15:05:00',1.41),('5819','2014-05-05','15:10:00',1.29),('5819','2014-05-05','15:15:00',1.17),('5819','2014-05-05','15:20:00',1.41),('5819','2014-05-05','15:25:00',2.65),('5819','2014-05-05','15:30:00',3.65),('5819','2014-05-05','15:35:00',2.33),('5819','2014-05-05','15:40:00',2.95),('5819','2014-05-05','15:45:00',1.55),('5819','2014-05-05','15:50:00',1.32),('5819','2014-05-05','15:55:00',1.27),('5819','2014-05-05','16:00:00',1.37),('5819','2014-05-05','16:05:00',2.03),('5819','2014-05-05','16:10:00',1.15),('5819','2014-05-05','16:15:00',1.31),('5819','2014-05-05','16:20:00',1.07),('5819','2014-05-05','16:40:00',1.59),('5819','2014-05-05','16:45:00',1.42),('5819','2014-05-05','16:55:00',1.74),('5819','2014-05-05','17:00:00',2.06),('5819','2014-05-05','17:05:00',1.9),('5819','2014-05-05','17:10:00',1.83),('5819','2014-05-05','17:15:00',1.79),('5819','2014-05-05','17:20:00',1.73),('5819','2014-05-05','17:25:00',1.56),('5819','2014-05-05','17:30:00',1.4),('5819','2014-05-05','17:35:00',1.18),('5819','2014-05-05','17:40:00',1.18),('5819','2014-05-05','17:45:00',1.1),('5819','2014-05-05','17:50:00',1.02),('5819','2014-04-26','09:50:00',1.05),('5819','2014-04-26','09:55:00',1.38),('5819','2014-04-26','10:00:00',1.36),('5819','2014-04-26','10:05:00',1.27),('5819','2014-04-26','10:10:00',1.22),('5819','2014-04-26','10:15:00',1.28),('5819','2014-04-26','10:20:00',1.37),('5819','2014-04-26','10:25:00',1.44),('5819','2014-04-26','10:30:00',1.99),('5819','2014-04-26','10:35:00',1.86),('5819','2014-04-26','10:40:00',1.75),('5819','2014-04-26','10:45:00',1.87),('5819','2014-04-26','10:50:00',2.3),('5819','2014-04-26','10:55:00',3.09),('5819','2014-04-26','11:00:00',3.49),('5819','2014-04-26','11:05:00',3.12),('5819','2014-04-26','11:10:00',3.29),('5819','2014-04-26','11:15:00',3.11),('5819','2014-04-26','11:20:00',3.02),('5819','2014-04-26','11:25:00',2.98),('5819','2014-04-26','11:30:00',2.99),('5819','2014-04-26','11:35:00',2.92),('5819','2014-04-26','11:40:00',2.83),('5819','2014-04-26','11:45:00',3.09),('5819','2014-04-26','11:50:00',3.08),('5819','2014-04-26','11:55:00',2.58),('5819','2014-04-26','12:00:00',3.03),('5819','2014-04-26','12:05:00',3.03),('5819','2014-04-26','12:10:00',3.05),('5819','2014-04-26','12:15:00',2.74),('5819','2014-04-26','12:20:00',2.61),('5819','2014-04-26','12:25:00',1.79),('5819','2014-04-26','12:30:00',2.28),('5819','2014-04-26','12:35:00',3.16),('5819','2014-04-26','12:40:00',2.91),('5819','2014-04-26','12:45:00',3.15),('5819','2014-04-26','12:50:00',3.86),('5819','2014-04-26','12:55:00',4.02),('5819','2014-04-26','13:00:00',3.74),('5819','2014-04-26','13:05:00',3.16),('5819','2014-04-26','13:10:00',2.85),('5819','2014-04-26','13:15:00',4.06),('5819','2014-04-26','13:20:00',3.31),('5819','2014-04-26','13:25:00',2.12),('5819','2014-04-26','13:30:00',1.3),('5819','2014-04-26','13:35:00',2.78),('5819','2014-04-26','13:40:00',3.95),('5819','2014-04-26','13:45:00',3.79),('5819','2014-04-26','13:50:00',3.81),('5819','2014-04-26','13:55:00',4.04),('5819','2014-04-26','14:00:00',2.85),('5819','2014-04-26','14:05:00',1.03),('5819','2014-04-26','14:10:00',3.48),('5819','2014-04-26','14:35:00',2.12),('5819','2014-04-26','14:40:00',2.06),('5819','2014-04-25','07:55:00',1.28),('5819','2014-04-25','08:00:00',1.42),('5819','2014-04-25','08:05:00',1.42),('5819','2014-04-25','08:10:00',1.47),('5819','2014-04-25','08:15:00',1.53),('5819','2014-04-25','08:20:00',1.63),('5819','2014-04-25','08:25:00',1.74),('5819','2014-04-25','08:30:00',1.8),('5819','2014-04-25','08:35:00',1.85),('5819','2014-04-25','08:40:00',1.93),('5819','2014-04-25','08:45:00',2.01),('5819','2014-04-25','08:50:00',2.1),('5819','2014-04-25','08:55:00',2.18),('5819','2014-04-25','09:00:00',2.35),('5819','2014-04-25','09:05:00',2.11),('5819','2014-04-25','09:10:00',2.54),('5819','2014-04-25','09:15:00',2.5),('5819','2014-04-25','09:20:00',1.42),('5819','2014-04-25','09:25:00',1.28),('5819','2014-04-25','09:30:00',1.4),('5819','2014-04-25','09:35:00',1.25),('5819','2014-04-25','09:40:00',1),('5819','2014-04-25','10:00:00',1.21),('5819','2014-04-25','10:05:00',1.15),('5819','2014-04-25','10:10:00',1.03),('5819','2014-04-25','10:15:00',1.02),('5819','2014-04-25','10:20:00',1.06),('5819','2014-04-25','10:25:00',1.17),('5819','2014-04-25','10:30:00',1.24),('5819','2014-04-25','10:35:00',2.3),('5819','2014-04-25','10:40:00',3.8),('5819','2014-04-25','10:45:00',3.84),('5819','2014-04-25','10:50:00',3.46),('5819','2014-04-25','10:55:00',2.43),('5819','2014-04-25','11:00:00',3.44),('5819','2014-04-25','11:05:00',2.3),('5819','2014-04-25','11:10:00',1.06),('5819','2014-04-25','11:15:00',1.64),('5819','2014-04-25','11:20:00',4.02),('5819','2014-04-25','11:25:00',3.46),('5819','2014-04-25','11:30:00',1.51),('5819','2014-04-25','11:35:00',3.94),('5819','2014-04-25','11:40:00',2.53),('5819','2014-04-25','11:45:00',1.9),('5819','2014-04-25','11:50:00',1.23),('5819','2014-04-25','11:55:00',1.29),('5819','2014-04-25','12:00:00',1.7),('5819','2014-04-25','12:05:00',1.56),('5819','2014-04-25','12:10:00',1.64),('5819','2014-04-25','12:15:00',2.64),('5819','2014-04-25','12:20:00',4.07),('5819','2014-04-25','12:25:00',2.92),('5819','2014-04-25','12:30:00',2.27),('5819','2014-04-25','12:35:00',3.62),('5819','2014-04-25','12:40:00',3.81),('5819','2014-04-25','12:45:00',3.76),('5819','2014-04-25','12:50:00',2.7),('5819','2014-04-25','12:55:00',2.29),('5819','2014-04-25','13:00:00',1.39),('5819','2014-04-25','13:05:00',2.71),('5819','2014-04-25','13:10:00',1.32),('5819','2014-04-25','13:15:00',2.39),('5819','2014-04-25','13:20:00',2.03),('5819','2014-04-25','13:25:00',2.05),('5819','2014-04-25','13:30:00',1.95),('5819','2014-04-25','13:35:00',1.24),('5819','2014-04-25','13:40:00',2.74),('5819','2014-04-25','13:45:00',2.08),('5819','2014-04-25','13:50:00',1.16),('5819','2014-04-25','13:55:00',1.31),('5819','2014-04-25','14:00:00',1.19),('5819','2014-04-25','14:05:00',1.48),('5819','2014-04-25','14:10:00',1.34),('5819','2014-04-25','14:15:00',1.06),('5819','2014-04-25','14:20:00',2.57),('5819','2014-04-25','14:25:00',2.62),('5819','2014-04-25','14:30:00',3.3),('5819','2014-04-25','14:35:00',3.66),('5819','2014-04-25','14:40:00',3.52),('5819','2014-04-25','14:45:00',3.54),('5819','2014-04-25','14:50:00',3.53),('5819','2014-04-25','14:55:00',3.38),('5819','2014-04-25','15:00:00',3.33),('5819','2014-04-25','15:05:00',3.23),('5819','2014-04-25','15:10:00',3.15),('5819','2014-04-25','15:15:00',3.13),('5819','2014-04-25','15:20:00',2.98),('5819','2014-04-25','15:25:00',2.95),('5819','2014-04-25','15:30:00',2.85),('5819','2014-04-25','15:35:00',2.87),('5819','2014-04-25','15:40:00',2.83),('5819','2014-04-25','15:45:00',2.73),('5819','2014-04-25','15:50:00',2.67),('5819','2014-04-25','15:55:00',2.64),('5819','2014-04-25','16:00:00',2.59),('5819','2014-04-25','16:05:00',2.44),('5819','2014-04-25','16:10:00',2.39),('5819','2014-04-25','16:15:00',2.27),('5819','2014-04-25','16:20:00',2.09),('5819','2014-04-25','16:25:00',2.05),('5819','2014-04-25','16:30:00',2.14),('5819','2014-04-25','16:35:00',2.1),('5819','2014-04-25','16:40:00',2.09),('5819','2014-04-25','16:45:00',1.99),('5819','2014-04-25','16:50:00',1.85),('5819','2014-04-25','16:55:00',1.58),('5819','2014-04-25','17:00:00',1.37),('5819','2014-04-25','17:05:00',1.56),('5819','2014-04-25','17:10:00',1.43),('5819','2014-04-25','17:15:00',1.33),('5819','2014-04-25','17:20:00',1.1),('5819','2014-01-12','10:25:00',1),('5819','2014-01-12','10:35:00',1.06),('5819','2014-01-12','10:40:00',1.23),('5819','2014-01-12','10:45:00',1.26),('5819','2014-01-12','10:50:00',1.31),('5819','2014-01-12','10:55:00',1.43),('5819','2014-01-12','11:00:00',1.46),('5819','2014-01-12','11:05:00',1.42),('5819','2014-01-12','11:10:00',1.8),('5819','2014-01-12','11:15:00',1.62),('5819','2014-01-12','11:20:00',1.6),('5819','2014-01-12','11:25:00',1.44),('5819','2014-01-12','11:30:00',1.58),('5819','2014-01-12','11:35:00',1.3),('5819','2014-01-12','11:40:00',1.52),('5819','2014-01-12','11:45:00',1.81),('5819','2014-01-12','11:50:00',1.84),('5819','2014-01-12','11:55:00',1.82),('5819','2014-01-12','12:00:00',1.37),('5819','2014-01-12','12:05:00',1.36),('5819','2014-01-12','12:10:00',1.23),('5819','2014-01-12','12:15:00',1.11),('5819','2014-01-12','12:20:00',1.13),('5819','2014-01-12','12:25:00',1.07),('5819','2014-01-12','12:30:00',1.13),('5819','2014-01-12','12:35:00',1.12),('5819','2014-01-12','12:40:00',1.23),('5819','2014-01-12','12:45:00',1.19),('5819','2014-01-12','12:50:00',1.2),('5819','2014-01-12','12:55:00',1.18),('5819','2014-01-12','13:00:00',1.18),('5819','2014-01-12','13:05:00',1.08),('5819','2014-01-12','13:10:00',1.04),('5819','2014-01-12','13:15:00',1.01),('5819','2014-01-12','13:20:00',1.06),('5819','2014-01-12','13:25:00',1.04),('5819','2014-01-12','13:30:00',1.28),('5819','2014-01-12','13:35:00',1.14),('5819','2014-01-12','13:40:00',1.04),('5819','2014-01-11','09:50:00',1.07),('5819','2014-01-11','09:55:00',1.54),('5819','2014-01-11','10:00:00',1.8),('5819','2014-01-11','10:05:00',1.37),('5819','2014-01-11','10:10:00',1.35),('5819','2014-01-11','10:15:00',1.53),('5819','2014-01-11','10:20:00',1.49),('5819','2014-01-11','10:25:00',1.87),('5819','2014-01-11','10:30:00',1.79),('5819','2014-01-11','10:35:00',1.84),('5819','2014-01-11','10:40:00',2.27),('5819','2014-01-11','10:45:00',2.42),('5819','2014-01-11','10:50:00',2.44),('5819','2014-01-11','10:55:00',2.4),('5819','2014-01-11','11:00:00',2.33),('5819','2014-01-11','11:05:00',2.24),('5819','2014-01-11','11:10:00',2.38),('5819','2014-01-11','11:15:00',2.22),('5819','2014-01-11','11:20:00',1.99),('5819','2014-01-11','11:25:00',1.96),('5819','2014-01-11','11:30:00',1.97),('5819','2014-01-11','11:35:00',1.84),('5819','2014-01-11','11:40:00',1.63),('5819','2014-01-11','11:45:00',1.68),('5819','2014-01-11','11:50:00',1.8),('5819','2014-01-11','11:55:00',1.8),('5819','2014-01-11','12:00:00',1.8),('5819','2014-01-11','12:05:00',1.99),('5819','2014-01-11','12:10:00',1.87),('5819','2014-01-11','12:15:00',1.92),('5819','2014-01-11','12:20:00',1.81),('5819','2014-01-11','12:25:00',1.69),('5819','2014-01-11','12:30:00',1.51),('5819','2014-01-11','12:35:00',1.41),('5819','2014-01-11','12:40:00',1.28),('5819','2014-01-11','12:45:00',1.35),('5819','2014-01-11','12:50:00',1.64),('5819','2014-01-11','12:55:00',1.93),('5819','2014-01-11','13:00:00',1.93),('5819','2014-01-11','13:05:00',1.76),('5819','2014-01-11','13:10:00',1.77),('5819','2014-01-11','13:15:00',2),('5819','2014-01-11','13:20:00',1.75),('5819','2014-01-11','13:25:00',1.4),('5819','2014-01-11','13:30:00',1.19),('5819','2014-01-11','13:35:00',1.2),('5819','2014-01-11','13:40:00',1.04),('5819','2014-01-11','13:45:00',1.11),('5819','2014-01-11','14:00:00',1.25),('5819','2014-01-11','14:05:00',1.37),('5819','2014-01-11','14:10:00',1.23),('5819','2014-01-09','09:20:00',1.04),('5819','2014-01-09','09:25:00',1.25),('5819','2014-01-09','09:30:00',1.33),('5819','2014-01-09','09:35:00',1.69),('5819','2014-01-09','09:40:00',1.61),('5819','2014-01-09','09:45:00',1.77),('5819','2014-01-09','09:50:00',1.96),('5819','2014-01-09','09:55:00',1.95),('5819','2014-01-09','10:00:00',1.97),('5819','2014-01-09','10:05:00',1.97),('5819','2014-01-09','10:10:00',1.62),('5819','2014-01-09','10:15:00',1.73),('5819','2014-01-09','10:20:00',1.79),('5819','2014-01-09','10:25:00',1.83),('5819','2014-01-09','10:30:00',1.91),('5819','2014-01-09','10:35:00',1.89),('5819','2014-01-09','10:40:00',1.92),('5819','2014-01-09','10:45:00',1.94),('5819','2014-01-09','10:50:00',2.07),('5819','2014-01-09','10:55:00',1.58),('5819','2014-01-09','11:00:00',1.09),('5819','2014-01-09','11:05:00',1.01),('5819','2014-01-09','11:10:00',1.08),('5819','2014-01-09','11:15:00',1.02),('5819','2014-01-09','11:20:00',1.08),('5819','2014-01-09','11:25:00',1.23),('5819','2014-01-09','11:30:00',1.1),('5819','2014-01-09','11:35:00',1.03),('5819','2014-01-09','11:40:00',1.24),('5819','2014-01-09','11:45:00',1.46),('5819','2014-01-09','11:50:00',1.31),('5819','2014-01-08','08:55:00',1.12),('5819','2014-01-08','09:00:00',1.25),('5819','2014-01-08','09:05:00',1.28),('5819','2014-01-08','09:10:00',1.39),('5819','2014-01-08','09:15:00',1.48),('5819','2014-01-08','09:20:00',1.54),('5819','2014-01-08','09:25:00',1.59),('5819','2014-01-08','09:30:00',1.62),('5819','2014-01-08','09:35:00',1.65),('5819','2014-01-08','09:40:00',1.79),('5819','2014-01-08','09:45:00',1.86),('5819','2014-01-08','09:50:00',1.86),('5819','2014-01-08','09:55:00',1.93),('5819','2014-01-08','10:00:00',1.98),('5819','2014-01-08','10:05:00',1.94),('5819','2014-01-08','10:10:00',1.94),('5819','2014-01-08','10:15:00',2),('5819','2014-01-08','10:20:00',2.15),('5819','2014-01-08','10:25:00',2.23),('5819','2014-01-08','10:30:00',2.25),('5819','2014-01-08','10:35:00',2.09),('5819','2014-01-08','10:40:00',2.08),('5819','2014-01-08','10:45:00',2.28),('5819','2014-01-08','10:50:00',2.36),('5819','2014-01-08','10:55:00',2.4),('5819','2014-01-08','11:00:00',2.41),('5819','2014-01-08','11:05:00',2.41),('5819','2014-01-08','11:10:00',2.44),('5819','2014-01-08','11:15:00',2.46),('5819','2014-01-08','11:20:00',2.45),('5819','2014-01-08','11:25:00',2.46),('5819','2014-01-08','11:30:00',2.45),('5819','2014-01-08','11:35:00',2.51),('5819','2014-01-08','11:40:00',2.53),('5819','2014-01-08','11:45:00',2.47),('5819','2014-01-08','11:50:00',2.47),('5819','2014-01-08','11:55:00',2.43),('5819','2014-01-08','12:00:00',2.42),('5819','2014-01-08','12:05:00',2.42),('5819','2014-01-08','12:10:00',2.38),('5819','2014-01-08','12:15:00',2.4),('5819','2014-01-08','12:20:00',2.39),('5819','2014-01-08','12:25:00',2.35),('5819','2014-01-08','12:30:00',2.35),('5819','2014-01-08','12:35:00',2.31),('5819','2014-01-08','12:40:00',2.25),('5819','2014-01-08','12:45:00',2.15),('5819','2014-01-08','12:50:00',2.11),('5819','2014-01-08','12:55:00',2.11),('5819','2014-01-08','13:00:00',2.14),('5819','2014-01-08','13:05:00',2.14),('5819','2014-01-08','13:10:00',2.08),('5819','2014-01-08','13:15:00',2.07),('5819','2014-01-08','13:20:00',2.01),('5819','2014-01-08','13:25:00',1.99),('5819','2014-01-08','13:30:00',1.91),('5819','2014-01-08','13:35:00',1.88),('5819','2014-01-08','13:40:00',1.83),('5819','2014-01-08','13:45:00',1.82),('5819','2014-01-08','13:50:00',1.72),('5819','2014-01-08','13:55:00',1.69),('5819','2014-01-08','14:00:00',1.65),('5819','2014-01-08','14:05:00',1.63),('5819','2014-01-08','14:10:00',1.59),('5819','2014-01-08','14:15:00',1.56),('5819','2014-01-08','14:20:00',1.52),('5819','2014-01-08','14:25:00',1.5),('5819','2014-01-08','14:30:00',1.47),('5819','2014-01-08','14:35:00',1.44),('5819','2014-01-08','14:40:00',1.3),('5819','2014-01-08','14:45:00',1.25),('5819','2014-01-08','14:50:00',1.21),('5819','2014-01-08','14:55:00',1.04),('5819','2014-01-07','08:35:00',1.02),('5819','2014-01-07','08:40:00',1.11),('5819','2014-01-07','08:45:00',1.2),('5819','2014-01-07','08:50:00',1.27),('5819','2014-01-07','08:55:00',1.35),('5819','2014-01-07','09:00:00',1.42),('5819','2014-01-07','09:05:00',1.49),('5819','2014-01-07','09:10:00',1.57),('5819','2014-01-07','09:15:00',1.64),('5819','2014-01-07','09:20:00',1.71),('5819','2014-01-07','09:25:00',1.76),('5819','2014-01-07','09:30:00',1.82),('5819','2014-01-07','09:35:00',1.87),('5819','2014-01-07','09:40:00',1.93),('5819','2014-01-07','09:45:00',1.97),('5819','2014-01-07','09:50:00',2.02),('5819','2014-01-07','09:55:00',2.05),('5819','2014-01-07','10:00:00',2.09),('5819','2014-01-07','10:05:00',2.13),('5819','2014-01-07','10:10:00',2.17),('5819','2014-01-07','10:15:00',2.21),('5819','2014-01-07','10:20:00',2.25),('5819','2014-01-07','10:25:00',2.29),('5819','2014-01-07','10:30:00',2.33),('5819','2014-01-07','10:35:00',2.36),('5819','2014-01-07','10:40:00',2.39),('5819','2014-01-07','10:45:00',2.42),('5819','2014-01-07','10:50:00',2.45),('5819','2014-01-07','10:55:00',2.47),('5819','2014-01-07','11:00:00',2.48),('5819','2014-01-07','11:05:00',2.49),('5819','2014-01-07','11:10:00',2.51),('5819','2014-01-07','11:15:00',2.52),('5819','2014-01-07','11:20:00',2.54),('5819','2014-01-07','11:25:00',2.54),('5819','2014-01-07','11:30:00',2.56),('5819','2014-01-07','11:35:00',2.56),('5819','2014-01-07','11:40:00',2.58),('5819','2014-01-07','11:45:00',2.56),('5819','2014-01-07','11:50:00',2.56),('5819','2014-01-07','11:55:00',2.56),('5819','2014-01-07','12:00:00',2.52),('5819','2014-01-07','12:05:00',2.52),('5819','2014-01-07','12:10:00',2.52),('5819','2014-01-07','12:15:00',2.46),('5819','2014-01-07','12:20:00',2.48),('5819','2014-01-07','12:25:00',2.46),('5819','2014-01-07','12:30:00',2.43),('5819','2014-01-07','12:35:00',2.39),('5819','2014-01-07','12:40:00',2.33),('5819','2014-01-07','12:45:00',2.32),('5819','2014-01-07','12:50:00',2.33),('5819','2014-01-07','12:55:00',2.27),('5819','2014-01-07','13:00:00',2.19),('5819','2014-01-07','13:05:00',2.14),('5819','2014-01-07','13:10:00',2.17),('5819','2014-01-07','13:15:00',2.13),('5819','2014-01-07','13:20:00',2.07),('5819','2014-01-07','13:25:00',1.98),('5819','2014-01-07','13:30:00',1.91),('5819','2014-01-07','13:35:00',1.88),('5819','2014-01-07','13:40:00',1.87),('5819','2014-01-07','13:45:00',1.88),('5819','2014-01-07','13:50:00',1.86),('5819','2014-01-07','13:55:00',1.82),('5819','2014-01-07','14:00:00',1.82),('5819','2014-01-07','14:05:00',1.7),('5819','2014-01-07','14:10:00',1.65),('5819','2014-01-07','14:15:00',1.63),('5819','2014-01-07','14:20:00',1.58),('5819','2014-01-07','14:25:00',1.5),('5819','2014-01-07','14:30:00',1.44),('5819','2014-01-07','14:35:00',1.37),('5819','2014-01-07','14:40:00',1.36),('5819','2014-01-07','14:45:00',1.27),('5819','2014-01-07','14:50:00',1.25),('5819','2014-01-07','14:55:00',1.22),('5819','2014-01-07','15:00:00',1.14),('5819','2014-01-07','15:05:00',1.1),('5819','2014-01-07','15:10:00',1.05),('5819','2014-04-24','07:40:00',1.05),('5819','2014-04-24','07:45:00',1.13),('5819','2014-04-24','07:50:00',1.22),('5819','2014-04-24','07:55:00',1.31),('5819','2014-04-24','08:00:00',1.4),('5819','2014-04-24','08:05:00',1.49),('5819','2014-04-24','08:10:00',1.56),('5819','2014-04-24','08:15:00',1.64),('5819','2014-04-24','08:20:00',1.73),('5819','2014-04-24','08:25:00',1.83),('5819','2014-04-24','08:30:00',1.91),('5819','2014-04-24','08:35:00',1.99),('5819','2014-04-24','08:40:00',2.07),('5819','2014-04-24','08:45:00',2.14),('5819','2014-04-24','08:50:00',2.2),('5819','2014-04-24','08:55:00',2.28),('5819','2014-04-24','09:00:00',2.35),('5819','2014-04-24','09:05:00',2.42),('5819','2014-04-24','09:10:00',2.46),('5819','2014-04-24','09:15:00',2.53),('5819','2014-04-24','09:20:00',2.59),('5819','2014-04-24','09:25:00',2.66),('5819','2014-04-24','09:30:00',2.74),('5819','2014-04-24','09:35:00',2.81),('5819','2014-04-24','09:40:00',2.85),('5819','2014-04-24','09:45:00',2.92),('5819','2014-04-24','09:50:00',2.98),('5819','2014-04-24','09:55:00',3.01),('5819','2014-04-24','10:00:00',3.06),('5819','2014-04-24','10:05:00',3.11),('5819','2014-04-24','10:10:00',3.15),('5819','2014-04-24','10:15:00',3.21),('5819','2014-04-24','10:20:00',3.25),('5819','2014-04-24','10:25:00',3.26),('5819','2014-04-24','10:30:00',3.31),('5819','2014-04-24','10:35:00',3.33),('5819','2014-04-24','10:40:00',3.37),('5819','2014-04-24','10:45:00',3.41),('5819','2014-04-24','10:50:00',3.43),('5819','2014-04-24','10:55:00',3.47),('5819','2014-04-24','11:00:00',3.53),('5819','2014-04-24','11:05:00',3.59),('5819','2014-04-24','11:10:00',3.59),('5819','2014-04-24','11:15:00',3.6),('5819','2014-04-24','11:20:00',3.6),('5819','2014-04-24','11:25:00',3.6),('5819','2014-04-24','11:30:00',3.63),('5819','2014-04-24','11:35:00',3.67),('5819','2014-04-24','11:40:00',3.68),('5819','2014-04-24','11:45:00',3.66),('5819','2014-04-24','11:50:00',3.69),('5819','2014-04-24','11:55:00',3.7),('5819','2014-04-24','12:00:00',3.69),('5819','2014-04-24','12:05:00',3.74),('5819','2014-04-24','12:10:00',3.76),('5819','2014-04-24','12:15:00',3.89),('5819','2014-04-24','12:20:00',3.85),('5819','2014-04-24','12:25:00',3.74),('5819','2014-04-24','12:30:00',3.86),('5819','2014-04-24','12:35:00',3.84),('5819','2014-04-24','12:40:00',3.83),('5819','2014-04-24','12:45:00',3.85),('5819','2014-04-24','12:50:00',3.87),('5819','2014-04-24','12:55:00',3.73),('5819','2014-04-24','13:00:00',3.65),('5819','2014-04-24','13:05:00',3.78),('5819','2014-04-24','13:10:00',3.87),('5819','2014-04-24','13:15:00',3.91),('5819','2014-04-24','13:20:00',3.92),('5819','2014-04-24','13:25:00',3.84),('5819','2014-04-24','13:30:00',3.85),('5819','2014-04-24','13:35:00',3.85),('5819','2014-04-24','13:40:00',1.2),('5819','2014-04-24','13:45:00',3.87),('5819','2014-04-24','13:50:00',1.29),('5819','2014-04-24','13:55:00',2.19),('5819','2014-04-24','14:00:00',3.25),('5819','2014-04-24','14:05:00',1.66),('5819','2014-04-24','14:10:00',3.64),('5819','2014-04-24','14:15:00',2.44),('5819','2014-04-24','14:20:00',3.05),('5819','2014-04-24','14:25:00',2.87),('5819','2014-04-24','14:30:00',3.97),('5819','2014-04-24','14:35:00',3.83),('5819','2014-04-24','14:40:00',2.47),('5819','2014-04-24','14:45:00',3.19),('5819','2014-04-24','14:50:00',1.41),('5819','2014-04-24','14:55:00',3.06),('5819','2014-04-24','15:00:00',4.14),('5819','2014-04-24','15:05:00',4.02),('5819','2014-04-24','15:10:00',3.52),('5819','2014-04-24','15:15:00',3.47),('5819','2014-04-24','15:20:00',2.24),('5819','2014-04-24','15:25:00',1.98),('5819','2014-04-24','15:30:00',2.14),('5819','2014-04-24','15:35:00',2.46),('5819','2014-04-24','15:40:00',1.91),('5819','2014-04-24','15:45:00',1.76),('5819','2014-04-24','15:50:00',2.26),('5819','2014-04-24','15:55:00',2.15),('5819','2014-04-24','16:00:00',3.13),('5819','2014-04-24','16:05:00',3),('5819','2014-04-24','16:10:00',2.32),('5819','2014-04-24','16:15:00',2.44),('5819','2014-04-24','16:20:00',2.44),('5819','2014-04-24','16:25:00',2.1),('5819','2014-04-24','16:30:00',2.67),('5819','2014-04-24','16:35:00',1.61),('5819','2014-04-24','16:40:00',1.66),('5819','2014-04-24','16:45:00',1.75),('5819','2014-04-24','16:50:00',1.38),('5819','2014-04-24','16:55:00',1.51),('5819','2014-04-24','17:00:00',1.24),('5819','2014-04-24','17:05:00',1.11),('5819','2014-04-24','17:10:00',1.04),('5819','2014-01-06','11:35:00',1.18),('5819','2014-01-06','11:40:00',2.85),('5819','2014-01-06','11:45:00',2.59),('5819','2014-01-06','11:50:00',2.59),('5819','2014-01-06','11:55:00',2.47),('5819','2014-01-06','12:00:00',2.53),('5819','2014-01-06','12:05:00',2.59),('5819','2014-01-06','12:10:00',2.51),('5819','2014-01-06','12:15:00',2.46),('5819','2014-01-06','12:20:00',2.43),('5819','2014-01-06','12:25:00',2.45),('5819','2014-01-06','12:30:00',2.42),('5819','2014-01-06','12:35:00',2.39),('5819','2014-01-06','12:40:00',2.39),('5819','2014-01-06','12:45:00',2.38),('5819','2014-01-06','12:50:00',2.39),('5819','2014-01-06','12:55:00',2.33),('5819','2014-01-06','13:00:00',2.29),('5819','2014-01-06','13:05:00',2.24),('5819','2014-01-06','13:10:00',2.24),('5819','2014-01-06','13:15:00',2.3),('5819','2014-01-06','13:20:00',2.25),('5819','2014-01-06','13:25:00',2.23),('5819','2014-01-06','13:30:00',2.07),('5819','2014-01-06','13:35:00',2.01),('5819','2014-01-06','13:40:00',1.97),('5819','2014-01-06','13:45:00',1.91),('5819','2014-01-06','13:50:00',1.88),('5819','2014-01-06','13:55:00',1.82),('5819','2014-01-06','14:00:00',1.48),('5819','2014-01-06','14:20:00',1.86),('5819','2014-01-06','14:35:00',1.08),('5819','2014-01-06','14:40:00',1.47),('5819','2014-01-06','14:45:00',1.64),('5819','2014-01-06','14:50:00',1.39),('5819','2014-01-06','15:05:00',1.04),('5819','2014-01-06','15:10:00',1.01),('5819','2014-01-03','08:55:00',1.01),('5819','2014-01-03','09:10:00',1.01),('5819','2014-01-03','09:20:00',1.49),('5819','2014-01-03','09:30:00',1.58),('5819','2014-01-03','09:35:00',1.86),('5819','2014-01-03','09:40:00',2.1),('5819','2014-01-03','09:45:00',2.11),('5819','2014-01-03','09:50:00',1.28),('5819','2014-01-03','09:55:00',1.25),('5819','2014-01-03','10:00:00',1.56),('5819','2014-01-03','10:05:00',1.79),('5819','2014-01-03','10:15:00',1.1),('5819','2014-01-03','10:20:00',2.13),('5819','2014-01-03','10:25:00',1.07),('5819','2014-01-03','10:30:00',1.05),('5819','2014-01-03','10:40:00',1.13),('5819','2014-01-03','10:45:00',1.29),('5819','2014-01-03','10:50:00',1.28),('5819','2014-01-03','10:55:00',1.07),('5819','2014-01-03','11:05:00',1.03),('5819','2014-01-03','11:45:00',1.01),('5819','2014-01-03','11:50:00',1.03),('5819','2014-01-03','12:00:00',1.04),('5819','2014-01-03','12:05:00',1.5),('5819','2014-01-03','12:10:00',1.63),('5819','2014-01-03','12:15:00',1.46),('5819','2014-01-03','12:20:00',1.01),('5819','2014-01-03','12:25:00',1.01),('5819','2014-01-03','12:30:00',1.07),('5819','2014-01-03','12:35:00',1.27),('5819','2014-01-03','12:40:00',1.3),('5819','2014-01-03','12:45:00',1.65),('5819','2014-01-03','12:50:00',1.32),('5819','2014-01-03','12:55:00',1.9),('5819','2014-01-03','13:00:00',1.4),('5819','2014-01-03','13:05:00',1.03),('5819','2014-01-03','13:10:00',1.43),('5819','2014-01-03','13:15:00',1.19),('5819','2014-01-03','13:30:00',1.03),('5819','2014-01-03','13:35:00',1.4),('5819','2014-01-03','13:40:00',1.31),('5819','2014-01-03','13:45:00',1.25),('5819','2014-01-02','08:40:00',1.05),('5819','2014-01-02','08:45:00',1.12),('5819','2014-01-02','08:50:00',1.22),('5819','2014-01-02','08:55:00',1.29),('5819','2014-01-02','09:00:00',1.36),('5819','2014-01-02','09:05:00',1.44),('5819','2014-01-02','09:10:00',1.51),('5819','2014-01-02','09:15:00',1.56),('5819','2014-01-02','09:20:00',1.64),('5819','2014-01-02','09:25:00',1.69),('5819','2014-01-02','09:30:00',1.72),('5819','2014-01-02','09:35:00',1.77),('5819','2014-01-02','09:40:00',1.81),('5819','2014-01-02','09:45:00',1.86),('5819','2014-01-02','09:50:00',1.91),('5819','2014-01-02','09:55:00',1.95),('5819','2014-01-02','10:00:00',2.02),('5819','2014-01-02','10:05:00',2.12),('5819','2014-01-02','10:10:00',2.12),('5819','2014-01-02','10:15:00',2.09),('5819','2014-01-02','10:20:00',2.14),('5819','2014-01-02','10:25:00',2.21),('5819','2014-01-02','10:30:00',2.24),('5819','2014-01-02','10:35:00',2.26),('5819','2014-01-02','10:40:00',2.25),('5819','2014-01-02','10:45:00',2.28),('5819','2014-01-02','10:50:00',2.32),('5819','2014-01-02','10:55:00',2.41),('5819','2014-01-02','11:00:00',2.38),('5819','2014-01-02','11:05:00',2.44),('5819','2014-01-02','11:10:00',1.84),('5819','2014-01-02','11:15:00',1.45),('5819','2014-01-02','11:20:00',1.18),('5819','2014-01-02','11:25:00',1.32),('5819','2014-01-02','11:30:00',1.48),('5819','2014-01-02','11:35:00',1.52),('5819','2014-01-02','11:40:00',1.53),('5819','2014-01-02','11:45:00',1.49),('5819','2014-01-02','11:50:00',1.32),('5819','2014-01-02','11:55:00',1.15),('5819','2014-01-02','12:00:00',1.07),('5819','2014-01-02','12:05:00',1.1),('5819','2014-01-02','12:10:00',1.2),('5819','2014-01-02','12:15:00',1),('5819','2014-01-02','12:50:00',1.36),('5819','2014-01-02','12:55:00',2.01),('5819','2014-01-02','13:00:00',1.6),('5819','2014-01-02','13:40:00',1.72),('5819','2014-01-02','13:45:00',1.1),('5819','2014-01-01','08:55:00',1.42),('5819','2014-01-01','09:00:00',1.61),('5819','2014-01-01','09:05:00',1.34),('5819','2014-01-01','09:10:00',1.86),('5819','2014-01-01','09:20:00',1),('5819','2014-01-01','09:25:00',1.03),('5819','2014-01-01','09:30:00',2.04),('5819','2014-01-01','09:35:00',1.23),('5819','2014-01-01','09:40:00',1.58),('5819','2014-01-01','09:45:00',1.76),('5819','2014-01-01','09:50:00',2.26),('5819','2014-01-01','09:55:00',1.44),('5819','2014-01-01','10:00:00',1.13),('5819','2014-01-01','10:05:00',1.02),('5819','2014-01-01','12:10:00',1.04),('5819','2014-01-01','12:15:00',1.08),('5819','2014-01-01','12:20:00',1.12),('5819','2014-01-01','12:25:00',1.12),('5819','2014-01-01','12:30:00',1.18),('5819','2014-01-01','12:35:00',1.2),('5819','2014-01-01','12:40:00',1.12),('5819','2014-01-01','12:45:00',1.12),('5819','2014-01-01','12:50:00',1.12),('5819','2014-01-01','12:55:00',1.09),('5819','2014-01-01','13:00:00',1.07),('5819','2014-01-01','13:30:00',1.13),('5819','2014-01-01','13:35:00',1.54),('5819','2014-01-01','13:40:00',2.56),('5819','2014-01-01','13:45:00',1.32),('5819','2014-01-01','13:50:00',1.16),('5819','2014-01-01','13:55:00',1.18),('5819','2014-01-01','14:00:00',1.68),('5819','2014-01-01','14:05:00',1),('5819','2014-01-01','14:15:00',1.03),('5819','2014-01-01','15:05:00',1.01),('5819','2014-01-01','15:10:00',1.21),('5819','2014-01-01','15:15:00',1.08),('5819','2013-12-31','08:45:00',1.15),('5819','2013-12-31','08:50:00',1.31),('5819','2013-12-31','08:55:00',1.13),('5819','2013-12-31','09:00:00',1.56),('5819','2013-12-31','09:05:00',1.59),('5819','2013-12-31','09:10:00',1.28),('5819','2013-12-31','09:15:00',1.39),('5819','2013-12-31','09:20:00',1.78),('5819','2013-12-31','09:25:00',1.84),('5819','2013-12-31','09:30:00',1.99),('5819','2013-12-31','09:35:00',2.06),('5819','2013-12-31','09:40:00',2.04),('5819','2013-12-31','09:45:00',2.11),('5819','2013-12-31','09:50:00',1.91),('5819','2013-12-31','09:55:00',1.28),('5819','2013-12-31','10:05:00',1),('5819','2013-12-31','10:10:00',1.15),('5819','2013-12-31','10:30:00',1.03),('5819','2013-12-31','10:50:00',1.09),('5819','2013-12-31','10:55:00',1.24),('5819','2013-12-31','11:00:00',1.28),('5819','2013-12-31','11:05:00',1.17),('5819','2013-12-31','11:10:00',1.89),('5819','2013-12-31','11:15:00',2.15),('5819','2013-12-31','11:20:00',1.81),('5819','2013-12-31','11:25:00',2.03),('5819','2013-12-31','11:30:00',2.11),('5819','2013-12-31','11:35:00',1.04),('5819','2013-12-31','11:40:00',2.3),('5819','2013-12-31','11:45:00',1.36),('5819','2013-12-31','11:50:00',1.6),('5819','2013-12-31','11:55:00',2.57),('5819','2013-12-31','12:00:00',2.69),('5819','2013-12-31','12:05:00',2.63),('5819','2013-12-31','12:10:00',2.61),('5819','2013-12-31','12:15:00',2.58),('5819','2013-12-31','12:20:00',2.55),('5819','2013-12-31','12:25:00',2.52),('5819','2013-12-31','12:30:00',2.49),('5819','2013-12-31','12:35:00',2.44),('5819','2013-12-31','12:40:00',2.41),('5819','2013-12-31','12:45:00',2.39),('5819','2013-12-31','12:50:00',2.36),('5819','2013-12-31','12:55:00',2.33),('5819','2013-12-31','13:00:00',2.31),('5819','2013-12-31','13:05:00',2.28),('5819','2013-12-31','13:10:00',2.23),('5819','2013-12-31','13:15:00',2.2),('5819','2013-12-31','13:20:00',2.16),('5819','2013-12-31','13:25:00',2.13),('5819','2013-12-31','13:30:00',2.09),('5819','2013-12-31','13:35:00',2.03),('5819','2013-12-31','13:40:00',1.97),('5819','2013-12-31','13:45:00',1.93),('5819','2013-12-31','13:50:00',1.87),('5819','2013-12-31','13:55:00',1.81),('5819','2013-12-31','14:00:00',1.76),('5819','2013-12-31','14:05:00',1.71),('5819','2013-12-31','14:10:00',1.65),('5819','2013-12-31','14:15:00',1.6),('5819','2013-12-31','14:20:00',1.54),('5819','2013-12-31','14:25:00',1.49),('5819','2013-12-31','14:30:00',1.43),('5819','2013-12-31','14:35:00',1.36),('5819','2013-12-31','14:40:00',1.3),('5819','2013-12-31','14:45:00',1.23),('5819','2013-12-31','14:50:00',1.17),('5819','2013-12-31','14:55:00',1.11),('5819','2013-12-31','15:00:00',1.05),('5819','2013-12-29','08:40:00',1.45),('5819','2013-12-29','08:45:00',1.29),('5819','2013-12-29','09:05:00',1.01),('5819','2013-12-29','09:10:00',1.42),('5819','2013-12-29','09:15:00',1.54),('5819','2013-12-29','09:20:00',1.76),('5819','2013-12-29','09:25:00',1.78),('5819','2013-12-29','09:30:00',1.84),('5819','2013-12-29','09:35:00',1.87),('5819','2013-12-29','09:40:00',1.96),('5819','2013-12-29','09:45:00',1.99),('5819','2013-12-29','09:50:00',1.92),('5819','2013-12-29','09:55:00',1.61),('5819','2013-12-29','10:00:00',1.72),('5819','2013-12-29','10:05:00',1.85),('5819','2013-12-29','10:10:00',1.43),('5819','2013-12-29','10:15:00',2.24),('5819','2013-12-29','10:20:00',2.38),('5819','2013-12-29','10:25:00',2.05),('5819','2013-12-29','10:30:00',2.52),('5819','2013-12-29','10:35:00',2.69),('5819','2013-12-29','10:40:00',2.97),('5819','2013-12-29','10:45:00',1.07),('5819','2013-12-29','10:50:00',1.24),('5819','2013-12-29','11:00:00',1.23),('5819','2013-12-28','08:35:00',1.08),('5819','2013-12-28','08:40:00',1.15),('5819','2013-12-28','08:45:00',1.23),('5819','2013-12-28','08:50:00',1.31),('5819','2013-12-28','08:55:00',1.38),('5819','2013-12-28','09:00:00',1.45),('5819','2013-12-28','09:05:00',1.5),('5819','2013-12-28','09:10:00',1.57),('5819','2013-12-28','09:15:00',1.65),('5819','2013-12-28','09:20:00',1.73),('5819','2013-12-28','09:25:00',1.8),('5819','2013-12-28','09:30:00',1.86),('5819','2013-12-28','09:35:00',1.89),('5819','2013-12-28','09:40:00',1.94),('5819','2013-12-28','09:45:00',1.99),('5819','2013-12-28','09:50:00',2.06),('5819','2013-12-28','09:55:00',2.1),('5819','2013-12-28','10:00:00',2.14),('5819','2013-12-28','10:05:00',2.16),('5819','2013-12-28','10:10:00',2.2),('5819','2013-12-28','10:15:00',2.23),('5819','2013-12-28','10:20:00',2.27),('5819','2013-12-28','10:25:00',2.31),('5819','2013-12-28','10:30:00',2.35),('5819','2013-12-28','10:35:00',2.38),('5819','2013-12-28','10:40:00',2.4),('5819','2013-12-28','10:45:00',2.41),('5819','2013-12-28','10:50:00',2.42),('5819','2013-12-28','10:55:00',2.44),('5819','2013-12-28','11:00:00',2.47),('5819','2013-12-28','11:05:00',2.49),('5819','2013-12-28','11:10:00',2.49),('5819','2013-12-28','11:15:00',2.5),('5819','2013-12-28','11:20:00',2.51),('5819','2013-12-28','11:25:00',2.53),('5819','2013-12-28','11:30:00',2.52),('5819','2013-12-28','11:35:00',2.52),('5819','2013-12-28','11:40:00',2.52),('5819','2013-12-28','11:45:00',2.52),('5819','2013-12-28','11:50:00',2.51),('5819','2013-12-28','11:55:00',2.5),('5819','2013-12-28','12:00:00',2.48),('5819','2013-12-28','12:05:00',2.43),('5819','2013-12-28','12:10:00',2.47),('5819','2013-12-28','12:15:00',2.47),('5819','2013-12-28','12:20:00',2.44),('5819','2013-12-28','12:25:00',2.41),('5819','2013-12-28','12:30:00',2.36),('5819','2013-12-28','12:35:00',2.34),('5819','2013-12-28','12:40:00',2.3),('5819','2013-12-28','12:45:00',2.29),('5819','2013-12-28','12:50:00',2.25),('5819','2013-12-28','12:55:00',2.22),('5819','2013-12-28','13:00:00',2.18),('5819','2013-12-28','13:05:00',2.14),('5819','2013-12-28','13:10:00',2.1),('5819','2013-12-28','13:15:00',2.06),('5819','2013-12-28','13:20:00',2.01),('5819','2013-12-28','13:25:00',1.96),('5819','2013-12-28','13:30:00',1.91),('5819','2013-12-28','13:35:00',1.87),('5819','2013-12-28','13:40:00',1.82),('5819','2013-12-28','13:45:00',1.75),('5819','2013-12-28','13:50:00',1.71),('5819','2013-12-28','13:55:00',1.66),('5819','2013-12-28','14:00:00',1.59),('5819','2013-12-28','14:05:00',1.55),('5819','2013-12-28','14:10:00',1.48),('5819','2013-12-28','14:15:00',1.43),('5819','2013-12-28','14:20:00',1.34),('5819','2013-12-28','14:25:00',1.31),('5819','2013-12-28','14:30:00',1.25),('5819','2013-12-28','14:35:00',1.19),('5819','2013-12-28','14:40:00',1.13),('5819','2014-04-23','13:15:00',1.07),('5819','2014-04-23','13:20:00',1.1),('5819','2014-04-23','13:25:00',1.16),('5819','2014-04-23','13:30:00',1.24),('5819','2014-04-23','13:35:00',1.3),('5819','2014-04-23','13:40:00',1.4),('5819','2014-04-23','13:45:00',1.43),('5819','2014-04-23','13:50:00',1.42),('5819','2014-04-23','13:55:00',1.38),('5819','2014-04-23','14:00:00',1.3),('5819','2014-04-23','14:05:00',1.33),('5819','2014-04-23','14:10:00',1.22),('5819','2014-04-23','14:15:00',1.05),('5819','2014-04-23','14:45:00',1.13),('5819','2014-04-23','14:50:00',1.36),('5819','2014-04-23','14:55:00',1.54),('5819','2014-04-23','15:00:00',1.63),('5819','2014-04-23','15:05:00',1.64),('5819','2014-04-23','15:10:00',1.59),('5819','2014-04-23','15:15:00',1.57),('5819','2014-04-23','15:20:00',1.33),('5819','2014-04-23','15:25:00',1.28),('5819','2014-04-23','15:30:00',1.27),('5819','2014-04-23','15:35:00',1.19),('5819','2014-04-23','15:40:00',1.2),('5819','2014-04-23','15:45:00',1.08),('5819','2013-12-27','12:10:00',1.34),('5819','2013-12-27','12:15:00',2.28),('5819','2013-12-27','12:20:00',1.43),('5819','2013-12-27','12:25:00',1.44),('5819','2013-12-27','12:30:00',1.02),('5819','2013-12-27','12:35:00',1.11),('5819','2013-12-27','12:40:00',1.47),('5819','2013-12-27','12:45:00',1.9),('5819','2013-12-27','12:50:00',2.18),('5819','2013-12-27','12:55:00',2.22),('5819','2013-12-27','13:00:00',2.21),('5819','2013-12-27','13:05:00',1.94),('5819','2013-12-27','13:10:00',1.06),('5819','2013-12-27','13:15:00',1.26),('5819','2013-12-27','13:20:00',1.16),('5819','2013-12-27','13:25:00',1.21),('5819','2013-12-27','13:30:00',1.99),('5819','2013-12-27','13:35:00',2.13),('5819','2013-12-27','13:40:00',1.3),('5819','2013-12-27','13:45:00',1.25),('5819','2013-12-27','13:50:00',1.02),('5819','2013-12-27','14:20:00',1.07),('5819','2013-12-27','14:35:00',1.05),('5819','2013-12-27','14:40:00',1.1),('5819','2013-12-25','10:30:00',1.42),('5819','2013-12-25','10:35:00',1.59),('5819','2013-12-25','10:40:00',1.61),('5819','2013-12-25','10:45:00',1.38),('5819','2013-12-25','10:50:00',1.62),('5819','2013-12-25','11:15:00',1.26),('5819','2013-12-25','11:20:00',1.5),('5819','2013-12-25','11:25:00',1.67),('5819','2013-12-25','11:30:00',1.63),('5819','2013-12-25','11:35:00',1.14),('5819','2013-12-25','11:40:00',1.77),('5819','2013-12-25','11:45:00',1.86),('5819','2013-12-25','11:50:00',1.27),('5819','2013-12-25','11:55:00',2.21),('5819','2013-12-25','12:00:00',2.45),('5819','2013-12-25','12:15:00',1.14),('5819','2013-12-25','12:20:00',1.64),('5819','2013-12-25','12:25:00',1.18),('5819','2013-12-25','12:30:00',1.41),('5819','2013-12-25','12:35:00',1.49),('5819','2013-12-25','12:40:00',1.07),('5819','2013-12-25','12:50:00',1.36),('5819','2013-12-25','13:30:00',1.13),('5819','2013-12-25','13:40:00',1),('5819','2013-12-25','13:45:00',1.07),('5819','2013-12-25','13:50:00',1.18),('5819','2013-12-25','13:55:00',1.17),('5819','2013-12-24','08:55:00',1.14),('5819','2013-12-24','09:00:00',1.28),('5819','2013-12-24','09:05:00',1.37),('5819','2013-12-24','09:10:00',1.42),('5819','2013-12-24','09:15:00',1.47),('5819','2013-12-24','09:20:00',1.52),('5819','2013-12-24','09:25:00',1.57),('5819','2013-12-24','09:30:00',1.65),('5819','2013-12-24','09:35:00',1.74),('5819','2013-12-24','09:40:00',1.82),('5819','2013-12-24','09:45:00',1.84),('5819','2013-12-24','09:50:00',1.83),('5819','2013-12-24','09:55:00',1.87),('5819','2013-12-24','10:00:00',1.85),('5819','2013-12-24','10:05:00',1.87),('5819','2013-12-24','10:10:00',1.97),('5819','2013-12-24','10:15:00',2.06),('5819','2013-12-24','10:20:00',2.06),('5819','2013-12-24','10:25:00',2.09),('5819','2013-12-24','10:30:00',2.14),('5819','2013-12-24','10:35:00',2.16),('5819','2013-12-24','10:40:00',2.19),('5819','2013-12-24','10:45:00',2.24),('5819','2013-12-24','10:50:00',2.25),('5819','2013-12-24','10:55:00',2.24),('5819','2013-12-24','11:00:00',2.25),('5819','2013-12-24','11:05:00',2.28),('5819','2013-12-24','11:10:00',2.25),('5819','2013-12-24','11:15:00',2.28),('5819','2013-12-24','11:20:00',2.31),('5819','2013-12-24','11:25:00',2.33),('5819','2013-12-24','11:30:00',2.34),('5819','2013-12-24','11:35:00',2.34),('5819','2013-12-24','11:40:00',2.35),('5819','2013-12-24','11:45:00',2.34),('5819','2013-12-24','11:50:00',2.31),('5819','2013-12-24','11:55:00',2.28),('5819','2013-12-24','12:00:00',2.26),('5819','2013-12-24','12:05:00',2.23),('5819','2013-12-24','12:10:00',2.2),('5819','2013-12-24','12:15:00',2.19),('5819','2013-12-24','12:20:00',2.19),('5819','2013-12-24','12:25:00',2.16),('5819','2013-12-24','12:30:00',2.13),('5819','2013-12-24','12:35:00',2.09),('5819','2013-12-24','12:40:00',2.04),('5819','2013-12-24','12:45:00',2.02),('5819','2013-12-24','12:50:00',2.01),('5819','2013-12-24','12:55:00',2),('5819','2013-12-24','13:00:00',1.94),('5819','2013-12-24','13:05:00',1.91),('5819','2013-12-24','13:10:00',1.87),('5819','2013-12-24','13:15:00',1.83),('5819','2013-12-24','13:20:00',1.78),('5819','2013-12-24','13:25:00',1.74),('5819','2013-12-24','13:30:00',1.7),('5819','2013-12-24','13:35:00',1.66),('5819','2013-12-24','13:40:00',1.6),('5819','2013-12-24','13:45:00',1.53),('5819','2013-12-24','13:50:00',1.51),('5819','2013-12-24','13:55:00',1.44),('5819','2013-12-24','14:00:00',1.38),('5819','2013-12-24','14:05:00',1.34),('5819','2013-12-24','14:10:00',1.31),('5819','2013-12-24','14:15:00',1.25),('5819','2013-12-24','14:20:00',1.21),('5819','2013-12-24','14:25:00',1.14),('5819','2013-12-24','14:30:00',1.04),('5819','2013-12-23','09:35:00',1.02),('5819','2013-12-23','09:40:00',1.11),('5819','2013-12-23','09:45:00',1.1),('5819','2013-12-23','09:50:00',1.2),('5819','2013-12-23','09:55:00',1.64),('5819','2013-12-23','10:00:00',1.92),('5819','2013-12-23','10:05:00',2.1),('5819','2013-12-23','10:10:00',2.18),('5819','2013-12-23','10:15:00',1.99),('5819','2013-12-23','10:20:00',2.16),('5819','2013-12-23','10:25:00',2.09),('5819','2013-12-23','10:30:00',1.94),('5819','2013-12-23','10:35:00',1.96),('5819','2013-12-23','10:40:00',2.01),('5819','2013-12-23','10:45:00',2.03),('5819','2013-12-23','10:50:00',2),('5819','2013-12-23','10:55:00',2.06),('5819','2013-12-23','11:00:00',2.41),('5819','2013-12-23','11:05:00',2.51),('5819','2013-12-23','11:10:00',2.54),('5819','2013-12-23','11:15:00',2.55),('5819','2013-12-23','11:20:00',2.41),('5819','2013-12-23','11:25:00',2.49),('5819','2013-12-23','11:30:00',2.34),('5819','2013-12-23','11:35:00',2.43),('5819','2013-12-23','11:40:00',2.49),('5819','2013-12-23','11:45:00',2.18),('5819','2013-12-23','11:50:00',2.2),('5819','2013-12-23','11:55:00',2.24),('5819','2013-12-23','12:00:00',2.3),('5819','2013-12-23','12:05:00',2.36),('5819','2013-12-23','12:10:00',2.3),('5819','2013-12-23','12:15:00',2.25),('5819','2013-12-23','12:20:00',2.23),('5819','2013-12-23','12:25:00',2.21),('5819','2013-12-23','12:30:00',2.34),('5819','2013-12-23','12:35:00',2.31),('5819','2013-12-23','12:40:00',2.28),('5819','2013-12-23','12:45:00',2.25),('5819','2013-12-23','12:50:00',2.22),('5819','2013-12-23','12:55:00',2.2),('5819','2013-12-23','13:00:00',2.17),('5819','2013-12-23','13:05:00',2.13),('5819','2013-12-23','13:10:00',2.09),('5819','2013-12-23','13:15:00',2.03),('5819','2013-12-23','13:20:00',1.89),('5819','2013-12-23','13:25:00',1.62),('5819','2013-12-23','13:30:00',1.89),('5819','2013-12-23','13:40:00',1.42),('5819','2013-12-23','13:45:00',1.34),('5819','2013-12-23','13:50:00',1.22),('5819','2013-12-23','13:55:00',1.42),('5819','2013-12-23','14:00:00',1.64),('5819','2013-12-23','14:05:00',1.59),('5819','2013-12-23','14:10:00',1.54),('5819','2013-12-23','14:15:00',1.46),('5819','2013-12-23','14:20:00',1.36),('5819','2013-12-23','14:25:00',1.31),('5819','2013-12-23','14:30:00',1.18),('5819','2013-12-23','14:35:00',1.17),('5819','2013-12-23','14:40:00',1.12),('5819','2013-12-23','14:45:00',1.09),('5819','2013-12-23','14:50:00',1.04),('5819','2013-12-22','09:05:00',1.2),('5819','2013-12-22','09:10:00',1.24),('5819','2013-12-22','09:15:00',1.21),('5819','2013-12-22','09:20:00',1.36),('5819','2013-12-22','09:25:00',1.3),('5819','2013-12-22','09:30:00',1.34),('5819','2013-12-22','09:35:00',1.61),('5819','2013-12-22','09:40:00',2.21),('5819','2013-12-22','09:45:00',2.26),('5819','2013-12-22','09:50:00',2.38),('5819','2013-12-22','09:55:00',2.41),('5819','2013-12-22','10:00:00',2.39),('5819','2013-12-22','10:05:00',2.4),('5819','2013-12-22','10:10:00',2.44),('5819','2013-12-22','10:15:00',2.38),('5819','2013-12-22','10:20:00',2.29),('5819','2013-12-22','10:25:00',2.3),('5819','2013-12-22','10:30:00',2.4),('5819','2013-12-22','10:35:00',2.26),('5819','2013-12-22','10:40:00',2.12),('5819','2013-12-22','10:45:00',2.18),('5819','2013-12-22','10:50:00',2.29),('5819','2013-12-22','10:55:00',2.13),('5819','2013-12-22','11:00:00',1.88),('5819','2013-12-22','11:05:00',1.82),('5819','2013-12-22','11:10:00',2.45),('5819','2013-12-22','11:15:00',2.42),('5819','2013-12-22','11:20:00',2.19),('5819','2013-12-22','11:25:00',2.23),('5819','2013-12-22','11:30:00',2.09),('5819','2013-12-22','11:35:00',2.05),('5819','2013-12-22','11:40:00',2.21),('5819','2013-12-22','11:45:00',2.07),('5819','2013-12-22','11:50:00',1.56),('5819','2013-12-22','11:55:00',1.16),('5819','2013-12-22','12:20:00',1.07),('5819','2013-12-22','12:25:00',1.15),('5819','2013-12-22','12:30:00',1.38),('5819','2013-12-22','12:35:00',1.62),('5819','2013-12-22','12:40:00',1.57),('5819','2013-12-22','12:45:00',1.46),('5819','2013-12-22','12:50:00',1.75),('5819','2013-12-22','12:55:00',2.18),('5819','2013-12-22','13:00:00',2.08),('5819','2013-12-22','13:05:00',2.48),('5819','2013-12-22','13:10:00',2.51),('5819','2013-12-22','13:15:00',1.94),('5819','2013-12-22','13:20:00',1.84),('5819','2013-12-22','13:25:00',1.83),('5819','2013-12-22','13:30:00',1.7),('5819','2013-12-22','13:35:00',1.62),('5819','2013-12-22','13:40:00',1.29),('5819','2013-12-22','13:45:00',1.46),('5819','2013-12-22','13:50:00',1.4),('5819','2013-12-22','13:55:00',1.2),('5819','2013-12-22','14:00:00',1.1),('5819','2013-12-22','14:05:00',1.19),('5819','2013-12-22','14:10:00',1.37),('5819','2013-12-22','14:15:00',1.02),('5819','2013-12-22','14:20:00',1.02),('5819','2013-12-22','14:40:00',1.05),('5819','2013-12-22','14:45:00',1.02),('5819','2013-12-21','08:40:00',1.07),('5819','2013-12-21','08:45:00',1.15),('5819','2013-12-21','08:50:00',1.23),('5819','2013-12-21','08:55:00',1.29),('5819','2013-12-21','09:00:00',1.37),('5819','2013-12-21','09:05:00',1.42),('5819','2013-12-21','09:10:00',1.47),('5819','2013-12-21','09:15:00',1.54),('5819','2013-12-21','09:20:00',1.6),('5819','2013-12-21','09:25:00',1.65),('5819','2013-12-21','09:30:00',1.71),('5819','2013-12-21','09:35:00',1.77),('5819','2013-12-21','09:40:00',1.81),('5819','2013-12-21','09:45:00',1.86),('5819','2013-12-21','09:50:00',1.91),('5819','2013-12-21','09:55:00',1.98),('5819','2013-12-21','10:00:00',2.03),('5819','2013-12-21','10:05:00',2.08),('5819','2013-12-21','10:10:00',2.11),('5819','2013-12-21','10:15:00',2.14),('5819','2013-12-21','10:20:00',2.17),('5819','2013-12-21','10:25:00',2.21),('5819','2013-12-21','10:30:00',2.26),('5819','2013-12-21','10:35:00',2.29),('5819','2013-12-21','10:40:00',2.3),('5819','2013-12-21','10:45:00',2.33),('5819','2013-12-21','10:50:00',2.35),('5819','2013-12-21','10:55:00',2.37),('5819','2013-12-21','11:00:00',2.4),('5819','2013-12-21','11:05:00',2.42),('5819','2013-12-21','11:10:00',2.43),('5819','2013-12-21','11:15:00',2.44),('5819','2013-12-21','11:20:00',2.46),('5819','2013-12-21','11:25:00',2.48),('5819','2013-12-21','11:30:00',2.49),('5819','2013-12-21','11:35:00',2.48),('5819','2013-12-21','11:40:00',2.48),('5819','2013-12-21','11:45:00',2.48),('5819','2013-12-21','11:50:00',2.48),('5819','2013-12-21','11:55:00',2.48),('5819','2013-12-21','12:00:00',2.47),('5819','2013-12-21','12:05:00',2.46),('5819','2013-12-21','12:10:00',2.45),('5819','2013-12-21','12:15:00',2.42),('5819','2013-12-21','12:20:00',2.4),('5819','2013-12-21','12:25:00',2.38),('5819','2013-12-21','12:30:00',2.36),('5819','2013-12-21','12:35:00',2.34),('5819','2013-12-21','12:40:00',2.31),('5819','2013-12-21','12:45:00',2.28),('5819','2013-12-21','12:50:00',2.26),('5819','2013-12-21','12:55:00',2.24),('5819','2013-12-21','13:00:00',2.18),('5819','2013-12-21','13:05:00',2.15),('5819','2013-12-21','13:10:00',2.12),('5819','2013-12-21','13:15:00',2.07),('5819','2013-12-21','13:20:00',2.01),('5819','2013-12-21','13:25:00',1.98),('5819','2013-12-21','13:30:00',1.93),('5819','2013-12-21','13:35:00',1.87),('5819','2013-12-21','13:40:00',1.83),('5819','2013-12-21','13:45:00',1.79),('5819','2013-12-21','13:50:00',1.73),('5819','2013-12-21','13:55:00',1.68),('5819','2013-12-21','14:00:00',1.63),('5819','2013-12-21','14:05:00',1.57),('5819','2013-12-21','14:10:00',1.5),('5819','2013-12-21','14:15:00',1.48),('5819','2013-12-21','14:20:00',1.44),('5819','2013-12-21','14:25:00',1.37),('5819','2013-12-21','14:30:00',1.31),('5819','2013-12-21','14:35:00',1.25),('5819','2013-12-21','14:40:00',1.19),('5819','2013-12-21','14:45:00',1.13),('5819','2013-12-21','14:50:00',1.05),('5819','2013-12-20','08:40:00',1.04),('5819','2013-12-20','08:45:00',1.08),('5819','2013-12-20','08:50:00',1.12),('5819','2013-12-20','08:55:00',1.18),('5819','2013-12-20','09:00:00',1.25),('5819','2013-12-20','09:05:00',1.33),('5819','2013-12-20','09:10:00',1.41),('5819','2013-12-20','09:15:00',1.47),('5819','2013-12-20','09:20:00',1.54),('5819','2013-12-20','09:25:00',1.62),('5819','2013-12-20','09:30:00',1.67),('5819','2013-12-20','09:35:00',1.73),('5819','2013-12-20','09:40:00',1.79),('5819','2013-12-20','09:45:00',1.84),('5819','2013-12-20','09:50:00',1.88),('5819','2013-12-20','09:55:00',1.9),('5819','2013-12-20','10:00:00',1.94),('5819','2013-12-20','10:05:00',2),('5819','2013-12-20','10:10:00',2.01),('5819','2013-12-20','10:15:00',2.04),('5819','2013-12-20','10:20:00',2.07),('5819','2013-12-20','10:25:00',2.12),('5819','2013-12-20','10:30:00',2.13),('5819','2013-12-20','10:35:00',2.16),('5819','2013-12-20','10:40:00',2.2),('5819','2013-12-20','10:45:00',2.22),('5819','2013-12-20','10:50:00',2.25),('5819','2013-12-20','10:55:00',2.27),('5819','2013-12-20','11:00:00',2.29),('5819','2013-12-20','11:05:00',2.3),('5819','2013-12-20','11:10:00',2.29),('5819','2013-12-20','11:15:00',2.3),('5819','2013-12-20','11:20:00',2.31),('5819','2013-12-20','11:25:00',2.32),('5819','2013-12-20','11:30:00',2.31),('5819','2013-12-20','11:35:00',2.3),('5819','2013-12-20','11:40:00',2.33),('5819','2013-12-20','11:45:00',2.33),('5819','2013-12-20','11:50:00',2.34),('5819','2013-12-20','11:55:00',2.36),('5819','2013-12-20','12:00:00',2.31),('5819','2013-12-20','12:05:00',2.29),('5819','2013-12-20','12:10:00',2.31),('5819','2013-12-20','12:15:00',2.28),('5819','2013-12-20','12:20:00',2.26),('5819','2013-12-20','12:25:00',2.21),('5819','2013-12-20','12:30:00',2.21),('5819','2013-12-20','12:35:00',2.18),('5819','2013-12-20','12:40:00',2.15),('5819','2013-12-20','12:45:00',2.1),('5819','2013-12-20','12:50:00',2.06),('5819','2013-12-20','12:55:00',2.05),('5819','2013-12-20','13:00:00',2.03),('5819','2013-12-20','13:05:00',2),('5819','2013-12-20','13:10:00',1.97),('5819','2013-12-20','13:15:00',1.91),('5819','2013-12-20','13:20:00',1.83),('5819','2013-12-20','13:25:00',1.8),('5819','2013-12-20','13:30:00',1.76),('5819','2013-12-20','13:35:00',1.71),('5819','2013-12-20','13:40:00',1.65),('5819','2013-12-20','13:45:00',1.62),('5819','2013-12-20','13:50:00',1.55),('5819','2013-12-20','13:55:00',1.46),('5819','2013-12-20','14:00:00',1.35),('5819','2013-12-20','14:05:00',1.08),('5819','2013-12-19','08:50:00',1.12),('5819','2013-12-19','08:55:00',1.25),('5819','2013-12-19','09:00:00',1.46),('5819','2013-12-19','09:05:00',1.59),('5819','2013-12-19','09:10:00',1.49),('5819','2013-12-19','09:15:00',1.42),('5819','2013-12-19','09:20:00',1.01),('5819','2013-12-19','09:25:00',1.81),('5819','2013-12-19','09:30:00',1.11),('5819','2013-12-19','09:35:00',1.44),('5819','2013-12-19','09:50:00',1.44),('5819','2013-12-19','09:55:00',2.17),('5819','2013-12-19','10:00:00',2.01),('5819','2013-12-19','10:05:00',2.03),('5819','2013-12-19','10:10:00',2.12),('5819','2013-12-19','10:15:00',2.15),('5819','2013-12-19','10:20:00',1.75),('5819','2013-12-19','10:30:00',1.07),('5819','2013-12-19','10:40:00',1.05),('5819','2013-12-19','10:45:00',1.77),('5819','2013-12-19','10:50:00',2.52),('5819','2013-12-19','10:55:00',1.27),('5819','2013-12-19','11:15:00',2.01),('5819','2013-12-19','11:20:00',1.29),('5819','2013-12-19','11:25:00',1.14),('5819','2013-12-19','14:30:00',1.14),('5819','2013-12-19','14:35:00',1.36),('5819','2013-12-19','14:40:00',1.18),('5819','2013-12-19','14:45:00',1.08),('5819','2013-12-18','08:35:00',1.03),('5819','2013-12-18','08:40:00',1.11),('5819','2013-12-18','08:45:00',1.19),('5819','2013-12-18','08:50:00',1.27),('5819','2013-12-18','08:55:00',1.34),('5819','2013-12-18','09:00:00',1.41),('5819','2013-12-18','09:05:00',1.46),('5819','2013-12-18','09:10:00',1.53),('5819','2013-12-18','09:15:00',1.58),('5819','2013-12-18','09:20:00',1.65),('5819','2013-12-18','09:25:00',1.72),('5819','2013-12-18','09:30:00',1.77),('5819','2013-12-18','09:35:00',1.83),('5819','2013-12-18','09:40:00',1.88),('5819','2013-12-18','09:45:00',1.93),('5819','2013-12-18','09:50:00',1.96),('5819','2013-12-18','09:55:00',2.01),('5819','2013-12-18','10:00:00',2.07),('5819','2013-12-18','10:05:00',2.11),('5819','2013-12-18','10:10:00',2.16),('5819','2013-12-18','10:15:00',2.2),('5819','2013-12-18','10:20:00',2.24),('5819','2013-12-18','10:25:00',2.28),('5819','2013-12-18','10:30:00',2.32),('5819','2013-12-18','10:35:00',2.33),('5819','2013-12-18','10:40:00',2.34),('5819','2013-12-18','10:45:00',2.35),('5819','2013-12-18','10:50:00',2.37),('5819','2013-12-18','10:55:00',2.39),('5819','2013-12-18','11:00:00',2.39),('5819','2013-12-18','11:05:00',2.41),('5819','2013-12-18','11:10:00',2.43),('5819','2013-12-18','11:15:00',2.43),('5819','2013-12-18','11:20:00',2.42),('5819','2013-12-18','11:25:00',2.41),('5819','2013-12-18','11:30:00',2.42),('5819','2013-12-18','11:35:00',2.41),('5819','2013-12-18','11:40:00',2.42),('5819','2013-12-18','11:45:00',2.4),('5819','2013-12-18','11:50:00',2.4),('5819','2013-12-18','11:55:00',2.4),('5819','2013-12-18','12:00:00',2.38),('5819','2013-12-18','12:05:00',2.38),('5819','2013-12-18','12:10:00',2.38),('5819','2013-12-18','12:15:00',2.37),('5819','2013-12-18','12:20:00',2.34),('5819','2013-12-18','12:25:00',2.32),('5819','2013-12-18','12:30:00',2.32),('5819','2013-12-18','12:35:00',2.29),('5819','2013-12-18','12:40:00',2.25),('5819','2013-12-18','12:45:00',2.22),('5819','2013-12-18','12:50:00',2.18),('5819','2013-12-18','12:55:00',2.16),('5819','2013-12-18','13:00:00',2.09),('5819','2013-12-18','13:05:00',2.07),('5819','2013-12-18','13:10:00',2.03),('5819','2013-12-18','13:15:00',1.98),('5819','2013-12-18','13:20:00',1.94),('5819','2013-12-18','13:25:00',1.89),('5819','2013-12-18','13:30:00',1.84),('5819','2013-12-18','13:35:00',1.79),('5819','2013-12-18','13:40:00',1.75),('5819','2013-12-18','13:45:00',1.67),('5819','2013-12-18','13:50:00',1.63),('5819','2013-12-18','13:55:00',1.57),('5819','2013-12-18','14:00:00',1.52),('5819','2013-12-18','14:05:00',1.47),('5819','2013-12-18','14:10:00',1.41),('5819','2013-12-18','14:15:00',1.39),('5819','2013-12-18','14:20:00',1.31),('5819','2013-12-18','14:25:00',1.27),('5819','2013-12-18','14:30:00',1.23),('5819','2013-12-18','14:35:00',1.17),('5819','2013-12-18','14:40:00',1.13),('5819','2013-12-18','14:45:00',1.05),('5819','2013-12-18','14:50:00',1.01),('5819','2014-04-22','07:45:00',1.03),('5819','2014-04-22','07:50:00',1.12),('5819','2014-04-22','07:55:00',1.21),('5819','2014-04-22','08:00:00',1.29),('5819','2014-04-22','08:05:00',1.37),('5819','2014-04-22','08:10:00',1.48),('5819','2014-04-22','08:15:00',1.58),('5819','2014-04-22','08:20:00',1.65),('5819','2014-04-22','08:25:00',1.74),('5819','2014-04-22','08:30:00',1.84),('5819','2014-04-22','08:35:00',1.9),('5819','2014-04-22','08:40:00',2.01),('5819','2014-04-22','08:45:00',2.06),('5819','2014-04-22','08:50:00',2.12),('5819','2014-04-22','08:55:00',2.15),('5819','2014-04-22','09:00:00',2.24),('5819','2014-04-22','09:05:00',2.41),('5819','2014-04-22','09:10:00',2.34),('5819','2014-04-22','09:15:00',2.3),('5819','2014-04-22','09:20:00',2.44),('5819','2014-04-22','09:25:00',2.11),('5819','2014-04-22','09:30:00',1.85),('5819','2014-04-22','09:35:00',2.5),('5819','2014-04-22','09:40:00',2.8),('5819','2014-04-22','09:45:00',2.94),('5819','2014-04-22','09:50:00',2.45),('5819','2014-04-22','09:55:00',1.43),('5819','2014-04-22','10:00:00',1.29),('5819','2014-04-22','10:05:00',1.34),('5819','2014-04-22','10:10:00',1.77),('5819','2014-04-22','10:15:00',1.91),('5819','2014-04-22','10:20:00',2.94),('5819','2014-04-22','10:25:00',2.16),('5819','2014-04-22','10:30:00',3.21),('5819','2014-04-22','10:35:00',3.49),('5819','2014-04-22','10:40:00',3.2),('5819','2014-04-22','10:45:00',3.49),('5819','2014-04-22','10:50:00',3.99),('5819','2014-04-22','10:55:00',2.97),('5819','2014-04-22','11:00:00',1.91),('5819','2014-04-22','11:05:00',2.11),('5819','2014-04-22','11:10:00',1.56),('5819','2014-04-22','11:15:00',1.27),('5819','2014-04-22','11:20:00',1.1),('5819','2014-04-22','11:25:00',1.11),('5819','2014-04-22','11:35:00',1.04),('5819','2014-04-22','12:05:00',1.04),('5819','2014-04-22','12:10:00',1.1),('5819','2014-04-22','12:15:00',1.11),('5819','2014-04-22','12:20:00',1.18),('5819','2014-04-22','12:25:00',1.25),('5819','2014-04-22','12:30:00',1.46),('5819','2014-04-22','12:35:00',1.34),('5819','2014-04-22','13:15:00',1.19),('5819','2014-04-22','13:20:00',2.03),('5819','2014-04-22','13:25:00',2.36),('5819','2014-04-22','13:30:00',2.64),('5819','2014-04-22','13:35:00',2.37),('5819','2014-04-22','13:40:00',2.91),('5819','2014-04-22','13:45:00',2.94),('5819','2014-04-22','13:50:00',2.63),('5819','2014-04-22','13:55:00',1.48),('5819','2014-04-22','14:00:00',1.24),('5819','2014-04-22','14:05:00',1.41),('5819','2014-04-22','14:10:00',3.11),('5819','2014-04-22','14:15:00',2.93),('5819','2014-04-22','14:20:00',3.2),('5819','2014-04-22','14:25:00',2.64),('5819','2014-04-22','14:30:00',1.8),('5819','2014-04-22','14:35:00',2.08),('5819','2014-04-22','14:40:00',2.83),('5819','2014-04-22','14:45:00',3.4),('5819','2014-04-22','14:50:00',3.13),('5819','2014-04-22','14:55:00',2.52),('5819','2014-04-22','15:00:00',1.25),('5819','2014-04-22','15:05:00',1.2),('5819','2014-04-22','15:10:00',1.1),('5819','2014-04-22','15:15:00',1.04),('5819','2014-04-22','15:20:00',1.16),('5819','2014-04-22','15:25:00',1.27),('5819','2014-04-22','15:30:00',1.53),('5819','2014-04-22','15:35:00',2.21),('5819','2014-04-22','15:40:00',1.98),('5819','2014-04-22','15:45:00',1.63),('5819','2014-04-22','15:50:00',1.91),('5819','2014-04-22','15:55:00',1.62),('5819','2014-04-22','16:00:00',1.88),('5819','2014-04-22','16:05:00',1.36),('5819','2014-04-22','16:10:00',1.27),('5819','2014-04-22','16:15:00',1.22),('5819','2014-04-22','16:20:00',1.42),('5819','2014-04-22','16:25:00',1.39),('5819','2014-04-22','16:30:00',1.16),('5819','2014-04-22','16:35:00',1.16),('5819','2014-04-22','16:40:00',1.5),('5819','2014-04-22','16:45:00',1.47),('5819','2014-04-22','16:50:00',1.17),('5819','2014-04-22','16:55:00',1.02),('5819','2014-04-22','17:00:00',1.05),('5819','2014-04-22','17:05:00',1.25),('5819','2014-04-22','17:10:00',1),('5819','2013-12-17','08:30:00',1.06),('5819','2013-12-17','08:35:00',1.15),('5819','2013-12-17','08:40:00',1.24),('5819','2013-12-17','08:45:00',1.33),('5819','2013-12-17','08:50:00',1.41),('5819','2013-12-17','08:55:00',1.47),('5819','2013-12-17','09:00:00',1.55),('5819','2013-12-17','09:05:00',1.62),('5819','2013-12-17','09:10:00',1.68),('5819','2013-12-17','09:15:00',1.73),('5819','2013-12-17','09:20:00',1.78),('5819','2013-12-17','09:25:00',1.84),('5819','2013-12-17','09:30:00',1.89),('5819','2013-12-17','09:35:00',1.94),('5819','2013-12-17','09:40:00',2),('5819','2013-12-17','09:45:00',2.06),('5819','2013-12-17','09:50:00',2.11),('5819','2013-12-17','09:55:00',2.15),('5819','2013-12-17','10:00:00',2.19),('5819','2013-12-17','10:05:00',2.23),('5819','2013-12-17','10:10:00',2.26),('5819','2013-12-17','10:15:00',2.27),('5819','2013-12-17','10:20:00',2.32),('5819','2013-12-17','10:25:00',2.35),('5819','2013-12-17','10:30:00',2.39),('5819','2013-12-17','10:35:00',2.41),('5819','2013-12-17','10:40:00',2.43),('5819','2013-12-17','10:45:00',2.44),('5819','2013-12-17','10:50:00',2.44),('5819','2013-12-17','10:55:00',2.47),('5819','2013-12-17','11:00:00',2.48),('5819','2013-12-17','11:05:00',2.48),('5819','2013-12-17','11:10:00',2.49),('5819','2013-12-17','11:15:00',2.51),('5819','2013-12-17','11:20:00',2.51),('5819','2013-12-17','11:25:00',2.51),('5819','2013-12-17','11:30:00',2.54),('5819','2013-12-17','11:35:00',2.54),('5819','2013-12-17','11:40:00',2.54),('5819','2013-12-17','11:45:00',2.54),('5819','2013-12-17','11:50:00',2.54),('5819','2013-12-17','11:55:00',2.52),('5819','2013-12-17','12:00:00',2.5),('5819','2013-12-17','12:05:00',2.48),('5819','2013-12-17','12:10:00',2.47),('5819','2013-12-17','12:15:00',2.46),('5819','2013-12-17','12:20:00',2.45),('5819','2013-12-17','12:25:00',2.43),('5819','2013-12-17','12:30:00',2.41),('5819','2013-12-17','12:35:00',2.41),('5819','2013-12-17','12:40:00',2.36),('5819','2013-12-17','12:45:00',2.32),('5819','2013-12-17','12:50:00',2.29),('5819','2013-12-17','12:55:00',2.26),('5819','2013-12-17','13:00:00',2.22),('5819','2013-12-17','13:05:00',2.18),('5819','2013-12-17','13:10:00',2.13),('5819','2013-12-17','13:15:00',2.07),('5819','2013-12-17','13:20:00',2.03),('5819','2013-12-17','13:25:00',1.98),('5819','2013-12-17','13:30:00',1.94),('5819','2013-12-17','13:35:00',1.91),('5819','2013-12-17','13:40:00',1.87),('5819','2013-12-17','13:45:00',1.81),('5819','2013-12-17','13:50:00',1.75),('5819','2013-12-17','13:55:00',1.69),('5819','2013-12-17','14:00:00',1.64),('5819','2013-12-17','14:05:00',1.58),('5819','2013-12-17','14:10:00',1.51),('5819','2013-12-17','14:15:00',1.44),('5819','2013-12-17','14:20:00',1.39),('5819','2013-12-17','14:25:00',1.34),('5819','2013-12-17','14:30:00',1.27),('5819','2013-12-17','14:35:00',1.23),('5819','2013-12-17','14:40:00',1.17),('5819','2013-12-17','14:45:00',1.09),('5819','2013-12-17','14:50:00',1.04),('5819','2013-12-16','08:30:00',1.07),('5819','2013-12-16','08:35:00',1.15),('5819','2013-12-16','08:40:00',1.22),('5819','2013-12-16','08:45:00',1.29),('5819','2013-12-16','08:50:00',1.36),('5819','2013-12-16','08:55:00',1.44),('5819','2013-12-16','09:00:00',1.52),('5819','2013-12-16','09:05:00',1.58),('5819','2013-12-16','09:10:00',1.64),('5819','2013-12-16','09:15:00',1.69),('5819','2013-12-16','09:20:00',1.74),('5819','2013-12-16','09:25:00',1.81),('5819','2013-12-16','09:30:00',1.87),('5819','2013-12-16','09:35:00',1.93),('5819','2013-12-16','09:40:00',1.99),('5819','2013-12-16','09:45:00',2.03),('5819','2013-12-16','09:50:00',2.08),('5819','2013-12-16','09:55:00',2.1),('5819','2013-12-16','10:00:00',2.14),('5819','2013-12-16','10:05:00',2.18),('5819','2013-12-16','10:10:00',2.22),('5819','2013-12-16','10:15:00',2.25),('5819','2013-12-16','10:20:00',2.26),('5819','2013-12-16','10:25:00',2.27),('5819','2013-12-16','10:30:00',2.28),('5819','2013-12-16','10:35:00',2.31),('5819','2013-12-16','10:40:00',2.34),('5819','2013-12-16','10:45:00',2.36),('5819','2013-12-16','10:50:00',2.39),('5819','2013-12-16','10:55:00',2.41),('5819','2013-12-16','11:00:00',2.43),('5819','2013-12-16','11:05:00',2.44),('5819','2013-12-16','11:10:00',2.44),('5819','2013-12-16','11:15:00',2.44),('5819','2013-12-16','11:20:00',2.44),('5819','2013-12-16','11:25:00',2.46),('5819','2013-12-16','11:30:00',2.48),('5819','2013-12-16','11:35:00',2.48),('5819','2013-12-16','11:40:00',2.48),('5819','2013-12-16','11:45:00',2.47),('5819','2013-12-16','11:50:00',2.46),('5819','2013-12-16','11:55:00',2.47),('5819','2013-12-16','12:00:00',2.48),('5819','2013-12-16','12:05:00',2.47),('5819','2013-12-16','12:10:00',2.47),('5819','2013-12-16','12:15:00',2.45),('5819','2013-12-16','12:20:00',2.44),('5819','2013-12-16','12:25:00',2.42),('5819','2013-12-16','12:30:00',2.39),('5819','2013-12-16','12:35:00',2.36),('5819','2013-12-16','12:40:00',2.35),('5819','2013-12-16','12:45:00',2.32),('5819','2013-12-16','12:50:00',2.29),('5819','2013-12-16','12:55:00',2.25),('5819','2013-12-16','13:00:00',2.23),('5819','2013-12-16','13:05:00',2.19),('5819','2013-12-16','13:10:00',2.14),('5819','2013-12-16','13:15:00',2.08),('5819','2013-12-16','13:20:00',2.02),('5819','2013-12-16','13:25:00',1.96),('5819','2013-12-16','13:30:00',1.93),('5819','2013-12-16','13:35:00',1.87),('5819','2013-12-16','13:40:00',1.84),('5819','2013-12-16','13:45:00',1.8),('5819','2013-12-16','13:50:00',1.74),('5819','2013-12-16','13:55:00',1.68),('5819','2013-12-16','14:00:00',1.59),('5819','2013-12-16','14:05:00',1.57),('5819','2013-12-16','14:10:00',1.49),('5819','2013-12-16','14:15:00',1.45),('5819','2013-12-16','14:20:00',1.39),('5819','2013-12-16','14:25:00',1.34),('5819','2013-12-16','14:30:00',1.28),('5819','2013-12-16','14:35:00',1.22),('5819','2013-12-16','14:40:00',1.16),('5819','2013-12-16','14:45:00',1.09),('5819','2013-12-16','14:50:00',1.03),('5819','2013-12-15','10:20:00',1.25),('5819','2013-12-15','10:25:00',1.15),('5819','2013-12-15','10:30:00',1.05),('5819','2013-12-15','10:35:00',1.21),('5819','2013-12-15','10:40:00',1.24),('5819','2013-12-15','10:45:00',1.18),('5819','2013-12-14','08:35:00',1.01),('5819','2013-12-14','08:40:00',1.08),('5819','2013-12-14','08:45:00',1.16),('5819','2013-12-14','08:50:00',1.26),('5819','2013-12-14','08:55:00',1.33),('5819','2013-12-14','09:00:00',1.42),('5819','2013-12-14','09:05:00',1.5),('5819','2013-12-14','09:10:00',1.57),('5819','2013-12-14','09:15:00',1.64),('5819','2013-12-14','09:20:00',1.7),('5819','2013-12-14','09:25:00',1.77),('5819','2013-12-14','09:30:00',1.83),('5819','2013-12-14','09:35:00',1.87),('5819','2013-12-14','09:40:00',1.92),('5819','2013-12-14','09:45:00',1.97),('5819','2013-12-14','09:50:00',2),('5819','2013-12-14','09:55:00',2.03),('5819','2013-12-14','10:00:00',2.06),('5819','2013-12-14','10:05:00',2.09),('5819','2013-12-14','10:10:00',2.14),('5819','2013-12-14','10:15:00',2.18),('5819','2013-12-14','10:20:00',2.21),('5819','2013-12-14','10:25:00',2.23),('5819','2013-12-14','10:30:00',2.24),('5819','2013-12-14','10:35:00',2.29),('5819','2013-12-14','10:40:00',2.3),('5819','2013-12-14','10:45:00',2.32),('5819','2013-12-14','10:50:00',2.34),('5819','2013-12-14','10:55:00',2.33),('5819','2013-12-14','11:00:00',2.34),('5819','2013-12-14','11:05:00',2.34),('5819','2013-12-14','11:10:00',2.38),('5819','2013-12-14','11:15:00',2.37),('5819','2013-12-14','11:20:00',2.39),('5819','2013-12-14','11:25:00',2.38),('5819','2013-12-14','11:30:00',2.38),('5819','2013-12-14','11:35:00',2.37),('5819','2013-12-14','11:40:00',2.41),('5819','2013-12-14','11:45:00',2.38),('5819','2013-12-14','11:50:00',2.34),('5819','2013-12-14','11:55:00',2.3),('5819','2013-12-14','12:00:00',2.28),('5819','2013-12-14','12:05:00',2.27),('5819','2013-12-14','12:10:00',2.26),('5819','2013-12-14','12:15:00',2.27),('5819','2013-12-14','12:20:00',2.24),('5819','2013-12-14','12:25:00',2.2),('5819','2013-12-14','12:30:00',2.13),('5819','2013-12-14','12:35:00',2.12),('5819','2013-12-14','12:40:00',2.1),('5819','2013-12-14','12:45:00',2.06),('5819','2013-12-14','12:50:00',2.11),('5819','2013-12-14','12:55:00',2.05),('5819','2013-12-14','13:00:00',2.03),('5819','2013-12-14','13:05:00',1.99),('5819','2013-12-14','13:10:00',1.97),('5819','2013-12-14','13:15:00',1.93),('5819','2013-12-14','13:20:00',1.93),('5819','2013-12-14','13:25:00',1.9),('5819','2013-12-14','13:30:00',1.83),('5819','2013-12-14','13:35:00',1.78),('5819','2013-12-14','13:40:00',1.79),('5819','2013-12-14','13:45:00',1.77),('5819','2013-12-14','13:50:00',1.71),('5819','2013-12-14','13:55:00',1.65),('5819','2013-12-14','14:00:00',1.57),('5819','2013-12-14','14:05:00',1.54),('5819','2013-12-14','14:10:00',1.47),('5819','2013-12-14','14:15:00',1.43),('5819','2013-12-14','14:20:00',1.37),('5819','2013-12-14','14:25:00',1.31),('5819','2013-12-14','14:30:00',1.26),('5819','2013-12-14','14:35:00',1.2),('5819','2013-12-14','14:40:00',1.14),('5819','2013-12-14','14:45:00',1.06),('5819','2013-12-13','08:40:00',1),('5819','2013-12-13','08:45:00',1.07),('5819','2013-12-13','08:50:00',1.15),('5819','2013-12-13','08:55:00',1.22),('5819','2013-12-13','09:00:00',1.27),('5819','2013-12-13','09:05:00',1.34),('5819','2013-12-13','09:10:00',1.4),('5819','2013-12-13','09:15:00',1.48),('5819','2013-12-13','09:20:00',1.54),('5819','2013-12-13','09:25:00',1.59),('5819','2013-12-13','09:30:00',1.62),('5819','2013-12-13','09:35:00',1.65),('5819','2013-12-13','09:40:00',1.71),('5819','2013-12-13','09:45:00',1.77),('5819','2013-12-13','09:50:00',1.82),('5819','2013-12-13','09:55:00',1.87),('5819','2013-12-13','10:00:00',1.89),('5819','2013-12-13','10:05:00',1.93),('5819','2013-12-13','10:10:00',1.97),('5819','2013-12-13','10:15:00',2.02),('5819','2013-12-13','10:20:00',2.06),('5819','2013-12-13','10:25:00',2.08),('5819','2013-12-13','10:30:00',2.12),('5819','2013-12-13','10:35:00',2.15),('5819','2013-12-13','10:40:00',2.18),('5819','2013-12-13','10:45:00',2.19),('5819','2013-12-13','10:50:00',2.21),('5819','2013-12-13','10:55:00',2.25),('5819','2013-12-13','11:00:00',2.26),('5819','2013-12-13','11:05:00',2.27),('5819','2013-12-13','11:10:00',2.24),('5819','2013-12-13','11:15:00',2.27),('5819','2013-12-13','11:20:00',2.31),('5819','2013-12-13','11:25:00',2.3),('5819','2013-12-13','11:30:00',2.29),('5819','2013-12-13','11:35:00',2.28),('5819','2013-12-13','11:40:00',2.27),('5819','2013-12-13','11:45:00',2.3),('5819','2013-12-13','11:50:00',2.29),('5819','2013-12-13','11:55:00',2.29),('5819','2013-12-13','12:00:00',2.32),('5819','2013-12-13','12:05:00',2.28),('5819','2013-12-13','12:10:00',2.22),('5819','2013-12-13','12:15:00',2.2),('5819','2013-12-13','12:20:00',2.14),('5819','2013-12-13','12:25:00',2.19),('5819','2013-12-13','12:30:00',2.19),('5819','2013-12-13','12:35:00',2.15),('5819','2013-12-13','12:40:00',2.11),('5819','2013-12-13','12:45:00',2.12),('5819','2013-12-13','12:50:00',2.08),('5819','2013-12-13','12:55:00',2.02),('5819','2013-12-13','13:00:00',2.02),('5819','2013-12-13','13:05:00',2.01),('5819','2013-12-13','13:10:00',1.96),('5819','2013-12-13','13:15:00',1.94),('5819','2013-12-13','13:20:00',1.84),('5819','2013-12-13','13:25:00',1.87),('5819','2013-12-13','13:30:00',1.87),('5819','2013-12-13','13:35:00',1.8),('5819','2013-12-13','13:40:00',1.72),('5819','2013-12-13','13:45:00',1.7),('5819','2013-12-13','13:50:00',1.65),('5819','2013-12-13','13:55:00',1.6),('5819','2013-12-13','14:00:00',1.55),('5819','2013-12-13','14:05:00',1.5),('5819','2013-12-13','14:10:00',1.45),('5819','2013-12-13','14:15:00',1.43),('5819','2013-12-13','14:20:00',1.35),('5819','2013-12-13','14:25:00',1.31),('5819','2013-12-13','14:30:00',1.26),('5819','2013-12-13','14:35:00',1.2),('5819','2013-12-13','14:40:00',1.13),('5819','2013-12-13','14:45:00',1.07),('5819','2013-12-13','14:50:00',1.04),('5819','2013-12-12','08:35:00',1.03),('5819','2013-12-12','08:40:00',1.1),('5819','2013-12-12','08:45:00',1.19),('5819','2013-12-12','08:50:00',1.29),('5819','2013-12-12','08:55:00',1.36),('5819','2013-12-12','09:00:00',1.41),('5819','2013-12-12','09:05:00',1.47),('5819','2013-12-12','09:10:00',1.53),('5819','2013-12-12','09:15:00',1.58),('5819','2013-12-12','09:20:00',1.64),('5819','2013-12-12','09:25:00',1.71),('5819','2013-12-12','09:30:00',1.77),('5819','2013-12-12','09:35:00',1.84),('5819','2013-12-12','09:40:00',1.89),('5819','2013-12-12','09:45:00',1.93),('5819','2013-12-12','09:50:00',1.97),('5819','2013-12-12','09:55:00',2),('5819','2013-12-12','10:00:00',2.05),('5819','2013-12-12','10:05:00',2.1),('5819','2013-12-12','10:10:00',2.14),('5819','2013-12-12','10:15:00',2.18),('5819','2013-12-12','10:20:00',2.2),('5819','2013-12-12','10:25:00',2.22),('5819','2013-12-12','10:30:00',2.25),('5819','2013-12-12','10:35:00',2.28),('5819','2013-12-12','10:40:00',2.3),('5819','2013-12-12','10:45:00',2.32),('5819','2013-12-12','10:50:00',2.33),('5819','2013-12-12','10:55:00',2.34),('5819','2013-12-12','11:00:00',2.34),('5819','2013-12-12','11:05:00',2.36),('5819','2013-12-12','11:10:00',2.35),('5819','2013-12-12','11:15:00',2.36),('5819','2013-12-12','11:20:00',2.36),('5819','2013-12-12','11:25:00',2.37),('5819','2013-12-12','11:30:00',2.39),('5819','2013-12-12','11:35:00',2.42),('5819','2013-12-12','11:40:00',2.38),('5819','2013-12-12','11:45:00',2.36),('5819','2013-12-12','11:50:00',2.32),('5819','2013-12-12','11:55:00',2.32),('5819','2013-12-12','12:00:00',2.33),('5819','2013-12-12','12:05:00',2.33),('5819','2013-12-12','12:10:00',2.32),('5819','2013-12-12','12:15:00',2.3),('5819','2013-12-12','12:20:00',2.27),('5819','2013-12-12','12:25:00',2.27),('5819','2013-12-12','12:30:00',2.25),('5819','2013-12-12','12:35:00',2.22),('5819','2013-12-12','12:40:00',2.18),('5819','2013-12-12','12:45:00',2.16),('5819','2013-12-12','12:50:00',2.16),('5819','2013-12-12','12:55:00',2.07),('5819','2013-12-12','13:00:00',2.05),('5819','2013-12-12','13:05:00',2),('5819','2013-12-12','13:10:00',1.97),('5819','2013-12-12','13:15:00',1.96),('5819','2013-12-12','13:20:00',1.94),('5819','2013-12-12','13:25:00',1.87),('5819','2013-12-12','13:30:00',1.8),('5819','2013-12-12','13:35:00',1.82),('5819','2013-12-12','13:40:00',1.75),('5819','2013-12-12','13:45:00',1.69),('5819','2013-12-12','13:50:00',1.67),('5819','2013-12-12','13:55:00',1.63),('5819','2013-12-12','14:00:00',1.54),('5819','2013-12-12','14:05:00',1.5),('5819','2013-12-12','14:10:00',1.44),('5819','2013-12-12','14:15:00',1.38),('5819','2013-12-12','14:20:00',1.33),('5819','2013-12-12','14:25:00',1.27),('5819','2013-12-12','14:30:00',1.19),('5819','2013-12-12','14:35:00',1.13),('5819','2013-12-12','14:40:00',1.1),('5819','2013-12-12','14:45:00',1.03),('5819','2013-12-11','08:30:00',1.02),('5819','2013-12-11','08:35:00',1.09),('5819','2013-12-11','08:40:00',1.16),('5819','2013-12-11','08:45:00',1.24),('5819','2013-12-11','08:50:00',1.33),('5819','2013-12-11','08:55:00',1.41),('5819','2013-12-11','09:00:00',1.47),('5819','2013-12-11','09:05:00',1.53),('5819','2013-12-11','09:10:00',1.61),('5819','2013-12-11','09:15:00',1.66),('5819','2013-12-11','09:20:00',1.72),('5819','2013-12-11','09:25:00',1.78),('5819','2013-12-11','09:30:00',1.85),('5819','2013-12-11','09:35:00',1.9),('5819','2013-12-11','09:40:00',1.96),('5819','2013-12-11','09:45:00',2.02),('5819','2013-12-11','09:50:00',2.06),('5819','2013-12-11','09:55:00',2.12),('5819','2013-12-11','10:00:00',2.14),('5819','2013-12-11','10:05:00',2.17),('5819','2013-12-11','10:10:00',2.22),('5819','2013-12-11','10:15:00',2.26),('5819','2013-12-11','10:20:00',2.3),('5819','2013-12-11','10:25:00',2.34),('5819','2013-12-11','10:30:00',2.4),('5819','2013-12-11','10:35:00',2.44),('5819','2013-12-11','10:40:00',2.45),('5819','2013-12-11','10:45:00',2.42),('5819','2013-12-11','10:50:00',2.41),('5819','2013-12-11','10:55:00',2.43),('5819','2013-12-11','11:00:00',2.48),('5819','2013-12-11','11:05:00',2.51),('5819','2013-12-11','11:10:00',2.52),('5819','2013-12-11','11:15:00',2.5),('5819','2013-12-11','11:20:00',2.51),('5819','2013-12-11','11:25:00',2.45),('5819','2013-12-11','11:30:00',2.44),('5819','2013-12-11','11:35:00',2.47),('5819','2013-12-11','11:40:00',2.5),('5819','2013-12-11','11:45:00',2.48),('5819','2013-12-11','11:50:00',2.5),('5819','2013-12-11','11:55:00',2.5),('5819','2013-12-11','12:00:00',2.5),('5819','2013-12-11','12:05:00',2.47),('5819','2013-12-11','12:10:00',2.46),('5819','2013-12-11','12:15:00',2.46),('5819','2013-12-11','12:20:00',2.42),('5819','2013-12-11','12:25:00',2.33),('5819','2013-12-11','12:30:00',2.3),('5819','2013-12-11','12:35:00',2.29),('5819','2013-12-11','12:40:00',2.27),('5819','2013-12-11','12:45:00',2.27),('5819','2013-12-11','12:50:00',2.22),('5819','2013-12-11','12:55:00',2.2),('5819','2013-12-11','13:00:00',2.19),('5819','2013-12-11','13:05:00',2.14),('5819','2013-12-11','13:10:00',2.08),('5819','2013-12-11','13:15:00',2.02),('5819','2013-12-11','13:20:00',1.99),('5819','2013-12-11','13:25:00',1.96),('5819','2013-12-11','13:30:00',1.93),('5819','2013-12-11','13:35:00',1.87),('5819','2013-12-11','13:40:00',1.83),('5819','2013-12-11','13:45:00',1.77),('5819','2013-12-11','13:50:00',1.71),('5819','2013-12-11','13:55:00',1.66),('5819','2013-12-11','14:00:00',1.6),('5819','2013-12-11','14:05:00',1.56),('5819','2013-12-11','14:10:00',1.52),('5819','2013-12-11','14:15:00',1.46),('5819','2013-12-11','14:20:00',1.4),('5819','2013-12-11','14:25:00',1.34),('5819','2013-12-11','14:30:00',1.28),('5819','2013-12-11','14:35:00',1.22),('5819','2013-12-11','14:40:00',1.16),('5819','2013-12-11','14:45:00',1.09),('5819','2013-12-11','14:50:00',1.02),('5819','2013-12-10','08:25:00',1),('5819','2013-12-10','08:30:00',1.08),('5819','2013-12-10','08:35:00',1.16),('5819','2013-12-10','08:40:00',1.21),('5819','2013-12-10','08:45:00',1.29),('5819','2013-12-10','08:50:00',1.38),('5819','2013-12-10','08:55:00',1.45),('5819','2013-12-10','09:00:00',1.52),('5819','2013-12-10','09:05:00',1.59),('5819','2013-12-10','09:10:00',1.65),('5819','2013-12-10','09:15:00',1.71),('5819','2013-12-10','09:20:00',1.79),('5819','2013-12-10','09:25:00',1.85),('5819','2013-12-10','09:30:00',1.89),('5819','2013-12-10','09:35:00',1.93),('5819','2013-12-10','09:40:00',1.98),('5819','2013-12-10','09:45:00',2.03),('5819','2013-12-10','09:50:00',2.06),('5819','2013-12-10','09:55:00',2.12),('5819','2013-12-10','10:00:00',2.16),('5819','2013-12-10','10:05:00',2.21),('5819','2013-12-10','10:10:00',2.25),('5819','2013-12-10','10:15:00',2.28),('5819','2013-12-10','10:20:00',2.28),('5819','2013-12-10','10:25:00',2.3),('5819','2013-12-10','10:30:00',2.34),('5819','2013-12-10','10:35:00',2.37),('5819','2013-12-10','10:40:00',2.39),('5819','2013-12-10','10:45:00',2.42),('5819','2013-12-10','10:50:00',2.45),('5819','2013-12-10','10:55:00',2.46),('5819','2013-12-10','11:00:00',2.47),('5819','2013-12-10','11:05:00',2.49),('5819','2013-12-10','11:10:00',2.49),('5819','2013-12-10','11:15:00',2.51),('5819','2013-12-10','11:20:00',2.53),('5819','2013-12-10','11:25:00',2.54),('5819','2013-12-10','11:30:00',2.55),('5819','2013-12-10','11:35:00',2.55),('5819','2013-12-10','11:40:00',2.55),('5819','2013-12-10','11:45:00',2.54),('5819','2013-12-10','11:50:00',2.53),('5819','2013-12-10','11:55:00',2.52),('5819','2013-12-10','12:00:00',2.5),('5819','2013-12-10','12:05:00',2.47),('5819','2013-12-10','12:10:00',2.45),('5819','2013-12-10','12:15:00',2.43),('5819','2013-12-10','12:20:00',2.41),('5819','2013-12-10','12:25:00',2.37),('5819','2013-12-10','12:30:00',2.34),('5819','2013-12-10','12:35:00',2.28),('5819','2013-12-10','12:40:00',2.25),('5819','2013-12-10','12:45:00',2.23),('5819','2013-12-10','12:50:00',2.19),('5819','2013-12-10','12:55:00',2.13),('5819','2013-12-10','13:00:00',2.07),('5819','2013-12-10','13:05:00',2.09),('5819','2013-12-10','13:10:00',2.05),('5819','2013-12-10','13:15:00',1.99),('5819','2013-12-10','13:20:00',1.95),('5819','2013-12-10','13:25:00',1.91),('5819','2013-12-10','13:30:00',1.9),('5819','2013-12-10','13:35:00',1.89),('5819','2013-12-10','13:40:00',1.85),('5819','2013-12-10','13:45:00',1.8),('5819','2013-12-10','13:50:00',1.75),('5819','2013-12-10','13:55:00',1.7),('5819','2013-12-10','14:00:00',1.65),('5819','2013-12-10','14:05:00',1.58),('5819','2013-12-10','14:10:00',1.52),('5819','2013-12-10','14:15:00',1.47),('5819','2013-12-10','14:20:00',1.42),('5819','2013-12-10','14:25:00',1.38),('5819','2013-12-10','14:30:00',1.32),('5819','2013-12-10','14:35:00',1.25),('5819','2013-12-10','14:40:00',1.19),('5819','2013-12-10','14:45:00',1.12),('5819','2013-12-10','14:50:00',1.07),('5819','2013-12-10','14:55:00',1.01),('5819','2013-12-09','09:35:00',1.84),('5819','2013-12-09','09:40:00',1.97),('5819','2013-12-09','09:45:00',2),('5819','2013-12-09','09:50:00',2.01),('5819','2013-12-09','09:55:00',2.07),('5819','2013-12-09','10:00:00',2.09),('5819','2013-12-09','10:05:00',2.19),('5819','2013-12-09','10:10:00',2.62),('5819','2013-12-09','10:15:00',2.57),('5819','2013-12-09','10:20:00',2.84),('5819','2013-12-09','10:25:00',1.84),('5819','2013-12-09','12:30:00',1.88),('5819','2013-12-09','12:35:00',1.23),('5819','2013-12-09','12:40:00',1.1),('5819','2013-12-09','12:45:00',1.5),('5819','2013-12-09','12:50:00',1.41),('5819','2013-12-09','12:55:00',1.65),('5819','2013-12-09','13:00:00',2.33),('5819','2013-12-09','13:05:00',2.02),('5819','2013-12-09','13:10:00',1.6),('5819','2013-12-09','13:15:00',1.33),('5819','2013-12-09','13:20:00',1.62),('5819','2013-12-09','13:25:00',1.18),('5819','2013-12-09','13:50:00',1.03),('5819','2013-12-09','13:55:00',1.1),('5819','2013-12-08','08:50:00',1.21),('5819','2013-12-08','09:55:00',1.05),('5819','2013-12-08','10:40:00',1.01),('5819','2013-12-08','10:45:00',1.01),('5819','2013-12-08','10:50:00',1.04),('5819','2013-12-08','10:55:00',1.08),('5819','2013-12-08','11:00:00',1.21),('5819','2013-12-08','11:05:00',1.19),('5819','2013-12-08','11:10:00',1.21),('5819','2013-12-08','11:15:00',1.5),('5819','2013-12-08','11:20:00',1.66),('5819','2013-12-08','11:25:00',1.02),('5819','2013-12-08','13:00:00',1.08),('5819','2013-12-08','13:15:00',1.6),('5819','2013-12-08','13:20:00',1.53),('5819','2013-12-08','13:25:00',1.29),('5819','2014-04-21','09:20:00',1.34),('5819','2014-04-21','09:25:00',1.22),('5819','2014-04-21','10:00:00',1.35),('5819','2014-04-21','10:05:00',2.26),('5819','2014-04-21','10:10:00',3.17),('5819','2014-04-21','10:15:00',3.4),('5819','2014-04-21','10:20:00',3.29),('5819','2014-04-21','10:25:00',3.3),('5819','2014-04-21','10:30:00',3.29),('5819','2014-04-21','10:35:00',3.31),('5819','2014-04-21','10:40:00',3.33),('5819','2014-04-21','10:45:00',3.38),('5819','2014-04-21','10:50:00',3.4),('5819','2014-04-21','10:55:00',3.44),('5819','2014-04-21','11:00:00',3.46),('5819','2014-04-21','11:05:00',3.49),('5819','2014-04-21','11:10:00',3.5),('5819','2014-04-21','11:15:00',3.54),('5819','2014-04-21','11:20:00',3.55),('5819','2014-04-21','11:25:00',3.57),('5819','2014-04-21','11:30:00',3.6),('5819','2014-04-21','11:35:00',3.63),('5819','2014-04-21','11:40:00',3.64),('5819','2014-04-21','11:45:00',3.68),('5819','2014-04-21','11:50:00',3.71),('5819','2014-04-21','11:55:00',3.72),('5819','2014-04-21','12:00:00',3.72),('5819','2014-04-21','12:05:00',3.72),('5819','2014-04-21','12:10:00',3.75),('5819','2014-04-21','12:15:00',3.76),('5819','2014-04-21','12:20:00',3.8),('5819','2014-04-21','12:25:00',3.81),('5819','2014-04-21','12:30:00',3.82),('5819','2014-04-21','12:35:00',3.82),('5819','2014-04-21','12:40:00',3.84),('5819','2014-04-21','12:45:00',3.84),('5819','2014-04-21','12:50:00',3.85),('5819','2014-04-21','12:55:00',3.84),('5819','2014-04-21','13:00:00',3.8),('5819','2014-04-21','13:05:00',3.78),('5819','2014-04-21','13:10:00',3.8),('5819','2014-04-21','13:15:00',3.77),('5819','2014-04-21','13:20:00',3.76),('5819','2014-04-21','13:25:00',3.75),('5819','2014-04-21','13:30:00',3.74),('5819','2014-04-21','13:35:00',3.71),('5819','2014-04-21','13:40:00',3.67),('5819','2014-04-21','13:45:00',3.71),('5819','2014-04-21','13:50:00',3.71),('5819','2014-04-21','13:55:00',3.71),('5819','2014-04-21','14:00:00',3.69),('5819','2014-04-21','14:05:00',3.66),('5819','2014-04-21','14:10:00',3.62),('5819','2014-04-21','14:15:00',3.6),('5819','2014-04-21','14:20:00',3.58),('5819','2014-04-21','14:25:00',3.54),('5819','2014-04-21','14:30:00',3.51),('5819','2014-04-21','14:35:00',3.46),('5819','2014-04-21','14:40:00',3.43),('5819','2014-04-21','14:45:00',3.38),('5819','2014-04-21','14:50:00',3.33),('5819','2014-04-21','14:55:00',3.3),('5819','2014-04-21','15:00:00',3.25),('5819','2014-04-21','15:05:00',3.2),('5819','2014-04-21','15:10:00',3.15),('5819','2014-04-21','15:15:00',3.1),('5819','2014-04-21','15:20:00',3.04),('5819','2014-04-21','15:25:00',2.98),('5819','2014-04-21','15:30:00',2.93),('5819','2014-04-21','15:35:00',2.87),('5819','2014-04-21','15:40:00',2.8),('5819','2014-04-21','15:45:00',2.74),('5819','2014-04-21','15:50:00',2.68),('5819','2014-04-21','15:55:00',2.62),('5819','2014-04-21','16:00:00',2.56),('5819','2014-04-21','16:05:00',2.5),('5819','2014-04-21','16:10:00',2.31),('5819','2014-04-21','16:15:00',1.89),('5819','2014-04-21','16:20:00',2.34),('5819','2014-04-21','16:25:00',2.22),('5819','2014-04-21','16:30:00',2.09),('5819','2014-04-21','16:35:00',2.05),('5819','2014-04-21','16:40:00',2.03),('5819','2014-04-21','16:45:00',1.96),('5819','2014-04-21','16:50:00',1.88),('5819','2014-04-21','16:55:00',1.78),('5819','2014-04-21','17:00:00',1.7),('5819','2014-04-21','17:05:00',1.63),('5819','2014-04-21','17:10:00',1.56),('5819','2014-04-21','17:15:00',1.47),('5819','2014-04-21','17:20:00',1.39),('5819','2014-04-21','17:25:00',1.31),('5819','2014-04-21','17:30:00',1.14),('5819','2014-04-21','17:35:00',1.11),('5819','2014-04-21','17:40:00',1.01),('5819','2013-12-07','08:25:00',1.05),('5819','2013-12-07','08:30:00',1.14),('5819','2013-12-07','08:35:00',1.2),('5819','2013-12-07','08:40:00',1.26),('5819','2013-12-07','08:45:00',1.32),('5819','2013-12-07','08:50:00',1.39),('5819','2013-12-07','08:55:00',1.46),('5819','2013-12-07','09:00:00',1.52),('5819','2013-12-07','09:05:00',1.58),('5819','2013-12-07','09:10:00',1.64),('5819','2013-12-07','09:15:00',1.72),('5819','2013-12-07','09:20:00',1.76),('5819','2013-12-07','09:25:00',1.81),('5819','2013-12-07','09:30:00',1.86),('5819','2013-12-07','09:35:00',1.93),('5819','2013-12-07','09:40:00',1.98),('5819','2013-12-07','09:45:00',2),('5819','2013-12-07','09:50:00',2.05),('5819','2013-12-07','09:55:00',2.08),('5819','2013-12-07','10:00:00',2.13),('5819','2013-12-07','10:05:00',2.17),('5819','2013-12-07','10:10:00',2.2),('5819','2013-12-07','10:15:00',2.22),('5819','2013-12-07','10:20:00',2.24),('5819','2013-12-07','10:25:00',2.28),('5819','2013-12-07','10:30:00',2.3),('5819','2013-12-07','10:35:00',2.35),('5819','2013-12-07','10:40:00',2.38),('5819','2013-12-07','10:45:00',2.38),('5819','2013-12-07','10:50:00',2.36),('5819','2013-12-07','10:55:00',2.35),('5819','2013-12-07','11:00:00',2.37),('5819','2013-12-07','11:05:00',2.39),('5819','2013-12-07','11:10:00',2.4),('5819','2013-12-07','11:15:00',2.4),('5819','2013-12-07','11:20:00',2.42),('5819','2013-12-07','11:25:00',2.42),('5819','2013-12-07','11:30:00',2.43),('5819','2013-12-07','11:35:00',2.39),('5819','2013-12-07','11:40:00',2.4),('5819','2013-12-07','11:45:00',2.37),('5819','2013-12-07','11:50:00',2.37),('5819','2013-12-07','11:55:00',2.35),('5819','2013-12-07','12:00:00',2.34),('5819','2013-12-07','12:05:00',2.32),('5819','2013-12-07','12:10:00',2.32),('5819','2013-12-07','12:15:00',2.31),('5819','2013-12-07','12:20:00',2.29),('5819','2013-12-07','12:25:00',2.27),('5819','2013-12-07','12:30:00',2.25),('5819','2013-12-07','12:35:00',2.23),('5819','2013-12-07','12:40:00',2.2),('5819','2013-12-07','12:45:00',2.18),('5819','2013-12-07','12:50:00',2.15),('5819','2013-12-07','12:55:00',2.07),('5819','2013-12-07','13:00:00',2.11),('5819','2013-12-07','13:05:00',2.07),('5819','2013-12-07','13:10:00',2.04),('5819','2013-12-07','13:15:00',2.02),('5819','2013-12-07','13:20:00',1.99),('5819','2013-12-07','13:25:00',1.93),('5819','2013-12-07','13:30:00',1.88),('5819','2013-12-07','13:35:00',1.85),('5819','2013-12-07','13:40:00',1.81),('5819','2013-12-07','13:45:00',1.76),('5819','2013-12-07','13:50:00',1.72),('5819','2013-12-07','13:55:00',1.65),('5819','2013-12-07','14:00:00',1.6),('5819','2013-12-07','14:05:00',1.54),('5819','2013-12-07','14:10:00',1.48),('5819','2013-12-07','14:15:00',1.41),('5819','2013-12-07','14:20:00',1.34),('5819','2013-12-07','14:25:00',1.29),('5819','2013-12-07','14:30:00',1.21),('5819','2013-12-07','14:35:00',1.15),('5819','2013-12-07','14:40:00',1.09),('5819','2013-12-07','14:45:00',1.04),('5819','2013-12-06','10:10:00',1.12),('5819','2013-12-06','11:35:00',1.18),('5819','2013-12-06','11:40:00',1.65),('5819','2013-12-06','11:45:00',1.52),('5819','2013-12-06','11:50:00',1.73),('5819','2013-12-06','11:55:00',1.57),('5819','2013-12-06','12:00:00',1.54),('5819','2013-12-06','12:05:00',1.44),('5819','2013-12-06','12:10:00',1.54),('5819','2013-12-06','12:15:00',1.22),('5819','2013-12-06','12:20:00',1.64),('5819','2013-12-06','12:25:00',1.25),('5819','2013-12-06','12:30:00',1.32),('5819','2013-12-06','12:35:00',1.85),('5819','2013-12-06','12:40:00',1.81),('5819','2013-12-06','12:45:00',1.04),('5819','2013-12-06','14:40:00',1.05),('5819','2013-12-05','08:25:00',1.06),('5819','2013-12-05','08:30:00',1.14),('5819','2013-12-05','08:35:00',1.23),('5819','2013-12-05','08:40:00',1.32),('5819','2013-12-05','08:45:00',1.4),('5819','2013-12-05','08:50:00',1.48),('5819','2013-12-05','08:55:00',1.54),('5819','2013-12-05','09:00:00',1.6),('5819','2013-12-05','09:05:00',1.67),('5819','2013-12-05','09:10:00',1.72),('5819','2013-12-05','09:15:00',1.78),('5819','2013-12-05','09:20:00',1.84),('5819','2013-12-05','09:25:00',1.9),('5819','2013-12-05','09:30:00',1.94),('5819','2013-12-05','09:35:00',1.99),('5819','2013-12-05','09:40:00',2.03),('5819','2013-12-05','09:45:00',2.07),('5819','2013-12-05','09:50:00',2.12),('5819','2013-12-05','09:55:00',2.17),('5819','2013-12-05','10:00:00',2.2),('5819','2013-12-05','10:05:00',2.23),('5819','2013-12-05','10:10:00',2.27),('5819','2013-12-05','10:15:00',2.31),('5819','2013-12-05','10:20:00',2.34),('5819','2013-12-05','10:25:00',2.35),('5819','2013-12-05','10:30:00',2.39),('5819','2013-12-05','10:35:00',2.42),('5819','2013-12-05','10:40:00',2.43),('5819','2013-12-05','10:45:00',2.43),('5819','2013-12-05','10:50:00',2.44),('5819','2013-12-05','10:55:00',2.45),('5819','2013-12-05','11:00:00',2.47),('5819','2013-12-05','11:05:00',2.49),('5819','2013-12-05','11:10:00',2.44),('5819','2013-12-05','11:15:00',2.48),('5819','2013-12-05','11:20:00',2.5),('5819','2013-12-05','11:25:00',2.51),('5819','2013-12-05','11:30:00',2.53),('5819','2013-12-05','11:35:00',2.47),('5819','2013-12-05','11:40:00',2.48),('5819','2013-12-05','11:45:00',2.46),('5819','2013-12-05','11:50:00',2.45),('5819','2013-12-05','11:55:00',2.45),('5819','2013-12-05','12:00:00',2.46),('5819','2013-12-05','12:05:00',2.43),('5819','2013-12-05','12:10:00',2.37),('5819','2013-12-05','12:15:00',2.33),('5819','2013-12-05','12:20:00',2.38),('5819','2013-12-05','12:25:00',2.27),('5819','2013-12-05','12:30:00',2.26),('5819','2013-12-05','12:35:00',2.3),('5819','2013-12-05','12:40:00',2.24),('5819','2013-12-05','12:45:00',2.01),('5819','2013-12-05','12:50:00',1.98),('5819','2013-12-05','12:55:00',2.01),('5819','2013-12-05','13:00:00',1.84),('5819','2013-12-05','13:05:00',1.56),('5819','2013-12-05','13:10:00',1.88),('5819','2013-12-05','13:15:00',2.07),('5819','2013-12-05','13:20:00',2.01),('5819','2013-12-05','13:25:00',1.79),('5819','2013-12-05','13:30:00',1.18),('5819','2013-12-05','13:35:00',1.72),('5819','2013-12-05','13:40:00',1.7),('5819','2013-12-05','13:45:00',1.76),('5819','2013-12-05','13:50:00',1.69),('5819','2013-12-05','13:55:00',1.59),('5819','2013-12-05','14:00:00',1.57),('5819','2013-12-05','14:05:00',1.51),('5819','2013-12-05','14:10:00',1.47),('5819','2013-12-05','14:15:00',1.38),('5819','2013-12-05','14:20:00',1.32),('5819','2013-12-05','14:25:00',1.31),('5819','2013-12-05','14:30:00',1.23),('5819','2013-12-05','14:35:00',1.18),('5819','2013-12-05','14:40:00',1.12),('5819','2013-12-05','14:45:00',1.04),('5819','2013-12-05','14:50:00',1.01),('5819','2013-12-04','08:15:00',1.04),('5819','2013-12-04','08:20:00',1.12),('5819','2013-12-04','08:25:00',1.2),('5819','2013-12-04','08:30:00',1.29),('5819','2013-12-04','08:35:00',1.38),('5819','2013-12-04','08:40:00',1.46),('5819','2013-12-04','08:45:00',1.54),('5819','2013-12-04','08:50:00',1.61),('5819','2013-12-04','08:55:00',1.68),('5819','2013-12-04','09:00:00',1.76),('5819','2013-12-04','09:05:00',1.83),('5819','2013-12-04','09:10:00',1.88),('5819','2013-12-04','09:15:00',1.94),('5819','2013-12-04','09:20:00',1.99),('5819','2013-12-04','09:25:00',2.04),('5819','2013-12-04','09:30:00',2.1),('5819','2013-12-04','09:35:00',2.15),('5819','2013-12-04','09:40:00',2.2),('5819','2013-12-04','09:45:00',2.25),('5819','2013-12-04','09:50:00',2.29),('5819','2013-12-04','09:55:00',2.33),('5819','2013-12-04','10:00:00',2.36),('5819','2013-12-04','10:05:00',2.4),('5819','2013-12-04','10:10:00',2.43),('5819','2013-12-04','10:15:00',2.45),('5819','2013-12-04','10:20:00',2.48),('5819','2013-12-04','10:25:00',2.51),('5819','2013-12-04','10:30:00',2.54),('5819','2013-12-04','10:35:00',2.55),('5819','2013-12-04','10:40:00',2.57),('5819','2013-12-04','10:45:00',2.59),('5819','2013-12-04','10:50:00',2.62),('5819','2013-12-04','10:55:00',2.62),('5819','2013-12-04','11:00:00',2.62),('5819','2013-12-04','11:05:00',2.62),('5819','2013-12-04','11:10:00',2.63),('5819','2013-12-04','11:15:00',2.63),('5819','2013-12-04','11:20:00',2.62),('5819','2013-12-04','11:25:00',2.62),('5819','2013-12-04','11:30:00',2.64),('5819','2013-12-04','11:35:00',2.64),('5819','2013-12-04','11:40:00',2.62),('5819','2013-12-04','11:45:00',2.63),('5819','2013-12-04','11:50:00',2.61),('5819','2013-12-04','11:55:00',2.6),('5819','2013-12-04','12:00:00',2.6),('5819','2013-12-04','12:05:00',2.57),('5819','2013-12-04','12:10:00',2.55),('5819','2013-12-04','12:15:00',2.52),('5819','2013-12-04','12:20:00',2.51),('5819','2013-12-04','12:25:00',2.49),('5819','2013-12-04','12:30:00',2.46),('5819','2013-12-04','12:35:00',2.42),('5819','2013-12-04','12:40:00',2.4),('5819','2013-12-04','12:45:00',2.38),('5819','2013-12-04','12:50:00',2.34),('5819','2013-12-04','12:55:00',2.3),('5819','2013-12-04','13:00:00',2.27),('5819','2013-12-04','13:05:00',2.24),('5819','2013-12-04','13:10:00',2.19),('5819','2013-12-04','13:15:00',2.14),('5819','2013-12-04','13:20:00',2.09),('5819','2013-12-04','13:25:00',2.05),('5819','2013-12-04','13:30:00',2.01),('5819','2013-12-04','13:35:00',1.97),('5819','2013-12-04','13:40:00',1.9),('5819','2013-12-04','13:45:00',1.85),('5819','2013-12-04','13:50:00',1.79),('5819','2013-12-04','13:55:00',1.75),('5819','2013-12-04','14:00:00',1.69),('5819','2013-12-04','14:05:00',1.64),('5819','2013-12-04','14:10:00',1.58),('5819','2013-12-04','14:15:00',1.52),('5819','2013-12-04','14:20:00',1.46),('5819','2013-12-04','14:25:00',1.38),('5819','2013-12-04','14:30:00',1.33),('5819','2013-12-04','14:35:00',1.28),('5819','2013-12-04','14:40:00',1.23),('5819','2013-12-04','14:45:00',1.16),('5819','2013-12-04','14:50:00',1.09),('5819','2013-12-04','14:55:00',1.04),('5819','2013-12-03','09:20:00',1.05),('5819','2013-12-03','09:25:00',1.01),('5819','2013-12-03','09:30:00',1.41),('5819','2013-12-03','09:35:00',1.38),('5819','2013-12-03','09:40:00',1.62),('5819','2013-12-03','09:45:00',1.76),('5819','2013-12-03','09:50:00',1.92),('5819','2013-12-03','09:55:00',1.9),('5819','2013-12-03','10:00:00',2.37),('5819','2013-12-03','10:05:00',2.37),('5819','2013-12-03','10:10:00',2.42),('5819','2013-12-03','10:15:00',2.45),('5819','2013-12-03','10:20:00',2.45),('5819','2013-12-03','10:25:00',2.5),('5819','2013-12-03','10:30:00',2.52),('5819','2013-12-03','10:35:00',2.54),('5819','2013-12-03','10:40:00',2.56),('5819','2013-12-03','10:45:00',2.57),('5819','2013-12-03','10:50:00',2.61),('5819','2013-12-03','10:55:00',2.65),('5819','2013-12-03','11:00:00',2.68),('5819','2013-12-03','11:05:00',2.7),('5819','2013-12-03','11:10:00',2.72),('5819','2013-12-03','11:15:00',2.72),('5819','2013-12-03','11:20:00',2.72),('5819','2013-12-03','11:25:00',2.7),('5819','2013-12-03','11:30:00',2.67),('5819','2013-12-03','11:35:00',2.67),('5819','2013-12-03','11:40:00',2.66),('5819','2013-12-03','11:45:00',2.67),('5819','2013-12-03','11:50:00',2.67),('5819','2013-12-03','11:55:00',2.67),('5819','2013-12-03','12:00:00',2.66),('5819','2013-12-03','12:05:00',2.66),('5819','2013-12-03','12:10:00',2.66),('5819','2013-12-03','12:15:00',2.66),('5819','2013-12-03','12:20:00',2.67),('5819','2013-12-03','12:25:00',2.67),('5819','2013-12-03','12:30:00',2.67),('5819','2013-12-03','12:35:00',2.68),('5819','2013-12-03','12:40:00',2.7),('5819','2013-12-03','12:45:00',2.74),('5819','2013-12-03','12:50:00',2.8),('5819','2013-12-03','12:55:00',2.85),('5819','2013-12-03','13:00:00',2.87),('5819','2013-12-03','13:05:00',2.89),('5819','2013-12-03','13:10:00',2.85),('5819','2013-12-03','13:15:00',2.72),('5819','2013-12-03','13:20:00',2.67),('5819','2013-12-03','13:25:00',2.54),('5819','2013-12-03','13:30:00',2.44),('5819','2013-12-03','13:35:00',2.33),('5819','2013-12-03','13:40:00',2.2),('5819','2013-12-03','13:45:00',2.1),('5819','2013-12-03','13:50:00',2.02),('5819','2013-12-03','13:55:00',1.9),('5819','2013-12-03','14:00:00',1.84),('5819','2013-12-03','14:05:00',1.72),('5819','2013-12-03','14:10:00',1.6),('5819','2013-12-03','14:15:00',1.5),('5819','2013-12-03','14:20:00',1.26),('5819','2013-12-03','14:25:00',1.16),('5819','2013-12-03','14:30:00',1.25),('5819','2013-12-03','14:35:00',1.28),('5819','2013-12-03','14:40:00',1.22),('5819','2013-12-03','14:45:00',1.15),('5819','2013-12-03','14:50:00',1.09),('5819','2013-12-03','14:55:00',1.02),('5819','2013-12-01','11:55:00',1.08),('5819','2013-12-01','12:05:00',1.14),('5819','2013-12-01','12:10:00',1.39),('5819','2013-12-01','12:15:00',1.07),('5819','2013-11-30','09:10:00',1.38),('5819','2013-11-30','09:15:00',1.76),('5819','2013-11-30','09:20:00',1.96),('5819','2013-11-30','09:25:00',1.91),('5819','2013-11-30','09:30:00',1.78),('5819','2013-11-30','09:35:00',2.04),('5819','2013-11-30','09:40:00',2.28),('5819','2013-11-30','09:45:00',1.91),('5819','2013-11-30','09:50:00',1.4),('5819','2013-11-30','09:55:00',1.22),('5819','2013-11-30','10:00:00',1.21),('5819','2013-11-30','10:05:00',1.03),('5819','2013-11-30','10:15:00',1.02),('5819','2013-11-30','10:20:00',1.13),('5819','2013-11-30','10:25:00',1.09),('5819','2013-11-30','10:30:00',1.13),('5819','2013-11-30','10:35:00',1.21),('5819','2013-11-30','10:40:00',1.35),('5819','2013-11-30','10:45:00',1.32),('5819','2013-11-30','10:50:00',1.33),('5819','2013-11-30','10:55:00',1.11),('5819','2013-11-30','11:00:00',1.01),('5819','2013-11-30','11:05:00',1.21),('5819','2013-11-30','11:10:00',1.31),('5819','2013-11-30','11:15:00',1.33),('5819','2013-11-30','11:20:00',1.15),('5819','2013-11-30','11:25:00',1.2),('5819','2013-11-30','11:30:00',1.09),('5819','2013-11-29','08:15:00',1.07),('5819','2013-11-29','08:20:00',1.16),('5819','2013-11-29','08:25:00',1.25),('5819','2013-11-29','08:30:00',1.33),('5819','2013-11-29','08:35:00',1.4),('5819','2013-11-29','08:40:00',1.48),('5819','2013-11-29','08:45:00',1.55),('5819','2013-11-29','08:50:00',1.63),('5819','2013-11-29','08:55:00',1.69),('5819','2013-11-29','09:00:00',1.77),('5819','2013-11-29','09:05:00',1.83),('5819','2013-11-29','09:10:00',1.89),('5819','2013-11-29','09:15:00',1.95),('5819','2013-11-29','09:20:00',2.02),('5819','2013-11-29','09:25:00',2.08),('5819','2013-11-29','09:30:00',2.13),('5819','2013-11-29','09:35:00',2.18),('5819','2013-11-29','09:40:00',2.24),('5819','2013-11-29','09:45:00',2.29),('5819','2013-11-29','09:50:00',2.33),('5819','2013-11-29','09:55:00',2.38),('5819','2013-11-29','10:00:00',2.41),('5819','2013-11-29','10:05:00',2.45),('5819','2013-11-29','10:10:00',2.48),('5819','2013-11-29','10:15:00',2.51),('5819','2013-11-29','10:20:00',2.54),('5819','2013-11-29','10:25:00',2.56),('5819','2013-11-29','10:30:00',2.59),('5819','2013-11-29','10:35:00',2.61),('5819','2013-11-29','10:40:00',2.64),('5819','2013-11-29','10:45:00',2.66),('5819','2013-11-29','10:50:00',2.67),('5819','2013-11-29','10:55:00',2.69),('5819','2013-11-29','11:00:00',2.7),('5819','2013-11-29','11:05:00',2.71),('5819','2013-11-29','11:10:00',2.71),('5819','2013-11-29','11:15:00',2.71),('5819','2013-11-29','11:20:00',2.73),('5819','2013-11-29','11:25:00',2.73),('5819','2013-11-29','11:30:00',2.72),('5819','2013-11-29','11:35:00',2.72),('5819','2013-11-29','11:40:00',2.72),('5819','2013-11-29','11:45:00',2.72),('5819','2013-11-29','11:50:00',2.7),('5819','2013-11-29','11:55:00',2.68),('5819','2013-11-29','12:00:00',2.68),('5819','2013-11-29','12:05:00',2.66),('5819','2013-11-29','12:10:00',2.64),('5819','2013-11-29','12:15:00',2.62),('5819','2013-11-29','12:20:00',2.59),('5819','2013-11-29','12:25:00',2.56),('5819','2013-11-29','12:30:00',2.54),('5819','2013-11-29','12:35:00',2.52),('5819','2013-11-29','12:40:00',2.49),('5819','2013-11-29','12:45:00',2.47),('5819','2013-11-29','12:50:00',2.43),('5819','2013-11-29','12:55:00',2.39),('5819','2013-11-29','13:00:00',2.34),('5819','2013-11-29','13:05:00',2.29),('5819','2013-11-29','13:10:00',2.26),('5819','2013-11-29','13:15:00',2.21),('5819','2013-11-29','13:20:00',2.16),('5819','2013-11-29','13:25:00',2.11),('5819','2013-11-29','13:30:00',2.06),('5819','2013-11-29','13:35:00',2.01),('5819','2013-11-29','13:40:00',1.96),('5819','2013-11-29','13:45:00',1.91),('5819','2013-11-29','13:50:00',1.84),('5819','2013-11-29','13:55:00',1.78),('5819','2013-11-29','14:00:00',1.72),('5819','2013-11-29','14:05:00',1.66),('5819','2013-11-29','14:10:00',1.6),('5819','2013-11-29','14:15:00',1.54),('5819','2013-11-29','14:20:00',1.47),('5819','2013-11-29','14:25:00',1.41),('5819','2013-11-29','14:30:00',1.35),('5819','2013-11-29','14:35:00',1.28),('5819','2013-11-29','14:40:00',1.21),('5819','2013-11-29','14:45:00',1.15),('5819','2013-11-29','14:50:00',1.09),('5819','2013-11-29','14:55:00',1.03),('5819','2014-04-20','07:50:00',1.02),('5819','2014-04-20','07:55:00',1.3),('5819','2014-04-20','08:00:00',1.33),('5819','2014-04-20','08:05:00',1.36),('5819','2014-04-20','08:10:00',1.45),('5819','2014-04-20','08:15:00',1.45),('5819','2014-04-20','08:20:00',1.77),('5819','2014-04-20','08:25:00',2.36),('5819','2014-04-20','08:30:00',2.48),('5819','2014-04-20','08:35:00',2.54),('5819','2014-04-20','08:40:00',2.14),('5819','2014-04-20','08:45:00',1.44),('5819','2014-04-20','08:50:00',2.13),('5819','2014-04-20','09:00:00',1.73),('5819','2014-04-20','09:10:00',1.38),('5819','2014-04-20','09:15:00',2.67),('5819','2014-04-20','09:20:00',2.85),('5819','2014-04-20','09:25:00',3.06),('5819','2014-04-20','09:30:00',3.38),('5819','2014-04-20','09:35:00',3.11),('5819','2014-04-20','09:40:00',1.73),('5819','2014-04-20','09:45:00',1.45),('5819','2014-04-20','09:50:00',1.47),('5819','2014-04-20','09:55:00',1.84),('5819','2014-04-20','10:00:00',2.24),('5819','2014-04-20','10:05:00',3.18),('5819','2014-04-20','10:10:00',2.56),('5819','2014-04-20','10:15:00',2.67),('5819','2014-04-20','10:20:00',2.76),('5819','2014-04-20','10:25:00',2.55),('5819','2014-04-20','10:30:00',2.39),('5819','2014-04-20','10:35:00',2.55),('5819','2014-04-20','10:40:00',2.51),('5819','2014-04-20','10:45:00',2.53),('5819','2014-04-20','10:50:00',2.83),('5819','2014-04-20','10:55:00',3.06),('5819','2014-04-20','11:00:00',3.29),('5819','2014-04-20','11:05:00',3.17),('5819','2014-04-20','11:10:00',2.97),('5819','2014-04-20','11:15:00',3.27),('5819','2014-04-20','11:20:00',3.34),('5819','2014-04-20','11:25:00',3.08),('5819','2014-04-20','11:30:00',3.88),('5819','2014-04-20','11:35:00',4.13),('5819','2014-04-20','11:40:00',3.23),('5819','2014-04-20','11:45:00',3.76),('5819','2014-04-20','11:50:00',3.55),('5819','2014-04-20','11:55:00',1.19),('5819','2014-04-20','12:00:00',2.87),('5819','2014-04-20','12:05:00',2.41),('5819','2014-04-20','12:10:00',3.07),('5819','2014-04-20','12:15:00',3.3),('5819','2014-04-20','12:20:00',1.53),('5819','2014-04-20','12:25:00',3.41),('5819','2014-04-20','12:30:00',4.27),('5819','2014-04-20','12:35:00',4.01),('5819','2014-04-20','12:40:00',4),('5819','2014-04-20','12:45:00',4.01),('5819','2014-04-20','12:50:00',4.05),('5819','2014-04-20','12:55:00',4.08),('5819','2014-04-20','13:00:00',4.1),('5819','2014-04-20','13:05:00',4.09),('5819','2014-04-20','13:10:00',4.16),('5819','2014-04-20','13:15:00',4.06),('5819','2014-04-20','13:20:00',3.97),('5819','2014-04-20','13:25:00',3.95),('5819','2014-04-20','13:30:00',3.97),('5819','2014-04-20','13:35:00',3.96),('5819','2014-04-20','13:40:00',3.95),('5819','2014-04-20','13:45:00',3.91),('5819','2014-04-20','13:50:00',3.88),('5819','2014-04-20','13:55:00',3.83),('5819','2014-04-20','14:00:00',3.8),('5819','2014-04-20','14:05:00',3.8),('5819','2014-04-20','14:10:00',3.79),('5819','2014-04-20','14:15:00',3.89),('5819','2014-04-20','14:20:00',3.23),('5819','2014-04-20','14:25:00',2.78),('5819','2014-04-20','14:30:00',2.77),('5819','2014-04-20','14:35:00',2.25),('5819','2014-04-20','14:40:00',2.26),('5819','2014-04-20','14:45:00',2.4),('5819','2014-04-20','14:50:00',2.3),('5819','2014-04-20','14:55:00',2.6),('5819','2014-04-20','15:00:00',3.17),('5819','2014-04-20','15:05:00',3.37),('5819','2014-04-20','15:10:00',3.13),('5819','2014-04-20','15:15:00',3.32),('5819','2014-04-20','15:20:00',3.16),('5819','2014-04-20','15:25:00',3.13),('5819','2014-04-20','15:30:00',3.06),('5819','2014-04-20','15:35:00',3),('5819','2014-04-20','15:40:00',2.99),('5819','2014-04-20','15:45:00',2.69),('5819','2014-04-20','15:50:00',2.06),('5819','2014-04-20','15:55:00',2.85),('5819','2014-04-20','16:00:00',2.69),('5819','2014-04-20','16:05:00',2.62),('5819','2014-04-20','16:10:00',2.56),('5819','2014-04-20','16:15:00',2.5),('5819','2014-04-20','16:20:00',2.49),('5819','2014-04-20','16:25:00',2.03),('5819','2014-04-20','16:30:00',2.38),('5819','2014-04-20','16:35:00',2.08),('5819','2014-04-20','16:40:00',2.03),('5819','2014-04-20','16:45:00',1.82),('5819','2014-04-20','16:50:00',2.02),('5819','2014-04-20','16:55:00',1.99),('5819','2014-04-20','17:00:00',1.85),('5819','2014-04-20','17:05:00',1.73),('5819','2014-04-20','17:10:00',1.61),('5819','2014-04-20','17:15:00',1.5),('5819','2014-04-20','17:20:00',1.41),('5819','2014-04-20','17:25:00',1.33),('5819','2014-04-20','17:30:00',1.13),('5819','2014-04-20','17:35:00',1.05),('5819','2014-04-20','17:40:00',1.05),('5819','2013-11-27','09:25:00',1.03),('5819','2013-11-27','09:40:00',1.23),('5819','2013-11-27','09:55:00',1.33),('5819','2013-11-27','10:00:00',1.15),('5819','2013-11-27','10:05:00',1.17),('5819','2013-11-27','10:10:00',1.16),('5819','2013-11-27','10:15:00',1.14),('5819','2013-11-27','10:20:00',1.09),('5819','2013-11-27','10:25:00',1.03),('5819','2013-11-27','10:30:00',1),('5819','2013-11-27','10:35:00',1.08),('5819','2013-11-27','10:40:00',1.18),('5819','2013-11-27','10:45:00',1.43),('5819','2013-11-27','10:50:00',1.4),('5819','2013-11-27','10:55:00',1.22),('5819','2013-11-27','11:00:00',1.32),('5819','2013-11-27','11:05:00',1.35),('5819','2013-11-27','11:10:00',1.71),('5819','2013-11-27','11:15:00',1.41),('5819','2013-11-27','11:20:00',1.45),('5819','2013-11-27','11:25:00',1.42),('5819','2013-11-27','11:30:00',1.91),('5819','2013-11-27','11:35:00',2.03),('5819','2013-11-27','11:40:00',1.54),('5819','2013-11-27','11:45:00',1.48),('5819','2013-11-27','11:50:00',1.83),('5819','2013-11-27','11:55:00',2.97),('5819','2013-11-27','12:00:00',3.02),('5819','2013-11-27','12:05:00',2.38),('5819','2013-11-27','12:10:00',1.16),('5819','2013-11-27','12:15:00',1.92),('5819','2013-11-27','12:20:00',2.76),('5819','2013-11-27','12:25:00',1.4),('5819','2013-11-27','12:30:00',2.16),('5819','2013-11-27','12:35:00',1.46),('5819','2013-11-27','12:40:00',1.28),('5819','2013-11-26','08:05:00',1.16),('5819','2013-11-26','08:10:00',1.25),('5819','2013-11-26','08:15:00',1.01),('5819','2013-11-26','09:05:00',1.04),('5819','2013-11-26','09:10:00',1.3),('5819','2013-11-26','09:15:00',1.41),('5819','2013-11-26','09:20:00',1.45),('5819','2013-11-26','09:25:00',1.35),('5819','2013-11-26','09:30:00',1.22),('5819','2013-11-26','09:35:00',1.39),('5819','2013-11-26','09:40:00',2.04),('5819','2013-11-26','09:45:00',1.48),('5819','2013-11-26','09:50:00',1.61),('5819','2013-11-26','09:55:00',2.02),('5819','2013-11-26','10:00:00',1.89),('5819','2013-11-26','10:05:00',2.29),('5819','2013-11-26','10:10:00',1.22),('5819','2013-11-26','10:25:00',1.81),('5819','2013-11-26','10:30:00',2.58),('5819','2013-11-26','10:35:00',2.85),('5819','2013-11-26','10:40:00',2.84),('5819','2013-11-26','10:45:00',2.86),('5819','2013-11-26','10:50:00',2.92),('5819','2013-11-26','10:55:00',2.96),('5819','2013-11-26','11:00:00',3.13),('5819','2013-11-26','11:05:00',2.44),('5819','2013-11-26','11:10:00',3.15),('5819','2013-11-26','11:15:00',3.48),('5819','2013-11-26','11:20:00',3.28),('5819','2013-11-26','11:25:00',3.26),('5819','2013-11-26','11:30:00',3.3),('5819','2013-11-26','11:35:00',3.41),('5819','2013-11-26','11:40:00',3.2),('5819','2013-11-26','11:45:00',3.02),('5819','2013-11-26','11:50:00',2.79),('5819','2013-11-26','11:55:00',1.47),('5819','2013-11-26','12:05:00',1.41),('5819','2013-11-26','12:15:00',1.39),('5819','2013-11-26','12:20:00',2.87),('5819','2013-11-26','12:25:00',2.79),('5819','2013-11-26','12:30:00',2.71),('5819','2013-11-26','12:35:00',2.7),('5819','2013-11-26','12:40:00',2.69),('5819','2013-11-26','12:45:00',2.63),('5819','2013-11-26','12:50:00',2.61),('5819','2013-11-26','12:55:00',2.58),('5819','2013-11-26','13:00:00',2.55),('5819','2013-11-26','13:05:00',2.51),('5819','2013-11-26','13:10:00',2.46),('5819','2013-11-26','13:15:00',2.42),('5819','2013-11-26','13:20:00',2.37),('5819','2013-11-26','13:25:00',2.31),('5819','2013-11-26','13:30:00',2.26),('5819','2013-11-26','13:35:00',2.21),('5819','2013-11-26','13:40:00',2.16),('5819','2013-11-26','13:45:00',2.12),('5819','2013-11-26','13:50:00',2.12),('5819','2013-11-26','13:55:00',2.02),('5819','2013-11-26','14:00:00',2.03),('5819','2013-11-26','14:05:00',1.55),('5819','2013-11-26','14:10:00',2.33),('5819','2013-11-26','14:15:00',2.37),('5819','2013-11-26','14:20:00',1.99),('5819','2013-11-26','14:25:00',1.34),('5819','2013-11-26','14:30:00',1.29),('5819','2013-11-26','14:35:00',1.49),('5819','2013-11-26','14:40:00',1.57),('5819','2013-11-26','14:45:00',1.59),('5819','2013-11-26','14:50:00',1.71),('5819','2013-11-26','14:55:00',1.7),('5819','2013-11-26','15:00:00',1.58),('5819','2013-11-26','15:05:00',1.39),('5819','2013-11-26','15:10:00',1.16),('5819','2013-11-26','15:15:00',1.04),('5819','2013-11-25','08:05:00',1.05),('5819','2013-11-25','08:10:00',1.14),('5819','2013-11-25','08:15:00',1.24),('5819','2013-11-25','08:20:00',1.37),('5819','2013-11-25','08:25:00',1.51),('5819','2013-11-25','08:30:00',1.57),('5819','2013-11-25','08:35:00',1.66),('5819','2013-11-25','08:40:00',1.75),('5819','2013-11-25','08:45:00',1.88),('5819','2013-11-25','08:50:00',2.02),('5819','2013-11-25','08:55:00',2.16),('5819','2013-11-25','09:00:00',2.33),('5819','2013-11-25','09:05:00',2.41),('5819','2013-11-25','09:10:00',2.43),('5819','2013-11-25','09:15:00',2.52),('5819','2013-11-25','09:20:00',2.62),('5819','2013-11-25','09:25:00',2.68),('5819','2013-11-25','09:30:00',2.4),('5819','2013-11-25','09:35:00',2.36),('5819','2013-11-25','09:40:00',2.02),('5819','2013-11-25','09:45:00',1.22),('5819','2013-11-25','09:50:00',1.44),('5819','2013-11-25','09:55:00',1.4),('5819','2013-11-25','10:00:00',1.31),('5819','2013-11-25','10:05:00',1.36),('5819','2013-11-25','10:10:00',1.2),('5819','2013-11-25','10:15:00',1.57),('5819','2013-11-25','10:20:00',1.7),('5819','2013-11-25','10:25:00',1.66),('5819','2013-11-25','10:30:00',2.32),('5819','2013-11-25','10:35:00',3.46),('5819','2013-11-25','10:40:00',3.31),('5819','2013-11-25','10:45:00',2.94),('5819','2013-11-25','10:50:00',2.59),('5819','2013-11-25','10:55:00',2.51),('5819','2013-11-25','11:00:00',2.84),('5819','2013-11-25','11:05:00',3.01),('5819','2013-11-25','11:10:00',3.38),('5819','2013-11-25','11:15:00',1.83),('5819','2013-11-25','11:20:00',1.58),('5819','2013-11-25','11:25:00',1.12),('5819','2013-11-25','11:30:00',1.24),('5819','2013-11-25','11:35:00',1.15),('5819','2013-11-25','11:40:00',1.03),('5819','2013-11-25','11:45:00',1.05),('5819','2013-11-25','11:50:00',1.56),('5819','2013-11-25','11:55:00',1.91),('5819','2013-11-25','12:00:00',1.32),('5819','2013-11-25','12:05:00',1.33),('5819','2013-11-25','12:10:00',1.89),('5819','2013-11-25','12:15:00',1.52),('5819','2013-11-25','12:20:00',1.39),('5819','2013-11-25','12:25:00',1.35),('5819','2013-11-25','12:30:00',1.2),('5819','2013-11-25','12:35:00',1.07),('5819','2013-11-25','12:40:00',2.59),('5819','2013-11-25','12:45:00',2.71),('5819','2013-11-25','12:50:00',1.92),('5819','2013-11-25','12:55:00',2.36),('5819','2013-11-25','13:00:00',3.04),('5819','2013-11-25','13:05:00',3.05),('5819','2013-11-25','13:10:00',1.85),('5819','2013-11-25','13:15:00',1.91),('5819','2013-11-25','13:20:00',1.95),('5819','2013-11-25','13:25:00',1.34),('5819','2013-11-25','13:30:00',1.01),('5819','2013-11-24','10:00:00',1.24),('5819','2013-11-24','10:05:00',1.4),('5819','2013-11-24','10:10:00',1.47),('5819','2013-11-24','10:15:00',1.26),('5819','2013-11-24','10:20:00',1.12),('5819','2013-11-24','10:25:00',1.67),('5819','2013-11-24','10:30:00',1.75),('5819','2013-11-24','10:35:00',1.12),('5819','2013-11-24','10:40:00',1.14),('5819','2013-11-24','10:55:00',1.07),('5819','2013-11-24','11:00:00',1.09),('5819','2013-11-24','11:05:00',1.12),('5819','2013-11-24','11:10:00',1.17),('5819','2013-11-24','11:15:00',1.21),('5819','2013-11-24','11:20:00',1.37),('5819','2013-11-24','11:25:00',1.49),('5819','2013-11-24','11:30:00',1.27),('5819','2013-11-24','11:35:00',1.11),('5819','2013-11-24','11:40:00',1.04),('5819','2013-11-24','11:50:00',1.1),('5819','2013-11-24','13:10:00',1.17),('5819','2013-11-24','13:15:00',1.15),('5819','2013-11-23','10:15:00',1.03),('5819','2013-11-23','10:20:00',1.2),('5819','2013-11-23','10:25:00',1.18),('5819','2013-11-23','10:30:00',1.69),('5819','2013-11-23','10:40:00',2.63),('5819','2013-11-23','13:25:00',1.17),('5819','2013-11-23','13:35:00',1.08),('5819','2013-11-23','13:40:00',1.08),('5819','2013-11-21','08:10:00',1.3),('5819','2013-11-21','08:15:00',1.39),('5819','2013-11-21','09:15:00',1.14),('5819','2013-11-21','09:20:00',1.42),('5819','2013-11-21','09:25:00',1.1),('5819','2013-11-21','09:30:00',1.15),('5819','2013-11-21','09:40:00',1.51),('5819','2013-11-21','09:45:00',2.18),('5819','2013-11-21','09:50:00',2.16),('5819','2013-11-21','09:55:00',1.77),('5819','2013-11-21','10:00:00',1.57),('5819','2013-11-21','10:05:00',2.51),('5819','2013-11-21','10:10:00',2.32),('5819','2013-11-21','10:15:00',2.62),('5819','2013-11-21','10:20:00',2.63),('5819','2013-11-21','10:25:00',1.85),('5819','2013-11-21','10:30:00',2.21),('5819','2013-11-21','10:35:00',2.61),('5819','2013-11-21','10:40:00',2.74),('5819','2013-11-21','10:45:00',2.15),('5819','2013-11-21','11:15:00',1.15),('5819','2013-11-21','11:20:00',1.09),('5819','2013-11-21','11:25:00',2.1),('5819','2013-11-21','11:30:00',2.69),('5819','2013-11-21','11:35:00',1.68),('5819','2013-11-21','11:40:00',2.82),('5819','2013-11-21','11:45:00',2.2),('5819','2013-11-21','11:50:00',2.76),('5819','2013-11-21','11:55:00',2.74),('5819','2013-11-21','12:00:00',1.81),('5819','2013-11-21','12:05:00',2.69),('5819','2013-11-21','12:10:00',2.74),('5819','2013-11-21','12:15:00',2.71),('5819','2013-11-21','12:20:00',2.69),('5819','2013-11-21','12:25:00',2.74),('5819','2013-11-21','12:30:00',2.86),('5819','2013-11-21','12:35:00',2.94),('5819','2013-11-21','12:40:00',3.02),('5819','2013-11-21','12:45:00',2.87),('5819','2013-11-21','12:50:00',2.78),('5819','2013-11-21','12:55:00',2.99),('5819','2013-11-21','13:00:00',2.93),('5819','2013-11-21','13:05:00',2.57),('5819','2013-11-21','13:10:00',1.51),('5819','2013-11-21','13:15:00',2.38),('5819','2013-11-21','13:20:00',2.54),('5819','2013-11-21','13:25:00',2.09),('5819','2013-11-21','13:40:00',1.48),('5819','2013-11-21','13:45:00',2.23),('5819','2013-11-21','13:50:00',1.16),('5819','2013-11-21','13:55:00',1.97),('5819','2013-11-21','14:00:00',2.05),('5819','2013-11-21','14:05:00',1.1),('5819','2013-11-21','14:25:00',1.03),('5819','2013-11-21','14:40:00',1.33),('5819','2013-11-21','14:45:00',1.25),('5819','2013-11-21','14:50:00',1.18),('5819','2013-11-21','15:00:00',1.04),('5819','2013-11-20','08:20:00',1.46),('5819','2013-11-20','09:00:00',1.5),('5819','2013-11-20','09:10:00',1.16),('5819','2013-11-20','09:15:00',1.97),('5819','2013-11-20','09:20:00',1.98),('5819','2013-11-20','09:25:00',2.2),('5819','2013-11-20','09:30:00',2.27),('5819','2013-11-20','09:35:00',1.24),('5819','2013-11-20','10:00:00',1.58),('5819','2013-11-20','10:05:00',1.19),('5819','2013-11-20','10:15:00',1.82),('5819','2013-11-20','11:25:00',1.16),('5819','2013-11-20','11:30:00',1.18),('5819','2013-11-20','11:35:00',1.04),('5819','2013-11-20','11:40:00',1.01),('5819','2013-11-20','11:45:00',3.06),('5819','2013-11-20','11:50:00',3.17),('5819','2013-11-20','11:55:00',1.39),('5819','2013-11-20','12:20:00',2.34),('5819','2013-11-20','12:25:00',1.5),('5819','2013-11-20','12:45:00',1.04),('5819','2013-11-20','12:50:00',1.28),('5819','2013-11-20','12:55:00',1.5),('5819','2013-11-20','13:00:00',2),('5819','2013-11-20','13:05:00',1.74),('5819','2013-11-20','13:10:00',1.15),('5819','2013-11-20','13:20:00',1.4),('5819','2013-11-20','13:40:00',1.65),('5819','2013-11-20','13:45:00',1.15),('5819','2013-11-20','13:50:00',1.96),('5819','2013-11-20','13:55:00',1.4),('5819','2013-11-20','14:00:00',1.12),('5819','2013-11-20','14:45:00',1.22),('5819','2013-11-20','15:10:00',1.16),('5819','2013-11-19','09:35:00',1.13),('5819','2013-11-19','09:40:00',2.2),('5819','2013-11-19','09:45:00',2.14),('5819','2013-11-19','09:50:00',1.29),('5819','2013-11-19','10:00:00',1.26),('5819','2013-11-19','10:05:00',1.63),('5819','2013-11-19','10:50:00',1.55),('5819','2013-11-19','11:20:00',2.39),('5819','2013-11-19','11:25:00',2.13),('5819','2013-11-19','11:30:00',2.53),('5819','2013-11-19','11:35:00',2.61),('5819','2013-11-19','11:40:00',2.56),('5819','2013-11-19','11:45:00',2.52),('5819','2013-11-19','11:50:00',2.55),('5819','2013-11-19','11:55:00',2.52),('5819','2013-11-19','12:00:00',2.33),('5819','2013-11-19','12:05:00',2.25),('5819','2013-11-19','12:10:00',2.5),('5819','2013-11-19','12:15:00',2.49),('5819','2013-11-19','12:20:00',1.59),('5819','2013-11-19','12:30:00',1.27),('5819','2013-11-19','12:45:00',2),('5819','2013-11-19','12:50:00',1.06),('5819','2013-11-19','12:55:00',2.82),('5819','2013-11-19','13:00:00',2.35),('5819','2013-11-19','13:10:00',1.15),('5819','2013-11-19','13:15:00',1.9),('5819','2013-11-19','13:20:00',2.33),('5819','2013-11-19','15:30:00',1.35),('5819','2013-11-19','15:35:00',1.02),('5819','2013-11-18','08:00:00',1.02),('5819','2013-11-18','08:05:00',1.07),('5819','2013-11-18','08:10:00',1.09),('5819','2013-11-18','08:15:00',1.14),('5819','2013-11-18','08:20:00',1.19),('5819','2013-11-18','08:25:00',1.23),('5819','2013-11-18','08:30:00',1.32),('5819','2013-11-18','08:35:00',1.37),('5819','2013-11-18','08:40:00',1.19),('5819','2013-11-18','08:45:00',1.18),('5819','2013-11-18','08:50:00',1.01),('5819','2013-11-18','09:15:00',1.17),('5819','2013-11-18','09:20:00',1.66),('5819','2013-11-18','09:25:00',1.71),('5819','2013-11-18','09:30:00',1.61),('5819','2013-11-18','09:35:00',2.11),('5819','2013-11-18','09:40:00',1.67),('5819','2013-11-18','09:45:00',1.47),('5819','2013-11-18','09:50:00',1.06),('5819','2013-11-18','09:55:00',1.03),('5819','2013-11-18','10:00:00',1.14),('5819','2013-11-18','10:05:00',1.34),('5819','2013-11-18','10:10:00',1.46),('5819','2013-11-18','10:15:00',1.75),('5819','2013-11-18','10:20:00',1.5),('5819','2013-11-18','10:25:00',1.29),('5819','2013-11-18','10:30:00',1.24),('5819','2013-11-18','10:35:00',1.13),('5819','2013-11-18','10:40:00',1.17),('5819','2013-11-18','10:45:00',1.22),('5819','2013-11-18','10:50:00',1.16),('5819','2013-11-18','10:55:00',1.04),('5819','2013-11-18','11:35:00',1.02),('5819','2013-11-18','11:40:00',1.06),('5819','2013-11-18','11:45:00',1.1),('5819','2013-11-18','11:50:00',1.15),('5819','2013-11-18','11:55:00',1.23),('5819','2013-11-18','12:00:00',1.3),('5819','2013-11-18','12:05:00',1.37),('5819','2013-11-18','12:10:00',1.37),('5819','2013-11-18','12:15:00',1.4),('5819','2013-11-18','12:20:00',1.48),('5819','2013-11-18','12:25:00',1.55),('5819','2013-11-18','12:30:00',1.37),('5819','2013-11-18','12:35:00',1.19),('5819','2013-11-18','12:40:00',1.04),('5819','2013-11-18','13:35:00',1.03),('5819','2013-11-18','13:40:00',1.06),('5819','2014-04-19','07:35:00',1.08),('5819','2014-04-19','07:40:00',1.27),('5819','2014-04-19','07:55:00',1.72),('5819','2014-04-19','08:00:00',1.35),('5819','2014-04-19','08:05:00',1.06),('5819','2014-04-19','08:10:00',1.61),('5819','2014-04-19','08:15:00',1.08),('5819','2014-04-19','08:20:00',1.16),('5819','2014-04-19','08:25:00',1.47),('5819','2014-04-19','08:30:00',1.85),('5819','2014-04-19','08:35:00',2.46),('5819','2014-04-19','08:40:00',2.24),('5819','2014-04-19','08:45:00',1.91),('5819','2014-04-19','08:50:00',1.53),('5819','2014-04-19','08:55:00',1.13),('5819','2014-04-19','09:25:00',1.2),('5819','2014-04-19','09:30:00',2.05),('5819','2014-04-19','09:35:00',2.18),('5819','2014-04-19','09:40:00',1.28),('5819','2014-04-19','10:40:00',1.09),('5819','2014-04-19','10:45:00',1.07),('5819','2014-04-19','10:50:00',1.08),('5819','2014-04-19','10:55:00',1.36),('5819','2014-04-19','11:00:00',1.49),('5819','2014-04-19','11:05:00',1.19),('5819','2014-04-19','11:10:00',1.07),('5819','2014-04-19','11:15:00',1.55),('5819','2014-04-19','11:20:00',3.11),('5819','2014-04-19','11:25:00',2.55),('5819','2014-04-19','11:30:00',2.49),('5819','2014-04-19','11:35:00',2.23),('5819','2014-04-19','11:40:00',2.58),('5819','2014-04-19','11:45:00',1.99),('5819','2014-04-19','11:50:00',1.74),('5819','2014-04-19','11:55:00',1.08),('5819','2014-04-19','13:15:00',1.2),('5819','2014-04-19','13:20:00',1.27),('5819','2014-04-19','14:30:00',1.15),('5819','2014-04-19','14:35:00',1.36),('5819','2014-04-19','14:40:00',1.53),('5819','2014-04-19','14:45:00',1.63),('5819','2014-04-19','14:50:00',1.15),('5819','2014-04-19','15:00:00',1.19),('5819','2014-04-19','15:05:00',1.26),('5819','2014-04-19','15:30:00',1.05),('5819','2014-04-19','15:50:00',2.26),('5819','2014-04-19','15:55:00',3.02),('5819','2014-04-19','16:00:00',1.67),('5819','2014-04-19','16:05:00',1.45),('5819','2014-04-19','16:10:00',1.46),('5819','2014-04-19','16:15:00',1.36),('5819','2014-04-19','16:20:00',1.65),('5819','2014-04-19','16:25:00',1.64),('5819','2014-04-19','16:30:00',2.45),('5819','2014-04-19','16:35:00',1.45),('5819','2014-04-19','16:40:00',1.02),('5819','2014-04-19','17:20:00',1.37),('5819','2014-04-19','17:25:00',1.11),('5819','2013-11-17','08:45:00',1.31),('5819','2013-11-17','08:50:00',1.37),('5819','2013-11-17','08:55:00',2.31),('5819','2013-11-17','09:00:00',2.17),('5819','2013-11-17','09:05:00',2.04),('5819','2013-11-17','09:10:00',2.05),('5819','2013-11-17','09:15:00',2.06),('5819','2013-11-17','09:20:00',1.81),('5819','2013-11-17','09:25:00',2.18),('5819','2013-11-17','09:30:00',2.22),('5819','2013-11-17','09:35:00',2.24),('5819','2013-11-17','09:40:00',2.29),('5819','2013-11-17','09:45:00',2.31),('5819','2013-11-17','09:50:00',2.35),('5819','2013-11-17','09:55:00',2.39),('5819','2013-11-17','10:00:00',2.42),('5819','2013-11-17','10:05:00',2.45),('5819','2013-11-17','10:10:00',2.48),('5819','2013-11-17','10:15:00',2.51),('5819','2013-11-17','10:20:00',2.53),('5819','2013-11-17','10:25:00',2.54),('5819','2013-11-17','10:30:00',2.56),('5819','2013-11-17','10:35:00',2.57),('5819','2013-11-17','10:40:00',2.58),('5819','2013-11-17','10:45:00',2.59),('5819','2013-11-17','10:50:00',2.6),('5819','2013-11-17','10:55:00',2.62),('5819','2013-11-17','11:00:00',2.62),('5819','2013-11-17','11:05:00',2.63),('5819','2013-11-17','11:10:00',2.63),('5819','2013-11-17','11:15:00',2.63),('5819','2013-11-17','11:20:00',2.63),('5819','2013-11-17','11:25:00',2.62),('5819','2013-11-17','11:30:00',2.61),('5819','2013-11-17','11:35:00',2.61),('5819','2013-11-17','11:40:00',2.63),('5819','2013-11-17','11:45:00',2.61),('5819','2013-11-17','11:50:00',2.6),('5819','2013-11-17','11:55:00',2.59),('5819','2013-11-17','12:00:00',2.54),('5819','2013-11-17','12:05:00',2.54),('5819','2013-11-17','12:10:00',2.52),('5819','2013-11-17','12:15:00',2.5),('5819','2013-11-17','12:20:00',2.49),('5819','2013-11-17','12:25:00',2.46),('5819','2013-11-17','12:30:00',2.45),('5819','2013-11-17','12:35:00',2.42),('5819','2013-11-17','12:40:00',2.4),('5819','2013-11-17','12:45:00',2.36),('5819','2013-11-17','12:50:00',2.32),('5819','2013-11-17','12:55:00',2.27),('5819','2013-11-17','13:00:00',2.24),('5819','2013-11-17','13:05:00',2.17),('5819','2013-11-17','13:10:00',2.17),('5819','2013-11-17','13:15:00',2.14),('5819','2013-11-17','13:20:00',2.1),('5819','2013-11-17','13:25:00',2.05),('5819','2013-11-17','13:30:00',1.76),('5819','2013-11-17','13:35:00',1.79),('5819','2013-11-17','13:40:00',1.15),('5819','2013-11-17','14:00:00',1.26),('5819','2013-11-17','14:05:00',1.48),('5819','2013-11-17','14:10:00',1.56),('5819','2013-11-17','14:15:00',1.52),('5819','2013-11-17','14:20:00',1.46),('5819','2013-11-17','14:25:00',1.39),('5819','2013-11-17','14:30:00',1.28),('5819','2013-11-17','14:35:00',1.23),('5819','2013-11-17','14:40:00',1.14),('5819','2013-11-17','14:45:00',1.16),('5819','2013-11-17','14:50:00',1.14),('5819','2013-11-17','14:55:00',1.08),('5819','2013-11-15','09:15:00',1.02),('5819','2013-11-15','09:35:00',1.04),('5819','2013-11-15','10:15:00',1.15),('5819','2013-11-15','10:20:00',1.19),('5819','2013-11-15','10:50:00',1.09),('5819','2013-11-15','10:55:00',1.83),('5819','2013-11-15','11:00:00',1.38),('5819','2013-11-15','11:05:00',1.2),('5819','2013-11-15','11:10:00',1.12),('5819','2013-11-15','11:15:00',1.28),('5819','2013-11-15','11:20:00',1.6),('5819','2013-11-15','11:25:00',2.54),('5819','2013-11-15','11:30:00',1.55),('5819','2013-11-15','11:35:00',1.58),('5819','2013-11-15','11:40:00',1.82),('5819','2013-11-15','11:45:00',1.53),('5819','2013-11-15','11:50:00',1.35),('5819','2013-11-15','11:55:00',1.18),('5819','2013-11-15','12:00:00',1.2),('5819','2013-11-15','12:05:00',1.2),('5819','2013-11-15','12:10:00',1.17),('5819','2013-11-15','12:15:00',1.15),('5819','2013-11-15','12:20:00',1.18),('5819','2013-11-15','12:25:00',1.73),('5819','2013-11-15','12:30:00',1.53),('5819','2013-11-15','12:35:00',1.24),('5819','2013-11-15','12:40:00',1.14),('5819','2013-11-15','12:45:00',1.08),('5819','2013-11-15','12:50:00',1.39),('5819','2013-11-15','12:55:00',1.49),('5819','2013-11-15','13:00:00',1.3),('5819','2013-11-15','13:05:00',1.15),('5819','2013-11-15','13:10:00',1.15),('5819','2013-11-15','13:35:00',1.06),('5819','2013-11-15','13:40:00',1.02),('5819','2013-11-15','13:45:00',1.42),('5819','2013-11-15','13:50:00',1.49),('5819','2013-11-15','13:55:00',1.12),('5819','2013-11-15','14:00:00',1.06),('5819','2013-11-14','08:20:00',1.34),('5819','2013-11-14','08:25:00',1.41),('5819','2013-11-14','08:30:00',1.5),('5819','2013-11-14','08:35:00',1.42),('5819','2013-11-14','08:40:00',1.14),('5819','2013-11-14','09:05:00',1.37),('5819','2013-11-14','09:10:00',1.27),('5819','2013-11-14','09:15:00',1.52),('5819','2013-11-14','09:20:00',2.17),('5819','2013-11-14','09:25:00',2.17),('5819','2013-11-14','09:30:00',2.2),('5819','2013-11-14','09:35:00',2.23),('5819','2013-11-14','09:40:00',2.25),('5819','2013-11-14','09:45:00',2.23),('5819','2013-11-14','09:50:00',1.82),('5819','2013-11-14','10:00:00',1.25),('5819','2013-11-14','10:05:00',1.86),('5819','2013-11-14','10:10:00',1.34),('5819','2013-11-14','10:15:00',2.53),('5819','2013-11-14','10:20:00',2.57),('5819','2013-11-14','10:25:00',2.54),('5819','2013-11-14','10:30:00',2.53),('5819','2013-11-14','10:35:00',2.53),('5819','2013-11-14','10:40:00',2.55),('5819','2013-11-14','10:45:00',2.58),('5819','2013-11-14','10:50:00',2.58),('5819','2013-11-14','10:55:00',2.56),('5819','2013-11-14','11:00:00',2.56),('5819','2013-11-14','11:05:00',2.64),('5819','2013-11-14','11:10:00',2.7),('5819','2013-11-14','11:15:00',2.75),('5819','2013-11-14','11:20:00',2.76),('5819','2013-11-14','11:25:00',2.79),('5819','2013-11-14','11:30:00',2.78),('5819','2013-11-14','11:35:00',2.69),('5819','2013-11-14','11:40:00',2.3),('5819','2013-11-14','11:45:00',1.5),('5819','2013-11-14','11:50:00',1.6),('5819','2013-11-14','11:55:00',2.34),('5819','2013-11-14','12:00:00',1.95),('5819','2013-11-14','12:05:00',1.24),('5819','2013-11-14','12:10:00',1.22),('5819','2013-11-14','12:15:00',1.57),('5819','2013-11-14','12:20:00',1.22),('5819','2013-11-14','12:25:00',1.07),('5819','2013-11-14','12:35:00',1.02),('5819','2013-11-14','12:45:00',1.01),('5819','2013-11-14','12:50:00',1.08),('5819','2013-11-14','12:55:00',1.06),('5819','2013-11-14','13:00:00',1.05),('5819','2013-11-13','08:35:00',1.1),('5819','2013-11-13','10:00:00',1.19),('5819','2013-11-13','10:20:00',1.38),('5819','2013-11-13','10:25:00',1.32),('5819','2013-11-13','10:30:00',1.6),('5819','2013-11-13','10:35:00',3.14),('5819','2013-11-13','10:40:00',2.86),('5819','2013-11-13','10:45:00',2.6),('5819','2013-11-13','10:50:00',3.48),('5819','2013-11-13','10:55:00',3.34),('5819','2013-11-13','11:00:00',3.23),('5819','2013-11-13','11:05:00',1.02),('5819','2013-11-13','11:15:00',1.03),('5819','2013-11-13','11:25:00',1.01),('5819','2013-11-13','11:30:00',1.13),('5819','2013-11-13','11:35:00',1.11),('5819','2013-11-13','11:45:00',1.06),('5819','2013-11-13','11:50:00',1.22),('5819','2013-11-13','11:55:00',1.06),('5819','2013-11-13','13:00:00',1.03),('5819','2013-11-13','13:05:00',1.28),('5819','2013-11-13','13:10:00',1.14),('5819','2013-11-13','13:15:00',1.15),('5819','2013-11-13','13:55:00',1.48),('5819','2013-11-13','14:00:00',1.67),('5819','2013-11-13','14:05:00',1.61),('5819','2013-11-13','14:10:00',1.43),('5819','2013-11-13','14:15:00',1.51),('5819','2013-11-13','14:20:00',1.34),('5819','2013-11-13','14:25:00',1.41),('5819','2013-11-13','14:30:00',1.29),('5819','2013-11-12','11:25:00',1.31),('5819','2013-11-12','11:35:00',1.11),('5819','2013-11-12','11:40:00',2.53),('5819','2013-11-12','11:45:00',1.47),('5819','2013-11-12','11:50:00',1.43),('5819','2013-11-12','11:55:00',1),('5819','2013-11-12','12:00:00',2.69),('5819','2013-11-12','12:05:00',1.07),('5819','2013-11-12','12:30:00',3.41),('5819','2013-11-12','12:35:00',2.69),('5819','2013-11-12','12:40:00',1.83),('5819','2013-11-12','12:45:00',1.75),('5819','2013-11-12','12:50:00',1.45),('5819','2013-11-12','12:55:00',1.8),('5819','2013-11-12','13:00:00',1.78),('5819','2013-11-12','13:05:00',1.99),('5819','2013-11-12','13:10:00',2.33),('5819','2013-11-12','13:15:00',3.35),('5819','2013-11-12','13:20:00',2.66),('5819','2013-11-12','13:25:00',2.2),('5819','2013-11-12','13:30:00',1.72),('5819','2013-11-12','13:35:00',2.1),('5819','2013-11-12','13:40:00',2.98),('5819','2013-11-12','13:45:00',1.67),('5819','2013-11-12','13:50:00',1.11),('5819','2013-11-12','13:55:00',1.28),('5819','2013-11-12','14:00:00',1.26),('5819','2013-11-12','14:05:00',1.04),('5819','2013-11-12','14:10:00',1.41),('5819','2013-11-12','14:15:00',2.18),('5819','2013-11-12','14:20:00',2.18),('5819','2013-11-12','14:25:00',2.07),('5819','2013-11-12','14:30:00',1.74),('5819','2013-11-12','14:35:00',1.43),('5819','2013-11-12','14:40:00',1.68),('5819','2013-11-12','14:45:00',1.39),('5819','2013-11-12','14:50:00',1.2),('5819','2013-11-11','09:50:00',1.26),('5819','2013-11-11','09:55:00',1.25),('5819','2013-11-11','10:10:00',1.11),('5819','2013-11-11','10:15:00',1.99),('5819','2013-11-11','10:20:00',3.07),('5819','2013-11-11','10:25:00',1.64),('5819','2013-11-11','11:05:00',1.07),('5819','2013-11-11','11:10:00',2.24),('5819','2013-11-11','11:15:00',1.92),('5819','2013-11-11','11:20:00',1.57),('5819','2013-11-11','11:25:00',3.18),('5819','2013-11-11','11:30:00',1.46),('5819','2013-11-11','11:35:00',2.66),('5819','2013-11-11','11:40:00',3.48),('5819','2013-11-11','11:45:00',3.46),('5819','2013-11-11','11:50:00',3.49),('5819','2013-11-11','11:55:00',3.21),('5819','2013-11-11','12:00:00',3.03),('5819','2013-11-11','12:05:00',2.97),('5819','2013-11-11','12:10:00',2.92),('5819','2013-11-11','12:15:00',2.91),('5819','2013-11-11','12:20:00',2.75),('5819','2013-11-11','12:25:00',2.3),('5819','2013-11-11','12:30:00',2.84),('5819','2013-11-11','12:35:00',1.61),('5819','2013-11-11','12:40:00',2.01),('5819','2013-11-11','12:45:00',1.54),('5819','2013-11-11','13:00:00',1.23),('5819','2013-11-11','13:05:00',1.16),('5819','2013-11-11','13:10:00',2.58),('5819','2013-11-11','13:15:00',1.8),('5819','2013-11-11','13:35:00',1.42),('5819','2013-11-11','13:40:00',1.56),('5819','2013-11-11','13:45:00',1.08),('5819','2013-11-11','14:15:00',1.61),('5819','2013-11-11','14:20:00',1.91),('5819','2013-11-11','14:25:00',1.79),('5819','2013-11-11','14:30:00',1.66),('5819','2013-11-11','14:35:00',1.59),('5819','2013-11-11','14:40:00',1.38),('5819','2013-11-10','07:50:00',1.32),('5819','2013-11-10','07:55:00',1.32),('5819','2013-11-10','08:00:00',1.27),('5819','2013-11-10','08:40:00',1.45),('5819','2013-11-10','08:45:00',1.25),('5819','2013-11-10','08:50:00',1.61),('5819','2013-11-10','08:55:00',2.05),('5819','2013-11-10','09:00:00',1.54),('5819','2013-11-10','09:05:00',1.27),('5819','2013-11-10','09:10:00',1.1),('5819','2013-11-10','09:15:00',1.62),('5819','2013-11-10','09:20:00',2.09),('5819','2013-11-10','09:25:00',2.31),('5819','2013-11-10','09:30:00',2.05),('5819','2013-11-10','09:35:00',2.05),('5819','2013-11-10','09:40:00',2.15),('5819','2013-11-10','09:45:00',2.36),('5819','2013-11-10','09:50:00',2.44),('5819','2013-11-10','09:55:00',2.53),('5819','2013-11-10','10:00:00',2.45),('5819','2013-11-10','10:05:00',2.72),('5819','2013-11-10','10:10:00',2.79),('5819','2013-11-10','10:15:00',2.76),('5819','2013-11-10','10:20:00',2.54),('5819','2013-11-10','10:25:00',2.85),('5819','2013-11-10','10:30:00',3.09),('5819','2013-11-10','10:35:00',2.91),('5819','2013-11-10','10:40:00',2.35),('5819','2013-11-10','10:45:00',2.25),('5819','2013-11-10','10:50:00',2.45),('5819','2013-11-10','10:55:00',2.51),('5819','2013-11-10','11:00:00',2.31),('5819','2013-11-10','11:05:00',1.81),('5819','2013-11-10','11:10:00',1.32),('5819','2013-11-10','11:25:00',1.31),('5819','2013-11-10','11:40:00',1.3),('5819','2013-11-10','11:45:00',1.88),('5819','2013-11-10','11:50:00',1.51),('5819','2013-11-10','11:55:00',1.14),('5819','2013-11-10','12:00:00',1.17),('5819','2013-11-10','12:05:00',1.34),('5819','2013-11-10','12:10:00',1.66),('5819','2013-11-10','12:15:00',2.73),('5819','2013-11-10','12:20:00',2.81),('5819','2013-11-10','12:25:00',2.61),('5819','2013-11-10','12:30:00',1.98),('5819','2013-11-10','12:35:00',1.63),('5819','2013-11-10','12:40:00',2.78),('5819','2013-11-10','12:45:00',2.97),('5819','2013-11-10','12:50:00',2.97),('5819','2013-11-10','12:55:00',1.47),('5819','2013-11-10','13:00:00',1.03),('5819','2013-11-10','13:50:00',1.8),('5819','2013-11-10','13:55:00',1.97),('5819','2013-11-09','09:40:00',2.71),('5819','2013-11-09','09:45:00',1.82),('5819','2013-11-09','09:50:00',2.6),('5819','2013-11-09','09:55:00',2.89),('5819','2013-11-09','10:00:00',2.72),('5819','2013-11-09','10:05:00',2.52),('5819','2013-11-09','10:10:00',2.42),('5819','2013-11-09','10:15:00',2.28),('5819','2013-11-09','10:20:00',2.52),('5819','2013-11-09','10:25:00',2.75),('5819','2013-11-09','10:30:00',1.2),('5819','2013-11-09','10:35:00',1.27),('5819','2013-11-09','10:40:00',1.29),('5819','2013-11-09','10:45:00',1.39),('5819','2013-11-09','10:50:00',1.29),('5819','2013-11-09','10:55:00',1.97),('5819','2013-11-09','11:00:00',2.32),('5819','2013-11-09','11:05:00',3.3),('5819','2013-11-09','11:10:00',2.87),('5819','2013-11-09','11:15:00',3.69),('5819','2013-11-09','11:20:00',2.73),('5819','2013-11-09','11:25:00',1.33),('5819','2013-11-09','11:30:00',2.71),('5819','2013-11-09','11:35:00',2.76),('5819','2013-11-09','11:40:00',2.3),('5819','2013-11-09','11:45:00',2.05),('5819','2013-11-09','11:50:00',1.49),('5819','2013-11-09','11:55:00',2.02),('5819','2013-11-09','12:00:00',2.28),('5819','2013-11-09','12:05:00',2.68),('5819','2013-11-09','12:10:00',1.95),('5819','2013-11-09','12:15:00',1.98),('5819','2013-11-09','12:20:00',1.11),('5819','2013-11-09','12:25:00',1.5),('5819','2013-11-09','12:30:00',2.14),('5819','2013-11-09','12:35:00',2.71),('5819','2013-11-09','12:40:00',1.76),('5819','2013-11-09','12:45:00',1.5),('5819','2013-11-09','12:50:00',2.45),('5819','2013-11-09','12:55:00',2.29),('5819','2013-11-09','13:00:00',2.99),('5819','2013-11-09','13:05:00',2.68),('5819','2013-11-09','13:10:00',2.77),('5819','2013-11-09','13:15:00',2.76),('5819','2013-11-09','13:20:00',1.85),('5819','2013-11-09','13:25:00',1.95),('5819','2013-11-09','13:30:00',2.46),('5819','2013-11-09','13:35:00',2.34),('5819','2013-11-09','13:40:00',2.08),('5819','2013-11-09','13:45:00',2.09),('5819','2013-11-09','13:50:00',2.04),('5819','2013-11-09','13:55:00',2.01),('5819','2013-11-09','14:00:00',1.82),('5819','2013-11-09','14:05:00',1.68),('5819','2013-11-09','14:10:00',1.24),('5819','2013-11-09','14:15:00',1.05),('5819','2013-11-09','14:20:00',1.89),('5819','2013-11-09','14:25:00',1.51),('5819','2013-11-09','14:40:00',1.35),('5819','2013-11-09','14:50:00',1.2),('5819','2013-11-08','09:10:00',1.38),('5819','2013-11-08','09:15:00',1.18),('5819','2013-11-08','09:20:00',2.03),('5819','2013-11-08','09:25:00',2.11),('5819','2013-11-08','09:30:00',2.21),('5819','2013-11-08','09:35:00',2.39),('5819','2013-11-08','09:40:00',1.8),('5819','2013-11-08','09:45:00',1.07),('5819','2013-11-08','09:50:00',2.07),('5819','2013-11-08','09:55:00',1.19),('5819','2013-11-08','10:00:00',1.35),('5819','2013-11-08','10:05:00',1.87),('5819','2013-11-08','10:10:00',2.7),('5819','2013-11-08','10:45:00',1.02),('5819','2013-11-08','10:50:00',2.32),('5819','2013-11-08','10:55:00',2.2),('5819','2013-11-08','11:00:00',1.23),('5819','2013-11-08','11:05:00',1.21),('5819','2013-11-08','11:25:00',2.71),('5819','2013-11-08','11:30:00',3.35),('5819','2013-11-08','11:35:00',3.26),('5819','2013-11-08','11:40:00',3.14),('5819','2013-11-08','11:45:00',3.1),('5819','2013-11-08','11:50:00',3.11),('5819','2013-11-08','11:55:00',2.89),('5819','2013-11-08','12:00:00',1.54),('5819','2013-11-08','12:05:00',2.8),('5819','2013-11-08','12:10:00',2.72),('5819','2013-11-08','12:15:00',2.36),('5819','2013-11-08','12:40:00',2.31),('5819','2013-11-08','12:45:00',1.73),('5819','2013-11-08','12:50:00',2.39),('5819','2013-11-08','12:55:00',2.8),('5819','2013-11-08','13:00:00',2.72),('5819','2013-11-08','13:05:00',2.56),('5819','2013-11-08','13:10:00',2.54),('5819','2013-11-08','13:15:00',2.6),('5819','2013-11-08','13:20:00',1.79),('5819','2013-11-08','13:25:00',2.57),('5819','2013-11-08','13:30:00',1.63),('5819','2013-11-08','13:35:00',2.11),('5819','2013-11-08','13:40:00',2.22),('5819','2013-11-08','13:45:00',2.1),('5819','2013-11-08','13:50:00',2.03),('5819','2013-11-08','13:55:00',1.99),('5819','2013-11-08','14:00:00',1.94),('5819','2013-11-08','14:05:00',1.83),('5819','2013-11-08','14:10:00',1.77),('5819','2013-11-08','14:15:00',1.61),('5819','2013-11-08','14:25:00',1.28),('5819','2013-11-08','14:35:00',1.43),('5819','2013-11-08','14:40:00',1.31),('5819','2013-11-08','14:45:00',1.34),('5819','2013-11-08','14:50:00',1.28),('5819','2013-11-08','14:55:00',1.03),('5819','2013-11-08','15:05:00',1.01),('5819','2013-11-08','15:10:00',1.01),('5819','2014-04-18','08:05:00',1.87),('5819','2014-04-18','08:10:00',1.58),('5819','2014-04-18','08:35:00',1.06),('5819','2014-04-18','08:40:00',1.58),('5819','2014-04-18','08:45:00',1.43),('5819','2014-04-18','08:50:00',1.07),('5819','2014-04-18','09:25:00',2.07),('5819','2014-04-18','09:30:00',3.18),('5819','2014-04-18','09:35:00',1.65),('5819','2014-04-18','09:40:00',1.22),('5819','2014-04-18','09:45:00',1.82),('5819','2014-04-18','09:50:00',2.95),('5819','2014-04-18','09:55:00',2.81),('5819','2014-04-18','10:00:00',2.5),('5819','2014-04-18','10:05:00',1.6),('5819','2014-04-18','10:10:00',1.46),('5819','2014-04-18','10:15:00',1.67),('5819','2014-04-18','10:20:00',1.37),('5819','2014-04-18','10:25:00',1.43),('5819','2014-04-18','10:30:00',1.18),('5819','2014-04-18','10:35:00',1.07),('5819','2014-04-18','10:40:00',1.34),('5819','2014-04-18','10:45:00',2.6),('5819','2014-04-18','10:50:00',2.93),('5819','2014-04-18','10:55:00',2.84),('5819','2014-04-18','11:00:00',1.7),('5819','2014-04-18','11:05:00',1.53),('5819','2014-04-18','11:10:00',2.17),('5819','2014-04-18','11:15:00',2.53),('5819','2014-04-18','11:20:00',1.65),('5819','2014-04-18','11:25:00',1.25),('5819','2014-04-18','11:30:00',1.58),('5819','2014-04-18','11:35:00',1.48),('5819','2014-04-18','11:40:00',1.56),('5819','2014-04-18','11:45:00',1.48),('5819','2014-04-18','11:50:00',1.77),('5819','2014-04-18','11:55:00',1.67),('5819','2014-04-18','12:00:00',1.67),('5819','2014-04-18','12:05:00',2.74),('5819','2014-04-18','12:10:00',3.13),('5819','2014-04-18','12:15:00',2.88),('5819','2014-04-18','12:20:00',3.7),('5819','2014-04-18','12:25:00',2.83),('5819','2014-04-18','12:30:00',4.23),('5819','2014-04-18','12:35:00',3.97),('5819','2014-04-18','12:40:00',4.08),('5819','2014-04-18','12:45:00',3.46),('5819','2014-04-18','12:50:00',3.42),('5819','2014-04-18','12:55:00',2.47),('5819','2014-04-18','13:00:00',4.28),('5819','2014-04-18','13:05:00',3.01),('5819','2014-04-18','13:10:00',2.49),('5819','2014-04-18','13:15:00',2.33),('5819','2014-04-18','13:20:00',2.08),('5819','2014-04-18','13:25:00',1.51),('5819','2014-04-18','13:30:00',1.34),('5819','2014-04-18','13:35:00',1.33),('5819','2014-04-18','13:40:00',1.13),('5819','2014-04-18','13:50:00',1.3),('5819','2014-04-18','13:55:00',2.01),('5819','2014-04-18','14:00:00',1.78),('5819','2014-04-18','14:05:00',1.44),('5819','2014-04-18','14:10:00',1.29),('5819','2014-04-18','14:15:00',1.16),('5819','2014-04-18','14:20:00',1.43),('5819','2014-04-18','14:25:00',1.83),('5819','2014-04-18','14:30:00',2.03),('5819','2014-04-18','14:35:00',2.28),('5819','2014-04-18','14:40:00',2.13),('5819','2014-04-18','14:45:00',2.56),('5819','2014-04-18','14:50:00',2.93),('5819','2014-04-18','14:55:00',1.98),('5819','2014-04-18','15:00:00',3.64),('5819','2014-04-18','15:05:00',2.14),('5819','2014-04-18','15:10:00',2.01),('5819','2014-04-18','15:15:00',2.21),('5819','2014-04-18','15:20:00',1.87),('5819','2014-04-18','15:25:00',1.95),('5819','2014-04-18','15:30:00',2.47),('5819','2014-04-18','15:35:00',3.2),('5819','2014-04-18','15:40:00',1.57),('5819','2014-04-18','15:45:00',2.04),('5819','2014-04-18','15:50:00',2.41),('5819','2014-04-18','15:55:00',2.16),('5819','2014-04-18','16:00:00',1.94),('5819','2014-04-18','16:05:00',1.54),('5819','2014-04-18','16:10:00',1.25),('5819','2014-04-18','16:15:00',1.1),('5819','2014-04-18','16:20:00',1.17),('5819','2014-04-18','16:25:00',1.65),('5819','2014-04-18','16:30:00',1.85),('5819','2014-04-18','16:35:00',2.06),('5819','2014-04-18','16:40:00',2.24),('5819','2014-04-18','16:45:00',2.13),('5819','2014-04-18','16:50:00',2.05),('5819','2014-04-18','16:55:00',1.44),('5819','2014-04-18','17:00:00',1.71),('5819','2014-04-18','17:05:00',1.98),('5819','2014-04-18','17:10:00',1.42),('5819','2014-04-18','17:15:00',1.54),('5819','2014-04-18','17:20:00',1.39),('5819','2014-04-18','17:25:00',1.38),('5819','2014-04-18','17:30:00',1.13),('5819','2014-04-18','17:35:00',1.08),('5819','2014-04-18','17:40:00',1.07),('5819','2013-11-07','07:50:00',1.08),('5819','2013-11-07','07:55:00',1.16),('5819','2013-11-07','08:00:00',1.25),('5819','2013-11-07','08:05:00',1.33),('5819','2013-11-07','08:10:00',1.41),('5819','2013-11-07','08:15:00',1.47),('5819','2013-11-07','08:20:00',1.54),('5819','2013-11-07','08:25:00',1.61),('5819','2013-11-07','08:30:00',1.67),('5819','2013-11-07','08:35:00',1.74),('5819','2013-11-07','08:40:00',1.8),('5819','2013-11-07','08:45:00',1.86),('5819','2013-11-07','08:50:00',1.92),('5819','2013-11-07','08:55:00',1.98),('5819','2013-11-07','09:00:00',2.03),('5819','2013-11-07','09:05:00',2.09),('5819','2013-11-07','09:10:00',2.13),('5819','2013-11-07','09:15:00',2.17),('5819','2013-11-07','09:20:00',2.22),('5819','2013-11-07','09:25:00',2.27),('5819','2013-11-07','09:30:00',2.32),('5819','2013-11-07','09:35:00',2.35),('5819','2013-11-07','09:40:00',2.39),('5819','2013-11-07','09:45:00',2.43),('5819','2013-11-07','09:50:00',2.45),('5819','2013-11-07','09:55:00',2.48),('5819','2013-11-07','10:00:00',2.48),('5819','2013-11-07','10:05:00',2.49),('5819','2013-11-07','10:10:00',2.53),('5819','2013-11-07','10:15:00',2.55),('5819','2013-11-07','10:20:00',2.57),('5819','2013-11-07','10:25:00',2.58),('5819','2013-11-07','10:30:00',2.6),('5819','2013-11-07','10:35:00',2.62),('5819','2013-11-07','10:40:00',2.6),('5819','2013-11-07','10:45:00',2.6),('5819','2013-11-07','10:50:00',2.61),('5819','2013-11-07','10:55:00',2.6),('5819','2013-11-07','11:00:00',2.65),('5819','2013-11-07','11:05:00',2.62),('5819','2013-11-07','11:10:00',2.63),('5819','2013-11-07','11:15:00',2.63),('5819','2013-11-07','11:20:00',2.62),('5819','2013-11-07','11:25:00',2.61),('5819','2013-11-07','11:30:00',2.5),('5819','2013-11-07','11:35:00',2.45),('5819','2013-11-07','11:40:00',2.57),('5819','2013-11-07','11:45:00',2.59),('5819','2013-11-07','11:50:00',2.54),('5819','2013-11-07','11:55:00',2.5),('5819','2013-11-07','12:00:00',2.5),('5819','2013-11-07','12:05:00',2.49),('5819','2013-11-07','12:10:00',2.4),('5819','2013-11-07','12:15:00',2.42),('5819','2013-11-07','12:20:00',2.43),('5819','2013-11-07','12:25:00',2.41),('5819','2013-11-07','12:30:00',2.34),('5819','2013-11-07','12:35:00',2.36),('5819','2013-11-07','12:40:00',2.31),('5819','2013-11-07','12:45:00',2.27),('5819','2013-11-07','12:50:00',2.23),('5819','2013-11-07','12:55:00',2.31),('5819','2013-11-07','13:00:00',2.36),('5819','2013-11-07','13:05:00',2.46),('5819','2013-11-07','13:10:00',1.83),('5819','2013-11-07','13:15:00',1.24),('5819','2013-11-07','13:20:00',1.51),('5819','2013-11-07','13:40:00',2.13),('5819','2013-11-07','13:45:00',1.31),('5819','2013-11-07','13:50:00',1.4),('5819','2013-11-07','13:55:00',2.11),('5819','2013-11-07','14:00:00',1.16),('5819','2013-11-07','14:05:00',1.23),('5819','2013-11-07','14:10:00',1.34),('5819','2013-11-07','14:15:00',1.03),('5819','2013-11-07','14:20:00',1.04),('5819','2013-11-07','14:25:00',1.55),('5819','2013-11-07','14:35:00',1.38),('5819','2013-11-07','14:40:00',1.48),('5819','2013-11-07','14:45:00',1.33),('5819','2013-11-07','14:50:00',1.25),('5819','2013-11-07','14:55:00',1.19),('5819','2013-11-07','15:00:00',1.12),('5819','2013-11-07','15:05:00',1.06),('5819','2013-11-06','08:05:00',1.03),('5819','2013-11-06','08:10:00',1.47),('5819','2013-11-06','08:15:00',1.66),('5819','2013-11-06','08:20:00',1.49),('5819','2013-11-06','08:35:00',1.85),('5819','2013-11-06','08:40:00',1.87),('5819','2013-11-06','08:45:00',1.95),('5819','2013-11-06','08:50:00',2.09),('5819','2013-11-06','08:55:00',1.94),('5819','2013-11-06','09:00:00',1.37),('5819','2013-11-06','09:05:00',1.5),('5819','2013-11-06','09:10:00',1.31),('5819','2013-11-06','09:15:00',1.82),('5819','2013-11-06','09:20:00',2.19),('5819','2013-11-06','09:25:00',2.23),('5819','2013-11-06','09:30:00',2.4),('5819','2013-11-06','09:35:00',2.43),('5819','2013-11-06','09:40:00',2.46),('5819','2013-11-06','09:45:00',2.48),('5819','2013-11-06','09:50:00',2.51),('5819','2013-11-06','09:55:00',2.54),('5819','2013-11-06','10:00:00',2.59),('5819','2013-11-06','10:05:00',2.61),('5819','2013-11-06','10:10:00',2.63),('5819','2013-11-06','10:15:00',2.65),('5819','2013-11-06','10:20:00',2.69),('5819','2013-11-06','10:25:00',2.73),('5819','2013-11-06','10:30:00',2.75),('5819','2013-11-06','10:35:00',2.77),('5819','2013-11-06','10:40:00',2.78),('5819','2013-11-06','10:45:00',2.79),('5819','2013-11-06','10:50:00',2.8),('5819','2013-11-06','10:55:00',2.79),('5819','2013-11-06','11:00:00',2.8),('5819','2013-11-06','11:05:00',2.81),('5819','2013-11-06','11:10:00',2.79),('5819','2013-11-06','11:15:00',2.8),('5819','2013-11-06','11:20:00',2.8),('5819','2013-11-06','11:25:00',2.82),('5819','2013-11-06','11:30:00',2.8),('5819','2013-11-06','11:35:00',2.78),('5819','2013-11-06','11:40:00',2.79),('5819','2013-11-06','11:45:00',2.79),('5819','2013-11-06','11:50:00',2.79),('5819','2013-11-06','11:55:00',2.77),('5819','2013-11-06','12:00:00',2.75),('5819','2013-11-06','12:05:00',2.76),('5819','2013-11-06','12:10:00',2.73),('5819','2013-11-06','12:15:00',2.7),('5819','2013-11-06','12:20:00',2.69),('5819','2013-11-06','12:25:00',2.67),('5819','2013-11-06','12:30:00',2.64),('5819','2013-11-06','12:35:00',2.61),('5819','2013-11-06','12:40:00',2.58),('5819','2013-11-06','12:45:00',2.54),('5819','2013-11-06','12:50:00',2.52),('5819','2013-11-06','12:55:00',2.49),('5819','2013-11-06','13:00:00',2.44),('5819','2013-11-06','13:05:00',2.41),('5819','2013-11-06','13:10:00',2.36),('5819','2013-11-06','13:15:00',2.31),('5819','2013-11-06','13:20:00',2.28),('5819','2013-11-06','13:25:00',2.25),('5819','2013-11-06','13:30:00',2.2),('5819','2013-11-06','13:35:00',2.14),('5819','2013-11-06','13:40:00',2.09),('5819','2013-11-06','13:45:00',2.03),('5819','2013-11-06','13:50:00',1.99),('5819','2013-11-06','13:55:00',1.94),('5819','2013-11-06','14:00:00',1.89),('5819','2013-11-06','14:05:00',1.83),('5819','2013-11-06','14:10:00',1.78),('5819','2013-11-06','14:15:00',1.72),('5819','2013-11-06','14:20:00',1.66),('5819','2013-11-06','14:25:00',1.59),('5819','2013-11-06','14:30:00',1.53),('5819','2013-11-06','14:35:00',1.47),('5819','2013-11-06','14:40:00',1.41),('5819','2013-11-06','14:45:00',1.34),('5819','2013-11-06','14:50:00',1.26),('5819','2013-11-06','14:55:00',1.2),('5819','2013-11-06','15:00:00',1.14),('5819','2013-11-06','15:05:00',1.07),('5819','2013-11-06','15:10:00',1),('5819','2013-11-05','08:25:00',1.33),('5819','2013-11-05','08:30:00',1.67),('5819','2013-11-05','08:35:00',1.91),('5819','2013-11-05','08:40:00',1.96),('5819','2013-11-05','08:45:00',1.19),('5819','2013-11-05','10:20:00',1.46),('5819','2013-11-05','10:25:00',2.05),('5819','2013-11-05','10:30:00',1.74),('5819','2013-11-05','10:35:00',1.94),('5819','2013-11-05','10:40:00',1.91),('5819','2013-11-05','10:45:00',1.89),('5819','2013-11-05','10:50:00',1.6),('5819','2013-11-05','10:55:00',1.39),('5819','2013-11-05','11:00:00',1.12),('5819','2013-11-05','11:40:00',1.31),('5819','2013-11-05','11:45:00',1.38),('5819','2013-11-05','11:50:00',1.26),('5819','2013-11-05','11:55:00',1.08),('5819','2013-11-05','12:10:00',1.12),('5819','2013-11-05','12:15:00',1.22),('5819','2013-11-05','12:20:00',1.54),('5819','2013-11-05','12:25:00',1.65),('5819','2013-11-05','12:30:00',1.14),('5819','2013-11-05','13:35:00',1.85),('5819','2013-11-05','13:40:00',2.13),('5819','2013-11-05','13:45:00',2.03),('5819','2013-11-05','13:50:00',1.31),('5819','2013-11-05','13:55:00',1.26),('5819','2013-11-05','14:00:00',2.01),('5819','2013-11-05','14:05:00',2.04),('5819','2013-11-05','14:10:00',2.31),('5819','2013-11-05','14:15:00',1.76),('5819','2013-11-05','14:20:00',1.2),('5819','2013-11-05','14:25:00',1),('5819','2013-11-05','14:30:00',1.18),('5819','2013-11-05','14:35:00',1.34),('5819','2013-11-04','07:55:00',1.09),('5819','2013-11-04','08:00:00',1.2),('5819','2013-11-04','08:05:00',1.27),('5819','2013-11-04','08:10:00',1.32),('5819','2013-11-04','08:15:00',1.41),('5819','2013-11-04','08:20:00',1.55),('5819','2013-11-04','08:25:00',1.45),('5819','2013-11-04','08:30:00',1.53),('5819','2013-11-04','08:35:00',1.23),('5819','2013-11-04','08:40:00',1.07),('5819','2013-11-04','09:10:00',2.1),('5819','2013-11-04','09:15:00',2.45),('5819','2013-11-04','09:20:00',2.59),('5819','2013-11-04','09:25:00',2.92),('5819','2013-11-04','09:30:00',1.82),('5819','2013-11-04','10:05:00',2.32),('5819','2013-11-04','10:10:00',2.76),('5819','2013-11-04','10:15:00',2.78),('5819','2013-11-04','10:20:00',2.81),('5819','2013-11-04','10:25:00',3.08),('5819','2013-11-04','10:30:00',2.99),('5819','2013-11-04','10:35:00',2.15),('5819','2013-11-04','10:40:00',3.12),('5819','2013-11-04','10:45:00',2.04),('5819','2013-11-04','10:50:00',1.65),('5819','2013-11-04','10:55:00',1.29),('5819','2013-11-04','11:00:00',1.89),('5819','2013-11-04','11:05:00',3.6),('5819','2013-11-04','11:10:00',1.81),('5819','2013-11-04','11:15:00',2.92),('5819','2013-11-04','11:20:00',1.94),('5819','2013-11-04','11:25:00',1.2),('5819','2013-11-04','11:30:00',2.15),('5819','2013-11-04','11:35:00',2.77),('5819','2013-11-04','11:40:00',1.96),('5819','2013-11-04','11:45:00',2.22),('5819','2013-11-04','11:50:00',3.57),('5819','2013-11-04','11:55:00',3.23),('5819','2013-11-04','12:00:00',2.73),('5819','2013-11-04','12:05:00',2.75),('5819','2013-11-04','12:10:00',2.75),('5819','2013-11-04','12:15:00',2.33),('5819','2013-11-04','12:20:00',2.89),('5819','2013-11-04','12:25:00',2.87),('5819','2013-11-04','12:30:00',2.81),('5819','2013-11-04','12:35:00',2.85),('5819','2013-11-04','12:40:00',2.43),('5819','2013-11-04','12:45:00',2.42),('5819','2013-11-04','12:50:00',2.34),('5819','2013-11-04','12:55:00',2.6),('5819','2013-11-04','13:00:00',2.56),('5819','2013-11-04','13:05:00',2.54),('5819','2013-11-04','13:10:00',2.43),('5819','2013-11-04','13:15:00',2.19),('5819','2013-11-04','13:20:00',2.14),('5819','2013-11-04','13:25:00',2.39),('5819','2013-11-04','13:30:00',2.35),('5819','2013-11-04','13:35:00',2.31),('5819','2013-11-04','13:40:00',2.25),('5819','2013-11-04','13:45:00',1.97),('5819','2013-11-04','13:50:00',2.23),('5819','2013-11-04','13:55:00',2.01),('5819','2013-11-04','14:00:00',1.66),('5819','2013-11-04','14:05:00',1.99),('5819','2013-11-04','14:10:00',1.69),('5819','2013-11-04','14:15:00',1.88),('5819','2013-11-04','14:20:00',2),('5819','2013-11-04','14:25:00',1.26),('5819','2013-11-04','14:30:00',1.73),('5819','2013-11-04','14:35:00',1.6),('5819','2013-11-04','14:40:00',1.65),('5819','2013-11-04','14:45:00',1.31),('5819','2013-11-04','14:50:00',1.38),('5819','2013-11-04','14:55:00',1.06),('5819','2013-11-04','15:00:00',1.33),('5819','2013-11-03','07:40:00',1.04),('5819','2013-11-03','07:45:00',1.17),('5819','2013-11-03','07:50:00',1.14),('5819','2013-11-03','07:55:00',1),('5819','2013-11-03','08:00:00',1.03),('5819','2013-11-03','08:20:00',1.13),('5819','2013-11-03','08:25:00',1.06),('5819','2013-11-03','08:35:00',1.19),('5819','2013-11-03','08:40:00',1.47),('5819','2013-11-03','08:50:00',1.05),('5819','2013-11-03','08:55:00',1.35),('5819','2013-11-03','09:40:00',2.39),('5819','2013-11-03','09:45:00',1.97),('5819','2013-11-03','10:10:00',2.03),('5819','2013-11-03','10:20:00',1.99),('5819','2013-11-03','10:25:00',2.41),('5819','2013-11-03','10:30:00',2.62),('5819','2013-11-03','10:35:00',2.25),('5819','2013-11-03','11:20:00',1.41),('5819','2013-11-03','11:25:00',2.17),('5819','2013-11-03','11:30:00',1.64),('5819','2013-11-03','11:35:00',2.61),('5819','2013-11-03','11:40:00',2.95),('5819','2013-11-03','11:45:00',3.14),('5819','2013-11-03','11:50:00',3.22),('5819','2013-11-03','11:55:00',3.14),('5819','2013-11-03','12:00:00',1.62),('5819','2013-11-03','12:05:00',2.69),('5819','2013-11-03','12:10:00',2.84),('5819','2013-11-03','12:15:00',1.1),('5819','2013-11-03','12:20:00',1.53),('5819','2013-11-03','12:25:00',1.14),('5819','2013-11-03','12:30:00',1.23),('5819','2013-11-03','12:35:00',1.19),('5819','2013-11-03','12:40:00',1.21),('5819','2013-11-03','12:45:00',1.1),('5819','2013-11-03','13:40:00',1.2),('5819','2013-11-03','13:45:00',1.77),('5819','2013-11-03','13:50:00',1.36),('5819','2013-11-03','14:00:00',1.05),('5819','2013-11-03','14:05:00',2.19),('5819','2013-11-03','14:10:00',1.79),('5819','2013-11-03','14:15:00',1.72),('5819','2013-11-03','14:20:00',1.56),('5819','2013-11-03','14:25:00',1.91),('5819','2013-11-03','14:30:00',1.18),('5819','2013-11-03','14:35:00',1.05),('5819','2013-11-03','14:40:00',1.62),('5819','2013-11-03','14:45:00',1.41),('5819','2013-11-03','14:50:00',1.03),('5819','2013-11-02','08:00:00',1.11),('5819','2013-11-02','08:05:00',1.18),('5819','2013-11-02','08:10:00',1.25),('5819','2013-11-02','08:15:00',1.37),('5819','2013-11-02','08:20:00',1.45),('5819','2013-11-02','08:25:00',1.5),('5819','2013-11-02','08:30:00',1.59),('5819','2013-11-02','08:35:00',1.67),('5819','2013-11-02','08:40:00',1.75),('5819','2013-11-02','08:45:00',1.81),('5819','2013-11-02','08:50:00',1.85),('5819','2013-11-02','08:55:00',1.92),('5819','2013-11-02','09:00:00',1.99),('5819','2013-11-02','09:05:00',2.11),('5819','2013-11-02','09:10:00',2.24),('5819','2013-11-02','09:15:00',1.1),('5819','2013-11-02','09:20:00',1.81),('5819','2013-11-02','09:25:00',2.39),('5819','2013-11-02','09:30:00',2.3),('5819','2013-11-02','09:35:00',2.34),('5819','2013-11-02','09:40:00',2.28),('5819','2013-11-02','09:45:00',1.81),('5819','2013-11-02','09:50:00',2.55),('5819','2013-11-02','09:55:00',2.61),('5819','2013-11-02','10:00:00',2.79),('5819','2013-11-02','10:05:00',3.11),('5819','2013-11-02','10:10:00',1.73),('5819','2013-11-02','10:15:00',1.11),('5819','2013-11-02','11:05:00',1.24),('5819','2013-11-02','11:10:00',1.16),('5819','2013-11-02','11:50:00',1.01),('5819','2013-11-02','11:55:00',1.46),('5819','2013-11-02','12:00:00',3.15),('5819','2013-11-02','12:05:00',3.39),('5819','2013-11-02','12:10:00',3),('5819','2013-11-02','12:15:00',3.42),('5819','2013-11-02','12:20:00',3.15),('5819','2013-11-02','12:25:00',3.19),('5819','2013-11-02','12:30:00',3.41),('5819','2013-11-02','12:35:00',3.31),('5819','2013-11-02','12:40:00',2.77),('5819','2013-11-02','12:45:00',2.32),('5819','2013-11-02','12:50:00',2.38),('5819','2013-11-02','12:55:00',3.01),('5819','2013-11-02','13:00:00',2.62),('5819','2013-11-02','13:05:00',2.86),('5819','2013-11-02','13:10:00',3.01),('5819','2013-11-02','13:15:00',1.98),('5819','2013-11-02','13:20:00',1.06),('5819','2013-11-02','13:30:00',1.73),('5819','2013-11-02','13:35:00',1.67),('5819','2013-11-02','13:40:00',2.6),('5819','2013-11-02','13:45:00',2.31),('5819','2013-11-02','13:50:00',2.8),('5819','2013-11-02','13:55:00',2.67),('5819','2013-11-02','14:00:00',2.48),('5819','2013-11-02','14:05:00',2.17),('5819','2013-11-02','14:10:00',1.96),('5819','2013-11-02','14:15:00',1.84),('5819','2013-11-02','14:20:00',1.74),('5819','2013-11-02','14:25:00',1.65),('5819','2013-11-02','14:30:00',1.59),('5819','2013-11-02','14:35:00',1.52),('5819','2013-11-02','14:40:00',1.46),('5819','2013-11-02','14:45:00',1.38),('5819','2013-11-02','14:50:00',1.32),('5819','2013-11-02','14:55:00',1.27),('5819','2013-11-02','15:00:00',1.17),('5819','2013-11-02','15:05:00',1.03),('5819','2013-11-02','15:10:00',1.11),('5819','2013-11-01','08:00:00',1.04),('5819','2013-11-01','08:15:00',1.04),('5819','2013-11-01','08:20:00',1.23),('5819','2013-11-01','08:25:00',1.29),('5819','2013-11-01','08:30:00',1.51),('5819','2013-11-01','08:35:00',1.61),('5819','2013-11-01','08:40:00',1.74),('5819','2013-11-01','08:45:00',1.79),('5819','2013-11-01','08:50:00',1.7),('5819','2013-11-01','08:55:00',1.79),('5819','2013-11-01','09:00:00',1.86),('5819','2013-11-01','09:05:00',2.05),('5819','2013-11-01','09:10:00',2.11),('5819','2013-11-01','09:15:00',2.13),('5819','2013-11-01','09:20:00',2.2),('5819','2013-11-01','09:25:00',2.25),('5819','2013-11-01','09:30:00',2.28),('5819','2013-11-01','09:35:00',2.32),('5819','2013-11-01','09:40:00',2.37),('5819','2013-11-01','09:45:00',2.43),('5819','2013-11-01','09:50:00',2.48),('5819','2013-11-01','09:55:00',2.51),('5819','2013-11-01','10:00:00',2.55),('5819','2013-11-01','10:05:00',2.58),('5819','2013-11-01','10:10:00',2.61),('5819','2013-11-01','10:15:00',2.63),('5819','2013-11-01','10:20:00',2.66),('5819','2013-11-01','10:25:00',2.69),('5819','2013-11-01','10:30:00',2.66),('5819','2013-11-01','10:35:00',2.64),('5819','2013-11-01','10:40:00',2.7),('5819','2013-11-01','10:45:00',2.64),('5819','2013-11-01','10:50:00',2.65),('5819','2013-11-01','10:55:00',2.59),('5819','2013-11-01','11:00:00',2.68),('5819','2013-11-01','11:05:00',2.57),('5819','2013-11-01','11:10:00',2.23),('5819','2013-11-01','11:15:00',2.23),('5819','2013-11-01','11:20:00',2.67),('5819','2013-11-01','11:25:00',2.86),('5819','2013-11-01','11:30:00',2.86),('5819','2013-11-01','11:35:00',2.78),('5819','2013-11-01','11:40:00',2.61),('5819','2013-11-01','11:45:00',2.39),('5819','2013-11-01','11:50:00',2.74),('5819','2013-11-01','11:55:00',2.82),('5819','2013-11-01','12:00:00',2.82),('5819','2013-11-01','12:05:00',2.75),('5819','2013-11-01','12:10:00',2.57),('5819','2013-11-01','12:15:00',2.53),('5819','2013-11-01','12:20:00',2.05),('5819','2013-11-01','12:30:00',1.71),('5819','2013-11-01','12:35:00',2.25),('5819','2013-11-01','13:20:00',1.13),('5819','2013-11-01','13:25:00',1),('5819','2013-11-01','13:30:00',1.13),('5819','2013-11-01','13:35:00',1.09),('5819','2013-11-01','13:40:00',1.01),('5819','2013-11-01','13:45:00',1.05),('5819','2013-10-31','08:20:00',1.07),('5819','2013-10-31','08:25:00',1.01),('5819','2013-10-31','08:30:00',1.43),('5819','2013-10-31','08:35:00',1.57),('5819','2013-10-31','08:40:00',1.84),('5819','2013-10-31','08:45:00',1.83),('5819','2013-10-31','08:50:00',1.69),('5819','2013-10-31','08:55:00',1.2),('5819','2013-10-31','09:00:00',1.88),('5819','2013-10-31','09:05:00',1.75),('5819','2013-10-31','09:15:00',1.13),('5819','2013-10-31','09:20:00',1.26),('5819','2013-10-31','09:35:00',1.97),('5819','2013-10-31','09:40:00',1.81),('5819','2013-10-31','09:45:00',1.87),('5819','2013-10-31','09:50:00',2.01),('5819','2013-10-31','09:55:00',1.96),('5819','2013-10-31','10:00:00',1.94),('5819','2013-10-31','10:05:00',1.69),('5819','2013-10-31','10:10:00',1.49),('5819','2013-10-31','10:15:00',1.43),('5819','2013-10-31','10:20:00',1.63),('5819','2013-10-31','10:25:00',1.78),('5819','2013-10-31','10:30:00',1.69),('5819','2013-10-31','10:35:00',1.74),('5819','2013-10-31','10:40:00',1.82),('5819','2013-10-31','10:45:00',1.75),('5819','2013-10-31','10:50:00',1.78),('5819','2013-10-31','10:55:00',2.04),('5819','2013-10-31','11:00:00',2.52),('5819','2013-10-31','11:05:00',2.74),('5819','2013-10-31','11:10:00',2.65),('5819','2013-10-31','11:15:00',1.98),('5819','2013-10-31','11:20:00',2.62),('5819','2013-10-31','11:25:00',2.36),('5819','2013-10-31','11:30:00',2.44),('5819','2013-10-31','11:35:00',2.36),('5819','2013-10-31','11:40:00',2.5),('5819','2013-10-31','11:45:00',2.68),('5819','2013-10-31','11:50:00',2.68),('5819','2013-10-31','11:55:00',2.7),('5819','2013-10-31','12:00:00',2.63),('5819','2013-10-31','12:05:00',2.56),('5819','2013-10-31','12:10:00',2.5),('5819','2013-10-31','12:15:00',2.56),('5819','2013-10-31','12:20:00',2.5),('5819','2013-10-31','12:25:00',2.52),('5819','2013-10-31','12:30:00',2.46),('5819','2013-10-31','12:35:00',2.39),('5819','2013-10-31','12:40:00',2.45),('5819','2013-10-31','12:45:00',2.49),('5819','2013-10-31','12:50:00',2.5),('5819','2013-10-31','12:55:00',2.53),('5819','2013-10-31','13:00:00',2.48),('5819','2013-10-31','13:05:00',2.41),('5819','2013-10-31','13:10:00',2.36),('5819','2013-10-31','13:15:00',2.31),('5819','2013-10-31','13:20:00',2.28),('5819','2013-10-31','13:25:00',2.21),('5819','2013-10-31','13:30:00',2.13),('5819','2013-10-31','13:35:00',2.07),('5819','2013-10-31','13:40:00',1.89),('5819','2013-10-31','13:45:00',1.87),('5819','2013-10-31','13:50:00',1.6),('5819','2013-10-31','13:55:00',1.31),('5819','2013-10-31','14:00:00',1.84),('5819','2013-10-31','14:05:00',1.78),('5819','2013-10-31','14:10:00',1.65),('5819','2013-10-31','14:15:00',1.59),('5819','2013-10-31','14:20:00',1.37),('5819','2013-10-31','14:25:00',1.51),('5819','2013-10-31','14:30:00',1.2),('5819','2013-10-31','14:35:00',1.05),('5819','2013-10-31','14:50:00',1.02),('5819','2013-10-30','08:00:00',1.02),('5819','2013-10-30','08:05:00',1.09),('5819','2013-10-30','08:10:00',1.17),('5819','2013-10-30','08:15:00',1.24),('5819','2013-10-30','08:20:00',1.3),('5819','2013-10-30','08:25:00',1.37),('5819','2013-10-30','08:30:00',1.43),('5819','2013-10-30','08:35:00',1.53),('5819','2013-10-30','08:40:00',1.62),('5819','2013-10-30','08:45:00',1.71),('5819','2013-10-30','08:50:00',1.73),('5819','2013-10-30','08:55:00',1.71),('5819','2013-10-30','09:00:00',1.81),('5819','2013-10-30','09:05:00',1.92),('5819','2013-10-30','09:10:00',2.04),('5819','2013-10-30','09:15:00',2.09),('5819','2013-10-30','09:20:00',2.11),('5819','2013-10-30','09:25:00',2.18),('5819','2013-10-30','09:30:00',2.24),('5819','2013-10-30','09:35:00',2.3),('5819','2013-10-30','09:40:00',2.29),('5819','2013-10-30','09:45:00',2.35),('5819','2013-10-30','09:50:00',2.3),('5819','2013-10-30','09:55:00',2.35),('5819','2013-10-30','10:00:00',2.19),('5819','2013-10-30','10:05:00',2.27),('5819','2013-10-30','10:10:00',2.31),('5819','2013-10-30','10:15:00',2.49),('5819','2013-10-30','10:20:00',2.49),('5819','2013-10-30','10:25:00',2.36),('5819','2013-10-30','10:30:00',2.24),('5819','2013-10-30','10:35:00',2.33),('5819','2013-10-30','10:40:00',2.4),('5819','2013-10-30','10:45:00',2.33),('5819','2013-10-30','10:50:00',2.31),('5819','2013-10-30','10:55:00',1.14),('5819','2013-10-30','11:00:00',1.81),('5819','2013-10-30','11:05:00',2.19),('5819','2013-10-30','11:10:00',2.72),('5819','2013-10-30','11:15:00',2.72),('5819','2013-10-30','11:20:00',2.39),('5819','2013-10-30','11:25:00',1.41),('5819','2013-10-30','11:30:00',1.03),('5819','2013-10-30','11:35:00',1.09),('5819','2013-10-30','11:40:00',1.05),('5819','2013-10-30','11:50:00',2.14),('5819','2013-10-30','11:55:00',1.38),('5819','2013-10-30','12:10:00',1.04),('5819','2013-10-30','12:20:00',1),('5819','2013-10-30','12:25:00',1.18),('5819','2013-10-30','12:30:00',2.19),('5819','2013-10-30','12:35:00',1.08),('5819','2013-10-30','12:40:00',1.07),('5819','2013-10-30','12:45:00',1.63),('5819','2013-10-30','12:50:00',1.32),('5819','2013-10-30','12:55:00',2.08),('5819','2013-10-30','13:00:00',2.02),('5819','2013-10-30','13:05:00',1.28),('5819','2013-10-30','13:15:00',1.01),('5819','2013-10-30','13:20:00',1),('5819','2013-10-30','13:30:00',1.43),('5819','2013-10-30','13:45:00',1.6),('5819','2013-10-30','13:50:00',1.55),('5819','2013-10-30','14:00:00',1.03),('5819','2013-10-30','14:05:00',1.79),('5819','2013-10-30','14:10:00',2),('5819','2013-10-30','14:15:00',1.65),('5819','2013-10-30','14:35:00',1.12),('5819','2013-10-30','14:40:00',1.43),('5819','2013-10-30','14:45:00',1.35),('5819','2013-10-30','14:50:00',1.23),('5819','2013-10-29','08:35:00',1.08),('5819','2013-10-29','08:40:00',1.37),('5819','2013-10-29','08:45:00',1.64),('5819','2013-10-29','08:50:00',1.94),('5819','2013-10-29','08:55:00',1.94),('5819','2013-10-29','09:00:00',2.01),('5819','2013-10-29','09:05:00',2.08),('5819','2013-10-29','09:10:00',2.12),('5819','2013-10-29','09:15:00',2.15),('5819','2013-10-29','09:20:00',2.24),('5819','2013-10-29','09:25:00',2.26),('5819','2013-10-29','09:30:00',2.32),('5819','2013-10-29','09:35:00',2.35),('5819','2013-10-29','09:40:00',2.38),('5819','2013-10-29','09:45:00',2.36),('5819','2013-10-29','09:50:00',1.99),('5819','2013-10-29','09:55:00',2.38),('5819','2013-10-29','10:00:00',2.57),('5819','2013-10-29','10:05:00',2.7),('5819','2013-10-29','10:10:00',2.66),('5819','2013-10-29','10:15:00',2.33),('5819','2013-10-29','10:20:00',2.27),('5819','2013-10-29','10:25:00',2.77),('5819','2013-10-29','10:30:00',2.98),('5819','2013-10-29','10:35:00',2.85),('5819','2013-10-29','10:40:00',2.87),('5819','2013-10-29','10:45:00',2.88),('5819','2013-10-29','10:50:00',2.98),('5819','2013-10-29','10:55:00',2.72),('5819','2013-10-29','11:00:00',1.65),('5819','2013-10-29','11:05:00',1.75),('5819','2013-10-29','11:10:00',1.21),('5819','2013-10-29','11:15:00',2.19),('5819','2013-10-29','11:20:00',2.84),('5819','2013-10-29','11:25:00',2.74),('5819','2013-10-29','11:30:00',2.91),('5819','2013-10-29','11:35:00',2.9),('5819','2013-10-29','11:40:00',2.85),('5819','2013-10-29','11:45:00',2.69),('5819','2013-10-29','11:50:00',2.67),('5819','2013-10-29','11:55:00',2.63),('5819','2013-10-29','12:00:00',2.54),('5819','2013-10-29','12:05:00',2.67),('5819','2013-10-29','12:10:00',2.61),('5819','2013-10-29','12:15:00',2.6),('5819','2013-10-29','12:20:00',2.59),('5819','2013-10-29','12:25:00',2.59),('5819','2013-10-29','12:30:00',2.54),('5819','2013-10-29','12:35:00',2.45),('5819','2013-10-29','12:40:00',2.49),('5819','2013-10-29','12:45:00',2.52),('5819','2013-10-29','12:50:00',2.49),('5819','2013-10-29','12:55:00',2.43),('5819','2013-10-29','13:00:00',2.32),('5819','2013-10-29','13:05:00',2.25),('5819','2013-10-29','13:10:00',2.28),('5819','2013-10-29','13:15:00',2.25),('5819','2013-10-29','13:20:00',2.19),('5819','2013-10-29','13:25:00',2.12),('5819','2013-10-29','13:30:00',2.1),('5819','2013-10-29','13:35:00',2.05),('5819','2013-10-29','13:40:00',2.03),('5819','2013-10-29','13:45:00',2.01),('5819','2013-10-29','13:50:00',1.95),('5819','2013-10-29','13:55:00',1.86),('5819','2013-10-29','14:00:00',1.8),('5819','2013-10-29','14:05:00',1.74),('5819','2013-10-29','14:10:00',1.76),('5819','2013-10-29','14:15:00',1.7),('5819','2013-10-29','14:20:00',1.67),('5819','2013-10-29','14:25:00',1.57),('5819','2013-10-29','14:30:00',1.48),('5819','2013-10-29','14:35:00',1.41),('5819','2013-10-29','14:40:00',1.35),('5819','2013-10-29','14:45:00',1.3),('5819','2013-10-29','14:50:00',1.25),('5819','2013-10-29','14:55:00',1.17),('5819','2013-10-29','15:00:00',1.1),('5819','2013-10-29','15:05:00',1.02),('5819','2014-04-17','07:55:00',1.06),('5819','2014-04-17','08:00:00',1.42),('5819','2014-04-17','08:05:00',1.55),('5819','2014-04-17','08:10:00',1.65),('5819','2014-04-17','08:15:00',1.73),('5819','2014-04-17','08:20:00',1.74),('5819','2014-04-17','08:25:00',1.9),('5819','2014-04-17','08:30:00',2),('5819','2014-04-17','08:35:00',2.08),('5819','2014-04-17','08:40:00',2.16),('5819','2014-04-17','08:45:00',2.24),('5819','2014-04-17','08:50:00',2.35),('5819','2014-04-17','08:55:00',2.08),('5819','2014-04-17','09:00:00',2.06),('5819','2014-04-17','09:05:00',2.35),('5819','2014-04-17','09:10:00',2.59),('5819','2014-04-17','09:15:00',2.58),('5819','2014-04-17','09:20:00',2.77),('5819','2014-04-17','09:25:00',2.87),('5819','2014-04-17','09:30:00',2.94),('5819','2014-04-17','09:35:00',3.01),('5819','2014-04-17','09:40:00',3.09),('5819','2014-04-17','09:45:00',3.17),('5819','2014-04-17','09:50:00',3.23),('5819','2014-04-17','09:55:00',3.32),('5819','2014-04-17','10:00:00',3.44),('5819','2014-04-17','10:05:00',3.67),('5819','2014-04-17','10:10:00',3.41),('5819','2014-04-17','10:15:00',2.95),('5819','2014-04-17','10:20:00',3.48),('5819','2014-04-17','10:25:00',3.93),('5819','2014-04-17','10:30:00',4.08),('5819','2014-04-17','10:35:00',4.2),('5819','2014-04-17','10:40:00',3.96),('5819','2014-04-17','10:45:00',3.19),('5819','2014-04-17','10:50:00',2.43),('5819','2014-04-17','10:55:00',2.46),('5819','2014-04-17','11:00:00',2.51),('5819','2014-04-17','11:05:00',3.68),('5819','2014-04-17','11:10:00',3.13),('5819','2014-04-17','11:15:00',2.99),('5819','2014-04-17','11:20:00',3.14),('5819','2014-04-17','11:25:00',3.44),('5819','2014-04-17','11:30:00',2.35),('5819','2014-04-17','11:35:00',2.79),('5819','2014-04-17','11:40:00',2.73),('5819','2014-04-17','11:45:00',3.08),('5819','2014-04-17','11:50:00',2.35),('5819','2014-04-17','11:55:00',1.9),('5819','2014-04-17','12:00:00',2.07),('5819','2014-04-17','12:05:00',2.7),('5819','2014-04-17','12:10:00',2.72),('5819','2014-04-17','12:15:00',2.34),('5819','2014-04-17','12:20:00',2.27),('5819','2014-04-17','12:25:00',2.52),('5819','2014-04-17','12:30:00',2.91),('5819','2014-04-17','12:35:00',3.72),('5819','2014-04-17','12:40:00',4.12),('5819','2014-04-17','12:45:00',3.96),('5819','2014-04-17','12:50:00',4.05),('5819','2014-04-17','12:55:00',4.12),('5819','2014-04-17','13:00:00',3.6),('5819','2014-04-17','13:05:00',2.32),('5819','2014-04-17','13:10:00',1.53),('5819','2014-04-17','13:15:00',1.56),('5819','2014-04-17','13:20:00',3.9),('5819','2014-04-17','13:25:00',4.57),('5819','2014-04-17','13:30:00',3.2),('5819','2014-04-17','13:55:00',1.1),('5819','2014-04-17','14:00:00',1.03),('5819','2014-04-17','14:05:00',1.04),('5819','2014-04-17','14:10:00',2.32),('5819','2014-04-17','14:15:00',1.09),('5819','2014-04-17','14:20:00',1.28),('5819','2014-04-17','14:25:00',1.36),('5819','2014-04-17','14:30:00',1.39),('5819','2014-04-17','14:35:00',1.67),('5819','2014-04-17','14:40:00',3.11),('5819','2014-04-17','14:45:00',1.13),('5819','2014-04-17','15:25:00',1.06),('5819','2014-04-17','15:30:00',1.57),('5819','2014-04-17','15:35:00',1.86),('5819','2014-04-17','15:40:00',1.4),('5819','2014-04-17','15:45:00',1.06),('5819','2014-04-17','15:50:00',1.04),('5819','2014-04-17','15:55:00',1.21),('5819','2014-04-17','16:00:00',1.06),('5819','2014-04-17','16:25:00',1.06),('5819','2014-04-17','16:30:00',1.1),('5819','2014-04-17','16:35:00',1.01),('5819','2014-04-17','16:40:00',1.12),('5819','2014-04-17','16:45:00',1.29),('5819','2014-04-17','16:50:00',1.29),('5819','2014-04-17','16:55:00',1.03),('5819','2013-10-28','08:50:00',1.27),('5819','2013-10-28','08:55:00',1.87),('5819','2013-10-28','09:00:00',2.08),('5819','2013-10-28','09:05:00',2.28),('5819','2013-10-28','09:10:00',2.38),('5819','2013-10-28','09:15:00',1.89),('5819','2013-10-28','09:20:00',1.46),('5819','2013-10-28','09:25:00',2.39),('5819','2013-10-28','09:30:00',2.58),('5819','2013-10-28','09:35:00',2.08),('5819','2013-10-28','09:40:00',1.45),('5819','2013-10-28','09:45:00',1.4),('5819','2013-10-28','09:50:00',2.17),('5819','2013-10-28','09:55:00',1.7),('5819','2013-10-28','10:50:00',2.89),('5819','2013-10-28','10:55:00',2.86),('5819','2013-10-28','11:00:00',2.86),('5819','2013-10-28','11:05:00',2.84),('5819','2013-10-28','11:10:00',2.85),('5819','2013-10-28','11:15:00',2.88),('5819','2013-10-28','11:20:00',2.87),('5819','2013-10-28','11:25:00',2.88),('5819','2013-10-28','11:30:00',2.84),('5819','2013-10-28','11:35:00',2.85),('5819','2013-10-28','11:40:00',2.76),('5819','2013-10-28','11:45:00',2.78),('5819','2013-10-28','11:50:00',2.8),('5819','2013-10-28','11:55:00',2.79),('5819','2013-10-28','12:00:00',2.51),('5819','2013-10-28','12:05:00',2.73),('5819','2013-10-28','12:10:00',2.12),('5819','2013-10-28','12:15:00',2.88),('5819','2013-10-28','12:20:00',2.95),('5819','2013-10-28','12:25:00',2.94),('5819','2013-10-28','12:30:00',2.53),('5819','2013-10-28','12:35:00',3),('5819','2013-10-28','12:40:00',2.95),('5819','2013-10-28','12:45:00',2.85),('5819','2013-10-28','12:50:00',2.87),('5819','2013-10-28','12:55:00',2.75),('5819','2013-10-28','13:00:00',2.58),('5819','2013-10-28','13:05:00',2.51),('5819','2013-10-28','13:10:00',2.52),('5819','2013-10-28','13:15:00',2.44),('5819','2013-10-28','13:20:00',2.38),('5819','2013-10-28','13:25:00',2.37),('5819','2013-10-28','13:30:00',2.3),('5819','2013-10-28','13:35:00',2.26),('5819','2013-10-28','13:40:00',2.16),('5819','2013-10-28','13:45:00',1.73),('5819','2013-10-28','13:50:00',2.12),('5819','2013-10-28','13:55:00',2.08),('5819','2013-10-28','14:00:00',2.08),('5819','2013-10-28','14:05:00',1.54),('5819','2013-10-28','14:10:00',2.01),('5819','2013-10-28','14:15:00',1.97),('5819','2013-10-28','14:20:00',1.9),('5819','2013-10-28','14:25:00',1.96),('5819','2013-10-28','14:30:00',1.76),('5819','2013-10-28','14:35:00',1.62),('5819','2013-10-28','14:40:00',1.34),('5819','2013-10-28','14:45:00',1.46),('5819','2013-10-28','14:50:00',1.43),('5819','2013-10-28','14:55:00',1.31),('5819','2013-10-28','15:00:00',1.24),('5819','2013-10-28','15:05:00',1.21),('5819','2013-10-28','15:10:00',1.13),('5819','2013-10-28','15:15:00',1.03),('5819','2013-10-27','10:05:00',1.03),('5819','2013-10-27','10:10:00',1.06),('5819','2013-10-27','10:15:00',1.1),('5819','2013-10-27','10:20:00',1.16),('5819','2013-10-27','10:25:00',1.18),('5819','2013-10-27','10:30:00',1.17),('5819','2013-10-27','10:35:00',1.17),('5819','2013-10-27','10:40:00',1.16),('5819','2013-10-27','10:45:00',1.23),('5819','2013-10-27','10:50:00',1.35),('5819','2013-10-27','10:55:00',1.22),('5819','2013-10-27','11:00:00',1.17),('5819','2013-10-27','11:05:00',1.05),('5819','2013-10-27','11:35:00',1.14),('5819','2013-10-27','11:40:00',2.4),('5819','2013-10-27','11:45:00',2.65),('5819','2013-10-27','11:50:00',2.12),('5819','2013-10-27','11:55:00',1.19),('5819','2013-10-27','12:00:00',1.12),('5819','2013-10-27','12:05:00',1.12),('5819','2013-10-27','12:10:00',1.19),('5819','2013-10-27','12:15:00',1.23),('5819','2013-10-27','12:20:00',2.19),('5819','2013-10-27','12:25:00',2.72),('5819','2013-10-27','12:30:00',2.47),('5819','2013-10-27','12:35:00',2.54),('5819','2013-10-27','12:40:00',2.13),('5819','2013-10-27','12:45:00',1.42),('5819','2013-10-27','12:50:00',1.54),('5819','2013-10-27','12:55:00',1.29),('5819','2013-10-27','13:00:00',2.06),('5819','2013-10-27','13:10:00',1.93),('5819','2013-10-27','13:15:00',1.29),('5819','2013-10-27','13:25:00',1.42),('5819','2013-10-27','13:30:00',2.11),('5819','2013-10-27','13:35:00',1.68),('5819','2013-10-27','13:40:00',1.98),('5819','2013-10-27','14:05:00',1.1),('5819','2013-10-27','14:10:00',1.01),('5819','2013-10-27','14:20:00',1.01),('5819','2013-10-27','14:30:00',1.06),('5819','2013-10-27','14:35:00',1.56),('5819','2013-10-27','14:40:00',1.6),('5819','2013-10-27','14:45:00',1.37),('5819','2013-10-27','14:50:00',1.29),('5819','2013-10-27','14:55:00',1.39),('5819','2013-10-27','15:00:00',1.31),('5819','2013-10-27','15:15:00',1.05),('5819','2013-10-26','08:45:00',1.01),('5819','2013-10-26','08:50:00',1.09),('5819','2013-10-26','08:55:00',1.15),('5819','2013-10-26','09:00:00',1.22),('5819','2013-10-26','09:05:00',1.3),('5819','2013-10-26','09:10:00',1.38),('5819','2013-10-26','09:15:00',1.47),('5819','2013-10-26','09:20:00',1.54),('5819','2013-10-26','09:25:00',1.61),('5819','2013-10-26','09:30:00',1.67),('5819','2013-10-26','09:35:00',1.74),('5819','2013-10-26','09:40:00',1.81),('5819','2013-10-26','09:45:00',1.88),('5819','2013-10-26','09:50:00',1.95),('5819','2013-10-26','09:55:00',2.01),('5819','2013-10-26','10:00:00',2.06),('5819','2013-10-26','10:05:00',2.13),('5819','2013-10-26','10:10:00',2.18),('5819','2013-10-26','10:15:00',2.23),('5819','2013-10-26','10:20:00',2.27),('5819','2013-10-26','10:25:00',2.31),('5819','2013-10-26','10:30:00',2.35),('5819','2013-10-26','10:35:00',2.38),('5819','2013-10-26','10:40:00',2.42),('5819','2013-10-26','10:45:00',2.45),('5819','2013-10-26','10:50:00',2.5),('5819','2013-10-26','10:55:00',2.54),('5819','2013-10-26','11:00:00',2.58),('5819','2013-10-26','11:05:00',2.62),('5819','2013-10-26','11:10:00',2.63),('5819','2013-10-26','11:15:00',2.65),('5819','2013-10-26','11:20:00',2.67),('5819','2013-10-26','11:25:00',2.69),('5819','2013-10-26','11:30:00',2.7),('5819','2013-10-26','11:35:00',2.73),('5819','2013-10-26','11:40:00',2.74),('5819','2013-10-26','11:45:00',2.75),('5819','2013-10-26','11:50:00',2.77),('5819','2013-10-26','11:55:00',2.74),('5819','2013-10-26','12:00:00',2.78),('5819','2013-10-26','12:05:00',2.77),('5819','2013-10-26','12:10:00',2.77),('5819','2013-10-26','12:15:00',2.74),('5819','2013-10-26','12:20:00',2.79),('5819','2013-10-26','12:25:00',2.73),('5819','2013-10-26','12:30:00',2.77),('5819','2013-10-26','12:35:00',2.8),('5819','2013-10-26','12:40:00',2.75),('5819','2013-10-26','12:45:00',2.71),('5819','2013-10-26','12:50:00',2.73),('5819','2013-10-26','12:55:00',2.69),('5819','2013-10-26','13:00:00',2.72),('5819','2013-10-26','13:05:00',2.69),('5819','2013-10-26','13:10:00',2.65),('5819','2013-10-26','13:15:00',2.46),('5819','2013-10-26','13:20:00',2.37),('5819','2013-10-26','13:25:00',2.5),('5819','2013-10-26','13:30:00',2.42),('5819','2013-10-26','13:35:00',2.49),('5819','2013-10-26','13:40:00',2.62),('5819','2013-10-26','13:45:00',2.46),('5819','2013-10-26','13:50:00',2.21),('5819','2013-10-26','13:55:00',2.39),('5819','2013-10-26','14:00:00',2.33),('5819','2013-10-26','14:05:00',2.18),('5819','2013-10-26','14:10:00',2.13),('5819','2013-10-26','14:15:00',2.26),('5819','2013-10-26','14:20:00',2.09),('5819','2013-10-26','14:25:00',1.53),('5819','2013-10-26','14:35:00',1.32),('5819','2013-10-26','14:40:00',1.99),('5819','2013-10-26','14:45:00',1.98),('5819','2013-10-26','14:50:00',1.94),('5819','2013-10-26','14:55:00',1.84),('5819','2013-10-26','15:00:00',1.78),('5819','2013-10-26','15:05:00',1.63),('5819','2013-10-26','15:10:00',1.68),('5819','2013-10-26','15:15:00',1.5),('5819','2013-10-26','15:20:00',1.51),('5819','2013-10-26','15:25:00',1.5),('5819','2013-10-26','15:30:00',1.47),('5819','2013-10-26','15:35:00',1.44),('5819','2013-10-26','15:40:00',1.44),('5819','2013-10-26','15:45:00',1.26),('5819','2013-10-26','15:50:00',1.3),('5819','2013-10-26','15:55:00',1.18),('5819','2013-10-26','16:00:00',1.05),('5819','2013-10-26','16:10:00',1.02),('5819','2013-10-25','08:45:00',1.02),('5819','2013-10-25','08:50:00',1.09),('5819','2013-10-25','08:55:00',1.17),('5819','2013-10-25','09:00:00',1.26),('5819','2013-10-25','09:05:00',1.34),('5819','2013-10-25','09:10:00',1.42),('5819','2013-10-25','09:15:00',1.5),('5819','2013-10-25','09:20:00',1.58),('5819','2013-10-25','09:25:00',1.65),('5819','2013-10-25','09:30:00',1.72),('5819','2013-10-25','09:35:00',1.78),('5819','2013-10-25','09:40:00',1.85),('5819','2013-10-25','09:45:00',1.9),('5819','2013-10-25','09:50:00',1.97),('5819','2013-10-25','09:55:00',2.03),('5819','2013-10-25','10:00:00',2.09),('5819','2013-10-25','10:05:00',2.15),('5819','2013-10-25','10:10:00',2.2),('5819','2013-10-25','10:15:00',2.24),('5819','2013-10-25','10:20:00',2.29),('5819','2013-10-25','10:25:00',2.35),('5819','2013-10-25','10:30:00',2.4),('5819','2013-10-25','10:35:00',2.45),('5819','2013-10-25','10:40:00',2.48),('5819','2013-10-25','10:45:00',2.51),('5819','2013-10-25','10:50:00',2.56),('5819','2013-10-25','10:55:00',2.57),('5819','2013-10-25','11:00:00',2.61),('5819','2013-10-25','11:05:00',2.61),('5819','2013-10-25','11:10:00',2.66),('5819','2013-10-25','11:15:00',2.68),('5819','2013-10-25','11:20:00',2.69),('5819','2013-10-25','11:25:00',2.71),('5819','2013-10-25','11:30:00',2.72),('5819','2013-10-25','11:35:00',2.72),('5819','2013-10-25','11:40:00',2.73),('5819','2013-10-25','11:45:00',2.77),('5819','2013-10-25','11:50:00',2.79),('5819','2013-10-25','11:55:00',2.83),('5819','2013-10-25','12:00:00',2.84),('5819','2013-10-25','12:05:00',2.85),('5819','2013-10-25','12:10:00',2.85),('5819','2013-10-25','12:15:00',2.87),('5819','2013-10-25','12:20:00',2.87),('5819','2013-10-25','12:25:00',2.85),('5819','2013-10-25','12:30:00',2.86),('5819','2013-10-25','12:35:00',2.86),('5819','2013-10-25','12:40:00',2.84),('5819','2013-10-25','12:45:00',2.82),('5819','2013-10-25','12:50:00',2.79),('5819','2013-10-25','12:55:00',2.78),('5819','2013-10-25','13:00:00',2.8),('5819','2013-10-25','13:05:00',2.78),('5819','2013-10-25','13:10:00',2.76),('5819','2013-10-25','13:15:00',2.71),('5819','2013-10-25','13:20:00',2.69),('5819','2013-10-25','13:25:00',2.61),('5819','2013-10-25','13:30:00',2.59),('5819','2013-10-25','13:35:00',2.6),('5819','2013-10-25','13:40:00',2.6),('5819','2013-10-25','13:45:00',2.54),('5819','2013-10-25','13:50:00',2.53),('5819','2013-10-25','13:55:00',2.52),('5819','2013-10-25','14:00:00',2.47),('5819','2013-10-25','14:05:00',2.44),('5819','2013-10-25','14:10:00',2.42),('5819','2013-10-25','14:15:00',2.37),('5819','2013-10-25','14:20:00',2.33),('5819','2013-10-25','14:25:00',2.28),('5819','2013-10-25','14:30:00',2.23),('5819','2013-10-25','14:35:00',2.18),('5819','2013-10-25','14:40:00',2.16),('5819','2013-10-25','14:45:00',2.12),('5819','2013-10-25','14:50:00',2.08),('5819','2013-10-25','14:55:00',2.02),('5819','2013-10-25','15:00:00',1.96),('5819','2013-10-25','15:05:00',1.9),('5819','2013-10-25','15:10:00',1.83),('5819','2013-10-25','15:15:00',1.77),('5819','2013-10-25','15:20:00',1.7),('5819','2013-10-25','15:25:00',1.67),('5819','2013-10-25','15:30:00',1.57),('5819','2013-10-25','15:35:00',1.51),('5819','2013-10-25','15:40:00',1.42),('5819','2013-10-25','15:45:00',1.38),('5819','2013-10-25','15:50:00',1.3),('5819','2013-10-25','15:55:00',1.27),('5819','2013-10-25','16:00:00',1.21),('5819','2013-10-25','16:05:00',1.15),('5819','2013-10-25','16:10:00',1.08),('5819','2013-10-25','16:15:00',1.03),('5819','2013-10-24','09:15:00',1.52),('5819','2013-10-24','09:20:00',1.57),('5819','2013-10-24','09:35:00',1.02),('5819','2013-10-24','09:40:00',1.08),('5819','2013-10-24','09:45:00',1.1),('5819','2013-10-24','09:50:00',1.12),('5819','2013-10-24','09:55:00',1.07),('5819','2013-10-24','10:00:00',1.05),('5819','2013-10-24','10:05:00',1.01),('5819','2013-10-24','10:10:00',1.07),('5819','2013-10-24','10:35:00',1.11),('5819','2013-10-24','10:40:00',1.42),('5819','2013-10-24','10:45:00',2.48),('5819','2013-10-24','10:50:00',2.08),('5819','2013-10-24','10:55:00',2.5),('5819','2013-10-24','11:00:00',2.91),('5819','2013-10-24','11:05:00',3.08),('5819','2013-10-24','11:10:00',3.35),('5819','2013-10-24','11:15:00',1.63),('5819','2013-10-24','11:20:00',1.4),('5819','2013-10-24','11:25:00',2.4),('5819','2013-10-24','11:30:00',1.91),('5819','2013-10-24','11:35:00',1.14),('5819','2013-10-24','11:40:00',1.14),('5819','2013-10-24','11:45:00',1.17),('5819','2013-10-24','11:50:00',1.65),('5819','2013-10-24','11:55:00',3.04),('5819','2013-10-24','12:00:00',1.77),('5819','2013-10-24','12:05:00',1.35),('5819','2013-10-24','12:10:00',1.25),('5819','2013-10-24','12:15:00',1.23),('5819','2013-10-24','12:20:00',1.26),('5819','2013-10-24','12:25:00',1.38),('5819','2013-10-24','12:30:00',1.44),('5819','2013-10-24','12:35:00',1.56),('5819','2013-10-24','12:40:00',1.79),('5819','2013-10-24','12:45:00',1.93),('5819','2013-10-24','12:50:00',2.06),('5819','2013-10-24','12:55:00',2.08),('5819','2013-10-24','13:00:00',2.52),('5819','2013-10-24','13:05:00',3.34),('5819','2013-10-24','13:10:00',2.72),('5819','2013-10-24','13:15:00',2.16),('5819','2013-10-24','13:20:00',2.21),('5819','2013-10-24','13:25:00',2.31),('5819','2013-10-24','13:30:00',1.31),('5819','2013-10-24','13:35:00',1.21),('5819','2013-10-24','13:40:00',1.2),('5819','2013-10-24','13:45:00',1.26),('5819','2013-10-24','13:50:00',1.45),('5819','2013-10-24','13:55:00',1.73),('5819','2013-10-24','14:00:00',2.02),('5819','2013-10-24','14:05:00',1.83),('5819','2013-10-24','14:10:00',1.29),('5819','2013-10-24','14:15:00',1.27),('5819','2013-10-24','14:20:00',1.29),('5819','2013-10-24','14:25:00',1.36),('5819','2013-10-24','14:30:00',1.36),('5819','2013-10-24','14:35:00',1.63),('5819','2013-10-24','14:40:00',1.65),('5819','2013-10-24','14:45:00',1.66),('5819','2013-10-24','14:50:00',2.08),('5819','2013-10-24','15:05:00',1.01),('5819','2013-10-24','15:10:00',1.89),('5819','2013-10-24','15:15:00',1.47),('5819','2013-10-24','15:25:00',1.17),('5819','2013-10-24','15:35:00',1.86),('5819','2013-10-24','15:40:00',1.93),('5819','2013-10-24','15:45:00',1.49),('5819','2013-10-24','15:50:00',1.13),('5819','2013-10-23','10:45:00',1.27),('5819','2013-10-23','10:50:00',1.61),('5819','2013-10-23','10:55:00',1.35),('5819','2013-10-23','11:00:00',1.42),('5819','2013-10-23','11:05:00',1.27),('5819','2013-10-23','11:10:00',1.68),('5819','2013-10-23','11:15:00',2.84),('5819','2013-10-23','11:20:00',2.5),('5819','2013-10-23','11:25:00',2.76),('5819','2013-10-23','11:30:00',2.23),('5819','2013-10-23','11:35:00',2.66),('5819','2013-10-23','11:40:00',2.84),('5819','2013-10-23','11:45:00',2.77),('5819','2013-10-23','11:50:00',2.68),('5819','2013-10-23','11:55:00',2.69),('5819','2013-10-23','12:00:00',2.78),('5819','2013-10-23','12:05:00',2.75),('5819','2013-10-23','12:10:00',2.61),('5819','2013-10-23','12:15:00',2.68),('5819','2013-10-23','12:20:00',2.68),('5819','2013-10-23','12:25:00',2.73),('5819','2013-10-23','12:30:00',2.7),('5819','2013-10-23','12:35:00',2.66),('5819','2013-10-23','12:40:00',2.68),('5819','2013-10-23','12:45:00',2.44),('5819','2013-10-23','12:50:00',2.27),('5819','2013-10-23','12:55:00',1.95),('5819','2013-10-23','13:00:00',2.68),('5819','2013-10-23','13:05:00',2.62),('5819','2013-10-23','13:10:00',2.59),('5819','2013-10-23','13:15:00',2.62),('5819','2013-10-23','13:20:00',2.6),('5819','2013-10-23','13:25:00',2.61),('5819','2013-10-23','13:30:00',2.6),('5819','2013-10-23','13:35:00',2.57),('5819','2013-10-23','13:40:00',2.57),('5819','2013-10-23','13:45:00',2.56),('5819','2013-10-23','13:50:00',2.37),('5819','2013-10-23','13:55:00',1.75),('5819','2013-10-23','14:00:00',2.16),('5819','2013-10-23','14:05:00',2.23),('5819','2013-10-23','14:10:00',2.21),('5819','2013-10-23','14:15:00',2.36),('5819','2013-10-23','14:20:00',2.25),('5819','2013-10-23','14:25:00',2.14),('5819','2013-10-23','14:30:00',2.17),('5819','2013-10-23','14:35:00',2.1),('5819','2013-10-23','14:40:00',1.91),('5819','2013-10-23','14:45:00',1.91),('5819','2013-10-23','14:50:00',1.81),('5819','2013-10-23','14:55:00',1.96),('5819','2013-10-23','15:00:00',1.81),('5819','2013-10-23','15:05:00',1.89),('5819','2013-10-23','15:10:00',1.79),('5819','2013-10-23','15:15:00',1.8),('5819','2013-10-23','15:20:00',1.76),('5819','2013-10-23','15:25:00',1.75),('5819','2013-10-23','15:30:00',1.67),('5819','2013-10-23','15:35:00',1.55),('5819','2013-10-23','15:40:00',1.6),('5819','2013-10-23','15:45:00',1.52),('5819','2013-10-23','15:50:00',1.34),('5819','2013-10-22','08:50:00',1.08),('5819','2013-10-22','08:55:00',1.16),('5819','2013-10-22','09:00:00',1.23),('5819','2013-10-22','09:05:00',1.31),('5819','2013-10-22','09:10:00',1.39),('5819','2013-10-22','09:15:00',1.47),('5819','2013-10-22','09:20:00',1.55),('5819','2013-10-22','09:25:00',1.63),('5819','2013-10-22','09:30:00',1.69),('5819','2013-10-22','09:35:00',1.77),('5819','2013-10-22','09:40:00',1.83),('5819','2013-10-22','09:45:00',1.89),('5819','2013-10-22','09:50:00',1.95),('5819','2013-10-22','09:55:00',2.01),('5819','2013-10-22','10:00:00',2.05),('5819','2013-10-22','10:05:00',2.1),('5819','2013-10-22','10:10:00',2.16),('5819','2013-10-22','10:15:00',2.22),('5819','2013-10-22','10:20:00',2.27),('5819','2013-10-22','10:25:00',2.33),('5819','2013-10-22','10:30:00',2.36),('5819','2013-10-22','10:35:00',2.4),('5819','2013-10-22','10:40:00',2.43),('5819','2013-10-22','10:45:00',2.49),('5819','2013-10-22','10:50:00',2.53),('5819','2013-10-22','10:55:00',2.53),('5819','2013-10-22','11:00:00',2.55),('5819','2013-10-22','11:05:00',2.61),('5819','2013-10-22','11:10:00',2.61),('5819','2013-10-22','11:15:00',2.63),('5819','2013-10-22','11:20:00',2.7),('5819','2013-10-22','11:25:00',2.68),('5819','2013-10-22','11:30:00',2.67),('5819','2013-10-22','11:35:00',2.69),('5819','2013-10-22','11:40:00',2.69),('5819','2013-10-22','11:45:00',2.66),('5819','2013-10-22','11:50:00',2.67),('5819','2013-10-22','11:55:00',2.71),('5819','2013-10-22','12:00:00',2.73),('5819','2013-10-22','12:05:00',2.76),('5819','2013-10-22','12:10:00',2.73),('5819','2013-10-22','12:15:00',2.71),('5819','2013-10-22','12:20:00',2.75),('5819','2013-10-22','12:25:00',2.76),('5819','2013-10-22','12:30:00',2.71),('5819','2013-10-22','12:35:00',2.72),('5819','2013-10-22','12:40:00',2.74),('5819','2013-10-22','12:45:00',2.73),('5819','2013-10-22','12:50:00',2.74),('5819','2013-10-22','12:55:00',2.64),('5819','2013-10-22','13:00:00',2.49),('5819','2013-10-22','13:05:00',2.63),('5819','2013-10-22','13:10:00',2.58),('5819','2013-10-22','13:15:00',2.56),('5819','2013-10-22','13:20:00',2.58),('5819','2013-10-22','13:25:00',2.59),('5819','2013-10-22','13:30:00',2.58),('5819','2013-10-22','13:35:00',2.44),('5819','2013-10-22','13:40:00',2.53),('5819','2013-10-22','13:45:00',2.5),('5819','2013-10-22','13:50:00',2.4),('5819','2013-10-22','13:55:00',2.35),('5819','2013-10-22','14:00:00',2.27),('5819','2013-10-22','14:05:00',2.38),('5819','2013-10-22','14:10:00',2.33),('5819','2013-10-22','14:15:00',2.21),('5819','2013-10-22','14:20:00',1.54),('5819','2013-10-22','14:25:00',2.05),('5819','2013-10-22','14:30:00',1.1),('5819','2013-10-22','14:45:00',1.37),('5819','2013-10-22','14:50:00',1.82),('5819','2013-10-22','14:55:00',1.93),('5819','2013-10-22','15:00:00',1.82),('5819','2013-10-22','15:05:00',1.79),('5819','2013-10-22','15:10:00',1.8),('5819','2013-10-22','15:15:00',1.72),('5819','2013-10-22','15:20:00',1.66),('5819','2013-10-22','15:25:00',1.62),('5819','2013-10-22','15:30:00',1.55),('5819','2013-10-22','15:35:00',1.51),('5819','2013-10-22','15:40:00',1.47),('5819','2013-10-22','15:45:00',1.47),('5819','2013-10-22','15:50:00',1.39),('5819','2013-10-22','15:55:00',1.29),('5819','2013-10-22','16:00:00',1.19),('5819','2013-10-22','16:05:00',1.12),('5819','2013-10-22','16:10:00',1.08),('5819','2013-10-22','16:15:00',1.04),('5819','2013-10-21','08:45:00',1.04),('5819','2013-10-21','08:55:00',1.06),('5819','2013-10-21','09:10:00',1.25),('5819','2013-10-21','09:15:00',1.47),('5819','2013-10-21','09:20:00',1.68),('5819','2013-10-21','09:25:00',1.76),('5819','2013-10-21','09:30:00',1.67),('5819','2013-10-21','09:35:00',1.53),('5819','2013-10-21','09:40:00',1.86),('5819','2013-10-21','09:45:00',1.64),('5819','2013-10-21','09:50:00',1.71),('5819','2013-10-21','09:55:00',1.89),('5819','2013-10-21','10:00:00',1.9),('5819','2013-10-21','10:05:00',2.07),('5819','2013-10-21','10:10:00',2.26),('5819','2013-10-21','10:15:00',2.32),('5819','2013-10-21','10:20:00',2.3),('5819','2013-10-21','10:25:00',2.39),('5819','2013-10-21','10:30:00',2.37),('5819','2013-10-21','10:35:00',2.35),('5819','2013-10-21','10:40:00',2.32),('5819','2013-10-21','10:45:00',2.4),('5819','2013-10-21','10:50:00',2.49),('5819','2013-10-21','10:55:00',2.5),('5819','2013-10-21','11:00:00',2.65),('5819','2013-10-21','11:05:00',2.49),('5819','2013-10-21','11:10:00',2.18),('5819','2013-10-21','11:15:00',2.76),('5819','2013-10-21','11:20:00',2.76),('5819','2013-10-21','11:25:00',2.73),('5819','2013-10-21','11:30:00',2.78),('5819','2013-10-21','11:35:00',2.8),('5819','2013-10-21','11:40:00',2.76),('5819','2013-10-21','11:45:00',2.87),('5819','2013-10-21','11:50:00',2.86),('5819','2013-10-21','11:55:00',2.87),('5819','2013-10-21','12:00:00',2.91),('5819','2013-10-21','12:05:00',2.93),('5819','2013-10-21','12:10:00',2.93),('5819','2013-10-21','12:15:00',2.91),('5819','2013-10-21','12:20:00',2.89),('5819','2013-10-21','12:25:00',2.91),('5819','2013-10-21','12:30:00',2.79),('5819','2013-10-21','12:35:00',2.8),('5819','2013-10-21','12:40:00',2.89),('5819','2013-10-21','12:45:00',2.89),('5819','2013-10-21','12:50:00',2.86),('5819','2013-10-21','12:55:00',2.84),('5819','2013-10-21','13:00:00',2.81),('5819','2013-10-21','13:05:00',2.75),('5819','2013-10-21','13:10:00',2.61),('5819','2013-10-21','13:15:00',2.66),('5819','2013-10-21','13:20:00',2.68),('5819','2013-10-21','13:25:00',2.64),('5819','2013-10-21','13:30:00',2.72),('5819','2013-10-21','13:35:00',2.7),('5819','2013-10-21','13:40:00',2.64),('5819','2013-10-21','13:45:00',2.61),('5819','2013-10-21','13:50:00',2.58),('5819','2013-10-21','13:55:00',2.52),('5819','2013-10-21','14:00:00',2.42),('5819','2013-10-21','14:05:00',2.49),('5819','2013-10-21','14:10:00',2.46),('5819','2013-10-21','14:15:00',2.41),('5819','2013-10-21','14:20:00',2.38),('5819','2013-10-21','14:25:00',2.32),('5819','2013-10-21','14:30:00',2.27),('5819','2013-10-21','14:35:00',2.26),('5819','2013-10-21','14:40:00',2.13),('5819','2013-10-21','14:45:00',2.04),('5819','2013-10-21','14:50:00',1.99),('5819','2013-10-21','14:55:00',1.95),('5819','2013-10-21','15:00:00',1.97),('5819','2013-10-21','15:05:00',1.92),('5819','2013-10-21','15:10:00',1.86),('5819','2013-10-21','15:15:00',1.82),('5819','2013-10-21','15:20:00',1.79),('5819','2013-10-21','15:25:00',1.71),('5819','2013-10-21','15:30:00',1.59),('5819','2013-10-21','15:35:00',1.5),('5819','2013-10-21','15:40:00',1.51),('5819','2013-10-21','15:45:00',1.45),('5819','2013-10-21','15:50:00',1.37),('5819','2013-10-21','15:55:00',1.31),('5819','2013-10-21','16:00:00',1.26),('5819','2013-10-21','16:05:00',1.2),('5819','2013-10-21','16:10:00',1.15),('5819','2013-10-21','16:15:00',1.08),('5819','2013-10-21','16:20:00',1.01),('5819','2013-10-20','08:35:00',1.08),('5819','2013-10-20','08:40:00',1.13),('5819','2013-10-20','08:45:00',1.18),('5819','2013-10-20','08:50:00',1.27),('5819','2013-10-20','08:55:00',1.36),('5819','2013-10-20','09:00:00',1.41),('5819','2013-10-20','09:05:00',1.44),('5819','2013-10-20','09:10:00',1.54),('5819','2013-10-20','09:15:00',1.62),('5819','2013-10-20','09:20:00',1.71),('5819','2013-10-20','09:25:00',1.78),('5819','2013-10-20','09:30:00',1.83),('5819','2013-10-20','09:35:00',1.9),('5819','2013-10-20','09:40:00',1.97),('5819','2013-10-20','09:45:00',2.03),('5819','2013-10-20','09:50:00',2.08),('5819','2013-10-20','09:55:00',2.14),('5819','2013-10-20','10:00:00',2.22),('5819','2013-10-20','10:05:00',2.28),('5819','2013-10-20','10:10:00',2.34),('5819','2013-10-20','10:15:00',2.38),('5819','2013-10-20','10:20:00',2.42),('5819','2013-10-20','10:25:00',2.47),('5819','2013-10-20','10:30:00',2.52),('5819','2013-10-20','10:35:00',2.56),('5819','2013-10-20','10:40:00',2.6),('5819','2013-10-20','10:45:00',2.64),('5819','2013-10-20','10:50:00',2.66),('5819','2013-10-20','10:55:00',2.69),('5819','2013-10-20','11:00:00',2.72),('5819','2013-10-20','11:05:00',2.76),('5819','2013-10-20','11:10:00',2.8),('5819','2013-10-20','11:15:00',2.8),('5819','2013-10-20','11:20:00',2.83),('5819','2013-10-20','11:25:00',2.86),('5819','2013-10-20','11:30:00',2.9),('5819','2013-10-20','11:35:00',2.91),('5819','2013-10-20','11:40:00',2.94),('5819','2013-10-20','11:45:00',2.94),('5819','2013-10-20','11:50:00',2.96),('5819','2013-10-20','11:55:00',2.92),('5819','2013-10-20','12:00:00',2.95),('5819','2013-10-20','12:05:00',2.98),('5819','2013-10-20','12:10:00',3.01),('5819','2013-10-20','12:15:00',2.05),('5819','2013-10-20','12:20:00',1.41),('5819','2013-10-20','12:25:00',1.32),('5819','2013-10-20','12:30:00',2.68),('5819','2013-10-20','12:35:00',2.34),('5819','2013-10-20','12:40:00',2.66),('5819','2013-10-20','12:45:00',1.25),('5819','2013-10-20','12:50:00',1.62),('5819','2013-10-20','12:55:00',2.63),('5819','2013-10-20','13:00:00',2.57),('5819','2013-10-20','13:05:00',2.34),('5819','2013-10-20','13:10:00',3.35),('5819','2013-10-20','13:15:00',2.09),('5819','2013-10-20','13:25:00',1.47),('5819','2013-10-20','13:30:00',2.23),('5819','2013-10-20','13:35:00',2.28),('5819','2013-10-20','13:40:00',1.42),('5819','2013-10-20','13:45:00',2.28),('5819','2013-10-20','13:50:00',1.5),('5819','2013-10-20','13:55:00',1.64),('5819','2013-10-20','14:00:00',1.23),('5819','2013-10-20','14:10:00',1.48),('5819','2013-10-19','08:35:00',1.15),('5819','2013-10-19','08:40:00',1.32),('5819','2013-10-19','08:45:00',1.41),('5819','2013-10-19','08:50:00',1.54),('5819','2013-10-19','08:55:00',1.34),('5819','2013-10-19','09:00:00',1.35),('5819','2013-10-19','09:05:00',1.24),('5819','2013-10-19','09:10:00',1.77),('5819','2013-10-19','09:15:00',2.06),('5819','2013-10-19','09:20:00',2.1),('5819','2013-10-19','09:25:00',2.12),('5819','2013-10-19','09:30:00',2.15),('5819','2013-10-19','09:35:00',2.19),('5819','2013-10-19','09:40:00',2.27),('5819','2013-10-19','09:45:00',2.38),('5819','2013-10-19','09:50:00',2.45),('5819','2013-10-19','09:55:00',2.54),('5819','2013-10-19','10:00:00',2.54),('5819','2013-10-19','10:05:00',2.39),('5819','2013-10-19','10:10:00',2.57),('5819','2013-10-19','10:15:00',2.52),('5819','2013-10-19','10:20:00',2.69),('5819','2013-10-19','10:25:00',2.9),('5819','2013-10-19','10:30:00',2.93),('5819','2013-10-19','10:35:00',2.93),('5819','2013-10-19','10:40:00',2.92),('5819','2013-10-19','10:45:00',2.88),('5819','2013-10-19','10:50:00',2.94),('5819','2013-10-19','10:55:00',3.01),('5819','2013-10-19','11:00:00',3.03),('5819','2013-10-19','11:05:00',2.7),('5819','2013-10-19','11:10:00',1.78),('5819','2013-10-19','11:15:00',1.22),('5819','2013-10-19','11:20:00',2.11),('5819','2013-10-19','11:25:00',3.42),('5819','2013-10-19','11:30:00',3.26),('5819','2013-10-19','11:35:00',3.26),('5819','2013-10-19','11:40:00',3.08),('5819','2013-10-19','11:45:00',3.16),('5819','2013-10-19','11:50:00',3.11),('5819','2013-10-19','11:55:00',3.16),('5819','2013-10-19','12:00:00',3.26),('5819','2013-10-19','12:05:00',3.25),('5819','2013-10-19','12:10:00',3.19),('5819','2013-10-19','12:15:00',3.18),('5819','2013-10-19','12:20:00',3.22),('5819','2013-10-19','12:25:00',2.89),('5819','2013-10-19','12:30:00',3.11),('5819','2013-10-19','12:35:00',3.19),('5819','2013-10-19','12:40:00',3.29),('5819','2013-10-19','12:45:00',3.31),('5819','2013-10-19','12:50:00',3.38),('5819','2013-10-19','12:55:00',3.25),('5819','2013-10-19','13:00:00',3.51),('5819','2013-10-19','13:05:00',2.77),('5819','2013-10-19','13:10:00',2.85),('5819','2013-10-19','13:15:00',2.89),('5819','2013-10-19','13:20:00',2.84),('5819','2013-10-19','13:25:00',3.12),('5819','2013-10-19','13:30:00',3.16),('5819','2013-10-19','13:35:00',2.72),('5819','2013-10-19','13:40:00',2.47),('5819','2013-10-19','13:45:00',2.47),('5819','2013-10-19','13:50:00',2.55),('5819','2013-10-19','13:55:00',3.12),('5819','2013-10-19','14:00:00',2.56),('5819','2013-10-19','14:05:00',2.19),('5819','2013-10-19','14:10:00',1.69),('5819','2013-10-19','14:15:00',2.09),('5819','2013-10-19','14:20:00',1.89),('5819','2013-10-19','14:25:00',1.9),('5819','2013-10-19','14:30:00',2.16),('5819','2013-10-19','14:35:00',2.94),('5819','2013-10-19','14:40:00',2.24),('5819','2013-10-19','14:45:00',1.81),('5819','2013-10-19','14:50:00',2.57),('5819','2013-10-19','14:55:00',2.47),('5819','2013-10-19','15:00:00',2.39),('5819','2013-10-19','15:05:00',2.3),('5819','2013-10-19','15:10:00',2.25),('5819','2013-10-19','15:15:00',2.19),('5819','2013-10-19','15:20:00',2.02),('5819','2013-10-19','15:25:00',1.96),('5819','2013-10-19','15:30:00',1.85),('5819','2013-10-19','15:35:00',1.8),('5819','2013-10-19','15:40:00',1.66),('5819','2013-10-19','15:45:00',1.4),('5819','2013-10-19','15:50:00',1.45),('5819','2013-10-19','15:55:00',1.6),('5819','2013-10-19','16:00:00',1.34),('5819','2013-10-19','16:05:00',1.4),('5819','2013-10-19','16:10:00',1.32),('5819','2013-10-19','16:15:00',1.36),('5819','2013-10-19','16:20:00',1.27),('5819','2013-10-19','16:30:00',1.1),('5819','2013-10-19','16:35:00',1.12),('5819','2013-10-19','16:40:00',1.07),('5819','2014-05-04','07:35:00',1.03),('5819','2014-05-04','07:40:00',1.32),('5819','2014-05-04','07:45:00',1.33),('5819','2014-05-04','07:50:00',1.57),('5819','2014-05-04','07:55:00',1.65),('5819','2014-05-04','08:00:00',1.72),('5819','2014-05-04','08:05:00',1.83),('5819','2014-05-04','08:10:00',1.9),('5819','2014-05-04','08:15:00',2.01),('5819','2014-05-04','08:20:00',2.12),('5819','2014-05-04','08:25:00',2.2),('5819','2014-05-04','08:30:00',2.41),('5819','2014-05-04','08:35:00',2.24),('5819','2014-05-04','08:40:00',1.27),('5819','2014-05-04','08:45:00',1.15),('5819','2014-05-04','08:50:00',1.6),('5819','2014-05-04','08:55:00',1.23),('5819','2014-05-04','09:00:00',1.42),('5819','2014-05-04','09:05:00',2.41),('5819','2014-05-04','09:10:00',1.9),('5819','2014-05-04','09:15:00',2.46),('5819','2014-05-04','09:20:00',3.74),('5819','2014-05-04','09:25:00',2.89),('5819','2014-05-04','09:30:00',1.31),('5819','2014-05-04','09:35:00',1.24),('5819','2014-05-04','09:40:00',1.99),('5819','2014-05-04','09:45:00',2.52),('5819','2014-05-04','09:50:00',2.42),('5819','2014-05-04','09:55:00',2.73),('5819','2014-05-04','10:00:00',3.78),('5819','2014-05-04','10:05:00',3.71),('5819','2014-05-04','10:10:00',3.75),('5819','2014-05-04','10:15:00',2.72),('5819','2014-05-04','10:20:00',1.88),('5819','2014-05-04','10:25:00',1.81),('5819','2014-05-04','10:30:00',1.85),('5819','2014-05-04','10:35:00',1.96),('5819','2014-05-04','10:40:00',2.03),('5819','2014-05-04','10:45:00',2.9),('5819','2014-05-04','10:50:00',2.77),('5819','2014-05-04','10:55:00',2.57),('5819','2014-05-04','11:00:00',2.45),('5819','2014-05-04','11:05:00',3.6),('5819','2014-05-04','11:10:00',4.12),('5819','2014-05-04','11:15:00',4.08),('5819','2014-05-04','11:20:00',3.9),('5819','2014-05-04','11:25:00',3.44),('5819','2014-05-04','11:30:00',3.79),('5819','2014-05-04','11:35:00',3.85),('5819','2014-05-04','11:40:00',2.9),('5819','2014-05-04','11:45:00',4.18),('5819','2014-05-04','11:50:00',2.74),('5819','2014-05-04','11:55:00',3.37),('5819','2014-05-04','12:00:00',3.03),('5819','2014-05-04','12:05:00',2.7),('5819','2014-05-04','12:10:00',2.42),('5819','2014-05-04','12:15:00',1.56),('5819','2014-05-04','12:20:00',1.72),('5819','2014-05-04','12:25:00',2.96),('5819','2014-05-04','12:30:00',4.9),('5819','2014-05-04','12:35:00',4.61),('5819','2014-05-04','12:40:00',4.68),('5819','2014-05-04','12:45:00',3.23),('5819','2014-05-04','12:50:00',2.3),('5819','2014-05-04','12:55:00',2.21),('5819','2014-05-04','13:00:00',2.31),('5819','2014-05-04','13:05:00',2.2),('5819','2014-05-04','13:10:00',2.24),('5819','2014-05-04','13:15:00',1.95),('5819','2014-05-04','13:20:00',1.77),('5819','2014-05-04','13:25:00',1.47),('5819','2014-05-04','13:30:00',1.64),('5819','2014-05-04','13:35:00',1.66),('5819','2014-05-04','13:40:00',1.54),('5819','2014-05-04','13:45:00',1.35),('5819','2014-05-04','13:50:00',1.33),('5819','2014-05-04','13:55:00',1.35),('5819','2014-05-04','14:00:00',1.35),('5819','2014-05-04','14:05:00',1.38),('5819','2014-05-04','14:10:00',1.35),('5819','2014-05-04','14:15:00',1.21),('5819','2014-05-04','14:50:00',1.13),('5819','2014-05-04','14:55:00',1.58),('5819','2014-05-04','15:00:00',1.75),('5819','2014-05-04','15:05:00',2.78),('5819','2014-05-04','15:10:00',2.88),('5819','2014-05-04','15:15:00',2.49),('5819','2014-05-04','15:20:00',1.45),('5819','2014-05-04','15:25:00',1.16),('5819','2014-05-04','15:50:00',1.08),('5819','2014-05-04','15:55:00',1.06),('5819','2014-05-04','16:10:00',1.19),('5819','2014-05-04','16:15:00',1.16),('5819','2014-04-16','07:50:00',1.16),('5819','2014-04-16','07:55:00',1.31),('5819','2014-04-16','08:00:00',1.39),('5819','2014-04-16','08:05:00',1.5),('5819','2014-04-16','08:10:00',1.61),('5819','2014-04-16','08:15:00',1.71),('5819','2014-04-16','08:20:00',1.83),('5819','2014-04-16','08:25:00',1.92),('5819','2014-04-16','08:30:00',1.37),('5819','2014-04-16','08:35:00',1.17),('5819','2014-04-16','08:40:00',1.35),('5819','2014-04-16','08:45:00',2.12),('5819','2014-04-16','08:50:00',2.37),('5819','2014-04-16','08:55:00',2.43),('5819','2014-04-16','09:00:00',2.5),('5819','2014-04-16','09:05:00',2.58),('5819','2014-04-16','09:10:00',2.64),('5819','2014-04-16','09:15:00',2.69),('5819','2014-04-16','09:20:00',2.77),('5819','2014-04-16','09:25:00',2.89),('5819','2014-04-16','09:30:00',1.62),('5819','2014-04-16','09:45:00',1.27),('5819','2014-04-16','09:50:00',2.55),('5819','2014-04-16','09:55:00',3.53),('5819','2014-04-16','10:00:00',3.43),('5819','2014-04-16','10:05:00',3.46),('5819','2014-04-16','10:10:00',3.52),('5819','2014-04-16','10:15:00',3.57),('5819','2014-04-16','10:20:00',3.63),('5819','2014-04-16','10:25:00',3.66),('5819','2014-04-16','10:30:00',3.72),('5819','2014-04-16','10:35:00',3.75),('5819','2014-04-16','10:40:00',3.79),('5819','2014-04-16','10:45:00',3.84),('5819','2014-04-16','10:50:00',3.95),('5819','2014-04-16','10:55:00',3.57),('5819','2014-04-16','11:00:00',3.88),('5819','2014-04-16','11:05:00',3.11),('5819','2014-04-16','11:10:00',1.63),('5819','2014-04-16','11:15:00',2.33),('5819','2014-04-16','11:20:00',4.4),('5819','2014-04-16','11:25:00',2.95),('5819','2014-04-16','11:30:00',3.79),('5819','2014-04-16','11:35:00',2.67),('5819','2014-04-16','11:40:00',3.71),('5819','2014-04-16','11:45:00',4.07),('5819','2014-04-16','11:50:00',4.64),('5819','2014-04-16','11:55:00',4.37),('5819','2014-04-16','12:00:00',4.54),('5819','2014-04-16','12:05:00',1.75),('5819','2014-04-16','12:10:00',4.11),('5819','2014-04-16','12:15:00',4.36),('5819','2014-04-16','12:20:00',3.78),('5819','2014-04-16','12:25:00',1.34),('5819','2014-04-16','12:30:00',2.97),('5819','2014-04-16','12:35:00',4.44),('5819','2014-04-16','12:40:00',4.46),('5819','2014-04-16','12:45:00',4.35),('5819','2014-04-16','12:50:00',4.39),('5819','2014-04-16','12:55:00',3.15),('5819','2014-04-16','13:00:00',2.47),('5819','2014-04-16','13:05:00',1.26),('5819','2014-04-16','13:20:00',1.45),('5819','2014-04-16','13:25:00',1.06),('5819','2014-04-16','13:35:00',1.46),('5819','2014-04-16','13:40:00',1.95),('5819','2014-04-16','13:45:00',4.28),('5819','2014-04-16','13:50:00',4.12),('5819','2014-04-16','13:55:00',2.36),('5819','2014-04-16','14:00:00',1.65),('5819','2014-04-16','14:05:00',3),('5819','2014-04-16','14:10:00',4.44),('5819','2014-04-16','14:15:00',4.52),('5819','2014-04-16','14:20:00',3.92),('5819','2014-04-16','14:25:00',3.56),('5819','2014-04-16','14:30:00',3.43),('5819','2014-04-16','14:35:00',3.87),('5819','2014-04-16','14:40:00',3.78),('5819','2014-04-16','14:45:00',2.57),('5819','2014-04-16','14:50:00',3.01),('5819','2014-04-16','14:55:00',1.18),('5819','2014-04-16','15:00:00',1.41),('5819','2014-04-16','15:05:00',2.87),('5819','2014-04-16','15:10:00',4.25),('5819','2014-04-16','15:15:00',2.45),('5819','2014-04-16','15:25:00',1.23),('5819','2014-04-16','15:30:00',3.15),('5819','2014-04-16','15:35:00',3.46),('5819','2014-04-16','15:40:00',3.31),('5819','2014-04-16','15:45:00',3.15),('5819','2014-04-16','15:50:00',3.04),('5819','2014-04-16','15:55:00',2.93),('5819','2014-04-16','16:00:00',2.83),('5819','2014-04-16','16:05:00',2.74),('5819','2014-04-16','16:10:00',2.65),('5819','2014-04-16','16:15:00',2.59),('5819','2014-04-16','16:20:00',2.54),('5819','2014-04-16','16:25:00',2.43),('5819','2014-04-16','16:30:00',2.36),('5819','2014-04-16','16:35:00',2.29),('5819','2014-04-16','16:40:00',2.21),('5819','2014-04-16','16:45:00',2.14),('5819','2014-04-16','16:50:00',2.02),('5819','2014-04-16','16:55:00',1.92),('5819','2014-04-16','17:00:00',1.84),('5819','2014-04-16','17:05:00',1.74),('5819','2014-04-16','17:10:00',1.66),('5819','2014-04-16','17:15:00',1.6),('5819','2014-04-16','17:20:00',1.48),('5819','2014-04-16','17:25:00',1.37),('5819','2014-04-16','17:30:00',1.18),('5819','2014-04-16','17:35:00',1.07),('5819','2014-04-16','17:40:00',1.12),('5819','2014-04-16','17:45:00',1.08),('5819','2014-04-16','17:50:00',1.08),('5819','2014-04-16','17:55:00',1.07),('5819','2013-10-18','08:35:00',1.04),('5819','2013-10-18','08:40:00',1.17),('5819','2013-10-18','08:45:00',1.31),('5819','2013-10-18','08:50:00',1.33),('5819','2013-10-18','08:55:00',1.38),('5819','2013-10-18','09:00:00',1.55),('5819','2013-10-18','09:05:00',1.69),('5819','2013-10-18','09:10:00',1.81),('5819','2013-10-18','09:15:00',1.84),('5819','2013-10-18','09:20:00',1.99),('5819','2013-10-18','09:25:00',2.03),('5819','2013-10-18','09:30:00',2.13),('5819','2013-10-18','09:35:00',2.2),('5819','2013-10-18','09:40:00',2.27),('5819','2013-10-18','09:45:00',2.34),('5819','2013-10-18','09:50:00',2.39),('5819','2013-10-18','09:55:00',2.44),('5819','2013-10-18','10:00:00',2.48),('5819','2013-10-18','10:05:00',2.55),('5819','2013-10-18','10:10:00',2.58),('5819','2013-10-18','10:15:00',2.63),('5819','2013-10-18','10:20:00',2.65),('5819','2013-10-18','10:25:00',2.71),('5819','2013-10-18','10:30:00',2.76),('5819','2013-10-18','10:35:00',2.8),('5819','2013-10-18','10:40:00',2.86),('5819','2013-10-18','10:45:00',2.89),('5819','2013-10-18','10:50:00',2.91),('5819','2013-10-18','10:55:00',2.95),('5819','2013-10-18','11:00:00',2.91),('5819','2013-10-18','11:05:00',2.9),('5819','2013-10-18','11:10:00',2.83),('5819','2013-10-18','11:15:00',2.61),('5819','2013-10-18','11:20:00',2.97),('5819','2013-10-18','11:25:00',2.71),('5819','2013-10-18','11:30:00',3.07),('5819','2013-10-18','11:35:00',3.07),('5819','2013-10-18','11:40:00',3.15),('5819','2013-10-18','11:45:00',3.06),('5819','2013-10-18','11:50:00',3.1),('5819','2013-10-18','11:55:00',3.16),('5819','2013-10-18','12:00:00',3.02),('5819','2013-10-18','12:05:00',3.14),('5819','2013-10-18','12:10:00',3.12),('5819','2013-10-18','12:15:00',3.08),('5819','2013-10-18','12:20:00',3.05),('5819','2013-10-18','12:25:00',3.11),('5819','2013-10-18','12:30:00',3.13),('5819','2013-10-18','12:35:00',3.05),('5819','2013-10-18','12:40:00',3.08),('5819','2013-10-18','12:45:00',2.98),('5819','2013-10-18','12:50:00',2.95),('5819','2013-10-18','12:55:00',3.02),('5819','2013-10-18','13:00:00',3),('5819','2013-10-18','13:05:00',2.91),('5819','2013-10-18','13:10:00',2.8),('5819','2013-10-18','13:15:00',2.91),('5819','2013-10-18','13:20:00',2.9),('5819','2013-10-18','13:25:00',2.99),('5819','2013-10-18','13:30:00',2.95),('5819','2013-10-18','13:35:00',2.88),('5819','2013-10-18','13:40:00',2.88),('5819','2013-10-18','13:45:00',2.81),('5819','2013-10-18','13:50:00',2.79),('5819','2013-10-18','13:55:00',2.78),('5819','2013-10-18','14:00:00',2.54),('5819','2013-10-18','14:05:00',2.6),('5819','2013-10-18','14:10:00',2.57),('5819','2013-10-18','14:15:00',2.6),('5819','2013-10-18','14:20:00',2.57),('5819','2013-10-18','14:25:00',2.55),('5819','2013-10-18','14:30:00',2.48),('5819','2013-10-18','14:35:00',2.39),('5819','2013-10-18','14:40:00',2.37),('5819','2013-10-18','14:45:00',2.3),('5819','2013-10-18','14:50:00',2.2),('5819','2013-10-18','14:55:00',2.2),('5819','2013-10-18','15:00:00',1.97),('5819','2013-10-18','15:05:00',1.75),('5819','2013-10-18','15:10:00',1.87),('5819','2013-10-18','15:15:00',1.87),('5819','2013-10-18','15:20:00',1.95),('5819','2013-10-18','15:25:00',1.83),('5819','2013-10-18','15:30:00',1.74),('5819','2013-10-18','15:35:00',1.71),('5819','2013-10-18','15:40:00',1.62),('5819','2013-10-18','15:45:00',1.45),('5819','2013-10-18','15:50:00',1.45),('5819','2013-10-18','15:55:00',1.34),('5819','2013-10-18','16:00:00',1.36),('5819','2013-10-18','16:05:00',1.27),('5819','2013-10-18','16:10:00',1.21),('5819','2013-10-18','16:15:00',1.08),('5819','2013-10-18','16:20:00',1),('5819','2013-10-17','08:25:00',1.04),('5819','2013-10-17','08:30:00',1.12),('5819','2013-10-17','08:35:00',1.22),('5819','2013-10-17','08:40:00',1.31),('5819','2013-10-17','08:45:00',1.4),('5819','2013-10-17','08:50:00',1.49),('5819','2013-10-17','08:55:00',1.59),('5819','2013-10-17','09:00:00',1.67),('5819','2013-10-17','09:05:00',1.75),('5819','2013-10-17','09:10:00',1.83),('5819','2013-10-17','09:15:00',1.91),('5819','2013-10-17','09:20:00',1.99),('5819','2013-10-17','09:25:00',2.06),('5819','2013-10-17','09:30:00',2.12),('5819','2013-10-17','09:35:00',2.19),('5819','2013-10-17','09:40:00',2.26),('5819','2013-10-17','09:45:00',2.32),('5819','2013-10-17','09:50:00',2.38),('5819','2013-10-17','09:55:00',2.44),('5819','2013-10-17','10:00:00',2.48),('5819','2013-10-17','10:05:00',2.52),('5819','2013-10-17','10:10:00',2.59),('5819','2013-10-17','10:15:00',2.64),('5819','2013-10-17','10:20:00',2.68),('5819','2013-10-17','10:25:00',2.73),('5819','2013-10-17','10:30:00',2.79),('5819','2013-10-17','10:35:00',2.83),('5819','2013-10-17','10:40:00',2.87),('5819','2013-10-17','10:45:00',2.92),('5819','2013-10-17','10:50:00',2.95),('5819','2013-10-17','10:55:00',2.98),('5819','2013-10-17','11:00:00',3),('5819','2013-10-17','11:05:00',3.03),('5819','2013-10-17','11:10:00',3.05),('5819','2013-10-17','11:15:00',3.08),('5819','2013-10-17','11:20:00',3.09),('5819','2013-10-17','11:25:00',3.11),('5819','2013-10-17','11:30:00',3.14),('5819','2013-10-17','11:35:00',3.18),('5819','2013-10-17','11:40:00',3.19),('5819','2013-10-17','11:45:00',3.18),('5819','2013-10-17','11:50:00',3.2),('5819','2013-10-17','11:55:00',3.21),('5819','2013-10-17','12:00:00',3.2),('5819','2013-10-17','12:05:00',3.2),('5819','2013-10-17','12:10:00',3.21),('5819','2013-10-17','12:15:00',3.23),('5819','2013-10-17','12:20:00',3.22),('5819','2013-10-17','12:25:00',3.21),('5819','2013-10-17','12:30:00',3.22),('5819','2013-10-17','12:35:00',3.21),('5819','2013-10-17','12:40:00',3.2),('5819','2013-10-17','12:45:00',3.22),('5819','2013-10-17','12:50:00',3.19),('5819','2013-10-17','12:55:00',3.18),('5819','2013-10-17','13:00:00',3.15),('5819','2013-10-17','13:05:00',3.13),('5819','2013-10-17','13:10:00',3.1),('5819','2013-10-17','13:15:00',3.1),('5819','2013-10-17','13:20:00',3.1),('5819','2013-10-17','13:25:00',3.06),('5819','2013-10-17','13:30:00',3.03),('5819','2013-10-17','13:35:00',2.98),('5819','2013-10-17','13:40:00',2.96),('5819','2013-10-17','13:45:00',2.93),('5819','2013-10-17','13:50:00',2.89),('5819','2013-10-17','13:55:00',2.88),('5819','2013-10-17','14:00:00',2.85),('5819','2013-10-17','14:05:00',2.8),('5819','2013-10-17','14:10:00',2.77),('5819','2013-10-17','14:15:00',2.74),('5819','2013-10-17','14:20:00',2.68),('5819','2013-10-17','14:25:00',2.64),('5819','2013-10-17','14:30:00',2.6),('5819','2013-10-17','14:35:00',2.55),('5819','2013-10-17','14:40:00',2.51),('5819','2013-10-17','14:45:00',2.46),('5819','2013-10-17','14:50:00',2.39),('5819','2013-10-17','14:55:00',2.34),('5819','2013-10-17','15:00:00',2.28),('5819','2013-10-17','15:05:00',2.22),('5819','2013-10-17','15:10:00',2.17),('5819','2013-10-17','15:15:00',2.12),('5819','2013-10-17','15:20:00',2.06),('5819','2013-10-17','15:25:00',2),('5819','2013-10-17','15:30:00',1.94),('5819','2013-10-17','15:35:00',1.86),('5819','2013-10-17','15:40:00',1.76),('5819','2013-10-17','15:45:00',1.69),('5819','2013-10-17','15:50:00',1.62),('5819','2013-10-17','15:55:00',1.55),('5819','2013-10-17','16:00:00',1.48),('5819','2013-10-17','16:05:00',1.39),('5819','2013-10-17','16:10:00',1.34),('5819','2013-10-17','16:15:00',1.27),('5819','2013-10-17','16:20:00',1.2),('5819','2013-10-17','16:25:00',1.14),('5819','2013-10-17','16:30:00',1.07),('5819','2013-10-17','16:35:00',1),('5819','2013-10-16','09:45:00',1.19),('5819','2013-10-16','09:50:00',1.77),('5819','2013-10-16','11:15:00',1.4),('5819','2013-10-16','11:55:00',1.07),('5819','2013-10-16','12:15:00',1.52),('5819','2013-10-16','12:20:00',2.83),('5819','2013-10-16','12:25:00',1.48),('5819','2013-10-16','12:35:00',1.18),('5819','2013-10-16','12:40:00',3.4),('5819','2013-10-16','12:45:00',3.43),('5819','2013-10-16','12:50:00',3.3),('5819','2013-10-16','12:55:00',2.86),('5819','2013-10-16','13:00:00',2.36),('5819','2013-10-16','13:05:00',3.02),('5819','2013-10-16','13:10:00',3.32),('5819','2013-10-16','13:15:00',2.17),('5819','2013-10-16','13:20:00',2.1),('5819','2013-10-16','13:25:00',3.04),('5819','2013-10-16','13:30:00',2.84),('5819','2013-10-16','13:35:00',2.93),('5819','2013-10-16','13:40:00',3.09),('5819','2013-10-16','13:45:00',3),('5819','2013-10-16','13:50:00',2.93),('5819','2013-10-16','13:55:00',3.09),('5819','2013-10-16','14:00:00',2.58),('5819','2013-10-16','14:05:00',2.02),('5819','2013-10-16','14:10:00',2.62),('5819','2013-10-16','14:15:00',1.79),('5819','2013-10-16','14:20:00',2.75),('5819','2013-10-16','14:25:00',1.45),('5819','2013-10-16','14:30:00',2.18),('5819','2013-10-16','14:35:00',2.16),('5819','2013-10-16','14:40:00',2.04),('5819','2013-10-16','14:45:00',2.6),('5819','2013-10-16','14:50:00',2.5),('5819','2013-10-16','14:55:00',2.02),('5819','2013-10-16','15:00:00',2.37),('5819','2013-10-16','15:05:00',2.32),('5819','2013-10-16','15:10:00',2.31),('5819','2013-10-16','15:15:00',2.23),('5819','2013-10-16','15:20:00',2.16),('5819','2013-10-16','15:25:00',1.71),('5819','2013-10-16','15:30:00',1.08),('5819','2013-10-16','15:35:00',1.66),('5819','2013-10-16','15:40:00',2.02),('5819','2013-10-16','15:45:00',1.77),('5819','2013-10-16','15:50:00',1.67),('5819','2013-10-16','15:55:00',1.61),('5819','2013-10-16','16:00:00',1.54),('5819','2013-10-16','16:05:00',1.47),('5819','2013-10-16','16:10:00',1.37),('5819','2013-10-16','16:15:00',1.31),('5819','2013-10-16','16:20:00',1.24),('5819','2013-10-16','16:25:00',1.18),('5819','2013-10-16','16:30:00',1.09),('5819','2013-10-16','16:35:00',1.04),('5819','2013-10-16','16:40:00',1.01),('5819','2013-10-15','09:20:00',1.04),('5819','2013-10-15','09:25:00',1.17),('5819','2013-10-15','09:30:00',1.77),('5819','2013-10-15','09:35:00',1.07),('5819','2013-10-15','09:40:00',1.56),('5819','2013-10-15','09:45:00',2.05),('5819','2013-10-15','09:50:00',2.3),('5819','2013-10-15','09:55:00',2.39),('5819','2013-10-15','10:00:00',2.36),('5819','2013-10-15','10:05:00',2.51),('5819','2013-10-15','10:10:00',1.99),('5819','2013-10-15','10:15:00',1.26),('5819','2013-10-15','10:20:00',1.2),('5819','2013-10-15','10:25:00',1.29),('5819','2013-10-15','10:30:00',2.02),('5819','2013-10-15','10:35:00',1.61),('5819','2013-10-15','10:40:00',1.96),('5819','2013-10-15','10:45:00',2.22),('5819','2013-10-15','10:50:00',2.19),('5819','2013-10-15','10:55:00',1.86),('5819','2013-10-15','11:00:00',1.85),('5819','2013-10-15','11:05:00',1.91),('5819','2013-10-15','11:10:00',2.59),('5819','2013-10-15','11:15:00',2.74),('5819','2013-10-15','11:20:00',2.8),('5819','2013-10-15','11:25:00',2.64),('5819','2013-10-15','11:30:00',2.69),('5819','2013-10-15','11:35:00',2.32),('5819','2013-10-15','11:40:00',1.83),('5819','2013-10-15','11:45:00',1.45),('5819','2013-10-15','11:50:00',1.39),('5819','2013-10-15','11:55:00',1.36),('5819','2013-10-15','12:00:00',1.4),('5819','2013-10-15','12:05:00',1.4),('5819','2013-10-15','12:10:00',1.43),('5819','2013-10-15','12:15:00',1.41),('5819','2013-10-15','12:20:00',1.47),('5819','2013-10-15','12:25:00',1.37),('5819','2013-10-15','12:30:00',1.23),('5819','2013-10-15','12:35:00',1.2),('5819','2013-10-15','12:40:00',1.19),('5819','2013-10-15','12:45:00',1.27),('5819','2013-10-15','12:50:00',1.21),('5819','2013-10-15','12:55:00',1.07),('5819','2013-10-15','13:00:00',1.06),('5819','2013-10-15','13:05:00',1.37),('5819','2013-10-15','13:10:00',1.68),('5819','2013-10-15','13:15:00',1.71),('5819','2013-10-15','13:20:00',2.39),('5819','2013-10-15','13:25:00',2.81),('5819','2013-10-15','13:30:00',1.8),('5819','2013-10-15','13:35:00',1.54),('5819','2013-10-15','13:40:00',1.43),('5819','2013-10-15','13:45:00',1.47),('5819','2013-10-15','13:50:00',1.34),('5819','2013-10-15','13:55:00',1.2),('5819','2013-10-15','14:00:00',1.08),('5819','2013-10-15','14:05:00',1.06),('5819','2013-10-15','14:10:00',1.14),('5819','2013-10-15','14:15:00',1.56),('5819','2013-10-15','14:20:00',1.84),('5819','2013-10-15','14:25:00',1.97),('5819','2013-10-15','14:30:00',1.98),('5819','2013-10-15','14:35:00',1.25),('5819','2013-10-15','14:40:00',1.74),('5819','2013-10-15','14:45:00',1.92),('5819','2013-10-15','14:50:00',2.06),('5819','2013-10-15','14:55:00',1.86),('5819','2013-10-15','15:00:00',1.19),('5819','2013-10-15','15:05:00',1.18),('5819','2013-10-15','15:10:00',1.25),('5819','2013-10-15','15:15:00',1.13),('5819','2013-10-15','15:20:00',1.02),('5819','2013-10-15','16:35:00',1.04),('5819','2013-10-14','08:25:00',1.1),('5819','2013-10-14','08:30:00',1.13),('5819','2013-10-14','08:35:00',1.25),('5819','2013-10-14','08:40:00',1.09),('5819','2013-10-14','08:45:00',1.36),('5819','2013-10-14','08:50:00',1.21),('5819','2013-10-14','08:55:00',1.41),('5819','2013-10-14','09:00:00',1.28),('5819','2013-10-14','09:05:00',1.31),('5819','2013-10-14','09:10:00',1.24),('5819','2013-10-14','09:20:00',1.19),('5819','2013-10-14','09:25:00',1.87),('5819','2013-10-14','09:30:00',2.05),('5819','2013-10-14','09:35:00',2.04),('5819','2013-10-14','09:40:00',1.66),('5819','2013-10-14','09:45:00',1.54),('5819','2013-10-14','09:50:00',1.83),('5819','2013-10-14','09:55:00',2.16),('5819','2013-10-14','10:00:00',2.07),('5819','2013-10-14','10:05:00',2.29),('5819','2013-10-14','10:10:00',2.39),('5819','2013-10-14','10:15:00',2.52),('5819','2013-10-14','10:20:00',2.55),('5819','2013-10-14','10:25:00',2.58),('5819','2013-10-14','10:30:00',2.62),('5819','2013-10-14','10:35:00',2.63),('5819','2013-10-14','10:40:00',2.59),('5819','2013-10-14','10:45:00',2.65),('5819','2013-10-14','10:50:00',2.76),('5819','2013-10-14','10:55:00',2.78),('5819','2013-10-14','11:00:00',2.85),('5819','2013-10-14','11:05:00',2.81),('5819','2013-10-14','11:10:00',2.91),('5819','2013-10-14','11:15:00',2.92),('5819','2013-10-14','11:20:00',2.91),('5819','2013-10-14','11:25:00',2.97),('5819','2013-10-14','11:30:00',3.03),('5819','2013-10-14','11:35:00',2.96),('5819','2013-10-14','11:40:00',2.98),('5819','2013-10-14','11:45:00',2.92),('5819','2013-10-14','11:50:00',2.96),('5819','2013-10-14','11:55:00',2.97),('5819','2013-10-14','12:00:00',2.98),('5819','2013-10-14','12:05:00',2.98),('5819','2013-10-14','12:10:00',3.03),('5819','2013-10-14','12:15:00',3),('5819','2013-10-14','12:20:00',2.8),('5819','2013-10-14','12:25:00',2.9),('5819','2013-10-14','12:30:00',3.09),('5819','2013-10-14','12:35:00',3.05),('5819','2013-10-14','12:40:00',3.03),('5819','2013-10-14','12:45:00',3),('5819','2013-10-14','12:50:00',2.99),('5819','2013-10-14','12:55:00',2.99),('5819','2013-10-14','13:00:00',2.98),('5819','2013-10-14','13:05:00',2.96),('5819','2013-10-14','13:10:00',2.96),('5819','2013-10-14','13:15:00',2.94),('5819','2013-10-14','13:20:00',2.93),('5819','2013-10-14','13:25:00',2.9),('5819','2013-10-14','13:30:00',2.87),('5819','2013-10-14','13:35:00',2.83),('5819','2013-10-14','13:40:00',2.81),('5819','2013-10-14','13:45:00',2.79),('5819','2013-10-14','13:50:00',2.76),('5819','2013-10-14','13:55:00',2.72),('5819','2013-10-14','14:00:00',2.69),('5819','2013-10-14','14:05:00',2.66),('5819','2013-10-14','14:10:00',2.63),('5819','2013-10-14','14:15:00',2.59),('5819','2013-10-14','14:20:00',2.55),('5819','2013-10-14','14:25:00',2.51),('5819','2013-10-14','14:30:00',2.47),('5819','2013-10-14','14:35:00',2.42),('5819','2013-10-14','14:40:00',2.37),('5819','2013-10-14','14:45:00',2.33),('5819','2013-10-14','14:50:00',2.3),('5819','2013-10-14','14:55:00',2.25),('5819','2013-10-14','15:00:00',2.19),('5819','2013-10-14','15:05:00',2.12),('5819','2013-10-14','15:10:00',2.05),('5819','2013-10-14','15:15:00',1.98),('5819','2013-10-14','15:20:00',1.93),('5819','2013-10-14','15:25:00',1.86),('5819','2013-10-14','15:30:00',1.79),('5819','2013-10-14','15:35:00',1.73),('5819','2013-10-14','15:40:00',1.49),('5819','2013-10-14','15:45:00',1.36),('5819','2013-10-14','15:50:00',1.24),('5819','2013-10-14','16:00:00',1.21),('5819','2013-10-13','08:55:00',1.1),('5819','2013-10-13','09:00:00',1.25),('5819','2013-10-13','09:05:00',1.32),('5819','2013-10-13','09:10:00',1.16),('5819','2013-10-13','09:15:00',1.83),('5819','2013-10-13','09:20:00',2),('5819','2013-10-13','09:25:00',1.86),('5819','2013-10-13','09:30:00',1.27),('5819','2013-10-13','09:35:00',1.47),('5819','2013-10-13','09:40:00',1.96),('5819','2013-10-13','09:45:00',2.79),('5819','2013-10-13','09:50:00',2.7),('5819','2013-10-13','09:55:00',2.79),('5819','2013-10-13','10:00:00',2.27),('5819','2013-10-13','10:05:00',1.58),('5819','2013-10-13','10:10:00',1.95),('5819','2013-10-13','10:15:00',2.37),('5819','2013-10-13','10:20:00',1.96),('5819','2013-10-13','10:25:00',2.03),('5819','2013-10-13','10:30:00',2.66),('5819','2013-10-13','10:35:00',3.12),('5819','2013-10-13','10:40:00',3.23),('5819','2013-10-13','10:45:00',3.26),('5819','2013-10-13','10:50:00',3.01),('5819','2013-10-13','10:55:00',2.14),('5819','2013-10-13','11:00:00',2.76),('5819','2013-10-13','11:05:00',2.95),('5819','2013-10-13','11:10:00',3.09),('5819','2013-10-13','11:15:00',3.18),('5819','2013-10-13','11:20:00',3.04),('5819','2013-10-13','11:25:00',2.99),('5819','2013-10-13','11:30:00',3.04),('5819','2013-10-13','11:35:00',3.02),('5819','2013-10-13','11:40:00',3.02),('5819','2013-10-13','11:45:00',3.02),('5819','2013-10-13','11:50:00',3.04),('5819','2013-10-13','11:55:00',3.04),('5819','2013-10-13','12:00:00',3.05),('5819','2013-10-13','12:05:00',3.06),('5819','2013-10-13','12:10:00',3.06),('5819','2013-10-13','12:15:00',3.07),('5819','2013-10-13','12:20:00',3.06),('5819','2013-10-13','12:25:00',2.92),('5819','2013-10-13','12:30:00',3.06),('5819','2013-10-13','12:35:00',3.1),('5819','2013-10-13','12:40:00',3.08),('5819','2013-10-13','12:45:00',3.02),('5819','2013-10-13','12:50:00',2.99),('5819','2013-10-13','12:55:00',3),('5819','2013-10-13','13:00:00',3),('5819','2013-10-13','13:05:00',2.97),('5819','2013-10-13','13:10:00',2.98),('5819','2013-10-13','13:15:00',3.02),('5819','2013-10-13','13:20:00',3.01),('5819','2013-10-13','13:25:00',2.72),('5819','2013-10-13','13:30:00',2.17),('5819','2013-10-13','13:35:00',2.7),('5819','2013-10-13','13:40:00',1.71),('5819','2013-10-13','13:45:00',1.85),('5819','2013-10-13','13:50:00',1.96),('5819','2013-10-13','13:55:00',2.18),('5819','2013-10-13','14:00:00',2.74),('5819','2013-10-13','14:05:00',2.82),('5819','2013-10-13','14:10:00',2.76),('5819','2013-10-13','14:15:00',2.53),('5819','2013-10-13','14:20:00',2.75),('5819','2013-10-13','14:25:00',2.72),('5819','2013-10-13','14:30:00',2.57),('5819','2013-10-13','14:35:00',1.9),('5819','2013-10-13','14:40:00',2.33),('5819','2013-10-13','14:45:00',1.96),('5819','2013-10-13','14:50:00',1.52),('5819','2013-10-13','14:55:00',1.78),('5819','2013-10-13','15:00:00',2.13),('5819','2013-10-13','15:05:00',2.08),('5819','2013-10-13','15:10:00',1.49),('5819','2013-10-13','15:15:00',1.53),('5819','2013-10-13','15:20:00',1.79),('5819','2013-10-13','15:25:00',1.91),('5819','2013-10-13','15:30:00',1.47),('5819','2013-10-13','15:35:00',1.31),('5819','2013-10-13','15:40:00',1.3),('5819','2013-10-13','15:45:00',1.22),('5819','2013-10-13','15:50:00',1.17),('5819','2013-10-13','15:55:00',1.12),('5819','2013-10-13','16:00:00',1.18),('5819','2013-10-13','16:05:00',1.45),('5819','2013-10-13','16:10:00',1.29),('5819','2013-10-13','16:15:00',1.05),('5819','2013-10-13','16:20:00',1.09),('5819','2013-10-13','16:25:00',1.35),('5819','2013-10-13','16:30:00',1.34),('5819','2013-10-13','16:35:00',1.19),('5819','2013-10-12','11:25:00',1.05),('5819','2013-10-12','11:30:00',1.22),('5819','2013-10-12','11:35:00',1.64),('5819','2013-10-12','11:40:00',2.87),('5819','2013-10-12','11:45:00',1.62),('5819','2013-10-12','11:50:00',1.38),('5819','2013-10-12','11:55:00',1.23),('5819','2013-10-12','12:20:00',1.59),('5819','2013-10-12','12:25:00',3.4),('5819','2013-10-12','12:30:00',2.52),('5819','2013-10-12','12:35:00',3.01),('5819','2013-10-12','12:40:00',2.97),('5819','2013-10-12','12:45:00',2.74),('5819','2013-10-12','12:50:00',2.92),('5819','2013-10-12','12:55:00',2.45),('5819','2013-10-12','13:00:00',1.82),('5819','2013-10-12','13:05:00',1.38),('5819','2013-10-12','13:20:00',1.27),('5819','2013-10-12','13:25:00',1.3),('5819','2013-10-12','13:30:00',3.11),('5819','2013-10-12','13:35:00',1.62),('5819','2013-10-12','16:15:00',1.42),('5819','2013-10-12','16:20:00',1.2),('5819','2013-10-11','09:25:00',1.21),('5819','2013-10-11','09:35:00',1.26),('5819','2013-10-11','09:45:00',2.43),('5819','2013-10-11','09:50:00',2.46),('5819','2013-10-11','09:55:00',2.48),('5819','2013-10-11','10:00:00',2.53),('5819','2013-10-11','10:05:00',2.59),('5819','2013-10-11','10:10:00',2.65),('5819','2013-10-11','10:15:00',2.32),('5819','2013-10-11','10:20:00',2.32),('5819','2013-10-11','10:25:00',1.66),('5819','2013-10-11','10:30:00',2.37),('5819','2013-10-11','10:35:00',3.21),('5819','2013-10-11','10:40:00',1.73),('5819','2013-10-11','11:05:00',2.47),('5819','2013-10-11','11:10:00',2.78),('5819','2013-10-11','11:15:00',1.13),('5819','2013-10-11','11:20:00',1),('5819','2013-10-11','11:25:00',1.06),('5819','2013-10-11','11:35:00',1.32),('5819','2013-10-11','11:40:00',1.85),('5819','2013-10-11','11:45:00',1.7),('5819','2013-10-11','11:50:00',2.02),('5819','2013-10-11','11:55:00',1.72),('5819','2013-10-11','12:00:00',2.33),('5819','2013-10-11','12:05:00',3.98),('5819','2013-10-11','12:10:00',1.79),('5819','2013-10-11','12:15:00',1.15),('5819','2013-10-11','12:30:00',1.86),('5819','2013-10-11','13:05:00',2.4),('5819','2013-10-11','13:10:00',1.58),('5819','2013-10-11','13:15:00',1.13),('5819','2013-10-11','13:20:00',1.73),('5819','2013-10-11','13:25:00',3.34),('5819','2013-10-11','13:30:00',1.42),('5819','2013-10-11','13:40:00',2.4),('5819','2013-10-11','13:45:00',3.36),('5819','2013-10-11','13:50:00',1.03),('5819','2013-10-11','15:35:00',1.05),('5819','2013-10-11','15:40:00',1.17),('5819','2013-10-11','15:45:00',1.34),('5819','2013-10-11','16:00:00',1.74),('5819','2013-10-11','16:30:00',1.02),('5819','2013-10-11','16:35:00',1.27),('5819','2013-10-10','08:50:00',1.4),('5819','2013-10-10','08:55:00',1.84),('5819','2013-10-10','09:00:00',1.28),('5819','2013-10-10','09:10:00',1.73),('5819','2013-10-10','09:15:00',1.95),('5819','2013-10-10','09:20:00',2.02),('5819','2013-10-10','09:25:00',1.98),('5819','2013-10-10','09:30:00',2.01),('5819','2013-10-10','09:35:00',1.82),('5819','2013-10-10','09:40:00',1.89),('5819','2013-10-10','09:45:00',1.77),('5819','2013-10-10','10:15:00',2.06),('5819','2013-10-10','10:20:00',2.73),('5819','2013-10-10','10:25:00',2.67),('5819','2013-10-10','10:30:00',2.71),('5819','2013-10-10','10:35:00',1.09),('5819','2013-10-10','10:45:00',1.93),('5819','2013-10-10','10:50:00',1.08),('5819','2013-10-10','10:55:00',1.25),('5819','2013-10-10','11:25:00',3.15),('5819','2013-10-10','11:30:00',2.42),('5819','2013-10-10','11:45:00',1.29),('5819','2013-10-10','11:50:00',1.49),('5819','2013-10-10','11:55:00',3.16),('5819','2013-10-10','12:00:00',3.42),('5819','2013-10-10','12:05:00',2.37),('5819','2013-10-10','12:10:00',1.37),('5819','2013-10-10','12:25:00',2.81),('5819','2013-10-10','12:30:00',1.57),('5819','2013-10-10','12:35:00',3.38),('5819','2013-10-10','12:40:00',3.83),('5819','2013-10-10','12:45:00',3),('5819','2013-10-10','12:50:00',2.56),('5819','2013-10-10','12:55:00',1.42),('5819','2013-10-10','13:00:00',2.6),('5819','2013-10-10','13:05:00',3.61),('5819','2013-10-10','13:10:00',2.47),('5819','2013-10-10','13:15:00',1.53),('5819','2013-10-10','13:20:00',1.04),('5819','2013-10-10','13:25:00',2.41),('5819','2013-10-10','13:30:00',2.31),('5819','2013-10-10','13:35:00',2.14),('5819','2013-10-10','13:40:00',2.01),('5819','2013-10-10','13:45:00',3.17),('5819','2013-10-10','13:50:00',3.31),('5819','2013-10-10','13:55:00',3.22),('5819','2013-10-10','14:00:00',3.13),('5819','2013-10-10','14:05:00',2.19),('5819','2013-10-10','14:10:00',1.83),('5819','2013-10-10','14:15:00',1.76),('5819','2013-10-10','14:20:00',3.19),('5819','2013-10-10','14:25:00',3.06),('5819','2013-10-10','14:30:00',2.27),('5819','2013-10-10','14:35:00',1.76),('5819','2013-10-10','14:40:00',3.08),('5819','2013-10-10','14:45:00',2.67),('5819','2013-10-10','14:50:00',2.76),('5819','2013-10-10','14:55:00',2.72),('5819','2013-10-10','15:00:00',2.54),('5819','2013-10-10','15:05:00',2.7),('5819','2013-10-10','15:10:00',2.52),('5819','2013-10-10','15:15:00',2.55),('5819','2013-10-10','15:20:00',1.96),('5819','2013-10-10','15:25:00',1.71),('5819','2013-10-10','15:30:00',1.46),('5819','2013-10-10','15:35:00',1.34),('5819','2013-10-10','16:15:00',1.43),('5819','2013-10-10','16:20:00',1.41),('5819','2013-10-10','16:25:00',1.35),('5819','2013-10-10','16:30:00',1.14),('5819','2013-10-10','16:45:00',1.07),('5819','2013-10-09','08:25:00',1.19),('5819','2013-10-09','08:30:00',1.29),('5819','2013-10-09','08:35:00',1.16),('5819','2013-10-09','08:40:00',1.43),('5819','2013-10-09','08:45:00',1.51),('5819','2013-10-09','08:50:00',1.59),('5819','2013-10-09','08:55:00',1.68),('5819','2013-10-09','09:00:00',1.77),('5819','2013-10-09','09:05:00',1.87),('5819','2013-10-09','09:10:00',1.96),('5819','2013-10-09','09:15:00',1.91),('5819','2013-10-09','09:20:00',1.75),('5819','2013-10-09','09:25:00',2.14),('5819','2013-10-09','09:30:00',2.19),('5819','2013-10-09','09:35:00',2.26),('5819','2013-10-09','09:40:00',2.35),('5819','2013-10-09','09:45:00',2.44),('5819','2013-10-09','09:50:00',2.49),('5819','2013-10-09','09:55:00',2.59),('5819','2013-10-09','10:00:00',2.73),('5819','2013-10-09','10:05:00',2.76),('5819','2013-10-09','10:10:00',2.96),('5819','2013-10-09','10:15:00',1.38),('5819','2013-10-09','10:25:00',1.16),('5819','2013-10-09','10:30:00',1.5),('5819','2013-10-09','10:35:00',1.84),('5819','2013-10-09','10:40:00',1.6),('5819','2013-10-09','10:45:00',1.97),('5819','2013-10-09','10:50:00',3.61),('5819','2013-10-09','10:55:00',1.74),('5819','2013-10-09','11:00:00',2.74),('5819','2013-10-09','11:05:00',3.01),('5819','2013-10-09','11:10:00',3.89),('5819','2013-10-09','11:15:00',3.8),('5819','2013-10-09','11:20:00',3.52),('5819','2013-10-09','11:25:00',2.89),('5819','2013-10-09','11:30:00',3.7),('5819','2013-10-09','11:35:00',3.91),('5819','2013-10-09','11:40:00',3.18),('5819','2013-10-09','11:45:00',2.68),('5819','2013-10-09','11:50:00',3.16),('5819','2013-10-09','11:55:00',3.44),('5819','2013-10-09','12:00:00',2.78),('5819','2013-10-09','12:05:00',1.11),('5819','2013-10-09','12:10:00',2.26),('5819','2013-10-09','12:15:00',2.1),('5819','2013-10-09','12:20:00',2.93),('5819','2013-10-09','12:25:00',3.47),('5819','2013-10-09','12:30:00',1.61),('5819','2013-10-09','12:35:00',1.35),('5819','2013-10-09','12:40:00',1.37),('5819','2013-10-09','13:15:00',1.53),('5819','2013-10-09','13:20:00',1.82),('5819','2013-10-09','13:25:00',1.91),('5819','2013-10-09','13:30:00',2.07),('5819','2013-10-09','13:35:00',2.01),('5819','2013-10-09','13:40:00',3.11),('5819','2013-10-09','13:45:00',2.65),('5819','2013-10-09','13:50:00',2.71),('5819','2013-10-09','13:55:00',3.73),('5819','2013-10-09','14:00:00',3.5),('5819','2013-10-09','14:05:00',1.42),('5819','2013-10-09','14:10:00',1.97),('5819','2013-10-09','14:55:00',2.32),('5819','2013-10-09','15:00:00',1.69),('5819','2013-10-09','15:05:00',2.41),('5819','2013-10-09','15:10:00',2.68),('5819','2013-10-09','15:15:00',2.45),('5819','2013-10-09','15:20:00',2.28),('5819','2013-10-09','15:25:00',2.18),('5819','2013-10-09','15:30:00',1.64),('5819','2013-10-09','15:35:00',1.5),('5819','2013-10-09','15:40:00',1.92),('5819','2013-10-09','15:45:00',1.02),('5819','2013-10-09','15:50:00',1.64),('5819','2013-10-09','16:15:00',1.14),('5819','2013-10-09','16:20:00',1.39),('5819','2013-10-09','16:25:00',1.21),('5819','2013-10-09','16:30:00',1.75),('5819','2013-10-09','16:35:00',1.04),('5819','2013-10-09','16:40:00',1.36),('5819','2014-04-15','09:00:00',1.64),('5819','2014-04-15','09:05:00',2.13),('5819','2014-04-15','09:10:00',1.24),('5819','2014-04-15','09:15:00',2.05),('5819','2014-04-15','09:20:00',1.73),('5819','2014-04-15','09:25:00',2.36),('5819','2014-04-15','09:30:00',2.26),('5819','2014-04-15','09:35:00',1.03),('5819','2014-04-15','09:50:00',3.11),('5819','2014-04-15','09:55:00',1.03),('5819','2014-04-15','10:00:00',1.14),('5819','2014-04-15','10:05:00',1.18),('5819','2014-04-15','10:10:00',1.21),('5819','2014-04-15','10:15:00',2.16),('5819','2014-04-15','10:20:00',1.57),('5819','2014-04-15','10:25:00',1.32),('5819','2014-04-15','10:30:00',1.77),('5819','2014-04-15','10:35:00',3.42),('5819','2014-04-15','10:40:00',2),('5819','2014-04-15','10:45:00',2.85),('5819','2014-04-15','10:50:00',2.41),('5819','2014-04-15','10:55:00',1.51),('5819','2014-04-15','11:00:00',1.31),('5819','2014-04-15','11:05:00',3.13),('5819','2014-04-15','11:10:00',3.12),('5819','2014-04-15','11:15:00',1.59),('5819','2014-04-15','11:20:00',1.07),('5819','2014-04-15','11:25:00',1.37),('5819','2014-04-15','11:30:00',1.1),('5819','2014-04-15','11:50:00',1.3),('5819','2014-04-15','11:55:00',1.06),('5819','2014-04-15','12:15:00',1.59),('5819','2014-04-15','12:20:00',1.81),('5819','2014-04-15','13:10:00',1.48),('5819','2014-04-15','13:15:00',1.49),('5819','2014-04-15','13:20:00',2.59),('5819','2014-04-15','13:25:00',1.71),('5819','2014-04-15','13:30:00',2.73),('5819','2014-04-15','13:35:00',2.33),('5819','2014-04-15','13:40:00',2.83),('5819','2014-04-15','13:45:00',1.36),('5819','2014-04-15','14:00:00',1.84),('5819','2014-04-15','14:05:00',2.71),('5819','2014-04-15','14:10:00',1.51),('5819','2014-04-15','14:15:00',3.09),('5819','2014-04-15','14:20:00',2.85),('5819','2014-04-15','14:25:00',3.32),('5819','2014-04-15','14:30:00',2.45),('5819','2014-04-15','14:35:00',2.02),('5819','2014-04-15','14:40:00',1.39),('5819','2014-04-15','14:45:00',1.38),('5819','2014-04-15','14:50:00',1.22),('5819','2014-04-15','14:55:00',1.27),('5819','2014-04-15','15:15:00',1.28),('5819','2014-04-15','15:20:00',1.52),('5819','2014-04-15','15:25:00',2.11),('5819','2014-04-15','15:30:00',1.42),('5819','2014-04-15','15:35:00',1.31),('5819','2014-04-15','15:40:00',1.32),('5819','2014-04-15','15:45:00',1.22),('5819','2014-04-15','15:50:00',1.24),('5819','2014-04-15','15:55:00',1.24),('5819','2014-04-15','16:00:00',1.22),('5819','2014-04-15','16:05:00',1.14),('5819','2013-10-08','08:10:00',1.08),('5819','2013-10-08','08:15:00',1.3),('5819','2013-10-08','08:20:00',1.35),('5819','2013-10-08','10:00:00',1.12),('5819','2013-10-08','11:00:00',1.58),('5819','2013-10-08','11:05:00',1.38),('5819','2013-10-08','11:10:00',2.57),('5819','2013-10-08','11:15:00',3.87),('5819','2013-10-08','11:20:00',3.52),('5819','2013-10-08','11:25:00',1.89),('5819','2013-10-08','11:30:00',2.98),('5819','2013-10-08','11:35:00',2.57),('5819','2013-10-08','11:40:00',1.61),('5819','2013-10-08','11:45:00',1.51),('5819','2013-10-08','11:50:00',1.11),('5819','2013-10-08','12:20:00',1.07),('5819','2013-10-08','12:25:00',1.3),('5819','2013-10-08','12:30:00',3.27),('5819','2013-10-08','12:35:00',1.87),('5819','2013-10-08','12:40:00',4.14),('5819','2013-10-08','12:45:00',3.71),('5819','2013-10-08','12:50:00',3.73),('5819','2013-10-08','12:55:00',3.68),('5819','2013-10-08','13:00:00',3.18),('5819','2013-10-08','13:05:00',3.47),('5819','2013-10-08','13:10:00',2.25),('5819','2013-10-08','13:15:00',3.47),('5819','2013-10-08','13:20:00',1.69),('5819','2013-10-08','13:25:00',2.92),('5819','2013-10-08','13:30:00',1.83),('5819','2013-10-08','13:35:00',1.13),('5819','2013-10-08','13:40:00',1.15),('5819','2013-10-08','14:05:00',1.2),('5819','2013-10-08','14:10:00',1.99),('5819','2013-10-08','14:15:00',2.06),('5819','2013-10-08','14:20:00',2.48),('5819','2013-10-08','14:25:00',2.47),('5819','2013-10-08','14:30:00',2.62),('5819','2013-10-08','14:35:00',1.09),('5819','2013-10-08','14:40:00',1.22),('5819','2013-10-08','14:45:00',2.6),('5819','2013-10-08','14:50:00',2.9),('5819','2013-10-08','14:55:00',2.68),('5819','2013-10-08','15:00:00',2.6),('5819','2013-10-08','15:05:00',2.56),('5819','2013-10-08','15:10:00',2.6),('5819','2013-10-08','15:15:00',2.35),('5819','2013-10-08','15:20:00',2.15),('5819','2013-10-08','15:25:00',1.95),('5819','2013-10-08','15:30:00',2.77),('5819','2013-10-08','15:35:00',2.58),('5819','2013-10-08','15:40:00',2.09),('5819','2013-10-08','15:45:00',1.41),('5819','2013-10-08','15:50:00',1.68),('5819','2013-10-08','15:55:00',1.4),('5819','2013-10-08','16:05:00',1.03),('5819','2013-10-07','08:20:00',1.08),('5819','2013-10-07','08:25:00',1.18),('5819','2013-10-07','08:30:00',1.24),('5819','2013-10-07','08:35:00',1.44),('5819','2013-10-07','08:40:00',1.75),('5819','2013-10-07','09:00:00',1.71),('5819','2013-10-07','09:05:00',2.08),('5819','2013-10-07','09:10:00',1.97),('5819','2013-10-07','09:15:00',2.03),('5819','2013-10-07','09:20:00',2.08),('5819','2013-10-07','09:25:00',2.14),('5819','2013-10-07','09:30:00',2.21),('5819','2013-10-07','09:35:00',2.28),('5819','2013-10-07','09:40:00',2.35),('5819','2013-10-07','09:45:00',2.41),('5819','2013-10-07','09:50:00',2.46),('5819','2013-10-07','09:55:00',2.5),('5819','2013-10-07','10:00:00',2.57),('5819','2013-10-07','10:05:00',2.63),('5819','2013-10-07','10:10:00',2.66),('5819','2013-10-07','10:15:00',2.71),('5819','2013-10-07','10:20:00',2.77),('5819','2013-10-07','10:25:00',2.81),('5819','2013-10-07','10:30:00',2.87),('5819','2013-10-07','10:35:00',2.98),('5819','2013-10-07','10:40:00',2.98),('5819','2013-10-07','10:45:00',3.03),('5819','2013-10-07','10:50:00',3.07),('5819','2013-10-07','10:55:00',2.76),('5819','2013-10-07','11:00:00',2.73),('5819','2013-10-07','11:05:00',3.2),('5819','2013-10-07','11:10:00',2.61),('5819','2013-10-07','11:15:00',2.59),('5819','2013-10-07','11:20:00',3.11),('5819','2013-10-07','11:25:00',3.25),('5819','2013-10-07','11:30:00',3.24),('5819','2013-10-07','11:35:00',3.25),('5819','2013-10-07','11:40:00',3.28),('5819','2013-10-07','11:45:00',3.27),('5819','2013-10-07','11:50:00',3.27),('5819','2013-10-07','11:55:00',3.32),('5819','2013-10-07','12:00:00',3.3),('5819','2013-10-07','12:05:00',2.78),('5819','2013-10-07','12:10:00',3.57),('5819','2013-10-07','12:15:00',2.78),('5819','2013-10-07','12:20:00',2.56),('5819','2013-10-07','12:25:00',3.41),('5819','2013-10-07','12:30:00',3.7),('5819','2013-10-07','12:35:00',3.42),('5819','2013-10-07','12:40:00',3.57),('5819','2013-10-07','12:45:00',3.56),('5819','2013-10-07','12:50:00',3.54),('5819','2013-10-07','12:55:00',3.59),('5819','2013-10-07','13:00:00',3.15),('5819','2013-10-07','13:05:00',3.49),('5819','2013-10-07','13:10:00',3.49),('5819','2013-10-07','13:15:00',2.26),('5819','2013-10-07','13:20:00',3.09),('5819','2013-10-07','13:25:00',3.21),('5819','2013-10-07','13:30:00',3.44),('5819','2013-10-07','13:35:00',1.18),('5819','2013-10-07','13:40:00',1.55),('5819','2013-10-07','13:45:00',1.53),('5819','2013-10-07','13:50:00',2.38),('5819','2013-10-07','13:55:00',3.51),('5819','2013-10-07','14:00:00',3.83),('5819','2013-10-07','14:05:00',2.17),('5819','2013-10-07','14:10:00',1.46),('5819','2013-10-07','14:20:00',1.07),('5819','2013-10-07','14:25:00',2.79),('5819','2013-10-07','14:35:00',1.7),('5819','2013-10-07','14:40:00',1.93),('5819','2013-10-07','14:45:00',2.67),('5819','2013-10-07','14:50:00',3.16),('5819','2013-10-07','14:55:00',3.16),('5819','2013-10-07','15:00:00',2.32),('5819','2013-10-07','15:05:00',1.57),('5819','2013-10-07','15:10:00',2.4),('5819','2013-10-07','15:25:00',1.82),('5819','2013-10-07','15:30:00',1.68),('5819','2013-10-07','15:35:00',1.28),('5819','2013-10-07','15:40:00',1.66),('5819','2013-10-07','15:45:00',2.12),('5819','2013-10-07','15:50:00',1.56),('5819','2013-10-07','15:55:00',2.33),('5819','2013-10-07','16:10:00',1.45),('5819','2013-10-07','16:15:00',1.78),('5819','2013-10-07','16:20:00',1.67),('5819','2013-10-07','16:25:00',1.28),('5819','2013-10-07','16:30:00',1.49),('5819','2013-10-07','16:35:00',1.2),('5819','2013-10-07','16:40:00',1.32),('5819','2013-10-07','16:45:00',1.24),('5819','2013-10-07','16:50:00',1.14),('5819','2013-10-07','16:55:00',1.02),('5819','2013-10-06','09:05:00',1.07),('5819','2013-10-06','09:10:00',1.04),('5819','2013-10-06','09:30:00',1.16),('5819','2013-10-06','09:35:00',1.63),('5819','2013-10-06','09:40:00',1.47),('5819','2013-10-06','09:45:00',1.14),('5819','2013-10-06','09:50:00',2.14),('5819','2013-10-06','09:55:00',2.53),('5819','2013-10-06','10:00:00',2.93),('5819','2013-10-06','10:05:00',2.99),('5819','2013-10-06','10:10:00',2.91),('5819','2013-10-06','10:15:00',2.69),('5819','2013-10-06','10:20:00',2.69),('5819','2013-10-06','10:25:00',3),('5819','2013-10-06','10:30:00',2.91),('5819','2013-10-06','10:35:00',2.88),('5819','2013-10-06','10:40:00',2.46),('5819','2013-10-06','10:45:00',1.99),('5819','2013-10-06','10:50:00',2.19),('5819','2013-10-06','10:55:00',2.42),('5819','2013-10-06','11:00:00',2.47),('5819','2013-10-06','11:05:00',2.73),('5819','2013-10-06','11:10:00',2.85),('5819','2013-10-06','11:15:00',2.72),('5819','2013-10-06','11:20:00',2.74),('5819','2013-10-06','11:25:00',2.9),('5819','2013-10-06','11:30:00',2.81),('5819','2013-10-06','11:35:00',2.76),('5819','2013-10-06','11:40:00',2.39),('5819','2013-10-06','11:45:00',1.8),('5819','2013-10-06','11:50:00',1.93),('5819','2013-10-06','11:55:00',2.53),('5819','2013-10-06','12:00:00',2.6),('5819','2013-10-06','12:05:00',2.6),('5819','2013-10-06','12:10:00',3.23),('5819','2013-10-06','12:15:00',3.11),('5819','2013-10-06','12:20:00',2.7),('5819','2013-10-06','12:25:00',2.33),('5819','2013-10-06','12:30:00',2.38),('5819','2013-10-06','12:35:00',2.59),('5819','2013-10-06','12:40:00',2.18),('5819','2013-10-06','12:45:00',2.17),('5819','2013-10-06','12:50:00',2.58),('5819','2013-10-06','12:55:00',3.07),('5819','2013-10-06','13:00:00',3.16),('5819','2013-10-06','13:05:00',3.01),('5819','2013-10-06','13:10:00',2.34),('5819','2013-10-06','13:15:00',1.39),('5819','2013-10-06','13:20:00',2.85),('5819','2013-10-06','13:25:00',1.12),('5819','2013-10-06','13:50:00',3.07),('5819','2013-10-06','13:55:00',2.06),('5819','2013-10-06','14:00:00',1.65),('5819','2013-10-06','14:05:00',3.1),('5819','2013-10-06','14:10:00',3.18),('5819','2013-10-06','14:15:00',2.19),('5819','2013-10-06','14:20:00',1.79),('5819','2013-10-06','14:25:00',1.51),('5819','2013-10-06','14:30:00',1.6),('5819','2013-10-06','14:35:00',1.39),('5819','2013-10-06','14:40:00',1.19),('5819','2013-10-06','14:45:00',1.39),('5819','2013-10-06','14:50:00',1.66),('5819','2013-10-06','14:55:00',2.22),('5819','2013-10-06','15:00:00',1.93),('5819','2013-10-06','15:05:00',1.43),('5819','2013-10-06','15:10:00',1.2),('5819','2013-10-06','15:15:00',1.04),('5819','2013-10-05','16:05:00',1.03),('5819','2013-10-05','16:10:00',1.05),('5819','2013-10-04','09:30:00',1.03),('5819','2013-10-04','09:35:00',1.01),('5819','2013-10-04','09:40:00',1.09),('5819','2013-10-04','09:45:00',1.04),('5819','2013-10-04','09:50:00',1.25),('5819','2013-10-04','09:55:00',2.71),('5819','2013-10-04','10:00:00',2.14),('5819','2013-10-04','10:05:00',1.58),('5819','2013-10-04','10:10:00',1.51),('5819','2013-10-04','10:15:00',1.83),('5819','2013-10-04','10:20:00',1.43),('5819','2013-10-04','10:25:00',2.3),('5819','2013-10-04','10:30:00',1.96),('5819','2013-10-04','10:35:00',1.53),('5819','2013-10-04','10:40:00',2.79),('5819','2013-10-04','10:45:00',2.39),('5819','2013-10-04','10:50:00',1.69),('5819','2013-10-04','10:55:00',2.65),('5819','2013-10-04','11:00:00',2.38),('5819','2013-10-04','11:05:00',1.72),('5819','2013-10-04','11:10:00',1.58),('5819','2013-10-04','11:15:00',3.42),('5819','2013-10-04','11:20:00',2.86),('5819','2013-10-04','11:25:00',2.97),('5819','2013-10-04','11:30:00',3.71),('5819','2013-10-04','11:35:00',3.63),('5819','2013-10-04','11:40:00',3.57),('5819','2013-10-04','11:45:00',3.49),('5819','2013-10-04','11:50:00',3.43),('5819','2013-10-04','11:55:00',3.41),('5819','2013-10-04','12:00:00',3.42),('5819','2013-10-04','12:05:00',3.42),('5819','2013-10-04','12:10:00',3.46),('5819','2013-10-04','12:15:00',3.18),('5819','2013-10-04','12:20:00',3.29),('5819','2013-10-04','12:25:00',3.5),('5819','2013-10-04','12:30:00',3.23),('5819','2013-10-04','12:35:00',3.07),('5819','2013-10-04','12:40:00',3.39),('5819','2013-10-04','12:45:00',3.38),('5819','2013-10-04','12:50:00',3.25),('5819','2013-10-04','12:55:00',3.27),('5819','2013-10-04','13:00:00',3.29),('5819','2013-10-04','13:05:00',3.32),('5819','2013-10-04','13:10:00',3.33),('5819','2013-10-04','13:15:00',3.56),('5819','2013-10-04','13:20:00',3.41),('5819','2013-10-04','13:25:00',3.18),('5819','2013-10-04','13:30:00',3.37),('5819','2013-10-04','13:35:00',2.38),('5819','2013-10-04','13:40:00',3.19),('5819','2013-10-04','13:45:00',3.12),('5819','2013-10-04','13:50:00',3.07),('5819','2013-10-04','13:55:00',3.05),('5819','2013-10-04','14:00:00',3.03),('5819','2013-10-04','14:05:00',2.98),('5819','2013-10-04','14:10:00',2.75),('5819','2013-10-04','14:15:00',2.48),('5819','2013-10-04','14:20:00',2.57),('5819','2013-10-04','14:25:00',2.83),('5819','2013-10-04','14:30:00',2.45),('5819','2013-10-04','14:35:00',1.77),('5819','2013-10-04','14:40:00',1.47),('5819','2013-10-04','14:45:00',1.6),('5819','2013-10-04','14:50:00',2.14),('5819','2013-10-04','14:55:00',2.21),('5819','2013-10-04','15:00:00',1.91),('5819','2013-10-04','15:05:00',2.11),('5819','2013-10-04','15:10:00',1.85),('5819','2013-10-04','15:15:00',1.46),('5819','2013-10-04','15:20:00',1.26),('5819','2013-10-04','15:25:00',1.83),('5819','2013-10-04','15:30:00',2.23),('5819','2013-10-04','15:35:00',1.41),('5819','2013-10-03','08:15:00',1.14),('5819','2013-10-03','08:20:00',1.25),('5819','2013-10-03','08:25:00',1.32),('5819','2013-10-03','08:30:00',1.42),('5819','2013-10-03','08:35:00',1.51),('5819','2013-10-03','08:40:00',1.6),('5819','2013-10-03','08:45:00',1.7),('5819','2013-10-03','08:50:00',1.79),('5819','2013-10-03','08:55:00',1.88),('5819','2013-10-03','09:00:00',1.96),('5819','2013-10-03','09:05:00',2.04),('5819','2013-10-03','09:10:00',2.13),('5819','2013-10-03','09:15:00',2.21),('5819','2013-10-03','09:20:00',2.29),('5819','2013-10-03','09:25:00',2.36),('5819','2013-10-03','09:30:00',2.43),('5819','2013-10-03','09:35:00',2.51),('5819','2013-10-03','09:40:00',2.58),('5819','2013-10-03','09:45:00',2.65),('5819','2013-10-03','09:50:00',2.71),('5819','2013-10-03','09:55:00',2.77),('5819','2013-10-03','10:00:00',2.84),('5819','2013-10-03','10:05:00',2.91),('5819','2013-10-03','10:10:00',2.95),('5819','2013-10-03','10:15:00',3.01),('5819','2013-10-03','10:20:00',3.06),('5819','2013-10-03','10:25:00',3.1),('5819','2013-10-03','10:30:00',3.15),('5819','2013-10-03','10:35:00',3.19),('5819','2013-10-03','10:40:00',3.23),('5819','2013-10-03','10:45:00',3.29),('5819','2013-10-03','10:50:00',3.3),('5819','2013-10-03','10:55:00',3.34),('5819','2013-10-03','11:00:00',3.37),('5819','2013-10-03','11:05:00',3.4),('5819','2013-10-03','11:10:00',3.43),('5819','2013-10-03','11:15:00',3.45),('5819','2013-10-03','11:20:00',3.48),('5819','2013-10-03','11:25:00',3.5),('5819','2013-10-03','11:30:00',3.5),('5819','2013-10-03','11:35:00',3.55),('5819','2013-10-03','11:40:00',3.57),('5819','2013-10-03','11:45:00',3.58),('5819','2013-10-03','11:50:00',3.61),('5819','2013-10-03','11:55:00',3.63),('5819','2013-10-03','12:00:00',3.62),('5819','2013-10-03','12:05:00',3.63),('5819','2013-10-03','12:10:00',3.62),('5819','2013-10-03','12:15:00',3.59),('5819','2013-10-03','12:20:00',3.58),('5819','2013-10-03','12:25:00',3.61),('5819','2013-10-03','12:30:00',3.63),('5819','2013-10-03','12:35:00',3.62),('5819','2013-10-03','12:40:00',3.6),('5819','2013-10-03','12:45:00',3.59),('5819','2013-10-03','12:50:00',3.58),('5819','2013-10-03','12:55:00',3.57),('5819','2013-10-03','13:00:00',3.54),('5819','2013-10-03','13:05:00',3.48),('5819','2013-10-03','13:10:00',3.49),('5819','2013-10-03','13:15:00',3.46),('5819','2013-10-03','13:20:00',3.46),('5819','2013-10-03','13:25:00',3.43),('5819','2013-10-03','13:30:00',3.42),('5819','2013-10-03','13:35:00',3.4),('5819','2013-10-03','13:40:00',3.37),('5819','2013-10-03','13:45:00',3.33),('5819','2013-10-03','13:50:00',3.3),('5819','2013-10-03','13:55:00',3.29),('5819','2013-10-03','14:00:00',3.26),('5819','2013-10-03','14:05:00',3.23),('5819','2013-10-03','14:10:00',3.19),('5819','2013-10-03','14:15:00',3.13),('5819','2013-10-03','14:20:00',3.1),('5819','2013-10-03','14:25:00',3.05),('5819','2013-10-03','14:30:00',3.01),('5819','2013-10-03','14:35:00',2.95),('5819','2013-10-03','14:40:00',2.9),('5819','2013-10-03','14:45:00',2.85),('5819','2013-10-03','14:50:00',2.8),('5819','2013-10-03','14:55:00',2.75),('5819','2013-10-03','15:00:00',2.69),('5819','2013-10-03','15:05:00',2.63),('5819','2013-10-03','15:10:00',2.56),('5819','2013-10-03','15:15:00',2.51),('5819','2013-10-03','15:20:00',2.44),('5819','2013-10-03','15:25:00',2.38),('5819','2013-10-03','15:30:00',2.3),('5819','2013-10-03','15:35:00',2.23),('5819','2013-10-03','15:40:00',2.16),('5819','2013-10-03','15:45:00',2.09),('5819','2013-10-03','15:50:00',2.03),('5819','2013-10-03','15:55:00',1.94),('5819','2013-10-03','16:00:00',1.87),('5819','2013-10-03','16:05:00',1.78),('5819','2013-10-03','16:10:00',1.71),('5819','2013-10-03','16:15:00',1.63),('5819','2013-10-03','16:20:00',1.55),('5819','2013-10-03','16:25:00',1.47),('5819','2013-10-03','16:30:00',1.4),('5819','2013-10-03','16:35:00',1.31),('5819','2013-10-03','16:40:00',1.23),('5819','2013-10-03','16:45:00',1.16),('5819','2013-10-03','16:50:00',1.09),('5819','2013-10-03','16:55:00',1.01),('5819','2013-10-02','08:15:00',1.03),('5819','2013-10-02','08:20:00',1.31),('5819','2013-10-02','08:30:00',1.2),('5819','2013-10-02','08:35:00',1.39),('5819','2013-10-02','08:40:00',1.47),('5819','2013-10-02','08:45:00',1.56),('5819','2013-10-02','08:50:00',1.68),('5819','2013-10-02','08:55:00',1.77),('5819','2013-10-02','09:00:00',1.86),('5819','2013-10-02','09:05:00',1.93),('5819','2013-10-02','09:10:00',2.01),('5819','2013-10-02','09:15:00',2.1),('5819','2013-10-02','09:20:00',2.17),('5819','2013-10-02','09:25:00',2.24),('5819','2013-10-02','09:30:00',2.32),('5819','2013-10-02','09:35:00',2.38),('5819','2013-10-02','09:40:00',2.44),('5819','2013-10-02','09:45:00',2.5),('5819','2013-10-02','09:50:00',2.56),('5819','2013-10-02','09:55:00',2.61),('5819','2013-10-02','10:00:00',2.66),('5819','2013-10-02','10:05:00',2.71),('5819','2013-10-02','10:10:00',2.76),('5819','2013-10-02','10:15:00',2.8),('5819','2013-10-02','10:20:00',2.86),('5819','2013-10-02','10:25:00',2.92),('5819','2013-10-02','10:30:00',2.97),('5819','2013-10-02','10:35:00',3.03),('5819','2013-10-02','10:40:00',3.08),('5819','2013-10-02','10:45:00',3.12),('5819','2013-10-02','10:50:00',3.17),('5819','2013-10-02','10:55:00',3.2),('5819','2013-10-02','11:00:00',3.25),('5819','2013-10-02','11:05:00',3.27),('5819','2013-10-02','11:10:00',3.31),('5819','2013-10-02','11:15:00',3.32),('5819','2013-10-02','11:20:00',3.36),('5819','2013-10-02','11:25:00',3.37),('5819','2013-10-02','11:30:00',3.38),('5819','2013-10-02','11:35:00',3.4),('5819','2013-10-02','11:40:00',3.42),('5819','2013-10-02','11:45:00',3.45),('5819','2013-10-02','11:50:00',3.46),('5819','2013-10-02','11:55:00',3.46),('5819','2013-10-02','12:00:00',3.48),('5819','2013-10-02','12:05:00',3.47),('5819','2013-10-02','12:10:00',3.49),('5819','2013-10-02','12:15:00',3.49),('5819','2013-10-02','12:20:00',3.49),('5819','2013-10-02','12:25:00',3.47),('5819','2013-10-02','12:30:00',3.47),('5819','2013-10-02','12:35:00',3.47),('5819','2013-10-02','12:40:00',3.45),('5819','2013-10-02','12:45:00',3.46),('5819','2013-10-02','12:50:00',3.47),('5819','2013-10-02','12:55:00',3.45),('5819','2013-10-02','13:00:00',3.44),('5819','2013-10-02','13:05:00',3.42),('5819','2013-10-02','13:10:00',3.4),('5819','2013-10-02','13:15:00',3.38),('5819','2013-10-02','13:20:00',3.37),('5819','2013-10-02','13:25:00',3.37),('5819','2013-10-02','13:30:00',3.34),('5819','2013-10-02','13:35:00',3.31),('5819','2013-10-02','13:40:00',3.3),('5819','2013-10-02','13:45:00',3.28),('5819','2013-10-02','13:50:00',3.25),('5819','2013-10-02','13:55:00',3.2),('5819','2013-10-02','14:00:00',3.17),('5819','2013-10-02','14:05:00',3.13),('5819','2013-10-02','14:10:00',3.09),('5819','2013-10-02','14:15:00',3.07),('5819','2013-10-02','14:20:00',3.01),('5819','2013-10-02','14:25:00',2.97),('5819','2013-10-02','14:30:00',2.93),('5819','2013-10-02','14:35:00',2.9),('5819','2013-10-02','14:40:00',2.84),('5819','2013-10-02','14:45:00',2.79),('5819','2013-10-02','14:50:00',2.74),('5819','2013-10-02','14:55:00',2.7),('5819','2013-10-02','15:00:00',2.64),('5819','2013-10-02','15:05:00',2.58),('5819','2013-10-02','15:10:00',2.51),('5819','2013-10-02','15:15:00',2.46),('5819','2013-10-02','15:20:00',2.4),('5819','2013-10-02','15:25:00',2.33),('5819','2013-10-02','15:30:00',2.26),('5819','2013-10-02','15:35:00',2.2),('5819','2013-10-02','15:40:00',2.14),('5819','2013-10-02','15:45:00',2.07),('5819','2013-10-02','15:50:00',1.99),('5819','2013-10-02','15:55:00',1.9),('5819','2013-10-02','16:00:00',1.84),('5819','2013-10-02','16:05:00',1.76),('5819','2013-10-02','16:10:00',1.68),('5819','2013-10-02','16:15:00',1.61),('5819','2013-10-02','16:20:00',1.53),('5819','2013-10-02','16:25:00',1.45),('5819','2013-10-02','16:30:00',1.38),('5819','2013-10-02','16:35:00',1.3),('5819','2013-10-02','16:40:00',1.22),('5819','2013-10-02','16:45:00',1.14),('5819','2013-10-02','16:50:00',1.07),('5819','2013-10-01','08:40:00',1.4),('5819','2013-10-01','08:45:00',1.62),('5819','2013-10-01','08:50:00',1.72),('5819','2013-10-01','08:55:00',1.8),('5819','2013-10-01','09:00:00',1.88),('5819','2013-10-01','09:05:00',1.95),('5819','2013-10-01','09:10:00',2.02),('5819','2013-10-01','09:15:00',2.08),('5819','2013-10-01','09:20:00',2.14),('5819','2013-10-01','09:25:00',2.19),('5819','2013-10-01','09:30:00',2.27),('5819','2013-10-01','09:35:00',2.31),('5819','2013-10-01','09:40:00',2.37),('5819','2013-10-01','09:45:00',2.44),('5819','2013-10-01','09:50:00',2.5),('5819','2013-10-01','09:55:00',2.56),('5819','2013-10-01','10:00:00',2.61),('5819','2013-10-01','10:05:00',2.66),('5819','2013-10-01','10:10:00',2.71),('5819','2013-10-01','10:15:00',2.76),('5819','2013-10-01','10:20:00',2.82),('5819','2013-10-01','10:25:00',2.87),('5819','2013-10-01','10:30:00',2.93),('5819','2013-10-01','10:35:00',2.97),('5819','2013-10-01','10:40:00',3),('5819','2013-10-01','10:45:00',3.03),('5819','2013-10-01','10:50:00',3.06),('5819','2013-10-01','10:55:00',3.08),('5819','2013-10-01','11:00:00',3.15),('5819','2013-10-01','11:05:00',1.88),('5819','2013-10-01','11:10:00',3.47),('5819','2013-10-01','11:15:00',2.48),('5819','2013-10-01','11:20:00',3.28),('5819','2013-10-01','11:25:00',2.59),('5819','2013-10-01','11:30:00',3.43),('5819','2013-10-01','11:35:00',2.61),('5819','2013-10-01','11:40:00',3.52),('5819','2013-10-01','11:45:00',3.58),('5819','2013-10-01','11:50:00',3.59),('5819','2013-10-01','11:55:00',3.58),('5819','2013-10-01','12:00:00',3.16),('5819','2013-10-01','12:10:00',2.75),('5819','2013-10-01','12:15:00',3.46),('5819','2013-10-01','12:20:00',3.61),('5819','2013-10-01','12:25:00',3.49),('5819','2013-10-01','12:30:00',3.69),('5819','2013-10-01','12:35:00',3.71),('5819','2013-10-01','12:40:00',2.55),('5819','2013-10-01','12:45:00',3.04),('5819','2013-10-01','12:50:00',3.54),('5819','2013-10-01','12:55:00',3.47),('5819','2013-10-01','13:00:00',3.19),('5819','2013-10-01','13:05:00',3.53),('5819','2013-10-01','13:10:00',1.44),('5819','2013-10-01','13:15:00',1.16),('5819','2013-10-01','13:20:00',3.68),('5819','2013-10-01','13:25:00',3.68),('5819','2013-10-01','13:30:00',2.74),('5819','2013-10-01','13:35:00',3.15),('5819','2013-10-01','13:40:00',1.6),('5819','2013-10-01','13:45:00',2.5),('5819','2013-10-01','13:55:00',1.68),('5819','2013-10-01','14:00:00',3.28),('5819','2013-10-01','14:05:00',3.14),('5819','2013-10-01','14:10:00',3.08),('5819','2013-10-01','14:15:00',3.03),('5819','2013-10-01','14:20:00',2.99),('5819','2013-10-01','14:25:00',2.95),('5819','2013-10-01','14:30:00',2.91),('5819','2013-10-01','14:35:00',2.87),('5819','2013-10-01','14:40:00',2.86),('5819','2013-10-01','14:45:00',2.85),('5819','2013-10-01','14:50:00',2.84),('5819','2013-10-01','14:55:00',2.79),('5819','2013-10-01','15:00:00',2.75),('5819','2013-10-01','15:05:00',2.6),('5819','2013-10-01','15:10:00',2.51),('5819','2013-10-01','15:15:00',2.45),('5819','2013-10-01','15:20:00',2.4),('5819','2013-10-01','15:25:00',2.33),('5819','2013-10-01','15:30:00',2.27),('5819','2013-10-01','15:35:00',2.2),('5819','2013-10-01','15:40:00',2.13),('5819','2013-10-01','15:45:00',2.06),('5819','2013-10-01','15:50:00',2),('5819','2013-10-01','15:55:00',1.93),('5819','2013-10-01','16:00:00',1.84),('5819','2013-10-01','16:05:00',1.77),('5819','2013-10-01','16:10:00',1.69),('5819','2013-10-01','16:15:00',1.62),('5819','2013-10-01','16:20:00',1.55),('5819','2013-10-01','16:25:00',1.47),('5819','2013-10-01','16:30:00',1.38),('5819','2013-10-01','16:35:00',1.3),('5819','2013-10-01','16:40:00',1.23),('5819','2013-10-01','16:45:00',1.15),('5819','2013-10-01','16:50:00',1.07),('5819','2013-10-01','16:55:00',1.01),('5819','2013-09-30','09:50:00',1.25),('5819','2013-09-30','09:55:00',1.06),('5819','2013-09-30','10:15:00',1.03),('5819','2013-09-30','10:20:00',1.04),('5819','2013-09-30','10:25:00',1.27),('5819','2013-09-30','10:30:00',1.47),('5819','2013-09-30','10:35:00',1.71),('5819','2013-09-30','10:40:00',2.13),('5819','2013-09-30','10:45:00',3.22),('5819','2013-09-30','10:50:00',3.37),('5819','2013-09-30','10:55:00',3.07),('5819','2013-09-30','11:00:00',2.74),('5819','2013-09-30','11:05:00',3.08),('5819','2013-09-30','11:10:00',3.16),('5819','2013-09-30','11:15:00',2.56),('5819','2013-09-30','11:20:00',2.4),('5819','2013-09-30','11:25:00',3.01),('5819','2013-09-30','11:30:00',1.61),('5819','2013-09-30','11:35:00',1.76),('5819','2013-09-30','11:40:00',3.12),('5819','2013-09-30','11:45:00',1.98),('5819','2013-09-30','11:50:00',1.76),('5819','2013-09-30','11:55:00',1.47),('5819','2013-09-30','12:00:00',1.7),('5819','2013-09-30','12:05:00',2.83),('5819','2013-09-30','12:10:00',2.55),('5819','2013-09-30','12:15:00',3.66),('5819','2013-09-30','12:20:00',3.78),('5819','2013-09-30','12:25:00',3.81),('5819','2013-09-30','12:30:00',3.61),('5819','2013-09-30','12:35:00',3.55),('5819','2013-09-30','12:40:00',3.61),('5819','2013-09-30','12:45:00',2.77),('5819','2013-09-30','12:50:00',3.68),('5819','2013-09-30','12:55:00',3.59),('5819','2013-09-30','13:00:00',3.57),('5819','2013-09-30','13:05:00',2.81),('5819','2013-09-30','13:10:00',3.72),('5819','2013-09-30','13:15:00',3.21),('5819','2013-09-30','13:20:00',3.85),('5819','2013-09-30','13:25:00',4.04),('5819','2013-09-30','13:30:00',4.04),('5819','2013-09-30','13:35:00',3.15),('5819','2013-09-30','13:40:00',2.37),('5819','2013-09-30','13:45:00',1.56),('5819','2013-09-30','13:50:00',2.75),('5819','2013-09-30','13:55:00',2.17),('5819','2013-09-30','14:00:00',1.25),('5819','2013-09-30','14:05:00',1.25),('5819','2013-09-30','14:10:00',1.24),('5819','2013-09-30','14:15:00',1.18),('5819','2013-09-30','14:25:00',1.06),('5819','2013-09-30','14:30:00',2.08),('5819','2013-09-30','14:35:00',2.69),('5819','2013-09-30','14:40:00',3.5),('5819','2013-09-30','14:45:00',2.41),('5819','2013-09-30','14:50:00',2.99),('5819','2013-09-30','14:55:00',1.86),('5819','2013-09-30','15:00:00',2.5),('5819','2013-09-30','15:05:00',1.99),('5819','2013-09-30','15:10:00',2.43),('5819','2013-09-30','15:15:00',1.74),('5819','2013-09-30','15:25:00',2.65),('5819','2013-09-30','15:30:00',1.91),('5819','2013-09-30','15:35:00',1.68),('5819','2013-09-30','15:40:00',2.65),('5819','2013-09-30','15:45:00',1.54),('5819','2013-09-30','16:10:00',1.22),('5819','2013-09-30','16:15:00',1.48),('5819','2013-09-30','16:20:00',1.08),('5819','2013-09-30','16:45:00',1.16),('5819','2013-09-29','08:50:00',1.19),('5819','2013-09-29','08:55:00',1.09),('5819','2013-09-29','09:15:00',1.28),('5819','2013-09-29','09:55:00',1.02),('5819','2013-09-29','10:00:00',1.23),('5819','2013-09-29','10:05:00',1.72),('5819','2013-09-29','10:10:00',1.95),('5819','2013-09-29','10:15:00',2.51),('5819','2013-09-29','10:20:00',2.19),('5819','2013-09-29','10:25:00',2.01),('5819','2013-09-29','10:30:00',2.36),('5819','2013-09-29','10:35:00',2.59),('5819','2013-09-29','10:40:00',2.82),('5819','2013-09-29','10:45:00',2.67),('5819','2013-09-29','10:50:00',2.8),('5819','2013-09-29','10:55:00',2.75),('5819','2013-09-29','11:00:00',2.81),('5819','2013-09-29','11:05:00',2.7),('5819','2013-09-29','11:10:00',2.68),('5819','2013-09-29','11:15:00',2.88),('5819','2013-09-29','11:20:00',2.89),('5819','2013-09-29','11:25:00',2.73),('5819','2013-09-29','11:30:00',2.91),('5819','2013-09-29','11:35:00',2.89),('5819','2013-09-29','11:40:00',2.98),('5819','2013-09-29','11:45:00',2.97),('5819','2013-09-29','11:50:00',3.17),('5819','2013-09-29','11:55:00',3.14),('5819','2013-09-29','12:00:00',2.92),('5819','2013-09-29','12:05:00',3.13),('5819','2013-09-29','12:10:00',3.1),('5819','2013-09-29','12:15:00',3.32),('5819','2013-09-29','12:20:00',2.84),('5819','2013-09-29','12:25:00',1.89),('5819','2013-09-29','12:30:00',1.95),('5819','2013-09-29','12:35:00',1.84),('5819','2013-09-29','12:40:00',1.59),('5819','2013-09-29','12:45:00',1.39),('5819','2013-09-29','12:50:00',1.42),('5819','2013-09-29','12:55:00',1.2),('5819','2013-09-29','13:00:00',1.21),('5819','2013-09-29','13:05:00',1.01),('5819','2013-09-29','13:10:00',1.23),('5819','2013-09-29','13:25:00',1.2),('5819','2013-09-29','13:30:00',2.19),('5819','2013-09-29','13:35:00',1.5),('5819','2013-09-29','13:40:00',1.5),('5819','2013-09-29','13:45:00',1.4),('5819','2013-09-29','13:50:00',1.44),('5819','2013-09-29','13:55:00',2.02),('5819','2013-09-29','14:00:00',1.81),('5819','2013-09-29','14:05:00',2.17),('5819','2013-09-29','14:10:00',1.52),('5819','2013-09-29','14:15:00',1.54),('5819','2013-09-29','14:20:00',2.07),('5819','2013-09-29','14:25:00',1.42),('5819','2013-09-29','14:30:00',1.08),('5819','2013-09-29','14:35:00',1.1),('5819','2013-09-29','15:00:00',1.27),('5819','2013-09-29','16:00:00',1.05),('5819','2013-09-28','08:20:00',1.08),('5819','2013-09-28','08:25:00',1.04),('5819','2013-09-28','08:30:00',1),('5819','2013-09-28','08:35:00',1.29),('5819','2013-09-28','08:40:00',1.38),('5819','2013-09-28','08:45:00',1.46),('5819','2013-09-28','08:50:00',1.52),('5819','2013-09-28','08:55:00',1.61),('5819','2013-09-28','09:00:00',1.66),('5819','2013-09-28','09:05:00',1.75),('5819','2013-09-28','09:10:00',1.85),('5819','2013-09-28','09:15:00',1.95),('5819','2013-09-28','09:20:00',2.01),('5819','2013-09-28','09:25:00',2.1),('5819','2013-09-28','09:30:00',2.18),('5819','2013-09-28','09:35:00',2.24),('5819','2013-09-28','09:40:00',2.32),('5819','2013-09-28','09:45:00',2.39),('5819','2013-09-28','09:50:00',2.47),('5819','2013-09-28','09:55:00',2.58),('5819','2013-09-28','10:00:00',1.51),('5819','2013-09-28','10:05:00',1.66),('5819','2013-09-28','10:10:00',1.64),('5819','2013-09-28','10:15:00',1.11),('5819','2013-09-28','10:25:00',1.13),('5819','2013-09-28','10:30:00',1.05),('5819','2013-09-28','10:35:00',2.63),('5819','2013-09-28','10:40:00',2.25),('5819','2013-09-28','10:45:00',2.68),('5819','2013-09-28','10:50:00',3.04),('5819','2013-09-28','10:55:00',3.38),('5819','2013-09-28','11:00:00',1.71),('5819','2013-09-28','11:15:00',1.52),('5819','2013-09-28','11:20:00',2.33),('5819','2013-09-28','11:25:00',3.49),('5819','2013-09-28','11:30:00',3.61),('5819','2013-09-28','11:35:00',3),('5819','2013-09-28','11:40:00',2.05),('5819','2013-09-28','11:45:00',1.4),('5819','2013-09-28','11:50:00',1.09),('5819','2013-09-28','11:55:00',1.35),('5819','2013-09-28','12:00:00',1.29),('5819','2013-09-28','12:05:00',3.38),('5819','2013-09-28','12:10:00',3.65),('5819','2013-09-28','12:15:00',2.89),('5819','2013-09-28','12:20:00',1.7),('5819','2013-09-28','12:25:00',3.47),('5819','2013-09-28','12:30:00',1.08),('5819','2013-09-28','12:35:00',2.02),('5819','2013-09-28','12:40:00',3.08),('5819','2013-09-28','12:45:00',1.3),('5819','2013-09-28','12:50:00',2.69),('5819','2013-09-28','12:55:00',3.6),('5819','2013-09-28','13:00:00',1.55),('5819','2013-09-28','13:05:00',3.41),('5819','2013-09-28','13:10:00',1.21),('5819','2013-09-28','13:15:00',1.17),('5819','2013-09-28','13:20:00',1.24),('5819','2013-09-28','13:25:00',1.36),('5819','2013-09-28','13:30:00',2.92),('5819','2013-09-28','13:35:00',1.62),('5819','2013-09-28','13:40:00',1.3),('5819','2013-09-28','13:45:00',1.48),('5819','2013-09-28','13:50:00',1.99),('5819','2013-09-28','13:55:00',1.31),('5819','2013-09-28','14:00:00',1.28),('5819','2013-09-28','14:05:00',1.2),('5819','2013-09-28','14:10:00',1.2),('5819','2013-09-28','14:15:00',1.39),('5819','2013-09-28','14:20:00',1.86),('5819','2013-09-28','14:25:00',3.49),('5819','2013-09-28','14:30:00',2.56),('5819','2013-09-28','14:35:00',2.12),('5819','2013-09-28','14:40:00',3.25),('5819','2013-09-28','14:45:00',3.09),('5819','2013-09-28','14:50:00',2.79),('5819','2013-09-28','14:55:00',1.14),('5819','2013-09-28','15:00:00',2.49),('5819','2013-09-28','15:05:00',2.87),('5819','2013-09-28','15:10:00',1.97),('5819','2013-09-28','15:15:00',2.82),('5819','2013-09-28','15:20:00',2.6),('5819','2013-09-28','15:25:00',2.75),('5819','2013-09-28','15:30:00',2.7),('5819','2013-09-28','15:35:00',2.47),('5819','2013-09-28','15:40:00',2.44),('5819','2013-09-28','15:45:00',2.2),('5819','2013-09-28','15:50:00',1.31),('5819','2013-09-28','15:55:00',1.54),('5819','2013-09-28','16:00:00',2.1),('5819','2013-09-28','16:05:00',1.96),('5819','2013-09-28','16:10:00',2.03),('5819','2013-09-28','16:15:00',1.94),('5819','2013-09-28','16:20:00',1.54),('5819','2013-09-28','16:25:00',1.61),('5819','2013-09-28','16:30:00',1.4),('5819','2013-09-28','16:35:00',1.35),('5819','2013-09-28','16:40:00',1.29),('5819','2013-09-28','16:45:00',1.18),('5819','2013-09-28','16:50:00',1.11),('5819','2013-09-28','16:55:00',1.04),('5819','2013-09-27','08:25:00',1.25),('5819','2013-09-27','08:30:00',1.2),('5819','2013-09-27','08:35:00',1.37),('5819','2013-09-27','08:40:00',1.42),('5819','2013-09-27','08:45:00',1.49),('5819','2013-09-27','08:50:00',1.44),('5819','2013-09-27','08:55:00',1.69),('5819','2013-09-27','09:00:00',1.49),('5819','2013-09-27','09:05:00',1.09),('5819','2013-09-27','09:10:00',1.11),('5819','2013-09-27','09:15:00',1.13),('5819','2013-09-27','09:50:00',1.03),('5819','2013-09-27','09:55:00',1.39),('5819','2013-09-27','10:00:00',1.36),('5819','2013-09-27','10:05:00',2.11),('5819','2013-09-27','10:10:00',2.11),('5819','2013-09-27','10:15:00',1.56),('5819','2013-09-27','10:20:00',2.07),('5819','2013-09-27','10:25:00',1.69),('5819','2013-09-27','10:30:00',2.12),('5819','2013-09-27','10:35:00',1.28),('5819','2013-09-27','10:40:00',1.03),('5819','2013-09-27','10:45:00',1.46),('5819','2013-09-27','10:50:00',2.79),('5819','2013-09-27','10:55:00',2.92),('5819','2013-09-27','11:00:00',3.06),('5819','2013-09-27','11:05:00',3.06),('5819','2013-09-27','11:10:00',2.78),('5819','2013-09-27','11:15:00',3.09),('5819','2013-09-27','11:20:00',3.08),('5819','2013-09-27','11:25:00',2.87),('5819','2013-09-27','11:30:00',2.89),('5819','2013-09-27','11:35:00',1.2),('5819','2013-09-27','11:40:00',1.06),('5819','2013-09-27','11:45:00',2.18),('5819','2013-09-27','11:50:00',1.14),('5819','2013-09-27','11:55:00',1.22),('5819','2013-09-27','12:00:00',2.97),('5819','2013-09-27','12:05:00',1.81),('5819','2013-09-27','12:10:00',2.84),('5819','2013-09-27','12:15:00',2.67),('5819','2013-09-27','12:45:00',1.53),('5819','2013-09-27','12:50:00',3.25),('5819','2013-09-27','12:55:00',3.3),('5819','2013-09-27','13:00:00',3.31),('5819','2013-09-27','13:05:00',3.3),('5819','2013-09-27','13:10:00',3.3),('5819','2013-09-27','13:15:00',1.56),('5819','2013-09-27','13:20:00',3.18),('5819','2013-09-27','13:25:00',2.77),('5819','2013-09-27','13:35:00',1.22),('5819','2013-09-27','13:40:00',1.23),('5819','2013-09-27','13:45:00',2.48),('5819','2013-09-27','13:50:00',1.58),('5819','2013-09-27','13:55:00',1.03),('5819','2013-09-27','14:00:00',1.44),('5819','2013-09-27','14:05:00',2.82),('5819','2013-09-27','14:10:00',2.54),('5819','2013-09-27','14:15:00',2.86),('5819','2013-09-27','14:20:00',3.22),('5819','2013-09-27','14:25:00',3.1),('5819','2013-09-27','14:30:00',3.05),('5819','2013-09-27','14:35:00',2.94),('5819','2013-09-27','14:40:00',2.93),('5819','2013-09-27','14:45:00',2.8),('5819','2013-09-27','14:50:00',2.59),('5819','2013-09-27','14:55:00',2.51),('5819','2013-09-27','15:00:00',2.04),('5819','2013-09-27','15:05:00',2.07),('5819','2013-09-27','15:10:00',1.82),('5819','2013-09-27','15:15:00',2.5),('5819','2013-09-27','15:20:00',1.6),('5819','2013-09-27','15:25:00',2.27),('5819','2013-09-27','15:30:00',2.42),('5819','2013-09-27','15:35:00',1.92),('5819','2013-09-27','15:40:00',2.2),('5819','2013-09-27','15:45:00',1.17),('5819','2013-09-27','15:50:00',2.09),('5819','2013-09-27','15:55:00',2.05),('5819','2013-09-27','16:00:00',1.67),('5819','2013-09-27','16:05:00',1.61),('5819','2013-09-27','16:15:00',1.17),('5819','2013-09-27','16:20:00',1.67),('5819','2013-09-27','16:25:00',1.56),('5819','2013-09-27','16:30:00',1.21),('5819','2013-09-27','16:35:00',1.38),('5819','2013-09-27','16:40:00',1.29),('5819','2013-09-27','16:45:00',1.22),('5819','2013-09-27','16:50:00',1.18),('5819','2013-09-26','08:10:00',1.01),('5819','2013-09-26','08:15:00',1.06),('5819','2013-09-26','08:25:00',1.07),('5819','2013-09-26','08:30:00',1.33),('5819','2013-09-26','08:35:00',1.03),('5819','2013-09-26','08:40:00',1.44),('5819','2013-09-26','08:45:00',1.58),('5819','2013-09-26','08:50:00',1.69),('5819','2013-09-26','08:55:00',1.78),('5819','2013-09-26','09:00:00',1.86),('5819','2013-09-26','09:05:00',1.94),('5819','2013-09-26','09:10:00',2.02),('5819','2013-09-26','09:15:00',2.1),('5819','2013-09-26','09:20:00',2.17),('5819','2013-09-26','09:25:00',2.23),('5819','2013-09-26','09:30:00',2.3),('5819','2013-09-26','09:35:00',2.36),('5819','2013-09-26','09:40:00',2.4),('5819','2013-09-26','09:45:00',2.46),('5819','2013-09-26','09:50:00',2.49),('5819','2013-09-26','09:55:00',2.55),('5819','2013-09-26','10:00:00',2.62),('5819','2013-09-26','10:05:00',2.64),('5819','2013-09-26','10:10:00',2.68),('5819','2013-09-26','10:15:00',2.76),('5819','2013-09-26','10:20:00',2.77),('5819','2013-09-26','10:25:00',2.81),('5819','2013-09-26','10:30:00',2.82),('5819','2013-09-26','10:35:00',2.86),('5819','2013-09-26','10:40:00',2.88),('5819','2013-09-26','10:45:00',2.65),('5819','2013-09-26','10:50:00',3),('5819','2013-09-26','10:55:00',3.05),('5819','2013-09-26','11:00:00',3.08),('5819','2013-09-26','11:05:00',3.01),('5819','2013-09-26','11:10:00',3.1),('5819','2013-09-26','11:15:00',3.11),('5819','2013-09-26','11:20:00',3.16),('5819','2013-09-26','11:25:00',3.22),('5819','2013-09-26','11:30:00',3.21),('5819','2013-09-26','11:35:00',3.29),('5819','2013-09-26','11:40:00',2.93),('5819','2013-09-26','11:45:00',2.58),('5819','2013-09-26','11:50:00',3.26),('5819','2013-09-26','11:55:00',3.11),('5819','2013-09-26','12:00:00',2.34),('5819','2013-09-26','12:05:00',2.74),('5819','2013-09-26','12:15:00',1.32),('5819','2013-09-26','12:20:00',1.65),('5819','2013-09-26','12:25:00',1.25),('5819','2013-09-26','12:30:00',1.3),('5819','2013-09-26','12:35:00',1.27),('5819','2013-09-26','12:40:00',1.67),('5819','2013-09-26','12:45:00',1.84),('5819','2013-09-26','12:50:00',1.6),('5819','2013-09-26','12:55:00',1.92),('5819','2013-09-26','13:00:00',2.92),('5819','2013-09-26','13:05:00',2.06),('5819','2013-09-26','13:10:00',1.41),('5819','2013-09-26','13:15:00',2.85),('5819','2013-09-26','13:20:00',3.65),('5819','2013-09-26','13:25:00',2.96),('5819','2013-09-26','13:30:00',2.1),('5819','2013-09-26','13:35:00',1.9),('5819','2013-09-26','13:40:00',1.43),('5819','2013-09-26','13:45:00',1.33),('5819','2013-09-26','13:50:00',1.22),('5819','2013-09-26','13:55:00',1.7),('5819','2013-09-26','14:00:00',1.89),('5819','2013-09-26','14:05:00',2.4),('5819','2013-09-26','14:10:00',3.43),('5819','2013-09-26','14:15:00',3.32),('5819','2013-09-26','14:20:00',3.02),('5819','2013-09-26','14:25:00',2.02),('5819','2013-09-26','14:30:00',1.65),('5819','2013-09-26','14:35:00',1.92),('5819','2013-09-26','14:40:00',1.95),('5819','2013-09-26','14:45:00',2.24),('5819','2013-09-26','14:50:00',3.31),('5819','2013-09-26','14:55:00',2.38),('5819','2013-09-26','15:00:00',1.13),('5819','2013-09-26','15:05:00',1.27),('5819','2013-09-26','15:10:00',1.36),('5819','2013-09-26','15:20:00',1.15),('5819','2013-09-26','15:25:00',2.34),('5819','2013-09-26','15:30:00',1.05),('5819','2013-09-26','15:35:00',1.59),('5819','2013-09-26','15:40:00',1.02),('5819','2013-09-26','15:45:00',2.09),('5819','2013-09-26','15:50:00',2.33),('5819','2013-09-26','15:55:00',2.09),('5819','2013-09-26','16:00:00',1.97),('5819','2013-09-26','16:05:00',1.84),('5819','2013-09-26','16:10:00',1.81),('5819','2013-09-26','16:15:00',1.69),('5819','2013-09-26','16:20:00',1.63),('5819','2013-09-26','16:25:00',1.6),('5819','2013-09-26','16:30:00',1.51),('5819','2013-09-26','16:35:00',1.41),('5819','2013-09-26','16:40:00',1.33),('5819','2013-09-26','16:45:00',1.24),('5819','2013-09-26','16:50:00',1.16),('5819','2013-09-26','16:55:00',1.09),('5819','2013-09-26','17:00:00',1.02),('5819','2013-09-25','08:25:00',1.17),('5819','2013-09-25','08:30:00',1.12),('5819','2013-09-25','08:45:00',1.24),('5819','2013-09-25','08:50:00',1.45),('5819','2013-09-25','09:10:00',1.86),('5819','2013-09-25','09:15:00',1.94),('5819','2013-09-25','09:25:00',1.28),('5819','2013-09-25','09:30:00',1.96),('5819','2013-09-25','09:35:00',1.81),('5819','2013-09-25','09:40:00',2.34),('5819','2013-09-25','09:45:00',2.29),('5819','2013-09-25','09:50:00',1.97),('5819','2013-09-25','09:55:00',1.53),('5819','2013-09-25','10:00:00',2.85),('5819','2013-09-25','10:05:00',2.12),('5819','2013-09-25','10:10:00',1.05),('5819','2013-09-25','10:20:00',1.19),('5819','2013-09-25','10:25:00',1.6),('5819','2013-09-25','10:30:00',1.46),('5819','2013-09-25','10:35:00',1.27),('5819','2013-09-25','10:45:00',2.72),('5819','2013-09-25','10:50:00',3.48),('5819','2013-09-25','10:55:00',3.73),('5819','2013-09-25','11:00:00',2.78),('5819','2013-09-25','11:05:00',1.06),('5819','2013-09-25','11:10:00',1.38),('5819','2013-09-25','11:15:00',1.39),('5819','2013-09-25','11:25:00',1.72),('5819','2013-09-25','11:30:00',3.49),('5819','2013-09-25','11:35:00',3.49),('5819','2013-09-25','11:40:00',3.26),('5819','2013-09-25','11:45:00',3.44),('5819','2013-09-25','11:50:00',2.47),('5819','2013-09-25','11:55:00',1.88),('5819','2013-09-25','12:00:00',2.56),('5819','2013-09-25','12:10:00',1.1),('5819','2013-09-25','12:15:00',3.4),('5819','2013-09-25','12:20:00',3.54),('5819','2013-09-25','12:25:00',3.55),('5819','2013-09-25','12:30:00',2.5),('5819','2013-09-25','12:35:00',3.6),('5819','2013-09-25','12:40:00',3.63),('5819','2013-09-25','12:45:00',1.62),('5819','2013-09-25','12:50:00',1.02),('5819','2013-09-25','13:00:00',1.27),('5819','2013-09-25','13:05:00',1.4),('5819','2013-09-25','13:10:00',1.11),('5819','2013-09-25','13:35:00',2.88),('5819','2013-09-25','13:40:00',2.34),('5819','2013-09-25','13:45:00',3.7),('5819','2013-09-25','13:50:00',3.61),('5819','2013-09-25','13:55:00',3.74),('5819','2013-09-25','14:00:00',1.57),('5819','2013-09-25','14:10:00',1.01),('5819','2013-09-25','14:30:00',1.07),('5819','2013-09-25','14:35:00',1.55),('5819','2013-09-25','14:40:00',2.47),('5819','2013-09-25','14:45:00',2.5),('5819','2013-09-25','14:50:00',1.94),('5819','2013-09-25','14:55:00',2.93),('5819','2013-09-25','15:00:00',2.35),('5819','2013-09-25','15:05:00',3.09),('5819','2013-09-25','15:10:00',2.93),('5819','2013-09-25','15:15:00',2.81),('5819','2013-09-25','15:20:00',2.71),('5819','2013-09-25','15:25:00',2.49),('5819','2013-09-25','15:30:00',2.49),('5819','2013-09-25','15:35:00',2.24),('5819','2013-09-25','15:40:00',2.61),('5819','2013-09-25','15:45:00',2.3),('5819','2013-09-25','15:50:00',2.24),('5819','2013-09-25','15:55:00',2.16),('5819','2013-09-25','16:00:00',2.09),('5819','2013-09-25','16:05:00',2),('5819','2013-09-25','16:10:00',1.91),('5819','2013-09-25','16:15:00',1.82),('5819','2013-09-25','16:20:00',1.73),('5819','2013-09-25','16:30:00',1.28),('5819','2013-09-25','16:35:00',1.52),('5819','2013-09-25','16:40:00',1.41),('5819','2013-09-25','16:45:00',1.3),('5819','2013-09-25','16:50:00',1.24),('5819','2013-09-25','16:55:00',1.15),('5819','2013-09-25','17:00:00',1.08),('5819','2013-09-25','17:05:00',1.01),('5819','2013-09-24','08:10:00',1.09),('5819','2013-09-24','08:15:00',1.19),('5819','2013-09-24','08:20:00',1.28),('5819','2013-09-24','08:25:00',1.37),('5819','2013-09-24','08:30:00',1.46),('5819','2013-09-24','08:35:00',1.57),('5819','2013-09-24','08:40:00',1.65),('5819','2013-09-24','08:45:00',1.72),('5819','2013-09-24','08:50:00',1.81),('5819','2013-09-24','08:55:00',1.88),('5819','2013-09-24','09:00:00',1.96),('5819','2013-09-24','09:05:00',2.04),('5819','2013-09-24','09:10:00',2.13),('5819','2013-09-24','09:15:00',2.19),('5819','2013-09-24','09:20:00',2.26),('5819','2013-09-24','09:25:00',2.34),('5819','2013-09-24','09:30:00',2.41),('5819','2013-09-24','09:35:00',2.47),('5819','2013-09-24','09:40:00',2.53),('5819','2013-09-24','09:45:00',2.58),('5819','2013-09-24','09:50:00',2.63),('5819','2013-09-24','09:55:00',2.67),('5819','2013-09-24','10:00:00',2.71),('5819','2013-09-24','10:05:00',2.78),('5819','2013-09-24','10:10:00',2.85),('5819','2013-09-24','10:15:00',2.91),('5819','2013-09-24','10:20:00',2.95),('5819','2013-09-24','10:25:00',3),('5819','2013-09-24','10:30:00',3.04),('5819','2013-09-24','10:35:00',3.06),('5819','2013-09-24','10:40:00',3.09),('5819','2013-09-24','10:45:00',3.13),('5819','2013-09-24','10:50:00',3.17),('5819','2013-09-24','10:55:00',3.19),('5819','2013-09-24','11:00:00',3.23),('5819','2013-09-24','11:05:00',3.25),('5819','2013-09-24','11:10:00',3.26),('5819','2013-09-24','11:15:00',3.29),('5819','2013-09-24','11:20:00',3.29),('5819','2013-09-24','11:25:00',3.3),('5819','2013-09-24','11:30:00',3.32),('5819','2013-09-24','11:35:00',3.34),('5819','2013-09-24','11:40:00',3.38),('5819','2013-09-24','11:45:00',3.37),('5819','2013-09-24','11:50:00',3.38),('5819','2013-09-24','11:55:00',3.41),('5819','2013-09-24','12:00:00',3.41),('5819','2013-09-24','12:05:00',3.42),('5819','2013-09-24','12:10:00',3.43),('5819','2013-09-24','12:15:00',3.42),('5819','2013-09-24','12:20:00',3.44),('5819','2013-09-24','12:25:00',3.41),('5819','2013-09-24','12:30:00',3.39),('5819','2013-09-24','12:35:00',3.4),('5819','2013-09-24','12:40:00',3.42),('5819','2013-09-24','12:45:00',3.45),('5819','2013-09-24','12:50:00',3.44),('5819','2013-09-24','12:55:00',3.4),('5819','2013-09-24','13:00:00',3.37),('5819','2013-09-24','13:05:00',3.4),('5819','2013-09-24','13:10:00',3.36),('5819','2013-09-24','13:15:00',3.36),('5819','2013-09-24','13:20:00',3.36),('5819','2013-09-24','13:25:00',3.35),('5819','2013-09-24','13:30:00',3.33),('5819','2013-09-24','13:35:00',3.28),('5819','2013-09-24','13:40:00',3.27),('5819','2013-09-24','13:45:00',3.27),('5819','2013-09-24','13:50:00',3.26),('5819','2013-09-24','13:55:00',3.2),('5819','2013-09-24','14:00:00',3.16),('5819','2013-09-24','14:05:00',3.14),('5819','2013-09-24','14:10:00',3.11),('5819','2013-09-24','14:15:00',3.08),('5819','2013-09-24','14:20:00',3.04),('5819','2013-09-24','14:25:00',3.01),('5819','2013-09-24','14:30:00',2.99),('5819','2013-09-24','14:35:00',2.93),('5819','2013-09-24','14:40:00',2.89),('5819','2013-09-24','14:45:00',2.83),('5819','2013-09-24','14:50:00',2.77),('5819','2013-09-24','14:55:00',2.73),('5819','2013-09-24','15:00:00',2.67),('5819','2013-09-24','15:05:00',2.63),('5819','2013-09-24','15:10:00',2.61),('5819','2013-09-24','15:15:00',2.54),('5819','2013-09-24','15:20:00',2.5),('5819','2013-09-24','15:25:00',2.47),('5819','2013-09-24','15:30:00',2.41),('5819','2013-09-24','15:35:00',2.33),('5819','2013-09-24','15:40:00',2.26),('5819','2013-09-24','15:45:00',2.2),('5819','2013-09-24','15:50:00',2.13),('5819','2013-09-24','15:55:00',2.06),('5819','2013-09-24','16:00:00',1.99),('5819','2013-09-24','16:05:00',1.92),('5819','2013-09-24','16:10:00',1.84),('5819','2013-09-24','16:15:00',1.78),('5819','2013-09-24','16:20:00',1.71),('5819','2013-09-24','16:25:00',1.63),('5819','2013-09-24','16:30:00',1.55),('5819','2013-09-24','16:35:00',1.47),('5819','2013-09-24','16:40:00',1.39),('5819','2013-09-24','16:45:00',1.31),('5819','2013-09-24','16:50:00',1.23),('5819','2013-09-24','16:55:00',1.17),('5819','2013-09-24','17:00:00',1.11),('5819','2013-09-24','17:05:00',1.03),('5819','2013-09-23','08:05:00',1.06),('5819','2013-09-23','08:10:00',1.16),('5819','2013-09-23','08:15:00',1.24),('5819','2013-09-23','08:20:00',1.33),('5819','2013-09-23','08:25:00',1.42),('5819','2013-09-23','08:30:00',1.51),('5819','2013-09-23','08:35:00',1.62),('5819','2013-09-23','08:40:00',1.7),('5819','2013-09-23','08:45:00',1.79),('5819','2013-09-23','08:50:00',1.87),('5819','2013-09-23','08:55:00',1.95),('5819','2013-09-23','09:00:00',2.04),('5819','2013-09-23','09:05:00',2.12),('5819','2013-09-23','09:10:00',2.19),('5819','2013-09-23','09:15:00',2.26),('5819','2013-09-23','09:20:00',2.33),('5819','2013-09-23','09:25:00',2.41),('5819','2013-09-23','09:30:00',2.47),('5819','2013-09-23','09:35:00',2.53),('5819','2013-09-23','09:40:00',2.58),('5819','2013-09-23','09:45:00',2.64),('5819','2013-09-23','09:50:00',2.7),('5819','2013-09-23','09:55:00',2.75),('5819','2013-09-23','10:00:00',2.8),('5819','2013-09-23','10:05:00',2.85),('5819','2013-09-23','10:10:00',2.9),('5819','2013-09-23','10:15:00',2.93),('5819','2013-09-23','10:20:00',2.97),('5819','2013-09-23','10:25:00',3.02),('5819','2013-09-23','10:30:00',3.05),('5819','2013-09-23','10:35:00',3.09),('5819','2013-09-23','10:40:00',3.13),('5819','2013-09-23','10:45:00',3.16),('5819','2013-09-23','10:50:00',3.22),('5819','2013-09-23','10:55:00',3.23),('5819','2013-09-23','11:00:00',3.25),('5819','2013-09-23','11:05:00',3.31),('5819','2013-09-23','11:10:00',3.35),('5819','2013-09-23','11:15:00',3.4),('5819','2013-09-23','11:20:00',3.44),('5819','2013-09-23','11:25:00',3.45),('5819','2013-09-23','11:30:00',3.48),('5819','2013-09-23','11:35:00',3.49),('5819','2013-09-23','11:40:00',3.49),('5819','2013-09-23','11:45:00',3.51),('5819','2013-09-23','11:50:00',3.53),('5819','2013-09-23','11:55:00',3.55),('5819','2013-09-23','12:00:00',3.56),('5819','2013-09-23','12:05:00',3.58),('5819','2013-09-23','12:10:00',3.62),('5819','2013-09-23','12:15:00',3.63),('5819','2013-09-23','12:20:00',3.59),('5819','2013-09-23','12:25:00',3.56),('5819','2013-09-23','12:30:00',3.52),('5819','2013-09-23','12:35:00',3.52),('5819','2013-09-23','12:40:00',3.52),('5819','2013-09-23','12:45:00',3.53),('5819','2013-09-23','12:50:00',3.51),('5819','2013-09-23','12:55:00',3.52),('5819','2013-09-23','13:00:00',3.5),('5819','2013-09-23','13:05:00',3.5),('5819','2013-09-23','13:10:00',3.49),('5819','2013-09-23','13:15:00',3.46),('5819','2013-09-23','13:20:00',3.42),('5819','2013-09-23','13:25:00',3.43),('5819','2013-09-23','13:30:00',3.4),('5819','2013-09-23','13:35:00',3.37),('5819','2013-09-23','13:40:00',3.34),('5819','2013-09-23','13:45:00',3.31),('5819','2013-09-23','13:50:00',3.28),('5819','2013-09-23','13:55:00',3.24),('5819','2013-09-23','14:00:00',3.17),('5819','2013-09-23','14:05:00',3.1),('5819','2013-09-23','14:10:00',3.09),('5819','2013-09-23','14:15:00',3.08),('5819','2013-09-23','14:20:00',3.04),('5819','2013-09-23','14:25:00',3.03),('5819','2013-09-23','14:30:00',3.09),('5819','2013-09-23','14:35:00',3),('5819','2013-09-23','14:40:00',2.93),('5819','2013-09-23','14:45:00',2.85),('5819','2013-09-23','14:50:00',2.78),('5819','2013-09-23','14:55:00',2.78),('5819','2013-09-23','15:00:00',2.73),('5819','2013-09-23','15:05:00',2.12),('5819','2013-09-23','15:10:00',1.84),('5819','2013-09-23','15:15:00',2.63),('5819','2013-09-23','15:20:00',2.52),('5819','2013-09-23','15:25:00',2.46),('5819','2013-09-23','15:30:00',2.39),('5819','2013-09-23','15:35:00',2.34),('5819','2013-09-23','15:40:00',2.27),('5819','2013-09-23','15:45:00',2.2),('5819','2013-09-23','15:50:00',2.11),('5819','2013-09-23','15:55:00',1.81),('5819','2013-09-23','16:00:00',1.95),('5819','2013-09-23','16:05:00',1.93),('5819','2013-09-23','16:10:00',1.57),('5819','2013-09-23','16:15:00',1.6),('5819','2013-09-23','16:20:00',1.52),('5819','2013-09-23','16:25:00',1.34),('5819','2013-09-23','16:30:00',1.49),('5819','2013-09-23','16:35:00',1.42),('5819','2013-09-23','16:40:00',1.37),('5819','2013-09-23','16:45:00',1.3),('5819','2013-09-23','16:50:00',1.21),('5819','2013-09-23','16:55:00',1.14),('5819','2013-09-23','17:00:00',1.07),('5819','2013-09-22','08:05:00',1.09),('5819','2013-09-22','08:10:00',1.16),('5819','2013-09-22','08:15:00',1.02),('5819','2013-09-22','08:20:00',1.27),('5819','2013-09-22','08:25:00',1.4),('5819','2013-09-22','08:30:00',1.48),('5819','2013-09-22','08:35:00',1.56),('5819','2013-09-22','08:40:00',1.64),('5819','2013-09-22','08:45:00',1.73),('5819','2013-09-22','08:50:00',1.82),('5819','2013-09-22','08:55:00',1.91),('5819','2013-09-22','09:00:00',2),('5819','2013-09-22','09:05:00',2.08),('5819','2013-09-22','09:10:00',2.17),('5819','2013-09-22','09:15:00',2.26),('5819','2013-09-22','09:20:00',2.32),('5819','2013-09-22','09:25:00',2.4),('5819','2013-09-22','09:30:00',2.47),('5819','2013-09-22','09:35:00',2.53),('5819','2013-09-22','09:40:00',2.57),('5819','2013-09-22','09:45:00',2.63),('5819','2013-09-22','09:50:00',2.69),('5819','2013-09-22','09:55:00',2.76),('5819','2013-09-22','10:00:00',2.83),('5819','2013-09-22','10:05:00',2.9),('5819','2013-09-22','10:10:00',2.95),('5819','2013-09-22','10:15:00',3),('5819','2013-09-22','10:20:00',3.05),('5819','2013-09-22','10:25:00',3.08),('5819','2013-09-22','10:30:00',3.15),('5819','2013-09-22','10:35:00',3.19),('5819','2013-09-22','10:40:00',3.23),('5819','2013-09-22','10:45:00',3.25),('5819','2013-09-22','10:50:00',3.27),('5819','2013-09-22','10:55:00',3.31),('5819','2013-09-22','11:00:00',3.34),('5819','2013-09-22','11:05:00',3.35),('5819','2013-09-22','11:10:00',3.37),('5819','2013-09-22','11:15:00',3.39),('5819','2013-09-22','11:20:00',3.43),('5819','2013-09-22','11:25:00',3.45),('5819','2013-09-22','11:30:00',3.48),('5819','2013-09-22','11:35:00',3.53),('5819','2013-09-22','11:40:00',3.57),('5819','2013-09-22','11:45:00',3.59),('5819','2013-09-22','11:50:00',3.6),('5819','2013-09-22','11:55:00',3.61),('5819','2013-09-22','12:00:00',3.62),('5819','2013-09-22','12:05:00',3.64),('5819','2013-09-22','12:10:00',3.64),('5819','2013-09-22','12:15:00',3.62),('5819','2013-09-22','12:20:00',3.66),('5819','2013-09-22','12:25:00',3.64),('5819','2013-09-22','12:30:00',3.62),('5819','2013-09-22','12:35:00',3.61),('5819','2013-09-22','12:40:00',3.62),('5819','2013-09-22','12:45:00',3.57),('5819','2013-09-22','12:50:00',3.62),('5819','2013-09-22','12:55:00',3.65),('5819','2013-09-22','13:00:00',3.6),('5819','2013-09-22','13:05:00',3.58),('5819','2013-09-22','13:10:00',3.62),('5819','2013-09-22','13:15:00',3.56),('5819','2013-09-22','13:20:00',3.51),('5819','2013-09-22','13:25:00',3.5),('5819','2013-09-22','13:30:00',3.46),('5819','2013-09-22','13:35:00',3.43),('5819','2013-09-22','13:40:00',3.4),('5819','2013-09-22','13:45:00',3.4),('5819','2013-09-22','13:50:00',3.4),('5819','2013-09-22','13:55:00',3.18),('5819','2013-09-22','14:00:00',3.31),('5819','2013-09-22','14:05:00',3.34),('5819','2013-09-22','14:10:00',3.27),('5819','2013-09-22','14:15:00',3.33),('5819','2013-09-22','14:20:00',2.38),('5819','2013-09-22','14:25:00',3.1),('5819','2013-09-22','14:30:00',3.26),('5819','2013-09-22','14:35:00',3.13),('5819','2013-09-22','14:40:00',2.34),('5819','2013-09-22','14:45:00',2.74),('5819','2013-09-22','14:50:00',2.98),('5819','2013-09-22','14:55:00',2.93),('5819','2013-09-22','15:00:00',2.93),('5819','2013-09-22','15:05:00',2.99),('5819','2013-09-22','15:10:00',2.88),('5819','2013-09-22','15:15:00',3.02),('5819','2013-09-22','15:20:00',3.09),('5819','2013-09-22','15:25:00',1.43),('5819','2013-09-22','15:40:00',2.04),('5819','2013-09-22','15:45:00',2.48),('5819','2013-09-22','15:50:00',2.33),('5819','2013-09-22','15:55:00',2.3),('5819','2013-09-22','16:00:00',2.51),('5819','2013-09-22','16:05:00',2.55),('5819','2013-09-22','16:10:00',2.64),('5819','2013-09-22','16:15:00',2.08),('5819','2013-09-22','16:20:00',1.25),('5819','2013-09-22','16:25:00',1.05),('5819','2013-09-22','16:45:00',1.42),('5819','2013-09-22','16:50:00',1.05),('5819','2013-09-22','16:55:00',1.11),('5819','2013-09-22','17:05:00',1.24),('5819','2013-09-21','08:05:00',1.02),('5819','2013-09-21','08:10:00',1.11),('5819','2013-09-21','08:15:00',1.2),('5819','2013-09-21','08:20:00',1.28),('5819','2013-09-21','08:25:00',1.37),('5819','2013-09-21','08:30:00',1.47),('5819','2013-09-21','08:35:00',1.57),('5819','2013-09-21','08:40:00',1.65),('5819','2013-09-21','08:45:00',1.73),('5819','2013-09-21','08:50:00',1.81),('5819','2013-09-21','08:55:00',1.89),('5819','2013-09-21','09:00:00',1.96),('5819','2013-09-21','09:05:00',2.05),('5819','2013-09-21','09:10:00',2.12),('5819','2013-09-21','09:15:00',2.19),('5819','2013-09-21','09:20:00',2.26),('5819','2013-09-21','09:25:00',2.32),('5819','2013-09-21','09:30:00',2.4),('5819','2013-09-21','09:35:00',2.46),('5819','2013-09-21','09:40:00',2.5),('5819','2013-09-21','09:45:00',2.57),('5819','2013-09-21','09:50:00',2.62),('5819','2013-09-21','09:55:00',2.69),('5819','2013-09-21','10:00:00',2.75),('5819','2013-09-21','10:05:00',2.8),('5819','2013-09-21','10:10:00',2.86),('5819','2013-09-21','10:15:00',2.9),('5819','2013-09-21','10:20:00',2.94),('5819','2013-09-21','10:25:00',2.99),('5819','2013-09-21','10:30:00',3.02),('5819','2013-09-21','10:35:00',3.06),('5819','2013-09-21','10:40:00',3.11),('5819','2013-09-21','10:45:00',3.14),('5819','2013-09-21','10:50:00',3.17),('5819','2013-09-21','10:55:00',3.21),('5819','2013-09-21','11:00:00',3.23),('5819','2013-09-21','11:05:00',3.25),('5819','2013-09-21','11:10:00',3.29),('5819','2013-09-21','11:15:00',3.31),('5819','2013-09-21','11:20:00',3.34),('5819','2013-09-21','11:25:00',3.38),('5819','2013-09-21','11:30:00',3.38),('5819','2013-09-21','11:35:00',3.39),('5819','2013-09-21','11:40:00',3.43),('5819','2013-09-21','11:45:00',3.43),('5819','2013-09-21','11:50:00',3.47),('5819','2013-09-21','11:55:00',3.4),('5819','2013-09-21','12:00:00',3.47),('5819','2013-09-21','12:05:00',3.5),('5819','2013-09-21','12:10:00',3.5),('5819','2013-09-21','12:15:00',3.52),('5819','2013-09-21','12:20:00',3.53),('5819','2013-09-21','12:25:00',3.2),('5819','2013-09-21','12:30:00',3.58),('5819','2013-09-21','12:35:00',3.54),('5819','2013-09-21','12:40:00',3.2),('5819','2013-09-21','12:45:00',3.21),('5819','2013-09-21','12:50:00',3.48),('5819','2013-09-21','12:55:00',3.5),('5819','2013-09-21','13:00:00',3.47),('5819','2013-09-21','13:05:00',3.33),('5819','2013-09-21','13:10:00',3.46),('5819','2013-09-21','13:15:00',3.45),('5819','2013-09-21','13:20:00',2.8),('5819','2013-09-21','13:25:00',3.14),('5819','2013-09-21','13:30:00',3.27),('5819','2013-09-21','13:35:00',3.32),('5819','2013-09-21','13:40:00',2.93),('5819','2013-09-21','13:45:00',2.89),('5819','2013-09-21','13:50:00',3),('5819','2013-09-21','13:55:00',3.08),('5819','2013-09-21','14:00:00',2.97),('5819','2013-09-21','14:05:00',3.14),('5819','2013-09-21','14:10:00',3.04),('5819','2013-09-21','14:15:00',3.14),('5819','2013-09-21','14:20:00',3.16),('5819','2013-09-21','14:25:00',3.09),('5819','2013-09-21','14:30:00',3.05),('5819','2013-09-21','14:35:00',2.99),('5819','2013-09-21','14:40:00',2.93),('5819','2013-09-21','14:45:00',2.88),('5819','2013-09-21','14:50:00',2.85),('5819','2013-09-21','14:55:00',2.81),('5819','2013-09-21','15:00:00',2.75),('5819','2013-09-21','15:05:00',2.69),('5819','2013-09-21','15:10:00',2.56),('5819','2013-09-21','15:15:00',2.56),('5819','2013-09-21','15:20:00',2.54),('5819','2013-09-21','15:25:00',2.47),('5819','2013-09-21','15:30:00',2.4),('5819','2013-09-21','15:35:00',2.37),('5819','2013-09-21','15:40:00',2.18),('5819','2013-09-21','15:45:00',1.66),('5819','2013-09-21','15:50:00',1.88),('5819','2013-09-21','15:55:00',2.13),('5819','2013-09-21','16:00:00',1.69),('5819','2013-09-21','16:05:00',1.04),('5819','2013-09-21','16:10:00',1.3),('5819','2013-09-21','16:15:00',1.14),('5819','2013-09-21','16:20:00',1.4),('5819','2013-09-21','16:35:00',1.17),('5819','2013-09-20','08:35:00',1.57),('5819','2013-09-20','08:40:00',1.8),('5819','2013-09-20','08:45:00',1.8),('5819','2013-09-20','08:50:00',1.07),('5819','2013-09-20','09:00:00',1.11),('5819','2013-09-20','09:05:00',1.25),('5819','2013-09-20','09:10:00',1.16),('5819','2013-09-20','09:15:00',1.08),('5819','2013-09-20','09:20:00',1.64),('5819','2013-09-20','09:25:00',2),('5819','2013-09-20','09:30:00',1.32),('5819','2013-09-20','09:35:00',1.18),('5819','2013-09-20','09:40:00',1.21),('5819','2013-09-20','09:45:00',1.23),('5819','2013-09-20','09:50:00',1.34),('5819','2013-09-20','09:55:00',1.35),('5819','2013-09-20','10:00:00',1.49),('5819','2013-09-20','10:05:00',1.78),('5819','2013-09-20','10:10:00',3.37),('5819','2013-09-20','10:15:00',1.93),('5819','2013-09-20','10:20:00',3.2),('5819','2013-09-20','10:25:00',1.86),('5819','2013-09-20','10:30:00',1.87),('5819','2013-09-20','10:35:00',2.52),('5819','2013-09-20','10:40:00',2.17),('5819','2013-09-20','10:45:00',2.31),('5819','2013-09-20','10:50:00',2.4),('5819','2013-09-20','10:55:00',2.55),('5819','2013-09-20','11:00:00',2.39),('5819','2013-09-20','11:05:00',1.89),('5819','2013-09-20','11:10:00',1.9),('5819','2013-09-20','11:15:00',2.41),('5819','2013-09-20','11:20:00',2.46),('5819','2013-09-20','11:25:00',2.19),('5819','2013-09-20','11:30:00',2.71),('5819','2013-09-20','11:35:00',2.57),('5819','2013-09-20','11:40:00',2.99),('5819','2013-09-20','11:45:00',3.83),('5819','2013-09-20','11:50:00',3.82),('5819','2013-09-20','11:55:00',3.72),('5819','2013-09-20','12:00:00',3.6),('5819','2013-09-20','12:05:00',3.59),('5819','2013-09-20','12:10:00',3.59),('5819','2013-09-20','12:15:00',3.62),('5819','2013-09-20','12:20:00',3.67),('5819','2013-09-20','12:25:00',3.7),('5819','2013-09-20','12:30:00',3.02),('5819','2013-09-20','12:35:00',3.32),('5819','2013-09-20','12:40:00',2.7),('5819','2013-09-20','12:45:00',3.63),('5819','2013-09-20','12:50:00',2.99),('5819','2013-09-20','12:55:00',3.67),('5819','2013-09-20','13:00:00',3.36),('5819','2013-09-20','13:05:00',3.09),('5819','2013-09-20','13:10:00',3.37),('5819','2013-09-20','13:15:00',3.26),('5819','2013-09-20','13:20:00',3.19),('5819','2013-09-20','13:25:00',3.69),('5819','2013-09-20','13:30:00',3.53),('5819','2013-09-20','13:35:00',2.21),('5819','2013-09-20','13:40:00',3.06),('5819','2013-09-20','13:45:00',3.49),('5819','2013-09-20','13:50:00',3.36),('5819','2013-09-20','13:55:00',3.07),('5819','2013-09-20','14:00:00',3.29),('5819','2013-09-20','14:05:00',3.33),('5819','2013-09-20','14:10:00',2.47),('5819','2013-09-20','14:15:00',3.07),('5819','2013-09-20','14:20:00',2.26),('5819','2013-09-20','14:25:00',1.51),('5819','2013-09-20','14:30:00',3.39),('5819','2013-09-20','14:35:00',3.29),('5819','2013-09-20','14:40:00',3.21),('5819','2013-09-20','14:45:00',3.18),('5819','2013-09-20','14:50:00',3.18),('5819','2013-09-20','14:55:00',3.11),('5819','2013-09-20','15:00:00',2.73),('5819','2013-09-20','15:05:00',1.61),('5819','2013-09-20','15:10:00',2.69),('5819','2013-09-20','15:15:00',2.23),('5819','2013-09-20','15:20:00',2.38),('5819','2013-09-20','15:25:00',1.79),('5819','2013-09-20','15:30:00',1.39),('5819','2013-09-20','15:40:00',1.22),('5819','2013-09-20','15:45:00',2.56),('5819','2013-09-20','15:50:00',2.44),('5819','2013-09-20','15:55:00',2.51),('5819','2013-09-20','16:00:00',1.57),('5819','2013-09-20','16:05:00',1.31),('5819','2013-09-20','16:10:00',2.15),('5819','2013-09-20','16:15:00',2.25),('5819','2013-09-20','16:45:00',1.01),('5819','2013-09-20','16:50:00',1.27),('5819','2013-09-20','16:55:00',1.62),('5819','2013-09-20','17:00:00',1.66),('5819','2013-09-20','17:05:00',1.74),('5819','2013-09-20','17:10:00',1.65),('5819','2013-09-20','17:15:00',1.49),('5819','2013-09-20','17:20:00',1.37),('5819','2013-09-20','17:25:00',1.14),('5819','2013-09-19','08:20:00',1.21),('5819','2013-09-19','08:25:00',1.17),('5819','2013-09-19','08:30:00',1.45),('5819','2013-09-19','08:35:00',1.58),('5819','2013-09-19','08:40:00',1.03),('5819','2013-09-19','08:45:00',1.66),('5819','2013-09-19','08:50:00',1.26),('5819','2013-09-19','08:55:00',1.19),('5819','2013-09-19','09:00:00',1.27),('5819','2013-09-19','09:10:00',1.42),('5819','2013-09-19','09:15:00',2.04),('5819','2013-09-19','09:20:00',1.1),('5819','2013-09-19','09:40:00',1.03),('5819','2013-09-19','10:00:00',1.02),('5819','2013-09-19','10:05:00',1.79),('5819','2013-09-19','10:10:00',2.69),('5819','2013-09-19','10:15:00',2.72),('5819','2013-09-19','10:20:00',1.35),('5819','2013-09-19','10:25:00',1.13),('5819','2013-09-19','10:35:00',2.5),('5819','2013-09-19','10:40:00',3.4),('5819','2013-09-19','10:45:00',2.38),('5819','2013-09-19','10:50:00',1.6),('5819','2013-09-19','10:55:00',2.26),('5819','2013-09-19','11:00:00',3.64),('5819','2013-09-19','11:05:00',3.43),('5819','2013-09-19','11:10:00',1.49),('5819','2013-09-19','11:15:00',2.02),('5819','2013-09-19','11:20:00',2.4),('5819','2013-09-19','11:25:00',1.51),('5819','2013-09-19','11:30:00',4.01),('5819','2013-09-19','11:35:00',2.88),('5819','2013-09-19','11:40:00',3.41),('5819','2013-09-19','11:45:00',2.28),('5819','2013-09-19','11:50:00',3.63),('5819','2013-09-19','11:55:00',3.66),('5819','2013-09-19','12:00:00',2.66),('5819','2013-09-19','12:05:00',1.71),('5819','2013-09-19','12:10:00',3.13),('5819','2013-09-19','12:15:00',3.55),('5819','2013-09-19','12:20:00',3.08),('5819','2013-09-19','12:25:00',4.24),('5819','2013-09-19','12:30:00',4.12),('5819','2013-09-19','12:35:00',3.76),('5819','2013-09-19','12:40:00',3.74),('5819','2013-09-19','12:45:00',1.71),('5819','2013-09-19','12:50:00',3.83),('5819','2013-09-19','12:55:00',3.84),('5819','2013-09-19','13:00:00',3.87),('5819','2013-09-19','13:05:00',3.85),('5819','2013-09-19','13:10:00',3.98),('5819','2013-09-19','13:15:00',3.76),('5819','2013-09-19','13:20:00',3.62),('5819','2013-09-19','13:25:00',2.14),('5819','2013-09-19','13:30:00',3.7),('5819','2013-09-19','13:35:00',3.82),('5819','2013-09-19','13:40:00',3.67),('5819','2013-09-19','13:45:00',3.52),('5819','2013-09-19','13:50:00',1.61),('5819','2013-09-19','13:55:00',1.09),('5819','2013-09-19','14:00:00',1.18),('5819','2013-09-19','14:05:00',2.37),('5819','2013-09-19','14:10:00',3.09),('5819','2013-09-19','14:15:00',3.41),('5819','2013-09-19','14:20:00',3.35),('5819','2013-09-19','14:25:00',3.12),('5819','2013-09-19','14:30:00',3.2),('5819','2013-09-19','14:35:00',3.13),('5819','2013-09-19','14:40:00',3.08),('5819','2013-09-19','14:45:00',3),('5819','2013-09-19','14:50:00',3.02),('5819','2013-09-19','14:55:00',2.26),('5819','2013-09-19','15:00:00',3.07),('5819','2013-09-19','15:05:00',2.96),('5819','2013-09-19','15:10:00',2.57),('5819','2013-09-19','15:15:00',2.37),('5819','2013-09-19','15:20:00',2.8),('5819','2013-09-19','15:25:00',2.6),('5819','2013-09-19','15:30:00',2),('5819','2013-09-19','15:35:00',1.48),('5819','2013-09-19','15:40:00',2.14),('5819','2013-09-19','15:45:00',2.36),('5819','2013-09-19','15:50:00',2.36),('5819','2013-09-19','15:55:00',2.12),('5819','2013-09-19','16:00:00',2.18),('5819','2013-09-19','16:05:00',2.1),('5819','2013-09-19','16:10:00',1.52),('5819','2013-09-19','16:15:00',1.33),('5819','2013-09-19','16:20:00',1.98),('5819','2013-09-19','16:25:00',1.88),('5819','2013-09-19','16:30:00',1.54),('5819','2013-09-19','16:35:00',1.09),('5819','2013-09-19','16:40:00',1.03),('5819','2013-09-19','17:00:00',1.31),('5819','2013-09-19','17:05:00',1.18),('5819','2013-09-19','17:10:00',1.12),('5819','2013-09-19','17:15:00',1.02),('5819','2013-09-18','08:10:00',1.08),('5819','2013-09-18','08:15:00',1.11),('5819','2013-09-18','08:20:00',1.02),('5819','2013-09-18','08:25:00',1.24),('5819','2013-09-18','08:30:00',1.03),('5819','2013-09-18','08:45:00',1.42),('5819','2013-09-18','08:50:00',1.07),('5819','2013-09-18','09:00:00',1.19),('5819','2013-09-18','09:05:00',1.77),('5819','2013-09-18','09:15:00',1.03),('5819','2013-09-18','09:20:00',2.46),('5819','2013-09-18','09:25:00',1.87),('5819','2013-09-18','09:30:00',1.87),('5819','2013-09-18','09:35:00',2.04),('5819','2013-09-18','09:40:00',2.72),('5819','2013-09-18','09:45:00',2.11),('5819','2013-09-18','09:55:00',1.22),('5819','2013-09-18','10:00:00',1.75),('5819','2013-09-18','10:05:00',3.43),('5819','2013-09-18','10:10:00',3.19),('5819','2013-09-18','10:15:00',3),('5819','2013-09-18','10:20:00',2.94),('5819','2013-09-18','10:25:00',2.99),('5819','2013-09-18','10:30:00',3),('5819','2013-09-18','10:35:00',3.05),('5819','2013-09-18','10:40:00',3.07),('5819','2013-09-18','10:45:00',2.91),('5819','2013-09-18','10:50:00',2.96),('5819','2013-09-18','10:55:00',2.38),('5819','2013-09-18','11:00:00',2.29),('5819','2013-09-18','11:05:00',3.17),('5819','2013-09-18','11:10:00',2.06),('5819','2013-09-18','11:15:00',2.92),('5819','2013-09-18','11:20:00',2.25),('5819','2013-09-18','11:25:00',2.88),('5819','2013-09-18','11:30:00',3.62),('5819','2013-09-18','11:35:00',3.63),('5819','2013-09-18','11:40:00',1.8),('5819','2013-09-18','11:45:00',1.91),('5819','2013-09-18','11:50:00',3.35),('5819','2013-09-18','11:55:00',3.78),('5819','2013-09-18','12:00:00',3.74),('5819','2013-09-18','12:05:00',2.77),('5819','2013-09-18','12:10:00',3.77),('5819','2013-09-18','12:15:00',3.89),('5819','2013-09-18','12:20:00',3.64),('5819','2013-09-18','12:25:00',3.53),('5819','2013-09-18','12:30:00',3.6),('5819','2013-09-18','12:35:00',1.89),('5819','2013-09-18','12:40:00',4.12),('5819','2013-09-18','12:45:00',3.75),('5819','2013-09-18','12:50:00',3.86),('5819','2013-09-18','12:55:00',3.82),('5819','2013-09-18','13:00:00',3.86),('5819','2013-09-18','13:05:00',2.14),('5819','2013-09-18','13:10:00',3.81),('5819','2013-09-18','13:15:00',1.95),('5819','2013-09-18','13:20:00',3.85),('5819','2013-09-18','13:25:00',3.55),('5819','2013-09-18','13:30:00',3.74),('5819','2013-09-18','13:35:00',3.65),('5819','2013-09-18','13:40:00',3.58),('5819','2013-09-18','13:45:00',3.57),('5819','2013-09-18','13:50:00',3.31),('5819','2013-09-18','13:55:00',2.63),('5819','2013-09-18','14:00:00',3.6),('5819','2013-09-18','14:05:00',3.39),('5819','2013-09-18','14:10:00',3.44),('5819','2013-09-18','14:15:00',3.4),('5819','2013-09-18','14:20:00',3.37),('5819','2013-09-18','14:25:00',3.29),('5819','2013-09-18','14:30:00',3.21),('5819','2013-09-18','14:35:00',3.17),('5819','2013-09-18','14:40:00',3.15),('5819','2013-09-18','14:45:00',3.08),('5819','2013-09-18','14:50:00',3.05),('5819','2013-09-18','14:55:00',3.04),('5819','2013-09-18','15:00:00',2.93),('5819','2013-09-18','15:05:00',2.91),('5819','2013-09-18','15:10:00',1.46),('5819','2013-09-18','15:15:00',1.96),('5819','2013-09-18','15:20:00',2.87),('5819','2013-09-18','15:25:00',2.79),('5819','2013-09-18','15:30:00',2.74),('5819','2013-09-18','15:35:00',2.7),('5819','2013-09-18','15:40:00',2.67),('5819','2013-09-18','15:45:00',2.33),('5819','2013-09-18','15:50:00',1.77),('5819','2013-09-18','15:55:00',1.7),('5819','2013-09-18','16:00:00',1.74),('5819','2013-09-18','16:05:00',1.94),('5819','2013-09-18','16:10:00',2.27),('5819','2013-09-18','16:15:00',2.12),('5819','2013-09-18','16:20:00',1.98),('5819','2013-09-18','16:25:00',1.67),('5819','2013-09-18','16:30:00',1.55),('5819','2013-09-18','16:35:00',1.51),('5819','2013-09-18','16:40:00',1.48),('5819','2013-09-18','16:45:00',1.41),('5819','2013-09-18','16:50:00',1.26),('5819','2013-09-18','16:55:00',1.21),('5819','2013-09-18','17:00:00',1.24),('5819','2013-09-18','17:05:00',1.07),('5819','2013-09-18','17:10:00',1.06),('5819','2013-09-18','17:15:00',1),('5819','2013-09-17','09:20:00',1.09),('5819','2013-09-17','09:30:00',1),('5819','2013-09-17','09:40:00',1.33),('5819','2013-09-17','09:45:00',2.49),('5819','2013-09-17','09:50:00',1.52),('5819','2013-09-17','09:55:00',1.34),('5819','2013-09-17','10:00:00',2.21),('5819','2013-09-17','10:05:00',1.77),('5819','2013-09-17','10:10:00',2.01),('5819','2013-09-17','10:15:00',1.01),('5819','2013-09-17','10:25:00',2.06),('5819','2013-09-17','10:30:00',3.05),('5819','2013-09-17','10:35:00',1.65),('5819','2013-09-17','10:40:00',1.91),('5819','2013-09-17','10:45:00',2.36),('5819','2013-09-17','10:50:00',3.84),('5819','2013-09-17','10:55:00',2.74),('5819','2013-09-17','11:00:00',1.97),('5819','2013-09-17','11:05:00',1.53),('5819','2013-09-17','11:10:00',3.17),('5819','2013-09-17','11:15:00',2.74),('5819','2013-09-17','11:20:00',2.33),('5819','2013-09-17','11:25:00',1.79),('5819','2013-09-17','11:30:00',1.73),('5819','2013-09-17','11:35:00',3.16),('5819','2013-09-17','11:40:00',3.63),('5819','2013-09-17','11:45:00',3.57),('5819','2013-09-17','11:50:00',3.14),('5819','2013-09-17','11:55:00',2.83),('5819','2013-09-17','12:00:00',3.27),('5819','2013-09-17','12:05:00',3.19),('5819','2013-09-17','12:10:00',1.7),('5819','2013-09-17','12:15:00',2.2),('5819','2013-09-17','12:20:00',1.95),('5819','2013-09-17','12:25:00',3.78),('5819','2013-09-17','12:30:00',3.37),('5819','2013-09-17','12:35:00',1.99),('5819','2013-09-17','12:40:00',3.29),('5819','2013-09-17','12:45:00',3.27),('5819','2013-09-17','12:50:00',2.9),('5819','2013-09-17','12:55:00',2.13),('5819','2013-09-17','13:00:00',2.52),('5819','2013-09-17','13:05:00',1.36),('5819','2013-09-17','13:10:00',2.07),('5819','2013-09-17','13:15:00',3.11),('5819','2013-09-17','13:20:00',2.3),('5819','2013-09-17','13:25:00',2.01),('5819','2013-09-17','13:30:00',1.71),('5819','2013-09-17','13:35:00',1.6),('5819','2013-09-17','13:40:00',2.51),('5819','2013-09-17','13:45:00',1.83),('5819','2013-09-17','13:55:00',1.15),('5819','2013-09-17','14:00:00',1.54),('5819','2013-09-17','14:05:00',1.2),('5819','2013-09-17','14:15:00',1.36),('5819','2013-09-17','14:25:00',1.78),('5819','2013-09-17','14:35:00',1.02),('5819','2013-09-17','14:55:00',2.72),('5819','2013-09-17','15:00:00',3.07),('5819','2013-09-17','15:05:00',2.45),('5819','2013-09-17','15:10:00',2.36),('5819','2013-09-17','15:15:00',2.16),('5819','2013-09-17','15:20:00',2.46),('5819','2013-09-17','15:25:00',2.44),('5819','2013-09-17','15:30:00',2),('5819','2013-09-17','15:45:00',1.14),('5819','2013-09-17','15:50:00',1.65),('5819','2013-09-17','15:55:00',2.03),('5819','2013-09-17','16:00:00',1.19),('5819','2013-09-17','16:05:00',1.56),('5819','2013-09-17','16:10:00',1.49),('5819','2013-09-17','16:15:00',1.66),('5819','2013-09-17','16:20:00',1.01),('5819','2013-09-17','16:45:00',1.09),('5819','2013-09-17','16:50:00',1.04),('5819','2013-09-17','17:00:00',1.2),('5819','2013-09-17','17:05:00',1.25),('5819','2013-09-17','17:10:00',1.17),('5819','2013-09-17','17:15:00',1.24),('5819','2013-09-17','17:20:00',1.08),('5819','2013-09-17','17:25:00',1.02),('5819','2013-09-16','08:10:00',1.03),('5819','2013-09-16','08:15:00',1.3),('5819','2013-09-16','08:20:00',1.35),('5819','2013-09-16','08:25:00',1.42),('5819','2013-09-16','08:30:00',1.5),('5819','2013-09-16','08:35:00',1.6),('5819','2013-09-16','08:40:00',1.71),('5819','2013-09-16','08:45:00',1.1),('5819','2013-09-16','08:50:00',1.5),('5819','2013-09-16','08:55:00',1.3),('5819','2013-09-16','09:05:00',1.91),('5819','2013-09-16','09:10:00',2.37),('5819','2013-09-16','09:15:00',1.9),('5819','2013-09-16','09:20:00',1.94),('5819','2013-09-16','09:25:00',2.24),('5819','2013-09-16','09:30:00',2.26),('5819','2013-09-16','09:35:00',2.48),('5819','2013-09-16','09:40:00',2.53),('5819','2013-09-16','09:45:00',2.6),('5819','2013-09-16','09:50:00',2.67),('5819','2013-09-16','09:55:00',2.76),('5819','2013-09-16','10:00:00',2.83),('5819','2013-09-16','10:05:00',2.9),('5819','2013-09-16','10:10:00',3.04),('5819','2013-09-16','10:15:00',1.62),('5819','2013-09-16','10:20:00',2.09),('5819','2013-09-16','10:25:00',1.61),('5819','2013-09-16','10:30:00',2.79),('5819','2013-09-16','10:35:00',3.55),('5819','2013-09-16','10:40:00',3.25),('5819','2013-09-16','10:45:00',3.89),('5819','2013-09-16','10:50:00',1.87),('5819','2013-09-16','11:05:00',2.51),('5819','2013-09-16','11:10:00',2.24),('5819','2013-09-16','11:15:00',1.74),('5819','2013-09-16','11:20:00',2.4),('5819','2013-09-16','11:25:00',1.72),('5819','2013-09-16','11:30:00',3.74),('5819','2013-09-16','11:35:00',3.74),('5819','2013-09-16','11:40:00',3.78),('5819','2013-09-16','11:45:00',2.07),('5819','2013-09-16','11:50:00',2.66),('5819','2013-09-16','11:55:00',3.87),('5819','2013-09-16','12:00:00',3.9),('5819','2013-09-16','12:05:00',3.64),('5819','2013-09-16','12:10:00',3.08),('5819','2013-09-16','12:15:00',3.05),('5819','2013-09-16','12:20:00',3.85),('5819','2013-09-16','12:25:00',3.75),('5819','2013-09-16','12:30:00',3.72),('5819','2013-09-16','12:35:00',3.72),('5819','2013-09-16','12:40:00',3.82),('5819','2013-09-16','12:45:00',4.05),('5819','2013-09-16','12:50:00',2.67),('5819','2013-09-16','12:55:00',2.88),('5819','2013-09-16','13:00:00',2.36),('5819','2013-09-16','13:05:00',3.55),('5819','2013-09-16','13:10:00',3.48),('5819','2013-09-16','13:15:00',3.64),('5819','2013-09-16','13:20:00',3.71),('5819','2013-09-16','13:25:00',3.61),('5819','2013-09-16','13:30:00',3.54),('5819','2013-09-16','13:35:00',3.6),('5819','2013-09-16','13:40:00',3.59),('5819','2013-09-16','13:45:00',3.51),('5819','2013-09-16','13:50:00',3.51),('5819','2013-09-16','13:55:00',3.63),('5819','2013-09-16','14:00:00',3.53),('5819','2013-09-16','14:05:00',2.86),('5819','2013-09-16','14:10:00',3.39),('5819','2013-09-16','14:15:00',3.33),('5819','2013-09-16','14:20:00',3.27),('5819','2013-09-16','14:25:00',3.23),('5819','2013-09-16','14:30:00',3.2),('5819','2013-09-16','14:35:00',3.16),('5819','2013-09-16','14:40:00',3.1),('5819','2013-09-16','14:45:00',3.05),('5819','2013-09-16','14:50:00',3.02),('5819','2013-09-16','14:55:00',3),('5819','2013-09-16','15:00:00',2.93),('5819','2013-09-16','15:05:00',2.89),('5819','2013-09-16','15:10:00',2.85),('5819','2013-09-16','15:15:00',2.81),('5819','2013-09-16','15:20:00',2.75),('5819','2013-09-16','15:25:00',2.68),('5819','2013-09-16','15:30:00',2.62),('5819','2013-09-16','15:35:00',2.55),('5819','2013-09-16','15:40:00',2.5),('5819','2013-09-16','15:45:00',2.44),('5819','2013-09-16','15:50:00',2.37),('5819','2013-09-16','15:55:00',2.26),('5819','2013-09-16','16:00:00',2.23),('5819','2013-09-16','16:05:00',1.14),('5819','2013-09-16','16:10:00',2.02),('5819','2013-09-16','16:15:00',2.04),('5819','2013-09-16','16:20:00',1.95),('5819','2013-09-16','16:25:00',1.87),('5819','2013-09-16','16:30:00',1.79),('5819','2013-09-16','16:35:00',1.7),('5819','2013-09-16','16:40:00',1.62),('5819','2013-09-16','16:45:00',1.54),('5819','2013-09-16','16:50:00',1.46),('5819','2013-09-16','16:55:00',1.37),('5819','2013-09-16','17:00:00',1.29),('5819','2013-09-16','17:05:00',1.21),('5819','2013-09-16','17:10:00',1.14),('5819','2013-09-16','17:15:00',1.06),('5819','2013-09-15','08:00:00',1.04),('5819','2013-09-15','08:05:00',1.13),('5819','2013-09-15','08:10:00',1.23),('5819','2013-09-15','08:15:00',1.33),('5819','2013-09-15','08:20:00',1.41),('5819','2013-09-15','08:25:00',1.5),('5819','2013-09-15','08:30:00',1.59),('5819','2013-09-15','08:35:00',1.69),('5819','2013-09-15','08:40:00',1.8),('5819','2013-09-15','08:45:00',1.9),('5819','2013-09-15','08:50:00',1.91),('5819','2013-09-15','08:55:00',1.83),('5819','2013-09-15','09:00:00',1.98),('5819','2013-09-15','09:05:00',2.03),('5819','2013-09-15','09:10:00',2.19),('5819','2013-09-15','09:15:00',2.38),('5819','2013-09-15','09:20:00',2.3),('5819','2013-09-15','09:25:00',2.39),('5819','2013-09-15','09:30:00',2.45),('5819','2013-09-15','09:35:00',2.58),('5819','2013-09-15','09:40:00',2.62),('5819','2013-09-15','09:45:00',2.64),('5819','2013-09-15','09:50:00',2.73),('5819','2013-09-15','09:55:00',2.74),('5819','2013-09-15','10:00:00',2.87),('5819','2013-09-15','10:05:00',2.92),('5819','2013-09-15','10:10:00',2.93),('5819','2013-09-15','10:15:00',2.79),('5819','2013-09-15','10:20:00',2.92),('5819','2013-09-15','10:25:00',3),('5819','2013-09-15','10:30:00',2.81),('5819','2013-09-15','10:35:00',2.6),('5819','2013-09-15','10:40:00',1.55),('5819','2013-09-15','10:45:00',1.41),('5819','2013-09-15','10:55:00',2.26),('5819','2013-09-15','11:00:00',2.13),('5819','2013-09-15','11:05:00',3.65),('5819','2013-09-15','11:10:00',2.73),('5819','2013-09-15','11:15:00',1.5),('5819','2013-09-15','11:20:00',1.22),('5819','2013-09-15','11:25:00',1.34),('5819','2013-09-15','11:30:00',1.11),('5819','2013-09-15','11:35:00',2.62),('5819','2013-09-15','11:40:00',1.42),('5819','2013-09-15','11:45:00',1.14),('5819','2013-09-15','11:50:00',2.8),('5819','2013-09-15','11:55:00',1.93),('5819','2013-09-15','12:00:00',1.14),('5819','2013-09-15','12:05:00',1.07),('5819','2013-09-15','12:10:00',1.04),('5819','2013-09-15','12:15:00',1.02),('5819','2013-09-15','12:20:00',1.2),('5819','2013-09-15','12:25:00',1.52),('5819','2013-09-15','12:30:00',1.62),('5819','2013-09-15','12:35:00',1.49),('5819','2013-09-15','12:40:00',1.48),('5819','2013-09-15','12:45:00',1.12),('5819','2013-09-15','12:50:00',1.17),('5819','2013-09-15','12:55:00',1.21),('5819','2013-09-15','13:00:00',1.18),('5819','2013-09-15','13:05:00',1.12),('5819','2013-09-15','13:35:00',1.13),('5819','2013-09-15','13:40:00',1.33),('5819','2013-09-15','13:45:00',2.04),('5819','2013-09-15','13:50:00',2.29),('5819','2013-09-15','13:55:00',1.22),('5819','2013-09-15','14:00:00',1.55),('5819','2013-09-15','14:05:00',1.52),('5819','2013-09-15','14:10:00',1.38),('5819','2013-09-15','14:15:00',1.29),('5819','2013-09-15','14:20:00',1.15),('5819','2013-09-15','14:25:00',1.16),('5819','2013-09-15','14:30:00',1.18),('5819','2013-09-15','14:40:00',1.04),('5819','2013-09-15','15:00:00',1.02),('5819','2013-09-15','15:05:00',1.08),('5819','2013-09-15','15:10:00',1.18),('5819','2013-09-15','15:15:00',2.16),('5819','2013-09-15','15:20:00',1.93),('5819','2013-09-15','15:25:00',1.41),('5819','2013-09-15','15:30:00',1.06),('5819','2013-09-15','15:35:00',1),('5819','2013-09-14','08:05:00',1.08),('5819','2013-09-14','08:10:00',1.18),('5819','2013-09-14','08:15:00',1.26),('5819','2013-09-14','08:20:00',1.36),('5819','2013-09-14','08:25:00',1.43),('5819','2013-09-14','08:30:00',1.52),('5819','2013-09-14','08:35:00',1.62),('5819','2013-09-14','08:40:00',1.72),('5819','2013-09-14','08:45:00',1.81),('5819','2013-09-14','08:50:00',1.88),('5819','2013-09-14','08:55:00',1.96),('5819','2013-09-14','09:00:00',2.05),('5819','2013-09-14','09:05:00',2.12),('5819','2013-09-14','09:10:00',2.2),('5819','2013-09-14','09:15:00',2.27),('5819','2013-09-14','09:20:00',2.35),('5819','2013-09-14','09:25:00',2.41),('5819','2013-09-14','09:30:00',2.49),('5819','2013-09-14','09:35:00',2.53),('5819','2013-09-14','09:40:00',2.59),('5819','2013-09-14','09:45:00',2.66),('5819','2013-09-14','09:50:00',2.67),('5819','2013-09-14','09:55:00',2.78),('5819','2013-09-14','10:00:00',2.73),('5819','2013-09-14','10:05:00',1.95),('5819','2013-09-14','10:10:00',2.64),('5819','2013-09-14','10:15:00',2.69),('5819','2013-09-14','10:20:00',2.92),('5819','2013-09-14','10:25:00',3.06),('5819','2013-09-14','10:30:00',3.06),('5819','2013-09-14','10:35:00',3.15),('5819','2013-09-14','10:40:00',3.28),('5819','2013-09-14','10:45:00',3.44),('5819','2013-09-14','10:50:00',3.7),('5819','2013-09-14','10:55:00',3.48),('5819','2013-09-14','11:00:00',3.75),('5819','2013-09-14','11:05:00',2),('5819','2013-09-14','11:25:00',2.27),('5819','2013-09-14','11:30:00',3.78),('5819','2013-09-14','11:35:00',3.71),('5819','2013-09-14','11:40:00',3.83),('5819','2013-09-14','11:45:00',3.68),('5819','2013-09-14','11:50:00',3.49),('5819','2013-09-14','11:55:00',3.12),('5819','2013-09-14','12:00:00',1.72),('5819','2013-09-14','12:05:00',3.14),('5819','2013-09-14','12:10:00',1.88),('5819','2013-09-14','12:15:00',1.85),('5819','2013-09-14','12:20:00',1.56),('5819','2013-09-14','12:35:00',1.38),('5819','2013-09-14','12:40:00',2.63),('5819','2013-09-14','12:45:00',1.25),('5819','2013-09-14','12:55:00',1.05),('5819','2013-09-14','13:15:00',3.45),('5819','2013-09-14','13:20:00',3.94),('5819','2013-09-14','13:25:00',3.38),('5819','2013-09-14','13:30:00',3.95),('5819','2013-09-14','13:35:00',2.71),('5819','2013-09-14','13:40:00',1.34),('5819','2013-09-14','13:45:00',2.25),('5819','2013-09-14','13:50:00',2.13),('5819','2013-09-14','13:55:00',3.36),('5819','2013-09-14','14:00:00',3.91),('5819','2013-09-14','14:05:00',3.59),('5819','2013-09-14','14:10:00',3.48),('5819','2013-09-14','14:15:00',3.43),('5819','2013-09-14','14:20:00',3.41),('5819','2013-09-14','14:25:00',3.26),('5819','2013-09-14','14:30:00',3.31),('5819','2013-09-14','14:35:00',3.25),('5819','2013-09-14','14:40:00',3.2),('5819','2013-09-14','14:45:00',3.16),('5819','2013-09-14','14:50:00',3.1),('5819','2013-09-14','14:55:00',3.05),('5819','2013-09-14','15:00:00',2.98),('5819','2013-09-14','15:05:00',2.93),('5819','2013-09-14','15:10:00',2.85),('5819','2013-09-14','15:15:00',2.81),('5819','2013-09-14','15:20:00',2.75),('5819','2013-09-14','15:25:00',2.72),('5819','2013-09-14','15:30:00',2.67),('5819','2013-09-14','15:35:00',2.57),('5819','2013-09-14','15:40:00',2.54),('5819','2013-09-14','15:45:00',2.47),('5819','2013-09-14','15:50:00',2.38),('5819','2013-09-14','15:55:00',2.32),('5819','2013-09-14','16:00:00',2.24),('5819','2013-09-14','16:05:00',2.18),('5819','2013-09-14','16:10:00',2.08),('5819','2013-09-14','16:15:00',2),('5819','2013-09-14','16:20:00',1.95),('5819','2013-09-14','16:25:00',1.85),('5819','2013-09-14','16:30:00',1.81),('5819','2013-09-14','16:35:00',1.73),('5819','2013-09-14','16:40:00',1.65),('5819','2013-09-14','16:45:00',1.57),('5819','2013-09-14','16:50:00',1.49),('5819','2013-09-14','16:55:00',1.42),('5819','2013-09-14','17:00:00',1.34),('5819','2013-09-14','17:05:00',1.23),('5819','2013-09-14','17:10:00',1.2),('5819','2013-09-14','17:15:00',1.14),('5819','2013-09-14','17:20:00',1.04),('5819','2013-09-13','08:55:00',1.03),('5819','2013-09-13','09:25:00',1.05),('5819','2013-09-13','09:30:00',1.14),('5819','2013-09-13','09:35:00',1.27),('5819','2013-09-13','09:40:00',1.53),('5819','2013-09-13','09:45:00',1.41),('5819','2013-09-13','09:50:00',1.41),('5819','2013-09-13','09:55:00',1.87),('5819','2013-09-13','10:00:00',2.77),('5819','2013-09-13','10:05:00',1.62),('5819','2013-09-13','10:10:00',1.92),('5819','2013-09-13','10:15:00',3.68),('5819','2013-09-13','10:20:00',3.3),('5819','2013-09-13','10:25:00',1.72),('5819','2013-09-13','10:30:00',2.05),('5819','2013-09-13','10:35:00',3.52),('5819','2013-09-13','10:40:00',3.27),('5819','2013-09-13','10:45:00',3.27),('5819','2013-09-13','10:50:00',3.29),('5819','2013-09-13','10:55:00',3.31),('5819','2013-09-13','11:00:00',3.35),('5819','2013-09-13','11:05:00',3.39),('5819','2013-09-13','11:10:00',3.42),('5819','2013-09-13','11:15:00',3.46),('5819','2013-09-13','11:20:00',3.45),('5819','2013-09-13','11:25:00',3.49),('5819','2013-09-13','11:30:00',3.49),('5819','2013-09-13','11:35:00',3.52),('5819','2013-09-13','11:40:00',3.54),('5819','2013-09-13','11:45:00',3.56),('5819','2013-09-13','11:50:00',3.58),('5819','2013-09-13','11:55:00',3.58),('5819','2013-09-13','12:00:00',3.6),('5819','2013-09-13','12:05:00',3.64),('5819','2013-09-13','12:10:00',3.64),('5819','2013-09-13','12:15:00',3.67),('5819','2013-09-13','12:20:00',3.69),('5819','2013-09-13','12:25:00',3.71),('5819','2013-09-13','12:30:00',2.09),('5819','2013-09-13','12:35:00',3.76),('5819','2013-09-13','12:40:00',3.75),('5819','2013-09-13','12:45:00',3.73),('5819','2013-09-13','12:50:00',3.72),('5819','2013-09-13','12:55:00',3.66),('5819','2013-09-13','13:00:00',3.65),('5819','2013-09-13','13:05:00',3.65),('5819','2013-09-13','13:10:00',3.63),('5819','2013-09-13','13:15:00',3.61),('5819','2013-09-13','13:20:00',3.6),('5819','2013-09-13','13:25:00',3.57),('5819','2013-09-13','13:30:00',3.54),('5819','2013-09-13','13:35:00',3.49),('5819','2013-09-13','13:40:00',3.46),('5819','2013-09-13','13:45:00',3.45),('5819','2013-09-13','13:50:00',3.45),('5819','2013-09-13','13:55:00',3.4),('5819','2013-09-13','14:00:00',3.39),('5819','2013-09-13','14:05:00',3.38),('5819','2013-09-13','14:10:00',3.34),('5819','2013-09-13','14:15:00',3.3),('5819','2013-09-13','14:20:00',3.27),('5819','2013-09-13','14:25:00',3.25),('5819','2013-09-13','14:30:00',3.23),('5819','2013-09-13','14:35:00',3.19),('5819','2013-09-13','14:40:00',3.11),('5819','2013-09-13','14:45:00',3.09),('5819','2013-09-13','14:50:00',3.06),('5819','2013-09-13','14:55:00',3),('5819','2013-09-13','15:00:00',2.9),('5819','2013-09-13','15:05:00',2.88),('5819','2013-09-13','15:10:00',2.85),('5819','2013-09-13','15:15:00',2.84),('5819','2013-09-13','15:20:00',2.76),('5819','2013-09-13','15:25:00',2.71),('5819','2013-09-13','15:30:00',2.63),('5819','2013-09-13','15:35:00',2.59),('5819','2013-09-13','15:40:00',2.53),('5819','2013-09-13','15:45:00',2.47),('5819','2013-09-13','15:50:00',2.41),('5819','2013-09-13','15:55:00',2.35),('5819','2013-09-13','16:00:00',2.27),('5819','2013-09-13','16:05:00',2.21),('5819','2013-09-13','16:10:00',2.13),('5819','2013-09-13','16:15:00',2.06),('5819','2013-09-13','16:20:00',1.99),('5819','2013-09-13','16:25:00',1.91),('5819','2013-09-13','16:30:00',1.82),('5819','2013-09-13','16:35:00',1.75),('5819','2013-09-13','16:40:00',1.67),('5819','2013-09-13','16:45:00',1.59),('5819','2013-09-13','16:50:00',1.51),('5819','2013-09-13','16:55:00',1.42),('5819','2013-09-13','17:00:00',1.33),('5819','2013-09-13','17:05:00',1.25),('5819','2013-09-13','17:10:00',1.18),('5819','2013-09-13','17:15:00',1.1),('5819','2013-09-13','17:20:00',1.03),('5819','2013-09-12','08:00:00',1.11),('5819','2013-09-12','08:15:00',1.44),('5819','2013-09-12','08:20:00',1.46),('5819','2013-09-12','08:25:00',1.66),('5819','2013-09-12','08:30:00',1.81),('5819','2013-09-12','08:35:00',1.64),('5819','2013-09-12','08:55:00',1.67),('5819','2013-09-12','09:00:00',2.05),('5819','2013-09-12','09:05:00',1.92),('5819','2013-09-12','09:10:00',1.41),('5819','2013-09-12','09:15:00',2.1),('5819','2013-09-12','09:20:00',2.15),('5819','2013-09-12','09:25:00',2.4),('5819','2013-09-12','09:30:00',2.57),('5819','2013-09-12','09:35:00',2.32),('5819','2013-09-12','09:40:00',1.92),('5819','2013-09-12','09:45:00',2.37),('5819','2013-09-12','09:50:00',1.97),('5819','2013-09-12','09:55:00',1.36),('5819','2013-09-12','10:00:00',1.03),('5819','2013-09-12','10:05:00',1.3),('5819','2013-09-12','10:10:00',1.63),('5819','2013-09-12','10:15:00',1.54),('5819','2013-09-12','10:20:00',1.36),('5819','2013-09-12','10:30:00',1.46),('5819','2013-09-12','10:35:00',1.55),('5819','2013-09-12','10:55:00',1.68),('5819','2013-09-12','11:00:00',2.17),('5819','2013-09-12','11:05:00',3.49),('5819','2013-09-12','11:10:00',2.6),('5819','2013-09-12','11:15:00',2.94),('5819','2013-09-12','11:45:00',1.86),('5819','2013-09-12','11:50:00',1.47),('5819','2013-09-12','11:55:00',2.95),('5819','2013-09-12','12:00:00',3.2),('5819','2013-09-12','12:05:00',3.74),('5819','2013-09-12','12:10:00',3.51),('5819','2013-09-12','12:15:00',3.48),('5819','2013-09-12','12:20:00',1.58),('5819','2013-09-12','12:25:00',1.69),('5819','2013-09-12','12:30:00',1.71),('5819','2013-09-12','12:35:00',2.52),('5819','2013-09-12','12:40:00',3.83),('5819','2013-09-12','12:45:00',1.45),('5819','2013-09-12','12:50:00',2.81),('5819','2013-09-12','12:55:00',1.69),('5819','2013-09-12','13:00:00',3.75),('5819','2013-09-12','13:05:00',3.06),('5819','2013-09-12','13:10:00',2.81),('5819','2013-09-12','13:15:00',3.26),('5819','2013-09-12','13:20:00',3.76),('5819','2013-09-12','13:25:00',4.36),('5819','2013-09-12','13:30:00',3.86),('5819','2013-09-12','13:35:00',3.01),('5819','2013-09-12','13:40:00',2.79),('5819','2013-09-12','13:45:00',3.74),('5819','2013-09-12','13:50:00',3.83),('5819','2013-09-12','13:55:00',3.61),('5819','2013-09-12','14:00:00',3.5),('5819','2013-09-12','14:05:00',3.26),('5819','2013-09-12','14:10:00',2.71),('5819','2013-09-12','14:15:00',3.54),('5819','2013-09-12','14:20:00',3.26),('5819','2013-09-12','14:25:00',3.54),('5819','2013-09-12','14:30:00',3.49),('5819','2013-09-12','14:35:00',2.86),('5819','2013-09-12','14:40:00',2.49),('5819','2013-09-12','14:45:00',3.28),('5819','2013-09-12','14:50:00',3.19),('5819','2013-09-12','14:55:00',3.13),('5819','2013-09-12','15:00:00',3.08),('5819','2013-09-12','15:05:00',3.07),('5819','2013-09-12','15:10:00',2.33),('5819','2013-09-12','15:15:00',2.68),('5819','2013-09-12','15:20:00',2.85),('5819','2013-09-12','15:25:00',2.49),('5819','2013-09-12','15:30:00',2.74),('5819','2013-09-12','15:35:00',2.67),('5819','2013-09-12','15:40:00',2.55),('5819','2013-09-12','15:45:00',2.57),('5819','2013-09-12','15:50:00',2.46),('5819','2013-09-12','15:55:00',2.32),('5819','2013-09-12','16:00:00',2.35),('5819','2013-09-12','16:05:00',1.83),('5819','2013-09-12','16:10:00',1.9),('5819','2013-09-12','16:15:00',2.09),('5819','2013-09-12','16:20:00',1.47),('5819','2013-09-12','16:25:00',1.63),('5819','2013-09-12','16:35:00',1.07),('5819','2013-09-12','16:40:00',1.24),('5819','2013-09-12','16:45:00',1.88),('5819','2013-09-12','16:50:00',1.07),('5819','2013-09-12','16:55:00',1.37),('5819','2013-09-12','17:05:00',1.53),('5819','2013-09-12','17:10:00',1.09),('5819','2013-09-12','17:15:00',1.28),('5819','2013-09-12','17:20:00',1.05),('5819','2013-09-11','08:05:00',1.36),('5819','2013-09-11','08:10:00',1.23),('5819','2013-09-11','08:15:00',1.1),('5819','2013-09-11','08:55:00',1.02),('5819','2013-09-11','09:00:00',1.62),('5819','2013-09-11','09:05:00',2.29),('5819','2013-09-11','09:10:00',2.52),('5819','2013-09-11','09:15:00',2.06),('5819','2013-09-11','09:20:00',2.74),('5819','2013-09-11','09:25:00',1.97),('5819','2013-09-11','09:30:00',1.53),('5819','2013-09-11','09:35:00',1.38),('5819','2013-09-11','09:40:00',1.56),('5819','2013-09-11','10:05:00',1.67),('5819','2013-09-11','10:10:00',1.74),('5819','2013-09-11','10:15:00',1.78),('5819','2013-09-11','10:20:00',3.12),('5819','2013-09-11','10:25:00',1.95),('5819','2013-09-11','10:30:00',3.06),('5819','2013-09-11','10:35:00',2.86),('5819','2013-09-11','10:40:00',2.75),('5819','2013-09-11','10:45:00',1.5),('5819','2013-09-11','10:50:00',2.73),('5819','2013-09-11','10:55:00',1.75),('5819','2013-09-11','11:00:00',1.49),('5819','2013-09-11','11:05:00',2.17),('5819','2013-09-11','11:10:00',2.87),('5819','2013-09-11','11:15:00',2.6),('5819','2013-09-11','11:20:00',3.69),('5819','2013-09-11','11:25:00',3.08),('5819','2013-09-11','11:35:00',2.55),('5819','2013-09-11','11:40:00',2.58),('5819','2013-09-11','11:45:00',3.8),('5819','2013-09-11','11:50:00',3.82),('5819','2013-09-11','11:55:00',3.91),('5819','2013-09-11','12:00:00',2.11),('5819','2013-09-11','12:05:00',3.79),('5819','2013-09-11','12:10:00',2.79),('5819','2013-09-11','12:15:00',2.28),('5819','2013-09-11','12:20:00',2.96),('5819','2013-09-11','12:25:00',2.8),('5819','2013-09-11','12:30:00',3.61),('5819','2013-09-11','12:35:00',3.42),('5819','2013-09-11','12:40:00',1.31),('5819','2013-09-11','12:45:00',1.41),('5819','2013-09-11','12:50:00',3.3),('5819','2013-09-11','12:55:00',3.58),('5819','2013-09-11','13:00:00',3.03),('5819','2013-09-11','13:05:00',3.66),('5819','2013-09-11','13:10:00',3.85),('5819','2013-09-11','13:15:00',4.03),('5819','2013-09-11','13:20:00',3.45),('5819','2013-09-11','13:25:00',3.65),('5819','2013-09-11','13:30:00',3.45),('5819','2013-09-11','13:35:00',1.88),('5819','2013-09-11','13:40:00',2.78),('5819','2013-09-11','13:45:00',1.66),('5819','2013-09-11','13:50:00',3.32),('5819','2013-09-11','13:55:00',2.76),('5819','2013-09-11','14:00:00',2.39),('5819','2013-09-11','14:05:00',3.71),('5819','2013-09-11','14:10:00',3.45),('5819','2013-09-11','14:15:00',3.56),('5819','2013-09-11','14:20:00',2.08),('5819','2013-09-11','14:25:00',3.49),('5819','2013-09-11','14:30:00',2.16),('5819','2013-09-11','14:35:00',3.21),('5819','2013-09-11','14:40:00',1.43),('5819','2013-09-11','14:45:00',2.79),('5819','2013-09-11','14:50:00',3.43),('5819','2013-09-11','14:55:00',3.14),('5819','2013-09-11','15:00:00',1.47),('5819','2013-09-11','15:05:00',3.29),('5819','2013-09-11','15:10:00',1.49),('5819','2013-09-11','15:15:00',3.04),('5819','2013-09-11','15:20:00',2.27),('5819','2013-09-11','15:25:00',2.84),('5819','2013-09-11','15:30:00',2.56),('5819','2013-09-11','15:35:00',1.43),('5819','2013-09-11','15:40:00',1.24),('5819','2013-09-11','15:45:00',2.49),('5819','2013-09-11','15:50:00',2.63),('5819','2013-09-11','15:55:00',1.89),('5819','2013-09-11','16:00:00',2.08),('5819','2013-09-11','16:05:00',2.47),('5819','2013-09-11','16:10:00',2.12),('5819','2013-09-11','16:15:00',2.22),('5819','2013-09-11','16:20:00',2.1),('5819','2013-09-11','16:25:00',1.98),('5819','2013-09-11','16:30:00',1.14),('5819','2013-09-11','16:35:00',1.6),('5819','2013-09-11','16:45:00',1.81),('5819','2013-09-11','16:50:00',1.6),('5819','2013-09-11','16:55:00',1.45),('5819','2013-09-11','17:00:00',1.32),('5819','2013-09-11','17:05:00',1.33),('5819','2013-09-11','17:10:00',1.24),('5819','2013-09-11','17:15:00',1.14),('5819','2013-09-11','17:20:00',1.06),('5819','2013-09-10','08:55:00',1.48),('5819','2013-09-10','09:00:00',1.94),('5819','2013-09-10','09:05:00',1.86),('5819','2013-09-10','09:10:00',2.43),('5819','2013-09-10','09:15:00',2.07),('5819','2013-09-10','09:20:00',1.6),('5819','2013-09-10','09:25:00',1.62),('5819','2013-09-10','09:30:00',2.54),('5819','2013-09-10','09:35:00',2.85),('5819','2013-09-10','09:40:00',1.54),('5819','2013-09-10','09:45:00',1.31),('5819','2013-09-10','09:50:00',1.18),('5819','2013-09-10','09:55:00',1.05),('5819','2013-09-10','10:35:00',1.03),('5819','2013-09-10','10:40:00',1.38),('5819','2013-09-10','10:45:00',1.98),('5819','2013-09-10','10:50:00',1.25),('5819','2013-09-10','10:55:00',1.17),('5819','2013-09-10','11:00:00',1.48),('5819','2013-09-10','11:05:00',1.27),('5819','2013-09-10','11:10:00',1.31),('5819','2013-09-10','11:15:00',1.13),('5819','2013-09-10','11:20:00',1.21),('5819','2013-09-10','11:25:00',1.55),('5819','2013-09-10','11:30:00',1.06),('5819','2013-09-10','11:45:00',1.25),('5819','2013-09-10','11:50:00',1.25),('5819','2013-09-10','11:55:00',1.62),('5819','2013-09-10','12:00:00',1.37),('5819','2013-09-10','12:05:00',1.07),('5819','2013-09-10','13:25:00',1),('5819','2013-09-10','13:40:00',1.59),('5819','2013-09-10','13:45:00',2.52),('5819','2013-09-10','13:50:00',1.71),('5819','2013-09-10','13:55:00',1.47),('5819','2013-09-10','14:00:00',1.03),('5819','2013-09-10','14:05:00',1.21),('5819','2013-09-10','14:10:00',1.22),('5819','2013-09-10','14:15:00',1.47),('5819','2013-09-10','14:20:00',1.49),('5819','2013-09-10','14:25:00',1.94),('5819','2013-09-10','14:30:00',1.87),('5819','2013-09-10','14:35:00',1.35),('5819','2013-09-10','14:40:00',1.59),('5819','2013-09-10','14:45:00',1.68),('5819','2013-09-10','14:50:00',1.9),('5819','2013-09-10','14:55:00',1.79),('5819','2013-09-10','15:00:00',2.08),('5819','2013-09-10','15:05:00',2.02),('5819','2013-09-10','15:10:00',1.55),('5819','2013-09-10','15:15:00',1.35),('5819','2013-09-10','15:20:00',1.8),('5819','2013-09-10','15:25:00',1.6),('5819','2013-09-10','15:30:00',1.8),('5819','2013-09-10','15:35:00',1.71),('5819','2013-09-10','15:40:00',1.1),('5819','2013-09-10','16:05:00',1.06),('5819','2013-09-10','16:10:00',1.13),('5819','2013-09-10','16:15:00',1.3),('5819','2013-09-09','07:50:00',1.05),('5819','2013-09-09','08:55:00',1.15),('5819','2013-09-09','09:00:00',1.26),('5819','2013-09-09','09:05:00',1.1),('5819','2013-09-09','09:40:00',1),('5819','2013-09-09','10:00:00',1.08),('5819','2013-09-09','10:05:00',1.63),('5819','2013-09-09','10:10:00',1.73),('5819','2013-09-09','10:15:00',1.7),('5819','2013-09-09','10:20:00',1.27),('5819','2013-09-09','10:25:00',1.15),('5819','2013-09-09','10:30:00',1.28),('5819','2013-09-09','10:35:00',1.62),('5819','2013-09-09','10:40:00',1.72),('5819','2013-09-09','10:45:00',1.88),('5819','2013-09-09','10:50:00',2.47),('5819','2013-09-09','10:55:00',2.41),('5819','2013-09-09','11:00:00',2.63),('5819','2013-09-09','11:05:00',2.02),('5819','2013-09-09','11:10:00',1.63),('5819','2013-09-09','11:15:00',1.99),('5819','2013-09-09','11:20:00',2.36),('5819','2013-09-09','11:25:00',2.64),('5819','2013-09-09','11:30:00',2.08),('5819','2013-09-09','11:35:00',2.01),('5819','2013-09-09','11:40:00',3.11),('5819','2013-09-09','11:45:00',3.22),('5819','2013-09-09','11:50:00',2.47),('5819','2013-09-09','11:55:00',3.02),('5819','2013-09-09','12:00:00',2.69),('5819','2013-09-09','12:05:00',3.01),('5819','2013-09-09','12:10:00',2.83),('5819','2013-09-09','12:15:00',2.13),('5819','2013-09-09','12:20:00',1.65),('5819','2013-09-09','12:25:00',1.21),('5819','2013-09-09','12:30:00',1.11),('5819','2013-09-09','12:40:00',1.15),('5819','2013-09-09','12:45:00',1.58),('5819','2013-09-09','12:50:00',1.23),('5819','2013-09-09','12:55:00',1.34),('5819','2013-09-09','13:00:00',1.27),('5819','2013-09-09','13:05:00',2.08),('5819','2013-09-09','13:10:00',2.49),('5819','2013-09-09','13:15:00',3.09),('5819','2013-09-09','13:20:00',2.48),('5819','2013-09-09','13:25:00',2.23),('5819','2013-09-09','13:30:00',2.66),('5819','2013-09-09','13:35:00',3.3),('5819','2013-09-09','13:40:00',3.3),('5819','2013-09-09','13:45:00',3.39),('5819','2013-09-09','13:50:00',3.63),('5819','2013-09-09','13:55:00',3.67),('5819','2013-09-09','14:00:00',3.32),('5819','2013-09-09','14:05:00',3.13),('5819','2013-09-09','14:10:00',3.43),('5819','2013-09-09','14:15:00',2.55),('5819','2013-09-09','14:20:00',1.86),('5819','2013-09-09','14:25:00',1.69),('5819','2013-09-09','14:30:00',1.6),('5819','2013-09-09','14:35:00',3.39),('5819','2013-09-09','14:40:00',3.25),('5819','2013-09-09','14:45:00',1.84),('5819','2013-09-09','14:50:00',2.88),('5819','2013-09-09','14:55:00',2.86),('5819','2013-09-09','15:00:00',2.4),('5819','2013-09-09','15:05:00',2.24),('5819','2013-09-09','15:10:00',2.53),('5819','2013-09-09','15:15:00',1.44),('5819','2013-09-09','15:20:00',1.77),('5819','2013-09-09','15:25:00',1.01),('5819','2013-09-09','15:30:00',2.51),('5819','2013-09-09','15:35:00',2.02),('5819','2013-09-09','15:40:00',2.16),('5819','2013-09-09','15:45:00',1.04),('5819','2013-09-09','15:50:00',1.03),('5819','2013-09-09','15:55:00',1.15),('5819','2013-09-09','16:00:00',1.26),('5819','2013-09-09','16:05:00',1.13),('5819','2013-09-09','16:10:00',1.32),('5819','2013-09-09','16:15:00',1.81),('5819','2013-09-09','16:20:00',1.48),('5819','2013-09-09','16:35:00',1.03),('5819','2013-09-09','16:40:00',1.2),('5819','2013-09-09','16:45:00',1.87),('5819','2013-09-08','09:10:00',1),('5819','2013-09-08','09:15:00',1.14),('5819','2013-09-08','09:20:00',1.41),('5819','2013-09-08','09:25:00',1.49),('5819','2013-09-08','09:30:00',2.08),('5819','2013-09-08','09:35:00',2.47),('5819','2013-09-08','09:40:00',2.41),('5819','2013-09-08','09:45:00',2.4),('5819','2013-09-08','09:50:00',2.5),('5819','2013-09-08','09:55:00',2.56),('5819','2013-09-08','10:00:00',2.58),('5819','2013-09-08','10:05:00',2.65),('5819','2013-09-08','10:10:00',2.7),('5819','2013-09-08','10:15:00',2.73),('5819','2013-09-08','10:20:00',2.83),('5819','2013-09-08','10:25:00',2.89),('5819','2013-09-08','10:30:00',2.91),('5819','2013-09-08','10:35:00',2.96),('5819','2013-09-08','10:40:00',2.93),('5819','2013-09-08','10:45:00',3.01),('5819','2013-09-08','10:50:00',3.04),('5819','2013-09-08','10:55:00',3.1),('5819','2013-09-08','11:00:00',3.14),('5819','2013-09-08','11:05:00',3.12),('5819','2013-09-08','11:10:00',3.11),('5819','2013-09-08','11:15:00',3.13),('5819','2013-09-08','11:20:00',3.12),('5819','2013-09-08','11:25:00',3.11),('5819','2013-09-08','11:30:00',3.18),('5819','2013-09-08','11:35:00',3.16),('5819','2013-09-08','11:40:00',3.19),('5819','2013-09-08','11:45:00',3.21),('5819','2013-09-08','11:50:00',3.16),('5819','2013-09-08','11:55:00',3.16),('5819','2013-09-08','12:00:00',3.13),('5819','2013-09-08','12:05:00',3.13),('5819','2013-09-08','12:10:00',3.18),('5819','2013-09-08','12:15:00',3.27),('5819','2013-09-08','12:20:00',3.33),('5819','2013-09-08','12:25:00',3.23),('5819','2013-09-08','12:30:00',3.25),('5819','2013-09-08','12:35:00',3.35),('5819','2013-09-08','12:40:00',3.24),('5819','2013-09-08','12:45:00',3.16),('5819','2013-09-08','12:50:00',3.21),('5819','2013-09-08','12:55:00',3.25),('5819','2013-09-08','13:00:00',3.21),('5819','2013-09-08','13:05:00',3.26),('5819','2013-09-08','13:10:00',3.3),('5819','2013-09-08','13:15:00',3.19),('5819','2013-09-08','13:20:00',3.14),('5819','2013-09-08','13:25:00',3.01),('5819','2013-09-08','13:30:00',2.81),('5819','2013-09-08','13:35:00',2.87),('5819','2013-09-08','13:40:00',2.23),('5819','2013-09-08','13:45:00',1.88),('5819','2013-09-08','13:50:00',2.14),('5819','2013-09-08','13:55:00',2.29),('5819','2013-09-08','14:00:00',2.87),('5819','2013-09-08','14:05:00',2.93),('5819','2013-09-08','14:10:00',3.05),('5819','2013-09-08','14:15:00',2.84),('5819','2013-09-08','14:20:00',2.57),('5819','2013-09-08','14:25:00',3.38),('5819','2013-09-08','14:30:00',2.91),('5819','2013-09-08','14:35:00',3.18),('5819','2013-09-08','14:40:00',3.02),('5819','2013-09-08','14:45:00',3.01),('5819','2013-09-08','14:50:00',2.96),('5819','2013-09-08','14:55:00',2.86),('5819','2013-09-08','15:00:00',2.84),('5819','2013-09-08','15:05:00',2.45),('5819','2013-09-08','15:10:00',1.5),('5819','2013-09-08','15:15:00',2.14),('5819','2013-09-08','15:20:00',2.65),('5819','2013-09-08','15:25:00',2.71),('5819','2013-09-08','15:30:00',2.7),('5819','2013-09-08','15:35:00',2.59),('5819','2013-09-08','15:40:00',2.38),('5819','2013-09-08','15:45:00',2.38),('5819','2013-09-08','15:50:00',2.41),('5819','2013-09-08','15:55:00',1.94),('5819','2013-09-08','16:00:00',1.95),('5819','2013-09-08','16:05:00',1.89),('5819','2013-09-08','16:10:00',1.79),('5819','2013-09-08','16:15:00',1.87),('5819','2013-09-08','16:20:00',1.81),('5819','2013-09-08','16:25:00',1.8),('5819','2013-09-08','16:30:00',1.65),('5819','2013-09-08','16:35:00',1.65),('5819','2013-09-08','16:40:00',1.43),('5819','2013-09-08','17:05:00',1.43),('5819','2013-09-08','17:10:00',1.36),('5819','2013-09-08','17:15:00',1.22),('5819','2013-09-08','17:20:00',1.06),('5819','2013-09-08','17:25:00',1),('5819','2013-09-07','08:00:00',1),('5819','2013-09-07','08:05:00',1.09),('5819','2013-09-07','08:10:00',1.17),('5819','2013-09-07','08:15:00',1.26),('5819','2013-09-07','08:20:00',1.34),('5819','2013-09-07','08:25:00',1.42),('5819','2013-09-07','08:30:00',1.49),('5819','2013-09-07','08:35:00',1.57),('5819','2013-09-07','08:40:00',1.67),('5819','2013-09-07','08:45:00',1.74),('5819','2013-09-07','08:50:00',1.81),('5819','2013-09-07','08:55:00',1.87),('5819','2013-09-07','09:00:00',1.95),('5819','2013-09-07','09:05:00',2.03),('5819','2013-09-07','09:10:00',2.11),('5819','2013-09-07','09:15:00',2.18),('5819','2013-09-07','09:20:00',2.22),('5819','2013-09-07','09:25:00',2.29),('5819','2013-09-07','09:30:00',2.38),('5819','2013-09-07','09:35:00',2.42),('5819','2013-09-07','09:40:00',2.47),('5819','2013-09-07','09:45:00',2.54),('5819','2013-09-07','09:50:00',2.57),('5819','2013-09-07','09:55:00',2.63),('5819','2013-09-07','10:00:00',2.68),('5819','2013-09-07','10:05:00',2.72),('5819','2013-09-07','10:10:00',2.77),('5819','2013-09-07','10:15:00',2.77),('5819','2013-09-07','10:20:00',2.84),('5819','2013-09-07','10:25:00',2.9),('5819','2013-09-07','10:30:00',2.93),('5819','2013-09-07','10:35:00',2.96),('5819','2013-09-07','10:40:00',3),('5819','2013-09-07','10:45:00',3.03),('5819','2013-09-07','10:50:00',3.07),('5819','2013-09-07','10:55:00',3.08),('5819','2013-09-07','11:00:00',3.1),('5819','2013-09-07','11:05:00',3.12),('5819','2013-09-07','11:10:00',3.17),('5819','2013-09-07','11:15:00',3.23),('5819','2013-09-07','11:20:00',3.24),('5819','2013-09-07','11:25:00',3.32),('5819','2013-09-07','11:30:00',3.34),('5819','2013-09-07','11:35:00',3.34),('5819','2013-09-07','11:40:00',3.34),('5819','2013-09-07','11:45:00',3.38),('5819','2013-09-07','11:50:00',3.37),('5819','2013-09-07','11:55:00',3.35),('5819','2013-09-07','12:00:00',3.35),('5819','2013-09-07','12:05:00',3.38),('5819','2013-09-07','12:10:00',3.41),('5819','2013-09-07','12:15:00',3.39),('5819','2013-09-07','12:20:00',3.39),('5819','2013-09-07','12:25:00',3.42),('5819','2013-09-07','12:30:00',3.38),('5819','2013-09-07','12:35:00',3.4),('5819','2013-09-07','12:40:00',3.38),('5819','2013-09-07','12:45:00',3.33),('5819','2013-09-07','12:50:00',3.42),('5819','2013-09-07','12:55:00',3.42),('5819','2013-09-07','13:00:00',3.42),('5819','2013-09-07','13:05:00',3.38),('5819','2013-09-07','13:10:00',3.37),('5819','2013-09-07','13:15:00',3.34),('5819','2013-09-07','13:20:00',3.33),('5819','2013-09-07','13:25:00',3.29),('5819','2013-09-07','13:30:00',3.29),('5819','2013-09-07','13:35:00',3.28),('5819','2013-09-07','13:40:00',3.36),('5819','2013-09-07','13:45:00',3.33),('5819','2013-09-07','13:50:00',3.31),('5819','2013-09-07','13:55:00',3.25),('5819','2013-09-07','14:00:00',1.84),('5819','2013-09-07','14:05:00',3.23),('5819','2013-09-07','14:10:00',3.25),('5819','2013-09-07','14:15:00',3.24),('5819','2013-09-07','14:20:00',3.15),('5819','2013-09-07','14:25:00',3.06),('5819','2013-09-07','14:30:00',3.06),('5819','2013-09-07','14:35:00',3.07),('5819','2013-09-07','14:40:00',3.03),('5819','2013-09-07','14:45:00',3.02),('5819','2013-09-07','14:50:00',2.96),('5819','2013-09-07','14:55:00',2.9),('5819','2013-09-07','15:00:00',2.89),('5819','2013-09-07','15:05:00',2.85),('5819','2013-09-07','15:10:00',2.76),('5819','2013-09-07','15:15:00',2.73),('5819','2013-09-07','15:20:00',2.68),('5819','2013-09-07','15:25:00',2.62),('5819','2013-09-07','15:30:00',2.57),('5819','2013-09-07','15:35:00',2.52),('5819','2013-09-07','15:40:00',2.44),('5819','2013-09-07','15:45:00',2.37),('5819','2013-09-07','15:50:00',2.32),('5819','2013-09-07','15:55:00',2.26),('5819','2013-09-07','16:00:00',2.2),('5819','2013-09-07','16:05:00',2.13),('5819','2013-09-07','16:10:00',2.06),('5819','2013-09-07','16:15:00',1.99),('5819','2013-09-07','16:20:00',1.91),('5819','2013-09-07','16:25:00',1.83),('5819','2013-09-07','16:30:00',1.77),('5819','2013-09-07','16:35:00',1.7),('5819','2013-09-07','16:40:00',1.63),('5819','2013-09-07','16:45:00',1.55),('5819','2013-09-07','16:50:00',1.47),('5819','2013-09-07','16:55:00',1.41),('5819','2013-09-07','17:00:00',1.33),('5819','2013-09-07','17:05:00',1.26),('5819','2013-09-07','17:10:00',1.19),('5819','2013-09-07','17:15:00',1.11),('5819','2013-09-07','17:20:00',1.04),('5819','2013-09-06','08:00:00',1.02),('5819','2013-09-06','08:05:00',1.12),('5819','2013-09-06','08:10:00',1.2),('5819','2013-09-06','08:15:00',1.28),('5819','2013-09-06','08:20:00',1.36),('5819','2013-09-06','08:25:00',1.44),('5819','2013-09-06','08:30:00',1.54),('5819','2013-09-06','08:35:00',1.62),('5819','2013-09-06','08:40:00',1.71),('5819','2013-09-06','08:45:00',1.8),('5819','2013-09-06','08:50:00',1.87),('5819','2013-09-06','08:55:00',1.93),('5819','2013-09-06','09:00:00',2.01),('5819','2013-09-06','09:05:00',2.09),('5819','2013-09-06','09:10:00',2.16),('5819','2013-09-06','09:15:00',2.22),('5819','2013-09-06','09:20:00',2.27),('5819','2013-09-06','09:25:00',2.32),('5819','2013-09-06','09:30:00',2.39),('5819','2013-09-06','09:35:00',2.45),('5819','2013-09-06','09:40:00',2.51),('5819','2013-09-06','09:45:00',2.57),('5819','2013-09-06','09:50:00',2.63),('5819','2013-09-06','09:55:00',2.67),('5819','2013-09-06','10:00:00',2.71),('5819','2013-09-06','10:05:00',2.77),('5819','2013-09-06','10:10:00',2.82),('5819','2013-09-06','10:15:00',2.85),('5819','2013-09-06','10:20:00',2.9),('5819','2013-09-06','10:25:00',2.95),('5819','2013-09-06','10:30:00',3.01),('5819','2013-09-06','10:35:00',3.03),('5819','2013-09-06','10:40:00',3.06),('5819','2013-09-06','10:45:00',3.09),('5819','2013-09-06','10:50:00',3.14),('5819','2013-09-06','10:55:00',3.18),('5819','2013-09-06','11:00:00',3.19),('5819','2013-09-06','11:05:00',3.2),('5819','2013-09-06','11:10:00',3.24),('5819','2013-09-06','11:15:00',3.28),('5819','2013-09-06','11:20:00',3.3),('5819','2013-09-06','11:25:00',3.29),('5819','2013-09-06','11:30:00',3.31),('5819','2013-09-06','11:35:00',3.33),('5819','2013-09-06','11:40:00',3.38),('5819','2013-09-06','11:45:00',3.37),('5819','2013-09-06','11:50:00',3.41),('5819','2013-09-06','11:55:00',3.42),('5819','2013-09-06','12:00:00',3.41),('5819','2013-09-06','12:05:00',3.41),('5819','2013-09-06','12:10:00',3.41),('5819','2013-09-06','12:15:00',3.44),('5819','2013-09-06','12:20:00',3.45),('5819','2013-09-06','12:25:00',3.46),('5819','2013-09-06','12:30:00',3.49),('5819','2013-09-06','12:35:00',3.5),('5819','2013-09-06','12:40:00',3.44),('5819','2013-09-06','12:45:00',3.4),('5819','2013-09-06','12:50:00',3.43),('5819','2013-09-06','12:55:00',3.46),('5819','2013-09-06','13:00:00',3.44),('5819','2013-09-06','13:05:00',3.42),('5819','2013-09-06','13:10:00',3.41),('5819','2013-09-06','13:15:00',3.39),('5819','2013-09-06','13:20:00',3.37),('5819','2013-09-06','13:25:00',3.34),('5819','2013-09-06','13:30:00',3.32),('5819','2013-09-06','13:35:00',3.32),('5819','2013-09-06','13:40:00',3.34),('5819','2013-09-06','13:45:00',3.29),('5819','2013-09-06','13:50:00',3.25),('5819','2013-09-06','13:55:00',3.22),('5819','2013-09-06','14:00:00',3.2),('5819','2013-09-06','14:05:00',3.16),('5819','2013-09-06','14:10:00',3.16),('5819','2013-09-06','14:15:00',3.16),('5819','2013-09-06','14:20:00',3.13),('5819','2013-09-06','14:25:00',3.1),('5819','2013-09-06','14:30:00',3.04),('5819','2013-09-06','14:35:00',2.98),('5819','2013-09-06','14:40:00',2.83),('5819','2013-09-06','14:45:00',2.88),('5819','2013-09-06','14:50:00',2.92),('5819','2013-09-06','14:55:00',2.9),('5819','2013-09-06','15:00:00',2.83),('5819','2013-09-06','15:05:00',2.77),('5819','2013-09-06','15:10:00',2.73),('5819','2013-09-06','15:15:00',2.69),('5819','2013-09-06','15:20:00',2.64),('5819','2013-09-06','15:25:00',2.59),('5819','2013-09-06','15:30:00',2.56),('5819','2013-09-06','15:35:00',2.49),('5819','2013-09-06','15:40:00',2.43),('5819','2013-09-06','15:45:00',2.38),('5819','2013-09-06','15:50:00',2.32),('5819','2013-09-06','15:55:00',2.28),('5819','2013-09-06','16:00:00',2.2),('5819','2013-09-06','16:05:00',2.12),('5819','2013-09-06','16:10:00',2.05),('5819','2013-09-06','16:15:00',1.99),('5819','2013-09-06','16:20:00',1.93),('5819','2013-09-06','16:25:00',1.88),('5819','2013-09-06','16:30:00',1.81),('5819','2013-09-06','16:35:00',1.73),('5819','2013-09-06','16:40:00',1.66),('5819','2013-09-06','16:45:00',1.6),('5819','2013-09-06','16:50:00',1.5),('5819','2013-09-06','16:55:00',1.44),('5819','2013-09-06','17:00:00',1.37),('5819','2013-09-06','17:05:00',1.27),('5819','2013-09-06','17:10:00',1.21),('5819','2013-09-06','17:15:00',1.13),('5819','2013-09-06','17:20:00',1.06),('5819','2013-09-05','07:50:00',1.01),('5819','2013-09-05','07:55:00',1.09),('5819','2013-09-05','08:00:00',1.17),('5819','2013-09-05','08:05:00',1.26),('5819','2013-09-05','08:10:00',1.34),('5819','2013-09-05','08:15:00',1.44),('5819','2013-09-05','08:20:00',1.54),('5819','2013-09-05','08:25:00',1.63),('5819','2013-09-05','08:30:00',1.71),('5819','2013-09-05','08:35:00',1.79),('5819','2013-09-05','08:40:00',1.87),('5819','2013-09-05','08:45:00',1.95),('5819','2013-09-05','08:50:00',2.03),('5819','2013-09-05','08:55:00',2.09),('5819','2013-09-05','09:00:00',2.16),('5819','2013-09-05','09:05:00',2.23),('5819','2013-09-05','09:10:00',2.29),('5819','2013-09-05','09:15:00',2.36),('5819','2013-09-05','09:20:00',2.43),('5819','2013-09-05','09:25:00',2.48),('5819','2013-09-05','09:30:00',2.55),('5819','2013-09-05','09:35:00',2.59),('5819','2013-09-05','09:40:00',2.65),('5819','2013-09-05','09:45:00',2.71),('5819','2013-09-05','09:50:00',2.77),('5819','2013-09-05','09:55:00',2.82),('5819','2013-09-05','10:00:00',2.88),('5819','2013-09-05','10:05:00',2.91),('5819','2013-09-05','10:10:00',2.95),('5819','2013-09-05','10:15:00',2.99),('5819','2013-09-05','10:20:00',3.03),('5819','2013-09-05','10:25:00',3.07),('5819','2013-09-05','10:30:00',3.11),('5819','2013-09-05','10:35:00',3.14),('5819','2013-09-05','10:40:00',3.18),('5819','2013-09-05','10:45:00',3.2),('5819','2013-09-05','10:50:00',3.23),('5819','2013-09-05','10:55:00',3.27),('5819','2013-09-05','11:00:00',3.28),('5819','2013-09-05','11:05:00',3.32),('5819','2013-09-05','11:10:00',3.34),('5819','2013-09-05','11:15:00',3.36),('5819','2013-09-05','11:20:00',3.39),('5819','2013-09-05','11:25:00',3.41),('5819','2013-09-05','11:30:00',3.42),('5819','2013-09-05','11:35:00',3.4),('5819','2013-09-05','11:40:00',3.38),('5819','2013-09-05','11:45:00',3.38),('5819','2013-09-05','11:50:00',3.48),('5819','2013-09-05','11:55:00',3.5),('5819','2013-09-05','12:00:00',3.49),('5819','2013-09-05','12:05:00',3.52),('5819','2013-09-05','12:10:00',3.52),('5819','2013-09-05','12:15:00',3.53),('5819','2013-09-05','12:20:00',3.52),('5819','2013-09-05','12:25:00',3.53),('5819','2013-09-05','12:30:00',3.5),('5819','2013-09-05','12:35:00',3.49),('5819','2013-09-05','12:40:00',3.52),('5819','2013-09-05','12:45:00',3.51),('5819','2013-09-05','12:50:00',3.51),('5819','2013-09-05','12:55:00',3.52),('5819','2013-09-05','13:00:00',3.52),('5819','2013-09-05','13:05:00',3.5),('5819','2013-09-05','13:10:00',3.49),('5819','2013-09-05','13:15:00',3.47),('5819','2013-09-05','13:20:00',3.46),('5819','2013-09-05','13:25:00',3.45),('5819','2013-09-05','13:30:00',3.42),('5819','2013-09-05','13:35:00',3.45),('5819','2013-09-05','13:40:00',3.45),('5819','2013-09-05','13:45:00',3.4),('5819','2013-09-05','13:50:00',3.36),('5819','2013-09-05','13:55:00',3.32),('5819','2013-09-05','14:00:00',3.28),('5819','2013-09-05','14:05:00',3.26),('5819','2013-09-05','14:10:00',3.25),('5819','2013-09-05','14:15:00',3.25),('5819','2013-09-05','14:20:00',3.21),('5819','2013-09-05','14:25:00',3.15),('5819','2013-09-05','14:30:00',3.09),('5819','2013-09-05','14:35:00',3.04),('5819','2013-09-05','14:40:00',2.97),('5819','2013-09-05','14:45:00',2.94),('5819','2013-09-05','14:50:00',2.91),('5819','2013-09-05','14:55:00',2.9),('5819','2013-09-05','15:00:00',2.89),('5819','2013-09-05','15:05:00',2.87),('5819','2013-09-05','15:10:00',2.84),('5819','2013-09-05','15:15:00',2.79),('5819','2013-09-05','15:20:00',2.75),('5819','2013-09-05','15:25:00',2.7),('5819','2013-09-05','15:30:00',2.64),('5819','2013-09-05','15:35:00',2.58),('5819','2013-09-05','15:40:00',2.5),('5819','2013-09-05','15:45:00',2.45),('5819','2013-09-05','15:50:00',2.38),('5819','2013-09-05','15:55:00',2.34),('5819','2013-09-05','16:00:00',2.29),('5819','2013-09-05','16:05:00',2.24),('5819','2013-09-05','16:10:00',2.16),('5819','2013-09-05','16:15:00',2.1),('5819','2013-09-05','16:20:00',2.04),('5819','2013-09-05','16:25:00',1.97),('5819','2013-09-05','16:30:00',1.9),('5819','2013-09-05','16:35:00',1.85),('5819','2013-09-05','16:40:00',1.8),('5819','2013-09-05','16:45:00',1.76),('5819','2013-09-05','16:50:00',1.57),('5819','2013-09-05','16:55:00',1.25),('5819','2013-09-05','17:10:00',1.04),('5819','2013-09-05','17:25:00',1.02),('5819','2013-09-05','17:35:00',1),('5819','2013-09-05','17:40:00',1.05),('5819','2013-09-04','07:50:00',1),('5819','2013-09-04','07:55:00',1.09),('5819','2013-09-04','08:00:00',1.18),('5819','2013-09-04','08:05:00',1.26),('5819','2013-09-04','08:10:00',1.34),('5819','2013-09-04','08:15:00',1.43),('5819','2013-09-04','08:20:00',1.53),('5819','2013-09-04','08:25:00',1.61),('5819','2013-09-04','08:30:00',1.69),('5819','2013-09-04','08:35:00',1.77),('5819','2013-09-04','08:40:00',1.84),('5819','2013-09-04','08:45:00',1.93),('5819','2013-09-04','08:50:00',2.01),('5819','2013-09-04','08:55:00',2.08),('5819','2013-09-04','09:00:00',2.16),('5819','2013-09-04','09:05:00',2.23),('5819','2013-09-04','09:10:00',2.31),('5819','2013-09-04','09:15:00',2.39),('5819','2013-09-04','09:20:00',2.47),('5819','2013-09-04','09:25:00',2.55),('5819','2013-09-04','09:30:00',2.62),('5819','2013-09-04','09:35:00',2.69),('5819','2013-09-04','09:40:00',2.75),('5819','2013-09-04','09:45:00',2.81),('5819','2013-09-04','09:50:00',2.87),('5819','2013-09-04','09:55:00',2.93),('5819','2013-09-04','10:00:00',2.98),('5819','2013-09-04','10:05:00',3.03),('5819','2013-09-04','10:10:00',3.07),('5819','2013-09-04','10:15:00',3.1),('5819','2013-09-04','10:20:00',3.14),('5819','2013-09-04','10:25:00',3.18),('5819','2013-09-04','10:30:00',3.23),('5819','2013-09-04','10:35:00',3.28),('5819','2013-09-04','10:40:00',3.31),('5819','2013-09-04','10:45:00',3.35),('5819','2013-09-04','10:50:00',3.38),('5819','2013-09-04','10:55:00',3.42),('5819','2013-09-04','11:00:00',3.44),('5819','2013-09-04','11:05:00',3.47),('5819','2013-09-04','11:10:00',3.49),('5819','2013-09-04','11:15:00',3.51),('5819','2013-09-04','11:20:00',3.53),('5819','2013-09-04','11:25:00',3.55),('5819','2013-09-04','11:30:00',3.56),('5819','2013-09-04','11:35:00',3.59),('5819','2013-09-04','11:40:00',3.62),('5819','2013-09-04','11:45:00',3.63),('5819','2013-09-04','11:50:00',3.66),('5819','2013-09-04','11:55:00',3.67),('5819','2013-09-04','12:00:00',3.68),('5819','2013-09-04','12:05:00',3.69),('5819','2013-09-04','12:10:00',3.68),('5819','2013-09-04','12:15:00',3.66),('5819','2013-09-04','12:20:00',3.3),('5819','2013-09-04','12:25:00',3.68),('5819','2013-09-04','12:30:00',3.68),('5819','2013-09-04','12:35:00',3.7),('5819','2013-09-04','12:40:00',3.7),('5819','2013-09-04','12:45:00',3.67),('5819','2013-09-04','12:50:00',3.67),('5819','2013-09-04','12:55:00',3.67),('5819','2013-09-04','13:00:00',3.63),('5819','2013-09-04','13:05:00',3.61),('5819','2013-09-04','13:10:00',3.62),('5819','2013-09-04','13:15:00',3.6),('5819','2013-09-04','13:20:00',3.61),('5819','2013-09-04','13:25:00',3.6),('5819','2013-09-04','13:30:00',3.59),('5819','2013-09-04','13:35:00',3.57),('5819','2013-09-04','13:40:00',3.55),('5819','2013-09-04','13:45:00',3.52),('5819','2013-09-04','13:50:00',3.5),('5819','2013-09-04','13:55:00',3.48),('5819','2013-09-04','14:00:00',3.44),('5819','2013-09-04','14:05:00',3.44),('5819','2013-09-04','14:10:00',3.43),('5819','2013-09-04','14:15:00',3.41),('5819','2013-09-04','14:20:00',3.35),('5819','2013-09-04','14:25:00',3.32),('5819','2013-09-04','14:30:00',3.28),('5819','2013-09-04','14:35:00',3.23),('5819','2013-09-04','14:40:00',3.19),('5819','2013-09-04','14:45:00',3.15),('5819','2013-09-04','14:50:00',3.11),('5819','2013-09-04','14:55:00',3.07),('5819','2013-09-04','15:00:00',3),('5819','2013-09-04','15:05:00',2.97),('5819','2013-09-04','15:10:00',2.91),('5819','2013-09-04','15:15:00',2.87),('5819','2013-09-04','15:20:00',2.82),('5819','2013-09-04','15:25:00',2.76),('5819','2013-09-04','15:30:00',2.7),('5819','2013-09-04','15:35:00',2.65),('5819','2013-09-04','15:40:00',2.58),('5819','2013-09-04','15:45:00',2.52),('5819','2013-09-04','15:50:00',2.46),('5819','2013-09-04','15:55:00',2.4),('5819','2013-09-04','16:00:00',2.32),('5819','2013-09-04','16:05:00',2.25),('5819','2013-09-04','16:10:00',2.19),('5819','2013-09-04','16:15:00',2.13),('5819','2013-09-04','16:20:00',2.05),('5819','2013-09-04','16:25:00',1.98),('5819','2013-09-04','16:30:00',1.91),('5819','2013-09-04','16:35:00',1.83),('5819','2013-09-04','16:40:00',1.75),('5819','2013-09-04','16:45:00',1.68),('5819','2013-09-04','16:50:00',1.6),('5819','2013-09-04','16:55:00',1.52),('5819','2013-09-04','17:00:00',1.44),('5819','2013-09-04','17:05:00',1.36),('5819','2013-09-04','17:10:00',1.28),('5819','2013-09-04','17:15:00',1.21),('5819','2013-09-04','17:20:00',1.13),('5819','2013-09-04','17:25:00',1.06),('5819','2013-09-02','08:00:00',1.04),('5819','2013-09-02','08:05:00',1.13),('5819','2013-09-02','08:10:00',1.21),('5819','2013-09-02','08:15:00',1.3),('5819','2013-09-02','08:20:00',1.39),('5819','2013-09-02','08:25:00',1.46),('5819','2013-09-02','08:30:00',1.54),('5819','2013-09-02','08:35:00',1.64),('5819','2013-09-02','08:40:00',1.73),('5819','2013-09-02','08:45:00',1.81),('5819','2013-09-02','08:50:00',1.88),('5819','2013-09-02','08:55:00',1.97),('5819','2013-09-02','09:00:00',2.05),('5819','2013-09-02','09:05:00',2.12),('5819','2013-09-02','09:10:00',2.2),('5819','2013-09-02','09:15:00',2.28),('5819','2013-09-02','09:20:00',2.34),('5819','2013-09-02','09:25:00',2.41),('5819','2013-09-02','09:30:00',2.48),('5819','2013-09-02','09:35:00',2.55),('5819','2013-09-02','09:40:00',2.61),('5819','2013-09-02','09:45:00',2.66),('5819','2013-09-02','09:50:00',2.72),('5819','2013-09-02','09:55:00',2.76),('5819','2013-09-02','10:00:00',2.8),('5819','2013-09-02','10:05:00',2.88),('5819','2013-09-02','10:10:00',2.93),('5819','2013-09-02','10:15:00',3),('5819','2013-09-02','10:20:00',3.03),('5819','2013-09-02','10:25:00',3.07),('5819','2013-09-02','10:30:00',3.1),('5819','2013-09-02','10:35:00',3.15),('5819','2013-09-02','10:40:00',3.17),('5819','2013-09-02','10:45:00',3.19),('5819','2013-09-02','10:50:00',3.22),('5819','2013-09-02','10:55:00',3.25),('5819','2013-09-02','11:00:00',3.29),('5819','2013-09-02','11:05:00',3.31),('5819','2013-09-02','11:10:00',3.36),('5819','2013-09-02','11:15:00',3.39),('5819','2013-09-02','11:20:00',3.4),('5819','2013-09-02','11:25:00',3.4),('5819','2013-09-02','11:30:00',3.43),('5819','2013-09-02','11:35:00',3.43),('5819','2013-09-02','11:40:00',3.45),('5819','2013-09-02','11:45:00',3.47),('5819','2013-09-02','11:50:00',3.48),('5819','2013-09-02','11:55:00',3.48),('5819','2013-09-02','12:00:00',3.51),('5819','2013-09-02','12:05:00',3.54),('5819','2013-09-02','12:10:00',3.55),('5819','2013-09-02','12:15:00',3.53),('5819','2013-09-02','12:20:00',3.54),('5819','2013-09-02','12:25:00',3.53),('5819','2013-09-02','12:30:00',3.53),('5819','2013-09-02','12:35:00',3.53),('5819','2013-09-02','12:40:00',3.51),('5819','2013-09-02','12:45:00',3.49),('5819','2013-09-02','12:50:00',3.53),('5819','2013-09-02','12:55:00',3.52),('5819','2013-09-02','13:00:00',3.54),('5819','2013-09-02','13:05:00',3.53),('5819','2013-09-02','13:10:00',3.51),('5819','2013-09-02','13:15:00',3.52),('5819','2013-09-02','13:20:00',3.5),('5819','2013-09-02','13:25:00',3.48),('5819','2013-09-02','13:30:00',3.44),('5819','2013-09-02','13:35:00',3.4),('5819','2013-09-02','13:40:00',3.33),('5819','2013-09-02','13:45:00',3.29),('5819','2013-09-02','13:50:00',3),('5819','2013-09-02','13:55:00',3.43),('5819','2013-09-02','14:00:00',3.38),('5819','2013-09-02','14:05:00',2.92),('5819','2013-09-02','14:10:00',2.98),('5819','2013-09-02','14:15:00',3.34),('5819','2013-09-02','14:20:00',3.28),('5819','2013-09-02','14:25:00',3.28),('5819','2013-09-02','14:30:00',3.26),('5819','2013-09-02','14:35:00',3.2),('5819','2013-09-02','14:40:00',3.21),('5819','2013-09-02','14:45:00',3.22),('5819','2013-09-02','14:50:00',3.18),('5819','2013-09-02','14:55:00',1.89),('5819','2013-09-02','15:00:00',2.96),('5819','2013-09-02','15:05:00',2.92),('5819','2013-09-02','15:10:00',2.86),('5819','2013-09-02','15:15:00',2.91),('5819','2013-09-02','15:20:00',1.67),('5819','2013-09-02','15:25:00',2.75),('5819','2013-09-02','15:30:00',1.56),('5819','2013-09-02','15:35:00',1.46),('5819','2013-09-02','15:40:00',2.71),('5819','2013-09-02','15:45:00',2.61),('5819','2013-09-02','15:50:00',2.57),('5819','2013-09-02','15:55:00',2.5),('5819','2013-09-02','16:00:00',2.38),('5819','2013-09-02','16:05:00',2.27),('5819','2013-09-02','16:10:00',2.23),('5819','2013-09-02','16:15:00',2.22),('5819','2013-09-02','16:20:00',2.18),('5819','2013-09-02','16:25:00',2.09),('5819','2013-09-02','16:30:00',2.01),('5819','2013-09-02','16:35:00',1.91),('5819','2013-09-02','16:40:00',1.8),('5819','2013-09-02','16:45:00',1.71),('5819','2013-09-02','16:50:00',1.6),('5819','2013-09-02','16:55:00',1.52),('5819','2013-09-02','17:00:00',1.42),('5819','2013-09-02','17:05:00',1.36),('5819','2013-09-02','17:10:00',1.3),('5819','2013-09-02','17:15:00',1.22),('5819','2013-09-02','17:20:00',1.15),('5819','2013-09-02','17:25:00',1.07),('5819','2013-09-01','07:55:00',1.05),('5819','2013-09-01','08:00:00',1.14),('5819','2013-09-01','08:05:00',1.23),('5819','2013-09-01','08:10:00',1.32),('5819','2013-09-01','08:15:00',1.4),('5819','2013-09-01','08:20:00',1.48),('5819','2013-09-01','08:25:00',1.56),('5819','2013-09-01','08:30:00',1.59),('5819','2013-09-01','08:35:00',1.72),('5819','2013-09-01','08:40:00',1.82),('5819','2013-09-01','08:45:00',1.89),('5819','2013-09-01','08:50:00',1.96),('5819','2013-09-01','08:55:00',2.04),('5819','2013-09-01','09:00:00',2.11),('5819','2013-09-01','09:05:00',2.17),('5819','2013-09-01','09:10:00',2.25),('5819','2013-09-01','09:15:00',2.32),('5819','2013-09-01','09:20:00',2.39),('5819','2013-09-01','09:25:00',2.45),('5819','2013-09-01','09:30:00',2.52),('5819','2013-09-01','09:35:00',2.59),('5819','2013-09-01','09:40:00',2.65),('5819','2013-09-01','09:45:00',2.7),('5819','2013-09-01','09:50:00',2.76),('5819','2013-09-01','09:55:00',2.8),('5819','2013-09-01','10:00:00',2.85),('5819','2013-09-01','10:05:00',2.89),('5819','2013-09-01','10:10:00',2.93),('5819','2013-09-01','10:15:00',2.97),('5819','2013-09-01','10:20:00',3.01),('5819','2013-09-01','10:25:00',3.06),('5819','2013-09-01','10:30:00',3.1),('5819','2013-09-01','10:35:00',3.13),('5819','2013-09-01','10:40:00',3.17),('5819','2013-09-01','10:45:00',3.22),('5819','2013-09-01','10:50:00',3.24),('5819','2013-09-01','10:55:00',3.28),('5819','2013-09-01','11:00:00',3.32),('5819','2013-09-01','11:05:00',3.35),('5819','2013-09-01','11:10:00',3.38),('5819','2013-09-01','11:15:00',3.39),('5819','2013-09-01','11:20:00',3.4),('5819','2013-09-01','11:25:00',3.41),('5819','2013-09-01','11:30:00',3.46),('5819','2013-09-01','11:35:00',3.47),('5819','2013-09-01','11:40:00',3.51),('5819','2013-09-01','11:45:00',3.52),('5819','2013-09-01','11:50:00',3.55),('5819','2013-09-01','11:55:00',3.57),('5819','2013-09-01','12:00:00',3.57),('5819','2013-09-01','12:05:00',3.51),('5819','2013-09-01','12:10:00',3.56),('5819','2013-09-01','12:15:00',3.57),('5819','2013-09-01','12:20:00',3.61),('5819','2013-09-01','12:25:00',3.55),('5819','2013-09-01','12:30:00',3.58),('5819','2013-09-01','12:35:00',3.55),('5819','2013-09-01','12:40:00',3.57),('5819','2013-09-01','12:45:00',3.56),('5819','2013-09-01','12:50:00',3.54),('5819','2013-09-01','12:55:00',3.52),('5819','2013-09-01','13:00:00',3.53),('5819','2013-09-01','13:05:00',3.47),('5819','2013-09-01','13:10:00',3.49),('5819','2013-09-01','13:15:00',3.39),('5819','2013-09-01','13:20:00',3.52),('5819','2013-09-01','13:25:00',3.5),('5819','2013-09-01','13:30:00',3.52),('5819','2013-09-01','13:35:00',3.49),('5819','2013-09-01','13:40:00',3.48),('5819','2013-09-01','13:45:00',3.37),('5819','2013-09-01','13:50:00',2.93),('5819','2013-09-01','13:55:00',3.15),('5819','2013-09-01','14:00:00',2.69),('5819','2013-09-01','14:05:00',2.7),('5819','2013-09-01','14:10:00',3.06),('5819','2013-09-01','14:15:00',3.12),('5819','2013-09-01','14:20:00',2.75),('5819','2013-09-01','14:25:00',2.82),('5819','2013-09-01','14:30:00',2.88),('5819','2013-09-01','14:35:00',2.86),('5819','2013-09-01','14:40:00',2.85),('5819','2013-09-01','14:45:00',2.9),('5819','2013-09-01','14:50:00',2.88),('5819','2013-09-01','14:55:00',2.77),('5819','2013-09-01','15:00:00',2.76),('5819','2013-09-01','15:05:00',2.73),('5819','2013-09-01','15:10:00',2.69),('5819','2013-09-01','15:15:00',2.56),('5819','2013-09-01','15:20:00',2.46),('5819','2013-09-01','15:25:00',2.27),('5819','2013-09-01','15:30:00',1.83),('5819','2013-09-01','15:35:00',2.04),('5819','2013-09-01','15:40:00',2.31),('5819','2013-09-01','15:45:00',2.19),('5819','2013-09-01','15:50:00',1.74),('5819','2013-09-01','15:55:00',1.77),('5819','2013-09-01','16:00:00',2.11),('5819','2013-09-01','16:05:00',2.15),('5819','2013-09-01','16:10:00',2.28),('5819','2013-09-01','16:15:00',2.18),('5819','2013-09-01','16:20:00',2.1),('5819','2013-09-01','16:25:00',1.97),('5819','2013-09-01','16:30:00',2.13),('5819','2013-09-01','16:35:00',2),('5819','2013-09-01','16:40:00',1.93),('5819','2013-09-01','16:45:00',1.82),('5819','2013-09-01','16:50:00',1.71),('5819','2013-09-01','16:55:00',1.55),('5819','2013-09-01','17:00:00',1.31),('5819','2013-09-01','17:05:00',1.22),('5819','2013-09-01','17:10:00',1.13),('5819','2013-09-01','17:15:00',1.07),('5819','2013-09-01','17:20:00',1.15),('5819','2013-09-01','17:25:00',1.11),('5819','2013-09-01','17:30:00',1),('5819','2013-08-31','08:20:00',1.24),('5819','2013-08-31','08:25:00',1.41),('5819','2013-08-31','08:30:00',1.68),('5819','2013-08-31','08:35:00',1.76),('5819','2013-08-31','08:40:00',1.87),('5819','2013-08-31','08:45:00',1.98),('5819','2013-08-31','08:50:00',2.14),('5819','2013-08-31','08:55:00',2.29),('5819','2013-08-31','09:00:00',2.41),('5819','2013-08-31','09:05:00',2.17),('5819','2013-08-31','09:10:00',1.78),('5819','2013-08-31','09:15:00',2.11),('5819','2013-08-31','09:20:00',2.41),('5819','2013-08-31','09:25:00',2.62),('5819','2013-08-31','09:30:00',2.65),('5819','2013-08-31','09:35:00',2.73),('5819','2013-08-31','09:40:00',2.76),('5819','2013-08-31','09:45:00',2.6),('5819','2013-08-31','09:50:00',2.67),('5819','2013-08-31','09:55:00',2.86),('5819','2013-08-31','10:00:00',3),('5819','2013-08-31','10:05:00',2.95),('5819','2013-08-31','10:10:00',3.08),('5819','2013-08-31','10:15:00',3.07),('5819','2013-08-31','10:20:00',3.13),('5819','2013-08-31','10:25:00',3.17),('5819','2013-08-31','10:30:00',3.23),('5819','2013-08-31','10:35:00',3.29),('5819','2013-08-31','10:40:00',3.3),('5819','2013-08-31','10:45:00',3.36),('5819','2013-08-31','10:50:00',3.42),('5819','2013-08-31','10:55:00',3.46),('5819','2013-08-31','11:00:00',3.51),('5819','2013-08-31','11:05:00',3.53),('5819','2013-08-31','11:10:00',3.55),('5819','2013-08-31','11:15:00',3.57),('5819','2013-08-31','11:20:00',3.6),('5819','2013-08-31','11:25:00',3.62),('5819','2013-08-31','11:30:00',3.64),('5819','2013-08-31','11:35:00',3.68),('5819','2013-08-31','11:40:00',3.69),('5819','2013-08-31','11:45:00',3.68),('5819','2013-08-31','11:50:00',3.69),('5819','2013-08-31','11:55:00',3.73),('5819','2013-08-31','12:00:00',3.74),('5819','2013-08-31','12:05:00',3.51),('5819','2013-08-31','12:10:00',3.73),('5819','2013-08-31','12:15:00',3.72),('5819','2013-08-31','12:20:00',3.65),('5819','2013-08-31','12:25:00',3.68),('5819','2013-08-31','12:30:00',3.69),('5819','2013-08-31','12:35:00',3.66),('5819','2013-08-31','12:40:00',3.66),('5819','2013-08-31','12:45:00',3.65),('5819','2013-08-31','12:50:00',3.63),('5819','2013-08-31','12:55:00',3.68),('5819','2013-08-31','13:00:00',3.64),('5819','2013-08-31','13:05:00',3.65),('5819','2013-08-31','13:10:00',3.61),('5819','2013-08-31','13:15:00',3.58),('5819','2013-08-31','13:20:00',3.59),('5819','2013-08-31','13:25:00',3.59),('5819','2013-08-31','13:30:00',3.56),('5819','2013-08-31','13:35:00',3.57),('5819','2013-08-31','13:40:00',3.55),('5819','2013-08-31','13:45:00',3.48),('5819','2013-08-31','13:50:00',3.48),('5819','2013-08-31','13:55:00',3.44),('5819','2013-08-31','14:00:00',3.45),('5819','2013-08-31','14:05:00',3.43),('5819','2013-08-31','14:10:00',3.39),('5819','2013-08-31','14:15:00',3.35),('5819','2013-08-31','14:20:00',3.27),('5819','2013-08-31','14:25:00',3.25),('5819','2013-08-31','14:30:00',3.22),('5819','2013-08-31','14:35:00',3.06),('5819','2013-08-31','14:40:00',3.1),('5819','2013-08-31','14:45:00',3.06),('5819','2013-08-31','14:50:00',3.04),('5819','2013-08-31','14:55:00',2.97),('5819','2013-08-31','15:00:00',2.94),('5819','2013-08-31','15:05:00',2.93),('5819','2013-08-31','15:10:00',2.88),('5819','2013-08-31','15:15:00',2.81),('5819','2013-08-31','15:20:00',2.75),('5819','2013-08-31','15:25:00',2.68),('5819','2013-08-31','15:30:00',2.65),('5819','2013-08-31','15:35:00',2.56),('5819','2013-08-31','15:40:00',2.54),('5819','2013-08-31','15:45:00',2.5),('5819','2013-08-31','15:50:00',2.43),('5819','2013-08-31','15:55:00',2.35),('5819','2013-08-31','16:00:00',2.31),('5819','2013-08-31','16:05:00',2.26),('5819','2013-08-31','16:10:00',2.19),('5819','2013-08-31','16:15:00',2.13),('5819','2013-08-31','16:20:00',2.05),('5819','2013-08-31','16:25:00',1.99),('5819','2013-08-31','16:30:00',1.89),('5819','2013-08-31','16:35:00',1.88),('5819','2013-08-31','16:40:00',1.79),('5819','2013-08-31','16:45:00',1.68),('5819','2013-08-31','16:50:00',1.61),('5819','2013-08-31','16:55:00',1.55),('5819','2013-08-31','17:00:00',1.47),('5819','2013-08-31','17:05:00',1.43),('5819','2013-08-31','17:10:00',1.37),('5819','2013-08-31','17:15:00',1.27),('5819','2013-08-31','17:20:00',1.18),('5819','2013-08-31','17:25:00',1.1),('5819','2013-08-30','08:00:00',1.1),('5819','2013-08-30','08:05:00',1.35),('5819','2013-08-30','08:10:00',1.47),('5819','2013-08-30','08:15:00',1.36),('5819','2013-08-30','08:20:00',1.45),('5819','2013-08-30','08:25:00',1.47),('5819','2013-08-30','08:30:00',1.52),('5819','2013-08-30','08:35:00',1.56),('5819','2013-08-30','08:40:00',1.6),('5819','2013-08-30','08:45:00',1.43),('5819','2013-08-30','08:50:00',1.28),('5819','2013-08-30','08:55:00',1.27),('5819','2013-08-30','09:00:00',1.47),('5819','2013-08-30','09:05:00',1.61),('5819','2013-08-30','09:10:00',1.41),('5819','2013-08-30','09:15:00',1.3),('5819','2013-08-30','09:20:00',1.18),('5819','2013-08-30','09:25:00',1.24),('5819','2013-08-30','09:30:00',1.64),('5819','2013-08-30','09:35:00',1.72),('5819','2013-08-30','09:40:00',1.77),('5819','2013-08-30','09:45:00',1.8),('5819','2013-08-30','09:50:00',1.79),('5819','2013-08-30','09:55:00',1.87),('5819','2013-08-30','10:00:00',1.91),('5819','2013-08-30','10:05:00',1.86),('5819','2013-08-30','10:10:00',1.88),('5819','2013-08-30','10:15:00',1.99),('5819','2013-08-30','10:20:00',2.1),('5819','2013-08-30','10:25:00',1.91),('5819','2013-08-30','10:30:00',2.14),('5819','2013-08-30','10:35:00',2.03),('5819','2013-08-30','10:40:00',1.93),('5819','2013-08-30','10:45:00',1.85),('5819','2013-08-30','10:50:00',1.97),('5819','2013-08-30','10:55:00',1.88),('5819','2013-08-30','11:00:00',1.94),('5819','2013-08-30','11:05:00',2.08),('5819','2013-08-30','11:10:00',2.18),('5819','2013-08-30','11:15:00',2.22),('5819','2013-08-30','11:20:00',2.21),('5819','2013-08-30','11:25:00',2.3),('5819','2013-08-30','11:30:00',2.17),('5819','2013-08-30','11:35:00',2.32),('5819','2013-08-30','11:40:00',2.51),('5819','2013-08-30','11:45:00',2.44),('5819','2013-08-30','11:50:00',2.87),('5819','2013-08-30','11:55:00',2.48),('5819','2013-08-30','12:00:00',2.25),('5819','2013-08-30','12:05:00',1.9),('5819','2013-08-30','12:10:00',2.08),('5819','2013-08-30','12:15:00',2.27),('5819','2013-08-30','12:20:00',2.42),('5819','2013-08-30','12:25:00',2.81),('5819','2013-08-30','12:30:00',3.06),('5819','2013-08-30','12:35:00',2.93),('5819','2013-08-30','12:40:00',2.81),('5819','2013-08-30','12:45:00',2.91),('5819','2013-08-30','12:50:00',2.84),('5819','2013-08-30','12:55:00',2.66),('5819','2013-08-30','13:00:00',2.58),('5819','2013-08-30','13:05:00',2.53),('5819','2013-08-30','13:10:00',2.57),('5819','2013-08-30','13:15:00',2.65),('5819','2013-08-30','13:20:00',2.95),('5819','2013-08-30','13:25:00',3.35),('5819','2013-08-30','13:30:00',3.59),('5819','2013-08-30','13:35:00',3.33),('5819','2013-08-30','13:40:00',3.52),('5819','2013-08-30','13:45:00',3.22),('5819','2013-08-30','13:50:00',3.18),('5819','2013-08-30','13:55:00',3.43),('5819','2013-08-30','14:00:00',3.52),('5819','2013-08-30','14:05:00',3.39),('5819','2013-08-30','14:10:00',3.41),('5819','2013-08-30','14:15:00',3.32),('5819','2013-08-30','14:20:00',3.36),('5819','2013-08-30','14:25:00',3.34),('5819','2013-08-30','14:30:00',3.3),('5819','2013-08-30','14:35:00',3.31),('5819','2013-08-30','14:40:00',3.18),('5819','2013-08-30','14:45:00',2.68),('5819','2013-08-30','14:50:00',2.19),('5819','2013-08-30','14:55:00',2.51),('5819','2013-08-30','15:00:00',2.2),('5819','2013-08-30','15:05:00',2.03),('5819','2013-08-30','15:10:00',1.97),('5819','2013-08-30','15:15:00',2.47),('5819','2013-08-30','15:20:00',2.18),('5819','2013-08-30','15:25:00',1.96),('5819','2013-08-30','15:30:00',1.77),('5819','2013-08-30','15:35:00',1.56),('5819','2013-08-30','15:40:00',1.64),('5819','2013-08-30','15:45:00',1.9),('5819','2013-08-30','15:50:00',2.02),('5819','2013-08-30','15:55:00',1.98),('5819','2013-08-30','16:00:00',1.87),('5819','2013-08-30','16:05:00',1.66),('5819','2013-08-30','16:10:00',1.39),('5819','2013-08-30','16:15:00',1.27),('5819','2013-08-30','16:20:00',1.4),('5819','2013-08-30','16:25:00',1.42),('5819','2013-08-30','16:30:00',1.46),('5819','2013-08-30','16:35:00',1.75),('5819','2013-08-30','16:40:00',1.36),('5819','2013-08-30','16:45:00',1.6),('5819','2013-08-30','16:50:00',1.83),('5819','2013-08-30','16:55:00',1.55),('5819','2013-08-30','17:00:00',1.2),('5819','2013-08-30','17:05:00',1.08),('5819','2013-08-30','17:10:00',1.3),('5819','2013-08-30','17:15:00',1.11),('5819','2013-08-30','17:35:00',1.07),('5819','2013-08-29','07:50:00',1.05),('5819','2013-08-29','07:55:00',1.14),('5819','2013-08-29','08:00:00',1.25),('5819','2013-08-29','08:05:00',1.32),('5819','2013-08-29','08:10:00',1.42),('5819','2013-08-29','08:15:00',1.52),('5819','2013-08-29','08:20:00',1.68),('5819','2013-08-29','08:25:00',1.85),('5819','2013-08-29','08:30:00',2.06),('5819','2013-08-29','08:35:00',1.99),('5819','2013-08-29','08:40:00',1.49),('5819','2013-08-29','08:45:00',1.06),('5819','2013-08-29','08:50:00',1.25),('5819','2013-08-29','08:55:00',1.59),('5819','2013-08-29','09:00:00',1.61),('5819','2013-08-29','09:05:00',1.56),('5819','2013-08-29','09:10:00',1.5),('5819','2013-08-29','09:15:00',1.62),('5819','2013-08-29','09:20:00',1.63),('5819','2013-08-29','09:25:00',1.5),('5819','2013-08-29','09:30:00',1.51),('5819','2013-08-29','09:35:00',1.67),('5819','2013-08-29','09:40:00',1.74),('5819','2013-08-29','09:45:00',1.48),('5819','2013-08-29','09:50:00',1.4),('5819','2013-08-29','09:55:00',1.45),('5819','2013-08-29','10:00:00',1.56),('5819','2013-08-29','10:05:00',1.47),('5819','2013-08-29','10:10:00',1.44),('5819','2013-08-29','10:15:00',1.44),('5819','2013-08-29','10:20:00',1.46),('5819','2013-08-29','10:25:00',1.44),('5819','2013-08-29','10:30:00',1.49),('5819','2013-08-29','10:35:00',1.41),('5819','2013-08-29','10:40:00',1.29),('5819','2013-08-29','10:45:00',1.19),('5819','2013-08-29','10:50:00',1.16),('5819','2013-08-29','10:55:00',1.27),('5819','2013-08-29','11:00:00',1.38),('5819','2013-08-29','11:05:00',1.38),('5819','2013-08-29','11:10:00',2.02),('5819','2013-08-29','11:15:00',2.45),('5819','2013-08-29','11:20:00',2.38),('5819','2013-08-29','11:25:00',1.77),('5819','2013-08-29','11:30:00',1.53),('5819','2013-08-29','11:35:00',1.32),('5819','2013-08-29','11:40:00',1.47),('5819','2013-08-29','11:45:00',1.72),('5819','2013-08-29','11:50:00',1.81),('5819','2013-08-29','11:55:00',1.73),('5819','2013-08-29','12:00:00',1.71),('5819','2013-08-29','12:05:00',1.92),('5819','2013-08-29','12:10:00',2.36),('5819','2013-08-29','12:15:00',2.85),('5819','2013-08-29','12:20:00',2.47),('5819','2013-08-29','12:25:00',2.52),('5819','2013-08-29','12:30:00',2.44),('5819','2013-08-29','12:35:00',3),('5819','2013-08-29','12:40:00',3.99),('5819','2013-08-29','12:45:00',4.14),('5819','2013-08-29','12:50:00',2.56),('5819','2013-08-29','12:55:00',3.04),('5819','2013-08-29','13:00:00',2.65),('5819','2013-08-29','13:05:00',2.31),('5819','2013-08-29','13:10:00',2.35),('5819','2013-08-29','13:15:00',2.23),('5819','2013-08-29','13:20:00',2.25),('5819','2013-08-29','13:25:00',1.94),('5819','2013-08-29','13:30:00',1.74),('5819','2013-08-29','13:35:00',1.64),('5819','2013-08-29','13:40:00',1.56),('5819','2013-08-29','13:45:00',1.45),('5819','2013-08-29','13:50:00',1.4),('5819','2013-08-29','13:55:00',1.58),('5819','2013-08-29','14:00:00',2.13),('5819','2013-08-29','14:05:00',1.62),('5819','2013-08-29','14:10:00',1.43),('5819','2013-08-29','14:15:00',1.23),('5819','2013-08-29','14:50:00',1.05),('5819','2013-08-29','14:55:00',1.22),('5819','2013-08-29','15:00:00',1.37),('5819','2013-08-29','15:05:00',1.54),('5819','2013-08-29','15:10:00',1.28),('5819','2013-08-29','15:15:00',1.07),('5819','2013-08-29','15:20:00',1.14),('5819','2013-08-29','15:25:00',1.32),('5819','2013-08-29','15:30:00',1.99),('5819','2013-08-29','15:35:00',2.13),('5819','2013-08-29','15:40:00',1.88),('5819','2013-08-29','15:45:00',2.02),('5819','2013-08-29','15:50:00',2.51),('5819','2013-08-29','15:55:00',2.93),('5819','2013-08-29','16:00:00',2.88),('5819','2013-08-29','16:05:00',2.73),('5819','2013-08-29','16:10:00',2.72),('5819','2013-08-29','16:15:00',2.44),('5819','2013-08-29','16:20:00',2.28),('5819','2013-08-29','16:25:00',2.17),('5819','2013-08-29','16:30:00',2.02),('5819','2013-08-29','16:35:00',2),('5819','2013-08-29','16:40:00',1.91),('5819','2013-08-29','16:45:00',1.82),('5819','2013-08-29','16:50:00',1.74),('5819','2013-08-29','16:55:00',1.66),('5819','2013-08-29','17:00:00',1.58),('5819','2013-08-29','17:05:00',1.51),('5819','2013-08-29','17:10:00',1.42),('5819','2013-08-29','17:15:00',1.34),('5819','2013-08-29','17:20:00',1.26),('5819','2013-08-29','17:25:00',1.18),('5819','2013-08-29','17:30:00',1.02),('5819','2013-08-28','07:50:00',1.04),('5819','2013-08-28','08:00:00',1.15),('5819','2013-08-28','08:05:00',1.27),('5819','2013-08-28','08:10:00',1.34),('5819','2013-08-28','08:15:00',1.43),('5819','2013-08-28','08:20:00',1.49),('5819','2013-08-28','08:25:00',1.5),('5819','2013-08-28','08:30:00',1.64),('5819','2013-08-28','08:35:00',1.81),('5819','2013-08-28','08:40:00',1.69),('5819','2013-08-28','08:45:00',1.55),('5819','2013-08-28','08:50:00',1.22),('5819','2013-08-28','08:55:00',1.14),('5819','2013-08-28','09:00:00',1.76),('5819','2013-08-28','09:05:00',1.46),('5819','2013-08-28','09:10:00',1.47),('5819','2013-08-28','09:15:00',1.48),('5819','2013-08-28','09:20:00',1.4),('5819','2013-08-28','09:30:00',1.32),('5819','2013-08-28','09:35:00',2.67),('5819','2013-08-28','09:40:00',2.75),('5819','2013-08-28','09:45:00',2.78),('5819','2013-08-28','09:50:00',2.84),('5819','2013-08-28','09:55:00',2.85),('5819','2013-08-28','10:00:00',2.87),('5819','2013-08-28','10:05:00',2.95),('5819','2013-08-28','10:10:00',1.3),('5819','2013-08-28','10:15:00',3.1),('5819','2013-08-28','10:20:00',3.18),('5819','2013-08-28','10:25:00',2.32),('5819','2013-08-28','10:30:00',2.5),('5819','2013-08-28','10:35:00',2.07),('5819','2013-08-28','10:40:00',3.01),('5819','2013-08-28','10:45:00',2.39),('5819','2013-08-28','10:50:00',3.39),('5819','2013-08-28','10:55:00',3.52),('5819','2013-08-28','11:00:00',2.79),('5819','2013-08-28','11:05:00',1.86),('5819','2013-08-28','11:10:00',2.43),('5819','2013-08-28','11:15:00',3.25),('5819','2013-08-28','11:20:00',3.15),('5819','2013-08-28','11:25:00',3.73),('5819','2013-08-28','11:30:00',3.8),('5819','2013-08-28','11:35:00',3.76),('5819','2013-08-28','11:40:00',3.99),('5819','2013-08-28','11:45:00',3.43),('5819','2013-08-28','11:50:00',2.11),('5819','2013-08-28','11:55:00',3.52),('5819','2013-08-28','12:00:00',1.5),('5819','2013-08-28','12:05:00',3.36),('5819','2013-08-28','12:10:00',3.96),('5819','2013-08-28','12:15:00',3.97),('5819','2013-08-28','12:20:00',3.89),('5819','2013-08-28','12:25:00',3.74),('5819','2013-08-28','12:30:00',3.86),('5819','2013-08-28','12:35:00',3.83),('5819','2013-08-28','12:40:00',3.66),('5819','2013-08-28','12:45:00',3.94),('5819','2013-08-28','12:50:00',3.93),('5819','2013-08-28','12:55:00',3.85),('5819','2013-08-28','13:00:00',3.85),('5819','2013-08-28','13:05:00',3.36),('5819','2013-08-28','13:10:00',3.73),('5819','2013-08-28','13:15:00',3.92),('5819','2013-08-28','13:20:00',3.83),('5819','2013-08-28','13:25:00',3.85),('5819','2013-08-28','13:30:00',3.83),('5819','2013-08-28','13:35:00',3.75),('5819','2013-08-28','13:40:00',3.76),('5819','2013-08-28','13:45:00',3.61),('5819','2013-08-28','13:50:00',3.6),('5819','2013-08-28','13:55:00',3.73),('5819','2013-08-28','14:00:00',3.25),('5819','2013-08-28','14:05:00',3.69),('5819','2013-08-28','14:10:00',3.42),('5819','2013-08-28','14:15:00',3.68),('5819','2013-08-28','14:20:00',3.56),('5819','2013-08-28','14:25:00',3.53),('5819','2013-08-28','14:30:00',3.38),('5819','2013-08-28','14:35:00',2.73),('5819','2013-08-28','14:40:00',2.45),('5819','2013-08-28','14:45:00',3.49),('5819','2013-08-28','14:50:00',3.32),('5819','2013-08-28','14:55:00',3.3),('5819','2013-08-28','15:00:00',3.24),('5819','2013-08-28','15:05:00',3.2),('5819','2013-08-28','15:10:00',3.21),('5819','2013-08-28','15:15:00',3.15),('5819','2013-08-28','15:20:00',3.09),('5819','2013-08-28','15:25:00',3),('5819','2013-08-28','15:30:00',2.14),('5819','2013-08-28','15:35:00',2.02),('5819','2013-08-28','15:40:00',2.22),('5819','2013-08-28','15:45:00',1.4),('5819','2013-08-28','15:50:00',2.65),('5819','2013-08-28','15:55:00',2.1),('5819','2013-08-28','16:00:00',2.56),('5819','2013-08-28','16:05:00',2.55),('5819','2013-08-28','16:10:00',2.67),('5819','2013-08-28','16:15:00',2.44),('5819','2013-08-28','16:20:00',1.34),('5819','2013-08-28','16:25:00',2.46),('5819','2013-08-28','16:30:00',2.27),('5819','2013-08-28','16:35:00',1.83),('5819','2013-08-28','16:40:00',2.11),('5819','2013-08-28','16:45:00',1.97),('5819','2013-08-28','16:50:00',1.82),('5819','2013-08-28','16:55:00',1.6),('5819','2013-08-28','17:00:00',1.7),('5819','2013-08-28','17:05:00',1.56),('5819','2013-08-27','08:20:00',1.18),('5819','2013-08-27','08:25:00',1.64),('5819','2013-08-27','08:30:00',1.66),('5819','2013-08-27','08:35:00',1.15),('5819','2013-08-27','08:40:00',1.08),('5819','2013-08-27','08:45:00',1.34),('5819','2013-08-27','09:00:00',1.04),('5819','2013-08-27','09:05:00',1.1),('5819','2013-08-27','09:10:00',1.42),('5819','2013-08-27','09:15:00',1.47),('5819','2013-08-27','09:20:00',1.63),('5819','2013-08-27','09:25:00',2.18),('5819','2013-08-27','09:30:00',2.4),('5819','2013-08-27','09:35:00',1.43),('5819','2013-08-27','09:40:00',1.05),('5819','2013-08-27','09:45:00',1.09),('5819','2013-08-27','09:50:00',1.14),('5819','2013-08-27','09:55:00',1.47),('5819','2013-08-27','10:00:00',1.96),('5819','2013-08-27','10:05:00',2.38),('5819','2013-08-27','10:10:00',2.86),('5819','2013-08-27','10:15:00',2.95),('5819','2013-08-27','10:20:00',3.07),('5819','2013-08-27','10:25:00',3.1),('5819','2013-08-27','10:30:00',3.11),('5819','2013-08-27','10:35:00',3.18),('5819','2013-08-27','10:40:00',3.12),('5819','2013-08-27','10:45:00',3.21),('5819','2013-08-27','10:50:00',3.27),('5819','2013-08-27','10:55:00',3.25),('5819','2013-08-27','11:00:00',3.29),('5819','2013-08-27','11:05:00',3.35),('5819','2013-08-27','11:10:00',3.33),('5819','2013-08-27','11:15:00',3.32),('5819','2013-08-27','11:20:00',3.21),('5819','2013-08-27','11:25:00',3.35),('5819','2013-08-27','11:30:00',3.4),('5819','2013-08-27','11:35:00',3.43),('5819','2013-08-27','11:40:00',3.35),('5819','2013-08-27','11:45:00',3.85),('5819','2013-08-27','11:50:00',3.48),('5819','2013-08-27','11:55:00',3.63),('5819','2013-08-27','12:00:00',3.76),('5819','2013-08-27','12:05:00',3.77),('5819','2013-08-27','12:10:00',3.18),('5819','2013-08-27','12:15:00',3.19),('5819','2013-08-27','12:20:00',3.49),('5819','2013-08-27','12:25:00',3.28),('5819','2013-08-27','12:30:00',3.61),('5819','2013-08-27','12:35:00',3.81),('5819','2013-08-27','12:40:00',3.46),('5819','2013-08-27','12:45:00',2.89),('5819','2013-08-27','12:50:00',2.24),('5819','2013-08-27','12:55:00',2.06),('5819','2013-08-27','13:00:00',1.45),('5819','2013-08-27','13:05:00',1.62),('5819','2013-08-27','13:10:00',2.29),('5819','2013-08-27','13:15:00',1.68),('5819','2013-08-27','13:20:00',1.7),('5819','2013-08-27','13:25:00',1.79),('5819','2013-08-27','13:30:00',2.3),('5819','2013-08-27','13:35:00',1.81),('5819','2013-08-27','13:40:00',1.78),('5819','2013-08-27','13:45:00',1.95),('5819','2013-08-27','13:50:00',3.65),('5819','2013-08-27','13:55:00',2.88),('5819','2013-08-27','14:00:00',3.16),('5819','2013-08-27','14:05:00',2.03),('5819','2013-08-27','14:10:00',1.84),('5819','2013-08-27','14:15:00',3.12),('5819','2013-08-27','14:20:00',2.4),('5819','2013-08-27','14:25:00',1.36),('5819','2013-08-27','14:30:00',1.05),('5819','2013-08-27','14:35:00',1.06),('5819','2013-08-27','14:40:00',1.15),('5819','2013-08-27','14:45:00',1.23),('5819','2013-08-27','14:50:00',1.02),('5819','2013-08-27','16:00:00',1.27),('5819','2013-08-27','16:05:00',1.32),('5819','2013-08-27','16:10:00',2.52),('5819','2013-08-27','16:15:00',2.67),('5819','2013-08-27','16:20:00',1.33),('5819','2013-08-27','16:25:00',1.49),('5819','2013-08-27','16:30:00',1.18),('5819','2013-08-27','16:35:00',1.15),('5819','2013-08-27','16:40:00',1.27),('5819','2013-08-27','16:50:00',1.34),('5819','2013-08-27','17:10:00',1.91),('5819','2013-08-27','17:15:00',1.25),('5819','2013-08-27','17:50:00',1.06),('5819','2013-08-27','17:55:00',1.01),('5819','2013-08-26','07:55:00',1.03),('5819','2013-08-26','08:05:00',1.49),('5819','2013-08-26','08:10:00',1.45),('5819','2013-08-26','08:20:00',1.49),('5819','2013-08-26','08:25:00',1.29),('5819','2013-08-26','08:30:00',1.83),('5819','2013-08-26','08:35:00',1.56),('5819','2013-08-26','08:40:00',1.73),('5819','2013-08-26','08:45:00',1.91),('5819','2013-08-26','08:50:00',1.97),('5819','2013-08-26','08:55:00',2.05),('5819','2013-08-26','09:00:00',2.11),('5819','2013-08-26','09:05:00',2.16),('5819','2013-08-26','09:10:00',2.25),('5819','2013-08-26','09:15:00',2.31),('5819','2013-08-26','09:20:00',2.38),('5819','2013-08-26','09:25:00',2.43),('5819','2013-08-26','09:30:00',2.51),('5819','2013-08-26','09:35:00',2.57),('5819','2013-08-26','09:40:00',2.64),('5819','2013-08-26','09:45:00',2.68),('5819','2013-08-26','09:50:00',2.73),('5819','2013-08-26','09:55:00',2.77),('5819','2013-08-26','10:00:00',2.82),('5819','2013-08-26','10:05:00',2.88),('5819','2013-08-26','10:10:00',2.91),('5819','2013-08-26','10:15:00',2.95),('5819','2013-08-26','10:20:00',3.03),('5819','2013-08-26','10:25:00',3.09),('5819','2013-08-26','10:30:00',3.12),('5819','2013-08-26','10:35:00',3.16),('5819','2013-08-26','10:40:00',3.19),('5819','2013-08-26','10:45:00',3.23),('5819','2013-08-26','10:50:00',3.25),('5819','2013-08-26','10:55:00',3.34),('5819','2013-08-26','11:00:00',3.37),('5819','2013-08-26','11:05:00',3.39),('5819','2013-08-26','11:10:00',3.39),('5819','2013-08-26','11:15:00',3.43),('5819','2013-08-26','11:20:00',3.46),('5819','2013-08-26','11:25:00',3.46),('5819','2013-08-26','11:30:00',3.46),('5819','2013-08-26','11:35:00',3.53),('5819','2013-08-26','11:40:00',3.55),('5819','2013-08-26','11:45:00',3.54),('5819','2013-08-26','11:50:00',3.53),('5819','2013-08-26','11:55:00',3.54),('5819','2013-08-26','12:00:00',3.58),('5819','2013-08-26','12:05:00',3.58),('5819','2013-08-26','12:10:00',3.6),('5819','2013-08-26','12:15:00',3.61),('5819','2013-08-26','12:20:00',3.61),('5819','2013-08-26','12:25:00',3.58),('5819','2013-08-26','12:30:00',3.56),('5819','2013-08-26','12:35:00',3.54),('5819','2013-08-26','12:40:00',3.53),('5819','2013-08-26','12:45:00',3.6),('5819','2013-08-26','12:50:00',3.63),('5819','2013-08-26','12:55:00',3.21),('5819','2013-08-26','13:00:00',3.77),('5819','2013-08-26','13:05:00',4.11),('5819','2013-08-26','13:10:00',3.81),('5819','2013-08-26','13:15:00',2.67),('5819','2013-08-26','13:20:00',2.81),('5819','2013-08-26','13:25:00',2.6),('5819','2013-08-26','13:30:00',2.59),('5819','2013-08-26','13:35:00',3.48),('5819','2013-08-26','13:40:00',3.53),('5819','2013-08-26','13:45:00',3.52),('5819','2013-08-26','13:50:00',3.65),('5819','2013-08-26','13:55:00',2.94),('5819','2013-08-26','14:00:00',2.84),('5819','2013-08-26','14:05:00',3.5),('5819','2013-08-26','14:10:00',2.25),('5819','2013-08-26','14:15:00',3.55),('5819','2013-08-26','14:20:00',3.36),('5819','2013-08-26','14:25:00',3.26),('5819','2013-08-26','14:30:00',3.26),('5819','2013-08-26','14:35:00',3.18),('5819','2013-08-26','14:40:00',2.9),('5819','2013-08-26','14:45:00',2.34),('5819','2013-08-26','14:50:00',1.89),('5819','2013-08-26','14:55:00',1.7),('5819','2013-08-26','15:00:00',1.64),('5819','2013-08-26','15:05:00',1.32),('5819','2013-08-26','15:40:00',1.37),('5819','2013-08-26','15:45:00',1.51),('5819','2013-08-26','15:50:00',1.47),('5819','2013-08-26','15:55:00',1.4),('5819','2013-08-26','16:00:00',1.74),('5819','2013-08-26','16:05:00',2.77),('5819','2013-08-26','16:10:00',2.38),('5819','2013-08-26','16:15:00',2.22),('5819','2013-08-26','16:20:00',2.16),('5819','2013-08-26','16:25:00',2.05),('5819','2013-08-26','16:30:00',1.99),('5819','2013-08-26','16:35:00',1.92),('5819','2013-08-26','16:40:00',1.87),('5819','2013-08-26','16:45:00',1.83),('5819','2013-08-26','16:50:00',1.69),('5819','2013-08-26','16:55:00',1.61),('5819','2013-08-26','17:00:00',1.57),('5819','2013-08-26','17:05:00',1.42),('5819','2013-08-26','17:10:00',1.4),('5819','2013-08-26','17:15:00',1.33),('5819','2013-08-26','17:20:00',1.08),('5819','2013-08-25','08:00:00',1.05),('5819','2013-08-25','08:05:00',1.15),('5819','2013-08-25','08:10:00',1.33),('5819','2013-08-25','08:15:00',1.37),('5819','2013-08-25','08:20:00',1.17),('5819','2013-08-25','08:25:00',1.23),('5819','2013-08-25','08:30:00',1.18),('5819','2013-08-25','08:35:00',1.02),('5819','2013-08-25','08:40:00',1.11),('5819','2013-08-25','08:45:00',1.67),('5819','2013-08-25','09:20:00',2.18),('5819','2013-08-25','09:25:00',1.94),('5819','2013-08-25','09:30:00',2.34),('5819','2013-08-25','09:35:00',2.15),('5819','2013-08-25','09:40:00',2.93),('5819','2013-08-25','09:45:00',3.2),('5819','2013-08-25','09:50:00',2.95),('5819','2013-08-25','09:55:00',3.26),('5819','2013-08-25','10:00:00',2.4),('5819','2013-08-25','10:05:00',1.69),('5819','2013-08-25','15:15:00',1.06),('5819','2013-08-25','15:20:00',1.26),('5819','2013-08-25','15:25:00',1.4),('5819','2013-08-25','15:30:00',1.92),('5819','2013-08-25','15:35:00',2.8),('5819','2013-08-25','15:40:00',3.03),('5819','2013-08-25','15:45:00',3.02),('5819','2013-08-25','15:50:00',2.63),('5819','2013-08-25','15:55:00',1.51),('5819','2013-08-25','16:00:00',2.87),('5819','2013-08-25','16:05:00',2.65),('5819','2013-08-25','16:10:00',2.5),('5819','2013-08-25','16:15:00',2.4),('5819','2013-08-25','16:20:00',2.31),('5819','2013-08-25','16:25:00',2.23),('5819','2013-08-25','16:30:00',2.15),('5819','2013-08-25','16:35:00',2.05),('5819','2013-08-25','16:40:00',1.63),('5819','2013-08-25','16:45:00',1.19),('5819','2013-08-25','16:50:00',1.46),('5819','2013-08-25','16:55:00',2.06),('5819','2013-08-25','17:00:00',1.83),('5819','2013-08-25','17:05:00',1.7),('5819','2013-08-25','17:10:00',1.62),('5819','2013-08-25','17:15:00',1.48),('5819','2013-08-25','17:20:00',1.36),('5819','2013-08-25','17:25:00',1.27),('5819','2013-08-25','17:30:00',1.12),('5819','2013-08-24','08:05:00',1.1),('5819','2013-08-24','08:15:00',1.08),('5819','2013-08-24','08:25:00',1.44),('5819','2013-08-24','08:30:00',1.52),('5819','2013-08-24','08:35:00',1.59),('5819','2013-08-24','08:40:00',1.74),('5819','2013-08-24','08:45:00',1.78),('5819','2013-08-24','08:50:00',1.66),('5819','2013-08-24','08:55:00',1.94),('5819','2013-08-24','09:00:00',2.09),('5819','2013-08-24','09:05:00',2.11),('5819','2013-08-24','09:10:00',2.25),('5819','2013-08-24','09:15:00',2.06),('5819','2013-08-24','09:20:00',2.39),('5819','2013-08-24','09:25:00',2.03),('5819','2013-08-24','09:30:00',1.91),('5819','2013-08-24','09:35:00',1.74),('5819','2013-08-24','09:40:00',2.7),('5819','2013-08-24','09:45:00',1.68),('5819','2013-08-24','09:50:00',2.25),('5819','2013-08-24','09:55:00',2.3),('5819','2013-08-24','10:00:00',2.93),('5819','2013-08-24','10:05:00',2.93),('5819','2013-08-24','10:10:00',2.98),('5819','2013-08-24','10:15:00',2.99),('5819','2013-08-24','10:20:00',3.03),('5819','2013-08-24','10:25:00',3.05),('5819','2013-08-24','10:30:00',3.08),('5819','2013-08-24','10:35:00',3.11),('5819','2013-08-24','10:40:00',3.19),('5819','2013-08-24','10:45:00',3.22),('5819','2013-08-24','10:50:00',2.97),('5819','2013-08-24','10:55:00',2.83),('5819','2013-08-24','11:00:00',3.34),('5819','2013-08-24','11:05:00',3.36),('5819','2013-08-24','11:10:00',3.41),('5819','2013-08-24','11:15:00',3.42),('5819','2013-08-24','11:20:00',3.47),('5819','2013-08-24','11:25:00',3.47),('5819','2013-08-24','11:30:00',3.42),('5819','2013-08-24','11:35:00',3.5),('5819','2013-08-24','11:40:00',3.51),('5819','2013-08-24','11:45:00',3.51),('5819','2013-08-24','11:50:00',3.57),('5819','2013-08-24','11:55:00',3.53),('5819','2013-08-24','12:00:00',3.54),('5819','2013-08-24','12:05:00',3.51),('5819','2013-08-24','12:10:00',3.55),('5819','2013-08-24','12:15:00',3.6),('5819','2013-08-24','12:20:00',3.59),('5819','2013-08-24','12:25:00',3.6),('5819','2013-08-24','12:30:00',3.57),('5819','2013-08-24','12:35:00',3.58),('5819','2013-08-24','12:40:00',3.57),('5819','2013-08-24','12:45:00',3.59),('5819','2013-08-24','12:50:00',3.58),('5819','2013-08-24','12:55:00',3.56),('5819','2013-08-24','13:00:00',3.5),('5819','2013-08-24','13:05:00',3.53),('5819','2013-08-24','13:10:00',3.57),('5819','2013-08-24','13:15:00',3.56),('5819','2013-08-24','13:20:00',3.57),('5819','2013-08-24','13:25:00',3.57),('5819','2013-08-24','13:30:00',3.58),('5819','2013-08-24','13:35:00',3.55),('5819','2013-08-24','13:40:00',3.52),('5819','2013-08-24','13:45:00',3.51),('5819','2013-08-24','13:50:00',3.52),('5819','2013-08-24','13:55:00',3.48),('5819','2013-08-24','14:00:00',3.43),('5819','2013-08-24','14:05:00',3.41),('5819','2013-08-24','14:10:00',3.4),('5819','2013-08-24','14:15:00',3.37),('5819','2013-08-24','14:20:00',3.35),('5819','2013-08-24','14:25:00',3.3),('5819','2013-08-24','14:30:00',3.28),('5819','2013-08-24','14:35:00',3.26),('5819','2013-08-24','14:40:00',3.21),('5819','2013-08-24','14:45:00',3.15),('5819','2013-08-24','14:50:00',3.12),('5819','2013-08-24','14:55:00',3.09),('5819','2013-08-24','15:00:00',3.03),('5819','2013-08-24','15:05:00',3),('5819','2013-08-24','15:10:00',2.95),('5819','2013-08-24','15:15:00',2.9),('5819','2013-08-24','15:20:00',2.84),('5819','2013-08-24','15:25:00',2.79),('5819','2013-08-24','15:30:00',2.75),('5819','2013-08-24','15:35:00',2.69),('5819','2013-08-24','15:40:00',2.63),('5819','2013-08-24','15:45:00',2.57),('5819','2013-08-24','15:50:00',2.52),('5819','2013-08-24','15:55:00',2.46),('5819','2013-08-24','16:00:00',2.41),('5819','2013-08-24','16:05:00',2.35),('5819','2013-08-24','16:10:00',2.29),('5819','2013-08-24','16:15:00',2.22),('5819','2013-08-24','16:20:00',2.15),('5819','2013-08-24','16:25:00',2.08),('5819','2013-08-24','16:30:00',2.01),('5819','2013-08-24','16:35:00',1.94),('5819','2013-08-24','16:40:00',1.88),('5819','2013-08-24','16:45:00',1.8),('5819','2013-08-24','16:50:00',1.72),('5819','2013-08-24','16:55:00',1.66),('5819','2013-08-24','17:00:00',1.57),('5819','2013-08-24','17:05:00',1.51),('5819','2013-08-24','17:10:00',1.45),('5819','2013-08-24','17:15:00',1.37),('5819','2013-08-24','17:20:00',1.31),('5819','2013-08-24','17:25:00',1.23),('5819','2013-08-24','17:30:00',1.1),('5819','2013-08-24','17:35:00',1),('5819','2013-08-23','08:05:00',1.02),('5819','2013-08-23','08:10:00',1.1),('5819','2013-08-23','08:15:00',1.18),('5819','2013-08-23','08:20:00',1.27),('5819','2013-08-23','08:25:00',1.34),('5819','2013-08-23','08:30:00',1.43),('5819','2013-08-23','08:35:00',1.49),('5819','2013-08-23','08:40:00',1.53),('5819','2013-08-23','08:45:00',1.63),('5819','2013-08-23','08:50:00',1.73),('5819','2013-08-23','08:55:00',1.78),('5819','2013-08-23','09:00:00',1.81),('5819','2013-08-23','09:05:00',1.9),('5819','2013-08-23','09:10:00',1.98),('5819','2013-08-23','09:15:00',2.07),('5819','2013-08-23','09:20:00',2.14),('5819','2013-08-23','09:25:00',2.2),('5819','2013-08-23','09:30:00',2.26),('5819','2013-08-23','09:35:00',2.31),('5819','2013-08-23','09:40:00',2.32),('5819','2013-08-23','09:45:00',2.39),('5819','2013-08-23','09:50:00',2.47),('5819','2013-08-23','09:55:00',2.5),('5819','2013-08-23','10:00:00',2.58),('5819','2013-08-23','10:05:00',2.62),('5819','2013-08-23','10:10:00',2.61),('5819','2013-08-23','10:15:00',2.68),('5819','2013-08-23','10:20:00',2.76),('5819','2013-08-23','10:25:00',2.79),('5819','2013-08-23','10:30:00',2.83),('5819','2013-08-23','10:35:00',2.87),('5819','2013-08-23','10:40:00',2.86),('5819','2013-08-23','10:45:00',2.93),('5819','2013-08-23','10:50:00',2.96),('5819','2013-08-23','10:55:00',2.94),('5819','2013-08-23','11:00:00',2.98),('5819','2013-08-23','11:05:00',3.12),('5819','2013-08-23','11:10:00',3.16),('5819','2013-08-23','11:15:00',2.71),('5819','2013-08-23','11:20:00',2.25),('5819','2013-08-23','11:25:00',2.86),('5819','2013-08-23','11:30:00',3.38),('5819','2013-08-23','11:35:00',2.51),('5819','2013-08-23','11:40:00',2.34),('5819','2013-08-23','11:45:00',3.07),('5819','2013-08-23','11:50:00',3.3),('5819','2013-08-23','11:55:00',3.38),('5819','2013-08-23','12:00:00',3),('5819','2013-08-23','12:05:00',2.24),('5819','2013-08-23','12:10:00',1.09),('5819','2013-08-23','12:15:00',1.64),('5819','2013-08-23','12:20:00',1.14),('5819','2013-08-23','12:40:00',1.07),('5819','2013-08-23','12:45:00',1.09),('5819','2013-08-23','13:00:00',1.13),('5819','2013-08-23','13:05:00',1.1),('5819','2013-08-23','13:10:00',1.47),('5819','2013-08-23','13:15:00',2.3),('5819','2013-08-23','13:20:00',1.13),('5819','2013-08-23','13:25:00',2.25),('5819','2013-08-23','13:30:00',3.83),('5819','2013-08-23','13:35:00',3.45),('5819','2013-08-23','13:40:00',2.67),('5819','2013-08-23','13:45:00',3.45),('5819','2013-08-23','13:50:00',2.22),('5819','2013-08-23','13:55:00',2.9),('5819','2013-08-23','14:00:00',3.85),('5819','2013-08-23','14:05:00',3.62),('5819','2013-08-23','14:10:00',3.57),('5819','2013-08-23','14:15:00',3.58),('5819','2013-08-23','14:20:00',3.07),('5819','2013-08-23','14:25:00',2.86),('5819','2013-08-23','14:30:00',3.23),('5819','2013-08-23','14:35:00',3.33),('5819','2013-08-23','14:40:00',3.29),('5819','2013-08-23','14:45:00',3.23),('5819','2013-08-23','14:50:00',3.12),('5819','2013-08-23','14:55:00',2.98),('5819','2013-08-23','15:00:00',2.9),('5819','2013-08-23','15:05:00',2.77),('5819','2013-08-23','15:10:00',2.82),('5819','2013-08-23','15:15:00',2.85),('5819','2013-08-23','15:20:00',2.79),('5819','2013-08-23','15:25:00',2.79),('5819','2013-08-23','15:30:00',2.86),('5819','2013-08-23','15:35:00',2.65),('5819','2013-08-23','15:40:00',2.59),('5819','2013-08-23','15:45:00',2.57),('5819','2013-08-23','15:50:00',2.4),('5819','2013-08-23','15:55:00',2.44),('5819','2013-08-23','16:00:00',2.34),('5819','2013-08-23','16:05:00',2.19),('5819','2013-08-23','16:10:00',1.88),('5819','2013-08-23','16:15:00',1.96),('5819','2013-08-23','16:20:00',2.26),('5819','2013-08-23','16:25:00',2.04),('5819','2013-08-23','16:30:00',1.97),('5819','2013-08-23','16:35:00',2.05),('5819','2013-08-23','16:40:00',1.99),('5819','2013-08-23','16:45:00',1.91),('5819','2013-08-23','16:50:00',1.82),('5819','2013-08-23','16:55:00',1.72),('5819','2013-08-23','17:00:00',1.63),('5819','2013-08-23','17:05:00',1.53),('5819','2013-08-23','17:10:00',1.45),('5819','2013-08-23','17:15:00',1.37),('5819','2013-08-23','17:20:00',1.29),('5819','2013-08-23','17:25:00',1.21),('5819','2013-08-23','17:30:00',1.11),('5819','2013-08-22','08:00:00',1.04),('5819','2013-08-22','08:05:00',1.11),('5819','2013-08-22','08:10:00',1.2),('5819','2013-08-22','08:15:00',1.27),('5819','2013-08-22','08:20:00',1.35),('5819','2013-08-22','08:25:00',1.42),('5819','2013-08-22','08:30:00',1.49),('5819','2013-08-22','08:35:00',1.58),('5819','2013-08-22','08:40:00',1.65),('5819','2013-08-22','08:45:00',1.76),('5819','2013-08-22','08:50:00',1.84),('5819','2013-08-22','08:55:00',1.93),('5819','2013-08-22','09:00:00',2.02),('5819','2013-08-22','09:05:00',2.16),('5819','2013-08-22','09:10:00',2.27),('5819','2013-08-22','09:15:00',2.36),('5819','2013-08-22','09:20:00',2.49),('5819','2013-08-22','09:25:00',2.36),('5819','2013-08-22','09:30:00',1.98),('5819','2013-08-22','09:35:00',1.29),('5819','2013-08-22','09:40:00',1.43),('5819','2013-08-22','09:45:00',1.89),('5819','2013-08-22','09:50:00',2.18),('5819','2013-08-22','09:55:00',2.54),('5819','2013-08-22','10:00:00',2.97),('5819','2013-08-22','10:05:00',3),('5819','2013-08-22','10:10:00',3.01),('5819','2013-08-22','10:15:00',2.97),('5819','2013-08-22','10:20:00',2.98),('5819','2013-08-22','10:25:00',3.02),('5819','2013-08-22','10:30:00',3.05),('5819','2013-08-22','10:35:00',3.06),('5819','2013-08-22','10:40:00',3.12),('5819','2013-08-22','10:45:00',3.15),('5819','2013-08-22','10:50:00',3.17),('5819','2013-08-22','10:55:00',3.2),('5819','2013-08-22','11:00:00',3.22),('5819','2013-08-22','11:05:00',3.24),('5819','2013-08-22','11:10:00',3.27),('5819','2013-08-22','11:15:00',3.29),('5819','2013-08-22','11:20:00',3.28),('5819','2013-08-22','11:25:00',3.3),('5819','2013-08-22','11:30:00',3.36),('5819','2013-08-22','11:35:00',3.38),('5819','2013-08-22','11:40:00',3.41),('5819','2013-08-22','11:45:00',3.41),('5819','2013-08-22','11:50:00',3.42),('5819','2013-08-22','11:55:00',3.43),('5819','2013-08-22','12:00:00',3.44),('5819','2013-08-22','12:05:00',3.45),('5819','2013-08-22','12:10:00',3.45),('5819','2013-08-22','12:15:00',3.46),('5819','2013-08-22','12:20:00',3.46),('5819','2013-08-22','12:25:00',3.46),('5819','2013-08-22','12:30:00',3.45),('5819','2013-08-22','12:35:00',3.46),('5819','2013-08-22','12:40:00',3.45),('5819','2013-08-22','12:45:00',3.46),('5819','2013-08-22','12:50:00',3.45),('5819','2013-08-22','12:55:00',3.44),('5819','2013-08-22','13:00:00',3.22),('5819','2013-08-22','13:05:00',3.24),('5819','2013-08-22','13:10:00',3.29),('5819','2013-08-22','13:15:00',3.32),('5819','2013-08-22','13:20:00',3.27),('5819','2013-08-22','13:25:00',3.32),('5819','2013-08-22','13:30:00',3.31),('5819','2013-08-22','13:35:00',3.32),('5819','2013-08-22','13:40:00',3.34),('5819','2013-08-22','13:45:00',3.32),('5819','2013-08-22','13:50:00',3.31),('5819','2013-08-22','13:55:00',3.26),('5819','2013-08-22','14:00:00',3.23),('5819','2013-08-22','14:05:00',3.23),('5819','2013-08-22','14:10:00',3.22),('5819','2013-08-22','14:15:00',3.21),('5819','2013-08-22','14:20:00',3.21),('5819','2013-08-22','14:25:00',3.23),('5819','2013-08-22','14:30:00',3.16),('5819','2013-08-22','14:35:00',3.14),('5819','2013-08-22','14:40:00',2.77),('5819','2013-08-22','14:45:00',3.1),('5819','2013-08-22','14:50:00',3.02),('5819','2013-08-22','14:55:00',2.64),('5819','2013-08-22','15:00:00',2.92),('5819','2013-08-22','15:05:00',2.92),('5819','2013-08-22','15:10:00',2.89),('5819','2013-08-22','15:15:00',2.85),('5819','2013-08-22','15:20:00',2.77),('5819','2013-08-22','15:25:00',2.7),('5819','2013-08-22','15:30:00',2.68),('5819','2013-08-22','15:35:00',2.62),('5819','2013-08-22','15:40:00',2.59),('5819','2013-08-22','15:45:00',2.53),('5819','2013-08-22','15:50:00',2.48),('5819','2013-08-22','15:55:00',2.42),('5819','2013-08-22','16:00:00',2.37),('5819','2013-08-22','16:05:00',2.26),('5819','2013-08-22','16:10:00',2.21),('5819','2013-08-22','16:15:00',2.15),('5819','2013-08-22','16:20:00',2.08),('5819','2013-08-22','16:25:00',2.03),('5819','2013-08-22','16:30:00',1.98),('5819','2013-08-22','16:35:00',1.91),('5819','2013-08-22','16:40:00',1.84),('5819','2013-08-22','16:45:00',1.75),('5819','2013-08-22','16:50:00',1.67),('5819','2013-08-22','16:55:00',1.62),('5819','2013-08-22','17:00:00',1.54),('5819','2013-08-22','17:05:00',1.48),('5819','2013-08-22','17:10:00',1.4),('5819','2013-08-22','17:15:00',1.32),('5819','2013-08-22','17:20:00',1.26),('5819','2013-08-22','17:25:00',1.19),('5819','2013-08-22','17:30:00',1.11),('5819','2013-08-21','09:05:00',1.29),('5819','2013-08-21','09:10:00',1.31),('5819','2013-08-21','09:15:00',2.4),('5819','2013-08-21','09:20:00',2.74),('5819','2013-08-21','09:25:00',1.12),('5819','2013-08-21','09:40:00',1.11),('5819','2013-08-21','09:45:00',1.21),('5819','2013-08-21','09:50:00',2.99),('5819','2013-08-21','09:55:00',3.46),('5819','2013-08-21','10:00:00',3.22),('5819','2013-08-21','10:05:00',2.44),('5819','2013-08-21','10:10:00',2.17),('5819','2013-08-21','10:15:00',2.76),('5819','2013-08-21','10:20:00',1.92),('5819','2013-08-21','10:25:00',1.85),('5819','2013-08-21','10:30:00',1.73),('5819','2013-08-21','10:35:00',3.35),('5819','2013-08-21','10:40:00',2.96),('5819','2013-08-21','10:45:00',2.76),('5819','2013-08-21','10:50:00',2.4),('5819','2013-08-21','10:55:00',1.75),('5819','2013-08-21','11:00:00',2.21),('5819','2013-08-21','11:05:00',1.89),('5819','2013-08-21','11:10:00',1.63),('5819','2013-08-21','11:15:00',2.13),('5819','2013-08-21','11:20:00',3.5),('5819','2013-08-21','11:25:00',2.73),('5819','2013-08-21','11:30:00',2.63),('5819','2013-08-21','11:35:00',3.65),('5819','2013-08-21','11:40:00',3.81),('5819','2013-08-21','11:45:00',3.78),('5819','2013-08-21','11:50:00',2.7),('5819','2013-08-21','11:55:00',3.5),('5819','2013-08-21','12:00:00',3.83),('5819','2013-08-21','12:05:00',3.8),('5819','2013-08-21','12:10:00',3.77),('5819','2013-08-21','12:15:00',3.77),('5819','2013-08-21','12:20:00',3.66),('5819','2013-08-21','12:25:00',2.46),('5819','2013-08-21','12:30:00',3.75),('5819','2013-08-21','12:35:00',3.36),('5819','2013-08-21','12:40:00',3.29),('5819','2013-08-21','12:45:00',3.58),('5819','2013-08-21','12:50:00',3.45),('5819','2013-08-21','12:55:00',3.31),('5819','2013-08-21','13:00:00',3.4),('5819','2013-08-21','13:05:00',3.49),('5819','2013-08-21','13:10:00',3.53),('5819','2013-08-21','13:15:00',3.55),('5819','2013-08-21','13:20:00',3.55),('5819','2013-08-21','13:25:00',3.57),('5819','2013-08-21','13:30:00',3.55),('5819','2013-08-21','13:35:00',3.5),('5819','2013-08-21','13:40:00',3.51),('5819','2013-08-21','13:45:00',3.42),('5819','2013-08-21','13:50:00',3.32),('5819','2013-08-21','13:55:00',3.3),('5819','2013-08-21','14:00:00',3.42),('5819','2013-08-21','14:05:00',3.37),('5819','2013-08-21','14:10:00',3.38),('5819','2013-08-21','14:15:00',3.42),('5819','2013-08-21','14:20:00',3.27),('5819','2013-08-21','14:25:00',2.75),('5819','2013-08-21','14:30:00',2.97),('5819','2013-08-21','14:35:00',2.87),('5819','2013-08-21','14:40:00',2.92),('5819','2013-08-21','14:45:00',2.93),('5819','2013-08-21','14:50:00',2.83),('5819','2013-08-21','14:55:00',2.78),('5819','2013-08-21','15:00:00',2.85),('5819','2013-08-21','15:05:00',2.87),('5819','2013-08-21','15:10:00',2.78),('5819','2013-08-21','15:15:00',2.7),('5819','2013-08-21','15:20:00',2.67),('5819','2013-08-21','15:25:00',2.68),('5819','2013-08-21','15:30:00',2.54),('5819','2013-08-21','15:35:00',2.43),('5819','2013-08-21','15:40:00',2.29),('5819','2013-08-21','15:45:00',2.35),('5819','2013-08-21','15:50:00',2.4),('5819','2013-08-21','15:55:00',2.19),('5819','2013-08-21','16:00:00',2.07),('5819','2013-08-21','16:05:00',2.06),('5819','2013-08-21','16:10:00',1.98),('5819','2013-08-21','16:15:00',2.04),('5819','2013-08-21','16:20:00',2.07),('5819','2013-08-21','16:25:00',2.03),('5819','2013-08-21','16:30:00',2.1),('5819','2013-08-21','16:35:00',2.01),('5819','2013-08-21','16:40:00',1.94),('5819','2013-08-21','16:45:00',1.88),('5819','2013-08-21','16:50:00',1.8),('5819','2013-08-21','16:55:00',1.75),('5819','2013-08-21','17:00:00',1.69),('5819','2013-08-21','17:05:00',1.64),('5819','2013-08-21','17:10:00',1.58),('5819','2013-08-21','17:15:00',1.53),('5819','2013-08-21','17:20:00',1.5),('5819','2013-08-21','17:25:00',1.44),('5819','2013-08-21','17:30:00',1.35),('5819','2013-08-21','17:35:00',1.19),('5819','2013-08-21','17:40:00',1.2),('5819','2013-08-21','17:45:00',1.16),('5819','2013-08-21','17:50:00',1.1),('5819','2013-08-21','17:55:00',1.04),('5819','2013-08-20','07:55:00',1.08),('5819','2013-08-20','08:00:00',1.13),('5819','2013-08-20','08:55:00',1.13),('5819','2013-08-20','09:00:00',1.09),('5819','2013-08-20','09:05:00',1.22),('5819','2013-08-20','09:10:00',1.07),('5819','2013-08-20','09:15:00',1.16),('5819','2013-08-20','09:20:00',1.18),('5819','2013-08-20','09:25:00',1.76),('5819','2013-08-20','09:30:00',2.41),('5819','2013-08-20','09:35:00',2.48),('5819','2013-08-20','09:40:00',2.84),('5819','2013-08-20','09:45:00',3.01),('5819','2013-08-20','09:50:00',2.86),('5819','2013-08-20','09:55:00',1.85),('5819','2013-08-20','10:00:00',3.41),('5819','2013-08-20','10:05:00',1.85),('5819','2013-08-20','10:10:00',1.83),('5819','2013-08-20','10:15:00',2.48),('5819','2013-08-20','10:20:00',1.7),('5819','2013-08-20','10:25:00',1.25),('5819','2013-08-20','10:50:00',1.96),('5819','2013-08-20','10:55:00',2.77),('5819','2013-08-20','11:00:00',1.14),('5819','2013-08-20','11:20:00',3.7),('5819','2013-08-20','11:25:00',3.83),('5819','2013-08-20','11:30:00',1.85),('5819','2013-08-20','11:40:00',3.07),('5819','2013-08-20','11:45:00',3.9),('5819','2013-08-20','11:50:00',2.68),('5819','2013-08-20','11:55:00',4.11),('5819','2013-08-20','12:00:00',2.3),('5819','2013-08-20','12:05:00',1.09),('5819','2013-08-20','12:35:00',1.2),('5819','2013-08-20','12:40:00',1.56),('5819','2013-08-20','12:45:00',1.64),('5819','2013-08-20','12:50:00',1.76),('5819','2013-08-20','12:55:00',1.75),('5819','2013-08-20','13:00:00',1.7),('5819','2013-08-20','13:05:00',1.54),('5819','2013-08-20','13:10:00',1.46),('5819','2013-08-20','13:15:00',1.49),('5819','2013-08-20','13:20:00',1.55),('5819','2013-08-20','13:25:00',1.63),('5819','2013-08-20','13:30:00',1.78),('5819','2013-08-20','13:35:00',2.23),('5819','2013-08-20','13:40:00',3.42),('5819','2013-08-20','13:45:00',3.37),('5819','2013-08-20','13:50:00',3.75),('5819','2013-08-20','13:55:00',3.68),('5819','2013-08-20','14:00:00',3.63),('5819','2013-08-20','14:05:00',3.61),('5819','2013-08-20','14:10:00',3.52),('5819','2013-08-20','14:15:00',3.49),('5819','2013-08-20','14:20:00',3.47),('5819','2013-08-20','14:25:00',3.36),('5819','2013-08-20','14:30:00',2.79),('5819','2013-08-20','14:35:00',3.21),('5819','2013-08-20','14:40:00',3.19),('5819','2013-08-20','14:45:00',3.11),('5819','2013-08-20','14:50:00',3.34),('5819','2013-08-20','14:55:00',2.81),('5819','2013-08-20','15:00:00',3.39),('5819','2013-08-20','15:05:00',3.24),('5819','2013-08-20','15:10:00',3.37),('5819','2013-08-20','15:15:00',3.21),('5819','2013-08-20','15:20:00',3.19),('5819','2013-08-20','15:25:00',3.17),('5819','2013-08-20','15:30:00',3.13),('5819','2013-08-20','15:35:00',3.1),('5819','2013-08-20','15:40:00',3.14),('5819','2013-08-20','15:45:00',3.24),('5819','2013-08-20','15:50:00',3.24),('5819','2013-08-20','15:55:00',3.42),('5819','2013-08-20','16:00:00',3.18),('5819','2013-08-20','16:05:00',3.01),('5819','2013-08-20','16:10:00',3.04),('5819','2013-08-20','16:15:00',2.96),('5819','2013-08-20','16:20:00',2.88),('5819','2013-08-20','16:25:00',2.66),('5819','2013-08-20','16:30:00',2.38),('5819','2013-08-20','16:35:00',2.48),('5819','2013-08-20','16:40:00',2.55),('5819','2013-08-20','16:45:00',2.41),('5819','2013-08-20','16:50:00',2.09),('5819','2013-08-20','16:55:00',2),('5819','2013-08-20','17:00:00',1.86),('5819','2013-08-20','17:05:00',1.71),('5819','2013-08-20','17:10:00',1.61),('5819','2013-08-20','17:15:00',1.5),('5819','2013-08-20','17:20:00',1.45),('5819','2013-08-20','17:25:00',1.36),('5819','2013-08-20','17:30:00',1.26),('5819','2013-08-20','17:35:00',1.07),('5819','2013-08-20','17:40:00',1.01),('5819','2013-08-20','17:45:00',1.03),('5819','2013-08-19','07:50:00',1),('5819','2013-08-19','07:55:00',1.1),('5819','2013-08-19','08:00:00',1.17),('5819','2013-08-19','08:05:00',1.26),('5819','2013-08-19','08:10:00',1.34),('5819','2013-08-19','08:15:00',1.41),('5819','2013-08-19','08:20:00',1.48),('5819','2013-08-19','08:25:00',1.56),('5819','2013-08-19','08:30:00',1.62),('5819','2013-08-19','08:35:00',1.7),('5819','2013-08-19','08:40:00',1.79),('5819','2013-08-19','08:45:00',1.87),('5819','2013-08-19','08:50:00',1.97),('5819','2013-08-19','08:55:00',2.06),('5819','2013-08-19','09:00:00',2.14),('5819','2013-08-19','09:05:00',2.21),('5819','2013-08-19','09:10:00',2.26),('5819','2013-08-19','09:15:00',2.33),('5819','2013-08-19','09:20:00',2.4),('5819','2013-08-19','09:25:00',2.45),('5819','2013-08-19','09:30:00',2.5),('5819','2013-08-19','09:35:00',2.57),('5819','2013-08-19','09:40:00',2.63),('5819','2013-08-19','09:45:00',2.68),('5819','2013-08-19','09:50:00',2.72),('5819','2013-08-19','09:55:00',2.77),('5819','2013-08-19','10:00:00',2.82),('5819','2013-08-19','10:05:00',2.88),('5819','2013-08-19','10:10:00',2.92),('5819','2013-08-19','10:15:00',2.97),('5819','2013-08-19','10:20:00',3.01),('5819','2013-08-19','10:25:00',3.04),('5819','2013-08-19','10:30:00',3.07),('5819','2013-08-19','10:35:00',3.09),('5819','2013-08-19','10:40:00',3.14),('5819','2013-08-19','10:45:00',3.17),('5819','2013-08-19','10:50:00',3.21),('5819','2013-08-19','10:55:00',3.24),('5819','2013-08-19','11:00:00',3.24),('5819','2013-08-19','11:05:00',3.26),('5819','2013-08-19','11:10:00',3.3),('5819','2013-08-19','11:15:00',3.34),('5819','2013-08-19','11:20:00',3.34),('5819','2013-08-19','11:25:00',3.37),('5819','2013-08-19','11:30:00',3.38),('5819','2013-08-19','11:35:00',3.41),('5819','2013-08-19','11:40:00',3.41),('5819','2013-08-19','11:45:00',3.42),('5819','2013-08-19','11:50:00',3.46),('5819','2013-08-19','11:55:00',3.46),('5819','2013-08-19','12:00:00',3.43),('5819','2013-08-19','12:05:00',3.44),('5819','2013-08-19','12:10:00',3.53),('5819','2013-08-19','12:15:00',3.52),('5819','2013-08-19','12:20:00',3.55),('5819','2013-08-19','12:25:00',3.54),('5819','2013-08-19','12:30:00',3.54),('5819','2013-08-19','12:35:00',3.53),('5819','2013-08-19','12:40:00',3.55),('5819','2013-08-19','12:45:00',3.53),('5819','2013-08-19','12:50:00',3.54),('5819','2013-08-19','12:55:00',3.55),('5819','2013-08-19','13:00:00',3.56),('5819','2013-08-19','13:05:00',3.55),('5819','2013-08-19','13:10:00',3.56),('5819','2013-08-19','13:15:00',3.53),('5819','2013-08-19','13:20:00',3.55),('5819','2013-08-19','13:25:00',3.54),('5819','2013-08-19','13:30:00',3.55),('5819','2013-08-19','13:35:00',3.53),('5819','2013-08-19','13:40:00',3.53),('5819','2013-08-19','13:45:00',3.51),('5819','2013-08-19','13:50:00',3.48),('5819','2013-08-19','13:55:00',3.48),('5819','2013-08-19','14:00:00',3.44),('5819','2013-08-19','14:05:00',3.41),('5819','2013-08-19','14:10:00',3.39),('5819','2013-08-19','14:15:00',3.35),('5819','2013-08-19','14:20:00',3.34),('5819','2013-08-19','14:25:00',3.34),('5819','2013-08-19','14:30:00',3.32),('5819','2013-08-19','14:35:00',3.29),('5819','2013-08-19','14:40:00',3.25),('5819','2013-08-19','14:45:00',3.22),('5819','2013-08-19','14:50:00',3.19),('5819','2013-08-19','14:55:00',3.15),('5819','2013-08-19','15:00:00',3.12),('5819','2013-08-19','15:05:00',3.08),('5819','2013-08-19','15:10:00',3.03),('5819','2013-08-19','15:15:00',2.99),('5819','2013-08-19','15:20:00',2.93),('5819','2013-08-19','15:25:00',2.89),('5819','2013-08-19','15:30:00',2.85),('5819','2013-08-19','15:35:00',2.8),('5819','2013-08-19','15:40:00',2.75),('5819','2013-08-19','15:45:00',2.7),('5819','2013-08-19','15:50:00',2.64),('5819','2013-08-19','15:55:00',2.59),('5819','2013-08-19','16:00:00',2.53),('5819','2013-08-19','16:05:00',2.44),('5819','2013-08-19','16:10:00',2.36),('5819','2013-08-19','16:15:00',2.28),('5819','2013-08-19','16:20:00',2.25),('5819','2013-08-19','16:25:00',2.2),('5819','2013-08-19','16:30:00',2.12),('5819','2013-08-19','16:35:00',2.06),('5819','2013-08-19','16:40:00',1.98),('5819','2013-08-19','16:45:00',1.91),('5819','2013-08-19','16:50:00',1.85),('5819','2013-08-19','16:55:00',1.78),('5819','2013-08-19','17:00:00',1.71),('5819','2013-08-19','17:05:00',1.62),('5819','2013-08-19','17:10:00',1.54),('5819','2013-08-19','17:15:00',1.47),('5819','2013-08-19','17:20:00',1.39),('5819','2013-08-19','17:25:00',1.32),('5819','2013-08-19','17:30:00',1.23),('5819','2013-08-19','17:35:00',1.06),('5819','2013-08-19','17:40:00',1.07),('5819','2013-08-18','07:50:00',1.07),('5819','2013-08-18','07:55:00',1.15),('5819','2013-08-18','08:00:00',1.24),('5819','2013-08-18','08:05:00',1.31),('5819','2013-08-18','08:10:00',1.4),('5819','2013-08-18','08:15:00',1.48),('5819','2013-08-18','08:20:00',1.58),('5819','2013-08-18','08:25:00',1.66),('5819','2013-08-18','08:30:00',1.74),('5819','2013-08-18','08:35:00',1.81),('5819','2013-08-18','08:40:00',1.89),('5819','2013-08-18','08:45:00',1.97),('5819','2013-08-18','08:50:00',2.04),('5819','2013-08-18','08:55:00',2.1),('5819','2013-08-18','09:00:00',2.16),('5819','2013-08-18','09:05:00',2.23),('5819','2013-08-18','09:10:00',2.3),('5819','2013-08-18','09:15:00',2.37),('5819','2013-08-18','09:20:00',2.44),('5819','2013-08-18','09:25:00',2.5),('5819','2013-08-18','09:30:00',2.58),('5819','2013-08-18','09:35:00',2.63),('5819','2013-08-18','09:40:00',2.72),('5819','2013-08-18','09:45:00',2.54),('5819','2013-08-18','09:50:00',2.82),('5819','2013-08-18','09:55:00',2.06),('5819','2013-08-18','10:00:00',2.89),('5819','2013-08-18','10:05:00',2.45),('5819','2013-08-18','10:10:00',2.55),('5819','2013-08-18','10:15:00',3),('5819','2013-08-18','10:20:00',3.02),('5819','2013-08-18','10:25:00',3.07),('5819','2013-08-18','10:30:00',3.08),('5819','2013-08-18','10:35:00',3.1),('5819','2013-08-18','10:40:00',3.13),('5819','2013-08-18','10:45:00',3.17),('5819','2013-08-18','10:50:00',3.2),('5819','2013-08-18','10:55:00',3.23),('5819','2013-08-18','11:00:00',3.23),('5819','2013-08-18','11:05:00',3.3),('5819','2013-08-18','11:10:00',3.29),('5819','2013-08-18','11:15:00',3.3),('5819','2013-08-18','11:20:00',3.32),('5819','2013-08-18','11:25:00',3.36),('5819','2013-08-18','11:30:00',3.39),('5819','2013-08-18','11:35:00',3.37),('5819','2013-08-18','11:40:00',3.4),('5819','2013-08-18','11:45:00',3.43),('5819','2013-08-18','11:50:00',3.45),('5819','2013-08-18','11:55:00',3.45),('5819','2013-08-18','12:00:00',3.44),('5819','2013-08-18','12:05:00',3.47),('5819','2013-08-18','12:10:00',3.5),('5819','2013-08-18','12:15:00',3.42),('5819','2013-08-18','12:20:00',3.53),('5819','2013-08-18','12:25:00',3.65),('5819','2013-08-18','12:30:00',3.58),('5819','2013-08-18','12:35:00',3.31),('5819','2013-08-18','12:40:00',2.35),('5819','2013-08-18','12:45:00',1.88),('5819','2013-08-18','12:50:00',1.22),('5819','2013-08-18','12:55:00',2.6),('5819','2013-08-18','13:00:00',1.49),('5819','2013-08-18','13:05:00',3.75),('5819','2013-08-18','13:10:00',3.8),('5819','2013-08-18','13:15:00',3.49),('5819','2013-08-18','13:20:00',3.38),('5819','2013-08-18','13:25:00',3.63),('5819','2013-08-18','13:30:00',3.49),('5819','2013-08-18','13:35:00',3.51),('5819','2013-08-18','13:40:00',3.56),('5819','2013-08-18','13:45:00',3.51),('5819','2013-08-18','13:50:00',3.51),('5819','2013-08-18','13:55:00',2.94),('5819','2013-08-18','14:00:00',3.48),('5819','2013-08-18','14:05:00',3.48),('5819','2013-08-18','14:10:00',3.41),('5819','2013-08-18','14:15:00',3.38),('5819','2013-08-18','14:20:00',3.33),('5819','2013-08-18','14:25:00',3.31),('5819','2013-08-18','14:30:00',3.29),('5819','2013-08-18','14:35:00',3.27),('5819','2013-08-18','14:40:00',3.24),('5819','2013-08-18','14:45:00',3.21),('5819','2013-08-18','14:50:00',3.17),('5819','2013-08-18','14:55:00',3.14),('5819','2013-08-18','15:00:00',3.1),('5819','2013-08-18','15:05:00',3.06),('5819','2013-08-18','15:10:00',3.01),('5819','2013-08-18','15:15:00',2.97),('5819','2013-08-18','15:20:00',2.91),('5819','2013-08-18','15:25:00',2.87),('5819','2013-08-18','15:30:00',2.81),('5819','2013-08-18','15:35:00',2.78),('5819','2013-08-18','15:40:00',2.73),('5819','2013-08-18','15:45:00',2.67),('5819','2013-08-18','15:50:00',2.62),('5819','2013-08-18','15:55:00',2.55),('5819','2013-08-18','16:00:00',2.51),('5819','2013-08-18','16:05:00',2.45),('5819','2013-08-18','16:10:00',2.38),('5819','2013-08-18','16:15:00',2.31),('5819','2013-08-18','16:20:00',2.26),('5819','2013-08-18','16:25:00',2.19),('5819','2013-08-18','16:30:00',2.12),('5819','2013-08-18','16:35:00',2.06),('5819','2013-08-18','16:40:00',1.99),('5819','2013-08-18','16:45:00',1.91),('5819','2013-08-18','16:50:00',1.86),('5819','2013-08-18','16:55:00',1.78),('5819','2013-08-18','17:00:00',1.71),('5819','2013-08-18','17:05:00',1.64),('5819','2013-08-18','17:10:00',1.56),('5819','2013-08-18','17:15:00',1.49),('5819','2013-08-18','17:20:00',1.42),('5819','2013-08-18','17:25:00',1.34),('5819','2013-08-18','17:30:00',1.26),('5819','2013-08-18','17:35:00',1.08),('5819','2013-08-18','17:40:00',1.09),('5819','2013-08-18','17:45:00',1.01),('5819','2013-08-17','07:50:00',1.05),('5819','2013-08-17','07:55:00',1.12),('5819','2013-08-17','08:00:00',1.19),('5819','2013-08-17','08:05:00',1.28),('5819','2013-08-17','08:10:00',1.36),('5819','2013-08-17','08:15:00',1.43),('5819','2013-08-17','08:20:00',1.52),('5819','2013-08-17','08:25:00',1.59),('5819','2013-08-17','08:30:00',1.66),('5819','2013-08-17','08:35:00',1.75),('5819','2013-08-17','08:40:00',1.84),('5819','2013-08-17','08:45:00',1.93),('5819','2013-08-17','08:50:00',2),('5819','2013-08-17','08:55:00',2.08),('5819','2013-08-17','09:00:00',2.15),('5819','2013-08-17','09:05:00',2.22),('5819','2013-08-17','09:10:00',2.28),('5819','2013-08-17','09:15:00',2.34),('5819','2013-08-17','09:20:00',2.41),('5819','2013-08-17','09:25:00',2.49),('5819','2013-08-17','09:30:00',2.55),('5819','2013-08-17','09:35:00',2.61),('5819','2013-08-17','09:40:00',2.66),('5819','2013-08-17','09:45:00',2.71),('5819','2013-08-17','09:50:00',2.76),('5819','2013-08-17','09:55:00',2.82),('5819','2013-08-17','10:00:00',2.87),('5819','2013-08-17','10:05:00',2.91),('5819','2013-08-17','10:10:00',2.96),('5819','2013-08-17','10:15:00',3),('5819','2013-08-17','10:20:00',3.02),('5819','2013-08-17','10:25:00',3.07),('5819','2013-08-17','10:30:00',3.11),('5819','2013-08-17','10:35:00',3.14),('5819','2013-08-17','10:40:00',3.17),('5819','2013-08-17','10:45:00',3.2),('5819','2013-08-17','10:50:00',3.25),('5819','2013-08-17','10:55:00',3.28),('5819','2013-08-17','11:00:00',3.29),('5819','2013-08-17','11:05:00',3.32),('5819','2013-08-17','11:10:00',3.36),('5819','2013-08-17','11:15:00',3.36),('5819','2013-08-17','11:20:00',3.38),('5819','2013-08-17','11:25:00',3.4),('5819','2013-08-17','11:30:00',3.44),('5819','2013-08-17','11:35:00',3.45),('5819','2013-08-17','11:40:00',3.48),('5819','2013-08-17','11:45:00',3.48),('5819','2013-08-17','11:50:00',3.49),('5819','2013-08-17','11:55:00',3.56),('5819','2013-08-17','12:00:00',3.5),('5819','2013-08-17','12:05:00',3.52),('5819','2013-08-17','12:10:00',3.5),('5819','2013-08-17','12:15:00',3.37),('5819','2013-08-17','12:20:00',3.52),('5819','2013-08-17','12:25:00',3.57),('5819','2013-08-17','12:30:00',3.61),('5819','2013-08-17','12:35:00',3.57),('5819','2013-08-17','12:40:00',3.38),('5819','2013-08-17','12:45:00',3.51),('5819','2013-08-17','12:50:00',3.62),('5819','2013-08-17','12:55:00',3.58),('5819','2013-08-17','13:00:00',3.5),('5819','2013-08-17','13:05:00',3.28),('5819','2013-08-17','13:10:00',3.63),('5819','2013-08-17','13:15:00',3.61),('5819','2013-08-17','13:20:00',3.56),('5819','2013-08-17','13:25:00',3.66),('5819','2013-08-17','13:30:00',2.37),('5819','2013-08-17','13:35:00',3.16),('5819','2013-08-17','13:40:00',1.69),('5819','2013-08-17','13:50:00',1.34),('5819','2013-08-17','14:00:00',1.96),('5819','2013-08-17','14:05:00',2.89),('5819','2013-08-17','14:10:00',2.69),('5819','2013-08-17','14:15:00',3.53),('5819','2013-08-17','14:20:00',3.45),('5819','2013-08-17','14:25:00',3.44),('5819','2013-08-17','14:30:00',3.32),('5819','2013-08-17','14:35:00',3.31),('5819','2013-08-17','14:40:00',3.22),('5819','2013-08-17','14:45:00',3.2),('5819','2013-08-17','14:50:00',3.22),('5819','2013-08-17','14:55:00',3.13),('5819','2013-08-17','15:00:00',3.12),('5819','2013-08-17','15:05:00',3.09),('5819','2013-08-17','15:10:00',3.02),('5819','2013-08-17','15:15:00',2.97),('5819','2013-08-17','15:20:00',2.95),('5819','2013-08-17','15:25:00',2.88),('5819','2013-08-17','15:30:00',2.83),('5819','2013-08-17','15:35:00',2.83),('5819','2013-08-17','15:40:00',2.76),('5819','2013-08-17','15:45:00',2.68),('5819','2013-08-17','15:50:00',2.63),('5819','2013-08-17','15:55:00',2.57),('5819','2013-08-17','16:00:00',2.53),('5819','2013-08-17','16:05:00',2.46),('5819','2013-08-17','16:10:00',2.4),('5819','2013-08-17','16:15:00',2.35),('5819','2013-08-17','16:20:00',2.3),('5819','2013-08-17','16:25:00',2.23),('5819','2013-08-17','16:30:00',2.18),('5819','2013-08-17','16:35:00',2.12),('5819','2013-08-17','16:40:00',2.03),('5819','2013-08-17','16:45:00',1.95),('5819','2013-08-17','16:50:00',1.83),('5819','2013-08-17','16:55:00',1.83),('5819','2013-08-17','17:00:00',1.75),('5819','2013-08-17','17:05:00',1.67),('5819','2013-08-17','17:10:00',1.59),('5819','2013-08-17','17:15:00',1.35),('5819','2013-08-17','17:20:00',1.44),('5819','2013-08-17','17:25:00',1.35),('5819','2013-08-17','17:30:00',1.35),('5819','2013-08-17','17:35:00',1.2),('5819','2013-08-17','17:40:00',1.15),('5819','2013-08-17','17:45:00',1.1),('5819','2013-08-17','17:50:00',1.02),('5819','2013-08-16','07:45:00',1),('5819','2013-08-16','07:50:00',1.07),('5819','2013-08-16','07:55:00',1.15),('5819','2013-08-16','08:00:00',1.23),('5819','2013-08-16','08:05:00',1.31),('5819','2013-08-16','08:10:00',1.4),('5819','2013-08-16','08:15:00',1.5),('5819','2013-08-16','08:20:00',1.58),('5819','2013-08-16','08:25:00',1.67),('5819','2013-08-16','08:30:00',1.75),('5819','2013-08-16','08:35:00',1.83),('5819','2013-08-16','08:40:00',1.91),('5819','2013-08-16','08:45:00',1.99),('5819','2013-08-16','08:50:00',2.06),('5819','2013-08-16','08:55:00',2.14),('5819','2013-08-16','09:00:00',2.22),('5819','2013-08-16','09:05:00',2.3),('5819','2013-08-16','09:10:00',2.37),('5819','2013-08-16','09:15:00',2.45),('5819','2013-08-16','09:20:00',2.52),('5819','2013-08-16','09:25:00',2.58),('5819','2013-08-16','09:30:00',2.66),('5819','2013-08-16','09:35:00',2.72),('5819','2013-08-16','09:40:00',2.78),('5819','2013-08-16','09:45:00',2.83),('5819','2013-08-16','09:50:00',2.89),('5819','2013-08-16','09:55:00',2.94),('5819','2013-08-16','10:00:00',2.99),('5819','2013-08-16','10:05:00',3.04),('5819','2013-08-16','10:10:00',3.08),('5819','2013-08-16','10:15:00',3.12),('5819','2013-08-16','10:20:00',3.16),('5819','2013-08-16','10:25:00',3.2),('5819','2013-08-16','10:30:00',3.24),('5819','2013-08-16','10:35:00',3.28),('5819','2013-08-16','10:40:00',3.31),('5819','2013-08-16','10:45:00',3.34),('5819','2013-08-16','10:50:00',3.36),('5819','2013-08-16','10:55:00',3.39),('5819','2013-08-16','11:00:00',3.41),('5819','2013-08-16','11:05:00',3.46),('5819','2013-08-16','11:10:00',3.46),('5819','2013-08-16','11:15:00',3.47),('5819','2013-08-16','11:20:00',3.51),('5819','2013-08-16','11:25:00',3.51),('5819','2013-08-16','11:30:00',3.54),('5819','2013-08-16','11:35:00',3.57),('5819','2013-08-16','11:40:00',3.56),('5819','2013-08-16','11:45:00',3.56),('5819','2013-08-16','11:50:00',3.57),('5819','2013-08-16','11:55:00',3.57),('5819','2013-08-16','12:00:00',3.6),('5819','2013-08-16','12:05:00',3.61),('5819','2013-08-16','12:10:00',3.62),('5819','2013-08-16','12:15:00',3.64),('5819','2013-08-16','12:20:00',3.65),('5819','2013-08-16','12:25:00',3.64),('5819','2013-08-16','12:30:00',3.62),('5819','2013-08-16','12:35:00',3.59),('5819','2013-08-16','12:40:00',3.6),('5819','2013-08-16','12:45:00',3.6),('5819','2013-08-16','12:50:00',3.6),('5819','2013-08-16','12:55:00',3.58),('5819','2013-08-16','13:00:00',3.57),('5819','2013-08-16','13:05:00',3.58),('5819','2013-08-16','13:10:00',3.57),('5819','2013-08-16','13:15:00',3.57),('5819','2013-08-16','13:20:00',3.53),('5819','2013-08-16','13:25:00',3.51),('5819','2013-08-16','13:30:00',3.5),('5819','2013-08-16','13:35:00',3.49),('5819','2013-08-16','13:40:00',3.48),('5819','2013-08-16','13:45:00',3.48),('5819','2013-08-16','13:50:00',3.47),('5819','2013-08-16','13:55:00',3.43),('5819','2013-08-16','14:00:00',3.41),('5819','2013-08-16','14:05:00',3.4),('5819','2013-08-16','14:10:00',3.37),('5819','2013-08-16','14:15:00',3.36),('5819','2013-08-16','14:20:00',3.31),('5819','2013-08-16','14:25:00',3.28),('5819','2013-08-16','14:30:00',3.24),('5819','2013-08-16','14:35:00',3.2),('5819','2013-08-16','14:40:00',3.16),('5819','2013-08-16','14:45:00',3.14),('5819','2013-08-16','14:50:00',3.11),('5819','2013-08-16','14:55:00',3.09),('5819','2013-08-16','15:00:00',3.04),('5819','2013-08-16','15:05:00',2.96),('5819','2013-08-16','15:10:00',2.96),('5819','2013-08-16','15:15:00',2.93),('5819','2013-08-16','15:20:00',2.86),('5819','2013-08-16','15:25:00',2.83),('5819','2013-08-16','15:30:00',2.81),('5819','2013-08-16','15:35:00',2.78),('5819','2013-08-16','15:40:00',2.71),('5819','2013-08-16','15:45:00',2.67),('5819','2013-08-16','15:50:00',2.62),('5819','2013-08-16','15:55:00',2.58),('5819','2013-08-16','16:00:00',2.52),('5819','2013-08-16','16:05:00',2.47),('5819','2013-08-16','16:10:00',2.41),('5819','2013-08-16','16:15:00',2.33),('5819','2013-08-16','16:20:00',2.27),('5819','2013-08-16','16:25:00',2.2),('5819','2013-08-16','16:30:00',2.14),('5819','2013-08-16','16:35:00',2.08),('5819','2013-08-16','16:40:00',2.03),('5819','2013-08-16','16:45:00',1.96),('5819','2013-08-16','16:50:00',1.88),('5819','2013-08-16','16:55:00',1.8),('5819','2013-08-16','17:00:00',1.73),('5819','2013-08-16','17:05:00',1.65),('5819','2013-08-16','17:10:00',1.57),('5819','2013-08-16','17:15:00',1.49),('5819','2013-08-16','17:20:00',1.41),('5819','2013-08-16','17:25:00',1.34),('5819','2013-08-16','17:30:00',1.26),('5819','2013-08-16','17:35:00',1.13),('5819','2013-08-16','17:40:00',1.07),('5819','2013-08-16','17:45:00',1.01),('5819','2013-08-15','08:05:00',1.41),('5819','2013-08-15','08:10:00',1.33),('5819','2013-08-15','08:15:00',1.43),('5819','2013-08-15','08:20:00',1.65),('5819','2013-08-15','08:25:00',1.71),('5819','2013-08-15','08:30:00',1.78),('5819','2013-08-15','08:35:00',1.87),('5819','2013-08-15','08:40:00',1.94),('5819','2013-08-15','08:45:00',2.04),('5819','2013-08-15','08:50:00',2.12),('5819','2013-08-15','08:55:00',2.19),('5819','2013-08-15','09:00:00',2.28),('5819','2013-08-15','09:05:00',2.15),('5819','2013-08-15','09:10:00',1.7),('5819','2013-08-15','09:15:00',1.4),('5819','2013-08-15','09:20:00',2.46),('5819','2013-08-15','09:25:00',2.58),('5819','2013-08-15','09:30:00',2.64),('5819','2013-08-15','09:35:00',2.71),('5819','2013-08-15','09:40:00',2.77),('5819','2013-08-15','09:45:00',2.82),('5819','2013-08-15','09:50:00',2.89),('5819','2013-08-15','09:55:00',2.95),('5819','2013-08-15','10:00:00',3),('5819','2013-08-15','10:05:00',3.03),('5819','2013-08-15','10:10:00',3.08),('5819','2013-08-15','10:15:00',3.14),('5819','2013-08-15','10:20:00',3.18),('5819','2013-08-15','10:25:00',3.25),('5819','2013-08-15','10:30:00',3.28),('5819','2013-08-15','10:35:00',3.29),('5819','2013-08-15','10:40:00',3.32),('5819','2013-08-15','10:45:00',3.3),('5819','2013-08-15','10:50:00',3.25),('5819','2013-08-15','10:55:00',3.24),('5819','2013-08-15','11:00:00',3.16),('5819','2013-08-15','11:05:00',2.72),('5819','2013-08-15','11:10:00',2.42),('5819','2013-08-15','11:15:00',2.59),('5819','2013-08-15','11:20:00',2.96),('5819','2013-08-15','11:25:00',3.25),('5819','2013-08-15','11:30:00',3.63),('5819','2013-08-15','11:35:00',3.76),('5819','2013-08-15','11:40:00',3.82),('5819','2013-08-15','11:45:00',3.89),('5819','2013-08-15','11:50:00',3.89),('5819','2013-08-15','11:55:00',3.88),('5819','2013-08-15','12:00:00',3.86),('5819','2013-08-15','12:05:00',3.84),('5819','2013-08-15','12:10:00',3.8),('5819','2013-08-15','12:15:00',3.82),('5819','2013-08-15','12:20:00',3.79),('5819','2013-08-15','12:25:00',3.8),('5819','2013-08-15','12:30:00',3.78),('5819','2013-08-15','12:35:00',3.79),('5819','2013-08-15','12:40:00',3.76),('5819','2013-08-15','12:45:00',3.79),('5819','2013-08-15','12:50:00',3.72),('5819','2013-08-15','12:55:00',3.54),('5819','2013-08-15','13:00:00',3.55),('5819','2013-08-15','13:05:00',3.54),('5819','2013-08-15','13:10:00',3.5),('5819','2013-08-15','13:15:00',3.42),('5819','2013-08-15','13:20:00',3.43),('5819','2013-08-15','13:25:00',3.57),('5819','2013-08-15','13:30:00',3.63),('5819','2013-08-15','13:35:00',3.62),('5819','2013-08-15','13:40:00',3.56),('5819','2013-08-15','13:45:00',3.54),('5819','2013-08-15','13:50:00',3.49),('5819','2013-08-15','13:55:00',3.46),('5819','2013-08-15','14:00:00',3.49),('5819','2013-08-15','14:05:00',3.47),('5819','2013-08-15','14:10:00',3.45),('5819','2013-08-15','14:15:00',3.42),('5819','2013-08-15','14:20:00',3.37),('5819','2013-08-15','14:25:00',3.28),('5819','2013-08-15','14:30:00',3.22),('5819','2013-08-15','14:35:00',3.28),('5819','2013-08-15','14:40:00',3.23),('5819','2013-08-15','14:45:00',3.16),('5819','2013-08-15','14:50:00',3.14),('5819','2013-08-15','14:55:00',3.08),('5819','2013-08-15','15:00:00',3.06),('5819','2013-08-15','15:05:00',3.04),('5819','2013-08-15','15:10:00',3),('5819','2013-08-15','15:15:00',2.94),('5819','2013-08-15','15:20:00',2.86),('5819','2013-08-15','15:25:00',2.81),('5819','2013-08-15','15:30:00',2.79),('5819','2013-08-15','15:35:00',2.76),('5819','2013-08-15','15:40:00',2.69),('5819','2013-08-15','15:45:00',2.6),('5819','2013-08-15','15:50:00',2.55),('5819','2013-08-15','15:55:00',2.54),('5819','2013-08-15','16:00:00',2.46),('5819','2013-08-15','16:05:00',2.38),('5819','2013-08-15','16:10:00',2.19),('5819','2013-08-15','16:15:00',2.25),('5819','2013-08-15','16:20:00',2.25),('5819','2013-08-15','16:25:00',2.14),('5819','2013-08-15','16:30:00',2.04),('5819','2013-08-15','16:35:00',2.01),('5819','2013-08-15','16:40:00',1.95),('5819','2013-08-15','16:45:00',1.88),('5819','2013-08-15','16:50:00',1.83),('5819','2013-08-15','16:55:00',1.72),('5819','2013-08-15','17:00:00',1.69),('5819','2013-08-15','17:05:00',1.63),('5819','2013-08-15','17:10:00',1.56),('5819','2013-08-15','17:15:00',1.5),('5819','2013-08-15','17:20:00',1.44),('5819','2013-08-15','17:25:00',1.34),('5819','2013-08-15','17:30:00',1.28),('5819','2013-08-15','17:35:00',1.17),('5819','2013-08-15','17:45:00',1.04),('5819','2013-08-14','07:50:00',1.04),('5819','2013-08-14','07:55:00',1.12),('5819','2013-08-14','08:00:00',1.2),('5819','2013-08-14','08:05:00',1.27),('5819','2013-08-14','08:10:00',1.34),('5819','2013-08-14','08:15:00',1.44),('5819','2013-08-14','08:20:00',1.52),('5819','2013-08-14','08:25:00',1.54),('5819','2013-08-14','08:30:00',1.66),('5819','2013-08-14','08:35:00',1.71),('5819','2013-08-14','08:40:00',1.86),('5819','2013-08-14','08:45:00',1.98),('5819','2013-08-14','08:50:00',1.97),('5819','2013-08-14','08:55:00',2.01),('5819','2013-08-14','09:00:00',2.11),('5819','2013-08-14','09:05:00',2.18),('5819','2013-08-14','09:10:00',2.27),('5819','2013-08-14','09:15:00',2.36),('5819','2013-08-14','09:20:00',2.41),('5819','2013-08-14','09:25:00',2.34),('5819','2013-08-14','09:30:00',2.54),('5819','2013-08-14','09:35:00',2.7),('5819','2013-08-14','09:40:00',2.72),('5819','2013-08-14','09:45:00',1.19),('5819','2013-08-14','09:55:00',1.15),('5819','2013-08-14','10:00:00',1.57),('5819','2013-08-14','10:05:00',2.16),('5819','2013-08-14','10:10:00',2.55),('5819','2013-08-14','10:15:00',2.83),('5819','2013-08-14','10:20:00',2.7),('5819','2013-08-14','10:25:00',3.1),('5819','2013-08-14','10:30:00',3.32),('5819','2013-08-14','10:35:00',3.36),('5819','2013-08-14','10:40:00',3.45),('5819','2013-08-14','10:45:00',2.46),('5819','2013-08-14','10:50:00',2.62),('5819','2013-08-14','10:55:00',1.7),('5819','2013-08-14','11:00:00',2.56),('5819','2013-08-14','11:05:00',3.44),('5819','2013-08-14','11:10:00',1.6),('5819','2013-08-14','11:15:00',1.81),('5819','2013-08-14','11:20:00',3.01),('5819','2013-08-14','11:25:00',2.98),('5819','2013-08-14','11:30:00',3.58),('5819','2013-08-14','11:35:00',3.63),('5819','2013-08-14','11:40:00',3.67),('5819','2013-08-14','11:45:00',2.6),('5819','2013-08-14','11:50:00',1.37),('5819','2013-08-14','11:55:00',1.32),('5819','2013-08-14','12:00:00',1.29),('5819','2013-08-14','12:05:00',1.83),('5819','2013-08-14','12:10:00',1.84),('5819','2013-08-14','12:15:00',2.06),('5819','2013-08-14','12:20:00',1.9),('5819','2013-08-14','12:25:00',1.11),('5819','2013-08-14','12:30:00',1.24),('5819','2013-08-14','12:35:00',1.96),('5819','2013-08-14','12:40:00',1.62),('5819','2013-08-14','12:50:00',1.07),('5819','2013-08-14','12:55:00',1.88),('5819','2013-08-14','13:00:00',1.53),('5819','2013-08-14','13:25:00',1.04),('5819','2013-08-14','13:30:00',1.73),('5819','2013-08-14','13:35:00',1.18),('5819','2013-08-14','13:40:00',2.33),('5819','2013-08-14','13:45:00',3.26),('5819','2013-08-14','13:50:00',3.93),('5819','2013-08-14','13:55:00',2.8),('5819','2013-08-14','14:00:00',1.61),('5819','2013-08-14','14:05:00',3.79),('5819','2013-08-14','14:10:00',2.1),('5819','2013-08-14','14:15:00',3.79),('5819','2013-08-14','14:20:00',3.69),('5819','2013-08-14','14:25:00',3.69),('5819','2013-08-14','14:30:00',3.59),('5819','2013-08-14','14:35:00',3.57),('5819','2013-08-14','14:40:00',3.42),('5819','2013-08-14','14:45:00',3.34),('5819','2013-08-14','14:50:00',3.33),('5819','2013-08-14','14:55:00',2.46),('5819','2013-08-14','15:00:00',3.21),('5819','2013-08-14','15:05:00',3.18),('5819','2013-08-14','15:10:00',3.06),('5819','2013-08-14','15:15:00',3.09),('5819','2013-08-14','15:20:00',3.16),('5819','2013-08-14','15:25:00',3.08),('5819','2013-08-14','15:30:00',2.92),('5819','2013-08-14','15:35:00',2.83),('5819','2013-08-14','15:40:00',2.8),('5819','2013-08-14','15:45:00',2.75),('5819','2013-08-14','15:50:00',2.7),('5819','2013-08-14','15:55:00',2.63),('5819','2013-08-14','16:00:00',2.6),('5819','2013-08-14','16:05:00',2.56),('5819','2013-08-14','16:10:00',2.51),('5819','2013-08-14','16:15:00',2.43),('5819','2013-08-14','16:20:00',2.39),('5819','2013-08-14','16:25:00',2.3),('5819','2013-08-14','16:30:00',2.22),('5819','2013-08-14','16:35:00',2.18),('5819','2013-08-14','16:40:00',2.11),('5819','2013-08-14','16:45:00',2.01),('5819','2013-08-14','16:50:00',1.97),('5819','2013-08-14','16:55:00',1.88),('5819','2013-08-14','17:00:00',1.8),('5819','2013-08-14','17:05:00',1.71),('5819','2013-08-14','17:10:00',1.63),('5819','2013-08-14','17:15:00',1.57),('5819','2013-08-14','17:20:00',1.49),('5819','2013-08-14','17:25:00',1.41),('5819','2013-08-14','17:30:00',1.34),('5819','2013-08-14','17:35:00',1.24),('5819','2013-08-14','17:40:00',1.09),('5819','2013-08-14','17:45:00',1.09),('5819','2013-08-14','17:50:00',1.02),('5819','2013-08-13','07:50:00',1.06),('5819','2013-08-13','07:55:00',1.15),('5819','2013-08-13','08:00:00',1.25),('5819','2013-08-13','08:05:00',1.32),('5819','2013-08-13','08:10:00',1.37),('5819','2013-08-13','08:15:00',1.43),('5819','2013-08-13','08:20:00',1.54),('5819','2013-08-13','08:25:00',1.65),('5819','2013-08-13','08:30:00',1.74),('5819','2013-08-13','08:35:00',1.83),('5819','2013-08-13','08:40:00',1.89),('5819','2013-08-13','08:45:00',1.96),('5819','2013-08-13','08:50:00',2.05),('5819','2013-08-13','08:55:00',2.13),('5819','2013-08-13','09:00:00',2.2),('5819','2013-08-13','09:05:00',2.27),('5819','2013-08-13','09:10:00',2.33),('5819','2013-08-13','09:15:00',2.41),('5819','2013-08-13','09:20:00',2.44),('5819','2013-08-13','09:25:00',2.45),('5819','2013-08-13','09:30:00',2.45),('5819','2013-08-13','09:35:00',2.6),('5819','2013-08-13','09:40:00',2.74),('5819','2013-08-13','09:45:00',2.67),('5819','2013-08-13','09:50:00',2.83),('5819','2013-08-13','09:55:00',2.86),('5819','2013-08-13','10:00:00',2.58),('5819','2013-08-13','10:05:00',1.86),('5819','2013-08-13','10:10:00',3),('5819','2013-08-13','10:15:00',3.14),('5819','2013-08-13','10:20:00',3.07),('5819','2013-08-13','10:25:00',3.15),('5819','2013-08-13','10:30:00',3.16),('5819','2013-08-13','10:35:00',3.22),('5819','2013-08-13','10:40:00',3.24),('5819','2013-08-13','10:45:00',3.26),('5819','2013-08-13','10:50:00',3.3),('5819','2013-08-13','10:55:00',3.32),('5819','2013-08-13','11:00:00',3.35),('5819','2013-08-13','11:05:00',3.41),('5819','2013-08-13','11:10:00',3.4),('5819','2013-08-13','11:15:00',3.4),('5819','2013-08-13','11:20:00',3.45),('5819','2013-08-13','11:25:00',3.46),('5819','2013-08-13','11:30:00',3.49),('5819','2013-08-13','11:35:00',3.47),('5819','2013-08-13','11:40:00',3.48),('5819','2013-08-13','11:45:00',3.48),('5819','2013-08-13','11:50:00',3.52),('5819','2013-08-13','11:55:00',3.61),('5819','2013-08-13','12:00:00',3.65),('5819','2013-08-13','12:05:00',3.67),('5819','2013-08-13','12:10:00',3.69),('5819','2013-08-13','12:15:00',3.75),('5819','2013-08-13','12:20:00',3.76),('5819','2013-08-13','12:25:00',3.77),('5819','2013-08-13','12:30:00',3.79),('5819','2013-08-13','12:35:00',3.09),('5819','2013-08-13','12:40:00',3.69),('5819','2013-08-13','12:45:00',1.82),('5819','2013-08-13','12:50:00',3.1),('5819','2013-08-13','12:55:00',3.71),('5819','2013-08-13','13:00:00',1.24),('5819','2013-08-13','13:05:00',1.16),('5819','2013-08-13','13:10:00',1.12),('5819','2013-08-13','13:15:00',1.79),('5819','2013-08-13','13:20:00',4.26),('5819','2013-08-13','13:25:00',4.07),('5819','2013-08-13','13:30:00',3.99),('5819','2013-08-13','13:35:00',3.87),('5819','2013-08-13','13:40:00',3.88),('5819','2013-08-13','13:45:00',3.95),('5819','2013-08-13','13:50:00',3.94),('5819','2013-08-13','13:55:00',3.9),('5819','2013-08-13','14:00:00',3.75),('5819','2013-08-13','14:05:00',3.8),('5819','2013-08-13','14:10:00',2.93),('5819','2013-08-13','14:15:00',3.66),('5819','2013-08-13','14:20:00',3.72),('5819','2013-08-13','14:25:00',2.97),('5819','2013-08-13','14:30:00',1.34),('5819','2013-08-13','14:35:00',3.58),('5819','2013-08-13','14:40:00',2.53),('5819','2013-08-13','14:45:00',1.66),('5819','2013-08-13','14:50:00',3.39),('5819','2013-08-13','14:55:00',3.6),('5819','2013-08-13','15:00:00',3.04),('5819','2013-08-13','15:05:00',2.61),('5819','2013-08-13','15:10:00',2.09),('5819','2013-08-13','15:15:00',2.72),('5819','2013-08-13','15:20:00',3.05),('5819','2013-08-13','15:25:00',3.05),('5819','2013-08-13','15:30:00',2.94),('5819','2013-08-13','15:35:00',2.92),('5819','2013-08-13','15:40:00',2.86),('5819','2013-08-13','15:45:00',2.78),('5819','2013-08-13','15:50:00',2.7),('5819','2013-08-13','15:55:00',2.64),('5819','2013-08-13','16:00:00',2.59),('5819','2013-08-13','16:05:00',2.52),('5819','2013-08-13','16:10:00',2.45),('5819','2013-08-13','16:15:00',2.4),('5819','2013-08-13','16:20:00',2.34),('5819','2013-08-13','16:25:00',2.28),('5819','2013-08-13','16:30:00',2.2),('5819','2013-08-13','16:35:00',2.14),('5819','2013-08-13','16:40:00',2.08),('5819','2013-08-13','16:45:00',2.01),('5819','2013-08-13','16:50:00',1.94),('5819','2013-08-13','16:55:00',1.86),('5819','2013-08-13','17:00:00',1.78),('5819','2013-08-13','17:05:00',1.71),('5819','2013-08-13','17:10:00',1.65),('5819','2013-08-13','17:15:00',1.57),('5819','2013-08-13','17:20:00',1.49),('5819','2013-08-13','17:25:00',1.41),('5819','2013-08-13','17:30:00',1.33),('5819','2013-08-13','17:35:00',1.24),('5819','2013-08-13','17:40:00',1.03),('5819','2013-08-13','17:45:00',1.07),('5819','2013-08-13','17:50:00',1),('5819','2013-08-12','07:50:00',1.06),('5819','2013-08-12','07:55:00',1.14),('5819','2013-08-12','08:00:00',1.22),('5819','2013-08-12','08:05:00',1.3),('5819','2013-08-12','08:10:00',1.37),('5819','2013-08-12','08:15:00',1.45),('5819','2013-08-12','08:20:00',1.54),('5819','2013-08-12','08:25:00',1.62),('5819','2013-08-12','08:30:00',1.69),('5819','2013-08-12','08:35:00',1.77),('5819','2013-08-12','08:40:00',1.84),('5819','2013-08-12','08:45:00',1.92),('5819','2013-08-12','08:50:00',2),('5819','2013-08-12','08:55:00',2.08),('5819','2013-08-12','09:00:00',2.15),('5819','2013-08-12','09:05:00',2.22),('5819','2013-08-12','09:10:00',2.29),('5819','2013-08-12','09:15:00',2.36),('5819','2013-08-12','09:20:00',2.42),('5819','2013-08-12','09:25:00',2.48),('5819','2013-08-12','09:30:00',2.53),('5819','2013-08-12','09:35:00',2.59),('5819','2013-08-12','09:40:00',2.65),('5819','2013-08-12','09:45:00',2.71),('5819','2013-08-12','09:50:00',2.75),('5819','2013-08-12','09:55:00',2.8),('5819','2013-08-12','10:00:00',2.84),('5819','2013-08-12','10:05:00',2.88),('5819','2013-08-12','10:10:00',2.91),('5819','2013-08-12','10:15:00',2.95),('5819','2013-08-12','10:20:00',3),('5819','2013-08-12','10:25:00',3.04),('5819','2013-08-12','10:30:00',3.06),('5819','2013-08-12','10:35:00',3.09),('5819','2013-08-12','10:40:00',3.16),('5819','2013-08-12','10:45:00',3.19),('5819','2013-08-12','10:50:00',3.23),('5819','2013-08-12','10:55:00',3.26),('5819','2013-08-12','11:00:00',3.27),('5819','2013-08-12','11:05:00',3.3),('5819','2013-08-12','11:10:00',3.34),('5819','2013-08-12','11:15:00',3.36),('5819','2013-08-12','11:20:00',3.34),('5819','2013-08-12','11:25:00',3.38),('5819','2013-08-12','11:30:00',3.38),('5819','2013-08-12','11:35:00',3.31),('5819','2013-08-12','11:40:00',3.44),('5819','2013-08-12','11:45:00',3.5),('5819','2013-08-12','11:50:00',3.51),('5819','2013-08-12','11:55:00',3.55),('5819','2013-08-12','12:00:00',3.61),('5819','2013-08-12','12:05:00',3.67),('5819','2013-08-12','12:10:00',3.55),('5819','2013-08-12','12:15:00',2.95),('5819','2013-08-12','12:20:00',1.08),('5819','2013-08-12','12:25:00',1.04),('5819','2013-08-12','12:40:00',1.22),('5819','2013-08-12','12:45:00',2.95),('5819','2013-08-12','12:50:00',1.66),('5819','2013-08-12','12:55:00',1.24),('5819','2013-08-12','13:00:00',1.01),('5819','2013-08-12','13:25:00',1.97),('5819','2013-08-12','13:30:00',1.12),('5819','2013-08-12','13:35:00',1.12),('5819','2013-08-12','13:40:00',1.04),('5819','2013-08-12','13:50:00',2.19),('5819','2013-08-12','13:55:00',3.53),('5819','2013-08-12','14:00:00',1.29),('5819','2013-08-12','14:10:00',1.12),('5819','2013-08-12','14:15:00',1.57),('5819','2013-08-12','14:20:00',1.13),('5819','2013-08-12','14:40:00',1.06),('5819','2013-08-12','14:45:00',1.11),('5819','2013-08-12','14:50:00',1.85),('5819','2013-08-12','14:55:00',3.82),('5819','2013-08-12','15:00:00',3.52),('5819','2013-08-12','15:05:00',2.92),('5819','2013-08-12','15:10:00',3.38),('5819','2013-08-12','15:15:00',3.28),('5819','2013-08-12','15:20:00',2.65),('5819','2013-08-12','15:25:00',2.87),('5819','2013-08-12','15:30:00',3.05),('5819','2013-08-12','15:35:00',2.85),('5819','2013-08-12','15:40:00',2.84),('5819','2013-08-12','15:45:00',2.76),('5819','2013-08-12','15:50:00',2.71),('5819','2013-08-12','15:55:00',2.65),('5819','2013-08-12','16:00:00',2.58),('5819','2013-08-12','16:05:00',2.51),('5819','2013-08-12','16:10:00',2.46),('5819','2013-08-12','16:15:00',2.39),('5819','2013-08-12','16:20:00',2.33),('5819','2013-08-12','16:25:00',2.27),('5819','2013-08-12','16:30:00',2.21),('5819','2013-08-12','16:35:00',2.12),('5819','2013-08-12','16:40:00',2.07),('5819','2013-08-12','16:45:00',1.99),('5819','2013-08-12','16:50:00',1.92),('5819','2013-08-12','16:55:00',1.85),('5819','2013-08-12','17:00:00',1.8),('5819','2013-08-12','17:05:00',1.72),('5819','2013-08-12','17:10:00',1.63),('5819','2013-08-12','17:15:00',1.55),('5819','2013-08-12','17:20:00',1.48),('5819','2013-08-12','17:25:00',1.4),('5819','2013-08-12','17:30:00',1.34),('5819','2013-08-12','17:35:00',1.26),('5819','2013-08-12','17:40:00',1.09),('5819','2013-08-12','17:45:00',1.06),('5819','2013-08-12','17:50:00',1.01),('5819','2013-08-11','07:45:00',1.02),('5819','2013-08-11','07:50:00',1.11),('5819','2013-08-11','07:55:00',1.2),('5819','2013-08-11','08:00:00',1.28),('5819','2013-08-11','08:05:00',1.32),('5819','2013-08-11','08:10:00',1.44),('5819','2013-08-11','08:15:00',1.52),('5819','2013-08-11','08:20:00',1.61),('5819','2013-08-11','08:25:00',1.68),('5819','2013-08-11','08:30:00',1.75),('5819','2013-08-11','08:35:00',1.83),('5819','2013-08-11','08:40:00',1.9),('5819','2013-08-11','08:45:00',1.99),('5819','2013-08-11','08:50:00',2.06),('5819','2013-08-11','08:55:00',2.12),('5819','2013-08-11','09:00:00',2.2),('5819','2013-08-11','09:05:00',2.27),('5819','2013-08-11','09:10:00',2.34),('5819','2013-08-11','09:15:00',2.4),('5819','2013-08-11','09:20:00',2.47),('5819','2013-08-11','09:25:00',2.54),('5819','2013-08-11','09:30:00',2.6),('5819','2013-08-11','09:35:00',2.66),('5819','2013-08-11','09:40:00',2.72),('5819','2013-08-11','09:45:00',2.8),('5819','2013-08-11','09:50:00',2.84),('5819','2013-08-11','09:55:00',2.9),('5819','2013-08-11','10:00:00',2.95),('5819','2013-08-11','10:05:00',2.99),('5819','2013-08-11','10:10:00',3.04),('5819','2013-08-11','10:15:00',3.09),('5819','2013-08-11','10:20:00',3.12),('5819','2013-08-11','10:25:00',3.15),('5819','2013-08-11','10:30:00',3.19),('5819','2013-08-11','10:35:00',3.21),('5819','2013-08-11','10:40:00',3.24),('5819','2013-08-11','10:45:00',3.29),('5819','2013-08-11','10:50:00',3.32),('5819','2013-08-11','10:55:00',3.36),('5819','2013-08-11','11:00:00',3.39),('5819','2013-08-11','11:05:00',3.43),('5819','2013-08-11','11:10:00',3.47),('5819','2013-08-11','11:15:00',3.45),('5819','2013-08-11','11:20:00',3.49),('5819','2013-08-11','11:25:00',3.54),('5819','2013-08-11','11:30:00',3.54),('5819','2013-08-11','11:35:00',3.53),('5819','2013-08-11','11:40:00',3.54),('5819','2013-08-11','11:45:00',3.54),('5819','2013-08-11','11:50:00',3.59),('5819','2013-08-11','11:55:00',3.59),('5819','2013-08-11','12:00:00',3.6),('5819','2013-08-11','12:05:00',3.61),('5819','2013-08-11','12:10:00',3.63),('5819','2013-08-11','12:15:00',3.62),('5819','2013-08-11','12:20:00',3.65),('5819','2013-08-11','12:25:00',3.67),('5819','2013-08-11','12:30:00',3.65),('5819','2013-08-11','12:35:00',3.64),('5819','2013-08-11','12:40:00',3.65),('5819','2013-08-11','12:45:00',3.65),('5819','2013-08-11','12:50:00',3.65),('5819','2013-08-11','12:55:00',3.64),('5819','2013-08-11','13:00:00',3.62),('5819','2013-08-11','13:05:00',3.61),('5819','2013-08-11','13:10:00',3.57),('5819','2013-08-11','13:15:00',3.57),('5819','2013-08-11','13:20:00',3.57),('5819','2013-08-11','13:25:00',3.58),('5819','2013-08-11','13:30:00',3.55),('5819','2013-08-11','13:35:00',3.51),('5819','2013-08-11','13:40:00',3.53),('5819','2013-08-11','13:45:00',3.5),('5819','2013-08-11','13:50:00',3.49),('5819','2013-08-11','13:55:00',3.45),('5819','2013-08-11','14:00:00',3.44),('5819','2013-08-11','14:05:00',3.42),('5819','2013-08-11','14:10:00',3.42),('5819','2013-08-11','14:15:00',3.33),('5819','2013-08-11','14:20:00',3.35),('5819','2013-08-11','14:25:00',3.29),('5819','2013-08-11','14:30:00',3.26),('5819','2013-08-11','14:35:00',3.23),('5819','2013-08-11','14:40:00',3.24),('5819','2013-08-11','14:45:00',3.2),('5819','2013-08-11','14:50:00',3.13),('5819','2013-08-11','14:55:00',3.12),('5819','2013-08-11','15:00:00',3.13),('5819','2013-08-11','15:05:00',3.07),('5819','2013-08-11','15:10:00',2.99),('5819','2013-08-11','15:15:00',2.95),('5819','2013-08-11','15:20:00',2.94),('5819','2013-08-11','15:25:00',2.97),('5819','2013-08-11','15:30:00',2.12),('5819','2013-08-11','15:35:00',2.79),('5819','2013-08-11','15:40:00',2.77),('5819','2013-08-11','15:45:00',2.73),('5819','2013-08-11','15:50:00',2.71),('5819','2013-08-11','15:55:00',2.65),('5819','2013-08-11','16:00:00',2.58),('5819','2013-08-11','16:05:00',2.51),('5819','2013-08-11','16:10:00',2.45),('5819','2013-08-11','16:15:00',2.38),('5819','2013-08-11','16:20:00',2.32),('5819','2013-08-11','16:25:00',2.25),('5819','2013-08-11','16:30:00',2.17),('5819','2013-08-11','16:35:00',2.12),('5819','2013-08-11','16:40:00',2.05),('5819','2013-08-11','16:45:00',1.98),('5819','2013-08-11','16:50:00',1.91),('5819','2013-08-11','16:55:00',1.84),('5819','2013-08-11','17:00:00',1.78),('5819','2013-08-11','17:05:00',1.71),('5819','2013-08-11','17:10:00',1.63),('5819','2013-08-11','17:15:00',1.55),('5819','2013-08-11','17:20:00',1.48),('5819','2013-08-11','17:25:00',1.4),('5819','2013-08-11','17:30:00',1.33),('5819','2013-08-11','17:35:00',1.26),('5819','2013-08-11','17:40:00',1.11),('5819','2013-08-11','17:45:00',1.01),('5819','2013-08-11','17:50:00',1.01),('5819','2013-08-10','07:45:00',1.04),('5819','2013-08-10','07:50:00',1.12),('5819','2013-08-10','07:55:00',1.2),('5819','2013-08-10','08:00:00',1.3),('5819','2013-08-10','08:05:00',1.38),('5819','2013-08-10','08:10:00',1.48),('5819','2013-08-10','08:15:00',1.57),('5819','2013-08-10','08:20:00',1.66),('5819','2013-08-10','08:25:00',1.75),('5819','2013-08-10','08:30:00',1.83),('5819','2013-08-10','08:35:00',1.91),('5819','2013-08-10','08:40:00',1.98),('5819','2013-08-10','08:45:00',2.04),('5819','2013-08-10','08:50:00',2.11),('5819','2013-08-10','08:55:00',2.18),('5819','2013-08-10','09:00:00',2.24),('5819','2013-08-10','09:05:00',2.32),('5819','2013-08-10','09:10:00',2.39),('5819','2013-08-10','09:15:00',2.46),('5819','2013-08-10','09:20:00',2.53),('5819','2013-08-10','09:25:00',2.6),('5819','2013-08-10','09:30:00',2.66),('5819','2013-08-10','09:35:00',2.7),('5819','2013-08-10','09:40:00',2.74),('5819','2013-08-10','09:45:00',2.81),('5819','2013-08-10','09:50:00',2.86),('5819','2013-08-10','09:55:00',2.9),('5819','2013-08-10','10:00:00',2.96),('5819','2013-08-10','10:05:00',2.99),('5819','2013-08-10','10:15:00',3.09),('5819','2013-08-10','10:20:00',3.12),('5819','2013-08-10','10:25:00',3.16),('5819','2013-08-10','10:30:00',3.19),('5819','2013-08-10','10:35:00',3.22),('5819','2013-08-10','10:40:00',3.29),('5819','2013-08-10','10:45:00',3.32),('5819','2013-08-10','10:50:00',3.36),('5819','2013-08-10','10:55:00',3.41),('5819','2013-08-10','11:00:00',3.51),('5819','2013-08-10','11:05:00',3.53),('5819','2013-08-10','11:10:00',3.25),('5819','2013-08-10','11:15:00',3.12),('5819','2013-08-10','11:20:00',2.31),('5819','2013-08-10','11:25:00',2.57),('5819','2013-08-10','11:30:00',3.12),('5819','2013-08-10','11:35:00',3.69),('5819','2013-08-10','11:40:00',3.64),('5819','2013-08-10','11:45:00',3.64),('5819','2013-08-10','11:50:00',3.65),('5819','2013-08-10','11:55:00',3.63),('5819','2013-08-10','12:00:00',3.66),('5819','2013-08-10','12:05:00',3.68),('5819','2013-08-10','12:10:00',3.69),('5819','2013-08-10','12:15:00',3.68),('5819','2013-08-10','12:20:00',3.68),('5819','2013-08-10','12:25:00',3.7),('5819','2013-08-10','12:30:00',3.66),('5819','2013-08-10','12:35:00',3.68),('5819','2013-08-10','12:40:00',3.71),('5819','2013-08-10','12:45:00',3.78),('5819','2013-08-10','12:50:00',3.84),('5819','2013-08-10','12:55:00',3.84),('5819','2013-08-10','13:00:00',3.78),('5819','2013-08-10','13:05:00',3.74),('5819','2013-08-10','13:10:00',3.78),('5819','2013-08-10','13:15:00',3.85),('5819','2013-08-10','13:20:00',3.64),('5819','2013-08-10','13:25:00',3.94),('5819','2013-08-10','13:30:00',3.36),('5819','2013-08-10','13:35:00',2.49),('5819','2013-08-10','13:45:00',1.65),('5819','2013-08-10','13:50:00',3.87),('5819','2013-08-10','13:55:00',3.76),('5819','2013-08-10','14:00:00',3.94),('5819','2013-08-10','14:05:00',3.14),('5819','2013-08-10','14:10:00',3.96),('5819','2013-08-10','14:15:00',3.35),('5819','2013-08-10','14:20:00',1.81),('5819','2013-08-10','14:25:00',1.18),('5819','2013-08-10','14:30:00',1.21),('5819','2013-08-10','14:35:00',1.05),('5819','2013-08-10','15:10:00',1.04),('5819','2013-08-10','15:15:00',1.23),('5819','2013-08-10','15:20:00',1.23),('5819','2013-08-10','15:25:00',1.08),('5819','2013-08-10','15:30:00',1.04),('5819','2013-08-10','15:35:00',1.29),('5819','2013-08-10','15:40:00',1.21),('5819','2013-08-10','15:45:00',1.28),('5819','2013-08-10','15:50:00',1.47),('5819','2013-08-10','15:55:00',1.72),('5819','2013-08-10','16:00:00',1.9),('5819','2013-08-10','16:05:00',3.21),('5819','2013-08-10','16:10:00',1.72),('5819','2013-08-10','16:15:00',1.84),('5819','2013-08-10','16:20:00',2.02),('5819','2013-08-10','16:25:00',1.05),('5819','2013-08-10','16:30:00',1.59),('5819','2013-08-10','16:35:00',2.64),('5819','2013-08-10','16:40:00',2.35),('5819','2013-08-10','16:45:00',2.3),('5819','2013-08-10','16:50:00',2.12),('5819','2013-08-10','16:55:00',1.94),('5819','2013-08-10','17:00:00',1.76),('5819','2013-08-10','17:05:00',1.37),('5819','2013-08-10','17:15:00',1.06),('5819','2013-08-09','08:05:00',1.24),('5819','2013-08-09','08:10:00',1.07),('5819','2013-08-09','08:35:00',1.18),('5819','2013-08-09','08:40:00',1.63),('5819','2013-08-09','08:45:00',1.56),('5819','2013-08-09','08:50:00',1.84),('5819','2013-08-09','08:55:00',1.82),('5819','2013-08-09','09:00:00',1.78),('5819','2013-08-09','09:05:00',2.11),('5819','2013-08-09','09:10:00',2.2),('5819','2013-08-09','09:15:00',1.88),('5819','2013-08-09','09:20:00',1.77),('5819','2013-08-09','09:25:00',1.56),('5819','2013-08-09','09:30:00',2.13),('5819','2013-08-09','09:35:00',2.64),('5819','2013-08-09','09:40:00',2.13),('5819','2013-08-09','09:45:00',2.66),('5819','2013-08-09','09:50:00',2.66),('5819','2013-08-09','09:55:00',1.75),('5819','2013-08-09','10:00:00',1.96),('5819','2013-08-09','10:05:00',2.37),('5819','2013-08-09','10:10:00',2.76),('5819','2013-08-09','10:15:00',2.78),('5819','2013-08-09','10:20:00',2.77),('5819','2013-08-09','10:25:00',2.8),('5819','2013-08-09','10:30:00',2.88),('5819','2013-08-09','10:35:00',2.89),('5819','2013-08-09','10:40:00',3.01),('5819','2013-08-09','10:45:00',2.93),('5819','2013-08-09','10:50:00',3.02),('5819','2013-08-09','10:55:00',3.05),('5819','2013-08-09','11:00:00',3.09),('5819','2013-08-09','11:05:00',3.11),('5819','2013-08-09','11:10:00',3.14),('5819','2013-08-09','11:15:00',3.18),('5819','2013-08-09','11:20:00',3.22),('5819','2013-08-09','11:25:00',3.25),('5819','2013-08-09','11:30:00',3.26),('5819','2013-08-09','11:35:00',3.23),('5819','2013-08-09','11:40:00',3.24),('5819','2013-08-09','11:45:00',3.27),('5819','2013-08-09','11:50:00',3.31),('5819','2013-08-09','11:55:00',3.34),('5819','2013-08-09','12:00:00',3.34),('5819','2013-08-09','12:05:00',3.32),('5819','2013-08-09','12:10:00',3.36),('5819','2013-08-09','12:15:00',3.41),('5819','2013-08-09','12:20:00',3.53),('5819','2013-08-09','12:25:00',3.36),('5819','2013-08-09','12:30:00',2.41),('5819','2013-08-09','12:35:00',2.95),('5819','2013-08-09','12:40:00',3.67),('5819','2013-08-09','12:45:00',2.81),('5819','2013-08-09','12:50:00',2.3),('5819','2013-08-09','12:55:00',2.42),('5819','2013-08-09','13:00:00',1.43),('5819','2013-08-09','13:20:00',1.18),('5819','2013-08-09','13:25:00',1.91),('5819','2013-08-09','13:30:00',1.86),('5819','2013-08-09','13:35:00',1.37),('5819','2013-08-09','13:40:00',1.43),('5819','2013-08-09','13:45:00',1.32),('5819','2013-08-09','13:50:00',1.36),('5819','2013-08-09','13:55:00',1.19),('5819','2013-08-09','14:00:00',1.1),('5819','2013-08-09','14:05:00',1.14),('5819','2013-08-09','14:10:00',1.5),('5819','2013-08-09','14:30:00',1.02),('5819','2013-08-09','15:05:00',1.18),('5819','2013-08-09','15:10:00',2.46),('5819','2013-08-09','15:15:00',2.29),('5819','2013-08-09','15:20:00',1.38),('5819','2013-08-09','15:25:00',1.14),('5819','2013-08-09','15:35:00',1.76),('5819','2013-08-09','15:40:00',1.38),('5819','2013-08-09','15:45:00',2.57),('5819','2013-08-09','15:50:00',1.89),('5819','2013-08-09','15:55:00',1.91),('5819','2013-08-09','16:00:00',1.1),('5819','2013-08-09','16:50:00',1.15),('5819','2013-08-09','16:55:00',1.8),('5819','2013-08-09','17:00:00',1.23),('5819','2013-08-09','17:05:00',1.63),('5819','2013-08-08','07:55:00',1.05),('5819','2013-08-08','08:00:00',1.13),('5819','2013-08-08','08:05:00',1.2),('5819','2013-08-08','08:10:00',1.28),('5819','2013-08-08','08:15:00',1.35),('5819','2013-08-08','08:20:00',1.41),('5819','2013-08-08','08:25:00',1.5),('5819','2013-08-08','08:30:00',1.58),('5819','2013-08-08','08:35:00',1.65),('5819','2013-08-08','08:40:00',1.72),('5819','2013-08-08','08:45:00',1.78),('5819','2013-08-08','08:50:00',1.85),('5819','2013-08-08','08:55:00',1.91),('5819','2013-08-08','09:00:00',2),('5819','2013-08-08','09:05:00',2.08),('5819','2013-08-08','09:10:00',2.14),('5819','2013-08-08','09:15:00',2.21),('5819','2013-08-08','09:20:00',2.27),('5819','2013-08-08','09:25:00',2.33),('5819','2013-08-08','09:30:00',2.39),('5819','2013-08-08','09:35:00',2.47),('5819','2013-08-08','09:40:00',2.52),('5819','2013-08-08','09:45:00',2.57),('5819','2013-08-08','09:50:00',2.61),('5819','2013-08-08','09:55:00',2.66),('5819','2013-08-08','10:00:00',2.71),('5819','2013-08-08','10:05:00',2.75),('5819','2013-08-08','10:10:00',2.8),('5819','2013-08-08','10:15:00',2.84),('5819','2013-08-08','10:20:00',2.87),('5819','2013-08-08','10:25:00',2.9),('5819','2013-08-08','10:30:00',2.94),('5819','2013-08-08','10:35:00',2.97),('5819','2013-08-08','10:40:00',3),('5819','2013-08-08','10:45:00',3.03),('5819','2013-08-08','10:50:00',3.07),('5819','2013-08-08','10:55:00',3.1),('5819','2013-08-08','11:00:00',3.12),('5819','2013-08-08','11:05:00',3.15),('5819','2013-08-08','11:10:00',3.18),('5819','2013-08-08','11:15:00',3.19),('5819','2013-08-08','11:20:00',3.21),('5819','2013-08-08','11:25:00',3.23),('5819','2013-08-08','11:30:00',3.2),('5819','2013-08-08','11:35:00',3.24),('5819','2013-08-08','11:40:00',3.29),('5819','2013-08-08','11:45:00',3.29),('5819','2013-08-08','11:50:00',3.29),('5819','2013-08-08','11:55:00',3.3),('5819','2013-08-08','12:00:00',3.33),('5819','2013-08-08','12:05:00',3.32),('5819','2013-08-08','12:10:00',3.31),('5819','2013-08-08','12:15:00',3.34),('5819','2013-08-08','12:20:00',3.34),('5819','2013-08-08','12:25:00',3.36),('5819','2013-08-08','12:30:00',3.41),('5819','2013-08-08','12:35:00',3.42),('5819','2013-08-08','12:40:00',3.39),('5819','2013-08-08','12:45:00',3.39),('5819','2013-08-08','12:50:00',3.39),('5819','2013-08-08','12:55:00',3.41),('5819','2013-08-08','13:00:00',3.41),('5819','2013-08-08','13:05:00',3.42),('5819','2013-08-08','13:10:00',3.41),('5819','2013-08-08','13:15:00',3.4),('5819','2013-08-08','13:20:00',3.4),('5819','2013-08-08','13:25:00',3.41),('5819','2013-08-08','13:30:00',3.38),('5819','2013-08-08','13:35:00',3.36),('5819','2013-08-08','13:40:00',3.34),('5819','2013-08-08','13:45:00',3.29),('5819','2013-08-08','13:50:00',3.3),('5819','2013-08-08','13:55:00',3.26),('5819','2013-08-08','14:00:00',3.27),('5819','2013-08-08','14:05:00',3.26),('5819','2013-08-08','14:10:00',3.23),('5819','2013-08-08','14:15:00',3.19),('5819','2013-08-08','14:20:00',3.16),('5819','2013-08-08','14:25:00',3.12),('5819','2013-08-08','14:30:00',3.1),('5819','2013-08-08','14:35:00',3.08),('5819','2013-08-08','14:40:00',3.05),('5819','2013-08-08','14:45:00',3.02),('5819','2013-08-08','14:50:00',2.98),('5819','2013-08-08','14:55:00',2.94),('5819','2013-08-08','15:00:00',2.91),('5819','2013-08-08','15:05:00',2.85),('5819','2013-08-08','15:10:00',2.81),('5819','2013-08-08','15:15:00',2.79),('5819','2013-08-08','15:20:00',2.74),('5819','2013-08-08','15:25:00',2.69),('5819','2013-08-08','15:30:00',2.66),('5819','2013-08-08','15:35:00',2.59),('5819','2013-08-08','15:40:00',2.54),('5819','2013-08-08','15:45:00',2.51),('5819','2013-08-08','15:50:00',2.46),('5819','2013-08-08','15:55:00',2.4),('5819','2013-08-08','16:00:00',2.36),('5819','2013-08-08','16:05:00',2.32),('5819','2013-08-08','16:10:00',2.27),('5819','2013-08-08','16:15:00',2.21),('5819','2013-08-08','16:20:00',2.17),('5819','2013-08-08','16:25:00',2.13),('5819','2013-08-08','16:30:00',2.07),('5819','2013-08-08','16:35:00',2),('5819','2013-08-08','16:40:00',1.95),('5819','2013-08-08','16:45:00',1.88),('5819','2013-08-08','16:50:00',1.8),('5819','2013-08-08','16:55:00',1.74),('5819','2013-08-08','17:00:00',1.68),('5819','2013-08-08','17:05:00',1.6),('5819','2013-08-08','17:10:00',1.52),('5819','2013-08-08','17:15:00',1.46),('5819','2013-08-08','17:20:00',1.4),('5819','2013-08-08','17:25:00',1.32),('5819','2013-08-08','17:30:00',1.25),('5819','2013-08-08','17:35:00',1.18),('5819','2013-08-08','17:40:00',1.08),('5819','2013-08-07','07:50:00',1.03),('5819','2013-08-07','07:55:00',1.11),('5819','2013-08-07','08:00:00',1.19),('5819','2013-08-07','08:05:00',1.26),('5819','2013-08-07','08:10:00',1.34),('5819','2013-08-07','08:15:00',1.41),('5819','2013-08-07','08:20:00',1.5),('5819','2013-08-07','08:25:00',1.58),('5819','2013-08-07','08:30:00',1.66),('5819','2013-08-07','08:35:00',1.73),('5819','2013-08-07','08:40:00',1.8),('5819','2013-08-07','08:45:00',1.88),('5819','2013-08-07','08:50:00',1.93),('5819','2013-08-07','08:55:00',1.98),('5819','2013-08-07','09:00:00',2.05),('5819','2013-08-07','09:05:00',2.12),('5819','2013-08-07','09:10:00',2.2),('5819','2013-08-07','09:15:00',2.27),('5819','2013-08-07','09:20:00',2.33),('5819','2013-08-07','09:25:00',2.38),('5819','2013-08-07','09:30:00',2.44),('5819','2013-08-07','09:35:00',2.5),('5819','2013-08-07','09:40:00',2.54),('5819','2013-08-07','09:45:00',2.56),('5819','2013-08-07','09:50:00',2.63),('5819','2013-08-07','09:55:00',2.7),('5819','2013-08-07','10:00:00',2.76),('5819','2013-08-07','10:05:00',2.76),('5819','2013-08-07','10:10:00',2.83),('5819','2013-08-07','10:15:00',2.86),('5819','2013-08-07','10:20:00',2.92),('5819','2013-08-07','10:25:00',2.97),('5819','2013-08-07','10:30:00',2.98),('5819','2013-08-07','10:35:00',2.99),('5819','2013-08-07','10:40:00',3.06),('5819','2013-08-07','10:45:00',3.11),('5819','2013-08-07','10:50:00',3.14),('5819','2013-08-07','10:55:00',3.15),('5819','2013-08-07','11:00:00',3.17),('5819','2013-08-07','11:05:00',3.18),('5819','2013-08-07','11:10:00',3.19),('5819','2013-08-07','11:15:00',3.22),('5819','2013-08-07','11:20:00',3.25),('5819','2013-08-07','11:25:00',3.27),('5819','2013-08-07','11:30:00',3.27),('5819','2013-08-07','11:35:00',3.29),('5819','2013-08-07','11:40:00',3.3),('5819','2013-08-07','11:45:00',3.31),('5819','2013-08-07','11:50:00',3.33),('5819','2013-08-07','11:55:00',3.33),('5819','2013-08-07','12:00:00',3.37),('5819','2013-08-07','12:05:00',3.37),('5819','2013-08-07','12:10:00',3.38),('5819','2013-08-07','12:15:00',3.38),('5819','2013-08-07','12:20:00',3.38),('5819','2013-08-07','12:25:00',3.35),('5819','2013-08-07','12:30:00',3.35),('5819','2013-08-07','12:35:00',3.39),('5819','2013-08-07','12:40:00',3.34),('5819','2013-08-07','12:45:00',3.33),('5819','2013-08-07','12:50:00',3.35),('5819','2013-08-07','12:55:00',3.36),('5819','2013-08-07','13:00:00',3.36),('5819','2013-08-07','13:05:00',3.38),('5819','2013-08-07','13:10:00',3.41),('5819','2013-08-07','13:15:00',3.38),('5819','2013-08-07','13:20:00',3.4),('5819','2013-08-07','13:25:00',3.33),('5819','2013-08-07','13:30:00',3.35),('5819','2013-08-07','13:35:00',3.25),('5819','2013-08-07','13:40:00',3.34),('5819','2013-08-07','13:45:00',3.35),('5819','2013-08-07','13:50:00',3.3),('5819','2013-08-07','13:55:00',3.32),('5819','2013-08-07','14:00:00',3.27),('5819','2013-08-07','14:05:00',3.28),('5819','2013-08-07','14:10:00',3.29),('5819','2013-08-07','14:15:00',3.16),('5819','2013-08-07','14:20:00',3.16),('5819','2013-08-07','14:25:00',3.1),('5819','2013-08-07','14:30:00',3.06),('5819','2013-08-07','14:35:00',3.03),('5819','2013-08-07','14:40:00',3.05),('5819','2013-08-07','14:45:00',3.08),('5819','2013-08-07','14:50:00',3.03),('5819','2013-08-07','14:55:00',3.01),('5819','2013-08-07','15:00:00',2.96),('5819','2013-08-07','15:05:00',2.89),('5819','2013-08-07','15:10:00',2.87),('5819','2013-08-07','15:15:00',2.82),('5819','2013-08-07','15:20:00',2.79),('5819','2013-08-07','15:25:00',2.74),('5819','2013-08-07','15:30:00',2.71),('5819','2013-08-07','15:35:00',2.66),('5819','2013-08-07','15:40:00',2.61),('5819','2013-08-07','15:45:00',2.56),('5819','2013-08-07','15:50:00',2.51),('5819','2013-08-07','15:55:00',2.46),('5819','2013-08-07','16:00:00',2.38),('5819','2013-08-07','16:05:00',2.35),('5819','2013-08-07','16:10:00',2.28),('5819','2013-08-07','16:15:00',2.23),('5819','2013-08-07','16:20:00',2.18),('5819','2013-08-07','16:25:00',2.14),('5819','2013-08-07','16:30:00',2.08),('5819','2013-08-07','16:35:00',2.03),('5819','2013-08-07','16:40:00',1.96),('5819','2013-08-07','16:45:00',1.9),('5819','2013-08-07','16:50:00',1.84),('5819','2013-08-07','16:55:00',1.77),('5819','2013-08-07','17:00:00',1.7),('5819','2013-08-07','17:05:00',1.64),('5819','2013-08-07','17:10:00',1.54),('5819','2013-08-07','17:15:00',1.48),('5819','2013-08-07','17:20:00',1.4),('5819','2013-08-07','17:25:00',1.36),('5819','2013-08-07','17:30:00',1.29),('5819','2013-08-07','17:35:00',1.21),('5819','2013-08-07','17:40:00',1.09),('5819','2013-08-06','07:55:00',1.07),('5819','2013-08-06','08:00:00',1.15),('5819','2013-08-06','08:05:00',1.23),('5819','2013-08-06','08:10:00',1.3),('5819','2013-08-06','08:15:00',1.38),('5819','2013-08-06','08:20:00',1.46),('5819','2013-08-06','08:25:00',1.55),('5819','2013-08-06','08:30:00',1.61),('5819','2013-08-06','08:35:00',1.68),('5819','2013-08-06','08:40:00',1.75),('5819','2013-08-06','08:45:00',1.82),('5819','2013-08-06','08:50:00',1.9),('5819','2013-08-06','08:55:00',1.97),('5819','2013-08-06','09:00:00',2.03),('5819','2013-08-06','09:05:00',2.1),('5819','2013-08-06','09:10:00',2.18),('5819','2013-08-06','09:15:00',2.23),('5819','2013-08-06','09:20:00',2.29),('5819','2013-08-06','09:25:00',2.33),('5819','2013-08-06','09:30:00',2.4),('5819','2013-08-06','09:35:00',2.46),('5819','2013-08-06','09:40:00',2.52),('5819','2013-08-06','09:45:00',2.57),('5819','2013-08-06','09:50:00',2.58),('5819','2013-08-06','09:55:00',2.65),('5819','2013-08-06','10:00:00',2.71),('5819','2013-08-06','10:05:00',2.76),('5819','2013-08-06','10:10:00',2.8),('5819','2013-08-06','10:15:00',2.84),('5819','2013-08-06','10:20:00',2.88),('5819','2013-08-06','10:25:00',2.91),('5819','2013-08-06','10:30:00',2.94),('5819','2013-08-06','10:35:00',2.96),('5819','2013-08-06','10:40:00',3),('5819','2013-08-06','10:45:00',3.02),('5819','2013-08-06','10:50:00',3.05),('5819','2013-08-06','10:55:00',3.08),('5819','2013-08-06','11:00:00',3.12),('5819','2013-08-06','11:05:00',3.16),('5819','2013-08-06','11:10:00',3.18),('5819','2013-08-06','11:15:00',3.21),('5819','2013-08-06','11:20:00',3.24),('5819','2013-08-06','11:25:00',3.24),('5819','2013-08-06','11:30:00',3.28),('5819','2013-08-06','11:35:00',3.3),('5819','2013-08-06','11:40:00',3.31),('5819','2013-08-06','11:45:00',3.31),('5819','2013-08-06','11:50:00',3.31),('5819','2013-08-06','11:55:00',3.35),('5819','2013-08-06','12:00:00',3.37),('5819','2013-08-06','12:05:00',3.35),('5819','2013-08-06','12:10:00',3.37),('5819','2013-08-06','12:15:00',3.39),('5819','2013-08-06','12:20:00',3.39),('5819','2013-08-06','12:25:00',3.36),('5819','2013-08-06','12:30:00',3.39),('5819','2013-08-06','12:35:00',3.38),('5819','2013-08-06','12:40:00',3.38),('5819','2013-08-06','12:45:00',3.34),('5819','2013-08-06','12:50:00',3.34),('5819','2013-08-06','12:55:00',3.38),('5819','2013-08-06','13:00:00',3.38),('5819','2013-08-06','13:05:00',3.39),('5819','2013-08-06','13:10:00',3.36),('5819','2013-08-06','13:15:00',3.39),('5819','2013-08-06','13:20:00',3.37),('5819','2013-08-06','13:25:00',3.41),('5819','2013-08-06','13:30:00',3.4),('5819','2013-08-06','13:35:00',3.4),('5819','2013-08-06','13:40:00',3.38),('5819','2013-08-06','13:45:00',3.38),('5819','2013-08-06','13:50:00',3.39),('5819','2013-08-06','13:55:00',3.39),('5819','2013-08-06','14:00:00',3.39),('5819','2013-08-06','14:05:00',3.36),('5819','2013-08-06','14:10:00',3.34),('5819','2013-08-06','14:15:00',3.33),('5819','2013-08-06','14:20:00',3.3),('5819','2013-08-06','14:25:00',3.28),('5819','2013-08-06','14:30:00',3.27),('5819','2013-08-06','14:35:00',3.22),('5819','2013-08-06','14:40:00',3.19),('5819','2013-08-06','14:45:00',3.16),('5819','2013-08-06','14:50:00',3.13),('5819','2013-08-06','14:55:00',3.1),('5819','2013-08-06','15:00:00',3.07),('5819','2013-08-06','15:05:00',3.04),('5819','2013-08-06','15:10:00',2.99),('5819','2013-08-06','15:15:00',2.95),('5819','2013-08-06','15:20:00',2.92),('5819','2013-08-06','15:25:00',2.86),('5819','2013-08-06','15:30:00',2.82),('5819','2013-08-06','15:35:00',2.78),('5819','2013-08-06','15:40:00',2.73),('5819','2013-08-06','15:45:00',2.67),('5819','2013-08-06','15:50:00',2.62),('5819','2013-08-06','15:55:00',2.57),('5819','2013-08-06','16:00:00',2.51),('5819','2013-08-06','16:05:00',2.45),('5819','2013-08-06','16:10:00',2.39),('5819','2013-08-06','16:15:00',2.33),('5819','2013-08-06','16:20:00',2.28),('5819','2013-08-06','16:25:00',2.21),('5819','2013-08-06','16:30:00',2.16),('5819','2013-08-06','16:35:00',2.09),('5819','2013-08-06','16:40:00',2.03),('5819','2013-08-06','16:45:00',1.95),('5819','2013-08-06','16:50:00',1.89),('5819','2013-08-06','16:55:00',1.83),('5819','2013-08-06','17:00:00',1.75),('5819','2013-08-06','17:05:00',1.7),('5819','2013-08-06','17:10:00',1.62),('5819','2013-08-06','17:15:00',1.53),('5819','2013-08-06','17:20:00',1.46),('5819','2013-08-06','17:25:00',1.39),('5819','2013-08-06','17:30:00',1.32),('5819','2013-08-06','17:35:00',1.25),('5819','2013-08-06','17:40:00',1.14),('5819','2013-08-06','17:45:00',1.05),('5819','2013-08-06','17:50:00',1.01),('5819','2013-08-05','07:50:00',1.07),('5819','2013-08-05','07:55:00',1.15),('5819','2013-08-05','08:00:00',1.23),('5819','2013-08-05','08:05:00',1.31),('5819','2013-08-05','08:10:00',1.39),('5819','2013-08-05','08:15:00',1.47),('5819','2013-08-05','08:20:00',1.54),('5819','2013-08-05','08:25:00',1.62),('5819','2013-08-05','08:30:00',1.68),('5819','2013-08-05','08:35:00',1.75),('5819','2013-08-05','08:40:00',1.83),('5819','2013-08-05','08:45:00',1.9),('5819','2013-08-05','08:50:00',1.97),('5819','2013-08-05','08:55:00',2.03),('5819','2013-08-05','09:00:00',2.1),('5819','2013-08-05','09:05:00',2.16),('5819','2013-08-05','09:10:00',2.22),('5819','2013-08-05','09:15:00',2.29),('5819','2013-08-05','09:20:00',2.33),('5819','2013-08-05','09:25:00',2.39),('5819','2013-08-05','09:30:00',2.44),('5819','2013-08-05','09:35:00',2.5),('5819','2013-08-05','09:40:00',2.54),('5819','2013-08-05','09:45:00',2.59),('5819','2013-08-05','09:50:00',2.63),('5819','2013-08-05','09:55:00',2.7),('5819','2013-08-05','10:00:00',2.75),('5819','2013-08-05','10:05:00',2.79),('5819','2013-08-05','10:10:00',2.84),('5819','2013-08-05','10:15:00',2.88),('5819','2013-08-05','10:20:00',2.92),('5819','2013-08-05','10:25:00',2.99),('5819','2013-08-05','10:30:00',3.01),('5819','2013-08-05','10:35:00',3.05),('5819','2013-08-05','10:40:00',3.08),('5819','2013-08-05','10:45:00',3.11),('5819','2013-08-05','10:50:00',3.14),('5819','2013-08-05','10:55:00',3.18),('5819','2013-08-05','11:00:00',3.2),('5819','2013-08-05','11:05:00',3.25),('5819','2013-08-05','11:10:00',3.27),('5819','2013-08-05','11:15:00',3.3),('5819','2013-08-05','11:20:00',3.33),('5819','2013-08-05','11:25:00',3.34),('5819','2013-08-05','11:30:00',3.34),('5819','2013-08-05','11:35:00',3.37),('5819','2013-08-05','11:40:00',3.37),('5819','2013-08-05','11:45:00',3.42),('5819','2013-08-05','11:50:00',3.43),('5819','2013-08-05','11:55:00',3.44),('5819','2013-08-05','12:00:00',3.44),('5819','2013-08-05','12:05:00',3.45),('5819','2013-08-05','12:10:00',3.46),('5819','2013-08-05','12:15:00',3.45),('5819','2013-08-05','12:20:00',3.46),('5819','2013-08-05','12:25:00',3.48),('5819','2013-08-05','12:30:00',3.46),('5819','2013-08-05','12:35:00',3.46),('5819','2013-08-05','12:40:00',3.47),('5819','2013-08-05','12:45:00',3.51),('5819','2013-08-05','12:50:00',3.48),('5819','2013-08-05','12:55:00',3.46),('5819','2013-08-05','13:00:00',3.48),('5819','2013-08-05','13:05:00',3.49),('5819','2013-08-05','13:10:00',3.43),('5819','2013-08-05','13:15:00',3.42),('5819','2013-08-05','13:20:00',3.42),('5819','2013-08-05','13:25:00',3.41),('5819','2013-08-05','13:30:00',3.39),('5819','2013-08-05','13:35:00',3.39),('5819','2013-08-05','13:40:00',3.36),('5819','2013-08-05','13:45:00',3.37),('5819','2013-08-05','13:50:00',3.35),('5819','2013-08-05','13:55:00',3.28),('5819','2013-08-05','14:00:00',3.26),('5819','2013-08-05','14:05:00',3.29),('5819','2013-08-05','14:10:00',3.24),('5819','2013-08-05','14:15:00',3.22),('5819','2013-08-05','14:20:00',3.23),('5819','2013-08-05','14:25:00',3.17),('5819','2013-08-05','14:30:00',3.15),('5819','2013-08-05','14:35:00',3.13),('5819','2013-08-05','14:40:00',3.11),('5819','2013-08-05','14:45:00',3.1),('5819','2013-08-05','14:50:00',3.04),('5819','2013-08-05','14:55:00',3.02),('5819','2013-08-05','15:00:00',2.98),('5819','2013-08-05','15:05:00',2.96),('5819','2013-08-05','15:10:00',2.93),('5819','2013-08-05','15:15:00',2.91),('5819','2013-08-05','15:20:00',2.86),('5819','2013-08-05','15:25:00',2.83),('5819','2013-08-05','15:30:00',2.79),('5819','2013-08-05','15:35:00',2.74),('5819','2013-08-05','15:40:00',2.69),('5819','2013-08-05','15:45:00',2.63),('5819','2013-08-05','15:50:00',2.56),('5819','2013-08-05','15:55:00',2.52),('5819','2013-08-05','16:00:00',2.49),('5819','2013-08-05','16:05:00',2.46),('5819','2013-08-05','16:10:00',2.39),('5819','2013-08-05','16:15:00',2.31),('5819','2013-08-05','16:20:00',2.25),('5819','2013-08-05','16:25:00',2.18),('5819','2013-08-05','16:30:00',2.13),('5819','2013-08-05','16:35:00',2.09),('5819','2013-08-05','16:40:00',2.02),('5819','2013-08-05','16:45:00',1.95),('5819','2013-08-05','16:50:00',1.88),('5819','2013-08-05','16:55:00',1.8),('5819','2013-08-05','17:00:00',1.74),('5819','2013-08-05','17:05:00',1.68),('5819','2013-08-05','17:10:00',1.6),('5819','2013-08-05','17:15:00',1.52),('5819','2013-08-05','17:20:00',1.45),('5819','2013-08-05','17:25:00',1.38),('5819','2013-08-05','17:30:00',1.32),('5819','2013-08-05','17:35:00',1.25),('5819','2013-08-05','17:40:00',1.16),('5819','2013-08-05','17:45:00',1.03),('5819','2013-08-05','17:50:00',1.02),('5819','2013-08-04','07:40:00',1.02),('5819','2013-08-04','07:45:00',1.11),('5819','2013-08-04','07:50:00',1.18),('5819','2013-08-04','07:55:00',1.26),('5819','2013-08-04','08:00:00',1.35),('5819','2013-08-04','08:05:00',1.43),('5819','2013-08-04','08:10:00',1.51),('5819','2013-08-04','08:15:00',1.59),('5819','2013-08-04','08:20:00',1.67),('5819','2013-08-04','08:25:00',1.74),('5819','2013-08-04','08:30:00',1.81),('5819','2013-08-04','08:35:00',1.88),('5819','2013-08-04','08:40:00',1.96),('5819','2013-08-04','08:45:00',2.03),('5819','2013-08-04','08:50:00',2.1),('5819','2013-08-04','08:55:00',2.15),('5819','2013-08-04','09:00:00',2.22),('5819','2013-08-04','09:05:00',2.27),('5819','2013-08-04','09:10:00',2.35),('5819','2013-08-04','09:15:00',2.4),('5819','2013-08-04','09:20:00',2.46),('5819','2013-08-04','09:25:00',2.53),('5819','2013-08-04','09:30:00',2.59),('5819','2013-08-04','09:35:00',2.58),('5819','2013-08-04','09:40:00',2.7),('5819','2013-08-04','09:45:00',2.75),('5819','2013-08-04','09:50:00',2.79),('5819','2013-08-04','09:55:00',2.83),('5819','2013-08-04','10:00:00',2.87),('5819','2013-08-04','10:05:00',2.93),('5819','2013-08-04','10:10:00',2.95),('5819','2013-08-04','10:15:00',3),('5819','2013-08-04','10:20:00',3.04),('5819','2013-08-04','10:25:00',3.1),('5819','2013-08-04','10:30:00',3.14),('5819','2013-08-04','10:35:00',3.17),('5819','2013-08-04','10:40:00',3.19),('5819','2013-08-04','10:45:00',3.22),('5819','2013-08-04','10:50:00',3.25),('5819','2013-08-04','10:55:00',3.26),('5819','2013-08-04','11:00:00',3.27),('5819','2013-08-04','11:05:00',3.3),('5819','2013-08-04','11:10:00',3.33),('5819','2013-08-04','11:15:00',3.36),('5819','2013-08-04','11:20:00',3.39),('5819','2013-08-04','11:25:00',3.43),('5819','2013-08-04','11:30:00',3.45),('5819','2013-08-04','11:35:00',3.48),('5819','2013-08-04','11:40:00',3.5),('5819','2013-08-04','11:45:00',3.5),('5819','2013-08-04','11:50:00',3.51),('5819','2013-08-04','11:55:00',3.55),('5819','2013-08-04','12:00:00',3.56),('5819','2013-08-04','12:05:00',3.55),('5819','2013-08-04','12:10:00',3.57),('5819','2013-08-04','12:15:00',3.54),('5819','2013-08-04','12:20:00',3.56),('5819','2013-08-04','12:25:00',3.54),('5819','2013-08-04','12:30:00',3.54),('5819','2013-08-04','12:35:00',3.53),('5819','2013-08-04','12:40:00',3.56),('5819','2013-08-04','12:45:00',3.53),('5819','2013-08-04','12:50:00',3.56),('5819','2013-08-04','12:55:00',3.49),('5819','2013-08-04','13:00:00',3.51),('5819','2013-08-04','13:05:00',3.54),('5819','2013-08-04','13:10:00',3.49),('5819','2013-08-04','13:15:00',3.49),('5819','2013-08-04','13:20:00',3.48),('5819','2013-08-04','13:25:00',3.45),('5819','2013-08-04','13:30:00',3.46),('5819','2013-08-04','13:35:00',3.48),('5819','2013-08-04','13:40:00',3.49),('5819','2013-08-04','13:45:00',3.51),('5819','2013-08-04','13:50:00',3.5),('5819','2013-08-04','13:55:00',3.48),('5819','2013-08-04','14:00:00',3.46),('5819','2013-08-04','14:05:00',3.45),('5819','2013-08-04','14:10:00',3.41),('5819','2013-08-04','14:15:00',3.4),('5819','2013-08-04','14:20:00',3.36),('5819','2013-08-04','14:25:00',3.34),('5819','2013-08-04','14:30:00',3.31),('5819','2013-08-04','14:35:00',3.29),('5819','2013-08-04','14:40:00',3.27),('5819','2013-08-04','14:45:00',3.23),('5819','2013-08-04','14:50:00',3.2),('5819','2013-08-04','14:55:00',3.16),('5819','2013-08-04','15:00:00',3.12),('5819','2013-08-04','15:05:00',3.08),('5819','2013-08-04','15:10:00',3.05),('5819','2013-08-04','15:15:00',3.02),('5819','2013-08-04','15:20:00',2.98),('5819','2013-08-04','15:25:00',2.9),('5819','2013-08-04','15:30:00',2.83),('5819','2013-08-04','15:35:00',2.83),('5819','2013-08-04','15:40:00',2.77),('5819','2013-08-04','15:45:00',2.72),('5819','2013-08-04','15:50:00',2.65),('5819','2013-08-04','15:55:00',2.6),('5819','2013-08-04','16:00:00',2.55),('5819','2013-08-04','16:05:00',2.48),('5819','2013-08-04','16:10:00',2.44),('5819','2013-08-04','16:15:00',2.4),('5819','2013-08-04','16:20:00',2.36),('5819','2013-08-04','16:25:00',2.29),('5819','2013-08-04','16:30:00',2.21),('5819','2013-08-04','16:35:00',2.14),('5819','2013-08-04','16:40:00',2.08),('5819','2013-08-04','16:45:00',2),('5819','2013-08-04','16:50:00',1.93),('5819','2013-08-04','16:55:00',1.87),('5819','2013-08-04','17:00:00',1.78),('5819','2013-08-04','17:05:00',1.72),('5819','2013-08-04','17:10:00',1.67),('5819','2013-08-04','17:15:00',1.59),('5819','2013-08-04','17:20:00',1.51),('5819','2013-08-04','17:25:00',1.43),('5819','2013-08-04','17:30:00',1.35),('5819','2013-08-04','17:35:00',1.28),('5819','2013-08-04','17:40:00',1.18),('5819','2013-08-04','17:45:00',1.06),('5819','2013-08-04','17:50:00',1.04),('5819','2013-08-03','07:40:00',1.02),('5819','2013-08-03','07:45:00',1.1),('5819','2013-08-03','07:50:00',1.17),('5819','2013-08-03','07:55:00',1.25),('5819','2013-08-03','08:00:00',1.34),('5819','2013-08-03','08:05:00',1.41),('5819','2013-08-03','08:10:00',1.5),('5819','2013-08-03','08:15:00',1.58),('5819','2013-08-03','08:20:00',1.65),('5819','2013-08-03','08:25:00',1.73),('5819','2013-08-03','08:30:00',1.79),('5819','2013-08-03','08:35:00',1.86),('5819','2013-08-03','08:40:00',1.93),('5819','2013-08-03','08:45:00',2),('5819','2013-08-03','08:50:00',2.06),('5819','2013-08-03','08:55:00',2.13),('5819','2013-08-03','09:00:00',2.22),('5819','2013-08-03','09:05:00',2.28),('5819','2013-08-03','09:10:00',2.34),('5819','2013-08-03','09:15:00',2.4),('5819','2013-08-03','09:20:00',2.46),('5819','2013-08-03','09:25:00',2.52),('5819','2013-08-03','09:30:00',2.57),('5819','2013-08-03','09:35:00',2.63),('5819','2013-08-03','09:40:00',2.67),('5819','2013-08-03','09:45:00',2.72),('5819','2013-08-03','09:50:00',2.77),('5819','2013-08-03','09:55:00',2.82),('5819','2013-08-03','10:00:00',2.86),('5819','2013-08-03','10:05:00',2.91),('5819','2013-08-03','10:10:00',2.95),('5819','2013-08-03','10:15:00',3.01),('5819','2013-08-03','10:20:00',3.02),('5819','2013-08-03','10:25:00',3.06),('5819','2013-08-03','10:30:00',3.08),('5819','2013-08-03','10:35:00',3.1),('5819','2013-08-03','10:40:00',3.18),('5819','2013-08-03','10:45:00',3.24),('5819','2013-08-03','10:50:00',3.27),('5819','2013-08-03','10:55:00',3.3),('5819','2013-08-03','11:00:00',3.34),('5819','2013-08-03','11:05:00',3.36),('5819','2013-08-03','11:10:00',3.36),('5819','2013-08-03','11:15:00',3.38),('5819','2013-08-03','11:20:00',3.38),('5819','2013-08-03','11:25:00',3.41),('5819','2013-08-03','11:30:00',3.44),('5819','2013-08-03','11:35:00',3.46),('5819','2013-08-03','11:40:00',3.45),('5819','2013-08-03','11:45:00',3.44),('5819','2013-08-03','11:50:00',3.49),('5819','2013-08-03','11:55:00',3.5),('5819','2013-08-03','12:00:00',3.51),('5819','2013-08-03','12:05:00',3.56),('5819','2013-08-03','12:10:00',3.56),('5819','2013-08-03','12:15:00',3.56),('5819','2013-08-03','12:20:00',3.57),('5819','2013-08-03','12:25:00',3.56),('5819','2013-08-03','12:30:00',3.56),('5819','2013-08-03','12:35:00',3.52),('5819','2013-08-03','12:40:00',3.54),('5819','2013-08-03','12:45:00',3.54),('5819','2013-08-03','12:50:00',3.54),('5819','2013-08-03','12:55:00',3.55),('5819','2013-08-03','13:00:00',3.51),('5819','2013-08-03','13:05:00',3.46),('5819','2013-08-03','13:10:00',3.44),('5819','2013-08-03','13:15:00',3.41),('5819','2013-08-03','13:20:00',3.36),('5819','2013-08-03','13:25:00',3.36),('5819','2013-08-03','13:30:00',3.35),('5819','2013-08-03','13:35:00',3.28),('5819','2013-08-03','13:40:00',3.36),('5819','2013-08-03','13:45:00',3.38),('5819','2013-08-03','13:50:00',3.37),('5819','2013-08-03','13:55:00',3.37),('5819','2013-08-03','14:00:00',3.4),('5819','2013-08-03','14:05:00',3.36),('5819','2013-08-03','14:10:00',3.25),('5819','2013-08-03','14:15:00',3.19),('5819','2013-08-03','14:20:00',3.12),('5819','2013-08-03','14:25:00',3.12),('5819','2013-08-03','14:30:00',3.17),('5819','2013-08-03','14:35:00',3.21),('5819','2013-08-03','14:40:00',3.17),('5819','2013-08-03','14:45:00',3.18),('5819','2013-08-03','14:50:00',3.14),('5819','2013-08-03','14:55:00',3.13),('5819','2013-08-03','15:00:00',3.09),('5819','2013-08-03','15:05:00',3.02),('5819','2013-08-03','15:10:00',2.99),('5819','2013-08-03','15:15:00',2.94),('5819','2013-08-03','15:20:00',2.94),('5819','2013-08-03','15:25:00',2.91),('5819','2013-08-03','15:30:00',2.86),('5819','2013-08-03','15:35:00',2.82),('5819','2013-08-03','15:40:00',2.76),('5819','2013-08-03','15:45:00',2.71),('5819','2013-08-03','15:50:00',2.67),('5819','2013-08-03','15:55:00',2.61),('5819','2013-08-03','16:00:00',2.54),('5819','2013-08-03','16:05:00',2.49),('5819','2013-08-03','16:10:00',2.42),('5819','2013-08-03','16:15:00',2.34),('5819','2013-08-03','16:20:00',2.28),('5819','2013-08-03','16:25:00',2.23),('5819','2013-08-03','16:30:00',2.18),('5819','2013-08-03','16:35:00',2.12),('5819','2013-08-03','16:40:00',2.05),('5819','2013-08-03','16:45:00',1.99),('5819','2013-08-03','16:50:00',1.93),('5819','2013-08-03','16:55:00',1.86),('5819','2013-08-03','17:00:00',1.78),('5819','2013-08-03','17:05:00',1.71),('5819','2013-08-03','17:10:00',1.64),('5819','2013-08-03','17:15:00',1.57),('5819','2013-08-03','17:20:00',1.5),('5819','2013-08-03','17:25:00',1.43),('5819','2013-08-03','17:30:00',1.36),('5819','2013-08-03','17:35:00',1.29),('5819','2013-08-03','17:40:00',1.19),('5819','2013-08-03','17:45:00',1.06),('5819','2013-08-03','17:50:00',1.04),('5819','2013-08-02','07:35:00',1.03),('5819','2013-08-02','07:40:00',1.1),('5819','2013-08-02','07:45:00',1.18),('5819','2013-08-02','07:50:00',1.26),('5819','2013-08-02','07:55:00',1.34),('5819','2013-08-02','08:00:00',1.44),('5819','2013-08-02','08:05:00',1.51),('5819','2013-08-02','08:10:00',1.59),('5819','2013-08-02','08:15:00',1.66),('5819','2013-08-02','08:20:00',1.74),('5819','2013-08-02','08:25:00',1.81),('5819','2013-08-02','08:30:00',1.89),('5819','2013-08-02','08:35:00',1.96),('5819','2013-08-02','08:40:00',2.03),('5819','2013-08-02','08:45:00',2.1),('5819','2013-08-02','08:50:00',2.15),('5819','2013-08-02','08:55:00',2.22),('5819','2013-08-02','09:00:00',2.29),('5819','2013-08-02','09:05:00',2.35),('5819','2013-08-02','09:10:00',2.42),('5819','2013-08-02','09:15:00',2.48),('5819','2013-08-02','09:20:00',2.55),('5819','2013-08-02','09:25:00',2.59),('5819','2013-08-02','09:30:00',2.64),('5819','2013-08-02','09:35:00',2.7),('5819','2013-08-02','09:40:00',2.75),('5819','2013-08-02','09:45:00',2.79),('5819','2013-08-02','09:50:00',2.84),('5819','2013-08-02','09:55:00',2.87),('5819','2013-08-02','10:00:00',2.91),('5819','2013-08-02','10:05:00',2.97),('5819','2013-08-02','10:10:00',3.01),('5819','2013-08-02','10:15:00',3.04),('5819','2013-08-02','10:20:00',3.07),('5819','2013-08-02','10:25:00',3.12),('5819','2013-08-02','10:30:00',3.17),('5819','2013-08-02','10:35:00',3.2),('5819','2013-08-02','10:40:00',3.23),('5819','2013-08-02','10:45:00',3.26),('5819','2013-08-02','10:50:00',3.3),('5819','2013-08-02','10:55:00',3.32),('5819','2013-08-02','11:00:00',3.33),('5819','2013-08-02','11:05:00',3.36),('5819','2013-08-02','11:10:00',3.38),('5819','2013-08-02','11:15:00',3.4),('5819','2013-08-02','11:20:00',3.44),('5819','2013-08-02','11:25:00',3.48),('5819','2013-08-02','11:30:00',3.5),('5819','2013-08-02','11:35:00',3.5),('5819','2013-08-02','11:40:00',3.49),('5819','2013-08-02','11:45:00',3.54),('5819','2013-08-02','11:50:00',3.55),('5819','2013-08-02','11:55:00',3.59),('5819','2013-08-02','12:00:00',3.59),('5819','2013-08-02','12:05:00',3.58),('5819','2013-08-02','12:10:00',3.58),('5819','2013-08-02','12:15:00',3.57),('5819','2013-08-02','12:20:00',3.6),('5819','2013-08-02','12:25:00',3.57),('5819','2013-08-02','12:30:00',3.55),('5819','2013-08-02','12:35:00',3.56),('5819','2013-08-02','12:40:00',3.56),('5819','2013-08-02','12:45:00',3.56),('5819','2013-08-02','12:50:00',3.54),('5819','2013-08-02','12:55:00',3.53),('5819','2013-08-02','13:00:00',3.56),('5819','2013-08-02','13:05:00',3.58),('5819','2013-08-02','13:10:00',3.6),('5819','2013-08-02','13:15:00',3.58),('5819','2013-08-02','13:20:00',3.55),('5819','2013-08-02','13:25:00',3.52),('5819','2013-08-02','13:30:00',3.54),('5819','2013-08-02','13:35:00',3.53),('5819','2013-08-02','13:40:00',3.49),('5819','2013-08-02','13:45:00',3.46),('5819','2013-08-02','13:50:00',3.44),('5819','2013-08-02','13:55:00',3.44),('5819','2013-08-02','14:00:00',3.42),('5819','2013-08-02','14:05:00',3.39),('5819','2013-08-02','14:10:00',3.37),('5819','2013-08-02','14:15:00',3.34),('5819','2013-08-02','14:20:00',3.27),('5819','2013-08-02','14:25:00',3.22),('5819','2013-08-02','14:30:00',3.27),('5819','2013-08-02','14:35:00',3.27),('5819','2013-08-02','14:40:00',3.23),('5819','2013-08-02','14:45:00',3.24),('5819','2013-08-02','14:50:00',3.21),('5819','2013-08-02','14:55:00',3.19),('5819','2013-08-02','15:00:00',3.17),('5819','2013-08-02','15:05:00',3.13),('5819','2013-08-02','15:10:00',3.05),('5819','2013-08-02','15:15:00',2.97),('5819','2013-08-02','15:20:00',2.97),('5819','2013-08-02','15:25:00',2.95),('5819','2013-08-02','15:30:00',2.92),('5819','2013-08-02','15:35:00',2.87),('5819','2013-08-02','15:40:00',2.83),('5819','2013-08-02','15:45:00',2.79),('5819','2013-08-02','15:50:00',2.74),('5819','2013-08-02','15:55:00',2.64),('5819','2013-08-02','16:00:00',2.6),('5819','2013-08-02','16:05:00',2.56),('5819','2013-08-02','16:10:00',2.51),('5819','2013-08-02','16:15:00',2.43),('5819','2013-08-02','16:20:00',2.36),('5819','2013-08-02','16:25:00',2.29),('5819','2013-08-02','16:30:00',2.24),('5819','2013-08-02','16:35:00',2.18),('5819','2013-08-02','16:40:00',2.12),('5819','2013-08-02','16:45:00',2.06),('5819','2013-08-02','16:50:00',2),('5819','2013-08-02','16:55:00',1.92),('5819','2013-08-02','17:00:00',1.84),('5819','2013-08-02','17:05:00',1.74),('5819','2013-08-02','17:10:00',1.68),('5819','2013-08-02','17:15:00',1.62),('5819','2013-08-02','17:20:00',1.56),('5819','2013-08-02','17:25:00',1.49),('5819','2013-08-02','17:30:00',1.41),('5819','2013-08-02','17:35:00',1.33),('5819','2013-08-02','17:40:00',1.24),('5819','2013-08-02','17:45:00',1.1),('5819','2013-08-02','17:50:00',1.06),('5819','2013-08-01','07:35:00',1.03),('5819','2013-08-01','07:40:00',1.11),('5819','2013-08-01','07:45:00',1.19),('5819','2013-08-01','07:50:00',1.26),('5819','2013-08-01','07:55:00',1.35),('5819','2013-08-01','08:00:00',1.42),('5819','2013-08-01','08:05:00',1.51),('5819','2013-08-01','08:10:00',1.58),('5819','2013-08-01','08:15:00',1.66),('5819','2013-08-01','08:20:00',1.75),('5819','2013-08-01','08:25:00',1.84),('5819','2013-08-01','08:30:00',1.92),('5819','2013-08-01','08:35:00',1.99),('5819','2013-08-01','08:40:00',2.07),('5819','2013-08-01','08:45:00',2.15),('5819','2013-08-01','08:50:00',2.21),('5819','2013-08-01','08:55:00',2.28),('5819','2013-08-01','09:00:00',2.34),('5819','2013-08-01','09:05:00',2.41),('5819','2013-08-01','09:10:00',2.5),('5819','2013-08-01','09:15:00',2.56),('5819','2013-08-01','09:20:00',2.62),('5819','2013-08-01','09:25:00',2.68),('5819','2013-08-01','09:30:00',2.73),('5819','2013-08-01','09:35:00',2.79),('5819','2013-08-01','09:40:00',2.86),('5819','2013-08-01','09:45:00',2.92),('5819','2013-08-01','09:50:00',2.96),('5819','2013-08-01','09:55:00',3.01),('5819','2013-08-01','10:00:00',3.07),('5819','2013-08-01','10:05:00',3.12),('5819','2013-08-01','10:10:00',3.17),('5819','2013-08-01','10:15:00',3.2),('5819','2013-08-01','10:20:00',3.24),('5819','2013-08-01','10:25:00',3.28),('5819','2013-08-01','10:30:00',3.32),('5819','2013-08-01','10:35:00',3.34),('5819','2013-08-01','10:40:00',3.37),('5819','2013-08-01','10:45:00',3.42),('5819','2013-08-01','10:50:00',3.47),('5819','2013-08-01','10:55:00',3.49),('5819','2013-08-01','11:00:00',3.51),('5819','2013-08-01','11:05:00',3.54),('5819','2013-08-01','11:10:00',3.6),('5819','2013-08-01','11:15:00',3.64),('5819','2013-08-01','11:20:00',3.66),('5819','2013-08-01','11:25:00',3.7),('5819','2013-08-01','11:30:00',3.71),('5819','2013-08-01','11:35:00',3.73),('5819','2013-08-01','11:40:00',3.75),('5819','2013-08-01','11:45:00',3.78),('5819','2013-08-01','11:50:00',3.77),('5819','2013-08-01','11:55:00',3.79),('5819','2013-08-01','12:00:00',3.8),('5819','2013-08-01','12:05:00',3.81),('5819','2013-08-01','12:10:00',3.8),('5819','2013-08-01','12:15:00',3.84),('5819','2013-08-01','12:20:00',3.82),('5819','2013-08-01','12:25:00',3.8),('5819','2013-08-01','12:30:00',3.8),('5819','2013-08-01','12:35:00',3.81),('5819','2013-08-01','12:40:00',3.83),('5819','2013-08-01','12:45:00',3.8),('5819','2013-08-01','12:50:00',3.83),('5819','2013-08-01','12:55:00',3.81),('5819','2013-08-01','13:00:00',3.8),('5819','2013-08-01','13:05:00',3.77),('5819','2013-08-01','13:10:00',3.76),('5819','2013-08-01','13:15:00',3.63),('5819','2013-08-01','13:20:00',3.77),('5819','2013-08-01','13:25:00',3.78),('5819','2013-08-01','13:30:00',3.54),('5819','2013-08-01','13:35:00',3.7),('5819','2013-08-01','13:40:00',3.7),('5819','2013-08-01','13:45:00',3.66),('5819','2013-08-01','13:50:00',3.56),('5819','2013-08-01','13:55:00',3.6),('5819','2013-08-01','14:00:00',3.43),('5819','2013-08-01','14:05:00',3.61),('5819','2013-08-01','14:10:00',3.48),('5819','2013-08-01','14:15:00',3.49),('5819','2013-08-01','14:20:00',3.37),('5819','2013-08-01','14:25:00',3.43),('5819','2013-08-01','14:30:00',3.4),('5819','2013-08-01','14:35:00',2.77),('5819','2013-08-01','14:40:00',3.24),('5819','2013-08-01','14:45:00',2.81),('5819','2013-08-01','14:50:00',2.86),('5819','2013-08-01','14:55:00',3.27),('5819','2013-08-01','15:00:00',3.21),('5819','2013-08-01','15:05:00',3.2),('5819','2013-08-01','15:10:00',2.7),('5819','2013-08-01','15:15:00',2.92),('5819','2013-08-01','15:20:00',3.16),('5819','2013-08-01','15:25:00',3.07),('5819','2013-08-01','15:30:00',3),('5819','2013-08-01','15:35:00',2.65),('5819','2013-08-01','15:40:00',2.03),('5819','2013-08-01','15:45:00',2.87),('5819','2013-08-01','15:50:00',2.8),('5819','2013-08-01','15:55:00',2.77),('5819','2013-08-01','16:00:00',2.72),('5819','2013-08-01','16:05:00',2.64),('5819','2013-08-01','16:10:00',2.56),('5819','2013-08-01','16:15:00',2.49),('5819','2013-08-01','16:20:00',2.44),('5819','2013-08-01','16:25:00',2.37),('5819','2013-08-01','16:30:00',2.3),('5819','2013-08-01','16:35:00',2.24),('5819','2013-08-01','16:40:00',2.17),('5819','2013-08-01','16:45:00',2.09),('5819','2013-08-01','16:50:00',2.02),('5819','2013-08-01','16:55:00',1.96),('5819','2013-08-01','17:00:00',1.88),('5819','2013-08-01','17:05:00',1.81),('5819','2013-08-01','17:10:00',1.74),('5819','2013-08-01','17:15:00',1.66),('5819','2013-08-01','17:20:00',1.59),('5819','2013-08-01','17:25:00',1.5),('5819','2013-08-01','17:30:00',1.43),('5819','2013-08-01','17:35:00',1.36),('5819','2013-08-01','17:40:00',1.27),('5819','2013-08-01','17:45:00',1.1),('5819','2013-08-01','17:50:00',1.09),('5819','2013-07-31','07:35:00',1.07),('5819','2013-07-31','07:40:00',1.15),('5819','2013-07-31','07:45:00',1.23),('5819','2013-07-31','07:50:00',1.31),('5819','2013-07-31','07:55:00',1.4),('5819','2013-07-31','08:00:00',1.48),('5819','2013-07-31','08:05:00',1.56),('5819','2013-07-31','08:10:00',1.65),('5819','2013-07-31','08:15:00',1.73),('5819','2013-07-31','08:20:00',1.81),('5819','2013-07-31','08:25:00',1.88),('5819','2013-07-31','08:30:00',1.96),('5819','2013-07-31','08:35:00',2.04),('5819','2013-07-31','08:40:00',2.11),('5819','2013-07-31','08:45:00',2.2),('5819','2013-07-31','08:50:00',2.26),('5819','2013-07-31','08:55:00',2.33),('5819','2013-07-31','09:00:00',2.4),('5819','2013-07-31','09:05:00',2.47),('5819','2013-07-31','09:10:00',2.55),('5819','2013-07-31','09:15:00',2.59),('5819','2013-07-31','09:20:00',2.66),('5819','2013-07-31','09:25:00',2.7),('5819','2013-07-31','09:30:00',2.78),('5819','2013-07-31','09:35:00',2.83),('5819','2013-07-31','09:40:00',2.87),('5819','2013-07-31','09:45:00',2.93),('5819','2013-07-31','09:50:00',2.98),('5819','2013-07-31','09:55:00',3.04),('5819','2013-07-31','10:00:00',3.07),('5819','2013-07-31','10:05:00',3.12),('5819','2013-07-31','10:10:00',3.17),('5819','2013-07-31','10:15:00',3.24),('5819','2013-07-31','10:20:00',3.27),('5819','2013-07-31','10:25:00',3.26),('5819','2013-07-31','10:30:00',3.3),('5819','2013-07-31','10:35:00',3.37),('5819','2013-07-31','10:40:00',3.42),('5819','2013-07-31','10:45:00',3.47),('5819','2013-07-31','10:50:00',3.51),('5819','2013-07-31','10:55:00',3.54),('5819','2013-07-31','11:00:00',3.59),('5819','2013-07-31','11:05:00',3.61),('5819','2013-07-31','11:10:00',3.65),('5819','2013-07-31','11:15:00',3.66),('5819','2013-07-31','11:20:00',3.69),('5819','2013-07-31','11:25:00',3.71),('5819','2013-07-31','11:30:00',3.71),('5819','2013-07-31','11:35:00',3.74),('5819','2013-07-31','11:40:00',3.77),('5819','2013-07-31','11:45:00',3.8),('5819','2013-07-31','11:50:00',3.83),('5819','2013-07-31','11:55:00',3.85),('5819','2013-07-31','12:00:00',3.84),('5819','2013-07-31','12:05:00',3.83),('5819','2013-07-31','12:10:00',3.8),('5819','2013-07-31','12:15:00',3.83),('5819','2013-07-31','12:20:00',3.85),('5819','2013-07-31','12:25:00',3.89),('5819','2013-07-31','12:30:00',3.87),('5819','2013-07-31','12:35:00',3.85),('5819','2013-07-31','12:40:00',3.9),('5819','2013-07-31','12:45:00',2.88),('5819','2013-07-31','12:50:00',2.92),('5819','2013-07-31','12:55:00',4.04),('5819','2013-07-31','13:00:00',1.73),('5819','2013-07-31','13:05:00',4.05),('5819','2013-07-31','13:10:00',3.77),('5819','2013-07-31','13:15:00',3.88),('5819','2013-07-31','13:20:00',3.56),('5819','2013-07-31','13:25:00',3.73),('5819','2013-07-31','13:30:00',3.78),('5819','2013-07-31','13:35:00',3.75),('5819','2013-07-31','13:40:00',3.83),('5819','2013-07-31','13:45:00',3.88),('5819','2013-07-31','13:50:00',3.31),('5819','2013-07-31','13:55:00',1.96),('5819','2013-07-31','14:00:00',3.29),('5819','2013-07-31','14:05:00',3.75),('5819','2013-07-31','14:10:00',3.04),('5819','2013-07-31','14:15:00',3.45),('5819','2013-07-31','14:20:00',3.71),('5819','2013-07-31','14:25:00',3.62),('5819','2013-07-31','14:30:00',3.51),('5819','2013-07-31','14:35:00',3.46),('5819','2013-07-31','14:40:00',3.47),('5819','2013-07-31','14:45:00',3.45),('5819','2013-07-31','14:50:00',2.75),('5819','2013-07-31','14:55:00',1.18),('5819','2013-07-31','15:00:00',1.8),('5819','2013-07-31','15:05:00',3.27),('5819','2013-07-31','15:10:00',2.4),('5819','2013-07-31','15:15:00',1.78),('5819','2013-07-31','15:20:00',3.01),('5819','2013-07-31','15:25:00',2.81),('5819','2013-07-31','15:30:00',3.13),('5819','2013-07-31','15:35:00',2.66),('5819','2013-07-31','15:40:00',2.95),('5819','2013-07-31','15:45:00',2.86),('5819','2013-07-31','15:50:00',2.8),('5819','2013-07-31','15:55:00',2.71),('5819','2013-07-31','16:00:00',2.65),('5819','2013-07-31','16:05:00',2.64),('5819','2013-07-31','16:10:00',2.62),('5819','2013-07-31','16:15:00',2.57),('5819','2013-07-31','16:20:00',2.39),('5819','2013-07-31','16:25:00',2.39),('5819','2013-07-31','16:30:00',1.44),('5819','2013-07-31','16:35:00',1.36),('5819','2013-07-31','16:40:00',2.17),('5819','2013-07-31','16:45:00',2.1),('5819','2013-07-31','16:50:00',2.05),('5819','2013-07-31','16:55:00',1.97),('5819','2013-07-31','17:00:00',1.66),('5819','2013-07-31','17:05:00',1.83),('5819','2013-07-31','17:10:00',1.7),('5819','2013-07-31','17:15:00',1.19),('5819','2013-07-31','17:20:00',1.58),('5819','2013-07-31','17:25:00',1.53),('5819','2013-07-31','17:30:00',1.42),('5819','2013-07-31','17:35:00',1.34),('5819','2013-07-31','17:40:00',1.27),('5819','2013-07-31','17:45:00',1.14),('5819','2013-07-31','17:50:00',1.09),('5819','2013-07-30','07:55:00',1.25),('5819','2013-07-30','08:00:00',1.37),('5819','2013-07-30','08:05:00',1.46),('5819','2013-07-30','08:10:00',1.54),('5819','2013-07-30','08:15:00',1.6),('5819','2013-07-30','08:20:00',1.77),('5819','2013-07-30','08:25:00',1.86),('5819','2013-07-30','08:30:00',1.85),('5819','2013-07-30','08:35:00',1.97),('5819','2013-07-30','08:40:00',2.03),('5819','2013-07-30','08:45:00',2.09),('5819','2013-07-30','08:50:00',2.17),('5819','2013-07-30','08:55:00',2.29),('5819','2013-07-30','09:00:00',2.36),('5819','2013-07-30','09:05:00',2.41),('5819','2013-07-30','09:10:00',2.42),('5819','2013-07-30','09:15:00',2.56),('5819','2013-07-30','09:20:00',2.71),('5819','2013-07-30','09:25:00',2.78),('5819','2013-07-30','09:30:00',2.86),('5819','2013-07-30','09:35:00',2.93),('5819','2013-07-30','09:40:00',3.05),('5819','2013-07-30','09:45:00',3.06),('5819','2013-07-30','09:50:00',3.05),('5819','2013-07-30','09:55:00',3.07),('5819','2013-07-30','10:00:00',3.03),('5819','2013-07-30','10:05:00',3.15),('5819','2013-07-30','10:10:00',3.21),('5819','2013-07-30','10:15:00',2.7),('5819','2013-07-30','10:20:00',2.89),('5819','2013-07-30','10:25:00',3.32),('5819','2013-07-30','10:30:00',3.34),('5819','2013-07-30','10:35:00',3.39),('5819','2013-07-30','10:40:00',3.36),('5819','2013-07-30','10:45:00',3.41),('5819','2013-07-30','10:50:00',3.39),('5819','2013-07-30','10:55:00',3.41),('5819','2013-07-30','11:00:00',3.45),('5819','2013-07-30','11:05:00',3.53),('5819','2013-07-30','11:10:00',3.59),('5819','2013-07-30','11:15:00',3.63),('5819','2013-07-30','11:20:00',3.51),('5819','2013-07-30','11:25:00',3.5),('5819','2013-07-30','11:30:00',3.41),('5819','2013-07-30','11:35:00',1.99),('5819','2013-07-30','11:40:00',3.24),('5819','2013-07-30','11:45:00',3.69),('5819','2013-07-30','11:50:00',3.73),('5819','2013-07-30','11:55:00',3.71),('5819','2013-07-30','12:00:00',3.73),('5819','2013-07-30','12:05:00',3.69),('5819','2013-07-30','12:10:00',3.71),('5819','2013-07-30','12:15:00',3.68),('5819','2013-07-30','12:20:00',3.66),('5819','2013-07-30','12:25:00',3.65),('5819','2013-07-30','12:30:00',3.65),('5819','2013-07-30','12:35:00',3.8),('5819','2013-07-30','12:40:00',3.7),('5819','2013-07-30','12:45:00',2.99),('5819','2013-07-30','12:50:00',3.9),('5819','2013-07-30','12:55:00',3.96),('5819','2013-07-30','13:00:00',2.28),('5819','2013-07-30','13:05:00',2.21),('5819','2013-07-30','13:10:00',4),('5819','2013-07-30','13:15:00',3.91),('5819','2013-07-30','13:20:00',2.77),('5819','2013-07-30','13:25:00',2.05),('5819','2013-07-30','13:30:00',3.35),('5819','2013-07-30','13:35:00',3.94),('5819','2013-07-30','13:40:00',3.79),('5819','2013-07-30','13:45:00',3.79),('5819','2013-07-30','13:50:00',3.89),('5819','2013-07-30','13:55:00',3.88),('5819','2013-07-30','14:00:00',3.54),('5819','2013-07-30','14:05:00',3.84),('5819','2013-07-30','14:10:00',3.83),('5819','2013-07-30','14:15:00',3.58),('5819','2013-07-30','14:20:00',3.51),('5819','2013-07-30','14:25:00',3.53),('5819','2013-07-30','14:30:00',2.64),('5819','2013-07-30','14:35:00',3.32),('5819','2013-07-30','14:40:00',3.36),('5819','2013-07-30','14:45:00',3.34),('5819','2013-07-30','14:50:00',3.35),('5819','2013-07-30','14:55:00',3.32),('5819','2013-07-30','15:00:00',3.23),('5819','2013-07-30','15:05:00',3.16),('5819','2013-07-30','15:10:00',2.99),('5819','2013-07-30','15:15:00',3.06),('5819','2013-07-30','15:20:00',3.05),('5819','2013-07-30','15:25:00',2.96),('5819','2013-07-30','15:30:00',2.9),('5819','2013-07-30','15:35:00',2.87),('5819','2013-07-30','15:40:00',2.83),('5819','2013-07-30','15:45:00',2.76),('5819','2013-07-30','15:50:00',2.72),('5819','2013-07-30','15:55:00',2.66),('5819','2013-07-30','16:00:00',2.62),('5819','2013-07-30','16:05:00',2.56),('5819','2013-07-30','16:10:00',2.48),('5819','2013-07-30','16:15:00',2.43),('5819','2013-07-30','16:20:00',2.39),('5819','2013-07-30','16:25:00',2.32),('5819','2013-07-30','16:30:00',2.24),('5819','2013-07-30','16:35:00',2.19),('5819','2013-07-30','16:40:00',2.14),('5819','2013-07-30','16:45:00',2.07),('5819','2013-07-30','16:50:00',1.98),('5819','2013-07-30','16:55:00',1.92),('5819','2013-07-30','17:00:00',1.86),('5819','2013-07-30','17:05:00',1.79),('5819','2013-07-30','17:10:00',1.7),('5819','2013-07-30','17:15:00',1.64),('5819','2013-07-30','17:20:00',1.58),('5819','2013-07-30','17:25:00',1.51),('5819','2013-07-30','17:30:00',1.43),('5819','2013-07-30','17:35:00',1.36),('5819','2013-07-30','17:40:00',1.28),('5819','2013-07-30','17:45:00',1.12),('5819','2013-07-30','17:50:00',1.07),('5819','2013-07-29','07:45:00',1.02),('5819','2013-07-29','07:50:00',1.1),('5819','2013-07-29','07:55:00',1.18),('5819','2013-07-29','08:00:00',1.26),('5819','2013-07-29','08:05:00',1.32),('5819','2013-07-29','08:10:00',1.37),('5819','2013-07-29','08:15:00',1.44),('5819','2013-07-29','08:20:00',1.53),('5819','2013-07-29','08:25:00',1.61),('5819','2013-07-29','08:30:00',1.68),('5819','2013-07-29','08:35:00',1.75),('5819','2013-07-29','08:40:00',1.83),('5819','2013-07-29','08:45:00',1.88),('5819','2013-07-29','08:50:00',1.97),('5819','2013-07-29','08:55:00',2.04),('5819','2013-07-29','09:00:00',2.09),('5819','2013-07-29','09:05:00',2.19),('5819','2013-07-29','09:10:00',2.25),('5819','2013-07-29','09:15:00',2.3),('5819','2013-07-29','09:20:00',2.36),('5819','2013-07-29','09:25:00',2.41),('5819','2013-07-29','09:30:00',2.46),('5819','2013-07-29','09:35:00',2.54),('5819','2013-07-29','09:40:00',2.64),('5819','2013-07-29','09:45:00',2.7),('5819','2013-07-29','09:50:00',2.73),('5819','2013-07-29','09:55:00',2.79),('5819','2013-07-29','10:00:00',2.86),('5819','2013-07-29','10:05:00',2.91),('5819','2013-07-29','10:10:00',2.96),('5819','2013-07-29','10:15:00',2.99),('5819','2013-07-29','10:20:00',3.05),('5819','2013-07-29','10:25:00',3.1),('5819','2013-07-29','10:30:00',3.12),('5819','2013-07-29','10:35:00',3.19),('5819','2013-07-29','10:40:00',3.24),('5819','2013-07-29','10:45:00',3.24),('5819','2013-07-29','10:50:00',3.25),('5819','2013-07-29','10:55:00',3.26),('5819','2013-07-29','11:00:00',3.33),('5819','2013-07-29','11:05:00',3.32),('5819','2013-07-29','11:10:00',3.27),('5819','2013-07-29','11:15:00',3.28),('5819','2013-07-29','11:20:00',3.31),('5819','2013-07-29','11:25:00',3.34),('5819','2013-07-29','11:30:00',3.38),('5819','2013-07-29','11:35:00',3.37),('5819','2013-07-29','11:40:00',3.39),('5819','2013-07-29','11:45:00',3.4),('5819','2013-07-29','11:50:00',3.41),('5819','2013-07-29','11:55:00',3.43),('5819','2013-07-29','12:00:00',3.47),('5819','2013-07-29','12:05:00',3.44),('5819','2013-07-29','12:10:00',3.44),('5819','2013-07-29','12:15:00',3.46),('5819','2013-07-29','12:20:00',3.49),('5819','2013-07-29','12:25:00',3.51),('5819','2013-07-29','12:30:00',3.51),('5819','2013-07-29','12:35:00',3.52),('5819','2013-07-29','12:40:00',3.53),('5819','2013-07-29','12:45:00',3.52),('5819','2013-07-29','12:50:00',3.52),('5819','2013-07-29','12:55:00',3.49),('5819','2013-07-29','13:00:00',3.43),('5819','2013-07-29','13:05:00',3.53),('5819','2013-07-29','13:10:00',3.51),('5819','2013-07-29','13:15:00',3.5),('5819','2013-07-29','13:20:00',3.57),('5819','2013-07-29','13:25:00',3.56),('5819','2013-07-29','13:30:00',3.54),('5819','2013-07-29','13:35:00',3.54),('5819','2013-07-29','13:40:00',3.56),('5819','2013-07-29','13:45:00',3.57),('5819','2013-07-29','13:50:00',3.53),('5819','2013-07-29','13:55:00',3.51),('5819','2013-07-29','14:00:00',3.51),('5819','2013-07-29','14:05:00',3.48),('5819','2013-07-29','14:10:00',3.46),('5819','2013-07-29','14:15:00',3.43),('5819','2013-07-29','14:20:00',3.41),('5819','2013-07-29','14:25:00',3.38),('5819','2013-07-29','14:30:00',3.33),('5819','2013-07-29','14:35:00',3.3),('5819','2013-07-29','14:40:00',3.27),('5819','2013-07-29','14:45:00',3.25),('5819','2013-07-29','14:50:00',3.22),('5819','2013-07-29','14:55:00',3.17),('5819','2013-07-29','15:00:00',3.14),('5819','2013-07-29','15:05:00',3.1),('5819','2013-07-29','15:10:00',3.06),('5819','2013-07-29','15:15:00',3.03),('5819','2013-07-29','15:20:00',2.98),('5819','2013-07-29','15:25:00',2.93),('5819','2013-07-29','15:30:00',2.88),('5819','2013-07-29','15:35:00',2.85),('5819','2013-07-29','15:40:00',2.86),('5819','2013-07-29','15:45:00',2.84),('5819','2013-07-29','15:50:00',2.5),('5819','2013-07-29','15:55:00',1.66),('5819','2013-07-29','16:00:00',1.43),('5819','2013-07-29','16:05:00',2.12),('5819','2013-07-29','16:10:00',2.44),('5819','2013-07-29','16:15:00',2.35),('5819','2013-07-29','16:20:00',2.09),('5819','2013-07-29','16:25:00',1.9),('5819','2013-07-29','16:30:00',2.43),('5819','2013-07-29','16:35:00',2.29),('5819','2013-07-29','16:40:00',1.78),('5819','2013-07-29','16:45:00',2.29),('5819','2013-07-29','16:50:00',2.14),('5819','2013-07-29','16:55:00',1.38),('5819','2013-07-29','17:00:00',1.08),('5819','2013-07-29','17:05:00',1.35),('5819','2013-07-29','17:10:00',1.23),('5819','2013-07-29','17:20:00',1.56),('5819','2013-07-29','17:25:00',1.51),('5819','2013-07-29','17:45:00',1.26),('5819','2013-07-29','17:50:00',1.16),('5819','2013-07-28','07:45:00',1.03),('5819','2013-07-28','07:50:00',1.09),('5819','2013-07-28','07:55:00',1.17),('5819','2013-07-28','08:00:00',1.25),('5819','2013-07-28','08:05:00',1.35),('5819','2013-07-28','08:10:00',1.43),('5819','2013-07-28','08:15:00',1.51),('5819','2013-07-28','08:20:00',1.58),('5819','2013-07-28','08:25:00',1.67),('5819','2013-07-28','08:30:00',1.75),('5819','2013-07-28','08:35:00',1.84),('5819','2013-07-28','08:40:00',1.91),('5819','2013-07-28','08:45:00',1.97),('5819','2013-07-28','08:50:00',2.03),('5819','2013-07-28','08:55:00',2.1),('5819','2013-07-28','09:00:00',2.15),('5819','2013-07-28','09:05:00',2.24),('5819','2013-07-28','09:10:00',2.3),('5819','2013-07-28','09:15:00',2.37),('5819','2013-07-28','09:20:00',2.42),('5819','2013-07-28','09:25:00',2.46),('5819','2013-07-28','09:30:00',2.54),('5819','2013-07-28','09:35:00',2.59),('5819','2013-07-28','09:40:00',2.66),('5819','2013-07-28','09:45:00',2.7),('5819','2013-07-28','09:50:00',2.75),('5819','2013-07-28','09:55:00',2.79),('5819','2013-07-28','10:00:00',2.84),('5819','2013-07-28','10:05:00',2.87),('5819','2013-07-28','10:10:00',2.91),('5819','2013-07-28','10:15:00',2.95),('5819','2013-07-28','10:20:00',2.99),('5819','2013-07-28','10:25:00',3.02),('5819','2013-07-28','10:30:00',3.06),('5819','2013-07-28','10:35:00',3.06),('5819','2013-07-28','10:40:00',3.14),('5819','2013-07-28','10:45:00',3.16),('5819','2013-07-28','10:50:00',3.19),('5819','2013-07-28','10:55:00',3.21),('5819','2013-07-28','11:00:00',3.21),('5819','2013-07-28','11:05:00',3.25),('5819','2013-07-28','11:10:00',3.31),('5819','2013-07-28','11:15:00',3.34),('5819','2013-07-28','11:20:00',3.38),('5819','2013-07-28','11:25:00',3.42),('5819','2013-07-28','11:30:00',3.41),('5819','2013-07-28','11:35:00',3.42),('5819','2013-07-28','11:40:00',3.4),('5819','2013-07-28','11:45:00',3.38),('5819','2013-07-28','11:50:00',3.39),('5819','2013-07-28','11:55:00',3.42),('5819','2013-07-28','12:00:00',3.49),('5819','2013-07-28','12:05:00',3.5),('5819','2013-07-28','12:10:00',3.45),('5819','2013-07-28','12:15:00',3.49),('5819','2013-07-28','12:20:00',3.41),('5819','2013-07-28','12:25:00',3.45),('5819','2013-07-28','12:30:00',3.47),('5819','2013-07-28','12:35:00',3.58),('5819','2013-07-28','12:40:00',3.57),('5819','2013-07-28','12:45:00',3.54),('5819','2013-07-28','12:50:00',3.54),('5819','2013-07-28','12:55:00',3.51),('5819','2013-07-28','13:00:00',3.53),('5819','2013-07-28','13:05:00',3.48),('5819','2013-07-28','13:10:00',3.32),('5819','2013-07-28','13:15:00',3.59),('5819','2013-07-28','13:20:00',3.54),('5819','2013-07-28','13:25:00',3.54),('5819','2013-07-28','13:30:00',3.48),('5819','2013-07-28','13:35:00',3.52),('5819','2013-07-28','13:40:00',3.51),('5819','2013-07-28','13:45:00',3.46),('5819','2013-07-28','13:50:00',3.56),('5819','2013-07-28','13:55:00',3.51),('5819','2013-07-28','14:00:00',3.46),('5819','2013-07-28','14:05:00',3.45),('5819','2013-07-28','14:10:00',3.42),('5819','2013-07-28','14:15:00',3.39),('5819','2013-07-28','14:20:00',3.36),('5819','2013-07-28','14:25:00',3.31),('5819','2013-07-28','14:30:00',3.3),('5819','2013-07-28','14:35:00',3.24),('5819','2013-07-28','14:40:00',3.27),('5819','2013-07-28','14:45:00',3.22),('5819','2013-07-28','14:50:00',3.19),('5819','2013-07-28','14:55:00',3.14),('5819','2013-07-28','15:00:00',3.1),('5819','2013-07-28','15:05:00',3.04),('5819','2013-07-28','15:10:00',2.99),('5819','2013-07-28','15:15:00',3),('5819','2013-07-28','15:20:00',2.96),('5819','2013-07-28','15:25:00',2.89),('5819','2013-07-28','15:30:00',2.87),('5819','2013-07-28','15:35:00',2.83),('5819','2013-07-28','15:40:00',2.75),('5819','2013-07-28','15:45:00',2.73),('5819','2013-07-28','15:50:00',2.67),('5819','2013-07-28','15:55:00',2.64),('5819','2013-07-28','16:00:00',2.61),('5819','2013-07-28','16:05:00',2.56),('5819','2013-07-28','16:10:00',2.52),('5819','2013-07-28','16:15:00',2.46),('5819','2013-07-28','16:20:00',2.4),('5819','2013-07-28','16:25:00',2.35),('5819','2013-07-28','16:30:00',2.28),('5819','2013-07-28','16:35:00',2.22),('5819','2013-07-28','16:40:00',2.16),('5819','2013-07-28','16:45:00',2.08),('5819','2013-07-28','16:50:00',2.01),('5819','2013-07-28','16:55:00',1.95),('5819','2013-07-28','17:00:00',1.88),('5819','2013-07-28','17:05:00',1.81),('5819','2013-07-28','17:10:00',1.74),('5819','2013-07-28','17:15:00',1.67),('5819','2013-07-28','17:20:00',1.6),('5819','2013-07-28','17:25:00',1.53),('5819','2013-07-28','17:30:00',1.45),('5819','2013-07-28','17:35:00',1.38),('5819','2013-07-28','17:40:00',1.31),('5819','2013-07-28','17:45:00',1.15),('5819','2013-07-28','17:50:00',1.1),('5819','2013-07-27','07:45:00',1.04),('5819','2013-07-27','07:50:00',1.12),('5819','2013-07-27','07:55:00',1.2),('5819','2013-07-27','08:00:00',1.28),('5819','2013-07-27','08:05:00',1.36),('5819','2013-07-27','08:10:00',1.45),('5819','2013-07-27','08:15:00',1.55),('5819','2013-07-27','08:20:00',1.63),('5819','2013-07-27','08:25:00',1.7),('5819','2013-07-27','08:30:00',1.78),('5819','2013-07-27','08:35:00',1.86),('5819','2013-07-27','08:40:00',1.93),('5819','2013-07-27','08:45:00',1.99),('5819','2013-07-27','08:50:00',2.06),('5819','2013-07-27','08:55:00',2.13),('5819','2013-07-27','09:00:00',2.19),('5819','2013-07-27','09:05:00',2.27),('5819','2013-07-27','09:10:00',2.33),('5819','2013-07-27','09:15:00',2.4),('5819','2013-07-27','09:20:00',2.49),('5819','2013-07-27','09:25:00',2.57),('5819','2013-07-27','09:30:00',2.57),('5819','2013-07-27','09:35:00',2.62),('5819','2013-07-27','09:40:00',2.69),('5819','2013-07-27','09:45:00',2.76),('5819','2013-07-27','09:50:00',2.79),('5819','2013-07-27','09:55:00',2.84),('5819','2013-07-27','10:00:00',2.9),('5819','2013-07-27','10:05:00',2.95),('5819','2013-07-27','10:10:00',3),('5819','2013-07-27','10:15:00',3.04),('5819','2013-07-27','10:20:00',3.09),('5819','2013-07-27','10:25:00',3.13),('5819','2013-07-27','10:30:00',3.16),('5819','2013-07-27','10:35:00',3.17),('5819','2013-07-27','10:40:00',3.19),('5819','2013-07-27','10:45:00',3.24),('5819','2013-07-27','10:50:00',3.25),('5819','2013-07-27','10:55:00',3.29),('5819','2013-07-27','11:00:00',3.31),('5819','2013-07-27','11:05:00',3.35),('5819','2013-07-27','11:10:00',3.39),('5819','2013-07-27','11:15:00',3.39),('5819','2013-07-27','11:20:00',3.41),('5819','2013-07-27','11:25:00',3.47),('5819','2013-07-27','11:30:00',3.49),('5819','2013-07-27','11:35:00',3.52),('5819','2013-07-27','11:40:00',3.5),('5819','2013-07-27','11:45:00',3.52),('5819','2013-07-27','11:50:00',3.51),('5819','2013-07-27','11:55:00',3.53),('5819','2013-07-27','12:00:00',3.53),('5819','2013-07-27','12:05:00',3.54),('5819','2013-07-27','12:10:00',3.55),('5819','2013-07-27','12:15:00',3.54),('5819','2013-07-27','12:20:00',3.6),('5819','2013-07-27','12:25:00',3.59),('5819','2013-07-27','12:30:00',3.55),('5819','2013-07-27','12:35:00',3.61),('5819','2013-07-27','12:40:00',3.62),('5819','2013-07-27','12:45:00',3.55),('5819','2013-07-27','12:50:00',3.52),('5819','2013-07-27','12:55:00',3.56),('5819','2013-07-27','13:00:00',3.57),('5819','2013-07-27','13:05:00',3.68),('5819','2013-07-27','13:10:00',3.64),('5819','2013-07-27','13:15:00',3.64),('5819','2013-07-27','13:20:00',3.65),('5819','2013-07-27','13:25:00',3.68),('5819','2013-07-27','13:30:00',3.73),('5819','2013-07-27','13:35:00',3.38),('5819','2013-07-27','13:40:00',3.32),('5819','2013-07-27','13:45:00',3.66),('5819','2013-07-27','13:50:00',3.67),('5819','2013-07-27','13:55:00',3.67),('5819','2013-07-27','14:00:00',3.5),('5819','2013-07-27','14:05:00',3.52),('5819','2013-07-27','14:10:00',2.79),('5819','2013-07-27','14:15:00',3.17),('5819','2013-07-27','14:20:00',3.49),('5819','2013-07-27','14:25:00',3.41),('5819','2013-07-27','14:30:00',3.36),('5819','2013-07-27','14:35:00',3.35),('5819','2013-07-27','14:40:00',3.32),('5819','2013-07-27','14:45:00',3.3),('5819','2013-07-27','14:50:00',3.24),('5819','2013-07-27','14:55:00',3.19),('5819','2013-07-27','15:00:00',3.13),('5819','2013-07-27','15:05:00',3.06),('5819','2013-07-27','15:10:00',3.09),('5819','2013-07-27','15:15:00',3.04),('5819','2013-07-27','15:20:00',2.99),('5819','2013-07-27','15:25:00',2.94),('5819','2013-07-27','15:30:00',2.9),('5819','2013-07-27','15:35:00',2.85),('5819','2013-07-27','15:40:00',2.81),('5819','2013-07-27','15:45:00',2.75),('5819','2013-07-27','15:50:00',2.72),('5819','2013-07-27','15:55:00',2.66),('5819','2013-07-27','16:00:00',2.62),('5819','2013-07-27','16:05:00',2.57),('5819','2013-07-27','16:10:00',2.52),('5819','2013-07-27','16:15:00',2.46),('5819','2013-07-27','16:20:00',2.4),('5819','2013-07-27','16:25:00',2.33),('5819','2013-07-27','16:30:00',2.27),('5819','2013-07-27','16:35:00',2.22),('5819','2013-07-27','16:40:00',2.15),('5819','2013-07-27','16:45:00',2.09),('5819','2013-07-27','16:50:00',2.02),('5819','2013-07-27','16:55:00',1.95),('5819','2013-07-27','17:00:00',1.89),('5819','2013-07-27','17:05:00',1.81),('5819','2013-07-27','17:10:00',1.74),('5819','2013-07-27','17:15:00',1.67),('5819','2013-07-27','17:20:00',1.6),('5819','2013-07-27','17:25:00',1.54),('5819','2013-07-27','17:30:00',1.46),('5819','2013-07-27','17:35:00',1.38),('5819','2013-07-27','17:40:00',1.31),('5819','2013-07-27','17:45:00',1.17),('5819','2013-07-27','17:50:00',1.09),('5819','2013-07-26','07:45:00',1.05),('5819','2013-07-26','07:50:00',1.13),('5819','2013-07-26','07:55:00',1.18),('5819','2013-07-26','08:00:00',1.22),('5819','2013-07-26','08:05:00',1.31),('5819','2013-07-26','08:10:00',1.4),('5819','2013-07-26','08:15:00',1.48),('5819','2013-07-26','08:20:00',1.55),('5819','2013-07-26','08:25:00',1.62),('5819','2013-07-26','08:30:00',1.72),('5819','2013-07-26','08:35:00',1.79),('5819','2013-07-26','08:40:00',1.83),('5819','2013-07-26','08:45:00',1.91),('5819','2013-07-26','08:50:00',2.01),('5819','2013-07-26','08:55:00',2.09),('5819','2013-07-26','09:00:00',2.15),('5819','2013-07-26','09:05:00',2.21),('5819','2013-07-26','09:10:00',2.29),('5819','2013-07-26','09:15:00',2.34),('5819','2013-07-26','09:20:00',2.41),('5819','2013-07-26','09:25:00',2.43),('5819','2013-07-26','09:30:00',2.47),('5819','2013-07-26','09:35:00',2.52),('5819','2013-07-26','09:40:00',2.59),('5819','2013-07-26','09:45:00',2.62),('5819','2013-07-26','09:50:00',2.1),('5819','2013-07-26','09:55:00',2.77),('5819','2013-07-26','10:00:00',2.81),('5819','2013-07-26','10:05:00',2.92),('5819','2013-07-26','10:10:00',2.87),('5819','2013-07-26','10:15:00',2.98),('5819','2013-07-26','10:20:00',3.02),('5819','2013-07-26','10:25:00',3.06),('5819','2013-07-26','10:30:00',3.11),('5819','2013-07-26','10:35:00',3.14),('5819','2013-07-26','10:40:00',3.18),('5819','2013-07-26','10:45:00',3.22),('5819','2013-07-26','10:50:00',3.25),('5819','2013-07-26','10:55:00',3.26),('5819','2013-07-26','11:00:00',3.31),('5819','2013-07-26','11:05:00',3.33),('5819','2013-07-26','11:10:00',3.34),('5819','2013-07-26','11:15:00',3.34),('5819','2013-07-26','11:20:00',2.61),('5819','2013-07-26','11:25:00',3.29),('5819','2013-07-26','11:30:00',3.34),('5819','2013-07-26','11:35:00',3.24),('5819','2013-07-26','11:40:00',3.38),('5819','2013-07-26','11:45:00',3.44),('5819','2013-07-26','11:50:00',3.52),('5819','2013-07-26','11:55:00',3.54),('5819','2013-07-26','12:00:00',3.52),('5819','2013-07-26','12:05:00',3.52),('5819','2013-07-26','12:10:00',1.29),('5819','2013-07-26','12:15:00',2.6),('5819','2013-07-26','12:20:00',1.92),('5819','2013-07-26','12:25:00',3.69),('5819','2013-07-26','12:30:00',3.62),('5819','2013-07-26','12:35:00',3.65),('5819','2013-07-26','12:40:00',3.76),('5819','2013-07-26','12:45:00',3.85),('5819','2013-07-26','12:50:00',3.84),('5819','2013-07-26','12:55:00',3.71),('5819','2013-07-26','13:00:00',2.53),('5819','2013-07-26','13:05:00',1.11),('5819','2013-07-26','13:10:00',1.21),('5819','2013-07-26','13:15:00',1.64),('5819','2013-07-26','13:20:00',2.57),('5819','2013-07-26','13:25:00',3.55),('5819','2013-07-26','13:30:00',3.99),('5819','2013-07-26','13:35:00',3.77),('5819','2013-07-26','13:40:00',3.69),('5819','2013-07-26','13:45:00',3.71),('5819','2013-07-26','13:50:00',3.66),('5819','2013-07-26','13:55:00',3.39),('5819','2013-07-26','14:00:00',3.66),('5819','2013-07-26','14:05:00',3.72),('5819','2013-07-26','14:10:00',3.57),('5819','2013-07-26','14:15:00',3.53),('5819','2013-07-26','14:20:00',3.56),('5819','2013-07-26','14:25:00',3.51),('5819','2013-07-26','14:30:00',3.43),('5819','2013-07-26','14:35:00',3.37),('5819','2013-07-26','14:40:00',3.39),('5819','2013-07-26','14:45:00',3.27),('5819','2013-07-26','14:50:00',3.28),('5819','2013-07-26','14:55:00',3.21),('5819','2013-07-26','15:00:00',3.23),('5819','2013-07-26','15:05:00',3.15),('5819','2013-07-26','15:10:00',3.14),('5819','2013-07-26','15:15:00',3.08),('5819','2013-07-26','15:20:00',3.03),('5819','2013-07-26','15:25:00',2.95),('5819','2013-07-26','15:30:00',2.92),('5819','2013-07-26','15:35:00',2.91),('5819','2013-07-26','15:40:00',2.86),('5819','2013-07-26','15:45:00',2.84),('5819','2013-07-26','15:50:00',2.79),('5819','2013-07-26','15:55:00',2.72),('5819','2013-07-26','16:00:00',2.65),('5819','2013-07-26','16:05:00',2.59),('5819','2013-07-26','16:10:00',2.52),('5819','2013-07-26','16:15:00',2.47),('5819','2013-07-26','16:20:00',2.4),('5819','2013-07-26','16:25:00',2.36),('5819','2013-07-26','16:30:00',2.31),('5819','2013-07-26','16:35:00',2.23),('5819','2013-07-26','16:40:00',2.18),('5819','2013-07-26','16:45:00',2.12),('5819','2013-07-26','16:50:00',2.04),('5819','2013-07-26','16:55:00',1.97),('5819','2013-07-26','17:00:00',1.9),('5819','2013-07-26','17:05:00',1.83),('5819','2013-07-26','17:10:00',1.76),('5819','2013-07-26','17:15:00',1.66),('5819','2013-07-26','17:20:00',1.61),('5819','2013-07-26','17:25:00',1.54),('5819','2013-07-26','17:30:00',1.44),('5819','2013-07-26','17:35:00',1.38),('5819','2013-07-26','17:40:00',1.31),('5819','2013-07-26','17:45:00',1.17),('5819','2013-07-26','17:50:00',1.05),('5819','2013-07-25','07:45:00',1.04),('5819','2013-07-25','07:50:00',1.12),('5819','2013-07-25','07:55:00',1.19),('5819','2013-07-25','08:00:00',1.28),('5819','2013-07-25','08:05:00',1.36),('5819','2013-07-25','08:10:00',1.42),('5819','2013-07-25','08:15:00',1.52),('5819','2013-07-25','08:20:00',1.58),('5819','2013-07-25','08:25:00',1.65),('5819','2013-07-25','08:30:00',1.71),('5819','2013-07-25','08:35:00',1.79),('5819','2013-07-25','08:40:00',1.91),('5819','2013-07-25','08:45:00',2),('5819','2013-07-25','08:50:00',2.06),('5819','2013-07-25','08:55:00',2.04),('5819','2013-07-25','09:00:00',2.16),('5819','2013-07-25','09:05:00',2.18),('5819','2013-07-25','09:10:00',1.99),('5819','2013-07-25','09:15:00',2.38),('5819','2013-07-25','09:20:00',2.49),('5819','2013-07-25','09:25:00',2.14),('5819','2013-07-25','09:30:00',1.61),('5819','2013-07-25','09:35:00',1.18),('5819','2013-07-25','09:40:00',1.5),('5819','2013-07-25','09:45:00',1.25),('5819','2013-07-25','09:50:00',1.69),('5819','2013-07-25','09:55:00',1.01),('5819','2013-07-25','10:00:00',1.03),('5819','2013-07-25','10:10:00',1.81),('5819','2013-07-25','10:15:00',3.24),('5819','2013-07-25','10:20:00',3.27),('5819','2013-07-25','10:25:00',3.33),('5819','2013-07-25','10:30:00',3.33),('5819','2013-07-25','10:35:00',3.13),('5819','2013-07-25','10:40:00',2.97),('5819','2013-07-25','10:45:00',2.99),('5819','2013-07-25','10:50:00',3.25),('5819','2013-07-25','10:55:00',3.47),('5819','2013-07-25','11:00:00',3.46),('5819','2013-07-25','11:05:00',2.55),('5819','2013-07-25','11:10:00',2.63),('5819','2013-07-25','11:15:00',3.56),('5819','2013-07-25','11:20:00',3.3),('5819','2013-07-25','11:25:00',3.1),('5819','2013-07-25','11:30:00',3.22),('5819','2013-07-25','11:35:00',3.55),('5819','2013-07-25','11:40:00',3.6),('5819','2013-07-25','11:45:00',3.81),('5819','2013-07-25','11:50:00',3.92),('5819','2013-07-25','11:55:00',2.87),('5819','2013-07-25','12:00:00',2.96),('5819','2013-07-25','12:05:00',3.77),('5819','2013-07-25','12:10:00',3.79),('5819','2013-07-25','12:15:00',3.25),('5819','2013-07-25','12:20:00',2.51),('5819','2013-07-25','12:25:00',3.37),('5819','2013-07-25','12:30:00',1.35),('5819','2013-07-25','12:35:00',2.05),('5819','2013-07-25','12:40:00',1.24),('5819','2013-07-25','12:45:00',1.06),('5819','2013-07-25','12:50:00',1.18),('5819','2013-07-25','12:55:00',1.87),('5819','2013-07-25','13:00:00',3.37),('5819','2013-07-25','13:05:00',2.31),('5819','2013-07-25','13:10:00',1.48),('5819','2013-07-25','13:15:00',1.56),('5819','2013-07-25','13:20:00',2.96),('5819','2013-07-25','13:25:00',3.96),('5819','2013-07-25','13:30:00',3.86),('5819','2013-07-25','13:35:00',3.62),('5819','2013-07-25','13:40:00',3.61),('5819','2013-07-25','13:45:00',3.65),('5819','2013-07-25','13:50:00',3.63),('5819','2013-07-25','13:55:00',3.61),('5819','2013-07-25','14:00:00',3.64),('5819','2013-07-25','14:05:00',3.63),('5819','2013-07-25','14:10:00',3.63),('5819','2013-07-25','14:15:00',3.59),('5819','2013-07-25','14:20:00',3.61),('5819','2013-07-25','14:25:00',3.59),('5819','2013-07-25','14:30:00',3.54),('5819','2013-07-25','14:35:00',3.49),('5819','2013-07-25','14:40:00',3.45),('5819','2013-07-25','14:45:00',3.4),('5819','2013-07-25','14:50:00',3.34),('5819','2013-07-25','14:55:00',3.32),('5819','2013-07-25','15:00:00',3.31),('5819','2013-07-25','15:05:00',3.29),('5819','2013-07-25','15:10:00',3.23),('5819','2013-07-25','15:15:00',3.17),('5819','2013-07-25','15:20:00',3.14),('5819','2013-07-25','15:25:00',3.1),('5819','2013-07-25','15:30:00',3.06),('5819','2013-07-25','15:35:00',3.01),('5819','2013-07-25','15:40:00',2.97),('5819','2013-07-25','15:45:00',2.93),('5819','2013-07-25','15:50:00',2.88),('5819','2013-07-25','15:55:00',2.83),('5819','2013-07-25','16:00:00',2.75),('5819','2013-07-25','16:05:00',2.68),('5819','2013-07-25','16:10:00',2.63),('5819','2013-07-25','16:15:00',2.55),('5819','2013-07-25','16:20:00',2.5),('5819','2013-07-25','16:25:00',2.44),('5819','2013-07-25','16:30:00',2.38),('5819','2013-07-25','16:35:00',2.34),('5819','2013-07-25','16:40:00',2.27),('5819','2013-07-25','16:45:00',2.19),('5819','2013-07-25','16:50:00',2.12),('5819','2013-07-25','16:55:00',2.07),('5819','2013-07-25','17:00:00',1.96),('5819','2013-07-25','17:05:00',1.92),('5819','2013-07-25','17:10:00',1.82),('5819','2013-07-25','17:15:00',1.75),('5819','2013-07-25','17:20:00',1.67),('5819','2013-07-25','17:25:00',1.59),('5819','2013-07-25','17:30:00',1.52),('5819','2013-07-25','17:35:00',1.45),('5819','2013-07-25','17:40:00',1.36),('5819','2013-07-25','17:45:00',1.23),('5819','2013-07-25','17:50:00',1.11),('5819','2013-07-25','17:55:00',1.04),('5819','2013-07-25','18:00:00',1.01),('5819','2013-07-24','08:00:00',1.21),('5819','2013-07-24','08:05:00',1.08),('5819','2013-07-24','08:20:00',1.34),('5819','2013-07-24','08:25:00',1.1),('5819','2013-07-24','08:30:00',1.08),('5819','2013-07-24','08:35:00',1.05),('5819','2013-07-24','08:40:00',1.13),('5819','2013-07-24','08:45:00',1.22),('5819','2013-07-24','08:50:00',1.98),('5819','2013-07-24','08:55:00',1.53),('5819','2013-07-24','09:00:00',1.19),('5819','2013-07-24','09:05:00',1.96),('5819','2013-07-24','09:10:00',2.39),('5819','2013-07-24','09:15:00',2.04),('5819','2013-07-24','09:20:00',1.85),('5819','2013-07-24','09:25:00',1.18),('5819','2013-07-24','09:30:00',1.5),('5819','2013-07-24','09:35:00',1.9),('5819','2013-07-24','09:40:00',1.87),('5819','2013-07-24','09:45:00',1.96),('5819','2013-07-24','09:50:00',1.89),('5819','2013-07-24','09:55:00',1.3),('5819','2013-07-24','10:00:00',1.08),('5819','2013-07-24','10:05:00',1.03),('5819','2013-07-24','10:10:00',1.03),('5819','2013-07-24','10:15:00',1.13),('5819','2013-07-24','10:20:00',1.44),('5819','2013-07-24','10:25:00',2.45),('5819','2013-07-24','10:30:00',3.29),('5819','2013-07-24','10:35:00',3.33),('5819','2013-07-24','10:40:00',3.5),('5819','2013-07-24','10:45:00',3.56),('5819','2013-07-24','10:50:00',2.52),('5819','2013-07-24','10:55:00',2.37),('5819','2013-07-24','11:00:00',1.57),('5819','2013-07-24','11:05:00',1.7),('5819','2013-07-24','11:10:00',3.73),('5819','2013-07-24','11:15:00',3.71),('5819','2013-07-24','11:20:00',3.72),('5819','2013-07-24','11:25:00',3.72),('5819','2013-07-24','11:30:00',3.72),('5819','2013-07-24','11:35:00',3.83),('5819','2013-07-24','11:40:00',3.67),('5819','2013-07-24','11:45:00',3.63),('5819','2013-07-24','11:50:00',3.66),('5819','2013-07-24','11:55:00',3.69),('5819','2013-07-24','12:00:00',3.83),('5819','2013-07-24','12:05:00',3.99),('5819','2013-07-24','12:10:00',3.29),('5819','2013-07-24','12:15:00',1.47),('5819','2013-07-24','12:20:00',2.55),('5819','2013-07-24','12:25:00',4.08),('5819','2013-07-24','12:30:00',2.39),('5819','2013-07-24','12:35:00',1.08),('5819','2013-07-24','12:40:00',2.02),('5819','2013-07-24','12:45:00',3.98),('5819','2013-07-24','12:50:00',2.02),('5819','2013-07-24','12:55:00',1.33),('5819','2013-07-24','13:00:00',3.94),('5819','2013-07-24','13:05:00',3.69),('5819','2013-07-24','13:10:00',1.18),('5819','2013-07-24','13:15:00',2.45),('5819','2013-07-24','13:20:00',1.18),('5819','2013-07-24','13:25:00',3.47),('5819','2013-07-24','13:30:00',1.71),('5819','2013-07-24','13:35:00',4.03),('5819','2013-07-24','13:40:00',3.26),('5819','2013-07-24','13:45:00',3.57),('5819','2013-07-24','13:50:00',2.87),('5819','2013-07-24','13:55:00',3.86),('5819','2013-07-24','14:00:00',3.88),('5819','2013-07-24','14:05:00',3.82),('5819','2013-07-24','14:10:00',3.75),('5819','2013-07-24','14:15:00',3.76),('5819','2013-07-24','14:20:00',3.6),('5819','2013-07-24','14:25:00',3.49),('5819','2013-07-24','14:30:00',3.68),('5819','2013-07-24','14:35:00',2.73),('5819','2013-07-24','14:40:00',3.69),('5819','2013-07-24','14:45:00',3.56),('5819','2013-07-24','14:50:00',3.61),('5819','2013-07-24','14:55:00',3.55),('5819','2013-07-24','15:00:00',3.4),('5819','2013-07-24','15:05:00',3.4),('5819','2013-07-24','15:10:00',3.31),('5819','2013-07-24','15:15:00',3.3),('5819','2013-07-24','15:20:00',3.25),('5819','2013-07-24','15:25:00',3.19),('5819','2013-07-24','15:30:00',3.03),('5819','2013-07-24','15:35:00',2.95),('5819','2013-07-24','15:40:00',2.99),('5819','2013-07-24','15:45:00',2.92),('5819','2013-07-24','15:50:00',2.84),('5819','2013-07-24','15:55:00',2.9),('5819','2013-07-24','16:00:00',2.83),('5819','2013-07-24','16:05:00',2.73),('5819','2013-07-24','16:10:00',2.63),('5819','2013-07-24','16:15:00',2.31),('5819','2013-07-24','16:20:00',2.7),('5819','2013-07-24','16:25:00',2.53),('5819','2013-07-24','16:30:00',2.57),('5819','2013-07-24','16:35:00',2.36),('5819','2013-07-24','16:40:00',2.39),('5819','2013-07-24','16:45:00',2.18),('5819','2013-07-24','16:50:00',2.16),('5819','2013-07-24','16:55:00',2.25),('5819','2013-07-24','17:00:00',2.18),('5819','2013-07-24','17:05:00',1.83),('5819','2013-07-24','17:10:00',1.22),('5819','2013-07-24','17:15:00',1.83),('5819','2013-07-24','17:20:00',1.77),('5819','2013-07-24','17:25:00',1.69),('5819','2013-07-24','17:30:00',1.58),('5819','2013-07-24','17:35:00',1.49),('5819','2013-07-24','17:40:00',1.4),('5819','2013-07-24','17:45:00',1.28),('5819','2013-07-24','17:50:00',1.11),('5819','2013-07-24','18:00:00',1.02),('5819','2013-07-23','07:35:00',1.05),('5819','2013-07-23','07:40:00',1.12),('5819','2013-07-23','07:45:00',1.15),('5819','2013-07-23','07:50:00',1.19),('5819','2013-07-23','07:55:00',1.3),('5819','2013-07-23','08:00:00',1.46),('5819','2013-07-23','08:05:00',1.57),('5819','2013-07-23','08:10:00',1.63),('5819','2013-07-23','08:15:00',1.71),('5819','2013-07-23','08:20:00',1.79),('5819','2013-07-23','08:25:00',1.86),('5819','2013-07-23','08:30:00',1.92),('5819','2013-07-23','08:35:00',1.98),('5819','2013-07-23','08:40:00',2.07),('5819','2013-07-23','08:45:00',2.15),('5819','2013-07-23','08:50:00',2.22),('5819','2013-07-23','08:55:00',2.29),('5819','2013-07-23','09:00:00',2.36),('5819','2013-07-23','09:05:00',2.45),('5819','2013-07-23','09:10:00',2.48),('5819','2013-07-23','09:15:00',2.55),('5819','2013-07-23','09:20:00',2.59),('5819','2013-07-23','09:25:00',2.63),('5819','2013-07-23','09:30:00',2.67),('5819','2013-07-23','09:35:00',2.72),('5819','2013-07-23','09:40:00',2.77),('5819','2013-07-23','09:45:00',2.79),('5819','2013-07-23','09:50:00',2.85),('5819','2013-07-23','09:55:00',2.87),('5819','2013-07-23','10:00:00',2.89),('5819','2013-07-23','10:05:00',2.97),('5819','2013-07-23','10:10:00',3.02),('5819','2013-07-23','10:15:00',3.06),('5819','2013-07-23','10:20:00',3.1),('5819','2013-07-23','10:25:00',3.15),('5819','2013-07-23','10:30:00',3.22),('5819','2013-07-23','10:35:00',3.31),('5819','2013-07-23','10:40:00',3.39),('5819','2013-07-23','10:45:00',3.4),('5819','2013-07-23','10:50:00',3.4),('5819','2013-07-23','10:55:00',3.4),('5819','2013-07-23','11:00:00',3.45),('5819','2013-07-23','11:05:00',3.49),('5819','2013-07-23','11:10:00',3.5),('5819','2013-07-23','11:15:00',3.56),('5819','2013-07-23','11:20:00',3.57),('5819','2013-07-23','11:25:00',3.59),('5819','2013-07-23','11:30:00',3.63),('5819','2013-07-23','11:35:00',3.69),('5819','2013-07-23','11:40:00',3.67),('5819','2013-07-23','11:45:00',3.65),('5819','2013-07-23','11:50:00',3.62),('5819','2013-07-23','11:55:00',3.61),('5819','2013-07-23','12:00:00',3.73),('5819','2013-07-23','12:05:00',3.72),('5819','2013-07-23','12:10:00',3.74),('5819','2013-07-23','12:15:00',3.75),('5819','2013-07-23','12:20:00',3.73),('5819','2013-07-23','12:25:00',3.77),('5819','2013-07-23','12:30:00',3.75),('5819','2013-07-23','12:35:00',3.67),('5819','2013-07-23','12:40:00',3.74),('5819','2013-07-23','12:45:00',2.72),('5819','2013-07-23','12:50:00',2.7),('5819','2013-07-23','12:55:00',2.36),('5819','2013-07-23','13:00:00',1.32),('5819','2013-07-23','13:10:00',2.67),('5819','2013-07-23','13:15:00',2.9),('5819','2013-07-23','13:20:00',1.1),('5819','2013-07-23','13:25:00',1.39),('5819','2013-07-23','13:30:00',2.56),('5819','2013-07-23','13:35:00',3.96),('5819','2013-07-23','13:40:00',3.9),('5819','2013-07-23','13:45:00',3.73),('5819','2013-07-23','13:50:00',2.51),('5819','2013-07-23','13:55:00',2.57),('5819','2013-07-23','14:00:00',3.81),('5819','2013-07-23','14:05:00',2.06),('5819','2013-07-23','14:35:00',1.42),('5819','2013-07-23','14:40:00',3.5),('5819','2013-07-23','14:45:00',2.6),('5819','2013-07-23','14:50:00',3.62),('5819','2013-07-23','14:55:00',3.73),('5819','2013-07-23','15:00:00',2.46),('5819','2013-07-23','15:05:00',3.88),('5819','2013-07-23','15:10:00',3.63),('5819','2013-07-23','15:15:00',3.35),('5819','2013-07-23','15:20:00',3.35),('5819','2013-07-23','15:25:00',3.18),('5819','2013-07-23','15:30:00',3.09),('5819','2013-07-23','15:35:00',2.1),('5819','2013-07-23','15:40:00',2.97),('5819','2013-07-23','15:45:00',2.86),('5819','2013-07-23','15:50:00',2.83),('5819','2013-07-23','15:55:00',2.8),('5819','2013-07-23','16:00:00',2.73),('5819','2013-07-23','16:05:00',2.67),('5819','2013-07-23','16:10:00',2.61),('5819','2013-07-23','16:15:00',2.52),('5819','2013-07-23','16:20:00',2.51),('5819','2013-07-23','16:25:00',2.44),('5819','2013-07-23','16:30:00',2.38),('5819','2013-07-23','16:35:00',2.3),('5819','2013-07-23','16:40:00',2.23),('5819','2013-07-23','16:45:00',2.15),('5819','2013-07-23','16:50:00',2.08),('5819','2013-07-23','16:55:00',2.03),('5819','2013-07-23','17:00:00',1.95),('5819','2013-07-23','17:05:00',1.88),('5819','2013-07-23','17:10:00',1.84),('5819','2013-07-23','17:15:00',1.79),('5819','2013-07-23','17:20:00',1.72),('5819','2013-07-23','17:25:00',1.66),('5819','2013-07-23','17:30:00',1.59),('5819','2013-07-23','17:35:00',1.52),('5819','2013-07-23','17:40:00',1.45),('5819','2013-07-23','17:45:00',1.34),('5819','2013-07-23','17:50:00',1.17),('5819','2013-07-23','17:55:00',1.15),('5819','2013-07-23','18:00:00',1.1),('5819','2013-07-23','18:05:00',1.02),('5819','2013-07-22','07:40:00',1.08),('5819','2013-07-22','07:45:00',1.16),('5819','2013-07-22','07:50:00',1.23),('5819','2013-07-22','07:55:00',1.31),('5819','2013-07-22','08:00:00',1.39),('5819','2013-07-22','08:05:00',1.48),('5819','2013-07-22','08:10:00',1.56),('5819','2013-07-22','08:15:00',1.64),('5819','2013-07-22','08:20:00',1.72),('5819','2013-07-22','08:25:00',1.8),('5819','2013-07-22','08:30:00',1.88),('5819','2013-07-22','08:35:00',1.96),('5819','2013-07-22','08:40:00',2.05),('5819','2013-07-22','08:45:00',2.12),('5819','2013-07-22','08:50:00',2.18),('5819','2013-07-22','08:55:00',2.25),('5819','2013-07-22','09:00:00',2.33),('5819','2013-07-22','09:05:00',2.4),('5819','2013-07-22','09:10:00',2.45),('5819','2013-07-22','09:15:00',2.51),('5819','2013-07-22','09:20:00',2.57),('5819','2013-07-22','09:25:00',2.62),('5819','2013-07-22','09:30:00',2.67),('5819','2013-07-22','09:35:00',2.72),('5819','2013-07-22','09:40:00',2.78),('5819','2013-07-22','09:45:00',2.85),('5819','2013-07-22','09:50:00',2.88),('5819','2013-07-22','09:55:00',2.94),('5819','2013-07-22','10:00:00',3),('5819','2013-07-22','10:05:00',3.05),('5819','2013-07-22','10:10:00',3.09),('5819','2013-07-22','10:15:00',3.14),('5819','2013-07-22','10:20:00',3.18),('5819','2013-07-22','10:25:00',3.23),('5819','2013-07-22','10:30:00',3.26),('5819','2013-07-22','10:35:00',3.28),('5819','2013-07-22','10:40:00',3.32),('5819','2013-07-22','10:45:00',3.35),('5819','2013-07-22','10:50:00',3.38),('5819','2013-07-22','10:55:00',3.41),('5819','2013-07-22','11:00:00',3.41),('5819','2013-07-22','11:05:00',3.45),('5819','2013-07-22','11:10:00',3.47),('5819','2013-07-22','11:15:00',3.48),('5819','2013-07-22','11:20:00',3.49),('5819','2013-07-22','11:25:00',3.5),('5819','2013-07-22','11:30:00',3.52),('5819','2013-07-22','11:35:00',3.53),('5819','2013-07-22','11:40:00',3.55),('5819','2013-07-22','11:45:00',3.58),('5819','2013-07-22','11:50:00',3.57),('5819','2013-07-22','11:55:00',3.57),('5819','2013-07-22','12:00:00',3.6),('5819','2013-07-22','12:05:00',3.62),('5819','2013-07-22','12:10:00',3.63),('5819','2013-07-22','12:15:00',3.64),('5819','2013-07-22','12:20:00',3.65),('5819','2013-07-22','12:25:00',3.69),('5819','2013-07-22','12:30:00',3.71),('5819','2013-07-22','12:35:00',3.68),('5819','2013-07-22','12:40:00',3.69),('5819','2013-07-22','12:45:00',3.68),('5819','2013-07-22','12:50:00',3.68),('5819','2013-07-22','12:55:00',3.67),('5819','2013-07-22','13:00:00',3.71),('5819','2013-07-22','13:05:00',3.72),('5819','2013-07-22','13:10:00',3.67),('5819','2013-07-22','13:15:00',3.67),('5819','2013-07-22','13:20:00',3.65),('5819','2013-07-22','13:25:00',3.6),('5819','2013-07-22','13:30:00',3.58),('5819','2013-07-22','13:35:00',3.62),('5819','2013-07-22','13:40:00',3.66),('5819','2013-07-22','13:45:00',3.62),('5819','2013-07-22','13:50:00',3.58),('5819','2013-07-22','13:55:00',3.53),('5819','2013-07-22','14:00:00',3.54),('5819','2013-07-22','14:05:00',3.45),('5819','2013-07-22','14:10:00',3.48),('5819','2013-07-22','14:15:00',3.51),('5819','2013-07-22','14:20:00',3.49),('5819','2013-07-22','14:25:00',3.44),('5819','2013-07-22','14:30:00',3.39),('5819','2013-07-22','14:35:00',3.37),('5819','2013-07-22','14:40:00',3.36),('5819','2013-07-22','14:45:00',3.33),('5819','2013-07-22','14:50:00',3.29),('5819','2013-07-22','14:55:00',3.19),('5819','2013-07-22','15:00:00',3.1),('5819','2013-07-22','15:05:00',2.93),('5819','2013-07-22','15:10:00',3.15),('5819','2013-07-22','15:15:00',3.13),('5819','2013-07-22','15:20:00',3.07),('5819','2013-07-22','15:25:00',3.03),('5819','2013-07-22','15:30:00',1.03),('5819','2013-07-22','15:35:00',1.41),('5819','2013-07-22','15:40:00',2.92),('5819','2013-07-22','15:45:00',3.08),('5819','2013-07-22','15:50:00',3),('5819','2013-07-22','15:55:00',3.16),('5819','2013-07-22','16:00:00',2.85),('5819','2013-07-22','16:05:00',1.66),('5819','2013-07-22','16:10:00',1.26),('5819','2013-07-22','16:15:00',2.39),('5819','2013-07-22','16:20:00',2.84),('5819','2013-07-22','16:25:00',2.74),('5819','2013-07-22','16:30:00',2.55),('5819','2013-07-22','16:35:00',2.43),('5819','2013-07-22','16:40:00',2.27),('5819','2013-07-22','16:45:00',2.18),('5819','2013-07-22','16:50:00',2.11),('5819','2013-07-22','16:55:00',2.01),('5819','2013-07-22','17:00:00',1.97),('5819','2013-07-22','17:05:00',1.93),('5819','2013-07-22','17:10:00',1.87),('5819','2013-07-22','17:15:00',1.77),('5819','2013-07-22','17:20:00',1.71),('5819','2013-07-22','17:25:00',1.61),('5819','2013-07-22','17:30:00',1.58),('5819','2013-07-22','17:35:00',1.53),('5819','2013-07-22','17:40:00',1.41),('5819','2013-07-22','17:45:00',1.26),('5819','2013-07-22','17:50:00',1.13),('5819','2013-07-22','17:55:00',1.1),('5819','2013-07-22','18:00:00',1.09),('5819','2013-07-21','07:40:00',1.02),('5819','2013-07-21','07:45:00',1.13),('5819','2013-07-21','07:50:00',1.16),('5819','2013-07-21','07:55:00',1.2),('5819','2013-07-21','08:00:00',1.28),('5819','2013-07-21','08:05:00',1.34),('5819','2013-07-21','08:10:00',1.46),('5819','2013-07-21','08:15:00',1.54),('5819','2013-07-21','08:20:00',1.6),('5819','2013-07-21','08:25:00',1.7),('5819','2013-07-21','08:30:00',1.78),('5819','2013-07-21','08:35:00',1.85),('5819','2013-07-21','08:40:00',1.91),('5819','2013-07-21','08:45:00',1.97),('5819','2013-07-21','08:50:00',2.04),('5819','2013-07-21','08:55:00',2.13),('5819','2013-07-21','09:00:00',2.22),('5819','2013-07-21','09:05:00',2.28),('5819','2013-07-21','09:10:00',2.33),('5819','2013-07-21','09:15:00',2.4),('5819','2013-07-21','09:20:00',2.47),('5819','2013-07-21','09:25:00',2.53),('5819','2013-07-21','09:30:00',2.58),('5819','2013-07-21','09:35:00',2.64),('5819','2013-07-21','09:40:00',2.7),('5819','2013-07-21','09:45:00',2.74),('5819','2013-07-21','09:50:00',2.78),('5819','2013-07-21','09:55:00',2.84),('5819','2013-07-21','10:00:00',2.9),('5819','2013-07-21','10:05:00',2.94),('5819','2013-07-21','10:10:00',2.97),('5819','2013-07-21','10:15:00',3.03),('5819','2013-07-21','10:20:00',3.07),('5819','2013-07-21','10:25:00',3.12),('5819','2013-07-21','10:30:00',3.11),('5819','2013-07-21','10:35:00',3.16),('5819','2013-07-21','10:40:00',3.22),('5819','2013-07-21','10:45:00',3.26),('5819','2013-07-21','10:50:00',3.3),('5819','2013-07-21','10:55:00',3.3),('5819','2013-07-21','11:00:00',3.33),('5819','2013-07-21','11:05:00',3.33),('5819','2013-07-21','11:10:00',3.37),('5819','2013-07-21','11:15:00',3.45),('5819','2013-07-21','11:20:00',3.46),('5819','2013-07-21','11:25:00',3.51),('5819','2013-07-21','11:30:00',3.51),('5819','2013-07-21','11:35:00',3.54),('5819','2013-07-21','11:40:00',3.66),('5819','2013-07-21','11:45:00',3.13),('5819','2013-07-21','11:50:00',3.69),('5819','2013-07-21','11:55:00',3.64),('5819','2013-07-21','12:00:00',3.63),('5819','2013-07-21','12:05:00',3.49),('5819','2013-07-21','12:10:00',3.7),('5819','2013-07-21','12:15:00',3.82),('5819','2013-07-21','12:20:00',3.9),('5819','2013-07-21','12:25:00',3.98),('5819','2013-07-21','12:30:00',3.98),('5819','2013-07-21','12:35:00',3.83),('5819','2013-07-21','12:40:00',3.9),('5819','2013-07-21','12:45:00',3.26),('5819','2013-07-21','12:50:00',4.16),('5819','2013-07-21','12:55:00',4.32),('5819','2013-07-21','13:00:00',4.17),('5819','2013-07-21','13:05:00',4.25),('5819','2013-07-21','13:10:00',4),('5819','2013-07-21','13:15:00',3.6),('5819','2013-07-21','13:20:00',3.98),('5819','2013-07-21','13:25:00',4.04),('5819','2013-07-21','13:30:00',3.8),('5819','2013-07-21','13:35:00',1.94),('5819','2013-07-21','13:40:00',1.13),('5819','2013-07-21','14:25:00',1.07),('5819','2013-07-21','14:30:00',1.06),('5819','2013-07-21','14:35:00',1.15),('5819','2013-07-21','14:40:00',1.08),('5819','2013-07-21','14:45:00',1.9),('5819','2013-07-21','14:50:00',2.1),('5819','2013-07-21','14:55:00',1.68),('5819','2013-07-21','15:00:00',1.54),('5819','2013-07-21','15:05:00',1.37),('5819','2013-07-21','15:10:00',1.33),('5819','2013-07-21','15:15:00',2.97),('5819','2013-07-21','15:20:00',2.79),('5819','2013-07-21','15:25:00',1.42),('5819','2013-07-21','15:30:00',1.26),('5819','2013-07-21','15:35:00',1.54),('5819','2013-07-21','15:40:00',3.6),('5819','2013-07-21','15:45:00',1.86),('5819','2013-07-21','15:50:00',2.06),('5819','2013-07-21','15:55:00',1.94),('5819','2013-07-21','16:00:00',1.2),('5819','2013-07-21','17:00:00',1.03),('5819','2013-07-21','17:05:00',1.1),('5819','2013-07-21','17:10:00',1.06),('5819','2013-07-20','07:35:00',1.04),('5819','2013-07-20','07:40:00',1.1),('5819','2013-07-20','07:45:00',1.17),('5819','2013-07-20','07:50:00',1.2),('5819','2013-07-20','07:55:00',1.31),('5819','2013-07-20','08:00:00',1.39),('5819','2013-07-20','08:05:00',1.49),('5819','2013-07-20','08:10:00',1.56),('5819','2013-07-20','08:15:00',1.62),('5819','2013-07-20','08:20:00',1.71),('5819','2013-07-20','08:25:00',1.79),('5819','2013-07-20','08:30:00',1.86),('5819','2013-07-20','08:35:00',1.95),('5819','2013-07-20','08:40:00',2.01),('5819','2013-07-20','08:45:00',2.1),('5819','2013-07-20','08:50:00',2.19),('5819','2013-07-20','08:55:00',2.27),('5819','2013-07-20','09:00:00',2.36),('5819','2013-07-20','09:05:00',2.42),('5819','2013-07-20','09:10:00',2.53),('5819','2013-07-20','09:15:00',2.61),('5819','2013-07-20','09:20:00',2.66),('5819','2013-07-20','09:25:00',2.61),('5819','2013-07-20','09:30:00',2.62),('5819','2013-07-20','09:35:00',2.69),('5819','2013-07-20','09:40:00',2.67),('5819','2013-07-20','09:45:00',2.79),('5819','2013-07-20','09:50:00',2.74),('5819','2013-07-20','09:55:00',2.79),('5819','2013-07-20','10:00:00',2.95),('5819','2013-07-20','10:05:00',2.99),('5819','2013-07-20','10:10:00',3.05),('5819','2013-07-20','10:15:00',3.09),('5819','2013-07-20','10:20:00',3.12),('5819','2013-07-20','10:25:00',3.18),('5819','2013-07-20','10:30:00',3.2),('5819','2013-07-20','10:35:00',3.25),('5819','2013-07-20','10:40:00',3.28),('5819','2013-07-20','10:45:00',3.31),('5819','2013-07-20','10:50:00',3.37),('5819','2013-07-20','10:55:00',3.37),('5819','2013-07-20','11:00:00',3.41),('5819','2013-07-20','11:05:00',3.42),('5819','2013-07-20','11:10:00',3.4),('5819','2013-07-20','11:15:00',3.48),('5819','2013-07-20','11:20:00',3.5),('5819','2013-07-20','11:25:00',3.52),('5819','2013-07-20','11:30:00',3.53),('5819','2013-07-20','11:35:00',3.52),('5819','2013-07-20','11:40:00',3.58),('5819','2013-07-20','11:45:00',3.58),('5819','2013-07-20','11:50:00',3.64),('5819','2013-07-20','11:55:00',3.69),('5819','2013-07-20','12:00:00',3.72),('5819','2013-07-20','12:05:00',3.73),('5819','2013-07-20','12:10:00',3.77),('5819','2013-07-20','12:15:00',3.71),('5819','2013-07-20','12:20:00',3.46),('5819','2013-07-20','12:25:00',3.65),('5819','2013-07-20','12:30:00',3.7),('5819','2013-07-20','12:35:00',3.62),('5819','2013-07-20','12:40:00',3.67),('5819','2013-07-20','12:45:00',3.82),('5819','2013-07-20','12:50:00',3.77),('5819','2013-07-20','12:55:00',3.66),('5819','2013-07-20','13:00:00',3.85),('5819','2013-07-20','13:05:00',3.81),('5819','2013-07-20','13:10:00',3.71),('5819','2013-07-20','13:15:00',3.44),('5819','2013-07-20','13:20:00',3.34),('5819','2013-07-20','13:25:00',3.66),('5819','2013-07-20','13:30:00',3.82),('5819','2013-07-20','13:35:00',3.83),('5819','2013-07-20','13:40:00',3.86),('5819','2013-07-20','13:45:00',3.81),('5819','2013-07-20','13:50:00',2.74),('5819','2013-07-20','14:00:00',3.15),('5819','2013-07-20','14:05:00',3.9),('5819','2013-07-20','14:10:00',3.55),('5819','2013-07-20','14:15:00',2.99),('5819','2013-07-20','14:20:00',2.08),('5819','2013-07-20','14:25:00',3.77),('5819','2013-07-20','14:30:00',3.64),('5819','2013-07-20','14:35:00',2.57),('5819','2013-07-20','14:40:00',3.23),('5819','2013-07-20','14:45:00',1.28),('5819','2013-07-20','14:50:00',2.79),('5819','2013-07-20','14:55:00',1.08),('5819','2013-07-20','15:00:00',1.53),('5819','2013-07-20','15:05:00',3.52),('5819','2013-07-20','15:10:00',3.41),('5819','2013-07-20','15:15:00',3.29),('5819','2013-07-20','15:20:00',3.19),('5819','2013-07-20','15:25:00',3.13),('5819','2013-07-20','15:30:00',3.07),('5819','2013-07-20','15:35:00',3),('5819','2013-07-20','15:40:00',2.97),('5819','2013-07-20','15:45:00',2.89),('5819','2013-07-20','15:50:00',2.81),('5819','2013-07-20','15:55:00',2.77),('5819','2013-07-20','16:00:00',2.73),('5819','2013-07-20','16:05:00',2.67),('5819','2013-07-20','16:10:00',2.61),('5819','2013-07-20','16:15:00',2.57),('5819','2013-07-20','16:20:00',2.53),('5819','2013-07-20','16:25:00',2.46),('5819','2013-07-20','16:30:00',2.4),('5819','2013-07-20','16:35:00',2.33),('5819','2013-07-20','16:40:00',2.26),('5819','2013-07-20','16:45:00',2.17),('5819','2013-07-20','16:50:00',2.1),('5819','2013-07-20','16:55:00',2.03),('5819','2013-07-20','17:00:00',1.95),('5819','2013-07-20','17:05:00',1.89),('5819','2013-07-20','17:10:00',1.82),('5819','2013-07-20','17:15:00',1.75),('5819','2013-07-20','17:20:00',1.68),('5819','2013-07-20','17:25:00',1.6),('5819','2013-07-20','17:30:00',1.53),('5819','2013-07-20','17:35:00',1.48),('5819','2013-07-20','17:40:00',1.4),('5819','2013-07-20','17:45:00',1.31),('5819','2013-07-20','17:50:00',1.14),('5819','2013-07-20','17:55:00',1.12),('5819','2013-07-20','18:00:00',1.06),('5819','2013-07-19','07:40:00',1.04),('5819','2013-07-19','07:45:00',1.1),('5819','2013-07-19','07:50:00',1.18),('5819','2013-07-19','07:55:00',1.25),('5819','2013-07-19','08:00:00',1.32),('5819','2013-07-19','08:05:00',1.41),('5819','2013-07-19','08:10:00',1.5),('5819','2013-07-19','08:15:00',1.57),('5819','2013-07-19','08:20:00',1.65),('5819','2013-07-19','08:25:00',1.7),('5819','2013-07-19','08:30:00',1.76),('5819','2013-07-19','08:35:00',1.86),('5819','2013-07-19','08:40:00',1.94),('5819','2013-07-19','08:45:00',2.03),('5819','2013-07-19','08:50:00',2.1),('5819','2013-07-19','08:55:00',2.17),('5819','2013-07-19','09:00:00',2.22),('5819','2013-07-19','09:05:00',2.28),('5819','2013-07-19','09:10:00',2.34),('5819','2013-07-19','09:15:00',2.4),('5819','2013-07-19','09:20:00',2.46),('5819','2013-07-19','09:25:00',2.51),('5819','2013-07-19','09:30:00',2.57),('5819','2013-07-19','09:35:00',2.64),('5819','2013-07-19','09:40:00',2.69),('5819','2013-07-19','09:45:00',2.72),('5819','2013-07-19','09:50:00',2.76),('5819','2013-07-19','09:55:00',2.8),('5819','2013-07-19','10:00:00',2.85),('5819','2013-07-19','10:05:00',2.87),('5819','2013-07-19','10:10:00',2.91),('5819','2013-07-19','10:15:00',2.94),('5819','2013-07-19','10:20:00',2.98),('5819','2013-07-19','10:25:00',3.1),('5819','2013-07-19','10:30:00',3.03),('5819','2013-07-19','10:35:00',3.17),('5819','2013-07-19','10:40:00',3.15),('5819','2013-07-19','10:45:00',3.17),('5819','2013-07-19','10:50:00',3.21),('5819','2013-07-19','10:55:00',3.23),('5819','2013-07-19','11:00:00',3.27),('5819','2013-07-19','11:05:00',3.26),('5819','2013-07-19','11:10:00',3.29),('5819','2013-07-19','11:15:00',3.33),('5819','2013-07-19','11:20:00',3.37),('5819','2013-07-19','11:25:00',3.4),('5819','2013-07-19','11:30:00',3.4),('5819','2013-07-19','11:35:00',3.37),('5819','2013-07-19','11:40:00',3.36),('5819','2013-07-19','11:45:00',3.52),('5819','2013-07-19','11:50:00',3.5),('5819','2013-07-19','11:55:00',3.43),('5819','2013-07-19','12:00:00',2.51),('5819','2013-07-19','12:05:00',3.22),('5819','2013-07-19','12:10:00',3.62),('5819','2013-07-19','12:15:00',3.7),('5819','2013-07-19','12:20:00',3.66),('5819','2013-07-19','12:25:00',3.68),('5819','2013-07-19','12:30:00',3.68),('5819','2013-07-19','12:35:00',3.62),('5819','2013-07-19','12:40:00',3.63),('5819','2013-07-19','12:45:00',3.58),('5819','2013-07-19','12:50:00',3.66),('5819','2013-07-19','12:55:00',2.69),('5819','2013-07-19','13:00:00',2.76),('5819','2013-07-19','13:05:00',3.78),('5819','2013-07-19','13:10:00',3.77),('5819','2013-07-19','13:15:00',2.02),('5819','2013-07-19','13:20:00',1.43),('5819','2013-07-19','13:25:00',2.8),('5819','2013-07-19','13:30:00',4.02),('5819','2013-07-19','13:35:00',3.86),('5819','2013-07-19','13:40:00',3.79),('5819','2013-07-19','13:45:00',3.8),('5819','2013-07-19','13:50:00',3.79),('5819','2013-07-19','13:55:00',3.8),('5819','2013-07-19','14:00:00',3.83),('5819','2013-07-19','14:05:00',3.77),('5819','2013-07-19','14:10:00',3.13),('5819','2013-07-19','14:15:00',3.45),('5819','2013-07-19','14:20:00',2.92),('5819','2013-07-19','14:25:00',3.04),('5819','2013-07-19','14:30:00',3.52),('5819','2013-07-19','14:35:00',3.71),('5819','2013-07-19','14:40:00',3.26),('5819','2013-07-19','14:45:00',3.51),('5819','2013-07-19','14:50:00',3.15),('5819','2013-07-19','14:55:00',3.33),('5819','2013-07-19','15:00:00',3.1),('5819','2013-07-19','15:05:00',3.4),('5819','2013-07-19','15:10:00',3.29),('5819','2013-07-19','15:15:00',2.8),('5819','2013-07-19','15:20:00',2.6),('5819','2013-07-19','15:25:00',2.52),('5819','2013-07-19','15:30:00',3.29),('5819','2013-07-19','15:35:00',3.17),('5819','2013-07-19','15:40:00',2.76),('5819','2013-07-19','15:45:00',3.04),('5819','2013-07-19','15:50:00',3.02),('5819','2013-07-19','15:55:00',2.8),('5819','2013-07-19','16:00:00',2.89),('5819','2013-07-19','16:05:00',2.83),('5819','2013-07-19','16:10:00',2.75),('5819','2013-07-19','16:15:00',2.72),('5819','2013-07-19','16:20:00',2.68),('5819','2013-07-19','16:25:00',2.63),('5819','2013-07-19','16:30:00',2.59),('5819','2013-07-19','16:35:00',2.54),('5819','2013-07-19','16:40:00',2.48),('5819','2013-07-19','16:45:00',2.44),('5819','2013-07-19','16:50:00',2.23),('5819','2013-07-19','16:55:00',2.35),('5819','2013-07-19','17:00:00',1.71),('5819','2013-07-19','17:05:00',2.31),('5819','2013-07-19','17:10:00',2.21),('5819','2013-07-19','17:15:00',1.85),('5819','2013-07-19','17:20:00',1.47),('5819','2013-07-19','17:25:00',1.62),('5819','2013-07-19','17:30:00',1.65),('5819','2013-07-19','17:35:00',1.47),('5819','2013-07-19','17:40:00',1.3),('5819','2013-07-19','17:45:00',1.11),('5819','2013-07-18','07:35:00',1.06),('5819','2013-07-18','07:40:00',1.14),('5819','2013-07-18','07:45:00',1.22),('5819','2013-07-18','07:50:00',1.31),('5819','2013-07-18','07:55:00',1.38),('5819','2013-07-18','08:00:00',1.47),('5819','2013-07-18','08:05:00',1.55),('5819','2013-07-18','08:10:00',1.62),('5819','2013-07-18','08:15:00',1.7),('5819','2013-07-18','08:20:00',1.78),('5819','2013-07-18','08:25:00',1.84),('5819','2013-07-18','08:30:00',1.91),('5819','2013-07-18','08:35:00',1.99),('5819','2013-07-18','08:40:00',2.05),('5819','2013-07-18','08:45:00',2.12),('5819','2013-07-18','08:50:00',2.19),('5819','2013-07-18','08:55:00',2.27),('5819','2013-07-18','09:00:00',2.33),('5819','2013-07-18','09:05:00',2.39),('5819','2013-07-18','09:10:00',2.44),('5819','2013-07-18','09:15:00',2.49),('5819','2013-07-18','09:20:00',2.56),('5819','2013-07-18','09:25:00',2.61),('5819','2013-07-18','09:30:00',2.68),('5819','2013-07-18','09:35:00',2.74),('5819','2013-07-18','09:40:00',2.79),('5819','2013-07-18','09:45:00',2.83),('5819','2013-07-18','09:50:00',2.89),('5819','2013-07-18','09:55:00',2.93),('5819','2013-07-18','10:00:00',2.97),('5819','2013-07-18','10:05:00',3),('5819','2013-07-18','10:10:00',3.07),('5819','2013-07-18','10:15:00',3.1),('5819','2013-07-18','10:20:00',3.12),('5819','2013-07-18','10:25:00',3.18),('5819','2013-07-18','10:30:00',3.25),('5819','2013-07-18','10:35:00',3.28),('5819','2013-07-18','10:40:00',3.32),('5819','2013-07-18','10:45:00',3.34),('5819','2013-07-18','10:50:00',3.37),('5819','2013-07-18','10:55:00',3.39),('5819','2013-07-18','11:00:00',3.4),('5819','2013-07-18','11:05:00',3.42),('5819','2013-07-18','11:10:00',3.47),('5819','2013-07-18','11:15:00',3.49),('5819','2013-07-18','11:20:00',3.52),('5819','2013-07-18','11:25:00',3.51),('5819','2013-07-18','11:30:00',3.53),('5819','2013-07-18','11:35:00',3.54),('5819','2013-07-18','11:40:00',3.54),('5819','2013-07-18','11:45:00',3.55),('5819','2013-07-18','11:50:00',3.56),('5819','2013-07-18','11:55:00',3.6),('5819','2013-07-18','12:00:00',3.64),('5819','2013-07-18','12:05:00',3.61),('5819','2013-07-18','12:10:00',3.61),('5819','2013-07-18','12:15:00',3.64),('5819','2013-07-18','12:20:00',3.67),('5819','2013-07-18','12:25:00',3.67),('5819','2013-07-18','12:30:00',3.61),('5819','2013-07-18','12:35:00',3.82),('5819','2013-07-18','12:40:00',3.92),('5819','2013-07-18','12:45:00',2.72),('5819','2013-07-18','12:50:00',1.48),('5819','2013-07-18','12:55:00',3.29),('5819','2013-07-18','13:00:00',3.9),('5819','2013-07-18','13:05:00',3.71),('5819','2013-07-18','13:10:00',3.66),('5819','2013-07-18','13:15:00',3.68),('5819','2013-07-18','13:20:00',3.82),('5819','2013-07-18','13:25:00',3.79),('5819','2013-07-18','13:30:00',3.85),('5819','2013-07-18','13:35:00',3.62),('5819','2013-07-18','13:40:00',3.03),('5819','2013-07-18','13:45:00',3.79),('5819','2013-07-18','13:50:00',3.74),('5819','2013-07-18','13:55:00',3.54),('5819','2013-07-18','14:00:00',3.64),('5819','2013-07-18','14:05:00',3.56),('5819','2013-07-18','14:10:00',3.55),('5819','2013-07-18','14:15:00',3.36),('5819','2013-07-18','14:20:00',3.56),('5819','2013-07-18','14:25:00',3.52),('5819','2013-07-18','14:30:00',3.47),('5819','2013-07-18','14:35:00',3.47),('5819','2013-07-18','14:40:00',3.43),('5819','2013-07-18','14:45:00',3.38),('5819','2013-07-18','14:50:00',3.34),('5819','2013-07-18','14:55:00',3.25),('5819','2013-07-18','15:00:00',3.2),('5819','2013-07-18','15:05:00',3.2),('5819','2013-07-18','15:10:00',3.2),('5819','2013-07-18','15:15:00',3.15),('5819','2013-07-18','15:20:00',3.11),('5819','2013-07-18','15:25:00',3.12),('5819','2013-07-18','15:30:00',3.04),('5819','2013-07-18','15:35:00',2.96),('5819','2013-07-18','15:40:00',2.94),('5819','2013-07-18','15:45:00',2.87),('5819','2013-07-18','15:50:00',2.83),('5819','2013-07-18','15:55:00',2.77),('5819','2013-07-18','16:00:00',2.71),('5819','2013-07-18','16:05:00',2.65),('5819','2013-07-18','16:10:00',2.6),('5819','2013-07-18','16:15:00',2.52),('5819','2013-07-18','16:20:00',2.47),('5819','2013-07-18','16:25:00',2.41),('5819','2013-07-18','16:30:00',2.34),('5819','2013-07-18','16:35:00',2.29),('5819','2013-07-18','16:40:00',2.22),('5819','2013-07-18','16:45:00',2.14),('5819','2013-07-18','16:50:00',2.07),('5819','2013-07-18','16:55:00',2),('5819','2013-07-18','17:00:00',1.9),('5819','2013-07-18','17:05:00',1.86),('5819','2013-07-18','17:10:00',1.74),('5819','2013-07-18','17:15:00',1.69),('5819','2013-07-18','17:20:00',1.5),('5819','2013-07-18','17:25:00',1.58),('5819','2013-07-18','17:30:00',1.48),('5819','2013-07-18','17:35:00',1.4),('5819','2013-07-18','17:40:00',1.33),('5819','2013-07-18','17:45:00',1.09),('5819','2013-07-18','17:50:00',1.03),('5819','2013-07-17','07:30:00',1),('5819','2013-07-17','07:35:00',1.06),('5819','2013-07-17','07:40:00',1.14),('5819','2013-07-17','07:45:00',1.24),('5819','2013-07-17','07:50:00',1.33),('5819','2013-07-17','07:55:00',1.41),('5819','2013-07-17','08:00:00',1.49),('5819','2013-07-17','08:05:00',1.59),('5819','2013-07-17','08:10:00',1.68),('5819','2013-07-17','08:15:00',1.77),('5819','2013-07-17','08:20:00',1.86),('5819','2013-07-17','08:25:00',1.93),('5819','2013-07-17','08:30:00',2),('5819','2013-07-17','08:35:00',2.09),('5819','2013-07-17','08:40:00',2.17),('5819','2013-07-17','08:45:00',2.24),('5819','2013-07-17','08:50:00',2.31),('5819','2013-07-17','08:55:00',2.37),('5819','2013-07-17','09:00:00',2.45),('5819','2013-07-17','09:05:00',2.53),('5819','2013-07-17','09:10:00',2.6),('5819','2013-07-17','09:15:00',2.68),('5819','2013-07-17','09:20:00',2.74),('5819','2013-07-17','09:25:00',2.79),('5819','2013-07-17','09:30:00',2.83),('5819','2013-07-17','09:35:00',2.87),('5819','2013-07-17','09:40:00',2.92),('5819','2013-07-17','09:45:00',2.99),('5819','2013-07-17','09:50:00',3.04),('5819','2013-07-17','09:55:00',3.07),('5819','2013-07-17','10:00:00',3.14),('5819','2013-07-17','10:05:00',3.19),('5819','2013-07-17','10:10:00',3.21),('5819','2013-07-17','10:15:00',3.24),('5819','2013-07-17','10:20:00',3.27),('5819','2013-07-17','10:25:00',3.32),('5819','2013-07-17','10:30:00',3.35),('5819','2013-07-17','10:35:00',3.39),('5819','2013-07-17','10:40:00',3.41),('5819','2013-07-17','10:45:00',3.48),('5819','2013-07-17','10:50:00',3.52),('5819','2013-07-17','10:55:00',3.54),('5819','2013-07-17','11:00:00',3.59),('5819','2013-07-17','11:05:00',3.62),('5819','2013-07-17','11:10:00',3.62),('5819','2013-07-17','11:15:00',3.62),('5819','2013-07-17','11:20:00',3.65),('5819','2013-07-17','11:25:00',3.68),('5819','2013-07-17','11:30:00',3.69),('5819','2013-07-17','11:35:00',3.71),('5819','2013-07-17','11:40:00',3.72),('5819','2013-07-17','11:45:00',3.73),('5819','2013-07-17','11:50:00',3.78),('5819','2013-07-17','11:55:00',3.8),('5819','2013-07-17','12:00:00',3.79),('5819','2013-07-17','12:05:00',3.8),('5819','2013-07-17','12:10:00',3.8),('5819','2013-07-17','12:15:00',3.75),('5819','2013-07-17','12:20:00',3.77),('5819','2013-07-17','12:25:00',3.81),('5819','2013-07-17','12:30:00',3.77),('5819','2013-07-17','12:35:00',3.79),('5819','2013-07-17','12:40:00',3.78),('5819','2013-07-17','12:45:00',3.78),('5819','2013-07-17','12:50:00',3.78),('5819','2013-07-17','12:55:00',3.81),('5819','2013-07-17','13:00:00',3.82),('5819','2013-07-17','13:05:00',3.79),('5819','2013-07-17','13:10:00',3.75),('5819','2013-07-17','13:15:00',3.76),('5819','2013-07-17','13:20:00',3.7),('5819','2013-07-17','13:25:00',3.69),('5819','2013-07-17','13:30:00',3.69),('5819','2013-07-17','13:35:00',3.65),('5819','2013-07-17','13:40:00',3.67),('5819','2013-07-17','13:45:00',3.67),('5819','2013-07-17','13:50:00',3.64),('5819','2013-07-17','13:55:00',3.63),('5819','2013-07-17','14:00:00',3.61),('5819','2013-07-17','14:05:00',3.57),('5819','2013-07-17','14:10:00',3.54),('5819','2013-07-17','14:15:00',3.55),('5819','2013-07-17','14:20:00',3.54),('5819','2013-07-17','14:25:00',3.5),('5819','2013-07-17','14:30:00',3.46),('5819','2013-07-17','14:35:00',3.41),('5819','2013-07-17','14:40:00',3.6),('5819','2013-07-17','14:45:00',3.47),('5819','2013-07-17','14:50:00',3.34),('5819','2013-07-17','14:55:00',3.26),('5819','2013-07-17','15:00:00',3.33),('5819','2013-07-17','15:05:00',3.27),('5819','2013-07-17','15:10:00',3.26),('5819','2013-07-17','15:15:00',3.26),('5819','2013-07-17','15:20:00',3.19),('5819','2013-07-17','15:25:00',3.11),('5819','2013-07-17','15:30:00',3.02),('5819','2013-07-17','15:35:00',3),('5819','2013-07-17','15:40:00',2.46),('5819','2013-07-17','15:45:00',2.91),('5819','2013-07-17','15:50:00',2.88),('5819','2013-07-17','15:55:00',2.82),('5819','2013-07-17','16:00:00',2.78),('5819','2013-07-17','16:05:00',2.71),('5819','2013-07-17','16:10:00',2.68),('5819','2013-07-17','16:15:00',2.61),('5819','2013-07-17','16:20:00',2.51),('5819','2013-07-17','16:25:00',2.44),('5819','2013-07-17','16:30:00',2.41),('5819','2013-07-17','16:35:00',2.37),('5819','2013-07-17','16:40:00',2.26),('5819','2013-07-17','16:45:00',2.26),('5819','2013-07-17','16:50:00',2.18),('5819','2013-07-17','16:55:00',2.06),('5819','2013-07-17','17:00:00',1.72),('5819','2013-07-17','17:05:00',1.96),('5819','2013-07-17','17:10:00',1.95),('5819','2013-07-17','17:15:00',1.83),('5819','2013-07-17','17:20:00',1.73),('5819','2013-07-17','17:25:00',1.61),('5819','2013-07-17','17:30:00',1.56),('5819','2013-07-17','17:35:00',1.46),('5819','2013-07-17','17:40:00',1.37),('5819','2013-07-17','17:45:00',1.32),('5819','2013-07-17','17:50:00',1.15),('5819','2013-07-17','18:00:00',1),('5819','2013-07-16','07:30:00',1.03),('5819','2013-07-16','07:35:00',1.1),('5819','2013-07-16','07:40:00',1.17),('5819','2013-07-16','07:45:00',1.24),('5819','2013-07-16','07:50:00',1.31),('5819','2013-07-16','07:55:00',1.37),('5819','2013-07-16','08:00:00',1.43),('5819','2013-07-16','08:05:00',1.53),('5819','2013-07-16','08:10:00',1.6),('5819','2013-07-16','08:15:00',1.68),('5819','2013-07-16','08:20:00',1.76),('5819','2013-07-16','08:25:00',1.84),('5819','2013-07-16','08:30:00',1.92),('5819','2013-07-16','08:35:00',1.98),('5819','2013-07-16','08:40:00',2.03),('5819','2013-07-16','08:45:00',2.1),('5819','2013-07-16','08:50:00',2.19),('5819','2013-07-16','08:55:00',2.27),('5819','2013-07-16','09:00:00',2.31),('5819','2013-07-16','09:05:00',2.37),('5819','2013-07-16','09:10:00',2.44),('5819','2013-07-16','09:15:00',2.49),('5819','2013-07-16','09:20:00',2.56),('5819','2013-07-16','09:25:00',2.62),('5819','2013-07-16','09:30:00',2.67),('5819','2013-07-16','09:35:00',2.72),('5819','2013-07-16','09:40:00',2.77),('5819','2013-07-16','09:45:00',2.86),('5819','2013-07-16','09:50:00',2.92),('5819','2013-07-16','09:55:00',2.98),('5819','2013-07-16','10:00:00',3.04),('5819','2013-07-16','10:05:00',3.09),('5819','2013-07-16','10:10:00',3.15),('5819','2013-07-16','10:15:00',3.17),('5819','2013-07-16','10:20:00',3.19),('5819','2013-07-16','10:25:00',3.24),('5819','2013-07-16','10:30:00',3.28),('5819','2013-07-16','10:35:00',3.31),('5819','2013-07-16','10:40:00',3.35),('5819','2013-07-16','10:45:00',3.37),('5819','2013-07-16','10:50:00',3.41),('5819','2013-07-16','10:55:00',3.45),('5819','2013-07-16','11:00:00',3.47),('5819','2013-07-16','11:05:00',3.51),('5819','2013-07-16','11:10:00',3.54),('5819','2013-07-16','11:15:00',3.56),('5819','2013-07-16','11:20:00',3.58),('5819','2013-07-16','11:25:00',3.59),('5819','2013-07-16','11:30:00',3.58),('5819','2013-07-16','11:35:00',3.58),('5819','2013-07-16','11:40:00',3.62),('5819','2013-07-16','11:45:00',3.67),('5819','2013-07-16','11:50:00',3.73),('5819','2013-07-16','11:55:00',3.75),('5819','2013-07-16','12:00:00',3.76),('5819','2013-07-16','12:05:00',3.76),('5819','2013-07-16','12:10:00',3.78),('5819','2013-07-16','12:15:00',3.77),('5819','2013-07-16','12:20:00',3.77),('5819','2013-07-16','12:25:00',3.77),('5819','2013-07-16','12:30:00',3.74),('5819','2013-07-16','12:35:00',3.73),('5819','2013-07-16','12:40:00',3.72),('5819','2013-07-16','12:45:00',3.66),('5819','2013-07-16','12:50:00',3.7),('5819','2013-07-16','12:55:00',3.7),('5819','2013-07-16','13:00:00',3.71),('5819','2013-07-16','13:05:00',3.74),('5819','2013-07-16','13:10:00',3.72),('5819','2013-07-16','13:15:00',3.74),('5819','2013-07-16','13:20:00',3.69),('5819','2013-07-16','13:25:00',3.72),('5819','2013-07-16','13:30:00',3.68),('5819','2013-07-16','13:35:00',3.69),('5819','2013-07-16','13:40:00',3.67),('5819','2013-07-16','13:45:00',3.75),('5819','2013-07-16','13:50:00',3.73),('5819','2013-07-16','13:55:00',3.58),('5819','2013-07-16','14:00:00',3.57),('5819','2013-07-16','14:05:00',3.62),('5819','2013-07-16','14:10:00',3.26),('5819','2013-07-16','14:15:00',2.72),('5819','2013-07-16','14:20:00',1.79),('5819','2013-07-16','14:25:00',3.66),('5819','2013-07-16','14:30:00',3.56),('5819','2013-07-16','14:35:00',3.53),('5819','2013-07-16','14:40:00',3.46),('5819','2013-07-16','14:45:00',3.41),('5819','2013-07-16','14:50:00',3.41),('5819','2013-07-16','14:55:00',3.39),('5819','2013-07-16','15:00:00',3.32),('5819','2013-07-16','15:05:00',3.24),('5819','2013-07-16','15:10:00',3.18),('5819','2013-07-16','15:15:00',3.12),('5819','2013-07-16','15:20:00',3.11),('5819','2013-07-16','15:25:00',3.07),('5819','2013-07-16','15:30:00',3.08),('5819','2013-07-16','15:35:00',3.03),('5819','2013-07-16','15:40:00',2.88),('5819','2013-07-16','15:45:00',2.08),('5819','2013-07-16','15:50:00',2.87),('5819','2013-07-16','15:55:00',2.74),('5819','2013-07-16','16:00:00',1.64),('5819','2013-07-16','16:05:00',1.12),('5819','2013-07-16','16:10:00',2.58),('5819','2013-07-16','16:15:00',2.43),('5819','2013-07-16','16:20:00',1.89),('5819','2013-07-16','16:25:00',1.21),('5819','2013-07-16','16:30:00',1.06),('5819','2013-07-16','16:55:00',1.42),('5819','2013-07-16','17:00:00',2.13),('5819','2013-07-16','17:05:00',2.15),('5819','2013-07-16','17:10:00',2.18),('5819','2013-07-16','17:15:00',2.01),('5819','2013-07-16','17:20:00',1.84),('5819','2013-07-16','17:25:00',1.11),('5819','2013-07-16','17:30:00',1.22),('5819','2013-07-16','17:35:00',1.09),('5819','2013-07-16','17:40:00',1.38),('5819','2013-07-16','17:45:00',1.53),('5819','2013-07-16','17:50:00',1.33),('5819','2013-07-16','17:55:00',1.07),('5819','2013-07-15','07:30:00',1.03),('5819','2013-07-15','07:35:00',1.11),('5819','2013-07-15','07:40:00',1.19),('5819','2013-07-15','07:45:00',1.27),('5819','2013-07-15','07:50:00',1.36),('5819','2013-07-15','07:55:00',1.44),('5819','2013-07-15','08:00:00',1.52),('5819','2013-07-15','08:05:00',1.6),('5819','2013-07-15','08:10:00',1.68),('5819','2013-07-15','08:15:00',1.76),('5819','2013-07-15','08:20:00',1.85),('5819','2013-07-15','08:25:00',1.92),('5819','2013-07-15','08:30:00',2),('5819','2013-07-15','08:35:00',2.07),('5819','2013-07-15','08:40:00',2.14),('5819','2013-07-15','08:45:00',2.21),('5819','2013-07-15','08:50:00',2.28),('5819','2013-07-15','08:55:00',2.35),('5819','2013-07-15','09:00:00',2.42),('5819','2013-07-15','09:05:00',2.5),('5819','2013-07-15','09:10:00',2.57),('5819','2013-07-15','09:15:00',2.63),('5819','2013-07-15','09:20:00',2.67),('5819','2013-07-15','09:25:00',2.73),('5819','2013-07-15','09:30:00',2.79),('5819','2013-07-15','09:35:00',2.84),('5819','2013-07-15','09:40:00',2.89),('5819','2013-07-15','09:45:00',2.93),('5819','2013-07-15','09:50:00',2.99),('5819','2013-07-15','09:55:00',3.03),('5819','2013-07-15','10:00:00',3.06),('5819','2013-07-15','10:05:00',3.1),('5819','2013-07-15','10:10:00',3.16),('5819','2013-07-15','10:15:00',3.19),('5819','2013-07-15','10:20:00',3.21),('5819','2013-07-15','10:25:00',3.24),('5819','2013-07-15','10:30:00',3.26),('5819','2013-07-15','10:35:00',3.31),('5819','2013-07-15','10:40:00',3.36),('5819','2013-07-15','10:45:00',3.39),('5819','2013-07-15','10:50:00',3.41),('5819','2013-07-15','10:55:00',3.44),('5819','2013-07-15','11:00:00',3.49),('5819','2013-07-15','11:05:00',3.52),('5819','2013-07-15','11:10:00',3.54),('5819','2013-07-15','11:15:00',3.56),('5819','2013-07-15','11:20:00',3.58),('5819','2013-07-15','11:25:00',3.6),('5819','2013-07-15','11:30:00',3.61),('5819','2013-07-15','11:35:00',3.64),('5819','2013-07-15','11:40:00',3.67),('5819','2013-07-15','11:45:00',3.65),('5819','2013-07-15','11:50:00',3.66),('5819','2013-07-15','11:55:00',3.7),('5819','2013-07-15','12:00:00',3.7),('5819','2013-07-15','12:05:00',3.66),('5819','2013-07-15','12:10:00',3.68),('5819','2013-07-15','12:15:00',3.74),('5819','2013-07-15','12:20:00',3.75),('5819','2013-07-15','12:25:00',3.73),('5819','2013-07-15','12:30:00',3.75),('5819','2013-07-15','12:35:00',3.72),('5819','2013-07-15','12:40:00',3.69),('5819','2013-07-15','12:45:00',3.67),('5819','2013-07-15','12:50:00',3.71),('5819','2013-07-15','12:55:00',3.74),('5819','2013-07-15','13:00:00',3.26),('5819','2013-07-15','13:05:00',3.59),('5819','2013-07-15','13:10:00',3.47),('5819','2013-07-15','13:15:00',3.74),('5819','2013-07-15','13:20:00',3.69),('5819','2013-07-15','13:25:00',3.89),('5819','2013-07-15','13:30:00',3.9),('5819','2013-07-15','13:35:00',2.47),('5819','2013-07-15','13:40:00',1.08),('5819','2013-07-15','13:45:00',1.95),('5819','2013-07-15','13:50:00',4.11),('5819','2013-07-15','13:55:00',3.96),('5819','2013-07-15','14:00:00',3.94),('5819','2013-07-15','14:05:00',2.37),('5819','2013-07-15','14:10:00',1.21),('5819','2013-07-15','14:15:00',1.28),('5819','2013-07-15','14:20:00',3.27),('5819','2013-07-15','14:25:00',3.71),('5819','2013-07-15','14:30:00',3),('5819','2013-07-15','14:35:00',3.62),('5819','2013-07-15','14:40:00',3.57),('5819','2013-07-15','14:45:00',3.48),('5819','2013-07-15','14:50:00',3.47),('5819','2013-07-15','14:55:00',3.45),('5819','2013-07-15','15:00:00',3.42),('5819','2013-07-15','15:05:00',3.36),('5819','2013-07-15','15:10:00',3.3),('5819','2013-07-15','15:15:00',3.26),('5819','2013-07-15','15:20:00',3.16),('5819','2013-07-15','15:25:00',3.11),('5819','2013-07-15','15:30:00',3.08),('5819','2013-07-15','15:35:00',2.99),('5819','2013-07-15','15:40:00',3.07),('5819','2013-07-15','15:45:00',2.9),('5819','2013-07-15','15:50:00',3.01),('5819','2013-07-15','15:55:00',2.64),('5819','2013-07-15','16:00:00',2.77),('5819','2013-07-15','16:05:00',2.72),('5819','2013-07-15','16:10:00',2.67),('5819','2013-07-15','16:15:00',2.64),('5819','2013-07-15','16:20:00',2.49),('5819','2013-07-15','16:25:00',2.42),('5819','2013-07-15','16:30:00',2.36),('5819','2013-07-15','16:35:00',2.33),('5819','2013-07-15','16:40:00',2.25),('5819','2013-07-15','16:45:00',2.18),('5819','2013-07-15','16:50:00',2.11),('5819','2013-07-15','16:55:00',2.06),('5819','2013-07-15','17:00:00',2),('5819','2013-07-15','17:05:00',1.92),('5819','2013-07-15','17:10:00',1.84),('5819','2013-07-15','17:15:00',1.78),('5819','2013-07-15','17:20:00',1.71),('5819','2013-07-15','17:25:00',1.65),('5819','2013-07-15','17:30:00',1.57),('5819','2013-07-15','17:35:00',1.49),('5819','2013-07-15','17:40:00',1.42),('5819','2013-07-15','17:45:00',1.33),('5819','2013-07-15','17:50:00',1.18),('5819','2013-07-15','17:55:00',1.07),('5819','2013-07-15','18:00:00',1.07),('5819','2013-07-14','07:55:00',1.14),('5819','2013-07-14','08:00:00',1),('5819','2013-07-14','08:05:00',1.35),('5819','2013-07-14','08:10:00',2.16),('5819','2013-07-14','08:15:00',1.75),('5819','2013-07-14','08:20:00',2.39),('5819','2013-07-14','08:25:00',1.69),('5819','2013-07-14','08:35:00',1.18),('5819','2013-07-14','08:40:00',1.18),('5819','2013-07-14','08:45:00',1.02),('5819','2013-07-14','08:50:00',1.17),('5819','2013-07-14','08:55:00',1.33),('5819','2013-07-14','09:00:00',1.07),('5819','2013-07-14','09:05:00',1.29),('5819','2013-07-14','09:10:00',1.39),('5819','2013-07-14','09:15:00',1.51),('5819','2013-07-14','09:20:00',1.86),('5819','2013-07-14','09:25:00',2.4),('5819','2013-07-14','09:30:00',2.26),('5819','2013-07-14','09:35:00',1.79),('5819','2013-07-14','09:40:00',1.62),('5819','2013-07-14','09:45:00',1.62),('5819','2013-07-14','09:50:00',1.55),('5819','2013-07-14','09:55:00',1.7),('5819','2013-07-14','10:00:00',1.62),('5819','2013-07-14','10:05:00',1.72),('5819','2013-07-14','10:10:00',1.7),('5819','2013-07-14','10:15:00',1.77),('5819','2013-07-14','10:20:00',2.29),('5819','2013-07-14','10:25:00',2.72),('5819','2013-07-14','10:30:00',2.43),('5819','2013-07-14','10:35:00',3.31),('5819','2013-07-14','10:40:00',3.5),('5819','2013-07-14','10:45:00',3.19),('5819','2013-07-14','10:50:00',3.74),('5819','2013-07-14','10:55:00',3.19),('5819','2013-07-14','11:00:00',3.79),('5819','2013-07-14','11:05:00',3.68),('5819','2013-07-14','11:10:00',2.64),('5819','2013-07-14','11:15:00',3),('5819','2013-07-14','11:20:00',4.12),('5819','2013-07-14','11:25:00',3.81),('5819','2013-07-14','11:30:00',3.95),('5819','2013-07-14','11:35:00',3.71),('5819','2013-07-14','11:40:00',3.61),('5819','2013-07-14','11:45:00',4.06),('5819','2013-07-14','11:50:00',3.15),('5819','2013-07-14','11:55:00',1.4),('5819','2013-07-14','12:00:00',1.33),('5819','2013-07-14','12:05:00',1.54),('5819','2013-07-14','12:10:00',3.34),('5819','2013-07-14','12:15:00',3.21),('5819','2013-07-14','12:20:00',2.17),('5819','2013-07-14','12:25:00',2.11),('5819','2013-07-14','12:30:00',1.56),('5819','2013-07-14','12:35:00',1.35),('5819','2013-07-14','12:40:00',1.53),('5819','2013-07-14','12:45:00',3.14),('5819','2013-07-14','12:50:00',2.93),('5819','2013-07-14','12:55:00',3.52),('5819','2013-07-14','13:00:00',4.14),('5819','2013-07-14','13:05:00',4.19),('5819','2013-07-14','13:10:00',4.04),('5819','2013-07-14','13:15:00',4.04),('5819','2013-07-14','13:20:00',4.1),('5819','2013-07-14','13:25:00',3.94),('5819','2013-07-14','13:30:00',3.92),('5819','2013-07-14','13:35:00',3.89),('5819','2013-07-14','13:40:00',3.85),('5819','2013-07-14','13:45:00',3.85),('5819','2013-07-14','13:50:00',3.86),('5819','2013-07-14','13:55:00',3.85),('5819','2013-07-14','14:00:00',3.85),('5819','2013-07-14','14:05:00',3.83),('5819','2013-07-14','14:10:00',3.79),('5819','2013-07-14','14:15:00',3.79),('5819','2013-07-14','14:20:00',3.75),('5819','2013-07-14','14:25:00',3.7),('5819','2013-07-14','14:30:00',3.69),('5819','2013-07-14','14:35:00',3.59),('5819','2013-07-14','14:40:00',3.5),('5819','2013-07-14','14:45:00',3.47),('5819','2013-07-14','14:50:00',3.52),('5819','2013-07-14','14:55:00',3.5),('5819','2013-07-14','15:00:00',3.38),('5819','2013-07-14','15:05:00',3.33),('5819','2013-07-14','15:10:00',3.29),('5819','2013-07-14','15:15:00',3.24),('5819','2013-07-14','15:20:00',3.2),('5819','2013-07-14','15:25:00',3.14),('5819','2013-07-14','15:30:00',3.09),('5819','2013-07-14','15:35:00',3.04),('5819','2013-07-14','15:40:00',2.98),('5819','2013-07-14','15:45:00',2.94),('5819','2013-07-14','15:50:00',2.88),('5819','2013-07-14','15:55:00',2.86),('5819','2013-07-14','16:00:00',2.78),('5819','2013-07-14','16:05:00',2.76),('5819','2013-07-14','16:10:00',2.69),('5819','2013-07-14','16:15:00',2.65),('5819','2013-07-14','16:20:00',2.49),('5819','2013-07-14','16:25:00',2.48),('5819','2013-07-14','16:30:00',2.07),('5819','2013-07-14','16:35:00',2.07),('5819','2013-07-14','16:40:00',2.25),('5819','2013-07-14','16:45:00',2.23),('5819','2013-07-14','16:50:00',2.23),('5819','2013-07-14','16:55:00',2.27),('5819','2013-07-14','17:00:00',2.03),('5819','2013-07-14','17:05:00',1.62),('5819','2013-07-14','17:10:00',1.61),('5819','2013-07-14','17:15:00',1.57),('5819','2013-07-14','17:20:00',1.05),('5819','2013-07-14','17:25:00',1.49),('5819','2013-07-14','17:30:00',1.55),('5819','2013-07-14','17:35:00',1.61),('5819','2013-07-14','17:40:00',1.21),('5819','2013-07-14','17:55:00',1.24),('5819','2013-07-13','07:30:00',1.08),('5819','2013-07-13','07:35:00',1.07),('5819','2013-07-13','07:40:00',1.1),('5819','2013-07-13','07:45:00',1.18),('5819','2013-07-13','07:50:00',1.22),('5819','2013-07-13','07:55:00',1.29),('5819','2013-07-13','08:00:00',1.33),('5819','2013-07-13','08:05:00',1.4),('5819','2013-07-13','08:10:00',1.52),('5819','2013-07-13','08:15:00',1.64),('5819','2013-07-13','08:20:00',1.71),('5819','2013-07-13','08:25:00',1.81),('5819','2013-07-13','08:30:00',1.87),('5819','2013-07-13','08:35:00',1.94),('5819','2013-07-13','08:40:00',1.99),('5819','2013-07-13','08:45:00',2.1),('5819','2013-07-13','08:50:00',2.19),('5819','2013-07-13','08:55:00',2.22),('5819','2013-07-13','09:00:00',2.32),('5819','2013-07-13','09:05:00',2.38),('5819','2013-07-13','09:10:00',2.45),('5819','2013-07-13','09:15:00',2.52),('5819','2013-07-13','09:20:00',2.55),('5819','2013-07-13','09:25:00',2.64),('5819','2013-07-13','09:30:00',2.67),('5819','2013-07-13','09:35:00',2.74),('5819','2013-07-13','09:40:00',2.78),('5819','2013-07-13','09:45:00',2.85),('5819','2013-07-13','09:50:00',2.93),('5819','2013-07-13','09:55:00',2.96),('5819','2013-07-13','10:00:00',2.96),('5819','2013-07-13','10:05:00',3.03),('5819','2013-07-13','10:10:00',3.1),('5819','2013-07-13','10:15:00',3.05),('5819','2013-07-13','10:20:00',3.14),('5819','2013-07-13','10:25:00',3.27),('5819','2013-07-13','10:30:00',3.29),('5819','2013-07-13','10:35:00',3.27),('5819','2013-07-13','10:40:00',3.2),('5819','2013-07-13','10:45:00',3.32),('5819','2013-07-13','10:50:00',3.22),('5819','2013-07-13','10:55:00',3.53),('5819','2013-07-13','11:00:00',3.42),('5819','2013-07-13','11:05:00',3.62),('5819','2013-07-13','11:10:00',3.75),('5819','2013-07-13','11:15:00',2.55),('5819','2013-07-13','11:20:00',1.35),('5819','2013-07-13','11:25:00',1.99),('5819','2013-07-13','11:30:00',3.76),('5819','2013-07-13','11:35:00',3.72),('5819','2013-07-13','11:40:00',3.26),('5819','2013-07-13','11:45:00',1.7),('5819','2013-07-13','11:50:00',3.61),('5819','2013-07-13','11:55:00',2.97),('5819','2013-07-13','12:00:00',2.69),('5819','2013-07-13','12:05:00',3.33),('5819','2013-07-13','12:10:00',3.8),('5819','2013-07-13','12:15:00',1.98),('5819','2013-07-13','12:20:00',1.93),('5819','2013-07-13','12:25:00',2.62),('5819','2013-07-13','12:30:00',1.22),('5819','2013-07-13','12:35:00',3.99),('5819','2013-07-13','12:40:00',4.09),('5819','2013-07-13','12:45:00',2.32),('5819','2013-07-13','12:50:00',2.75),('5819','2013-07-13','12:55:00',3.94),('5819','2013-07-13','13:00:00',3.96),('5819','2013-07-13','13:05:00',4.01),('5819','2013-07-13','13:10:00',3.16),('5819','2013-07-13','13:15:00',3.23),('5819','2013-07-13','13:20:00',4.01),('5819','2013-07-13','13:25:00',3.93),('5819','2013-07-13','13:30:00',3.84),('5819','2013-07-13','13:35:00',3.82),('5819','2013-07-13','13:40:00',3.8),('5819','2013-07-13','13:45:00',3.75),('5819','2013-07-13','13:50:00',3.76),('5819','2013-07-13','13:55:00',3.75),('5819','2013-07-13','14:00:00',3.71),('5819','2013-07-13','14:05:00',3.71),('5819','2013-07-13','14:10:00',3.67),('5819','2013-07-13','14:15:00',3.64),('5819','2013-07-13','14:20:00',3.62),('5819','2013-07-13','14:25:00',3.6),('5819','2013-07-13','14:30:00',3.58),('5819','2013-07-13','14:35:00',3.56),('5819','2013-07-13','14:40:00',3.52),('5819','2013-07-13','14:45:00',3.5),('5819','2013-07-13','14:50:00',3.45),('5819','2013-07-13','14:55:00',3.45),('5819','2013-07-13','15:00:00',3.4),('5819','2013-07-13','15:05:00',3.38),('5819','2013-07-13','15:10:00',3.33),('5819','2013-07-13','15:15:00',3.31),('5819','2013-07-13','15:20:00',3.12),('5819','2013-07-13','15:25:00',3.25),('5819','2013-07-13','15:30:00',3.17),('5819','2013-07-13','15:35:00',3.15),('5819','2013-07-13','15:40:00',3.08),('5819','2013-07-13','15:45:00',3.02),('5819','2013-07-13','15:50:00',2.97),('5819','2013-07-13','15:55:00',2.92),('5819','2013-07-13','16:00:00',2.86),('5819','2013-07-13','16:05:00',2.82),('5819','2013-07-13','16:10:00',2.76),('5819','2013-07-13','16:15:00',2.66),('5819','2013-07-13','16:20:00',2.52),('5819','2013-07-13','16:25:00',2.58),('5819','2013-07-13','16:30:00',2.51),('5819','2013-07-13','16:35:00',2.45),('5819','2013-07-13','16:40:00',2.37),('5819','2013-07-13','16:45:00',2.29),('5819','2013-07-13','16:50:00',2.2),('5819','2013-07-13','16:55:00',2.12),('5819','2013-07-13','17:00:00',2.06),('5819','2013-07-13','17:05:00',1.97),('5819','2013-07-13','17:10:00',1.92),('5819','2013-07-13','17:15:00',1.86),('5819','2013-07-13','17:20:00',1.71),('5819','2013-07-13','17:25:00',1.72),('5819','2013-07-13','17:30:00',1.6),('5819','2013-07-13','17:35:00',1.52),('5819','2013-07-13','17:40:00',1.47),('5819','2013-07-13','17:45:00',1.4),('5819','2013-07-13','17:50:00',1.2),('5819','2013-07-13','17:55:00',1.22),('5819','2013-07-13','18:00:00',1.13),('5819','2013-07-13','18:05:00',1.05),('5819','2013-07-12','08:15:00',1.61),('5819','2013-07-12','08:20:00',2.07),('5819','2013-07-12','08:25:00',1),('5819','2013-07-12','08:35:00',1),('5819','2013-07-12','08:40:00',1.16),('5819','2013-07-12','08:45:00',1.35),('5819','2013-07-12','08:50:00',1.09),('5819','2013-07-12','09:05:00',1.01),('5819','2013-07-12','09:10:00',1.42),('5819','2013-07-12','09:15:00',1.74),('5819','2013-07-12','09:20:00',2.05),('5819','2013-07-12','09:25:00',2.53),('5819','2013-07-12','09:30:00',1.8),('5819','2013-07-12','09:35:00',1.63),('5819','2013-07-12','09:40:00',1.89),('5819','2013-07-12','09:45:00',2.88),('5819','2013-07-12','09:50:00',2.85),('5819','2013-07-12','09:55:00',2.94),('5819','2013-07-12','10:00:00',2.94),('5819','2013-07-12','10:05:00',2.98),('5819','2013-07-12','10:10:00',1.69),('5819','2013-07-12','10:15:00',2.65),('5819','2013-07-12','10:20:00',1.49),('5819','2013-07-12','10:25:00',1.34),('5819','2013-07-12','10:30:00',2.01),('5819','2013-07-12','10:35:00',2.06),('5819','2013-07-12','10:40:00',1.04),('5819','2013-07-12','10:50:00',1.58),('5819','2013-07-12','10:55:00',1.91),('5819','2013-07-12','11:00:00',3.94),('5819','2013-07-12','11:05:00',1.94),('5819','2013-07-12','11:10:00',1.18),('5819','2013-07-12','11:15:00',2.53),('5819','2013-07-12','11:25:00',3.53),('5819','2013-07-12','11:30:00',4.01),('5819','2013-07-12','11:35:00',3.73),('5819','2013-07-12','11:40:00',2.63),('5819','2013-07-12','11:45:00',3.27),('5819','2013-07-12','11:50:00',3.45),('5819','2013-07-12','11:55:00',3.11),('5819','2013-07-12','12:00:00',4.05),('5819','2013-07-12','12:05:00',2.33),('5819','2013-07-12','12:10:00',3.85),('5819','2013-07-12','12:15:00',2.37),('5819','2013-07-12','12:20:00',4.03),('5819','2013-07-12','12:25:00',2.68),('5819','2013-07-12','12:30:00',3.76),('5819','2013-07-12','12:35:00',3.69),('5819','2013-07-12','12:40:00',2.8),('5819','2013-07-12','12:45:00',3.35),('5819','2013-07-12','12:50:00',2.62),('5819','2013-07-12','12:55:00',4.09),('5819','2013-07-12','13:00:00',3.95),('5819','2013-07-12','13:05:00',3.99),('5819','2013-07-12','13:10:00',3.94),('5819','2013-07-12','13:15:00',3.95),('5819','2013-07-12','13:20:00',3.91),('5819','2013-07-12','13:25:00',3.87),('5819','2013-07-12','13:30:00',3.93),('5819','2013-07-12','13:35:00',3.9),('5819','2013-07-12','13:40:00',3.9),('5819','2013-07-12','13:45:00',3.84),('5819','2013-07-12','13:50:00',3.91),('5819','2013-07-12','13:55:00',3.81),('5819','2013-07-12','14:00:00',3.11),('5819','2013-07-12','14:05:00',3.21),('5819','2013-07-12','14:10:00',2.93),('5819','2013-07-12','14:15:00',3.32),('5819','2013-07-12','14:20:00',4.09),('5819','2013-07-12','14:25:00',3.93),('5819','2013-07-12','14:30:00',2.47),('5819','2013-07-12','14:35:00',2.76),('5819','2013-07-12','14:40:00',3.58),('5819','2013-07-12','14:45:00',3.48),('5819','2013-07-12','14:50:00',3.45),('5819','2013-07-12','14:55:00',3.4),('5819','2013-07-12','15:00:00',3.2),('5819','2013-07-12','15:05:00',3.32),('5819','2013-07-12','15:10:00',3.23),('5819','2013-07-12','15:15:00',2.69),('5819','2013-07-12','15:20:00',3.23),('5819','2013-07-12','15:25:00',3.17),('5819','2013-07-12','15:30:00',2.99),('5819','2013-07-12','15:35:00',2.58),('5819','2013-07-12','15:40:00',3.11),('5819','2013-07-12','15:45:00',2.71),('5819','2013-07-12','15:50:00',2.74),('5819','2013-07-12','15:55:00',2.86),('5819','2013-07-12','16:00:00',2.78),('5819','2013-07-12','16:05:00',2.73),('5819','2013-07-12','16:10:00',2.66),('5819','2013-07-12','16:15:00',2.57),('5819','2013-07-12','16:20:00',2.53),('5819','2013-07-12','16:25:00',2.49),('5819','2013-07-12','16:30:00',2.41),('5819','2013-07-12','16:35:00',2.33),('5819','2013-07-12','16:40:00',2.29),('5819','2013-07-12','16:45:00',2.23),('5819','2013-07-12','16:50:00',2.15),('5819','2013-07-12','16:55:00',2.09),('5819','2013-07-12','17:00:00',2.01),('5819','2013-07-12','17:05:00',1.95),('5819','2013-07-12','17:10:00',1.88),('5819','2013-07-12','17:15:00',1.79),('5819','2013-07-12','17:20:00',1.72),('5819','2013-07-12','17:25:00',1.62),('5819','2013-07-12','17:30:00',1.56),('5819','2013-07-12','17:35:00',1.49),('5819','2013-07-12','17:40:00',1.41),('5819','2013-07-12','17:45:00',1.34),('5819','2013-07-12','17:50:00',1.18),('5819','2013-07-12','17:55:00',1.11),('5819','2013-07-12','18:00:00',1.08),('5819','2013-07-12','18:05:00',1.03),('5819','2013-07-11','07:35:00',1.01),('5819','2013-07-11','07:40:00',1.09),('5819','2013-07-11','07:45:00',1.18),('5819','2013-07-11','07:50:00',1.26),('5819','2013-07-11','07:55:00',1.33),('5819','2013-07-11','08:00:00',1.41),('5819','2013-07-11','08:05:00',1.5),('5819','2013-07-11','08:10:00',1.56),('5819','2013-07-11','08:15:00',1.64),('5819','2013-07-11','08:20:00',1.73),('5819','2013-07-11','08:25:00',1.83),('5819','2013-07-11','08:30:00',1.9),('5819','2013-07-11','08:35:00',1.93),('5819','2013-07-11','08:40:00',2.02),('5819','2013-07-11','08:45:00',2.12),('5819','2013-07-11','08:50:00',2.15),('5819','2013-07-11','08:55:00',2.27),('5819','2013-07-11','09:00:00',2.35),('5819','2013-07-11','09:05:00',2.42),('5819','2013-07-11','09:10:00',2.42),('5819','2013-07-11','09:15:00',2.49),('5819','2013-07-11','09:20:00',2.41),('5819','2013-07-11','09:25:00',2.77),('5819','2013-07-11','09:30:00',2.83),('5819','2013-07-11','09:35:00',2.64),('5819','2013-07-11','09:40:00',2.52),('5819','2013-07-11','09:45:00',3.02),('5819','2013-07-11','09:50:00',2.27),('5819','2013-07-11','09:55:00',2.15),('5819','2013-07-11','10:00:00',2.45),('5819','2013-07-11','10:05:00',1.49),('5819','2013-07-11','10:10:00',1.3),('5819','2013-07-11','10:15:00',3.19),('5819','2013-07-11','10:20:00',3.25),('5819','2013-07-11','10:25:00',3.25),('5819','2013-07-11','10:30:00',3.52),('5819','2013-07-11','10:35:00',2.08),('5819','2013-07-11','10:45:00',2.67),('5819','2013-07-11','10:50:00',3.43),('5819','2013-07-11','10:55:00',3.67),('5819','2013-07-11','11:00:00',3.1),('5819','2013-07-11','11:05:00',2.75),('5819','2013-07-11','11:10:00',3.67),('5819','2013-07-11','11:15:00',2.02),('5819','2013-07-11','11:20:00',2.64),('5819','2013-07-11','11:25:00',2.35),('5819','2013-07-11','11:30:00',2.9),('5819','2013-07-11','11:35:00',2.97),('5819','2013-07-11','11:40:00',4.16),('5819','2013-07-11','11:45:00',3.97),('5819','2013-07-11','11:50:00',2.44),('5819','2013-07-11','11:55:00',1.64),('5819','2013-07-11','12:00:00',3.39),('5819','2013-07-11','12:05:00',1.06),('5819','2013-07-11','12:10:00',1.15),('5819','2013-07-11','12:15:00',1.97),('5819','2013-07-11','12:20:00',4.2),('5819','2013-07-11','12:25:00',4.02),('5819','2013-07-11','12:30:00',3.49),('5819','2013-07-11','12:35:00',3.96),('5819','2013-07-11','12:40:00',2.77),('5819','2013-07-11','12:45:00',1.87),('5819','2013-07-11','12:50:00',2.56),('5819','2013-07-11','12:55:00',3.58),('5819','2013-07-11','13:00:00',4.14),('5819','2013-07-11','13:05:00',3.19),('5819','2013-07-11','13:10:00',3.92),('5819','2013-07-11','13:15:00',4.03),('5819','2013-07-11','13:20:00',3.96),('5819','2013-07-11','13:25:00',3.94),('5819','2013-07-11','13:30:00',4.02),('5819','2013-07-11','13:35:00',3.79),('5819','2013-07-11','13:40:00',3.97),('5819','2013-07-11','13:45:00',3.51),('5819','2013-07-11','13:50:00',2.82),('5819','2013-07-11','13:55:00',3.16),('5819','2013-07-11','14:00:00',3.53),('5819','2013-07-11','14:05:00',3.45),('5819','2013-07-11','14:10:00',3.84),('5819','2013-07-11','14:15:00',3.81),('5819','2013-07-11','14:20:00',3.76),('5819','2013-07-11','14:25:00',3.26),('5819','2013-07-11','14:30:00',3.29),('5819','2013-07-11','14:35:00',3.67),('5819','2013-07-11','14:40:00',3.59),('5819','2013-07-11','14:45:00',3.57),('5819','2013-07-11','14:50:00',3.59),('5819','2013-07-11','14:55:00',2.68),('5819','2013-07-11','15:00:00',3.71),('5819','2013-07-11','15:05:00',2.1),('5819','2013-07-11','15:10:00',1.75),('5819','2013-07-11','15:15:00',3.42),('5819','2013-07-11','15:20:00',2.22),('5819','2013-07-11','15:25:00',2.29),('5819','2013-07-11','15:30:00',2.81),('5819','2013-07-11','15:35:00',3.36),('5819','2013-07-11','15:40:00',2.47),('5819','2013-07-11','15:45:00',2.75),('5819','2013-07-11','15:50:00',2.33),('5819','2013-07-11','15:55:00',1.83),('5819','2013-07-11','16:00:00',2.14),('5819','2013-07-11','16:05:00',2.33),('5819','2013-07-11','16:10:00',2.42),('5819','2013-07-11','16:15:00',1.96),('5819','2013-07-11','16:20:00',1.76),('5819','2013-07-11','16:25:00',2.03),('5819','2013-07-11','16:30:00',2.48),('5819','2013-07-11','16:35:00',1.3),('5819','2013-07-11','16:40:00',2.42),('5819','2013-07-11','16:45:00',1.89),('5819','2013-07-11','16:50:00',2.31),('5819','2013-07-11','16:55:00',2.3),('5819','2013-07-11','17:00:00',1.98),('5819','2013-07-11','17:05:00',1.75),('5819','2013-07-11','17:10:00',1.66),('5819','2013-07-11','17:15:00',1.04),('5819','2013-07-11','17:20:00',1.52),('5819','2013-07-11','17:25:00',1.15),('5819','2013-07-11','17:30:00',1.72),('5819','2013-07-11','17:35:00',1.66),('5819','2013-07-11','17:40:00',1.64),('5819','2013-07-11','17:45:00',1.51),('5819','2013-07-11','17:50:00',1.23),('5819','2013-07-11','18:00:00',1.1),('5819','2013-07-11','18:05:00',1.41),('5819','2013-07-11','18:10:00',1.31),('5819','2013-07-11','18:15:00',1.07),('5819','2013-07-11','18:25:00',1.02),('5819','2014-05-03','07:25:00',1.04),('5819','2014-05-03','07:30:00',1.13),('5819','2014-05-03','07:35:00',1.22),('5819','2014-05-03','07:40:00',1.31),('5819','2014-05-03','07:45:00',1.41),('5819','2014-05-03','07:50:00',1.53),('5819','2014-05-03','07:55:00',1.63),('5819','2014-05-03','08:00:00',1.54),('5819','2014-05-03','08:05:00',1.9),('5819','2014-05-03','08:10:00',2.14),('5819','2014-05-03','08:15:00',1.89),('5819','2014-05-03','08:20:00',1.36),('5819','2014-05-03','08:25:00',1.08),('5819','2014-05-03','08:30:00',1.22),('5819','2014-05-03','08:35:00',1.01),('5819','2014-05-03','08:40:00',1.27),('5819','2014-05-03','08:45:00',2.04),('5819','2014-05-03','08:50:00',2.6),('5819','2014-05-03','08:55:00',2.8),('5819','2014-05-03','09:00:00',3.16),('5819','2014-05-03','09:05:00',3.47),('5819','2014-05-03','09:10:00',2.23),('5819','2014-05-03','09:15:00',1.51),('5819','2014-05-03','09:20:00',2.5),('5819','2014-05-03','09:25:00',3.33),('5819','2014-05-03','09:30:00',1.9),('5819','2014-05-03','09:35:00',3.26),('5819','2014-05-03','09:40:00',1.93),('5819','2014-05-03','09:45:00',2.88),('5819','2014-05-03','09:50:00',1.8),('5819','2014-05-03','09:55:00',3.07),('5819','2014-05-03','10:00:00',3.59),('5819','2014-05-03','10:05:00',3.59),('5819','2014-05-03','10:10:00',3.67),('5819','2014-05-03','10:15:00',3.87),('5819','2014-05-03','10:20:00',2.87),('5819','2014-05-03','10:25:00',3.15),('5819','2014-05-03','10:30:00',2.4),('5819','2014-05-03','10:40:00',1.09),('5819','2014-05-03','10:45:00',1.91),('5819','2014-05-03','10:50:00',1.24),('5819','2014-05-03','10:55:00',1.92),('5819','2014-05-03','11:00:00',1.32),('5819','2014-05-03','11:05:00',2.93),('5819','2014-05-03','11:10:00',5),('5819','2014-05-03','11:15:00',1.84),('5819','2014-05-03','11:20:00',2.43),('5819','2014-05-03','11:25:00',3.02),('5819','2014-05-03','11:30:00',4.44),('5819','2014-05-03','11:35:00',2.85),('5819','2014-05-03','11:40:00',2.67),('5819','2014-05-03','11:45:00',2.63),('5819','2014-05-03','11:50:00',2.21),('5819','2014-05-03','11:55:00',2.43),('5819','2014-05-03','12:00:00',2.1),('5819','2014-05-03','12:05:00',1.8),('5819','2014-05-03','12:10:00',1.63),('5819','2014-05-03','12:15:00',1.43),('5819','2014-05-03','12:20:00',1.25),('5819','2014-05-03','12:25:00',1.28),('5819','2014-05-03','12:30:00',1.61),('5819','2014-05-03','12:35:00',1.89),('5819','2014-05-03','12:40:00',1.7),('5819','2014-05-03','12:45:00',1.77),('5819','2014-05-03','12:50:00',1.86),('5819','2014-05-03','12:55:00',1.93),('5819','2014-05-03','13:00:00',1.93),('5819','2014-05-03','13:05:00',1.78),('5819','2014-05-03','13:10:00',2.65),('5819','2014-05-03','13:15:00',2.68),('5819','2014-05-03','13:20:00',2.37),('5819','2014-05-03','13:25:00',2.91),('5819','2014-05-03','13:30:00',2.79),('5819','2014-05-03','13:35:00',2.27),('5819','2014-05-03','13:40:00',1.72),('5819','2014-05-03','13:45:00',1.66),('5819','2014-05-03','13:50:00',1.66),('5819','2014-05-03','13:55:00',1.67),('5819','2014-05-03','14:00:00',1.63),('5819','2014-05-03','14:05:00',1.62),('5819','2014-05-03','14:10:00',1.75),('5819','2014-05-03','14:15:00',1.95),('5819','2014-05-03','14:20:00',2.2),('5819','2014-05-03','14:25:00',2.57),('5819','2014-05-03','14:30:00',2.18),('5819','2014-05-03','14:35:00',1.6),('5819','2014-05-03','14:40:00',1.41),('5819','2013-07-10','07:20:00',1.08),('5819','2013-07-10','07:25:00',1.25),('5819','2013-07-10','07:30:00',1.38),('5819','2013-07-10','07:35:00',1.51),('5819','2013-07-10','07:40:00',1.65),('5819','2013-07-10','07:45:00',1.77),('5819','2013-07-10','07:50:00',1.9),('5819','2013-07-10','07:55:00',2.04),('5819','2013-07-10','08:00:00',2.16),('5819','2013-07-10','08:05:00',1.77),('5819','2013-07-10','08:10:00',1.58),('5819','2013-07-10','08:15:00',1.65),('5819','2013-07-10','08:20:00',1.8),('5819','2013-07-10','08:25:00',2.39),('5819','2013-07-10','08:30:00',2.27),('5819','2013-07-10','08:35:00',2.45),('5819','2013-07-10','08:40:00',2.61),('5819','2013-07-10','08:45:00',2.47),('5819','2013-07-10','08:50:00',2.44),('5819','2013-07-10','08:55:00',2.41),('5819','2013-07-10','09:00:00',2.45),('5819','2013-07-10','09:05:00',2.57),('5819','2013-07-10','09:10:00',2.67),('5819','2013-07-10','09:15:00',2.73),('5819','2013-07-10','09:20:00',2.77),('5819','2013-07-10','09:25:00',2.74),('5819','2013-07-10','09:30:00',2.84),('5819','2013-07-10','09:35:00',2.84),('5819','2013-07-10','09:40:00',2.86),('5819','2013-07-10','09:45:00',2.92),('5819','2013-07-10','09:50:00',2.96),('5819','2013-07-10','09:55:00',3.08),('5819','2013-07-10','10:00:00',2.91),('5819','2013-07-10','10:05:00',3.11),('5819','2013-07-10','10:10:00',3.13),('5819','2013-07-10','10:15:00',3.16),('5819','2013-07-10','10:20:00',3.23),('5819','2013-07-10','10:25:00',3.29),('5819','2013-07-10','10:30:00',3.3),('5819','2013-07-10','10:35:00',3.34),('5819','2013-07-10','10:40:00',3.36),('5819','2013-07-10','10:45:00',3.4),('5819','2013-07-10','10:50:00',3.39),('5819','2013-07-10','10:55:00',3.41),('5819','2013-07-10','11:00:00',3.47),('5819','2013-07-10','11:05:00',3.51),('5819','2013-07-10','11:10:00',3.52),('5819','2013-07-10','11:15:00',3.54),('5819','2013-07-10','11:20:00',3.56),('5819','2013-07-10','11:25:00',3.58),('5819','2013-07-10','11:30:00',3.58),('5819','2013-07-10','11:35:00',3.54),('5819','2013-07-10','11:40:00',3.5),('5819','2013-07-10','11:45:00',3.56),('5819','2013-07-10','11:50:00',3.63),('5819','2013-07-10','11:55:00',3.71),('5819','2013-07-10','12:00:00',3.7),('5819','2013-07-10','12:05:00',3.72),('5819','2013-07-10','12:10:00',3.71),('5819','2013-07-10','12:15:00',3.71),('5819','2013-07-10','12:20:00',3.75),('5819','2013-07-10','12:25:00',3.81),('5819','2013-07-10','12:30:00',3.83),('5819','2013-07-10','12:35:00',3.76),('5819','2013-07-10','12:40:00',3.71),('5819','2013-07-10','12:45:00',3.77),('5819','2013-07-10','12:50:00',3.78),('5819','2013-07-10','12:55:00',3.78),('5819','2013-07-10','13:00:00',3.78),('5819','2013-07-10','13:05:00',3.79),('5819','2013-07-10','13:10:00',3.85),('5819','2013-07-10','13:15:00',3.79),('5819','2013-07-10','13:20:00',3.78),('5819','2013-07-10','13:25:00',3.8),('5819','2013-07-10','13:30:00',3.8),('5819','2013-07-10','13:35:00',3.78),('5819','2013-07-10','13:40:00',3.75),('5819','2013-07-10','13:45:00',3.76),('5819','2013-07-10','13:50:00',3.77),('5819','2013-07-10','13:55:00',3.73),('5819','2013-07-10','14:00:00',3.73),('5819','2013-07-10','14:05:00',3.71),('5819','2013-07-10','14:10:00',3.69),('5819','2013-07-10','14:15:00',3.67),('5819','2013-07-10','14:20:00',3.64),('5819','2013-07-10','14:25:00',3.59),('5819','2013-07-10','14:30:00',3.57),('5819','2013-07-10','14:35:00',3.56),('5819','2013-07-10','14:40:00',3.54),('5819','2013-07-10','14:45:00',3.51),('5819','2013-07-10','14:50:00',3.46),('5819','2013-07-10','14:55:00',3.44),('5819','2013-07-10','15:00:00',3.42),('5819','2013-07-10','15:05:00',3.38),('5819','2013-07-10','15:10:00',3.33),('5819','2013-07-10','15:15:00',3.3),('5819','2013-07-10','15:20:00',3.25),('5819','2013-07-10','15:25:00',3.21),('5819','2013-07-10','15:30:00',3.16),('5819','2013-07-10','15:35:00',3.14),('5819','2013-07-10','15:40:00',3.07),('5819','2013-07-10','15:45:00',3.01),('5819','2013-07-10','15:50:00',2.94),('5819','2013-07-10','15:55:00',2.9),('5819','2013-07-10','16:00:00',2.86),('5819','2013-07-10','16:05:00',2.8),('5819','2013-07-10','16:10:00',2.72),('5819','2013-07-10','16:15:00',2.62),('5819','2013-07-10','16:20:00',2.59),('5819','2013-07-10','16:25:00',2.53),('5819','2013-07-10','16:30:00',2.45),('5819','2013-07-10','16:35:00',2.39),('5819','2013-07-10','16:40:00',2.32),('5819','2013-07-10','16:45:00',2.28),('5819','2013-07-10','16:50:00',2.2),('5819','2013-07-10','16:55:00',2.18),('5819','2013-07-10','17:00:00',2.19),('5819','2013-07-10','17:05:00',1.98),('5819','2013-07-10','17:10:00',1.71),('5819','2013-07-10','17:15:00',1.15),('5819','2013-07-10','17:20:00',1.04),('5819','2013-07-10','17:35:00',1.67),('5819','2013-07-10','17:40:00',1.22),('5819','2013-07-10','17:45:00',1.34),('5819','2013-07-10','17:50:00',1.11),('5819','2013-07-10','17:55:00',1.22),('5819','2013-07-10','18:00:00',1.15),('5819','2013-07-09','07:35:00',1.11),('5819','2013-07-09','07:40:00',1.18),('5819','2013-07-09','07:45:00',1.26),('5819','2013-07-09','07:50:00',1.36),('5819','2013-07-09','07:55:00',1.43),('5819','2013-07-09','08:00:00',1.5),('5819','2013-07-09','08:05:00',1.57),('5819','2013-07-09','08:10:00',1.65),('5819','2013-07-09','08:15:00',1.74),('5819','2013-07-09','08:20:00',1.81),('5819','2013-07-09','08:25:00',1.88),('5819','2013-07-09','08:30:00',1.96),('5819','2013-07-09','08:35:00',2.03),('5819','2013-07-09','08:40:00',2.09),('5819','2013-07-09','08:45:00',2.16),('5819','2013-07-09','08:50:00',2.24),('5819','2013-07-09','08:55:00',2.31),('5819','2013-07-09','09:00:00',2.38),('5819','2013-07-09','09:05:00',2.44),('5819','2013-07-09','09:10:00',2.49),('5819','2013-07-09','09:15:00',2.55),('5819','2013-07-09','09:20:00',2.61),('5819','2013-07-09','09:25:00',2.67),('5819','2013-07-09','09:30:00',2.73),('5819','2013-07-09','09:35:00',2.78),('5819','2013-07-09','09:40:00',2.84),('5819','2013-07-09','09:45:00',2.91),('5819','2013-07-09','09:50:00',2.95),('5819','2013-07-09','09:55:00',3),('5819','2013-07-09','10:00:00',3.03),('5819','2013-07-09','10:05:00',3.07),('5819','2013-07-09','10:10:00',3.13),('5819','2013-07-09','10:15:00',3.18),('5819','2013-07-09','10:20:00',3.23),('5819','2013-07-09','10:25:00',3.27),('5819','2013-07-09','10:30:00',3.26),('5819','2013-07-09','10:35:00',3.29),('5819','2013-07-09','10:40:00',3.31),('5819','2013-07-09','10:45:00',3.36),('5819','2013-07-09','10:50:00',3.39),('5819','2013-07-09','10:55:00',3.46),('5819','2013-07-09','11:00:00',3.5),('5819','2013-07-09','11:05:00',3.3),('5819','2013-07-09','11:10:00',3.13),('5819','2013-07-09','11:15:00',2.98),('5819','2013-07-09','11:20:00',3.08),('5819','2013-07-09','11:25:00',3.15),('5819','2013-07-09','11:30:00',2.12),('5819','2013-07-09','11:35:00',2.46),('5819','2013-07-09','11:40:00',2.71),('5819','2013-07-09','11:45:00',3.64),('5819','2013-07-09','11:50:00',4.23),('5819','2013-07-09','11:55:00',4.17),('5819','2013-07-09','12:00:00',4.17),('5819','2013-07-09','12:05:00',3.89),('5819','2013-07-09','12:10:00',2.81),('5819','2013-07-09','12:15:00',3.85),('5819','2013-07-09','12:20:00',3.78),('5819','2013-07-09','12:25:00',3.71),('5819','2013-07-09','12:30:00',3.67),('5819','2013-07-09','12:35:00',3.7),('5819','2013-07-09','12:40:00',3.71),('5819','2013-07-09','12:45:00',3.67),('5819','2013-07-09','12:50:00',3.71),('5819','2013-07-09','12:55:00',3.74),('5819','2013-07-09','13:00:00',3.74),('5819','2013-07-09','13:05:00',3.53),('5819','2013-07-09','13:10:00',3.87),('5819','2013-07-09','13:15:00',3.92),('5819','2013-07-09','13:20:00',3.87),('5819','2013-07-09','13:25:00',3.92),('5819','2013-07-09','13:30:00',3.97),('5819','2013-07-09','13:35:00',3.74),('5819','2013-07-09','13:40:00',3.69),('5819','2013-07-09','13:45:00',3.1),('5819','2013-07-09','13:50:00',2.91),('5819','2013-07-09','13:55:00',2.91),('5819','2013-07-09','14:00:00',2.85),('5819','2013-07-09','14:05:00',2.84),('5819','2013-07-09','14:10:00',3.13),('5819','2013-07-09','14:15:00',3.13),('5819','2013-07-09','14:20:00',2.39),('5819','2013-07-09','14:25:00',1.88),('5819','2013-07-09','14:30:00',1.24),('5819','2013-07-08','07:35:00',1.12),('5819','2013-07-08','07:40:00',1.48),('5819','2013-07-08','07:45:00',1.32),('5819','2013-07-08','07:50:00',1.26),('5819','2013-07-08','07:55:00',1.24),('5819','2013-07-08','08:00:00',1.25),('5819','2013-07-08','08:05:00',1.27),('5819','2013-07-08','08:10:00',1.53),('5819','2013-07-08','08:15:00',1.69),('5819','2013-07-08','08:20:00',1.81),('5819','2013-07-08','08:25:00',1.9),('5819','2013-07-08','08:30:00',1.97),('5819','2013-07-08','08:35:00',2.04),('5819','2013-07-08','08:40:00',2.1),('5819','2013-07-08','08:45:00',2.16),('5819','2013-07-08','08:50:00',2.22),('5819','2013-07-08','08:55:00',2.3),('5819','2013-07-08','09:00:00',2.36),('5819','2013-07-08','09:05:00',2.42),('5819','2013-07-08','09:10:00',2.48),('5819','2013-07-08','09:15:00',2.53),('5819','2013-07-08','09:20:00',2.59),('5819','2013-07-08','09:25:00',2.61),('5819','2013-07-08','09:30:00',2.73),('5819','2013-07-08','09:35:00',2.84),('5819','2013-07-08','09:40:00',2.88),('5819','2013-07-08','09:45:00',2.89),('5819','2013-07-08','09:50:00',2.89),('5819','2013-07-08','09:55:00',2.99),('5819','2013-07-08','10:00:00',3.05),('5819','2013-07-08','10:05:00',3.08),('5819','2013-07-08','10:10:00',3.08),('5819','2013-07-08','10:15:00',3.15),('5819','2013-07-08','10:20:00',3.18),('5819','2013-07-08','10:25:00',3.24),('5819','2013-07-08','10:30:00',3.17),('5819','2013-07-08','10:35:00',3.33),('5819','2013-07-08','10:40:00',3.32),('5819','2013-07-08','10:45:00',3.33),('5819','2013-07-08','10:50:00',3.35),('5819','2013-07-08','10:55:00',3.36),('5819','2013-07-08','11:00:00',3.4),('5819','2013-07-08','11:05:00',3.44),('5819','2013-07-08','11:10:00',3.51),('5819','2013-07-08','11:15:00',3.58),('5819','2013-07-08','11:20:00',3.65),('5819','2013-07-08','11:25:00',3.69),('5819','2013-07-08','11:30:00',3.73),('5819','2013-07-08','11:35:00',3.73),('5819','2013-07-08','11:40:00',3.49),('5819','2013-07-08','11:45:00',3.76),('5819','2013-07-08','11:50:00',3.73),('5819','2013-07-08','11:55:00',3.71),('5819','2013-07-08','12:00:00',3.71),('5819','2013-07-08','12:05:00',3.76),('5819','2013-07-08','12:10:00',3.83),('5819','2013-07-08','12:15:00',3.85),('5819','2013-07-08','12:20:00',3.96),('5819','2013-07-08','12:25:00',3.82),('5819','2013-07-08','12:30:00',3.67),('5819','2013-07-08','12:35:00',3.83),('5819','2013-07-08','12:40:00',3.81),('5819','2013-07-08','12:45:00',3.83),('5819','2013-07-08','12:50:00',3.84),('5819','2013-07-08','12:55:00',3.9),('5819','2013-07-08','13:00:00',3.6),('5819','2013-07-08','13:05:00',4.05),('5819','2013-07-08','13:10:00',4.3),('5819','2013-07-08','13:15:00',3.28),('5819','2013-07-08','13:20:00',2.28),('5819','2013-07-08','13:25:00',1.07),('5819','2013-07-08','14:35:00',1),('5819','2013-07-08','14:40:00',1.01),('5819','2013-07-07','07:25:00',1.06),('5819','2013-07-07','07:30:00',1.14),('5819','2013-07-07','07:35:00',1.21),('5819','2013-07-07','07:40:00',1.29),('5819','2013-07-07','07:45:00',1.38),('5819','2013-07-07','07:50:00',1.46),('5819','2013-07-07','07:55:00',1.54),('5819','2013-07-07','08:00:00',1.63),('5819','2013-07-07','08:05:00',1.71),('5819','2013-07-07','08:10:00',1.8),('5819','2013-07-07','08:15:00',1.62),('5819','2013-07-07','08:20:00',1.52),('5819','2013-07-07','08:25:00',1.6),('5819','2013-07-07','08:30:00',2.06),('5819','2013-07-07','08:35:00',2.02),('5819','2013-07-07','08:40:00',1.02),('5819','2013-07-07','08:45:00',1.18),('5819','2013-07-07','08:50:00',2.17),('5819','2013-07-07','08:55:00',2.52),('5819','2013-07-07','09:00:00',2.5),('5819','2013-07-07','09:05:00',2.28),('5819','2013-07-07','09:10:00',2.26),('5819','2013-07-07','09:15:00',2.2),('5819','2013-07-07','09:20:00',1.76),('5819','2013-07-07','09:25:00',2.31),('5819','2013-07-07','09:30:00',2.77),('5819','2013-07-07','09:35:00',2.88),('5819','2013-07-07','09:40:00',2.66),('5819','2013-07-07','09:45:00',3.18),('5819','2013-07-07','09:50:00',3.16),('5819','2013-07-07','09:55:00',3.22),('5819','2013-07-07','10:00:00',3.21),('5819','2013-07-07','10:05:00',3.04),('5819','2013-07-07','10:10:00',3.18),('5819','2013-07-07','10:15:00',2.97),('5819','2013-07-07','10:20:00',3.22),('5819','2013-07-07','10:25:00',3.1),('5819','2013-07-07','10:30:00',3.07),('5819','2013-07-07','10:35:00',3.54),('5819','2013-07-07','10:40:00',3.25),('5819','2013-07-07','10:45:00',3.53),('5819','2013-07-07','10:50:00',3.56),('5819','2013-07-07','10:55:00',3.53),('5819','2013-07-07','11:00:00',3.55),('5819','2013-07-07','11:05:00',3.59),('5819','2013-07-07','11:10:00',3.65),('5819','2013-07-07','11:15:00',3.51),('5819','2013-07-07','11:20:00',3.45),('5819','2013-07-07','11:25:00',3.13),('5819','2013-07-07','11:30:00',3.27),('5819','2013-07-07','11:35:00',3.22),('5819','2013-07-07','11:40:00',3.21),('5819','2013-07-07','11:45:00',2.75),('5819','2013-07-07','11:50:00',2.57),('5819','2013-07-07','11:55:00',1.94),('5819','2013-07-07','12:00:00',2.9),('5819','2013-07-07','12:05:00',3.64),('5819','2013-07-07','12:10:00',3.66),('5819','2013-07-07','12:15:00',3.91),('5819','2013-07-07','12:20:00',3.78),('5819','2013-07-07','12:25:00',3.57),('5819','2013-07-07','12:30:00',3.63),('5819','2013-07-07','12:35:00',3.84),('5819','2013-07-07','12:40:00',3.93),('5819','2013-07-07','12:45:00',3.9),('5819','2013-07-07','12:50:00',3.82),('5819','2013-07-07','12:55:00',3.98),('5819','2013-07-07','13:00:00',3.91),('5819','2013-07-07','13:05:00',3.89),('5819','2013-07-07','13:10:00',3.89),('5819','2013-07-07','13:15:00',3.82),('5819','2013-07-07','13:20:00',3.82),('5819','2013-07-07','13:25:00',3.71),('5819','2013-07-07','13:30:00',3.6),('5819','2013-07-07','13:35:00',3.9),('5819','2013-07-07','13:40:00',2.66),('5819','2013-07-07','13:45:00',4.12),('5819','2013-07-07','13:50:00',4.08),('5819','2013-07-07','13:55:00',3.58),('5819','2013-07-07','14:00:00',3.21),('5819','2013-07-07','14:05:00',3.38),('5819','2013-07-07','14:10:00',2.1),('5819','2013-07-07','14:15:00',1.72),('5819','2013-07-07','14:20:00',1.09),('5819','2013-07-07','15:05:00',1),('5819','2013-07-06','07:25:00',1),('5819','2013-07-06','07:30:00',1.08),('5819','2013-07-06','07:35:00',1.14),('5819','2013-07-06','07:40:00',1.22),('5819','2013-07-06','07:45:00',1.31),('5819','2013-07-06','07:50:00',1.4),('5819','2013-07-06','07:55:00',1.48),('5819','2013-07-06','08:00:00',1.56),('5819','2013-07-06','08:05:00',1.64),('5819','2013-07-06','08:10:00',1.72),('5819','2013-07-06','08:15:00',1.79),('5819','2013-07-06','08:20:00',1.86),('5819','2013-07-06','08:25:00',1.94),('5819','2013-07-06','08:30:00',2.01),('5819','2013-07-06','08:35:00',2.08),('5819','2013-07-06','08:40:00',2.15),('5819','2013-07-06','08:45:00',2.21),('5819','2013-07-06','08:50:00',2.28),('5819','2013-07-06','08:55:00',2.35),('5819','2013-07-06','09:00:00',2.42),('5819','2013-07-06','09:05:00',2.48),('5819','2013-07-06','09:10:00',2.55),('5819','2013-07-06','09:15:00',2.62),('5819','2013-07-06','09:20:00',2.68),('5819','2013-07-06','09:25:00',2.73),('5819','2013-07-06','09:30:00',2.77),('5819','2013-07-06','09:35:00',2.81),('5819','2013-07-06','09:40:00',2.86),('5819','2013-07-06','09:45:00',2.91),('5819','2013-07-06','09:50:00',2.97),('5819','2013-07-06','09:55:00',3.04),('5819','2013-07-06','10:00:00',3.08),('5819','2013-07-06','10:05:00',3.15),('5819','2013-07-06','10:10:00',3.2),('5819','2013-07-06','10:15:00',3.23),('5819','2013-07-06','10:20:00',3.26),('5819','2013-07-06','10:25:00',3.3),('5819','2013-07-06','10:30:00',3.34),('5819','2013-07-06','10:35:00',3.36),('5819','2013-07-06','10:40:00',3.39),('5819','2013-07-06','10:45:00',3.44),('5819','2013-07-06','10:50:00',3.51),('5819','2013-07-06','10:55:00',3.53),('5819','2013-07-06','11:00:00',3.55),('5819','2013-07-06','11:05:00',3.58),('5819','2013-07-06','11:10:00',3.59),('5819','2013-07-06','11:15:00',3.57),('5819','2013-07-06','11:20:00',3.63),('5819','2013-07-06','11:25:00',3.66),('5819','2013-07-06','11:30:00',3.64),('5819','2013-07-06','11:35:00',3.66),('5819','2013-07-06','11:40:00',3.65),('5819','2013-07-06','11:45:00',3.68),('5819','2013-07-06','11:50:00',3.7),('5819','2013-07-06','11:55:00',3.69),('5819','2013-07-06','12:00:00',3.72),('5819','2013-07-06','12:05:00',3.76),('5819','2013-07-06','12:10:00',3.8),('5819','2013-07-06','12:15:00',3.8),('5819','2013-07-06','12:20:00',3.83),('5819','2013-07-06','12:25:00',3.79),('5819','2013-07-06','12:30:00',3.84),('5819','2013-07-06','12:35:00',3.8),('5819','2013-07-06','12:40:00',3.83),('5819','2013-07-06','12:45:00',3.84),('5819','2013-07-06','12:50:00',3.82),('5819','2013-07-06','12:55:00',3.84),('5819','2013-07-06','13:00:00',3.85),('5819','2013-07-06','13:05:00',3.87),('5819','2013-07-06','13:10:00',3.89),('5819','2013-07-06','13:15:00',3.88),('5819','2013-07-06','13:20:00',3.84),('5819','2013-07-06','13:25:00',3.8),('5819','2013-07-06','13:30:00',3.83),('5819','2013-07-06','13:35:00',3.75),('5819','2013-07-06','13:40:00',3.78),('5819','2013-07-06','13:45:00',3.77),('5819','2013-07-06','13:50:00',3.7),('5819','2013-07-06','13:55:00',3.72),('5819','2013-07-06','14:00:00',3.74),('5819','2013-07-06','14:05:00',3.73),('5819','2013-07-06','14:10:00',3.67),('5819','2013-07-06','14:15:00',3.48),('5819','2013-07-06','14:20:00',3.74),('5819','2013-07-06','14:25:00',3.63),('5819','2013-07-06','14:30:00',3.57),('5819','2013-07-06','14:35:00',3.58),('5819','2013-07-06','14:40:00',3.53),('5819','2013-07-06','14:45:00',3.51),('5819','2013-07-06','14:50:00',3.43),('5819','2013-07-06','14:55:00',3.1),('5819','2013-07-06','15:00:00',3.46),('5819','2013-07-06','15:05:00',3.41),('5819','2013-07-06','15:10:00',3.38),('5819','2013-07-06','15:15:00',3.33),('5819','2013-07-06','15:20:00',3.32),('5819','2013-07-06','15:25:00',3.3),('5819','2013-07-06','15:30:00',2.94),('5819','2013-07-06','15:35:00',1.17),('5819','2013-07-06','16:55:00',1.11),('5819','2013-07-05','07:25:00',1.03),('5819','2013-07-05','07:30:00',1.05),('5819','2013-07-05','07:35:00',1.17),('5819','2013-07-05','07:40:00',1.24),('5819','2013-07-05','07:45:00',1.31),('5819','2013-07-05','07:50:00',1.4),('5819','2013-07-05','07:55:00',1.47),('5819','2013-07-05','08:00:00',1.58),('5819','2013-07-05','08:05:00',1.67),('5819','2013-07-05','08:10:00',1.73),('5819','2013-07-05','08:15:00',1.81),('5819','2013-07-05','08:20:00',1.87),('5819','2013-07-05','08:25:00',1.94),('5819','2013-07-05','08:30:00',2.01),('5819','2013-07-05','08:35:00',2.08),('5819','2013-07-05','08:40:00',2.15),('5819','2013-07-05','08:45:00',2.21),('5819','2013-07-05','08:50:00',2.29),('5819','2013-07-05','08:55:00',2.34),('5819','2013-07-05','09:00:00',2.41),('5819','2013-07-05','09:05:00',2.46),('5819','2013-07-05','09:10:00',2.51),('5819','2013-07-05','09:15:00',2.57),('5819','2013-07-05','09:20:00',2.65),('5819','2013-07-05','09:25:00',2.72),('5819','2013-07-05','09:30:00',2.78),('5819','2013-07-05','09:35:00',2.84),('5819','2013-07-05','09:40:00',2.89),('5819','2013-07-05','09:45:00',2.93),('5819','2013-07-05','09:50:00',2.97),('5819','2013-07-05','09:55:00',3.02),('5819','2013-07-05','10:00:00',3.06),('5819','2013-07-05','10:05:00',3.1),('5819','2013-07-05','10:10:00',3.15),('5819','2013-07-05','10:15:00',3.2),('5819','2013-07-05','10:20:00',3.23),('5819','2013-07-05','10:25:00',3.26),('5819','2013-07-05','10:30:00',3.3),('5819','2013-07-05','10:35:00',3.34),('5819','2013-07-05','10:40:00',3.35),('5819','2013-07-05','10:45:00',3.38),('5819','2013-07-05','10:50:00',3.41),('5819','2013-07-05','10:55:00',3.44),('5819','2013-07-05','11:00:00',3.47),('5819','2013-07-05','11:05:00',3.48),('5819','2013-07-05','11:10:00',3.52),('5819','2013-07-05','11:15:00',3.54),('5819','2013-07-05','11:20:00',3.56),('5819','2013-07-05','11:25:00',3.59),('5819','2013-07-05','11:30:00',3.63),('5819','2013-07-05','11:35:00',3.64),('5819','2013-07-05','11:40:00',3.62),('5819','2013-07-05','11:45:00',3.62),('5819','2013-07-05','11:50:00',3.7),('5819','2013-07-05','11:55:00',3.68),('5819','2013-07-05','12:00:00',3.68),('5819','2013-07-05','12:05:00',3.68),('5819','2013-07-05','12:10:00',3.68),('5819','2013-07-05','12:15:00',3.73),('5819','2013-07-05','12:20:00',3.75),('5819','2013-07-05','12:25:00',2.4),('5819','2013-07-05','12:30:00',3.56),('5819','2013-07-05','12:35:00',2.81),('5819','2013-07-05','12:40:00',3.77),('5819','2013-07-05','12:45:00',3.89),('5819','2013-07-05','12:50:00',3.68),('5819','2013-07-05','12:55:00',3.42),('5819','2013-07-05','13:00:00',3.81),('5819','2013-07-05','13:05:00',2.6),('5819','2013-07-05','13:10:00',3.89),('5819','2013-07-05','13:15:00',3.49),('5819','2013-07-05','13:20:00',3.43),('5819','2013-07-05','13:25:00',3.69),('5819','2013-07-05','13:30:00',3.5),('5819','2013-07-05','13:35:00',3.83),('5819','2013-07-05','13:40:00',3.84),('5819','2013-07-05','13:45:00',3.75),('5819','2013-07-05','13:50:00',3.7),('5819','2013-07-05','13:55:00',3.75),('5819','2013-07-05','14:00:00',3.74),('5819','2013-07-05','14:05:00',3.33),('5819','2013-07-05','14:10:00',3.2),('5819','2013-07-05','14:15:00',3.67),('5819','2013-07-05','14:20:00',3.51),('5819','2013-07-05','14:25:00',3.62),('5819','2013-07-05','14:30:00',3.51),('5819','2013-07-05','14:35:00',3.38),('5819','2013-07-05','14:40:00',3.51),('5819','2013-07-05','14:45:00',3.01),('5819','2013-07-05','14:50:00',3.43),('5819','2013-07-05','14:55:00',3.37),('5819','2013-07-05','15:00:00',3.19),('5819','2013-07-05','15:05:00',3.35),('5819','2013-07-05','15:10:00',3.36),('5819','2013-07-05','15:15:00',2.77),('5819','2013-07-05','15:20:00',2.51),('5819','2013-07-05','15:25:00',2.42),('5819','2013-07-05','15:30:00',3.01),('5819','2013-07-05','15:35:00',3.15),('5819','2013-07-05','15:40:00',3.05),('5819','2013-07-05','15:45:00',3.06),('5819','2013-07-05','15:50:00',3),('5819','2013-07-05','15:55:00',2.87),('5819','2013-07-05','16:00:00',2.79),('5819','2013-07-05','16:05:00',2.78),('5819','2013-07-05','16:10:00',2.7),('5819','2013-07-05','16:15:00',2.63),('5819','2013-07-05','16:20:00',2.6),('5819','2013-07-05','16:25:00',2.52),('5819','2013-07-05','16:30:00',2.46),('5819','2013-07-05','16:35:00',2.39),('5819','2013-07-05','16:40:00',2.33),('5819','2013-07-05','16:45:00',2.3),('5819','2013-07-05','16:50:00',2.18),('5819','2013-07-05','16:55:00',1.97),('5819','2013-07-05','17:00:00',2.02),('5819','2013-07-05','17:05:00',1.99),('5819','2013-07-05','17:10:00',1.97),('5819','2013-07-05','17:15:00',1.94),('5819','2013-07-05','17:20:00',1.87),('5819','2013-07-05','17:25:00',1.76),('5819','2013-07-05','17:30:00',1.65),('5819','2013-07-05','17:35:00',1.53),('5819','2013-07-05','17:40:00',1.43),('5819','2013-07-05','17:45:00',1.32),('5819','2013-07-05','17:50:00',1.19),('5819','2013-07-05','17:55:00',1.16),('5819','2013-07-05','18:00:00',1.15),('5819','2013-07-05','18:05:00',1.06),('5819','2013-07-04','11:15:00',1.01),('5819','2013-07-04','11:35:00',1.14),('5819','2013-07-04','11:40:00',1.32),('5819','2013-07-04','11:45:00',1.52),('5819','2013-07-04','11:50:00',1.63),('5819','2013-07-04','11:55:00',1.49),('5819','2013-07-04','12:00:00',1.44),('5819','2013-07-04','12:05:00',1.41),('5819','2013-07-04','12:10:00',2.02),('5819','2013-07-04','12:15:00',2.76),('5819','2013-07-04','12:20:00',2.48),('5819','2013-07-04','12:25:00',2.9),('5819','2013-07-04','12:30:00',2.85),('5819','2013-07-04','12:35:00',2.19),('5819','2013-07-04','12:40:00',1.64),('5819','2013-07-04','12:45:00',1.32),('5819','2013-07-04','12:50:00',1.05),('5819','2013-07-04','13:10:00',1.25),('5819','2013-07-04','13:15:00',1.44),('5819','2013-07-04','13:20:00',1.66),('5819','2013-07-04','13:25:00',1.93),('5819','2013-07-04','13:30:00',1.79),('5819','2013-07-04','13:35:00',1.88),('5819','2013-07-04','13:40:00',2.23),('5819','2013-07-04','13:45:00',2.01),('5819','2013-07-04','13:50:00',2.82),('5819','2013-07-04','13:55:00',2.51),('5819','2013-07-04','14:00:00',2.03),('5819','2013-07-04','14:05:00',1.97),('5819','2013-07-04','14:10:00',1.94),('5819','2013-07-04','14:15:00',1.99),('5819','2013-07-04','14:20:00',2.04),('5819','2013-07-04','14:25:00',1.74),('5819','2013-07-04','14:30:00',1.66),('5819','2013-07-04','14:35:00',1.7),('5819','2013-07-04','14:40:00',2.84),('5819','2013-07-04','14:45:00',4.05),('5819','2013-07-04','14:50:00',2.16),('5819','2013-07-04','14:55:00',2.23),('5819','2013-07-04','15:00:00',3.97),('5819','2013-07-04','15:05:00',3.55),('5819','2013-07-04','15:10:00',2.61),('5819','2013-07-04','15:15:00',3.82),('5819','2013-07-04','15:20:00',3.65),('5819','2013-07-04','15:25:00',3.58),('5819','2013-07-04','15:30:00',2.39),('5819','2013-07-04','15:35:00',2.64),('5819','2013-07-04','15:40:00',2.73),('5819','2013-07-04','15:45:00',2.71),('5819','2013-07-04','15:50:00',2.01),('5819','2013-07-04','15:55:00',2.14),('5819','2013-07-04','16:00:00',2.22),('5819','2013-07-04','16:05:00',1.92),('5819','2013-07-04','16:10:00',1.82),('5819','2013-07-04','16:15:00',1.68),('5819','2013-07-04','16:20:00',1.69),('5819','2013-07-04','16:25:00',1.75),('5819','2013-07-04','16:30:00',1.77),('5819','2013-07-04','16:35:00',1.72),('5819','2013-07-04','16:40:00',1.41),('5819','2013-07-04','16:45:00',1.33),('5819','2013-07-04','16:50:00',1.4),('5819','2013-07-04','16:55:00',1.35),('5819','2013-07-04','17:00:00',1.19),('5819','2013-07-04','17:05:00',1.13),('5819','2013-07-04','17:10:00',1.75),('5819','2013-07-04','17:15:00',2.09),('5819','2013-07-04','17:20:00',2.13),('5819','2013-07-04','17:25:00',2.01),('5819','2013-07-04','17:30:00',1.7),('5819','2013-07-04','17:35:00',1.66),('5819','2013-07-04','17:40:00',1.79),('5819','2013-07-04','17:45:00',1.69),('5819','2013-07-04','17:50:00',1.52),('5819','2013-07-04','17:55:00',1.44),('5819','2013-07-04','18:00:00',1.47),('5819','2013-07-04','18:05:00',1.43),('5819','2013-07-04','18:10:00',1.38),('5819','2013-07-04','18:15:00',1.31),('5819','2013-07-04','18:20:00',1.06),('5819','2013-07-04','18:25:00',1),('5819','2013-07-03','07:20:00',1.01),('5819','2013-07-03','07:25:00',1.08),('5819','2013-07-03','07:30:00',1.16),('5819','2013-07-03','07:35:00',1.24),('5819','2013-07-03','07:40:00',1.32),('5819','2013-07-03','07:45:00',1.42),('5819','2013-07-03','07:50:00',1.5),('5819','2013-07-03','07:55:00',1.58),('5819','2013-07-03','08:00:00',1.66),('5819','2013-07-03','08:05:00',1.74),('5819','2013-07-03','08:10:00',1.8),('5819','2013-07-03','08:15:00',1.88),('5819','2013-07-03','08:20:00',1.96),('5819','2013-07-03','08:25:00',2.03),('5819','2013-07-03','08:30:00',2.12),('5819','2013-07-03','08:35:00',2.19),('5819','2013-07-03','08:40:00',2.26),('5819','2013-07-03','08:45:00',2.33),('5819','2013-07-03','08:50:00',2.4),('5819','2013-07-03','08:55:00',2.46),('5819','2013-07-03','09:00:00',2.5),('5819','2013-07-03','09:05:00',2.57),('5819','2013-07-03','09:10:00',2.63),('5819','2013-07-03','09:15:00',2.67),('5819','2013-07-03','09:20:00',2.73),('5819','2013-07-03','09:25:00',2.78),('5819','2013-07-03','09:30:00',2.84),('5819','2013-07-03','09:35:00',2.86),('5819','2013-07-03','09:40:00',2.9),('5819','2013-07-03','09:45:00',2.99),('5819','2013-07-03','09:50:00',3.04),('5819','2013-07-03','09:55:00',3.06),('5819','2013-07-03','10:00:00',3.12),('5819','2013-07-03','10:05:00',3.15),('5819','2013-07-03','10:10:00',3.12),('5819','2013-07-03','10:15:00',3.17),('5819','2013-07-03','10:20:00',3.17),('5819','2013-07-03','10:25:00',3.28),('5819','2013-07-03','10:30:00',3.36),('5819','2013-07-03','10:35:00',3.35),('5819','2013-07-03','10:40:00',3.38),('5819','2013-07-03','10:45:00',3.45),('5819','2013-07-03','10:50:00',3.49),('5819','2013-07-03','10:55:00',3.49),('5819','2013-07-03','11:00:00',3.53),('5819','2013-07-03','11:05:00',3.54),('5819','2013-07-03','11:10:00',3.57),('5819','2013-07-03','11:15:00',3.63),('5819','2013-07-03','11:20:00',3.66),('5819','2013-07-03','11:25:00',3.68),('5819','2013-07-03','11:30:00',3.67),('5819','2013-07-03','11:35:00',3.68),('5819','2013-07-03','11:40:00',3.67),('5819','2013-07-03','11:45:00',3.74),('5819','2013-07-03','11:50:00',3.79),('5819','2013-07-03','11:55:00',3.79),('5819','2013-07-03','12:00:00',3.83),('5819','2013-07-03','12:05:00',3.87),('5819','2013-07-03','12:10:00',3.81),('5819','2013-07-03','12:15:00',3.87),('5819','2013-07-03','12:20:00',3.88),('5819','2013-07-03','12:25:00',3.87),('5819','2013-07-03','12:30:00',3.87),('5819','2013-07-03','12:35:00',3.9),('5819','2013-07-03','12:40:00',3.9),('5819','2013-07-03','12:45:00',3.85),('5819','2013-07-03','12:50:00',3.88),('5819','2013-07-03','12:55:00',3.87),('5819','2013-07-03','13:00:00',3.91),('5819','2013-07-03','13:05:00',3.93),('5819','2013-07-03','13:10:00',3.92),('5819','2013-07-03','13:15:00',3.9),('5819','2013-07-03','13:20:00',3.9),('5819','2013-07-03','13:25:00',3.86),('5819','2013-07-03','13:30:00',3.87),('5819','2013-07-03','13:35:00',3.82),('5819','2013-07-03','13:40:00',3.82),('5819','2013-07-03','13:45:00',3.82),('5819','2013-07-03','13:50:00',3.8),('5819','2013-07-03','13:55:00',3.75),('5819','2013-07-03','14:00:00',3.74),('5819','2013-07-03','14:05:00',3.71),('5819','2013-07-03','14:10:00',3.69),('5819','2013-07-03','14:15:00',3.68),('5819','2013-07-03','14:20:00',3.7),('5819','2013-07-03','14:25:00',3.66),('5819','2013-07-03','14:30:00',3.65),('5819','2013-07-03','14:35:00',3.61),('5819','2013-07-03','14:40:00',3.57),('5819','2013-07-03','14:45:00',3.54),('5819','2013-07-03','14:50:00',3.51),('5819','2013-07-03','14:55:00',3.47),('5819','2013-07-03','15:00:00',3.45),('5819','2013-07-03','15:05:00',3.43),('5819','2013-07-03','15:10:00',3.38),('5819','2013-07-03','15:15:00',3.33),('5819','2013-07-03','15:20:00',3.28),('5819','2013-07-03','15:25:00',3.24),('5819','2013-07-03','15:30:00',3.21),('5819','2013-07-03','15:35:00',3.16),('5819','2013-07-03','15:40:00',3.1),('5819','2013-07-03','15:45:00',3.05),('5819','2013-07-03','15:50:00',3),('5819','2013-07-03','15:55:00',2.95),('5819','2013-07-03','16:00:00',2.88),('5819','2013-07-03','16:05:00',2.82),('5819','2013-07-03','16:10:00',2.77),('5819','2013-07-03','16:15:00',2.7),('5819','2013-07-03','16:20:00',2.64),('5819','2013-07-03','16:25:00',2.58),('5819','2013-07-03','16:30:00',2.52),('5819','2013-07-03','16:35:00',2.45),('5819','2013-07-03','16:40:00',2.39),('5819','2013-07-03','16:45:00',2.33),('5819','2013-07-03','16:50:00',2.26),('5819','2013-07-03','16:55:00',2.19),('5819','2013-07-03','17:00:00',2.11),('5819','2013-07-03','17:05:00',2.04),('5819','2013-07-03','17:10:00',1.97),('5819','2013-07-03','17:15:00',1.89),('5819','2013-07-03','17:20:00',1.82),('5819','2013-07-03','17:25:00',1.74),('5819','2013-07-03','17:30:00',1.66),('5819','2013-07-03','17:35:00',1.58),('5819','2013-07-03','17:40:00',1.51),('5819','2013-07-03','17:45:00',1.42),('5819','2013-07-03','17:50:00',1.17),('5819','2013-07-03','17:55:00',1.16),('5819','2013-07-03','18:00:00',1.14),('5819','2013-07-03','18:05:00',1.05),('5819','2013-07-02','07:25:00',1.04),('5819','2013-07-02','07:30:00',1.12),('5819','2013-07-02','07:35:00',1.2),('5819','2013-07-02','07:40:00',1.29),('5819','2013-07-02','07:45:00',1.38),('5819','2013-07-02','07:50:00',1.45),('5819','2013-07-02','07:55:00',1.53),('5819','2013-07-02','08:00:00',1.61),('5819','2013-07-02','08:05:00',1.7),('5819','2013-07-02','08:10:00',1.79),('5819','2013-07-02','08:15:00',1.86),('5819','2013-07-02','08:20:00',1.93),('5819','2013-07-02','08:25:00',2.02),('5819','2013-07-02','08:30:00',2.08),('5819','2013-07-02','08:35:00',2.14),('5819','2013-07-02','08:40:00',2.21),('5819','2013-07-02','08:45:00',2.29),('5819','2013-07-02','08:50:00',2.34),('5819','2013-07-02','08:55:00',2.39),('5819','2013-07-02','09:00:00',2.46),('5819','2013-07-02','09:05:00',2.54),('5819','2013-07-02','09:10:00',2.61),('5819','2013-07-02','09:15:00',2.67),('5819','2013-07-02','09:20:00',2.73),('5819','2013-07-02','09:25:00',2.78),('5819','2013-07-02','09:30:00',2.84),('5819','2013-07-02','09:35:00',2.87),('5819','2013-07-02','09:40:00',2.91),('5819','2013-07-02','09:45:00',2.96),('5819','2013-07-02','09:50:00',3),('5819','2013-07-02','09:55:00',3.05),('5819','2013-07-02','10:00:00',3.11),('5819','2013-07-02','10:05:00',3.18),('5819','2013-07-02','10:10:00',3.19),('5819','2013-07-02','10:15:00',3.21),('5819','2013-07-02','10:20:00',3.24),('5819','2013-07-02','10:25:00',3.28),('5819','2013-07-02','10:30:00',3.33),('5819','2013-07-02','10:35:00',3.38),('5819','2013-07-02','10:40:00',3.41),('5819','2013-07-02','10:45:00',3.43),('5819','2013-07-02','10:50:00',3.44),('5819','2013-07-02','10:55:00',3.44),('5819','2013-07-02','11:00:00',3.47),('5819','2013-07-02','11:05:00',3.47),('5819','2013-07-02','11:10:00',3.49),('5819','2013-07-02','11:15:00',3.5),('5819','2013-07-02','11:20:00',3.51),('5819','2013-07-02','11:25:00',3.53),('5819','2013-07-02','11:30:00',3.57),('5819','2013-07-02','11:35:00',3.62),('5819','2013-07-02','11:40:00',3.63),('5819','2013-07-02','11:45:00',3.59),('5819','2013-07-02','11:50:00',3.59),('5819','2013-07-02','11:55:00',3.63),('5819','2013-07-02','12:00:00',3.62),('5819','2013-07-02','12:05:00',3.55),('5819','2013-07-02','12:10:00',3.7),('5819','2013-07-02','12:15:00',3.66),('5819','2013-07-02','12:20:00',3.63),('5819','2013-07-02','12:25:00',3.55),('5819','2013-07-02','12:30:00',3.66),('5819','2013-07-02','12:35:00',3.75),('5819','2013-07-02','12:40:00',3.82),('5819','2013-07-02','12:45:00',3.84),('5819','2013-07-02','12:50:00',3.85),('5819','2013-07-02','12:55:00',1.76),('5819','2013-07-02','13:00:00',3.16),('5819','2013-07-02','13:05:00',1.27),('5819','2013-07-02','13:10:00',4),('5819','2013-07-02','13:15:00',3.99),('5819','2013-07-02','13:20:00',3.91),('5819','2013-07-02','13:25:00',3.99),('5819','2013-07-02','13:30:00',3.9),('5819','2013-07-02','13:35:00',3.84),('5819','2013-07-02','13:40:00',3.86),('5819','2013-07-02','13:45:00',3.6),('5819','2013-07-02','13:50:00',3.57),('5819','2013-07-02','13:55:00',3.64),('5819','2013-07-02','14:00:00',3.61),('5819','2013-07-02','14:05:00',3.59),('5819','2013-07-02','14:10:00',3.57),('5819','2013-07-02','14:15:00',3.58),('5819','2013-07-02','14:20:00',3.57),('5819','2013-07-02','14:25:00',3.54),('5819','2013-07-02','14:30:00',3.52),('5819','2013-07-02','14:35:00',3.52),('5819','2013-07-02','14:40:00',3.47),('5819','2013-07-02','14:45:00',3.44),('5819','2013-07-02','14:50:00',3.41),('5819','2013-07-02','14:55:00',3.38),('5819','2013-07-02','15:00:00',3.34),('5819','2013-07-02','15:05:00',3.33),('5819','2013-07-02','15:10:00',3.3),('5819','2013-07-02','15:15:00',3.24),('5819','2013-07-02','15:20:00',3.21),('5819','2013-07-02','15:25:00',3.18),('5819','2013-07-02','15:30:00',3.14),('5819','2013-07-02','15:35:00',3.09),('5819','2013-07-02','15:40:00',3.05),('5819','2013-07-02','15:45:00',2.98),('5819','2013-07-02','15:50:00',2.92),('5819','2013-07-02','15:55:00',2.86),('5819','2013-07-02','16:00:00',2.82),('5819','2013-07-02','16:05:00',2.77),('5819','2013-07-02','16:10:00',2.71),('5819','2013-07-02','16:15:00',2.65),('5819','2013-07-02','16:20:00',2.59),('5819','2013-07-02','16:25:00',2.52),('5819','2013-07-02','16:30:00',2.46),('5819','2013-07-02','16:35:00',2.38),('5819','2013-07-02','16:40:00',2.31),('5819','2013-07-02','16:45:00',2.24),('5819','2013-07-02','16:50:00',2.18),('5819','2013-07-02','16:55:00',2.11),('5819','2013-07-02','17:00:00',2.07),('5819','2013-07-02','17:05:00',2),('5819','2013-07-02','17:10:00',1.91),('5819','2013-07-02','17:15:00',1.84),('5819','2013-07-02','17:20:00',1.77),('5819','2013-07-02','17:25:00',1.7),('5819','2013-07-02','17:30:00',1.61),('5819','2013-07-02','17:35:00',1.54),('5819','2013-07-02','17:40:00',1.46),('5819','2013-07-02','17:45:00',1.36),('5819','2013-07-02','17:50:00',1.17),('5819','2013-07-02','17:55:00',1.11),('5819','2013-07-02','18:00:00',1.11),('5819','2013-07-02','18:05:00',1.04),('5819','2013-07-01','07:25:00',1.06),('5819','2013-07-01','07:30:00',1.14),('5819','2013-07-01','07:35:00',1.22),('5819','2013-07-01','07:40:00',1.29),('5819','2013-07-01','07:45:00',1.37),('5819','2013-07-01','07:50:00',1.47),('5819','2013-07-01','07:55:00',1.56),('5819','2013-07-01','08:00:00',1.65),('5819','2013-07-01','08:05:00',1.74),('5819','2013-07-01','08:10:00',1.81),('5819','2013-07-01','08:15:00',1.89),('5819','2013-07-01','08:20:00',1.97),('5819','2013-07-01','08:25:00',2.05),('5819','2013-07-01','08:30:00',2.13),('5819','2013-07-01','08:35:00',2.2),('5819','2013-07-01','08:40:00',2.27),('5819','2013-07-01','08:45:00',2.34),('5819','2013-07-01','08:50:00',2.41),('5819','2013-07-01','08:55:00',2.47),('5819','2013-07-01','09:00:00',2.54),('5819','2013-07-01','09:05:00',2.61),('5819','2013-07-01','09:10:00',2.68),('5819','2013-07-01','09:15:00',2.74),('5819','2013-07-01','09:20:00',2.8),('5819','2013-07-01','09:25:00',2.86),('5819','2013-07-01','09:30:00',2.93),('5819','2013-07-01','09:35:00',2.98),('5819','2013-07-01','09:40:00',3.01),('5819','2013-07-01','09:45:00',3.05),('5819','2013-07-01','09:50:00',3.1),('5819','2013-07-01','09:55:00',3.13),('5819','2013-07-01','10:00:00',3.17),('5819','2013-07-01','10:05:00',3.22),('5819','2013-07-01','10:10:00',3.27),('5819','2013-07-01','10:15:00',3.34),('5819','2013-07-01','10:20:00',3.36),('5819','2013-07-01','10:25:00',3.4),('5819','2013-07-01','10:30:00',3.43),('5819','2013-07-01','10:35:00',3.47),('5819','2013-07-01','10:40:00',3.53),('5819','2013-07-01','10:45:00',3.56),('5819','2013-07-01','10:50:00',3.58),('5819','2013-07-01','10:55:00',3.6),('5819','2013-07-01','11:00:00',3.64),('5819','2013-07-01','11:05:00',3.68),('5819','2013-07-01','11:10:00',3.73),('5819','2013-07-01','11:15:00',3.75),('5819','2013-07-01','11:20:00',3.76),('5819','2013-07-01','11:25:00',3.78),('5819','2013-07-01','11:30:00',3.8),('5819','2013-07-01','11:35:00',3.79),('5819','2013-07-01','11:40:00',3.79),('5819','2013-07-01','11:45:00',3.81),('5819','2013-07-01','11:50:00',3.83),('5819','2013-07-01','11:55:00',3.86),('5819','2013-07-01','12:00:00',3.86),('5819','2013-07-01','12:05:00',3.84),('5819','2013-07-01','12:10:00',3.82),('5819','2013-07-01','12:15:00',3.85),('5819','2013-07-01','12:20:00',3.85),('5819','2013-07-01','12:25:00',3.84),('5819','2013-07-01','12:30:00',3.87),('5819','2013-07-01','12:35:00',3.86),('5819','2013-07-01','12:40:00',3.83),('5819','2013-07-01','12:45:00',3.86),('5819','2013-07-01','12:50:00',3.89),('5819','2013-07-01','12:55:00',3.92),('5819','2013-07-01','13:00:00',3.91),('5819','2013-07-01','13:05:00',3.87),('5819','2013-07-01','13:10:00',3.88),('5819','2013-07-01','13:15:00',3.86),('5819','2013-07-01','13:20:00',3.88),('5819','2013-07-01','13:25:00',3.87),('5819','2013-07-01','13:30:00',3.83),('5819','2013-07-01','13:35:00',3.79),('5819','2013-07-01','13:40:00',3.74),('5819','2013-07-01','13:45:00',3.7),('5819','2013-07-01','13:50:00',3.73),('5819','2013-07-01','13:55:00',3.68),('5819','2013-07-01','14:00:00',3.68),('5819','2013-07-01','14:05:00',3.74),('5819','2013-07-01','14:10:00',3.75),('5819','2013-07-01','14:15:00',3.7),('5819','2013-07-01','14:20:00',3.67),('5819','2013-07-01','14:25:00',3.63),('5819','2013-07-01','14:30:00',3.6),('5819','2013-07-01','14:35:00',3.55),('5819','2013-07-01','14:40:00',3.55),('5819','2013-07-01','14:45:00',3.52),('5819','2013-07-01','14:50:00',3.45),('5819','2013-07-01','14:55:00',3.41),('5819','2013-07-01','15:00:00',3.38),('5819','2013-07-01','15:05:00',3.3),('5819','2013-07-01','15:10:00',3.27),('5819','2013-07-01','15:15:00',3.25),('5819','2013-07-01','15:20:00',3.22),('5819','2013-07-01','15:25:00',3.16),('5819','2013-07-01','15:30:00',3.11),('5819','2013-07-01','15:35:00',3.06),('5819','2013-07-01','15:40:00',2.99),('5819','2013-07-01','15:45:00',2.96),('5819','2013-07-01','15:50:00',2.9),('5819','2013-07-01','15:55:00',2.85),('5819','2013-07-01','16:00:00',2.81),('5819','2013-07-01','16:05:00',2.74),('5819','2013-07-01','16:10:00',2.7),('5819','2013-07-01','16:15:00',2.62),('5819','2013-07-01','16:20:00',2.53),('5819','2013-07-01','16:25:00',2.48),('5819','2013-07-01','16:30:00',2.41),('5819','2013-07-01','16:35:00',2.35),('5819','2013-07-01','16:40:00',2.28),('5819','2013-07-01','16:45:00',2.23),('5819','2013-07-01','16:50:00',2.18),('5819','2013-07-01','16:55:00',2.11),('5819','2013-07-01','17:00:00',2.06),('5819','2013-07-01','17:05:00',1.98),('5819','2013-07-01','17:10:00',1.91),('5819','2013-07-01','17:15:00',1.84),('5819','2013-07-01','17:20:00',1.75),('5819','2013-07-01','17:25:00',1.67),('5819','2013-07-01','17:30:00',1.59),('5819','2013-07-01','17:35:00',1.51),('5819','2013-07-01','17:40:00',1.44),('5819','2013-07-01','17:45:00',1.37),('5819','2013-07-01','17:50:00',1.22),('5819','2013-07-01','17:55:00',1.13),('5819','2013-07-01','18:00:00',1.05),('5819','2013-07-01','18:05:00',1.02),('5819','2013-06-30','07:20:00',1.08),('5819','2013-06-30','07:25:00',1.15),('5819','2013-06-30','07:30:00',1.24),('5819','2013-06-30','07:35:00',1.32),('5819','2013-06-30','07:40:00',1.41),('5819','2013-06-30','07:45:00',1.49),('5819','2013-06-30','07:50:00',1.57),('5819','2013-06-30','07:55:00',1.65),('5819','2013-06-30','08:00:00',1.73),('5819','2013-06-30','08:05:00',1.81),('5819','2013-06-30','08:10:00',1.9),('5819','2013-06-30','08:15:00',1.97),('5819','2013-06-30','08:20:00',2.05),('5819','2013-06-30','08:25:00',2.13),('5819','2013-06-30','08:30:00',2.21),('5819','2013-06-30','08:35:00',2.28),('5819','2013-06-30','08:40:00',2.36),('5819','2013-06-30','08:45:00',2.43),('5819','2013-06-30','08:50:00',2.49),('5819','2013-06-30','08:55:00',2.56),('5819','2013-06-30','09:00:00',2.62),('5819','2013-06-30','09:05:00',2.69),('5819','2013-06-30','09:10:00',2.75),('5819','2013-06-30','09:15:00',2.81),('5819','2013-06-30','09:20:00',2.87),('5819','2013-06-30','09:25:00',2.92),('5819','2013-06-30','09:30:00',2.97),('5819','2013-06-30','09:35:00',3.02),('5819','2013-06-30','09:40:00',3.08),('5819','2013-06-30','09:45:00',3.14),('5819','2013-06-30','09:50:00',3.18),('5819','2013-06-30','09:55:00',3.23),('5819','2013-06-30','10:00:00',3.29),('5819','2013-06-30','10:05:00',3.33),('5819','2013-06-30','10:10:00',3.34),('5819','2013-06-30','10:15:00',3.39),('5819','2013-06-30','10:20:00',3.43),('5819','2013-06-30','10:25:00',3.46),('5819','2013-06-30','10:30:00',3.51),('5819','2013-06-30','10:35:00',3.56),('5819','2013-06-30','10:40:00',3.59),('5819','2013-06-30','10:45:00',3.6),('5819','2013-06-30','10:50:00',3.62),('5819','2013-06-30','10:55:00',3.66),('5819','2013-06-30','11:00:00',3.7),('5819','2013-06-30','11:05:00',3.72),('5819','2013-06-30','11:10:00',3.73),('5819','2013-06-30','11:15:00',3.73),('5819','2013-06-30','11:20:00',3.76),('5819','2013-06-30','11:25:00',3.79),('5819','2013-06-30','11:30:00',3.8),('5819','2013-06-30','11:35:00',3.83),('5819','2013-06-30','11:40:00',3.86),('5819','2013-06-30','11:45:00',3.87),('5819','2013-06-30','11:50:00',3.89),('5819','2013-06-30','11:55:00',3.88),('5819','2013-06-30','12:00:00',3.89),('5819','2013-06-30','12:05:00',3.93),('5819','2013-06-30','12:10:00',3.94),('5819','2013-06-30','12:15:00',3.9),('5819','2013-06-30','12:20:00',3.92),('5819','2013-06-30','12:25:00',3.95),('5819','2013-06-30','12:30:00',3.95),('5819','2013-06-30','12:35:00',3.96),('5819','2013-06-30','12:40:00',3.96),('5819','2013-06-30','12:45:00',3.98),('5819','2013-06-30','12:50:00',4),('5819','2013-06-30','12:55:00',3.96),('5819','2013-06-30','13:00:00',3.95),('5819','2013-06-30','13:05:00',3.93),('5819','2013-06-30','13:10:00',3.92),('5819','2013-06-30','13:15:00',3.92),('5819','2013-06-30','13:20:00',3.93),('5819','2013-06-30','13:25:00',3.98),('5819','2013-06-30','13:30:00',3.92),('5819','2013-06-30','13:35:00',3.88),('5819','2013-06-30','13:40:00',3.88),('5819','2013-06-30','13:45:00',3.89),('5819','2013-06-30','13:50:00',3.91),('5819','2013-06-30','13:55:00',3.41),('5819','2013-06-30','14:00:00',3.88),('5819','2013-06-30','14:05:00',3.83),('5819','2013-06-30','14:10:00',3.81),('5819','2013-06-30','14:15:00',3.73),('5819','2013-06-30','14:20:00',3.7),('5819','2013-06-30','14:25:00',3.66),('5819','2013-06-30','14:30:00',3.61),('5819','2013-06-30','14:35:00',3.61),('5819','2013-06-30','14:40:00',3.61),('5819','2013-06-30','14:45:00',3.58),('5819','2013-06-30','14:50:00',3.56),('5819','2013-06-30','14:55:00',3.51),('5819','2013-06-30','15:00:00',3.46),('5819','2013-06-30','15:05:00',3.41),('5819','2013-06-30','15:10:00',3.39),('5819','2013-06-30','15:15:00',3.35),('5819','2013-06-30','15:20:00',3.34),('5819','2013-06-30','15:25:00',3.26),('5819','2013-06-30','15:30:00',3.24),('5819','2013-06-30','15:35:00',3.21),('5819','2013-06-30','15:40:00',3.16),('5819','2013-06-30','15:45:00',3.11),('5819','2013-06-30','15:50:00',3.07),('5819','2013-06-30','15:55:00',3.01),('5819','2013-06-30','16:00:00',2.95),('5819','2013-06-30','16:05:00',2.9),('5819','2013-06-30','16:10:00',2.88),('5819','2013-06-30','16:15:00',2.83),('5819','2013-06-30','16:20:00',2.88),('5819','2013-06-30','16:25:00',2.9),('5819','2013-06-30','16:30:00',2.48),('5819','2013-06-30','16:35:00',2.51),('5819','2013-06-30','16:40:00',2.4),('5819','2013-06-30','16:45:00',2.35),('5819','2013-06-30','16:50:00',2.28),('5819','2013-06-30','16:55:00',2.18),('5819','2013-06-30','17:00:00',2.08),('5819','2013-06-30','17:05:00',2.03),('5819','2013-06-30','17:10:00',1.99),('5819','2013-06-30','17:15:00',1.9),('5819','2013-06-30','17:20:00',1.81),('5819','2013-06-30','17:25:00',1.72),('5819','2013-06-30','17:30:00',1.62),('5819','2013-06-30','17:35:00',1.55),('5819','2013-06-30','17:40:00',1.48),('5819','2013-06-30','17:45:00',1.39),('5819','2013-06-30','17:50:00',1.25),('5819','2013-06-30','17:55:00',1.17),('5819','2013-06-30','18:00:00',1.14),('5819','2013-06-30','18:05:00',1.06),('5819','2013-06-30','18:10:00',1.01),('5819','2013-06-29','07:30:00',1.27),('5819','2013-06-29','07:35:00',1.58),('5819','2013-06-29','07:40:00',1.67),('5819','2013-06-29','07:45:00',1.7),('5819','2013-06-29','07:50:00',1.76),('5819','2013-06-29','07:55:00',1.76),('5819','2013-06-29','08:00:00',2.12),('5819','2013-06-29','08:05:00',2.26),('5819','2013-06-29','08:10:00',2.35),('5819','2013-06-29','08:15:00',2.11),('5819','2013-06-29','08:20:00',1.34),('5819','2013-06-29','08:25:00',1.78),('5819','2013-06-29','08:30:00',2.33),('5819','2013-06-29','08:35:00',2.37),('5819','2013-06-29','08:40:00',1.39),('5819','2013-06-29','08:45:00',2.16),('5819','2013-06-29','08:50:00',2.51),('5819','2013-06-29','08:55:00',2.55),('5819','2013-06-29','09:00:00',2.59),('5819','2013-06-29','09:05:00',2.65),('5819','2013-06-29','09:10:00',2.71),('5819','2013-06-29','09:15:00',2.78),('5819','2013-06-29','09:20:00',2.82),('5819','2013-06-29','09:25:00',2.87),('5819','2013-06-29','09:30:00',2.9),('5819','2013-06-29','09:35:00',3),('5819','2013-06-29','09:40:00',3.04),('5819','2013-06-29','09:45:00',3.08),('5819','2013-06-29','09:50:00',3.14),('5819','2013-06-29','09:55:00',3.18),('5819','2013-06-29','10:00:00',3.22),('5819','2013-06-29','10:05:00',3.28),('5819','2013-06-29','10:10:00',3.33),('5819','2013-06-29','10:15:00',3.33),('5819','2013-06-29','10:20:00',3.39),('5819','2013-06-29','10:25:00',3.43),('5819','2013-06-29','10:30:00',3.46),('5819','2013-06-29','10:35:00',3.49),('5819','2013-06-29','10:40:00',3.53),('5819','2013-06-29','10:45:00',3.58),('5819','2013-06-29','10:50:00',3.6),('5819','2013-06-29','10:55:00',3.7),('5819','2013-06-29','11:00:00',3.72),('5819','2013-06-29','11:05:00',3.78),('5819','2013-06-29','11:10:00',3.83),('5819','2013-06-29','11:15:00',3.91),('5819','2013-06-29','11:20:00',2.23),('5819','2013-06-29','11:25:00',4.14),('5819','2013-06-29','11:30:00',4.18),('5819','2013-06-29','11:35:00',3.68),('5819','2013-06-29','11:40:00',3.65),('5819','2013-06-29','11:45:00',1.1),('5819','2013-06-29','11:50:00',2.83),('5819','2013-06-29','11:55:00',4.47),('5819','2013-06-29','12:00:00',3.15),('5819','2013-06-29','12:05:00',4.13),('5819','2013-06-29','12:10:00',4.19),('5819','2013-06-29','12:15:00',3.26),('5819','2013-06-29','12:20:00',1.59),('5819','2013-06-29','12:25:00',4.38),('5819','2013-06-29','12:30:00',4.08),('5819','2013-06-29','12:35:00',4.21),('5819','2013-06-29','12:40:00',4.08),('5819','2013-06-29','12:45:00',4.42),('5819','2013-06-29','12:50:00',2.1),('5819','2013-06-29','12:55:00',3.18),('5819','2013-06-29','13:00:00',2.79),('5819','2013-06-29','13:05:00',2.19),('5819','2013-06-29','13:10:00',4.5),('5819','2013-06-29','13:15:00',4.28),('5819','2013-06-29','13:20:00',2.29),('5819','2013-06-29','13:25:00',3.72),('5819','2013-06-29','13:30:00',1.44),('5819','2013-06-29','13:45:00',2.88),('5819','2013-06-29','13:50:00',4.25),('5819','2013-06-29','13:55:00',3.27),('5819','2013-06-29','14:00:00',4.07),('5819','2013-06-29','14:05:00',3.11),('5819','2013-06-29','14:10:00',3.66),('5819','2013-06-29','14:15:00',4.47),('5819','2013-06-29','14:20:00',4),('5819','2013-06-29','14:25:00',2.47),('5819','2013-06-29','14:30:00',4.39),('5819','2013-06-29','14:35:00',4.14),('5819','2013-06-29','14:40:00',4.1),('5819','2013-06-29','14:45:00',4.12),('5819','2013-06-29','14:50:00',3.26),('5819','2013-06-29','14:55:00',1.05),('5819','2013-06-29','15:00:00',1.84),('5819','2013-06-29','15:05:00',2.68),('5819','2013-06-29','15:10:00',1.97),('5819','2013-06-29','15:15:00',1.14),('5819','2013-06-29','16:40:00',1.1),('5819','2013-06-29','16:45:00',1.41),('5819','2013-06-29','16:50:00',2.07),('5819','2013-06-29','17:25:00',1.28),('5819','2013-06-29','17:30:00',1.84),('5819','2013-06-29','17:35:00',1.81),('5819','2013-06-29','17:45:00',1.4),('5819','2013-06-29','17:50:00',1.33),('5819','2013-06-29','17:55:00',1.25),('5819','2013-06-29','18:00:00',1.17),('5819','2013-06-29','18:05:00',1.1),('5819','2013-06-29','18:10:00',1.02),('5819','2013-06-28','07:15:00',1.03),('5819','2013-06-28','07:20:00',1.09),('5819','2013-06-28','07:25:00',1.14),('5819','2013-06-28','07:30:00',1.24),('5819','2013-06-28','07:35:00',1.28),('5819','2013-06-28','07:40:00',1.37),('5819','2013-06-28','07:45:00',1.51),('5819','2013-06-28','07:50:00',1.53),('5819','2013-06-28','07:55:00',1.62),('5819','2013-06-28','08:00:00',1.68),('5819','2013-06-28','08:05:00',1.71),('5819','2013-06-28','08:10:00',1.74),('5819','2013-06-28','08:15:00',1.88),('5819','2013-06-28','08:20:00',1.96),('5819','2013-06-28','08:25:00',1.9),('5819','2013-06-28','08:30:00',2.1),('5819','2013-06-28','08:35:00',2.23),('5819','2013-06-28','08:40:00',2.3),('5819','2013-06-28','08:45:00',2.31),('5819','2013-06-28','08:50:00',2.4),('5819','2013-06-28','08:55:00',2.46),('5819','2013-06-28','09:00:00',2.5),('5819','2013-06-28','09:05:00',2.56),('5819','2013-06-28','09:10:00',2.73),('5819','2013-06-28','09:15:00',2.56),('5819','2013-06-28','09:20:00',1.17),('5819','2013-06-28','09:30:00',1.48),('5819','2013-06-28','09:35:00',3.24),('5819','2013-06-28','09:40:00',3.18),('5819','2013-06-28','09:45:00',1.82),('5819','2013-06-28','09:50:00',1.11),('5819','2013-06-28','09:55:00',2.1),('5819','2013-06-28','10:00:00',3.53),('5819','2013-06-28','10:05:00',2.24),('5819','2013-06-28','10:10:00',3.56),('5819','2013-06-28','10:15:00',3.37),('5819','2013-06-28','10:20:00',3.75),('5819','2013-06-28','10:25:00',3.23),('5819','2013-06-28','10:30:00',1.26),('5819','2013-06-28','10:35:00',2.75),('5819','2013-06-28','10:40:00',4.13),('5819','2013-06-28','10:45:00',3.96),('5819','2013-06-28','10:50:00',3.83),('5819','2013-06-28','10:55:00',2.44),('5819','2013-06-28','11:00:00',2.63),('5819','2013-06-28','11:05:00',4.35),('5819','2013-06-28','11:10:00',2.98),('5819','2013-06-28','11:15:00',1.4),('5819','2013-06-28','11:20:00',1.62),('5819','2013-06-28','11:25:00',2.39),('5819','2013-06-28','11:30:00',4.34),('5819','2013-06-28','11:35:00',3.95),('5819','2013-06-28','11:40:00',4.16),('5819','2013-06-28','11:45:00',3.74),('5819','2013-06-28','11:50:00',4.35),('5819','2013-06-28','11:55:00',3.28),('5819','2013-06-28','12:00:00',2.36),('5819','2013-06-28','12:05:00',2.85),('5819','2013-06-28','12:10:00',2.88),('5819','2013-06-28','12:15:00',4.5),('5819','2013-06-28','12:20:00',4.23),('5819','2013-06-28','12:25:00',4.28),('5819','2013-06-28','12:30:00',4.05),('5819','2013-06-28','12:35:00',4.26),('5819','2013-06-28','12:40:00',3.62),('5819','2013-06-28','12:45:00',3.93),('5819','2013-06-28','12:50:00',4.25),('5819','2013-06-28','12:55:00',4.2),('5819','2013-06-28','13:00:00',3.84),('5819','2013-06-28','13:05:00',4.18),('5819','2013-06-28','13:10:00',3.42),('5819','2013-06-28','13:15:00',4.31),('5819','2013-06-28','13:20:00',4.14),('5819','2013-06-28','13:25:00',4.04),('5819','2013-06-28','13:30:00',4.12),('5819','2013-06-28','13:35:00',4.12),('5819','2013-06-28','13:40:00',4.03),('5819','2013-06-28','13:45:00',3.87),('5819','2013-06-28','13:50:00',4.18),('5819','2013-06-28','13:55:00',4.05),('5819','2013-06-28','14:00:00',3.94),('5819','2013-06-28','14:05:00',3.79),('5819','2013-06-28','14:10:00',3.88),('5819','2013-06-28','14:15:00',3.44),('5819','2013-06-28','14:20:00',3.82),('5819','2013-06-28','14:25:00',3.97),('5819','2013-06-28','14:30:00',3.48),('5819','2013-06-28','14:35:00',3.68),('5819','2013-06-28','14:40:00',3.3),('5819','2013-06-28','14:45:00',3),('5819','2013-06-28','14:50:00',3.97),('5819','2013-06-28','14:55:00',3.33),('5819','2013-06-28','15:00:00',3.06),('5819','2013-06-28','15:05:00',3.58),('5819','2013-06-28','15:10:00',3.27),('5819','2013-06-28','15:15:00',3.41),('5819','2013-06-28','15:20:00',1.65),('5819','2013-06-28','15:25:00',3.47),('5819','2013-06-28','15:30:00',2.46),('5819','2013-06-28','15:35:00',1.72),('5819','2013-06-28','15:40:00',3.14),('5819','2013-06-28','15:45:00',2.15),('5819','2013-06-28','15:50:00',3.56),('5819','2013-06-28','15:55:00',3.34),('5819','2013-06-28','16:00:00',2.19),('5819','2013-06-28','16:05:00',3.37),('5819','2013-06-28','16:10:00',2.25),('5819','2013-06-28','16:15:00',3.12),('5819','2013-06-28','16:20:00',1.72),('5819','2013-06-28','16:25:00',2.07),('5819','2013-06-28','16:30:00',1.33),('5819','2013-06-28','16:35:00',1.79),('5819','2013-06-28','16:40:00',2.35),('5819','2013-06-28','16:55:00',1.53),('5819','2013-06-28','17:00:00',1.39),('5819','2013-06-28','17:05:00',2.13),('5819','2013-06-28','17:10:00',2.01),('5819','2013-06-28','17:15:00',1.9),('5819','2013-06-28','17:20:00',1.81),('5819','2013-06-28','17:25:00',1.75),('5819','2013-06-28','17:30:00',1.26),('5819','2013-06-28','17:35:00',1.45),('5819','2013-06-28','17:40:00',1.5),('5819','2013-06-28','17:45:00',1.41),('5819','2013-06-28','17:50:00',1.25),('5819','2013-06-28','17:55:00',1.21),('5819','2013-06-28','18:00:00',1.15),('5819','2013-06-28','18:05:00',1.08),('5819','2013-06-27','07:30:00',1.19),('5819','2013-06-27','07:35:00',1.29),('5819','2013-06-27','07:40:00',1.36),('5819','2013-06-27','07:45:00',1.44),('5819','2013-06-27','07:50:00',1.55),('5819','2013-06-27','07:55:00',1.64),('5819','2013-06-27','08:00:00',1.72),('5819','2013-06-27','08:05:00',1.81),('5819','2013-06-27','08:10:00',1.91),('5819','2013-06-27','08:15:00',1.96),('5819','2013-06-27','08:20:00',2.01),('5819','2013-06-27','08:25:00',2.09),('5819','2013-06-27','08:30:00',2.14),('5819','2013-06-27','08:35:00',2.2),('5819','2013-06-27','08:40:00',2.26),('5819','2013-06-27','08:45:00',2.35),('5819','2013-06-27','08:50:00',2.4),('5819','2013-06-27','08:55:00',2.49),('5819','2013-06-27','09:00:00',2.58),('5819','2013-06-27','09:05:00',2.64),('5819','2013-06-27','09:10:00',2.69),('5819','2013-06-27','09:15:00',2.8),('5819','2013-06-27','09:20:00',2.85),('5819','2013-06-27','09:25:00',2.89),('5819','2013-06-27','09:30:00',2.96),('5819','2013-06-27','09:35:00',3.02),('5819','2013-06-27','09:40:00',3.06),('5819','2013-06-27','09:45:00',3.11),('5819','2013-06-27','09:50:00',3.21),('5819','2013-06-27','09:55:00',3.24),('5819','2013-06-27','10:00:00',3.03),('5819','2013-06-27','10:05:00',3.47),('5819','2013-06-27','10:10:00',2.86),('5819','2013-06-27','10:15:00',3.27),('5819','2013-06-27','10:20:00',3.45),('5819','2013-06-27','10:25:00',3.46),('5819','2013-06-27','10:30:00',3.53),('5819','2013-06-27','10:35:00',3.63),('5819','2013-06-27','10:40:00',3.69),('5819','2013-06-27','10:45:00',3.84),('5819','2013-06-27','10:50:00',3.82),('5819','2013-06-27','10:55:00',3.81),('5819','2013-06-27','11:00:00',2.61),('5819','2013-06-27','11:05:00',3.95),('5819','2013-06-27','11:10:00',3.89),('5819','2013-06-27','11:15:00',3.87),('5819','2013-06-27','11:20:00',3.84),('5819','2013-06-27','11:25:00',3.82),('5819','2013-06-27','11:30:00',3.91),('5819','2013-06-27','11:35:00',3.73),('5819','2013-06-27','11:40:00',1.52),('5819','2013-06-27','11:45:00',3.91),('5819','2013-06-27','11:50:00',2.69),('5819','2013-06-27','11:55:00',1.35),('5819','2013-06-27','12:00:00',2.03),('5819','2013-06-27','12:05:00',1.32),('5819','2013-06-27','12:10:00',2.14),('5819','2013-06-27','12:15:00',1.23),('5819','2013-06-27','12:20:00',1.18),('5819','2013-06-27','12:25:00',1.39),('5819','2013-06-27','12:30:00',1.4),('5819','2013-06-27','12:35:00',3.44),('5819','2013-06-27','12:40:00',2.34),('5819','2013-06-27','12:45:00',1.38),('5819','2013-06-27','12:50:00',1.24),('5819','2013-06-27','12:55:00',1.13),('5819','2013-06-27','13:05:00',1.04),('5819','2013-06-27','13:10:00',1.43),('5819','2013-06-27','13:15:00',2.45),('5819','2013-06-27','13:20:00',2.85),('5819','2013-06-27','13:25:00',1.94),('5819','2013-06-27','13:30:00',1.54),('5819','2013-06-27','13:35:00',3.14),('5819','2013-06-27','13:40:00',1.61),('5819','2013-06-27','13:45:00',1.13),('5819','2013-06-27','13:50:00',1.15),('5819','2013-06-27','13:55:00',1.27),('5819','2013-06-27','14:00:00',1.4),('5819','2013-06-27','14:05:00',1.24),('5819','2013-06-27','14:10:00',1.41),('5819','2013-06-27','14:15:00',1.7),('5819','2013-06-27','14:20:00',1.78),('5819','2013-06-27','14:25:00',1.9),('5819','2013-06-27','14:30:00',3.98),('5819','2013-06-27','14:35:00',3.83),('5819','2013-06-27','14:40:00',3.74),('5819','2013-06-27','14:45:00',3.3),('5819','2013-06-27','14:50:00',3.01),('5819','2013-06-27','14:55:00',3.41),('5819','2013-06-27','15:00:00',3.43),('5819','2013-06-27','15:05:00',3.38),('5819','2013-06-27','15:10:00',3.31),('5819','2013-06-27','15:15:00',3.27),('5819','2013-06-27','15:20:00',3.22),('5819','2013-06-27','15:25:00',3.23),('5819','2013-06-27','15:30:00',3.19),('5819','2013-06-27','15:35:00',3.13),('5819','2013-06-27','15:40:00',3.08),('5819','2013-06-27','15:45:00',3.02),('5819','2013-06-27','15:50:00',2.95),('5819','2013-06-27','15:55:00',2.9),('5819','2013-06-27','16:00:00',2.8),('5819','2013-06-27','16:05:00',2.72),('5819','2013-06-27','16:10:00',2.69),('5819','2013-06-27','16:15:00',2.63),('5819','2013-06-27','16:20:00',2.59),('5819','2013-06-27','16:25:00',2.55),('5819','2013-06-27','16:30:00',2.49),('5819','2013-06-27','16:35:00',2.28),('5819','2013-06-27','16:40:00',2.27),('5819','2013-06-27','16:45:00',2.28),('5819','2013-06-27','16:50:00',2.2),('5819','2013-06-27','16:55:00',2.14),('5819','2013-06-27','17:00:00',2.08),('5819','2013-06-27','17:05:00',2),('5819','2013-06-27','17:10:00',1.89),('5819','2013-06-27','17:15:00',1.79),('5819','2013-06-27','17:20:00',1.8),('5819','2013-06-27','17:25:00',1.75),('5819','2013-06-27','17:30:00',1.68),('5819','2013-06-27','17:35:00',1.61),('5819','2013-06-27','17:40:00',1.17),('5819','2013-06-27','17:50:00',1.29),('5819','2013-06-27','17:55:00',1.22),('5819','2013-06-27','18:00:00',1.15),('5819','2013-06-27','18:05:00',1.09),('5819','2013-06-27','18:10:00',1),('5819','2013-06-26','07:15:00',1),('5819','2013-06-26','07:20:00',1.08),('5819','2013-06-26','07:25:00',1.16),('5819','2013-06-26','07:30:00',1.24),('5819','2013-06-26','07:35:00',1.32),('5819','2013-06-26','07:40:00',1.4),('5819','2013-06-26','07:45:00',1.5),('5819','2013-06-26','07:50:00',1.59),('5819','2013-06-26','07:55:00',1.66),('5819','2013-06-26','08:00:00',1.71),('5819','2013-06-26','08:05:00',1.79),('5819','2013-06-26','08:10:00',1.87),('5819','2013-06-26','08:15:00',1.93),('5819','2013-06-26','08:20:00',1.99),('5819','2013-06-26','08:25:00',2.06),('5819','2013-06-26','08:30:00',2.14),('5819','2013-06-26','08:35:00',2.2),('5819','2013-06-26','08:40:00',2.25),('5819','2013-06-26','08:45:00',2.32),('5819','2013-06-26','08:50:00',2.39),('5819','2013-06-26','08:55:00',2.44),('5819','2013-06-26','09:00:00',2.5),('5819','2013-06-26','09:05:00',2.58),('5819','2013-06-26','09:10:00',2.62),('5819','2013-06-26','09:15:00',2.67),('5819','2013-06-26','09:20:00',2.72),('5819','2013-06-26','09:25:00',2.79),('5819','2013-06-26','09:30:00',2.88),('5819','2013-06-26','09:35:00',2.93),('5819','2013-06-26','09:40:00',2.97),('5819','2013-06-26','09:45:00',3),('5819','2013-06-26','09:50:00',3.04),('5819','2013-06-26','09:55:00',3.1),('5819','2013-06-26','10:00:00',3.17),('5819','2013-06-26','10:05:00',3.23),('5819','2013-06-26','10:10:00',3.27),('5819','2013-06-26','10:15:00',3.3),('5819','2013-06-26','10:20:00',3.34),('5819','2013-06-26','10:25:00',3.36),('5819','2013-06-26','10:30:00',3.38),('5819','2013-06-26','10:35:00',3.44),('5819','2013-06-26','10:40:00',3.5),('5819','2013-06-26','10:45:00',3.53),('5819','2013-06-26','10:50:00',3.56),('5819','2013-06-26','10:55:00',3.58),('5819','2013-06-26','11:00:00',3.63),('5819','2013-06-26','11:05:00',3.63),('5819','2013-06-26','11:10:00',3.67),('5819','2013-06-26','11:15:00',3.69),('5819','2013-06-26','11:20:00',3.72),('5819','2013-06-26','11:25:00',3.71),('5819','2013-06-26','11:30:00',3.71),('5819','2013-06-26','11:35:00',3.74),('5819','2013-06-26','11:40:00',3.75),('5819','2013-06-26','11:45:00',3.77),('5819','2013-06-26','11:50:00',3.8),('5819','2013-06-26','11:55:00',3.82),('5819','2013-06-26','12:00:00',3.88),('5819','2013-06-26','12:05:00',3.86),('5819','2013-06-26','12:10:00',3.85),('5819','2013-06-26','12:15:00',3.74),('5819','2013-06-26','12:20:00',3.7),('5819','2013-06-26','12:25:00',3.76),('5819','2013-06-26','12:30:00',3.87),('5819','2013-06-26','12:35:00',3.88),('5819','2013-06-26','12:40:00',3.96),('5819','2013-06-26','12:45:00',3.89),('5819','2013-06-26','12:50:00',1.99),('5819','2013-06-26','13:10:00',1.07),('5819','2013-06-26','13:15:00',3.57),('5819','2013-06-26','13:20:00',4.25),('5819','2013-06-26','13:25:00',2.85),('5819','2013-06-26','13:30:00',1.25),('5819','2013-06-26','13:45:00',1.07),('5819','2013-06-26','13:50:00',1.25),('5819','2013-06-26','13:55:00',2.39),('5819','2013-06-26','14:00:00',2.45),('5819','2013-06-26','14:10:00',1.97),('5819','2013-06-26','14:15:00',4.12),('5819','2013-06-26','14:20:00',3.86),('5819','2013-06-26','14:25:00',3.33),('5819','2013-06-26','14:30:00',3.2),('5819','2013-06-26','14:35:00',3.71),('5819','2013-06-26','14:40:00',1.05),('5819','2013-06-26','14:45:00',3.22),('5819','2013-06-26','14:50:00',3.83),('5819','2013-06-26','14:55:00',3.4),('5819','2013-06-26','15:00:00',3.47),('5819','2013-06-26','15:05:00',3.44),('5819','2013-06-26','15:10:00',3.39),('5819','2013-06-26','15:15:00',3.33),('5819','2013-06-26','15:20:00',3.26),('5819','2013-06-26','15:25:00',3.23),('5819','2013-06-26','15:30:00',3.2),('5819','2013-06-26','15:35:00',3.2),('5819','2013-06-26','15:40:00',3.1),('5819','2013-06-26','15:45:00',3.04),('5819','2013-06-26','15:50:00',3.02),('5819','2013-06-26','15:55:00',2.81),('5819','2013-06-26','16:00:00',2.87),('5819','2013-06-26','16:05:00',2.8),('5819','2013-06-26','16:10:00',2.75),('5819','2013-06-26','16:15:00',2.71),('5819','2013-06-26','16:20:00',2.63),('5819','2013-06-26','16:25:00',2.58),('5819','2013-06-26','16:30:00',2.54),('5819','2013-06-26','16:35:00',2.45),('5819','2013-06-26','16:40:00',2.35),('5819','2013-06-26','16:45:00',2.29),('5819','2013-06-26','16:50:00',2.22),('5819','2013-06-26','16:55:00',2.15),('5819','2013-06-26','17:00:00',2.1),('5819','2013-06-26','17:05:00',2.03),('5819','2013-06-26','17:10:00',1.98),('5819','2013-06-26','17:15:00',1.88),('5819','2013-06-26','17:20:00',1.81),('5819','2013-06-26','17:25:00',1.71),('5819','2013-06-26','17:30:00',1.65),('5819','2013-06-26','17:35:00',1.59),('5819','2013-06-26','17:40:00',1.5),('5819','2013-06-26','17:45:00',1.4),('5819','2013-06-26','17:50:00',1.25),('5819','2013-06-26','17:55:00',1.17),('5819','2013-06-26','18:00:00',1.16),('5819','2013-06-26','18:05:00',1.23),('5819','2013-06-26','18:10:00',1.37),('5819','2013-06-26','18:15:00',1.01),('5819','2013-06-25','07:40:00',1.38),('5819','2013-06-25','07:45:00',1.48),('5819','2013-06-25','07:50:00',1.38),('5819','2013-06-25','07:55:00',1.29),('5819','2013-06-25','08:05:00',1.37),('5819','2013-06-25','08:10:00',1.5),('5819','2013-06-25','08:15:00',1.32),('5819','2013-06-25','08:20:00',2.27),('5819','2013-06-25','08:25:00',1.01),('5819','2013-06-25','08:30:00',1.55),('5819','2013-06-25','08:35:00',2.28),('5819','2013-06-25','08:40:00',2.32),('5819','2013-06-25','08:45:00',2.4),('5819','2013-06-25','08:50:00',2.46),('5819','2013-06-25','08:55:00',2.53),('5819','2013-06-25','09:00:00',2.6),('5819','2013-06-25','09:05:00',2.65),('5819','2013-06-25','09:10:00',2.72),('5819','2013-06-25','09:15:00',2.81),('5819','2013-06-25','09:20:00',2.74),('5819','2013-06-25','09:25:00',2.96),('5819','2013-06-25','09:30:00',3.01),('5819','2013-06-25','09:35:00',3.15),('5819','2013-06-25','09:40:00',3.18),('5819','2013-06-25','09:45:00',3.22),('5819','2013-06-25','09:50:00',3.38),('5819','2013-06-25','09:55:00',3.48),('5819','2013-06-25','10:00:00',3.54),('5819','2013-06-25','10:05:00',2.01),('5819','2013-06-25','10:10:00',2.17),('5819','2013-06-25','10:15:00',3.76),('5819','2013-06-25','10:20:00',3.74),('5819','2013-06-25','10:25:00',2.43),('5819','2013-06-25','10:30:00',3.88),('5819','2013-06-25','10:35:00',3.9),('5819','2013-06-25','10:40:00',3.84),('5819','2013-06-25','10:45:00',3.61),('5819','2013-06-25','10:50:00',3.79),('5819','2013-06-25','10:55:00',3.5),('5819','2013-06-25','11:05:00',1.67),('5819','2013-06-25','11:10:00',3.55),('5819','2013-06-25','11:15:00',2.41),('5819','2013-06-25','11:20:00',3.95),('5819','2013-06-25','11:25:00',1.1),('5819','2013-06-25','11:30:00',2.18),('5819','2013-06-25','11:35:00',3.14),('5819','2013-06-25','11:40:00',4.06),('5819','2013-06-25','11:45:00',4.07),('5819','2013-06-25','11:50:00',3.12),('5819','2013-06-25','11:55:00',2.84),('5819','2013-06-25','12:00:00',3.37),('5819','2013-06-25','12:05:00',2.96),('5819','2013-06-25','12:10:00',2.69),('5819','2013-06-25','12:15:00',3.03),('5819','2013-06-25','12:20:00',1.91),('5819','2013-06-25','12:25:00',1.05),('5819','2013-06-25','12:40:00',1.55),('5819','2013-06-25','12:45:00',1.35),('5819','2013-06-25','12:50:00',1.18),('5819','2013-06-25','12:55:00',2.66),('5819','2013-06-25','13:00:00',4.47),('5819','2013-06-25','13:05:00',4.27),('5819','2013-06-25','13:10:00',4.24),('5819','2013-06-25','13:15:00',3.9),('5819','2013-06-25','13:20:00',4.13),('5819','2013-06-25','13:25:00',4.06),('5819','2013-06-25','13:30:00',4.13),('5819','2013-06-25','13:35:00',3.76),('5819','2013-06-25','13:40:00',2.88),('5819','2013-06-25','13:45:00',4.24),('5819','2013-06-25','13:50:00',3.58),('5819','2013-06-25','13:55:00',4.13),('5819','2013-06-25','14:00:00',3.42),('5819','2013-06-25','14:05:00',3.99),('5819','2013-06-25','14:10:00',4.06),('5819','2013-06-25','14:15:00',2.88),('5819','2013-06-25','14:20:00',3.75),('5819','2013-06-25','14:25:00',3.82),('5819','2013-06-25','14:30:00',3.74),('5819','2013-06-25','14:35:00',3.66),('5819','2013-06-25','14:40:00',3.43),('5819','2013-06-25','14:45:00',3.06),('5819','2013-06-25','14:50:00',3.63),('5819','2013-06-25','14:55:00',3.55),('5819','2013-06-25','15:00:00',3.5),('5819','2013-06-25','15:05:00',3.44),('5819','2013-06-25','15:10:00',3.36),('5819','2013-06-25','15:15:00',3.38),('5819','2013-06-25','15:20:00',3.29),('5819','2013-06-25','15:25:00',3.21),('5819','2013-06-25','15:30:00',3.16),('5819','2013-06-25','15:35:00',3.1),('5819','2013-06-25','15:40:00',3.05),('5819','2013-06-25','15:45:00',2.99),('5819','2013-06-25','15:50:00',2.92),('5819','2013-06-25','15:55:00',2.86),('5819','2013-06-25','16:00:00',2.83),('5819','2013-06-25','16:05:00',2.78),('5819','2013-06-25','16:10:00',2.71),('5819','2013-06-25','16:15:00',2.65),('5819','2013-06-25','16:20:00',2.58),('5819','2013-06-25','16:25:00',2.52),('5819','2013-06-25','16:30:00',2.46),('5819','2013-06-25','16:35:00',2.38),('5819','2013-06-25','16:40:00',2.32),('5819','2013-06-25','16:45:00',2.26),('5819','2013-06-25','16:50:00',2.2),('5819','2013-06-25','16:55:00',2.13),('5819','2013-06-25','17:00:00',2.06),('5819','2013-06-25','17:05:00',1.99),('5819','2013-06-25','17:10:00',1.91),('5819','2013-06-25','17:15:00',1.85),('5819','2013-06-25','17:20:00',1.78),('5819','2013-06-25','17:25:00',1.69),('5819','2013-06-25','17:30:00',1.62),('5819','2013-06-25','17:35:00',1.54),('5819','2013-06-25','17:40:00',1.47),('5819','2013-06-25','17:45:00',1.35),('5819','2013-06-25','17:50:00',1.2),('5819','2013-06-25','17:55:00',1.15),('5819','2013-06-25','18:00:00',1.12),('5819','2013-06-25','18:05:00',1.04),('5819','2013-06-24','08:45:00',1.94),('5819','2013-06-24','08:50:00',2.66),('5819','2013-06-24','08:55:00',2.71),('5819','2013-06-24','09:00:00',2.17),('5819','2013-06-24','09:05:00',2.38),('5819','2013-06-24','09:10:00',1.02),('5819','2013-06-24','09:15:00',2.69),('5819','2013-06-24','09:20:00',3.14),('5819','2013-06-24','09:25:00',2.94),('5819','2013-06-24','09:30:00',2.88),('5819','2013-06-24','09:40:00',2.21),('5819','2013-06-24','09:45:00',2.16),('5819','2013-06-24','09:50:00',2.69),('5819','2013-06-24','09:55:00',3.42),('5819','2013-06-24','10:00:00',3.41),('5819','2013-06-24','10:05:00',3.43),('5819','2013-06-24','10:10:00',3.55),('5819','2013-06-24','10:15:00',3.75),('5819','2013-06-24','10:20:00',2.38),('5819','2013-06-24','10:25:00',3.89),('5819','2013-06-24','10:30:00',2.22),('5819','2013-06-24','10:35:00',3.1),('5819','2013-06-24','10:40:00',2.33),('5819','2013-06-24','10:45:00',2.49),('5819','2013-06-24','10:50:00',3.17),('5819','2013-06-24','10:55:00',3.02),('5819','2013-06-24','11:00:00',4.25),('5819','2013-06-24','11:05:00',3.6),('5819','2013-06-24','11:10:00',3.67),('5819','2013-06-24','11:15:00',2.17),('5819','2013-06-24','11:20:00',3.22),('5819','2013-06-24','11:25:00',1.4),('5819','2013-06-24','11:30:00',1.62),('5819','2013-06-24','11:35:00',1.26),('5819','2013-06-24','11:40:00',1.31),('5819','2013-06-24','11:45:00',1.49),('5819','2013-06-24','11:50:00',2.59),('5819','2013-06-24','11:55:00',3.45),('5819','2013-06-24','12:00:00',3.38),('5819','2013-06-24','12:05:00',3.66),('5819','2013-06-24','12:10:00',4.1),('5819','2013-06-24','12:15:00',3.62),('5819','2013-06-24','12:20:00',3.64),('5819','2013-06-24','12:25:00',2.62),('5819','2013-06-24','12:30:00',2.5),('5819','2013-06-24','12:35:00',4.5),('5819','2013-06-24','12:40:00',4.57),('5819','2013-06-24','12:45:00',2.22),('5819','2013-06-24','12:50:00',4.74),('5819','2013-06-24','12:55:00',4.69),('5819','2013-06-24','13:00:00',4.35),('5819','2013-06-24','13:05:00',4.49),('5819','2013-06-24','13:10:00',3.83),('5819','2013-06-24','13:15:00',3.1),('5819','2013-06-24','13:20:00',2.37),('5819','2013-06-24','13:25:00',3.74),('5819','2013-06-24','13:30:00',4.29),('5819','2013-06-24','13:35:00',3.71),('5819','2013-06-24','13:40:00',4.07),('5819','2013-06-24','13:45:00',4.2),('5819','2013-06-24','13:50:00',4.04),('5819','2013-06-24','13:55:00',3.98),('5819','2013-06-24','14:00:00',3.96),('5819','2013-06-24','14:05:00',3.95),('5819','2013-06-24','14:10:00',3.93),('5819','2013-06-24','14:15:00',3.88),('5819','2013-06-24','14:20:00',3.87),('5819','2013-06-24','14:25:00',3.85),('5819','2013-06-24','14:30:00',3.84),('5819','2013-06-24','14:35:00',3.76),('5819','2013-06-24','14:40:00',3.77),('5819','2013-06-24','14:45:00',3.8),('5819','2013-06-24','14:50:00',3.56),('5819','2013-06-24','14:55:00',3.98),('5819','2013-06-24','15:00:00',3.94),('5819','2013-06-24','15:05:00',2.91),('5819','2013-06-24','15:10:00',1.86),('5819','2013-06-24','15:15:00',3.38),('5819','2013-06-24','15:20:00',3.62),('5819','2013-06-24','15:25:00',3.23),('5819','2013-06-24','15:30:00',2.51),('5819','2013-06-24','15:35:00',3.06),('5819','2013-06-24','15:40:00',2.07),('5819','2013-06-24','15:45:00',3.2),('5819','2013-06-24','15:50:00',2.14),('5819','2013-06-24','15:55:00',2.7),('5819','2013-06-24','16:00:00',3.15),('5819','2013-06-24','16:05:00',3.09),('5819','2013-06-24','16:10:00',3.11),('5819','2013-06-24','16:15:00',3.18),('5819','2013-06-24','16:20:00',2.51),('5819','2013-06-24','16:25:00',2.09),('5819','2013-06-24','16:30:00',2.71),('5819','2013-06-24','16:35:00',2.36),('5819','2013-06-24','16:40:00',1.61),('5819','2013-06-24','16:45:00',1.86),('5819','2013-06-24','16:50:00',1.78),('5819','2013-06-24','17:00:00',1.24),('5819','2013-06-24','17:05:00',1.64),('5819','2013-06-24','17:10:00',1.89),('5819','2013-06-24','17:15:00',2.39),('5819','2013-06-24','17:20:00',2.14),('5819','2013-06-24','17:25:00',1.36),('5819','2013-06-24','17:30:00',1.85),('5819','2013-06-24','17:35:00',1),('5819','2013-06-24','17:50:00',1.49),('5819','2013-06-24','18:00:00',1.36),('5819','2013-06-24','18:05:00',1.28),('5819','2013-06-24','18:15:00',1.06),('5819','2013-06-24','18:20:00',1.02),('5819','2013-06-23','08:50:00',1.64),('5819','2013-06-23','09:00:00',1.63),('5819','2013-06-23','09:05:00',1.61),('5819','2013-06-23','09:20:00',1.7),('5819','2013-06-23','09:25:00',2.66),('5819','2013-06-23','09:30:00',3.03),('5819','2013-06-23','09:35:00',3.05),('5819','2013-06-23','09:40:00',3.35),('5819','2013-06-23','09:45:00',2.34),('5819','2013-06-23','09:50:00',1.31),('5819','2013-06-23','09:55:00',1.18),('5819','2013-06-23','10:00:00',3.1),('5819','2013-06-23','10:05:00',3.49),('5819','2013-06-23','10:10:00',2.79),('5819','2013-06-23','10:15:00',3.42),('5819','2013-06-23','10:20:00',2.52),('5819','2013-06-23','10:25:00',1.38),('5819','2013-06-23','10:30:00',1.07),('5819','2013-06-23','10:40:00',1.57),('5819','2013-06-23','10:45:00',3.76),('5819','2013-06-23','10:50:00',2.01),('5819','2013-06-23','10:55:00',3.67),('5819','2013-06-23','11:00:00',3.55),('5819','2013-06-23','11:05:00',3.55),('5819','2013-06-23','11:10:00',3.68),('5819','2013-06-23','11:15:00',3.69),('5819','2013-06-23','11:20:00',3.83),('5819','2013-06-23','11:25:00',3.74),('5819','2013-06-23','11:30:00',3.68),('5819','2013-06-23','11:35:00',3.73),('5819','2013-06-23','11:40:00',3.68),('5819','2013-06-23','11:45:00',3.72),('5819','2013-06-23','11:50:00',3.79),('5819','2013-06-23','11:55:00',3.85),('5819','2013-06-23','12:00:00',2.78),('5819','2013-06-23','12:05:00',2.76),('5819','2013-06-23','12:10:00',4.03),('5819','2013-06-23','12:15:00',3.94),('5819','2013-06-23','12:20:00',3.96),('5819','2013-06-23','12:25:00',3.77),('5819','2013-06-23','12:30:00',3.91),('5819','2013-06-23','12:35:00',3.91),('5819','2013-06-23','12:40:00',3.93),('5819','2013-06-23','12:45:00',3.9),('5819','2013-06-23','12:50:00',3.91),('5819','2013-06-23','12:55:00',3.91),('5819','2013-06-23','13:00:00',3.93),('5819','2013-06-23','13:05:00',3.92),('5819','2013-06-23','13:10:00',3.91),('5819','2013-06-23','13:15:00',3.89),('5819','2013-06-23','13:20:00',3.87),('5819','2013-06-23','13:25:00',3.87),('5819','2013-06-23','13:30:00',3.86),('5819','2013-06-23','13:35:00',3.86),('5819','2013-06-23','13:40:00',3.87),('5819','2013-06-23','13:45:00',3.86),('5819','2013-06-23','13:50:00',3.84),('5819','2013-06-23','13:55:00',3.82),('5819','2013-06-23','14:00:00',3.78),('5819','2013-06-23','14:05:00',3.76),('5819','2013-06-23','14:10:00',3.72),('5819','2013-06-23','14:15:00',3.71),('5819','2013-06-23','14:20:00',3.7),('5819','2013-06-23','14:25:00',3.7),('5819','2013-06-23','14:30:00',3.68),('5819','2013-06-23','14:35:00',3.65),('5819','2013-06-23','14:40:00',3.61),('5819','2013-06-23','14:45:00',3.58),('5819','2013-06-23','14:50:00',3.56),('5819','2013-06-23','14:55:00',3.53),('5819','2013-06-23','15:00:00',3.5),('5819','2013-06-23','15:05:00',3.45),('5819','2013-06-23','15:10:00',3.4),('5819','2013-06-23','15:15:00',3.37),('5819','2013-06-23','15:20:00',3.32),('5819','2013-06-23','15:25:00',3.27),('5819','2013-06-23','15:30:00',3.2),('5819','2013-06-23','15:35:00',3.14),('5819','2013-06-23','15:40:00',3.11),('5819','2013-06-23','15:45:00',3.06),('5819','2013-06-23','15:50:00',3.01),('5819','2013-06-23','15:55:00',2.96),('5819','2013-06-23','16:00:00',2.89),('5819','2013-06-23','16:05:00',2.85),('5819','2013-06-23','16:10:00',2.77),('5819','2013-06-23','16:15:00',2.69),('5819','2013-06-23','16:20:00',2.62),('5819','2013-06-23','16:25:00',2.55),('5819','2013-06-23','16:30:00',2.5),('5819','2013-06-23','16:35:00',2.43),('5819','2013-06-23','16:40:00',2.38),('5819','2013-06-23','16:45:00',2.3),('5819','2013-06-23','16:50:00',2.24),('5819','2013-06-23','16:55:00',2.16),('5819','2013-06-23','17:00:00',2.09),('5819','2013-06-23','17:05:00',2.02),('5819','2013-06-23','17:10:00',1.95),('5819','2013-06-23','17:15:00',1.87),('5819','2013-06-23','17:20:00',1.73),('5819','2013-06-23','17:25:00',1.23),('5819','2013-06-23','17:30:00',1.63),('5819','2013-06-23','17:35:00',1.57),('5819','2013-06-23','17:40:00',1.5),('5819','2013-06-23','17:45:00',1.29),('5819','2013-06-23','17:50:00',1.25),('5819','2013-06-23','17:55:00',1.21),('5819','2013-06-23','18:00:00',1.13),('5819','2013-06-23','18:05:00',1.05),('5819','2013-06-22','07:25:00',1.02),('5819','2013-06-22','07:30:00',1.11),('5819','2013-06-22','07:35:00',1.18),('5819','2013-06-22','07:40:00',1.25),('5819','2013-06-22','07:45:00',1.31),('5819','2013-06-22','07:50:00',1.38),('5819','2013-06-22','07:55:00',1.46),('5819','2013-06-22','08:00:00',1.53),('5819','2013-06-22','08:05:00',1.59),('5819','2013-06-22','08:10:00',1.68),('5819','2013-06-22','08:15:00',1.75),('5819','2013-06-22','08:20:00',1.84),('5819','2013-06-22','08:25:00',1.94),('5819','2013-06-22','08:30:00',2.01),('5819','2013-06-22','08:35:00',2.09),('5819','2013-06-22','08:40:00',2.17),('5819','2013-06-22','08:45:00',2.24),('5819','2013-06-22','08:50:00',2.28),('5819','2013-06-22','08:55:00',2.36),('5819','2013-06-22','09:00:00',2.43),('5819','2013-06-22','09:05:00',2.47),('5819','2013-06-22','09:10:00',2.51),('5819','2013-06-22','09:15:00',2.57),('5819','2013-06-22','09:20:00',2.64),('5819','2013-06-22','09:25:00',2.67),('5819','2013-06-22','09:30:00',2.71),('5819','2013-06-22','09:35:00',2.78),('5819','2013-06-22','09:40:00',2.83),('5819','2013-06-22','09:45:00',2.88),('5819','2013-06-22','09:50:00',2.93),('5819','2013-06-22','09:55:00',2.97),('5819','2013-06-22','10:00:00',3.04),('5819','2013-06-22','10:05:00',3.09),('5819','2013-06-22','10:10:00',3.15),('5819','2013-06-22','10:15:00',3.18),('5819','2013-06-22','10:20:00',3.23),('5819','2013-06-22','10:25:00',3.27),('5819','2013-06-22','10:30:00',3.28),('5819','2013-06-22','10:35:00',3.32),('5819','2013-06-22','10:40:00',3.36),('5819','2013-06-22','10:45:00',3.42),('5819','2013-06-22','10:50:00',3.45),('5819','2013-06-22','10:55:00',3.46),('5819','2013-06-22','11:00:00',3.48),('5819','2013-06-22','11:05:00',3.51),('5819','2013-06-22','11:10:00',3.54),('5819','2013-06-22','11:15:00',3.57),('5819','2013-06-22','11:20:00',3.61),('5819','2013-06-22','11:25:00',3.63),('5819','2013-06-22','11:30:00',3.63),('5819','2013-06-22','11:35:00',3.65),('5819','2013-06-22','11:40:00',3.67),('5819','2013-06-22','11:45:00',3.67),('5819','2013-06-22','11:50:00',3.68),('5819','2013-06-22','11:55:00',3.69),('5819','2013-06-22','12:00:00',3.71),('5819','2013-06-22','12:05:00',3.65),('5819','2013-06-22','12:10:00',3.57),('5819','2013-06-22','12:15:00',3.72),('5819','2013-06-22','12:20:00',3.74),('5819','2013-06-22','12:25:00',3.66),('5819','2013-06-22','12:30:00',3.74),('5819','2013-06-22','12:35:00',3.77),('5819','2013-06-22','12:40:00',3.79),('5819','2013-06-22','12:45:00',3.76),('5819','2013-06-22','12:50:00',3.69),('5819','2013-06-22','12:55:00',3.66),('5819','2013-06-22','13:00:00',3.59),('5819','2013-06-22','13:05:00',3.6),('5819','2013-06-22','13:10:00',3.56),('5819','2013-06-22','13:15:00',3.51),('5819','2013-06-22','13:20:00',3.39),('5819','2013-06-22','13:25:00',3.52),('5819','2013-06-22','13:30:00',3.85),('5819','2013-06-22','13:35:00',3.84),('5819','2013-06-22','13:40:00',3.55),('5819','2013-06-22','13:45:00',3.5),('5819','2013-06-22','13:50:00',3.76),('5819','2013-06-22','13:55:00',3.01),('5819','2013-06-22','14:00:00',1.98),('5819','2013-06-22','14:05:00',4.05),('5819','2013-06-22','14:10:00',3.84),('5819','2013-06-22','14:15:00',3.79),('5819','2013-06-22','14:20:00',3.03),('5819','2013-06-22','14:25:00',3.74),('5819','2013-06-22','14:30:00',2.73),('5819','2013-06-22','14:35:00',2.08),('5819','2013-06-22','14:40:00',1.58),('5819','2013-06-22','14:45:00',1.78),('5819','2013-06-22','14:50:00',2.87),('5819','2013-06-22','14:55:00',3.59),('5819','2013-06-22','15:00:00',3.33),('5819','2013-06-22','15:05:00',2.96),('5819','2013-06-22','15:10:00',3.09),('5819','2013-06-22','15:15:00',3.48),('5819','2013-06-22','15:20:00',3.21),('5819','2013-06-22','15:25:00',3.01),('5819','2013-06-22','15:30:00',1.98),('5819','2013-06-22','15:35:00',1.82),('5819','2013-06-22','15:40:00',1.72),('5819','2013-06-22','15:45:00',2.24),('5819','2013-06-22','15:50:00',2.25),('5819','2013-06-22','15:55:00',2.14),('5819','2013-06-22','16:00:00',1.83),('5819','2013-06-22','16:05:00',1.16),('5819','2013-06-22','16:10:00',1.08),('5819','2013-06-22','16:15:00',1.32),('5819','2013-06-22','16:20:00',1.68),('5819','2013-06-22','16:25:00',1.24),('5819','2013-06-22','17:00:00',1.31),('5819','2013-06-22','17:05:00',1.27),('5819','2013-06-22','17:10:00',1.56),('5819','2013-06-22','17:15:00',2.28),('5819','2013-06-22','17:20:00',2.18),('5819','2013-06-22','17:25:00',2.17),('5819','2013-06-22','17:30:00',1.85),('5819','2013-06-22','17:35:00',1.42),('5819','2013-06-22','17:40:00',1.61),('5819','2013-06-22','17:45:00',1.56),('5819','2013-06-22','17:50:00',1.34),('5819','2013-06-22','17:55:00',1.23),('5819','2013-06-22','18:00:00',1.22),('5819','2013-06-22','18:05:00',1.01),('5819','2013-06-21','07:25:00',1.03),('5819','2013-06-21','07:30:00',1.1),('5819','2013-06-21','07:35:00',1.18),('5819','2013-06-21','07:40:00',1.25),('5819','2013-06-21','07:45:00',1.33),('5819','2013-06-21','07:50:00',1.4),('5819','2013-06-21','07:55:00',1.48),('5819','2013-06-21','08:00:00',1.55),('5819','2013-06-21','08:05:00',1.64),('5819','2013-06-21','08:10:00',1.71),('5819','2013-06-21','08:15:00',1.77),('5819','2013-06-21','08:20:00',1.84),('5819','2013-06-21','08:25:00',1.91),('5819','2013-06-21','08:30:00',1.99),('5819','2013-06-21','08:35:00',2.06),('5819','2013-06-21','08:40:00',2.12),('5819','2013-06-21','08:45:00',2.19),('5819','2013-06-21','08:50:00',2.25),('5819','2013-06-21','08:55:00',2.29),('5819','2013-06-21','09:00:00',2.35),('5819','2013-06-21','09:05:00',2.39),('5819','2013-06-21','09:10:00',2.44),('5819','2013-06-21','09:15:00',2.48),('5819','2013-06-21','09:20:00',2.52),('5819','2013-06-21','09:25:00',2.59),('5819','2013-06-21','09:30:00',2.62),('5819','2013-06-21','09:35:00',2.66),('5819','2013-06-21','09:40:00',2.72),('5819','2013-06-21','09:45:00',2.77),('5819','2013-06-21','09:50:00',2.84),('5819','2013-06-21','09:55:00',2.86),('5819','2013-06-21','10:00:00',2.87),('5819','2013-06-21','10:05:00',2.9),('5819','2013-06-21','10:10:00',2.95),('5819','2013-06-21','10:15:00',2.99),('5819','2013-06-21','10:20:00',3.03),('5819','2013-06-21','10:25:00',3.03),('5819','2013-06-21','10:30:00',3.1),('5819','2013-06-21','10:35:00',3.14),('5819','2013-06-21','10:40:00',3.13),('5819','2013-06-21','10:45:00',3.15),('5819','2013-06-21','10:50:00',3.23),('5819','2013-06-21','10:55:00',3.26),('5819','2013-06-21','11:00:00',3.29),('5819','2013-06-21','11:05:00',3.27),('5819','2013-06-21','11:10:00',3.27),('5819','2013-06-21','11:15:00',3.36),('5819','2013-06-21','11:20:00',3.4),('5819','2013-06-21','11:25:00',3.43),('5819','2013-06-21','11:30:00',3.45),('5819','2013-06-21','11:35:00',3.44),('5819','2013-06-21','11:40:00',3.48),('5819','2013-06-21','11:45:00',3.48),('5819','2013-06-21','11:50:00',3.54),('5819','2013-06-21','11:55:00',3.58),('5819','2013-06-21','12:00:00',3.55),('5819','2013-06-21','12:05:00',3.57),('5819','2013-06-21','12:10:00',3.57),('5819','2013-06-21','12:15:00',3.55),('5819','2013-06-21','12:20:00',3.54),('5819','2013-06-21','12:25:00',3.51),('5819','2013-06-21','12:30:00',3.63),('5819','2013-06-21','12:35:00',3.59),('5819','2013-06-21','12:40:00',3.54),('5819','2013-06-21','12:45:00',3.56),('5819','2013-06-21','12:50:00',3.51),('5819','2013-06-21','12:55:00',3.5),('5819','2013-06-21','13:00:00',3.5),('5819','2013-06-21','13:05:00',3.44),('5819','2013-06-21','13:10:00',3.44),('5819','2013-06-21','13:15:00',3.49),('5819','2013-06-21','13:20:00',3.52),('5819','2013-06-21','13:25:00',3.55),('5819','2013-06-21','13:30:00',3.57),('5819','2013-06-21','13:35:00',3.6),('5819','2013-06-21','13:40:00',3.57),('5819','2013-06-21','13:45:00',3.53),('5819','2013-06-21','13:50:00',3.54),('5819','2013-06-21','13:55:00',3.55),('5819','2013-06-21','14:00:00',3.51),('5819','2013-06-21','14:05:00',3.53),('5819','2013-06-21','14:10:00',3.47),('5819','2013-06-21','14:15:00',3.44),('5819','2013-06-21','14:20:00',3.43),('5819','2013-06-21','14:25:00',3.42),('5819','2013-06-21','14:30:00',3.43),('5819','2013-06-21','14:35:00',3.41),('5819','2013-06-21','14:40:00',3.38),('5819','2013-06-21','14:45:00',3.36),('5819','2013-06-21','14:50:00',3.32),('5819','2013-06-21','14:55:00',3.28),('5819','2013-06-21','15:00:00',3.25),('5819','2013-06-21','15:05:00',3.21),('5819','2013-06-21','15:10:00',3.16),('5819','2013-06-21','15:15:00',3.12),('5819','2013-06-21','15:20:00',3.09),('5819','2013-06-21','15:25:00',3.04),('5819','2013-06-21','15:30:00',3),('5819','2013-06-21','15:35:00',2.95),('5819','2013-06-21','15:40:00',2.9),('5819','2013-06-21','15:45:00',2.85),('5819','2013-06-21','15:50:00',2.81),('5819','2013-06-21','15:55:00',2.75),('5819','2013-06-21','16:00:00',2.69),('5819','2013-06-21','16:05:00',2.64),('5819','2013-06-21','16:10:00',2.59),('5819','2013-06-21','16:15:00',2.54),('5819','2013-06-21','16:20:00',2.47),('5819','2013-06-21','16:25:00',2.43),('5819','2013-06-21','16:30:00',2.37),('5819','2013-06-21','16:35:00',2.3),('5819','2013-06-21','16:40:00',2.23),('5819','2013-06-21','16:45:00',2.17),('5819','2013-06-21','16:50:00',2.1),('5819','2013-06-21','16:55:00',2.03),('5819','2013-06-21','17:00:00',1.96),('5819','2013-06-21','17:05:00',1.9),('5819','2013-06-21','17:10:00',1.84),('5819','2013-06-21','17:15:00',1.77),('5819','2013-06-21','17:20:00',1.69),('5819','2013-06-21','17:25:00',1.62),('5819','2013-06-21','17:30:00',1.55),('5819','2013-06-21','17:35:00',1.48),('5819','2013-06-21','17:40:00',1.4),('5819','2013-06-21','17:45:00',1.27),('5819','2013-06-21','17:50:00',1.13),('5819','2013-06-21','17:55:00',1.1),('5819','2013-06-21','18:00:00',1.05),('5819','2013-06-20','07:30:00',1.04),('5819','2013-06-20','07:35:00',1.1),('5819','2013-06-20','07:40:00',1.07),('5819','2013-06-20','07:45:00',1.18),('5819','2013-06-20','07:50:00',1.27),('5819','2013-06-20','07:55:00',1.41),('5819','2013-06-20','08:00:00',1.5),('5819','2013-06-20','08:05:00',1.62),('5819','2013-06-20','08:10:00',1.7),('5819','2013-06-20','08:15:00',1.78),('5819','2013-06-20','08:20:00',1.87),('5819','2013-06-20','08:25:00',1.94),('5819','2013-06-20','08:30:00',2.01),('5819','2013-06-20','08:35:00',2.08),('5819','2013-06-20','08:40:00',2.15),('5819','2013-06-20','08:45:00',2.22),('5819','2013-06-20','08:50:00',2.29),('5819','2013-06-20','08:55:00',2.33),('5819','2013-06-20','09:00:00',2.38),('5819','2013-06-20','09:05:00',2.45),('5819','2013-06-20','09:10:00',2.51),('5819','2013-06-20','09:15:00',2.55),('5819','2013-06-20','09:20:00',2.62),('5819','2013-06-20','09:25:00',2.67),('5819','2013-06-20','09:30:00',2.73),('5819','2013-06-20','09:35:00',2.77),('5819','2013-06-20','09:40:00',2.81),('5819','2013-06-20','09:45:00',2.83),('5819','2013-06-20','09:50:00',2.9),('5819','2013-06-20','09:55:00',2.94),('5819','2013-06-20','10:00:00',3.01),('5819','2013-06-20','10:05:00',3.04),('5819','2013-06-20','10:10:00',3.08),('5819','2013-06-20','10:15:00',3.1),('5819','2013-06-20','10:20:00',3.15),('5819','2013-06-20','10:25:00',3.19),('5819','2013-06-20','10:30:00',3.22),('5819','2013-06-20','10:35:00',3.27),('5819','2013-06-20','10:40:00',3.28),('5819','2013-06-20','10:45:00',3.3),('5819','2013-06-20','10:50:00',3.3),('5819','2013-06-20','10:55:00',3.32),('5819','2013-06-20','12:05:00',3.41),('5819','2013-06-20','12:10:00',3.45),('5819','2013-06-20','12:15:00',3.47),('5819','2013-06-20','12:20:00',3.42),('5819','2013-06-20','12:25:00',3.41),('5819','2013-06-20','12:30:00',3.37),('5819','2013-06-20','12:35:00',3.61),('5819','2013-06-20','12:40:00',3.49),('5819','2013-06-20','12:45:00',3.34),('5819','2013-06-20','12:50:00',3.62),('5819','2013-06-20','12:55:00',3.29),('5819','2013-06-20','13:00:00',1.79),('5819','2013-06-20','13:05:00',2.85),('5819','2013-06-20','13:10:00',3.77),('5819','2013-06-20','13:15:00',3.71),('5819','2013-06-20','13:20:00',3.58),('5819','2013-06-20','13:25:00',3.44),('5819','2013-06-20','13:30:00',3.09),('5819','2013-06-20','13:35:00',3.5),('5819','2013-06-20','13:40:00',3.53),('5819','2013-06-20','13:45:00',3.55),('5819','2013-06-20','13:50:00',3.52),('5819','2013-06-20','13:55:00',3.5),('5819','2013-06-20','14:00:00',3.51),('5819','2013-06-20','14:05:00',3.57),('5819','2013-06-20','14:10:00',3.58),('5819','2013-06-20','14:15:00',3.54),('5819','2013-06-20','14:20:00',3.53),('5819','2013-06-20','14:25:00',3.49),('5819','2013-06-20','14:30:00',3.44),('5819','2013-06-20','14:35:00',3.46),('5819','2013-06-20','14:40:00',3.47),('5819','2013-06-20','14:45:00',3.43),('5819','2013-06-20','14:50:00',3.43),('5819','2013-06-20','14:55:00',3.38),('5819','2013-06-20','15:00:00',3.34),('5819','2013-06-20','15:05:00',3.28),('5819','2013-06-20','15:10:00',3.24),('5819','2013-06-20','15:15:00',3.2),('5819','2013-06-20','15:20:00',3.15),('5819','2013-06-20','15:25:00',3.12),('5819','2013-06-20','15:30:00',3.07),('5819','2013-06-20','15:35:00',3.01),('5819','2013-06-20','15:40:00',2.96),('5819','2013-06-20','15:45:00',2.92),('5819','2013-06-20','15:50:00',2.87),('5819','2013-06-20','15:55:00',2.81),('5819','2013-06-20','16:00:00',2.75),('5819','2013-06-20','16:05:00',2.71),('5819','2013-06-20','16:10:00',2.65),('5819','2013-06-20','16:15:00',2.58),('5819','2013-06-20','16:20:00',2.51),('5819','2013-06-20','16:25:00',2.46),('5819','2013-06-20','16:30:00',2.4),('5819','2013-06-20','16:35:00',2.33),('5819','2013-06-20','16:40:00',2.25),('5819','2013-06-20','16:45:00',2.16),('5819','2013-06-20','16:50:00',2.11),('5819','2013-06-20','16:55:00',2.05),('5819','2013-06-20','17:00:00',1.99),('5819','2013-06-20','17:05:00',1.92),('5819','2013-06-20','17:10:00',1.85),('5819','2013-06-20','17:15:00',1.77),('5819','2013-06-20','17:20:00',1.7),('5819','2013-06-20','17:25:00',1.63),('5819','2013-06-20','17:30:00',1.56),('5819','2013-06-20','17:35:00',1.48),('5819','2013-06-20','17:40:00',1.4),('5819','2013-06-20','17:45:00',1.25),('5819','2013-06-20','17:50:00',1.17),('5819','2013-06-20','17:55:00',1.13),('5819','2013-06-20','18:00:00',1.06),('5819','2013-06-19','07:25:00',1),('5819','2013-06-19','07:30:00',1.07),('5819','2013-06-19','07:35:00',1.14),('5819','2013-06-19','07:40:00',1.2),('5819','2013-06-19','07:45:00',1.28),('5819','2013-06-19','07:50:00',1.37),('5819','2013-06-19','07:55:00',1.46),('5819','2013-06-19','08:00:00',1.52),('5819','2013-06-19','08:05:00',1.6),('5819','2013-06-19','08:10:00',1.68),('5819','2013-06-19','08:15:00',1.75),('5819','2013-06-19','08:20:00',1.82),('5819','2013-06-19','08:25:00',1.88),('5819','2013-06-19','08:30:00',1.96),('5819','2013-06-19','08:35:00',2.04),('5819','2013-06-19','08:40:00',2.1),('5819','2013-06-19','08:45:00',2.16),('5819','2013-06-19','08:50:00',2.23),('5819','2013-06-19','08:55:00',2.29),('5819','2013-06-19','09:00:00',2.34),('5819','2013-06-19','09:05:00',2.4),('5819','2013-06-19','09:10:00',2.47),('5819','2013-06-19','09:15:00',2.52),('5819','2013-06-19','09:20:00',2.57),('5819','2013-06-19','09:25:00',2.62),('5819','2013-06-19','09:30:00',2.68),('5819','2013-06-19','09:35:00',2.72),('5819','2013-06-19','09:40:00',2.76),('5819','2013-06-19','09:45:00',2.81),('5819','2013-06-19','09:50:00',2.84),('5819','2013-06-19','09:55:00',2.9),('5819','2013-06-19','10:00:00',2.93),('5819','2013-06-19','10:05:00',2.97),('5819','2013-06-19','10:10:00',3),('5819','2013-06-19','10:15:00',3.06),('5819','2013-06-19','10:20:00',3.1),('5819','2013-06-19','10:25:00',3.11),('5819','2013-06-19','10:30:00',3.12),('5819','2013-06-19','10:35:00',3.14),('5819','2013-06-19','10:40:00',3.16),('5819','2013-06-19','10:45:00',3.23),('5819','2013-06-19','10:50:00',3.24),('5819','2013-06-19','10:55:00',3.27),('5819','2013-06-19','11:00:00',3.25),('5819','2013-06-19','11:05:00',3.32),('5819','2013-06-19','11:10:00',3.32),('5819','2013-06-19','11:15:00',3.33),('5819','2013-06-19','11:20:00',3.36),('5819','2013-06-19','11:25:00',3.34),('5819','2013-06-19','11:30:00',3.36),('5819','2013-06-19','11:35:00',3.39),('5819','2013-06-19','11:40:00',3.43),('5819','2013-06-19','11:45:00',3.44),('5819','2013-06-19','11:50:00',3.41),('5819','2013-06-19','11:55:00',3.39),('5819','2013-06-19','12:00:00',3.44),('5819','2013-06-19','12:05:00',3.41),('5819','2013-06-19','12:10:00',3.48),('5819','2013-06-19','12:15:00',3.46),('5819','2013-06-19','12:20:00',3.48),('5819','2013-06-19','12:25:00',3.49),('5819','2013-06-19','12:30:00',3.53),('5819','2013-06-19','12:35:00',3.54),('5819','2013-06-19','12:40:00',3.52),('5819','2013-06-19','12:45:00',3.57),('5819','2013-06-19','12:50:00',3.56),('5819','2013-06-19','12:55:00',3.55),('5819','2013-06-19','13:00:00',3.51),('5819','2013-06-19','13:05:00',3.49),('5819','2013-06-19','13:10:00',3.49),('5819','2013-06-19','13:15:00',3.51),('5819','2013-06-19','13:20:00',3.47),('5819','2013-06-19','13:25:00',3.53),('5819','2013-06-19','13:30:00',3.55),('5819','2013-06-19','13:35:00',3.52),('5819','2013-06-19','13:40:00',3.53),('5819','2013-06-19','13:45:00',3.52),('5819','2013-06-19','13:50:00',3.49),('5819','2013-06-19','13:55:00',3.53),('5819','2013-06-19','14:00:00',3.53),('5819','2013-06-19','14:05:00',3.5),('5819','2013-06-19','14:10:00',3.45),('5819','2013-06-19','14:15:00',3.43),('5819','2013-06-19','14:20:00',3.4),('5819','2013-06-19','14:25:00',3.37),('5819','2013-06-19','14:30:00',3.33),('5819','2013-06-19','14:35:00',3.29),('5819','2013-06-19','14:40:00',3.26),('5819','2013-06-19','14:45:00',3.23),('5819','2013-06-19','14:50:00',3.2),('5819','2013-06-19','14:55:00',3.16),('5819','2013-06-19','15:00:00',3.14),('5819','2013-06-19','15:05:00',3.11),('5819','2013-06-19','15:10:00',3.06),('5819','2013-06-19','15:15:00',3.03),('5819','2013-06-19','15:20:00',3),('5819','2013-06-19','15:25:00',2.95),('5819','2013-06-19','15:30:00',2.91),('5819','2013-06-19','15:35:00',2.87),('5819','2013-06-19','15:40:00',2.83),('5819','2013-06-19','15:45:00',2.79),('5819','2013-06-19','15:50:00',2.71),('5819','2013-06-19','15:55:00',2.65),('5819','2013-06-19','16:00:00',2.6),('5819','2013-06-19','16:05:00',2.54),('5819','2013-06-19','16:10:00',2.5),('5819','2013-06-19','16:15:00',2.44),('5819','2013-06-19','16:20:00',2.37),('5819','2013-06-19','16:25:00',2.32),('5819','2013-06-19','16:30:00',2.26),('5819','2013-06-19','16:35:00',2.2),('5819','2013-06-19','16:40:00',2.14),('5819','2013-06-19','16:45:00',2.08),('5819','2013-06-19','16:50:00',2.02),('5819','2013-06-19','16:55:00',1.96),('5819','2013-06-19','17:00:00',1.91),('5819','2013-06-19','17:05:00',1.84),('5819','2013-06-19','17:10:00',1.79),('5819','2013-06-19','17:15:00',1.72),('5819','2013-06-19','17:20:00',1.67),('5819','2013-06-19','17:25:00',1.61),('5819','2013-06-19','17:30:00',1.53),('5819','2013-06-19','17:35:00',1.45),('5819','2013-06-19','17:40:00',1.38),('5819','2013-06-19','17:45:00',1.23),('5819','2013-06-19','17:50:00',1.12),('5819','2013-06-19','17:55:00',1.07),('5819','2013-06-19','18:00:00',1.04),('5819','2013-06-18','07:30:00',1.06),('5819','2013-06-18','07:35:00',1.13),('5819','2013-06-18','07:40:00',1.2),('5819','2013-06-18','07:45:00',1.27),('5819','2013-06-18','07:50:00',1.34),('5819','2013-06-18','07:55:00',1.43),('5819','2013-06-18','08:00:00',1.5),('5819','2013-06-18','08:05:00',1.58),('5819','2013-06-18','08:10:00',1.65),('5819','2013-06-18','08:15:00',1.72),('5819','2013-06-18','08:20:00',1.79),('5819','2013-06-18','08:25:00',1.86),('5819','2013-06-18','08:30:00',1.94),('5819','2013-06-18','08:35:00',2),('5819','2013-06-18','08:40:00',2.07),('5819','2013-06-18','08:45:00',2.13),('5819','2013-06-18','08:50:00',2.2),('5819','2013-06-18','08:55:00',2.27),('5819','2013-06-18','09:00:00',2.3),('5819','2013-06-18','09:05:00',2.36),('5819','2013-06-18','09:10:00',2.42),('5819','2013-06-18','09:15:00',2.49),('5819','2013-06-18','09:20:00',2.54),('5819','2013-06-18','09:25:00',2.6),('5819','2013-06-18','09:30:00',2.64),('5819','2013-06-18','09:35:00',2.68),('5819','2013-06-18','09:40:00',2.73),('5819','2013-06-18','09:45:00',2.75),('5819','2013-06-18','09:50:00',2.8),('5819','2013-06-18','09:55:00',2.83),('5819','2013-06-18','10:00:00',2.88),('5819','2013-06-18','10:05:00',2.9),('5819','2013-06-18','10:10:00',2.96),('5819','2013-06-18','10:15:00',3.01),('5819','2013-06-18','10:20:00',3.06),('5819','2013-06-18','10:25:00',3.06),('5819','2013-06-18','10:30:00',3.08),('5819','2013-06-18','10:35:00',3.08),('5819','2013-06-18','10:40:00',3.13),('5819','2013-06-18','10:45:00',3.18),('5819','2013-06-18','10:50:00',3.2),('5819','2013-06-18','10:55:00',3.24),('5819','2013-06-18','11:00:00',3.28),('5819','2013-06-18','11:05:00',3.31),('5819','2013-06-18','11:10:00',3.35),('5819','2013-06-18','11:15:00',3.37),('5819','2013-06-18','11:20:00',3.36),('5819','2013-06-18','11:25:00',3.39),('5819','2013-06-18','11:30:00',3.41),('5819','2013-06-18','11:35:00',3.42),('5819','2013-06-18','11:40:00',3.35),('5819','2013-06-18','11:45:00',3.38),('5819','2013-06-18','11:50:00',3.43),('5819','2013-06-18','11:55:00',3.41),('5819','2013-06-18','12:00:00',3.39),('5819','2013-06-18','12:05:00',3.4),('5819','2013-06-18','12:10:00',3.38),('5819','2013-06-18','12:15:00',3.37),('5819','2013-06-18','12:20:00',3.36),('5819','2013-06-18','12:25:00',3.36),('5819','2013-06-18','12:30:00',3.41),('5819','2013-06-18','12:35:00',3.4),('5819','2013-06-18','12:40:00',3.43),('5819','2013-06-18','12:45:00',2.63),('5819','2013-06-18','12:50:00',3.09),('5819','2013-06-18','12:55:00',3.5),('5819','2013-06-18','13:00:00',3.65),('5819','2013-06-18','13:05:00',2.09),('5819','2013-06-18','13:10:00',2.45),('5819','2013-06-18','13:15:00',3.68),('5819','2013-06-18','13:20:00',3.7),('5819','2013-06-18','13:25:00',3.74),('5819','2013-06-18','13:30:00',2.39),('5819','2013-06-18','13:35:00',3.5),('5819','2013-06-18','13:40:00',3.59),('5819','2013-06-18','13:45:00',3.54),('5819','2013-06-18','13:50:00',3.57),('5819','2013-06-18','13:55:00',3.62),('5819','2013-06-18','14:00:00',3.59),('5819','2013-06-18','14:05:00',3.61),('5819','2013-06-18','14:10:00',3.55),('5819','2013-06-18','14:15:00',3.5),('5819','2013-06-18','14:20:00',3.43),('5819','2013-06-18','14:25:00',3.42),('5819','2013-06-18','14:30:00',3.4),('5819','2013-06-18','14:35:00',3.39),('5819','2013-06-18','14:40:00',3.41),('5819','2013-06-18','14:45:00',3.33),('5819','2013-06-18','14:50:00',3.3),('5819','2013-06-18','14:55:00',3.27),('5819','2013-06-18','15:00:00',3.26),('5819','2013-06-18','15:05:00',3.19),('5819','2013-06-18','15:10:00',3.14),('5819','2013-06-18','15:15:00',3.1),('5819','2013-06-18','15:20:00',3.05),('5819','2013-06-18','15:25:00',3.01),('5819','2013-06-18','15:30:00',2.96),('5819','2013-06-18','15:35:00',2.94),('5819','2013-06-18','15:40:00',2.92),('5819','2013-06-18','15:45:00',2.9),('5819','2013-06-18','15:50:00',2.83),('5819','2013-06-18','15:55:00',2.82),('5819','2013-06-18','16:00:00',2.79),('5819','2013-06-18','16:05:00',2.76),('5819','2013-06-18','16:10:00',2.71),('5819','2013-06-18','16:15:00',2.68),('5819','2013-06-18','16:20:00',2.62),('5819','2013-06-18','16:25:00',2.43),('5819','2013-06-18','16:30:00',2.29),('5819','2013-06-18','16:35:00',2.28),('5819','2013-06-18','16:40:00',2.24),('5819','2013-06-18','16:45:00',2.13),('5819','2013-06-18','16:50:00',2.07),('5819','2013-06-18','16:55:00',2.01),('5819','2013-06-18','17:00:00',1.95),('5819','2013-06-18','17:05:00',1.89),('5819','2013-06-18','17:10:00',1.82),('5819','2013-06-18','17:15:00',1.75),('5819','2013-06-18','17:20:00',1.69),('5819','2013-06-18','17:25:00',1.6),('5819','2013-06-18','17:30:00',1.52),('5819','2013-06-18','17:35:00',1.45),('5819','2013-06-18','17:40:00',1.38),('5819','2013-06-18','17:45:00',1.25),('5819','2013-06-18','17:50:00',1.13),('5819','2013-06-18','17:55:00',1.11),('5819','2013-06-18','18:00:00',1.06),('5819','2013-06-18','18:05:00',1),('5819','2013-06-17','07:25:00',1.05),('5819','2013-06-17','07:30:00',1.13),('5819','2013-06-17','07:35:00',1.2),('5819','2013-06-17','07:40:00',1.28),('5819','2013-06-17','07:45:00',1.35),('5819','2013-06-17','07:50:00',1.44),('5819','2013-06-17','07:55:00',1.53),('5819','2013-06-17','08:00:00',1.61),('5819','2013-06-17','08:05:00',1.68),('5819','2013-06-17','08:10:00',1.76),('5819','2013-06-17','08:15:00',1.84),('5819','2013-06-17','08:20:00',1.91),('5819','2013-06-17','08:25:00',1.98),('5819','2013-06-17','08:30:00',2.04),('5819','2013-06-17','08:35:00',2.11),('5819','2013-06-17','08:40:00',2.17),('5819','2013-06-17','08:45:00',2.24),('5819','2013-06-17','08:50:00',2.31),('5819','2013-06-17','08:55:00',2.38),('5819','2013-06-17','09:00:00',2.44),('5819','2013-06-17','09:05:00',2.49),('5819','2013-06-17','09:10:00',2.55),('5819','2013-06-17','09:15:00',2.59),('5819','2013-06-17','09:20:00',2.65),('5819','2013-06-17','09:25:00',2.71),('5819','2013-06-17','09:30:00',2.77),('5819','2013-06-17','09:35:00',2.81),('5819','2013-06-17','09:40:00',2.86),('5819','2013-06-17','09:45:00',2.92),('5819','2013-06-17','09:50:00',2.98),('5819','2013-06-17','09:55:00',3.01),('5819','2013-06-17','10:00:00',3.04),('5819','2013-06-17','10:05:00',3.07),('5819','2013-06-17','10:10:00',3.1),('5819','2013-06-17','10:15:00',3.15),('5819','2013-06-17','10:20:00',3.18),('5819','2013-06-17','10:25:00',3.22),('5819','2013-06-17','10:30:00',3.24),('5819','2013-06-17','10:35:00',3.27),('5819','2013-06-17','10:40:00',3.3),('5819','2013-06-17','10:45:00',3.33),('5819','2013-06-17','10:50:00',3.34),('5819','2013-06-17','10:55:00',3.38),('5819','2013-06-17','11:00:00',3.39),('5819','2013-06-17','11:05:00',3.41),('5819','2013-06-17','11:10:00',3.43),('5819','2013-06-17','11:15:00',3.44),('5819','2013-06-17','11:20:00',3.48),('5819','2013-06-17','11:25:00',3.49),('5819','2013-06-17','11:30:00',3.49),('5819','2013-06-17','11:35:00',3.5),('5819','2013-06-17','11:40:00',3.49),('5819','2013-06-17','11:45:00',3.53),('5819','2013-06-17','11:50:00',3.5),('5819','2013-06-17','11:55:00',3.52),('5819','2013-06-17','12:00:00',3.49),('5819','2013-06-17','12:05:00',3.51),('5819','2013-06-17','12:10:00',3.54),('5819','2013-06-17','12:15:00',3.56),('5819','2013-06-17','12:20:00',3.58),('5819','2013-06-17','12:25:00',3.56),('5819','2013-06-17','12:30:00',3.56),('5819','2013-06-17','12:35:00',3.56),('5819','2013-06-17','12:40:00',3.56),('5819','2013-06-17','12:45:00',3.54),('5819','2013-06-17','12:50:00',3.58),('5819','2013-06-17','12:55:00',3.61),('5819','2013-06-17','13:00:00',3.64),('5819','2013-06-17','13:05:00',3.65),('5819','2013-06-17','13:10:00',3.65),('5819','2013-06-17','13:15:00',3.64),('5819','2013-06-17','13:20:00',3.61),('5819','2013-06-17','13:25:00',3.58),('5819','2013-06-17','13:30:00',3.59),('5819','2013-06-17','13:35:00',3.54),('5819','2013-06-17','13:40:00',3.54),('5819','2013-06-17','13:45:00',3.52),('5819','2013-06-17','13:50:00',3.5),('5819','2013-06-17','13:55:00',3.48),('5819','2013-06-17','14:00:00',3.48),('5819','2013-06-17','14:05:00',3.47),('5819','2013-06-17','14:10:00',3.43),('5819','2013-06-17','14:15:00',3.41),('5819','2013-06-17','14:20:00',3.41),('5819','2013-06-17','14:25:00',3.39),('5819','2013-06-17','14:30:00',3.37),('5819','2013-06-17','14:35:00',3.36),('5819','2013-06-17','14:40:00',3.33),('5819','2013-06-17','14:45:00',3.29),('5819','2013-06-17','14:50:00',3.26),('5819','2013-06-17','14:55:00',3.23),('5819','2013-06-17','15:00:00',3.18),('5819','2013-06-17','15:05:00',3.14),('5819','2013-06-17','15:10:00',3.1),('5819','2013-06-17','15:15:00',3.06),('5819','2013-06-17','15:20:00',3.03),('5819','2013-06-17','15:25:00',2.98),('5819','2013-06-17','15:30:00',2.95),('5819','2013-06-17','15:35:00',2.92),('5819','2013-06-17','15:40:00',2.86),('5819','2013-06-17','15:45:00',2.81),('5819','2013-06-17','15:50:00',2.77),('5819','2013-06-17','15:55:00',2.71),('5819','2013-06-17','16:00:00',2.66),('5819','2013-06-17','16:05:00',2.62),('5819','2013-06-17','16:10:00',2.57),('5819','2013-06-17','16:15:00',2.52),('5819','2013-06-17','16:20:00',2.46),('5819','2013-06-17','16:25:00',2.4),('5819','2013-06-17','16:30:00',2.34),('5819','2013-06-17','16:35:00',2.28),('5819','2013-06-17','16:40:00',2.22),('5819','2013-06-17','16:45:00',2.16),('5819','2013-06-17','16:50:00',2.1),('5819','2013-06-17','16:55:00',2.03),('5819','2013-06-17','17:00:00',1.98),('5819','2013-06-17','17:05:00',1.91),('5819','2013-06-17','17:10:00',1.85),('5819','2013-06-17','17:15:00',1.78),('5819','2013-06-17','17:20:00',1.72),('5819','2013-06-17','17:25:00',1.65),('5819','2013-06-17','17:30:00',1.59),('5819','2013-06-17','17:35:00',1.52),('5819','2013-06-17','17:40:00',1.44),('5819','2013-06-17','17:45:00',1.31),('5819','2013-06-17','17:50:00',1.2),('5819','2013-06-17','17:55:00',1.17),('5819','2013-06-17','18:00:00',1.11),('5819','2013-06-17','18:05:00',1.04),('5819','2013-06-16','07:20:00',1.02),('5819','2013-06-16','07:25:00',1.09),('5819','2013-06-16','07:30:00',1.17),('5819','2013-06-16','07:35:00',1.25),('5819','2013-06-16','07:40:00',1.33),('5819','2013-06-16','07:45:00',1.41),('5819','2013-06-16','07:50:00',1.48),('5819','2013-06-16','07:55:00',1.56),('5819','2013-06-16','08:00:00',1.64),('5819','2013-06-16','08:05:00',1.71),('5819','2013-06-16','08:10:00',1.78),('5819','2013-06-16','08:15:00',1.86),('5819','2013-06-16','08:20:00',1.93),('5819','2013-06-16','08:25:00',2.02),('5819','2013-06-16','08:30:00',2.08),('5819','2013-06-16','08:35:00',2.16),('5819','2013-06-16','08:40:00',2.22),('5819','2013-06-16','08:45:00',2.29),('5819','2013-06-16','08:50:00',2.33),('5819','2013-06-16','08:55:00',2.41),('5819','2013-06-16','09:00:00',2.48),('5819','2013-06-16','09:05:00',2.54),('5819','2013-06-16','09:10:00',2.6),('5819','2013-06-16','09:15:00',2.67),('5819','2013-06-16','09:20:00',2.73),('5819','2013-06-16','09:25:00',2.78),('5819','2013-06-16','09:30:00',2.82),('5819','2013-06-16','09:35:00',2.88),('5819','2013-06-16','09:40:00',2.93),('5819','2013-06-16','09:45:00',2.96),('5819','2013-06-16','09:50:00',3.02),('5819','2013-06-16','09:55:00',3.04),('5819','2013-06-16','10:00:00',3.08),('5819','2013-06-16','10:05:00',3.11),('5819','2013-06-16','10:10:00',3.12),('5819','2013-06-16','10:15:00',3.2),('5819','2013-06-16','10:20:00',3.22),('5819','2013-06-16','10:25:00',3.25),('5819','2013-06-16','10:30:00',3.31),('5819','2013-06-16','10:35:00',3.34),('5819','2013-06-16','10:40:00',3.37),('5819','2013-06-16','10:45:00',3.38),('5819','2013-06-16','10:50:00',3.42),('5819','2013-06-16','10:55:00',3.42),('5819','2013-06-16','11:00:00',3.44),('5819','2013-06-16','11:05:00',3.45),('5819','2013-06-16','11:10:00',3.49),('5819','2013-06-16','11:15:00',3.5),('5819','2013-06-16','11:20:00',3.52),('5819','2013-06-16','11:25:00',3.55),('5819','2013-06-16','11:30:00',3.59),('5819','2013-06-16','11:35:00',3.64),('5819','2013-06-16','11:40:00',3.64),('5819','2013-06-16','11:45:00',3.64),('5819','2013-06-16','11:50:00',3.66),('5819','2013-06-16','11:55:00',3.68),('5819','2013-06-16','12:00:00',3.7),('5819','2013-06-16','12:05:00',3.7),('5819','2013-06-16','12:10:00',3.72),('5819','2013-06-16','12:15:00',3.72),('5819','2013-06-16','12:20:00',3.74),('5819','2013-06-16','12:25:00',3.77),('5819','2013-06-16','12:30:00',3.75),('5819','2013-06-16','12:35:00',3.73),('5819','2013-06-16','12:40:00',3.72),('5819','2013-06-16','12:45:00',3.71),('5819','2013-06-16','12:50:00',3.71),('5819','2013-06-16','12:55:00',3.72),('5819','2013-06-16','13:00:00',3.72),('5819','2013-06-16','13:05:00',3.73),('5819','2013-06-16','13:10:00',3.76),('5819','2013-06-16','13:15:00',3.75),('5819','2013-06-16','13:20:00',3.75),('5819','2013-06-16','13:25:00',3.74),('5819','2013-06-16','13:30:00',3.73),('5819','2013-06-16','13:35:00',3.73),('5819','2013-06-16','13:40:00',3.69),('5819','2013-06-16','13:45:00',3.69),('5819','2013-06-16','13:50:00',3.67),('5819','2013-06-16','13:55:00',3.66),('5819','2013-06-16','14:00:00',3.67),('5819','2013-06-16','14:05:00',3.63),('5819','2013-06-16','14:10:00',3.6),('5819','2013-06-16','14:15:00',3.58),('5819','2013-06-16','14:20:00',3.54),('5819','2013-06-16','14:25:00',3.51),('5819','2013-06-16','14:30:00',3.48),('5819','2013-06-16','14:35:00',3.44),('5819','2013-06-16','14:40:00',3.41),('5819','2013-06-16','14:45:00',3.39),('5819','2013-06-16','14:50:00',3.35),('5819','2013-06-16','14:55:00',3.3),('5819','2013-06-16','15:00:00',3.27),('5819','2013-06-16','15:05:00',3.25),('5819','2013-06-16','15:10:00',3.2),('5819','2013-06-16','15:15:00',3.17),('5819','2013-06-16','15:20:00',3.13),('5819','2013-06-16','15:25:00',3.1),('5819','2013-06-16','15:30:00',3.04),('5819','2013-06-16','15:35:00',2.99),('5819','2013-06-16','15:40:00',2.95),('5819','2013-06-16','15:45:00',2.9),('5819','2013-06-16','15:50:00',2.84),('5819','2013-06-16','15:55:00',2.79),('5819','2013-06-16','16:00:00',2.73),('5819','2013-06-16','16:05:00',2.68),('5819','2013-06-16','16:10:00',2.63),('5819','2013-06-16','16:15:00',2.57),('5819','2013-06-16','16:20:00',2.51),('5819','2013-06-16','16:25:00',2.45),('5819','2013-06-16','16:30:00',2.4),('5819','2013-06-16','16:35:00',2.33),('5819','2013-06-16','16:40:00',2.25),('5819','2013-06-16','16:45:00',2.18),('5819','2013-06-16','16:50:00',2.11),('5819','2013-06-16','16:55:00',2.04),('5819','2013-06-16','17:00:00',1.97),('5819','2013-06-16','17:05:00',1.9),('5819','2013-06-16','17:10:00',1.83),('5819','2013-06-16','17:15:00',1.75),('5819','2013-06-16','17:20:00',1.68),('5819','2013-06-16','17:25:00',1.61),('5819','2013-06-16','17:30:00',1.53),('5819','2013-06-16','17:35:00',1.46),('5819','2013-06-16','17:40:00',1.39),('5819','2013-06-16','17:45:00',1.23),('5819','2013-06-16','17:50:00',1.14),('5819','2013-06-16','17:55:00',1.11),('5819','2013-06-16','18:00:00',1.04),('5819','2013-06-15','07:25:00',1.02),('5819','2013-06-15','07:30:00',1.09),('5819','2013-06-15','07:35:00',1.17),('5819','2013-06-15','07:40:00',1.25),('5819','2013-06-15','07:45:00',1.33),('5819','2013-06-15','07:50:00',1.41),('5819','2013-06-15','07:55:00',1.5),('5819','2013-06-15','08:00:00',1.55),('5819','2013-06-15','08:05:00',1.65),('5819','2013-06-15','08:10:00',1.73),('5819','2013-06-15','08:15:00',1.8),('5819','2013-06-15','08:20:00',1.89),('5819','2013-06-15','08:25:00',1.96),('5819','2013-06-15','08:30:00',1.99),('5819','2013-06-15','08:35:00',2.06),('5819','2013-06-15','08:40:00',2.16),('5819','2013-06-15','08:45:00',2.26),('5819','2013-06-15','08:50:00',2.31),('5819','2013-06-15','08:55:00',2.25),('5819','2013-06-15','09:00:00',2.3),('5819','2013-06-15','09:05:00',2.5),('5819','2013-06-15','09:10:00',2.55),('5819','2013-06-15','09:15:00',2.64),('5819','2013-06-15','09:20:00',2.69),('5819','2013-06-15','09:25:00',2.67),('5819','2013-06-15','09:30:00',2.76),('5819','2013-06-15','09:35:00',2.66),('5819','2013-06-15','09:40:00',2.84),('5819','2013-06-15','09:45:00',2.68),('5819','2013-06-15','09:50:00',2.96),('5819','2013-06-15','09:55:00',3.02),('5819','2013-06-15','10:00:00',2.34),('5819','2013-06-15','10:05:00',1.76),('5819','2013-06-15','10:10:00',2.02),('5819','2013-06-15','10:15:00',2.36),('5819','2013-06-15','10:20:00',3.04),('5819','2013-06-15','10:25:00',2.91),('5819','2013-06-15','10:30:00',3.23),('5819','2013-06-15','10:35:00',3.43),('5819','2013-06-15','10:40:00',3.42),('5819','2013-06-15','10:45:00',3.32),('5819','2013-06-15','10:50:00',3.51),('5819','2013-06-15','10:55:00',3.53),('5819','2013-06-15','11:00:00',2.27),('5819','2013-06-15','11:05:00',1.76),('5819','2013-06-15','11:10:00',3.13),('5819','2013-06-15','11:15:00',3.43),('5819','2013-06-15','11:20:00',3.41),('5819','2013-06-15','11:25:00',3.55),('5819','2013-06-15','11:30:00',2.78),('5819','2013-06-15','11:35:00',2.85),('5819','2013-06-15','11:40:00',2.44),('5819','2013-06-15','11:45:00',1.72),('5819','2013-06-15','11:50:00',1.93),('5819','2013-06-15','11:55:00',4.05),('5819','2013-06-15','12:00:00',3.94),('5819','2013-06-15','12:05:00',3.54),('5819','2013-06-15','12:10:00',3.87),('5819','2013-06-15','12:15:00',3.94),('5819','2013-06-15','12:20:00',3.9),('5819','2013-06-15','12:25:00',3.84),('5819','2013-06-15','12:30:00',3.87),('5819','2013-06-15','12:35:00',3.89),('5819','2013-06-15','12:40:00',3.87),('5819','2013-06-15','12:45:00',3.83),('5819','2013-06-15','12:50:00',3.81),('5819','2013-06-15','12:55:00',3.81),('5819','2013-06-15','13:00:00',3.83),('5819','2013-06-15','13:05:00',3.78),('5819','2013-06-15','13:10:00',3.76),('5819','2013-06-15','13:15:00',3.78),('5819','2013-06-15','13:20:00',3.75),('5819','2013-06-15','13:25:00',3.74),('5819','2013-06-15','13:30:00',3.74),('5819','2013-06-15','13:35:00',3.71),('5819','2013-06-15','13:40:00',3.71),('5819','2013-06-15','13:45:00',3.71),('5819','2013-06-15','13:50:00',3.71),('5819','2013-06-15','13:55:00',3.66),('5819','2013-06-15','14:00:00',3.63),('5819','2013-06-15','14:05:00',3.59),('5819','2013-06-15','14:10:00',3.58),('5819','2013-06-15','14:15:00',3.56),('5819','2013-06-15','14:20:00',3.53),('5819','2013-06-15','14:25:00',3.49),('5819','2013-06-15','14:30:00',3.48),('5819','2013-06-15','14:35:00',3.44),('5819','2013-06-15','14:40:00',3.43),('5819','2013-06-15','14:45:00',3.42),('5819','2013-06-15','14:50:00',3.33),('5819','2013-06-15','14:55:00',3.34),('5819','2013-06-15','15:00:00',3.29),('5819','2013-06-15','15:05:00',3.23),('5819','2013-06-15','15:10:00',3.22),('5819','2013-06-15','15:15:00',3.19),('5819','2013-06-15','15:20:00',3.14),('5819','2013-06-15','15:25:00',3.11),('5819','2013-06-15','15:30:00',3.08),('5819','2013-06-15','15:35:00',3.01),('5819','2013-06-15','15:40:00',2.95),('5819','2013-06-15','15:45:00',2.9),('5819','2013-06-15','15:50:00',2.84),('5819','2013-06-15','15:55:00',2.8),('5819','2013-06-15','16:00:00',2.74),('5819','2013-06-15','16:05:00',2.68),('5819','2013-06-15','16:10:00',2.62),('5819','2013-06-15','16:15:00',2.56),('5819','2013-06-15','16:20:00',2.5),('5819','2013-06-15','16:25:00',2.43),('5819','2013-06-15','16:30:00',2.37),('5819','2013-06-15','16:35:00',2.31),('5819','2013-06-15','16:40:00',2.23),('5819','2013-06-15','16:45:00',2.18),('5819','2013-06-15','16:50:00',2.1),('5819','2013-06-15','16:55:00',2.03),('5819','2013-06-15','17:00:00',1.97),('5819','2013-06-15','17:05:00',1.9),('5819','2013-06-15','17:10:00',1.81),('5819','2013-06-15','17:15:00',1.74),('5819','2013-06-15','17:20:00',1.67),('5819','2013-06-15','17:25:00',1.6),('5819','2013-06-15','17:30:00',1.52),('5819','2013-06-15','17:35:00',1.45),('5819','2013-06-15','17:40:00',1.38),('5819','2013-06-15','17:45:00',1.2),('5819','2013-06-15','17:50:00',1.12),('5819','2013-06-15','17:55:00',1.08),('5819','2013-06-15','18:00:00',1.03),('5819','2013-06-14','07:15:00',1.04),('5819','2013-06-14','07:20:00',1.11),('5819','2013-06-14','07:25:00',1.2),('5819','2013-06-14','07:30:00',1.27),('5819','2013-06-14','07:35:00',1.35),('5819','2013-06-14','07:40:00',1.45),('5819','2013-06-14','07:45:00',1.53),('5819','2013-06-14','07:50:00',1.61),('5819','2013-06-14','07:55:00',1.69),('5819','2013-06-14','08:00:00',1.76),('5819','2013-06-14','08:05:00',1.84),('5819','2013-06-14','08:10:00',1.9),('5819','2013-06-14','08:15:00',1.98),('5819','2013-06-14','08:20:00',2.06),('5819','2013-06-14','08:25:00',2.13),('5819','2013-06-14','08:30:00',2.21),('5819','2013-06-14','08:35:00',2.27),('5819','2013-06-14','08:40:00',2.33),('5819','2013-06-14','08:45:00',2.41),('5819','2013-06-14','08:50:00',2.47),('5819','2013-06-14','08:55:00',2.53),('5819','2013-06-14','09:00:00',2.59),('5819','2013-06-14','09:05:00',2.65),('5819','2013-06-14','09:10:00',2.7),('5819','2013-06-14','09:15:00',2.75),('5819','2013-06-14','09:20:00',2.81),('5819','2013-06-14','09:25:00',2.85),('5819','2013-06-14','09:30:00',2.9),('5819','2013-06-14','09:35:00',2.97),('5819','2013-06-14','09:40:00',3.03),('5819','2013-06-14','09:45:00',3.09),('5819','2013-06-14','09:50:00',3.15),('5819','2013-06-14','09:55:00',3.19),('5819','2013-06-14','10:00:00',3.25),('5819','2013-06-14','10:05:00',3.25),('5819','2013-06-14','10:10:00',3.24),('5819','2013-06-14','10:15:00',3.29),('5819','2013-06-14','10:20:00',3.35),('5819','2013-06-14','10:25:00',3.33),('5819','2013-06-14','10:30:00',3.42),('5819','2013-06-14','10:35:00',3.49),('5819','2013-06-14','10:40:00',3.49),('5819','2013-06-14','10:45:00',3.55),('5819','2013-06-14','10:50:00',3.54),('5819','2013-06-14','10:55:00',3.51),('5819','2013-06-14','11:00:00',3.49),('5819','2013-06-14','11:05:00',3.52),('5819','2013-06-14','11:10:00',3.61),('5819','2013-06-14','11:15:00',3.68),('5819','2013-06-14','11:20:00',3.62),('5819','2013-06-14','11:25:00',3.55),('5819','2013-06-14','11:30:00',3.73),('5819','2013-06-14','11:35:00',3.73),('5819','2013-06-14','11:40:00',3.73),('5819','2013-06-14','11:45:00',3.74),('5819','2013-06-14','11:50:00',3.78),('5819','2013-06-14','11:55:00',3.76),('5819','2013-06-14','12:00:00',3.75),('5819','2013-06-14','12:05:00',3.74),('5819','2013-06-14','12:10:00',3.79),('5819','2013-06-14','12:15:00',3.77),('5819','2013-06-14','12:20:00',3.76),('5819','2013-06-14','12:25:00',3.76),('5819','2013-06-14','12:30:00',3.77),('5819','2013-06-14','12:35:00',3.74),('5819','2013-06-14','12:40:00',3.76),('5819','2013-06-14','12:45:00',3.75),('5819','2013-06-14','12:50:00',3.7),('5819','2013-06-14','12:55:00',3.72),('5819','2013-06-14','13:00:00',3.75),('5819','2013-06-14','13:05:00',3.77),('5819','2013-06-14','13:10:00',2.84),('5819','2013-06-14','13:15:00',1.74),('5819','2013-06-14','13:20:00',2.4),('5819','2013-06-14','13:25:00',1.45),('5819','2013-06-14','13:30:00',3.17),('5819','2013-06-14','13:35:00',3.31),('5819','2013-06-14','13:40:00',3.79),('5819','2013-06-14','13:45:00',3.7),('5819','2013-06-14','13:50:00',3.72),('5819','2013-06-14','13:55:00',3.71),('5819','2013-06-14','14:00:00',3.68),('5819','2013-06-14','14:05:00',3.74),('5819','2013-06-14','14:10:00',3.7),('5819','2013-06-14','14:15:00',3.66),('5819','2013-06-14','14:20:00',3.58),('5819','2013-06-14','14:25:00',3.55),('5819','2013-06-14','14:30:00',3.55),('5819','2013-06-14','14:35:00',3.56),('5819','2013-06-14','14:40:00',3.51),('5819','2013-06-14','14:45:00',3.42),('5819','2013-06-14','14:50:00',3.39),('5819','2013-06-14','14:55:00',3.37),('5819','2013-06-14','15:00:00',3.35),('5819','2013-06-14','15:05:00',3.3),('5819','2013-06-14','15:10:00',3.29),('5819','2013-06-14','15:15:00',3.24),('5819','2013-06-14','15:20:00',3.19),('5819','2013-06-14','15:25:00',3.13),('5819','2013-06-14','15:30:00',3.08),('5819','2013-06-14','15:35:00',3.04),('5819','2013-06-14','15:40:00',3.02),('5819','2013-06-14','15:45:00',2.96),('5819','2013-06-14','15:50:00',2.91),('5819','2013-06-14','15:55:00',2.84),('5819','2013-06-14','16:00:00',2.78),('5819','2013-06-14','16:05:00',2.72),('5819','2013-06-14','16:10:00',2.67),('5819','2013-06-14','16:15:00',2.61),('5819','2013-06-14','16:20:00',2.57),('5819','2013-06-14','16:25:00',2.48),('5819','2013-06-14','16:30:00',2.4),('5819','2013-06-14','16:35:00',2.35),('5819','2013-06-14','16:40:00',2.26),('5819','2013-06-14','16:45:00',2.2),('5819','2013-06-14','16:50:00',2.14),('5819','2013-06-14','16:55:00',2.05),('5819','2013-06-14','17:00:00',2),('5819','2013-06-14','17:05:00',1.88),('5819','2013-06-14','17:10:00',1.84),('5819','2013-06-14','17:15:00',1.8),('5819','2013-06-14','17:20:00',1.71),('5819','2013-06-14','17:25:00',1.63),('5819','2013-06-14','17:30:00',1.53),('5819','2013-06-14','17:35:00',1.46),('5819','2013-06-14','17:40:00',1.41),('5819','2013-06-14','17:45:00',1.21),('5819','2013-06-14','17:50:00',1.13),('5819','2013-06-14','17:55:00',1.13),('5819','2013-06-14','18:00:00',1.06),('5819','2013-06-13','07:15:00',1.05),('5819','2013-06-13','07:20:00',1.13),('5819','2013-06-13','07:25:00',1.2),('5819','2013-06-13','07:30:00',1.29),('5819','2013-06-13','07:35:00',1.38),('5819','2013-06-13','07:40:00',1.47),('5819','2013-06-13','07:45:00',1.55),('5819','2013-06-13','07:50:00',1.63),('5819','2013-06-13','07:55:00',1.71),('5819','2013-06-13','08:00:00',1.79),('5819','2013-06-13','08:05:00',1.87),('5819','2013-06-13','08:10:00',1.94),('5819','2013-06-13','08:15:00',2.01),('5819','2013-06-13','08:20:00',2.07),('5819','2013-06-13','08:25:00',2.13),('5819','2013-06-13','08:30:00',2.19),('5819','2013-06-13','08:35:00',2.28),('5819','2013-06-13','08:40:00',2.35),('5819','2013-06-13','08:45:00',2.42),('5819','2013-06-13','08:50:00',2.48),('5819','2013-06-13','08:55:00',2.55),('5819','2013-06-13','09:00:00',2.61),('5819','2013-06-13','09:05:00',2.68),('5819','2013-06-13','09:10:00',2.74),('5819','2013-06-13','09:15:00',2.81),('5819','2013-06-13','09:20:00',2.89),('5819','2013-06-13','09:25:00',2.96),('5819','2013-06-13','09:30:00',3.01),('5819','2013-06-13','09:35:00',3.06),('5819','2013-06-13','09:40:00',3.1),('5819','2013-06-13','09:45:00',3.15),('5819','2013-06-13','09:50:00',3.2),('5819','2013-06-13','09:55:00',3.24),('5819','2013-06-13','10:00:00',3.3),('5819','2013-06-13','10:05:00',3.34),('5819','2013-06-13','10:10:00',3.37),('5819','2013-06-13','10:15:00',3.41),('5819','2013-06-13','10:20:00',3.43),('5819','2013-06-13','10:25:00',3.47),('5819','2013-06-13','10:30:00',3.53),('5819','2013-06-13','10:35:00',3.55),('5819','2013-06-13','10:40:00',3.58),('5819','2013-06-13','10:45:00',3.66),('5819','2013-06-13','10:50:00',3.68),('5819','2013-06-13','10:55:00',3.7),('5819','2013-06-13','11:00:00',3.73),('5819','2013-06-13','11:05:00',3.75),('5819','2013-06-13','11:10:00',3.76),('5819','2013-06-13','11:15:00',3.78),('5819','2013-06-13','11:20:00',3.82),('5819','2013-06-13','11:25:00',3.84),('5819','2013-06-13','11:30:00',3.84),('5819','2013-06-13','11:35:00',3.88),('5819','2013-06-13','11:40:00',3.88),('5819','2013-06-13','11:45:00',3.92),('5819','2013-06-13','11:50:00',3.93),('5819','2013-06-13','11:55:00',3.92),('5819','2013-06-13','12:00:00',3.93),('5819','2013-06-13','12:05:00',3.98),('5819','2013-06-13','12:10:00',3.96),('5819','2013-06-13','12:15:00',3.98),('5819','2013-06-13','12:20:00',3.99),('5819','2013-06-13','12:25:00',3.99),('5819','2013-06-13','12:30:00',3.99),('5819','2013-06-13','12:35:00',3.97),('5819','2013-06-13','12:40:00',3.97),('5819','2013-06-13','12:45:00',3.96),('5819','2013-06-13','12:50:00',3.92),('5819','2013-06-13','12:55:00',3.9),('5819','2013-06-13','13:00:00',3.93),('5819','2013-06-13','13:05:00',3.93),('5819','2013-06-13','13:10:00',3.92),('5819','2013-06-13','13:15:00',3.92),('5819','2013-06-13','13:20:00',3.89),('5819','2013-06-13','13:25:00',3.87),('5819','2013-06-13','13:30:00',3.86),('5819','2013-06-13','13:35:00',3.86),('5819','2013-06-13','13:40:00',3.85),('5819','2013-06-13','13:45:00',3.8),('5819','2013-06-13','13:50:00',3.77),('5819','2013-06-13','13:55:00',3.77),('5819','2013-06-13','14:00:00',3.74),('5819','2013-06-13','14:05:00',3.71),('5819','2013-06-13','14:10:00',3.68),('5819','2013-06-13','14:15:00',3.67),('5819','2013-06-13','14:20:00',3.62),('5819','2013-06-13','14:25:00',3.68),('5819','2013-06-13','14:30:00',2.04),('5819','2013-06-13','14:35:00',3.6),('5819','2013-06-13','14:40:00',3.62),('5819','2013-06-13','14:45:00',3.53),('5819','2013-06-13','14:50:00',3.39),('5819','2013-06-13','14:55:00',3.43),('5819','2013-06-13','15:00:00',3.4),('5819','2013-06-13','15:05:00',3.32),('5819','2013-06-13','15:10:00',3.26),('5819','2013-06-13','15:15:00',3.21),('5819','2013-06-13','15:20:00',3.19),('5819','2013-06-13','15:25:00',3.14),('5819','2013-06-13','15:30:00',3.1),('5819','2013-06-13','15:35:00',3.06),('5819','2013-06-13','15:40:00',3.04),('5819','2013-06-13','15:45:00',2.97),('5819','2013-06-13','15:50:00',2.93),('5819','2013-06-13','15:55:00',2.87),('5819','2013-06-13','16:00:00',2.8),('5819','2013-06-13','16:05:00',2.74),('5819','2013-06-13','16:10:00',2.67),('5819','2013-06-13','16:15:00',2.61),('5819','2013-06-13','16:20:00',2.55),('5819','2013-06-13','16:25:00',2.49),('5819','2013-06-13','16:30:00',2.42),('5819','2013-06-13','16:35:00',2.35),('5819','2013-06-13','16:40:00',2.27),('5819','2013-06-13','16:45:00',2.21),('5819','2013-06-13','16:50:00',2.14),('5819','2013-06-13','16:55:00',2.08),('5819','2013-06-13','17:00:00',1.98),('5819','2013-06-13','17:05:00',1.91),('5819','2013-06-13','17:10:00',1.85),('5819','2013-06-13','17:15:00',1.79),('5819','2013-06-13','17:20:00',1.71),('5819','2013-06-13','17:25:00',1.63),('5819','2013-06-13','17:30:00',1.56),('5819','2013-06-13','17:35:00',1.48),('5819','2013-06-13','17:40:00',1.39),('5819','2013-06-13','17:45:00',1.21),('5819','2013-06-13','17:50:00',1.16),('5819','2013-06-13','17:55:00',1.11),('5819','2013-06-13','18:00:00',1.03),('5819','2013-06-12','07:15:00',1.07),('5819','2013-06-12','07:20:00',1.15),('5819','2013-06-12','07:25:00',1.23),('5819','2013-06-12','07:30:00',1.3),('5819','2013-06-12','07:35:00',1.39),('5819','2013-06-12','07:40:00',1.47),('5819','2013-06-12','07:45:00',1.55),('5819','2013-06-12','07:50:00',1.63),('5819','2013-06-12','07:55:00',1.72),('5819','2013-06-12','08:00:00',1.81),('5819','2013-06-12','08:05:00',1.89),('5819','2013-06-12','08:10:00',1.97),('5819','2013-06-12','08:15:00',2.05),('5819','2013-06-12','08:20:00',2.12),('5819','2013-06-12','08:25:00',2.19),('5819','2013-06-12','08:30:00',2.26),('5819','2013-06-12','08:35:00',2.34),('5819','2013-06-12','08:40:00',2.41),('5819','2013-06-12','08:45:00',2.49),('5819','2013-06-12','08:50:00',2.55),('5819','2013-06-12','08:55:00',2.61),('5819','2013-06-12','09:00:00',2.68),('5819','2013-06-12','09:05:00',2.76),('5819','2013-06-12','09:10:00',2.83),('5819','2013-06-12','09:15:00',2.89),('5819','2013-06-12','09:20:00',2.94),('5819','2013-06-12','09:25:00',3),('5819','2013-06-12','09:30:00',3.05),('5819','2013-06-12','09:35:00',3.1),('5819','2013-06-12','09:40:00',3.14),('5819','2013-06-12','09:45:00',3.2),('5819','2013-06-12','09:50:00',3.24),('5819','2013-06-12','09:55:00',3.3),('5819','2013-06-12','10:00:00',3.32),('5819','2013-06-12','10:05:00',3.37),('5819','2013-06-12','10:10:00',3.41),('5819','2013-06-12','10:15:00',3.46),('5819','2013-06-12','10:20:00',3.49),('5819','2013-06-12','10:25:00',3.5),('5819','2013-06-12','10:30:00',3.53),('5819','2013-06-12','10:35:00',3.54),('5819','2013-06-12','10:40:00',3.57),('5819','2013-06-12','10:45:00',3.64),('5819','2013-06-12','10:50:00',3.7),('5819','2013-06-12','10:55:00',3.77),('5819','2013-06-12','11:00:00',3.79),('5819','2013-06-12','11:05:00',3.81),('5819','2013-06-12','11:10:00',3.83),('5819','2013-06-12','11:15:00',3.83),('5819','2013-06-12','11:20:00',3.84),('5819','2013-06-12','11:25:00',3.86),('5819','2013-06-12','11:30:00',3.9),('5819','2013-06-12','11:35:00',3.89),('5819','2013-06-12','11:40:00',3.93),('5819','2013-06-12','11:45:00',3.89),('5819','2013-06-12','11:50:00',3.96),('5819','2013-06-12','11:55:00',3.98),('5819','2013-06-12','12:00:00',3.98),('5819','2013-06-12','12:05:00',4),('5819','2013-06-12','12:10:00',3.96),('5819','2013-06-12','12:15:00',4),('5819','2013-06-12','12:20:00',4),('5819','2013-06-12','12:25:00',4.07),('5819','2013-06-12','12:30:00',4.05),('5819','2013-06-12','12:35:00',3.81),('5819','2013-06-12','12:40:00',2.23),('5819','2013-06-12','12:45:00',2.65),('5819','2013-06-12','12:50:00',4.34),('5819','2013-06-12','12:55:00',3.41),('5819','2013-06-12','13:00:00',3.59),('5819','2013-06-12','13:05:00',4.06),('5819','2013-06-12','13:10:00',3.97),('5819','2013-06-12','13:15:00',3.91),('5819','2013-06-12','13:20:00',3.88),('5819','2013-06-12','13:25:00',3.89),('5819','2013-06-12','13:30:00',3.9),('5819','2013-06-12','13:35:00',3.88),('5819','2013-06-12','13:40:00',3.84),('5819','2013-06-12','13:45:00',3.88),('5819','2013-06-12','13:50:00',3.84),('5819','2013-06-12','13:55:00',3.9),('5819','2013-06-12','14:00:00',3.92),('5819','2013-06-12','14:05:00',2.38),('5819','2013-06-12','14:10:00',3.46),('5819','2013-06-12','14:15:00',3.47),('5819','2013-06-12','14:20:00',2.18),('5819','2013-06-12','14:25:00',1.71),('5819','2013-06-12','14:30:00',3.95),('5819','2013-06-12','14:35:00',3.85),('5819','2013-06-12','14:40:00',3.66),('5819','2013-06-12','14:45:00',3.42),('5819','2013-06-12','14:50:00',3.71),('5819','2013-06-12','14:55:00',3.8),('5819','2013-06-12','15:00:00',3.73),('5819','2013-06-12','15:05:00',3.37),('5819','2013-06-12','15:10:00',3.43),('5819','2013-06-12','15:15:00',2.62),('5819','2013-06-12','15:20:00',3.48),('5819','2013-06-12','15:25:00',3.24),('5819','2013-06-12','15:30:00',3.21),('5819','2013-06-12','15:35:00',3.21),('5819','2013-06-12','15:40:00',3.14),('5819','2013-06-12','15:45:00',3.08),('5819','2013-06-12','15:50:00',2.97),('5819','2013-06-12','15:55:00',3.01),('5819','2013-06-12','16:00:00',2.68),('5819','2013-06-12','16:05:00',2.76),('5819','2013-06-12','16:10:00',2.82),('5819','2013-06-12','16:15:00',2.75),('5819','2013-06-12','16:20:00',2.62),('5819','2013-06-12','16:25:00',2.49),('5819','2013-06-12','16:30:00',2.51),('5819','2013-06-12','16:35:00',2.41),('5819','2013-06-12','16:40:00',2.4),('5819','2013-06-12','16:45:00',1.96),('5819','2013-06-12','16:50:00',2.24),('5819','2013-06-12','16:55:00',2.12),('5819','2013-06-12','17:00:00',2.03),('5819','2013-06-12','17:05:00',1.99),('5819','2013-06-12','17:10:00',1.92),('5819','2013-06-12','17:15:00',1.83),('5819','2013-06-12','17:20:00',1.73),('5819','2013-06-12','17:25:00',1.66),('5819','2013-06-12','17:30:00',1.6),('5819','2013-06-12','17:35:00',1.53),('5819','2013-06-12','17:40:00',1.46),('5819','2013-06-12','17:45:00',1.16),('5819','2013-06-12','18:05:00',1.05),('5819','2013-06-11','07:20:00',1.08),('5819','2013-06-11','07:25:00',1.31),('5819','2013-06-11','07:30:00',1.24),('5819','2013-06-11','07:35:00',1.33),('5819','2013-06-11','07:40:00',1.42),('5819','2013-06-11','07:45:00',1.5),('5819','2013-06-11','07:50:00',1.46),('5819','2013-06-11','08:00:00',1.62),('5819','2013-06-11','08:10:00',1.46),('5819','2013-06-11','08:15:00',2.25),('5819','2013-06-11','08:20:00',2.32),('5819','2013-06-11','08:25:00',2.3),('5819','2013-06-11','08:30:00',2.37),('5819','2013-06-11','08:35:00',2.39),('5819','2013-06-11','08:40:00',2.53),('5819','2013-06-11','08:45:00',2.55),('5819','2013-06-11','08:50:00',2.63),('5819','2013-06-11','08:55:00',2.73),('5819','2013-06-11','09:00:00',2.82),('5819','2013-06-11','09:05:00',2.86),('5819','2013-06-11','09:10:00',2.92),('5819','2013-06-11','09:15:00',2.99),('5819','2013-06-11','09:20:00',3.02),('5819','2013-06-11','09:25:00',3.2),('5819','2013-06-11','09:30:00',3.28),('5819','2013-06-11','09:35:00',3.22),('5819','2013-06-11','09:40:00',1.16),('5819','2013-06-11','09:45:00',1.16),('5819','2013-06-11','09:50:00',2.64),('5819','2013-06-11','09:55:00',3.22),('5819','2013-06-11','10:00:00',2.22),('5819','2013-06-11','10:05:00',2.87),('5819','2013-06-11','10:10:00',1.57),('5819','2013-06-11','10:15:00',3.62),('5819','2013-06-11','10:20:00',3.64),('5819','2013-06-11','10:25:00',3.37),('5819','2013-06-11','10:30:00',3.68),('5819','2013-06-11','10:35:00',3.64),('5819','2013-06-11','10:40:00',2.92),('5819','2013-06-11','10:45:00',3.48),('5819','2013-06-11','10:50:00',3.81),('5819','2013-06-11','10:55:00',3.9),('5819','2013-06-11','11:00:00',3.95),('5819','2013-06-11','11:05:00',3.92),('5819','2013-06-11','11:10:00',3.15),('5819','2013-06-11','11:15:00',3.37),('5819','2013-06-11','11:20:00',4.09),('5819','2013-06-11','11:25:00',2.71),('5819','2013-06-11','11:30:00',3.47),('5819','2013-06-11','11:35:00',4.02),('5819','2013-06-11','11:40:00',4.02),('5819','2013-06-11','11:45:00',3.99),('5819','2013-06-11','11:50:00',4.01),('5819','2013-06-11','11:55:00',4.05),('5819','2013-06-11','12:00:00',3.5),('5819','2013-06-11','12:05:00',2.46),('5819','2013-06-11','12:10:00',4.15),('5819','2013-06-11','12:15:00',4.08),('5819','2013-06-11','12:20:00',4),('5819','2013-06-11','12:25:00',4.11),('5819','2013-06-11','12:30:00',4.11),('5819','2013-06-11','12:35:00',4.12),('5819','2013-06-11','12:40:00',4.1),('5819','2013-06-11','12:45:00',4.09),('5819','2013-06-11','12:50:00',4.08),('5819','2013-06-11','12:55:00',4.12),('5819','2013-06-11','13:00:00',4.12),('5819','2013-06-11','13:05:00',4.12),('5819','2013-06-11','13:10:00',4.12),('5819','2013-06-11','13:15:00',4.13),('5819','2013-06-11','13:20:00',4.09),('5819','2013-06-11','13:25:00',4.06),('5819','2013-06-11','13:30:00',4.02),('5819','2013-06-11','13:35:00',4.06),('5819','2013-06-11','13:40:00',4.1),('5819','2013-06-11','13:45:00',4.08),('5819','2013-06-11','13:50:00',3.84),('5819','2013-06-11','13:55:00',4.1),('5819','2013-06-11','14:00:00',4.02),('5819','2013-06-11','14:05:00',3.94),('5819','2013-06-11','14:10:00',3.88),('5819','2013-06-11','14:15:00',3.84),('5819','2013-06-11','14:20:00',3.8),('5819','2013-06-11','14:25:00',3.77),('5819','2013-06-11','14:30:00',3.72),('5819','2013-06-11','14:35:00',3.72),('5819','2013-06-11','14:40:00',3.67),('5819','2013-06-11','14:45:00',3.63),('5819','2013-06-11','14:50:00',3.59),('5819','2013-06-11','14:55:00',3.54),('5819','2013-06-11','15:00:00',3.5),('5819','2013-06-11','15:05:00',3.45),('5819','2013-06-11','15:10:00',3.42),('5819','2013-06-11','15:15:00',3.38),('5819','2013-06-11','15:20:00',3.33),('5819','2013-06-11','15:25:00',3.25),('5819','2013-06-11','15:30:00',3.2),('5819','2013-06-11','15:35:00',3.23),('5819','2013-06-11','15:40:00',3.08),('5819','2013-06-11','15:45:00',2.32),('5819','2013-06-11','15:50:00',2.98),('5819','2013-06-11','15:55:00',2.78),('5819','2013-06-11','16:00:00',2.97),('5819','2013-06-11','16:05:00',2.93),('5819','2013-06-11','16:10:00',2.87),('5819','2013-06-11','16:15:00',2.79),('5819','2013-06-11','16:20:00',2.71),('5819','2013-06-11','16:25:00',2.65),('5819','2013-06-11','16:30:00',2.59),('5819','2013-06-11','16:35:00',2.55),('5819','2013-06-11','16:40:00',2.58),('5819','2013-06-11','16:45:00',2.69),('5819','2013-06-11','16:50:00',2.72),('5819','2013-06-11','16:55:00',2.57),('5819','2013-06-11','17:00:00',2.4),('5819','2013-06-11','17:05:00',1.96),('5819','2013-06-10','07:30:00',1.25),('5819','2013-06-10','07:35:00',1.71),('5819','2013-06-10','07:40:00',1.11),('5819','2013-06-10','08:00:00',1.14),('5819','2013-06-10','08:05:00',1.64),('5819','2013-06-10','08:10:00',2.13),('5819','2013-06-10','08:15:00',1.8),('5819','2013-06-10','08:20:00',2.18),('5819','2013-06-10','08:25:00',1.33),('5819','2013-06-10','08:30:00',1.31),('5819','2013-06-10','08:35:00',1.17),('5819','2013-06-10','08:55:00',1.12),('5819','2013-06-10','09:00:00',1.3),('5819','2013-06-10','09:05:00',1.06),('5819','2013-06-10','09:10:00',2.03),('5819','2013-06-10','09:15:00',1),('5819','2013-06-10','09:20:00',2.43),('5819','2013-06-10','09:25:00',1.73),('5819','2013-06-10','09:30:00',2.12),('5819','2013-06-10','09:35:00',3.28),('5819','2013-06-10','09:40:00',2.41),('5819','2013-06-10','09:45:00',3.66),('5819','2013-06-10','09:50:00',2.07),('5819','2013-06-10','09:55:00',1.91),('5819','2013-06-10','10:00:00',2.16),('5819','2013-06-10','10:05:00',2.5),('5819','2013-06-10','10:10:00',2.96),('5819','2013-06-10','10:15:00',3.01),('5819','2013-06-10','10:20:00',2.12),('5819','2013-06-10','10:25:00',1.75),('5819','2013-06-10','10:30:00',1.78),('5819','2013-06-10','10:35:00',1.58),('5819','2013-06-10','10:40:00',1.72),('5819','2013-06-10','10:45:00',1.23),('5819','2013-06-10','10:50:00',1.87),('5819','2013-06-10','10:55:00',2.17),('5819','2013-06-10','11:00:00',3.31),('5819','2013-06-10','11:05:00',3.08),('5819','2013-06-10','11:10:00',2.93),('5819','2013-06-10','11:15:00',4.1),('5819','2013-06-10','11:20:00',4.18),('5819','2013-06-10','11:25:00',3.89),('5819','2013-06-10','11:30:00',4.22),('5819','2013-06-10','11:35:00',4.28),('5819','2013-06-10','11:40:00',2.75),('5819','2013-06-10','11:45:00',3.12),('5819','2013-06-10','11:50:00',2.51),('5819','2013-06-10','11:55:00',3.01),('5819','2013-06-10','12:00:00',4.45),('5819','2013-06-10','12:05:00',2.08),('5819','2013-06-10','12:10:00',2.7),('5819','2013-06-10','12:15:00',2.83),('5819','2013-06-10','12:20:00',3.38),('5819','2013-06-10','12:25:00',4.28),('5819','2013-06-10','12:30:00',4.45),('5819','2013-06-10','12:35:00',4.53),('5819','2013-06-10','12:40:00',3.74),('5819','2013-06-10','12:45:00',4.51),('5819','2013-06-10','12:50:00',1.98),('5819','2013-06-10','12:55:00',4.13),('5819','2013-06-10','13:00:00',4.63),('5819','2013-06-10','13:05:00',4.24),('5819','2013-06-10','13:10:00',3.96),('5819','2013-06-10','13:15:00',2.54),('5819','2013-06-10','13:20:00',2.22),('5819','2013-06-10','13:25:00',2.24),('5819','2013-06-10','13:30:00',1.73),('5819','2013-06-10','13:35:00',3.32),('5819','2013-06-10','13:40:00',3.45),('5819','2013-06-10','13:45:00',4.14),('5819','2013-06-10','13:50:00',4.42),('5819','2013-06-10','13:55:00',3.55),('5819','2013-06-10','14:00:00',4.16),('5819','2013-06-10','14:05:00',4.07),('5819','2013-06-10','14:10:00',4.01),('5819','2013-06-10','14:15:00',3.9),('5819','2013-06-10','14:20:00',3.43),('5819','2013-06-10','14:25:00',3.79),('5819','2013-06-10','14:30:00',3.78),('5819','2013-06-10','14:35:00',3.76),('5819','2013-06-10','14:40:00',3.67),('5819','2013-06-10','14:45:00',3.69),('5819','2013-06-10','14:50:00',3.64),('5819','2013-06-10','14:55:00',3.56),('5819','2013-06-10','15:00:00',3.52),('5819','2013-06-10','15:05:00',3.5),('5819','2013-06-10','15:10:00',3.45),('5819','2013-06-10','15:15:00',3.42),('5819','2013-06-10','15:20:00',3.39),('5819','2013-06-10','15:25:00',3.33),('5819','2013-06-10','15:30:00',3.29),('5819','2013-06-10','15:35:00',3.25),('5819','2013-06-10','15:40:00',3.21),('5819','2013-06-10','15:45:00',3.14),('5819','2013-06-10','15:50:00',3.07),('5819','2013-06-10','15:55:00',3.02),('5819','2013-06-10','16:00:00',2.97),('5819','2013-06-10','16:05:00',2.9),('5819','2013-06-10','16:10:00',2.83),('5819','2013-06-10','16:15:00',2.76),('5819','2013-06-10','16:20:00',2.7),('5819','2013-06-10','16:25:00',2.63),('5819','2013-06-10','16:30:00',2.57),('5819','2013-06-10','16:35:00',2.49),('5819','2013-06-10','16:40:00',2.41),('5819','2013-06-10','16:45:00',2.34),('5819','2013-06-10','16:50:00',2.28),('5819','2013-06-10','16:55:00',2.21),('5819','2013-06-10','17:00:00',2.13),('5819','2013-06-10','17:05:00',2.05),('5819','2013-06-10','17:10:00',1.97),('5819','2013-06-10','17:15:00',1.9),('5819','2013-06-10','17:20:00',1.82),('5819','2013-06-10','17:25:00',1.74),('5819','2013-06-10','17:30:00',1.65),('5819','2013-06-10','17:35:00',1.57),('5819','2013-06-10','17:40:00',1.47),('5819','2013-06-10','17:45:00',1.29),('5819','2013-06-10','17:50:00',1.19),('5819','2013-06-10','17:55:00',1.18),('5819','2013-06-10','18:00:00',1.1),('5819','2013-06-10','18:05:00',1.02),('5819','2013-06-09','07:35:00',1.51),('5819','2013-06-09','07:40:00',1.33),('5819','2013-06-09','07:50:00',1.09),('5819','2013-06-09','07:55:00',1.59),('5819','2013-06-09','08:00:00',1.67),('5819','2013-06-09','08:05:00',1.75),('5819','2013-06-09','08:10:00',1.68),('5819','2013-06-09','08:15:00',1.84),('5819','2013-06-09','08:20:00',1.96),('5819','2013-06-09','08:25:00',2.06),('5819','2013-06-09','08:30:00',2.1),('5819','2013-06-09','08:35:00',2.18),('5819','2013-06-09','08:40:00',2.23),('5819','2013-06-09','08:45:00',2.33),('5819','2013-06-09','08:50:00',2.4),('5819','2013-06-09','08:55:00',2.42),('5819','2013-06-09','09:00:00',2.51),('5819','2013-06-09','09:05:00',2.6),('5819','2013-06-09','09:10:00',2.67),('5819','2013-06-09','09:15:00',2.73),('5819','2013-06-09','09:20:00',2.63),('5819','2013-06-09','09:25:00',2.79),('5819','2013-06-09','09:30:00',2.85),('5819','2013-06-09','09:35:00',2.94),('5819','2013-06-09','09:40:00',3.01),('5819','2013-06-09','09:45:00',3.05),('5819','2013-06-09','09:50:00',3.09),('5819','2013-06-09','09:55:00',3.12),('5819','2013-06-09','10:00:00',3.17),('5819','2013-06-09','10:05:00',3.21),('5819','2013-06-09','10:10:00',3.25),('5819','2013-06-09','10:15:00',3.31),('5819','2013-06-09','10:20:00',3.37),('5819','2013-06-09','10:25:00',3.37),('5819','2013-06-09','10:30:00',3.36),('5819','2013-06-09','10:35:00',3.46),('5819','2013-06-09','10:40:00',3.5),('5819','2013-06-09','10:45:00',3.48),('5819','2013-06-09','10:50:00',3.53),('5819','2013-06-09','10:55:00',3.53),('5819','2013-06-09','11:00:00',3.56),('5819','2013-06-09','11:05:00',3.6),('5819','2013-06-09','11:10:00',3.59),('5819','2013-06-09','11:15:00',3.56),('5819','2013-06-09','11:20:00',3.63),('5819','2013-06-09','11:25:00',3.69),('5819','2013-06-09','11:30:00',3.67),('5819','2013-06-09','11:35:00',3.67),('5819','2013-06-09','11:40:00',3.69),('5819','2013-06-09','11:45:00',3.74),('5819','2013-06-09','11:50:00',3.77),('5819','2013-06-09','11:55:00',3.77),('5819','2013-06-09','12:00:00',3.77),('5819','2013-06-09','12:05:00',3.77),('5819','2013-06-09','12:10:00',3.45),('5819','2013-06-09','12:15:00',3.7),('5819','2013-06-09','12:20:00',3.76),('5819','2013-06-09','12:25:00',3.72),('5819','2013-06-09','12:30:00',3.71),('5819','2013-06-09','12:35:00',3.69),('5819','2013-06-09','12:40:00',3.76),('5819','2013-06-09','12:45:00',3.74),('5819','2013-06-09','12:50:00',3.68),('5819','2013-06-09','12:55:00',3.47),('5819','2013-06-09','13:00:00',3.31),('5819','2013-06-09','13:05:00',2.67),('5819','2013-06-09','13:10:00',3.54),('5819','2013-06-09','13:15:00',1.62),('5819','2013-06-09','13:20:00',1.83),('5819','2013-06-09','13:25:00',4.25),('5819','2013-06-09','13:30:00',4.01),('5819','2013-06-09','13:35:00',3.92),('5819','2013-06-09','13:40:00',3.99),('5819','2013-06-09','13:45:00',3.99),('5819','2013-06-09','13:50:00',4.1),('5819','2013-06-09','13:55:00',3.86),('5819','2013-06-09','14:00:00',3.85),('5819','2013-06-09','14:05:00',3.91),('5819','2013-06-09','14:10:00',3.93),('5819','2013-06-09','14:15:00',2.46),('5819','2013-06-09','14:20:00',2),('5819','2013-06-09','14:25:00',1.09),('5819','2013-06-09','14:30:00',1.24),('5819','2013-06-09','14:35:00',2.95),('5819','2013-06-09','14:40:00',3.27),('5819','2013-06-09','14:45:00',3.29),('5819','2013-06-09','14:50:00',3.44),('5819','2013-06-09','14:55:00',3.49),('5819','2013-06-09','15:00:00',3.43),('5819','2013-06-09','15:05:00',3.28),('5819','2013-06-09','15:10:00',3.3),('5819','2013-06-09','15:15:00',3.14),('5819','2013-06-09','15:20:00',3.16),('5819','2013-06-09','15:25:00',3.18),('5819','2013-06-09','15:30:00',3.03),('5819','2013-06-09','15:35:00',3.14),('5819','2013-06-09','15:40:00',2.43),('5819','2013-06-09','15:45:00',2.46),('5819','2013-06-09','15:50:00',2.7),('5819','2013-06-09','15:55:00',3.03),('5819','2013-06-09','16:00:00',1.89),('5819','2013-06-09','16:05:00',2.65),('5819','2013-06-09','16:10:00',2.67),('5819','2013-06-09','16:15:00',1.57),('5819','2013-06-09','16:20:00',1.27),('5819','2013-06-09','16:25:00',1.91),('5819','2013-06-09','16:30:00',1.31),('5819','2013-06-08','07:15:00',1.01),('5819','2013-06-08','07:20:00',1.07),('5819','2013-06-08','07:25:00',1.13),('5819','2013-06-08','07:30:00',1.21),('5819','2013-06-08','07:35:00',1.28),('5819','2013-06-08','07:40:00',1.38),('5819','2013-06-08','07:45:00',1.47),('5819','2013-06-08','07:50:00',1.54),('5819','2013-06-08','07:55:00',1.6),('5819','2013-06-08','08:00:00',1.67),('5819','2013-06-08','08:05:00',1.74),('5819','2013-06-08','08:10:00',1.82),('5819','2013-06-08','08:15:00',1.91),('5819','2013-06-08','08:20:00',2),('5819','2013-06-08','08:25:00',2.07),('5819','2013-06-08','08:30:00',2.14),('5819','2013-06-08','08:35:00',2.22),('5819','2013-06-08','08:40:00',2.29),('5819','2013-06-08','08:45:00',2.37),('5819','2013-06-08','08:50:00',2.45),('5819','2013-06-08','08:55:00',2.5),('5819','2013-06-08','09:00:00',2.55),('5819','2013-06-08','09:05:00',2.64),('5819','2013-06-08','09:10:00',2.71),('5819','2013-06-08','09:15:00',2.74),('5819','2013-06-08','09:20:00',2.78),('5819','2013-06-08','09:25:00',2.82),('5819','2013-06-08','09:30:00',2.88),('5819','2013-06-08','09:35:00',2.91),('5819','2013-06-08','09:40:00',2.97),('5819','2013-06-08','09:45:00',2.99),('5819','2013-06-08','09:50:00',3.01),('5819','2013-06-08','09:55:00',3.01),('5819','2013-06-08','10:00:00',3.04),('5819','2013-06-08','10:05:00',3.18),('5819','2013-06-08','10:10:00',3.33),('5819','2013-06-08','10:15:00',3.35),('5819','2013-06-08','10:20:00',3.36),('5819','2013-06-08','10:25:00',3.4),('5819','2013-06-08','10:30:00',3.43),('5819','2013-06-08','10:35:00',3.49),('5819','2013-06-08','10:40:00',3.55),('5819','2013-06-08','10:45:00',3.47),('5819','2013-06-08','10:50:00',3.67),('5819','2013-06-08','10:55:00',3.1),('5819','2013-06-08','11:00:00',1.39),('5819','2013-06-08','11:05:00',3.9),('5819','2013-06-08','11:10:00',4.1),('5819','2013-06-08','11:15:00',3.97),('5819','2013-06-08','11:20:00',3.96),('5819','2013-06-08','11:25:00',4.07),('5819','2013-06-08','11:30:00',3.79),('5819','2013-06-08','11:35:00',2.29),('5819','2013-06-08','11:40:00',4.1),('5819','2013-06-08','11:45:00',4.02),('5819','2013-06-08','11:50:00',4.05),('5819','2013-06-08','11:55:00',3.57),('5819','2013-06-08','12:00:00',1.27),('5819','2013-06-08','12:05:00',2.75),('5819','2013-06-08','12:10:00',1.05),('5819','2013-06-08','12:15:00',3.13),('5819','2013-06-08','12:20:00',4.27),('5819','2013-06-08','12:25:00',1.08),('5819','2013-06-08','12:30:00',1.51),('5819','2013-06-08','12:35:00',2.87),('5819','2013-06-08','12:40:00',4.14),('5819','2013-06-08','12:45:00',4.12),('5819','2013-06-08','12:50:00',4.12),('5819','2013-06-08','12:55:00',4.08),('5819','2013-06-08','13:00:00',2.23),('5819','2013-06-08','13:05:00',4.09),('5819','2013-06-08','13:10:00',4.12),('5819','2013-06-08','13:15:00',4.14),('5819','2013-06-08','13:20:00',4.12),('5819','2013-06-08','13:25:00',3.99),('5819','2013-06-08','13:30:00',4.04),('5819','2013-06-08','13:35:00',4.01),('5819','2013-06-08','13:40:00',4.03),('5819','2013-06-08','13:45:00',3.96),('5819','2013-06-08','13:50:00',3.9),('5819','2013-06-08','13:55:00',3.89),('5819','2013-06-08','14:00:00',3.84),('5819','2013-06-08','14:05:00',3.82),('5819','2013-06-08','14:10:00',3.82),('5819','2013-06-08','14:15:00',3.81),('5819','2013-06-08','14:20:00',3.75),('5819','2013-06-08','14:25:00',3.7),('5819','2013-06-08','14:30:00',3.69),('5819','2013-06-08','14:35:00',3.64),('5819','2013-06-08','14:40:00',3.61),('5819','2013-06-08','14:45:00',3.58),('5819','2013-06-08','14:50:00',3.57),('5819','2013-06-08','14:55:00',3.52),('5819','2013-06-08','15:00:00',3.53),('5819','2013-06-08','15:05:00',3.4),('5819','2013-06-08','15:10:00',3.15),('5819','2013-06-08','15:15:00',3.28),('5819','2013-06-08','15:20:00',3.34),('5819','2013-06-08','15:25:00',3.14),('5819','2013-06-08','15:30:00',3.2),('5819','2013-06-08','15:35:00',3.32),('5819','2013-06-08','15:40:00',3.24),('5819','2013-06-08','15:45:00',3.25),('5819','2013-06-08','15:50:00',3.2),('5819','2013-06-08','15:55:00',2.98),('5819','2013-06-08','16:00:00',2.94),('5819','2013-06-08','16:05:00',2.89),('5819','2013-06-08','16:10:00',2.83),('5819','2013-06-08','16:15:00',2.9),('5819','2013-06-08','16:20:00',2.81),('5819','2013-06-08','16:25:00',2.67),('5819','2013-06-08','16:30:00',2.5),('5819','2013-06-08','16:35:00',2.41),('5819','2013-06-08','16:40:00',2.33),('5819','2013-06-08','16:45:00',2.28),('5819','2013-06-08','16:50:00',1.95),('5819','2013-06-08','16:55:00',1.96),('5819','2013-06-08','17:00:00',2.08),('5819','2013-06-08','17:05:00',1.54),('5819','2013-06-08','17:10:00',2.11),('5819','2013-06-08','17:15:00',2.12),('5819','2013-06-08','17:20:00',1.98),('5819','2013-06-08','17:25:00',1.8),('5819','2013-06-08','17:30:00',1.08),('5819','2013-06-08','17:40:00',1.29),('5819','2013-06-08','17:45:00',1.42),('5819','2013-06-08','17:50:00',1.27),('5819','2013-06-08','17:55:00',1.35),('5819','2013-06-08','18:00:00',1.04),('5819','2013-06-07','07:15:00',1.07),('5819','2013-06-07','07:20:00',1.14),('5819','2013-06-07','07:25:00',1.22),('5819','2013-06-07','07:30:00',1.3),('5819','2013-06-07','07:35:00',1.4),('5819','2013-06-07','07:40:00',1.48),('5819','2013-06-07','07:45:00',1.57),('5819','2013-06-07','07:50:00',1.66),('5819','2013-06-07','07:55:00',1.73),('5819','2013-06-07','08:00:00',1.81),('5819','2013-06-07','08:05:00',1.9),('5819','2013-06-07','08:10:00',1.97),('5819','2013-06-07','08:15:00',2.05),('5819','2013-06-07','08:20:00',2.13),('5819','2013-06-07','08:25:00',2.22),('5819','2013-06-07','08:30:00',2.3),('5819','2013-06-07','08:35:00',2.37),('5819','2013-06-07','08:40:00',2.45),('5819','2013-06-07','08:45:00',2.53),('5819','2013-06-07','08:50:00',2.61),('5819','2013-06-07','08:55:00',2.68),('5819','2013-06-07','09:00:00',2.73),('5819','2013-06-07','09:05:00',2.8),('5819','2013-06-07','09:10:00',2.86),('5819','2013-06-07','09:15:00',2.92),('5819','2013-06-07','09:20:00',2.97),('5819','2013-06-07','09:25:00',3.03),('5819','2013-06-07','09:30:00',3.09),('5819','2013-06-07','09:35:00',3.17),('5819','2013-06-07','09:40:00',3.24),('5819','2013-06-07','09:45:00',3.3),('5819','2013-06-07','09:50:00',3.33),('5819','2013-06-07','09:55:00',3.38),('5819','2013-06-07','10:00:00',3.42),('5819','2013-06-07','10:05:00',3.46),('5819','2013-06-07','10:10:00',3.52),('5819','2013-06-07','10:15:00',3.55),('5819','2013-06-07','10:20:00',3.58),('5819','2013-06-07','10:25:00',3.64),('5819','2013-06-07','10:30:00',3.68),('5819','2013-06-07','10:35:00',3.68),('5819','2013-06-07','10:40:00',3.72),('5819','2013-06-07','10:45:00',3.74),('5819','2013-06-07','10:50:00',3.77),('5819','2013-06-07','10:55:00',3.79),('5819','2013-06-07','11:00:00',3.82),('5819','2013-06-07','11:05:00',3.85),('5819','2013-06-07','11:10:00',3.87),('5819','2013-06-07','11:15:00',3.88),('5819','2013-06-07','11:20:00',3.89),('5819','2013-06-07','11:25:00',3.91),('5819','2013-06-07','11:30:00',3.92),('5819','2013-06-07','11:35:00',3.95),('5819','2013-06-07','11:40:00',3.97),('5819','2013-06-07','11:45:00',3.97),('5819','2013-06-07','11:50:00',4),('5819','2013-06-07','11:55:00',4),('5819','2013-06-07','12:00:00',4.01),('5819','2013-06-07','12:05:00',4.02),('5819','2013-06-07','12:10:00',4.03),('5819','2013-06-07','12:15:00',4.04),('5819','2013-06-07','12:20:00',4.04),('5819','2013-06-07','12:25:00',4.06),('5819','2013-06-07','12:30:00',4.04),('5819','2013-06-07','12:35:00',4.01),('5819','2013-06-07','12:40:00',4.05),('5819','2013-06-07','12:45:00',4.04),('5819','2013-06-07','12:50:00',4.01),('5819','2013-06-07','12:55:00',3.99),('5819','2013-06-07','13:00:00',3.97),('5819','2013-06-07','13:05:00',3.94),('5819','2013-06-07','13:10:00',3.94),('5819','2013-06-07','13:15:00',3.94),('5819','2013-06-07','13:20:00',3.93),('5819','2013-06-07','13:25:00',3.93),('5819','2013-06-07','13:30:00',3.91),('5819','2013-06-07','13:35:00',3.85),('5819','2013-06-07','13:40:00',3.82),('5819','2013-06-07','13:45:00',3.8),('5819','2013-06-07','13:50:00',3.8),('5819','2013-06-07','13:55:00',3.79),('5819','2013-06-07','14:00:00',3.76),('5819','2013-06-07','14:05:00',3.73),('5819','2013-06-07','14:10:00',3.67),('5819','2013-06-07','14:15:00',3.64),('5819','2013-06-07','14:20:00',3.59),('5819','2013-06-07','14:25:00',3.56),('5819','2013-06-07','14:30:00',3.56),('5819','2013-06-07','14:35:00',3.53),('5819','2013-06-07','14:40:00',3.52),('5819','2013-06-07','14:45:00',3.51),('5819','2013-06-07','14:50:00',3.48),('5819','2013-06-07','14:55:00',3.41),('5819','2013-06-07','15:00:00',3.39),('5819','2013-06-07','15:05:00',3.38),('5819','2013-06-07','15:10:00',3.38),('5819','2013-06-07','15:15:00',3.31),('5819','2013-06-07','15:20:00',3.22),('5819','2013-06-07','15:25:00',3.2),('5819','2013-06-07','15:30:00',3.19),('5819','2013-06-07','15:35:00',3.16),('5819','2013-06-07','15:40:00',3.07),('5819','2013-06-07','15:45:00',3.03),('5819','2013-06-07','15:50:00',2.97),('5819','2013-06-07','15:55:00',2.92),('5819','2013-06-07','16:00:00',2.87),('5819','2013-06-07','16:05:00',2.8),('5819','2013-06-07','16:10:00',2.73),('5819','2013-06-07','16:15:00',2.63),('5819','2013-06-07','16:20:00',2.56),('5819','2013-06-07','16:25:00',2.51),('5819','2013-06-07','16:30:00',2.43),('5819','2013-06-07','16:35:00',2.36),('5819','2013-06-07','16:40:00',2.34),('5819','2013-06-07','16:45:00',2.28),('5819','2013-06-07','16:50:00',2.2),('5819','2013-06-07','16:55:00',2.13),('5819','2013-06-07','17:00:00',2.06),('5819','2013-06-07','17:05:00',1.98),('5819','2013-06-07','17:10:00',1.9),('5819','2013-06-07','17:15:00',1.83),('5819','2013-06-07','17:20:00',1.74),('5819','2013-06-07','17:25:00',1.68),('5819','2013-06-07','17:30:00',1.62),('5819','2013-06-07','17:35:00',1.56),('5819','2013-06-07','17:40:00',1.5),('5819','2013-06-07','17:45:00',1.36),('5819','2013-06-07','17:50:00',1.36),('5819','2013-06-07','17:55:00',1.25),('5819','2013-06-07','18:00:00',1.15),('5819','2013-06-07','18:05:00',1.07),('5819','2013-06-06','07:00:00',1.03),('5819','2013-06-06','07:05:00',1.16),('5819','2013-06-06','07:10:00',1.16),('5819','2013-06-06','07:15:00',1.2),('5819','2013-06-06','07:50:00',1.38),('5819','2013-06-06','07:55:00',1.76),('5819','2013-06-06','08:00:00',1.93),('5819','2013-06-06','08:05:00',1.45),('5819','2013-06-06','08:10:00',1.68),('5819','2013-06-06','08:15:00',1.6),('5819','2013-06-06','08:20:00',1.83),('5819','2013-06-06','08:25:00',2.18),('5819','2013-06-06','08:30:00',2.26),('5819','2013-06-06','08:35:00',2.34),('5819','2013-06-06','08:40:00',2.36),('5819','2013-06-06','08:45:00',2.42),('5819','2013-06-06','08:50:00',2.5),('5819','2013-06-06','08:55:00',2.59),('5819','2013-06-06','09:00:00',2.64),('5819','2013-06-06','09:05:00',2.68),('5819','2013-06-06','09:10:00',2.77),('5819','2013-06-06','09:15:00',2.82),('5819','2013-06-06','09:20:00',2.85),('5819','2013-06-06','09:25:00',2.96),('5819','2013-06-06','09:30:00',2.97),('5819','2013-06-06','09:35:00',3.04),('5819','2013-06-06','09:40:00',3.15),('5819','2013-06-06','09:45:00',3.2),('5819','2013-06-06','09:50:00',3.21),('5819','2013-06-06','09:55:00',3.19),('5819','2013-06-06','10:00:00',3.28),('5819','2013-06-06','10:05:00',3.39),('5819','2013-06-06','10:10:00',3.4),('5819','2013-06-06','10:15:00',3.45),('5819','2013-06-06','10:20:00',3.52),('5819','2013-06-06','10:25:00',3.55),('5819','2013-06-06','10:30:00',3.55),('5819','2013-06-06','10:35:00',3.55),('5819','2013-06-06','10:40:00',3.56),('5819','2013-06-06','10:45:00',3.66),('5819','2013-06-06','10:50:00',3.66),('5819','2013-06-06','10:55:00',3.69),('5819','2013-06-06','11:00:00',3.73),('5819','2013-06-06','11:05:00',3.72),('5819','2013-06-06','11:10:00',3.76),('5819','2013-06-06','11:15:00',3.79),('5819','2013-06-06','11:20:00',3.79),('5819','2013-06-06','11:25:00',3.8),('5819','2013-06-06','11:30:00',3.81),('5819','2013-06-06','11:35:00',3.84),('5819','2013-06-06','11:40:00',3.88),('5819','2013-06-06','11:45:00',3.82),('5819','2013-06-06','11:50:00',3.81),('5819','2013-06-06','11:55:00',3.78),('5819','2013-06-06','12:00:00',3.8),('5819','2013-06-06','12:05:00',3.91),('5819','2013-06-06','12:10:00',3.93),('5819','2013-06-06','12:15:00',3.93),('5819','2013-06-06','12:20:00',3.93),('5819','2013-06-06','12:25:00',3.96),('5819','2013-06-06','12:30:00',3.96),('5819','2013-06-06','12:35:00',3.91),('5819','2013-06-06','12:40:00',3.94),('5819','2013-06-06','12:45:00',3.94),('5819','2013-06-06','12:50:00',3.95),('5819','2013-06-06','12:55:00',3.95),('5819','2013-06-06','13:00:00',3.95),('5819','2013-06-06','13:05:00',3.96),('5819','2013-06-06','13:10:00',3.95),('5819','2013-06-06','13:15:00',3.96),('5819','2013-06-06','13:20:00',3.98),('5819','2013-06-06','13:25:00',3.95),('5819','2013-06-06','13:30:00',3.98),('5819','2013-06-06','13:35:00',3.89),('5819','2013-06-06','13:40:00',3.9),('5819','2013-06-06','13:45:00',3.88),('5819','2013-06-06','13:50:00',3.82),('5819','2013-06-06','13:55:00',3.79),('5819','2013-06-06','14:00:00',3.82),('5819','2013-06-06','14:05:00',3.83),('5819','2013-06-06','14:10:00',3.76),('5819','2013-06-06','14:15:00',3.35),('5819','2013-06-06','14:20:00',3.64),('5819','2013-06-06','14:25:00',3.18),('5819','2013-06-06','14:30:00',3.67),('5819','2013-06-06','14:35:00',3.67),('5819','2013-06-06','14:40:00',3.72),('5819','2013-06-06','14:45:00',2.58),('5819','2013-06-06','14:50:00',2.8),('5819','2013-06-06','14:55:00',3.89),('5819','2013-06-06','15:00:00',3.68),('5819','2013-06-06','15:05:00',3.51),('5819','2013-06-06','15:10:00',3.42),('5819','2013-06-06','15:15:00',3.16),('5819','2013-06-06','15:20:00',3.37),('5819','2013-06-06','15:25:00',3.29),('5819','2013-06-06','15:30:00',3.17),('5819','2013-06-06','15:35:00',3.08),('5819','2013-06-06','15:40:00',3.11),('5819','2013-06-06','15:45:00',3.07),('5819','2013-06-06','15:50:00',2.96),('5819','2013-06-06','15:55:00',2.78),('5819','2013-06-06','16:00:00',2.89),('5819','2013-06-06','16:05:00',2.88),('5819','2013-06-06','16:10:00',2.65),('5819','2013-06-06','16:15:00',2.59),('5819','2013-06-06','16:20:00',2.48),('5819','2013-06-06','16:25:00',2.48),('5819','2013-06-06','16:30:00',2.47),('5819','2013-06-06','16:35:00',2.45),('5819','2013-06-06','16:40:00',2.37),('5819','2013-06-06','16:45:00',2.22),('5819','2013-06-06','16:50:00',2.12),('5819','2013-06-06','16:55:00',2.04),('5819','2013-06-06','17:00:00',2),('5819','2013-06-06','17:05:00',1.9),('5819','2013-06-06','17:10:00',1.83),('5819','2013-06-06','17:15:00',1.75),('5819','2013-06-06','17:20:00',1.7),('5819','2013-06-06','17:25:00',1.61),('5819','2013-06-06','17:30:00',1.54),('5819','2013-06-06','17:35:00',1.48),('5819','2013-06-06','17:40:00',1.37),('5819','2013-06-06','17:45:00',1.18),('5819','2013-06-06','17:50:00',1.18),('5819','2013-06-06','17:55:00',1.1),('5819','2013-06-06','18:00:00',1.04),('5819','2013-06-05','07:00:00',1.02),('5819','2013-06-05','07:55:00',1.35),('5819','2013-06-05','08:00:00',1.49),('5819','2013-06-05','08:10:00',1.47),('5819','2013-06-05','08:15:00',1.89),('5819','2013-06-05','08:20:00',2.09),('5819','2013-06-05','08:25:00',2.2),('5819','2013-06-05','08:30:00',2.26),('5819','2013-06-05','08:35:00',2.34),('5819','2013-06-05','08:40:00',2.4),('5819','2013-06-05','08:45:00',2.49),('5819','2013-06-05','08:50:00',2.52),('5819','2013-06-05','08:55:00',2.65),('5819','2013-06-05','09:00:00',2.6),('5819','2013-06-05','09:05:00',2.75),('5819','2013-06-05','09:10:00',2.78),('5819','2013-06-05','09:15:00',2.89),('5819','2013-06-05','09:20:00',3.1),('5819','2013-06-05','09:25:00',2.88),('5819','2013-06-05','09:30:00',3.16),('5819','2013-06-05','09:35:00',3.33),('5819','2013-06-05','09:40:00',3.5),('5819','2013-06-05','09:45:00',3.17),('5819','2013-06-05','09:50:00',3.02),('5819','2013-06-05','09:55:00',1.99),('5819','2013-06-05','10:00:00',1.84),('5819','2013-06-05','10:05:00',3.69),('5819','2013-06-05','10:10:00',1.55),('5819','2013-06-05','10:15:00',1.74),('5819','2013-06-05','10:20:00',1.45),('5819','2013-06-05','10:25:00',2.68),('5819','2013-06-05','10:30:00',1.73),('5819','2013-06-05','10:35:00',3.35),('5819','2013-06-05','10:40:00',2.6),('5819','2013-06-05','10:45:00',3.37),('5819','2013-06-05','10:50:00',3.43),('5819','2013-06-05','10:55:00',3.95),('5819','2013-06-05','11:00:00',3.98),('5819','2013-06-05','11:05:00',4.06),('5819','2013-06-05','11:10:00',1.68),('5819','2013-06-05','11:15:00',1.29),('5819','2013-06-05','11:20:00',1.58),('5819','2013-06-05','11:25:00',1.04),('5819','2013-06-05','11:30:00',1.13),('5819','2013-06-05','11:35:00',1.74),('5819','2013-06-05','11:40:00',2.03),('5819','2013-06-05','11:45:00',4.14),('5819','2013-06-05','11:50:00',3.37),('5819','2013-06-05','11:55:00',3.4),('5819','2013-06-05','12:00:00',1.43),('5819','2013-06-05','12:05:00',2.67),('5819','2013-06-05','12:10:00',4.6),('5819','2013-06-05','12:15:00',2.33),('5819','2013-06-05','12:20:00',4.24),('5819','2013-06-05','12:25:00',4.62),('5819','2013-06-05','12:30:00',4.44),('5819','2013-06-05','12:35:00',3.34),('5819','2013-06-05','12:40:00',3.41),('5819','2013-06-05','12:45:00',3.24),('5819','2013-06-05','12:50:00',3.29),('5819','2013-06-05','12:55:00',1.45),('5819','2013-06-05','13:00:00',1.86),('5819','2013-06-05','13:05:00',3.09),('5819','2013-06-05','13:10:00',2.27),('5819','2013-06-05','13:15:00',1.94),('5819','2013-06-05','13:20:00',2.46),('5819','2013-06-05','13:25:00',3.85),('5819','2013-06-05','13:30:00',2.99),('5819','2013-06-05','13:35:00',4.72),('5819','2013-06-05','13:40:00',4.44),('5819','2013-06-05','13:45:00',4.3),('5819','2013-06-05','13:50:00',4.15),('5819','2013-06-05','13:55:00',4.1),('5819','2013-06-05','14:00:00',4.04),('5819','2013-06-05','14:05:00',3.98),('5819','2013-06-05','14:10:00',3.84),('5819','2013-06-05','14:15:00',3.92),('5819','2013-06-05','14:20:00',3.91),('5819','2013-06-05','14:25:00',3.83),('5819','2013-06-05','14:30:00',3.78),('5819','2013-06-05','14:35:00',3.73),('5819','2013-06-05','14:40:00',3.71),('5819','2013-06-05','14:45:00',3.74),('5819','2013-06-05','14:50:00',3.68),('5819','2013-06-05','14:55:00',3.64),('5819','2013-06-05','15:00:00',3.54),('5819','2013-06-05','15:05:00',3.46),('5819','2013-06-05','15:10:00',3.44),('5819','2013-06-05','15:15:00',3.42),('5819','2013-06-05','15:20:00',3.28),('5819','2013-06-05','15:25:00',3.37),('5819','2013-06-05','15:30:00',3.31),('5819','2013-06-05','15:35:00',3.09),('5819','2013-06-05','15:40:00',3.26),('5819','2013-06-05','15:45:00',3.13),('5819','2013-06-05','15:50:00',3.13),('5819','2013-06-05','15:55:00',3.06),('5819','2013-06-05','16:00:00',3),('5819','2013-06-05','16:05:00',2.94),('5819','2013-06-05','16:10:00',2.83),('5819','2013-06-05','16:15:00',2.79),('5819','2013-06-05','16:20:00',2.7),('5819','2013-06-05','16:25:00',2.65),('5819','2013-06-05','16:30:00',2.53),('5819','2013-06-05','16:35:00',2.48),('5819','2013-06-05','16:40:00',2.41),('5819','2013-06-05','16:45:00',2.34),('5819','2013-06-05','16:50:00',2.29),('5819','2013-06-05','16:55:00',2.21),('5819','2013-06-05','17:00:00',2.13),('5819','2013-06-05','17:05:00',2.03),('5819','2013-06-05','17:10:00',1.66),('5819','2013-06-05','17:15:00',1.48),('5819','2013-06-05','17:20:00',1.07),('5819','2013-06-05','17:25:00',1.49),('5819','2013-06-05','17:30:00',1.74),('5819','2013-06-05','17:35:00',1.52),('5819','2013-06-05','17:40:00',1.34),('5819','2013-06-05','17:45:00',1.21),('5819','2013-06-05','17:50:00',1.17),('5819','2013-06-05','17:55:00',1.15),('5819','2013-06-05','18:00:00',1.07),('5819','2013-06-04','07:15:00',1.09),('5819','2013-06-04','07:20:00',1.13),('5819','2013-06-04','07:25:00',1.21),('5819','2013-06-04','07:30:00',1.26),('5819','2013-06-04','07:35:00',1.38),('5819','2013-06-04','07:40:00',1.5),('5819','2013-06-04','07:45:00',1.66),('5819','2013-06-04','07:50:00',1.79),('5819','2013-06-04','07:55:00',1.9),('5819','2013-06-04','08:00:00',2.06),('5819','2013-06-04','08:05:00',2.19),('5819','2013-06-04','08:10:00',2.25),('5819','2013-06-04','08:15:00',2.31),('5819','2013-06-04','08:20:00',2.36),('5819','2013-06-04','08:25:00',2.16),('5819','2013-06-04','08:30:00',1.87),('5819','2013-06-04','08:35:00',2.55),('5819','2013-06-04','08:40:00',2.31),('5819','2013-06-04','08:45:00',1.98),('5819','2013-06-04','08:50:00',1.31),('5819','2013-06-04','08:55:00',1.35),('5819','2013-06-04','09:00:00',1.52),('5819','2013-06-04','09:05:00',1.88),('5819','2013-06-04','09:10:00',2.32),('5819','2013-06-04','09:15:00',2.75),('5819','2013-06-04','09:20:00',2.8),('5819','2013-06-04','09:25:00',3.7),('5819','2013-06-04','09:30:00',3.03),('5819','2013-06-04','09:35:00',2.74),('5819','2013-06-04','09:40:00',1.67),('5819','2013-06-04','09:45:00',1.83),('5819','2013-06-04','09:50:00',1.61),('5819','2013-06-04','09:55:00',1.51),('5819','2013-06-04','10:00:00',1.91),('5819','2013-06-04','10:05:00',2.08),('5819','2013-06-04','10:10:00',3.29),('5819','2013-06-04','10:15:00',2.98),('5819','2013-06-04','10:20:00',1.83),('5819','2013-06-04','10:25:00',1.71),('5819','2013-06-04','10:30:00',1.61),('5819','2013-06-04','10:35:00',1.66),('5819','2013-06-04','10:40:00',1.74),('5819','2013-06-04','10:45:00',1.99),('5819','2013-06-04','10:50:00',2.73),('5819','2013-06-04','10:55:00',3.32),('5819','2013-06-04','11:00:00',2.24),('5819','2013-06-04','11:05:00',2.61),('5819','2013-06-04','11:10:00',3.1),('5819','2013-06-04','11:15:00',2.99),('5819','2013-06-04','11:20:00',2.15),('5819','2013-06-04','11:25:00',2.77),('5819','2013-06-04','11:30:00',3.32),('5819','2013-06-04','11:35:00',2.73),('5819','2013-06-04','11:40:00',2.91),('5819','2013-06-04','11:45:00',3.91),('5819','2013-06-04','11:50:00',4.38),('5819','2013-06-04','11:55:00',3.8),('5819','2013-06-04','12:00:00',3.18),('5819','2013-06-04','12:05:00',2.83),('5819','2013-06-04','12:10:00',2.26),('5819','2013-06-04','12:15:00',2.46),('5819','2013-06-04','12:20:00',1.79),('5819','2013-06-04','12:25:00',1.96),('5819','2013-06-04','12:30:00',2.62),('5819','2013-06-04','12:35:00',3.68),('5819','2013-06-04','12:40:00',2.39),('5819','2013-06-04','12:45:00',2.74),('5819','2013-06-04','12:50:00',2.41),('5819','2013-06-04','12:55:00',1.71),('5819','2013-06-04','13:00:00',2.03),('5819','2013-06-04','13:05:00',1.49),('5819','2013-06-04','13:10:00',1.29),('5819','2013-06-04','13:15:00',1.31),('5819','2013-06-04','13:20:00',1.12),('5819','2013-06-04','13:25:00',1.4),('5819','2013-06-04','13:30:00',1.72),('5819','2013-06-04','13:35:00',3.85),('5819','2013-06-04','13:40:00',3.57),('5819','2013-06-04','13:45:00',4.86),('5819','2013-06-04','13:50:00',4.77),('5819','2013-06-04','13:55:00',2.65),('5819','2013-06-04','14:00:00',1.74),('5819','2013-06-04','14:05:00',3.83),('5819','2013-06-04','14:10:00',4.6),('5819','2013-06-04','14:15:00',4.16),('5819','2013-06-04','14:20:00',3.17),('5819','2013-06-04','14:25:00',2.32),('5819','2013-06-04','14:30:00',1.39),('5819','2013-06-04','14:35:00',1.73),('5819','2013-06-04','14:40:00',2.31),('5819','2013-06-04','14:45:00',1.04),('5819','2013-06-04','14:55:00',3.04),('5819','2013-06-04','15:00:00',4.72),('5819','2013-06-04','15:05:00',4.52),('5819','2013-06-04','15:10:00',2.38),('5819','2013-06-03','07:40:00',1.21),('5819','2013-06-03','07:45:00',1.57),('5819','2013-06-03','07:50:00',1.6),('5819','2013-06-03','07:55:00',1.74),('5819','2013-06-03','08:00:00',1.82),('5819','2013-06-03','08:05:00',1.86),('5819','2013-06-03','08:10:00',1.94),('5819','2013-06-03','08:15:00',2.01),('5819','2013-06-03','08:20:00',2.08),('5819','2013-06-03','08:25:00',2.18),('5819','2013-06-03','08:30:00',2.25),('5819','2013-06-03','08:35:00',2.32),('5819','2013-06-03','08:40:00',2.39),('5819','2013-06-03','08:45:00',2.49),('5819','2013-06-03','08:50:00',2.51),('5819','2013-06-03','08:55:00',2.51),('5819','2013-06-03','09:00:00',2.65),('5819','2013-06-03','09:05:00',2.76),('5819','2013-06-03','09:10:00',2.92),('5819','2013-06-03','09:15:00',3.05),('5819','2013-06-03','09:20:00',2.46),('5819','2013-06-03','09:25:00',2.77),('5819','2013-06-03','09:30:00',2.66),('5819','2013-06-03','09:35:00',1.87),('5819','2013-06-03','09:40:00',2.14),('5819','2013-06-03','09:45:00',2.51),('5819','2013-06-03','09:50:00',3.62),('5819','2013-06-03','09:55:00',3.81),('5819','2013-06-03','10:00:00',4.06),('5819','2013-06-03','10:05:00',4.12),('5819','2013-06-03','10:10:00',3.5),('5819','2013-06-03','10:15:00',2.42),('5819','2013-06-03','10:20:00',1.35),('5819','2013-06-03','10:25:00',1.67),('5819','2013-06-03','10:30:00',1.28),('5819','2013-06-03','10:35:00',1.27),('5819','2013-06-03','10:40:00',1.65),('5819','2013-06-03','10:45:00',1.72),('5819','2013-06-03','10:50:00',3.31),('5819','2013-06-03','10:55:00',4.6),('5819','2013-06-03','11:00:00',2.26),('5819','2013-06-03','11:05:00',1.63),('5819','2013-06-03','11:10:00',1.24),('5819','2013-06-03','11:15:00',1.31),('5819','2013-06-03','11:20:00',1.63),('5819','2013-06-03','11:25:00',1.66),('5819','2013-06-03','11:30:00',1.43),('5819','2013-06-03','11:35:00',1.32),('5819','2013-06-03','11:40:00',1.45),('5819','2013-06-03','11:45:00',2.51),('5819','2013-06-03','11:50:00',1.61),('5819','2013-06-03','11:55:00',1.59),('5819','2013-06-03','12:00:00',1.63),('5819','2013-06-03','12:05:00',3.67),('5819','2013-06-03','12:10:00',1.64),('5819','2013-06-03','12:15:00',1.34),('5819','2013-06-03','12:20:00',1.49),('5819','2013-06-03','12:25:00',1.41),('5819','2013-06-03','12:30:00',1.59),('5819','2013-06-03','12:35:00',1.64),('5819','2013-06-03','12:40:00',4.01),('5819','2013-06-03','12:45:00',2.38),('5819','2013-06-03','12:50:00',2.63),('5819','2013-06-03','12:55:00',2.53),('5819','2013-06-03','13:00:00',1.92),('5819','2013-06-03','13:05:00',1.68),('5819','2013-06-03','13:10:00',1.8),('5819','2013-06-03','13:15:00',2.34),('5819','2013-06-03','13:20:00',4.44),('5819','2013-06-03','13:25:00',3.12),('5819','2013-06-03','13:30:00',3.53),('5819','2013-06-03','13:35:00',3.85),('5819','2013-06-03','13:40:00',4.52),('5819','2013-06-03','13:45:00',2.27),('5819','2013-06-03','13:50:00',4.74),('5819','2013-06-03','13:55:00',2.93),('5819','2013-06-03','14:00:00',4.01),('5819','2013-06-03','14:05:00',4.08),('5819','2013-06-03','14:10:00',2.19),('5819','2013-06-03','14:15:00',2.17),('5819','2013-06-03','14:20:00',1.68),('5819','2013-06-03','14:25:00',2.74),('5819','2013-06-03','14:30:00',4.21),('5819','2013-06-03','14:35:00',4.34),('5819','2013-06-03','14:40:00',3.24),('5819','2013-06-03','14:45:00',3.38),('5819','2013-06-03','14:50:00',3.04),('5819','2013-06-03','14:55:00',3.25),('5819','2013-06-03','15:00:00',3.29),('5819','2013-06-03','15:05:00',2.85),('5819','2013-06-03','15:10:00',3.48),('5819','2013-06-03','15:15:00',2.18),('5819','2013-06-03','15:20:00',2.94),('5819','2013-06-03','15:25:00',3.47),('5819','2013-06-03','15:30:00',3.36),('5819','2013-06-03','15:35:00',3.31),('5819','2013-06-03','15:40:00',3.24),('5819','2013-06-03','15:45:00',3.19),('5819','2013-06-03','15:50:00',3.15),('5819','2013-06-03','15:55:00',3.1),('5819','2013-06-03','16:00:00',3.03),('5819','2013-06-03','16:05:00',2.97),('5819','2013-06-03','16:10:00',2.93),('5819','2013-06-03','16:15:00',2.77),('5819','2013-06-03','16:20:00',2.72),('5819','2013-06-03','16:25:00',2.69),('5819','2013-06-03','16:30:00',2.78),('5819','2013-06-03','16:35:00',2.62),('5819','2013-06-03','16:40:00',2.6),('5819','2013-06-03','16:45:00',2.25),('5819','2013-06-03','16:50:00',1.74),('5819','2013-06-03','16:55:00',1.6),('5819','2013-06-03','17:00:00',1.97),('5819','2013-06-03','17:05:00',2.22),('5819','2013-06-03','17:10:00',2.41),('5819','2013-06-03','17:15:00',2.06),('5819','2013-06-03','17:20:00',1.79),('5819','2013-06-03','17:25:00',1.23),('5819','2013-06-02','06:55:00',1.17),('5819','2013-06-02','07:00:00',1.23),('5819','2013-06-02','08:50:00',1.06),('5819','2013-06-02','09:10:00',1.11),('5819','2013-06-02','09:15:00',1.2),('5819','2013-06-02','09:20:00',1.69),('5819','2013-06-02','09:25:00',3.47),('5819','2013-06-02','09:30:00',3.3),('5819','2013-06-02','09:35:00',3.26),('5819','2013-06-02','09:40:00',3.26),('5819','2013-06-02','09:45:00',3.28),('5819','2013-06-02','09:50:00',3.33),('5819','2013-06-02','09:55:00',3.37),('5819','2013-06-02','10:00:00',3.39),('5819','2013-06-02','10:05:00',3.51),('5819','2013-06-02','10:10:00',3.55),('5819','2013-06-02','10:15:00',3.56),('5819','2013-06-02','10:20:00',3.59),('5819','2013-06-02','10:25:00',3.69),('5819','2013-06-02','10:30:00',3.75),('5819','2013-06-02','10:35:00',3.9),('5819','2013-06-02','10:40:00',3.96),('5819','2013-06-02','10:45:00',3.38),('5819','2013-06-02','10:50:00',1.44),('5819','2013-06-02','10:55:00',1.64),('5819','2013-06-02','11:00:00',4.05),('5819','2013-06-02','11:05:00',3.75),('5819','2013-06-02','11:10:00',4.09),('5819','2013-06-02','11:15:00',3.14),('5819','2013-06-02','11:20:00',3.75),('5819','2013-06-02','11:25:00',2.18),('5819','2013-06-02','11:30:00',4.14),('5819','2013-06-02','11:35:00',2.41),('5819','2013-06-02','11:40:00',1.63),('5819','2013-06-02','11:45:00',1.22),('5819','2013-06-02','11:50:00',1.73),('5819','2013-06-02','11:55:00',4.64),('5819','2013-06-02','12:00:00',4.09),('5819','2013-06-02','12:05:00',2.62),('5819','2013-06-02','12:10:00',3.58),('5819','2013-06-02','12:15:00',4.46),('5819','2013-06-02','12:20:00',2.64),('5819','2013-06-02','12:25:00',2.34),('5819','2013-06-02','12:30:00',3.55),('5819','2013-06-02','12:35:00',4.72),('5819','2013-06-02','12:40:00',3.2),('5819','2013-06-02','12:45:00',4.1),('5819','2013-06-02','12:50:00',2.28),('5819','2013-06-02','12:55:00',1.23),('5819','2013-06-02','13:00:00',2.72),('5819','2013-06-02','13:05:00',2.5),('5819','2013-06-02','13:10:00',1.7),('5819','2013-06-02','13:15:00',4.77),('5819','2013-06-02','13:20:00',4.35),('5819','2013-06-02','13:25:00',4.18),('5819','2013-06-02','13:30:00',4.12),('5819','2013-06-02','13:35:00',4.09),('5819','2013-06-02','13:40:00',4.05),('5819','2013-06-02','13:45:00',4),('5819','2013-06-02','13:50:00',3.97),('5819','2013-06-02','13:55:00',3.96),('5819','2013-06-02','14:00:00',3.96),('5819','2013-06-02','14:05:00',3.93),('5819','2013-06-02','14:10:00',3.91),('5819','2013-06-02','14:15:00',3.93),('5819','2013-06-02','14:20:00',3.8),('5819','2013-06-02','14:25:00',3.83),('5819','2013-06-02','14:30:00',3.81),('5819','2013-06-02','14:35:00',3.75),('5819','2013-06-02','14:40:00',3.71),('5819','2013-06-02','14:45:00',3.67),('5819','2013-06-02','14:50:00',3.6),('5819','2013-06-02','14:55:00',3.57),('5819','2013-06-02','15:00:00',3.53),('5819','2013-06-02','15:05:00',3.5),('5819','2013-06-02','15:10:00',3.47),('5819','2013-06-02','15:15:00',3.46),('5819','2013-06-02','15:20:00',3.41),('5819','2013-06-02','15:25:00',3.02),('5819','2013-06-02','15:30:00',3),('5819','2013-06-02','15:35:00',2.99),('5819','2013-06-02','15:40:00',2.42),('5819','2013-06-02','15:45:00',2.67),('5819','2013-06-02','15:50:00',3.14),('5819','2013-06-02','15:55:00',2.8),('5819','2013-06-02','16:00:00',2.64),('5819','2013-06-02','16:05:00',2.96),('5819','2013-06-02','16:10:00',2.95),('5819','2013-06-02','16:15:00',2.93),('5819','2013-06-02','16:20:00',2.73),('5819','2013-06-02','16:25:00',2.75),('5819','2013-06-02','16:30:00',2.61),('5819','2013-06-02','16:35:00',2.51),('5819','2013-06-02','16:40:00',2.57),('5819','2013-06-02','16:45:00',2.27),('5819','2013-06-02','16:50:00',2.26),('5819','2013-06-02','16:55:00',2.29),('5819','2013-06-02','17:00:00',2.06),('5819','2013-06-02','17:05:00',1.73),('5819','2013-06-02','17:10:00',2.04),('5819','2013-06-02','17:15:00',1.67),('5819','2013-06-02','17:20:00',1.83),('5819','2013-06-02','17:25:00',1.73),('5819','2013-06-02','17:30:00',1.69),('5819','2013-06-02','17:35:00',1.46),('5819','2013-06-02','17:40:00',1.02),('5819','2013-06-01','07:10:00',1.02),('5819','2013-06-01','07:15:00',1.08),('5819','2013-06-01','07:20:00',1.19),('5819','2013-06-01','07:25:00',1.26),('5819','2013-06-01','07:30:00',1.34),('5819','2013-06-01','07:35:00',1.42),('5819','2013-06-01','07:40:00',1.53),('5819','2013-06-01','07:45:00',1.74),('5819','2013-06-01','07:55:00',1.49),('5819','2013-06-01','08:15:00',1.21),('5819','2013-06-01','08:20:00',1.49),('5819','2013-06-01','08:35:00',1.91),('5819','2013-06-01','09:50:00',1.05),('5819','2013-06-01','10:40:00',1.19),('5819','2013-06-01','10:50:00',1.82),('5819','2013-06-01','10:55:00',2.24),('5819','2013-06-01','11:50:00',1.23),('5819','2013-06-01','11:55:00',1.74),('5819','2013-06-01','12:00:00',1.97),('5819','2013-06-01','12:05:00',2.98),('5819','2013-06-01','12:10:00',2.84),('5819','2013-06-01','12:15:00',1.7),('5819','2013-06-01','12:20:00',1.02),('5819','2013-06-01','12:25:00',1.12),('5819','2013-06-01','12:30:00',1.15),('5819','2013-06-01','12:45:00',1.47),('5819','2013-06-01','12:50:00',1.77),('5819','2013-06-01','12:55:00',1.68),('5819','2013-06-01','13:00:00',1.95),('5819','2013-06-01','13:05:00',2.17),('5819','2013-06-01','13:10:00',2.26),('5819','2013-06-01','13:15:00',2.48),('5819','2013-06-01','13:20:00',2.3),('5819','2013-06-01','13:25:00',1.74),('5819','2013-06-01','13:30:00',1.58),('5819','2013-06-01','13:35:00',1.24),('5819','2013-06-01','13:40:00',1.09),('5819','2013-06-01','13:45:00',1.16),('5819','2013-06-01','13:50:00',1.24),('5819','2013-06-01','13:55:00',1.38),('5819','2013-06-01','14:00:00',1.78),('5819','2013-06-01','14:05:00',2.28),('5819','2013-06-01','14:10:00',2.25),('5819','2013-06-01','14:15:00',2.34),('5819','2013-06-01','14:20:00',2.62),('5819','2013-06-01','14:25:00',1.68),('5819','2013-06-01','14:30:00',1.3),('5819','2013-06-01','14:35:00',1.34),('5819','2013-06-01','14:40:00',1.29),('5819','2013-06-01','14:45:00',1.19),('5819','2013-06-01','14:50:00',1.06),('5819','2013-06-01','18:35:00',1.01),('5819','2013-05-31','07:15:00',1.05),('5819','2013-05-31','07:20:00',1.16),('5819','2013-05-31','07:25:00',1.25),('5819','2013-05-31','07:30:00',1.35),('5819','2013-05-31','07:35:00',1.43),('5819','2013-05-31','07:40:00',1.53),('5819','2013-05-31','07:45:00',1.59),('5819','2013-05-31','07:50:00',1.68),('5819','2013-05-31','07:55:00',1.81),('5819','2013-05-31','08:00:00',1.94),('5819','2013-05-31','08:05:00',1.97),('5819','2013-05-31','08:10:00',2.06),('5819','2013-05-31','08:15:00',2.13),('5819','2013-05-31','08:20:00',2.21),('5819','2013-05-31','08:25:00',2.28),('5819','2013-05-31','08:30:00',2.41),('5819','2013-05-31','08:35:00',1.4),('5819','2013-05-31','08:40:00',2.81),('5819','2013-05-31','08:45:00',2.85),('5819','2013-05-31','08:50:00',3.14),('5819','2013-05-31','08:55:00',1.78),('5819','2013-05-31','09:10:00',1.13),('5819','2013-05-31','09:15:00',1.88),('5819','2013-05-31','09:30:00',1.27),('5819','2013-05-31','09:35:00',1.99),('5819','2013-05-31','09:40:00',1.91),('5819','2013-05-31','09:45:00',3.73),('5819','2013-05-31','09:50:00',3.68),('5819','2013-05-31','09:55:00',3.78),('5819','2013-05-31','10:00:00',3.47),('5819','2013-05-31','10:05:00',3.3),('5819','2013-05-31','10:10:00',2.38),('5819','2013-05-31','10:15:00',2.32),('5819','2013-05-31','10:20:00',3.08),('5819','2013-05-31','10:25:00',1.21),('5819','2013-05-31','10:35:00',2.02),('5819','2013-05-31','10:40:00',3.3),('5819','2013-05-31','10:45:00',4.59),('5819','2013-05-31','10:50:00',2.62),('5819','2013-05-31','10:55:00',3.11),('5819','2013-05-31','11:00:00',1.71),('5819','2013-05-31','11:05:00',1.8),('5819','2013-05-31','11:10:00',3.88),('5819','2013-05-31','11:15:00',3.93),('5819','2013-05-31','11:20:00',1.75),('5819','2013-05-31','11:25:00',2.95),('5819','2013-05-31','11:30:00',4.68),('5819','2013-05-31','11:35:00',1.91),('5819','2013-05-31','11:45:00',3.34),('5819','2013-05-31','11:50:00',3.7),('5819','2013-05-31','11:55:00',2.44),('5819','2013-05-31','12:00:00',3.16),('5819','2013-05-31','12:05:00',4.29),('5819','2013-05-31','12:10:00',3.71),('5819','2013-05-31','12:15:00',1.69),('5819','2013-05-31','12:20:00',1.56),('5819','2013-05-31','12:25:00',3.45),('5819','2013-05-31','12:30:00',1.8),('5819','2013-05-31','12:35:00',1.46),('5819','2013-05-31','12:40:00',4.27),('5819','2013-05-31','12:45:00',2.65),('5819','2013-05-31','12:55:00',1.4),('5819','2013-05-31','13:00:00',4.48),('5819','2013-05-31','13:05:00',2.35),('5819','2013-05-31','13:20:00',1.02),('5819','2013-05-31','13:25:00',1.8),('5819','2013-05-31','13:30:00',3.04),('5819','2013-05-31','13:35:00',4.44),('5819','2013-05-31','13:40:00',2.87),('5819','2013-05-31','13:45:00',1.55),('5819','2013-05-31','14:00:00',2.6),('5819','2013-05-31','15:05:00',1.41),('5819','2013-05-31','15:10:00',1.58),('5819','2013-05-31','15:15:00',2.27),('5819','2013-05-31','15:20:00',4.12),('5819','2013-05-31','15:25:00',3.19),('5819','2013-05-31','15:30:00',2.63),('5819','2013-05-31','15:35:00',2.04),('5819','2013-05-31','15:40:00',1.74),('5819','2013-05-31','15:45:00',1.52),('5819','2013-05-31','15:50:00',2.03),('5819','2013-05-31','15:55:00',2.03),('5819','2013-05-31','16:00:00',1.55),('5819','2013-05-31','16:05:00',1.22),('5819','2013-05-31','16:25:00',1.18),('5819','2013-05-31','16:30:00',1.13),('5819','2013-05-31','16:40:00',1.03),('5819','2013-05-31','16:45:00',1.14),('5819','2013-05-30','07:50:00',1.15),('5819','2013-05-30','08:25:00',1.16),('5819','2013-05-30','08:30:00',1.04),('5819','2013-05-30','08:40:00',2.51),('5819','2013-05-30','08:45:00',2.7),('5819','2013-05-30','08:50:00',2.72),('5819','2013-05-30','08:55:00',2.77),('5819','2013-05-30','09:00:00',2.84),('5819','2013-05-30','09:05:00',2.92),('5819','2013-05-30','09:10:00',3),('5819','2013-05-30','09:15:00',3.04),('5819','2013-05-30','09:20:00',3.1),('5819','2013-05-30','09:25:00',3.29),('5819','2013-05-30','09:30:00',3.44),('5819','2013-05-30','09:35:00',3.37),('5819','2013-05-30','09:40:00',3.45),('5819','2013-05-30','09:45:00',3.23),('5819','2013-05-30','09:50:00',3.73),('5819','2013-05-30','09:55:00',3),('5819','2013-05-30','10:00:00',1.07),('5819','2013-05-30','10:05:00',1.28),('5819','2013-05-30','10:10:00',4.1),('5819','2013-05-30','10:15:00',1.32),('5819','2013-05-30','10:20:00',3.89),('5819','2013-05-30','10:25:00',1.23),('5819','2013-05-30','10:40:00',1.59),('5819','2013-05-30','10:45:00',3.7),('5819','2013-05-30','10:50:00',4.4),('5819','2013-05-30','10:55:00',4.3),('5819','2013-05-30','11:00:00',4.18),('5819','2013-05-30','11:05:00',3.88),('5819','2013-05-30','11:10:00',2.02),('5819','2013-05-30','11:15:00',1.24),('5819','2013-05-30','11:20:00',4.47),('5819','2013-05-30','11:25:00',2.65),('5819','2013-05-30','11:30:00',2.46),('5819','2013-05-30','11:35:00',4.07),('5819','2013-05-30','11:40:00',4.72),('5819','2013-05-30','11:45:00',3.18),('5819','2013-05-30','11:50:00',4.77),('5819','2013-05-30','11:55:00',1.39),('5819','2013-05-30','12:00:00',2.52),('5819','2013-05-30','12:05:00',4.84),('5819','2013-05-30','12:10:00',4.34),('5819','2013-05-30','12:15:00',3.34),('5819','2013-05-30','12:20:00',4.56),('5819','2013-05-30','12:25:00',3.48),('5819','2013-05-30','12:30:00',3.83),('5819','2013-05-30','12:35:00',3.86),('5819','2013-05-30','12:40:00',3.87),('5819','2013-05-30','12:45:00',2.26),('5819','2013-05-30','12:50:00',3.58),('5819','2013-05-30','12:55:00',4.56),('5819','2013-05-30','13:00:00',3.69),('5819','2013-05-30','13:05:00',2.03),('5819','2013-05-30','13:10:00',1.9),('5819','2013-05-30','13:15:00',2.55),('5819','2013-05-30','13:20:00',2.09),('5819','2013-05-30','13:25:00',2.04),('5819','2013-05-30','13:30:00',2.49),('5819','2013-05-30','13:35:00',1.63),('5819','2013-05-30','13:40:00',3.29),('5819','2013-05-30','13:45:00',3.17),('5819','2013-05-30','13:50:00',1.6),('5819','2013-05-30','13:55:00',1.78),('5819','2013-05-30','14:00:00',4.27),('5819','2013-05-30','14:05:00',4.67),('5819','2013-05-30','14:10:00',3.55),('5819','2013-05-30','14:15:00',2),('5819','2013-05-30','14:20:00',4.08),('5819','2013-05-30','14:25:00',2.26),('5819','2013-05-30','14:30:00',4.27),('5819','2013-05-30','14:35:00',3.37),('5819','2013-05-30','14:40:00',4.13),('5819','2013-05-30','14:45:00',4.07),('5819','2013-05-30','14:50:00',4.1),('5819','2013-05-30','14:55:00',3.94),('5819','2013-05-30','15:00:00',3.89),('5819','2013-05-30','15:05:00',3.9),('5819','2013-05-30','15:10:00',1.22),('5819','2013-05-30','15:15:00',3.66),('5819','2013-05-30','15:20:00',3.82),('5819','2013-05-30','15:25:00',3.69),('5819','2013-05-30','15:30:00',3.7),('5819','2013-05-30','15:35:00',3.86),('5819','2013-05-30','15:40:00',3.7),('5819','2013-05-30','15:45:00',2.91),('5819','2013-05-30','15:50:00',3.28),('5819','2013-05-30','15:55:00',2.63),('5819','2013-05-30','16:00:00',3.77),('5819','2013-05-30','16:05:00',3),('5819','2013-05-30','16:10:00',3.26),('5819','2013-05-30','16:15:00',3.06),('5819','2013-05-30','16:20:00',2.71),('5819','2013-05-30','16:25:00',2.26),('5819','2013-05-30','16:30:00',1.3),('5819','2013-05-30','16:35:00',1.4),('5819','2013-05-30','16:45:00',1.67),('5819','2013-05-30','16:50:00',2.08),('5819','2013-05-30','16:55:00',2.07),('5819','2013-05-30','17:00:00',1.15),('5819','2013-05-30','17:05:00',1.64),('5819','2013-05-29','07:15:00',1.05),('5819','2013-05-29','07:20:00',1.14),('5819','2013-05-29','07:25:00',1.22),('5819','2013-05-29','07:30:00',1.31),('5819','2013-05-29','07:35:00',1.4),('5819','2013-05-29','07:40:00',1.5),('5819','2013-05-29','07:45:00',1.58),('5819','2013-05-29','07:50:00',1.65),('5819','2013-05-29','07:55:00',1.74),('5819','2013-05-29','08:00:00',1.83),('5819','2013-05-29','08:05:00',1.91),('5819','2013-05-29','08:10:00',2),('5819','2013-05-29','08:15:00',2.08),('5819','2013-05-29','08:20:00',2.15),('5819','2013-05-29','08:25:00',2.21),('5819','2013-05-29','08:30:00',2.31),('5819','2013-05-29','08:35:00',2.41),('5819','2013-05-29','08:40:00',2.46),('5819','2013-05-29','08:45:00',2.54),('5819','2013-05-29','08:50:00',2.61),('5819','2013-05-29','08:55:00',2.69),('5819','2013-05-29','09:00:00',2.78),('5819','2013-05-29','09:05:00',2.84),('5819','2013-05-29','09:10:00',2.89),('5819','2013-05-29','09:15:00',2.97),('5819','2013-05-29','09:20:00',3.03),('5819','2013-05-29','09:25:00',3.08),('5819','2013-05-29','09:30:00',3.14),('5819','2013-05-29','09:35:00',3.19),('5819','2013-05-29','09:40:00',3.25),('5819','2013-05-29','09:45:00',3.32),('5819','2013-05-29','09:50:00',3.36),('5819','2013-05-29','09:55:00',3.42),('5819','2013-05-29','10:00:00',3.45),('5819','2013-05-29','10:05:00',3.51),('5819','2013-05-29','10:10:00',3.54),('5819','2013-05-29','10:15:00',3.56),('5819','2013-05-29','10:20:00',3.66),('5819','2013-05-29','10:25:00',3.72),('5819','2013-05-29','10:30:00',3.76),('5819','2013-05-29','10:35:00',3.82),('5819','2013-05-29','10:40:00',3.84),('5819','2013-05-29','10:45:00',3.91),('5819','2013-05-29','10:50:00',3.93),('5819','2013-05-29','10:55:00',3.98),('5819','2013-05-29','11:00:00',4.01),('5819','2013-05-29','11:05:00',4.07),('5819','2013-05-29','11:10:00',4.11),('5819','2013-05-29','11:15:00',3.17),('5819','2013-05-29','11:20:00',3.44),('5819','2013-05-29','11:25:00',2.4),('5819','2013-05-29','11:30:00',4.38),('5819','2013-05-29','11:35:00',4.41),('5819','2013-05-29','11:40:00',3.75),('5819','2013-05-29','11:45:00',3.99),('5819','2013-05-29','11:50:00',3.64),('5819','2013-05-29','11:55:00',3.87),('5819','2013-05-29','12:00:00',4.38),('5819','2013-05-29','12:05:00',3.46),('5819','2013-05-29','12:10:00',3.45),('5819','2013-05-29','12:15:00',3.65),('5819','2013-05-29','12:20:00',4.49),('5819','2013-05-29','12:25:00',4.07),('5819','2013-05-29','12:30:00',4.34),('5819','2013-05-29','12:35:00',4.34),('5819','2013-05-29','12:40:00',4.35),('5819','2013-05-29','12:45:00',4.08),('5819','2013-05-29','12:50:00',4.2),('5819','2013-05-29','12:55:00',4.2),('5819','2013-05-29','13:00:00',4.32),('5819','2013-05-29','13:05:00',4.38),('5819','2013-05-29','13:10:00',3.63),('5819','2013-05-29','13:15:00',4.32),('5819','2013-05-29','13:20:00',4.61),('5819','2013-05-29','13:25:00',4.6),('5819','2013-05-29','13:30:00',4.59),('5819','2013-05-29','13:35:00',3.86),('5819','2013-05-29','13:40:00',4.19),('5819','2013-05-29','13:45:00',4.05),('5819','2013-05-29','13:50:00',3.69),('5819','2013-05-29','13:55:00',3.48),('5819','2013-05-29','14:00:00',4.14),('5819','2013-05-29','14:05:00',4.06),('5819','2013-05-29','14:10:00',3.91),('5819','2013-05-29','14:15:00',4.02),('5819','2013-05-29','14:20:00',3.97),('5819','2013-05-29','14:25:00',3.51),('5819','2013-05-29','14:30:00',3.98),('5819','2013-05-29','14:35:00',3.22),('5819','2013-05-29','14:40:00',4.1),('5819','2013-05-29','14:45:00',3.99),('5819','2013-05-29','14:50:00',3.67),('5819','2013-05-29','14:55:00',3.77),('5819','2013-05-29','15:00:00',3.94),('5819','2013-05-29','15:05:00',3.95),('5819','2013-05-29','15:10:00',3.81),('5819','2013-05-29','15:15:00',2.41),('5819','2013-05-29','15:20:00',2.73),('5819','2013-05-29','15:25:00',2.29),('5819','2013-05-29','15:30:00',2.51),('5819','2013-05-29','15:35:00',2.74),('5819','2013-05-29','15:40:00',2.77),('5819','2013-05-29','15:45:00',2.69),('5819','2013-05-29','15:50:00',2.53),('5819','2013-05-29','15:55:00',2.7),('5819','2013-05-29','16:00:00',2.39),('5819','2013-05-29','16:05:00',2.34),('5819','2013-05-29','16:10:00',1.98),('5819','2013-05-29','16:15:00',1.86),('5819','2013-05-29','16:20:00',1.81),('5819','2013-05-29','16:25:00',1.85),('5819','2013-05-29','16:30:00',1.81),('5819','2013-05-29','16:35:00',1.65),('5819','2013-05-29','16:40:00',1.88),('5819','2013-05-29','16:45:00',1.66),('5819','2013-05-29','16:50:00',1.38),('5819','2013-05-29','16:55:00',1.31),('5819','2013-05-29','17:00:00',1.27),('5819','2013-05-29','17:40:00',1.35),('5819','2013-05-29','17:45:00',1.04),('5819','2013-05-29','18:15:00',1.14),('5819','2013-05-29','18:20:00',1.17),('5819','2013-05-28','07:15:00',1.09),('5819','2013-05-28','07:20:00',1.27),('5819','2013-05-28','07:25:00',1.31),('5819','2013-05-28','07:30:00',1.01),('5819','2013-05-28','07:40:00',1.17),('5819','2013-05-28','07:45:00',1.23),('5819','2013-05-28','07:50:00',1.22),('5819','2013-05-28','07:55:00',1.21),('5819','2013-05-28','08:00:00',1.26),('5819','2013-05-28','08:05:00',1.38),('5819','2013-05-28','08:10:00',1.51),('5819','2013-05-28','08:15:00',1.82),('5819','2013-05-28','08:20:00',1.95),('5819','2013-05-28','08:25:00',1.74),('5819','2013-05-28','08:30:00',1.9),('5819','2013-05-28','08:35:00',1.72),('5819','2013-05-28','08:40:00',1.51),('5819','2013-05-28','08:45:00',1.39),('5819','2013-05-28','08:50:00',1.63),('5819','2013-05-28','08:55:00',1.46),('5819','2013-05-28','09:00:00',1.66),('5819','2013-05-28','09:05:00',1.8),('5819','2013-05-28','09:10:00',1.68),('5819','2013-05-28','09:15:00',1.56),('5819','2013-05-28','09:20:00',1.84),('5819','2013-05-28','09:25:00',2.13),('5819','2013-05-28','09:30:00',2.28),('5819','2013-05-28','09:35:00',2.41),('5819','2013-05-28','09:40:00',2.26),('5819','2013-05-28','09:45:00',2.07),('5819','2013-05-28','09:50:00',2.1),('5819','2013-05-28','09:55:00',2.21),('5819','2013-05-28','10:00:00',2.07),('5819','2013-05-28','10:05:00',2.17),('5819','2013-05-28','10:10:00',2.45),('5819','2013-05-28','10:15:00',2.53),('5819','2013-05-28','10:20:00',2.7),('5819','2013-05-28','10:25:00',2.63),('5819','2013-05-28','10:30:00',2.93),('5819','2013-05-28','10:35:00',3.01),('5819','2013-05-28','10:40:00',2.71),('5819','2013-05-28','10:45:00',2.49),('5819','2013-05-28','10:50:00',2.67),('5819','2013-05-28','10:55:00',2.4),('5819','2013-05-28','11:00:00',2.37),('5819','2013-05-28','11:05:00',2.29),('5819','2013-05-28','11:10:00',2.57),('5819','2013-05-28','11:15:00',1.92),('5819','2013-05-28','11:20:00',2.19),('5819','2013-05-28','11:25:00',1.92),('5819','2013-05-28','11:30:00',3.41),('5819','2013-05-28','11:35:00',3.01),('5819','2013-05-28','11:40:00',3.38),('5819','2013-05-28','11:45:00',3.53),('5819','2013-05-28','11:50:00',1.15),('5819','2013-05-28','11:55:00',1.44),('5819','2013-05-28','12:00:00',1.56),('5819','2013-05-28','12:05:00',1.67),('5819','2013-05-28','12:10:00',2.67),('5819','2013-05-28','12:15:00',2.6),('5819','2013-05-28','12:20:00',2.16),('5819','2013-05-28','12:25:00',2.18),('5819','2013-05-28','12:30:00',2.5),('5819','2013-05-28','12:35:00',2.45),('5819','2013-05-28','12:40:00',2.44),('5819','2013-05-28','12:45:00',2.8),('5819','2013-05-28','12:50:00',2.52),('5819','2013-05-28','12:55:00',2.5),('5819','2013-05-28','13:00:00',2.58),('5819','2013-05-28','13:05:00',2.75),('5819','2013-05-28','13:10:00',2.9),('5819','2013-05-28','13:15:00',2.62),('5819','2013-05-28','13:20:00',3.39),('5819','2013-05-28','13:25:00',1.83),('5819','2013-05-28','13:30:00',2.03),('5819','2013-05-28','13:35:00',1.69),('5819','2013-05-28','13:40:00',1.87),('5819','2013-05-28','13:45:00',1.75),('5819','2013-05-28','13:50:00',2.52),('5819','2013-05-28','13:55:00',2.59),('5819','2013-05-28','14:00:00',2.47),('5819','2013-05-28','14:05:00',2.51),('5819','2013-05-28','14:10:00',3.55),('5819','2013-05-28','14:15:00',3.71),('5819','2013-05-28','14:20:00',2.27),('5819','2013-05-28','14:25:00',2.64),('5819','2013-05-28','14:30:00',3.12),('5819','2013-05-28','14:35:00',2.66),('5819','2013-05-28','14:40:00',3.03),('5819','2013-05-28','14:45:00',3.49),('5819','2013-05-28','14:50:00',2.67),('5819','2013-05-28','14:55:00',2.42),('5819','2013-05-28','15:00:00',2.02),('5819','2013-05-28','15:05:00',3.34),('5819','2013-05-28','15:10:00',1.63),('5819','2013-05-28','15:15:00',2.27),('5819','2013-05-28','15:20:00',2.84),('5819','2013-05-28','15:25:00',1.91),('5819','2013-05-28','15:30:00',1.39),('5819','2013-05-28','15:35:00',1.4),('5819','2013-05-28','15:40:00',1.92),('5819','2013-05-28','15:45:00',3.26),('5819','2013-05-28','15:50:00',2.71),('5819','2013-05-28','15:55:00',2.16),('5819','2013-05-28','16:00:00',1.51),('5819','2013-05-28','16:05:00',1.17),('5819','2013-05-28','16:10:00',1.31),('5819','2013-05-28','16:15:00',1.3),('5819','2013-05-28','16:20:00',1.88),('5819','2013-05-28','16:25:00',1.91),('5819','2013-05-28','16:30:00',1.82),('5819','2013-05-28','16:35:00',2.49),('5819','2013-05-28','16:40:00',2.28),('5819','2013-05-28','16:45:00',2.19),('5819','2013-05-28','16:50:00',2.11),('5819','2013-05-28','16:55:00',2.03),('5819','2013-05-28','17:00:00',1.97),('5819','2013-05-28','17:05:00',1.89),('5819','2013-05-28','17:10:00',1.81),('5819','2013-05-28','17:15:00',1.75),('5819','2013-05-28','17:20:00',1.67),('5819','2013-05-28','17:25:00',1.56),('5819','2013-05-28','17:30:00',1.48),('5819','2013-05-28','17:35:00',1.4),('5819','2013-05-28','17:40:00',1.18),('5819','2013-05-28','17:45:00',1.17),('5819','2013-05-28','17:50:00',1.12),('5819','2013-05-28','17:55:00',1.05),('5819','2013-05-28','18:00:00',1.07),('5819','2013-05-27','07:25:00',1.11),('5819','2013-05-27','07:30:00',1.43),('5819','2013-05-27','07:35:00',1.5),('5819','2013-05-27','07:40:00',1.54),('5819','2013-05-27','07:45:00',1.59),('5819','2013-05-27','07:50:00',1.54),('5819','2013-05-27','08:00:00',1.52),('5819','2013-05-27','08:05:00',1.86),('5819','2013-05-27','08:10:00',2.23),('5819','2013-05-27','08:15:00',1.77),('5819','2013-05-27','08:20:00',2.08),('5819','2013-05-27','08:25:00',2.31),('5819','2013-05-27','08:30:00',2.38),('5819','2013-05-27','08:35:00',2.44),('5819','2013-05-27','08:40:00',2.52),('5819','2013-05-27','08:45:00',2.74),('5819','2013-05-27','08:50:00',2.99),('5819','2013-05-27','08:55:00',2.14),('5819','2013-05-27','09:00:00',2.63),('5819','2013-05-27','09:05:00',3.2),('5819','2013-05-27','09:10:00',2.9),('5819','2013-05-27','09:15:00',1.98),('5819','2013-05-27','09:20:00',2.59),('5819','2013-05-27','09:25:00',3.08),('5819','2013-05-27','09:30:00',3.37),('5819','2013-05-27','09:35:00',3.36),('5819','2013-05-27','09:40:00',3.37),('5819','2013-05-27','09:45:00',3.44),('5819','2013-05-27','09:50:00',2.32),('5819','2013-05-27','09:55:00',2.62),('5819','2013-05-27','10:00:00',3.79),('5819','2013-05-27','10:05:00',3.21),('5819','2013-05-27','10:10:00',3.7),('5819','2013-05-27','10:15:00',3.87),('5819','2013-05-27','10:20:00',3.35),('5819','2013-05-27','10:25:00',2.44),('5819','2013-05-27','10:30:00',2.37),('5819','2013-05-27','10:35:00',1.32),('5819','2013-05-27','10:40:00',1.23),('5819','2013-05-27','10:45:00',3.01),('5819','2013-05-27','10:50:00',2.85),('5819','2013-05-27','10:55:00',2.45),('5819','2013-05-27','11:00:00',3.03),('5819','2013-05-27','11:05:00',3.36),('5819','2013-05-27','11:10:00',3.25),('5819','2013-05-27','11:15:00',1.97),('5819','2013-05-27','11:20:00',3.13),('5819','2013-05-27','11:25:00',4.31),('5819','2013-05-27','11:30:00',3.14),('5819','2013-05-27','11:35:00',4.03),('5819','2013-05-27','11:40:00',2.41),('5819','2013-05-27','11:45:00',4.81),('5819','2013-05-27','11:50:00',2.2),('5819','2013-05-27','11:55:00',1.85),('5819','2013-05-27','12:00:00',4.18),('5819','2013-05-27','12:05:00',4.34),('5819','2013-05-27','12:10:00',2.47),('5819','2013-05-27','12:15:00',4.18),('5819','2013-05-27','12:20:00',2.99),('5819','2013-05-27','12:25:00',3.4),('5819','2013-05-27','12:30:00',3.39),('5819','2013-05-27','12:35:00',2.55),('5819','2013-05-27','12:40:00',3.28),('5819','2013-05-27','12:45:00',4.88),('5819','2013-05-27','12:50:00',4.58),('5819','2013-05-27','12:55:00',4.31),('5819','2013-05-27','13:00:00',2.84),('5819','2013-05-27','13:05:00',3.88),('5819','2013-05-27','13:10:00',4.38),('5819','2013-05-27','13:15:00',4.01),('5819','2013-05-27','13:20:00',4.21),('5819','2013-05-27','13:25:00',3.47),('5819','2013-05-27','13:30:00',4.38),('5819','2013-05-27','13:35:00',3.85),('5819','2013-05-27','13:40:00',4.2),('5819','2013-05-27','13:45:00',4.51),('5819','2013-05-27','13:50:00',3.89),('5819','2013-05-27','13:55:00',2.87),('5819','2013-05-27','14:00:00',4.21),('5819','2013-05-27','14:05:00',4.15),('5819','2013-05-27','14:10:00',3.99),('5819','2013-05-27','14:15:00',3.68),('5819','2013-05-27','14:20:00',3.63),('5819','2013-05-27','14:25:00',3.4),('5819','2013-05-27','14:30:00',3.64),('5819','2013-05-27','14:35:00',4.01),('5819','2013-05-27','14:40:00',1.47),('5819','2013-05-27','14:45:00',4.09),('5819','2013-05-27','14:50:00',4.02),('5819','2013-05-27','14:55:00',3.27),('5819','2013-05-27','15:00:00',2.53),('5819','2013-05-27','15:05:00',2.36),('5819','2013-05-27','15:10:00',3.81),('5819','2013-05-27','15:15:00',2.65),('5819','2013-05-27','15:20:00',3),('5819','2013-05-27','15:25:00',2.95),('5819','2013-05-27','15:30:00',3.13),('5819','2013-05-27','15:35:00',3.55),('5819','2013-05-27','15:40:00',2.83),('5819','2013-05-27','15:45:00',2.65),('5819','2013-05-27','15:50:00',3.34),('5819','2013-05-27','15:55:00',2.24),('5819','2013-05-27','16:00:00',2.67),('5819','2013-05-27','16:05:00',1.94),('5819','2013-05-27','16:10:00',2.31),('5819','2013-05-27','16:15:00',2.02),('5819','2013-05-27','16:20:00',3.08),('5819','2013-05-27','16:25:00',2.96),('5819','2013-05-27','16:30:00',2.64),('5819','2013-05-27','16:35:00',2.49),('5819','2013-05-27','16:40:00',1.25),('5819','2013-05-27','16:45:00',1.09),('5819','2013-05-27','16:50:00',1.13),('5819','2013-05-27','16:55:00',1.22),('5819','2013-05-27','17:00:00',1.27),('5819','2013-05-27','17:05:00',1.3),('5819','2013-05-27','17:10:00',1.55),('5819','2013-05-27','17:15:00',1.32),('5819','2013-05-27','17:20:00',1.15),('5819','2013-05-27','17:25:00',1.06),('5819','2013-05-27','17:30:00',1.04),('5819','2013-05-26','07:35:00',1.12),('5819','2013-05-26','07:40:00',1.48),('5819','2013-05-26','07:45:00',1.7),('5819','2013-05-26','07:50:00',2.25),('5819','2013-05-26','07:55:00',1.13),('5819','2013-05-26','08:05:00',2.33),('5819','2013-05-26','08:10:00',2.26),('5819','2013-05-26','08:20:00',1.13),('5819','2013-05-26','08:25:00',1.67),('5819','2013-05-26','08:30:00',2.39),('5819','2013-05-26','08:35:00',2.63),('5819','2013-05-26','08:40:00',2.52),('5819','2013-05-26','08:45:00',2.25),('5819','2013-05-26','08:50:00',2.46),('5819','2013-05-26','09:00:00',2.59),('5819','2013-05-26','09:10:00',1.73),('5819','2013-05-26','09:15:00',2.87),('5819','2013-05-26','09:25:00',1.5),('5819','2013-05-26','09:45:00',2.2),('5819','2013-05-26','10:00:00',1.31),('5819','2013-05-26','10:05:00',3.05),('5819','2013-05-26','10:10:00',4.1),('5819','2013-05-26','10:15:00',2.99),('5819','2013-05-26','10:20:00',3.76),('5819','2013-05-26','10:25:00',2.89),('5819','2013-05-26','10:30:00',3.4),('5819','2013-05-26','10:35:00',3.24),('5819','2013-05-26','10:40:00',3.93),('5819','2013-05-26','10:45:00',4.09),('5819','2013-05-26','10:50:00',4.13),('5819','2013-05-26','10:55:00',3.92),('5819','2013-05-26','11:00:00',4.18),('5819','2013-05-26','11:05:00',4.24),('5819','2013-05-26','11:10:00',4.25),('5819','2013-05-26','11:15:00',4.25),('5819','2013-05-26','11:20:00',4.28),('5819','2013-05-26','11:25:00',4.33),('5819','2013-05-26','11:30:00',4.35),('5819','2013-05-26','11:35:00',4.39),('5819','2013-05-26','11:40:00',4.43),('5819','2013-05-26','11:45:00',4.47),('5819','2013-05-26','11:50:00',4.49),('5819','2013-05-26','11:55:00',4.43),('5819','2013-05-26','12:00:00',4.38),('5819','2013-05-26','12:05:00',4.49),('5819','2013-05-26','12:10:00',4.47),('5819','2013-05-26','12:15:00',4.37),('5819','2013-05-26','12:20:00',3.9),('5819','2013-05-26','12:25:00',3.95),('5819','2013-05-26','12:30:00',4.62),('5819','2013-05-26','12:35:00',4.52),('5819','2013-05-26','12:40:00',4.13),('5819','2013-05-26','12:45:00',3.26),('5819','2013-05-26','12:50:00',4.56),('5819','2013-05-26','12:55:00',4.52),('5819','2013-05-26','13:00:00',4.52),('5819','2013-05-26','13:05:00',4.57),('5819','2013-05-26','13:10:00',4.38),('5819','2013-05-26','13:15:00',4.22),('5819','2013-05-26','13:20:00',4.24),('5819','2013-05-26','13:25:00',4.44),('5819','2013-05-26','13:30:00',4.4),('5819','2013-05-26','13:35:00',4.39),('5819','2013-05-26','13:40:00',4.35),('5819','2013-05-26','13:45:00',4.33),('5819','2013-05-26','13:50:00',3.75),('5819','2013-05-26','13:55:00',4.24),('5819','2013-05-26','14:00:00',4.19),('5819','2013-05-26','14:05:00',4.17),('5819','2013-05-26','14:10:00',4.12),('5819','2013-05-26','14:15:00',4.06),('5819','2013-05-26','14:20:00',4.06),('5819','2013-05-26','14:25:00',4),('5819','2013-05-26','14:30:00',3.97),('5819','2013-05-26','14:35:00',3.95),('5819','2013-05-26','14:40:00',3.9),('5819','2013-05-26','14:45:00',3.87),('5819','2013-05-26','14:50:00',3.84),('5819','2013-05-26','14:55:00',3.79),('5819','2013-05-26','15:00:00',3.73),('5819','2013-05-26','15:05:00',3.69),('5819','2013-05-26','15:10:00',3.66),('5819','2013-05-26','15:15:00',3.6),('5819','2013-05-26','15:20:00',3.55),('5819','2013-05-26','15:25:00',3.48),('5819','2013-05-26','15:30:00',3.42),('5819','2013-05-26','15:35:00',3.38),('5819','2013-05-26','15:40:00',3.33),('5819','2013-05-26','15:45:00',3.26),('5819','2013-05-26','15:50:00',3.18),('5819','2013-05-26','15:55:00',3.12),('5819','2013-05-26','16:00:00',3.06),('5819','2013-05-26','16:05:00',3),('5819','2013-05-26','16:10:00',2.94),('5819','2013-05-26','16:15:00',2.87),('5819','2013-05-26','16:20:00',2.79),('5819','2013-05-26','16:25:00',2.72),('5819','2013-05-26','16:30:00',2.65),('5819','2013-05-26','16:35:00',2.56),('5819','2013-05-26','16:40:00',2.48),('5819','2013-05-26','16:45:00',2.41),('5819','2013-05-26','16:50:00',2.33),('5819','2013-05-26','16:55:00',2.24),('5819','2013-05-26','17:00:00',2.15),('5819','2013-05-26','17:05:00',2.08),('5819','2013-05-26','17:10:00',1.99),('5819','2013-05-26','17:15:00',1.91),('5819','2013-05-26','17:20:00',1.81),('5819','2013-05-26','17:25:00',1.73),('5819','2013-05-26','17:30:00',1.63),('5819','2013-05-26','17:35:00',1.54),('5819','2013-05-26','17:40:00',1.34),('5819','2013-05-26','17:45:00',1),('5819','2013-05-26','17:50:00',1.22),('5819','2013-05-26','17:55:00',1.14),('5819','2013-05-26','18:00:00',1.06),('5819','2013-05-25','07:15:00',1.31),('5819','2013-05-25','07:20:00',1.25),('5819','2013-05-25','07:30:00',1.4),('5819','2013-05-25','07:35:00',1.76),('5819','2013-05-25','07:40:00',1.57),('5819','2013-05-25','07:55:00',1.92),('5819','2013-05-25','08:00:00',2.25),('5819','2013-05-25','08:05:00',2.48),('5819','2013-05-25','08:10:00',1.68),('5819','2013-05-25','08:20:00',1.38),('5819','2013-05-25','08:25:00',2.6),('5819','2013-05-25','08:30:00',2.65),('5819','2013-05-25','08:35:00',1.52),('5819','2013-05-25','08:40:00',1.7),('5819','2013-05-25','08:45:00',1.57),('5819','2013-05-25','08:50:00',1.94),('5819','2013-05-25','08:55:00',2.74),('5819','2013-05-25','09:00:00',1.95),('5819','2013-05-25','09:05:00',3.19),('5819','2013-05-25','09:10:00',2.44),('5819','2013-05-25','09:15:00',2.97),('5819','2013-05-25','09:20:00',1.8),('5819','2013-05-25','09:25:00',1.69),('5819','2013-05-25','09:30:00',1.15),('5819','2013-05-25','09:35:00',2.31),('5819','2013-05-25','09:40:00',3.85),('5819','2013-05-25','09:45:00',2.61),('5819','2013-05-25','09:50:00',3.52),('5819','2013-05-25','09:55:00',2.33),('5819','2013-05-25','10:15:00',1.37),('5819','2013-05-25','10:40:00',1.23),('5819','2013-05-25','10:45:00',1.39),('5819','2013-05-25','10:50:00',1.35),('5819','2013-05-25','11:05:00',1.79),('5819','2013-05-25','11:10:00',4.13),('5819','2013-05-25','11:15:00',3.44),('5819','2013-05-25','11:20:00',2.9),('5819','2013-05-25','11:25:00',1.08),('5819','2013-05-25','11:35:00',1.03),('5819','2013-05-25','11:40:00',2.53),('5819','2013-05-25','11:45:00',2.12),('5819','2013-05-25','11:50:00',1.71),('5819','2013-05-25','11:55:00',1.92),('5819','2013-05-25','12:00:00',1.32),('5819','2013-05-25','12:05:00',1.2),('5819','2013-05-25','12:10:00',1.62),('5819','2013-05-25','12:15:00',1.09),('5819','2013-05-25','12:20:00',1.19),('5819','2013-05-25','12:25:00',1.9),('5819','2013-05-25','12:30:00',1.5),('5819','2013-05-25','12:35:00',1.28),('5819','2013-05-25','12:40:00',1.61),('5819','2013-05-25','12:45:00',1.74),('5819','2013-05-25','12:50:00',1.29),('5819','2013-05-25','12:55:00',1.66),('5819','2013-05-25','13:05:00',1.8),('5819','2013-05-25','13:10:00',1.35),('5819','2013-05-25','13:15:00',1.69),('5819','2013-05-25','13:20:00',2.61),('5819','2013-05-25','13:25:00',2.31),('5819','2013-05-25','13:30:00',2.15),('5819','2013-05-25','13:35:00',1.28),('5819','2013-05-25','13:40:00',1.85),('5819','2013-05-25','13:45:00',2.04),('5819','2013-05-25','13:50:00',2.21),('5819','2013-05-25','13:55:00',3.16),('5819','2013-05-25','14:00:00',3.64),('5819','2013-05-25','14:05:00',4.22),('5819','2013-05-25','14:10:00',3.93),('5819','2013-05-25','14:15:00',4.32),('5819','2013-05-25','14:20:00',3.72),('5819','2013-05-25','14:25:00',1.62),('5819','2013-05-25','14:30:00',2.8),('5819','2013-05-25','14:35:00',1.59),('5819','2013-05-25','14:40:00',2.22),('5819','2013-05-25','14:45:00',1.79),('5819','2013-05-25','14:50:00',2.69),('5819','2013-05-25','14:55:00',1.72),('5819','2013-05-25','15:00:00',3.06),('5819','2013-05-25','15:05:00',2.96),('5819','2013-05-25','15:10:00',1.93),('5819','2013-05-25','15:15:00',2.42),('5819','2013-05-25','15:20:00',1.56),('5819','2013-05-25','15:25:00',2.39),('5819','2013-05-25','15:30:00',3.12),('5819','2013-05-25','15:35:00',3.76),('5819','2013-05-25','15:40:00',3.62),('5819','2013-05-25','15:45:00',3.39),('5819','2013-05-25','15:50:00',3.32),('5819','2013-05-25','15:55:00',3.57),('5819','2013-05-25','16:00:00',2.82),('5819','2013-05-25','16:05:00',1.22),('5819','2013-05-25','16:10:00',2),('5819','2013-05-25','16:15:00',1.37),('5819','2013-05-25','16:20:00',1.41),('5819','2013-05-25','16:25:00',1.69),('5819','2013-05-25','16:30:00',2.58),('5819','2013-05-25','16:35:00',2.53),('5819','2013-05-25','16:40:00',2.89),('5819','2013-05-25','16:45:00',2.13),('5819','2013-05-25','16:50:00',1.41),('5819','2013-05-25','17:10:00',2.29),('5819','2013-05-25','17:15:00',1.94),('5819','2013-05-25','17:20:00',1.81),('5819','2013-05-25','17:35:00',1.3),('5819','2013-05-25','17:40:00',1.3),('5819','2013-05-24','08:05:00',2.02),('5819','2013-05-24','08:10:00',2.06),('5819','2013-05-24','08:15:00',2.12),('5819','2013-05-24','08:25:00',1.28),('5819','2013-05-24','08:30:00',2.3),('5819','2013-05-24','08:35:00',1.91),('5819','2013-05-24','08:45:00',2.65),('5819','2013-05-24','08:50:00',2.71),('5819','2013-05-24','08:55:00',2.8),('5819','2013-05-24','09:00:00',2.91),('5819','2013-05-24','09:05:00',3.08),('5819','2013-05-24','09:10:00',1.15),('5819','2013-05-24','09:20:00',1.91),('5819','2013-05-24','09:25:00',1.87),('5819','2013-05-24','09:30:00',3.21),('5819','2013-05-24','09:40:00',1.49),('5819','2013-05-24','09:45:00',1.04),('5819','2013-05-24','09:50:00',1.2),('5819','2013-05-24','09:55:00',2.42),('5819','2013-05-24','10:00:00',3.11),('5819','2013-05-24','10:25:00',1.95),('5819','2013-05-24','10:30:00',3.76),('5819','2013-05-24','10:35:00',4.03),('5819','2013-05-24','10:40:00',4.16),('5819','2013-05-24','10:45:00',3.99),('5819','2013-05-24','10:50:00',3.9),('5819','2013-05-24','10:55:00',4.41),('5819','2013-05-24','11:00:00',4.11),('5819','2013-05-24','11:05:00',4.05),('5819','2013-05-24','11:10:00',3.89),('5819','2013-05-24','11:15:00',3.64),('5819','2013-05-24','11:20:00',4.47),('5819','2013-05-24','11:25:00',4.48),('5819','2013-05-24','11:30:00',3.62),('5819','2013-05-24','11:35:00',1.43),('5819','2013-05-24','11:45:00',2.32),('5819','2013-05-24','11:50:00',4.88),('5819','2013-05-24','11:55:00',3.94),('5819','2013-05-24','12:00:00',1.82),('5819','2013-05-24','12:05:00',2.72),('5819','2013-05-24','12:10:00',3.93),('5819','2013-05-24','12:15:00',2.95),('5819','2013-05-24','12:20:00',2),('5819','2013-05-24','12:25:00',3.48),('5819','2013-05-24','12:30:00',4.45),('5819','2013-05-24','12:35:00',2.01),('5819','2013-05-24','12:40:00',2.68),('5819','2013-05-24','12:45:00',2.55),('5819','2013-05-24','12:50:00',3.07),('5819','2013-05-24','12:55:00',2.51),('5819','2013-05-24','13:00:00',2.3),('5819','2013-05-24','13:05:00',1.94),('5819','2013-05-24','13:10:00',2.38),('5819','2013-05-24','13:15:00',2.93),('5819','2013-05-24','13:20:00',3.27),('5819','2013-05-24','13:25:00',2.42),('5819','2013-05-24','13:30:00',1.7),('5819','2013-05-24','13:35:00',3.5),('5819','2013-05-24','13:40:00',2.55),('5819','2013-05-24','13:45:00',1.29),('5819','2013-05-24','13:50:00',1.09),('5819','2013-05-24','13:55:00',2.69),('5819','2013-05-24','14:00:00',2.32),('5819','2013-05-24','14:05:00',2.22),('5819','2013-05-24','14:10:00',1.23),('5819','2013-05-24','14:15:00',3.77),('5819','2013-05-24','14:20:00',3.55),('5819','2013-05-24','14:25:00',2.46),('5819','2013-05-24','14:30:00',2.68),('5819','2013-05-24','14:35:00',2.78),('5819','2013-05-24','14:40:00',2.56),('5819','2013-05-24','14:45:00',2.44),('5819','2013-05-24','14:50:00',1.54),('5819','2013-05-24','14:55:00',1.75),('5819','2013-05-24','15:00:00',2.12),('5819','2013-05-24','15:05:00',3.12),('5819','2013-05-24','15:10:00',2.75),('5819','2013-05-24','15:15:00',2.09),('5819','2013-05-24','15:20:00',4.6),('5819','2013-05-24','15:25:00',3.36),('5819','2013-05-24','15:30:00',2.87),('5819','2013-05-24','15:35:00',2.56),('5819','2013-05-24','15:40:00',2.93),('5819','2013-05-24','15:45:00',3.52),('5819','2013-05-24','15:50:00',4.26),('5819','2013-05-24','15:55:00',4.06),('5819','2013-05-24','16:00:00',2.14),('5819','2013-05-24','16:05:00',1.85),('5819','2013-05-24','16:10:00',2),('5819','2013-05-24','16:15:00',2.37),('5819','2013-05-24','16:20:00',1.87),('5819','2013-05-24','16:25:00',2.36),('5819','2013-05-24','16:30:00',2.88),('5819','2013-05-24','16:35:00',1.53),('5819','2013-05-24','16:50:00',1.24),('5819','2013-05-24','16:55:00',1.58),('5819','2013-05-24','17:00:00',1.29),('5819','2013-05-23','08:05:00',1.64),('5819','2013-05-23','08:10:00',1.93),('5819','2013-05-23','08:30:00',1.55),('5819','2013-05-23','08:35:00',2.04),('5819','2013-05-23','08:40:00',2.34),('5819','2013-05-23','08:45:00',2.27),('5819','2013-05-23','08:50:00',1.94),('5819','2013-05-23','09:00:00',2.86),('5819','2013-05-23','09:05:00',1.85),('5819','2013-05-23','09:20:00',2.34),('5819','2013-05-23','09:25:00',3.31),('5819','2013-05-23','09:30:00',3.78),('5819','2013-05-23','09:35:00',2.19),('5819','2013-05-23','09:40:00',2.48),('5819','2013-05-23','09:45:00',1.67),('5819','2013-05-23','09:50:00',3.74),('5819','2013-05-23','09:55:00',1.81),('5819','2013-05-23','10:00:00',1.07),('5819','2013-05-23','10:05:00',3.8),('5819','2013-05-23','10:10:00',2.96),('5819','2013-05-23','10:15:00',3.65),('5819','2013-05-23','10:20:00',2.93),('5819','2013-05-23','10:25:00',3.62),('5819','2013-05-23','10:30:00',3.57),('5819','2013-05-23','10:35:00',4.1),('5819','2013-05-23','10:40:00',3.63),('5819','2013-05-23','10:45:00',4.18),('5819','2013-05-23','10:50:00',4.12),('5819','2013-05-23','10:55:00',2.86),('5819','2013-05-23','11:00:00',2.71),('5819','2013-05-23','11:05:00',2.91),('5819','2013-05-23','11:10:00',2.8),('5819','2013-05-23','11:15:00',2.58),('5819','2013-05-23','11:20:00',2.19),('5819','2013-05-23','11:25:00',2.54),('5819','2013-05-23','11:30:00',2.99),('5819','2013-05-23','11:35:00',3.41),('5819','2013-05-23','11:40:00',4.4),('5819','2013-05-23','11:45:00',3.29),('5819','2013-05-23','11:50:00',2.87),('5819','2013-05-23','11:55:00',3.52),('5819','2013-05-23','12:00:00',4.22),('5819','2013-05-23','12:05:00',4.46),('5819','2013-05-23','12:10:00',4.51),('5819','2013-05-23','12:15:00',4.17),('5819','2013-05-23','12:20:00',3.09),('5819','2013-05-23','12:25:00',3.82),('5819','2013-05-23','12:30:00',3.42),('5819','2013-05-23','12:35:00',2.39),('5819','2013-05-23','12:40:00',4.01),('5819','2013-05-23','12:45:00',3.18),('5819','2013-05-23','12:50:00',3.17),('5819','2013-05-23','12:55:00',4.15),('5819','2013-05-23','13:00:00',4.56),('5819','2013-05-23','13:05:00',2.71),('5819','2013-05-23','13:10:00',4.3),('5819','2013-05-23','13:15:00',3.86),('5819','2013-05-23','13:20:00',3.19),('5819','2013-05-23','13:25:00',3.9),('5819','2013-05-23','13:30:00',3.83),('5819','2013-05-23','13:35:00',2.27),('5819','2013-05-23','13:40:00',1.7),('5819','2013-05-23','13:45:00',3.26),('5819','2013-05-23','13:50:00',2.81),('5819','2013-05-23','13:55:00',4.02),('5819','2013-05-23','14:00:00',4.18),('5819','2013-05-23','14:05:00',4.28),('5819','2013-05-23','14:10:00',3.18),('5819','2013-05-23','14:15:00',3.94),('5819','2013-05-23','14:20:00',4.14),('5819','2013-05-23','14:25:00',2.75),('5819','2013-05-23','14:30:00',1.45),('5819','2013-05-23','14:35:00',4.37),('5819','2013-05-23','14:40:00',3.24),('5819','2013-05-23','14:45:00',2.41),('5819','2013-05-23','14:50:00',1.88),('5819','2013-05-23','14:55:00',3.21),('5819','2013-05-23','15:00:00',3.89),('5819','2013-05-23','15:05:00',3.63),('5819','2013-05-23','15:10:00',1.3),('5819','2013-05-23','15:15:00',1.36),('5819','2013-05-23','15:20:00',3.65),('5819','2013-05-23','15:25:00',1.48),('5819','2013-05-23','15:30:00',2.18),('5819','2013-05-23','15:35:00',2.66),('5819','2013-05-23','15:40:00',1.97),('5819','2013-05-23','15:45:00',2.48),('5819','2013-05-23','15:50:00',1.37),('5819','2013-05-23','15:55:00',1.28),('5819','2013-05-23','16:00:00',2.73),('5819','2013-05-23','16:05:00',3.36),('5819','2013-05-23','16:10:00',2.4),('5819','2013-05-23','16:15:00',2.15),('5819','2013-05-23','16:20:00',2.93),('5819','2013-05-23','16:25:00',1.87),('5819','2013-05-23','16:30:00',2.51),('5819','2013-05-23','16:35:00',1.31),('5819','2013-05-23','16:40:00',1.27),('5819','2013-05-23','16:45:00',1.7),('5819','2013-05-23','16:50:00',1.05),('5819','2013-05-23','17:10:00',2.08),('5819','2013-05-23','17:15:00',1.8),('5819','2013-05-23','17:35:00',1.18),('5819','2013-05-23','17:55:00',1.09),('5819','2013-05-23','18:00:00',1.2),('5819','2013-05-23','18:05:00',1.32),('5819','2013-05-22','07:55:00',1.04),('5819','2013-05-22','08:00:00',1.13),('5819','2013-05-22','08:05:00',1.72),('5819','2013-05-22','08:10:00',1.15),('5819','2013-05-22','08:15:00',2.2),('5819','2013-05-22','08:20:00',2.17),('5819','2013-05-22','08:25:00',1.98),('5819','2013-05-22','08:30:00',2.17),('5819','2013-05-22','08:35:00',2.65),('5819','2013-05-22','08:40:00',1.55),('5819','2013-05-22','08:45:00',1.65),('5819','2013-05-22','08:50:00',1.09),('5819','2013-05-22','09:25:00',1.11),('5819','2013-05-22','09:30:00',2.79),('5819','2013-05-22','09:35:00',3.08),('5819','2013-05-22','09:40:00',3.04),('5819','2013-05-22','09:45:00',3.06),('5819','2013-05-22','09:50:00',3.1),('5819','2013-05-22','09:55:00',3.16),('5819','2013-05-22','10:00:00',3.21),('5819','2013-05-22','10:05:00',3.26),('5819','2013-05-22','10:10:00',3.33),('5819','2013-05-22','10:15:00',3.37),('5819','2013-05-22','10:20:00',3.34),('5819','2013-05-22','10:25:00',3.49),('5819','2013-05-22','10:30:00',3.49),('5819','2013-05-22','10:35:00',3.46),('5819','2013-05-22','10:40:00',3.66),('5819','2013-05-22','10:45:00',3.65),('5819','2013-05-22','10:50:00',3.61),('5819','2013-05-22','10:55:00',3.64),('5819','2013-05-22','11:00:00',3.71),('5819','2013-05-22','11:05:00',3.8),('5819','2013-05-22','11:10:00',3.61),('5819','2013-05-22','11:15:00',3.43),('5819','2013-05-22','11:20:00',3.9),('5819','2013-05-22','11:25:00',4.08),('5819','2013-05-22','11:30:00',3.22),('5819','2013-05-22','11:35:00',3.46),('5819','2013-05-22','11:40:00',3.43),('5819','2013-05-22','11:45:00',4.07),('5819','2013-05-22','11:50:00',2.51),('5819','2013-05-22','11:55:00',1.9),('5819','2013-05-22','12:00:00',2.86),('5819','2013-05-22','12:05:00',2.25),('5819','2013-05-22','12:10:00',2.13),('5819','2013-05-22','12:15:00',2.71),('5819','2013-05-22','12:20:00',3.85),('5819','2013-05-22','12:25:00',2.99),('5819','2013-05-22','12:30:00',2.23),('5819','2013-05-22','12:35:00',2.17),('5819','2013-05-22','12:40:00',1.63),('5819','2013-05-22','13:05:00',4.07),('5819','2013-05-22','13:10:00',2.27),('5819','2013-05-22','13:15:00',2.2),('5819','2013-05-22','13:20:00',2.23),('5819','2013-05-22','13:25:00',1.09),('5819','2013-05-22','13:30:00',1.61),('5819','2013-05-22','13:35:00',2.97),('5819','2013-05-22','13:40:00',3.29),('5819','2013-05-22','13:45:00',2.21),('5819','2013-05-22','13:50:00',2.16),('5819','2013-05-22','13:55:00',2.33),('5819','2013-05-22','14:00:00',2.35),('5819','2013-05-22','14:05:00',3.38),('5819','2013-05-22','14:10:00',3.53),('5819','2013-05-22','14:15:00',3.89),('5819','2013-05-22','14:20:00',3.76),('5819','2013-05-22','14:25:00',3.7),('5819','2013-05-22','14:30:00',3.6),('5819','2013-05-22','14:35:00',3.52),('5819','2013-05-22','14:40:00',3.57),('5819','2013-05-22','14:45:00',3.52),('5819','2013-05-22','14:50:00',3.46),('5819','2013-05-22','14:55:00',3.42),('5819','2013-05-22','15:00:00',3.37),('5819','2013-05-22','15:05:00',3.31),('5819','2013-05-22','15:10:00',3.27),('5819','2013-05-22','15:15:00',3.23),('5819','2013-05-22','15:20:00',3.02),('5819','2013-05-22','15:25:00',1.85),('5819','2013-05-22','15:30:00',1.69),('5819','2013-05-22','15:35:00',1.68),('5819','2013-05-22','15:40:00',1.42),('5819','2013-05-22','15:45:00',2.13),('5819','2013-05-22','15:50:00',2.93),('5819','2013-05-22','15:55:00',2.74),('5819','2013-05-22','16:00:00',2.73),('5819','2013-05-22','16:05:00',2.65),('5819','2013-05-22','16:10:00',2.61),('5819','2013-05-22','16:15:00',2.54),('5819','2013-05-22','16:20:00',2.47),('5819','2013-05-22','16:25:00',2.41),('5819','2013-05-22','16:30:00',2.34);
INSERT INTO `solarlog` VALUES ('5819','2013-05-22','16:35:00',2.25),('5819','2013-05-22','16:40:00',2.19),('5819','2013-05-22','16:45:00',1.79),('5819','2013-05-22','16:50:00',1.44),('5819','2013-05-22','17:20:00',1.26),('5819','2013-05-22','17:25:00',1.61),('5819','2013-05-22','17:30:00',1.27),('5819','2013-05-22','17:35:00',1.15),('5819','2013-05-22','18:00:00',1.07),('5819','2013-05-21','07:20:00',1.02),('5819','2013-05-21','07:25:00',1.12),('5819','2013-05-21','07:30:00',1.26),('5819','2013-05-21','07:35:00',1.49),('5819','2013-05-21','07:40:00',1.69),('5819','2013-05-21','07:45:00',1.46),('5819','2013-05-21','07:50:00',1.23),('5819','2013-05-21','07:55:00',1.02),('5819','2013-05-21','08:00:00',1.43),('5819','2013-05-21','08:10:00',1.48),('5819','2013-05-21','08:15:00',2.06),('5819','2013-05-21','08:20:00',1.45),('5819','2013-05-21','08:25:00',1.97),('5819','2013-05-21','08:30:00',1.4),('5819','2013-05-21','08:35:00',1.25),('5819','2013-05-21','08:40:00',1.45),('5819','2013-05-21','08:45:00',1.24),('5819','2013-05-21','08:50:00',1.3),('5819','2013-05-21','08:55:00',1.75),('5819','2013-05-21','09:00:00',1.56),('5819','2013-05-21','09:05:00',1.33),('5819','2013-05-21','09:10:00',1.46),('5819','2013-05-21','09:15:00',1.64),('5819','2013-05-21','09:20:00',2.17),('5819','2013-05-21','09:25:00',2.5),('5819','2013-05-21','09:30:00',1.95),('5819','2013-05-21','09:35:00',1.93),('5819','2013-05-21','09:40:00',1.99),('5819','2013-05-21','09:45:00',1.67),('5819','2013-05-21','09:50:00',1.57),('5819','2013-05-21','09:55:00',1.83),('5819','2013-05-21','10:00:00',1.96),('5819','2013-05-21','10:05:00',2.21),('5819','2013-05-21','10:10:00',2.23),('5819','2013-05-21','10:15:00',2.17),('5819','2013-05-21','10:20:00',2.15),('5819','2013-05-21','10:25:00',1.9),('5819','2013-05-21','10:30:00',1.73),('5819','2013-05-21','10:35:00',1.75),('5819','2013-05-21','10:40:00',1.98),('5819','2013-05-21','10:45:00',2.91),('5819','2013-05-21','10:50:00',2.12),('5819','2013-05-21','10:55:00',1.58),('5819','2013-05-21','11:00:00',1.79),('5819','2013-05-21','11:05:00',1.63),('5819','2013-05-21','11:10:00',2.64),('5819','2013-05-21','11:15:00',4.16),('5819','2013-05-21','11:20:00',3.06),('5819','2013-05-21','11:25:00',3.95),('5819','2013-05-21','11:30:00',2.64),('5819','2013-05-21','11:35:00',2.4),('5819','2013-05-21','11:40:00',2.5),('5819','2013-05-21','11:45:00',3.45),('5819','2013-05-21','11:50:00',2.54),('5819','2013-05-21','11:55:00',3.57),('5819','2013-05-21','12:00:00',2.89),('5819','2013-05-21','12:05:00',3.59),('5819','2013-05-21','12:10:00',2.69),('5819','2013-05-21','12:15:00',2.93),('5819','2013-05-21','12:20:00',2.22),('5819','2013-05-21','12:25:00',3),('5819','2013-05-21','12:30:00',3.88),('5819','2013-05-21','12:35:00',2.25),('5819','2013-05-21','12:40:00',3.78),('5819','2013-05-21','12:45:00',3.82),('5819','2013-05-21','12:50:00',2.39),('5819','2013-05-21','12:55:00',4.24),('5819','2013-05-21','13:00:00',3.69),('5819','2013-05-21','13:05:00',4.05),('5819','2013-05-21','13:10:00',2.41),('5819','2013-05-21','13:15:00',3.38),('5819','2013-05-21','13:20:00',2.68),('5819','2013-05-21','13:25:00',3.05),('5819','2013-05-21','13:30:00',2.8),('5819','2013-05-21','13:35:00',1.49),('5819','2013-05-21','14:10:00',1.55),('5819','2013-05-21','14:15:00',1.88),('5819','2013-05-21','14:20:00',1.69),('5819','2013-05-21','14:25:00',2.13),('5819','2013-05-21','14:30:00',2.34),('5819','2013-05-21','14:35:00',1.81),('5819','2013-05-21','14:40:00',1.72),('5819','2013-05-21','14:45:00',1.53),('5819','2013-05-21','15:20:00',1.37),('5819','2013-05-21','15:25:00',1.42),('5819','2013-05-21','15:30:00',2.03),('5819','2013-05-21','15:35:00',1.5),('5819','2013-05-21','15:40:00',1.2),('5819','2013-05-21','15:45:00',1.27),('5819','2013-05-21','15:50:00',1.18),('5819','2013-05-21','15:55:00',1.18),('5819','2013-05-21','16:00:00',1.16),('5819','2013-05-21','16:05:00',1.11),('5819','2013-05-21','16:10:00',1.24),('5819','2013-05-21','16:15:00',1.09),('5819','2013-05-21','16:25:00',1.12),('5819','2013-05-21','16:30:00',1.61),('5819','2013-05-21','16:35:00',1.73),('5819','2013-05-21','16:40:00',1.82),('5819','2013-05-21','16:45:00',1.73),('5819','2013-05-21','16:50:00',1.07),('5819','2013-05-20','07:15:00',1.02),('5819','2013-05-20','07:20:00',1.09),('5819','2013-05-20','07:25:00',1.07),('5819','2013-05-20','07:30:00',1.26),('5819','2013-05-20','07:35:00',1.36),('5819','2013-05-20','07:40:00',1.44),('5819','2013-05-20','07:45:00',1.53),('5819','2013-05-20','07:50:00',1.6),('5819','2013-05-20','07:55:00',1.67),('5819','2013-05-20','08:00:00',1.84),('5819','2013-05-20','08:05:00',1.67),('5819','2013-05-20','08:10:00',1.99),('5819','2013-05-20','08:15:00',1.64),('5819','2013-05-20','08:20:00',1.42),('5819','2013-05-20','08:50:00',2.96),('5819','2013-05-20','08:55:00',2.9),('5819','2013-05-20','09:00:00',3.14),('5819','2013-05-20','09:05:00',2.83),('5819','2013-05-20','09:10:00',3.31),('5819','2013-05-20','09:15:00',2.45),('5819','2013-05-20','09:20:00',1.84),('5819','2013-05-20','09:25:00',1.81),('5819','2013-05-20','09:35:00',1.77),('5819','2013-05-20','09:40:00',1.34),('5819','2013-05-20','09:50:00',3.44),('5819','2013-05-20','09:55:00',1.69),('5819','2013-05-20','10:05:00',1.24),('5819','2013-05-20','10:15:00',1.53),('5819','2013-05-20','10:30:00',2.5),('5819','2013-05-20','10:35:00',2.42),('5819','2013-05-20','10:45:00',1.38),('5819','2013-05-20','10:50:00',1.28),('5819','2013-05-20','10:55:00',1.8),('5819','2013-05-20','11:00:00',3.4),('5819','2013-05-20','11:05:00',4.37),('5819','2013-05-20','11:10:00',4),('5819','2013-05-20','11:15:00',4.35),('5819','2013-05-20','11:20:00',3.08),('5819','2013-05-20','11:25:00',3.46),('5819','2013-05-20','11:30:00',3.51),('5819','2013-05-20','11:35:00',3.34),('5819','2013-05-20','11:40:00',1.77),('5819','2013-05-20','11:45:00',1.59),('5819','2013-05-20','11:50:00',1.76),('5819','2013-05-20','11:55:00',3.39),('5819','2013-05-20','12:00:00',2.69),('5819','2013-05-20','12:05:00',4.7),('5819','2013-05-20','12:10:00',3.36),('5819','2013-05-20','12:15:00',1.83),('5819','2013-05-20','12:20:00',2.47),('5819','2013-05-20','12:25:00',1.78),('5819','2013-05-20','12:30:00',1.74),('5819','2013-05-20','12:35:00',3.17),('5819','2013-05-20','12:40:00',2.99),('5819','2013-05-20','12:45:00',4.65),('5819','2013-05-20','12:50:00',2.4),('5819','2013-05-20','12:55:00',2.07),('5819','2013-05-20','13:00:00',1.99),('5819','2013-05-20','13:05:00',3.13),('5819','2013-05-20','13:10:00',2.05),('5819','2013-05-20','13:15:00',2.31),('5819','2013-05-20','13:20:00',4.59),('5819','2013-05-20','13:25:00',3.57),('5819','2013-05-20','13:30:00',3.4),('5819','2013-05-20','13:35:00',2.37),('5819','2013-05-20','13:40:00',2.99),('5819','2013-05-20','13:45:00',2.44),('5819','2013-05-20','13:50:00',4.48),('5819','2013-05-20','13:55:00',3.15),('5819','2013-05-20','14:00:00',4.43),('5819','2013-05-20','14:05:00',2.72),('5819','2013-05-20','14:15:00',4.08),('5819','2013-05-20','14:20:00',3.14),('5819','2013-05-20','14:25:00',2.37),('5819','2013-05-20','14:30:00',4.21),('5819','2013-05-20','14:35:00',3.06),('5819','2013-05-20','14:40:00',1.28),('5819','2013-05-20','14:45:00',2.47),('5819','2013-05-20','14:50:00',4.28),('5819','2013-05-20','14:55:00',3.93),('5819','2013-05-20','15:00:00',3.32),('5819','2013-05-20','15:10:00',3.23),('5819','2013-05-20','15:15:00',3.56),('5819','2013-05-20','15:20:00',2.34),('5819','2013-05-20','15:25:00',3.82),('5819','2013-05-20','15:30:00',2.68),('5819','2013-05-20','15:35:00',3.58),('5819','2013-05-20','15:40:00',2.46),('5819','2013-05-20','15:45:00',1.93),('5819','2013-05-20','15:50:00',2.49),('5819','2013-05-20','15:55:00',1.23),('5819','2013-05-20','16:00:00',1.92),('5819','2013-05-20','16:05:00',2.88),('5819','2013-05-20','16:10:00',2.91),('5819','2013-05-20','16:15:00',3.11),('5819','2013-05-20','16:20:00',2.9),('5819','2013-05-20','16:25:00',2.78),('5819','2013-05-20','16:30:00',2.69),('5819','2013-05-20','16:35:00',2.54),('5819','2013-05-20','16:40:00',2.49),('5819','2013-05-20','16:45:00',2.25),('5819','2013-05-20','16:50:00',2.17),('5819','2013-05-20','16:55:00',2.13),('5819','2013-05-20','17:00:00',2),('5819','2013-05-20','17:05:00',2.06),('5819','2013-05-20','17:10:00',1.54),('5819','2013-05-20','17:15:00',1.02),('5819','2013-05-20','17:20:00',1.51),('5819','2013-05-20','17:25:00',1.97),('5819','2013-05-20','17:30:00',1.97),('5819','2013-05-20','17:35:00',1.52),('5819','2013-05-20','17:40:00',1.22),('5819','2013-05-20','17:45:00',1.2),('5819','2013-05-20','17:50:00',1.15),('5819','2013-05-20','17:55:00',1.06),('5819','2013-05-20','18:00:00',1.01),('5819','2013-05-20','18:05:00',1.06),('5819','2013-05-19','08:35:00',1.17),('5819','2013-05-19','08:50:00',1.13),('5819','2013-05-19','08:55:00',1.66),('5819','2013-05-19','09:00:00',1.74),('5819','2013-05-19','09:05:00',1.1),('5819','2013-05-19','09:10:00',1.18),('5819','2013-05-19','09:15:00',1.29),('5819','2013-05-19','09:20:00',1.1),('5819','2013-05-19','09:45:00',1.08),('5819','2013-05-19','10:00:00',1.37),('5819','2013-05-19','10:05:00',1.53),('5819','2013-05-19','10:10:00',1.82),('5819','2013-05-19','10:15:00',2.87),('5819','2013-05-19','10:20:00',3.04),('5819','2013-05-19','10:25:00',2.21),('5819','2013-05-19','10:30:00',2.57),('5819','2013-05-19','10:35:00',2.3),('5819','2013-05-19','10:40:00',1.89),('5819','2013-05-19','10:45:00',2.82),('5819','2013-05-19','10:50:00',1.78),('5819','2013-05-19','10:55:00',2),('5819','2013-05-19','11:00:00',1.9),('5819','2013-05-19','11:05:00',3.04),('5819','2013-05-19','11:10:00',2.62),('5819','2013-05-19','11:15:00',3.51),('5819','2013-05-19','11:20:00',4.35),('5819','2013-05-19','11:25:00',4.22),('5819','2013-05-19','11:30:00',4.3),('5819','2013-05-19','11:35:00',4.27),('5819','2013-05-19','11:40:00',4.39),('5819','2013-05-19','11:45:00',4.39),('5819','2013-05-19','11:50:00',4.35),('5819','2013-05-19','11:55:00',4.38),('5819','2013-05-19','12:00:00',4.41),('5819','2013-05-19','12:05:00',4.35),('5819','2013-05-19','12:10:00',4.36),('5819','2013-05-19','12:15:00',4.38),('5819','2013-05-19','12:20:00',4.53),('5819','2013-05-19','12:25:00',4.88),('5819','2013-05-19','12:30:00',3.91),('5819','2013-05-19','12:35:00',4.79),('5819','2013-05-19','12:40:00',4.69),('5819','2013-05-19','12:45:00',4.66),('5819','2013-05-19','12:50:00',3.55),('5819','2013-05-19','12:55:00',2.71),('5819','2013-05-19','13:00:00',4.18),('5819','2013-05-19','13:05:00',4.47),('5819','2013-05-19','13:10:00',3.78),('5819','2013-05-19','13:15:00',3.63),('5819','2013-05-19','13:20:00',4.2),('5819','2013-05-19','13:25:00',3.7),('5819','2013-05-19','13:30:00',4.16),('5819','2013-05-19','13:35:00',4.15),('5819','2013-05-19','13:40:00',4.08),('5819','2013-05-19','13:45:00',4.05),('5819','2013-05-19','13:50:00',4.05),('5819','2013-05-19','13:55:00',4.04),('5819','2013-05-19','14:00:00',4.03),('5819','2013-05-19','14:05:00',4.02),('5819','2013-05-19','14:10:00',3.99),('5819','2013-05-19','14:15:00',3.94),('5819','2013-05-19','14:20:00',3.92),('5819','2013-05-19','14:25:00',3.88),('5819','2013-05-19','14:30:00',3.86),('5819','2013-05-19','14:35:00',3.81),('5819','2013-05-19','14:40:00',3.79),('5819','2013-05-19','14:45:00',3.75),('5819','2013-05-19','14:50:00',3.7),('5819','2013-05-19','14:55:00',3.65),('5819','2013-05-19','15:00:00',3.63),('5819','2013-05-19','15:05:00',3.59),('5819','2013-05-19','15:10:00',3.54),('5819','2013-05-19','15:15:00',3.5),('5819','2013-05-19','15:20:00',3.43),('5819','2013-05-19','15:25:00',3.38),('5819','2013-05-19','15:30:00',3.31),('5819','2013-05-19','15:35:00',3.27),('5819','2013-05-19','15:40:00',3.2),('5819','2013-05-19','15:45:00',3.14),('5819','2013-05-19','15:50:00',3.06),('5819','2013-05-19','15:55:00',3.04),('5819','2013-05-19','16:00:00',2.96),('5819','2013-05-19','16:05:00',2.87),('5819','2013-05-19','16:10:00',2.82),('5819','2013-05-19','16:15:00',2.74),('5819','2013-05-19','16:20:00',2.68),('5819','2013-05-19','16:25:00',2.62),('5819','2013-05-19','16:30:00',2.54),('5819','2013-05-19','16:35:00',2.47),('5819','2013-05-19','16:40:00',2.41),('5819','2013-05-19','16:45:00',2.33),('5819','2013-05-19','16:50:00',2.25),('5819','2013-05-19','16:55:00',2.17),('5819','2013-05-19','17:00:00',2.08),('5819','2013-05-19','17:05:00',2.01),('5819','2013-05-19','17:10:00',1.93),('5819','2013-05-19','17:15:00',1.84),('5819','2013-05-19','17:20:00',1.75),('5819','2013-05-19','17:25:00',1.66),('5819','2013-05-19','17:30:00',1.56),('5819','2013-05-19','17:35:00',1.41),('5819','2013-05-19','17:40:00',1.27),('5819','2013-05-19','17:45:00',1.25),('5819','2013-05-19','17:50:00',1.17),('5819','2013-05-19','17:55:00',1.09),('5819','2013-05-19','18:00:00',1.01),('5819','2013-05-18','07:20:00',1.05),('5819','2013-05-18','07:25:00',1.14),('5819','2013-05-18','07:30:00',1.23),('5819','2013-05-18','07:35:00',1.32),('5819','2013-05-18','07:40:00',1.44),('5819','2013-05-18','07:45:00',1.46),('5819','2013-05-18','07:50:00',1.14),('5819','2013-05-18','07:55:00',1.95),('5819','2013-05-18','08:00:00',2.07),('5819','2013-05-18','08:05:00',2.11),('5819','2013-05-18','08:10:00',1.01),('5819','2013-05-18','08:20:00',1.19),('5819','2013-05-18','08:25:00',2.69),('5819','2013-05-18','08:30:00',2.47),('5819','2013-05-18','08:35:00',2.22),('5819','2013-05-18','08:40:00',2.46),('5819','2013-05-18','08:45:00',2.46),('5819','2013-05-18','08:50:00',2.5),('5819','2013-05-18','08:55:00',2.59),('5819','2013-05-18','09:00:00',2.66),('5819','2013-05-18','09:05:00',2.69),('5819','2013-05-18','09:10:00',2.83),('5819','2013-05-18','09:15:00',2.89),('5819','2013-05-18','09:20:00',2.93),('5819','2013-05-18','09:25:00',2.99),('5819','2013-05-18','09:30:00',3.05),('5819','2013-05-18','09:35:00',3.1),('5819','2013-05-18','09:40:00',3.14),('5819','2013-05-18','09:45:00',3.19),('5819','2013-05-18','09:50:00',3.24),('5819','2013-05-18','09:55:00',3.3),('5819','2013-05-18','10:00:00',3.35),('5819','2013-05-18','10:05:00',3.37),('5819','2013-05-18','10:10:00',3.43),('5819','2013-05-18','10:15:00',3.44),('5819','2013-05-18','10:20:00',3.5),('5819','2013-05-18','10:25:00',3.52),('5819','2013-05-18','10:30:00',3.55),('5819','2013-05-18','10:35:00',3.52),('5819','2013-05-18','10:40:00',3.6),('5819','2013-05-18','10:45:00',3.63),('5819','2013-05-18','10:50:00',3.66),('5819','2013-05-18','10:55:00',3.55),('5819','2013-05-18','11:00:00',3.88),('5819','2013-05-18','11:05:00',3.59),('5819','2013-05-18','11:10:00',3.09),('5819','2013-05-18','11:15:00',4.13),('5819','2013-05-18','11:20:00',3.99),('5819','2013-05-18','11:25:00',4.06),('5819','2013-05-18','11:30:00',4.03),('5819','2013-05-18','11:35:00',3.83),('5819','2013-05-18','11:40:00',3.94),('5819','2013-05-18','11:45:00',3.74),('5819','2013-05-18','11:50:00',3.72),('5819','2013-05-18','11:55:00',3.89),('5819','2013-05-18','12:00:00',3.91),('5819','2013-05-18','12:05:00',3.8),('5819','2013-05-18','12:10:00',3.89),('5819','2013-05-18','12:15:00',3.86),('5819','2013-05-18','12:20:00',3.87),('5819','2013-05-18','12:25:00',3.92),('5819','2013-05-18','12:30:00',3.08),('5819','2013-05-18','12:35:00',4),('5819','2013-05-18','12:40:00',3.93),('5819','2013-05-18','12:45:00',3.82),('5819','2013-05-18','12:50:00',3.89),('5819','2013-05-18','12:55:00',3.86),('5819','2013-05-18','13:00:00',3.84),('5819','2013-05-18','13:05:00',3.83),('5819','2013-05-18','13:10:00',3.82),('5819','2013-05-18','13:15:00',3.83),('5819','2013-05-18','13:20:00',3.8),('5819','2013-05-18','13:25:00',3.79),('5819','2013-05-18','13:30:00',3.81),('5819','2013-05-18','13:35:00',3.38),('5819','2013-05-18','13:40:00',3.71),('5819','2013-05-18','13:45:00',3.93),('5819','2013-05-18','13:50:00',3.49),('5819','2013-05-18','13:55:00',3.13),('5819','2013-05-18','14:00:00',2.66),('5819','2013-05-18','14:05:00',2.8),('5819','2013-05-18','14:10:00',4.05),('5819','2013-05-18','14:15:00',3.82),('5819','2013-05-18','14:20:00',3.76),('5819','2013-05-18','14:25:00',3.66),('5819','2013-05-18','14:30:00',3.65),('5819','2013-05-18','14:35:00',3.49),('5819','2013-05-18','14:40:00',3.77),('5819','2013-05-18','14:45:00',3.54),('5819','2013-05-18','14:50:00',3.32),('5819','2013-05-18','14:55:00',2.85),('5819','2013-05-18','15:00:00',3.24),('5819','2013-05-18','15:05:00',3.17),('5819','2013-05-18','15:10:00',3.1),('5819','2013-05-18','15:15:00',3.04),('5819','2013-05-18','15:20:00',2.99),('5819','2013-05-18','15:25:00',2.94),('5819','2013-05-18','15:30:00',2.88),('5819','2013-05-18','15:35:00',2.82),('5819','2013-05-18','15:40:00',2.77),('5819','2013-05-18','15:45:00',2.71),('5819','2013-05-18','15:50:00',2.65),('5819','2013-05-18','15:55:00',2.6),('5819','2013-05-18','16:00:00',2.54),('5819','2013-05-18','16:05:00',2.48),('5819','2013-05-18','16:10:00',2.41),('5819','2013-05-18','16:15:00',2.35),('5819','2013-05-18','16:20:00',2.29),('5819','2013-05-18','16:25:00',2.22),('5819','2013-05-18','16:30:00',2.16),('5819','2013-05-18','16:35:00',2.08),('5819','2013-05-18','16:40:00',2.02),('5819','2013-05-18','16:45:00',1.97),('5819','2013-05-18','16:50:00',1.89),('5819','2013-05-18','16:55:00',1.82),('5819','2013-05-18','17:00:00',1.76),('5819','2013-05-18','17:05:00',1.69),('5819','2013-05-18','17:10:00',1.63),('5819','2013-05-18','17:15:00',1.57),('5819','2013-05-18','17:20:00',1.5),('5819','2013-05-18','17:25:00',1.43),('5819','2013-05-18','17:30:00',1.35),('5819','2013-05-18','17:35:00',1.25),('5819','2013-05-18','17:40:00',1.12),('5819','2013-05-18','17:45:00',1.06),('5819','2013-05-18','17:50:00',1.04),('5819','2013-05-17','07:40:00',1.17),('5819','2013-05-17','07:45:00',1.41),('5819','2013-05-17','07:50:00',1.15),('5819','2013-05-17','08:00:00',1.62),('5819','2013-05-17','08:15:00',1.51),('5819','2013-05-17','08:20:00',2.31),('5819','2013-05-17','08:25:00',1.49),('5819','2013-05-17','08:30:00',1.17),('5819','2013-05-17','09:25:00',1.22),('5819','2013-05-17','10:25:00',1.13),('5819','2013-05-17','10:30:00',1.5),('5819','2013-05-17','10:35:00',1.24),('5819','2013-05-17','10:40:00',1.37),('5819','2013-05-17','10:45:00',1.49),('5819','2013-05-17','10:50:00',2.72),('5819','2013-05-17','10:55:00',3.5),('5819','2013-05-17','11:00:00',2.28),('5819','2013-05-17','11:05:00',2.14),('5819','2013-05-17','11:10:00',1.41),('5819','2013-05-17','11:15:00',2.42),('5819','2013-05-17','11:20:00',2.02),('5819','2013-05-17','11:25:00',1.7),('5819','2013-05-17','11:30:00',1.77),('5819','2013-05-17','11:35:00',2.53),('5819','2013-05-17','11:40:00',1.61),('5819','2013-05-17','11:45:00',1.48),('5819','2013-05-17','11:50:00',2.49),('5819','2013-05-17','11:55:00',2.26),('5819','2013-05-17','12:00:00',2.21),('5819','2013-05-17','12:05:00',2.49),('5819','2013-05-17','12:10:00',3.22),('5819','2013-05-17','12:15:00',2.27),('5819','2013-05-17','12:20:00',2.47),('5819','2013-05-17','12:25:00',2.64),('5819','2013-05-17','12:30:00',2.56),('5819','2013-05-17','12:35:00',3.03),('5819','2013-05-17','12:40:00',3.9),('5819','2013-05-17','12:45:00',4.19),('5819','2013-05-17','12:50:00',4.44),('5819','2013-05-17','12:55:00',4.34),('5819','2013-05-17','13:00:00',3.53),('5819','2013-05-17','13:05:00',4.43),('5819','2013-05-17','13:10:00',3.02),('5819','2013-05-17','13:15:00',3.66),('5819','2013-05-17','13:20:00',4.55),('5819','2013-05-17','13:25:00',4.15),('5819','2013-05-17','13:30:00',3.26),('5819','2013-05-17','13:35:00',4.34),('5819','2013-05-17','13:40:00',3.29),('5819','2013-05-17','13:45:00',3.96),('5819','2013-05-17','13:50:00',3.75),('5819','2013-05-17','13:55:00',4.2),('5819','2013-05-17','14:00:00',3.33),('5819','2013-05-17','14:05:00',2.07),('5819','2013-05-17','14:10:00',3.96),('5819','2013-05-17','14:15:00',3.84),('5819','2013-05-17','14:20:00',4.11),('5819','2013-05-17','14:25:00',3.43),('5819','2013-05-17','14:30:00',3.73),('5819','2013-05-17','14:35:00',3.39),('5819','2013-05-17','14:40:00',2.61),('5819','2013-05-17','14:45:00',2.68),('5819','2013-05-17','14:50:00',2.75),('5819','2013-05-17','14:55:00',2.08),('5819','2013-05-17','15:00:00',3.47),('5819','2013-05-17','15:05:00',2.61),('5819','2013-05-17','15:10:00',1.68),('5819','2013-05-17','15:15:00',2.2),('5819','2013-05-17','15:20:00',2.63),('5819','2013-05-17','15:25:00',2.97),('5819','2013-05-17','15:30:00',1.6),('5819','2013-05-17','15:35:00',2.47),('5819','2013-05-17','15:40:00',3.51),('5819','2013-05-17','15:45:00',1.46),('5819','2013-05-17','15:50:00',2.5),('5819','2013-05-17','15:55:00',2.76),('5819','2013-05-17','16:00:00',3.12),('5819','2013-05-17','16:05:00',1.8),('5819','2013-05-17','16:10:00',1.33),('5819','2013-05-17','16:15:00',2.5),('5819','2013-05-17','16:20:00',2.79),('5819','2013-05-17','16:25:00',2.62),('5819','2013-05-17','16:30:00',2.82),('5819','2013-05-17','16:35:00',2.82),('5819','2013-05-17','16:40:00',2.66),('5819','2013-05-17','16:45:00',2.58),('5819','2013-05-17','16:50:00',2.28),('5819','2013-05-17','16:55:00',2.11),('5819','2013-05-17','17:00:00',2.03),('5819','2013-05-17','17:05:00',1.94),('5819','2013-05-17','17:10:00',1.84),('5819','2013-05-17','17:15:00',1.77),('5819','2013-05-17','17:20:00',1.7),('5819','2013-05-17','17:25:00',1.61),('5819','2013-05-17','17:30:00',1.53),('5819','2013-05-17','17:35:00',1.34),('5819','2013-05-17','17:40:00',1.24),('5819','2013-05-17','17:45:00',1.15),('5819','2013-05-17','17:50:00',1.14),('5819','2013-05-17','17:55:00',1.06),('5819','2013-05-16','09:20:00',1.05),('5819','2013-05-16','09:25:00',1.58),('5819','2013-05-16','09:30:00',1.58),('5819','2013-05-16','09:35:00',1.8),('5819','2013-05-16','09:40:00',2.19),('5819','2013-05-16','09:45:00',2.63),('5819','2013-05-16','09:50:00',1.24),('5819','2013-05-16','09:55:00',1.13),('5819','2013-05-16','10:00:00',1.56),('5819','2013-05-16','10:05:00',1.25),('5819','2013-05-16','10:10:00',1.1),('5819','2013-05-16','10:15:00',1.45),('5819','2013-05-16','10:20:00',1.94),('5819','2013-05-16','10:25:00',2.18),('5819','2013-05-16','10:30:00',1.77),('5819','2013-05-16','10:35:00',1.29),('5819','2013-05-16','10:40:00',1.34),('5819','2013-05-16','10:45:00',1.25),('5819','2013-05-16','10:50:00',1.51),('5819','2013-05-16','10:55:00',1.66),('5819','2013-05-16','11:00:00',3.91),('5819','2013-05-16','11:05:00',3.61),('5819','2013-05-16','11:10:00',2.83),('5819','2013-05-16','11:15:00',1.98),('5819','2013-05-16','11:20:00',1.12),('5819','2013-05-16','11:25:00',1.27),('5819','2013-05-16','11:30:00',1.48),('5819','2013-05-16','11:35:00',3.03),('5819','2013-05-16','11:40:00',3.94),('5819','2013-05-16','11:45:00',3.84),('5819','2013-05-16','11:50:00',3.65),('5819','2013-05-16','11:55:00',2.51),('5819','2013-05-16','12:00:00',1.67),('5819','2013-05-16','12:05:00',1.51),('5819','2013-05-16','12:10:00',1.59),('5819','2013-05-16','12:15:00',2.61),('5819','2013-05-16','12:20:00',1.89),('5819','2013-05-16','12:25:00',2.11),('5819','2013-05-16','12:30:00',2.82),('5819','2013-05-16','12:35:00',3.24),('5819','2013-05-16','12:40:00',3.64),('5819','2013-05-16','12:45:00',3.35),('5819','2013-05-16','12:50:00',2.62),('5819','2013-05-16','12:55:00',4.04),('5819','2013-05-16','13:00:00',3.86),('5819','2013-05-16','13:05:00',3.51),('5819','2013-05-16','13:10:00',3.77),('5819','2013-05-16','13:15:00',3.21),('5819','2013-05-16','13:20:00',3.02),('5819','2013-05-16','13:25:00',3.82),('5819','2013-05-16','13:30:00',3.72),('5819','2013-05-16','13:35:00',3.69),('5819','2013-05-16','13:40:00',3.62),('5819','2013-05-16','13:45:00',3.6),('5819','2013-05-16','13:50:00',3.59),('5819','2013-05-16','13:55:00',3.6),('5819','2013-05-16','14:00:00',3.56),('5819','2013-05-16','14:05:00',3.54),('5819','2013-05-16','14:10:00',3.51),('5819','2013-05-16','14:15:00',3.45),('5819','2013-05-16','14:20:00',3.45),('5819','2013-05-16','14:25:00',3.32),('5819','2013-05-16','14:30:00',3.33),('5819','2013-05-16','14:35:00',3.26),('5819','2013-05-16','14:40:00',3.25),('5819','2013-05-16','14:45:00',3.22),('5819','2013-05-16','14:50:00',3.09),('5819','2013-05-16','14:55:00',2.56),('5819','2013-05-16','15:00:00',3.08),('5819','2013-05-16','15:05:00',3.09),('5819','2013-05-16','15:10:00',3.06),('5819','2013-05-16','15:15:00',2.84),('5819','2013-05-16','15:20:00',2.81),('5819','2013-05-16','15:25:00',2.9),('5819','2013-05-16','15:30:00',2.81),('5819','2013-05-16','15:35:00',2.72),('5819','2013-05-16','15:40:00',2.77),('5819','2013-05-16','15:45:00',2.68),('5819','2013-05-16','15:50:00',2.67),('5819','2013-05-16','15:55:00',2.63),('5819','2013-05-16','16:00:00',2.58),('5819','2013-05-16','16:05:00',2.46),('5819','2013-05-16','16:10:00',2.42),('5819','2013-05-16','16:15:00',2.29),('5819','2013-05-16','16:20:00',2.37),('5819','2013-05-16','16:25:00',2.29),('5819','2013-05-16','16:30:00',2.29),('5819','2013-05-16','16:35:00',2.22),('5819','2013-05-16','16:40:00',1.37),('5819','2013-05-16','16:45:00',1.24),('5819','2013-05-16','16:50:00',1.62),('5819','2013-05-16','16:55:00',1.35),('5819','2013-05-16','17:00:00',1.33),('5819','2013-05-16','17:15:00',1.01),('5819','2013-05-16','17:20:00',1.18),('5819','2013-05-16','17:25:00',1.09),('5819','2013-05-16','17:30:00',1.28),('5819','2013-05-16','17:35:00',1.41),('5819','2013-05-16','17:40:00',1.17),('5819','2013-05-15','07:20:00',1.06),('5819','2013-05-15','07:25:00',1.15),('5819','2013-05-15','07:30:00',1.26),('5819','2013-05-15','07:35:00',1.34),('5819','2013-05-15','07:40:00',1.46),('5819','2013-05-15','07:45:00',1.62),('5819','2013-05-15','07:50:00',1.63),('5819','2013-05-15','07:55:00',1.55),('5819','2013-05-15','08:00:00',1.62),('5819','2013-05-15','08:05:00',1.58),('5819','2013-05-15','08:10:00',1.86),('5819','2013-05-15','08:15:00',1.97),('5819','2013-05-15','08:20:00',2.02),('5819','2013-05-15','08:25:00',2.09),('5819','2013-05-15','08:30:00',2.08),('5819','2013-05-15','08:35:00',2.25),('5819','2013-05-15','08:40:00',2.35),('5819','2013-05-15','08:45:00',2.42),('5819','2013-05-15','08:50:00',2.5),('5819','2013-05-15','08:55:00',2.58),('5819','2013-05-15','09:00:00',2.48),('5819','2013-05-15','09:05:00',2.65),('5819','2013-05-15','09:10:00',2.64),('5819','2013-05-15','09:15:00',2.7),('5819','2013-05-15','09:20:00',2.71),('5819','2013-05-15','09:25:00',2.79),('5819','2013-05-15','09:30:00',2.94),('5819','2013-05-15','09:35:00',3),('5819','2013-05-15','09:40:00',2.97),('5819','2013-05-15','09:45:00',3.07),('5819','2013-05-15','09:50:00',3.16),('5819','2013-05-15','09:55:00',3.17),('5819','2013-05-15','10:00:00',3.27),('5819','2013-05-15','10:05:00',3.35),('5819','2013-05-15','10:10:00',3.33),('5819','2013-05-15','10:15:00',3.32),('5819','2013-05-15','10:20:00',3.39),('5819','2013-05-15','10:25:00',3.49),('5819','2013-05-15','10:30:00',3.42),('5819','2013-05-15','10:35:00',3.46),('5819','2013-05-15','10:40:00',3.53),('5819','2013-05-15','10:45:00',3.61),('5819','2013-05-15','10:50:00',3.61),('5819','2013-05-15','10:55:00',3.52),('5819','2013-05-15','11:00:00',3.5),('5819','2013-05-15','11:05:00',3.52),('5819','2013-05-15','11:10:00',3.66),('5819','2013-05-15','11:15:00',3.71),('5819','2013-05-15','11:20:00',3.56),('5819','2013-05-15','11:25:00',3.69),('5819','2013-05-15','11:30:00',3.68),('5819','2013-05-15','11:35:00',3.63),('5819','2013-05-15','11:40:00',3.22),('5819','2013-05-15','11:45:00',2.88),('5819','2013-05-15','11:50:00',2.52),('5819','2013-05-15','11:55:00',1.87),('5819','2013-05-15','12:00:00',2.05),('5819','2013-05-15','12:05:00',3.1),('5819','2013-05-15','12:10:00',4.11),('5819','2013-05-15','12:15:00',4.47),('5819','2013-05-15','12:20:00',2.62),('5819','2013-05-15','12:25:00',3.42),('5819','2013-05-15','12:30:00',2.53),('5819','2013-05-15','12:35:00',2.71),('5819','2013-05-15','12:40:00',4.42),('5819','2013-05-15','12:45:00',2.36),('5819','2013-05-15','12:50:00',2.3),('5819','2013-05-15','12:55:00',2.52),('5819','2013-05-15','13:00:00',2.63),('5819','2013-05-15','13:05:00',3.02),('5819','2013-05-15','13:10:00',2.75),('5819','2013-05-15','13:15:00',2.16),('5819','2013-05-15','13:20:00',2.55),('5819','2013-05-15','13:25:00',2.44),('5819','2013-05-15','13:30:00',2.51),('5819','2013-05-15','13:35:00',2.25),('5819','2013-05-15','13:40:00',2.27),('5819','2013-05-15','13:45:00',2.43),('5819','2013-05-15','13:50:00',1.98),('5819','2013-05-15','13:55:00',1.94),('5819','2013-05-15','14:00:00',1.73),('5819','2013-05-15','14:05:00',1.51),('5819','2013-05-15','14:10:00',1.52),('5819','2013-05-15','14:15:00',1.53),('5819','2013-05-15','14:20:00',1.55),('5819','2013-05-15','14:25:00',1.54),('5819','2013-05-15','14:30:00',1.37),('5819','2013-05-15','14:35:00',1.32),('5819','2013-05-15','14:40:00',1.45),('5819','2013-05-15','14:45:00',1.36),('5819','2013-05-15','14:50:00',1.37),('5819','2013-05-15','14:55:00',1.36),('5819','2013-05-15','15:00:00',1.36),('5819','2013-05-15','15:05:00',1.09),('5819','2013-05-15','15:50:00',1.26),('5819','2013-05-15','15:55:00',1.68),('5819','2013-05-15','16:00:00',1.73),('5819','2013-05-15','16:05:00',1.61),('5819','2013-05-15','16:10:00',1.5),('5819','2013-05-15','16:15:00',1.34),('5819','2013-05-15','16:20:00',1.44),('5819','2013-05-15','16:25:00',1.5),('5819','2013-05-15','16:30:00',1.36),('5819','2013-05-15','16:35:00',1.24),('5819','2013-05-15','16:40:00',1.14),('5819','2013-05-15','16:45:00',1.09),('5819','2013-05-15','16:50:00',1.08),('5819','2013-05-15','16:55:00',1.21),('5819','2013-05-15','17:00:00',1.43),('5819','2013-05-15','17:05:00',1.73),('5819','2013-05-15','17:10:00',1.66),('5819','2013-05-15','17:15:00',2.3),('5819','2013-05-15','17:20:00',1.44),('5819','2013-05-14','07:15:00',1.02),('5819','2013-05-14','07:20:00',1.13),('5819','2013-05-14','07:25:00',1.21),('5819','2013-05-14','07:30:00',1.3),('5819','2013-05-14','07:35:00',1.39),('5819','2013-05-14','07:40:00',1.48),('5819','2013-05-14','07:45:00',1.58),('5819','2013-05-14','07:50:00',1.67),('5819','2013-05-14','07:55:00',1.76),('5819','2013-05-14','08:00:00',1.85),('5819','2013-05-14','08:05:00',1.93),('5819','2013-05-14','08:10:00',2.02),('5819','2013-05-14','08:15:00',2.1),('5819','2013-05-14','08:20:00',2.19),('5819','2013-05-14','08:25:00',2.27),('5819','2013-05-14','08:30:00',2.35),('5819','2013-05-14','08:35:00',2.42),('5819','2013-05-14','08:40:00',2.49),('5819','2013-05-14','08:45:00',2.56),('5819','2013-05-14','08:50:00',2.63),('5819','2013-05-14','08:55:00',2.7),('5819','2013-05-14','09:00:00',2.77),('5819','2013-05-14','09:05:00',2.83),('5819','2013-05-14','09:10:00',2.9),('5819','2013-05-14','09:15:00',2.96),('5819','2013-05-14','09:20:00',3.01),('5819','2013-05-14','09:25:00',3.06),('5819','2013-05-14','09:30:00',3.11),('5819','2013-05-14','09:35:00',3.17),('5819','2013-05-14','09:40:00',3.2),('5819','2013-05-14','09:45:00',3.27),('5819','2013-05-14','09:50:00',3.33),('5819','2013-05-14','09:55:00',3.36),('5819','2013-05-14','10:00:00',3.43),('5819','2013-05-14','10:05:00',3.46),('5819','2013-05-14','10:10:00',3.5),('5819','2013-05-14','10:15:00',3.55),('5819','2013-05-14','10:20:00',3.56),('5819','2013-05-14','10:25:00',3.58),('5819','2013-05-14','10:30:00',3.62),('5819','2013-05-14','10:35:00',3.66),('5819','2013-05-14','10:40:00',3.7),('5819','2013-05-14','10:45:00',3.71),('5819','2013-05-14','10:50:00',3.76),('5819','2013-05-14','10:55:00',3.77),('5819','2013-05-14','11:00:00',3.78),('5819','2013-05-14','11:05:00',3.82),('5819','2013-05-14','11:10:00',3.84),('5819','2013-05-14','11:15:00',3.84),('5819','2013-05-14','11:20:00',3.85),('5819','2013-05-14','11:25:00',3.87),('5819','2013-05-14','11:30:00',3.89),('5819','2013-05-14','11:35:00',3.89),('5819','2013-05-14','11:40:00',3.92),('5819','2013-05-14','11:45:00',3.92),('5819','2013-05-14','11:50:00',3.94),('5819','2013-05-14','11:55:00',3.93),('5819','2013-05-14','12:00:00',3.93),('5819','2013-05-14','12:05:00',3.95),('5819','2013-05-14','12:10:00',3.96),('5819','2013-05-14','12:15:00',3.97),('5819','2013-05-14','12:20:00',3.99),('5819','2013-05-14','12:25:00',4.01),('5819','2013-05-14','12:30:00',4),('5819','2013-05-14','12:35:00',3.98),('5819','2013-05-14','12:40:00',3.99),('5819','2013-05-14','12:45:00',3.98),('5819','2013-05-14','12:50:00',3.98),('5819','2013-05-14','12:55:00',4),('5819','2013-05-14','13:00:00',3.97),('5819','2013-05-14','13:05:00',3.96),('5819','2013-05-14','13:10:00',3.98),('5819','2013-05-14','13:15:00',3.96),('5819','2013-05-14','13:20:00',3.92),('5819','2013-05-14','13:25:00',3.88),('5819','2013-05-14','13:30:00',3.89),('5819','2013-05-14','13:35:00',3.9),('5819','2013-05-14','13:40:00',3.87),('5819','2013-05-14','13:45:00',3.82),('5819','2013-05-14','13:50:00',3.8),('5819','2013-05-14','13:55:00',3.75),('5819','2013-05-14','14:00:00',3.72),('5819','2013-05-14','14:05:00',3.72),('5819','2013-05-14','14:10:00',3.7),('5819','2013-05-14','14:15:00',3.68),('5819','2013-05-14','14:20:00',3.63),('5819','2013-05-14','14:25:00',3.58),('5819','2013-05-14','14:30:00',3.55),('5819','2013-05-14','14:35:00',3.5),('5819','2013-05-14','14:40:00',3.46),('5819','2013-05-14','14:45:00',3.45),('5819','2013-05-14','14:50:00',3.49),('5819','2013-05-14','14:55:00',3.49),('5819','2013-05-14','15:00:00',3.45),('5819','2013-05-14','15:05:00',3.42),('5819','2013-05-14','15:10:00',3.38),('5819','2013-05-14','15:15:00',3.34),('5819','2013-05-14','15:20:00',3.28),('5819','2013-05-14','15:25:00',3.25),('5819','2013-05-14','15:30:00',3.19),('5819','2013-05-14','15:35:00',3.13),('5819','2013-05-14','15:40:00',3.07),('5819','2013-05-14','15:45:00',3),('5819','2013-05-14','15:50:00',2.96),('5819','2013-05-14','15:55:00',2.9),('5819','2013-05-14','16:00:00',2.84),('5819','2013-05-14','16:05:00',2.76),('5819','2013-05-14','16:10:00',2.7),('5819','2013-05-14','16:15:00',2.63),('5819','2013-05-14','16:20:00',2.56),('5819','2013-05-14','16:25:00',2.5),('5819','2013-05-14','16:30:00',2.42),('5819','2013-05-14','16:35:00',2.34),('5819','2013-05-14','16:40:00',2.27),('5819','2013-05-14','16:45:00',2.19),('5819','2013-05-14','16:50:00',2.11),('5819','2013-05-14','16:55:00',2.03),('5819','2013-05-14','17:00:00',1.95),('5819','2013-05-14','17:05:00',1.87),('5819','2013-05-14','17:10:00',1.79),('5819','2013-05-14','17:15:00',1.71),('5819','2013-05-14','17:20:00',1.62),('5819','2013-05-14','17:25:00',1.53),('5819','2013-05-14','17:30:00',1.45),('5819','2013-05-14','17:35:00',1.28),('5819','2013-05-14','17:40:00',1.21),('5819','2013-05-14','17:45:00',1.05),('5819','2013-05-14','17:50:00',1.07),('5819','2013-05-13','07:30:00',1.07),('5819','2013-05-13','07:35:00',1.15),('5819','2013-05-13','07:40:00',1.01),('5819','2013-05-13','07:45:00',1.25),('5819','2013-05-13','07:50:00',1.03),('5819','2013-05-13','08:00:00',1.47),('5819','2013-05-13','08:05:00',1.69),('5819','2013-05-13','08:10:00',1.82),('5819','2013-05-13','08:15:00',1.9),('5819','2013-05-13','08:20:00',1.99),('5819','2013-05-13','08:25:00',2.04),('5819','2013-05-13','08:30:00',2.11),('5819','2013-05-13','08:35:00',2.21),('5819','2013-05-13','08:40:00',2.28),('5819','2013-05-13','08:45:00',2.35),('5819','2013-05-13','08:50:00',2.45),('5819','2013-05-13','08:55:00',2.5),('5819','2013-05-13','09:00:00',2.56),('5819','2013-05-13','09:05:00',2.66),('5819','2013-05-13','09:10:00',2.73),('5819','2013-05-13','09:15:00',2.76),('5819','2013-05-13','09:20:00',2.8),('5819','2013-05-13','09:25:00',2.9),('5819','2013-05-13','09:30:00',2.95),('5819','2013-05-13','09:35:00',2.99),('5819','2013-05-13','09:40:00',3.07),('5819','2013-05-13','09:45:00',3.17),('5819','2013-05-13','09:50:00',3.22),('5819','2013-05-13','09:55:00',3.35),('5819','2013-05-13','10:00:00',3.29),('5819','2013-05-13','10:05:00',2.32),('5819','2013-05-13','10:10:00',3.33),('5819','2013-05-13','10:15:00',3.71),('5819','2013-05-13','10:20:00',2.56),('5819','2013-05-13','10:25:00',2.81),('5819','2013-05-13','10:30:00',3.76),('5819','2013-05-13','10:40:00',1.73),('5819','2013-05-13','10:45:00',3.8),('5819','2013-05-13','10:50:00',4.18),('5819','2013-05-13','10:55:00',2.62),('5819','2013-05-13','11:00:00',2.82),('5819','2013-05-13','11:05:00',2.06),('5819','2013-05-13','11:10:00',1.62),('5819','2013-05-13','11:15:00',2.23),('5819','2013-05-13','11:20:00',1.45),('5819','2013-05-13','11:25:00',1.7),('5819','2013-05-13','11:30:00',2),('5819','2013-05-13','11:35:00',3.24),('5819','2013-05-13','11:40:00',2.29),('5819','2013-05-13','11:45:00',2.55),('5819','2013-05-13','11:50:00',1.67),('5819','2013-05-13','11:55:00',1.64),('5819','2013-05-13','12:00:00',1.49),('5819','2013-05-13','12:05:00',1.57),('5819','2013-05-13','12:10:00',3.07),('5819','2013-05-13','12:15:00',2.32),('5819','2013-05-13','12:20:00',1.35),('5819','2013-05-13','12:25:00',2.43),('5819','2013-05-13','12:30:00',4.27),('5819','2013-05-13','12:35:00',2.75),('5819','2013-05-13','12:40:00',1.9),('5819','2013-05-13','12:45:00',1.96),('5819','2013-05-13','12:50:00',3.47),('5819','2013-05-13','12:55:00',4.5),('5819','2013-05-13','13:00:00',3.88),('5819','2013-05-13','13:05:00',3.96),('5819','2013-05-13','13:10:00',4.28),('5819','2013-05-13','13:15:00',4.43),('5819','2013-05-13','13:20:00',4.11),('5819','2013-05-13','13:25:00',4.3),('5819','2013-05-13','13:30:00',4.33),('5819','2013-05-13','13:35:00',3.9),('5819','2013-05-13','13:40:00',2.21),('5819','2013-05-13','13:45:00',2.09),('5819','2013-05-13','13:50:00',1.5),('5819','2013-05-13','13:55:00',1.07),('5819','2013-05-13','14:00:00',1.56),('5819','2013-05-13','14:05:00',4.41),('5819','2013-05-13','14:10:00',4.32),('5819','2013-05-13','14:15:00',4.11),('5819','2013-05-13','14:20:00',3.88),('5819','2013-05-13','14:25:00',2.75),('5819','2013-05-13','14:30:00',2.07),('5819','2013-05-13','14:35:00',3.88),('5819','2013-05-13','14:40:00',3.9),('5819','2013-05-13','14:45:00',1.6),('5819','2013-05-13','14:50:00',2.33),('5819','2013-05-13','14:55:00',3.96),('5819','2013-05-13','15:00:00',3.35),('5819','2013-05-13','15:05:00',1.9),('5819','2013-05-13','15:10:00',1.01),('5819','2013-05-13','15:15:00',1.01),('5819','2013-05-13','15:20:00',1.37),('5819','2013-05-13','16:00:00',1.01),('5819','2013-05-13','16:05:00',1.01),('5819','2013-05-13','16:10:00',1.48),('5819','2013-05-13','16:20:00',1.54),('5819','2013-05-13','16:25:00',1.21),('5819','2013-05-13','16:30:00',1.85),('5819','2013-05-13','16:35:00',1.2),('5819','2013-05-13','16:40:00',1.96),('5819','2013-05-13','16:45:00',2.32),('5819','2013-05-13','16:50:00',2.89),('5819','2013-05-13','16:55:00',2.56),('5819','2013-05-13','17:00:00',2.35),('5819','2013-05-13','17:05:00',1.94),('5819','2013-05-13','17:10:00',1.66),('5819','2013-05-13','17:15:00',2.37),('5819','2013-05-13','17:20:00',2.33),('5819','2013-05-13','17:25:00',1.96),('5819','2013-05-13','17:30:00',1.46),('5819','2013-05-13','17:35:00',1.62),('5819','2013-05-13','17:40:00',1.47),('5819','2013-05-13','17:45:00',1.4),('5819','2013-05-13','17:50:00',1.18),('5819','2013-05-12','08:00:00',1.4),('5819','2013-05-12','08:05:00',1.05),('5819','2013-05-12','08:10:00',1.56),('5819','2013-05-12','08:15:00',2.3),('5819','2013-05-12','08:20:00',2.04),('5819','2013-05-12','08:25:00',1.39),('5819','2013-05-12','08:40:00',1.05),('5819','2013-05-12','08:45:00',1.9),('5819','2013-05-12','08:50:00',1.58),('5819','2013-05-12','08:55:00',1.03),('5819','2013-05-12','09:00:00',1.31),('5819','2013-05-12','09:05:00',1.1),('5819','2013-05-12','09:15:00',1.14),('5819','2013-05-12','09:20:00',1.09),('5819','2013-05-12','09:25:00',1.11),('5819','2013-05-12','09:30:00',2.69),('5819','2013-05-12','09:35:00',1.28),('5819','2013-05-12','09:40:00',1.52),('5819','2013-05-12','09:45:00',2.15),('5819','2013-05-12','09:50:00',3.03),('5819','2013-05-12','09:55:00',3.33),('5819','2013-05-12','10:00:00',3.53),('5819','2013-05-12','10:05:00',2.72),('5819','2013-05-12','10:10:00',1.25),('5819','2013-05-12','10:15:00',2.7),('5819','2013-05-12','10:30:00',1.19),('5819','2013-05-12','10:35:00',1.2),('5819','2013-05-12','10:40:00',1.03),('5819','2013-05-12','10:45:00',3.37),('5819','2013-05-12','10:50:00',2.38),('5819','2013-05-12','10:55:00',4.38),('5819','2013-05-12','11:00:00',4.13),('5819','2013-05-12','11:05:00',1.47),('5819','2013-05-12','11:10:00',1.1),('5819','2013-05-12','11:15:00',3.9),('5819','2013-05-12','11:20:00',4.37),('5819','2013-05-12','11:25:00',4.36),('5819','2013-05-12','11:30:00',4.45),('5819','2013-05-12','11:35:00',4.23),('5819','2013-05-12','11:40:00',4.34),('5819','2013-05-12','11:45:00',4.47),('5819','2013-05-12','11:50:00',2.66),('5819','2013-05-12','11:55:00',4.54),('5819','2013-05-12','12:00:00',3.6),('5819','2013-05-12','12:05:00',3.43),('5819','2013-05-12','12:10:00',3.82),('5819','2013-05-12','12:15:00',2.43),('5819','2013-05-12','12:20:00',1.13),('5819','2013-05-12','12:25:00',1.05),('5819','2013-05-12','12:30:00',1.19),('5819','2013-05-12','12:35:00',1.47),('5819','2013-05-12','12:40:00',2.01),('5819','2013-05-12','12:45:00',2.43),('5819','2013-05-12','12:50:00',4.84),('5819','2013-05-12','12:55:00',3.29),('5819','2013-05-12','13:00:00',3.75),('5819','2013-05-12','13:05:00',1.34),('5819','2013-05-12','13:10:00',2.95),('5819','2013-05-12','13:15:00',4.02),('5819','2013-05-12','13:20:00',1.76),('5819','2013-05-12','13:25:00',2.02),('5819','2013-05-12','13:30:00',3.24),('5819','2013-05-12','13:35:00',4.36),('5819','2013-05-12','13:40:00',4.35),('5819','2013-05-12','13:45:00',3.46),('5819','2013-05-12','13:50:00',3.82),('5819','2013-05-12','13:55:00',3.86),('5819','2013-05-12','14:00:00',2.56),('5819','2013-05-12','14:05:00',4.58),('5819','2013-05-12','14:10:00',3.12),('5819','2013-05-12','14:15:00',3.69),('5819','2013-05-12','14:20:00',4.17),('5819','2013-05-12','14:25:00',4.05),('5819','2013-05-12','14:30:00',3.95),('5819','2013-05-12','14:35:00',3.92),('5819','2013-05-12','14:40:00',3.86),('5819','2013-05-12','14:45:00',3.72),('5819','2013-05-12','14:50:00',3.74),('5819','2013-05-12','14:55:00',3.7),('5819','2013-05-12','15:00:00',3.12),('5819','2013-05-12','15:05:00',3.66),('5819','2013-05-12','15:10:00',3.53),('5819','2013-05-12','15:15:00',2.88),('5819','2013-05-12','15:20:00',3.11),('5819','2013-05-12','15:25:00',3.4),('5819','2013-05-12','15:30:00',3.18),('5819','2013-05-12','15:35:00',3.18),('5819','2013-05-12','15:40:00',3.12),('5819','2013-05-12','15:45:00',3.06),('5819','2013-05-12','15:50:00',2.98),('5819','2013-05-12','15:55:00',2.88),('5819','2013-05-12','16:00:00',2.82),('5819','2013-05-12','16:05:00',2.56),('5819','2013-05-12','16:10:00',2.66),('5819','2013-05-12','16:15:00',2.61),('5819','2013-05-12','16:20:00',2.55),('5819','2013-05-12','16:25:00',2.46),('5819','2013-05-12','16:30:00',2.4),('5819','2013-05-12','16:35:00',2.38),('5819','2013-05-12','16:40:00',2.4),('5819','2013-05-12','16:45:00',2.56),('5819','2013-05-12','16:50:00',2.55),('5819','2013-05-12','16:55:00',2.31),('5819','2013-05-12','17:00:00',2.72),('5819','2013-05-12','17:05:00',2.36),('5819','2013-05-12','17:10:00',2.37),('5819','2013-05-12','17:15:00',2.5),('5819','2013-05-12','17:20:00',2.24),('5819','2013-05-12','17:25:00',1.86),('5819','2013-05-12','17:30:00',1.84),('5819','2013-05-12','17:35:00',1.48),('5819','2013-05-12','17:40:00',1.19),('5819','2013-05-12','18:00:00',1.04),('5819','2013-05-12','18:05:00',1.36),('5819','2013-05-12','18:10:00',1.33),('5819','2013-05-12','18:15:00',1.17),('5819','2013-05-12','18:25:00',1.01),('5819','2013-05-12','18:30:00',1.03),('5819','2013-05-12','18:35:00',1.01),('5819','2013-05-11','07:30:00',1.04),('5819','2013-05-11','07:35:00',1.05),('5819','2013-05-11','07:45:00',1.35),('5819','2013-05-11','07:50:00',1.51),('5819','2013-05-11','07:55:00',1.68),('5819','2013-05-11','08:00:00',1.55),('5819','2013-05-11','08:05:00',1.62),('5819','2013-05-11','08:15:00',1.18),('5819','2013-05-11','08:20:00',1.25),('5819','2013-05-11','08:25:00',1.06),('5819','2013-05-11','09:15:00',1.16),('5819','2013-05-11','09:20:00',1.83),('5819','2013-05-11','09:25:00',1.23),('5819','2013-05-11','09:30:00',2.34),('5819','2013-05-11','09:35:00',1.57),('5819','2013-05-11','09:40:00',1.85),('5819','2013-05-11','09:45:00',2.24),('5819','2013-05-11','09:50:00',1.49),('5819','2013-05-11','09:55:00',1.77),('5819','2013-05-11','10:00:00',1.47),('5819','2013-05-11','10:05:00',1.62),('5819','2013-05-11','10:10:00',1.26),('5819','2013-05-11','10:25:00',1.02),('5819','2013-05-11','10:30:00',1.01),('5819','2013-05-11','10:35:00',1.13),('5819','2013-05-11','10:55:00',2.55),('5819','2013-05-11','11:00:00',3.94),('5819','2013-05-11','11:05:00',3.22),('5819','2013-05-11','11:10:00',1.27),('5819','2013-05-11','11:15:00',1.02),('5819','2013-05-11','11:30:00',1.22),('5819','2013-05-11','11:35:00',2.41),('5819','2013-05-11','11:40:00',2.02),('5819','2013-05-11','11:45:00',3.08),('5819','2013-05-11','11:50:00',3.18),('5819','2013-05-11','11:55:00',1.02),('5819','2013-05-11','12:00:00',1.08),('5819','2013-05-11','12:05:00',1.69),('5819','2013-05-11','12:10:00',1.47),('5819','2013-05-11','12:15:00',1.42),('5819','2013-05-11','12:20:00',1.59),('5819','2013-05-11','12:25:00',4.74),('5819','2013-05-11','12:30:00',3.29),('5819','2013-05-11','12:35:00',2.15),('5819','2013-05-11','12:40:00',1.77),('5819','2013-05-11','12:45:00',1.92),('5819','2013-05-11','12:50:00',1.71),('5819','2013-05-11','12:55:00',1.5),('5819','2013-05-11','13:00:00',1.39),('5819','2013-05-11','13:05:00',1.36),('5819','2013-05-11','13:10:00',1.23),('5819','2013-05-11','13:35:00',1.07),('5819','2013-05-11','14:00:00',1.85),('5819','2013-05-11','14:05:00',2.75),('5819','2013-05-11','14:10:00',3.18),('5819','2013-05-11','14:15:00',1.97),('5819','2013-05-11','14:20:00',3.83),('5819','2013-05-11','14:25:00',3.35),('5819','2013-05-11','14:30:00',3.06),('5819','2013-05-11','14:35:00',2.66),('5819','2013-05-11','14:40:00',2.73),('5819','2013-05-11','14:45:00',3.05),('5819','2013-05-11','14:50:00',3.73),('5819','2013-05-11','14:55:00',3.84),('5819','2013-05-11','15:00:00',3.63),('5819','2013-05-11','15:05:00',3.41),('5819','2013-05-11','15:10:00',3.49),('5819','2013-05-11','15:15:00',3.5),('5819','2013-05-11','15:20:00',3.45),('5819','2013-05-11','15:25:00',3.35),('5819','2013-05-11','15:30:00',3.29),('5819','2013-05-11','15:35:00',3.19),('5819','2013-05-11','15:40:00',3.19),('5819','2013-05-11','15:45:00',3.17),('5819','2013-05-11','15:50:00',2.49),('5819','2013-05-11','15:55:00',3.05),('5819','2013-05-11','16:00:00',2.63),('5819','2013-05-11','16:05:00',2.91),('5819','2013-05-11','16:10:00',2.86),('5819','2013-05-11','16:15:00',1.77),('5819','2013-05-11','16:20:00',2.79),('5819','2013-05-11','16:25:00',2.66),('5819','2013-05-11','16:30:00',2.45),('5819','2013-05-11','16:35:00',2.25),('5819','2013-05-11','16:40:00',2.26),('5819','2013-05-11','16:45:00',2.26),('5819','2013-05-11','16:50:00',1.83),('5819','2013-05-11','16:55:00',1.9),('5819','2013-05-11','17:00:00',1.95),('5819','2013-05-11','17:05:00',1.93),('5819','2013-05-11','17:10:00',1.76),('5819','2013-05-11','17:15:00',1.62),('5819','2013-05-11','17:20:00',1.53),('5819','2013-05-11','17:25:00',1.7),('5819','2013-05-11','17:30:00',1.37),('5819','2013-05-11','17:35:00',1.33),('5819','2013-05-11','17:40:00',1.16),('5819','2013-05-11','17:45:00',1.34),('5819','2013-05-11','17:50:00',1.05),('5819','2013-05-11','17:55:00',1.22),('5819','2013-05-11','18:10:00',1.09),('5819','2013-05-10','07:35:00',1.04),('5819','2013-05-10','07:55:00',1.08),('5819','2013-05-10','08:00:00',1.44),('5819','2013-05-10','08:05:00',2.19),('5819','2013-05-10','08:10:00',2.16),('5819','2013-05-10','08:15:00',2.27),('5819','2013-05-10','08:20:00',2.1),('5819','2013-05-10','08:25:00',1.97),('5819','2013-05-10','08:30:00',2.09),('5819','2013-05-10','08:35:00',2.12),('5819','2013-05-10','08:40:00',1.4),('5819','2013-05-10','09:00:00',1.62),('5819','2013-05-10','09:05:00',2.48),('5819','2013-05-10','09:10:00',2.8),('5819','2013-05-10','09:15:00',2.89),('5819','2013-05-10','09:20:00',2.79),('5819','2013-05-10','09:25:00',2.45),('5819','2013-05-10','09:30:00',2.46),('5819','2013-05-10','09:35:00',3.03),('5819','2013-05-10','09:40:00',2.93),('5819','2013-05-10','09:45:00',2.68),('5819','2013-05-10','09:50:00',2.79),('5819','2013-05-10','09:55:00',3.15),('5819','2013-05-10','10:00:00',2.5),('5819','2013-05-10','10:05:00',2.97),('5819','2013-05-10','10:10:00',3.12),('5819','2013-05-10','10:15:00',3.3),('5819','2013-05-10','10:20:00',1.95),('5819','2013-05-10','10:25:00',2.54),('5819','2013-05-10','10:30:00',3),('5819','2013-05-10','10:35:00',1.15),('5819','2013-05-10','10:40:00',3.1),('5819','2013-05-10','10:45:00',3.92),('5819','2013-05-10','10:50:00',3.98),('5819','2013-05-10','10:55:00',3.79),('5819','2013-05-10','11:00:00',3.63),('5819','2013-05-10','11:05:00',3.94),('5819','2013-05-10','11:10:00',3.88),('5819','2013-05-10','11:15:00',3.52),('5819','2013-05-10','11:20:00',4.12),('5819','2013-05-10','11:25:00',3.77),('5819','2013-05-10','11:30:00',3.38),('5819','2013-05-10','11:35:00',3.68),('5819','2013-05-10','11:40:00',3.96),('5819','2013-05-10','11:45:00',3.07),('5819','2013-05-10','11:50:00',3.33),('5819','2013-05-10','11:55:00',3.75),('5819','2013-05-10','12:00:00',3.78),('5819','2013-05-10','12:05:00',3.21),('5819','2013-05-10','12:10:00',2.27),('5819','2013-05-10','12:15:00',2.08),('5819','2013-05-10','12:20:00',2.45),('5819','2013-05-10','12:25:00',2.24),('5819','2013-05-10','12:30:00',2.06),('5819','2013-05-10','12:35:00',2.39),('5819','2013-05-10','12:40:00',3.33),('5819','2013-05-10','12:45:00',4.43),('5819','2013-05-10','12:50:00',3.56),('5819','2013-05-10','12:55:00',3.19),('5819','2013-05-10','13:00:00',3.66),('5819','2013-05-10','13:05:00',3.56),('5819','2013-05-10','13:10:00',4.22),('5819','2013-05-10','13:15:00',4.46),('5819','2013-05-10','13:20:00',3.2),('5819','2013-05-10','13:25:00',2.77),('5819','2013-05-10','13:30:00',2.92),('5819','2013-05-10','13:35:00',3.19),('5819','2013-05-10','13:40:00',4.23),('5819','2013-05-10','13:45:00',3.92),('5819','2013-05-10','13:50:00',2.32),('5819','2013-05-10','13:55:00',2.02),('5819','2013-05-10','14:00:00',1.82),('5819','2013-05-10','14:05:00',1.83),('5819','2013-05-10','14:10:00',2.18),('5819','2013-05-10','14:15:00',2.34),('5819','2013-05-10','14:20:00',2.43),('5819','2013-05-10','14:25:00',2.37),('5819','2013-05-10','14:30:00',2.36),('5819','2013-05-10','14:35:00',2.99),('5819','2013-05-10','14:40:00',2.64),('5819','2013-05-10','14:45:00',1.99),('5819','2013-05-10','14:50:00',1.47),('5819','2013-05-10','14:55:00',1.25),('5819','2013-05-10','15:00:00',1.14),('5819','2013-05-10','15:05:00',1.18),('5819','2013-05-10','15:10:00',1.54),('5819','2013-05-10','15:15:00',2.64),('5819','2013-05-10','15:20:00',2.59),('5819','2013-05-10','15:25:00',1.88),('5819','2013-05-10','15:30:00',1.74),('5819','2013-05-10','15:35:00',1.77),('5819','2013-05-10','15:40:00',1.83),('5819','2013-05-10','15:45:00',1.8),('5819','2013-05-10','15:50:00',1.66),('5819','2013-05-10','15:55:00',1.56),('5819','2013-05-10','16:00:00',1.49),('5819','2013-05-10','16:05:00',1.47),('5819','2013-05-10','16:10:00',1.45),('5819','2013-05-10','16:15:00',1.36),('5819','2013-05-10','16:20:00',1.21),('5819','2013-05-10','16:25:00',1.18),('5819','2013-05-10','16:30:00',1.22),('5819','2013-05-10','16:35:00',1.29),('5819','2013-05-10','16:40:00',1.25),('5819','2013-05-10','16:45:00',1.28),('5819','2013-05-10','16:50:00',1.25),('5819','2013-05-10','16:55:00',1.08),('5819','2013-05-10','17:15:00',1.22),('5819','2013-05-10','17:20:00',1.65),('5819','2013-05-10','17:25:00',1.64),('5819','2013-05-10','17:30:00',1.48),('5819','2013-05-10','17:35:00',1.65),('5819','2013-05-10','17:40:00',1.25),('5819','2013-05-10','17:45:00',1.1),('5819','2013-05-09','07:25:00',1.07),('5819','2013-05-09','07:30:00',1.15),('5819','2013-05-09','07:35:00',1.24),('5819','2013-05-09','07:40:00',1.33),('5819','2013-05-09','07:45:00',1.42),('5819','2013-05-09','07:50:00',1.5),('5819','2013-05-09','07:55:00',1.6),('5819','2013-05-09','08:00:00',1.68),('5819','2013-05-09','08:05:00',1.76),('5819','2013-05-09','08:10:00',1.84),('5819','2013-05-09','08:15:00',1.93),('5819','2013-05-09','08:20:00',2.01),('5819','2013-05-09','08:25:00',2.09),('5819','2013-05-09','08:30:00',2.16),('5819','2013-05-09','08:35:00',2.25),('5819','2013-05-09','08:40:00',2.32),('5819','2013-05-09','08:45:00',2.4),('5819','2013-05-09','08:50:00',2.46),('5819','2013-05-09','08:55:00',2.53),('5819','2013-05-09','09:00:00',2.6),('5819','2013-05-09','09:05:00',2.68),('5819','2013-05-09','09:10:00',2.76),('5819','2013-05-09','09:15:00',2.82),('5819','2013-05-09','09:20:00',2.87),('5819','2013-05-09','09:25:00',2.96),('5819','2013-05-09','09:30:00',3.01),('5819','2013-05-09','09:35:00',3.07),('5819','2013-05-09','09:40:00',3.12),('5819','2013-05-09','09:45:00',3.16),('5819','2013-05-09','09:50:00',3.23),('5819','2013-05-09','09:55:00',3.28),('5819','2013-05-09','10:00:00',3.33),('5819','2013-05-09','10:05:00',3.37),('5819','2013-05-09','10:10:00',3.42),('5819','2013-05-09','10:15:00',3.44),('5819','2013-05-09','10:20:00',3.49),('5819','2013-05-09','10:25:00',3.54),('5819','2013-05-09','10:30:00',3.57),('5819','2013-05-09','10:35:00',3.61),('5819','2013-05-09','10:40:00',3.65),('5819','2013-05-09','10:45:00',3.67),('5819','2013-05-09','10:50:00',3.68),('5819','2013-05-09','10:55:00',3.71),('5819','2013-05-09','11:00:00',3.74),('5819','2013-05-09','11:05:00',3.77),('5819','2013-05-09','11:10:00',3.8),('5819','2013-05-09','11:15:00',3.81),('5819','2013-05-09','11:20:00',3.82),('5819','2013-05-09','11:25:00',3.81),('5819','2013-05-09','11:30:00',3.84),('5819','2013-05-09','11:35:00',3.84),('5819','2013-05-09','11:40:00',3.83),('5819','2013-05-09','11:45:00',3.85),('5819','2013-05-09','11:50:00',3.86),('5819','2013-05-09','11:55:00',3.91),('5819','2013-05-09','12:00:00',3.92),('5819','2013-05-09','12:05:00',3.92),('5819','2013-05-09','12:10:00',4),('5819','2013-05-09','12:15:00',3.98),('5819','2013-05-09','12:20:00',3.97),('5819','2013-05-09','12:25:00',3.99),('5819','2013-05-09','12:30:00',3.86),('5819','2013-05-09','12:35:00',3.71),('5819','2013-05-09','12:40:00',4.01),('5819','2013-05-09','12:45:00',3.97),('5819','2013-05-09','12:50:00',4),('5819','2013-05-09','12:55:00',3.93),('5819','2013-05-09','13:00:00',3.89),('5819','2013-05-09','13:05:00',3.87),('5819','2013-05-09','13:10:00',3.9),('5819','2013-05-09','13:15:00',3.92),('5819','2013-05-09','13:20:00',3.93),('5819','2013-05-09','13:25:00',3.9),('5819','2013-05-09','13:30:00',3.87),('5819','2013-05-09','13:35:00',3.85),('5819','2013-05-09','13:40:00',3.87),('5819','2013-05-09','13:45:00',3.91),('5819','2013-05-09','13:50:00',3.87),('5819','2013-05-09','13:55:00',3.74),('5819','2013-05-09','14:00:00',3),('5819','2013-05-09','14:05:00',3.61),('5819','2013-05-09','14:10:00',2.76),('5819','2013-05-09','14:15:00',2.88),('5819','2013-05-09','14:20:00',3.47),('5819','2013-05-09','14:25:00',3.11),('5819','2013-05-09','14:30:00',3.34),('5819','2013-05-09','14:35:00',3.61),('5819','2013-05-09','14:40:00',3.58),('5819','2013-05-09','14:45:00',3.55),('5819','2013-05-09','14:50:00',3.45),('5819','2013-05-09','14:55:00',3.18),('5819','2013-05-09','15:00:00',3.48),('5819','2013-05-09','15:05:00',3.39),('5819','2013-05-09','15:10:00',3.35),('5819','2013-05-09','15:15:00',3.28),('5819','2013-05-09','15:20:00',3.19),('5819','2013-05-09','15:25:00',3.13),('5819','2013-05-09','15:30:00',3.12),('5819','2013-05-09','15:35:00',3.08),('5819','2013-05-09','15:40:00',3.02),('5819','2013-05-09','15:45:00',2.96),('5819','2013-05-09','15:50:00',2.9),('5819','2013-05-09','15:55:00',2.85),('5819','2013-05-09','16:00:00',2.77),('5819','2013-05-09','16:05:00',2.69),('5819','2013-05-09','16:10:00',2.63),('5819','2013-05-09','16:15:00',2.57),('5819','2013-05-09','16:20:00',2.49),('5819','2013-05-09','16:25:00',2.39),('5819','2013-05-09','16:30:00',2.33),('5819','2013-05-09','16:35:00',2.25),('5819','2013-05-09','16:40:00',2.18),('5819','2013-05-09','16:45:00',2.11),('5819','2013-05-09','16:50:00',2.02),('5819','2013-05-09','16:55:00',1.94),('5819','2013-05-09','17:00:00',1.87),('5819','2013-05-09','17:05:00',1.79),('5819','2013-05-09','17:10:00',1.71),('5819','2013-05-09','17:15:00',1.63),('5819','2013-05-09','17:20:00',1.56),('5819','2013-05-09','17:25:00',1.48),('5819','2013-05-09','17:30:00',1.38),('5819','2013-05-09','17:35:00',1.24),('5819','2013-05-09','17:40:00',1.2),('5819','2013-05-09','17:45:00',1.08),('5819','2013-05-08','07:55:00',1),('5819','2013-05-08','08:05:00',1.51),('5819','2013-05-08','08:10:00',1.99),('5819','2013-05-08','08:15:00',2.04),('5819','2013-05-08','08:20:00',2.06),('5819','2013-05-08','08:25:00',2.06),('5819','2013-05-08','08:30:00',2.1),('5819','2013-05-08','08:35:00',2.17),('5819','2013-05-08','08:40:00',1.67),('5819','2013-05-08','08:45:00',2.27),('5819','2013-05-08','08:50:00',2.49),('5819','2013-05-08','08:55:00',2.85),('5819','2013-05-08','09:00:00',2.87),('5819','2013-05-08','09:05:00',3.23),('5819','2013-05-08','09:10:00',3.11),('5819','2013-05-08','09:15:00',2.11),('5819','2013-05-08','09:20:00',2.68),('5819','2013-05-08','09:25:00',1.5),('5819','2013-05-08','09:40:00',1.84),('5819','2013-05-08','09:45:00',2.06),('5819','2013-05-08','09:50:00',1.39),('5819','2013-05-08','10:05:00',1.41),('5819','2013-05-08','10:10:00',3.15),('5819','2013-05-08','10:15:00',2.16),('5819','2013-05-08','10:20:00',1.12),('5819','2013-05-08','10:55:00',1.24),('5819','2013-05-08','11:00:00',1.2),('5819','2013-05-08','11:05:00',4.35),('5819','2013-05-08','11:10:00',4.17),('5819','2013-05-08','11:15:00',4.11),('5819','2013-05-08','11:20:00',3.95),('5819','2013-05-08','11:25:00',4),('5819','2013-05-08','11:30:00',4.17),('5819','2013-05-08','11:35:00',4.05),('5819','2013-05-08','11:40:00',3.32),('5819','2013-05-08','11:45:00',1.92),('5819','2013-05-08','11:50:00',1.5),('5819','2013-05-08','11:55:00',1.56),('5819','2013-05-08','12:00:00',3.8),('5819','2013-05-08','12:05:00',3),('5819','2013-05-08','12:20:00',2.57),('5819','2013-05-08','12:25:00',4.57),('5819','2013-05-08','12:30:00',1.63),('5819','2013-05-08','12:35:00',1.11),('5819','2013-05-08','12:40:00',1.24),('5819','2013-05-08','12:45:00',1.68),('5819','2013-05-08','12:50:00',1.36),('5819','2013-05-08','12:55:00',2.31),('5819','2013-05-08','13:00:00',3.26),('5819','2013-05-08','13:05:00',4.82),('5819','2013-05-08','13:10:00',4.8),('5819','2013-05-08','13:15:00',2.95),('5819','2013-05-08','13:20:00',1.01),('5819','2013-05-08','13:40:00',1.18),('5819','2013-05-08','13:45:00',4.64),('5819','2013-05-08','13:50:00',4.47),('5819','2013-05-08','13:55:00',3.85),('5819','2013-05-08','14:00:00',3.62),('5819','2013-05-08','14:05:00',2.86),('5819','2013-05-08','14:10:00',3.13),('5819','2013-05-08','14:15:00',1.28),('5819','2013-05-08','14:20:00',1.5),('5819','2013-05-08','14:25:00',1.34),('5819','2013-05-08','14:30:00',1.66),('5819','2013-05-08','14:35:00',1.52),('5819','2013-05-08','14:40:00',3.92),('5819','2013-05-08','14:45:00',2.74),('5819','2013-05-08','14:50:00',2.9),('5819','2013-05-08','14:55:00',3.82),('5819','2013-05-08','15:00:00',3.51),('5819','2013-05-08','15:05:00',3.51),('5819','2013-05-08','15:10:00',2.85),('5819','2013-05-08','15:15:00',3.52),('5819','2013-05-08','15:20:00',3.38),('5819','2013-05-08','15:25:00',3.32),('5819','2013-05-08','15:30:00',3.26),('5819','2013-05-08','15:35:00',3.14),('5819','2013-05-08','15:40:00',3.08),('5819','2013-05-08','15:45:00',3.02),('5819','2013-05-08','15:50:00',2.95),('5819','2013-05-08','15:55:00',2.89),('5819','2013-05-08','16:00:00',2.85),('5819','2013-05-08','16:05:00',2.81),('5819','2013-05-08','16:10:00',2.76),('5819','2013-05-08','16:15:00',2.7),('5819','2013-05-08','16:20:00',2.59),('5819','2013-05-08','16:25:00',2.45),('5819','2013-05-08','16:30:00',2.55),('5819','2013-05-08','16:35:00',2.5),('5819','2013-05-08','16:40:00',2.46),('5819','2013-05-08','16:45:00',1.02),('5819','2013-05-08','16:50:00',2.02),('5819','2013-05-08','16:55:00',2.32),('5819','2013-05-08','17:00:00',2.4),('5819','2013-05-08','17:05:00',1.99),('5819','2013-05-08','17:10:00',2.18),('5819','2013-05-08','17:15:00',2.02),('5819','2013-05-08','17:20:00',1.57),('5819','2013-05-08','17:25:00',1.75),('5819','2013-05-08','17:30:00',1.81),('5819','2013-05-08','17:35:00',1.64),('5819','2013-05-08','17:40:00',1.69),('5819','2013-05-08','17:45:00',1.67),('5819','2013-05-08','17:50:00',1.61),('5819','2013-05-08','17:55:00',1.19),('5819','2013-05-07','07:25:00',1.06),('5819','2013-05-07','07:30:00',1.14),('5819','2013-05-07','07:35:00',1.24),('5819','2013-05-07','07:40:00',1.32),('5819','2013-05-07','07:45:00',1.41),('5819','2013-05-07','07:50:00',1.5),('5819','2013-05-07','07:55:00',1.57),('5819','2013-05-07','08:00:00',1.65),('5819','2013-05-07','08:05:00',1.77),('5819','2013-05-07','08:10:00',1.86),('5819','2013-05-07','08:15:00',1.95),('5819','2013-05-07','08:20:00',2.02),('5819','2013-05-07','08:25:00',2.09),('5819','2013-05-07','08:30:00',2.17),('5819','2013-05-07','08:35:00',2.28),('5819','2013-05-07','08:40:00',2.31),('5819','2013-05-07','08:45:00',2.44),('5819','2013-05-07','08:50:00',2.36),('5819','2013-05-07','08:55:00',2.24),('5819','2013-05-07','09:00:00',2.89),('5819','2013-05-07','09:05:00',3.11),('5819','2013-05-07','09:10:00',2.45),('5819','2013-05-07','09:15:00',2.71),('5819','2013-05-07','09:20:00',1.83),('5819','2013-05-07','09:25:00',1.17),('5819','2013-05-07','09:35:00',2.19),('5819','2013-05-07','09:40:00',2.19),('5819','2013-05-07','09:45:00',1.7),('5819','2013-05-07','09:50:00',2.28),('5819','2013-05-07','09:55:00',1.25),('5819','2013-05-07','10:00:00',1.31),('5819','2013-05-07','11:05:00',1.1),('5819','2013-05-07','11:10:00',1.17),('5819','2013-05-07','11:15:00',1.26),('5819','2013-05-07','11:20:00',3.15),('5819','2013-05-07','11:25:00',3.03),('5819','2013-05-07','11:30:00',1.48),('5819','2013-05-07','12:05:00',1.57),('5819','2013-05-07','12:10:00',1.12),('5819','2013-05-07','12:15:00',3.7),('5819','2013-05-07','12:20:00',1.44),('5819','2013-05-07','12:25:00',2.02),('5819','2013-05-07','12:30:00',4.9),('5819','2013-05-07','12:35:00',1.41),('5819','2013-05-07','13:25:00',1.01),('5819','2013-05-07','13:30:00',1.35),('5819','2013-05-07','13:35:00',1.26),('5819','2013-05-07','13:40:00',3.57),('5819','2013-05-07','13:45:00',4.34),('5819','2013-05-07','13:50:00',4.48),('5819','2013-05-07','13:55:00',4.32),('5819','2013-05-07','14:00:00',4.22),('5819','2013-05-07','14:05:00',4.12),('5819','2013-05-07','14:10:00',4.13),('5819','2013-05-07','14:15:00',4.14),('5819','2013-05-07','14:20:00',4.06),('5819','2013-05-07','14:25:00',2.5),('5819','2013-05-07','14:30:00',4.18),('5819','2013-05-07','14:35:00',2.67),('5819','2013-05-07','14:40:00',4.41),('5819','2013-05-07','14:45:00',3.56),('5819','2013-05-07','14:50:00',3.24),('5819','2013-05-07','14:55:00',4),('5819','2013-05-07','15:00:00',2.8),('5819','2013-05-07','15:05:00',3.91),('5819','2013-05-07','15:10:00',3.03),('5819','2013-05-07','15:15:00',3.37),('5819','2013-05-07','15:20:00',2.95),('5819','2013-05-07','15:25:00',2.1),('5819','2013-05-07','15:30:00',1.95),('5819','2013-05-07','15:35:00',2.72),('5819','2013-05-07','15:40:00',1.88),('5819','2013-05-07','15:45:00',2.31),('5819','2013-05-07','15:50:00',1.52),('5819','2013-05-07','15:55:00',1.63),('5819','2013-05-07','16:00:00',2.8),('5819','2013-05-07','16:05:00',2.38),('5819','2013-05-07','16:10:00',1.18),('5819','2013-05-07','16:15:00',1.65),('5819','2013-05-07','16:20:00',3.52),('5819','2013-05-07','16:25:00',3.39),('5819','2013-05-07','16:30:00',3.16),('5819','2013-05-07','16:35:00',3.04),('5819','2013-05-07','16:40:00',3.05),('5819','2013-05-07','16:45:00',2.25),('5819','2013-05-07','16:50:00',2.3),('5819','2013-05-07','16:55:00',2.19),('5819','2013-05-07','17:00:00',2.26),('5819','2013-05-07','17:05:00',2.19),('5819','2013-05-07','17:10:00',1.78),('5819','2013-05-07','17:15:00',1.13),('5819','2013-05-07','17:20:00',1.06),('5819','2013-05-07','17:25:00',1.12),('5819','2013-05-06','08:25:00',1.08),('5819','2013-05-06','08:30:00',1.27),('5819','2013-05-06','08:35:00',1.11),('5819','2013-05-06','08:55:00',1.53),('5819','2013-05-06','09:00:00',1.89),('5819','2013-05-06','09:05:00',1.27),('5819','2013-05-06','09:10:00',1.55),('5819','2013-05-06','09:15:00',1.35),('5819','2013-05-06','09:20:00',1.12),('5819','2013-05-06','09:25:00',1.04),('5819','2013-05-06','10:00:00',1.54),('5819','2013-05-06','10:05:00',1.25),('5819','2013-05-06','10:10:00',1.18),('5819','2013-05-06','10:15:00',1.38),('5819','2013-05-06','10:20:00',1.82),('5819','2013-05-06','10:25:00',1.47),('5819','2013-05-06','10:30:00',1.57),('5819','2013-05-06','10:35:00',1.55),('5819','2013-05-06','10:40:00',1.56),('5819','2013-05-06','10:45:00',2.38),('5819','2013-05-06','10:50:00',2.41),('5819','2013-05-06','10:55:00',1.96),('5819','2013-05-06','11:00:00',1.96),('5819','2013-05-06','11:05:00',1.94),('5819','2013-05-06','11:10:00',1.89),('5819','2013-05-06','11:15:00',1.57),('5819','2013-05-06','11:20:00',2.16),('5819','2013-05-06','11:25:00',2.03),('5819','2013-05-06','11:30:00',2.06),('5819','2013-05-06','11:35:00',1.39),('5819','2013-05-06','11:40:00',2.89),('5819','2013-05-06','11:45:00',3.88),('5819','2013-05-06','11:50:00',3.11),('5819','2013-05-06','11:55:00',1.63),('5819','2013-05-06','12:00:00',1.55),('5819','2013-05-06','12:05:00',1.9),('5819','2013-05-06','12:10:00',4.23),('5819','2013-05-06','12:15:00',2.94),('5819','2013-05-06','12:20:00',2.51),('5819','2013-05-06','12:25:00',2.69),('5819','2013-05-06','12:30:00',3.69),('5819','2013-05-06','12:35:00',3.29),('5819','2013-05-06','12:40:00',2.68),('5819','2013-05-06','12:45:00',2.38),('5819','2013-05-06','12:50:00',2.57),('5819','2013-05-06','12:55:00',4.13),('5819','2013-05-06','13:00:00',1.68),('5819','2013-05-06','13:05:00',3.18),('5819','2013-05-06','13:10:00',3.93),('5819','2013-05-06','13:15:00',3.2),('5819','2013-05-06','13:20:00',3.17),('5819','2013-05-06','13:25:00',2.52),('5819','2013-05-06','13:30:00',3.65),('5819','2013-05-06','13:35:00',2.53),('5819','2013-05-06','13:40:00',3.48),('5819','2013-05-06','13:45:00',4.31),('5819','2013-05-06','13:50:00',3.99),('5819','2013-05-06','13:55:00',4),('5819','2013-05-06','14:00:00',2.84),('5819','2013-05-06','14:05:00',4.43),('5819','2013-05-06','14:10:00',2.5),('5819','2013-05-06','14:15:00',3.14),('5819','2013-05-06','14:20:00',3.71),('5819','2013-05-06','14:25:00',2.58),('5819','2013-05-06','14:30:00',3.18),('5819','2013-05-06','14:35:00',3.3),('5819','2013-05-06','14:40:00',1.7),('5819','2013-05-06','14:45:00',3.34),('5819','2013-05-06','14:50:00',1.69),('5819','2013-05-06','14:55:00',3.38),('5819','2013-05-06','15:00:00',3.7),('5819','2013-05-06','15:05:00',2.42),('5819','2013-05-06','15:10:00',3.41),('5819','2013-05-06','15:15:00',2.17),('5819','2013-05-06','15:20:00',1.76),('5819','2013-05-06','15:25:00',2.81),('5819','2013-05-06','15:30:00',1.98),('5819','2013-05-06','15:35:00',1.49),('5819','2013-05-06','15:40:00',1.62),('5819','2013-05-06','15:45:00',1.21),('5819','2013-05-06','15:50:00',1.41),('5819','2013-05-06','15:55:00',1.9),('5819','2013-05-06','16:00:00',1.84),('5819','2013-05-06','16:05:00',1.49),('5819','2013-05-06','16:10:00',1.36),('5819','2013-05-06','16:15:00',1.41),('5819','2013-05-06','16:20:00',1.45),('5819','2013-05-06','16:25:00',1.91),('5819','2013-05-06','16:30:00',1.95),('5819','2013-05-06','16:35:00',1.74),('5819','2013-05-06','16:40:00',2.39),('5819','2013-05-06','16:45:00',2.4),('5819','2013-05-06','16:50:00',1.86),('5819','2013-05-06','16:55:00',2.39),('5819','2013-05-06','17:00:00',1.21),('5819','2013-05-06','17:40:00',1.15),('5819','2013-05-06','17:45:00',1.06),('5819','2013-05-05','07:45:00',1.21),('5819','2013-05-05','07:50:00',1.29),('5819','2013-05-05','07:55:00',1.31),('5819','2013-05-05','08:00:00',1.39),('5819','2013-05-05','08:05:00',1.53),('5819','2013-05-05','08:10:00',1.63),('5819','2013-05-05','08:15:00',1.74),('5819','2013-05-05','08:20:00',1.93),('5819','2013-05-05','08:25:00',2.3),('5819','2013-05-05','08:30:00',2.33),('5819','2013-05-05','08:35:00',2.02),('5819','2013-05-05','08:40:00',2.22),('5819','2013-05-05','08:45:00',1.88),('5819','2013-05-05','08:50:00',1.43),('5819','2013-05-05','08:55:00',1.26),('5819','2013-05-05','09:00:00',1.35),('5819','2013-05-05','09:05:00',1.46),('5819','2013-05-05','09:10:00',1.82),('5819','2013-05-05','09:15:00',1.86),('5819','2013-05-05','09:20:00',1.76),('5819','2013-05-05','09:25:00',1.98),('5819','2013-05-05','09:30:00',2.16),('5819','2013-05-05','09:35:00',1.49),('5819','2013-05-05','09:40:00',2.3),('5819','2013-05-05','09:45:00',2.9),('5819','2013-05-05','09:50:00',2.12),('5819','2013-05-05','09:55:00',3.43),('5819','2013-05-05','10:00:00',2.53),('5819','2013-05-05','10:05:00',2.25),('5819','2013-05-05','10:10:00',2.15),('5819','2013-05-05','10:15:00',1.85),('5819','2013-05-05','10:20:00',3.15),('5819','2013-05-05','10:25:00',2.33),('5819','2013-05-05','10:30:00',2.56),('5819','2013-05-05','10:35:00',2.39),('5819','2013-05-05','10:40:00',2.29),('5819','2013-05-05','10:45:00',2.4),('5819','2013-05-05','10:50:00',1.87),('5819','2013-05-05','10:55:00',1.63),('5819','2013-05-05','11:00:00',1.48),('5819','2013-05-05','11:05:00',1.76),('5819','2013-05-05','11:10:00',1.7),('5819','2013-05-05','11:15:00',1.67),('5819','2013-05-05','11:20:00',2.2),('5819','2013-05-05','11:25:00',3.2),('5819','2013-05-05','11:30:00',2.62),('5819','2013-05-05','11:35:00',3.49),('5819','2013-05-05','11:40:00',3.11),('5819','2013-05-05','11:45:00',2.81),('5819','2013-05-05','11:50:00',2.53),('5819','2013-05-05','11:55:00',3.35),('5819','2013-05-05','12:00:00',2.47),('5819','2013-05-05','12:05:00',2.47),('5819','2013-05-05','12:10:00',2.35),('5819','2013-05-05','12:15:00',2.71),('5819','2013-05-05','12:20:00',2.95),('5819','2013-05-05','12:25:00',3.15),('5819','2013-05-05','12:30:00',3.41),('5819','2013-05-05','12:35:00',3.69),('5819','2013-05-05','12:40:00',3.24),('5819','2013-05-05','12:45:00',3.23),('5819','2013-05-05','12:50:00',3.14),('5819','2013-05-05','12:55:00',3.81),('5819','2013-05-05','13:00:00',3.87),('5819','2013-05-05','13:05:00',4.05),('5819','2013-05-05','13:10:00',4.1),('5819','2013-05-05','13:15:00',4.12),('5819','2013-05-05','13:20:00',3.55),('5819','2013-05-05','13:25:00',2.06),('5819','2013-05-05','13:30:00',1.44),('5819','2013-05-05','13:35:00',3.51),('5819','2013-05-05','13:40:00',3.87),('5819','2013-05-05','13:45:00',3.95),('5819','2013-05-05','13:50:00',3.91),('5819','2013-05-05','13:55:00',3.9),('5819','2013-05-05','14:00:00',3.96),('5819','2013-05-05','14:05:00',4.08),('5819','2013-05-05','14:10:00',3.06),('5819','2013-05-05','14:15:00',2.67),('5819','2013-05-05','14:20:00',3.48),('5819','2013-05-05','14:25:00',3.55),('5819','2013-05-05','14:30:00',3.43),('5819','2013-05-05','14:35:00',3.38),('5819','2013-05-05','14:40:00',3.32),('5819','2013-05-05','14:45:00',3.33),('5819','2013-05-05','14:50:00',3.29),('5819','2013-05-05','14:55:00',3.24),('5819','2013-05-05','15:00:00',3.18),('5819','2013-05-05','15:05:00',3.14),('5819','2013-05-05','15:10:00',3.1),('5819','2013-05-05','15:15:00',3.07),('5819','2013-05-05','15:20:00',3.01),('5819','2013-05-05','15:25:00',2.97),('5819','2013-05-05','15:30:00',2.94),('5819','2013-05-05','15:35:00',2.89),('5819','2013-05-05','15:40:00',2.83),('5819','2013-05-05','15:45:00',2.79),('5819','2013-05-05','15:50:00',2.75),('5819','2013-05-05','15:55:00',2.67),('5819','2013-05-05','16:00:00',2.61),('5819','2013-05-05','16:05:00',2.55),('5819','2013-05-05','16:10:00',2.49),('5819','2013-05-05','16:15:00',2.44),('5819','2013-05-05','16:20:00',2.37),('5819','2013-05-05','16:25:00',2.3),('5819','2013-05-05','16:30:00',2.23),('5819','2013-05-05','16:35:00',2.16),('5819','2013-05-05','16:40:00',2.09),('5819','2013-05-05','16:45:00',2.01),('5819','2013-05-05','16:50:00',1.94),('5819','2013-05-05','16:55:00',1.86),('5819','2013-05-05','17:00:00',1.78),('5819','2013-05-05','17:05:00',1.7),('5819','2013-05-05','17:10:00',1.62),('5819','2013-05-05','17:15:00',1.56),('5819','2013-05-05','17:20:00',1.48),('5819','2013-05-05','17:25:00',1.39),('5819','2013-05-05','17:30:00',1.3),('5819','2013-05-05','17:35:00',1.16),('5819','2013-05-05','17:40:00',1.14),('5819','2013-05-05','17:45:00',1.07),('5819','2013-05-04','07:40:00',1.15),('5819','2013-05-04','07:45:00',1.14),('5819','2013-05-04','07:50:00',1.11),('5819','2013-05-04','07:55:00',1.33),('5819','2013-05-04','08:00:00',1.45),('5819','2013-05-04','08:05:00',1.54),('5819','2013-05-04','08:10:00',1.61),('5819','2013-05-04','08:15:00',1.68),('5819','2013-05-04','08:20:00',1.75),('5819','2013-05-04','08:25:00',1.81),('5819','2013-05-04','08:30:00',1.9),('5819','2013-05-04','08:35:00',1.97),('5819','2013-05-04','08:40:00',2.05),('5819','2013-05-04','08:45:00',2.14),('5819','2013-05-04','08:50:00',2.21),('5819','2013-05-04','08:55:00',2.28),('5819','2013-05-04','09:00:00',2.35),('5819','2013-05-04','09:05:00',2.43),('5819','2013-05-04','09:10:00',2.5),('5819','2013-05-04','09:15:00',2.52),('5819','2013-05-04','09:20:00',2.63),('5819','2013-05-04','09:25:00',2.68),('5819','2013-05-04','09:30:00',2.71),('5819','2013-05-04','09:35:00',2.79),('5819','2013-05-04','09:40:00',2.86),('5819','2013-05-04','09:45:00',2.95),('5819','2013-05-04','09:50:00',3),('5819','2013-05-04','09:55:00',3.04),('5819','2013-05-04','10:00:00',3.12),('5819','2013-05-04','10:05:00',3.15),('5819','2013-05-04','10:10:00',3.2),('5819','2013-05-04','10:15:00',3.25),('5819','2013-05-04','10:20:00',3.32),('5819','2013-05-04','10:25:00',3.35),('5819','2013-05-04','10:30:00',3.38),('5819','2013-05-04','10:35:00',3.41),('5819','2013-05-04','10:40:00',3.39),('5819','2013-05-04','10:45:00',3.39),('5819','2013-05-04','10:50:00',3.36),('5819','2013-05-04','10:55:00',3.33),('5819','2013-05-04','11:00:00',3.35),('5819','2013-05-04','11:05:00',3.36),('5819','2013-05-04','11:10:00',3.22),('5819','2013-05-04','11:15:00',3.05),('5819','2013-05-04','11:20:00',3.24),('5819','2013-05-04','11:25:00',3.39),('5819','2013-05-04','11:30:00',3.19),('5819','2013-05-04','11:35:00',3.33),('5819','2013-05-04','11:40:00',3.21),('5819','2013-05-04','11:45:00',3.26),('5819','2013-05-04','11:50:00',3.31),('5819','2013-05-04','11:55:00',3.26),('5819','2013-05-04','12:00:00',3.22),('5819','2013-05-04','12:05:00',3.34),('5819','2013-05-04','12:10:00',3.37),('5819','2013-05-04','12:15:00',3.41),('5819','2013-05-04','12:20:00',3.5),('5819','2013-05-04','12:25:00',3.56),('5819','2013-05-04','12:30:00',3.55),('5819','2013-05-04','12:35:00',3.61),('5819','2013-05-04','12:40:00',3.59),('5819','2013-05-04','12:45:00',3.6),('5819','2013-05-04','12:50:00',3.5),('5819','2013-05-04','12:55:00',3.42),('5819','2013-05-04','13:00:00',3.37),('5819','2013-05-04','13:05:00',3.11),('5819','2013-05-04','13:10:00',3.17),('5819','2013-05-04','13:15:00',3.64),('5819','2013-05-04','13:20:00',3.7),('5819','2013-05-04','13:25:00',3.52),('5819','2013-05-04','13:30:00',3.48),('5819','2013-05-04','13:35:00',3.36),('5819','2013-05-04','13:40:00',3.42),('5819','2013-05-04','13:45:00',3.38),('5819','2013-05-04','13:50:00',2.98),('5819','2013-05-04','13:55:00',3.17),('5819','2013-05-04','14:00:00',3.23),('5819','2013-05-04','14:05:00',3.32),('5819','2013-05-04','14:10:00',3.14),('5819','2013-05-04','14:15:00',3.17),('5819','2013-05-04','14:20:00',3.24),('5819','2013-05-04','14:25:00',2.92),('5819','2013-05-04','14:30:00',3.1),('5819','2013-05-04','14:35:00',2.9),('5819','2013-05-04','14:40:00',3),('5819','2013-05-04','14:45:00',2.97),('5819','2013-05-04','14:50:00',2.79),('5819','2013-05-04','14:55:00',2.88),('5819','2013-05-04','15:00:00',2.9),('5819','2013-05-04','15:05:00',3.01),('5819','2013-05-04','15:10:00',2.78),('5819','2013-05-04','15:15:00',2.83),('5819','2013-05-04','15:20:00',2.84),('5819','2013-05-04','15:25:00',2.88),('5819','2013-05-04','15:30:00',2.82),('5819','2013-05-04','15:35:00',2.7),('5819','2013-05-04','15:40:00',2.61),('5819','2013-05-04','15:45:00',2.65),('5819','2013-05-04','15:50:00',2.6),('5819','2013-05-04','15:55:00',2.55),('5819','2013-05-04','16:00:00',2.49),('5819','2013-05-04','16:05:00',2.43),('5819','2013-05-04','16:10:00',2.37),('5819','2013-05-04','16:15:00',2.3),('5819','2013-05-04','16:20:00',2.22),('5819','2013-05-04','16:25:00',2.16),('5819','2013-05-04','16:30:00',2.09),('5819','2013-05-04','16:35:00',2.03),('5819','2013-05-04','16:40:00',1.96),('5819','2013-05-04','16:45:00',1.88),('5819','2013-05-04','16:50:00',1.79),('5819','2013-05-04','16:55:00',1.73),('5819','2013-05-04','17:00:00',1.67),('5819','2013-05-04','17:05:00',1.58),('5819','2013-05-04','17:10:00',1.25),('5819','2013-05-04','17:15:00',1.36),('5819','2013-05-04','17:20:00',1.41),('5819','2013-05-04','17:25:00',1.33),('5819','2013-05-04','17:30:00',1.23),('5819','2013-05-04','17:35:00',1.02),('5819','2013-05-04','17:40:00',1.03),('5819','2013-05-03','08:05:00',1.43),('5819','2013-05-03','08:10:00',1.7),('5819','2013-05-03','08:15:00',1.94),('5819','2013-05-03','08:20:00',1.89),('5819','2013-05-03','08:25:00',2.03),('5819','2013-05-03','08:30:00',2.1),('5819','2013-05-03','08:35:00',2.15),('5819','2013-05-03','08:40:00',2.2),('5819','2013-05-03','08:45:00',2.27),('5819','2013-05-03','08:50:00',2.25),('5819','2013-05-03','08:55:00',2.25),('5819','2013-05-03','09:00:00',2.41),('5819','2013-05-03','09:05:00',2.55),('5819','2013-05-03','09:10:00',2.55),('5819','2013-05-03','09:15:00',2.63),('5819','2013-05-03','09:20:00',2.7),('5819','2013-05-03','09:25:00',2.75),('5819','2013-05-03','09:30:00',2.8),('5819','2013-05-03','09:35:00',2.89),('5819','2013-05-03','09:40:00',2.96),('5819','2013-05-03','09:45:00',3.01),('5819','2013-05-03','09:50:00',3.08),('5819','2013-05-03','09:55:00',3.11),('5819','2013-05-03','10:00:00',3.17),('5819','2013-05-03','10:05:00',3.22),('5819','2013-05-03','10:10:00',3.28),('5819','2013-05-03','10:15:00',3.31),('5819','2013-05-03','10:20:00',3.34),('5819','2013-05-03','10:25:00',3.36),('5819','2013-05-03','10:30:00',3.41),('5819','2013-05-03','10:35:00',3.42),('5819','2013-05-03','10:40:00',3.43),('5819','2013-05-03','10:45:00',3.49),('5819','2013-05-03','10:50:00',3.53),('5819','2013-05-03','10:55:00',3.55),('5819','2013-05-03','11:00:00',3.57),('5819','2013-05-03','11:05:00',3.61),('5819','2013-05-03','11:10:00',3.64),('5819','2013-05-03','11:15:00',3.64),('5819','2013-05-03','11:20:00',3.68),('5819','2013-05-03','11:25:00',3.7),('5819','2013-05-03','11:30:00',3.69),('5819','2013-05-03','11:35:00',3.72),('5819','2013-05-03','11:40:00',3.73),('5819','2013-05-03','11:45:00',3.73),('5819','2013-05-03','11:50:00',3.76),('5819','2013-05-03','11:55:00',3.77),('5819','2013-05-03','12:00:00',3.76),('5819','2013-05-03','12:05:00',3.75),('5819','2013-05-03','12:10:00',3.79),('5819','2013-05-03','12:15:00',3.8),('5819','2013-05-03','12:20:00',3.79),('5819','2013-05-03','12:25:00',3.82),('5819','2013-05-03','12:30:00',3.8),('5819','2013-05-03','12:35:00',3.76),('5819','2013-05-03','12:40:00',3.74),('5819','2013-05-03','12:45:00',3.75),('5819','2013-05-03','12:50:00',3.77),('5819','2013-05-03','12:55:00',3.83),('5819','2013-05-03','13:00:00',3.78),('5819','2013-05-03','13:05:00',3.74),('5819','2013-05-03','13:10:00',3.76),('5819','2013-05-03','13:15:00',3.73),('5819','2013-05-03','13:20:00',3.77),('5819','2013-05-03','13:25:00',3.74),('5819','2013-05-03','13:30:00',3.71),('5819','2013-05-03','13:35:00',3.66),('5819','2013-05-03','13:40:00',3.51),('5819','2013-05-03','13:45:00',3.5),('5819','2013-05-03','13:50:00',3.48),('5819','2013-05-03','13:55:00',3.49),('5819','2013-05-03','14:00:00',3.46),('5819','2013-05-03','14:05:00',3.3),('5819','2013-05-03','14:10:00',3.32),('5819','2013-05-03','14:15:00',3.22),('5819','2013-05-03','14:20:00',3.32),('5819','2013-05-03','14:25:00',3.29),('5819','2013-05-03','14:30:00',3.3),('5819','2013-05-03','14:35:00',3.31),('5819','2013-05-03','14:40:00',3.22),('5819','2013-05-03','14:45:00',3.19),('5819','2013-05-03','14:50:00',3.17),('5819','2013-05-03','14:55:00',3.14),('5819','2013-05-03','15:00:00',3.11),('5819','2013-05-03','15:05:00',3.08),('5819','2013-05-03','15:10:00',3.08),('5819','2013-05-03','15:15:00',3.06),('5819','2013-05-03','15:20:00',2.99),('5819','2013-05-03','15:25:00',2.95),('5819','2013-05-03','15:30:00',2.9),('5819','2013-05-03','15:35:00',2.87),('5819','2013-05-03','15:40:00',2.8),('5819','2013-05-03','15:45:00',2.76),('5819','2013-05-03','15:50:00',2.69),('5819','2013-05-03','15:55:00',2.61),('5819','2013-05-03','16:00:00',2.58),('5819','2013-05-03','16:05:00',2.52),('5819','2013-05-03','16:10:00',2.45),('5819','2013-05-03','16:15:00',2.37),('5819','2013-05-03','16:20:00',2.28),('5819','2013-05-03','16:25:00',2.19),('5819','2013-05-03','16:30:00',2.19),('5819','2013-05-03','16:35:00',2.12),('5819','2013-05-03','16:40:00',2.05),('5819','2013-05-03','16:45:00',1.96),('5819','2013-05-03','16:50:00',1.88),('5819','2013-05-03','16:55:00',1.8),('5819','2013-05-03','17:00:00',1.74),('5819','2013-05-03','17:05:00',1.65),('5819','2013-05-03','17:10:00',1.58),('5819','2013-05-03','17:15:00',1.5),('5819','2013-05-03','17:20:00',1.39),('5819','2013-05-03','17:25:00',1.29),('5819','2013-05-03','17:30:00',1.21),('5819','2013-05-03','17:35:00',1.08),('5819','2013-05-03','17:40:00',1.05),('5819','2013-05-02','08:55:00',1.08),('5819','2013-05-02','09:00:00',1.89),('5819','2013-05-02','09:05:00',1.86),('5819','2013-05-02','09:25:00',1.5),('5819','2013-05-02','09:30:00',1.83),('5819','2013-05-02','09:35:00',2.14),('5819','2013-05-02','09:40:00',1.4),('5819','2013-05-02','09:45:00',2.52),('5819','2013-05-02','09:50:00',1.26),('5819','2013-05-02','10:05:00',1.39),('5819','2013-05-02','10:10:00',1.45),('5819','2013-05-02','10:15:00',1.46),('5819','2013-05-02','10:20:00',1.5),('5819','2013-05-02','10:25:00',1.82),('5819','2013-05-02','10:30:00',3.01),('5819','2013-05-02','10:35:00',2.58),('5819','2013-05-02','10:40:00',3.5),('5819','2013-05-02','10:45:00',2.83),('5819','2013-05-02','10:50:00',3.24),('5819','2013-05-02','10:55:00',3.76),('5819','2013-05-02','11:00:00',3.87),('5819','2013-05-02','11:05:00',3.66),('5819','2013-05-02','11:10:00',2.93),('5819','2013-05-02','11:15:00',2.76),('5819','2013-05-02','11:20:00',2.51),('5819','2013-05-02','11:25:00',3.81),('5819','2013-05-02','11:30:00',3.82),('5819','2013-05-02','11:35:00',3.79),('5819','2013-05-02','11:40:00',3.71),('5819','2013-05-02','11:45:00',3.7),('5819','2013-05-02','11:50:00',3.71),('5819','2013-05-02','11:55:00',3.7),('5819','2013-05-02','12:00:00',3.69),('5819','2013-05-02','12:05:00',3.65),('5819','2013-05-02','12:10:00',3.63),('5819','2013-05-02','12:15:00',3.67),('5819','2013-05-02','12:20:00',3.7),('5819','2013-05-02','12:25:00',3.68),('5819','2013-05-02','12:30:00',3.74),('5819','2013-05-02','12:35:00',3.79),('5819','2013-05-02','12:40:00',3.82),('5819','2013-05-02','12:45:00',3.84),('5819','2013-05-02','12:50:00',3.85),('5819','2013-05-02','12:55:00',3.86),('5819','2013-05-02','13:00:00',3.91),('5819','2013-05-02','13:05:00',3.89),('5819','2013-05-02','13:10:00',3.91),('5819','2013-05-02','13:15:00',3.91),('5819','2013-05-02','13:20:00',3.9),('5819','2013-05-02','13:25:00',3.88),('5819','2013-05-02','13:30:00',3.88),('5819','2013-05-02','13:35:00',3.86),('5819','2013-05-02','13:40:00',3.82),('5819','2013-05-02','13:45:00',3.79),('5819','2013-05-02','13:50:00',3.76),('5819','2013-05-02','13:55:00',3.75),('5819','2013-05-02','14:00:00',3.71),('5819','2013-05-02','14:05:00',3.63),('5819','2013-05-02','14:10:00',3.61),('5819','2013-05-02','14:15:00',3.6),('5819','2013-05-02','14:20:00',3.57),('5819','2013-05-02','14:25:00',3.53),('5819','2013-05-02','14:30:00',3.5),('5819','2013-05-02','14:35:00',3.46),('5819','2013-05-02','14:40:00',3.42),('5819','2013-05-02','14:45:00',3.4),('5819','2013-05-02','14:50:00',3.36),('5819','2013-05-02','14:55:00',3.31),('5819','2013-05-02','15:00:00',3.27),('5819','2013-05-02','15:05:00',3.22),('5819','2013-05-02','15:10:00',3.18),('5819','2013-05-02','15:15:00',3.12),('5819','2013-05-02','15:20:00',3.06),('5819','2013-05-02','15:25:00',3),('5819','2013-05-02','15:30:00',2.92),('5819','2013-05-02','15:35:00',2.83),('5819','2013-05-02','15:40:00',2.79),('5819','2013-05-02','15:45:00',2.71),('5819','2013-05-02','15:50:00',2.67),('5819','2013-05-02','15:55:00',2.62),('5819','2013-05-02','16:00:00',2.55),('5819','2013-05-02','16:05:00',2.5),('5819','2013-05-02','16:10:00',2.45),('5819','2013-05-02','16:15:00',2.38),('5819','2013-05-02','16:20:00',2.32),('5819','2013-05-02','16:25:00',2.24),('5819','2013-05-02','16:30:00',2.17),('5819','2013-05-02','16:35:00',2.08),('5819','2013-05-02','16:40:00',2.02),('5819','2013-05-02','16:45:00',1.94),('5819','2013-05-02','16:50:00',1.88),('5819','2013-05-02','16:55:00',1.8),('5819','2013-05-02','17:00:00',1.73),('5819','2013-05-02','17:05:00',1.67),('5819','2013-05-02','17:10:00',1.59),('5819','2013-05-02','17:15:00',1.52),('5819','2013-05-02','17:20:00',1.45),('5819','2013-05-02','17:25:00',1.37),('5819','2013-05-02','17:30:00',1.27),('5819','2013-05-02','17:35:00',1.06),('5819','2013-05-02','17:40:00',1.04),('5819','2013-05-02','17:45:00',1.05),('5819','2013-05-01','07:50:00',1.06),('5819','2013-05-01','07:55:00',1.14),('5819','2013-05-01','08:00:00',1.23),('5819','2013-05-01','08:05:00',1.3),('5819','2013-05-01','08:10:00',1.35),('5819','2013-05-01','08:15:00',1.44),('5819','2013-05-01','08:20:00',1.55),('5819','2013-05-01','08:25:00',1.65),('5819','2013-05-01','08:30:00',1.74),('5819','2013-05-01','08:35:00',1.85),('5819','2013-05-01','08:40:00',1.92),('5819','2013-05-01','08:45:00',1.98),('5819','2013-05-01','08:50:00',2.07),('5819','2013-05-01','08:55:00',2.16),('5819','2013-05-01','09:00:00',2.26),('5819','2013-05-01','09:05:00',2.32),('5819','2013-05-01','09:10:00',2.37),('5819','2013-05-01','09:15:00',2.43),('5819','2013-05-01','09:20:00',2.46),('5819','2013-05-01','09:25:00',2.51),('5819','2013-05-01','09:30:00',2.54),('5819','2013-05-01','09:35:00',2.58),('5819','2013-05-01','09:40:00',2.65),('5819','2013-05-01','09:45:00',2.71),('5819','2013-05-01','09:50:00',2.77),('5819','2013-05-01','09:55:00',2.82),('5819','2013-05-01','10:00:00',2.85),('5819','2013-05-01','10:05:00',2.86),('5819','2013-05-01','10:10:00',2.93),('5819','2013-05-01','10:15:00',3.01),('5819','2013-05-01','10:20:00',3.06),('5819','2013-05-01','10:25:00',3.1),('5819','2013-05-01','10:30:00',3.14),('5819','2013-05-01','10:35:00',3.17),('5819','2013-05-01','10:40:00',3.27),('5819','2013-05-01','10:45:00',3.42),('5819','2013-05-01','10:50:00',3.45),('5819','2013-05-01','10:55:00',3.46),('5819','2013-05-01','11:00:00',3.45),('5819','2013-05-01','11:05:00',3.48),('5819','2013-05-01','11:10:00',3.5),('5819','2013-05-01','11:15:00',3.29),('5819','2013-05-01','11:20:00',3.28),('5819','2013-05-01','11:25:00',3.23),('5819','2013-05-01','11:30:00',3.15),('5819','2013-05-01','11:35:00',3.27),('5819','2013-05-01','11:40:00',2.73),('5819','2013-05-01','11:45:00',2.52),('5819','2013-05-01','11:50:00',3.02),('5819','2013-05-01','11:55:00',3.71),('5819','2013-05-01','12:00:00',3.65),('5819','2013-05-01','12:05:00',3.61),('5819','2013-05-01','12:10:00',3.6),('5819','2013-05-01','12:15:00',3.57),('5819','2013-05-01','12:20:00',3.57),('5819','2013-05-01','12:25:00',3.61),('5819','2013-05-01','12:30:00',3.63),('5819','2013-05-01','12:35:00',3.67),('5819','2013-05-01','12:40:00',3.74),('5819','2013-05-01','12:45:00',3.59),('5819','2013-05-01','12:50:00',2.99),('5819','2013-05-01','12:55:00',1.44),('5819','2013-05-01','13:00:00',1.41),('5819','2013-05-01','13:05:00',1.61),('5819','2013-05-01','13:10:00',1.96),('5819','2013-05-01','13:15:00',3.34),('5819','2013-05-01','13:20:00',4.31),('5819','2013-05-01','13:25:00',3.53),('5819','2013-05-01','13:30:00',2.32),('5819','2013-05-01','13:35:00',3.02),('5819','2013-05-01','13:40:00',3.4),('5819','2013-05-01','13:45:00',4.06),('5819','2013-05-01','13:50:00',3.8),('5819','2013-05-01','13:55:00',3.66),('5819','2013-05-01','14:00:00',3.52),('5819','2013-05-01','14:05:00',3.4),('5819','2013-05-01','14:10:00',3.37),('5819','2013-05-01','14:15:00',2.94),('5819','2013-05-01','14:20:00',3.48),('5819','2013-05-01','14:25:00',3.49),('5819','2013-05-01','14:30:00',3.49),('5819','2013-05-01','14:35:00',3.41),('5819','2013-05-01','14:40:00',3),('5819','2013-05-01','14:45:00',3.19),('5819','2013-05-01','14:50:00',2.73),('5819','2013-05-01','14:55:00',2.56),('5819','2013-05-01','15:00:00',2.58),('5819','2013-05-01','15:05:00',3.01),('5819','2013-05-01','15:10:00',3.04),('5819','2013-05-01','15:15:00',2.94),('5819','2013-05-01','15:20:00',2.78),('5819','2013-05-01','15:25:00',2.88),('5819','2013-05-01','15:30:00',2.46),('5819','2013-05-01','15:35:00',2.08),('5819','2013-05-01','15:40:00',2.07),('5819','2013-05-01','15:45:00',2.03),('5819','2013-05-01','15:50:00',1.58),('5819','2013-05-01','15:55:00',1.47),('5819','2013-05-01','16:00:00',1.77),('5819','2013-05-01','16:05:00',1.76),('5819','2013-05-01','16:10:00',1.56),('5819','2013-05-01','16:15:00',1.41),('5819','2013-05-01','16:20:00',1.26),('5819','2013-05-01','16:40:00',1.03),('5819','2013-04-30','08:55:00',1.47),('5819','2013-04-30','09:00:00',1.86),('5819','2013-04-30','09:05:00',1.63),('5819','2013-04-30','09:10:00',2.15),('5819','2013-04-30','09:15:00',2.69),('5819','2013-04-30','09:20:00',2.63),('5819','2013-04-30','09:25:00',2.84),('5819','2013-04-30','09:30:00',2.79),('5819','2013-04-30','09:35:00',2.37),('5819','2013-04-30','09:40:00',1.71),('5819','2013-04-30','09:45:00',1.89),('5819','2013-04-30','09:50:00',2.57),('5819','2013-04-30','09:55:00',2.83),('5819','2013-04-30','10:00:00',3.21),('5819','2013-04-30','10:05:00',3.34),('5819','2013-04-30','10:10:00',2.71),('5819','2013-04-30','10:15:00',2.38),('5819','2013-04-30','10:20:00',2.21),('5819','2013-04-30','10:25:00',2.36),('5819','2013-04-30','10:30:00',1.97),('5819','2013-04-30','10:35:00',1.9),('5819','2013-04-30','10:40:00',1.57),('5819','2013-04-30','10:45:00',1.23),('5819','2013-04-30','10:50:00',1.32),('5819','2013-04-30','10:55:00',1.42),('5819','2013-04-30','11:00:00',1.42),('5819','2013-04-30','11:05:00',1.58),('5819','2013-04-30','11:10:00',1.65),('5819','2013-04-30','11:15:00',1.7),('5819','2013-04-30','11:20:00',1.99),('5819','2013-04-30','11:25:00',1.84),('5819','2013-04-30','11:30:00',1.78),('5819','2013-04-30','11:35:00',1.86),('5819','2013-04-30','11:40:00',1.89),('5819','2013-04-30','11:45:00',1.59),('5819','2013-04-30','11:50:00',1.63),('5819','2013-04-30','11:55:00',1.66),('5819','2013-04-30','12:00:00',1.66),('5819','2013-04-30','12:05:00',1.67),('5819','2013-04-30','12:10:00',1.64),('5819','2013-04-30','12:15:00',1.52),('5819','2013-04-30','12:20:00',1.35),('5819','2013-04-30','12:25:00',1.23),('5819','2013-04-30','12:30:00',1.22),('5819','2013-04-30','12:35:00',1.99),('5819','2013-04-30','12:40:00',3.85),('5819','2013-04-30','12:45:00',4.22),('5819','2013-04-30','12:50:00',4.01),('5819','2013-04-30','12:55:00',3.66),('5819','2013-04-30','13:00:00',3.76),('5819','2013-04-30','13:05:00',3.7),('5819','2013-04-30','13:10:00',3.79),('5819','2013-04-30','13:15:00',3.72),('5819','2013-04-30','13:20:00',3.66),('5819','2013-04-30','13:25:00',3.64),('5819','2013-04-30','13:30:00',3.59),('5819','2013-04-30','13:35:00',3.59),('5819','2013-04-30','13:40:00',3.53),('5819','2013-04-30','13:45:00',3.5),('5819','2013-04-30','13:50:00',3.45),('5819','2013-04-30','13:55:00',3.41),('5819','2013-04-30','14:00:00',3.38),('5819','2013-04-30','14:05:00',3.35),('5819','2013-04-30','14:10:00',3.32),('5819','2013-04-30','14:15:00',3.29),('5819','2013-04-30','14:20:00',3.28),('5819','2013-04-30','14:25:00',3.27),('5819','2013-04-30','14:30:00',3.22),('5819','2013-04-30','14:35:00',3.19),('5819','2013-04-30','14:40:00',3.15),('5819','2013-04-30','14:45:00',3.1),('5819','2013-04-30','14:50:00',3.05),('5819','2013-04-30','14:55:00',2.99),('5819','2013-04-30','15:00:00',2.94),('5819','2013-04-30','15:05:00',2.89),('5819','2013-04-30','15:10:00',2.85),('5819','2013-04-30','15:15:00',2.8),('5819','2013-04-30','15:20:00',2.76),('5819','2013-04-30','15:25:00',2.7),('5819','2013-04-30','15:30:00',2.64),('5819','2013-04-30','15:35:00',2.62),('5819','2013-04-30','15:40:00',2.57),('5819','2013-04-30','15:45:00',2.51),('5819','2013-04-30','15:50:00',2.43),('5819','2013-04-30','15:55:00',2.37),('5819','2013-04-30','16:00:00',2.32),('5819','2013-04-30','16:05:00',2.26),('5819','2013-04-30','16:10:00',2.2),('5819','2013-04-30','16:15:00',2.14),('5819','2013-04-30','16:20:00',2.08),('5819','2013-04-30','16:25:00',2.01),('5819','2013-04-30','16:30:00',1.96),('5819','2013-04-30','16:35:00',1.88),('5819','2013-04-30','16:40:00',1.62),('5819','2013-04-30','16:45:00',1.66),('5819','2013-04-30','16:50:00',1.37),('5819','2013-04-30','16:55:00',1.57),('5819','2013-04-30','17:00:00',1.47),('5819','2013-04-30','17:05:00',1.47),('5819','2013-04-30','17:10:00',1.31),('5819','2013-04-30','17:20:00',1),('5819','2013-04-30','17:25:00',1.19),('5819','2013-04-30','17:30:00',1.11),('5819','2013-04-30','17:35:00',1.02),('5819','2013-04-29','07:55:00',1.1),('5819','2013-04-29','08:00:00',1.32),('5819','2013-04-29','08:05:00',1.42),('5819','2013-04-29','08:10:00',1.37),('5819','2013-04-29','08:15:00',1.39),('5819','2013-04-29','08:20:00',1.5),('5819','2013-04-29','08:25:00',1.7),('5819','2013-04-29','08:30:00',1.92),('5819','2013-04-29','08:35:00',2.16),('5819','2013-04-29','08:40:00',2.2),('5819','2013-04-29','08:45:00',2.11),('5819','2013-04-29','08:50:00',2.27),('5819','2013-04-29','08:55:00',2.28),('5819','2013-04-29','09:00:00',1.7),('5819','2013-04-29','09:05:00',2.27),('5819','2013-04-29','09:10:00',2.59),('5819','2013-04-29','09:15:00',2.75),('5819','2013-04-29','09:20:00',2.62),('5819','2013-04-29','09:25:00',2.5),('5819','2013-04-29','09:30:00',2.49),('5819','2013-04-29','09:35:00',2.64),('5819','2013-04-29','09:40:00',2.64),('5819','2013-04-29','09:45:00',2.72),('5819','2013-04-29','09:50:00',2.93),('5819','2013-04-29','09:55:00',2.68),('5819','2013-04-29','10:00:00',2.81),('5819','2013-04-29','10:05:00',2.81),('5819','2013-04-29','10:10:00',2.77),('5819','2013-04-29','10:15:00',2.35),('5819','2013-04-29','10:20:00',2.23),('5819','2013-04-29','10:25:00',2.76),('5819','2013-04-29','10:30:00',2.68),('5819','2013-04-29','10:35:00',3.18),('5819','2013-04-29','10:40:00',3.22),('5819','2013-04-29','10:45:00',3.27),('5819','2013-04-29','10:50:00',3.12),('5819','2013-04-29','10:55:00',2.9),('5819','2013-04-29','11:00:00',3.22),('5819','2013-04-29','11:05:00',3.19),('5819','2013-04-29','11:10:00',3.05),('5819','2013-04-29','11:15:00',2.84),('5819','2013-04-29','11:20:00',3.29),('5819','2013-04-29','11:25:00',3.4),('5819','2013-04-29','11:30:00',3.54),('5819','2013-04-29','11:35:00',3.4),('5819','2013-04-29','11:40:00',3.42),('5819','2013-04-29','11:45:00',3.37),('5819','2013-04-29','11:50:00',3.64),('5819','2013-04-29','11:55:00',3.62),('5819','2013-04-29','12:00:00',3.72),('5819','2013-04-29','12:05:00',3.75),('5819','2013-04-29','12:10:00',3.62),('5819','2013-04-29','12:15:00',3.61),('5819','2013-04-29','12:20:00',3.66),('5819','2013-04-29','12:25:00',3.54),('5819','2013-04-29','12:30:00',3.63),('5819','2013-04-29','12:35:00',3.68),('5819','2013-04-29','12:40:00',3.76),('5819','2013-04-29','12:45:00',3.76),('5819','2013-04-29','12:50:00',3.78),('5819','2013-04-29','12:55:00',3.66),('5819','2013-04-29','13:00:00',3.73),('5819','2013-04-29','13:05:00',3.69),('5819','2013-04-29','13:10:00',3.55),('5819','2013-04-29','13:15:00',3.36),('5819','2013-04-29','13:20:00',3.54),('5819','2013-04-29','13:25:00',3.74),('5819','2013-04-29','13:30:00',3.68),('5819','2013-04-29','13:35:00',3.59),('5819','2013-04-29','13:40:00',3.63),('5819','2013-04-29','13:45:00',3.58),('5819','2013-04-29','13:50:00',3.41),('5819','2013-04-29','13:55:00',3.73),('5819','2013-04-29','14:00:00',3.48),('5819','2013-04-29','14:05:00',3.44),('5819','2013-04-29','14:10:00',3.49),('5819','2013-04-29','14:15:00',3.54),('5819','2013-04-29','14:20:00',3.54),('5819','2013-04-29','14:25:00',3.43),('5819','2013-04-29','14:30:00',3.27),('5819','2013-04-29','14:35:00',3.17),('5819','2013-04-29','14:40:00',3.02),('5819','2013-04-29','14:45:00',3.23),('5819','2013-04-29','14:50:00',3.12),('5819','2013-04-29','14:55:00',3.16),('5819','2013-04-29','15:00:00',3.03),('5819','2013-04-29','15:05:00',3.21),('5819','2013-04-29','15:10:00',2.95),('5819','2013-04-29','15:15:00',2.72),('5819','2013-04-29','15:20:00',2.84),('5819','2013-04-29','15:25:00',3.03),('5819','2013-04-29','15:30:00',2.94),('5819','2013-04-29','15:35:00',2.61),('5819','2013-04-29','15:40:00',2.37),('5819','2013-04-29','15:45:00',2.26),('5819','2013-04-29','15:50:00',2.29),('5819','2013-04-29','15:55:00',2.44),('5819','2013-04-29','16:00:00',2.37),('5819','2013-04-29','16:05:00',2.54),('5819','2013-04-29','16:10:00',2.39),('5819','2013-04-29','16:15:00',2.72),('5819','2013-04-29','16:20:00',2.68),('5819','2013-04-29','16:25:00',2.06),('5819','2013-04-29','16:30:00',2.14),('5819','2013-04-29','16:35:00',2.11),('5819','2013-04-29','16:40:00',2.22),('5819','2013-04-29','16:45:00',2.15),('5819','2013-04-29','16:50:00',2.18),('5819','2013-04-29','16:55:00',2.24),('5819','2013-04-29','17:00:00',2.06),('5819','2013-04-29','17:05:00',1.76),('5819','2013-04-29','17:10:00',1.79),('5819','2013-04-29','17:15:00',1.57),('5819','2013-04-29','17:20:00',1.27),('5819','2013-04-29','17:25:00',1.25),('5819','2013-04-29','17:30:00',1.14),('5819','2013-04-29','17:35:00',1.02),('5819','2013-04-29','17:55:00',1.05),('5819','2013-04-29','18:00:00',1.02),('5819','2013-04-29','18:05:00',1.05),('5819','2013-04-28','07:35:00',1.02),('5819','2013-04-28','07:40:00',1.12),('5819','2013-04-28','07:45:00',1.21),('5819','2013-04-28','07:50:00',1.3),('5819','2013-04-28','07:55:00',1.37),('5819','2013-04-28','08:00:00',1.44),('5819','2013-04-28','08:05:00',1.55),('5819','2013-04-28','08:10:00',1.65),('5819','2013-04-28','08:15:00',1.74),('5819','2013-04-28','08:20:00',1.83),('5819','2013-04-28','08:25:00',1.92),('5819','2013-04-28','08:30:00',1.99),('5819','2013-04-28','08:35:00',2.06),('5819','2013-04-28','08:40:00',2.13),('5819','2013-04-28','08:45:00',2.21),('5819','2013-04-28','08:50:00',2.29),('5819','2013-04-28','08:55:00',2.34),('5819','2013-04-28','09:00:00',2.44),('5819','2013-04-28','09:05:00',2.51),('5819','2013-04-28','09:10:00',2.59),('5819','2013-04-28','09:15:00',2.65),('5819','2013-04-28','09:20:00',2.71),('5819','2013-04-28','09:25:00',2.78),('5819','2013-04-28','09:30:00',2.82),('5819','2013-04-28','09:35:00',2.91),('5819','2013-04-28','09:40:00',2.95),('5819','2013-04-28','09:45:00',3.03),('5819','2013-04-28','09:50:00',3.09),('5819','2013-04-28','09:55:00',3.15),('5819','2013-04-28','10:00:00',3.17),('5819','2013-04-28','10:05:00',3.19),('5819','2013-04-28','10:10:00',3.29),('5819','2013-04-28','10:15:00',3.23),('5819','2013-04-28','10:20:00',3.33),('5819','2013-04-28','10:25:00',3.43),('5819','2013-04-28','10:30:00',3.35),('5819','2013-04-28','10:35:00',3.43),('5819','2013-04-28','10:40:00',3.14),('5819','2013-04-28','10:45:00',3.57),('5819','2013-04-28','10:50:00',3.56),('5819','2013-04-28','10:55:00',3.58),('5819','2013-04-28','11:00:00',3.6),('5819','2013-04-28','11:05:00',3.6),('5819','2013-04-28','11:10:00',3.66),('5819','2013-04-28','11:15:00',3.66),('5819','2013-04-28','11:20:00',3.69),('5819','2013-04-28','11:25:00',3.75),('5819','2013-04-28','11:30:00',3.76),('5819','2013-04-28','11:35:00',3.65),('5819','2013-04-28','11:40:00',3.65),('5819','2013-04-28','11:45:00',3.54),('5819','2013-04-28','11:50:00',3.57),('5819','2013-04-28','11:55:00',3.7),('5819','2013-04-28','12:00:00',3.27),('5819','2013-04-28','12:05:00',3.22),('5819','2013-04-28','12:10:00',3.53),('5819','2013-04-28','12:15:00',3.71),('5819','2013-04-28','12:20:00',3.6),('5819','2013-04-28','12:25:00',3.2),('5819','2013-04-28','12:30:00',3.12),('5819','2013-04-28','12:35:00',2.8),('5819','2013-04-28','12:40:00',2.83),('5819','2013-04-28','12:45:00',3.6),('5819','2013-04-28','12:50:00',3.8),('5819','2013-04-28','12:55:00',3.46),('5819','2013-04-28','13:00:00',3.58),('5819','2013-04-28','13:05:00',3.82),('5819','2013-04-28','13:10:00',3.76),('5819','2013-04-28','13:15:00',3.51),('5819','2013-04-28','13:20:00',3.54),('5819','2013-04-28','13:25:00',3.52),('5819','2013-04-28','13:30:00',3.68),('5819','2013-04-28','13:35:00',3.67),('5819','2013-04-28','13:40:00',3.89),('5819','2013-04-28','13:45:00',3.8),('5819','2013-04-28','13:50:00',3.6),('5819','2013-04-28','13:55:00',3.42),('5819','2013-04-28','14:00:00',3.58),('5819','2013-04-28','14:05:00',3.58),('5819','2013-04-28','14:10:00',3.46),('5819','2013-04-28','14:15:00',3.53),('5819','2013-04-28','14:20:00',3.34),('5819','2013-04-28','14:25:00',3.17),('5819','2013-04-28','14:30:00',3.39),('5819','2013-04-28','14:35:00',3.38),('5819','2013-04-28','14:40:00',3.32),('5819','2013-04-28','14:45:00',3.27),('5819','2013-04-28','14:50:00',3.23),('5819','2013-04-28','14:55:00',3.19),('5819','2013-04-28','15:00:00',3.15),('5819','2013-04-28','15:05:00',3.1),('5819','2013-04-28','15:10:00',3.08),('5819','2013-04-28','15:15:00',3.07),('5819','2013-04-28','15:20:00',3.02),('5819','2013-04-28','15:25:00',2.95),('5819','2013-04-28','15:30:00',2.89),('5819','2013-04-28','15:35:00',2.83),('5819','2013-04-28','15:40:00',2.77),('5819','2013-04-28','15:45:00',2.73),('5819','2013-04-28','15:50:00',2.68),('5819','2013-04-28','15:55:00',2.62),('5819','2013-04-28','16:00:00',2.55),('5819','2013-04-28','16:05:00',2.49),('5819','2013-04-28','16:10:00',2.43),('5819','2013-04-28','16:15:00',2.35),('5819','2013-04-28','16:20:00',2.28),('5819','2013-04-28','16:25:00',2.21),('5819','2013-04-28','16:30:00',2.14),('5819','2013-04-28','16:35:00',2.07),('5819','2013-04-28','16:40:00',2),('5819','2013-04-28','16:45:00',1.93),('5819','2013-04-28','16:50:00',1.87),('5819','2013-04-28','16:55:00',1.79),('5819','2013-04-28','17:00:00',1.71),('5819','2013-04-28','17:05:00',1.59),('5819','2013-04-28','17:10:00',1.48),('5819','2013-04-28','17:15:00',1.51),('5819','2013-04-28','17:20:00',1.43),('5819','2013-04-28','17:25:00',1.36),('5819','2013-04-28','17:30:00',1.11),('5819','2013-04-28','17:40:00',1),('5819','2013-04-28','17:45:00',1.03),('5819','2013-04-27','12:55:00',1.16),('5819','2013-04-27','13:00:00',1.35),('5819','2013-04-27','13:05:00',1.08),('5819','2013-04-27','13:10:00',1.06),('5819','2013-04-27','13:15:00',1.3),('5819','2013-04-27','13:20:00',1.34),('5819','2013-04-27','13:25:00',1.09),('5819','2013-04-27','13:30:00',1.06),('5819','2013-04-27','13:35:00',1.29),('5819','2013-04-27','13:40:00',1.67),('5819','2013-04-27','13:45:00',1.07),('5819','2013-04-27','14:25:00',1.1),('5819','2013-04-27','14:30:00',1.98),('5819','2013-04-27','14:35:00',1.86),('5819','2013-04-27','14:40:00',1.19),('5819','2013-04-27','14:45:00',1.24),('5819','2013-04-27','15:05:00',1.33),('5819','2013-04-27','15:10:00',1.15),('5819','2013-04-27','15:15:00',1.07),('5819','2013-04-27','16:45:00',1.02),('5819','2013-04-27','16:50:00',1.57),('5819','2013-04-27','16:55:00',1.62),('5819','2013-04-27','17:00:00',2.11),('5819','2013-04-27','17:05:00',1.61),('5819','2013-04-26','08:05:00',1.01),('5819','2013-04-26','08:10:00',1.33),('5819','2013-04-26','08:15:00',1.46),('5819','2013-04-26','08:20:00',1.51),('5819','2013-04-26','08:25:00',1.59),('5819','2013-04-26','08:30:00',1.63),('5819','2013-04-26','08:35:00',1.77),('5819','2013-04-26','08:40:00',1.83),('5819','2013-04-26','08:45:00',1.92),('5819','2013-04-26','08:50:00',1.97),('5819','2013-04-26','08:55:00',1.71),('5819','2013-04-26','09:00:00',1.22),('5819','2013-04-26','09:05:00',1.68),('5819','2013-04-26','09:10:00',1.97),('5819','2013-04-26','09:15:00',1.22),('5819','2013-04-26','09:20:00',1.13),('5819','2013-04-26','09:25:00',1.27),('5819','2013-04-26','09:30:00',1.71),('5819','2013-04-26','09:35:00',1.86),('5819','2013-04-26','09:40:00',2.24),('5819','2013-04-26','09:45:00',2.64),('5819','2013-04-26','09:50:00',2.66),('5819','2013-04-26','09:55:00',1.68),('5819','2013-04-26','10:00:00',1.71),('5819','2013-04-26','10:05:00',2.19),('5819','2013-04-26','10:10:00',2.98),('5819','2013-04-26','10:15:00',3.09),('5819','2013-04-26','10:20:00',3.16),('5819','2013-04-26','10:25:00',2.53),('5819','2013-04-26','10:30:00',3.13),('5819','2013-04-26','10:35:00',3.4),('5819','2013-04-26','10:40:00',3.39),('5819','2013-04-26','10:45:00',2.96),('5819','2013-04-26','10:50:00',1.94),('5819','2013-04-26','10:55:00',2.73),('5819','2013-04-26','11:00:00',2.88),('5819','2013-04-26','11:05:00',3.35),('5819','2013-04-26','11:10:00',2.99),('5819','2013-04-26','11:15:00',3.39),('5819','2013-04-26','11:20:00',2.88),('5819','2013-04-26','11:25:00',2.88),('5819','2013-04-26','11:30:00',2.89),('5819','2013-04-26','11:35:00',3.17),('5819','2013-04-26','11:40:00',3.23),('5819','2013-04-26','11:45:00',3.26),('5819','2013-04-26','11:50:00',2.66),('5819','2013-04-26','11:55:00',2.42),('5819','2013-04-26','12:00:00',2.55),('5819','2013-04-26','12:05:00',2.56),('5819','2013-04-26','12:10:00',2.19),('5819','2013-04-26','12:15:00',2.28),('5819','2013-04-26','12:20:00',2.27),('5819','2013-04-26','12:25:00',2.02),('5819','2013-04-26','12:30:00',1.68),('5819','2013-04-26','12:35:00',2.05),('5819','2013-04-26','12:40:00',3.09),('5819','2013-04-26','12:45:00',3.52),('5819','2013-04-26','12:50:00',2.21),('5819','2013-04-26','12:55:00',1.87),('5819','2013-04-26','13:00:00',1.37),('5819','2013-04-26','13:05:00',1.25),('5819','2013-04-26','13:10:00',1.47),('5819','2013-04-26','13:15:00',2.08),('5819','2013-04-26','13:20:00',1.52),('5819','2013-04-26','13:25:00',1.75),('5819','2013-04-26','13:30:00',2.26),('5819','2013-04-26','13:35:00',2.06),('5819','2013-04-26','13:40:00',2.45),('5819','2013-04-26','13:45:00',2.04),('5819','2013-04-26','13:50:00',2.77),('5819','2013-04-26','13:55:00',2.37),('5819','2013-04-26','14:00:00',2.45),('5819','2013-04-26','14:05:00',3.1),('5819','2013-04-26','14:10:00',3.09),('5819','2013-04-26','14:15:00',3.17),('5819','2013-04-26','14:20:00',2.79),('5819','2013-04-26','14:25:00',3.28),('5819','2013-04-26','14:30:00',3.44),('5819','2013-04-26','14:35:00',2.7),('5819','2013-04-26','14:40:00',1.66),('5819','2013-04-26','14:45:00',1.55),('5819','2013-04-26','14:50:00',3.16),('5819','2013-04-26','14:55:00',3.57),('5819','2013-04-26','15:00:00',3.32),('5819','2013-04-26','15:05:00',2.82),('5819','2013-04-26','15:10:00',1.19),('5819','2013-04-26','15:15:00',1.49),('5819','2013-04-26','15:20:00',1.33),('5819','2013-04-26','15:25:00',1.39),('5819','2013-04-26','15:30:00',1.83),('5819','2013-04-26','15:35:00',1.66),('5819','2013-04-26','15:40:00',1.61),('5819','2013-04-26','15:45:00',1.79),('5819','2013-04-26','15:50:00',1.6),('5819','2013-04-26','15:55:00',1.02),('5819','2013-04-25','08:10:00',1.15),('5819','2013-04-25','08:15:00',1.44),('5819','2013-04-25','08:20:00',1.2),('5819','2013-04-25','08:25:00',1.04),('5819','2013-04-25','08:35:00',1.06),('5819','2013-04-25','08:40:00',1.12),('5819','2013-04-25','08:45:00',1.26),('5819','2013-04-25','08:50:00',2.03),('5819','2013-04-25','08:55:00',2.49),('5819','2013-04-25','09:00:00',2.14),('5819','2013-04-25','09:05:00',1.5),('5819','2013-04-25','09:10:00',1.32),('5819','2013-04-25','09:15:00',1.25),('5819','2013-04-25','09:20:00',1.27),('5819','2013-04-25','09:25:00',1.56),('5819','2013-04-25','09:30:00',1.47),('5819','2013-04-25','09:35:00',1.61),('5819','2013-04-25','09:40:00',2.3),('5819','2013-04-25','09:45:00',2.72),('5819','2013-04-25','09:50:00',3.15),('5819','2013-04-25','09:55:00',3.16),('5819','2013-04-25','10:00:00',3.17),('5819','2013-04-25','10:05:00',3.02),('5819','2013-04-25','10:10:00',2.77),('5819','2013-04-25','10:15:00',2.88),('5819','2013-04-25','10:20:00',3.27),('5819','2013-04-25','10:25:00',3.34),('5819','2013-04-25','10:30:00',3.4),('5819','2013-04-25','10:35:00',3.46),('5819','2013-04-25','10:40:00',3.45),('5819','2013-04-25','10:45:00',3.35),('5819','2013-04-25','10:50:00',3.46),('5819','2013-04-25','10:55:00',3.55),('5819','2013-04-25','11:00:00',3.61),('5819','2013-04-25','11:05:00',3.67),('5819','2013-04-25','11:10:00',3.67),('5819','2013-04-25','11:15:00',3.66),('5819','2013-04-25','11:20:00',3.68),('5819','2013-04-25','11:25:00',3.7),('5819','2013-04-25','11:30:00',3.7),('5819','2013-04-25','11:35:00',3.77),('5819','2013-04-25','11:40:00',3.77),('5819','2013-04-25','11:45:00',3.82),('5819','2013-04-25','11:50:00',3.84),('5819','2013-04-25','11:55:00',3.78),('5819','2013-04-25','12:00:00',3.72),('5819','2013-04-25','12:05:00',3.71),('5819','2013-04-25','12:10:00',3.77),('5819','2013-04-25','12:15:00',3.77),('5819','2013-04-25','12:20:00',3.79),('5819','2013-04-25','12:25:00',3.78),('5819','2013-04-25','12:30:00',3.79),('5819','2013-04-25','12:35:00',3.78),('5819','2013-04-25','12:40:00',3.76),('5819','2013-04-25','12:45:00',3.76),('5819','2013-04-25','12:50:00',3.75),('5819','2013-04-25','12:55:00',3.79),('5819','2013-04-25','13:00:00',3.82),('5819','2013-04-25','13:05:00',3.88),('5819','2013-04-25','13:10:00',3.76),('5819','2013-04-25','13:15:00',3.63),('5819','2013-04-25','13:20:00',3.42),('5819','2013-04-25','13:25:00',3.43),('5819','2013-04-25','13:30:00',2.75),('5819','2013-04-25','13:35:00',2.7),('5819','2013-04-25','13:40:00',2.23),('5819','2013-04-25','13:45:00',2.02),('5819','2013-04-25','13:50:00',1.86),('5819','2013-04-25','13:55:00',1.95),('5819','2013-04-25','14:00:00',2.1),('5819','2013-04-25','14:05:00',1.9),('5819','2013-04-25','14:10:00',2.06),('5819','2013-04-25','14:15:00',2.18),('5819','2013-04-25','14:20:00',2.24),('5819','2013-04-25','14:25:00',2.26),('5819','2013-04-25','14:30:00',2.64),('5819','2013-04-25','14:35:00',3.16),('5819','2013-04-25','14:40:00',3.04),('5819','2013-04-25','14:45:00',3.08),('5819','2013-04-25','14:50:00',2.77),('5819','2013-04-25','14:55:00',2.9),('5819','2013-04-25','15:00:00',2.75),('5819','2013-04-25','15:05:00',2.54),('5819','2013-04-25','15:10:00',2.41),('5819','2013-04-25','15:15:00',2.75),('5819','2013-04-25','15:20:00',2.92),('5819','2013-04-25','15:25:00',2.96),('5819','2013-04-25','15:30:00',2.92),('5819','2013-04-25','15:35:00',2.74),('5819','2013-04-25','15:40:00',2.59),('5819','2013-04-25','15:45:00',2.4),('5819','2013-04-25','15:50:00',2.28),('5819','2013-04-25','15:55:00',2.19),('5819','2013-04-25','16:00:00',2.23),('5819','2013-04-25','16:05:00',1.89),('5819','2013-04-25','16:10:00',1.89),('5819','2013-04-25','16:15:00',1.84),('5819','2013-04-25','16:20:00',1.89),('5819','2013-04-25','16:25:00',1.75),('5819','2013-04-25','16:30:00',1.59),('5819','2013-04-25','16:35:00',1.97),('5819','2013-04-25','16:40:00',1.67),('5819','2013-04-25','16:45:00',1.79),('5819','2013-04-25','16:50:00',1.52),('5819','2013-04-25','16:55:00',1.55),('5819','2013-04-25','17:00:00',1.49),('5819','2013-04-25','17:05:00',1.69),('5819','2013-04-25','17:10:00',1.85),('5819','2013-04-25','17:15:00',1.68),('5819','2013-04-25','17:20:00',1.63),('5819','2013-04-25','17:25:00',1.39),('5819','2013-04-25','17:30:00',1.16),('5819','2013-04-25','17:35:00',1.03),('5819','2013-04-25','17:40:00',1.01),('5819','2013-04-24','07:50:00',1.12),('5819','2013-04-24','07:55:00',1.23),('5819','2013-04-24','08:00:00',1.34),('5819','2013-04-24','08:05:00',1.37),('5819','2013-04-24','08:10:00',1.49),('5819','2013-04-24','08:15:00',1.7),('5819','2013-04-24','08:20:00',1.78),('5819','2013-04-24','08:25:00',1.92),('5819','2013-04-24','08:30:00',1.94),('5819','2013-04-24','08:35:00',1.83),('5819','2013-04-24','08:40:00',1.89),('5819','2013-04-24','08:45:00',1.94),('5819','2013-04-24','08:50:00',2.01),('5819','2013-04-24','08:55:00',2.15),('5819','2013-04-24','09:00:00',2.32),('5819','2013-04-24','09:05:00',2.56),('5819','2013-04-24','09:10:00',2.55),('5819','2013-04-24','09:15:00',2.41),('5819','2013-04-24','09:20:00',2.02),('5819','2013-04-24','09:25:00',2.28),('5819','2013-04-24','09:30:00',2.85),('5819','2013-04-24','09:35:00',2.88),('5819','2013-04-24','09:40:00',2.71),('5819','2013-04-24','09:45:00',2.71),('5819','2013-04-24','09:50:00',2.84),('5819','2013-04-24','09:55:00',3.28),('5819','2013-04-24','10:00:00',3.26),('5819','2013-04-24','10:05:00',3.33),('5819','2013-04-24','10:10:00',3.33),('5819','2013-04-24','10:15:00',3.33),('5819','2013-04-24','10:20:00',3.31),('5819','2013-04-24','10:25:00',3.29),('5819','2013-04-24','10:30:00',3.25),('5819','2013-04-24','10:35:00',3.19),('5819','2013-04-24','10:40:00',3.49),('5819','2013-04-24','10:45:00',3.63),('5819','2013-04-24','10:50:00',3.62),('5819','2013-04-24','10:55:00',3.7),('5819','2013-04-24','11:00:00',3.75),('5819','2013-04-24','11:05:00',3.63),('5819','2013-04-24','11:10:00',3.84),('5819','2013-04-24','11:15:00',3.95),('5819','2013-04-24','11:20:00',4.01),('5819','2013-04-24','11:25:00',4.13),('5819','2013-04-24','11:30:00',3.94),('5819','2013-04-24','11:35:00',3.3),('5819','2013-04-24','11:40:00',2.29),('5819','2013-04-24','11:45:00',2.64),('5819','2013-04-24','11:50:00',1.92),('5819','2013-04-24','11:55:00',2.48),('5819','2013-04-24','12:00:00',3.21),('5819','2013-04-24','12:05:00',2.26),('5819','2013-04-24','12:10:00',2.69),('5819','2013-04-24','12:15:00',3.57),('5819','2013-04-24','12:20:00',4.32),('5819','2013-04-24','12:25:00',3.69),('5819','2013-04-24','12:30:00',3.61),('5819','2013-04-24','12:35:00',3.64),('5819','2013-04-24','12:40:00',3.39),('5819','2013-04-24','12:45:00',3.63),('5819','2013-04-24','12:50:00',3.87),('5819','2013-04-24','12:55:00',3.67),('5819','2013-04-24','13:00:00',3.47),('5819','2013-04-24','13:05:00',3.06),('5819','2013-04-24','13:10:00',4.08),('5819','2013-04-24','13:15:00',3.52),('5819','2013-04-24','13:20:00',3.53),('5819','2013-04-24','13:25:00',3.48),('5819','2013-04-24','13:30:00',3.31),('5819','2013-04-24','13:35:00',3.15),('5819','2013-04-24','13:40:00',3.94),('5819','2013-04-24','13:45:00',3.21),('5819','2013-04-24','13:50:00',2.35),('5819','2013-04-24','13:55:00',3.61),('5819','2013-04-24','14:00:00',3.61),('5819','2013-04-24','14:05:00',2.59),('5819','2013-04-24','14:10:00',2.47),('5819','2013-04-24','14:15:00',3.67),('5819','2013-04-24','14:20:00',3.18),('5819','2013-04-24','14:25:00',3.41),('5819','2013-04-24','14:30:00',3.25),('5819','2013-04-24','14:35:00',2.79),('5819','2013-04-24','14:40:00',2.61),('5819','2013-04-24','14:45:00',2.6),('5819','2013-04-24','14:50:00',2.27),('5819','2013-04-24','14:55:00',2.06),('5819','2013-04-24','15:00:00',2.28),('5819','2013-04-24','15:05:00',2.11),('5819','2013-04-24','15:10:00',1.97),('5819','2013-04-24','15:15:00',2.09),('5819','2013-04-24','15:20:00',2.17),('5819','2013-04-24','15:25:00',1.86),('5819','2013-04-24','15:30:00',1.61),('5819','2013-04-24','15:35:00',1.54),('5819','2013-04-24','15:40:00',1.52),('5819','2013-04-24','15:45:00',1.53),('5819','2013-04-24','15:50:00',1.56),('5819','2013-04-24','15:55:00',1.84),('5819','2013-04-24','16:00:00',2.21),('5819','2013-04-24','16:05:00',2.31),('5819','2013-04-24','16:10:00',2.3),('5819','2013-04-24','16:15:00',2.21),('5819','2013-04-24','16:20:00',2.89),('5819','2013-04-24','16:25:00',2.15),('5819','2013-04-24','16:30:00',1.84),('5819','2013-04-24','16:35:00',1.47),('5819','2013-04-24','16:40:00',1.99),('5819','2013-04-24','16:45:00',2.07),('5819','2013-04-24','16:50:00',1.85),('5819','2013-04-24','16:55:00',2.12),('5819','2013-04-24','17:00:00',2.11),('5819','2013-04-24','17:05:00',1.95),('5819','2013-04-24','17:10:00',1.86),('5819','2013-04-24','17:15:00',1.43),('5819','2013-04-24','17:20:00',1.27),('5819','2013-04-24','17:25:00',1.24),('5819','2013-04-23','07:35:00',1.09),('5819','2013-04-23','07:40:00',1.19),('5819','2013-04-23','07:45:00',1.28),('5819','2013-04-23','07:50:00',1.36),('5819','2013-04-23','07:55:00',1.45),('5819','2013-04-23','08:00:00',1.54),('5819','2013-04-23','08:05:00',1.65),('5819','2013-04-23','08:10:00',1.73),('5819','2013-04-23','08:15:00',1.82),('5819','2013-04-23','08:20:00',1.91),('5819','2013-04-23','08:25:00',1.99),('5819','2013-04-23','08:30:00',2.07),('5819','2013-04-23','08:35:00',2.16),('5819','2013-04-23','08:40:00',2.24),('5819','2013-04-23','08:45:00',2.33),('5819','2013-04-23','08:50:00',2.42),('5819','2013-04-23','08:55:00',2.48),('5819','2013-04-23','09:00:00',2.55),('5819','2013-04-23','09:05:00',2.62),('5819','2013-04-23','09:10:00',2.7),('5819','2013-04-23','09:15:00',2.79),('5819','2013-04-23','09:20:00',2.87),('5819','2013-04-23','09:25:00',2.93),('5819','2013-04-23','09:30:00',2.98),('5819','2013-04-23','09:35:00',3.05),('5819','2013-04-23','09:40:00',2.91),('5819','2013-04-23','09:45:00',2.69),('5819','2013-04-23','09:50:00',3.25),('5819','2013-04-23','09:55:00',3.3),('5819','2013-04-23','10:00:00',3.32),('5819','2013-04-23','10:05:00',3.38),('5819','2013-04-23','10:10:00',3.41),('5819','2013-04-23','10:15:00',3.46),('5819','2013-04-23','10:20:00',3.52),('5819','2013-04-23','10:25:00',3.55),('5819','2013-04-23','10:30:00',3.58),('5819','2013-04-23','10:35:00',3.62),('5819','2013-04-23','10:40:00',3.6),('5819','2013-04-23','10:45:00',3.56),('5819','2013-04-23','10:50:00',3.62),('5819','2013-04-23','10:55:00',3.72),('5819','2013-04-23','11:00:00',3.77),('5819','2013-04-23','11:05:00',3.8),('5819','2013-04-23','11:10:00',3.82),('5819','2013-04-23','11:15:00',3.84),('5819','2013-04-23','11:20:00',3.87),('5819','2013-04-23','11:25:00',3.91),('5819','2013-04-23','11:30:00',3.91),('5819','2013-04-23','11:35:00',3.9),('5819','2013-04-23','11:40:00',3.89),('5819','2013-04-23','11:45:00',3.92),('5819','2013-04-23','11:50:00',3.93),('5819','2013-04-23','11:55:00',3.93),('5819','2013-04-23','12:00:00',3.93),('5819','2013-04-23','12:05:00',3.91),('5819','2013-04-23','12:10:00',3.91),('5819','2013-04-23','12:15:00',3.92),('5819','2013-04-23','12:20:00',3.89),('5819','2013-04-23','12:25:00',3.89),('5819','2013-04-23','12:30:00',2.19),('5819','2013-04-23','12:35:00',1.54),('5819','2013-04-23','12:40:00',2.63),('5819','2013-04-23','12:45:00',1.58),('5819','2013-04-23','12:50:00',3.5),('5819','2013-04-23','12:55:00',2.14),('5819','2013-04-23','13:00:00',2.39),('5819','2013-04-23','13:05:00',3.35),('5819','2013-04-23','13:10:00',1.52),('5819','2013-04-23','13:15:00',3.53),('5819','2013-04-23','13:20:00',3.84),('5819','2013-04-23','13:25:00',4.12),('5819','2013-04-23','13:30:00',3.9),('5819','2013-04-23','13:35:00',3.95),('5819','2013-04-23','13:40:00',4.07),('5819','2013-04-23','13:45:00',2.9),('5819','2013-04-23','13:50:00',3.46),('5819','2013-04-23','13:55:00',3.92),('5819','2013-04-23','14:00:00',2.69),('5819','2013-04-23','14:05:00',3.46),('5819','2013-04-23','14:10:00',2.8),('5819','2013-04-23','14:15:00',3.42),('5819','2013-04-23','14:20:00',3.53),('5819','2013-04-23','14:25:00',3.22),('5819','2013-04-23','14:30:00',3.69),('5819','2013-04-23','14:35:00',3.68),('5819','2013-04-23','14:40:00',3.61),('5819','2013-04-23','14:45:00',3.11),('5819','2013-04-23','14:50:00',2.04),('5819','2013-04-23','14:55:00',2.14),('5819','2013-04-23','15:00:00',2.16),('5819','2013-04-23','15:05:00',2.19),('5819','2013-04-23','15:10:00',2.53),('5819','2013-04-23','15:15:00',2.69),('5819','2013-04-23','15:20:00',2.47),('5819','2013-04-23','15:25:00',2.26),('5819','2013-04-23','15:30:00',2.22),('5819','2013-04-23','15:35:00',2.23),('5819','2013-04-23','15:40:00',1.88),('5819','2013-04-23','15:45:00',2.17),('5819','2013-04-23','15:50:00',1.69),('5819','2013-04-23','15:55:00',1.44),('5819','2013-04-23','16:00:00',1.46),('5819','2013-04-23','16:05:00',1.52),('5819','2013-04-23','16:10:00',1.45),('5819','2013-04-23','16:15:00',1.54),('5819','2013-04-23','16:20:00',1.17),('5819','2013-04-23','16:25:00',1.17),('5819','2013-04-23','16:30:00',1.07),('5819','2013-04-23','16:35:00',1.06),('5819','2013-04-23','16:40:00',1.01),('5819','2013-04-23','16:45:00',1.12),('5819','2013-04-23','17:10:00',1.26),('5819','2013-04-23','17:15:00',1.5),('5819','2013-04-23','17:20:00',1.43),('5819','2013-04-23','17:25:00',1.22),('5819','2013-04-23','17:30:00',1.14),('5819','2013-04-23','17:40:00',1.02),('5819','2013-04-23','17:45:00',1.17),('5819','2013-04-22','09:30:00',1.04),('5819','2013-04-22','10:35:00',1.9),('5819','2013-04-22','10:40:00',3.47),('5819','2013-04-22','10:45:00',4.75),('5819','2013-04-22','10:50:00',2.32),('5819','2013-04-22','10:55:00',2.03),('5819','2013-04-22','11:00:00',1.91),('5819','2013-04-22','11:05:00',1.87),('5819','2013-04-22','11:10:00',2.27),('5819','2013-04-22','11:15:00',1.43),('5819','2013-04-22','11:20:00',1.36),('5819','2013-04-22','11:25:00',1.78),('5819','2013-04-22','11:30:00',2.84),('5819','2013-04-22','11:35:00',3.51),('5819','2013-04-22','11:40:00',3.83),('5819','2013-04-22','11:45:00',2.07),('5819','2013-04-22','11:50:00',1.67),('5819','2013-04-22','11:55:00',3.59),('5819','2013-04-22','12:00:00',3.12),('5819','2013-04-22','12:05:00',3.24),('5819','2013-04-22','12:10:00',3.77),('5819','2013-04-22','12:15:00',3.13),('5819','2013-04-22','12:20:00',3.37),('5819','2013-04-22','12:25:00',3.05),('5819','2013-04-22','12:30:00',2.21),('5819','2013-04-22','12:35:00',2.2),('5819','2013-04-22','12:40:00',4.05),('5819','2013-04-22','12:45:00',3.73),('5819','2013-04-22','12:50:00',4.31),('5819','2013-04-22','12:55:00',4.27),('5819','2013-04-22','13:00:00',4.25),('5819','2013-04-22','13:05:00',3.97),('5819','2013-04-22','13:10:00',3.58),('5819','2013-04-22','13:15:00',4.03),('5819','2013-04-22','13:20:00',4.01),('5819','2013-04-22','13:25:00',2.12),('5819','2013-04-22','13:30:00',3.62),('5819','2013-04-22','13:35:00',2.58),('5819','2013-04-22','13:40:00',2),('5819','2013-04-22','13:45:00',4.12),('5819','2013-04-22','13:50:00',1.07),('5819','2013-04-22','13:55:00',2.43),('5819','2013-04-22','14:00:00',1.35),('5819','2013-04-22','14:05:00',1.27),('5819','2013-04-22','14:10:00',2.01),('5819','2013-04-22','14:15:00',1.21),('5819','2013-04-22','14:20:00',3.06),('5819','2013-04-22','14:25:00',2.67),('5819','2013-04-22','14:30:00',3.86),('5819','2013-04-22','14:35:00',2.97),('5819','2013-04-22','14:40:00',3.95),('5819','2013-04-22','14:45:00',4.01),('5819','2013-04-22','14:50:00',3.96),('5819','2013-04-22','14:55:00',3.99),('5819','2013-04-22','15:00:00',2.56),('5819','2013-04-22','15:05:00',2.43),('5819','2013-04-22','15:10:00',2.15),('5819','2013-04-22','15:25:00',1.62),('5819','2013-04-22','15:30:00',1.69),('5819','2013-04-22','15:40:00',1.24),('5819','2013-04-22','15:45:00',2.68),('5819','2013-04-22','15:50:00',2.62),('5819','2013-04-22','15:55:00',1.44),('5819','2013-04-22','16:45:00',1.54),('5819','2013-04-21','08:15:00',1.05),('5819','2013-04-21','08:25:00',1.01),('5819','2013-04-21','08:35:00',1.22),('5819','2013-04-21','08:40:00',1.38),('5819','2013-04-21','08:45:00',1.59),('5819','2013-04-21','08:50:00',2.7),('5819','2013-04-21','08:55:00',2.68),('5819','2013-04-21','09:00:00',1.76),('5819','2013-04-21','09:05:00',1.89),('5819','2013-04-21','09:10:00',2.28),('5819','2013-04-21','09:15:00',2.7),('5819','2013-04-21','09:20:00',1.88),('5819','2013-04-21','09:25:00',2.09),('5819','2013-04-21','09:30:00',3.07),('5819','2013-04-21','09:35:00',3.09),('5819','2013-04-21','09:40:00',3.16),('5819','2013-04-21','09:45:00',3.2),('5819','2013-04-21','09:50:00',3.73),('5819','2013-04-21','09:55:00',3.43),('5819','2013-04-21','10:00:00',3.01),('5819','2013-04-21','10:05:00',2.36),('5819','2013-04-21','10:10:00',2.07),('5819','2013-04-21','10:15:00',1.83),('5819','2013-04-21','10:20:00',2.98),('5819','2013-04-21','10:25:00',3.59),('5819','2013-04-21','10:30:00',2.99),('5819','2013-04-21','10:35:00',2.07),('5819','2013-04-21','10:40:00',2.6),('5819','2013-04-21','10:45:00',2.47),('5819','2013-04-21','10:50:00',3.9),('5819','2013-04-21','10:55:00',3.27),('5819','2013-04-21','11:00:00',3.84),('5819','2013-04-21','11:05:00',3.35),('5819','2013-04-21','11:10:00',3.75),('5819','2013-04-21','11:15:00',3.01),('5819','2013-04-21','11:20:00',2.85),('5819','2013-04-21','11:25:00',3.08),('5819','2013-04-21','11:30:00',2.88),('5819','2013-04-21','11:35:00',2.55),('5819','2013-04-21','11:40:00',3.22),('5819','2013-04-21','11:45:00',3.4),('5819','2013-04-21','11:50:00',2.99),('5819','2013-04-21','11:55:00',2.79),('5819','2013-04-21','12:00:00',2.42),('5819','2013-04-21','12:05:00',2.33),('5819','2013-04-21','12:10:00',2.34),('5819','2013-04-21','12:15:00',2.1),('5819','2013-04-21','12:20:00',1.93),('5819','2013-04-21','12:25:00',1.8),('5819','2013-04-21','12:30:00',1.97),('5819','2013-04-21','12:35:00',2.05),('5819','2013-04-21','12:40:00',2.05),('5819','2013-04-21','12:45:00',2.08),('5819','2013-04-21','12:50:00',1.92),('5819','2013-04-21','12:55:00',1.87),('5819','2013-04-21','13:00:00',2.09),('5819','2013-04-21','13:05:00',2.49),('5819','2013-04-21','13:10:00',2.61),('5819','2013-04-21','13:15:00',2.36),('5819','2013-04-21','13:20:00',2.23),('5819','2013-04-21','13:25:00',2.08),('5819','2013-04-21','13:30:00',3.04),('5819','2013-04-21','13:35:00',3.87),('5819','2013-04-21','13:40:00',2.58),('5819','2013-04-21','13:45:00',2.72),('5819','2013-04-21','13:50:00',2.45),('5819','2013-04-21','13:55:00',3.46),('5819','2013-04-21','14:00:00',4.23),('5819','2013-04-21','14:05:00',3.39),('5819','2013-04-21','14:10:00',3.61),('5819','2013-04-21','14:15:00',3.13),('5819','2013-04-21','14:20:00',4.15),('5819','2013-04-21','14:25:00',3.3),('5819','2013-04-21','14:30:00',3.55),('5819','2013-04-21','14:35:00',3.51),('5819','2013-04-21','14:40:00',3.95),('5819','2013-04-21','14:45:00',3.44),('5819','2013-04-21','14:50:00',1.95),('5819','2013-04-21','14:55:00',1.8),('5819','2013-04-21','15:00:00',2.43),('5819','2013-04-21','15:05:00',3.48),('5819','2013-04-21','15:10:00',3.63),('5819','2013-04-21','15:15:00',2.81),('5819','2013-04-21','15:20:00',1.87),('5819','2013-04-21','15:25:00',1.79),('5819','2013-04-21','15:30:00',1.6),('5819','2013-04-21','15:35:00',1.34),('5819','2013-04-21','15:40:00',1.4),('5819','2013-04-21','15:45:00',1.2),('5819','2013-04-21','15:50:00',1),('5819','2013-04-20','07:40:00',1.03),('5819','2013-04-20','07:55:00',1.02),('5819','2013-04-20','08:00:00',1.17),('5819','2013-04-20','08:05:00',1.31),('5819','2013-04-20','08:10:00',1.49),('5819','2013-04-20','08:15:00',1.38),('5819','2013-04-20','08:20:00',1.28),('5819','2013-04-20','08:25:00',1.46),('5819','2013-04-20','08:30:00',1.65),('5819','2013-04-20','08:35:00',1.82),('5819','2013-04-20','08:40:00',1.96),('5819','2013-04-20','08:45:00',2.03),('5819','2013-04-20','08:50:00',2.07),('5819','2013-04-20','08:55:00',2.05),('5819','2013-04-20','09:00:00',2.32),('5819','2013-04-20','09:05:00',2.42),('5819','2013-04-20','09:10:00',2.33),('5819','2013-04-20','09:15:00',2.21),('5819','2013-04-20','09:20:00',2.71),('5819','2013-04-20','09:25:00',2.51),('5819','2013-04-20','09:30:00',2.26),('5819','2013-04-20','09:35:00',1.8),('5819','2013-04-20','09:40:00',1.09),('5819','2013-04-20','09:45:00',1.32),('5819','2013-04-20','09:50:00',1.33),('5819','2013-04-20','10:40:00',1.01),('5819','2013-04-20','10:45:00',1.58),('5819','2013-04-20','10:50:00',2.41),('5819','2013-04-20','10:55:00',2.2),('5819','2013-04-20','11:00:00',2.88),('5819','2013-04-20','11:05:00',2.75),('5819','2013-04-20','11:10:00',1.48),('5819','2013-04-20','11:15:00',3.86),('5819','2013-04-20','11:20:00',3.44),('5819','2013-04-20','11:25:00',1.69),('5819','2013-04-20','11:30:00',4.38),('5819','2013-04-20','11:35:00',3.82),('5819','2013-04-20','11:40:00',1.81),('5819','2013-04-20','11:45:00',2.75),('5819','2013-04-20','11:50:00',2.57),('5819','2013-04-20','11:55:00',3.88),('5819','2013-04-20','12:00:00',4.32),('5819','2013-04-20','12:05:00',2.46),('5819','2013-04-20','12:10:00',3.94),('5819','2013-04-20','12:15:00',4.22),('5819','2013-04-20','12:20:00',2.41),('5819','2013-04-20','12:25:00',3.43),('5819','2013-04-20','12:30:00',2.05),('5819','2013-04-20','12:35:00',4.18),('5819','2013-04-20','12:40:00',1.96),('5819','2013-04-20','12:45:00',4.15),('5819','2013-04-20','12:50:00',4.31),('5819','2013-04-20','12:55:00',4.29),('5819','2013-04-20','13:00:00',1.58),('5819','2013-04-20','13:05:00',2.26),('5819','2013-04-20','13:10:00',4.18),('5819','2013-04-20','13:15:00',4.02),('5819','2013-04-20','13:20:00',1.75),('5819','2013-04-20','13:25:00',3.18),('5819','2013-04-20','13:30:00',2.96),('5819','2013-04-20','13:35:00',1.74),('5819','2013-04-20','13:40:00',4.12),('5819','2013-04-20','13:45:00',2.09),('5819','2013-04-20','13:50:00',2.05),('5819','2013-04-20','13:55:00',2.83),('5819','2013-04-20','14:00:00',2.57),('5819','2013-04-20','14:05:00',3.63),('5819','2013-04-20','14:10:00',4.08),('5819','2013-04-20','14:15:00',3.5),('5819','2013-04-20','14:20:00',3.61),('5819','2013-04-20','14:25:00',3.64),('5819','2013-04-20','14:30:00',3.57),('5819','2013-04-20','14:35:00',3.47),('5819','2013-04-20','14:40:00',3.45),('5819','2013-04-20','14:45:00',3.43),('5819','2013-04-20','14:50:00',3.47),('5819','2013-04-20','14:55:00',3.44),('5819','2013-04-20','15:00:00',3.41),('5819','2013-04-20','15:05:00',3.34),('5819','2013-04-20','15:10:00',2.41),('5819','2013-04-20','15:15:00',2.34),('5819','2013-04-20','15:20:00',2.09),('5819','2013-04-20','15:25:00',2.86),('5819','2013-04-20','15:30:00',1.97),('5819','2013-04-20','16:10:00',1.14),('5819','2013-04-20','16:15:00',1.86),('5819','2013-04-20','16:20:00',1.92),('5819','2013-04-20','16:25:00',2.04),('5819','2013-04-20','16:30:00',2.47),('5819','2013-04-20','16:35:00',2.44),('5819','2013-04-20','16:40:00',2.14),('5819','2013-04-20','16:45:00',2.12),('5819','2013-04-20','16:50:00',2.14),('5819','2013-04-20','16:55:00',2.01),('5819','2013-04-20','17:00:00',1.88),('5819','2013-04-20','17:05:00',1.78),('5819','2013-04-20','17:10:00',1.69),('5819','2013-04-20','17:15:00',1.57),('5819','2013-04-20','17:20:00',1.28),('5819','2013-04-20','17:25:00',1.48),('5819','2013-04-20','17:30:00',1.4),('5819','2013-04-20','17:35:00',1.3),('5819','2013-04-20','17:40:00',1.33),('5819','2013-04-20','17:55:00',1.1),('5819','2013-04-19','08:05:00',1.37),('5819','2013-04-19','08:15:00',1.24),('5819','2013-04-19','08:20:00',1.57),('5819','2013-04-19','08:25:00',1.73),('5819','2013-04-19','08:30:00',1.62),('5819','2013-04-19','08:35:00',1.68),('5819','2013-04-19','08:40:00',1.96),('5819','2013-04-19','08:45:00',2.03),('5819','2013-04-19','08:50:00',2.11),('5819','2013-04-19','08:55:00',2.21),('5819','2013-04-19','09:00:00',2.26),('5819','2013-04-19','09:05:00',2.28),('5819','2013-04-19','09:10:00',2.39),('5819','2013-04-19','09:15:00',2.45),('5819','2013-04-19','09:20:00',2.54),('5819','2013-04-19','09:25:00',2.57),('5819','2013-04-19','09:30:00',2.67),('5819','2013-04-19','09:35:00',2.74),('5819','2013-04-19','09:40:00',2.8),('5819','2013-04-19','09:45:00',2.84),('5819','2013-04-19','09:50:00',2.86),('5819','2013-04-19','09:55:00',2.9),('5819','2013-04-19','10:00:00',2.98),('5819','2013-04-19','10:05:00',3.02),('5819','2013-04-19','10:10:00',3.06),('5819','2013-04-19','10:15:00',3.17),('5819','2013-04-19','10:20:00',2.47),('5819','2013-04-19','10:25:00',3.06),('5819','2013-04-19','10:30:00',2.87),('5819','2013-04-19','10:35:00',2.99),('5819','2013-04-19','10:40:00',3.34),('5819','2013-04-19','10:45:00',3.32),('5819','2013-04-19','10:50:00',3.38),('5819','2013-04-19','10:55:00',3.37),('5819','2013-04-19','11:00:00',3.4),('5819','2013-04-19','11:05:00',3.42),('5819','2013-04-19','11:10:00',3.44),('5819','2013-04-19','11:15:00',3.47),('5819','2013-04-19','11:20:00',3.46),('5819','2013-04-19','11:25:00',3.49),('5819','2013-04-19','11:30:00',3.53),('5819','2013-04-19','11:35:00',3.58),('5819','2013-04-19','11:40:00',3.59),('5819','2013-04-19','11:45:00',3.63),('5819','2013-04-19','11:50:00',3.64),('5819','2013-04-19','11:55:00',3.64),('5819','2013-04-19','12:00:00',3.65),('5819','2013-04-19','12:05:00',3.66),('5819','2013-04-19','12:10:00',3.67),('5819','2013-04-19','12:15:00',3.69),('5819','2013-04-19','12:20:00',3.68),('5819','2013-04-19','12:25:00',3.7),('5819','2013-04-19','12:30:00',3.63),('5819','2013-04-19','12:35:00',3.59),('5819','2013-04-19','12:40:00',3.67),('5819','2013-04-19','12:45:00',3.68),('5819','2013-04-19','12:50:00',3.7),('5819','2013-04-19','12:55:00',3.63),('5819','2013-04-19','13:00:00',3.68),('5819','2013-04-19','13:05:00',3.66),('5819','2013-04-19','13:10:00',3.65),('5819','2013-04-19','13:15:00',3.68),('5819','2013-04-19','13:20:00',3.63),('5819','2013-04-19','13:25:00',3.64),('5819','2013-04-19','13:30:00',3.7),('5819','2013-04-19','13:35:00',3.6),('5819','2013-04-19','13:40:00',3.59),('5819','2013-04-19','13:45:00',3.56),('5819','2013-04-19','13:50:00',3.53),('5819','2013-04-19','13:55:00',3.46),('5819','2013-04-19','14:00:00',3.47),('5819','2013-04-19','14:05:00',3.43),('5819','2013-04-19','14:10:00',3.43),('5819','2013-04-19','14:15:00',3.38),('5819','2013-04-19','14:20:00',3.32),('5819','2013-04-19','14:25:00',3.27),('5819','2013-04-19','14:30:00',3.3),('5819','2013-04-19','14:35:00',3.22),('5819','2013-04-19','14:40:00',3.2),('5819','2013-04-19','14:45:00',3.16),('5819','2013-04-19','14:50:00',3.18),('5819','2013-04-19','14:55:00',3.17),('5819','2013-04-19','15:00:00',3.1),('5819','2013-04-19','15:05:00',3.07),('5819','2013-04-19','15:10:00',2.99),('5819','2013-04-19','15:15:00',2.94),('5819','2013-04-19','15:20:00',2.86),('5819','2013-04-19','15:25:00',2.83),('5819','2013-04-19','15:30:00',2.76),('5819','2013-04-19','15:35:00',2.7),('5819','2013-04-19','15:40:00',2.67),('5819','2013-04-19','15:45:00',2.62),('5819','2013-04-19','15:50:00',2.56),('5819','2013-04-19','15:55:00',2.51),('5819','2013-04-19','16:00:00',2.44),('5819','2013-04-19','16:05:00',2.38),('5819','2013-04-19','16:10:00',2.3),('5819','2013-04-19','16:15:00',2.2),('5819','2013-04-19','16:20:00',2.15),('5819','2013-04-19','16:25:00',2.11),('5819','2013-04-19','16:30:00',2.03),('5819','2013-04-19','16:35:00',1.95),('5819','2013-04-19','16:40:00',1.88),('5819','2013-04-19','16:45:00',1.8),('5819','2013-04-19','16:50:00',1.73),('5819','2013-04-19','16:55:00',1.65),('5819','2013-04-19','17:00:00',1.57),('5819','2013-04-19','17:05:00',1.49),('5819','2013-04-19','17:10:00',1.4),('5819','2013-04-19','17:15:00',1.33),('5819','2013-04-19','17:20:00',1.26),('5819','2013-04-19','17:25:00',1.19),('5819','2013-04-19','17:30:00',1.06),('5819','2013-04-18','08:10:00',1.17),('5819','2013-04-18','08:15:00',1.32),('5819','2013-04-18','08:20:00',1.33),('5819','2013-04-18','08:25:00',1.33),('5819','2013-04-18','08:30:00',1.53),('5819','2013-04-18','08:35:00',1.59),('5819','2013-04-18','08:40:00',1.53),('5819','2013-04-18','08:45:00',1.59),('5819','2013-04-18','08:50:00',1.76),('5819','2013-04-18','08:55:00',2.01),('5819','2013-04-18','09:00:00',1.87),('5819','2013-04-18','09:05:00',2.2),('5819','2013-04-18','09:10:00',2.19),('5819','2013-04-18','09:15:00',2.23),('5819','2013-04-18','09:20:00',2.42),('5819','2013-04-18','09:25:00',2.49),('5819','2013-04-18','09:30:00',2.58),('5819','2013-04-18','09:35:00',2.71),('5819','2013-04-18','09:40:00',3.07),('5819','2013-04-18','09:45:00',2.71),('5819','2013-04-18','09:50:00',2.37),('5819','2013-04-18','09:55:00',2.47),('5819','2013-04-18','10:00:00',2.93),('5819','2013-04-18','10:05:00',3.16),('5819','2013-04-18','10:10:00',3.21),('5819','2013-04-18','10:15:00',3.32),('5819','2013-04-18','10:20:00',3.36),('5819','2013-04-18','10:25:00',3.33),('5819','2013-04-18','10:30:00',3.4),('5819','2013-04-18','10:35:00',3.43),('5819','2013-04-18','10:40:00',3.45),('5819','2013-04-18','10:45:00',3.47),('5819','2013-04-18','10:50:00',3.51),('5819','2013-04-18','10:55:00',3.54),('5819','2013-04-18','11:00:00',3.57),('5819','2013-04-18','11:05:00',3.59),('5819','2013-04-18','11:10:00',3.6),('5819','2013-04-18','11:15:00',3.63),('5819','2013-04-18','11:20:00',3.69),('5819','2013-04-18','11:25:00',3.7),('5819','2013-04-18','11:30:00',3.71),('5819','2013-04-18','11:35:00',3.73),('5819','2013-04-18','11:40:00',3.72),('5819','2013-04-18','11:45:00',3.69),('5819','2013-04-18','11:50:00',3.69),('5819','2013-04-18','11:55:00',3.76),('5819','2013-04-18','12:00:00',3.74),('5819','2013-04-18','12:05:00',3.84),('5819','2013-04-18','12:10:00',3.85),('5819','2013-04-18','12:15:00',3.81),('5819','2013-04-18','12:20:00',3.85),('5819','2013-04-18','12:25:00',3.87),('5819','2013-04-18','12:30:00',3.87),('5819','2013-04-18','12:35:00',3.86),('5819','2013-04-18','12:40:00',3.89),('5819','2013-04-18','12:45:00',3.86),('5819','2013-04-18','12:50:00',3.86),('5819','2013-04-18','12:55:00',3.88),('5819','2013-04-18','13:00:00',3.87),('5819','2013-04-18','13:05:00',3.84),('5819','2013-04-18','13:10:00',3.83),('5819','2013-04-18','13:15:00',3.83),('5819','2013-04-18','13:20:00',3.79),('5819','2013-04-18','13:25:00',3.79),('5819','2013-04-18','13:30:00',3.78),('5819','2013-04-18','13:35:00',3.76),('5819','2013-04-18','13:40:00',3.72),('5819','2013-04-18','13:45:00',3.73),('5819','2013-04-18','13:50:00',3.73),('5819','2013-04-18','13:55:00',3.71),('5819','2013-04-18','14:00:00',3.65),('5819','2013-04-18','14:05:00',3.65),('5819','2013-04-18','14:10:00',3.62),('5819','2013-04-18','14:15:00',3.59),('5819','2013-04-18','14:20:00',3.57),('5819','2013-04-18','14:25:00',3.55),('5819','2013-04-18','14:30:00',3.5),('5819','2013-04-18','14:35:00',3.45),('5819','2013-04-18','14:40:00',3.42),('5819','2013-04-18','14:45:00',3.38),('5819','2013-04-18','14:50:00',3.33),('5819','2013-04-18','14:55:00',3.27),('5819','2013-04-18','15:00:00',3.21),('5819','2013-04-18','15:05:00',3.19),('5819','2013-04-18','15:10:00',3.14),('5819','2013-04-18','15:15:00',3.1),('5819','2013-04-18','15:20:00',3.04),('5819','2013-04-18','15:25:00',2.98),('5819','2013-04-18','15:30:00',2.91),('5819','2013-04-18','15:35:00',2.88),('5819','2013-04-18','15:40:00',2.81),('5819','2013-04-18','15:45:00',2.74),('5819','2013-04-18','15:50:00',2.68),('5819','2013-04-18','15:55:00',2.6),('5819','2013-04-18','16:00:00',2.54),('5819','2013-04-18','16:05:00',2.46),('5819','2013-04-18','16:10:00',2.42),('5819','2013-04-18','16:15:00',2.35),('5819','2013-04-18','16:20:00',2.25),('5819','2013-04-18','16:25:00',2.18),('5819','2013-04-18','16:30:00',2.11),('5819','2013-04-18','16:35:00',2.02),('5819','2013-04-18','16:40:00',1.95),('5819','2013-04-18','16:45:00',1.89),('5819','2013-04-18','16:50:00',1.81),('5819','2013-04-18','16:55:00',1.73),('5819','2013-04-18','17:00:00',1.64),('5819','2013-04-18','17:05:00',1.55),('5819','2013-04-18','17:10:00',1.48),('5819','2013-04-18','17:15:00',1.41),('5819','2013-04-18','17:20:00',1.32),('5819','2013-04-18','17:25:00',1.24),('5819','2013-04-18','17:30:00',1.07),('5819','2013-04-18','17:35:00',1.07),('5819','2013-04-17','07:45:00',1.08),('5819','2013-04-17','07:50:00',1.17),('5819','2013-04-17','07:55:00',1.26),('5819','2013-04-17','08:00:00',1.36),('5819','2013-04-17','08:05:00',1.45),('5819','2013-04-17','08:10:00',1.55),('5819','2013-04-17','08:15:00',1.65),('5819','2013-04-17','08:20:00',1.73),('5819','2013-04-17','08:25:00',1.81),('5819','2013-04-17','08:30:00',1.89),('5819','2013-04-17','08:35:00',1.97),('5819','2013-04-17','08:40:00',2.05),('5819','2013-04-17','08:45:00',2.13),('5819','2013-04-17','08:50:00',2.21),('5819','2013-04-17','08:55:00',2.28),('5819','2013-04-17','09:00:00',2.36),('5819','2013-04-17','09:05:00',2.43),('5819','2013-04-17','09:10:00',2.51),('5819','2013-04-17','09:15:00',2.59),('5819','2013-04-17','09:20:00',2.66),('5819','2013-04-17','09:25:00',2.72),('5819','2013-04-17','09:30:00',2.79),('5819','2013-04-17','09:35:00',2.86),('5819','2013-04-17','09:40:00',2.92),('5819','2013-04-17','09:45:00',2.97),('5819','2013-04-17','09:50:00',3.02),('5819','2013-04-17','09:55:00',3.07),('5819','2013-04-17','10:00:00',3.13),('5819','2013-04-17','10:05:00',3.19),('5819','2013-04-17','10:10:00',3.24),('5819','2013-04-17','10:15:00',3.28),('5819','2013-04-17','10:20:00',3.33),('5819','2013-04-17','10:25:00',3.37),('5819','2013-04-17','10:30:00',3.41),('5819','2013-04-17','10:35:00',3.44),('5819','2013-04-17','10:40:00',3.49),('5819','2013-04-17','10:45:00',3.52),('5819','2013-04-17','10:50:00',3.54),('5819','2013-04-17','10:55:00',3.57),('5819','2013-04-17','11:00:00',3.63),('5819','2013-04-17','11:05:00',3.66),('5819','2013-04-17','11:10:00',3.68),('5819','2013-04-17','11:15:00',3.68),('5819','2013-04-17','11:20:00',3.72),('5819','2013-04-17','11:25:00',3.73),('5819','2013-04-17','11:30:00',3.72),('5819','2013-04-17','11:35:00',3.74),('5819','2013-04-17','11:40:00',3.76),('5819','2013-04-17','11:45:00',3.78),('5819','2013-04-17','11:50:00',3.82),('5819','2013-04-17','11:55:00',3.81),('5819','2013-04-17','12:00:00',3.8),('5819','2013-04-17','12:05:00',3.84),('5819','2013-04-17','12:10:00',3.84),('5819','2013-04-17','12:15:00',3.84),('5819','2013-04-17','12:20:00',3.83),('5819','2013-04-17','12:25:00',3.87),('5819','2013-04-17','12:30:00',3.89),('5819','2013-04-17','12:35:00',3.86),('5819','2013-04-17','12:40:00',3.84),('5819','2013-04-17','12:45:00',3.85),('5819','2013-04-17','12:50:00',3.85),('5819','2013-04-17','12:55:00',3.86),('5819','2013-04-17','13:00:00',3.82),('5819','2013-04-17','13:05:00',3.78),('5819','2013-04-17','13:10:00',3.78),('5819','2013-04-17','13:15:00',3.81),('5819','2013-04-17','13:20:00',3.82),('5819','2013-04-17','13:25:00',3.82),('5819','2013-04-17','13:30:00',3.79),('5819','2013-04-17','13:35:00',3.7),('5819','2013-04-17','13:40:00',3.77),('5819','2013-04-17','13:45:00',3.5),('5819','2013-04-17','13:50:00',3.51),('5819','2013-04-17','13:55:00',3.8),('5819','2013-04-17','14:00:00',3.66),('5819','2013-04-17','14:05:00',3.92),('5819','2013-04-17','14:10:00',3.84),('5819','2013-04-17','14:15:00',3.39),('5819','2013-04-17','14:20:00',3.34),('5819','2013-04-17','14:25:00',3.38),('5819','2013-04-17','14:30:00',3.21),('5819','2013-04-17','14:35:00',3.71),('5819','2013-04-17','14:40:00',3.58),('5819','2013-04-17','14:45:00',2.99),('5819','2013-04-17','14:50:00',3.5),('5819','2013-04-17','14:55:00',3.59),('5819','2013-04-17','15:00:00',3.54),('5819','2013-04-17','15:05:00',3.61),('5819','2013-04-17','15:10:00',3.71),('5819','2013-04-17','15:15:00',3.33),('5819','2013-04-17','15:20:00',1.75),('5819','2013-04-17','15:25:00',1.91),('5819','2013-04-17','15:30:00',2.95),('5819','2013-04-17','15:35:00',3.09),('5819','2013-04-17','15:40:00',3.06),('5819','2013-04-17','15:45:00',3.07),('5819','2013-04-17','15:50:00',3.04),('5819','2013-04-17','15:55:00',3.06),('5819','2013-04-17','16:00:00',2.93),('5819','2013-04-17','16:05:00',2.17),('5819','2013-04-17','16:10:00',2.71),('5819','2013-04-17','16:15:00',2.58),('5819','2013-04-17','16:20:00',2.45),('5819','2013-04-17','16:25:00',2.36),('5819','2013-04-17','16:30:00',2.28),('5819','2013-04-17','16:35:00',2.26),('5819','2013-04-17','16:40:00',2.07),('5819','2013-04-17','16:45:00',2.12),('5819','2013-04-17','16:50:00',1.92),('5819','2013-04-17','16:55:00',1.8),('5819','2013-04-17','17:00:00',1.7),('5819','2013-04-17','17:05:00',1.61),('5819','2013-04-17','17:10:00',1.52),('5819','2013-04-17','17:15:00',1.43),('5819','2013-04-17','17:20:00',1.35),('5819','2013-04-17','17:25:00',1.26),('5819','2013-04-17','17:30:00',1.08),('5819','2013-04-17','17:35:00',1.07),('5819','2013-04-16','07:50:00',1.01),('5819','2013-04-16','07:55:00',1.08),('5819','2013-04-16','08:05:00',1.28),('5819','2013-04-16','08:10:00',1.28),('5819','2013-04-16','08:30:00',1.03),('5819','2013-04-16','08:50:00',1.01),('5819','2013-04-16','08:55:00',1.13),('5819','2013-04-16','09:00:00',1.13),('5819','2013-04-16','09:10:00',1.45),('5819','2013-04-16','09:15:00',1.88),('5819','2013-04-16','09:20:00',1.4),('5819','2013-04-16','09:25:00',1.81),('5819','2013-04-16','09:30:00',1.64),('5819','2013-04-16','09:35:00',1.46),('5819','2013-04-16','09:40:00',1.36),('5819','2013-04-16','09:45:00',1.37),('5819','2013-04-16','09:50:00',1.33),('5819','2013-04-16','09:55:00',1.29),('5819','2013-04-16','10:00:00',1.24),('5819','2013-04-16','10:05:00',1.23),('5819','2013-04-16','10:10:00',1.3),('5819','2013-04-16','10:15:00',1.4),('5819','2013-04-16','10:20:00',1.44),('5819','2013-04-16','10:25:00',1.47),('5819','2013-04-16','10:30:00',1.5),('5819','2013-04-16','10:35:00',1.51),('5819','2013-04-16','10:40:00',1.46),('5819','2013-04-16','10:45:00',1.39),('5819','2013-04-16','10:50:00',1.41),('5819','2013-04-16','10:55:00',1.51),('5819','2013-04-16','11:00:00',1.65),('5819','2013-04-16','11:05:00',1.7),('5819','2013-04-16','11:10:00',1.7),('5819','2013-04-16','11:15:00',1.76),('5819','2013-04-16','11:20:00',1.81),('5819','2013-04-16','11:25:00',1.79),('5819','2013-04-16','11:30:00',1.76),('5819','2013-04-16','11:35:00',1.75),('5819','2013-04-16','11:40:00',1.95),('5819','2013-04-16','11:45:00',2.3),('5819','2013-04-16','11:50:00',2.45),('5819','2013-04-16','11:55:00',2.55),('5819','2013-04-16','12:00:00',2.88),('5819','2013-04-16','12:05:00',3.86),('5819','2013-04-16','12:10:00',3.8),('5819','2013-04-16','12:15:00',4.55),('5819','2013-04-16','12:20:00',3.57),('5819','2013-04-16','12:25:00',3.12),('5819','2013-04-16','12:30:00',3.53),('5819','2013-04-16','12:35:00',3.92),('5819','2013-04-16','12:40:00',3.91),('5819','2013-04-16','12:45:00',3.3),('5819','2013-04-16','12:50:00',2.91),('5819','2013-04-16','12:55:00',3.76),('5819','2013-04-16','13:00:00',3.87),('5819','2013-04-16','13:05:00',3.65),('5819','2013-04-16','13:10:00',3.69),('5819','2013-04-16','13:15:00',3.72),('5819','2013-04-16','13:20:00',3.75),('5819','2013-04-16','13:25:00',3.76),('5819','2013-04-16','13:30:00',3.74),('5819','2013-04-16','13:35:00',3.74),('5819','2013-04-16','13:40:00',3.69),('5819','2013-04-16','13:45:00',3.62),('5819','2013-04-16','13:50:00',3.58),('5819','2013-04-16','13:55:00',3.46),('5819','2013-04-16','14:00:00',3.49),('5819','2013-04-16','14:05:00',3.54),('5819','2013-04-16','14:10:00',3.55),('5819','2013-04-16','14:15:00',3.4),('5819','2013-04-16','14:20:00',3.46),('5819','2013-04-16','14:25:00',2.73),('5819','2013-04-16','14:30:00',2.92),('5819','2013-04-16','14:35:00',2.88),('5819','2013-04-16','14:40:00',3.24),('5819','2013-04-16','14:45:00',3.35),('5819','2013-04-16','14:50:00',3.19),('5819','2013-04-16','14:55:00',3.11),('5819','2013-04-16','15:00:00',3.19),('5819','2013-04-16','15:05:00',3.14),('5819','2013-04-16','15:10:00',3.1),('5819','2013-04-16','15:15:00',3.07),('5819','2013-04-16','15:20:00',3.02),('5819','2013-04-16','15:25:00',2.9),('5819','2013-04-16','15:30:00',2.79),('5819','2013-04-16','15:35:00',2.81),('5819','2013-04-16','15:40:00',2.77),('5819','2013-04-16','15:45:00',2.7),('5819','2013-04-16','15:50:00',2.68),('5819','2013-04-16','15:55:00',2.59),('5819','2013-04-16','16:00:00',2.43),('5819','2013-04-16','16:05:00',2.45),('5819','2013-04-16','16:10:00',2.38),('5819','2013-04-16','16:15:00',2.27),('5819','2013-04-16','16:20:00',2.27),('5819','2013-04-16','16:25:00',2.21),('5819','2013-04-16','16:30:00',2.16),('5819','2013-04-16','16:35:00',2.13),('5819','2013-04-16','16:40:00',2.26),('5819','2013-04-16','16:45:00',2.28),('5819','2013-04-16','16:50:00',2),('5819','2013-04-16','16:55:00',1.7),('5819','2013-04-16','17:00:00',1.78),('5819','2013-04-16','17:05:00',1.8),('5819','2013-04-16','17:10:00',1.79),('5819','2013-04-16','17:15:00',1.69),('5819','2013-04-16','17:20:00',1.61),('5819','2013-04-16','17:25:00',1.57),('5819','2013-04-16','17:30:00',1.45),('5819','2013-04-16','17:35:00',1.32),('5819','2013-04-16','17:40:00',1.36),('5819','2013-04-16','17:45:00',1.24),('5819','2013-04-16','17:50:00',1.11),('5819','2013-04-15','07:40:00',1),('5819','2013-04-15','07:45:00',1.11),('5819','2013-04-15','07:50:00',1.2),('5819','2013-04-15','07:55:00',1.28),('5819','2013-04-15','08:00:00',1.38),('5819','2013-04-15','08:05:00',1.47),('5819','2013-04-15','08:10:00',1.56),('5819','2013-04-15','08:15:00',1.64),('5819','2013-04-15','08:20:00',1.72),('5819','2013-04-15','08:25:00',1.82),('5819','2013-04-15','08:30:00',1.91),('5819','2013-04-15','08:35:00',1.99),('5819','2013-04-15','08:40:00',2.07),('5819','2013-04-15','08:45:00',2.15),('5819','2013-04-15','08:50:00',2.24),('5819','2013-04-15','08:55:00',2.32),('5819','2013-04-15','09:00:00',2.4),('5819','2013-04-15','09:05:00',2.48),('5819','2013-04-15','09:10:00',2.54),('5819','2013-04-15','09:15:00',2.61),('5819','2013-04-15','09:20:00',2.68),('5819','2013-04-15','09:25:00',2.73),('5819','2013-04-15','09:30:00',2.8),('5819','2013-04-15','09:35:00',2.85),('5819','2013-04-15','09:40:00',2.91),('5819','2013-04-15','09:45:00',2.97),('5819','2013-04-15','09:50:00',3.02),('5819','2013-04-15','09:55:00',3.08),('5819','2013-04-15','10:00:00',3.13),('5819','2013-04-15','10:05:00',3.17),('5819','2013-04-15','10:10:00',3.23),('5819','2013-04-15','10:15:00',3.28),('5819','2013-04-15','10:20:00',3.31),('5819','2013-04-15','10:25:00',3.34),('5819','2013-04-15','10:30:00',3.39),('5819','2013-04-15','10:35:00',3.43),('5819','2013-04-15','10:40:00',3.46),('5819','2013-04-15','10:45:00',3.49),('5819','2013-04-15','10:50:00',3.53),('5819','2013-04-15','10:55:00',3.58),('5819','2013-04-15','11:00:00',3.62),('5819','2013-04-15','11:05:00',3.65),('5819','2013-04-15','11:10:00',3.66),('5819','2013-04-15','11:15:00',3.69),('5819','2013-04-15','11:20:00',3.69),('5819','2013-04-15','11:25:00',3.7),('5819','2013-04-15','11:30:00',3.73),('5819','2013-04-15','11:35:00',3.74),('5819','2013-04-15','11:40:00',3.75),('5819','2013-04-15','11:45:00',3.79),('5819','2013-04-15','11:50:00',3.79),('5819','2013-04-15','11:55:00',3.81),('5819','2013-04-15','12:00:00',3.81),('5819','2013-04-15','12:05:00',3.79),('5819','2013-04-15','12:10:00',3.82),('5819','2013-04-15','12:15:00',3.83),('5819','2013-04-15','12:20:00',3.81),('5819','2013-04-15','12:25:00',3.81),('5819','2013-04-15','12:30:00',3.84),('5819','2013-04-15','12:35:00',3.83),('5819','2013-04-15','12:40:00',3.83),('5819','2013-04-15','12:45:00',3.81),('5819','2013-04-15','12:50:00',3.81),('5819','2013-04-15','12:55:00',3.79),('5819','2013-04-15','13:00:00',3.79),('5819','2013-04-15','13:05:00',3.77),('5819','2013-04-15','13:10:00',3.82),('5819','2013-04-15','13:15:00',3.81),('5819','2013-04-15','13:20:00',3.77),('5819','2013-04-15','13:25:00',3.73),('5819','2013-04-15','13:30:00',3.7),('5819','2013-04-15','13:35:00',3.71),('5819','2013-04-15','13:40:00',3.71),('5819','2013-04-15','13:45:00',3.64),('5819','2013-04-15','13:50:00',3.63),('5819','2013-04-15','13:55:00',3.69),('5819','2013-04-15','14:00:00',3.69),('5819','2013-04-15','14:05:00',3.65),('5819','2013-04-15','14:10:00',3.65),('5819','2013-04-15','14:15:00',3.64),('5819','2013-04-15','14:20:00',3.61),('5819','2013-04-15','14:25:00',3.57),('5819','2013-04-15','14:30:00',3.53),('5819','2013-04-15','14:35:00',3.48),('5819','2013-04-15','14:40:00',3.44),('5819','2013-04-15','14:45:00',3.41),('5819','2013-04-15','14:50:00',3.36),('5819','2013-04-15','14:55:00',3.32),('5819','2013-04-15','15:00:00',3.28),('5819','2013-04-15','15:05:00',3.24),('5819','2013-04-15','15:10:00',3.18),('5819','2013-04-15','15:15:00',3.14),('5819','2013-04-15','15:20:00',3.08),('5819','2013-04-15','15:25:00',3.02),('5819','2013-04-15','15:30:00',2.98),('5819','2013-04-15','15:35:00',2.92),('5819','2013-04-15','15:40:00',2.85),('5819','2013-04-15','15:45:00',2.79),('5819','2013-04-15','15:50:00',2.73),('5819','2013-04-15','15:55:00',2.66),('5819','2013-04-15','16:00:00',2.58),('5819','2013-04-15','16:05:00',2.52),('5819','2013-04-15','16:10:00',2.45),('5819','2013-04-15','16:15:00',2.37),('5819','2013-04-15','16:20:00',2.3),('5819','2013-04-15','16:25:00',2.22),('5819','2013-04-15','16:30:00',2.14),('5819','2013-04-15','16:35:00',2.06),('5819','2013-04-15','16:40:00',1.98),('5819','2013-04-15','16:45:00',1.9),('5819','2013-04-15','16:50:00',1.82),('5819','2013-04-15','16:55:00',1.74),('5819','2013-04-15','17:00:00',1.65),('5819','2013-04-15','17:05:00',1.57),('5819','2013-04-15','17:10:00',1.49),('5819','2013-04-15','17:15:00',1.4),('5819','2013-04-15','17:20:00',1.33),('5819','2013-04-15','17:25:00',1.25),('5819','2013-04-15','17:30:00',1.07),('5819','2013-04-15','17:35:00',1.06),('5819','2013-04-14','07:50:00',1.08),('5819','2013-04-14','07:55:00',1.18),('5819','2013-04-14','08:00:00',1.26),('5819','2013-04-14','08:05:00',1.21),('5819','2013-04-14','08:10:00',1.36),('5819','2013-04-14','08:15:00',1.51),('5819','2013-04-14','08:20:00',1.61),('5819','2013-04-14','08:25:00',1.68),('5819','2013-04-14','08:30:00',1.73),('5819','2013-04-14','08:35:00',1.79),('5819','2013-04-14','08:40:00',1.92),('5819','2013-04-14','08:45:00',2.01),('5819','2013-04-14','08:50:00',2.08),('5819','2013-04-14','08:55:00',2.17),('5819','2013-04-14','09:00:00',2.25),('5819','2013-04-14','09:05:00',2.31),('5819','2013-04-14','09:10:00',2.37),('5819','2013-04-14','09:15:00',2.44),('5819','2013-04-14','09:20:00',2.51),('5819','2013-04-14','09:25:00',2.58),('5819','2013-04-14','09:30:00',2.64),('5819','2013-04-14','09:35:00',2.72),('5819','2013-04-14','09:40:00',2.79),('5819','2013-04-14','09:45:00',2.86),('5819','2013-04-14','09:50:00',2.92),('5819','2013-04-14','09:55:00',2.98),('5819','2013-04-14','10:00:00',3.04),('5819','2013-04-14','10:05:00',3.1),('5819','2013-04-14','10:10:00',3.14),('5819','2013-04-14','10:15:00',3.19),('5819','2013-04-14','10:20:00',3.23),('5819','2013-04-14','10:25:00',3.27),('5819','2013-04-14','10:30:00',3.31),('5819','2013-04-14','10:35:00',3.36),('5819','2013-04-14','10:40:00',3.38),('5819','2013-04-14','10:45:00',3.44),('5819','2013-04-14','10:50:00',3.48),('5819','2013-04-14','10:55:00',3.5),('5819','2013-04-14','11:00:00',3.56),('5819','2013-04-14','11:05:00',3.56),('5819','2013-04-14','11:10:00',3.62),('5819','2013-04-14','11:15:00',3.63),('5819','2013-04-14','11:20:00',3.63),('5819','2013-04-14','11:25:00',3.62),('5819','2013-04-14','11:30:00',3.65),('5819','2013-04-14','11:35:00',3.71),('5819','2013-04-14','11:40:00',3.74),('5819','2013-04-14','11:45:00',3.76),('5819','2013-04-14','11:50:00',3.72),('5819','2013-04-14','11:55:00',3.76),('5819','2013-04-14','12:00:00',3.74),('5819','2013-04-14','12:05:00',3.74),('5819','2013-04-14','12:10:00',3.78),('5819','2013-04-14','12:15:00',3.77),('5819','2013-04-14','12:20:00',3.79),('5819','2013-04-14','12:25:00',3.77),('5819','2013-04-14','12:30:00',3.78),('5819','2013-04-14','12:35:00',3.8),('5819','2013-04-14','12:40:00',3.84),('5819','2013-04-14','12:45:00',3.86),('5819','2013-04-14','12:50:00',3.9),('5819','2013-04-14','12:55:00',3.92),('5819','2013-04-14','13:00:00',2.8),('5819','2013-04-14','13:05:00',3.08),('5819','2013-04-14','13:10:00',3.99),('5819','2013-04-14','13:15:00',3.94),('5819','2013-04-14','13:20:00',3.89),('5819','2013-04-14','13:25:00',3.85),('5819','2013-04-14','13:30:00',3.75),('5819','2013-04-14','13:35:00',3.75),('5819','2013-04-14','13:40:00',3.72),('5819','2013-04-14','13:45:00',3.69),('5819','2013-04-14','13:50:00',3.63),('5819','2013-04-14','13:55:00',3.58),('5819','2013-04-14','14:00:00',3.49),('5819','2013-04-14','14:05:00',3.59),('5819','2013-04-14','14:10:00',3.58),('5819','2013-04-14','14:15:00',3.54),('5819','2013-04-14','14:20:00',3.49),('5819','2013-04-14','14:25:00',3.44),('5819','2013-04-14','14:30:00',3.43),('5819','2013-04-14','14:35:00',3.47),('5819','2013-04-14','14:40:00',3.5),('5819','2013-04-14','14:45:00',3.56),('5819','2013-04-14','14:50:00',3.54),('5819','2013-04-14','14:55:00',3.4),('5819','2013-04-14','15:00:00',3.34),('5819','2013-04-14','15:05:00',3.3),('5819','2013-04-14','15:10:00',3.12),('5819','2013-04-14','15:15:00',3.05),('5819','2013-04-14','15:20:00',2.74),('5819','2013-04-14','15:25:00',2.6),('5819','2013-04-14','15:30:00',2.92),('5819','2013-04-14','15:35:00',3.03),('5819','2013-04-14','15:40:00',3.07),('5819','2013-04-14','15:45:00',2.95),('5819','2013-04-14','15:50:00',2.82),('5819','2013-04-14','15:55:00',1.71),('5819','2013-04-14','16:00:00',2.59),('5819','2013-04-14','16:05:00',2.5),('5819','2013-04-14','16:10:00',2.44),('5819','2013-04-14','16:15:00',2.28),('5819','2013-04-14','16:20:00',2.23),('5819','2013-04-14','16:25:00',2.22),('5819','2013-04-14','16:30:00',2.13),('5819','2013-04-14','16:35:00',2.02),('5819','2013-04-14','16:40:00',1.92),('5819','2013-04-14','16:45:00',1.83),('5819','2013-04-14','16:50:00',1.79),('5819','2013-04-14','16:55:00',1.68),('5819','2013-04-14','17:00:00',1.61),('5819','2013-04-14','17:05:00',1.53),('5819','2013-04-14','17:10:00',1.47),('5819','2013-04-14','17:15:00',1.37),('5819','2013-04-14','17:20:00',1.3),('5819','2013-04-14','17:25:00',1.21),('5819','2013-04-14','17:30:00',1.07),('5819','2013-04-13','07:50:00',1.02),('5819','2013-04-13','07:55:00',1.11),('5819','2013-04-13','08:00:00',1.22),('5819','2013-04-13','08:05:00',1.31),('5819','2013-04-13','08:10:00',1.26),('5819','2013-04-13','08:55:00',1.07),('5819','2013-04-13','09:00:00',1.2),('5819','2013-04-13','09:05:00',1.93),('5819','2013-04-13','09:10:00',1.9),('5819','2013-04-13','09:15:00',2.49),('5819','2013-04-13','09:20:00',2.71),('5819','2013-04-13','09:25:00',2.33),('5819','2013-04-13','09:30:00',2.72),('5819','2013-04-13','09:35:00',2.66),('5819','2013-04-13','09:40:00',2.45),('5819','2013-04-13','09:45:00',2.86),('5819','2013-04-13','09:50:00',2.91),('5819','2013-04-13','09:55:00',3.03),('5819','2013-04-13','10:00:00',3.1),('5819','2013-04-13','10:05:00',3.14),('5819','2013-04-13','10:10:00',3.27),('5819','2013-04-13','10:15:00',3.61),('5819','2013-04-13','10:20:00',3.41),('5819','2013-04-13','10:25:00',2.62),('5819','2013-04-13','10:30:00',3.09),('5819','2013-04-13','10:35:00',2.49),('5819','2013-04-13','10:40:00',2.08),('5819','2013-04-13','10:45:00',3.32),('5819','2013-04-13','10:50:00',1.69),('5819','2013-04-13','10:55:00',2.61),('5819','2013-04-13','11:00:00',2.52),('5819','2013-04-13','11:05:00',2.46),('5819','2013-04-13','11:10:00',2.03),('5819','2013-04-13','11:15:00',2.65),('5819','2013-04-13','11:20:00',3.48),('5819','2013-04-13','11:25:00',1.68),('5819','2013-04-13','11:30:00',1.31),('5819','2013-04-13','11:35:00',4.28),('5819','2013-04-13','11:40:00',3.78),('5819','2013-04-13','11:45:00',3.08),('5819','2013-04-13','11:50:00',4.25),('5819','2013-04-13','11:55:00',2.19),('5819','2013-04-13','12:00:00',4.25),('5819','2013-04-13','12:05:00',4.11),('5819','2013-04-13','12:10:00',4.19),('5819','2013-04-13','12:15:00',4.17),('5819','2013-04-13','12:20:00',4.02),('5819','2013-04-13','12:25:00',3.94),('5819','2013-04-13','12:30:00',3.52),('5819','2013-04-13','12:35:00',4.06),('5819','2013-04-13','12:40:00',4.1),('5819','2013-04-13','12:45:00',4.01),('5819','2013-04-13','12:50:00',3.9),('5819','2013-04-13','12:55:00',3.97),('5819','2013-04-13','13:00:00',3.7),('5819','2013-04-13','13:05:00',3.98),('5819','2013-04-13','13:10:00',4.06),('5819','2013-04-13','13:15:00',3.91),('5819','2013-04-13','13:20:00',3.63),('5819','2013-04-13','13:25:00',3.91),('5819','2013-04-13','13:30:00',3.87),('5819','2013-04-13','13:35:00',2.15),('5819','2013-04-13','13:40:00',1.87),('5819','2013-04-13','13:45:00',3.28),('5819','2013-04-13','13:50:00',2.67),('5819','2013-04-13','13:55:00',1.83),('5819','2013-04-13','14:00:00',1.85),('5819','2013-04-13','14:05:00',2.27),('5819','2013-04-13','14:10:00',1.5),('5819','2013-04-13','14:15:00',1.57),('5819','2013-04-13','14:20:00',2.97),('5819','2013-04-13','14:25:00',3.35),('5819','2013-04-13','14:30:00',3.28),('5819','2013-04-13','14:35:00',3.46),('5819','2013-04-13','14:40:00',3.32),('5819','2013-04-13','14:45:00',3.31),('5819','2013-04-13','14:50:00',3.16),('5819','2013-04-13','14:55:00',3.19),('5819','2013-04-13','15:00:00',2.96),('5819','2013-04-13','15:05:00',2.63),('5819','2013-04-13','15:10:00',2.35),('5819','2013-04-13','15:15:00',2.68),('5819','2013-04-13','15:20:00',2.54),('5819','2013-04-13','15:25:00',2.37),('5819','2013-04-13','15:30:00',2.41),('5819','2013-04-13','15:35:00',2.32),('5819','2013-04-13','15:40:00',2.4),('5819','2013-04-13','15:45:00',2.43),('5819','2013-04-13','15:50:00',2.38),('5819','2013-04-13','15:55:00',2.29),('5819','2013-04-13','16:00:00',2.3),('5819','2013-04-13','16:05:00',2.16),('5819','2013-04-13','16:10:00',2.01),('5819','2013-04-13','16:15:00',2.08),('5819','2013-04-13','16:20:00',1.96),('5819','2013-04-13','16:25:00',1.83),('5819','2013-04-13','16:30:00',1.76),('5819','2013-04-13','16:35:00',1.63),('5819','2013-04-13','16:40:00',1.55),('5819','2013-04-13','16:45:00',1.49),('5819','2013-04-13','16:50:00',1.51),('5819','2013-04-13','16:55:00',1.26),('5819','2013-04-13','17:00:00',1.09),('5819','2013-04-13','17:05:00',1.06),('5819','2013-04-13','17:10:00',1.45),('5819','2013-04-13','17:15:00',1.53),('5819','2013-04-13','17:20:00',1.27),('5819','2013-04-13','17:25:00',1.4),('5819','2013-04-13','17:30:00',1.15),('5819','2013-04-13','17:35:00',1.07),('5819','2013-04-13','17:40:00',1.06),('5819','2013-04-12','07:50:00',1.12),('5819','2013-04-12','08:00:00',1.07),('5819','2013-04-12','08:05:00',1.34),('5819','2013-04-12','08:10:00',1.28),('5819','2013-04-12','08:30:00',1.07),('5819','2013-04-12','08:35:00',1.19),('5819','2013-04-12','08:40:00',1.07),('5819','2013-04-12','08:45:00',1.16),('5819','2013-04-12','08:51:00',1.13),('5819','2013-04-12','08:55:00',1.22),('5819','2013-04-12','09:00:00',1.82),('5819','2013-04-12','09:05:00',1.85),('5819','2013-04-12','09:10:00',1.15),('5819','2013-04-12','09:15:00',2.29),('5819','2013-04-12','09:20:00',2.12),('5819','2013-04-12','09:25:00',1.76),('5819','2013-04-12','09:30:00',1.89),('5819','2013-04-12','09:35:00',1.27),('5819','2013-04-12','09:40:00',1.77),('5819','2013-04-12','09:45:00',1.43),('5819','2013-04-12','09:50:00',1.15),('5819','2013-04-12','10:20:00',1.36),('5819','2013-04-12','10:25:00',1.87),('5819','2013-04-12','10:30:00',1.1),('5819','2013-04-12','10:35:00',1.15),('5819','2013-04-12','10:40:00',1.34),('5819','2013-04-12','10:45:00',3.62),('5819','2013-04-12','10:50:00',2.87),('5819','2013-04-12','10:55:00',4.28),('5819','2013-04-12','11:00:00',2.01),('5819','2013-04-12','11:05:00',1.37),('5819','2013-04-12','11:10:00',1.68),('5819','2013-04-12','11:15:00',2.12),('5819','2013-04-12','11:20:00',4.34),('5819','2013-04-12','11:25:00',4.24),('5819','2013-04-12','11:30:00',3.17),('5819','2013-04-12','11:35:00',3.75),('5819','2013-04-12','11:40:00',4.18),('5819','2013-04-12','11:45:00',3.33),('5819','2013-04-12','11:50:00',3.04),('5819','2013-04-12','11:55:00',4.1),('5819','2013-04-12','12:00:00',4.07),('5819','2013-04-12','12:05:00',3.82),('5819','2013-04-12','12:10:00',3.83),('5819','2013-04-12','12:15:00',3.98),('5819','2013-04-12','12:20:00',4.1),('5819','2013-04-12','12:25:00',4.08),('5819','2013-04-12','12:30:00',4.02),('5819','2013-04-12','12:35:00',3.95),('5819','2013-04-12','12:40:00',3.86),('5819','2013-04-12','12:45:00',3.85),('5819','2013-04-12','12:50:00',3.86),('5819','2013-04-12','12:55:00',3.99),('5819','2013-04-12','13:00:00',4.02),('5819','2013-04-12','13:05:00',3.97),('5819','2013-04-12','13:10:00',3.97),('5819','2013-04-12','13:15:00',3.95),('5819','2013-04-12','13:20:00',3.95),('5819','2013-04-12','13:25:00',3.92),('5819','2013-04-12','13:30:00',3.87),('5819','2013-04-12','13:35:00',3.89),('5819','2013-04-12','13:40:00',3.82),('5819','2013-04-12','13:45:00',3.85),('5819','2013-04-12','13:50:00',3.8),('5819','2013-04-12','13:55:00',3.78),('5819','2013-04-12','14:00:00',3.77),('5819','2013-04-12','14:05:00',3.75),('5819','2013-04-12','14:10:00',3.71),('5819','2013-04-12','14:15:00',3.64),('5819','2013-04-12','14:20:00',3.6),('5819','2013-04-12','14:25:00',3.57),('5819','2013-04-12','14:30:00',3.53),('5819','2013-04-12','14:35:00',3.49),('5819','2013-04-12','14:40:00',3.43),('5819','2013-04-12','14:45:00',3.39),('5819','2013-04-12','14:50:00',3.33),('5819','2013-04-12','14:55:00',3.31),('5819','2013-04-12','15:00:00',3.26),('5819','2013-04-12','15:05:00',3.21),('5819','2013-04-12','15:10:00',3.14),('5819','2013-04-12','15:15:00',3.07),('5819','2013-04-12','15:20:00',3.03),('5819','2013-04-12','15:25:00',2.97),('5819','2013-04-12','15:30:00',2.91),('5819','2013-04-12','15:35:00',2.84),('5819','2013-04-12','15:40:00',2.78),('5819','2013-04-12','15:45:00',2.73),('5819','2013-04-12','15:50:00',2.66),('5819','2013-04-12','15:55:00',2.59),('5819','2013-04-12','16:00:00',2.52),('5819','2013-04-12','16:05:00',2.46),('5819','2013-04-12','16:10:00',2.41),('5819','2013-04-12','16:15:00',2.14),('5819','2013-04-12','16:20:00',2.19),('5819','2013-04-12','16:25:00',2.18),('5819','2013-04-12','16:30:00',1.41),('5819','2013-04-12','16:35:00',1.1),('5819','2013-04-12','16:40:00',1.2),('5819','2013-04-12','16:45:00',1.94),('5819','2013-04-12','16:50:00',1.78),('5819','2013-04-12','16:55:00',1.71),('5819','2013-04-12','17:00:00',1.62),('5819','2013-04-12','17:05:00',1.55),('5819','2013-04-12','17:10:00',1.46),('5819','2013-04-12','17:15:00',1.37),('5819','2013-04-12','17:20:00',1.3),('5819','2013-04-12','17:25:00',1.22),('5819','2013-04-12','17:30:00',1.1),('5819','2013-04-11','07:50:00',1.04),('5819','2013-04-11','07:55:00',1.13),('5819','2013-04-11','08:00:00',1.21),('5819','2013-04-11','08:05:00',1.3),('5819','2013-04-11','08:10:00',1.38),('5819','2013-04-11','08:15:00',1.46),('5819','2013-04-11','08:20:00',1.54),('5819','2013-04-11','08:25:00',1.63),('5819','2013-04-11','08:30:00',1.72),('5819','2013-04-11','08:35:00',1.8),('5819','2013-04-11','08:40:00',1.87),('5819','2013-04-11','08:45:00',1.95),('5819','2013-04-11','08:50:00',2.04),('5819','2013-04-11','08:55:00',2.13),('5819','2013-04-11','09:00:00',2.21),('5819','2013-04-11','09:05:00',2.28),('5819','2013-04-11','09:10:00',2.34),('5819','2013-04-11','09:15:00',2.43),('5819','2013-04-11','09:20:00',2.49),('5819','2013-04-11','09:25:00',2.56),('5819','2013-04-11','09:30:00',2.57),('5819','2013-04-11','09:35:00',2.64),('5819','2013-04-11','09:40:00',2.74),('5819','2013-04-11','09:45:00',2.83),('5819','2013-04-11','09:50:00',2.92),('5819','2013-04-11','09:55:00',2.59),('5819','2013-04-11','10:00:00',1.81),('5819','2013-04-11','10:10:00',1.55),('5819','2013-04-11','10:15:00',2.24),('5819','2013-04-11','10:20:00',3.36),('5819','2013-04-11','10:25:00',3.32),('5819','2013-04-11','10:30:00',3.37),('5819','2013-04-11','10:35:00',3.61),('5819','2013-04-11','10:40:00',3.69),('5819','2013-04-11','10:45:00',3.89),('5819','2013-04-11','10:50:00',1.98),('5819','2013-04-11','10:55:00',1.14),('5819','2013-04-11','11:05:00',3.67),('5819','2013-04-11','11:10:00',3.81),('5819','2013-04-11','11:15:00',3.82),('5819','2013-04-11','11:20:00',3.12),('5819','2013-04-11','11:25:00',1.46),('5819','2013-04-11','11:30:00',2.86),('5819','2013-04-11','11:35:00',4.12),('5819','2013-04-11','11:40:00',1.81),('5819','2013-04-11','11:45:00',1.24),('5819','2013-04-11','11:50:00',1.08),('5819','2013-04-11','11:55:00',1.6),('5819','2013-04-11','12:00:00',4),('5819','2013-04-11','12:05:00',4.31),('5819','2013-04-11','12:10:00',4.11),('5819','2013-04-11','12:15:00',1.39),('5819','2013-04-11','12:20:00',1.99),('5819','2013-04-11','12:25:00',4.34),('5819','2013-04-11','12:30:00',4.25),('5819','2013-04-11','12:35:00',4.22),('5819','2013-04-11','12:40:00',4.22),('5819','2013-04-11','12:45:00',4.21),('5819','2013-04-11','12:50:00',4.13),('5819','2013-04-11','12:55:00',3.54),('5819','2013-04-11','13:00:00',3.58),('5819','2013-04-11','13:05:00',3.75),('5819','2013-04-11','13:10:00',3.06),('5819','2013-04-11','13:15:00',4.07),('5819','2013-04-11','13:20:00',2.83),('5819','2013-04-11','13:25:00',3.45),('5819','2013-04-11','13:30:00',3.97),('5819','2013-04-11','13:35:00',3.88),('5819','2013-04-11','13:40:00',3.89),('5819','2013-04-11','13:45:00',3.84),('5819','2013-04-11','13:50:00',3.8),('5819','2013-04-11','13:55:00',3.86),('5819','2013-04-11','14:00:00',3.82),('5819','2013-04-11','14:05:00',3.77),('5819','2013-04-11','14:10:00',3.77),('5819','2013-04-11','14:15:00',3.73),('5819','2013-04-11','14:20:00',3.7),('5819','2013-04-11','14:25:00',3.64),('5819','2013-04-11','14:30:00',3.56),('5819','2013-04-11','14:35:00',3.36),('5819','2013-04-11','14:40:00',3.47),('5819','2013-04-11','14:45:00',3.58),('5819','2013-04-11','14:50:00',3.46),('5819','2013-04-11','14:55:00',3.41),('5819','2013-04-11','15:00:00',3.35),('5819','2013-04-11','15:05:00',3.27),('5819','2013-04-11','15:10:00',3.19),('5819','2013-04-11','15:15:00',3.14),('5819','2013-04-11','15:20:00',3.07),('5819','2013-04-11','15:25:00',3.02),('5819','2013-04-11','15:30:00',2.96),('5819','2013-04-11','15:35:00',2.9),('5819','2013-04-11','15:40:00',2.83),('5819','2013-04-11','15:45:00',2.76),('5819','2013-04-11','15:50:00',2.68),('5819','2013-04-11','15:55:00',2.63),('5819','2013-04-11','16:00:00',2.56),('5819','2013-04-11','16:05:00',2.5),('5819','2013-04-11','16:10:00',2.43),('5819','2013-04-11','16:15:00',2.35),('5819','2013-04-11','16:20:00',2.28),('5819','2013-04-11','16:25:00',2.2),('5819','2013-04-11','16:30:00',2.13),('5819','2013-04-11','16:35:00',2.05),('5819','2013-04-11','16:40:00',1.97),('5819','2013-04-11','16:45:00',1.89),('5819','2013-04-11','16:50:00',1.8),('5819','2013-04-11','16:55:00',1.73),('5819','2013-04-11','17:00:00',1.65),('5819','2013-04-11','17:05:00',1.56),('5819','2013-04-11','17:10:00',1.48),('5819','2013-04-11','17:15:00',1.4),('5819','2013-04-11','17:20:00',1.31),('5819','2013-04-11','17:25:00',1.22),('5819','2013-04-11','17:30:00',1.09),('5819','2013-04-11','17:35:00',1.01),('5819','2013-04-10','08:55:00',1.74),('5819','2013-04-10','09:00:00',2.16),('5819','2013-04-10','09:05:00',2.33),('5819','2013-04-10','09:10:00',2.42),('5819','2013-04-10','09:15:00',2.36),('5819','2013-04-10','09:20:00',2.39),('5819','2013-04-10','09:25:00',2.62),('5819','2013-04-10','09:30:00',2.66),('5819','2013-04-10','09:35:00',2.8),('5819','2013-04-10','09:40:00',2.85),('5819','2013-04-10','09:45:00',2.95),('5819','2013-04-10','09:50:00',3.04),('5819','2013-04-10','09:55:00',3.13),('5819','2013-04-10','10:00:00',3.16),('5819','2013-04-10','10:05:00',3.3),('5819','2013-04-10','10:10:00',3.47),('5819','2013-04-10','10:15:00',3.57),('5819','2013-04-10','10:20:00',3.58),('5819','2013-04-10','10:25:00',3.61),('5819','2013-04-10','10:30:00',3.62),('5819','2013-04-10','10:35:00',3.63),('5819','2013-04-10','10:40:00',3.66),('5819','2013-04-10','10:45:00',3.77),('5819','2013-04-10','10:50:00',3.56),('5819','2013-04-10','10:55:00',3.51),('5819','2013-04-10','11:00:00',3.52),('5819','2013-04-10','11:05:00',3.47),('5819','2013-04-10','11:10:00',3.56),('5819','2013-04-10','11:15:00',3.42),('5819','2013-04-10','11:20:00',3.74),('5819','2013-04-10','11:25:00',3.86),('5819','2013-04-10','11:30:00',3.86),('5819','2013-04-10','11:35:00',3.9),('5819','2013-04-10','11:40:00',3.87),('5819','2013-04-10','11:45:00',3.93),('5819','2013-04-10','11:50:00',3.96),('5819','2013-04-10','11:55:00',3.59),('5819','2013-04-10','12:00:00',4),('5819','2013-04-10','12:05:00',4.01),('5819','2013-04-10','12:10:00',4.03),('5819','2013-04-10','12:15:00',4.06),('5819','2013-04-10','12:20:00',4.06),('5819','2013-04-10','12:25:00',4.12),('5819','2013-04-10','12:30:00',4.16),('5819','2013-04-10','12:35:00',4.12),('5819','2013-04-10','12:40:00',4.05),('5819','2013-04-10','12:45:00',4.05),('5819','2013-04-10','12:50:00',4.11),('5819','2013-04-10','12:55:00',3.94),('5819','2013-04-10','13:00:00',4.08),('5819','2013-04-10','13:05:00',4),('5819','2013-04-10','13:10:00',3.76),('5819','2013-04-10','13:15:00',3.05),('5819','2013-04-10','13:20:00',4.57),('5819','2013-04-10','13:25:00',2.55),('5819','2013-04-10','13:30:00',2.66),('5819','2013-04-10','13:35:00',3.8),('5819','2013-04-10','13:40:00',3.19),('5819','2013-04-10','13:45:00',4.14),('5819','2013-04-10','13:50:00',3.08),('5819','2013-04-10','13:55:00',3.3),('5819','2013-04-10','14:00:00',3.1),('5819','2013-04-10','14:05:00',3.93),('5819','2013-04-10','14:10:00',3.82),('5819','2013-04-10','14:15:00',3.83),('5819','2013-04-10','14:20:00',3.8),('5819','2013-04-10','14:25:00',3.78),('5819','2013-04-10','14:30:00',3.73),('5819','2013-04-10','14:35:00',3.69),('5819','2013-04-10','14:40:00',3.67),('5819','2013-04-10','14:45:00',3.35),('5819','2013-04-10','14:50:00',3.39),('5819','2013-04-10','14:55:00',3.24),('5819','2013-04-10','15:00:00',3.56),('5819','2013-04-10','15:05:00',3.51),('5819','2013-04-10','15:10:00',3.41),('5819','2013-04-10','15:15:00',2.74),('5819','2013-04-10','15:20:00',2.4),('5819','2013-04-10','15:25:00',3.26),('5819','2013-04-10','15:30:00',3.01),('5819','2013-04-10','15:35:00',2.53),('5819','2013-04-10','15:40:00',2.95),('5819','2013-04-10','15:45:00',2.86),('5819','2013-04-10','15:50:00',2.99),('5819','2013-04-10','15:55:00',2.32),('5819','2013-04-10','16:00:00',2.7),('5819','2013-04-10','16:05:00',2.17),('5819','2013-04-10','16:10:00',2.49),('5819','2013-04-10','16:15:00',2.27),('5819','2013-04-10','16:20:00',2.44),('5819','2013-04-10','16:25:00',1.95),('5819','2013-04-10','16:30:00',2.2),('5819','2013-04-10','16:35:00',1.21),('5819','2013-04-10','16:40:00',1.98),('5819','2013-04-10','16:45:00',1.9),('5819','2013-04-10','16:50:00',1.81),('5819','2013-04-10','16:55:00',1),('5819','2013-04-10','17:00:00',1.92),('5819','2013-04-10','17:05:00',1.49),('5819','2013-04-10','17:10:00',1.19),('5819','2013-04-10','17:15:00',1.39),('5819','2013-04-10','17:20:00',1.51),('5819','2013-04-10','17:25:00',1.13),('5819','2013-04-10','17:30:00',1.05),('5819','2013-04-10','17:35:00',1),('5819','2013-04-09','07:55:00',1.07),('5819','2013-04-09','08:00:00',1.26),('5819','2013-04-09','08:10:00',1.04),('5819','2013-04-09','08:20:00',1.54),('5819','2013-04-09','08:35:00',1.09),('5819','2013-04-09','09:15:00',1.13),('5819','2013-04-09','09:20:00',1.11),('5819','2013-04-09','09:25:00',1.05),('5819','2013-04-09','09:30:00',1.18),('5819','2013-04-09','09:35:00',1.02),('5819','2013-04-09','09:50:00',1.63),('5819','2013-04-09','09:55:00',3.13),('5819','2013-04-09','10:00:00',1.82),('5819','2013-04-09','10:10:00',1.29),('5819','2013-04-09','10:15:00',2.03),('5819','2013-04-09','10:20:00',1.87),('5819','2013-04-09','10:35:00',3.04),('5819','2013-04-09','10:40:00',2.03),('5819','2013-04-09','10:45:00',3.26),('5819','2013-04-09','10:50:00',4.06),('5819','2013-04-09','10:55:00',3.12),('5819','2013-04-09','11:00:00',3.16),('5819','2013-04-09','11:05:00',3.52),('5819','2013-04-09','11:10:00',4.05),('5819','2013-04-09','11:15:00',2.4),('5819','2013-04-09','11:25:00',3.79),('5819','2013-04-09','11:30:00',4.58),('5819','2013-04-09','11:35:00',3.56),('5819','2013-04-09','11:45:00',2.82),('5819','2013-04-09','11:50:00',4.17),('5819','2013-04-09','11:55:00',2.3),('5819','2013-04-09','12:00:00',4.52),('5819','2013-04-09','12:05:00',4.28),('5819','2013-04-09','12:10:00',4.27),('5819','2013-04-09','12:15:00',4.27),('5819','2013-04-09','12:20:00',3.07),('5819','2013-04-09','12:25:00',3.9),('5819','2013-04-09','12:30:00',4.17),('5819','2013-04-09','12:35:00',3.83),('5819','2013-04-09','12:40:00',4.17),('5819','2013-04-09','12:45:00',4.12),('5819','2013-04-09','12:50:00',4.24),('5819','2013-04-09','12:55:00',4.19),('5819','2013-04-09','13:00:00',4.21),('5819','2013-04-09','13:05:00',4.28),('5819','2013-04-09','13:10:00',4.41),('5819','2013-04-09','13:15:00',4.32),('5819','2013-04-09','13:20:00',2.75),('5819','2013-04-09','13:25:00',3.94),('5819','2013-04-09','13:30:00',3.4),('5819','2013-04-09','13:35:00',1.26),('5819','2013-04-09','13:40:00',2.13),('5819','2013-04-09','13:45:00',1.45),('5819','2013-04-09','13:50:00',2.94),('5819','2013-04-09','13:55:00',3.92),('5819','2013-04-09','14:00:00',3.7),('5819','2013-04-09','14:05:00',3.47),('5819','2013-04-09','14:10:00',2.91),('5819','2013-04-09','14:15:00',3.35),('5819','2013-04-09','14:20:00',1.97),('5819','2013-04-09','14:25:00',2.38),('5819','2013-04-09','14:30:00',3.32),('5819','2013-04-09','14:35:00',3.36),('5819','2013-04-09','14:40:00',3.51),('5819','2013-04-09','14:45:00',3.24),('5819','2013-04-09','14:50:00',3.15),('5819','2013-04-09','14:55:00',3.16),('5819','2013-04-09','15:00:00',2.59),('5819','2013-04-09','15:05:00',2.7),('5819','2013-04-09','15:10:00',3.47),('5819','2013-04-09','15:15:00',2.37),('5819','2013-04-09','15:20:00',3.3),('5819','2013-04-09','15:25:00',3.37),('5819','2013-04-09','15:30:00',2.92),('5819','2013-04-09','15:35:00',2.07),('5819','2013-04-09','15:40:00',3.14),('5819','2013-04-09','15:45:00',2.36),('5819','2013-04-09','15:50:00',2.82),('5819','2013-04-09','15:55:00',2.52),('5819','2013-04-09','16:00:00',2.3),('5819','2013-04-09','16:05:00',2.44),('5819','2013-04-09','16:10:00',2.54),('5819','2013-04-09','16:15:00',1.82),('5819','2013-04-09','16:20:00',1.37),('5819','2013-04-09','16:25:00',1.12),('5819','2013-04-09','16:35:00',1.33),('5819','2013-04-09','16:40:00',1.08),('5819','2013-04-09','16:50:00',1.72),('5819','2013-04-09','16:55:00',1.85),('5819','2013-04-09','17:30:00',1.09),('5819','2013-04-08','08:40:00',1.15),('5819','2013-04-08','08:45:00',1.21),('5819','2013-04-08','08:50:00',1.53),('5819','2013-04-08','08:55:00',1.18),('5819','2013-04-08','09:00:00',1.45),('5819','2013-04-08','09:05:00',1.6),('5819','2013-04-08','09:10:00',2.03),('5819','2013-04-08','09:15:00',1.67),('5819','2013-04-08','09:20:00',2.27),('5819','2013-04-08','09:25:00',1.88),('5819','2013-04-08','09:30:00',2.67),('5819','2013-04-08','09:35:00',2.92),('5819','2013-04-08','09:40:00',3.02),('5819','2013-04-08','09:45:00',3.02),('5819','2013-04-08','09:50:00',2.27),('5819','2013-04-08','09:55:00',1.51),('5819','2013-04-08','10:00:00',3.14),('5819','2013-04-08','10:05:00',3.32),('5819','2013-04-08','10:10:00',3.19),('5819','2013-04-08','10:15:00',3.3),('5819','2013-04-08','10:20:00',3.27),('5819','2013-04-08','10:25:00',3.26),('5819','2013-04-08','10:30:00',3.3),('5819','2013-04-08','10:35:00',3.17),('5819','2013-04-08','10:40:00',3.42),('5819','2013-04-08','10:45:00',3.55),('5819','2013-04-08','10:50:00',3.61),('5819','2013-04-08','10:55:00',3.45),('5819','2013-04-08','11:00:00',3.61),('5819','2013-04-08','11:05:00',3.23),('5819','2013-04-08','11:10:00',2.71),('5819','2013-04-08','11:15:00',2.77),('5819','2013-04-08','11:20:00',2.3),('5819','2013-04-08','11:25:00',1.95),('5819','2013-04-08','11:30:00',2.09),('5819','2013-04-08','11:35:00',2.7),('5819','2013-04-08','11:40:00',3.04),('5819','2013-04-08','11:45:00',2.75),('5819','2013-04-08','11:50:00',2.61),('5819','2013-04-08','11:55:00',2.22),('5819','2013-04-08','12:00:00',2.13),('5819','2013-04-08','12:05:00',2),('5819','2013-04-08','12:10:00',2.11),('5819','2013-04-08','12:15:00',2.52),('5819','2013-04-08','12:20:00',2.55),('5819','2013-04-08','12:25:00',2.6),('5819','2013-04-08','12:30:00',2.8),('5819','2013-04-08','12:35:00',2.64),('5819','2013-04-08','12:40:00',2.02),('5819','2013-04-08','12:45:00',2.13),('5819','2013-04-08','12:50:00',2.64),('5819','2013-04-08','12:55:00',2.93),('5819','2013-04-08','13:00:00',2.06),('5819','2013-04-08','13:05:00',2.14),('5819','2013-04-08','13:10:00',2.61),('5819','2013-04-08','13:15:00',2.74),('5819','2013-04-08','13:20:00',3.41),('5819','2013-04-08','13:25:00',3.04),('5819','2013-04-08','13:30:00',2.64),('5819','2013-04-08','13:35:00',2.87),('5819','2013-04-08','13:40:00',3.32),('5819','2013-04-08','13:45:00',2.69),('5819','2013-04-08','13:50:00',2.75),('5819','2013-04-08','13:55:00',3.55),('5819','2013-04-08','14:00:00',3.57),('5819','2013-04-08','14:05:00',2.89),('5819','2013-04-08','14:10:00',3.02),('5819','2013-04-08','14:15:00',3.36),('5819','2013-04-08','14:20:00',3.08),('5819','2013-04-08','14:25:00',3.53),('5819','2013-04-08','14:30:00',3.44),('5819','2013-04-08','14:35:00',3.27),('5819','2013-04-08','14:40:00',3.17),('5819','2013-04-08','14:45:00',3.25),('5819','2013-04-08','14:50:00',3.24),('5819','2013-04-08','14:55:00',3.4),('5819','2013-04-08','15:00:00',2.71),('5819','2013-04-08','15:05:00',2.68),('5819','2013-04-08','15:10:00',2.52),('5819','2013-04-08','15:15:00',2.7),('5819','2013-04-08','15:20:00',2.28),('5819','2013-04-08','15:25:00',3.05),('5819','2013-04-08','15:30:00',3.12),('5819','2013-04-08','15:35:00',2.97),('5819','2013-04-08','15:40:00',2.86),('5819','2013-04-08','15:45:00',2.77),('5819','2013-04-08','15:50:00',2.69),('5819','2013-04-08','15:55:00',2.63),('5819','2013-04-08','16:00:00',2.56),('5819','2013-04-08','16:05:00',2.42),('5819','2013-04-08','16:10:00',2.22),('5819','2013-04-08','16:15:00',2.35),('5819','2013-04-08','16:20:00',2.34),('5819','2013-04-08','16:25:00',2.2),('5819','2013-04-08','16:30:00',2.12),('5819','2013-04-08','16:35:00',2.04),('5819','2013-04-08','16:40:00',1.96),('5819','2013-04-08','16:45:00',1.89),('5819','2013-04-08','16:50:00',1.82),('5819','2013-04-08','16:55:00',1.73),('5819','2013-04-08','17:00:00',1.66),('5819','2013-04-08','17:05:00',1.59),('5819','2013-04-08','17:10:00',1.47),('5819','2013-04-08','17:15:00',1.41),('5819','2013-04-08','17:20:00',1.28),('5819','2013-04-08','17:25:00',1.3),('5819','2013-04-08','17:30:00',1.19),('5819','2013-04-08','17:35:00',1.01),('5819','2013-04-07','08:25:00',1.12),('5819','2013-04-07','08:30:00',1.25),('5819','2013-04-07','08:35:00',1.35),('5819','2013-04-07','08:40:00',1.42),('5819','2013-04-07','08:45:00',1.45),('5819','2013-04-07','08:50:00',1.49),('5819','2013-04-07','08:55:00',1.53),('5819','2013-04-07','09:00:00',1.47),('5819','2013-04-07','09:05:00',1.5),('5819','2013-04-07','09:10:00',1.6),('5819','2013-04-07','09:15:00',1.57),('5819','2013-04-07','09:20:00',1.68),('5819','2013-04-07','09:25:00',1.65),('5819','2013-04-07','09:30:00',1.59),('5819','2013-04-07','09:35:00',1.48),('5819','2013-04-07','09:40:00',1.56),('5819','2013-04-07','09:45:00',1.99),('5819','2013-04-07','09:50:00',2.12),('5819','2013-04-07','09:55:00',2.34),('5819','2013-04-07','10:00:00',2.71),('5819','2013-04-07','10:05:00',2.77),('5819','2013-04-07','10:10:00',2.77),('5819','2013-04-07','10:15:00',2.84),('5819','2013-04-07','10:20:00',2.91),('5819','2013-04-07','10:25:00',2.84),('5819','2013-04-07','10:30:00',2.5),('5819','2013-04-07','10:35:00',2.78),('5819','2013-04-07','10:40:00',2.71),('5819','2013-04-07','10:45:00',2.67),('5819','2013-04-07','10:50:00',2.6),('5819','2013-04-07','10:55:00',2.32),('5819','2013-04-07','11:00:00',2.07),('5819','2013-04-07','11:05:00',1.79),('5819','2013-04-07','11:10:00',2.15),('5819','2013-04-07','11:15:00',2.94),('5819','2013-04-07','11:20:00',3.35),('5819','2013-04-07','11:25:00',3.65),('5819','2013-04-07','11:30:00',3.48),('5819','2013-04-07','11:35:00',3.27),('5819','2013-04-07','11:40:00',2.92),('5819','2013-04-07','11:45:00',2.33),('5819','2013-04-07','11:50:00',2.22),('5819','2013-04-07','11:55:00',2.35),('5819','2013-04-07','12:00:00',2.44),('5819','2013-04-07','12:05:00',2.36),('5819','2013-04-07','12:10:00',2.55),('5819','2013-04-07','12:15:00',2.47),('5819','2013-04-07','12:20:00',2.67),('5819','2013-04-07','12:25:00',2.94),('5819','2013-04-07','12:30:00',2.49),('5819','2013-04-07','12:35:00',2.69),('5819','2013-04-07','12:40:00',2.65),('5819','2013-04-07','12:45:00',2.29),('5819','2013-04-07','12:50:00',2.39),('5819','2013-04-07','12:55:00',2.58),('5819','2013-04-07','13:00:00',2.99),('5819','2013-04-07','13:05:00',3.26),('5819','2013-04-07','13:10:00',3.18),('5819','2013-04-07','13:15:00',2.8),('5819','2013-04-07','13:20:00',2.61),('5819','2013-04-07','13:25:00',2.99),('5819','2013-04-07','13:30:00',3.08),('5819','2013-04-07','13:35:00',2.78),('5819','2013-04-07','13:40:00',2.95),('5819','2013-04-07','13:45:00',3.27),('5819','2013-04-07','13:50:00',3),('5819','2013-04-07','13:55:00',2.81),('5819','2013-04-07','14:00:00',3.31),('5819','2013-04-07','14:05:00',2.99),('5819','2013-04-07','14:10:00',2.31),('5819','2013-04-07','14:15:00',2.11),('5819','2013-04-07','14:20:00',1.87),('5819','2013-04-07','14:25:00',2.21),('5819','2013-04-07','14:30:00',2.31),('5819','2013-04-07','14:35:00',2.11),('5819','2013-04-07','14:40:00',1.76),('5819','2013-04-07','14:45:00',1.94),('5819','2013-04-07','14:50:00',2.15),('5819','2013-04-07','14:55:00',2.02),('5819','2013-04-07','15:00:00',2.05),('5819','2013-04-07','15:05:00',2.6),('5819','2013-04-07','15:10:00',2.57),('5819','2013-04-07','15:15:00',2.54),('5819','2013-04-07','15:20:00',2.56),('5819','2013-04-07','15:25:00',2.71),('5819','2013-04-07','15:30:00',2.56),('5819','2013-04-07','15:35:00',2.4),('5819','2013-04-07','15:40:00',2.43),('5819','2013-04-07','15:45:00',2.28),('5819','2013-04-07','15:50:00',2.1),('5819','2013-04-07','15:55:00',2.22),('5819','2013-04-07','16:00:00',2.06),('5819','2013-04-07','16:05:00',1.84),('5819','2013-04-07','16:10:00',1.56),('5819','2013-04-07','16:15:00',1.39),('5819','2013-04-07','16:20:00',1.31),('5819','2013-04-07','16:25:00',1.21),('5819','2013-04-07','16:30:00',1.21),('5819','2013-04-07','16:35:00',1.3),('5819','2013-04-07','16:40:00',1.38),('5819','2013-04-07','16:45:00',1.74),('5819','2013-04-07','16:50:00',1.86),('5819','2013-04-07','16:55:00',1.71),('5819','2013-04-07','17:00:00',1.58),('5819','2013-04-07','17:05:00',1.2),('5819','2013-04-07','17:20:00',1.34),('5819','2013-04-07','17:25:00',1.27),('5819','2013-04-07','17:30:00',1.38),('5819','2013-04-07','17:35:00',1.23),('5819','2013-04-07','17:40:00',1.17),('5819','2013-04-07','17:45:00',1.12),('5819','2013-04-07','17:50:00',1),('5819','2013-04-06','07:55:00',1.07),('5819','2013-04-06','08:00:00',1.15),('5819','2013-04-06','08:05:00',1.24),('5819','2013-04-06','08:10:00',1.33),('5819','2013-04-06','08:15:00',1.42),('5819','2013-04-06','08:20:00',1.5),('5819','2013-04-06','08:25:00',1.58),('5819','2013-04-06','08:30:00',1.67),('5819','2013-04-06','08:35:00',1.75),('5819','2013-04-06','08:40:00',1.82),('5819','2013-04-06','08:45:00',1.89),('5819','2013-04-06','08:50:00',1.98),('5819','2013-04-06','08:55:00',2.06),('5819','2013-04-06','09:00:00',2.13),('5819','2013-04-06','09:05:00',2.23),('5819','2013-04-06','09:10:00',2.3),('5819','2013-04-06','09:15:00',2.4),('5819','2013-04-06','09:20:00',2.47),('5819','2013-04-06','09:25:00',2.54),('5819','2013-04-06','09:30:00',2.6),('5819','2013-04-06','09:35:00',2.61),('5819','2013-04-06','09:40:00',2.72),('5819','2013-04-06','09:45:00',2.76),('5819','2013-04-06','09:50:00',2.81),('5819','2013-04-06','09:55:00',2.88),('5819','2013-04-06','10:00:00',2.96),('5819','2013-04-06','10:05:00',2.98),('5819','2013-04-06','10:10:00',3.03),('5819','2013-04-06','10:15:00',3.03),('5819','2013-04-06','10:20:00',3.13),('5819','2013-04-06','10:25:00',3.18),('5819','2013-04-06','10:30:00',3.28),('5819','2013-04-06','10:35:00',3.28),('5819','2013-04-06','10:40:00',3.33),('5819','2013-04-06','10:45:00',3.36),('5819','2013-04-06','10:50:00',3.41),('5819','2013-04-06','10:55:00',3.45),('5819','2013-04-06','11:00:00',3.5),('5819','2013-04-06','11:05:00',3.54),('5819','2013-04-06','11:10:00',3.59),('5819','2013-04-06','11:15:00',3.58),('5819','2013-04-06','11:20:00',3.65),('5819','2013-04-06','11:25:00',3.71),('5819','2013-04-06','11:30:00',3.72),('5819','2013-04-06','11:35:00',3.76),('5819','2013-04-06','11:40:00',3.79),('5819','2013-04-06','11:45:00',3.78),('5819','2013-04-06','11:50:00',3.78),('5819','2013-04-06','11:55:00',3.8),('5819','2013-04-06','12:00:00',3.75),('5819','2013-04-06','12:05:00',3.79),('5819','2013-04-06','12:10:00',3.77),('5819','2013-04-06','12:15:00',3.77),('5819','2013-04-06','12:20:00',3.64),('5819','2013-04-06','12:25:00',3.23),('5819','2013-04-06','12:30:00',3.66),('5819','2013-04-06','12:35:00',3.93),('5819','2013-04-06','12:40:00',3.88),('5819','2013-04-06','12:45:00',3.89),('5819','2013-04-06','12:50:00',3.89),('5819','2013-04-06','12:55:00',3.9),('5819','2013-04-06','13:00:00',3.86),('5819','2013-04-06','13:05:00',3.86),('5819','2013-04-06','13:10:00',3.82),('5819','2013-04-06','13:15:00',2.99),('5819','2013-04-06','13:20:00',2.3),('5819','2013-04-06','13:30:00',2.38),('5819','2013-04-06','13:35:00',3.99),('5819','2013-04-06','13:40:00',4.31),('5819','2013-04-06','13:45:00',4.27),('5819','2013-04-06','13:50:00',3.99),('5819','2013-04-06','13:55:00',3.98),('5819','2013-04-06','14:00:00',3.72),('5819','2013-04-06','14:05:00',3.83),('5819','2013-04-06','14:10:00',1.61),('5819','2013-04-06','14:15:00',3.91),('5819','2013-04-06','14:20:00',1.75),('5819','2013-04-06','14:25:00',2.7),('5819','2013-04-06','14:30:00',2.99),('5819','2013-04-06','14:35:00',3.5),('5819','2013-04-06','14:40:00',3.53),('5819','2013-04-06','14:45:00',3.33),('5819','2013-04-06','14:50:00',3.33),('5819','2013-04-06','14:55:00',2.77),('5819','2013-04-06','15:00:00',3.25),('5819','2013-04-06','15:05:00',3.23),('5819','2013-04-06','15:10:00',2.8),('5819','2013-04-06','15:15:00',3.02),('5819','2013-04-06','15:20:00',2.96),('5819','2013-04-06','15:25:00',2.92),('5819','2013-04-06','15:30:00',2.79),('5819','2013-04-06','15:35:00',2.72),('5819','2013-04-06','15:40:00',2.7),('5819','2013-04-06','15:45:00',2.44),('5819','2013-04-06','15:50:00',2.35),('5819','2013-04-06','15:55:00',2.56),('5819','2013-04-06','16:00:00',2.3),('5819','2013-04-06','16:05:00',2.43),('5819','2013-04-06','16:10:00',2.44),('5819','2013-04-06','16:15:00',2.24),('5819','2013-04-06','16:20:00',1.85),('5819','2013-04-06','16:25:00',1.54),('5819','2013-04-06','16:30:00',1.86),('5819','2013-04-06','16:35:00',1.79),('5819','2013-04-06','16:40:00',1.4),('5819','2013-04-06','16:45:00',1.85),('5819','2013-04-06','16:50:00',1.69),('5819','2013-04-06','16:55:00',1.46),('5819','2013-04-06','17:00:00',1.51),('5819','2013-04-06','17:05:00',1.23),('5819','2013-04-06','17:10:00',1.16),('5819','2013-04-05','08:20:00',1.28),('5819','2013-04-05','08:25:00',1.04),('5819','2013-04-05','08:55:00',1.53),('5819','2013-04-05','09:00:00',1),('5819','2013-04-05','09:05:00',2.53),('5819','2013-04-05','09:10:00',1.52),('5819','2013-04-05','09:15:00',2.46),('5819','2013-04-05','09:20:00',2.18),('5819','2013-04-05','09:25:00',1.11),('5819','2013-04-05','09:35:00',1.36),('5819','2013-04-05','09:40:00',2.28),('5819','2013-04-05','09:45:00',2.32),('5819','2013-04-05','09:50:00',1.2),('5819','2013-04-05','10:00:00',1.22),('5819','2013-04-05','10:10:00',2.18),('5819','2013-04-05','10:15:00',3.32),('5819','2013-04-05','10:20:00',1.36),('5819','2013-04-05','10:25:00',2.47),('5819','2013-04-05','10:30:00',2.53),('5819','2013-04-05','10:35:00',2.4),('5819','2013-04-05','10:40:00',3.43),('5819','2013-04-05','10:45:00',2.31),('5819','2013-04-05','10:50:00',2.16),('5819','2013-04-05','10:55:00',2.33),('5819','2013-04-05','11:00:00',2.38),('5819','2013-04-05','11:05:00',3.16),('5819','2013-04-05','11:10:00',3.96),('5819','2013-04-05','11:15:00',4),('5819','2013-04-05','11:20:00',2.76),('5819','2013-04-05','11:25:00',3.28),('5819','2013-04-05','11:30:00',3.22),('5819','2013-04-05','11:35:00',3.99),('5819','2013-04-05','11:40:00',3.62),('5819','2013-04-05','11:45:00',3.7),('5819','2013-04-05','11:50:00',2.82),('5819','2013-04-05','11:55:00',3.7),('5819','2013-04-05','12:00:00',4.08),('5819','2013-04-05','12:05:00',3.37),('5819','2013-04-05','12:10:00',3.28),('5819','2013-04-05','12:15:00',2.02),('5819','2013-04-05','12:20:00',1.47),('5819','2013-04-05','12:25:00',1.89),('5819','2013-04-05','12:30:00',1.22),('5819','2013-04-05','12:35:00',1.25),('5819','2013-04-05','12:40:00',1.56),('5819','2013-04-05','12:45:00',3.46),('5819','2013-04-05','12:50:00',4.27),('5819','2013-04-05','12:55:00',4.09),('5819','2013-04-05','13:00:00',2.76),('5819','2013-04-05','13:05:00',3.75),('5819','2013-04-05','13:10:00',2.53),('5819','2013-04-05','13:15:00',2.32),('5819','2013-04-05','13:20:00',2.21),('5819','2013-04-05','13:25:00',2.91),('5819','2013-04-05','13:30:00',2.44),('5819','2013-04-05','13:35:00',3.25),('5819','2013-04-05','13:40:00',4.21),('5819','2013-04-05','13:45:00',2.52),('5819','2013-04-05','13:50:00',4.38),('5819','2013-04-05','13:55:00',3.82),('5819','2013-04-05','14:00:00',2.49),('5819','2013-04-05','14:05:00',4.44),('5819','2013-04-05','14:10:00',3.25),('5819','2013-04-05','14:15:00',3.37),('5819','2013-04-05','14:20:00',3.71),('5819','2013-04-05','14:25:00',3.79),('5819','2013-04-05','14:30:00',3.66),('5819','2013-04-05','14:35:00',3.74),('5819','2013-04-05','14:40:00',3.66),('5819','2013-04-05','14:45:00',3.35),('5819','2013-04-05','14:50:00',2.26),('5819','2013-04-05','14:55:00',3.92),('5819','2013-04-05','15:00:00',3.41),('5819','2013-04-05','15:05:00',3.2),('5819','2013-04-05','15:10:00',3.13),('5819','2013-04-05','15:15:00',1.57),('5819','2013-04-05','15:20:00',1.6),('5819','2013-04-05','15:25:00',2),('5819','2013-04-05','15:30:00',1.63),('5819','2013-04-05','15:35:00',1.36),('5819','2013-04-05','15:40:00',1.08),('5819','2013-04-05','15:45:00',1.33),('5819','2013-04-05','15:50:00',1.6),('5819','2013-04-05','15:55:00',1.51),('5819','2013-04-05','16:00:00',1.62),('5819','2013-04-05','16:05:00',1.45),('5819','2013-04-05','16:10:00',1.34),('5819','2013-04-05','16:15:00',2.06),('5819','2013-04-05','16:20:00',1.76),('5819','2013-04-05','16:25:00',1.78),('5819','2013-04-05','16:30:00',1.32),('5819','2013-04-05','16:35:00',1.44),('5819','2013-04-05','16:40:00',1.29),('5819','2013-04-05','16:45:00',1.72),('5819','2013-04-05','16:50:00',2.5),('5819','2013-04-05','16:55:00',1.4),('5819','2013-04-05','17:00:00',1.38),('5819','2013-04-05','17:05:00',1.05),('5819','2013-04-05','17:10:00',1.51),('5819','2013-04-05','17:15:00',1.58),('5819','2013-04-05','17:20:00',1.09),('5819','2013-04-05','17:30:00',1.51),('5819','2013-04-05','17:35:00',1.15),('5819','2013-04-05','17:55:00',1.06),('5819','2013-04-04','08:55:00',1.31),('5819','2013-04-04','09:00:00',2.08),('5819','2013-04-04','09:05:00',1.42),('5819','2013-04-04','09:10:00',1.21),('5819','2013-04-04','09:15:00',1.22),('5819','2013-04-04','09:20:00',1.39),('5819','2013-04-04','09:30:00',1.41),('5819','2013-04-04','09:35:00',2.52),('5819','2013-04-04','09:40:00',2.37),('5819','2013-04-04','09:45:00',2),('5819','2013-04-04','09:50:00',1.16),('5819','2013-04-04','09:55:00',1.14),('5819','2013-04-04','10:00:00',1.73),('5819','2013-04-04','10:05:00',2.42),('5819','2013-04-04','10:10:00',2.34),('5819','2013-04-04','10:15:00',1.59),('5819','2013-04-04','10:20:00',1.61),('5819','2013-04-04','10:25:00',3.28),('5819','2013-04-04','10:30:00',3.25),('5819','2013-04-04','10:35:00',1.99),('5819','2013-04-04','10:40:00',3.84),('5819','2013-04-04','10:45:00',2.16),('5819','2013-04-04','10:50:00',2.3),('5819','2013-04-04','10:55:00',3.49),('5819','2013-04-04','11:00:00',2.18),('5819','2013-04-04','11:05:00',1.2),('5819','2013-04-04','11:10:00',1),('5819','2013-04-04','11:15:00',1.31),('5819','2013-04-04','11:20:00',1.33),('5819','2013-04-04','11:30:00',1.06),('5819','2013-04-04','11:35:00',1.47),('5819','2013-04-04','11:40:00',2.61),('5819','2013-04-04','11:45:00',3.18),('5819','2013-04-04','11:50:00',3.67),('5819','2013-04-04','11:55:00',3.83),('5819','2013-04-04','12:00:00',3.82),('5819','2013-04-04','12:05:00',3.73),('5819','2013-04-04','12:10:00',3.84),('5819','2013-04-04','12:15:00',3.73),('5819','2013-04-04','12:20:00',3.42),('5819','2013-04-04','12:25:00',3.01),('5819','2013-04-04','12:30:00',2.79),('5819','2013-04-04','12:35:00',2.38),('5819','2013-04-04','12:40:00',3.56),('5819','2013-04-04','12:45:00',2.48),('5819','2013-04-04','12:50:00',3.36),('5819','2013-04-04','12:55:00',3.67),('5819','2013-04-04','13:00:00',3.52),('5819','2013-04-04','13:05:00',3.64),('5819','2013-04-04','13:10:00',3.76),('5819','2013-04-04','13:15:00',3.91),('5819','2013-04-04','13:20:00',3.77),('5819','2013-04-04','13:25:00',3.83),('5819','2013-04-04','13:30:00',3.77),('5819','2013-04-04','13:35:00',3.48),('5819','2013-04-04','13:40:00',2.94),('5819','2013-04-04','13:45:00',2.93),('5819','2013-04-04','13:50:00',2.88),('5819','2013-04-04','13:55:00',2.27),('5819','2013-04-04','14:00:00',2.34),('5819','2013-04-04','14:05:00',3.11),('5819','2013-04-04','14:10:00',3.57),('5819','2013-04-04','14:15:00',3.52),('5819','2013-04-04','14:20:00',3.42),('5819','2013-04-04','14:25:00',3.32),('5819','2013-04-04','14:30:00',3.3),('5819','2013-04-04','14:35:00',3.25),('5819','2013-04-04','14:40:00',3.24),('5819','2013-04-04','14:45:00',3.18),('5819','2013-04-04','14:50:00',3.15),('5819','2013-04-04','14:55:00',3.14),('5819','2013-04-04','15:00:00',3.08),('5819','2013-04-04','15:05:00',2.97),('5819','2013-04-04','15:10:00',2.81),('5819','2013-04-04','15:15:00',2.74),('5819','2013-04-04','15:20:00',2.78),('5819','2013-04-04','15:25:00',2.8),('5819','2013-04-04','15:30:00',2.77),('5819','2013-04-04','15:35:00',2.71),('5819','2013-04-04','15:40:00',2.63),('5819','2013-04-04','15:45:00',2.56),('5819','2013-04-04','15:50:00',2.44),('5819','2013-04-04','15:55:00',2.39),('5819','2013-04-04','16:00:00',2.34),('5819','2013-04-04','16:05:00',2.27),('5819','2013-04-04','16:10:00',2.1),('5819','2013-04-04','16:15:00',2.07),('5819','2013-04-04','16:20:00',1.9),('5819','2013-04-04','16:25:00',1.9),('5819','2013-04-04','16:30:00',1.46),('5819','2013-04-04','16:35:00',1.57),('5819','2013-04-04','16:40:00',1.48),('5819','2013-04-04','16:45:00',1.45),('5819','2013-04-04','16:50:00',1.24),('5819','2013-04-04','16:55:00',1.49),('5819','2013-04-04','17:00:00',1.33),('5819','2013-04-04','17:05:00',1.31),('5819','2013-04-04','17:10:00',1.22),('5819','2013-04-04','17:15:00',1.11),('5819','2013-04-03','08:00:00',1.09),('5819','2013-04-03','08:05:00',1.18),('5819','2013-04-03','08:10:00',1.26),('5819','2013-04-03','08:15:00',1.28),('5819','2013-04-03','08:20:00',1.47),('5819','2013-04-03','08:25:00',1.43),('5819','2013-04-03','08:30:00',1.75),('5819','2013-04-03','08:35:00',2.02),('5819','2013-04-03','08:40:00',1.98),('5819','2013-04-03','08:45:00',2.05),('5819','2013-04-03','09:00:00',1.57),('5819','2013-04-03','09:05:00',2.46),('5819','2013-04-03','09:10:00',2.5),('5819','2013-04-03','09:15:00',2.61),('5819','2013-04-03','09:20:00',2.74),('5819','2013-04-03','09:25:00',1.59),('5819','2013-04-03','09:30:00',2.02),('5819','2013-04-03','09:35:00',1.5),('5819','2013-04-03','09:40:00',3.19),('5819','2013-04-03','09:45:00',2.31),('5819','2013-04-03','09:50:00',3.23),('5819','2013-04-03','09:55:00',3.54),('5819','2013-04-03','10:00:00',3.6),('5819','2013-04-03','10:05:00',1.26),('5819','2013-04-03','10:10:00',1.1),('5819','2013-04-03','10:15:00',1.43),('5819','2013-04-03','10:20:00',2.81),('5819','2013-04-03','10:25:00',3.54),('5819','2013-04-03','10:30:00',2.43),('5819','2013-04-03','10:35:00',2.13),('5819','2013-04-03','10:40:00',1.71),('5819','2013-04-03','10:45:00',1.65),('5819','2013-04-03','10:50:00',1.73),('5819','2013-04-03','10:55:00',3.2),('5819','2013-04-03','11:00:00',1.71),('5819','2013-04-03','11:05:00',4.21),('5819','2013-04-03','11:10:00',2.18),('5819','2013-04-03','11:15:00',2.74),('5819','2013-04-03','11:20:00',2.02),('5819','2013-04-03','11:25:00',2.6),('5819','2013-04-03','11:30:00',1.78),('5819','2013-04-03','11:35:00',1.4),('5819','2013-04-03','11:40:00',2.26),('5819','2013-04-03','11:45:00',1.26),('5819','2013-04-03','11:50:00',2.52),('5819','2013-04-03','11:55:00',2.12),('5819','2013-04-03','12:00:00',3.58),('5819','2013-04-03','12:05:00',2.78),('5819','2013-04-03','12:10:00',4.48),('5819','2013-04-03','12:15:00',1.58),('5819','2013-04-03','12:20:00',3.37),('5819','2013-04-03','12:25:00',2.83),('5819','2013-04-03','12:30:00',3.99),('5819','2013-04-03','12:35:00',3.46),('5819','2013-04-03','12:40:00',3.57),('5819','2013-04-03','12:45:00',4.03),('5819','2013-04-03','12:50:00',4.08),('5819','2013-04-03','12:55:00',4.17),('5819','2013-04-03','13:00:00',4.1),('5819','2013-04-03','13:05:00',3.02),('5819','2013-04-03','13:10:00',2.35),('5819','2013-04-03','13:15:00',4.26),('5819','2013-04-03','13:20:00',2.87),('5819','2013-04-03','13:25:00',2.48),('5819','2013-04-03','13:30:00',2.36),('5819','2013-04-03','13:35:00',3.36),('5819','2013-04-03','13:40:00',3.01),('5819','2013-04-03','13:45:00',3.45),('5819','2013-04-03','13:50:00',2.94),('5819','2013-04-03','13:55:00',3.78),('5819','2013-04-03','14:00:00',3.74),('5819','2013-04-03','14:05:00',2.68),('5819','2013-04-03','14:10:00',2.33),('5819','2013-04-03','14:15:00',3.37),('5819','2013-04-03','14:20:00',2.63),('5819','2013-04-03','14:25:00',3.36),('5819','2013-04-03','14:30:00',2.84),('5819','2013-04-03','14:35:00',3.57),('5819','2013-04-03','14:40:00',3.72),('5819','2013-04-03','14:45:00',3.04),('5819','2013-04-03','14:50:00',1.54),('5819','2013-04-03','14:55:00',1.97),('5819','2013-04-03','15:00:00',3.91),('5819','2013-04-03','15:05:00',3.41),('5819','2013-04-03','15:10:00',3.89),('5819','2013-04-03','15:15:00',3.49),('5819','2013-04-03','15:20:00',3.32),('5819','2013-04-03','15:25:00',3.44),('5819','2013-04-03','15:30:00',3.27),('5819','2013-04-03','15:35:00',3.21),('5819','2013-04-03','15:40:00',3.13),('5819','2013-04-03','15:45:00',2.61),('5819','2013-04-03','15:50:00',2.96),('5819','2013-04-03','15:55:00',2.71),('5819','2013-04-03','16:00:00',2.89),('5819','2013-04-03','16:05:00',2.73),('5819','2013-04-03','16:10:00',2.57),('5819','2013-04-03','16:15:00',2.5),('5819','2013-04-03','16:20:00',2.39),('5819','2013-04-03','16:25:00',2.32),('5819','2013-04-03','16:30:00',2.2),('5819','2013-04-03','16:35:00',1.94),('5819','2013-04-03','16:40:00',2.08),('5819','2013-04-03','16:45:00',1.94),('5819','2013-04-03','16:50:00',1.86),('5819','2013-04-03','16:55:00',1.77),('5819','2013-04-03','17:00:00',1.68),('5819','2013-04-03','17:05:00',1.59),('5819','2013-04-03','17:10:00',1.5),('5819','2013-04-03','17:15:00',1.42),('5819','2013-04-03','17:20:00',1.31),('5819','2013-04-03','17:25:00',1.24),('5819','2013-04-03','17:30:00',1.15),('5819','2013-04-03','17:35:00',1.07),('5819','2013-04-02','08:40:00',1.56),('5819','2013-04-02','08:45:00',2.04),('5819','2013-04-02','08:50:00',1.6),('5819','2013-04-02','08:55:00',1.04),('5819','2013-04-02','09:00:00',2.22),('5819','2013-04-02','09:05:00',2.29),('5819','2013-04-02','09:10:00',2.4),('5819','2013-04-02','09:15:00',2.58),('5819','2013-04-02','09:20:00',2.24),('5819','2013-04-02','09:30:00',2.99),('5819','2013-04-02','09:35:00',2.82),('5819','2013-04-02','09:40:00',2.07),('5819','2013-04-02','09:45:00',2.93),('5819','2013-04-02','09:50:00',2.01),('5819','2013-04-02','09:55:00',1.99),('5819','2013-04-02','10:00:00',2.14),('5819','2013-04-02','10:05:00',1.62),('5819','2013-04-02','10:10:00',1.68),('5819','2013-04-02','10:15:00',1.11),('5819','2013-04-02','10:20:00',1.99),('5819','2013-04-02','10:25:00',1.97),('5819','2013-04-02','10:35:00',1.24),('5819','2013-04-02','10:40:00',1.36),('5819','2013-04-02','10:45:00',3.02),('5819','2013-04-02','10:50:00',4.07),('5819','2013-04-02','10:55:00',1.85),('5819','2013-04-02','11:05:00',2.64),('5819','2013-04-02','11:10:00',2.52),('5819','2013-04-02','11:15:00',1.06),('5819','2013-04-02','11:35:00',1.59),('5819','2013-04-02','11:45:00',1.47),('5819','2013-04-02','11:50:00',1.68),('5819','2013-04-02','11:55:00',1.46),('5819','2013-04-02','12:05:00',1.99),('5819','2013-04-02','12:10:00',2.29),('5819','2013-04-02','12:15:00',2.74),('5819','2013-04-02','12:35:00',1.52),('5819','2013-04-02','12:40:00',2.3),('5819','2013-04-02','12:45:00',1.97),('5819','2013-04-02','12:50:00',2.13),('5819','2013-04-02','12:55:00',2.06),('5819','2013-04-02','13:00:00',2.08),('5819','2013-04-02','13:05:00',2.26),('5819','2013-04-02','13:10:00',3.11),('5819','2013-04-02','13:15:00',2.34),('5819','2013-04-02','13:20:00',1.82),('5819','2013-04-02','13:25:00',2.97),('5819','2013-04-02','13:30:00',2.68),('5819','2013-04-02','13:35:00',1.83),('5819','2013-04-02','13:40:00',2.21),('5819','2013-04-02','13:45:00',2.44),('5819','2013-04-02','13:50:00',2.03),('5819','2013-04-02','13:55:00',1.5),('5819','2013-04-02','14:00:00',2.33),('5819','2013-04-02','14:05:00',2.04),('5819','2013-04-02','14:10:00',3.15),('5819','2013-04-02','14:15:00',2.41),('5819','2013-04-02','14:20:00',3.47),('5819','2013-04-02','14:25:00',4.34),('5819','2013-04-02','14:30:00',3.4),('5819','2013-04-02','14:35:00',1.79),('5819','2013-04-02','14:40:00',2.1),('5819','2013-04-02','14:45:00',2.2),('5819','2013-04-02','14:50:00',2),('5819','2013-04-02','14:55:00',1.56),('5819','2013-04-02','15:00:00',1.57),('5819','2013-04-02','15:45:00',1.13),('5819','2013-04-02','16:05:00',1.07),('5819','2013-04-02','16:20:00',1.03),('5819','2013-04-02','17:45:00',1.16),('5819','2014-05-02','07:35:00',1.22),('5819','2014-05-02','07:40:00',1.25),('5819','2014-05-02','07:45:00',1.28),('5819','2014-05-02','07:50:00',1.39),('5819','2014-05-02','08:00:00',1.68),('5819','2014-05-02','08:05:00',1.75),('5819','2014-05-02','08:15:00',1.61),('5819','2014-05-02','08:20:00',2.64),('5819','2014-05-02','08:25:00',1.34),('5819','2014-05-02','08:30:00',1.18),('5819','2014-05-02','08:50:00',1.1),('5819','2014-05-02','09:20:00',1.2),('5819','2014-05-02','09:25:00',1.35),('5819','2014-05-02','09:30:00',1.72),('5819','2014-05-02','09:35:00',1.8),('5819','2014-05-02','09:40:00',1.36),('5819','2014-05-02','09:45:00',1.34),('5819','2014-05-02','09:50:00',1.43),('5819','2014-05-02','09:55:00',1.33),('5819','2014-05-02','10:00:00',1.73),('5819','2014-05-02','10:05:00',1.61),('5819','2014-05-02','10:10:00',1.77),('5819','2014-05-02','10:15:00',1.55),('5819','2014-05-02','10:20:00',1.48),('5819','2014-05-02','10:25:00',1.05),('5819','2014-05-02','10:45:00',1.03),('5819','2014-05-02','10:50:00',1.12),('5819','2014-05-02','12:35:00',1.17),('5819','2014-05-02','12:40:00',1.03),('5819','2014-05-02','12:45:00',1.08),('5819','2014-05-02','12:50:00',1.46),('5819','2014-05-02','12:55:00',1.52),('5819','2014-05-02','13:00:00',1.25),('5819','2014-05-02','13:05:00',1.53),('5819','2014-05-02','13:10:00',1.71),('5819','2014-05-02','13:15:00',1.99),('5819','2014-05-02','13:20:00',2.87),('5819','2014-05-02','13:25:00',2.55),('5819','2014-05-02','13:30:00',2.29),('5819','2014-05-02','13:35:00',2.08),('5819','2014-05-02','13:40:00',2.43),('5819','2014-05-02','13:45:00',1.9),('5819','2014-05-02','13:50:00',1.49),('5819','2014-05-02','13:55:00',1.15),('5819','2014-05-02','14:00:00',1.23),('5819','2014-05-02','14:05:00',1.34),('5819','2014-05-02','14:10:00',1.42),('5819','2014-05-02','14:35:00',1.22),('5819','2014-05-02','14:40:00',3),('5819','2014-05-02','14:45:00',2.19),('5819','2014-05-02','14:50:00',1.34),('5819','2014-05-02','14:55:00',1.67),('5819','2014-05-02','15:00:00',2.11),('5819','2014-05-02','15:05:00',1.89),('5819','2014-05-02','15:10:00',2.87),('5819','2014-05-02','15:15:00',4.18),('5819','2014-05-02','15:20:00',1.9),('5819','2014-05-02','15:25:00',1.68),('5819','2014-05-02','15:30:00',1.07),('5819','2014-05-02','15:35:00',1.97),('5819','2014-05-02','15:40:00',3.05),('5819','2014-05-02','15:45:00',1.41),('5819','2014-05-02','16:00:00',1.01),('5819','2014-05-02','16:05:00',1.77),('5819','2014-05-02','16:10:00',1.18),('5819','2014-05-02','16:20:00',2.5),('5819','2014-05-02','17:25:00',1.07),('5819','2013-04-01','08:25:00',1.51),('5819','2013-04-01','08:30:00',1.67),('5819','2013-04-01','08:35:00',1.86),('5819','2013-04-01','08:40:00',2.1),('5819','2013-04-01','08:45:00',1.04),('5819','2013-04-01','08:50:00',1.39),('5819','2013-04-01','08:55:00',1.83),('5819','2013-04-01','09:00:00',2.21),('5819','2013-04-01','09:05:00',2.29),('5819','2013-04-01','09:10:00',2.46),('5819','2013-04-01','09:15:00',2.52),('5819','2013-04-01','09:20:00',2.11),('5819','2013-04-01','09:25:00',2.33),('5819','2013-04-01','09:30:00',2.74),('5819','2013-04-01','09:35:00',1.41),('5819','2013-04-01','09:40:00',2.85),('5819','2013-04-01','09:45:00',2.14),('5819','2013-04-01','09:50:00',2.66),('5819','2013-04-01','09:55:00',2.75),('5819','2013-04-01','10:00:00',2.97),('5819','2013-04-01','10:05:00',3.15),('5819','2013-04-01','10:10:00',2.86),('5819','2013-04-01','10:15:00',2.37),('5819','2013-04-01','10:20:00',3.09),('5819','2013-04-01','10:25:00',2.88),('5819','2013-04-01','10:30:00',2.57),('5819','2013-04-01','10:35:00',1.37),('5819','2013-04-01','10:40:00',2.12),('5819','2013-04-01','10:45:00',3.79),('5819','2013-04-01','10:50:00',2.58),('5819','2013-04-01','11:00:00',1.48),('5819','2013-04-01','11:05:00',1.19),('5819','2013-04-01','11:10:00',2.26),('5819','2013-04-01','11:15:00',3.23),('5819','2013-04-01','11:20:00',2.44),('5819','2013-04-01','11:25:00',2.64),('5819','2013-04-01','11:30:00',1.58),('5819','2013-04-01','11:35:00',1.8),('5819','2013-04-01','11:40:00',2.89),('5819','2013-04-01','11:45:00',3.07),('5819','2013-04-01','11:50:00',2.57),('5819','2013-04-01','11:55:00',2.09),('5819','2013-04-01','12:00:00',2.84),('5819','2013-04-01','12:05:00',1.87),('5819','2013-04-01','12:10:00',2.15),('5819','2013-04-01','12:15:00',2.03),('5819','2013-04-01','12:20:00',1.68),('5819','2013-04-01','12:25:00',1.75),('5819','2013-04-01','12:30:00',2.38),('5819','2013-04-01','12:35:00',2.23),('5819','2013-04-01','12:40:00',2.19),('5819','2013-04-01','12:45:00',2.48),('5819','2013-04-01','12:50:00',2.6),('5819','2013-04-01','12:55:00',2.94),('5819','2013-04-01','13:00:00',2.78),('5819','2013-04-01','13:05:00',3.06),('5819','2013-04-01','13:10:00',2.87),('5819','2013-04-01','13:15:00',2.72),('5819','2013-04-01','13:20:00',2.66),('5819','2013-04-01','13:25:00',2.44),('5819','2013-04-01','13:30:00',2.84),('5819','2013-04-01','13:35:00',2.45),('5819','2013-04-01','13:40:00',2.87),('5819','2013-04-01','13:45:00',3.34),('5819','2013-04-01','13:50:00',3.71),('5819','2013-04-01','13:55:00',3.9),('5819','2013-04-01','14:00:00',2.27),('5819','2013-04-01','14:05:00',1.67),('5819','2013-04-01','14:10:00',2.06),('5819','2013-04-01','14:15:00',2.36),('5819','2013-04-01','14:20:00',2.37),('5819','2013-04-01','14:25:00',3.79),('5819','2013-04-01','14:30:00',2.79),('5819','2013-04-01','14:35:00',2.07),('5819','2013-04-01','14:40:00',1.87),('5819','2013-04-01','14:45:00',1.76),('5819','2013-04-01','14:50:00',1.91),('5819','2013-04-01','14:55:00',2.08),('5819','2013-04-01','15:00:00',1.84),('5819','2013-04-01','15:05:00',1.82),('5819','2013-04-01','15:10:00',1.84),('5819','2013-04-01','15:15:00',1.98),('5819','2013-04-01','15:20:00',2.03),('5819','2013-04-01','15:25:00',2.04),('5819','2013-04-01','15:30:00',1.75),('5819','2013-04-01','15:35:00',2.2),('5819','2013-04-01','15:40:00',2.09),('5819','2013-04-01','15:45:00',2.11),('5819','2013-04-01','15:50:00',2.45),('5819','2013-04-01','15:55:00',1.97),('5819','2013-04-01','16:00:00',1.75),('5819','2013-04-01','16:05:00',1.45),('5819','2013-04-01','16:10:00',1.23),('5819','2013-03-31','08:35:00',1.17),('5819','2013-03-31','08:45:00',1.34),('5819','2013-03-31','08:50:00',1),('5819','2013-03-31','08:55:00',1.21),('5819','2013-03-31','09:00:00',1.09),('5819','2013-03-31','09:10:00',1.01),('5819','2013-03-31','09:15:00',1.05),('5819','2013-03-31','09:20:00',2.35),('5819','2013-03-31','09:25:00',3.05),('5819','2013-03-31','09:30:00',2.51),('5819','2013-03-31','09:35:00',2.41),('5819','2013-03-31','09:40:00',1.56),('5819','2013-03-31','09:45:00',2.93),('5819','2013-03-31','09:50:00',1.5),('5819','2013-03-31','09:55:00',1.88),('5819','2013-03-31','10:00:00',2.6),('5819','2013-03-31','10:20:00',1.93),('5819','2013-03-31','10:25:00',2.82),('5819','2013-03-31','10:30:00',2.4),('5819','2013-03-31','10:35:00',2.71),('5819','2013-03-31','10:50:00',1.82),('5819','2013-03-31','10:55:00',1.29),('5819','2013-03-31','11:10:00',1.28),('5819','2013-03-31','11:15:00',1.28),('5819','2013-03-31','11:20:00',1.04),('5819','2013-03-31','11:25:00',1.45),('5819','2013-03-31','11:30:00',1.12),('5819','2013-03-31','11:35:00',1.36),('5819','2013-03-31','11:40:00',1.61),('5819','2013-03-31','11:45:00',1.37),('5819','2013-03-31','11:50:00',1.41),('5819','2013-03-31','11:55:00',1.52),('5819','2013-03-31','12:00:00',1.39),('5819','2013-03-31','12:05:00',1.29),('5819','2013-03-31','12:10:00',1.15),('5819','2013-03-31','12:15:00',1.16),('5819','2013-03-31','12:20:00',1.16),('5819','2013-03-31','12:25:00',1.25),('5819','2013-03-31','12:30:00',1.57),('5819','2013-03-31','12:35:00',2.64),('5819','2013-03-31','12:40:00',3.22),('5819','2013-03-31','12:45:00',1.74),('5819','2013-03-31','12:50:00',1.48),('5819','2013-03-31','12:55:00',1.78),('5819','2013-03-31','13:00:00',2.22),('5819','2013-03-31','13:05:00',1.89),('5819','2013-03-31','13:10:00',2.41),('5819','2013-03-31','13:15:00',2.86),('5819','2013-03-31','13:20:00',3.86),('5819','2013-03-31','13:25:00',3.12),('5819','2013-03-31','13:40:00',1.11),('5819','2013-03-31','13:45:00',1.88),('5819','2013-03-31','13:50:00',1.77),('5819','2013-03-31','13:55:00',1.41),('5819','2013-03-31','14:00:00',1.87),('5819','2013-03-31','14:05:00',3.27),('5819','2013-03-31','14:10:00',2.37),('5819','2013-03-31','14:15:00',2.66),('5819','2013-03-31','14:20:00',1.69),('5819','2013-03-31','14:25:00',1.56),('5819','2013-03-31','14:30:00',1.95),('5819','2013-03-31','14:35:00',3.64),('5819','2013-03-31','14:40:00',3.79),('5819','2013-03-31','14:45:00',3.4),('5819','2013-03-31','14:50:00',3.49),('5819','2013-03-31','14:55:00',2.37),('5819','2013-03-31','15:00:00',2.68),('5819','2013-03-31','15:05:00',1.85),('5819','2013-03-31','15:10:00',2.82),('5819','2013-03-31','15:15:00',2.26),('5819','2013-03-31','15:20:00',3.41),('5819','2013-03-31','15:25:00',2.85),('5819','2013-03-31','15:30:00',2.47),('5819','2013-03-31','15:35:00',2.23),('5819','2013-03-31','15:40:00',3.28),('5819','2013-03-31','15:45:00',2.43),('5819','2013-03-31','15:50:00',1.04),('5819','2013-03-31','16:00:00',1.86),('5819','2013-03-31','16:05:00',1.26),('5819','2013-03-31','16:15:00',1.7),('5819','2013-03-31','16:20:00',1.67),('5819','2013-03-31','16:25:00',1.32),('5819','2013-03-31','16:30:00',1.02),('5819','2013-03-31','16:35:00',1.02),('5819','2013-03-31','17:00:00',1.11),('5819','2013-03-31','17:05:00',1.97),('5819','2013-03-31','17:10:00',1.49),('5819','2013-03-31','17:30:00',1.11),('5819','2013-03-31','17:35:00',1.13),('5819','2013-03-31','17:55:00',1.18),('5819','2013-03-30','08:40:00',1.02),('5819','2013-03-30','09:05:00',1.88),('5819','2013-03-30','09:10:00',1.49),('5819','2013-03-30','09:15:00',1.43),('5819','2013-03-30','09:20:00',3.51),('5819','2013-03-30','09:25:00',2.7),('5819','2013-03-30','09:30:00',1.36),('5819','2013-03-30','09:35:00',1.77),('5819','2013-03-30','09:40:00',1.4),('5819','2013-03-30','10:20:00',1.4),('5819','2013-03-30','10:25:00',1.34),('5819','2013-03-30','10:30:00',1.53),('5819','2013-03-30','10:35:00',1.83),('5819','2013-03-30','10:40:00',2.33),('5819','2013-03-30','10:45:00',3.28),('5819','2013-03-30','10:50:00',3.46),('5819','2013-03-30','10:55:00',2.25),('5819','2013-03-30','11:00:00',3.18),('5819','2013-03-30','11:05:00',3.93),('5819','2013-03-30','11:10:00',4.51),('5819','2013-03-30','11:15:00',4.05),('5819','2013-03-30','11:50:00',4.8),('5819','2013-03-30','11:55:00',3.57),('5819','2013-03-30','12:00:00',4.43),('5819','2013-03-30','12:05:00',2.48),('5819','2013-03-30','12:10:00',1.91),('5819','2013-03-30','12:15:00',1.79),('5819','2013-03-30','12:20:00',1.84),('5819','2013-03-30','13:55:00',1.98),('5819','2013-03-30','14:00:00',2.74),('5819','2013-03-30','14:05:00',2.37),('5819','2013-03-30','14:10:00',1.16),('5819','2013-03-30','14:15:00',1.42),('5819','2013-03-30','14:20:00',1.92),('5819','2013-03-30','14:25:00',1.33),('5819','2013-03-30','14:30:00',1.49),('5819','2013-03-30','14:35:00',1.67),('5819','2013-03-30','14:40:00',1.05),('5819','2013-03-30','14:45:00',1.1),('5819','2013-03-30','14:50:00',1.44),('5819','2013-03-29','07:10:00',1.1),('5819','2013-03-29','07:15:00',1.18),('5819','2013-03-29','07:20:00',1.29),('5819','2013-03-29','07:25:00',1.41),('5819','2013-03-29','07:30:00',1.56),('5819','2013-03-29','07:35:00',1.36),('5819','2013-03-29','07:40:00',1.69),('5819','2013-03-29','07:45:00',1.82),('5819','2013-03-29','07:50:00',1.78),('5819','2013-03-29','07:55:00',1.05),('5819','2013-03-29','08:00:00',1.49),('5819','2013-03-29','08:05:00',1.98),('5819','2013-03-29','08:10:00',2.3),('5819','2013-03-29','08:16:00',2.27),('5819','2013-03-29','08:20:00',2.35),('5819','2013-03-29','08:25:00',2.41),('5819','2013-03-29','08:30:00',2.49),('5819','2013-03-29','08:35:00',2.59),('5819','2013-03-29','08:40:00',2.66),('5819','2013-03-29','08:45:00',2.65),('5819','2013-03-29','08:50:00',2.69),('5819','2013-03-29','08:55:00',2.6),('5819','2013-03-29','09:00:00',2.52),('5819','2013-03-29','09:05:00',2.73),('5819','2013-03-29','09:10:00',2.8),('5819','2013-03-29','09:15:00',3.14),('5819','2013-03-29','09:20:00',3.3),('5819','2013-03-29','09:25:00',3.05),('5819','2013-03-29','09:30:00',3.43),('5819','2013-03-29','09:35:00',3.49),('5819','2013-03-29','09:40:00',3.27),('5819','2013-03-29','09:45:00',3.15),('5819','2013-03-29','09:50:00',3.42),('5819','2013-03-29','09:55:00',3.3),('5819','2013-03-29','10:00:00',3.39),('5819','2013-03-29','10:05:00',2.91),('5819','2013-03-29','10:10:00',2.68),('5819','2013-03-29','10:15:00',3.3),('5819','2013-03-29','10:20:00',3.06),('5819','2013-03-29','10:25:00',3.12),('5819','2013-03-29','10:30:00',3.02),('5819','2013-03-29','10:35:00',2.66),('5819','2013-03-29','10:40:00',3.01),('5819','2013-03-29','10:45:00',2.01),('5819','2013-03-29','10:50:00',2.74),('5819','2013-03-29','10:55:00',2.61),('5819','2013-03-29','11:00:00',3.89),('5819','2013-03-29','11:05:00',3.82),('5819','2013-03-29','11:10:00',4.29),('5819','2013-03-29','11:15:00',3.13),('5819','2013-03-29','11:20:00',2.04),('5819','2013-03-29','11:25:00',2.3),('5819','2013-03-29','11:30:00',4.18),('5819','2013-03-29','11:35:00',3.03),('5819','2013-03-29','11:40:00',4.1),('5819','2013-03-29','11:45:00',4.03),('5819','2013-03-29','11:50:00',4.02),('5819','2013-03-29','11:55:00',4.01),('5819','2013-03-29','12:00:00',4),('5819','2013-03-29','12:05:00',4.09),('5819','2013-03-29','12:10:00',4.03),('5819','2013-03-29','12:15:00',3.76),('5819','2013-03-29','12:20:00',4.01),('5819','2013-03-29','12:25:00',3.76),('5819','2013-03-29','12:30:00',3.51),('5819','2013-03-29','12:35:00',3.7),('5819','2013-03-29','12:40:00',3.92),('5819','2013-03-29','12:45:00',3.38),('5819','2013-03-29','12:50:00',3.13),('5819','2013-03-29','12:55:00',2.86),('5819','2013-03-29','13:00:00',3.53),('5819','2013-03-29','13:05:00',2.39),('5819','2013-03-29','13:10:00',3.57),('5819','2013-03-29','13:15:00',3.1),('5819','2013-03-29','13:20:00',3.23),('5819','2013-03-29','13:25:00',3.96),('5819','2013-03-29','13:30:00',3.5),('5819','2013-03-29','13:35:00',3),('5819','2013-03-29','13:40:00',3.05),('5819','2013-03-29','13:45:00',2.92),('5819','2013-03-29','13:50:00',3.1),('5819','2013-03-29','13:55:00',3.04),('5819','2013-03-29','14:00:00',3.09),('5819','2013-03-29','14:05:00',2.69),('5819','2013-03-29','14:10:00',2.12),('5819','2013-03-29','14:15:00',2.16),('5819','2013-03-29','14:20:00',2.16),('5819','2013-03-29','14:25:00',2.17),('5819','2013-03-29','14:30:00',1.87),('5819','2013-03-29','14:35:00',1.88),('5819','2013-03-29','14:40:00',1.82),('5819','2013-03-29','14:45:00',1.72),('5819','2013-03-29','14:50:00',1.62),('5819','2013-03-29','14:55:00',1.56),('5819','2013-03-29','15:00:00',1.42),('5819','2013-03-29','15:05:00',1.44),('5819','2013-03-29','15:10:00',1.36),('5819','2013-03-29','15:15:00',1.3),('5819','2013-03-29','15:20:00',1.26),('5819','2013-03-29','15:25:00',1.14),('5819','2013-03-29','15:30:00',1.06),('5819','2013-03-29','15:35:00',1.01),('5819','2013-03-29','15:55:00',1.08),('5819','2013-03-29','16:00:00',1.24),('5819','2013-03-29','16:05:00',1.19),('5819','2013-03-29','16:40:00',1.37),('5819','2013-03-29','16:45:00',1.19),('5819','2013-03-28','09:15:00',2.76),('5819','2013-03-28','09:20:00',1.58),('5819','2013-03-28','09:25:00',1.46),('5819','2013-03-28','09:30:00',1.19),('5819','2013-03-28','09:55:00',1.02),('5819','2013-03-28','10:00:00',1.15),('5819','2013-03-28','11:35:00',1.03),('5819','2013-03-28','11:40:00',1.64),('5819','2013-03-28','11:45:00',1.3),('5819','2013-03-28','11:50:00',1.03),('5819','2013-03-28','11:55:00',1.83),('5819','2013-03-28','12:00:00',1.61),('5819','2013-03-28','12:05:00',1.11),('5819','2013-03-28','12:10:00',1.02),('5819','2013-03-28','12:20:00',1.14),('5819','2013-03-28','12:40:00',1.17),('5819','2013-03-28','12:45:00',1.5),('5819','2013-03-28','12:50:00',2.73),('5819','2013-03-28','12:55:00',3.21),('5819','2013-03-28','13:00:00',2.98),('5819','2013-03-28','13:05:00',3.85),('5819','2013-03-28','13:10:00',2.94),('5819','2013-03-28','13:15:00',3.07),('5819','2013-03-28','13:20:00',3.46),('5819','2013-03-28','13:25:00',3.08),('5819','2013-03-28','13:30:00',3.22),('5819','2013-03-28','13:35:00',2.46),('5819','2013-03-28','13:40:00',2.15),('5819','2013-03-28','13:45:00',1.91),('5819','2013-03-28','13:50:00',3.02),('5819','2013-03-28','13:55:00',1.57),('5819','2013-03-28','14:00:00',1.74),('5819','2013-03-28','14:05:00',2.35),('5819','2013-03-28','14:10:00',1.83),('5819','2013-03-28','14:15:00',1.39),('5819','2013-03-28','14:20:00',1.36),('5819','2013-03-28','14:25:00',1.39),('5819','2013-03-28','14:30:00',1.66),('5819','2013-03-28','14:35:00',1.56),('5819','2013-03-28','14:40:00',1.14),('5819','2013-03-28','14:45:00',1.08),('5819','2013-03-28','14:50:00',1.04),('5819','2013-03-28','15:00:00',1.04),('5819','2013-03-28','15:05:00',1.13),('5819','2013-03-28','15:10:00',1.77),('5819','2013-03-28','15:15:00',2.24),('5819','2013-03-28','15:20:00',1.52),('5819','2013-03-28','15:25:00',1.81),('5819','2013-03-28','15:30:00',1.19),('5819','2013-03-28','15:35:00',1.86),('5819','2013-03-28','15:40:00',1.52),('5819','2013-03-28','15:45:00',1.82),('5819','2013-03-28','15:50:00',1.18),('5819','2013-03-28','15:55:00',2.18),('5819','2013-03-28','16:00:00',1.37),('5819','2013-03-28','16:10:00',1.14),('5819','2013-03-28','16:35:00',1.15),('5819','2013-03-27','07:10:00',1),('5819','2013-03-27','07:15:00',1.08),('5819','2013-03-27','07:20:00',1.2),('5819','2013-03-27','07:25:00',1.31),('5819','2013-03-27','07:30:00',1.39),('5819','2013-03-27','07:35:00',1.33),('5819','2013-03-27','07:40:00',1.48),('5819','2013-03-27','07:55:00',1.42),('5819','2013-03-27','08:00:00',1.35),('5819','2013-03-27','08:05:00',1.62),('5819','2013-03-27','08:10:00',1.31),('5819','2013-03-27','08:15:00',1.48),('5819','2013-03-27','08:20:00',1.31),('5819','2013-03-27','08:25:00',1.49),('5819','2013-03-27','08:30:00',1.98),('5819','2013-03-27','08:35:00',2),('5819','2013-03-27','08:40:00',1.49),('5819','2013-03-27','08:45:00',1.28),('5819','2013-03-27','08:50:00',1.75),('5819','2013-03-27','08:55:00',1.33),('5819','2013-03-27','09:00:00',1.4),('5819','2013-03-27','09:05:00',1.1),('5819','2013-03-27','09:15:00',1.49),('5819','2013-03-27','09:20:00',2.01),('5819','2013-03-27','09:25:00',1.26),('5819','2013-03-27','09:30:00',1),('5819','2013-03-27','09:45:00',1.42),('5819','2013-03-27','09:50:00',2.15),('5819','2013-03-27','09:55:00',1.91),('5819','2013-03-27','10:00:00',1.37),('5819','2013-03-27','10:05:00',1.04),('5819','2013-03-27','10:10:00',1.22),('5819','2013-03-27','10:15:00',1.72),('5819','2013-03-27','10:20:00',1.46),('5819','2013-03-27','10:25:00',1.7),('5819','2013-03-27','10:30:00',2.12),('5819','2013-03-27','10:35:00',1.76),('5819','2013-03-27','10:40:00',1.72),('5819','2013-03-27','10:45:00',2.15),('5819','2013-03-27','10:50:00',1.86),('5819','2013-03-27','10:55:00',1.8),('5819','2013-03-27','11:00:00',1.5),('5819','2013-03-27','11:05:00',1.46),('5819','2013-03-27','11:10:00',1.61),('5819','2013-03-27','11:15:00',1.69),('5819','2013-03-27','11:20:00',1.77),('5819','2013-03-27','11:25:00',1.65),('5819','2013-03-27','11:30:00',1.88),('5819','2013-03-27','11:35:00',1.79),('5819','2013-03-27','11:40:00',1.76),('5819','2013-03-27','11:45:00',1.64),('5819','2013-03-27','11:50:00',1.6),('5819','2013-03-27','11:55:00',2.34),('5819','2013-03-27','12:00:00',2.73),('5819','2013-03-27','12:05:00',2.63),('5819','2013-03-27','12:10:00',2.41),('5819','2013-03-27','12:15:00',1.79),('5819','2013-03-27','12:20:00',1.77),('5819','2013-03-27','12:25:00',1.61),('5819','2013-03-27','12:30:00',2.74),('5819','2013-03-27','12:35:00',4.15),('5819','2013-03-27','12:40:00',3.61),('5819','2013-03-27','12:45:00',4.62),('5819','2013-03-27','12:50:00',2.63),('5819','2013-03-27','12:55:00',2.46),('5819','2013-03-27','13:00:00',1.64),('5819','2013-03-27','13:05:00',1.6),('5819','2013-03-27','13:10:00',2.07),('5819','2013-03-27','13:15:00',1.76),('5819','2013-03-27','13:20:00',1.43),('5819','2013-03-27','13:25:00',1.24),('5819','2013-03-27','13:30:00',1.62),('5819','2013-03-27','13:35:00',2),('5819','2013-03-27','13:40:00',1.8),('5819','2013-03-27','13:45:00',2.03),('5819','2013-03-27','13:50:00',2.26),('5819','2013-03-27','13:55:00',2.28),('5819','2013-03-27','14:00:00',1.66),('5819','2013-03-27','14:05:00',1.39),('5819','2013-03-27','14:10:00',1.47),('5819','2013-03-27','14:15:00',1.66),('5819','2013-03-27','14:20:00',2.03),('5819','2013-03-27','14:25:00',1.63),('5819','2013-03-27','14:30:00',1.4),('5819','2013-03-27','14:35:00',1.47),('5819','2013-03-27','14:40:00',1.89),('5819','2013-03-27','14:45:00',1.94),('5819','2013-03-27','14:50:00',1.43),('5819','2013-03-27','14:55:00',1.24),('5819','2013-03-27','15:00:00',1.14),('5819','2013-03-27','15:05:00',1.35),('5819','2013-03-27','15:10:00',1.6),('5819','2013-03-27','15:20:00',1),('5819','2013-03-27','15:25:00',1.09),('5819','2013-03-27','17:05:00',1.02),('5819','2013-03-26','07:45:00',1.02),('5819','2013-03-26','07:50:00',1.62),('5819','2013-03-26','07:55:00',2.48),('5819','2013-03-26','08:35:00',1.25),('5819','2013-03-26','08:40:00',1.38),('5819','2013-03-26','09:15:00',1.32),('5819','2013-03-26','09:20:00',1.03),('5819','2013-03-26','09:55:00',2.36),('5819','2013-03-26','10:00:00',1.59),('5819','2013-03-26','11:00:00',1.01),('5819','2013-03-26','11:05:00',1),('5819','2013-03-26','11:10:00',2.32),('5819','2013-03-26','11:15:00',1.7),('5819','2013-03-26','11:20:00',1.47),('5819','2013-03-26','11:50:00',1.1),('5819','2013-03-26','12:05:00',1.15),('5819','2013-03-26','12:10:00',1.2),('5819','2013-03-26','12:15:00',1.29),('5819','2013-03-26','12:20:00',1.4),('5819','2013-03-26','12:25:00',2.29),('5819','2013-03-26','12:30:00',2.13),('5819','2013-03-26','12:35:00',2.63),('5819','2013-03-26','12:40:00',1.65),('5819','2013-03-26','12:45:00',2.76),('5819','2013-03-26','12:50:00',1.95),('5819','2013-03-26','12:55:00',1.07),('5819','2013-03-26','13:00:00',1.2),('5819','2013-03-26','13:05:00',2.24),('5819','2013-03-26','13:10:00',1.99),('5819','2013-03-26','13:15:00',2),('5819','2013-03-26','13:20:00',1.44),('5819','2013-03-26','13:25:00',2.07),('5819','2013-03-26','13:30:00',1.48),('5819','2013-03-26','13:35:00',1.79),('5819','2013-03-26','13:40:00',2.09),('5819','2013-03-26','13:45:00',1.87),('5819','2013-03-26','13:50:00',1.65),('5819','2013-03-26','13:55:00',1.5),('5819','2013-03-26','14:00:00',1.45),('5819','2013-03-26','14:05:00',1.38),('5819','2013-03-26','14:10:00',1.42),('5819','2013-03-26','14:15:00',1.34),('5819','2013-03-26','14:20:00',1.17),('5819','2013-03-26','14:25:00',1.01),('5819','2013-03-25','08:20:00',1.04),('5819','2013-03-25','08:25:00',1.82),('5819','2013-03-25','08:30:00',1.31),('5819','2013-03-25','08:55:00',1.01),('5819','2013-03-25','09:00:00',1.09),('5819','2013-03-25','09:05:00',1.07),('5819','2013-03-25','09:10:00',1.05),('5819','2013-03-25','09:20:00',2.36),('5819','2013-03-25','09:25:00',3.14),('5819','2013-03-25','09:30:00',1.57),('5819','2013-03-25','09:35:00',1.03),('5819','2013-03-25','09:50:00',2.73),('5819','2013-03-25','09:55:00',3.81),('5819','2013-03-25','10:00:00',2.58),('5819','2013-03-25','10:05:00',1.21),('5819','2013-03-25','10:20:00',1.34),('5819','2013-03-25','10:25:00',2.09),('5819','2013-03-25','10:30:00',2.57),('5819','2013-03-25','10:35:00',1.32),('5819','2013-03-25','10:40:00',1.6),('5819','2013-03-25','10:45:00',2.32),('5819','2013-03-25','10:50:00',1.93),('5819','2013-03-25','10:55:00',2.27),('5819','2013-03-25','11:00:00',2.14),('5819','2013-03-25','11:05:00',1.84),('5819','2013-03-25','11:10:00',1.77),('5819','2013-03-25','11:15:00',1.75),('5819','2013-03-25','11:20:00',3.65),('5819','2013-03-25','11:25:00',3.45),('5819','2013-03-25','11:30:00',2.76),('5819','2013-03-25','11:35:00',2.39),('5819','2013-03-25','11:40:00',1.46),('5819','2013-03-25','11:45:00',1.61),('5819','2013-03-25','11:50:00',1.64),('5819','2013-03-25','11:55:00',2.55),('5819','2013-03-25','12:00:00',3.94),('5819','2013-03-25','12:05:00',3.29),('5819','2013-03-25','12:10:00',3.62),('5819','2013-03-25','12:15:00',3.95),('5819','2013-03-25','12:20:00',2.8),('5819','2013-03-25','12:25:00',3.52),('5819','2013-03-25','12:30:00',3.81),('5819','2013-03-25','12:35:00',2.88),('5819','2013-03-25','12:40:00',2.31),('5819','2013-03-25','12:45:00',2.48),('5819','2013-03-25','12:50:00',2.79),('5819','2013-03-25','12:55:00',2.73),('5819','2013-03-25','13:00:00',2.26),('5819','2013-03-25','13:05:00',4.02),('5819','2013-03-25','13:10:00',3.52),('5819','2013-03-25','13:15:00',3.41),('5819','2013-03-25','13:20:00',3.86),('5819','2013-03-25','13:25:00',2.43),('5819','2013-03-25','13:30:00',1.85),('5819','2013-03-25','13:35:00',1.17),('5819','2013-03-25','13:40:00',1.11),('5819','2013-03-25','13:45:00',1.72),('5819','2013-03-25','13:50:00',2.03),('5819','2013-03-25','13:55:00',1.84),('5819','2013-03-25','14:00:00',1.06),('5819','2013-03-25','14:10:00',2.36),('5819','2013-03-25','14:15:00',1.94),('5819','2013-03-25','14:20:00',2.06),('5819','2013-03-25','14:25:00',2.51),('5819','2013-03-25','14:30:00',3.33),('5819','2013-03-25','14:35:00',2.29),('5819','2013-03-25','14:40:00',1.36),('5819','2013-03-25','14:45:00',1.41),('5819','2013-03-25','14:50:00',1.56),('5819','2013-03-25','14:55:00',2.26),('5819','2013-03-25','15:00:00',2.07),('5819','2013-03-25','15:05:00',1.98),('5819','2013-03-25','15:10:00',1.83),('5819','2013-03-25','15:15:00',1.63),('5819','2013-03-25','15:20:00',2.15),('5819','2013-03-25','15:25:00',2.66),('5819','2013-03-25','15:30:00',1.9),('5819','2013-03-25','15:35:00',2.35),('5819','2013-03-25','15:40:00',1.55),('5819','2013-03-25','15:45:00',1.21),('5819','2013-03-25','16:00:00',1.58),('5819','2013-03-25','16:05:00',1.09),('5819','2013-03-25','16:10:00',1.01),('5819','2013-03-25','16:15:00',1.2),('5819','2013-03-25','16:35:00',1.19),('5819','2013-03-25','16:40:00',1.45),('5819','2013-03-24','07:25:00',1.02),('5819','2013-03-24','07:35:00',1.02),('5819','2013-03-24','07:40:00',1.08),('5819','2013-03-24','07:45:00',1.17),('5819','2013-03-24','07:50:00',1.38),('5819','2013-03-24','07:55:00',1.55),('5819','2013-03-24','08:00:00',1.87),('5819','2013-03-24','08:05:00',1.98),('5819','2013-03-24','08:10:00',2.02),('5819','2013-03-24','08:15:00',2.14),('5819','2013-03-24','08:20:00',2.24),('5819','2013-03-24','08:25:00',2.32),('5819','2013-03-24','08:30:00',2.38),('5819','2013-03-24','08:35:00',2.45),('5819','2013-03-24','08:40:00',2.53),('5819','2013-03-24','08:45:00',2.57),('5819','2013-03-24','08:50:00',2.6),('5819','2013-03-24','08:55:00',2.65),('5819','2013-03-24','09:00:00',2.71),('5819','2013-03-24','09:05:00',2.8),('5819','2013-03-24','09:10:00',2.88),('5819','2013-03-24','09:15:00',2.93),('5819','2013-03-24','09:20:00',2.98),('5819','2013-03-24','09:25:00',3.02),('5819','2013-03-24','09:30:00',3.07),('5819','2013-03-24','09:35:00',3.1),('5819','2013-03-24','09:40:00',3.14),('5819','2013-03-24','09:45:00',3.18),('5819','2013-03-24','09:50:00',3.24),('5819','2013-03-24','09:55:00',3.27),('5819','2013-03-24','10:00:00',3.31),('5819','2013-03-24','10:05:00',3.37),('5819','2013-03-24','10:10:00',3.4),('5819','2013-03-24','10:15:00',3.44),('5819','2013-03-24','10:20:00',3.47),('5819','2013-03-24','10:25:00',3.48),('5819','2013-03-24','10:30:00',3.53),('5819','2013-03-24','10:35:00',3.53),('5819','2013-03-24','10:40:00',3.54),('5819','2013-03-24','10:45:00',3.55),('5819','2013-03-24','10:50:00',3.54),('5819','2013-03-24','10:55:00',3.57),('5819','2013-03-24','11:00:00',3.58),('5819','2013-03-24','11:05:00',3.62),('5819','2013-03-24','11:10:00',3.63),('5819','2013-03-24','11:15:00',3.61),('5819','2013-03-24','11:20:00',3.61),('5819','2013-03-24','11:25:00',3.63),('5819','2013-03-24','11:30:00',3.66),('5819','2013-03-24','11:35:00',3.64),('5819','2013-03-24','11:40:00',3.64),('5819','2013-03-24','11:45:00',3.65),('5819','2013-03-24','11:50:00',3.66),('5819','2013-03-24','11:55:00',3.66),('5819','2013-03-24','12:00:00',3.68),('5819','2013-03-24','12:05:00',3.67),('5819','2013-03-24','12:10:00',3.69),('5819','2013-03-24','12:15:00',3.72),('5819','2013-03-24','12:20:00',3.76),('5819','2013-03-24','12:25:00',3.79),('5819','2013-03-24','12:30:00',3.75),('5819','2013-03-24','12:35:00',3.76),('5819','2013-03-24','12:40:00',3.74),('5819','2013-03-24','12:45:00',3.72),('5819','2013-03-24','12:50:00',3.7),('5819','2013-03-24','12:55:00',3.65),('5819','2013-03-24','13:00:00',3.61),('5819','2013-03-24','13:05:00',3.62),('5819','2013-03-24','13:10:00',3.57),('5819','2013-03-24','13:15:00',3.56),('5819','2013-03-24','13:20:00',3.53),('5819','2013-03-24','13:25:00',3.46),('5819','2013-03-24','13:30:00',3.41),('5819','2013-03-24','13:35:00',3.38),('5819','2013-03-24','13:40:00',3.34),('5819','2013-03-24','13:45:00',3.29),('5819','2013-03-24','13:50:00',3.26),('5819','2013-03-24','13:55:00',3.22),('5819','2013-03-24','14:00:00',3.16),('5819','2013-03-24','14:05:00',3.11),('5819','2013-03-24','14:10:00',3.03),('5819','2013-03-24','14:15:00',2.98),('5819','2013-03-24','14:20:00',2.92),('5819','2013-03-24','14:25:00',2.85),('5819','2013-03-24','14:30:00',2.77),('5819','2013-03-24','14:35:00',2.65),('5819','2013-03-24','14:40:00',2.61),('5819','2013-03-24','14:45:00',2.55),('5819','2013-03-24','14:50:00',2.44),('5819','2013-03-24','14:55:00',2.4),('5819','2013-03-24','15:00:00',2.32),('5819','2013-03-24','15:05:00',2.25),('5819','2013-03-24','15:10:00',2.11),('5819','2013-03-24','15:15:00',2.27),('5819','2013-03-24','15:20:00',2.17),('5819','2013-03-24','15:25:00',2.04),('5819','2013-03-24','15:30:00',1.83),('5819','2013-03-24','15:35:00',1.79),('5819','2013-03-24','15:40:00',1.78),('5819','2013-03-24','15:45:00',1.57),('5819','2013-03-24','15:50:00',1.09),('5819','2013-03-24','15:55:00',1.08),('5819','2013-03-24','16:00:00',1.04),('5819','2013-03-24','16:05:00',1.23),('5819','2013-03-24','16:15:00',1.15),('5819','2013-03-24','16:20:00',1.01),('5819','2013-03-23','07:15:00',1.09),('5819','2013-03-23','07:20:00',1.15),('5819','2013-03-23','07:25:00',1.18),('5819','2013-03-23','07:30:00',1.22),('5819','2013-03-23','07:35:00',1.25),('5819','2013-03-23','07:40:00',1.42),('5819','2013-03-23','07:45:00',1.43),('5819','2013-03-23','07:50:00',1.56),('5819','2013-03-23','07:55:00',1.73),('5819','2013-03-23','08:00:00',1.89),('5819','2013-03-23','08:05:00',2.06),('5819','2013-03-23','08:10:00',2.13),('5819','2013-03-23','08:15:00',2.21),('5819','2013-03-23','08:20:00',2.27),('5819','2013-03-23','08:25:00',2.34),('5819','2013-03-23','08:30:00',2.35),('5819','2013-03-23','08:35:00',2.44),('5819','2013-03-23','08:40:00',2.54),('5819','2013-03-23','08:45:00',2.61),('5819','2013-03-23','08:50:00',2.66),('5819','2013-03-23','08:55:00',2.81),('5819','2013-03-23','09:00:00',2.85),('5819','2013-03-23','09:05:00',2.92),('5819','2013-03-23','09:10:00',2.91),('5819','2013-03-23','09:15:00',3.03),('5819','2013-03-23','09:20:00',3),('5819','2013-03-23','09:25:00',3.11),('5819','2013-03-23','09:30:00',3.2),('5819','2013-03-23','09:35:00',3.19),('5819','2013-03-23','09:40:00',3.05),('5819','2013-03-23','09:45:00',3.24),('5819','2013-03-23','09:50:00',3.32),('5819','2013-03-23','09:55:00',3.41),('5819','2013-03-23','10:00:00',3.43),('5819','2013-03-23','10:05:00',3.45),('5819','2013-03-23','10:10:00',3.51),('5819','2013-03-23','10:15:00',3.46),('5819','2013-03-23','10:20:00',3.43),('5819','2013-03-23','10:25:00',3.38),('5819','2013-03-23','10:30:00',3.62),('5819','2013-03-23','10:35:00',3.64),('5819','2013-03-23','10:40:00',3.61),('5819','2013-03-23','10:45:00',3.59),('5819','2013-03-23','10:50:00',3.57),('5819','2013-03-23','10:55:00',3.43),('5819','2013-03-23','11:00:00',3.36),('5819','2013-03-23','11:05:00',3.18),('5819','2013-03-23','11:10:00',2.73),('5819','2013-03-23','11:15:00',2.89),('5819','2013-03-23','11:20:00',3.54),('5819','2013-03-23','11:25:00',3.53),('5819','2013-03-23','11:30:00',3.51),('5819','2013-03-23','11:35:00',3.67),('5819','2013-03-23','11:40:00',3.67),('5819','2013-03-23','11:45:00',3.68),('5819','2013-03-23','11:50:00',3.51),('5819','2013-03-23','11:55:00',3.68),('5819','2013-03-23','12:00:00',3.68),('5819','2013-03-23','12:05:00',3.64),('5819','2013-03-23','12:10:00',3.61),('5819','2013-03-23','12:15:00',3.67),('5819','2013-03-23','12:20:00',3.67),('5819','2013-03-23','12:25:00',3.65),('5819','2013-03-23','12:30:00',3.68),('5819','2013-03-23','12:35:00',3.67),('5819','2013-03-23','12:40:00',3.47),('5819','2013-03-23','12:45:00',3.54),('5819','2013-03-23','12:50:00',3.61),('5819','2013-03-23','12:55:00',3.54),('5819','2013-03-23','13:00:00',2.67),('5819','2013-03-23','13:05:00',3.45),('5819','2013-03-23','13:10:00',3.49),('5819','2013-03-23','13:15:00',3.31),('5819','2013-03-23','13:20:00',3.38),('5819','2013-03-23','13:25:00',3.37),('5819','2013-03-23','13:30:00',3.22),('5819','2013-03-23','13:35:00',3.01),('5819','2013-03-23','13:40:00',3.22),('5819','2013-03-23','13:45:00',2.59),('5819','2013-03-23','13:50:00',3.1),('5819','2013-03-23','13:55:00',3.1),('5819','2013-03-23','14:00:00',3.04),('5819','2013-03-23','14:05:00',3.02),('5819','2013-03-23','14:10:00',2.95),('5819','2013-03-23','14:15:00',2.85),('5819','2013-03-23','14:20:00',2.91),('5819','2013-03-23','14:25:00',2.86),('5819','2013-03-23','14:30:00',2.84),('5819','2013-03-23','14:35:00',2.73),('5819','2013-03-23','14:40:00',2.64),('5819','2013-03-23','14:45:00',2.45),('5819','2013-03-23','14:50:00',2.41),('5819','2013-03-23','14:55:00',2.42),('5819','2013-03-23','15:00:00',2.31),('5819','2013-03-23','15:05:00',2.18),('5819','2013-03-23','15:10:00',2.24),('5819','2013-03-23','15:15:00',2.07),('5819','2013-03-23','15:20:00',2.07),('5819','2013-03-23','15:25:00',2.04),('5819','2013-03-23','15:30:00',1.82),('5819','2013-03-23','15:35:00',1.81),('5819','2013-03-23','15:40:00',1.67),('5819','2013-03-23','15:45:00',1.58),('5819','2013-03-23','15:50:00',1.46),('5819','2013-03-23','15:55:00',1.41),('5819','2013-03-23','16:00:00',1.32),('5819','2013-03-23','16:05:00',1.17),('5819','2013-03-23','16:10:00',1.45),('5819','2013-03-23','16:15:00',1.33),('5819','2013-03-23','16:20:00',1.11),('5819','2013-03-23','16:25:00',1.09),('5819','2013-03-22','07:15:00',1.06),('5819','2013-03-22','07:20:00',1.17),('5819','2013-03-22','07:25:00',1.27),('5819','2013-03-22','07:30:00',1.36),('5819','2013-03-22','07:35:00',1.47),('5819','2013-03-22','07:40:00',1.57),('5819','2013-03-22','07:45:00',1.66),('5819','2013-03-22','07:50:00',1.73),('5819','2013-03-22','07:55:00',1.82),('5819','2013-03-22','08:00:00',1.9),('5819','2013-03-22','08:05:00',2),('5819','2013-03-22','08:10:00',2.09),('5819','2013-03-22','08:15:00',2.18),('5819','2013-03-22','08:20:00',2.27),('5819','2013-03-22','08:25:00',2.36),('5819','2013-03-22','08:30:00',2.44),('5819','2013-03-22','08:35:00',2.51),('5819','2013-03-22','08:40:00',2.58),('5819','2013-03-22','08:45:00',2.64),('5819','2013-03-22','08:50:00',2.7),('5819','2013-03-22','08:55:00',2.77),('5819','2013-03-22','09:00:00',2.83),('5819','2013-03-22','09:05:00',2.89),('5819','2013-03-22','09:10:00',2.94),('5819','2013-03-22','09:15:00',3.01),('5819','2013-03-22','09:20:00',3.02),('5819','2013-03-22','09:25:00',3.11),('5819','2013-03-22','09:30:00',3.16),('5819','2013-03-22','09:35:00',3.22),('5819','2013-03-22','09:40:00',3.3),('5819','2013-03-22','09:45:00',3.3),('5819','2013-03-22','09:50:00',3.39),('5819','2013-03-22','09:55:00',3.38),('5819','2013-03-22','10:00:00',3.44),('5819','2013-03-22','10:05:00',3.42),('5819','2013-03-22','10:10:00',3.47),('5819','2013-03-22','10:15:00',3.5),('5819','2013-03-22','10:20:00',3.47),('5819','2013-03-22','10:25:00',3.56),('5819','2013-03-22','10:30:00',3.66),('5819','2013-03-22','10:35:00',3.7),('5819','2013-03-22','10:40:00',3.77),('5819','2013-03-22','10:45:00',3.79),('5819','2013-03-22','10:50:00',3.8),('5819','2013-03-22','10:55:00',3.82),('5819','2013-03-22','11:00:00',3.79),('5819','2013-03-22','11:05:00',3.81),('5819','2013-03-22','11:10:00',3.83),('5819','2013-03-22','11:15:00',3.84),('5819','2013-03-22','11:20:00',3.86),('5819','2013-03-22','11:25:00',3.86),('5819','2013-03-22','11:30:00',3.88),('5819','2013-03-22','11:35:00',3.91),('5819','2013-03-22','11:40:00',3.87),('5819','2013-03-22','11:45:00',3.94),('5819','2013-03-22','11:50:00',3.9),('5819','2013-03-22','11:55:00',3.93),('5819','2013-03-22','12:00:00',3.93),('5819','2013-03-22','12:05:00',3.92),('5819','2013-03-22','12:10:00',3.9),('5819','2013-03-22','12:15:00',3.88),('5819','2013-03-22','12:20:00',3.86),('5819','2013-03-22','12:25:00',3.84),('5819','2013-03-22','12:30:00',3.84),('5819','2013-03-22','12:35:00',3.85),('5819','2013-03-22','12:40:00',3.86),('5819','2013-03-22','12:45:00',3.82),('5819','2013-03-22','12:50:00',3.7),('5819','2013-03-22','12:55:00',3.44),('5819','2013-03-22','13:00:00',3.77),('5819','2013-03-22','13:05:00',3.62),('5819','2013-03-22','13:10:00',3.73),('5819','2013-03-22','13:15:00',3.68),('5819','2013-03-22','13:20:00',3.61),('5819','2013-03-22','13:25:00',3.44),('5819','2013-03-22','13:30:00',3.36),('5819','2013-03-22','13:35:00',3.44),('5819','2013-03-22','13:40:00',2.87),('5819','2013-03-22','13:45:00',2.98),('5819','2013-03-22','13:50:00',3.45),('5819','2013-03-22','13:55:00',3.36),('5819','2013-03-22','14:00:00',3.27),('5819','2013-03-22','14:05:00',3.21),('5819','2013-03-22','14:10:00',3.17),('5819','2013-03-22','14:15:00',3.12),('5819','2013-03-22','14:20:00',3.05),('5819','2013-03-22','14:25:00',2.97),('5819','2013-03-22','14:30:00',2.92),('5819','2013-03-22','14:35:00',2.85),('5819','2013-03-22','14:40:00',2.76),('5819','2013-03-22','14:45:00',2.71),('5819','2013-03-22','14:50:00',2.65),('5819','2013-03-22','14:55:00',2.58),('5819','2013-03-22','15:00:00',2.53),('5819','2013-03-22','15:05:00',2.45),('5819','2013-03-22','15:10:00',2.17),('5819','2013-03-22','15:15:00',1.79),('5819','2013-03-22','15:20:00',1.74),('5819','2013-03-22','15:25:00',1.87),('5819','2013-03-22','15:30:00',1.68),('5819','2013-03-22','15:35:00',1.84),('5819','2013-03-22','15:40:00',1.76),('5819','2013-03-22','15:45:00',1.53),('5819','2013-03-22','15:50:00',1.62),('5819','2013-03-22','15:55:00',1.4),('5819','2013-03-22','16:10:00',1.13),('5819','2013-03-22','16:15:00',1.32),('5819','2013-03-22','16:20:00',1.08),('5819','2013-03-22','16:30:00',1.11),('5819','2013-03-22','16:35:00',1.09),('5819','2013-03-22','16:40:00',1.05),('5819','2013-03-21','07:45:00',1.37),('5819','2013-03-21','07:50:00',1.89),('5819','2013-03-21','07:55:00',1.02),('5819','2013-03-21','08:10:00',1.59),('5819','2013-03-21','08:15:00',2.33),('5819','2013-03-21','08:20:00',2.36),('5819','2013-03-21','08:25:00',2.36),('5819','2013-03-21','08:30:00',2.54),('5819','2013-03-21','08:35:00',2.61),('5819','2013-03-21','08:40:00',2.66),('5819','2013-03-21','08:45:00',2.71),('5819','2013-03-21','08:50:00',2.82),('5819','2013-03-21','08:55:00',2.89),('5819','2013-03-21','09:00:00',3),('5819','2013-03-21','09:05:00',3.14),('5819','2013-03-21','09:10:00',3.48),('5819','2013-03-21','09:15:00',2.3),('5819','2013-03-21','09:20:00',2.8),('5819','2013-03-21','09:25:00',3.42),('5819','2013-03-21','09:30:00',3.42),('5819','2013-03-21','09:35:00',3.42),('5819','2013-03-21','09:40:00',3.47),('5819','2013-03-21','09:45:00',3.51),('5819','2013-03-21','09:50:00',3.03),('5819','2013-03-21','09:55:00',3.67),('5819','2013-03-21','10:00:00',3.69),('5819','2013-03-21','10:05:00',3.72),('5819','2013-03-21','10:10:00',3.76),('5819','2013-03-21','10:15:00',3.77),('5819','2013-03-21','10:20:00',3.81),('5819','2013-03-21','10:25:00',3.81),('5819','2013-03-21','10:30:00',3.82),('5819','2013-03-21','10:35:00',3.87),('5819','2013-03-21','10:40:00',3.9),('5819','2013-03-21','10:45:00',3.89),('5819','2013-03-21','10:50:00',3.87),('5819','2013-03-21','10:55:00',2.7),('5819','2013-03-21','11:00:00',4.01),('5819','2013-03-21','11:05:00',3.98),('5819','2013-03-21','11:10:00',4.01),('5819','2013-03-21','11:15:00',4.03),('5819','2013-03-21','11:20:00',4.05),('5819','2013-03-21','11:25:00',4.07),('5819','2013-03-21','11:30:00',4.07),('5819','2013-03-21','11:35:00',4.08),('5819','2013-03-21','11:40:00',4.07),('5819','2013-03-21','11:45:00',4.08),('5819','2013-03-21','11:50:00',4.1),('5819','2013-03-21','11:55:00',4.09),('5819','2013-03-21','12:00:00',4.09),('5819','2013-03-21','12:05:00',4.09),('5819','2013-03-21','12:10:00',4.08),('5819','2013-03-21','12:15:00',4.07),('5819','2013-03-21','12:20:00',4.03),('5819','2013-03-21','12:25:00',4.02),('5819','2013-03-21','12:30:00',4),('5819','2013-03-21','12:35:00',4.01),('5819','2013-03-21','12:40:00',3.98),('5819','2013-03-21','12:45:00',3.95),('5819','2013-03-21','12:50:00',3.92),('5819','2013-03-21','12:55:00',3.87),('5819','2013-03-21','13:00:00',3.85),('5819','2013-03-21','13:05:00',3.8),('5819','2013-03-21','13:10:00',3.76),('5819','2013-03-21','13:15:00',3.71),('5819','2013-03-21','13:20:00',3.68),('5819','2013-03-21','13:25:00',3.66),('5819','2013-03-21','13:30:00',3.63),('5819','2013-03-21','13:35:00',3.58),('5819','2013-03-21','13:40:00',3.54),('5819','2013-03-21','13:45:00',3.49),('5819','2013-03-21','13:50:00',3.44),('5819','2013-03-21','13:55:00',3.38),('5819','2013-03-21','14:00:00',3.33),('5819','2013-03-21','14:05:00',3.26),('5819','2013-03-21','14:10:00',3.19),('5819','2013-03-21','14:15:00',3.12),('5819','2013-03-21','14:20:00',3.07),('5819','2013-03-21','14:25:00',3.02),('5819','2013-03-21','14:30:00',2.94),('5819','2013-03-21','14:35:00',2.87),('5819','2013-03-21','14:40:00',2.8),('5819','2013-03-21','14:45:00',2.73),('5819','2013-03-21','14:50:00',2.67),('5819','2013-03-21','14:55:00',2.62),('5819','2013-03-21','15:00:00',2.53),('5819','2013-03-21','15:05:00',2.46),('5819','2013-03-21','15:10:00',2.38),('5819','2013-03-21','15:15:00',2.31),('5819','2013-03-21','15:20:00',2.22),('5819','2013-03-21','15:25:00',2.13),('5819','2013-03-21','15:30:00',2.05),('5819','2013-03-21','15:35:00',1.97),('5819','2013-03-21','15:40:00',1.88),('5819','2013-03-21','15:45:00',1.79),('5819','2013-03-21','15:50:00',1.7),('5819','2013-03-21','15:55:00',1.61),('5819','2013-03-21','16:00:00',1.52),('5819','2013-03-21','16:05:00',1.44),('5819','2013-03-21','16:10:00',1.35),('5819','2013-03-21','16:15:00',1.27),('5819','2013-03-21','16:20:00',1.19),('5819','2013-03-21','16:25:00',1.1),('5819','2013-03-21','16:30:00',1.01),('5819','2013-03-20','07:15:00',1.02),('5819','2013-03-20','07:20:00',1.11),('5819','2013-03-20','07:25:00',1.22),('5819','2013-03-20','07:30:00',1.33),('5819','2013-03-20','07:35:00',1.45),('5819','2013-03-20','07:40:00',1.49),('5819','2013-03-20','07:45:00',1.53),('5819','2013-03-20','07:50:00',1.56),('5819','2013-03-20','07:55:00',1.74),('5819','2013-03-20','08:00:00',1.74),('5819','2013-03-20','08:05:00',1.7),('5819','2013-03-20','08:10:00',2.04),('5819','2013-03-20','08:15:00',2.14),('5819','2013-03-20','08:20:00',2.21),('5819','2013-03-20','08:25:00',2.31),('5819','2013-03-20','08:30:00',2.4),('5819','2013-03-20','08:35:00',2.39),('5819','2013-03-20','08:40:00',2.27),('5819','2013-03-20','08:45:00',2.47),('5819','2013-03-20','08:50:00',2.59),('5819','2013-03-20','08:55:00',2.53),('5819','2013-03-20','09:00:00',2.47),('5819','2013-03-20','09:05:00',3.22),('5819','2013-03-20','09:10:00',2.61),('5819','2013-03-20','09:15:00',2.92),('5819','2013-03-20','09:20:00',2.89),('5819','2013-03-20','09:25:00',2.98),('5819','2013-03-20','09:30:00',3.18),('5819','2013-03-20','09:35:00',3.09),('5819','2013-03-20','09:40:00',3.23),('5819','2013-03-20','09:45:00',3.31),('5819','2013-03-20','09:50:00',3.32),('5819','2013-03-20','09:55:00',3.29),('5819','2013-03-20','10:00:00',3.4),('5819','2013-03-20','10:05:00',3.39),('5819','2013-03-20','10:10:00',3.3),('5819','2013-03-20','10:15:00',2.54),('5819','2013-03-20','10:20:00',2.81),('5819','2013-03-20','10:25:00',2.45),('5819','2013-03-20','10:30:00',3.08),('5819','2013-03-20','10:35:00',3.49),('5819','2013-03-20','10:40:00',3.16),('5819','2013-03-20','10:45:00',2.25),('5819','2013-03-20','10:50:00',3.21),('5819','2013-03-20','10:55:00',2.9),('5819','2013-03-20','11:00:00',2.78),('5819','2013-03-20','11:05:00',2.94),('5819','2013-03-20','11:10:00',2.73),('5819','2013-03-20','11:15:00',2.27),('5819','2013-03-20','11:20:00',2.6),('5819','2013-03-20','11:25:00',2.54),('5819','2013-03-20','11:30:00',2.33),('5819','2013-03-20','11:35:00',2.57),('5819','2013-03-20','11:40:00',2.11),('5819','2013-03-20','11:45:00',1.96),('5819','2013-03-20','11:50:00',1.86),('5819','2013-03-20','11:55:00',2.11),('5819','2013-03-20','12:00:00',2.01),('5819','2013-03-20','12:05:00',2.27),('5819','2013-03-20','12:10:00',1.86),('5819','2013-03-20','12:15:00',1.61),('5819','2013-03-20','12:20:00',1.52),('5819','2013-03-20','12:25:00',1.28),('5819','2013-03-20','12:35:00',1.19),('5819','2013-03-20','12:50:00',1.3),('5819','2013-03-20','12:55:00',1.5),('5819','2013-03-20','13:00:00',1.72),('5819','2013-03-20','13:05:00',1.25),('5819','2013-03-20','13:10:00',1.32),('5819','2013-03-20','13:15:00',1.04),('5819','2013-03-20','13:20:00',1.13),('5819','2013-03-20','13:25:00',1.23),('5819','2013-03-20','13:30:00',1.37),('5819','2013-03-20','13:35:00',1.29),('5819','2013-03-20','13:40:00',1.57),('5819','2013-03-20','13:45:00',1.89),('5819','2013-03-20','13:50:00',1.6),('5819','2013-03-20','13:55:00',1.47),('5819','2013-03-20','14:00:00',1.48),('5819','2013-03-20','14:05:00',1.28),('5819','2013-03-20','14:10:00',1.17),('5819','2013-03-20','14:15:00',1.51),('5819','2013-03-20','14:20:00',1.92),('5819','2013-03-20','14:25:00',1.79),('5819','2013-03-20','14:30:00',1.55),('5819','2013-03-20','14:35:00',1.29),('5819','2013-03-20','14:40:00',1.02),('5819','2013-03-19','07:10:00',1.1),('5819','2013-03-19','07:15:00',1.19),('5819','2013-03-19','07:20:00',1.09),('5819','2013-03-19','07:25:00',1.18),('5819','2013-03-19','07:30:00',1.27),('5819','2013-03-19','07:35:00',1.36),('5819','2013-03-19','07:40:00',1.46),('5819','2013-03-19','07:45:00',1.56),('5819','2013-03-19','07:50:00',1.68),('5819','2013-03-19','07:55:00',1.71),('5819','2013-03-19','08:00:00',1.25),('5819','2013-03-19','08:05:00',1.64),('5819','2013-03-19','08:10:00',1.96),('5819','2013-03-19','08:15:00',2.15),('5819','2013-03-19','08:20:00',2.21),('5819','2013-03-19','08:25:00',2.27),('5819','2013-03-19','08:30:00',2.12),('5819','2013-03-19','08:35:00',2.49),('5819','2013-03-19','08:40:00',2.55),('5819','2013-03-19','08:45:00',2.64),('5819','2013-03-19','08:50:00',2.75),('5819','2013-03-19','08:55:00',2.79),('5819','2013-03-19','09:00:00',2.86),('5819','2013-03-19','09:05:00',2.78),('5819','2013-03-19','09:10:00',3.02),('5819','2013-03-19','09:15:00',3.04),('5819','2013-03-19','09:20:00',2.57),('5819','2013-03-19','09:25:00',2.91),('5819','2013-03-19','09:30:00',3.28),('5819','2013-03-19','09:35:00',3.32),('5819','2013-03-19','09:40:00',3.42),('5819','2013-03-19','09:45:00',3.57),('5819','2013-03-19','09:50:00',3.55),('5819','2013-03-19','09:55:00',2.89),('5819','2013-03-19','10:00:00',3.75),('5819','2013-03-19','10:05:00',3.2),('5819','2013-03-19','10:10:00',3.36),('5819','2013-03-19','10:15:00',3.69),('5819','2013-03-19','10:20:00',3.73),('5819','2013-03-19','10:25:00',3.82),('5819','2013-03-19','10:30:00',3.82),('5819','2013-03-19','10:35:00',3.84),('5819','2013-03-19','10:40:00',3.86),('5819','2013-03-19','10:45:00',3.9),('5819','2013-03-19','10:50:00',3.93),('5819','2013-03-19','10:55:00',3.89),('5819','2013-03-19','11:00:00',4),('5819','2013-03-19','11:05:00',3.99),('5819','2013-03-19','11:10:00',3.95),('5819','2013-03-19','11:15:00',4.02),('5819','2013-03-19','11:20:00',4.02),('5819','2013-03-19','11:25:00',4.01),('5819','2013-03-19','11:30:00',3.98),('5819','2013-03-19','11:35:00',2.6),('5819','2013-03-19','11:40:00',3.47),('5819','2013-03-19','11:45:00',3.77),('5819','2013-03-19','11:50:00',3.96),('5819','2013-03-19','11:55:00',4.11),('5819','2013-03-19','12:00:00',4.04),('5819','2013-03-19','12:05:00',3.94),('5819','2013-03-19','12:10:00',4),('5819','2013-03-19','12:15:00',3.81),('5819','2013-03-19','12:20:00',3.97),('5819','2013-03-19','12:25:00',3.88),('5819','2013-03-19','12:30:00',3.89),('5819','2013-03-19','12:35:00',3.86),('5819','2013-03-19','12:40:00',3.86),('5819','2013-03-19','12:45:00',3.88),('5819','2013-03-19','12:50:00',3.72),('5819','2013-03-19','12:55:00',3.66),('5819','2013-03-19','13:00:00',3.77),('5819','2013-03-19','13:05:00',3.73),('5819','2013-03-19','13:10:00',3.67),('5819','2013-03-19','13:15:00',3.65),('5819','2013-03-19','13:20:00',3.6),('5819','2013-03-19','13:25:00',3.56),('5819','2013-03-19','13:30:00',3.54),('5819','2013-03-19','13:35:00',3.48),('5819','2013-03-19','13:40:00',3.42),('5819','2013-03-19','13:45:00',3.41),('5819','2013-03-19','13:50:00',3.36),('5819','2013-03-19','13:55:00',3.3),('5819','2013-03-19','14:00:00',3.26),('5819','2013-03-19','14:05:00',3.2),('5819','2013-03-19','14:10:00',3.15),('5819','2013-03-19','14:15:00',3.11),('5819','2013-03-19','14:20:00',3.04),('5819','2013-03-19','14:25:00',2.98),('5819','2013-03-19','14:30:00',2.89),('5819','2013-03-19','14:35:00',2.83),('5819','2013-03-19','14:40:00',2.78),('5819','2013-03-19','14:45:00',2.72),('5819','2013-03-19','14:50:00',2.64),('5819','2013-03-19','14:55:00',2.55),('5819','2013-03-19','15:00:00',2.48),('5819','2013-03-19','15:05:00',2.42),('5819','2013-03-19','15:10:00',2.33),('5819','2013-03-19','15:15:00',2.25),('5819','2013-03-19','15:20:00',2.19),('5819','2013-03-19','15:25:00',2.11),('5819','2013-03-19','15:30:00',2.02),('5819','2013-03-19','15:35:00',1.95),('5819','2013-03-19','15:40:00',1.87),('5819','2013-03-19','15:45:00',1.78),('5819','2013-03-19','15:50:00',1.69),('5819','2013-03-19','15:55:00',1.61),('5819','2013-03-19','16:00:00',1.51),('5819','2013-03-19','16:05:00',1.43),('5819','2013-03-19','16:10:00',1.34),('5819','2013-03-19','16:15:00',1.25),('5819','2013-03-19','16:20:00',1.18),('5819','2013-03-19','16:25:00',1.11),('5819','2013-03-19','16:30:00',1.03),('5819','2013-03-18','10:00:00',1.08),('5819','2013-03-18','10:05:00',1.37),('5819','2013-03-18','10:10:00',1.38),('5819','2013-03-18','10:15:00',1.2),('5819','2013-03-18','10:20:00',1.47),('5819','2013-03-18','10:25:00',1.87),('5819','2013-03-18','10:30:00',1.8),('5819','2013-03-18','10:35:00',1.41),('5819','2013-03-18','10:40:00',1.28),('5819','2013-03-18','10:45:00',1.32),('5819','2013-03-18','10:50:00',1.3),('5819','2013-03-18','10:55:00',1.08),('5819','2013-03-18','11:00:00',1.15),('5819','2013-03-18','11:05:00',1.28),('5819','2013-03-18','11:10:00',1.45),('5819','2013-03-18','11:15:00',1.58),('5819','2013-03-18','11:20:00',1.64),('5819','2013-03-18','11:25:00',1.72),('5819','2013-03-18','11:30:00',2.16),('5819','2013-03-18','11:35:00',1.83),('5819','2013-03-18','11:40:00',1.64),('5819','2013-03-18','11:45:00',1.4),('5819','2013-03-18','11:50:00',1.13),('5819','2013-03-18','11:55:00',1.3),('5819','2013-03-18','12:00:00',1.39),('5819','2013-03-18','12:05:00',2.33),('5819','2013-03-18','12:10:00',2.26),('5819','2013-03-18','12:15:00',2.61),('5819','2013-03-18','12:20:00',2.62),('5819','2013-03-18','12:25:00',1.74),('5819','2013-03-18','12:30:00',3.05),('5819','2013-03-18','12:35:00',3.23),('5819','2013-03-18','12:40:00',2.88),('5819','2013-03-18','12:45:00',2.38),('5819','2013-03-18','12:50:00',3.35),('5819','2013-03-18','12:55:00',3.55),('5819','2013-03-18','13:00:00',2.39),('5819','2013-03-18','13:05:00',1.39),('5819','2013-03-18','13:25:00',1.54),('5819','2013-03-18','13:30:00',1.29),('5819','2013-03-18','13:35:00',1.02),('5819','2013-03-18','13:40:00',1.62),('5819','2013-03-18','13:45:00',1.56),('5819','2013-03-18','13:50:00',1.53),('5819','2013-03-18','13:55:00',1.44),('5819','2013-03-18','14:00:00',1.51),('5819','2013-03-18','14:05:00',2.33),('5819','2013-03-18','14:10:00',2.29),('5819','2013-03-18','14:15:00',1.22),('5819','2013-03-18','14:20:00',1.05),('5819','2013-03-18','14:25:00',1.5),('5819','2013-03-18','14:40:00',1.12),('5819','2013-03-18','14:45:00',1.04),('5819','2013-03-18','15:00:00',1.02),('5819','2013-03-17','08:15:00',1.18),('5819','2013-03-17','08:20:00',1.37),('5819','2013-03-17','08:25:00',1.6),('5819','2013-03-17','08:30:00',1.54),('5819','2013-03-17','08:35:00',1.2),('5819','2013-03-17','08:40:00',1.21),('5819','2013-03-17','08:45:00',1.41),('5819','2013-03-17','08:50:00',1.42),('5819','2013-03-17','08:55:00',1.32),('5819','2013-03-17','09:00:00',1.27),('5819','2013-03-17','09:05:00',1.48),('5819','2013-03-17','09:10:00',1.7),('5819','2013-03-17','09:15:00',1.86),('5819','2013-03-17','09:20:00',1.58),('5819','2013-03-17','09:25:00',1.31),('5819','2013-03-17','09:30:00',1.37),('5819','2013-03-17','09:35:00',1.64),('5819','2013-03-17','09:40:00',1.47),('5819','2013-03-17','09:45:00',1.49),('5819','2013-03-17','09:50:00',1.67),('5819','2013-03-17','09:55:00',1.82),('5819','2013-03-17','10:00:00',1.99),('5819','2013-03-17','10:05:00',1.68),('5819','2013-03-17','10:10:00',1.61),('5819','2013-03-17','10:15:00',1.77),('5819','2013-03-17','10:20:00',1.78),('5819','2013-03-17','10:25:00',1.87),('5819','2013-03-17','10:30:00',1.83),('5819','2013-03-17','10:35:00',1.73),('5819','2013-03-17','10:40:00',1.64),('5819','2013-03-17','10:45:00',1.72),('5819','2013-03-17','10:50:00',1.7),('5819','2013-03-17','10:55:00',1.5),('5819','2013-03-17','11:00:00',1.55),('5819','2013-03-17','11:05:00',1.36),('5819','2013-03-17','11:10:00',1.27),('5819','2013-03-17','11:15:00',1.31),('5819','2013-03-17','11:20:00',1.52),('5819','2013-03-17','11:25:00',1.61),('5819','2013-03-17','11:30:00',1.42),('5819','2013-03-17','11:35:00',1.4),('5819','2013-03-17','11:40:00',1.33),('5819','2013-03-17','11:45:00',1.25),('5819','2013-03-17','11:50:00',1.16),('5819','2013-03-17','11:55:00',1.03),('5819','2013-03-17','12:05:00',1.01),('5819','2013-03-17','12:10:00',1.27),('5819','2013-03-17','12:15:00',1.72),('5819','2013-03-17','12:20:00',2.12),('5819','2013-03-17','12:25:00',3.18),('5819','2013-03-17','12:30:00',3.64),('5819','2013-03-17','12:35:00',2.52),('5819','2013-03-17','12:40:00',2.72),('5819','2013-03-17','12:45:00',2.41),('5819','2013-03-17','12:50:00',2.11),('5819','2013-03-17','12:55:00',1.62),('5819','2013-03-17','13:00:00',1.83),('5819','2013-03-17','13:05:00',2.06),('5819','2013-03-17','13:10:00',2.25),('5819','2013-03-17','13:15:00',2.21),('5819','2013-03-17','13:20:00',1.87),('5819','2013-03-17','13:25:00',1.66),('5819','2013-03-17','13:30:00',2.41),('5819','2013-03-17','13:35:00',2.84),('5819','2013-03-17','13:40:00',1.9),('5819','2013-03-17','13:45:00',1.74),('5819','2013-03-17','13:50:00',1.34),('5819','2013-03-17','13:55:00',1.87),('5819','2013-03-17','14:00:00',2),('5819','2013-03-17','14:05:00',1.89),('5819','2013-03-17','14:10:00',2.24),('5819','2013-03-17','14:15:00',2.51),('5819','2013-03-17','14:20:00',2.16),('5819','2013-03-17','14:25:00',2.29),('5819','2013-03-17','14:30:00',2.1),('5819','2013-03-17','14:35:00',1.75),('5819','2013-03-17','14:40:00',1.41),('5819','2013-03-17','14:45:00',1.21),('5819','2013-03-17','14:50:00',1.06),('5819','2013-03-17','14:55:00',1.1),('5819','2013-03-17','15:00:00',1.37),('5819','2013-03-17','15:05:00',1.45),('5819','2013-03-17','15:10:00',1.83),('5819','2013-03-17','15:15:00',1.54),('5819','2013-03-17','15:20:00',1.54),('5819','2013-03-17','15:25:00',1.58),('5819','2013-03-17','15:30:00',1.13),('5819','2013-03-17','15:35:00',1.23),('5819','2013-03-17','15:40:00',1.19),('5819','2013-03-17','15:45:00',1.4),('5819','2013-03-16','08:05:00',1.09),('5819','2013-03-16','08:15:00',1.57),('5819','2013-03-16','08:20:00',2.27),('5819','2013-03-16','08:25:00',2.55),('5819','2013-03-16','08:30:00',2.51),('5819','2013-03-16','08:35:00',2.58),('5819','2013-03-16','08:40:00',2.65),('5819','2013-03-16','08:45:00',2.36),('5819','2013-03-16','08:50:00',2.83),('5819','2013-03-16','08:55:00',2.99),('5819','2013-03-16','09:00:00',2.89),('5819','2013-03-16','09:05:00',2.49),('5819','2013-03-16','09:10:00',2.4),('5819','2013-03-16','09:15:00',3.15),('5819','2013-03-16','09:20:00',3.31),('5819','2013-03-16','09:25:00',3.23),('5819','2013-03-16','09:30:00',3.32),('5819','2013-03-16','09:35:00',3.48),('5819','2013-03-16','09:40:00',3.62),('5819','2013-03-16','09:45:00',3.62),('5819','2013-03-16','09:50:00',3.62),('5819','2013-03-16','09:55:00',3.68),('5819','2013-03-16','10:00:00',2.93),('5819','2013-03-16','10:05:00',1.87),('5819','2013-03-16','10:10:00',2.79),('5819','2013-03-16','10:15:00',2.71),('5819','2013-03-16','10:20:00',1.88),('5819','2013-03-16','10:25:00',2.36),('5819','2013-03-16','10:30:00',2.03),('5819','2013-03-16','10:35:00',1.58),('5819','2013-03-16','10:40:00',2.83),('5819','2013-03-16','10:45:00',3.97),('5819','2013-03-16','10:50:00',3.94),('5819','2013-03-16','10:55:00',3.76),('5819','2013-03-16','11:00:00',3.96),('5819','2013-03-16','11:05:00',3.97),('5819','2013-03-16','11:10:00',3.97),('5819','2013-03-16','11:15:00',3.98),('5819','2013-03-16','11:20:00',3.96),('5819','2013-03-16','11:25:00',3.97),('5819','2013-03-16','11:30:00',3.96),('5819','2013-03-16','11:35:00',3.94),('5819','2013-03-16','11:40:00',3.97),('5819','2013-03-16','11:45:00',3.96),('5819','2013-03-16','11:50:00',3.98),('5819','2013-03-16','11:55:00',3.96),('5819','2013-03-16','12:00:00',3.95),('5819','2013-03-16','12:05:00',3.92),('5819','2013-03-16','12:10:00',3.9),('5819','2013-03-16','12:15:00',3.89),('5819','2013-03-16','12:20:00',3.87),('5819','2013-03-16','12:25:00',3.88),('5819','2013-03-16','12:30:00',3.86),('5819','2013-03-16','12:35:00',3.83),('5819','2013-03-16','12:40:00',3.79),('5819','2013-03-16','12:45:00',3.8),('5819','2013-03-16','12:50:00',3.75),('5819','2013-03-16','12:55:00',3.73),('5819','2013-03-16','13:00:00',3.7),('5819','2013-03-16','13:05:00',3.66),('5819','2013-03-16','13:10:00',3.62),('5819','2013-03-16','13:15:00',3.61),('5819','2013-03-16','13:20:00',1.66),('5819','2013-03-16','13:30:00',1.82),('5819','2013-03-16','13:35:00',3.64),('5819','2013-03-16','13:40:00',3.53),('5819','2013-03-16','13:45:00',3.46),('5819','2013-03-16','13:50:00',3.45),('5819','2013-03-16','13:55:00',3.11),('5819','2013-03-16','14:00:00',3.39),('5819','2013-03-16','14:05:00',3.31),('5819','2013-03-16','14:10:00',1.71),('5819','2013-03-16','14:15:00',2.41),('5819','2013-03-16','14:20:00',2.09),('5819','2013-03-16','14:25:00',1.31),('5819','2013-03-16','14:30:00',2.98),('5819','2013-03-16','14:35:00',2.95),('5819','2013-03-16','14:40:00',1.27),('5819','2013-03-16','15:40:00',1),('5819','2013-03-16','16:05:00',1.11),('5819','2013-03-16','16:10:00',1.12),('5819','2013-03-16','16:15:00',1.03),('5819','2013-03-15','10:40:00',1.09),('5819','2013-03-15','10:45:00',1.31),('5819','2013-03-15','10:50:00',1.3),('5819','2013-03-15','10:55:00',1.38),('5819','2013-03-15','11:00:00',1.34),('5819','2013-03-15','11:05:00',1.25),('5819','2013-03-15','11:10:00',1.13),('5819','2013-03-15','11:20:00',1.16),('5819','2013-03-15','11:25:00',1.36),('5819','2013-03-15','11:30:00',1.52),('5819','2013-03-15','11:35:00',1.8),('5819','2013-03-15','11:40:00',2.14),('5819','2013-03-15','11:45:00',2.02),('5819','2013-03-15','11:50:00',1.89),('5819','2013-03-15','11:55:00',1.94),('5819','2013-03-15','12:00:00',1.72),('5819','2013-03-15','12:05:00',1.74),('5819','2013-03-15','12:10:00',1.81),('5819','2013-03-15','12:15:00',1.6),('5819','2013-03-15','12:20:00',1.6),('5819','2013-03-15','12:25:00',1.6),('5819','2013-03-15','12:30:00',1.65),('5819','2013-03-15','12:35:00',1.84),('5819','2013-03-15','12:40:00',1.7),('5819','2013-03-15','12:45:00',1.49),('5819','2013-03-15','12:50:00',1.4),('5819','2013-03-15','12:55:00',1.32),('5819','2013-03-15','13:00:00',1.24),('5819','2013-03-15','13:05:00',1.13),('5819','2013-03-15','13:10:00',1.18),('5819','2013-03-15','13:15:00',1.27),('5819','2013-03-15','13:20:00',1.35),('5819','2013-03-15','13:25:00',1.49),('5819','2013-03-15','13:30:00',1.46),('5819','2013-03-15','13:35:00',1.34),('5819','2013-03-15','13:40:00',1.39),('5819','2013-03-15','13:45:00',1.47),('5819','2013-03-15','13:50:00',1.24),('5819','2013-03-15','13:55:00',1.09),('5819','2013-03-15','14:00:00',1),('5819','2013-03-15','14:55:00',1.01),('5819','2013-03-15','15:00:00',1.06),('5819','2013-03-15','15:05:00',1.05),('5819','2013-03-15','15:10:00',1.04),('5819','2013-03-15','15:15:00',1.13),('5819','2013-03-15','15:20:00',1.12),('5819','2013-03-15','15:25:00',1.19),('5819','2013-03-15','15:30:00',1.11),('5819','2013-03-14','13:00:00',1.06),('5819','2013-03-14','13:05:00',1.12),('5819','2013-03-14','13:15:00',1.01),('5819','2013-03-14','13:20:00',1.1),('5819','2013-03-14','13:25:00',1.1),('5819','2013-03-14','13:30:00',1.03),('5819','2013-03-14','13:40:00',1.11),('5819','2013-03-14','13:45:00',1.55),('5819','2013-03-14','13:50:00',1.84),('5819','2013-03-14','13:55:00',2.19),('5819','2013-03-14','14:00:00',1.82),('5819','2013-03-14','14:05:00',1.83),('5819','2013-03-14','14:10:00',1.41),('5819','2013-03-14','14:15:00',1.18),('5819','2013-03-14','14:20:00',1.02),('5819','2013-03-14','14:25:00',1.01),('5819','2013-03-14','14:30:00',1.02),('5819','2013-03-14','15:10:00',1.2),('5819','2013-03-14','15:15:00',1.23),('5819','2013-03-14','15:20:00',1.13),('5819','2013-03-14','15:25:00',1.11),('5819','2013-03-14','15:30:00',1.07),('5819','2013-03-13','08:50:00',1.05),('5819','2013-03-13','08:55:00',1.08),('5819','2013-03-13','09:10:00',1.18),('5819','2013-03-13','09:15:00',1.06),('5819','2013-03-13','09:20:00',1.08),('5819','2013-03-13','10:10:00',1.06),('5819','2013-03-13','10:15:00',2.18),('5819','2013-03-13','10:20:00',1.68),('5819','2013-03-13','10:25:00',1.68),('5819','2013-03-13','10:30:00',3.68),('5819','2013-03-13','10:35:00',2.44),('5819','2013-03-13','10:40:00',2.69),('5819','2013-03-13','10:45:00',1.46),('5819','2013-03-13','10:50:00',1.21),('5819','2013-03-13','10:55:00',1.13),('5819','2013-03-13','11:00:00',1.11),('5819','2013-03-13','11:30:00',1.03),('5819','2013-03-13','11:35:00',1.07),('5819','2013-03-13','11:40:00',1.06),('5819','2013-03-13','11:45:00',1.14),('5819','2013-03-13','11:50:00',1.07),('5819','2013-03-13','12:50:00',1.19),('5819','2013-03-13','12:55:00',1.07),('5819','2013-03-13','13:00:00',1.01),('5819','2013-03-13','13:05:00',1.01),('5819','2013-03-12','08:20:00',1.62),('5819','2013-03-12','08:25:00',1.95),('5819','2013-03-12','08:30:00',2.13),('5819','2013-03-12','08:35:00',2.08),('5819','2013-03-12','08:40:00',2.24),('5819','2013-03-12','08:45:00',2.55),('5819','2013-03-12','08:50:00',1.88),('5819','2013-03-12','09:00:00',1.45),('5819','2013-03-12','09:05:00',2.79),('5819','2013-03-12','09:10:00',2.84),('5819','2013-03-12','09:15:00',2.86),('5819','2013-03-12','09:20:00',2.9),('5819','2013-03-12','09:25:00',2.97),('5819','2013-03-12','09:30:00',3.04),('5819','2013-03-12','09:35:00',3.12),('5819','2013-03-12','09:40:00',3.16),('5819','2013-03-12','09:45:00',3.21),('5819','2013-03-12','09:50:00',2.07),('5819','2013-03-12','09:55:00',3.54),('5819','2013-03-12','10:00:00',3.37),('5819','2013-03-12','10:05:00',3.4),('5819','2013-03-12','10:10:00',2.72),('5819','2013-03-12','10:15:00',2.72),('5819','2013-03-12','10:20:00',3.5),('5819','2013-03-12','10:25:00',3.38),('5819','2013-03-12','10:30:00',3.89),('5819','2013-03-12','10:35:00',2.39),('5819','2013-03-12','10:40:00',2.92),('5819','2013-03-12','10:45:00',1.94),('5819','2013-03-12','10:50:00',3.31),('5819','2013-03-12','10:55:00',3.48),('5819','2013-03-12','11:00:00',3.41),('5819','2013-03-12','11:05:00',4.22),('5819','2013-03-12','11:10:00',3.08),('5819','2013-03-12','11:15:00',3.38),('5819','2013-03-12','11:20:00',4.05),('5819','2013-03-12','11:25:00',1.92),('5819','2013-03-12','11:30:00',1.48),('5819','2013-03-12','11:35:00',1.63),('5819','2013-03-12','11:40:00',2),('5819','2013-03-12','11:45:00',2.12),('5819','2013-03-12','11:50:00',2.51),('5819','2013-03-12','11:55:00',3.89),('5819','2013-03-12','12:05:00',1.04),('5819','2013-03-12','12:10:00',3.35),('5819','2013-03-12','12:15:00',3.8),('5819','2013-03-12','12:20:00',1.75),('5819','2013-03-12','12:25:00',3.44),('5819','2013-03-12','12:30:00',4.53),('5819','2013-03-12','12:35:00',3.24),('5819','2013-03-12','12:40:00',3.6),('5819','2013-03-12','12:45:00',1.12),('5819','2013-03-12','12:50:00',1.55),('5819','2013-03-12','12:55:00',1.82),('5819','2013-03-12','13:00:00',3.19),('5819','2013-03-12','13:05:00',2.17),('5819','2013-03-12','13:10:00',2.31),('5819','2013-03-12','13:15:00',2.12),('5819','2013-03-12','13:20:00',2.87),('5819','2013-03-12','13:25:00',1.99),('5819','2013-03-12','13:30:00',1.39),('5819','2013-03-12','13:35:00',1.53),('5819','2013-03-12','13:40:00',1.38),('5819','2013-03-12','13:50:00',1.03),('5819','2013-03-12','13:55:00',1.47),('5819','2013-03-12','14:00:00',1.77),('5819','2013-03-12','14:05:00',2.23),('5819','2013-03-12','14:10:00',2.29),('5819','2013-03-12','14:20:00',1.07),('5819','2013-03-11','07:30:00',1.01),('5819','2013-03-11','08:10:00',1.13),('5819','2013-03-11','08:15:00',1.91),('5819','2013-03-11','08:20:00',2),('5819','2013-03-11','08:25:00',2.09),('5819','2013-03-11','08:30:00',2.18),('5819','2013-03-11','08:35:00',2.28),('5819','2013-03-11','08:40:00',2.34),('5819','2013-03-11','08:45:00',2.41),('5819','2013-03-11','08:50:00',2.49),('5819','2013-03-11','08:55:00',2.57),('5819','2013-03-11','09:00:00',2.61),('5819','2013-03-11','09:05:00',2.7),('5819','2013-03-11','09:10:00',2.67),('5819','2013-03-11','09:15:00',2.83),('5819','2013-03-11','09:20:00',2.38),('5819','2013-03-11','09:25:00',2.09),('5819','2013-03-11','09:30:00',1.15),('5819','2013-03-11','09:35:00',2.55),('5819','2013-03-11','09:40:00',3.44),('5819','2013-03-11','09:45:00',3.08),('5819','2013-03-11','09:50:00',1.37),('5819','2013-03-11','10:10:00',1.04),('5819','2013-03-11','10:15:00',1.12),('5819','2013-03-11','10:20:00',1.21),('5819','2013-03-11','10:25:00',1.34),('5819','2013-03-11','10:30:00',1.22),('5819','2013-03-11','10:35:00',1.38),('5819','2013-03-11','10:40:00',2),('5819','2013-03-11','10:45:00',2.34),('5819','2013-03-11','10:50:00',2.79),('5819','2013-03-11','10:55:00',1.67),('5819','2013-03-11','11:00:00',1.43),('5819','2013-03-11','11:05:00',1.23),('5819','2013-03-11','11:10:00',1.47),('5819','2013-03-11','11:15:00',1.58),('5819','2013-03-11','11:20:00',1.36),('5819','2013-03-11','11:25:00',1.25),('5819','2013-03-11','11:30:00',2.18),('5819','2013-03-11','11:35:00',2.69),('5819','2013-03-11','11:40:00',2),('5819','2013-03-11','11:45:00',2.45),('5819','2013-03-11','11:50:00',2.49),('5819','2013-03-11','11:55:00',1.79),('5819','2013-03-11','12:00:00',1.61),('5819','2013-03-11','12:05:00',1.6),('5819','2013-03-11','12:10:00',1.67),('5819','2013-03-11','12:35:00',1.16),('5819','2013-03-11','12:40:00',1.23),('5819','2013-03-11','12:45:00',1.17),('5819','2013-03-11','12:50:00',1.95),('5819','2013-03-11','12:55:00',3.77),('5819','2013-03-11','13:00:00',2.6),('5819','2013-03-11','13:05:00',1.95),('5819','2013-03-11','13:10:00',2.6),('5819','2013-03-11','13:15:00',3.31),('5819','2013-03-11','13:20:00',3.34),('5819','2013-03-11','13:25:00',3.61),('5819','2013-03-11','13:30:00',3.58),('5819','2013-03-11','13:35:00',3.46),('5819','2013-03-11','13:40:00',3.41),('5819','2013-03-11','13:45:00',2.58),('5819','2013-03-11','13:50:00',1.92),('5819','2013-03-11','13:55:00',2.15),('5819','2013-03-11','14:25:00',1.72),('5819','2013-03-11','14:30:00',1.09),('5819','2013-03-11','14:40:00',1.45),('5819','2013-03-11','15:30:00',1.49),('5819','2013-03-11','15:35:00',1.2),('5819','2013-03-11','15:45:00',2.09),('5819','2013-03-11','15:50:00',1.63),('5819','2013-03-11','15:55:00',1.6),('5819','2013-03-11','16:00:00',1.54),('5819','2013-03-11','16:05:00',1.4),('5819','2013-03-11','16:10:00',1.15),('5819','2013-03-11','16:20:00',1.12),('5819','2013-03-11','16:25:00',1.01),('5819','2013-03-11','16:45:00',1.02),('5819','2013-03-10','07:35:00',1.12),('5819','2013-03-10','07:40:00',1.19),('5819','2013-03-10','07:45:00',1.1),('5819','2013-03-10','07:50:00',1.45),('5819','2013-03-10','07:55:00',1.57),('5819','2013-03-10','08:00:00',1.65),('5819','2013-03-10','08:05:00',1.75),('5819','2013-03-10','08:10:00',1.85),('5819','2013-03-10','08:15:00',1.78),('5819','2013-03-10','08:20:00',2.01),('5819','2013-03-10','08:25:00',2.08),('5819','2013-03-10','08:30:00',2.17),('5819','2013-03-10','08:35:00',2.26),('5819','2013-03-10','08:40:00',2.32),('5819','2013-03-10','08:45:00',2.41),('5819','2013-03-10','08:50:00',2.48),('5819','2013-03-10','08:55:00',2.57),('5819','2013-03-10','09:00:00',2.63),('5819','2013-03-10','09:05:00',2.7),('5819','2013-03-10','09:10:00',2.76),('5819','2013-03-10','09:15:00',2.81),('5819','2013-03-10','09:20:00',2.88),('5819','2013-03-10','09:25:00',2.93),('5819','2013-03-10','09:30:00',3),('5819','2013-03-10','09:35:00',3.05),('5819','2013-03-10','09:40:00',3.1),('5819','2013-03-10','09:45:00',3.1),('5819','2013-03-10','09:50:00',1.89),('5819','2013-03-10','09:55:00',3.5),('5819','2013-03-10','10:00:00',1.8),('5819','2013-03-10','10:05:00',2.71),('5819','2013-03-10','10:10:00',2.56),('5819','2013-03-10','10:15:00',2.07),('5819','2013-03-10','10:20:00',3.28),('5819','2013-03-10','10:25:00',3.15),('5819','2013-03-10','10:30:00',3.57),('5819','2013-03-10','10:35:00',3.41),('5819','2013-03-10','10:40:00',2.9),('5819','2013-03-10','10:45:00',3.71),('5819','2013-03-10','10:50:00',3.53),('5819','2013-03-10','10:55:00',2.26),('5819','2013-03-10','11:00:00',3.39),('5819','2013-03-10','11:05:00',3.13),('5819','2013-03-10','11:10:00',3.13),('5819','2013-03-10','11:15:00',2.65),('5819','2013-03-10','11:20:00',1.91),('5819','2013-03-10','11:25:00',2.72),('5819','2013-03-10','11:30:00',2.41),('5819','2013-03-10','11:35:00',1.5),('5819','2013-03-10','11:40:00',1.56),('5819','2013-03-10','11:45:00',1.61),('5819','2013-03-10','11:50:00',2.86),('5819','2013-03-10','11:55:00',3.57),('5819','2013-03-10','12:00:00',3.65),('5819','2013-03-10','12:05:00',3.78),('5819','2013-03-10','12:10:00',3.36),('5819','2013-03-10','12:15:00',3.68),('5819','2013-03-10','12:20:00',1.92),('5819','2013-03-10','12:25:00',3.56),('5819','2013-03-10','12:35:00',1.51),('5819','2013-03-10','12:40:00',1.49),('5819','2013-03-10','12:45:00',4.03),('5819','2013-03-10','12:50:00',3.8),('5819','2013-03-10','12:55:00',3.8),('5819','2013-03-10','13:00:00',3.61),('5819','2013-03-10','13:05:00',3.51),('5819','2013-03-10','13:10:00',3.36),('5819','2013-03-10','13:15:00',3.53),('5819','2013-03-10','13:20:00',3.55),('5819','2013-03-10','13:25:00',3.17),('5819','2013-03-10','13:30:00',3.05),('5819','2013-03-10','13:35:00',2.82),('5819','2013-03-10','13:40:00',1.66),('5819','2013-03-10','13:45:00',1.84),('5819','2013-03-10','13:50:00',1.62),('5819','2013-03-10','13:55:00',1.57),('5819','2013-03-10','14:00:00',1.42),('5819','2013-03-10','14:05:00',1.64),('5819','2013-03-10','14:10:00',1.83),('5819','2013-03-10','14:15:00',2.35),('5819','2013-03-10','14:20:00',2.12),('5819','2013-03-10','14:25:00',1.53),('5819','2013-03-10','14:30:00',1.44),('5819','2013-03-10','14:35:00',2.65),('5819','2013-03-10','14:40:00',2.42),('5819','2013-03-10','14:45:00',1.47),('5819','2013-03-10','14:50:00',1.48),('5819','2013-03-10','14:55:00',1.4),('5819','2013-03-10','15:00:00',1.07),('5819','2013-03-10','15:05:00',1.19),('5819','2013-03-10','15:10:00',1.24),('5819','2013-03-09','08:05:00',1.86),('5819','2013-03-09','08:10:00',1.81),('5819','2013-03-09','08:15:00',1.89),('5819','2013-03-09','08:20:00',1.91),('5819','2013-03-09','08:25:00',2.04),('5819','2013-03-09','08:30:00',2.14),('5819','2013-03-09','08:35:00',2.22),('5819','2013-03-09','08:40:00',2.02),('5819','2013-03-09','08:45:00',1.25),('5819','2013-03-09','08:50:00',1.15),('5819','2013-03-09','08:55:00',2.08),('5819','2013-03-09','09:00:00',1.02),('5819','2013-03-09','09:30:00',2.03),('5819','2013-03-09','09:35:00',2.54),('5819','2013-03-09','09:40:00',3.41),('5819','2013-03-09','09:45:00',3.67),('5819','2013-03-09','09:50:00',2.69),('5819','2013-03-09','09:55:00',2.32),('5819','2013-03-09','10:00:00',1.72),('5819','2013-03-09','10:05:00',1.24),('5819','2013-03-09','10:10:00',1.18),('5819','2013-03-09','10:15:00',1.15),('5819','2013-03-09','10:20:00',1.28),('5819','2013-03-09','10:35:00',1.12),('5819','2013-03-09','10:40:00',1.55),('5819','2013-03-09','10:45:00',2.02),('5819','2013-03-09','10:50:00',3.04),('5819','2013-03-09','10:55:00',4.01),('5819','2013-03-09','11:00:00',2.67),('5819','2013-03-09','11:05:00',3.68),('5819','2013-03-09','11:10:00',3.99),('5819','2013-03-09','11:15:00',3.97),('5819','2013-03-09','11:20:00',3.98),('5819','2013-03-09','11:25:00',3.22),('5819','2013-03-09','11:30:00',4),('5819','2013-03-09','11:35:00',3.89),('5819','2013-03-09','11:40:00',3.89),('5819','2013-03-09','11:45:00',3.93),('5819','2013-03-09','11:50:00',3.79),('5819','2013-03-09','11:55:00',3.8),('5819','2013-03-09','12:00:00',3.76),('5819','2013-03-09','12:05:00',2.16),('5819','2013-03-09','12:10:00',1.54),('5819','2013-03-09','12:15:00',1.16),('5819','2013-03-09','12:20:00',1.14),('5819','2013-03-09','12:25:00',1.56),('5819','2013-03-09','12:30:00',1.38),('5819','2013-03-09','12:35:00',1.42),('5819','2013-03-09','12:40:00',1.39),('5819','2013-03-09','12:45:00',1.77),('5819','2013-03-09','12:50:00',2.33),('5819','2013-03-09','12:55:00',2.5),('5819','2013-03-09','13:00:00',3.74),('5819','2013-03-09','13:05:00',3.58),('5819','2013-03-09','13:10:00',3.53),('5819','2013-03-09','13:15:00',3.48),('5819','2013-03-09','13:20:00',3.35),('5819','2013-03-09','13:25:00',2.33),('5819','2013-03-09','13:30:00',3.2),('5819','2013-03-09','13:35:00',2.31),('5819','2013-03-09','13:40:00',2.99),('5819','2013-03-09','13:45:00',3.4),('5819','2013-03-09','13:50:00',3.33),('5819','2013-03-09','13:55:00',1.57),('5819','2013-03-09','14:00:00',1.38),('5819','2013-03-09','14:05:00',1.27),('5819','2013-03-09','14:10:00',3.25),('5819','2013-03-09','14:15:00',2.77),('5819','2013-03-09','14:20:00',2.87),('5819','2013-03-09','14:25:00',2.78),('5819','2013-03-09','14:30:00',2.71),('5819','2013-03-09','14:35:00',2.64),('5819','2013-03-09','14:40:00',2.57),('5819','2013-03-09','14:45:00',2.51),('5819','2013-03-09','14:50:00',2.42),('5819','2013-03-09','14:55:00',2.36),('5819','2013-03-09','15:00:00',2.29),('5819','2013-03-09','15:05:00',2.21),('5819','2013-03-09','15:10:00',2.15),('5819','2013-03-09','15:15:00',2.07),('5819','2013-03-09','15:20:00',1.98),('5819','2013-03-09','15:25:00',1.89),('5819','2013-03-09','15:30:00',1.8),('5819','2013-03-09','15:35:00',1.73),('5819','2013-03-09','15:40:00',1.67),('5819','2013-03-09','15:45:00',1.59),('5819','2013-03-09','15:50:00',1.5),('5819','2013-03-09','15:55:00',1.38),('5819','2013-03-09','16:00:00',1.23),('5819','2013-03-09','16:05:00',1.19),('5819','2013-03-09','16:15:00',1.05),('5819','2013-03-08','08:10:00',1.2),('5819','2013-03-08','08:15:00',1.23),('5819','2013-03-08','08:30:00',1.26),('5819','2013-03-08','08:35:00',1.56),('5819','2013-03-08','09:25:00',1),('5819','2013-03-08','09:30:00',1.35),('5819','2013-03-08','09:35:00',2.09),('5819','2013-03-08','09:40:00',1.47),('5819','2013-03-08','09:45:00',2.43),('5819','2013-03-08','09:50:00',2.48),('5819','2013-03-08','09:55:00',2.12),('5819','2013-03-08','10:00:00',1.14),('5819','2013-03-08','10:05:00',1.13),('5819','2013-03-08','10:10:00',2.08),('5819','2013-03-08','10:15:00',1.87),('5819','2013-03-08','10:20:00',2.27),('5819','2013-03-08','10:25:00',1.66),('5819','2013-03-08','10:30:00',1.42),('5819','2013-03-08','10:35:00',2.01),('5819','2013-03-08','10:40:00',1.81),('5819','2013-03-08','10:45:00',1.08),('5819','2013-03-08','10:50:00',1.15),('5819','2013-03-08','10:55:00',1.17),('5819','2013-03-08','11:00:00',1.13),('5819','2013-03-08','11:35:00',1.31),('5819','2013-03-08','11:40:00',1.95),('5819','2013-03-08','11:45:00',1.55),('5819','2013-03-08','11:50:00',1.28),('5819','2013-03-08','11:55:00',1.37),('5819','2013-03-08','12:00:00',2.07),('5819','2013-03-08','12:05:00',1.32),('5819','2013-03-08','12:20:00',1.28),('5819','2013-03-08','12:25:00',1.06),('5819','2013-03-08','12:35:00',1.43),('5819','2013-03-08','12:40:00',1.89),('5819','2013-03-08','12:45:00',2.16),('5819','2013-03-08','12:50:00',2.14),('5819','2013-03-08','12:55:00',1.81),('5819','2013-03-08','13:00:00',1.97),('5819','2013-03-08','13:05:00',1.96),('5819','2013-03-08','13:10:00',1.39),('5819','2013-03-08','13:15:00',1.1),('5819','2013-03-08','13:20:00',1.01),('5819','2013-03-08','13:25:00',1.27),('5819','2013-03-08','13:30:00',1.6),('5819','2013-03-08','13:35:00',1.25),('5819','2013-03-08','13:40:00',1.09),('5819','2013-03-07','10:55:00',1.18),('5819','2013-03-07','11:05:00',1.47),('5819','2013-03-07','11:10:00',1.11),('5819','2013-03-07','11:30:00',1.28),('5819','2013-03-07','11:35:00',1.59),('5819','2013-03-07','11:40:00',1.75),('5819','2013-03-07','11:45:00',2.29),('5819','2013-03-07','11:50:00',1.92),('5819','2013-03-07','11:55:00',1.54),('5819','2013-03-07','12:00:00',1.17),('5819','2013-03-07','12:05:00',1),('5819','2013-03-07','12:40:00',1.29),('5819','2013-03-07','12:45:00',1.94),('5819','2013-03-07','12:50:00',1.69),('5819','2013-03-07','12:55:00',1.52),('5819','2013-03-07','13:00:00',1.52),('5819','2013-03-07','13:05:00',1.58),('5819','2013-03-07','13:10:00',1.31),('5819','2013-03-07','13:15:00',1.52),('5819','2013-03-07','13:20:00',1.86),('5819','2013-03-07','13:25:00',1.73),('5819','2013-03-07','13:30:00',1.42),('5819','2013-03-07','13:35:00',1.28),('5819','2013-03-05','08:15:00',1.51),('5819','2013-03-05','08:20:00',1.45),('5819','2013-03-05','08:25:00',1.54),('5819','2013-03-05','08:30:00',2.27),('5819','2013-03-05','08:35:00',2.01),('5819','2013-03-05','08:40:00',2.03),('5819','2013-03-05','08:45:00',1.59),('5819','2013-03-05','08:50:00',1.58),('5819','2013-03-05','08:55:00',1.49),('5819','2013-03-05','09:00:00',1.61),('5819','2013-03-05','09:05:00',1.62),('5819','2013-03-05','09:10:00',1.55),('5819','2013-03-05','09:15:00',1.44),('5819','2013-03-05','09:20:00',1.43),('5819','2013-03-05','09:25:00',1.38),('5819','2013-03-05','09:30:00',1.45),('5819','2013-03-05','09:35:00',1.61),('5819','2013-03-05','09:40:00',1.67),('5819','2013-03-05','09:45:00',1.7),('5819','2013-03-05','09:50:00',1.76),('5819','2013-03-05','09:55:00',1.64),('5819','2013-03-05','10:00:00',1.58),('5819','2013-03-05','10:05:00',1.76),('5819','2013-03-05','10:10:00',1.86),('5819','2013-03-05','10:15:00',1.8),('5819','2013-03-05','10:20:00',2.01),('5819','2013-03-05','10:25:00',1.95),('5819','2013-03-05','10:30:00',1.81),('5819','2013-03-05','10:35:00',2.13),('5819','2013-03-05','10:40:00',2.21),('5819','2013-03-05','10:45:00',2.34),('5819','2013-03-05','10:50:00',2.5),('5819','2013-03-05','10:55:00',2.59),('5819','2013-03-05','11:00:00',2.46),('5819','2013-03-05','11:05:00',2.55),('5819','2013-03-05','11:10:00',2.62),('5819','2013-03-05','11:15:00',2.56),('5819','2013-03-05','11:20:00',2.46),('5819','2013-03-05','11:25:00',2.39),('5819','2013-03-05','11:30:00',2.41),('5819','2013-03-05','11:35:00',2.64),('5819','2013-03-05','11:40:00',2.93),('5819','2013-03-05','11:45:00',2.82),('5819','2013-03-05','11:50:00',2.89),('5819','2013-03-05','11:55:00',2.92),('5819','2013-03-05','12:00:00',2.98),('5819','2013-03-05','12:05:00',3.09),('5819','2013-03-05','12:10:00',3.13),('5819','2013-03-05','12:15:00',2.55),('5819','2013-03-05','12:20:00',2.89),('5819','2013-03-05','12:25:00',2.94),('5819','2013-03-05','12:30:00',2.46),('5819','2013-03-05','12:35:00',2.63),('5819','2013-03-05','12:40:00',2.44),('5819','2013-03-05','12:45:00',2.43),('5819','2013-03-05','12:50:00',2.11),('5819','2013-03-05','12:55:00',1.95),('5819','2013-03-05','13:00:00',1.59),('5819','2013-03-05','13:05:00',1.51),('5819','2013-03-05','13:10:00',1.59),('5819','2013-03-05','13:15:00',1.71),('5819','2013-03-05','13:20:00',1.67),('5819','2013-03-05','13:25:00',1.49),('5819','2013-03-05','13:30:00',1.37),('5819','2013-03-05','13:35:00',1.28),('5819','2013-03-05','13:40:00',1.22),('5819','2013-03-05','13:45:00',1.11),('5819','2013-03-05','13:50:00',1.02),('5819','2013-03-04','07:40:00',1.01),('5819','2013-03-04','07:45:00',1.11),('5819','2013-03-04','07:50:00',1.2),('5819','2013-03-04','07:55:00',1.29),('5819','2013-03-04','08:00:00',1.38),('5819','2013-03-04','08:05:00',1.47),('5819','2013-03-04','08:45:00',2.17),('5819','2013-03-04','08:50:00',2.24),('5819','2013-03-04','08:55:00',2.31),('5819','2013-03-04','09:00:00',2.37),('5819','2013-03-04','09:05:00',2.44),('5819','2013-03-04','09:10:00',2.51),('5819','2013-03-04','09:15:00',2.57),('5819','2013-03-04','09:20:00',2.64),('5819','2013-03-04','09:25:00',2.7),('5819','2013-03-04','09:30:00',2.77),('5819','2013-03-04','09:35:00',2.83),('5819','2013-03-04','09:40:00',2.89),('5819','2013-03-04','09:45:00',2.96),('5819','2013-03-04','09:50:00',3.02),('5819','2013-03-04','09:55:00',3.05),('5819','2013-03-04','10:00:00',3.1),('5819','2013-03-04','10:05:00',3.15),('5819','2013-03-04','10:10:00',3.17),('5819','2013-03-04','10:16:00',3.19),('5819','2013-03-04','10:20:00',3.25),('5819','2013-03-04','10:25:00',3.27),('5819','2013-03-04','10:30:00',3.31),('5819','2013-03-04','10:35:00',3.32),('5819','2013-03-04','10:40:00',3.33),('5819','2013-03-04','10:45:00',3.37),('5819','2013-03-04','11:20:00',3.5),('5819','2013-03-04','11:25:00',3.46),('5819','2013-03-04','11:30:00',3.44),('5819','2013-03-04','11:35:00',3.46),('5819','2013-03-04','11:40:00',3.5),('5819','2013-03-04','11:45:00',3.51),('5819','2013-03-04','11:50:00',3.42),('5819','2013-03-04','11:55:00',3.41),('5819','2013-03-04','12:00:00',3.46),('5819','2013-03-04','12:05:00',3.37),('5819','2013-03-04','12:10:00',3.34),('5819','2013-03-04','12:15:00',3.41),('5819','2013-03-04','12:55:00',3.28),('5819','2013-03-04','13:00:00',3.23),('5819','2013-03-04','13:05:00',3.18),('5819','2013-03-04','13:10:00',3.22),('5819','2013-03-04','13:15:00',3.17),('5819','2013-03-04','13:20:00',3.14),('5819','2013-03-04','13:55:00',2.83),('5819','2013-03-04','14:00:00',2.76),('5819','2013-03-04','14:05:00',2.71),('5819','2013-03-04','14:10:00',2.67),('5819','2013-03-04','14:15:00',2.61),('5819','2013-03-04','14:20:00',2.53),('5819','2013-03-04','14:25:00',2.44),('5819','2013-03-04','14:30:00',2.35),('5819','2013-03-04','14:35:00',2.29),('5819','2013-03-04','14:40:00',2.3),('5819','2013-03-04','14:45:00',2.22),('5819','2013-03-04','14:50:00',2.13),('5819','2013-03-04','14:55:00',2.1),('5819','2013-03-04','15:00:00',2.04),('5819','2013-03-04','15:05:00',1.98),('5819','2013-03-04','15:10:00',1.9),('5819','2013-03-04','15:15:00',1.82),('5819','2013-03-04','15:20:00',1.76),('5819','2013-03-04','15:25:00',1.66),('5819','2013-03-04','15:30:00',1.62),('5819','2013-03-04','15:35:00',1.54),('5819','2013-03-04','15:40:00',1.45),('5819','2013-03-04','15:45:00',1.39),('5819','2013-03-04','15:50:00',1.31),('5819','2013-03-04','15:55:00',1.25),('5819','2013-03-04','16:00:00',1.18),('5819','2013-03-04','16:05:00',1.11),('5819','2013-03-04','16:10:00',1.04),('5819','2013-03-03','07:40:00',1.09),('5819','2013-03-03','07:45:00',1.2),('5819','2013-03-03','07:50:00',1.28),('5819','2013-03-03','07:55:00',1.39),('5819','2013-03-03','08:00:00',1.5),('5819','2013-03-03','08:05:00',1.59),('5819','2013-03-03','08:10:00',1.69),('5819','2013-03-03','08:15:00',1.78),('5819','2013-03-03','08:20:00',1.88),('5819','2013-03-03','08:25:00',1.97),('5819','2013-03-03','08:30:00',2.06),('5819','2013-03-03','08:35:00',2.15),('5819','2013-03-03','08:40:00',2.24),('5819','2013-03-03','08:45:00',2.31),('5819','2013-03-03','08:50:00',2.39),('5819','2013-03-03','08:55:00',2.46),('5819','2013-03-03','09:00:00',2.53),('5819','2013-03-03','09:05:00',2.6),('5819','2013-03-03','09:10:00',2.65),('5819','2013-03-03','09:15:00',2.7),('5819','2013-03-03','09:20:00',2.77),('5819','2013-03-03','09:25:00',2.83),('5819','2013-03-03','09:30:00',2.89),('5819','2013-03-03','09:35:00',2.94),('5819','2013-03-03','09:40:00',2.99),('5819','2013-03-03','10:15:00',3.39),('5819','2013-03-03','10:50:00',3.54),('5819','2013-03-03','10:55:00',3.56),('5819','2013-03-03','11:00:00',3.57),('5819','2013-03-03','11:05:00',3.58),('5819','2013-03-03','11:10:00',3.58),('5819','2013-03-03','11:15:00',3.58),('5819','2013-03-03','11:20:00',3.6),('5819','2013-03-03','11:25:00',3.61),('5819','2013-03-03','11:30:00',3.62),('5819','2013-03-03','11:35:00',3.62),('5819','2013-03-03','11:40:00',3.63),('5819','2013-03-03','11:45:00',3.62),('5819','2013-03-03','11:50:00',3.63),('5819','2013-03-03','11:55:00',3.6),('5819','2013-03-03','12:00:00',3.61),('5819','2013-03-03','12:05:00',3.57),('5819','2013-03-03','12:10:00',3.55),('5819','2013-03-03','12:15:00',3.56),('5819','2013-03-03','12:20:00',3.55),('5819','2013-03-03','12:25:00',3.54),('5819','2013-03-03','12:30:00',3.52),('5819','2013-03-03','12:35:00',3.49),('5819','2013-03-03','12:40:00',3.49),('5819','2013-03-03','12:45:00',3.47),('5819','2013-03-03','12:50:00',3.44),('5819','2013-03-03','12:55:00',3.41),('5819','2013-03-03','13:00:00',3.38),('5819','2013-03-03','13:05:00',3.37),('5819','2013-03-03','13:10:00',3.35),('5819','2013-03-03','13:15:00',3.32),('5819','2013-03-03','13:20:00',3.27),('5819','2013-03-03','13:25:00',3.22),('5819','2013-03-03','13:30:00',3.18),('5819','2013-03-03','13:35:00',3.15),('5819','2013-03-03','13:40:00',3.1),('5819','2013-03-03','13:45:00',3.04),('5819','2013-03-03','13:50:00',3.01),('5819','2013-03-03','13:55:00',2.97),('5819','2013-03-03','14:00:00',2.92),('5819','2013-03-03','14:05:00',2.86),('5819','2013-03-03','14:10:00',2.82),('5819','2013-03-03','14:15:00',2.77),('5819','2013-03-03','14:20:00',2.71),('5819','2013-03-03','14:25:00',2.65),('5819','2013-03-03','14:30:00',2.58),('5819','2013-03-03','14:35:00',2.52),('5819','2013-03-03','14:40:00',2.46),('5819','2013-03-03','14:45:00',2.38),('5819','2013-03-03','14:50:00',2.32),('5819','2013-03-03','14:55:00',2.23),('5819','2013-03-03','15:00:00',2.18),('5819','2013-03-03','15:05:00',2.13),('5819','2013-03-03','15:10:00',2.04),('5819','2013-03-03','15:15:00',1.97),('5819','2013-03-03','15:20:00',1.89),('5819','2013-03-03','15:25:00',1.81),('5819','2013-03-03','15:30:00',1.74),('5819','2013-03-03','15:35:00',1.66),('5819','2013-03-03','15:40:00',1.57),('5819','2013-03-03','15:45:00',1.49),('5819','2013-03-03','15:50:00',1.41),('5819','2013-03-03','15:55:00',1.33),('5819','2013-03-03','16:00:00',1.25),('5819','2013-03-03','16:05:00',1.17),('5819','2013-03-03','16:10:00',1.1),('5819','2013-03-03','16:15:00',1.03),('5819','2013-03-02','10:55:00',1.02),('5819','2013-03-02','11:00:00',1.09),('5819','2013-03-02','11:05:00',1.12),('5819','2013-03-02','11:10:00',1.21),('5819','2013-03-02','11:15:00',1.32),('5819','2013-03-02','11:20:00',1.18),('5819','2013-03-02','11:25:00',1.04),('5819','2013-03-02','11:35:00',1.04),('5819','2013-03-02','11:40:00',1.18),('5819','2013-03-02','11:45:00',1.06),('5819','2013-03-02','11:50:00',1.06),('5819','2013-03-02','11:55:00',1),('5819','2013-03-02','12:05:00',1.09),('5819','2013-03-02','12:10:00',1.1),('5819','2013-03-02','12:15:00',1.08),('5819','2013-03-02','12:20:00',1.03),('5819','2013-03-02','12:25:00',1.12),('5819','2013-03-02','12:30:00',1.1),('5819','2013-03-02','12:35:00',1.25),('5819','2013-03-02','12:40:00',1.29),('5819','2013-03-02','12:45:00',1.19),('5819','2013-03-02','12:50:00',1.15),('5819','2013-03-02','12:55:00',1.26),('5819','2013-03-02','13:00:00',1.32),('5819','2013-03-02','13:05:00',1.14),('5819','2013-03-02','13:45:00',1.04),('5819','2013-03-02','13:50:00',1),('5819','2013-03-02','13:55:00',1.09),('5819','2013-03-02','14:00:00',1.24),('5819','2013-03-02','14:05:00',1.22),('5819','2013-03-01','08:00:00',1.11),('5819','2013-03-01','08:05:00',1.13),('5819','2013-03-01','08:10:00',1.13),('5819','2013-03-01','08:15:00',1.19),('5819','2013-03-01','08:20:00',1.26),('5819','2013-03-01','08:25:00',1.27),('5819','2013-03-01','08:30:00',1.35),('5819','2013-03-01','08:35:00',1.43),('5819','2013-03-01','08:40:00',1.54),('5819','2013-03-01','08:45:00',1.65),('5819','2013-03-01','08:50:00',1.73),('5819','2013-03-01','08:55:00',1.83),('5819','2013-03-01','09:00:00',1.94),('5819','2013-03-01','09:05:00',2.18),('5819','2013-03-01','09:10:00',2.19),('5819','2013-03-01','09:15:00',2.18),('5819','2013-03-01','09:20:00',2.23),('5819','2013-03-01','09:25:00',2.24),('5819','2013-03-01','09:30:00',2.53),('5819','2013-03-01','09:35:00',2.4),('5819','2013-03-01','09:40:00',2.47),('5819','2013-03-01','09:45:00',2.63),('5819','2013-03-01','09:50:00',2.66),('5819','2013-03-01','09:55:00',2.59),('5819','2013-03-01','10:00:00',2.63),('5819','2013-03-01','10:05:00',2.61),('5819','2013-03-01','10:10:00',2.57),('5819','2013-03-01','10:15:00',2.32),('5819','2013-03-01','10:20:00',2.1),('5819','2013-03-01','10:25:00',2.19),('5819','2013-03-01','10:30:00',2.38),('5819','2013-03-01','10:35:00',2.7),('5819','2013-03-01','10:40:00',2.4),('5819','2013-03-01','10:45:00',2.26),('5819','2013-03-01','10:50:00',2.12),('5819','2013-03-01','10:55:00',2),('5819','2013-03-01','11:00:00',1.76),('5819','2013-03-01','11:05:00',1.5),('5819','2013-03-01','11:10:00',1.4),('5819','2013-03-01','11:15:00',1.52),('5819','2013-03-01','11:20:00',1.64),('5819','2013-03-01','11:25:00',1.64),('5819','2013-03-01','11:30:00',1.65),('5819','2013-03-01','11:35:00',1.68),('5819','2013-03-01','11:40:00',1.61),('5819','2013-03-01','11:45:00',1.53),('5819','2013-03-01','11:50:00',1.51),('5819','2013-03-01','11:55:00',1.44),('5819','2013-03-01','12:00:00',1.38),('5819','2013-03-01','12:05:00',1.31),('5819','2013-03-01','12:10:00',1.22),('5819','2013-03-01','12:15:00',1.12),('5819','2013-03-01','12:20:00',1.05),('5819','2013-03-01','12:25:00',1.03),('5819','2013-03-01','12:30:00',1.06),('5819','2013-03-01','12:35:00',1.06),('5819','2013-03-01','12:40:00',1.02),('5819','2013-03-01','12:45:00',1.01),('5819','2013-03-01','12:50:00',1.03),('5819','2013-03-01','12:55:00',1.08),('5819','2013-03-01','13:00:00',1.14),('5819','2013-03-01','13:05:00',1.16),('5819','2013-03-01','13:10:00',1.19),('5819','2013-03-01','13:15:00',1.28),('5819','2013-03-01','13:20:00',1.37),('5819','2013-03-01','13:25:00',1.51),('5819','2013-03-01','13:30:00',1.51),('5819','2013-03-01','13:35:00',1.4),('5819','2013-03-01','13:40:00',1.33),('5819','2013-03-01','13:45:00',1.3),('5819','2013-03-01','13:50:00',1.29),('5819','2013-03-01','13:55:00',1.24),('5819','2013-03-01','14:00:00',1.21),('5819','2013-03-01','14:05:00',1.16),('5819','2013-03-01','14:10:00',1.1),('5819','2013-03-01','14:15:00',1.04),('5819','2013-03-01','14:30:00',1.01),('5819','2013-03-01','14:35:00',1.02),('5819','2013-02-28','07:55:00',1.08),('5819','2013-02-28','08:00:00',1.18),('5819','2013-02-28','08:05:00',1.26),('5819','2013-02-28','08:10:00',1.33),('5819','2013-02-28','08:15:00',1.42),('5819','2013-02-28','08:20:00',1.51),('5819','2013-02-28','08:25:00',1.62),('5819','2013-02-28','08:30:00',1.71),('5819','2013-02-28','08:35:00',1.8),('5819','2013-02-28','08:40:00',1.89),('5819','2013-02-28','08:45:00',1.98),('5819','2013-02-28','08:50:00',2.08),('5819','2013-02-28','08:55:00',2.16),('5819','2013-02-28','09:00:00',2.24),('5819','2013-02-28','09:05:00',2.29),('5819','2013-02-28','09:10:00',2.35),('5819','2013-02-28','09:15:00',2.39),('5819','2013-02-28','09:20:00',2.47),('5819','2013-02-28','09:25:00',2.53),('5819','2013-02-28','09:30:00',2.59),('5819','2013-02-28','09:35:00',2.65),('5819','2013-02-28','09:40:00',2.7),('5819','2013-02-28','09:45:00',2.77),('5819','2013-02-28','09:50:00',2.62),('5819','2013-02-28','09:55:00',2.85),('5819','2013-02-28','10:00:00',2.91),('5819','2013-02-28','10:05:00',2.96),('5819','2013-02-28','10:10:00',2.96),('5819','2013-02-28','10:15:00',3),('5819','2013-02-28','10:20:00',3.03),('5819','2013-02-28','10:25:00',3.04),('5819','2013-02-28','10:30:00',3.02),('5819','2013-02-28','10:35:00',3.14),('5819','2013-02-28','10:40:00',3.15),('5819','2013-02-28','10:45:00',3.18),('5819','2013-02-28','10:50:00',3.2),('5819','2013-02-28','10:55:00',3.23),('5819','2013-02-28','11:00:00',3.29),('5819','2013-02-28','11:05:00',3.33),('5819','2013-02-28','11:10:00',3.32),('5819','2013-02-28','11:15:00',3.32),('5819','2013-02-28','11:20:00',3.35),('5819','2013-02-28','11:25:00',3.41),('5819','2013-02-28','11:30:00',3.4),('5819','2013-02-28','11:35:00',3.39),('5819','2013-02-28','11:40:00',3.4),('5819','2013-02-28','11:45:00',3.4),('5819','2013-02-28','11:50:00',3.42),('5819','2013-02-28','11:55:00',3.42),('5819','2013-02-28','12:00:00',3.33),('5819','2013-02-28','12:05:00',3.3),('5819','2013-02-28','12:10:00',3.38),('5819','2013-02-28','12:15:00',3.37),('5819','2013-02-28','12:20:00',3.34),('5819','2013-02-28','12:25:00',3.3),('5819','2013-02-28','12:30:00',3.31),('5819','2013-02-28','12:35:00',3.31),('5819','2013-02-28','12:40:00',3.31),('5819','2013-02-28','12:45:00',3.19),('5819','2013-02-28','12:50:00',3.17),('5819','2013-02-28','12:55:00',3.22),('5819','2013-02-28','13:00:00',3.07),('5819','2013-02-28','13:05:00',3.21),('5819','2013-02-28','13:10:00',3.13),('5819','2013-02-28','13:15:00',3.16),('5819','2013-02-28','13:20:00',3.19),('5819','2013-02-28','13:25:00',3.17),('5819','2013-02-28','13:30:00',3.03),('5819','2013-02-28','13:35:00',2.93),('5819','2013-02-28','13:40:00',2.26),('5819','2013-02-28','13:45:00',2.71),('5819','2013-02-28','13:50:00',2.99),('5819','2013-02-28','13:55:00',2.88),('5819','2013-02-28','14:00:00',2.83),('5819','2013-02-28','14:05:00',2.75),('5819','2013-02-28','14:10:00',2.7),('5819','2013-02-28','14:15:00',2.6),('5819','2013-02-28','14:20:00',1.9),('5819','2013-02-28','14:25:00',1.75),('5819','2013-02-28','14:30:00',2.35),('5819','2013-02-28','14:35:00',2.19),('5819','2013-02-28','14:40:00',2.25),('5819','2013-02-28','14:45:00',2.21),('5819','2013-02-28','14:50:00',2.14),('5819','2013-02-28','14:55:00',2.09),('5819','2013-02-28','15:00:00',2.01),('5819','2013-02-28','15:05:00',1.93),('5819','2013-02-28','15:10:00',1.8),('5819','2013-02-28','15:15:00',1.75),('5819','2013-02-28','15:20:00',1.68),('5819','2013-02-28','15:25:00',1.52),('5819','2013-02-28','15:30:00',1.44),('5819','2013-02-28','15:35:00',1.4),('5819','2013-02-28','15:40:00',1.35),('5819','2013-02-28','15:45:00',1.29),('5819','2013-02-28','15:50:00',1.22),('5819','2013-02-28','15:55:00',1.16),('5819','2013-02-28','16:00:00',1.07),('5819','2013-02-28','16:05:00',1.01),('5819','2013-02-27','07:55:00',1.02),('5819','2013-02-27','08:00:00',1.14),('5819','2013-02-27','08:05:00',1.23),('5819','2013-02-27','08:10:00',1.3),('5819','2013-02-27','08:15:00',1.38),('5819','2013-02-27','08:20:00',1.48),('5819','2013-02-27','08:25:00',1.58),('5819','2013-02-27','08:30:00',1.67),('5819','2013-02-27','08:35:00',1.75),('5819','2013-02-27','08:40:00',1.82),('5819','2013-02-27','08:45:00',1.9),('5819','2013-02-27','08:50:00',2.01),('5819','2013-02-27','08:55:00',2.08),('5819','2013-02-27','09:00:00',2.15),('5819','2013-02-27','09:05:00',2.23),('5819','2013-02-27','09:10:00',2.3),('5819','2013-02-27','09:15:00',2.38),('5819','2013-02-27','09:20:00',2.45),('5819','2013-02-27','09:25:00',2.5),('5819','2013-02-27','09:30:00',2.57),('5819','2013-02-27','09:35:00',2.62),('5819','2013-02-27','09:40:00',2.68),('5819','2013-02-27','09:45:00',2.74),('5819','2013-02-27','09:50:00',2.78),('5819','2013-02-27','09:55:00',2.83),('5819','2013-02-27','10:00:00',2.88),('5819','2013-02-27','10:05:00',2.92),('5819','2013-02-27','10:10:00',2.97),('5819','2013-02-27','10:15:00',3.03),('5819','2013-02-27','10:20:00',3.07),('5819','2013-02-27','10:25:00',3.06),('5819','2013-02-27','10:30:00',3.1),('5819','2013-02-27','10:35:00',3.17),('5819','2013-02-27','10:40:00',3.17),('5819','2013-02-27','10:45:00',3.19),('5819','2013-02-27','10:50:00',3.27),('5819','2013-02-27','10:55:00',3.29),('5819','2013-02-27','11:00:00',3.32),('5819','2013-02-27','11:05:00',3.36),('5819','2013-02-27','11:10:00',3.39),('5819','2013-02-27','11:15:00',3.35),('5819','2013-02-27','11:20:00',3.32),('5819','2013-02-27','11:25:00',3.41),('5819','2013-02-27','11:30:00',3.04),('5819','2013-02-27','11:35:00',2.78),('5819','2013-02-27','11:40:00',3.09),('5819','2013-02-27','11:45:00',3.38),('5819','2013-02-27','11:50:00',3.52),('5819','2013-02-27','11:55:00',3.54),('5819','2013-02-27','12:00:00',3.49),('5819','2013-02-27','12:05:00',3.47),('5819','2013-02-27','12:10:00',3.49),('5819','2013-02-27','12:15:00',3.59),('5819','2013-02-27','12:20:00',3.57),('5819','2013-02-27','12:25:00',3.44),('5819','2013-02-27','12:30:00',3.35),('5819','2013-02-27','12:35:00',3.36),('5819','2013-02-27','12:40:00',3.38),('5819','2013-02-27','12:45:00',3.37),('5819','2013-02-27','12:50:00',3.32),('5819','2013-02-27','12:55:00',3.25),('5819','2013-02-27','13:00:00',3.26),('5819','2013-02-27','13:05:00',3.31),('5819','2013-02-27','13:10:00',3.28),('5819','2013-02-27','13:15:00',3.12),('5819','2013-02-27','13:20:00',1.7),('5819','2013-02-27','13:25:00',1.47),('5819','2013-02-27','13:30:00',2.4),('5819','2013-02-27','13:35:00',3.13),('5819','2013-02-27','13:40:00',3.01),('5819','2013-02-27','13:45:00',2.95),('5819','2013-02-27','13:50:00',2.24),('5819','2013-02-27','13:55:00',1.9),('5819','2013-02-27','14:00:00',2.1),('5819','2013-02-27','14:05:00',1.81),('5819','2013-02-27','14:10:00',2.55),('5819','2013-02-27','14:15:00',1.41),('5819','2013-02-27','14:20:00',2.47),('5819','2013-02-27','14:25:00',2.51),('5819','2013-02-27','14:30:00',2.45),('5819','2013-02-27','14:35:00',2.41),('5819','2013-02-27','14:40:00',2.35),('5819','2013-02-27','14:45:00',2.28),('5819','2013-02-27','14:50:00',1.66),('5819','2013-02-27','14:55:00',2.05),('5819','2013-02-27','15:00:00',2.06),('5819','2013-02-27','15:05:00',2.03),('5819','2013-02-27','15:10:00',1.93),('5819','2013-02-27','15:15:00',1.51),('5819','2013-02-27','15:20:00',1.74),('5819','2013-02-27','15:25:00',1.67),('5819','2013-02-27','15:30:00',1.58),('5819','2013-02-27','15:35:00',1.52),('5819','2013-02-27','15:40:00',1.39),('5819','2013-02-27','15:45:00',1.35),('5819','2013-02-27','15:50:00',1.29),('5819','2013-02-27','15:55:00',1.22),('5819','2013-02-27','16:00:00',1.16),('5819','2013-02-27','16:05:00',1.08),('5819','2013-02-27','16:10:00',1.02),('5819','2013-02-26','09:25:00',1.07),('5819','2013-02-26','09:30:00',1.31),('5819','2013-02-26','09:35:00',1.64),('5819','2013-02-26','09:40:00',1.84),('5819','2013-02-26','09:45:00',1.84),('5819','2013-02-26','09:50:00',1.87),('5819','2013-02-26','09:55:00',2.09),('5819','2013-02-26','10:00:00',1.98),('5819','2013-02-26','10:05:00',1.99),('5819','2013-02-26','10:10:00',2.37),('5819','2013-02-26','10:15:00',2.73),('5819','2013-02-26','10:20:00',3.18),('5819','2013-02-26','10:25:00',3.45),('5819','2013-02-26','10:30:00',3.29),('5819','2013-02-26','10:35:00',2.9),('5819','2013-02-26','10:40:00',2.03),('5819','2013-02-26','10:45:00',1.36),('5819','2013-02-26','10:50:00',1.59),('5819','2013-02-26','10:55:00',1.71),('5819','2013-02-26','11:00:00',1.9),('5819','2013-02-26','11:05:00',1.99),('5819','2013-02-26','11:10:00',2.05),('5819','2013-02-26','11:15:00',1.84),('5819','2013-02-26','11:20:00',1.54),('5819','2013-02-26','11:25:00',1.47),('5819','2013-02-26','11:30:00',1.44),('5819','2013-02-26','11:35:00',1.42),('5819','2013-02-26','11:40:00',1.55),('5819','2013-02-26','11:45:00',1.48),('5819','2013-02-26','11:50:00',1.74),('5819','2013-02-26','11:55:00',1.67),('5819','2013-02-26','12:00:00',1.69),('5819','2013-02-26','12:05:00',1.62),('5819','2013-02-26','12:10:00',1.62),('5819','2013-02-26','12:15:00',1.41),('5819','2013-02-26','12:20:00',1.4),('5819','2013-02-26','12:25:00',1.27),('5819','2013-02-26','12:30:00',1.28),('5819','2013-02-26','12:35:00',1.17),('5819','2013-02-26','12:40:00',1.07),('5819','2013-02-25','08:45:00',1.05),('5819','2013-02-25','08:50:00',1.3),('5819','2013-02-25','09:00:00',1.31),('5819','2013-02-25','09:25:00',1.25),('5819','2013-02-25','09:30:00',1.42),('5819','2013-02-25','09:35:00',1.41),('5819','2013-02-25','09:40:00',1.16),('5819','2013-02-25','10:45:00',1.48),('5819','2013-02-25','10:50:00',2.72),('5819','2013-02-25','10:55:00',3.76),('5819','2013-02-25','11:00:00',4.38),('5819','2013-02-25','11:05:00',2.54),('5819','2013-02-25','11:10:00',1.78),('5819','2013-02-25','11:15:00',1.55),('5819','2013-02-25','11:20:00',1.08),('5819','2013-02-25','11:30:00',1.72),('5819','2013-02-25','11:35:00',1.16),('5819','2013-02-25','11:40:00',1.2),('5819','2013-02-25','11:45:00',1.5),('5819','2013-02-25','11:50:00',1.85),('5819','2013-02-25','11:55:00',4.33),('5819','2013-02-25','12:00:00',2.76),('5819','2013-02-25','12:05:00',2.14),('5819','2013-02-25','12:10:00',1.7),('5819','2013-02-25','12:15:00',2.38),('5819','2013-02-25','12:20:00',3.68),('5819','2013-02-25','12:25:00',4.01),('5819','2013-02-25','12:30:00',3.43),('5819','2013-02-25','12:35:00',2.46),('5819','2013-02-25','12:40:00',3.59),('5819','2013-02-25','12:45:00',3.58),('5819','2013-02-25','12:50:00',3.41),('5819','2013-02-25','12:55:00',3.37),('5819','2013-02-25','13:00:00',3.53),('5819','2013-02-25','13:05:00',2.7),('5819','2013-02-25','13:10:00',3.32),('5819','2013-02-25','13:15:00',2.25),('5819','2013-02-25','13:20:00',1.85),('5819','2013-02-25','13:25:00',1.29),('5819','2013-02-25','13:30:00',1.54),('5819','2013-02-25','13:35:00',1.32),('5819','2013-02-24','10:50:00',1.11),('5819','2013-02-24','10:55:00',1.08),('5819','2013-02-24','12:40:00',1.01),('5819','2013-02-24','12:45:00',1.24),('5819','2013-02-24','12:50:00',1.12),('5819','2013-02-24','13:00:00',1.04),('5819','2013-02-24','13:05:00',1.57),('5819','2013-02-24','13:10:00',1.46),('5819','2013-02-24','13:15:00',1.16),('5819','2013-02-24','13:20:00',1.36),('5819','2013-02-24','13:25:00',1.05),('5819','2013-02-24','13:35:00',1.16),('5819','2013-02-24','13:40:00',1.26),('5819','2013-02-24','13:45:00',1.31),('5819','2013-02-24','13:50:00',1.12),('5819','2013-02-24','14:00:00',1.06),('5819','2013-02-24','14:05:00',1.58),('5819','2013-02-24','14:10:00',1.64),('5819','2013-02-24','14:15:00',1.07),('5819','2013-02-24','14:30:00',1.09),('5819','2013-02-24','14:35:00',1.16),('5819','2013-02-24','15:10:00',1.7),('5819','2013-02-24','15:15:00',1.22),('5819','2013-02-24','15:25:00',1.54),('5819','2013-02-24','15:35:00',1.06),('5819','2013-02-24','15:40:00',1.31),('5819','2013-02-24','15:45:00',1.02),('5819','2013-02-24','15:50:00',1.08),('5819','2013-02-24','15:55:00',1.09),('5819','2013-02-24','16:00:00',1.42),('5819','2013-02-24','16:05:00',1.01),('5819','2013-02-23','07:50:00',1.09),('5819','2013-02-23','07:55:00',1.21),('5819','2013-02-23','08:00:00',1.31),('5819','2013-02-23','08:05:00',1.43),('5819','2013-02-23','08:10:00',1.68),('5819','2013-02-23','08:15:00',1.95),('5819','2013-02-23','08:20:00',1.14),('5819','2013-02-23','09:00:00',1.29),('5819','2013-02-23','09:05:00',1.33),('5819','2013-02-23','09:45:00',1.23),('5819','2013-02-23','09:50:00',1.28),('5819','2013-02-23','09:55:00',1.25),('5819','2013-02-23','10:00:00',1.01),('5819','2013-02-23','14:05:00',1.39),('5819','2013-02-23','14:10:00',1.27),('5819','2013-02-22','14:35:00',1.14),('5819','2013-02-22','14:40:00',1.27),('5819','2013-02-22','14:45:00',1.09),('5819','2013-02-22','14:55:00',1.23),('5819','2013-02-21','11:50:00',1.04),('5819','2013-02-21','11:55:00',1.08),('5819','2013-02-21','12:00:00',1.06),('5819','2013-02-21','12:05:00',1.06),('5819','2013-02-21','12:10:00',1.11),('5819','2013-02-21','12:15:00',1.17),('5819','2013-02-21','12:20:00',1.27),('5819','2013-02-21','12:25:00',1.26),('5819','2013-02-21','12:30:00',1.17),('5819','2013-02-21','12:35:00',1.11),('5819','2013-02-21','12:40:00',1.07),('5819','2013-02-21','12:45:00',1.09),('5819','2013-02-21','12:50:00',1.09),('5819','2013-02-21','12:55:00',1.16),('5819','2013-02-21','13:00:00',1.2),('5819','2013-02-21','13:05:00',1.12),('5819','2013-02-21','13:10:00',1.06),('5819','2013-02-21','13:15:00',1.07),('5819','2013-02-21','13:20:00',1.11),('5819','2013-02-21','13:25:00',1.14),('5819','2013-02-21','13:30:00',1.16),('5819','2013-02-21','13:35:00',1.16),('5819','2013-02-21','13:40:00',1.13),('5819','2013-02-21','13:45:00',1.08),('5819','2013-02-21','13:50:00',1.07),('5819','2013-02-21','13:55:00',1.07),('5819','2013-02-21','14:00:00',1.09),('5819','2013-02-21','14:05:00',1.06),('5819','2013-02-21','16:20:00',1.13),('5819','2013-02-21','16:25:00',1.2),('5819','2013-02-21','16:30:00',1.1),('5819','2013-02-20','08:20:00',1.43),('5819','2013-02-20','08:25:00',1.59),('5819','2013-02-20','08:30:00',1.67),('5819','2013-02-20','08:35:00',1.77),('5819','2013-02-20','08:40:00',1.85),('5819','2013-02-20','09:15:00',1.32),('5819','2013-02-20','09:55:00',2.34),('5819','2013-02-20','10:00:00',1.51),('5819','2013-02-20','10:10:00',1.92),('5819','2013-02-20','10:15:00',1.19),('5819','2013-02-20','10:45:00',1),('5819','2013-02-20','10:50:00',2.72),('5819','2013-02-20','10:55:00',3.41),('5819','2013-02-20','11:10:00',3.43),('5819','2013-02-20','11:15:00',3.6),('5819','2013-02-20','11:20:00',1.5),('5819','2013-02-20','11:25:00',3.13),('5819','2013-02-20','11:30:00',2.27),('5819','2013-02-20','11:35:00',3.09),('5819','2013-02-20','11:40:00',3.75),('5819','2013-02-20','11:45:00',3.65),('5819','2013-02-20','11:50:00',4.09),('5819','2013-02-20','11:55:00',2.7),('5819','2013-02-20','12:00:00',3.47),('5819','2013-02-20','12:05:00',1.88),('5819','2013-02-20','12:10:00',2.96),('5819','2013-02-20','12:15:00',2.4),('5819','2013-02-20','12:20:00',1.42),('5819','2013-02-20','12:25:00',2.13),('5819','2013-02-20','12:30:00',4.28),('5819','2013-02-20','12:35:00',3.27),('5819','2013-02-20','12:40:00',2.59),('5819','2013-02-20','12:45:00',1.29),('5819','2013-02-20','12:50:00',1.05),('5819','2013-02-20','12:55:00',1.1),('5819','2013-02-20','13:00:00',1.68),('5819','2013-02-20','13:05:00',3.43),('5819','2013-02-20','13:10:00',2.84),('5819','2013-02-20','13:15:00',3.8),('5819','2013-02-20','13:20:00',2.29),('5819','2013-02-20','13:25:00',1.24),('5819','2013-02-20','13:30:00',2.68),('5819','2013-02-20','13:35:00',1.33),('5819','2013-02-20','13:40:00',1.24),('5819','2013-02-20','13:45:00',1.1),('5819','2013-02-20','13:50:00',1.11),('5819','2013-02-20','13:55:00',1.01),('5819','2013-02-20','14:00:00',1),('5819','2013-02-20','14:05:00',1.12),('5819','2013-02-20','15:15:00',1.22),('5819','2013-02-20','15:20:00',1.61),('5819','2013-02-20','15:25:00',1.96),('5819','2013-02-20','15:30:00',1.47),('5819','2013-02-20','16:00:00',1.04),('5819','2013-02-20','16:05:00',1.33),('5819','2013-02-20','16:10:00',1.21),('5819','2013-02-20','16:15:00',1.21),('5819','2013-02-20','16:20:00',1.11),('5819','2013-02-19','08:00:00',1.09),('5819','2013-02-19','08:05:00',1.2),('5819','2013-02-19','08:10:00',1.29),('5819','2013-02-19','08:15:00',1.39),('5819','2013-02-19','08:20:00',1.48),('5819','2013-02-19','08:25:00',1.58),('5819','2013-02-19','08:30:00',1.67),('5819','2013-02-19','08:35:00',1.76),('5819','2013-02-19','08:40:00',1.83),('5819','2013-02-19','08:45:00',1.92),('5819','2013-02-19','08:50:00',2),('5819','2013-02-19','08:55:00',2.06),('5819','2013-02-19','09:00:00',2.14),('5819','2013-02-19','09:05:00',2.21),('5819','2013-02-19','09:10:00',2.27),('5819','2013-02-19','09:15:00',2.35),('5819','2013-02-19','09:20:00',2.42),('5819','2013-02-19','09:25:00',2.48),('5819','2013-02-19','09:30:00',2.54),('5819','2013-02-19','09:35:00',2.59),('5819','2013-02-19','09:40:00',2.63),('5819','2013-02-19','09:45:00',2.7),('5819','2013-02-19','09:50:00',2.75),('5819','2013-02-19','09:55:00',2.79),('5819','2013-02-19','10:00:00',2.84),('5819','2013-02-19','10:05:00',2.88),('5819','2013-02-19','10:10:00',2.93),('5819','2013-02-19','10:15:00',2.98),('5819','2013-02-19','10:20:00',3.02),('5819','2013-02-19','10:25:00',3.06),('5819','2013-02-19','10:30:00',3.09),('5819','2013-02-19','10:35:00',3.12),('5819','2013-02-19','10:40:00',3.14),('5819','2013-02-19','10:45:00',3.16),('5819','2013-02-19','10:50:00',3.19),('5819','2013-02-19','10:55:00',3.19),('5819','2013-02-19','11:00:00',3.23),('5819','2013-02-19','11:05:00',3.28),('5819','2013-02-19','11:10:00',3.27),('5819','2013-02-19','11:15:00',3.31),('5819','2013-02-19','11:20:00',3.34),('5819','2013-02-19','11:25:00',3.35),('5819','2013-02-19','11:30:00',3.33),('5819','2013-02-19','11:35:00',3.36),('5819','2013-02-19','11:40:00',3.34),('5819','2013-02-19','11:45:00',3.35),('5819','2013-02-19','11:50:00',3.37),('5819','2013-02-19','11:55:00',3.35),('5819','2013-02-19','12:00:00',3.34),('5819','2013-02-19','12:05:00',3.35),('5819','2013-02-19','12:10:00',3.31),('5819','2013-02-19','12:15:00',3.28),('5819','2013-02-19','12:20:00',3.27),('5819','2013-02-19','12:25:00',3.27),('5819','2013-02-19','12:30:00',3.25),('5819','2013-02-19','12:35:00',3.22),('5819','2013-02-19','12:40:00',3.23),('5819','2013-02-19','12:45:00',3.21),('5819','2013-02-19','12:50:00',3.21),('5819','2013-02-19','12:55:00',3.2),('5819','2013-02-19','13:00:00',3.16),('5819','2013-02-19','13:05:00',3.14),('5819','2013-02-19','13:10:00',3.08),('5819','2013-02-19','13:15:00',3.03),('5819','2013-02-19','13:20:00',2.95),('5819','2013-02-19','13:25:00',3.01),('5819','2013-02-19','13:30:00',2.98),('5819','2013-02-19','13:35:00',2.95),('5819','2013-02-19','13:40:00',2.89),('5819','2013-02-19','13:45:00',2.86),('5819','2013-02-19','13:50:00',2.82),('5819','2013-02-19','13:55:00',2.74),('5819','2013-02-19','14:00:00',2.64),('5819','2013-02-19','14:05:00',2.6),('5819','2013-02-19','14:10:00',2.58),('5819','2013-02-19','14:15:00',2.55),('5819','2013-02-19','14:20:00',2.37),('5819','2013-02-19','14:25:00',2.31),('5819','2013-02-19','14:30:00',2.28),('5819','2013-02-19','14:35:00',2.19),('5819','2013-02-19','14:40:00',2.17),('5819','2013-02-19','14:45:00',2.1),('5819','2013-02-19','14:50:00',2.06),('5819','2013-02-19','14:55:00',2.01),('5819','2013-02-19','15:00:00',1.93),('5819','2013-02-19','15:05:00',1.85),('5819','2013-02-19','15:10:00',1.79),('5819','2013-02-19','15:15:00',1.73),('5819','2013-02-19','15:20:00',1.64),('5819','2013-02-19','15:25:00',1.58),('5819','2013-02-19','15:30:00',1.44),('5819','2013-02-19','15:35:00',1.39),('5819','2013-02-19','15:40:00',1.33),('5819','2013-02-19','15:45:00',1.25),('5819','2013-02-19','15:50:00',1.18),('5819','2013-02-19','15:55:00',1.12),('5819','2013-02-19','16:00:00',1.05),('5819','2013-02-18','08:05:00',1.07),('5819','2013-02-18','08:10:00',1.21),('5819','2013-02-18','08:15:00',1.28),('5819','2013-02-18','08:20:00',1.37),('5819','2013-02-18','08:25:00',1.45),('5819','2013-02-18','08:30:00',1.54),('5819','2013-02-18','08:35:00',1.65),('5819','2013-02-18','08:40:00',1.73),('5819','2013-02-18','08:45:00',1.79),('5819','2013-02-18','08:50:00',1.83),('5819','2013-02-18','08:55:00',1.92),('5819','2013-02-18','09:00:00',1.98),('5819','2013-02-18','09:05:00',2.07),('5819','2013-02-18','09:10:00',2.15),('5819','2013-02-18','09:15:00',2.18),('5819','2013-02-18','09:20:00',2.48),('5819','2013-02-18','09:25:00',2.6),('5819','2013-02-18','09:30:00',2.48),('5819','2013-02-18','09:35:00',1.48),('5819','2013-02-18','09:40:00',1.04),('5819','2013-02-18','09:45:00',1.01),('5819','2013-02-18','09:50:00',1.64),('5819','2013-02-18','10:10:00',1.22),('5819','2013-02-18','11:00:00',1.18),('5819','2013-02-18','11:05:00',1.19),('5819','2013-02-18','11:10:00',1.27),('5819','2013-02-18','11:15:00',1.16),('5819','2013-02-18','11:20:00',1.3),('5819','2013-02-18','11:25:00',1.44),('5819','2013-02-18','11:30:00',1.29),('5819','2013-02-18','11:35:00',1.31),('5819','2013-02-18','11:40:00',1.3),('5819','2013-02-18','11:45:00',1.21),('5819','2013-02-18','11:50:00',1.28),('5819','2013-02-18','11:55:00',1.47),('5819','2013-02-18','12:00:00',1.55),('5819','2013-02-18','12:05:00',1.45),('5819','2013-02-18','12:10:00',1.34),('5819','2013-02-18','12:15:00',1.33),('5819','2013-02-18','12:20:00',1.27),('5819','2013-02-18','12:25:00',1.27),('5819','2013-02-18','12:30:00',1.23),('5819','2013-02-18','12:35:00',1.15),('5819','2013-02-18','12:40:00',1.19),('5819','2013-02-18','12:45:00',1.43),('5819','2013-02-18','12:50:00',1.48),('5819','2013-02-18','12:55:00',1.35),('5819','2013-02-18','13:00:00',1.35),('5819','2013-02-18','13:05:00',1.4),('5819','2013-02-18','13:10:00',1.39),('5819','2013-02-18','13:15:00',1.69),('5819','2013-02-18','13:20:00',1.42),('5819','2013-02-18','13:25:00',1.77),('5819','2013-02-18','13:30:00',1.56),('5819','2013-02-18','13:35:00',1.27),('5819','2013-02-18','13:40:00',1.19),('5819','2013-02-18','13:45:00',1.13),('5819','2013-02-18','13:50:00',1.15),('5819','2013-02-18','13:55:00',1.38),('5819','2013-02-18','14:00:00',1.46),('5819','2013-02-18','14:05:00',1.37),('5819','2013-02-18','14:10:00',1.22),('5819','2013-02-18','14:15:00',1.01),('5819','2013-02-18','14:20:00',1.14),('5819','2013-02-17','08:10:00',1.08),('5819','2013-02-17','08:15:00',1.19),('5819','2013-02-17','08:20:00',1.3),('5819','2013-02-17','08:25:00',1.39),('5819','2013-02-17','08:30:00',1.53),('5819','2013-02-17','08:35:00',1.68),('5819','2013-02-17','08:40:00',1.81),('5819','2013-02-17','08:45:00',1.74),('5819','2013-02-17','08:50:00',1.56),('5819','2013-02-17','08:55:00',1.73),('5819','2013-02-17','09:00:00',1.93),('5819','2013-02-17','09:05:00',1.94),('5819','2013-02-17','09:10:00',2.06),('5819','2013-02-17','09:15:00',2.13),('5819','2013-02-17','09:20:00',2.26),('5819','2013-02-17','09:25:00',2.31),('5819','2013-02-17','09:30:00',2.35),('5819','2013-02-17','09:35:00',2.41),('5819','2013-02-17','09:40:00',2.47),('5819','2013-02-17','09:45:00',2.54),('5819','2013-02-17','09:50:00',2.6),('5819','2013-02-17','09:55:00',2.66),('5819','2013-02-17','10:00:00',2.71),('5819','2013-02-17','10:05:00',2.76),('5819','2013-02-17','10:10:00',2.78),('5819','2013-02-17','10:15:00',2.84),('5819','2013-02-17','10:20:00',2.89),('5819','2013-02-17','10:25:00',2.91),('5819','2013-02-17','10:30:00',2.97),('5819','2013-02-17','10:35:00',3),('5819','2013-02-17','10:40:00',3.03),('5819','2013-02-17','10:45:00',3.04),('5819','2013-02-17','10:50:00',3.07),('5819','2013-02-17','10:55:00',3.09),('5819','2013-02-17','11:00:00',3.1),('5819','2013-02-17','11:05:00',3.14),('5819','2013-02-17','11:10:00',3.13),('5819','2013-02-17','11:15:00',3.18),('5819','2013-02-17','11:20:00',3.18),('5819','2013-02-17','11:25:00',3.18),('5819','2013-02-17','11:30:00',3.2),('5819','2013-02-17','11:35:00',3.19),('5819','2013-02-17','11:40:00',3.19),('5819','2013-02-17','11:45:00',3.18),('5819','2013-02-17','11:50:00',3.19),('5819','2013-02-17','11:55:00',3.2),('5819','2013-02-17','12:00:00',3.19),('5819','2013-02-17','12:05:00',3.19),('5819','2013-02-17','12:10:00',3.22),('5819','2013-02-17','12:15:00',3.22),('5819','2013-02-17','12:20:00',3.2),('5819','2013-02-17','12:25:00',3.2),('5819','2013-02-17','12:30:00',3.18),('5819','2013-02-17','12:35:00',3.16),('5819','2013-02-17','12:40:00',3.13),('5819','2013-02-17','12:45:00',3.07),('5819','2013-02-17','12:50:00',3),('5819','2013-02-17','12:55:00',2.98),('5819','2013-02-17','13:00:00',2.99),('5819','2013-02-17','13:05:00',2.96),('5819','2013-02-17','13:10:00',2.91),('5819','2013-02-17','13:15:00',2.89),('5819','2013-02-17','13:20:00',2.8),('5819','2013-02-17','13:25:00',2.78),('5819','2013-02-17','13:30:00',2.8),('5819','2013-02-17','13:35:00',2.73),('5819','2013-02-17','13:40:00',2.66),('5819','2013-02-17','13:45:00',2.59),('5819','2013-02-17','13:50:00',2.45),('5819','2013-02-17','13:55:00',2.44),('5819','2013-02-17','14:00:00',1.26),('5819','2013-02-17','14:10:00',2.22),('5819','2013-02-17','14:15:00',2.39),('5819','2013-02-17','14:20:00',1.27),('5819','2013-02-17','14:25:00',1.3),('5819','2013-02-17','14:30:00',2.22),('5819','2013-02-17','14:35:00',1.91),('5819','2013-02-17','14:40:00',1.36),('5819','2013-02-17','15:05:00',1.17),('5819','2013-02-17','15:10:00',2),('5819','2013-02-17','15:15:00',1.99),('5819','2013-02-17','15:20:00',1.94),('5819','2013-02-17','15:25:00',1.84),('5819','2013-02-17','15:30:00',1.48),('5819','2013-02-17','15:35:00',1.57),('5819','2013-02-17','15:40:00',1.59),('5819','2013-02-17','15:45:00',1.47),('5819','2013-02-17','15:50:00',1.36),('5819','2013-02-17','15:55:00',1.28),('5819','2013-02-17','16:00:00',1.18),('5819','2013-02-17','16:05:00',1.08),('5819','2013-02-16','08:10:00',1.08),('5819','2013-02-16','08:15:00',1.19),('5819','2013-02-16','08:20:00',1.27),('5819','2013-02-16','08:25:00',1.39),('5819','2013-02-16','08:30:00',1.48),('5819','2013-02-16','08:35:00',1.57),('5819','2013-02-16','08:40:00',1.68),('5819','2013-02-16','08:45:00',1.69),('5819','2013-02-16','09:10:00',1.16),('5819','2013-02-16','09:15:00',2.32),('5819','2013-02-16','09:20:00',2.38),('5819','2013-02-16','09:25:00',2.42),('5819','2013-02-16','09:30:00',2.47),('5819','2013-02-16','09:35:00',2.53),('5819','2013-02-16','09:40:00',2.55),('5819','2013-02-16','09:45:00',2.61),('5819','2013-02-16','09:50:00',2.7),('5819','2013-02-16','09:55:00',2.72),('5819','2013-02-16','10:00:00',2.73),('5819','2013-02-16','10:05:00',2.8),('5819','2013-02-16','10:10:00',2.88),('5819','2013-02-16','10:15:00',2.89),('5819','2013-02-16','10:20:00',2.95),('5819','2013-02-16','10:25:00',2.95),('5819','2013-02-16','10:30:00',3.05),('5819','2013-02-16','10:35:00',3.11),('5819','2013-02-16','10:40:00',3.22),('5819','2013-02-16','10:45:00',3.25),('5819','2013-02-16','10:50:00',3.24),('5819','2013-02-16','10:55:00',3.22),('5819','2013-02-16','11:00:00',3.23),('5819','2013-02-16','11:05:00',3.14),('5819','2013-02-16','11:10:00',3.31),('5819','2013-02-16','11:15:00',3.31),('5819','2013-02-16','11:20:00',3.16),('5819','2013-02-16','11:25:00',3.25),('5819','2013-02-16','11:30:00',3.3),('5819','2013-02-16','11:35:00',3.33),('5819','2013-02-16','11:40:00',3.31),('5819','2013-02-16','11:45:00',3.35),('5819','2013-02-16','11:50:00',3.37),('5819','2013-02-16','11:55:00',3.37),('5819','2013-02-16','12:00:00',3.35),('5819','2013-02-16','12:05:00',3.31),('5819','2013-02-16','12:10:00',3.31),('5819','2013-02-16','12:15:00',3.29),('5819','2013-02-16','12:20:00',3.29),('5819','2013-02-16','12:25:00',3.26),('5819','2013-02-16','12:30:00',3.25),('5819','2013-02-16','12:35:00',3.23),('5819','2013-02-16','12:40:00',3.23),('5819','2013-02-16','12:45:00',3.22),('5819','2013-02-16','12:50:00',3.23),('5819','2013-02-16','12:55:00',3.2),('5819','2013-02-16','13:00:00',3.16),('5819','2013-02-16','13:05:00',3.12),('5819','2013-02-16','13:10:00',3.07),('5819','2013-02-16','13:15:00',3.05),('5819','2013-02-16','13:20:00',3),('5819','2013-02-16','13:25:00',2.96),('5819','2013-02-16','13:30:00',2.93),('5819','2013-02-16','13:35:00',2.9),('5819','2013-02-16','13:40:00',2.89),('5819','2013-02-16','13:45:00',2.85),('5819','2013-02-16','13:50:00',2.8),('5819','2013-02-16','13:55:00',2.76),('5819','2013-02-16','14:00:00',2.69),('5819','2013-02-16','14:05:00',2.65),('5819','2013-02-16','14:10:00',2.6),('5819','2013-02-16','14:15:00',2.56),('5819','2013-02-16','14:20:00',2.24),('5819','2013-02-16','14:25:00',1.44),('5819','2013-02-16','15:20:00',1.1),('5819','2013-02-16','15:30:00',1.62),('5819','2013-02-16','15:35:00',1.57),('5819','2013-02-16','15:40:00',1.56),('5819','2013-02-16','15:45:00',1.7),('5819','2013-02-16','15:50:00',1.6),('5819','2013-02-16','15:55:00',1.06),('5819','2013-02-16','16:00:00',1.09),('5819','2013-02-16','16:05:00',1.08),('5819','2013-02-15','08:00:00',1.03),('5819','2013-02-15','09:25:00',1.61),('5819','2013-02-15','09:30:00',1.45),('5819','2013-02-15','09:35:00',1.04),('5819','2013-02-15','09:45:00',1.02),('5819','2013-02-15','09:50:00',1.21),('5819','2013-02-15','09:55:00',1.2),('5819','2013-02-15','10:00:00',1.61),('5819','2013-02-15','10:05:00',1.74),('5819','2013-02-15','10:10:00',1.51),('5819','2013-02-15','10:15:00',1.36),('5819','2013-02-15','10:20:00',1.29),('5819','2013-02-15','10:25:00',2.31),('5819','2013-02-15','10:30:00',1.79),('5819','2013-02-15','10:35:00',2.73),('5819','2013-02-15','10:41:00',3.15),('5819','2013-02-15','10:45:00',2.79),('5819','2013-02-15','10:50:00',2.47),('5819','2013-02-15','10:55:00',1.95),('5819','2013-02-15','11:00:00',1.75),('5819','2013-02-15','11:05:00',1.84),('5819','2013-02-15','11:10:00',2.13),('5819','2013-02-15','11:15:00',2.53),('5819','2013-02-15','11:20:00',3.36),('5819','2013-02-15','11:25:00',3.39),('5819','2013-02-15','11:30:00',3.4),('5819','2013-02-15','11:35:00',2.82),('5819','2013-02-15','11:40:00',1.94),('5819','2013-02-15','11:45:00',1.94),('5819','2013-02-15','11:50:00',3.39),('5819','2013-02-15','11:55:00',3.3),('5819','2013-02-15','12:00:00',2.7),('5819','2013-02-15','12:05:00',2.69),('5819','2013-02-15','12:10:00',2.81),('5819','2013-02-15','12:15:00',2.69),('5819','2013-02-15','12:20:00',3.62),('5819','2013-02-15','12:25:00',3.12),('5819','2013-02-15','12:32:00',3.15),('5819','2013-02-15','12:35:00',3.26),('5819','2013-02-15','12:40:00',3.21),('5819','2013-02-15','12:45:00',3.22),('5819','2013-02-15','12:50:00',3.18),('5819','2013-02-15','12:55:00',3.19),('5819','2013-02-15','13:00:00',3.13),('5819','2013-02-15','13:05:00',3.12),('5819','2013-02-15','13:10:00',3.11),('5819','2013-02-15','13:15:00',3.02),('5819','2013-02-15','13:20:00',2.8),('5819','2013-02-15','13:25:00',2.5),('5819','2013-02-15','13:30:00',2.16),('5819','2013-02-15','13:35:00',2.34),('5819','2013-02-15','13:40:00',3.01),('5819','2013-02-15','13:45:00',2.41),('5819','2013-02-15','13:50:00',2.47),('5819','2013-02-15','13:55:00',2.77),('5819','2013-02-15','14:00:00',1.94),('5819','2013-02-15','14:05:00',2.4),('5819','2013-02-15','14:10:00',3.13),('5819','2013-02-15','14:15:00',2.13),('5819','2013-02-15','14:20:00',2.31),('5819','2013-02-15','14:25:00',1.69),('5819','2013-02-15','14:30:00',1.62),('5819','2013-02-15','14:35:00',2.12),('5819','2013-02-15','14:40:00',2.22),('5819','2013-02-15','14:45:00',1.93),('5819','2013-02-15','14:50:00',1.09),('5819','2013-02-15','14:55:00',1.09),('5819','2013-02-15','15:00:00',1.41),('5819','2013-02-15','15:05:00',1.03),('5819','2013-02-15','15:10:00',1.23),('5819','2013-02-15','15:15:00',1.4),('5819','2013-02-15','15:20:00',1.13),('5819','2013-02-15','15:25:00',1.29),('5819','2013-02-15','15:30:00',1.47),('5819','2013-02-15','15:35:00',1.16),('5819','2013-02-14','08:00:00',1.03),('5819','2013-02-14','08:05:00',1.12),('5819','2013-02-14','08:10:00',1.23),('5819','2013-02-14','08:15:00',1.33),('5819','2013-02-14','08:20:00',1.33),('5819','2013-02-14','08:25:00',1.43),('5819','2013-02-14','08:30:00',1.42),('5819','2013-02-14','08:35:00',1.66),('5819','2013-02-14','08:40:00',1.82),('5819','2013-02-14','08:45:00',1.89),('5819','2013-02-14','08:50:00',1.97),('5819','2013-02-14','08:55:00',2.05),('5819','2013-02-14','09:00:00',2.13),('5819','2013-02-14','09:05:00',2.2),('5819','2013-02-14','09:10:00',2.28),('5819','2013-02-14','09:15:00',2.35),('5819','2013-02-14','09:20:00',2.42),('5819','2013-02-14','09:25:00',2.49),('5819','2013-02-14','09:30:00',2.56),('5819','2013-02-14','09:35:00',2.62),('5819','2013-02-14','09:40:00',2.68),('5819','2013-02-14','09:45:00',2.74),('5819','2013-02-14','09:50:00',2.79),('5819','2013-02-14','09:55:00',2.85),('5819','2013-02-14','10:00:00',2.9),('5819','2013-02-14','10:05:00',2.95),('5819','2013-02-14','10:10:00',3.01),('5819','2013-02-14','10:15:00',3.04),('5819','2013-02-14','10:20:00',3.08),('5819','2013-02-14','10:25:00',3.12),('5819','2013-02-14','10:30:00',3.15),('5819','2013-02-14','10:35:00',3.17),('5819','2013-02-14','10:40:00',3.21),('5819','2013-02-14','10:45:00',3.24),('5819','2013-02-14','10:50:00',3.27),('5819','2013-02-14','10:55:00',3.3),('5819','2013-02-14','11:00:00',3.32),('5819','2013-02-14','11:05:00',3.33),('5819','2013-02-14','11:10:00',3.35),('5819','2013-02-14','11:15:00',3.36),('5819','2013-02-14','11:20:00',3.36),('5819','2013-02-14','11:25:00',3.37),('5819','2013-02-14','11:30:00',3.38),('5819','2013-02-14','11:35:00',3.38),('5819','2013-02-14','11:40:00',3.37),('5819','2013-02-14','11:45:00',3.39),('5819','2013-02-14','11:50:00',3.39),('5819','2013-02-14','11:55:00',3.41),('5819','2013-02-14','12:00:00',3.39),('5819','2013-02-14','12:05:00',3.38),('5819','2013-02-14','12:10:00',3.36),('5819','2013-02-14','12:15:00',3.36),('5819','2013-02-14','12:20:00',3.34),('5819','2013-02-14','12:25:00',3.33),('5819','2013-02-14','12:30:00',3.31),('5819','2013-02-14','12:35:00',3.3),('5819','2013-02-14','12:40:00',3.28),('5819','2013-02-14','12:45:00',3.24),('5819','2013-02-14','12:50:00',3.2),('5819','2013-02-14','12:55:00',3.18),('5819','2013-02-14','13:00:00',3.15),('5819','2013-02-14','13:05:00',3.12),('5819','2013-02-14','13:10:00',3.11),('5819','2013-02-14','13:15:00',3.08),('5819','2013-02-14','13:20:00',3.03),('5819','2013-02-14','13:25:00',2.98),('5819','2013-02-14','13:30:00',2.94),('5819','2013-02-14','13:35:00',2.91),('5819','2013-02-14','13:40:00',2.87),('5819','2013-02-14','13:45:00',2.82),('5819','2013-02-14','13:50:00',2.78),('5819','2013-02-14','13:55:00',2.72),('5819','2013-02-14','14:00:00',2.66),('5819','2013-02-14','14:05:00',2.62),('5819','2013-02-14','14:10:00',2.55),('5819','2013-02-14','14:15:00',2.49),('5819','2013-02-14','14:20:00',2.44),('5819','2013-02-14','14:25:00',2.37),('5819','2013-02-14','14:30:00',2.31),('5819','2013-02-14','14:35:00',2.24),('5819','2013-02-14','14:40:00',2.17),('5819','2013-02-14','14:45:00',2.11),('5819','2013-02-14','14:50:00',2.06),('5819','2013-02-14','14:55:00',1.97),('5819','2013-02-14','15:00:00',1.89),('5819','2013-02-14','15:05:00',1.81),('5819','2013-02-14','15:10:00',1.73),('5819','2013-02-14','15:15:00',1.66),('5819','2013-02-14','15:20:00',1.57),('5819','2013-02-14','15:25:00',1.49),('5819','2013-02-14','15:30:00',1.42),('5819','2013-02-14','15:35:00',1.34),('5819','2013-02-14','15:40:00',1.26),('5819','2013-02-14','15:45:00',1.19),('5819','2013-02-14','15:50:00',1.13),('5819','2013-02-14','15:55:00',1.06),('5819','2013-02-13','09:00:00',1.13),('5819','2013-02-13','09:05:00',1.33),('5819','2013-02-13','09:10:00',1.43),('5819','2013-02-13','09:15:00',1.36),('5819','2013-02-13','09:20:00',1.33),('5819','2013-02-13','09:25:00',1.31),('5819','2013-02-13','09:30:00',1.47),('5819','2013-02-13','09:35:00',1.75),('5819','2013-02-13','09:40:00',2.34),('5819','2013-02-13','09:45:00',2.62),('5819','2013-02-13','09:50:00',2.58),('5819','2013-02-13','09:55:00',2.63),('5819','2013-02-13','10:00:00',2.38),('5819','2013-02-13','10:05:00',2.63),('5819','2013-02-13','10:10:00',2.78),('5819','2013-02-13','10:15:00',2.93),('5819','2013-02-13','10:20:00',2.97),('5819','2013-02-13','10:25:00',3.09),('5819','2013-02-13','10:30:00',3.16),('5819','2013-02-13','10:35:00',3.14),('5819','2013-02-13','10:40:00',3.25),('5819','2013-02-13','10:45:00',3.41),('5819','2013-02-13','10:50:00',3.41),('5819','2013-02-13','10:55:00',3.36),('5819','2013-02-13','11:00:00',3.34),('5819','2013-02-13','11:05:00',3.2),('5819','2013-02-13','11:10:00',3.25),('5819','2013-02-13','11:15:00',3.28),('5819','2013-02-13','11:20:00',3.21),('5819','2013-02-13','11:25:00',2.81),('5819','2013-02-13','11:30:00',2.39),('5819','2013-02-13','11:35:00',2.12),('5819','2013-02-13','11:40:00',1.34),('5819','2013-02-13','11:45:00',1.35),('5819','2013-02-13','11:50:00',1.72),('5819','2013-02-13','12:10:00',1.18),('5819','2013-02-13','12:15:00',2.52),('5819','2013-02-13','12:20:00',1.63),('5819','2013-02-13','12:25:00',2.05),('5819','2013-02-13','12:40:00',1.13),('5819','2013-02-13','12:45:00',1.1),('5819','2013-02-13','12:50:00',1.9),('5819','2013-02-13','12:55:00',2.09),('5819','2013-02-13','13:00:00',2.34),('5819','2013-02-13','13:05:00',2.5),('5819','2013-02-13','13:10:00',2.15),('5819','2013-02-13','13:15:00',1.76),('5819','2013-02-13','13:20:00',3),('5819','2013-02-13','13:25:00',3.09),('5819','2013-02-13','13:30:00',3.19),('5819','2013-02-13','13:35:00',3.07),('5819','2013-02-13','13:40:00',2.8),('5819','2013-02-13','13:45:00',2.57),('5819','2013-02-13','13:50:00',2.22),('5819','2013-02-13','13:55:00',2.3),('5819','2013-02-13','14:00:00',2.72),('5819','2013-02-13','14:05:00',2.76),('5819','2013-02-13','14:10:00',2.22),('5819','2013-02-13','14:15:00',2.36),('5819','2013-02-13','14:20:00',2.05),('5819','2013-02-13','14:25:00',2.19),('5819','2013-02-13','14:30:00',2.25),('5819','2013-02-13','14:35:00',2.31),('5819','2013-02-13','14:40:00',2.21),('5819','2013-02-13','14:45:00',2.07),('5819','2013-02-13','14:50:00',2.07),('5819','2013-02-13','14:55:00',2),('5819','2013-02-13','15:00:00',1.9),('5819','2013-02-13','15:05:00',1.82),('5819','2013-02-13','15:10:00',1.73),('5819','2013-02-13','15:15:00',1.65),('5819','2013-02-13','15:20:00',1.57),('5819','2013-02-13','15:25:00',1.52),('5819','2013-02-13','15:30:00',1.45),('5819','2013-02-13','15:35:00',1.37),('5819','2013-02-13','15:40:00',1.32),('5819','2013-02-13','15:45:00',1.24),('5819','2013-02-13','15:50:00',1.14),('5819','2013-02-13','15:55:00',1.08),('5819','2013-02-13','16:00:00',1.01),('5819','2013-02-11','10:35:00',1.17),('5819','2013-02-11','10:40:00',1.06),('5819','2013-02-11','11:05:00',1.16),('5819','2013-02-11','11:10:00',1.21),('5819','2013-02-11','11:15:00',1.28),('5819','2013-02-11','11:20:00',1.05),('5819','2013-02-11','12:45:00',1.09),('5819','2013-02-11','14:10:00',1.07),('5819','2013-02-11','14:25:00',1.31),('5819','2013-02-11','14:30:00',1.79),('5819','2013-02-11','14:40:00',1.33),('5819','2013-02-11','14:45:00',1.04),('5819','2013-02-10','09:45:00',1.34),('5819','2013-02-10','09:50:00',1.51),('5819','2013-02-10','09:55:00',1.07),('5819','2013-02-10','10:00:00',2.52),('5819','2013-02-10','10:05:00',2.94),('5819','2013-02-10','10:10:00',2.88),('5819','2013-02-10','10:15:00',2.97),('5819','2013-02-10','10:20:00',3),('5819','2013-02-10','10:25:00',3.05),('5819','2013-02-10','10:30:00',3.09),('5819','2013-02-10','10:35:00',3.11),('5819','2013-02-10','10:40:00',3.13),('5819','2013-02-10','10:45:00',3.17),('5819','2013-02-10','10:50:00',3.2),('5819','2013-02-10','10:55:00',3.22),('5819','2013-02-10','11:00:00',3.24),('5819','2013-02-10','11:05:00',3.25),('5819','2013-02-10','11:10:00',3.25),('5819','2013-02-10','11:15:00',3.26),('5819','2013-02-10','11:20:00',3.26),('5819','2013-02-10','11:25:00',3.26),('5819','2013-02-10','11:30:00',3.29),('5819','2013-02-10','11:35:00',3.29),('5819','2013-02-10','11:40:00',3.3),('5819','2013-02-10','11:45:00',3.31),('5819','2013-02-10','11:50:00',3.31),('5819','2013-02-10','11:55:00',3.33),('5819','2013-02-10','12:00:00',3.35),('5819','2013-02-10','12:05:00',3.34),('5819','2013-02-10','12:10:00',3.35),('5819','2013-02-10','12:15:00',3.35),('5819','2013-02-10','12:20:00',3.32),('5819','2013-02-10','12:25:00',3.3),('5819','2013-02-10','12:30:00',3.29),('5819','2013-02-10','12:35:00',3.26),('5819','2013-02-10','12:40:00',3.23),('5819','2013-02-10','12:45:00',3.22),('5819','2013-02-10','12:50:00',3.23),('5819','2013-02-10','12:55:00',3.18),('5819','2013-02-10','13:00:00',3.12),('5819','2013-02-10','13:05:00',3.06),('5819','2013-02-10','13:10:00',3.04),('5819','2013-02-10','13:15:00',3),('5819','2013-02-10','13:20:00',2.98),('5819','2013-02-10','13:25:00',2.95),('5819','2013-02-10','13:30:00',2.9),('5819','2013-02-10','13:35:00',2.82),('5819','2013-02-10','13:40:00',2.75),('5819','2013-02-10','13:45:00',2.71),('5819','2013-02-10','13:50:00',2.67),('5819','2013-02-10','13:55:00',2.61),('5819','2013-02-10','14:00:00',2.55),('5819','2013-02-10','14:05:00',2.51),('5819','2013-02-10','14:10:00',2.44),('5819','2013-02-10','14:15:00',2.4),('5819','2013-02-10','14:20:00',2.34),('5819','2013-02-10','14:25:00',2.23),('5819','2013-02-10','14:30:00',2.2),('5819','2013-02-10','14:35:00',2.17),('5819','2013-02-10','14:40:00',1.68),('5819','2013-02-10','14:45:00',2.06),('5819','2013-02-10','14:50:00',1.96),('5819','2013-02-10','14:55:00',1.88),('5819','2013-02-10','15:00:00',1.33),('5819','2013-02-10','15:05:00',1.02),('5819','2013-02-10','15:10:00',1.68),('5819','2013-02-10','15:25:00',1.48),('5819','2013-02-10','15:35:00',1.33),('5819','2013-02-09','11:10:00',1),('5819','2013-02-09','11:15:00',1.05),('5819','2013-02-09','11:20:00',1.08),('5819','2013-02-09','11:25:00',1.09),('5819','2013-02-09','11:30:00',1.11),('5819','2013-02-09','11:35:00',1.08),('5819','2013-02-09','11:40:00',1.05),('5819','2013-02-09','11:45:00',1.07),('5819','2013-02-09','11:50:00',1.07),('5819','2013-02-09','11:55:00',1.03),('5819','2013-02-09','12:00:00',1.04),('5819','2013-02-09','12:05:00',1.04),('5819','2013-02-09','12:10:00',1.03),('5819','2013-02-09','12:15:00',1.03),('5819','2013-02-09','12:20:00',1.04),('5819','2013-02-09','12:25:00',1.05),('5819','2013-02-09','12:30:00',1.06),('5819','2013-02-09','12:35:00',1.12),('5819','2013-02-09','12:40:00',1.15),('5819','2013-02-09','12:45:00',1.16),('5819','2013-02-09','12:50:00',1.18),('5819','2013-02-09','12:55:00',1.16),('5819','2013-02-09','13:00:00',1.02),('5819','2013-02-09','13:05:00',1.12),('5819','2013-02-09','13:10:00',1.54),('5819','2013-02-09','13:15:00',1.71),('5819','2013-02-09','13:20:00',1.87),('5819','2013-02-09','13:25:00',1.99),('5819','2013-02-09','13:30:00',2.34),('5819','2013-02-09','13:35:00',2.33),('5819','2013-02-09','13:40:00',2.44),('5819','2013-02-09','13:45:00',2.62),('5819','2013-02-09','13:50:00',2.81),('5819','2013-02-09','13:55:00',2.7),('5819','2013-02-09','14:00:00',2.76),('5819','2013-02-09','14:05:00',2.54),('5819','2013-02-09','14:10:00',1.91),('5819','2013-02-09','14:15:00',2.51),('5819','2013-02-09','14:20:00',2.79),('5819','2013-02-09','14:25:00',2.95),('5819','2013-02-09','14:30:00',2.67),('5819','2013-02-09','14:35:00',2.4),('5819','2013-02-09','14:40:00',2.15),('5819','2013-02-09','14:45:00',2.01),('5819','2013-02-09','14:50:00',1.94),('5819','2013-02-09','14:55:00',1.91),('5819','2013-02-09','15:00:00',1.79),('5819','2013-02-09','15:05:00',1.7),('5819','2013-02-09','15:10:00',1.63),('5819','2013-02-09','15:15:00',1.53),('5819','2013-02-09','15:20:00',1.45),('5819','2013-02-09','15:25:00',1.32),('5819','2013-02-09','15:30:00',1.27),('5819','2013-02-09','15:35:00',1.22),('5819','2013-02-09','15:50:00',1),('5819','2013-02-08','09:35:00',2.14),('5819','2013-02-08','09:40:00',2.77),('5819','2013-02-08','09:45:00',2.61),('5819','2013-02-08','09:50:00',3.09),('5819','2013-02-08','09:55:00',3.15),('5819','2013-02-08','10:00:00',3.27),('5819','2013-02-08','10:05:00',3.46),('5819','2013-02-08','10:10:00',3.54),('5819','2013-02-08','10:15:00',3.66),('5819','2013-02-08','10:20:00',3.56),('5819','2013-02-08','10:25:00',3.52),('5819','2013-02-08','10:30:00',3.61),('5819','2013-02-08','10:35:00',1.8),('5819','2013-02-08','10:40:00',2.45),('5819','2013-02-08','10:45:00',3.56),('5819','2013-02-08','10:50:00',3.59),('5819','2013-02-08','10:55:00',3.51),('5819','2013-02-08','11:00:00',3.41),('5819','2013-02-08','11:05:00',3.37),('5819','2013-02-08','11:10:00',3.36),('5819','2013-02-08','11:15:00',3.34),('5819','2013-02-08','11:20:00',3.34),('5819','2013-02-08','11:25:00',3.34),('5819','2013-02-08','11:30:00',3.32),('5819','2013-02-08','11:35:00',3.31),('5819','2013-02-08','11:40:00',3.33),('5819','2013-02-08','11:45:00',3.33),('5819','2013-02-08','11:50:00',3.32),('5819','2013-02-08','11:55:00',3.32),('5819','2013-02-08','12:00:00',3.3),('5819','2013-02-08','12:05:00',3.3),('5819','2013-02-08','12:10:00',3.3),('5819','2013-02-08','12:15:00',3.28),('5819','2013-02-08','12:20:00',3.27),('5819','2013-02-08','12:25:00',3.26),('5819','2013-02-08','12:30:00',3.26),('5819','2013-02-08','12:35:00',3.24),('5819','2013-02-08','12:40:00',3.31),('5819','2013-02-08','12:45:00',3.22),('5819','2013-02-08','12:50:00',2.61),('5819','2013-02-08','12:55:00',1.84),('5819','2013-02-08','13:00:00',1.74),('5819','2013-02-08','13:05:00',1.63),('5819','2013-02-08','13:10:00',1.78),('5819','2013-02-08','13:15:00',1.74),('5819','2013-02-08','13:20:00',1.79),('5819','2013-02-08','13:25:00',1.7),('5819','2013-02-08','13:30:00',1.62),('5819','2013-02-08','13:35:00',2.1),('5819','2013-02-08','13:40:00',1.85),('5819','2013-02-08','13:45:00',1.47),('5819','2013-02-08','13:50:00',1.48),('5819','2013-02-08','13:55:00',1.49),('5819','2013-02-08','14:00:00',1.41),('5819','2013-02-08','14:05:00',1.35),('5819','2013-02-08','14:10:00',1.24),('5819','2013-02-08','14:15:00',1.1),('5819','2013-02-08','14:20:00',1.08),('5819','2013-02-08','14:25:00',1.17),('5819','2013-02-08','14:30:00',1.57),('5819','2013-02-08','14:35:00',1.57),('5819','2013-02-08','14:40:00',2.66),('5819','2013-02-08','14:45:00',2.8),('5819','2013-02-08','14:50:00',1.76),('5819','2013-02-08','14:55:00',2.22),('5819','2013-02-08','15:00:00',2.16),('5819','2013-02-08','15:05:00',2.41),('5819','2013-02-08','15:10:00',2.37),('5819','2013-02-08','15:15:00',2.12),('5819','2013-02-08','15:20:00',1.58),('5819','2013-02-08','15:25:00',1.64),('5819','2013-02-08','15:30:00',1.47),('5819','2013-02-08','15:35:00',1.36),('5819','2013-02-08','15:40:00',1.27),('5819','2013-02-08','15:45:00',1.2),('5819','2013-02-08','15:50:00',1.12),('5819','2013-02-08','15:55:00',1.03),('5819','2013-02-07','10:40:00',1.15),('5819','2013-02-07','10:45:00',1.53),('5819','2013-02-07','10:55:00',1.16),('5819','2013-02-07','11:00:00',2.11),('5819','2013-02-07','11:05:00',1.33),('5819','2013-02-07','12:25:00',2.44),('5819','2013-02-07','12:30:00',2.1),('5819','2013-02-07','12:35:00',1.07),('5819','2013-02-07','13:15:00',1.04),('5819','2013-02-07','13:20:00',1.28),('5819','2013-02-07','13:25:00',1.13),('5819','2013-02-07','14:00:00',1.14),('5819','2013-02-07','14:05:00',1.6),('5819','2013-02-07','14:10:00',2.56),('5819','2013-02-07','14:15:00',2.46),('5819','2013-02-07','14:20:00',2.34),('5819','2013-02-07','14:25:00',1.27),('5819','2013-02-07','14:35:00',1.53),('5819','2013-02-07','14:40:00',1.37),('5819','2013-02-07','14:45:00',1.79),('5819','2013-02-07','14:50:00',1.22),('5819','2013-02-07','14:55:00',1.03),('5819','2013-02-07','15:00:00',1.4),('5819','2013-02-07','15:05:00',1.98),('5819','2013-02-07','15:10:00',2.11),('5819','2013-02-07','15:15:00',1.72),('5819','2013-02-07','15:25:00',1.03),('5819','2013-02-06','08:45:00',1.11),('5819','2013-02-06','08:50:00',1.55),('5819','2013-02-06','08:55:00',1.08),('5819','2013-02-06','09:00:00',1.17),('5819','2013-02-06','09:05:00',1.38),('5819','2013-02-06','09:10:00',1.73),('5819','2013-02-06','09:25:00',1.11),('5819','2013-02-06','09:30:00',1.59),('5819','2013-02-06','09:35:00',1.15),('5819','2013-02-06','09:40:00',1.74),('5819','2013-02-06','09:45:00',1.18),('5819','2013-02-06','09:50:00',1.26),('5819','2013-02-06','09:55:00',1.58),('5819','2013-02-06','10:00:00',1.29),('5819','2013-02-06','10:05:00',1.74),('5819','2013-02-06','10:10:00',1.5),('5819','2013-02-06','10:15:00',1.31),('5819','2013-02-06','10:20:00',1.17),('5819','2013-02-06','10:25:00',1.61),('5819','2013-02-06','10:30:00',1.4),('5819','2013-02-06','10:35:00',1.84),('5819','2013-02-06','10:40:00',1.34),('5819','2013-02-06','10:45:00',1.01),('5819','2013-02-06','10:50:00',1.57),('5819','2013-02-06','10:55:00',2.26),('5819','2013-02-06','11:00:00',1.82),('5819','2013-02-06','11:05:00',1.3),('5819','2013-02-06','11:10:00',1.52),('5819','2013-02-06','11:15:00',1.36),('5819','2013-02-06','11:20:00',1.83),('5819','2013-02-06','11:25:00',2.47),('5819','2013-02-06','11:30:00',1.62),('5819','2013-02-06','11:35:00',1.4),('5819','2013-02-06','11:40:00',1.52),('5819','2013-02-06','11:45:00',1.55),('5819','2013-02-06','11:50:00',1.59),('5819','2013-02-06','11:55:00',1.5),('5819','2013-02-06','12:00:00',1.3),('5819','2013-02-06','12:05:00',1.08),('5819','2013-02-06','12:20:00',1),('5819','2013-02-06','13:30:00',1.06),('5819','2013-02-06','13:35:00',1.19),('5819','2013-02-06','13:50:00',1.54),('5819','2013-02-06','13:55:00',1.18),('5819','2013-02-06','14:00:00',1.33),('5819','2013-02-06','14:05:00',1.24),('5819','2013-02-06','14:30:00',1.19),('5819','2013-02-06','14:35:00',2.12),('5819','2013-02-06','14:40:00',1.18),('5819','2013-02-05','08:15:00',1.09),('5819','2013-02-05','08:20:00',1.18),('5819','2013-02-05','08:25:00',1.27),('5819','2013-02-05','08:30:00',1.36),('5819','2013-02-05','08:35:00',1.46),('5819','2013-02-05','08:40:00',1.53),('5819','2013-02-05','08:45:00',1.58),('5819','2013-02-05','08:50:00',1.68),('5819','2013-02-05','08:55:00',1.74),('5819','2013-02-05','09:00:00',1.82),('5819','2013-02-05','09:05:00',1.88),('5819','2013-02-05','09:10:00',1.96),('5819','2013-02-05','09:15:00',2.03),('5819','2013-02-05','09:20:00',2.11),('5819','2013-02-05','09:25:00',2.18),('5819','2013-02-05','09:30:00',2.22),('5819','2013-02-05','09:35:00',2.29),('5819','2013-02-05','09:40:00',2.36),('5819','2013-02-05','09:45:00',2.41),('5819','2013-02-05','09:50:00',2.47),('5819','2013-02-05','09:55:00',2.52),('5819','2013-02-05','10:00:00',2.53),('5819','2013-02-05','10:05:00',2.58),('5819','2013-02-05','10:10:00',2.43),('5819','2013-02-05','10:15:00',2.44),('5819','2013-02-05','10:20:00',2.72),('5819','2013-02-05','10:25:00',2.78),('5819','2013-02-05','10:30:00',2.81),('5819','2013-02-05','10:35:00',2.84),('5819','2013-02-05','10:40:00',2.86),('5819','2013-02-05','10:45:00',2.87),('5819','2013-02-05','10:50:00',2.85),('5819','2013-02-05','10:55:00',2.86),('5819','2013-02-05','11:00:00',2.88),('5819','2013-02-05','11:05:00',2.88),('5819','2013-02-05','11:10:00',2.93),('5819','2013-02-05','11:15:00',2.96),('5819','2013-02-05','11:20:00',2.94),('5819','2013-02-05','11:25:00',2.96),('5819','2013-02-05','11:30:00',2.89),('5819','2013-02-05','11:35:00',2.78),('5819','2013-02-05','11:40:00',2.44),('5819','2013-02-05','11:45:00',2.12),('5819','2013-02-05','11:50:00',1.7),('5819','2013-02-05','11:55:00',1.44),('5819','2013-02-05','12:00:00',1.18),('5819','2013-02-05','12:10:00',2.16),('5819','2013-02-05','12:15:00',1.58),('5819','2013-02-05','12:20:00',1.14),('5819','2013-02-05','12:25:00',1.09),('5819','2013-02-05','12:35:00',1.08),('5819','2013-02-05','12:40:00',1.56),('5819','2013-02-05','12:45:00',1.69),('5819','2013-02-05','12:50:00',2.05),('5819','2013-02-05','13:15:00',1.15),('5819','2013-02-05','13:20:00',1.22),('5819','2013-02-05','13:25:00',1.15),('5819','2013-02-05','13:30:00',1.15),('5819','2013-02-05','13:45:00',1.15),('5819','2013-02-05','13:50:00',1.25),('5819','2013-02-05','13:55:00',1.09),('5819','2013-02-05','14:00:00',1.05),('5819','2013-02-05','14:05:00',1.14),('5819','2013-02-05','14:20:00',1.02),('5819','2013-02-05','14:25:00',1.53),('5819','2013-02-05','14:30:00',1.57),('5819','2013-02-05','14:35:00',1.43),('5819','2013-02-05','14:40:00',1.62),('5819','2013-02-04','08:10:00',1.02),('5819','2013-02-04','08:15:00',1.13),('5819','2013-02-04','08:20:00',1.23),('5819','2013-02-04','08:25:00',1.33),('5819','2013-02-04','08:30:00',1.43),('5819','2013-02-04','08:35:00',1.52),('5819','2013-02-04','08:40:00',1.61),('5819','2013-02-04','08:45:00',1.69),('5819','2013-02-04','08:50:00',1.77),('5819','2013-02-04','08:55:00',1.6),('5819','2013-02-04','09:00:00',1.96),('5819','2013-02-04','09:05:00',2.07),('5819','2013-02-04','09:10:00',2.18),('5819','2013-02-04','09:15:00',2.23),('5819','2013-02-04','09:20:00',2.19),('5819','2013-02-04','09:25:00',2.17),('5819','2013-02-04','09:30:00',2.33),('5819','2013-02-04','09:35:00',2.33),('5819','2013-02-04','09:40:00',2.38),('5819','2013-02-04','09:45:00',2.13),('5819','2013-02-04','09:50:00',2.52),('5819','2013-02-04','09:55:00',2.71),('5819','2013-02-04','10:00:00',2.76),('5819','2013-02-04','10:05:00',2.8),('5819','2013-02-04','10:10:00',2.89),('5819','2013-02-04','10:15:00',2.96),('5819','2013-02-04','10:20:00',2.8),('5819','2013-02-04','10:25:00',2.92),('5819','2013-02-04','10:30:00',2.79),('5819','2013-02-04','10:35:00',2.62),('5819','2013-02-04','10:40:00',2.78),('5819','2013-02-04','10:45:00',3.02),('5819','2013-02-04','10:50:00',3.08),('5819','2013-02-04','10:55:00',3.05),('5819','2013-02-04','11:00:00',3.06),('5819','2013-02-04','11:05:00',3.12),('5819','2013-02-04','11:10:00',3.13),('5819','2013-02-04','11:15:00',3.14),('5819','2013-02-04','11:20:00',3.15),('5819','2013-02-04','11:25:00',3.15),('5819','2013-02-04','11:30:00',3.15),('5819','2013-02-04','11:35:00',3.14),('5819','2013-02-04','11:40:00',3.16),('5819','2013-02-04','11:45:00',3.15),('5819','2013-02-04','11:50:00',3.16),('5819','2013-02-04','11:55:00',3.15),('5819','2013-02-04','12:00:00',3.15),('5819','2013-02-04','12:05:00',3.16),('5819','2013-02-04','12:10:00',3.15),('5819','2013-02-04','12:15:00',3.13),('5819','2013-02-04','12:20:00',3.11),('5819','2013-02-04','12:25:00',3.09),('5819','2013-02-04','12:30:00',3.08),('5819','2013-02-04','12:35:00',3.06),('5819','2013-02-04','12:40:00',3.05),('5819','2013-02-04','12:45:00',3.02),('5819','2013-02-04','12:50:00',2.97),('5819','2013-02-04','12:55:00',2.98),('5819','2013-02-04','13:00:00',2.97),('5819','2013-02-04','13:05:00',2.94),('5819','2013-02-04','13:10:00',2.91),('5819','2013-02-04','13:15:00',2.87),('5819','2013-02-04','13:20:00',2.83),('5819','2013-02-04','13:25:00',2.79),('5819','2013-02-04','13:30:00',2.76),('5819','2013-02-04','13:35:00',2.71),('5819','2013-02-04','13:40:00',2.65),('5819','2013-02-04','13:45:00',2.6),('5819','2013-02-04','13:50:00',2.58),('5819','2013-02-04','13:55:00',2.54),('5819','2013-02-04','14:00:00',2.48),('5819','2013-02-04','14:05:00',2.43),('5819','2013-02-04','14:10:00',2.37),('5819','2013-02-04','14:15:00',2.31),('5819','2013-02-04','14:20:00',2.25),('5819','2013-02-04','14:25:00',2.19),('5819','2013-02-04','14:30:00',2.12),('5819','2013-02-04','14:35:00',2.06),('5819','2013-02-04','14:40:00',2),('5819','2013-02-04','14:45:00',1.94),('5819','2013-02-04','14:50:00',1.85),('5819','2013-02-04','14:55:00',1.77),('5819','2013-02-04','15:00:00',1.71),('5819','2013-02-04','15:05:00',1.63),('5819','2013-02-04','15:10:00',1.56),('5819','2013-02-04','15:15:00',1.48),('5819','2013-02-04','15:20:00',1.41),('5819','2013-02-04','15:25:00',1.34),('5819','2013-02-04','15:30:00',1.27),('5819','2013-02-04','15:35:00',1.19),('5819','2013-02-04','15:40:00',1.12),('5819','2013-02-04','15:45:00',1.05),('5819','2013-02-03','09:25:00',1.2),('5819','2013-02-03','09:40:00',1.17),('5819','2013-02-03','09:45:00',1.54),('5819','2013-02-03','09:50:00',1.59),('5819','2013-02-03','09:55:00',1.24),('5819','2013-02-03','10:00:00',2.02),('5819','2013-02-03','10:05:00',1.14),('5819','2013-02-03','11:20:00',1.19),('5819','2013-02-03','12:00:00',1.15),('5819','2013-02-03','12:05:00',1.08),('5819','2013-02-03','12:10:00',1.02),('5819','2013-02-02','10:30:00',1.08),('5819','2013-02-02','10:35:00',1.23),('5819','2013-02-02','10:40:00',1.38),('5819','2013-02-02','10:45:00',1.56),('5819','2013-02-02','10:50:00',1.25),('5819','2013-02-02','10:55:00',1.7),('5819','2013-02-02','11:00:00',1.99),('5819','2013-02-02','11:05:00',1.78),('5819','2013-02-02','11:10:00',1.9),('5819','2013-02-02','11:15:00',1.85),('5819','2013-02-02','11:20:00',1.81),('5819','2013-02-02','11:25:00',1.93),('5819','2013-02-02','11:30:00',1.92),('5819','2013-02-02','11:35:00',1.65),('5819','2013-02-02','11:40:00',1.65),('5819','2013-02-02','11:45:00',1.1),('5819','2013-02-02','11:55:00',1.04),('5819','2013-02-02','12:55:00',2.03),('5819','2013-02-02','13:00:00',1.77),('5819','2013-02-02','13:05:00',1.81),('5819','2013-02-02','13:10:00',1.63),('5819','2013-02-02','13:15:00',1.93),('5819','2013-02-02','13:20:00',1.71),('5819','2013-02-02','13:25:00',1.54),('5819','2013-02-02','13:30:00',1.13),('5819','2013-02-02','13:35:00',1.86),('5819','2013-02-02','13:40:00',2.36),('5819','2013-02-02','13:45:00',1.79),('5819','2013-02-02','13:50:00',1.79),('5819','2013-02-02','13:55:00',1.16),('5819','2013-02-01','08:25:00',1.16),('5819','2013-02-01','08:30:00',1.11),('5819','2013-02-01','08:35:00',1.2),('5819','2013-02-01','08:40:00',1.26),('5819','2013-02-01','08:45:00',1.35),('5819','2013-02-01','09:00:00',1.59),('5819','2013-02-01','09:05:00',1.77),('5819','2013-02-01','09:10:00',1.98),('5819','2013-02-01','09:15:00',1.15),('5819','2013-02-01','09:25:00',1.74),('5819','2013-02-01','09:30:00',1.33),('5819','2013-02-01','09:35:00',1.18),('5819','2013-02-01','09:40:00',1.75),('5819','2013-02-01','09:45:00',1.34),('5819','2013-02-01','09:50:00',1.27),('5819','2013-02-01','09:55:00',1.05),('5819','2013-02-01','10:00:00',1.71),('5819','2013-02-01','10:10:00',1.29),('5819','2013-02-01','10:20:00',1.95),('5819','2013-02-01','10:25:00',1.59),('5819','2013-02-01','10:30:00',1.18),('5819','2013-02-01','10:35:00',1.37),('5819','2013-02-01','10:50:00',2.18),('5819','2013-02-01','10:55:00',3.26),('5819','2013-02-01','11:00:00',3.05),('5819','2013-02-01','11:05:00',2.82),('5819','2013-02-01','11:10:00',2.96),('5819','2013-02-01','11:15:00',1.92),('5819','2013-02-01','11:20:00',2.33),('5819','2013-02-01','11:25:00',1.67),('5819','2013-02-01','11:30:00',1.01),('5819','2013-02-01','11:35:00',1.48),('5819','2013-02-01','11:40:00',2.59),('5819','2013-02-01','11:45:00',1.54),('5819','2013-02-01','11:50:00',1.76),('5819','2013-02-01','11:55:00',1.06),('5819','2013-02-01','12:00:00',1.16),('5819','2013-02-01','12:05:00',1.27),('5819','2013-02-01','12:10:00',1.55),('5819','2013-02-01','12:15:00',1.77),('5819','2013-02-01','12:20:00',3.48),('5819','2013-02-01','12:25:00',3.14),('5819','2013-02-01','12:30:00',1.32),('5819','2013-02-01','12:35:00',1.09),('5819','2013-02-01','12:40:00',2.5),('5819','2013-02-01','12:45:00',2.48),('5819','2013-02-01','12:50:00',2.9),('5819','2013-02-01','12:55:00',3.3),('5819','2013-02-01','13:00:00',3.17),('5819','2013-02-01','13:05:00',1.92),('5819','2013-02-01','13:10:00',2.9),('5819','2013-02-01','13:15:00',2.71),('5819','2013-02-01','13:20:00',2.71),('5819','2013-02-01','13:25:00',1.89),('5819','2013-02-01','13:30:00',1.89),('5819','2013-02-01','13:35:00',2.06),('5819','2013-02-01','13:40:00',2.06),('5819','2013-02-01','13:45:00',2.1),('5819','2013-02-01','13:50:00',1.73),('5819','2013-02-01','13:55:00',1.22),('5819','2013-02-01','14:15:00',1.57),('5819','2013-02-01','14:20:00',2.16),('5819','2013-02-01','14:25:00',2.18),('5819','2013-02-01','14:30:00',2.09),('5819','2013-02-01','14:35:00',1.98),('5819','2013-02-01','14:40:00',1.78),('5819','2013-02-01','15:05:00',1.05),('5819','2013-02-01','15:10:00',1.66),('5819','2013-02-01','15:15:00',1.09),('5819','2013-02-01','15:20:00',1.39),('5819','2013-01-31','09:10:00',1.02),('5819','2013-01-31','09:20:00',1.38),('5819','2013-01-31','09:25:00',2),('5819','2013-01-31','09:30:00',2.25),('5819','2013-01-31','09:35:00',2.16),('5819','2013-01-31','09:40:00',2.21),('5819','2013-01-31','09:45:00',2.07),('5819','2013-01-31','09:50:00',2.2),('5819','2013-01-31','09:55:00',2.43),('5819','2013-01-31','10:00:00',2.42),('5819','2013-01-31','10:05:00',2.4),('5819','2013-01-31','10:10:00',2.44),('5819','2013-01-31','10:15:00',2.53),('5819','2013-01-31','10:20:00',2.6),('5819','2013-01-31','10:25:00',2.52),('5819','2013-01-31','10:30:00',2.39),('5819','2013-01-31','10:35:00',2.81),('5819','2013-01-31','10:40:00',2.88),('5819','2013-01-31','10:45:00',2.88),('5819','2013-01-31','10:50:00',2.49),('5819','2013-01-31','11:00:00',2.96),('5819','2013-01-31','11:05:00',3.22),('5819','2013-01-31','11:10:00',3.2),('5819','2013-01-31','11:15:00',3.14),('5819','2013-01-31','11:20:00',3.16),('5819','2013-01-31','11:25:00',2.98),('5819','2013-01-31','11:30:00',2.87),('5819','2013-01-31','11:35:00',2.95),('5819','2013-01-31','11:40:00',2.92),('5819','2013-01-31','11:45:00',2.89),('5819','2013-01-31','11:50:00',2.88),('5819','2013-01-31','11:55:00',2.85),('5819','2013-01-31','12:00:00',2.85),('5819','2013-01-31','12:05:00',2.88),('5819','2013-01-31','12:10:00',2.31),('5819','2013-01-31','12:15:00',2.81),('5819','2013-01-31','12:20:00',2.86),('5819','2013-01-31','12:25:00',2.84),('5819','2013-01-31','12:30:00',2.83),('5819','2013-01-31','12:35:00',2.81),('5819','2013-01-31','12:40:00',2.79),('5819','2013-01-31','12:45:00',2.77),('5819','2013-01-31','12:50:00',2.74),('5819','2013-01-31','12:55:00',2.69),('5819','2013-01-31','13:00:00',2.67),('5819','2013-01-31','13:05:00',2.67),('5819','2013-01-31','13:10:00',2.64),('5819','2013-01-31','13:15:00',2.57),('5819','2013-01-31','13:20:00',2.51),('5819','2013-01-31','13:25:00',2.48),('5819','2013-01-31','13:30:00',2.42),('5819','2013-01-31','13:35:00',2.38),('5819','2013-01-31','13:40:00',2.29),('5819','2013-01-31','13:45:00',2.21),('5819','2013-01-31','13:50:00',2.32),('5819','2013-01-31','13:55:00',2.3),('5819','2013-01-31','14:00:00',2.24),('5819','2013-01-31','14:05:00',2.12),('5819','2013-01-31','14:10:00',2.06),('5819','2013-01-31','14:15:00',1.98),('5819','2013-01-31','14:20:00',1.99),('5819','2013-01-31','14:25:00',1.92),('5819','2013-01-31','14:30:00',1.83),('5819','2013-01-31','14:35:00',1.8),('5819','2013-01-31','14:40:00',1.75),('5819','2013-01-31','14:45:00',1.67),('5819','2013-01-31','14:50:00',1.58),('5819','2013-01-31','14:55:00',1.54),('5819','2013-01-31','15:00:00',1.45),('5819','2013-01-31','15:05:00',1.4),('5819','2013-01-31','15:10:00',1.35),('5819','2013-01-31','15:15:00',1.33),('5819','2013-01-31','15:20:00',1.29),('5819','2013-01-31','15:25:00',1.19),('5819','2013-01-31','15:30:00',1.14),('5819','2013-01-31','15:35:00',1.12),('5819','2013-01-31','15:40:00',1.04),('5819','2013-01-30','10:10:00',1.52),('5819','2013-01-30','10:15:00',1.08),('5819','2013-01-30','10:20:00',1.56),('5819','2013-01-30','10:25:00',1.54),('5819','2013-01-30','10:30:00',1.47),('5819','2013-01-30','10:35:00',1.28),('5819','2013-01-30','10:40:00',1.4),('5819','2013-01-30','10:45:00',1.96),('5819','2013-01-30','10:50:00',2.61),('5819','2013-01-30','10:55:00',2.63),('5819','2013-01-30','11:00:00',2.77),('5819','2013-01-30','11:05:00',2.68),('5819','2013-01-30','11:10:00',2.71),('5819','2013-01-30','11:15:00',2.75),('5819','2013-01-30','11:20:00',2.76),('5819','2013-01-30','11:25:00',2.83),('5819','2013-01-30','11:30:00',2.84),('5819','2013-01-30','11:35:00',2.82),('5819','2013-01-30','11:40:00',2.38),('5819','2013-01-30','11:45:00',2.89),('5819','2013-01-30','11:50:00',2.9),('5819','2013-01-30','11:55:00',2.81),('5819','2013-01-30','12:00:00',2.9),('5819','2013-01-30','12:05:00',2.93),('5819','2013-01-30','12:10:00',1.87),('5819','2013-01-30','12:15:00',2.42),('5819','2013-01-30','12:20:00',1.82),('5819','2013-01-30','12:40:00',1.67),('5819','2013-01-30','12:50:00',1.31),('5819','2013-01-30','12:55:00',3.1),('5819','2013-01-30','13:00:00',3.07),('5819','2013-01-30','13:05:00',3.11),('5819','2013-01-30','13:10:00',2.88),('5819','2013-01-30','13:15:00',2.73),('5819','2013-01-30','13:20:00',2.74),('5819','2013-01-30','13:25:00',2.85),('5819','2013-01-30','13:30:00',2.51),('5819','2013-01-30','13:35:00',2.63),('5819','2013-01-30','13:40:00',1.45),('5819','2013-01-30','13:45:00',1.55),('5819','2013-01-30','13:50:00',2.14),('5819','2013-01-30','13:55:00',1.82),('5819','2013-01-30','14:00:00',1.98),('5819','2013-01-30','14:05:00',1.41),('5819','2013-01-30','14:10:00',2.15),('5819','2013-01-30','14:20:00',1.59),('5819','2013-01-30','14:25:00',1.89),('5819','2013-01-30','14:30:00',1.25),('5819','2013-01-30','14:35:00',1.24),('5819','2013-01-30','14:40:00',1.49),('5819','2013-01-30','14:45:00',1.54),('5819','2013-01-29','08:25:00',1.07),('5819','2013-01-29','08:30:00',1.18),('5819','2013-01-29','08:35:00',1.28),('5819','2013-01-29','08:40:00',1.34),('5819','2013-01-29','08:45:00',1.43),('5819','2013-01-29','08:50:00',1.52),('5819','2013-01-29','08:55:00',1.6),('5819','2013-01-29','09:00:00',1.69),('5819','2013-01-29','09:05:00',1.76),('5819','2013-01-29','09:10:00',1.83),('5819','2013-01-29','09:15:00',1.9),('5819','2013-01-29','09:20:00',1.97),('5819','2013-01-29','09:25:00',2.03),('5819','2013-01-29','09:30:00',2.09),('5819','2013-01-29','09:35:00',2.15),('5819','2013-01-29','09:40:00',2.22),('5819','2013-01-29','09:45:00',2.29),('5819','2013-01-29','09:50:00',2.34),('5819','2013-01-29','09:55:00',2.39),('5819','2013-01-29','10:00:00',2.44),('5819','2013-01-29','10:05:00',2.51),('5819','2013-01-29','10:10:00',2.57),('5819','2013-01-29','10:15:00',2.62),('5819','2013-01-29','10:20:00',2.66),('5819','2013-01-29','10:25:00',2.72),('5819','2013-01-29','10:30:00',2.76),('5819','2013-01-29','10:35:00',2.78),('5819','2013-01-29','10:40:00',2.82),('5819','2013-01-29','10:45:00',2.83),('5819','2013-01-29','10:50:00',2.86),('5819','2013-01-29','10:55:00',2.86),('5819','2013-01-29','11:00:00',2.85),('5819','2013-01-29','11:05:00',2.86),('5819','2013-01-29','11:10:00',2.87),('5819','2013-01-29','11:15:00',2.91),('5819','2013-01-29','11:20:00',2.93),('5819','2013-01-29','11:25:00',2.9),('5819','2013-01-29','11:30:00',2.87),('5819','2013-01-29','11:35:00',2.96),('5819','2013-01-29','11:40:00',3),('5819','2013-01-29','11:45:00',3),('5819','2013-01-29','11:50:00',2.99),('5819','2013-01-29','11:55:00',2.96),('5819','2013-01-29','12:00:00',2.91),('5819','2013-01-29','12:05:00',2.91),('5819','2013-01-29','12:10:00',2.95),('5819','2013-01-29','12:15:00',2.91),('5819','2013-01-29','12:20:00',2.9),('5819','2013-01-29','12:25:00',2.91),('5819','2013-01-29','12:30:00',2.87),('5819','2013-01-29','12:35:00',2.82),('5819','2013-01-29','12:40:00',2.81),('5819','2013-01-29','12:45:00',2.77),('5819','2013-01-29','12:50:00',2.74),('5819','2013-01-29','12:55:00',2.77),('5819','2013-01-29','13:00:00',2.74),('5819','2013-01-29','13:05:00',2.69),('5819','2013-01-29','13:10:00',2.67),('5819','2013-01-29','13:15:00',2.61),('5819','2013-01-29','13:20:00',2.59),('5819','2013-01-29','13:25:00',2.57),('5819','2013-01-29','13:30:00',2.53),('5819','2013-01-29','13:35:00',2.48),('5819','2013-01-29','13:40:00',2.43),('5819','2013-01-29','13:45:00',2.39),('5819','2013-01-29','13:50:00',2.32),('5819','2013-01-29','13:55:00',2.26),('5819','2013-01-29','14:00:00',2.22),('5819','2013-01-29','14:05:00',2.13),('5819','2013-01-29','14:10:00',2.07),('5819','2013-01-29','14:15:00',2.07),('5819','2013-01-29','14:20:00',2.06),('5819','2013-01-29','14:25:00',1.98),('5819','2013-01-29','14:30:00',1.92),('5819','2013-01-29','14:35:00',1.84),('5819','2013-01-29','14:40:00',1.79),('5819','2013-01-29','14:45:00',1.74),('5819','2013-01-29','14:50:00',1.67),('5819','2013-01-29','14:55:00',1.59),('5819','2013-01-29','15:00:00',1.51),('5819','2013-01-29','15:05:00',1.45),('5819','2013-01-29','15:10:00',1.36),('5819','2013-01-29','15:15:00',1.3),('5819','2013-01-29','15:20:00',1.23),('5819','2013-01-29','15:25:00',1.16),('5819','2013-01-29','15:30:00',1.08),('5819','2013-01-29','15:35:00',1.02),('5819','2013-01-28','12:50:00',1.13),('5819','2013-01-28','12:55:00',1.1),('5819','2013-01-28','13:00:00',1.03),('5819','2013-01-28','13:05:00',1),('5819','2013-01-27','08:25:00',1.01),('5819','2013-01-27','08:30:00',1.19),('5819','2013-01-27','08:35:00',1.33),('5819','2013-01-27','08:40:00',1.44),('5819','2013-01-27','08:45:00',1.41),('5819','2013-01-27','08:50:00',1.45),('5819','2013-01-27','08:55:00',1.51),('5819','2013-01-27','09:00:00',1.61),('5819','2013-01-27','09:05:00',1.69),('5819','2013-01-27','09:10:00',1.75),('5819','2013-01-27','09:15:00',1.82),('5819','2013-01-27','09:20:00',1.9),('5819','2013-01-27','09:25:00',1.98),('5819','2013-01-27','09:30:00',2.03),('5819','2013-01-27','09:35:00',2.1),('5819','2013-01-27','09:40:00',2.17),('5819','2013-01-27','09:45:00',2.23),('5819','2013-01-27','09:50:00',2.29),('5819','2013-01-27','09:55:00',2.35),('5819','2013-01-27','10:00:00',2.38),('5819','2013-01-27','10:05:00',2.44),('5819','2013-01-27','10:10:00',2.47),('5819','2013-01-27','10:15:00',2.53),('5819','2013-01-27','10:20:00',2.56),('5819','2013-01-27','10:25:00',2.6),('5819','2013-01-27','10:30:00',2.64),('5819','2013-01-27','10:35:00',2.67),('5819','2013-01-27','10:40:00',2.69),('5819','2013-01-27','10:45:00',2.72),('5819','2013-01-27','10:50:00',2.75),('5819','2013-01-27','10:55:00',2.78),('5819','2013-01-27','11:00:00',2.79),('5819','2013-01-27','11:05:00',2.81),('5819','2013-01-27','11:10:00',2.83),('5819','2013-01-27','11:15:00',2.85),('5819','2013-01-27','11:20:00',2.87),('5819','2013-01-27','11:25:00',2.88),('5819','2013-01-27','11:30:00',2.87),('5819','2013-01-27','11:35:00',2.88),('5819','2013-01-27','11:40:00',2.88),('5819','2013-01-27','11:45:00',2.89),('5819','2013-01-27','11:50:00',2.88),('5819','2013-01-27','11:55:00',2.9),('5819','2013-01-27','12:00:00',2.9),('5819','2013-01-27','12:05:00',2.89),('5819','2013-01-27','12:10:00',2.88),('5819','2013-01-27','12:15:00',2.87),('5819','2013-01-27','12:20:00',2.87),('5819','2013-01-27','12:25:00',2.85),('5819','2013-01-27','12:30:00',2.83),('5819','2013-01-27','12:35:00',2.81),('5819','2013-01-27','12:40:00',2.77),('5819','2013-01-27','12:45:00',2.72),('5819','2013-01-27','12:50:00',2.74),('5819','2013-01-27','12:55:00',2.76),('5819','2013-01-27','13:00:00',2.73),('5819','2013-01-27','13:05:00',2.69),('5819','2013-01-27','13:10:00',2.64),('5819','2013-01-27','13:15:00',2.58),('5819','2013-01-27','13:20:00',2.51),('5819','2013-01-27','13:25:00',2.49),('5819','2013-01-27','13:30:00',2.46),('5819','2013-01-27','13:35:00',2.41),('5819','2013-01-27','13:40:00',2.33),('5819','2013-01-27','13:45:00',2.27),('5819','2013-01-27','13:50:00',2.24),('5819','2013-01-27','13:55:00',2.2),('5819','2013-01-27','14:00:00',2.17),('5819','2013-01-27','14:05:00',2.12),('5819','2013-01-27','14:10:00',2.05),('5819','2013-01-27','14:15:00',1.99),('5819','2013-01-27','14:20:00',1.92),('5819','2013-01-27','14:25:00',1.84),('5819','2013-01-27','14:30:00',1.79),('5819','2013-01-27','14:35:00',1.74),('5819','2013-01-27','14:40:00',1.66),('5819','2013-01-27','14:45:00',1.6),('5819','2013-01-27','14:50:00',1.57),('5819','2013-01-27','14:55:00',1.52),('5819','2013-01-27','15:00:00',1.42),('5819','2013-01-27','15:05:00',1.36),('5819','2013-01-27','15:10:00',1.27),('5819','2013-01-27','15:15:00',1.2),('5819','2013-01-27','15:20:00',1.14),('5819','2013-01-27','15:25:00',1.08),('5819','2013-01-27','15:30:00',1.03),('5819','2013-01-26','09:00:00',1.29),('5819','2013-01-26','09:05:00',1.37),('5819','2013-01-26','09:10:00',1.15),('5819','2013-01-26','09:15:00',1.14),('5819','2013-01-26','09:20:00',1.38),('5819','2013-01-26','09:50:00',1.07),('5819','2013-01-26','09:55:00',1.16),('5819','2013-01-26','10:20:00',1.17),('5819','2013-01-26','10:25:00',1.38),('5819','2013-01-26','10:50:00',1.04),('5819','2013-01-25','08:25:00',1.09),('5819','2013-01-25','08:30:00',1.14),('5819','2013-01-25','08:35:00',1.35),('5819','2013-01-25','08:40:00',1.45),('5819','2013-01-25','08:45:00',1.54),('5819','2013-01-25','08:50:00',1.53),('5819','2013-01-25','08:55:00',1.56),('5819','2013-01-25','09:00:00',1.82),('5819','2013-01-25','09:05:00',1.54),('5819','2013-01-25','09:10:00',1.55),('5819','2013-01-25','09:15:00',1.92),('5819','2013-01-25','09:20:00',2.04),('5819','2013-01-25','09:25:00',2.16),('5819','2013-01-25','09:30:00',2.26),('5819','2013-01-25','09:35:00',2.2),('5819','2013-01-25','09:40:00',2.05),('5819','2013-01-25','09:45:00',2.13),('5819','2013-01-25','09:50:00',2.53),('5819','2013-01-25','09:55:00',2.65),('5819','2013-01-25','10:00:00',2.68),('5819','2013-01-25','10:05:00',2.72),('5819','2013-01-25','10:10:00',2.68),('5819','2013-01-25','10:15:00',2.68),('5819','2013-01-25','10:20:00',2.73),('5819','2013-01-25','10:25:00',2.78),('5819','2013-01-25','10:30:00',2.73),('5819','2013-01-25','10:35:00',2.22),('5819','2013-01-25','10:40:00',2.99),('5819','2013-01-25','10:45:00',2.71),('5819','2013-01-25','10:50:00',2.17),('5819','2013-01-25','10:55:00',3.07),('5819','2013-01-25','11:00:00',1.81),('5819','2013-01-25','11:05:00',2.7),('5819','2013-01-25','11:10:00',2.93),('5819','2013-01-25','11:15:00',3.02),('5819','2013-01-25','11:20:00',2.96),('5819','2013-01-25','11:25:00',2.95),('5819','2013-01-25','11:30:00',2.97),('5819','2013-01-25','11:35:00',3.01),('5819','2013-01-25','11:40:00',3),('5819','2013-01-25','11:45:00',3),('5819','2013-01-25','11:50:00',3.05),('5819','2013-01-25','11:55:00',3.02),('5819','2013-01-25','12:00:00',2.98),('5819','2013-01-25','12:05:00',2.97),('5819','2013-01-25','12:10:00',3),('5819','2013-01-25','12:15:00',3),('5819','2013-01-25','12:20:00',3.01),('5819','2013-01-25','12:25:00',3.01),('5819','2013-01-25','12:30:00',3.01),('5819','2013-01-25','12:35:00',2.58),('5819','2013-01-25','12:40:00',2.6),('5819','2013-01-25','12:45:00',2.75),('5819','2013-01-25','12:50:00',2.83),('5819','2013-01-25','12:55:00',2.76),('5819','2013-01-25','13:00:00',2.77),('5819','2013-01-25','13:05:00',2.71),('5819','2013-01-25','13:10:00',2.67),('5819','2013-01-25','13:15:00',2.66),('5819','2013-01-25','13:20:00',2.64),('5819','2013-01-25','13:25:00',2.65),('5819','2013-01-25','13:30:00',2.69),('5819','2013-01-25','13:35:00',2.65),('5819','2013-01-25','13:40:00',2.58),('5819','2013-01-25','13:45:00',2.5),('5819','2013-01-25','13:50:00',2.42),('5819','2013-01-25','13:55:00',2.35),('5819','2013-01-25','14:00:00',2.26),('5819','2013-01-25','14:05:00',2.17),('5819','2013-01-25','14:10:00',2),('5819','2013-01-25','14:15:00',1.9),('5819','2013-01-25','14:20:00',1.74),('5819','2013-01-25','14:25:00',1.76),('5819','2013-01-25','14:30:00',1.66),('5819','2013-01-25','14:35:00',1.56),('5819','2013-01-25','14:40:00',1.5),('5819','2013-01-25','14:45:00',1.44),('5819','2013-01-25','14:50:00',1.42),('5819','2013-01-25','14:55:00',1.39),('5819','2013-01-25','15:00:00',1.27),('5819','2013-01-25','15:05:00',1.19),('5819','2013-01-25','15:10:00',1.17),('5819','2013-01-25','15:15:00',1.11),('5819','2013-01-25','15:20:00',1.08),('5819','2013-01-25','15:25:00',1.08),('5819','2013-01-25','15:30:00',1.06),('5819','2013-01-25','15:35:00',1.07),('5819','2013-01-25','15:40:00',1.03),('5819','2013-01-24','09:30:00',1.01),('5819','2013-01-24','09:45:00',1.4),('5819','2013-01-24','09:50:00',1.38),('5819','2013-01-24','09:55:00',2.37),('5819','2013-01-24','10:00:00',2.44),('5819','2013-01-24','10:05:00',2.51),('5819','2013-01-24','10:10:00',2.74),('5819','2013-01-24','10:15:00',2.69),('5819','2013-01-24','10:20:00',2.77),('5819','2013-01-24','10:25:00',2.77),('5819','2013-01-24','10:30:00',2.79),('5819','2013-01-24','10:35:00',2.81),('5819','2013-01-24','10:40:00',2.84),('5819','2013-01-24','10:45:00',2.9),('5819','2013-01-24','10:50:00',2.98),('5819','2013-01-24','10:55:00',2.84),('5819','2013-01-24','11:00:00',1.61),('5819','2013-01-24','14:00:00',1.05),('5819','2013-01-24','14:05:00',1.09),('5819','2013-01-24','14:10:00',1.03),('5819','2013-01-24','14:15:00',1.18),('5819','2013-01-24','14:20:00',1.55),('5819','2013-01-24','14:25:00',2.73),('5819','2013-01-24','14:30:00',2.48),('5819','2013-01-24','14:35:00',1.89),('5819','2013-01-24','14:40:00',1.17),('5819','2013-01-24','14:45:00',1.63),('5819','2013-01-24','14:50:00',1.69),('5819','2013-01-24','14:55:00',1.72),('5819','2013-01-24','15:00:00',1.3),('5819','2013-01-24','15:20:00',1.05),('5819','2013-01-24','15:25:00',1.06),('5819','2013-01-24','15:30:00',1.07),('5819','2013-01-23','09:55:00',1.65),('5819','2013-01-23','10:00:00',1.1),('5819','2013-01-23','10:25:00',1.02),('5819','2013-01-23','10:30:00',2.03),('5819','2013-01-23','10:35:00',2.87),('5819','2013-01-23','10:40:00',1.28),('5819','2013-01-23','10:45:00',1.77),('5819','2013-01-23','10:50:00',2.26),('5819','2013-01-23','10:55:00',2.02),('5819','2013-01-22','08:45:00',1.26),('5819','2013-01-22','08:50:00',1.39),('5819','2013-01-22','09:00:00',1.27),('5819','2013-01-22','09:05:00',1.45),('5819','2013-01-22','09:30:00',2.02),('5819','2013-01-22','09:35:00',2.27),('5819','2013-01-22','09:40:00',1.74),('5819','2013-01-22','09:45:00',2.76),('5819','2013-01-22','09:50:00',1.84),('5819','2013-01-22','09:55:00',2.05),('5819','2013-01-22','10:00:00',1.45),('5819','2013-01-22','10:05:00',2.48),('5819','2013-01-22','10:10:00',2.66),('5819','2013-01-22','10:15:00',2.42),('5819','2013-01-22','10:20:00',2.27),('5819','2013-01-22','10:25:00',2.54),('5819','2013-01-22','10:30:00',2.83),('5819','2013-01-22','10:35:00',2.92),('5819','2013-01-22','10:40:00',3.31),('5819','2013-01-22','10:45:00',2.74),('5819','2013-01-22','10:50:00',2.3),('5819','2013-01-22','10:55:00',1.29),('5819','2013-01-22','11:10:00',1.07),('5819','2013-01-22','11:15:00',1.87),('5819','2013-01-22','11:20:00',1.78),('5819','2013-01-22','11:25:00',1.26),('5819','2013-01-22','11:45:00',1.26),('5819','2013-01-22','11:50:00',2.49),('5819','2013-01-22','12:00:00',1.02),('5819','2013-01-22','12:10:00',2.18),('5819','2013-01-22','12:15:00',2.46),('5819','2013-01-22','12:20:00',1.55),('5819','2013-01-22','12:25:00',2.49),('5819','2013-01-22','12:30:00',1.08),('5819','2013-01-22','12:40:00',3.12),('5819','2013-01-22','12:45:00',1.18),('5819','2013-01-22','12:55:00',1.19),('5819','2013-01-22','13:00:00',2.28),('5819','2013-01-22','13:05:00',2.71),('5819','2013-01-22','13:10:00',1.96),('5819','2013-01-22','13:15:00',1.17),('5819','2013-01-22','13:20:00',2.39),('5819','2013-01-22','13:50:00',1.38),('5819','2013-01-22','14:10:00',1.07),('5819','2013-01-22','14:15:00',1.51),('5819','2013-01-22','14:25:00',1.82),('5819','2013-01-22','14:35:00',1.13),('5819','2013-01-22','14:40:00',1.02),('5819','2013-01-22','14:45:00',1.45),('5819','2013-01-22','14:50:00',1.04),('5819','2013-01-21','11:15:00',1.04),('5819','2013-01-21','11:55:00',3.31),('5819','2013-01-21','12:00:00',2.88),('5819','2013-01-21','12:05:00',2.79),('5819','2013-01-21','12:10:00',2.92),('5819','2013-01-21','12:15:00',2.61),('5819','2013-01-21','12:25:00',1.19),('5819','2013-01-21','12:40:00',1.3),('5819','2013-01-21','13:05:00',1.81),('5819','2013-01-21','13:10:00',1.54),('5819','2013-01-21','13:30:00',2.21),('5819','2013-01-21','13:35:00',2.88),('5819','2013-01-21','13:40:00',2.19),('5819','2013-01-21','13:45:00',1.02),('5819','2013-01-21','13:50:00',1.26),('5819','2013-01-21','13:55:00',1.85),('5819','2013-01-21','14:00:00',2.46),('5819','2013-01-21','14:05:00',2.52),('5819','2013-01-21','14:10:00',2.07),('5819','2013-01-21','14:15:00',1.85),('5819','2013-01-21','14:20:00',1.91),('5819','2013-01-21','14:25:00',2.31),('5819','2013-01-21','14:30:00',1.08),('5819','2013-01-20','10:55:00',1.01),('5819','2013-01-20','11:00:00',1.12),('5819','2013-01-20','11:05:00',1.09),('5819','2013-01-20','11:10:00',1.09),('5819','2013-01-20','11:15:00',1.61),('5819','2013-01-20','11:20:00',1.24),('5819','2013-01-20','11:25:00',1.65),('5819','2013-01-20','11:30:00',2.33),('5819','2013-01-20','11:35:00',1.77),('5819','2013-01-19','09:15:00',1.43),('5819','2013-01-19','09:20:00',1.49),('5819','2013-01-19','09:25:00',1.08),('5819','2013-01-19','09:50:00',1.03),('5819','2013-01-19','09:55:00',1.5),('5819','2013-01-19','10:00:00',1.33),('5819','2013-01-19','10:05:00',1.01),('5819','2013-01-19','10:45:00',1.15),('5819','2013-01-19','10:50:00',1.35),('5819','2013-01-19','11:20:00',1.02),('5819','2013-01-19','11:25:00',1.07),('5819','2013-01-18','10:15:00',2.36),('5819','2013-01-18','10:20:00',2.49),('5819','2013-01-18','10:25:00',1.51),('5819','2013-01-18','10:30:00',1.27),('5819','2013-01-18','11:35:00',1.08),('5819','2013-01-18','11:40:00',1.08),('5819','2013-01-18','12:35:00',1.12),('5819','2013-01-18','12:40:00',1.31),('5819','2013-01-18','12:45:00',1.4),('5819','2013-01-18','12:50:00',2.05),('5819','2013-01-18','12:55:00',1.93),('5819','2013-01-18','13:00:00',2.08),('5819','2013-01-18','13:05:00',1.89),('5819','2013-01-18','13:10:00',1.81),('5819','2013-01-18','13:15:00',2.09),('5819','2013-01-18','13:20:00',1.72),('5819','2013-01-18','13:25:00',1.44),('5819','2013-01-18','13:30:00',1.42),('5819','2013-01-18','13:35:00',1.56),('5819','2013-01-18','13:40:00',2.19),('5819','2013-01-18','13:45:00',2.34),('5819','2013-01-18','13:50:00',2.75),('5819','2013-01-18','13:55:00',2.63),('5819','2013-01-18','14:00:00',1.94),('5819','2013-01-18','14:05:00',2.14),('5819','2013-01-18','14:10:00',1.99),('5819','2013-01-18','14:15:00',1.43),('5819','2013-01-18','14:20:00',1.59),('5819','2013-01-18','14:25:00',1.34),('5819','2013-01-17','09:45:00',1.04),('5819','2013-01-17','09:50:00',1.38),('5819','2013-01-17','09:55:00',1.23),('5819','2013-01-17','10:10:00',1.06),('5819','2013-01-17','10:15:00',1.28),('5819','2013-01-17','10:20:00',1.24),('5819','2013-01-17','10:25:00',1.59),('5819','2013-01-17','10:30:00',1.74),('5819','2013-01-17','10:35:00',1.57),('5819','2013-01-17','10:40:00',1.47),('5819','2013-01-17','10:45:00',1.59),('5819','2013-01-17','10:50:00',1.48),('5819','2013-01-17','10:55:00',1.77),('5819','2013-01-17','11:00:00',1.56),('5819','2013-01-17','11:05:00',1.56),('5819','2013-01-17','11:10:00',1.87),('5819','2013-01-17','11:15:00',1.82),('5819','2013-01-17','11:20:00',1.71),('5819','2013-01-17','11:25:00',1.49),('5819','2013-01-17','11:30:00',1.28),('5819','2013-01-17','11:35:00',1.42),('5819','2013-01-17','11:40:00',1.51),('5819','2013-01-17','11:45:00',1.39),('5819','2013-01-17','11:50:00',1.45),('5819','2013-01-17','11:55:00',1.56),('5819','2013-01-17','12:00:00',1.76),('5819','2013-01-17','12:05:00',1.72),('5819','2013-01-17','12:10:00',1.6),('5819','2013-01-17','12:15:00',1.92),('5819','2013-01-17','12:20:00',1.67),('5819','2013-01-17','12:25:00',1.57),('5819','2013-01-17','12:30:00',1.26),('5819','2013-01-17','12:35:00',1.57),('5819','2013-01-17','12:40:00',1.68),('5819','2013-01-17','12:45:00',1.34),('5819','2013-01-17','13:00:00',1.53),('5819','2013-01-17','13:05:00',1.45),('5819','2013-01-17','13:15:00',1.34),('5819','2013-01-17','13:20:00',1.42),('5819','2013-01-17','13:25:00',1.26),('5819','2013-01-17','13:30:00',1.16),('5819','2013-01-17','13:35:00',1.51),('5819','2013-01-17','13:40:00',1.89),('5819','2013-01-17','13:45:00',2.09),('5819','2013-01-17','13:50:00',1.86),('5819','2013-01-17','14:00:00',1.2),('5819','2013-01-17','14:30:00',1.09),('5819','2013-01-17','14:35:00',1.46),('5819','2013-01-16','09:15:00',1.36),('5819','2013-01-16','09:20:00',1.08),('5819','2013-01-16','09:25:00',1.82),('5819','2013-01-16','09:30:00',1.97),('5819','2013-01-16','09:35:00',2.07),('5819','2013-01-16','09:40:00',2.2),('5819','2013-01-16','09:45:00',1.3),('5819','2013-01-16','10:35:00',1.86),('5819','2013-01-16','10:40:00',2.19),('5819','2013-01-16','10:45:00',2.48),('5819','2013-01-16','10:55:00',2.16),('5819','2013-01-16','11:25:00',1.48),('5819','2013-01-16','12:00:00',1.12),('5819','2013-01-16','12:05:00',1.2),('5819','2013-01-16','12:10:00',1.42),('5819','2013-01-16','12:15:00',3.21),('5819','2013-01-16','12:20:00',3.1),('5819','2013-01-16','12:25:00',1.4),('5819','2013-01-16','13:05:00',1.55),('5819','2013-01-16','13:10:00',3.21),('5819','2013-01-16','13:15:00',3.51),('5819','2013-01-16','13:20:00',2.8),('5819','2013-01-16','13:25:00',1.76),('5819','2013-01-16','13:55:00',1.95),('5819','2013-01-16','14:00:00',1.72),('5819','2013-01-16','14:05:00',1.14),('5819','2013-01-15','10:00:00',1.14),('5819','2013-01-15','10:45:00',1.05),('5819','2013-01-15','10:50:00',1.32),('5819','2013-01-15','10:55:00',1.43),('5819','2013-01-15','11:00:00',1.38),('5819','2013-01-15','11:05:00',1.43),('5819','2013-01-15','11:10:00',1.48),('5819','2013-01-15','11:15:00',1.4),('5819','2013-01-15','11:20:00',1.48),('5819','2013-01-15','11:25:00',1.46),('5819','2013-01-15','11:30:00',1.39),('5819','2013-01-15','11:35:00',1.31),('5819','2013-01-15','11:40:00',1.17),('5819','2013-01-15','11:45:00',1.01),('5819','2013-01-15','11:55:00',1.01),('5819','2013-01-15','12:20:00',1.17),('5819','2013-01-15','12:25:00',1.15),('5819','2013-01-15','12:30:00',1.07),('5819','2013-01-15','12:35:00',1.08),('5819','2013-01-15','12:40:00',1.22),('5819','2013-01-15','12:45:00',1.3),('5819','2013-01-15','12:50:00',1.24),('5819','2013-01-15','12:55:00',1.04),('5819','2013-01-15','13:35:00',1),('5819','2013-01-15','13:40:00',1.15),('5819','2013-01-15','13:45:00',1.1),('5819','2013-01-15','13:50:00',1.04),('5819','2013-01-15','13:55:00',1.17),('5819','2013-01-15','14:00:00',1.29),('5819','2013-01-15','14:05:00',1.96),('5819','2013-01-15','14:10:00',2.3),('5819','2013-01-15','14:15:00',2.37),('5819','2013-01-15','14:20:00',2.41),('5819','2013-01-15','14:25:00',1.98),('5819','2013-01-15','14:35:00',1.53),('5819','2013-01-15','14:40:00',1.14),('5819','2013-01-15','14:45:00',1.49),('5819','2013-01-15','14:50:00',1.44),('5819','2013-01-15','14:55:00',1.51),('5819','2013-01-15','15:00:00',1.52),('5819','2013-01-15','15:05:00',1.4),('5819','2013-01-15','15:10:00',1.22),('5819','2013-01-15','15:15:00',1.08),('5819','2013-01-15','15:20:00',1),('5819','2013-01-14','12:50:00',1.06),('5819','2013-01-14','13:00:00',1.05),('5819','2013-01-14','13:05:00',1.06),('5819','2013-01-14','15:15:00',1.12),('5819','2013-01-13','09:15:00',1.74),('5819','2013-01-13','09:20:00',1.87),('5819','2013-01-13','09:25:00',1.83),('5819','2013-01-13','09:30:00',1.91),('5819','2013-01-13','09:35:00',1.99),('5819','2013-01-13','09:40:00',1.4),('5819','2013-01-13','09:50:00',1.54),('5819','2013-01-13','09:55:00',1.92),('5819','2013-01-13','10:00:00',1.98),('5819','2013-01-13','10:05:00',2.09),('5819','2013-01-13','10:10:00',1.48),('5819','2013-01-13','10:20:00',1.48),('5819','2013-01-13','10:25:00',1.58),('5819','2013-01-13','10:30:00',1.84),('5819','2013-01-12','08:35:00',1.07),('5819','2013-01-12','08:40:00',1.17),('5819','2013-01-12','08:45:00',1.23),('5819','2013-01-12','08:50:00',1.31),('5819','2013-01-12','08:55:00',1.38),('5819','2013-01-12','09:00:00',1.45),('5819','2013-01-12','09:05:00',1.52),('5819','2013-01-12','09:10:00',1.57),('5819','2013-01-12','09:15:00',1.61),('5819','2013-01-12','09:20:00',1.68),('5819','2013-01-12','09:25:00',1.75),('5819','2013-01-12','09:30:00',1.8),('5819','2013-01-12','09:35:00',1.85),('5819','2013-01-12','09:40:00',1.92),('5819','2013-01-12','09:45:00',1.97),('5819','2013-01-12','09:50:00',2.05),('5819','2013-01-12','09:55:00',2.08),('5819','2013-01-12','10:00:00',2.14),('5819','2013-01-12','10:05:00',2.21),('5819','2013-01-12','10:10:00',2.21),('5819','2013-01-12','10:15:00',2.22),('5819','2013-01-12','10:20:00',2.26),('5819','2013-01-12','10:25:00',2.32),('5819','2013-01-12','10:30:00',2.36),('5819','2013-01-12','10:35:00',2.38),('5819','2013-01-12','10:40:00',2.43),('5819','2013-01-12','10:45:00',2.44),('5819','2013-01-12','10:50:00',2.46),('5819','2013-01-12','10:55:00',2.45),('5819','2013-01-12','11:00:00',2.45),('5819','2013-01-12','11:05:00',2.53),('5819','2013-01-12','11:10:00',2.52),('5819','2013-01-12','11:15:00',2.52),('5819','2013-01-12','11:20:00',2.53),('5819','2013-01-12','11:25:00',2.56),('5819','2013-01-12','11:30:00',2.55),('5819','2013-01-12','11:35:00',2.56),('5819','2013-01-12','11:40:00',2.56),('5819','2013-01-12','11:45:00',2.55),('5819','2013-01-12','11:50:00',2.57),('5819','2013-01-12','11:55:00',2.58),('5819','2013-01-12','12:00:00',2.56),('5819','2013-01-12','12:05:00',2.54),('5819','2013-01-12','12:10:00',2.51),('5819','2013-01-12','12:15:00',2.51),('5819','2013-01-12','12:20:00',2.47),('5819','2013-01-12','12:25:00',2.43),('5819','2013-01-12','12:30:00',2.44),('5819','2013-01-12','12:35:00',2.17),('5819','2013-01-12','12:40:00',1.85),('5819','2013-01-12','12:50:00',1.67),('5819','2013-01-12','12:55:00',1.68),('5819','2013-01-12','13:00:00',2.1),('5819','2013-01-12','13:05:00',2.25),('5819','2013-01-12','13:10:00',2.05),('5819','2013-01-12','13:15:00',1.31),('5819','2013-01-12','13:25:00',1.82),('5819','2013-01-12','13:30:00',2.15),('5819','2013-01-12','13:35:00',2.08),('5819','2013-01-12','13:40:00',1.03),('5819','2013-01-12','13:50:00',1.41),('5819','2013-01-12','13:55:00',2.1),('5819','2013-01-12','14:00:00',1.45),('5819','2013-01-12','14:05:00',1.3),('5819','2013-01-12','14:10:00',2),('5819','2013-01-12','14:15:00',1.92),('5819','2013-01-12','14:20:00',1.71),('5819','2013-01-12','14:25:00',1.66),('5819','2013-01-12','14:30:00',1.54),('5819','2013-01-12','14:35:00',1.47),('5819','2013-01-12','14:40:00',1.42),('5819','2013-01-12','14:45:00',1.36),('5819','2013-01-12','14:50:00',1.25),('5819','2013-01-12','14:55:00',1.2),('5819','2013-01-12','15:00:00',1.15),('5819','2013-01-12','15:05:00',1.07),('5819','2013-01-11','09:45:00',1.01),('5819','2013-01-11','09:50:00',1.23),('5819','2013-01-11','10:00:00',1.16),('5819','2013-01-11','10:05:00',1.43),('5819','2013-01-11','10:10:00',1.46),('5819','2013-01-11','10:15:00',1.85),('5819','2013-01-11','10:20:00',1.17),('5819','2013-01-11','10:25:00',2.32),('5819','2013-01-11','10:30:00',2.32),('5819','2013-01-11','10:35:00',2.35),('5819','2013-01-11','10:40:00',2.36),('5819','2013-01-11','10:45:00',2.39),('5819','2013-01-11','10:50:00',2.44),('5819','2013-01-11','10:55:00',2.45),('5819','2013-01-11','11:00:00',2.49),('5819','2013-01-11','11:05:00',2.49),('5819','2013-01-11','11:10:00',2.48),('5819','2013-01-11','11:15:00',2.45),('5819','2013-01-11','11:20:00',2.45),('5819','2013-01-11','11:25:00',1.89),('5819','2013-01-11','11:30:00',1.03),('5819','2013-01-11','11:35:00',1.54),('5819','2013-01-11','11:40:00',1.41),('5819','2013-01-11','11:45:00',1.48),('5819','2013-01-11','11:50:00',1.37),('5819','2013-01-11','11:55:00',1.13),('5819','2013-01-11','12:55:00',1.32),('5819','2013-01-11','13:00:00',1.19),('5819','2013-01-11','13:10:00',1.43),('5819','2013-01-11','13:15:00',1.09),('5819','2013-01-11','13:35:00',1.91),('5819','2013-01-11','13:40:00',1.6),('5819','2013-01-11','13:45:00',1.93),('5819','2013-01-11','14:20:00',1.05),('5819','2013-01-11','14:25:00',1.19),('5819','2013-01-11','14:45:00',1.13),('5819','2013-01-11','14:50:00',1.48),('5819','2013-01-11','14:55:00',1.27),('5819','2013-01-11','15:00:00',1.22),('5819','2013-01-11','15:05:00',1.24),('5819','2013-01-10','11:55:00',1.06),('5819','2013-01-10','12:00:00',1.14),('5819','2013-01-10','12:05:00',1.13),('5819','2013-01-10','12:10:00',1.01),('5819','2013-01-09','10:40:00',1.02),('5819','2013-01-09','10:45:00',1.07),('5819','2013-01-09','10:50:00',1.41),('5819','2013-01-09','10:55:00',1.29),('5819','2013-01-09','11:00:00',1.2),('5819','2013-01-09','11:10:00',1.1),('5819','2013-01-09','11:15:00',2.03),('5819','2013-01-09','11:20:00',1.66),('5819','2013-01-09','11:25:00',1.24),('5819','2013-01-09','11:30:00',1.09),('5819','2013-01-09','11:35:00',1.12),('5819','2013-01-09','11:40:00',1.2),('5819','2013-01-09','11:45:00',1.06),('5819','2013-01-09','11:50:00',1.23),('5819','2013-01-09','11:55:00',1.19),('5819','2013-01-09','12:00:00',1.26),('5819','2013-01-09','12:05:00',1.16),('5819','2013-01-09','12:10:00',1.03),('5819','2013-01-09','12:15:00',1.01),('5819','2013-01-09','12:20:00',1.03),('5819','2013-01-09','13:00:00',1.09),('5819','2013-01-09','13:05:00',1.42),('5819','2013-01-09','13:10:00',2.01),('5819','2013-01-09','13:15:00',1.22),('5819','2013-01-09','13:20:00',1.1),('5819','2013-01-08','08:35:00',1.34),('5819','2013-01-08','08:40:00',1.4),('5819','2013-01-08','08:45:00',1.5),('5819','2013-01-08','08:50:00',1.55),('5819','2013-01-08','08:55:00',1.71),('5819','2013-01-08','09:00:00',1.77),('5819','2013-01-08','09:05:00',1.76),('5819','2013-01-08','09:10:00',1.06),('5819','2013-01-08','09:15:00',1.44),('5819','2013-01-08','09:20:00',1.73),('5819','2013-01-08','09:25:00',1.84),('5819','2013-01-08','09:30:00',1.64),('5819','2013-01-08','09:35:00',1.28),('5819','2013-01-08','09:40:00',1.9),('5819','2013-01-08','09:45:00',2.19),('5819','2013-01-08','09:50:00',2.27),('5819','2013-01-08','09:55:00',2.2),('5819','2013-01-08','10:00:00',2),('5819','2013-01-08','10:05:00',1.97),('5819','2013-01-08','10:10:00',2.03),('5819','2013-01-08','10:15:00',2.09),('5819','2013-01-08','10:20:00',1.97),('5819','2013-01-08','10:25:00',2.13),('5819','2013-01-08','10:30:00',2.13),('5819','2013-01-08','10:35:00',2.32),('5819','2013-01-08','10:40:00',2.47),('5819','2013-01-08','10:45:00',2.4),('5819','2013-01-08','10:50:00',2.45),('5819','2013-01-08','10:55:00',2.48),('5819','2013-01-08','11:00:00',2.42),('5819','2013-01-08','11:05:00',2.5),('5819','2013-01-08','11:10:00',2.51),('5819','2013-01-08','11:15:00',2.5),('5819','2013-01-08','11:20:00',2.5),('5819','2013-01-08','11:25:00',2.52),('5819','2013-01-08','11:30:00',2.54),('5819','2013-01-08','11:35:00',2.56),('5819','2013-01-08','11:40:00',2.49),('5819','2013-01-08','11:45:00',2.97),('5819','2013-01-08','11:50:00',2.22),('5819','2013-01-08','11:55:00',1.67),('5819','2013-01-08','12:00:00',1.48),('5819','2013-01-08','12:05:00',1.41),('5819','2013-01-08','12:10:00',1.47),('5819','2013-01-08','12:15:00',1.33),('5819','2013-01-08','12:20:00',1.2),('5819','2013-01-08','12:25:00',1.18),('5819','2013-01-08','12:30:00',1.12),('5819','2013-01-08','12:35:00',1.1),('5819','2013-01-08','12:40:00',1.39),('5819','2013-01-08','12:45:00',1.56),('5819','2013-01-08','12:50:00',2.05),('5819','2013-01-08','12:55:00',1.44),('5819','2013-01-08','13:15:00',1.03),('5819','2013-01-08','13:20:00',1.05),('5819','2013-01-08','13:25:00',1.04),('5819','2013-01-08','13:45:00',1.2),('5819','2013-01-08','13:50:00',1.19),('5819','2013-01-08','13:55:00',1.21),('5819','2013-01-08','14:40:00',1.01),('5819','2013-01-07','08:40:00',1.02),('5819','2013-01-07','08:45:00',1.1),('5819','2013-01-07','08:50:00',1.21),('5819','2013-01-07','08:55:00',1.33),('5819','2013-01-07','09:00:00',1.35),('5819','2013-01-07','09:05:00',1.2),('5819','2013-01-07','09:10:00',1.35),('5819','2013-01-07','09:15:00',1.03),('5819','2013-01-07','09:20:00',1.55),('5819','2013-01-07','09:25:00',1.68),('5819','2013-01-07','09:30:00',1.73),('5819','2013-01-07','09:35:00',1.79),('5819','2013-01-07','09:40:00',1.81),('5819','2013-01-07','09:45:00',1.91),('5819','2013-01-07','09:50:00',1.94),('5819','2013-01-07','09:55:00',2.03),('5819','2013-01-07','10:00:00',2.08),('5819','2013-01-07','10:05:00',2.16),('5819','2013-01-07','10:10:00',2.24),('5819','2013-01-07','10:15:00',2.29),('5819','2013-01-07','10:20:00',2.29),('5819','2013-01-07','10:25:00',2.35),('5819','2013-01-07','10:30:00',2.36),('5819','2013-01-07','10:35:00',2.37),('5819','2013-01-07','10:40:00',2.39),('5819','2013-01-07','10:45:00',2.41),('5819','2013-01-07','10:50:00',2.41),('5819','2013-01-07','10:55:00',2.37),('5819','2013-01-07','11:00:00',2.41),('5819','2013-01-07','11:05:00',2.39),('5819','2013-01-07','11:10:00',2.44),('5819','2013-01-07','11:15:00',2.49),('5819','2013-01-07','11:20:00',2.47),('5819','2013-01-07','11:25:00',2.5),('5819','2013-01-07','11:30:00',2.5),('5819','2013-01-07','11:35:00',2.5),('5819','2013-01-07','11:40:00',2.48),('5819','2013-01-07','11:45:00',2.49),('5819','2013-01-07','11:50:00',2.5),('5819','2013-01-07','11:55:00',2.52),('5819','2013-01-07','12:00:00',2.51),('5819','2013-01-07','12:05:00',2.5),('5819','2013-01-07','12:10:00',2.49),('5819','2013-01-07','12:15:00',2.48),('5819','2013-01-07','12:20:00',2.45),('5819','2013-01-07','12:25:00',2.45),('5819','2013-01-07','12:30:00',2.42),('5819','2013-01-07','12:35:00',2.39),('5819','2013-01-07','12:40:00',2.39),('5819','2013-01-07','12:45:00',2.36),('5819','2013-01-07','12:50:00',2.32),('5819','2013-01-07','12:55:00',2.3),('5819','2013-01-07','13:00:00',2.27),('5819','2013-01-07','13:05:00',2.23),('5819','2013-01-07','13:10:00',2.18),('5819','2013-01-07','13:15:00',2.13),('5819','2013-01-07','13:20:00',2.1),('5819','2013-01-07','13:25:00',2.07),('5819','2013-01-07','13:30:00',2.03),('5819','2013-01-07','13:35:00',1.99),('5819','2013-01-07','13:40:00',1.94),('5819','2013-01-07','13:45:00',1.91),('5819','2013-01-07','13:50:00',1.86),('5819','2013-01-07','13:55:00',1.82),('5819','2013-01-07','14:00:00',1.79),('5819','2013-01-07','14:05:00',1.73),('5819','2013-01-07','14:10:00',1.66),('5819','2013-01-07','14:15:00',1.61),('5819','2013-01-07','14:20:00',1.59),('5819','2013-01-07','14:25:00',1.51),('5819','2013-01-07','14:30:00',1.45),('5819','2013-01-07','14:35:00',1.39),('5819','2013-01-07','14:40:00',1.35),('5819','2013-01-07','14:45:00',1.28),('5819','2013-01-07','14:50:00',1.24),('5819','2013-01-07','14:55:00',1.15),('5819','2013-01-07','15:00:00',1.08),('5819','2013-01-07','15:05:00',1.02),('5819','2013-01-06','08:35:00',1.07),('5819','2013-01-06','08:40:00',1.14),('5819','2013-01-06','08:45:00',1.23),('5819','2013-01-06','08:50:00',1.3),('5819','2013-01-06','08:55:00',1.38),('5819','2013-01-06','09:00:00',1.45),('5819','2013-01-06','09:05:00',1.52),('5819','2013-01-06','09:10:00',1.59),('5819','2013-01-06','09:15:00',1.66),('5819','2013-01-06','09:20:00',1.71),('5819','2013-01-06','09:25:00',1.78),('5819','2013-01-06','09:30:00',1.84),('5819','2013-01-06','09:35:00',1.9),('5819','2013-01-06','09:40:00',1.95),('5819','2013-01-06','09:45:00',1.99),('5819','2013-01-06','09:50:00',2.05),('5819','2013-01-06','09:55:00',2.07),('5819','2013-01-06','10:00:00',2.11),('5819','2013-01-06','10:05:00',2.14),('5819','2013-01-06','10:10:00',2.19),('5819','2013-01-06','10:15:00',2.24),('5819','2013-01-06','10:20:00',2.24),('5819','2013-01-06','10:25:00',2.31),('5819','2013-01-06','10:30:00',2.35),('5819','2013-01-06','10:35:00',2.38),('5819','2013-01-06','10:40:00',2.41),('5819','2013-01-06','10:45:00',2.44),('5819','2013-01-06','10:50:00',2.46),('5819','2013-01-06','10:55:00',2.47),('5819','2013-01-06','11:00:00',2.48),('5819','2013-01-06','11:05:00',2.5),('5819','2013-01-06','11:10:00',2.51),('5819','2013-01-06','11:15:00',2.51),('5819','2013-01-06','11:20:00',2.52),('5819','2013-01-06','11:25:00',2.54),('5819','2013-01-06','11:30:00',2.54),('5819','2013-01-06','11:35:00',2.54),('5819','2013-01-06','11:40:00',2.53),('5819','2013-01-06','11:45:00',2.53),('5819','2013-01-06','11:50:00',2.54),('5819','2013-01-06','11:55:00',2.54),('5819','2013-01-06','12:00:00',2.54),('5819','2013-01-06','12:05:00',2.54),('5819','2013-01-06','12:10:00',2.52),('5819','2013-01-06','12:15:00',2.5),('5819','2013-01-06','12:20:00',2.49),('5819','2013-01-06','12:25:00',2.43),('5819','2013-01-06','12:30:00',2.42),('5819','2013-01-06','12:35:00',2.38),('5819','2013-01-06','12:40:00',2.37),('5819','2013-01-06','12:45:00',2.35),('5819','2013-01-06','12:50:00',2.35),('5819','2013-01-06','12:55:00',2.34),('5819','2013-01-06','13:00:00',2.32),('5819','2013-01-06','13:05:00',2.29),('5819','2013-01-06','13:10:00',2.27),('5819','2013-01-06','13:15:00',2.22),('5819','2013-01-06','13:20:00',2.17),('5819','2013-01-06','13:25:00',2.13),('5819','2013-01-06','13:30:00',2.1),('5819','2013-01-06','13:35:00',2.07),('5819','2013-01-06','13:40:00',2.03),('5819','2013-01-06','13:45:00',1.98),('5819','2013-01-06','13:50:00',1.92),('5819','2013-01-06','13:55:00',1.84),('5819','2013-01-06','14:00:00',1.84),('5819','2013-01-06','14:05:00',1.7),('5819','2013-01-06','14:10:00',1.51),('5819','2013-01-06','14:15:00',1.23),('5819','2013-01-06','14:20:00',1.46),('5819','2013-01-06','14:25:00',1.46),('5819','2013-01-06','14:30:00',1.45),('5819','2013-01-06','14:35:00',1.38),('5819','2013-01-06','14:40:00',1.3),('5819','2013-01-06','14:45:00',1.27),('5819','2013-01-06','14:50:00',1.19),('5819','2013-01-06','14:55:00',1.11),('5819','2013-01-06','15:00:00',1.05),('5819','2013-01-05','10:10:00',1.11),('5819','2013-01-05','10:15:00',1.16),('5819','2013-01-05','10:20:00',1.07),('5819','2013-01-05','10:35:00',1.06),('5819','2013-01-05','10:40:00',1.13),('5819','2013-01-05','10:45:00',1.1),('5819','2013-01-05','10:50:00',1.32),('5819','2013-01-05','10:55:00',2.16),('5819','2013-01-05','11:00:00',1.81),('5819','2013-01-05','11:05:00',2.17),('5819','2013-01-05','11:10:00',2.1),('5819','2013-01-05','11:15:00',1.77),('5819','2013-01-05','11:20:00',2.32),('5819','2013-01-05','11:25:00',2.41),('5819','2013-01-05','11:30:00',2.39),('5819','2013-01-05','11:35:00',2.19),('5819','2013-01-05','11:40:00',1.97),('5819','2013-01-05','11:45:00',1.96),('5819','2013-01-05','11:50:00',1.71),('5819','2013-01-05','11:55:00',1.55),('5819','2013-01-05','12:00:00',1.45),('5819','2013-01-05','12:05:00',1.42),('5819','2013-01-05','12:10:00',1.4),('5819','2013-01-05','12:15:00',1.41),('5819','2013-01-05','12:20:00',1.26),('5819','2013-01-05','12:25:00',1.09),('5819','2013-01-05','12:30:00',1.15),('5819','2013-01-05','12:35:00',1.57),('5819','2013-01-05','12:40:00',1.87),('5819','2013-01-05','12:45:00',2.06),('5819','2013-01-05','12:50:00',1.3),('5819','2013-01-05','12:55:00',1.13),('5819','2013-01-05','13:00:00',1.18),('5819','2013-01-05','13:05:00',1.07),('5819','2013-01-05','13:10:00',1.03),('5819','2013-01-05','13:30:00',1.57),('5819','2013-01-05','13:35:00',1.44),('5819','2013-01-05','13:40:00',1.02),('5819','2013-01-05','13:55:00',1.04),('5819','2013-01-05','14:05:00',1.45),('5819','2013-01-05','14:10:00',1.29),('5819','2013-01-05','14:30:00',1.05),('5819','2013-01-05','14:35:00',1.02),('5819','2013-01-05','14:40:00',1.1),('5819','2013-01-05','14:45:00',1.13),('5819','2013-01-04','08:45:00',1.21),('5819','2013-01-04','08:50:00',1.29),('5819','2013-01-04','08:55:00',1.28),('5819','2013-01-04','09:00:00',1.3),('5819','2013-01-04','09:05:00',1.4),('5819','2013-01-04','09:10:00',1.48),('5819','2013-01-04','09:15:00',1.14),('5819','2013-01-04','09:20:00',1.45),('5819','2013-01-04','09:25:00',1.36),('5819','2013-01-04','09:30:00',1.31),('5819','2013-01-04','09:35:00',1.25),('5819','2013-01-04','09:40:00',1.36),('5819','2013-01-04','09:45:00',1.35),('5819','2013-01-04','09:50:00',1.41),('5819','2013-01-04','09:55:00',1.89),('5819','2013-01-04','10:00:00',2.2),('5819','2013-01-04','10:05:00',2.25),('5819','2013-01-04','10:10:00',1.91),('5819','2013-01-04','10:15:00',2.25),('5819','2013-01-04','10:20:00',1.83),('5819','2013-01-04','10:25:00',2.3),('5819','2013-01-04','10:30:00',2.37),('5819','2013-01-04','10:35:00',2.4),('5819','2013-01-04','10:40:00',2.47),('5819','2013-01-04','10:45:00',2.56),('5819','2013-01-04','10:50:00',2.67),('5819','2013-01-04','10:55:00',2.69),('5819','2013-01-04','11:00:00',2.34),('5819','2013-01-04','11:05:00',1.3),('5819','2013-01-04','11:20:00',1.18),('5819','2013-01-04','11:35:00',1.36),('5819','2013-01-04','11:40:00',1.12),('5819','2013-01-04','11:45:00',1.68),('5819','2013-01-04','11:50:00',2.47),('5819','2013-01-04','11:55:00',2.82),('5819','2013-01-04','12:00:00',2.82),('5819','2013-01-04','12:05:00',2.42),('5819','2013-01-04','12:10:00',1.93),('5819','2013-01-04','12:15:00',1.29),('5819','2013-01-04','12:20:00',1.04),('5819','2013-01-04','12:25:00',1.37),('5819','2013-01-04','12:30:00',1.79),('5819','2013-01-04','12:35:00',1.66),('5819','2013-01-04','12:40:00',2.34),('5819','2013-01-04','12:45:00',2.49),('5819','2013-01-04','12:50:00',2.48),('5819','2013-01-04','12:55:00',2.44),('5819','2013-01-04','13:00:00',2.36),('5819','2013-01-04','13:05:00',2.23),('5819','2013-01-04','13:10:00',2.2),('5819','2013-01-04','13:15:00',1.92),('5819','2013-01-04','13:20:00',2.11),('5819','2013-01-04','13:25:00',2.06),('5819','2013-01-04','13:30:00',2.01),('5819','2013-01-04','13:35:00',1.95),('5819','2013-01-04','13:40:00',1.9),('5819','2013-01-04','13:45:00',1.83),('5819','2013-01-04','13:50:00',1.75),('5819','2013-01-04','13:55:00',1.71),('5819','2013-01-04','14:00:00',1.64),('5819','2013-01-04','14:05:00',1.62),('5819','2013-01-04','14:10:00',1.61),('5819','2013-01-04','14:15:00',1.54),('5819','2013-01-04','14:20:00',1.47),('5819','2013-01-04','14:25:00',1.39),('5819','2013-01-04','14:30:00',1.33),('5819','2013-01-04','14:35:00',1.29),('5819','2013-01-04','14:40:00',1.25),('5819','2013-01-04','14:45:00',1.2),('5819','2013-01-04','14:50:00',1.11),('5819','2013-01-04','14:55:00',1.08),('5819','2013-01-04','15:00:00',1.03),('5819','2013-01-03','08:40:00',1.08),('5819','2013-01-03','08:45:00',1.16),('5819','2013-01-03','08:50:00',1.23),('5819','2013-01-03','08:55:00',1.29),('5819','2013-01-03','09:00:00',1.39),('5819','2013-01-03','09:05:00',1.47),('5819','2013-01-03','09:10:00',1.55),('5819','2013-01-03','09:15:00',1.63),('5819','2013-01-03','09:20:00',1.7),('5819','2013-01-03','09:25:00',1.76),('5819','2013-01-03','09:30:00',1.83),('5819','2013-01-03','09:35:00',1.9),('5819','2013-01-03','09:40:00',2.02),('5819','2013-01-03','09:45:00',2.17),('5819','2013-01-03','09:50:00',2.32),('5819','2013-01-03','09:55:00',2.45),('5819','2013-01-03','10:00:00',2.56),('5819','2013-01-03','10:05:00',2.45),('5819','2013-01-03','10:10:00',2.6),('5819','2013-01-03','10:15:00',2.79),('5819','2013-01-03','10:20:00',2.17),('5819','2013-01-03','10:25:00',2.06),('5819','2013-01-03','10:30:00',1.92),('5819','2013-01-03','10:35:00',2.07),('5819','2013-01-03','10:40:00',1.81),('5819','2013-01-03','10:45:00',1.66),('5819','2013-01-03','10:50:00',1.59),('5819','2013-01-03','10:55:00',1.48),('5819','2013-01-03','11:00:00',1.6),('5819','2013-01-03','11:05:00',1.55),('5819','2013-01-03','11:10:00',1.4),('5819','2013-01-03','11:15:00',1.38),('5819','2013-01-03','11:20:00',1.24),('5819','2013-01-03','11:25:00',1.15),('5819','2013-01-03','11:30:00',1.1),('5819','2013-01-03','11:35:00',2.33),('5819','2013-01-03','11:40:00',2.7),('5819','2013-01-03','11:45:00',2.67),('5819','2013-01-03','11:50:00',2.61),('5819','2013-01-03','11:55:00',2.57),('5819','2013-01-03','12:00:00',2.55),('5819','2013-01-03','12:05:00',2.54),('5819','2013-01-03','12:10:00',2.51),('5819','2013-01-03','12:15:00',2.49),('5819','2013-01-03','12:20:00',2.48),('5819','2013-01-03','12:25:00',2.46),('5819','2013-01-03','12:30:00',2.45),('5819','2013-01-03','12:35:00',2.44),('5819','2013-01-03','12:40:00',2.41),('5819','2013-01-03','12:45:00',2.38),('5819','2013-01-03','12:50:00',2.35),('5819','2013-01-03','12:55:00',2.33),('5819','2013-01-03','13:00:00',2.29),('5819','2013-01-03','13:05:00',2.25),('5819','2013-01-03','13:10:00',2.22),('5819','2013-01-03','13:15:00',2.17),('5819','2013-01-03','13:20:00',2.14),('5819','2013-01-03','13:25:00',2.11),('5819','2013-01-03','13:30:00',2.05),('5819','2013-01-03','13:35:00',2.02),('5819','2013-01-03','13:40:00',1.98),('5819','2013-01-03','13:45:00',1.92),('5819','2013-01-03','13:50:00',1.88),('5819','2013-01-03','13:55:00',1.83),('5819','2013-01-03','14:00:00',1.78),('5819','2013-01-03','14:05:00',1.72),('5819','2013-01-03','14:10:00',1.69),('5819','2013-01-03','14:15:00',1.64),('5819','2013-01-03','14:20:00',1.58),('5819','2013-01-03','14:25:00',1.51),('5819','2013-01-03','14:30:00',1.45),('5819','2013-01-03','14:35:00',1.39),('5819','2013-01-03','14:40:00',1.33),('5819','2013-01-03','14:45:00',1.27),('5819','2013-01-03','14:50:00',1.21),('5819','2013-01-03','14:55:00',1.16),('5819','2013-01-03','15:00:00',1.09),('5819','2013-01-03','15:05:00',1.02),('5819','2013-01-01','08:40:00',1.05),('5819','2013-01-01','08:45:00',1.13),('5819','2013-01-01','08:50:00',1.19),('5819','2013-01-01','08:55:00',1.26),('5819','2013-01-01','09:00:00',1.34),('5819','2013-01-01','09:05:00',1.41),('5819','2013-01-01','09:10:00',1.48),('5819','2013-01-01','09:15:00',1.54),('5819','2013-01-01','09:20:00',1.6),('5819','2013-01-01','09:25:00',1.66),('5819','2013-01-01','09:30:00',1.71),('5819','2013-01-01','09:35:00',1.77),('5819','2013-01-01','09:40:00',1.82),('5819','2013-01-01','09:45:00',1.88),('5819','2013-01-01','09:50:00',1.93),('5819','2013-01-01','09:55:00',1.97),('5819','2013-01-01','10:00:00',1.99),('5819','2013-01-01','10:05:00',2.04),('5819','2013-01-01','10:10:00',2.09),('5819','2013-01-01','10:15:00',2.12),('5819','2013-01-01','10:20:00',2.17),('5819','2013-01-01','10:25:00',2.2),('5819','2013-01-01','10:30:00',2.24),('5819','2013-01-01','10:35:00',2.26),('5819','2013-01-01','10:40:00',2.31),('5819','2013-01-01','10:45:00',2.21),('5819','2013-01-01','10:50:00',2.08),('5819','2013-01-01','10:55:00',1.4),('5819','2013-01-01','11:05:00',2.52),('5819','2013-01-01','11:10:00',2.55),('5819','2013-01-01','11:15:00',2.57),('5819','2013-01-01','11:20:00',2.01),('5819','2013-01-01','11:25:00',2.14),('5819','2013-01-01','11:30:00',2.82),('5819','2013-01-01','11:35:00',1.3),('5819','2013-01-01','11:40:00',1.28),('5819','2013-01-01','11:45:00',2.18),('5819','2013-01-01','11:50:00',2.43),('5819','2013-01-01','11:55:00',2.4),('5819','2013-01-01','12:00:00',1.29),('5819','2013-01-01','12:05:00',1.11),('5819','2013-01-01','12:10:00',1.31),('5819','2013-01-01','12:15:00',1.18),('5819','2013-01-01','12:20:00',1.26),('5819','2013-01-01','12:25:00',1.24),('5819','2013-01-01','12:30:00',1.01),('5819','2013-01-01','12:40:00',1.09),('5819','2013-01-01','12:45:00',1.23),('5819','2013-01-01','12:50:00',1.02),('5819','2013-01-01','12:55:00',1.01),('5819','2012-12-31','08:25:00',1.01),('5819','2012-12-31','08:30:00',1.11),('5819','2012-12-31','08:35:00',1.17),('5819','2012-12-31','09:05:00',1.18),('5819','2012-12-31','09:10:00',1.16),('5819','2012-12-31','09:15:00',1.42),('5819','2012-12-31','09:20:00',1.77),('5819','2012-12-31','09:25:00',1.94),('5819','2012-12-31','09:30:00',1.67),('5819','2012-12-31','10:10:00',1.78),('5819','2012-12-31','10:15:00',2.44),('5819','2012-12-31','10:20:00',2.44),('5819','2012-12-31','10:25:00',2.43),('5819','2012-12-31','10:30:00',2.44),('5819','2012-12-31','10:35:00',2.45),('5819','2012-12-31','10:40:00',2.48),('5819','2012-12-31','10:45:00',2.45),('5819','2012-12-31','10:50:00',2.42),('5819','2012-12-31','10:55:00',2.47),('5819','2012-12-31','11:00:00',2.49),('5819','2012-12-31','11:05:00',2.5),('5819','2012-12-31','11:10:00',2.43),('5819','2012-12-31','11:15:00',2.42),('5819','2012-12-31','11:20:00',2.52),('5819','2012-12-31','11:25:00',2.55),('5819','2012-12-31','11:30:00',2.57),('5819','2012-12-31','11:35:00',2.58),('5819','2012-12-31','11:40:00',2.59),('5819','2012-12-31','11:45:00',2.58),('5819','2012-12-31','11:50:00',2.58),('5819','2012-12-31','11:55:00',2.58),('5819','2012-12-31','12:00:00',2.61),('5819','2012-12-31','12:05:00',2.61),('5819','2012-12-31','12:10:00',2.6),('5819','2012-12-31','12:15:00',2.59),('5819','2012-12-31','12:20:00',2.56),('5819','2012-12-31','12:25:00',2.54),('5819','2012-12-31','12:30:00',2.5),('5819','2012-12-31','12:35:00',2.48),('5819','2012-12-31','12:40:00',2.46),('5819','2012-12-31','12:45:00',2.43),('5819','2012-12-31','12:50:00',2.4),('5819','2012-12-31','12:55:00',2.38),('5819','2012-12-31','13:00:00',2.34),('5819','2012-12-31','13:05:00',2.3),('5819','2012-12-31','13:10:00',2.27),('5819','2012-12-31','13:15:00',2.23),('5819','2012-12-31','13:20:00',2.19),('5819','2012-12-31','13:25:00',2.16),('5819','2012-12-31','13:30:00',2.11),('5819','2012-12-31','13:35:00',2.06),('5819','2012-12-31','13:40:00',2),('5819','2012-12-31','13:45:00',1.94),('5819','2012-12-31','13:50:00',1.89),('5819','2012-12-31','13:55:00',1.85),('5819','2012-12-31','14:00:00',1.79),('5819','2012-12-31','14:05:00',1.73),('5819','2012-12-31','14:10:00',1.67),('5819','2012-12-31','14:15:00',1.61),('5819','2012-12-31','14:20:00',1.55),('5819','2012-12-31','14:25:00',1.49),('5819','2012-12-31','14:30:00',1.45),('5819','2012-12-31','14:35:00',1.38),('5819','2012-12-31','14:40:00',1.32),('5819','2012-12-31','14:45:00',1.25),('5819','2012-12-31','14:50:00',1.2),('5819','2012-12-31','14:55:00',1.13),('5819','2012-12-31','15:00:00',1.06),('5819','2012-12-31','15:05:00',1.01),('5819','2012-12-30','08:35:00',1.04),('5819','2012-12-30','08:40:00',1.12),('5819','2012-12-30','08:45:00',1.21),('5819','2012-12-30','08:50:00',1.28),('5819','2012-12-30','08:55:00',1.35),('5819','2012-12-30','09:00:00',1.42),('5819','2012-12-30','09:05:00',1.5),('5819','2012-12-30','09:10:00',1.57),('5819','2012-12-30','09:15:00',1.64),('5819','2012-12-30','09:20:00',1.71),('5819','2012-12-30','09:25:00',1.77),('5819','2012-12-30','09:30:00',1.83),('5819','2012-12-30','09:35:00',1.89),('5819','2012-12-30','09:40:00',1.95),('5819','2012-12-30','09:45:00',1.99),('5819','2012-12-30','09:50:00',2.03),('5819','2012-12-30','09:55:00',2.07),('5819','2012-12-30','10:00:00',2.13),('5819','2012-12-30','10:05:00',2.18),('5819','2012-12-30','10:10:00',2.23),('5819','2012-12-30','10:15:00',2.26),('5819','2012-12-30','10:20:00',2.3),('5819','2012-12-30','10:25:00',2.34),('5819','2012-12-30','10:30:00',2.37),('5819','2012-12-30','10:35:00',2.41),('5819','2012-12-30','10:40:00',2.43),('5819','2012-12-30','10:45:00',2.45),('5819','2012-12-30','10:50:00',2.46),('5819','2012-12-30','10:55:00',2.48),('5819','2012-12-30','11:00:00',2.49),('5819','2012-12-30','11:05:00',2.51),('5819','2012-12-30','11:10:00',2.53),('5819','2012-12-30','11:15:00',2.54),('5819','2012-12-30','11:20:00',2.54),('5819','2012-12-30','11:25:00',2.54),('5819','2012-12-30','11:30:00',2.54),('5819','2012-12-30','11:35:00',2.56),('5819','2012-12-30','11:40:00',2.54),('5819','2012-12-30','11:45:00',2.55),('5819','2012-12-30','11:50:00',2.54),('5819','2012-12-30','11:55:00',2.54),('5819','2012-12-30','12:00:00',2.52),('5819','2012-12-30','12:05:00',2.52),('5819','2012-12-30','12:10:00',2.5),('5819','2012-12-30','12:15:00',2.49),('5819','2012-12-30','12:20:00',2.46),('5819','2012-12-30','12:25:00',2.44),('5819','2012-12-30','12:30:00',2.43),('5819','2012-12-30','12:35:00',2.39),('5819','2012-12-30','12:40:00',2.37),('5819','2012-12-30','12:45:00',2.32),('5819','2012-12-30','12:50:00',2.29),('5819','2012-12-30','12:55:00',2.28),('5819','2012-12-30','13:00:00',2.29),('5819','2012-12-30','13:05:00',2.28),('5819','2012-12-30','13:10:00',2.25),('5819','2012-12-30','13:15:00',2.22),('5819','2012-12-30','13:20:00',2.16),('5819','2012-12-30','13:25:00',2.14),('5819','2012-12-30','13:30:00',2.09),('5819','2012-12-30','13:35:00',2.05),('5819','2012-12-30','13:40:00',2),('5819','2012-12-30','13:45:00',1.95),('5819','2012-12-30','13:50:00',1.91),('5819','2012-12-30','13:55:00',1.85),('5819','2012-12-30','14:00:00',1.81),('5819','2012-12-30','14:05:00',1.75),('5819','2012-12-30','14:10:00',1.69),('5819','2012-12-30','14:15:00',1.64),('5819','2012-12-30','14:20:00',1.58),('5819','2012-12-30','14:25:00',1.52),('5819','2012-12-30','14:30:00',1.44),('5819','2012-12-30','14:35:00',1.39),('5819','2012-12-30','14:40:00',1.32),('5819','2012-12-30','14:45:00',1.26),('5819','2012-12-30','14:50:00',1.2),('5819','2012-12-30','14:55:00',1.13),('5819','2012-12-30','15:00:00',1.07),('5819','2012-12-29','08:35:00',1.06),('5819','2012-12-29','08:40:00',1.18),('5819','2012-12-29','08:45:00',1.27),('5819','2012-12-29','08:50:00',1.36),('5819','2012-12-29','08:55:00',1.43),('5819','2012-12-29','09:00:00',1.47),('5819','2012-12-29','09:05:00',1.54),('5819','2012-12-29','09:10:00',1.62),('5819','2012-12-29','09:15:00',1.68),('5819','2012-12-29','09:20:00',1.74),('5819','2012-12-29','09:25:00',1.79),('5819','2012-12-29','09:30:00',1.84),('5819','2012-12-29','09:35:00',1.89),('5819','2012-12-29','09:40:00',1.96),('5819','2012-12-29','09:45:00',2.03),('5819','2012-12-29','09:50:00',2.09),('5819','2012-12-29','09:55:00',2.15),('5819','2012-12-29','10:00:00',2.2),('5819','2012-12-29','10:05:00',2.24),('5819','2012-12-29','10:10:00',2.28),('5819','2012-12-29','10:15:00',2.33),('5819','2012-12-29','10:20:00',2.36),('5819','2012-12-29','10:25:00',2.4),('5819','2012-12-29','10:30:00',2.43),('5819','2012-12-29','10:35:00',2.45),('5819','2012-12-29','10:40:00',2.47),('5819','2012-12-29','10:45:00',2.5),('5819','2012-12-29','10:50:00',2.53),('5819','2012-12-29','10:55:00',2.56),('5819','2012-12-29','11:00:00',2.57),('5819','2012-12-29','11:05:00',2.58),('5819','2012-12-29','11:10:00',2.59),('5819','2012-12-29','11:15:00',2.61),('5819','2012-12-29','11:20:00',2.62),('5819','2012-12-29','11:25:00',2.63),('5819','2012-12-29','11:30:00',2.61),('5819','2012-12-29','11:35:00',2.62),('5819','2012-12-29','11:40:00',2.59),('5819','2012-12-29','11:45:00',2.6),('5819','2012-12-29','11:50:00',2.61),('5819','2012-12-29','11:55:00',2.59),('5819','2012-12-29','12:00:00',2.59),('5819','2012-12-29','12:05:00',2.6),('5819','2012-12-29','12:10:00',2.61),('5819','2012-12-29','12:15:00',2.56),('5819','2012-12-29','12:20:00',2.52),('5819','2012-12-29','12:25:00',2.48),('5819','2012-12-29','12:30:00',2.47),('5819','2012-12-29','12:35:00',2.47),('5819','2012-12-29','12:40:00',2.46),('5819','2012-12-29','12:45:00',2.41),('5819','2012-12-29','12:50:00',2.36),('5819','2012-12-29','12:55:00',2.34),('5819','2012-12-29','13:00:00',2.33),('5819','2012-12-29','13:05:00',2.31),('5819','2012-12-29','13:10:00',2.28),('5819','2012-12-29','13:15:00',2.26),('5819','2012-12-29','13:20:00',2.22),('5819','2012-12-29','13:25:00',2.16),('5819','2012-12-29','13:30:00',2.12),('5819','2012-12-29','13:35:00',2.07),('5819','2012-12-29','13:40:00',2.03),('5819','2012-12-29','13:45:00',1.98),('5819','2012-12-29','13:50:00',1.93),('5819','2012-12-29','13:55:00',1.88),('5819','2012-12-29','14:00:00',1.82),('5819','2012-12-29','14:05:00',1.76),('5819','2012-12-29','14:10:00',1.71),('5819','2012-12-29','14:15:00',1.66),('5819','2012-12-29','14:20:00',1.6),('5819','2012-12-29','14:25:00',1.54),('5819','2012-12-29','14:30:00',1.47),('5819','2012-12-29','14:35:00',1.41),('5819','2012-12-29','14:40:00',1.34),('5819','2012-12-29','14:45:00',1.29),('5819','2012-12-29','14:50:00',1.23),('5819','2012-12-29','14:55:00',1.16),('5819','2012-12-29','15:00:00',1.1),('5819','2012-12-29','15:05:00',1.04),('5819','2012-12-28','08:45:00',1.07),('5819','2012-12-28','08:50:00',1.16),('5819','2012-12-28','08:55:00',1.26),('5819','2012-12-28','09:00:00',1.33),('5819','2012-12-28','09:05:00',1.41),('5819','2012-12-28','09:10:00',1.47),('5819','2012-12-28','09:15:00',1.55),('5819','2012-12-28','09:20:00',1.59),('5819','2012-12-28','09:25:00',1.63),('5819','2012-12-28','09:30:00',1.69),('5819','2012-12-28','09:35:00',1.74),('5819','2012-12-28','09:40:00',1.81),('5819','2012-12-28','09:45:00',1.85),('5819','2012-12-28','09:50:00',1.82),('5819','2012-12-28','09:55:00',1.94),('5819','2012-12-28','10:00:00',1.98),('5819','2012-12-28','10:05:00',2.03),('5819','2012-12-28','10:10:00',2.11),('5819','2012-12-28','10:15:00',2.18),('5819','2012-12-28','10:20:00',2.2),('5819','2012-12-28','10:25:00',2.23),('5819','2012-12-28','10:30:00',2.27),('5819','2012-12-28','10:35:00',2.32),('5819','2012-12-28','10:40:00',2.31),('5819','2012-12-28','10:45:00',2.36),('5819','2012-12-28','10:50:00',2.38),('5819','2012-12-28','10:55:00',2.4),('5819','2012-12-28','11:00:00',2.43),('5819','2012-12-28','11:05:00',2.48),('5819','2012-12-28','11:10:00',2.4),('5819','2012-12-28','11:15:00',2.11),('5819','2012-12-28','11:20:00',2.49),('5819','2012-12-28','11:25:00',2.51),('5819','2012-12-28','11:30:00',2.5),('5819','2012-12-28','11:35:00',2.52),('5819','2012-12-28','11:40:00',2.53),('5819','2012-12-28','11:45:00',2.56),('5819','2012-12-28','11:50:00',2.41),('5819','2012-12-28','11:55:00',2.53),('5819','2012-12-28','12:00:00',2.52),('5819','2012-12-28','12:05:00',2.51),('5819','2012-12-28','12:10:00',2.47),('5819','2012-12-28','12:15:00',2.46),('5819','2012-12-28','12:20:00',2.43),('5819','2012-12-28','12:25:00',2.41),('5819','2012-12-28','12:30:00',2.38),('5819','2012-12-28','12:35:00',2.35),('5819','2012-12-28','12:40:00',2.02),('5819','2012-12-28','12:45:00',2.28),('5819','2012-12-28','12:50:00',2.33),('5819','2012-12-28','12:55:00',2.26),('5819','2012-12-28','13:00:00',2.18),('5819','2012-12-28','13:05:00',2.17),('5819','2012-12-28','13:10:00',2.1),('5819','2012-12-28','13:15:00',2.08),('5819','2012-12-28','13:20:00',2.05),('5819','2012-12-28','13:25:00',2.01),('5819','2012-12-28','13:30:00',1.97),('5819','2012-12-28','13:35:00',1.91),('5819','2012-12-28','13:40:00',1.86),('5819','2012-12-28','13:45:00',1.83),('5819','2012-12-28','13:50:00',1.79),('5819','2012-12-28','13:55:00',1.73),('5819','2012-12-28','14:00:00',1.68),('5819','2012-12-28','14:05:00',1.6),('5819','2012-12-28','14:10:00',1.52),('5819','2012-12-28','14:15:00',1.3),('5819','2012-12-28','14:20:00',1.44),('5819','2012-12-28','14:25:00',1.39),('5819','2012-12-28','14:30:00',1.32),('5819','2012-12-28','14:35:00',1.22),('5819','2012-12-28','14:45:00',1.14),('5819','2012-12-28','14:50:00',1.09),('5819','2012-12-28','14:55:00',1.03),('5819','2012-12-27','09:25:00',1.02),('5819','2012-12-27','09:30:00',1.01),('5819','2012-12-27','09:35:00',1.48),('5819','2012-12-27','09:40:00',1.87),('5819','2012-12-27','09:45:00',1.93),('5819','2012-12-27','09:50:00',1.99),('5819','2012-12-27','09:55:00',1.41),('5819','2012-12-27','10:05:00',1.1),('5819','2012-12-27','10:10:00',1.28),('5819','2012-12-27','10:15:00',1.61),('5819','2012-12-27','10:20:00',2.03),('5819','2012-12-27','10:25:00',2.12),('5819','2012-12-27','10:30:00',2.05),('5819','2012-12-27','10:35:00',2.14),('5819','2012-12-27','10:40:00',2.19),('5819','2012-12-27','10:45:00',2.19),('5819','2012-12-27','10:50:00',2.23),('5819','2012-12-27','10:55:00',2.12),('5819','2012-12-27','11:00:00',2.14),('5819','2012-12-27','11:05:00',1.95),('5819','2012-12-27','11:10:00',1.36),('5819','2012-12-27','11:15:00',1.14),('5819','2012-12-27','11:25:00',1.36),('5819','2012-12-27','11:50:00',1.47),('5819','2012-12-27','11:55:00',2.33),('5819','2012-12-27','12:00:00',2.43),('5819','2012-12-27','12:05:00',2.55),('5819','2012-12-27','12:10:00',2.71),('5819','2012-12-27','12:15:00',2.52),('5819','2012-12-27','12:20:00',1.26),('5819','2012-12-27','12:25:00',2.25),('5819','2012-12-27','12:30:00',2.36),('5819','2012-12-27','12:35:00',2.37),('5819','2012-12-27','12:40:00',2.33),('5819','2012-12-27','12:45:00',2.38),('5819','2012-12-27','12:50:00',1.21),('5819','2012-12-27','12:55:00',2.34),('5819','2012-12-27','13:00:00',2.39),('5819','2012-12-27','13:05:00',1.84),('5819','2012-12-27','13:10:00',1.23),('5819','2012-12-27','13:15:00',1.12),('5819','2012-12-27','13:20:00',1.2),('5819','2012-12-27','14:05:00',1.16),('5819','2012-12-27','14:10:00',1.02),('5819','2012-12-27','14:15:00',1.3),('5819','2012-12-27','14:20:00',1.46),('5819','2012-12-27','14:25:00',1.43),('5819','2012-12-27','14:30:00',1.35),('5819','2012-12-27','14:35:00',1.29),('5819','2012-12-27','14:40:00',1.23),('5819','2012-12-27','14:45:00',1.1),('5819','2012-12-27','15:00:00',1.05),('5819','2012-12-26','09:15:00',1.3),('5819','2012-12-26','09:20:00',1.67),('5819','2012-12-26','09:25:00',1.71),('5819','2012-12-26','09:30:00',1.74),('5819','2012-12-26','09:35:00',1.78),('5819','2012-12-26','09:40:00',1.85),('5819','2012-12-26','09:45:00',1.88),('5819','2012-12-26','09:50:00',1.94),('5819','2012-12-26','09:55:00',1.98),('5819','2012-12-26','10:00:00',2.03),('5819','2012-12-26','10:05:00',2.06),('5819','2012-12-26','10:10:00',2.09),('5819','2012-12-26','10:15:00',2.12),('5819','2012-12-26','10:20:00',2.14),('5819','2012-12-26','10:25:00',2.15),('5819','2012-12-26','10:30:00',2.17),('5819','2012-12-26','10:35:00',2.2),('5819','2012-12-26','10:40:00',2.23),('5819','2012-12-26','10:45:00',2.23),('5819','2012-12-26','10:50:00',2.24),('5819','2012-12-26','10:55:00',2.27),('5819','2012-12-26','11:00:00',2.29),('5819','2012-12-26','11:05:00',2.31),('5819','2012-12-26','11:10:00',2.32),('5819','2012-12-26','11:15:00',2.32),('5819','2012-12-26','11:20:00',2.33),('5819','2012-12-26','11:25:00',2.34),('5819','2012-12-26','11:30:00',2.33),('5819','2012-12-26','11:35:00',2.35),('5819','2012-12-26','11:40:00',2.37),('5819','2012-12-26','11:45:00',2.36),('5819','2012-12-26','11:50:00',2.38),('5819','2012-12-26','11:55:00',2.42),('5819','2012-12-26','12:00:00',2.46),('5819','2012-12-26','12:05:00',2.48),('5819','2012-12-26','12:10:00',2.44),('5819','2012-12-26','12:15:00',2.47),('5819','2012-12-26','12:20:00',2.46),('5819','2012-12-26','12:25:00',2.47),('5819','2012-12-26','12:30:00',2.45),('5819','2012-12-26','12:35:00',2.41),('5819','2012-12-26','12:40:00',2.44),('5819','2012-12-26','12:45:00',2.38),('5819','2012-12-26','12:50:00',2.31),('5819','2012-12-26','12:55:00',2.3),('5819','2012-12-26','13:00:00',2.33),('5819','2012-12-26','13:05:00',2.28),('5819','2012-12-26','13:10:00',2.3),('5819','2012-12-26','13:15:00',2.29),('5819','2012-12-26','13:20:00',2.33),('5819','2012-12-26','13:25:00',2.37),('5819','2012-12-26','13:30:00',2.53),('5819','2012-12-26','13:35:00',2.4),('5819','2012-12-26','13:40:00',2.34),('5819','2012-12-26','13:45:00',2.24),('5819','2012-12-26','13:50:00',1.91),('5819','2012-12-26','13:55:00',1.91),('5819','2012-12-26','14:00:00',1.72),('5819','2012-12-26','14:05:00',1.85),('5819','2012-12-23','08:35:00',1.08),('5819','2012-12-23','08:40:00',1.17),('5819','2012-12-23','08:45:00',1.24),('5819','2012-12-23','08:50:00',1.31),('5819','2012-12-23','08:55:00',1.4),('5819','2012-12-23','09:00:00',1.49),('5819','2012-12-23','09:05:00',1.57),('5819','2012-12-23','09:10:00',1.61),('5819','2012-12-23','09:15:00',1.62),('5819','2012-12-23','09:20:00',1.67),('5819','2012-12-23','09:25:00',1.76),('5819','2012-12-23','09:30:00',1.77),('5819','2012-12-23','09:35:00',1.85),('5819','2012-12-23','09:40:00',1.9),('5819','2012-12-23','09:45:00',1.95),('5819','2012-12-23','09:50:00',1.98),('5819','2012-12-23','09:55:00',2),('5819','2012-12-23','10:00:00',2.03),('5819','2012-12-23','10:05:00',2.1),('5819','2012-12-23','10:10:00',2.13),('5819','2012-12-23','10:15:00',2.15),('5819','2012-12-23','10:20:00',2.2),('5819','2012-12-23','10:25:00',2.22),('5819','2012-12-23','10:30:00',2.2),('5819','2012-12-23','10:35:00',2.28),('5819','2012-12-23','10:40:00',2.3),('5819','2012-12-23','10:45:00',2.33),('5819','2012-12-23','10:50:00',2.33),('5819','2012-12-23','10:55:00',2.22),('5819','2012-12-23','11:00:00',2.36),('5819','2012-12-23','11:05:00',2.37),('5819','2012-12-23','11:10:00',2.37),('5819','2012-12-23','11:15:00',2.39),('5819','2012-12-23','11:20:00',2.46),('5819','2012-12-23','11:25:00',2.24),('5819','2012-12-23','11:30:00',2.37),('5819','2012-12-23','11:35:00',2.48),('5819','2012-12-23','11:40:00',2.46),('5819','2012-12-23','11:45:00',2.42),('5819','2012-12-23','11:50:00',2.48),('5819','2012-12-23','11:55:00',2.3),('5819','2012-12-23','12:00:00',2.15),('5819','2012-12-23','12:05:00',2.17),('5819','2012-12-23','12:10:00',2.17),('5819','2012-12-23','12:15:00',1.76),('5819','2012-12-23','12:20:00',1.67),('5819','2012-12-23','12:30:00',1.37),('5819','2012-12-23','12:35:00',1.42),('5819','2012-12-23','12:40:00',1.35),('5819','2012-12-23','12:45:00',1.09),('5819','2012-12-23','12:50:00',1.55),('5819','2012-12-23','12:55:00',2.03),('5819','2012-12-23','13:00:00',2.11),('5819','2012-12-23','13:05:00',1.82),('5819','2012-12-23','13:10:00',2.07),('5819','2012-12-23','13:15:00',1.35),('5819','2012-12-23','13:40:00',1.47),('5819','2012-12-23','13:45:00',1.42),('5819','2012-12-23','13:50:00',1.26),('5819','2012-12-23','13:55:00',1.2),('5819','2012-12-23','14:00:00',1.74),('5819','2012-12-23','14:05:00',1.47),('5819','2012-12-23','14:10:00',1.39),('5819','2012-12-23','14:15:00',1.4),('5819','2012-12-23','14:20:00',1.1),('5819','2012-12-23','14:40:00',1.15),('5819','2012-12-23','14:45:00',1.19),('5819','2014-05-01','07:45:00',1.07),('5819','2014-05-01','07:50:00',1.43),('5819','2014-05-01','07:55:00',1.56),('5819','2014-05-01','08:00:00',1.69),('5819','2014-05-01','08:05:00',1.68),('5819','2014-05-01','08:10:00',1.79),('5819','2014-05-01','08:15:00',1.88),('5819','2014-05-01','08:20:00',1.97),('5819','2014-05-01','08:25:00',2.05),('5819','2014-05-01','08:30:00',2.13),('5819','2014-05-01','08:35:00',2.22),('5819','2014-05-01','08:40:00',2.29),('5819','2014-05-01','08:45:00',2.37),('5819','2014-05-01','08:50:00',2.54),('5819','2014-05-01','08:55:00',2.79),('5819','2014-05-01','09:00:00',1.4),('5819','2014-05-01','09:05:00',1.33),('5819','2014-05-01','09:10:00',2.19),('5819','2014-05-01','09:15:00',1.82),('5819','2014-05-01','09:20:00',1.15),('5819','2014-05-01','09:25:00',1.98),('5819','2014-05-01','09:30:00',3.15),('5819','2014-05-01','09:35:00',2.79),('5819','2014-05-01','09:40:00',1.17),('5819','2014-05-01','09:45:00',1.8),('5819','2014-05-01','09:50:00',1.55),('5819','2014-05-01','09:55:00',1.65),('5819','2014-05-01','10:00:00',1.85),('5819','2014-05-01','10:05:00',2.81),('5819','2014-05-01','10:10:00',2.92),('5819','2014-05-01','10:15:00',3.29),('5819','2014-05-01','10:20:00',3.01),('5819','2014-05-01','10:25:00',3.73),('5819','2014-05-01','10:30:00',2.66),('5819','2014-05-01','10:35:00',1.23),('5819','2014-05-01','10:40:00',1.64),('5819','2014-05-01','10:45:00',4.11),('5819','2014-05-01','10:50:00',4.08),('5819','2014-05-01','10:55:00',3.2),('5819','2014-05-01','11:00:00',3.24),('5819','2014-05-01','11:05:00',1.47),('5819','2014-05-01','11:10:00',1.72),('5819','2014-05-01','11:15:00',2.67),('5819','2014-05-01','11:20:00',4.53),('5819','2014-05-01','11:25:00',3.4),('5819','2014-05-01','11:30:00',4.3),('5819','2014-05-01','11:35:00',3.18),('5819','2014-05-01','11:40:00',3.63),('5819','2014-05-01','11:45:00',4.24),('5819','2014-05-01','11:50:00',2.05),('5819','2014-05-01','11:55:00',3.78),('5819','2014-05-01','12:00:00',3.63),('5819','2014-05-01','12:05:00',4.53),('5819','2014-05-01','12:10:00',3.76),('5819','2014-05-01','12:15:00',2.92),('5819','2014-05-01','12:20:00',2.34),('5819','2014-05-01','12:25:00',3.63),('5819','2014-05-01','12:30:00',4.49),('5819','2014-05-01','12:35:00',4.44),('5819','2014-05-01','12:40:00',4.41),('5819','2014-05-01','12:45:00',4.29),('5819','2014-05-01','12:50:00',4.32),('5819','2014-05-01','12:55:00',4.32),('5819','2014-05-01','13:00:00',4.41),('5819','2014-05-01','13:05:00',4.31),('5819','2014-05-01','13:10:00',4.4),('5819','2014-05-01','13:15:00',4.34),('5819','2014-05-01','13:20:00',1.11),('5819','2014-05-01','13:25:00',3.89),('5819','2014-05-01','13:30:00',4.55),('5819','2014-05-01','13:35:00',4.4),('5819','2014-05-01','13:40:00',3.93),('5819','2014-05-01','13:45:00',2.69),('5819','2014-05-01','13:50:00',2.26),('5819','2014-05-01','14:00:00',1.48),('5819','2014-05-01','14:05:00',1.45),('5819','2014-05-01','14:10:00',4.48),('5819','2014-05-01','14:15:00',4.27),('5819','2014-05-01','14:20:00',3.85),('5819','2014-05-01','14:25:00',4.14),('5819','2014-05-01','14:30:00',3.79),('5819','2014-05-01','14:35:00',3.77),('5819','2014-05-01','14:40:00',3.91),('5819','2014-05-01','14:45:00',2.99),('5819','2014-05-01','14:50:00',3.55),('5819','2014-05-01','14:55:00',3.78),('5819','2014-05-01','15:00:00',3.49),('5819','2014-05-01','15:05:00',3.89),('5819','2014-05-01','15:10:00',2.72),('5819','2014-05-01','15:15:00',3.52),('5819','2014-05-01','15:20:00',3.46),('5819','2014-05-01','15:25:00',3.37),('5819','2014-05-01','15:30:00',3.25),('5819','2014-05-01','15:35:00',3.16),('5819','2014-05-01','15:40:00',3.11),('5819','2014-05-01','15:45:00',3.08),('5819','2014-05-01','15:50:00',2.91),('5819','2014-05-01','15:55:00',2.88),('5819','2014-05-01','16:00:00',2.79),('5819','2014-05-01','16:05:00',2.77),('5819','2014-05-01','16:10:00',2.67),('5819','2014-05-01','16:15:00',2.59),('5819','2014-05-01','16:20:00',2.49),('5819','2014-05-01','16:25:00',2.22),('5819','2014-05-01','16:30:00',2.32),('5819','2014-05-01','16:35:00',2.27),('5819','2014-05-01','16:40:00',2.13),('5819','2014-05-01','16:45:00',1.81),('5819','2014-05-01','16:50:00',1.77),('5819','2014-05-01','16:55:00',1.83),('5819','2014-05-01','17:00:00',1.59),('5819','2014-05-01','17:05:00',1.75),('5819','2014-05-01','17:10:00',1.76),('5819','2014-05-01','17:15:00',1.62),('5819','2014-05-01','17:20:00',1.55),('5819','2014-05-01','17:25:00',1.45),('5819','2014-05-01','17:30:00',1.34),('5819','2014-05-01','17:35:00',1.15),('5819','2014-05-01','17:45:00',1.1),('5819','2014-05-01','17:50:00',1.03),('5819','2014-05-01','18:00:00',1.02),('5819','2012-12-22','10:20:00',1.09),('5819','2012-12-22','10:25:00',2.12),('5819','2012-12-22','10:30:00',2.66),('5819','2012-12-22','10:35:00',2.82),('5819','2012-12-22','10:40:00',2.73),('5819','2012-12-22','10:45:00',2.67),('5819','2012-12-22','10:50:00',2.64),('5819','2012-12-22','10:55:00',2.66),('5819','2012-12-22','11:00:00',1.74),('5819','2012-12-22','11:45:00',1.39),('5819','2012-12-22','11:50:00',2.12),('5819','2012-12-22','11:55:00',1.31),('5819','2012-12-22','12:00:00',2.01),('5819','2012-12-22','12:50:00',1.59),('5819','2012-12-22','12:55:00',1.41),('5819','2012-12-22','13:00:00',1.81),('5819','2012-12-22','13:05:00',2.58),('5819','2012-12-22','13:10:00',2.74),('5819','2012-12-22','13:15:00',2.68),('5819','2012-12-22','13:20:00',2.66),('5819','2012-12-22','13:25:00',2.57),('5819','2012-12-22','13:30:00',2.16),('5819','2012-12-22','13:35:00',2.22),('5819','2012-12-22','13:40:00',2.06),('5819','2012-12-22','14:00:00',1.01),('5819','2012-12-22','14:05:00',1.2),('5819','2012-12-22','14:10:00',1.22),('5819','2012-12-22','14:15:00',1.31),('5819','2012-12-22','14:20:00',1.29),('5819','2012-12-22','15:00:00',1.11),('5819','2014-04-30','07:30:00',1.02),('5819','2014-04-30','07:35:00',1.13),('5819','2014-04-30','07:40:00',1.2),('5819','2014-04-30','07:45:00',1.31),('5819','2014-04-30','07:50:00',1.38),('5819','2014-04-30','07:55:00',1.49),('5819','2014-04-30','08:00:00',1.56),('5819','2014-04-30','08:05:00',1.6),('5819','2014-04-30','08:11:00',1.74),('5819','2014-04-30','08:15:00',1.83),('5819','2014-04-30','08:20:00',1.89),('5819','2014-04-30','08:25:00',1.98),('5819','2014-04-30','08:30:00',2.03),('5819','2014-04-30','08:35:00',2.14),('5819','2014-04-30','08:40:00',2.19),('5819','2014-04-30','08:45:00',2.23),('5819','2014-04-30','08:50:00',2.17),('5819','2014-04-30','08:55:00',2.45),('5819','2014-04-30','09:00:00',2.52),('5819','2014-04-30','09:05:00',2.69),('5819','2014-04-30','09:10:00',2.85),('5819','2014-04-30','09:15:00',2.88),('5819','2014-04-30','09:20:00',2.27),('5819','2014-04-30','09:25:00',1.74),('5819','2014-04-30','09:30:00',1.54),('5819','2014-04-30','09:35:00',3.16),('5819','2014-04-30','09:40:00',2.48),('5819','2014-04-30','09:45:00',3.38),('5819','2014-04-30','09:50:00',2.04),('5819','2014-04-30','09:55:00',2.45),('5819','2014-04-30','10:00:00',3.67),('5819','2014-04-30','10:05:00',3.98),('5819','2014-04-30','10:10:00',2.41),('5819','2014-04-30','10:15:00',2.35),('5819','2014-04-30','10:20:00',1.92),('5819','2014-04-30','10:25:00',1.54),('5819','2014-04-30','10:30:00',1.55),('5819','2014-04-30','10:35:00',2.22),('5819','2014-04-30','10:40:00',2.12),('5819','2014-04-30','10:45:00',1.47),('5819','2014-04-30','10:50:00',1.3),('5819','2014-04-30','10:55:00',3.79),('5819','2014-04-30','11:00:00',2.26),('5819','2014-04-30','11:05:00',3.45),('5819','2014-04-30','11:10:00',2.76),('5819','2014-04-30','11:15:00',2.1),('5819','2014-04-30','11:20:00',1.57),('5819','2014-04-30','11:25:00',2),('5819','2014-04-30','11:30:00',1.97),('5819','2014-04-30','11:35:00',1.91),('5819','2014-04-30','11:40:00',1.87),('5819','2014-04-30','11:45:00',2.03),('5819','2014-04-30','11:50:00',2.97),('5819','2014-04-30','11:55:00',2.11),('5819','2014-04-30','12:00:00',2.94),('5819','2014-04-30','12:05:00',1.48),('5819','2014-04-30','12:10:00',1.28),('5819','2014-04-30','12:15:00',1.59),('5819','2014-04-30','12:20:00',2.11),('5819','2014-04-30','12:25:00',1.39),('5819','2014-04-30','12:30:00',1.32),('5819','2014-04-30','12:35:00',1.27),('5819','2014-04-30','12:40:00',1.21),('5819','2014-04-30','12:45:00',1.9),('5819','2014-04-30','12:50:00',1.58),('5819','2014-04-30','12:55:00',3.5),('5819','2014-04-30','13:00:00',4.32),('5819','2014-04-30','13:05:00',3.58),('5819','2014-04-30','13:10:00',4.65),('5819','2014-04-30','13:15:00',2.23),('5819','2014-04-30','13:20:00',1.71),('5819','2014-04-30','13:25:00',2.14),('5819','2014-04-30','13:30:00',2.05),('5819','2014-04-30','13:35:00',1.67),('5819','2014-04-30','13:40:00',3.22),('5819','2014-04-30','13:45:00',2.67),('5819','2014-04-30','13:50:00',3.89),('5819','2014-04-30','13:55:00',4.81),('5819','2014-04-30','14:00:00',2.09),('5819','2014-04-30','14:05:00',1.75),('5819','2014-04-30','14:10:00',1.52),('5819','2014-04-30','14:15:00',1.71),('5819','2014-04-30','14:20:00',2.89),('5819','2014-04-30','14:25:00',2.76),('5819','2014-04-30','14:30:00',3.79),('5819','2014-04-30','14:35:00',4.07),('5819','2014-04-30','14:40:00',2.11),('5819','2014-04-30','14:45:00',1.38),('5819','2014-04-30','14:50:00',1.52),('5819','2014-04-30','14:55:00',1.72),('5819','2014-04-30','15:00:00',1.37),('5819','2014-04-30','15:05:00',1.35),('5819','2014-04-30','15:10:00',1.28),('5819','2014-04-30','15:15:00',1.2),('5819','2014-04-30','15:20:00',1.17),('5819','2014-04-30','15:25:00',1.3),('5819','2014-04-30','15:30:00',1.75),('5819','2014-04-30','15:35:00',2.11),('5819','2014-04-30','15:40:00',3.38),('5819','2014-04-30','15:45:00',3.4),('5819','2014-04-30','15:50:00',2.38),('5819','2014-04-30','15:55:00',2.88),('5819','2014-04-30','16:00:00',1.3),('5819','2014-04-30','16:05:00',1.96),('5819','2014-04-30','16:10:00',1.44),('5819','2014-04-30','16:15:00',1.67),('5819','2014-04-30','16:20:00',1.38),('5819','2014-04-30','16:25:00',1.37),('5819','2014-04-30','16:30:00',2.03),('5819','2014-04-30','16:35:00',1.36),('5819','2014-04-30','16:40:00',1.75),('5819','2014-04-30','16:45:00',2.02),('5819','2014-04-30','16:50:00',2.47),('5819','2014-04-30','16:55:00',2.08),('5819','2014-04-30','17:00:00',1.2),('5819','2014-04-30','17:05:00',2.28),('5819','2014-04-30','17:10:00',1.24),('5819','2014-04-29','09:55:00',1.03),('5819','2014-04-29','10:00:00',1.06),('5819','2014-04-29','10:05:00',1.82),('5819','2014-04-29','10:10:00',2.61),('5819','2014-04-29','10:15:00',3.67),('5819','2014-04-29','10:20:00',3.86),('5819','2014-04-29','10:25:00',3.86),('5819','2014-04-29','10:30:00',3.93),('5819','2014-04-29','10:35:00',3.86),('5819','2014-04-29','10:40:00',3.9),('5819','2014-04-29','10:45:00',3.92),('5819','2014-04-29','10:50:00',3.98),('5819','2014-04-29','10:55:00',3.73),('5819','2014-04-28','08:15:00',1.86),('5819','2014-04-28','08:20:00',1.98),('5819','2014-04-28','08:25:00',1.64),('5819','2014-04-28','08:30:00',1.27),('5819','2014-04-28','08:35:00',1.23),('5819','2014-04-28','08:40:00',1.11),('5819','2014-04-28','08:45:00',1.24),('5819','2014-04-28','08:50:00',1.42),('5819','2014-04-28','08:55:00',1.34),('5819','2014-04-28','09:00:00',1.2),('5819','2014-04-28','09:10:00',1.73),('5819','2014-04-28','09:15:00',2.32),('5819','2014-04-28','09:20:00',2.63),('5819','2014-04-28','09:25:00',1.77),('5819','2014-04-28','09:30:00',3.09),('5819','2014-04-28','09:35:00',1.91),('5819','2014-04-28','09:40:00',1.98),('5819','2014-04-28','09:45:00',2.25),('5819','2014-04-28','09:50:00',3.39),('5819','2014-04-28','09:55:00',1.78),('5819','2014-04-28','10:00:00',1.38),('5819','2014-04-28','10:05:00',1.89),('5819','2014-04-28','10:10:00',2.17),('5819','2014-04-28','10:15:00',2.12),('5819','2014-04-28','10:20:00',1.99),('5819','2014-04-28','10:25:00',1.51),('5819','2014-04-28','10:45:00',1.27),('5819','2014-04-28','10:50:00',1.8),('5819','2014-04-28','10:55:00',1.89),('5819','2014-04-28','11:00:00',1.67),('5819','2014-04-28','11:05:00',2.18),('5819','2014-04-28','11:10:00',2.44),('5819','2014-04-28','11:15:00',2.23),('5819','2014-04-28','11:20:00',2.37),('5819','2014-04-28','11:25:00',1.66),('5819','2014-04-28','11:30:00',1.7),('5819','2014-04-28','11:35:00',1.7),('5819','2014-04-28','11:40:00',1.43),('5819','2014-04-28','11:45:00',1.54),('5819','2014-04-28','11:50:00',1.65),('5819','2014-04-28','11:55:00',1.75),('5819','2014-04-28','12:00:00',1.67),('5819','2014-04-28','12:05:00',1.25),('5819','2014-04-28','12:10:00',1.63),('5819','2014-04-28','12:15:00',2.68),('5819','2014-04-28','12:20:00',2.79),('5819','2014-04-28','12:25:00',2.64),('5819','2014-04-28','12:30:00',2.46),('5819','2014-04-28','12:35:00',2.27),('5819','2014-04-28','12:40:00',2.04),('5819','2014-04-28','12:45:00',1.77),('5819','2014-04-28','12:50:00',2.06),('5819','2014-04-28','12:55:00',2.09),('5819','2014-04-28','13:00:00',2.16),('5819','2014-04-28','13:05:00',2.47),('5819','2014-04-28','13:10:00',3.33),('5819','2014-04-28','13:15:00',2.29),('5819','2014-04-28','13:20:00',2.05),('5819','2014-04-28','13:25:00',2.46),('5819','2014-04-28','13:30:00',4.11),('5819','2014-04-28','13:35:00',2.82),('5819','2014-04-28','13:40:00',4.02),('5819','2014-04-28','13:45:00',2.01),('5819','2014-04-28','13:50:00',4.25),('5819','2014-04-28','13:55:00',3.69),('5819','2014-04-28','14:00:00',2.9),('5819','2014-04-28','14:05:00',1.81),('5819','2014-04-28','14:10:00',4.47),('5819','2014-04-28','14:15:00',3.79),('5819','2014-04-28','14:20:00',3.24),('5819','2014-04-28','14:25:00',2.83),('5819','2014-04-28','14:30:00',3.24),('5819','2014-04-28','14:35:00',3.88),('5819','2014-04-28','14:40:00',2.73),('5819','2014-04-28','14:45:00',2.46),('5819','2014-04-28','14:50:00',1.98),('5819','2014-04-28','14:55:00',2.39),('5819','2014-04-28','15:00:00',2.04),('5819','2014-04-28','15:05:00',2.78),('5819','2014-04-28','15:10:00',2.73),('5819','2014-04-28','15:15:00',2.62),('5819','2014-04-28','15:20:00',2.96),('5819','2014-04-28','15:25:00',2.07),('5819','2014-04-28','15:30:00',1.48),('5819','2014-04-28','15:35:00',1.56),('5819','2014-04-28','15:40:00',2.54),('5819','2014-04-28','15:45:00',1.44),('5819','2014-04-28','15:50:00',3.14),('5819','2014-04-28','15:55:00',1.18),('5819','2014-04-28','16:00:00',3),('5819','2014-04-28','16:05:00',3.19),('5819','2014-04-28','16:10:00',2.65),('5819','2014-04-28','16:15:00',1.52),('5819','2014-04-28','16:20:00',2.42),('5819','2014-04-28','16:25:00',1.59),('5819','2014-04-28','16:30:00',2.16),('5819','2014-04-28','16:35:00',1.55),('5819','2014-04-28','16:55:00',1.85),('5819','2014-04-28','17:00:00',1.05),('5819','2014-04-28','17:40:00',1),('5819','2014-04-27','10:10:00',1.08),('5819','2014-04-27','11:05:00',1.24),('5819','2014-04-27','11:10:00',1.42),('5819','2014-04-27','11:15:00',1.33),('5819','2014-04-27','11:20:00',1.09),('5819','2014-04-27','11:35:00',1.27),('5819','2014-04-27','11:40:00',1.46),('5819','2014-04-27','11:45:00',2.86),('5819','2014-04-27','11:50:00',2.82),('5819','2014-04-27','11:55:00',2.27),('5819','2014-04-27','12:00:00',2.36),('5819','2014-04-27','12:05:00',2.51),('5819','2014-04-27','12:10:00',2.85),('5819','2014-04-27','12:15:00',2.79),('5819','2014-04-27','12:20:00',2.6),('5819','2014-04-27','12:25:00',2.68),('5819','2014-04-27','12:30:00',2.46),('5819','2014-04-27','12:35:00',2.47),('5819','2014-04-27','12:40:00',2.24),('5819','2014-04-27','12:45:00',2.41),('5819','2014-04-27','12:50:00',2.17),('5819','2014-04-27','12:55:00',1.55),('5819','2014-04-27','13:00:00',1.8),('5819','2014-04-27','13:05:00',1.94),('5819','2014-04-27','13:10:00',1.65),('5819','2014-04-27','13:15:00',1.63),('5819','2014-04-27','13:20:00',2.17),('5819','2014-04-27','13:25:00',2.11),('5819','2014-04-27','13:30:00',1.87),('5819','2014-04-27','13:35:00',1.62),('5819','2014-04-27','13:40:00',1.51),('5819','2014-04-27','13:45:00',1.45),('5819','2014-04-27','13:50:00',1.35),('5819','2014-04-27','13:55:00',1.31),('5819','2014-04-27','14:00:00',1.56),('5819','2014-04-27','14:05:00',2.14),('5819','2014-04-27','14:10:00',1.62),('5819','2014-04-27','14:15:00',1.36),('5819','2014-04-27','14:20:00',1.58),('5819','2014-04-27','14:25:00',1.98),('5819','2014-04-27','14:30:00',2.13),('5819','2014-04-27','14:35:00',2.05),('5819','2014-04-27','14:40:00',2.11),('5819','2014-04-27','14:45:00',1.89),('5819','2014-04-27','14:50:00',1.76),('5819','2014-04-27','14:55:00',1.86),('5819','2014-04-27','15:00:00',1.94),('5819','2014-04-27','15:05:00',2.62),('5819','2014-04-27','15:10:00',3.41),('5819','2014-04-27','15:15:00',2.7),('5819','2014-04-27','15:20:00',1.79),('5819','2014-04-27','15:25:00',1.17),('5819','2014-04-27','15:40:00',1.01),('6449','2013-06-20','06:45:00',1.04),('6449','2013-06-20','06:50:00',1.21),('6449','2013-06-20','06:55:00',1.4),('6449','2013-06-20','07:00:00',1.59),('6449','2013-06-20','07:05:00',1.83),('6449','2013-06-20','07:10:00',2.06),('6449','2013-06-20','07:15:00',2.31),('6449','2013-06-20','07:20:00',2.56),('6449','2013-06-20','07:25:00',2.85),('6449','2013-06-20','07:30:00',3.11),('6449','2013-06-20','07:35:00',3.42),('6449','2013-06-20','07:40:00',3.71),('6449','2013-06-20','07:45:00',4.03),('6449','2013-06-20','07:50:00',4.35),('6449','2013-06-20','07:55:00',4.67),('6449','2013-06-20','08:00:00',4.87),('6449','2013-06-20','08:05:00',5.27),('6449','2013-06-20','08:10:00',5.58),('6449','2013-06-20','08:15:00',5.93),('6449','2013-06-20','08:20:00',6.24),('6449','2013-06-20','08:25:00',6.57),('6449','2013-06-20','08:30:00',6.76),('6449','2013-06-20','08:35:00',7.21),('6449','2013-06-20','08:40:00',7.44),('6449','2013-06-20','08:45:00',7.74),('6449','2013-06-20','08:50:00',7.98),('6449','2013-06-20','08:55:00',8.37),('6449','2013-06-20','09:00:00',8.56),('6449','2013-06-20','09:05:00',8.91),('6449','2013-06-20','09:10:00',9.24),('6449','2013-06-20','09:15:00',9.34),('6449','2013-06-20','09:20:00',9.65),('6449','2013-06-20','09:25:00',9.97),('6449','2013-06-20','09:30:00',10.16),('6449','2013-06-20','09:35:00',10.36),('6449','2013-06-20','09:40:00',7.84),('6449','2013-06-20','09:45:00',10.7),('6449','2013-06-20','09:50:00',11.03),('6449','2013-06-20','09:55:00',11.02),('6449','2013-06-20','10:00:00',11.37),('6449','2013-06-20','10:05:00',11.42),('6449','2013-06-20','10:10:00',11.62),('6449','2013-06-20','10:15:00',11.84),('6449','2013-06-20','10:20:00',12.06),('6449','2013-06-20','10:25:00',11.98),('6449','2013-06-20','10:30:00',12.35),('6449','2013-06-20','10:35:00',12.79),('6449','2013-06-20','10:40:00',13.19),('6449','2013-06-20','10:45:00',13.41),('6449','2013-06-20','10:50:00',13.42),('6449','2013-06-20','10:55:00',13.46),('6449','2013-06-20','11:00:00',13.79),('6449','2013-06-20','11:05:00',13.88),('6449','2013-06-20','11:10:00',13.97),('6449','2013-06-20','11:15:00',13.91),('6449','2013-06-20','11:20:00',13.91),('6449','2013-06-20','11:25:00',14.06),('6449','2013-06-20','11:30:00',14.27),('6449','2013-06-20','11:35:00',14.34),('6449','2013-06-20','11:40:00',14.45),('6449','2013-06-20','11:45:00',14.5),('6449','2013-06-20','11:50:00',14.74),('6449','2013-06-20','11:55:00',14.81),('6449','2013-06-20','12:00:00',14.92),('6449','2013-06-20','12:05:00',15.02),('6449','2013-06-20','12:10:00',15.01),('6449','2013-06-20','12:15:00',14.73),('6449','2013-06-20','12:20:00',15.05),('6449','2013-06-20','12:25:00',15.2),('6449','2013-06-20','12:30:00',15.35),('6449','2013-06-20','12:35:00',15.37),('6449','2013-06-20','12:40:00',15.3),('6449','2013-06-20','12:45:00',15.17),('6449','2013-06-20','12:50:00',15.24),('6449','2013-06-20','12:55:00',15.14),('6449','2013-06-20','13:00:00',15.09),('6449','2013-06-20','13:05:00',15.14),('6449','2013-06-20','13:10:00',15.18),('6449','2013-06-20','13:15:00',15.21),('6449','2013-06-20','13:20:00',15.2),('6449','2013-06-20','13:25:00',15.15),('6449','2013-06-20','13:30:00',14.95),('6449','2013-06-20','13:35:00',14.94),('6449','2013-06-20','13:40:00',14.87),('6449','2013-06-20','13:45:00',14.85),('6449','2013-06-20','13:50:00',14.9),('6449','2013-06-20','13:55:00',14.89),('6449','2013-06-20','14:00:00',14.78),('6449','2013-06-20','14:05:00',14.9),('6449','2013-06-20','14:10:00',14.98),('6449','2013-06-20','14:15:00',14.89),('6449','2013-06-20','14:20:00',14.8),('6449','2013-06-20','14:25:00',14.79),('6449','2013-06-20','14:30:00',14.55),('6449','2013-06-20','14:35:00',14.66),('6449','2013-06-20','14:40:00',14.53),('6449','2013-06-20','14:45:00',14.32),('6449','2013-06-20','14:50:00',14.2),('6449','2013-06-20','14:55:00',14.05),('6449','2013-06-20','15:00:00',13.93),('6449','2013-06-20','15:05:00',13.74),('6449','2013-06-20','15:10:00',13.47),('6449','2013-06-20','15:15:00',13.19),('6449','2013-06-20','15:20:00',13.29),('6449','2013-06-20','15:25:00',12.93),('6449','2013-06-20','15:30:00',12.83),('6449','2013-06-20','15:35:00',12.78),('6449','2013-06-20','15:40:00',12.62),('6449','2013-06-20','15:45:00',12.23),('6449','2013-06-20','15:50:00',12.08),('6449','2013-06-20','15:55:00',11.89),('6449','2013-06-20','16:00:00',11.72),('6449','2013-06-20','16:05:00',11.61),('6449','2013-06-20','16:10:00',11.43),('6449','2013-06-20','16:15:00',10.99),('6449','2013-06-20','16:20:00',10.74),('6449','2013-06-20','16:25:00',10.66),('6449','2013-06-20','16:30:00',10.52),('6449','2013-06-20','16:35:00',10.22),('6449','2013-06-20','16:40:00',9.78),('6449','2013-06-20','16:45:00',9.53),('6449','2013-06-20','16:50:00',9.19),('6449','2013-06-20','16:55:00',8.94),('6449','2013-06-19','06:45:00',1.03),('6449','2013-06-19','06:50:00',1.2),('6449','2013-06-19','06:55:00',1.38),('6449','2013-06-19','07:00:00',1.59),('6449','2013-06-19','07:05:00',1.79),('6449','2013-06-19','07:10:00',1.76),('6449','2013-06-19','07:15:00',2.26),('6449','2013-06-19','07:20:00',2.5),('6449','2013-06-19','07:25:00',2.79),('6449','2013-06-19','07:30:00',3.08),('6449','2013-06-19','07:35:00',3.38),('6449','2013-06-19','07:40:00',3.66),('6449','2013-06-19','07:45:00',3.97),('6449','2013-06-19','07:50:00',4.26),('6449','2013-06-19','07:55:00',4.53),('6449','2013-06-19','08:00:00',4.81),('6449','2013-06-19','08:05:00',5.12),('6449','2013-06-19','08:10:00',5.41),('6449','2013-06-19','08:15:00',5.66),('6449','2013-06-19','08:20:00',6.02),('6449','2013-06-19','08:25:00',6.29),('6449','2013-06-19','08:30:00',6.46),('6449','2013-06-19','08:35:00',6.83),('6449','2013-06-19','08:40:00',7.14),('6449','2013-06-19','08:45:00',7.39),('6449','2013-06-19','08:50:00',7.72),('6449','2013-06-19','08:55:00',7.9),('6449','2013-06-19','09:00:00',8.04),('6449','2013-06-19','09:05:00',8.38),('6449','2013-06-19','09:10:00',8.6),('6449','2013-06-19','09:15:00',8.9),('6449','2013-06-19','09:20:00',9.22),('6449','2013-06-19','09:25:00',9.39),('6449','2013-06-19','09:30:00',9.63),('6449','2013-06-19','09:35:00',9.85),('6449','2013-06-19','09:40:00',10.05),('6449','2013-06-19','09:45:00',10.22),('6449','2013-06-19','09:50:00',10.54),('6449','2013-06-19','09:55:00',10.67),('6449','2013-06-19','10:00:00',11.04),('6449','2013-06-19','10:05:00',10.98),('6449','2013-06-19','10:10:00',11.36),('6449','2013-06-19','10:15:00',11.61),('6449','2013-06-19','10:20:00',12.04),('6449','2013-06-19','10:25:00',12.22),('6449','2013-06-19','10:30:00',12.33),('6449','2013-06-19','10:35:00',12.67),('6449','2013-06-19','10:40:00',12.83),('6449','2013-06-19','10:45:00',12.96),('6449','2013-06-19','10:50:00',13.24),('6449','2013-06-19','10:55:00',13.42),('6449','2013-06-19','11:00:00',13.53),('6449','2013-06-19','11:05:00',13.74),('6449','2013-06-19','11:10:00',13.86),('6449','2013-06-19','11:15:00',13.92),('6449','2013-06-19','11:20:00',14.08),('6449','2013-06-19','11:25:00',14.16),('6449','2013-06-19','11:30:00',14.39),('6449','2013-06-19','11:35:00',14.58),('6449','2013-06-19','11:40:00',14.58),('6449','2013-06-19','11:45:00',14.67),('6449','2013-06-19','11:50:00',14.5),('6449','2013-06-19','11:55:00',14.82),('6449','2013-06-19','12:00:00',14.83),('6449','2013-06-19','12:05:00',14.96),('6449','2013-06-19','12:10:00',15.01),('6449','2013-06-19','12:15:00',15.1),('6449','2013-06-19','12:20:00',15.1),('6449','2013-06-19','12:25:00',15.18),('6449','2013-06-19','12:30:00',15.31),('6449','2013-06-19','12:35:00',15.37),('6449','2013-06-19','12:40:00',15.46),('6449','2013-06-19','12:45:00',15.43),('6449','2013-06-19','12:50:00',15.41),('6449','2013-06-19','12:55:00',15.43),('6449','2013-06-19','13:00:00',15.51),('6449','2013-06-19','13:05:00',15.48),('6449','2013-06-19','13:10:00',15.58),('6449','2013-06-19','13:15:00',15.54),('6449','2013-06-19','13:20:00',15.54),('6449','2013-06-19','13:25:00',15.42),('6449','2013-06-19','13:30:00',15.37),('6449','2013-06-19','13:35:00',15.1),('6449','2013-06-19','13:40:00',15.37),('6449','2013-06-19','13:45:00',15.15),('6449','2013-06-19','13:50:00',15.36),('6449','2013-06-19','13:55:00',15.21),('6449','2013-06-19','14:00:00',15.09),('6449','2013-06-19','14:05:00',14.99),('6449','2013-06-19','14:10:00',14.93),('6449','2013-06-19','14:15:00',14.73),('6449','2013-06-19','14:20:00',14.85),('6449','2013-06-19','14:25:00',14.65),('6449','2013-06-19','14:30:00',14.45),('6449','2013-06-19','14:35:00',14.23),('6449','2013-06-19','14:40:00',14.03),('6449','2013-06-19','14:45:00',13.96),('6449','2013-06-19','14:50:00',13.74),('6449','2013-06-19','14:55:00',13.56),('6449','2013-06-19','15:00:00',13.51),('6449','2013-06-19','15:05:00',13.4),('6449','2013-06-19','15:10:00',13.2),('6449','2013-06-19','15:15:00',13.06),('6449','2013-06-19','15:20:00',12.77),('6449','2013-06-19','15:25:00',12.83),('6449','2013-06-19','15:30:00',10.92),('6449','2013-06-19','15:35:00',12.44),('6449','2013-06-19','15:40:00',12.28),('6449','2013-06-19','15:45:00',12.09),('6449','2013-06-19','15:50:00',11.97),('6449','2013-06-19','15:55:00',11.71),('6449','2013-06-19','16:00:00',11.39),('6449','2013-06-19','16:05:00',11.39),('6449','2013-06-19','16:10:00',11.02),('6449','2013-06-19','16:15:00',10.68),('6449','2013-06-19','16:20:00',10.62),('6449','2013-06-19','16:25:00',10.45),('6449','2013-06-19','16:30:00',10.19),('6449','2013-06-19','16:35:00',9.94),('6449','2013-06-19','16:40:00',9.57),('6449','2013-06-19','16:45:00',9.5),('6449','2013-06-19','16:50:00',9.21),('6449','2013-06-19','16:55:00',8.83),('6449','2013-06-19','17:00:00',8.55),('6449','2013-06-19','17:05:00',8.29),('6449','2013-06-19','17:10:00',8.06),('6449','2013-06-19','17:15:00',7.69),('6449','2013-06-19','17:20:00',7.47),('6449','2013-06-19','17:25:00',7.13),('6449','2013-06-19','17:30:00',6.79),('6449','2013-06-19','17:35:00',6.41),('6449','2013-06-19','17:40:00',6.17),('6449','2013-06-19','17:45:00',5.73),('6449','2013-06-19','17:50:00',5.51),('6449','2013-06-19','17:55:00',5.06),('6449','2013-06-19','18:00:00',4.82),('6449','2013-06-19','18:05:00',4.44),('6449','2013-06-19','18:10:00',4.19),('6449','2013-06-19','18:15:00',3.86),('6449','2013-06-19','18:20:00',3.58),('6449','2013-06-19','18:25:00',3.32),('6449','2013-06-19','18:30:00',3.02),('6449','2013-06-19','18:35:00',2.71),('6449','2013-06-19','18:40:00',2.44),('6449','2013-06-19','18:45:00',2.21),('6449','2013-06-19','18:50:00',1.94),('6449','2013-06-19','18:55:00',1.73),('6449','2013-06-19','19:00:00',1.51),('6449','2013-06-19','19:05:00',1.33),('6449','2013-06-19','19:10:00',1.15),('6449','2013-06-18','06:45:00',1.07),('6449','2013-06-18','06:50:00',1.24),('6449','2013-06-18','06:55:00',1.41),('6449','2013-06-18','07:00:00',1.59),('6449','2013-06-18','07:05:00',1.78),('6449','2013-06-18','07:10:00',2.04),('6449','2013-06-18','07:15:00',2.27),('6449','2013-06-18','07:20:00',2.5),('6449','2013-06-18','07:25:00',2.81),('6449','2013-06-18','07:30:00',3.1),('6449','2013-06-18','07:35:00',3.38),('6449','2013-06-18','07:40:00',3.71),('6449','2013-06-18','07:45:00',4),('6449','2013-06-18','07:50:00',4.28),('6449','2013-06-18','07:55:00',4.63),('6449','2013-06-18','08:00:00',4.92),('6449','2013-06-18','08:05:00',5.22),('6449','2013-06-18','08:10:00',5.55),('6449','2013-06-18','08:15:00',5.82),('6449','2013-06-18','08:20:00',6.06),('6449','2013-06-18','08:25:00',5.68),('6449','2013-06-18','08:30:00',6.69),('6449','2013-06-18','08:35:00',7.07),('6449','2013-06-18','08:40:00',7.37),('6449','2013-06-18','08:45:00',7.59),('6449','2013-06-18','08:50:00',7.82),('6449','2013-06-18','08:55:00',8.11),('6449','2013-06-18','09:00:00',8.37),('6449','2013-06-18','09:05:00',8.68),('6449','2013-06-18','09:10:00',8.83),('6449','2013-06-18','09:15:00',9.29),('6449','2013-06-18','09:20:00',9.45),('6449','2013-06-18','09:25:00',9.75),('6449','2013-06-18','09:30:00',10.01),('6449','2013-06-18','09:35:00',10.14),('6449','2013-06-18','09:40:00',10.35),('6449','2013-06-18','09:45:00',10.69),('6449','2013-06-18','09:50:00',10.9),('6449','2013-06-18','09:55:00',11.01),('6449','2013-06-18','10:00:00',11.45),('6449','2013-06-18','10:05:00',11.32),('6449','2013-06-18','10:10:00',11.68),('6449','2013-06-18','10:15:00',11.89),('6449','2013-06-18','10:20:00',12.06),('6449','2013-06-18','10:25:00',12.21),('6449','2013-06-18','10:30:00',12.33),('6449','2013-06-18','10:35:00',12.49),('6449','2013-06-18','10:40:00',12.38),('6449','2013-06-18','10:45:00',12.59),('6449','2013-06-18','10:50:00',10.99),('6449','2013-06-18','10:55:00',12.67),('6449','2013-06-18','11:00:00',11.24),('6449','2013-06-18','11:05:00',12.84),('6449','2013-06-18','11:10:00',13.14),('6449','2013-06-18','11:15:00',13.15),('6449','2013-06-18','11:20:00',13.27),('6449','2013-06-18','11:25:00',13.38),('6449','2013-06-18','11:30:00',13.38),('6449','2013-06-18','11:35:00',14.04),('6449','2013-06-18','11:40:00',14.25),('6449','2013-06-18','11:45:00',14.27),('6449','2013-06-18','11:50:00',14.17),('6449','2013-06-18','11:55:00',14.29),('6449','2013-06-18','12:00:00',14.42),('6449','2013-06-18','12:05:00',14.48),('6449','2013-06-18','12:10:00',14.51),('6449','2013-06-18','12:15:00',14.63),('6449','2013-06-18','12:20:00',14.65),('6449','2013-06-18','12:25:00',14.6),('6449','2013-06-18','12:30:00',14.63),('6449','2013-06-18','12:35:00',14.6),('6449','2013-06-18','12:40:00',14.66),('6449','2013-06-18','12:45:00',14.67),('6449','2013-06-18','12:50:00',14.58),('6449','2013-06-18','12:55:00',14.83),('6449','2013-06-18','13:00:00',14.88),('6449','2013-06-18','13:05:00',14.87),('6449','2013-06-18','13:10:00',14.9),('6449','2013-06-18','13:15:00',14.66),('6449','2013-06-18','13:20:00',14.88),('6449','2013-06-18','13:25:00',14.98),('6449','2013-06-18','13:30:00',15.03),('6449','2013-06-18','13:35:00',15.01),('6449','2013-06-18','13:40:00',15.08),('6449','2013-06-18','13:45:00',15.01),('6449','2013-06-18','13:50:00',14.99),('6449','2013-06-18','13:55:00',14.93),('6449','2013-06-18','14:00:00',14.83),('6449','2013-06-18','14:05:00',14.67),('6449','2013-06-18','14:10:00',14.64),('6449','2013-06-18','14:15:00',14.6),('6449','2013-06-18','14:20:00',14.62),('6449','2013-06-18','14:25:00',14.6),('6449','2013-06-18','14:30:00',14.53),('6449','2013-06-18','14:35:00',14.4),('6449','2013-06-18','14:40:00',14.53),('6449','2013-06-18','14:45:00',12.29),('6449','2013-06-18','14:50:00',12.88),('6449','2013-06-18','14:55:00',14.39),('6449','2013-06-18','15:00:00',14.44),('6449','2013-06-18','15:05:00',14.42),('6449','2013-06-18','15:10:00',14.36),('6449','2013-06-18','15:15:00',14.25),('6449','2013-06-18','15:20:00',13.88),('6449','2013-06-18','15:25:00',13.82),('6449','2013-06-18','15:30:00',13.53),('6449','2013-06-18','15:35:00',13.16),('6449','2013-06-18','15:40:00',12.99),('6449','2013-06-18','15:45:00',12.65),('6449','2013-06-18','15:50:00',12.39),('6449','2013-06-18','15:55:00',12.07),('6449','2013-06-18','16:00:00',11.7),('6449','2013-06-18','16:05:00',11.53),('6449','2013-06-18','16:10:00',11.3),('6449','2013-06-18','16:15:00',11.09),('6449','2013-06-18','16:20:00',10.74),('6449','2013-06-18','16:25:00',10.55),('6449','2013-06-18','16:30:00',10.31),('6449','2013-06-18','16:35:00',10.08),('6449','2013-06-18','16:40:00',9.77),('6449','2013-06-18','16:45:00',9.64),('6449','2013-06-18','16:50:00',9.35),('6449','2013-06-18','16:55:00',9.14),('6449','2013-06-18','17:00:00',8.82),('6449','2013-06-18','17:05:00',8.46),('6449','2013-06-18','17:10:00',8.28),('6449','2013-06-18','17:15:00',7.84),('6449','2013-06-18','17:20:00',7.44),('6449','2013-06-18','17:25:00',7.1),('6449','2013-06-18','17:30:00',6.77),('6449','2013-06-18','17:35:00',5.58),('6449','2013-06-18','17:40:00',6.22),('6449','2013-06-18','17:45:00',3.72),('6449','2013-06-18','17:50:00',4.37),('6449','2013-06-18','17:55:00',3.9),('6449','2013-06-18','18:00:00',4.77),('6449','2013-06-18','18:05:00',4.5),('6449','2013-06-18','18:10:00',4.18),('6449','2013-06-18','18:15:00',3.91),('6449','2013-06-18','18:20:00',3.61),('6449','2013-06-18','18:25:00',3.3),('6449','2013-06-18','18:30:00',3.02),('6449','2013-06-18','18:35:00',2.76),('6449','2013-06-18','18:40:00',2.47),('6449','2013-06-18','18:45:00',2.23),('6449','2013-06-18','18:50:00',1.98),('6449','2013-06-18','18:55:00',1.7),('6449','2013-06-18','19:00:00',1.53),('6449','2013-06-18','19:05:00',1.33),('6449','2013-06-18','19:10:00',1.15),('6449','2013-06-17','06:45:00',1.12),('6449','2013-06-17','06:50:00',1.32),('6449','2013-06-17','06:55:00',1.49),('6449','2013-06-17','07:00:00',1.71),('6449','2013-06-17','07:05:00',1.93),('6449','2013-06-17','07:10:00',2.16),('6449','2013-06-17','07:15:00',2.43),('6449','2013-06-17','07:20:00',2.7),('6449','2013-06-17','07:25:00',2.96),('6449','2013-06-17','07:30:00',3.26),('6449','2013-06-17','07:35:00',2.22),('6449','2013-06-17','07:40:00',3.86),('6449','2013-06-17','07:45:00',4.24),('6449','2013-06-17','07:50:00',4.48),('6449','2013-06-17','07:55:00',4.82),('6449','2013-06-17','08:00:00',5.17),('6449','2013-06-17','08:05:00',5.43),('6449','2013-06-17','08:10:00',5.77),('6449','2013-06-17','08:15:00',6.08),('6449','2013-06-17','08:20:00',6.35),('6449','2013-06-17','08:25:00',6.67),('6449','2013-06-17','08:30:00',6.88),('6449','2013-06-17','08:35:00',7.25),('6449','2013-06-17','08:40:00',7.6),('6449','2013-06-17','08:45:00',7.86),('6449','2013-06-17','08:50:00',8.21),('6449','2013-06-17','08:55:00',8.43),('6449','2013-06-17','09:00:00',8.69),('6449','2013-06-17','09:05:00',8.97),('6449','2013-06-17','09:10:00',9.32),('6449','2013-06-17','09:15:00',9.47),('6449','2013-06-17','09:20:00',9.78),('6449','2013-06-17','09:25:00',9.93),('6449','2013-06-17','09:30:00',10.27),('6449','2013-06-17','09:35:00',10.5),('6449','2013-06-17','09:40:00',10.61),('6449','2013-06-17','09:45:00',10.84),('6449','2013-06-17','09:50:00',10.96),('6449','2013-06-17','09:55:00',11.17),('6449','2013-06-17','10:00:00',11.42),('6449','2013-06-17','10:05:00',11.63),('6449','2013-06-17','10:10:00',12.02),('6449','2013-06-17','10:15:00',12.31),('6449','2013-06-17','10:20:00',12.31),('6449','2013-06-17','10:25:00',12.59),('6449','2013-06-17','10:30:00',12.9),('6449','2013-06-17','10:35:00',13.02),('6449','2013-06-17','10:40:00',13.13),('6449','2013-06-17','10:45:00',13.31),('6449','2013-06-17','10:50:00',13.42),('6449','2013-06-17','10:55:00',13.64),('6449','2013-06-17','11:00:00',13.74),('6449','2013-06-17','11:05:00',13.79),('6449','2013-06-17','11:10:00',14.01),('6449','2013-06-17','11:15:00',14.15),('6449','2013-06-17','11:20:00',14.25),('6449','2013-06-17','11:25:00',14.38),('6449','2013-06-17','11:30:00',14.45),('6449','2013-06-17','11:35:00',14.48),('6449','2013-06-17','11:40:00',14.7),('6449','2013-06-17','11:45:00',14.82),('6449','2013-06-17','11:50:00',14.93),('6449','2013-06-17','11:55:00',15),('6449','2013-06-17','12:00:00',15.06),('6449','2013-06-17','12:05:00',14.99),('6449','2013-06-17','12:10:00',14.9),('6449','2013-06-17','12:15:00',15.1),('6449','2013-06-17','12:20:00',15.18),('6449','2013-06-17','12:25:00',15.17),('6449','2013-06-17','12:30:00',15.15),('6449','2013-06-17','12:35:00',15.23),('6449','2013-06-17','12:40:00',15.29),('6449','2013-06-17','12:45:00',15.24),('6449','2013-06-17','12:50:00',15.14),('6449','2013-06-17','12:55:00',15.3),('6449','2013-06-17','13:00:00',15.29),('6449','2013-06-17','13:05:00',15.32),('6449','2013-06-17','13:10:00',15.26),('6449','2013-06-17','13:15:00',15.25),('6449','2013-06-17','13:20:00',15.25),('6449','2013-06-17','13:25:00',15.24),('6449','2013-06-17','13:30:00',15.23),('6449','2013-06-17','13:35:00',15.21),('6449','2013-06-17','13:40:00',15.16),('6449','2013-06-17','13:45:00',15.07),('6449','2013-06-17','13:50:00',14.95),('6449','2013-06-17','13:55:00',14.74),('6449','2013-06-17','14:00:00',14.89),('6449','2013-06-17','14:05:00',14.82),('6449','2013-06-17','14:10:00',14.77),('6449','2013-06-17','14:15:00',14.77),('6449','2013-06-17','14:20:00',14.63),('6449','2013-06-17','14:25:00',14.5),('6449','2013-06-17','14:30:00',14.4),('6449','2013-06-17','14:35:00',14.21),('6449','2013-06-17','14:40:00',14.1),('6449','2013-06-17','14:45:00',13.95),('6449','2013-06-17','14:50:00',13.77),('6449','2013-06-17','14:55:00',13.62),('6449','2013-06-17','15:00:00',13.53),('6449','2013-06-17','15:05:00',13.36),('6449','2013-06-17','15:10:00',13.3),('6449','2013-06-17','15:15:00',13.12),('6449','2013-06-17','15:20:00',12.97),('6449','2013-06-17','15:25:00',12.77),('6449','2013-06-17','15:30:00',12.69),('6449','2013-06-17','15:35:00',12.45),('6449','2013-06-17','15:40:00',12.25),('6449','2013-06-17','15:45:00',12.01),('6449','2013-06-17','15:50:00',11.93),('6449','2013-06-17','15:55:00',11.75),('6449','2013-06-17','16:00:00',11.53),('6449','2013-06-17','16:05:00',11.34),('6449','2013-06-17','16:10:00',11.07),('6449','2013-06-17','16:15:00',10.94),('6449','2013-06-17','16:20:00',10.65),('6449','2013-06-17','16:25:00',10.26),('6449','2013-06-17','16:30:00',10.16),('6449','2013-06-17','16:35:00',9.9),('6449','2013-06-17','16:40:00',9.58),('6449','2013-06-17','16:45:00',9.39),('6449','2013-06-17','16:50:00',9.13),('6449','2013-06-17','16:55:00',8.92),('6449','2013-06-17','17:00:00',8.57),('6449','2013-06-17','17:05:00',8.39),('6449','2013-06-17','17:10:00',8.01),('6449','2013-06-17','17:15:00',7.73),('6449','2013-06-17','17:20:00',7.49),('6449','2013-06-17','17:25:00',7.05),('6449','2013-06-17','17:30:00',6.78),('6449','2013-06-17','17:35:00',6.6),('6449','2013-06-17','17:40:00',6.31),('6449','2013-06-17','17:45:00',5.96),('6449','2013-06-17','17:50:00',5.68),('6449','2013-06-17','17:55:00',5.33),('6449','2013-06-17','18:00:00',4.96),('6449','2013-06-17','18:05:00',4.63),('6449','2013-06-17','18:10:00',4.31),('6449','2013-06-17','18:15:00',4.05),('6449','2013-06-17','18:20:00',3.73),('6449','2013-06-17','18:25:00',3.45),('6449','2013-06-17','18:30:00',3.12),('6449','2013-06-17','18:35:00',2.83),('6449','2013-06-17','18:40:00',2.53),('6449','2013-06-17','18:45:00',2.26),('6449','2013-06-17','18:50:00',2.02),('6449','2013-06-17','18:55:00',1.78),('6449','2013-06-17','19:00:00',1.59),('6449','2013-06-17','19:05:00',1.38),('6449','2013-06-17','19:10:00',1.19),('6449','2013-06-17','19:15:00',1.05),('6449','2013-06-16','06:45:00',1.09),('6449','2013-06-16','06:50:00',1.32),('6449','2013-06-16','06:55:00',1.51),('6449','2013-06-16','07:00:00',1.71),('6449','2013-06-16','07:05:00',1.94),('6449','2013-06-16','07:10:00',2.23),('6449','2013-06-16','07:15:00',2.49),('6449','2013-06-16','07:20:00',2.76),('6449','2013-06-16','07:25:00',3.06),('6449','2013-06-16','07:30:00',3.33),('6449','2013-06-16','07:35:00',3.66),('6449','2013-06-16','07:40:00',3.98),('6449','2013-06-16','07:45:00',4.29),('6449','2013-06-16','07:50:00',4.66),('6449','2013-06-16','07:55:00',4.97),('6449','2013-06-16','08:00:00',5.25),('6449','2013-06-16','08:05:00',5.59),('6449','2013-06-16','08:10:00',5.94),('6449','2013-06-16','08:15:00',6.16),('6449','2013-06-16','08:20:00',6.48),('6449','2013-06-16','08:25:00',6.71),('6449','2013-06-16','08:30:00',6.99),('6449','2013-06-16','08:35:00',7.15),('6449','2013-06-16','08:40:00',7.73),('6449','2013-06-16','08:45:00',7.93),('6449','2013-06-16','08:50:00',8.38),('6449','2013-06-16','08:55:00',7.47),('6449','2013-06-16','09:00:00',8.66),('6449','2013-06-16','09:05:00',9.15),('6449','2013-06-16','09:10:00',9.11),('6449','2013-06-16','09:15:00',9.44),('6449','2013-06-16','09:20:00',9.89),('6449','2013-06-16','09:25:00',9.97),('6449','2013-06-16','09:30:00',10.08),('6449','2013-06-16','09:35:00',10.36),('6449','2013-06-16','09:40:00',10.62),('6449','2013-06-16','09:45:00',10.87),('6449','2013-06-16','09:50:00',11.02),('6449','2013-06-16','09:55:00',11.31),('6449','2013-06-16','10:00:00',11.5),('6449','2013-06-16','10:05:00',11.72),('6449','2013-06-16','10:10:00',12.04),('6449','2013-06-16','10:15:00',12.04),('6449','2013-06-16','10:20:00',12.62),('6449','2013-06-16','10:25:00',12.84),('6449','2013-06-16','10:30:00',13.06),('6449','2013-06-16','10:35:00',13.16),('6449','2013-06-16','10:40:00',13.48),('6449','2013-06-16','10:45:00',13.48),('6449','2013-06-16','10:50:00',13.77),('6449','2013-06-16','10:55:00',13.94),('6449','2013-06-16','11:00:00',14.15),('6449','2013-06-16','11:05:00',14.22),('6449','2013-06-16','11:10:00',14.28),('6449','2013-06-16','11:15:00',14.41),('6449','2013-06-16','11:20:00',14.56),('6449','2013-06-16','11:25:00',14.67),('6449','2013-06-16','11:30:00',14.87),('6449','2013-06-16','11:35:00',15.02),('6449','2013-06-16','11:40:00',15.07),('6449','2013-06-16','11:45:00',15.19),('6449','2013-06-16','11:50:00',15.29),('6449','2013-06-16','11:55:00',15.45),('6449','2013-06-16','12:00:00',15.42),('6449','2013-06-16','12:05:00',15.41),('6449','2013-06-16','12:10:00',15.7),('6449','2013-06-16','12:15:00',15.66),('6449','2013-06-16','12:20:00',15.63),('6449','2013-06-16','12:25:00',15.67),('6449','2013-06-16','12:30:00',15.76),('6449','2013-06-16','12:35:00',15.73),('6449','2013-06-16','12:40:00',15.76),('6449','2013-06-16','12:45:00',15.8),('6449','2013-06-16','12:50:00',15.7),('6449','2013-06-16','12:55:00',15.68),('6449','2013-06-16','13:00:00',15.78),('6449','2013-06-16','13:05:00',15.74),('6449','2013-06-16','13:10:00',15.85),('6449','2013-06-16','13:15:00',15.76),('6449','2013-06-16','13:20:00',15.75),('6449','2013-06-16','13:25:00',15.71),('6449','2013-06-16','13:30:00',15.65),('6449','2013-06-16','13:35:00',15.52),('6449','2013-06-16','13:40:00',15.48),('6449','2013-06-16','13:45:00',15.36),('6449','2013-06-16','13:50:00',15.31),('6449','2013-06-16','13:55:00',15.44),('6449','2013-06-16','14:00:00',15.37),('6449','2013-06-16','14:05:00',15.26),('6449','2013-06-16','14:10:00',15.15),('6449','2013-06-16','14:15:00',15.06),('6449','2013-06-16','14:20:00',14.84),('6449','2013-06-16','14:25:00',14.96),('6449','2013-06-16','14:30:00',14.77),('6449','2013-06-16','14:35:00',12.81),('6449','2013-06-16','14:40:00',12.68),('6449','2013-06-16','14:45:00',14.28),('6449','2013-06-16','14:50:00',14.25),('6449','2013-06-16','14:55:00',14.02),('6449','2013-06-16','15:00:00',13.94),('6449','2013-06-16','15:05:00',13.84),('6449','2013-06-16','15:10:00',13.55),('6449','2013-06-16','15:15:00',13.61),('6449','2013-06-16','15:20:00',13.42),('6449','2013-06-16','15:25:00',13.2),('6449','2013-06-16','15:30:00',13.06),('6449','2013-06-16','15:35:00',12.91),('6449','2013-06-16','15:40:00',12.61),('6449','2013-06-16','15:45:00',12.53),('6449','2013-06-16','15:50:00',12.1),('6449','2013-06-16','15:55:00',11.98),('6449','2013-06-16','16:00:00',11.77),('6449','2013-06-16','16:05:00',11.54),('6449','2013-06-16','16:10:00',11.19),('6449','2013-06-16','16:15:00',10.99),('6449','2013-06-16','16:20:00',10.71),('6449','2013-06-16','16:25:00',10.37),('6449','2013-06-16','16:30:00',10.16),('6449','2013-06-16','16:35:00',9.92),('6449','2013-06-16','16:40:00',9.74),('6449','2013-06-16','16:45:00',9.31),('6449','2013-06-16','16:50:00',9.01),('6449','2013-06-16','16:55:00',8.62),('6449','2013-06-16','17:00:00',8.46),('6449','2013-06-16','17:05:00',7.25),('6449','2013-06-16','17:10:00',6.98),('6449','2013-06-16','17:15:00',6.92),('6449','2013-06-16','17:20:00',6.98),('6449','2013-06-16','17:25:00',7.09),('6449','2013-06-16','17:30:00',6.72),('6449','2013-06-16','17:35:00',4.82),('6449','2013-06-16','17:40:00',4.61),('6449','2013-06-16','17:45:00',5.78),('6449','2013-06-16','17:50:00',5.39),('6449','2013-06-16','17:55:00',5.09),('6449','2013-06-16','18:00:00',4.79),('6449','2013-06-16','18:05:00',4.45),('6449','2013-06-16','18:10:00',4.17),('6449','2013-06-16','18:15:00',3.89),('6449','2013-06-16','18:20:00',3.57),('6449','2013-06-16','18:25:00',3.27),('6449','2013-06-16','18:30:00',2.97),('6449','2013-06-16','18:35:00',2.7),('6449','2013-06-16','18:40:00',2.41),('6449','2013-06-16','18:45:00',2.15),('6449','2013-06-16','18:50:00',1.92),('6449','2013-06-16','18:55:00',1.7),('6449','2013-06-16','19:00:00',1.49),('6449','2013-06-16','19:05:00',1.3),('6449','2013-06-16','19:10:00',1.12),('6449','2013-06-15','06:50:00',1.08),('6449','2013-06-15','06:55:00',1.29),('6449','2013-06-15','07:00:00',1.16),('6449','2013-06-15','07:05:00',1.13),('6449','2013-06-15','07:10:00',1.75),('6449','2013-06-15','07:15:00',1.72),('6449','2013-06-15','07:20:00',1.64),('6449','2013-06-15','07:25:00',1.7),('6449','2013-06-15','07:30:00',1.33),('6449','2013-06-15','07:35:00',1.52),('6449','2013-06-15','07:40:00',2.26),('6449','2013-06-15','07:45:00',2.85),('6449','2013-06-15','07:50:00',3.7),('6449','2013-06-15','07:55:00',5),('6449','2013-06-15','08:00:00',4.15),('6449','2013-06-15','08:05:00',4.08),('6449','2013-06-15','08:10:00',3.76),('6449','2013-06-15','08:15:00',3.36),('6449','2013-06-15','08:20:00',3.91),('6449','2013-06-15','08:25:00',3.64),('6449','2013-06-15','08:30:00',3.81),('6449','2013-06-15','08:35:00',4.22),('6449','2013-06-15','08:40:00',5.52),('6449','2013-06-15','08:45:00',8.75),('6449','2013-06-15','08:50:00',7.59),('6449','2013-06-15','08:55:00',6.59),('6449','2013-06-15','09:00:00',4.7),('6449','2013-06-15','09:05:00',6.77),('6449','2013-06-15','09:10:00',9.7),('6449','2013-06-15','09:15:00',7.75),('6449','2013-06-15','09:20:00',4.41),('6449','2013-06-15','09:25:00',3.41),('6449','2013-06-15','09:30:00',3.58),('6449','2013-06-15','09:35:00',4.25),('6449','2013-06-15','09:40:00',4.3),('6449','2013-06-15','09:45:00',4.19),('6449','2013-06-15','09:50:00',4.21),('6449','2013-06-15','09:55:00',4.74),('6449','2013-06-15','10:00:00',5.47),('6449','2013-06-15','10:05:00',13.13),('6449','2013-06-15','10:10:00',12.74),('6449','2013-06-15','10:15:00',11.69),('6449','2013-06-15','10:20:00',11.19),('6449','2013-06-15','10:25:00',12.74),('6449','2013-06-15','10:30:00',12.19),('6449','2013-06-15','10:35:00',13.6),('6449','2013-06-15','10:40:00',13.62),('6449','2013-06-15','10:45:00',13.79),('6449','2013-06-15','10:50:00',13.86),('6449','2013-06-15','10:55:00',14.2),('6449','2013-06-15','11:00:00',14.11),('6449','2013-06-15','11:05:00',14.51),('6449','2013-06-15','11:10:00',14.53),('6449','2013-06-15','11:15:00',13.86),('6449','2013-06-15','11:20:00',14.72),('6449','2013-06-15','11:25:00',15.08),('6449','2013-06-15','11:30:00',14.86),('6449','2013-06-15','11:35:00',13.34),('6449','2013-06-15','11:40:00',13.44),('6449','2013-06-15','11:45:00',14.55),('6449','2013-06-15','11:50:00',15.35),('6449','2013-06-15','11:55:00',15.36),('6449','2013-06-15','12:00:00',15.32),('6449','2013-06-15','12:05:00',15.59),('6449','2013-06-15','12:10:00',14.56),('6449','2013-06-15','12:15:00',13.88),('6449','2013-06-15','12:20:00',16.11),('6449','2013-06-15','12:25:00',14.57),('6449','2013-06-15','12:30:00',15.02),('6449','2013-06-15','12:35:00',15.78),('6449','2013-06-15','12:40:00',15.74),('6449','2013-06-15','12:45:00',15.75),('6449','2013-06-15','12:50:00',15.87),('6449','2013-06-15','12:55:00',15.75),('6449','2013-06-15','13:00:00',15.92),('6449','2013-06-15','13:05:00',15.77),('6449','2013-06-15','13:10:00',13.88),('6449','2013-06-15','13:15:00',14.88),('6449','2013-06-15','13:20:00',13.15),('6449','2013-06-15','13:25:00',15.49),('6449','2013-06-15','13:30:00',15.63),('6449','2013-06-15','13:35:00',15.69),('6449','2013-06-15','13:40:00',14.65),('6449','2013-06-15','13:45:00',13.88),('6449','2013-06-15','13:50:00',8.99),('6449','2013-06-15','13:55:00',9.43),('6449','2013-06-15','14:00:00',10.01),('6449','2013-06-15','14:05:00',15.5),('6449','2013-06-15','14:10:00',12.22),('6449','2013-06-15','14:15:00',13.52),('6449','2013-06-15','14:20:00',9.99),('6449','2013-06-15','14:25:00',11.75),('6449','2013-06-15','14:30:00',14.02),('6449','2013-06-15','14:35:00',14.95),('6449','2013-06-15','14:40:00',13.19),('6449','2013-06-15','14:45:00',11.6),('6449','2013-06-15','14:50:00',13.57),('6449','2013-06-15','14:55:00',14.13),('6449','2013-06-15','15:00:00',14),('6449','2013-06-15','15:05:00',13.68),('6449','2013-06-15','15:10:00',13.48),('6449','2013-06-15','15:15:00',13.38),('6449','2013-06-15','15:20:00',13.08),('6449','2013-06-15','15:25:00',12.94),('6449','2013-06-15','15:30:00',12.83),('6449','2013-06-15','15:35:00',12.68),('6449','2013-06-15','15:40:00',12.57),('6449','2013-06-15','15:45:00',12.21),('6449','2013-06-15','15:50:00',12.11),('6449','2013-06-15','15:55:00',11.6),('6449','2013-06-15','16:00:00',11.58),('6449','2013-06-15','16:05:00',11.34),('6449','2013-06-15','16:10:00',11.17),('6449','2013-06-15','16:15:00',10.94),('6449','2013-06-15','16:20:00',10.7),('6449','2013-06-15','16:25:00',10.34),('6449','2013-06-15','16:30:00',10.01),('6449','2013-06-15','16:35:00',9.11),('6449','2013-06-15','16:40:00',8.86),('6449','2013-06-15','16:45:00',9.25),('6449','2013-06-15','16:50:00',8.98),('6449','2013-06-15','16:55:00',8.72),('6449','2013-06-15','17:00:00',8.33),('6449','2013-06-15','17:05:00',8.14),('6449','2013-06-15','17:10:00',7.83),('6449','2013-06-15','17:15:00',7.6),('6449','2013-06-15','17:20:00',7.24),('6449','2013-06-15','17:25:00',6.99),('6449','2013-06-15','17:30:00',6.65),('6449','2013-06-15','17:35:00',6.44),('6449','2013-06-15','17:40:00',6.03),('6449','2013-06-15','17:45:00',5.71),('6449','2013-06-15','17:50:00',5.4),('6449','2013-06-15','17:55:00',5.04),('6449','2013-06-15','18:00:00',4.77),('6449','2013-06-15','18:05:00',4.46),('6449','2013-06-15','18:10:00',4.12),('6449','2013-06-15','18:15:00',3.83),('6449','2013-06-15','18:20:00',3.54),('6449','2013-06-15','18:25:00',3.24),('6449','2013-06-15','18:30:00',2.96),('6449','2013-06-15','18:35:00',2.7),('6449','2013-06-15','18:40:00',2.44),('6449','2013-06-15','18:45:00',2.19),('6449','2013-06-15','18:50:00',1.97),('6449','2013-06-15','18:55:00',1.73),('6449','2013-06-15','19:00:00',1.52),('6449','2013-06-15','19:05:00',1.33),('6449','2013-06-15','19:10:00',1.15),('6449','2013-06-14','06:50:00',1.2),('6449','2013-06-14','06:59:00',1.44),('6449','2013-06-14','07:00:00',1.84),('6449','2013-06-14','07:10:00',1.93),('6449','2013-06-14','07:15:00',2.56),('6449','2013-06-14','07:20:00',2.53),('6449','2013-06-14','07:29:00',2.89),('6449','2013-06-14','07:30:00',3.73),('6449','2013-06-14','07:39:00',3.81),('6449','2013-06-14','07:40:00',4.49),('6449','2013-06-14','07:49:00',4.45),('6449','2013-06-14','07:50:00',5.14),('6449','2013-06-14','07:59:00',5.36),('6449','2013-06-14','08:00:00',5.83),('6449','2013-06-14','08:09:00',6),('6449','2013-06-14','08:10:00',6.48),('6449','2013-06-14','08:19:00',6.59),('6449','2013-06-14','08:20:00',7.16),('6449','2013-06-14','08:29:00',7.36),('6449','2013-06-14','08:30:00',7.99),('6449','2013-06-14','08:39:00',8.08),('6449','2013-06-14','08:40:00',8.69),('6449','2013-06-14','08:49:00',8.72),('6449','2013-06-14','08:50:00',9.03),('6449','2013-06-14','08:55:00',9.15),('6449','2013-06-14','09:00:00',9.36),('6449','2013-06-14','09:05:00',9.69),('6449','2013-06-14','09:10:00',10.14),('6449','2013-06-14','09:15:00',10.21),('6449','2013-06-14','09:20:00',10.35),('6449','2013-06-14','09:25:00',10.52),('6449','2013-06-14','09:30:00',10.6),('6449','2013-06-14','09:35:00',10.89),('6449','2013-06-14','09:40:00',10.96),('6449','2013-06-14','09:45:00',11.31),('6449','2013-06-14','09:50:00',11.89),('6449','2013-06-14','09:55:00',12.07),('6449','2013-06-14','10:00:00',12.02),('6449','2013-06-14','10:05:00',12.22),('6449','2013-06-14','10:10:00',12.28),('6449','2013-06-14','10:15:00',12.57),('6449','2013-06-14','10:20:00',12.86),('6449','2013-06-14','10:25:00',12.84),('6449','2013-06-14','10:30:00',13.48),('6449','2013-06-14','10:35:00',12.67),('6449','2013-06-14','10:40:00',13.97),('6449','2013-06-14','10:45:00',13.65),('6449','2013-06-14','10:50:00',13.55),('6449','2013-06-14','10:55:00',13.99),('6449','2013-06-14','11:00:00',14.75),('6449','2013-06-14','11:05:00',15.09),('6449','2013-06-14','11:10:00',15.16),('6449','2013-06-14','11:15:00',14.88),('6449','2013-06-14','11:20:00',14.55),('6449','2013-06-14','11:25:00',14.89),('6449','2013-06-14','11:30:00',15.55),('6449','2013-06-14','11:35:00',15.53),('6449','2013-06-14','11:40:00',15.56),('6449','2013-06-14','11:45:00',15.51),('6449','2013-06-14','11:50:00',15.53),('6449','2013-06-14','11:55:00',15.62),('6449','2013-06-14','12:00:00',15.87),('6449','2013-06-14','12:05:00',16),('6449','2013-06-14','12:10:00',16.09),('6449','2013-06-14','12:15:00',16.04),('6449','2013-06-14','12:20:00',16.08),('6449','2013-06-14','12:25:00',16.24),('6449','2013-06-14','12:30:00',16.04),('6449','2013-06-14','12:35:00',16.21),('6449','2013-06-14','12:40:00',16.23),('6449','2013-06-14','12:45:00',16.26),('6449','2013-06-14','12:50:00',16.29),('6449','2013-06-14','12:55:00',16.39),('6449','2013-06-14','13:00:00',16.34),('6449','2013-06-14','13:05:00',16.38),('6449','2013-06-14','13:10:00',16.5),('6449','2013-06-14','13:15:00',16.37),('6449','2013-06-14','13:20:00',15.87),('6449','2013-06-14','13:25:00',15.91),('6449','2013-06-14','13:30:00',15.74),('6449','2013-06-14','13:35:00',15.96),('6449','2013-06-14','13:40:00',16.03),('6449','2013-06-14','13:45:00',15.98),('6449','2013-06-14','13:50:00',15.94),('6449','2013-06-14','13:55:00',15.83),('6449','2013-06-14','14:00:00',15.68),('6449','2013-06-14','14:05:00',15.6),('6449','2013-06-14','14:10:00',15.57),('6449','2013-06-14','14:15:00',15.37),('6449','2013-06-14','14:20:00',15.45),('6449','2013-06-14','14:25:00',15.35),('6449','2013-06-14','14:30:00',15.33),('6449','2013-06-14','14:35:00',15.14),('6449','2013-06-14','14:40:00',15.01),('6449','2013-06-14','14:45:00',14.59),('6449','2013-06-14','14:50:00',14.71),('6449','2013-06-14','14:55:00',14.51),('6449','2013-06-14','15:00:00',14.34),('6449','2013-06-14','15:05:00',14.28),('6449','2013-06-14','15:10:00',14.2),('6449','2013-06-14','15:15:00',14.16),('6449','2013-06-14','15:20:00',13.93),('6449','2013-06-14','15:25:00',13.63),('6449','2013-06-14','15:30:00',13.37),('6449','2013-06-14','15:35:00',13.39),('6449','2013-06-14','15:40:00',13.12),('6449','2013-06-14','15:45:00',12.96),('6449','2013-06-14','15:50:00',12.63),('6449','2013-06-14','15:55:00',12.45),('6449','2013-06-14','16:00:00',12.11),('6449','2013-06-14','16:05:00',12.03),('6449','2013-06-14','16:10:00',11.82),('6449','2013-06-14','16:15:00',11.46),('6449','2013-06-14','16:20:00',11.18),('6449','2013-06-14','16:25:00',10.8),('6449','2013-06-14','16:30:00',10.38),('6449','2013-06-14','16:35:00',10.1),('6449','2013-06-14','16:40:00',9.93),('6449','2013-06-14','16:45:00',9.5),('6449','2013-06-14','16:50:00',9.27),('6449','2013-06-14','16:55:00',9.13),('6449','2013-06-14','17:00:00',8.89),('6449','2013-06-14','17:05:00',8.55),('6449','2013-06-14','17:10:00',8.21),('6449','2013-06-14','17:15:00',7.88),('6449','2013-06-14','17:20:00',7.64),('6449','2013-06-14','17:25:00',7.26),('6449','2013-06-14','17:30:00',6.94),('6449','2013-06-14','17:35:00',6.6),('6449','2013-06-14','17:40:00',6.37),('6449','2013-06-14','17:45:00',5.9),('6449','2013-06-14','17:50:00',5.67),('6449','2013-06-14','17:55:00',5.36),('6449','2013-06-14','18:00:00',4.97),('6449','2013-06-14','18:05:00',4.61),('6449','2013-06-14','18:10:00',4.31),('6449','2013-06-14','18:15:00',3.97),('6449','2013-06-14','18:20:00',3.66),('6449','2013-06-14','18:25:00',3.34),('6449','2013-06-14','18:30:00',3.05),('6449','2013-06-14','18:35:00',2.75),('6449','2013-06-14','18:40:00',2.43),('6449','2013-06-14','18:45:00',2.17),('6449','2013-06-14','18:50:00',1.91),('6449','2013-06-14','18:55:00',1.67),('6449','2013-06-14','19:00:00',1.43),('6449','2013-06-14','19:05:00',1.24),('6449','2013-06-14','19:10:00',1.05),('6449','2013-06-07','06:50:00',1.04),('6449','2013-06-07','06:55:00',1.41),('6449','2013-06-07','07:00:00',1.67),('6449','2013-06-07','07:05:00',1.94),('6449','2013-06-07','07:10:00',2.27),('6449','2013-06-07','07:15:00',2.56),('6449','2013-06-07','07:20:00',2.88),('6449','2013-06-07','07:25:00',3.23),('6449','2013-06-07','07:30:00',3.57),('6449','2013-06-07','07:35:00',3.95),('6449','2013-06-07','07:40:00',4.31),('6449','2013-06-07','07:45:00',4.66),('6449','2013-06-07','07:50:00',5.05),('6449','2013-06-07','07:55:00',5.39),('6449','2013-06-07','08:00:00',5.75),('6449','2013-06-07','08:05:00',6.08),('6449','2013-06-07','08:10:00',6.46),('6449','2013-06-07','08:15:00',6.8),('6449','2013-06-07','08:20:00',7.12),('6449','2013-06-07','08:25:00',7.48),('6449','2013-06-07','08:30:00',7.8),('6449','2013-06-07','08:35:00',8.14),('6449','2013-06-07','08:40:00',8.5),('6449','2013-06-07','08:45:00',8.82),('6449','2013-06-07','08:50:00',8.92),('6449','2013-06-07','08:55:00',9.31),('6449','2013-06-07','09:00:00',9.65),('6449','2013-06-07','09:05:00',9.85),('6449','2013-06-07','09:10:00',10.18),('6449','2013-06-07','09:15:00',10.42),('6449','2013-06-07','09:20:00',10.9),('6449','2013-06-07','09:25:00',11.05),('6449','2013-06-07','09:30:00',11.36),('6449','2013-06-07','09:35:00',11.65),('6449','2013-06-07','09:40:00',11.86),('6449','2013-06-07','09:45:00',12.2),('6449','2013-06-07','09:50:00',12.32),('6449','2013-06-07','09:55:00',12.52),('6449','2013-06-07','10:00:00',12.77),('6449','2013-06-07','10:05:00',12.76),('6449','2013-06-07','10:10:00',13.32),('6449','2013-06-07','10:15:00',13.41),('6449','2013-06-07','10:20:00',13.68),('6449','2013-06-07','10:25:00',13.84),('6449','2013-06-07','10:30:00',14.02),('6449','2013-06-07','10:35:00',13.99),('6449','2013-06-07','10:40:00',14.2),('6449','2013-06-07','10:45:00',14.38),('6449','2013-06-07','10:50:00',14.49),('6449','2013-06-07','10:55:00',14.55),('6449','2013-06-07','11:00:00',14.64),('6449','2013-06-07','11:05:00',14.87),('6449','2013-06-07','11:10:00',15.02),('6449','2013-06-07','11:15:00',14.85),('6449','2013-06-07','11:20:00',14.92),('6449','2013-06-07','11:25:00',15.11),('6449','2013-06-07','11:30:00',15.15),('6449','2013-06-07','11:35:00',15.05),('6449','2013-06-07','11:40:00',15.02),('6449','2013-06-07','11:45:00',15.03),('6449','2013-06-07','11:50:00',15.26),('6449','2013-06-07','11:55:00',15.6),('6449','2013-06-07','12:00:00',15.8),('6449','2013-06-07','12:05:00',15.86),('6449','2013-06-07','12:10:00',16.01),('6449','2013-06-07','12:15:00',16.11),('6449','2013-06-07','12:20:00',15.92),('6449','2013-06-07','12:25:00',16.07),('6449','2013-06-07','12:30:00',15.92),('6449','2013-06-07','12:35:00',15.7),('6449','2013-06-07','12:40:00',16.21),('6449','2013-06-07','12:45:00',16.28),('6449','2013-06-07','12:50:00',16.33),('6449','2013-06-07','12:55:00',16.5),('6449','2013-06-07','13:00:00',16.48),('6449','2013-06-07','13:05:00',16.7),('6449','2013-06-07','13:10:00',16.63),('6449','2013-06-07','13:15:00',16.71),('6449','2013-06-07','13:20:00',16.72),('6449','2013-06-07','13:25:00',16.65),('6449','2013-06-07','13:30:00',16.66),('6449','2013-06-07','13:35:00',16.38),('6449','2013-06-07','13:40:00',16.47),('6449','2013-06-07','13:45:00',16.48),('6449','2013-06-07','13:50:00',16.44),('6449','2013-06-07','13:55:00',16.36),('6449','2013-06-07','14:00:00',16.27),('6449','2013-06-07','14:05:00',16.09),('6449','2013-06-07','14:10:00',16.25),('6449','2013-06-07','14:15:00',16.14),('6449','2013-06-07','14:20:00',16.03),('6449','2013-06-07','14:25:00',15.92),('6449','2013-06-07','14:30:00',15.8),('6449','2013-06-07','14:35:00',15.64),('6449','2013-06-07','14:40:00',15.48),('6449','2013-06-07','14:45:00',15.33),('6449','2013-06-07','14:50:00',15.24),('6449','2013-06-07','14:55:00',15.12),('6449','2013-06-07','15:00:00',14.94),('6449','2013-06-07','15:05:00',14.71),('6449','2013-06-07','15:10:00',14.48),('6449','2013-06-07','15:15:00',14.27),('6449','2013-06-07','15:20:00',14),('6449','2013-06-07','15:25:00',13.79),('6449','2013-06-07','15:30:00',13.74),('6449','2013-06-07','15:35:00',13.51),('6449','2013-06-07','15:40:00',13.31),('6449','2013-06-07','15:45:00',13.15),('6449','2013-06-07','15:50:00',12.93),('6449','2013-06-07','15:55:00',12.53),('6449','2013-06-07','16:00:00',12.48),('6449','2013-06-07','16:05:00',12.29),('6449','2013-06-07','16:10:00',11.99),('6449','2013-06-07','16:15:00',11.66),('6449','2013-06-07','16:20:00',11.34),('6449','2013-06-07','16:25:00',9.74),('6449','2013-06-07','16:30:00',10.67),('6449','2013-06-07','16:35:00',9.28),('6449','2013-06-07','16:40:00',10.07),('6449','2013-06-07','16:45:00',8.53),('6449','2013-06-07','16:50:00',9.54),('6449','2013-06-07','16:55:00',9.27),('6449','2013-06-07','17:00:00',9.01),('6449','2013-06-07','17:05:00',8.77),('6449','2013-06-07','17:10:00',8.53),('6449','2013-06-07','17:15:00',8.88),('6449','2013-06-07','17:20:00',8.15),('6449','2013-06-07','17:25:00',8.52),('6449','2013-06-07','17:30:00',7.7),('6449','2013-06-07','17:35:00',7.22),('6449','2013-06-07','17:40:00',5.29),('6449','2013-06-07','17:45:00',3.72),('6449','2013-06-07','17:50:00',6.41),('6449','2013-06-06','06:45:00',1.19),('6449','2013-06-06','06:50:00',1.52),('6449','2013-06-06','06:55:00',2.01),('6449','2013-06-06','07:00:00',2.3),('6449','2013-06-06','07:05:00',2.17),('6449','2013-06-06','07:10:00',2.15),('6449','2013-06-06','07:15:00',2.02),('6449','2013-06-06','07:20:00',2.3),('6449','2013-06-06','07:25:00',2.91),('6449','2013-06-06','07:30:00',3.07),('6449','2013-06-06','07:35:00',3.89),('6449','2013-06-06','07:40:00',4.6),('6449','2013-06-06','07:45:00',4.91),('6449','2013-06-06','07:50:00',5.16),('6449','2013-06-06','07:55:00',5.59),('6449','2013-06-06','08:00:00',6),('6449','2013-06-06','08:05:00',6.26),('6449','2013-06-06','08:10:00',6.48),('6449','2013-06-06','08:15:00',6.79),('6449','2013-06-06','08:20:00',7.23),('6449','2013-06-06','08:25:00',7.53),('6449','2013-06-06','08:30:00',7.89),('6449','2013-06-06','08:35:00',8.12),('6449','2013-06-06','08:40:00',8.48),('6449','2013-06-06','08:45:00',8.7),('6449','2013-06-06','08:50:00',9.12),('6449','2013-06-06','08:55:00',9.36),('6449','2013-06-06','09:00:00',9.68),('6449','2013-06-06','09:05:00',9.82),('6449','2013-06-06','09:10:00',10.22),('6449','2013-06-06','09:15:00',10.36),('6449','2013-06-06','09:20:00',10.58),('6449','2013-06-06','09:25:00',10.85),('6449','2013-06-06','09:30:00',11.13),('6449','2013-06-06','09:35:00',11.32),('6449','2013-06-06','09:40:00',11.51),('6449','2013-06-06','09:45:00',11.81),('6449','2013-06-06','09:50:00',11.88),('6449','2013-06-06','09:55:00',12.23),('6449','2013-06-06','10:00:00',12.39),('6449','2013-06-06','10:05:00',12.67),('6449','2013-06-06','10:10:00',12.82),('6449','2013-06-06','10:15:00',13.19),('6449','2013-06-06','10:20:00',13.51),('6449','2013-06-06','10:25:00',11.14),('6449','2013-06-06','10:30:00',8.91),('6449','2013-06-06','10:35:00',14.68),('6449','2013-06-06','10:40:00',14.8),('6449','2013-06-06','10:45:00',12.39),('6449','2013-06-06','10:50:00',12.64),('6449','2013-06-06','10:55:00',12.64),('6449','2013-06-06','11:00:00',14.47),('6449','2013-06-06','11:05:00',15.05),('6449','2013-06-06','11:10:00',15.05),('6449','2013-06-06','11:15:00',15.25),('6449','2013-06-06','11:20:00',14.22),('6449','2013-06-06','11:25:00',15.09),('6449','2013-06-06','11:30:00',15.6),('6449','2013-06-06','11:35:00',15.55),('6449','2013-06-06','11:40:00',15.32),('6449','2013-06-06','11:45:00',15.06),('6449','2013-06-06','11:50:00',15.68),('6449','2013-06-06','11:55:00',15.65),('6449','2013-06-06','12:00:00',15.76),('6449','2013-06-06','12:05:00',15.69),('6449','2013-06-06','12:10:00',15.96),('6449','2013-06-06','12:15:00',16.07),('6449','2013-06-06','12:20:00',16.16),('6449','2013-06-06','12:25:00',16.23),('6449','2013-06-06','12:30:00',16.3),('6449','2013-06-06','12:35:00',16),('6449','2013-06-06','12:40:00',16.3),('6449','2013-06-06','12:45:00',16.35),('6449','2013-06-06','12:50:00',16.35),('6449','2013-06-06','12:55:00',16.33),('6449','2013-06-06','13:00:00',16.38),('6449','2013-06-06','13:05:00',15.96),('6449','2013-06-06','13:10:00',16.45),('6449','2013-06-06','13:15:00',16.32),('6449','2013-06-06','13:20:00',16.4),('6449','2013-06-06','13:25:00',16.23),('6449','2013-06-06','13:30:00',16.42),('6449','2013-06-06','13:35:00',16.43),('6449','2013-06-06','13:40:00',16.41),('6449','2013-06-06','13:45:00',16.15),('6449','2013-06-06','13:50:00',16.03),('6449','2013-06-06','13:55:00',16.12),('6449','2013-06-06','14:00:00',15.98),('6449','2013-06-06','14:05:00',15.84),('6449','2013-06-06','14:10:00',15.83),('6449','2013-06-06','14:15:00',15.84),('6449','2013-06-06','14:20:00',15.49),('6449','2013-06-06','14:25:00',15.61),('6449','2013-06-06','14:30:00',15.55),('6449','2013-06-06','14:35:00',15.28),('6449','2013-06-06','14:40:00',15.04),('6449','2013-06-06','14:45:00',15),('6449','2013-06-06','14:50:00',14.87),('6449','2013-06-06','14:55:00',14.32),('6449','2013-06-06','15:00:00',14.51),('6449','2013-06-06','15:05:00',14.45),('6449','2013-06-06','15:10:00',14.32),('6449','2013-06-06','15:15:00',14.07),('6449','2013-06-06','15:20:00',13.86),('6449','2013-06-06','15:25:00',13.79),('6449','2013-06-06','15:30:00',13.57),('6449','2013-06-06','15:35:00',13.58),('6449','2013-06-06','15:40:00',13.21),('6449','2013-06-06','15:45:00',12.97),('6449','2013-06-06','15:50:00',12.78),('6449','2013-06-06','15:55:00',12.63),('6449','2013-06-06','16:00:00',12.43),('6449','2013-06-06','16:05:00',11.97),('6449','2013-06-06','16:10:00',11.86),('6449','2013-06-06','16:15:00',11.56),('6449','2013-06-06','16:20:00',11.2),('6449','2013-06-06','16:25:00',10.93),('6449','2013-06-06','16:30:00',10.65),('6449','2013-06-06','16:35:00',10.48),('6449','2013-06-06','16:40:00',10.2),('6449','2013-06-06','16:45:00',9.97),('6449','2013-06-06','16:50:00',9.64),('6449','2013-06-06','16:55:00',9.11),('6449','2013-06-06','17:00:00',8.93),('6449','2013-06-06','17:05:00',8.69),('6449','2013-06-06','17:10:00',8.27),('6449','2013-06-06','17:15:00',7.92),('6449','2013-06-06','17:20:00',7.73),('6449','2013-06-06','17:25:00',7.28),('6449','2013-06-06','17:30:00',7.04),('6449','2013-06-06','17:35:00',6.63),('6449','2013-06-06','17:40:00',6.32),('6449','2013-06-06','17:45:00',6),('6449','2013-06-06','17:50:00',5.52),('6449','2013-06-06','17:55:00',5.24),('6449','2013-06-06','18:00:00',4.87),('6449','2013-06-06','18:05:00',4.54),('6449','2013-06-06','18:10:00',4.21),('6449','2013-06-06','18:15:00',3.88),('6449','2013-06-06','18:20:00',3.54),('6449','2013-06-06','18:25:00',3.23),('6449','2013-06-06','18:30:00',2.87),('6449','2013-06-06','18:35:00',2.57),('6449','2013-06-06','18:40:00',2.3),('6449','2013-06-06','18:45:00',1.99),('6449','2013-06-06','18:50:00',1.78),('6449','2013-06-06','18:55:00',1.53),('6449','2013-06-06','19:00:00',1.3),('6449','2013-06-06','19:05:00',1.1),('6449','2013-06-05','06:50:00',1.23),('6449','2013-06-05','06:55:00',1.7),('6449','2013-06-05','07:00:00',1.92),('6449','2013-06-05','07:05:00',3.08),('6449','2013-06-05','07:10:00',2.85),('6449','2013-06-05','07:15:00',2.79),('6449','2013-06-05','07:20:00',3.26),('6449','2013-06-05','07:25:00',3.05),('6449','2013-06-05','07:30:00',2.48),('6449','2013-06-05','07:35:00',3.89),('6449','2013-06-05','07:40:00',4.18),('6449','2013-06-05','07:45:00',4.67),('6449','2013-06-05','07:50:00',5.03),('6449','2013-06-05','07:55:00',5.29),('6449','2013-06-05','08:00:00',5.65),('6449','2013-06-05','08:05:00',6.02),('6449','2013-06-05','08:10:00',6.42),('6449','2013-06-05','08:15:00',6.61),('6449','2013-06-05','08:20:00',6.97),('6449','2013-06-05','08:25:00',7.08),('6449','2013-06-05','08:30:00',7.4),('6449','2013-06-05','08:35:00',7.82),('6449','2013-06-05','08:40:00',8.13),('6449','2013-06-05','08:45:00',8.43),('6449','2013-06-05','08:50:00',8.88),('6449','2013-06-05','08:55:00',9.25),('6449','2013-06-05','09:00:00',9.48),('6449','2013-06-05','09:05:00',9.8),('6449','2013-06-05','09:10:00',10.3),('6449','2013-06-05','09:15:00',10.46),('6449','2013-06-05','09:20:00',10.69),('6449','2013-06-05','09:25:00',10.69),('6449','2013-06-05','09:30:00',9.9),('6449','2013-06-05','09:35:00',11.51),('6449','2013-06-05','09:40:00',11.81),('6449','2013-06-05','09:45:00',12.21),('6449','2013-06-05','09:50:00',13.36),('6449','2013-06-05','09:55:00',11.28),('6449','2013-06-05','10:00:00',5.02),('6449','2013-06-05','10:05:00',4.67),('6449','2013-06-05','10:10:00',8.5),('6449','2013-06-05','10:15:00',9.55),('6449','2013-06-05','10:20:00',4.04),('6449','2013-06-05','10:25:00',4.04),('6449','2013-06-05','10:30:00',4.83),('6449','2013-06-05','10:35:00',4.46),('6449','2013-06-05','10:40:00',4.78),('6449','2013-06-05','10:45:00',4.77),('6449','2013-06-05','10:50:00',10.01),('6449','2013-06-05','10:55:00',13.23),('6449','2013-06-05','11:00:00',15.6),('6449','2013-06-05','11:05:00',15.07),('6449','2013-06-05','11:10:00',14.91),('6449','2013-06-05','11:15:00',14.77),('6449','2013-06-05','11:20:00',14.77),('6449','2013-06-05','11:25:00',15.38),('6449','2013-06-05','11:30:00',15.35),('6449','2013-06-05','11:35:00',15.46),('6449','2013-06-05','11:40:00',15.56),('6449','2013-06-05','11:45:00',15.77),('6449','2013-06-05','11:50:00',15.75),('6449','2013-06-05','11:55:00',15.81),('6449','2013-06-05','12:00:00',16),('6449','2013-06-05','12:05:00',16.12),('6449','2013-06-05','12:10:00',16.02),('6449','2013-06-05','12:15:00',16.16),('6449','2013-06-05','12:20:00',16.21),('6449','2013-06-05','12:25:00',16.17),('6449','2013-06-05','12:30:00',16.26),('6449','2013-06-05','12:35:00',16.14),('6449','2013-06-05','12:40:00',16.34),('6449','2013-06-05','12:45:00',16.39),('6449','2013-06-05','12:50:00',16.55),('6449','2013-06-05','12:55:00',16.6),('6449','2013-06-05','13:00:00',16.46),('6449','2013-06-05','13:05:00',16.48),('6449','2013-06-05','13:10:00',16.87),('6449','2013-06-05','13:15:00',17.02),('6449','2013-06-05','13:20:00',16.73),('6449','2013-06-05','13:25:00',16.64),('6449','2013-06-05','13:30:00',16.06),('6449','2013-06-05','13:35:00',16.14),('6449','2013-06-05','13:40:00',16.21),('6449','2013-06-05','13:45:00',16.29),('6449','2013-06-05','13:50:00',16.3),('6449','2013-06-05','13:55:00',16.14),('6449','2013-06-05','14:00:00',15.91),('6449','2013-06-05','14:05:00',15.85),('6449','2013-06-05','14:10:00',15.89),('6449','2013-06-05','14:15:00',15.86),('6449','2013-06-05','14:20:00',15.49),('6449','2013-06-05','14:25:00',15.77),('6449','2013-06-05','14:30:00',14.41),('6449','2013-06-05','14:35:00',15.43),('6449','2013-06-05','14:40:00',15.1),('6449','2013-06-05','14:45:00',14.56),('6449','2013-06-05','14:50:00',12.25),('6449','2013-06-05','14:55:00',14.84),('6449','2013-06-05','15:00:00',14.04),('6449','2013-06-05','15:05:00',14.78),('6449','2013-06-05','15:10:00',14.39),('6449','2013-06-05','15:15:00',13.99),('6449','2013-06-05','15:20:00',13.07),('6449','2013-06-05','15:25:00',12.74),('6449','2013-06-05','15:30:00',14.13),('6449','2013-06-05','15:35:00',10.88),('6449','2013-06-05','15:40:00',12.44),('6449','2013-06-05','15:45:00',8.59),('6449','2013-06-05','15:50:00',7.97),('6449','2013-06-05','15:55:00',12.6),('6449','2013-06-05','16:00:00',12.65),('6449','2013-06-05','16:05:00',10.72),('6449','2013-06-05','16:10:00',10.01),('6449','2013-06-05','16:15:00',11.84),('6449','2013-06-05','16:20:00',11.48),('6449','2013-06-05','16:25:00',10.64),('6449','2013-06-05','16:30:00',7.36),('6449','2013-06-05','16:35:00',9.69),('6449','2013-06-05','16:40:00',10.14),('6449','2013-06-05','16:45:00',9.84),('6449','2013-06-05','16:50:00',7.14),('6449','2013-06-05','16:55:00',7.99),('6449','2013-06-05','17:00:00',5.14),('6449','2013-06-05','17:05:00',7.99),('6449','2013-06-05','17:10:00',6.96),('6449','2013-06-05','17:15:00',8.51),('6449','2013-06-05','17:20:00',7.48),('6449','2013-06-05','17:25:00',6.25),('6449','2013-06-05','17:30:00',7.59),('6449','2013-06-05','17:35:00',7.09),('6449','2013-06-05','17:40:00',6.41),('6449','2013-06-05','17:45:00',6.39),('6449','2013-06-05','17:50:00',5.02),('6449','2013-06-05','17:55:00',5.16),('6449','2013-06-05','18:00:00',5.08),('6449','2013-06-05','18:05:00',4.62),('6449','2013-06-05','18:10:00',4.36),('6449','2013-06-05','18:15:00',4.27),('6449','2013-06-05','18:20:00',3.97),('6449','2013-06-05','18:25:00',3.76),('6449','2013-06-05','18:30:00',3.47),('6449','2013-06-05','18:35:00',2.97),('6449','2013-06-05','18:40:00',2.5),('6449','2013-06-05','18:45:00',2.1),('6449','2013-06-05','18:50:00',1.88),('6449','2013-06-05','18:55:00',1.64),('6449','2013-06-05','19:00:00',1.43),('6449','2013-06-05','19:05:00',1.24),('6449','2013-06-05','19:10:00',1.08),('6449','2013-06-04','06:40:00',1.05),('6449','2013-06-04','06:45:00',1.17),('6449','2013-06-04','06:50:00',1.68),('6449','2013-06-04','06:55:00',2.49),('6449','2013-06-04','07:00:00',2.84),('6449','2013-06-04','07:05:00',2.97),('6449','2013-06-04','07:10:00',3.66),('6449','2013-06-04','07:15:00',4.65),('6449','2013-06-04','07:20:00',4.77),('6449','2013-06-04','07:25:00',5.03),('6449','2013-06-04','07:30:00',4.54),('6449','2013-06-04','07:35:00',3.49),('6449','2013-06-04','07:40:00',3.1),('6449','2013-06-04','07:45:00',2.63),('6449','2013-06-04','07:50:00',3.28),('6449','2013-06-04','07:55:00',4.9),('6449','2013-06-04','08:00:00',6.4),('6449','2013-06-04','08:05:00',5.66),('6449','2013-06-04','08:10:00',3.37),('6449','2013-06-04','08:15:00',3.68),('6449','2013-06-04','08:20:00',3.96),('6449','2013-06-04','08:25:00',4.1),('6449','2013-06-04','08:30:00',2.44),('6449','2013-06-04','08:35:00',1.95),('6449','2013-06-04','08:40:00',2.04),('6449','2013-06-04','08:45:00',2.52),('6449','2013-06-04','08:50:00',2.96),('6449','2013-06-04','08:55:00',3.09),('6449','2013-06-04','09:00:00',3.7),('6449','2013-06-04','09:05:00',5.49),('6449','2013-06-04','09:10:00',6.38),('6449','2013-06-04','09:15:00',6.93),('6449','2013-06-04','09:20:00',8.4),('6449','2013-06-04','09:25:00',6.38),('6449','2013-06-04','09:30:00',5.74),('6449','2013-06-04','09:35:00',6.54),('6449','2013-06-04','09:40:00',8.69),('6449','2013-06-04','09:45:00',10.32),('6449','2013-06-04','09:50:00',5.37),('6449','2013-06-04','09:55:00',4.65),('6449','2013-06-04','10:00:00',4.91),('6449','2013-06-04','10:05:00',5.95),('6449','2013-06-04','10:10:00',7),('6449','2013-06-04','10:15:00',9.42),('6449','2013-06-04','10:20:00',9.64),('6449','2013-06-04','10:25:00',6.31),('6449','2013-06-04','10:30:00',6.41),('6449','2013-06-04','10:35:00',8.7),('6449','2013-06-04','10:40:00',8.45),('6449','2013-06-04','10:45:00',6.15),('6449','2013-06-04','10:50:00',6.35),('6449','2013-06-04','10:55:00',6.41),('6449','2013-06-04','11:00:00',6.88),('6449','2013-06-04','11:05:00',9.15),('6449','2013-06-04','11:10:00',7.12),('6449','2013-06-04','11:15:00',14.04),('6449','2013-06-04','11:20:00',12.62),('6449','2013-06-04','11:25:00',16.71),('6449','2013-06-04','11:30:00',16.63),('6449','2013-06-04','11:35:00',14.11),('6449','2013-06-04','11:40:00',11.38),('6449','2013-06-04','11:45:00',7.76),('6449','2013-06-04','11:50:00',11.16),('6449','2013-06-04','11:55:00',8.59),('6449','2013-06-04','12:00:00',7.55),('6449','2013-06-04','12:05:00',14.16),('6449','2013-06-04','12:10:00',11.97),('6449','2013-06-04','12:15:00',8.19),('6449','2013-06-04','12:20:00',8.37),('6449','2013-06-04','12:25:00',7.25),('6449','2013-06-04','12:30:00',5.31),('6449','2013-06-04','12:35:00',4.89),('6449','2013-06-04','12:40:00',5.96),('6449','2013-06-04','12:45:00',9.48),('6449','2013-06-04','12:50:00',11),('6449','2013-06-04','12:55:00',13.22),('6449','2013-06-04','13:00:00',13.04),('6449','2013-06-04','13:05:00',9.06),('6449','2013-06-04','13:10:00',12.52),('6449','2013-06-04','13:15:00',12.4),('6449','2013-06-04','13:20:00',11.46),('6449','2013-06-04','13:25:00',12.66),('6449','2013-06-04','13:30:00',10.87),('6449','2013-06-04','13:35:00',10.44),('6449','2013-06-04','13:40:00',13.07),('6449','2013-06-04','13:45:00',17.91),('6449','2013-06-04','13:50:00',16.62),('6449','2013-06-04','13:55:00',17.17),('6449','2013-06-04','14:00:00',14.3),('6449','2013-06-04','14:05:00',14.14),('6449','2013-06-04','14:10:00',12.71),('6449','2013-06-04','14:15:00',15.97),('6449','2013-06-04','14:20:00',15.78),('6449','2013-06-04','14:25:00',16.83),('6449','2013-06-04','14:30:00',12.72),('6449','2013-06-04','14:35:00',10.84),('6449','2013-06-04','14:40:00',11.01),('6449','2013-06-04','14:45:00',12.81),('6449','2013-06-04','14:50:00',6.92),('6449','2013-06-04','14:55:00',17.37),('6449','2013-06-04','15:00:00',16.27),('6449','2013-06-04','15:05:00',14.84),('6449','2013-06-04','15:10:00',13.3),('6449','2013-06-04','15:15:00',12.47),('6449','2013-06-04','15:20:00',12.6),('6449','2013-06-04','15:25:00',7.49),('6449','2013-06-04','15:30:00',8.55),('6449','2013-06-04','15:35:00',12.21),('6449','2013-06-04','15:40:00',14.07),('6449','2013-06-04','15:45:00',12.18),('6449','2013-06-04','15:50:00',10.53),('6449','2013-06-04','15:55:00',12.3),('6449','2013-06-04','16:00:00',12.5),('6449','2013-06-04','16:05:00',13.18),('6449','2013-06-04','16:10:00',10.43),('6449','2013-06-04','16:15:00',6.9),('6449','2013-06-04','16:20:00',5.16),('6449','2013-06-04','16:25:00',4.78),('6449','2013-06-04','16:30:00',4.72),('6449','2013-06-04','16:35:00',4.36),('6449','2013-06-04','16:40:00',4.33),('6449','2013-06-04','16:45:00',4.09),('6449','2013-06-04','16:50:00',3.74),('6449','2013-06-04','16:55:00',3.32),('6449','2013-06-04','17:00:00',3.1),('6449','2013-06-04','17:05:00',3.01),('6449','2013-06-04','17:10:00',2.98),('6449','2013-06-04','17:15:00',3.02),('6449','2013-06-04','17:20:00',3.22),('6449','2013-06-04','17:25:00',3.51),('6449','2013-06-04','17:30:00',3.74),('6449','2013-06-04','17:35:00',4.16),('6449','2013-06-04','17:40:00',4.96),('6449','2013-06-04','17:45:00',5.43),('6449','2013-06-04','17:50:00',6.23),('6449','2013-06-04','17:55:00',5.26),('6449','2013-06-04','18:00:00',3.29),('6449','2013-06-04','18:05:00',2.68),('6449','2013-06-04','18:10:00',2.73),('6449','2013-06-04','18:15:00',2.82),('6449','2013-06-04','18:20:00',2.73),('6449','2013-06-04','18:25:00',2.52),('6449','2013-06-04','18:30:00',2.73),('6449','2013-06-04','18:35:00',1.91),('6449','2013-06-04','18:40:00',1.71),('6449','2013-06-04','18:45:00',1.59),('6449','2013-06-04','18:50:00',1.5),('6449','2013-06-04','18:55:00',1.33),('6449','2013-06-04','19:00:00',1.17),('6449','2013-06-04','19:05:00',1.19),('6449','2013-06-04','19:10:00',1.25),('6449','2013-06-04','19:15:00',1.06),('6449','2013-06-04','19:30:00',1.01),('6449','2013-06-03','06:30:00',1.2),('6449','2013-06-03','06:35:00',1.55),('6449','2013-06-03','06:40:00',1.86),('6449','2013-06-03','06:45:00',2.17),('6449','2013-06-03','06:50:00',2.39),('6449','2013-06-03','06:55:00',2.55),('6449','2013-06-03','07:00:00',3.02),('6449','2013-06-03','07:05:00',3.34),('6449','2013-06-03','07:10:00',3.64),('6449','2013-06-03','07:15:00',2.98),('6449','2013-06-03','07:20:00',2.52),('6449','2013-06-03','07:25:00',3.69),('6449','2013-06-03','07:30:00',2.93),('6449','2013-06-03','07:35:00',2.49),('6449','2013-06-03','07:40:00',2.58),('6449','2013-06-03','07:45:00',2.82),('6449','2013-06-03','07:50:00',3.22),('6449','2013-06-03','07:55:00',3.18),('6449','2013-06-03','08:00:00',3.08),('6449','2013-06-03','08:05:00',2.7),('6449','2013-06-03','08:10:00',2.77),('6449','2013-06-03','08:15:00',2.92),('6449','2013-06-03','08:20:00',3.33),('6449','2013-06-03','08:25:00',4.88),('6449','2013-06-03','08:30:00',4.55),('6449','2013-06-03','08:35:00',7.19),('6449','2013-06-03','08:40:00',6.25),('6449','2013-06-03','08:45:00',5.04),('6449','2013-06-03','08:50:00',8.14),('6449','2013-06-03','08:55:00',8.5),('6449','2013-06-03','09:00:00',5.19),('6449','2013-06-03','09:05:00',4.52),('6449','2013-06-03','09:10:00',4.15),('6449','2013-06-03','09:15:00',3.8),('6449','2013-06-03','09:20:00',4.29),('6449','2013-06-03','09:25:00',5.09),('6449','2013-06-03','09:30:00',4.91),('6449','2013-06-03','09:35:00',4.36),('6449','2013-06-03','09:40:00',4.65),('6449','2013-06-03','09:45:00',5.74),('6449','2013-06-03','09:50:00',6.17),('6449','2013-06-03','09:55:00',8.07),('6449','2013-06-03','10:00:00',7.42),('6449','2013-06-03','10:05:00',5.61),('6449','2013-06-03','10:10:00',7.81),('6449','2013-06-03','10:15:00',10.81),('6449','2013-06-03','10:20:00',9.42),('6449','2013-06-03','10:25:00',13.59),('6449','2013-06-03','10:30:00',5.62),('6449','2013-06-03','10:35:00',6.76),('6449','2013-06-03','10:40:00',6.45),('6449','2013-06-03','10:45:00',6.15),('6449','2013-06-03','10:50:00',6.94),('6449','2013-06-03','10:55:00',8.3),('6449','2013-06-03','11:00:00',8.34),('6449','2013-06-03','11:05:00',11.54),('6449','2013-06-03','11:10:00',15.67),('6449','2013-06-03','11:15:00',10.93),('6449','2013-06-03','11:20:00',11.11),('6449','2013-06-03','11:25:00',4.32),('6449','2013-06-03','11:30:00',3.19),('6449','2013-06-03','11:35:00',3.28),('6449','2013-06-03','11:40:00',3.29),('6449','2013-06-03','11:45:00',3.65),('6449','2013-06-03','11:50:00',5),('6449','2013-06-03','11:55:00',7.61),('6449','2013-06-03','12:00:00',11.45),('6449','2013-06-03','12:05:00',18.94),('6449','2013-06-03','12:10:00',14.56),('6449','2013-06-03','12:15:00',5.4),('6449','2013-06-03','12:20:00',5.3),('6449','2013-06-03','12:25:00',5.53),('6449','2013-06-03','12:30:00',6.1),('6449','2013-06-03','12:35:00',7.03),('6449','2013-06-03','12:40:00',7.03),('6449','2013-06-03','12:45:00',11.39),('6449','2013-06-03','12:50:00',7.88),('6449','2013-06-03','12:55:00',5.51),('6449','2013-06-03','13:00:00',5.83),('6449','2013-06-03','13:05:00',6.62),('6449','2013-06-03','13:10:00',6.87),('6449','2013-06-03','13:15:00',8.44),('6449','2013-06-03','13:20:00',8.09),('6449','2013-06-03','13:25:00',7.43),('6449','2013-06-03','13:30:00',17.75),('6449','2013-06-03','13:35:00',16.91),('6449','2013-06-03','13:40:00',16.62),('6449','2013-06-03','13:45:00',16.86),('6449','2013-06-03','13:50:00',17.22),('6449','2013-06-03','13:55:00',15.45),('6449','2013-06-03','14:00:00',9.51),('6449','2013-06-03','14:05:00',7.08),('6449','2013-06-03','14:10:00',6.46),('6449','2013-06-03','14:15:00',15.3),('6449','2013-06-03','14:20:00',17.54),('6449','2013-06-03','14:25:00',18.14),('6449','2013-06-03','14:30:00',14.75),('6449','2013-06-03','14:35:00',16.24),('6449','2013-06-03','14:40:00',12.88),('6449','2013-06-03','14:45:00',9.99),('6449','2013-06-03','14:50:00',14.25),('6449','2013-06-03','14:55:00',10.63),('6449','2013-06-03','15:00:00',8.98),('6449','2013-06-03','15:05:00',15.32),('6449','2013-06-03','15:10:00',14.33),('6449','2013-06-03','15:15:00',14.01),('6449','2013-06-03','15:20:00',15.1),('6449','2013-06-03','15:25:00',14.08),('6449','2013-06-03','15:30:00',10.27),('6449','2013-06-03','15:35:00',10.13),('6449','2013-06-03','15:40:00',13.4),('6449','2013-06-03','15:45:00',12.82),('6449','2013-06-03','15:50:00',12.96),('6449','2013-06-03','15:55:00',12.66),('6449','2013-06-03','16:00:00',12.18),('6449','2013-06-03','16:05:00',12.25),('6449','2013-06-03','16:10:00',12.02),('6449','2013-06-03','16:15:00',11.84),('6449','2013-06-03','16:20:00',11.73),('6449','2013-06-03','16:25:00',10.59),('6449','2013-06-03','16:30:00',6.96),('6449','2013-06-03','16:35:00',6.64),('6449','2013-06-03','16:40:00',6.77),('6449','2013-06-03','16:45:00',7.95),('6449','2013-06-03','16:50:00',9.36),('6449','2013-06-03','16:55:00',8.06),('6449','2013-06-03','17:00:00',7.8),('6449','2013-06-03','17:05:00',6.94),('6449','2013-06-03','17:10:00',6.17),('6449','2013-06-03','17:15:00',6.38),('6449','2013-06-03','17:20:00',5.55),('6449','2013-06-03','17:25:00',4.44),('6449','2013-06-03','17:30:00',4.05),('6449','2013-06-03','17:35:00',3.78),('6449','2013-06-03','17:40:00',3.68),('6449','2013-06-03','17:45:00',3.56),('6449','2013-06-03','17:50:00',3.47),('6449','2013-06-03','17:55:00',2.96),('6449','2013-06-03','18:00:00',2.67),('6449','2013-06-03','18:05:00',2.64),('6449','2013-06-03','18:10:00',2.44),('6449','2013-06-03','18:15:00',2.09),('6449','2013-06-03','18:20:00',2.03),('6449','2013-06-03','18:25:00',2.18),('6449','2013-06-03','18:30:00',2.05),('6449','2013-06-03','18:35:00',1.92),('6449','2013-06-03','18:40:00',1.81),('6449','2013-06-03','18:45:00',1.46),('6449','2013-06-03','18:50:00',1.3),('6449','2013-06-03','18:55:00',1.26),('6449','2013-06-03','19:00:00',1.26),('6449','2013-06-03','19:05:00',1.24),('6449','2013-06-03','19:10:00',1.24),('6449','2013-06-03','19:15:00',1.08),('6449','2013-06-03','19:20:00',1.07),('6449','2013-06-02','07:35:00',1.13),('6449','2013-06-02','07:40:00',1.4),('6449','2013-06-02','07:45:00',1.83),('6449','2013-06-02','07:50:00',2.48),('6449','2013-06-02','07:55:00',3.02),('6449','2013-06-02','08:00:00',2.39),('6449','2013-06-02','08:05:00',4.64),('6449','2013-06-02','08:10:00',4.93),('6449','2013-06-02','08:15:00',4.48),('6449','2013-06-02','08:20:00',8.45),('6449','2013-06-02','08:25:00',8.32),('6449','2013-06-02','08:30:00',8.7),('6449','2013-06-02','08:35:00',8.87),('6449','2013-06-02','08:40:00',9.17),('6449','2013-06-02','08:45:00',8.28),('6449','2013-06-02','08:50:00',9.76),('6449','2013-06-02','08:55:00',9.5),('6449','2013-06-02','09:00:00',9.75),('6449','2013-06-02','09:05:00',10.06),('6449','2013-06-02','09:10:00',10.33),('6449','2013-06-02','09:15:00',10.66),('6449','2013-06-02','09:20:00',10.96),('6449','2013-06-02','09:25:00',11.17),('6449','2013-06-02','09:30:00',11.21),('6449','2013-06-02','09:35:00',11.46),('6449','2013-06-02','09:40:00',11.9),('6449','2013-06-02','09:45:00',10.76),('6449','2013-06-02','09:50:00',12.26),('6449','2013-06-02','09:55:00',12.92),('6449','2013-06-02','10:00:00',13.26),('6449','2013-06-02','10:05:00',13.49),('6449','2013-06-02','10:10:00',12.65),('6449','2013-06-02','10:15:00',10.87),('6449','2013-06-02','10:20:00',9.4),('6449','2013-06-02','10:25:00',13.47),('6449','2013-06-02','10:30:00',6.69),('6449','2013-06-02','10:35:00',9.59),('6449','2013-06-02','10:40:00',6.57),('6449','2013-06-02','10:45:00',12.5),('6449','2013-06-02','10:50:00',15.6),('6449','2013-06-02','10:55:00',15.46),('6449','2013-06-02','11:00:00',15.43),('6449','2013-06-02','11:05:00',15.42),('6449','2013-06-02','11:10:00',15.4),('6449','2013-06-02','11:15:00',15.31),('6449','2013-06-02','11:20:00',15.51),('6449','2013-06-02','11:25:00',15.65),('6449','2013-06-02','11:30:00',15.75),('6449','2013-06-02','11:35:00',15.78),('6449','2013-06-02','11:40:00',15.95),('6449','2013-06-02','11:45:00',16.09),('6449','2013-06-02','11:50:00',16.12),('6449','2013-06-02','11:55:00',16.08),('6449','2013-06-02','12:00:00',16.1),('6449','2013-06-02','12:05:00',16.14),('6449','2013-06-02','12:10:00',16.32),('6449','2013-06-02','12:15:00',16.33),('6449','2013-06-02','12:20:00',16.5),('6449','2013-06-02','12:25:00',16.56),('6449','2013-06-02','12:30:00',16.55),('6449','2013-06-02','12:35:00',16.54),('6449','2013-06-02','12:40:00',16.49),('6449','2013-06-02','12:45:00',16.49),('6449','2013-06-02','12:50:00',16.51),('6449','2013-06-02','12:55:00',16.62),('6449','2013-06-02','13:00:00',16.55),('6449','2013-06-02','13:05:00',16.65),('6449','2013-06-02','13:10:00',16.79),('6449','2013-06-02','13:15:00',16.55),('6449','2013-06-02','13:20:00',16.57),('6449','2013-06-02','13:25:00',16.34),('6449','2013-06-02','13:30:00',16.14),('6449','2013-06-02','13:35:00',16.2),('6449','2013-06-02','13:40:00',16.48),('6449','2013-06-02','13:45:00',16.42),('6449','2013-06-02','13:50:00',7.9),('6449','2013-06-02','13:55:00',16.87),('6449','2013-06-02','14:00:00',10.38),('6449','2013-06-02','14:05:00',11.27),('6449','2013-06-02','14:10:00',12.47),('6449','2013-06-02','14:15:00',13.57),('6449','2013-06-02','14:20:00',12.96),('6449','2013-06-02','14:25:00',15.01),('6449','2013-06-02','14:30:00',9.53),('6449','2013-06-02','14:35:00',11.98),('6449','2013-06-02','14:40:00',16.62),('6449','2013-06-02','14:45:00',16.6),('6449','2013-06-02','14:50:00',12.31),('6449','2013-06-02','14:55:00',14.45),('6449','2013-06-02','15:00:00',13.13),('6449','2013-06-02','15:05:00',12.55),('6449','2013-06-02','15:10:00',14.27),('6449','2013-06-02','15:15:00',14.77),('6449','2013-06-02','15:20:00',11.48),('6449','2013-06-02','15:25:00',12.65),('6449','2013-06-02','15:30:00',13.94),('6449','2013-06-02','15:35:00',13.46),('6449','2013-06-02','15:40:00',13.1),('6449','2013-06-02','15:45:00',12.8),('6449','2013-06-02','15:50:00',10.13),('6449','2013-06-02','15:55:00',7.4),('6449','2013-06-02','16:00:00',6.9),('6449','2013-06-02','16:05:00',7.76),('6449','2013-06-02','16:10:00',7.94),('6449','2013-06-02','16:15:00',6.04),('6449','2013-06-02','16:20:00',4.88),('6449','2013-06-02','16:25:00',4.93),('6449','2013-06-02','16:30:00',4.97),('6449','2013-06-02','16:35:00',5.04),('6449','2013-06-02','16:40:00',4.76),('6449','2013-06-02','16:45:00',3.86),('6449','2013-06-02','16:50:00',3.6),('6449','2013-06-02','16:55:00',3.82),('6449','2013-06-02','17:00:00',3.36),('6449','2013-06-02','17:05:00',3.23),('6449','2013-06-02','17:10:00',3.72),('6449','2013-06-02','17:15:00',3.69),('6449','2013-06-02','17:20:00',3.64),('6449','2013-06-02','17:25:00',3.12),('6449','2013-06-02','17:30:00',3.15),('6449','2013-06-02','17:35:00',3.15),('6449','2013-06-02','17:40:00',3.01),('6449','2013-06-02','17:45:00',2.92),('6449','2013-06-02','17:50:00',2.68),('6449','2013-06-02','17:55:00',2.7),('6449','2013-06-02','18:00:00',2.67),('6449','2013-06-02','18:05:00',2.55),('6449','2013-06-02','18:10:00',2.64),('6449','2013-06-02','18:15:00',2.5),('6449','2013-06-02','18:20:00',2.44),('6449','2013-06-02','18:25:00',2.49),('6449','2013-06-02','18:30:00',2.32),('6449','2013-06-02','18:35:00',2.38),('6449','2013-06-02','18:40:00',2.16),('6449','2013-06-02','18:45:00',2.27),('6449','2013-06-02','18:50:00',2.05),('6449','2013-06-02','18:55:00',2.03),('6449','2013-06-02','19:00:00',1.33),('6449','2013-06-02','19:05:00',1.29),('6449','2013-06-02','19:10:00',1.47),('6449','2013-06-02','19:15:00',1.24),('6449','2013-06-02','19:20:00',1.13),('6449','2013-06-02','19:25:00',1.11),('6449','2013-06-02','19:30:00',1.08),('6449','2013-06-02','19:35:00',1.04),('6449','2013-06-01','06:30:00',1.15),('6449','2013-06-01','06:35:00',1.22),('6449','2013-06-01','06:40:00',1.17),('6449','2013-06-01','06:45:00',1.02),('6449','2013-06-01','06:55:00',1.19),('6449','2013-06-01','07:10:00',1.92),('6449','2013-06-01','07:15:00',2.86),('6449','2013-06-01','07:20:00',3.17),('6449','2013-06-01','07:25:00',3.7),('6449','2013-06-01','07:30:00',4.42),('6449','2013-06-01','07:35:00',3.41),('6449','2013-06-01','07:40:00',3.84),('6449','2013-06-01','07:45:00',5.51),('6449','2013-06-01','07:50:00',4.88),('6449','2013-06-01','07:55:00',5.23),('6449','2013-06-01','08:00:00',4.43),('6449','2013-06-01','08:05:00',4.07),('6449','2013-06-01','08:10:00',3.47),('6449','2013-06-01','08:15:00',2.92),('6449','2013-06-01','08:20:00',6.49),('6449','2013-06-01','08:25:00',4.9),('6449','2013-06-01','08:30:00',3.34),('6449','2013-06-01','08:35:00',4.19),('6449','2013-06-01','08:40:00',4.66),('6449','2013-06-01','08:45:00',6.25),('6449','2013-06-01','08:50:00',3.87),('6449','2013-06-01','08:55:00',5.76),('6449','2013-06-01','09:00:00',5.5),('6449','2013-06-01','09:05:00',4.66),('6449','2013-06-01','09:10:00',7.09),('6449','2013-06-01','09:15:00',9.73),('6449','2013-06-01','09:20:00',10.22),('6449','2013-06-01','09:25:00',9.04),('6449','2013-06-01','09:30:00',14.11),('6449','2013-06-01','09:35:00',6.83),('6449','2013-06-01','09:40:00',3.84),('6449','2013-06-01','09:45:00',4.78),('6449','2013-06-01','09:50:00',6.13),('6449','2013-06-01','09:55:00',6.14),('6449','2013-06-01','10:00:00',5.68),('6449','2013-06-01','10:05:00',4.48),('6449','2013-06-01','10:10:00',3.25),('6449','2013-06-01','10:15:00',2.09),('6449','2013-06-01','10:25:00',1.17),('6449','2013-06-01','10:30:00',2.87),('6449','2013-06-01','10:35:00',3.84),('6449','2013-06-01','10:40:00',4.63),('6449','2013-06-01','10:45:00',2.84),('6449','2013-06-01','10:50:00',2.74),('6449','2013-06-01','10:55:00',4.36),('6449','2013-06-01','11:00:00',5.09),('6449','2013-06-01','11:05:00',6.54),('6449','2013-06-01','11:10:00',5.87),('6449','2013-06-01','11:15:00',5.18),('6449','2013-06-01','11:20:00',3.95),('6449','2013-06-01','11:25:00',3.29),('6449','2013-06-01','11:30:00',3.03),('6449','2013-06-01','11:35:00',2.57),('6449','2013-06-01','11:40:00',4.03),('6449','2013-06-01','11:45:00',7.18),('6449','2013-06-01','11:50:00',6.45),('6449','2013-06-01','11:55:00',6.59),('6449','2013-06-01','12:00:00',7.88),('6449','2013-06-01','12:05:00',13.25),('6449','2013-06-01','12:10:00',11.97),('6449','2013-06-01','12:15:00',9.96),('6449','2013-06-01','12:20:00',9.69),('6449','2013-06-01','12:25:00',8.31),('6449','2013-06-01','12:30:00',7.13),('6449','2013-06-01','12:35:00',8.31),('6449','2013-06-01','12:40:00',8.63),('6449','2013-06-01','12:45:00',8.82),('6449','2013-06-01','12:50:00',8.87),('6449','2013-06-01','12:55:00',7.78),('6449','2013-06-01','13:00:00',7.52),('6449','2013-06-01','13:05:00',7.8),('6449','2013-06-01','13:10:00',7.96),('6449','2013-06-01','13:15:00',8.48),('6449','2013-06-01','13:20:00',8.36),('6449','2013-06-01','13:25:00',8.26),('6449','2013-06-01','13:30:00',9.03),('6449','2013-06-01','13:35:00',8.89),('6449','2013-06-01','13:40:00',8.23),('6449','2013-06-01','13:45:00',7.48),('6449','2013-06-01','13:50:00',7.38),('6449','2013-06-01','13:55:00',6.26),('6449','2013-06-01','14:00:00',4.86),('6449','2013-06-01','14:05:00',5.03),('6449','2013-06-01','14:10:00',5.4),('6449','2013-06-01','14:15:00',5.82),('6449','2013-06-01','14:20:00',5.77),('6449','2013-06-01','14:25:00',4.62),('6449','2013-06-01','14:30:00',5.41),('6449','2013-06-01','14:35:00',4.28),('6449','2013-06-01','14:40:00',5.92),('6449','2013-06-01','14:45:00',6.86),('6449','2013-06-01','14:50:00',5.25),('6449','2013-06-01','14:55:00',4.75),('6449','2013-06-01','15:00:00',4.69),('6449','2013-06-01','15:05:00',4.31),('6449','2013-06-01','15:10:00',4.16),('6449','2013-06-01','15:15:00',4.12),('6449','2013-06-01','15:20:00',4.02),('6449','2013-06-01','15:25:00',4.9),('6449','2013-06-01','15:30:00',5.44),('6449','2013-06-01','15:35:00',5.43),('6449','2013-06-01','15:40:00',4.35),('6449','2013-06-01','15:45:00',5.09),('6449','2013-06-01','15:50:00',4.96),('6449','2013-06-01','15:55:00',3.79),('6449','2013-06-01','16:00:00',3.31),('6449','2013-06-01','16:05:00',3.47),('6449','2013-06-01','16:10:00',3.42),('6449','2013-06-01','16:15:00',2.98),('6449','2013-06-01','16:20:00',2.66),('6449','2013-06-01','16:25:00',2.36),('6449','2013-06-01','16:30:00',1.96),('6449','2013-06-01','16:35:00',1.63),('6449','2013-06-01','16:40:00',1.44),('6449','2013-06-01','16:45:00',1.69),('6449','2013-06-01','16:50:00',2.52),('6449','2013-06-01','16:55:00',3.73),('6449','2013-06-01','17:00:00',4.21),('6449','2013-06-01','17:05:00',3.62),('6449','2013-06-01','17:10:00',2.02),('6449','2013-06-01','17:15:00',2.24),('6449','2013-06-01','17:20:00',3.51),('6449','2013-06-01','17:25:00',4.49),('6449','2013-06-01','17:30:00',7.82),('6449','2013-06-01','17:35:00',5.06),('6449','2013-06-01','17:40:00',3.34),('6449','2013-06-01','17:45:00',5.5),('6449','2013-06-01','17:50:00',4.6),('6449','2013-06-01','17:55:00',5.5),('6449','2013-06-01','18:00:00',2.36),('6449','2013-06-01','18:05:00',4.78),('6449','2013-06-01','18:10:00',4.48),('6449','2013-06-01','18:15:00',4.05),('6449','2013-06-01','18:20:00',3.7),('6449','2013-06-01','18:25:00',2.37),('6449','2013-06-01','18:30:00',2.82),('6449','2013-06-01','18:35:00',2.49),('6449','2013-06-01','18:40:00',1.31),('6449','2013-06-01','18:45:00',1.26),('6449','2013-06-01','18:50:00',1.27),('6449','2013-06-01','18:55:00',1.49),('6449','2013-06-01','19:00:00',1.86),('6449','2013-06-01','19:05:00',2.14),('6449','2013-06-01','19:10:00',2.02),('6449','2013-06-01','19:15:00',1.89),('6449','2013-06-01','19:20:00',1.62),('6449','2013-06-01','19:25:00',1.67),('6449','2013-06-01','19:30:00',1.53),('6449','2013-06-01','19:35:00',1.24),('6449','2013-05-31','06:45:00',1.19),('6449','2013-05-31','06:50:00',1.4),('6449','2013-05-31','06:55:00',1.63),('6449','2013-05-31','07:00:00',1.94),('6449','2013-05-31','07:05:00',2.17),('6449','2013-05-31','07:10:00',2.5),('6449','2013-05-31','07:15:00',2.92),('6449','2013-05-31','07:20:00',3.42),('6449','2013-05-31','07:25:00',3.91),('6449','2013-05-31','07:30:00',3.61),('6449','2013-05-31','07:35:00',4.64),('6449','2013-05-31','07:40:00',5.77),('6449','2013-05-31','07:45:00',6.71),('6449','2013-05-31','07:50:00',4.45),('6449','2013-05-31','07:55:00',2.06),('6449','2013-05-31','08:00:00',2.56),('6449','2013-05-31','08:05:00',5.48),('6449','2013-05-31','08:10:00',6.98),('6449','2013-05-31','08:15:00',7.43),('6449','2013-05-31','08:20:00',7.99),('6449','2013-05-31','08:25:00',8.52),('6449','2013-05-31','08:30:00',5.94),('6449','2013-05-31','08:35:00',5.67),('6449','2013-05-31','08:40:00',9.41),('6449','2013-05-31','08:45:00',9.44),('6449','2013-05-31','08:50:00',9.78),('6449','2013-05-31','08:55:00',9.11),('6449','2013-05-31','09:00:00',9.65),('6449','2013-05-31','09:05:00',9.04),('6449','2013-05-31','09:10:00',6.89),('6449','2013-05-31','09:15:00',10.85),('6449','2013-05-31','09:20:00',11.4),('6449','2013-05-31','09:25:00',11.88),('6449','2013-05-31','09:30:00',11.36),('6449','2013-05-31','09:35:00',11.72),('6449','2013-05-31','09:40:00',10.76),('6449','2013-05-31','09:45:00',9.72),('6449','2013-05-31','09:50:00',14.65),('6449','2013-05-31','09:55:00',8.72),('6449','2013-05-31','10:00:00',14.08),('6449','2013-05-31','10:05:00',9.55),('6449','2013-05-31','10:10:00',8.86),('6449','2013-05-31','10:15:00',5.18),('6449','2013-05-31','10:20:00',4.82),('6449','2013-05-31','10:25:00',10.21),('6449','2013-05-31','10:30:00',10.39),('6449','2013-05-31','10:35:00',12.78),('6449','2013-05-31','10:40:00',7.91),('6449','2013-05-31','10:45:00',11.36),('6449','2013-05-31','10:50:00',16.43),('6449','2013-05-31','10:55:00',13.31),('6449','2013-05-31','11:00:00',16.24),('6449','2013-05-31','11:05:00',15.84),('6449','2013-05-31','11:10:00',16.16),('6449','2013-05-31','11:15:00',16.29),('6449','2013-05-31','11:20:00',15.78),('6449','2013-05-31','11:25:00',16.25),('6449','2013-05-31','11:30:00',16.51),('6449','2013-05-31','11:35:00',17.77),('6449','2013-05-31','11:40:00',14),('6449','2013-05-31','11:45:00',4.18),('6449','2013-05-31','11:50:00',9.62),('6449','2013-05-31','11:55:00',7.75),('6449','2013-05-31','12:00:00',4.14),('6449','2013-05-31','12:05:00',7.39),('6449','2013-05-31','12:10:00',13.15),('6449','2013-05-31','12:15:00',13.99),('6449','2013-05-31','12:20:00',13.24),('6449','2013-05-31','12:25:00',11.3),('6449','2013-05-31','12:30:00',7.81),('6449','2013-05-31','12:35:00',5.83),('6449','2013-05-31','12:40:00',4.27),('6449','2013-05-31','12:45:00',3.94),('6449','2013-05-31','12:50:00',4.35),('6449','2013-05-31','12:55:00',4.29),('6449','2013-05-31','13:00:00',4.76),('6449','2013-05-31','13:05:00',6.39),('6449','2013-05-31','13:10:00',7.22),('6449','2013-05-31','13:15:00',12.45),('6449','2013-05-31','13:20:00',14.7),('6449','2013-05-31','13:25:00',8.54),('6449','2013-05-31','13:30:00',5.55),('6449','2013-05-31','13:35:00',6.36),('6449','2013-05-31','13:40:00',6.97),('6449','2013-05-31','13:45:00',7.45),('6449','2013-05-31','13:50:00',8.45),('6449','2013-05-31','13:55:00',7.92),('6449','2013-05-31','14:00:00',7.35),('6449','2013-05-31','14:05:00',7.5),('6449','2013-05-31','14:10:00',7.86),('6449','2013-05-31','14:15:00',7.82),('6449','2013-05-31','14:20:00',9.29),('6449','2013-05-31','14:25:00',8.75),('6449','2013-05-31','14:30:00',2.84),('6449','2013-05-31','14:35:00',1.96),('6449','2013-05-31','14:40:00',2.84),('6449','2013-05-31','14:45:00',3.4),('6449','2013-05-31','14:50:00',7.44),('6449','2013-05-31','14:55:00',7.73),('6449','2013-05-31','15:00:00',5.06),('6449','2013-05-31','15:05:00',5.68),('6449','2013-05-31','15:10:00',4.15),('6449','2013-05-31','15:15:00',3.29),('6449','2013-05-31','15:20:00',4.19),('6449','2013-05-31','15:25:00',4.16),('6449','2013-05-31','15:30:00',4.37),('6449','2013-05-31','15:35:00',5.21),('6449','2013-05-31','15:40:00',8.19),('6449','2013-05-31','15:45:00',5.77),('6449','2013-05-31','15:50:00',3.34),('6449','2013-05-31','15:55:00',4.33),('6449','2013-05-31','16:00:00',5.87),('6449','2013-05-31','16:05:00',6.5),('6449','2013-05-31','16:10:00',5.77),('6449','2013-05-31','16:15:00',5.39),('6449','2013-05-31','16:20:00',5.06),('6449','2013-05-31','16:25:00',5.53),('6449','2013-05-31','16:30:00',5.5),('6449','2013-05-31','16:35:00',5.33),('6449','2013-05-31','16:40:00',5.35),('6449','2013-05-31','16:45:00',4.19),('6449','2013-05-31','16:50:00',3.04),('6449','2013-05-31','16:55:00',3.53),('6449','2013-05-31','17:00:00',3.63),('6449','2013-05-31','17:05:00',3.1),('6449','2013-05-31','17:10:00',2.6),('6449','2013-05-31','17:15:00',2.58),('6449','2013-05-31','17:20:00',2.63),('6449','2013-05-31','17:25:00',2.54),('6449','2013-05-31','17:30:00',2.24),('6449','2013-05-31','17:35:00',2.02),('6449','2013-05-31','17:40:00',1.46),('6449','2013-05-31','17:50:00',1.16),('6449','2013-05-31','17:55:00',2.08),('6449','2013-05-31','18:00:00',2.7),('6449','2013-05-31','18:05:00',2.25),('6449','2013-05-31','18:10:00',1.92),('6449','2013-05-31','18:15:00',1.8),('6449','2013-05-31','18:20:00',1.53),('6449','2013-05-31','18:25:00',1.44),('6449','2013-05-31','18:30:00',1.37),('6449','2013-05-31','18:35:00',1.48),('6449','2013-05-31','18:40:00',2.04),('6449','2013-05-31','18:45:00',1.77),('6449','2013-05-31','18:50:00',1.46),('6449','2013-05-31','18:55:00',1.46),('6449','2013-05-31','19:00:00',1.46),('6449','2013-05-31','19:05:00',1.28),('6449','2013-05-31','19:35:00',1.16),('6449','2013-05-30','06:55:00',1),('6449','2013-05-30','07:00:00',1.72),('6449','2013-05-30','07:05:00',2.49),('6449','2013-05-30','07:10:00',2.69),('6449','2013-05-30','07:15:00',3.48),('6449','2013-05-30','07:20:00',4.86),('6449','2013-05-30','07:25:00',4.49),('6449','2013-05-30','07:30:00',2.45),('6449','2013-05-30','07:35:00',3.75),('6449','2013-05-30','07:40:00',5.15),('6449','2013-05-30','07:45:00',4.47),('6449','2013-05-30','07:50:00',5.24),('6449','2013-05-30','07:55:00',5.55),('6449','2013-05-30','08:00:00',6.03),('6449','2013-05-30','08:05:00',4.92),('6449','2013-05-30','08:10:00',2.06),('6449','2013-05-30','08:15:00',6.77),('6449','2013-05-30','08:20:00',8.84),('6449','2013-05-30','08:25:00',5.89),('6449','2013-05-30','08:30:00',7.52),('6449','2013-05-30','08:35:00',8.67),('6449','2013-05-30','08:40:00',8.83),('6449','2013-05-30','08:45:00',8.97),('6449','2013-05-30','08:50:00',9.24),('6449','2013-05-30','08:55:00',9.84),('6449','2013-05-30','09:00:00',10.11),('6449','2013-05-30','09:05:00',10.49),('6449','2013-05-30','09:10:00',10.5),('6449','2013-05-30','09:15:00',11.29),('6449','2013-05-30','09:20:00',10.74),('6449','2013-05-30','09:25:00',10.72),('6449','2013-05-30','09:30:00',13.27),('6449','2013-05-30','09:35:00',7.6),('6449','2013-05-30','09:40:00',5.86),('6449','2013-05-30','09:45:00',9.74),('6449','2013-05-30','09:50:00',13.63),('6449','2013-05-30','09:55:00',12.89),('6449','2013-05-30','10:00:00',14.34),('6449','2013-05-30','10:05:00',12.66),('6449','2013-05-30','10:10:00',12.56),('6449','2013-05-30','10:15:00',15.14),('6449','2013-05-30','10:20:00',16.15),('6449','2013-05-30','10:25:00',13.75),('6449','2013-05-30','10:30:00',11.5),('6449','2013-05-30','10:35:00',9.76),('6449','2013-05-30','10:40:00',15.05),('6449','2013-05-30','10:45:00',16.55),('6449','2013-05-30','10:50:00',16.95),('6449','2013-05-30','10:55:00',14.94),('6449','2013-05-30','11:00:00',15.46),('6449','2013-05-30','11:05:00',16.17),('6449','2013-05-30','11:10:00',16.21),('6449','2013-05-30','11:15:00',14.99),('6449','2013-05-30','11:20:00',16.46),('6449','2013-05-30','11:25:00',15.43),('6449','2013-05-30','11:30:00',16.7),('6449','2013-05-30','11:35:00',16.76),('6449','2013-05-30','11:40:00',16.13),('6449','2013-05-30','11:45:00',15.21),('6449','2013-05-30','11:50:00',13.2),('6449','2013-05-30','11:55:00',19.09),('6449','2013-05-30','12:00:00',14.26),('6449','2013-05-30','12:05:00',17.54),('6449','2013-05-30','12:10:00',17.37),('6449','2013-05-30','12:15:00',17.44),('6449','2013-05-30','12:20:00',17.33),('6449','2013-05-30','12:25:00',17.2),('6449','2013-05-30','12:30:00',17.27),('6449','2013-05-30','12:35:00',17.5),('6449','2013-05-30','12:40:00',17.32),('6449','2013-05-30','12:45:00',17.34),('6449','2013-05-30','12:50:00',17.31),('6449','2013-05-30','12:55:00',17.3),('6449','2013-05-30','13:00:00',15.12),('6449','2013-05-30','13:05:00',17.26),('6449','2013-05-30','13:10:00',17.58),('6449','2013-05-30','13:15:00',12.21),('6449','2013-05-30','13:20:00',8.81),('6449','2013-05-30','13:25:00',12.49),('6449','2013-05-30','13:30:00',17.69),('6449','2013-05-30','13:35:00',19.27),('6449','2013-05-30','13:40:00',11.7),('6449','2013-05-30','13:45:00',7.95),('6449','2013-05-30','13:50:00',10.06),('6449','2013-05-30','13:55:00',16.7),('6449','2013-05-30','14:00:00',18.56),('6449','2013-05-30','14:05:00',16.98),('6449','2013-05-30','14:10:00',8.39),('6449','2013-05-30','14:15:00',10.37),('6449','2013-05-30','14:20:00',10.84),('6449','2013-05-30','14:25:00',11.61),('6449','2013-05-30','14:30:00',11.75),('6449','2013-05-30','14:35:00',12.95),('6449','2013-05-30','14:40:00',15.5),('6449','2013-05-30','14:45:00',10.81),('6449','2013-05-30','14:50:00',8.41),('6449','2013-05-30','14:55:00',9.97),('6449','2013-05-30','15:00:00',8.38),('6449','2013-05-30','15:05:00',7.37),('6449','2013-05-30','15:10:00',12.92),('6449','2013-05-30','15:15:00',8.98),('6449','2013-05-30','15:20:00',7.4),('6449','2013-05-30','15:25:00',8.04),('6449','2013-05-30','15:30:00',8.48),('6449','2013-05-30','15:35:00',6.23),('6449','2013-05-30','15:40:00',5.62),('6449','2013-05-30','15:45:00',9),('6449','2013-05-30','15:50:00',8.82),('6449','2013-05-30','15:55:00',6.87),('6449','2013-05-30','16:00:00',7.81),('6449','2013-05-30','16:05:00',12.03),('6449','2013-05-30','16:10:00',15.29),('6449','2013-05-30','16:15:00',14.26),('6449','2013-05-30','16:20:00',12.66),('6449','2013-05-30','16:25:00',12.59),('6449','2013-05-30','16:30:00',8.88),('6449','2013-05-30','16:35:00',5.82),('6449','2013-05-30','16:40:00',3.55),('6449','2013-05-30','16:45:00',2.37),('6449','2013-05-30','16:50:00',1.95),('6449','2013-05-30','16:55:00',3.25),('6449','2013-05-30','17:00:00',7.06),('6449','2013-05-30','17:05:00',8.59),('6449','2013-05-30','17:10:00',6.98),('6449','2013-05-30','17:15:00',8.11),('6449','2013-05-30','17:20:00',4.82),('6449','2013-05-30','17:25:00',6.32),('6449','2013-05-30','17:30:00',8.2),('6449','2013-05-30','17:35:00',7.24),('6449','2013-05-30','17:40:00',4.02),('6449','2013-05-30','17:45:00',2.61),('6449','2013-05-30','17:50:00',4.23),('6449','2013-05-30','17:55:00',7.8),('6449','2013-05-30','18:00:00',5.64),('6449','2013-05-30','18:05:00',2.05),('6449','2013-05-30','18:10:00',3.72),('6449','2013-05-30','18:15:00',2.33),('6449','2013-05-30','18:20:00',1.44),('6449','2013-05-30','18:25:00',1.22),('6449','2013-05-30','18:30:00',1.06),('6449','2013-05-30','18:35:00',1.03),('6449','2013-05-30','19:00:00',1.37),('6449','2013-05-30','19:05:00',1.8),('6449','2013-05-30','19:10:00',1.96),('6449','2013-05-30','19:15:00',1.07),('6449','2013-05-29','06:45:00',1.06),('6449','2013-05-29','06:50:00',1.12),('6449','2013-05-29','06:55:00',1.51),('6449','2013-05-29','07:00:00',1.77),('6449','2013-05-29','07:05:00',2.03),('6449','2013-05-29','07:10:00',2.35),('6449','2013-05-29','07:15:00',2.67),('6449','2013-05-29','07:20:00',2.98),('6449','2013-05-29','07:25:00',3.31),('6449','2013-05-29','07:30:00',3.64),('6449','2013-05-29','07:35:00',3.99),('6449','2013-05-29','07:40:00',4.36),('6449','2013-05-29','07:45:00',4.72),('6449','2013-05-29','07:50:00',5.09),('6449','2013-05-29','07:55:00',5.43),('6449','2013-05-29','08:00:00',5.82),('6449','2013-05-29','08:05:00',6.13),('6449','2013-05-29','08:10:00',6.58),('6449','2013-05-29','08:15:00',6.97),('6449','2013-05-29','08:20:00',7.37),('6449','2013-05-29','08:25:00',7.73),('6449','2013-05-29','08:30:00',8.02),('6449','2013-05-29','08:35:00',8.35),('6449','2013-05-29','08:40:00',8.73),('6449','2013-05-29','08:45:00',8.97),('6449','2013-05-29','08:50:00',8.99),('6449','2013-05-29','08:55:00',9.39),('6449','2013-05-29','09:00:00',9.88),('6449','2013-05-29','09:05:00',10.12),('6449','2013-05-29','09:10:00',10.53),('6449','2013-05-29','09:15:00',10.73),('6449','2013-05-29','09:20:00',10.84),('6449','2013-05-29','09:25:00',10.92),('6449','2013-05-29','09:30:00',11.28),('6449','2013-05-29','09:35:00',11.29),('6449','2013-05-29','09:40:00',11.92),('6449','2013-05-29','09:45:00',12.41),('6449','2013-05-29','09:50:00',12.58),('6449','2013-05-29','09:55:00',12.88),('6449','2013-05-29','10:00:00',13.03),('6449','2013-05-29','10:05:00',13.18),('6449','2013-05-29','10:10:00',13.38),('6449','2013-05-29','10:15:00',13.57),('6449','2013-05-29','10:20:00',13.8),('6449','2013-05-29','10:25:00',13.98),('6449','2013-05-29','10:30:00',14.26),('6449','2013-05-29','10:35:00',14.34),('6449','2013-05-29','10:40:00',14.68),('6449','2013-05-29','10:45:00',14.8),('6449','2013-05-29','10:50:00',15.01),('6449','2013-05-29','10:55:00',15.18),('6449','2013-05-29','11:00:00',15.36),('6449','2013-05-29','11:05:00',15.17),('6449','2013-05-29','11:10:00',15.62),('6449','2013-05-29','11:15:00',15.93),('6449','2013-05-29','11:20:00',16.15),('6449','2013-05-29','11:25:00',16.31),('6449','2013-05-29','11:30:00',16.37),('6449','2013-05-29','11:35:00',16.49),('6449','2013-05-29','11:40:00',16.91),('6449','2013-05-29','11:45:00',16.95),('6449','2013-05-29','11:50:00',16.5),('6449','2013-05-29','11:55:00',16.21),('6449','2013-05-29','12:00:00',16.45),('6449','2013-05-29','12:05:00',16.83),('6449','2013-05-29','12:10:00',17.1),('6449','2013-05-29','12:15:00',17.1),('6449','2013-05-29','12:20:00',17.1),('6449','2013-05-29','12:25:00',16.89),('6449','2013-05-29','12:30:00',17.17),('6449','2013-05-29','12:35:00',17.17),('6449','2013-05-29','12:40:00',17.18),('6449','2013-05-29','12:45:00',17.21),('6449','2013-05-29','12:50:00',17.1),('6449','2013-05-29','12:55:00',16.9),('6449','2013-05-29','13:00:00',17.14),('6449','2013-05-29','13:05:00',17.2),('6449','2013-05-29','13:10:00',17.3),('6449','2013-05-29','13:15:00',17.4),('6449','2013-05-29','13:20:00',17.34),('6449','2013-05-29','13:25:00',17.5),('6449','2013-05-29','13:30:00',17.32),('6449','2013-05-29','13:35:00',17.26),('6449','2013-05-29','13:40:00',17.18),('6449','2013-05-29','13:45:00',16.92),('6449','2013-05-29','13:50:00',15.96),('6449','2013-05-29','13:55:00',16.52),('6449','2013-05-29','14:00:00',16.55),('6449','2013-05-29','14:05:00',16.47),('6449','2013-05-29','14:10:00',16.28),('6449','2013-05-29','14:15:00',16.4),('6449','2013-05-29','14:20:00',16.02),('6449','2013-05-29','14:25:00',15.43),('6449','2013-05-29','14:30:00',15.93),('6449','2013-05-29','14:35:00',11.7),('6449','2013-05-29','14:40:00',15.26),('6449','2013-05-29','14:45:00',16.69),('6449','2013-05-29','14:50:00',8.95),('6449','2013-05-29','14:55:00',10.86),('6449','2013-05-29','15:00:00',8.02),('6449','2013-05-29','15:05:00',16.88),('6449','2013-05-29','15:10:00',15.32),('6449','2013-05-29','15:15:00',14.79),('6449','2013-05-29','15:20:00',14.8),('6449','2013-05-29','15:25:00',14.86),('6449','2013-05-29','15:30:00',14.22),('6449','2013-05-29','15:35:00',14.17),('6449','2013-05-29','15:40:00',11.12),('6449','2013-05-29','15:45:00',6.61),('6449','2013-05-29','15:50:00',9.41),('6449','2013-05-29','15:55:00',7.44),('6449','2013-05-29','16:00:00',5.91),('6449','2013-05-29','16:05:00',6.3),('6449','2013-05-29','16:10:00',8.9),('6449','2013-05-29','16:15:00',6.4),('6449','2013-05-29','16:20:00',5.85),('6449','2013-05-29','16:25:00',5.25),('6449','2013-05-29','16:30:00',4.83),('6449','2013-05-29','16:35:00',3.96),('6449','2013-05-29','16:40:00',4.72),('6449','2013-05-29','16:45:00',6.13),('6449','2013-05-29','16:50:00',5.93),('6449','2013-05-29','16:55:00',5.36),('6449','2013-05-29','17:00:00',5.54),('6449','2013-05-29','17:05:00',5.11),('6449','2013-05-29','17:10:00',6.86),('6449','2013-05-29','17:15:00',4.64),('6449','2013-05-29','17:20:00',2.48),('6449','2013-05-29','17:25:00',1.96),('6449','2013-05-29','17:30:00',2.08),('6449','2013-05-29','17:35:00',1.92),('6449','2013-05-29','17:45:00',1.89),('6449','2013-05-29','17:50:00',1.59),('6449','2013-05-29','17:55:00',1.12),('6449','2013-05-29','18:00:00',1.48),('6449','2013-05-29','18:05:00',1.51),('6449','2013-05-29','18:10:00',1.17),('6449','2013-05-29','18:15:00',1.55),('6449','2013-05-29','18:20:00',2.24),('6449','2013-05-29','18:25:00',3.1),('6449','2013-05-29','18:30:00',4.42),('6449','2013-05-29','18:35:00',3.04),('6449','2013-05-29','18:40:00',2.53),('6449','2013-05-29','18:45:00',1.91),('6449','2013-05-29','18:50:00',1.5),('6449','2013-05-29','18:55:00',2.34),('6449','2013-05-29','19:00:00',1.54),('6449','2013-05-29','19:05:00',1.26),('6449','2013-05-29','19:10:00',1.54),('6449','2013-05-29','19:15:00',1.68),('6449','2013-05-29','19:20:00',1.47),('6449','2013-05-29','19:25:00',1.24),('6449','2013-05-28','06:40:00',1.14),('6449','2013-05-28','06:45:00',1.52),('6449','2013-05-28','06:50:00',1.91),('6449','2013-05-28','06:55:00',2.36),('6449','2013-05-28','07:00:00',2.8),('6449','2013-05-28','07:05:00',3.06),('6449','2013-05-28','07:10:00',2.67),('6449','2013-05-28','07:15:00',2.68),('6449','2013-05-28','07:20:00',2.71),('6449','2013-05-28','07:25:00',2.57),('6449','2013-05-28','07:30:00',3.74),('6449','2013-05-28','07:35:00',3.56),('6449','2013-05-28','07:40:00',3.2),('6449','2013-05-28','07:45:00',3.82),('6449','2013-05-28','07:50:00',4.34),('6449','2013-05-28','07:55:00',5.65),('6449','2013-05-28','08:00:00',5.93),('6449','2013-05-28','08:05:00',3.81),('6449','2013-05-28','08:10:00',4.41),('6449','2013-05-28','08:15:00',5.41),('6449','2013-05-28','08:20:00',7.45),('6449','2013-05-28','08:25:00',7.56),('6449','2013-05-28','08:30:00',7.1),('6449','2013-05-28','08:35:00',6.74),('6449','2013-05-28','08:40:00',8.35),('6449','2013-05-28','08:45:00',9.11),('6449','2013-05-28','08:50:00',8.6),('6449','2013-05-28','08:55:00',8.54),('6449','2013-05-28','09:00:00',8.02),('6449','2013-05-28','09:05:00',7.89),('6449','2013-05-28','09:10:00',5.83),('6449','2013-05-28','09:15:00',8.76),('6449','2013-05-28','09:20:00',11.01),('6449','2013-05-28','09:25:00',10.82),('6449','2013-05-28','09:30:00',10.38),('6449','2013-05-28','09:35:00',8.32),('6449','2013-05-28','09:40:00',9.12),('6449','2013-05-28','09:45:00',9.28),('6449','2013-05-28','09:50:00',10),('6449','2013-05-28','09:55:00',8.26),('6449','2013-05-28','10:00:00',7),('6449','2013-05-28','10:05:00',8.19),('6449','2013-05-28','10:10:00',10.76),('6449','2013-05-28','10:15:00',9.66),('6449','2013-05-28','10:20:00',10.4),('6449','2013-05-28','10:25:00',7.24),('6449','2013-05-28','10:30:00',10.6),('6449','2013-05-28','10:35:00',11.44),('6449','2013-05-28','10:40:00',10.17),('6449','2013-05-28','10:45:00',10.25),('6449','2013-05-28','10:50:00',10.69),('6449','2013-05-28','10:55:00',5.41),('6449','2013-05-28','11:00:00',4.73),('6449','2013-05-28','11:05:00',6.06),('6449','2013-05-28','11:10:00',13.45),('6449','2013-05-28','11:15:00',15.41),('6449','2013-05-28','11:20:00',14.95),('6449','2013-05-28','11:25:00',14.53),('6449','2013-05-28','11:30:00',16.09),('6449','2013-05-28','11:35:00',6.41),('6449','2013-05-28','11:40:00',7.12),('6449','2013-05-28','11:45:00',8.5),('6449','2013-05-28','11:50:00',7.2),('6449','2013-05-28','11:55:00',7.36),('6449','2013-05-28','12:00:00',7.6),('6449','2013-05-28','12:05:00',8.31),('6449','2013-05-28','12:10:00',7.84),('6449','2013-05-28','12:15:00',6.21),('6449','2013-05-28','12:20:00',6.95),('6449','2013-05-28','12:25:00',6.45),('6449','2013-05-28','12:30:00',7.38),('6449','2013-05-28','12:35:00',6.81),('6449','2013-05-28','12:40:00',14.17),('6449','2013-05-28','12:45:00',16.67),('6449','2013-05-28','12:50:00',7.86),('6449','2013-05-28','12:55:00',8.04),('6449','2013-05-28','13:00:00',9.48),('6449','2013-05-28','13:05:00',11.65),('6449','2013-05-28','13:10:00',13.31),('6449','2013-05-28','13:15:00',14.07),('6449','2013-05-28','13:20:00',12.3),('6449','2013-05-28','13:25:00',12.07),('6449','2013-05-28','13:30:00',11.68),('6449','2013-05-28','13:35:00',10.93),('6449','2013-05-28','13:40:00',7.79),('6449','2013-05-28','13:45:00',11),('6449','2013-05-28','13:50:00',10.67),('6449','2013-05-28','13:55:00',7.95),('6449','2013-05-28','14:00:00',8.3),('6449','2013-05-28','14:05:00',13.18),('6449','2013-05-28','14:10:00',14.33),('6449','2013-05-28','14:15:00',14.12),('6449','2013-05-28','14:20:00',13.62),('6449','2013-05-28','14:25:00',12.67),('6449','2013-05-28','14:30:00',9.5),('6449','2013-05-28','14:35:00',15.7),('6449','2013-05-28','14:40:00',11.2),('6449','2013-05-28','14:45:00',16.24),('6449','2013-05-28','14:50:00',12.34),('6449','2013-05-28','14:55:00',6.95),('6449','2013-05-28','15:00:00',6.23),('6449','2013-05-28','15:05:00',6.45),('6449','2013-05-28','15:10:00',7.37),('6449','2013-05-28','15:15:00',8.8),('6449','2013-05-28','15:20:00',12.54),('6449','2013-05-28','15:25:00',10.86),('6449','2013-05-28','15:30:00',11.86),('6449','2013-05-28','15:35:00',10.53),('6449','2013-05-28','15:40:00',6.5),('6449','2013-05-28','15:45:00',4.45),('6449','2013-05-28','15:50:00',3.95),('6449','2013-05-28','15:55:00',4.18),('6449','2013-05-28','16:00:00',3.63),('6449','2013-05-28','16:05:00',3.81),('6449','2013-05-28','16:10:00',4.07),('6449','2013-05-28','16:15:00',3.87),('6449','2013-05-28','16:20:00',3.68),('6449','2013-05-28','16:25:00',3.91),('6449','2013-05-28','16:30:00',4.3),('6449','2013-05-28','16:35:00',4.97),('6449','2013-05-28','16:40:00',4.79),('6449','2013-05-28','16:45:00',4.52),('6449','2013-05-28','16:50:00',4.48),('6449','2013-05-28','16:55:00',5.29),('6449','2013-05-28','17:00:00',6.17),('6449','2013-05-28','17:05:00',8.25),('6449','2013-05-28','17:10:00',5.31),('6449','2013-05-28','17:15:00',6.03),('6449','2013-05-28','17:20:00',6.45),('6449','2013-05-28','17:25:00',5.02),('6449','2013-05-28','17:30:00',5.94),('6449','2013-05-28','17:35:00',4.02),('6449','2013-05-28','17:40:00',3.59),('6449','2013-05-28','17:45:00',3.49),('6449','2013-05-28','17:50:00',3.54),('6449','2013-05-28','17:55:00',3.48),('6449','2013-05-28','18:00:00',3.38),('6449','2013-05-28','18:05:00',2.78),('6449','2013-05-28','18:10:00',2.69),('6449','2013-05-28','18:15:00',4.45),('6449','2013-05-28','18:20:00',3.64),('6449','2013-05-28','18:25:00',2.03),('6449','2013-05-28','18:30:00',1.8),('6449','2013-05-28','18:35:00',2.21),('6449','2013-05-28','18:40:00',1.18),('6449','2013-05-28','18:45:00',1.17),('6449','2013-05-28','18:50:00',1.05),('6449','2013-05-28','19:05:00',1.02),('6449','2013-05-28','19:10:00',1.17),('6449','2013-05-28','19:15:00',1.04),('6449','2013-05-27','06:55:00',1.04),('6449','2013-05-27','07:00:00',1.38),('6449','2013-05-27','07:05:00',1.39),('6449','2013-05-27','07:10:00',1.03),('6449','2013-05-27','07:15:00',1.1),('6449','2013-05-27','07:20:00',1.03),('6449','2013-05-27','07:25:00',1.11),('6449','2013-05-27','07:30:00',1.29),('6449','2013-05-27','07:35:00',1.11),('6449','2013-05-27','07:40:00',1.23),('6449','2013-05-27','07:45:00',3.9),('6449','2013-05-27','07:50:00',5.43),('6449','2013-05-27','07:55:00',5.73),('6449','2013-05-27','08:00:00',6.15),('6449','2013-05-27','08:05:00',6.49),('6449','2013-05-27','08:10:00',6.88),('6449','2013-05-27','08:15:00',7.22),('6449','2013-05-27','08:20:00',7.53),('6449','2013-05-27','08:25:00',7.87),('6449','2013-05-27','08:30:00',8.18),('6449','2013-05-27','08:35:00',8.51),('6449','2013-05-27','08:40:00',8.85),('6449','2013-05-27','08:45:00',9.19),('6449','2013-05-27','08:50:00',9.54),('6449','2013-05-27','08:55:00',9.75),('6449','2013-05-27','09:00:00',9.92),('6449','2013-05-27','09:05:00',10.37),('6449','2013-05-27','09:10:00',10.63),('6449','2013-05-27','09:15:00',10.79),('6449','2013-05-27','09:20:00',11.07),('6449','2013-05-27','09:25:00',11.3),('6449','2013-05-27','09:30:00',11.46),('6449','2013-05-27','09:35:00',11.68),('6449','2013-05-27','09:40:00',12.06),('6449','2013-05-27','09:45:00',12.15),('6449','2013-05-27','09:50:00',12.41),('6449','2013-05-27','09:55:00',12.84),('6449','2013-05-27','10:00:00',13.32),('6449','2013-05-27','10:05:00',13.31),('6449','2013-05-27','10:10:00',13.62),('6449','2013-05-27','10:15:00',13.7),('6449','2013-05-27','10:20:00',13.94),('6449','2013-05-27','10:25:00',14.19),('6449','2013-05-27','10:30:00',14.28),('6449','2013-05-27','10:35:00',14.48),('6449','2013-05-27','10:40:00',15.2),('6449','2013-05-27','10:45:00',15.14),('6449','2013-05-27','10:50:00',15.77),('6449','2013-05-27','10:55:00',15.09),('6449','2013-05-27','11:00:00',14.06),('6449','2013-05-27','11:05:00',8.47),('6449','2013-05-27','11:10:00',10.83),('6449','2013-05-27','11:15:00',11.37),('6449','2013-05-27','11:20:00',9.16),('6449','2013-05-27','11:25:00',17.38),('6449','2013-05-27','11:30:00',17.1),('6449','2013-05-27','11:35:00',17.04),('6449','2013-05-27','11:40:00',16.39),('6449','2013-05-27','11:45:00',16.32),('6449','2013-05-27','11:50:00',16.4),('6449','2013-05-27','11:55:00',16.43),('6449','2013-05-27','12:00:00',16.68),('6449','2013-05-27','12:05:00',16.52),('6449','2013-05-27','12:10:00',16.95),('6449','2013-05-27','12:15:00',16.95),('6449','2013-05-27','12:20:00',16.97),('6449','2013-05-27','12:25:00',16.66),('6449','2013-05-27','12:30:00',16.39),('6449','2013-05-27','12:35:00',16.62),('6449','2013-05-27','12:40:00',16.8),('6449','2013-05-27','12:45:00',16.96),('6449','2013-05-27','12:50:00',16.8),('6449','2013-05-27','12:55:00',16.55),('6449','2013-05-27','13:00:00',16.23),('6449','2013-05-27','13:05:00',16.34),('6449','2013-05-27','13:10:00',17.3),('6449','2013-05-27','13:15:00',16.66),('6449','2013-05-27','13:20:00',15.18),('6449','2013-05-27','13:25:00',16.67),('6449','2013-05-27','13:30:00',17.1),('6449','2013-05-27','13:35:00',16.94),('6449','2013-05-27','13:40:00',16.62),('6449','2013-05-27','13:45:00',16.52),('6449','2013-05-27','13:50:00',16.72),('6449','2013-05-27','13:55:00',16.54),('6449','2013-05-27','14:00:00',16.52),('6449','2013-05-27','14:05:00',16),('6449','2013-05-27','14:10:00',16.16),('6449','2013-05-27','14:15:00',16.14),('6449','2013-05-27','14:20:00',16.04),('6449','2013-05-27','14:25:00',16.19),('6449','2013-05-27','14:30:00',16.04),('6449','2013-05-27','14:35:00',15.56),('6449','2013-05-27','14:40:00',15.02),('6449','2013-05-27','14:45:00',11.1),('6449','2013-05-27','14:50:00',12.94),('6449','2013-05-27','14:55:00',16.78),('6449','2013-05-27','15:00:00',13.26),('6449','2013-05-27','15:05:00',10),('6449','2013-05-27','15:10:00',16.36),('6449','2013-05-27','15:15:00',14.82),('6449','2013-05-27','15:20:00',14.94),('6449','2013-05-27','15:25:00',12.66),('6449','2013-05-27','15:30:00',10.03),('6449','2013-05-27','15:35:00',11.23),('6449','2013-05-27','15:40:00',9.93),('6449','2013-05-27','15:45:00',12.88),('6449','2013-05-27','15:50:00',11.89),('6449','2013-05-27','15:55:00',10.64),('6449','2013-05-27','16:00:00',9.67),('6449','2013-05-27','16:05:00',13.17),('6449','2013-05-27','16:10:00',13.5),('6449','2013-05-27','16:15:00',11.04),('6449','2013-05-27','16:20:00',8.3),('6449','2013-05-27','16:25:00',8.63),('6449','2013-05-27','16:30:00',10.05),('6449','2013-05-27','16:35:00',6.14),('6449','2013-05-27','16:40:00',9.37),('6449','2013-05-27','16:45:00',8.59),('6449','2013-05-27','16:50:00',5.35),('6449','2013-05-27','16:55:00',4.76),('6449','2013-05-27','17:00:00',4.55),('6449','2013-05-27','17:05:00',4.34),('6449','2013-05-27','17:10:00',4.24),('6449','2013-05-27','17:15:00',4.52),('6449','2013-05-27','17:20:00',4.49),('6449','2013-05-27','17:25:00',3.92),('6449','2013-05-27','17:30:00',4.89),('6449','2013-05-27','17:35:00',4.24),('6449','2013-05-27','17:40:00',3.42),('6449','2013-05-27','17:45:00',3.28),('6449','2013-05-27','17:50:00',3.29),('6449','2013-05-27','17:55:00',3.3),('6449','2013-05-27','18:00:00',3.26),('6449','2013-05-27','18:05:00',3.27),('6449','2013-05-27','18:10:00',5.02),('6449','2013-05-27','18:15:00',6.07),('6449','2013-05-27','18:20:00',4.86),('6449','2013-05-27','18:25:00',4.4),('6449','2013-05-27','18:30:00',3.63),('6449','2013-05-27','18:35:00',2.81),('6449','2013-05-27','18:40:00',2.51),('6449','2013-05-27','18:45:00',3),('6449','2013-05-27','18:50:00',2.97),('6449','2013-05-27','18:55:00',2.39),('6449','2013-05-27','19:00:00',1.76),('6449','2013-05-27','19:05:00',1.34),('6449','2013-05-27','19:10:00',1.22),('6449','2013-05-27','19:15:00',1.14),('6449','2013-05-27','19:20:00',1.01),('6449','2013-05-26','06:50:00',1.33),('6449','2013-05-26','06:55:00',1.07),('6449','2013-05-26','07:05:00',1.77),('6449','2013-05-26','07:10:00',1.83),('6449','2013-05-26','07:15:00',2.77),('6449','2013-05-26','07:20:00',4.6),('6449','2013-05-26','07:50:00',1.01),('6449','2013-05-26','07:55:00',1.54),('6449','2013-05-26','08:00:00',1.15),('6449','2013-05-26','08:05:00',2.17),('6449','2013-05-26','08:10:00',2.59),('6449','2013-05-26','08:15:00',2.87),('6449','2013-05-26','08:20:00',4.36),('6449','2013-05-26','08:25:00',2.66),('6449','2013-05-26','08:30:00',2.43),('6449','2013-05-26','08:35:00',3.99),('6449','2013-05-26','08:40:00',2.32),('6449','2013-05-26','08:55:00',2.16),('6449','2013-05-26','09:00:00',11.1),('6449','2013-05-26','09:05:00',11.07),('6449','2013-05-26','09:10:00',11.28),('6449','2013-05-26','09:15:00',11.41),('6449','2013-05-26','09:20:00',11.76),('6449','2013-05-26','09:25:00',12.1),('6449','2013-05-26','09:30:00',12.37),('6449','2013-05-26','09:35:00',12.55),('6449','2013-05-26','09:40:00',12.87),('6449','2013-05-26','09:45:00',13.16),('6449','2013-05-26','09:50:00',13.57),('6449','2013-05-26','09:55:00',13.74),('6449','2013-05-26','10:00:00',13.98),('6449','2013-05-26','10:05:00',14.32),('6449','2013-05-26','10:10:00',14.49),('6449','2013-05-26','10:15:00',14.65),('6449','2013-05-26','10:20:00',14.93),('6449','2013-05-26','10:25:00',15.06),('6449','2013-05-26','10:30:00',15.03),('6449','2013-05-26','10:35:00',15.63),('6449','2013-05-26','10:40:00',15.85),('6449','2013-05-26','10:45:00',16.01),('6449','2013-05-26','10:50:00',16.16),('6449','2013-05-26','10:55:00',16.26),('6449','2013-05-26','11:00:00',15.94),('6449','2013-05-26','11:05:00',16.63),('6449','2013-05-26','11:10:00',16.76),('6449','2013-05-26','11:15:00',16.85),('6449','2013-05-26','11:20:00',16.93),('6449','2013-05-26','11:25:00',17.05),('6449','2013-05-26','11:30:00',17.19),('6449','2013-05-26','11:35:00',17.36),('6449','2013-05-26','11:40:00',17.49),('6449','2013-05-26','11:45:00',17.61),('6449','2013-05-26','11:50:00',17.65),('6449','2013-05-26','11:55:00',17.76),('6449','2013-05-26','12:00:00',17.77),('6449','2013-05-26','12:05:00',17.91),('6449','2013-05-26','12:10:00',17.89),('6449','2013-05-26','12:15:00',17.46),('6449','2013-05-26','12:20:00',17.9),('6449','2013-05-26','12:25:00',17.94),('6449','2013-05-26','12:30:00',17.96),('6449','2013-05-26','12:35:00',17.99),('6449','2013-05-26','12:40:00',18.16),('6449','2013-05-26','12:45:00',17.69),('6449','2013-05-26','12:50:00',18),('6449','2013-05-26','12:55:00',18.22),('6449','2013-05-26','13:00:00',18.57),('6449','2013-05-26','13:05:00',18.46),('6449','2013-05-26','13:10:00',19.02),('6449','2013-05-26','13:15:00',19.73),('6449','2013-05-26','13:20:00',18.16),('6449','2013-05-26','13:25:00',17.7),('6449','2013-05-26','13:30:00',17.62),('6449','2013-05-26','13:35:00',17.62),('6449','2013-05-26','13:40:00',17.52),('6449','2013-05-26','13:45:00',17.48),('6449','2013-05-26','13:50:00',17.39),('6449','2013-05-26','13:55:00',17.35),('6449','2013-05-26','14:00:00',16.85),('6449','2013-05-26','14:05:00',17.21),('6449','2013-05-26','14:10:00',17.08),('6449','2013-05-26','14:15:00',16.96),('6449','2013-05-26','14:20:00',16.85),('6449','2013-05-26','14:25:00',16.74),('6449','2013-05-26','14:30:00',16.13),('6449','2013-05-26','14:35:00',16.53),('6449','2013-05-26','14:40:00',16.46),('6449','2013-05-26','14:45:00',16.22),('6449','2013-05-26','14:50:00',16.1),('6449','2013-05-26','14:55:00',15.96),('6449','2013-05-26','15:00:00',15.72),('6449','2013-05-26','15:05:00',15.57),('6449','2013-05-26','15:10:00',15.28),('6449','2013-05-26','15:15:00',15.11),('6449','2013-05-26','15:20:00',14.89),('6449','2013-05-26','15:25:00',14.62),('6449','2013-05-26','15:30:00',14.43),('6449','2013-05-26','15:35:00',14.19),('6449','2013-05-26','15:40:00',13.94),('6449','2013-05-26','15:45:00',13.41),('6449','2013-05-26','15:50:00',13.47),('6449','2013-05-26','15:55:00',13.19),('6449','2013-05-26','16:00:00',12.85),('6449','2013-05-26','16:05:00',12.61),('6449','2013-05-26','16:10:00',12.47),('6449','2013-05-26','16:15:00',11.83),('6449','2013-05-26','16:20:00',11.81),('6449','2013-05-26','16:25:00',11.57),('6449','2013-05-26','16:30:00',11.37),('6449','2013-05-26','16:35:00',10.27),('6449','2013-05-26','16:40:00',7.9),('6449','2013-05-26','16:45:00',10.57),('6449','2013-05-26','16:50:00',9.99),('6449','2013-05-26','16:55:00',9.69),('6449','2013-05-26','17:00:00',9.37),('6449','2013-05-26','17:05:00',9.04),('6449','2013-05-26','17:10:00',8.71),('6449','2013-05-26','17:15:00',8.37),('6449','2013-05-26','17:20:00',8.06),('6449','2013-05-26','17:25:00',7.68),('6449','2013-05-26','17:30:00',7.13),('6449','2013-05-26','17:35:00',6.89),('6449','2013-05-26','17:40:00',6.56),('6449','2013-05-26','17:45:00',6.18),('6449','2013-05-26','17:50:00',5.85),('6449','2013-05-26','17:55:00',5.41),('6449','2013-05-26','18:00:00',4.95),('6449','2013-05-26','18:05:00',4.65),('6449','2013-05-26','18:10:00',4.3),('6449','2013-05-26','18:15:00',3.94),('6449','2013-05-26','18:20:00',3.57),('6449','2013-05-26','18:25:00',3.2),('6449','2013-05-26','18:30:00',2.85),('6449','2013-05-26','18:35:00',2.51),('6449','2013-05-26','18:40:00',2.18),('6449','2013-05-26','18:45:00',1.89),('6449','2013-05-26','18:50:00',1.61),('6449','2013-05-26','18:55:00',1.35),('6449','2013-05-26','19:00:00',1.12),('6449','2013-05-25','06:35:00',1.45),('6449','2013-05-25','06:40:00',1.32),('6449','2013-05-25','06:45:00',1.47),('6449','2013-05-25','06:50:00',1.68),('6449','2013-05-25','06:55:00',1.27),('6449','2013-05-25','07:00:00',1.14),('6449','2013-05-25','07:30:00',2.27),('6449','2013-05-25','07:35:00',4.58),('6449','2013-05-25','07:40:00',4.36),('6449','2013-05-25','07:45:00',4.25),('6449','2013-05-25','07:50:00',5.35),('6449','2013-05-25','07:55:00',5.92),('6449','2013-05-25','08:00:00',6.5),('6449','2013-05-25','08:05:00',7.14),('6449','2013-05-25','08:10:00',6.36),('6449','2013-05-25','08:15:00',5.99),('6449','2013-05-25','08:20:00',6.79),('6449','2013-05-25','08:25:00',5.63),('6449','2013-05-25','08:30:00',6.91),('6449','2013-05-25','08:35:00',8.97),('6449','2013-05-25','08:40:00',4.24),('6449','2013-05-25','08:45:00',3.59),('6449','2013-05-25','08:50:00',3.55),('6449','2013-05-25','08:55:00',8.01),('6449','2013-05-25','09:00:00',10.52),('6449','2013-05-25','09:05:00',4.73),('6449','2013-05-25','09:10:00',4.63),('6449','2013-05-25','09:15:00',4.36),('6449','2013-05-25','09:20:00',2.85),('6449','2013-05-25','09:25:00',2.11),('6449','2013-05-25','09:30:00',1.5),('6449','2013-05-25','09:35:00',2),('6449','2013-05-25','09:40:00',2.33),('6449','2013-05-25','09:45:00',2.06),('6449','2013-05-25','09:50:00',2.17),('6449','2013-05-25','09:55:00',3.67),('6449','2013-05-25','10:00:00',6.66),('6449','2013-05-25','10:05:00',5.39),('6449','2013-05-25','10:10:00',3.46),('6449','2013-05-25','10:15:00',2.27),('6449','2013-05-25','10:20:00',2.63),('6449','2013-05-25','10:25:00',4.32),('6449','2013-05-25','10:30:00',6.47),('6449','2013-05-25','10:35:00',6.11),('6449','2013-05-25','10:40:00',3.41),('6449','2013-05-25','10:45:00',3.6),('6449','2013-05-25','10:50:00',4.09),('6449','2013-05-25','10:55:00',4.13),('6449','2013-05-25','11:00:00',5.45),('6449','2013-05-25','11:05:00',6.54),('6449','2013-05-25','11:10:00',5.12),('6449','2013-05-25','11:15:00',8.8),('6449','2013-05-25','11:20:00',8.23),('6449','2013-05-25','11:25:00',2.57),('6449','2013-05-25','11:30:00',5.38),('6449','2013-05-25','11:35:00',6.8),('6449','2013-05-25','11:40:00',5.32),('6449','2013-05-25','11:45:00',4.81),('6449','2013-05-25','11:50:00',4.41),('6449','2013-05-25','11:55:00',4.46),('6449','2013-05-25','12:00:00',4.64),('6449','2013-05-25','12:05:00',4.16),('6449','2013-05-25','12:10:00',3.14),('6449','2013-05-25','12:15:00',3.33),('6449','2013-05-25','12:20:00',2.71),('6449','2013-05-25','12:25:00',3.36),('6449','2013-05-25','12:30:00',4.12),('6449','2013-05-25','12:35:00',5.79),('6449','2013-05-25','12:40:00',10.38),('6449','2013-05-25','12:45:00',11.24),('6449','2013-05-25','12:50:00',12.69),('6449','2013-05-25','12:55:00',19.52),('6449','2013-05-25','13:00:00',12.67),('6449','2013-05-25','13:05:00',4.99),('6449','2013-05-25','13:10:00',10.9),('6449','2013-05-25','13:15:00',12.48),('6449','2013-05-25','13:20:00',18.57),('6449','2013-05-25','13:25:00',16.47),('6449','2013-05-25','13:30:00',16.16),('6449','2013-05-25','13:35:00',13.82),('6449','2013-05-25','13:40:00',12.73),('6449','2013-05-25','13:45:00',13.67),('6449','2013-05-25','13:50:00',10.88),('6449','2013-05-25','13:55:00',18.75),('6449','2013-05-25','14:00:00',17.6),('6449','2013-05-25','14:05:00',17.37),('6449','2013-05-25','14:10:00',16.63),('6449','2013-05-25','14:15:00',16.79),('6449','2013-05-25','14:20:00',16.87),('6449','2013-05-25','14:25:00',14.21),('6449','2013-05-25','14:30:00',10.19),('6449','2013-05-25','14:35:00',9.6),('6449','2013-05-25','14:40:00',14.83),('6449','2013-05-25','14:45:00',4.14),('6449','2013-05-25','14:50:00',11.89),('6449','2013-05-25','14:55:00',15.92),('6449','2013-05-25','15:00:00',15.27),('6449','2013-05-25','15:05:00',14.1),('6449','2013-05-25','15:10:00',15.86),('6449','2013-05-25','15:15:00',15.54),('6449','2013-05-25','15:20:00',14.22),('6449','2013-05-25','15:25:00',13.61),('6449','2013-05-25','15:30:00',5.89),('6449','2013-05-25','15:35:00',4.92),('6449','2013-05-25','15:40:00',15.04),('6449','2013-05-25','15:45:00',9.89),('6449','2013-05-25','15:50:00',6.48),('6449','2013-05-25','15:55:00',13.3),('6449','2013-05-25','16:00:00',10.14),('6449','2013-05-25','16:05:00',12.85),('6449','2013-05-25','16:10:00',12.46),('6449','2013-05-25','16:15:00',10.47),('6449','2013-05-25','16:20:00',12.26),('6449','2013-05-25','16:25:00',12.4),('6449','2013-05-25','16:30:00',11.84),('6449','2013-05-25','16:35:00',12.06),('6449','2013-05-25','16:40:00',7.72),('6449','2013-05-25','16:45:00',9.6),('6449','2013-05-25','16:50:00',10.21),('6449','2013-05-25','16:55:00',10),('6449','2013-05-25','17:00:00',9.75),('6449','2013-05-25','17:05:00',9.32),('6449','2013-05-25','17:10:00',8.98),('6449','2013-05-25','17:15:00',8.49),('6449','2013-05-25','17:20:00',6.02),('6449','2013-05-25','17:25:00',1.91),('6449','2013-05-25','17:30:00',1.95),('6449','2013-05-25','17:35:00',3.03),('6449','2013-05-25','17:40:00',3.6),('6449','2013-05-25','17:45:00',2.88),('6449','2013-05-25','17:50:00',1.69),('6449','2013-05-25','17:55:00',1.29),('6449','2013-05-25','18:00:00',1.06),('6449','2013-05-25','18:05:00',1.08),('6449','2013-05-25','18:10:00',1.37),('6449','2013-05-25','18:15:00',1.18),('6449','2013-05-25','18:20:00',1.26),('6449','2013-05-25','18:40:00',3.05),('6449','2013-05-25','18:45:00',1.95),('6449','2013-05-25','18:50:00',1.33),('6449','2013-05-25','19:10:00',1.43),('6449','2013-05-25','19:15:00',1.01),('6449','2013-05-24','07:15:00',1.26),('6449','2013-05-24','07:20:00',1.76),('6449','2013-05-24','07:25:00',2.09),('6449','2013-05-24','07:30:00',2.02),('6449','2013-05-24','07:35:00',1.66),('6449','2013-05-24','07:40:00',1.69),('6449','2013-05-24','07:45:00',4.85),('6449','2013-05-24','07:50:00',4.93),('6449','2013-05-24','07:55:00',5.25),('6449','2013-05-24','08:00:00',5.61),('6449','2013-05-24','08:05:00',5.58),('6449','2013-05-24','08:10:00',5.07),('6449','2013-05-24','08:15:00',4.25),('6449','2013-05-24','08:20:00',5.36),('6449','2013-05-24','08:25:00',8.59),('6449','2013-05-24','08:30:00',2.9),('6449','2013-05-24','08:35:00',4.98),('6449','2013-05-24','08:40:00',6.07),('6449','2013-05-24','08:45:00',4.44),('6449','2013-05-24','08:50:00',8.69),('6449','2013-05-24','08:55:00',10.98),('6449','2013-05-24','09:00:00',9.76),('6449','2013-05-24','09:05:00',11.06),('6449','2013-05-24','09:10:00',7),('6449','2013-05-24','09:15:00',4.52),('6449','2013-05-24','09:20:00',11.27),('6449','2013-05-24','09:25:00',10.57),('6449','2013-05-24','09:30:00',4.85),('6449','2013-05-24','09:35:00',12.75),('6449','2013-05-24','09:40:00',5.99),('6449','2013-05-24','09:45:00',3.79),('6449','2013-05-24','09:50:00',2.7),('6449','2013-05-24','09:55:00',4.37),('6449','2013-05-24','10:00:00',13.61),('6449','2013-05-24','10:05:00',14.57),('6449','2013-05-24','10:10:00',8.14),('6449','2013-05-24','10:15:00',3.79),('6449','2013-05-24','10:20:00',9.47),('6449','2013-05-24','10:25:00',15.69),('6449','2013-05-24','10:30:00',13.65),('6449','2013-05-24','10:35:00',14.94),('6449','2013-05-24','10:40:00',16.59),('6449','2013-05-24','10:45:00',9.25),('6449','2013-05-24','10:50:00',5.84),('6449','2013-05-24','10:55:00',13.08),('6449','2013-05-24','11:00:00',16.91),('6449','2013-05-24','11:05:00',17.68),('6449','2013-05-24','11:10:00',12.08),('6449','2013-05-24','11:15:00',8.46),('6449','2013-05-24','11:20:00',15.56),('6449','2013-05-24','11:25:00',17.67),('6449','2013-05-24','11:30:00',17.61),('6449','2013-05-24','11:35:00',17.06),('6449','2013-05-24','11:40:00',17.72),('6449','2013-05-24','11:45:00',14.34),('6449','2013-05-24','11:50:00',15.82),('6449','2013-05-24','11:55:00',14.98),('6449','2013-05-24','12:00:00',17.74),('6449','2013-05-24','12:05:00',19.25),('6449','2013-05-24','12:10:00',19.59),('6449','2013-05-24','12:15:00',8.65),('6449','2013-05-24','12:20:00',15.91),('6449','2013-05-24','12:25:00',17.93),('6449','2013-05-24','12:30:00',12.24),('6449','2013-05-24','12:35:00',12.54),('6449','2013-05-24','12:40:00',19.4),('6449','2013-05-24','12:45:00',16.23),('6449','2013-05-24','12:50:00',11.42),('6449','2013-05-24','12:55:00',6.11),('6449','2013-05-24','13:00:00',9.97),('6449','2013-05-24','13:05:00',18.71),('6449','2013-05-24','13:10:00',18.2),('6449','2013-05-24','13:15:00',17.94),('6449','2013-05-24','13:20:00',18.22),('6449','2013-05-24','13:25:00',15.62),('6449','2013-05-24','13:30:00',3.76),('6449','2013-05-24','13:35:00',5.96),('6449','2013-05-24','13:40:00',12.01),('6449','2013-05-24','13:45:00',19.44),('6449','2013-05-24','13:50:00',9.84),('6449','2013-05-24','13:55:00',4.93),('6449','2013-05-24','14:00:00',11.61),('6449','2013-05-24','14:05:00',19.11),('6449','2013-05-24','14:10:00',18.33),('6449','2013-05-24','14:15:00',13.35),('6449','2013-05-24','14:20:00',17.09),('6449','2013-05-24','14:25:00',14.72),('6449','2013-05-24','14:30:00',10.54),('6449','2013-05-24','14:35:00',10.32),('6449','2013-05-24','14:40:00',15.5),('6449','2013-05-24','14:45:00',14.84),('6449','2013-05-24','14:50:00',16.84),('6449','2013-05-24','14:55:00',16.01),('6449','2013-05-24','15:00:00',15.75),('6449','2013-05-24','15:05:00',17.06),('6449','2013-05-24','15:10:00',16.87),('6449','2013-05-24','15:15:00',16.61),('6449','2013-05-24','15:20:00',15.52),('6449','2013-05-24','15:25:00',15.28),('6449','2013-05-24','15:30:00',13.42),('6449','2013-05-24','15:35:00',5.55),('6449','2013-05-24','15:40:00',6.1),('6449','2013-05-24','15:45:00',5.04),('6449','2013-05-24','15:50:00',5.41),('6449','2013-05-24','15:55:00',9.77),('6449','2013-05-24','16:00:00',7.87),('6449','2013-05-24','16:05:00',5.32),('6449','2013-05-24','16:10:00',4.67),('6449','2013-05-24','16:15:00',4.1),('6449','2013-05-24','16:20:00',4.58),('6449','2013-05-24','16:25:00',2.97),('6449','2013-05-24','16:30:00',3.23),('6449','2013-05-24','16:35:00',4.22),('6449','2013-05-24','16:40:00',4.46),('6449','2013-05-24','16:45:00',4.64),('6449','2013-05-24','16:50:00',6.99),('6449','2013-05-24','16:55:00',13.76),('6449','2013-05-24','17:00:00',12.66),('6449','2013-05-24','17:05:00',10.57),('6449','2013-05-24','17:10:00',4.24),('6449','2013-05-24','17:15:00',4.65),('6449','2013-05-24','17:20:00',4.52),('6449','2013-05-24','17:25:00',5.05),('6449','2013-05-24','17:30:00',9.34),('6449','2013-05-24','17:35:00',4.94),('6449','2013-05-24','17:40:00',2.88),('6449','2013-05-24','17:45:00',3.37),('6449','2013-05-24','17:50:00',3.52),('6449','2013-05-24','17:55:00',3.12),('6449','2013-05-24','18:00:00',1.96),('6449','2013-05-24','18:05:00',1.45),('6449','2013-05-24','18:10:00',1.4),('6449','2013-05-24','18:15:00',1.51),('6449','2013-05-24','18:20:00',1.69),('6449','2013-05-24','18:25:00',1.63),('6449','2013-05-24','18:30:00',1.72),('6449','2013-05-24','18:35:00',1.4),('6449','2013-05-24','18:40:00',1.22),('6449','2013-05-24','18:45:00',1.23),('6449','2013-05-24','18:50:00',1.25),('6449','2013-05-24','18:55:00',1.35),('6449','2013-05-24','19:00:00',1.18),('6449','2013-05-23','07:00:00',1.02),('6449','2013-05-23','07:05:00',1.17),('6449','2013-05-23','07:10:00',1.41),('6449','2013-05-23','07:15:00',1.59),('6449','2013-05-23','07:20:00',2.96),('6449','2013-05-23','07:25:00',4.64),('6449','2013-05-23','07:30:00',4.46),('6449','2013-05-23','07:35:00',3.87),('6449','2013-05-23','07:40:00',1.13),('6449','2013-05-23','07:45:00',1.64),('6449','2013-05-23','07:50:00',2.13),('6449','2013-05-23','07:55:00',1.86),('6449','2013-05-23','08:00:00',3.21),('6449','2013-05-23','08:05:00',3.08),('6449','2013-05-23','08:10:00',2.9),('6449','2013-05-23','08:15:00',2.4),('6449','2013-05-23','08:20:00',2.34),('6449','2013-05-23','08:25:00',7.75),('6449','2013-05-23','08:30:00',7.02),('6449','2013-05-23','08:35:00',4.39),('6449','2013-05-23','08:40:00',7.44),('6449','2013-05-23','08:45:00',6.68),('6449','2013-05-23','08:50:00',9.61),('6449','2013-05-23','08:55:00',9.78),('6449','2013-05-23','09:00:00',10.08),('6449','2013-05-23','09:05:00',10.52),('6449','2013-05-23','09:10:00',10.78),('6449','2013-05-23','09:15:00',11.01),('6449','2013-05-23','09:20:00',11.58),('6449','2013-05-23','09:25:00',11.09),('6449','2013-05-23','09:30:00',8.4),('6449','2013-05-23','09:35:00',7.49),('6449','2013-05-23','09:40:00',6.27),('6449','2013-05-23','09:45:00',9.86),('6449','2013-05-23','09:50:00',11.86),('6449','2013-05-23','09:55:00',14.41),('6449','2013-05-23','10:00:00',12.56),('6449','2013-05-23','10:05:00',13.09),('6449','2013-05-23','10:10:00',10.37),('6449','2013-05-23','10:15:00',15.11),('6449','2013-05-23','10:20:00',14.58),('6449','2013-05-23','10:25:00',14.8),('6449','2013-05-23','10:30:00',13.22),('6449','2013-05-23','10:35:00',15.43),('6449','2013-05-23','10:40:00',13.25),('6449','2013-05-23','10:45:00',16.05),('6449','2013-05-23','10:50:00',16.89),('6449','2013-05-23','10:55:00',11.44),('6449','2013-05-23','11:00:00',13.57),('6449','2013-05-23','11:05:00',6.81),('6449','2013-05-23','11:10:00',11.88),('6449','2013-05-23','11:15:00',13.93),('6449','2013-05-23','11:20:00',13.22),('6449','2013-05-23','11:25:00',13.03),('6449','2013-05-23','11:30:00',17.26),('6449','2013-05-23','11:35:00',15.23),('6449','2013-05-23','11:40:00',13.44),('6449','2013-05-23','11:45:00',16.43),('6449','2013-05-23','11:50:00',11.35),('6449','2013-05-23','11:55:00',10.01),('6449','2013-05-23','12:00:00',15.2),('6449','2013-05-23','12:05:00',18.68),('6449','2013-05-23','12:10:00',16.01),('6449','2013-05-23','12:15:00',17.7),('6449','2013-05-23','12:20:00',17.45),('6449','2013-05-23','12:25:00',17.27),('6449','2013-05-23','12:30:00',17.35),('6449','2013-05-23','12:35:00',17.58),('6449','2013-05-23','12:40:00',17.49),('6449','2013-05-23','12:45:00',17.58),('6449','2013-05-23','12:50:00',18.02),('6449','2013-05-23','12:55:00',16.83),('6449','2013-05-23','13:00:00',17.54),('6449','2013-05-23','13:05:00',16.4),('6449','2013-05-23','13:10:00',17.35),('6449','2013-05-23','13:15:00',17.41),('6449','2013-05-23','13:20:00',14.22),('6449','2013-05-23','13:25:00',17.03),('6449','2013-05-23','13:30:00',18.25),('6449','2013-05-23','13:35:00',16.91),('6449','2013-05-23','13:40:00',12.44),('6449','2013-05-23','13:45:00',10.12),('6449','2013-05-23','13:50:00',7.84),('6449','2013-05-23','13:55:00',9.22),('6449','2013-05-23','14:00:00',10.59),('6449','2013-05-23','14:05:00',12.02),('6449','2013-05-23','14:10:00',16.55),('6449','2013-05-23','14:15:00',17.63),('6449','2013-05-23','14:20:00',15.1),('6449','2013-05-23','14:25:00',14.88),('6449','2013-05-23','14:30:00',13.25),('6449','2013-05-23','14:35:00',13.94),('6449','2013-05-23','14:40:00',8.64),('6449','2013-05-23','14:45:00',12.56),('6449','2013-05-23','14:50:00',17.41),('6449','2013-05-23','14:55:00',17.54),('6449','2013-05-23','15:00:00',11.08),('6449','2013-05-23','15:05:00',8.35),('6449','2013-05-23','15:10:00',9.25),('6449','2013-05-23','15:15:00',10.3),('6449','2013-05-23','15:20:00',9.31),('6449','2013-05-23','15:25:00',11.38),('6449','2013-05-23','15:30:00',8.89),('6449','2013-05-23','15:35:00',14.12),('6449','2013-05-23','15:40:00',10.04),('6449','2013-05-23','15:45:00',8.11),('6449','2013-05-23','15:50:00',11.78),('6449','2013-05-23','15:55:00',7.72),('6449','2013-05-23','16:00:00',7.54),('6449','2013-05-23','16:05:00',14.92),('6449','2013-05-23','16:10:00',5.96),('6449','2013-05-23','16:15:00',3.71),('6449','2013-05-23','16:20:00',4.38),('6449','2013-05-23','16:25:00',4.28),('6449','2013-05-23','16:30:00',5.08),('6449','2013-05-23','16:35:00',5.78),('6449','2013-05-23','16:40:00',5.84),('6449','2013-05-23','16:45:00',5.58),('6449','2013-05-23','16:50:00',5.42),('6449','2013-05-23','16:55:00',5.27),('6449','2013-05-23','17:00:00',5.69),('6449','2013-05-23','17:05:00',5.77),('6449','2013-05-23','17:10:00',6.93),('6449','2013-05-23','17:15:00',9.98),('6449','2013-05-23','17:20:00',9.61),('6449','2013-05-23','17:25:00',8.45),('6449','2013-05-23','17:30:00',4.6),('6449','2013-05-23','17:35:00',1.22),('6449','2013-05-23','17:45:00',1.24),('6449','2013-05-23','17:50:00',2.07),('6449','2013-05-23','17:55:00',2.28),('6449','2013-05-23','18:00:00',2.32),('6449','2013-05-23','18:05:00',1.76),('6449','2013-05-23','18:10:00',1.79),('6449','2013-05-23','18:15:00',2.04),('6449','2013-05-23','18:20:00',2.14),('6449','2013-05-23','18:25:00',1.74),('6449','2013-05-23','18:30:00',1.35),('6449','2013-05-23','18:50:00',1.06),('6449','2013-05-23','18:55:00',1.18),('6449','2013-05-23','19:00:00',1.22),('6449','2013-05-23','19:05:00',1.15),('6449','2013-05-23','19:10:00',1.03),('6449','2013-05-22','06:55:00',1.09),('6449','2013-05-22','07:00:00',1.13),('6449','2013-05-22','07:05:00',1.16),('6449','2013-05-22','07:10:00',1.38),('6449','2013-05-22','07:15:00',1.22),('6449','2013-05-22','07:20:00',1.34),('6449','2013-05-22','07:25:00',1.44),('6449','2013-05-22','07:30:00',1.6),('6449','2013-05-22','07:35:00',1.84),('6449','2013-05-22','07:40:00',2.07),('6449','2013-05-22','07:45:00',2.36),('6449','2013-05-22','07:50:00',2.52),('6449','2013-05-22','07:55:00',2.99),('6449','2013-05-22','08:00:00',3.91),('6449','2013-05-22','08:05:00',6.03),('6449','2013-05-22','08:10:00',5.9),('6449','2013-05-22','08:15:00',8.06),('6449','2013-05-22','08:20:00',5.05),('6449','2013-05-22','08:45:00',1.54),('6449','2013-05-22','08:50:00',7.98),('6449','2013-05-22','08:55:00',11.24),('6449','2013-05-22','09:00:00',7.24),('6449','2013-05-22','09:05:00',4.13),('6449','2013-05-22','09:10:00',5.89),('6449','2013-05-22','09:15:00',4.74),('6449','2013-05-22','09:20:00',2.15),('6449','2013-05-22','09:25:00',5.83),('6449','2013-05-22','09:30:00',11.82),('6449','2013-05-22','09:35:00',5.86),('6449','2013-05-22','09:40:00',11.97),('6449','2013-05-22','09:45:00',11.85),('6449','2013-05-22','09:50:00',11.94),('6449','2013-05-22','09:55:00',12.27),('6449','2013-05-22','10:00:00',12.75),('6449','2013-05-22','10:05:00',12.96),('6449','2013-05-22','10:10:00',11.14),('6449','2013-05-22','10:15:00',14.55),('6449','2013-05-22','10:20:00',13.4),('6449','2013-05-22','10:25:00',11.51),('6449','2013-05-22','10:30:00',12.04),('6449','2013-05-22','10:35:00',8.22),('6449','2013-05-22','10:40:00',10.4),('6449','2013-05-22','10:45:00',14.67),('6449','2013-05-22','10:50:00',16.73),('6449','2013-05-22','10:55:00',16.29),('6449','2013-05-22','11:00:00',14.02),('6449','2013-05-22','11:05:00',10.82),('6449','2013-05-22','11:10:00',11.07),('6449','2013-05-22','11:15:00',14.72),('6449','2013-05-22','11:20:00',12.53),('6449','2013-05-22','11:25:00',15.63),('6449','2013-05-22','11:30:00',14.08),('6449','2013-05-22','11:35:00',17.01),('6449','2013-05-22','11:40:00',16.05),('6449','2013-05-22','11:45:00',12.97),('6449','2013-05-22','11:50:00',16.87),('6449','2013-05-22','11:55:00',14.04),('6449','2013-05-22','12:00:00',11.22),('6449','2013-05-22','12:05:00',7.93),('6449','2013-05-22','12:10:00',6.85),('6449','2013-05-22','12:15:00',8.25),('6449','2013-05-22','12:20:00',8.21),('6449','2013-05-22','12:25:00',8.52),('6449','2013-05-22','12:30:00',8.06),('6449','2013-05-22','12:35:00',6.03),('6449','2013-05-22','12:40:00',4.73),('6449','2013-05-22','12:45:00',5.63),('6449','2013-05-22','12:50:00',6.89),('6449','2013-05-22','12:55:00',3.77),('6449','2013-05-22','13:00:00',2.33),('6449','2013-05-22','13:05:00',1.68),('6449','2013-05-22','13:10:00',1.07),('6449','2013-05-22','13:20:00',1.36),('6449','2013-05-22','13:25:00',3.09),('6449','2013-05-22','13:30:00',5.41),('6449','2013-05-22','13:35:00',9.72),('6449','2013-05-22','13:40:00',7.65),('6449','2013-05-22','13:45:00',7.55),('6449','2013-05-22','13:50:00',9.39),('6449','2013-05-22','13:55:00',13.43),('6449','2013-05-22','14:00:00',10.78),('6449','2013-05-22','14:05:00',15.1),('6449','2013-05-22','14:10:00',15.88),('6449','2013-05-22','14:15:00',16.08),('6449','2013-05-22','14:20:00',15.36),('6449','2013-05-22','14:25:00',15.55),('6449','2013-05-22','14:30:00',15.38),('6449','2013-05-22','14:35:00',15.13),('6449','2013-05-22','14:40:00',15.01),('6449','2013-05-22','14:45:00',15),('6449','2013-05-22','14:50:00',14.79),('6449','2013-05-22','14:55:00',14.57),('6449','2013-05-22','15:00:00',14.35),('6449','2013-05-22','15:05:00',14.06),('6449','2013-05-22','15:10:00',14),('6449','2013-05-22','15:15:00',13.77),('6449','2013-05-22','15:20:00',13.56),('6449','2013-05-22','15:25:00',13.43),('6449','2013-05-22','15:30:00',12.77),('6449','2013-05-22','15:35:00',13.75),('6449','2013-05-22','15:40:00',12.33),('6449','2013-05-22','15:45:00',12.23),('6449','2013-05-22','15:50:00',12.16),('6449','2013-05-22','15:55:00',11.89),('6449','2013-05-22','16:00:00',11.44),('6449','2013-05-22','16:05:00',11.37),('6449','2013-05-22','16:10:00',11.12),('6449','2013-05-22','16:15:00',10.86),('6449','2013-05-22','16:20:00',10.37),('6449','2013-05-22','16:25:00',10.08),('6449','2013-05-22','16:30:00',9.95),('6449','2013-05-22','16:35:00',9.64),('6449','2013-05-22','16:40:00',10.29),('6449','2013-05-22','16:45:00',7.33),('6449','2013-05-22','16:50:00',5.18),('6449','2013-05-22','16:55:00',4.95),('6449','2013-05-22','17:00:00',4.66),('6449','2013-05-22','17:05:00',5.44),('6449','2013-05-22','17:10:00',4.12),('6449','2013-05-22','17:15:00',2.63),('6449','2013-05-22','17:20:00',3.19),('6449','2013-05-22','17:25:00',3.95),('6449','2013-05-22','17:30:00',6.12),('6449','2013-05-22','17:35:00',5.64),('6449','2013-05-22','17:40:00',5.95),('6449','2013-05-22','17:45:00',5.88),('6449','2013-05-22','17:50:00',5.57),('6449','2013-05-22','17:55:00',5.92),('6449','2013-05-22','18:00:00',5.07),('6449','2013-05-22','18:05:00',4.28),('6449','2013-05-22','18:10:00',3.84),('6449','2013-05-22','18:15:00',3.68),('6449','2013-05-22','18:20:00',3.28),('6449','2013-05-22','18:25:00',3.17),('6449','2013-05-22','18:30:00',2.96),('6449','2013-05-22','18:35:00',2.79),('6449','2013-05-22','18:40:00',2.49),('6449','2013-05-22','18:45:00',2.13),('6449','2013-05-22','18:50:00',1.91),('6449','2013-05-22','18:55:00',1.76),('6449','2013-05-22','19:00:00',1.63),('6449','2013-05-22','19:05:00',1.58),('6449','2013-05-22','19:10:00',1.31),('6449','2013-05-21','06:40:00',1),('6449','2013-05-21','06:45:00',1.2),('6449','2013-05-21','06:50:00',1.37),('6449','2013-05-21','06:55:00',1.59),('6449','2013-05-21','07:00:00',1.82),('6449','2013-05-21','07:05:00',2.07),('6449','2013-05-21','07:10:00',2.34),('6449','2013-05-21','07:15:00',2.71),('6449','2013-05-21','07:20:00',3.09),('6449','2013-05-21','07:25:00',3.37),('6449','2013-05-21','07:30:00',3.64),('6449','2013-05-21','07:35:00',3.98),('6449','2013-05-21','07:40:00',4.41),('6449','2013-05-21','07:45:00',5.17),('6449','2013-05-21','07:50:00',5.76),('6449','2013-05-21','07:55:00',5.33),('6449','2013-05-21','08:00:00',5.42),('6449','2013-05-21','08:05:00',4.95),('6449','2013-05-21','08:10:00',3.49),('6449','2013-05-21','08:15:00',3.85),('6449','2013-05-21','08:20:00',4.65),('6449','2013-05-21','08:25:00',4.05),('6449','2013-05-21','08:30:00',3.32),('6449','2013-05-21','08:35:00',4.04),('6449','2013-05-21','08:40:00',4.87),('6449','2013-05-21','08:45:00',3.66),('6449','2013-05-21','08:50:00',3.3),('6449','2013-05-21','08:55:00',3.67),('6449','2013-05-21','09:00:00',4.58),('6449','2013-05-21','09:05:00',4.92),('6449','2013-05-21','09:10:00',4.73),('6449','2013-05-21','09:15:00',5.67),('6449','2013-05-21','09:20:00',5.88),('6449','2013-05-21','09:25:00',6.59),('6449','2013-05-21','09:30:00',6.18),('6449','2013-05-21','09:35:00',5.32),('6449','2013-05-21','09:40:00',4.43),('6449','2013-05-21','09:45:00',5.05),('6449','2013-05-21','09:50:00',10.1),('6449','2013-05-21','09:55:00',11.96),('6449','2013-05-21','10:00:00',7.05),('6449','2013-05-21','10:05:00',6.2),('6449','2013-05-21','10:10:00',5.83),('6449','2013-05-21','10:15:00',6.95),('6449','2013-05-21','10:20:00',11.07),('6449','2013-05-21','10:25:00',8.52),('6449','2013-05-21','10:30:00',11.58),('6449','2013-05-21','10:35:00',8.4),('6449','2013-05-21','10:40:00',6.62),('6449','2013-05-21','10:45:00',4.85),('6449','2013-05-21','10:50:00',5.21),('6449','2013-05-21','10:55:00',9.4),('6449','2013-05-21','11:00:00',10.36),('6449','2013-05-21','11:05:00',10.73),('6449','2013-05-21','11:10:00',13.17),('6449','2013-05-21','11:15:00',13.97),('6449','2013-05-21','11:20:00',15.51),('6449','2013-05-21','11:25:00',15.78),('6449','2013-05-21','11:30:00',16.19),('6449','2013-05-21','11:35:00',13.21),('6449','2013-05-21','11:40:00',6.41),('6449','2013-05-21','11:45:00',11.04),('6449','2013-05-21','11:50:00',15.27),('6449','2013-05-21','11:55:00',14.86),('6449','2013-05-21','12:00:00',9.89),('6449','2013-05-21','12:05:00',7.55),('6449','2013-05-21','12:10:00',5.78),('6449','2013-05-21','12:15:00',6.27),('6449','2013-05-21','12:20:00',8.16),('6449','2013-05-21','12:25:00',8.67),('6449','2013-05-21','12:30:00',14.26),('6449','2013-05-21','12:35:00',11.15),('6449','2013-05-21','12:40:00',13.81),('6449','2013-05-21','12:45:00',12.3),('6449','2013-05-21','12:50:00',14.47),('6449','2013-05-21','12:55:00',7.2),('6449','2013-05-21','13:00:00',7.04),('6449','2013-05-21','13:05:00',6.81),('6449','2013-05-21','13:10:00',9.66),('6449','2013-05-21','13:15:00',12.94),('6449','2013-05-21','13:20:00',13.62),('6449','2013-05-21','13:25:00',7.6),('6449','2013-05-21','13:30:00',6.82),('6449','2013-05-21','13:35:00',5.72),('6449','2013-05-21','13:40:00',3.99),('6449','2013-05-21','13:45:00',2.96),('6449','2013-05-21','13:50:00',2.55),('6449','2013-05-21','13:55:00',1.44),('6449','2013-05-21','14:15:00',1.28),('6449','2013-05-21','14:20:00',2.25),('6449','2013-05-21','14:25:00',3.88),('6449','2013-05-21','14:30:00',5.39),('6449','2013-05-21','14:35:00',5.77),('6449','2013-05-21','14:40:00',3.22),('6449','2013-05-21','14:45:00',1.68),('6449','2013-05-21','15:05:00',1.47),('6449','2013-05-21','15:10:00',2.61),('6449','2013-05-21','15:15:00',2.72),('6449','2013-05-21','15:20:00',2.52),('6449','2013-05-21','15:25:00',3.1),('6449','2013-05-21','15:30:00',3.34),('6449','2013-05-21','15:35:00',2.32),('6449','2013-05-21','15:40:00',2.69),('6449','2013-05-21','15:45:00',5.24),('6449','2013-05-21','15:50:00',6.55),('6449','2013-05-21','15:55:00',3.92),('6449','2013-05-21','16:00:00',2.79),('6449','2013-05-21','16:05:00',2.91),('6449','2013-05-21','16:10:00',2.75),('6449','2013-05-21','16:15:00',2.87),('6449','2013-05-21','16:20:00',2.34),('6449','2013-05-21','16:25:00',2.25),('6449','2013-05-21','16:30:00',1.55),('6449','2013-05-21','16:35:00',1.34),('6449','2013-05-21','16:40:00',1.32),('6449','2013-05-21','16:45:00',1.44),('6449','2013-05-21','16:50:00',1.99),('6449','2013-05-21','16:55:00',2.19),('6449','2013-05-21','17:00:00',1.41),('6449','2013-05-21','18:20:00',1.04),('6449','2013-05-20','06:50:00',1.18),('6449','2013-05-20','06:55:00',1.15),('6449','2013-05-20','07:00:00',1.53),('6449','2013-05-20','07:05:00',1.48),('6449','2013-05-20','07:35:00',2.96),('6449','2013-05-20','07:40:00',4.12),('6449','2013-05-20','07:45:00',4.61),('6449','2013-05-20','07:50:00',4.98),('6449','2013-05-20','07:55:00',5.38),('6449','2013-05-20','08:00:00',5.75),('6449','2013-05-20','08:05:00',6.12),('6449','2013-05-20','08:10:00',6.5),('6449','2013-05-20','08:15:00',6.86),('6449','2013-05-20','08:20:00',7.36),('6449','2013-05-20','08:25:00',7.03),('6449','2013-05-20','08:30:00',7.66),('6449','2013-05-20','08:35:00',8.07),('6449','2013-05-20','08:40:00',8.58),('6449','2013-05-20','08:45:00',8.79),('6449','2013-05-20','08:50:00',9.14),('6449','2013-05-20','08:55:00',9.48),('6449','2013-05-20','09:00:00',9.67),('6449','2013-05-20','09:05:00',10.1),('6449','2013-05-20','09:10:00',10.3),('6449','2013-05-20','09:15:00',10.37),('6449','2013-05-20','09:20:00',10.77),('6449','2013-05-20','09:25:00',11.12),('6449','2013-05-20','09:30:00',11.54),('6449','2013-05-20','09:35:00',12.24),('6449','2013-05-20','09:40:00',12.99),('6449','2013-05-20','09:45:00',12.63),('6449','2013-05-20','09:50:00',8.04),('6449','2013-05-20','09:55:00',11.63),('6449','2013-05-20','10:00:00',9.97),('6449','2013-05-20','10:05:00',13.39),('6449','2013-05-20','10:10:00',13.59),('6449','2013-05-20','10:15:00',13.61),('6449','2013-05-20','10:20:00',13.85),('6449','2013-05-20','10:25:00',14.14),('6449','2013-05-20','10:30:00',13.58),('6449','2013-05-20','10:35:00',13.98),('6449','2013-05-20','10:40:00',14.71),('6449','2013-05-20','10:45:00',14.79),('6449','2013-05-20','10:50:00',14.87),('6449','2013-05-20','10:55:00',15.02),('6449','2013-05-20','11:00:00',15.18),('6449','2013-05-20','11:05:00',15.36),('6449','2013-05-20','11:10:00',15.42),('6449','2013-05-20','11:15:00',15.55),('6449','2013-05-20','11:20:00',15.75),('6449','2013-05-20','11:25:00',15.88),('6449','2013-05-20','11:30:00',15.86),('6449','2013-05-20','11:35:00',16.01),('6449','2013-05-20','11:40:00',16.07),('6449','2013-05-20','11:45:00',15.95),('6449','2013-05-20','11:50:00',16.21),('6449','2013-05-20','11:55:00',16.35),('6449','2013-05-20','12:00:00',16.28),('6449','2013-05-20','12:05:00',16.46),('6449','2013-05-20','12:10:00',16.5),('6449','2013-05-20','12:15:00',16.33),('6449','2013-05-20','12:20:00',16.65),('6449','2013-05-20','12:25:00',16.78),('6449','2013-05-20','12:30:00',16.74),('6449','2013-05-20','12:35:00',16.79),('6449','2013-05-20','12:40:00',16.81),('6449','2013-05-20','12:45:00',16.85),('6449','2013-05-20','12:50:00',16.86),('6449','2013-05-20','12:55:00',16.95),('6449','2013-05-20','13:00:00',16.85),('6449','2013-05-20','13:05:00',16.87),('6449','2013-05-20','13:10:00',16.94),('6449','2013-05-20','13:15:00',16.98),('6449','2013-05-20','13:20:00',16.88),('6449','2013-05-20','13:25:00',16.84),('6449','2013-05-20','13:30:00',16.6),('6449','2013-05-20','13:35:00',16.75),('6449','2013-05-20','13:40:00',16.72),('6449','2013-05-20','13:45:00',16.55),('6449','2013-05-20','13:50:00',16.66),('6449','2013-05-20','13:55:00',16.59),('6449','2013-05-20','14:00:00',16.53),('6449','2013-05-20','14:05:00',16.39),('6449','2013-05-20','14:10:00',16.18),('6449','2013-05-20','14:15:00',15.96),('6449','2013-05-20','14:20:00',15.85),('6449','2013-05-20','14:25:00',15.76),('6449','2013-05-20','14:30:00',15.54),('6449','2013-05-20','14:35:00',15.53),('6449','2013-05-20','14:40:00',15.37),('6449','2013-05-20','14:45:00',15.2),('6449','2013-05-20','14:50:00',15.14),('6449','2013-05-20','14:55:00',14.9),('6449','2013-05-20','15:00:00',14.77),('6449','2013-05-20','15:05:00',14.57),('6449','2013-05-20','15:10:00',14.49),('6449','2013-05-20','15:15:00',14.08),('6449','2013-05-20','15:20:00',14.11),('6449','2013-05-20','15:25:00',13.92),('6449','2013-05-20','15:30:00',13.75),('6449','2013-05-20','15:35:00',13.39),('6449','2013-05-20','15:40:00',13.47),('6449','2013-05-20','15:45:00',13.18),('6449','2013-05-20','15:50:00',12.76),('6449','2013-05-20','15:55:00',12.57),('6449','2013-05-20','16:00:00',12.5),('6449','2013-05-20','16:05:00',10.25),('6449','2013-05-20','16:10:00',8.37),('6449','2013-05-20','16:15:00',6.36),('6449','2013-05-20','16:20:00',5.11),('6449','2013-05-20','16:25:00',4.7),('6449','2013-05-20','16:30:00',6.88),('6449','2013-05-20','16:35:00',11.15),('6449','2013-05-20','16:40:00',11.05),('6449','2013-05-20','16:45:00',6.92),('6449','2013-05-20','16:50:00',4.97),('6449','2013-05-20','16:55:00',3.15),('6449','2013-05-20','17:00:00',3.15),('6449','2013-05-20','17:05:00',5.25),('6449','2013-05-20','17:10:00',10.49),('6449','2013-05-20','17:15:00',8.23),('6449','2013-05-20','17:20:00',7.41),('6449','2013-05-20','17:25:00',7.24),('6449','2013-05-20','17:30:00',6.79),('6449','2013-05-20','17:35:00',6.43),('6449','2013-05-20','17:40:00',6.17),('6449','2013-05-20','17:45:00',6.03),('6449','2013-05-20','17:50:00',5.98),('6449','2013-05-20','17:55:00',6.18),('6449','2013-05-20','18:00:00',6.05),('6449','2013-05-20','18:05:00',3.79),('6449','2013-05-20','18:10:00',3.85),('6449','2013-05-20','18:15:00',3.67),('6449','2013-05-20','18:20:00',3.27),('6449','2013-05-20','18:25:00',2.96),('6449','2013-05-20','18:30:00',2.64),('6449','2013-05-20','18:35:00',2.39),('6449','2013-05-20','18:40:00',2.08),('6449','2013-05-20','18:45:00',1.78),('6449','2013-05-20','18:50:00',1.57),('6449','2013-05-20','18:55:00',1.35),('6449','2013-05-19','07:15:00',1.03),('6449','2013-05-19','07:20:00',1.22),('6449','2013-05-19','07:25:00',1.15),('6449','2013-05-19','07:30:00',1.3),('6449','2013-05-19','07:35:00',1.57),('6449','2013-05-19','07:40:00',1.68),('6449','2013-05-19','07:45:00',1.75),('6449','2013-05-19','07:50:00',1.91),('6449','2013-05-19','07:55:00',2.39),('6449','2013-05-19','08:00:00',2.56),('6449','2013-05-19','08:05:00',3.39),('6449','2013-05-19','08:10:00',3.46),('6449','2013-05-19','08:15:00',3.78),('6449','2013-05-19','08:20:00',3.98),('6449','2013-05-19','08:25:00',5.18),('6449','2013-05-19','08:30:00',5.52),('6449','2013-05-19','08:35:00',6.1),('6449','2013-05-19','08:40:00',7.53),('6449','2013-05-19','08:45:00',7.96),('6449','2013-05-19','08:50:00',6.77),('6449','2013-05-19','08:55:00',7.76),('6449','2013-05-19','09:00:00',8.02),('6449','2013-05-19','09:05:00',7.3),('6449','2013-05-19','09:10:00',9.22),('6449','2013-05-19','09:15:00',9.43),('6449','2013-05-19','09:20:00',10.41),('6449','2013-05-19','09:25:00',9.1),('6449','2013-05-19','09:30:00',8.71),('6449','2013-05-19','09:35:00',11.64),('6449','2013-05-19','09:40:00',11.76),('6449','2013-05-19','09:45:00',12.05),('6449','2013-05-19','09:50:00',12.31),('6449','2013-05-19','09:55:00',12.65),('6449','2013-05-19','10:00:00',12.85),('6449','2013-05-19','10:05:00',13.18),('6449','2013-05-19','10:10:00',13.44),('6449','2013-05-19','10:15:00',13.69),('6449','2013-05-19','10:20:00',13.82),('6449','2013-05-19','10:25:00',14.1),('6449','2013-05-19','10:30:00',14.45),('6449','2013-05-19','10:35:00',14.64),('6449','2013-05-19','10:40:00',14.95),('6449','2013-05-19','10:45:00',15.15),('6449','2013-05-19','10:50:00',15.39),('6449','2013-05-19','10:55:00',15.52),('6449','2013-05-19','11:00:00',15.71),('6449','2013-05-19','11:05:00',15.87),('6449','2013-05-19','11:10:00',16.05),('6449','2013-05-19','11:15:00',16.09),('6449','2013-05-19','11:20:00',16.47),('6449','2013-05-19','11:25:00',16.87),('6449','2013-05-19','11:30:00',16.77),('6449','2013-05-19','11:35:00',15.55),('6449','2013-05-19','11:40:00',9),('6449','2013-05-19','11:45:00',11.38),('6449','2013-05-19','11:50:00',10.97),('6449','2013-05-19','11:55:00',13.68),('6449','2013-05-19','12:00:00',12.89),('6449','2013-05-19','12:05:00',12.22),('6449','2013-05-19','12:10:00',17.59),('6449','2013-05-19','12:15:00',17.85),('6449','2013-05-19','12:20:00',15.36),('6449','2013-05-19','12:25:00',16.9),('6449','2013-05-19','12:30:00',17.71),('6449','2013-05-19','12:35:00',17.62),('6449','2013-05-19','12:40:00',17.54),('6449','2013-05-19','12:45:00',17.54),('6449','2013-05-19','12:50:00',17.6),('6449','2013-05-19','12:55:00',17.64),('6449','2013-05-19','13:00:00',17.51),('6449','2013-05-19','13:05:00',17.68),('6449','2013-05-19','13:10:00',17.58),('6449','2013-05-19','13:15:00',17.54),('6449','2013-05-19','13:20:00',17.58),('6449','2013-05-19','13:25:00',17.53),('6449','2013-05-19','13:30:00',17.28),('6449','2013-05-19','13:35:00',17.44),('6449','2013-05-19','13:40:00',17.39),('6449','2013-05-19','13:45:00',17.35),('6449','2013-05-19','13:50:00',17.28),('6449','2013-05-19','13:55:00',17.13),('6449','2013-05-19','14:00:00',17.01),('6449','2013-05-19','14:05:00',16.99),('6449','2013-05-19','14:10:00',16.85),('6449','2013-05-19','14:15:00',16.74),('6449','2013-05-19','14:20:00',16.66),('6449','2013-05-19','14:25:00',16.65),('6449','2013-05-19','14:30:00',16.51),('6449','2013-05-19','14:35:00',16.38),('6449','2013-05-19','14:40:00',16.26),('6449','2013-05-19','14:45:00',16.09),('6449','2013-05-19','14:50:00',15.85),('6449','2013-05-19','14:55:00',15.76),('6449','2013-05-19','15:00:00',15.61),('6449','2013-05-19','15:05:00',15.37),('6449','2013-05-19','15:10:00',15.16),('6449','2013-05-19','15:15:00',15),('6449','2013-05-19','15:20:00',14.6),('6449','2013-05-19','15:25:00',14.66),('6449','2013-05-19','15:30:00',14.39),('6449','2013-05-19','15:35:00',14.19),('6449','2013-05-19','15:40:00',14.01),('6449','2013-05-19','15:45:00',13.68),('6449','2013-05-19','15:50:00',13.39),('6449','2013-05-19','15:55:00',13.21),('6449','2013-05-19','16:00:00',12.93),('6449','2013-05-19','16:05:00',12.61),('6449','2013-05-19','16:10:00',12.43),('6449','2013-05-19','16:15:00',12.06),('6449','2013-05-19','16:20:00',11.72),('6449','2013-05-19','16:25:00',11.45),('6449','2013-05-19','16:30:00',11.21),('6449','2013-05-19','16:35:00',10.8),('6449','2013-05-19','16:40:00',10.63),('6449','2013-05-19','16:45:00',10.25),('6449','2013-05-19','16:50:00',10),('6449','2013-05-19','16:55:00',9.58),('6449','2013-05-19','17:00:00',9.43),('6449','2013-05-19','17:05:00',8.89),('6449','2013-05-19','17:10:00',8.64),('6449','2013-05-19','17:15:00',8.22),('6449','2013-05-19','17:20:00',7.89),('6449','2013-05-19','17:25:00',7.52),('6449','2013-05-19','17:30:00',7.1),('6449','2013-05-19','17:35:00',6.76),('6449','2013-05-19','17:40:00',6.37),('6449','2013-05-19','17:45:00',5.93),('6449','2013-05-19','17:50:00',5.6),('6449','2013-05-19','17:55:00',5.24),('6449','2013-05-19','18:00:00',4.89),('6449','2013-05-19','18:05:00',4.5),('6449','2013-05-19','18:10:00',4.07),('6449','2013-05-19','18:15:00',3.72),('6449','2013-05-19','18:20:00',3.35),('6449','2013-05-19','18:25:00',3.02),('6449','2013-05-19','18:30:00',2.65),('6449','2013-05-19','18:35:00',2.34),('6449','2013-05-19','18:40:00',2.03),('6449','2013-05-19','18:45:00',1.74),('6449','2013-05-19','18:50:00',1.46),('6449','2013-05-19','18:55:00',1.22),('6449','2013-05-19','19:00:00',1.01),('6449','2013-05-18','06:50:00',1.16),('6449','2013-05-18','06:55:00',1.38),('6449','2013-05-18','07:00:00',1.66),('6449','2013-05-18','07:05:00',1.93),('6449','2013-05-18','07:10:00',2.25),('6449','2013-05-18','07:15:00',2.55),('6449','2013-05-18','07:20:00',2.86),('6449','2013-05-18','07:25:00',3.19),('6449','2013-05-18','07:30:00',3.44),('6449','2013-05-18','07:35:00',3.82),('6449','2013-05-18','07:40:00',4.26),('6449','2013-05-18','07:45:00',4.6),('6449','2013-05-18','07:50:00',4.87),('6449','2013-05-18','07:55:00',5.17),('6449','2013-05-18','08:00:00',5.65),('6449','2013-05-18','08:05:00',6.15),('6449','2013-05-18','08:10:00',6.31),('6449','2013-05-18','08:15:00',6.92),('6449','2013-05-18','08:20:00',7.6),('6449','2013-05-18','08:25:00',7.18),('6449','2013-05-18','08:30:00',6.3),('6449','2013-05-18','08:35:00',8.11),('6449','2013-05-18','08:40:00',9.3),('6449','2013-05-18','08:45:00',8.7),('6449','2013-05-18','08:50:00',8.83),('6449','2013-05-18','08:55:00',7.56),('6449','2013-05-18','09:00:00',10.28),('6449','2013-05-18','09:05:00',10.26),('6449','2013-05-18','09:10:00',11.12),('6449','2013-05-18','09:15:00',10.85),('6449','2013-05-18','09:20:00',11.1),('6449','2013-05-18','09:25:00',11.32),('6449','2013-05-18','09:30:00',11.59),('6449','2013-05-18','09:35:00',11.79),('6449','2013-05-18','09:40:00',12.09),('6449','2013-05-18','09:45:00',12.16),('6449','2013-05-18','09:50:00',12.56),('6449','2013-05-18','09:55:00',12.81),('6449','2013-05-18','10:00:00',12.96),('6449','2013-05-18','10:05:00',13.31),('6449','2013-05-18','10:10:00',13.48),('6449','2013-05-18','10:15:00',14.36),('6449','2013-05-18','10:20:00',11.45),('6449','2013-05-18','10:25:00',9.9),('6449','2013-05-18','10:30:00',14.4),('6449','2013-05-18','10:35:00',14.52),('6449','2013-05-18','10:40:00',14.55),('6449','2013-05-18','10:45:00',13.62),('6449','2013-05-18','10:50:00',15.93),('6449','2013-05-18','10:55:00',11.11),('6449','2013-05-18','11:00:00',13.84),('6449','2013-05-18','11:05:00',11.93),('6449','2013-05-18','11:10:00',13.36),('6449','2013-05-18','11:15:00',15.43),('6449','2013-05-18','11:20:00',14),('6449','2013-05-18','11:25:00',9.64),('6449','2013-05-18','11:30:00',16.21),('6449','2013-05-18','11:35:00',15.78),('6449','2013-05-18','11:40:00',14.94),('6449','2013-05-18','11:45:00',15.66),('6449','2013-05-18','11:50:00',15.64),('6449','2013-05-18','11:55:00',15.67),('6449','2013-05-18','12:00:00',15.57),('6449','2013-05-18','12:05:00',15.67),('6449','2013-05-18','12:10:00',15.7),('6449','2013-05-18','12:15:00',16.41),('6449','2013-05-18','12:20:00',13.44),('6449','2013-05-18','12:25:00',15.34),('6449','2013-05-18','12:30:00',16.72),('6449','2013-05-18','12:35:00',7.26),('6449','2013-05-18','12:40:00',10.21),('6449','2013-05-18','12:45:00',17.5),('6449','2013-05-18','12:50:00',16.84),('6449','2013-05-18','12:55:00',16.08),('6449','2013-05-18','13:00:00',15.89),('6449','2013-05-18','13:05:00',15.84),('6449','2013-05-18','13:10:00',15.9),('6449','2013-05-18','13:15:00',15.76),('6449','2013-05-18','13:20:00',15.96),('6449','2013-05-18','13:25:00',15.88),('6449','2013-05-18','13:30:00',15.79),('6449','2013-05-18','13:35:00',15.73),('6449','2013-05-18','13:40:00',15.64),('6449','2013-05-18','13:45:00',15.53),('6449','2013-05-18','13:50:00',15.39),('6449','2013-05-18','13:55:00',14.9),('6449','2013-05-18','14:00:00',13.93),('6449','2013-05-18','14:05:00',14.43),('6449','2013-05-18','14:10:00',15.51),('6449','2013-05-18','14:15:00',15.57),('6449','2013-05-18','14:20:00',14.82),('6449','2013-05-18','14:25:00',15.92),('6449','2013-05-18','14:30:00',15.47),('6449','2013-05-18','14:35:00',13.1),('6449','2013-05-18','14:40:00',13.23),('6449','2013-05-18','14:45:00',14.89),('6449','2013-05-18','14:50:00',13.46),('6449','2013-05-18','14:55:00',13.52),('6449','2013-05-18','15:00:00',13.08),('6449','2013-05-18','15:05:00',13.61),('6449','2013-05-18','15:10:00',13.3),('6449','2013-05-18','15:15:00',12.45),('6449','2013-05-18','15:20:00',12.7),('6449','2013-05-18','15:25:00',12.6),('6449','2013-05-18','15:30:00',12.17),('6449','2013-05-18','15:35:00',11.89),('6449','2013-05-18','15:40:00',11.71),('6449','2013-05-18','15:45:00',11.48),('6449','2013-05-18','15:50:00',11.29),('6449','2013-05-18','15:55:00',10.99),('6449','2013-05-18','16:00:00',10.73),('6449','2013-05-18','16:05:00',10.35),('6449','2013-05-18','16:10:00',10.24),('6449','2013-05-18','16:15:00',10.06),('6449','2013-05-18','16:20:00',9.7),('6449','2013-05-18','16:25:00',9.06),('6449','2013-05-18','16:30:00',5.35),('6449','2013-05-18','16:35:00',8.42),('6449','2013-05-18','16:40:00',8.68),('6449','2013-05-18','16:45:00',8.41),('6449','2013-05-18','16:50:00',8.02),('6449','2013-05-18','16:55:00',7.73),('6449','2013-05-18','17:00:00',7.35),('6449','2013-05-18','17:05:00',6.97),('6449','2013-05-18','17:10:00',6.62),('6449','2013-05-18','17:15:00',6.29),('6449','2013-05-18','17:20:00',6.12),('6449','2013-05-18','17:25:00',5.99),('6449','2013-05-18','17:30:00',5.71),('6449','2013-05-18','17:35:00',5.42),('6449','2013-05-18','17:40:00',5.08),('6449','2013-05-18','17:45:00',4.73),('6449','2013-05-18','17:50:00',4.4),('6449','2013-05-18','17:55:00',4.24),('6449','2013-05-18','18:00:00',4.02),('6449','2013-05-18','18:05:00',3.76),('6449','2013-05-18','18:10:00',3.5),('6449','2013-05-18','18:15:00',3.26),('6449','2013-05-18','18:20:00',3),('6449','2013-05-18','18:25:00',2.74),('6449','2013-05-18','18:30:00',2.51),('6449','2013-05-18','18:35:00',2.32),('6449','2013-05-18','18:40:00',2.12),('6449','2013-05-18','18:45:00',1.95),('6449','2013-05-18','18:50:00',1.76),('6449','2013-05-18','18:55:00',1.6),('6449','2013-05-18','19:00:00',1.44),('6449','2013-05-18','19:05:00',1.31),('6449','2013-05-18','19:10:00',1.17),('6449','2013-05-18','19:15:00',1.05),('6449','2013-05-17','07:00:00',1.05),('6449','2013-05-17','07:05:00',1.8),('6449','2013-05-17','07:10:00',1.76),('6449','2013-05-17','07:15:00',1.83),('6449','2013-05-17','07:20:00',2.9),('6449','2013-05-17','07:25:00',3),('6449','2013-05-17','07:30:00',2.6),('6449','2013-05-17','07:35:00',1.95),('6449','2013-05-17','07:40:00',3.38),('6449','2013-05-17','07:45:00',4.5),('6449','2013-05-17','07:50:00',6.05),('6449','2013-05-17','07:55:00',4.29),('6449','2013-05-17','08:00:00',2.43),('6449','2013-05-17','08:05:00',1.21),('6449','2013-05-17','08:10:00',2.04),('6449','2013-05-17','08:15:00',2.4),('6449','2013-05-17','08:20:00',1.55),('6449','2013-05-17','08:50:00',1.18),('6449','2013-05-17','08:55:00',2.41),('6449','2013-05-17','09:00:00',1.92),('6449','2013-05-17','09:05:00',1.5),('6449','2013-05-17','09:10:00',1.49),('6449','2013-05-17','09:15:00',1.68),('6449','2013-05-17','09:20:00',2.02),('6449','2013-05-17','09:25:00',2),('6449','2013-05-17','09:30:00',2.16),('6449','2013-05-17','09:35:00',1.38),('6449','2013-05-17','09:40:00',1.41),('6449','2013-05-17','09:45:00',1.46),('6449','2013-05-17','09:50:00',1.94),('6449','2013-05-17','09:55:00',2.95),('6449','2013-05-17','10:00:00',4.23),('6449','2013-05-17','10:05:00',4.25),('6449','2013-05-17','10:10:00',5.46),('6449','2013-05-17','10:15:00',5.55),('6449','2013-05-17','10:20:00',7.27),('6449','2013-05-17','10:25:00',6.79),('6449','2013-05-17','10:30:00',8.93),('6449','2013-05-17','10:35:00',10.6),('6449','2013-05-17','10:40:00',8.25),('6449','2013-05-17','10:45:00',10.01),('6449','2013-05-17','10:50:00',8.43),('6449','2013-05-17','10:55:00',10.03),('6449','2013-05-17','11:00:00',10.08),('6449','2013-05-17','11:05:00',11),('6449','2013-05-17','11:10:00',7.15),('6449','2013-05-17','11:15:00',8.54),('6449','2013-05-17','11:20:00',10.62),('6449','2013-05-17','11:25:00',11.05),('6449','2013-05-17','11:30:00',12.32),('6449','2013-05-17','11:35:00',11.04),('6449','2013-05-17','11:40:00',8.89),('6449','2013-05-17','11:45:00',9.89),('6449','2013-05-17','11:50:00',5.91),('6449','2013-05-17','11:55:00',6.56),('6449','2013-05-17','12:00:00',11.6),('6449','2013-05-17','12:05:00',17.8),('6449','2013-05-17','12:10:00',13.04),('6449','2013-05-17','12:15:00',14.2),('6449','2013-05-17','12:20:00',18.19),('6449','2013-05-17','12:25:00',17.52),('6449','2013-05-17','12:30:00',14.92),('6449','2013-05-17','12:35:00',17.84),('6449','2013-05-17','12:40:00',12.83),('6449','2013-05-17','12:45:00',17.78),('6449','2013-05-17','12:50:00',17.43),('6449','2013-05-17','12:55:00',17.27),('6449','2013-05-17','13:00:00',17.23),('6449','2013-05-17','13:05:00',17.15),('6449','2013-05-17','13:10:00',17.11),('6449','2013-05-17','13:15:00',17.21),('6449','2013-05-17','13:20:00',17.5),('6449','2013-05-17','13:25:00',16.93),('6449','2013-05-17','13:30:00',14.67),('6449','2013-05-17','13:35:00',15.66),('6449','2013-05-17','13:40:00',15.35),('6449','2013-05-17','13:45:00',16.38),('6449','2013-05-17','13:50:00',14.38),('6449','2013-05-17','13:55:00',12.28),('6449','2013-05-17','14:00:00',12.11),('6449','2013-05-17','14:05:00',15.98),('6449','2013-05-17','14:10:00',15.46),('6449','2013-05-17','14:15:00',12.51),('6449','2013-05-17','14:20:00',16.36),('6449','2013-05-17','14:25:00',15.93),('6449','2013-05-17','14:30:00',12.39),('6449','2013-05-17','14:35:00',11.99),('6449','2013-05-17','14:40:00',13.08),('6449','2013-05-17','14:45:00',13.59),('6449','2013-05-17','14:50:00',14.2),('6449','2013-05-17','14:55:00',15.28),('6449','2013-05-17','15:00:00',15.16),('6449','2013-05-17','15:05:00',14.96),('6449','2013-05-17','15:10:00',14.79),('6449','2013-05-17','15:15:00',14.52),('6449','2013-05-17','15:20:00',14.42),('6449','2013-05-17','15:25:00',14.29),('6449','2013-05-17','15:30:00',13.98),('6449','2013-05-17','15:35:00',13.77),('6449','2013-05-17','15:40:00',13.52),('6449','2013-05-17','15:45:00',13.17),('6449','2013-05-17','15:50:00',12.97),('6449','2013-05-17','15:55:00',12.65),('6449','2013-05-17','16:00:00',11.44),('6449','2013-05-17','16:05:00',9.71),('6449','2013-05-17','16:10:00',11.83),('6449','2013-05-17','16:15:00',11.47),('6449','2013-05-17','16:20:00',11.25),('6449','2013-05-17','16:25:00',10.97),('6449','2013-05-17','16:30:00',10.69),('6449','2013-05-17','16:35:00',10.38),('6449','2013-05-17','16:40:00',10.09),('6449','2013-05-17','16:45:00',9.89),('6449','2013-05-17','16:50:00',9.54),('6449','2013-05-17','16:55:00',9.24),('6449','2013-05-17','17:00:00',8.8),('6449','2013-05-17','17:05:00',8.32),('6449','2013-05-17','17:10:00',8.15),('6449','2013-05-17','17:15:00',7.76),('6449','2013-05-17','17:20:00',7.51),('6449','2013-05-17','17:25:00',7.21),('6449','2013-05-17','17:30:00',6.81),('6449','2013-05-17','17:35:00',6.42),('6449','2013-05-17','17:40:00',6.09),('6449','2013-05-17','17:45:00',5.74),('6449','2013-05-17','17:50:00',5.32),('6449','2013-05-17','17:55:00',4.96),('6449','2013-05-17','18:00:00',4.66),('6449','2013-05-17','18:05:00',4.32),('6449','2013-05-17','18:10:00',3.94),('6449','2013-05-17','18:15:00',3.58),('6449','2013-05-17','18:20:00',3.23),('6449','2013-05-17','18:25:00',2.93),('6449','2013-05-17','18:30:00',2.58),('6449','2013-05-17','18:35:00',2.35),('6449','2013-05-17','18:40:00',1.97),('6449','2013-05-17','18:45:00',1.71),('6449','2013-05-17','18:50:00',1.37),('6449','2013-05-17','18:55:00',1.11),('6449','2013-05-17','19:00:00',1.02),('6449','2013-05-16','08:45:00',1.11),('6449','2013-05-16','08:50:00',1.83),('6449','2013-05-16','08:55:00',1.65),('6449','2013-05-16','09:00:00',1.3),('6449','2013-05-16','09:05:00',1.73),('6449','2013-05-16','09:10:00',2.72),('6449','2013-05-16','09:15:00',3.08),('6449','2013-05-16','09:20:00',4.33),('6449','2013-05-16','09:25:00',3.57),('6449','2013-05-16','09:30:00',4.9),('6449','2013-05-16','09:35:00',6.92),('6449','2013-05-16','09:40:00',11.9),('6449','2013-05-16','09:45:00',11.69),('6449','2013-05-16','09:50:00',12.73),('6449','2013-05-16','09:55:00',9.96),('6449','2013-05-16','10:00:00',5.32),('6449','2013-05-16','10:05:00',10.05),('6449','2013-05-16','10:10:00',7.54),('6449','2013-05-16','10:15:00',6.66),('6449','2013-05-16','10:20:00',7.31),('6449','2013-05-16','10:25:00',5.89),('6449','2013-05-16','10:30:00',2.83),('6449','2013-05-16','10:35:00',1.85),('6449','2013-05-16','10:40:00',2.93),('6449','2013-05-16','10:45:00',8.09),('6449','2013-05-16','10:50:00',6.97),('6449','2013-05-16','10:55:00',5.11),('6449','2013-05-16','11:00:00',3.83),('6449','2013-05-16','11:05:00',2.82),('6449','2013-05-16','11:10:00',2.2),('6449','2013-05-16','11:15:00',2.19),('6449','2013-05-16','11:20:00',2.85),('6449','2013-05-16','11:25:00',3.53),('6449','2013-05-16','11:30:00',2.85),('6449','2013-05-16','11:35:00',3.22),('6449','2013-05-16','11:40:00',4.76),('6449','2013-05-16','11:45:00',4.5),('6449','2013-05-16','11:50:00',4.73),('6449','2013-05-16','11:55:00',4.23),('6449','2013-05-16','12:00:00',3.5),('6449','2013-05-16','12:05:00',3.81),('6449','2013-05-16','12:10:00',5.86),('6449','2013-05-16','12:15:00',5.51),('6449','2013-05-16','12:20:00',7),('6449','2013-05-16','12:25:00',6.22),('6449','2013-05-16','12:30:00',8.42),('6449','2013-05-16','12:35:00',8.25),('6449','2013-05-16','12:40:00',7.2),('6449','2013-05-16','12:45:00',7.88),('6449','2013-05-16','12:50:00',11.19),('6449','2013-05-16','12:55:00',15.49),('6449','2013-05-16','13:00:00',16.01),('6449','2013-05-16','13:05:00',15.54),('6449','2013-05-16','13:10:00',14.4),('6449','2013-05-16','13:15:00',11.72),('6449','2013-05-16','13:20:00',15.92),('6449','2013-05-16','13:25:00',15.29),('6449','2013-05-16','13:30:00',15.09),('6449','2013-05-16','13:35:00',15.07),('6449','2013-05-16','13:40:00',15.16),('6449','2013-05-16','13:45:00',15.03),('6449','2013-05-16','13:50:00',14.82),('6449','2013-05-16','13:55:00',14.71),('6449','2013-05-16','14:00:00',14.47),('6449','2013-05-16','14:05:00',14.26),('6449','2013-05-16','14:10:00',14.18),('6449','2013-05-16','14:15:00',13.98),('6449','2013-05-16','14:20:00',13.89),('6449','2013-05-16','14:25:00',13.71),('6449','2013-05-16','14:30:00',13.78),('6449','2013-05-16','14:35:00',14.02),('6449','2013-05-16','14:40:00',13.76),('6449','2013-05-16','14:45:00',13.7),('6449','2013-05-16','14:50:00',13.51),('6449','2013-05-16','14:55:00',13.61),('6449','2013-05-16','15:00:00',13.5),('6449','2013-05-16','15:05:00',13.38),('6449','2013-05-16','15:10:00',13.21),('6449','2013-05-16','15:15:00',12.97),('6449','2013-05-16','15:20:00',12.8),('6449','2013-05-16','15:25:00',12.51),('6449','2013-05-16','15:30:00',12.18),('6449','2013-05-16','15:35:00',12.01),('6449','2013-05-16','15:40:00',11.63),('6449','2013-05-16','15:45:00',11.22),('6449','2013-05-16','15:50:00',10.58),('6449','2013-05-16','15:55:00',10.81),('6449','2013-05-16','16:00:00',10.66),('6449','2013-05-16','16:05:00',9.77),('6449','2013-05-16','16:10:00',10.26),('6449','2013-05-16','16:15:00',9.52),('6449','2013-05-16','16:20:00',9.58),('6449','2013-05-16','16:25:00',9.07),('6449','2013-05-16','16:30:00',8.88),('6449','2013-05-16','16:35:00',8.64),('6449','2013-05-16','16:40:00',8.25),('6449','2013-05-16','16:45:00',7.57),('6449','2013-05-16','16:50:00',5.96),('6449','2013-05-16','16:55:00',6.99),('6449','2013-05-16','17:00:00',5.52),('6449','2013-05-16','17:05:00',6.04),('6449','2013-05-16','17:10:00',6.58),('6449','2013-05-16','17:15:00',5.96),('6449','2013-05-16','17:20:00',6.01),('6449','2013-05-16','17:25:00',4.93),('6449','2013-05-16','17:30:00',4.76),('6449','2013-05-16','17:35:00',4.36),('6449','2013-05-16','17:40:00',4.91),('6449','2013-05-16','17:45:00',5.12),('6449','2013-05-16','17:50:00',3.65),('6449','2013-05-16','17:55:00',4.21),('6449','2013-05-16','18:00:00',4.21),('6449','2013-05-16','18:05:00',3.37),('6449','2013-05-16','18:10:00',2.79),('6449','2013-05-16','18:15:00',2.22),('6449','2013-05-16','18:20:00',1.75),('6449','2013-05-16','18:25:00',1.37),('6449','2013-05-16','18:30:00',1.88),('6449','2013-05-16','18:35:00',2),('6449','2013-05-16','18:40:00',1.94),('6449','2013-05-16','18:45:00',1.64),('6449','2013-05-16','18:50:00',1.18),('6449','2013-05-16','18:55:00',1.1),('6449','2013-05-16','19:00:00',1.26),('6449','2013-05-16','19:05:00',1.35),('6449','2013-05-16','19:10:00',1.33),('6449','2013-05-16','19:15:00',1.25),('6449','2013-05-16','19:20:00',1.14),('6449','2013-05-15','06:55:00',1.12),('6449','2013-05-15','07:00:00',1.14),('6449','2013-05-15','07:05:00',1.68),('6449','2013-05-15','07:10:00',2.14),('6449','2013-05-15','07:15:00',2.69),('6449','2013-05-15','07:20:00',3.3),('6449','2013-05-15','07:25:00',2.94),('6449','2013-05-15','07:30:00',3.95),('6449','2013-05-15','07:35:00',4.08),('6449','2013-05-15','07:40:00',4.52),('6449','2013-05-15','07:45:00',4.81),('6449','2013-05-15','07:50:00',4.48),('6449','2013-05-15','07:55:00',5.01),('6449','2013-05-15','08:00:00',5.78),('6449','2013-05-15','08:05:00',5.98),('6449','2013-05-15','08:10:00',6.48),('6449','2013-05-15','08:15:00',6.54),('6449','2013-05-15','08:20:00',7.17),('6449','2013-05-15','08:25:00',7.44),('6449','2013-05-15','08:30:00',7.71),('6449','2013-05-15','08:35:00',7.98),('6449','2013-05-15','08:40:00',8.34),('6449','2013-05-15','08:45:00',8.8),('6449','2013-05-15','08:50:00',8.95),('6449','2013-05-15','08:55:00',9.45),('6449','2013-05-15','09:00:00',9.51),('6449','2013-05-15','09:05:00',9.5),('6449','2013-05-15','09:10:00',9.69),('6449','2013-05-15','09:15:00',10.24),('6449','2013-05-15','09:20:00',10.8),('6449','2013-05-15','09:25:00',10.96),('6449','2013-05-15','09:30:00',10.67),('6449','2013-05-15','09:35:00',11.09),('6449','2013-05-15','09:40:00',11.89),('6449','2013-05-15','09:45:00',12.21),('6449','2013-05-15','09:50:00',12.2),('6449','2013-05-15','09:55:00',12.13),('6449','2013-05-15','10:00:00',12.49),('6449','2013-05-15','10:05:00',12.88),('6449','2013-05-15','10:10:00',13.14),('6449','2013-05-15','10:15:00',13.32),('6449','2013-05-15','10:20:00',13.51),('6449','2013-05-15','10:25:00',13.73),('6449','2013-05-15','10:30:00',13.2),('6449','2013-05-15','10:35:00',13.69),('6449','2013-05-15','10:40:00',14.07),('6449','2013-05-15','10:45:00',13.83),('6449','2013-05-15','10:50:00',14.83),('6449','2013-05-15','10:55:00',12.54),('6449','2013-05-15','11:00:00',14.54),('6449','2013-05-15','11:05:00',14.46),('6449','2013-05-15','11:10:00',14.84),('6449','2013-05-15','11:15:00',15.27),('6449','2013-05-15','11:20:00',15.68),('6449','2013-05-15','11:25:00',16.21),('6449','2013-05-15','11:30:00',14.06),('6449','2013-05-15','11:35:00',8.86),('6449','2013-05-15','11:40:00',13.22),('6449','2013-05-15','11:45:00',16.41),('6449','2013-05-15','11:50:00',16.63),('6449','2013-05-15','11:55:00',15.42),('6449','2013-05-15','12:00:00',11.12),('6449','2013-05-15','12:05:00',10.87),('6449','2013-05-15','12:10:00',14.35),('6449','2013-05-15','12:15:00',16.67),('6449','2013-05-15','12:20:00',15.49),('6449','2013-05-15','12:25:00',10.99),('6449','2013-05-15','12:30:00',8.96),('6449','2013-05-15','12:35:00',7.03),('6449','2013-05-15','12:40:00',6.66),('6449','2013-05-15','12:45:00',6.62),('6449','2013-05-15','12:50:00',6.59),('6449','2013-05-15','12:55:00',6.35),('6449','2013-05-15','13:00:00',6.52),('6449','2013-05-15','13:05:00',7.26),('6449','2013-05-15','13:10:00',8.09),('6449','2013-05-15','13:15:00',9.32),('6449','2013-05-15','13:20:00',9.31),('6449','2013-05-15','13:25:00',10.56),('6449','2013-05-15','13:30:00',7.51),('6449','2013-05-15','13:35:00',7.39),('6449','2013-05-15','13:40:00',7.29),('6449','2013-05-15','13:45:00',7.56),('6449','2013-05-15','13:50:00',5.87),('6449','2013-05-15','13:55:00',5.12),('6449','2013-05-15','14:00:00',5.5),('6449','2013-05-15','14:05:00',6.22),('6449','2013-05-15','14:10:00',7),('6449','2013-05-15','14:15:00',6.17),('6449','2013-05-15','14:20:00',5.67),('6449','2013-05-15','14:25:00',5.58),('6449','2013-05-15','14:30:00',5.5),('6449','2013-05-15','14:35:00',5.45),('6449','2013-05-15','14:40:00',4.98),('6449','2013-05-15','14:45:00',4.67),('6449','2013-05-15','14:50:00',4.48),('6449','2013-05-15','14:55:00',3.83),('6449','2013-05-15','15:00:00',3.38),('6449','2013-05-15','15:05:00',3.19),('6449','2013-05-15','15:10:00',3.34),('6449','2013-05-15','15:15:00',3.26),('6449','2013-05-15','15:20:00',3.52),('6449','2013-05-15','15:25:00',3.97),('6449','2013-05-15','15:30:00',4.35),('6449','2013-05-15','15:35:00',4.57),('6449','2013-05-15','15:40:00',7.04),('6449','2013-05-15','15:45:00',8.45),('6449','2013-05-15','15:50:00',9.42),('6449','2013-05-15','15:55:00',11.41),('6449','2013-05-15','16:00:00',10.44),('6449','2013-05-15','16:05:00',7.89),('6449','2013-05-15','16:10:00',6.04),('6449','2013-05-15','16:15:00',5.46),('6449','2013-05-15','16:20:00',7.87),('6449','2013-05-15','16:25:00',8.52),('6449','2013-05-15','16:30:00',8.78),('6449','2013-05-15','16:35:00',5.3),('6449','2013-05-15','16:40:00',5.06),('6449','2013-05-15','16:45:00',7.45),('6449','2013-05-15','16:50:00',7.83),('6449','2013-05-15','16:55:00',5.72),('6449','2013-05-15','17:00:00',6.77),('6449','2013-05-15','17:05:00',10),('6449','2013-05-15','17:10:00',7.75),('6449','2013-05-15','17:15:00',5.09),('6449','2013-05-15','17:20:00',3.64),('6449','2013-05-15','17:25:00',2.98),('6449','2013-05-15','17:30:00',2.21),('6449','2013-05-15','17:35:00',2.09),('6449','2013-05-15','17:40:00',1.68),('6449','2013-05-15','17:45:00',1.59),('6449','2013-05-15','17:50:00',1.59),('6449','2013-05-15','17:55:00',1.38),('6449','2013-05-15','18:00:00',1.38),('6449','2013-05-15','18:05:00',1.39),('6449','2013-05-15','18:10:00',1.03),('6449','2013-05-15','18:15:00',1.04),('6449','2013-05-15','18:20:00',1.16),('6449','2013-05-15','18:30:00',1.05),('6449','2013-05-15','18:35:00',1.46),('6449','2013-05-15','18:40:00',1.74),('6449','2013-05-15','18:45:00',1.77),('6449','2013-05-15','18:50:00',1.32),('6449','2013-05-15','18:55:00',1.44),('6449','2013-05-15','19:00:00',1.37),('6449','2013-05-14','06:55:00',1.2),('6449','2013-05-14','07:00:00',1.45),('6449','2013-05-14','07:05:00',1.79),('6449','2013-05-14','07:10:00',2.11),('6449','2013-05-14','07:15:00',2.45),('6449','2013-05-14','07:20:00',2.8),('6449','2013-05-14','07:25:00',3.16),('6449','2013-05-14','07:30:00',3.53),('6449','2013-05-14','07:35:00',3.91),('6449','2013-05-14','07:40:00',4.31),('6449','2013-05-14','07:45:00',4.67),('6449','2013-05-14','07:50:00',5.04),('6449','2013-05-14','07:55:00',5.44),('6449','2013-05-14','08:00:00',5.85),('6449','2013-05-14','08:05:00',6.24),('6449','2013-05-14','08:10:00',6.61),('6449','2013-05-14','08:15:00',6.94),('6449','2013-05-14','08:20:00',7.39),('6449','2013-05-14','08:25:00',7.73),('6449','2013-05-14','08:30:00',7.96),('6449','2013-05-14','08:35:00',8.38),('6449','2013-05-14','08:40:00',8.61),('6449','2013-05-14','08:45:00',8.89),('6449','2013-05-14','08:50:00',9.32),('6449','2013-05-14','08:55:00',9.58),('6449','2013-05-14','09:00:00',10.02),('6449','2013-05-14','09:05:00',10.35),('6449','2013-05-14','09:10:00',10.65),('6449','2013-05-14','09:15:00',10.95),('6449','2013-05-14','09:20:00',11.27),('6449','2013-05-14','09:25:00',11.51),('6449','2013-05-14','09:30:00',11.72),('6449','2013-05-14','09:35:00',11.96),('6449','2013-05-14','09:40:00',12.18),('6449','2013-05-14','09:45:00',12.42),('6449','2013-05-14','09:50:00',12.51),('6449','2013-05-14','09:55:00',12.78),('6449','2013-05-14','10:00:00',12.92),('6449','2013-05-14','10:05:00',13.02),('6449','2013-05-14','10:10:00',13.36),('6449','2013-05-14','10:15:00',13.59),('6449','2013-05-14','10:20:00',13.61),('6449','2013-05-14','10:25:00',13.93),('6449','2013-05-14','10:30:00',13.96),('6449','2013-05-14','10:35:00',13.85),('6449','2013-05-14','10:40:00',14.13),('6449','2013-05-14','10:45:00',14.21),('6449','2013-05-14','10:50:00',14.28),('6449','2013-05-14','10:55:00',14.38),('6449','2013-05-14','11:00:00',14.56),('6449','2013-05-14','11:05:00',14.68),('6449','2013-05-14','11:10:00',14.96),('6449','2013-05-14','11:15:00',15.27),('6449','2013-05-14','11:20:00',15.54),('6449','2013-05-14','11:25:00',15.71),('6449','2013-05-14','11:30:00',15.89),('6449','2013-05-14','11:35:00',16.02),('6449','2013-05-14','11:40:00',16.07),('6449','2013-05-14','11:45:00',16.08),('6449','2013-05-14','11:50:00',16.04),('6449','2013-05-14','11:55:00',16.25),('6449','2013-05-14','12:00:00',16.26),('6449','2013-05-14','12:05:00',16.11),('6449','2013-05-14','12:10:00',16.42),('6449','2013-05-14','12:15:00',16.49),('6449','2013-05-14','12:20:00',16.49),('6449','2013-05-14','12:25:00',16.46),('6449','2013-05-14','12:30:00',16.57),('6449','2013-05-14','12:35:00',16.54),('6449','2013-05-14','12:40:00',16.55),('6449','2013-05-14','12:45:00',16.61),('6449','2013-05-14','12:50:00',16.62),('6449','2013-05-14','12:55:00',16.62),('6449','2013-05-14','13:00:00',16.56),('6449','2013-05-14','13:05:00',16.62),('6449','2013-05-14','13:10:00',16.75),('6449','2013-05-14','13:15:00',16.67),('6449','2013-05-14','13:20:00',16.79),('6449','2013-05-14','13:25:00',16.85),('6449','2013-05-14','13:30:00',16.75),('6449','2013-05-14','13:35:00',16.45),('6449','2013-05-14','13:40:00',16.64),('6449','2013-05-14','13:45:00',16.54),('6449','2013-05-14','13:50:00',16.15),('6449','2013-05-14','13:55:00',16.34),('6449','2013-05-14','14:00:00',16.3),('6449','2013-05-14','14:05:00',16.16),('6449','2013-05-14','14:10:00',16.28),('6449','2013-05-14','14:15:00',16.17),('6449','2013-05-14','14:20:00',16.03),('6449','2013-05-14','14:25:00',15.99),('6449','2013-05-14','14:30:00',15.78),('6449','2013-05-14','14:35:00',15.63),('6449','2013-05-14','14:40:00',15.49),('6449','2013-05-14','14:45:00',15.32),('6449','2013-05-14','14:50:00',15.25),('6449','2013-05-14','14:55:00',15.22),('6449','2013-05-14','15:00:00',15.03),('6449','2013-05-14','15:05:00',14.97),('6449','2013-05-14','15:10:00',14.81),('6449','2013-05-14','15:15:00',14.56),('6449','2013-05-14','15:20:00',14.17),('6449','2013-05-14','15:25:00',14.2),('6449','2013-05-14','15:30:00',13.95),('6449','2013-05-14','15:35:00',13.6),('6449','2013-05-14','15:40:00',13.51),('6449','2013-05-14','15:45:00',13.29),('6449','2013-05-14','15:50:00',12.86),('6449','2013-05-14','15:55:00',12.72),('6449','2013-05-14','16:00:00',12.44),('6449','2013-05-14','16:05:00',12.22),('6449','2013-05-14','16:10:00',11.96),('6449','2013-05-14','16:15:00',11.74),('6449','2013-05-14','16:20:00',11.39),('6449','2013-05-14','16:25:00',11.13),('6449','2013-05-14','16:30:00',10.83),('6449','2013-05-14','16:35:00',10.47),('6449','2013-05-14','16:40:00',10.26),('6449','2013-05-14','16:45:00',9.9),('6449','2013-05-14','16:50:00',9.55),('6449','2013-05-14','16:55:00',9.25),('6449','2013-05-14','17:00:00',8.89),('6449','2013-05-14','17:05:00',8.43),('6449','2013-05-14','17:10:00',8.11),('6449','2013-05-14','17:15:00',7.88),('6449','2013-05-14','17:20:00',7.36),('6449','2013-05-14','17:25:00',7.09),('6449','2013-05-14','17:30:00',6.66),('6449','2013-05-14','17:35:00',6.28),('6449','2013-05-14','17:40:00',6),('6449','2013-05-14','17:45:00',5.63),('6449','2013-05-14','17:50:00',5.27),('6449','2013-05-14','17:55:00',4.85),('6449','2013-05-14','18:00:00',4.49),('6449','2013-05-14','18:05:00',4.16),('6449','2013-05-14','18:10:00',3.8),('6449','2013-05-14','18:15:00',3.47),('6449','2013-05-14','18:20:00',3.13),('6449','2013-05-14','18:25:00',2.82),('6449','2013-05-14','18:30:00',2.48),('6449','2013-05-14','18:35:00',2.2),('6449','2013-05-14','18:40:00',1.88),('6449','2013-05-14','18:45:00',1.63),('6449','2013-05-14','18:50:00',1.35),('6449','2013-05-14','18:55:00',1.14),('6449','2013-05-13','06:55:00',1.36),('6449','2013-05-13','07:00:00',1.83),('6449','2013-05-13','07:05:00',2.05),('6449','2013-05-13','07:10:00',2.27),('6449','2013-05-13','07:15:00',2.67),('6449','2013-05-13','07:20:00',3.15),('6449','2013-05-13','07:25:00',2.16),('6449','2013-05-13','07:30:00',1.27),('6449','2013-05-13','07:35:00',1.27),('6449','2013-05-13','07:40:00',2.76),('6449','2013-05-13','07:45:00',3.71),('6449','2013-05-13','07:50:00',2.16),('6449','2013-05-13','07:55:00',5.31),('6449','2013-05-13','08:00:00',5.51),('6449','2013-05-13','08:05:00',5.82),('6449','2013-05-13','08:10:00',6.24),('6449','2013-05-13','08:15:00',6.7),('6449','2013-05-13','08:20:00',7),('6449','2013-05-13','08:25:00',7.2),('6449','2013-05-13','08:30:00',7.56),('6449','2013-05-13','08:35:00',7.88),('6449','2013-05-13','08:40:00',8.15),('6449','2013-05-13','08:45:00',8.51),('6449','2013-05-13','08:50:00',8.95),('6449','2013-05-13','08:55:00',9.12),('6449','2013-05-13','09:00:00',9.51),('6449','2013-05-13','09:05:00',9.67),('6449','2013-05-13','09:10:00',10.18),('6449','2013-05-13','09:15:00',10.47),('6449','2013-05-13','09:20:00',10.94),('6449','2013-05-13','09:25:00',11.27),('6449','2013-05-13','09:30:00',11.38),('6449','2013-05-13','09:35:00',11.58),('6449','2013-05-13','09:40:00',12.09),('6449','2013-05-13','09:45:00',12.22),('6449','2013-05-13','09:50:00',12.3),('6449','2013-05-13','09:55:00',12.7),('6449','2013-05-13','10:00:00',13.12),('6449','2013-05-13','10:05:00',12.16),('6449','2013-05-13','10:10:00',3.09),('6449','2013-05-13','10:15:00',9.48),('6449','2013-05-13','10:20:00',13.95),('6449','2013-05-13','10:25:00',14.29),('6449','2013-05-13','10:30:00',13.84),('6449','2013-05-13','10:35:00',11.02),('6449','2013-05-13','10:40:00',15.35),('6449','2013-05-13','10:45:00',12.21),('6449','2013-05-13','10:50:00',13.49),('6449','2013-05-13','10:55:00',13.48),('6449','2013-05-13','11:00:00',15.58),('6449','2013-05-13','11:05:00',14.38),('6449','2013-05-13','11:10:00',13.89),('6449','2013-05-13','11:15:00',4.74),('6449','2013-05-13','11:20:00',3.76),('6449','2013-05-13','11:25:00',9.25),('6449','2013-05-13','11:30:00',6.73),('6449','2013-05-13','11:35:00',8.34),('6449','2013-05-13','11:40:00',4.11),('6449','2013-05-13','11:45:00',3.79),('6449','2013-05-13','11:50:00',5.69),('6449','2013-05-13','11:55:00',9.91),('6449','2013-05-13','12:00:00',3.98),('6449','2013-05-13','12:05:00',5.62),('6449','2013-05-13','12:10:00',17.75),('6449','2013-05-13','12:15:00',17.46),('6449','2013-05-13','12:20:00',17.06),('6449','2013-05-13','12:25:00',17.04),('6449','2013-05-13','12:30:00',16.98),('6449','2013-05-13','12:35:00',17.03),('6449','2013-05-13','12:40:00',17.5),('6449','2013-05-13','12:45:00',17.66),('6449','2013-05-13','12:50:00',17.72),('6449','2013-05-13','12:55:00',17.53),('6449','2013-05-13','13:00:00',17.03),('6449','2013-05-13','13:05:00',16.65),('6449','2013-05-13','13:10:00',17.03),('6449','2013-05-13','13:15:00',17.55),('6449','2013-05-13','13:20:00',14.25),('6449','2013-05-13','13:25:00',17.66),('6449','2013-05-13','13:30:00',17.14),('6449','2013-05-13','13:35:00',16.91),('6449','2013-05-13','13:40:00',16.67),('6449','2013-05-13','13:45:00',16.75),('6449','2013-05-13','13:50:00',16.98),('6449','2013-05-13','13:55:00',17.29),('6449','2013-05-13','14:00:00',16.43),('6449','2013-05-13','14:05:00',16.16),('6449','2013-05-13','14:10:00',15.94),('6449','2013-05-13','14:15:00',16.2),('6449','2013-05-13','14:20:00',15.4),('6449','2013-05-13','14:25:00',15.82),('6449','2013-05-13','14:30:00',15.84),('6449','2013-05-13','14:35:00',15.76),('6449','2013-05-13','14:40:00',15.74),('6449','2013-05-13','14:45:00',15.76),('6449','2013-05-13','14:50:00',15.61),('6449','2013-05-13','14:55:00',15.5),('6449','2013-05-13','15:00:00',15.13),('6449','2013-05-13','15:05:00',14.77),('6449','2013-05-13','15:10:00',14.64),('6449','2013-05-13','15:15:00',14.7),('6449','2013-05-13','15:20:00',14.35),('6449','2013-05-13','15:25:00',14.2),('6449','2013-05-13','15:30:00',14.03),('6449','2013-05-13','15:35:00',13.82),('6449','2013-05-13','15:40:00',13.53),('6449','2013-05-13','15:45:00',13.33),('6449','2013-05-13','15:50:00',13.09),('6449','2013-05-13','15:55:00',12.89),('6449','2013-05-13','16:00:00',12.63),('6449','2013-05-13','16:05:00',12.2),('6449','2013-05-13','16:10:00',12.11),('6449','2013-05-13','16:15:00',11.83),('6449','2013-05-13','16:20:00',11.56),('6449','2013-05-13','16:25:00',11.23),('6449','2013-05-13','16:30:00',10.82),('6449','2013-05-13','16:35:00',10.64),('6449','2013-05-13','16:40:00',10.11),('6449','2013-05-13','16:45:00',9.89),('6449','2013-05-13','16:50:00',9.46),('6449','2013-05-13','16:55:00',9.11),('6449','2013-05-13','17:00:00',8.72),('6449','2013-05-13','17:05:00',8.37),('6449','2013-05-13','17:10:00',7.99),('6449','2013-05-13','17:15:00',7.63),('6449','2013-05-13','17:20:00',7.31),('6449','2013-05-13','17:25:00',7.07),('6449','2013-05-13','17:30:00',6.74),('6449','2013-05-13','17:35:00',6.36),('6449','2013-05-13','17:40:00',5.89),('6449','2013-05-13','17:45:00',5.6),('6449','2013-05-13','17:50:00',5.2),('6449','2013-05-13','17:55:00',4.7),('6449','2013-05-13','18:00:00',1.16),('6449','2013-05-13','18:05:00',1.19),('6449','2013-05-13','18:10:00',2.34),('6449','2013-05-13','18:15:00',3.16),('6449','2013-05-13','18:20:00',3.26),('6449','2013-05-13','18:25:00',3),('6449','2013-05-13','18:30:00',1.97),('6449','2013-05-13','18:35:00',2.5),('6449','2013-05-13','18:40:00',2.29),('6449','2013-05-13','18:45:00',2.1),('6449','2013-05-13','18:50:00',2.09),('6449','2013-05-13','18:55:00',2.11),('6449','2013-05-13','19:00:00',2.03),('6449','2013-05-13','19:05:00',1.76),('6449','2013-05-13','19:10:00',1.46),('6449','2013-05-13','19:15:00',1.19),('6449','2013-05-12','06:45:00',1),('6449','2013-05-12','06:50:00',1.15),('6449','2013-05-12','06:55:00',1.26),('6449','2013-05-12','07:00:00',1.08),('6449','2013-05-12','07:05:00',1.79),('6449','2013-05-12','07:10:00',1.83),('6449','2013-05-12','07:15:00',1.8),('6449','2013-05-12','07:20:00',1.45),('6449','2013-05-12','07:25:00',1.27),('6449','2013-05-12','07:30:00',1.61),('6449','2013-05-12','07:35:00',1.81),('6449','2013-05-12','07:40:00',2.24),('6449','2013-05-12','07:45:00',3.71),('6449','2013-05-12','07:50:00',4.93),('6449','2013-05-12','07:55:00',4.3),('6449','2013-05-12','08:00:00',4.95),('6449','2013-05-12','08:05:00',5.61),('6449','2013-05-12','08:10:00',4.03),('6449','2013-05-12','08:15:00',3.26),('6449','2013-05-12','08:20:00',3.83),('6449','2013-05-12','08:25:00',7.8),('6449','2013-05-12','08:30:00',6.49),('6449','2013-05-12','08:35:00',5),('6449','2013-05-12','08:40:00',7.04),('6449','2013-05-12','08:45:00',9.44),('6449','2013-05-12','08:50:00',10.24),('6449','2013-05-12','08:55:00',10.43),('6449','2013-05-12','09:00:00',10.58),('6449','2013-05-12','09:05:00',9.76),('6449','2013-05-12','09:10:00',10.99),('6449','2013-05-12','09:15:00',6.65),('6449','2013-05-12','09:20:00',3.99),('6449','2013-05-12','09:25:00',3.84),('6449','2013-05-12','09:30:00',2.8),('6449','2013-05-12','09:35:00',5.8),('6449','2013-05-12','09:40:00',7.31),('6449','2013-05-12','09:45:00',7.54),('6449','2013-05-12','09:50:00',11.17),('6449','2013-05-12','09:55:00',6.37),('6449','2013-05-12','10:00:00',13.45),('6449','2013-05-12','10:05:00',13.47),('6449','2013-05-12','10:10:00',13.26),('6449','2013-05-12','10:15:00',13.63),('6449','2013-05-12','10:20:00',13.69),('6449','2013-05-12','10:25:00',13.93),('6449','2013-05-12','10:30:00',14.08),('6449','2013-05-12','10:35:00',14.22),('6449','2013-05-12','10:40:00',14.26),('6449','2013-05-12','10:45:00',14.57),('6449','2013-05-12','10:50:00',14.67),('6449','2013-05-12','10:55:00',14.9),('6449','2013-05-12','11:00:00',14.96),('6449','2013-05-12','11:05:00',15.11),('6449','2013-05-12','11:10:00',15.13),('6449','2013-05-12','11:15:00',15.4),('6449','2013-05-12','11:20:00',15.38),('6449','2013-05-12','11:25:00',15.75),('6449','2013-05-12','11:30:00',15.91),('6449','2013-05-12','11:35:00',16.03),('6449','2013-05-12','11:40:00',16.09),('6449','2013-05-12','11:45:00',16.12),('6449','2013-05-12','11:50:00',16.09),('6449','2013-05-12','11:55:00',15.86),('6449','2013-05-12','12:00:00',16.12),('6449','2013-05-12','12:05:00',16.22),('6449','2013-05-12','12:10:00',16.34),('6449','2013-05-12','12:15:00',16.38),('6449','2013-05-12','12:20:00',16.44),('6449','2013-05-12','12:25:00',16.38),('6449','2013-05-12','12:30:00',16.56),('6449','2013-05-12','12:35:00',16.55),('6449','2013-05-12','12:40:00',16.54),('6449','2013-05-12','12:45:00',16.65),('6449','2013-05-12','12:50:00',16.69),('6449','2013-05-12','12:55:00',16.74),('6449','2013-05-12','13:00:00',16.75),('6449','2013-05-12','13:05:00',16.44),('6449','2013-05-12','13:10:00',16.57),('6449','2013-05-12','13:15:00',16.56),('6449','2013-05-12','13:20:00',16.58),('6449','2013-05-12','13:25:00',16.58),('6449','2013-05-12','13:30:00',16.5),('6449','2013-05-12','13:35:00',16.39),('6449','2013-05-12','13:40:00',16.44),('6449','2013-05-12','13:45:00',16.32),('6449','2013-05-12','13:50:00',16.04),('6449','2013-05-12','13:55:00',15.92),('6449','2013-05-12','14:00:00',16.18),('6449','2013-05-12','14:05:00',15.14),('6449','2013-05-12','14:10:00',15.75),('6449','2013-05-12','14:15:00',15.95),('6449','2013-05-12','14:20:00',15.85),('6449','2013-05-12','14:25:00',15.67),('6449','2013-05-12','14:30:00',15.55),('6449','2013-05-12','14:35:00',15.52),('6449','2013-05-12','14:40:00',15.39),('6449','2013-05-12','14:45:00',15.12),('6449','2013-05-12','14:50:00',14.93),('6449','2013-05-12','14:55:00',14.81),('6449','2013-05-12','15:00:00',14.63),('6449','2013-05-12','15:05:00',14.48),('6449','2013-05-12','15:10:00',14.38),('6449','2013-05-12','15:15:00',14.05),('6449','2013-05-12','15:20:00',13.78),('6449','2013-05-12','15:25:00',13.66),('6449','2013-05-12','15:30:00',12.74),('6449','2013-05-12','15:35:00',13.42),('6449','2013-05-12','15:40:00',12.42),('6449','2013-05-12','15:45:00',11.58),('6449','2013-05-12','15:50:00',10.74),('6449','2013-05-12','15:55:00',12.13),('6449','2013-05-12','16:00:00',12.11),('6449','2013-05-12','16:05:00',12.15),('6449','2013-05-12','16:10:00',11.84),('6449','2013-05-12','16:15:00',11.73),('6449','2013-05-12','16:20:00',11.14),('6449','2013-05-12','16:25:00',11.13),('6449','2013-05-12','16:30:00',11.01),('6449','2013-05-12','16:35:00',9.05),('6449','2013-05-12','16:40:00',5.51),('6449','2013-05-12','16:45:00',8.58),('6449','2013-05-12','16:50:00',10.55),('6449','2013-05-12','16:55:00',9.34),('6449','2013-05-12','17:00:00',8.67),('6449','2013-05-12','17:05:00',8.24),('6449','2013-05-12','17:10:00',8.28),('6449','2013-05-12','17:15:00',8.12),('6449','2013-05-12','17:20:00',7.46),('6449','2013-05-12','17:25:00',6.45),('6449','2013-05-12','17:30:00',8.16),('6449','2013-05-12','17:35:00',7.59),('6449','2013-05-12','17:40:00',7.59),('6449','2013-05-12','17:45:00',6.69),('6449','2013-05-12','17:50:00',6.16),('6449','2013-05-12','17:55:00',5.55),('6449','2013-05-12','18:00:00',5.03),('6449','2013-05-12','18:05:00',4.64),('6449','2013-05-12','18:10:00',4.36),('6449','2013-05-12','18:15:00',4.07),('6449','2013-05-12','18:20:00',3.69),('6449','2013-05-12','18:25:00',3.42),('6449','2013-05-12','18:30:00',3.42),('6449','2013-05-12','18:35:00',3.52),('6449','2013-05-12','18:40:00',3.49),('6449','2013-05-12','18:45:00',3.65),('6449','2013-05-12','18:50:00',3.32),('6449','2013-05-12','18:55:00',2.44),('6449','2013-05-12','19:00:00',1.74),('6449','2013-05-12','19:05:00',1.41),('6449','2013-05-12','19:10:00',1.18),('6449','2013-05-12','19:15:00',1.04),('6449','2013-05-12','19:20:00',1.05),('6449','2013-05-12','19:25:00',1.06),('6449','2013-05-11','07:10:00',1.27),('6449','2013-05-11','07:15:00',1.62),('6449','2013-05-11','07:20:00',1.53),('6449','2013-05-11','07:25:00',2.28),('6449','2013-05-11','07:30:00',3.22),('6449','2013-05-11','07:35:00',3.66),('6449','2013-05-11','07:40:00',4),('6449','2013-05-11','07:45:00',4.48),('6449','2013-05-11','07:50:00',5.27),('6449','2013-05-11','07:55:00',6.34),('6449','2013-05-11','08:00:00',6.5),('6449','2013-05-11','08:05:00',4.23),('6449','2013-05-11','08:10:00',5.11),('6449','2013-05-11','08:15:00',5.45),('6449','2013-05-11','08:20:00',3.9),('6449','2013-05-11','08:25:00',7.82),('6449','2013-05-11','08:30:00',6.87),('6449','2013-05-11','08:35:00',4.03),('6449','2013-05-11','08:40:00',5.61),('6449','2013-05-11','08:45:00',6.02),('6449','2013-05-11','08:50:00',9.4),('6449','2013-05-11','08:55:00',9.81),('6449','2013-05-11','09:00:00',8.79),('6449','2013-05-11','09:05:00',5.68),('6449','2013-05-11','09:10:00',10.6),('6449','2013-05-11','09:15:00',10.77),('6449','2013-05-11','09:20:00',9.65),('6449','2013-05-11','09:25:00',4.34),('6449','2013-05-11','09:30:00',4.38),('6449','2013-05-11','09:35:00',2.76),('6449','2013-05-11','09:40:00',4.18),('6449','2013-05-11','09:45:00',13.73),('6449','2013-05-11','09:50:00',14.27),('6449','2013-05-11','09:55:00',7.74),('6449','2013-05-11','10:00:00',11.72),('6449','2013-05-11','10:05:00',13.55),('6449','2013-05-11','10:10:00',13.22),('6449','2013-05-11','10:15:00',13.66),('6449','2013-05-11','10:20:00',14.31),('6449','2013-05-11','10:25:00',15.42),('6449','2013-05-11','10:30:00',12.98),('6449','2013-05-11','10:35:00',13.65),('6449','2013-05-11','10:40:00',10.15),('6449','2013-05-11','10:45:00',8.34),('6449','2013-05-11','10:50:00',9.93),('6449','2013-05-11','10:55:00',6.44),('6449','2013-05-11','11:00:00',7.09),('6449','2013-05-11','11:05:00',15.76),('6449','2013-05-11','11:10:00',13.19),('6449','2013-05-11','11:15:00',16.44),('6449','2013-05-11','11:20:00',15.1),('6449','2013-05-11','11:25:00',11.21),('6449','2013-05-11','11:30:00',9.24),('6449','2013-05-11','11:35:00',6.9),('6449','2013-05-11','11:40:00',7.52),('6449','2013-05-11','11:45:00',8.74),('6449','2013-05-11','11:50:00',8.88),('6449','2013-05-11','11:55:00',10),('6449','2013-05-11','12:00:00',9.05),('6449','2013-05-11','12:05:00',11.37),('6449','2013-05-11','12:10:00',11.71),('6449','2013-05-11','12:15:00',9.8),('6449','2013-05-11','12:20:00',11.31),('6449','2013-05-11','12:25:00',11.52),('6449','2013-05-11','12:30:00',13.35),('6449','2013-05-11','12:35:00',11.13),('6449','2013-05-11','12:40:00',11.29),('6449','2013-05-11','12:45:00',4.38),('6449','2013-05-11','12:50:00',4.38),('6449','2013-05-11','12:55:00',6.07),('6449','2013-05-11','13:00:00',6.26),('6449','2013-05-11','13:05:00',9.21),('6449','2013-05-11','13:10:00',10.02),('6449','2013-05-11','13:15:00',12.38),('6449','2013-05-11','13:20:00',10.24),('6449','2013-05-11','13:25:00',7.96),('6449','2013-05-11','13:30:00',12.29),('6449','2013-05-11','13:35:00',13.74),('6449','2013-05-11','13:40:00',15.8),('6449','2013-05-11','13:45:00',16.95),('6449','2013-05-11','13:50:00',16.58),('6449','2013-05-11','13:55:00',16.55),('6449','2013-05-11','14:00:00',16.21),('6449','2013-05-11','14:05:00',16.41),('6449','2013-05-11','14:10:00',16.36),('6449','2013-05-11','14:15:00',16.21),('6449','2013-05-11','14:20:00',16.16),('6449','2013-05-11','14:25:00',16.04),('6449','2013-05-11','14:30:00',15.78),('6449','2013-05-11','14:35:00',15.76),('6449','2013-05-11','14:40:00',15.65),('6449','2013-05-11','14:45:00',15.37),('6449','2013-05-11','14:50:00',15.5),('6449','2013-05-11','14:55:00',15.83),('6449','2013-05-11','15:00:00',15.01),('6449','2013-05-11','15:05:00',14.54),('6449','2013-05-11','15:10:00',12.67),('6449','2013-05-11','15:15:00',14.72),('6449','2013-05-11','15:20:00',12.25),('6449','2013-05-11','15:25:00',15.3),('6449','2013-05-11','15:30:00',14.7),('6449','2013-05-11','15:35:00',9.77),('6449','2013-05-11','15:40:00',14.32),('6449','2013-05-11','15:45:00',11.96),('6449','2013-05-11','15:50:00',12.51),('6449','2013-05-11','15:55:00',7.93),('6449','2013-05-11','16:00:00',10.05),('6449','2013-05-11','16:05:00',5.49),('6449','2013-05-11','16:10:00',9.18),('6449','2013-05-11','16:15:00',10.66),('6449','2013-05-11','16:20:00',11.06),('6449','2013-05-11','16:25:00',11.39),('6449','2013-05-11','16:30:00',10.98),('6449','2013-05-11','16:35:00',10.69),('6449','2013-05-11','16:40:00',10.56),('6449','2013-05-11','16:45:00',10.24),('6449','2013-05-11','16:50:00',9.77),('6449','2013-05-11','16:55:00',9.26),('6449','2013-05-11','17:00:00',9.3),('6449','2013-05-11','17:05:00',9.12),('6449','2013-05-11','17:10:00',8.32),('6449','2013-05-11','17:15:00',8.18),('6449','2013-05-11','17:20:00',7.01),('6449','2013-05-11','17:25:00',7.32),('6449','2013-05-11','17:30:00',6.52),('6449','2013-05-11','17:35:00',7.41),('6449','2013-05-11','17:40:00',7.36),('6449','2013-05-11','17:45:00',5.6),('6449','2013-05-11','17:50:00',5.51),('6449','2013-05-11','17:55:00',5.13),('6449','2013-05-11','18:00:00',4.6),('6449','2013-05-11','18:05:00',3.99),('6449','2013-05-11','18:10:00',3.99),('6449','2013-05-11','18:15:00',3.15),('6449','2013-05-11','18:20:00',3.4),('6449','2013-05-11','18:25:00',3.01),('6449','2013-05-11','18:30:00',2.65),('6449','2013-05-11','18:35:00',2.47),('6449','2013-05-11','18:40:00',2.1),('6449','2013-05-11','18:45:00',2.06),('6449','2013-05-11','18:50:00',1.79),('6449','2013-05-11','18:55:00',1.54),('6449','2013-05-11','19:00:00',1.43),('6449','2013-05-11','19:05:00',1.35),('6449','2013-05-11','19:10:00',1.01),('6449','2013-05-11','19:15:00',1),('6449','2013-05-10','06:30:00',1.08),('6449','2013-05-10','06:35:00',1.16),('6449','2013-05-10','06:40:00',1.28),('6449','2013-05-10','06:45:00',1.42),('6449','2013-05-10','06:50:00',1.56),('6449','2013-05-10','06:55:00',2.05),('6449','2013-05-10','07:00:00',2.12),('6449','2013-05-10','07:05:00',2.52),('6449','2013-05-10','07:10:00',3.25),('6449','2013-05-10','07:15:00',3.44),('6449','2013-05-10','07:20:00',3.5),('6449','2013-05-10','07:25:00',3.55),('6449','2013-05-10','07:30:00',3.46),('6449','2013-05-10','07:35:00',2.9),('6449','2013-05-10','07:40:00',2.55),('6449','2013-05-10','07:45:00',2.64),('6449','2013-05-10','07:50:00',4.33),('6449','2013-05-10','07:55:00',3.05),('6449','2013-05-10','08:00:00',2.26),('6449','2013-05-10','08:05:00',3.41),('6449','2013-05-10','08:10:00',3.81),('6449','2013-05-10','08:15:00',4.05),('6449','2013-05-10','08:20:00',4.34),('6449','2013-05-10','08:25:00',5.5),('6449','2013-05-10','08:30:00',7.59),('6449','2013-05-10','08:35:00',7.27),('6449','2013-05-10','08:40:00',7.64),('6449','2013-05-10','08:45:00',8.56),('6449','2013-05-10','08:50:00',6.91),('6449','2013-05-10','08:55:00',8.04),('6449','2013-05-10','09:00:00',7.08),('6449','2013-05-10','09:05:00',4.18),('6449','2013-05-10','09:10:00',4.56),('6449','2013-05-10','09:15:00',7.14),('6449','2013-05-10','09:20:00',8.43),('6449','2013-05-10','09:25:00',6.63),('6449','2013-05-10','09:30:00',5.34),('6449','2013-05-10','09:35:00',13.29),('6449','2013-05-10','09:40:00',12.54),('6449','2013-05-10','09:45:00',6.39),('6449','2013-05-10','09:50:00',9.21),('6449','2013-05-10','09:55:00',12.9),('6449','2013-05-10','10:00:00',12.09),('6449','2013-05-10','10:05:00',12.7),('6449','2013-05-10','10:10:00',13.08),('6449','2013-05-10','10:15:00',13.66),('6449','2013-05-10','10:20:00',11.39),('6449','2013-05-10','10:25:00',12.41),('6449','2013-05-10','10:30:00',13.49),('6449','2013-05-10','10:35:00',12.55),('6449','2013-05-10','10:40:00',11.65),('6449','2013-05-10','10:45:00',12.42),('6449','2013-05-10','10:50:00',13.76),('6449','2013-05-10','10:55:00',9.41),('6449','2013-05-10','11:00:00',13.55),('6449','2013-05-10','11:05:00',9.85),('6449','2013-05-10','11:10:00',7.7),('6449','2013-05-10','11:15:00',7.44),('6449','2013-05-10','11:20:00',10.2),('6449','2013-05-10','11:25:00',13.11),('6449','2013-05-10','11:30:00',15.64),('6449','2013-05-10','11:35:00',12.94),('6449','2013-05-10','11:40:00',15.3),('6449','2013-05-10','11:45:00',17.82),('6449','2013-05-10','11:50:00',16.74),('6449','2013-05-10','11:55:00',10.94),('6449','2013-05-10','12:00:00',13.43),('6449','2013-05-10','12:05:00',17.49),('6449','2013-05-10','12:10:00',19.01),('6449','2013-05-10','12:15:00',11.55),('6449','2013-05-10','12:20:00',16.49),('6449','2013-05-10','12:25:00',12.01),('6449','2013-05-10','12:30:00',13.58),('6449','2013-05-10','12:35:00',8.75),('6449','2013-05-10','12:40:00',11.27),('6449','2013-05-10','12:45:00',14.01),('6449','2013-05-10','12:50:00',13.63),('6449','2013-05-10','12:55:00',11.63),('6449','2013-05-10','13:00:00',16.18),('6449','2013-05-10','13:05:00',18.48),('6449','2013-05-10','13:10:00',18.16),('6449','2013-05-10','13:15:00',14.66),('6449','2013-05-10','13:20:00',12.79),('6449','2013-05-10','13:25:00',10.39),('6449','2013-05-10','13:30:00',10.07),('6449','2013-05-10','13:35:00',10.71),('6449','2013-05-10','13:40:00',9.09),('6449','2013-05-10','13:45:00',7.75),('6449','2013-05-10','13:50:00',8.71),('6449','2013-05-10','13:55:00',9.35),('6449','2013-05-10','14:00:00',9.04),('6449','2013-05-10','14:05:00',9.51),('6449','2013-05-10','14:10:00',8.81),('6449','2013-05-10','14:15:00',8.24),('6449','2013-05-10','14:20:00',8.07),('6449','2013-05-10','14:25:00',8.45),('6449','2013-05-10','14:30:00',8.06),('6449','2013-05-10','14:35:00',8.34),('6449','2013-05-10','14:40:00',8.8),('6449','2013-05-10','14:45:00',7.66),('6449','2013-05-10','14:50:00',7.61),('6449','2013-05-10','14:55:00',9.01),('6449','2013-05-10','15:00:00',12.7),('6449','2013-05-10','15:05:00',9.17),('6449','2013-05-10','15:10:00',7.39),('6449','2013-05-10','15:15:00',7.25),('6449','2013-05-10','15:20:00',7.02),('6449','2013-05-10','15:25:00',6.95),('6449','2013-05-10','15:30:00',6.97),('6449','2013-05-10','15:35:00',8.61),('6449','2013-05-10','15:40:00',7.65),('6449','2013-05-10','15:45:00',6.35),('6449','2013-05-10','15:50:00',5.18),('6449','2013-05-10','15:55:00',5.27),('6449','2013-05-10','16:00:00',7.08),('6449','2013-05-10','16:05:00',8.04),('6449','2013-05-10','16:10:00',8.05),('6449','2013-05-10','16:15:00',7.34),('6449','2013-05-10','16:20:00',6.97),('6449','2013-05-10','16:25:00',6.75),('6449','2013-05-10','16:30:00',6.75),('6449','2013-05-10','16:35:00',6.72),('6449','2013-05-10','16:40:00',6.32),('6449','2013-05-10','16:45:00',5.63),('6449','2013-05-10','16:50:00',4.86),('6449','2013-05-10','16:55:00',4.88),('6449','2013-05-10','17:00:00',4.9),('6449','2013-05-10','17:05:00',4.49),('6449','2013-05-10','17:10:00',4.17),('6449','2013-05-10','17:15:00',4.06),('6449','2013-05-10','17:20:00',4.07),('6449','2013-05-10','17:25:00',3.87),('6449','2013-05-10','17:30:00',3.19),('6449','2013-05-10','17:35:00',2.71),('6449','2013-05-10','17:40:00',2.45),('6449','2013-05-10','17:45:00',2.07),('6449','2013-05-10','17:50:00',1.88),('6449','2013-05-10','17:55:00',2.08),('6449','2013-05-10','18:00:00',2.42),('6449','2013-05-10','18:05:00',2.55),('6449','2013-05-10','18:10:00',2.35),('6449','2013-05-10','18:15:00',2.2),('6449','2013-05-10','18:20:00',1.82),('6449','2013-05-10','18:25:00',1.52),('6449','2013-05-10','18:30:00',1.28),('6449','2013-05-10','18:35:00',1.11),('6449','2013-05-10','18:40:00',1.07),('6449','2013-05-10','18:45:00',1.22),('6449','2013-05-10','18:50:00',1.22),('6449','2013-05-10','18:55:00',1.04),('6449','2013-05-09','06:55:00',1.15),('6449','2013-05-09','07:00:00',1.36),('6449','2013-05-09','07:05:00',1.63),('6449','2013-05-09','07:10:00',1.89),('6449','2013-05-09','07:15:00',2.21),('6449','2013-05-09','07:20:00',2.55),('6449','2013-05-09','07:25:00',2.87),('6449','2013-05-09','07:30:00',3.21),('6449','2013-05-09','07:35:00',3.58),('6449','2013-05-09','07:40:00',3.93),('6449','2013-05-09','07:45:00',4.29),('6449','2013-05-09','07:50:00',4.56),('6449','2013-05-09','07:55:00',4.94),('6449','2013-05-09','08:00:00',5.47),('6449','2013-05-09','08:05:00',5.79),('6449','2013-05-09','08:10:00',6.08),('6449','2013-05-09','08:15:00',6.52),('6449','2013-05-09','08:20:00',6.86),('6449','2013-05-09','08:25:00',7.14),('6449','2013-05-09','08:30:00',7.64),('6449','2013-05-09','08:35:00',7.92),('6449','2013-05-09','08:40:00',8.3),('6449','2013-05-09','08:45:00',8.62),('6449','2013-05-09','08:50:00',8.96),('6449','2013-05-09','08:55:00',9.35),('6449','2013-05-09','09:00:00',9.66),('6449','2013-05-09','09:05:00',9.95),('6449','2013-05-09','09:10:00',10.32),('6449','2013-05-09','09:15:00',10.56),('6449','2013-05-09','09:20:00',10.84),('6449','2013-05-09','09:25:00',11.12),('6449','2013-05-09','09:30:00',11.38),('6449','2013-05-09','09:35:00',11.69),('6449','2013-05-09','09:40:00',11.9),('6449','2013-05-09','09:45:00',12.09),('6449','2013-05-09','09:50:00',12.34),('6449','2013-05-09','09:55:00',12.33),('6449','2013-05-09','10:00:00',12.59),('6449','2013-05-09','10:05:00',12.79),('6449','2013-05-09','10:10:00',12.95),('6449','2013-05-09','10:15:00',13.04),('6449','2013-05-09','10:20:00',13.18),('6449','2013-05-09','10:25:00',13.39),('6449','2013-05-09','10:30:00',13.63),('6449','2013-05-09','10:35:00',14),('6449','2013-05-09','10:40:00',14.21),('6449','2013-05-09','10:45:00',14.31),('6449','2013-05-09','10:50:00',14.45),('6449','2013-05-09','10:55:00',14.63),('6449','2013-05-09','11:00:00',14.85),('6449','2013-05-09','11:05:00',14.89),('6449','2013-05-09','11:10:00',15),('6449','2013-05-09','11:15:00',15.18),('6449','2013-05-09','11:20:00',15.27),('6449','2013-05-09','11:25:00',15.32),('6449','2013-05-09','11:30:00',15.57),('6449','2013-05-09','11:35:00',15.74),('6449','2013-05-09','11:40:00',15.77),('6449','2013-05-09','11:45:00',16.05),('6449','2013-05-09','11:50:00',16.29),('6449','2013-05-09','11:55:00',16.35),('6449','2013-05-09','12:00:00',16.42),('6449','2013-05-09','12:05:00',16.35),('6449','2013-05-09','12:10:00',16.32),('6449','2013-05-09','12:15:00',16.35),('6449','2013-05-09','12:20:00',16.46),('6449','2013-05-09','12:25:00',16.61),('6449','2013-05-09','12:30:00',16.66),('6449','2013-05-09','12:35:00',16.7),('6449','2013-05-09','12:40:00',16.56),('6449','2013-05-09','12:45:00',16.78),('6449','2013-05-09','12:50:00',16.76),('6449','2013-05-09','12:55:00',16.89),('6449','2013-05-09','13:00:00',16.93),('6449','2013-05-09','13:05:00',17.01),('6449','2013-05-09','13:10:00',16.89),('6449','2013-05-09','13:15:00',16.9),('6449','2013-05-09','13:20:00',17),('6449','2013-05-09','13:25:00',16.66),('6449','2013-05-09','13:30:00',16.68),('6449','2013-05-09','13:35:00',16.7),('6449','2013-05-09','13:40:00',16.61),('6449','2013-05-09','13:45:00',16.53),('6449','2013-05-09','13:50:00',16.53),('6449','2013-05-09','13:55:00',16.36),('6449','2013-05-09','14:00:00',16.15),('6449','2013-05-09','14:05:00',16.07),('6449','2013-05-09','14:10:00',16.06),('6449','2013-05-09','14:15:00',15.76),('6449','2013-05-09','14:20:00',15.95),('6449','2013-05-09','14:25:00',15.74),('6449','2013-05-09','14:30:00',15.72),('6449','2013-05-09','14:35:00',15.59),('6449','2013-05-09','14:40:00',15.46),('6449','2013-05-09','14:45:00',15.4),('6449','2013-05-09','14:50:00',15.23),('6449','2013-05-09','14:55:00',14.53),('6449','2013-05-09','15:00:00',14.86),('6449','2013-05-09','15:05:00',14.78),('6449','2013-05-09','15:10:00',14.43),('6449','2013-05-09','15:15:00',14.4),('6449','2013-05-09','15:20:00',14.22),('6449','2013-05-09','15:25:00',14.11),('6449','2013-05-09','15:30:00',13.82),('6449','2013-05-09','15:35:00',13.52),('6449','2013-05-09','15:40:00',13.27),('6449','2013-05-09','15:45:00',13.06),('6449','2013-05-09','15:50:00',12.94),('6449','2013-05-09','15:55:00',12.57),('6449','2013-05-09','16:00:00',12.09),('6449','2013-05-09','16:05:00',12.01),('6449','2013-05-09','16:10:00',11.7),('6449','2013-05-09','16:15:00',11.52),('6449','2013-05-09','16:20:00',11.18),('6449','2013-05-09','16:25:00',10.9),('6449','2013-05-09','16:30:00',10.61),('6449','2013-05-09','16:35:00',10.28),('6449','2013-05-09','16:40:00',10.03),('6449','2013-05-09','16:45:00',9.7),('6449','2013-05-09','16:50:00',9.39),('6449','2013-05-09','16:55:00',8.95),('6449','2013-05-09','17:00:00',8.72),('6449','2013-05-09','17:05:00',8.31),('6449','2013-05-09','17:10:00',8.05),('6449','2013-05-09','17:15:00',7.66),('6449','2013-05-09','17:20:00',7.29),('6449','2013-05-09','17:25:00',6.94),('6449','2013-05-09','17:30:00',6.55),('6449','2013-05-09','17:35:00',6.24),('6449','2013-05-09','17:40:00',5.87),('6449','2013-05-09','17:45:00',5.47),('6449','2013-05-09','17:50:00',5.14),('6449','2013-05-09','17:55:00',4.7),('6449','2013-05-09','18:00:00',4.31),('6449','2013-05-09','18:05:00',4.02),('6449','2013-05-09','18:10:00',3.66),('6449','2013-05-09','18:15:00',3.27),('6449','2013-05-09','18:20:00',2.97),('6449','2013-05-09','18:25:00',2.66),('6449','2013-05-09','18:30:00',2.31),('6449','2013-05-09','18:35:00',2.08),('6449','2013-05-09','18:40:00',1.8),('6449','2013-05-09','18:45:00',1.57),('6449','2013-05-09','18:50:00',1.32),('6449','2013-05-09','18:55:00',1.12),('6449','2013-05-08','07:05:00',1.12),('6449','2013-05-08','07:10:00',1.77),('6449','2013-05-08','07:15:00',2.1),('6449','2013-05-08','07:20:00',2.48),('6449','2013-05-08','07:25:00',2.77),('6449','2013-05-08','07:30:00',3.11),('6449','2013-05-08','07:35:00',3.38),('6449','2013-05-08','07:40:00',3.69),('6449','2013-05-08','07:45:00',4.1),('6449','2013-05-08','07:50:00',4.52),('6449','2013-05-08','07:55:00',4.9),('6449','2013-05-08','08:00:00',5.27),('6449','2013-05-08','08:05:00',5.31),('6449','2013-05-08','08:10:00',5.8),('6449','2013-05-08','08:15:00',6.13),('6449','2013-05-08','08:20:00',6.31),('6449','2013-05-08','08:25:00',7.06),('6449','2013-05-08','08:30:00',7.29),('6449','2013-05-08','08:35:00',7.63),('6449','2013-05-08','08:40:00',8.06),('6449','2013-05-08','08:45:00',8.45),('6449','2013-05-08','08:50:00',8.9),('6449','2013-05-08','08:55:00',9.39),('6449','2013-05-08','09:00:00',9.27),('6449','2013-05-08','09:05:00',8),('6449','2013-05-08','09:10:00',8.65),('6449','2013-05-08','09:15:00',11.18),('6449','2013-05-08','09:20:00',5.45),('6449','2013-05-08','09:25:00',11.07),('6449','2013-05-08','09:30:00',13.12),('6449','2013-05-08','09:35:00',7.55),('6449','2013-05-08','09:40:00',3.07),('6449','2013-05-08','09:45:00',3.64),('6449','2013-05-08','09:50:00',4.24),('6449','2013-05-08','09:55:00',9.7),('6449','2013-05-08','10:00:00',13.99),('6449','2013-05-08','10:05:00',14.02),('6449','2013-05-08','10:10:00',14.59),('6449','2013-05-08','10:15:00',8.94),('6449','2013-05-08','10:20:00',14.95),('6449','2013-05-08','10:25:00',13.6),('6449','2013-05-08','10:30:00',10.57),('6449','2013-05-08','10:35:00',14.27),('6449','2013-05-08','10:40:00',14.27),('6449','2013-05-08','10:45:00',14.27),('6449','2013-05-08','10:50:00',14.56),('6449','2013-05-08','10:55:00',14.59),('6449','2013-05-08','11:00:00',14.75),('6449','2013-05-08','11:05:00',14.84),('6449','2013-05-08','11:10:00',14.95),('6449','2013-05-08','11:15:00',15.18),('6449','2013-05-08','11:20:00',15.38),('6449','2013-05-08','11:25:00',15.53),('6449','2013-05-08','11:30:00',15.67),('6449','2013-05-08','11:35:00',15.7),('6449','2013-05-08','11:40:00',15.69),('6449','2013-05-08','11:45:00',15.93),('6449','2013-05-08','11:50:00',15.98),('6449','2013-05-08','11:55:00',16.1),('6449','2013-05-08','12:00:00',16.02),('6449','2013-05-08','12:05:00',16.27),('6449','2013-05-08','12:10:00',16.31),('6449','2013-05-08','12:15:00',16.47),('6449','2013-05-08','12:20:00',16.58),('6449','2013-05-08','12:25:00',16.52),('6449','2013-05-08','12:30:00',16.43),('6449','2013-05-08','12:35:00',16.59),('6449','2013-05-08','12:40:00',16.57),('6449','2013-05-08','12:45:00',16.61),('6449','2013-05-08','12:50:00',16.59),('6449','2013-05-08','12:55:00',16.52),('6449','2013-05-08','13:00:00',16.58),('6449','2013-05-08','13:05:00',16.55),('6449','2013-05-08','13:10:00',16.55),('6449','2013-05-08','13:15:00',16.56),('6449','2013-05-08','13:20:00',16.53),('6449','2013-05-08','13:25:00',16.41),('6449','2013-05-08','13:30:00',16.53),('6449','2013-05-08','13:35:00',16.4),('6449','2013-05-08','13:40:00',16.36),('6449','2013-05-08','13:45:00',16.19),('6449','2013-05-08','13:50:00',16.28),('6449','2013-05-08','13:55:00',16.11),('6449','2013-05-08','14:00:00',16.01),('6449','2013-05-08','14:05:00',15.94),('6449','2013-05-08','14:10:00',15.79),('6449','2013-05-08','14:15:00',15.75),('6449','2013-05-08','14:20:00',15.65),('6449','2013-05-08','14:25:00',15.49),('6449','2013-05-08','14:30:00',15.42),('6449','2013-05-08','14:35:00',15.31),('6449','2013-05-08','14:40:00',15.07),('6449','2013-05-08','14:45:00',15.09),('6449','2013-05-08','14:50:00',14.79),('6449','2013-05-08','14:55:00',14.9),('6449','2013-05-08','15:00:00',14.58),('6449','2013-05-08','15:05:00',14.29),('6449','2013-05-08','15:10:00',13.91),('6449','2013-05-08','15:15:00',13.92),('6449','2013-05-08','15:20:00',13.71),('6449','2013-05-08','15:25:00',13.58),('6449','2013-05-08','15:30:00',13.3),('6449','2013-05-08','15:35:00',13.28),('6449','2013-05-08','15:40:00',13.59),('6449','2013-05-08','15:45:00',11.83),('6449','2013-05-08','15:50:00',5.67),('6449','2013-05-08','15:55:00',5.13),('6449','2013-05-08','16:00:00',5.87),('6449','2013-05-08','16:05:00',9.01),('6449','2013-05-08','16:10:00',7.34),('6449','2013-05-08','16:15:00',6.88),('6449','2013-05-08','16:20:00',6.82),('6449','2013-05-08','16:25:00',3.81),('6449','2013-05-08','16:30:00',6.37),('6449','2013-05-08','16:35:00',5.46),('6449','2013-05-08','16:40:00',5.08),('6449','2013-05-08','16:45:00',4.25),('6449','2013-05-08','16:50:00',4.49),('6449','2013-05-08','16:55:00',8.62),('6449','2013-05-08','17:00:00',9.62),('6449','2013-05-08','17:05:00',9.26),('6449','2013-05-08','17:10:00',8.84),('6449','2013-05-08','17:15:00',8.26),('6449','2013-05-08','17:20:00',7.18),('6449','2013-05-08','17:25:00',3.58),('6449','2013-05-08','17:30:00',3.48),('6449','2013-05-08','17:35:00',2.06),('6449','2013-05-08','17:40:00',2.56),('6449','2013-05-08','17:45:00',2.55),('6449','2013-05-08','17:50:00',2.67),('6449','2013-05-08','17:55:00',3.09),('6449','2013-05-08','18:00:00',2.91),('6449','2013-05-08','18:05:00',2.43),('6449','2013-05-08','18:10:00',2.18),('6449','2013-05-08','18:15:00',3.65),('6449','2013-05-08','18:20:00',3.59),('6449','2013-05-08','18:25:00',2.51),('6449','2013-05-08','18:30:00',3.01),('6449','2013-05-08','18:35:00',2.82),('6449','2013-05-08','18:40:00',2.49),('6449','2013-05-08','18:45:00',1.59),('6449','2013-05-08','18:50:00',1.32),('6449','2013-05-08','18:55:00',1.07),('6449','2013-05-07','07:25:00',2.14),('6449','2013-05-07','07:30:00',3.29),('6449','2013-05-07','07:35:00',3.62),('6449','2013-05-07','07:40:00',3.98),('6449','2013-05-07','07:45:00',4.34),('6449','2013-05-07','07:50:00',4.63),('6449','2013-05-07','07:55:00',3.66),('6449','2013-05-07','08:00:00',5.42),('6449','2013-05-07','08:05:00',5.82),('6449','2013-05-07','08:10:00',6.23),('6449','2013-05-07','08:15:00',6.61),('6449','2013-05-07','08:20:00',6.95),('6449','2013-05-07','08:25:00',7.33),('6449','2013-05-07','08:30:00',7.63),('6449','2013-05-07','08:35:00',7.22),('6449','2013-05-07','08:40:00',8.34),('6449','2013-05-07','08:45:00',8.66),('6449','2013-05-07','08:50:00',9.27),('6449','2013-05-07','08:55:00',9.26),('6449','2013-05-07','09:00:00',9.78),('6449','2013-05-07','09:05:00',10.16),('6449','2013-05-07','09:10:00',8.95),('6449','2013-05-07','09:15:00',10.88),('6449','2013-05-07','09:20:00',11.05),('6449','2013-05-07','09:25:00',11.9),('6449','2013-05-07','09:30:00',9.22),('6449','2013-05-07','09:35:00',12.43),('6449','2013-05-07','09:40:00',13.78),('6449','2013-05-07','09:45:00',13.05),('6449','2013-05-07','09:50:00',13.36),('6449','2013-05-07','09:55:00',12.54),('6449','2013-05-07','10:00:00',9.48),('6449','2013-05-07','10:05:00',11.03),('6449','2013-05-07','10:10:00',13.38),('6449','2013-05-07','10:15:00',15.78),('6449','2013-05-07','10:20:00',15.75),('6449','2013-05-07','10:25:00',15.91),('6449','2013-05-07','10:30:00',16.31),('6449','2013-05-07','10:35:00',11.38),('6449','2013-05-07','10:40:00',4.96),('6449','2013-05-07','10:45:00',4.41),('6449','2013-05-07','10:50:00',3.99),('6449','2013-05-07','10:55:00',10.66),('6449','2013-05-07','11:00:00',15.2),('6449','2013-05-07','11:05:00',15.8),('6449','2013-05-07','11:10:00',15.5),('6449','2013-05-07','11:15:00',15.35),('6449','2013-05-07','11:20:00',15.58),('6449','2013-05-07','11:25:00',15.69),('6449','2013-05-07','11:30:00',15.72),('6449','2013-05-07','11:35:00',15.77),('6449','2013-05-07','11:40:00',15.79),('6449','2013-05-07','11:45:00',16.1),('6449','2013-05-07','11:50:00',16.32),('6449','2013-05-07','11:55:00',16.29),('6449','2013-05-07','12:00:00',14.73),('6449','2013-05-07','12:05:00',16.21),('6449','2013-05-07','12:10:00',16.12),('6449','2013-05-07','12:15:00',15.6),('6449','2013-05-07','12:20:00',14.24),('6449','2013-05-07','12:25:00',13.86),('6449','2013-05-07','12:30:00',13.22),('6449','2013-05-07','12:35:00',9.6),('6449','2013-05-07','12:40:00',14.61),('6449','2013-05-07','12:45:00',15.59),('6449','2013-05-07','12:50:00',16.05),('6449','2013-05-07','12:55:00',16.4),('6449','2013-05-07','13:00:00',15.8),('6449','2013-05-07','13:05:00',16.96),('6449','2013-05-07','13:10:00',14.63),('6449','2013-05-07','13:15:00',16.22),('6449','2013-05-07','13:20:00',16.81),('6449','2013-05-07','13:25:00',16.68),('6449','2013-05-07','13:30:00',16.22),('6449','2013-05-07','13:35:00',17.01),('6449','2013-05-07','13:40:00',15.53),('6449','2013-05-07','13:45:00',16.22),('6449','2013-05-07','13:50:00',15.93),('6449','2013-05-07','13:55:00',15.46),('6449','2013-05-07','14:00:00',16.89),('6449','2013-05-07','14:05:00',13.22),('6449','2013-05-07','14:10:00',14.88),('6449','2013-05-07','14:15:00',16.25),('6449','2013-05-07','14:20:00',14.68),('6449','2013-05-07','14:25:00',15.36),('6449','2013-05-07','14:30:00',14.69),('6449','2013-05-07','14:35:00',15.38),('6449','2013-05-07','14:40:00',15.53),('6449','2013-05-07','14:45:00',15.63),('6449','2013-05-07','14:50:00',15.91),('6449','2013-05-07','14:55:00',13.54),('6449','2013-05-07','15:00:00',13.51),('6449','2013-05-07','15:05:00',14.07),('6449','2013-05-07','15:10:00',15.84),('6449','2013-05-07','15:15:00',14.01),('6449','2013-05-07','15:20:00',13.21),('6449','2013-05-07','15:25:00',12.46),('6449','2013-05-07','15:30:00',11.94),('6449','2013-05-07','15:35:00',12.02),('6449','2013-05-07','15:40:00',11.03),('6449','2013-05-07','15:45:00',9.62),('6449','2013-05-07','15:50:00',8.31),('6449','2013-05-07','15:55:00',8.7),('6449','2013-05-07','16:00:00',9.71),('6449','2013-05-07','16:05:00',12.13),('6449','2013-05-07','16:10:00',12.37),('6449','2013-05-07','16:15:00',12.84),('6449','2013-05-07','16:20:00',12.86),('6449','2013-05-07','16:25:00',7.6),('6449','2013-05-07','16:30:00',7.22),('6449','2013-05-07','16:35:00',9.83),('6449','2013-05-07','16:40:00',9.67),('6449','2013-05-07','16:45:00',10.23),('6449','2013-05-07','16:50:00',6.23),('6449','2013-05-07','16:55:00',8.99),('6449','2013-05-07','17:00:00',7.88),('6449','2013-05-07','17:05:00',4.68),('6449','2013-05-07','17:10:00',4.2),('6449','2013-05-07','17:15:00',3.53),('6449','2013-05-07','17:20:00',3.25),('6449','2013-05-07','17:25:00',3.12),('6449','2013-05-07','17:30:00',3.33),('6449','2013-05-07','17:35:00',4.65),('6449','2013-05-07','17:40:00',9.86),('6449','2013-05-07','17:45:00',8.96),('6449','2013-05-07','17:50:00',3.89),('6449','2013-05-07','17:55:00',5.97),('6449','2013-05-07','18:00:00',5.34),('6449','2013-05-07','18:05:00',3.32),('6449','2013-05-07','18:10:00',2.01),('6449','2013-05-07','18:15:00',1.92),('6449','2013-05-07','18:20:00',1.92),('6449','2013-05-07','18:25:00',1.64),('6449','2013-05-07','18:30:00',1.44),('6449','2013-05-07','18:35:00',1.52),('6449','2013-05-07','18:40:00',1.5),('6449','2013-05-07','18:45:00',1.28),('6449','2013-05-06','08:25:00',1.42),('6449','2013-05-06','08:30:00',1.52),('6449','2013-05-06','08:35:00',1.03),('6449','2013-05-06','08:55:00',1.6),('6449','2013-05-06','09:00:00',1.25),('6449','2013-05-06','09:20:00',1.74),('6449','2013-05-06','09:25:00',1.21),('6449','2013-05-06','09:55:00',1.64),('6449','2013-05-06','10:00:00',4.08),('6449','2013-05-06','10:05:00',7.52),('6449','2013-05-06','10:10:00',6.09),('6449','2013-05-06','10:15:00',5.09),('6449','2013-05-06','10:20:00',8.7),('6449','2013-05-06','10:25:00',7.01),('6449','2013-05-06','10:30:00',4.33),('6449','2013-05-06','10:35:00',2.65),('6449','2013-05-06','10:40:00',4.6),('6449','2013-05-06','10:45:00',4.4),('6449','2013-05-06','10:50:00',4.99),('6449','2013-05-06','10:55:00',7),('6449','2013-05-06','11:00:00',7.96),('6449','2013-05-06','11:05:00',6.94),('6449','2013-05-06','11:10:00',8.08),('6449','2013-05-06','11:15:00',9.25),('6449','2013-05-06','11:20:00',14.79),('6449','2013-05-06','11:25:00',13.27),('6449','2013-05-06','11:30:00',11.88),('6449','2013-05-06','11:35:00',16.93),('6449','2013-05-06','11:40:00',16.91),('6449','2013-05-06','11:45:00',16.34),('6449','2013-05-06','11:50:00',16.57),('6449','2013-05-06','11:55:00',16.19),('6449','2013-05-06','12:00:00',15.93),('6449','2013-05-06','12:05:00',16.13),('6449','2013-05-06','12:10:00',16.31),('6449','2013-05-06','12:15:00',16.29),('6449','2013-05-06','12:20:00',15.94),('6449','2013-05-06','12:25:00',14.22),('6449','2013-05-06','12:30:00',16.95),('6449','2013-05-06','12:35:00',16.78),('6449','2013-05-06','12:40:00',16.56),('6449','2013-05-06','12:45:00',16.49),('6449','2013-05-06','12:50:00',14.05),('6449','2013-05-06','12:55:00',14.62),('6449','2013-05-06','13:00:00',12.31),('6449','2013-05-06','13:05:00',12.82),('6449','2013-05-06','13:10:00',18.02),('6449','2013-05-06','13:15:00',16.7),('6449','2013-05-06','13:20:00',16.78),('6449','2013-05-06','13:25:00',16.98),('6449','2013-05-06','13:30:00',15.77),('6449','2013-05-06','13:35:00',16),('6449','2013-05-06','13:40:00',15.09),('6449','2013-05-06','13:45:00',10.06),('6449','2013-05-06','13:50:00',16.5),('6449','2013-05-06','13:55:00',14.66),('6449','2013-05-06','14:00:00',15.88),('6449','2013-05-06','14:05:00',10.03),('6449','2013-05-06','14:10:00',14.87),('6449','2013-05-06','14:15:00',13.51),('6449','2013-05-06','14:20:00',12.06),('6449','2013-05-06','14:25:00',12.27),('6449','2013-05-06','14:30:00',14.69),('6449','2013-05-06','14:35:00',13.09),('6449','2013-05-06','14:40:00',13.4),('6449','2013-05-06','14:45:00',14.99),('6449','2013-05-06','14:50:00',15.18),('6449','2013-05-06','14:55:00',13.69),('6449','2013-05-06','15:00:00',15.23),('6449','2013-05-06','15:05:00',15.04),('6449','2013-05-06','15:10:00',13),('6449','2013-05-06','15:15:00',12.82),('6449','2013-05-06','15:20:00',10.57),('6449','2013-05-06','15:25:00',13.11),('6449','2013-05-06','15:30:00',14.61),('6449','2013-05-06','15:35:00',12.35),('6449','2013-05-06','15:40:00',13.74),('6449','2013-05-06','15:45:00',13.13),('6449','2013-05-06','15:50:00',13.05),('6449','2013-05-06','15:55:00',11),('6449','2013-05-06','16:00:00',6.56),('6449','2013-05-06','16:05:00',11.38),('6449','2013-05-06','16:10:00',10.29),('6449','2013-05-06','16:15:00',7.93),('6449','2013-05-06','16:20:00',8.03),('6449','2013-05-06','16:25:00',7.42),('6449','2013-05-06','16:30:00',7.41),('6449','2013-05-06','16:35:00',9.01),('6449','2013-05-06','16:40:00',5.93),('6449','2013-05-06','16:45:00',9.34),('6449','2013-05-06','16:50:00',5.5),('6449','2013-05-06','16:55:00',5.37),('6449','2013-05-06','17:00:00',4.98),('6449','2013-05-06','17:05:00',4.11),('6449','2013-05-06','17:10:00',2.44),('6449','2013-05-06','17:15:00',2.46),('6449','2013-05-06','17:20:00',2.15),('6449','2013-05-06','17:25:00',2.11),('6449','2013-05-06','17:30:00',2.54),('6449','2013-05-06','17:35:00',2.68),('6449','2013-05-06','17:40:00',2.38),('6449','2013-05-06','17:45:00',1.9),('6449','2013-05-06','17:50:00',2.99),('6449','2013-05-06','17:55:00',2.84),('6449','2013-05-06','18:00:00',2.91),('6449','2013-05-06','18:05:00',1.65),('6449','2013-05-06','18:10:00',1.72),('6449','2013-05-06','18:15:00',1.43),('6449','2013-05-06','18:20:00',1.15),('6449','2013-05-06','18:25:00',1.18),('6449','2013-05-06','18:30:00',1.51),('6449','2013-05-06','18:35:00',1.94),('6449','2013-05-06','18:40:00',1.86),('6449','2013-05-06','18:45:00',1.43),('6449','2013-05-06','18:50:00',1.15),('6449','2013-05-06','18:55:00',1.19),('6449','2013-05-06','19:00:00',1.49),('6449','2013-05-06','19:05:00',1.84),('6449','2013-05-06','19:10:00',1.94),('6449','2013-05-06','19:15:00',1.46),('6449','2013-05-06','19:20:00',1.18),('6449','2013-05-05','07:00:00',1.23),('6449','2013-05-05','07:05:00',1.69),('6449','2013-05-05','07:10:00',1.94),('6449','2013-05-05','07:15:00',2.23),('6449','2013-05-05','07:20:00',2.72),('6449','2013-05-05','07:25:00',3.31),('6449','2013-05-05','07:30:00',3.46),('6449','2013-05-05','07:35:00',3.61),('6449','2013-05-05','07:40:00',3.42),('6449','2013-05-05','07:45:00',4.07),('6449','2013-05-05','07:50:00',2.77),('6449','2013-05-05','07:55:00',2.41),('6449','2013-05-05','08:00:00',2.41),('6449','2013-05-05','08:05:00',2.36),('6449','2013-05-05','08:10:00',2.46),('6449','2013-05-05','08:15:00',2.44),('6449','2013-05-05','08:20:00',2.36),('6449','2013-05-05','08:25:00',2.55),('6449','2013-05-05','08:30:00',3.74),('6449','2013-05-05','08:35:00',4.21),('6449','2013-05-05','08:40:00',5.14),('6449','2013-05-05','08:45:00',4.48),('6449','2013-05-05','08:50:00',3.44),('6449','2013-05-05','08:55:00',3.27),('6449','2013-05-05','09:00:00',3.39),('6449','2013-05-05','09:05:00',6.38),('6449','2013-05-05','09:10:00',5.16),('6449','2013-05-05','09:15:00',10.19),('6449','2013-05-05','09:20:00',10.19),('6449','2013-05-05','09:25:00',11.68),('6449','2013-05-05','09:30:00',11.97),('6449','2013-05-05','09:35:00',12.11),('6449','2013-05-05','09:40:00',9.73),('6449','2013-05-05','09:45:00',7.02),('6449','2013-05-05','09:50:00',6.54),('6449','2013-05-05','09:55:00',2.86),('6449','2013-05-05','10:00:00',2.12),('6449','2013-05-05','10:05:00',2.78),('6449','2013-05-05','10:10:00',5.41),('6449','2013-05-05','10:15:00',13.99),('6449','2013-05-05','10:20:00',8.35),('6449','2013-05-05','10:25:00',8.68),('6449','2013-05-05','10:30:00',5.22),('6449','2013-05-05','10:35:00',5.78),('6449','2013-05-05','10:40:00',4.18),('6449','2013-05-05','10:45:00',6.14),('6449','2013-05-05','10:50:00',10.35),('6449','2013-05-05','10:55:00',12.08),('6449','2013-05-05','11:00:00',15.33),('6449','2013-05-05','11:05:00',13.22),('6449','2013-05-05','11:10:00',10.16),('6449','2013-05-05','11:15:00',10.05),('6449','2013-05-05','11:20:00',11.59),('6449','2013-05-05','11:25:00',12.53),('6449','2013-05-05','11:30:00',11.49),('6449','2013-05-05','11:35:00',11.62),('6449','2013-05-05','11:40:00',11.71),('6449','2013-05-05','11:45:00',10.28),('6449','2013-05-05','11:50:00',17.25),('6449','2013-05-05','11:55:00',17.65),('6449','2013-05-05','12:00:00',18.63),('6449','2013-05-05','12:05:00',17.43),('6449','2013-05-05','12:10:00',18.21),('6449','2013-05-05','12:15:00',17.72),('6449','2013-05-05','12:20:00',16.59),('6449','2013-05-05','12:25:00',16.55),('6449','2013-05-05','12:30:00',16.65),('6449','2013-05-05','12:35:00',16.79),('6449','2013-05-05','12:40:00',16.75),('6449','2013-05-05','12:45:00',17.76),('6449','2013-05-05','12:50:00',17.65),('6449','2013-05-05','12:55:00',17.22),('6449','2013-05-05','13:00:00',17.38),('6449','2013-05-05','13:05:00',17.34),('6449','2013-05-05','13:10:00',17.24),('6449','2013-05-05','13:15:00',17.48),('6449','2013-05-05','13:20:00',17.35),('6449','2013-05-05','13:25:00',15.37),('6449','2013-05-05','13:30:00',9.36),('6449','2013-05-05','13:35:00',9.62),('6449','2013-05-05','13:40:00',8.17),('6449','2013-05-05','13:45:00',7.77),('6449','2013-05-05','13:50:00',8.18),('6449','2013-05-05','13:55:00',6.95),('6449','2013-05-05','14:00:00',13.06),('6449','2013-05-05','14:05:00',16.58),('6449','2013-05-05','14:10:00',15.74),('6449','2013-05-05','14:15:00',15.57),('6449','2013-05-05','14:20:00',15.44),('6449','2013-05-05','14:25:00',15.19),('6449','2013-05-05','14:30:00',15.1),('6449','2013-05-05','14:35:00',14.87),('6449','2013-05-05','14:40:00',14.45),('6449','2013-05-05','14:45:00',14.47),('6449','2013-05-05','14:50:00',14.35),('6449','2013-05-05','14:55:00',14.41),('6449','2013-05-05','15:00:00',14.16),('6449','2013-05-05','15:05:00',11.99),('6449','2013-05-05','15:10:00',14.25),('6449','2013-05-05','15:15:00',13.93),('6449','2013-05-05','15:20:00',13.67),('6449','2013-05-05','15:25:00',13.4),('6449','2013-05-05','15:30:00',13.19),('6449','2013-05-05','15:35:00',12.99),('6449','2013-05-05','15:40:00',12.78),('6449','2013-05-05','15:45:00',12.57),('6449','2013-05-05','15:50:00',12.31),('6449','2013-05-05','15:55:00',12.02),('6449','2013-05-05','16:00:00',11.77),('6449','2013-05-05','16:05:00',11.37),('6449','2013-05-05','16:10:00',10.89),('6449','2013-05-05','16:15:00',10.78),('6449','2013-05-05','16:20:00',10.48),('6449','2013-05-05','16:25:00',10.19),('6449','2013-05-05','16:30:00',10.08),('6449','2013-05-05','16:35:00',9.81),('6449','2013-05-05','16:40:00',9.51),('6449','2013-05-05','16:45:00',9.24),('6449','2013-05-05','16:50:00',8.93),('6449','2013-05-05','16:55:00',8.56),('6449','2013-05-05','17:00:00',8.22),('6449','2013-05-05','17:05:00',7.86),('6449','2013-05-05','17:10:00',7.58),('6449','2013-05-05','17:15:00',7.26),('6449','2013-05-05','17:20:00',6.88),('6449','2013-05-05','17:25:00',6.45),('6449','2013-05-05','17:30:00',6.12),('6449','2013-05-05','17:35:00',5.73),('6449','2013-05-05','17:40:00',5.41),('6449','2013-05-05','17:45:00',5.05),('6449','2013-05-05','17:50:00',4.71),('6449','2013-05-05','17:55:00',4.38),('6449','2013-05-05','18:00:00',4.07),('6449','2013-05-05','18:05:00',3.75),('6449','2013-05-05','18:10:00',3.42),('6449','2013-05-05','18:15:00',3.18),('6449','2013-05-05','18:20:00',2.88),('6449','2013-05-05','18:25:00',2.56),('6449','2013-05-05','18:30:00',2.27),('6449','2013-05-05','18:35:00',2.02),('6449','2013-05-05','18:40:00',1.76),('6449','2013-05-05','18:45:00',1.56),('6449','2013-05-05','18:50:00',1.37),('6449','2013-05-05','18:55:00',1.18),('6449','2013-05-05','19:00:00',1.03),('6449','2013-05-04','06:55:00',1.05),('6449','2013-05-04','07:00:00',1.41),('6449','2013-05-04','07:05:00',1.69),('6449','2013-05-04','07:10:00',1.89),('6449','2013-05-04','07:15:00',2.12),('6449','2013-05-04','07:20:00',2.36),('6449','2013-05-04','07:25:00',2.63),('6449','2013-05-04','07:30:00',2.92),('6449','2013-05-04','07:35:00',3.46),('6449','2013-05-04','07:40:00',4.16),('6449','2013-05-04','07:45:00',4.18),('6449','2013-05-04','07:50:00',3.82),('6449','2013-05-04','07:55:00',4.37),('6449','2013-05-04','08:00:00',2.72),('6449','2013-05-04','08:05:00',5.17),('6449','2013-05-04','08:10:00',5.84),('6449','2013-05-04','08:15:00',6.66),('6449','2013-05-04','08:20:00',5.28),('6449','2013-05-04','08:25:00',3.57),('6449','2013-05-04','08:30:00',7.07),('6449','2013-05-04','08:35:00',7.35),('6449','2013-05-04','08:40:00',5.8),('6449','2013-05-04','08:45:00',6.51),('6449','2013-05-04','08:50:00',9.74),('6449','2013-05-04','08:55:00',10.7),('6449','2013-05-04','09:00:00',8.04),('6449','2013-05-04','09:05:00',9.06),('6449','2013-05-04','09:10:00',10.22),('6449','2013-05-04','09:15:00',9.39),('6449','2013-05-04','09:20:00',10.02),('6449','2013-05-04','09:25:00',9.82),('6449','2013-05-04','09:30:00',10.36),('6449','2013-05-04','09:35:00',11.14),('6449','2013-05-04','09:40:00',11.02),('6449','2013-05-04','09:45:00',11.51),('6449','2013-05-04','09:50:00',11.72),('6449','2013-05-04','09:55:00',11.93),('6449','2013-05-04','10:00:00',12.14),('6449','2013-05-04','10:05:00',12.37),('6449','2013-05-04','10:10:00',12.26),('6449','2013-05-04','10:15:00',12.63),('6449','2013-05-04','10:20:00',12.9),('6449','2013-05-04','10:25:00',12.94),('6449','2013-05-04','10:30:00',13.11),('6449','2013-05-04','10:35:00',13.13),('6449','2013-05-04','10:40:00',13.23),('6449','2013-05-04','10:45:00',13.49),('6449','2013-05-04','10:50:00',13.59),('6449','2013-05-04','10:55:00',13.78),('6449','2013-05-04','11:00:00',14),('6449','2013-05-04','11:05:00',14.06),('6449','2013-05-04','11:10:00',13.58),('6449','2013-05-04','11:15:00',13.25),('6449','2013-05-04','11:20:00',12.85),('6449','2013-05-04','11:25:00',14.12),('6449','2013-05-04','11:30:00',14.39),('6449','2013-05-04','11:35:00',14.19),('6449','2013-05-04','11:40:00',14.06),('6449','2013-05-04','11:45:00',14.19),('6449','2013-05-04','11:50:00',14.17),('6449','2013-05-04','11:55:00',13.91),('6449','2013-05-04','12:00:00',13.44),('6449','2013-05-04','12:05:00',14.11),('6449','2013-05-04','12:10:00',14.27),('6449','2013-05-04','12:15:00',14.48),('6449','2013-05-04','12:20:00',14.42),('6449','2013-05-04','12:25:00',14.19),('6449','2013-05-04','12:30:00',13.89),('6449','2013-05-04','12:35:00',13.87),('6449','2013-05-04','12:40:00',13.55),('6449','2013-05-04','12:45:00',13.44),('6449','2013-05-04','12:50:00',13.21),('6449','2013-05-04','12:55:00',14.36),('6449','2013-05-04','13:00:00',15.21),('6449','2013-05-04','13:05:00',15.13),('6449','2013-05-04','13:10:00',15.19),('6449','2013-05-04','13:15:00',14.58),('6449','2013-05-04','13:20:00',15.06),('6449','2013-05-04','13:25:00',15.17),('6449','2013-05-04','13:30:00',14.56),('6449','2013-05-04','13:35:00',14.98),('6449','2013-05-04','13:40:00',14.62),('6449','2013-05-04','13:45:00',14.45),('6449','2013-05-04','13:50:00',14.38),('6449','2013-05-04','13:55:00',13.96),('6449','2013-05-04','14:00:00',13.56),('6449','2013-05-04','14:05:00',13.81),('6449','2013-05-04','14:10:00',14.76),('6449','2013-05-04','14:15:00',14.14),('6449','2013-05-04','14:20:00',13.69),('6449','2013-05-04','14:25:00',13.56),('6449','2013-05-04','14:30:00',13.78),('6449','2013-05-04','14:35:00',13.99),('6449','2013-05-04','14:40:00',13.78),('6449','2013-05-04','14:45:00',12.21),('6449','2013-05-04','14:50:00',12.53),('6449','2013-05-04','14:55:00',12.89),('6449','2013-05-04','15:00:00',12.7),('6449','2013-05-04','15:05:00',13.36),('6449','2013-05-04','15:10:00',13.21),('6449','2013-05-04','15:15:00',11.8),('6449','2013-05-04','15:20:00',11.52),('6449','2013-05-04','15:25:00',12.83),('6449','2013-05-04','15:30:00',12.05),('6449','2013-05-04','15:35:00',12.77),('6449','2013-05-04','15:40:00',12.46),('6449','2013-05-04','15:45:00',12.11),('6449','2013-05-04','15:50:00',11.93),('6449','2013-05-04','15:55:00',11.71),('6449','2013-05-04','16:00:00',11.48),('6449','2013-05-04','16:05:00',11.27),('6449','2013-05-04','16:10:00',11),('6449','2013-05-04','16:15:00',10.72),('6449','2013-05-04','16:20:00',10.41),('6449','2013-05-04','16:25:00',10.15),('6449','2013-05-04','16:30:00',9.9),('6449','2013-05-04','16:35:00',9.52),('6449','2013-05-04','16:40:00',9.23),('6449','2013-05-04','16:45:00',8.82),('6449','2013-05-04','16:50:00',8.59),('6449','2013-05-04','16:55:00',8.28),('6449','2013-05-04','17:00:00',7.94),('6449','2013-05-04','17:05:00',7.62),('6449','2013-05-04','17:10:00',7.4),('6449','2013-05-04','17:15:00',7),('6449','2013-05-04','17:20:00',6.91),('6449','2013-05-04','17:25:00',6.45),('6449','2013-05-04','17:30:00',5.94),('6449','2013-05-04','17:35:00',5.65),('6449','2013-05-04','17:40:00',5.22),('6449','2013-05-04','17:45:00',4.79),('6449','2013-05-04','17:50:00',4.37),('6449','2013-05-04','17:55:00',4.2),('6449','2013-05-04','18:00:00',3.36),('6449','2013-05-04','18:05:00',1.7),('6449','2013-05-04','18:10:00',2.08),('6449','2013-05-04','18:15:00',2.6),('6449','2013-05-04','18:20:00',2.56),('6449','2013-05-04','18:25:00',2.19),('6449','2013-05-04','18:30:00',2.15),('6449','2013-05-04','18:35:00',2.01),('6449','2013-05-04','18:40:00',1.68),('6449','2013-05-04','18:45:00',1.43),('6449','2013-05-04','18:50:00',1.31),('6449','2013-05-04','18:55:00',1.23),('6449','2013-05-04','19:00:00',1.11),('6449','2013-05-04','19:05:00',1.05),('6449','2013-05-03','06:45:00',1.02),('6449','2013-05-03','06:50:00',1.16),('6449','2013-05-03','06:55:00',1.11),('6449','2013-05-03','07:00:00',1.11),('6449','2013-05-03','07:05:00',1.56),('6449','2013-05-03','07:10:00',1.96),('6449','2013-05-03','07:15:00',2.3),('6449','2013-05-03','07:20:00',2.53),('6449','2013-05-03','07:25:00',2.73),('6449','2013-05-03','07:30:00',2.7),('6449','2013-05-03','07:35:00',2.06),('6449','2013-05-03','07:40:00',1.92),('6449','2013-05-03','07:45:00',1.96),('6449','2013-05-03','07:50:00',2.91),('6449','2013-05-03','07:55:00',4.12),('6449','2013-05-03','08:00:00',4.45),('6449','2013-05-03','08:05:00',4.81),('6449','2013-05-03','08:10:00',5.19),('6449','2013-05-03','08:15:00',5.58),('6449','2013-05-03','08:20:00',6.01),('6449','2013-05-03','08:25:00',6.65),('6449','2013-05-03','08:30:00',7.13),('6449','2013-05-03','08:35:00',7.66),('6449','2013-05-03','08:40:00',7.96),('6449','2013-05-03','08:45:00',8.14),('6449','2013-05-03','08:50:00',8.58),('6449','2013-05-03','08:55:00',8.74),('6449','2013-05-03','09:00:00',9.12),('6449','2013-05-03','09:05:00',9.36),('6449','2013-05-03','09:10:00',9.95),('6449','2013-05-03','09:15:00',10.23),('6449','2013-05-03','09:20:00',10.35),('6449','2013-05-03','09:25:00',10.73),('6449','2013-05-03','09:30:00',11.06),('6449','2013-05-03','09:35:00',11.25),('6449','2013-05-03','09:40:00',11.52),('6449','2013-05-03','09:45:00',11.78),('6449','2013-05-03','09:50:00',11.97),('6449','2013-05-03','09:55:00',12.29),('6449','2013-05-03','10:00:00',12.42),('6449','2013-05-03','10:05:00',12.57),('6449','2013-05-03','10:10:00',12.72),('6449','2013-05-03','10:15:00',12.81),('6449','2013-05-03','10:20:00',12.95),('6449','2013-05-03','10:25:00',13.27),('6449','2013-05-03','10:30:00',13.33),('6449','2013-05-03','10:35:00',13.26),('6449','2013-05-03','10:40:00',13.65),('6449','2013-05-03','10:45:00',13.87),('6449','2013-05-03','10:50:00',13.85),('6449','2013-05-03','10:55:00',14.21),('6449','2013-05-03','11:00:00',14.33),('6449','2013-05-03','11:05:00',14.4),('6449','2013-05-03','11:10:00',14.71),('6449','2013-05-03','11:15:00',14.81),('6449','2013-05-03','11:20:00',14.93),('6449','2013-05-03','11:25:00',14.9),('6449','2013-05-03','11:30:00',14.97),('6449','2013-05-03','11:35:00',15.19),('6449','2013-05-03','11:40:00',15.22),('6449','2013-05-03','11:45:00',15.32),('6449','2013-05-03','11:50:00',15.51),('6449','2013-05-03','11:55:00',15.71),('6449','2013-05-03','12:00:00',15.72),('6449','2013-05-03','12:05:00',15.72),('6449','2013-05-03','12:10:00',15.77),('6449','2013-05-03','12:15:00',15.61),('6449','2013-05-03','12:20:00',15.6),('6449','2013-05-03','12:25:00',15.73),('6449','2013-05-03','12:30:00',15.54),('6449','2013-05-03','12:35:00',15.24),('6449','2013-05-03','12:40:00',15.18),('6449','2013-05-03','12:45:00',15.48),('6449','2013-05-03','12:50:00',15.45),('6449','2013-05-03','12:55:00',15.78),('6449','2013-05-03','13:00:00',15.7),('6449','2013-05-03','13:05:00',15.39),('6449','2013-05-03','13:10:00',14.88),('6449','2013-05-03','13:15:00',15.52),('6449','2013-05-03','13:20:00',16.01),('6449','2013-05-03','13:25:00',15.84),('6449','2013-05-03','13:30:00',15.99),('6449','2013-05-03','13:35:00',16.09),('6449','2013-05-03','13:40:00',16.15),('6449','2013-05-03','13:45:00',16.02),('6449','2013-05-03','13:50:00',15.66),('6449','2013-05-03','13:55:00',15.74),('6449','2013-05-03','14:00:00',15.69),('6449','2013-05-03','14:05:00',15.71),('6449','2013-05-03','14:10:00',15.82),('6449','2013-05-03','14:15:00',15.69),('6449','2013-05-03','14:20:00',15.5),('6449','2013-05-03','14:25:00',15.44),('6449','2013-05-03','14:30:00',15.3),('6449','2013-05-03','14:35:00',14.71),('6449','2013-05-03','14:40:00',15.05),('6449','2013-05-03','14:45:00',15.02),('6449','2013-05-03','14:50:00',14.73),('6449','2013-05-03','14:55:00',14.41),('6449','2013-05-03','15:00:00',14.25),('6449','2013-05-03','15:05:00',14.15),('6449','2013-05-03','15:10:00',13.95),('6449','2013-05-03','15:15:00',13.65),('6449','2013-05-03','15:20:00',13.42),('6449','2013-05-03','15:25:00',12.93),('6449','2013-05-03','15:30:00',13.09),('6449','2013-05-03','15:35:00',12.88),('6449','2013-05-03','15:40:00',12.42),('6449','2013-05-03','15:45:00',12.46),('6449','2013-05-03','15:50:00',11.94),('6449','2013-05-03','15:55:00',11.88),('6449','2013-05-03','16:00:00',11.54),('6449','2013-05-03','16:05:00',11.2),('6449','2013-05-03','16:10:00',10.87),('6449','2013-05-03','16:15:00',10.75),('6449','2013-05-03','16:20:00',10.36),('6449','2013-05-03','16:25:00',10.23),('6449','2013-05-03','16:30:00',9.94),('6449','2013-05-03','16:35:00',9.58),('6449','2013-05-03','16:40:00',9.25),('6449','2013-05-03','16:45:00',8.95),('6449','2013-05-03','16:50:00',8.73),('6449','2013-05-03','16:55:00',7.64),('6449','2013-05-03','17:00:00',7.61),('6449','2013-05-03','17:05:00',7.66),('6449','2013-05-03','17:10:00',7.29),('6449','2013-05-03','17:15:00',7.01),('6449','2013-05-03','17:20:00',6.59),('6449','2013-05-03','17:25:00',6.28),('6449','2013-05-03','17:30:00',5.89),('6449','2013-05-03','17:35:00',5.57),('6449','2013-05-03','17:40:00',5.21),('6449','2013-05-03','17:45:00',4.86),('6449','2013-05-03','17:50:00',4.6),('6449','2013-05-03','17:55:00',4.23),('6449','2013-05-03','18:00:00',3.88),('6449','2013-05-03','18:05:00',3.55),('6449','2013-05-03','18:10:00',3.25),('6449','2013-05-03','18:15:00',2.96),('6449','2013-05-03','18:20:00',2.68),('6449','2013-05-03','18:25:00',2.39),('6449','2013-05-03','18:30:00',2.15),('6449','2013-05-03','18:35:00',1.9),('6449','2013-05-03','18:40:00',1.67),('6449','2013-05-03','18:45:00',1.47),('6449','2013-05-03','18:50:00',1.29),('6449','2013-05-03','18:55:00',1.11),('6449','2013-05-02','07:35:00',1.23),('6449','2013-05-02','07:40:00',1.18),('6449','2013-05-02','07:45:00',1.02),('6449','2013-05-02','08:25:00',1.27),('6449','2013-05-02','08:30:00',1.74),('6449','2013-05-02','08:35:00',1.12),('6449','2013-05-02','08:45:00',1.24),('6449','2013-05-02','08:50:00',1.6),('6449','2013-05-02','08:55:00',1.37),('6449','2013-05-02','09:00:00',1.43),('6449','2013-05-02','09:05:00',2.43),('6449','2013-05-02','09:10:00',3.93),('6449','2013-05-02','09:15:00',5.53),('6449','2013-05-02','09:20:00',2.61),('6449','2013-05-02','09:25:00',1.58),('6449','2013-05-02','09:30:00',1.16),('6449','2013-05-02','09:35:00',1.19),('6449','2013-05-02','09:40:00',1.62),('6449','2013-05-02','09:45:00',2.61),('6449','2013-05-02','09:50:00',6.48),('6449','2013-05-02','09:55:00',8.85),('6449','2013-05-02','10:00:00',12.04),('6449','2013-05-02','10:05:00',5.82),('6449','2013-05-02','10:10:00',13.64),('6449','2013-05-02','10:15:00',6.78),('6449','2013-05-02','10:20:00',7.04),('6449','2013-05-02','10:25:00',8.73),('6449','2013-05-02','10:30:00',12.83),('6449','2013-05-02','10:35:00',10.03),('6449','2013-05-02','10:40:00',8.38),('6449','2013-05-02','10:45:00',9.5),('6449','2013-05-02','10:50:00',11.34),('6449','2013-05-02','10:55:00',9.57),('6449','2013-05-02','11:00:00',6.84),('6449','2013-05-02','11:05:00',7.17),('6449','2013-05-02','11:10:00',7.76),('6449','2013-05-02','11:15:00',14.78),('6449','2013-05-02','11:20:00',10.49),('6449','2013-05-02','11:25:00',8.57),('6449','2013-05-02','11:30:00',8.71),('6449','2013-05-02','11:35:00',9.46),('6449','2013-05-02','11:40:00',8.61),('6449','2013-05-02','11:45:00',9.55),('6449','2013-05-02','11:50:00',9.65),('6449','2013-05-02','11:55:00',9.03),('6449','2013-05-02','12:00:00',8.56),('6449','2013-05-02','12:05:00',8.75),('6449','2013-05-02','12:10:00',11.65),('6449','2013-05-02','12:15:00',16.97),('6449','2013-05-02','12:20:00',15.35),('6449','2013-05-02','12:25:00',12),('6449','2013-05-02','12:30:00',12.56),('6449','2013-05-02','12:35:00',10.79),('6449','2013-05-02','12:40:00',11.22),('6449','2013-05-02','12:45:00',11.87),('6449','2013-05-02','12:50:00',14.3),('6449','2013-05-02','12:55:00',16.45),('6449','2013-05-02','13:00:00',15.34),('6449','2013-05-02','13:05:00',15.54),('6449','2013-05-02','13:10:00',15.93),('6449','2013-05-02','13:15:00',15.83),('6449','2013-05-02','13:20:00',15.79),('6449','2013-05-02','13:25:00',15.97),('6449','2013-05-02','13:30:00',15.95),('6449','2013-05-02','13:35:00',16.01),('6449','2013-05-02','13:40:00',16.04),('6449','2013-05-02','13:45:00',15.94),('6449','2013-05-02','13:50:00',15.92),('6449','2013-05-02','13:55:00',15.86),('6449','2013-05-02','14:00:00',15.72),('6449','2013-05-02','14:05:00',15.71),('6449','2013-05-02','14:10:00',15.54),('6449','2013-05-02','14:15:00',15.38),('6449','2013-05-02','14:20:00',15.1),('6449','2013-05-02','14:25:00',15.19),('6449','2013-05-02','14:30:00',14.9),('6449','2013-05-02','14:35:00',15.06),('6449','2013-05-02','14:40:00',14.95),('6449','2013-05-02','14:45:00',14.77),('6449','2013-05-02','14:50:00',14.66),('6449','2013-05-02','14:55:00',14.46),('6449','2013-05-02','15:00:00',14.25),('6449','2013-05-02','15:05:00',14.05),('6449','2013-05-02','15:10:00',14.01),('6449','2013-05-02','15:15:00',13.8),('6449','2013-05-02','15:20:00',13.67),('6449','2013-05-02','15:25:00',13.49),('6449','2013-05-02','15:30:00',13.25),('6449','2013-05-02','15:35:00',12.92),('6449','2013-05-02','15:40:00',12.65),('6449','2013-05-02','15:45:00',12.47),('6449','2013-05-02','15:50:00',12.23),('6449','2013-05-02','15:55:00',11.99),('6449','2013-05-02','16:00:00',11.61),('6449','2013-05-02','16:05:00',11.22),('6449','2013-05-02','16:10:00',11.09),('6449','2013-05-02','16:15:00',10.7),('6449','2013-05-02','16:20:00',10.59),('6449','2013-05-02','16:25:00',10.28),('6449','2013-05-02','16:30:00',9.97),('6449','2013-05-02','16:35:00',9.69),('6449','2013-05-02','16:40:00',9.46),('6449','2013-05-02','16:45:00',9.07),('6449','2013-05-02','16:50:00',8.7),('6449','2013-05-02','16:55:00',8.44),('6449','2013-05-02','17:00:00',8.13),('6449','2013-05-02','17:05:00',7.82),('6449','2013-05-02','17:10:00',7.43),('6449','2013-05-02','17:15:00',7.08),('6449','2013-05-02','17:20:00',6.7),('6449','2013-05-02','17:25:00',6.39),('6449','2013-05-02','17:30:00',5.99),('6449','2013-05-02','17:35:00',5.68),('6449','2013-05-02','17:40:00',5.36),('6449','2013-05-02','17:45:00',4.98),('6449','2013-05-02','17:50:00',4.62),('6449','2013-05-02','17:55:00',4.33),('6449','2013-05-02','18:00:00',3.95),('6449','2013-05-02','18:05:00',3.64),('6449','2013-05-02','18:10:00',3.35),('6449','2013-05-02','18:15:00',3.02),('6449','2013-05-02','18:20:00',2.73),('6449','2013-05-02','18:25:00',2.45),('6449','2013-05-02','18:30:00',2.18),('6449','2013-05-02','18:35:00',1.93),('6449','2013-05-02','18:40:00',1.69),('6449','2013-05-02','18:45:00',1.48),('6449','2013-05-02','18:50:00',1.28),('6449','2013-05-02','18:55:00',1.09),('6449','2013-05-01','07:00:00',1.09),('6449','2013-05-01','07:05:00',1.22),('6449','2013-05-01','07:10:00',1.44),('6449','2013-05-01','07:15:00',1.65),('6449','2013-05-01','07:20:00',1.91),('6449','2013-05-01','07:25:00',2.18),('6449','2013-05-01','07:30:00',2.44),('6449','2013-05-01','07:35:00',2.68),('6449','2013-05-01','07:40:00',3.01),('6449','2013-05-01','07:45:00',3.27),('6449','2013-05-01','07:50:00',3.47),('6449','2013-05-01','07:55:00',3.81),('6449','2013-05-01','08:00:00',4.18),('6449','2013-05-01','08:05:00',4.54),('6449','2013-05-01','08:10:00',4.91),('6449','2013-05-01','08:15:00',5.33),('6449','2013-05-01','08:20:00',5.61),('6449','2013-05-01','08:25:00',6.02),('6449','2013-05-01','08:30:00',6.34),('6449','2013-05-01','08:35:00',6.7),('6449','2013-05-01','08:40:00',7.04),('6449','2013-05-01','08:45:00',7.44),('6449','2013-05-01','08:50:00',7.73),('6449','2013-05-01','08:55:00',7.98),('6449','2013-05-01','09:00:00',8.07),('6449','2013-05-01','09:05:00',8.33),('6449','2013-05-01','09:10:00',8.74),('6449','2013-05-01','09:15:00',8.99),('6449','2013-05-01','09:20:00',9.12),('6449','2013-05-01','09:25:00',9.43),('6449','2013-05-01','09:30:00',9.73),('6449','2013-05-01','09:35:00',9.87),('6449','2013-05-01','09:40:00',10.15),('6449','2013-05-01','09:45:00',10.49),('6449','2013-05-01','09:50:00',10.76),('6449','2013-05-01','09:55:00',11.25),('6449','2013-05-01','10:00:00',11.49),('6449','2013-05-01','10:05:00',11.58),('6449','2013-05-01','10:10:00',11.98),('6449','2013-05-01','10:15:00',12.27),('6449','2013-05-01','10:20:00',12.53),('6449','2013-05-01','10:25:00',12.75),('6449','2013-05-01','10:30:00',12.79),('6449','2013-05-01','10:35:00',12.87),('6449','2013-05-01','10:40:00',13.12),('6449','2013-05-01','10:45:00',13.14),('6449','2013-05-01','10:50:00',13.27),('6449','2013-05-01','10:55:00',13.32),('6449','2013-05-01','11:00:00',13.43),('6449','2013-05-01','11:05:00',13.43),('6449','2013-05-01','11:10:00',13.58),('6449','2013-05-01','11:15:00',13.71),('6449','2013-05-01','11:20:00',13.88),('6449','2013-05-01','11:25:00',14.22),('6449','2013-05-01','11:30:00',14.35),('6449','2013-05-01','11:35:00',14.44),('6449','2013-05-01','11:40:00',14.52),('6449','2013-05-01','11:45:00',14.47),('6449','2013-05-01','11:50:00',14.23),('6449','2013-05-01','11:55:00',14.31),('6449','2013-05-01','12:00:00',14.32),('6449','2013-05-01','12:05:00',14.4),('6449','2013-05-01','12:10:00',15.21),('6449','2013-05-01','12:15:00',11.19),('6449','2013-05-01','12:20:00',10.48),('6449','2013-05-01','12:25:00',10.25),('6449','2013-05-01','12:30:00',8.27),('6449','2013-05-01','12:35:00',10.16),('6449','2013-05-01','12:40:00',8.44),('6449','2013-05-01','12:45:00',10.08),('6449','2013-05-01','12:50:00',11.57),('6449','2013-05-01','12:55:00',15.78),('6449','2013-05-01','13:00:00',14.34),('6449','2013-05-01','13:05:00',11.45),('6449','2013-05-01','13:10:00',13.19),('6449','2013-05-01','13:15:00',15.7),('6449','2013-05-01','13:20:00',15.19),('6449','2013-05-01','13:25:00',15.24),('6449','2013-05-01','13:30:00',15.19),('6449','2013-05-01','13:35:00',14.77),('6449','2013-05-01','13:40:00',15.13),('6449','2013-05-01','13:45:00',14.98),('6449','2013-05-01','13:50:00',14.66),('6449','2013-05-01','13:55:00',13.78),('6449','2013-05-01','14:00:00',15.62),('6449','2013-05-01','14:05:00',14.27),('6449','2013-05-01','14:10:00',10.01),('6449','2013-05-01','14:15:00',10.63),('6449','2013-05-01','14:20:00',11.68),('6449','2013-05-01','14:25:00',12.84),('6449','2013-05-01','14:30:00',14.98),('6449','2013-05-01','14:35:00',13.76),('6449','2013-05-01','14:40:00',11.49),('6449','2013-05-01','14:45:00',12.52),('6449','2013-05-01','14:50:00',8.55),('6449','2013-05-01','14:55:00',7.27),('6449','2013-05-01','15:00:00',9.83),('6449','2013-05-01','15:05:00',7.33),('6449','2013-05-01','15:10:00',8.69),('6449','2013-05-01','15:15:00',7.78),('6449','2013-05-01','15:20:00',7.08),('6449','2013-05-01','15:25:00',6.89),('6449','2013-05-01','15:30:00',6.87),('6449','2013-05-01','15:35:00',7.8),('6449','2013-05-01','15:40:00',8.5),('6449','2013-05-01','15:45:00',7.56),('6449','2013-05-01','15:50:00',6.84),('6449','2013-05-01','15:55:00',5.65),('6449','2013-05-01','16:00:00',6.17),('6449','2013-05-01','16:05:00',7.5),('6449','2013-05-01','16:10:00',8.19),('6449','2013-05-01','16:15:00',8.08),('6449','2013-05-01','16:20:00',5.92),('6449','2013-05-01','16:25:00',4.64),('6449','2013-05-01','16:30:00',4.25),('6449','2013-05-01','16:35:00',4.06),('6449','2013-05-01','16:40:00',3.52),('6449','2013-05-01','16:45:00',3.16),('6449','2013-05-01','16:50:00',3.17),('6449','2013-05-01','16:55:00',3.22),('6449','2013-05-01','17:00:00',2.95),('6449','2013-05-01','17:05:00',2.48),('6449','2013-05-01','17:10:00',1.98),('6449','2013-05-01','17:15:00',1.74),('6449','2013-05-01','17:20:00',1.61),('6449','2013-05-01','17:25:00',1.63),('6449','2013-05-01','17:30:00',1.53),('6449','2013-05-01','17:35:00',1.5),('6449','2013-05-01','17:40:00',1.45),('6449','2013-05-01','17:45:00',1.32),('6449','2013-05-01','17:50:00',1.29),('6449','2013-05-01','17:55:00',1.37),('6449','2013-05-01','18:00:00',1.3),('6449','2013-04-30','07:50:00',1.18),('6449','2013-04-30','07:55:00',1.78),('6449','2013-04-30','08:00:00',2.71),('6449','2013-04-30','08:05:00',3.57),('6449','2013-04-30','08:10:00',3.47),('6449','2013-04-30','08:15:00',4.33),('6449','2013-04-30','08:20:00',3.67),('6449','2013-04-30','08:25:00',2.88),('6449','2013-04-30','08:30:00',3.08),('6449','2013-04-30','08:35:00',2.98),('6449','2013-04-30','08:40:00',2.99),('6449','2013-04-30','08:45:00',3.27),('6449','2013-04-30','08:50:00',3.62),('6449','2013-04-30','08:55:00',4.87),('6449','2013-04-30','09:00:00',6.57),('6449','2013-04-30','09:05:00',7.93),('6449','2013-04-30','09:10:00',8.38),('6449','2013-04-30','09:15:00',7.22),('6449','2013-04-30','09:20:00',6.78),('6449','2013-04-30','09:25:00',5.09),('6449','2013-04-30','09:30:00',8.84),('6449','2013-04-30','09:35:00',8.18),('6449','2013-04-30','09:40:00',7.5),('6449','2013-04-30','09:45:00',6.56),('6449','2013-04-30','09:50:00',5.82),('6449','2013-04-30','09:55:00',4.96),('6449','2013-04-30','10:00:00',2.97),('6449','2013-04-30','10:05:00',2.29),('6449','2013-04-30','10:10:00',2.19),('6449','2013-04-30','10:15:00',2.21),('6449','2013-04-30','10:20:00',2.46),('6449','2013-04-30','10:25:00',2.7),('6449','2013-04-30','10:30:00',3.21),('6449','2013-04-30','10:35:00',5.14),('6449','2013-04-30','10:40:00',6.11),('6449','2013-04-30','10:45:00',5.47),('6449','2013-04-30','10:50:00',6.28),('6449','2013-04-30','10:55:00',7.23),('6449','2013-04-30','11:00:00',8.81),('6449','2013-04-30','11:05:00',9.71),('6449','2013-04-30','11:10:00',8),('6449','2013-04-30','11:15:00',7.52),('6449','2013-04-30','11:20:00',9.2),('6449','2013-04-30','11:25:00',11.87),('6449','2013-04-30','11:30:00',8.9),('6449','2013-04-30','11:35:00',8.22),('6449','2013-04-30','11:40:00',10.39),('6449','2013-04-30','11:45:00',14.34),('6449','2013-04-30','11:50:00',14.2),('6449','2013-04-30','11:55:00',8.85),('6449','2013-04-30','12:00:00',8.23),('6449','2013-04-30','12:05:00',8),('6449','2013-04-30','12:10:00',6.75),('6449','2013-04-30','12:15:00',6.61),('6449','2013-04-30','12:20:00',7.32),('6449','2013-04-30','12:25:00',9.89),('6449','2013-04-30','12:30:00',10.11),('6449','2013-04-30','12:35:00',10.78),('6449','2013-04-30','12:40:00',15.07),('6449','2013-04-30','12:45:00',13.32),('6449','2013-04-30','12:50:00',17.33),('6449','2013-04-30','12:55:00',16.48),('6449','2013-04-30','13:00:00',16.41),('6449','2013-04-30','13:05:00',15.95),('6449','2013-04-30','13:10:00',15.66),('6449','2013-04-30','13:15:00',15.47),('6449','2013-04-30','13:20:00',15.5),('6449','2013-04-30','13:25:00',15.48),('6449','2013-04-30','13:30:00',15.32),('6449','2013-04-30','13:35:00',15.23),('6449','2013-04-30','13:40:00',15.22),('6449','2013-04-30','13:45:00',15.15),('6449','2013-04-30','13:50:00',14.73),('6449','2013-04-30','13:55:00',15.02),('6449','2013-04-30','14:00:00',15.03),('6449','2013-04-30','14:05:00',14.77),('6449','2013-04-30','14:10:00',14.62),('6449','2013-04-30','14:15:00',14.43),('6449','2013-04-30','14:20:00',14.26),('6449','2013-04-30','14:25:00',14.2),('6449','2013-04-30','14:30:00',13.99),('6449','2013-04-30','14:35:00',13.83),('6449','2013-04-30','14:40:00',13.66),('6449','2013-04-30','14:45:00',13.44),('6449','2013-04-30','14:50:00',13.11),('6449','2013-04-30','14:55:00',12.98),('6449','2013-04-30','15:00:00',12.77),('6449','2013-04-30','15:05:00',12.59),('6449','2013-04-30','15:10:00',12.27),('6449','2013-04-30','15:15:00',11.96),('6449','2013-04-30','15:20:00',12.11),('6449','2013-04-30','15:25:00',11.99),('6449','2013-04-30','15:30:00',12.07),('6449','2013-04-30','15:35:00',11.97),('6449','2013-04-30','15:40:00',9.71),('6449','2013-04-30','15:45:00',7.64),('6449','2013-04-30','15:50:00',8.62),('6449','2013-04-30','15:55:00',10.02),('6449','2013-04-30','16:00:00',11.27),('6449','2013-04-30','16:05:00',10.88),('6449','2013-04-30','16:10:00',9.59),('6449','2013-04-30','16:15:00',7.55),('6449','2013-04-30','16:20:00',5.47),('6449','2013-04-30','16:25:00',6.35),('6449','2013-04-30','16:30:00',7.25),('6449','2013-04-30','16:35:00',6.11),('6449','2013-04-30','16:40:00',5.39),('6449','2013-04-30','16:45:00',5.3),('6449','2013-04-30','16:50:00',6.32),('6449','2013-04-30','16:55:00',6.63),('6449','2013-04-30','17:00:00',5.47),('6449','2013-04-30','17:05:00',4.69),('6449','2013-04-30','17:10:00',6.68),('6449','2013-04-30','17:15:00',5.83),('6449','2013-04-30','17:20:00',4.64),('6449','2013-04-30','17:25:00',5.49),('6449','2013-04-30','17:30:00',4.91),('6449','2013-04-30','17:35:00',4.76),('6449','2013-04-30','17:40:00',4.33),('6449','2013-04-30','17:45:00',4.1),('6449','2013-04-30','17:50:00',3.84),('6449','2013-04-30','17:55:00',3.44),('6449','2013-04-30','18:00:00',3.2),('6449','2013-04-30','18:05:00',2.74),('6449','2013-04-30','18:10:00',2.17),('6449','2013-04-30','18:15:00',2.05),('6449','2013-04-30','18:20:00',2.26),('6449','2013-04-30','18:25:00',2.12),('6449','2013-04-30','18:30:00',2),('6449','2013-04-30','18:35:00',1.8),('6449','2013-04-30','18:40:00',1.54),('6449','2013-04-30','18:45:00',1.32),('6449','2013-04-30','18:50:00',1.1),('6449','2013-04-29','07:05:00',1.28),('6449','2013-04-29','07:10:00',1.66),('6449','2013-04-29','07:15:00',1.96),('6449','2013-04-29','07:20:00',2.07),('6449','2013-04-29','07:25:00',2.05),('6449','2013-04-29','07:30:00',2),('6449','2013-04-29','07:35:00',2.34),('6449','2013-04-29','07:40:00',2.87),('6449','2013-04-29','07:45:00',3.34),('6449','2013-04-29','07:50:00',3.76),('6449','2013-04-29','07:55:00',3.82),('6449','2013-04-29','08:00:00',4.26),('6449','2013-04-29','08:05:00',4.46),('6449','2013-04-29','08:10:00',4.04),('6449','2013-04-29','08:15:00',4.05),('6449','2013-04-29','08:20:00',4.69),('6449','2013-04-29','08:25:00',4.79),('6449','2013-04-29','08:30:00',5.47),('6449','2013-04-29','08:35:00',5.76),('6449','2013-04-29','08:40:00',5.63),('6449','2013-04-29','08:45:00',7.09),('6449','2013-04-29','08:50:00',7.55),('6449','2013-04-29','08:55:00',7.79),('6449','2013-04-29','09:00:00',8.21),('6449','2013-04-29','09:05:00',8.78),('6449','2013-04-29','09:10:00',8.89),('6449','2013-04-29','09:15:00',8.49),('6449','2013-04-29','09:20:00',8.8),('6449','2013-04-29','09:25:00',8.69),('6449','2013-04-29','09:30:00',8.91),('6449','2013-04-29','09:35:00',10.18),('6449','2013-04-29','09:40:00',9.85),('6449','2013-04-29','09:45:00',10.44),('6449','2013-04-29','09:50:00',10.6),('6449','2013-04-29','09:55:00',11.32),('6449','2013-04-29','10:00:00',10.81),('6449','2013-04-29','10:05:00',10.64),('6449','2013-04-29','10:10:00',10.63),('6449','2013-04-29','10:15:00',11.3),('6449','2013-04-29','10:20:00',10.72),('6449','2013-04-29','10:25:00',11.83),('6449','2013-04-29','10:30:00',11.34),('6449','2013-04-29','10:35:00',11.21),('6449','2013-04-29','10:40:00',12.51),('6449','2013-04-29','10:45:00',13.24),('6449','2013-04-29','10:50:00',13.02),('6449','2013-04-29','10:55:00',13.11),('6449','2013-04-29','11:00:00',13.3),('6449','2013-04-29','11:05:00',13.94),('6449','2013-04-29','11:10:00',13.56),('6449','2013-04-29','11:15:00',14.25),('6449','2013-04-29','11:20:00',14.55),('6449','2013-04-29','11:25:00',14.72),('6449','2013-04-29','11:30:00',14.54),('6449','2013-04-29','11:35:00',14.22),('6449','2013-04-29','11:40:00',13.87),('6449','2013-04-29','11:45:00',14.32),('6449','2013-04-29','11:50:00',14.62),('6449','2013-04-29','11:55:00',14.47),('6449','2013-04-29','12:00:00',15.02),('6449','2013-04-29','12:05:00',14.91),('6449','2013-04-29','12:10:00',14.92),('6449','2013-04-29','12:15:00',15.01),('6449','2013-04-29','12:20:00',15.2),('6449','2013-04-29','12:25:00',15.74),('6449','2013-04-29','12:30:00',15.41),('6449','2013-04-29','12:35:00',14.9),('6449','2013-04-29','12:40:00',14.91),('6449','2013-04-29','12:45:00',15.13),('6449','2013-04-29','12:50:00',14.93),('6449','2013-04-29','12:55:00',15.31),('6449','2013-04-29','13:00:00',15.39),('6449','2013-04-29','13:05:00',14.79),('6449','2013-04-29','13:10:00',14.22),('6449','2013-04-29','13:15:00',14.19),('6449','2013-04-29','13:20:00',14.41),('6449','2013-04-29','13:25:00',13.84),('6449','2013-04-29','13:30:00',14),('6449','2013-04-29','13:35:00',13.96),('6449','2013-04-29','13:40:00',13.33),('6449','2013-04-29','13:45:00',13.09),('6449','2013-04-29','13:50:00',12.46),('6449','2013-04-29','13:55:00',12.69),('6449','2013-04-29','14:00:00',12.28),('6449','2013-04-29','14:05:00',12.28),('6449','2013-04-29','14:10:00',12.18),('6449','2013-04-29','14:15:00',12.09),('6449','2013-04-29','14:20:00',12.18),('6449','2013-04-29','14:25:00',12.12),('6449','2013-04-29','14:30:00',11.9),('6449','2013-04-29','14:35:00',12.25),('6449','2013-04-29','14:40:00',12.49),('6449','2013-04-29','14:45:00',12.36),('6449','2013-04-29','14:50:00',11.33),('6449','2013-04-29','14:55:00',11.45),('6449','2013-04-29','15:00:00',12.28),('6449','2013-04-29','15:05:00',12),('6449','2013-04-29','15:10:00',10.18),('6449','2013-04-29','15:15:00',10.76),('6449','2013-04-29','15:20:00',10.2),('6449','2013-04-29','15:25:00',10.14),('6449','2013-04-29','15:30:00',10.07),('6449','2013-04-29','15:35:00',10.83),('6449','2013-04-29','15:40:00',11.39),('6449','2013-04-29','15:45:00',11.2),('6449','2013-04-29','15:50:00',10.34),('6449','2013-04-29','15:55:00',10.3),('6449','2013-04-29','16:00:00',10.01),('6449','2013-04-29','16:05:00',10.37),('6449','2013-04-29','16:10:00',10.31),('6449','2013-04-29','16:15:00',10.6),('6449','2013-04-29','16:20:00',11.05),('6449','2013-04-29','16:25:00',9.96),('6449','2013-04-29','16:30:00',10.76),('6449','2013-04-29','16:35:00',10),('6449','2013-04-29','16:40:00',8.96),('6449','2013-04-29','16:45:00',9.16),('6449','2013-04-29','16:50:00',9.37),('6449','2013-04-29','16:55:00',6.88),('6449','2013-04-29','17:00:00',6.13),('6449','2013-04-29','17:05:00',5.43),('6449','2013-04-29','17:10:00',7.68),('6449','2013-04-29','17:15:00',7.44),('6449','2013-04-29','17:20:00',7.19),('6449','2013-04-29','17:25:00',7.12),('6449','2013-04-29','17:30:00',6.45),('6449','2013-04-29','17:35:00',6.12),('6449','2013-04-29','17:40:00',5.87),('6449','2013-04-29','17:45:00',5.47),('6449','2013-04-29','17:50:00',5.47),('6449','2013-04-29','17:55:00',4.77),('6449','2013-04-29','18:00:00',4.64),('6449','2013-04-29','18:05:00',4.16),('6449','2013-04-29','18:10:00',3.45),('6449','2013-04-29','18:15:00',3.16),('6449','2013-04-29','18:20:00',2.76),('6449','2013-04-29','18:25:00',2.4),('6449','2013-04-29','18:30:00',2.14),('6449','2013-04-29','18:35:00',1.69),('6449','2013-04-29','18:40:00',1.26),('6449','2013-04-29','18:45:00',1),('6449','2013-04-28','07:00:00',1.07),('6449','2013-04-28','07:05:00',1.26),('6449','2013-04-28','07:10:00',1.54),('6449','2013-04-28','07:15:00',1.83),('6449','2013-04-28','07:20:00',2.15),('6449','2013-04-28','07:25:00',2.47),('6449','2013-04-28','07:30:00',2.78),('6449','2013-04-28','07:35:00',3.03),('6449','2013-04-28','07:40:00',3.44),('6449','2013-04-28','07:45:00',3.79),('6449','2013-04-28','07:50:00',4.11),('6449','2013-04-28','07:55:00',4.51),('6449','2013-04-28','08:00:00',4.93),('6449','2013-04-28','08:05:00',5.45),('6449','2013-04-28','08:10:00',5.99),('6449','2013-04-28','08:15:00',6.27),('6449','2013-04-28','08:20:00',4.91),('6449','2013-04-28','08:25:00',6.41),('6449','2013-04-28','08:30:00',7.22),('6449','2013-04-28','08:35:00',7.25),('6449','2013-04-28','08:40:00',7.84),('6449','2013-04-28','08:45:00',8.21),('6449','2013-04-28','08:50:00',8.46),('6449','2013-04-28','08:55:00',8.92),('6449','2013-04-28','09:00:00',9.29),('6449','2013-04-28','09:05:00',9.58),('6449','2013-04-28','09:10:00',9.87),('6449','2013-04-28','09:15:00',10.27),('6449','2013-04-28','09:20:00',10.42),('6449','2013-04-28','09:25:00',10.83),('6449','2013-04-28','09:30:00',11.18),('6449','2013-04-28','09:35:00',11.43),('6449','2013-04-28','09:40:00',11.67),('6449','2013-04-28','09:45:00',11.89),('6449','2013-04-28','09:50:00',12.26),('6449','2013-04-28','09:55:00',12.55),('6449','2013-04-28','10:00:00',12.77),('6449','2013-04-28','10:05:00',13.05),('6449','2013-04-28','10:10:00',13.27),('6449','2013-04-28','10:15:00',13.48),('6449','2013-04-28','10:20:00',13.48),('6449','2013-04-28','10:25:00',13.71),('6449','2013-04-28','10:30:00',13.48),('6449','2013-04-28','10:35:00',13.77),('6449','2013-04-28','10:40:00',14.14),('6449','2013-04-28','10:45:00',13.92),('6449','2013-04-28','10:50:00',14.6),('6449','2013-04-28','10:55:00',14.41),('6449','2013-04-28','11:00:00',14.89),('6449','2013-04-28','11:05:00',14.67),('6449','2013-04-28','11:10:00',14.65),('6449','2013-04-28','11:15:00',14.09),('6449','2013-04-28','11:20:00',13.72),('6449','2013-04-28','11:25:00',15.15),('6449','2013-04-28','11:30:00',14.91),('6449','2013-04-28','11:35:00',15.24),('6449','2013-04-28','11:40:00',15.51),('6449','2013-04-28','11:45:00',14.31),('6449','2013-04-28','11:50:00',13.6),('6449','2013-04-28','11:55:00',14.12),('6449','2013-04-28','12:00:00',14.85),('6449','2013-04-28','12:05:00',14.42),('6449','2013-04-28','12:10:00',14.54),('6449','2013-04-28','12:15:00',14.37),('6449','2013-04-28','12:20:00',14.36),('6449','2013-04-28','12:25:00',16.06),('6449','2013-04-28','12:30:00',14.69),('6449','2013-04-28','12:35:00',12.96),('6449','2013-04-28','12:40:00',15.2),('6449','2013-04-28','12:45:00',15.11),('6449','2013-04-28','12:50:00',16.14),('6449','2013-04-28','12:55:00',14.84),('6449','2013-04-28','13:00:00',14.44),('6449','2013-04-28','13:05:00',14.79),('6449','2013-04-28','13:10:00',15.2),('6449','2013-04-28','13:15:00',15.96),('6449','2013-04-28','13:20:00',15.97),('6449','2013-04-28','13:25:00',13.92),('6449','2013-04-28','13:30:00',13.51),('6449','2013-04-28','13:35:00',14.69),('6449','2013-04-28','13:40:00',15.56),('6449','2013-04-28','13:45:00',15.73),('6449','2013-04-28','13:50:00',15.53),('6449','2013-04-28','13:55:00',15.18),('6449','2013-04-28','14:00:00',15.09),('6449','2013-04-28','14:05:00',15.01),('6449','2013-04-28','14:10:00',13.91),('6449','2013-04-28','14:15:00',14.83),('6449','2013-04-28','14:20:00',14.6),('6449','2013-04-28','14:25:00',14.54),('6449','2013-04-28','14:30:00',14.44),('6449','2013-04-28','14:35:00',14.26),('6449','2013-04-28','14:40:00',13.9),('6449','2013-04-28','14:45:00',13.88),('6449','2013-04-28','14:50:00',13.73),('6449','2013-04-28','14:55:00',13.65),('6449','2013-04-28','15:00:00',13.55),('6449','2013-04-28','15:05:00',13.39),('6449','2013-04-28','15:10:00',13.21),('6449','2013-04-28','15:15:00',13.08),('6449','2013-04-28','15:20:00',12.89),('6449','2013-04-28','15:25:00',12.74),('6449','2013-04-28','15:30:00',12.54),('6449','2013-04-28','15:35:00',12.3),('6449','2013-04-28','15:40:00',12.07),('6449','2013-04-28','15:45:00',11.82),('6449','2013-04-28','15:50:00',11.55),('6449','2013-04-28','15:55:00',11.03),('6449','2013-04-28','16:00:00',10.94),('6449','2013-04-28','16:05:00',10.72),('6449','2013-04-28','16:10:00',10.51),('6449','2013-04-28','16:15:00',10.23),('6449','2013-04-28','16:20:00',9.93),('6449','2013-04-28','16:25:00',9.5),('6449','2013-04-28','16:30:00',9.35),('6449','2013-04-28','16:35:00',9.1),('6449','2013-04-28','16:40:00',8.93),('6449','2013-04-28','16:45:00',8.66),('6449','2013-04-28','16:50:00',8.42),('6449','2013-04-28','16:55:00',7.98),('6449','2013-04-28','17:00:00',7.17),('6449','2013-04-28','17:05:00',7.13),('6449','2013-04-28','17:10:00',6.99),('6449','2013-04-28','17:15:00',6.98),('6449','2013-04-28','17:20:00',6.33),('6449','2013-04-28','17:25:00',5.99),('6449','2013-04-28','17:30:00',5.58),('6449','2013-04-28','17:35:00',4.68),('6449','2013-04-28','17:40:00',5.07),('6449','2013-04-28','17:45:00',4.65),('6449','2013-04-28','17:50:00',4.49),('6449','2013-04-28','17:55:00',3.85),('6449','2013-04-28','18:00:00',3.05),('6449','2013-04-28','18:05:00',2.88),('6449','2013-04-28','18:10:00',3.26),('6449','2013-04-28','18:15:00',2.79),('6449','2013-04-28','18:20:00',2.33),('6449','2013-04-28','18:25:00',1.84),('6449','2013-04-28','18:30:00',1.73),('6449','2013-04-28','18:35:00',1.56),('6449','2013-04-28','18:40:00',1.53),('6449','2013-04-28','18:45:00',1.72),('6449','2013-04-28','18:50:00',1.65),('6449','2013-04-28','18:55:00',1.46),('6449','2013-04-28','19:00:00',1.22),('6449','2013-04-28','19:05:00',1.05),('6449','2013-04-27','07:20:00',1.05),('6449','2013-04-27','07:25:00',1.5),('6449','2013-04-27','07:30:00',1.84),('6449','2013-04-27','07:35:00',1.95),('6449','2013-04-27','07:40:00',1.97),('6449','2013-04-27','07:45:00',1.83),('6449','2013-04-27','07:50:00',1.47),('6449','2013-04-27','09:15:00',1.37),('6449','2013-04-27','09:20:00',1.44),('6449','2013-04-27','09:25:00',1.26),('6449','2013-04-27','09:30:00',1.26),('6449','2013-04-27','09:35:00',1.17),('6449','2013-04-27','09:40:00',1.13),('6449','2013-04-27','10:30:00',1.15),('6449','2013-04-27','10:35:00',1.15),('6449','2013-04-27','10:40:00',1.07),('6449','2013-04-27','10:45:00',1.11),('6449','2013-04-27','11:25:00',1.04),('6449','2013-04-27','11:35:00',1.29),('6449','2013-04-27','11:40:00',1.48),('6449','2013-04-27','11:45:00',1.72),('6449','2013-04-27','11:50:00',1.43),('6449','2013-04-27','11:55:00',1.55),('6449','2013-04-27','12:00:00',1.94),('6449','2013-04-27','12:05:00',2.35),('6449','2013-04-27','12:10:00',2.88),('6449','2013-04-27','12:15:00',2.37),('6449','2013-04-27','12:20:00',2.51),('6449','2013-04-27','12:25:00',2.62),('6449','2013-04-27','12:30:00',4.09),('6449','2013-04-27','12:35:00',4.49),('6449','2013-04-27','12:40:00',6.14),('6449','2013-04-27','12:45:00',5.71),('6449','2013-04-27','12:50:00',3.73),('6449','2013-04-27','12:55:00',2.66),('6449','2013-04-27','13:00:00',3.19),('6449','2013-04-27','13:05:00',2.63),('6449','2013-04-27','13:10:00',2.65),('6449','2013-04-27','13:15:00',4.3),('6449','2013-04-27','13:20:00',6.08),('6449','2013-04-27','13:25:00',5.71),('6449','2013-04-27','13:30:00',3.55),('6449','2013-04-27','13:35:00',5.37),('6449','2013-04-27','13:40:00',4.7),('6449','2013-04-27','13:45:00',3.5),('6449','2013-04-27','13:50:00',2.72),('6449','2013-04-27','13:55:00',2.93),('6449','2013-04-27','14:00:00',5.45),('6449','2013-04-27','14:05:00',11.9),('6449','2013-04-27','14:10:00',6.51),('6449','2013-04-27','14:15:00',6.28),('6449','2013-04-27','14:20:00',6.59),('6449','2013-04-27','14:25:00',5.61),('6449','2013-04-27','14:30:00',3.84),('6449','2013-04-27','14:35:00',3.8),('6449','2013-04-27','14:40:00',3.94),('6449','2013-04-27','14:45:00',3.39),('6449','2013-04-27','14:50:00',2.58),('6449','2013-04-27','14:55:00',1.55),('6449','2013-04-27','15:25:00',2.03),('6449','2013-04-27','15:30:00',3.1),('6449','2013-04-27','15:35:00',3.49),('6449','2013-04-27','15:40:00',2.58),('6449','2013-04-27','16:00:00',1.07),('6449','2013-04-27','16:05:00',1.92),('6449','2013-04-27','16:10:00',1.53),('6449','2013-04-27','16:15:00',2.78),('6449','2013-04-27','16:20:00',7.14),('6449','2013-04-27','16:25:00',5.48),('6449','2013-04-27','16:30:00',4.67),('6449','2013-04-27','16:35:00',8.62),('6449','2013-04-27','16:40:00',5.42),('6449','2013-04-27','16:45:00',4.21),('6449','2013-04-27','16:50:00',3.76),('6449','2013-04-27','16:55:00',2.57),('6449','2013-04-27','17:00:00',2.26),('6449','2013-04-27','17:05:00',3.13),('6449','2013-04-27','17:10:00',2.17),('6449','2013-04-27','17:15:00',1.63),('6449','2013-04-27','17:20:00',1.4),('6449','2013-04-27','17:25:00',2.71),('6449','2013-04-27','17:30:00',2.87),('6449','2013-04-27','17:35:00',1.44),('6449','2013-04-27','17:40:00',1.27),('6449','2013-04-27','17:45:00',1.46),('6449','2013-04-27','17:50:00',1.29),('6449','2013-04-27','17:55:00',1.72),('6449','2013-04-27','18:00:00',2.61),('6449','2013-04-27','18:05:00',1.83),('6449','2013-04-27','18:10:00',1.26),('6449','2013-04-27','18:15:00',1.19),('6449','2013-04-27','18:20:00',1.5),('6449','2013-04-27','18:25:00',1.22),('6449','2013-04-27','18:30:00',1.26),('6449','2013-04-26','06:55:00',1.04),('6449','2013-04-26','07:00:00',1.17),('6449','2013-04-26','07:05:00',1.22),('6449','2013-04-26','07:10:00',1.21),('6449','2013-04-26','07:15:00',1.19),('6449','2013-04-26','07:20:00',1.14),('6449','2013-04-26','07:25:00',1.23),('6449','2013-04-26','07:30:00',1.45),('6449','2013-04-26','07:35:00',1.61),('6449','2013-04-26','07:40:00',1.84),('6449','2013-04-26','07:45:00',2.38),('6449','2013-04-26','07:50:00',2.67),('6449','2013-04-26','07:55:00',3.45),('6449','2013-04-26','08:00:00',3.93),('6449','2013-04-26','08:05:00',4.3),('6449','2013-04-26','08:10:00',4.71),('6449','2013-04-26','08:15:00',4.95),('6449','2013-04-26','08:20:00',5.19),('6449','2013-04-26','08:25:00',5.69),('6449','2013-04-26','08:30:00',4.97),('6449','2013-04-26','08:35:00',5.32),('6449','2013-04-26','08:40:00',5.67),('6449','2013-04-26','08:45:00',4.07),('6449','2013-04-26','08:50:00',3.42),('6449','2013-04-26','08:55:00',3.5),('6449','2013-04-26','09:00:00',4.69),('6449','2013-04-26','09:05:00',6.8),('6449','2013-04-26','09:10:00',7.89),('6449','2013-04-26','09:15:00',9.15),('6449','2013-04-26','09:20:00',9.54),('6449','2013-04-26','09:25:00',9.77),('6449','2013-04-26','09:30:00',10.2),('6449','2013-04-26','09:35:00',10.71),('6449','2013-04-26','09:40:00',11.35),('6449','2013-04-26','09:45:00',12.44),('6449','2013-04-26','09:50:00',12.5),('6449','2013-04-26','09:55:00',9.6),('6449','2013-04-26','10:00:00',8.16),('6449','2013-04-26','10:05:00',8.06),('6449','2013-04-26','10:10:00',9.53),('6449','2013-04-26','10:15:00',10.07),('6449','2013-04-26','10:20:00',9.24),('6449','2013-04-26','10:25:00',10.76),('6449','2013-04-26','10:30:00',9.76),('6449','2013-04-26','10:35:00',8.58),('6449','2013-04-26','10:40:00',8.71),('6449','2013-04-26','10:45:00',10.14),('6449','2013-04-26','10:50:00',9.97),('6449','2013-04-26','10:55:00',10.48),('6449','2013-04-26','11:00:00',9.19),('6449','2013-04-26','11:05:00',9.2),('6449','2013-04-26','11:10:00',8.8),('6449','2013-04-26','11:15:00',8.16),('6449','2013-04-26','11:20:00',7.53),('6449','2013-04-26','11:25:00',7.08),('6449','2013-04-26','11:30:00',7.27),('6449','2013-04-26','11:35:00',8.3),('6449','2013-04-26','11:40:00',10.38),('6449','2013-04-26','11:45:00',11.28),('6449','2013-04-26','11:50:00',6.76),('6449','2013-04-26','11:55:00',5.66),('6449','2013-04-26','12:00:00',7.39),('6449','2013-04-26','12:05:00',13.54),('6449','2013-04-26','12:10:00',11.07),('6449','2013-04-26','12:15:00',14.4),('6449','2013-04-26','12:20:00',15.43),('6449','2013-04-26','12:25:00',13.52),('6449','2013-04-26','12:30:00',15.79),('6449','2013-04-26','12:35:00',13.47),('6449','2013-04-26','12:40:00',9.46),('6449','2013-04-26','12:45:00',8.39),('6449','2013-04-26','12:50:00',7.34),('6449','2013-04-26','12:55:00',8.08),('6449','2013-04-26','13:00:00',7.56),('6449','2013-04-26','13:05:00',8.8),('6449','2013-04-26','13:10:00',6.52),('6449','2013-04-26','13:15:00',7.04),('6449','2013-04-26','13:20:00',8.29),('6449','2013-04-26','13:25:00',7.89),('6449','2013-04-26','13:30:00',10.27),('6449','2013-04-26','13:35:00',16.61),('6449','2013-04-26','13:40:00',8.93),('6449','2013-04-26','13:45:00',13.13),('6449','2013-04-26','13:50:00',11.75),('6449','2013-04-26','13:55:00',10.21),('6449','2013-04-26','14:00:00',9.54),('6449','2013-04-26','14:05:00',11.36),('6449','2013-04-26','14:10:00',14.76),('6449','2013-04-26','14:15:00',8.08),('6449','2013-04-26','14:20:00',6.33),('6449','2013-04-26','14:25:00',6.33),('6449','2013-04-26','14:30:00',4.67),('6449','2013-04-26','14:35:00',5.09),('6449','2013-04-26','14:40:00',5.97),('6449','2013-04-26','14:45:00',6.62),('6449','2013-04-26','14:50:00',8.89),('6449','2013-04-26','14:55:00',5.09),('6449','2013-04-26','15:00:00',3.84),('6449','2013-04-26','15:05:00',4.1),('6449','2013-04-26','15:10:00',2.59),('6449','2013-04-26','15:15:00',1.55),('6449','2013-04-26','15:20:00',1.45),('6449','2013-04-26','15:25:00',1.59),('6449','2013-04-26','15:30:00',1.69),('6449','2013-04-26','15:35:00',1.55),('6449','2013-04-26','15:40:00',1.22),('6449','2013-04-26','15:45:00',1.48),('6449','2013-04-26','15:50:00',1.73),('6449','2013-04-26','15:55:00',1.5),('6449','2013-04-26','16:00:00',1.08),('6449','2013-04-25','07:15:00',1.12),('6449','2013-04-25','07:20:00',1.29),('6449','2013-04-25','07:25:00',1.48),('6449','2013-04-25','07:30:00',1.75),('6449','2013-04-25','07:35:00',1.96),('6449','2013-04-25','07:40:00',2.41),('6449','2013-04-25','07:45:00',2.84),('6449','2013-04-25','07:50:00',2.66),('6449','2013-04-25','07:55:00',2.98),('6449','2013-04-25','08:00:00',2.99),('6449','2013-04-25','08:05:00',2.87),('6449','2013-04-25','08:10:00',3.14),('6449','2013-04-25','08:15:00',3.11),('6449','2013-04-25','08:20:00',3.9),('6449','2013-04-25','08:25:00',5.16),('6449','2013-04-25','08:30:00',3.71),('6449','2013-04-25','08:35:00',3.64),('6449','2013-04-25','08:40:00',4.09),('6449','2013-04-25','08:45:00',5.9),('6449','2013-04-25','08:50:00',8.57),('6449','2013-04-25','08:55:00',5.72),('6449','2013-04-25','09:00:00',6.12),('6449','2013-04-25','09:05:00',5.32),('6449','2013-04-25','09:10:00',4.78),('6449','2013-04-25','09:15:00',6.91),('6449','2013-04-25','09:20:00',9.42),('6449','2013-04-25','09:25:00',9.46),('6449','2013-04-25','09:30:00',9.76),('6449','2013-04-25','09:35:00',10.71),('6449','2013-04-25','09:40:00',11.1),('6449','2013-04-25','09:45:00',11.71),('6449','2013-04-25','09:50:00',9.49),('6449','2013-04-25','09:55:00',10.03),('6449','2013-04-25','10:00:00',13.3),('6449','2013-04-25','10:05:00',10.89),('6449','2013-04-25','10:10:00',9.7),('6449','2013-04-25','10:15:00',8.99),('6449','2013-04-25','10:20:00',11.88),('6449','2013-04-25','10:25:00',12.48),('6449','2013-04-25','10:30:00',12.97),('6449','2013-04-25','10:35:00',13.7),('6449','2013-04-25','10:40:00',13.92),('6449','2013-04-25','10:45:00',14.04),('6449','2013-04-25','10:50:00',14.86),('6449','2013-04-25','10:55:00',11.48),('6449','2013-04-25','11:00:00',10.07),('6449','2013-04-25','11:05:00',14.05),('6449','2013-04-25','11:10:00',12.29),('6449','2013-04-25','11:15:00',14.2),('6449','2013-04-25','11:20:00',12.43),('6449','2013-04-25','11:25:00',11.62),('6449','2013-04-25','11:30:00',13.05),('6449','2013-04-25','11:35:00',13.57),('6449','2013-04-25','11:40:00',13.4),('6449','2013-04-25','11:45:00',16.21),('6449','2013-04-25','11:50:00',16.64),('6449','2013-04-25','11:55:00',16.65),('6449','2013-04-25','12:00:00',16.45),('6449','2013-04-25','12:05:00',16.58),('6449','2013-04-25','12:10:00',17.11),('6449','2013-04-25','12:15:00',17.07),('6449','2013-04-25','12:20:00',16.93),('6449','2013-04-25','12:25:00',16.55),('6449','2013-04-25','12:30:00',13.95),('6449','2013-04-25','12:35:00',11.5),('6449','2013-04-25','12:40:00',11.75),('6449','2013-04-25','12:45:00',11.95),('6449','2013-04-25','12:50:00',11.13),('6449','2013-04-25','12:55:00',11.06),('6449','2013-04-25','13:00:00',13.01),('6449','2013-04-25','13:05:00',11.02),('6449','2013-04-25','13:10:00',11.34),('6449','2013-04-25','13:15:00',11.83),('6449','2013-04-25','13:20:00',7.54),('6449','2013-04-25','13:25:00',6.42),('6449','2013-04-25','13:30:00',6.14),('6449','2013-04-25','13:35:00',5.93),('6449','2013-04-25','13:40:00',5.97),('6449','2013-04-25','13:45:00',6.06),('6449','2013-04-25','13:50:00',6.69),('6449','2013-04-25','13:55:00',6.94),('6449','2013-04-25','14:00:00',7.23),('6449','2013-04-25','14:05:00',9.75),('6449','2013-04-25','14:10:00',14.26),('6449','2013-04-25','14:15:00',14.54),('6449','2013-04-25','14:20:00',11.29),('6449','2013-04-25','14:25:00',14.14),('6449','2013-04-25','14:30:00',14.69),('6449','2013-04-25','14:35:00',14.91),('6449','2013-04-25','14:40:00',11.32),('6449','2013-04-25','14:45:00',12.42),('6449','2013-04-25','14:50:00',10.72),('6449','2013-04-25','14:55:00',11.25),('6449','2013-04-25','15:00:00',14.71),('6449','2013-04-25','15:05:00',13.35),('6449','2013-04-25','15:10:00',11.89),('6449','2013-04-25','15:15:00',11.03),('6449','2013-04-25','15:20:00',11.66),('6449','2013-04-25','15:25:00',10.04),('6449','2013-04-25','15:30:00',11.55),('6449','2013-04-25','15:35:00',10.29),('6449','2013-04-25','15:40:00',8.74),('6449','2013-04-25','15:45:00',8.34),('6449','2013-04-25','15:50:00',9.1),('6449','2013-04-25','15:55:00',9.51),('6449','2013-04-25','16:00:00',7.51),('6449','2013-04-25','16:05:00',7.22),('6449','2013-04-25','16:10:00',7.37),('6449','2013-04-25','16:15:00',7.87),('6449','2013-04-25','16:20:00',7.19),('6449','2013-04-25','16:25:00',6.45),('6449','2013-04-25','16:30:00',5.91),('6449','2013-04-25','16:35:00',6.37),('6449','2013-04-25','16:40:00',5.01),('6449','2013-04-25','16:45:00',4.63),('6449','2013-04-25','16:50:00',4.56),('6449','2013-04-25','16:55:00',4.35),('6449','2013-04-25','17:00:00',4.11),('6449','2013-04-25','17:05:00',3.86),('6449','2013-04-25','17:10:00',3.63),('6449','2013-04-25','17:15:00',3.57),('6449','2013-04-25','17:20:00',3.47),('6449','2013-04-25','17:25:00',3.6),('6449','2013-04-25','17:30:00',3.58),('6449','2013-04-25','17:35:00',3.56),('6449','2013-04-25','17:40:00',3.66),('6449','2013-04-25','17:45:00',3.72),('6449','2013-04-25','17:50:00',3.22),('6449','2013-04-25','17:55:00',2.81),('6449','2013-04-25','18:00:00',2.45),('6449','2013-04-25','18:05:00',2.21),('6449','2013-04-25','18:10:00',1.97),('6449','2013-04-25','18:15:00',1.81),('6449','2013-04-25','18:20:00',1.72),('6449','2013-04-25','18:25:00',1.69),('6449','2013-04-25','18:30:00',1.56),('6449','2013-04-25','18:35:00',1.44),('6449','2013-04-25','18:40:00',1.38),('6449','2013-04-25','18:45:00',1.29),('6449','2013-04-25','18:50:00',1.17),('6449','2013-04-25','18:55:00',1.05),('6449','2013-04-24','07:15:00',1.22),('6449','2013-04-24','07:20:00',1.36),('6449','2013-04-24','07:25:00',1.43),('6449','2013-04-24','07:30:00',1.64),('6449','2013-04-24','07:35:00',1.87),('6449','2013-04-24','07:40:00',2.18),('6449','2013-04-24','07:45:00',2.27),('6449','2013-04-24','07:50:00',2.96),('6449','2013-04-24','07:55:00',2.9),('6449','2013-04-24','08:00:00',3.36),('6449','2013-04-24','08:05:00',4.26),('6449','2013-04-24','08:10:00',5.19),('6449','2013-04-24','08:15:00',5.54),('6449','2013-04-24','08:20:00',5.66),('6449','2013-04-24','08:25:00',5.91),('6449','2013-04-24','08:30:00',6.35),('6449','2013-04-24','08:35:00',6.99),('6449','2013-04-24','08:40:00',7.37),('6449','2013-04-24','08:45:00',8.05),('6449','2013-04-24','08:50:00',8.56),('6449','2013-04-24','08:55:00',8.86),('6449','2013-04-24','09:00:00',5.91),('6449','2013-04-24','09:05:00',6.16),('6449','2013-04-24','09:10:00',7.5),('6449','2013-04-24','09:15:00',6.74),('6449','2013-04-24','09:20:00',7.52),('6449','2013-04-24','09:25:00',7.81),('6449','2013-04-24','09:30:00',6.78),('6449','2013-04-24','09:35:00',7.68),('6449','2013-04-24','09:40:00',7.69),('6449','2013-04-24','09:45:00',7.74),('6449','2013-04-24','09:50:00',9.88),('6449','2013-04-24','09:55:00',10.65),('6449','2013-04-24','10:00:00',10.67),('6449','2013-04-24','10:05:00',11.76),('6449','2013-04-24','10:10:00',13.98),('6449','2013-04-24','10:15:00',13.27),('6449','2013-04-24','10:20:00',12.82),('6449','2013-04-24','10:25:00',13.76),('6449','2013-04-24','10:30:00',12.71),('6449','2013-04-24','10:35:00',13.27),('6449','2013-04-24','10:40:00',13.93),('6449','2013-04-24','10:45:00',14.25),('6449','2013-04-24','10:50:00',13.9),('6449','2013-04-24','10:55:00',14.01),('6449','2013-04-24','11:00:00',14.87),('6449','2013-04-24','11:05:00',11.44),('6449','2013-04-24','11:10:00',10.35),('6449','2013-04-24','11:15:00',15.27),('6449','2013-04-24','11:20:00',16.07),('6449','2013-04-24','11:25:00',17.34),('6449','2013-04-24','11:30:00',17.97),('6449','2013-04-24','11:35:00',17.69),('6449','2013-04-24','11:40:00',13.31),('6449','2013-04-24','11:45:00',11.06),('6449','2013-04-24','11:50:00',11.45),('6449','2013-04-24','11:55:00',14.48),('6449','2013-04-24','12:00:00',14.02),('6449','2013-04-24','12:05:00',14.77),('6449','2013-04-24','12:10:00',17.51),('6449','2013-04-24','12:15:00',14.2),('6449','2013-04-24','12:20:00',14.55),('6449','2013-04-24','12:25:00',15.76),('6449','2013-04-24','12:30:00',15.85),('6449','2013-04-24','12:35:00',14.6),('6449','2013-04-24','12:40:00',15.07),('6449','2013-04-24','12:45:00',16.99),('6449','2013-04-24','12:50:00',17.01),('6449','2013-04-24','12:55:00',16.98),('6449','2013-04-24','13:00:00',14.62),('6449','2013-04-24','13:05:00',17.36),('6449','2013-04-24','13:10:00',15.86),('6449','2013-04-24','13:15:00',17.56),('6449','2013-04-24','13:20:00',16.84),('6449','2013-04-24','13:25:00',18.18),('6449','2013-04-24','13:30:00',17.74),('6449','2013-04-24','13:35:00',15.88),('6449','2013-04-24','13:40:00',13.2),('6449','2013-04-24','13:45:00',10.27),('6449','2013-04-24','13:50:00',8.97),('6449','2013-04-24','13:55:00',11.74),('6449','2013-04-24','14:00:00',12.46),('6449','2013-04-24','14:05:00',12.86),('6449','2013-04-24','14:10:00',14.91),('6449','2013-04-24','14:15:00',15.94),('6449','2013-04-24','14:20:00',15.52),('6449','2013-04-24','14:25:00',15.01),('6449','2013-04-24','14:30:00',14.42),('6449','2013-04-24','14:35:00',14.56),('6449','2013-04-24','14:40:00',13.62),('6449','2013-04-24','14:45:00',12.3),('6449','2013-04-24','14:50:00',10.68),('6449','2013-04-24','14:55:00',10.74),('6449','2013-04-24','15:00:00',8.34),('6449','2013-04-24','15:05:00',8.67),('6449','2013-04-24','15:10:00',8.52),('6449','2013-04-24','15:15:00',9.1),('6449','2013-04-24','15:20:00',10.33),('6449','2013-04-24','15:25:00',9.86),('6449','2013-04-24','15:30:00',9.96),('6449','2013-04-24','15:35:00',10.68),('6449','2013-04-24','15:40:00',9.51),('6449','2013-04-24','15:45:00',5.47),('6449','2013-04-24','15:50:00',7.18),('6449','2013-04-24','15:55:00',8.56),('6449','2013-04-24','16:00:00',9.55),('6449','2013-04-24','16:05:00',8.44),('6449','2013-04-24','16:10:00',8.48),('6449','2013-04-24','16:15:00',8.07),('6449','2013-04-24','16:20:00',7.2),('6449','2013-04-24','16:25:00',7.37),('6449','2013-04-24','16:30:00',8.07),('6449','2013-04-24','16:35:00',8.65),('6449','2013-04-24','16:40:00',7.65),('6449','2013-04-24','16:45:00',8.88),('6449','2013-04-24','16:50:00',8.01),('6449','2013-04-24','16:55:00',8.61),('6449','2013-04-24','17:00:00',8.29),('6449','2013-04-24','17:05:00',8.04),('6449','2013-04-24','17:10:00',7.05),('6449','2013-04-24','17:15:00',5.47),('6449','2013-04-24','17:20:00',6.23),('6449','2013-04-24','17:25:00',6.09),('6449','2013-04-24','17:30:00',6.08),('6449','2013-04-24','17:35:00',5.81),('6449','2013-04-24','17:40:00',5.59),('6449','2013-04-24','17:45:00',4.4),('6449','2013-04-24','17:50:00',3.13),('6449','2013-04-24','17:55:00',3.64),('6449','2013-04-24','18:00:00',3.21),('6449','2013-04-24','18:05:00',3.51),('6449','2013-04-24','18:10:00',3.57),('6449','2013-04-24','18:15:00',3.56),('6449','2013-04-24','18:20:00',3.11),('6449','2013-04-24','18:25:00',2.81),('6449','2013-04-24','18:30:00',2.4),('6449','2013-04-24','18:35:00',2.07),('6449','2013-04-24','18:40:00',1.88),('6449','2013-04-24','18:45:00',1.59),('6449','2013-04-24','18:50:00',1.33),('6449','2013-04-24','18:55:00',1.02),('6449','2013-04-23','07:05:00',1.07),('6449','2013-04-23','07:10:00',1.3),('6449','2013-04-23','07:15:00',1.56),('6449','2013-04-23','07:20:00',1.87),('6449','2013-04-23','07:25:00',2.22),('6449','2013-04-23','07:30:00',2.58),('6449','2013-04-23','07:35:00',2.94),('6449','2013-04-23','07:40:00',3.33),('6449','2013-04-23','07:45:00',3.71),('6449','2013-04-23','07:50:00',4.13),('6449','2013-04-23','07:55:00',4.57),('6449','2013-04-23','08:00:00',4.95),('6449','2013-04-23','08:05:00',5.34),('6449','2013-04-23','08:10:00',5.78),('6449','2013-04-23','08:15:00',6.16),('6449','2013-04-23','08:20:00',6.58),('6449','2013-04-23','08:25:00',6.99),('6449','2013-04-23','08:30:00',7.33),('6449','2013-04-23','08:35:00',7.78),('6449','2013-04-23','08:40:00',8.18),('6449','2013-04-23','08:45:00',8.46),('6449','2013-04-23','08:50:00',8.93),('6449','2013-04-23','08:55:00',9.28),('6449','2013-04-23','09:00:00',9.58),('6449','2013-04-23','09:05:00',10.01),('6449','2013-04-23','09:10:00',10.36),('6449','2013-04-23','09:15:00',10.69),('6449','2013-04-23','09:20:00',10.94),('6449','2013-04-23','09:25:00',11.28),('6449','2013-04-23','09:30:00',11.67),('6449','2013-04-23','09:35:00',11.94),('6449','2013-04-23','09:40:00',12.19),('6449','2013-04-23','09:45:00',12.51),('6449','2013-04-23','09:50:00',12.79),('6449','2013-04-23','09:55:00',13.1),('6449','2013-04-23','10:00:00',13.37),('6449','2013-04-23','10:05:00',13.56),('6449','2013-04-23','10:10:00',13.79),('6449','2013-04-23','10:15:00',13.88),('6449','2013-04-23','10:20:00',14.19),('6449','2013-04-23','10:25:00',14.41),('6449','2013-04-23','10:30:00',14.52),('6449','2013-04-23','10:35:00',14.97),('6449','2013-04-23','10:40:00',14.9),('6449','2013-04-23','10:45:00',15.35),('6449','2013-04-23','10:50:00',15.03),('6449','2013-04-23','10:55:00',15.52),('6449','2013-04-23','11:00:00',15.45),('6449','2013-04-23','11:05:00',15.78),('6449','2013-04-23','11:10:00',15.96),('6449','2013-04-23','11:15:00',15.27),('6449','2013-04-23','11:20:00',14.84),('6449','2013-04-23','11:25:00',15.37),('6449','2013-04-23','11:30:00',16.27),('6449','2013-04-23','11:35:00',16.38),('6449','2013-04-23','11:40:00',16.47),('6449','2013-04-23','11:45:00',16.58),('6449','2013-04-23','11:50:00',16.63),('6449','2013-04-23','11:55:00',16.57),('6449','2013-04-23','12:00:00',16.53),('6449','2013-04-23','12:05:00',16.53),('6449','2013-04-23','12:10:00',16.61),('6449','2013-04-23','12:15:00',16.42),('6449','2013-04-23','12:20:00',16.42),('6449','2013-04-23','12:25:00',16.43),('6449','2013-04-23','12:30:00',16.5),('6449','2013-04-23','12:35:00',16.43),('6449','2013-04-23','12:40:00',16.75),('6449','2013-04-23','12:45:00',16.75),('6449','2013-04-23','12:50:00',16.7),('6449','2013-04-23','12:55:00',16.44),('6449','2013-04-23','13:00:00',16.1),('6449','2013-04-23','13:05:00',16.32),('6449','2013-04-23','13:10:00',16.23),('6449','2013-04-23','13:15:00',15.15),('6449','2013-04-23','13:20:00',15.44),('6449','2013-04-23','13:25:00',14.83),('6449','2013-04-23','13:30:00',15.4),('6449','2013-04-23','13:35:00',14.16),('6449','2013-04-23','13:40:00',16.88),('6449','2013-04-23','13:45:00',16.09),('6449','2013-04-23','13:50:00',15.51),('6449','2013-04-23','13:55:00',14.93),('6449','2013-04-23','14:00:00',14.92),('6449','2013-04-23','14:05:00',15.6),('6449','2013-04-23','14:10:00',14.13),('6449','2013-04-23','14:15:00',15.6),('6449','2013-04-23','14:20:00',15.14),('6449','2013-04-23','14:25:00',16.47),('6449','2013-04-23','14:30:00',13.83),('6449','2013-04-23','14:35:00',13.62),('6449','2013-04-23','14:40:00',13.34),('6449','2013-04-23','14:45:00',14.3),('6449','2013-04-23','14:50:00',14.69),('6449','2013-04-23','14:55:00',15.7),('6449','2013-04-23','15:00:00',15.92),('6449','2013-04-23','15:05:00',12.27),('6449','2013-04-23','15:10:00',7.37),('6449','2013-04-23','15:15:00',8.7),('6449','2013-04-23','15:20:00',10.67),('6449','2013-04-23','15:25:00',9.85),('6449','2013-04-23','15:30:00',10.56),('6449','2013-04-23','15:35:00',10.88),('6449','2013-04-23','15:40:00',11.56),('6449','2013-04-23','15:45:00',12.22),('6449','2013-04-23','15:50:00',11),('6449','2013-04-23','15:55:00',10.32),('6449','2013-04-23','16:00:00',9.52),('6449','2013-04-23','16:05:00',10.04),('6449','2013-04-23','16:10:00',9.08),('6449','2013-04-23','16:15:00',8.54),('6449','2013-04-23','16:20:00',8.23),('6449','2013-04-23','16:25:00',8.26),('6449','2013-04-23','16:30:00',8.42),('6449','2013-04-23','16:35:00',8.96),('6449','2013-04-23','16:40:00',8.77),('6449','2013-04-23','16:45:00',8.05),('6449','2013-04-23','16:50:00',8.68),('6449','2013-04-23','16:55:00',7.64),('6449','2013-04-23','17:00:00',6.99),('6449','2013-04-23','17:05:00',8.12),('6449','2013-04-23','17:10:00',7.9),('6449','2013-04-23','17:15:00',7),('6449','2013-04-23','17:20:00',7),('6449','2013-04-23','17:25:00',6.82),('6449','2013-04-23','17:30:00',6.72),('6449','2013-04-23','17:35:00',6.7),('6449','2013-04-23','17:40:00',5.14),('6449','2013-04-23','17:45:00',4.08),('6449','2013-04-23','17:50:00',3.07),('6449','2013-04-23','17:55:00',3.01),('6449','2013-04-23','18:00:00',3.25),('6449','2013-04-23','18:05:00',3.16),('6449','2013-04-23','18:10:00',2.3),('6449','2013-04-23','18:15:00',2.42),('6449','2013-04-23','18:20:00',1.48),('6449','2013-04-23','18:25:00',1.5),('6449','2013-04-23','18:30:00',1.99),('6449','2013-04-23','18:35:00',2.04),('6449','2013-04-23','18:40:00',1.41),('6449','2013-04-23','18:45:00',1.09),('6449','2013-04-22','07:35:00',1.1),('6449','2013-04-22','07:40:00',1.44),('6449','2013-04-22','07:45:00',1.86),('6449','2013-04-22','07:50:00',1.55),('6449','2013-04-22','07:55:00',1.5),('6449','2013-04-22','08:00:00',1.23),('6449','2013-04-22','08:10:00',1.15),('6449','2013-04-22','08:15:00',1.38),('6449','2013-04-22','08:20:00',1.49),('6449','2013-04-22','08:25:00',1.68),('6449','2013-04-22','08:30:00',1.84),('6449','2013-04-22','08:35:00',1.74),('6449','2013-04-22','08:40:00',1.12),('6449','2013-04-22','09:20:00',1.03),('6449','2013-04-22','09:25:00',1.62),('6449','2013-04-22','09:30:00',1.71),('6449','2013-04-22','09:35:00',2.03),('6449','2013-04-22','09:40:00',1.59),('6449','2013-04-22','09:45:00',1.22),('6449','2013-04-22','09:50:00',1.22),('6449','2013-04-22','09:55:00',1.56),('6449','2013-04-22','10:00:00',1.7),('6449','2013-04-22','10:05:00',1.26),('6449','2013-04-22','10:10:00',1.05),('6449','2013-04-22','10:20:00',1.35),('6449','2013-04-22','10:25:00',1.48),('6449','2013-04-22','10:30:00',2.83),('6449','2013-04-22','10:35:00',4.01),('6449','2013-04-22','10:40:00',3.85),('6449','2013-04-22','10:45:00',4.37),('6449','2013-04-22','10:50:00',6.43),('6449','2013-04-22','10:55:00',6.4),('6449','2013-04-22','11:00:00',6.56),('6449','2013-04-22','11:05:00',18.54),('6449','2013-04-22','11:10:00',15.84),('6449','2013-04-22','11:15:00',17.07),('6449','2013-04-22','11:20:00',18.09),('6449','2013-04-22','11:25:00',17.55),('6449','2013-04-22','11:30:00',13.01),('6449','2013-04-22','11:35:00',14.04),('6449','2013-04-22','11:40:00',18.2),('6449','2013-04-22','11:45:00',13.01),('6449','2013-04-22','11:50:00',14.35),('6449','2013-04-22','11:55:00',15.36),('6449','2013-04-22','12:00:00',16.99),('6449','2013-04-22','12:05:00',16.21),('6449','2013-04-22','12:10:00',17.35),('6449','2013-04-22','12:15:00',14.77),('6449','2013-04-22','12:20:00',17.82),('6449','2013-04-22','12:25:00',17.76),('6449','2013-04-22','12:30:00',17.87),('6449','2013-04-22','12:35:00',17.09),('6449','2013-04-22','12:40:00',16.89),('6449','2013-04-22','12:45:00',17.72),('6449','2013-04-22','12:50:00',19.22),('6449','2013-04-22','12:55:00',19.66),('6449','2013-04-22','13:00:00',18.09),('6449','2013-04-22','13:05:00',13.63),('6449','2013-04-22','13:10:00',14.64),('6449','2013-04-22','13:15:00',10.82),('6449','2013-04-22','13:20:00',16.26),('6449','2013-04-22','13:25:00',6.31),('6449','2013-04-22','13:30:00',3.74),('6449','2013-04-22','13:35:00',4.01),('6449','2013-04-22','13:40:00',15.04),('6449','2013-04-22','13:45:00',10.05),('6449','2013-04-22','13:50:00',9.16),('6449','2013-04-22','13:55:00',12.69),('6449','2013-04-22','14:00:00',14.94),('6449','2013-04-22','14:05:00',3.2),('6449','2013-04-22','14:10:00',1.8),('6449','2013-04-22','14:15:00',2),('6449','2013-04-22','14:20:00',2.13),('6449','2013-04-22','14:25:00',1.52),('6449','2013-04-22','14:40:00',1.33),('6449','2013-04-22','14:45:00',1.5),('6449','2013-04-22','14:50:00',1.2),('6449','2013-04-22','14:55:00',1.51),('6449','2013-04-22','15:00:00',10.01),('6449','2013-04-22','15:05:00',9.71),('6449','2013-04-22','15:10:00',14.75),('6449','2013-04-22','15:15:00',18.34),('6449','2013-04-22','15:20:00',14.13),('6449','2013-04-22','15:25:00',15.87),('6449','2013-04-22','15:30:00',15.5),('6449','2013-04-22','15:35:00',14.93),('6449','2013-04-22','15:40:00',14.56),('6449','2013-04-22','15:45:00',14.15),('6449','2013-04-22','15:50:00',13.74),('6449','2013-04-22','15:55:00',12.97),('6449','2013-04-22','16:00:00',10.01),('6449','2013-04-22','16:05:00',4.74),('6449','2013-04-22','16:10:00',6.03),('6449','2013-04-22','16:15:00',11.94),('6449','2013-04-22','16:20:00',11.21),('6449','2013-04-22','16:25:00',11.3),('6449','2013-04-22','16:30:00',11.63),('6449','2013-04-22','16:35:00',9.5),('6449','2013-04-22','16:40:00',8.92),('6449','2013-04-22','16:45:00',10.72),('6449','2013-04-22','16:50:00',4.95),('6449','2013-04-22','16:55:00',7.22),('6449','2013-04-22','17:00:00',8.31),('6449','2013-04-22','17:05:00',7.98),('6449','2013-04-22','17:10:00',10.8),('6449','2013-04-22','17:15:00',6.15),('6449','2013-04-22','17:20:00',4.34),('6449','2013-04-22','17:25:00',3.18),('6449','2013-04-22','17:30:00',2.73),('6449','2013-04-22','17:35:00',2.71),('6449','2013-04-22','17:40:00',2.46),('6449','2013-04-22','17:45:00',2.35),('6449','2013-04-22','17:50:00',2.37),('6449','2013-04-22','17:55:00',2.44),('6449','2013-04-22','18:00:00',2.3),('6449','2013-04-22','18:05:00',2.41),('6449','2013-04-22','18:10:00',3.63),('6449','2013-04-22','18:15:00',3.6),('6449','2013-04-22','18:20:00',1.09),('6449','2013-04-21','07:15:00',1.06),('6449','2013-04-21','07:20:00',1.4),('6449','2013-04-21','07:25:00',1.21),('6449','2013-04-21','07:30:00',1.43),('6449','2013-04-21','07:35:00',1.38),('6449','2013-04-21','07:40:00',1.39),('6449','2013-04-21','07:45:00',2.15),('6449','2013-04-21','07:50:00',2.56),('6449','2013-04-21','07:55:00',2.44),('6449','2013-04-21','08:00:00',2.65),('6449','2013-04-21','08:05:00',2.9),('6449','2013-04-21','08:10:00',3.49),('6449','2013-04-21','08:15:00',4.98),('6449','2013-04-21','08:20:00',7.19),('6449','2013-04-21','08:25:00',8.54),('6449','2013-04-21','08:30:00',7.64),('6449','2013-04-21','08:35:00',5.58),('6449','2013-04-21','08:40:00',7.92),('6449','2013-04-21','08:45:00',9.14),('6449','2013-04-21','08:50:00',8.77),('6449','2013-04-21','08:55:00',4.95),('6449','2013-04-21','09:00:00',3.75),('6449','2013-04-21','09:05:00',3.42),('6449','2013-04-21','09:10:00',3.41),('6449','2013-04-21','09:15:00',3.61),('6449','2013-04-21','09:20:00',4.77),('6449','2013-04-21','09:25:00',5.15),('6449','2013-04-21','09:30:00',5.21),('6449','2013-04-21','09:35:00',10.78),('6449','2013-04-21','09:40:00',12.13),('6449','2013-04-21','09:45:00',12.46),('6449','2013-04-21','09:50:00',12.58),('6449','2013-04-21','09:55:00',12.8),('6449','2013-04-21','10:00:00',12.96),('6449','2013-04-21','10:05:00',13.2),('6449','2013-04-21','10:10:00',13.28),('6449','2013-04-21','10:15:00',13.69),('6449','2013-04-21','10:20:00',13.9),('6449','2013-04-21','10:25:00',14.09),('6449','2013-04-21','10:30:00',14.21),('6449','2013-04-21','10:35:00',14.42),('6449','2013-04-21','10:40:00',14.59),('6449','2013-04-21','10:45:00',14.82),('6449','2013-04-21','10:50:00',15.05),('6449','2013-04-21','10:55:00',15.23),('6449','2013-04-21','11:00:00',15.45),('6449','2013-04-21','11:05:00',15.59),('6449','2013-04-21','11:10:00',15.71),('6449','2013-04-21','11:15:00',15.89),('6449','2013-04-21','11:20:00',16),('6449','2013-04-21','11:25:00',16.43),('6449','2013-04-21','11:30:00',16.98),('6449','2013-04-21','11:35:00',17.5),('6449','2013-04-21','11:40:00',13.33),('6449','2013-04-21','11:45:00',11.35),('6449','2013-04-21','11:50:00',11.35),('6449','2013-04-21','11:55:00',13.79),('6449','2013-04-21','12:00:00',18.66),('6449','2013-04-21','12:05:00',19.34),('6449','2013-04-21','12:10:00',8.01),('6449','2013-04-21','12:15:00',9.23),('6449','2013-04-21','12:20:00',12.58),('6449','2013-04-21','12:25:00',16.08),('6449','2013-04-21','12:30:00',16.46),('6449','2013-04-21','12:35:00',15.64),('6449','2013-04-21','12:40:00',18.63),('6449','2013-04-21','12:45:00',18.04),('6449','2013-04-21','12:50:00',17.77),('6449','2013-04-21','12:55:00',17.51),('6449','2013-04-21','13:00:00',17.34),('6449','2013-04-21','13:05:00',17),('6449','2013-04-21','13:10:00',17.06),('6449','2013-04-21','13:15:00',17.01),('6449','2013-04-21','13:20:00',17.12),('6449','2013-04-21','13:25:00',17.31),('6449','2013-04-21','13:30:00',16.87),('6449','2013-04-21','13:35:00',16.74),('6449','2013-04-21','13:40:00',16.62),('6449','2013-04-21','13:45:00',16.65),('6449','2013-04-21','13:50:00',16.55),('6449','2013-04-21','13:55:00',16.56),('6449','2013-04-21','14:00:00',16.55),('6449','2013-04-21','14:05:00',16.16),('6449','2013-04-21','14:10:00',16.2),('6449','2013-04-21','14:15:00',15.99),('6449','2013-04-21','14:20:00',15.78),('6449','2013-04-21','14:25:00',15.4),('6449','2013-04-21','14:30:00',15.94),('6449','2013-04-21','14:35:00',13.7),('6449','2013-04-21','14:40:00',13.74),('6449','2013-04-21','14:45:00',16.67),('6449','2013-04-21','14:50:00',17.08),('6449','2013-04-21','14:55:00',16.15),('6449','2013-04-21','15:00:00',14.94),('6449','2013-04-21','15:05:00',14.7),('6449','2013-04-21','15:10:00',14.6),('6449','2013-04-21','15:15:00',14.55),('6449','2013-04-21','15:20:00',14.42),('6449','2013-04-21','15:25:00',14.16),('6449','2013-04-21','15:30:00',14.1),('6449','2013-04-21','15:35:00',9.6),('6449','2013-04-21','15:40:00',11.78),('6449','2013-04-21','15:45:00',12.1),('6449','2013-04-21','15:50:00',8.84),('6449','2013-04-21','15:55:00',8.34),('6449','2013-04-21','16:00:00',9.39),('6449','2013-04-21','16:05:00',8.91),('6449','2013-04-21','16:10:00',6.59),('6449','2013-04-21','16:15:00',10),('6449','2013-04-21','16:20:00',8.09),('6449','2013-04-21','16:25:00',6.08),('6449','2013-04-21','16:30:00',4.83),('6449','2013-04-21','16:35:00',4.19),('6449','2013-04-21','16:40:00',4.33),('6449','2013-04-21','16:45:00',3.89),('6449','2013-04-21','16:50:00',3.62),('6449','2013-04-21','16:55:00',3.29),('6449','2013-04-21','17:00:00',2.7),('6449','2013-04-21','17:05:00',2.26),('6449','2013-04-21','17:10:00',2.06),('6449','2013-04-21','17:15:00',1.9),('6449','2013-04-21','17:20:00',1.71),('6449','2013-04-21','17:25:00',1.61),('6449','2013-04-21','17:30:00',1.57),('6449','2013-04-21','17:35:00',1.45),('6449','2013-04-21','17:40:00',1.54),('6449','2013-04-21','17:45:00',1.63),('6449','2013-04-21','17:50:00',1.51),('6449','2013-04-21','17:55:00',1.43),('6449','2013-04-21','18:00:00',1.57),('6449','2013-04-21','18:05:00',1.16),('6449','2013-04-21','18:15:00',1.03),('6449','2013-04-21','18:20:00',1.2),('6449','2013-04-21','18:25:00',1.42),('6449','2013-04-21','18:30:00',1.49),('6449','2013-04-21','18:35:00',1.11),('6449','2013-04-21','18:40:00',1.04),('6449','2013-04-20','07:35:00',1.02),('6449','2013-04-20','07:55:00',1.4),('6449','2013-04-20','08:00:00',1.63),('6449','2013-04-20','08:05:00',1.62),('6449','2013-04-20','08:10:00',1.97),('6449','2013-04-20','08:15:00',2.37),('6449','2013-04-20','08:20:00',2.52),('6449','2013-04-20','08:25:00',2.82),('6449','2013-04-20','08:30:00',2.76),('6449','2013-04-20','08:35:00',2.84),('6449','2013-04-20','08:40:00',3.43),('6449','2013-04-20','08:45:00',3.26),('6449','2013-04-20','08:50:00',3.27),('6449','2013-04-20','08:55:00',3.2),('6449','2013-04-20','09:00:00',3.09),('6449','2013-04-20','09:05:00',3.13),('6449','2013-04-20','09:10:00',3.3),('6449','2013-04-20','09:15:00',2.73),('6449','2013-04-20','09:20:00',2.48),('6449','2013-04-20','09:25:00',2.38),('6449','2013-04-20','09:30:00',2.65),('6449','2013-04-20','09:35:00',2.7),('6449','2013-04-20','09:40:00',2.64),('6449','2013-04-20','09:45:00',2.47),('6449','2013-04-20','09:50:00',2.86),('6449','2013-04-20','09:55:00',3.5),('6449','2013-04-20','10:00:00',3.8),('6449','2013-04-20','10:05:00',4.38),('6449','2013-04-20','10:10:00',4.08),('6449','2013-04-20','10:15:00',4.16),('6449','2013-04-20','10:20:00',4.28),('6449','2013-04-20','10:25:00',3.66),('6449','2013-04-20','10:30:00',3.76),('6449','2013-04-20','10:35:00',4.15),('6449','2013-04-20','10:40:00',4.79),('6449','2013-04-20','10:45:00',5.35),('6449','2013-04-20','10:50:00',5.95),('6449','2013-04-20','10:55:00',6.6),('6449','2013-04-20','11:00:00',7.57),('6449','2013-04-20','11:05:00',10.05),('6449','2013-04-20','11:10:00',9.64),('6449','2013-04-20','11:15:00',9.67),('6449','2013-04-20','11:20:00',13.73),('6449','2013-04-20','11:25:00',10.1),('6449','2013-04-20','11:30:00',12.51),('6449','2013-04-20','11:35:00',16),('6449','2013-04-20','11:40:00',17.21),('6449','2013-04-20','11:45:00',16.81),('6449','2013-04-20','11:50:00',16.41),('6449','2013-04-20','11:55:00',13.3),('6449','2013-04-20','12:00:00',14.38),('6449','2013-04-20','12:05:00',18.38),('6449','2013-04-20','12:10:00',18.24),('6449','2013-04-20','12:15:00',11.31),('6449','2013-04-20','12:20:00',12.05),('6449','2013-04-20','12:25:00',10.94),('6449','2013-04-20','12:30:00',10.96),('6449','2013-04-20','12:35:00',9.27),('6449','2013-04-20','12:40:00',7.73),('6449','2013-04-20','12:45:00',7.21),('6449','2013-04-20','12:50:00',5.8),('6449','2013-04-20','12:55:00',4.82),('6449','2013-04-20','13:00:00',4.38),('6449','2013-04-20','13:05:00',4.34),('6449','2013-04-20','13:10:00',4.98),('6449','2013-04-20','13:15:00',5.81),('6449','2013-04-20','13:20:00',7.33),('6449','2013-04-20','13:25:00',11.64),('6449','2013-04-20','13:30:00',14.35),('6449','2013-04-20','13:35:00',17.11),('6449','2013-04-20','13:40:00',18.54),('6449','2013-04-20','13:45:00',17.29),('6449','2013-04-20','13:50:00',18.69),('6449','2013-04-20','13:55:00',13.72),('6449','2013-04-20','14:00:00',12.51),('6449','2013-04-20','14:05:00',14.8),('6449','2013-04-20','14:10:00',13.34),('6449','2013-04-20','14:15:00',8.79),('6449','2013-04-20','14:20:00',5.59),('6449','2013-04-20','14:25:00',6.04),('6449','2013-04-20','14:30:00',9.03),('6449','2013-04-20','14:35:00',12.88),('6449','2013-04-20','14:40:00',10.18),('6449','2013-04-20','14:45:00',8.45),('6449','2013-04-20','14:50:00',4.88),('6449','2013-04-20','14:55:00',3.63),('6449','2013-04-20','15:00:00',3.31),('6449','2013-04-20','15:05:00',3.31),('6449','2013-04-20','15:10:00',3.36),('6449','2013-04-20','15:15:00',3.8),('6449','2013-04-20','15:20:00',4.74),('6449','2013-04-20','15:25:00',6.34),('6449','2013-04-20','15:30:00',13.16),('6449','2013-04-20','15:35:00',15.74),('6449','2013-04-20','15:40:00',14.42),('6449','2013-04-20','15:45:00',13.68),('6449','2013-04-20','15:50:00',13.06),('6449','2013-04-20','15:55:00',12.42),('6449','2013-04-20','16:00:00',11.89),('6449','2013-04-20','16:05:00',10.98),('6449','2013-04-20','16:10:00',9.05),('6449','2013-04-20','16:15:00',5.21),('6449','2013-04-20','16:20:00',2.94),('6449','2013-04-20','16:25:00',7.85),('6449','2013-04-20','16:30:00',10.9),('6449','2013-04-20','16:35:00',10.63),('6449','2013-04-20','16:40:00',9.53),('6449','2013-04-20','16:45:00',8.93),('6449','2013-04-20','16:50:00',8.74),('6449','2013-04-20','16:55:00',8.39),('6449','2013-04-20','17:00:00',7.81),('6449','2013-04-20','17:05:00',7.6),('6449','2013-04-20','17:10:00',7.32),('6449','2013-04-20','17:15:00',6.57),('6449','2013-04-20','17:20:00',4.41),('6449','2013-04-20','17:25:00',3.25),('6449','2013-04-20','17:30:00',2.89),('6449','2013-04-20','17:35:00',3.33),('6449','2013-04-20','17:40:00',3.5),('6449','2013-04-20','17:45:00',3.87),('6449','2013-04-20','17:50:00',2.44),('6449','2013-04-20','17:55:00',1.94),('6449','2013-04-20','18:00:00',2.25),('6449','2013-04-20','18:05:00',2.47),('6449','2013-04-20','18:10:00',2.31),('6449','2013-04-20','18:15:00',2.11),('6449','2013-04-20','18:20:00',1.77),('6449','2013-04-20','18:25:00',1.43),('6449','2013-04-20','18:30:00',1.31),('6449','2013-04-20','18:35:00',1.36),('6449','2013-04-20','18:40:00',1.33),('6449','2013-04-20','18:45:00',1.4),('6449','2013-04-20','18:50:00',1.55),('6449','2013-04-20','18:55:00',1.68),('6449','2013-04-20','19:00:00',1.31),('6449','2013-04-20','19:05:00',1.01),('6449','2013-04-19','07:15:00',1.17),('6449','2013-04-19','07:20:00',1.03),('6449','2013-04-19','07:25:00',1.12),('6449','2013-04-19','07:30:00',1.33),('6449','2013-04-19','07:35:00',1.72),('6449','2013-04-19','07:40:00',2),('6449','2013-04-19','07:45:00',3.02),('6449','2013-04-19','07:50:00',3.32),('6449','2013-04-19','07:55:00',3.68),('6449','2013-04-19','08:00:00',4.06),('6449','2013-04-19','08:05:00',4.48),('6449','2013-04-19','08:10:00',4.74),('6449','2013-04-19','08:15:00',5.08),('6449','2013-04-19','08:20:00',5.41),('6449','2013-04-19','08:25:00',5.86),('6449','2013-04-19','08:30:00',6.26),('6449','2013-04-19','08:35:00',6.58),('6449','2013-04-19','08:40:00',7.04),('6449','2013-04-19','08:45:00',7.5),('6449','2013-04-19','08:50:00',7.78),('6449','2013-04-19','08:55:00',8.12),('6449','2013-04-19','09:00:00',8.41),('6449','2013-04-19','09:05:00',8.54),('6449','2013-04-19','09:10:00',9.06),('6449','2013-04-19','09:15:00',9.35),('6449','2013-04-19','09:20:00',9.62),('6449','2013-04-19','09:25:00',10.04),('6449','2013-04-19','09:30:00',10.28),('6449','2013-04-19','09:35:00',10.54),('6449','2013-04-19','09:40:00',11.02),('6449','2013-04-19','09:45:00',11.43),('6449','2013-04-19','09:50:00',11.17),('6449','2013-04-19','09:55:00',11.8),('6449','2013-04-19','10:00:00',11.93),('6449','2013-04-19','10:05:00',12.53),('6449','2013-04-19','10:10:00',10.22),('6449','2013-04-19','10:15:00',9.92),('6449','2013-04-19','10:20:00',13.66),('6449','2013-04-19','10:25:00',11.05),('6449','2013-04-19','10:30:00',13.52),('6449','2013-04-19','10:35:00',13.12),('6449','2013-04-19','10:40:00',14.16),('6449','2013-04-19','10:45:00',11.52),('6449','2013-04-19','10:50:00',12.72),('6449','2013-04-19','10:55:00',13.75),('6449','2013-04-19','11:00:00',11.6),('6449','2013-04-19','11:05:00',11.58),('6449','2013-04-19','11:10:00',14.18),('6449','2013-04-19','11:15:00',13.64),('6449','2013-04-19','11:20:00',14.78),('6449','2013-04-19','11:25:00',14.78),('6449','2013-04-19','11:30:00',15.04),('6449','2013-04-19','11:35:00',15.13),('6449','2013-04-19','11:40:00',15.22),('6449','2013-04-19','11:45:00',15.3),('6449','2013-04-19','11:50:00',15.29),('6449','2013-04-19','11:55:00',15.49),('6449','2013-04-19','12:00:00',15.52),('6449','2013-04-19','12:05:00',15.51),('6449','2013-04-19','12:10:00',15.7),('6449','2013-04-19','12:15:00',15.8),('6449','2013-04-19','12:20:00',15.83),('6449','2013-04-19','12:25:00',15.88),('6449','2013-04-19','12:30:00',15.88),('6449','2013-04-19','12:35:00',15.82),('6449','2013-04-19','12:40:00',15.92),('6449','2013-04-19','12:45:00',15.87),('6449','2013-04-19','12:50:00',15.93),('6449','2013-04-19','12:55:00',15.99),('6449','2013-04-19','13:00:00',15.91),('6449','2013-04-19','13:05:00',15.95),('6449','2013-04-19','13:10:00',15.92),('6449','2013-04-19','13:15:00',15.91),('6449','2013-04-19','13:20:00',15.79),('6449','2013-04-19','13:25:00',15.83),('6449','2013-04-19','13:30:00',15.87),('6449','2013-04-19','13:35:00',15.71),('6449','2013-04-19','13:40:00',15.76),('6449','2013-04-19','13:45:00',15.6),('6449','2013-04-19','13:50:00',15.55),('6449','2013-04-19','13:55:00',15.51),('6449','2013-04-19','14:00:00',15.47),('6449','2013-04-19','14:05:00',15.34),('6449','2013-04-19','14:10:00',15.3),('6449','2013-04-19','14:15:00',15.14),('6449','2013-04-19','14:20:00',14.93),('6449','2013-04-19','14:25:00',14.9),('6449','2013-04-19','14:30:00',14.8),('6449','2013-04-19','14:35:00',14.65),('6449','2013-04-19','14:40:00',14.58),('6449','2013-04-19','14:45:00',14.34),('6449','2013-04-19','14:50:00',14.24),('6449','2013-04-19','14:55:00',14.11),('6449','2013-04-19','15:00:00',14.02),('6449','2013-04-19','15:05:00',13.83),('6449','2013-04-19','15:10:00',13.64),('6449','2013-04-19','15:15:00',13.42),('6449','2013-04-19','15:20:00',13.19),('6449','2013-04-19','15:25:00',13.16),('6449','2013-04-19','15:30:00',12.91),('6449','2013-04-19','15:35:00',12.57),('6449','2013-04-19','15:40:00',12.4),('6449','2013-04-19','15:45:00',12.13),('6449','2013-04-19','15:50:00',11.49),('6449','2013-04-19','15:55:00',11.72),('6449','2013-04-19','16:00:00',11.53),('6449','2013-04-19','16:05:00',10.96),('6449','2013-04-19','16:10:00',10.9),('6449','2013-04-19','16:15:00',9.79),('6449','2013-04-19','16:20:00',10.28),('6449','2013-04-19','16:25:00',10.01),('6449','2013-04-19','16:30:00',9.66),('6449','2013-04-19','16:35:00',9.27),('6449','2013-04-19','16:40:00',9.19),('6449','2013-04-19','16:45:00',8.55),('6449','2013-04-19','16:50:00',8.04),('6449','2013-04-19','16:55:00',7.48),('6449','2013-04-19','17:00:00',7.6),('6449','2013-04-19','17:05:00',7.3),('6449','2013-04-19','17:10:00',7.03),('6449','2013-04-19','17:15:00',5.75),('6449','2013-04-19','17:20:00',5.26),('6449','2013-04-19','17:25:00',5.19),('6449','2013-04-19','17:30:00',5.74),('6449','2013-04-19','17:35:00',5.57),('6449','2013-04-19','17:40:00',5.44),('6449','2013-04-19','17:45:00',5.33),('6449','2013-04-19','17:50:00',4.54),('6449','2013-04-19','17:55:00',3.38),('6449','2013-04-19','18:00:00',3.47),('6449','2013-04-19','18:05:00',3.21),('6449','2013-04-19','18:10:00',2.81),('6449','2013-04-19','18:15:00',2.52),('6449','2013-04-19','18:20:00',2.28),('6449','2013-04-19','18:25:00',2.01),('6449','2013-04-19','18:30:00',1.73),('6449','2013-04-19','18:35:00',1.49),('6449','2013-04-19','18:40:00',1.32),('6449','2013-04-19','18:45:00',1.14),('6449','2013-04-18','07:35:00',1.1),('6449','2013-04-18','07:40:00',1.39),('6449','2013-04-18','07:45:00',1.77),('6449','2013-04-18','07:50:00',2.04),('6449','2013-04-18','07:55:00',2.99),('6449','2013-04-18','08:00:00',3.89),('6449','2013-04-18','08:05:00',4.54),('6449','2013-04-18','08:10:00',5.21),('6449','2013-04-18','08:15:00',5.08),('6449','2013-04-18','08:20:00',5.63),('6449','2013-04-18','08:25:00',5.93),('6449','2013-04-18','08:30:00',6.87),('6449','2013-04-18','08:35:00',6.92),('6449','2013-04-18','08:40:00',6.64),('6449','2013-04-18','08:45:00',6.21),('6449','2013-04-18','08:50:00',5.69),('6449','2013-04-18','08:55:00',7.04),('6449','2013-04-18','09:00:00',8.31),('6449','2013-04-18','09:05:00',9.45),('6449','2013-04-18','09:10:00',9.91),('6449','2013-04-18','09:15:00',10.08),('6449','2013-04-18','09:20:00',10.42),('6449','2013-04-18','09:25:00',10.65),('6449','2013-04-18','09:30:00',10.94),('6449','2013-04-18','09:35:00',11.22),('6449','2013-04-18','09:40:00',11.28),('6449','2013-04-18','09:45:00',11.3),('6449','2013-04-18','09:50:00',11.69),('6449','2013-04-18','09:55:00',11.87),('6449','2013-04-18','10:00:00',12.02),('6449','2013-04-18','10:05:00',12.17),('6449','2013-04-18','10:10:00',12.28),('6449','2013-04-18','10:15:00',12.6),('6449','2013-04-18','10:20:00',12.76),('6449','2013-04-18','10:25:00',12.97),('6449','2013-04-18','10:30:00',13.13),('6449','2013-04-18','10:35:00',11.24),('6449','2013-04-18','10:40:00',12.02),('6449','2013-04-18','10:45:00',13.65),('6449','2013-04-18','10:50:00',13.73),('6449','2013-04-18','10:55:00',13.88),('6449','2013-04-18','11:00:00',13.98),('6449','2013-04-18','11:05:00',14.2),('6449','2013-04-18','11:10:00',14.3),('6449','2013-04-18','11:15:00',14.58),('6449','2013-04-18','11:20:00',14.76),('6449','2013-04-18','11:25:00',14.69),('6449','2013-04-18','11:30:00',15.06),('6449','2013-04-18','11:35:00',15.28),('6449','2013-04-18','11:40:00',15.35),('6449','2013-04-18','11:45:00',15.46),('6449','2013-04-18','11:50:00',15.57),('6449','2013-04-18','11:55:00',15.52),('6449','2013-04-18','12:00:00',15.85),('6449','2013-04-18','12:05:00',16.02),('6449','2013-04-18','12:10:00',16.11),('6449','2013-04-18','12:15:00',16.24),('6449','2013-04-18','12:20:00',16.34),('6449','2013-04-18','12:25:00',16.36),('6449','2013-04-18','12:30:00',16.45),('6449','2013-04-18','12:35:00',16.51),('6449','2013-04-18','12:40:00',16.54),('6449','2013-04-18','12:45:00',16.39),('6449','2013-04-18','12:50:00',16.39),('6449','2013-04-18','12:55:00',16.32),('6449','2013-04-18','13:00:00',16.26),('6449','2013-04-18','13:05:00',16.29),('6449','2013-04-18','13:10:00',15.91),('6449','2013-04-18','13:15:00',16.21),('6449','2013-04-18','13:20:00',16),('6449','2013-04-18','13:25:00',16.14),('6449','2013-04-18','13:30:00',16.15),('6449','2013-04-18','13:35:00',15.99),('6449','2013-04-18','13:40:00',15.73),('6449','2013-04-18','13:45:00',15.81),('6449','2013-04-18','13:50:00',15.54),('6449','2013-04-18','13:55:00',15.46),('6449','2013-04-18','14:00:00',15.21),('6449','2013-04-18','14:05:00',15.33),('6449','2013-04-18','14:10:00',15.13),('6449','2013-04-18','14:15:00',15.27),('6449','2013-04-18','14:20:00',15.19),('6449','2013-04-18','14:25:00',15.07),('6449','2013-04-18','14:30:00',15.11),('6449','2013-04-18','14:35:00',14.9),('6449','2013-04-18','14:40:00',14.75),('6449','2013-04-18','14:45:00',14.73),('6449','2013-04-18','14:50:00',14.6),('6449','2013-04-18','14:55:00',13.76),('6449','2013-04-18','15:00:00',13.73),('6449','2013-04-18','15:05:00',13.14),('6449','2013-04-18','15:10:00',13.68),('6449','2013-04-18','15:15:00',13.4),('6449','2013-04-18','15:20:00',13.29),('6449','2013-04-18','15:25:00',12.95),('6449','2013-04-18','15:30:00',12.72),('6449','2013-04-18','15:35:00',12.73),('6449','2013-04-18','15:40:00',12.61),('6449','2013-04-18','15:45:00',12.28),('6449','2013-04-18','15:50:00',12.06),('6449','2013-04-18','15:55:00',11.68),('6449','2013-04-18','16:00:00',11.54),('6449','2013-04-18','16:05:00',11.35),('6449','2013-04-18','16:10:00',11.14),('6449','2013-04-18','16:15:00',10.91),('6449','2013-04-18','16:20:00',10.57),('6449','2013-04-18','16:25:00',10.25),('6449','2013-04-18','16:30:00',9.83),('6449','2013-04-18','16:35:00',9.46),('6449','2013-04-18','16:40:00',9.02),('6449','2013-04-18','16:45:00',8.82),('6449','2013-04-18','16:50:00',8.45),('6449','2013-04-18','16:55:00',8.23),('6449','2013-04-18','17:00:00',7.81),('6449','2013-04-18','17:05:00',7.44),('6449','2013-04-18','17:10:00',7),('6449','2013-04-18','17:15:00',6.77),('6449','2013-04-18','17:20:00',6.48),('6449','2013-04-18','17:25:00',6.07),('6449','2013-04-18','17:30:00',5.7),('6449','2013-04-18','17:35:00',5.26),('6449','2013-04-18','17:40:00',4.9),('6449','2013-04-18','17:45:00',4.52),('6449','2013-04-18','17:50:00',4.12),('6449','2013-04-18','17:55:00',3.76),('6449','2013-04-18','18:00:00',3.41),('6449','2013-04-18','18:05:00',3.08),('6449','2013-04-18','18:10:00',2.76),('6449','2013-04-18','18:15:00',2.5),('6449','2013-04-18','18:20:00',2.21),('6449','2013-04-18','18:25:00',1.92),('6449','2013-04-18','18:30:00',1.73),('6449','2013-04-18','18:35:00',1.49),('6449','2013-04-18','18:40:00',1.28),('6449','2013-04-18','18:45:00',1.1),('6449','2013-04-17','07:10:00',1.03),('6449','2013-04-17','07:15:00',1.25),('6449','2013-04-17','07:20:00',1.51),('6449','2013-04-17','07:25:00',1.8),('6449','2013-04-17','07:30:00',2.12),('6449','2013-04-17','07:35:00',2.46),('6449','2013-04-17','07:40:00',2.79),('6449','2013-04-17','07:45:00',3.12),('6449','2013-04-17','07:50:00',3.53),('6449','2013-04-17','07:55:00',3.9),('6449','2013-04-17','08:00:00',4.27),('6449','2013-04-17','08:05:00',4.52),('6449','2013-04-17','08:10:00',5.01),('6449','2013-04-17','08:15:00',5.38),('6449','2013-04-17','08:20:00',5.74),('6449','2013-04-17','08:25:00',6.18),('6449','2013-04-17','08:30:00',6.54),('6449','2013-04-17','08:35:00',6.87),('6449','2013-04-17','08:40:00',7.14),('6449','2013-04-17','08:45:00',7.52),('6449','2013-04-17','08:50:00',7.92),('6449','2013-04-17','08:55:00',8.33),('6449','2013-04-17','09:00:00',8.57),('6449','2013-04-17','09:05:00',8.92),('6449','2013-04-17','09:10:00',9.33),('6449','2013-04-17','09:15:00',9.56),('6449','2013-04-17','09:20:00',9.93),('6449','2013-04-17','09:25:00',10.18),('6449','2013-04-17','09:30:00',10.56),('6449','2013-04-17','09:35:00',10.9),('6449','2013-04-17','09:40:00',11.1),('6449','2013-04-17','09:45:00',11.43),('6449','2013-04-17','09:50:00',11.59),('6449','2013-04-17','09:55:00',12.01),('6449','2013-04-17','10:00:00',12.28),('6449','2013-04-17','10:05:00',12.42),('6449','2013-04-17','10:10:00',12.65),('6449','2013-04-17','10:15:00',12.81),('6449','2013-04-17','10:20:00',13.03),('6449','2013-04-17','10:25:00',13.2),('6449','2013-04-17','10:30:00',13.4),('6449','2013-04-17','10:35:00',13.58),('6449','2013-04-17','10:40:00',13.61),('6449','2013-04-17','10:45:00',13.78),('6449','2013-04-17','10:50:00',13.87),('6449','2013-04-17','10:55:00',14.02),('6449','2013-04-17','11:00:00',14.13),('6449','2013-04-17','11:05:00',14.21),('6449','2013-04-17','11:10:00',14.17),('6449','2013-04-17','11:15:00',14.32),('6449','2013-04-17','11:20:00',14.43),('6449','2013-04-17','11:25:00',14.9),('6449','2013-04-17','11:30:00',15.15),('6449','2013-04-17','11:35:00',15.32),('6449','2013-04-17','11:40:00',15.23),('6449','2013-04-17','11:45:00',15.72),('6449','2013-04-17','11:50:00',15.93),('6449','2013-04-17','11:55:00',15.99),('6449','2013-04-17','12:00:00',16.07),('6449','2013-04-17','12:05:00',16.14),('6449','2013-04-17','12:10:00',16.19),('6449','2013-04-17','12:15:00',16.33),('6449','2013-04-17','12:20:00',16.4),('6449','2013-04-17','12:25:00',16.33),('6449','2013-04-17','12:30:00',16.28),('6449','2013-04-17','12:35:00',16.16),('6449','2013-04-17','12:40:00',16.31),('6449','2013-04-17','12:45:00',16.13),('6449','2013-04-17','12:50:00',16.43),('6449','2013-04-17','12:55:00',16.13),('6449','2013-04-17','13:00:00',15.55),('6449','2013-04-17','13:05:00',15.2),('6449','2013-04-17','13:10:00',15.76),('6449','2013-04-17','13:15:00',14.8),('6449','2013-04-17','13:20:00',14.4),('6449','2013-04-17','13:25:00',14.09),('6449','2013-04-17','13:30:00',13.89),('6449','2013-04-17','13:35:00',16.23),('6449','2013-04-17','13:40:00',16.75),('6449','2013-04-17','13:45:00',15.07),('6449','2013-04-17','13:50:00',14.87),('6449','2013-04-17','13:55:00',14.1),('6449','2013-04-17','14:00:00',13.12),('6449','2013-04-17','14:05:00',12.91),('6449','2013-04-17','14:10:00',15.69),('6449','2013-04-17','14:15:00',14.41),('6449','2013-04-17','14:20:00',15.94),('6449','2013-04-17','14:25:00',16.24),('6449','2013-04-17','14:30:00',16.01),('6449','2013-04-17','14:35:00',15.91),('6449','2013-04-17','14:40:00',15.58),('6449','2013-04-17','14:45:00',16.27),('6449','2013-04-17','14:50:00',15.83),('6449','2013-04-17','14:55:00',13.77),('6449','2013-04-17','15:00:00',13.47),('6449','2013-04-17','15:05:00',12.77),('6449','2013-04-17','15:10:00',13.24),('6449','2013-04-17','15:15:00',15.83),('6449','2013-04-17','15:20:00',14.28),('6449','2013-04-17','15:25:00',15.23),('6449','2013-04-17','15:30:00',14.8),('6449','2013-04-17','15:35:00',14.04),('6449','2013-04-17','15:40:00',13.83),('6449','2013-04-17','15:45:00',13.5),('6449','2013-04-17','15:50:00',12.08),('6449','2013-04-17','15:55:00',12.41),('6449','2013-04-17','16:00:00',12.14),('6449','2013-04-17','16:05:00',11.55),('6449','2013-04-17','16:10:00',11.48),('6449','2013-04-17','16:15:00',11.04),('6449','2013-04-17','16:20:00',10.75),('6449','2013-04-17','16:25:00',10.12),('6449','2013-04-17','16:30:00',10.08),('6449','2013-04-17','16:35:00',9.75),('6449','2013-04-17','16:40:00',9.32),('6449','2013-04-17','16:45:00',8.98),('6449','2013-04-17','16:50:00',8.59),('6449','2013-04-17','16:55:00',8.2),('6449','2013-04-17','17:00:00',7.91),('6449','2013-04-17','17:05:00',7.52),('6449','2013-04-17','17:10:00',7.13),('6449','2013-04-17','17:15:00',6.84),('6449','2013-04-17','17:20:00',6.49),('6449','2013-04-17','17:25:00',6.13),('6449','2013-04-17','17:30:00',5.75),('6449','2013-04-17','17:35:00',5.37),('6449','2013-04-17','17:40:00',5.08),('6449','2013-04-17','17:45:00',4.72),('6449','2013-04-17','17:50:00',4.35),('6449','2013-04-17','17:55:00',4.03),('6449','2013-04-17','18:00:00',3.64),('6449','2013-04-17','18:05:00',3.29),('6449','2013-04-17','18:10:00',2.83),('6449','2013-04-17','18:15:00',2.62),('6449','2013-04-17','18:20:00',2.32),('6449','2013-04-17','18:25:00',2.01),('6449','2013-04-17','18:30:00',1.73),('6449','2013-04-17','18:35:00',1.47),('6449','2013-04-17','18:40:00',1.22),('6449','2013-04-17','18:45:00',1.04),('6449','2013-04-16','07:05:00',1.04),('6449','2013-04-16','07:10:00',1.3),('6449','2013-04-16','07:15:00',1.59),('6449','2013-04-16','07:20:00',1.5),('6449','2013-04-16','07:25:00',1.49),('6449','2013-04-16','07:30:00',1.84),('6449','2013-04-16','07:35:00',1.35),('6449','2013-04-16','07:40:00',2.33),('6449','2013-04-16','07:45:00',2.61),('6449','2013-04-16','07:50:00',2.82),('6449','2013-04-16','07:55:00',3.58),('6449','2013-04-16','08:00:00',3.94),('6449','2013-04-16','08:05:00',4.29),('6449','2013-04-16','08:10:00',4.61),('6449','2013-04-16','08:15:00',4.98),('6449','2013-04-16','08:20:00',5.28),('6449','2013-04-16','08:25:00',5.75),('6449','2013-04-16','08:30:00',6.05),('6449','2013-04-16','08:35:00',6.03),('6449','2013-04-16','08:40:00',6.36),('6449','2013-04-16','08:45:00',3.62),('6449','2013-04-16','08:50:00',3.18),('6449','2013-04-16','08:55:00',6.9),('6449','2013-04-16','09:00:00',8.74),('6449','2013-04-16','09:05:00',7.5),('6449','2013-04-16','09:10:00',4.31),('6449','2013-04-16','09:15:00',6.02),('6449','2013-04-16','09:20:00',6.08),('6449','2013-04-16','09:25:00',10.05),('6449','2013-04-16','09:30:00',5.05),('6449','2013-04-16','09:35:00',5.39),('6449','2013-04-16','09:40:00',5.54),('6449','2013-04-16','09:45:00',7.36),('6449','2013-04-16','09:50:00',5.49),('6449','2013-04-16','09:55:00',4.9),('6449','2013-04-16','10:00:00',5.33),('6449','2013-04-16','10:05:00',5.64),('6449','2013-04-16','10:10:00',5.33),('6449','2013-04-16','10:15:00',4.75),('6449','2013-04-16','10:20:00',4.64),('6449','2013-04-16','10:25:00',4.99),('6449','2013-04-16','10:30:00',4.85),('6449','2013-04-16','10:35:00',4.27),('6449','2013-04-16','10:40:00',4.1),('6449','2013-04-16','10:45:00',4.25),('6449','2013-04-16','10:50:00',4.54),('6449','2013-04-16','10:55:00',4.68),('6449','2013-04-16','11:00:00',4.51),('6449','2013-04-16','11:05:00',4.53),('6449','2013-04-16','11:10:00',4.94),('6449','2013-04-16','11:15:00',5.88),('6449','2013-04-16','11:20:00',6.42),('6449','2013-04-16','11:25:00',7.19),('6449','2013-04-16','11:30:00',7.88),('6449','2013-04-16','11:35:00',9.6),('6449','2013-04-16','11:40:00',12.57),('6449','2013-04-16','11:45:00',12.69),('6449','2013-04-16','11:50:00',14.35),('6449','2013-04-16','11:55:00',10.96),('6449','2013-04-16','12:00:00',15.55),('6449','2013-04-16','12:05:00',14.12),('6449','2013-04-16','12:10:00',11.92),('6449','2013-04-16','12:15:00',9.2),('6449','2013-04-16','12:20:00',13.05),('6449','2013-04-16','12:25:00',13.69),('6449','2013-04-16','12:30:00',13),('6449','2013-04-16','12:35:00',12.83),('6449','2013-04-16','12:40:00',15.75),('6449','2013-04-16','12:45:00',16.17),('6449','2013-04-16','12:50:00',16.01),('6449','2013-04-16','12:55:00',16.04),('6449','2013-04-16','13:00:00',16.13),('6449','2013-04-16','13:05:00',16.17),('6449','2013-04-16','13:10:00',16.11),('6449','2013-04-16','13:15:00',16.08),('6449','2013-04-16','13:20:00',16.05),('6449','2013-04-16','13:25:00',16.04),('6449','2013-04-16','13:30:00',15.88),('6449','2013-04-16','13:35:00',15.26),('6449','2013-04-16','13:40:00',14.87),('6449','2013-04-16','13:45:00',14.35),('6449','2013-04-16','13:50:00',15.25),('6449','2013-04-16','13:55:00',16.19),('6449','2013-04-16','14:00:00',16.43),('6449','2013-04-16','14:05:00',16.13),('6449','2013-04-16','14:10:00',16.11),('6449','2013-04-16','14:15:00',14.66),('6449','2013-04-16','14:20:00',13.8),('6449','2013-04-16','14:25:00',15.62),('6449','2013-04-16','14:30:00',14.84),('6449','2013-04-16','14:35:00',15.12),('6449','2013-04-16','14:40:00',15.25),('6449','2013-04-16','14:45:00',9.82),('6449','2013-04-16','14:50:00',11.72),('6449','2013-04-16','14:55:00',15.28),('6449','2013-04-16','15:00:00',15.09),('6449','2013-04-16','15:05:00',14.01),('6449','2013-04-16','15:10:00',13.4),('6449','2013-04-16','15:15:00',11.28),('6449','2013-04-16','15:20:00',12.39),('6449','2013-04-16','15:25:00',11.3),('6449','2013-04-16','15:30:00',10.86),('6449','2013-04-16','15:35:00',11.88),('6449','2013-04-16','15:40:00',11.33),('6449','2013-04-16','15:45:00',12.31),('6449','2013-04-16','15:50:00',11.99),('6449','2013-04-16','15:55:00',11.7),('6449','2013-04-16','16:00:00',11.62),('6449','2013-04-16','16:05:00',11.43),('6449','2013-04-16','16:10:00',10.9),('6449','2013-04-16','16:15:00',7.5),('6449','2013-04-16','16:20:00',7.59),('6449','2013-04-16','16:25:00',8.32),('6449','2013-04-16','16:30:00',10.25),('6449','2013-04-16','16:35:00',9.45),('6449','2013-04-16','16:40:00',9.62),('6449','2013-04-16','16:45:00',9.04),('6449','2013-04-16','16:50:00',8.47),('6449','2013-04-16','16:55:00',8.09),('6449','2013-04-16','17:00:00',7.29),('6449','2013-04-16','17:05:00',7.25),('6449','2013-04-16','17:10:00',6.79),('6449','2013-04-16','17:15:00',6.63),('6449','2013-04-16','17:20:00',6.3),('6449','2013-04-16','17:25:00',6),('6449','2013-04-16','17:30:00',5.66),('6449','2013-04-16','17:35:00',5.27),('6449','2013-04-16','17:40:00',4.97),('6449','2013-04-16','17:45:00',4.62),('6449','2013-04-16','17:50:00',4.29),('6449','2013-04-16','17:55:00',3.94),('6449','2013-04-16','18:00:00',3.54),('6449','2013-04-16','18:05:00',3.24),('6449','2013-04-16','18:10:00',2.89),('6449','2013-04-16','18:15:00',2.51),('6449','2013-04-16','18:20:00',2.18),('6449','2013-04-16','18:25:00',1.94),('6449','2013-04-16','18:30:00',1.62),('6449','2013-04-16','18:35:00',1.25),('6449','2013-04-15','07:15:00',1.16),('6449','2013-04-15','07:20:00',1.42),('6449','2013-04-15','07:25:00',1.71),('6449','2013-04-15','07:30:00',2.06),('6449','2013-04-15','07:35:00',2.42),('6449','2013-04-15','07:40:00',2.75),('6449','2013-04-15','07:45:00',3.17),('6449','2013-04-15','07:50:00',3.52),('6449','2013-04-15','07:55:00',3.89),('6449','2013-04-15','08:00:00',4.26),('6449','2013-04-15','08:05:00',4.67),('6449','2013-04-15','08:10:00',5),('6449','2013-04-15','08:15:00',5.42),('6449','2013-04-15','08:20:00',5.86),('6449','2013-04-15','08:25:00',6.25),('6449','2013-04-15','08:30:00',6.59),('6449','2013-04-15','08:35:00',7.01),('6449','2013-04-15','08:40:00',7.45),('6449','2013-04-15','08:45:00',7.82),('6449','2013-04-15','08:50:00',8.14),('6449','2013-04-15','08:55:00',8.44),('6449','2013-04-15','09:00:00',8.73),('6449','2013-04-15','09:05:00',9.05),('6449','2013-04-15','09:10:00',9.42),('6449','2013-04-15','09:15:00',9.82),('6449','2013-04-15','09:20:00',10.09),('6449','2013-04-15','09:25:00',10.28),('6449','2013-04-15','09:30:00',10.75),('6449','2013-04-15','09:35:00',10.98),('6449','2013-04-15','09:40:00',11.23),('6449','2013-04-15','09:45:00',11.49),('6449','2013-04-15','09:50:00',11.87),('6449','2013-04-15','09:55:00',11.97),('6449','2013-04-15','10:00:00',12.4),('6449','2013-04-15','10:05:00',12.64),('6449','2013-04-15','10:10:00',12.85),('6449','2013-04-15','10:15:00',12.98),('6449','2013-04-15','10:20:00',13.05),('6449','2013-04-15','10:25:00',13.16),('6449','2013-04-15','10:30:00',13.26),('6449','2013-04-15','10:35:00',13.39),('6449','2013-04-15','10:40:00',13.57),('6449','2013-04-15','10:45:00',13.68),('6449','2013-04-15','10:50:00',13.76),('6449','2013-04-15','10:55:00',13.87),('6449','2013-04-15','11:00:00',13.94),('6449','2013-04-15','11:05:00',14.1),('6449','2013-04-15','11:10:00',14.14),('6449','2013-04-15','11:15:00',14.46),('6449','2013-04-15','11:20:00',14.62),('6449','2013-04-15','11:25:00',14.76),('6449','2013-04-15','11:30:00',14.86),('6449','2013-04-15','11:35:00',14.9),('6449','2013-04-15','11:40:00',14.85),('6449','2013-04-15','11:45:00',15.13),('6449','2013-04-15','11:50:00',15.23),('6449','2013-04-15','11:55:00',15.3),('6449','2013-04-15','12:00:00',15.34),('6449','2013-04-15','12:05:00',15.49),('6449','2013-04-15','12:10:00',15.7),('6449','2013-04-15','12:15:00',15.91),('6449','2013-04-15','12:20:00',16.09),('6449','2013-04-15','12:25:00',16.31),('6449','2013-04-15','12:30:00',16.37),('6449','2013-04-15','12:35:00',16.39),('6449','2013-04-15','12:40:00',16.37),('6449','2013-04-15','12:45:00',16.4),('6449','2013-04-15','12:50:00',16.46),('6449','2013-04-15','12:55:00',16.22),('6449','2013-04-15','13:00:00',16.51),('6449','2013-04-15','13:05:00',16.39),('6449','2013-04-15','13:10:00',16.37),('6449','2013-04-15','13:15:00',16.32),('6449','2013-04-15','13:20:00',16.21),('6449','2013-04-15','13:25:00',15.96),('6449','2013-04-15','13:30:00',16.39),('6449','2013-04-15','13:35:00',16.31),('6449','2013-04-15','13:40:00',16.31),('6449','2013-04-15','13:45:00',16.2),('6449','2013-04-15','13:50:00',16.24),('6449','2013-04-15','13:55:00',16.11),('6449','2013-04-15','14:00:00',16.05),('6449','2013-04-15','14:05:00',15.85),('6449','2013-04-15','14:10:00',15.66),('6449','2013-04-15','14:15:00',15.63),('6449','2013-04-15','14:20:00',15.55),('6449','2013-04-15','14:25:00',15.45),('6449','2013-04-15','14:30:00',15.29),('6449','2013-04-15','14:35:00',15.12),('6449','2013-04-15','14:40:00',14.84),('6449','2013-04-15','14:45:00',14.83),('6449','2013-04-15','14:50:00',14.72),('6449','2013-04-15','14:55:00',14.58),('6449','2013-04-15','15:00:00',14.41),('6449','2013-04-15','15:05:00',14.27),('6449','2013-04-15','15:10:00',14.07),('6449','2013-04-15','15:15:00',13.79),('6449','2013-04-15','15:20:00',13.84),('6449','2013-04-15','15:25:00',13.66),('6449','2013-04-15','15:30:00',13.39),('6449','2013-04-15','15:35:00',13.11),('6449','2013-04-15','15:40:00',12.94),('6449','2013-04-15','15:45:00',12.68),('6449','2013-04-15','15:50:00',12.47),('6449','2013-04-15','15:55:00',12.22),('6449','2013-04-15','16:00:00',11.94),('6449','2013-04-15','16:05:00',11.7),('6449','2013-04-15','16:10:00',11.34),('6449','2013-04-15','16:15:00',10.99),('6449','2013-04-15','16:20:00',10.82),('6449','2013-04-15','16:25:00',10.5),('6449','2013-04-15','16:30:00',10.15),('6449','2013-04-15','16:35:00',9.9),('6449','2013-04-15','16:40:00',9.48),('6449','2013-04-15','16:45:00',9.13),('6449','2013-04-15','16:50:00',8.71),('6449','2013-04-15','16:55:00',8.43),('6449','2013-04-15','17:00:00',7.95),('6449','2013-04-15','17:05:00',7.66),('6449','2013-04-15','17:10:00',7.31),('6449','2013-04-15','17:15:00',6.92),('6449','2013-04-15','17:20:00',6.61),('6449','2013-04-15','17:25:00',6.23),('6449','2013-04-15','17:30:00',5.87),('6449','2013-04-15','17:35:00',5.47),('6449','2013-04-15','17:40:00',5.12),('6449','2013-04-15','17:45:00',4.74),('6449','2013-04-15','17:50:00',4.37),('6449','2013-04-15','17:55:00',3.98),('6449','2013-04-15','18:00:00',3.62),('6449','2013-04-15','18:05:00',3.25),('6449','2013-04-15','18:10:00',2.88),('6449','2013-04-15','18:15:00',2.55),('6449','2013-04-15','18:20:00',2.28),('6449','2013-04-15','18:25:00',1.96),('6449','2013-04-15','18:30:00',1.67),('6449','2013-04-15','18:35:00',1.4),('6449','2013-04-15','18:40:00',1.17),('6449','2013-04-14','07:15:00',1.12),('6449','2013-04-14','07:20:00',1.38),('6449','2013-04-14','07:25:00',1.71),('6449','2013-04-14','07:30:00',2.07),('6449','2013-04-14','07:35:00',2.42),('6449','2013-04-14','07:40:00',2.73),('6449','2013-04-14','07:45:00',2.95),('6449','2013-04-14','07:50:00',3.52),('6449','2013-04-14','07:55:00',3.59),('6449','2013-04-14','08:00:00',3.74),('6449','2013-04-14','08:05:00',4.16),('6449','2013-04-14','08:10:00',4.73),('6449','2013-04-14','08:15:00',5.2),('6449','2013-04-14','08:20:00',5.54),('6449','2013-04-14','08:25:00',5.94),('6449','2013-04-14','08:30:00',6.38),('6449','2013-04-14','08:35:00',6.75),('6449','2013-04-14','08:40:00',7.12),('6449','2013-04-14','08:45:00',7.48),('6449','2013-04-14','08:50:00',7.82),('6449','2013-04-14','08:55:00',8.16),('6449','2013-04-14','09:00:00',8.53),('6449','2013-04-14','09:05:00',8.83),('6449','2013-04-14','09:10:00',9.24),('6449','2013-04-14','09:15:00',9.48),('6449','2013-04-14','09:20:00',9.76),('6449','2013-04-14','09:25:00',10.06),('6449','2013-04-14','09:30:00',10.39),('6449','2013-04-14','09:35:00',10.65),('6449','2013-04-14','09:40:00',10.94),('6449','2013-04-14','09:45:00',11.26),('6449','2013-04-14','09:50:00',11.52),('6449','2013-04-14','09:55:00',11.49),('6449','2013-04-14','10:00:00',11.99),('6449','2013-04-14','10:05:00',12.23),('6449','2013-04-14','10:10:00',12.43),('6449','2013-04-14','10:15:00',12.66),('6449','2013-04-14','10:20:00',12.85),('6449','2013-04-14','10:25:00',13.06),('6449','2013-04-14','10:30:00',13.22),('6449','2013-04-14','10:35:00',13.4),('6449','2013-04-14','10:40:00',13.41),('6449','2013-04-14','10:45:00',13.7),('6449','2013-04-14','10:50:00',13.84),('6449','2013-04-14','10:55:00',13.86),('6449','2013-04-14','11:00:00',13.96),('6449','2013-04-14','11:05:00',14.12),('6449','2013-04-14','11:10:00',14.18),('6449','2013-04-14','11:15:00',14.5),('6449','2013-04-14','11:20:00',14.8),('6449','2013-04-14','11:25:00',14.88),('6449','2013-04-14','11:30:00',15.09),('6449','2013-04-14','11:35:00',15.25),('6449','2013-04-14','11:40:00',15.37),('6449','2013-04-14','11:45:00',15.33),('6449','2013-04-14','11:50:00',15.4),('6449','2013-04-14','11:55:00',15.58),('6449','2013-04-14','12:00:00',15.82),('6449','2013-04-14','12:05:00',16),('6449','2013-04-14','12:10:00',16.02),('6449','2013-04-14','12:15:00',16.05),('6449','2013-04-14','12:20:00',16.09),('6449','2013-04-14','12:25:00',16.18),('6449','2013-04-14','12:30:00',16.13),('6449','2013-04-14','12:35:00',16.3),('6449','2013-04-14','12:40:00',16.34),('6449','2013-04-14','12:45:00',16.25),('6449','2013-04-14','12:50:00',16.3),('6449','2013-04-14','12:55:00',16.3),('6449','2013-04-14','13:00:00',16.1),('6449','2013-04-14','13:05:00',16.24),('6449','2013-04-14','13:10:00',16.21),('6449','2013-04-14','13:15:00',16.18),('6449','2013-04-14','13:20:00',16.2),('6449','2013-04-14','13:25:00',16.24),('6449','2013-04-14','13:30:00',16.03),('6449','2013-04-14','13:35:00',16.14),('6449','2013-04-14','13:40:00',16.1),('6449','2013-04-14','13:45:00',16.03),('6449','2013-04-14','13:50:00',15.94),('6449','2013-04-14','13:55:00',15.83),('6449','2013-04-14','14:00:00',15.72),('6449','2013-04-14','14:05:00',15.71),('6449','2013-04-14','14:10:00',15.72),('6449','2013-04-14','14:15:00',15.57),('6449','2013-04-14','14:20:00',15.6),('6449','2013-04-14','14:25:00',15.43),('6449','2013-04-14','14:30:00',15.24),('6449','2013-04-14','14:35:00',15.17),('6449','2013-04-14','14:40:00',15.12),('6449','2013-04-14','14:45:00',14.72),('6449','2013-04-14','14:50:00',14.72),('6449','2013-04-14','14:55:00',14.48),('6449','2013-04-14','15:00:00',14.31),('6449','2013-04-14','15:05:00',14.13),('6449','2013-04-14','15:10:00',13.93),('6449','2013-04-14','15:15:00',13.63),('6449','2013-04-14','15:20:00',13.55),('6449','2013-04-14','15:25:00',13.37),('6449','2013-04-14','15:30:00',13.26),('6449','2013-04-14','15:35:00',13.09),('6449','2013-04-14','15:40:00',12.84),('6449','2013-04-14','15:45:00',12.48),('6449','2013-04-14','15:50:00',12.25),('6449','2013-04-14','15:55:00',12.02),('6449','2013-04-14','16:00:00',11.71),('6449','2013-04-14','16:05:00',11.51),('6449','2013-04-14','16:10:00',11.19),('6449','2013-04-14','16:15:00',10.96),('6449','2013-04-14','16:20:00',10.64),('6449','2013-04-14','16:25:00',10.24),('6449','2013-04-14','16:30:00',9.85),('6449','2013-04-14','16:35:00',9.62),('6449','2013-04-14','16:40:00',9.28),('6449','2013-04-14','16:45:00',8.9),('6449','2013-04-14','16:50:00',8.58),('6449','2013-04-14','16:55:00',8.19),('6449','2013-04-14','17:00:00',7.83),('6449','2013-04-14','17:05:00',7.47),('6449','2013-04-14','17:10:00',7.11),('6449','2013-04-14','17:15:00',6.7),('6449','2013-04-14','17:20:00',6.37),('6449','2013-04-14','17:25:00',6.04),('6449','2013-04-14','17:30:00',5.65),('6449','2013-04-14','17:35:00',5.4),('6449','2013-04-14','17:40:00',4.99),('6449','2013-04-14','17:45:00',4.61),('6449','2013-04-14','17:50:00',4.3),('6449','2013-04-14','17:55:00',3.93),('6449','2013-04-14','18:00:00',3.53),('6449','2013-04-14','18:05:00',3.22),('6449','2013-04-14','18:10:00',2.88),('6449','2013-04-14','18:15:00',2.51),('6449','2013-04-14','18:20:00',2.25),('6449','2013-04-14','18:25:00',1.97),('6449','2013-04-14','18:30:00',1.7),('6449','2013-04-14','18:35:00',1.46),('6449','2013-04-14','18:40:00',1.23),('6449','2013-04-14','18:45:00',1),('6449','2013-04-13','07:30:00',1.13),('6449','2013-04-13','07:35:00',1.37),('6449','2013-04-13','07:40:00',1.28),('6449','2013-04-13','07:45:00',1.1),('6449','2013-04-13','07:50:00',1.53),('6449','2013-04-13','07:55:00',1.21),('6449','2013-04-13','08:00:00',1.01),('6449','2013-04-13','08:05:00',2.56),('6449','2013-04-13','08:10:00',3.86),('6449','2013-04-13','08:15:00',5.11),('6449','2013-04-13','08:20:00',5.53),('6449','2013-04-13','08:25:00',5.86),('6449','2013-04-13','08:30:00',6.15),('6449','2013-04-13','08:35:00',6.22),('6449','2013-04-13','08:40:00',6.52),('6449','2013-04-13','08:45:00',6.89),('6449','2013-04-13','08:50:00',7.49),('6449','2013-04-13','08:55:00',8.09),('6449','2013-04-13','09:00:00',9.42),('6449','2013-04-13','09:05:00',10.15),('6449','2013-04-13','09:10:00',10.61),('6449','2013-04-13','09:15:00',10.58),('6449','2013-04-13','09:20:00',3.78),('6449','2013-04-13','09:25:00',2.27),('6449','2013-04-13','09:30:00',1.92),('6449','2013-04-13','09:35:00',2.11),('6449','2013-04-13','09:40:00',10.29),('6449','2013-04-13','09:45:00',11.07),('6449','2013-04-13','09:50:00',10.47),('6449','2013-04-13','09:55:00',8.86),('6449','2013-04-13','10:00:00',12.18),('6449','2013-04-13','10:05:00',12.35),('6449','2013-04-13','10:10:00',12.55),('6449','2013-04-13','10:15:00',12.68),('6449','2013-04-13','10:20:00',12.43),('6449','2013-04-13','10:25:00',13.05),('6449','2013-04-13','10:30:00',13.49),('6449','2013-04-13','10:35:00',13.79),('6449','2013-04-13','10:40:00',13.63),('6449','2013-04-13','10:45:00',12.99),('6449','2013-04-13','10:50:00',14.12),('6449','2013-04-13','10:55:00',14.46),('6449','2013-04-13','11:00:00',14.46),('6449','2013-04-13','11:05:00',14.19),('6449','2013-04-13','11:10:00',14.84),('6449','2013-04-13','11:15:00',14.98),('6449','2013-04-13','11:20:00',14.87),('6449','2013-04-13','11:25:00',14.93),('6449','2013-04-13','11:30:00',14.53),('6449','2013-04-13','11:35:00',14.87),('6449','2013-04-13','11:40:00',15.47),('6449','2013-04-13','11:45:00',15.6),('6449','2013-04-13','11:50:00',15.65),('6449','2013-04-13','11:55:00',15.76),('6449','2013-04-13','12:00:00',15.93),('6449','2013-04-13','12:05:00',15.78),('6449','2013-04-13','12:10:00',16.29),('6449','2013-04-13','12:15:00',16.11),('6449','2013-04-13','12:20:00',16.23),('6449','2013-04-13','12:25:00',16.27),('6449','2013-04-13','12:30:00',16.42),('6449','2013-04-13','12:35:00',16.1),('6449','2013-04-13','12:40:00',16),('6449','2013-04-13','12:45:00',16.16),('6449','2013-04-13','12:50:00',15.65),('6449','2013-04-13','12:55:00',14.28),('6449','2013-04-13','13:00:00',13.96),('6449','2013-04-13','13:05:00',14.2),('6449','2013-04-13','13:10:00',14.59),('6449','2013-04-13','13:15:00',15.16),('6449','2013-04-13','13:20:00',14.43),('6449','2013-04-13','13:25:00',14.82),('6449','2013-04-13','13:30:00',14.36),('6449','2013-04-13','13:35:00',13.75),('6449','2013-04-13','13:40:00',13.23),('6449','2013-04-13','13:45:00',14.25),('6449','2013-04-13','13:50:00',14.02),('6449','2013-04-13','13:55:00',14.52),('6449','2013-04-13','14:00:00',14.43),('6449','2013-04-13','14:05:00',14.08),('6449','2013-04-13','14:10:00',13.61),('6449','2013-04-13','14:15:00',13.42),('6449','2013-04-13','14:20:00',13.14),('6449','2013-04-13','14:25:00',13.49),('6449','2013-04-13','14:30:00',13.78),('6449','2013-04-13','14:35:00',13.28),('6449','2013-04-13','14:40:00',13.45),('6449','2013-04-13','14:45:00',12.24),('6449','2013-04-13','14:50:00',11.7),('6449','2013-04-13','14:55:00',11.19),('6449','2013-04-13','15:00:00',11.11),('6449','2013-04-13','15:05:00',11.31),('6449','2013-04-13','15:10:00',11.59),('6449','2013-04-13','15:15:00',12.01),('6449','2013-04-13','15:20:00',11.52),('6449','2013-04-13','15:25:00',11.91),('6449','2013-04-13','15:30:00',11.36),('6449','2013-04-13','15:35:00',10.35),('6449','2013-04-13','15:40:00',11.09),('6449','2013-04-13','15:45:00',10.16),('6449','2013-04-13','15:50:00',9.91),('6449','2013-04-13','15:55:00',9.32),('6449','2013-04-13','16:00:00',9.78),('6449','2013-04-13','16:05:00',7.99),('6449','2013-04-13','16:10:00',6.88),('6449','2013-04-13','16:15:00',7.81),('6449','2013-04-13','16:20:00',7.23),('6449','2013-04-13','16:25:00',8.13),('6449','2013-04-13','16:30:00',8.41),('6449','2013-04-13','16:35:00',9),('6449','2013-04-13','16:40:00',8.51),('6449','2013-04-13','16:45:00',8.71),('6449','2013-04-13','16:50:00',8.68),('6449','2013-04-13','16:55:00',7.63),('6449','2013-04-13','17:00:00',4.31),('6449','2013-04-13','17:05:00',8.56),('6449','2013-04-13','17:10:00',3.99),('6449','2013-04-13','17:15:00',6.31),('6449','2013-04-13','17:20:00',6.02),('6449','2013-04-13','17:25:00',6.48),('6449','2013-04-13','17:30:00',6.23),('6449','2013-04-13','17:35:00',3.97),('6449','2013-04-13','17:40:00',5.27),('6449','2013-04-13','17:45:00',5.54),('6449','2013-04-13','17:50:00',3.14),('6449','2013-04-13','17:55:00',2.63),('6449','2013-04-13','18:00:00',2.42),('6449','2013-04-13','18:05:00',2.14),('6449','2013-04-13','18:10:00',1.64),('6449','2013-04-13','18:15:00',1.28),('6449','2013-04-13','18:20:00',2.59),('6449','2013-04-13','18:25:00',1.79),('6449','2013-04-13','18:30:00',1.62),('6449','2013-04-12','07:40:00',1.33),('6449','2013-04-12','07:45:00',1.34),('6449','2013-04-12','07:50:00',1.61),('6449','2013-04-12','07:55:00',1.06),('6449','2013-04-12','08:00:00',1.06),('6449','2013-04-12','08:05:00',1.22),('6449','2013-04-12','08:10:00',1.3),('6449','2013-04-12','08:15:00',1.42),('6449','2013-04-12','08:20:00',2.07),('6449','2013-04-12','08:25:00',1.93),('6449','2013-04-12','08:30:00',2.52),('6449','2013-04-12','08:35:00',1.63),('6449','2013-04-12','08:40:00',2.01),('6449','2013-04-12','08:45:00',2.65),('6449','2013-04-12','08:50:00',5.77),('6449','2013-04-12','08:55:00',3.96),('6449','2013-04-12','09:00:00',2.43),('6449','2013-04-12','09:05:00',3.34),('6449','2013-04-12','09:10:00',6.87),('6449','2013-04-12','09:15:00',2.91),('6449','2013-04-12','09:20:00',2.49),('6449','2013-04-12','09:25:00',6.73),('6449','2013-04-12','09:30:00',5.28),('6449','2013-04-12','09:35:00',4.32),('6449','2013-04-12','09:40:00',4.35),('6449','2013-04-12','09:45:00',9.36),('6449','2013-04-12','09:50:00',7.2),('6449','2013-04-12','09:55:00',3.42),('6449','2013-04-12','10:00:00',3.45),('6449','2013-04-12','10:05:00',2.65),('6449','2013-04-12','10:10:00',3.14),('6449','2013-04-12','10:15:00',2.73),('6449','2013-04-12','10:20:00',5.32),('6449','2013-04-12','10:25:00',6.21),('6449','2013-04-12','10:30:00',4.37),('6449','2013-04-12','10:35:00',5.54),('6449','2013-04-12','10:40:00',4.42),('6449','2013-04-12','10:45:00',6.2),('6449','2013-04-12','10:50:00',9.75),('6449','2013-04-12','10:55:00',6.95),('6449','2013-04-12','11:00:00',5.83),('6449','2013-04-12','11:05:00',8.08),('6449','2013-04-12','11:10:00',9.69),('6449','2013-04-12','11:15:00',14.4),('6449','2013-04-12','11:20:00',8.54),('6449','2013-04-12','11:25:00',10.65),('6449','2013-04-12','11:30:00',12.45),('6449','2013-04-12','11:35:00',10.91),('6449','2013-04-12','11:40:00',16.3),('6449','2013-04-12','11:45:00',11.8),('6449','2013-04-12','11:50:00',13.62),('6449','2013-04-12','11:55:00',9.72),('6449','2013-04-12','12:00:00',9.31),('6449','2013-04-12','12:05:00',10.07),('6449','2013-04-12','12:10:00',14.68),('6449','2013-04-12','12:15:00',7.59),('6449','2013-04-12','12:20:00',15.46),('6449','2013-04-12','12:25:00',18.05),('6449','2013-04-12','12:30:00',17.86),('6449','2013-04-12','12:35:00',18.32),('6449','2013-04-12','12:40:00',17.07),('6449','2013-04-12','12:45:00',16.94),('6449','2013-04-12','12:50:00',17.1),('6449','2013-04-12','12:55:00',17.15),('6449','2013-04-12','13:00:00',17),('6449','2013-04-12','13:05:00',17.1),('6449','2013-04-12','13:10:00',16.53),('6449','2013-04-12','13:15:00',16.84),('6449','2013-04-12','13:20:00',17.35),('6449','2013-04-12','13:25:00',17.41),('6449','2013-04-12','13:30:00',16.35),('6449','2013-04-12','13:35:00',15.26),('6449','2013-04-12','13:40:00',15.04),('6449','2013-04-12','13:45:00',14.02),('6449','2013-04-12','13:50:00',14.6),('6449','2013-04-12','13:55:00',15.75),('6449','2013-04-12','14:00:00',16.85),('6449','2013-04-12','14:05:00',16.37),('6449','2013-04-12','14:10:00',15.93),('6449','2013-04-12','14:15:00',15.64),('6449','2013-04-12','14:20:00',15.67),('6449','2013-04-12','14:25:00',15.07),('6449','2013-04-12','14:30:00',15.36),('6449','2013-04-12','14:35:00',15.19),('6449','2013-04-12','14:40:00',14.98),('6449','2013-04-12','14:45:00',14.81),('6449','2013-04-12','14:50:00',14.64),('6449','2013-04-12','14:55:00',14.01),('6449','2013-04-12','15:00:00',14.33),('6449','2013-04-12','15:05:00',14.16),('6449','2013-04-12','15:10:00',13.99),('6449','2013-04-12','15:15:00',13.85),('6449','2013-04-12','15:20:00',13.65),('6449','2013-04-12','15:25:00',13.36),('6449','2013-04-12','15:30:00',13.19),('6449','2013-04-12','15:35:00',12.91),('6449','2013-04-12','15:40:00',12.68),('6449','2013-04-12','15:45:00',12.41),('6449','2013-04-12','15:50:00',12.13),('6449','2013-04-12','15:55:00',11.92),('6449','2013-04-12','16:00:00',11.58),('6449','2013-04-12','16:05:00',11.21),('6449','2013-04-12','16:10:00',10.57),('6449','2013-04-12','16:15:00',9.8),('6449','2013-04-12','16:20:00',8.73),('6449','2013-04-12','16:25:00',8.95),('6449','2013-04-12','16:30:00',7.87),('6449','2013-04-12','16:35:00',7.91),('6449','2013-04-12','16:40:00',6.38),('6449','2013-04-12','16:45:00',7.25),('6449','2013-04-12','16:50:00',6.03),('6449','2013-04-12','16:55:00',4.82),('6449','2013-04-12','17:00:00',4.35),('6449','2013-04-12','17:05:00',3.93),('6449','2013-04-12','17:10:00',4),('6449','2013-04-12','17:15:00',4.38),('6449','2013-04-12','17:20:00',5.5),('6449','2013-04-12','17:25:00',6.78),('6449','2013-04-12','17:30:00',5.44),('6449','2013-04-12','17:35:00',3.38),('6449','2013-04-12','17:40:00',2.63),('6449','2013-04-12','17:45:00',2.56),('6449','2013-04-12','17:50:00',2.09),('6449','2013-04-12','17:55:00',1.62),('6449','2013-04-12','18:00:00',1.26),('6449','2013-04-12','18:05:00',1.02),('6449','2013-04-11','07:15:00',1.16),('6449','2013-04-11','07:20:00',1.62),('6449','2013-04-11','07:25:00',1.77),('6449','2013-04-11','07:30:00',1.86),('6449','2013-04-11','07:35:00',2.13),('6449','2013-04-11','07:40:00',2.43),('6449','2013-04-11','07:45:00',2.75),('6449','2013-04-11','07:50:00',3.08),('6449','2013-04-11','07:55:00',3.48),('6449','2013-04-11','08:00:00',3.77),('6449','2013-04-11','08:05:00',4.19),('6449','2013-04-11','08:10:00',4.5),('6449','2013-04-11','08:15:00',4.98),('6449','2013-04-11','08:20:00',5.34),('6449','2013-04-11','08:25:00',5.85),('6449','2013-04-11','08:30:00',6.17),('6449','2013-04-11','08:35:00',6.66),('6449','2013-04-11','08:40:00',7.01),('6449','2013-04-11','08:45:00',7.28),('6449','2013-04-11','08:50:00',7.71),('6449','2013-04-11','08:55:00',8.1),('6449','2013-04-11','09:00:00',8.44),('6449','2013-04-11','09:05:00',8.75),('6449','2013-04-11','09:10:00',9.08),('6449','2013-04-11','09:15:00',9.48),('6449','2013-04-11','09:20:00',9.79),('6449','2013-04-11','09:25:00',10.12),('6449','2013-04-11','09:30:00',10.43),('6449','2013-04-11','09:35:00',10.79),('6449','2013-04-11','09:40:00',11.14),('6449','2013-04-11','09:45:00',11.35),('6449','2013-04-11','09:50:00',11.81),('6449','2013-04-11','09:55:00',11.82),('6449','2013-04-11','10:00:00',10.85),('6449','2013-04-11','10:05:00',5.88),('6449','2013-04-11','10:10:00',10.37),('6449','2013-04-11','10:15:00',12.98),('6449','2013-04-11','10:20:00',9.04),('6449','2013-04-11','10:25:00',13.78),('6449','2013-04-11','10:30:00',9.89),('6449','2013-04-11','10:35:00',6.48),('6449','2013-04-11','10:40:00',4.65),('6449','2013-04-11','10:45:00',3.43),('6449','2013-04-11','10:50:00',8.34),('6449','2013-04-11','10:55:00',15.18),('6449','2013-04-11','11:00:00',15.1),('6449','2013-04-11','11:05:00',15.09),('6449','2013-04-11','11:10:00',15.19),('6449','2013-04-11','11:15:00',15.38),('6449','2013-04-11','11:20:00',15.46),('6449','2013-04-11','11:25:00',15.69),('6449','2013-04-11','11:30:00',15.76),('6449','2013-04-11','11:35:00',15.76),('6449','2013-04-11','11:40:00',16.01),('6449','2013-04-11','11:45:00',15.98),('6449','2013-04-11','11:50:00',16.22),('6449','2013-04-11','11:55:00',14.56),('6449','2013-04-11','12:00:00',14.89),('6449','2013-04-11','12:05:00',16.38),('6449','2013-04-11','12:10:00',16.41),('6449','2013-04-11','12:15:00',16.51),('6449','2013-04-11','12:20:00',16.5),('6449','2013-04-11','12:25:00',16.65),('6449','2013-04-11','12:30:00',16.66),('6449','2013-04-11','12:35:00',16.66),('6449','2013-04-11','12:40:00',16.61),('6449','2013-04-11','12:45:00',16.57),('6449','2013-04-11','12:50:00',16.6),('6449','2013-04-11','12:55:00',16.61),('6449','2013-04-11','13:00:00',16.6),('6449','2013-04-11','13:05:00',16.6),('6449','2013-04-11','13:10:00',16.59),('6449','2013-04-11','13:15:00',16.34),('6449','2013-04-11','13:20:00',16.31),('6449','2013-04-11','13:25:00',16.45),('6449','2013-04-11','13:30:00',16.27),('6449','2013-04-11','13:35:00',16.32),('6449','2013-04-11','13:40:00',16.28),('6449','2013-04-11','13:45:00',16.21),('6449','2013-04-11','13:50:00',15.84),('6449','2013-04-11','13:55:00',16.16),('6449','2013-04-11','14:00:00',16.06),('6449','2013-04-11','14:05:00',16.03),('6449','2013-04-11','14:10:00',15.91),('6449','2013-04-11','14:15:00',15.81),('6449','2013-04-11','14:20:00',15.72),('6449','2013-04-11','14:25:00',15.62),('6449','2013-04-11','14:30:00',15.51),('6449','2013-04-11','14:35:00',15.41),('6449','2013-04-11','14:40:00',15.27),('6449','2013-04-11','14:45:00',15.07),('6449','2013-04-11','14:50:00',14.94),('6449','2013-04-11','14:55:00',14.75),('6449','2013-04-11','15:00:00',14.55),('6449','2013-04-11','15:05:00',14.28),('6449','2013-04-11','15:10:00',14.24),('6449','2013-04-11','15:15:00',13.9),('6449','2013-04-11','15:20:00',13.84),('6449','2013-04-11','15:25:00',13.63),('6449','2013-04-11','15:30:00',13.47),('6449','2013-04-11','15:35:00',13.04),('6449','2013-04-11','15:40:00',13.08),('6449','2013-04-11','15:45:00',12.7),('6449','2013-04-11','15:50:00',12.57),('6449','2013-04-11','15:55:00',12.38),('6449','2013-04-11','16:00:00',12.02),('6449','2013-04-11','16:05:00',11.56),('6449','2013-04-11','16:10:00',11.46),('6449','2013-04-11','16:15:00',11.12),('6449','2013-04-11','16:20:00',10.9),('6449','2013-04-11','16:25:00',10.54),('6449','2013-04-11','16:30:00',10.24),('6449','2013-04-11','16:35:00',9.97),('6449','2013-04-11','16:40:00',9.52),('6449','2013-04-11','16:45:00',9.27),('6449','2013-04-11','16:50:00',8.87),('6449','2013-04-11','16:55:00',8.56),('6449','2013-04-11','17:00:00',8.16),('6449','2013-04-11','17:05:00',7.94),('6449','2013-04-11','17:10:00',7.47),('6449','2013-04-11','17:15:00',7.09),('6449','2013-04-11','17:20:00',6.65),('6449','2013-04-11','17:25:00',6.33),('6449','2013-04-11','17:30:00',5.97),('6449','2013-04-11','17:35:00',5.62),('6449','2013-04-11','17:40:00',5.06),('6449','2013-04-11','17:45:00',4.66),('6449','2013-04-11','17:50:00',4.31),('6449','2013-04-11','17:55:00',3.64),('6449','2013-04-11','18:00:00',3.11),('6449','2013-04-11','18:05:00',3.25),('6449','2013-04-11','18:10:00',2.99),('6449','2013-04-11','18:15:00',2.7),('6449','2013-04-11','18:20:00',2.31),('6449','2013-04-11','18:25:00',2),('6449','2013-04-11','18:30:00',1.67),('6449','2013-04-11','18:35:00',1.32),('6449','2013-04-10','08:25:00',1.95),('6449','2013-04-10','08:30:00',3.17),('6449','2013-04-10','08:35:00',6.33),('6449','2013-04-10','08:40:00',6.66),('6449','2013-04-10','08:45:00',7.26),('6449','2013-04-10','08:50:00',6.41),('6449','2013-04-10','08:55:00',3.08),('6449','2013-04-10','09:00:00',3.14),('6449','2013-04-10','09:05:00',1.78),('6449','2013-04-10','09:10:00',2.39),('6449','2013-04-10','09:15:00',1.53),('6449','2013-04-10','09:20:00',1.8),('6449','2013-04-10','09:25:00',2.31),('6449','2013-04-10','09:30:00',2.56),('6449','2013-04-10','09:35:00',3.65),('6449','2013-04-10','09:40:00',3.63),('6449','2013-04-10','09:45:00',2.17),('6449','2013-04-10','09:50:00',2.6),('6449','2013-04-10','09:55:00',2.05),('6449','2013-04-10','10:00:00',2.55),('6449','2013-04-10','10:05:00',4.9),('6449','2013-04-10','10:10:00',2.9),('6449','2013-04-10','10:15:00',4.47),('6449','2013-04-10','10:20:00',6.57),('6449','2013-04-10','10:25:00',5.92),('6449','2013-04-10','10:30:00',2.89),('6449','2013-04-10','10:35:00',11.09),('6449','2013-04-10','10:40:00',12.39),('6449','2013-04-10','10:45:00',11.37),('6449','2013-04-10','10:50:00',13.67),('6449','2013-04-10','10:55:00',11.7),('6449','2013-04-10','11:00:00',10.68),('6449','2013-04-10','11:05:00',12.84),('6449','2013-04-10','11:10:00',15.39),('6449','2013-04-10','11:15:00',14.68),('6449','2013-04-10','11:20:00',14.15),('6449','2013-04-10','11:25:00',15.47),('6449','2013-04-10','11:30:00',13.94),('6449','2013-04-10','11:35:00',12.47),('6449','2013-04-10','11:40:00',14.82),('6449','2013-04-10','11:45:00',15.07),('6449','2013-04-10','11:50:00',17.52),('6449','2013-04-10','11:55:00',14.33),('6449','2013-04-10','12:00:00',15.28),('6449','2013-04-10','12:05:00',14.15),('6449','2013-04-10','12:10:00',11.65),('6449','2013-04-10','12:15:00',15.51),('6449','2013-04-10','12:20:00',17.4),('6449','2013-04-10','12:25:00',10.91),('6449','2013-04-10','12:30:00',16.59),('6449','2013-04-10','12:35:00',17.14),('6449','2013-04-10','12:40:00',16.34),('6449','2013-04-10','12:45:00',17.05),('6449','2013-04-10','12:50:00',16.76),('6449','2013-04-10','12:55:00',17.38),('6449','2013-04-10','13:00:00',13.6),('6449','2013-04-10','13:05:00',16.72),('6449','2013-04-10','13:10:00',17.58),('6449','2013-04-10','13:15:00',15.88),('6449','2013-04-10','13:20:00',13.86),('6449','2013-04-10','13:25:00',16.82),('6449','2013-04-10','13:30:00',16.44),('6449','2013-04-10','13:35:00',16.65),('6449','2013-04-10','13:40:00',16.47),('6449','2013-04-10','13:45:00',16.62),('6449','2013-04-10','13:50:00',16.21),('6449','2013-04-10','13:55:00',16.11),('6449','2013-04-10','14:00:00',16),('6449','2013-04-10','14:05:00',15.51),('6449','2013-04-10','14:10:00',15.86),('6449','2013-04-10','14:15:00',15.74),('6449','2013-04-10','14:20:00',15.72),('6449','2013-04-10','14:25:00',15.64),('6449','2013-04-10','14:30:00',15.46),('6449','2013-04-10','14:35:00',15.29),('6449','2013-04-10','14:40:00',15.2),('6449','2013-04-10','14:45:00',15.09),('6449','2013-04-10','14:50:00',14.97),('6449','2013-04-10','14:55:00',14.79),('6449','2013-04-10','15:00:00',14.7),('6449','2013-04-10','15:05:00',14.51),('6449','2013-04-10','15:10:00',14.17),('6449','2013-04-10','15:15:00',13.75),('6449','2013-04-10','15:20:00',13.89),('6449','2013-04-10','15:25:00',13.68),('6449','2013-04-10','15:30:00',13.49),('6449','2013-04-10','15:35:00',13.21),('6449','2013-04-10','15:40:00',12.99),('6449','2013-04-10','15:45:00',12.8),('6449','2013-04-10','15:50:00',12.5),('6449','2013-04-10','15:55:00',12.16),('6449','2013-04-10','16:00:00',11.98),('6449','2013-04-10','16:05:00',11.76),('6449','2013-04-10','16:10:00',11.37),('6449','2013-04-10','16:15:00',11.22),('6449','2013-04-10','16:20:00',10.54),('6449','2013-04-10','16:25:00',10.47),('6449','2013-04-10','16:30:00',9.76),('6449','2013-04-10','16:35:00',9.76),('6449','2013-04-10','16:40:00',9.21),('6449','2013-04-10','16:45:00',8.83),('6449','2013-04-10','16:50:00',8.54),('6449','2013-04-10','16:55:00',8.58),('6449','2013-04-10','17:00:00',7.88),('6449','2013-04-10','17:05:00',7.53),('6449','2013-04-10','17:10:00',7.26),('6449','2013-04-10','17:15:00',6.45),('6449','2013-04-10','17:20:00',6.7),('6449','2013-04-10','17:25:00',6.45),('6449','2013-04-10','17:30:00',5.98),('6449','2013-04-10','17:35:00',5.52),('6449','2013-04-10','17:40:00',5.09),('6449','2013-04-10','17:45:00',4.84),('6449','2013-04-10','17:50:00',4.37),('6449','2013-04-10','17:55:00',3.92),('6449','2013-04-10','18:00:00',3.65),('6449','2013-04-10','18:05:00',3.17),('6449','2013-04-10','18:10:00',2.13),('6449','2013-04-10','18:15:00',1.44),('6449','2013-04-10','18:20:00',1.75),('6449','2013-04-10','18:25:00',1.55),('6449','2013-04-10','18:30:00',1.03),('6449','2013-04-10','18:35:00',1.22),('6449','2013-04-10','18:40:00',1.05),('6449','2013-04-09','07:25:00',1.03),('6449','2013-04-09','07:30:00',1.5),('6449','2013-04-09','07:35:00',1.69),('6449','2013-04-09','07:40:00',1.57),('6449','2013-04-09','07:45:00',1.36),('6449','2013-04-09','07:50:00',2.61),('6449','2013-04-09','07:55:00',2.34),('6449','2013-04-09','08:00:00',2.49),('6449','2013-04-09','08:05:00',1.27),('6449','2013-04-09','08:10:00',1.89),('6449','2013-04-09','08:15:00',1.27),('6449','2013-04-09','08:20:00',2.31),('6449','2013-04-09','08:25:00',5.14),('6449','2013-04-09','08:30:00',6.1),('6449','2013-04-09','08:35:00',5.06),('6449','2013-04-09','08:40:00',5.32),('6449','2013-04-09','08:45:00',7.51),('6449','2013-04-09','08:50:00',7.47),('6449','2013-04-09','08:55:00',6.56),('6449','2013-04-09','09:00:00',6.13),('6449','2013-04-09','09:05:00',7.26),('6449','2013-04-09','09:10:00',3.91),('6449','2013-04-09','09:15:00',4.73),('6449','2013-04-09','09:20:00',7.4),('6449','2013-04-09','09:25:00',10.68),('6449','2013-04-09','09:30:00',10.88),('6449','2013-04-09','09:35:00',11.15),('6449','2013-04-09','09:40:00',11.15),('6449','2013-04-09','09:45:00',11.72),('6449','2013-04-09','09:50:00',11.91),('6449','2013-04-09','09:55:00',12.17),('6449','2013-04-09','10:00:00',12.46),('6449','2013-04-09','10:05:00',12.76),('6449','2013-04-09','10:10:00',13.01),('6449','2013-04-09','10:15:00',12.36),('6449','2013-04-09','10:20:00',14.08),('6449','2013-04-09','10:25:00',12.83),('6449','2013-04-09','10:30:00',6.42),('6449','2013-04-09','10:35:00',9.67),('6449','2013-04-09','10:40:00',10.05),('6449','2013-04-09','10:45:00',15.36),('6449','2013-04-09','10:50:00',13.55),('6449','2013-04-09','10:55:00',12.35),('6449','2013-04-09','11:00:00',5.22),('6449','2013-04-09','11:05:00',13.11),('6449','2013-04-09','11:10:00',9.27),('6449','2013-04-09','11:15:00',15.7),('6449','2013-04-09','11:20:00',15.1),('6449','2013-04-09','11:25:00',9.45),('6449','2013-04-09','11:30:00',9),('6449','2013-04-09','11:35:00',9.17),('6449','2013-04-09','11:40:00',12.87),('6449','2013-04-09','11:45:00',14.49),('6449','2013-04-09','11:50:00',16.08),('6449','2013-04-09','11:55:00',10),('6449','2013-04-09','12:00:00',15.58),('6449','2013-04-09','12:05:00',17.4),('6449','2013-04-09','12:10:00',15.08),('6449','2013-04-09','12:15:00',17.33),('6449','2013-04-09','12:20:00',15.55),('6449','2013-04-09','12:25:00',14.87),('6449','2013-04-09','12:30:00',9.72),('6449','2013-04-09','12:35:00',15.23),('6449','2013-04-09','12:40:00',16.8),('6449','2013-04-09','12:45:00',14.34),('6449','2013-04-09','12:50:00',17.47),('6449','2013-04-09','12:55:00',16.4),('6449','2013-04-09','13:00:00',15.58),('6449','2013-04-09','13:05:00',16.38),('6449','2013-04-09','13:10:00',12.85),('6449','2013-04-09','13:15:00',13.97),('6449','2013-04-09','13:20:00',15.8),('6449','2013-04-09','13:25:00',14.64),('6449','2013-04-09','13:30:00',16.15),('6449','2013-04-09','13:35:00',16.66),('6449','2013-04-09','13:40:00',14.74),('6449','2013-04-09','13:45:00',13.27),('6449','2013-04-09','13:50:00',15.9),('6449','2013-04-09','13:55:00',15.99),('6449','2013-04-09','14:00:00',14.72),('6449','2013-04-09','14:05:00',14.3),('6449','2013-04-09','14:10:00',12.43),('6449','2013-04-09','14:15:00',13.72),('6449','2013-04-09','14:20:00',15.12),('6449','2013-04-09','14:25:00',15.2),('6449','2013-04-09','14:30:00',15.21),('6449','2013-04-09','14:35:00',13.76),('6449','2013-04-09','14:40:00',15.44),('6449','2013-04-09','14:45:00',13.12),('6449','2013-04-09','14:50:00',13.89),('6449','2013-04-09','14:55:00',14.58),('6449','2013-04-09','15:00:00',15.19),('6449','2013-04-09','15:05:00',13.83),('6449','2013-04-09','15:10:00',14.49),('6449','2013-04-09','15:15:00',14.59),('6449','2013-04-09','15:20:00',14.62),('6449','2013-04-09','15:25:00',11.98),('6449','2013-04-09','15:30:00',13.87),('6449','2013-04-09','15:35:00',12.58),('6449','2013-04-09','15:40:00',12.94),('6449','2013-04-09','15:45:00',11.2),('6449','2013-04-09','15:50:00',12.6),('6449','2013-04-09','15:55:00',12.82),('6449','2013-04-09','16:00:00',12.05),('6449','2013-04-09','16:05:00',11.39),('6449','2013-04-09','16:10:00',11.7),('6449','2013-04-09','16:15:00',9.69),('6449','2013-04-09','16:20:00',8.76),('6449','2013-04-09','16:25:00',9.31),('6449','2013-04-09','16:30:00',9.52),('6449','2013-04-09','16:35:00',10.37),('6449','2013-04-09','16:40:00',9.42),('6449','2013-04-09','16:45:00',8.26),('6449','2013-04-09','16:50:00',9.54),('6449','2013-04-09','16:55:00',8.99),('6449','2013-04-09','17:00:00',8.5),('6449','2013-04-09','17:05:00',7.51),('6449','2013-04-09','17:10:00',7.57),('6449','2013-04-09','17:15:00',6.36),('6449','2013-04-09','17:20:00',5.85),('6449','2013-04-09','17:25:00',4.9),('6449','2013-04-09','17:30:00',4.84),('6449','2013-04-09','17:35:00',4.26),('6449','2013-04-09','17:40:00',3.37),('6449','2013-04-09','17:45:00',3.67),('6449','2013-04-09','17:50:00',4.78),('6449','2013-04-09','17:55:00',4.22),('6449','2013-04-09','18:00:00',3.99),('6449','2013-04-09','18:05:00',2.84),('6449','2013-04-09','18:10:00',1.93),('6449','2013-04-09','18:15:00',1.73),('6449','2013-04-09','18:20:00',1.8),('6449','2013-04-09','18:25:00',1.57),('6449','2013-04-09','18:30:00',1.31),('6449','2013-04-09','18:35:00',1.19),('6449','2013-04-09','18:40:00',1.1),('6449','2013-04-09','18:45:00',1.25),('6449','2013-04-09','18:50:00',1.03),('6449','2013-04-08','07:25:00',1.32),('6449','2013-04-08','07:30:00',1.16),('6449','2013-04-08','07:35:00',1),('6449','2013-04-08','07:40:00',1.16),('6449','2013-04-08','07:45:00',1.78),('6449','2013-04-08','07:50:00',2.69),('6449','2013-04-08','07:55:00',2.15),('6449','2013-04-08','08:00:00',1.48),('6449','2013-04-08','08:05:00',1.79),('6449','2013-04-08','08:10:00',2.26),('6449','2013-04-08','08:15:00',3.33),('6449','2013-04-08','08:20:00',5.17),('6449','2013-04-08','08:25:00',5.77),('6449','2013-04-08','08:30:00',5.81),('6449','2013-04-08','08:35:00',6.48),('6449','2013-04-08','08:40:00',7.02),('6449','2013-04-08','08:45:00',7.5),('6449','2013-04-08','08:50:00',7.93),('6449','2013-04-08','08:55:00',7.73),('6449','2013-04-08','09:00:00',8.26),('6449','2013-04-08','09:05:00',9.18),('6449','2013-04-08','09:10:00',9.35),('6449','2013-04-08','09:15:00',10.12),('6449','2013-04-08','09:20:00',10.83),('6449','2013-04-08','09:25:00',10.69),('6449','2013-04-08','09:30:00',11.65),('6449','2013-04-08','09:35:00',9.92),('6449','2013-04-08','09:40:00',5.55),('6449','2013-04-08','09:45:00',10.62),('6449','2013-04-08','09:50:00',12.52),('6449','2013-04-08','09:55:00',11.16),('6449','2013-04-08','10:00:00',12.88),('6449','2013-04-08','10:05:00',13.42),('6449','2013-04-08','10:10:00',12.49),('6449','2013-04-08','10:15:00',11.72),('6449','2013-04-08','10:20:00',13.02),('6449','2013-04-08','10:25:00',13.33),('6449','2013-04-08','10:30:00',12.57),('6449','2013-04-08','10:35:00',13.62),('6449','2013-04-08','10:40:00',12.87),('6449','2013-04-08','10:45:00',11.75),('6449','2013-04-08','10:50:00',12.69),('6449','2013-04-08','10:55:00',10.8),('6449','2013-04-08','11:00:00',8.91),('6449','2013-04-08','11:05:00',8.78),('6449','2013-04-08','11:10:00',7.55),('6449','2013-04-08','11:15:00',9.06),('6449','2013-04-08','11:20:00',11.19),('6449','2013-04-08','11:25:00',13.12),('6449','2013-04-08','11:30:00',10.81),('6449','2013-04-08','11:35:00',11.75),('6449','2013-04-08','11:40:00',13.17),('6449','2013-04-08','11:45:00',14.14),('6449','2013-04-08','11:50:00',12.43),('6449','2013-04-08','11:55:00',11.51),('6449','2013-04-08','12:00:00',13.5),('6449','2013-04-08','12:05:00',13.55),('6449','2013-04-08','12:10:00',11.92),('6449','2013-04-08','12:15:00',12.75),('6449','2013-04-08','12:20:00',11.53),('6449','2013-04-08','12:25:00',11.19),('6449','2013-04-08','12:30:00',12.77),('6449','2013-04-08','12:35:00',12.73),('6449','2013-04-08','12:40:00',11.89),('6449','2013-04-08','12:45:00',13.6),('6449','2013-04-08','12:50:00',14.13),('6449','2013-04-08','12:55:00',12.39),('6449','2013-04-08','13:00:00',12.71),('6449','2013-04-08','13:05:00',12.53),('6449','2013-04-08','13:10:00',13.62),('6449','2013-04-08','13:15:00',13.38),('6449','2013-04-08','13:20:00',15.06),('6449','2013-04-08','13:25:00',12.35),('6449','2013-04-08','13:30:00',11.79),('6449','2013-04-08','13:35:00',12.45),('6449','2013-04-08','13:40:00',14.18),('6449','2013-04-08','13:45:00',16.24),('6449','2013-04-08','13:50:00',12.67),('6449','2013-04-08','13:55:00',11.99),('6449','2013-04-08','14:00:00',13.94),('6449','2013-04-08','14:05:00',13.52),('6449','2013-04-08','14:10:00',13.45),('6449','2013-04-08','14:15:00',13.56),('6449','2013-04-08','14:20:00',12.79),('6449','2013-04-08','14:25:00',14.3),('6449','2013-04-08','14:30:00',14.37),('6449','2013-04-08','14:35:00',14.67),('6449','2013-04-08','14:40:00',12.91),('6449','2013-04-08','14:45:00',12.94),('6449','2013-04-08','14:50:00',10.34),('6449','2013-04-08','14:55:00',10.59),('6449','2013-04-08','15:00:00',12.55),('6449','2013-04-08','15:05:00',12.21),('6449','2013-04-08','15:10:00',8.83),('6449','2013-04-08','15:15:00',14.1),('6449','2013-04-08','15:20:00',14.34),('6449','2013-04-08','15:25:00',13.86),('6449','2013-04-08','15:30:00',13.4),('6449','2013-04-08','15:35:00',13.29),('6449','2013-04-08','15:40:00',13.18),('6449','2013-04-08','15:45:00',10.24),('6449','2013-04-08','15:50:00',9.07),('6449','2013-04-08','15:55:00',11.92),('6449','2013-04-08','16:00:00',12.06),('6449','2013-04-08','16:05:00',11.71),('6449','2013-04-08','16:10:00',11.4),('6449','2013-04-08','16:15:00',10.83),('6449','2013-04-08','16:20:00',10.77),('6449','2013-04-08','16:25:00',10.48),('6449','2013-04-08','16:30:00',10.13),('6449','2013-04-08','16:35:00',9.83),('6449','2013-04-08','16:40:00',9.7),('6449','2013-04-08','16:45:00',9.38),('6449','2013-04-08','16:50:00',8.88),('6449','2013-04-08','16:55:00',8.46),('6449','2013-04-08','17:00:00',7.86),('6449','2013-04-08','17:05:00',7.83),('6449','2013-04-08','17:10:00',7.04),('6449','2013-04-08','17:15:00',6.98),('6449','2013-04-08','17:20:00',5.35),('6449','2013-04-08','17:25:00',5.57),('6449','2013-04-08','17:30:00',5.43),('6449','2013-04-08','17:35:00',4.99),('6449','2013-04-08','17:40:00',4.36),('6449','2013-04-08','17:45:00',3.49),('6449','2013-04-08','17:50:00',2.64),('6449','2013-04-08','17:55:00',2.17),('6449','2013-04-08','18:00:00',4.46),('6449','2013-04-08','18:05:00',4.98),('6449','2013-04-08','18:10:00',3.88),('6449','2013-04-08','18:15:00',2.49),('6449','2013-04-08','18:20:00',2.24),('6449','2013-04-08','18:25:00',2.07),('6449','2013-04-08','18:30:00',1.3),('6449','2013-04-08','18:35:00',1.03),('6449','2013-04-07','07:25:00',1.09),('6449','2013-04-07','07:30:00',1.46),('6449','2013-04-07','07:35:00',1.84),('6449','2013-04-07','07:40:00',2.21),('6449','2013-04-07','07:45:00',2.68),('6449','2013-04-07','07:50:00',3.07),('6449','2013-04-07','07:55:00',3.46),('6449','2013-04-07','08:00:00',3.89),('6449','2013-04-07','08:05:00',4.27),('6449','2013-04-07','08:10:00',4.6),('6449','2013-04-07','08:15:00',5.04),('6449','2013-04-07','08:20:00',5.41),('6449','2013-04-07','08:25:00',5.67),('6449','2013-04-07','08:30:00',5.97),('6449','2013-04-07','08:35:00',6.26),('6449','2013-04-07','08:40:00',6.44),('6449','2013-04-07','08:45:00',6.78),('6449','2013-04-07','08:50:00',7.13),('6449','2013-04-07','08:55:00',7.29),('6449','2013-04-07','09:00:00',7.24),('6449','2013-04-07','09:05:00',7.27),('6449','2013-04-07','09:10:00',7.49),('6449','2013-04-07','09:15:00',8.06),('6449','2013-04-07','09:20:00',8.86),('6449','2013-04-07','09:25:00',9.18),('6449','2013-04-07','09:30:00',9.12),('6449','2013-04-07','09:35:00',9.46),('6449','2013-04-07','09:40:00',9.6),('6449','2013-04-07','09:45:00',9.81),('6449','2013-04-07','09:50:00',10.36),('6449','2013-04-07','09:55:00',10.48),('6449','2013-04-07','10:00:00',10.35),('6449','2013-04-07','10:05:00',10.5),('6449','2013-04-07','10:10:00',10.92),('6449','2013-04-07','10:15:00',11.84),('6449','2013-04-07','10:20:00',12.05),('6449','2013-04-07','10:25:00',12.16),('6449','2013-04-07','10:30:00',11.96),('6449','2013-04-07','10:35:00',12.09),('6449','2013-04-07','10:40:00',12.34),('6449','2013-04-07','10:45:00',13.12),('6449','2013-04-07','10:50:00',13.89),('6449','2013-04-07','10:55:00',13.82),('6449','2013-04-07','11:00:00',13.45),('6449','2013-04-07','11:05:00',13.88),('6449','2013-04-07','11:10:00',14.45),('6449','2013-04-07','11:15:00',14.06),('6449','2013-04-07','11:20:00',14.44),('6449','2013-04-07','11:25:00',14.52),('6449','2013-04-07','11:30:00',11.16),('6449','2013-04-07','11:35:00',13.09),('6449','2013-04-07','11:40:00',13),('6449','2013-04-07','11:45:00',13.44),('6449','2013-04-07','11:50:00',11.62),('6449','2013-04-07','11:55:00',11.8),('6449','2013-04-07','12:00:00',13.64),('6449','2013-04-07','12:05:00',14.56),('6449','2013-04-07','12:10:00',14.02),('6449','2013-04-07','12:15:00',13.03),('6449','2013-04-07','12:20:00',12.03),('6449','2013-04-07','12:25:00',12.18),('6449','2013-04-07','12:30:00',12.09),('6449','2013-04-07','12:35:00',11.66),('6449','2013-04-07','12:40:00',11.75),('6449','2013-04-07','12:45:00',10.45),('6449','2013-04-07','12:50:00',10.8),('6449','2013-04-07','12:55:00',11.13),('6449','2013-04-07','13:00:00',10.77),('6449','2013-04-07','13:05:00',10.15),('6449','2013-04-07','13:10:00',10.03),('6449','2013-04-07','13:15:00',10.12),('6449','2013-04-07','13:20:00',10.49),('6449','2013-04-07','13:25:00',10.49),('6449','2013-04-07','13:30:00',10.62),('6449','2013-04-07','13:35:00',10.95),('6449','2013-04-07','13:40:00',11.31),('6449','2013-04-07','13:45:00',11.26),('6449','2013-04-07','13:50:00',11.43),('6449','2013-04-07','13:55:00',11.72),('6449','2013-04-07','14:00:00',12.01),('6449','2013-04-07','14:05:00',12.2),('6449','2013-04-07','14:10:00',12.97),('6449','2013-04-07','14:15:00',12.62),('6449','2013-04-07','14:20:00',12.2),('6449','2013-04-07','14:25:00',11.14),('6449','2013-04-07','14:30:00',10.54),('6449','2013-04-07','14:35:00',9.85),('6449','2013-04-07','14:40:00',9.47),('6449','2013-04-07','14:45:00',9.54),('6449','2013-04-07','14:50:00',10.57),('6449','2013-04-07','14:55:00',11.51),('6449','2013-04-07','15:00:00',11.51),('6449','2013-04-07','15:05:00',11.99),('6449','2013-04-07','15:10:00',12.34),('6449','2013-04-07','15:15:00',12.79),('6449','2013-04-07','15:20:00',13.31),('6449','2013-04-07','15:25:00',13.69),('6449','2013-04-07','15:30:00',13.79),('6449','2013-04-07','15:35:00',13.98),('6449','2013-04-07','15:40:00',13.76),('6449','2013-04-07','15:45:00',13.5),('6449','2013-04-07','15:50:00',13.3),('6449','2013-04-07','15:55:00',12.89),('6449','2013-04-07','16:00:00',12.63),('6449','2013-04-07','16:05:00',12.49),('6449','2013-04-07','16:10:00',12.06),('6449','2013-04-07','16:15:00',11.58),('6449','2013-04-07','16:20:00',11.43),('6449','2013-04-07','16:25:00',11.1),('6449','2013-04-07','16:30:00',10.64),('6449','2013-04-07','16:35:00',10.38),('6449','2013-04-07','16:40:00',9.96),('6449','2013-04-07','16:45:00',9.48),('6449','2013-04-07','16:50:00',9.14),('6449','2013-04-07','16:55:00',8.73),('6449','2013-04-07','17:00:00',8.11),('6449','2013-04-07','17:05:00',4.54),('6449','2013-04-07','17:10:00',3.46),('6449','2013-04-07','17:15:00',1.76),('6449','2013-04-07','17:20:00',1.53),('6449','2013-04-07','17:25:00',1.4),('6449','2013-04-07','17:30:00',1.24),('6449','2013-04-07','17:35:00',1.11),('6449','2013-04-07','17:40:00',1.02),('6449','2013-04-06','07:25:00',1.21),('6449','2013-04-06','07:30:00',1.42),('6449','2013-04-06','07:35:00',1.79),('6449','2013-04-06','07:40:00',2.11),('6449','2013-04-06','07:45:00',2.21),('6449','2013-04-06','07:50:00',2.72),('6449','2013-04-06','07:55:00',3.22),('6449','2013-04-06','08:00:00',3.65),('6449','2013-04-06','08:05:00',4.08),('6449','2013-04-06','08:10:00',4.42),('6449','2013-04-06','08:15:00',4.84),('6449','2013-04-06','08:20:00',5.22),('6449','2013-04-06','08:25:00',5.63),('6449','2013-04-06','08:30:00',6.01),('6449','2013-04-06','08:35:00',6.45),('6449','2013-04-06','08:40:00',6.83),('6449','2013-04-06','08:45:00',7.2),('6449','2013-04-06','08:50:00',7.54),('6449','2013-04-06','08:55:00',8.06),('6449','2013-04-06','09:00:00',8.38),('6449','2013-04-06','09:05:00',8.71),('6449','2013-04-06','09:10:00',9.07),('6449','2013-04-06','09:15:00',9.47),('6449','2013-04-06','09:20:00',10.02),('6449','2013-04-06','09:25:00',10.26),('6449','2013-04-06','09:30:00',11.33),('6449','2013-04-06','09:35:00',11.42),('6449','2013-04-06','09:40:00',11.24),('6449','2013-04-06','09:45:00',11.63),('6449','2013-04-06','09:50:00',11.15),('6449','2013-04-06','09:55:00',10.66),('6449','2013-04-06','10:00:00',12.86),('6449','2013-04-06','10:05:00',12.67),('6449','2013-04-06','10:10:00',12.1),('6449','2013-04-06','10:15:00',11.59),('6449','2013-04-06','10:20:00',13.1),('6449','2013-04-06','10:25:00',13.41),('6449','2013-04-06','10:30:00',13.67),('6449','2013-04-06','10:35:00',13.79),('6449','2013-04-06','10:40:00',13.05),('6449','2013-04-06','10:45:00',14.24),('6449','2013-04-06','10:50:00',15.06),('6449','2013-04-06','10:55:00',14.7),('6449','2013-04-06','11:00:00',15.04),('6449','2013-04-06','11:05:00',14.74),('6449','2013-04-06','11:10:00',10.28),('6449','2013-04-06','11:15:00',5.32),('6449','2013-04-06','11:20:00',8.45),('6449','2013-04-06','11:25:00',12.23),('6449','2013-04-06','11:30:00',10.27),('6449','2013-04-06','11:35:00',16.45),('6449','2013-04-06','11:40:00',16.04),('6449','2013-04-06','11:45:00',16.03),('6449','2013-04-06','11:50:00',16.13),('6449','2013-04-06','11:55:00',16.03),('6449','2013-04-06','12:00:00',16.18),('6449','2013-04-06','12:05:00',16.2),('6449','2013-04-06','12:10:00',16.21),('6449','2013-04-06','12:15:00',16.34),('6449','2013-04-06','12:20:00',16.51),('6449','2013-04-06','12:25:00',16.45),('6449','2013-04-06','12:30:00',16.58),('6449','2013-04-06','12:35:00',16.58),('6449','2013-04-06','12:40:00',16.25),('6449','2013-04-06','12:45:00',16.71),('6449','2013-04-06','12:50:00',16.73),('6449','2013-04-06','12:55:00',16.57),('6449','2013-04-06','13:00:00',16.77),('6449','2013-04-06','13:05:00',16.81),('6449','2013-04-06','13:10:00',16.81),('6449','2013-04-06','13:15:00',16.78),('6449','2013-04-06','13:20:00',16.82),('6449','2013-04-06','13:25:00',16.77),('6449','2013-04-06','13:30:00',16.72),('6449','2013-04-06','13:35:00',16.65),('6449','2013-04-06','13:40:00',16.52),('6449','2013-04-06','13:45:00',16.41),('6449','2013-04-06','13:50:00',16.25),('6449','2013-04-06','13:55:00',15.93),('6449','2013-04-06','14:00:00',16.05),('6449','2013-04-06','14:05:00',15.93),('6449','2013-04-06','14:10:00',15.82),('6449','2013-04-06','14:15:00',15.82),('6449','2013-04-06','14:20:00',15.72),('6449','2013-04-06','14:25:00',15.43),('6449','2013-04-06','14:30:00',15.54),('6449','2013-04-06','14:35:00',15.43),('6449','2013-04-06','14:40:00',15.14),('6449','2013-04-06','14:45:00',15.29),('6449','2013-04-06','14:50:00',15.14),('6449','2013-04-06','14:55:00',14.89),('6449','2013-04-06','15:00:00',14.71),('6449','2013-04-06','15:05:00',14.43),('6449','2013-04-06','15:10:00',14.13),('6449','2013-04-06','15:15:00',13.75),('6449','2013-04-06','15:20:00',13.65),('6449','2013-04-06','15:25:00',13.99),('6449','2013-04-06','15:30:00',13.67),('6449','2013-04-06','15:35:00',13.23),('6449','2013-04-06','15:40:00',11.69),('6449','2013-04-06','15:45:00',11.14),('6449','2013-04-06','15:50:00',10.86),('6449','2013-04-06','15:55:00',11.52),('6449','2013-04-06','16:00:00',12.45),('6449','2013-04-06','16:05:00',12.21),('6449','2013-04-06','16:10:00',11.72),('6449','2013-04-06','16:15:00',10.69),('6449','2013-04-06','16:20:00',11.14),('6449','2013-04-06','16:25:00',10.48),('6449','2013-04-06','16:30:00',9.79),('6449','2013-04-06','16:35:00',8.85),('6449','2013-04-06','16:40:00',7.45),('6449','2013-04-06','16:45:00',5.38),('6449','2013-04-06','16:50:00',7.69),('6449','2013-04-06','16:55:00',9.28),('6449','2013-04-06','17:00:00',9.07),('6449','2013-04-06','17:05:00',7.65),('6449','2013-04-06','17:10:00',6.14),('6449','2013-04-06','17:15:00',6.85),('6449','2013-04-06','17:20:00',8.03),('6449','2013-04-06','17:25:00',6.93),('6449','2013-04-06','17:30:00',5.04),('6449','2013-04-06','17:35:00',4.23),('6449','2013-04-06','17:40:00',3.8),('6449','2013-04-06','17:45:00',3.22),('6449','2013-04-06','17:50:00',2.96),('6449','2013-04-06','17:55:00',2.82),('6449','2013-04-06','18:00:00',2.46),('6449','2013-04-06','18:05:00',2.4),('6449','2013-04-06','18:10:00',2.18),('6449','2013-04-06','18:15:00',2.08),('6449','2013-04-06','18:20:00',1.87),('6449','2013-04-06','18:25:00',1.54),('6449','2013-04-06','18:30:00',1.32),('6449','2013-04-06','18:35:00',1.16),('6449','2013-04-06','18:40:00',1.02),('6449','2013-04-05','07:50:00',1.34),('6449','2013-04-05','07:55:00',1.39),('6449','2013-04-05','08:00:00',1.47),('6449','2013-04-05','08:05:00',2.53),('6449','2013-04-05','08:10:00',3.11),('6449','2013-04-05','08:15:00',2.68),('6449','2013-04-05','08:20:00',3.39),('6449','2013-04-05','08:25:00',4.99),('6449','2013-04-05','08:30:00',3.78),('6449','2013-04-05','08:35:00',3.32),('6449','2013-04-05','08:40:00',6.57),('6449','2013-04-05','08:45:00',8.8),('6449','2013-04-05','08:50:00',7.32),('6449','2013-04-05','08:55:00',8.78),('6449','2013-04-05','09:00:00',5.64),('6449','2013-04-05','09:05:00',8.47),('6449','2013-04-05','09:10:00',7.75),('6449','2013-04-05','09:15:00',7.26),('6449','2013-04-05','09:20:00',7.14),('6449','2013-04-05','09:25:00',10.16),('6449','2013-04-05','09:30:00',7.96),('6449','2013-04-05','09:35:00',2.87),('6449','2013-04-05','09:40:00',3.84),('6449','2013-04-05','09:45:00',6.13),('6449','2013-04-05','09:50:00',8.16),('6449','2013-04-05','09:55:00',12.61),('6449','2013-04-05','10:00:00',11.4),('6449','2013-04-05','10:05:00',12.54),('6449','2013-04-05','10:10:00',13.05),('6449','2013-04-05','10:15:00',13.07),('6449','2013-04-05','10:20:00',13.31),('6449','2013-04-05','10:25:00',13.5),('6449','2013-04-05','10:30:00',13.73),('6449','2013-04-05','10:35:00',13.81),('6449','2013-04-05','10:40:00',14.16),('6449','2013-04-05','10:45:00',14.39),('6449','2013-04-05','10:50:00',14.64),('6449','2013-04-05','10:55:00',14.81),('6449','2013-04-05','11:00:00',15.04),('6449','2013-04-05','11:05:00',14.87),('6449','2013-04-05','11:10:00',10.71),('6449','2013-04-05','11:15:00',11.85),('6449','2013-04-05','11:20:00',11.4),('6449','2013-04-05','11:25:00',15.52),('6449','2013-04-05','11:30:00',16.51),('6449','2013-04-05','11:35:00',16.54),('6449','2013-04-05','11:40:00',16.25),('6449','2013-04-05','11:45:00',16.4),('6449','2013-04-05','11:50:00',16.23),('6449','2013-04-05','11:55:00',16.45),('6449','2013-04-05','12:00:00',16.53),('6449','2013-04-05','12:05:00',17.01),('6449','2013-04-05','12:10:00',16.47),('6449','2013-04-05','12:15:00',11.92),('6449','2013-04-05','12:20:00',13.45),('6449','2013-04-05','12:25:00',18.19),('6449','2013-04-05','12:30:00',13.5),('6449','2013-04-05','12:35:00',8.03),('6449','2013-04-05','12:40:00',16.02),('6449','2013-04-05','12:45:00',16.9),('6449','2013-04-05','12:50:00',11.64),('6449','2013-04-05','12:55:00',13.37),('6449','2013-04-05','13:00:00',16.29),('6449','2013-04-05','13:05:00',16.75),('6449','2013-04-05','13:10:00',17.01),('6449','2013-04-05','13:15:00',16.98),('6449','2013-04-05','13:20:00',17.01),('6449','2013-04-05','13:25:00',17.09),('6449','2013-04-05','13:30:00',8.52),('6449','2013-04-05','13:35:00',8.77),('6449','2013-04-05','13:40:00',14.57),('6449','2013-04-05','13:45:00',17.74),('6449','2013-04-05','13:50:00',8.29),('6449','2013-04-05','13:55:00',6.2),('6449','2013-04-05','14:00:00',6.8),('6449','2013-04-05','14:05:00',5.58),('6449','2013-04-05','14:10:00',4.76),('6449','2013-04-05','14:15:00',4.31),('6449','2013-04-05','14:20:00',3.77),('6449','2013-04-05','14:25:00',3.88),('6449','2013-04-05','14:30:00',4.15),('6449','2013-04-05','14:35:00',3.95),('6449','2013-04-05','14:40:00',5.52),('6449','2013-04-05','14:45:00',5.07),('6449','2013-04-05','14:50:00',3.96),('6449','2013-04-05','14:55:00',5.46),('6449','2013-04-05','15:00:00',5.04),('6449','2013-04-05','15:05:00',4.96),('6449','2013-04-05','15:10:00',6.36),('6449','2013-04-05','15:15:00',4.68),('6449','2013-04-05','15:20:00',6.58),('6449','2013-04-05','15:25:00',5.6),('6449','2013-04-05','15:30:00',5.83),('6449','2013-04-05','15:35:00',4.41),('6449','2013-04-05','15:40:00',3.91),('6449','2013-04-05','15:45:00',4.5),('6449','2013-04-05','15:50:00',4.31),('6449','2013-04-05','15:55:00',10.91),('6449','2013-04-05','16:00:00',12.02),('6449','2013-04-05','16:05:00',13.45),('6449','2013-04-05','16:10:00',12.58),('6449','2013-04-05','16:15:00',12),('6449','2013-04-05','16:20:00',11.19),('6449','2013-04-05','16:25:00',9.81),('6449','2013-04-05','16:30:00',10.17),('6449','2013-04-05','16:35:00',10.02),('6449','2013-04-05','16:40:00',9.55),('6449','2013-04-05','16:45:00',9.33),('6449','2013-04-05','16:50:00',8.97),('6449','2013-04-05','16:55:00',8.62),('6449','2013-04-05','17:00:00',7.92),('6449','2013-04-05','17:05:00',8.47),('6449','2013-04-05','17:10:00',7.76),('6449','2013-04-05','17:15:00',6.82),('6449','2013-04-05','17:20:00',6.77),('6449','2013-04-05','17:25:00',6.24),('6449','2013-04-05','17:30:00',5.89),('6449','2013-04-05','17:35:00',5.47),('6449','2013-04-05','17:40:00',5.1),('6449','2013-04-05','17:45:00',4.75),('6449','2013-04-05','17:50:00',4.41),('6449','2013-04-05','17:55:00',3.94),('6449','2013-04-05','18:00:00',3.57),('6449','2013-04-05','18:05:00',3.15),('6449','2013-04-05','18:10:00',2.84),('6449','2013-04-05','18:15:00',2.48),('6449','2013-04-05','18:20:00',2.14),('6449','2013-04-05','18:25:00',1.82),('6449','2013-04-05','18:30:00',1.54),('6449','2013-04-05','18:35:00',1.25),('6449','2013-04-05','18:40:00',1),('6449','2013-04-04','08:00:00',1.32),('6449','2013-04-04','08:05:00',1.49),('6449','2013-04-04','08:10:00',1.79),('6449','2013-04-04','08:15:00',2.07),('6449','2013-04-04','08:20:00',2.28),('6449','2013-04-04','08:25:00',2.61),('6449','2013-04-04','08:30:00',2.29),('6449','2013-04-04','08:35:00',2.94),('6449','2013-04-04','08:40:00',3.27),('6449','2013-04-04','08:45:00',3),('6449','2013-04-04','08:50:00',2.53),('6449','2013-04-04','08:55:00',2.63),('6449','2013-04-04','09:00:00',2.85),('6449','2013-04-04','09:05:00',2.63),('6449','2013-04-04','09:10:00',1.74),('6449','2013-04-04','09:15:00',1.4),('6449','2013-04-04','09:20:00',1.67),('6449','2013-04-04','09:25:00',2.18),('6449','2013-04-04','09:30:00',2.71),('6449','2013-04-04','09:35:00',3.41),('6449','2013-04-04','09:40:00',4.1),('6449','2013-04-04','09:45:00',3.95),('6449','2013-04-04','09:50:00',3.89),('6449','2013-04-04','09:55:00',3.9),('6449','2013-04-04','10:00:00',3.68),('6449','2013-04-04','10:05:00',4.74),('6449','2013-04-04','10:10:00',7.22),('6449','2013-04-04','10:15:00',6.68),('6449','2013-04-04','10:20:00',6.38),('6449','2013-04-04','10:25:00',5.78),('6449','2013-04-04','10:30:00',4.87),('6449','2013-04-04','10:35:00',5.72),('6449','2013-04-04','10:40:00',8.02),('6449','2013-04-04','10:45:00',8.02),('6449','2013-04-04','10:50:00',5.21),('6449','2013-04-04','10:55:00',4.43),('6449','2013-04-04','11:00:00',3.36),('6449','2013-04-04','11:05:00',3.19),('6449','2013-04-04','11:10:00',3.02),('6449','2013-04-04','11:15:00',2.65),('6449','2013-04-04','11:20:00',3.41),('6449','2013-04-04','11:25:00',4.27),('6449','2013-04-04','11:30:00',6.24),('6449','2013-04-04','11:35:00',7.86),('6449','2013-04-04','11:40:00',6.83),('6449','2013-04-04','11:45:00',6.53),('6449','2013-04-04','11:50:00',8.03),('6449','2013-04-04','11:55:00',11.44),('6449','2013-04-04','12:00:00',14.28),('6449','2013-04-04','12:05:00',12.99),('6449','2013-04-04','12:10:00',13.45),('6449','2013-04-04','12:15:00',11.73),('6449','2013-04-04','12:20:00',9.42),('6449','2013-04-04','12:25:00',15.14),('6449','2013-04-04','12:30:00',9.82),('6449','2013-04-04','12:35:00',6.66),('6449','2013-04-04','12:40:00',7.01),('6449','2013-04-04','12:45:00',12.34),('6449','2013-04-04','12:50:00',7.91),('6449','2013-04-04','12:55:00',6.65),('6449','2013-04-04','13:00:00',11.27),('6449','2013-04-04','13:05:00',7.75),('6449','2013-04-04','13:10:00',4.83),('6449','2013-04-04','13:15:00',7.02),('6449','2013-04-04','13:20:00',15.46),('6449','2013-04-04','13:25:00',9.39),('6449','2013-04-04','13:30:00',4.59),('6449','2013-04-04','13:35:00',7.65),('6449','2013-04-04','13:40:00',6.12),('6449','2013-04-04','13:45:00',7.04),('6449','2013-04-04','13:50:00',5.16),('6449','2013-04-04','13:55:00',6.92),('6449','2013-04-04','14:00:00',7.6),('6449','2013-04-04','14:05:00',8.69),('6449','2013-04-04','14:10:00',9.99),('6449','2013-04-04','14:15:00',8.03),('6449','2013-04-04','14:20:00',14.89),('6449','2013-04-04','14:25:00',14.99),('6449','2013-04-04','14:30:00',14.92),('6449','2013-04-04','14:35:00',14.94),('6449','2013-04-04','14:40:00',8.05),('6449','2013-04-04','14:45:00',10.88),('6449','2013-04-04','14:50:00',13.26),('6449','2013-04-04','14:55:00',14.2),('6449','2013-04-04','15:00:00',13.4),('6449','2013-04-04','15:05:00',13.33),('6449','2013-04-04','15:10:00',9.51),('6449','2013-04-04','15:15:00',12.4),('6449','2013-04-04','15:20:00',10.55),('6449','2013-04-04','15:25:00',9.16),('6449','2013-04-04','15:30:00',10.86),('6449','2013-04-04','15:35:00',11.57),('6449','2013-04-04','15:40:00',11.48),('6449','2013-04-04','15:45:00',11.34),('6449','2013-04-04','15:50:00',10.94),('6449','2013-04-04','15:55:00',9.53),('6449','2013-04-04','16:00:00',8.98),('6449','2013-04-04','16:05:00',8.9),('6449','2013-04-04','16:10:00',6.72),('6449','2013-04-04','16:15:00',7.4),('6449','2013-04-04','16:20:00',5.87),('6449','2013-04-04','16:25:00',7.27),('6449','2013-04-04','16:30:00',7.36),('6449','2013-04-04','16:35:00',5.14),('6449','2013-04-04','16:40:00',5.52),('6449','2013-04-04','16:45:00',6.68),('6449','2013-04-04','16:50:00',5.71),('6449','2013-04-04','16:55:00',5.56),('6449','2013-04-04','17:00:00',5.51),('6449','2013-04-04','17:05:00',4.81),('6449','2013-04-04','17:10:00',4.32),('6449','2013-04-04','17:15:00',4.45),('6449','2013-04-04','17:20:00',4.06),('6449','2013-04-04','17:25:00',3.6),('6449','2013-04-04','17:30:00',4.24),('6449','2013-04-04','17:35:00',3.69),('6449','2013-04-04','17:40:00',3.31),('6449','2013-04-04','17:45:00',2.99),('6449','2013-04-04','17:50:00',3.3),('6449','2013-04-04','17:55:00',2.45),('6449','2013-04-04','18:00:00',2.35),('6449','2013-04-04','18:05:00',1.96),('6449','2013-04-04','18:10:00',1.48),('6449','2013-04-04','18:15:00',1.43),('6449','2013-04-04','18:20:00',1.27),('6449','2013-04-04','18:25:00',1.14),('6449','2013-04-03','07:20:00',1.02),('6449','2013-04-03','07:25:00',1.11),('6449','2013-04-03','07:30:00',1.61),('6449','2013-04-03','07:35:00',2.14),('6449','2013-04-03','07:40:00',2.86),('6449','2013-04-03','07:45:00',2.98),('6449','2013-04-03','07:50:00',3.57),('6449','2013-04-03','07:55:00',2.65),('6449','2013-04-03','08:00:00',1.79),('6449','2013-04-03','08:05:00',2.09),('6449','2013-04-03','08:10:00',3.44),('6449','2013-04-03','08:15:00',4.06),('6449','2013-04-03','08:20:00',5.1),('6449','2013-04-03','08:25:00',5.65),('6449','2013-04-03','08:30:00',5.97),('6449','2013-04-03','08:35:00',6.52),('6449','2013-04-03','08:40:00',7.41),('6449','2013-04-03','08:45:00',8.48),('6449','2013-04-03','08:50:00',9.09),('6449','2013-04-03','08:55:00',9.2),('6449','2013-04-03','09:00:00',8.3),('6449','2013-04-03','09:05:00',7.39),('6449','2013-04-03','09:10:00',9.11),('6449','2013-04-03','09:15:00',9.42),('6449','2013-04-03','09:20:00',9.71),('6449','2013-04-03','09:25:00',10.04),('6449','2013-04-03','09:30:00',11.48),('6449','2013-04-03','09:35:00',10.66),('6449','2013-04-03','09:40:00',8.74),('6449','2013-04-03','09:45:00',4.62),('6449','2013-04-03','09:50:00',4.7),('6449','2013-04-03','09:55:00',3.4),('6449','2013-04-03','10:00:00',4.35),('6449','2013-04-03','10:05:00',6.65),('6449','2013-04-03','10:10:00',15.4),('6449','2013-04-03','10:15:00',10.26),('6449','2013-04-03','10:20:00',9.19),('6449','2013-04-03','10:25:00',8.52),('6449','2013-04-03','10:30:00',14.69),('6449','2013-04-03','10:35:00',11.24),('6449','2013-04-03','10:40:00',7.35),('6449','2013-04-03','10:45:00',7.65),('6449','2013-04-03','10:50:00',11.9),('6449','2013-04-03','10:55:00',16.61),('6449','2013-04-03','11:00:00',16.04),('6449','2013-04-03','11:05:00',14.72),('6449','2013-04-03','11:10:00',14.5),('6449','2013-04-03','11:15:00',16.61),('6449','2013-04-03','11:20:00',16.01),('6449','2013-04-03','11:25:00',15.99),('6449','2013-04-03','11:30:00',16.05),('6449','2013-04-03','11:35:00',16.22),('6449','2013-04-03','11:40:00',12.47),('6449','2013-04-03','11:45:00',14.99),('6449','2013-04-03','11:50:00',17.5),('6449','2013-04-03','11:55:00',16.78),('6449','2013-04-03','12:00:00',17.01),('6449','2013-04-03','12:05:00',11.8),('6449','2013-04-03','12:10:00',15.65),('6449','2013-04-03','12:15:00',17.63),('6449','2013-04-03','12:20:00',17.15),('6449','2013-04-03','12:25:00',16.97),('6449','2013-04-03','12:30:00',16.14),('6449','2013-04-03','12:35:00',14.98),('6449','2013-04-03','12:40:00',10.33),('6449','2013-04-03','12:45:00',10.38),('6449','2013-04-03','12:50:00',17.24),('6449','2013-04-03','12:55:00',15.27),('6449','2013-04-03','13:00:00',16.71),('6449','2013-04-03','13:05:00',19.42),('6449','2013-04-03','13:10:00',18.59),('6449','2013-04-03','13:15:00',18.78),('6449','2013-04-03','13:20:00',17.62),('6449','2013-04-03','13:25:00',18.11),('6449','2013-04-03','13:30:00',17.81),('6449','2013-04-03','13:35:00',17.48),('6449','2013-04-03','13:40:00',17.75),('6449','2013-04-03','13:45:00',16.08),('6449','2013-04-03','13:50:00',16.35),('6449','2013-04-03','13:55:00',15.86),('6449','2013-04-03','14:00:00',18),('6449','2013-04-03','14:05:00',18.4),('6449','2013-04-03','14:10:00',17.57),('6449','2013-04-03','14:15:00',16.62),('6449','2013-04-03','14:20:00',16.59),('6449','2013-04-03','14:25:00',8.18),('6449','2013-04-03','14:30:00',15.32),('6449','2013-04-03','14:35:00',17.46),('6449','2013-04-03','14:40:00',16.65),('6449','2013-04-03','14:45:00',16.69),('6449','2013-04-03','14:50:00',12.87),('6449','2013-04-03','14:55:00',15.86),('6449','2013-04-03','15:00:00',15.53),('6449','2013-04-03','15:05:00',15.26),('6449','2013-04-03','15:10:00',14.91),('6449','2013-04-03','15:15:00',14.78),('6449','2013-04-03','15:20:00',14.64),('6449','2013-04-03','15:25:00',14.79),('6449','2013-04-03','15:30:00',13.99),('6449','2013-04-03','15:35:00',14.43),('6449','2013-04-03','15:40:00',13.91),('6449','2013-04-03','15:45:00',14.57),('6449','2013-04-03','15:50:00',14.28),('6449','2013-04-03','15:55:00',11.82),('6449','2013-04-03','16:00:00',12.48),('6449','2013-04-03','16:05:00',12.21),('6449','2013-04-03','16:10:00',11.97),('6449','2013-04-03','16:15:00',11.66),('6449','2013-04-03','16:20:00',11.25),('6449','2013-04-03','16:25:00',10.95),('6449','2013-04-03','16:30:00',10.56),('6449','2013-04-03','16:35:00',10.2),('6449','2013-04-03','16:40:00',9.84),('6449','2013-04-03','16:45:00',9.55),('6449','2013-04-03','16:50:00',9.16),('6449','2013-04-03','16:55:00',8.82),('6449','2013-04-03','17:00:00',8.44),('6449','2013-04-03','17:05:00',8),('6449','2013-04-03','17:10:00',7.72),('6449','2013-04-03','17:15:00',7.6),('6449','2013-04-03','17:20:00',7.05),('6449','2013-04-03','17:25:00',6.48),('6449','2013-04-03','17:30:00',6.13),('6449','2013-04-03','17:35:00',5.6),('6449','2013-04-03','17:40:00',5.24),('6449','2013-04-03','17:45:00',4.81),('6449','2013-04-03','17:50:00',4.37),('6449','2013-04-03','17:55:00',3.95),('6449','2013-04-03','18:00:00',3.57),('6449','2013-04-03','18:05:00',3.17),('6449','2013-04-03','18:10:00',2.85),('6449','2013-04-03','18:15:00',2.47),('6449','2013-04-03','18:20:00',2.1),('6449','2013-04-03','18:25:00',1.79),('6449','2013-04-03','18:30:00',1.48),('6449','2013-04-03','18:35:00',1.21),('6449','2013-04-02','07:55:00',1.04),('6449','2013-04-02','08:00:00',1.31),('6449','2013-04-02','08:10:00',1.13),('6449','2013-04-02','08:15:00',1.76),('6449','2013-04-02','08:20:00',3.62),('6449','2013-04-02','08:25:00',3.44),('6449','2013-04-02','08:30:00',1.87),('6449','2013-04-02','08:35:00',1.19),('6449','2013-04-02','08:40:00',1.12),('6449','2013-04-02','08:45:00',2.97),('6449','2013-04-02','08:50:00',7.78),('6449','2013-04-02','08:55:00',5.38),('6449','2013-04-02','09:00:00',7.09),('6449','2013-04-02','09:05:00',9.44),('6449','2013-04-02','09:10:00',9.25),('6449','2013-04-02','09:15:00',9.32),('6449','2013-04-02','09:20:00',9.66),('6449','2013-04-02','09:25:00',9.73),('6449','2013-04-02','09:30:00',10.31),('6449','2013-04-02','09:35:00',10.75),('6449','2013-04-02','09:40:00',11.15),('6449','2013-04-02','09:45:00',11.21),('6449','2013-04-02','09:50:00',10.18),('6449','2013-04-02','09:55:00',9.36),('6449','2013-04-02','10:00:00',13),('6449','2013-04-02','10:05:00',12.66),('6449','2013-04-02','10:10:00',12.86),('6449','2013-04-02','10:15:00',11.61),('6449','2013-04-02','10:20:00',13.81),('6449','2013-04-02','10:25:00',13.25),('6449','2013-04-02','10:30:00',14.34),('6449','2013-04-02','10:35:00',14.22),('6449','2013-04-02','10:40:00',14.46),('6449','2013-04-02','10:45:00',14.33),('6449','2013-04-02','10:50:00',15.6),('6449','2013-04-02','10:55:00',11.16),('6449','2013-04-02','11:00:00',10.9),('6449','2013-04-02','11:05:00',4.96),('6449','2013-04-02','11:10:00',11.81),('6449','2013-04-02','11:15:00',18.81),('6449','2013-04-02','11:20:00',17.22),('6449','2013-04-02','11:25:00',4.14),('6449','2013-04-02','11:30:00',2.17),('6449','2013-04-02','11:35:00',1.78),('6449','2013-04-02','11:40:00',5.82),('6449','2013-04-02','11:45:00',12.78),('6449','2013-04-02','11:50:00',17.6),('6449','2013-04-02','11:55:00',11.32),('6449','2013-04-02','12:00:00',4.71),('6449','2013-04-02','12:05:00',3.52),('6449','2013-04-02','12:10:00',4.17),('6449','2013-04-02','12:15:00',1.82),('6449','2013-04-02','12:20:00',3.38),('6449','2013-04-02','12:25:00',11.08),('6449','2013-04-02','12:30:00',5.56),('6449','2013-04-02','12:35:00',7.74),('6449','2013-04-02','12:40:00',11.52),('6449','2013-04-02','12:45:00',7.38),('6449','2013-04-02','12:50:00',6.27),('6449','2013-04-02','12:55:00',7.85),('6449','2013-04-02','13:00:00',9.02),('6449','2013-04-02','13:05:00',6.08),('6449','2013-04-02','13:10:00',3.95),('6449','2013-04-02','13:15:00',4.58),('6449','2013-04-02','13:20:00',4.07),('6449','2013-04-02','13:25:00',4.12),('6449','2013-04-02','13:30:00',9.45),('6449','2013-04-02','13:35:00',7.77),('6449','2013-04-02','13:40:00',12.4),('6449','2013-04-02','13:45:00',20),('6449','2013-04-02','13:50:00',18.33),('6449','2013-04-02','13:55:00',17.18),('6449','2013-04-02','14:00:00',13.59),('6449','2013-04-02','14:05:00',14.75),('6449','2013-04-02','14:10:00',4.09),('6449','2013-04-02','14:15:00',3.39),('6449','2013-04-02','14:20:00',11.91),('6449','2013-04-02','14:25:00',15.7),('6449','2013-04-02','14:30:00',8.25),('6449','2013-04-02','14:35:00',5.89),('6449','2013-04-02','14:40:00',3.11),('6449','2013-04-02','14:45:00',2.02),('6449','2013-04-02','14:50:00',1.62),('6449','2013-04-02','14:55:00',3.68),('6449','2013-04-02','15:00:00',6.22),('6449','2013-04-02','15:05:00',4.38),('6449','2013-04-02','15:10:00',4.03),('6449','2013-04-02','15:15:00',3.6),('6449','2013-04-02','15:20:00',2.95),('6449','2013-04-02','15:25:00',1.84),('6449','2013-04-02','15:30:00',1.63),('6449','2013-04-02','15:35:00',1.31),('6449','2013-04-02','15:40:00',1.14),('6449','2013-04-02','15:45:00',1.15),('6449','2013-04-02','15:50:00',1.36),('6449','2013-04-02','15:55:00',1.61),('6449','2013-04-02','16:00:00',2.2),('6449','2013-04-02','16:05:00',2.61),('6449','2013-04-02','16:10:00',2.39),('6449','2013-04-02','16:15:00',2.55),('6449','2013-04-02','16:20:00',3.48),('6449','2013-04-02','16:25:00',4.57),('6449','2013-04-02','16:30:00',3.98),('6449','2013-04-02','16:35:00',3.18),('6449','2013-04-02','16:40:00',2.27),('6449','2013-04-02','16:45:00',1.56),('6449','2013-04-02','17:15:00',1.04),('6449','2013-04-01','07:30:00',1.14),('6449','2013-04-01','07:35:00',1.48),('6449','2013-04-01','07:40:00',1.78),('6449','2013-04-01','07:45:00',1.87),('6449','2013-04-01','07:50:00',1.33),('6449','2013-04-01','07:55:00',2.68),('6449','2013-04-01','08:00:00',3.55),('6449','2013-04-01','08:05:00',4.15),('6449','2013-04-01','08:10:00',5.02),('6449','2013-04-01','08:15:00',5.48),('6449','2013-04-01','08:20:00',2.9),('6449','2013-04-01','08:25:00',4.23),('6449','2013-04-01','08:30:00',7.41),('6449','2013-04-01','08:35:00',6.05),('6449','2013-04-01','08:40:00',2.06),('6449','2013-04-01','08:45:00',2.13),('6449','2013-04-01','08:50:00',4.35),('6449','2013-04-01','08:55:00',3.69),('6449','2013-04-01','09:00:00',4.3),('6449','2013-04-01','09:05:00',3.63),('6449','2013-04-01','09:10:00',2.31),('6449','2013-04-01','09:15:00',2.66),('6449','2013-04-01','09:20:00',3.68),('6449','2013-04-01','09:25:00',5.1),('6449','2013-04-01','09:30:00',7.18),('6449','2013-04-01','09:35:00',9.47),('6449','2013-04-01','09:40:00',4.22),('6449','2013-04-01','09:45:00',4.22),('6449','2013-04-01','09:50:00',8.97),('6449','2013-04-01','09:55:00',11.37),('6449','2013-04-01','10:00:00',13.41),('6449','2013-04-01','10:05:00',8.26),('6449','2013-04-01','10:10:00',7.95),('6449','2013-04-01','10:15:00',12.47),('6449','2013-04-01','10:20:00',9.93),('6449','2013-04-01','10:25:00',9.6),('6449','2013-04-01','10:30:00',10.95),('6449','2013-04-01','10:35:00',10.32),('6449','2013-04-01','10:40:00',9.07),('6449','2013-04-01','10:45:00',8.18),('6449','2013-04-01','10:50:00',9.87),('6449','2013-04-01','10:55:00',6.46),('6449','2013-04-01','11:00:00',9.19),('6449','2013-04-01','11:05:00',11.92),('6449','2013-04-01','11:10:00',7.71),('6449','2013-04-01','11:15:00',7.96),('6449','2013-04-01','11:20:00',8.49),('6449','2013-04-01','11:25:00',9.16),('6449','2013-04-01','11:30:00',9.34),('6449','2013-04-01','11:35:00',10.87),('6449','2013-04-01','11:40:00',10.98),('6449','2013-04-01','11:45:00',12.51),('6449','2013-04-01','11:50:00',11.56),('6449','2013-04-01','11:55:00',10.3),('6449','2013-04-01','12:00:00',7.96),('6449','2013-04-01','12:05:00',6.9),('6449','2013-04-01','12:10:00',9.46),('6449','2013-04-01','12:15:00',11.9),('6449','2013-04-01','12:20:00',12.21),('6449','2013-04-01','12:25:00',8.51),('6449','2013-04-01','12:30:00',6.88),('6449','2013-04-01','12:35:00',6.78),('6449','2013-04-01','12:40:00',7.6),('6449','2013-04-01','12:45:00',8.59),('6449','2013-04-01','12:50:00',8.76),('6449','2013-04-01','12:55:00',10.33),('6449','2013-04-01','13:00:00',10.1),('6449','2013-04-01','13:05:00',8.77),('6449','2013-04-01','13:10:00',11.58),('6449','2013-04-01','13:15:00',10.7),('6449','2013-04-01','13:20:00',9.23),('6449','2013-04-01','13:25:00',6.66),('6449','2013-04-01','13:30:00',6.24),('6449','2013-04-01','13:35:00',7.04),('6449','2013-04-01','13:40:00',8.07),('6449','2013-04-01','13:45:00',6.66),('6449','2013-04-01','13:50:00',6.2),('6449','2013-04-01','13:55:00',8.45),('6449','2013-04-01','14:00:00',11.65),('6449','2013-04-01','14:05:00',11.19),('6449','2013-04-01','14:10:00',10.42),('6449','2013-04-01','14:15:00',6.91),('6449','2013-04-01','14:20:00',8.71),('6449','2013-04-01','14:25:00',9.97),('6449','2013-04-01','14:30:00',7.73),('6449','2013-04-01','14:35:00',6.32),('6449','2013-04-01','14:40:00',5.21),('6449','2013-04-01','14:45:00',6.13),('6449','2013-04-01','14:50:00',6.71),('6449','2013-04-01','14:55:00',6.02),('6449','2013-04-01','15:00:00',6.11),('6449','2013-04-01','15:05:00',5.43),('6449','2013-04-01','15:10:00',4.15),('6449','2013-04-01','15:15:00',3.85),('6449','2013-04-01','15:20:00',5.14),('6449','2013-04-01','15:25:00',5.96),('6449','2013-04-01','15:30:00',4.76),('6449','2013-04-01','15:35:00',4.21),('6449','2013-04-01','15:40:00',4.62),('6449','2013-04-01','15:45:00',6),('6449','2013-04-01','15:50:00',7.55),('6449','2013-04-01','15:55:00',6.87),('6449','2013-04-01','16:00:00',6.19),('6449','2013-04-01','16:05:00',5.76),('6449','2013-04-01','16:10:00',3.95),('6449','2013-04-01','16:15:00',3.15),('6449','2013-04-01','16:20:00',2.72),('6449','2013-04-01','16:25:00',2.74),('6449','2013-04-01','16:30:00',2.84),('6449','2013-04-01','16:35:00',2.25),('6449','2013-04-01','16:40:00',1.87),('6449','2013-04-01','16:45:00',1.33),('6449','2013-04-01','17:15:00',1.02),('6449','2013-04-01','17:20:00',1.11),('6449','2013-04-01','17:25:00',1.06),('6449','2013-03-31','08:20:00',1.27),('6449','2013-03-31','08:25:00',1.44),('6449','2013-03-31','08:30:00',1.37),('6449','2013-03-31','08:35:00',1.6),('6449','2013-03-31','08:40:00',2.08),('6449','2013-03-31','08:45:00',3.08),('6449','2013-03-31','08:50:00',1.52),('6449','2013-03-31','08:55:00',1.64),('6449','2013-03-31','09:00:00',2.01),('6449','2013-03-31','09:05:00',3.08),('6449','2013-03-31','09:10:00',4.06),('6449','2013-03-31','09:15:00',3.72),('6449','2013-03-31','09:20:00',6.05),('6449','2013-03-31','09:25:00',4.06),('6449','2013-03-31','09:30:00',3.01),('6449','2013-03-31','09:35:00',3.83),('6449','2013-03-31','09:40:00',5.59),('6449','2013-03-31','09:45:00',4.17),('6449','2013-03-31','09:50:00',4.86),('6449','2013-03-31','09:55:00',4.26),('6449','2013-03-31','10:00:00',4.34),('6449','2013-03-31','10:05:00',13.03),('6449','2013-03-31','10:10:00',5.77),('6449','2013-03-31','10:15:00',4.65),('6449','2013-03-31','10:20:00',3.52),('6449','2013-03-31','10:25:00',2.99),('6449','2013-03-31','10:30:00',3.48),('6449','2013-03-31','10:35:00',4.81),('6449','2013-03-31','10:40:00',4.69),('6449','2013-03-31','10:45:00',3.16),('6449','2013-03-31','10:50:00',2.56),('6449','2013-03-31','10:55:00',3.37),('6449','2013-03-31','11:00:00',3.21),('6449','2013-03-31','11:05:00',3.33),('6449','2013-03-31','11:10:00',4.76),('6449','2013-03-31','11:15:00',4.42),('6449','2013-03-31','11:20:00',4.25),('6449','2013-03-31','11:25:00',3.64),('6449','2013-03-31','11:30:00',3.13),('6449','2013-03-31','11:35:00',3.64),('6449','2013-03-31','11:40:00',5.7),('6449','2013-03-31','11:45:00',4.34),('6449','2013-03-31','11:50:00',4.83),('6449','2013-03-31','11:55:00',4.06),('6449','2013-03-31','12:00:00',4.1),('6449','2013-03-31','12:05:00',4.34),('6449','2013-03-31','12:10:00',3.63),('6449','2013-03-31','12:15:00',3.49),('6449','2013-03-31','12:20:00',3.57),('6449','2013-03-31','12:25:00',4.2),('6449','2013-03-31','12:30:00',3.77),('6449','2013-03-31','12:35:00',3.97),('6449','2013-03-31','12:40:00',5.19),('6449','2013-03-31','12:45:00',6.85),('6449','2013-03-31','12:50:00',7.6),('6449','2013-03-31','12:55:00',8.11),('6449','2013-03-31','13:00:00',7.34),('6449','2013-03-31','13:05:00',9.22),('6449','2013-03-31','13:10:00',18.4),('6449','2013-03-31','13:15:00',16.94),('6449','2013-03-31','13:20:00',18.49),('6449','2013-03-31','13:25:00',12.2),('6449','2013-03-31','13:30:00',16.45),('6449','2013-03-31','13:35:00',12.11),('6449','2013-03-31','13:40:00',9.75),('6449','2013-03-31','13:45:00',14.89),('6449','2013-03-31','13:50:00',12.95),('6449','2013-03-31','13:55:00',6.16),('6449','2013-03-31','14:00:00',10.68),('6449','2013-03-31','14:05:00',10.71),('6449','2013-03-31','14:10:00',9.9),('6449','2013-03-31','14:15:00',16.91),('6449','2013-03-31','14:20:00',11.78),('6449','2013-03-31','14:25:00',14.78),('6449','2013-03-31','14:30:00',8.18),('6449','2013-03-31','14:35:00',5.92),('6449','2013-03-31','14:40:00',5.74),('6449','2013-03-31','14:45:00',5.8),('6449','2013-03-31','14:50:00',11.32),('6449','2013-03-31','14:55:00',17.8),('6449','2013-03-31','15:00:00',10.52),('6449','2013-03-31','15:05:00',9.51),('6449','2013-03-31','15:10:00',14.1),('6449','2013-03-31','15:15:00',15.53),('6449','2013-03-31','15:20:00',15.32),('6449','2013-03-31','15:25:00',14.21),('6449','2013-03-31','15:30:00',11.04),('6449','2013-03-31','15:35:00',10.88),('6449','2013-03-31','15:40:00',6.73),('6449','2013-03-31','15:45:00',8.45),('6449','2013-03-31','15:50:00',8.25),('6449','2013-03-31','15:55:00',6.78),('6449','2013-03-31','16:00:00',3.96),('6449','2013-03-31','16:05:00',2.42),('6449','2013-03-31','16:10:00',2.92),('6449','2013-03-31','16:15:00',5.8),('6449','2013-03-31','16:20:00',5.41),('6449','2013-03-31','16:25:00',2.42),('6449','2013-03-31','16:30:00',1.32),('6449','2013-03-31','16:35:00',2.79),('6449','2013-03-31','16:40:00',2.71),('6449','2013-03-31','16:45:00',1.77),('6449','2013-03-31','16:50:00',1.21),('6449','2013-03-31','17:15:00',1.59),('6449','2013-03-31','17:20:00',3.37),('6449','2013-03-31','17:25:00',9.5),('6449','2013-03-31','17:30:00',5.53),('6449','2013-03-31','17:35:00',5.12),('6449','2013-03-31','17:40:00',6.1),('6449','2013-03-31','17:45:00',4.92),('6449','2013-03-31','17:50:00',4.62),('6449','2013-03-31','17:55:00',1.11),('6449','2013-03-31','18:00:00',2.02),('6449','2013-03-31','18:05:00',3.37),('6449','2013-03-31','18:10:00',3.6),('6449','2013-03-31','18:15:00',2.2),('6449','2013-03-31','18:25:00',1.76),('6449','2013-03-31','18:30:00',1.51),('6449','2013-03-31','18:35:00',1.1),('6449','2013-03-31','18:40:00',1.01),('6449','2013-03-30','07:20:00',1.04),('6449','2013-03-30','07:30:00',1.22),('6449','2013-03-30','07:35:00',1.75),('6449','2013-03-30','07:40:00',1.71),('6449','2013-03-30','07:45:00',1.23),('6449','2013-03-30','07:50:00',1.22),('6449','2013-03-30','07:55:00',1.07),('6449','2013-03-30','08:00:00',1.02),('6449','2013-03-30','08:10:00',1.4),('6449','2013-03-30','08:15:00',1.41),('6449','2013-03-30','08:40:00',1.15),('6449','2013-03-30','08:50:00',1.35),('6449','2013-03-30','08:55:00',1.12),('6449','2013-03-30','09:00:00',1.61),('6449','2013-03-30','09:05:00',2.71),('6449','2013-03-30','09:10:00',3.18),('6449','2013-03-30','09:15:00',3.09),('6449','2013-03-30','09:20:00',3.21),('6449','2013-03-30','09:25:00',2.7),('6449','2013-03-30','09:30:00',2.01),('6449','2013-03-30','09:35:00',5.61),('6449','2013-03-30','09:40:00',4.15),('6449','2013-03-30','09:45:00',3.23),('6449','2013-03-30','09:50:00',3.5),('6449','2013-03-30','09:55:00',3.54),('6449','2013-03-30','10:00:00',5.24),('6449','2013-03-30','10:05:00',4.72),('6449','2013-03-30','10:10:00',7.46),('6449','2013-03-30','10:15:00',7.65),('6449','2013-03-30','10:20:00',7.01),('6449','2013-03-30','10:25:00',9.41),('6449','2013-03-30','10:30:00',9.94),('6449','2013-03-30','10:35:00',9.4),('6449','2013-03-30','10:40:00',6.14),('6449','2013-03-30','10:45:00',4.91),('6449','2013-03-30','10:50:00',4.79),('6449','2013-03-30','10:55:00',3.41),('6449','2013-03-30','11:00:00',3.43),('6449','2013-03-30','11:05:00',3.35),('6449','2013-03-30','11:10:00',3.22),('6449','2013-03-30','11:15:00',3.57),('6449','2013-03-30','11:20:00',3.54),('6449','2013-03-30','11:25:00',3.25),('6449','2013-03-30','11:30:00',2.79),('6449','2013-03-30','11:35:00',4),('6449','2013-03-30','11:40:00',4.82),('6449','2013-03-30','11:45:00',3.9),('6449','2013-03-30','11:50:00',3.84),('6449','2013-03-30','11:55:00',3.87),('6449','2013-03-30','12:00:00',2.56),('6449','2013-03-30','12:05:00',2.74),('6449','2013-03-30','12:10:00',3.41),('6449','2013-03-30','12:15:00',2.51),('6449','2013-03-30','12:20:00',1.88),('6449','2013-03-30','12:25:00',1.82),('6449','2013-03-30','12:30:00',1.51),('6449','2013-03-30','12:50:00',2.53),('6449','2013-03-30','12:55:00',2.19),('6449','2013-03-30','13:00:00',3.47),('6449','2013-03-30','13:05:00',3.7),('6449','2013-03-30','13:10:00',3.83),('6449','2013-03-30','13:15:00',3.52),('6449','2013-03-30','13:20:00',2.65),('6449','2013-03-30','13:25:00',1.88),('6449','2013-03-30','13:30:00',1.74),('6449','2013-03-30','13:35:00',2.65),('6449','2013-03-30','13:40:00',3.39),('6449','2013-03-30','13:45:00',3.65),('6449','2013-03-30','13:50:00',5.72),('6449','2013-03-30','13:55:00',9.11),('6449','2013-03-30','14:00:00',10.29),('6449','2013-03-30','14:05:00',13.32),('6449','2013-03-30','14:10:00',9.72),('6449','2013-03-30','14:15:00',10.11),('6449','2013-03-30','14:20:00',10.84),('6449','2013-03-30','14:25:00',8.01),('6449','2013-03-30','14:30:00',8.73),('6449','2013-03-30','14:35:00',6.94),('6449','2013-03-30','14:40:00',4.55),('6449','2013-03-30','14:45:00',3.63),('6449','2013-03-30','14:50:00',3.21),('6449','2013-03-30','14:55:00',2.16),('6449','2013-03-30','15:00:00',2.13),('6449','2013-03-30','15:05:00',1.43),('6449','2013-03-30','15:10:00',1.74),('6449','2013-03-29','06:50:00',1.07),('6449','2013-03-29','06:55:00',2.08),('6449','2013-03-29','07:00:00',3.55),('6449','2013-03-29','07:05:00',3.89),('6449','2013-03-29','07:10:00',3.54),('6449','2013-03-29','07:15:00',1.83),('6449','2013-03-29','07:20:00',2.49),('6449','2013-03-29','07:25:00',2.39),('6449','2013-03-29','07:30:00',2.84),('6449','2013-03-29','07:35:00',2.25),('6449','2013-03-29','07:40:00',1.26),('6449','2013-03-29','07:45:00',1.11),('6449','2013-03-29','07:50:00',1.54),('6449','2013-03-29','07:55:00',2.32),('6449','2013-03-29','08:00:00',3.12),('6449','2013-03-29','08:05:00',3.54),('6449','2013-03-29','08:10:00',4.77),('6449','2013-03-29','08:15:00',9.15),('6449','2013-03-29','08:20:00',8.36),('6449','2013-03-29','08:25:00',7.33),('6449','2013-03-29','08:30:00',4.63),('6449','2013-03-29','08:35:00',7.82),('6449','2013-03-29','08:40:00',10.61),('6449','2013-03-29','08:45:00',11.34),('6449','2013-03-29','08:50:00',11.52),('6449','2013-03-29','08:55:00',9.24),('6449','2013-03-29','09:00:00',11.15),('6449','2013-03-29','09:05:00',11.92),('6449','2013-03-29','09:10:00',10.99),('6449','2013-03-29','09:15:00',11.72),('6449','2013-03-29','09:20:00',12.15),('6449','2013-03-29','09:25:00',12.81),('6449','2013-03-29','09:30:00',12.52),('6449','2013-03-29','09:35:00',11.44),('6449','2013-03-29','09:40:00',10.06),('6449','2013-03-29','09:45:00',9.45),('6449','2013-03-29','09:50:00',12.81),('6449','2013-03-29','09:55:00',8.26),('6449','2013-03-29','10:00:00',9.19),('6449','2013-03-29','10:05:00',10.64),('6449','2013-03-29','10:10:00',13.53),('6449','2013-03-29','10:15:00',13.01),('6449','2013-03-29','10:20:00',14.02),('6449','2013-03-29','10:25:00',14.3),('6449','2013-03-29','10:30:00',14.15),('6449','2013-03-29','10:35:00',14.13),('6449','2013-03-29','10:40:00',15.24),('6449','2013-03-29','10:45:00',15.73),('6449','2013-03-29','10:50:00',15.65),('6449','2013-03-29','10:55:00',15.82),('6449','2013-03-29','11:00:00',15.88),('6449','2013-03-29','11:05:00',15.96),('6449','2013-03-29','11:10:00',16.04),('6449','2013-03-29','11:15:00',16.26),('6449','2013-03-29','11:20:00',16.41),('6449','2013-03-29','11:25:00',16.5),('6449','2013-03-29','11:30:00',16.57),('6449','2013-03-29','11:35:00',16.63),('6449','2013-03-29','11:40:00',16.7),('6449','2013-03-29','11:45:00',16.73),('6449','2013-03-29','11:50:00',16.77),('6449','2013-03-29','11:55:00',16.79),('6449','2013-03-29','12:00:00',16.76),('6449','2013-03-29','12:05:00',16.76),('6449','2013-03-29','12:10:00',16.86),('6449','2013-03-29','12:15:00',16.91),('6449','2013-03-29','12:20:00',16.87),('6449','2013-03-29','12:25:00',16.29),('6449','2013-03-29','12:30:00',16.55),('6449','2013-03-29','12:35:00',16.65),('6449','2013-03-29','12:40:00',16.56),('6449','2013-03-29','12:45:00',16.41),('6449','2013-03-29','12:50:00',16.27),('6449','2013-03-29','12:55:00',15.91),('6449','2013-03-29','13:00:00',16.37),('6449','2013-03-29','13:05:00',16.24),('6449','2013-03-29','13:10:00',16.34),('6449','2013-03-29','13:15:00',12.92),('6449','2013-03-29','13:20:00',10.95),('6449','2013-03-29','13:25:00',13.51),('6449','2013-03-29','13:30:00',13.29),('6449','2013-03-29','13:35:00',13.09),('6449','2013-03-29','13:40:00',13.29),('6449','2013-03-29','13:45:00',12.92),('6449','2013-03-29','13:50:00',10.58),('6449','2013-03-29','13:55:00',8.17),('6449','2013-03-29','14:00:00',7.86),('6449','2013-03-29','14:05:00',7.63),('6449','2013-03-29','14:10:00',6.86),('6449','2013-03-29','14:15:00',6.39),('6449','2013-03-29','14:20:00',6.21),('6449','2013-03-29','14:25:00',6.18),('6449','2013-03-29','14:30:00',7.02),('6449','2013-03-29','14:35:00',6.52),('6449','2013-03-29','14:40:00',6.11),('6449','2013-03-29','14:45:00',5.86),('6449','2013-03-29','14:50:00',5.37),('6449','2013-03-29','14:55:00',5),('6449','2013-03-29','15:00:00',4.65),('6449','2013-03-29','15:05:00',4.27),('6449','2013-03-29','15:10:00',3.95),('6449','2013-03-29','15:15:00',3.82),('6449','2013-03-29','15:20:00',3.86),('6449','2013-03-29','15:25:00',4.5),('6449','2013-03-29','15:30:00',4.97),('6449','2013-03-29','15:35:00',7.18),('6449','2013-03-29','15:40:00',9.7),('6449','2013-03-29','15:45:00',9.09),('6449','2013-03-29','15:50:00',5.39),('6449','2013-03-29','15:55:00',3.9),('6449','2013-03-29','16:00:00',3.72),('6449','2013-03-29','16:05:00',5.57),('6449','2013-03-29','16:10:00',5.08),('6449','2013-03-29','16:15:00',4.63),('6449','2013-03-29','16:20:00',4.84),('6449','2013-03-29','16:25:00',4.58),('6449','2013-03-29','16:30:00',5.34),('6449','2013-03-29','16:35:00',4.57),('6449','2013-03-29','16:40:00',4.55),('6449','2013-03-29','16:45:00',4.38),('6449','2013-03-29','16:50:00',2.71),('6449','2013-03-29','16:55:00',2.95),('6449','2013-03-29','17:00:00',4.07),('6449','2013-03-29','17:05:00',3.57),('6449','2013-03-29','17:10:00',3.94),('6449','2013-03-29','17:15:00',2.67),('6449','2013-03-29','17:20:00',3.11),('6449','2013-03-29','17:25:00',2.01),('6449','2013-03-29','17:30:00',1.24),('6449','2013-03-29','17:35:00',1.13),('6449','2013-03-29','17:40:00',1.02),('6449','2013-03-28','07:20:00',1.07),('6449','2013-03-28','07:25:00',1.11),('6449','2013-03-28','07:30:00',1.27),('6449','2013-03-28','07:35:00',1.47),('6449','2013-03-28','08:30:00',1.09),('6449','2013-03-28','08:35:00',2.34),('6449','2013-03-28','08:40:00',2.89),('6449','2013-03-28','08:45:00',2.95),('6449','2013-03-28','08:50:00',3.42),('6449','2013-03-28','08:55:00',3.42),('6449','2013-03-28','09:00:00',3),('6449','2013-03-28','09:05:00',2.21),('6449','2013-03-28','09:10:00',3.16),('6449','2013-03-28','09:15:00',5.09),('6449','2013-03-28','09:20:00',4.43),('6449','2013-03-28','09:25:00',3.95),('6449','2013-03-28','09:30:00',3.97),('6449','2013-03-28','09:35:00',5.49),('6449','2013-03-28','09:40:00',7.77),('6449','2013-03-28','09:45:00',7.45),('6449','2013-03-28','09:50:00',4.68),('6449','2013-03-28','09:55:00',5.06),('6449','2013-03-28','10:00:00',4.56),('6449','2013-03-28','10:05:00',3.11),('6449','2013-03-28','10:10:00',3.18),('6449','2013-03-28','10:15:00',2.94),('6449','2013-03-28','10:20:00',2.77),('6449','2013-03-28','10:25:00',2.54),('6449','2013-03-28','10:30:00',1.61),('6449','2013-03-28','10:35:00',1.73),('6449','2013-03-28','10:40:00',1.87),('6449','2013-03-28','10:45:00',1.68),('6449','2013-03-28','10:50:00',1.78),('6449','2013-03-28','10:55:00',2.38),('6449','2013-03-28','11:00:00',3.99),('6449','2013-03-28','11:05:00',3.39),('6449','2013-03-28','11:10:00',2.57),('6449','2013-03-28','11:15:00',2.75),('6449','2013-03-28','11:20:00',2.91),('6449','2013-03-28','11:25:00',2.45),('6449','2013-03-28','11:30:00',3.24),('6449','2013-03-28','11:35:00',3.02),('6449','2013-03-28','11:40:00',3.28),('6449','2013-03-28','11:45:00',3.71),('6449','2013-03-28','11:50:00',4.15),('6449','2013-03-28','11:55:00',3.33),('6449','2013-03-28','12:00:00',2.9),('6449','2013-03-28','12:05:00',3.57),('6449','2013-03-28','12:10:00',3.36),('6449','2013-03-28','12:15:00',2.94),('6449','2013-03-28','12:20:00',3.01),('6449','2013-03-28','12:25:00',4.18),('6449','2013-03-28','12:30:00',6.27),('6449','2013-03-28','12:35:00',5.34),('6449','2013-03-28','12:40:00',4.5),('6449','2013-03-28','12:45:00',4.8),('6449','2013-03-28','12:50:00',3.21),('6449','2013-03-28','12:55:00',3.65),('6449','2013-03-28','13:00:00',4.1),('6449','2013-03-28','13:05:00',6.41),('6449','2013-03-28','13:10:00',4.94),('6449','2013-03-28','13:15:00',6.02),('6449','2013-03-28','13:20:00',4.92),('6449','2013-03-28','13:25:00',2.27),('6449','2013-03-28','13:30:00',1.68),('6449','2013-03-28','13:35:00',2.23),('6449','2013-03-28','13:40:00',4.45),('6449','2013-03-28','13:45:00',3.42),('6449','2013-03-28','13:50:00',1.47),('6449','2013-03-28','13:55:00',1.43),('6449','2013-03-28','14:10:00',1.03),('6449','2013-03-28','14:15:00',1.96),('6449','2013-03-28','14:20:00',3.11),('6449','2013-03-28','14:25:00',2.92),('6449','2013-03-28','14:30:00',1.14),('6449','2013-03-28','14:35:00',1.01),('6449','2013-03-28','14:40:00',1.92),('6449','2013-03-28','15:00:00',1.41),('6449','2013-03-28','15:05:00',1.72),('6449','2013-03-28','15:10:00',2.77),('6449','2013-03-28','15:15:00',2.25),('6449','2013-03-28','15:20:00',1.28),('6449','2013-03-28','15:25:00',1.17),('6449','2013-03-28','15:30:00',1.5),('6449','2013-03-28','15:35:00',2.72),('6449','2013-03-28','15:40:00',3.03),('6449','2013-03-28','15:45:00',1.4),('6449','2013-03-28','15:55:00',1.1),('6449','2013-03-28','16:00:00',1.49),('6449','2013-03-28','16:05:00',1.48),('6449','2013-03-28','16:10:00',1.64),('6449','2013-03-28','16:15:00',1.42),('6449','2013-03-28','16:20:00',1.03),('6449','2013-03-28','16:25:00',1.55),('6449','2013-03-28','16:30:00',1.66),('6449','2013-03-28','16:35:00',1.26),('6449','2013-03-28','16:40:00',1.18),('6449','2013-03-28','16:45:00',1.58),('6449','2013-03-28','16:50:00',2.49),('6449','2013-03-28','16:55:00',2.85),('6449','2013-03-28','17:00:00',2.87),('6449','2013-03-28','17:05:00',1.94),('6449','2013-03-28','17:10:00',1.66),('6449','2013-03-28','17:15:00',1.16),('6449','2013-03-27','06:45:00',1.11),('6449','2013-03-27','06:50:00',1.3),('6449','2013-03-27','06:55:00',1.92),('6449','2013-03-27','07:00:00',2.4),('6449','2013-03-27','07:05:00',2.85),('6449','2013-03-27','07:10:00',3.11),('6449','2013-03-27','07:15:00',3.76),('6449','2013-03-27','07:20:00',3.99),('6449','2013-03-27','07:25:00',3.21),('6449','2013-03-27','07:30:00',4.35),('6449','2013-03-27','07:35:00',5.53),('6449','2013-03-27','07:40:00',6.51),('6449','2013-03-27','07:45:00',4.18),('6449','2013-03-27','07:50:00',3.56),('6449','2013-03-27','07:55:00',6.33),('6449','2013-03-27','08:00:00',7.67),('6449','2013-03-27','08:05:00',4.9),('6449','2013-03-27','08:10:00',4.1),('6449','2013-03-27','08:15:00',3.79),('6449','2013-03-27','08:20:00',3.71),('6449','2013-03-27','08:25:00',4.49),('6449','2013-03-27','08:30:00',8.57),('6449','2013-03-27','08:35:00',5.95),('6449','2013-03-27','08:40:00',4.93),('6449','2013-03-27','08:45:00',5.23),('6449','2013-03-27','08:50:00',9.72),('6449','2013-03-27','08:55:00',8.15),('6449','2013-03-27','09:00:00',8.22),('6449','2013-03-27','09:05:00',11.83),('6449','2013-03-27','09:10:00',10.47),('6449','2013-03-27','09:15:00',11.58),('6449','2013-03-27','09:20:00',8.92),('6449','2013-03-27','09:25:00',7.78),('6449','2013-03-27','09:30:00',7.24),('6449','2013-03-27','09:35:00',9.77),('6449','2013-03-27','09:40:00',15.19),('6449','2013-03-27','09:45:00',11.07),('6449','2013-03-27','09:50:00',13.88),('6449','2013-03-27','09:55:00',11.88),('6449','2013-03-27','10:00:00',14.9),('6449','2013-03-27','10:05:00',15.22),('6449','2013-03-27','10:10:00',11.22),('6449','2013-03-27','10:15:00',9),('6449','2013-03-27','10:20:00',7.65),('6449','2013-03-27','10:25:00',6.56),('6449','2013-03-27','10:30:00',7.95),('6449','2013-03-27','10:35:00',7.68),('6449','2013-03-27','10:40:00',8.83),('6449','2013-03-27','10:45:00',6.12),('6449','2013-03-27','10:50:00',7.81),('6449','2013-03-27','10:55:00',6.6),('6449','2013-03-27','11:00:00',7.57),('6449','2013-03-27','11:05:00',7.97),('6449','2013-03-27','11:10:00',7.19),('6449','2013-03-27','11:15:00',6.87),('6449','2013-03-27','11:20:00',6.64),('6449','2013-03-27','11:25:00',6.93),('6449','2013-03-27','11:30:00',9.33),('6449','2013-03-27','11:35:00',15.55),('6449','2013-03-27','11:40:00',12.2),('6449','2013-03-27','11:45:00',16.37),('6449','2013-03-27','11:50:00',14.7),('6449','2013-03-27','11:55:00',16.1),('6449','2013-03-27','12:00:00',15.35),('6449','2013-03-27','12:05:00',14.86),('6449','2013-03-27','12:10:00',16.91),('6449','2013-03-27','12:15:00',16.94),('6449','2013-03-27','12:20:00',12.24),('6449','2013-03-27','12:25:00',9.68),('6449','2013-03-27','12:30:00',13.69),('6449','2013-03-27','12:35:00',15.04),('6449','2013-03-27','12:40:00',13.93),('6449','2013-03-27','12:45:00',10.86),('6449','2013-03-27','12:50:00',9.51),('6449','2013-03-27','12:55:00',10.14),('6449','2013-03-27','13:00:00',13.59),('6449','2013-03-27','13:05:00',10.44),('6449','2013-03-27','13:10:00',11.96),('6449','2013-03-27','13:15:00',10.68),('6449','2013-03-27','13:20:00',8.87),('6449','2013-03-27','13:25:00',7.6),('6449','2013-03-27','13:30:00',6.99),('6449','2013-03-27','13:35:00',6.35),('6449','2013-03-27','13:40:00',4.85),('6449','2013-03-27','13:45:00',6.2),('6449','2013-03-27','13:50:00',9.55),('6449','2013-03-27','13:55:00',6.66),('6449','2013-03-27','14:00:00',7.82),('6449','2013-03-27','14:05:00',9.81),('6449','2013-03-27','14:10:00',10.11),('6449','2013-03-27','14:15:00',8.7),('6449','2013-03-27','14:20:00',9.84),('6449','2013-03-27','14:25:00',8.85),('6449','2013-03-27','14:30:00',9.36),('6449','2013-03-27','14:35:00',8.51),('6449','2013-03-27','14:40:00',11.21),('6449','2013-03-27','14:45:00',10.6),('6449','2013-03-27','14:50:00',10.41),('6449','2013-03-27','14:55:00',10.45),('6449','2013-03-27','15:00:00',6.72),('6449','2013-03-27','15:05:00',4.55),('6449','2013-03-27','15:10:00',4.02),('6449','2013-03-27','15:15:00',5.31),('6449','2013-03-27','15:20:00',7.22),('6449','2013-03-27','15:25:00',10.6),('6449','2013-03-27','15:30:00',6.69),('6449','2013-03-27','15:35:00',5.54),('6449','2013-03-27','15:40:00',6.47),('6449','2013-03-27','15:45:00',4.93),('6449','2013-03-27','15:50:00',4.8),('6449','2013-03-27','15:55:00',4.42),('6449','2013-03-27','16:00:00',3.96),('6449','2013-03-27','16:05:00',4.57),('6449','2013-03-27','16:10:00',4.25),('6449','2013-03-27','16:15:00',5.39),('6449','2013-03-27','16:20:00',3.3),('6449','2013-03-27','16:25:00',3.09),('6449','2013-03-27','16:30:00',3.56),('6449','2013-03-27','16:35:00',3.18),('6449','2013-03-27','16:40:00',2.13),('6449','2013-03-27','16:45:00',1.77),('6449','2013-03-27','16:50:00',1.31),('6449','2013-03-27','17:10:00',1.11),('6449','2013-03-27','17:15:00',1.16),('6449','2013-03-26','06:50:00',1.21),('6449','2013-03-26','06:55:00',1.38),('6449','2013-03-26','07:00:00',1.65),('6449','2013-03-26','07:05:00',1.42),('6449','2013-03-26','07:25:00',1.22),('6449','2013-03-26','07:30:00',1.54),('6449','2013-03-26','07:35:00',1.18),('6449','2013-03-26','07:40:00',1.1),('6449','2013-03-26','07:45:00',1.27),('6449','2013-03-26','07:50:00',1.57),('6449','2013-03-26','07:55:00',1.73),('6449','2013-03-26','08:00:00',2.14),('6449','2013-03-26','08:05:00',2.09),('6449','2013-03-26','08:10:00',2.4),('6449','2013-03-26','08:15:00',3.37),('6449','2013-03-26','08:20:00',7),('6449','2013-03-26','08:25:00',4.61),('6449','2013-03-26','08:30:00',3.03),('6449','2013-03-26','08:35:00',3.27),('6449','2013-03-26','08:40:00',2.67),('6449','2013-03-26','08:45:00',2.08),('6449','2013-03-26','08:50:00',2.3),('6449','2013-03-26','08:55:00',3.63),('6449','2013-03-26','09:00:00',3.32),('6449','2013-03-26','09:05:00',4.82),('6449','2013-03-26','09:10:00',6.77),('6449','2013-03-26','09:15:00',4.46),('6449','2013-03-26','09:20:00',6),('6449','2013-03-26','09:25:00',9.93),('6449','2013-03-26','09:30:00',2.8),('6449','2013-03-26','09:35:00',2.22),('6449','2013-03-26','09:40:00',1.77),('6449','2013-03-26','09:45:00',2.48),('6449','2013-03-26','09:50:00',3.61),('6449','2013-03-26','09:55:00',4.09),('6449','2013-03-26','10:00:00',3.52),('6449','2013-03-26','10:05:00',4.36),('6449','2013-03-26','10:10:00',8.11),('6449','2013-03-26','10:15:00',11.19),('6449','2013-03-26','10:20:00',8.65),('6449','2013-03-26','10:25:00',7.65),('6449','2013-03-26','10:30:00',6.19),('6449','2013-03-26','10:35:00',5.18),('6449','2013-03-26','10:40:00',6.06),('6449','2013-03-26','10:45:00',7.53),('6449','2013-03-26','10:50:00',5.61),('6449','2013-03-26','10:55:00',5.31),('6449','2013-03-26','11:00:00',4.57),('6449','2013-03-26','11:05:00',4.24),('6449','2013-03-26','11:10:00',3.99),('6449','2013-03-26','11:15:00',3.41),('6449','2013-03-26','11:20:00',3.4),('6449','2013-03-26','11:25:00',3.1),('6449','2013-03-26','11:30:00',3.19),('6449','2013-03-26','11:35:00',6.22),('6449','2013-03-26','11:40:00',8.36),('6449','2013-03-26','11:45:00',6.48),('6449','2013-03-26','11:50:00',5.08),('6449','2013-03-26','11:55:00',4.33),('6449','2013-03-26','12:00:00',7.1),('6449','2013-03-26','12:05:00',9.57),('6449','2013-03-26','12:10:00',8.62),('6449','2013-03-26','12:15:00',8.51),('6449','2013-03-26','12:20:00',12.52),('6449','2013-03-26','12:25:00',16.06),('6449','2013-03-26','12:30:00',11.86),('6449','2013-03-26','12:35:00',5.5),('6449','2013-03-26','12:40:00',5.73),('6449','2013-03-26','12:45:00',6.47),('6449','2013-03-26','12:50:00',5.14),('6449','2013-03-26','12:55:00',4.35),('6449','2013-03-26','13:00:00',6.72),('6449','2013-03-26','13:05:00',5.47),('6449','2013-03-26','13:10:00',3.95),('6449','2013-03-26','13:15:00',2.65),('6449','2013-03-26','13:20:00',5.29),('6449','2013-03-26','13:25:00',5.2),('6449','2013-03-26','13:30:00',6.17),('6449','2013-03-26','13:35:00',4.39),('6449','2013-03-26','13:40:00',5.26),('6449','2013-03-26','13:45:00',4.02),('6449','2013-03-26','13:50:00',2.68),('6449','2013-03-26','13:55:00',2.24),('6449','2013-03-26','14:00:00',2.54),('6449','2013-03-26','14:05:00',5.57),('6449','2013-03-26','14:10:00',5.72),('6449','2013-03-26','14:15:00',6.26),('6449','2013-03-26','14:20:00',5.17),('6449','2013-03-26','14:25:00',4.4),('6449','2013-03-26','14:30:00',4.44),('6449','2013-03-26','14:35:00',3.87),('6449','2013-03-26','14:40:00',3.37),('6449','2013-03-26','14:45:00',3.98),('6449','2013-03-26','14:50:00',3.65),('6449','2013-03-26','14:55:00',3.71),('6449','2013-03-26','15:00:00',3.96),('6449','2013-03-26','15:05:00',3.42),('6449','2013-03-26','15:10:00',3.71),('6449','2013-03-26','15:15:00',4.06),('6449','2013-03-26','15:20:00',4.17),('6449','2013-03-26','15:25:00',3.85),('6449','2013-03-26','15:30:00',2.72),('6449','2013-03-26','15:35:00',2.26),('6449','2013-03-26','15:40:00',2.55),('6449','2013-03-26','15:45:00',1.98),('6449','2013-03-26','15:50:00',1.34),('6449','2013-03-26','15:55:00',1.25),('6449','2013-03-26','16:00:00',1.25),('6449','2013-03-26','16:50:00',1.12),('6449','2013-03-26','16:55:00',1.06),('6449','2013-03-25','07:25:00',1.1),('6449','2013-03-25','07:30:00',1.24),('6449','2013-03-25','07:35:00',1.26),('6449','2013-03-25','07:40:00',2.1),('6449','2013-03-25','07:45:00',3.36),('6449','2013-03-25','07:50:00',4.7),('6449','2013-03-25','07:55:00',3.98),('6449','2013-03-25','08:00:00',2.99),('6449','2013-03-25','08:05:00',6.32),('6449','2013-03-25','08:10:00',6.18),('6449','2013-03-25','08:15:00',6.71),('6449','2013-03-25','08:20:00',10.11),('6449','2013-03-25','08:25:00',10.76),('6449','2013-03-25','08:30:00',11.54),('6449','2013-03-25','08:35:00',12.27),('6449','2013-03-25','08:40:00',12.42),('6449','2013-03-25','08:45:00',12.65),('6449','2013-03-25','08:50:00',10.18),('6449','2013-03-25','08:55:00',6.9),('6449','2013-03-25','09:00:00',6.4),('6449','2013-03-25','09:05:00',5.72),('6449','2013-03-25','09:10:00',6.57),('6449','2013-03-25','09:15:00',5.83),('6449','2013-03-25','09:20:00',6.76),('6449','2013-03-25','09:25:00',15.15),('6449','2013-03-25','09:30:00',10.01),('6449','2013-03-25','09:35:00',5.45),('6449','2013-03-25','09:40:00',6.19),('6449','2013-03-25','09:45:00',7.02),('6449','2013-03-25','09:50:00',4.59),('6449','2013-03-25','09:55:00',6.33),('6449','2013-03-25','10:00:00',4.73),('6449','2013-03-25','10:05:00',4.94),('6449','2013-03-25','10:10:00',5.58),('6449','2013-03-25','10:15:00',8.78),('6449','2013-03-25','10:20:00',14.91),('6449','2013-03-25','10:25:00',11.3),('6449','2013-03-25','10:30:00',15.69),('6449','2013-03-25','10:35:00',15.65),('6449','2013-03-25','10:40:00',17.03),('6449','2013-03-25','10:45:00',16.28),('6449','2013-03-25','10:50:00',14.41),('6449','2013-03-25','10:55:00',14.83),('6449','2013-03-25','11:00:00',12.45),('6449','2013-03-25','11:05:00',13.15),('6449','2013-03-25','11:10:00',11.16),('6449','2013-03-25','11:15:00',11.9),('6449','2013-03-25','11:20:00',19.25),('6449','2013-03-25','11:25:00',16.18),('6449','2013-03-25','11:30:00',18.81),('6449','2013-03-25','11:35:00',12.35),('6449','2013-03-25','11:40:00',5.28),('6449','2013-03-25','11:45:00',7.18),('6449','2013-03-25','11:50:00',15.94),('6449','2013-03-25','11:55:00',19.16),('6449','2013-03-25','12:00:00',13.02),('6449','2013-03-25','12:05:00',16.41),('6449','2013-03-25','12:10:00',15.57),('6449','2013-03-25','12:15:00',11.97),('6449','2013-03-25','12:20:00',16.3),('6449','2013-03-25','12:25:00',18.31),('6449','2013-03-25','12:30:00',16.88),('6449','2013-03-25','12:35:00',17.55),('6449','2013-03-25','12:40:00',16.31),('6449','2013-03-25','12:45:00',15.82),('6449','2013-03-25','12:50:00',16.6),('6449','2013-03-25','12:55:00',9.77),('6449','2013-03-25','13:00:00',5.47),('6449','2013-03-25','13:05:00',6.54),('6449','2013-03-25','13:10:00',12.68),('6449','2013-03-25','13:15:00',13.3),('6449','2013-03-25','13:20:00',14.1),('6449','2013-03-25','13:25:00',14.83),('6449','2013-03-25','13:30:00',9.33),('6449','2013-03-25','13:35:00',11.06),('6449','2013-03-25','13:40:00',13.45),('6449','2013-03-25','13:45:00',16.43),('6449','2013-03-25','13:50:00',12.16),('6449','2013-03-25','13:55:00',15.23),('6449','2013-03-25','14:00:00',15),('6449','2013-03-25','14:05:00',14.82),('6449','2013-03-25','14:10:00',12.95),('6449','2013-03-25','14:15:00',9.85),('6449','2013-03-25','14:20:00',9.62),('6449','2013-03-25','14:25:00',13.06),('6449','2013-03-25','14:30:00',12.63),('6449','2013-03-25','14:35:00',10.68),('6449','2013-03-25','14:40:00',8.92),('6449','2013-03-25','14:45:00',7.89),('6449','2013-03-25','14:50:00',9.71),('6449','2013-03-25','14:55:00',11.87),('6449','2013-03-25','15:00:00',9.56),('6449','2013-03-25','15:05:00',11.97),('6449','2013-03-25','15:10:00',11.5),('6449','2013-03-25','15:15:00',11.44),('6449','2013-03-25','15:20:00',9.74),('6449','2013-03-25','15:25:00',9.3),('6449','2013-03-25','15:30:00',10.42),('6449','2013-03-25','15:35:00',8.7),('6449','2013-03-25','15:40:00',7.8),('6449','2013-03-25','15:45:00',7.14),('6449','2013-03-25','15:50:00',8.15),('6449','2013-03-25','15:55:00',6.79),('6449','2013-03-25','16:00:00',3.57),('6449','2013-03-25','16:05:00',8.05),('6449','2013-03-25','16:10:00',5.91),('6449','2013-03-25','16:15:00',6.71),('6449','2013-03-25','16:20:00',5.21),('6449','2013-03-25','16:25:00',3.74),('6449','2013-03-25','16:30:00',2.84),('6449','2013-03-25','16:35:00',2.82),('6449','2013-03-25','16:40:00',2.6),('6449','2013-03-25','16:45:00',4.47),('6449','2013-03-25','16:50:00',4.11),('6449','2013-03-25','16:55:00',3.18),('6449','2013-03-25','17:00:00',3.5),('6449','2013-03-25','17:05:00',2.38),('6449','2013-03-25','17:10:00',2.08),('6449','2013-03-25','17:15:00',1.71),('6449','2013-03-25','17:20:00',1.4),('6449','2013-03-25','17:25:00',1.09),('6449','2013-03-24','06:45:00',1.13),('6449','2013-03-24','06:50:00',1.41),('6449','2013-03-24','06:55:00',1.88),('6449','2013-03-24','07:00:00',2.37),('6449','2013-03-24','07:05:00',2.82),('6449','2013-03-24','07:10:00',3.57),('6449','2013-03-24','07:15:00',3.72),('6449','2013-03-24','07:20:00',3.71),('6449','2013-03-24','07:25:00',4.26),('6449','2013-03-24','07:30:00',4.59),('6449','2013-03-24','07:35:00',4.55),('6449','2013-03-24','07:40:00',4.42),('6449','2013-03-24','07:45:00',5.15),('6449','2013-03-24','07:50:00',5.79),('6449','2013-03-24','07:55:00',6.65),('6449','2013-03-24','08:00:00',7.04),('6449','2013-03-24','08:05:00',7.3),('6449','2013-03-24','08:10:00',7.79),('6449','2013-03-24','08:15:00',8.29),('6449','2013-03-24','08:20:00',8.72),('6449','2013-03-24','08:25:00',9.03),('6449','2013-03-24','08:30:00',9.5),('6449','2013-03-24','08:35:00',9.79),('6449','2013-03-24','08:40:00',10.26),('6449','2013-03-24','08:45:00',10.59),('6449','2013-03-24','08:50:00',10.84),('6449','2013-03-24','08:55:00',11.23),('6449','2013-03-24','09:00:00',11.53),('6449','2013-03-24','09:05:00',11.68),('6449','2013-03-24','09:10:00',12.03),('6449','2013-03-24','09:15:00',12.36),('6449','2013-03-24','09:20:00',12.57),('6449','2013-03-24','09:25:00',12.79),('6449','2013-03-24','09:30:00',13.02),('6449','2013-03-24','09:35:00',13.23),('6449','2013-03-24','09:40:00',13.4),('6449','2013-03-24','09:45:00',13.55),('6449','2013-03-24','09:50:00',13.7),('6449','2013-03-24','09:55:00',13.9),('6449','2013-03-24','10:00:00',14.14),('6449','2013-03-24','10:05:00',14.33),('6449','2013-03-24','10:10:00',14.49),('6449','2013-03-24','10:15:00',14.67),('6449','2013-03-24','10:20:00',14.68),('6449','2013-03-24','10:25:00',15.02),('6449','2013-03-24','10:30:00',15.13),('6449','2013-03-24','10:35:00',15.1),('6449','2013-03-24','10:40:00',15.45),('6449','2013-03-24','10:45:00',15.6),('6449','2013-03-24','10:50:00',15.55),('6449','2013-03-24','10:55:00',15.8),('6449','2013-03-24','11:00:00',15.77),('6449','2013-03-24','11:05:00',15.78),('6449','2013-03-24','11:10:00',15.96),('6449','2013-03-24','11:15:00',15.98),('6449','2013-03-24','11:20:00',15.95),('6449','2013-03-24','11:25:00',16.08),('6449','2013-03-24','11:30:00',16.1),('6449','2013-03-24','11:35:00',16.11),('6449','2013-03-24','11:40:00',16.09),('6449','2013-03-24','11:45:00',16.04),('6449','2013-03-24','11:50:00',16.06),('6449','2013-03-24','11:55:00',15.91),('6449','2013-03-24','12:00:00',15.78),('6449','2013-03-24','12:05:00',15.57),('6449','2013-03-24','12:10:00',15.59),('6449','2013-03-24','12:15:00',15.57),('6449','2013-03-24','12:20:00',15.34),('6449','2013-03-24','12:25:00',15.36),('6449','2013-03-24','12:30:00',15.35),('6449','2013-03-24','12:35:00',15.24),('6449','2013-03-24','12:40:00',15.38),('6449','2013-03-24','12:45:00',15.71),('6449','2013-03-24','12:50:00',15.74),('6449','2013-03-24','12:55:00',15.73),('6449','2013-03-24','13:00:00',15.81),('6449','2013-03-24','13:05:00',15.63),('6449','2013-03-24','13:10:00',15.38),('6449','2013-03-24','13:15:00',15.16),('6449','2013-03-24','13:20:00',14.98),('6449','2013-03-24','13:25:00',14.88),('6449','2013-03-24','13:30:00',14.74),('6449','2013-03-24','13:35:00',14.7),('6449','2013-03-24','13:40:00',14.46),('6449','2013-03-24','13:45:00',14.31),('6449','2013-03-24','13:50:00',13.87),('6449','2013-03-24','13:55:00',14.05),('6449','2013-03-24','14:00:00',13.91),('6449','2013-03-24','14:05:00',13.32),('6449','2013-03-24','14:10:00',11.09),('6449','2013-03-24','14:15:00',13.39),('6449','2013-03-24','14:20:00',13),('6449','2013-03-24','14:25:00',12.91),('6449','2013-03-24','14:30:00',12.02),('6449','2013-03-24','14:35:00',12.17),('6449','2013-03-24','14:40:00',12.21),('6449','2013-03-24','14:45:00',11.73),('6449','2013-03-24','14:50:00',11.19),('6449','2013-03-24','14:55:00',10.62),('6449','2013-03-24','15:00:00',8.79),('6449','2013-03-24','15:05:00',5.87),('6449','2013-03-24','15:10:00',7.75),('6449','2013-03-24','15:15:00',5.94),('6449','2013-03-24','15:20:00',8.94),('6449','2013-03-24','15:25:00',4.51),('6449','2013-03-24','15:30:00',6.79),('6449','2013-03-24','15:35:00',6.7),('6449','2013-03-24','15:40:00',3.26),('6449','2013-03-24','15:45:00',5.09),('6449','2013-03-24','15:50:00',7.15),('6449','2013-03-24','15:55:00',3.33),('6449','2013-03-24','16:00:00',2.51),('6449','2013-03-24','16:05:00',4.72),('6449','2013-03-24','16:10:00',4.25),('6449','2013-03-24','16:15:00',3.36),('6449','2013-03-24','16:20:00',3.86),('6449','2013-03-24','16:25:00',2.69),('6449','2013-03-24','16:30:00',2.37),('6449','2013-03-24','16:35:00',2.5),('6449','2013-03-24','16:40:00',2.37),('6449','2013-03-24','16:45:00',2.63),('6449','2013-03-24','16:50:00',2.77),('6449','2013-03-24','16:55:00',2.22),('6449','2013-03-24','17:00:00',2.13),('6449','2013-03-24','17:05:00',1.64),('6449','2013-03-24','17:10:00',1.56),('6449','2013-03-24','17:15:00',1.37),('6449','2013-03-23','06:40:00',1.08),('6449','2013-03-23','06:45:00',1.28),('6449','2013-03-23','06:50:00',1.69),('6449','2013-03-23','06:55:00',1.96),('6449','2013-03-23','07:00:00',2.34),('6449','2013-03-23','07:05:00',2.62),('6449','2013-03-23','07:10:00',2.82),('6449','2013-03-23','07:15:00',2.77),('6449','2013-03-23','07:20:00',3.68),('6449','2013-03-23','07:25:00',3.79),('6449','2013-03-23','07:30:00',4.28),('6449','2013-03-23','07:35:00',4.83),('6449','2013-03-23','07:40:00',5.44),('6449','2013-03-23','07:45:00',5.71),('6449','2013-03-23','07:50:00',6.6),('6449','2013-03-23','07:55:00',6.87),('6449','2013-03-23','08:00:00',7.32),('6449','2013-03-23','08:05:00',7.66),('6449','2013-03-23','08:10:00',8.25),('6449','2013-03-23','08:15:00',8.52),('6449','2013-03-23','08:20:00',9.07),('6449','2013-03-23','08:25:00',9.22),('6449','2013-03-23','08:30:00',9.42),('6449','2013-03-23','08:35:00',9.87),('6449','2013-03-23','08:40:00',10.64),('6449','2013-03-23','08:45:00',10.38),('6449','2013-03-23','08:50:00',10.68),('6449','2013-03-23','08:55:00',11.14),('6449','2013-03-23','09:00:00',11.18),('6449','2013-03-23','09:05:00',11.71),('6449','2013-03-23','09:10:00',12.29),('6449','2013-03-23','09:15:00',12.39),('6449','2013-03-23','09:20:00',12.53),('6449','2013-03-23','09:25:00',12.81),('6449','2013-03-23','09:30:00',12.66),('6449','2013-03-23','09:35:00',13.38),('6449','2013-03-23','09:40:00',13.51),('6449','2013-03-23','09:45:00',13.56),('6449','2013-03-23','09:50:00',13.63),('6449','2013-03-23','09:55:00',13.17),('6449','2013-03-23','10:00:00',13.5),('6449','2013-03-23','10:05:00',13.34),('6449','2013-03-23','10:10:00',13.75),('6449','2013-03-23','10:15:00',13.27),('6449','2013-03-23','10:20:00',13.5),('6449','2013-03-23','10:25:00',13.18),('6449','2013-03-23','10:30:00',13.67),('6449','2013-03-23','10:35:00',14.21),('6449','2013-03-23','10:40:00',15.02),('6449','2013-03-23','10:45:00',14.86),('6449','2013-03-23','10:50:00',13.14),('6449','2013-03-23','10:55:00',15.59),('6449','2013-03-23','11:00:00',14.63),('6449','2013-03-23','11:05:00',15.31),('6449','2013-03-23','11:10:00',15.84),('6449','2013-03-23','11:15:00',14.61),('6449','2013-03-23','11:20:00',15.57),('6449','2013-03-23','11:25:00',15.92),('6449','2013-03-23','11:30:00',15.88),('6449','2013-03-23','11:35:00',15.44),('6449','2013-03-23','11:40:00',15.2),('6449','2013-03-23','11:45:00',14.87),('6449','2013-03-23','11:50:00',15.82),('6449','2013-03-23','11:55:00',16.09),('6449','2013-03-23','12:00:00',15.92),('6449','2013-03-23','12:05:00',16.2),('6449','2013-03-23','12:10:00',15.79),('6449','2013-03-23','12:15:00',16.01),('6449','2013-03-23','12:20:00',15.98),('6449','2013-03-23','12:25:00',15.86),('6449','2013-03-23','12:30:00',15.91),('6449','2013-03-23','12:35:00',15.62),('6449','2013-03-23','12:40:00',15.58),('6449','2013-03-23','12:45:00',15.52),('6449','2013-03-23','12:50:00',15.5),('6449','2013-03-23','12:55:00',15.48),('6449','2013-03-23','13:00:00',15.68),('6449','2013-03-23','13:05:00',15.3),('6449','2013-03-23','13:10:00',15.46),('6449','2013-03-23','13:15:00',15.23),('6449','2013-03-23','13:20:00',15.11),('6449','2013-03-23','13:25:00',15.15),('6449','2013-03-23','13:30:00',14.92),('6449','2013-03-23','13:35:00',14.69),('6449','2013-03-23','13:40:00',14.74),('6449','2013-03-23','13:45:00',14.64),('6449','2013-03-23','13:50:00',14.31),('6449','2013-03-23','13:55:00',13.74),('6449','2013-03-23','14:00:00',14.03),('6449','2013-03-23','14:05:00',13.59),('6449','2013-03-23','14:10:00',13.57),('6449','2013-03-23','14:15:00',13.07),('6449','2013-03-23','14:20:00',12.99),('6449','2013-03-23','14:25:00',12.41),('6449','2013-03-23','14:30:00',12.03),('6449','2013-03-23','14:35:00',11.16),('6449','2013-03-23','14:40:00',11.44),('6449','2013-03-23','14:45:00',12.16),('6449','2013-03-23','14:50:00',11.94),('6449','2013-03-23','14:55:00',10.62),('6449','2013-03-23','15:00:00',11.21),('6449','2013-03-23','15:05:00',11.35),('6449','2013-03-23','15:10:00',10.8),('6449','2013-03-23','15:15:00',10.04),('6449','2013-03-23','15:20:00',8.78),('6449','2013-03-23','15:25:00',8.53),('6449','2013-03-23','15:30:00',8.91),('6449','2013-03-23','15:35:00',8.68),('6449','2013-03-23','15:40:00',8.57),('6449','2013-03-23','15:45:00',7.96),('6449','2013-03-23','15:50:00',7.06),('6449','2013-03-23','15:55:00',6.99),('6449','2013-03-23','16:00:00',7.27),('6449','2013-03-23','16:05:00',7.07),('6449','2013-03-23','16:10:00',6.83),('6449','2013-03-23','16:15:00',5.48),('6449','2013-03-23','16:20:00',6.26),('6449','2013-03-23','16:25:00',6),('6449','2013-03-23','16:30:00',4.45),('6449','2013-03-23','16:35:00',3.82),('6449','2013-03-23','16:40:00',4.24),('6449','2013-03-23','16:45:00',3.73),('6449','2013-03-23','16:50:00',4.12),('6449','2013-03-23','16:55:00',4.1),('6449','2013-03-23','17:00:00',3.63),('6449','2013-03-23','17:05:00',2.87),('6449','2013-03-23','17:10:00',2.62),('6449','2013-03-23','17:15:00',2.32),('6449','2013-03-23','17:20:00',1.9),('6449','2013-03-23','17:25:00',1.6),('6449','2013-03-23','17:30:00',1.3),('6449','2013-03-23','17:35:00',1.03),('6449','2013-03-22','06:45:00',1.28),('6449','2013-03-22','06:50:00',1.63),('6449','2013-03-22','06:55:00',2.01),('6449','2013-03-22','07:00:00',2.4),('6449','2013-03-22','07:05:00',2.81),('6449','2013-03-22','07:10:00',3.23),('6449','2013-03-22','07:15:00',3.68),('6449','2013-03-22','07:20:00',4.12),('6449','2013-03-22','07:25:00',4.56),('6449','2013-03-22','07:30:00',5.01),('6449','2013-03-22','07:35:00',5.33),('6449','2013-03-22','07:40:00',5.89),('6449','2013-03-22','07:45:00',6.33),('6449','2013-03-22','07:50:00',6.76),('6449','2013-03-22','07:55:00',7.19),('6449','2013-03-22','08:00:00',7.59),('6449','2013-03-22','08:05:00',7.95),('6449','2013-03-22','08:10:00',8.39),('6449','2013-03-22','08:15:00',8.79),('6449','2013-03-22','08:20:00',9.18),('6449','2013-03-22','08:25:00',9.55),('6449','2013-03-22','08:30:00',9.88),('6449','2013-03-22','08:35:00',10.21),('6449','2013-03-22','08:40:00',10.61),('6449','2013-03-22','08:45:00',10.95),('6449','2013-03-22','08:50:00',11.26),('6449','2013-03-22','08:55:00',11.5),('6449','2013-03-22','09:00:00',11.78),('6449','2013-03-22','09:05:00',12.1),('6449','2013-03-22','09:10:00',12.35),('6449','2013-03-22','09:15:00',12.61),('6449','2013-03-22','09:20:00',12.52),('6449','2013-03-22','09:25:00',13.12),('6449','2013-03-22','09:30:00',13.37),('6449','2013-03-22','09:35:00',13.55),('6449','2013-03-22','09:40:00',13.72),('6449','2013-03-22','09:45:00',13.92),('6449','2013-03-22','09:50:00',14.04),('6449','2013-03-22','09:55:00',14.21),('6449','2013-03-22','10:00:00',14.34),('6449','2013-03-22','10:05:00',14.46),('6449','2013-03-22','10:10:00',14.61),('6449','2013-03-22','10:15:00',14.72),('6449','2013-03-22','10:20:00',14.75),('6449','2013-03-22','10:25:00',14.9),('6449','2013-03-22','10:30:00',15.07),('6449','2013-03-22','10:35:00',15.14),('6449','2013-03-22','10:40:00',15.08),('6449','2013-03-22','10:45:00',15.2),('6449','2013-03-22','10:50:00',15.34),('6449','2013-03-22','10:55:00',15.59),('6449','2013-03-22','11:00:00',15.81),('6449','2013-03-22','11:05:00',15.59),('6449','2013-03-22','11:10:00',16.07),('6449','2013-03-22','11:15:00',16.13),('6449','2013-03-22','11:20:00',16.28),('6449','2013-03-22','11:25:00',16.49),('6449','2013-03-22','11:30:00',16.57),('6449','2013-03-22','11:35:00',16.41),('6449','2013-03-22','11:40:00',16.74),('6449','2013-03-22','11:45:00',16.78),('6449','2013-03-22','11:50:00',16.8),('6449','2013-03-22','11:55:00',16.79),('6449','2013-03-22','12:00:00',16.84),('6449','2013-03-22','12:05:00',16.85),('6449','2013-03-22','12:10:00',16.83),('6449','2013-03-22','12:15:00',16.83),('6449','2013-03-22','12:20:00',16.74),('6449','2013-03-22','12:25:00',16.33),('6449','2013-03-22','12:30:00',16.54),('6449','2013-03-22','12:35:00',16.65),('6449','2013-03-22','12:40:00',16.63),('6449','2013-03-22','12:45:00',16.84),('6449','2013-03-22','12:50:00',16.43),('6449','2013-03-22','12:55:00',16.59),('6449','2013-03-22','13:00:00',16.47),('6449','2013-03-22','13:05:00',16.25),('6449','2013-03-22','13:10:00',15.03),('6449','2013-03-22','13:15:00',15.13),('6449','2013-03-22','13:20:00',15.71),('6449','2013-03-22','13:25:00',14.3),('6449','2013-03-22','13:30:00',14.69),('6449','2013-03-22','13:35:00',15.78),('6449','2013-03-22','13:40:00',15.56),('6449','2013-03-22','13:45:00',15.19),('6449','2013-03-22','13:50:00',14.98),('6449','2013-03-22','13:55:00',14.87),('6449','2013-03-22','14:00:00',14.66),('6449','2013-03-22','14:05:00',14.47),('6449','2013-03-22','14:10:00',14.3),('6449','2013-03-22','14:15:00',14.15),('6449','2013-03-22','14:20:00',13.92),('6449','2013-03-22','14:25:00',13.66),('6449','2013-03-22','14:30:00',13.42),('6449','2013-03-22','14:35:00',12.93),('6449','2013-03-22','14:40:00',13.03),('6449','2013-03-22','14:45:00',12.85),('6449','2013-03-22','14:50:00',12.61),('6449','2013-03-22','14:55:00',12.41),('6449','2013-03-22','15:00:00',11.69),('6449','2013-03-22','15:05:00',8.94),('6449','2013-03-22','15:10:00',10.61),('6449','2013-03-22','15:15:00',9.35),('6449','2013-03-22','15:20:00',10.76),('6449','2013-03-22','15:25:00',9.96),('6449','2013-03-22','15:30:00',9.55),('6449','2013-03-22','15:35:00',9.9),('6449','2013-03-22','15:40:00',8.32),('6449','2013-03-22','15:45:00',5.39),('6449','2013-03-22','15:50:00',5.3),('6449','2013-03-22','15:55:00',6.03),('6449','2013-03-22','16:00:00',7.96),('6449','2013-03-22','16:05:00',4.86),('6449','2013-03-22','16:10:00',3.93),('6449','2013-03-22','16:15:00',5.53),('6449','2013-03-22','16:20:00',4.94),('6449','2013-03-22','16:25:00',5.31),('6449','2013-03-22','16:30:00',5.88),('6449','2013-03-22','16:35:00',5.71),('6449','2013-03-22','16:40:00',4.74),('6449','2013-03-22','16:45:00',5.26),('6449','2013-03-22','16:50:00',4.4),('6449','2013-03-22','16:55:00',3.92),('6449','2013-03-22','17:00:00',3.99),('6449','2013-03-22','17:05:00',3.75),('6449','2013-03-22','17:10:00',3.39),('6449','2013-03-22','17:15:00',2.66),('6449','2013-03-22','17:20:00',1.99),('6449','2013-03-22','17:25:00',1.85),('6449','2013-03-22','17:30:00',1.67),('6449','2013-03-22','17:35:00',1.49),('6449','2013-03-22','17:40:00',1.07),('6449','2013-03-21','07:35:00',1.81),('6449','2013-03-21','07:40:00',2.4),('6449','2013-03-21','07:45:00',3.89),('6449','2013-03-21','07:50:00',2.01),('6449','2013-03-21','07:55:00',2.53),('6449','2013-03-21','08:00:00',2.99),('6449','2013-03-21','08:05:00',5.12),('6449','2013-03-21','08:10:00',3.15),('6449','2013-03-21','08:15:00',8.03),('6449','2013-03-21','08:20:00',9.25),('6449','2013-03-21','08:25:00',9.27),('6449','2013-03-21','08:30:00',9.81),('6449','2013-03-21','08:35:00',9.8),('6449','2013-03-21','08:40:00',8.74),('6449','2013-03-21','08:45:00',10.84),('6449','2013-03-21','08:50:00',11.29),('6449','2013-03-21','08:55:00',11.5),('6449','2013-03-21','09:00:00',12.06),('6449','2013-03-21','09:05:00',12.28),('6449','2013-03-21','09:10:00',12.51),('6449','2013-03-21','09:15:00',12.73),('6449','2013-03-21','09:20:00',13.05),('6449','2013-03-21','09:25:00',13.34),('6449','2013-03-21','09:30:00',13.7),('6449','2013-03-21','09:35:00',13.94),('6449','2013-03-21','09:40:00',14.16),('6449','2013-03-21','09:45:00',14.43),('6449','2013-03-21','09:50:00',14.51),('6449','2013-03-21','09:55:00',14.58),('6449','2013-03-21','10:00:00',14.6),('6449','2013-03-21','10:05:00',14.83),('6449','2013-03-21','10:10:00',14.64),('6449','2013-03-21','10:15:00',15.12),('6449','2013-03-21','10:20:00',15.48),('6449','2013-03-21','10:25:00',15.84),('6449','2013-03-21','10:30:00',16.23),('6449','2013-03-21','10:35:00',16.51),('6449','2013-03-21','10:40:00',16.56),('6449','2013-03-21','10:45:00',16.87),('6449','2013-03-21','10:50:00',16.98),('6449','2013-03-21','10:55:00',17.1),('6449','2013-03-21','11:00:00',17.18),('6449','2013-03-21','11:05:00',17.35),('6449','2013-03-21','11:10:00',17.35),('6449','2013-03-21','11:15:00',17.4),('6449','2013-03-21','11:20:00',17.45),('6449','2013-03-21','11:25:00',17.4),('6449','2013-03-21','11:30:00',17.62),('6449','2013-03-21','11:35:00',17.65),('6449','2013-03-21','11:40:00',17.67),('6449','2013-03-21','11:45:00',17.73),('6449','2013-03-21','11:50:00',17.79),('6449','2013-03-21','11:55:00',17.4),('6449','2013-03-21','12:00:00',17.81),('6449','2013-03-21','12:05:00',17.77),('6449','2013-03-21','12:10:00',17.7),('6449','2013-03-21','12:15:00',17.78),('6449','2013-03-21','12:20:00',17.81),('6449','2013-03-21','12:25:00',17.53),('6449','2013-03-21','12:30:00',17.72),('6449','2013-03-21','12:35:00',17.75),('6449','2013-03-21','12:40:00',17.69),('6449','2013-03-21','12:45:00',17.6),('6449','2013-03-21','12:50:00',17.44),('6449','2013-03-21','12:55:00',17.21),('6449','2013-03-21','13:00:00',17.18),('6449','2013-03-21','13:05:00',17.01),('6449','2013-03-21','13:10:00',16.73),('6449','2013-03-21','13:15:00',16.83),('6449','2013-03-21','13:20:00',16.6),('6449','2013-03-21','13:25:00',16.54),('6449','2013-03-21','13:30:00',16.44),('6449','2013-03-21','13:35:00',16.25),('6449','2013-03-21','13:40:00',15.79),('6449','2013-03-21','13:45:00',15.78),('6449','2013-03-21','13:50:00',15.59),('6449','2013-03-21','13:55:00',15.39),('6449','2013-03-21','14:00:00',15.2),('6449','2013-03-21','14:05:00',14.95),('6449','2013-03-21','14:10:00',14.43),('6449','2013-03-21','14:15:00',14.37),('6449','2013-03-21','14:20:00',14.28),('6449','2013-03-21','14:25:00',14.08),('6449','2013-03-21','14:30:00',14),('6449','2013-03-21','14:35:00',13.68),('6449','2013-03-21','14:40:00',13.4),('6449','2013-03-21','14:45:00',13.2),('6449','2013-03-21','14:50:00',12.86),('6449','2013-03-21','14:55:00',12.55),('6449','2013-03-21','15:00:00',12.38),('6449','2013-03-21','15:05:00',12.04),('6449','2013-03-21','15:10:00',11.77),('6449','2013-03-21','15:15:00',11.44),('6449','2013-03-21','15:20:00',11.05),('6449','2013-03-21','15:25:00',10.49),('6449','2013-03-21','15:30:00',10.42),('6449','2013-03-21','15:35:00',10.07),('6449','2013-03-21','15:40:00',9.71),('6449','2013-03-21','15:45:00',9.35),('6449','2013-03-21','15:50:00',8.96),('6449','2013-03-21','15:55:00',8.41),('6449','2013-03-21','16:00:00',8.2),('6449','2013-03-21','16:05:00',7.78),('6449','2013-03-21','16:10:00',7.36),('6449','2013-03-21','16:15:00',6.95),('6449','2013-03-21','16:20:00',5.78),('6449','2013-03-21','16:25:00',6.18),('6449','2013-03-21','16:30:00',5.63),('6449','2013-03-21','16:35:00',5.27),('6449','2013-03-21','16:40:00',4.8),('6449','2013-03-21','16:45:00',4.45),('6449','2013-03-21','16:50:00',4.06),('6449','2013-03-21','16:55:00',3.64),('6449','2013-03-21','17:00:00',3.23),('6449','2013-03-21','17:05:00',2.85),('6449','2013-03-21','17:10:00',2.4),('6449','2013-03-21','17:15:00',2.07),('6449','2013-03-21','17:20:00',1.74),('6449','2013-03-21','17:25:00',1.42),('6449','2013-03-21','17:30:00',1.15),('6449','2013-03-20','06:50:00',1.1),('6449','2013-03-20','06:55:00',1.66),('6449','2013-03-20','07:00:00',2.05),('6449','2013-03-20','07:05:00',2.41),('6449','2013-03-20','07:10:00',2.91),('6449','2013-03-20','07:15:00',3.44),('6449','2013-03-20','07:20:00',3.97),('6449','2013-03-20','07:25:00',4.57),('6449','2013-03-20','07:30:00',3.53),('6449','2013-03-20','07:35:00',3.27),('6449','2013-03-20','07:40:00',4.92),('6449','2013-03-20','07:45:00',5.43),('6449','2013-03-20','07:50:00',5.97),('6449','2013-03-20','07:55:00',6.77),('6449','2013-03-20','08:00:00',7.29),('6449','2013-03-20','08:05:00',7.65),('6449','2013-03-20','08:10:00',8.02),('6449','2013-03-20','08:15:00',8.73),('6449','2013-03-20','08:20:00',6.88),('6449','2013-03-20','08:25:00',5.12),('6449','2013-03-20','08:30:00',4.51),('6449','2013-03-20','08:35:00',9.18),('6449','2013-03-20','08:40:00',9.89),('6449','2013-03-20','08:45:00',9.82),('6449','2013-03-20','08:50:00',10.16),('6449','2013-03-20','08:55:00',10.85),('6449','2013-03-20','09:00:00',11.23),('6449','2013-03-20','09:05:00',11.26),('6449','2013-03-20','09:10:00',11.79),('6449','2013-03-20','09:15:00',10.26),('6449','2013-03-20','09:20:00',11.23),('6449','2013-03-20','09:25:00',10.89),('6449','2013-03-20','09:30:00',13.48),('6449','2013-03-20','09:35:00',13.3),('6449','2013-03-20','09:40:00',13.47),('6449','2013-03-20','09:45:00',13.4),('6449','2013-03-20','09:50:00',14.44),('6449','2013-03-20','09:55:00',13.9),('6449','2013-03-20','10:00:00',14.45),('6449','2013-03-20','10:05:00',14.68),('6449','2013-03-20','10:10:00',14.67),('6449','2013-03-20','10:15:00',14.62),('6449','2013-03-20','10:20:00',13.53),('6449','2013-03-20','10:25:00',12.83),('6449','2013-03-20','10:30:00',14.61),('6449','2013-03-20','10:35:00',13.51),('6449','2013-03-20','10:40:00',12.77),('6449','2013-03-20','10:45:00',6.45),('6449','2013-03-20','10:50:00',5.95),('6449','2013-03-20','10:55:00',8.35),('6449','2013-03-20','11:00:00',11),('6449','2013-03-20','11:05:00',13.08),('6449','2013-03-20','11:10:00',13.84),('6449','2013-03-20','11:15:00',8.8),('6449','2013-03-20','11:20:00',8.77),('6449','2013-03-20','11:25:00',8.74),('6449','2013-03-20','11:30:00',10.38),('6449','2013-03-20','11:35:00',9.27),('6449','2013-03-20','11:40:00',6.91),('6449','2013-03-20','11:45:00',7.98),('6449','2013-03-20','11:50:00',5.95),('6449','2013-03-20','11:55:00',5.78),('6449','2013-03-20','12:00:00',8.31),('6449','2013-03-20','12:05:00',10.35),('6449','2013-03-20','12:10:00',6.56),('6449','2013-03-20','12:15:00',3.87),('6449','2013-03-20','12:20:00',4.52),('6449','2013-03-20','12:25:00',4.56),('6449','2013-03-20','12:30:00',4.2),('6449','2013-03-20','12:35:00',4.04),('6449','2013-03-20','12:40:00',3.89),('6449','2013-03-20','12:45:00',4.66),('6449','2013-03-20','12:50:00',5.38),('6449','2013-03-20','12:55:00',3.34),('6449','2013-03-20','13:00:00',2.52),('6449','2013-03-20','13:05:00',3.39),('6449','2013-03-20','13:10:00',3.93),('6449','2013-03-20','13:15:00',3.76),('6449','2013-03-20','13:20:00',3.71),('6449','2013-03-20','13:25:00',4.12),('6449','2013-03-20','13:30:00',4.22),('6449','2013-03-20','13:35:00',4.28),('6449','2013-03-20','13:40:00',5.24),('6449','2013-03-20','13:45:00',5.31),('6449','2013-03-20','13:50:00',5.2),('6449','2013-03-20','13:55:00',4.68),('6449','2013-03-20','14:00:00',4.52),('6449','2013-03-20','14:05:00',3.75),('6449','2013-03-20','14:10:00',3.28),('6449','2013-03-20','14:15:00',2.59),('6449','2013-03-20','14:20:00',2.47),('6449','2013-03-20','14:25:00',2.67),('6449','2013-03-20','14:30:00',3.03),('6449','2013-03-20','14:35:00',2.63),('6449','2013-03-20','14:40:00',1.69),('6449','2013-03-20','14:45:00',1.65),('6449','2013-03-20','14:50:00',1.67),('6449','2013-03-20','14:55:00',1.38),('6449','2013-03-20','15:00:00',1.32),('6449','2013-03-20','15:05:00',1.12),('6449','2013-03-20','15:10:00',1.06),('6449','2013-03-20','15:15:00',1.25),('6449','2013-03-20','15:20:00',1.18),('6449','2013-03-20','15:25:00',1.19),('6449','2013-03-20','15:30:00',1.36),('6449','2013-03-20','15:35:00',1.01),('6449','2013-03-19','06:45:00',1.05),('6449','2013-03-19','06:50:00',1.33),('6449','2013-03-19','06:55:00',1.68),('6449','2013-03-19','07:00:00',2.02),('6449','2013-03-19','07:05:00',2.4),('6449','2013-03-19','07:10:00',2.82),('6449','2013-03-19','07:15:00',3.27),('6449','2013-03-19','07:20:00',3.67),('6449','2013-03-19','07:25:00',4.09),('6449','2013-03-19','07:30:00',4.49),('6449','2013-03-19','07:35:00',4.81),('6449','2013-03-19','07:40:00',5.34),('6449','2013-03-19','07:45:00',5.8),('6449','2013-03-19','07:50:00',6.19),('6449','2013-03-19','07:55:00',6.67),('6449','2013-03-19','08:00:00',7.18),('6449','2013-03-19','08:05:00',7.49),('6449','2013-03-19','08:10:00',8),('6449','2013-03-19','08:15:00',8.42),('6449','2013-03-19','08:20:00',8.79),('6449','2013-03-19','08:25:00',9.18),('6449','2013-03-19','08:30:00',9.54),('6449','2013-03-19','08:35:00',9.86),('6449','2013-03-19','08:40:00',10.31),('6449','2013-03-19','08:45:00',10.66),('6449','2013-03-19','08:50:00',10.98),('6449','2013-03-19','08:55:00',11.36),('6449','2013-03-19','09:00:00',11.68),('6449','2013-03-19','09:05:00',11.99),('6449','2013-03-19','09:10:00',12.33),('6449','2013-03-19','09:15:00',12.58),('6449','2013-03-19','09:20:00',12.88),('6449','2013-03-19','09:25:00',12.95),('6449','2013-03-19','09:30:00',13.29),('6449','2013-03-19','09:35:00',13.57),('6449','2013-03-19','09:40:00',13.81),('6449','2013-03-19','09:45:00',14.1),('6449','2013-03-19','09:50:00',14.33),('6449','2013-03-19','09:55:00',14.27),('6449','2013-03-19','10:00:00',14.79),('6449','2013-03-19','10:05:00',15.18),('6449','2013-03-19','10:10:00',15.36),('6449','2013-03-19','10:15:00',15.42),('6449','2013-03-19','10:20:00',15.73),('6449','2013-03-19','10:25:00',15.93),('6449','2013-03-19','10:30:00',16.13),('6449','2013-03-19','10:35:00',16.25),('6449','2013-03-19','10:40:00',16.33),('6449','2013-03-19','10:45:00',16.39),('6449','2013-03-19','10:50:00',16.65),('6449','2013-03-19','10:55:00',16.83),('6449','2013-03-19','11:00:00',17.07),('6449','2013-03-19','11:05:00',17.24),('6449','2013-03-19','11:10:00',17.08),('6449','2013-03-19','11:15:00',17.36),('6449','2013-03-19','11:20:00',17.23),('6449','2013-03-19','11:25:00',17.45),('6449','2013-03-19','11:30:00',17.77),('6449','2013-03-19','11:35:00',17.71),('6449','2013-03-19','11:40:00',17.32),('6449','2013-03-19','11:45:00',17.61),('6449','2013-03-19','11:50:00',17.53),('6449','2013-03-19','11:55:00',17.48),('6449','2013-03-19','12:00:00',17.44),('6449','2013-03-19','12:05:00',17.39),('6449','2013-03-19','12:10:00',17.35),('6449','2013-03-19','12:15:00',17.54),('6449','2013-03-19','12:20:00',17.44),('6449','2013-03-19','12:25:00',17.47),('6449','2013-03-19','12:30:00',17.43),('6449','2013-03-19','12:35:00',17.36),('6449','2013-03-19','12:40:00',17.28),('6449','2013-03-19','12:45:00',16.7),('6449','2013-03-19','12:50:00',16.72),('6449','2013-03-19','12:55:00',16.01),('6449','2013-03-19','13:00:00',16.68),('6449','2013-03-19','13:05:00',16.79),('6449','2013-03-19','13:10:00',16.64),('6449','2013-03-19','13:15:00',16.39),('6449','2013-03-19','13:20:00',15.93),('6449','2013-03-19','13:25:00',15.69),('6449','2013-03-19','13:30:00',16.17),('6449','2013-03-19','13:35:00',15.49),('6449','2013-03-19','13:40:00',15.06),('6449','2013-03-19','13:45:00',15.51),('6449','2013-03-19','13:50:00',15.28),('6449','2013-03-19','13:55:00',14.97),('6449','2013-03-19','14:00:00',14.86),('6449','2013-03-19','14:05:00',14.68),('6449','2013-03-19','14:10:00',14.44),('6449','2013-03-19','14:15:00',14.38),('6449','2013-03-19','14:20:00',14.15),('6449','2013-03-19','14:25:00',13.78),('6449','2013-03-19','14:30:00',13.67),('6449','2013-03-19','14:35:00',13.5),('6449','2013-03-19','14:40:00',13.09),('6449','2013-03-19','14:45:00',13.03),('6449','2013-03-19','14:50:00',12.7),('6449','2013-03-19','14:55:00',12.27),('6449','2013-03-19','15:00:00',12.01),('6449','2013-03-19','15:05:00',11.72),('6449','2013-03-19','15:10:00',11.23),('6449','2013-03-19','15:15:00',11.24),('6449','2013-03-19','15:20:00',10.99),('6449','2013-03-19','15:25:00',10.61),('6449','2013-03-19','15:30:00',10.26),('6449','2013-03-19','15:35:00',9.92),('6449','2013-03-19','15:40:00',9.59),('6449','2013-03-19','15:45:00',9.26),('6449','2013-03-19','15:50:00',8.93),('6449','2013-03-19','15:55:00',8.54),('6449','2013-03-19','16:00:00',8.15),('6449','2013-03-19','16:05:00',7.78),('6449','2013-03-19','16:10:00',7.34),('6449','2013-03-19','16:15:00',6.94),('6449','2013-03-19','16:20:00',6.38),('6449','2013-03-19','16:25:00',6.12),('6449','2013-03-19','16:30:00',5.77),('6449','2013-03-19','16:35:00',5.26),('6449','2013-03-19','16:40:00',4.46),('6449','2013-03-19','16:45:00',4.04),('6449','2013-03-19','16:50:00',3.63),('6449','2013-03-19','16:55:00',3.06),('6449','2013-03-19','17:00:00',3.27),('6449','2013-03-19','17:05:00',1.9),('6449','2013-03-19','17:10:00',1.87),('6449','2013-03-19','17:15:00',2.45),('6449','2013-03-19','17:20:00',2.14),('6449','2013-03-19','17:25:00',1.68),('6449','2013-03-19','17:30:00',1.23),('6449','2013-03-18','06:50:00',1.02),('6449','2013-03-18','06:55:00',1.56),('6449','2013-03-18','07:00:00',1.7),('6449','2013-03-18','07:05:00',1.1),('6449','2013-03-18','07:10:00',1.33),('6449','2013-03-18','07:15:00',1.23),('6449','2013-03-18','07:20:00',1.34),('6449','2013-03-18','07:25:00',1.49),('6449','2013-03-18','07:30:00',1.26),('6449','2013-03-18','07:35:00',1.78),('6449','2013-03-18','07:40:00',1.82),('6449','2013-03-18','07:45:00',2.19),('6449','2013-03-18','07:50:00',2.87),('6449','2013-03-18','07:55:00',2.17),('6449','2013-03-18','08:00:00',2.06),('6449','2013-03-18','08:05:00',2.25),('6449','2013-03-18','08:10:00',1.95),('6449','2013-03-18','08:15:00',1.64),('6449','2013-03-18','08:20:00',1.47),('6449','2013-03-18','08:25:00',1.19),('6449','2013-03-18','08:30:00',1.3),('6449','2013-03-18','08:35:00',1.62),('6449','2013-03-18','08:40:00',1.83),('6449','2013-03-18','08:45:00',1.75),('6449','2013-03-18','08:50:00',1.65),('6449','2013-03-18','08:55:00',1.7),('6449','2013-03-18','09:00:00',1.59),('6449','2013-03-18','09:05:00',1.26),('6449','2013-03-18','09:10:00',1.51),('6449','2013-03-18','09:15:00',1.65),('6449','2013-03-18','09:20:00',1.71),('6449','2013-03-18','09:25:00',1.58),('6449','2013-03-18','09:30:00',1.55),('6449','2013-03-18','09:35:00',1.97),('6449','2013-03-18','09:40:00',2.37),('6449','2013-03-18','09:45:00',3),('6449','2013-03-18','09:50:00',3.55),('6449','2013-03-18','09:55:00',3.4),('6449','2013-03-18','10:00:00',3.76),('6449','2013-03-18','10:05:00',5.04),('6449','2013-03-18','10:10:00',4.29),('6449','2013-03-18','10:15:00',3.56),('6449','2013-03-18','10:20:00',3.42),('6449','2013-03-18','10:25:00',3.61),('6449','2013-03-18','10:30:00',3.72),('6449','2013-03-18','10:35:00',3.32),('6449','2013-03-18','10:40:00',2.78),('6449','2013-03-18','10:45:00',3.06),('6449','2013-03-18','10:50:00',4.39),('6449','2013-03-18','10:55:00',5.52),('6449','2013-03-18','11:00:00',6.54),('6449','2013-03-18','11:05:00',6.91),('6449','2013-03-18','11:10:00',7.28),('6449','2013-03-18','11:15:00',6.97),('6449','2013-03-18','11:20:00',6.55),('6449','2013-03-18','11:25:00',4.79),('6449','2013-03-18','11:30:00',4.1),('6449','2013-03-18','11:35:00',3.65),('6449','2013-03-18','11:40:00',4.3),('6449','2013-03-18','11:45:00',4.37),('6449','2013-03-18','11:50:00',4.62),('6449','2013-03-18','11:55:00',4.29),('6449','2013-03-18','12:00:00',4.23),('6449','2013-03-18','12:05:00',4.82),('6449','2013-03-18','12:10:00',3.83),('6449','2013-03-18','12:15:00',3.67),('6449','2013-03-18','12:20:00',4.01),('6449','2013-03-18','12:25:00',3.44),('6449','2013-03-18','12:30:00',3.24),('6449','2013-03-18','12:35:00',2.88),('6449','2013-03-18','12:40:00',2.66),('6449','2013-03-18','12:45:00',2.71),('6449','2013-03-18','12:50:00',2.52),('6449','2013-03-18','12:55:00',3.14),('6449','2013-03-18','13:00:00',5.34),('6449','2013-03-18','13:05:00',4.74),('6449','2013-03-18','13:10:00',4),('6449','2013-03-18','13:15:00',3.47),('6449','2013-03-18','13:20:00',2.81),('6449','2013-03-18','13:25:00',2.96),('6449','2013-03-18','13:30:00',2.36),('6449','2013-03-18','13:35:00',2.02),('6449','2013-03-18','13:40:00',2.62),('6449','2013-03-18','13:45:00',3.9),('6449','2013-03-18','13:50:00',9.37),('6449','2013-03-18','13:55:00',11.38),('6449','2013-03-18','14:00:00',3.5),('6449','2013-03-18','14:05:00',3.08),('6449','2013-03-18','14:10:00',2.14),('6449','2013-03-18','14:15:00',1.7),('6449','2013-03-18','14:20:00',1.58),('6449','2013-03-18','14:25:00',1.14),('6449','2013-03-18','14:45:00',1.01),('6449','2013-03-18','15:10:00',1.03),('6449','2013-03-17','07:25:00',1.08),('6449','2013-03-17','07:30:00',1.07),('6449','2013-03-17','07:35:00',1.04),('6449','2013-03-17','07:40:00',1.25),('6449','2013-03-17','07:45:00',1.35),('6449','2013-03-17','07:50:00',1.42),('6449','2013-03-17','07:55:00',1.56),('6449','2013-03-17','08:00:00',2.16),('6449','2013-03-17','08:05:00',2.63),('6449','2013-03-17','08:10:00',2.74),('6449','2013-03-17','08:15:00',2.71),('6449','2013-03-17','08:20:00',3),('6449','2013-03-17','08:25:00',3.48),('6449','2013-03-17','08:30:00',4.58),('6449','2013-03-17','08:35:00',5.11),('6449','2013-03-17','08:40:00',5.05),('6449','2013-03-17','08:45:00',5.22),('6449','2013-03-17','08:50:00',5.56),('6449','2013-03-17','08:55:00',5),('6449','2013-03-17','09:00:00',4.9),('6449','2013-03-17','09:05:00',5.77),('6449','2013-03-17','09:10:00',4.83),('6449','2013-03-17','09:15:00',4.33),('6449','2013-03-17','09:20:00',4.99),('6449','2013-03-17','09:25:00',5.8),('6449','2013-03-17','09:30:00',5.63),('6449','2013-03-17','09:35:00',5.21),('6449','2013-03-17','09:40:00',4.81),('6449','2013-03-17','09:45:00',4.13),('6449','2013-03-17','09:50:00',3.63),('6449','2013-03-17','09:55:00',4.01),('6449','2013-03-17','10:00:00',4.62),('6449','2013-03-17','10:05:00',4.79),('6449','2013-03-17','10:10:00',5),('6449','2013-03-17','10:15:00',5.63),('6449','2013-03-17','10:20:00',6.02),('6449','2013-03-17','10:25:00',5.81),('6449','2013-03-17','10:30:00',4.62),('6449','2013-03-17','10:35:00',4.59),('6449','2013-03-17','10:40:00',4.31),('6449','2013-03-17','10:45:00',4.14),('6449','2013-03-17','10:50:00',4.14),('6449','2013-03-17','10:55:00',4.16),('6449','2013-03-17','11:00:00',5.3),('6449','2013-03-17','11:05:00',5.72),('6449','2013-03-17','11:10:00',6.14),('6449','2013-03-17','11:15:00',7.61),('6449','2013-03-17','11:20:00',7.5),('6449','2013-03-17','11:25:00',6.61),('6449','2013-03-17','11:30:00',6.47),('6449','2013-03-17','11:35:00',6.1),('6449','2013-03-17','11:40:00',5.75),('6449','2013-03-17','11:45:00',4.78),('6449','2013-03-17','11:50:00',5.67),('6449','2013-03-17','11:55:00',5.98),('6449','2013-03-17','12:00:00',6.39),('6449','2013-03-17','12:05:00',8.31),('6449','2013-03-17','12:10:00',10.23),('6449','2013-03-17','12:15:00',8.05),('6449','2013-03-17','12:20:00',7.62),('6449','2013-03-17','12:25:00',8.67),('6449','2013-03-17','12:30:00',9.11),('6449','2013-03-17','12:35:00',7.9),('6449','2013-03-17','12:40:00',6.57),('6449','2013-03-17','12:45:00',6.04),('6449','2013-03-17','12:50:00',5.27),('6449','2013-03-17','12:55:00',4.98),('6449','2013-03-17','13:00:00',4.53),('6449','2013-03-17','13:05:00',4.92),('6449','2013-03-17','13:10:00',4.23),('6449','2013-03-17','13:15:00',3.54),('6449','2013-03-17','13:20:00',3.18),('6449','2013-03-17','13:25:00',3.43),('6449','2013-03-17','13:30:00',2.76),('6449','2013-03-17','13:35:00',4.04),('6449','2013-03-17','13:40:00',4.2),('6449','2013-03-17','13:45:00',4.09),('6449','2013-03-17','13:50:00',5.11),('6449','2013-03-17','13:55:00',5.93),('6449','2013-03-17','14:00:00',5.07),('6449','2013-03-17','14:05:00',4.79),('6449','2013-03-17','14:10:00',5.84),('6449','2013-03-17','14:15:00',7.15),('6449','2013-03-17','14:20:00',8.29),('6449','2013-03-17','14:25:00',7.32),('6449','2013-03-17','14:30:00',5.97),('6449','2013-03-17','14:35:00',4.75),('6449','2013-03-17','14:40:00',5.29),('6449','2013-03-17','14:45:00',6.42),('6449','2013-03-17','14:50:00',6.28),('6449','2013-03-17','14:55:00',5.93),('6449','2013-03-17','15:00:00',5.75),('6449','2013-03-17','15:05:00',5.57),('6449','2013-03-17','15:10:00',6.25),('6449','2013-03-17','15:15:00',5.3),('6449','2013-03-17','15:20:00',4.26),('6449','2013-03-17','15:25:00',3.65),('6449','2013-03-17','15:30:00',3.21),('6449','2013-03-17','15:35:00',2.12),('6449','2013-03-17','15:40:00',1.25),('6449','2013-03-17','15:50:00',1.06),('6449','2013-03-17','15:55:00',1.47),('6449','2013-03-17','16:00:00',1.62),('6449','2013-03-17','16:05:00',1.71),('6449','2013-03-17','16:10:00',1.7),('6449','2013-03-17','16:15:00',1.68),('6449','2013-03-17','16:20:00',1.41),('6449','2013-03-17','16:25:00',1.81),('6449','2013-03-17','16:30:00',2.89),('6449','2013-03-17','16:35:00',2.9),('6449','2013-03-17','16:40:00',1.28),('6449','2013-03-16','07:10:00',1.4),('6449','2013-03-16','07:15:00',1.47),('6449','2013-03-16','07:20:00',1.22),('6449','2013-03-16','07:25:00',1.16),('6449','2013-03-16','07:30:00',2.77),('6449','2013-03-16','07:35:00',4.32),('6449','2013-03-16','07:40:00',3.11),('6449','2013-03-16','07:45:00',4.09),('6449','2013-03-16','07:50:00',5.18),('6449','2013-03-16','07:55:00',3.52),('6449','2013-03-16','08:00:00',6.03),('6449','2013-03-16','08:05:00',5.42),('6449','2013-03-16','08:10:00',6.35),('6449','2013-03-16','08:15:00',8.72),('6449','2013-03-16','08:20:00',9.59),('6449','2013-03-16','08:25:00',6.62),('6449','2013-03-16','08:30:00',6.84),('6449','2013-03-16','08:35:00',10.16),('6449','2013-03-16','08:40:00',10.35),('6449','2013-03-16','08:45:00',10.76),('6449','2013-03-16','08:50:00',10.81),('6449','2013-03-16','08:55:00',11.04),('6449','2013-03-16','09:00:00',11.44),('6449','2013-03-16','09:05:00',11.75),('6449','2013-03-16','09:10:00',12.03),('6449','2013-03-16','09:15:00',12.86),('6449','2013-03-16','09:20:00',13.57),('6449','2013-03-16','09:25:00',14.04),('6449','2013-03-16','09:30:00',14.14),('6449','2013-03-16','09:35:00',14.03),('6449','2013-03-16','09:40:00',13.96),('6449','2013-03-16','09:45:00',14.18),('6449','2013-03-16','09:50:00',14.37),('6449','2013-03-16','09:55:00',14.45),('6449','2013-03-16','10:00:00',14.54),('6449','2013-03-16','10:05:00',14.72),('6449','2013-03-16','10:10:00',14.92),('6449','2013-03-16','10:18:00',15.12),('6449','2013-03-16','10:20:00',15.39),('6449','2013-03-16','10:25:00',15.31),('6449','2013-03-16','10:30:00',15.62),('6449','2013-03-16','10:35:00',15.74),('6449','2013-03-16','10:40:00',15.88),('6449','2013-03-16','10:45:00',15.76),('6449','2013-03-16','10:50:00',16.1),('6449','2013-03-16','10:55:00',16.11),('6449','2013-03-16','11:00:00',16.23),('6449','2013-03-16','11:05:00',16.33),('6449','2013-03-16','11:10:00',16.37),('6449','2013-03-16','11:19:00',16.48),('6449','2013-03-16','11:20:00',16.77),('6449','2013-03-16','11:25:00',16.8),('6449','2013-03-16','11:30:00',16.82),('6449','2013-03-16','11:35:00',16.84),('6449','2013-03-16','11:40:00',16.78),('6449','2013-03-16','11:45:00',16.78),('6449','2013-03-16','11:50:00',16.85),('6449','2013-03-16','11:55:00',16.76),('6449','2013-03-16','12:00:00',16.78),('6449','2013-03-16','12:05:00',16.96),('6449','2013-03-16','12:10:00',16.82),('6449','2013-03-16','12:15:00',16.8),('6449','2013-03-16','12:20:00',16.76),('6449','2013-03-16','12:25:00',16.78),('6449','2013-03-16','12:30:00',16.7),('6449','2013-03-16','12:35:00',16.97),('6449','2013-03-16','12:40:00',15.96),('6449','2013-03-16','12:45:00',12.8),('6449','2013-03-16','12:50:00',16.96),('6449','2013-03-16','12:55:00',16.49),('6449','2013-03-16','13:00:00',14.31),('6449','2013-03-16','13:05:00',7.43),('6449','2013-03-16','13:10:00',11.63),('6449','2013-03-16','13:15:00',15.22),('6449','2013-03-16','13:20:00',16.73),('6449','2013-03-16','13:25:00',16.89),('6449','2013-03-16','13:30:00',10.78),('6449','2013-03-16','13:35:00',15.77),('6449','2013-03-16','13:40:00',16.9),('6449','2013-03-16','13:45:00',14.81),('6449','2013-03-16','13:50:00',17.33),('6449','2013-03-16','13:55:00',16.52),('6449','2013-03-16','14:00:00',16.37),('6449','2013-03-16','14:05:00',15.95),('6449','2013-03-16','14:10:00',15.41),('6449','2013-03-16','14:15:00',14.3),('6449','2013-03-16','14:20:00',13.98),('6449','2013-03-16','14:25:00',13.6),('6449','2013-03-16','14:30:00',13.36),('6449','2013-03-16','14:35:00',13.34),('6449','2013-03-16','14:40:00',13.14),('6449','2013-03-16','14:45:00',13.05),('6449','2013-03-16','14:50:00',12.95),('6449','2013-03-16','14:55:00',12.6),('6449','2013-03-16','15:00:00',12.15),('6449','2013-03-16','15:05:00',11.62),('6449','2013-03-16','15:10:00',11.38),('6449','2013-03-16','15:15:00',11.06),('6449','2013-03-16','15:20:00',10.74),('6449','2013-03-16','15:25:00',10.38),('6449','2013-03-16','15:30:00',10.05),('6449','2013-03-16','15:35:00',9.66),('6449','2013-03-16','15:40:00',9.28),('6449','2013-03-16','15:45:00',8.98),('6449','2013-03-16','15:50:00',8.68),('6449','2013-03-16','15:55:00',8.3),('6449','2013-03-16','16:00:00',7.88),('6449','2013-03-16','16:05:00',7.57),('6449','2013-03-16','16:10:00',7.2),('6449','2013-03-16','16:15:00',6.94),('6449','2013-03-16','16:20:00',6.51),('6449','2013-03-16','16:25:00',5.98),('6449','2013-03-16','16:30:00',5.56),('6449','2013-03-16','16:35:00',5.12),('6449','2013-03-16','16:40:00',4.64),('6449','2013-03-16','16:45:00',4.21),('6449','2013-03-16','16:50:00',3.75),('6449','2013-03-16','16:55:00',3.4),('6449','2013-03-16','17:00:00',2.98),('6449','2013-03-16','17:05:00',2.65),('6449','2013-03-16','17:10:00',2.28),('6449','2013-03-16','17:15:00',1.9),('6449','2013-03-16','17:20:00',1.6),('6449','2013-03-16','17:25:00',1.31),('6449','2013-03-16','17:30:00',1.03),('6449','2013-03-15','07:20:00',1.18),('6449','2013-03-15','07:25:00',1.47),('6449','2013-03-15','07:30:00',1.64),('6449','2013-03-15','07:35:00',1.7),('6449','2013-03-15','07:40:00',1.74),('6449','2013-03-15','07:45:00',1.76),('6449','2013-03-15','07:50:00',1.81),('6449','2013-03-15','07:55:00',1.86),('6449','2013-03-15','08:00:00',2.07),('6449','2013-03-15','08:05:00',2.2),('6449','2013-03-15','08:10:00',2),('6449','2013-03-15','08:15:00',1.94),('6449','2013-03-15','08:20:00',1.7),('6449','2013-03-15','08:25:00',1.55),('6449','2013-03-15','08:30:00',1.94),('6449','2013-03-15','08:35:00',2.23),('6449','2013-03-15','08:40:00',2.11),('6449','2013-03-15','08:45:00',2.14),('6449','2013-03-15','08:50:00',2.27),('6449','2013-03-15','08:55:00',2.36),('6449','2013-03-15','09:00:00',2.39),('6449','2013-03-15','09:05:00',2.29),('6449','2013-03-15','09:10:00',1.85),('6449','2013-03-15','09:15:00',1.7),('6449','2013-03-15','09:20:00',1.73),('6449','2013-03-15','09:25:00',1.82),('6449','2013-03-15','09:30:00',2.17),('6449','2013-03-15','09:35:00',2.59),('6449','2013-03-15','09:40:00',2.72),('6449','2013-03-15','09:45:00',2.68),('6449','2013-03-15','09:50:00',2.8),('6449','2013-03-15','09:55:00',2.83),('6449','2013-03-15','10:00:00',2.72),('6449','2013-03-15','10:05:00',2.8),('6449','2013-03-15','10:10:00',2.81),('6449','2013-03-15','10:15:00',2.85),('6449','2013-03-15','10:20:00',2.75),('6449','2013-03-15','10:25:00',2.91),('6449','2013-03-15','10:30:00',3.23),('6449','2013-03-15','10:35:00',3.83),('6449','2013-03-15','10:40:00',5.34),('6449','2013-03-15','10:45:00',7.31),('6449','2013-03-15','10:50:00',4.9),('6449','2013-03-15','10:55:00',4.46),('6449','2013-03-15','11:00:00',4.25),('6449','2013-03-15','11:05:00',4.39),('6449','2013-03-15','11:10:00',4.98),('6449','2013-03-15','11:15:00',5.48),('6449','2013-03-15','11:20:00',5.62),('6449','2013-03-15','11:25:00',5.68),('6449','2013-03-15','11:30:00',6.76),('6449','2013-03-15','11:35:00',7.48),('6449','2013-03-15','11:40:00',6.73),('6449','2013-03-15','11:45:00',6.79),('6449','2013-03-15','11:50:00',6.71),('6449','2013-03-15','11:55:00',7.26),('6449','2013-03-15','12:00:00',6.86),('6449','2013-03-15','12:05:00',6.75),('6449','2013-03-15','12:10:00',7.04),('6449','2013-03-15','12:15:00',8.1),('6449','2013-03-15','12:20:00',8.18),('6449','2013-03-15','12:25:00',7.19),('6449','2013-03-15','12:30:00',7.75),('6449','2013-03-15','12:35:00',7.76),('6449','2013-03-15','12:40:00',6.69),('6449','2013-03-15','12:45:00',7.26),('6449','2013-03-15','12:50:00',6.74),('6449','2013-03-15','12:55:00',6.57),('6449','2013-03-15','13:00:00',7.4),('6449','2013-03-15','13:05:00',8.24),('6449','2013-03-15','13:10:00',10.01),('6449','2013-03-15','13:15:00',6.41),('6449','2013-03-15','13:20:00',5.13),('6449','2013-03-15','13:25:00',3.88),('6449','2013-03-15','13:30:00',3.51),('6449','2013-03-15','13:35:00',3.3),('6449','2013-03-15','13:40:00',3.9),('6449','2013-03-15','13:45:00',5.34),('6449','2013-03-15','13:50:00',6.64),('6449','2013-03-15','13:55:00',6.56),('6449','2013-03-15','14:00:00',6.11),('6449','2013-03-15','14:05:00',6.33),('6449','2013-03-15','14:10:00',5.91),('6449','2013-03-15','14:15:00',5.35),('6449','2013-03-15','14:20:00',5.41),('6449','2013-03-15','14:25:00',5.96),('6449','2013-03-15','14:30:00',6.61),('6449','2013-03-15','14:35:00',9.82),('6449','2013-03-15','14:40:00',7.5),('6449','2013-03-15','14:45:00',6.32),('6449','2013-03-15','14:50:00',5.27),('6449','2013-03-15','14:55:00',5.54),('6449','2013-03-15','15:00:00',4.61),('6449','2013-03-15','15:05:00',4.08),('6449','2013-03-15','15:10:00',4.1),('6449','2013-03-15','15:15:00',5.02),('6449','2013-03-15','15:20:00',5.62),('6449','2013-03-15','15:25:00',4.12),('6449','2013-03-15','15:30:00',3.85),('6449','2013-03-15','15:35:00',2.98),('6449','2013-03-15','15:40:00',2.09),('6449','2013-03-15','15:45:00',2.21),('6449','2013-03-15','15:50:00',2.39),('6449','2013-03-15','15:55:00',1.9),('6449','2013-03-15','16:00:00',1.6),('6449','2013-03-15','16:05:00',1.25),('6449','2013-03-15','16:10:00',1.27),('6449','2013-03-15','16:15:00',1.67),('6449','2013-03-15','16:20:00',1.74),('6449','2013-03-15','16:25:00',1.53),('6449','2013-03-15','16:30:00',1.55),('6449','2013-03-15','16:35:00',2.43),('6449','2013-03-15','16:40:00',4.39),('6449','2013-03-15','16:45:00',4.11),('6449','2013-03-15','16:50:00',5.19),('6449','2013-03-15','16:55:00',3.35),('6449','2013-03-15','17:00:00',3.61),('6449','2013-03-15','17:05:00',3.18),('6449','2013-03-15','17:10:00',2.85),('6449','2013-03-15','17:15:00',2.59),('6449','2013-03-15','17:20:00',1.99),('6449','2013-03-15','17:25:00',1.3),('6449','2013-03-15','17:30:00',1.03),('6449','2013-03-14','07:05:00',1.34),('6449','2013-03-14','07:10:00',1.66),('6449','2013-03-14','07:15:00',1.52),('6449','2013-03-14','07:20:00',1.44),('6449','2013-03-14','07:25:00',1.48),('6449','2013-03-14','07:30:00',1.49),('6449','2013-03-14','07:35:00',1.43),('6449','2013-03-14','07:40:00',1.26),('6449','2013-03-14','08:50:00',1.16),('6449','2013-03-14','08:55:00',1.3),('6449','2013-03-14','09:00:00',1.36),('6449','2013-03-14','09:05:00',1.33),('6449','2013-03-14','09:10:00',1.32),('6449','2013-03-14','09:15:00',1.3),('6449','2013-03-14','09:20:00',1.21),('6449','2013-03-14','09:25:00',1.17),('6449','2013-03-14','09:30:00',1.09),('6449','2013-03-14','10:05:00',1.04),('6449','2013-03-14','10:10:00',1.17),('6449','2013-03-14','10:15:00',1.25),('6449','2013-03-14','10:20:00',1.33),('6449','2013-03-14','10:25:00',1.34),('6449','2013-03-14','10:30:00',1.51),('6449','2013-03-14','10:35:00',1.71),('6449','2013-03-14','10:40:00',1.85),('6449','2013-03-14','10:45:00',2.09),('6449','2013-03-14','10:50:00',2.27),('6449','2013-03-14','10:55:00',2.38),('6449','2013-03-14','11:00:00',2.41),('6449','2013-03-14','11:05:00',2.53),('6449','2013-03-14','11:10:00',2.62),('6449','2013-03-14','11:15:00',2.57),('6449','2013-03-14','11:20:00',2.71),('6449','2013-03-14','11:25:00',2.81),('6449','2013-03-14','11:30:00',3.36),('6449','2013-03-14','11:35:00',3.37),('6449','2013-03-14','11:40:00',2.76),('6449','2013-03-14','11:45:00',3.21),('6449','2013-03-14','11:50:00',3.36),('6449','2013-03-14','11:55:00',4.54),('6449','2013-03-14','12:00:00',4.42),('6449','2013-03-14','12:05:00',3.82),('6449','2013-03-14','12:10:00',3.66),('6449','2013-03-14','12:15:00',3.11),('6449','2013-03-14','12:20:00',2.57),('6449','2013-03-14','12:25:00',2.25),('6449','2013-03-14','12:30:00',1.88),('6449','2013-03-14','12:35:00',1.82),('6449','2013-03-14','12:40:00',2.14),('6449','2013-03-14','12:45:00',2.79),('6449','2013-03-14','12:50:00',3.31),('6449','2013-03-14','12:55:00',3.83),('6449','2013-03-14','13:00:00',5.51),('6449','2013-03-14','13:05:00',5.99),('6449','2013-03-14','13:10:00',7.1),('6449','2013-03-14','13:15:00',8.84),('6449','2013-03-14','13:20:00',7),('6449','2013-03-14','13:25:00',3.61),('6449','2013-03-14','13:30:00',2.45),('6449','2013-03-14','13:35:00',2),('6449','2013-03-14','13:40:00',1.76),('6449','2013-03-14','13:45:00',1.98),('6449','2013-03-14','13:50:00',2.56),('6449','2013-03-14','13:55:00',2.65),('6449','2013-03-14','14:00:00',2.64),('6449','2013-03-14','14:05:00',2.89),('6449','2013-03-14','14:10:00',3.06),('6449','2013-03-14','14:15:00',3.63),('6449','2013-03-14','14:20:00',4.1),('6449','2013-03-14','14:25:00',4.3),('6449','2013-03-14','14:30:00',4.39),('6449','2013-03-14','14:35:00',3.5),('6449','2013-03-14','14:40:00',2.88),('6449','2013-03-14','14:45:00',2.14),('6449','2013-03-14','14:50:00',1.5),('6449','2013-03-14','14:55:00',1.04),('6449','2013-03-14','15:20:00',1.07),('6449','2013-03-14','15:25:00',1.24),('6449','2013-03-14','15:30:00',1.78),('6449','2013-03-14','15:35:00',1.62),('6449','2013-03-14','15:40:00',1.69),('6449','2013-03-14','15:45:00',1.54),('6449','2013-03-14','15:50:00',2.14),('6449','2013-03-14','15:55:00',3.21),('6449','2013-03-14','16:00:00',3.11),('6449','2013-03-14','16:05:00',2.67),('6449','2013-03-14','16:10:00',1.99),('6449','2013-03-14','16:15:00',1.46),('6449','2013-03-14','16:20:00',1.16),('6449','2013-03-14','16:40:00',1.04),('6449','2013-03-14','16:45:00',1.48),('6449','2013-03-14','16:50:00',1.59),('6449','2013-03-14','16:55:00',2),('6449','2013-03-14','17:00:00',2.1),('6449','2013-03-14','17:05:00',1.63),('6449','2013-03-14','17:10:00',1.57),('6449','2013-03-14','17:15:00',1.27),('6449','2013-03-14','17:20:00',1.04),('6449','2013-03-13','07:00:00',1.05),('6449','2013-03-13','07:05:00',1.42),('6449','2013-03-13','07:10:00',1.43),('6449','2013-03-13','07:15:00',1.59),('6449','2013-03-13','07:20:00',1.61),('6449','2013-03-13','07:25:00',1.42),('6449','2013-03-13','07:45:00',1.23),('6449','2013-03-13','07:50:00',1.62),('6449','2013-03-13','07:55:00',1.73),('6449','2013-03-13','08:00:00',1.81),('6449','2013-03-13','08:05:00',2.37),('6449','2013-03-13','08:10:00',2.18),('6449','2013-03-13','08:15:00',2.1),('6449','2013-03-13','08:20:00',2.64),('6449','2013-03-13','08:25:00',2.37),('6449','2013-03-13','08:30:00',1.92),('6449','2013-03-13','08:35:00',2),('6449','2013-03-13','08:40:00',1.8),('6449','2013-03-13','08:45:00',1.66),('6449','2013-03-13','08:50:00',1.25),('6449','2013-03-13','08:55:00',1.05),('6449','2013-03-13','09:05:00',1.07),('6449','2013-03-13','09:10:00',1.95),('6449','2013-03-13','09:15:00',4.13),('6449','2013-03-13','09:20:00',4.27),('6449','2013-03-13','09:25:00',4.82),('6449','2013-03-13','09:30:00',5.41),('6449','2013-03-13','09:35:00',6.85),('6449','2013-03-13','09:40:00',9.67),('6449','2013-03-13','09:45:00',8.76),('6449','2013-03-13','09:50:00',10.35),('6449','2013-03-13','09:55:00',11.71),('6449','2013-03-13','10:00:00',10.21),('6449','2013-03-13','10:05:00',8.29),('6449','2013-03-13','10:10:00',14.01),('6449','2013-03-13','10:15:00',13.92),('6449','2013-03-13','10:20:00',13.74),('6449','2013-03-13','10:25:00',13.91),('6449','2013-03-13','10:30:00',12.38),('6449','2013-03-13','10:35:00',9.9),('6449','2013-03-13','10:40:00',11.03),('6449','2013-03-13','10:45:00',8.33),('6449','2013-03-13','10:50:00',7.89),('6449','2013-03-13','10:55:00',5.83),('6449','2013-03-13','11:00:00',5.96),('6449','2013-03-13','11:05:00',7.72),('6449','2013-03-13','11:10:00',6.64),('6449','2013-03-13','11:15:00',4.98),('6449','2013-03-13','11:20:00',4.69),('6449','2013-03-13','11:25:00',2.93),('6449','2013-03-13','11:30:00',2.98),('6449','2013-03-13','11:35:00',2.27),('6449','2013-03-13','11:40:00',2.31),('6449','2013-03-13','11:45:00',3.56),('6449','2013-03-13','11:50:00',4.94),('6449','2013-03-13','11:55:00',4.29),('6449','2013-03-13','12:00:00',2.27),('6449','2013-03-13','12:05:00',1.1),('6449','2013-03-13','12:10:00',1.24),('6449','2013-03-13','12:15:00',2.83),('6449','2013-03-13','12:20:00',2.95),('6449','2013-03-13','12:25:00',3.78),('6449','2013-03-13','12:30:00',4.14),('6449','2013-03-13','12:35:00',3.79),('6449','2013-03-13','12:40:00',3.28),('6449','2013-03-13','12:45:00',3.55),('6449','2013-03-13','12:50:00',3.45),('6449','2013-03-13','12:55:00',3.36),('6449','2013-03-13','13:00:00',3.13),('6449','2013-03-13','13:05:00',3.09),('6449','2013-03-13','13:10:00',3.13),('6449','2013-03-13','13:15:00',3.21),('6449','2013-03-13','13:20:00',3.19),('6449','2013-03-13','13:25:00',3.27),('6449','2013-03-13','13:30:00',3.49),('6449','2013-03-13','13:35:00',3.82),('6449','2013-03-13','13:40:00',3.2),('6449','2013-03-13','13:45:00',2.25),('6449','2013-03-13','13:50:00',1.69),('6449','2013-03-13','13:55:00',1.4),('6449','2013-03-13','14:00:00',1.15),('6449','2013-03-13','14:25:00',1.33),('6449','2013-03-13','14:30:00',1.53),('6449','2013-03-13','14:35:00',1.61),('6449','2013-03-13','14:40:00',1.27),('6449','2013-03-13','14:45:00',1.15),('6449','2013-03-13','14:50:00',1.12),('6449','2013-03-13','14:55:00',1.07),('6449','2013-03-13','15:00:00',1.08),('6449','2013-03-12','07:30:00',1.54),('6449','2013-03-12','07:35:00',4.12),('6449','2013-03-12','07:40:00',3.78),('6449','2013-03-12','07:45:00',3.24),('6449','2013-03-12','07:50:00',5.09),('6449','2013-03-12','07:55:00',5.88),('6449','2013-03-12','08:00:00',6.37),('6449','2013-03-12','08:05:00',6.54),('6449','2013-03-12','08:10:00',6.82),('6449','2013-03-12','08:15:00',6.73),('6449','2013-03-12','08:20:00',7.17),('6449','2013-03-12','08:25:00',7.32),('6449','2013-03-12','08:30:00',7.96),('6449','2013-03-12','08:35:00',8.78),('6449','2013-03-12','08:40:00',9.23),('6449','2013-03-12','08:45:00',9.55),('6449','2013-03-12','08:50:00',9.92),('6449','2013-03-12','08:55:00',10.32),('6449','2013-03-12','09:00:00',10.59),('6449','2013-03-12','09:05:00',10.86),('6449','2013-03-12','09:10:00',11.25),('6449','2013-03-12','09:15:00',11.49),('6449','2013-03-12','09:20:00',11.72),('6449','2013-03-12','09:25:00',11.98),('6449','2013-03-12','09:30:00',12.11),('6449','2013-03-12','09:35:00',12.43),('6449','2013-03-12','09:40:00',12.66),('6449','2013-03-12','09:45:00',12.87),('6449','2013-03-12','09:50:00',13.11),('6449','2013-03-12','09:55:00',13.3),('6449','2013-03-12','10:00:00',13.43),('6449','2013-03-12','10:05:00',13.75),('6449','2013-03-12','10:10:00',14.04),('6449','2013-03-12','10:15:00',14.17),('6449','2013-03-12','10:20:00',14.34),('6449','2013-03-12','10:25:00',14.56),('6449','2013-03-12','10:30:00',14.5),('6449','2013-03-12','10:35:00',14.92),('6449','2013-03-12','10:40:00',15.12),('6449','2013-03-12','10:45:00',15.39),('6449','2013-03-12','10:50:00',15.9),('6449','2013-03-12','10:55:00',13.27),('6449','2013-03-12','11:00:00',13.31),('6449','2013-03-12','11:05:00',17.22),('6449','2013-03-12','11:10:00',8.84),('6449','2013-03-12','11:15:00',7.92),('6449','2013-03-12','11:20:00',13.12),('6449','2013-03-12','11:25:00',9.71),('6449','2013-03-12','11:30:00',3.47),('6449','2013-03-12','11:35:00',1.83),('6449','2013-03-12','11:40:00',2.11),('6449','2013-03-12','11:45:00',2.79),('6449','2013-03-12','11:50:00',1.48),('6449','2013-03-12','11:55:00',1.52),('6449','2013-03-12','12:00:00',1.05),('6449','2013-03-12','12:05:00',1.66),('6449','2013-03-12','12:10:00',3.36),('6449','2013-03-12','12:15:00',11.11),('6449','2013-03-12','12:20:00',17.6),('6449','2013-03-12','12:25:00',16.58),('6449','2013-03-12','12:30:00',16.01),('6449','2013-03-12','12:35:00',17.23),('6449','2013-03-12','12:40:00',14.99),('6449','2013-03-12','12:45:00',16.76),('6449','2013-03-12','12:50:00',13.34),('6449','2013-03-12','12:55:00',16.26),('6449','2013-03-12','13:00:00',10.98),('6449','2013-03-12','13:05:00',6.01),('6449','2013-03-12','13:10:00',6.89),('6449','2013-03-12','13:15:00',14.61),('6449','2013-03-12','13:20:00',11.41),('6449','2013-03-12','13:25:00',15.17),('6449','2013-03-12','13:30:00',17.55),('6449','2013-03-12','13:35:00',10.28),('6449','2013-03-12','13:40:00',7.75),('6449','2013-03-12','13:45:00',5.86),('6449','2013-03-12','13:50:00',8.41),('6449','2013-03-12','13:55:00',18.32),('6449','2013-03-12','14:00:00',15.9),('6449','2013-03-12','14:05:00',10.38),('6449','2013-03-12','14:10:00',8.05),('6449','2013-03-12','14:15:00',5.18),('6449','2013-03-12','14:20:00',5.03),('6449','2013-03-12','14:25:00',2.98),('6449','2013-03-12','14:30:00',1.66),('6449','2013-03-12','14:35:00',1.24),('6449','2013-03-12','14:40:00',1.77),('6449','2013-03-12','14:45:00',6.15),('6449','2013-03-12','14:50:00',7.3),('6449','2013-03-12','14:55:00',6.08),('6449','2013-03-12','15:00:00',4.85),('6449','2013-03-12','15:05:00',4.56),('6449','2013-03-12','15:10:00',4.96),('6449','2013-03-12','15:15:00',5.84),('6449','2013-03-12','15:20:00',4.21),('6449','2013-03-12','15:25:00',3.69),('6449','2013-03-12','15:30:00',3.14),('6449','2013-03-12','15:35:00',3.97),('6449','2013-03-12','15:40:00',4.45),('6449','2013-03-12','15:45:00',3.05),('6449','2013-03-12','15:50:00',2.87),('6449','2013-03-12','15:55:00',7.42),('6449','2013-03-12','16:00:00',5.46),('6449','2013-03-12','16:05:00',3.25),('6449','2013-03-12','16:10:00',3.01),('6449','2013-03-12','16:15:00',5.82),('6449','2013-03-12','16:20:00',3.6),('6449','2013-03-12','16:25:00',3.43),('6449','2013-03-12','16:30:00',1.99),('6449','2013-03-12','16:35:00',1.5),('6449','2013-03-12','16:40:00',1.39),('6449','2013-03-12','16:45:00',1.38),('6449','2013-03-12','16:50:00',1.44),('6449','2013-03-12','16:55:00',1.59),('6449','2013-03-12','17:00:00',1.63),('6449','2013-03-12','17:05:00',1.54),('6449','2013-03-12','17:10:00',1.53),('6449','2013-03-12','17:15:00',1.22),('6449','2013-03-11','07:00:00',1.02),('6449','2013-03-11','07:05:00',1.37),('6449','2013-03-11','07:10:00',1.72),('6449','2013-03-11','07:15:00',1.99),('6449','2013-03-11','07:20:00',2.29),('6449','2013-03-11','07:25:00',2.22),('6449','2013-03-11','07:30:00',1.43),('6449','2013-03-11','07:35:00',1.65),('6449','2013-03-11','07:40:00',2.91),('6449','2013-03-11','07:45:00',3.75),('6449','2013-03-11','07:50:00',1.39),('6449','2013-03-11','08:00:00',1.08),('6449','2013-03-11','08:05:00',2.84),('6449','2013-03-11','08:10:00',7.82),('6449','2013-03-11','08:15:00',7.21),('6449','2013-03-11','08:20:00',7.75),('6449','2013-03-11','08:25:00',10.32),('6449','2013-03-11','08:30:00',6.49),('6449','2013-03-11','08:35:00',7.05),('6449','2013-03-11','08:40:00',10.44),('6449','2013-03-11','08:45:00',10.89),('6449','2013-03-11','08:50:00',10.28),('6449','2013-03-11','08:55:00',10.2),('6449','2013-03-11','09:00:00',10.53),('6449','2013-03-11','09:05:00',10.81),('6449','2013-03-11','09:10:00',11.15),('6449','2013-03-11','09:15:00',11.65),('6449','2013-03-11','09:20:00',12.2),('6449','2013-03-11','09:25:00',12.94),('6449','2013-03-11','09:30:00',12.19),('6449','2013-03-11','09:35:00',11.19),('6449','2013-03-11','09:40:00',9.72),('6449','2013-03-11','09:45:00',11.5),('6449','2013-03-11','09:50:00',13.8),('6449','2013-03-11','09:55:00',14.06),('6449','2013-03-11','10:00:00',14.59),('6449','2013-03-11','10:05:00',12.42),('6449','2013-03-11','10:10:00',10.89),('6449','2013-03-11','10:15:00',14.27),('6449','2013-03-11','10:20:00',15.01),('6449','2013-03-11','10:25:00',14.85),('6449','2013-03-11','10:30:00',15.22),('6449','2013-03-11','10:35:00',15.81),('6449','2013-03-11','10:40:00',16.75),('6449','2013-03-11','10:45:00',16.44),('6449','2013-03-11','10:50:00',9.63),('6449','2013-03-11','10:55:00',10.26),('6449','2013-03-11','11:00:00',7.74),('6449','2013-03-11','11:05:00',8.08),('6449','2013-03-11','11:10:00',11.41),('6449','2013-03-11','11:15:00',8.09),('6449','2013-03-11','11:20:00',6.73),('6449','2013-03-11','11:25:00',7.54),('6449','2013-03-11','11:30:00',8.44),('6449','2013-03-11','11:35:00',11.39),('6449','2013-03-11','11:40:00',7.44),('6449','2013-03-11','11:45:00',7.42),('6449','2013-03-11','11:50:00',7.3),('6449','2013-03-11','11:55:00',6.62),('6449','2013-03-11','12:00:00',6.86),('6449','2013-03-11','12:05:00',8.6),('6449','2013-03-11','12:10:00',11.91),('6449','2013-03-11','12:15:00',11.07),('6449','2013-03-11','12:20:00',11.75),('6449','2013-03-11','12:25:00',14.77),('6449','2013-03-11','12:30:00',18.02),('6449','2013-03-11','12:35:00',12.05),('6449','2013-03-11','12:40:00',17.36),('6449','2013-03-11','12:45:00',16.71),('6449','2013-03-11','12:50:00',14.16),('6449','2013-03-11','12:55:00',16.44),('6449','2013-03-11','13:00:00',16.04),('6449','2013-03-11','13:05:00',15.89),('6449','2013-03-11','13:10:00',15.8),('6449','2013-03-11','13:15:00',15.47),('6449','2013-03-11','13:20:00',15.4),('6449','2013-03-11','13:25:00',15.3),('6449','2013-03-11','13:30:00',15.31),('6449','2013-03-11','13:35:00',15.33),('6449','2013-03-11','13:40:00',15.96),('6449','2013-03-11','13:45:00',12.09),('6449','2013-03-11','13:50:00',10.79),('6449','2013-03-11','13:55:00',11.18),('6449','2013-03-11','14:00:00',14.57),('6449','2013-03-11','14:05:00',14.22),('6449','2013-03-11','14:10:00',14.29),('6449','2013-03-11','14:15:00',12.26),('6449','2013-03-11','14:20:00',8.63),('6449','2013-03-11','14:25:00',8.16),('6449','2013-03-11','14:30:00',8.18),('6449','2013-03-11','14:35:00',5.37),('6449','2013-03-11','14:40:00',5.39),('6449','2013-03-11','14:45:00',6.04),('6449','2013-03-11','14:50:00',4.91),('6449','2013-03-11','14:55:00',4.28),('6449','2013-03-11','15:00:00',4.69),('6449','2013-03-11','15:05:00',4.07),('6449','2013-03-11','15:10:00',3.98),('6449','2013-03-11','15:15:00',4.1),('6449','2013-03-11','15:20:00',4.66),('6449','2013-03-11','15:25:00',7.34),('6449','2013-03-11','15:30:00',7.49),('6449','2013-03-11','15:35:00',8.59),('6449','2013-03-11','15:40:00',8.72),('6449','2013-03-11','15:45:00',7.92),('6449','2013-03-11','15:50:00',7.27),('6449','2013-03-11','15:55:00',4.46),('6449','2013-03-11','16:00:00',2.95),('6449','2013-03-11','16:05:00',1.74),('6449','2013-03-11','16:10:00',3.75),('6449','2013-03-11','16:15:00',3.77),('6449','2013-03-11','16:20:00',2.76),('6449','2013-03-11','16:25:00',2.33),('6449','2013-03-11','16:30:00',2.32),('6449','2013-03-11','16:35:00',1.9),('6449','2013-03-11','16:40:00',2.59),('6449','2013-03-11','16:45:00',3.48),('6449','2013-03-11','16:50:00',3.46),('6449','2013-03-11','16:55:00',3.86),('6449','2013-03-11','17:00:00',2.8),('6449','2013-03-11','17:05:00',1.73),('6449','2013-03-11','17:10:00',1.22),('6449','2013-03-10','07:00:00',1.14),('6449','2013-03-10','07:05:00',1.46),('6449','2013-03-10','07:10:00',1.89),('6449','2013-03-10','07:20:00',1.16),('6449','2013-03-10','07:25:00',3.33),('6449','2013-03-10','07:30:00',3.44),('6449','2013-03-10','07:35:00',2.49),('6449','2013-03-10','07:40:00',4.06),('6449','2013-03-10','07:45:00',4.58),('6449','2013-03-10','07:50:00',4.87),('6449','2013-03-10','07:55:00',5.42),('6449','2013-03-10','08:00:00',5.81),('6449','2013-03-10','08:05:00',6.25),('6449','2013-03-10','08:10:00',6.54),('6449','2013-03-10','08:15:00',6.65),('6449','2013-03-10','08:20:00',7.22),('6449','2013-03-10','08:25:00',7.72),('6449','2013-03-10','08:30:00',8.22),('6449','2013-03-10','08:35:00',8.61),('6449','2013-03-10','08:40:00',9.16),('6449','2013-03-10','08:45:00',9.41),('6449','2013-03-10','08:50:00',11.34),('6449','2013-03-10','08:55:00',9.97),('6449','2013-03-10','09:00:00',10.92),('6449','2013-03-10','09:05:00',8.83),('6449','2013-03-10','09:10:00',10.94),('6449','2013-03-10','09:15:00',11.31),('6449','2013-03-10','09:20:00',11.6),('6449','2013-03-10','09:25:00',11.81),('6449','2013-03-10','09:30:00',12.14),('6449','2013-03-10','09:35:00',12.43),('6449','2013-03-10','09:40:00',12.69),('6449','2013-03-10','09:45:00',12.96),('6449','2013-03-10','09:50:00',13.14),('6449','2013-03-10','09:55:00',13.33),('6449','2013-03-10','10:00:00',13.56),('6449','2013-03-10','10:05:00',13.72),('6449','2013-03-10','10:10:00',13.89),('6449','2013-03-10','10:15:00',14.12),('6449','2013-03-10','10:20:00',14.31),('6449','2013-03-10','10:25:00',14.48),('6449','2013-03-10','10:30:00',14.66),('6449','2013-03-10','10:35:00',14.76),('6449','2013-03-10','10:40:00',14.83),('6449','2013-03-10','10:45:00',14.95),('6449','2013-03-10','10:50:00',15.08),('6449','2013-03-10','10:55:00',14.95),('6449','2013-03-10','11:00:00',15.49),('6449','2013-03-10','11:05:00',15.48),('6449','2013-03-10','11:10:00',15.66),('6449','2013-03-10','11:15:00',15.68),('6449','2013-03-10','11:20:00',15.85),('6449','2013-03-10','11:25:00',15.71),('6449','2013-03-10','11:30:00',16.13),('6449','2013-03-10','11:35:00',16.28),('6449','2013-03-10','11:40:00',16.27),('6449','2013-03-10','11:45:00',16.23),('6449','2013-03-10','11:50:00',16.27),('6449','2013-03-10','11:55:00',16.2),('6449','2013-03-10','12:00:00',16.18),('6449','2013-03-10','12:05:00',16.22),('6449','2013-03-10','12:10:00',16.2),('6449','2013-03-10','12:15:00',16.09),('6449','2013-03-10','12:20:00',15.86),('6449','2013-03-10','12:25:00',16),('6449','2013-03-10','12:30:00',16.01),('6449','2013-03-10','12:35:00',16.05),('6449','2013-03-10','12:40:00',15.88),('6449','2013-03-10','12:45:00',12.51),('6449','2013-03-10','12:50:00',11.74),('6449','2013-03-10','12:55:00',10.85),('6449','2013-03-10','13:00:00',14.2),('6449','2013-03-10','13:05:00',10.58),('6449','2013-03-10','13:10:00',12.12),('6449','2013-03-10','13:15:00',9.16),('6449','2013-03-10','13:20:00',6.97),('6449','2013-03-10','13:25:00',7.3),('6449','2013-03-10','13:30:00',9.39),('6449','2013-03-10','13:35:00',7.49),('6449','2013-03-10','13:40:00',6.99),('6449','2013-03-10','13:45:00',4.24),('6449','2013-03-10','13:50:00',3.71),('6449','2013-03-10','13:55:00',3.34),('6449','2013-03-10','14:00:00',3.52),('6449','2013-03-10','14:05:00',4.21),('6449','2013-03-10','14:10:00',5.16),('6449','2013-03-10','14:15:00',4.43),('6449','2013-03-10','14:20:00',3.7),('6449','2013-03-10','14:25:00',6.15),('6449','2013-03-10','14:30:00',8.23),('6449','2013-03-10','14:35:00',5.88),('6449','2013-03-10','14:40:00',4.18),('6449','2013-03-10','14:45:00',3.54),('6449','2013-03-10','14:50:00',2.67),('6449','2013-03-10','14:55:00',2.36),('6449','2013-03-10','15:00:00',2.4),('6449','2013-03-10','15:05:00',2.11),('6449','2013-03-10','15:10:00',1.13),('6449','2013-03-10','15:25:00',1.05),('6449','2013-03-10','15:30:00',1.08),('6449','2013-03-10','15:35:00',1.26),('6449','2013-03-10','15:40:00',1.27),('6449','2013-03-09','07:25:00',1.31),('6449','2013-03-09','07:30:00',1.99),('6449','2013-03-09','07:35:00',3.56),('6449','2013-03-09','07:40:00',3.85),('6449','2013-03-09','07:45:00',4.37),('6449','2013-03-09','07:50:00',4.78),('6449','2013-03-09','07:55:00',5.14),('6449','2013-03-09','08:00:00',5.58),('6449','2013-03-09','08:05:00',6.36),('6449','2013-03-09','08:10:00',7.39),('6449','2013-03-09','08:15:00',6.91),('6449','2013-03-09','08:20:00',7.41),('6449','2013-03-09','08:25:00',7.99),('6449','2013-03-09','08:30:00',8.26),('6449','2013-03-09','08:35:00',8.61),('6449','2013-03-09','08:40:00',8.97),('6449','2013-03-09','08:45:00',9.35),('6449','2013-03-09','08:50:00',9.7),('6449','2013-03-09','08:55:00',9.95),('6449','2013-03-09','09:00:00',10.37),('6449','2013-03-09','09:05:00',10.74),('6449','2013-03-09','09:10:00',10.95),('6449','2013-03-09','09:15:00',11.2),('6449','2013-03-09','09:20:00',11.36),('6449','2013-03-09','09:25:00',11.39),('6449','2013-03-09','09:30:00',11.98),('6449','2013-03-09','09:35:00',12.14),('6449','2013-03-09','09:40:00',12.46),('6449','2013-03-09','09:45:00',12.75),('6449','2013-03-09','09:50:00',12.95),('6449','2013-03-09','09:55:00',12.94),('6449','2013-03-09','10:00:00',13.41),('6449','2013-03-09','10:05:00',13.62),('6449','2013-03-09','10:10:00',13.87),('6449','2013-03-09','10:15:00',14.09),('6449','2013-03-09','10:20:00',14.22),('6449','2013-03-09','10:25:00',14.39),('6449','2013-03-09','10:30:00',14.6),('6449','2013-03-09','10:35:00',14.74),('6449','2013-03-09','10:40:00',14.75),('6449','2013-03-09','10:45:00',15.17),('6449','2013-03-09','10:50:00',15.37),('6449','2013-03-09','10:55:00',15.5),('6449','2013-03-09','11:00:00',15.6),('6449','2013-03-09','11:05:00',15.69),('6449','2013-03-09','11:10:00',15.73),('6449','2013-03-09','11:15:00',15.46),('6449','2013-03-09','11:20:00',15.92),('6449','2013-03-09','11:25:00',15.95),('6449','2013-03-09','11:30:00',16.01),('6449','2013-03-09','11:35:00',16.05),('6449','2013-03-09','11:40:00',16.09),('6449','2013-03-09','11:45:00',15.79),('6449','2013-03-09','11:50:00',16.08),('6449','2013-03-09','11:55:00',16.15),('6449','2013-03-09','12:00:00',16.24),('6449','2013-03-09','12:05:00',16.36),('6449','2013-03-09','12:10:00',15.55),('6449','2013-03-09','12:15:00',13.96),('6449','2013-03-09','12:20:00',16.31),('6449','2013-03-09','12:25:00',16.42),('6449','2013-03-09','12:30:00',17.01),('6449','2013-03-09','12:35:00',16.38),('6449','2013-03-09','12:40:00',16.17),('6449','2013-03-09','12:45:00',15.99),('6449','2013-03-09','12:50:00',15.9),('6449','2013-03-09','12:55:00',15.73),('6449','2013-03-09','13:00:00',15.25),('6449','2013-03-09','13:05:00',15.86),('6449','2013-03-09','13:10:00',12.81),('6449','2013-03-09','13:15:00',17.13),('6449','2013-03-09','13:20:00',15.58),('6449','2013-03-09','13:25:00',14.89),('6449','2013-03-09','13:30:00',14.45),('6449','2013-03-09','13:35:00',13.56),('6449','2013-03-09','13:40:00',14.38),('6449','2013-03-09','13:45:00',14.24),('6449','2013-03-09','13:50:00',14.22),('6449','2013-03-09','13:55:00',13.79),('6449','2013-03-09','14:00:00',12.39),('6449','2013-03-09','14:05:00',13.32),('6449','2013-03-09','14:10:00',11.69),('6449','2013-03-09','14:15:00',12.8),('6449','2013-03-09','14:20:00',12.7),('6449','2013-03-09','14:25:00',12.59),('6449','2013-03-09','14:30:00',12.45),('6449','2013-03-09','14:35:00',12.22),('6449','2013-03-09','14:40:00',11.97),('6449','2013-03-09','14:45:00',11.5),('6449','2013-03-09','14:50:00',11.27),('6449','2013-03-09','14:55:00',11.06),('6449','2013-03-09','15:00:00',10.72),('6449','2013-03-09','15:05:00',10.46),('6449','2013-03-09','15:10:00',10.15),('6449','2013-03-09','15:15:00',9.87),('6449','2013-03-09','15:20:00',9.57),('6449','2013-03-09','15:25:00',9.54),('6449','2013-03-09','15:30:00',8.51),('6449','2013-03-09','15:35:00',8.73),('6449','2013-03-09','15:40:00',8.34),('6449','2013-03-09','15:45:00',7.75),('6449','2013-03-09','15:50:00',7.21),('6449','2013-03-09','15:55:00',5.98),('6449','2013-03-09','16:00:00',5.47),('6449','2013-03-09','16:05:00',3.93),('6449','2013-03-09','16:10:00',3.94),('6449','2013-03-09','16:15:00',2.81),('6449','2013-03-09','16:20:00',2.83),('6449','2013-03-09','16:25:00',4.1),('6449','2013-03-09','16:30:00',3.07),('6449','2013-03-09','16:35:00',2.8),('6449','2013-03-09','16:40:00',2.2),('6449','2013-03-09','16:45:00',2.03),('6449','2013-03-09','16:50:00',1.92),('6449','2013-03-09','16:55:00',1.55),('6449','2013-03-09','17:00:00',1.15),('6449','2013-03-08','07:45:00',1.09),('6449','2013-03-08','07:50:00',1.17),('6449','2013-03-08','07:55:00',1.39),('6449','2013-03-08','08:00:00',1.39),('6449','2013-03-08','08:05:00',1.38),('6449','2013-03-08','08:10:00',2.28),('6449','2013-03-08','08:15:00',2.66),('6449','2013-03-08','08:20:00',1.22),('6449','2013-03-08','08:25:00',1.43),('6449','2013-03-08','08:30:00',1.62),('6449','2013-03-08','08:35:00',1.1),('6449','2013-03-08','08:40:00',1.25),('6449','2013-03-08','08:45:00',2.39),('6449','2013-03-08','08:50:00',3.54),('6449','2013-03-08','08:55:00',3.44),('6449','2013-03-08','09:00:00',3.22),('6449','2013-03-08','09:05:00',3.5),('6449','2013-03-08','09:10:00',4.16),('6449','2013-03-08','09:15:00',2.89),('6449','2013-03-08','09:20:00',2.11),('6449','2013-03-08','09:25:00',2.68),('6449','2013-03-08','09:30:00',3.06),('6449','2013-03-08','09:35:00',3.26),('6449','2013-03-08','09:40:00',4.42),('6449','2013-03-08','09:45:00',3.73),('6449','2013-03-08','09:50:00',3.49),('6449','2013-03-08','09:55:00',3.23),('6449','2013-03-08','10:00:00',2.93),('6449','2013-03-08','10:05:00',4.44),('6449','2013-03-08','10:10:00',7.08),('6449','2013-03-08','10:15:00',7.88),('6449','2013-03-08','10:20:00',4.51),('6449','2013-03-08','10:25:00',2.46),('6449','2013-03-08','10:30:00',1.9),('6449','2013-03-08','10:35:00',2.55),('6449','2013-03-08','10:40:00',2.94),('6449','2013-03-08','10:45:00',2.42),('6449','2013-03-08','10:50:00',1.28),('6449','2013-03-08','10:55:00',1.26),('6449','2013-03-08','11:00:00',1.86),('6449','2013-03-08','11:05:00',2.63),('6449','2013-03-08','11:10:00',1.36),('6449','2013-03-08','11:15:00',1.26),('6449','2013-03-08','11:20:00',2.21),('6449','2013-03-08','11:25:00',2.66),('6449','2013-03-08','11:30:00',3.38),('6449','2013-03-08','11:35:00',3.62),('6449','2013-03-08','11:40:00',3.04),('6449','2013-03-08','11:45:00',1.91),('6449','2013-03-08','11:50:00',2.52),('6449','2013-03-08','11:55:00',2.13),('6449','2013-03-08','12:00:00',1.43),('6449','2013-03-08','12:05:00',1.34),('6449','2013-03-08','12:10:00',1.73),('6449','2013-03-08','12:15:00',2.58),('6449','2013-03-08','12:20:00',2.97),('6449','2013-03-08','12:25:00',2.72),('6449','2013-03-08','12:30:00',3.32),('6449','2013-03-08','12:35:00',2.93),('6449','2013-03-08','12:40:00',2.02),('6449','2013-03-08','12:45:00',1.92),('6449','2013-03-08','12:50:00',1.37),('6449','2013-03-08','12:55:00',1.18),('6449','2013-03-08','13:00:00',1.89),('6449','2013-03-08','13:05:00',1.66),('6449','2013-03-08','13:10:00',2.56),('6449','2013-03-08','13:15:00',2.9),('6449','2013-03-08','13:20:00',2.83),('6449','2013-03-08','13:25:00',4.5),('6449','2013-03-08','13:30:00',5.18),('6449','2013-03-08','13:35:00',3.04),('6449','2013-03-08','13:40:00',1.65),('6449','2013-03-08','13:45:00',1.01),('6449','2013-03-08','13:50:00',1.06),('6449','2013-03-08','15:30:00',1.32),('6449','2013-03-08','15:35:00',1.28),('6449','2013-03-07','08:20:00',1.04),('6449','2013-03-07','08:25:00',1.17),('6449','2013-03-07','08:30:00',2.42),('6449','2013-03-07','08:35:00',3.14),('6449','2013-03-07','08:40:00',3.27),('6449','2013-03-07','08:45:00',3.98),('6449','2013-03-07','08:50:00',3.82),('6449','2013-03-07','08:55:00',2.79),('6449','2013-03-07','09:00:00',2.87),('6449','2013-03-07','09:05:00',2.19),('6449','2013-03-07','09:10:00',1.79),('6449','2013-03-07','09:15:00',1.78),('6449','2013-03-07','09:20:00',1.48),('6449','2013-03-07','09:25:00',1.89),('6449','2013-03-07','09:30:00',2.67),('6449','2013-03-07','09:35:00',2.91),('6449','2013-03-07','09:40:00',2.99),('6449','2013-03-07','09:45:00',3.75),('6449','2013-03-07','09:50:00',4.13),('6449','2013-03-07','09:55:00',4.22),('6449','2013-03-07','10:00:00',4.29),('6449','2013-03-07','10:05:00',3.91),('6449','2013-03-07','10:10:00',3.56),('6449','2013-03-07','10:15:00',3.94),('6449','2013-03-07','10:20:00',4.23),('6449','2013-03-07','10:25:00',5.15),('6449','2013-03-07','10:30:00',7.8),('6449','2013-03-07','10:35:00',4.29),('6449','2013-03-07','10:40:00',2.93),('6449','2013-03-07','10:45:00',3.49),('6449','2013-03-07','10:50:00',2.93),('6449','2013-03-07','10:55:00',3.59),('6449','2013-03-07','11:00:00',4.19),('6449','2013-03-07','11:05:00',4.65),('6449','2013-03-07','11:10:00',5.69),('6449','2013-03-07','11:15:00',6.32),('6449','2013-03-07','11:20:00',7.51),('6449','2013-03-07','11:25:00',9.94),('6449','2013-03-07','11:30:00',13.41),('6449','2013-03-07','11:35:00',13.77),('6449','2013-03-07','11:40:00',12.31),('6449','2013-03-07','11:45:00',11.64),('6449','2013-03-07','11:50:00',11.74),('6449','2013-03-07','11:55:00',7.22),('6449','2013-03-07','12:00:00',5.34),('6449','2013-03-07','12:05:00',4.68),('6449','2013-03-07','12:10:00',3.41),('6449','2013-03-07','12:15:00',3.71),('6449','2013-03-07','12:20:00',5.1),('6449','2013-03-07','12:25:00',5.97),('6449','2013-03-07','12:30:00',6.99),('6449','2013-03-07','12:35:00',8.67),('6449','2013-03-07','12:40:00',10.65),('6449','2013-03-07','12:45:00',10.61),('6449','2013-03-07','12:50:00',8.92),('6449','2013-03-07','12:55:00',7.47),('6449','2013-03-07','13:00:00',7.83),('6449','2013-03-07','13:05:00',7.91),('6449','2013-03-07','13:10:00',6.54),('6449','2013-03-07','13:15:00',7.34),('6449','2013-03-07','13:20:00',6.73),('6449','2013-03-07','13:25:00',7.8),('6449','2013-03-07','13:30:00',9.09),('6449','2013-03-07','13:35:00',9.61),('6449','2013-03-07','13:40:00',4.79),('6449','2013-03-07','13:45:00',3.09),('6449','2013-03-07','13:50:00',1.41),('6449','2013-03-07','13:55:00',1.16),('6449','2013-03-07','14:00:00',1.26),('6449','2013-03-07','14:15:00',1.22),('6449','2013-03-07','14:20:00',1.6),('6449','2013-03-07','14:25:00',3.21),('6449','2013-03-07','14:30:00',3.52),('6449','2013-03-07','14:35:00',3.03),('6449','2013-03-07','14:40:00',3.13),('6449','2013-03-07','14:45:00',2.05),('6449','2013-03-07','14:50:00',2.85),('6449','2013-03-07','14:55:00',5.58),('6449','2013-03-07','15:00:00',7.02),('6449','2013-03-07','15:05:00',5.13),('6449','2013-03-07','15:10:00',4.46),('6449','2013-03-07','15:15:00',3.94),('6449','2013-03-07','15:20:00',3.2),('6449','2013-03-07','15:25:00',2.54),('6449','2013-03-07','15:30:00',2.37),('6449','2013-03-07','15:35:00',2.18),('6449','2013-03-07','15:40:00',2.5),('6449','2013-03-07','15:45:00',2.4),('6449','2013-03-07','15:50:00',1.48),('6449','2013-03-07','15:55:00',2.08),('6449','2013-03-07','16:00:00',2.21),('6449','2013-03-07','16:05:00',2.43),('6449','2013-03-07','16:10:00',2.31),('6449','2013-03-07','16:15:00',2.13),('6449','2013-03-07','16:20:00',3.21),('6449','2013-03-07','16:25:00',2.84),('6449','2013-03-07','16:30:00',2.31),('6449','2013-03-07','16:35:00',1.51),('6449','2013-03-07','16:40:00',1.09),('6449','2013-03-06','09:20:00',1.01),('6449','2013-03-06','09:25:00',1.19),('6449','2013-03-06','09:30:00',1.37),('6449','2013-03-06','09:35:00',1.69),('6449','2013-03-06','09:40:00',2.17),('6449','2013-03-06','09:45:00',1.98),('6449','2013-03-06','09:50:00',2.01),('6449','2013-03-06','09:55:00',1.58),('6449','2013-03-06','10:00:00',1.21),('6449','2013-03-06','10:05:00',1.04),('6449','2013-03-06','10:15:00',1.14),('6449','2013-03-06','10:20:00',1.18),('6449','2013-03-06','10:55:00',1.14),('6449','2013-03-06','11:00:00',1.08),('6449','2013-03-06','12:20:00',1.08),('6449','2013-03-06','12:25:00',1),('6449','2013-03-06','12:35:00',1.27),('6449','2013-03-06','12:40:00',1.45),('6449','2013-03-06','12:45:00',1.57),('6449','2013-03-05','07:30:00',1.08),('6449','2013-03-05','07:35:00',1.74),('6449','2013-03-05','07:40:00',1.52),('6449','2013-03-05','07:45:00',1.55),('6449','2013-03-05','07:50:00',2.5),('6449','2013-03-05','07:55:00',4.14),('6449','2013-03-05','08:00:00',3.9),('6449','2013-03-05','08:05:00',4.35),('6449','2013-03-05','08:10:00',4.51),('6449','2013-03-05','08:15:00',4.81),('6449','2013-03-05','08:20:00',5.91),('6449','2013-03-05','08:25:00',6.31),('6449','2013-03-05','08:30:00',6.23),('6449','2013-03-05','08:35:00',5.69),('6449','2013-03-05','08:40:00',5.75),('6449','2013-03-05','08:45:00',4.85),('6449','2013-03-05','08:50:00',3.94),('6449','2013-03-05','08:55:00',3.68),('6449','2013-03-05','09:00:00',3.75),('6449','2013-03-05','09:05:00',4.12),('6449','2013-03-05','09:10:00',4.41),('6449','2013-03-05','09:15:00',4.38),('6449','2013-03-05','09:20:00',4.38),('6449','2013-03-05','09:25:00',4.52),('6449','2013-03-05','09:30:00',4.63),('6449','2013-03-05','09:35:00',4.56),('6449','2013-03-05','09:40:00',4.92),('6449','2013-03-05','09:45:00',6.44),('6449','2013-03-05','09:50:00',5.6),('6449','2013-03-05','09:55:00',5.45),('6449','2013-03-05','10:00:00',5.64),('6449','2013-03-05','10:05:00',7.08),('6449','2013-03-05','10:10:00',7.81),('6449','2013-03-05','10:15:00',8.16),('6449','2013-03-05','10:20:00',8.25),('6449','2013-03-05','10:25:00',9.36),('6449','2013-03-05','10:30:00',9.9),('6449','2013-03-05','10:35:00',9.94),('6449','2013-03-05','10:40:00',9.59),('6449','2013-03-05','10:45:00',9.9),('6449','2013-03-05','10:50:00',10.7),('6449','2013-03-05','10:55:00',11.83),('6449','2013-03-05','11:00:00',10.87),('6449','2013-03-05','11:05:00',10.79),('6449','2013-03-05','11:10:00',9.98),('6449','2013-03-05','11:15:00',8.74),('6449','2013-03-05','11:20:00',8.55),('6449','2013-03-05','11:25:00',9.84),('6449','2013-03-05','11:30:00',10.59),('6449','2013-03-05','11:35:00',11.75),('6449','2013-03-05','11:40:00',11.91),('6449','2013-03-05','11:45:00',12.76),('6449','2013-03-05','11:50:00',11.87),('6449','2013-03-05','11:55:00',11.48),('6449','2013-03-05','12:00:00',9.34),('6449','2013-03-05','12:05:00',10.29),('6449','2013-03-05','12:10:00',9.51),('6449','2013-03-05','12:15:00',9.42),('6449','2013-03-05','12:20:00',10.04),('6449','2013-03-05','12:25:00',9.02),('6449','2013-03-05','12:30:00',7.64),('6449','2013-03-05','12:35:00',8.65),('6449','2013-03-05','12:40:00',8.54),('6449','2013-03-05','12:45:00',6.92),('6449','2013-03-05','12:50:00',5.79),('6449','2013-03-05','12:55:00',5.63),('6449','2013-03-05','13:00:00',5.65),('6449','2013-03-05','13:05:00',5.26),('6449','2013-03-05','13:10:00',4.76),('6449','2013-03-05','13:15:00',4.27),('6449','2013-03-05','13:20:00',3.71),('6449','2013-03-05','13:25:00',3.22),('6449','2013-03-05','13:30:00',3.33),('6449','2013-03-05','13:35:00',3.38),('6449','2013-03-05','13:40:00',3.58),('6449','2013-03-05','13:45:00',4.07),('6449','2013-03-05','13:50:00',4.11),('6449','2013-03-05','13:55:00',4.16),('6449','2013-03-05','14:00:00',4.84),('6449','2013-03-05','14:05:00',4.87),('6449','2013-03-05','14:10:00',4.84),('6449','2013-03-05','14:15:00',4.9),('6449','2013-03-05','14:20:00',4.55),('6449','2013-03-05','14:25:00',4.09),('6449','2013-03-05','14:30:00',3.67),('6449','2013-03-05','14:35:00',3.57),('6449','2013-03-05','14:40:00',3.46),('6449','2013-03-05','14:45:00',3.31),('6449','2013-03-05','14:50:00',3.35),('6449','2013-03-05','14:55:00',3.15),('6449','2013-03-05','15:00:00',2.84),('6449','2013-03-05','15:05:00',2.36),('6449','2013-03-05','15:10:00',2.38),('6449','2013-03-05','15:15:00',2.66),('6449','2013-03-05','15:20:00',2.5),('6449','2013-03-05','15:25:00',2.71),('6449','2013-03-05','15:30:00',2.91),('6449','2013-03-05','15:35:00',3.18),('6449','2013-03-05','15:40:00',3.95),('6449','2013-03-05','15:45:00',4.66),('6449','2013-03-05','15:50:00',4.13),('6449','2013-03-05','15:55:00',3.1),('6449','2013-03-05','16:00:00',2.32),('6449','2013-03-05','16:05:00',2.01),('6449','2013-03-05','16:10:00',1.81),('6449','2013-03-05','16:15:00',1.59),('6449','2013-03-05','16:20:00',1.38),('6449','2013-03-05','16:25:00',1.25),('6449','2013-03-05','16:30:00',1.2),('6449','2013-03-05','16:35:00',1.08),('6449','2013-03-04','07:10:00',1.01),('6449','2013-03-04','07:15:00',1.21),('6449','2013-03-04','07:20:00',1.58),('6449','2013-03-04','07:25:00',1.87),('6449','2013-03-04','07:30:00',2.26),('6449','2013-03-04','07:35:00',2.72),('6449','2013-03-04','07:40:00',3.12),('6449','2013-03-04','07:45:00',3.49),('6449','2013-03-04','07:50:00',3.96),('6449','2013-03-04','07:55:00',4.44),('6449','2013-03-04','08:00:00',4.82),('6449','2013-03-04','08:05:00',5.28),('6449','2013-03-04','08:10:00',5.74),('6449','2013-03-04','08:15:00',6.15),('6449','2013-03-04','08:20:00',6.56),('6449','2013-03-04','08:25:00',6.98),('6449','2013-03-04','08:30:00',7.38),('6449','2013-03-04','08:35:00',7.79),('6449','2013-03-04','08:40:00',8.21),('6449','2013-03-04','08:45:00',8.57),('6449','2013-03-04','08:50:00',8.9),('6449','2013-03-04','08:55:00',9.33),('6449','2013-03-04','09:00:00',9.63),('6449','2013-03-04','09:05:00',10.1),('6449','2013-03-04','09:10:00',10.47),('6449','2013-03-04','09:15:00',10.77),('6449','2013-03-04','09:20:00',11.15),('6449','2013-03-04','09:25:00',11.44),('6449','2013-03-04','09:30:00',11.76),('6449','2013-03-04','09:35:00',12.03),('6449','2013-03-04','09:40:00',12.35),('6449','2013-03-04','09:45:00',12.46),('6449','2013-03-04','09:50:00',12.85),('6449','2013-03-04','09:55:00',13.07),('6449','2013-03-04','10:00:00',13.22),('6449','2013-03-04','10:05:00',13.36),('6449','2013-03-04','10:10:00',13.55),('6449','2013-03-04','10:15:00',13.72),('6449','2013-03-04','10:20:00',13.86),('6449','2013-03-04','10:25:00',14.05),('6449','2013-03-04','10:30:00',14.16),('6449','2013-03-04','10:35:00',14.31),('6449','2013-03-04','10:40:00',14.33),('6449','2013-03-04','10:45:00',14.51),('6449','2013-03-04','10:50:00',14.28),('6449','2013-03-04','10:55:00',14.75),('6449','2013-03-04','11:00:00',14.77),('6449','2013-03-04','11:05:00',15.03),('6449','2013-03-04','11:10:00',14.95),('6449','2013-03-04','11:15:00',14.84),('6449','2013-03-04','11:20:00',14.8),('6449','2013-03-04','11:25:00',15.21),('6449','2013-03-04','11:30:00',15.43),('6449','2013-03-04','11:35:00',13.89),('6449','2013-03-04','11:40:00',15.09),('6449','2013-03-04','11:45:00',15.26),('6449','2013-03-04','11:50:00',15.38),('6449','2013-03-04','11:55:00',15.54),('6449','2013-03-04','12:00:00',15.67),('6449','2013-03-04','12:05:00',15.77),('6449','2013-03-04','12:10:00',15.96),('6449','2013-03-04','12:15:00',15.96),('6449','2013-03-04','12:20:00',15.94),('6449','2013-03-04','12:25:00',15.89),('6449','2013-03-04','12:30:00',15.81),('6449','2013-03-04','12:35:00',15.6),('6449','2013-03-04','12:40:00',15.76),('6449','2013-03-04','12:45:00',15.74),('6449','2013-03-04','12:50:00',15.71),('6449','2013-03-04','12:55:00',15.74),('6449','2013-03-04','13:00:00',16.11),('6449','2013-03-04','13:05:00',16.4),('6449','2013-03-04','13:10:00',16.02),('6449','2013-03-04','13:15:00',15.26),('6449','2013-03-04','13:20:00',14.79),('6449','2013-03-04','13:25:00',14.84),('6449','2013-03-04','13:30:00',14.66),('6449','2013-03-04','13:35:00',14.47),('6449','2013-03-04','13:40:00',14.36),('6449','2013-03-04','13:45:00',14.26),('6449','2013-03-04','13:50:00',14.1),('6449','2013-03-04','13:55:00',13.92),('6449','2013-03-04','14:00:00',13.63),('6449','2013-03-04','14:05:00',13.46),('6449','2013-03-04','14:10:00',13.26),('6449','2013-03-04','14:15:00',13.12),('6449','2013-03-04','14:20:00',12.8),('6449','2013-03-04','14:25:00',12.69),('6449','2013-03-04','14:30:00',12.5),('6449','2013-03-04','14:35:00',12.31),('6449','2013-03-04','14:40:00',11.98),('6449','2013-03-04','14:45:00',11.6),('6449','2013-03-04','14:50:00',11.27),('6449','2013-03-04','14:55:00',11.13),('6449','2013-03-04','15:00:00',10.82),('6449','2013-03-04','15:05:00',10.49),('6449','2013-03-04','15:10:00',10.19),('6449','2013-03-04','15:15:00',9.92),('6449','2013-03-04','15:20:00',9.6),('6449','2013-03-04','15:25:00',9.26),('6449','2013-03-04','15:30:00',8.99),('6449','2013-03-04','15:35:00',8.72),('6449','2013-03-04','15:40:00',8.22),('6449','2013-03-04','15:45:00',7.92),('6449','2013-03-04','15:50:00',7.56),('6449','2013-03-04','15:55:00',7.19),('6449','2013-03-04','16:00:00',6.95),('6449','2013-03-04','16:05:00',6.34),('6449','2013-03-04','16:10:00',6.03),('6449','2013-03-04','16:15:00',5.64),('6449','2013-03-04','16:20:00',5.26),('6449','2013-03-04','16:25:00',4.89),('6449','2013-03-04','16:30:00',4.51),('6449','2013-03-04','16:35:00',4.14),('6449','2013-03-04','16:40:00',3.79),('6449','2013-03-04','16:45:00',3.42),('6449','2013-03-04','16:50:00',3.01),('6449','2013-03-04','16:55:00',2.73),('6449','2013-03-04','17:00:00',2.41),('6449','2013-03-04','17:05:00',2.06),('6449','2013-03-04','17:10:00',1.78),('6449','2013-03-04','17:15:00',1.47),('6449','2013-03-04','17:20:00',1.22),('6449','2013-03-03','07:10:00',1.21),('6449','2013-03-03','07:15:00',1.52),('6449','2013-03-03','07:20:00',1.85),('6449','2013-03-03','07:25:00',2.23),('6449','2013-03-03','07:30:00',2.66),('6449','2013-03-03','07:35:00',3.07),('6449','2013-03-03','07:40:00',3.52),('6449','2013-03-03','07:45:00',3.96),('6449','2013-03-03','07:50:00',4.33),('6449','2013-03-03','07:55:00',4.83),('6449','2013-03-03','08:00:00',5.29),('6449','2013-03-03','08:05:00',5.67),('6449','2013-03-03','08:10:00',6.19),('6449','2013-03-03','08:15:00',6.63),('6449','2013-03-03','08:20:00',7.06),('6449','2013-03-03','08:25:00',7.49),('6449','2013-03-03','08:30:00',7.94),('6449','2013-03-03','08:35:00',8.35),('6449','2013-03-03','08:40:00',8.78),('6449','2013-03-03','08:45:00',9.17),('6449','2013-03-03','08:50:00',9.59),('6449','2013-03-03','08:55:00',9.99),('6449','2013-03-03','09:00:00',10.36),('6449','2013-03-03','09:05:00',10.71),('6449','2013-03-03','09:10:00',11.05),('6449','2013-03-03','09:15:00',11.39),('6449','2013-03-03','09:20:00',11.68),('6449','2013-03-03','09:25:00',11.98),('6449','2013-03-03','09:30:00',12.29),('6449','2013-03-03','09:35:00',12.54),('6449','2013-03-03','09:40:00',12.93),('6449','2013-03-03','09:45:00',13.21),('6449','2013-03-03','09:50:00',13.4),('6449','2013-03-03','09:55:00',13.72),('6449','2013-03-03','10:00:00',13.9),('6449','2013-03-03','10:05:00',14.1),('6449','2013-03-03','10:10:00',14.32),('6449','2013-03-03','10:15:00',14.54),('6449','2013-03-03','10:20:00',14.64),('6449','2013-03-03','10:25:00',14.83),('6449','2013-03-03','10:30:00',15.02),('6449','2013-03-03','10:35:00',15.2),('6449','2013-03-03','10:40:00',15.35),('6449','2013-03-03','10:45:00',15.41),('6449','2013-03-03','10:50:00',15.51),('6449','2013-03-03','10:55:00',15.61),('6449','2013-03-03','11:00:00',15.75),('6449','2013-03-03','11:05:00',15.79),('6449','2013-03-03','11:10:00',15.87),('6449','2013-03-03','11:15:00',15.96),('6449','2013-03-03','11:20:00',15.66),('6449','2013-03-03','11:25:00',15.92),('6449','2013-03-03','11:30:00',15.88),('6449','2013-03-03','11:35:00',15.74),('6449','2013-03-03','11:40:00',15.94),('6449','2013-03-03','11:45:00',15.98),('6449','2013-03-03','11:50:00',15.91),('6449','2013-03-03','11:55:00',15.87),('6449','2013-03-03','12:00:00',15.92),('6449','2013-03-03','12:05:00',15.86),('6449','2013-03-03','12:10:00',15.87),('6449','2013-03-03','12:15:00',15.76),('6449','2013-03-03','12:20:00',15.62),('6449','2013-03-03','12:25:00',15.54),('6449','2013-03-03','12:30:00',15.46),('6449','2013-03-03','12:35:00',15.39),('6449','2013-03-03','12:40:00',15.4),('6449','2013-03-03','12:45:00',15.65),('6449','2013-03-03','12:50:00',15.67),('6449','2013-03-03','12:55:00',15.64),('6449','2013-03-03','13:00:00',15.52),('6449','2013-03-03','13:05:00',15.44),('6449','2013-03-03','13:10:00',15.07),('6449','2013-03-03','13:15:00',15.16),('6449','2013-03-03','13:20:00',15.04),('6449','2013-03-03','13:25:00',14.87),('6449','2013-03-03','13:30:00',14.87),('6449','2013-03-03','13:35:00',14.61),('6449','2013-03-03','13:40:00',14.5),('6449','2013-03-03','13:45:00',14.44),('6449','2013-03-03','13:50:00',14.26),('6449','2013-03-03','13:55:00',13.93),('6449','2013-03-03','14:00:00',13.77),('6449','2013-03-03','14:05:00',13.56),('6449','2013-03-03','14:10:00',13.3),('6449','2013-03-03','14:15:00',13.08),('6449','2013-03-03','14:20:00',12.96),('6449','2013-03-03','14:25:00',12.73),('6449','2013-03-03','14:30:00',12.63),('6449','2013-03-03','14:35:00',12.51),('6449','2013-03-03','14:40:00',12.17),('6449','2013-03-03','14:45:00',11.98),('6449','2013-03-03','14:50:00',11.69),('6449','2013-03-03','14:55:00',11.31),('6449','2013-03-03','15:00:00',11.26),('6449','2013-03-03','15:05:00',10.82),('6449','2013-03-03','15:10:00',10.36),('6449','2013-03-03','15:15:00',10.11),('6449','2013-03-03','15:20:00',9.85),('6449','2013-03-03','15:25:00',9.44),('6449','2013-03-03','15:30:00',9.11),('6449','2013-03-03','15:35:00',8.77),('6449','2013-03-03','15:40:00',8.39),('6449','2013-03-03','15:45:00',8.03),('6449','2013-03-03','15:50:00',7.66),('6449','2013-03-03','15:55:00',7.29),('6449','2013-03-03','16:00:00',6.91),('6449','2013-03-03','16:05:00',6.46),('6449','2013-03-03','16:10:00',6.1),('6449','2013-03-03','16:15:00',5.72),('6449','2013-03-03','16:20:00',5.31),('6449','2013-03-03','16:25:00',4.87),('6449','2013-03-03','16:30:00',4.55),('6449','2013-03-03','16:35:00',4.14),('6449','2013-03-03','16:40:00',3.71),('6449','2013-03-03','16:45:00',3.38),('6449','2013-03-03','16:50:00',2.99),('6449','2013-03-03','16:55:00',2.6),('6449','2013-03-03','17:00:00',2.3),('6449','2013-03-03','17:05:00',1.95),('6449','2013-03-03','17:10:00',1.65),('6449','2013-03-03','17:15:00',1.35),('6449','2013-03-03','17:20:00',1.09),('6449','2013-03-02','08:00:00',1.06),('6449','2013-03-02','08:05:00',1.04),('6449','2013-03-02','08:10:00',1.32),('6449','2013-03-02','08:15:00',1.34),('6449','2013-03-02','08:20:00',1.16),('6449','2013-03-02','08:25:00',1.32),('6449','2013-03-02','08:30:00',1.41),('6449','2013-03-02','08:35:00',1.17),('6449','2013-03-02','08:40:00',1.05),('6449','2013-03-02','09:25:00',1.52),('6449','2013-03-02','09:30:00',1.73),('6449','2013-03-02','09:35:00',1.67),('6449','2013-03-02','09:40:00',1.32),('6449','2013-03-02','09:45:00',1.24),('6449','2013-03-02','09:50:00',1.46),('6449','2013-03-02','09:55:00',1.61),('6449','2013-03-02','10:00:00',1.65),('6449','2013-03-02','10:05:00',1.78),('6449','2013-03-02','10:10:00',1.83),('6449','2013-03-02','10:15:00',1.98),('6449','2013-03-02','10:20:00',1.9),('6449','2013-03-02','10:25:00',1.93),('6449','2013-03-02','10:30:00',2.24),('6449','2013-03-02','10:35:00',2.84),('6449','2013-03-02','10:40:00',3.11),('6449','2013-03-02','10:45:00',3.61),('6449','2013-03-02','10:50:00',4.23),('6449','2013-03-02','10:55:00',4.83),('6449','2013-03-02','11:00:00',5.26),('6449','2013-03-02','11:05:00',5.72),('6449','2013-03-02','11:10:00',5.72),('6449','2013-03-02','11:15:00',6.15),('6449','2013-03-02','11:20:00',6.08),('6449','2013-03-02','11:25:00',5.91),('6449','2013-03-02','11:30:00',5.61),('6449','2013-03-02','11:35:00',7.76),('6449','2013-03-02','11:40:00',9.59),('6449','2013-03-02','11:45:00',9.76),('6449','2013-03-02','11:50:00',8.68),('6449','2013-03-02','11:55:00',5.39),('6449','2013-03-02','12:00:00',6.05),('6449','2013-03-02','12:05:00',9.56),('6449','2013-03-02','12:10:00',6.1),('6449','2013-03-02','12:15:00',5.59),('6449','2013-03-02','12:20:00',6.3),('6449','2013-03-02','12:25:00',6.54),('6449','2013-03-02','12:30:00',6.94),('6449','2013-03-02','12:35:00',6.42),('6449','2013-03-02','12:40:00',7.83),('6449','2013-03-02','12:45:00',8.24),('6449','2013-03-02','12:50:00',11.01),('6449','2013-03-02','12:55:00',14.96),('6449','2013-03-02','13:00:00',12.72),('6449','2013-03-02','13:05:00',13.17),('6449','2013-03-02','13:10:00',14.03),('6449','2013-03-02','13:15:00',14.88),('6449','2013-03-02','13:20:00',12.18),('6449','2013-03-02','13:25:00',7.68),('6449','2013-03-02','13:30:00',5.98),('6449','2013-03-02','13:35:00',4.97),('6449','2013-03-02','13:40:00',4.72),('6449','2013-03-02','13:45:00',4.69),('6449','2013-03-02','13:50:00',5.42),('6449','2013-03-02','13:55:00',5.05),('6449','2013-03-02','14:00:00',5.09),('6449','2013-03-02','14:05:00',4.53),('6449','2013-03-02','14:10:00',4.08),('6449','2013-03-02','14:15:00',3.79),('6449','2013-03-02','14:20:00',3.83),('6449','2013-03-02','14:25:00',3.32),('6449','2013-03-02','14:30:00',3.1),('6449','2013-03-02','14:35:00',3.25),('6449','2013-03-02','14:40:00',3.6),('6449','2013-03-02','14:45:00',3.96),('6449','2013-03-02','14:50:00',4.58),('6449','2013-03-02','14:55:00',4.75),('6449','2013-03-02','15:00:00',4.55),('6449','2013-03-02','15:05:00',4.7),('6449','2013-03-02','15:10:00',4.64),('6449','2013-03-02','15:15:00',4.18),('6449','2013-03-02','15:20:00',3.54),('6449','2013-03-02','15:25:00',3.06),('6449','2013-03-02','15:30:00',2.79),('6449','2013-03-02','15:35:00',3.08),('6449','2013-03-02','15:40:00',3.12),('6449','2013-03-02','15:45:00',2.99),('6449','2013-03-02','15:50:00',3.03),('6449','2013-03-02','15:55:00',3.3),('6449','2013-03-02','16:00:00',2.54),('6449','2013-03-02','16:05:00',1.65),('6449','2013-03-02','16:10:00',1.28),('6449','2013-03-02','16:15:00',1.21),('6449','2013-03-02','16:20:00',1.26),('6449','2013-03-02','16:25:00',1.34),('6449','2013-03-02','16:30:00',1.47),('6449','2013-03-02','16:35:00',1.41),('6449','2013-03-02','16:40:00',1.19),('6449','2013-03-02','16:45:00',1.01),('6449','2013-03-01','07:35:00',1.1),('6449','2013-03-01','07:40:00',1.39),('6449','2013-03-01','07:45:00',1.77),('6449','2013-03-01','07:50:00',2.18),('6449','2013-03-01','07:55:00',2.37),('6449','2013-03-01','08:00:00',2.63),('6449','2013-03-01','08:05:00',2.63),('6449','2013-03-01','08:10:00',2.57),('6449','2013-03-01','08:15:00',2.46),('6449','2013-03-01','08:20:00',2.83),('6449','2013-03-01','08:25:00',2.94),('6449','2013-03-01','08:30:00',3.13),('6449','2013-03-01','08:35:00',3.19),('6449','2013-03-01','08:40:00',3.38),('6449','2013-03-01','08:45:00',3.61),('6449','2013-03-01','08:50:00',3.79),('6449','2013-03-01','08:55:00',4.03),('6449','2013-03-01','09:00:00',4.58),('6449','2013-03-01','09:05:00',5.14),('6449','2013-03-01','09:10:00',5.34),('6449','2013-03-01','09:15:00',6.03),('6449','2013-03-01','09:20:00',7.5),('6449','2013-03-01','09:25:00',8.04),('6449','2013-03-01','09:30:00',8.45),('6449','2013-03-01','09:35:00',8.49),('6449','2013-03-01','09:40:00',7.81),('6449','2013-03-01','09:45:00',7.99),('6449','2013-03-01','09:50:00',7.96),('6449','2013-03-01','09:55:00',7.78),('6449','2013-03-01','10:00:00',7.87),('6449','2013-03-01','10:05:00',7.9),('6449','2013-03-01','10:10:00',7.25),('6449','2013-03-01','10:15:00',6.48),('6449','2013-03-01','10:20:00',6),('6449','2013-03-01','10:25:00',5.86),('6449','2013-03-01','10:30:00',5.6),('6449','2013-03-01','10:35:00',5.47),('6449','2013-03-01','10:40:00',5.49),('6449','2013-03-01','10:45:00',5.47),('6449','2013-03-01','10:50:00',5.38),('6449','2013-03-01','10:55:00',5.34),('6449','2013-03-01','11:00:00',5.26),('6449','2013-03-01','11:05:00',5.23),('6449','2013-03-01','11:10:00',5.33),('6449','2013-03-01','11:15:00',5.68),('6449','2013-03-01','11:20:00',5.85),('6449','2013-03-01','11:25:00',5.76),('6449','2013-03-01','11:30:00',6.02),('6449','2013-03-01','11:35:00',6.16),('6449','2013-03-01','11:40:00',6.28),('6449','2013-03-01','11:45:00',6.04),('6449','2013-03-01','11:50:00',5.8),('6449','2013-03-01','11:55:00',5.43),('6449','2013-03-01','12:00:00',5.28),('6449','2013-03-01','12:05:00',5.18),('6449','2013-03-01','12:10:00',5.18),('6449','2013-03-01','12:15:00',5.26),('6449','2013-03-01','12:20:00',5.45),('6449','2013-03-01','12:25:00',5.48),('6449','2013-03-01','12:30:00',5.3),('6449','2013-03-01','12:35:00',5.26),('6449','2013-03-01','12:40:00',5.68),('6449','2013-03-01','12:45:00',6.49),('6449','2013-03-01','12:50:00',6.44),('6449','2013-03-01','12:55:00',6.25),('6449','2013-03-01','13:00:00',6.06),('6449','2013-03-01','13:05:00',5.69),('6449','2013-03-01','13:10:00',5.47),('6449','2013-03-01','13:15:00',5.39),('6449','2013-03-01','13:20:00',5.06),('6449','2013-03-01','13:25:00',4.9),('6449','2013-03-01','13:30:00',4.71),('6449','2013-03-01','13:35:00',4.44),('6449','2013-03-01','13:40:00',3.96),('6449','2013-03-01','13:45:00',3.71),('6449','2013-03-01','13:50:00',3.5),('6449','2013-03-01','13:55:00',3.39),('6449','2013-03-01','14:00:00',3.42),('6449','2013-03-01','14:05:00',3.4),('6449','2013-03-01','14:10:00',3.39),('6449','2013-03-01','14:15:00',3.49),('6449','2013-03-01','14:20:00',3.65),('6449','2013-03-01','14:25:00',3.69),('6449','2013-03-01','14:30:00',3.68),('6449','2013-03-01','14:35:00',3.54),('6449','2013-03-01','14:40:00',3.48),('6449','2013-03-01','14:45:00',3.47),('6449','2013-03-01','14:50:00',3.38),('6449','2013-03-01','14:55:00',3.36),('6449','2013-03-01','15:00:00',3.33),('6449','2013-03-01','15:05:00',3.33),('6449','2013-03-01','15:10:00',2.95),('6449','2013-03-01','15:15:00',2.45),('6449','2013-03-01','15:20:00',2.08),('6449','2013-03-01','15:25:00',1.95),('6449','2013-03-01','15:30:00',1.96),('6449','2013-03-01','15:35:00',1.88),('6449','2013-03-01','15:40:00',1.66),('6449','2013-03-01','15:45:00',1.58),('6449','2013-03-01','15:50:00',1.8),('6449','2013-03-01','15:55:00',1.88),('6449','2013-03-01','16:00:00',1.78),('6449','2013-03-01','16:05:00',1.65),('6449','2013-03-01','16:10:00',1.38),('6449','2013-03-01','16:15:00',1.18),('6449','2013-03-01','16:20:00',1.11),('6449','2013-03-01','16:25:00',1.12),('6449','2013-03-01','16:30:00',1.06),('6449','2013-02-28','07:20:00',1.17),('6449','2013-02-28','07:25:00',1.42),('6449','2013-02-28','07:30:00',1.71),('6449','2013-02-28','07:35:00',2.04),('6449','2013-02-28','07:40:00',2.39),('6449','2013-02-28','07:45:00',2.76),('6449','2013-02-28','07:50:00',3.14),('6449','2013-02-28','07:55:00',3.55),('6449','2013-02-28','08:00:00',3.94),('6449','2013-02-28','08:05:00',4.32),('6449','2013-02-28','08:10:00',4.74),('6449','2013-02-28','08:15:00',5.12),('6449','2013-02-28','08:20:00',5.49),('6449','2013-02-28','08:25:00',5.76),('6449','2013-02-28','08:30:00',6.36),('6449','2013-02-28','08:35:00',6.8),('6449','2013-02-28','08:40:00',7.23),('6449','2013-02-28','08:45:00',7.33),('6449','2013-02-28','08:50:00',7.36),('6449','2013-02-28','08:55:00',8.33),('6449','2013-02-28','09:00:00',8.75),('6449','2013-02-28','09:05:00',9.12),('6449','2013-02-28','09:10:00',9.44),('6449','2013-02-28','09:15:00',9.77),('6449','2013-02-28','09:20:00',10.13),('6449','2013-02-28','09:25:00',10.49),('6449','2013-02-28','09:30:00',10.7),('6449','2013-02-28','09:35:00',10.76),('6449','2013-02-28','09:40:00',11.48),('6449','2013-02-28','09:45:00',11.76),('6449','2013-02-28','09:50:00',12.1),('6449','2013-02-28','09:55:00',12.38),('6449','2013-02-28','10:00:00',12.57),('6449','2013-02-28','10:05:00',12.76),('6449','2013-02-28','10:10:00',12.65),('6449','2013-02-28','10:15:00',13.13),('6449','2013-02-28','10:20:00',13.34),('6449','2013-02-28','10:25:00',13.4),('6449','2013-02-28','10:30:00',13.67),('6449','2013-02-28','10:35:00',13.81),('6449','2013-02-28','10:40:00',13.67),('6449','2013-02-28','10:45:00',14.09),('6449','2013-02-28','10:50:00',14.15),('6449','2013-02-28','10:55:00',14.34),('6449','2013-02-28','11:00:00',14.51),('6449','2013-02-28','11:05:00',13.1),('6449','2013-02-28','11:10:00',10.51),('6449','2013-02-28','11:15:00',14.71),('6449','2013-02-28','11:20:00',14.79),('6449','2013-02-28','11:25:00',15.01),('6449','2013-02-28','11:30:00',14.98),('6449','2013-02-28','11:35:00',15.19),('6449','2013-02-28','11:40:00',15.17),('6449','2013-02-28','11:45:00',15.28),('6449','2013-02-28','11:50:00',15.29),('6449','2013-02-28','11:55:00',14.78),('6449','2013-02-28','12:00:00',15.16),('6449','2013-02-28','12:05:00',15.14),('6449','2013-02-28','12:10:00',14.78),('6449','2013-02-28','12:15:00',14.91),('6449','2013-02-28','12:20:00',14.38),('6449','2013-02-28','12:25:00',14.01),('6449','2013-02-28','12:30:00',14.85),('6449','2013-02-28','12:35:00',14.57),('6449','2013-02-28','12:40:00',14.03),('6449','2013-02-28','12:45:00',14.81),('6449','2013-02-28','12:50:00',14.67),('6449','2013-02-28','12:55:00',14.54),('6449','2013-02-28','13:00:00',14.38),('6449','2013-02-28','13:05:00',14.15),('6449','2013-02-28','13:10:00',13.99),('6449','2013-02-28','13:15:00',13.92),('6449','2013-02-28','13:20:00',13.87),('6449','2013-02-28','13:25:00',14.12),('6449','2013-02-28','13:30:00',14.13),('6449','2013-02-28','13:35:00',14.12),('6449','2013-02-28','13:40:00',13.67),('6449','2013-02-28','13:45:00',13.59),('6449','2013-02-28','13:50:00',13.46),('6449','2013-02-28','13:55:00',13.14),('6449','2013-02-28','14:00:00',12.9),('6449','2013-02-28','14:05:00',12.78),('6449','2013-02-28','14:10:00',12.87),('6449','2013-02-28','14:15:00',12.44),('6449','2013-02-28','14:20:00',12.06),('6449','2013-02-28','14:25:00',12.04),('6449','2013-02-28','14:30:00',11.84),('6449','2013-02-28','14:35:00',11.36),('6449','2013-02-28','14:40:00',11.14),('6449','2013-02-28','14:45:00',10.86),('6449','2013-02-28','14:50:00',10.67),('6449','2013-02-28','14:55:00',10.57),('6449','2013-02-28','15:00:00',10.34),('6449','2013-02-28','15:05:00',10.02),('6449','2013-02-28','15:10:00',9.68),('6449','2013-02-28','15:15:00',9.05),('6449','2013-02-28','15:20:00',8.79),('6449','2013-02-28','15:25:00',8.53),('6449','2013-02-28','15:30:00',7.99),('6449','2013-02-28','15:35:00',7.77),('6449','2013-02-28','15:40:00',7.48),('6449','2013-02-28','15:45:00',7.05),('6449','2013-02-28','15:50:00',6.74),('6449','2013-02-28','15:55:00',6.45),('6449','2013-02-28','16:00:00',6.02),('6449','2013-02-28','16:05:00',5.83),('6449','2013-02-28','16:10:00',5.5),('6449','2013-02-28','16:15:00',5.14),('6449','2013-02-28','16:20:00',4.72),('6449','2013-02-28','16:25:00',4.32),('6449','2013-02-28','16:30:00',3.92),('6449','2013-02-28','16:35:00',3.59),('6449','2013-02-28','16:40:00',3.25),('6449','2013-02-28','16:45:00',2.89),('6449','2013-02-28','16:50:00',2.59),('6449','2013-02-28','16:55:00',2.27),('6449','2013-02-28','17:00:00',1.95),('6449','2013-02-28','17:05:00',1.66),('6449','2013-02-28','17:10:00',1.42),('6449','2013-02-28','17:15:00',1.13),('6449','2013-02-27','07:20:00',1.1),('6449','2013-02-27','07:25:00',1.37),('6449','2013-02-27','07:30:00',1.63),('6449','2013-02-27','07:35:00',1.99),('6449','2013-02-27','07:40:00',2.39),('6449','2013-02-27','07:45:00',2.73),('6449','2013-02-27','07:50:00',3.16),('6449','2013-02-27','07:55:00',3.56),('6449','2013-02-27','08:00:00',3.9),('6449','2013-02-27','08:05:00',4.36),('6449','2013-02-27','08:10:00',4.77),('6449','2013-02-27','08:15:00',5.14),('6449','2013-02-27','08:20:00',5.53),('6449','2013-02-27','08:25:00',5.97),('6449','2013-02-27','08:30:00',6.39),('6449','2013-02-27','08:35:00',6.78),('6449','2013-02-27','08:40:00',7.16),('6449','2013-02-27','08:45:00',7.57),('6449','2013-02-27','08:50:00',7.95),('6449','2013-02-27','08:55:00',8.35),('6449','2013-02-27','09:00:00',7.68),('6449','2013-02-27','09:05:00',9.06),('6449','2013-02-27','09:10:00',9.43),('6449','2013-02-27','09:15:00',9.64),('6449','2013-02-27','09:20:00',10.14),('6449','2013-02-27','09:25:00',10.53),('6449','2013-02-27','09:30:00',10.69),('6449','2013-02-27','09:35:00',11.16),('6449','2013-02-27','09:40:00',11.44),('6449','2013-02-27','09:45:00',11.69),('6449','2013-02-27','09:50:00',11.79),('6449','2013-02-27','09:55:00',12.19),('6449','2013-02-27','10:00:00',12.35),('6449','2013-02-27','10:05:00',12.61),('6449','2013-02-27','10:10:00',12.84),('6449','2013-02-27','10:15:00',13.06),('6449','2013-02-27','10:20:00',13.19),('6449','2013-02-27','10:25:00',13.34),('6449','2013-02-27','10:30:00',13.54),('6449','2013-02-27','10:35:00',13.62),('6449','2013-02-27','10:40:00',13.84),('6449','2013-02-27','10:45:00',14.06),('6449','2013-02-27','10:50:00',14.21),('6449','2013-02-27','10:55:00',14.33),('6449','2013-02-27','11:00:00',14.41),('6449','2013-02-27','11:05:00',14.33),('6449','2013-02-27','11:10:00',14.5),('6449','2013-02-27','11:15:00',14.45),('6449','2013-02-27','11:20:00',14.66),('6449','2013-02-27','11:25:00',14.78),('6449','2013-02-27','11:30:00',14.83),('6449','2013-02-27','11:35:00',14.83),('6449','2013-02-27','11:40:00',14.62),('6449','2013-02-27','11:45:00',14.56),('6449','2013-02-27','11:50:00',14.69),('6449','2013-02-27','11:55:00',14.67),('6449','2013-02-27','12:00:00',9.6),('6449','2013-02-27','12:05:00',15.09),('6449','2013-02-27','12:10:00',15.77),('6449','2013-02-27','12:15:00',15.45),('6449','2013-02-27','12:20:00',15.48),('6449','2013-02-27','12:25:00',15.6),('6449','2013-02-27','12:30:00',15.56),('6449','2013-02-27','12:35:00',15.44),('6449','2013-02-27','12:40:00',15.36),('6449','2013-02-27','12:45:00',15.31),('6449','2013-02-27','12:50:00',15.07),('6449','2013-02-27','12:55:00',15.08),('6449','2013-02-27','13:00:00',14.77),('6449','2013-02-27','13:05:00',14.92),('6449','2013-02-27','13:10:00',14.89),('6449','2013-02-27','13:15:00',14.76),('6449','2013-02-27','13:20:00',14.42),('6449','2013-02-27','13:25:00',14.5),('6449','2013-02-27','13:30:00',14.35),('6449','2013-02-27','13:35:00',14.17),('6449','2013-02-27','13:40:00',13.94),('6449','2013-02-27','13:45:00',13.8),('6449','2013-02-27','13:50:00',13.7),('6449','2013-02-27','13:55:00',13.49),('6449','2013-02-27','14:00:00',13.19),('6449','2013-02-27','14:05:00',12.95),('6449','2013-02-27','14:10:00',12.81),('6449','2013-02-27','14:15:00',12.47),('6449','2013-02-27','14:20:00',12.2),('6449','2013-02-27','14:25:00',10.67),('6449','2013-02-27','14:30:00',11.89),('6449','2013-02-27','14:35:00',11.53),('6449','2013-02-27','14:40:00',11.13),('6449','2013-02-27','14:45:00',11.1),('6449','2013-02-27','14:50:00',10.77),('6449','2013-02-27','14:55:00',10.7),('6449','2013-02-27','15:00:00',10.33),('6449','2013-02-27','15:05:00',9.93),('6449','2013-02-27','15:10:00',9.73),('6449','2013-02-27','15:15:00',9.46),('6449','2013-02-27','15:20:00',9.24),('6449','2013-02-27','15:25:00',8.87),('6449','2013-02-27','15:30:00',8.55),('6449','2013-02-27','15:35:00',8.25),('6449','2013-02-27','15:40:00',7.97),('6449','2013-02-27','15:45:00',7.55),('6449','2013-02-27','15:50:00',7.16),('6449','2013-02-27','15:55:00',6.86),('6449','2013-02-27','16:00:00',6.42),('6449','2013-02-27','16:05:00',6.06),('6449','2013-02-27','16:10:00',5.69),('6449','2013-02-27','16:15:00',5.3),('6449','2013-02-27','16:20:00',4.88),('6449','2013-02-27','16:25:00',4.5),('6449','2013-02-27','16:30:00',4.09),('6449','2013-02-27','16:35:00',3.67),('6449','2013-02-27','16:40:00',3.34),('6449','2013-02-27','16:45:00',2.98),('6449','2013-02-27','16:50:00',2.6),('6449','2013-02-27','16:55:00',2.29),('6449','2013-02-27','17:00:00',1.92),('6449','2013-02-27','17:05:00',1.65),('6449','2013-02-27','17:10:00',1.39),('6449','2013-02-27','17:15:00',1.14),('6449','2013-02-26','08:20:00',1.11),('6449','2013-02-26','08:25:00',1.27),('6449','2013-02-26','08:30:00',1.41),('6449','2013-02-26','08:35:00',1.56),('6449','2013-02-26','08:41:00',1.72),('6449','2013-02-26','08:45:00',2.03),('6449','2013-02-26','08:50:00',2.26),('6449','2013-02-26','08:55:00',2.57),('6449','2013-02-26','09:00:00',2.76),('6449','2013-02-26','09:05:00',2.94),('6449','2013-02-26','09:10:00',3.05),('6449','2013-02-26','09:15:00',3.22),('6449','2013-02-26','09:20:00',3.61),('6449','2013-02-26','09:25:00',4.09),('6449','2013-02-26','09:30:00',4.52),('6449','2013-02-26','09:35:00',5.05),('6449','2013-02-26','09:40:00',5.48),('6449','2013-02-26','09:45:00',6.01),('6449','2013-02-26','09:50:00',6.97),('6449','2013-02-26','09:55:00',8.18),('6449','2013-02-26','10:00:00',9.84),('6449','2013-02-26','10:05:00',11.4),('6449','2013-02-26','10:10:00',12.14),('6449','2013-02-26','10:15:00',12.92),('6449','2013-02-26','10:20:00',13.31),('6449','2013-02-26','10:25:00',13.35),('6449','2013-02-26','10:30:00',11.75),('6449','2013-02-26','10:35:00',11.5),('6449','2013-02-26','10:40:00',12.03),('6449','2013-02-26','10:45:00',14.33),('6449','2013-02-26','10:50:00',14.04),('6449','2013-02-26','10:55:00',13.9),('6449','2013-02-26','11:00:00',14.58),('6449','2013-02-26','11:05:00',8.41),('6449','2013-02-26','11:10:00',15.37),('6449','2013-02-26','11:15:00',10.24),('6449','2013-02-26','11:20:00',7.03),('6449','2013-02-26','11:25:00',7.1),('6449','2013-02-26','11:30:00',7.61),('6449','2013-02-26','11:35:00',8.66),('6449','2013-02-26','11:40:00',10.37),('6449','2013-02-26','11:45:00',13.02),('6449','2013-02-26','11:50:00',16.72),('6449','2013-02-26','11:55:00',18.22),('6449','2013-02-26','12:00:00',15.34),('6449','2013-02-26','12:05:00',12.98),('6449','2013-02-26','12:10:00',13.46),('6449','2013-02-26','12:15:00',12.94),('6449','2013-02-26','12:20:00',11.6),('6449','2013-02-26','12:25:00',14.95),('6449','2013-02-26','12:30:00',14.15),('6449','2013-02-26','12:35:00',12.12),('6449','2013-02-26','12:40:00',6.43),('6449','2013-02-26','12:45:00',6.48),('6449','2013-02-26','12:50:00',6.14),('6449','2013-02-26','12:55:00',5.93),('6449','2013-02-26','13:00:00',12.06),('6449','2013-02-26','13:05:00',10.67),('6449','2013-02-26','13:10:00',6.57),('6449','2013-02-26','13:15:00',6.21),('6449','2013-02-26','13:20:00',4.28),('6449','2013-02-26','13:25:00',3.04),('6449','2013-02-26','13:30:00',2.86),('6449','2013-02-26','13:35:00',2.71),('6449','2013-02-26','13:40:00',2.49),('6449','2013-02-26','13:45:00',2.28),('6449','2013-02-26','13:50:00',2.17),('6449','2013-02-26','13:55:00',2.27),('6449','2013-02-26','14:00:00',2.39),('6449','2013-02-26','14:05:00',2.68),('6449','2013-02-26','14:10:00',2.96),('6449','2013-02-26','14:15:00',3.22),('6449','2013-02-26','14:20:00',3.58),('6449','2013-02-26','14:25:00',3.72),('6449','2013-02-26','14:30:00',3.66),('6449','2013-02-26','14:35:00',3.72),('6449','2013-02-26','14:40:00',3.82),('6449','2013-02-26','14:45:00',3.67),('6449','2013-02-26','14:50:00',3.68),('6449','2013-02-26','14:55:00',3.58),('6449','2013-02-26','15:00:00',3.13),('6449','2013-02-26','15:05:00',2.5),('6449','2013-02-26','15:10:00',2.21),('6449','2013-02-26','15:15:00',1.84),('6449','2013-02-26','15:20:00',1.61),('6449','2013-02-26','15:25:00',1.4),('6449','2013-02-26','15:30:00',1.26),('6449','2013-02-26','15:35:00',1.21),('6449','2013-02-26','15:40:00',1.1),('6449','2013-02-26','15:45:00',1.29),('6449','2013-02-26','15:50:00',1.33),('6449','2013-02-26','15:55:00',1.37),('6449','2013-02-26','16:00:00',1.34),('6449','2013-02-26','16:05:00',1.26),('6449','2013-02-26','16:10:00',1.32),('6449','2013-02-26','16:15:00',1.43),('6449','2013-02-26','16:20:00',1.5),('6449','2013-02-26','16:25:00',1.48),('6449','2013-02-26','16:30:00',1.46),('6449','2013-02-26','16:35:00',1.34),('6449','2013-02-26','16:40:00',1.46),('6449','2013-02-26','16:45:00',1.61),('6449','2013-02-26','16:50:00',1.38),('6449','2013-02-26','16:55:00',1.19),('6449','2013-02-26','17:00:00',1.17),('6449','2013-02-26','17:05:00',1.12),('6449','2013-02-25','08:15:00',1.85),('6449','2013-02-25','08:20:00',1.95),('6449','2013-02-25','08:25:00',1.88),('6449','2013-02-25','08:30:00',2.05),('6449','2013-02-25','08:35:00',2.49),('6449','2013-02-25','08:40:00',2.21),('6449','2013-02-25','08:45:00',1.59),('6449','2013-02-25','08:50:00',1.14),('6449','2013-02-25','09:00:00',1.21),('6449','2013-02-25','09:05:00',2.38),('6449','2013-02-25','09:10:00',5.88),('6449','2013-02-25','09:15:00',8.59),('6449','2013-02-25','09:20:00',5.82),('6449','2013-02-25','09:25:00',6.15),('6449','2013-02-25','09:30:00',4.31),('6449','2013-02-25','09:35:00',5.09),('6449','2013-02-25','09:40:00',5.9),('6449','2013-02-25','09:45:00',5.87),('6449','2013-02-25','09:50:00',8.22),('6449','2013-02-25','09:55:00',10.28),('6449','2013-02-25','10:00:00',8.54),('6449','2013-02-25','10:05:00',7.27),('6449','2013-02-25','10:10:00',7.09),('6449','2013-02-25','10:15:00',9.95),('6449','2013-02-25','10:20:00',10.4),('6449','2013-02-25','10:25:00',7.81),('6449','2013-02-25','10:30:00',10.31),('6449','2013-02-25','10:35:00',14.53),('6449','2013-02-25','10:40:00',13.51),('6449','2013-02-25','10:45:00',15.28),('6449','2013-02-25','10:50:00',15.31),('6449','2013-02-25','10:55:00',15.06),('6449','2013-02-25','11:00:00',15.71),('6449','2013-02-25','11:05:00',15.66),('6449','2013-02-25','11:10:00',15.83),('6449','2013-02-25','11:15:00',15.91),('6449','2013-02-25','11:20:00',15.56),('6449','2013-02-25','11:25:00',12.03),('6449','2013-02-25','11:30:00',14.74),('6449','2013-02-25','11:35:00',6.45),('6449','2013-02-25','11:40:00',14.67),('6449','2013-02-25','11:45:00',8.29),('6449','2013-02-25','11:50:00',5.77),('6449','2013-02-25','11:55:00',15.3),('6449','2013-02-25','12:00:00',8.98),('6449','2013-02-25','12:05:00',6.47),('6449','2013-02-25','12:10:00',7.48),('6449','2013-02-25','12:15:00',8.38),('6449','2013-02-25','12:20:00',10.11),('6449','2013-02-25','12:25:00',6.54),('6449','2013-02-25','12:30:00',8.95),('6449','2013-02-25','12:35:00',10.25),('6449','2013-02-25','12:40:00',6.17),('6449','2013-02-25','12:45:00',5.47),('6449','2013-02-25','12:50:00',6.1),('6449','2013-02-25','12:55:00',6.59),('6449','2013-02-25','13:00:00',7.28),('6449','2013-02-25','13:05:00',7.45),('6449','2013-02-25','13:10:00',5.95),('6449','2013-02-25','13:15:00',4.73),('6449','2013-02-25','13:20:00',4.27),('6449','2013-02-25','13:25:00',4.01),('6449','2013-02-25','13:30:00',3.96),('6449','2013-02-25','13:35:00',4.22),('6449','2013-02-25','13:40:00',6.18),('6449','2013-02-25','13:45:00',6.36),('6449','2013-02-25','13:50:00',7.98),('6449','2013-02-25','13:55:00',8),('6449','2013-02-25','14:01:00',8.53),('6449','2013-02-25','14:05:00',7.79),('6449','2013-02-25','14:10:00',11.87),('6449','2013-02-25','14:15:00',8.51),('6449','2013-02-25','14:20:00',9.61),('6449','2013-02-25','14:25:00',11.84),('6449','2013-02-25','14:30:00',4.46),('6449','2013-02-25','14:35:00',6.95),('6449','2013-02-25','14:41:00',9.87),('6449','2013-02-25','14:45:00',3.61),('6449','2013-02-25','14:50:00',6.01),('6449','2013-02-25','14:55:00',8.72),('6449','2013-02-25','15:00:00',5.44),('6449','2013-02-25','15:05:00',5.09),('6449','2013-02-25','15:10:00',4.07),('6449','2013-02-25','15:15:00',3.85),('6449','2013-02-25','15:20:00',3.73),('6449','2013-02-25','15:25:00',3.53),('6449','2013-02-25','15:30:00',2.76),('6449','2013-02-25','15:35:00',2.03),('6449','2013-02-25','15:40:00',1.8),('6449','2013-02-25','15:45:00',1.96),('6449','2013-02-25','15:50:00',1.76),('6449','2013-02-25','15:55:00',1.55),('6449','2013-02-25','16:00:00',2.01),('6449','2013-02-25','16:05:00',5.26),('6449','2013-02-25','16:10:00',3.93),('6449','2013-02-25','16:15:00',3.92),('6449','2013-02-25','16:20:00',6.15),('6449','2013-02-25','16:25:00',4.5),('6449','2013-02-25','16:30:00',2.26),('6449','2013-02-25','16:35:00',1.51),('6449','2013-02-25','16:40:00',1.27),('6449','2013-02-25','16:45:00',1.09),('6449','2013-02-24','08:15:00',1.03),('6449','2013-02-24','08:20:00',1.23),('6449','2013-02-24','08:25:00',1.1),('6449','2013-02-24','08:30:00',1.46),('6449','2013-02-24','08:35:00',2.14),('6449','2013-02-24','08:40:00',2.23),('6449','2013-02-24','08:45:00',1.95),('6449','2013-02-24','08:50:00',2.3),('6449','2013-02-24','08:55:00',1.72),('6449','2013-02-24','09:00:00',2.08),('6449','2013-02-24','09:05:00',2.53),('6449','2013-02-24','09:10:00',3),('6449','2013-02-24','09:15:00',2.7),('6449','2013-02-24','09:20:00',2.22),('6449','2013-02-24','09:25:00',3.21),('6449','2013-02-24','09:30:00',2.91),('6449','2013-02-24','09:35:00',2.46),('6449','2013-02-24','09:40:00',2.71),('6449','2013-02-24','09:45:00',2.85),('6449','2013-02-24','09:50:00',3.03),('6449','2013-02-24','09:55:00',3.76),('6449','2013-02-24','10:00:00',2.59),('6449','2013-02-24','10:05:00',3),('6449','2013-02-24','10:10:00',2.7),('6449','2013-02-24','10:15:00',3.56),('6449','2013-02-24','10:20:00',4.24),('6449','2013-02-24','10:25:00',4.8),('6449','2013-02-24','10:30:00',5.57),('6449','2013-02-24','10:35:00',4.86),('6449','2013-02-24','10:40:00',3.34),('6449','2013-02-24','10:45:00',2.93),('6449','2013-02-24','10:50:00',3.03),('6449','2013-02-24','10:55:00',3.23),('6449','2013-02-24','11:00:00',2.96),('6449','2013-02-24','11:05:00',2.92),('6449','2013-02-24','11:10:00',3.42),('6449','2013-02-24','11:15:00',4),('6449','2013-02-24','11:20:00',4.85),('6449','2013-02-24','11:25:00',4.6),('6449','2013-02-24','11:30:00',3.44),('6449','2013-02-24','11:35:00',3.98),('6449','2013-02-24','11:41:00',5.08),('6449','2013-02-24','11:45:00',7.71),('6449','2013-02-24','11:50:00',7.46),('6449','2013-02-24','11:55:00',9.93),('6449','2013-02-24','12:00:00',5.96),('6449','2013-02-24','12:05:00',7.71),('6449','2013-02-24','12:10:00',7.35),('6449','2013-02-24','12:15:00',6.25),('6449','2013-02-24','12:20:00',8.09),('6449','2013-02-24','12:25:00',8.32),('6449','2013-02-24','12:30:00',6.04),('6449','2013-02-24','12:35:00',8.33),('6449','2013-02-24','12:40:00',17.17),('6449','2013-02-24','12:45:00',8.73),('6449','2013-02-24','12:50:00',8.31),('6449','2013-02-24','12:55:00',15.2),('6449','2013-02-24','13:00:00',11.35),('6449','2013-02-24','13:05:00',16.92),('6449','2013-02-24','13:10:00',16.6),('6449','2013-02-24','13:15:00',13.71),('6449','2013-02-24','13:20:00',17.19),('6449','2013-02-24','13:25:00',14.48),('6449','2013-02-24','13:30:00',13.61),('6449','2013-02-24','13:35:00',7.35),('6449','2013-02-24','13:40:00',11.6),('6449','2013-02-24','13:45:00',6.12),('6449','2013-02-24','13:50:00',3.77),('6449','2013-02-24','13:55:00',4.19),('6449','2013-02-24','14:00:00',5.19),('6449','2013-02-24','14:05:00',3.52),('6449','2013-02-24','14:10:00',3.37),('6449','2013-02-24','14:15:00',3.98),('6449','2013-02-24','14:20:00',11.26),('6449','2013-02-24','14:25:00',12.98),('6449','2013-02-24','14:30:00',9.84),('6449','2013-02-24','14:35:00',12.69),('6449','2013-02-24','14:40:00',4.54),('6449','2013-02-24','14:45:00',6.82),('6449','2013-02-24','14:50:00',12.94),('6449','2013-02-24','14:55:00',9.9),('6449','2013-02-24','15:00:00',7.55),('6449','2013-02-24','15:05:00',11.39),('6449','2013-02-24','15:10:00',9.59),('6449','2013-02-24','15:15:00',5.97),('6449','2013-02-24','15:20:00',6.92),('6449','2013-02-24','15:25:00',8.3),('6449','2013-02-24','15:30:00',8.58),('6449','2013-02-24','15:35:00',7.99),('6449','2013-02-24','15:40:00',6.35),('6449','2013-02-24','15:45:00',8.02),('6449','2013-02-24','15:50:00',7.43),('6449','2013-02-24','15:55:00',5.55),('6449','2013-02-24','16:00:00',3.95),('6449','2013-02-24','16:05:00',1.23),('6449','2013-02-24','16:10:00',1.08),('6449','2013-02-24','16:15:00',1.39),('6449','2013-02-24','16:20:00',1.24),('6449','2013-02-23','07:20:00',1.29),('6449','2013-02-23','07:25:00',1.83),('6449','2013-02-23','07:30:00',2.33),('6449','2013-02-23','07:35:00',2.83),('6449','2013-02-23','07:40:00',3.45),('6449','2013-02-23','07:45:00',4.24),('6449','2013-02-23','07:50:00',4.5),('6449','2013-02-23','07:55:00',5.14),('6449','2013-02-23','08:00:00',6.29),('6449','2013-02-23','08:05:00',3.98),('6449','2013-02-23','08:11:00',2.51),('6449','2013-02-23','08:15:00',1.73),('6449','2013-02-23','08:20:00',1.54),('6449','2013-02-23','08:25:00',1.56),('6449','2013-02-23','08:30:00',1.52),('6449','2013-02-23','08:35:00',1.7),('6449','2013-02-23','08:40:00',1.88),('6449','2013-02-23','08:45:00',2.38),('6449','2013-02-23','08:50:00',2.59),('6449','2013-02-23','08:55:00',2.3),('6449','2013-02-23','09:00:00',2.09),('6449','2013-02-23','09:05:00',1.76),('6449','2013-02-23','09:10:00',1.82),('6449','2013-02-23','09:15:00',1.64),('6449','2013-02-23','09:20:00',1.61),('6449','2013-02-23','09:25:00',2.02),('6449','2013-02-23','09:30:00',2.03),('6449','2013-02-23','09:35:00',1.91),('6449','2013-02-23','09:40:00',2.42),('6449','2013-02-23','09:45:00',2.84),('6449','2013-02-23','09:50:00',2.01),('6449','2013-02-23','09:55:00',1.24),('6449','2013-02-23','10:00:00',1.16),('6449','2013-02-23','10:05:00',1.46),('6449','2013-02-23','10:10:00',1.59),('6449','2013-02-23','10:15:00',1.3),('6449','2013-02-23','10:20:00',2.22),('6449','2013-02-23','10:25:00',3.88),('6449','2013-02-23','10:30:00',2.56),('6449','2013-02-23','10:35:00',1.99),('6449','2013-02-23','10:40:00',2.03),('6449','2013-02-23','10:45:00',2.11),('6449','2013-02-23','10:50:00',2.02),('6449','2013-02-23','10:55:00',1.54),('6449','2013-02-23','11:00:00',1.63),('6449','2013-02-23','11:05:00',2.46),('6449','2013-02-23','11:10:00',3.26),('6449','2013-02-23','11:15:00',2.41),('6449','2013-02-23','11:20:00',1.6),('6449','2013-02-23','11:25:00',2.83),('6449','2013-02-23','11:30:00',3.26),('6449','2013-02-23','11:35:00',2.33),('6449','2013-02-23','11:40:00',1.69),('6449','2013-02-23','11:45:00',2.01),('6449','2013-02-23','11:50:00',1.5),('6449','2013-02-23','11:55:00',1.38),('6449','2013-02-23','12:05:00',1.83),('6449','2013-02-23','12:10:00',1.82),('6449','2013-02-23','12:15:00',1.39),('6449','2013-02-23','12:20:00',1.41),('6449','2013-02-23','12:25:00',1.05),('6449','2013-02-23','13:05:00',1.29),('6449','2013-02-23','14:20:00',1.27),('6449','2013-02-23','14:40:00',1.05),('6449','2013-02-23','15:15:00',1.19),('6449','2013-02-23','15:20:00',1.64),('6449','2013-02-22','09:30:00',1.06),('6449','2013-02-22','09:40:00',1.53),('6449','2013-02-22','09:45:00',1.21),('6449','2013-02-22','09:50:00',1.2),('6449','2013-02-22','09:55:00',1.48),('6449','2013-02-22','10:00:00',1.39),('6449','2013-02-22','10:05:00',1.81),('6449','2013-02-22','10:10:00',1.92),('6449','2013-02-22','10:15:00',1.94),('6449','2013-02-22','10:20:00',1.07),('6449','2013-02-22','10:30:00',1.13),('6449','2013-02-22','10:35:00',1.31),('6449','2013-02-22','10:55:00',1.34),('6449','2013-02-22','11:00:00',1.49),('6449','2013-02-22','11:05:00',1.69),('6449','2013-02-22','11:10:00',2.02),('6449','2013-02-22','11:15:00',3.19),('6449','2013-02-22','11:20:00',2.83),('6449','2013-02-22','11:25:00',2.01),('6449','2013-02-22','11:30:00',1.16),('6449','2013-02-22','11:35:00',1.34),('6449','2013-02-22','11:40:00',1.44),('6449','2013-02-22','11:45:00',1.03),('6449','2013-02-22','11:50:00',1.32),('6449','2013-02-22','11:55:00',2.46),('6449','2013-02-22','12:00:00',4.22),('6449','2013-02-22','12:05:00',3.99),('6449','2013-02-22','12:10:00',3.73),('6449','2013-02-22','12:15:00',4.02),('6449','2013-02-22','12:20:00',3.08),('6449','2013-02-22','12:25:00',2.93),('6449','2013-02-22','12:30:00',1.61),('6449','2013-02-22','12:35:00',1.21),('6449','2013-02-22','12:50:00',1.22),('6449','2013-02-22','12:55:00',1.88),('6449','2013-02-22','13:00:00',2.63),('6449','2013-02-22','13:05:00',2.66),('6449','2013-02-22','13:10:00',1.45),('6449','2013-02-22','13:15:00',1.12),('6449','2013-02-22','13:20:00',1.02),('6449','2013-02-22','13:35:00',2.03),('6449','2013-02-22','13:40:00',4.27),('6449','2013-02-22','13:45:00',5.33),('6449','2013-02-22','13:50:00',5.04),('6449','2013-02-22','13:55:00',4.67),('6449','2013-02-22','14:00:00',2.58),('6449','2013-02-22','14:05:00',1.74),('6449','2013-02-22','14:10:00',2.51),('6449','2013-02-22','14:15:00',2.02),('6449','2013-02-22','14:20:00',1.23),('6449','2013-02-22','14:25:00',3.15),('6449','2013-02-22','14:30:00',5.35),('6449','2013-02-22','14:35:00',3.3),('6449','2013-02-22','14:41:00',5.24),('6449','2013-02-22','14:45:00',6.65),('6449','2013-02-22','14:50:00',5.37),('6449','2013-02-22','14:55:00',5.98),('6449','2013-02-22','15:00:00',4.93),('6449','2013-02-22','15:05:00',3.99),('6449','2013-02-22','15:10:00',2.15),('6449','2013-02-22','15:15:00',1.07),('6449','2013-02-22','15:20:00',1.41),('6449','2013-02-22','15:35:00',1.11),('6449','2013-02-22','15:40:00',2.86),('6449','2013-02-22','15:45:00',3.63),('6449','2013-02-22','15:50:00',1.93),('6449','2013-02-22','15:55:00',1.75),('6449','2013-02-22','16:00:00',1.54),('6449','2013-02-22','16:05:00',2.14),('6449','2013-02-22','16:10:00',4.04),('6449','2013-02-22','16:15:00',6.61),('6449','2013-02-22','16:20:00',1.32),('6449','2013-02-21','08:20:00',1.06),('6449','2013-02-21','08:25:00',1.11),('6449','2013-02-21','08:30:00',1.06),('6449','2013-02-21','08:35:00',1),('6449','2013-02-21','08:45:00',1.07),('6449','2013-02-21','08:50:00',1.21),('6449','2013-02-21','08:55:00',1.29),('6449','2013-02-21','09:00:00',1.18),('6449','2013-02-21','09:05:00',1.14),('6449','2013-02-21','09:10:00',1.31),('6449','2013-02-21','09:15:00',1.58),('6449','2013-02-21','09:20:00',1.9),('6449','2013-02-21','09:25:00',2.24),('6449','2013-02-21','09:30:00',2.38),('6449','2013-02-21','09:35:00',2.46),('6449','2013-02-21','09:40:00',2.4),('6449','2013-02-21','09:45:00',2.39),('6449','2013-02-21','09:50:00',2.67),('6449','2013-02-21','09:55:00',2.81),('6449','2013-02-21','10:00:00',2.99),('6449','2013-02-21','10:05:00',3.18),('6449','2013-02-21','10:10:00',3.3),('6449','2013-02-21','10:15:00',3.07),('6449','2013-02-21','10:20:00',3.02),('6449','2013-02-21','10:25:00',3.19),('6449','2013-02-21','10:30:00',3.52),('6449','2013-02-21','10:35:00',3.45),('6449','2013-02-21','10:40:00',3.34),('6449','2013-02-21','10:45:00',3.03),('6449','2013-02-21','10:50:00',2.78),('6449','2013-02-21','10:55:00',2.73),('6449','2013-02-21','11:00:00',2.52),('6449','2013-02-21','11:05:00',2.63),('6449','2013-02-21','11:10:00',3.02),('6449','2013-02-21','11:15:00',3.31),('6449','2013-02-21','11:20:00',3.5),('6449','2013-02-21','11:25:00',3.65),('6449','2013-02-21','11:30:00',3.81),('6449','2013-02-21','11:35:00',3.8),('6449','2013-02-21','11:40:00',3.74),('6449','2013-02-21','11:45:00',3.93),('6449','2013-02-21','11:50:00',4.36),('6449','2013-02-21','11:55:00',4.47),('6449','2013-02-21','12:00:00',4.28),('6449','2013-02-21','12:05:00',4.38),('6449','2013-02-21','12:10:00',4.45),('6449','2013-02-21','12:15:00',4.2),('6449','2013-02-21','12:20:00',3.8),('6449','2013-02-21','12:25:00',3.38),('6449','2013-02-21','12:30:00',2.96),('6449','2013-02-21','12:35:00',2.52),('6449','2013-02-21','12:40:00',2.33),('6449','2013-02-21','12:45:00',2.27),('6449','2013-02-21','12:50:00',2.46),('6449','2013-02-21','12:55:00',2.99),('6449','2013-02-21','13:00:00',3.97),('6449','2013-02-21','13:05:00',4.67),('6449','2013-02-21','13:10:00',4.56),('6449','2013-02-21','13:15:00',6.15),('6449','2013-02-21','13:20:00',6.81),('6449','2013-02-21','13:25:00',6.36),('6449','2013-02-21','13:30:00',6.08),('6449','2013-02-21','13:35:00',5.19),('6449','2013-02-21','13:40:00',5.1),('6449','2013-02-21','13:45:00',5.28),('6449','2013-02-21','13:50:00',5.36),('6449','2013-02-21','13:55:00',5.67),('6449','2013-02-21','14:00:00',8.34),('6449','2013-02-21','14:05:00',8.2),('6449','2013-02-21','14:10:00',6.12),('6449','2013-02-21','14:15:00',5.21),('6449','2013-02-21','14:20:00',4.5),('6449','2013-02-21','14:25:00',4.13),('6449','2013-02-21','14:30:00',3.89),('6449','2013-02-21','14:35:00',3.78),('6449','2013-02-21','14:40:00',4.5),('6449','2013-02-21','14:45:00',5.09),('6449','2013-02-21','14:50:00',6.06),('6449','2013-02-21','14:55:00',7.99),('6449','2013-02-21','15:00:00',11.47),('6449','2013-02-21','15:05:00',11.36),('6449','2013-02-21','15:10:00',10.72),('6449','2013-02-21','15:15:00',10.18),('6449','2013-02-21','15:20:00',9.65),('6449','2013-02-21','15:25:00',9.21),('6449','2013-02-21','15:30:00',8.72),('6449','2013-02-21','15:35:00',8.19),('6449','2013-02-21','15:40:00',7.75),('6449','2013-02-21','15:45:00',7.31),('6449','2013-02-21','15:50:00',6.8),('6449','2013-02-21','15:55:00',6.44),('6449','2013-02-21','16:00:00',6.03),('6449','2013-02-21','16:05:00',5.67),('6449','2013-02-21','16:10:00',5.28),('6449','2013-02-21','16:15:00',4.9),('6449','2013-02-21','16:20:00',4.42),('6449','2013-02-21','16:25:00',4.17),('6449','2013-02-21','16:30:00',3.88),('6449','2013-02-21','16:35:00',3.54),('6449','2013-02-21','16:40:00',3.12),('6449','2013-02-21','16:45:00',2.75),('6449','2013-02-21','16:50:00',2.39),('6449','2013-02-21','16:55:00',2.07),('6449','2013-02-21','17:00:00',1.72),('6449','2013-02-21','17:05:00',1.35),('6449','2013-02-21','17:10:00',1.06),('6449','2013-02-20','07:35:00',1.03),('6449','2013-02-20','07:45:00',1.02),('6449','2013-02-20','07:55:00',1.03),('6449','2013-02-20','08:00:00',1.01),('6449','2013-02-20','08:05:00',1.21),('6449','2013-02-20','08:10:00',1.63),('6449','2013-02-20','08:15:00',2.87),('6449','2013-02-20','08:20:00',4.61),('6449','2013-02-20','08:25:00',5.59),('6449','2013-02-20','08:30:00',5.83),('6449','2013-02-20','08:35:00',6.3),('6449','2013-02-20','08:40:00',6.64),('6449','2013-02-20','08:45:00',7.07),('6449','2013-02-20','08:50:00',7.36),('6449','2013-02-20','08:55:00',7.68),('6449','2013-02-20','09:00:00',8.03),('6449','2013-02-20','09:05:00',8.6),('6449','2013-02-20','09:10:00',9.95),('6449','2013-02-20','09:15:00',10.44),('6449','2013-02-20','09:20:00',10.3),('6449','2013-02-20','09:25:00',10.13),('6449','2013-02-20','09:30:00',10.44),('6449','2013-02-20','09:35:00',10.73),('6449','2013-02-20','09:40:00',11.04),('6449','2013-02-20','09:45:00',8.93),('6449','2013-02-20','09:50:00',5.64),('6449','2013-02-20','09:55:00',7.03),('6449','2013-02-20','10:00:00',5.84),('6449','2013-02-20','10:05:00',4.73),('6449','2013-02-20','10:10:00',4.82),('6449','2013-02-20','10:15:00',6.21),('6449','2013-02-20','10:20:00',6.63),('6449','2013-02-20','10:25:00',11.59),('6449','2013-02-20','10:30:00',6.58),('6449','2013-02-20','10:35:00',10.43),('6449','2013-02-20','10:40:00',9.26),('6449','2013-02-20','10:45:00',9.77),('6449','2013-02-20','10:50:00',7.96),('6449','2013-02-20','10:55:00',5.75),('6449','2013-02-20','11:00:00',11.41),('6449','2013-02-20','11:05:00',4.29),('6449','2013-02-20','11:10:00',13.65),('6449','2013-02-20','11:15:00',16.01),('6449','2013-02-20','11:20:00',14.19),('6449','2013-02-20','11:25:00',7.09),('6449','2013-02-20','11:30:00',13.87),('6449','2013-02-20','11:35:00',15.69),('6449','2013-02-20','11:40:00',15.95),('6449','2013-02-20','11:45:00',11.58),('6449','2013-02-20','11:50:00',8.68),('6449','2013-02-20','11:55:00',10.27),('6449','2013-02-20','12:00:00',11.92),('6449','2013-02-20','12:05:00',8.98),('6449','2013-02-20','12:10:00',9.73),('6449','2013-02-20','12:15:00',14.47),('6449','2013-02-20','12:20:00',9.12),('6449','2013-02-20','12:25:00',11.94),('6449','2013-02-20','12:30:00',16.83),('6449','2013-02-20','12:35:00',16.24),('6449','2013-02-20','12:40:00',15.68),('6449','2013-02-20','12:45:00',13.86),('6449','2013-02-20','12:50:00',9.73),('6449','2013-02-20','12:55:00',15.35),('6449','2013-02-20','13:00:00',15.34),('6449','2013-02-20','13:05:00',15.35),('6449','2013-02-20','13:10:00',15.1),('6449','2013-02-20','13:15:00',14.56),('6449','2013-02-20','13:20:00',13.6),('6449','2013-02-20','13:25:00',13.83),('6449','2013-02-20','13:30:00',14.45),('6449','2013-02-20','13:35:00',14.39),('6449','2013-02-20','13:40:00',13.88),('6449','2013-02-20','13:45:00',13.16),('6449','2013-02-20','13:50:00',13.79),('6449','2013-02-20','13:55:00',13.62),('6449','2013-02-20','14:00:00',13),('6449','2013-02-20','14:05:00',13.68),('6449','2013-02-20','14:10:00',13.3),('6449','2013-02-20','14:15:00',13.08),('6449','2013-02-20','14:20:00',12.87),('6449','2013-02-20','14:25:00',12.37),('6449','2013-02-20','14:30:00',12.27),('6449','2013-02-20','14:35:00',11.83),('6449','2013-02-20','14:40:00',11.37),('6449','2013-02-20','14:45:00',10.92),('6449','2013-02-20','14:50:00',9.78),('6449','2013-02-20','14:55:00',9.22),('6449','2013-02-20','15:00:00',5.68),('6449','2013-02-20','15:05:00',4.58),('6449','2013-02-20','15:10:00',9.35),('6449','2013-02-20','15:15:00',8.08),('6449','2013-02-20','15:20:00',7.64),('6449','2013-02-20','15:25:00',5.69),('6449','2013-02-20','15:30:00',5.17),('6449','2013-02-20','15:35:00',7.23),('6449','2013-02-20','15:40:00',6.02),('6449','2013-02-20','15:45:00',6.06),('6449','2013-02-20','15:50:00',7.47),('6449','2013-02-20','15:55:00',5.92),('6449','2013-02-20','16:00:00',4.69),('6449','2013-02-20','16:05:00',6.49),('6449','2013-02-20','16:10:00',4.9),('6449','2013-02-20','16:15:00',4.44),('6449','2013-02-20','16:20:00',4.42),('6449','2013-02-20','16:25:00',3.36),('6449','2013-02-20','16:30:00',4.18),('6449','2013-02-20','16:35:00',3.88),('6449','2013-02-20','16:40:00',3.91),('6449','2013-02-20','16:45:00',3.41),('6449','2013-02-20','16:50:00',2.77),('6449','2013-02-20','16:55:00',2.17),('6449','2013-02-20','17:00:00',1.7),('6449','2013-02-20','17:05:00',1.34),('6449','2013-02-20','17:10:00',1.3),('6449','2013-02-20','17:15:00',1.15),('6449','2013-02-19','07:25:00',1.06),('6449','2013-02-19','07:30:00',1.35),('6449','2013-02-19','07:35:00',1.65),('6449','2013-02-19','07:40:00',2),('6449','2013-02-19','07:45:00',2.37),('6449','2013-02-19','07:50:00',2.71),('6449','2013-02-19','07:55:00',3.08),('6449','2013-02-19','08:00:00',3.5),('6449','2013-02-19','08:05:00',3.92),('6449','2013-02-19','08:10:00',4.31),('6449','2013-02-19','08:15:00',4.64),('6449','2013-02-19','08:20:00',4.99),('6449','2013-02-19','08:25:00',5.43),('6449','2013-02-19','08:30:00',5.87),('6449','2013-02-19','08:35:00',6.2),('6449','2013-02-19','08:40:00',6.74),('6449','2013-02-19','08:45:00',7.09),('6449','2013-02-19','08:50:00',7.48),('6449','2013-02-19','08:55:00',7.8),('6449','2013-02-19','09:00:00',8.26),('6449','2013-02-19','09:05:00',8.6),('6449','2013-02-19','09:10:00',8.95),('6449','2013-02-19','09:15:00',9.29),('6449','2013-02-19','09:20:00',9.59),('6449','2013-02-19','09:25:00',9.93),('6449','2013-02-19','09:30:00',10.23),('6449','2013-02-19','09:35:00',10.53),('6449','2013-02-19','09:40:00',10.82),('6449','2013-02-19','09:45:00',11.1),('6449','2013-02-19','09:50:00',11.38),('6449','2013-02-19','09:55:00',11.66),('6449','2013-02-19','10:00:00',11.94),('6449','2013-02-19','10:05:00',12.21),('6449','2013-02-19','10:10:00',12.3),('6449','2013-02-19','10:15:00',12.68),('6449','2013-02-19','10:20:00',12.84),('6449','2013-02-19','10:25:00',12.89),('6449','2013-02-19','10:30:00',13.19),('6449','2013-02-19','10:35:00',13.31),('6449','2013-02-19','10:40:00',13.33),('6449','2013-02-19','10:45:00',13.63),('6449','2013-02-19','10:50:00',13.8),('6449','2013-02-19','10:55:00',13.86),('6449','2013-02-19','11:00:00',13.97),('6449','2013-02-19','11:05:00',14.09),('6449','2013-02-19','11:10:00',14.1),('6449','2013-02-19','11:15:00',14.28),('6449','2013-02-19','11:20:00',14.37),('6449','2013-02-19','11:25:00',14.37),('6449','2013-02-19','11:30:00',14.38),('6449','2013-02-19','11:35:00',14.4),('6449','2013-02-19','11:40:00',14.51),('6449','2013-02-19','11:45:00',14.6),('6449','2013-02-19','11:50:00',14.6),('6449','2013-02-19','11:55:00',14.32),('6449','2013-02-19','12:00:00',14.43),('6449','2013-02-19','12:05:00',14.57),('6449','2013-02-19','12:10:00',14.71),('6449','2013-02-19','12:15:00',15),('6449','2013-02-19','12:20:00',14.99),('6449','2013-02-19','12:25:00',14.77),('6449','2013-02-19','12:30:00',14.84),('6449','2013-02-19','12:35:00',14.78),('6449','2013-02-19','12:40:00',14.62),('6449','2013-02-19','12:45:00',14.72),('6449','2013-02-19','12:50:00',14.67),('6449','2013-02-19','12:55:00',14.64),('6449','2013-02-19','13:00:00',14.54),('6449','2013-02-19','13:05:00',14.52),('6449','2013-02-19','13:10:00',14.42),('6449','2013-02-19','13:15:00',14.24),('6449','2013-02-19','13:20:00',14.2),('6449','2013-02-19','13:25:00',14.16),('6449','2013-02-19','13:30:00',14.02),('6449','2013-02-19','13:35:00',13.94),('6449','2013-02-19','13:40:00',13.68),('6449','2013-02-19','13:45:00',13.53),('6449','2013-02-19','13:50:00',13.5),('6449','2013-02-19','13:55:00',13.25),('6449','2013-02-19','14:00:00',13.28),('6449','2013-02-19','14:05:00',13.05),('6449','2013-02-19','14:10:00',12.88),('6449','2013-02-19','14:15:00',12.37),('6449','2013-02-19','14:20:00',12.2),('6449','2013-02-19','14:25:00',11.89),('6449','2013-02-19','14:30:00',11.73),('6449','2013-02-19','14:35:00',11.45),('6449','2013-02-19','14:40:00',11.31),('6449','2013-02-19','14:45:00',11.13),('6449','2013-02-19','14:50:00',10.81),('6449','2013-02-19','14:55:00',10.63),('6449','2013-02-19','15:00:00',10.33),('6449','2013-02-19','15:05:00',10.03),('6449','2013-02-19','15:10:00',9.67),('6449','2013-02-19','15:15:00',9.4),('6449','2013-02-19','15:20:00',9.1),('6449','2013-02-19','15:25:00',8.64),('6449','2013-02-19','15:30:00',8.33),('6449','2013-02-19','15:35:00',8.03),('6449','2013-02-19','15:40:00',7.62),('6449','2013-02-19','15:45:00',7.33),('6449','2013-02-19','15:50:00',6.89),('6449','2013-02-19','15:55:00',6.46),('6449','2013-02-19','16:00:00',6.06),('6449','2013-02-19','16:05:00',5.66),('6449','2013-02-19','16:10:00',5.28),('6449','2013-02-19','16:15:00',4.86),('6449','2013-02-19','16:20:00',4.47),('6449','2013-02-19','16:25:00',4.05),('6449','2013-02-19','16:30:00',3.73),('6449','2013-02-19','16:35:00',3.37),('6449','2013-02-19','16:40:00',2.99),('6449','2013-02-19','16:45:00',2.61),('6449','2013-02-19','16:50:00',2.26),('6449','2013-02-19','16:55:00',1.89),('6449','2013-02-19','17:00:00',1.56),('6449','2013-02-19','17:05:00',1.25),('6449','2013-02-18','08:00:00',1.87),('6449','2013-02-18','08:05:00',3.29),('6449','2013-02-18','08:10:00',3.82),('6449','2013-02-18','08:15:00',4.15),('6449','2013-02-18','08:20:00',4.42),('6449','2013-02-18','08:25:00',5.04),('6449','2013-02-18','08:30:00',5.57),('6449','2013-02-18','08:35:00',5.89),('6449','2013-02-18','08:40:00',6.21),('6449','2013-02-18','08:45:00',6.8),('6449','2013-02-18','08:50:00',7.08),('6449','2013-02-18','08:55:00',7.58),('6449','2013-02-18','09:00:00',8.65),('6449','2013-02-18','09:05:00',8.27),('6449','2013-02-18','09:10:00',3.5),('6449','2013-02-18','09:15:00',3.22),('6449','2013-02-18','09:20:00',5.26),('6449','2013-02-18','09:25:00',5.43),('6449','2013-02-18','09:30:00',7.12),('6449','2013-02-18','09:35:00',8.05),('6449','2013-02-18','09:40:00',10.12),('6449','2013-02-18','09:45:00',9.22),('6449','2013-02-18','09:50:00',10.9),('6449','2013-02-18','09:55:00',4.52),('6449','2013-02-18','10:00:00',6.88),('6449','2013-02-18','10:05:00',12.54),('6449','2013-02-18','10:10:00',10.39),('6449','2013-02-18','10:15:00',13.2),('6449','2013-02-18','10:20:00',11.26),('6449','2013-02-18','10:25:00',12.72),('6449','2013-02-18','10:30:00',13.23),('6449','2013-02-18','10:35:00',13.76),('6449','2013-02-18','10:40:00',13.63),('6449','2013-02-18','10:45:00',14.1),('6449','2013-02-18','10:50:00',14.31),('6449','2013-02-18','10:55:00',10.72),('6449','2013-02-18','11:00:00',6.64),('6449','2013-02-18','11:05:00',8.11),('6449','2013-02-18','11:10:00',8.67),('6449','2013-02-18','11:15:00',9.66),('6449','2013-02-18','11:20:00',9.13),('6449','2013-02-18','11:25:00',12.16),('6449','2013-02-18','11:30:00',12.95),('6449','2013-02-18','11:35:00',5.61),('6449','2013-02-18','11:40:00',5.84),('6449','2013-02-18','11:45:00',5.49),('6449','2013-02-18','11:50:00',5.97),('6449','2013-02-18','11:55:00',5.73),('6449','2013-02-18','12:00:00',5.09),('6449','2013-02-18','12:05:00',6.12),('6449','2013-02-18','12:10:00',6.88),('6449','2013-02-18','12:15:00',6.48),('6449','2013-02-18','12:20:00',7.9),('6449','2013-02-18','12:25:00',9.21),('6449','2013-02-18','12:30:00',9.55),('6449','2013-02-18','12:35:00',7.43),('6449','2013-02-18','12:40:00',7.48),('6449','2013-02-18','12:45:00',8.04),('6449','2013-02-18','12:50:00',7.54),('6449','2013-02-18','12:55:00',7.14),('6449','2013-02-18','13:00:00',5.95),('6449','2013-02-18','13:05:00',5.85),('6449','2013-02-18','13:10:00',5.63),('6449','2013-02-18','13:15:00',5.27),('6449','2013-02-18','13:20:00',5.21),('6449','2013-02-18','13:25:00',6.12),('6449','2013-02-18','13:30:00',5.59),('6449','2013-02-18','13:35:00',5.84),('6449','2013-02-18','13:40:00',6.12),('6449','2013-02-18','13:45:00',5.12),('6449','2013-02-18','13:50:00',4.5),('6449','2013-02-18','13:55:00',4.27),('6449','2013-02-18','14:00:00',5.15),('6449','2013-02-18','14:05:00',5.66),('6449','2013-02-18','14:10:00',6.18),('6449','2013-02-18','14:15:00',4.91),('6449','2013-02-18','14:20:00',5.33),('6449','2013-02-18','14:25:00',5.57),('6449','2013-02-18','14:30:00',4.15),('6449','2013-02-18','14:35:00',3.98),('6449','2013-02-18','14:40:00',4.64),('6449','2013-02-18','14:45:00',5.05),('6449','2013-02-18','14:50:00',5.07),('6449','2013-02-18','14:55:00',7.88),('6449','2013-02-18','15:00:00',5.06),('6449','2013-02-18','15:05:00',3.4),('6449','2013-02-18','15:10:00',2.96),('6449','2013-02-18','15:15:00',2.24),('6449','2013-02-18','15:20:00',2.73),('6449','2013-02-18','15:25:00',2.42),('6449','2013-02-18','15:30:00',1.61),('6449','2013-02-18','15:35:00',1.44),('6449','2013-02-18','15:40:00',1.56),('6449','2013-02-18','15:45:00',1.67),('6449','2013-02-18','15:50:00',1.64),('6449','2013-02-18','15:55:00',1.29),('6449','2013-02-18','16:00:00',1.02),('6449','2013-02-18','16:05:00',1.31),('6449','2013-02-18','16:10:00',1.23),('6449','2013-02-18','16:15:00',1.27),('6449','2013-02-18','16:20:00',1.21),('6449','2013-02-18','16:25:00',1.11),('6449','2013-02-17','07:35:00',1.28),('6449','2013-02-17','07:40:00',1.58),('6449','2013-02-17','07:45:00',1.87),('6449','2013-02-17','07:50:00',2.21),('6449','2013-02-17','07:55:00',2.47),('6449','2013-02-17','08:00:00',2.86),('6449','2013-02-17','08:05:00',3.24),('6449','2013-02-17','08:10:00',3.62),('6449','2013-02-17','08:15:00',4.05),('6449','2013-02-17','08:20:00',4.25),('6449','2013-02-17','08:25:00',3.27),('6449','2013-02-17','08:30:00',4.31),('6449','2013-02-17','08:35:00',5.05),('6449','2013-02-17','08:40:00',6.03),('6449','2013-02-17','08:45:00',6.19),('6449','2013-02-17','08:50:00',6.51),('6449','2013-02-17','08:55:00',7.03),('6449','2013-02-17','09:00:00',6.97),('6449','2013-02-17','09:05:00',6.03),('6449','2013-02-17','09:10:00',7.77),('6449','2013-02-17','09:15:00',8.48),('6449','2013-02-17','09:20:00',8.87),('6449','2013-02-17','09:25:00',9.2),('6449','2013-02-17','09:30:00',9.54),('6449','2013-02-17','09:35:00',9.86),('6449','2013-02-17','09:40:00',10.04),('6449','2013-02-17','09:45:00',10.44),('6449','2013-02-17','09:50:00',10.71),('6449','2013-02-17','09:55:00',10.99),('6449','2013-02-17','10:00:00',11.25),('6449','2013-02-17','10:05:00',11.51),('6449','2013-02-17','10:10:00',11.7),('6449','2013-02-17','10:15:00',12.08),('6449','2013-02-17','10:20:00',12.29),('6449','2013-02-17','10:25:00',12.53),('6449','2013-02-17','10:30:00',12.69),('6449','2013-02-17','10:35:00',12.92),('6449','2013-02-17','10:40:00',13.14),('6449','2013-02-17','10:45:00',13.19),('6449','2013-02-17','10:50:00',13.4),('6449','2013-02-17','10:55:00',13.51),('6449','2013-02-17','11:00:00',13.66),('6449','2013-02-17','11:05:00',13.79),('6449','2013-02-17','11:10:00',13.77),('6449','2013-02-17','11:15:00',13.88),('6449','2013-02-17','11:20:00',13.97),('6449','2013-02-17','11:25:00',13.78),('6449','2013-02-17','11:30:00',14.14),('6449','2013-02-17','11:35:00',14.28),('6449','2013-02-17','11:40:00',14.35),('6449','2013-02-17','11:45:00',14.5),('6449','2013-02-17','11:50:00',14.49),('6449','2013-02-17','11:55:00',14.45),('6449','2013-02-17','12:00:00',15.13),('6449','2013-02-17','12:05:00',15.08),('6449','2013-02-17','12:10:00',14.52),('6449','2013-02-17','12:15:00',14.62),('6449','2013-02-17','12:20:00',14.77),('6449','2013-02-17','12:25:00',14.74),('6449','2013-02-17','12:30:00',14.85),('6449','2013-02-17','12:35:00',15.04),('6449','2013-02-17','12:40:00',13.93),('6449','2013-02-17','12:45:00',14.05),('6449','2013-02-17','12:50:00',13.12),('6449','2013-02-17','12:55:00',14.55),('6449','2013-02-17','13:00:00',14.13),('6449','2013-02-17','13:05:00',13.63),('6449','2013-02-17','13:10:00',13.16),('6449','2013-02-17','13:15:00',10.51),('6449','2013-02-17','13:20:00',12.01),('6449','2013-02-17','13:25:00',14.37),('6449','2013-02-17','13:30:00',15.3),('6449','2013-02-17','13:35:00',15.32),('6449','2013-02-17','13:40:00',11.86),('6449','2013-02-17','13:45:00',14.59),('6449','2013-02-17','13:50:00',11.88),('6449','2013-02-17','13:55:00',6.42),('6449','2013-02-17','14:00:00',5.66),('6449','2013-02-17','14:05:00',5.91),('6449','2013-02-17','14:10:00',6.27),('6449','2013-02-17','14:15:00',6.79),('6449','2013-02-17','14:20:00',12.38),('6449','2013-02-17','14:25:00',12.15),('6449','2013-02-17','14:30:00',9.12),('6449','2013-02-17','14:35:00',6.9),('6449','2013-02-17','14:40:00',11.15),('6449','2013-02-17','14:45:00',9.16),('6449','2013-02-17','14:50:00',9.15),('6449','2013-02-17','14:55:00',9.95),('6449','2013-02-17','15:00:00',8.27),('6449','2013-02-17','15:05:00',8.42),('6449','2013-02-17','15:10:00',8.04),('6449','2013-02-17','15:15:00',2.84),('6449','2013-02-17','15:20:00',3),('6449','2013-02-17','15:25:00',3.08),('6449','2013-02-17','15:30:00',3.13),('6449','2013-02-17','15:35:00',3.3),('6449','2013-02-17','15:40:00',2.99),('6449','2013-02-17','15:45:00',2.6),('6449','2013-02-17','15:50:00',2.03),('6449','2013-02-17','15:55:00',1.62),('6449','2013-02-17','16:00:00',1.53),('6449','2013-02-17','16:05:00',1.47),('6449','2013-02-17','16:10:00',1.45),('6449','2013-02-17','16:15:00',1.67),('6449','2013-02-17','16:20:00',1.7),('6449','2013-02-17','16:25:00',1.33),('6449','2013-02-17','16:30:00',1.19),('6449','2013-02-17','16:35:00',1.04),('6449','2013-02-16','07:30:00',1.07),('6449','2013-02-16','07:35:00',1.41),('6449','2013-02-16','07:40:00',1.44),('6449','2013-02-16','07:50:00',1.04),('6449','2013-02-16','07:55:00',1.22),('6449','2013-02-16','08:00:00',1.47),('6449','2013-02-16','08:05:00',1.81),('6449','2013-02-16','08:11:00',2.4),('6449','2013-02-16','08:15:00',4.17),('6449','2013-02-16','08:20:00',5.08),('6449','2013-02-16','08:25:00',3.97),('6449','2013-02-16','08:30:00',3.39),('6449','2013-02-16','08:35:00',3.19),('6449','2013-02-16','08:40:00',2.89),('6449','2013-02-16','08:45:00',2.35),('6449','2013-02-16','08:50:00',3),('6449','2013-02-16','08:55:00',4.98),('6449','2013-02-16','09:00:00',5.22),('6449','2013-02-16','09:05:00',7.67),('6449','2013-02-16','09:10:00',5.88),('6449','2013-02-16','09:15:00',7.08),('6449','2013-02-16','09:20:00',5.73),('6449','2013-02-16','09:25:00',9.19),('6449','2013-02-16','09:30:00',9.62),('6449','2013-02-16','09:35:00',9.8),('6449','2013-02-16','09:40:00',10.15),('6449','2013-02-16','09:45:00',10.39),('6449','2013-02-16','09:50:00',10.7),('6449','2013-02-16','09:55:00',10.98),('6449','2013-02-16','10:00:00',11.31),('6449','2013-02-16','10:05:00',11.86),('6449','2013-02-16','10:10:00',9.22),('6449','2013-02-16','10:15:00',10.67),('6449','2013-02-16','10:20:00',3.9),('6449','2013-02-16','10:25:00',9.41),('6449','2013-02-16','10:30:00',8.92),('6449','2013-02-16','10:35:00',11.67),('6449','2013-02-16','10:40:00',10.35),('6449','2013-02-16','10:45:00',11.52),('6449','2013-02-16','10:50:00',13.13),('6449','2013-02-16','10:55:00',13.73),('6449','2013-02-16','11:00:00',13.78),('6449','2013-02-16','11:05:00',13.7),('6449','2013-02-16','11:10:00',14.4),('6449','2013-02-16','11:15:00',14.78),('6449','2013-02-16','11:20:00',14.82),('6449','2013-02-16','11:25:00',11.99),('6449','2013-02-16','11:30:00',14.57),('6449','2013-02-16','11:35:00',14.07),('6449','2013-02-16','11:40:00',13.98),('6449','2013-02-16','11:45:00',14.72),('6449','2013-02-16','11:50:00',14.8),('6449','2013-02-16','11:55:00',14.75),('6449','2013-02-16','12:00:00',14.61),('6449','2013-02-16','12:05:00',14.73),('6449','2013-02-16','12:10:00',14.61),('6449','2013-02-16','12:15:00',14.94),('6449','2013-02-16','12:20:00',14.79),('6449','2013-02-16','12:25:00',15.84),('6449','2013-02-16','12:30:00',14.17),('6449','2013-02-16','12:35:00',16.06),('6449','2013-02-16','12:40:00',8.19),('6449','2013-02-16','12:45:00',6.43),('6449','2013-02-16','12:50:00',5.06),('6449','2013-02-16','12:55:00',5.73),('6449','2013-02-16','13:00:00',4.89),('6449','2013-02-16','13:05:00',5.17),('6449','2013-02-16','13:10:00',5.44),('6449','2013-02-16','13:15:00',5.27),('6449','2013-02-16','13:20:00',6.99),('6449','2013-02-16','13:25:00',9.44),('6449','2013-02-16','13:30:00',14.64),('6449','2013-02-16','13:35:00',16.01),('6449','2013-02-16','13:40:00',14.7),('6449','2013-02-16','13:45:00',15.65),('6449','2013-02-16','13:50:00',14.31),('6449','2013-02-16','13:55:00',13.08),('6449','2013-02-16','14:00:00',10.45),('6449','2013-02-16','14:05:00',5.57),('6449','2013-02-16','14:10:00',4.47),('6449','2013-02-16','14:15:00',3.95),('6449','2013-02-16','14:20:00',3.75),('6449','2013-02-16','14:25:00',3.65),('6449','2013-02-16','14:30:00',3.45),('6449','2013-02-16','14:35:00',3.41),('6449','2013-02-16','14:40:00',3.46),('6449','2013-02-16','14:45:00',3.49),('6449','2013-02-16','14:50:00',3.42),('6449','2013-02-16','14:55:00',3.27),('6449','2013-02-16','15:00:00',3.2),('6449','2013-02-16','15:05:00',3.06),('6449','2013-02-16','15:10:00',2.96),('6449','2013-02-16','15:15:00',3.06),('6449','2013-02-16','15:20:00',3.06),('6449','2013-02-16','15:25:00',3.31),('6449','2013-02-16','15:30:00',3.46),('6449','2013-02-16','15:35:00',3.73),('6449','2013-02-16','15:40:00',3.21),('6449','2013-02-16','15:45:00',3.91),('6449','2013-02-16','15:50:00',4.23),('6449','2013-02-16','15:55:00',3.31),('6449','2013-02-16','16:00:00',2.99),('6449','2013-02-16','16:05:00',2.59),('6449','2013-02-16','16:10:00',1.89),('6449','2013-02-16','16:15:00',1.51),('6449','2013-02-16','16:20:00',1.39),('6449','2013-02-16','16:25:00',1.24),('6449','2013-02-16','16:30:00',1.13),('6449','2013-02-16','16:35:00',1.03),('6449','2013-02-15','07:30:00',1.15),('6449','2013-02-15','07:35:00',1.55),('6449','2013-02-15','07:40:00',1.59),('6449','2013-02-15','07:50:00',1.02),('6449','2013-02-15','08:00:00',1.13),('6449','2013-02-15','08:05:00',1.01),('6449','2013-02-15','08:10:00',1.33),('6449','2013-02-15','08:15:00',1.16),('6449','2013-02-15','08:20:00',1.16),('6449','2013-02-15','08:25:00',1.4),('6449','2013-02-15','08:30:00',1.47),('6449','2013-02-15','08:35:00',1.65),('6449','2013-02-15','08:40:00',1.84),('6449','2013-02-15','08:45:00',1.88),('6449','2013-02-15','08:50:00',2.65),('6449','2013-02-15','08:55:00',3.68),('6449','2013-02-15','09:00:00',8.84),('6449','2013-02-15','09:05:00',9.97),('6449','2013-02-15','09:10:00',8.91),('6449','2013-02-15','09:15:00',6.65),('6449','2013-02-15','09:20:00',8.55),('6449','2013-02-15','09:25:00',10.83),('6449','2013-02-15','09:30:00',11.73),('6449','2013-02-15','09:35:00',7.24),('6449','2013-02-15','09:40:00',6.9),('6449','2013-02-15','09:45:00',6.85),('6449','2013-02-15','09:50:00',6.96),('6449','2013-02-15','09:55:00',7.97),('6449','2013-02-15','10:00:00',8.89),('6449','2013-02-15','10:05:00',10.51),('6449','2013-02-15','10:10:00',10.35),('6449','2013-02-15','10:15:00',8.75),('6449','2013-02-15','10:20:00',8.81),('6449','2013-02-15','10:25:00',6.78),('6449','2013-02-15','10:30:00',6.29),('6449','2013-02-15','10:35:00',10.3),('6449','2013-02-15','10:41:00',13.56),('6449','2013-02-15','10:45:00',14.01),('6449','2013-02-15','10:52:00',14.04),('6449','2013-02-15','10:55:00',14.19),('6449','2013-02-15','11:00:00',14.22),('6449','2013-02-15','11:05:00',13.22),('6449','2013-02-15','11:10:00',10.52),('6449','2013-02-15','11:15:00',10.74),('6449','2013-02-15','11:20:00',11.41),('6449','2013-02-15','11:25:00',12.55),('6449','2013-02-15','11:30:00',13.14),('6449','2013-02-15','11:35:00',13.15),('6449','2013-02-15','11:40:00',8.86),('6449','2013-02-15','11:45:00',11.85),('6449','2013-02-15','11:50:00',15.51),('6449','2013-02-15','11:55:00',15.59),('6449','2013-02-15','12:00:00',14.51),('6449','2013-02-15','12:05:00',14.91),('6449','2013-02-15','12:10:00',12.22),('6449','2013-02-15','12:15:00',11.31),('6449','2013-02-15','12:20:00',14.99),('6449','2013-02-15','12:25:00',13.64),('6449','2013-02-15','12:31:00',14.21),('6449','2013-02-15','12:35:00',14.75),('6449','2013-02-15','12:40:00',14.83),('6449','2013-02-15','12:45:00',11.15),('6449','2013-02-15','12:50:00',11.33),('6449','2013-02-15','12:55:00',12.04),('6449','2013-02-15','13:00:00',15.12),('6449','2013-02-15','13:05:00',14.88),('6449','2013-02-15','13:10:00',10.69),('6449','2013-02-15','13:15:00',9.09),('6449','2013-02-15','13:20:00',8.43),('6449','2013-02-15','13:25:00',8.77),('6449','2013-02-15','13:30:00',14.62),('6449','2013-02-15','13:35:00',14.57),('6449','2013-02-15','13:40:00',10.82),('6449','2013-02-15','13:45:00',11.31),('6449','2013-02-15','13:50:00',13.73),('6449','2013-02-15','13:55:00',13.86),('6449','2013-02-15','14:00:00',11.52),('6449','2013-02-15','14:05:00',11.69),('6449','2013-02-15','14:10:00',12.17),('6449','2013-02-15','14:15:00',12.59),('6449','2013-02-15','14:20:00',13.59),('6449','2013-02-15','14:25:00',9.31),('6449','2013-02-15','14:34:00',10.65),('6449','2013-02-15','14:35:00',10.55),('6449','2013-02-15','14:40:00',8.1),('6449','2013-02-15','14:45:00',6.74),('6449','2013-02-15','14:50:00',8.1),('6449','2013-02-15','14:55:00',9.76),('6449','2013-02-15','15:00:00',8.11),('6449','2013-02-15','15:05:00',5.62),('6449','2013-02-15','15:10:00',4.4),('6449','2013-02-15','15:15:00',4.09);
INSERT INTO `solarlog` VALUES ('6449','2013-02-15','15:20:00',4.57),('6449','2013-02-15','15:25:00',4.28),('6449','2013-02-15','15:30:00',3.83),('6449','2013-02-15','15:35:00',3.51),('6449','2013-02-15','15:40:00',3.29),('6449','2013-02-15','15:45:00',3.3),('6449','2013-02-15','15:50:00',3.53),('6449','2013-02-15','15:55:00',3.9),('6449','2013-02-15','16:00:00',3.99),('6449','2013-02-15','16:05:00',3.47),('6449','2013-02-15','16:10:00',2.99),('6449','2013-02-15','16:15:00',3.67),('6449','2013-02-15','16:20:00',4.75),('6449','2013-02-15','16:25:00',3.4),('6449','2013-02-15','16:30:00',3.19),('6449','2013-02-15','16:35:00',2.24),('6449','2013-02-15','16:40:00',1.55),('6449','2013-02-15','16:45:00',1.2),('6449','2013-02-14','07:30:00',1.06),('6449','2013-02-14','07:35:00',1.42),('6449','2013-02-14','07:40:00',1.78),('6449','2013-02-14','07:45:00',2.05),('6449','2013-02-14','07:50:00',2.49),('6449','2013-02-14','07:55:00',2.86),('6449','2013-02-14','08:00:00',3.23),('6449','2013-02-14','08:05:00',3.59),('6449','2013-02-14','08:10:00',3.85),('6449','2013-02-14','08:15:00',4.11),('6449','2013-02-14','08:20:00',4.41),('6449','2013-02-14','08:25:00',5),('6449','2013-02-14','08:30:00',5.4),('6449','2013-02-14','08:35:00',5.48),('6449','2013-02-14','08:40:00',5.78),('6449','2013-02-14','08:45:00',6.09),('6449','2013-02-14','08:50:00',5.85),('6449','2013-02-14','08:55:00',5.62),('6449','2013-02-14','09:00:00',6.68),('6449','2013-02-14','09:05:00',7.54),('6449','2013-02-14','09:10:00',8.36),('6449','2013-02-14','09:15:00',8.68),('6449','2013-02-14','09:20:00',9.15),('6449','2013-02-14','09:25:00',9.42),('6449','2013-02-14','09:30:00',9.47),('6449','2013-02-14','09:35:00',9.76),('6449','2013-02-14','09:40:00',10.33),('6449','2013-02-14','09:45:00',10.8),('6449','2013-02-14','09:50:00',11.14),('6449','2013-02-14','09:55:00',11.42),('6449','2013-02-14','10:00:00',11.67),('6449','2013-02-14','10:05:00',11.77),('6449','2013-02-14','10:10:00',12.09),('6449','2013-02-14','10:15:00',12.35),('6449','2013-02-14','10:20:00',12.59),('6449','2013-02-14','10:25:00',12.8),('6449','2013-02-14','10:30:00',13.01),('6449','2013-02-14','10:35:00',13.02),('6449','2013-02-14','10:40:00',13.44),('6449','2013-02-14','10:45:00',13.54),('6449','2013-02-14','10:50:00',13.75),('6449','2013-02-14','10:55:00',13.94),('6449','2013-02-14','11:00:00',14.1),('6449','2013-02-14','11:05:00',14.08),('6449','2013-02-14','11:10:00',14.38),('6449','2013-02-14','11:15:00',14.52),('6449','2013-02-14','11:20:00',14.58),('6449','2013-02-14','11:25:00',14.72),('6449','2013-02-14','11:30:00',14.81),('6449','2013-02-14','11:35:00',14.81),('6449','2013-02-14','11:40:00',14.86),('6449','2013-02-14','11:45:00',15.01),('6449','2013-02-14','11:50:00',14.98),('6449','2013-02-14','11:55:00',15.04),('6449','2013-02-14','12:00:00',15.1),('6449','2013-02-14','12:05:00',15.06),('6449','2013-02-14','12:10:00',15.09),('6449','2013-02-14','12:15:00',15.08),('6449','2013-02-14','12:20:00',14.84),('6449','2013-02-14','12:25:00',15.03),('6449','2013-02-14','12:30:00',14.97),('6449','2013-02-14','12:35:00',14.91),('6449','2013-02-14','12:40:00',14.91),('6449','2013-02-14','12:45:00',14.92),('6449','2013-02-14','12:50:00',14.61),('6449','2013-02-14','12:55:00',14.77),('6449','2013-02-14','13:00:00',14.72),('6449','2013-02-14','13:05:00',14.54),('6449','2013-02-14','13:10:00',14.47),('6449','2013-02-14','13:15:00',14.37),('6449','2013-02-14','13:20:00',14.23),('6449','2013-02-14','13:25:00',14.15),('6449','2013-02-14','13:30:00',14.01),('6449','2013-02-14','13:35:00',13.74),('6449','2013-02-14','13:40:00',13.67),('6449','2013-02-14','13:45:00',13.51),('6449','2013-02-14','13:50:00',13.36),('6449','2013-02-14','13:55:00',13.07),('6449','2013-02-14','14:00:00',12.82),('6449','2013-02-14','14:05:00',12.72),('6449','2013-02-14','14:10:00',12.51),('6449','2013-02-14','14:15:00',12.22),('6449','2013-02-14','14:20:00',11.99),('6449','2013-02-14','14:25:00',11.76),('6449','2013-02-14','14:30:00',11.5),('6449','2013-02-14','14:35:00',11.13),('6449','2013-02-14','14:40:00',10.99),('6449','2013-02-14','14:45:00',10.69),('6449','2013-02-14','14:50:00',10.39),('6449','2013-02-14','14:55:00',10.11),('6449','2013-02-14','15:00:00',9.8),('6449','2013-02-14','15:05:00',9.43),('6449','2013-02-14','15:10:00',9.15),('6449','2013-02-14','15:15:00',8.89),('6449','2013-02-14','15:20:00',8.46),('6449','2013-02-14','15:25:00',8.16),('6449','2013-02-14','15:30:00',7.71),('6449','2013-02-14','15:35:00',7.35),('6449','2013-02-14','15:40:00',6.95),('6449','2013-02-14','15:45:00',6.56),('6449','2013-02-14','15:50:00',6.1),('6449','2013-02-14','15:55:00',5.59),('6449','2013-02-14','16:00:00',5.38),('6449','2013-02-14','16:05:00',5.1),('6449','2013-02-14','16:10:00',4.72),('6449','2013-02-14','16:15:00',4.29),('6449','2013-02-14','16:20:00',3.81),('6449','2013-02-14','16:25:00',3.46),('6449','2013-02-14','16:30:00',3.17),('6449','2013-02-14','16:35:00',2.84),('6449','2013-02-14','16:40:00',2.51),('6449','2013-02-14','16:45:00',2.19),('6449','2013-02-14','16:50:00',1.83),('6449','2013-02-14','16:55:00',1.52),('6449','2013-02-14','17:00:00',1.19),('6449','2013-02-13','08:00:00',1.2),('6449','2013-02-13','08:05:00',1.42),('6449','2013-02-13','08:10:00',1.64),('6449','2013-02-13','08:15:00',1.87),('6449','2013-02-13','08:20:00',2.11),('6449','2013-02-13','08:25:00',2.43),('6449','2013-02-13','08:30:00',2.63),('6449','2013-02-13','08:35:00',3.08),('6449','2013-02-13','08:40:00',3.78),('6449','2013-02-13','08:45:00',4.13),('6449','2013-02-13','08:50:00',3.4),('6449','2013-02-13','08:55:00',3.6),('6449','2013-02-13','09:00:00',4.41),('6449','2013-02-13','09:05:00',4.46),('6449','2013-02-13','09:10:00',5.15),('6449','2013-02-13','09:15:00',4.91),('6449','2013-02-13','09:20:00',5.4),('6449','2013-02-13','09:25:00',6.39),('6449','2013-02-13','09:30:00',7.55),('6449','2013-02-13','09:35:00',8.87),('6449','2013-02-13','09:40:00',9.48),('6449','2013-02-13','09:45:00',9.87),('6449','2013-02-13','09:50:00',9.56),('6449','2013-02-13','09:55:00',10.83),('6449','2013-02-13','10:00:00',11.46),('6449','2013-02-13','10:05:00',11.93),('6449','2013-02-13','10:10:00',12.15),('6449','2013-02-13','10:15:00',12.55),('6449','2013-02-13','10:20:00',12.89),('6449','2013-02-13','10:25:00',13.25),('6449','2013-02-13','10:30:00',13.27),('6449','2013-02-13','10:35:00',13.15),('6449','2013-02-13','10:40:00',13.08),('6449','2013-02-13','10:45:00',13.28),('6449','2013-02-13','10:50:00',13.47),('6449','2013-02-13','10:55:00',14.04),('6449','2013-02-13','11:00:00',14.08),('6449','2013-02-13','11:05:00',13.71),('6449','2013-02-13','11:10:00',13.96),('6449','2013-02-13','11:15:00',13.54),('6449','2013-02-13','11:20:00',12.66),('6449','2013-02-13','11:25:00',12.8),('6449','2013-02-13','11:30:00',14.55),('6449','2013-02-13','11:35:00',14.23),('6449','2013-02-13','11:40:00',14.73),('6449','2013-02-13','11:45:00',15.49),('6449','2013-02-13','11:50:00',9.45),('6449','2013-02-13','11:55:00',8.87),('6449','2013-02-13','12:00:00',12.09),('6449','2013-02-13','12:05:00',12.13),('6449','2013-02-13','12:10:00',13.67),('6449','2013-02-13','12:15:00',13.08),('6449','2013-02-13','12:20:00',13.64),('6449','2013-02-13','12:25:00',14.4),('6449','2013-02-13','12:31:00',12.9),('6449','2013-02-13','12:35:00',12.5),('6449','2013-02-13','12:40:00',12.24),('6449','2013-02-13','12:45:00',15.09),('6449','2013-02-13','12:50:00',15.47),('6449','2013-02-13','12:55:00',14.68),('6449','2013-02-13','13:00:00',10.12),('6449','2013-02-13','13:05:00',11.13),('6449','2013-02-13','13:10:00',13.31),('6449','2013-02-13','13:15:00',12.54),('6449','2013-02-13','13:20:00',10.75),('6449','2013-02-13','13:25:00',8.84),('6449','2013-02-13','13:30:00',9.8),('6449','2013-02-13','13:35:00',12.99),('6449','2013-02-13','13:40:00',13.61),('6449','2013-02-13','13:45:00',13.73),('6449','2013-02-13','13:50:00',13.13),('6449','2013-02-13','13:55:00',12.4),('6449','2013-02-13','14:00:00',12.45),('6449','2013-02-13','14:05:00',12.46),('6449','2013-02-13','14:10:00',11.36),('6449','2013-02-13','14:15:00',10.53),('6449','2013-02-13','14:20:00',10.98),('6449','2013-02-13','14:25:00',9.78),('6449','2013-02-13','14:30:00',9.99),('6449','2013-02-13','14:35:00',9.4),('6449','2013-02-13','14:40:00',10.69),('6449','2013-02-13','14:45:00',10.97),('6449','2013-02-13','14:50:00',10.88),('6449','2013-02-13','14:55:00',10.26),('6449','2013-02-13','15:00:00',9.59),('6449','2013-02-13','15:05:00',8.23),('6449','2013-02-13','15:10:00',9.37),('6449','2013-02-13','15:15:00',8.86),('6449','2013-02-13','15:20:00',8.36),('6449','2013-02-13','15:25:00',7.84),('6449','2013-02-13','15:30:00',6.75),('6449','2013-02-13','15:35:00',6.82),('6449','2013-02-13','15:40:00',6.86),('6449','2013-02-13','15:45:00',6.71),('6449','2013-02-13','15:50:00',6.35),('6449','2013-02-13','15:55:00',5.85),('6449','2013-02-13','16:00:00',5.48),('6449','2013-02-13','16:05:00',5.31),('6449','2013-02-13','16:10:00',4.92),('6449','2013-02-13','16:15:00',4.52),('6449','2013-02-13','16:20:00',4.09),('6449','2013-02-13','16:25:00',3.74),('6449','2013-02-13','16:30:00',3.28),('6449','2013-02-13','16:35:00',2.94),('6449','2013-02-13','16:40:00',2.56),('6449','2013-02-13','16:45:00',2.23),('6449','2013-02-13','16:50:00',1.88),('6449','2013-02-13','16:55:00',1.56),('6449','2013-02-13','17:00:00',1.27),('6449','2013-02-13','17:05:00',1.01),('6449','2013-02-12','10:25:00',1.16),('6449','2013-02-12','10:30:00',1.33),('6449','2013-02-12','10:35:00',1.5),('6449','2013-02-12','10:40:00',1.72),('6449','2013-02-12','10:45:00',1.69),('6449','2013-02-12','10:50:00',1.62),('6449','2013-02-12','10:55:00',1.65),('6449','2013-02-12','11:00:00',1.56),('6449','2013-02-12','11:05:00',1.56),('6449','2013-02-12','11:10:00',1.62),('6449','2013-02-12','11:15:00',1.71),('6449','2013-02-12','11:20:00',1.87),('6449','2013-02-12','11:25:00',1.96),('6449','2013-02-12','11:30:00',2.07),('6449','2013-02-12','11:35:00',2.11),('6449','2013-02-12','11:40:00',1.97),('6449','2013-02-12','11:45:00',1.77),('6449','2013-02-12','11:50:00',1.78),('6449','2013-02-12','11:55:00',1.75),('6449','2013-02-12','12:00:00',1.72),('6449','2013-02-12','12:05:00',1.67),('6449','2013-02-12','12:10:00',1.68),('6449','2013-02-12','12:15:00',1.57),('6449','2013-02-12','12:20:00',1.73),('6449','2013-02-12','12:25:00',1.79),('6449','2013-02-12','12:30:00',1.85),('6449','2013-02-12','12:35:00',1.98),('6449','2013-02-12','12:40:00',1.91),('6449','2013-02-12','12:45:00',1.79),('6449','2013-02-12','12:50:00',1.71),('6449','2013-02-12','12:55:00',1.61),('6449','2013-02-12','13:00:00',1.51),('6449','2013-02-12','13:05:00',1.43),('6449','2013-02-12','13:10:00',1.41),('6449','2013-02-12','13:15:00',1.5),('6449','2013-02-12','13:20:00',1.44),('6449','2013-02-12','13:25:00',1.4),('6449','2013-02-12','13:30:00',1.38),('6449','2013-02-12','13:35:00',1.62),('6449','2013-02-12','13:40:00',1.83),('6449','2013-02-12','13:45:00',2.02),('6449','2013-02-12','13:50:00',2.2),('6449','2013-02-12','13:55:00',2.24),('6449','2013-02-12','14:00:00',2.19),('6449','2013-02-12','14:05:00',2.09),('6449','2013-02-12','14:10:00',2.02),('6449','2013-02-12','14:15:00',1.85),('6449','2013-02-12','14:20:00',1.92),('6449','2013-02-12','14:25:00',1.8),('6449','2013-02-12','14:30:00',1.77),('6449','2013-02-12','14:35:00',1.61),('6449','2013-02-12','14:40:00',1.42),('6449','2013-02-12','14:45:00',1.2),('6449','2013-02-12','14:50:00',1.35),('6449','2013-02-12','14:55:00',1.39),('6449','2013-02-12','15:00:00',1.51),('6449','2013-02-12','15:05:00',1.54),('6449','2013-02-12','15:10:00',1.84),('6449','2013-02-12','15:15:00',1.72),('6449','2013-02-12','15:20:00',1.53),('6449','2013-02-12','15:25:00',1.49),('6449','2013-02-12','15:30:00',1.49),('6449','2013-02-12','15:35:00',1.4),('6449','2013-02-12','15:40:00',1.1),('6449','2013-02-12','15:45:00',1.2),('6449','2013-02-12','15:50:00',1.1),('6449','2013-02-11','08:10:00',1.26),('6449','2013-02-11','08:15:00',1.03),('6449','2013-02-11','08:20:00',1.37),('6449','2013-02-11','08:25:00',1.32),('6449','2013-02-11','08:35:00',1.16),('6449','2013-02-11','08:40:00',1.19),('6449','2013-02-11','08:45:00',1.38),('6449','2013-02-11','08:50:00',1.49),('6449','2013-02-11','08:55:00',1.58),('6449','2013-02-11','09:00:00',1.89),('6449','2013-02-11','09:05:00',1.97),('6449','2013-02-11','09:10:00',1.84),('6449','2013-02-11','09:15:00',2.05),('6449','2013-02-11','09:20:00',2.21),('6449','2013-02-11','09:25:00',2.07),('6449','2013-02-11','09:30:00',2.77),('6449','2013-02-11','09:35:00',3.51),('6449','2013-02-11','09:40:00',3.44),('6449','2013-02-11','09:45:00',4.26),('6449','2013-02-11','09:50:00',3.09),('6449','2013-02-11','09:55:00',3.51),('6449','2013-02-11','10:00:00',4.16),('6449','2013-02-11','10:05:00',3.63),('6449','2013-02-11','10:10:00',2.96),('6449','2013-02-11','10:15:00',3.22),('6449','2013-02-11','10:20:00',2.47),('6449','2013-02-11','10:25:00',1.36),('6449','2013-02-11','10:30:00',1.26),('6449','2013-02-11','10:35:00',1.05),('6449','2013-02-11','10:40:00',1.13),('6449','2013-02-11','10:45:00',1.27),('6449','2013-02-11','10:50:00',1.15),('6449','2013-02-11','11:15:00',1.05),('6449','2013-02-11','11:20:00',1.27),('6449','2013-02-11','11:50:00',2.38),('6449','2013-02-11','11:55:00',1.45),('6449','2013-02-11','12:00:00',1.24),('6449','2013-02-11','12:05:00',1.25),('6449','2013-02-11','12:10:00',1.32),('6449','2013-02-11','12:15:00',1.16),('6449','2013-02-11','12:30:00',1.04),('6449','2013-02-11','12:35:00',1.25),('6449','2013-02-11','12:40:00',1.54),('6449','2013-02-11','12:45:00',2.01),('6449','2013-02-11','13:00:00',1.04),('6449','2013-02-11','13:05:00',1.05),('6449','2013-02-11','13:20:00',1.01),('6449','2013-02-11','13:25:00',1.42),('6449','2013-02-11','13:30:00',1.14),('6449','2013-02-11','13:40:00',1.92),('6449','2013-02-11','13:45:00',1.81),('6449','2013-02-11','13:55:00',1.62),('6449','2013-02-11','14:00:00',2.3),('6449','2013-02-11','14:05:00',2.4),('6449','2013-02-11','14:10:00',2.36),('6449','2013-02-11','14:15:00',1.81),('6449','2013-02-11','14:20:00',1.72),('6449','2013-02-11','14:25:00',2.05),('6449','2013-02-11','14:30:00',1.64),('6449','2013-02-11','14:35:00',1.5),('6449','2013-02-11','14:40:00',1.07),('6449','2013-02-11','14:55:00',1.16),('6449','2013-02-11','15:40:00',1.27),('6449','2013-02-11','15:50:00',1.62),('6449','2013-02-11','15:55:00',1.95),('6449','2013-02-11','16:15:00',1.11),('6449','2013-02-10','08:10:00',1.01),('6449','2013-02-10','08:15:00',1.31),('6449','2013-02-10','08:20:00',1.42),('6449','2013-02-10','08:25:00',1.43),('6449','2013-02-10','08:30:00',1.35),('6449','2013-02-10','08:35:00',1.22),('6449','2013-02-10','08:40:00',1.59),('6449','2013-02-10','08:45:00',2.01),('6449','2013-02-10','08:50:00',2.97),('6449','2013-02-10','08:55:00',3.98),('6449','2013-02-10','09:00:00',6.63),('6449','2013-02-10','09:05:00',8.1),('6449','2013-02-10','09:10:00',7.33),('6449','2013-02-10','09:15:00',8.42),('6449','2013-02-10','09:20:00',7.7),('6449','2013-02-10','09:25:00',8.26),('6449','2013-02-10','09:30:00',9.56),('6449','2013-02-10','09:35:00',9.8),('6449','2013-02-10','09:40:00',10.1),('6449','2013-02-10','09:45:00',10.39),('6449','2013-02-10','09:50:00',10.77),('6449','2013-02-10','09:55:00',11.14),('6449','2013-02-10','10:00:00',11.81),('6449','2013-02-10','10:05:00',12.56),('6449','2013-02-10','10:10:00',10.89),('6449','2013-02-10','10:15:00',12.49),('6449','2013-02-10','10:20:00',12.46),('6449','2013-02-10','10:25:00',12.35),('6449','2013-02-10','10:30:00',12.8),('6449','2013-02-10','10:35:00',12.9),('6449','2013-02-10','10:40:00',13.17),('6449','2013-02-10','10:45:00',13.38),('6449','2013-02-10','10:50:00',13.48),('6449','2013-02-10','10:55:00',13.75),('6449','2013-02-10','11:00:00',13.42),('6449','2013-02-10','11:05:00',12.08),('6449','2013-02-10','11:10:00',13.45),('6449','2013-02-10','11:15:00',14.2),('6449','2013-02-10','11:20:00',14.37),('6449','2013-02-10','11:25:00',14.48),('6449','2013-02-10','11:30:00',14.54),('6449','2013-02-10','11:35:00',14.6),('6449','2013-02-10','11:40:00',14.29),('6449','2013-02-10','11:45:00',14.76),('6449','2013-02-10','11:50:00',14.85),('6449','2013-02-10','11:55:00',14.84),('6449','2013-02-10','12:00:00',14.8),('6449','2013-02-10','12:05:00',14.86),('6449','2013-02-10','12:10:00',14.57),('6449','2013-02-10','12:15:00',14.74),('6449','2013-02-10','12:20:00',14.67),('6449','2013-02-10','12:25:00',14.58),('6449','2013-02-10','12:30:00',14.57),('6449','2013-02-10','12:35:00',14.59),('6449','2013-02-10','12:40:00',14.5),('6449','2013-02-10','12:45:00',14.46),('6449','2013-02-10','12:50:00',14.33),('6449','2013-02-10','12:55:00',14.17),('6449','2013-02-10','13:00:00',14.14),('6449','2013-02-10','13:05:00',13.96),('6449','2013-02-10','13:10:00',13.73),('6449','2013-02-10','13:15:00',13.66),('6449','2013-02-10','13:20:00',13.4),('6449','2013-02-10','13:25:00',13.18),('6449','2013-02-10','13:30:00',13.3),('6449','2013-02-10','13:35:00',13.19),('6449','2013-02-10','13:40:00',13.28),('6449','2013-02-10','13:45:00',13.75),('6449','2013-02-10','13:50:00',14.21),('6449','2013-02-10','13:55:00',13.59),('6449','2013-02-10','14:00:00',13.79),('6449','2013-02-10','14:05:00',13.71),('6449','2013-02-10','14:11:00',13.5),('6449','2013-02-10','14:15:00',13.22),('6449','2013-02-10','14:20:00',13.29),('6449','2013-02-10','14:25:00',12.89),('6449','2013-02-10','14:30:00',12.32),('6449','2013-02-10','14:35:00',11.7),('6449','2013-02-10','14:40:00',11.16),('6449','2013-02-10','14:45:00',10.75),('6449','2013-02-10','14:50:00',10.53),('6449','2013-02-10','14:55:00',10.53),('6449','2013-02-10','15:00:00',10.8),('6449','2013-02-10','15:05:00',11.06),('6449','2013-02-10','15:10:00',11.1),('6449','2013-02-10','15:15:00',11.54),('6449','2013-02-10','15:20:00',11.39),('6449','2013-02-10','15:25:00',11.09),('6449','2013-02-10','15:30:00',10.02),('6449','2013-02-10','15:35:00',9.74),('6449','2013-02-10','15:40:00',9.63),('6449','2013-02-10','15:45:00',8.91),('6449','2013-02-10','15:50:00',7.57),('6449','2013-02-10','15:55:00',3.2),('6449','2013-02-10','16:00:00',4.01),('6449','2013-02-10','16:05:00',6.13),('6449','2013-02-10','16:10:00',6.45),('6449','2013-02-10','16:15:00',5.5),('6449','2013-02-10','16:20:00',4.33),('6449','2013-02-10','16:25:00',3.87),('6449','2013-02-10','16:30:00',3.79),('6449','2013-02-10','16:35:00',3.41),('6449','2013-02-10','16:40:00',3.03),('6449','2013-02-10','16:45:00',2.59),('6449','2013-02-10','16:50:00',2.16),('6449','2013-02-10','16:55:00',1.54),('6449','2013-02-10','17:00:00',1.08),('6449','2013-02-09','08:45:00',1.01),('6449','2013-02-09','08:50:00',1.16),('6449','2013-02-09','08:55:00',1.31),('6449','2013-02-09','09:00:00',1.49),('6449','2013-02-09','09:05:00',1.7),('6449','2013-02-09','09:10:00',1.92),('6449','2013-02-09','09:15:00',2.07),('6449','2013-02-09','09:20:00',2.14),('6449','2013-02-09','09:25:00',2.21),('6449','2013-02-09','09:30:00',2.31),('6449','2013-02-09','09:35:00',2.4),('6449','2013-02-09','09:40:00',2.7),('6449','2013-02-09','09:45:00',3.02),('6449','2013-02-09','09:50:00',3.36),('6449','2013-02-09','09:55:00',3.57),('6449','2013-02-09','10:00:00',3.6),('6449','2013-02-09','10:05:00',3.58),('6449','2013-02-09','10:10:00',3.58),('6449','2013-02-09','10:15:00',3.63),('6449','2013-02-09','10:20:00',3.58),('6449','2013-02-09','10:25:00',3.64),('6449','2013-02-09','10:30:00',3.86),('6449','2013-02-09','10:35:00',3.93),('6449','2013-02-09','10:40:00',3.87),('6449','2013-02-09','10:45:00',3.79),('6449','2013-02-09','10:50:00',3.83),('6449','2013-02-09','10:55:00',4.08),('6449','2013-02-09','11:00:00',4.3),('6449','2013-02-09','11:05:00',4.5),('6449','2013-02-09','11:10:00',4.58),('6449','2013-02-09','11:15:00',4.6),('6449','2013-02-09','11:20:00',4.47),('6449','2013-02-09','11:25:00',4.59),('6449','2013-02-09','11:30:00',4.5),('6449','2013-02-09','11:35:00',4.61),('6449','2013-02-09','11:40:00',4.76),('6449','2013-02-09','11:45:00',4.85),('6449','2013-02-09','11:50:00',5.09),('6449','2013-02-09','11:55:00',5.3),('6449','2013-02-09','12:00:00',5.98),('6449','2013-02-09','12:05:00',6.36),('6449','2013-02-09','12:10:00',5.89),('6449','2013-02-09','12:15:00',5.63),('6449','2013-02-09','12:20:00',5.67),('6449','2013-02-09','12:25:00',5.97),('6449','2013-02-09','12:30:00',6.46),('6449','2013-02-09','12:35:00',7.25),('6449','2013-02-09','12:40:00',8.37),('6449','2013-02-09','12:45:00',9.52),('6449','2013-02-09','12:50:00',10.99),('6449','2013-02-09','12:55:00',11.57),('6449','2013-02-09','13:00:00',14.51),('6449','2013-02-09','13:05:00',14.1),('6449','2013-02-09','13:10:00',12.06),('6449','2013-02-09','13:15:00',8.85),('6449','2013-02-09','13:20:00',8.83),('6449','2013-02-09','13:25:00',10.57),('6449','2013-02-09','13:30:00',15.11),('6449','2013-02-09','13:35:00',14.31),('6449','2013-02-09','13:40:00',12.78),('6449','2013-02-09','13:45:00',11.54),('6449','2013-02-09','13:50:00',7.97),('6449','2013-02-09','13:55:00',4.37),('6449','2013-02-09','14:00:00',8.45),('6449','2013-02-09','14:05:00',6.98),('6449','2013-02-09','14:10:00',11.48),('6449','2013-02-09','14:15:00',13.5),('6449','2013-02-09','14:20:00',12.36),('6449','2013-02-09','14:25:00',11.18),('6449','2013-02-09','14:30:00',11.66),('6449','2013-02-09','14:35:00',11.48),('6449','2013-02-09','14:40:00',11.07),('6449','2013-02-09','14:45:00',10.64),('6449','2013-02-09','14:50:00',10.42),('6449','2013-02-09','14:55:00',9.89),('6449','2013-02-09','15:00:00',9.76),('6449','2013-02-09','15:05:00',9.4),('6449','2013-02-09','15:10:00',9.03),('6449','2013-02-09','15:15:00',8.67),('6449','2013-02-09','15:20:00',8.3),('6449','2013-02-09','15:25:00',7.87),('6449','2013-02-09','15:30:00',7.53),('6449','2013-02-09','15:35:00',7.14),('6449','2013-02-09','15:40:00',6.79),('6449','2013-02-09','15:45:00',6.44),('6449','2013-02-09','15:50:00',6.09),('6449','2013-02-09','15:55:00',5.83),('6449','2013-02-09','16:00:00',5.73),('6449','2013-02-09','16:05:00',5.63),('6449','2013-02-09','16:10:00',5.39),('6449','2013-02-09','16:15:00',5.4),('6449','2013-02-09','16:20:00',5.42),('6449','2013-02-09','16:25:00',5.39),('6449','2013-02-09','16:30:00',4.94),('6449','2013-02-09','16:35:00',4.52),('6449','2013-02-09','16:40:00',3.64),('6449','2013-02-09','16:45:00',2.99),('6449','2013-02-09','16:50:00',2.22),('6449','2013-02-09','16:55:00',1.46),('6449','2013-02-09','17:01:00',1.53),('6449','2013-02-09','17:05:00',1.2),('6449','2013-02-08','08:05:00',1.04),('6449','2013-02-08','08:10:00',1.23),('6449','2013-02-08','08:15:00',1.45),('6449','2013-02-08','08:20:00',1.95),('6449','2013-02-08','08:25:00',2.87),('6449','2013-02-08','08:30:00',6.15),('6449','2013-02-08','08:35:00',3.51),('6449','2013-02-08','08:40:00',6.57),('6449','2013-02-08','08:45:00',7.2),('6449','2013-02-08','08:50:00',8.61),('6449','2013-02-08','08:55:00',9.63),('6449','2013-02-08','09:00:00',9.58),('6449','2013-02-08','09:05:00',9.66),('6449','2013-02-08','09:10:00',10.48),('6449','2013-02-08','09:15:00',10.78),('6449','2013-02-08','09:20:00',9.79),('6449','2013-02-08','09:25:00',9.57),('6449','2013-02-08','09:30:00',9.42),('6449','2013-02-08','09:35:00',9.91),('6449','2013-02-08','09:40:00',10.44),('6449','2013-02-08','09:45:00',10.86),('6449','2013-02-08','09:50:00',10.95),('6449','2013-02-08','09:55:00',11.2),('6449','2013-02-08','10:00:00',11.1),('6449','2013-02-08','10:05:00',11.51),('6449','2013-02-08','10:10:00',11.71),('6449','2013-02-08','10:15:00',11.89),('6449','2013-02-08','10:20:00',12.2),('6449','2013-02-08','10:25:00',12.36),('6449','2013-02-08','10:30:00',12.62),('6449','2013-02-08','10:35:00',12.87),('6449','2013-02-08','10:40:00',13.04),('6449','2013-02-08','10:45:00',13.28),('6449','2013-02-08','10:50:00',13.57),('6449','2013-02-08','10:55:00',13.8),('6449','2013-02-08','11:00:00',14.1),('6449','2013-02-08','11:05:00',14.98),('6449','2013-02-08','11:10:00',16.22),('6449','2013-02-08','11:15:00',14.89),('6449','2013-02-08','11:20:00',14.88),('6449','2013-02-08','11:25:00',18.09),('6449','2013-02-08','11:30:00',14.68),('6449','2013-02-08','11:35:00',12.63),('6449','2013-02-08','11:40:00',16.56),('6449','2013-02-08','11:45:00',12.12),('6449','2013-02-08','11:50:00',10.29),('6449','2013-02-08','11:55:00',11.73),('6449','2013-02-08','12:00:00',15.4),('6449','2013-02-08','12:05:00',14.85),('6449','2013-02-08','12:10:00',13.93),('6449','2013-02-08','12:15:00',13.04),('6449','2013-02-08','12:20:00',15.88),('6449','2013-02-08','12:25:00',16.24),('6449','2013-02-08','12:30:00',16.24),('6449','2013-02-08','12:35:00',13.98),('6449','2013-02-08','12:40:00',16.52),('6449','2013-02-08','12:45:00',16.9),('6449','2013-02-08','12:50:00',11.48),('6449','2013-02-08','12:55:00',6.89),('6449','2013-02-08','13:00:00',12.07),('6449','2013-02-08','13:05:00',9.87),('6449','2013-02-08','13:10:00',6.72),('6449','2013-02-08','13:15:00',5.89),('6449','2013-02-08','13:20:00',3.73),('6449','2013-02-08','13:25:00',3.33),('6449','2013-02-08','13:30:00',3.48),('6449','2013-02-08','13:35:00',4.26),('6449','2013-02-08','13:40:00',4.8),('6449','2013-02-08','13:45:00',7.68),('6449','2013-02-08','13:50:00',5.71),('6449','2013-02-08','13:55:00',4.18),('6449','2013-02-08','14:00:00',4.17),('6449','2013-02-08','14:05:00',4.28),('6449','2013-02-08','14:10:00',4.76),('6449','2013-02-08','14:15:00',5.07),('6449','2013-02-08','14:20:00',6.81),('6449','2013-02-08','14:25:00',3.86),('6449','2013-02-08','14:30:00',3.13),('6449','2013-02-08','14:35:00',2.79),('6449','2013-02-08','14:40:00',3.73),('6449','2013-02-08','14:45:00',11.73),('6449','2013-02-08','14:50:00',8.84),('6449','2013-02-08','14:55:00',6),('6449','2013-02-08','15:00:00',8.83),('6449','2013-02-08','15:05:00',3.51),('6449','2013-02-08','15:10:00',2.5),('6449','2013-02-08','15:15:00',2.47),('6449','2013-02-08','15:20:00',2.39),('6449','2013-02-08','15:25:00',2.36),('6449','2013-02-08','15:30:00',2.53),('6449','2013-02-08','15:35:00',2.63),('6449','2013-02-08','15:40:00',2.6),('6449','2013-02-08','15:45:00',2.19),('6449','2013-02-08','15:50:00',1.8),('6449','2013-02-08','15:55:00',1.45),('6449','2013-02-08','16:00:00',1.4),('6449','2013-02-08','16:05:00',1.24),('6449','2013-02-08','16:10:00',1.1),('6449','2013-02-08','16:16:00',1.24),('6449','2013-02-08','16:20:00',1.41),('6449','2013-02-07','08:25:00',1.06),('6449','2013-02-07','08:30:00',1.17),('6449','2013-02-07','08:35:00',1.09),('6449','2013-02-07','08:40:00',1.41),('6449','2013-02-07','08:45:00',2.11),('6449','2013-02-07','08:50:00',2.33),('6449','2013-02-07','08:55:00',1.8),('6449','2013-02-07','09:01:00',4.45),('6449','2013-02-07','09:05:00',6.89),('6449','2013-02-07','09:10:00',4.97),('6449','2013-02-07','09:15:00',3),('6449','2013-02-07','09:20:00',2.32),('6449','2013-02-07','09:25:00',1.13),('6449','2013-02-07','09:40:00',1.19),('6449','2013-02-07','09:45:00',1.82),('6449','2013-02-07','09:50:00',2.24),('6449','2013-02-07','09:55:00',6.39),('6449','2013-02-07','10:00:00',7.03),('6449','2013-02-07','10:05:00',5.64),('6449','2013-02-07','10:10:00',12.46),('6449','2013-02-07','10:15:00',11.99),('6449','2013-02-07','10:20:00',12.75),('6449','2013-02-07','10:25:00',11.27),('6449','2013-02-07','10:30:00',3.54),('6449','2013-02-07','10:35:00',1.76),('6449','2013-02-07','10:40:00',1.26),('6449','2013-02-07','10:45:00',1.17),('6449','2013-02-07','10:50:00',1.19),('6449','2013-02-07','10:55:00',1.36),('6449','2013-02-07','11:00:00',2.16),('6449','2013-02-07','11:05:00',5.02),('6449','2013-02-07','11:10:00',7.98),('6449','2013-02-07','11:15:00',13.01),('6449','2013-02-07','11:20:00',14.41),('6449','2013-02-07','11:25:00',14.37),('6449','2013-02-07','11:30:00',14.7),('6449','2013-02-07','11:35:00',14.81),('6449','2013-02-07','11:40:00',14.38),('6449','2013-02-07','11:45:00',7.54),('6449','2013-02-07','11:50:00',1.86),('6449','2013-02-07','11:55:00',6.92),('6449','2013-02-07','12:00:00',10.36),('6449','2013-02-07','12:05:00',14.8),('6449','2013-02-07','12:10:00',15.47),('6449','2013-02-07','12:15:00',13),('6449','2013-02-07','12:20:00',10.92),('6449','2013-02-07','12:25:00',8.37),('6449','2013-02-07','12:30:00',9.61),('6449','2013-02-07','12:35:00',14.6),('6449','2013-02-07','12:40:00',12.47),('6449','2013-02-07','12:45:00',15.09),('6449','2013-02-07','12:50:00',16.11),('6449','2013-02-07','12:55:00',12.16),('6449','2013-02-07','13:00:00',12.24),('6449','2013-02-07','13:05:00',15.28),('6449','2013-02-07','13:10:00',14.62),('6449','2013-02-07','13:15:00',14.8),('6449','2013-02-07','13:20:00',3.84),('6449','2013-02-07','13:25:00',4.39),('6449','2013-02-07','13:30:00',9.06),('6449','2013-02-07','13:35:00',17.9),('6449','2013-02-07','13:40:00',16.41),('6449','2013-02-07','13:45:00',11.06),('6449','2013-02-07','13:50:00',6.91),('6449','2013-02-07','13:55:00',8.21),('6449','2013-02-07','14:00:00',11.71),('6449','2013-02-07','14:05:00',15.22),('6449','2013-02-07','14:10:00',13.68),('6449','2013-02-07','14:15:00',12.23),('6449','2013-02-07','14:20:00',10.85),('6449','2013-02-07','14:25:00',13.53),('6449','2013-02-07','14:30:00',12.87),('6449','2013-02-07','14:35:00',11.86),('6449','2013-02-07','14:40:00',11.29),('6449','2013-02-07','14:45:00',9.75),('6449','2013-02-07','14:50:00',11.53),('6449','2013-02-07','14:55:00',11.04),('6449','2013-02-07','15:00:00',9.26),('6449','2013-02-07','15:05:00',7.94),('6449','2013-02-07','15:10:00',7.05),('6449','2013-02-07','15:15:00',4.26),('6449','2013-02-07','15:20:00',6.52),('6449','2013-02-07','15:25:00',2.58),('6449','2013-02-07','15:30:00',1.09),('6449','2013-02-07','16:40:00',2.23),('6449','2013-02-07','16:45:00',3.66),('6449','2013-02-07','16:50:00',2.74),('6449','2013-02-07','16:55:00',1.78),('6449','2013-02-07','17:00:00',1.29),('6449','2013-02-06','07:45:00',1.25),('6449','2013-02-06','08:00:00',1.07),('6449','2013-02-06','08:05:00',1.3),('6449','2013-02-06','08:10:00',1.47),('6449','2013-02-06','08:15:00',2.34),('6449','2013-02-06','08:20:00',1.74),('6449','2013-02-06','08:25:00',1.75),('6449','2013-02-06','08:30:00',2.57),('6449','2013-02-06','08:35:00',2.48),('6449','2013-02-06','08:40:00',2.57),('6449','2013-02-06','08:45:00',3.42),('6449','2013-02-06','08:50:00',2.9),('6449','2013-02-06','08:55:00',3.07),('6449','2013-02-06','09:00:00',3.11),('6449','2013-02-06','09:05:00',2.64),('6449','2013-02-06','09:10:00',3.31),('6449','2013-02-06','09:15:00',2.69),('6449','2013-02-06','09:20:00',2.87),('6449','2013-02-06','09:25:00',2.8),('6449','2013-02-06','09:30:00',2.84),('6449','2013-02-06','09:35:00',2.85),('6449','2013-02-06','09:40:00',3.28),('6449','2013-02-06','09:45:00',3.9),('6449','2013-02-06','09:50:00',3.35),('6449','2013-02-06','09:55:00',3.03),('6449','2013-02-06','10:00:00',2.98),('6449','2013-02-06','10:05:00',3.06),('6449','2013-02-06','10:10:00',3.26),('6449','2013-02-06','10:15:00',3.53),('6449','2013-02-06','10:20:00',4.97),('6449','2013-02-06','10:25:00',5.85),('6449','2013-02-06','10:30:00',7.87),('6449','2013-02-06','10:35:00',6.14),('6449','2013-02-06','10:40:00',5.07),('6449','2013-02-06','10:45:00',4.78),('6449','2013-02-06','10:50:00',4.1),('6449','2013-02-06','10:55:00',4.24),('6449','2013-02-06','11:00:00',4.79),('6449','2013-02-06','11:05:00',4.16),('6449','2013-02-06','11:10:00',2.97),('6449','2013-02-06','11:15:00',4.16),('6449','2013-02-06','11:20:00',4.91),('6449','2013-02-06','11:25:00',4.51),('6449','2013-02-06','11:30:00',4.24),('6449','2013-02-06','11:35:00',3.91),('6449','2013-02-06','11:40:00',2.87),('6449','2013-02-06','11:45:00',2.02),('6449','2013-02-06','11:50:00',1.96),('6449','2013-02-06','11:55:00',2.11),('6449','2013-02-06','12:00:00',3.2),('6449','2013-02-06','12:05:00',4.84),('6449','2013-02-06','12:10:00',4.72),('6449','2013-02-06','12:15:00',4.29),('6449','2013-02-06','12:20:00',4.27),('6449','2013-02-06','12:25:00',4.07),('6449','2013-02-06','12:30:00',6.62),('6449','2013-02-06','12:35:00',9.52),('6449','2013-02-06','12:40:00',7.96),('6449','2013-02-06','12:45:00',5.86),('6449','2013-02-06','12:50:00',6.37),('6449','2013-02-06','12:55:00',4.2),('6449','2013-02-06','13:00:00',3.52),('6449','2013-02-06','13:05:00',5.02),('6449','2013-02-06','13:10:00',3.52),('6449','2013-02-06','13:15:00',1.6),('6449','2013-02-06','13:20:00',1.07),('6449','2013-02-06','13:30:00',1.45),('6449','2013-02-06','13:35:00',1.41),('6449','2013-02-06','13:40:00',1.16),('6449','2013-02-06','13:45:00',2.3),('6449','2013-02-06','13:50:00',2.1),('6449','2013-02-06','13:55:00',1.46),('6449','2013-02-06','14:15:00',1.66),('6449','2013-02-06','14:20:00',3.98),('6449','2013-02-06','14:25:00',1.23),('6449','2013-02-06','14:30:00',2.53),('6449','2013-02-06','14:35:00',13.64),('6449','2013-02-06','14:40:00',11.12),('6449','2013-02-06','14:45:00',4.65),('6449','2013-02-06','14:50:00',3.72),('6449','2013-02-06','14:55:00',10.65),('6449','2013-02-06','15:00:00',11.77),('6449','2013-02-06','15:05:00',8.82),('6449','2013-02-06','15:10:00',5.96),('6449','2013-02-06','15:15:00',6.63),('6449','2013-02-06','15:20:00',5.92),('6449','2013-02-06','15:25:00',3.76),('6449','2013-02-06','15:30:00',2.47),('6449','2013-02-06','15:35:00',2.28),('6449','2013-02-06','15:40:00',2.03),('6449','2013-02-06','15:45:00',1.82),('6449','2013-02-06','15:50:00',1.77),('6449','2013-02-06','15:55:00',1.73),('6449','2013-02-06','16:00:00',1.82),('6449','2013-02-06','16:05:00',1.7),('6449','2013-02-06','16:10:00',1.26),('6449','2013-02-06','16:15:00',1.14),('6449','2013-02-06','16:20:00',1.14),('6449','2013-02-06','16:25:00',1.14),('6449','2013-02-06','16:30:00',1.45),('6449','2013-02-06','16:35:00',2.27),('6449','2013-02-06','16:40:00',2.89),('6449','2013-02-06','16:45:00',2.45),('6449','2013-02-06','16:50:00',2.02),('6449','2013-02-06','16:55:00',1.04),('6449','2013-02-05','07:40:00',1.07),('6449','2013-02-05','07:45:00',1.44),('6449','2013-02-05','07:50:00',1.78),('6449','2013-02-05','07:55:00',2.06),('6449','2013-02-05','08:00:00',2.44),('6449','2013-02-05','08:05:00',2.81),('6449','2013-02-05','08:10:00',3.13),('6449','2013-02-05','08:15:00',3.42),('6449','2013-02-05','08:20:00',3.81),('6449','2013-02-05','08:25:00',4.09),('6449','2013-02-05','08:30:00',4.54),('6449','2013-02-05','08:35:00',4.9),('6449','2013-02-05','08:40:00',5.28),('6449','2013-02-05','08:45:00',5.68),('6449','2013-02-05','08:50:00',6.04),('6449','2013-02-05','08:55:00',6.37),('6449','2013-02-05','09:00:00',6.83),('6449','2013-02-05','09:05:00',7.11),('6449','2013-02-05','09:10:00',7.5),('6449','2013-02-05','09:15:00',7.52),('6449','2013-02-05','09:20:00',8.08),('6449','2013-02-05','09:25:00',8.42),('6449','2013-02-05','09:30:00',8.72),('6449','2013-02-05','09:35:00',9.01),('6449','2013-02-05','09:40:00',9.25),('6449','2013-02-05','09:45:00',9.52),('6449','2013-02-05','09:50:00',9.84),('6449','2013-02-05','09:55:00',10.11),('6449','2013-02-05','10:00:00',10.39),('6449','2013-02-05','10:05:00',10.62),('6449','2013-02-05','10:10:00',10.57),('6449','2013-02-05','10:15:00',11.04),('6449','2013-02-05','10:20:00',11.2),('6449','2013-02-05','10:25:00',11.3),('6449','2013-02-05','10:30:00',11.55),('6449','2013-02-05','10:35:00',11.87),('6449','2013-02-05','10:40:00',11.92),('6449','2013-02-05','10:45:00',12.57),('6449','2013-02-05','10:50:00',12.72),('6449','2013-02-05','10:55:00',12.37),('6449','2013-02-05','11:00:00',12.89),('6449','2013-02-05','11:05:00',13.41),('6449','2013-02-05','11:10:00',12.47),('6449','2013-02-05','11:15:00',12.94),('6449','2013-02-05','11:20:00',12.67),('6449','2013-02-05','11:25:00',12.86),('6449','2013-02-05','11:30:00',9.66),('6449','2013-02-05','11:35:00',8.73),('6449','2013-02-05','11:40:00',6.85),('6449','2013-02-05','11:45:00',6.36),('6449','2013-02-05','11:50:00',5.72),('6449','2013-02-05','11:55:00',5.73),('6449','2013-02-05','12:00:00',6.49),('6449','2013-02-05','12:05:00',8.49),('6449','2013-02-05','12:10:00',7.16),('6449','2013-02-05','12:15:00',6.93),('6449','2013-02-05','12:20:00',6.19),('6449','2013-02-05','12:25:00',5.43),('6449','2013-02-05','12:30:00',6.1),('6449','2013-02-05','12:35:00',5.31),('6449','2013-02-05','12:40:00',5.88),('6449','2013-02-05','12:45:00',6.18),('6449','2013-02-05','12:50:00',5.23),('6449','2013-02-05','12:55:00',4.34),('6449','2013-02-05','13:00:00',4.33),('6449','2013-02-05','13:05:00',5.22),('6449','2013-02-05','13:10:00',5.39),('6449','2013-02-05','13:15:00',5.71),('6449','2013-02-05','13:20:00',5.75),('6449','2013-02-05','13:25:00',5.99),('6449','2013-02-05','13:30:00',7.13),('6449','2013-02-05','13:35:00',7.75),('6449','2013-02-05','13:40:00',8.39),('6449','2013-02-05','13:45:00',5.63),('6449','2013-02-05','13:50:00',6.44),('6449','2013-02-05','13:55:00',6.83),('6449','2013-02-05','14:00:00',7.39),('6449','2013-02-05','14:05:00',8.84),('6449','2013-02-05','14:10:00',10.51),('6449','2013-02-05','14:15:00',10.2),('6449','2013-02-05','14:20:00',9.42),('6449','2013-02-05','14:25:00',8.57),('6449','2013-02-05','14:30:00',6.09),('6449','2013-02-05','14:35:00',4.58),('6449','2013-02-05','14:40:00',4.45),('6449','2013-02-05','14:45:00',4.23),('6449','2013-02-05','14:50:00',3.11),('6449','2013-02-05','14:55:00',2.38),('6449','2013-02-05','15:00:00',1.23),('6449','2013-02-04','07:35:00',1.04),('6449','2013-02-04','07:40:00',1.43),('6449','2013-02-04','07:45:00',1.78),('6449','2013-02-04','07:50:00',2.12),('6449','2013-02-04','07:55:00',2.55),('6449','2013-02-04','08:00:00',3.1),('6449','2013-02-04','08:05:00',3.54),('6449','2013-02-04','08:10:00',3.7),('6449','2013-02-04','08:15:00',3.92),('6449','2013-02-04','08:20:00',3.95),('6449','2013-02-04','08:25:00',4.39),('6449','2013-02-04','08:30:00',4.67),('6449','2013-02-04','08:35:00',5.18),('6449','2013-02-04','08:40:00',5.52),('6449','2013-02-04','08:45:00',5.94),('6449','2013-02-04','08:50:00',6.38),('6449','2013-02-04','08:55:00',6.79),('6449','2013-02-04','09:00:00',7.15),('6449','2013-02-04','09:05:00',7.11),('6449','2013-02-04','09:10:00',7.23),('6449','2013-02-04','09:15:00',8),('6449','2013-02-04','09:20:00',7.1),('6449','2013-02-04','09:25:00',6.71),('6449','2013-02-04','09:30:00',8.66),('6449','2013-02-04','09:35:00',8.94),('6449','2013-02-04','09:40:00',10.05),('6449','2013-02-04','09:45:00',10.31),('6449','2013-02-04','09:51:00',10.14),('6449','2013-02-04','09:55:00',9.04),('6449','2013-02-04','10:00:00',9.48),('6449','2013-02-04','10:05:00',10.92),('6449','2013-02-04','10:10:00',11.16),('6449','2013-02-04','10:15:00',11.59),('6449','2013-02-04','10:20:00',11.23),('6449','2013-02-04','10:25:00',11.99),('6449','2013-02-04','10:30:00',11.79),('6449','2013-02-04','10:35:00',11.52),('6449','2013-02-04','10:40:00',12.51),('6449','2013-02-04','10:45:00',12.66),('6449','2013-02-04','10:50:00',12.84),('6449','2013-02-04','10:55:00',12.95),('6449','2013-02-04','11:00:00',13),('6449','2013-02-04','11:05:00',13.22),('6449','2013-02-04','11:10:00',13.3),('6449','2013-02-04','11:15:00',13.42),('6449','2013-02-04','11:20:00',13.59),('6449','2013-02-04','11:25:00',13.69),('6449','2013-02-04','11:31:00',13.76),('6449','2013-02-04','11:35:00',13.9),('6449','2013-02-04','11:40:00',13.79),('6449','2013-02-04','11:45:00',14.09),('6449','2013-02-04','11:50:00',14.15),('6449','2013-02-04','11:55:00',14.12),('6449','2013-02-04','12:00:00',14.2),('6449','2013-02-04','12:05:00',14.2),('6449','2013-02-04','12:10:00',14.06),('6449','2013-02-04','12:15:00',14.06),('6449','2013-02-04','12:20:00',14.04),('6449','2013-02-04','12:25:00',14.04),('6449','2013-02-04','12:30:00',13.89),('6449','2013-02-04','12:35:00',13.9),('6449','2013-02-04','12:40:00',13.84),('6449','2013-02-04','12:45:00',13.77),('6449','2013-02-04','12:50:00',13.66),('6449','2013-02-04','12:55:00',13.55),('6449','2013-02-04','13:00:00',13.44),('6449','2013-02-04','13:05:00',13.31),('6449','2013-02-04','13:10:00',13.25),('6449','2013-02-04','13:15:00',13.13),('6449','2013-02-04','13:20:00',12.91),('6449','2013-02-04','13:25:00',12.73),('6449','2013-02-04','13:30:00',12.64),('6449','2013-02-04','13:35:00',12.5),('6449','2013-02-04','13:40:00',12.52),('6449','2013-02-04','13:45:00',12.27),('6449','2013-02-04','13:50:00',12.21),('6449','2013-02-04','13:55:00',12.08),('6449','2013-02-04','14:00:00',11.9),('6449','2013-02-04','14:05:00',11.8),('6449','2013-02-04','14:10:00',11.61),('6449','2013-02-04','14:15:00',11.27),('6449','2013-02-04','14:20:00',11.07),('6449','2013-02-04','14:25:00',10.82),('6449','2013-02-04','14:30:00',10.55),('6449','2013-02-04','14:35:00',10.32),('6449','2013-02-04','14:40:00',9.99),('6449','2013-02-04','14:45:00',9.79),('6449','2013-02-04','14:50:00',9.5),('6449','2013-02-04','14:55:00',9.24),('6449','2013-02-04','15:00:00',8.83),('6449','2013-02-04','15:05:00',8.71),('6449','2013-02-04','15:10:00',8.37),('6449','2013-02-04','15:15:00',7.95),('6449','2013-02-04','15:20:00',7.75),('6449','2013-02-04','15:25:00',7.41),('6449','2013-02-04','15:30:00',7.02),('6449','2013-02-04','15:35:00',6.68),('6449','2013-02-04','15:40:00',6.34),('6449','2013-02-04','15:45:00',5.9),('6449','2013-02-04','15:50:00',5.61),('6449','2013-02-04','15:55:00',5.24),('6449','2013-02-04','16:00:00',4.81),('6449','2013-02-04','16:05:00',4.46),('6449','2013-02-04','16:10:00',4.04),('6449','2013-02-04','16:15:00',3.68),('6449','2013-02-04','16:20:00',3.33),('6449','2013-02-04','16:25:00',2.94),('6449','2013-02-04','16:30:00',2.56),('6449','2013-02-04','16:35:00',2.21),('6449','2013-02-04','16:40:00',1.89),('6449','2013-02-04','16:45:00',1.57),('6449','2013-02-04','16:50:00',1.27),('6449','2013-02-04','16:55:00',1),('6449','2013-02-03','08:35:00',1.04),('6449','2013-02-03','08:40:00',1.2),('6449','2013-02-03','08:45:00',1.29),('6449','2013-02-03','08:50:00',1.03),('6449','2013-02-03','09:40:00',2.67),('6449','2013-02-03','09:45:00',3.52),('6449','2013-02-03','09:50:00',1.83),('6449','2013-02-03','09:55:00',1.55),('6449','2013-02-03','10:15:00',1),('6449','2013-02-03','10:20:00',1.44),('6449','2013-02-03','10:25:00',1.23),('6449','2013-02-03','11:25:00',1.18),('6449','2013-02-03','11:30:00',2.29),('6449','2013-02-03','11:35:00',4.01),('6449','2013-02-03','11:40:00',4.55),('6449','2013-02-03','11:45:00',4.12),('6449','2013-02-03','11:50:00',3.39),('6449','2013-02-03','11:55:00',2.24),('6449','2013-02-03','12:00:00',1.22),('6449','2013-02-03','13:55:00',1.18),('6449','2013-02-03','14:00:00',1.45),('6449','2013-02-03','14:05:00',1.34),('6449','2013-02-03','14:10:00',1.06),('6449','2013-02-03','14:30:00',1.07),('6449','2013-02-03','14:35:00',1.16),('6449','2013-02-03','14:40:00',1.24),('6449','2013-02-03','14:45:00',1.4),('6449','2013-02-03','14:50:00',1.35),('6449','2013-02-03','14:55:00',1.4),('6449','2013-02-03','15:00:00',1.38),('6449','2013-02-03','15:05:00',1.25),('6449','2013-02-03','15:10:00',1.17),('6449','2013-02-03','15:15:00',1.06),('6449','2013-02-02','08:25:00',1.17),('6449','2013-02-02','08:30:00',1.51),('6449','2013-02-02','08:35:00',1.65),('6449','2013-02-02','08:40:00',1.66),('6449','2013-02-02','08:45:00',1.85),('6449','2013-02-02','08:50:00',2.08),('6449','2013-02-02','08:55:00',2.12),('6449','2013-02-02','09:00:00',1.92),('6449','2013-02-02','09:05:00',1.48),('6449','2013-02-02','09:10:00',1.88),('6449','2013-02-02','09:15:00',1.8),('6449','2013-02-02','09:20:00',1.48),('6449','2013-02-02','09:25:00',2.13),('6449','2013-02-02','09:30:00',2.78),('6449','2013-02-02','09:35:00',3.72),('6449','2013-02-02','09:40:00',4.7),('6449','2013-02-02','09:45:00',5.5),('6449','2013-02-02','09:50:00',4.68),('6449','2013-02-02','09:55:00',5.01),('6449','2013-02-02','10:00:00',3.92),('6449','2013-02-02','10:05:00',2.17),('6449','2013-02-02','10:10:00',1.79),('6449','2013-02-02','10:20:00',2.63),('6449','2013-02-02','10:25:00',5.56),('6449','2013-02-02','10:30:00',3.81),('6449','2013-02-02','10:35:00',5.25),('6449','2013-02-02','10:40:00',5.87),('6449','2013-02-02','10:45:00',6.23),('6449','2013-02-02','10:50:00',7.41),('6449','2013-02-02','10:55:00',9.45),('6449','2013-02-02','11:00:00',7.93),('6449','2013-02-02','11:05:00',5.87),('6449','2013-02-02','11:10:00',4.51),('6449','2013-02-02','11:15:00',3.28),('6449','2013-02-02','11:20:00',2.74),('6449','2013-02-02','11:25:00',2),('6449','2013-02-02','11:30:00',1.63),('6449','2013-02-02','11:35:00',1.87),('6449','2013-02-02','11:40:00',1.79),('6449','2013-02-02','11:45:00',2.38),('6449','2013-02-02','11:50:00',2.14),('6449','2013-02-02','11:55:00',1.55),('6449','2013-02-02','12:00:00',2.2),('6449','2013-02-02','12:05:00',1.5),('6449','2013-02-02','12:10:00',1.28),('6449','2013-02-02','12:15:00',1.96),('6449','2013-02-02','12:20:00',1.61),('6449','2013-02-02','12:25:00',6.6),('6449','2013-02-02','12:30:00',8.5),('6449','2013-02-02','12:35:00',2.32),('6449','2013-02-02','12:40:00',1.82),('6449','2013-02-02','12:45:00',4.76),('6449','2013-02-02','12:50:00',4.18),('6449','2013-02-02','12:55:00',4.07),('6449','2013-02-02','13:00:00',3.48),('6449','2013-02-02','13:05:00',1.45),('6449','2013-02-02','13:10:00',1.26),('6449','2013-02-02','13:15:00',1.11),('6449','2013-02-02','13:20:00',1.39),('6449','2013-02-02','13:25:00',1.29),('6449','2013-02-02','13:30:00',1.27),('6449','2013-02-02','13:35:00',1.5),('6449','2013-02-02','13:40:00',1.24),('6449','2013-02-02','13:45:00',1.46),('6449','2013-02-02','13:55:00',1.01),('6449','2013-02-02','14:05:00',1.34),('6449','2013-02-02','14:10:00',2.16),('6449','2013-02-02','14:20:00',1.64),('6449','2013-02-02','14:25:00',1.69),('6449','2013-02-02','15:10:00',2.18),('6449','2013-02-02','15:15:00',1.18),('6449','2013-02-02','15:25:00',1.21),('6449','2013-02-01','08:05:00',1.41),('6449','2013-02-01','08:15:00',1.98),('6449','2013-02-01','08:20:00',2.93),('6449','2013-02-01','08:25:00',2.04),('6449','2013-02-01','08:30:00',1.69),('6449','2013-02-01','08:35:00',1.41),('6449','2013-02-01','08:40:00',2.59),('6449','2013-02-01','08:45:00',4.66),('6449','2013-02-01','08:50:00',3.46),('6449','2013-02-01','08:55:00',2.26),('6449','2013-02-01','09:00:00',3.95),('6449','2013-02-01','09:05:00',3.04),('6449','2013-02-01','09:10:00',3.08),('6449','2013-02-01','09:15:00',2.8),('6449','2013-02-01','09:20:00',3.93),('6449','2013-02-01','09:25:00',4),('6449','2013-02-01','09:30:00',3.09),('6449','2013-02-01','09:35:00',2.45),('6449','2013-02-01','09:40:00',1.59),('6449','2013-02-01','09:45:00',1.67),('6449','2013-02-01','09:50:00',3.63),('6449','2013-02-01','09:55:00',5.26),('6449','2013-02-01','10:00:00',8.39),('6449','2013-02-01','10:05:00',6.27),('6449','2013-02-01','10:10:00',4.26),('6449','2013-02-01','10:15:00',3.12),('6449','2013-02-01','10:20:00',3.61),('6449','2013-02-01','10:25:00',4.01),('6449','2013-02-01','10:30:00',4.98),('6449','2013-02-01','10:35:00',10.96),('6449','2013-02-01','10:40:00',11.44),('6449','2013-02-01','10:45:00',11.62),('6449','2013-02-01','10:50:00',10.44),('6449','2013-02-01','10:55:00',4.72),('6449','2013-02-01','11:00:00',11.29),('6449','2013-02-01','11:05:00',4.07),('6449','2013-02-01','11:10:00',3.63),('6449','2013-02-01','11:15:00',3.52),('6449','2013-02-01','11:20:00',5.32),('6449','2013-02-01','11:25:00',8.89),('6449','2013-02-01','11:30:00',12.99),('6449','2013-02-01','11:35:00',12.55),('6449','2013-02-01','11:40:00',12.62),('6449','2013-02-01','11:45:00',12.97),('6449','2013-02-01','11:50:00',10.45),('6449','2013-02-01','11:55:00',3.3),('6449','2013-02-01','12:00:00',2.81),('6449','2013-02-01','12:05:00',2.7),('6449','2013-02-01','12:10:00',4.61),('6449','2013-02-01','12:15:00',5.33),('6449','2013-02-01','12:20:00',12.61),('6449','2013-02-01','12:25:00',13.73),('6449','2013-02-01','12:30:00',13.02),('6449','2013-02-01','12:35:00',12.69),('6449','2013-02-01','12:40:00',12.4),('6449','2013-02-01','12:45:00',12.23),('6449','2013-02-01','12:50:00',12.17),('6449','2013-02-01','12:55:00',12.39),('6449','2013-02-01','13:00:00',12.24),('6449','2013-02-01','13:05:00',10.91),('6449','2013-02-01','13:10:00',11.21),('6449','2013-02-01','13:15:00',11.28),('6449','2013-02-01','13:20:00',10.41),('6449','2013-02-01','13:25:00',10.09),('6449','2013-02-01','13:30:00',11.94),('6449','2013-02-01','13:35:00',10.2),('6449','2013-02-01','13:40:00',11.29),('6449','2013-02-01','13:45:00',11.13),('6449','2013-02-01','13:50:00',11.21),('6449','2013-02-01','13:55:00',10.64),('6449','2013-02-01','14:00:00',10.99),('6449','2013-02-01','14:05:00',10.75),('6449','2013-02-01','14:10:00',10.39),('6449','2013-02-01','14:15:00',10.32),('6449','2013-02-01','14:20:00',10.19),('6449','2013-02-01','14:25:00',9.62),('6449','2013-02-01','14:30:00',9.65),('6449','2013-02-01','14:35:00',9.32),('6449','2013-02-01','14:40:00',9.08),('6449','2013-02-01','14:45:00',8.61),('6449','2013-02-01','14:50:00',8.51),('6449','2013-02-01','14:55:00',8.16),('6449','2013-02-01','15:00:00',7.91),('6449','2013-02-01','15:05:00',7.71),('6449','2013-02-01','15:10:00',7.34),('6449','2013-02-01','15:15:00',7.02),('6449','2013-02-01','15:20:00',6.5),('6449','2013-02-01','15:25:00',6.35),('6449','2013-02-01','15:30:00',5.62),('6449','2013-02-01','15:35:00',5.26),('6449','2013-02-01','15:40:00',5),('6449','2013-02-01','15:45:00',4.58),('6449','2013-02-01','15:50:00',4.04),('6449','2013-02-01','15:55:00',2.86),('6449','2013-02-01','16:00:00',2.2),('6449','2013-02-01','16:05:00',1.78),('6449','2013-02-01','16:10:00',2),('6449','2013-02-01','16:15:00',1.76),('6449','2013-02-01','16:20:00',1.48),('6449','2013-02-01','16:25:00',1.52),('6449','2013-02-01','16:30:00',1.16),('6449','2013-01-31','08:10:00',1.22),('6449','2013-01-31','08:15:00',1.91),('6449','2013-01-31','08:20:00',2.74),('6449','2013-01-31','08:25:00',2.24),('6449','2013-01-31','08:30:00',3.06),('6449','2013-01-31','08:35:00',3.77),('6449','2013-01-31','08:40:00',3.97),('6449','2013-01-31','08:45:00',4.52),('6449','2013-01-31','08:50:00',4.39),('6449','2013-01-31','08:55:00',5.39),('6449','2013-01-31','09:00:00',5.8),('6449','2013-01-31','09:05:00',6.1),('6449','2013-01-31','09:10:00',6.66),('6449','2013-01-31','09:15:00',7),('6449','2013-01-31','09:20:00',7.3),('6449','2013-01-31','09:25:00',7.66),('6449','2013-01-31','09:30:00',7.83),('6449','2013-01-31','09:35:00',8.25),('6449','2013-01-31','09:40:00',8.53),('6449','2013-01-31','09:45:00',8.77),('6449','2013-01-31','09:50:00',8.94),('6449','2013-01-31','09:55:00',9.38),('6449','2013-01-31','10:00:00',9.66),('6449','2013-01-31','10:05:00',9.76),('6449','2013-01-31','10:10:00',9.9),('6449','2013-01-31','10:15:00',10.19),('6449','2013-01-31','10:20:00',10.33),('6449','2013-01-31','10:25:00',10.72),('6449','2013-01-31','10:30:00',10.74),('6449','2013-01-31','10:35:00',10.93),('6449','2013-01-31','10:40:00',11.03),('6449','2013-01-31','10:45:00',11.29),('6449','2013-01-31','10:50:00',11.55),('6449','2013-01-31','10:55:00',11.62),('6449','2013-01-31','11:00:00',11.85),('6449','2013-01-31','11:05:00',11.78),('6449','2013-01-31','11:10:00',12.06),('6449','2013-01-31','11:15:00',11.93),('6449','2013-01-31','11:20:00',12.2),('6449','2013-01-31','11:25:00',12.16),('6449','2013-01-31','11:30:00',12.34),('6449','2013-01-31','11:35:00',12.46),('6449','2013-01-31','11:40:00',12.5),('6449','2013-01-31','11:45:00',12.62),('6449','2013-01-31','11:50:00',12.66),('6449','2013-01-31','11:55:00',12.66),('6449','2013-01-31','12:00:00',12.6),('6449','2013-01-31','12:05:00',12.67),('6449','2013-01-31','12:10:00',12.63),('6449','2013-01-31','12:15:00',12.72),('6449','2013-01-31','12:20:00',12.62),('6449','2013-01-31','12:25:00',12.7),('6449','2013-01-31','12:30:00',12.76),('6449','2013-01-31','12:35:00',12.76),('6449','2013-01-31','12:40:00',12.64),('6449','2013-01-31','12:45:00',12.56),('6449','2013-01-31','12:50:00',12.59),('6449','2013-01-31','12:55:00',12.33),('6449','2013-01-31','13:00:00',12.29),('6449','2013-01-31','13:05:00',12.29),('6449','2013-01-31','13:10:00',12.21),('6449','2013-01-31','13:15:00',12.08),('6449','2013-01-31','13:20:00',11.74),('6449','2013-01-31','13:25:00',11.83),('6449','2013-01-31','13:30:00',11.85),('6449','2013-01-31','13:35:00',11.8),('6449','2013-01-31','13:40:00',11.61),('6449','2013-01-31','13:45:00',11.49),('6449','2013-01-31','13:50:00',11.37),('6449','2013-01-31','13:55:00',11.09),('6449','2013-01-31','14:00:00',10.78),('6449','2013-01-31','14:05:00',10.64),('6449','2013-01-31','14:10:00',10.48),('6449','2013-01-31','14:15:00',10.32),('6449','2013-01-31','14:20:00',10.14),('6449','2013-01-31','14:25:00',9.81),('6449','2013-01-31','14:30:00',9.58),('6449','2013-01-31','14:35:00',9.32),('6449','2013-01-31','14:40:00',9.08),('6449','2013-01-31','14:45:00',8.66),('6449','2013-01-31','14:50:00',8.15),('6449','2013-01-31','14:55:00',8.12),('6449','2013-01-31','15:00:00',7.95),('6449','2013-01-31','15:05:00',7.57),('6449','2013-01-31','15:10:00',7.4),('6449','2013-01-31','15:15:00',7.13),('6449','2013-01-31','15:20:00',7.05),('6449','2013-01-31','15:25:00',6.74),('6449','2013-01-31','15:30:00',6.06),('6449','2013-01-31','15:35:00',5.04),('6449','2013-01-31','15:40:00',3.58),('6449','2013-01-31','15:45:00',3.65),('6449','2013-01-31','15:50:00',4.52),('6449','2013-01-31','15:55:00',3.77),('6449','2013-01-31','16:00:00',3.7),('6449','2013-01-31','16:05:00',3.31),('6449','2013-01-31','16:10:00',3.38),('6449','2013-01-31','16:15:00',3.22),('6449','2013-01-31','16:20:00',2.82),('6449','2013-01-31','16:25:00',2.48),('6449','2013-01-31','16:30:00',2.15),('6449','2013-01-31','16:35:00',1.83),('6449','2013-01-31','16:40:00',1.66),('6449','2013-01-31','16:45:00',1.37),('6449','2013-01-31','16:50:00',1.06),('6449','2013-01-30','08:10:00',1.02),('6449','2013-01-30','08:15:00',2.3),('6449','2013-01-30','08:20:00',1.74),('6449','2013-01-30','08:25:00',1.48),('6449','2013-01-30','08:30:00',1.17),('6449','2013-01-30','08:35:00',1.74),('6449','2013-01-30','08:40:00',2.29),('6449','2013-01-30','08:45:00',1.8),('6449','2013-01-30','08:50:00',5.08),('6449','2013-01-30','08:55:00',5.55),('6449','2013-01-30','09:00:00',6.1),('6449','2013-01-30','09:05:00',7.35),('6449','2013-01-30','09:10:00',8.78),('6449','2013-01-30','09:15:00',8.81),('6449','2013-01-30','09:20:00',4.91),('6449','2013-01-30','09:25:00',4.56),('6449','2013-01-30','09:30:00',7.88),('6449','2013-01-30','09:35:00',8.72),('6449','2013-01-30','09:40:00',4.87),('6449','2013-01-30','09:45:00',3.52),('6449','2013-01-30','09:50:00',3.5),('6449','2013-01-30','09:55:00',3.67),('6449','2013-01-30','10:00:00',8.27),('6449','2013-01-30','10:05:00',9.48),('6449','2013-01-30','10:10:00',3.59),('6449','2013-01-30','10:15:00',5.59),('6449','2013-01-30','10:20:00',4.29),('6449','2013-01-30','10:25:00',2.96),('6449','2013-01-30','10:30:00',6.38),('6449','2013-01-30','10:35:00',5.15),('6449','2013-01-30','10:40:00',10.01),('6449','2013-01-30','10:45:00',11.44),('6449','2013-01-30','10:50:00',11.66),('6449','2013-01-30','10:55:00',11.76),('6449','2013-01-30','11:00:00',11.97),('6449','2013-01-30','11:05:00',12.12),('6449','2013-01-30','11:10:00',12.12),('6449','2013-01-30','11:15:00',12.04),('6449','2013-01-30','11:20:00',12.32),('6449','2013-01-30','11:25:00',12.37),('6449','2013-01-30','11:30:00',12.52),('6449','2013-01-30','11:35:00',12.74),('6449','2013-01-30','11:40:00',12.67),('6449','2013-01-30','11:45:00',12.07),('6449','2013-01-30','11:50:00',13.09),('6449','2013-01-30','11:55:00',8.25),('6449','2013-01-30','12:00:00',6.29),('6449','2013-01-30','12:05:00',6.8),('6449','2013-01-30','12:10:00',9.94),('6449','2013-01-30','12:15:00',13.62),('6449','2013-01-30','12:20:00',13.25),('6449','2013-01-30','12:25:00',6.54),('6449','2013-01-30','12:30:00',6.72),('6449','2013-01-30','12:35:00',6.99),('6449','2013-01-30','12:40:00',7.58),('6449','2013-01-30','12:45:00',6.64),('6449','2013-01-30','12:50:00',7.17),('6449','2013-01-30','12:55:00',12.72),('6449','2013-01-30','13:00:00',13.52),('6449','2013-01-30','13:05:00',12.17),('6449','2013-01-30','13:10:00',12.37),('6449','2013-01-30','13:15:00',12.31),('6449','2013-01-30','13:20:00',8.9),('6449','2013-01-30','13:25:00',12.13),('6449','2013-01-30','13:30:00',10.71),('6449','2013-01-30','13:35:00',10.89),('6449','2013-01-30','13:40:00',10.56),('6449','2013-01-30','13:45:00',9.32),('6449','2013-01-30','13:50:00',8.16),('6449','2013-01-30','13:55:00',7.27),('6449','2013-01-30','14:00:00',8.45),('6449','2013-01-30','14:05:00',8.94),('6449','2013-01-30','14:10:00',8.35),('6449','2013-01-30','14:15:00',6.68),('6449','2013-01-30','14:20:00',4.33),('6449','2013-01-30','14:25:00',5.38),('6449','2013-01-30','14:30:00',5.18),('6449','2013-01-30','14:35:00',5.08),('6449','2013-01-30','14:40:00',4.63),('6449','2013-01-30','14:45:00',4.72),('6449','2013-01-30','14:50:00',4.76),('6449','2013-01-30','14:55:00',4.57),('6449','2013-01-30','15:00:00',4.14),('6449','2013-01-30','15:05:00',3.56),('6449','2013-01-30','15:10:00',3.22),('6449','2013-01-30','15:15:00',2.94),('6449','2013-01-30','15:20:00',2.76),('6449','2013-01-30','15:25:00',2.8),('6449','2013-01-30','15:30:00',3.05),('6449','2013-01-30','15:35:00',3.24),('6449','2013-01-30','15:40:00',2.89),('6449','2013-01-30','15:45:00',2.6),('6449','2013-01-30','15:50:00',2.53),('6449','2013-01-30','15:55:00',2.78),('6449','2013-01-30','16:00:00',4.02),('6449','2013-01-30','16:05:00',3.77),('6449','2013-01-30','16:10:00',2.11),('6449','2013-01-30','16:15:00',2.1),('6449','2013-01-30','16:20:00',1.55),('6449','2013-01-30','16:25:00',1.36),('6449','2013-01-30','16:30:00',1.51),('6449','2013-01-30','16:35:00',1.67),('6449','2013-01-30','16:40:00',1.4),('6449','2013-01-30','16:45:00',1.37),('6449','2013-01-30','16:50:00',1.17),('6449','2013-01-29','07:45:00',1.1),('6449','2013-01-29','07:50:00',1.46),('6449','2013-01-29','07:55:00',1.98),('6449','2013-01-29','08:00:00',2.5),('6449','2013-01-29','08:05:00',2.79),('6449','2013-01-29','08:10:00',3.17),('6449','2013-01-29','08:15:00',3.51),('6449','2013-01-29','08:20:00',3.62),('6449','2013-01-29','08:25:00',3.12),('6449','2013-01-29','08:30:00',1.67),('6449','2013-01-29','08:35:00',4.69),('6449','2013-01-29','08:40:00',5.05),('6449','2013-01-29','08:45:00',4.73),('6449','2013-01-29','08:50:00',5.32),('6449','2013-01-29','08:55:00',5.67),('6449','2013-01-29','09:00:00',5.97),('6449','2013-01-29','09:05:00',6.32),('6449','2013-01-29','09:10:00',6.67),('6449','2013-01-29','09:15:00',6.91),('6449','2013-01-29','09:20:00',7.3),('6449','2013-01-29','09:25:00',7.64),('6449','2013-01-29','09:30:00',7.95),('6449','2013-01-29','09:35:00',8.23),('6449','2013-01-29','09:40:00',8.51),('6449','2013-01-29','09:45:00',8.57),('6449','2013-01-29','09:50:00',8.98),('6449','2013-01-29','09:55:00',9.2),('6449','2013-01-29','10:00:00',9.48),('6449','2013-01-29','10:05:00',9.65),('6449','2013-01-29','10:10:00',10.35),('6449','2013-01-29','10:15:00',11.79),('6449','2013-01-29','10:20:00',9.6),('6449','2013-01-29','10:25:00',4.77),('6449','2013-01-29','10:30:00',4.61),('6449','2013-01-29','10:35:00',7.15),('6449','2013-01-29','10:40:00',6.3),('6449','2013-01-29','10:45:00',5.89),('6449','2013-01-29','10:50:00',10.36),('6449','2013-01-29','10:55:00',11.41),('6449','2013-01-29','11:00:00',12.62),('6449','2013-01-29','11:05:00',11.54),('6449','2013-01-29','11:10:00',12.49),('6449','2013-01-29','11:15:00',12.42),('6449','2013-01-29','11:20:00',12.46),('6449','2013-01-29','11:25:00',11.63),('6449','2013-01-29','11:30:00',11.94),('6449','2013-01-29','11:35:00',11.53),('6449','2013-01-29','11:41:00',11.43),('6449','2013-01-29','11:45:00',12.44),('6449','2013-01-29','11:50:00',12.53),('6449','2013-01-29','11:55:00',12.96),('6449','2013-01-29','12:00:00',12.64),('6449','2013-01-29','12:05:00',12.52),('6449','2013-01-29','12:10:00',12.59),('6449','2013-01-29','12:15:00',12.66),('6449','2013-01-29','12:20:00',12.6),('6449','2013-01-29','12:25:00',12.85),('6449','2013-01-29','12:30:00',12.89),('6449','2013-01-29','12:35:00',12.55),('6449','2013-01-29','12:40:00',12.4),('6449','2013-01-29','12:45:00',12.52),('6449','2013-01-29','12:50:00',12.52),('6449','2013-01-29','12:55:00',12.4),('6449','2013-01-29','13:01:00',12.37),('6449','2013-01-29','13:05:00',12.12),('6449','2013-01-29','13:10:00',12.18),('6449','2013-01-29','13:15:00',12.17),('6449','2013-01-29','13:20:00',12.16),('6449','2013-01-29','13:25:00',12.3),('6449','2013-01-29','13:30:00',12.39),('6449','2013-01-29','13:35:00',10.64),('6449','2013-01-29','13:40:00',8.56),('6449','2013-01-29','13:45:00',12.23),('6449','2013-01-29','13:50:00',11.89),('6449','2013-01-29','13:55:00',11.87),('6449','2013-01-29','14:00:00',8.96),('6449','2013-01-29','14:05:00',10.96),('6449','2013-01-29','14:10:00',11.08),('6449','2013-01-29','14:15:00',10.86),('6449','2013-01-29','14:20:00',10.49),('6449','2013-01-29','14:25:00',10.29),('6449','2013-01-29','14:30:00',10.32),('6449','2013-01-29','14:35:00',10.03),('6449','2013-01-29','14:40:00',5.07),('6449','2013-01-29','14:45:00',7.04),('6449','2013-01-29','14:50:00',8.95),('6449','2013-01-29','14:55:00',8.54),('6449','2013-01-29','15:00:00',8.11),('6449','2013-01-29','15:05:00',7.83),('6449','2013-01-29','15:10:00',7.48),('6449','2013-01-29','15:15:00',7.1),('6449','2013-01-29','15:20:00',6.8),('6449','2013-01-29','15:25:00',6.58),('6449','2013-01-29','15:30:00',6.29),('6449','2013-01-29','15:35:00',5.82),('6449','2013-01-29','15:40:00',5.51),('6449','2013-01-29','15:45:00',5.14),('6449','2013-01-29','15:50:00',4.79),('6449','2013-01-29','15:55:00',4.47),('6449','2013-01-29','16:00:00',4.08),('6449','2013-01-29','16:05:00',3.72),('6449','2013-01-29','16:10:00',3.39),('6449','2013-01-29','16:15:00',3.04),('6449','2013-01-29','16:20:00',2.69),('6449','2013-01-29','16:25:00',2.38),('6449','2013-01-29','16:30:00',2.06),('6449','2013-01-29','16:35:00',1.73),('6449','2013-01-29','16:40:00',1.39),('6449','2013-01-29','16:45:00',1.09),('6449','2013-01-28','09:55:00',1.01),('6449','2013-01-28','10:00:00',1.05),('6449','2013-01-28','10:05:00',1.26),('6449','2013-01-28','10:10:00',1.61),('6449','2013-01-28','10:15:00',2.03),('6449','2013-01-28','10:20:00',2.55),('6449','2013-01-28','10:25:00',3.16),('6449','2013-01-28','10:30:00',3.57),('6449','2013-01-28','10:35:00',3.45),('6449','2013-01-28','10:40:00',2.66),('6449','2013-01-28','10:45:00',2.34),('6449','2013-01-28','10:50:00',2.31),('6449','2013-01-28','10:55:00',2.3),('6449','2013-01-28','11:00:00',2.01),('6449','2013-01-28','11:05:00',1.53),('6449','2013-01-28','11:10:00',1.33),('6449','2013-01-28','11:15:00',1.23),('6449','2013-01-28','11:20:00',1.19),('6449','2013-01-28','11:25:00',1.01),('6449','2013-01-28','11:35:00',1.1),('6449','2013-01-28','11:40:00',1.37),('6449','2013-01-28','11:45:00',1.78),('6449','2013-01-28','11:50:00',2.07),('6449','2013-01-28','11:55:00',2.53),('6449','2013-01-28','12:00:00',3.08),('6449','2013-01-28','12:05:00',3.44),('6449','2013-01-28','12:10:00',3.45),('6449','2013-01-28','12:15:00',3.33),('6449','2013-01-28','12:20:00',3.35),('6449','2013-01-28','12:25:00',3.39),('6449','2013-01-28','12:30:00',2.99),('6449','2013-01-28','12:35:00',2.68),('6449','2013-01-28','12:40:00',2.54),('6449','2013-01-28','12:45:00',3.05),('6449','2013-01-28','12:50:00',3.09),('6449','2013-01-28','12:55:00',2.97),('6449','2013-01-28','13:00:00',3.14),('6449','2013-01-28','13:05:00',3.22),('6449','2013-01-28','13:10:00',2.8),('6449','2013-01-28','13:15:00',2.39),('6449','2013-01-28','13:20:00',2.34),('6449','2013-01-28','13:25:00',2.26),('6449','2013-01-28','13:30:00',2.09),('6449','2013-01-28','13:35:00',1.98),('6449','2013-01-28','13:40:00',2.26),('6449','2013-01-28','13:45:00',2.18),('6449','2013-01-28','13:50:00',2.21),('6449','2013-01-28','13:55:00',2.32),('6449','2013-01-28','14:00:00',2.44),('6449','2013-01-28','14:05:00',2.47),('6449','2013-01-28','14:10:00',2.19),('6449','2013-01-28','14:15:00',1.69),('6449','2013-01-28','14:20:00',1.59),('6449','2013-01-28','14:25:00',1.52),('6449','2013-01-28','14:30:00',1.49),('6449','2013-01-28','14:35:00',1.58),('6449','2013-01-28','14:40:00',1.54),('6449','2013-01-28','14:45:00',1.35),('6449','2013-01-28','14:50:00',1.25),('6449','2013-01-28','14:55:00',1.08),('6449','2013-01-28','15:10:00',1.02),('6449','2013-01-28','15:15:00',1.13),('6449','2013-01-28','15:20:00',1.1),('6449','2013-01-28','15:25:00',1.18),('6449','2013-01-28','15:30:00',1.17),('6449','2013-01-28','15:35:00',1.11),('6449','2013-01-28','15:40:00',1.01),('6449','2013-01-27','07:50:00',1.02),('6449','2013-01-27','07:55:00',1.15),('6449','2013-01-27','08:00:00',1.38),('6449','2013-01-27','08:05:00',1.22),('6449','2013-01-27','08:10:00',1.79),('6449','2013-01-27','08:15:00',1.51),('6449','2013-01-27','08:25:00',1.29),('6449','2013-01-27','08:30:00',1.59),('6449','2013-01-27','08:40:00',1.21),('6449','2013-01-27','08:45:00',1.68),('6449','2013-01-27','08:50:00',1.72),('6449','2013-01-27','08:55:00',1.6),('6449','2013-01-27','09:00:00',1.62),('6449','2013-01-27','09:05:00',2.42),('6449','2013-01-27','09:10:00',2.06),('6449','2013-01-27','09:15:00',1.56),('6449','2013-01-27','09:20:00',5.15),('6449','2013-01-27','09:25:00',6.62),('6449','2013-01-27','09:30:00',7.67),('6449','2013-01-27','09:35:00',7.91),('6449','2013-01-27','09:40:00',8.28),('6449','2013-01-27','09:45:00',8.53),('6449','2013-01-27','09:50:00',8.72),('6449','2013-01-27','09:55:00',8.98),('6449','2013-01-27','10:00:00',9.26),('6449','2013-01-27','10:05:00',9.49),('6449','2013-01-27','10:10:00',9.75),('6449','2013-01-27','10:15:00',10.05),('6449','2013-01-27','10:20:00',10.06),('6449','2013-01-27','10:25:00',10.43),('6449','2013-01-27','10:30:00',10.65),('6449','2013-01-27','10:35:00',10.8),('6449','2013-01-27','10:40:00',11.04),('6449','2013-01-27','10:45:00',11.28),('6449','2013-01-27','10:50:00',11.52),('6449','2013-01-27','10:55:00',11.74),('6449','2013-01-27','11:00:00',11.91),('6449','2013-01-27','11:05:00',12.09),('6449','2013-01-27','11:10:00',12.22),('6449','2013-01-27','11:15:00',12.32),('6449','2013-01-27','11:20:00',12.11),('6449','2013-01-27','11:25:00',12.51),('6449','2013-01-27','11:30:00',12.5),('6449','2013-01-27','11:35:00',12.49),('6449','2013-01-27','11:40:00',12.58),('6449','2013-01-27','11:45:00',12.65),('6449','2013-01-27','11:50:00',12.65),('6449','2013-01-27','11:55:00',12.86),('6449','2013-01-27','12:00:00',12.84),('6449','2013-01-27','12:05:00',12.48),('6449','2013-01-27','12:10:00',12.92),('6449','2013-01-27','12:15:00',13.03),('6449','2013-01-27','12:20:00',12.94),('6449','2013-01-27','12:25:00',12.85),('6449','2013-01-27','12:30:00',12.81),('6449','2013-01-27','12:35:00',12.68),('6449','2013-01-27','12:40:00',12.67),('6449','2013-01-27','12:45:00',12.6),('6449','2013-01-27','12:50:00',12.65),('6449','2013-01-27','12:55:00',12.43),('6449','2013-01-27','13:00:00',12.25),('6449','2013-01-27','13:05:00',12.12),('6449','2013-01-27','13:10:00',12.08),('6449','2013-01-27','13:15:00',11.93),('6449','2013-01-27','13:20:00',11.56),('6449','2013-01-27','13:25:00',11.4),('6449','2013-01-27','13:30:00',11.35),('6449','2013-01-27','13:35:00',11.3),('6449','2013-01-27','13:40:00',11.17),('6449','2013-01-27','13:45:00',11.18),('6449','2013-01-27','13:50:00',10.81),('6449','2013-01-27','13:55:00',10.61),('6449','2013-01-27','14:00:00',10.36),('6449','2013-01-27','14:05:00',10.27),('6449','2013-01-27','14:10:00',10.18),('6449','2013-01-27','14:15:00',9.83),('6449','2013-01-27','14:20:00',9.67),('6449','2013-01-27','14:25:00',9.35),('6449','2013-01-27','14:30:00',9.35),('6449','2013-01-27','14:35:00',9.06),('6449','2013-01-27','14:40:00',8.62),('6449','2013-01-27','14:45:00',8.57),('6449','2013-01-27','14:50:00',8.28),('6449','2013-01-27','14:55:00',7.64),('6449','2013-01-27','15:00:00',7.57),('6449','2013-01-27','15:05:00',7.2),('6449','2013-01-27','15:10:00',6.88),('6449','2013-01-27','15:15:00',6.59),('6449','2013-01-27','15:20:00',6.2),('6449','2013-01-27','15:25:00',5.25),('6449','2013-01-27','15:30:00',5.17),('6449','2013-01-27','15:35:00',5.3),('6449','2013-01-27','15:40:00',4.89),('6449','2013-01-27','15:45:00',4.57),('6449','2013-01-27','15:50:00',4.25),('6449','2013-01-27','15:55:00',3.87),('6449','2013-01-27','16:00:00',3.45),('6449','2013-01-27','16:05:00',3.09),('6449','2013-01-27','16:10:00',2.8),('6449','2013-01-27','16:15:00',2.54),('6449','2013-01-27','16:20:00',2.2),('6449','2013-01-27','16:25:00',1.9),('6449','2013-01-27','16:30:00',1.63),('6449','2013-01-27','16:35:00',1.35),('6449','2013-01-27','16:40:00',1.08),('6449','2013-01-26','09:00:00',1.19),('6449','2013-01-26','09:05:00',1.35),('6449','2013-01-26','09:20:00',1.1),('6449','2013-01-26','09:25:00',1.09),('6449','2013-01-26','09:30:00',1.41),('6449','2013-01-26','09:35:00',1.7),('6449','2013-01-26','09:40:00',1.84),('6449','2013-01-26','09:45:00',2.27),('6449','2013-01-26','09:50:00',2.86),('6449','2013-01-26','09:55:00',2.91),('6449','2013-01-26','10:00:00',3.35),('6449','2013-01-26','10:05:00',3.29),('6449','2013-01-26','10:10:00',3.01),('6449','2013-01-26','10:15:00',3.51),('6449','2013-01-26','10:20:00',3.82),('6449','2013-01-26','10:25:00',3.39),('6449','2013-01-26','10:30:00',3.59),('6449','2013-01-26','10:35:00',3.87),('6449','2013-01-26','10:40:00',4.33),('6449','2013-01-26','10:45:00',4.14),('6449','2013-01-26','10:50:00',4.04),('6449','2013-01-26','10:55:00',3.92),('6449','2013-01-26','11:00:00',3.67),('6449','2013-01-26','11:05:00',3.69),('6449','2013-01-26','11:10:00',3.56),('6449','2013-01-26','11:15:00',3.76),('6449','2013-01-26','11:20:00',9.26),('6449','2013-01-26','11:25:00',12.01),('6449','2013-01-26','11:30:00',12.72),('6449','2013-01-26','11:35:00',15.59),('6449','2013-01-26','11:40:00',9.07),('6449','2013-01-26','11:45:00',6.99),('6449','2013-01-26','11:50:00',7.65),('6449','2013-01-26','11:55:00',4.79),('6449','2013-01-26','12:00:00',4.55),('6449','2013-01-26','12:05:00',3.59),('6449','2013-01-26','12:10:00',2.99),('6449','2013-01-26','12:15:00',3.24),('6449','2013-01-26','12:20:00',3.38),('6449','2013-01-26','12:25:00',3.29),('6449','2013-01-26','12:30:00',3.32),('6449','2013-01-26','12:35:00',3.69),('6449','2013-01-26','12:40:00',4.14),('6449','2013-01-26','12:45:00',4.84),('6449','2013-01-26','12:50:00',4.59),('6449','2013-01-26','12:55:00',4.61),('6449','2013-01-26','13:00:00',4.8),('6449','2013-01-26','13:05:00',4.51),('6449','2013-01-26','13:10:00',4.53),('6449','2013-01-26','13:15:00',4.82),('6449','2013-01-26','13:20:00',4.27),('6449','2013-01-26','13:25:00',3.74),('6449','2013-01-26','13:30:00',3.58),('6449','2013-01-26','13:35:00',3.65),('6449','2013-01-26','13:40:00',3.61),('6449','2013-01-26','13:45:00',3.27),('6449','2013-01-26','13:50:00',3.35),('6449','2013-01-26','13:55:00',3.48),('6449','2013-01-26','14:00:00',3.11),('6449','2013-01-26','14:05:00',2.74),('6449','2013-01-26','14:10:00',2.47),('6449','2013-01-26','14:15:00',2.17),('6449','2013-01-26','14:20:00',1.82),('6449','2013-01-26','14:25:00',1.49),('6449','2013-01-26','14:30:00',1.35),('6449','2013-01-26','14:35:00',1.26),('6449','2013-01-26','14:40:00',1.08),('6449','2013-01-26','14:45:00',1.23),('6449','2013-01-26','14:50:00',1.52),('6449','2013-01-26','14:55:00',1.52),('6449','2013-01-26','15:00:00',1.33),('6449','2013-01-26','15:05:00',1.42),('6449','2013-01-26','15:10:00',1.41),('6449','2013-01-26','15:15:00',1.49),('6449','2013-01-26','15:20:00',1.56),('6449','2013-01-26','15:25:00',1.63),('6449','2013-01-26','15:30:00',1.71),('6449','2013-01-26','15:35:00',1.49),('6449','2013-01-26','15:40:00',1.12),('6449','2013-01-26','15:45:00',1.02),('6449','2013-01-26','15:50:00',1.05),('6449','2013-01-26','15:55:00',1.05),('6449','2013-01-25','08:00:00',1.76),('6449','2013-01-25','08:05:00',2.29),('6449','2013-01-25','08:10:00',2.73),('6449','2013-01-25','08:15:00',2.6),('6449','2013-01-25','08:20:00',3.11),('6449','2013-01-25','08:25:00',3.65),('6449','2013-01-25','08:30:00',4.24),('6449','2013-01-25','08:35:00',5.2),('6449','2013-01-25','08:40:00',4.38),('6449','2013-01-25','08:45:00',4.91),('6449','2013-01-25','08:50:00',6.09),('6449','2013-01-25','08:55:00',6.65),('6449','2013-01-25','09:00:00',7.32),('6449','2013-01-25','09:05:00',7.75),('6449','2013-01-25','09:10:00',8.01),('6449','2013-01-25','09:15:00',7.71),('6449','2013-01-25','09:20:00',8.52),('6449','2013-01-25','09:25:00',8.56),('6449','2013-01-25','09:30:00',8.99),('6449','2013-01-25','09:35:00',9.42),('6449','2013-01-25','09:40:00',9.77),('6449','2013-01-25','09:45:00',9.4),('6449','2013-01-25','09:50:00',8.3),('6449','2013-01-25','09:55:00',9.17),('6449','2013-01-25','10:00:00',9.88),('6449','2013-01-25','10:05:00',9.92),('6449','2013-01-25','10:10:00',10.95),('6449','2013-01-25','10:15:00',10.91),('6449','2013-01-25','10:20:00',9.43),('6449','2013-01-25','10:25:00',9.81),('6449','2013-01-25','10:30:00',10.19),('6449','2013-01-25','10:35:00',9.64),('6449','2013-01-25','10:40:00',9.33),('6449','2013-01-25','10:45:00',6.58),('6449','2013-01-25','10:50:00',4.33),('6449','2013-01-25','10:55:00',2.87),('6449','2013-01-25','11:00:00',3.19),('6449','2013-01-25','11:05:00',3.93),('6449','2013-01-25','11:10:00',3.73),('6449','2013-01-25','11:15:00',3.26),('6449','2013-01-25','11:20:00',3.98),('6449','2013-01-25','11:25:00',5.26),('6449','2013-01-25','11:30:00',7.54),('6449','2013-01-25','11:35:00',10.02),('6449','2013-01-25','11:40:00',12.65),('6449','2013-01-25','11:45:00',12.95),('6449','2013-01-25','11:50:00',12.91),('6449','2013-01-25','11:55:00',12.84),('6449','2013-01-25','12:00:00',12.61),('6449','2013-01-25','12:05:00',12.81),('6449','2013-01-25','12:10:00',12.88),('6449','2013-01-25','12:15:00',13.12),('6449','2013-01-25','12:20:00',11.77),('6449','2013-01-25','12:25:00',13.32),('6449','2013-01-25','12:30:00',13.01),('6449','2013-01-25','12:35:00',13.23),('6449','2013-01-25','12:40:00',13.25),('6449','2013-01-25','12:45:00',13.18),('6449','2013-01-25','12:50:00',13.19),('6449','2013-01-25','12:55:00',13.19),('6449','2013-01-25','13:00:00',13.09),('6449','2013-01-25','13:05:00',13.12),('6449','2013-01-25','13:10:00',12.26),('6449','2013-01-25','13:15:00',12.14),('6449','2013-01-25','13:20:00',12.81),('6449','2013-01-25','13:25:00',12.8),('6449','2013-01-25','13:30:00',11.76),('6449','2013-01-25','13:35:00',12.3),('6449','2013-01-25','13:40:00',11.9),('6449','2013-01-25','13:45:00',11.57),('6449','2013-01-25','13:50:00',11.66),('6449','2013-01-25','13:55:00',11.43),('6449','2013-01-25','14:00:00',11.25),('6449','2013-01-25','14:05:00',8.83),('6449','2013-01-25','14:10:00',9.84),('6449','2013-01-25','14:15:00',7.13),('6449','2013-01-25','14:20:00',9.7),('6449','2013-01-25','14:25:00',8.93),('6449','2013-01-25','14:30:00',8.86),('6449','2013-01-25','14:35:00',8.85),('6449','2013-01-25','14:40:00',8.6),('6449','2013-01-25','14:45:00',8.43),('6449','2013-01-25','14:50:00',8.09),('6449','2013-01-25','14:55:00',8.04),('6449','2013-01-25','15:00:00',7.68),('6449','2013-01-25','15:05:00',7.21),('6449','2013-01-25','15:10:00',7.12),('6449','2013-01-25','15:15:00',7.08),('6449','2013-01-25','15:20:00',6.37),('6449','2013-01-25','15:25:00',6.31),('6449','2013-01-25','15:30:00',5.95),('6449','2013-01-25','15:35:00',5.36),('6449','2013-01-25','15:40:00',4.56),('6449','2013-01-25','15:45:00',3.74),('6449','2013-01-25','15:50:00',4.89),('6449','2013-01-25','15:55:00',4.84),('6449','2013-01-25','16:00:00',1.81),('6449','2013-01-25','16:05:00',4.11),('6449','2013-01-25','16:10:00',4.16),('6449','2013-01-25','16:15:00',3.01),('6449','2013-01-25','16:20:00',1.8),('6449','2013-01-24','08:30:00',1.05),('6449','2013-01-24','08:35:00',1.35),('6449','2013-01-24','08:40:00',1.83),('6449','2013-01-24','08:45:00',2.5),('6449','2013-01-24','08:50:00',1.98),('6449','2013-01-24','08:55:00',2.24),('6449','2013-01-24','09:00:00',2.15),('6449','2013-01-24','09:05:00',2.21),('6449','2013-01-24','09:10:00',2.36),('6449','2013-01-24','09:15:00',3.36),('6449','2013-01-24','09:20:00',5.95),('6449','2013-01-24','09:25:00',7.52),('6449','2013-01-24','09:30:00',8.41),('6449','2013-01-24','09:35:00',7.07),('6449','2013-01-24','09:40:00',9.47),('6449','2013-01-24','09:45:00',9.35),('6449','2013-01-24','09:50:00',9.38),('6449','2013-01-24','09:56:00',7.24),('6449','2013-01-24','10:00:00',7.45),('6449','2013-01-24','10:05:00',6.15),('6449','2013-01-24','10:10:00',8.75),('6449','2013-01-24','10:15:00',10.99),('6449','2013-01-24','10:20:00',11.32),('6449','2013-01-24','10:25:00',11.38),('6449','2013-01-24','10:30:00',11.43),('6449','2013-01-24','10:35:00',11.49),('6449','2013-01-24','10:40:00',11.61),('6449','2013-01-24','10:45:00',11.61),('6449','2013-01-24','10:50:00',9.79),('6449','2013-01-24','10:55:00',10.28),('6449','2013-01-24','11:00:00',11.01),('6449','2013-01-24','11:05:00',12.23),('6449','2013-01-24','11:10:00',11.93),('6449','2013-01-24','11:15:00',11.3),('6449','2013-01-24','11:20:00',12.58),('6449','2013-01-24','11:25:00',12.81),('6449','2013-01-24','11:30:00',12.54),('6449','2013-01-24','11:35:00',13.61),('6449','2013-01-24','11:40:00',13.91),('6449','2013-01-24','11:45:00',8.31),('6449','2013-01-24','11:50:00',3.11),('6449','2013-01-24','11:55:00',2.62),('6449','2013-01-24','12:00:00',2.69),('6449','2013-01-24','12:05:00',2.68),('6449','2013-01-24','12:10:00',2.7),('6449','2013-01-24','12:15:00',2.74),('6449','2013-01-24','12:20:00',2.75),('6449','2013-01-24','12:25:00',2.76),('6449','2013-01-24','12:30:00',2.83),('6449','2013-01-24','12:35:00',2.9),('6449','2013-01-24','12:40:00',3.03),('6449','2013-01-24','12:45:00',3.2),('6449','2013-01-24','12:50:00',3.38),('6449','2013-01-24','12:55:00',3.6),('6449','2013-01-24','13:00:00',3.89),('6449','2013-01-24','13:05:00',4.25),('6449','2013-01-24','13:10:00',4.45),('6449','2013-01-24','13:15:00',7.11),('6449','2013-01-24','13:20:00',13.07),('6449','2013-01-24','13:25:00',11.59),('6449','2013-01-24','13:30:00',12.38),('6449','2013-01-24','13:35:00',13.23),('6449','2013-01-24','13:40:00',12.3),('6449','2013-01-24','13:45:00',9.61),('6449','2013-01-24','13:50:00',9.2),('6449','2013-01-24','13:55:00',6.2),('6449','2013-01-24','14:00:00',3.55),('6449','2013-01-24','14:05:00',5.14),('6449','2013-01-24','14:10:00',7.67),('6449','2013-01-24','14:15:00',11.09),('6449','2013-01-24','14:20:00',10.92),('6449','2013-01-24','14:25:00',10.08),('6449','2013-01-24','14:30:00',8.35),('6449','2013-01-24','14:35:00',6.86),('6449','2013-01-24','14:40:00',5.23),('6449','2013-01-24','14:45:00',4.85),('6449','2013-01-24','14:50:00',3.46),('6449','2013-01-24','14:55:00',3.87),('6449','2013-01-24','15:00:00',5.02),('6449','2013-01-24','15:05:00',7.85),('6449','2013-01-24','15:10:00',8.71),('6449','2013-01-24','15:15:00',8.24),('6449','2013-01-24','15:20:00',7.66),('6449','2013-01-24','15:25:00',6.97),('6449','2013-01-24','15:30:00',6.34),('6449','2013-01-24','15:35:00',5.52),('6449','2013-01-24','15:40:00',4.82),('6449','2013-01-24','15:45:00',4.51),('6449','2013-01-24','15:50:00',1.29),('6449','2013-01-24','15:55:00',2.33),('6449','2013-01-24','16:00:00',2.25),('6449','2013-01-24','16:05:00',3.14),('6449','2013-01-24','16:10:00',3.82),('6449','2013-01-24','16:15:00',1.98),('6449','2013-01-23','08:20:00',1.04),('6449','2013-01-23','08:40:00',1.26),('6449','2013-01-23','08:45:00',3.98),('6449','2013-01-23','08:50:00',3.45),('6449','2013-01-23','08:55:00',5.09),('6449','2013-01-23','09:00:00',5.51),('6449','2013-01-23','09:05:00',7.27),('6449','2013-01-23','09:10:00',7.2),('6449','2013-01-23','09:15:00',6.9),('6449','2013-01-23','09:20:00',4.09),('6449','2013-01-23','09:25:00',4.42),('6449','2013-01-23','09:30:00',3.09),('6449','2013-01-23','09:35:00',2.1),('6449','2013-01-23','09:40:00',1.72),('6449','2013-01-23','09:45:00',1.86),('6449','2013-01-23','09:50:00',2.05),('6449','2013-01-23','09:55:00',1.76),('6449','2013-01-23','10:00:00',1.37),('6449','2013-01-23','10:30:00',1.26),('6449','2013-01-23','10:35:00',3.1),('6449','2013-01-23','10:40:00',3.68),('6449','2013-01-23','10:45:00',3.55),('6449','2013-01-23','10:50:00',2.76),('6449','2013-01-23','10:55:00',1.7),('6449','2013-01-23','11:00:00',1.4),('6449','2013-01-23','11:05:00',1.49),('6449','2013-01-23','11:10:00',1.33),('6449','2013-01-23','11:30:00',1.14),('6449','2013-01-23','11:35:00',1.86),('6449','2013-01-23','11:40:00',2.88),('6449','2013-01-23','11:45:00',2.4),('6449','2013-01-23','11:50:00',1.99),('6449','2013-01-23','11:55:00',1.93),('6449','2013-01-23','12:00:00',1.33),('6449','2013-01-23','12:05:00',1.1),('6449','2013-01-23','12:10:00',1.76),('6449','2013-01-23','12:15:00',3.7),('6449','2013-01-23','12:20:00',4.57),('6449','2013-01-23','12:25:00',4.21),('6449','2013-01-23','12:30:00',2.3),('6449','2013-01-23','12:35:00',1.18),('6449','2013-01-23','12:40:00',1.17),('6449','2013-01-23','12:50:00',1.23),('6449','2013-01-23','13:05:00',1.2),('6449','2013-01-23','13:10:00',2.19),('6449','2013-01-23','13:15:00',1.31),('6449','2013-01-23','15:20:00',1.17),('6449','2013-01-23','15:25:00',1.3),('6449','2013-01-23','15:30:00',1.3),('6449','2013-01-23','15:35:00',1.48),('6449','2013-01-23','15:40:00',1.32),('6449','2013-01-23','15:45:00',1.02),('6449','2013-01-22','08:00:00',1.05),('6449','2013-01-22','08:20:00',1.8),('6449','2013-01-22','08:25:00',2.95),('6449','2013-01-22','08:30:00',3.16),('6449','2013-01-22','08:35:00',1.38),('6449','2013-01-22','08:40:00',1.83),('6449','2013-01-22','08:45:00',1.18),('6449','2013-01-22','09:00:00',1.62),('6449','2013-01-22','09:05:00',1.98),('6449','2013-01-22','09:10:00',3.24),('6449','2013-01-22','09:15:00',2.13),('6449','2013-01-22','09:20:00',1.23),('6449','2013-01-22','09:25:00',1.8),('6449','2013-01-22','09:30:00',5.67),('6449','2013-01-22','09:35:00',7.76),('6449','2013-01-22','09:40:00',8.7),('6449','2013-01-22','09:45:00',7.14),('6449','2013-01-22','09:50:00',8.77),('6449','2013-01-22','09:55:00',8.78),('6449','2013-01-22','10:00:00',6.75),('6449','2013-01-22','10:05:00',10.02),('6449','2013-01-22','10:10:00',11.47),('6449','2013-01-22','10:15:00',7.62),('6449','2013-01-22','10:20:00',4.11),('6449','2013-01-22','10:25:00',10.62),('6449','2013-01-22','10:30:00',4.48),('6449','2013-01-22','10:35:00',8.41),('6449','2013-01-22','10:40:00',4.54),('6449','2013-01-22','10:45:00',10.43),('6449','2013-01-22','10:50:00',5.09),('6449','2013-01-22','10:55:00',2.01),('6449','2013-01-22','11:00:00',6.13),('6449','2013-01-22','11:05:00',8.09),('6449','2013-01-22','11:10:00',12.35),('6449','2013-01-22','11:15:00',6.75),('6449','2013-01-22','11:20:00',6.01),('6449','2013-01-22','11:25:00',7.58),('6449','2013-01-22','11:30:00',7.71),('6449','2013-01-22','11:35:00',7.98),('6449','2013-01-22','11:40:00',5.67),('6449','2013-01-22','11:45:00',6.71),('6449','2013-01-22','11:50:00',7.2),('6449','2013-01-22','11:55:00',5.68),('6449','2013-01-22','12:00:00',7.89),('6449','2013-01-22','12:05:00',12.58),('6449','2013-01-22','12:10:00',10.93),('6449','2013-01-22','12:15:00',12.72),('6449','2013-01-22','12:20:00',13.6),('6449','2013-01-22','12:25:00',11.4),('6449','2013-01-22','12:30:00',11.46),('6449','2013-01-22','12:35:00',10.19),('6449','2013-01-22','12:40:00',13.23),('6449','2013-01-22','12:45:00',11.26),('6449','2013-01-22','12:50:00',8.03),('6449','2013-01-22','12:55:00',13.61),('6449','2013-01-22','13:00:00',12.98),('6449','2013-01-22','13:05:00',12.9),('6449','2013-01-22','13:10:00',12.59),('6449','2013-01-22','13:15:00',12.38),('6449','2013-01-22','13:20:00',12.51),('6449','2013-01-22','13:25:00',5.66),('6449','2013-01-22','13:30:00',6.29),('6449','2013-01-22','13:35:00',14.33),('6449','2013-01-22','13:40:00',9.98),('6449','2013-01-22','13:45:00',10.71),('6449','2013-01-22','13:50:00',9.24),('6449','2013-01-22','13:55:00',9.01),('6449','2013-01-22','14:00:00',3.32),('6449','2013-01-22','14:05:00',10.22),('6449','2013-01-22','14:10:00',9.32),('6449','2013-01-22','14:15:00',4.25),('6449','2013-01-22','14:20:00',4.58),('6449','2013-01-22','14:25:00',12.24),('6449','2013-01-22','14:30:00',8.41),('6449','2013-01-22','14:35:00',2.52),('6449','2013-01-22','14:40:00',1.49),('6449','2013-01-22','14:45:00',2.66),('6449','2013-01-22','14:55:00',1.42),('6449','2013-01-22','15:00:00',2.17),('6449','2013-01-22','15:05:00',1.1),('6449','2013-01-21','09:25:00',1.05),('6449','2013-01-21','09:30:00',1.54),('6449','2013-01-21','09:35:00',2.36),('6449','2013-01-21','09:40:00',2.31),('6449','2013-01-21','09:45:00',1.49),('6449','2013-01-21','09:50:00',1.44),('6449','2013-01-21','09:55:00',1.64),('6449','2013-01-21','10:00:00',2.38),('6449','2013-01-21','10:05:00',2.85),('6449','2013-01-21','10:10:00',2.67),('6449','2013-01-21','10:15:00',2.93),('6449','2013-01-21','10:20:00',3.58),('6449','2013-01-21','10:25:00',4.14),('6449','2013-01-21','10:30:00',3.75),('6449','2013-01-21','10:35:00',2.36),('6449','2013-01-21','10:40:00',2.04),('6449','2013-01-21','10:45:00',1.97),('6449','2013-01-21','10:50:00',2.54),('6449','2013-01-21','10:55:00',2.35),('6449','2013-01-21','11:00:00',2.69),('6449','2013-01-21','11:05:00',3.2),('6449','2013-01-21','11:10:00',3.66),('6449','2013-01-21','11:15:00',2.73),('6449','2013-01-21','11:20:00',7.78),('6449','2013-01-21','11:25:00',12.16),('6449','2013-01-21','11:30:00',11.81),('6449','2013-01-21','11:35:00',11.79),('6449','2013-01-21','11:40:00',11.45),('6449','2013-01-21','11:45:00',10.33),('6449','2013-01-21','11:50:00',12.11),('6449','2013-01-21','11:55:00',7.88),('6449','2013-01-21','12:00:00',9.91),('6449','2013-01-21','12:05:00',4.55),('6449','2013-01-21','12:10:00',3.76),('6449','2013-01-21','12:15:00',5.96),('6449','2013-01-21','12:20:00',5.2),('6449','2013-01-21','12:25:00',5.21),('6449','2013-01-21','12:30:00',3.71),('6449','2013-01-21','12:35:00',2.93),('6449','2013-01-21','12:40:00',2.35),('6449','2013-01-21','12:45:00',2.33),('6449','2013-01-21','12:50:00',3.28),('6449','2013-01-21','12:55:00',4.02),('6449','2013-01-21','13:00:00',6.04),('6449','2013-01-21','13:05:00',5.95),('6449','2013-01-21','13:10:00',14.3),('6449','2013-01-21','13:15:00',12.44),('6449','2013-01-21','13:20:00',12.05),('6449','2013-01-21','13:25:00',11.91),('6449','2013-01-21','13:30:00',9.74),('6449','2013-01-21','13:35:00',11.74),('6449','2013-01-21','13:40:00',11.62),('6449','2013-01-21','13:45:00',9.62),('6449','2013-01-21','13:50:00',11.34),('6449','2013-01-21','13:55:00',10.42),('6449','2013-01-21','14:00:00',8.05),('6449','2013-01-21','14:05:00',10.5),('6449','2013-01-21','14:10:00',7.92),('6449','2013-01-21','14:15:00',1.66),('6449','2013-01-21','14:20:00',2.82),('6449','2013-01-21','14:25:00',2.81),('6449','2013-01-21','14:30:00',1.93),('6449','2013-01-21','14:35:00',1.37),('6449','2013-01-21','14:40:00',1.91),('6449','2013-01-21','14:45:00',2.61),('6449','2013-01-21','14:50:00',2.08),('6449','2013-01-21','14:55:00',2.07),('6449','2013-01-21','15:00:00',2.87),('6449','2013-01-21','15:05:00',9.07),('6449','2013-01-21','15:10:00',7.96),('6449','2013-01-21','15:15:00',4.75),('6449','2013-01-21','15:20:00',2.63),('6449','2013-01-21','15:26:00',1.74),('6449','2013-01-21','15:30:00',1.38),('6449','2013-01-21','15:35:00',1.26),('6449','2013-01-21','15:40:00',1.04),('6449','2013-01-20','09:45:00',1.04),('6449','2013-01-20','10:05:00',1.18),('6449','2013-01-20','10:10:00',1.28),('6449','2013-01-20','10:15:00',1.36),('6449','2013-01-20','10:20:00',1.65),('6449','2013-01-20','10:25:00',1.73),('6449','2013-01-20','10:30:00',1.96),('6449','2013-01-20','10:35:00',2.26),('6449','2013-01-20','10:40:00',2.62),('6449','2013-01-20','10:45:00',2.29),('6449','2013-01-20','10:50:00',2.41),('6449','2013-01-20','10:55:00',2.04),('6449','2013-01-20','11:00:00',2.12),('6449','2013-01-20','11:05:00',2.46),('6449','2013-01-20','11:10:00',2.31),('6449','2013-01-20','11:15:00',2.24),('6449','2013-01-20','11:20:00',2.47),('6449','2013-01-20','11:25:00',2.77),('6449','2013-01-20','11:30:00',2.28),('6449','2013-01-20','11:35:00',2.13),('6449','2013-01-20','11:40:00',2.16),('6449','2013-01-20','11:45:00',2.13),('6449','2013-01-20','11:50:00',2.03),('6449','2013-01-20','11:55:00',2.04),('6449','2013-01-20','12:00:00',1.92),('6449','2013-01-20','12:05:00',1.62),('6449','2013-01-20','12:10:00',1.76),('6449','2013-01-20','12:15:00',2.1),('6449','2013-01-20','12:20:00',2.02),('6449','2013-01-20','12:25:00',2.11),('6449','2013-01-20','12:30:00',2.06),('6449','2013-01-20','12:35:00',2.02),('6449','2013-01-20','12:40:00',2.2),('6449','2013-01-20','12:45:00',2.29),('6449','2013-01-20','12:50:00',2.15),('6449','2013-01-20','12:55:00',1.96),('6449','2013-01-20','13:00:00',1.63),('6449','2013-01-20','13:05:00',1.46),('6449','2013-01-20','13:10:00',1.75),('6449','2013-01-20','13:15:00',1.79),('6449','2013-01-20','13:20:00',2),('6449','2013-01-20','13:25:00',2.48),('6449','2013-01-20','13:30:00',2.44),('6449','2013-01-20','13:35:00',2.18),('6449','2013-01-20','13:40:00',2.13),('6449','2013-01-20','13:45:00',2.08),('6449','2013-01-20','13:50:00',1.87),('6449','2013-01-20','13:55:00',1.73),('6449','2013-01-20','14:00:00',1.35),('6449','2013-01-20','14:05:00',1.15),('6449','2013-01-20','14:10:00',1.17),('6449','2013-01-20','14:15:00',1.38),('6449','2013-01-20','14:20:00',1.22),('6449','2013-01-19','08:30:00',1.15),('6449','2013-01-19','08:35:00',1.27),('6449','2013-01-19','08:40:00',1.36),('6449','2013-01-19','08:45:00',1.64),('6449','2013-01-19','08:50:00',2.12),('6449','2013-01-19','08:55:00',2.66),('6449','2013-01-19','09:00:00',2.85),('6449','2013-01-19','09:05:00',1.91),('6449','2013-01-19','09:10:00',1.55),('6449','2013-01-19','09:15:00',1.38),('6449','2013-01-19','09:20:00',1.42),('6449','2013-01-19','09:25:00',1.86),('6449','2013-01-19','09:30:00',2.82),('6449','2013-01-19','09:35:00',3.79),('6449','2013-01-19','09:40:00',4.26),('6449','2013-01-19','09:45:00',3.61),('6449','2013-01-19','09:50:00',2.35),('6449','2013-01-19','09:55:00',1.61),('6449','2013-01-19','10:00:00',1.18),('6449','2013-01-19','10:05:00',1.24),('6449','2013-01-19','10:10:00',1.4),('6449','2013-01-19','10:15:00',2.25),('6449','2013-01-19','10:20:00',2.41),('6449','2013-01-19','10:25:00',1.99),('6449','2013-01-19','10:30:00',1.51),('6449','2013-01-19','10:35:00',1.27),('6449','2013-01-19','10:40:00',1.53),('6449','2013-01-19','10:45:00',1.64),('6449','2013-01-19','10:50:00',1.87),('6449','2013-01-19','10:55:00',2.56),('6449','2013-01-19','11:00:00',2.96),('6449','2013-01-19','11:05:00',2.93),('6449','2013-01-19','11:10:00',2.54),('6449','2013-01-19','11:15:00',1.88),('6449','2013-01-19','11:20:00',1.7),('6449','2013-01-19','11:25:00',1.67),('6449','2013-01-19','11:30:00',1.63),('6449','2013-01-19','11:35:00',2.57),('6449','2013-01-19','11:40:00',2.91),('6449','2013-01-19','11:45:00',2.87),('6449','2013-01-19','11:50:00',2.3),('6449','2013-01-19','11:55:00',2.12),('6449','2013-01-19','12:00:00',2.04),('6449','2013-01-19','12:05:00',1.49),('6449','2013-01-19','12:10:00',1.76),('6449','2013-01-19','12:15:00',1.45),('6449','2013-01-19','12:20:00',1.4),('6449','2013-01-19','12:25:00',1.58),('6449','2013-01-19','12:30:00',1.58),('6449','2013-01-19','12:35:00',1.3),('6449','2013-01-19','12:40:00',1.46),('6449','2013-01-19','12:45:00',1.33),('6449','2013-01-19','12:50:00',1.21),('6449','2013-01-19','12:55:00',1.41),('6449','2013-01-19','13:00:00',1.34),('6449','2013-01-19','13:05:00',1.06),('6449','2013-01-19','13:55:00',1.02),('6449','2013-01-19','14:00:00',1.47),('6449','2013-01-19','14:05:00',1.97),('6449','2013-01-19','14:10:00',1.96),('6449','2013-01-19','14:15:00',1.42),('6449','2013-01-19','14:20:00',1.37),('6449','2013-01-19','14:25:00',1.37),('6449','2013-01-19','14:30:00',1.26),('6449','2013-01-19','14:35:00',1.42),('6449','2013-01-19','14:40:00',1.6),('6449','2013-01-19','14:45:00',1.74),('6449','2013-01-19','14:50:00',2.22),('6449','2013-01-19','14:55:00',1.78),('6449','2013-01-19','15:00:00',1.07),('6449','2013-01-18','09:30:00',1.21),('6449','2013-01-18','09:35:00',1.51),('6449','2013-01-18','09:40:00',1.92),('6449','2013-01-18','09:45:00',2.15),('6449','2013-01-18','09:50:00',2.15),('6449','2013-01-18','09:55:00',2.53),('6449','2013-01-18','10:00:00',3.69),('6449','2013-01-18','10:05:00',5.76),('6449','2013-01-18','10:10:00',3.62),('6449','2013-01-18','10:15:00',2.35),('6449','2013-01-18','10:20:00',1.8),('6449','2013-01-18','10:25:00',1.62),('6449','2013-01-18','10:30:00',1.75),('6449','2013-01-18','10:35:00',2.17),('6449','2013-01-18','10:40:00',2.54),('6449','2013-01-18','10:45:00',2.78),('6449','2013-01-18','10:50:00',3.22),('6449','2013-01-18','10:55:00',3.54),('6449','2013-01-18','11:00:00',4.5),('6449','2013-01-18','11:05:00',5.37),('6449','2013-01-18','11:10:00',4.91),('6449','2013-01-18','11:15:00',5.04),('6449','2013-01-18','11:20:00',4.23),('6449','2013-01-18','11:25:00',4.23),('6449','2013-01-18','11:30:00',4.59),('6449','2013-01-18','11:35:00',5.13),('6449','2013-01-18','11:40:00',4.7),('6449','2013-01-18','11:45:00',4.9),('6449','2013-01-18','11:50:00',5.79),('6449','2013-01-18','11:55:00',6.72),('6449','2013-01-18','12:00:00',7.04),('6449','2013-01-18','12:05:00',7.55),('6449','2013-01-18','12:10:00',8.57),('6449','2013-01-18','12:15:00',7.68),('6449','2013-01-18','12:20:00',5.18),('6449','2013-01-18','12:25:00',5),('6449','2013-01-18','12:30:00',5.33),('6449','2013-01-18','12:35:00',5.91),('6449','2013-01-18','12:40:00',5.65),('6449','2013-01-18','12:45:00',5.45),('6449','2013-01-18','12:50:00',10.97),('6449','2013-01-18','12:55:00',8.93),('6449','2013-01-18','13:00:00',6.22),('6449','2013-01-18','13:05:00',7.09),('6449','2013-01-18','13:10:00',7.16),('6449','2013-01-18','13:15:00',6.63),('6449','2013-01-18','13:20:00',5.93),('6449','2013-01-18','13:25:00',4.17),('6449','2013-01-18','13:30:00',8.73),('6449','2013-01-18','13:35:00',11.35),('6449','2013-01-18','13:40:00',11.17),('6449','2013-01-18','13:45:00',10.84),('6449','2013-01-18','13:50:00',10.22),('6449','2013-01-18','13:55:00',9.92),('6449','2013-01-18','14:00:00',9.92),('6449','2013-01-18','14:05:00',9.95),('6449','2013-01-18','14:10:00',10.33),('6449','2013-01-18','14:15:00',10.79),('6449','2013-01-18','14:20:00',10.67),('6449','2013-01-18','14:25:00',10.7),('6449','2013-01-18','14:30:00',9.79),('6449','2013-01-18','14:35:00',7.01),('6449','2013-01-18','14:40:00',4.96),('6449','2013-01-18','14:45:00',5.96),('6449','2013-01-18','14:50:00',5.15),('6449','2013-01-18','14:55:00',3.24),('6449','2013-01-18','15:00:00',3.7),('6449','2013-01-18','15:05:00',7.39),('6449','2013-01-18','15:10:00',7.99),('6449','2013-01-18','15:15:00',6.6),('6449','2013-01-18','15:20:00',6.11),('6449','2013-01-18','15:25:00',5.4),('6449','2013-01-18','15:30:00',5.48),('6449','2013-01-18','15:35:00',4.92),('6449','2013-01-18','15:40:00',4.58),('6449','2013-01-18','15:45:00',3.95),('6449','2013-01-18','15:50:00',3.49),('6449','2013-01-18','15:55:00',3.13),('6449','2013-01-18','16:00:00',2.83),('6449','2013-01-18','16:05:00',2.47),('6449','2013-01-18','16:10:00',2.23),('6449','2013-01-18','16:15:00',1.96),('6449','2013-01-18','16:20:00',1.75),('6449','2013-01-18','16:25:00',1.56),('6449','2013-01-18','16:30:00',1.41),('6449','2013-01-18','16:35:00',1.11),('6449','2013-01-17','08:40:00',1.02),('6449','2013-01-17','08:45:00',1.14),('6449','2013-01-17','08:50:00',1.17),('6449','2013-01-17','08:55:00',1.24),('6449','2013-01-17','09:00:00',1.32),('6449','2013-01-17','09:05:00',1.44),('6449','2013-01-17','09:10:00',1.67),('6449','2013-01-17','09:15:00',2.06),('6449','2013-01-17','09:20:00',2.86),('6449','2013-01-17','09:25:00',3.39),('6449','2013-01-17','09:30:00',3.49),('6449','2013-01-17','09:35:00',3.6),('6449','2013-01-17','09:40:00',3.96),('6449','2013-01-17','09:45:00',4.55),('6449','2013-01-17','09:50:00',4.18),('6449','2013-01-17','09:55:00',3.73),('6449','2013-01-17','10:00:00',3.6),('6449','2013-01-17','10:05:00',4.1),('6449','2013-01-17','10:10:00',4.57),('6449','2013-01-17','10:15:00',5.04),('6449','2013-01-17','10:20:00',5.29),('6449','2013-01-17','10:25:00',4.9),('6449','2013-01-17','10:30:00',5.77),('6449','2013-01-17','10:35:00',5.99),('6449','2013-01-17','10:40:00',6.13),('6449','2013-01-17','10:45:00',6.1),('6449','2013-01-17','10:50:00',6.1),('6449','2013-01-17','10:55:00',8.57),('6449','2013-01-17','11:00:00',10.01),('6449','2013-01-17','11:05:00',9.08),('6449','2013-01-17','11:10:00',8.29),('6449','2013-01-17','11:15:00',9.89),('6449','2013-01-17','11:20:00',10.19),('6449','2013-01-17','11:25:00',9.61),('6449','2013-01-17','11:30:00',10.8),('6449','2013-01-17','11:35:00',10.16),('6449','2013-01-17','11:40:00',9.62),('6449','2013-01-17','11:45:00',10.44),('6449','2013-01-17','11:50:00',8.7),('6449','2013-01-17','11:55:00',8.09),('6449','2013-01-17','12:00:00',9.42),('6449','2013-01-17','12:05:00',8.86),('6449','2013-01-17','12:10:00',7.03),('6449','2013-01-17','12:15:00',8.31),('6449','2013-01-17','12:20:00',9.33),('6449','2013-01-17','12:25:00',8.76),('6449','2013-01-17','12:30:00',10.14),('6449','2013-01-17','12:35:00',9.17),('6449','2013-01-17','12:40:00',3.93),('6449','2013-01-17','12:45:00',5.83),('6449','2013-01-17','12:50:00',7.16),('6449','2013-01-17','12:55:00',8.97),('6449','2013-01-17','13:00:00',8.22),('6449','2013-01-17','13:05:00',8.22),('6449','2013-01-17','13:10:00',3.84),('6449','2013-01-17','13:15:00',4.7),('6449','2013-01-17','13:20:00',9.64),('6449','2013-01-17','13:25:00',3.39),('6449','2013-01-17','13:30:00',3.71),('6449','2013-01-17','13:35:00',5.51),('6449','2013-01-17','13:40:00',9.66),('6449','2013-01-17','13:45:00',6.17),('6449','2013-01-17','13:50:00',9.18),('6449','2013-01-17','13:55:00',10.94),('6449','2013-01-17','14:00:00',7.97),('6449','2013-01-17','14:05:00',5.77),('6449','2013-01-17','14:10:00',7.47),('6449','2013-01-17','14:15:00',8.19),('6449','2013-01-17','14:20:00',6.03),('6449','2013-01-17','14:25:00',3.3),('6449','2013-01-17','14:30:00',2.96),('6449','2013-01-17','14:35:00',2.95),('6449','2013-01-17','14:40:00',2.64),('6449','2013-01-17','14:45:00',2.91),('6449','2013-01-17','14:50:00',3.17),('6449','2013-01-17','14:55:00',2.92),('6449','2013-01-17','15:00:00',2.4),('6449','2013-01-17','15:05:00',2.43),('6449','2013-01-17','15:10:00',2.2),('6449','2013-01-17','15:15:00',2.05),('6449','2013-01-17','15:20:00',1.71),('6449','2013-01-17','15:25:00',1.41),('6449','2013-01-17','15:30:00',1.25),('6449','2013-01-17','15:35:00',1.17),('6449','2013-01-17','15:40:00',1.03),('6449','2013-01-17','15:50:00',1),('6449','2013-01-16','08:30:00',1.16),('6449','2013-01-16','08:35:00',1.22),('6449','2013-01-16','08:40:00',1.35),('6449','2013-01-16','08:45:00',2.02),('6449','2013-01-16','08:50:00',1.83),('6449','2013-01-16','08:55:00',1.19),('6449','2013-01-16','09:00:00',1.78),('6449','2013-01-16','09:05:00',1.57),('6449','2013-01-16','09:15:00',1.51),('6449','2013-01-16','09:20:00',1.98),('6449','2013-01-16','09:25:00',1.31),('6449','2013-01-16','09:30:00',1.03),('6449','2013-01-16','09:45:00',1.68),('6449','2013-01-16','09:50:00',7.13),('6449','2013-01-16','09:55:00',5.04),('6449','2013-01-16','10:00:00',1.41),('6449','2013-01-16','10:05:00',1.91),('6449','2013-01-16','10:10:00',10.67),('6449','2013-01-16','10:15:00',11.33),('6449','2013-01-16','10:20:00',8.26),('6449','2013-01-16','10:25:00',5.92),('6449','2013-01-16','10:30:00',10.8),('6449','2013-01-16','10:35:00',9.25),('6449','2013-01-16','10:40:00',1.47),('6449','2013-01-16','10:45:00',1.16),('6449','2013-01-16','10:50:00',1.8),('6449','2013-01-16','10:55:00',2.61),('6449','2013-01-16','11:00:00',3.22),('6449','2013-01-16','11:05:00',6.63),('6449','2013-01-16','11:10:00',3.03),('6449','2013-01-16','11:15:00',3.12),('6449','2013-01-16','11:20:00',3.02),('6449','2013-01-16','11:25:00',2.84),('6449','2013-01-16','11:30:00',2.43),('6449','2013-01-16','11:35:00',2.52),('6449','2013-01-16','11:40:00',3.71),('6449','2013-01-16','11:45:00',3.23),('6449','2013-01-16','11:50:00',3.35),('6449','2013-01-16','11:55:00',7.42),('6449','2013-01-16','12:00:00',1.1),('6449','2013-01-16','12:10:00',1.48),('6449','2013-01-16','12:15:00',2.12),('6449','2013-01-16','12:20:00',1.63),('6449','2013-01-16','12:25:00',1.48),('6449','2013-01-16','12:55:00',1.41),('6449','2013-01-16','13:00:00',2.44),('6449','2013-01-16','13:05:00',1.45),('6449','2013-01-16','13:10:00',1.07),('6449','2013-01-16','13:30:00',1.37),('6449','2013-01-16','13:35:00',2),('6449','2013-01-16','13:40:00',1.72),('6449','2013-01-16','13:45:00',2.23),('6449','2013-01-16','13:50:00',2.2),('6449','2013-01-16','14:05:00',1.49),('6449','2013-01-16','14:10:00',6.43),('6449','2013-01-16','14:15:00',4.91),('6449','2013-01-16','14:20:00',2.6),('6449','2013-01-16','14:25:00',3.04),('6449','2013-01-16','14:30:00',3.81),('6449','2013-01-16','14:35:00',10),('6449','2013-01-16','14:40:00',5.11),('6449','2013-01-16','14:45:00',1.88),('6449','2013-01-16','14:50:00',1.26),('6449','2013-01-16','15:15:00',1.14),('6449','2013-01-16','15:20:00',4.12),('6449','2013-01-16','15:25:00',6.62),('6449','2013-01-16','15:30:00',5.6),('6449','2013-01-16','15:35:00',4.09),('6449','2013-01-16','15:40:00',4.38),('6449','2013-01-16','15:45:00',4.15),('6449','2013-01-16','15:50:00',3.64),('6449','2013-01-16','15:55:00',3.26),('6449','2013-01-16','16:00:00',1.23),('6449','2013-01-15','08:25:00',1.84),('6449','2013-01-15','08:30:00',1.03),('6449','2013-01-15','08:35:00',3.84),('6449','2013-01-15','08:40:00',4.2),('6449','2013-01-15','08:45:00',4.73),('6449','2013-01-15','08:50:00',5.07),('6449','2013-01-15','08:55:00',5.1),('6449','2013-01-15','09:00:00',5.33),('6449','2013-01-15','09:05:00',5.71),('6449','2013-01-15','09:10:00',5.96),('6449','2013-01-15','09:15:00',6.29),('6449','2013-01-15','09:20:00',6.59),('6449','2013-01-15','09:25:00',6.86),('6449','2013-01-15','09:30:00',7.22),('6449','2013-01-15','09:35:00',7.55),('6449','2013-01-15','09:40:00',7.86),('6449','2013-01-15','09:45:00',4.76),('6449','2013-01-15','09:50:00',2.49),('6449','2013-01-15','09:55:00',2.01),('6449','2013-01-15','10:00:00',6.21),('6449','2013-01-15','10:05:00',3.17),('6449','2013-01-15','10:10:00',1.14),('6449','2013-01-15','10:15:00',1.87),('6449','2013-01-15','10:20:00',4.05),('6449','2013-01-15','10:25:00',3.34),('6449','2013-01-15','10:30:00',3.12),('6449','2013-01-15','10:35:00',7.95),('6449','2013-01-15','10:40:00',8.87),('6449','2013-01-15','10:45:00',3.5),('6449','2013-01-15','10:50:00',3.98),('6449','2013-01-15','10:55:00',5.35),('6449','2013-01-15','11:00:00',4.62),('6449','2013-01-15','11:05:00',4.95),('6449','2013-01-15','11:10:00',6.02),('6449','2013-01-15','11:15:00',6.67),('6449','2013-01-15','11:20:00',6.62),('6449','2013-01-15','11:25:00',7.26),('6449','2013-01-15','11:30:00',7.1),('6449','2013-01-15','11:35:00',7.65),('6449','2013-01-15','11:40:00',8.41),('6449','2013-01-15','11:45:00',10.04),('6449','2013-01-15','11:50:00',8.7),('6449','2013-01-15','11:55:00',7.34),('6449','2013-01-15','12:00:00',5.51),('6449','2013-01-15','12:05:00',5.39),('6449','2013-01-15','12:10:00',5.83),('6449','2013-01-15','12:15:00',5.6),('6449','2013-01-15','12:20:00',5.51),('6449','2013-01-15','12:25:00',5.43),('6449','2013-01-15','12:30:00',5.64),('6449','2013-01-15','12:35:00',5.71),('6449','2013-01-15','12:40:00',6.06),('6449','2013-01-15','12:45:00',6.14),('6449','2013-01-15','12:50:00',6.31),('6449','2013-01-15','12:55:00',5.92),('6449','2013-01-15','13:00:00',6.8),('6449','2013-01-15','13:05:00',6.47),('6449','2013-01-15','13:10:00',7.04),('6449','2013-01-15','13:15:00',6.99),('6449','2013-01-15','13:20:00',6.32),('6449','2013-01-15','13:25:00',6.78),('6449','2013-01-15','13:30:00',7.44),('6449','2013-01-15','13:35:00',10.13),('6449','2013-01-15','13:40:00',8.69),('6449','2013-01-15','13:45:00',9.16),('6449','2013-01-15','13:50:00',7.97),('6449','2013-01-15','13:55:00',6.92),('6449','2013-01-15','14:00:00',6.87),('6449','2013-01-15','14:05:00',4.98),('6449','2013-01-15','14:10:00',4.92),('6449','2013-01-15','14:15:00',6.72),('6449','2013-01-15','14:20:00',9.4),('6449','2013-01-15','14:25:00',5.7),('6449','2013-01-15','14:30:00',5.19),('6449','2013-01-15','14:35:00',8.3),('6449','2013-01-15','14:40:00',7.63),('6449','2013-01-15','14:45:00',6.86),('6449','2013-01-15','14:50:00',7.19),('6449','2013-01-15','14:55:00',6.94),('6449','2013-01-15','15:00:00',6.49),('6449','2013-01-15','15:05:00',6.17),('6449','2013-01-15','15:10:00',6.01),('6449','2013-01-15','15:15:00',5.77),('6449','2013-01-15','15:20:00',5.38),('6449','2013-01-15','15:25:00',5.09),('6449','2013-01-15','15:30:00',4.89),('6449','2013-01-15','15:35:00',4.68),('6449','2013-01-15','15:40:00',4.31),('6449','2013-01-15','15:45:00',4.07),('6449','2013-01-15','15:50:00',3.86),('6449','2013-01-15','15:55:00',3.63),('6449','2013-01-15','16:00:00',3.44),('6449','2013-01-15','16:05:00',3.19),('6449','2013-01-15','16:10:00',2.89),('6449','2013-01-15','16:15:00',2.56),('6449','2013-01-15','16:20:00',2.23),('6449','2013-01-15','16:25:00',1.89),('6449','2013-01-15','16:30:00',1.45),('6449','2013-01-14','10:00:00',1.11),('6449','2013-01-14','10:05:00',1.79),('6449','2013-01-14','10:10:00',1.25),('6449','2013-01-14','10:15:00',1.1),('6449','2013-01-14','10:20:00',1.23),('6449','2013-01-14','10:25:00',1.62),('6449','2013-01-14','10:30:00',1.62),('6449','2013-01-14','10:35:00',1.34),('6449','2013-01-14','10:40:00',1.41),('6449','2013-01-14','10:45:00',1.19),('6449','2013-01-14','10:50:00',1.62),('6449','2013-01-14','10:55:00',1.76),('6449','2013-01-14','11:00:00',2.04),('6449','2013-01-14','11:05:00',1.84),('6449','2013-01-14','11:10:00',1.48),('6449','2013-01-14','11:15:00',1.55),('6449','2013-01-14','11:20:00',1.73),('6449','2013-01-14','11:25:00',1.14),('6449','2013-01-14','12:00:00',1.32),('6449','2013-01-14','12:05:00',1.31),('6449','2013-01-14','12:10:00',1.31),('6449','2013-01-14','12:15:00',1.25),('6449','2013-01-14','12:20:00',1.11),('6449','2013-01-14','12:25:00',1.14),('6449','2013-01-14','12:50:00',1.04),('6449','2013-01-14','12:55:00',1.56),('6449','2013-01-14','13:00:00',1.53),('6449','2013-01-14','13:05:00',1.41),('6449','2013-01-14','13:10:00',1.52),('6449','2013-01-14','13:15:00',1.48),('6449','2013-01-14','13:20:00',1.21),('6449','2013-01-14','13:25:00',1.56),('6449','2013-01-14','13:30:00',1.6),('6449','2013-01-14','13:35:00',1.6),('6449','2013-01-14','13:40:00',1.49),('6449','2013-01-14','13:45:00',1.41),('6449','2013-01-14','13:50:00',1.09),('6449','2013-01-14','13:55:00',1.07),('6449','2013-01-14','14:00:00',1.65),('6449','2013-01-14','14:05:00',1.86),('6449','2013-01-14','14:10:00',1.09),('6449','2013-01-14','15:10:00',1.09),('6449','2013-01-13','08:35:00',1.21),('6449','2013-01-13','08:40:00',1.28),('6449','2013-01-13','08:45:00',1.27),('6449','2013-01-13','08:50:00',1.8),('6449','2013-01-13','08:55:00',2.12),('6449','2013-01-13','09:00:00',1.15),('6449','2013-01-13','09:20:00',1.09),('6449','2013-01-13','09:25:00',1.47),('6449','2013-01-13','09:30:00',1.52),('6449','2013-01-13','09:35:00',2.09),('6449','2013-01-13','09:40:00',2.95),('6449','2013-01-13','09:45:00',1.94),('6449','2013-01-13','09:50:00',3.09),('6449','2013-01-13','09:55:00',9.13),('6449','2013-01-13','10:00:00',5.45),('6449','2013-01-13','10:05:00',6.58),('6449','2013-01-13','10:10:00',7.68),('6449','2013-01-13','10:15:00',3.22),('6449','2013-01-13','10:20:00',1.15),('6449','2013-01-13','10:25:00',1.46),('6449','2013-01-13','10:30:00',1.4),('6449','2013-01-13','10:35:00',1.75),('6449','2013-01-13','10:40:00',1.88),('6449','2013-01-13','10:45:00',1.66),('6449','2013-01-13','10:50:00',1.46),('6449','2013-01-13','10:55:00',1.58),('6449','2013-01-13','11:00:00',1.56),('6449','2013-01-13','11:05:00',2.27),('6449','2013-01-13','11:10:00',3.17),('6449','2013-01-13','11:15:00',2.38),('6449','2013-01-13','11:20:00',1.24),('6449','2013-01-13','11:25:00',1.17),('6449','2013-01-13','11:30:00',1.32),('6449','2013-01-13','11:35:00',1.38),('6449','2013-01-13','11:50:00',1.42),('6449','2013-01-13','11:55:00',1.23),('6449','2013-01-13','12:00:00',1.28),('6449','2013-01-13','12:05:00',1.39),('6449','2013-01-13','12:25:00',1.07),('6449','2013-01-13','12:30:00',1.38),('6449','2013-01-13','12:35:00',1.45),('6449','2013-01-13','12:40:00',1.21),('6449','2013-01-13','14:55:00',1.03),('6449','2013-01-13','15:00:00',1.07),('6449','2013-01-13','15:05:00',1.35),('6449','2013-01-13','15:25:00',1.03),('6449','2013-01-13','15:30:00',1.06),('6449','2013-01-12','07:55:00',1.2),('6449','2013-01-12','08:00:00',1.56),('6449','2013-01-12','08:05:00',1.91),('6449','2013-01-12','08:10:00',2.25),('6449','2013-01-12','08:15:00',2.57),('6449','2013-01-12','08:20:00',2.89),('6449','2013-01-12','08:25:00',3.2),('6449','2013-01-12','08:30:00',3.53),('6449','2013-01-12','08:35:00',3.85),('6449','2013-01-12','08:40:00',4.16),('6449','2013-01-12','08:45:00',4.45),('6449','2013-01-12','08:50:00',4.72),('6449','2013-01-12','08:55:00',5.01),('6449','2013-01-12','09:00:00',5.29),('6449','2013-01-12','09:05:00',5.56),('6449','2013-01-12','09:10:00',5.73),('6449','2013-01-12','09:15:00',6.08),('6449','2013-01-12','09:20:00',6.39),('6449','2013-01-12','09:25:00',6.65),('6449','2013-01-12','09:30:00',7),('6449','2013-01-12','09:35:00',7.29),('6449','2013-01-12','09:40:00',7.5),('6449','2013-01-12','09:45:00',7.81),('6449','2013-01-12','09:50:00',8.08),('6449','2013-01-12','09:55:00',8.29),('6449','2013-01-12','10:00:00',8.48),('6449','2013-01-12','10:05:00',8.69),('6449','2013-01-12','10:10:00',8.89),('6449','2013-01-12','10:15:00',9.08),('6449','2013-01-12','10:20:00',9.32),('6449','2013-01-12','10:25:00',9.5),('6449','2013-01-12','10:30:00',9.73),('6449','2013-01-12','10:35:00',9.95),('6449','2013-01-12','10:40:00',10.11),('6449','2013-01-12','10:45:00',10.3),('6449','2013-01-12','10:50:00',10.48),('6449','2013-01-12','10:55:00',10.46),('6449','2013-01-12','11:00:00',10.75),('6449','2013-01-12','11:05:00',10.82),('6449','2013-01-12','11:10:00',10.85),('6449','2013-01-12','11:15:00',11.05),('6449','2013-01-12','11:20:00',11.15),('6449','2013-01-12','11:25:00',11.05),('6449','2013-01-12','11:30:00',11.26),('6449','2013-01-12','11:35:00',11.33),('6449','2013-01-12','11:40:00',11.32),('6449','2013-01-12','11:45:00',11.45),('6449','2013-01-12','11:50:00',11.49),('6449','2013-01-12','11:55:00',11.5),('6449','2013-01-12','12:00:00',11.57),('6449','2013-01-12','12:05:00',11.53),('6449','2013-01-12','12:10:00',11.52),('6449','2013-01-12','12:15:00',11.3),('6449','2013-01-12','12:20:00',11.39),('6449','2013-01-12','12:25:00',11.4),('6449','2013-01-12','12:30:00',11.17),('6449','2013-01-12','12:35:00',11),('6449','2013-01-12','12:40:00',10.82),('6449','2013-01-12','12:45:00',10.69),('6449','2013-01-12','12:50:00',10.52),('6449','2013-01-12','12:55:00',10.44),('6449','2013-01-12','13:00:00',10.74),('6449','2013-01-12','13:05:00',10.67),('6449','2013-01-12','13:10:00',10.55),('6449','2013-01-12','13:15:00',10.52),('6449','2013-01-12','13:20:00',10.45),('6449','2013-01-12','13:25:00',10.18),('6449','2013-01-12','13:30:00',10.08),('6449','2013-01-12','13:35:00',9.96),('6449','2013-01-12','13:40:00',9.8),('6449','2013-01-12','13:45:00',9.61),('6449','2013-01-12','13:50:00',9.37),('6449','2013-01-12','13:55:00',9.3),('6449','2013-01-12','14:00:00',9.12),('6449','2013-01-12','14:05:00',8.94),('6449','2013-01-12','14:10:00',8.75),('6449','2013-01-12','14:15:00',8.63),('6449','2013-01-12','14:20:00',8.37),('6449','2013-01-12','14:25:00',7.96),('6449','2013-01-12','14:30:00',7.77),('6449','2013-01-12','14:35:00',7.54),('6449','2013-01-12','14:40:00',7.27),('6449','2013-01-12','14:45:00',7.02),('6449','2013-01-12','14:50:00',6.67),('6449','2013-01-12','14:55:00',6.48),('6449','2013-01-12','15:00:00',6.04),('6449','2013-01-12','15:05:00',5.78),('6449','2013-01-12','15:10:00',5.56),('6449','2013-01-12','15:15:00',5.31),('6449','2013-01-12','15:20:00',4.9),('6449','2013-01-12','15:25:00',4.63),('6449','2013-01-12','15:30:00',4.24),('6449','2013-01-12','15:36:00',3.99),('6449','2013-01-12','15:40:00',3.51),('6449','2013-01-12','15:45:00',3.3),('6449','2013-01-12','15:50:00',2.84),('6449','2013-01-12','15:55:00',2.05),('6449','2013-01-12','16:00:00',1.45),('6449','2013-01-12','16:05:00',1.32),('6449','2013-01-11','08:40:00',1.06),('6449','2013-01-11','08:45:00',1.1),('6449','2013-01-11','08:50:00',1.13),('6449','2013-01-11','08:55:00',1.25),('6449','2013-01-11','09:00:00',1.31),('6449','2013-01-11','09:05:00',1.5),('6449','2013-01-11','09:10:00',1.66),('6449','2013-01-11','09:15:00',1.79),('6449','2013-01-11','09:20:00',4.61),('6449','2013-01-11','09:25:00',6.15),('6449','2013-01-11','09:30:00',6.1),('6449','2013-01-11','09:35:00',4.6),('6449','2013-01-11','09:40:00',1.65),('6449','2013-01-11','09:45:00',4.12),('6449','2013-01-11','09:50:00',6.92),('6449','2013-01-11','09:55:00',7.36),('6449','2013-01-11','10:00:00',7.12),('6449','2013-01-11','10:05:00',6.56),('6449','2013-01-11','10:10:00',5.19),('6449','2013-01-11','10:15:00',3.77),('6449','2013-01-11','10:20:00',4.44),('6449','2013-01-11','10:25:00',5.09),('6449','2013-01-11','10:30:00',5.59),('6449','2013-01-11','10:35:00',7.86),('6449','2013-01-11','10:40:00',8.62),('6449','2013-01-11','10:45:00',8.78),('6449','2013-01-11','10:50:00',9.17),('6449','2013-01-11','10:55:00',9.57),('6449','2013-01-11','11:00:00',9.89),('6449','2013-01-11','11:05:00',10.17),('6449','2013-01-11','11:10:00',9.97),('6449','2013-01-11','11:15:00',10.46),('6449','2013-01-11','11:20:00',7.89),('6449','2013-01-11','11:25:00',5.18),('6449','2013-01-11','11:30:00',3.91),('6449','2013-01-11','11:35:00',3.14),('6449','2013-01-11','11:40:00',2.96),('6449','2013-01-11','11:45:00',3.67),('6449','2013-01-11','11:50:00',3.55),('6449','2013-01-11','11:55:00',3.21),('6449','2013-01-11','12:00:00',1.99),('6449','2013-01-11','12:05:00',1.92),('6449','2013-01-11','12:10:00',1.69),('6449','2013-01-11','12:15:00',1.9),('6449','2013-01-11','12:20:00',2.81),('6449','2013-01-11','12:25:00',6.39),('6449','2013-01-11','12:30:00',3.39),('6449','2013-01-11','12:35:00',3.47),('6449','2013-01-11','12:40:00',3.15),('6449','2013-01-11','12:45:00',2.11),('6449','2013-01-11','12:50:00',1.36),('6449','2013-01-11','12:55:00',1.38),('6449','2013-01-11','13:05:00',1.52),('6449','2013-01-11','13:10:00',2.29),('6449','2013-01-11','13:15:00',8.89),('6449','2013-01-11','13:20:00',9.1),('6449','2013-01-11','13:25:00',9.11),('6449','2013-01-11','13:30:00',5.75),('6449','2013-01-11','13:35:00',3.34),('6449','2013-01-11','13:40:00',2.03),('6449','2013-01-11','14:00:00',1.45),('6449','2013-01-11','14:05:00',1.6),('6449','2013-01-11','14:10:00',2.81),('6449','2013-01-11','14:15:00',5.11),('6449','2013-01-11','14:20:00',9.41),('6449','2013-01-11','14:25:00',5.67),('6449','2013-01-11','14:30:00',5.94),('6449','2013-01-11','14:35:00',3.17),('6449','2013-01-11','14:40:00',3.03),('6449','2013-01-11','14:45:00',1.37),('6449','2013-01-11','14:50:00',3.18),('6449','2013-01-11','14:55:00',2.76),('6449','2013-01-11','15:00:00',4.49),('6449','2013-01-11','15:05:00',3.97),('6449','2013-01-11','15:20:00',1.12),('6449','2013-01-11','15:25:00',2.01),('6449','2013-01-11','15:30:00',4.11),('6449','2013-01-11','15:35:00',4.34),('6449','2013-01-11','15:40:00',1.35),('6449','2013-01-11','16:00:00',1.16),('6449','2013-01-10','10:00:00',1.04),('6449','2013-01-10','10:05:00',1.38),('6449','2013-01-10','10:10:00',1.41),('6449','2013-01-10','10:15:00',1.43),('6449','2013-01-10','10:20:00',1.91),('6449','2013-01-10','10:25:00',1.84),('6449','2013-01-10','10:30:00',1.96),('6449','2013-01-10','10:35:00',1.89),('6449','2013-01-10','10:40:00',2),('6449','2013-01-10','10:45:00',2.05),('6449','2013-01-10','10:50:00',2.15),('6449','2013-01-10','10:55:00',2.06),('6449','2013-01-10','11:00:00',2.25),('6449','2013-01-10','11:05:00',2.42),('6449','2013-01-10','11:10:00',2.3),('6449','2013-01-10','11:15:00',1.7),('6449','2013-01-10','11:20:00',1.47),('6449','2013-01-10','11:25:00',1.42),('6449','2013-01-10','11:30:00',1.28),('6449','2013-01-10','11:35:00',1.59),('6449','2013-01-10','11:40:00',1.71),('6449','2013-01-10','11:45:00',2.02),('6449','2013-01-10','11:50:00',2.22),('6449','2013-01-10','11:55:00',2.5),('6449','2013-01-10','12:00:00',2.61),('6449','2013-01-10','12:05:00',2.94),('6449','2013-01-10','12:10:00',2.99),('6449','2013-01-10','12:15:00',2.37),('6449','2013-01-10','12:20:00',2.21),('6449','2013-01-10','12:25:00',2.15),('6449','2013-01-10','12:30:00',1.91),('6449','2013-01-10','12:35:00',1.66),('6449','2013-01-10','12:40:00',1.3),('6449','2013-01-10','12:45:00',1.62),('6449','2013-01-10','12:50:00',2.13),('6449','2013-01-10','12:55:00',2.46),('6449','2013-01-10','13:00:00',1.82),('6449','2013-01-10','13:05:00',1.64),('6449','2013-01-10','13:10:00',1.7),('6449','2013-01-10','13:15:00',2.59),('6449','2013-01-10','13:20:00',3.01),('6449','2013-01-10','13:25:00',2.46),('6449','2013-01-10','13:30:00',2.12),('6449','2013-01-10','13:35:00',2.52),('6449','2013-01-10','13:40:00',2.26),('6449','2013-01-10','13:45:00',1.86),('6449','2013-01-10','13:50:00',1.45),('6449','2013-01-10','13:55:00',1.57),('6449','2013-01-10','14:00:00',1.69),('6449','2013-01-10','14:05:00',1.56),('6449','2013-01-10','14:10:00',1.36),('6449','2013-01-10','14:15:00',1.32),('6449','2013-01-10','14:20:00',1.97),('6449','2013-01-10','14:25:00',1.99),('6449','2013-01-10','14:30:00',1.66),('6449','2013-01-10','14:35:00',1.8),('6449','2013-01-10','14:40:00',1.64),('6449','2013-01-10','14:45:00',1.6),('6449','2013-01-10','14:50:00',1.06),('6449','2013-01-10','15:00:00',1.05),('6449','2013-01-10','15:05:00',1.22),('6449','2013-01-09','08:45:00',1.03),('6449','2013-01-09','08:50:00',1.18),('6449','2013-01-09','08:55:00',1.29),('6449','2013-01-09','09:00:00',1.51),('6449','2013-01-09','09:05:00',1.59),('6449','2013-01-09','09:10:00',1.75),('6449','2013-01-09','09:15:00',1.9),('6449','2013-01-09','09:20:00',2.1),('6449','2013-01-09','09:25:00',2.62),('6449','2013-01-09','09:30:00',2.79),('6449','2013-01-09','09:35:00',2.78),('6449','2013-01-09','09:40:00',2.8),('6449','2013-01-09','09:45:00',3.14),('6449','2013-01-09','09:50:00',6.41),('6449','2013-01-09','09:55:00',4.49),('6449','2013-01-09','10:00:00',3.64),('6449','2013-01-09','10:05:00',4.22),('6449','2013-01-09','10:10:00',3.1),('6449','2013-01-09','10:15:00',3.04),('6449','2013-01-09','10:20:00',3.64),('6449','2013-01-09','10:25:00',3.51),('6449','2013-01-09','10:30:00',3.77),('6449','2013-01-09','10:35:00',5.5),('6449','2013-01-09','10:40:00',8.02),('6449','2013-01-09','10:45:00',4.21),('6449','2013-01-09','10:50:00',3.26),('6449','2013-01-09','10:55:00',2.87),('6449','2013-01-09','11:00:00',3),('6449','2013-01-09','11:05:00',3.19),('6449','2013-01-09','11:10:00',3.48),('6449','2013-01-09','11:15:00',3.67),('6449','2013-01-09','11:20:00',3.38),('6449','2013-01-09','11:25:00',3.33),('6449','2013-01-09','11:30:00',4.12),('6449','2013-01-09','11:35:00',4.98),('6449','2013-01-09','11:40:00',5.68),('6449','2013-01-09','11:45:00',9.34),('6449','2013-01-09','11:50:00',9.9),('6449','2013-01-09','11:55:00',9.91),('6449','2013-01-09','12:00:00',6.7),('6449','2013-01-09','12:05:00',8.13),('6449','2013-01-09','12:10:00',8.24),('6449','2013-01-09','12:15:00',11.43),('6449','2013-01-09','12:20:00',8.76),('6449','2013-01-09','12:25:00',7.47),('6449','2013-01-09','12:30:00',6.61),('6449','2013-01-09','12:35:00',6.96),('6449','2013-01-09','12:40:00',6.98),('6449','2013-01-09','12:45:00',6.78),('6449','2013-01-09','12:50:00',6.1),('6449','2013-01-09','12:55:00',5.88),('6449','2013-01-09','13:00:00',8.11),('6449','2013-01-09','13:05:00',8.3),('6449','2013-01-09','13:10:00',6.29),('6449','2013-01-09','13:15:00',7.18),('6449','2013-01-09','13:20:00',7.79),('6449','2013-01-09','13:25:00',10.01),('6449','2013-01-09','13:30:00',6.95),('6449','2013-01-09','13:35:00',4.05),('6449','2013-01-09','13:40:00',3.34),('6449','2013-01-09','13:45:00',3.12),('6449','2013-01-09','13:50:00',3.09),('6449','2013-01-09','13:55:00',3.55),('6449','2013-01-09','14:00:00',8.25),('6449','2013-01-09','14:05:00',7.01),('6449','2013-01-09','14:10:00',5.35),('6449','2013-01-09','14:15:00',3.85),('6449','2013-01-09','14:20:00',3.28),('6449','2013-01-09','14:25:00',2.86),('6449','2013-01-09','14:30:00',3),('6449','2013-01-09','14:35:00',2.96),('6449','2013-01-09','14:40:00',3.16),('6449','2013-01-09','14:45:00',4.29),('6449','2013-01-09','14:50:00',3.68),('6449','2013-01-09','14:55:00',3.45),('6449','2013-01-09','15:00:00',2.98),('6449','2013-01-09','15:05:00',2.4),('6449','2013-01-09','15:10:00',2.3),('6449','2013-01-09','15:15:00',3.07),('6449','2013-01-09','15:20:00',2.98),('6449','2013-01-09','15:25:00',2.4),('6449','2013-01-09','15:30:00',1.92),('6449','2013-01-09','15:35:00',3.24),('6449','2013-01-09','15:40:00',3.35),('6449','2013-01-09','15:45:00',3.34),('6449','2013-01-09','15:50:00',3.03),('6449','2013-01-09','15:55:00',2.61),('6449','2013-01-09','16:00:00',2.23),('6449','2013-01-09','16:05:00',1.94),('6449','2013-01-09','16:10:00',1.62),('6449','2013-01-09','16:15:00',1.29),('6449','2013-01-08','08:00:00',1.12),('6449','2013-01-08','08:05:00',1.79),('6449','2013-01-08','08:10:00',2.01),('6449','2013-01-08','08:15:00',2.57),('6449','2013-01-08','08:20:00',2.92),('6449','2013-01-08','08:25:00',3.2),('6449','2013-01-08','08:30:00',2.13),('6449','2013-01-08','08:40:00',1.08),('6449','2013-01-08','08:45:00',1.39),('6449','2013-01-08','08:50:00',1.73),('6449','2013-01-08','08:55:00',1.93),('6449','2013-01-08','09:00:00',2.17),('6449','2013-01-08','09:05:00',2.52),('6449','2013-01-08','09:10:00',2.66),('6449','2013-01-08','09:15:00',2.47),('6449','2013-01-08','09:20:00',2.77),('6449','2013-01-08','09:25:00',2.77),('6449','2013-01-08','09:30:00',2.96),('6449','2013-01-08','09:35:00',2.84),('6449','2013-01-08','09:40:00',2.8),('6449','2013-01-08','09:45:00',2.63),('6449','2013-01-08','09:50:00',2.62),('6449','2013-01-08','09:55:00',3.11),('6449','2013-01-08','10:00:00',3.17),('6449','2013-01-08','10:05:00',2.99),('6449','2013-01-08','10:10:00',5.71),('6449','2013-01-08','10:15:00',7.75),('6449','2013-01-08','10:20:00',8.25),('6449','2013-01-08','10:25:00',8.04),('6449','2013-01-08','10:30:00',8.51),('6449','2013-01-08','10:35:00',8.75),('6449','2013-01-08','10:40:00',9.73),('6449','2013-01-08','10:45:00',9.97),('6449','2013-01-08','10:50:00',10.15),('6449','2013-01-08','10:55:00',10.36),('6449','2013-01-08','11:00:00',10.53),('6449','2013-01-08','11:05:00',10.67),('6449','2013-01-08','11:10:00',10.78),('6449','2013-01-08','11:15:00',10.91),('6449','2013-01-08','11:20:00',11.03),('6449','2013-01-08','11:25:00',10.95),('6449','2013-01-08','11:30:00',10.9),('6449','2013-01-08','11:35:00',10.84),('6449','2013-01-08','11:40:00',10.82),('6449','2013-01-08','11:45:00',10.98),('6449','2013-01-08','11:50:00',11.5),('6449','2013-01-08','11:55:00',13.2),('6449','2013-01-08','12:00:00',10.05),('6449','2013-01-08','12:05:00',8.5),('6449','2013-01-08','12:10:00',10.07),('6449','2013-01-08','12:15:00',6.58),('6449','2013-01-08','12:20:00',5.55),('6449','2013-01-08','12:25:00',5.25),('6449','2013-01-08','12:30:00',4.71),('6449','2013-01-08','12:35:00',5.67),('6449','2013-01-08','12:40:00',3.26),('6449','2013-01-08','12:45:00',3.23),('6449','2013-01-08','12:50:00',2.21),('6449','2013-01-08','12:55:00',1.93),('6449','2013-01-08','13:00:00',2.48),('6449','2013-01-08','13:05:00',2.7),('6449','2013-01-08','13:10:00',2.44),('6449','2013-01-08','13:15:00',3.06),('6449','2013-01-08','13:20:00',3.53),('6449','2013-01-08','13:25:00',3.13),('6449','2013-01-08','13:30:00',2.22),('6449','2013-01-08','13:35:00',2.02),('6449','2013-01-08','13:40:00',1.73),('6449','2013-01-08','13:45:00',1.67),('6449','2013-01-08','13:50:00',1.41),('6449','2013-01-08','13:55:00',1.38),('6449','2013-01-08','14:00:00',1.58),('6449','2013-01-08','14:05:00',2),('6449','2013-01-08','14:10:00',2.52),('6449','2013-01-08','14:15:00',3.51),('6449','2013-01-08','14:20:00',5.22),('6449','2013-01-08','14:25:00',6.07),('6449','2013-01-08','14:30:00',6.77),('6449','2013-01-08','14:35:00',5.29),('6449','2013-01-08','14:40:00',3.49),('6449','2013-01-08','14:45:00',3),('6449','2013-01-08','14:50:00',3.21),('6449','2013-01-08','14:55:00',3.62),('6449','2013-01-08','15:00:00',2.02),('6449','2013-01-08','15:05:00',1.78),('6449','2013-01-08','15:10:00',2.01),('6449','2013-01-08','15:15:00',4.23),('6449','2013-01-08','15:20:00',2.63),('6449','2013-01-08','15:25:00',2.46),('6449','2013-01-08','15:30:00',2.01),('6449','2013-01-07','08:00:00',1.07),('6449','2013-01-07','08:05:00',1.37),('6449','2013-01-07','08:10:00',1.68),('6449','2013-01-07','08:15:00',2.05),('6449','2013-01-07','08:20:00',2.37),('6449','2013-01-07','08:25:00',2.68),('6449','2013-01-07','08:30:00',3.01),('6449','2013-01-07','08:35:00',3.34),('6449','2013-01-07','08:40:00',3.61),('6449','2013-01-07','08:45:00',3.9),('6449','2013-01-07','08:50:00',4.21),('6449','2013-01-07','08:55:00',4.47),('6449','2013-01-07','09:00:00',4.81),('6449','2013-01-07','09:05:00',5.08),('6449','2013-01-07','09:10:00',5.35),('6449','2013-01-07','09:15:00',5.59),('6449','2013-01-07','09:20:00',5.88),('6449','2013-01-07','09:25:00',6.02),('6449','2013-01-07','09:30:00',6.38),('6449','2013-01-07','09:35:00',6.64),('6449','2013-01-07','09:40:00',6.95),('6449','2013-01-07','09:45:00',7.28),('6449','2013-01-07','09:50:00',7.5),('6449','2013-01-07','09:55:00',7.75),('6449','2013-01-07','10:00:00',8.07),('6449','2013-01-07','10:05:00',8.33),('6449','2013-01-07','10:10:00',8.59),('6449','2013-01-07','10:15:00',8.83),('6449','2013-01-07','10:20:00',9.11),('6449','2013-01-07','10:25:00',9.31),('6449','2013-01-07','10:30:00',9.49),('6449','2013-01-07','10:35:00',9.69),('6449','2013-01-07','10:40:00',9.66),('6449','2013-01-07','10:45:00',9.98),('6449','2013-01-07','10:50:00',10.1),('6449','2013-01-07','10:55:00',10.24),('6449','2013-01-07','11:00:00',10.33),('6449','2013-01-07','11:05:00',10.46),('6449','2013-01-07','11:10:00',10.45),('6449','2013-01-07','11:15:00',10.71),('6449','2013-01-07','11:20:00',10.77),('6449','2013-01-07','11:25:00',10.86),('6449','2013-01-07','11:30:00',10.87),('6449','2013-01-07','11:35:00',10.86),('6449','2013-01-07','11:40:00',10.68),('6449','2013-01-07','11:45:00',10.8),('6449','2013-01-07','11:50:00',10.73),('6449','2013-01-07','11:55:00',10.77),('6449','2013-01-07','12:00:00',10.7),('6449','2013-01-07','12:05:00',10.75),('6449','2013-01-07','12:10:00',10.76),('6449','2013-01-07','12:15:00',10.78),('6449','2013-01-07','12:20:00',10.79),('6449','2013-01-07','12:25:00',10.76),('6449','2013-01-07','12:30:00',10.59),('6449','2013-01-07','12:35:00',10.66),('6449','2013-01-07','12:40:00',10.73),('6449','2013-01-07','12:45:00',10.56),('6449','2013-01-07','12:50:00',10.5),('6449','2013-01-07','12:55:00',10.44),('6449','2013-01-07','13:00:00',10.27),('6449','2013-01-07','13:05:00',10.28),('6449','2013-01-07','13:10:00',10.03),('6449','2013-01-07','13:15:00',9.72),('6449','2013-01-07','13:20:00',9.72),('6449','2013-01-07','13:25:00',9.71),('6449','2013-01-07','13:30:00',9.38),('6449','2013-01-07','13:35:00',9.48),('6449','2013-01-07','13:40:00',9.49),('6449','2013-01-07','13:45:00',9.17),('6449','2013-01-07','13:50:00',8.92),('6449','2013-01-07','13:55:00',8.78),('6449','2013-01-07','14:00:00',8.59),('6449','2013-01-07','14:05:00',8.24),('6449','2013-01-07','14:10:00',8.06),('6449','2013-01-07','14:15:00',7.94),('6449','2013-01-07','14:20:00',7.82),('6449','2013-01-07','14:25:00',7.57),('6449','2013-01-07','14:30:00',7.44),('6449','2013-01-07','14:35:00',7.12),('6449','2013-01-07','14:40:00',6.89),('6449','2013-01-07','14:45:00',6.47),('6449','2013-01-07','14:50:00',6.33),('6449','2013-01-07','14:55:00',6.05),('6449','2013-01-07','15:00:00',5.74),('6449','2013-01-07','15:05:00',5.44),('6449','2013-01-07','15:10:00',5.19),('6449','2013-01-07','15:15:00',4.87),('6449','2013-01-07','15:20:00',4.53),('6449','2013-01-07','15:25:00',4.21),('6449','2013-01-07','15:30:00',3.89),('6449','2013-01-07','15:35:00',3.63),('6449','2013-01-07','15:40:00',3.37),('6449','2013-01-07','15:45:00',3.03),('6449','2013-01-07','15:50:00',2.71),('6449','2013-01-07','15:55:00',2.39),('6449','2013-01-07','16:00:00',2.05),('6449','2013-01-07','16:05:00',1.77),('6449','2013-01-07','16:10:00',1.54),('6449','2013-01-07','16:15:00',1.29),('6449','2013-01-07','16:20:00',1.04),('6449','2013-01-06','07:55:00',1.02),('6449','2013-01-06','08:00:00',1.4),('6449','2013-01-06','08:05:00',1.84),('6449','2013-01-06','08:10:00',2.18),('6449','2013-01-06','08:15:00',2.52),('6449','2013-01-06','08:20:00',2.84),('6449','2013-01-06','08:25:00',3.13),('6449','2013-01-06','08:30:00',3.42),('6449','2013-01-06','08:35:00',3.74),('6449','2013-01-06','08:40:00',4.03),('6449','2013-01-06','08:45:00',4.32),('6449','2013-01-06','08:50:00',4.56),('6449','2013-01-06','08:55:00',4.79),('6449','2013-01-06','09:00:00',5.1),('6449','2013-01-06','09:05:00',5.34),('6449','2013-01-06','09:10:00',5.58),('6449','2013-01-06','09:15:00',5.85),('6449','2013-01-06','09:20:00',6.09),('6449','2013-01-06','09:25:00',6.31),('6449','2013-01-06','09:30:00',6.61),('6449','2013-01-06','09:35:00',6.77),('6449','2013-01-06','09:40:00',6.96),('6449','2013-01-06','09:45:00',7.29),('6449','2013-01-06','09:50:00',7.49),('6449','2013-01-06','09:55:00',7.75),('6449','2013-01-06','10:00:00',8.01),('6449','2013-01-06','10:05:00',8.2),('6449','2013-01-06','10:10:00',8.39),('6449','2013-01-06','10:15:00',8.6),('6449','2013-01-06','10:20:00',8.83),('6449','2013-01-06','10:25:00',9.04),('6449','2013-01-06','10:30:00',9.22),('6449','2013-01-06','10:35:00',9.35),('6449','2013-01-06','10:40:00',9.52),('6449','2013-01-06','10:45:00',9.57),('6449','2013-01-06','10:50:00',9.77),('6449','2013-01-06','10:55:00',9.82),('6449','2013-01-06','11:00:00',10.13),('6449','2013-01-06','11:05:00',10.22),('6449','2013-01-06','11:10:00',10.33),('6449','2013-01-06','11:15:00',10.46),('6449','2013-01-06','11:20:00',10.64),('6449','2013-01-06','11:25:00',10.75),('6449','2013-01-06','11:30:00',10.7),('6449','2013-01-06','11:35:00',11),('6449','2013-01-06','11:40:00',11.07),('6449','2013-01-06','11:45:00',11.16),('6449','2013-01-06','11:50:00',11.15),('6449','2013-01-06','11:55:00',11.21),('6449','2013-01-06','12:00:00',11.19),('6449','2013-01-06','12:05:00',11.2),('6449','2013-01-06','12:10:00',11.19),('6449','2013-01-06','12:15:00',11.15),('6449','2013-01-06','12:20:00',11.13),('6449','2013-01-06','12:25:00',11.09),('6449','2013-01-06','12:30:00',10.94),('6449','2013-01-06','12:35:00',10.99),('6449','2013-01-06','12:40:00',10.98),('6449','2013-01-06','12:45:00',10.76),('6449','2013-01-06','12:50:00',10.86),('6449','2013-01-06','12:55:00',10.75),('6449','2013-01-06','13:00:00',10.53),('6449','2013-01-06','13:05:00',10.51),('6449','2013-01-06','13:10:00',10.41),('6449','2013-01-06','13:15:00',10.17),('6449','2013-01-06','13:20:00',10.15),('6449','2013-01-06','13:25:00',9.89),('6449','2013-01-06','13:30:00',9.78),('6449','2013-01-06','13:35:00',9.67),('6449','2013-01-06','13:40:00',9.37),('6449','2013-01-06','13:45:00',9.13),('6449','2013-01-06','13:51:00',8.89),('6449','2013-01-06','13:55:00',8.74),('6449','2013-01-06','14:00:00',8.52),('6449','2013-01-06','14:05:00',8.15),('6449','2013-01-06','14:10:00',7.9),('6449','2013-01-06','14:15:00',7.63),('6449','2013-01-06','14:20:00',7.41),('6449','2013-01-06','14:25:00',7.15),('6449','2013-01-06','14:31:00',7.02),('6449','2013-01-06','14:35:00',6.62),('6449','2013-01-06','14:40:00',6.46),('6449','2013-01-06','14:45:00',6.2),('6449','2013-01-06','14:50:00',5.97),('6449','2013-01-06','14:55:00',5.61),('6449','2013-01-06','15:00:00',5.31),('6449','2013-01-06','15:05:00',5.09),('6449','2013-01-06','15:10:00',4.73),('6449','2013-01-06','15:15:00',4.33),('6449','2013-01-06','15:20:00',4.06),('6449','2013-01-06','15:25:00',3.76),('6449','2013-01-06','15:30:00',3.44),('6449','2013-01-06','15:35:00',3.19),('6449','2013-01-06','15:40:00',2.95),('6449','2013-01-06','15:45:00',2.77),('6449','2013-01-06','15:51:00',2.57),('6449','2013-01-06','15:55:00',2.22),('6449','2013-01-06','16:00:00',1.89),('6449','2013-01-06','16:05:00',1.39),('6449','2013-01-06','16:10:00',1.11),('6449','2013-01-05','08:20:00',1.29),('6449','2013-01-05','08:25:00',1.73),('6449','2013-01-05','08:30:00',2.18),('6449','2013-01-05','08:35:00',2.37),('6449','2013-01-05','08:40:00',2.67),('6449','2013-01-05','08:45:00',1.83),('6449','2013-01-05','08:50:00',3.1),('6449','2013-01-05','08:55:00',3.81),('6449','2013-01-05','09:00:00',3.81),('6449','2013-01-05','09:05:00',1.56),('6449','2013-01-05','09:10:00',1.55),('6449','2013-01-05','09:15:00',1.57),('6449','2013-01-05','09:20:00',1.66),('6449','2013-01-05','09:25:00',1.85),('6449','2013-01-05','09:30:00',2.34),('6449','2013-01-05','09:35:00',3.05),('6449','2013-01-05','09:40:00',3.45),('6449','2013-01-05','09:45:00',3.52),('6449','2013-01-05','09:50:00',3.76),('6449','2013-01-05','09:55:00',3.33),('6449','2013-01-05','10:00:00',3.13),('6449','2013-01-05','10:05:00',3.2),('6449','2013-01-05','10:10:00',3.94),('6449','2013-01-05','10:15:00',5.75),('6449','2013-01-05','10:20:00',7.17),('6449','2013-01-05','10:25:00',7),('6449','2013-01-05','10:30:00',6.27),('6449','2013-01-05','10:35:00',6.36),('6449','2013-01-05','10:40:00',7.1),('6449','2013-01-05','10:45:00',6.95),('6449','2013-01-05','10:50:00',6.38),('6449','2013-01-05','10:55:00',6.27),('6449','2013-01-05','11:00:00',7.62),('6449','2013-01-05','11:05:00',9.28),('6449','2013-01-05','11:10:00',10.3),('6449','2013-01-05','11:15:00',9.47),('6449','2013-01-05','11:20:00',9.91),('6449','2013-01-05','11:25:00',9.99),('6449','2013-01-05','11:30:00',10.01),('6449','2013-01-05','11:35:00',10.45),('6449','2013-01-05','11:40:00',10.34),('6449','2013-01-05','11:45:00',10.62),('6449','2013-01-05','11:50:00',9.84),('6449','2013-01-05','11:55:00',10.01),('6449','2013-01-05','12:00:00',8.58),('6449','2013-01-05','12:05:00',7.92),('6449','2013-01-05','12:10:00',8.15),('6449','2013-01-05','12:15:00',7.92),('6449','2013-01-05','12:20:00',7.74),('6449','2013-01-05','12:25:00',6.85),('6449','2013-01-05','12:30:00',5.93),('6449','2013-01-05','12:35:00',7.26),('6449','2013-01-05','12:40:00',6.65),('6449','2013-01-05','12:45:00',6.64),('6449','2013-01-05','12:50:00',7.69),('6449','2013-01-05','12:55:00',11.03),('6449','2013-01-05','13:00:00',10.11),('6449','2013-01-05','13:05:00',10.27),('6449','2013-01-05','13:10:00',7.87),('6449','2013-01-05','13:15:00',8.17),('6449','2013-01-05','13:20:00',9.7),('6449','2013-01-05','13:25:00',9.48),('6449','2013-01-05','13:30:00',8.42),('6449','2013-01-05','13:35:00',9.16),('6449','2013-01-05','13:40:00',8.36),('6449','2013-01-05','13:45:00',8.58),('6449','2013-01-05','13:50:00',8.26),('6449','2013-01-05','13:55:00',7.88),('6449','2013-01-05','14:00:00',7.21),('6449','2013-01-05','14:05:00',7.47),('6449','2013-01-05','14:10:00',7.05),('6449','2013-01-05','14:15:00',6.3),('6449','2013-01-05','14:20:00',6.99),('6449','2013-01-05','14:25:00',5.96),('6449','2013-01-05','14:30:00',5.8),('6449','2013-01-05','14:35:00',5.65),('6449','2013-01-05','14:40:00',4.6),('6449','2013-01-05','14:45:00',4.54),('6449','2013-01-05','14:50:00',5.5),('6449','2013-01-05','14:55:00',5.57),('6449','2013-01-05','15:00:00',5.56),('6449','2013-01-05','15:05:00',4.01),('6449','2013-01-05','15:10:00',4.69),('6449','2013-01-05','15:15:00',4.23),('6449','2013-01-05','15:20:00',3.63),('6449','2013-01-05','15:25:00',2.31),('6449','2013-01-05','15:30:00',3.13),('6449','2013-01-05','15:35:00',2.75),('6449','2013-01-05','15:40:00',2.44),('6449','2013-01-05','15:45:00',2.25),('6449','2013-01-05','15:50:00',2.06),('6449','2013-01-05','15:55:00',1.86),('6449','2013-01-05','16:00:00',1.63),('6449','2013-01-05','16:05:00',1.42),('6449','2013-01-05','16:10:00',1.2),('6449','2013-01-04','08:00:00',1.04),('6449','2013-01-04','08:05:00',1.63),('6449','2013-01-04','08:10:00',1.86),('6449','2013-01-04','08:15:00',2.23),('6449','2013-01-04','08:20:00',2.32),('6449','2013-01-04','08:25:00',2.34),('6449','2013-01-04','08:30:00',2.22),('6449','2013-01-04','08:35:00',2.64),('6449','2013-01-04','08:40:00',2.93),('6449','2013-01-04','08:45:00',3.7),('6449','2013-01-04','08:50:00',2.41),('6449','2013-01-04','08:55:00',2.39),('6449','2013-01-04','09:00:00',4.43),('6449','2013-01-04','09:05:00',4.97),('6449','2013-01-04','09:10:00',4.18),('6449','2013-01-04','09:15:00',4.78),('6449','2013-01-04','09:20:00',5.14),('6449','2013-01-04','09:25:00',5.43),('6449','2013-01-04','09:30:00',6.26),('6449','2013-01-04','09:35:00',6.82),('6449','2013-01-04','09:40:00',7.24),('6449','2013-01-04','09:45:00',8.01),('6449','2013-01-04','09:50:00',8.39),('6449','2013-01-04','09:55:00',8.94),('6449','2013-01-04','10:00:00',7.88),('6449','2013-01-04','10:05:00',5.46),('6449','2013-01-04','10:10:00',2.87),('6449','2013-01-04','10:15:00',2.44),('6449','2013-01-04','10:20:00',3.18),('6449','2013-01-04','10:25:00',5.22),('6449','2013-01-04','10:30:00',8.61),('6449','2013-01-04','10:35:00',9.48),('6449','2013-01-04','10:40:00',9.87),('6449','2013-01-04','10:45:00',10.32),('6449','2013-01-04','10:50:00',11),('6449','2013-01-04','10:55:00',10.7),('6449','2013-01-04','11:00:00',8.55),('6449','2013-01-04','11:05:00',10.1),('6449','2013-01-04','11:10:00',8.52),('6449','2013-01-04','11:15:00',4.53),('6449','2013-01-04','11:20:00',3.16),('6449','2013-01-04','11:25:00',3.46),('6449','2013-01-04','11:30:00',4.17),('6449','2013-01-04','11:35:00',3.49),('6449','2013-01-04','11:40:00',2.42),('6449','2013-01-04','11:45:00',3.85),('6449','2013-01-04','11:50:00',8.75),('6449','2013-01-04','11:55:00',12.36),('6449','2013-01-04','12:00:00',10.79),('6449','2013-01-04','12:05:00',8.16),('6449','2013-01-04','12:10:00',3.41),('6449','2013-01-04','12:15:00',3.75),('6449','2013-01-04','12:20:00',3.63),('6449','2013-01-04','12:25:00',8.96),('6449','2013-01-04','12:30:00',10.95),('6449','2013-01-04','12:35:00',10.93),('6449','2013-01-04','12:40:00',10.97),('6449','2013-01-04','12:45:00',10.84),('6449','2013-01-04','12:50:00',10.62),('6449','2013-01-04','12:55:00',10.5),('6449','2013-01-04','13:00:00',9.56),('6449','2013-01-04','13:05:00',7.99),('6449','2013-01-04','13:10:00',9.42),('6449','2013-01-04','13:15:00',9.64),('6449','2013-01-04','13:20:00',9.55),('6449','2013-01-04','13:25:00',9.35),('6449','2013-01-04','13:30:00',9.13),('6449','2013-01-04','13:35:00',8.91),('6449','2013-01-04','13:40:00',8.66),('6449','2013-01-04','13:45:00',8.56),('6449','2013-01-04','13:50:00',8.55),('6449','2013-01-04','13:55:00',8.3),('6449','2013-01-04','14:00:00',7.61),('6449','2013-01-04','14:05:00',7.95),('6449','2013-01-04','14:10:00',7.76),('6449','2013-01-04','14:15:00',7),('6449','2013-01-04','14:20:00',6.98),('6449','2013-01-04','14:25:00',6.85),('6449','2013-01-04','14:30:00',6.75),('6449','2013-01-04','14:35:00',6.5),('6449','2013-01-04','14:40:00',6.16),('6449','2013-01-04','14:45:00',5.86),('6449','2013-01-04','14:50:00',5.74),('6449','2013-01-04','14:55:00',5.4),('6449','2013-01-04','15:00:00',5.22),('6449','2013-01-04','15:05:00',5.03),('6449','2013-01-04','15:10:00',4.79),('6449','2013-01-04','15:15:00',4.47),('6449','2013-01-04','15:20:00',4.01),('6449','2013-01-04','15:25:00',3.8),('6449','2013-01-04','15:30:00',3.65),('6449','2013-01-04','15:35:00',2.27),('6449','2013-01-04','15:40:00',2.51),('6449','2013-01-04','15:45:00',2.87),('6449','2013-01-04','15:50:00',2.57),('6449','2013-01-04','15:55:00',2.31),('6449','2013-01-04','16:00:00',1.93),('6449','2013-01-04','16:05:00',1.75),('6449','2013-01-04','16:10:00',1.49),('6449','2013-01-04','16:15:00',1.2),('6449','2013-01-04','16:20:00',1.05),('6449','2013-01-03','08:05:00',1.67),('6449','2013-01-03','08:10:00',2.08),('6449','2013-01-03','08:15:00',2.34),('6449','2013-01-03','08:20:00',2.84),('6449','2013-01-03','08:25:00',3.24),('6449','2013-01-03','08:30:00',2.53),('6449','2013-01-03','08:35:00',1.99),('6449','2013-01-03','08:40:00',2.35),('6449','2013-01-03','08:45:00',2.26),('6449','2013-01-03','08:50:00',4.2),('6449','2013-01-03','08:55:00',1.94),('6449','2013-01-03','09:00:00',2.54),('6449','2013-01-03','09:05:00',2.44),('6449','2013-01-03','09:10:00',2.42),('6449','2013-01-03','09:15:00',5.68),('6449','2013-01-03','09:20:00',7.14),('6449','2013-01-03','09:25:00',5.57),('6449','2013-01-03','09:30:00',3.86),('6449','2013-01-03','09:35:00',4.24),('6449','2013-01-03','09:40:00',5.65),('6449','2013-01-03','09:45:00',4.97),('6449','2013-01-03','09:50:00',4.54),('6449','2013-01-03','09:55:00',4.87),('6449','2013-01-03','10:00:00',5.5),('6449','2013-01-03','10:05:00',5.3),('6449','2013-01-03','10:10:00',5.03),('6449','2013-01-03','10:15:00',4.95),('6449','2013-01-03','10:20:00',5.26),('6449','2013-01-03','10:25:00',4.93),('6449','2013-01-03','10:30:00',4.79),('6449','2013-01-03','10:35:00',5.06),('6449','2013-01-03','10:40:00',5.15),('6449','2013-01-03','10:45:00',4.88),('6449','2013-01-03','10:50:00',4.89),('6449','2013-01-03','10:55:00',4.92),('6449','2013-01-03','11:00:00',5.31),('6449','2013-01-03','11:05:00',5.92),('6449','2013-01-03','11:10:00',6.44),('6449','2013-01-03','11:15:00',7.67),('6449','2013-01-03','11:20:00',7.94),('6449','2013-01-03','11:25:00',7.86),('6449','2013-01-03','11:30:00',8.3),('6449','2013-01-03','11:35:00',7.83),('6449','2013-01-03','11:40:00',9.13),('6449','2013-01-03','11:45:00',9.29),('6449','2013-01-03','11:50:00',10.45),('6449','2013-01-03','11:55:00',11.18),('6449','2013-01-03','12:00:00',11.03),('6449','2013-01-03','12:05:00',11),('6449','2013-01-03','12:10:00',10.96),('6449','2013-01-03','12:15:00',10.93),('6449','2013-01-03','12:20:00',10.94),('6449','2013-01-03','12:25:00',10.92),('6449','2013-01-03','12:30:00',10.73),('6449','2013-01-03','12:35:00',10.81),('6449','2013-01-03','12:40:00',10.76),('6449','2013-01-03','12:45:00',10.64),('6449','2013-01-03','12:50:00',10.53),('6449','2013-01-03','12:55:00',10.39),('6449','2013-01-03','13:00:00',10.06),('6449','2013-01-03','13:05:00',10.12),('6449','2013-01-03','13:10:00',10.02),('6449','2013-01-03','13:15:00',9.9),('6449','2013-01-03','13:20:00',9.77),('6449','2013-01-03','13:25:00',9.61),('6449','2013-01-03','13:30:00',9.48),('6449','2013-01-03','13:35:00',9.23),('6449','2013-01-03','13:40:00',9),('6449','2013-01-03','13:45:00',8.81),('6449','2013-01-03','13:50:00',8.65),('6449','2013-01-03','13:55:00',8.44),('6449','2013-01-03','14:00:00',8.29),('6449','2013-01-03','14:05:00',8),('6449','2013-01-03','14:10:00',7.92),('6449','2013-01-03','14:15:00',7.63),('6449','2013-01-03','14:20:00',7.42),('6449','2013-01-03','14:25:00',7.21),('6449','2013-01-03','14:30:00',6.99),('6449','2013-01-03','14:35:00',6.71),('6449','2013-01-03','14:40:00',6.44),('6449','2013-01-03','14:45:00',6.16),('6449','2013-01-03','14:50:00',5.99),('6449','2013-01-03','14:55:00',5.64),('6449','2013-01-03','15:00:00',5.43),('6449','2013-01-03','15:05:00',5.14),('6449','2013-01-03','15:10:00',4.66),('6449','2013-01-03','15:15:00',4.22),('6449','2013-01-03','15:20:00',3.66),('6449','2013-01-03','15:25:00',3.22),('6449','2013-01-03','15:30:00',3.47),('6449','2013-01-03','15:35:00',3.3),('6449','2013-01-03','15:40:00',2.79),('6449','2013-01-03','15:45:00',2.46),('6449','2013-01-03','15:50:00',2.1),('6449','2013-01-03','15:55:00',1.75),('6449','2013-01-03','16:00:00',1.5),('6449','2013-01-03','16:05:00',1.29),('6449','2013-01-03','16:10:00',1.09),('6449','2013-01-02','09:00:00',1.24),('6449','2013-01-02','09:05:00',1.06),('6449','2013-01-02','09:45:00',1.05),('6449','2013-01-02','09:50:00',1.21),('6449','2013-01-02','09:55:00',1.62),('6449','2013-01-02','10:00:00',1.62),('6449','2013-01-02','10:05:00',3.34),('6449','2013-01-02','10:10:00',4.65),('6449','2013-01-02','10:15:00',4.05),('6449','2013-01-02','10:20:00',3.81),('6449','2013-01-02','10:25:00',3.05),('6449','2013-01-02','10:30:00',3.75),('6449','2013-01-02','10:35:00',5.06),('6449','2013-01-02','10:40:00',5.09),('6449','2013-01-02','10:45:00',4.26),('6449','2013-01-02','10:50:00',3.79),('6449','2013-01-02','10:55:00',3.38),('6449','2013-01-02','11:00:00',3.19),('6449','2013-01-02','11:05:00',4.11),('6449','2013-01-02','11:10:00',5.7),('6449','2013-01-02','11:15:00',6.52),('6449','2013-01-02','11:20:00',5.6),('6449','2013-01-02','11:25:00',6.12),('6449','2013-01-02','11:30:00',7.75),('6449','2013-01-02','11:35:00',10.64),('6449','2013-01-02','11:40:00',9.5),('6449','2013-01-02','11:45:00',8.25),('6449','2013-01-02','11:50:00',4.44),('6449','2013-01-02','11:55:00',3.32),('6449','2013-01-02','12:00:00',2.93),('6449','2013-01-02','12:05:00',3.41),('6449','2013-01-02','12:10:00',4.09),('6449','2013-01-02','12:15:00',4.53),('6449','2013-01-02','12:20:00',4.16),('6449','2013-01-02','12:25:00',4.21),('6449','2013-01-02','12:30:00',4.56),('6449','2013-01-02','12:35:00',4.78),('6449','2013-01-02','12:40:00',4.47),('6449','2013-01-02','12:45:00',4.03),('6449','2013-01-02','12:50:00',3.77),('6449','2013-01-02','12:55:00',4.32),('6449','2013-01-02','13:00:00',4.41),('6449','2013-01-02','13:05:00',4.96),('6449','2013-01-02','13:10:00',4.88),('6449','2013-01-02','13:15:00',5.24),('6449','2013-01-02','13:20:00',5.2),('6449','2013-01-02','13:25:00',4.91),('6449','2013-01-02','13:30:00',5.32),('6449','2013-01-02','13:35:00',6.29),('6449','2013-01-02','13:40:00',5.33),('6449','2013-01-02','13:45:00',6.15),('6449','2013-01-02','13:50:00',6.79),('6449','2013-01-02','13:55:00',6.48),('6449','2013-01-02','14:00:00',3.98),('6449','2013-01-02','14:05:00',4.04),('6449','2013-01-02','14:10:00',3.66),('6449','2013-01-02','14:15:00',3.81),('6449','2013-01-02','14:20:00',3.06),('6449','2013-01-02','14:25:00',2.37),('6449','2013-01-02','14:30:00',1.65),('6449','2013-01-02','14:35:00',1.07),('6449','2013-01-01','08:00:00',1.16),('6449','2013-01-01','08:05:00',1.53),('6449','2013-01-01','08:10:00',2.11),('6449','2013-01-01','08:15:00',2.74),('6449','2013-01-01','08:20:00',3.15),('6449','2013-01-01','08:25:00',3.43),('6449','2013-01-01','08:30:00',3.91),('6449','2013-01-01','08:35:00',4.27),('6449','2013-01-01','08:40:00',4.33),('6449','2013-01-01','08:45:00',2.52),('6449','2013-01-01','08:50:00',2.11),('6449','2013-01-01','08:55:00',4.06),('6449','2013-01-01','09:00:00',2.2),('6449','2013-01-01','09:05:00',2.77),('6449','2013-01-01','09:10:00',3.39),('6449','2013-01-01','09:15:00',5.49),('6449','2013-01-01','09:20:00',5.86),('6449','2013-01-01','09:25:00',7.28),('6449','2013-01-01','09:30:00',5.15),('6449','2013-01-01','09:35:00',3.49),('6449','2013-01-01','09:40:00',2.41),('6449','2013-01-01','09:45:00',2.19),('6449','2013-01-01','09:50:00',2.88),('6449','2013-01-01','09:55:00',6.81),('6449','2013-01-01','10:00:00',3.81),('6449','2013-01-01','10:05:00',3.99),('6449','2013-01-01','10:10:00',3.39),('6449','2013-01-01','10:15:00',3.79),('6449','2013-01-01','10:20:00',3.45),('6449','2013-01-01','10:25:00',3.42),('6449','2013-01-01','10:30:00',4.5),('6449','2013-01-01','10:35:00',3.59),('6449','2013-01-01','10:40:00',4.09),('6449','2013-01-01','10:45:00',5.8),('6449','2013-01-01','10:50:00',7.06),('6449','2013-01-01','10:55:00',5.36),('6449','2013-01-01','11:00:00',3.99),('6449','2013-01-01','11:05:00',3.66),('6449','2013-01-01','11:10:00',5.28),('6449','2013-01-01','11:15:00',3.6),('6449','2013-01-01','11:20:00',2.26),('6449','2013-01-01','11:25:00',1.73),('6449','2013-01-01','11:30:00',2.1),('6449','2013-01-01','11:35:00',3.21),('6449','2013-01-01','11:40:00',3.23),('6449','2013-01-01','11:45:00',2.69),('6449','2013-01-01','11:50:00',2.17),('6449','2013-01-01','11:55:00',1.85),('6449','2013-01-01','12:00:00',1.72),('6449','2013-01-01','12:05:00',1.83),('6449','2013-01-01','12:10:00',1.59),('6449','2013-01-01','12:15:00',1.52),('6449','2013-01-01','12:20:00',1.59),('6449','2013-01-01','12:25:00',1.27),('6449','2013-01-01','12:40:00',1.18),('6449','2013-01-01','12:45:00',1.19),('6449','2013-01-01','12:50:00',1.34),('6449','2013-01-01','12:55:00',1.9),('6449','2013-01-01','13:00:00',2.48),('6449','2013-01-01','13:05:00',3.18),('6449','2013-01-01','13:10:00',2.58),('6449','2013-01-01','13:15:00',2.04),('6449','2013-01-01','13:20:00',2.9),('6449','2013-01-01','13:25:00',4.5),('6449','2013-01-01','13:30:00',3.86),('6449','2013-01-01','13:35:00',5.93),('6449','2013-01-01','13:40:00',4.51),('6449','2013-01-01','13:45:00',5.66),('6449','2013-01-01','13:50:00',8.35),('6449','2013-01-01','13:55:00',8.91),('6449','2013-01-01','14:00:00',8.64),('6449','2013-01-01','14:05:00',8.19),('6449','2013-01-01','14:10:00',7.78),('6449','2013-01-01','14:15:00',7.36),('6449','2013-01-01','14:20:00',7.03),('6449','2013-01-01','14:25:00',6.92),('6449','2013-01-01','14:30:00',6.67),('6449','2013-01-01','14:35:00',6.44),('6449','2013-01-01','14:40:00',6.19),('6449','2013-01-01','14:45:00',5.85),('6449','2013-01-01','14:50:00',5.4),('6449','2013-01-01','14:55:00',5.29),('6449','2013-01-01','15:00:00',4.82),('6449','2013-01-01','15:05:00',4.74),('6449','2013-01-01','15:10:00',4.46),('6449','2013-01-01','15:15:00',4.2),('6449','2013-01-01','15:20:00',3.98),('6449','2013-01-01','15:25:00',3.62),('6449','2013-01-01','15:30:00',3.24),('6449','2013-01-01','15:35:00',1.21),('6449','2012-12-31','07:55:00',1.4),('6449','2012-12-31','08:00:00',1.47),('6449','2012-12-31','08:05:00',1.49),('6449','2012-12-31','08:10:00',1.99),('6449','2012-12-31','08:15:00',1.2),('6449','2012-12-31','08:20:00',1.37),('6449','2012-12-31','08:30:00',2.05),('6449','2012-12-31','08:35:00',3.95),('6449','2012-12-31','08:40:00',4.45),('6449','2012-12-31','08:45:00',4.44),('6449','2012-12-31','08:50:00',5.18),('6449','2012-12-31','08:55:00',5.41),('6449','2012-12-31','09:00:00',5.67),('6449','2012-12-31','09:05:00',5.89),('6449','2012-12-31','09:10:00',6.08),('6449','2012-12-31','09:15:00',6.1),('6449','2012-12-31','09:20:00',6.48),('6449','2012-12-31','09:25:00',6.97),('6449','2012-12-31','09:30:00',7.08),('6449','2012-12-31','09:35:00',6.85),('6449','2012-12-31','09:40:00',6.64),('6449','2012-12-31','09:45:00',7.22),('6449','2012-12-31','09:50:00',7.46),('6449','2012-12-31','09:55:00',7.38),('6449','2012-12-31','10:00:00',7.14),('6449','2012-12-31','10:05:00',7.88),('6449','2012-12-31','10:10:00',8.23),('6449','2012-12-31','10:15:00',8.88),('6449','2012-12-31','10:20:00',9.36),('6449','2012-12-31','10:25:00',9.69),('6449','2012-12-31','10:30:00',9.89),('6449','2012-12-31','10:35:00',10.05),('6449','2012-12-31','10:40:00',10.17),('6449','2012-12-31','10:45:00',10.24),('6449','2012-12-31','10:50:00',10.39),('6449','2012-12-31','10:55:00',10.41),('6449','2012-12-31','11:00:00',10.66),('6449','2012-12-31','11:05:00',10.84),('6449','2012-12-31','11:10:00',10.95),('6449','2012-12-31','11:15:00',10.99),('6449','2012-12-31','11:20:00',11.1),('6449','2012-12-31','11:25:00',11.17),('6449','2012-12-31','11:30:00',11.27),('6449','2012-12-31','11:35:00',11.3),('6449','2012-12-31','11:40:00',11.24),('6449','2012-12-31','11:45:00',11.46),('6449','2012-12-31','11:50:00',11.48),('6449','2012-12-31','11:55:00',11.51),('6449','2012-12-31','12:00:00',11.5),('6449','2012-12-31','12:05:00',11.51),('6449','2012-12-31','12:10:00',11.35),('6449','2012-12-31','12:15:00',11.5),('6449','2012-12-31','12:20:00',11.5),('6449','2012-12-31','12:25:00',11.45),('6449','2012-12-31','12:30:00',11.28),('6449','2012-12-31','12:35:00',11.27),('6449','2012-12-31','12:40:00',11.09),('6449','2012-12-31','12:45:00',11.11),('6449','2012-12-31','12:50:00',11.04),('6449','2012-12-31','12:55:00',10.9),('6449','2012-12-31','13:00:00',10.84),('6449','2012-12-31','13:05:00',10.64),('6449','2012-12-31','13:10:00',10.54),('6449','2012-12-31','13:15:00',10.38),('6449','2012-12-31','13:20:00',10.14),('6449','2012-12-31','13:25:00',9.97),('6449','2012-12-31','13:30:00',9.88),('6449','2012-12-31','13:35:00',9.75),('6449','2012-12-31','13:40:00',9.54),('6449','2012-12-31','13:45:00',9.39),('6449','2012-12-31','13:50:00',9.07),('6449','2012-12-31','13:55:00',8.96),('6449','2012-12-31','14:00:00',8.74),('6449','2012-12-31','14:05:00',8.52),('6449','2012-12-31','14:10:00',8.32),('6449','2012-12-31','14:15:00',8.08),('6449','2012-12-31','14:20:00',7.83),('6449','2012-12-31','14:25:00',7.59),('6449','2012-12-31','14:30:00',7.36),('6449','2012-12-31','14:35:00',7.12),('6449','2012-12-31','14:40:00',6.83),('6449','2012-12-31','14:45:00',6.58),('6449','2012-12-31','14:50:00',6.29),('6449','2012-12-31','14:55:00',6.03),('6449','2012-12-31','15:00:00',5.71),('6449','2012-12-31','15:05:00',5.42),('6449','2012-12-31','15:10:00',5.07),('6449','2012-12-31','15:15:00',4.81),('6449','2012-12-31','15:20:00',4.51),('6449','2012-12-31','15:25:00',4.15),('6449','2012-12-31','15:30:00',3.83),('6449','2012-12-31','15:35:00',3.52),('6449','2012-12-31','15:40:00',3.17),('6449','2012-12-31','15:45:00',2.88),('6449','2012-12-31','15:50:00',2.55),('6449','2012-12-31','15:55:00',2.2),('6449','2012-12-31','16:00:00',1.91),('6449','2012-12-31','16:05:00',1.61),('6449','2012-12-31','16:10:00',1.36),('6449','2012-12-31','16:15:00',1.15),('6449','2012-12-30','07:55:00',1.16),('6449','2012-12-30','08:00:00',1.5),('6449','2012-12-30','08:05:00',1.85),('6449','2012-12-30','08:10:00',2.18),('6449','2012-12-30','08:15:00',2.53),('6449','2012-12-30','08:20:00',2.87),('6449','2012-12-30','08:25:00',3.17),('6449','2012-12-30','08:30:00',3.52),('6449','2012-12-30','08:35:00',3.86),('6449','2012-12-30','08:40:00',4.15),('6449','2012-12-30','08:45:00',4.46),('6449','2012-12-30','08:50:00',4.74),('6449','2012-12-30','08:55:00',4.92),('6449','2012-12-30','09:00:00',5.31),('6449','2012-12-30','09:05:00',5.57),('6449','2012-12-30','09:10:00',5.85),('6449','2012-12-30','09:15:00',6.07),('6449','2012-12-30','09:20:00',6.35),('6449','2012-12-30','09:25:00',6.59),('6449','2012-12-30','09:30:00',6.89),('6449','2012-12-30','09:35:00',7.22),('6449','2012-12-30','09:40:00',7.53),('6449','2012-12-30','09:45:00',7.85),('6449','2012-12-30','09:50:00',8.14),('6449','2012-12-30','09:55:00',8.31),('6449','2012-12-30','10:00:00',8.59),('6449','2012-12-30','10:05:00',8.84),('6449','2012-12-30','10:10:00',9),('6449','2012-12-30','10:15:00',9.27),('6449','2012-12-30','10:20:00',9.48),('6449','2012-12-30','10:25:00',9.68),('6449','2012-12-30','10:30:00',9.87),('6449','2012-12-30','10:35:00',10.02),('6449','2012-12-30','10:40:00',10.1),('6449','2012-12-30','10:45:00',10.34),('6449','2012-12-30','10:50:00',10.5),('6449','2012-12-30','10:55:00',10.64),('6449','2012-12-30','11:00:00',10.75),('6449','2012-12-30','11:05:00',10.82),('6449','2012-12-30','11:10:00',10.89),('6449','2012-12-30','11:15:00',10.95),('6449','2012-12-30','11:20:00',11.04),('6449','2012-12-30','11:25:00',11.08),('6449','2012-12-30','11:30:00',11.07),('6449','2012-12-30','11:35:00',11.12),('6449','2012-12-30','11:40:00',11.07),('6449','2012-12-30','11:45:00',10.95),('6449','2012-12-30','11:50:00',10.89),('6449','2012-12-30','11:55:00',10.93),('6449','2012-12-30','12:00:00',10.94),('6449','2012-12-30','12:05:00',11.1),('6449','2012-12-30','12:10:00',11.05),('6449','2012-12-30','12:15:00',11.06),('6449','2012-12-30','12:20:00',11.04),('6449','2012-12-30','12:25:00',11.36),('6449','2012-12-30','12:30:00',11.06),('6449','2012-12-30','12:35:00',11.24),('6449','2012-12-30','12:40:00',11.16),('6449','2012-12-30','12:45:00',11.02),('6449','2012-12-30','12:50:00',11.02),('6449','2012-12-30','12:55:00',10.89),('6449','2012-12-30','13:00:00',10.63),('6449','2012-12-30','13:05:00',10.58),('6449','2012-12-30','13:10:00',10.44),('6449','2012-12-30','13:15:00',10.23),('6449','2012-12-30','13:20:00',10.01),('6449','2012-12-30','13:25:00',9.87),('6449','2012-12-30','13:30:00',9.67),('6449','2012-12-30','13:35:00',9.5),('6449','2012-12-30','13:40:00',9.4),('6449','2012-12-30','13:45:00',9.05),('6449','2012-12-30','13:50:00',8.98),('6449','2012-12-30','13:55:00',8.84),('6449','2012-12-30','14:00:00',8.56),('6449','2012-12-30','14:05:00',8.33),('6449','2012-12-30','14:10:00',8.19),('6449','2012-12-30','14:15:00',7.86),('6449','2012-12-30','14:20:00',7.68),('6449','2012-12-30','14:25:00',7.46),('6449','2012-12-30','14:30:00',7.27),('6449','2012-12-30','14:35:00',7.02),('6449','2012-12-30','14:40:00',6.74),('6449','2012-12-30','14:45:00',6.46),('6449','2012-12-30','14:50:00',6.17),('6449','2012-12-30','14:55:00',5.93),('6449','2012-12-30','15:00:00',5.62),('6449','2012-12-30','15:05:00',5.33),('6449','2012-12-30','15:10:00',5.04),('6449','2012-12-30','15:15:00',4.7),('6449','2012-12-30','15:20:00',4.39),('6449','2012-12-30','15:25:00',4.05),('6449','2012-12-30','15:30:00',3.68),('6449','2012-12-30','15:35:00',3.39),('6449','2012-12-30','15:40:00',3.07),('6449','2012-12-30','15:45:00',2.79),('6449','2012-12-30','15:50:00',2.49),('6449','2012-12-30','15:55:00',2.15),('6449','2012-12-30','16:00:00',1.83),('6449','2012-12-30','16:05:00',1.57),('6449','2012-12-30','16:10:00',1.33),('6449','2012-12-30','16:15:00',1.08),('6449','2012-12-29','07:55:00',1.08),('6449','2012-12-29','08:00:00',1.41),('6449','2012-12-29','08:05:00',1.74),('6449','2012-12-29','08:10:00',2.06),('6449','2012-12-29','08:15:00',2.48),('6449','2012-12-29','08:20:00',2.84),('6449','2012-12-29','08:25:00',3.17),('6449','2012-12-29','08:30:00',3.48),('6449','2012-12-29','08:35:00',3.82),('6449','2012-12-29','08:40:00',4.03),('6449','2012-12-29','08:45:00',4.4),('6449','2012-12-29','08:50:00',4.7),('6449','2012-12-29','08:55:00',5.04),('6449','2012-12-29','09:00:00',5.3),('6449','2012-12-29','09:05:00',5.58),('6449','2012-12-29','09:10:00',5.81),('6449','2012-12-29','09:15:00',6.11),('6449','2012-12-29','09:20:00',6.37),('6449','2012-12-29','09:25:00',6.66),('6449','2012-12-29','09:30:00',6.99),('6449','2012-12-29','09:35:00',7.26),('6449','2012-12-29','09:40:00',7.56),('6449','2012-12-29','09:45:00',7.79),('6449','2012-12-29','09:50:00',8.04),('6449','2012-12-29','09:55:00',8.07),('6449','2012-12-29','10:00:00',8.45),('6449','2012-12-29','10:05:00',8.66),('6449','2012-12-29','10:10:00',8.88),('6449','2012-12-29','10:15:00',9.11),('6449','2012-12-29','10:20:00',9.27),('6449','2012-12-29','10:25:00',9.35),('6449','2012-12-29','10:30:00',9.6),('6449','2012-12-29','10:35:00',9.74),('6449','2012-12-29','10:40:00',9.88),('6449','2012-12-29','10:45:00',10.04),('6449','2012-12-29','10:50:00',10.17),('6449','2012-12-29','10:55:00',10.31),('6449','2012-12-29','11:00:00',10.5),('6449','2012-12-29','11:05:00',10.65),('6449','2012-12-29','11:10:00',10.74),('6449','2012-12-29','11:15:00',10.84),('6449','2012-12-29','11:20:00',10.97),('6449','2012-12-29','11:25:00',11.05),('6449','2012-12-29','11:30:00',11.08),('6449','2012-12-29','11:35:00',11.1),('6449','2012-12-29','11:40:00',11.05),('6449','2012-12-29','11:45:00',11.02),('6449','2012-12-29','11:50:00',11.1),('6449','2012-12-29','11:55:00',11.01),('6449','2012-12-29','12:00:00',11.03),('6449','2012-12-29','12:05:00',11.05),('6449','2012-12-29','12:10:00',11.03),('6449','2012-12-29','12:15:00',11.14),('6449','2012-12-29','12:20:00',11.11),('6449','2012-12-29','12:25:00',10.93),('6449','2012-12-29','12:30:00',10.82),('6449','2012-12-29','12:35:00',10.76),('6449','2012-12-29','12:40:00',10.75),('6449','2012-12-29','12:45:00',10.71),('6449','2012-12-29','12:50:00',10.62),('6449','2012-12-29','12:55:00',10.55),('6449','2012-12-29','13:00:00',10.48),('6449','2012-12-29','13:05:00',10.36),('6449','2012-12-29','13:10:00',10.26),('6449','2012-12-29','13:15:00',10.01),('6449','2012-12-29','13:20:00',9.92),('6449','2012-12-29','13:25:00',9.85),('6449','2012-12-29','13:30:00',9.52),('6449','2012-12-29','13:35:00',9.65),('6449','2012-12-29','13:40:00',9.52),('6449','2012-12-29','13:45:00',9.44),('6449','2012-12-29','13:50:00',9.21),('6449','2012-12-29','13:55:00',9.15),('6449','2012-12-29','14:00:00',8.77),('6449','2012-12-29','14:06:00',8.69),('6449','2012-12-29','14:10:00',8.56),('6449','2012-12-29','14:15:00',8.2),('6449','2012-12-29','14:20:00',7.97),('6449','2012-12-29','14:25:00',7.72),('6449','2012-12-29','14:30:00',7.45),('6449','2012-12-29','14:35:00',7.16),('6449','2012-12-29','14:40:00',6.88),('6449','2012-12-29','14:45:00',6.61),('6449','2012-12-29','14:50:00',6.28),('6449','2012-12-29','14:55:00',6.03),('6449','2012-12-29','15:00:00',5.71),('6449','2012-12-29','15:05:00',5.41),('6449','2012-12-29','15:10:00',5.13),('6449','2012-12-29','15:15:00',4.7),('6449','2012-12-29','15:20:00',4.48),('6449','2012-12-29','15:25:00',4.13),('6449','2012-12-29','15:30:00',3.77),('6449','2012-12-29','15:35:00',3.44),('6449','2012-12-29','15:40:00',3.13),('6449','2012-12-29','15:45:00',2.82),('6449','2012-12-29','15:50:00',2.52),('6449','2012-12-29','15:55:00',2.2),('6449','2012-12-29','16:00:00',1.92),('6449','2012-12-29','16:05:00',1.63),('6449','2012-12-29','16:10:00',1.41),('6449','2012-12-29','16:15:00',1.13),('6449','2012-12-28','08:25:00',1.33),('6449','2012-12-28','08:30:00',2.62),('6449','2012-12-28','08:35:00',3.07),('6449','2012-12-28','08:40:00',3.55),('6449','2012-12-28','08:45:00',4.03),('6449','2012-12-28','08:50:00',4.3),('6449','2012-12-28','08:55:00',4.59),('6449','2012-12-28','09:00:00',4.81),('6449','2012-12-28','09:05:00',4.95),('6449','2012-12-28','09:10:00',5.05),('6449','2012-12-28','09:15:00',5.42),('6449','2012-12-28','09:20:00',5.78),('6449','2012-12-28','09:25:00',6.05),('6449','2012-12-28','09:30:00',6.37),('6449','2012-12-28','09:35:00',6.62),('6449','2012-12-28','09:40:00',6.81),('6449','2012-12-28','09:45:00',7.09),('6449','2012-12-28','09:50:00',7.4),('6449','2012-12-28','09:55:00',7.54),('6449','2012-12-28','10:00:00',7.81),('6449','2012-12-28','10:05:00',8.02),('6449','2012-12-28','10:10:00',8.26),('6449','2012-12-28','10:15:00',8.56),('6449','2012-12-28','10:20:00',8.84),('6449','2012-12-28','10:25:00',8.93),('6449','2012-12-28','10:30:00',9.36),('6449','2012-12-28','10:35:00',9.61),('6449','2012-12-28','10:40:00',9.69),('6449','2012-12-28','10:45:00',9.96),('6449','2012-12-28','10:50:00',10.08),('6449','2012-12-28','10:55:00',10.2),('6449','2012-12-28','11:00:00',10.29),('6449','2012-12-28','11:05:00',10.39),('6449','2012-12-28','11:10:00',10.48),('6449','2012-12-28','11:15:00',10.56),('6449','2012-12-28','11:20:00',10.59),('6449','2012-12-28','11:25:00',10.6),('6449','2012-12-28','11:30:00',10.73),('6449','2012-12-28','11:35:00',10.8),('6449','2012-12-28','11:40:00',10.76),('6449','2012-12-28','11:45:00',10.89),('6449','2012-12-28','11:50:00',10.89),('6449','2012-12-28','11:55:00',11.02),('6449','2012-12-28','12:00:00',11.04),('6449','2012-12-28','12:05:00',11.01),('6449','2012-12-28','12:10:00',11.01),('6449','2012-12-28','12:15:00',11.03),('6449','2012-12-28','12:20:00',11.09),('6449','2012-12-28','12:25:00',10.88),('6449','2012-12-28','12:30:00',10.79),('6449','2012-12-28','12:35:00',10.62),('6449','2012-12-28','12:40:00',10.3),('6449','2012-12-28','12:45:00',10.36),('6449','2012-12-28','12:50:00',10.17),('6449','2012-12-28','12:55:00',10.02),('6449','2012-12-28','13:00:00',9.9),('6449','2012-12-28','13:05:00',9.95),('6449','2012-12-28','13:10:00',9.67),('6449','2012-12-28','13:15:00',9.53),('6449','2012-12-28','13:20:00',9.42),('6449','2012-12-28','13:25:00',9.15),('6449','2012-12-28','13:30:00',9.1),('6449','2012-12-28','13:35:00',9.05),('6449','2012-12-28','13:40:00',8.98),('6449','2012-12-28','13:45:00',8.82),('6449','2012-12-28','13:50:00',8.74),('6449','2012-12-28','13:55:00',8.58),('6449','2012-12-28','14:00:00',8.2),('6449','2012-12-28','14:05:00',8.01),('6449','2012-12-28','14:10:00',7.86),('6449','2012-12-28','14:15:00',7.6),('6449','2012-12-28','14:20:00',7.38),('6449','2012-12-28','14:25:00',7.12),('6449','2012-12-28','14:30:00',6.85),('6449','2012-12-28','14:35:00',6.59),('6449','2012-12-28','14:40:00',6.35),('6449','2012-12-28','14:45:00',6.06),('6449','2012-12-28','14:50:00',5.8),('6449','2012-12-28','14:55:00',5.52),('6449','2012-12-28','15:00:00',5.22),('6449','2012-12-28','15:05:00',4.94),('6449','2012-12-28','15:10:00',4.58),('6449','2012-12-28','15:15:00',4.34),('6449','2012-12-28','15:20:00',4.05),('6449','2012-12-28','15:25:00',3.71),('6449','2012-12-28','15:30:00',3.4),('6449','2012-12-28','15:35:00',3.07),('6449','2012-12-28','15:40:00',2.74),('6449','2012-12-28','15:45:00',2.43),('6449','2012-12-28','15:50:00',2.12),('6449','2012-12-28','15:55:00',1.8),('6449','2012-12-28','16:00:00',1.54),('6449','2012-12-28','16:05:00',1.31),('6449','2012-12-28','16:10:00',1.11),('6449','2012-12-27','08:05:00',1.35),('6449','2012-12-27','08:10:00',1.65),('6449','2012-12-27','08:15:00',1.94),('6449','2012-12-27','08:20:00',2.16),('6449','2012-12-27','08:25:00',2.41),('6449','2012-12-27','08:30:00',2.63),('6449','2012-12-27','08:35:00',2.75),('6449','2012-12-27','08:40:00',1.63),('6449','2012-12-27','08:45:00',1.39),('6449','2012-12-27','08:50:00',1.46),('6449','2012-12-27','08:55:00',1.28),('6449','2012-12-27','09:00:00',1.94),('6449','2012-12-27','09:05:00',1.74),('6449','2012-12-27','09:10:00',2.69),('6449','2012-12-27','09:15:00',5.83),('6449','2012-12-27','09:20:00',4.13),('6449','2012-12-27','09:25:00',2.19),('6449','2012-12-27','09:30:00',3.58),('6449','2012-12-27','09:35:00',5.37),('6449','2012-12-27','09:40:00',5.71),('6449','2012-12-27','09:45:00',6.87),('6449','2012-12-27','09:50:00',7.04),('6449','2012-12-27','09:55:00',7.37),('6449','2012-12-27','10:00:00',7.72),('6449','2012-12-27','10:05:00',7.81),('6449','2012-12-27','10:10:00',8.01),('6449','2012-12-27','10:15:00',8.19),('6449','2012-12-27','10:20:00',8.34),('6449','2012-12-27','10:25:00',8.44),('6449','2012-12-27','10:30:00',8.77),('6449','2012-12-27','10:35:00',8.83),('6449','2012-12-27','10:40:00',9.04),('6449','2012-12-27','10:45:00',9.33),('6449','2012-12-27','10:50:00',9.42),('6449','2012-12-27','10:55:00',9.63),('6449','2012-12-27','11:00:00',9.83),('6449','2012-12-27','11:05:00',9.94),('6449','2012-12-27','11:10:00',10),('6449','2012-12-27','11:15:00',10.08),('6449','2012-12-27','11:20:00',10.05),('6449','2012-12-27','11:25:00',10.06),('6449','2012-12-27','11:30:00',10.31),('6449','2012-12-27','11:36:00',10.64),('6449','2012-12-27','11:40:00',9.71),('6449','2012-12-27','11:45:00',6.24),('6449','2012-12-27','11:50:00',7.17),('6449','2012-12-27','11:55:00',3.25),('6449','2012-12-27','12:00:00',2.62),('6449','2012-12-27','12:05:00',10.66),('6449','2012-12-27','12:10:00',10.73),('6449','2012-12-27','12:15:00',10.47),('6449','2012-12-27','12:20:00',10.59),('6449','2012-12-27','12:25:00',10.48),('6449','2012-12-27','12:30:00',10.28),('6449','2012-12-27','12:35:00',10.47),('6449','2012-12-27','12:40:00',10.36),('6449','2012-12-27','12:45:00',10.34),('6449','2012-12-27','12:50:00',8.47),('6449','2012-12-27','12:55:00',9.95),('6449','2012-12-27','13:00:00',10.04),('6449','2012-12-27','13:05:00',9.86),('6449','2012-12-27','13:10:00',9.52),('6449','2012-12-27','13:15:00',9.52),('6449','2012-12-27','13:20:00',9.51),('6449','2012-12-27','13:25:00',9.11),('6449','2012-12-27','13:30:00',3.17),('6449','2012-12-27','13:35:00',2.19),('6449','2012-12-27','13:40:00',3.6),('6449','2012-12-27','13:45:00',6.89),('6449','2012-12-27','13:50:00',3.84),('6449','2012-12-27','13:55:00',3.16),('6449','2012-12-27','14:00:00',2.8),('6449','2012-12-27','14:05:00',5.09),('6449','2012-12-27','14:10:00',8.88),('6449','2012-12-27','14:15:00',6.44),('6449','2012-12-27','14:20:00',6.97),('6449','2012-12-27','14:25:00',7.14),('6449','2012-12-27','14:30:00',6.91),('6449','2012-12-27','14:35:00',6.64),('6449','2012-12-27','14:40:00',6.37),('6449','2012-12-27','14:45:00',6.28),('6449','2012-12-27','14:50:00',5.91),('6449','2012-12-27','14:55:00',5.59),('6449','2012-12-27','15:00:00',5.39),('6449','2012-12-27','15:05:00',5.15),('6449','2012-12-27','15:10:00',4.86),('6449','2012-12-27','15:15:00',4.41),('6449','2012-12-27','15:20:00',3.82),('6449','2012-12-27','15:25:00',3.79),('6449','2012-12-27','15:30:00',3.73),('6449','2012-12-27','15:35:00',3.34),('6449','2012-12-27','15:40:00',2.33),('6449','2012-12-27','15:45:00',1.51),('6449','2012-12-27','15:50:00',2.16),('6449','2012-12-27','15:55:00',2.07),('6449','2012-12-27','16:00:00',1.62),('6449','2012-12-26','08:25:00',1.09),('6449','2012-12-26','08:30:00',1.51),('6449','2012-12-26','08:35:00',1.72),('6449','2012-12-26','08:40:00',1.09),('6449','2012-12-26','08:45:00',2.48),('6449','2012-12-26','08:55:00',1.17),('6449','2012-12-26','09:00:00',4.71),('6449','2012-12-26','09:05:00',4.97),('6449','2012-12-26','09:10:00',5.2),('6449','2012-12-26','09:15:00',5.42),('6449','2012-12-26','09:20:00',5.59),('6449','2012-12-26','09:25:00',5.97),('6449','2012-12-26','09:30:00',6.35),('6449','2012-12-26','09:35:00',6.65),('6449','2012-12-26','09:40:00',6.74),('6449','2012-12-26','09:45:00',7.03),('6449','2012-12-26','09:50:00',7.45),('6449','2012-12-26','09:55:00',7.68),('6449','2012-12-26','10:00:00',6.95),('6449','2012-12-26','10:05:00',4.11),('6449','2012-12-26','10:10:00',2.52),('6449','2012-12-26','10:15:00',2.36),('6449','2012-12-26','10:20:00',2.23),('6449','2012-12-26','10:25:00',2.13),('6449','2012-12-26','10:30:00',2.02),('6449','2012-12-26','10:35:00',2),('6449','2012-12-26','10:40:00',2.08),('6449','2012-12-26','10:45:00',1.84),('6449','2012-12-26','10:50:00',1.72),('6449','2012-12-26','10:55:00',1.54),('6449','2012-12-26','11:00:00',1.73),('6449','2012-12-26','11:05:00',1.59),('6449','2012-12-26','11:10:00',1.72),('6449','2012-12-26','11:15:00',2.01),('6449','2012-12-26','11:20:00',2.07),('6449','2012-12-26','11:25:00',2.07),('6449','2012-12-26','11:30:00',1.89),('6449','2012-12-26','11:35:00',2),('6449','2012-12-26','11:40:00',2.01),('6449','2012-12-26','11:45:00',2.01),('6449','2012-12-26','11:50:00',2.05),('6449','2012-12-26','11:55:00',2.53),('6449','2012-12-26','12:00:00',2.45),('6449','2012-12-26','12:05:00',2.21),('6449','2012-12-26','12:10:00',2.27),('6449','2012-12-26','12:15:00',2.17),('6449','2012-12-26','12:20:00',2.2),('6449','2012-12-26','12:25:00',2.19),('6449','2012-12-26','12:30:00',2.45),('6449','2012-12-26','12:35:00',2.87),('6449','2012-12-26','12:40:00',2.5),('6449','2012-12-26','12:45:00',1.91),('6449','2012-12-26','12:50:00',1.58),('6449','2012-12-26','12:55:00',1.77),('6449','2012-12-26','13:00:00',2.18),('6449','2012-12-26','13:05:00',2.07),('6449','2012-12-26','13:10:00',1.63),('6449','2012-12-26','13:15:00',2.15),('6449','2012-12-26','13:20:00',2.35),('6449','2012-12-26','13:25:00',2.79),('6449','2012-12-26','13:30:00',2.89),('6449','2012-12-26','13:35:00',2.58),('6449','2012-12-26','13:40:00',1.77),('6449','2012-12-26','13:45:00',1.42),('6449','2012-12-26','13:50:00',1.62),('6449','2012-12-26','13:55:00',1.42),('6449','2012-12-26','14:00:00',1.25),('6449','2012-12-26','14:05:00',1.32),('6449','2012-12-26','14:10:00',1.26),('6449','2012-12-26','14:15:00',1.26),('6449','2012-12-26','14:20:00',1.1),('6449','2012-12-26','14:25:00',1.39),('6449','2012-12-26','14:30:00',1.61),('6449','2012-12-26','14:35:00',1.62),('6449','2012-12-26','14:40:00',1.72),('6449','2012-12-26','14:45:00',1.8),('6449','2012-12-26','14:50:00',2.49),('6449','2012-12-26','14:55:00',2.24),('6449','2012-12-26','15:00:00',1.76),('6449','2012-12-26','15:05:00',1.44),('6449','2012-12-26','15:10:00',1.32),('6449','2012-12-26','15:15:00',1.26),('6449','2012-12-26','15:20:00',1.1),('6449','2012-12-26','15:25:00',1.1),('6449','2012-12-26','15:45:00',1.01),('6449','2012-12-25','09:00:00',1.07),('6449','2012-12-25','09:05:00',1.25),('6449','2012-12-25','09:10:00',1.25),('6449','2012-12-25','09:15:00',1.4),('6449','2012-12-25','09:20:00',1.39),('6449','2012-12-25','09:25:00',1.38),('6449','2012-12-25','09:30:00',1.51),('6449','2012-12-25','09:35:00',1.68),('6449','2012-12-25','09:40:00',1.72),('6449','2012-12-25','09:45:00',1.78),('6449','2012-12-25','09:50:00',2.02),('6449','2012-12-25','09:55:00',1.85),('6449','2012-12-25','10:00:00',1.76),('6449','2012-12-25','10:05:00',1.85),('6449','2012-12-25','10:10:00',2.01),('6449','2012-12-25','10:15:00',2.11),('6449','2012-12-25','10:20:00',2.13),('6449','2012-12-25','10:25:00',2.13),('6449','2012-12-25','10:30:00',2.18),('6449','2012-12-25','10:35:00',2.38),('6449','2012-12-25','10:40:00',2.35),('6449','2012-12-25','10:45:00',2.23),('6449','2012-12-25','10:50:00',2.17),('6449','2012-12-25','10:55:00',2.05),('6449','2012-12-25','11:00:00',2.07),('6449','2012-12-25','11:05:00',2.26),('6449','2012-12-25','11:10:00',2.2),('6449','2012-12-25','11:15:00',2.23),('6449','2012-12-25','11:20:00',2.08),('6449','2012-12-25','11:25:00',2.41),('6449','2012-12-25','11:30:00',2.94),('6449','2012-12-25','11:35:00',2.89),('6449','2012-12-25','11:40:00',2.84),('6449','2012-12-25','11:45:00',2.82),('6449','2012-12-25','11:50:00',2.77),('6449','2012-12-25','11:55:00',2.8),('6449','2012-12-25','12:00:00',2.95),('6449','2012-12-25','12:05:00',3.06),('6449','2012-12-25','12:10:00',2.92),('6449','2012-12-25','12:15:00',2.51),('6449','2012-12-25','12:20:00',2.27),('6449','2012-12-25','12:25:00',2.39),('6449','2012-12-25','12:30:00',2.67),('6449','2012-12-25','12:35:00',3.02),('6449','2012-12-25','12:40:00',3.42),('6449','2012-12-25','12:45:00',4.96),('6449','2012-12-25','12:50:00',6.69),('6449','2012-12-25','12:55:00',6.47),('6449','2012-12-25','13:00:00',4.57),('6449','2012-12-25','13:05:00',3.99),('6449','2012-12-25','13:10:00',3.09),('6449','2012-12-25','13:15:00',3.05),('6449','2012-12-25','13:20:00',3.55),('6449','2012-12-25','13:25:00',3.51),('6449','2012-12-25','13:30:00',3.3),('6449','2012-12-25','13:35:00',3.32),('6449','2012-12-25','13:40:00',2.49),('6449','2012-12-25','13:45:00',3.08),('6449','2012-12-25','13:50:00',2.57),('6449','2012-12-25','13:55:00',2.36),('6449','2012-12-25','14:00:00',2.04),('6449','2012-12-25','14:05:00',2.11),('6449','2012-12-25','14:10:00',2.69),('6449','2012-12-25','14:15:00',3.37),('6449','2012-12-25','14:20:00',3.24),('6449','2012-12-25','14:25:00',2.4),('6449','2012-12-25','14:30:00',2.22),('6449','2012-12-25','14:35:00',2.33),('6449','2012-12-25','14:40:00',2.04),('6449','2012-12-25','14:45:00',1.48),('6449','2012-12-25','14:50:00',1.68),('6449','2012-12-25','14:55:00',1.85),('6449','2012-12-25','15:00:00',1.96),('6449','2012-12-25','15:05:00',1.96),('6449','2012-12-25','15:10:00',2.2),('6449','2012-12-25','15:15:00',2.71),('6449','2012-12-25','15:20:00',2.82),('6449','2012-12-25','15:25:00',2.37),('6449','2012-12-25','15:30:00',1.98),('6449','2012-12-25','15:35:00',1.95),('6449','2012-12-25','15:40:00',1.72),('6449','2012-12-25','15:45:00',1.68),('6449','2012-12-25','15:50:00',1.43),('6449','2012-12-25','15:55:00',1.16),('6449','2012-12-24','09:35:00',1),('6449','2012-12-24','10:00:00',1.13),('6449','2012-12-24','10:05:00',1.22),('6449','2012-12-24','10:10:00',1.18),('6449','2012-12-24','10:15:00',1.14),('6449','2012-12-24','10:20:00',1.12),('6449','2012-12-24','10:25:00',1.06),('6449','2012-12-24','10:30:00',1.23),('6449','2012-12-24','10:35:00',1.73),('6449','2012-12-24','10:42:00',1.83),('6449','2012-12-24','10:45:00',1.96),('6449','2012-12-24','10:50:00',2),('6449','2012-12-24','10:55:00',2.15),('6449','2012-12-24','11:00:00',2.2),('6449','2012-12-24','11:05:00',2.27),('6449','2012-12-24','11:10:00',2.34),('6449','2012-12-24','11:15:00',2.24),('6449','2012-12-24','11:20:00',2.28),('6449','2012-12-24','11:25:00',2.56),('6449','2012-12-24','11:30:00',2.65),('6449','2012-12-24','11:35:00',2.73),('6449','2012-12-24','11:40:00',2.73),('6449','2012-12-24','11:45:00',2.31),('6449','2012-12-24','11:50:00',2.48),('6449','2012-12-24','11:55:00',2.6),('6449','2012-12-24','12:00:00',2.4),('6449','2012-12-24','12:05:00',2.42),('6449','2012-12-24','12:10:00',2.4),('6449','2012-12-24','12:15:00',2.51),('6449','2012-12-24','12:20:00',2.13),('6449','2012-12-24','12:25:00',2.38),('6449','2012-12-24','12:30:00',2.29),('6449','2012-12-24','12:35:00',2.21),('6449','2012-12-24','12:40:00',2.25),('6449','2012-12-24','12:45:00',2.21),('6449','2012-12-24','12:50:00',2.15),('6449','2012-12-24','12:55:00',2.04),('6449','2012-12-24','13:00:00',1.96),('6449','2012-12-24','13:05:00',1.89),('6449','2012-12-24','13:10:00',1.98),('6449','2012-12-24','13:15:00',2.14),('6449','2012-12-24','13:20:00',2.34),('6449','2012-12-24','13:25:00',2.36),('6449','2012-12-24','13:30:00',2.19),('6449','2012-12-24','13:35:00',1.99),('6449','2012-12-24','13:40:00',1.76),('6449','2012-12-24','13:45:00',1.55),('6449','2012-12-24','13:50:00',1.42),('6449','2012-12-24','13:55:00',1.5),('6449','2012-12-24','14:00:00',1.47),('6449','2012-12-24','14:05:00',1.52),('6449','2012-12-24','14:10:00',1.64),('6449','2012-12-24','14:15:00',1.59),('6449','2012-12-24','14:20:00',1.37),('6449','2012-12-24','14:25:00',1.27),('6449','2012-12-24','14:30:00',1.16),('6449','2012-12-24','14:35:00',1),('6449','2012-12-24','15:00:00',1),('6449','2012-12-23','07:55:00',1.15),('6449','2012-12-23','08:00:00',1.53),('6449','2012-12-23','08:05:00',1.87),('6449','2012-12-23','08:10:00',2.23),('6449','2012-12-23','08:15:00',2.46),('6449','2012-12-23','08:20:00',2.73),('6449','2012-12-23','08:25:00',3.09),('6449','2012-12-23','08:30:00',3.47),('6449','2012-12-23','08:35:00',3.78),('6449','2012-12-23','08:40:00',4.06),('6449','2012-12-23','08:45:00',4.32),('6449','2012-12-23','08:50:00',4.68),('6449','2012-12-23','08:55:00',4.9),('6449','2012-12-23','09:00:00',5.11),('6449','2012-12-23','09:05:00',5.23),('6449','2012-12-23','09:10:00',5.5),('6449','2012-12-23','09:15:00',5.58),('6449','2012-12-23','09:20:00',5.85),('6449','2012-12-23','09:25:00',6.08),('6449','2012-12-23','09:30:00',6.41),('6449','2012-12-23','09:35:00',6.83),('6449','2012-12-23','09:40:00',7.22),('6449','2012-12-23','09:45:00',7.31),('6449','2012-12-23','09:50:00',7.46),('6449','2012-12-23','09:55:00',7.85),('6449','2012-12-23','10:00:00',8.16),('6449','2012-12-23','10:05:00',8.48),('6449','2012-12-23','10:10:00',8.6),('6449','2012-12-23','10:15:00',8.86),('6449','2012-12-23','10:20:00',9.06),('6449','2012-12-23','10:25:00',9.13),('6449','2012-12-23','10:30:00',9.37),('6449','2012-12-23','10:35:00',9.49),('6449','2012-12-23','10:40:00',9.35),('6449','2012-12-23','10:45:00',9.78),('6449','2012-12-23','10:50:00',9.91),('6449','2012-12-23','10:55:00',9.85),('6449','2012-12-23','11:00:00',9.9),('6449','2012-12-23','11:05:00',10.26),('6449','2012-12-23','11:10:00',10.09),('6449','2012-12-23','11:15:00',9.91),('6449','2012-12-23','11:20:00',9.48),('6449','2012-12-23','11:25:00',9.83),('6449','2012-12-23','11:30:00',10.5),('6449','2012-12-23','11:35:00',10.61),('6449','2012-12-23','11:40:00',9.71),('6449','2012-12-23','11:45:00',10.7),('6449','2012-12-23','11:50:00',10.66),('6449','2012-12-23','11:55:00',9.83),('6449','2012-12-23','12:00:00',9.19),('6449','2012-12-23','12:05:00',10.57),('6449','2012-12-23','12:10:00',10.53),('6449','2012-12-23','12:15:00',10.38),('6449','2012-12-23','12:20:00',10.01),('6449','2012-12-23','12:25:00',9.76),('6449','2012-12-23','12:30:00',8.83),('6449','2012-12-23','12:35:00',10.31),('6449','2012-12-23','12:40:00',10.24),('6449','2012-12-23','12:45:00',10.4),('6449','2012-12-23','12:50:00',10.15),('6449','2012-12-23','12:55:00',8.25),('6449','2012-12-23','13:00:00',7.47),('6449','2012-12-23','13:05:00',8.14),('6449','2012-12-23','13:10:00',7.81),('6449','2012-12-23','13:15:00',8.72),('6449','2012-12-23','13:20:00',7.14),('6449','2012-12-23','13:25:00',7.54),('6449','2012-12-23','13:30:00',5.66),('6449','2012-12-23','13:35:00',4.07),('6449','2012-12-23','13:40:00',5.3),('6449','2012-12-23','13:45:00',8.44),('6449','2012-12-23','13:50:00',8.51),('6449','2012-12-23','13:55:00',8.04),('6449','2012-12-23','14:00:00',7.08),('6449','2012-12-23','14:05:00',5.44),('6449','2012-12-23','14:10:00',4.38),('6449','2012-12-23','14:15:00',4.04),('6449','2012-12-23','14:20:00',3.65),('6449','2012-12-23','14:25:00',3.57),('6449','2012-12-23','14:30:00',4.78),('6449','2012-12-23','14:36:00',5.81),('6449','2012-12-23','14:40:00',6.47),('6449','2012-12-23','14:45:00',6.57),('6449','2012-12-23','14:50:00',5.99),('6449','2012-12-23','14:56:00',5.82),('6449','2012-12-23','15:00:00',5.22),('6449','2012-12-23','15:05:00',4.63),('6449','2012-12-23','15:10:00',4.58),('6449','2012-12-23','15:15:00',3.36),('6449','2012-12-23','15:20:00',1.68),('6449','2012-12-23','15:25:00',1.4),('6449','2012-12-23','15:30:00',3.14),('6449','2012-12-23','15:35:00',3.25),('6449','2012-12-23','15:40:00',2.99),('6449','2012-12-23','15:45:00',2.66),('6449','2012-12-23','15:50:00',2.2),('6449','2012-12-23','15:55:00',1.81),('6449','2012-12-23','16:00:00',1.29),('6449','2012-12-22','09:45:00',1.11),('6449','2012-12-22','09:50:00',1.3),('6449','2012-12-22','09:55:00',1.49),('6449','2012-12-22','10:00:00',1.72),('6449','2012-12-22','10:05:00',1.83),('6449','2012-12-22','10:10:00',1.85),('6449','2012-12-22','10:15:00',2.02),('6449','2012-12-22','10:20:00',2.19),('6449','2012-12-22','10:25:00',2.72),('6449','2012-12-22','10:30:00',3.36),('6449','2012-12-22','10:35:00',3.02),('6449','2012-12-22','10:40:00',2.75),('6449','2012-12-22','10:45:00',2.53),('6449','2012-12-22','10:50:00',2.96),('6449','2012-12-22','10:55:00',3.26),('6449','2012-12-22','11:00:00',3.45),('6449','2012-12-22','11:05:00',3.77),('6449','2012-12-22','11:10:00',3.69),('6449','2012-12-22','11:15:00',3.7),('6449','2012-12-22','11:20:00',4.02),('6449','2012-12-22','11:25:00',5.91),('6449','2012-12-22','11:30:00',5.92),('6449','2012-12-22','11:35:00',9.38),('6449','2012-12-22','11:40:00',11.68),('6449','2012-12-22','11:45:00',12.33),('6449','2012-12-22','11:50:00',7.42),('6449','2012-12-22','11:55:00',7.59),('6449','2012-12-22','12:00:00',4.91),('6449','2012-12-22','12:05:00',4.97),('6449','2012-12-22','12:10:00',3.38),('6449','2012-12-22','12:15:00',2.54),('6449','2012-12-22','12:20:00',2.61),('6449','2012-12-22','12:25:00',2.46),('6449','2012-12-22','12:30:00',2.18),('6449','2012-12-22','12:35:00',1.85),('6449','2012-12-22','12:40:00',1.88),('6449','2012-12-22','12:45:00',2.13),('6449','2012-12-22','12:50:00',2.3),('6449','2012-12-22','12:55:00',2.5),('6449','2012-12-22','13:00:00',2.85),('6449','2012-12-22','13:05:00',2.97),('6449','2012-12-22','13:10:00',2.76),('6449','2012-12-22','13:15:00',2.34),('6449','2012-12-22','13:20:00',1.82),('6449','2012-12-22','13:25:00',1.38),('6449','2012-12-22','13:30:00',2.31),('6449','2012-12-22','13:35:00',2.97),('6449','2012-12-22','13:40:00',3.66),('6449','2012-12-22','13:45:00',3.67),('6449','2012-12-22','13:50:00',2.39),('6449','2012-12-22','13:55:00',4.16),('6449','2012-12-22','14:00:00',7.99),('6449','2012-12-22','14:05:00',9.22),('6449','2012-12-22','14:10:00',8.49),('6449','2012-12-22','14:15:00',3.93),('6449','2012-12-22','14:20:00',4.38),('6449','2012-12-22','14:25:00',7.47),('6449','2012-12-22','14:30:00',7.3),('6449','2012-12-22','14:35:00',7.37),('6449','2012-12-22','14:40:00',4.65),('6449','2012-12-22','14:45:00',2.46),('6449','2012-12-22','14:50:00',5.19),('6449','2012-12-22','14:55:00',5.23),('6449','2012-12-22','15:00:00',5.08),('6449','2012-12-22','15:05:00',4.48),('6449','2012-12-22','15:10:00',4.43),('6449','2012-12-22','15:15:00',4.18),('6449','2012-12-22','15:20:00',4.01),('6449','2012-12-22','15:25:00',3.61),('6449','2012-12-22','15:30:00',3.27),('6449','2012-12-22','15:35:00',2.97),('6449','2012-12-22','15:40:00',2.65),('6449','2012-12-22','15:45:00',2.28),('6449','2012-12-22','15:50:00',1.98),('6449','2012-12-22','15:55:00',1.73),('6449','2012-12-22','16:00:00',1.51),('6449','2012-12-22','16:05:00',1.29),('6449','2012-12-22','16:10:00',1.05),('7643','2014-05-04','07:10:00',1.64),('7643','2014-05-04','07:15:00',2.36),('7643','2014-05-04','07:20:00',2.6),('7643','2014-05-04','07:25:00',2.84),('7643','2014-05-04','07:30:00',2.16),('7643','2014-05-04','07:35:00',1.49),('7643','2014-05-04','07:40:00',2.08),('7643','2014-05-04','07:45:00',4.14),('7643','2014-05-04','07:50:00',4.78),('7643','2014-05-04','07:55:00',5.19),('7643','2014-05-04','08:00:00',5.6),('7643','2014-05-04','08:05:00',5.96),('7643','2014-05-04','08:10:00',6.36),('7643','2014-05-04','08:15:00',6.85),('7643','2014-05-04','08:20:00',7.2),('7643','2014-05-04','08:25:00',7.61),('7643','2014-05-04','08:30:00',7.99),('7643','2014-05-04','08:35:00',8.4),('7643','2014-05-04','08:40:00',8.82),('7643','2014-05-04','08:45:00',9.17),('7643','2014-05-04','08:50:00',9.46),('7643','2014-05-04','08:55:00',9.71),('7643','2014-05-04','09:00:00',9.92),('7643','2014-05-04','09:05:00',10.18),('7643','2014-05-04','09:10:00',10.54),('7643','2014-05-04','09:15:00',10.86),('7643','2014-05-04','09:20:00',11.11),('7643','2014-05-04','09:25:00',11.46),('7643','2014-05-04','09:30:00',11.85),('7643','2014-05-04','09:35:00',12.11),('7643','2014-05-04','09:40:00',12.53),('7643','2014-05-04','09:45:00',12.8),('7643','2014-05-04','09:50:00',13.15),('7643','2014-05-04','09:55:00',13.41),('7643','2014-05-04','10:00:00',13.67),('7643','2014-05-04','10:05:00',13.83),('7643','2014-05-04','10:10:00',14.04),('7643','2014-05-04','10:15:00',14.12),('7643','2014-05-04','10:20:00',14.23),('7643','2014-05-04','10:25:00',14.45),('7643','2014-05-04','10:30:00',14.59),('7643','2014-05-04','10:35:00',14.83),('7643','2014-05-04','10:40:00',14.9),('7643','2014-05-04','10:45:00',14.97),('7643','2014-05-04','10:50:00',15.24),('7643','2014-05-04','10:55:00',15.46),('7643','2014-05-04','11:00:00',15.65),('7643','2014-05-04','11:05:00',15.67),('7643','2014-05-04','11:10:00',15.78),('7643','2014-05-04','11:15:00',15.95),('7643','2014-05-04','11:20:00',15.95),('7643','2014-05-04','11:25:00',16.05),('7643','2014-05-04','11:30:00',16.07),('7643','2014-05-04','11:35:00',16.16),('7643','2014-05-04','11:40:00',16.43),('7643','2014-05-04','11:45:00',16.59),('7643','2014-05-04','11:50:00',16.72),('7643','2014-05-04','11:55:00',16.91),('7643','2014-05-04','12:00:00',14.77),('7643','2014-05-04','12:05:00',8.64),('7643','2014-05-04','12:10:00',9.43),('7643','2014-05-04','12:15:00',16.9),('7643','2014-05-04','12:20:00',7.99),('7643','2014-05-04','12:25:00',13.72),('7643','2014-05-04','12:30:00',9.3),('7643','2014-05-04','12:35:00',9.69),('7643','2014-05-04','12:40:00',9.43),('7643','2014-05-04','12:45:00',15.48),('7643','2014-05-04','12:50:00',14.16),('7643','2014-05-04','12:55:00',6.84),('7643','2014-05-04','13:00:00',15.31),('7643','2014-05-04','13:05:00',14.83),('7643','2014-05-04','13:10:00',12.59),('7643','2014-05-04','13:15:00',18.13),('7643','2014-05-04','13:20:00',16.26),('7643','2014-05-04','13:25:00',17.29),('7643','2014-05-04','13:30:00',15.09),('7643','2014-05-04','13:35:00',16.12),('7643','2014-05-04','13:40:00',17.57),('7643','2014-05-04','13:45:00',17.36),('7643','2014-05-04','13:50:00',17.41),('7643','2014-05-04','13:55:00',17.25),('7643','2014-05-04','14:00:00',17.32),('7643','2014-05-04','14:05:00',17.88),('7643','2014-05-04','14:10:00',17.44),('7643','2014-05-04','14:15:00',14.32),('7643','2014-05-04','14:20:00',15.95),('7643','2014-05-04','14:25:00',9.45),('7643','2014-05-04','14:30:00',10.3),('7643','2014-05-04','14:35:00',6.21),('7643','2014-05-04','14:40:00',7.7),('7643','2014-05-04','14:45:00',4.82),('7643','2014-05-04','14:50:00',4.78),('7643','2014-05-04','14:55:00',5.9),('7643','2014-05-04','15:00:00',5.84),('7643','2014-05-04','15:05:00',14.25),('7643','2014-05-04','15:10:00',10.52),('7643','2014-05-04','15:15:00',5.46),('7643','2014-05-04','15:20:00',5.75),('7643','2014-05-04','15:25:00',6.71),('7643','2014-05-04','15:30:00',15.63),('7643','2014-05-04','15:35:00',16.4),('7643','2014-05-04','15:40:00',15.57),('7643','2014-05-04','15:45:00',6.18),('7643','2014-05-04','15:50:00',5.57),('7643','2014-05-04','15:55:00',5.24),('7643','2014-05-04','16:00:00',4.27),('7643','2014-05-04','16:05:00',4.89),('7643','2014-05-04','16:10:00',4.99),('7643','2014-05-04','16:15:00',4.85),('7643','2014-05-04','16:20:00',4.93),('7643','2014-05-04','16:25:00',4.36),('7643','2014-05-04','16:30:00',3.83),('7643','2014-05-04','16:35:00',3.27),('7643','2014-05-04','16:40:00',4.76),('7643','2014-05-04','16:45:00',5.86),('7643','2014-05-04','16:50:00',10.87),('7643','2014-05-04','16:55:00',10.59),('7643','2014-05-04','17:00:00',9.93),('7643','2014-05-04','17:05:00',9.54),('7643','2014-05-04','17:10:00',9.66),('7643','2014-05-04','17:15:00',9.35),('7643','2014-05-04','17:20:00',8.85),('7643','2014-05-04','17:25:00',8.3),('7643','2014-05-04','17:30:00',7.63),('7643','2014-05-04','17:35:00',7.28),('7643','2014-05-04','17:40:00',6.81),('7643','2014-05-04','17:45:00',6.39),('7643','2014-05-04','17:50:00',6.04),('7643','2014-05-04','17:55:00',5.76),('7643','2014-05-04','18:00:00',5.34),('7643','2014-05-04','18:05:00',4.95),('7643','2014-05-04','18:10:00',4.6),('7643','2014-05-04','18:15:00',4.2),('7643','2014-05-04','18:20:00',3.89),('7643','2014-05-04','18:25:00',3.55),('7643','2014-05-04','18:30:00',3.22),('7643','2014-05-04','18:35:00',2.91),('7643','2014-05-04','18:40:00',2.57),('7643','2014-05-04','18:45:00',2.21),('7643','2014-05-04','18:50:00',1.83),('7643','2014-05-04','18:55:00',1.53),('7643','2014-05-04','19:00:00',1.33),('7643','2014-05-04','19:05:00',1.11),('7643','2014-04-25','07:30:00',1.04),('7643','2014-04-25','07:35:00',1.06),('7643','2014-04-25','07:40:00',1.17),('7643','2014-04-25','07:45:00',1.46),('7643','2014-04-25','07:50:00',1.75),('7643','2014-04-25','07:55:00',1.92),('7643','2014-04-25','08:00:00',2.08),('7643','2014-04-25','08:05:00',2.28),('7643','2014-04-25','08:10:00',2.48),('7643','2014-04-25','08:15:00',2.48),('7643','2014-04-25','08:20:00',2.6),('7643','2014-04-25','08:25:00',2.71),('7643','2014-04-25','08:30:00',2.53),('7643','2014-04-25','08:35:00',2.78),('7643','2014-04-25','08:40:00',3.09),('7643','2014-04-25','08:45:00',3.36),('7643','2014-04-25','08:50:00',3.45),('7643','2014-04-25','08:55:00',3.18),('7643','2014-04-25','09:00:00',3.3),('7643','2014-04-25','09:05:00',3.61),('7643','2014-04-25','09:10:00',3.11),('7643','2014-04-25','09:15:00',2.85),('7643','2014-04-25','09:20:00',2.98),('7643','2014-04-25','09:25:00',2.96),('7643','2014-04-25','09:30:00',3.05),('7643','2014-04-25','09:35:00',3.37),('7643','2014-04-25','09:40:00',3.59),('7643','2014-04-25','09:45:00',3.13),('7643','2014-04-25','09:50:00',4.04),('7643','2014-04-25','09:55:00',5.38),('7643','2014-04-25','10:00:00',5.18),('7643','2014-04-25','10:05:00',4.77),('7643','2014-04-25','10:10:00',4.72),('7643','2014-04-25','10:15:00',5.09),('7643','2014-04-25','10:20:00',5.62),('7643','2014-04-25','10:25:00',6.16),('7643','2014-04-25','10:30:00',6.95),('7643','2014-04-25','10:35:00',7.63),('7643','2014-04-25','10:40:00',7.58),('7643','2014-04-25','10:45:00',7.93),('7643','2014-04-25','10:50:00',11.27),('7643','2014-04-25','10:55:00',14.12),('7643','2014-04-25','11:00:00',14.08),('7643','2014-04-25','11:05:00',13.61),('7643','2014-04-25','11:10:00',12.44),('7643','2014-04-25','11:15:00',12.78),('7643','2014-04-25','11:20:00',11.62),('7643','2014-04-25','11:25:00',11.25),('7643','2014-04-25','11:30:00',11.89),('7643','2014-04-25','11:35:00',12.02),('7643','2014-04-25','11:40:00',11.57),('7643','2014-04-25','11:45:00',11.86),('7643','2014-04-25','11:50:00',11.82),('7643','2014-04-25','11:55:00',11.09),('7643','2014-04-25','12:00:00',11.53),('7643','2014-04-25','12:05:00',13.47),('7643','2014-04-25','12:10:00',12.07),('7643','2014-04-25','12:15:00',11.48),('7643','2014-04-25','12:20:00',12.09),('7643','2014-04-25','12:25:00',8.48),('7643','2014-04-25','12:30:00',11.67),('7643','2014-04-25','12:35:00',12.9),('7643','2014-04-25','12:40:00',14.02),('7643','2014-04-25','12:45:00',16.16),('7643','2014-04-25','12:50:00',14.79),('7643','2014-04-25','12:55:00',16.86),('7643','2014-04-25','13:00:00',15.65),('7643','2014-04-25','13:05:00',12.05),('7643','2014-04-25','13:10:00',14.82),('7643','2014-04-25','13:15:00',16.32),('7643','2014-04-25','13:20:00',16.96),('7643','2014-04-25','13:25:00',11.7),('7643','2014-04-25','13:30:00',4.98),('7643','2014-04-25','13:35:00',6.29),('7643','2014-04-25','13:40:00',13.04),('7643','2014-04-25','13:45:00',16.96),('7643','2014-04-25','13:50:00',15.67),('7643','2014-04-25','13:55:00',17.26),('7643','2014-04-25','14:00:00',16.08),('7643','2014-04-25','14:05:00',4.36),('7643','2014-04-25','14:10:00',9.8),('7643','2014-04-25','14:15:00',8.2),('7643','2014-04-25','14:20:00',1.91),('7643','2014-04-25','14:25:00',2.91),('7643','2014-04-25','14:30:00',3.14),('7643','2014-04-25','14:35:00',7.78),('7643','2014-04-25','14:40:00',11.59),('7643','2014-04-25','14:45:00',4.89),('7643','2014-04-25','14:50:00',1.94),('7643','2014-04-25','14:55:00',1.22),('7643','2014-04-25','15:00:00',1.89),('7643','2014-04-25','15:05:00',1.02),('7643','2014-04-25','15:10:00',1.74),('7643','2014-04-25','15:15:00',3.62),('7643','2014-04-25','15:20:00',2.96),('7643','2014-04-25','15:25:00',1.57),('7643','2014-04-25','15:30:00',1.33),('7643','2014-04-25','15:35:00',1.53),('7643','2014-04-25','15:40:00',1.37),('7643','2014-04-25','15:45:00',1.1),('7643','2014-04-25','15:50:00',1.38),('7643','2014-04-25','15:55:00',1.33),('7643','2014-04-25','16:00:00',1.6),('7643','2014-04-25','16:05:00',1.49),('7643','2014-04-25','16:10:00',1.36),('7643','2014-04-25','16:35:00',1.09),('7643','2014-04-25','17:30:00',1.28),('7643','2014-04-25','17:35:00',1.92),('7643','2014-04-25','17:40:00',2.7),('7643','2014-04-25','17:45:00',3.38),('7643','2014-04-25','17:50:00',3.41),('7643','2014-04-25','17:55:00',3.21),('7643','2014-04-25','18:00:00',1.99),('7643','2014-04-25','18:05:00',1.45),('7643','2014-04-25','18:10:00',1.27),('7643','2014-04-25','18:15:00',1.14),('7643','2014-04-25','18:20:00',1.2),('7643','2014-04-25','18:25:00',1.57),('7643','2014-04-25','18:30:00',2.12),('7643','2014-04-25','18:35:00',2.6),('7643','2014-04-25','18:40:00',3.04),('7643','2014-04-25','18:45:00',3.02),('7643','2014-04-25','18:50:00',2.3),('7643','2014-04-25','18:55:00',1.55),('7643','2014-01-25','08:00:00',1.43),('7643','2014-01-25','08:05:00',1.78),('7643','2014-01-25','08:10:00',2.68),('7643','2014-01-25','08:15:00',1.55),('7643','2014-01-25','08:20:00',1.08),('7643','2014-01-25','08:25:00',1.1),('7643','2014-01-25','08:30:00',1.3),('7643','2014-01-25','08:35:00',1.22),('7643','2014-01-25','08:40:00',1.69),('7643','2014-01-25','08:45:00',2.07),('7643','2014-01-25','08:50:00',2.13),('7643','2014-01-25','08:55:00',2.3),('7643','2014-01-25','09:00:00',3.26),('7643','2014-01-25','09:05:00',5.3),('7643','2014-01-25','09:10:00',2.94),('7643','2014-01-25','09:15:00',2.2),('7643','2014-01-25','09:20:00',2.06),('7643','2014-01-25','09:25:00',3.2),('7643','2014-01-25','09:30:00',6.2),('7643','2014-01-25','09:35:00',6.89),('7643','2014-01-25','09:40:00',3.13),('7643','2014-01-25','09:45:00',5.02),('7643','2014-01-25','09:50:00',5.89),('7643','2014-01-25','09:55:00',4.15),('7643','2014-01-25','10:00:00',3.11),('7643','2014-01-25','10:05:00',3.28),('7643','2014-01-25','10:10:00',8.03),('7643','2014-01-25','10:15:00',10.15),('7643','2014-01-25','10:20:00',4.65),('7643','2014-01-25','10:25:00',3.85),('7643','2014-01-25','10:30:00',3.45),('7643','2014-01-25','10:35:00',3.01),('7643','2014-01-25','10:40:00',2.51),('7643','2014-01-25','10:45:00',2.75),('7643','2014-01-25','10:50:00',2.9),('7643','2014-01-25','10:55:00',3.34),('7643','2014-01-25','11:00:00',3.03),('7643','2014-01-25','11:05:00',3.06),('7643','2014-01-25','11:10:00',2.64),('7643','2014-01-25','11:15:00',2.64),('7643','2014-01-25','11:20:00',2.61),('7643','2014-01-25','11:25:00',3.64),('7643','2014-01-25','11:30:00',3.14),('7643','2014-01-25','11:35:00',2.73),('7643','2014-01-25','11:40:00',2.75),('7643','2014-01-25','11:45:00',2.46),('7643','2014-01-25','11:50:00',2.08),('7643','2014-01-25','11:55:00',2.12),('7643','2014-01-25','12:00:00',2.11),('7643','2014-01-25','12:05:00',2.28),('7643','2014-01-25','12:10:00',2.92),('7643','2014-01-25','12:15:00',3.98),('7643','2014-01-25','12:20:00',4.36),('7643','2014-01-25','12:25:00',4.75),('7643','2014-01-25','12:30:00',9.22),('7643','2014-01-25','12:35:00',8.66),('7643','2014-01-25','12:40:00',4.86),('7643','2014-01-25','12:45:00',4.11),('7643','2014-01-25','12:50:00',3.59),('7643','2014-01-25','12:55:00',3.35),('7643','2014-01-25','13:00:00',3.6),('7643','2014-01-25','13:05:00',4.11),('7643','2014-01-25','13:10:00',4.58),('7643','2014-01-25','13:15:00',6.11),('7643','2014-01-25','13:20:00',5.81),('7643','2014-01-25','13:25:00',4.54),('7643','2014-01-25','13:30:00',3.37),('7643','2014-01-25','13:35:00',2.77),('7643','2014-01-25','13:40:00',2.41),('7643','2014-01-25','13:45:00',2.36),('7643','2014-01-25','13:50:00',3.16),('7643','2014-01-25','13:55:00',2.34),('7643','2014-01-25','14:00:00',1.8),('7643','2014-01-25','14:05:00',1.96),('7643','2014-01-25','14:10:00',2.38),('7643','2014-01-25','14:15:00',2.39),('7643','2014-01-25','14:20:00',1.72),('7643','2014-01-25','14:25:00',1.14),('7643','2014-01-25','14:35:00',1.29),('7643','2014-01-25','14:40:00',1.75),('7643','2014-01-25','14:45:00',1.81),('7643','2014-01-25','14:50:00',1.83),('7643','2014-01-25','14:55:00',1.87),('7643','2014-01-25','15:00:00',1.83),('7643','2014-01-25','15:05:00',1.57),('7643','2014-01-25','15:10:00',1.29),('7643','2014-01-25','15:15:00',1.21),('7643','2014-01-25','15:20:00',1.79),('7643','2014-01-25','15:25:00',2.89),('7643','2014-01-25','15:30:00',1.61),('7643','2014-01-25','15:40:00',1.75),('7643','2014-01-25','15:45:00',4.64),('7643','2014-01-25','15:50:00',2.69),('7643','2014-01-25','15:55:00',1.34),('7643','2014-01-24','08:15:00',1.12),('7643','2014-01-24','08:20:00',1.6),('7643','2014-01-24','08:25:00',1.5),('7643','2014-01-24','08:30:00',1.25),('7643','2014-01-24','08:35:00',1.42),('7643','2014-01-24','08:40:00',1.69),('7643','2014-01-24','08:45:00',1.45),('7643','2014-01-24','08:50:00',1.46),('7643','2014-01-24','08:55:00',1.97),('7643','2014-01-24','09:00:00',4.32),('7643','2014-01-24','09:05:00',6.97),('7643','2014-01-24','09:10:00',4.61),('7643','2014-01-24','09:15:00',4.5),('7643','2014-01-24','09:20:00',6.43),('7643','2014-01-24','09:25:00',2.92),('7643','2014-01-24','09:30:00',1.68),('7643','2014-01-24','09:35:00',1.84),('7643','2014-01-24','09:40:00',2.48),('7643','2014-01-24','09:45:00',4.49),('7643','2014-01-24','09:50:00',5.52),('7643','2014-01-24','09:55:00',7.96),('7643','2014-01-24','10:00:00',6.44),('7643','2014-01-24','10:05:00',9.08),('7643','2014-01-24','10:10:00',10.94),('7643','2014-01-24','10:15:00',10.96),('7643','2014-01-24','10:20:00',10.99),('7643','2014-01-24','10:25:00',6.86),('7643','2014-01-24','10:30:00',7.05),('7643','2014-01-24','10:35:00',7.43),('7643','2014-01-24','10:40:00',7.37),('7643','2014-01-24','10:45:00',5.63),('7643','2014-01-24','10:50:00',5.26),('7643','2014-01-24','10:55:00',6.07),('7643','2014-01-24','11:00:00',4.5),('7643','2014-01-24','11:05:00',4.24),('7643','2014-01-24','11:10:00',3.61),('7643','2014-01-24','11:15:00',3.29),('7643','2014-01-24','11:20:00',3.74),('7643','2014-01-24','11:25:00',4.44),('7643','2014-01-24','11:30:00',11.5),('7643','2014-01-24','11:35:00',15.53),('7643','2014-01-24','11:40:00',7.65),('7643','2014-01-24','11:45:00',5.33),('7643','2014-01-24','11:50:00',5.81),('7643','2014-01-24','11:55:00',5.84),('7643','2014-01-24','12:00:00',5.88),('7643','2014-01-24','12:05:00',6),('7643','2014-01-24','12:10:00',6.88),('7643','2014-01-24','12:15:00',6.81),('7643','2014-01-24','12:20:00',7.13),('7643','2014-01-24','12:25:00',7.44),('7643','2014-01-24','12:30:00',7.59),('7643','2014-01-24','12:35:00',6.68),('7643','2014-01-24','12:40:00',6.96),('7643','2014-01-24','12:45:00',8.13),('7643','2014-01-24','12:50:00',8.85),('7643','2014-01-24','12:55:00',10.33),('7643','2014-01-24','13:00:00',10.29),('7643','2014-01-24','13:05:00',11.48),('7643','2014-01-24','13:10:00',11.63),('7643','2014-01-24','13:15:00',7.66),('7643','2014-01-24','13:20:00',4.18),('7643','2014-01-24','13:25:00',4.24),('7643','2014-01-24','13:30:00',7.61),('7643','2014-01-24','13:35:00',4.38),('7643','2014-01-24','13:40:00',4.15),('7643','2014-01-24','13:45:00',7.46),('7643','2014-01-24','13:50:00',5.36),('7643','2014-01-24','13:55:00',2.58),('7643','2014-01-24','14:00:00',5.61),('7643','2014-01-24','14:05:00',7.44),('7643','2014-01-24','14:10:00',8.82),('7643','2014-01-24','14:15:00',7.51),('7643','2014-01-24','14:20:00',9.43),('7643','2014-01-24','14:25:00',9.3),('7643','2014-01-24','14:30:00',10.61),('7643','2014-01-24','14:35:00',9.04),('7643','2014-01-24','14:40:00',9.97),('7643','2014-01-24','14:45:00',10.09),('7643','2014-01-24','14:50:00',9.58),('7643','2014-01-24','14:55:00',8.83),('7643','2014-01-24','15:00:00',7.91),('7643','2014-01-24','15:05:00',7.31),('7643','2014-01-24','15:10:00',6.84),('7643','2014-01-24','15:15:00',6.45),('7643','2014-01-24','15:20:00',6.1),('7643','2014-01-24','15:25:00',5.76),('7643','2014-01-24','15:30:00',5.41),('7643','2014-01-24','15:35:00',5.03),('7643','2014-01-24','15:40:00',4.66),('7643','2014-01-24','15:45:00',4.34),('7643','2014-01-24','15:50:00',4),('7643','2014-01-24','15:55:00',3.7),('7643','2014-01-24','16:00:00',3.37),('7643','2014-01-24','16:05:00',3.07),('7643','2014-01-24','16:10:00',2.73),('7643','2014-01-24','16:15:00',2.4),('7643','2014-01-24','16:20:00',2.1),('7643','2014-01-24','16:25:00',1.79),('7643','2014-01-24','16:30:00',1.51),('7643','2014-01-24','16:35:00',1.23),('7643','2014-01-23','09:50:00',1.08),('7643','2014-01-23','09:55:00',1.34),('7643','2014-01-23','10:00:00',1.6),('7643','2014-01-23','10:05:00',3.36),('7643','2014-01-23','10:10:00',4.34),('7643','2014-01-23','10:15:00',5.41),('7643','2014-01-23','10:20:00',3.37),('7643','2014-01-23','10:25:00',2.48),('7643','2014-01-23','10:30:00',5.18),('7643','2014-01-23','10:35:00',4.69),('7643','2014-01-23','10:40:00',6.76),('7643','2014-01-23','10:45:00',6.47),('7643','2014-01-23','10:50:00',3.77),('7643','2014-01-23','10:55:00',3.7),('7643','2014-01-23','11:00:00',3.66),('7643','2014-01-23','11:05:00',2.9),('7643','2014-01-23','11:10:00',1.75),('7643','2014-01-23','11:20:00',2.08),('7643','2014-01-23','11:25:00',3.64),('7643','2014-01-23','11:30:00',4.47),('7643','2014-01-23','11:35:00',4.48),('7643','2014-01-23','11:40:00',2.21),('7643','2014-01-23','11:45:00',5.35),('7643','2014-01-23','11:50:00',11.56),('7643','2014-01-23','11:55:00',13.03),('7643','2014-01-23','12:00:00',9.49),('7643','2014-01-23','12:05:00',7.84),('7643','2014-01-23','12:10:00',3.02),('7643','2014-01-23','12:15:00',1.87),('7643','2014-01-23','12:20:00',3.58),('7643','2014-01-23','12:25:00',5.29),('7643','2014-01-23','12:30:00',4.19),('7643','2014-01-23','12:35:00',10.38),('7643','2014-01-23','12:40:00',9.16),('7643','2014-01-23','12:45:00',7.57),('7643','2014-01-23','12:50:00',4.9),('7643','2014-01-23','12:55:00',4.51),('7643','2014-01-23','13:00:00',6.78),('7643','2014-01-23','13:05:00',7.6),('7643','2014-01-23','13:10:00',6.12),('7643','2014-01-23','13:15:00',5.87),('7643','2014-01-23','13:20:00',4.29),('7643','2014-01-23','13:25:00',3.03),('7643','2014-01-23','13:30:00',5.48),('7643','2014-01-23','13:35:00',5.8),('7643','2014-01-23','13:40:00',5.8),('7643','2014-01-23','13:45:00',8.05),('7643','2014-01-23','13:50:00',11.92),('7643','2014-01-23','13:55:00',10.66),('7643','2014-01-23','14:00:00',9.39),('7643','2014-01-23','14:05:00',1.77),('7643','2014-01-23','14:10:00',11.53),('7643','2014-01-23','14:15:00',10.27),('7643','2014-01-23','14:20:00',9.48),('7643','2014-01-23','14:25:00',8.88),('7643','2014-01-23','14:30:00',2.39),('7643','2014-01-23','14:35:00',1.83),('7643','2014-01-23','14:40:00',2.17),('7643','2014-01-23','14:45:00',3.11),('7643','2014-01-23','14:50:00',1.57),('7643','2014-01-23','15:15:00',1.14),('7643','2014-01-22','09:50:00',1.12),('7643','2014-01-22','09:55:00',1.06),('7643','2014-01-22','10:10:00',1.61),('7643','2014-01-22','10:15:00',2.55),('7643','2014-01-22','10:20:00',2.53),('7643','2014-01-22','10:25:00',2.6),('7643','2014-01-22','10:30:00',2.08),('7643','2014-01-22','10:35:00',1.72),('7643','2014-01-22','10:40:00',1.99),('7643','2014-01-22','10:45:00',2.12),('7643','2014-01-22','10:50:00',2.69),('7643','2014-01-22','10:55:00',3.19),('7643','2014-01-22','11:00:00',3.7),('7643','2014-01-22','11:05:00',3.69),('7643','2014-01-22','11:10:00',3.9),('7643','2014-01-22','11:15:00',3.95),('7643','2014-01-22','11:20:00',3.46),('7643','2014-01-22','11:25:00',3.09),('7643','2014-01-22','11:30:00',2.2),('7643','2014-01-22','11:35:00',1.69),('7643','2014-01-22','11:40:00',1.13),('7643','2014-01-22','11:55:00',1.03),('7643','2014-01-22','12:00:00',1.29),('7643','2014-01-22','12:05:00',1.96),('7643','2014-01-22','12:10:00',2.92),('7643','2014-01-22','12:15:00',2.07),('7643','2014-01-22','12:20:00',1.85),('7643','2014-01-22','12:25:00',2.55),('7643','2014-01-22','12:30:00',3.63),('7643','2014-01-22','12:35:00',3.01),('7643','2014-01-22','12:40:00',1.85),('7643','2014-01-22','12:45:00',1.13),('7643','2014-01-22','13:15:00',1.08),('7643','2014-01-22','13:20:00',1.25),('7643','2014-01-22','13:25:00',1.14),('7643','2014-01-22','13:40:00',1.01),('7643','2014-01-22','13:45:00',1.21),('7643','2014-01-22','13:50:00',1.46),('7643','2014-01-22','13:55:00',1.5),('7643','2014-01-22','14:00:00',1.65),('7643','2014-01-22','14:05:00',2.23),('7643','2014-01-22','14:10:00',2.6),('7643','2014-01-22','14:15:00',2.75),('7643','2014-01-22','14:20:00',2.39),('7643','2014-01-22','14:25:00',1.97),('7643','2014-01-22','14:30:00',1.54),('7643','2014-01-22','14:35:00',1.04),('7643','2014-01-21','09:45:00',1.2),('7643','2014-01-21','09:50:00',1.09),('7643','2014-01-21','10:05:00',1.43),('7643','2014-01-21','10:10:00',1.74),('7643','2014-01-21','10:15:00',3.04),('7643','2014-01-21','10:20:00',2.76),('7643','2014-01-21','10:25:00',1.46),('7643','2014-01-21','10:30:00',1.56),('7643','2014-01-21','10:35:00',1.71),('7643','2014-01-21','10:40:00',1.99),('7643','2014-01-21','10:45:00',2.62),('7643','2014-01-21','10:50:00',2.7),('7643','2014-01-21','10:55:00',2.69),('7643','2014-01-21','11:00:00',3.14),('7643','2014-01-21','11:05:00',3.54),('7643','2014-01-21','11:10:00',3.58),('7643','2014-01-21','11:15:00',3.22),('7643','2014-01-21','11:20:00',3.34),('7643','2014-01-21','11:25:00',3.22),('7643','2014-01-21','11:30:00',2.42),('7643','2014-01-21','11:35:00',2.03),('7643','2014-01-21','11:40:00',2.98),('7643','2014-01-21','11:45:00',3.02),('7643','2014-01-21','11:50:00',2.38),('7643','2014-01-21','11:55:00',2.68),('7643','2014-01-21','12:00:00',2.82),('7643','2014-01-21','12:05:00',2.86),('7643','2014-01-21','12:10:00',2.45),('7643','2014-01-21','12:15:00',1.55),('7643','2014-01-21','12:20:00',1.36),('7643','2014-01-21','12:25:00',1.22),('7643','2014-01-21','12:30:00',1.36),('7643','2014-01-21','12:35:00',1.96),('7643','2014-01-21','12:40:00',2.18),('7643','2014-01-21','12:45:00',2.39),('7643','2014-01-21','12:50:00',2.9),('7643','2014-01-21','12:55:00',3.49),('7643','2014-01-21','13:00:00',3.31),('7643','2014-01-21','13:05:00',3.1),('7643','2014-01-21','13:10:00',3.59),('7643','2014-01-21','13:15:00',4.82),('7643','2014-01-21','13:20:00',5.04),('7643','2014-01-21','13:25:00',2.8),('7643','2014-01-21','13:30:00',2.16),('7643','2014-01-21','13:35:00',1.79),('7643','2014-01-21','13:40:00',2.15),('7643','2014-01-21','13:45:00',2.13),('7643','2014-01-21','13:50:00',2.08),('7643','2014-01-21','13:55:00',2.61),('7643','2014-01-21','14:00:00',2.47),('7643','2014-01-21','14:05:00',2.1),('7643','2014-01-21','14:10:00',2.46),('7643','2014-01-21','14:15:00',2.38),('7643','2014-01-21','14:20:00',2.17),('7643','2014-01-21','14:25:00',2.08),('7643','2014-01-21','14:30:00',2.03),('7643','2014-01-21','14:35:00',1.94),('7643','2014-01-21','14:40:00',1.46),('7643','2014-01-21','14:45:00',1.5),('7643','2014-01-21','14:50:00',1.64),('7643','2014-01-21','14:55:00',1.71),('7643','2014-01-21','15:00:00',1.98),('7643','2014-01-21','15:05:00',2.25),('7643','2014-01-21','15:10:00',1.95),('7643','2014-01-21','15:15:00',1.42),('7643','2014-01-21','15:20:00',1.27),('7643','2014-01-21','15:25:00',1.39),('7643','2014-01-21','15:30:00',1.43),('7643','2014-01-21','15:35:00',1.04),('7643','2014-01-21','15:40:00',1.18),('7643','2014-01-21','15:45:00',1.61),('7643','2014-01-21','15:50:00',1.78),('7643','2014-01-21','15:55:00',1.21),('7643','2014-01-21','16:00:00',1.25),('7643','2014-01-21','16:05:00',2.78),('7643','2014-01-21','16:10:00',3.16),('7643','2014-01-21','16:15:00',3.17),('7643','2014-01-21','16:20:00',1.59),('7643','2014-01-21','16:25:00',1.09),('7643','2014-01-21','16:35:00',1.07),('7643','2014-01-20','09:00:00',1.07),('7643','2014-01-20','09:05:00',1.33),('7643','2014-01-20','09:10:00',1.49),('7643','2014-01-20','09:15:00',1.89),('7643','2014-01-20','09:20:00',1.26),('7643','2014-01-20','09:25:00',1.07),('7643','2014-01-20','09:30:00',1.25),('7643','2014-01-20','09:35:00',2.31),('7643','2014-01-20','09:40:00',2.74),('7643','2014-01-20','09:45:00',1.65),('7643','2014-01-20','09:50:00',2.06),('7643','2014-01-20','09:55:00',3.03),('7643','2014-01-20','10:00:00',3.83),('7643','2014-01-20','10:05:00',4.77),('7643','2014-01-20','10:10:00',1.74),('7643','2014-01-20','10:15:00',1.52),('7643','2014-01-20','10:20:00',1.26),('7643','2014-01-20','10:25:00',1.11),('7643','2014-01-20','10:30:00',1.43),('7643','2014-01-20','10:35:00',2.36),('7643','2014-01-20','10:40:00',2.81),('7643','2014-01-20','10:45:00',2.06),('7643','2014-01-20','10:50:00',1.86),('7643','2014-01-20','10:55:00',5.75),('7643','2014-01-20','11:00:00',7.72),('7643','2014-01-20','11:05:00',3.46),('7643','2014-01-20','11:10:00',1.03),('7643','2014-01-20','11:15:00',1.74),('7643','2014-01-20','11:20:00',2.96),('7643','2014-01-20','11:25:00',1.77),('7643','2014-01-20','11:30:00',2.9),('7643','2014-01-20','11:35:00',2.2),('7643','2014-01-20','11:40:00',1.88),('7643','2014-01-20','11:45:00',1.84),('7643','2014-01-20','11:50:00',3.01),('7643','2014-01-20','11:55:00',4.14),('7643','2014-01-20','12:00:00',3.58),('7643','2014-01-20','12:05:00',5.61),('7643','2014-01-20','12:10:00',7.29),('7643','2014-01-20','12:15:00',4.99),('7643','2014-01-20','12:20:00',3.67),('7643','2014-01-20','12:25:00',4.91),('7643','2014-01-20','12:30:00',7.04),('7643','2014-01-20','12:35:00',5.89),('7643','2014-01-20','12:40:00',5.53),('7643','2014-01-20','12:45:00',4.97),('7643','2014-01-20','12:50:00',6.85),('7643','2014-01-20','12:55:00',3.73),('7643','2014-01-20','13:00:00',1.74),('7643','2014-01-20','13:05:00',1.52),('7643','2014-01-20','13:10:00',1.91),('7643','2014-01-20','13:15:00',2.94),('7643','2014-01-20','13:20:00',4.12),('7643','2014-01-20','13:25:00',2.21),('7643','2014-01-20','13:30:00',1.2),('7643','2014-01-20','13:35:00',1.29),('7643','2014-01-20','13:40:00',1.38),('7643','2014-01-20','13:45:00',1.07),('7643','2014-01-20','13:50:00',1.41),('7643','2014-01-20','13:55:00',2.02),('7643','2014-01-20','14:00:00',3.52),('7643','2014-01-20','14:05:00',5.11),('7643','2014-01-20','14:10:00',4.78),('7643','2014-01-20','14:15:00',3.9),('7643','2014-01-20','14:20:00',2.86),('7643','2014-01-20','14:25:00',1.92),('7643','2014-01-20','14:30:00',1.56),('7643','2014-01-20','14:35:00',1.32),('7643','2014-01-20','14:40:00',1.03),('7643','2014-01-20','15:00:00',1.12),('7643','2014-01-20','15:05:00',1.55),('7643','2014-01-20','15:10:00',2.13),('7643','2014-01-20','15:15:00',2.24),('7643','2014-01-20','15:20:00',1.63),('7643','2014-01-20','15:25:00',2.03),('7643','2014-01-20','15:30:00',2.25),('7643','2014-01-20','15:35:00',3.11),('7643','2014-01-20','15:40:00',3.8),('7643','2014-01-20','15:45:00',1.92),('7643','2014-01-20','15:50:00',1.28),('7643','2014-01-20','16:30:00',1.18),('7643','2014-01-19','08:25:00',1.16),('7643','2014-01-19','10:45:00',1.27),('7643','2014-01-19','10:50:00',2),('7643','2014-01-19','11:10:00',1.61),('7643','2014-01-19','11:15:00',3.33),('7643','2014-01-19','11:20:00',5.62),('7643','2014-01-19','11:25:00',7.18),('7643','2014-01-19','11:30:00',7.42),('7643','2014-01-19','11:35:00',7.63),('7643','2014-01-19','11:40:00',11.87),('7643','2014-01-19','11:45:00',11.35),('7643','2014-01-19','11:50:00',7.22),('7643','2014-01-19','11:55:00',3.62),('7643','2014-01-19','12:00:00',2.91),('7643','2014-01-19','12:05:00',2.15),('7643','2014-01-19','12:10:00',1.87),('7643','2014-01-19','12:15:00',2.1),('7643','2014-01-19','12:20:00',2.27),('7643','2014-01-19','12:25:00',5.14),('7643','2014-01-19','12:30:00',4.37),('7643','2014-01-19','12:35:00',2.94),('7643','2014-01-19','12:40:00',1.53),('7643','2014-01-19','12:45:00',1.66),('7643','2014-01-19','13:00:00',1.3),('7643','2014-01-19','13:05:00',2.03),('7643','2014-01-19','13:10:00',2.22),('7643','2014-01-19','13:15:00',3.81),('7643','2014-01-19','13:20:00',14.17),('7643','2014-01-19','13:25:00',13.03),('7643','2014-01-19','13:30:00',11.66),('7643','2014-01-19','13:35:00',10.98),('7643','2014-01-19','13:40:00',10.38),('7643','2014-01-19','13:45:00',9.12),('7643','2014-01-19','13:50:00',4.37),('7643','2014-01-19','13:55:00',5.51),('7643','2014-01-19','14:00:00',9.3),('7643','2014-01-19','14:05:00',8.1),('7643','2014-01-19','14:10:00',5.69),('7643','2014-01-19','14:15:00',3.93),('7643','2014-01-19','14:20:00',4.51),('7643','2014-01-19','14:25:00',2.75),('7643','2014-01-19','14:30:00',1.55),('7643','2014-01-19','15:00:00',1.37),('7643','2014-01-19','15:05:00',1.29),('7643','2014-01-18','09:50:00',1.15),('7643','2014-01-18','09:55:00',1.02),('7643','2014-01-18','10:00:00',1.07),('7643','2014-01-18','10:05:00',1.19),('7643','2014-01-18','10:10:00',1.08),('7643','2014-01-18','10:15:00',1.68),('7643','2014-01-18','10:20:00',2.05),('7643','2014-01-18','10:25:00',1.9),('7643','2014-01-18','10:30:00',1.79),('7643','2014-01-18','10:35:00',1.76),('7643','2014-01-18','10:40:00',1.8),('7643','2014-01-18','10:45:00',1.66),('7643','2014-01-18','10:50:00',1.46),('7643','2014-01-18','10:55:00',1.46),('7643','2014-01-18','11:00:00',1.87),('7643','2014-01-18','11:05:00',1.99),('7643','2014-01-18','11:10:00',1.32),('7643','2014-01-18','11:15:00',1.08),('7643','2014-01-18','11:20:00',1.47),('7643','2014-01-18','11:25:00',1.51),('7643','2014-01-18','11:30:00',1.01),('7643','2014-01-18','11:35:00',1.61),('7643','2014-01-18','11:40:00',1.84),('7643','2014-01-18','11:45:00',2.5),('7643','2014-01-18','11:50:00',3.25),('7643','2014-01-18','11:55:00',3.36),('7643','2014-01-18','12:00:00',3.71),('7643','2014-01-18','12:05:00',3.87),('7643','2014-01-18','12:10:00',3.71),('7643','2014-01-18','12:15:00',3.11),('7643','2014-01-18','12:20:00',3.37),('7643','2014-01-18','12:25:00',3.38),('7643','2014-01-18','12:30:00',2.03),('7643','2014-01-18','12:35:00',1.49),('7643','2014-01-18','12:40:00',1.81),('7643','2014-01-18','12:45:00',1.66),('7643','2014-01-18','12:50:00',1.81),('7643','2014-01-18','12:55:00',2.12),('7643','2014-01-18','13:00:00',2.71),('7643','2014-01-18','13:05:00',3.64),('7643','2014-01-18','13:10:00',4.04),('7643','2014-01-18','13:15:00',3.55),('7643','2014-01-18','13:20:00',2.84),('7643','2014-01-18','13:25:00',2.5),('7643','2014-01-18','13:30:00',2.42),('7643','2014-01-18','13:35:00',2.26),('7643','2014-01-18','13:40:00',2.03),('7643','2014-01-18','13:45:00',2),('7643','2014-01-18','13:50:00',2.1),('7643','2014-01-18','13:55:00',2.72),('7643','2014-01-18','14:00:00',2.38),('7643','2014-01-18','14:05:00',1.94),('7643','2014-01-18','14:10:00',1.78),('7643','2014-01-18','14:15:00',2.49),('7643','2014-01-18','14:20:00',4.74),('7643','2014-01-18','14:25:00',6.23),('7643','2014-01-18','14:30:00',6.84),('7643','2014-01-18','14:35:00',4.16),('7643','2014-01-18','14:40:00',3.55),('7643','2014-01-18','14:45:00',2.95),('7643','2014-01-18','14:50:00',1.84),('7643','2014-01-18','14:55:00',1.18),('7643','2014-01-18','15:35:00',1.56),('7643','2014-01-18','15:40:00',2.37),('7643','2014-01-18','15:45:00',1.41),('7643','2014-01-18','16:00:00',1.16),('7643','2014-01-18','16:05:00',1.1),('7643','2014-01-18','16:30:00',1.69),('7643','2014-01-18','16:35:00',1.41),('7643','2014-01-17','08:45:00',1.1),('7643','2014-01-17','08:50:00',1.23),('7643','2014-01-17','08:55:00',1.32),('7643','2014-01-17','09:00:00',1.49),('7643','2014-01-17','09:05:00',1.78),('7643','2014-01-17','09:10:00',1.98),('7643','2014-01-17','09:15:00',1.93),('7643','2014-01-17','09:20:00',1.86),('7643','2014-01-17','09:25:00',2.01),('7643','2014-01-17','09:30:00',2.43),('7643','2014-01-17','09:35:00',3.07),('7643','2014-01-17','09:40:00',3.32),('7643','2014-01-17','09:45:00',3.46),('7643','2014-01-17','09:50:00',3.2),('7643','2014-01-17','09:55:00',3.6),('7643','2014-01-17','10:00:00',4.72),('7643','2014-01-17','10:05:00',6.44),('7643','2014-01-17','10:10:00',9.69),('7643','2014-01-17','10:15:00',9.98),('7643','2014-01-17','10:20:00',9.1),('7643','2014-01-17','10:25:00',6.19),('7643','2014-01-17','10:30:00',6.56),('7643','2014-01-17','10:35:00',4.26),('7643','2014-01-17','10:40:00',4.18),('7643','2014-01-17','10:45:00',4.74),('7643','2014-01-17','10:50:00',4.9),('7643','2014-01-17','10:55:00',4.58),('7643','2014-01-17','11:00:00',3.31),('7643','2014-01-17','11:05:00',5.04),('7643','2014-01-17','11:10:00',8.48),('7643','2014-01-17','11:15:00',10.89),('7643','2014-01-17','11:20:00',10.54),('7643','2014-01-17','11:25:00',9.96),('7643','2014-01-17','11:30:00',10.16),('7643','2014-01-17','11:35:00',10.29),('7643','2014-01-17','11:40:00',10.69),('7643','2014-01-17','11:45:00',11.84),('7643','2014-01-17','11:50:00',11.9),('7643','2014-01-17','11:55:00',12.48),('7643','2014-01-17','12:00:00',12.01),('7643','2014-01-17','12:05:00',9.04),('7643','2014-01-17','12:10:00',11.22),('7643','2014-01-17','12:15:00',10.58),('7643','2014-01-17','12:20:00',10.43),('7643','2014-01-17','12:25:00',10.7),('7643','2014-01-17','12:30:00',10.71),('7643','2014-01-17','12:35:00',10.61),('7643','2014-01-17','12:40:00',10.83),('7643','2014-01-17','12:45:00',10.75),('7643','2014-01-17','12:50:00',10.27),('7643','2014-01-17','12:55:00',11.26),('7643','2014-01-17','13:00:00',7.2),('7643','2014-01-17','13:05:00',7.12),('7643','2014-01-17','13:10:00',8.9),('7643','2014-01-17','13:15:00',10.82),('7643','2014-01-17','13:20:00',7.05),('7643','2014-01-17','13:25:00',5.56),('7643','2014-01-17','13:30:00',9.63),('7643','2014-01-17','13:35:00',5.27),('7643','2014-01-17','13:40:00',8.28),('7643','2014-01-17','13:45:00',9.95),('7643','2014-01-17','13:50:00',6.4),('7643','2014-01-17','13:55:00',9.62),('7643','2014-01-17','14:00:00',9.36),('7643','2014-01-17','14:05:00',8.7),('7643','2014-01-17','14:10:00',8.38),('7643','2014-01-17','14:15:00',7.94),('7643','2014-01-17','14:20:00',8.24),('7643','2014-01-17','14:25:00',7.82),('7643','2014-01-17','14:30:00',7.48),('7643','2014-01-17','14:35:00',7.28),('7643','2014-01-17','14:40:00',7),('7643','2014-01-17','14:45:00',6.79),('7643','2014-01-17','14:50:00',6.53),('7643','2014-01-17','14:55:00',4.56),('7643','2014-01-17','15:00:00',1.49),('7643','2014-01-17','15:10:00',1.32),('7643','2014-01-17','15:15:00',2.03),('7643','2014-01-17','15:20:00',2.23),('7643','2014-01-17','15:25:00',2.25),('7643','2014-01-17','15:30:00',2.1),('7643','2014-01-17','15:35:00',2.18),('7643','2014-01-17','15:40:00',1.86),('7643','2014-01-17','15:45:00',1.48),('7643','2014-01-17','15:50:00',1.59),('7643','2014-01-17','15:55:00',2.99),('7643','2014-01-17','16:00:00',2.01),('7643','2014-01-17','16:05:00',2.89),('7643','2014-01-17','16:10:00',2.03),('7643','2014-01-17','16:15:00',1.57),('7643','2014-01-17','16:20:00',1.01),('7643','2014-01-16','08:20:00',1.15),('7643','2014-01-16','08:25:00',1.27),('7643','2014-01-16','08:30:00',2.2),('7643','2014-01-16','08:35:00',2.38),('7643','2014-01-16','08:40:00',2.19),('7643','2014-01-16','08:45:00',1.2),('7643','2014-01-16','08:50:00',3.02),('7643','2014-01-16','08:55:00',3.52),('7643','2014-01-16','09:00:00',4.75),('7643','2014-01-16','09:05:00',4.8),('7643','2014-01-16','09:10:00',4.14),('7643','2014-01-16','09:15:00',3.15),('7643','2014-01-16','09:20:00',5.62),('7643','2014-01-16','09:25:00',6.17),('7643','2014-01-16','09:30:00',6.04),('7643','2014-01-16','09:35:00',6.37),('7643','2014-01-16','09:40:00',7.19),('7643','2014-01-16','09:45:00',6.96),('7643','2014-01-16','09:50:00',3.25),('7643','2014-01-16','09:55:00',1.49),('7643','2014-01-16','10:05:00',1.79),('7643','2014-01-16','10:10:00',2.09),('7643','2014-01-16','10:15:00',1.82),('7643','2014-01-16','10:20:00',1.52),('7643','2014-01-16','10:25:00',1.42),('7643','2014-01-16','10:30:00',1.4),('7643','2014-01-16','10:35:00',1.3),('7643','2014-01-16','10:40:00',1.07),('7643','2014-01-16','10:45:00',1.12),('7643','2014-01-16','10:50:00',1.5),('7643','2014-01-16','10:55:00',1.88),('7643','2014-01-16','11:00:00',1.95),('7643','2014-01-16','11:05:00',1.76),('7643','2014-01-16','11:10:00',1.41),('7643','2014-01-16','11:15:00',1.74),('7643','2014-01-16','11:20:00',2.66),('7643','2014-01-16','11:25:00',5.07),('7643','2014-01-16','11:30:00',8.78),('7643','2014-01-16','11:35:00',7.43),('7643','2014-01-16','11:40:00',5.09),('7643','2014-01-16','11:45:00',2.52),('7643','2014-01-16','11:50:00',3.66),('7643','2014-01-16','11:55:00',5.02),('7643','2014-01-16','12:00:00',4.28),('7643','2014-01-16','12:05:00',7.09),('7643','2014-01-16','12:10:00',6.2),('7643','2014-01-16','12:15:00',3.13),('7643','2014-01-16','12:20:00',3.27),('7643','2014-01-16','12:25:00',3.08),('7643','2014-01-16','12:30:00',2.35),('7643','2014-01-16','12:35:00',2.79),('7643','2014-01-16','12:40:00',3.85),('7643','2014-01-16','12:45:00',3.9),('7643','2014-01-16','12:50:00',2.8),('7643','2014-01-16','12:55:00',2.27),('7643','2014-01-16','13:00:00',1.52),('7643','2014-01-16','13:05:00',1.76),('7643','2014-01-16','13:10:00',2.47),('7643','2014-01-16','13:15:00',2.35),('7643','2014-01-16','13:20:00',2.11),('7643','2014-01-16','13:25:00',1.76),('7643','2014-01-16','13:30:00',1.2),('7643','2014-01-16','13:40:00',1.01),('7643','2014-01-16','13:45:00',1.25),('7643','2014-01-16','13:50:00',1.44),('7643','2014-01-16','13:55:00',1.31),('7643','2014-01-16','14:00:00',1.13),('7643','2014-04-24','07:05:00',1.1),('7643','2014-04-24','07:10:00',1.35),('7643','2014-04-24','07:15:00',1.6),('7643','2014-04-24','07:20:00',1.82),('7643','2014-04-24','07:25:00',2.01),('7643','2014-04-24','07:30:00',2.31),('7643','2014-04-24','07:35:00',2.62),('7643','2014-04-24','07:40:00',2.87),('7643','2014-04-24','07:45:00',3.21),('7643','2014-04-24','07:50:00',3.12),('7643','2014-04-24','07:55:00',4.61),('7643','2014-04-24','08:00:00',4.77),('7643','2014-04-24','08:05:00',4.75),('7643','2014-04-24','08:10:00',5.16),('7643','2014-04-24','08:15:00',5.44),('7643','2014-04-24','08:20:00',5.83),('7643','2014-04-24','08:25:00',6.14),('7643','2014-04-24','08:30:00',6.36),('7643','2014-04-24','08:35:00',6.69),('7643','2014-04-24','08:40:00',6.99),('7643','2014-04-24','08:45:00',7.25),('7643','2014-04-24','08:50:00',7.78),('7643','2014-04-24','08:55:00',8.06),('7643','2014-04-24','09:00:00',9.26),('7643','2014-04-24','09:05:00',9.1),('7643','2014-04-24','09:10:00',10.99),('7643','2014-04-24','09:15:00',11.39),('7643','2014-04-24','09:20:00',9.98),('7643','2014-04-24','09:25:00',12.34),('7643','2014-04-24','09:30:00',11.65),('7643','2014-04-24','09:35:00',5.83),('7643','2014-04-24','09:40:00',4.49),('7643','2014-04-24','09:45:00',5.08),('7643','2014-04-24','09:50:00',4.24),('7643','2014-04-24','09:55:00',4.9),('7643','2014-04-24','10:00:00',6.69),('7643','2014-04-24','10:05:00',4.83),('7643','2014-04-24','10:10:00',4.15),('7643','2014-04-24','10:15:00',4.36),('7643','2014-04-24','10:20:00',4.6),('7643','2014-04-24','10:25:00',4.76),('7643','2014-04-24','10:30:00',4.75),('7643','2014-04-24','10:35:00',6.78),('7643','2014-04-24','10:40:00',6.61),('7643','2014-04-24','10:45:00',12.41),('7643','2014-04-24','10:50:00',13.84),('7643','2014-04-24','10:55:00',11.38),('7643','2014-04-24','11:00:00',13.56),('7643','2014-04-24','11:05:00',11.12),('7643','2014-04-24','11:10:00',13.88),('7643','2014-04-24','11:15:00',12.16),('7643','2014-04-24','11:20:00',15.67),('7643','2014-04-24','11:25:00',8.81),('7643','2014-04-24','11:30:00',12.71),('7643','2014-04-24','11:35:00',11.84),('7643','2014-04-24','11:40:00',5.14),('7643','2014-04-24','11:45:00',6.18),('7643','2014-04-24','11:50:00',5.16),('7643','2014-04-24','11:55:00',5.43),('7643','2014-04-24','12:00:00',6.82),('7643','2014-04-24','12:05:00',11.16),('7643','2014-04-24','12:10:00',9.85),('7643','2014-04-24','12:15:00',5.29),('7643','2014-04-24','12:20:00',12.05),('7643','2014-04-24','12:25:00',13.38),('7643','2014-04-24','12:30:00',17.06),('7643','2014-04-24','12:35:00',14.71),('7643','2014-04-24','12:40:00',17.04),('7643','2014-04-24','12:45:00',17.46),('7643','2014-04-24','12:50:00',13.79),('7643','2014-04-24','12:55:00',5.88),('7643','2014-04-24','13:00:00',7.53),('7643','2014-04-24','13:05:00',14.27),('7643','2014-04-24','13:10:00',4.79),('7643','2014-04-24','13:15:00',14.45),('7643','2014-04-24','13:20:00',6.69),('7643','2014-04-24','13:25:00',9.12),('7643','2014-04-24','13:30:00',4.74),('7643','2014-04-24','13:35:00',4.08),('7643','2014-04-24','13:40:00',4.28),('7643','2014-04-24','13:45:00',9.12),('7643','2014-04-24','13:50:00',4.09),('7643','2014-04-24','13:55:00',5.65),('7643','2014-04-24','14:00:00',5.95),('7643','2014-04-24','14:05:00',5.3),('7643','2014-04-24','14:10:00',4.8),('7643','2014-04-24','14:15:00',4.17),('7643','2014-04-24','14:20:00',12.85),('7643','2014-04-24','14:25:00',18.8),('7643','2014-04-24','14:30:00',13.1),('7643','2014-04-24','14:35:00',15.27),('7643','2014-04-24','14:40:00',13.82),('7643','2014-04-24','14:45:00',15.24),('7643','2014-04-24','14:50:00',15.26),('7643','2014-04-24','14:55:00',15.12),('7643','2014-04-24','15:00:00',14.63),('7643','2014-04-24','15:05:00',14.18),('7643','2014-04-24','15:10:00',14.1),('7643','2014-04-24','15:15:00',13.82),('7643','2014-04-24','15:20:00',13.37),('7643','2014-04-24','15:25:00',13.24),('7643','2014-04-24','15:30:00',12.63),('7643','2014-04-24','15:35:00',13.19),('7643','2014-04-24','15:40:00',12.97),('7643','2014-04-24','15:45:00',12.6),('7643','2014-04-24','15:50:00',12.39),('7643','2014-04-24','15:55:00',12.19),('7643','2014-04-24','16:00:00',12.16),('7643','2014-04-24','16:05:00',11.79),('7643','2014-04-24','16:10:00',11.08),('7643','2014-04-24','16:15:00',10.76),('7643','2014-04-24','16:20:00',10.01),('7643','2014-04-24','16:25:00',10.05),('7643','2014-04-24','16:30:00',10.35),('7643','2014-04-24','16:35:00',10.24),('7643','2014-04-24','16:40:00',10.24),('7643','2014-04-24','16:45:00',9.91),('7643','2014-04-24','16:50:00',9.17),('7643','2014-04-24','16:55:00',7.76),('7643','2014-04-24','17:00:00',7.27),('7643','2014-04-24','17:05:00',8.03),('7643','2014-04-24','17:10:00',7.05),('7643','2014-04-24','17:15:00',7.43),('7643','2014-04-24','17:20:00',5.22),('7643','2014-04-24','17:25:00',3.66),('7643','2014-04-24','17:30:00',3.75),('7643','2014-04-24','17:35:00',3.81),('7643','2014-04-24','17:40:00',3.76),('7643','2014-04-24','17:45:00',3.27),('7643','2014-04-24','17:50:00',2.94),('7643','2014-04-24','17:55:00',2.69),('7643','2014-04-24','18:00:00',2.59),('7643','2014-04-24','18:05:00',2.6),('7643','2014-04-24','18:10:00',2.57),('7643','2014-04-24','18:15:00',2.19),('7643','2014-04-24','18:20:00',2.1),('7643','2014-04-24','18:25:00',2.11),('7643','2014-04-24','18:30:00',1.97),('7643','2014-04-24','18:35:00',1.91),('7643','2014-04-24','18:40:00',1.76),('7643','2014-04-24','18:45:00',1.6),('7643','2014-04-24','18:50:00',1.48),('7643','2014-04-24','18:55:00',1.42),('7643','2014-04-24','19:00:00',1.3),('7643','2014-04-24','19:05:00',1.33),('7643','2014-04-24','19:10:00',1.37),('7643','2014-04-24','19:15:00',1.21),('7643','2014-01-15','08:00:00',1.15),('7643','2014-01-15','08:05:00',1.39),('7643','2014-01-15','08:10:00',1.79),('7643','2014-01-15','08:15:00',2.15),('7643','2014-01-15','08:20:00',2.75),('7643','2014-01-15','08:25:00',3.02),('7643','2014-01-15','08:30:00',2.8),('7643','2014-01-15','08:35:00',3.02),('7643','2014-01-15','08:40:00',3.12),('7643','2014-01-15','08:45:00',2.91),('7643','2014-01-15','08:50:00',2.97),('7643','2014-01-15','08:55:00',2.95),('7643','2014-01-15','09:00:00',3.45),('7643','2014-01-15','09:05:00',3.53),('7643','2014-01-15','09:10:00',4.12),('7643','2014-01-15','09:15:00',4.14),('7643','2014-01-15','09:20:00',5.75),('7643','2014-01-15','09:25:00',6.75),('7643','2014-01-15','09:30:00',7.12),('7643','2014-01-15','09:35:00',7.17),('7643','2014-01-15','09:40:00',7.69),('7643','2014-01-15','09:45:00',7),('7643','2014-01-15','09:50:00',5.28),('7643','2014-01-15','09:55:00',4.16),('7643','2014-01-15','10:00:00',3.58),('7643','2014-01-15','10:05:00',3.74),('7643','2014-01-15','10:10:00',4.19),('7643','2014-01-15','10:15:00',4.84),('7643','2014-01-15','10:20:00',5.12),('7643','2014-01-15','10:25:00',5.49),('7643','2014-01-15','10:30:00',7.65),('7643','2014-01-15','10:35:00',10.11),('7643','2014-01-15','10:40:00',9.73),('7643','2014-01-15','10:45:00',6.9),('7643','2014-01-15','10:50:00',7.3),('7643','2014-01-15','10:55:00',8.21),('7643','2014-01-15','11:00:00',8.13),('7643','2014-01-15','11:05:00',8.15),('7643','2014-01-15','11:10:00',8.43),('7643','2014-01-15','11:15:00',8.44),('7643','2014-01-15','11:20:00',7.57),('7643','2014-01-15','11:25:00',7.78),('7643','2014-01-15','11:30:00',7.01),('7643','2014-01-15','11:35:00',6.9),('7643','2014-01-15','11:40:00',6.69),('7643','2014-01-15','11:45:00',6.32),('7643','2014-01-15','11:50:00',6.69),('7643','2014-01-15','11:55:00',6.38),('7643','2014-01-15','12:00:00',6.46),('7643','2014-01-15','12:05:00',5.21),('7643','2014-01-15','12:10:00',6.44),('7643','2014-01-15','12:15:00',4.82),('7643','2014-01-15','12:20:00',5.36),('7643','2014-01-15','12:25:00',5.47),('7643','2014-01-15','12:30:00',5.49),('7643','2014-01-15','12:35:00',6.89),('7643','2014-01-15','12:40:00',7.24),('7643','2014-01-15','12:45:00',7.45),('7643','2014-01-15','12:50:00',8.17),('7643','2014-01-15','12:55:00',8.39),('7643','2014-01-15','13:00:00',8.49),('7643','2014-01-15','13:05:00',9.01),('7643','2014-01-15','13:10:00',8.63),('7643','2014-01-15','13:15:00',8.33),('7643','2014-01-15','13:20:00',5.86),('7643','2014-01-15','13:25:00',8.59),('7643','2014-01-15','13:30:00',8.54),('7643','2014-01-15','13:35:00',8.57),('7643','2014-01-15','13:40:00',5.52),('7643','2014-01-15','13:45:00',5.03),('7643','2014-01-15','13:50:00',6.7),('7643','2014-01-15','13:55:00',7.22),('7643','2014-01-15','14:00:00',4.17),('7643','2014-01-15','14:05:00',3.97),('7643','2014-01-15','14:10:00',3.85),('7643','2014-01-15','14:15:00',3.25),('7643','2014-01-15','14:20:00',2.79),('7643','2014-01-15','14:25:00',3.31),('7643','2014-01-15','14:30:00',3.58),('7643','2014-01-15','14:35:00',3.37),('7643','2014-01-15','14:40:00',2.91),('7643','2014-01-15','14:45:00',2.71),('7643','2014-01-15','14:50:00',2.93),('7643','2014-01-15','14:55:00',3.27),('7643','2014-01-15','15:00:00',3.14),('7643','2014-01-15','15:05:00',3.58),('7643','2014-01-15','15:10:00',3.62),('7643','2014-01-15','15:15:00',2.45),('7643','2014-01-15','15:20:00',1.76),('7643','2014-01-15','15:25:00',1.38),('7643','2014-01-15','15:30:00',1.19),('7643','2014-01-15','15:35:00',1.12),('7643','2014-01-15','15:40:00',1.02),('7643','2014-01-14','08:30:00',1.1),('7643','2014-01-14','08:35:00',1.26),('7643','2014-01-14','08:40:00',1.5),('7643','2014-01-14','08:45:00',1.68),('7643','2014-01-14','08:50:00',1.83),('7643','2014-01-14','08:55:00',1.97),('7643','2014-01-14','09:00:00',2.02),('7643','2014-01-14','09:05:00',1.9),('7643','2014-01-14','09:10:00',1.64),('7643','2014-01-14','09:15:00',1.53),('7643','2014-01-14','09:20:00',1.66),('7643','2014-01-14','09:25:00',1.84),('7643','2014-01-14','09:30:00',1.82),('7643','2014-01-14','09:35:00',1.9),('7643','2014-01-14','09:40:00',2.22),('7643','2014-01-14','09:45:00',2.27),('7643','2014-01-14','09:50:00',2.06),('7643','2014-01-14','09:55:00',2.28),('7643','2014-01-14','10:00:00',3.18),('7643','2014-01-14','10:05:00',3),('7643','2014-01-14','10:10:00',3.7),('7643','2014-01-14','10:15:00',5.65),('7643','2014-01-14','10:20:00',7.65),('7643','2014-01-14','10:25:00',8.48),('7643','2014-01-14','10:30:00',8.67),('7643','2014-01-14','10:35:00',5.56),('7643','2014-01-14','10:40:00',6.38),('7643','2014-01-14','10:45:00',8.1),('7643','2014-01-14','10:50:00',5.26),('7643','2014-01-14','10:55:00',5.3),('7643','2014-01-14','11:00:00',4.39),('7643','2014-01-14','11:05:00',6.63),('7643','2014-01-14','11:10:00',10.62),('7643','2014-01-14','11:15:00',10.27),('7643','2014-01-14','11:20:00',9.75),('7643','2014-01-14','11:25:00',9.32),('7643','2014-01-14','11:30:00',9.34),('7643','2014-01-14','11:35:00',10.01),('7643','2014-01-14','11:40:00',7.8),('7643','2014-01-14','11:45:00',9.42),('7643','2014-01-14','11:50:00',9.5),('7643','2014-01-14','11:55:00',8.05),('7643','2014-01-14','12:00:00',6.4),('7643','2014-01-14','12:05:00',6.41),('7643','2014-01-14','12:10:00',6.63),('7643','2014-01-14','12:15:00',8.23),('7643','2014-01-14','12:20:00',10.42),('7643','2014-01-14','12:25:00',9.17),('7643','2014-01-14','12:30:00',5.62),('7643','2014-01-14','12:35:00',5.98),('7643','2014-01-14','12:40:00',5.71),('7643','2014-01-14','12:45:00',5.12),('7643','2014-01-14','12:50:00',6.7),('7643','2014-01-14','12:55:00',5.93),('7643','2014-01-14','13:00:00',5.48),('7643','2014-01-14','13:05:00',5.83),('7643','2014-01-14','13:10:00',6.7),('7643','2014-01-14','13:15:00',10.91),('7643','2014-01-14','13:20:00',11.26),('7643','2014-01-14','13:25:00',11.09),('7643','2014-01-14','13:30:00',10.64),('7643','2014-01-14','13:35:00',10.17),('7643','2014-01-14','13:40:00',9.62),('7643','2014-01-14','13:45:00',9.35),('7643','2014-01-14','13:50:00',5.08),('7643','2014-01-14','13:55:00',4.84),('7643','2014-01-14','14:00:00',6.16),('7643','2014-01-14','14:05:00',6.16),('7643','2014-01-14','14:10:00',8.2),('7643','2014-01-14','14:15:00',7.45),('7643','2014-01-14','14:20:00',7.54),('7643','2014-01-14','14:25:00',7.53),('7643','2014-01-14','14:30:00',7.37),('7643','2014-01-14','14:35:00',7.2),('7643','2014-01-14','14:40:00',7.2),('7643','2014-01-14','14:45:00',7.3),('7643','2014-01-14','14:50:00',7.02),('7643','2014-01-14','14:55:00',6.88),('7643','2014-01-14','15:00:00',6.76),('7643','2014-01-14','15:05:00',6.34),('7643','2014-01-14','15:10:00',6.12),('7643','2014-01-14','15:15:00',5.74),('7643','2014-01-14','15:20:00',5.2),('7643','2014-01-14','15:25:00',2.54),('7643','2014-01-14','15:30:00',3.83),('7643','2014-01-14','15:35:00',4.08),('7643','2014-01-14','15:40:00',3.93),('7643','2014-01-14','15:45:00',3.66),('7643','2014-01-14','15:50:00',2.9),('7643','2014-01-14','16:10:00',1.44),('7643','2014-01-14','16:15:00',1.44),('7643','2014-01-14','16:20:00',1.23),('7643','2014-01-13','10:10:00',1.26),('7643','2014-01-13','10:15:00',2.03),('7643','2014-01-13','10:20:00',2.98),('7643','2014-01-13','10:25:00',5.05),('7643','2014-01-13','10:30:00',11.24),('7643','2014-01-13','10:35:00',11.73),('7643','2014-01-13','10:40:00',10.18),('7643','2014-01-13','10:45:00',9.34),('7643','2014-01-13','10:50:00',5.8),('7643','2014-01-13','10:55:00',4.43),('7643','2014-01-13','11:00:00',4.99),('7643','2014-01-13','11:05:00',3.94),('7643','2014-01-13','11:10:00',2.91),('7643','2014-01-13','11:15:00',3.23),('7643','2014-01-13','11:20:00',3.16),('7643','2014-01-13','11:25:00',2.77),('7643','2014-01-13','11:30:00',4.25),('7643','2014-01-13','11:35:00',5.1),('7643','2014-01-13','11:40:00',6.25),('7643','2014-01-13','11:45:00',3.39),('7643','2014-01-13','11:50:00',3.19),('7643','2014-01-13','11:55:00',3),('7643','2014-01-13','12:00:00',2.56),('7643','2014-01-13','12:05:00',1.83),('7643','2014-01-13','12:10:00',1.69),('7643','2014-01-13','13:15:00',1.48),('7643','2014-01-12','08:30:00',1.08),('7643','2014-01-12','08:35:00',1.31),('7643','2014-01-12','08:40:00',1.54),('7643','2014-01-12','08:45:00',1.73),('7643','2014-01-12','08:50:00',1.91),('7643','2014-01-12','08:55:00',2.2),('7643','2014-01-12','09:00:00',2.39),('7643','2014-01-12','09:05:00',2.28),('7643','2014-01-12','09:10:00',3.35),('7643','2014-01-12','09:15:00',4.93),('7643','2014-01-12','09:20:00',5.7),('7643','2014-01-12','09:25:00',5.78),('7643','2014-01-12','09:30:00',5.99),('7643','2014-01-12','09:35:00',6.25),('7643','2014-01-12','09:40:00',6.52),('7643','2014-01-12','09:45:00',6.7),('7643','2014-01-12','09:50:00',6.87),('7643','2014-01-12','09:55:00',7.04),('7643','2014-01-12','10:00:00',7.26),('7643','2014-01-12','10:05:00',7.39),('7643','2014-01-12','10:10:00',7.57),('7643','2014-01-12','10:15:00',7.68),('7643','2014-01-12','10:20:00',7.97),('7643','2014-01-12','10:25:00',8.1),('7643','2014-01-12','10:30:00',8.22),('7643','2014-01-12','10:35:00',8.31),('7643','2014-01-12','10:40:00',8.47),('7643','2014-01-12','10:45:00',8.65),('7643','2014-01-12','10:50:00',8.86),('7643','2014-01-12','10:55:00',9),('7643','2014-01-12','11:00:00',9.06),('7643','2014-01-12','11:05:00',9.1),('7643','2014-01-12','11:10:00',9.16),('7643','2014-01-12','11:15:00',9.36),('7643','2014-01-12','11:20:00',9.44),('7643','2014-01-12','11:25:00',9.44),('7643','2014-01-12','11:30:00',9.4),('7643','2014-01-12','11:35:00',9.43),('7643','2014-01-12','11:40:00',9.53),('7643','2014-01-12','11:45:00',9.55),('7643','2014-01-12','11:50:00',9.49),('7643','2014-01-12','11:55:00',9.53),('7643','2014-01-12','12:00:00',9.33),('7643','2014-01-12','12:05:00',9.35),('7643','2014-01-12','12:10:00',9.38),('7643','2014-01-12','12:15:00',9.34),('7643','2014-01-12','12:20:00',9.41),('7643','2014-01-12','12:25:00',9.38),('7643','2014-01-12','12:30:00',9.36),('7643','2014-01-12','12:35:00',9.39),('7643','2014-01-12','12:40:00',9.23),('7643','2014-01-12','12:45:00',9.13),('7643','2014-01-12','12:50:00',8.9),('7643','2014-01-12','12:55:00',8.65),('7643','2014-01-12','13:00:00',8.75),('7643','2014-01-12','13:05:00',8.79),('7643','2014-01-12','13:10:00',8.69),('7643','2014-01-12','13:15:00',8.53),('7643','2014-01-12','13:20:00',8.47),('7643','2014-01-12','13:25:00',7.8),('7643','2014-01-12','13:30:00',8.44),('7643','2014-01-12','13:35:00',8.19),('7643','2014-01-12','13:40:00',7.69),('7643','2014-01-12','13:45:00',7.76),('7643','2014-01-12','13:50:00',7.61),('7643','2014-01-12','13:55:00',7.66),('7643','2014-01-12','14:00:00',7.62),('7643','2014-01-12','14:05:00',7.43),('7643','2014-01-12','14:10:00',7.01),('7643','2014-01-12','14:15:00',6.96),('7643','2014-01-12','14:20:00',6.91),('7643','2014-01-12','14:25:00',6.77),('7643','2014-01-12','14:30:00',6.43),('7643','2014-01-12','14:35:00',6.31),('7643','2014-01-12','14:40:00',6.17),('7643','2014-01-12','14:45:00',5.9),('7643','2014-01-12','14:50:00',5.56),('7643','2014-01-12','14:55:00',5.32),('7643','2014-01-12','15:00:00',5.1),('7643','2014-01-12','15:05:00',4.94),('7643','2014-01-12','15:10:00',4.67),('7643','2014-01-12','15:15:00',4.39),('7643','2014-01-12','15:20:00',4.12),('7643','2014-01-12','15:25:00',3.85),('7643','2014-01-12','15:30:00',3.54),('7643','2014-01-12','15:35:00',3.23),('7643','2014-01-12','15:40:00',2.95),('7643','2014-01-12','15:45:00',2.66),('7643','2014-01-12','15:50:00',2.39),('7643','2014-01-12','15:55:00',2.12),('7643','2014-01-12','16:00:00',1.87),('7643','2014-01-12','16:05:00',1.64),('7643','2014-01-12','16:10:00',1.38),('7643','2014-01-12','16:15:00',1.15),('7643','2014-01-11','08:40:00',1.11),('7643','2014-01-11','08:45:00',1.05),('7643','2014-01-11','08:50:00',1.32),('7643','2014-01-11','08:55:00',1.61),('7643','2014-01-11','09:00:00',1.64),('7643','2014-01-11','09:05:00',1.46),('7643','2014-01-11','09:10:00',1.46),('7643','2014-01-11','09:15:00',1.67),('7643','2014-01-11','09:20:00',2.04),('7643','2014-01-11','09:25:00',2.32),('7643','2014-01-11','09:30:00',2.46),('7643','2014-01-11','09:35:00',2.43),('7643','2014-01-11','09:40:00',2.87),('7643','2014-01-11','09:45:00',3.22),('7643','2014-01-11','09:50:00',3.61),('7643','2014-01-11','09:55:00',3.56),('7643','2014-01-11','10:00:00',3.41),('7643','2014-01-11','10:05:00',3.19),('7643','2014-01-11','10:10:00',3.21),('7643','2014-01-11','10:15:00',3.45),('7643','2014-01-11','10:20:00',4.04),('7643','2014-01-11','10:25:00',3.98),('7643','2014-01-11','10:30:00',3.93),('7643','2014-01-11','10:35:00',4.43),('7643','2014-01-11','10:40:00',5.23),('7643','2014-01-11','10:45:00',5.07),('7643','2014-01-11','10:50:00',5.42),('7643','2014-01-11','10:55:00',5.8),('7643','2014-01-11','11:00:00',5.8),('7643','2014-01-11','11:05:00',5.72),('7643','2014-01-11','11:10:00',7.17),('7643','2014-01-11','11:15:00',6.31),('7643','2014-01-11','11:20:00',5.66),('7643','2014-01-11','11:25:00',5.63),('7643','2014-01-11','11:30:00',6),('7643','2014-01-11','11:35:00',5.11),('7643','2014-01-11','11:40:00',6.39),('7643','2014-01-11','11:45:00',6.21),('7643','2014-01-11','11:50:00',7.21),('7643','2014-01-11','11:55:00',7.35),('7643','2014-01-11','12:00:00',5.39),('7643','2014-01-11','12:05:00',5.33),('7643','2014-01-11','12:10:00',4.74),('7643','2014-01-11','12:15:00',4.35),('7643','2014-01-11','12:20:00',4.39),('7643','2014-01-11','12:25:00',4.24),('7643','2014-01-11','12:30:00',4.5),('7643','2014-01-11','12:35:00',4.67),('7643','2014-01-11','12:40:00',5.03),('7643','2014-01-11','12:45:00',4.8),('7643','2014-01-11','12:50:00',4.96),('7643','2014-01-11','12:55:00',4.78),('7643','2014-01-11','13:00:00',4.81),('7643','2014-01-11','13:05:00',4.36),('7643','2014-01-11','13:10:00',4.17),('7643','2014-01-11','13:15:00',4.3),('7643','2014-01-11','13:20:00',4.4),('7643','2014-01-11','13:25:00',4.42),('7643','2014-01-11','13:30:00',5.39),('7643','2014-01-11','13:35:00',4.72),('7643','2014-01-11','13:40:00',4.33),('7643','2014-01-11','13:45:00',3.72),('7643','2014-01-11','13:50:00',3.4),('7643','2014-01-11','13:55:00',3.08),('7643','2014-01-11','14:00:00',2.98),('7643','2014-01-11','14:05:00',2.85),('7643','2014-01-11','14:10:00',2.64),('7643','2014-01-11','14:15:00',2.38),('7643','2014-01-11','14:20:00',2.17),('7643','2014-01-11','14:25:00',2.05),('7643','2014-01-11','14:30:00',1.94),('7643','2014-01-11','14:35:00',1.75),('7643','2014-01-11','14:40:00',1.54),('7643','2014-01-11','14:45:00',1.41),('7643','2014-01-11','14:50:00',1.32),('7643','2014-01-11','14:55:00',1.21),('7643','2014-01-11','15:00:00',1.1),('7643','2014-01-11','15:05:00',1),('7643','2014-01-10','08:25:00',1.09),('7643','2014-01-10','08:30:00',1.23),('7643','2014-01-10','08:35:00',1.35),('7643','2014-01-10','08:40:00',1.47),('7643','2014-01-10','08:45:00',1.48),('7643','2014-01-10','08:50:00',1.58),('7643','2014-01-10','08:55:00',1.98),('7643','2014-01-10','09:00:00',1.9),('7643','2014-01-10','09:05:00',1.88),('7643','2014-01-10','09:10:00',2.08),('7643','2014-01-10','09:15:00',2.26),('7643','2014-01-10','09:20:00',2.65),('7643','2014-01-10','09:25:00',3.32),('7643','2014-01-10','09:30:00',2.49),('7643','2014-01-10','09:35:00',2.14),('7643','2014-01-10','09:40:00',2.1),('7643','2014-01-10','09:45:00',2.39),('7643','2014-01-10','09:50:00',3.72),('7643','2014-01-10','09:55:00',5.48),('7643','2014-01-10','10:00:00',6.39),('7643','2014-01-10','10:05:00',5.02),('7643','2014-01-10','10:10:00',4.89),('7643','2014-01-10','10:15:00',5.48),('7643','2014-01-10','10:20:00',5.5),('7643','2014-01-10','10:25:00',6.8),('7643','2014-01-10','10:30:00',6.66),('7643','2014-01-10','10:35:00',6.93),('7643','2014-01-10','10:40:00',8.69),('7643','2014-01-10','10:45:00',9.13),('7643','2014-01-10','10:50:00',9.23),('7643','2014-01-10','10:55:00',9.23),('7643','2014-01-10','11:00:00',9.05),('7643','2014-01-10','11:05:00',8.63),('7643','2014-01-10','11:10:00',9.28),('7643','2014-01-10','11:15:00',8.45),('7643','2014-01-10','11:20:00',7.88),('7643','2014-01-10','11:25:00',8.01),('7643','2014-01-10','11:30:00',7.93),('7643','2014-01-10','11:35:00',6.91),('7643','2014-01-10','11:40:00',6.35),('7643','2014-01-10','11:45:00',6.47),('7643','2014-01-10','11:50:00',7.03),('7643','2014-01-10','11:55:00',7.21),('7643','2014-01-10','12:00:00',7.31),('7643','2014-01-10','12:05:00',8.53),('7643','2014-01-10','12:10:00',7.71),('7643','2014-01-10','12:15:00',7.58),('7643','2014-01-10','12:20:00',7.19),('7643','2014-01-10','12:25:00',6.88),('7643','2014-01-10','12:30:00',6.35),('7643','2014-01-10','12:35:00',5.35),('7643','2014-01-10','12:40:00',5.04),('7643','2014-01-10','12:45:00',5.69),('7643','2014-01-10','12:50:00',7.14),('7643','2014-01-10','12:55:00',7.99),('7643','2014-01-10','13:00:00',7.96),('7643','2014-01-10','13:05:00',7.69),('7643','2014-01-10','13:10:00',7.64),('7643','2014-01-10','13:15:00',8.3),('7643','2014-01-10','13:20:00',6.91),('7643','2014-01-10','13:25:00',5.79),('7643','2014-01-10','13:30:00',5.05),('7643','2014-01-10','13:35:00',5.02),('7643','2014-01-10','13:40:00',4.36),('7643','2014-01-10','13:45:00',4.78),('7643','2014-01-10','13:50:00',3.62),('7643','2014-01-10','13:55:00',3.86),('7643','2014-01-10','14:00:00',5.56),('7643','2014-01-10','14:05:00',5.79),('7643','2014-01-10','14:10:00',5.19),('7643','2014-01-10','14:15:00',3.15),('7643','2014-01-10','14:20:00',2.34),('7643','2014-01-10','14:25:00',2.04),('7643','2014-01-10','14:30:00',2.19),('7643','2014-01-10','14:35:00',2.53),('7643','2014-01-10','14:40:00',2.96),('7643','2014-01-10','14:45:00',3.07),('7643','2014-01-10','14:50:00',2.8),('7643','2014-01-10','14:55:00',2.36),('7643','2014-01-10','15:00:00',2.29),('7643','2014-01-10','15:05:00',2.16),('7643','2014-01-10','15:10:00',2.07),('7643','2014-01-10','15:15:00',2.06),('7643','2014-01-10','15:20:00',1.95),('7643','2014-01-10','15:25:00',1.8),('7643','2014-01-10','15:30:00',1.74),('7643','2014-01-10','15:35:00',1.54),('7643','2014-01-10','15:40:00',1.35),('7643','2014-01-10','15:45:00',1.21),('7643','2014-01-10','15:50:00',1.14),('7643','2014-01-09','08:50:00',1.12),('7643','2014-01-09','08:55:00',1.26),('7643','2014-01-09','09:00:00',1.27),('7643','2014-01-09','09:05:00',1.24),('7643','2014-01-09','09:10:00',1.58),('7643','2014-01-09','09:15:00',1.54),('7643','2014-01-09','09:20:00',1.4),('7643','2014-01-09','09:25:00',1.55),('7643','2014-01-09','09:30:00',1.81),('7643','2014-01-09','09:35:00',1.97),('7643','2014-01-09','09:40:00',1.96),('7643','2014-01-09','09:45:00',1.88),('7643','2014-01-09','09:50:00',1.98),('7643','2014-01-09','09:55:00',2.06),('7643','2014-01-09','10:00:00',2.05),('7643','2014-01-09','10:05:00',1.96),('7643','2014-01-09','10:10:00',1.97),('7643','2014-01-09','10:15:00',2.08),('7643','2014-01-09','10:20:00',2.15),('7643','2014-01-09','10:25:00',2.29),('7643','2014-01-09','10:30:00',2.23),('7643','2014-01-09','10:35:00',2.13),('7643','2014-01-09','10:40:00',2),('7643','2014-01-09','10:45:00',2.08),('7643','2014-01-09','10:50:00',2.26),('7643','2014-01-09','10:55:00',2.27),('7643','2014-01-09','11:00:00',2.36),('7643','2014-01-09','11:05:00',2.56),('7643','2014-01-09','11:10:00',2.56),('7643','2014-01-09','11:15:00',2.19),('7643','2014-01-09','11:20:00',2),('7643','2014-01-09','11:25:00',2.14),('7643','2014-01-09','11:30:00',2.47),('7643','2014-01-09','11:35:00',2.82),('7643','2014-01-09','11:40:00',2.87),('7643','2014-01-09','11:45:00',2.62),('7643','2014-01-09','11:50:00',2.76),('7643','2014-01-09','11:55:00',2.94),('7643','2014-01-09','12:00:00',2.28),('7643','2014-01-09','12:05:00',1.89),('7643','2014-01-09','12:10:00',1.97),('7643','2014-01-09','12:15:00',2.24),('7643','2014-01-09','12:20:00',2.65),('7643','2014-01-09','12:25:00',2.68),('7643','2014-01-09','12:30:00',2.93),('7643','2014-01-09','12:35:00',2.83),('7643','2014-01-09','12:40:00',2.66),('7643','2014-01-09','12:45:00',2.77),('7643','2014-01-09','12:50:00',3.25),('7643','2014-01-09','12:55:00',3.21),('7643','2014-01-09','13:00:00',3.3),('7643','2014-01-09','13:05:00',3.45),('7643','2014-01-09','13:10:00',3.21),('7643','2014-01-09','13:15:00',2.73),('7643','2014-01-09','13:20:00',2.48),('7643','2014-01-09','13:25:00',2.42),('7643','2014-01-09','13:30:00',2.59),('7643','2014-01-09','13:35:00',2.64),('7643','2014-01-09','13:40:00',2.75),('7643','2014-01-09','13:45:00',2.49),('7643','2014-01-09','13:50:00',2.54),('7643','2014-01-09','13:55:00',2.39),('7643','2014-01-09','14:00:00',2),('7643','2014-01-09','14:05:00',1.96),('7643','2014-01-09','14:10:00',1.84),('7643','2014-01-09','14:15:00',1.58),('7643','2014-01-09','14:20:00',1.29),('7643','2014-01-09','14:25:00',1.06),('7643','2014-01-09','14:30:00',1.1),('7643','2014-01-09','14:35:00',1.01),('7643','2014-01-09','14:40:00',1.02),('7643','2014-01-09','14:45:00',1.02),('7643','2014-01-09','14:50:00',1.2),('7643','2014-01-09','14:55:00',1.18),('7643','2014-01-09','15:00:00',1.24),('7643','2014-01-09','15:05:00',1.16),('7643','2014-01-09','15:10:00',1.38),('7643','2014-01-09','15:15:00',1.18),('7643','2014-01-09','15:45:00',1.05),('7643','2014-01-08','08:35:00',1.38),('7643','2014-01-08','08:40:00',1.53),('7643','2014-01-08','08:45:00',1.6),('7643','2014-01-08','08:50:00',1.7),('7643','2014-01-08','08:55:00',2.11),('7643','2014-01-08','09:00:00',2.23),('7643','2014-01-08','09:05:00',2.48),('7643','2014-01-08','09:10:00',3.6),('7643','2014-01-08','09:15:00',4.15),('7643','2014-01-08','09:20:00',4.64),('7643','2014-01-08','09:25:00',3.84),('7643','2014-01-08','09:30:00',6.01),('7643','2014-01-08','09:35:00',6.69),('7643','2014-01-08','09:40:00',6.19),('7643','2014-01-08','09:45:00',6.83),('7643','2014-01-08','09:50:00',6.92),('7643','2014-01-08','09:55:00',7.17),('7643','2014-01-08','10:00:00',7.38),('7643','2014-01-08','10:05:00',7.15),('7643','2014-01-08','10:10:00',5.75),('7643','2014-01-08','10:15:00',6.61),('7643','2014-01-08','10:20:00',6.69),('7643','2014-01-08','10:25:00',7.04),('7643','2014-01-08','10:30:00',7.08),('7643','2014-01-08','10:35:00',7.28),('7643','2014-01-08','10:40:00',7.27),('7643','2014-01-08','10:45:00',7.82),('7643','2014-01-08','10:50:00',7.92),('7643','2014-01-08','10:55:00',5.64),('7643','2014-01-08','11:00:00',4.07),('7643','2014-01-08','11:05:00',3.81),('7643','2014-01-08','11:10:00',4.24),('7643','2014-01-08','11:15:00',4.04),('7643','2014-01-08','11:20:00',4.41),('7643','2014-01-08','11:25:00',4.63),('7643','2014-01-08','11:30:00',4.33),('7643','2014-01-08','11:35:00',4.1),('7643','2014-01-08','11:40:00',4.97),('7643','2014-01-08','11:45:00',5.48),('7643','2014-01-08','11:50:00',4.42),('7643','2014-01-08','11:55:00',3.87),('7643','2014-01-08','12:00:00',3.61),('7643','2014-01-08','12:05:00',3.15),('7643','2014-01-08','12:10:00',2.97),('7643','2014-01-08','12:15:00',3.47),('7643','2014-01-08','12:20:00',3.04),('7643','2014-01-08','12:25:00',3.06),('7643','2014-01-08','12:30:00',3.13),('7643','2014-01-08','12:35:00',3.14),('7643','2014-01-08','12:40:00',3.32),('7643','2014-01-08','12:45:00',3.6),('7643','2014-01-08','12:50:00',3.61),('7643','2014-01-08','12:55:00',2.91),('7643','2014-01-08','13:00:00',2.76),('7643','2014-01-08','13:05:00',2.86),('7643','2014-01-08','13:10:00',3.15),('7643','2014-01-08','13:15:00',3.96),('7643','2014-01-08','13:20:00',3.59),('7643','2014-01-08','13:25:00',3.42),('7643','2014-01-08','13:30:00',3.53),('7643','2014-01-08','13:35:00',3.18),('7643','2014-01-08','13:40:00',2.79),('7643','2014-01-08','13:45:00',2.62),('7643','2014-01-08','13:50:00',2.8),('7643','2014-01-08','13:55:00',2.68),('7643','2014-01-08','14:00:00',2.41),('7643','2014-01-08','14:05:00',2.29),('7643','2014-01-08','14:10:00',2.39),('7643','2014-01-08','14:15:00',2.43),('7643','2014-01-08','14:20:00',2.32),('7643','2014-01-08','14:25:00',2.11),('7643','2014-01-08','14:30:00',2.08),('7643','2014-01-08','14:35:00',2.21),('7643','2014-01-08','14:40:00',2.12),('7643','2014-01-08','14:45:00',2.1),('7643','2014-01-08','14:50:00',1.93),('7643','2014-01-08','14:55:00',1.82),('7643','2014-01-08','15:00:00',1.72),('7643','2014-01-08','15:05:00',1.69),('7643','2014-01-08','15:10:00',1.64),('7643','2014-01-08','15:15:00',1.53),('7643','2014-01-08','15:20:00',1.43),('7643','2014-01-08','15:25:00',1.23),('7643','2014-01-08','15:30:00',1.16),('7643','2014-01-08','15:35:00',1.07),('7643','2014-01-08','15:40:00',1.02),('7643','2014-01-07','08:10:00',1.11),('7643','2014-01-07','08:15:00',1.4),('7643','2014-01-07','08:20:00',1.64),('7643','2014-01-07','08:25:00',2.04),('7643','2014-01-07','08:30:00',2.37),('7643','2014-01-07','08:35:00',2.67),('7643','2014-01-07','08:40:00',2.92),('7643','2014-01-07','08:45:00',3),('7643','2014-01-07','08:50:00',2.79),('7643','2014-01-07','08:55:00',3.64),('7643','2014-01-07','09:00:00',4.03),('7643','2014-01-07','09:05:00',4.29),('7643','2014-01-07','09:10:00',4.66),('7643','2014-01-07','09:15:00',4.97),('7643','2014-01-07','09:20:00',5.16),('7643','2014-01-07','09:25:00',5.44),('7643','2014-01-07','09:30:00',5.54),('7643','2014-01-07','09:35:00',5.66),('7643','2014-01-07','09:40:00',6.22),('7643','2014-01-07','09:45:00',6.53),('7643','2014-01-07','09:50:00',6.6),('7643','2014-01-07','09:55:00',6.84),('7643','2014-01-07','10:00:00',7.03),('7643','2014-01-07','10:05:00',6.88),('7643','2014-01-07','10:10:00',7.19),('7643','2014-01-07','10:15:00',7.48),('7643','2014-01-07','10:20:00',7.83),('7643','2014-01-07','10:25:00',7.96),('7643','2014-01-07','10:30:00',8.41),('7643','2014-01-07','10:35:00',8.07),('7643','2014-01-07','10:40:00',7.87),('7643','2014-01-07','10:45:00',8.52),('7643','2014-01-07','10:50:00',8.76),('7643','2014-01-07','10:55:00',8.95),('7643','2014-01-07','11:00:00',9.07),('7643','2014-01-07','11:05:00',9.2),('7643','2014-01-07','11:10:00',9.39),('7643','2014-01-07','11:15:00',9.48),('7643','2014-01-07','11:20:00',9.52),('7643','2014-01-07','11:25:00',9.38),('7643','2014-01-07','11:30:00',9.43),('7643','2014-01-07','11:35:00',9.87),('7643','2014-01-07','11:40:00',10.05),('7643','2014-01-07','11:45:00',9.92),('7643','2014-01-07','11:50:00',9.88),('7643','2014-01-07','11:55:00',9.69),('7643','2014-01-07','12:00:00',9.69),('7643','2014-01-07','12:05:00',9.54),('7643','2014-01-07','12:10:00',9.67),('7643','2014-01-07','12:15:00',9.58),('7643','2014-01-07','12:20:00',9.61),('7643','2014-01-07','12:25:00',9.6),('7643','2014-01-07','12:30:00',9.58),('7643','2014-01-07','12:35:00',9.29),('7643','2014-01-07','12:40:00',9.43),('7643','2014-01-07','12:45:00',9.01),('7643','2014-01-07','12:50:00',8.73),('7643','2014-01-07','12:55:00',9.15),('7643','2014-01-07','13:00:00',8.96),('7643','2014-01-07','13:05:00',8.86),('7643','2014-01-07','13:10:00',8.88),('7643','2014-01-07','13:15:00',8.71),('7643','2014-01-07','13:20:00',8.63),('7643','2014-01-07','13:25:00',8.37),('7643','2014-01-07','13:30:00',8.22),('7643','2014-01-07','13:35:00',8.1),('7643','2014-01-07','13:40:00',8.1),('7643','2014-01-07','13:45:00',7.64),('7643','2014-01-07','13:50:00',7.67),('7643','2014-01-07','13:55:00',7.57),('7643','2014-01-07','14:00:00',7.4),('7643','2014-01-07','14:05:00',7.24),('7643','2014-01-07','14:10:00',7.06),('7643','2014-01-07','14:15:00',7.02),('7643','2014-01-07','14:20:00',6.96),('7643','2014-01-07','14:25:00',6.83),('7643','2014-01-07','14:30:00',6.84),('7643','2014-01-07','14:35:00',6.66),('7643','2014-01-07','14:40:00',6.07),('7643','2014-01-07','14:45:00',5.73),('7643','2014-01-07','14:50:00',5.53),('7643','2014-01-07','14:55:00',4.75),('7643','2014-01-07','15:00:00',4.12),('7643','2014-01-07','15:05:00',4.26),('7643','2014-01-07','15:10:00',3.41),('7643','2014-01-07','15:15:00',3.68),('7643','2014-01-07','15:20:00',3.95),('7643','2014-01-07','15:25:00',3.82),('7643','2014-01-07','15:30:00',3.38),('7643','2014-01-07','15:35:00',3.14),('7643','2014-01-07','15:40:00',2.84),('7643','2014-01-07','15:45:00',2.65),('7643','2014-01-07','15:50:00',2.26),('7643','2014-01-07','15:55:00',1.78),('7643','2014-01-07','16:00:00',1.59),('7643','2014-01-07','16:05:00',1.27),('7643','2014-01-07','16:10:00',1.17),('7643','2014-01-06','08:05:00',1.14),('7643','2014-01-06','08:10:00',1.41),('7643','2014-01-06','08:15:00',1.67),('7643','2014-01-06','08:20:00',1.95),('7643','2014-01-06','08:25:00',2.22),('7643','2014-01-06','08:30:00',2.54),('7643','2014-01-06','08:35:00',2.85),('7643','2014-01-06','08:40:00',3.17),('7643','2014-01-06','08:45:00',3.5),('7643','2014-01-06','08:50:00',3.79),('7643','2014-01-06','08:55:00',4.1),('7643','2014-01-06','09:00:00',4.42),('7643','2014-01-06','09:05:00',4.74),('7643','2014-01-06','09:10:00',5.03),('7643','2014-01-06','09:15:00',5.32),('7643','2014-01-06','09:20:00',5.65),('7643','2014-01-06','09:25:00',5.91),('7643','2014-01-06','09:30:00',6.23),('7643','2014-01-06','09:35:00',6.47),('7643','2014-01-06','09:40:00',6.74),('7643','2014-01-06','09:45:00',6.95),('7643','2014-01-06','09:50:00',7.16),('7643','2014-01-06','09:55:00',7.35),('7643','2014-01-06','10:00:00',7.57),('7643','2014-01-06','10:05:00',7.77),('7643','2014-01-06','10:10:00',7.99),('7643','2014-01-06','10:15:00',8.14),('7643','2014-01-06','10:20:00',8.28),('7643','2014-01-06','10:25:00',8.44),('7643','2014-01-06','10:30:00',8.54),('7643','2014-01-06','10:35:00',8.75),('7643','2014-01-06','10:40:00',8.82),('7643','2014-01-06','10:45:00',8.97),('7643','2014-01-06','10:50:00',9.06),('7643','2014-01-06','10:55:00',9.22),('7643','2014-01-06','11:00:00',9.44),('7643','2014-01-06','11:05:00',9.54),('7643','2014-01-06','11:10:00',9.61),('7643','2014-01-06','11:15:00',9.65),('7643','2014-01-06','11:20:00',9.75),('7643','2014-01-06','11:25:00',9.79),('7643','2014-01-06','11:30:00',9.8),('7643','2014-01-06','11:35:00',9.92),('7643','2014-01-06','11:40:00',9.98),('7643','2014-01-06','11:45:00',9.99),('7643','2014-01-06','11:50:00',10.03),('7643','2014-01-06','11:55:00',10.12),('7643','2014-01-06','12:00:00',10.06),('7643','2014-01-06','12:05:00',10.13),('7643','2014-01-06','12:10:00',10.16),('7643','2014-01-06','12:15:00',10.11),('7643','2014-01-06','12:20:00',10.05),('7643','2014-01-06','12:25:00',10.04),('7643','2014-01-06','12:30:00',9.98),('7643','2014-01-06','12:35:00',9.93),('7643','2014-01-06','12:40:00',9.49),('7643','2014-01-06','12:45:00',9.38),('7643','2014-01-06','12:50:00',9.5),('7643','2014-01-06','12:55:00',9.72),('7643','2014-01-06','13:00:00',9.28),('7643','2014-01-06','13:05:00',8.93),('7643','2014-01-06','13:10:00',9.04),('7643','2014-01-06','13:15:00',8.95),('7643','2014-01-06','13:20:00',8.5),('7643','2014-01-06','13:25:00',8.39),('7643','2014-01-06','13:30:00',8.11),('7643','2014-01-06','13:35:00',8.11),('7643','2014-01-06','13:40:00',8.21),('7643','2014-01-06','13:45:00',8.4),('7643','2014-01-06','13:50:00',8.36),('7643','2014-01-06','13:55:00',8.04),('7643','2014-01-06','14:00:00',8.04),('7643','2014-01-06','14:05:00',7.7),('7643','2014-01-06','14:10:00',7.39),('7643','2014-01-06','14:15:00',7.26),('7643','2014-01-06','14:20:00',7.2),('7643','2014-01-06','14:25:00',6.84),('7643','2014-01-06','14:30:00',6.59),('7643','2014-01-06','14:35:00',6.42),('7643','2014-01-06','14:40:00',6.43),('7643','2014-01-06','14:45:00',5.96),('7643','2014-01-06','14:50:00',5.9),('7643','2014-01-06','14:55:00',5.72),('7643','2014-01-06','15:00:00',5.41),('7643','2014-01-06','15:05:00',5.31),('7643','2014-01-06','15:10:00',5.09),('7643','2014-01-06','15:15:00',4.76),('7643','2014-01-06','15:20:00',4.46),('7643','2014-01-06','15:25:00',4.04),('7643','2014-01-06','15:30:00',3.58),('7643','2014-01-06','15:35:00',3.12),('7643','2014-01-06','15:40:00',2.47),('7643','2014-01-06','15:45:00',2.35),('7643','2014-01-06','15:50:00',2.18),('7643','2014-01-06','15:55:00',2.01),('7643','2014-01-06','16:00:00',1.62),('7643','2014-01-06','16:05:00',1.45),('7643','2014-01-06','16:10:00',1.57),('7643','2014-04-23','07:05:00',1.04),('7643','2014-04-23','07:10:00',1.28),('7643','2014-04-23','07:15:00',1.55),('7643','2014-04-23','07:20:00',1.84),('7643','2014-04-23','07:25:00',2.13),('7643','2014-04-23','07:30:00',2.43),('7643','2014-04-23','07:35:00',2.76),('7643','2014-04-23','07:40:00',3.14),('7643','2014-04-23','07:45:00',3.47),('7643','2014-04-23','07:50:00',3.85),('7643','2014-04-23','07:55:00',4.21),('7643','2014-04-23','08:00:00',4.59),('7643','2014-04-23','08:05:00',4.93),('7643','2014-04-23','08:10:00',5.29),('7643','2014-04-23','08:15:00',5.64),('7643','2014-04-23','08:20:00',5.99),('7643','2014-04-23','08:25:00',6.33),('7643','2014-04-23','08:30:00',6.65),('7643','2014-04-23','08:35:00',7.01),('7643','2014-04-23','08:40:00',7.33),('7643','2014-04-23','08:45:00',7.67),('7643','2014-04-23','08:50:00',7.99),('7643','2014-04-23','08:55:00',8.29),('7643','2014-04-23','09:00:00',8.67),('7643','2014-04-23','09:05:00',8.93),('7643','2014-04-23','09:10:00',9.15),('7643','2014-04-23','09:15:00',9.44),('7643','2014-04-23','09:20:00',9.76),('7643','2014-04-23','09:25:00',10.07),('7643','2014-04-23','09:30:00',10.29),('7643','2014-04-23','09:35:00',10.58),('7643','2014-04-23','09:40:00',10.79),('7643','2014-04-23','09:45:00',11.03),('7643','2014-04-23','09:50:00',11.3),('7643','2014-04-23','09:55:00',11.54),('7643','2014-04-23','10:00:00',11.71),('7643','2014-04-23','10:05:00',11.91),('7643','2014-04-23','10:10:00',12.03),('7643','2014-04-23','10:15:00',12.25),('7643','2014-04-23','10:20:00',12.43),('7643','2014-04-23','10:25:00',12.64),('7643','2014-04-23','10:30:00',12.87),('7643','2014-04-23','10:35:00',13.12),('7643','2014-04-23','10:40:00',13.31),('7643','2014-04-23','10:45:00',13.48),('7643','2014-04-23','10:50:00',13.75),('7643','2014-04-23','10:55:00',13.78),('7643','2014-04-23','11:00:00',13.94),('7643','2014-04-23','11:05:00',13.83),('7643','2014-04-23','11:10:00',14.09),('7643','2014-04-23','11:15:00',14.19),('7643','2014-04-23','11:20:00',14.32),('7643','2014-04-23','11:25:00',14.41),('7643','2014-04-23','11:30:00',14.44),('7643','2014-04-23','11:35:00',13.72),('7643','2014-04-23','11:40:00',14.74),('7643','2014-04-23','11:45:00',14.93),('7643','2014-04-23','11:50:00',15.02),('7643','2014-04-23','11:55:00',15.22),('7643','2014-04-23','12:00:00',15.28),('7643','2014-04-23','12:05:00',15.45),('7643','2014-04-23','12:10:00',16.1),('7643','2014-04-23','12:15:00',14.03),('7643','2014-04-23','12:20:00',15.68),('7643','2014-04-23','12:25:00',15.24),('7643','2014-04-23','12:30:00',15.55),('7643','2014-04-23','12:35:00',15.8),('7643','2014-04-23','12:40:00',16.12),('7643','2014-04-23','12:45:00',15.82),('7643','2014-04-23','12:50:00',16.31),('7643','2014-04-23','12:55:00',16.27),('7643','2014-04-23','13:00:00',16.04),('7643','2014-04-23','13:05:00',15.86),('7643','2014-04-23','13:10:00',13.32),('7643','2014-04-23','13:15:00',4.82),('7643','2014-04-23','13:20:00',17.18),('7643','2014-04-23','13:25:00',16.7),('7643','2014-04-23','13:30:00',16.82),('7643','2014-04-23','13:35:00',13.26),('7643','2014-04-23','13:40:00',12.66),('7643','2014-04-23','13:45:00',5.69),('7643','2014-04-23','13:50:00',12.99),('7643','2014-04-23','13:55:00',18.67),('7643','2014-04-23','14:00:00',15.54),('7643','2014-04-23','14:05:00',17.33),('7643','2014-04-23','14:10:00',14.97),('7643','2014-04-23','14:15:00',16.68),('7643','2014-04-23','14:20:00',13.1),('7643','2014-04-23','14:25:00',15.23),('7643','2014-04-23','14:30:00',17.31),('7643','2014-04-23','14:35:00',16.32),('7643','2014-04-23','14:40:00',11.55),('7643','2014-04-23','14:45:00',9.43),('7643','2014-04-23','14:50:00',6.02),('7643','2014-04-23','14:55:00',13.61),('7643','2014-04-23','15:00:00',18),('7643','2014-04-23','15:05:00',17.41),('7643','2014-04-23','15:10:00',17.18),('7643','2014-04-23','15:15:00',14.76),('7643','2014-04-23','15:20:00',9.73),('7643','2014-04-23','15:25:00',8.76),('7643','2014-04-23','15:30:00',11.22),('7643','2014-04-23','15:35:00',11.17),('7643','2014-04-23','15:40:00',8.68),('7643','2014-04-23','15:45:00',7.61),('7643','2014-04-23','15:50:00',8.61),('7643','2014-04-23','15:55:00',10.39),('7643','2014-04-23','16:00:00',14.43),('7643','2014-04-23','16:05:00',14.05),('7643','2014-04-23','16:10:00',11.88),('7643','2014-04-23','16:15:00',13.84),('7643','2014-04-23','16:20:00',12.01),('7643','2014-04-23','16:25:00',10.13),('7643','2014-04-23','16:30:00',13.3),('7643','2014-04-23','16:35:00',7.11),('7643','2014-04-23','16:40:00',8.23),('7643','2014-04-23','16:45:00',7.89),('7643','2014-04-23','16:50:00',5.51),('7643','2014-04-23','16:55:00',5.87),('7643','2014-04-23','17:00:00',5.05),('7643','2014-04-23','17:05:00',4.58),('7643','2014-04-23','17:10:00',4.26),('7643','2014-04-23','17:15:00',3.9),('7643','2014-04-23','17:20:00',3.93),('7643','2014-04-23','17:25:00',3.87),('7643','2014-04-23','17:30:00',3.76),('7643','2014-04-23','17:35:00',3.61),('7643','2014-04-23','17:40:00',3.19),('7643','2014-04-23','17:45:00',2.19),('7643','2014-04-23','17:50:00',1.72),('7643','2014-04-23','17:55:00',1.48),('7643','2014-04-23','18:00:00',1.26),('7643','2014-04-23','18:05:00',1.2),('7643','2014-04-23','18:10:00',1.4),('7643','2014-04-23','18:15:00',1.43),('7643','2014-04-23','18:20:00',1.16),('7643','2014-01-05','10:20:00',1.01),('7643','2014-01-05','10:25:00',1.04),('7643','2014-01-05','10:30:00',1.03),('7643','2014-01-05','10:50:00',1.04),('7643','2014-01-05','10:55:00',1.43),('7643','2014-01-05','11:00:00',1.82),('7643','2014-01-05','11:05:00',2.38),('7643','2014-01-05','11:10:00',2.85),('7643','2014-01-05','11:15:00',3.32),('7643','2014-01-05','11:20:00',3.47),('7643','2014-01-05','11:25:00',3.41),('7643','2014-01-05','11:30:00',3),('7643','2014-01-05','11:35:00',5.3),('7643','2014-01-05','11:40:00',10.29),('7643','2014-01-05','11:45:00',10.64),('7643','2014-01-05','11:50:00',7.79),('7643','2014-01-05','11:55:00',7.95),('7643','2014-01-05','12:00:00',4.41),('7643','2014-01-05','12:05:00',9.66),('7643','2014-01-05','12:10:00',10.42),('7643','2014-01-05','12:15:00',10.18),('7643','2014-01-05','12:20:00',10.09),('7643','2014-01-05','12:25:00',10.05),('7643','2014-01-05','12:30:00',9.95),('7643','2014-01-05','12:35:00',9.78),('7643','2014-01-05','12:40:00',9.84),('7643','2014-01-05','12:45:00',9.88),('7643','2014-01-05','12:50:00',9.84),('7643','2014-01-05','12:55:00',9.72),('7643','2014-01-05','13:00:00',9.59),('7643','2014-01-05','13:05:00',9.36),('7643','2014-01-05','13:10:00',9.5),('7643','2014-01-05','13:15:00',9.7),('7643','2014-01-05','13:20:00',9.67),('7643','2014-01-05','13:25:00',9.37),('7643','2014-01-05','13:30:00',8.72),('7643','2014-01-05','13:35:00',8.75),('7643','2014-01-05','13:40:00',8.6),('7643','2014-01-05','13:45:00',8.44),('7643','2014-01-05','13:50:00',8.2),('7643','2014-01-05','13:55:00',8.15),('7643','2014-01-05','14:00:00',5.4),('7643','2014-01-05','14:05:00',1.5),('7643','2014-01-05','14:10:00',1.93),('7643','2014-01-05','14:15:00',2.32),('7643','2014-01-05','14:20:00',7.01),('7643','2014-01-05','14:25:00',3.24),('7643','2014-01-05','14:30:00',2.68),('7643','2014-01-05','14:35:00',3.17),('7643','2014-01-05','14:40:00',7.31),('7643','2014-01-05','14:45:00',7.81),('7643','2014-01-05','14:50:00',5.69),('7643','2014-01-05','14:55:00',2.06),('7643','2014-01-05','15:00:00',3.78),('7643','2014-01-05','15:05:00',4.82),('7643','2014-01-05','15:10:00',4.83),('7643','2014-01-05','15:15:00',4.56),('7643','2014-01-05','15:20:00',4.19),('7643','2014-01-05','15:25:00',3.73),('7643','2014-01-05','15:30:00',3.38),('7643','2014-01-05','15:35:00',3.27),('7643','2014-01-05','15:40:00',3.07),('7643','2014-01-05','15:45:00',2.51),('7643','2014-01-05','15:50:00',2.28),('7643','2014-01-05','15:55:00',1.87),('7643','2014-01-05','16:00:00',1.66),('7643','2014-01-05','16:05:00',1.49),('7643','2014-01-05','16:10:00',1.37),('7643','2014-01-05','16:15:00',1.16),('7643','2014-01-04','08:45:00',1.24),('7643','2014-01-04','08:50:00',1.41),('7643','2014-01-04','08:55:00',1.29),('7643','2014-01-04','09:00:00',1.12),('7643','2014-01-04','09:30:00',1.12),('7643','2014-01-04','11:35:00',1.16),('7643','2014-01-04','11:40:00',1.23),('7643','2014-01-04','11:45:00',1.01),('7643','2014-01-04','11:50:00',1.13),('7643','2014-01-04','12:05:00',1.6),('7643','2014-01-04','12:10:00',1.46),('7643','2014-01-04','12:25:00',1.07),('7643','2014-01-04','12:30:00',1.06),('7643','2014-01-04','12:35:00',1.06),('7643','2014-01-04','12:40:00',1.88),('7643','2014-01-04','12:45:00',1.56),('7643','2014-01-04','12:55:00',1.19),('7643','2014-01-04','13:00:00',1.11),('7643','2014-01-04','13:10:00',1.12),('7643','2014-01-04','13:15:00',1.54),('7643','2014-01-04','13:20:00',2.08),('7643','2014-01-04','13:25:00',1.97),('7643','2014-01-04','13:30:00',2.05),('7643','2014-01-04','13:35:00',1.24),('7643','2014-01-04','13:40:00',1.02),('7643','2014-01-04','13:45:00',1.2),('7643','2014-01-04','13:50:00',1.35),('7643','2014-01-04','13:55:00',1.22),('7643','2014-01-04','14:45:00',1.12),('7643','2014-01-04','14:50:00',1.71),('7643','2014-01-04','14:55:00',1.6),('7643','2014-01-04','15:00:00',1.65),('7643','2014-01-04','15:05:00',1.61),('7643','2014-01-04','15:10:00',2.25),('7643','2014-01-04','15:15:00',2.24),('7643','2014-01-04','15:20:00',1.75),('7643','2014-01-04','15:25:00',1.39),('7643','2014-01-04','15:30:00',1.07),('7643','2014-01-03','09:30:00',1.23),('7643','2014-01-03','09:35:00',1.6),('7643','2014-01-03','09:40:00',1.29),('7643','2014-01-03','09:45:00',1.65),('7643','2014-01-03','09:50:00',1.23),('7643','2014-01-03','10:00:00',1.39),('7643','2014-01-03','10:05:00',1.81),('7643','2014-01-03','10:10:00',1.24),('7643','2014-01-03','12:05:00',1.16),('7643','2014-01-03','12:10:00',1.39),('7643','2014-01-03','14:40:00',1.56),('7643','2014-01-03','14:45:00',1.66),('7643','2014-01-03','14:50:00',1.8),('7643','2014-01-03','14:55:00',2.01),('7643','2014-01-03','15:00:00',2.92),('7643','2014-01-03','15:05:00',1.93),('7643','2014-01-03','15:10:00',1.19),('7643','2014-01-03','15:15:00',1.02),('7643','2014-01-03','15:25:00',1.23),('7643','2014-01-03','15:30:00',1.23),('7643','2014-01-03','15:35:00',1.01),('7643','2014-01-02','08:20:00',1.56),('7643','2014-01-02','08:50:00',1.61),('7643','2014-01-02','08:55:00',2.62),('7643','2014-01-02','09:05:00',1.34),('7643','2014-01-02','09:10:00',2.2),('7643','2014-01-02','09:15:00',3.97),('7643','2014-01-02','09:20:00',3.88),('7643','2014-01-02','09:25:00',2.52),('7643','2014-01-02','09:30:00',4.74),('7643','2014-01-02','09:35:00',6.39),('7643','2014-01-02','09:40:00',7.46),('7643','2014-01-02','09:45:00',5.52),('7643','2014-01-02','09:50:00',3.39),('7643','2014-01-02','09:55:00',3.01),('7643','2014-01-02','10:00:00',3.18),('7643','2014-01-02','10:05:00',7.52),('7643','2014-01-02','10:10:00',5.38),('7643','2014-01-02','10:15:00',2.84),('7643','2014-01-02','10:20:00',9.14),('7643','2014-01-02','10:25:00',4.54),('7643','2014-01-02','10:30:00',4.24),('7643','2014-01-02','10:35:00',4.06),('7643','2014-01-02','10:40:00',4.72),('7643','2014-01-02','10:45:00',5.03),('7643','2014-01-02','10:50:00',5.06),('7643','2014-01-02','10:55:00',4.27),('7643','2014-01-02','11:00:00',3.74),('7643','2014-01-02','11:05:00',4.03),('7643','2014-01-02','11:10:00',3.26),('7643','2014-01-02','11:15:00',2.74),('7643','2014-01-02','11:20:00',3.26),('7643','2014-01-02','11:25:00',2.92),('7643','2014-01-02','11:30:00',3.07),('7643','2014-01-02','11:35:00',3.42),('7643','2014-01-02','11:40:00',3.61),('7643','2014-01-02','11:45:00',4.36),('7643','2014-01-02','11:50:00',4.11),('7643','2014-01-02','11:55:00',4.02),('7643','2014-01-02','12:00:00',4.38),('7643','2014-01-02','12:05:00',6.89),('7643','2014-01-02','12:10:00',6.29),('7643','2014-01-02','12:15:00',5.31),('7643','2014-01-02','12:20:00',3.68),('7643','2014-01-02','12:25:00',4.6),('7643','2014-01-02','12:30:00',4.77),('7643','2014-01-02','12:35:00',5.6),('7643','2014-01-02','12:40:00',5.83),('7643','2014-01-02','12:45:00',6.46),('7643','2014-01-02','12:50:00',5.66),('7643','2014-01-02','12:55:00',7.64),('7643','2014-01-02','13:00:00',4.94),('7643','2014-01-02','13:05:00',3.85),('7643','2014-01-02','13:10:00',4.66),('7643','2014-01-02','13:15:00',4.16),('7643','2014-01-02','13:20:00',3.25),('7643','2014-01-02','13:25:00',3.46),('7643','2014-01-02','13:30:00',4.86),('7643','2014-01-02','13:35:00',6.6),('7643','2014-01-02','13:40:00',4.41),('7643','2014-01-02','13:45:00',5.5),('7643','2014-01-02','13:50:00',3.46),('7643','2014-01-02','13:55:00',2.86),('7643','2014-01-02','14:00:00',2.35),('7643','2014-01-02','14:05:00',1.39),('7643','2014-01-02','15:25:00',1.01),('7643','2014-01-01','08:35:00',2.42),('7643','2014-01-01','08:40:00',2.99),('7643','2014-01-01','08:45:00',3.29),('7643','2014-01-01','08:50:00',3.65),('7643','2014-01-01','08:55:00',3.9),('7643','2014-01-01','09:00:00',4.23),('7643','2014-01-01','09:05:00',4.57),('7643','2014-01-01','09:10:00',4.84),('7643','2014-01-01','09:15:00',5.09),('7643','2014-01-01','09:20:00',5.41),('7643','2014-01-01','09:25:00',5.62),('7643','2014-01-01','09:30:00',5.82),('7643','2014-01-01','09:35:00',6.07),('7643','2014-01-01','09:40:00',6.38),('7643','2014-01-01','09:45:00',6.63),('7643','2014-01-01','09:50:00',6.85),('7643','2014-01-01','09:55:00',7.09),('7643','2014-01-01','10:00:00',7.41),('7643','2014-01-01','10:05:00',7.65),('7643','2014-01-01','10:10:00',7.86),('7643','2014-01-01','10:15:00',8.01),('7643','2014-01-01','10:20:00',8.19),('7643','2014-01-01','10:25:00',8.19),('7643','2014-01-01','10:30:00',8.39),('7643','2014-01-01','10:35:00',8.52),('7643','2014-01-01','10:40:00',8.52),('7643','2014-01-01','10:45:00',8.59),('7643','2014-01-01','10:50:00',8.69),('7643','2014-01-01','10:55:00',9.04),('7643','2014-01-01','11:00:00',8.94),('7643','2014-01-01','11:05:00',8.98),('7643','2014-01-01','11:10:00',6.73),('7643','2014-01-01','11:15:00',4.76),('7643','2014-01-01','11:20:00',4.47),('7643','2014-01-01','11:25:00',5.25),('7643','2014-01-01','11:30:00',6.12),('7643','2014-01-01','11:35:00',6.37),('7643','2014-01-01','11:40:00',6.83),('7643','2014-01-01','11:45:00',5.81),('7643','2014-01-01','11:50:00',5.1),('7643','2014-01-01','11:55:00',4.6),('7643','2014-01-01','12:00:00',4.29),('7643','2014-01-01','12:05:00',4.38),('7643','2014-01-01','12:10:00',4.69),('7643','2014-01-01','12:15:00',3.98),('7643','2014-01-01','12:20:00',3.68),('7643','2014-01-01','12:25:00',3.52),('7643','2014-01-01','12:30:00',3.31),('7643','2014-01-01','12:35:00',2.64),('7643','2014-01-01','12:40:00',2.77),('7643','2014-01-01','12:45:00',3.34),('7643','2014-01-01','12:50:00',6.12),('7643','2014-01-01','12:55:00',11.9),('7643','2014-01-01','13:00:00',5.53),('7643','2014-01-01','13:05:00',2.64),('7643','2014-01-01','13:10:00',2.19),('7643','2014-01-01','13:15:00',2.21),('7643','2014-01-01','13:20:00',1.93),('7643','2014-01-01','13:25:00',2.01),('7643','2014-01-01','13:30:00',2.84),('7643','2014-01-01','13:35:00',4.06),('7643','2014-01-01','13:40:00',6.08),('7643','2014-01-01','13:45:00',5.1),('7643','2014-01-01','13:50:00',2.98),('7643','2014-01-01','13:55:00',1.96),('7643','2014-01-01','14:00:00',1.47),('7643','2014-01-01','14:05:00',1.18),('7643','2014-01-01','14:15:00',1.76),('7643','2014-01-01','14:20:00',2.33),('7643','2014-01-01','14:25:00',2.3),('7643','2014-01-01','14:30:00',2.09),('7643','2014-01-01','14:35:00',1.9),('7643','2014-01-01','14:40:00',1.63),('7643','2014-01-01','14:45:00',1.19),('7643','2014-01-01','15:00:00',1.06),('7643','2014-01-01','15:05:00',1.4),('7643','2014-01-01','15:10:00',1.34),('7643','2014-01-01','15:15:00',1.01),('7643','2014-01-01','15:45:00',1.09),('7643','2013-12-31','08:05:00',1.27),('7643','2013-12-31','08:10:00',1.55),('7643','2013-12-31','08:15:00',1.85),('7643','2013-12-31','08:20:00',2.13),('7643','2013-12-31','08:25:00',2.54),('7643','2013-12-31','08:30:00',2.81),('7643','2013-12-31','08:35:00',2.05),('7643','2013-12-31','08:40:00',2.24),('7643','2013-12-31','08:45:00',1.37),('7643','2013-12-31','08:50:00',2.64),('7643','2013-12-31','08:55:00',4.49),('7643','2013-12-31','09:00:00',4.68),('7643','2013-12-31','09:05:00',4.7),('7643','2013-12-31','09:10:00',6.35),('7643','2013-12-31','09:15:00',4.04),('7643','2013-12-31','09:20:00',3.42),('7643','2013-12-31','09:25:00',4.49),('7643','2013-12-31','09:30:00',6.82),('7643','2013-12-31','09:35:00',5.7),('7643','2013-12-31','09:40:00',6.38),('7643','2013-12-31','09:45:00',5.88),('7643','2013-12-31','09:50:00',8.21),('7643','2013-12-31','09:55:00',6.45),('7643','2013-12-31','10:00:00',4.59),('7643','2013-12-31','10:05:00',4.14),('7643','2013-12-31','10:10:00',3.47),('7643','2013-12-31','10:15:00',3.03),('7643','2013-12-31','10:20:00',2.8),('7643','2013-12-31','10:25:00',2.74),('7643','2013-12-31','10:30:00',2.72),('7643','2013-12-31','10:35:00',2.62),('7643','2013-12-31','10:40:00',2.65),('7643','2013-12-31','10:45:00',2.77),('7643','2013-12-31','10:50:00',2.97),('7643','2013-12-31','10:55:00',3.27),('7643','2013-12-31','11:00:00',3.33),('7643','2013-12-31','11:05:00',3.17),('7643','2013-12-31','11:10:00',3.1),('7643','2013-12-31','11:15:00',3.22),('7643','2013-12-31','11:20:00',3.41),('7643','2013-12-31','11:25:00',3.5),('7643','2013-12-31','11:30:00',3.57),('7643','2013-12-31','11:35:00',3.43),('7643','2013-12-31','11:40:00',3.42),('7643','2013-12-31','11:45:00',3.42),('7643','2013-12-31','11:50:00',3.34),('7643','2013-12-31','11:55:00',3.48),('7643','2013-12-31','12:00:00',3.82),('7643','2013-12-31','12:05:00',4.02),('7643','2013-12-31','12:10:00',4.32),('7643','2013-12-31','12:15:00',4.51),('7643','2013-12-31','12:20:00',4.62),('7643','2013-12-31','12:25:00',4.67),('7643','2013-12-31','12:30:00',5),('7643','2013-12-31','12:35:00',5.32),('7643','2013-12-31','12:40:00',4.77),('7643','2013-12-31','12:45:00',4.89),('7643','2013-12-31','12:50:00',4.7),('7643','2013-12-31','12:55:00',4.63),('7643','2013-12-31','13:00:00',4.46),('7643','2013-12-31','13:05:00',3.96),('7643','2013-12-31','13:10:00',3.74),('7643','2013-12-31','13:15:00',3.71),('7643','2013-12-31','13:20:00',3.93),('7643','2013-12-31','13:25:00',5.41),('7643','2013-12-31','13:30:00',5.8),('7643','2013-12-31','13:35:00',5.36),('7643','2013-12-31','13:40:00',5.31),('7643','2013-12-31','13:45:00',4.77),('7643','2013-12-31','13:50:00',5.4),('7643','2013-12-31','13:55:00',8.82),('7643','2013-12-31','14:00:00',7.94),('7643','2013-12-31','14:05:00',4.28),('7643','2013-12-31','14:10:00',3.89),('7643','2013-12-31','14:15:00',4.15),('7643','2013-12-31','14:20:00',3.84),('7643','2013-12-31','14:25:00',3.3),('7643','2013-12-31','14:30:00',3.22),('7643','2013-12-31','14:35:00',2.97),('7643','2013-12-31','14:40:00',3.07),('7643','2013-12-31','14:45:00',3.27),('7643','2013-12-31','14:50:00',3.02),('7643','2013-12-31','14:55:00',3.45),('7643','2013-12-31','15:00:00',2.9),('7643','2013-12-31','15:05:00',5.28),('7643','2013-12-31','15:10:00',5.84),('7643','2013-12-31','15:15:00',4.9),('7643','2013-12-31','15:20:00',4.22),('7643','2013-12-31','15:25:00',3.79),('7643','2013-12-31','15:30:00',3.35),('7643','2013-12-31','15:35:00',3.06),('7643','2013-12-31','15:40:00',2.75),('7643','2013-12-31','15:45:00',2.41),('7643','2013-12-31','15:50:00',2.14),('7643','2013-12-31','15:55:00',1.89),('7643','2013-12-31','16:00:00',1.59),('7643','2013-12-31','16:05:00',1.3),('7643','2013-12-31','16:10:00',1.02),('7643','2013-12-30','08:05:00',1.35),('7643','2013-12-30','08:10:00',1.73),('7643','2013-12-30','08:15:00',1.98),('7643','2013-12-30','08:40:00',1.46),('7643','2013-12-30','08:45:00',2.61),('7643','2013-12-30','08:50:00',3.25),('7643','2013-12-30','08:55:00',1.43),('7643','2013-12-30','09:00:00',3.89),('7643','2013-12-30','09:05:00',1.48),('7643','2013-12-30','09:10:00',3.08),('7643','2013-12-30','09:15:00',5.18),('7643','2013-12-30','09:20:00',5.91),('7643','2013-12-30','09:25:00',6.21),('7643','2013-12-30','09:30:00',6.78),('7643','2013-12-30','09:35:00',7.14),('7643','2013-12-30','09:40:00',7.61),('7643','2013-12-30','09:45:00',4.28),('7643','2013-12-30','09:50:00',6.68),('7643','2013-12-30','09:55:00',5.47),('7643','2013-12-30','10:00:00',5.6),('7643','2013-12-30','10:05:00',6.47),('7643','2013-12-30','10:10:00',3.5),('7643','2013-12-30','10:15:00',3.43),('7643','2013-12-30','10:20:00',3),('7643','2013-12-30','10:25:00',3.21),('7643','2013-12-30','10:30:00',3.79),('7643','2013-12-30','10:35:00',3.71),('7643','2013-12-30','10:40:00',3.59),('7643','2013-12-30','10:45:00',3.7),('7643','2013-12-30','10:50:00',4.83),('7643','2013-12-30','10:55:00',5.05),('7643','2013-12-30','11:00:00',4.9),('7643','2013-12-30','11:05:00',5),('7643','2013-12-30','11:10:00',6.76),('7643','2013-12-30','11:15:00',10.16),('7643','2013-12-30','11:20:00',7.5),('7643','2013-12-30','11:25:00',7.97),('7643','2013-12-30','11:30:00',9.18),('7643','2013-12-30','11:35:00',5.54),('7643','2013-12-30','11:40:00',7.49),('7643','2013-12-30','11:45:00',5.19),('7643','2013-12-30','11:50:00',5.97),('7643','2013-12-30','11:55:00',6.19),('7643','2013-12-30','12:00:00',11.18),('7643','2013-12-30','12:05:00',10.71),('7643','2013-12-30','12:10:00',10.61),('7643','2013-12-30','12:15:00',10.5),('7643','2013-12-30','12:20:00',10.41),('7643','2013-12-30','12:25:00',10.31),('7643','2013-12-30','12:30:00',10.16),('7643','2013-12-30','12:35:00',10.05),('7643','2013-12-30','12:40:00',10.01),('7643','2013-12-30','12:45:00',9.97),('7643','2013-12-30','12:50:00',9.91),('7643','2013-12-30','12:55:00',9.77),('7643','2013-12-30','13:00:00',9.72),('7643','2013-12-30','13:05:00',9.62),('7643','2013-12-30','13:10:00',9.51),('7643','2013-12-30','13:15:00',9.42),('7643','2013-12-30','13:20:00',9.27),('7643','2013-12-30','13:25:00',9.17),('7643','2013-12-30','13:30:00',9.05),('7643','2013-12-30','13:35:00',8.86),('7643','2013-12-30','13:40:00',8.64),('7643','2013-12-30','13:45:00',8.46),('7643','2013-12-30','13:50:00',8.24),('7643','2013-12-30','13:55:00',8.09),('7643','2013-12-30','14:00:00',7.94),('7643','2013-12-30','14:05:00',7.75),('7643','2013-12-30','14:10:00',7.49),('7643','2013-12-30','14:15:00',7.3),('7643','2013-12-30','14:20:00',7.09),('7643','2013-12-30','14:25:00',6.89),('7643','2013-12-30','14:30:00',6.65),('7643','2013-12-30','14:35:00',6.39),('7643','2013-12-30','14:40:00',6.14),('7643','2013-12-30','14:45:00',5.86),('7643','2013-12-30','14:50:00',5.58),('7643','2013-12-30','14:55:00',5.31),('7643','2013-12-30','15:00:00',5.03),('7643','2013-12-30','15:05:00',4.75),('7643','2013-12-30','15:10:00',4.47),('7643','2013-12-30','15:15:00',4.17),('7643','2013-12-30','15:20:00',3.87),('7643','2013-12-30','15:25:00',3.57),('7643','2013-12-30','15:30:00',3.28),('7643','2013-12-30','15:35:00',2.99),('7643','2013-12-30','15:40:00',2.66),('7643','2013-12-30','15:45:00',2.37),('7643','2013-12-30','15:50:00',2.09),('7643','2013-12-30','15:55:00',1.83),('7643','2013-12-30','16:00:00',1.57),('7643','2013-12-30','16:05:00',1.31),('7643','2013-12-30','16:10:00',1.06),('7643','2013-12-29','08:55:00',1.06),('7643','2013-12-29','09:00:00',1.44),('7643','2013-12-29','09:05:00',1.88),('7643','2013-12-29','09:10:00',2.1),('7643','2013-12-29','09:15:00',2.09),('7643','2013-12-29','09:20:00',2.25),('7643','2013-12-29','09:25:00',2.61),('7643','2013-12-29','09:30:00',2.54),('7643','2013-12-29','09:35:00',2.05),('7643','2013-12-29','09:40:00',1.98),('7643','2013-12-29','09:45:00',1.83),('7643','2013-12-29','09:50:00',1.55),('7643','2013-12-29','09:55:00',1.37),('7643','2013-12-29','10:00:00',1.24),('7643','2013-12-29','10:05:00',1.32),('7643','2013-12-29','10:10:00',1.27),('7643','2013-12-29','10:15:00',1.19),('7643','2013-12-29','10:20:00',1.14),('7643','2013-12-29','10:25:00',1.16),('7643','2013-12-29','10:30:00',1.2),('7643','2013-12-29','10:35:00',1.21),('7643','2013-12-29','10:40:00',1.27),('7643','2013-12-29','10:45:00',1.29),('7643','2013-12-29','10:50:00',1.5),('7643','2013-12-29','10:55:00',1.78),('7643','2013-12-29','11:00:00',1.92),('7643','2013-12-29','11:05:00',2.06),('7643','2013-12-29','11:10:00',2.41),('7643','2013-12-29','11:15:00',2.85),('7643','2013-12-29','11:20:00',3.41),('7643','2013-12-29','11:25:00',3.84),('7643','2013-12-29','11:30:00',3.85),('7643','2013-12-29','11:35:00',3.6),('7643','2013-12-29','11:40:00',3.37),('7643','2013-12-29','11:45:00',3.25),('7643','2013-12-29','11:50:00',3.18),('7643','2013-12-29','11:55:00',2.81),('7643','2013-12-29','12:00:00',2.48),('7643','2013-12-29','12:05:00',2.49),('7643','2013-12-29','12:10:00',2.6),('7643','2013-12-29','12:15:00',2.63),('7643','2013-12-29','12:20:00',2.54),('7643','2013-12-29','12:25:00',2.66),('7643','2013-12-29','12:30:00',2.64),('7643','2013-12-29','12:35:00',2.59),('7643','2013-12-29','12:40:00',2.7),('7643','2013-12-29','12:45:00',2.89),('7643','2013-12-29','12:50:00',2.88),('7643','2013-12-29','12:55:00',2.6),('7643','2013-12-29','13:00:00',2.33),('7643','2013-12-29','13:05:00',2.41),('7643','2013-12-29','13:10:00',2.62),('7643','2013-12-29','13:15:00',2.46),('7643','2013-12-29','13:20:00',2.35),('7643','2013-12-29','13:25:00',2.46),('7643','2013-12-29','13:30:00',2.5),('7643','2013-12-29','13:35:00',2.46),('7643','2013-12-29','13:40:00',2.31),('7643','2013-12-29','13:45:00',2.22),('7643','2013-12-29','13:50:00',2),('7643','2013-12-29','13:55:00',1.85),('7643','2013-12-29','14:00:00',1.75),('7643','2013-12-29','14:05:00',1.53),('7643','2013-12-29','14:10:00',1.45),('7643','2013-12-29','14:15:00',1.4),('7643','2013-12-29','14:20:00',1.26),('7643','2013-12-29','14:25:00',1.31),('7643','2013-12-29','14:30:00',1.51),('7643','2013-12-29','14:35:00',1.57),('7643','2013-12-29','14:40:00',1.39),('7643','2013-12-29','14:45:00',1.48),('7643','2013-12-29','14:50:00',1.46),('7643','2013-12-29','14:55:00',1.17),('7643','2013-12-29','15:00:00',1.21),('7643','2013-12-29','15:05:00',1.33),('7643','2013-12-29','15:10:00',1.27),('7643','2013-12-29','15:15:00',1.04),('7643','2013-12-28','08:05:00',1.36),('7643','2013-12-28','08:10:00',1.2),('7643','2013-12-28','08:15:00',1.24),('7643','2013-12-28','08:20:00',1.93),('7643','2013-12-28','08:25:00',2.13),('7643','2013-12-28','08:30:00',2.47),('7643','2013-12-28','08:35:00',3.75),('7643','2013-12-28','08:40:00',2.74),('7643','2013-12-28','08:45:00',3.3),('7643','2013-12-28','08:50:00',3.12),('7643','2013-12-28','09:00:00',1.22),('7643','2013-12-28','09:05:00',3.83),('7643','2013-12-28','09:10:00',4.77),('7643','2013-12-28','09:15:00',5.12),('7643','2013-12-28','09:20:00',5.82),('7643','2013-12-28','09:25:00',5.91),('7643','2013-12-28','09:30:00',6.24),('7643','2013-12-28','09:35:00',6.46),('7643','2013-12-28','09:40:00',6.81),('7643','2013-12-28','09:45:00',7.03),('7643','2013-12-28','09:50:00',6.73),('7643','2013-12-28','09:55:00',5.98),('7643','2013-12-28','10:00:00',6.03),('7643','2013-12-28','10:05:00',6.63),('7643','2013-12-28','10:10:00',7.1),('7643','2013-12-28','10:15:00',8.27),('7643','2013-12-28','10:20:00',8.92),('7643','2013-12-28','10:25:00',6.05),('7643','2013-12-28','10:30:00',6.59),('7643','2013-12-28','10:35:00',7.54),('7643','2013-12-28','10:40:00',8.69),('7643','2013-12-28','10:45:00',3.99),('7643','2013-12-28','10:50:00',3.7),('7643','2013-12-28','10:55:00',4.02),('7643','2013-12-28','11:00:00',4.65),('7643','2013-12-28','11:05:00',3.82),('7643','2013-12-28','11:10:00',4.4),('7643','2013-12-28','11:15:00',2.7),('7643','2013-12-28','11:20:00',2.24),('7643','2013-12-28','11:25:00',1.77),('7643','2013-12-28','11:30:00',2),('7643','2013-12-28','11:35:00',2.31),('7643','2013-12-28','11:40:00',2.13),('7643','2013-12-28','11:45:00',1.32),('7643','2013-12-28','11:50:00',1.46),('7643','2013-12-28','11:55:00',2.57),('7643','2013-12-28','12:00:00',2.59),('7643','2013-12-28','12:05:00',2.52),('7643','2013-12-28','12:10:00',2.43),('7643','2013-12-28','12:15:00',2.18),('7643','2013-12-28','12:20:00',1.77),('7643','2013-12-28','12:25:00',1.78),('7643','2013-12-28','12:30:00',1.6),('7643','2013-12-28','12:35:00',1.47),('7643','2013-12-28','12:40:00',1.32),('7643','2013-12-28','13:30:00',1.04),('7643','2013-12-28','13:35:00',1.95),('7643','2013-12-28','13:40:00',2.48),('7643','2013-12-28','13:45:00',1.91),('7643','2013-12-28','13:50:00',1.48),('7643','2013-12-28','13:55:00',1.29),('7643','2013-12-28','14:00:00',1.3),('7643','2013-12-28','14:05:00',1),('7643','2013-12-27','08:05:00',1.16),('7643','2013-12-27','08:10:00',1.42),('7643','2013-12-27','08:15:00',1.7),('7643','2013-12-27','08:20:00',2),('7643','2013-12-27','08:25:00',2.3),('7643','2013-12-27','08:30:00',2.64),('7643','2013-12-27','08:35:00',2.98),('7643','2013-12-27','08:40:00',3.29),('7643','2013-12-27','08:45:00',3.58),('7643','2013-12-27','08:50:00',3.9),('7643','2013-12-27','08:55:00',4.18),('7643','2013-12-27','09:00:00',4.48),('7643','2013-12-27','09:05:00',4.78),('7643','2013-12-27','09:10:00',5.06),('7643','2013-12-27','09:15:00',5.36),('7643','2013-12-27','09:20:00',5.66),('7643','2013-12-27','09:25:00',5.95),('7643','2013-12-27','09:30:00',6.25),('7643','2013-12-27','09:35:00',6.51),('7643','2013-12-27','09:40:00',6.73),('7643','2013-12-27','09:45:00',6.92),('7643','2013-12-27','09:50:00',7.18),('7643','2013-12-27','09:55:00',7.47),('7643','2013-12-27','10:00:00',7.69),('7643','2013-12-27','10:05:00',7.85),('7643','2013-12-27','10:10:00',8.03),('7643','2013-12-27','10:15:00',8.14),('7643','2013-12-27','10:20:00',8.3),('7643','2013-12-27','10:25:00',8.47),('7643','2013-12-27','10:30:00',8.68),('7643','2013-12-27','10:35:00',8.88),('7643','2013-12-27','10:40:00',9),('7643','2013-12-27','10:45:00',9.13),('7643','2013-12-27','10:50:00',9.23),('7643','2013-12-27','10:55:00',9.3),('7643','2013-12-27','11:00:00',9.4),('7643','2013-12-27','11:05:00',9.51),('7643','2013-12-27','11:10:00',9.6),('7643','2013-12-27','11:15:00',9.67),('7643','2013-12-27','11:20:00',9.76),('7643','2013-12-27','11:25:00',9.8),('7643','2013-12-27','11:30:00',9.88),('7643','2013-12-27','11:35:00',9.94),('7643','2013-12-27','11:40:00',9.92),('7643','2013-12-27','11:45:00',9.96),('7643','2013-12-27','11:50:00',9.97),('7643','2013-12-27','11:55:00',10),('7643','2013-12-27','12:00:00',9.93),('7643','2013-12-27','12:05:00',9.82),('7643','2013-12-27','12:10:00',9.95),('7643','2013-12-27','12:15:00',9.95),('7643','2013-12-27','12:20:00',9.85),('7643','2013-12-27','12:25:00',9.74),('7643','2013-12-27','12:30:00',9.65),('7643','2013-12-27','12:35:00',9.57),('7643','2013-12-27','12:40:00',9.62),('7643','2013-12-27','12:45:00',9.56),('7643','2013-12-27','12:50:00',9.45),('7643','2013-12-27','12:55:00',9.34),('7643','2013-12-27','13:00:00',9.25),('7643','2013-12-27','13:05:00',9.09),('7643','2013-12-27','13:10:00',8.86),('7643','2013-12-27','13:15:00',8.8),('7643','2013-12-27','13:20:00',8.69),('7643','2013-12-27','13:25:00',8.42),('7643','2013-12-27','13:30:00',8.04),('7643','2013-12-27','13:35:00',7.93),('7643','2013-12-27','13:40:00',7.84),('7643','2013-12-27','13:45:00',7.58),('7643','2013-12-27','13:50:00',7.54),('7643','2013-12-27','13:55:00',7.42),('7643','2013-12-27','14:00:00',7.12),('7643','2013-12-27','14:05:00',6.88),('7643','2013-12-27','14:10:00',6.7),('7643','2013-12-27','14:15:00',6.41),('7643','2013-12-27','14:20:00',6.14),('7643','2013-12-27','14:25:00',5.99),('7643','2013-12-27','14:30:00',5.9),('7643','2013-12-27','14:35:00',5.58),('7643','2013-12-27','14:40:00',5.33),('7643','2013-12-27','14:45:00',4.75),('7643','2013-12-27','14:50:00',4.15),('7643','2013-12-27','14:55:00',2.26),('7643','2013-12-27','15:00:00',3.34),('7643','2013-12-27','15:05:00',4.5),('7643','2013-12-27','15:10:00',4.15),('7643','2013-12-27','15:15:00',3.81),('7643','2013-12-27','15:20:00',3.5),('7643','2013-12-27','15:25:00',3.22),('7643','2013-12-27','15:30:00',2.77),('7643','2013-12-27','15:35:00',2.69),('7643','2013-12-27','15:40:00',2.44),('7643','2013-12-27','15:45:00',2.23),('7643','2013-12-27','15:50:00',2.04),('7643','2013-12-27','15:55:00',1.69),('7643','2013-12-27','16:00:00',1.26),('7643','2013-12-27','16:05:00',1.13),('7643','2014-04-22','08:15:00',1.08),('7643','2014-04-22','08:20:00',1.2),('7643','2014-04-22','09:10:00',1.02),('7643','2014-04-22','09:15:00',1.05),('7643','2014-04-22','09:20:00',1.16),('7643','2014-04-22','09:25:00',1.1),('7643','2014-04-22','09:45:00',1.33),('7643','2014-04-22','09:50:00',1.16),('7643','2014-04-22','10:05:00',1.17),('7643','2014-04-22','10:10:00',1.35),('7643','2014-04-22','10:15:00',1.31),('7643','2014-04-22','10:20:00',1.53),('7643','2014-04-22','10:25:00',1.73),('7643','2014-04-22','10:30:00',1.61),('7643','2014-04-22','10:35:00',1.58),('7643','2014-04-22','10:40:00',1.84),('7643','2014-04-22','10:45:00',1.86),('7643','2014-04-22','10:50:00',1.68),('7643','2014-04-22','10:55:00',1.5),('7643','2014-04-22','11:00:00',1.53),('7643','2014-04-22','11:05:00',1.49),('7643','2014-04-22','11:10:00',1.69),('7643','2014-04-22','11:15:00',1.99),('7643','2014-04-22','11:20:00',1.93),('7643','2014-04-22','11:25:00',1.81),('7643','2014-04-22','11:30:00',1.93),('7643','2014-04-22','11:35:00',2.19),('7643','2014-04-22','11:40:00',2.41),('7643','2014-04-22','11:45:00',2.53),('7643','2014-04-22','11:50:00',1.99),('7643','2014-04-22','11:55:00',1.55),('7643','2014-04-22','12:00:00',1.44),('7643','2014-04-22','12:05:00',1.48),('7643','2014-04-22','12:10:00',1.61),('7643','2014-04-22','12:15:00',1.83),('7643','2014-04-22','12:20:00',1.9),('7643','2014-04-22','12:25:00',1.98),('7643','2014-04-22','12:30:00',1.99),('7643','2014-04-22','12:35:00',2.04),('7643','2014-04-22','12:40:00',1.94),('7643','2014-04-22','12:45:00',2.02),('7643','2014-04-22','12:50:00',2.18),('7643','2014-04-22','12:55:00',2.39),('7643','2014-04-22','13:00:00',2.75),('7643','2014-04-22','13:05:00',3.37),('7643','2014-04-22','13:10:00',4.17),('7643','2014-04-22','13:15:00',4.57),('7643','2014-04-22','13:20:00',4.9),('7643','2014-04-22','13:25:00',5.08),('7643','2014-04-22','13:30:00',5.43),('7643','2014-04-22','13:35:00',5.65),('7643','2014-04-22','13:40:00',5.94),('7643','2014-04-22','13:45:00',5.97),('7643','2014-04-22','13:50:00',5.84),('7643','2014-04-22','13:55:00',5.71),('7643','2014-04-22','14:00:00',5.39),('7643','2014-04-22','14:05:00',5.5),('7643','2014-04-22','14:10:00',5.1),('7643','2014-04-22','14:15:00',4.16),('7643','2014-04-22','14:20:00',3.71),('7643','2014-04-22','14:25:00',3.41),('7643','2014-04-22','14:30:00',3.28),('7643','2014-04-22','14:35:00',3.31),('7643','2014-04-22','14:40:00',3.71),('7643','2014-04-22','14:45:00',4.54),('7643','2014-04-22','14:50:00',5.48),('7643','2014-04-22','14:55:00',6.25),('7643','2014-04-22','15:00:00',6.66),('7643','2014-04-22','15:05:00',6.71),('7643','2014-04-22','15:10:00',7),('7643','2014-04-22','15:15:00',6.64),('7643','2014-04-22','15:20:00',5.49),('7643','2014-04-22','15:25:00',5.22),('7643','2014-04-22','15:30:00',5.04),('7643','2014-04-22','15:35:00',4.79),('7643','2014-04-22','15:40:00',4.68),('7643','2014-04-22','15:45:00',4.45),('7643','2014-04-22','15:50:00',3.9),('7643','2014-04-22','15:55:00',3.74),('7643','2014-04-22','16:00:00',3.26),('7643','2014-04-22','16:05:00',3.12),('7643','2014-04-22','16:10:00',2.72),('7643','2014-04-22','16:15:00',2.4),('7643','2014-04-22','16:20:00',2.04),('7643','2014-04-22','16:25:00',1.61),('7643','2014-04-22','16:30:00',1.32),('7643','2014-04-22','16:35:00',1.29),('7643','2014-04-22','16:40:00',1.26),('7643','2014-04-22','16:45:00',1.23),('7643','2014-04-22','16:50:00',1.02),('7643','2013-12-26','08:05:00',1.16),('7643','2013-12-26','08:20:00',1.61),('7643','2013-12-26','08:25:00',1.08),('7643','2013-12-26','09:00:00',1.03),('7643','2013-12-26','09:05:00',1.1),('7643','2013-12-26','09:10:00',1.19),('7643','2013-12-26','09:15:00',1.26),('7643','2013-12-26','09:20:00',1.37),('7643','2013-12-26','09:25:00',1.45),('7643','2013-12-26','09:30:00',1.91),('7643','2013-12-26','09:35:00',1.76),('7643','2013-12-26','09:40:00',1.65),('7643','2013-12-26','09:45:00',1.7),('7643','2013-12-26','09:50:00',1.73),('7643','2013-12-26','09:55:00',1.7),('7643','2013-12-26','10:00:00',1.62),('7643','2013-12-26','10:05:00',1.55),('7643','2013-12-26','10:10:00',1.56),('7643','2013-12-26','10:15:00',1.74),('7643','2013-12-26','10:20:00',2.08),('7643','2013-12-26','10:25:00',2.47),('7643','2013-12-26','10:30:00',2.72),('7643','2013-12-26','10:35:00',2.76),('7643','2013-12-26','10:40:00',2.77),('7643','2013-12-26','10:45:00',2.7),('7643','2013-12-26','10:50:00',2.5),('7643','2013-12-26','10:55:00',2.21),('7643','2013-12-26','11:00:00',1.85),('7643','2013-12-26','11:05:00',1.8),('7643','2013-12-26','11:10:00',1.74),('7643','2013-12-26','11:15:00',1.47),('7643','2013-12-26','11:20:00',1.77),('7643','2013-12-26','11:25:00',2.27),('7643','2013-12-26','11:30:00',2.9),('7643','2013-12-26','11:35:00',3.51),('7643','2013-12-26','11:40:00',3.34),('7643','2013-12-26','11:45:00',3.08),('7643','2013-12-26','11:50:00',2.86),('7643','2013-12-26','11:55:00',2.5),('7643','2013-12-26','12:00:00',2.42),('7643','2013-12-26','12:05:00',3.41),('7643','2013-12-26','12:10:00',5.12),('7643','2013-12-26','12:15:00',8.74),('7643','2013-12-26','12:20:00',6.79),('7643','2013-12-26','12:25:00',6.26),('7643','2013-12-26','12:30:00',4.21),('7643','2013-12-26','12:35:00',4.5),('7643','2013-12-26','12:40:00',5.95),('7643','2013-12-26','12:45:00',7.61),('7643','2013-12-26','12:50:00',8.79),('7643','2013-12-26','12:55:00',9.2),('7643','2013-12-26','13:00:00',9.28),('7643','2013-12-26','13:05:00',8.14),('7643','2013-12-26','13:10:00',3.96),('7643','2013-12-26','13:15:00',4.9),('7643','2013-12-26','13:20:00',4.87),('7643','2013-12-26','13:25:00',4.82),('7643','2013-12-26','13:30:00',8.71),('7643','2013-12-26','13:35:00',9.56),('7643','2013-12-26','13:40:00',5.46),('7643','2013-12-26','13:45:00',4.92),('7643','2013-12-26','13:50:00',3.89),('7643','2013-12-26','13:55:00',3.27),('7643','2013-12-26','14:00:00',2.93),('7643','2013-12-26','14:05:00',3.02),('7643','2013-12-26','14:10:00',3.49),('7643','2013-12-26','14:15:00',3.82),('7643','2013-12-26','14:20:00',3.8),('7643','2013-12-26','14:25:00',3.76),('7643','2013-12-26','14:30:00',4.25),('7643','2013-12-26','14:35:00',4.56),('7643','2013-12-26','14:40:00',4.67),('7643','2013-12-26','14:45:00',3.79),('7643','2013-12-26','14:50:00',2.83),('7643','2013-12-26','14:55:00',1.85),('7643','2013-12-26','15:00:00',1.62),('7643','2013-12-26','15:05:00',1.34),('7643','2013-12-26','15:10:00',1.48),('7643','2013-12-26','15:15:00',1.32),('7643','2013-12-26','15:20:00',1.1),('7643','2013-12-26','15:25:00',1.42),('7643','2013-12-26','15:30:00',1.85),('7643','2013-12-26','15:35:00',1.92),('7643','2013-12-26','15:40:00',1.85),('7643','2013-12-26','15:45:00',1.55),('7643','2013-12-26','15:50:00',1.15),('7643','2013-12-25','09:50:00',1.4),('7643','2013-12-25','09:55:00',2.14),('7643','2013-12-25','10:00:00',1.57),('7643','2013-12-25','10:55:00',1.08),('7643','2013-12-25','11:00:00',1.22),('7643','2013-12-25','11:05:00',2.25),('7643','2013-12-25','11:10:00',1.68),('7643','2013-12-25','11:45:00',1.12),('7643','2013-12-25','11:50:00',1.11),('7643','2013-12-24','08:45:00',1.12),('7643','2013-12-24','08:50:00',1.19),('7643','2013-12-24','08:55:00',1.43),('7643','2013-12-24','09:00:00',1.62),('7643','2013-12-24','09:05:00',1.82),('7643','2013-12-24','09:10:00',2.1),('7643','2013-12-24','09:15:00',2.25),('7643','2013-12-24','09:20:00',2.23),('7643','2013-12-24','09:25:00',2.91),('7643','2013-12-24','09:30:00',3.24),('7643','2013-12-24','09:35:00',2.52),('7643','2013-12-24','09:40:00',2.24),('7643','2013-12-24','09:45:00',1.86),('7643','2013-12-24','09:50:00',1.44),('7643','2013-12-24','09:55:00',1.28),('7643','2013-12-24','10:00:00',1.15),('7643','2013-12-24','10:15:00',1),('7643','2013-12-24','10:20:00',1.43),('7643','2013-12-24','10:25:00',3.21),('7643','2013-12-24','10:30:00',5.63),('7643','2013-12-24','10:35:00',6.36),('7643','2013-12-24','10:40:00',5.55),('7643','2013-12-24','10:45:00',4.82),('7643','2013-12-24','10:50:00',5.82),('7643','2013-12-24','10:55:00',3.33),('7643','2013-12-24','11:00:00',3.09),('7643','2013-12-24','11:05:00',3.16),('7643','2013-12-24','11:10:00',3.46),('7643','2013-12-24','11:15:00',4.03),('7643','2013-12-24','11:20:00',6.38),('7643','2013-12-24','11:25:00',5.12),('7643','2013-12-24','11:30:00',8.88),('7643','2013-12-24','11:35:00',5.14),('7643','2013-12-24','11:40:00',6.41),('7643','2013-12-24','11:45:00',9.51),('7643','2013-12-24','11:50:00',5.52),('7643','2013-12-24','11:55:00',7.48),('7643','2013-12-24','12:00:00',9.47),('7643','2013-12-24','12:05:00',3.68),('7643','2013-12-24','12:10:00',3.64),('7643','2013-12-24','12:15:00',5.69),('7643','2013-12-24','12:20:00',7.38),('7643','2013-12-24','12:25:00',4.55),('7643','2013-12-24','12:30:00',9),('7643','2013-12-24','12:35:00',5.43),('7643','2013-12-24','12:40:00',4.58),('7643','2013-12-24','12:45:00',2.84),('7643','2013-12-24','12:50:00',4.76),('7643','2013-12-24','12:55:00',2.53),('7643','2013-12-24','13:00:00',1.78),('7643','2013-12-24','13:05:00',2.47),('7643','2013-12-24','13:10:00',2.94),('7643','2013-12-24','13:15:00',2.21),('7643','2013-12-24','13:20:00',1.7),('7643','2013-12-24','13:25:00',4.74),('7643','2013-12-24','13:30:00',4.76),('7643','2013-12-24','13:35:00',3.54),('7643','2013-12-24','13:40:00',4.13),('7643','2013-12-24','13:45:00',4.28),('7643','2013-12-24','13:50:00',4.94),('7643','2013-12-24','13:55:00',4.71),('7643','2013-12-24','14:00:00',3.87),('7643','2013-12-24','14:05:00',3.11),('7643','2013-12-24','14:10:00',2.82),('7643','2013-12-24','14:15:00',2.71),('7643','2013-12-24','14:20:00',2.47),('7643','2013-12-24','14:25:00',2.27),('7643','2013-12-24','14:30:00',2.23),('7643','2013-12-24','14:35:00',2.31),('7643','2013-12-24','14:40:00',2.27),('7643','2013-12-24','14:45:00',2.27),('7643','2013-12-24','14:50:00',2.28),('7643','2013-12-24','14:55:00',2.14),('7643','2013-12-24','15:00:00',1.86),('7643','2013-12-24','15:05:00',1.82),('7643','2013-12-24','15:10:00',2.11),('7643','2013-12-24','15:15:00',3.07),('7643','2013-12-24','15:20:00',3.05),('7643','2013-12-24','15:25:00',2.3),('7643','2013-12-24','15:30:00',1.48),('7643','2013-12-24','15:35:00',1.2),('7643','2013-12-24','15:40:00',1.13),('7643','2013-12-24','15:50:00',1.33),('7643','2013-12-24','16:05:00',1.01),('7643','2013-12-23','08:15:00',1.26),('7643','2013-12-23','08:20:00',1.8),('7643','2013-12-23','08:25:00',1.64),('7643','2013-12-23','08:40:00',1.36),('7643','2013-12-23','08:45:00',2),('7643','2013-12-23','08:50:00',2.56),('7643','2013-12-23','08:55:00',3.33),('7643','2013-12-23','09:00:00',3.86),('7643','2013-12-23','09:05:00',4.22),('7643','2013-12-23','09:10:00',4.48),('7643','2013-12-23','09:15:00',4.79),('7643','2013-12-23','09:20:00',5.02),('7643','2013-12-23','09:25:00',5.28),('7643','2013-12-23','09:30:00',5.52),('7643','2013-12-23','09:35:00',5.88),('7643','2013-12-23','09:40:00',6.19),('7643','2013-12-23','09:45:00',6.16),('7643','2013-12-23','09:50:00',6),('7643','2013-12-23','09:55:00',5.97),('7643','2013-12-23','10:00:00',6.72),('7643','2013-12-23','10:05:00',6.82),('7643','2013-12-23','10:10:00',7.05),('7643','2013-12-23','10:15:00',7.6),('7643','2013-12-23','10:20:00',7.74),('7643','2013-12-23','10:25:00',7.86),('7643','2013-12-23','10:30:00',7.89),('7643','2013-12-23','10:35:00',8.02),('7643','2013-12-23','10:40:00',8.19),('7643','2013-12-23','10:45:00',8.29),('7643','2013-12-23','10:50:00',8.39),('7643','2013-12-23','10:55:00',8.32),('7643','2013-12-23','11:00:00',8.56),('7643','2013-12-23','11:05:00',8.58),('7643','2013-12-23','11:10:00',8.63),('7643','2013-12-23','11:15:00',8.82),('7643','2013-12-23','11:20:00',8.93),('7643','2013-12-23','11:25:00',9.01),('7643','2013-12-23','11:30:00',9.09),('7643','2013-12-23','11:35:00',9.11),('7643','2013-12-23','11:40:00',9.08),('7643','2013-12-23','11:45:00',9.09),('7643','2013-12-23','11:50:00',9.06),('7643','2013-12-23','11:55:00',8.99),('7643','2013-12-23','12:00:00',8.88),('7643','2013-12-23','12:05:00',8.93),('7643','2013-12-23','12:10:00',8.94),('7643','2013-12-23','12:15:00',8.89),('7643','2013-12-23','12:20:00',8.86),('7643','2013-12-23','12:25:00',8.73),('7643','2013-12-23','12:30:00',8.63),('7643','2013-12-23','12:35:00',8.52),('7643','2013-12-23','12:40:00',8.37),('7643','2013-12-23','12:45:00',8.29),('7643','2013-12-23','12:50:00',8.27),('7643','2013-12-23','12:55:00',8.19),('7643','2013-12-23','13:00:00',8.06),('7643','2013-12-23','13:05:00',7.92),('7643','2013-12-23','13:10:00',7.79),('7643','2013-12-23','13:15:00',7.74),('7643','2013-12-23','13:20:00',7.62),('7643','2013-12-23','13:25:00',7.31),('7643','2013-12-23','13:30:00',7.04),('7643','2013-12-23','13:35:00',7),('7643','2013-12-23','13:40:00',6.6),('7643','2013-12-23','13:45:00',6.52),('7643','2013-12-23','13:50:00',6.43),('7643','2013-12-23','13:55:00',6.29),('7643','2013-12-23','14:00:00',6.07),('7643','2013-12-23','14:05:00',5.91),('7643','2013-12-23','14:10:00',5.72),('7643','2013-12-23','14:15:00',5.6),('7643','2013-12-23','14:20:00',5.44),('7643','2013-12-23','14:25:00',5.12),('7643','2013-12-23','14:30:00',4.77),('7643','2013-12-23','14:35:00',4.37),('7643','2013-12-23','14:40:00',4.08),('7643','2013-12-23','14:45:00',3.84),('7643','2013-12-23','14:50:00',3.61),('7643','2013-12-23','14:55:00',3.25),('7643','2013-12-23','15:00:00',2.8),('7643','2013-12-23','15:05:00',2.38),('7643','2013-12-23','15:10:00',1.86),('7643','2013-12-23','15:15:00',1.7),('7643','2013-12-23','15:20:00',1.84),('7643','2013-12-23','15:25:00',1.73),('7643','2013-12-23','15:30:00',1.68),('7643','2013-12-23','15:35:00',1.62),('7643','2013-12-23','15:40:00',1.51),('7643','2013-12-23','15:45:00',1.39),('7643','2013-12-23','15:50:00',1.28),('7643','2013-12-23','15:55:00',1.11),('7643','2013-12-22','08:25:00',1.01),('7643','2013-12-22','08:30:00',1.1),('7643','2013-12-22','08:35:00',1.21),('7643','2013-12-22','08:40:00',1.36),('7643','2013-12-22','08:45:00',1.53),('7643','2013-12-22','08:50:00',1.72),('7643','2013-12-22','08:55:00',1.86),('7643','2013-12-22','09:00:00',2.01),('7643','2013-12-22','09:05:00',2.13),('7643','2013-12-22','09:10:00',2.15),('7643','2013-12-22','09:15:00',2.26),('7643','2013-12-22','09:20:00',2.52),('7643','2013-12-22','09:25:00',3.03),('7643','2013-12-22','09:30:00',3.46),('7643','2013-12-22','09:35:00',3.8),('7643','2013-12-22','09:40:00',3.98),('7643','2013-12-22','09:45:00',4.05),('7643','2013-12-22','09:50:00',4.86),('7643','2013-12-22','09:55:00',6.23),('7643','2013-12-22','10:00:00',7.03),('7643','2013-12-22','10:05:00',7.58),('7643','2013-12-22','10:10:00',7.26),('7643','2013-12-22','10:15:00',7.32),('7643','2013-12-22','10:20:00',8.08),('7643','2013-12-22','10:25:00',7.89),('7643','2013-12-22','10:30:00',7.34),('7643','2013-12-22','10:35:00',7.55),('7643','2013-12-22','10:40:00',8.03),('7643','2013-12-22','10:45:00',8.21),('7643','2013-12-22','10:50:00',7.32),('7643','2013-12-22','10:55:00',8.74),('7643','2013-12-22','11:00:00',9.66),('7643','2013-12-22','11:05:00',9.67),('7643','2013-12-22','11:10:00',9.86),('7643','2013-12-22','11:15:00',9.65),('7643','2013-12-22','11:20:00',9.38),('7643','2013-12-22','11:25:00',9.56),('7643','2013-12-22','11:30:00',9.48),('7643','2013-12-22','11:35:00',9.47),('7643','2013-12-22','11:40:00',9.63),('7643','2013-12-22','11:45:00',8.61),('7643','2013-12-22','11:50:00',8.78),('7643','2013-12-22','11:55:00',9.01),('7643','2013-12-22','12:00:00',9.56),('7643','2013-12-22','12:05:00',9.48),('7643','2013-12-22','12:10:00',9.33),('7643','2013-12-22','12:15:00',9.28),('7643','2013-12-22','12:20:00',9.11),('7643','2013-12-22','12:25:00',9.25),('7643','2013-12-22','12:30:00',9.39),('7643','2013-12-22','12:35:00',9.42),('7643','2013-12-22','12:40:00',9.47),('7643','2013-12-22','12:45:00',9.34),('7643','2013-12-22','12:50:00',9.28),('7643','2013-12-22','12:55:00',9.23),('7643','2013-12-22','13:00:00',9.19),('7643','2013-12-22','13:05:00',9.02),('7643','2013-12-22','13:10:00',8.86),('7643','2013-12-22','13:15:00',7.56),('7643','2013-12-22','13:20:00',7.01),('7643','2013-12-22','13:25:00',7.22),('7643','2013-12-22','13:30:00',8),('7643','2013-12-22','13:35:00',3.18),('7643','2013-12-22','13:40:00',6.2),('7643','2013-12-22','13:45:00',5.73),('7643','2013-12-22','13:50:00',6.51),('7643','2013-12-22','13:55:00',6.62),('7643','2013-12-22','14:00:00',7.41),('7643','2013-12-22','14:05:00',7.06),('7643','2013-12-22','14:10:00',6.87),('7643','2013-12-22','14:15:00',6.31),('7643','2013-12-22','14:20:00',6.21),('7643','2013-12-22','14:25:00',6.04),('7643','2013-12-22','14:30:00',5.36),('7643','2013-12-22','14:35:00',5.34),('7643','2013-12-22','14:40:00',5.05),('7643','2013-12-22','14:45:00',4.85),('7643','2013-12-22','14:50:00',4.63),('7643','2013-12-22','14:55:00',4.41),('7643','2013-12-22','15:00:00',4.21),('7643','2013-12-22','15:05:00',4.03),('7643','2013-12-22','15:10:00',3.72),('7643','2013-12-22','15:15:00',3.36),('7643','2013-12-22','15:20:00',3.01),('7643','2013-12-22','15:25:00',2.77),('7643','2013-12-22','15:30:00',2.45),('7643','2013-12-22','15:35:00',2.22),('7643','2013-12-22','15:40:00',1.99),('7643','2013-12-22','15:45:00',1.75),('7643','2013-12-22','15:50:00',1.49),('7643','2013-12-22','15:55:00',1.27),('7643','2013-12-22','16:00:00',1.05),('7643','2013-12-21','08:00:00',1.09),('7643','2013-12-21','08:05:00',1.32),('7643','2013-12-21','08:10:00',1.48),('7643','2013-12-21','08:15:00',1.57),('7643','2013-12-21','08:20:00',1.6),('7643','2013-12-21','08:25:00',1.71),('7643','2013-12-21','08:30:00',1.9),('7643','2013-12-21','08:35:00',2.07),('7643','2013-12-21','08:40:00',2.43),('7643','2013-12-21','08:47:00',2.51),('7643','2013-12-21','08:50:00',2.57),('7643','2013-12-21','08:55:00',2.62),('7643','2013-12-21','09:00:00',3.33),('7643','2013-12-21','09:05:00',4.24),('7643','2013-12-21','09:10:00',4.09),('7643','2013-12-21','09:15:00',4.23),('7643','2013-12-21','09:20:00',4.88),('7643','2013-12-21','09:25:00',4.74),('7643','2013-12-21','09:30:00',4.91),('7643','2013-12-21','09:35:00',6.78),('7643','2013-12-21','09:40:00',7.98),('7643','2013-12-21','09:45:00',8.3),('7643','2013-12-21','09:50:00',8.9),('7643','2013-12-21','09:55:00',8.9),('7643','2013-12-21','10:00:00',8.91),('7643','2013-12-21','10:05:00',9),('7643','2013-12-21','10:10:00',9.12),('7643','2013-12-21','10:15:00',8.94),('7643','2013-12-21','10:20:00',8.68),('7643','2013-12-21','10:25:00',8.73),('7643','2013-12-21','10:30:00',9.1),('7643','2013-12-21','10:35:00',8.46),('7643','2013-12-21','10:40:00',7.92),('7643','2013-12-21','10:45:00',8.45),('7643','2013-12-21','10:50:00',8.2),('7643','2013-12-21','10:55:00',7.85),('7643','2013-12-21','11:00:00',6.87),('7643','2013-12-21','11:05:00',7.73),('7643','2013-12-21','11:10:00',9.69),('7643','2013-12-21','11:15:00',9.41),('7643','2013-12-21','11:20:00',8.47),('7643','2013-12-21','11:25:00',8.74),('7643','2013-12-21','11:30:00',8.17),('7643','2013-12-21','11:35:00',8.08),('7643','2013-12-21','11:40:00',8.69),('7643','2013-12-21','11:45:00',8.09),('7643','2013-12-21','11:50:00',5.9),('7643','2013-12-21','11:55:00',4.39),('7643','2013-12-21','12:00:00',3.5),('7643','2013-12-21','12:05:00',3.19),('7643','2013-12-21','12:10:00',3.31),('7643','2013-12-21','12:15:00',3.64),('7643','2013-12-21','12:20:00',4.55),('7643','2013-12-21','12:25:00',4.78),('7643','2013-12-21','12:30:00',5.92),('7643','2013-12-21','12:35:00',6.78),('7643','2013-12-21','12:40:00',6.28),('7643','2013-12-21','12:45:00',6.27),('7643','2013-12-21','12:50:00',7.61),('7643','2013-12-21','12:55:00',9.49),('7643','2013-12-21','13:00:00',9.35),('7643','2013-12-21','13:05:00',10.68),('7643','2013-12-21','13:10:00',10.54),('7643','2013-12-21','13:15:00',7.83),('7643','2013-12-21','13:20:00',7.66),('7643','2013-12-21','13:25:00',7.56),('7643','2013-12-21','13:30:00',7.34),('7643','2013-12-21','13:35:00',6.68),('7643','2013-12-21','13:40:00',5.18),('7643','2013-12-21','13:45:00',6.39),('7643','2013-12-21','13:50:00',5.65),('7643','2013-12-21','13:55:00',5.33),('7643','2013-12-21','14:00:00',4.43),('7643','2013-12-21','14:05:00',5.33),('7643','2013-12-21','14:10:00',5.79),('7643','2013-12-21','14:15:00',4.31),('7643','2013-12-21','14:20:00',4.46),('7643','2013-12-21','14:25:00',3.9),('7643','2013-12-21','14:30:00',3.83),('7643','2013-12-21','14:35:00',4.46),('7643','2013-12-21','14:40:00',4.77),('7643','2013-12-21','14:45:00',4.56),('7643','2013-12-21','14:50:00',2.81),('7643','2013-12-21','14:55:00',2.74),('7643','2013-12-21','15:00:00',3),('7643','2013-12-21','15:05:00',2.7),('7643','2013-12-21','15:10:00',3.15),('7643','2013-12-21','15:15:00',2.02),('7643','2013-12-21','15:20:00',1.97),('7643','2013-12-21','15:25:00',1.69),('7643','2013-12-21','15:30:00',1.5),('7643','2013-12-21','15:35:00',1.28),('7643','2013-12-21','15:40:00',1.24),('7643','2013-12-21','15:45:00',1.44),('7643','2013-12-21','15:50:00',1.14),('7643','2013-12-21','15:55:00',1.04),('7643','2013-12-20','08:05:00',1.07),('7643','2013-12-20','08:10:00',1.37),('7643','2013-12-20','08:15:00',1.67),('7643','2013-12-20','08:20:00',1.96),('7643','2013-12-20','08:25:00',2.29),('7643','2013-12-20','08:30:00',2.59),('7643','2013-12-20','08:35:00',2.91),('7643','2013-12-20','08:40:00',3.19),('7643','2013-12-20','08:45:00',3.37),('7643','2013-12-20','08:50:00',3.73),('7643','2013-12-20','08:55:00',4.03),('7643','2013-12-20','09:00:00',4.35),('7643','2013-12-20','09:05:00',4.61),('7643','2013-12-20','09:10:00',4.8),('7643','2013-12-20','09:15:00',5.05),('7643','2013-12-20','09:20:00',5.37),('7643','2013-12-20','09:25:00',5.57),('7643','2013-12-20','09:30:00',5.83),('7643','2013-12-20','09:35:00',6.13),('7643','2013-12-20','09:40:00',6.43),('7643','2013-12-20','09:45:00',6.66),('7643','2013-12-20','09:50:00',6.91),('7643','2013-12-20','09:55:00',7.11),('7643','2013-12-20','10:00:00',7.33),('7643','2013-12-20','10:05:00',7.51),('7643','2013-12-20','10:10:00',7.71),('7643','2013-12-20','10:15:00',7.91),('7643','2013-12-20','10:20:00',8.06),('7643','2013-12-20','10:25:00',8.21),('7643','2013-12-20','10:30:00',8.4),('7643','2013-12-20','10:35:00',8.55),('7643','2013-12-20','10:40:00',8.67),('7643','2013-12-20','10:45:00',8.81),('7643','2013-12-20','10:50:00',8.92),('7643','2013-12-20','10:55:00',9.01),('7643','2013-12-20','11:00:00',9.2),('7643','2013-12-20','11:05:00',9.31),('7643','2013-12-20','11:10:00',9.35),('7643','2013-12-20','11:15:00',9.48),('7643','2013-12-20','11:20:00',9.55),('7643','2013-12-20','11:25:00',9.69),('7643','2013-12-20','11:30:00',9.77),('7643','2013-12-20','11:35:00',9.8),('7643','2013-12-20','11:40:00',9.85),('7643','2013-12-20','11:45:00',9.87),('7643','2013-12-20','11:50:00',9.9),('7643','2013-12-20','11:55:00',9.93),('7643','2013-12-20','12:00:00',9.97),('7643','2013-12-20','12:05:00',9.97),('7643','2013-12-20','12:10:00',9.92),('7643','2013-12-20','12:15:00',9.91),('7643','2013-12-20','12:20:00',9.87),('7643','2013-12-20','12:25:00',9.79),('7643','2013-12-20','12:30:00',9.75),('7643','2013-12-20','12:35:00',9.72),('7643','2013-12-20','12:40:00',9.64),('7643','2013-12-20','12:45:00',9.55),('7643','2013-12-20','12:50:00',9.53),('7643','2013-12-20','12:55:00',9.47),('7643','2013-12-20','13:00:00',9.28),('7643','2013-12-20','13:05:00',9.16),('7643','2013-12-20','13:10:00',9.02),('7643','2013-12-20','13:15:00',8.88),('7643','2013-12-20','13:20:00',8.68),('7643','2013-12-20','13:25:00',8.59),('7643','2013-12-20','13:30:00',8.39),('7643','2013-12-20','13:35:00',8.22),('7643','2013-12-20','13:40:00',8.06),('7643','2013-12-20','13:45:00',7.91),('7643','2013-12-20','13:50:00',7.73),('7643','2013-12-20','13:55:00',7.58),('7643','2013-12-20','14:00:00',7.38),('7643','2013-12-20','14:05:00',7.11),('7643','2013-12-20','14:10:00',6.89),('7643','2013-12-20','14:15:00',6.71),('7643','2013-12-20','14:20:00',6.62),('7643','2013-12-20','14:25:00',6.34),('7643','2013-12-20','14:30:00',6.12),('7643','2013-12-20','14:35:00',5.86),('7643','2013-12-20','14:40:00',5.6),('7643','2013-12-20','14:45:00',5.31),('7643','2013-12-20','14:50:00',5),('7643','2013-12-20','14:55:00',4.72),('7643','2013-12-20','15:00:00',4.45),('7643','2013-12-20','15:05:00',4.22),('7643','2013-12-20','15:10:00',3.92),('7643','2013-12-20','15:15:00',3.63),('7643','2013-12-20','15:20:00',3.37),('7643','2013-12-20','15:25:00',3.07),('7643','2013-12-20','15:30:00',2.75),('7643','2013-12-20','15:35:00',2.45),('7643','2013-12-20','15:40:00',2.18),('7643','2013-12-20','15:45:00',1.91),('7643','2013-12-20','15:50:00',1.67),('7643','2013-12-20','15:55:00',1.39),('7643','2013-12-20','16:00:00',1.13),('7643','2013-12-19','08:10:00',1.12),('7643','2013-12-19','08:15:00',1.94),('7643','2013-12-19','08:20:00',2.44),('7643','2013-12-19','08:25:00',2.66),('7643','2013-12-19','08:30:00',2.83),('7643','2013-12-19','08:35:00',2.91),('7643','2013-12-19','08:40:00',3.25),('7643','2013-12-19','08:45:00',3.43),('7643','2013-12-19','08:50:00',3.62),('7643','2013-12-19','08:55:00',3.81),('7643','2013-12-19','09:00:00',4.02),('7643','2013-12-19','09:05:00',4.36),('7643','2013-12-19','09:10:00',4.67),('7643','2013-12-19','09:15:00',4.94),('7643','2013-12-19','09:20:00',5.22),('7643','2013-12-19','09:25:00',5.53),('7643','2013-12-19','09:30:00',5.78),('7643','2013-12-19','09:35:00',6.02),('7643','2013-12-19','09:40:00',6.25),('7643','2013-12-19','09:45:00',6.45),('7643','2013-12-19','09:50:00',6.7),('7643','2013-12-19','09:55:00',6.85),('7643','2013-12-19','10:00:00',6.99),('7643','2013-12-19','10:05:00',7.3),('7643','2013-12-19','10:10:00',7.45),('7643','2013-12-19','10:15:00',7.56),('7643','2013-12-19','10:20:00',7.7),('7643','2013-12-19','10:25:00',7.87),('7643','2013-12-19','10:30:00',7.97),('7643','2013-12-19','10:35:00',8.07),('7643','2013-12-19','10:40:00',8.25),('7643','2013-12-19','10:45:00',8.41),('7643','2013-12-19','10:50:00',8.55),('7643','2013-12-19','10:55:00',8.66),('7643','2013-12-19','11:00:00',8.73),('7643','2013-12-19','11:05:00',8.88),('7643','2013-12-19','11:10:00',8.94),('7643','2013-12-19','11:15:00',8.99),('7643','2013-12-19','11:20:00',9.14),('7643','2013-12-19','11:25:00',9.18),('7643','2013-12-19','11:30:00',9.25),('7643','2013-12-19','11:35:00',9.3),('7643','2013-12-19','11:40:00',9.3),('7643','2013-12-19','11:45:00',9.37),('7643','2013-12-19','11:50:00',9.31),('7643','2013-12-19','11:55:00',9.34),('7643','2013-12-19','12:00:00',9.44),('7643','2013-12-19','12:05:00',9.3),('7643','2013-12-19','12:10:00',9.37),('7643','2013-12-19','12:15:00',9.28),('7643','2013-12-19','12:20:00',9.29),('7643','2013-12-19','12:25:00',9.18),('7643','2013-12-19','12:30:00',9.26),('7643','2013-12-19','12:35:00',9.13),('7643','2013-12-19','12:40:00',8.94),('7643','2013-12-19','12:45:00',8.9),('7643','2013-12-19','12:50:00',8.74),('7643','2013-12-19','12:55:00',8.58),('7643','2013-12-19','13:00:00',8.57),('7643','2013-12-19','13:05:00',8.55),('7643','2013-12-19','13:10:00',8.43),('7643','2013-12-19','13:15:00',8.2),('7643','2013-12-19','13:20:00',7.76),('7643','2013-12-19','13:25:00',7.58),('7643','2013-12-19','13:30:00',7.49),('7643','2013-12-19','13:35:00',7.59),('7643','2013-12-19','13:40:00',7.1),('7643','2013-12-19','13:45:00',7.01),('7643','2013-12-19','13:50:00',6.9),('7643','2013-12-19','13:55:00',6.49),('7643','2013-12-19','14:00:00',6.23),('7643','2013-12-19','14:05:00',2.45),('7643','2013-12-19','14:10:00',2.12),('7643','2013-12-19','14:15:00',1.81),('7643','2013-12-19','14:20:00',1.69),('7643','2013-12-19','14:25:00',1.7),('7643','2013-12-19','14:30:00',2.11),('7643','2013-12-19','14:35:00',1.62),('7643','2013-12-19','14:40:00',3.07),('7643','2013-12-19','14:45:00',2.75),('7643','2013-12-19','14:50:00',1.77),('7643','2013-12-19','14:55:00',1.43),('7643','2013-12-19','15:00:00',1.32),('7643','2013-12-19','15:05:00',1.21),('7643','2013-12-18','08:25:00',1.38),('7643','2013-12-18','08:30:00',1.35),('7643','2013-12-18','08:35:00',1.35),('7643','2013-12-18','08:40:00',1.53),('7643','2013-12-18','08:45:00',2.49),('7643','2013-12-18','08:50:00',3.62),('7643','2013-12-18','08:55:00',4.07),('7643','2013-12-18','09:00:00',4.68),('7643','2013-12-18','09:05:00',5.22),('7643','2013-12-18','09:10:00',5.03),('7643','2013-12-18','09:15:00',4.09),('7643','2013-12-18','09:20:00',6.34),('7643','2013-12-18','09:25:00',6.31),('7643','2013-12-18','09:30:00',6.11),('7643','2013-12-18','09:35:00',6.88),('7643','2013-12-18','09:40:00',4.61),('7643','2013-12-18','09:45:00',3.54),('7643','2013-12-18','09:50:00',6.84),('7643','2013-12-18','09:55:00',8.38),('7643','2013-12-18','10:00:00',7.76),('7643','2013-12-18','10:05:00',7.35),('7643','2013-12-18','10:10:00',7.87),('7643','2013-12-18','10:15:00',7.92),('7643','2013-12-18','10:20:00',4.85),('7643','2013-12-18','10:25:00',3.09),('7643','2013-12-18','10:30:00',4.19),('7643','2013-12-18','10:35:00',3.5),('7643','2013-12-18','10:40:00',5.03),('7643','2013-12-18','10:45:00',5.9),('7643','2013-12-18','10:50:00',9.53),('7643','2013-12-18','10:55:00',5.36),('7643','2013-12-18','11:00:00',2.48),('7643','2013-12-18','11:05:00',2.32),('7643','2013-12-18','11:10:00',3.4),('7643','2013-12-18','11:15:00',6.95),('7643','2013-12-18','11:20:00',4.74),('7643','2013-12-18','11:25:00',3.29),('7643','2013-12-18','11:30:00',2.49),('7643','2013-12-18','11:35:00',2.15),('7643','2013-12-18','11:40:00',1.88),('7643','2013-12-18','11:45:00',1.5),('7643','2013-12-18','11:50:00',1.13),('7643','2013-12-18','11:55:00',1.23),('7643','2013-12-18','12:00:00',1.03),('7643','2013-12-18','12:10:00',1.12),('7643','2013-12-18','12:15:00',1.25),('7643','2013-12-18','12:20:00',1.5),('7643','2013-12-18','12:25:00',1.96),('7643','2013-12-18','12:30:00',2),('7643','2013-12-18','12:35:00',2.34),('7643','2013-12-18','12:40:00',2.7),('7643','2013-12-18','12:45:00',2.7),('7643','2013-12-18','12:50:00',2.44),('7643','2013-12-18','12:55:00',2.2),('7643','2013-12-18','13:00:00',2.19),('7643','2013-12-18','13:05:00',2),('7643','2013-12-18','13:10:00',1.8),('7643','2013-12-18','13:15:00',1.76),('7643','2013-12-18','13:20:00',1.87),('7643','2013-12-18','13:25:00',1.79),('7643','2013-12-18','13:30:00',1.78),('7643','2013-12-18','13:35:00',1.74),('7643','2013-12-18','13:40:00',1.82),('7643','2013-12-18','13:45:00',1.94),('7643','2013-12-18','13:50:00',2.06),('7643','2013-12-18','13:55:00',2.27),('7643','2013-12-18','14:00:00',2.68),('7643','2013-12-18','14:05:00',2.82),('7643','2013-12-18','14:10:00',2.73),('7643','2013-12-18','14:15:00',2.69),('7643','2013-12-18','14:20:00',4.42),('7643','2013-12-18','14:25:00',4.74),('7643','2013-12-18','14:30:00',6.68),('7643','2013-12-18','14:35:00',5.22),('7643','2013-12-18','14:40:00',5.22),('7643','2013-12-18','14:45:00',4.55),('7643','2013-12-18','14:50:00',2.56),('7643','2013-12-18','14:55:00',1.82),('7643','2013-12-18','15:00:00',1.27),('7643','2013-12-18','15:05:00',1.46),('7643','2013-12-18','15:10:00',1.51),('7643','2013-12-18','15:15:00',1.38),('7643','2013-12-18','15:20:00',1.37),('7643','2013-12-18','15:25:00',1.61),('7643','2013-12-18','15:30:00',1.53),('7643','2013-12-18','15:35:00',1.31),('7643','2013-12-18','15:40:00',1.26),('7643','2013-12-18','15:45:00',1.01),('7643','2013-12-17','08:00:00',1.12),('7643','2013-12-17','08:05:00',1.38),('7643','2013-12-17','08:10:00',1.65),('7643','2013-12-17','08:15:00',1.96),('7643','2013-12-17','08:20:00',2.21),('7643','2013-12-17','08:25:00',2.57),('7643','2013-12-17','08:30:00',2.79),('7643','2013-12-17','08:35:00',3.03),('7643','2013-12-17','08:40:00',3.3),('7643','2013-12-17','08:45:00',3.62),('7643','2013-12-17','08:50:00',3.91),('7643','2013-12-17','08:55:00',4.21),('7643','2013-12-17','09:00:00',4.5),('7643','2013-12-17','09:05:00',4.78),('7643','2013-12-17','09:10:00',5.08),('7643','2013-12-17','09:15:00',5.32),('7643','2013-12-17','09:20:00',5.59),('7643','2013-12-17','09:25:00',5.87),('7643','2013-12-17','09:30:00',6.11),('7643','2013-12-17','09:35:00',6.34),('7643','2013-12-17','09:40:00',6.58),('7643','2013-12-17','09:45:00',6.83),('7643','2013-12-17','09:50:00',7.05),('7643','2013-12-17','09:55:00',7.28),('7643','2013-12-17','10:00:00',7.54),('7643','2013-12-17','10:05:00',7.7),('7643','2013-12-17','10:10:00',7.91),('7643','2013-12-17','10:15:00',8.13),('7643','2013-12-17','10:20:00',8.27),('7643','2013-12-17','10:25:00',8.42),('7643','2013-12-17','10:30:00',8.61),('7643','2013-12-17','10:35:00',8.77),('7643','2013-12-17','10:40:00',8.87),('7643','2013-12-17','10:45:00',8.95),('7643','2013-12-17','10:50:00',9.07),('7643','2013-12-17','10:55:00',9.12),('7643','2013-12-17','11:00:00',9.19),('7643','2013-12-17','11:05:00',9.32),('7643','2013-12-17','11:10:00',9.43),('7643','2013-12-17','11:15:00',9.48),('7643','2013-12-17','11:20:00',9.47),('7643','2013-12-17','11:25:00',9.51),('7643','2013-12-17','11:30:00',9.49),('7643','2013-12-17','11:35:00',9.6),('7643','2013-12-17','11:40:00',9.62),('7643','2013-12-17','11:45:00',9.61),('7643','2013-12-17','11:50:00',9.61),('7643','2013-12-17','11:55:00',9.6),('7643','2013-12-17','12:00:00',9.59),('7643','2013-12-17','12:05:00',9.58),('7643','2013-12-17','12:10:00',9.63),('7643','2013-12-17','12:15:00',9.62),('7643','2013-12-17','12:20:00',9.56),('7643','2013-12-17','12:25:00',9.53),('7643','2013-12-17','12:30:00',9.48),('7643','2013-12-17','12:35:00',9.44),('7643','2013-12-17','12:40:00',9.42),('7643','2013-12-17','12:45:00',9.26),('7643','2013-12-17','12:50:00',9.24),('7643','2013-12-17','12:55:00',9.15),('7643','2013-12-17','13:00:00',9.15),('7643','2013-12-17','13:05:00',8.92),('7643','2013-12-17','13:10:00',8.55),('7643','2013-12-17','13:15:00',8.43),('7643','2013-12-17','13:20:00',8.31),('7643','2013-12-17','13:25:00',8.22),('7643','2013-12-17','13:30:00',8.17),('7643','2013-12-17','13:35:00',7.91),('7643','2013-12-17','13:40:00',7.74),('7643','2013-12-17','13:45:00',7.51),('7643','2013-12-17','13:50:00',7.22),('7643','2013-12-17','13:55:00',6.92),('7643','2013-12-17','14:00:00',6.87),('7643','2013-12-17','14:05:00',6.65),('7643','2013-12-17','14:10:00',6.35),('7643','2013-12-17','14:15:00',6.16),('7643','2013-12-17','14:20:00',6.16),('7643','2013-12-17','14:25:00',5.96),('7643','2013-12-17','14:30:00',5.82),('7643','2013-12-17','14:35:00',5.62),('7643','2013-12-17','14:40:00',5.38),('7643','2013-12-17','14:45:00',5.1),('7643','2013-12-17','14:50:00',4.82),('7643','2013-12-17','14:55:00',4.61),('7643','2013-12-17','15:00:00',4.37),('7643','2013-12-17','15:05:00',4.1),('7643','2013-12-17','15:10:00',3.81),('7643','2013-12-17','15:15:00',3.53),('7643','2013-12-17','15:20:00',3.3),('7643','2013-12-17','15:25:00',2.93),('7643','2013-12-17','15:30:00',2.69),('7643','2013-12-17','15:35:00',2.41),('7643','2013-12-17','15:40:00',2.09),('7643','2013-12-17','15:45:00',1.8),('7643','2013-12-17','15:50:00',1.38),('7643','2013-12-17','15:55:00',1.13),('7643','2014-04-21','07:05:00',1.04),('7643','2014-04-21','07:10:00',1.28),('7643','2014-04-21','07:15:00',1.53),('7643','2014-04-21','07:20:00',1.78),('7643','2014-04-21','07:25:00',2.02),('7643','2014-04-21','07:30:00',2.3),('7643','2014-04-21','07:35:00',2.59),('7643','2014-04-21','07:40:00',2.91),('7643','2014-04-21','07:45:00',3.22),('7643','2014-04-21','07:50:00',3.59),('7643','2014-04-21','07:55:00',3.95),('7643','2014-04-21','08:00:00',4.28),('7643','2014-04-21','08:05:00',4.65),('7643','2014-04-21','08:10:00',5.07),('7643','2014-04-21','08:15:00',5.45),('7643','2014-04-21','08:20:00',5.83),('7643','2014-04-21','08:25:00',6.2),('7643','2014-04-21','08:30:00',6.58),('7643','2014-04-21','08:35:00',6.97),('7643','2014-04-21','08:40:00',7.39),('7643','2014-04-21','08:45:00',7.62),('7643','2014-04-21','08:50:00',7.86),('7643','2014-04-21','08:55:00',8.12),('7643','2014-04-21','09:00:00',8.49),('7643','2014-04-21','09:05:00',9.29),('7643','2014-04-21','09:10:00',9.1),('7643','2014-04-21','09:15:00',8.65),('7643','2014-04-21','09:20:00',9.58),('7643','2014-04-21','09:25:00',10.43),('7643','2014-04-21','09:30:00',10.39),('7643','2014-04-21','09:35:00',10.89),('7643','2014-04-21','09:40:00',10.64),('7643','2014-04-21','09:45:00',11.5),('7643','2014-04-21','09:50:00',9.67),('7643','2014-04-21','09:55:00',5.65),('7643','2014-04-21','10:00:00',5.19),('7643','2014-04-21','10:05:00',5.47),('7643','2014-04-21','10:10:00',7.14),('7643','2014-04-21','10:15:00',8.51),('7643','2014-04-21','10:20:00',12.2),('7643','2014-04-21','10:25:00',8.36),('7643','2014-04-21','10:30:00',13.89),('7643','2014-04-21','10:35:00',14.79),('7643','2014-04-21','10:40:00',13.49),('7643','2014-04-21','10:45:00',13.8),('7643','2014-04-21','10:50:00',14.96),('7643','2014-04-21','10:55:00',11.8),('7643','2014-04-21','11:00:00',7.73),('7643','2014-04-21','11:05:00',9.4),('7643','2014-04-21','11:10:00',6.4),('7643','2014-04-21','11:15:00',5.26),('7643','2014-04-21','11:20:00',4.54),('7643','2014-04-21','11:25:00',4.74),('7643','2014-04-21','11:30:00',4.23),('7643','2014-04-21','11:35:00',4.47),('7643','2014-04-21','11:40:00',4.08),('7643','2014-04-21','11:45:00',3.44),('7643','2014-04-21','11:50:00',3.39),('7643','2014-04-21','11:55:00',3.16),('7643','2014-04-21','12:00:00',3.54),('7643','2014-04-21','12:05:00',4.35),('7643','2014-04-21','12:10:00',4.54),('7643','2014-04-21','12:15:00',4.66),('7643','2014-04-21','12:20:00',4.91),('7643','2014-04-21','12:25:00',5.29),('7643','2014-04-21','12:30:00',6.18),('7643','2014-04-21','12:35:00',5.46),('7643','2014-04-21','12:40:00',4.01),('7643','2014-04-21','12:45:00',3.28),('7643','2014-04-21','12:50:00',2.82),('7643','2014-04-21','12:55:00',2.65),('7643','2014-04-21','13:00:00',2.61),('7643','2014-04-21','13:05:00',2.82),('7643','2014-04-21','13:10:00',3.33),('7643','2014-04-21','13:15:00',5.32),('7643','2014-04-21','13:20:00',9.03),('7643','2014-04-21','13:25:00',10.23),('7643','2014-04-21','13:30:00',11.52),('7643','2014-04-21','13:35:00',10.26),('7643','2014-04-21','13:40:00',13.02),('7643','2014-04-21','13:45:00',13.33),('7643','2014-04-21','13:50:00',10.93),('7643','2014-04-21','13:55:00',6),('7643','2014-04-21','14:00:00',5.17),('7643','2014-04-21','14:05:00',6.1),('7643','2014-04-21','14:10:00',13.28),('7643','2014-04-21','14:15:00',13.22),('7643','2014-04-21','14:20:00',15.71),('7643','2014-04-21','14:25:00',9.93),('7643','2014-04-21','14:30:00',7.93),('7643','2014-04-21','14:35:00',9.36),('7643','2014-04-21','14:40:00',12.44),('7643','2014-04-21','14:45:00',15.97),('7643','2014-04-21','14:50:00',12.24),('7643','2014-04-21','14:55:00',10.94),('7643','2014-04-21','15:00:00',5),('7643','2014-04-21','15:05:00',4.89),('7643','2014-04-21','15:10:00',4.42),('7643','2014-04-21','15:15:00',4.31),('7643','2014-04-21','15:20:00',4.77),('7643','2014-04-21','15:25:00',5.53),('7643','2014-04-21','15:30:00',6.82),('7643','2014-04-21','15:35:00',10.13),('7643','2014-04-21','15:40:00',8.84),('7643','2014-04-21','15:45:00',6.97),('7643','2014-04-21','15:50:00',8.38),('7643','2014-04-21','15:55:00',6.83),('7643','2014-04-21','16:00:00',8.09),('7643','2014-04-21','16:05:00',5.68),('7643','2014-04-21','16:10:00',5.35),('7643','2014-04-21','16:15:00',5.14),('7643','2014-04-21','16:20:00',6.26),('7643','2014-04-21','16:25:00',5.73),('7643','2014-04-21','16:30:00',4.8),('7643','2014-04-21','16:35:00',4.8),('7643','2014-04-21','16:40:00',6.53),('7643','2014-04-21','16:45:00',6.64),('7643','2014-04-21','16:50:00',4.98),('7643','2014-04-21','16:55:00',4.29),('7643','2014-04-21','17:00:00',4.69),('7643','2014-04-21','17:05:00',5.25),('7643','2014-04-21','17:10:00',4.24),('7643','2014-04-21','17:15:00',3.78),('7643','2014-04-21','17:20:00',2.84),('7643','2014-04-21','17:25:00',2.41),('7643','2014-04-21','17:30:00',2.28),('7643','2014-04-21','17:35:00',2.6),('7643','2014-04-21','17:40:00',2.55),('7643','2014-04-21','17:45:00',2.28),('7643','2014-04-21','17:50:00',2.17),('7643','2014-04-21','17:55:00',1.82),('7643','2014-04-21','18:00:00',1.42),('7643','2014-04-21','18:05:00',1.07),('7643','2013-12-16','08:00:00',1.33),('7643','2013-12-16','08:05:00',1.61),('7643','2013-12-16','08:10:00',1.92),('7643','2013-12-16','08:15:00',2.24),('7643','2013-12-16','08:20:00',2.53),('7643','2013-12-16','08:25:00',2.81),('7643','2013-12-16','08:30:00',3.11),('7643','2013-12-16','08:35:00',3.43),('7643','2013-12-16','08:40:00',3.75),('7643','2013-12-16','08:45:00',4.09),('7643','2013-12-16','08:50:00',4.37),('7643','2013-12-16','08:55:00',4.68),('7643','2013-12-16','09:00:00',4.98),('7643','2013-12-16','09:05:00',5.23),('7643','2013-12-16','09:10:00',5.56),('7643','2013-12-16','09:15:00',5.76),('7643','2013-12-16','09:20:00',6.04),('7643','2013-12-16','09:25:00',6.27),('7643','2013-12-16','09:30:00',6.51),('7643','2013-12-16','09:35:00',6.74),('7643','2013-12-16','09:40:00',6.98),('7643','2013-12-16','09:45:00',7.2),('7643','2013-12-16','09:50:00',7.46),('7643','2013-12-16','09:55:00',7.65),('7643','2013-12-16','10:00:00',7.88),('7643','2013-12-16','10:05:00',8.07),('7643','2013-12-16','10:10:00',8.24),('7643','2013-12-16','10:15:00',8.43),('7643','2013-12-16','10:20:00',8.59),('7643','2013-12-16','10:25:00',8.8),('7643','2013-12-16','10:30:00',9.03),('7643','2013-12-16','10:35:00',9.13),('7643','2013-12-16','10:40:00',9.23),('7643','2013-12-16','10:45:00',9.39),('7643','2013-12-16','10:50:00',9.41),('7643','2013-12-16','10:55:00',9.5),('7643','2013-12-16','11:00:00',9.61),('7643','2013-12-16','11:05:00',9.71),('7643','2013-12-16','11:10:00',9.78),('7643','2013-12-16','11:15:00',9.81),('7643','2013-12-16','11:20:00',9.87),('7643','2013-12-16','11:25:00',9.9),('7643','2013-12-16','11:30:00',9.99),('7643','2013-12-16','11:35:00',10.04),('7643','2013-12-16','11:40:00',10.07),('7643','2013-12-16','11:45:00',10.09),('7643','2013-12-16','11:50:00',10.27),('7643','2013-12-16','11:55:00',10.2),('7643','2013-12-16','12:00:00',10.18),('7643','2013-12-16','12:05:00',10.16),('7643','2013-12-16','12:10:00',10.12),('7643','2013-12-16','12:15:00',10.1),('7643','2013-12-16','12:20:00',10.1),('7643','2013-12-16','12:25:00',10.04),('7643','2013-12-16','12:30:00',9.98),('7643','2013-12-16','12:35:00',9.88),('7643','2013-12-16','12:40:00',9.9),('7643','2013-12-16','12:45:00',9.82),('7643','2013-12-16','12:50:00',9.69),('7643','2013-12-16','12:55:00',9.58),('7643','2013-12-16','13:00:00',9.45),('7643','2013-12-16','13:05:00',9.33),('7643','2013-12-16','13:10:00',9.12),('7643','2013-12-16','13:15:00',8.98),('7643','2013-12-16','13:20:00',8.77),('7643','2013-12-16','13:25:00',8.59),('7643','2013-12-16','13:30:00',8.54),('7643','2013-12-16','13:35:00',8.49),('7643','2013-12-16','13:40:00',8.36),('7643','2013-12-16','13:45:00',8.13),('7643','2013-12-16','13:50:00',7.93),('7643','2013-12-16','13:55:00',7.76),('7643','2013-12-16','14:00:00',7.55),('7643','2013-12-16','14:05:00',7.26),('7643','2013-12-16','14:10:00',7.05),('7643','2013-12-16','14:15:00',6.79),('7643','2013-12-16','14:20:00',6.56),('7643','2013-12-16','14:25:00',6.28),('7643','2013-12-16','14:30:00',6.07),('7643','2013-12-16','14:35:00',5.88),('7643','2013-12-16','14:40:00',5.6),('7643','2013-12-16','14:45:00',5.26),('7643','2013-12-16','14:50:00',5.01),('7643','2013-12-16','14:55:00',4.83),('7643','2013-12-16','15:00:00',4.67),('7643','2013-12-16','15:05:00',4.39),('7643','2013-12-16','15:10:00',4.13),('7643','2013-12-16','15:15:00',3.82),('7643','2013-12-16','15:20:00',3.52),('7643','2013-12-16','15:25:00',3.23),('7643','2013-12-16','15:30:00',2.91),('7643','2013-12-16','15:35:00',2.62),('7643','2013-12-16','15:40:00',2.33),('7643','2013-12-16','15:45:00',2.05),('7643','2013-12-16','15:50:00',1.76),('7643','2013-12-16','15:55:00',1.5),('7643','2013-12-16','16:00:00',1.23),('7643','2013-12-15','08:00:00',1.28),('7643','2013-12-15','08:05:00',1.56),('7643','2013-12-15','08:10:00',1.85),('7643','2013-12-15','08:15:00',2.15),('7643','2013-12-15','08:20:00',2.45),('7643','2013-12-15','08:25:00',2.78),('7643','2013-12-15','08:30:00',3.09),('7643','2013-12-15','08:35:00',3.4),('7643','2013-12-15','08:40:00',3.7),('7643','2013-12-15','08:45:00',3.99),('7643','2013-12-15','08:50:00',4.29),('7643','2013-12-15','08:55:00',4.58),('7643','2013-12-15','09:00:00',4.89),('7643','2013-12-15','09:05:00',5.2),('7643','2013-12-15','09:10:00',5.48),('7643','2013-12-15','09:15:00',5.72),('7643','2013-12-15','09:20:00',5.93),('7643','2013-12-15','09:25:00',6.19),('7643','2013-12-15','09:30:00',6.46),('7643','2013-12-15','09:35:00',6.71),('7643','2013-12-15','09:40:00',6.95),('7643','2013-12-15','09:45:00',7.19),('7643','2013-12-15','09:50:00',7.4),('7643','2013-12-15','09:55:00',7.58),('7643','2013-12-15','10:00:00',7.74),('7643','2013-12-15','10:05:00',7.96),('7643','2013-12-15','10:10:00',8.1),('7643','2013-12-15','10:15:00',8.25),('7643','2013-12-15','10:20:00',8.28),('7643','2013-12-15','10:25:00',8.38),('7643','2013-12-15','10:30:00',8.53),('7643','2013-12-15','10:35:00',8.64),('7643','2013-12-15','10:40:00',8.81),('7643','2013-12-15','10:45:00',8.94),('7643','2013-12-15','10:50:00',9.05),('7643','2013-12-15','10:55:00',9.19),('7643','2013-12-15','11:00:00',9.31),('7643','2013-12-15','11:05:00',9.37),('7643','2013-12-15','11:10:00',9.43),('7643','2013-12-15','11:15:00',9.44),('7643','2013-12-15','11:20:00',9.49),('7643','2013-12-15','11:25:00',9.63),('7643','2013-12-15','11:30:00',9.68),('7643','2013-12-15','11:35:00',9.7),('7643','2013-12-15','11:40:00',9.8),('7643','2013-12-15','11:45:00',9.75),('7643','2013-12-15','11:50:00',9.8),('7643','2013-12-15','11:55:00',9.83),('7643','2013-12-15','12:00:00',9.96),('7643','2013-12-15','12:05:00',10.02),('7643','2013-12-15','12:10:00',10.11),('7643','2013-12-15','12:15:00',10.05),('7643','2013-12-15','12:20:00',10.1),('7643','2013-12-15','12:25:00',10.01),('7643','2013-12-15','12:30:00',9.88),('7643','2013-12-15','12:35:00',9.75),('7643','2013-12-15','12:40:00',9.71),('7643','2013-12-15','12:45:00',9.62),('7643','2013-12-15','12:50:00',9.63),('7643','2013-12-15','12:55:00',9.52),('7643','2013-12-15','13:00:00',9.49),('7643','2013-12-15','13:05:00',9.37),('7643','2013-12-15','13:10:00',9.18),('7643','2013-12-15','13:15:00',9.02),('7643','2013-12-15','13:20:00',8.82),('7643','2013-12-15','13:25:00',8.6),('7643','2013-12-15','13:30:00',8.45),('7643','2013-12-15','13:35:00',8.24),('7643','2013-12-15','13:40:00',8.06),('7643','2013-12-15','13:45:00',7.92),('7643','2013-12-15','13:50:00',7.81),('7643','2013-12-15','13:55:00',7.64),('7643','2013-12-15','14:00:00',7.27),('7643','2013-12-15','14:05:00',7.13),('7643','2013-12-15','14:10:00',6.91),('7643','2013-12-15','14:15:00',6.7),('7643','2013-12-15','14:20:00',6.5),('7643','2013-12-15','14:25:00',6.28),('7643','2013-12-15','14:30:00',6.01),('7643','2013-12-15','14:35:00',5.77),('7643','2013-12-15','14:40:00',5.5),('7643','2013-12-15','14:45:00',5.22),('7643','2013-12-15','14:50:00',4.94),('7643','2013-12-15','14:55:00',4.67),('7643','2013-12-15','15:00:00',4.44),('7643','2013-12-15','15:05:00',4.09),('7643','2013-12-15','15:10:00',3.84),('7643','2013-12-15','15:15:00',3.62),('7643','2013-12-15','15:20:00',3.39),('7643','2013-12-15','15:25:00',3.09),('7643','2013-12-15','15:30:00',2.8),('7643','2013-12-15','15:35:00',2.46),('7643','2013-12-15','15:40:00',2.12),('7643','2013-12-15','15:45:00',1.85),('7643','2013-12-15','15:50:00',1.57),('7643','2013-12-15','15:55:00',1.3),('7643','2013-12-15','16:00:00',1.08),('7643','2013-12-14','08:50:00',1.09),('7643','2013-12-14','08:55:00',1.3),('7643','2013-12-14','09:00:00',1.51),('7643','2013-12-14','09:05:00',1.55),('7643','2013-12-14','09:10:00',1.26),('7643','2013-12-14','09:15:00',1.22),('7643','2013-12-14','09:20:00',1.27),('7643','2013-12-14','09:25:00',1.49),('7643','2013-12-14','09:30:00',1.46),('7643','2013-12-14','09:35:00',1.5),('7643','2013-12-14','09:40:00',1.72),('7643','2013-12-14','09:45:00',2.18),('7643','2013-12-14','09:50:00',2.54),('7643','2013-12-14','09:55:00',2.59),('7643','2013-12-14','10:00:00',2.6),('7643','2013-12-14','10:05:00',2.63),('7643','2013-12-14','10:10:00',2.76),('7643','2013-12-14','10:15:00',3.09),('7643','2013-12-14','10:20:00',5.46),('7643','2013-12-14','10:25:00',4.93),('7643','2013-12-14','10:30:00',4.15),('7643','2013-12-14','10:35:00',4.7),('7643','2013-12-14','10:40:00',4.64),('7643','2013-12-14','10:45:00',4.74),('7643','2013-12-14','10:50:00',3.76),('7643','2013-12-14','10:55:00',3.03),('7643','2013-12-14','11:00:00',2.96),('7643','2013-12-14','11:05:00',2.87),('7643','2013-12-14','11:10:00',2.76),('7643','2013-12-14','11:15:00',2.79),('7643','2013-12-14','11:20:00',3.13),('7643','2013-12-14','11:25:00',3.17),('7643','2013-12-14','11:30:00',3.09),('7643','2013-12-14','11:35:00',3.22),('7643','2013-12-14','11:40:00',3.33),('7643','2013-12-14','11:45:00',3.46),('7643','2013-12-14','11:50:00',3.39),('7643','2013-12-14','11:55:00',3.37),('7643','2013-12-14','12:00:00',3.4),('7643','2013-12-14','12:05:00',3.46),('7643','2013-12-14','12:10:00',3.21),('7643','2013-12-14','12:15:00',2.96),('7643','2013-12-14','12:20:00',3.21),('7643','2013-12-14','12:25:00',2.61),('7643','2013-12-14','12:30:00',1.86),('7643','2013-12-14','12:35:00',1.93),('7643','2013-12-14','12:40:00',2.13),('7643','2013-12-14','12:45:00',2.46),('7643','2013-12-14','12:50:00',2.54),('7643','2013-12-14','12:55:00',2.01),('7643','2013-12-14','13:00:00',1.46),('7643','2013-12-14','13:05:00',1.37),('7643','2013-12-14','13:10:00',1.44),('7643','2013-12-14','13:15:00',1.32),('7643','2013-12-14','13:20:00',1.09),('7643','2013-12-13','08:00:00',1.18),('7643','2013-12-13','08:05:00',1.44),('7643','2013-12-13','08:10:00',1.71),('7643','2013-12-13','08:15:00',2),('7643','2013-12-13','08:20:00',2.27),('7643','2013-12-13','08:25:00',2.54),('7643','2013-12-13','08:30:00',2.73),('7643','2013-12-13','08:35:00',3.01),('7643','2013-12-13','08:40:00',3.29),('7643','2013-12-13','08:45:00',3.59),('7643','2013-12-13','08:50:00',3.86),('7643','2013-12-13','08:55:00',4.21),('7643','2013-12-13','09:00:00',4.59),('7643','2013-12-13','09:05:00',4.96),('7643','2013-12-13','09:10:00',5.25),('7643','2013-12-13','09:15:00',5.53),('7643','2013-12-13','09:20:00',5.84),('7643','2013-12-13','09:25:00',6.09),('7643','2013-12-13','09:30:00',6.33),('7643','2013-12-13','09:35:00',6.57),('7643','2013-12-13','09:40:00',6.76),('7643','2013-12-13','09:45:00',6.98),('7643','2013-12-13','09:50:00',7.2),('7643','2013-12-13','09:55:00',7.41),('7643','2013-12-13','10:00:00',7.58),('7643','2013-12-13','10:05:00',7.76),('7643','2013-12-13','10:10:00',7.93),('7643','2013-12-13','10:15:00',8.15),('7643','2013-12-13','10:20:00',8.29),('7643','2013-12-13','10:25:00',8.37),('7643','2013-12-13','10:30:00',8.53),('7643','2013-12-13','10:35:00',8.67),('7643','2013-12-13','10:40:00',8.79),('7643','2013-12-13','10:45:00',8.85),('7643','2013-12-13','10:50:00',8.93),('7643','2013-12-13','10:55:00',9.07),('7643','2013-12-13','11:00:00',9.06),('7643','2013-12-13','11:05:00',9.02),('7643','2013-12-13','11:10:00',9.14),('7643','2013-12-13','11:15:00',9.24),('7643','2013-12-13','11:20:00',9.34),('7643','2013-12-13','11:25:00',9.32),('7643','2013-12-13','11:30:00',9.4),('7643','2013-12-13','11:35:00',9.28),('7643','2013-12-13','11:40:00',9.4),('7643','2013-12-13','11:45:00',9.43),('7643','2013-12-13','11:50:00',9.3),('7643','2013-12-13','11:55:00',9.31),('7643','2013-12-13','12:00:00',9.19),('7643','2013-12-13','12:05:00',9.09),('7643','2013-12-13','12:10:00',9.2),('7643','2013-12-13','12:15:00',9.19),('7643','2013-12-13','12:20:00',9.16),('7643','2013-12-13','12:25:00',9.06),('7643','2013-12-13','12:30:00',8.78),('7643','2013-12-13','12:35:00',9.23),('7643','2013-12-13','12:40:00',9.06),('7643','2013-12-13','12:45:00',9.07),('7643','2013-12-13','12:50:00',9.13),('7643','2013-12-13','12:55:00',8.89),('7643','2013-12-13','13:00:00',8.65),('7643','2013-12-13','13:05:00',8.63),('7643','2013-12-13','13:10:00',8.69),('7643','2013-12-13','13:15:00',8.53),('7643','2013-12-13','13:20:00',8.38),('7643','2013-12-13','13:25:00',8.35),('7643','2013-12-13','13:30:00',8.36),('7643','2013-12-13','13:35:00',8.04),('7643','2013-12-13','13:40:00',7.9),('7643','2013-12-13','13:45:00',7.88),('7643','2013-12-13','13:50:00',7.58),('7643','2013-12-13','13:55:00',7.38),('7643','2013-12-13','14:00:00',7.24),('7643','2013-12-13','14:05:00',7.02),('7643','2013-12-13','14:10:00',6.89),('7643','2013-12-13','14:15:00',6.61),('7643','2013-12-13','14:20:00',6.32),('7643','2013-12-13','14:25:00',6.11),('7643','2013-12-13','14:30:00',5.86),('7643','2013-12-13','14:35:00',5.63),('7643','2013-12-13','14:40:00',5.32),('7643','2013-12-13','14:45:00',5.04),('7643','2013-12-13','14:50:00',4.72),('7643','2013-12-13','14:55:00',4.35),('7643','2013-12-13','15:00:00',4.16),('7643','2013-12-13','15:05:00',3.95),('7643','2013-12-13','15:10:00',3.67),('7643','2013-12-13','15:15:00',3.5),('7643','2013-12-13','15:20:00',3.24),('7643','2013-12-13','15:25:00',3.02),('7643','2013-12-13','15:30:00',2.71),('7643','2013-12-13','15:35:00',2.47),('7643','2013-12-13','15:40:00',2.17),('7643','2013-12-13','15:45:00',1.84),('7643','2013-12-13','15:50:00',1.6),('7643','2013-12-13','15:55:00',1.32),('7643','2013-12-13','16:00:00',1.08),('7643','2013-12-12','08:05:00',1.21),('7643','2013-12-12','08:10:00',1.52),('7643','2013-12-12','08:15:00',1.77),('7643','2013-12-12','08:20:00',2.06),('7643','2013-12-12','08:25:00',2.34),('7643','2013-12-12','08:30:00',2.61),('7643','2013-12-12','08:35:00',2.86),('7643','2013-12-12','08:40:00',3.14),('7643','2013-12-12','08:45:00',3.45),('7643','2013-12-12','08:50:00',3.71),('7643','2013-12-12','08:55:00',3.99),('7643','2013-12-12','09:00:00',4.27),('7643','2013-12-12','09:05:00',4.53),('7643','2013-12-12','09:10:00',4.78),('7643','2013-12-12','09:15:00',5.12),('7643','2013-12-12','09:20:00',5.33),('7643','2013-12-12','09:25:00',5.5),('7643','2013-12-12','09:30:00',5.68),('7643','2013-12-12','09:35:00',5.81),('7643','2013-12-12','09:40:00',6.1),('7643','2013-12-12','09:45:00',6.35),('7643','2013-12-12','09:50:00',6.57),('7643','2013-12-12','09:55:00',6.84),('7643','2013-12-12','10:00:00',7),('7643','2013-12-12','10:05:00',7.17),('7643','2013-12-12','10:10:00',7.33),('7643','2013-12-12','10:15:00',7.49),('7643','2013-12-12','10:20:00',7.65),('7643','2013-12-12','10:25:00',7.72),('7643','2013-12-12','10:30:00',7.94),('7643','2013-12-12','10:35:00',8.09),('7643','2013-12-12','10:40:00',8.27),('7643','2013-12-12','10:45:00',8.38),('7643','2013-12-12','10:50:00',8.49),('7643','2013-12-12','10:55:00',8.68),('7643','2013-12-12','11:00:00',8.82),('7643','2013-12-12','11:05:00',8.91),('7643','2013-12-12','11:10:00',8.89),('7643','2013-12-12','11:15:00',8.95),('7643','2013-12-12','11:20:00',9.01),('7643','2013-12-12','11:25:00',8.95),('7643','2013-12-12','11:30:00',9.01),('7643','2013-12-12','11:35:00',9.07),('7643','2013-12-12','11:40:00',8.93),('7643','2013-12-12','11:45:00',9.07),('7643','2013-12-12','11:50:00',9.14),('7643','2013-12-12','11:55:00',9.19),('7643','2013-12-12','12:00:00',9.1),('7643','2013-12-12','12:05:00',9.14),('7643','2013-12-12','12:10:00',9.25),('7643','2013-12-12','12:15:00',9.13),('7643','2013-12-12','12:20:00',9.02),('7643','2013-12-12','12:25:00',9.2),('7643','2013-12-12','12:30:00',9.03),('7643','2013-12-12','12:35:00',9.03),('7643','2013-12-12','12:40:00',8.38),('7643','2013-12-12','12:45:00',9.04),('7643','2013-12-12','12:50:00',8.8),('7643','2013-12-12','12:55:00',8.63),('7643','2013-12-12','13:00:00',8.58),('7643','2013-12-12','13:05:00',8.52),('7643','2013-12-12','13:10:00',8.51),('7643','2013-12-12','13:15:00',8.55),('7643','2013-12-12','13:20:00',8.2),('7643','2013-12-12','13:25:00',8.34),('7643','2013-12-12','13:30:00',8.34),('7643','2013-12-12','13:35:00',8.14),('7643','2013-12-12','13:40:00',7.85),('7643','2013-12-12','13:45:00',7.66),('7643','2013-12-12','13:50:00',7.48),('7643','2013-12-12','13:55:00',7.23),('7643','2013-12-12','14:00:00',7.18),('7643','2013-12-12','14:05:00',7),('7643','2013-12-12','14:10:00',6.8),('7643','2013-12-12','14:15:00',6.6),('7643','2013-12-12','14:20:00',6.34),('7643','2013-12-12','14:25:00',6.09),('7643','2013-12-12','14:30:00',5.85),('7643','2013-12-12','14:35:00',5.76),('7643','2013-12-12','14:40:00',5.5),('7643','2013-12-12','14:45:00',5.26),('7643','2013-12-12','14:50:00',5.08),('7643','2013-12-12','14:55:00',4.8),('7643','2013-12-12','15:00:00',4.26),('7643','2013-12-12','15:05:00',3.97),('7643','2013-12-12','15:10:00',3.68),('7643','2013-12-12','15:15:00',3.31),('7643','2013-12-12','15:20:00',3.08),('7643','2013-12-12','15:25:00',2.85),('7643','2013-12-12','15:30:00',2.58),('7643','2013-12-12','15:35:00',2.33),('7643','2013-12-12','15:40:00',2.05),('7643','2013-12-12','15:45:00',1.8),('7643','2013-12-12','15:50:00',1.5),('7643','2013-12-12','15:55:00',1.25),('7643','2013-12-12','16:00:00',1.01),('7643','2013-12-11','08:00:00',1.13),('7643','2013-12-11','08:05:00',1.42),('7643','2013-12-11','08:10:00',1.7),('7643','2013-12-11','08:15:00',1.98),('7643','2013-12-11','08:20:00',2.29),('7643','2013-12-11','08:25:00',2.59),('7643','2013-12-11','08:30:00',2.91),('7643','2013-12-11','08:35:00',3.18),('7643','2013-12-11','08:40:00',3.49),('7643','2013-12-11','08:45:00',3.78),('7643','2013-12-11','08:50:00',4.07),('7643','2013-12-11','08:55:00',4.38),('7643','2013-12-11','09:00:00',4.62),('7643','2013-12-11','09:05:00',4.89),('7643','2013-12-11','09:10:00',5.16),('7643','2013-12-11','09:15:00',5.41),('7643','2013-12-11','09:20:00',5.65),('7643','2013-12-11','09:25:00',5.94),('7643','2013-12-11','09:30:00',6.2),('7643','2013-12-11','09:35:00',6.47),('7643','2013-12-11','09:40:00',6.73),('7643','2013-12-11','09:45:00',6.91),('7643','2013-12-11','09:50:00',7.1),('7643','2013-12-11','09:55:00',7.28),('7643','2013-12-11','10:00:00',7.45),('7643','2013-12-11','10:05:00',7.64),('7643','2013-12-11','10:10:00',7.9),('7643','2013-12-11','10:15:00',8.11),('7643','2013-12-11','10:20:00',8.25),('7643','2013-12-11','10:25:00',8.43),('7643','2013-12-11','10:30:00',8.56),('7643','2013-12-11','10:35:00',8.69),('7643','2013-12-11','10:40:00',8.83),('7643','2013-12-11','10:45:00',8.93),('7643','2013-12-11','10:50:00',9.05),('7643','2013-12-11','10:55:00',9.14),('7643','2013-12-11','11:00:00',9.17),('7643','2013-12-11','11:05:00',9.18),('7643','2013-12-11','11:10:00',9.19),('7643','2013-12-11','11:15:00',9.3),('7643','2013-12-11','11:20:00',9.31),('7643','2013-12-11','11:25:00',9.34),('7643','2013-12-11','11:30:00',9.32),('7643','2013-12-11','11:35:00',9.33),('7643','2013-12-11','11:40:00',9.38),('7643','2013-12-11','11:45:00',9.36),('7643','2013-12-11','11:50:00',9.38),('7643','2013-12-11','11:55:00',9.47),('7643','2013-12-11','12:00:00',9.42),('7643','2013-12-11','12:05:00',9.52),('7643','2013-12-11','12:10:00',9.51),('7643','2013-12-11','12:15:00',9.46),('7643','2013-12-11','12:20:00',9.51),('7643','2013-12-11','12:25:00',9.43),('7643','2013-12-11','12:30:00',9.37),('7643','2013-12-11','12:35:00',9.32),('7643','2013-12-11','12:40:00',9.23),('7643','2013-12-11','12:45:00',9.04),('7643','2013-12-11','12:50:00',9.16),('7643','2013-12-11','12:55:00',8.88),('7643','2013-12-11','13:00:00',8.62),('7643','2013-12-11','13:05:00',8.45),('7643','2013-12-11','13:10:00',8.27),('7643','2013-12-11','13:15:00',8.45),('7643','2013-12-11','13:20:00',8.45),('7643','2013-12-11','13:25:00',8.24),('7643','2013-12-11','13:30:00',8.03),('7643','2013-12-11','13:35:00',8.01),('7643','2013-12-11','13:40:00',7.8),('7643','2013-12-11','13:45:00',7.63),('7643','2013-12-11','13:50:00',7.49),('7643','2013-12-11','13:55:00',7.38),('7643','2013-12-11','14:00:00',7.13),('7643','2013-12-11','14:05:00',6.92),('7643','2013-12-11','14:10:00',6.72),('7643','2013-12-11','14:15:00',6.35),('7643','2013-12-11','14:20:00',6.11),('7643','2013-12-11','14:25:00',5.84),('7643','2013-12-11','14:30:00',5.53),('7643','2013-12-11','14:35:00',5.27),('7643','2013-12-11','14:40:00',5.13),('7643','2013-12-11','14:45:00',4.81),('7643','2013-12-11','14:50:00',4.49),('7643','2013-12-11','14:55:00',4.32),('7643','2013-12-11','15:00:00',3.99),('7643','2013-12-11','15:05:00',3.71),('7643','2013-12-11','15:10:00',3.4),('7643','2013-12-11','15:15:00',3.19),('7643','2013-12-11','15:20:00',2.94),('7643','2013-12-11','15:25:00',2.68),('7643','2013-12-11','15:30:00',2.43),('7643','2013-12-11','15:35:00',2.17),('7643','2013-12-11','15:40:00',1.91),('7643','2013-12-11','15:45:00',1.65),('7643','2013-12-11','15:50:00',1.38),('7643','2013-12-11','15:55:00',1.12),('7643','2013-12-10','08:00:00',1.26),('7643','2013-12-10','08:05:00',1.2),('7643','2013-12-10','08:10:00',1.77),('7643','2013-12-10','08:15:00',1.95),('7643','2013-12-10','08:20:00',2.27),('7643','2013-12-10','08:25:00',2.75),('7643','2013-12-10','08:30:00',3.08),('7643','2013-12-10','08:35:00',3.34),('7643','2013-12-10','08:40:00',3.62),('7643','2013-12-10','08:45:00',3.89),('7643','2013-12-10','08:50:00',4.24),('7643','2013-12-10','08:55:00',4.56),('7643','2013-12-10','09:00:00',4.82),('7643','2013-12-10','09:05:00',5.08),('7643','2013-12-10','09:10:00',5.35),('7643','2013-12-10','09:15:00',5.59),('7643','2013-12-10','09:20:00',5.9),('7643','2013-12-10','09:25:00',6.18),('7643','2013-12-10','09:30:00',6.4),('7643','2013-12-10','09:35:00',6.65),('7643','2013-12-10','09:40:00',6.93),('7643','2013-12-10','09:45:00',7.2),('7643','2013-12-10','09:50:00',7.44),('7643','2013-12-10','09:55:00',7.57),('7643','2013-12-10','10:00:00',7.78),('7643','2013-12-10','10:05:00',8.02),('7643','2013-12-10','10:10:00',8.15),('7643','2013-12-10','10:15:00',8.36),('7643','2013-12-10','10:20:00',8.51),('7643','2013-12-10','10:25:00',8.71),('7643','2013-12-10','10:30:00',8.94),('7643','2013-12-10','10:35:00',9.2),('7643','2013-12-10','10:40:00',9.28),('7643','2013-12-10','10:45:00',9.23),('7643','2013-12-10','10:50:00',9.34),('7643','2013-12-10','10:55:00',9.43),('7643','2013-12-10','11:00:00',9.6),('7643','2013-12-10','11:05:00',9.78),('7643','2013-12-10','11:10:00',9.81),('7643','2013-12-10','11:15:00',9.82),('7643','2013-12-10','11:20:00',9.85),('7643','2013-12-10','11:25:00',9.81),('7643','2013-12-10','11:30:00',9.61),('7643','2013-12-10','11:35:00',9.8),('7643','2013-12-10','11:40:00',10),('7643','2013-12-10','11:45:00',10.02),('7643','2013-12-10','11:50:00',10.07),('7643','2013-12-10','11:55:00',10.05),('7643','2013-12-10','12:00:00',10.04),('7643','2013-12-10','12:05:00',10.15),('7643','2013-12-10','12:10:00',10.05),('7643','2013-12-10','12:15:00',9.97),('7643','2013-12-10','12:20:00',9.97),('7643','2013-12-10','12:25:00',9.66),('7643','2013-12-10','12:30:00',9.62),('7643','2013-12-10','12:35:00',9.63),('7643','2013-12-10','12:40:00',9.59),('7643','2013-12-10','12:45:00',9.64),('7643','2013-12-10','12:50:00',9.5),('7643','2013-12-10','12:55:00',9.45),('7643','2013-12-10','13:00:00',9.43),('7643','2013-12-10','13:05:00',9.22),('7643','2013-12-10','13:10:00',9.04),('7643','2013-12-10','13:15:00',8.84),('7643','2013-12-10','13:20:00',8.74),('7643','2013-12-10','13:25:00',8.7),('7643','2013-12-10','13:30:00',8.61),('7643','2013-12-10','13:35:00',8.4),('7643','2013-12-10','13:40:00',8.18),('7643','2013-12-10','13:45:00',7.96),('7643','2013-12-10','13:50:00',7.74),('7643','2013-12-10','13:55:00',7.51),('7643','2013-12-10','14:00:00',7.33),('7643','2013-12-10','14:05:00',7.22),('7643','2013-12-10','14:10:00',7.11),('7643','2013-12-10','14:15:00',6.86),('7643','2013-12-10','14:20:00',6.57),('7643','2013-12-10','14:25:00',6.37),('7643','2013-12-10','14:30:00',6.14),('7643','2013-12-10','14:35:00',5.85),('7643','2013-12-10','14:40:00',5.59),('7643','2013-12-10','14:45:00',5.28),('7643','2013-12-10','14:50:00',5.03),('7643','2013-12-10','14:55:00',4.78),('7643','2013-12-10','15:00:00',4.5),('7643','2013-12-10','15:05:00',4.19),('7643','2013-12-10','15:10:00',3.86),('7643','2013-12-10','15:15:00',3.52),('7643','2013-12-10','15:20:00',3.27),('7643','2013-12-10','15:25:00',2.94),('7643','2013-12-10','15:30:00',2.59),('7643','2013-12-10','15:35:00',2.3),('7643','2013-12-10','15:40:00',2.06),('7643','2013-12-10','15:45:00',1.8),('7643','2013-12-10','15:50:00',1.51),('7643','2013-12-10','15:55:00',1.26),('7643','2013-12-10','16:00:00',1.02),('7643','2013-12-09','08:00:00',1.41),('7643','2013-12-09','08:05:00',1.69),('7643','2013-12-09','08:10:00',1.96),('7643','2013-12-09','08:15:00',2.26),('7643','2013-12-09','08:20:00',2.57),('7643','2013-12-09','08:25:00',2.86),('7643','2013-12-09','08:30:00',3.17),('7643','2013-12-09','08:35:00',3.43),('7643','2013-12-09','08:40:00',3.77),('7643','2013-12-09','08:45:00',4.08),('7643','2013-12-09','08:50:00',4.41),('7643','2013-12-09','08:55:00',4.73),('7643','2013-12-09','09:00:00',5.05),('7643','2013-12-09','09:05:00',5.31),('7643','2013-12-09','09:10:00',5.59),('7643','2013-12-09','09:15:00',5.87),('7643','2013-12-09','09:20:00',6.18),('7643','2013-12-09','09:25:00',6.45),('7643','2013-12-09','09:30:00',6.58),('7643','2013-12-09','09:35:00',6.81),('7643','2013-12-09','09:40:00',7.04),('7643','2013-12-09','09:45:00',7.23),('7643','2013-12-09','09:50:00',7.55),('7643','2013-12-09','09:55:00',7.78),('7643','2013-12-09','10:00:00',7.98),('7643','2013-12-09','10:05:00',8.16),('7643','2013-12-09','10:10:00',8.4),('7643','2013-12-09','10:15:00',8.56),('7643','2013-12-09','10:20:00',8.73),('7643','2013-12-09','10:25:00',8.87),('7643','2013-12-09','10:30:00',8.98),('7643','2013-12-09','10:35:00',9.13),('7643','2013-12-09','10:40:00',9.17),('7643','2013-12-09','10:45:00',9.31),('7643','2013-12-09','10:50:00',9.52),('7643','2013-12-09','10:55:00',9.6),('7643','2013-12-09','11:00:00',9.72),('7643','2013-12-09','11:05:00',9.81),('7643','2013-12-09','11:10:00',9.89),('7643','2013-12-09','11:15:00',9.9),('7643','2013-12-09','11:20:00',9.99),('7643','2013-12-09','11:25:00',10.07),('7643','2013-12-09','11:30:00',10.15),('7643','2013-12-09','11:35:00',10.2),('7643','2013-12-09','11:40:00',10.23),('7643','2013-12-09','11:45:00',10.22),('7643','2013-12-09','11:50:00',10.21),('7643','2013-12-09','11:55:00',10.21),('7643','2013-12-09','12:00:00',10.19),('7643','2013-12-09','12:05:00',10.16),('7643','2013-12-09','12:10:00',10.09),('7643','2013-12-09','12:15:00',10.07),('7643','2013-12-09','12:20:00',10.05),('7643','2013-12-09','12:25:00',9.91),('7643','2013-12-09','12:30:00',9.81),('7643','2013-12-09','12:35:00',9.72),('7643','2013-12-09','12:40:00',9.53),('7643','2013-12-09','12:45:00',9.53),('7643','2013-12-09','12:50:00',9.38),('7643','2013-12-09','12:55:00',9.25),('7643','2013-12-09','13:00:00',9.07),('7643','2013-12-09','13:05:00',9.05),('7643','2013-12-09','13:10:00',8.79),('7643','2013-12-09','13:15:00',8.54),('7643','2013-12-09','13:20:00',8.62),('7643','2013-12-09','13:25:00',8.53),('7643','2013-12-09','13:30:00',8.39),('7643','2013-12-09','13:35:00',8.36),('7643','2013-12-09','13:40:00',8.32),('7643','2013-12-09','13:45:00',8.18),('7643','2013-12-09','13:50:00',7.98),('7643','2013-12-09','13:55:00',7.79),('7643','2013-12-09','14:00:00',7.55),('7643','2013-12-09','14:05:00',7.34),('7643','2013-12-09','14:10:00',7.12),('7643','2013-12-09','14:15:00',6.93),('7643','2013-12-09','14:20:00',6.72),('7643','2013-12-09','14:25:00',6.55),('7643','2013-12-09','14:30:00',6.33),('7643','2013-12-09','14:35:00',6.04),('7643','2013-12-09','14:40:00',5.79),('7643','2013-12-09','14:45:00',5.43),('7643','2013-12-09','14:50:00',5.27),('7643','2013-12-09','14:55:00',4.97),('7643','2013-12-09','15:00:00',4.66),('7643','2013-12-09','15:05:00',4.33),('7643','2013-12-09','15:10:00',4.02),('7643','2013-12-09','15:15:00',3.72),('7643','2013-12-09','15:20:00',3.39),('7643','2013-12-09','15:25:00',3.07),('7643','2013-12-09','15:30:00',2.76),('7643','2013-12-09','15:35:00',2.47),('7643','2013-12-09','15:40:00',2.18),('7643','2013-12-09','15:45:00',1.89),('7643','2013-12-09','15:50:00',1.61),('7643','2013-12-09','15:55:00',1.39),('7643','2013-12-09','16:00:00',1.18),('7643','2013-12-08','09:05:00',1.02),('7643','2013-12-08','09:10:00',1.66),('7643','2013-12-08','09:15:00',1.28),('7643','2013-12-08','09:20:00',1.03),('7643','2013-12-08','09:30:00',2.35),('7643','2013-12-08','09:35:00',6.62),('7643','2013-12-08','09:40:00',6.9),('7643','2013-12-08','09:45:00',7.11),('7643','2013-12-08','09:50:00',7.33),('7643','2013-12-08','09:55:00',7.58),('7643','2013-12-08','10:00:00',7.84),('7643','2013-12-08','10:05:00',8.12),('7643','2013-12-08','10:10:00',9.45),('7643','2013-12-08','10:15:00',10.27),('7643','2013-12-08','10:20:00',11.07),('7643','2013-12-08','10:25:00',9.21),('7643','2013-12-08','10:30:00',3.19),('7643','2013-12-08','10:35:00',2.58),('7643','2013-12-08','10:40:00',2.22),('7643','2013-12-08','10:45:00',1.84),('7643','2013-12-08','10:50:00',1.44),('7643','2013-12-08','10:55:00',1.52),('7643','2013-12-08','11:00:00',1.39),('7643','2013-12-08','11:05:00',1.5),('7643','2013-12-08','11:10:00',1.46),('7643','2013-12-08','11:15:00',1.46),('7643','2013-12-08','11:20:00',1.51),('7643','2013-12-08','11:25:00',1.55),('7643','2013-12-08','11:30:00',1.68),('7643','2013-12-08','11:35:00',1.6),('7643','2013-12-08','11:40:00',1.76),('7643','2013-12-08','11:45:00',2),('7643','2013-12-08','11:50:00',2.09),('7643','2013-12-08','11:55:00',2.27),('7643','2013-12-08','12:00:00',2.45),('7643','2013-12-08','12:05:00',2.6),('7643','2013-12-08','12:10:00',2.56),('7643','2013-12-08','12:15:00',2.47),('7643','2013-12-08','12:20:00',2.67),('7643','2013-12-08','12:25:00',3.44),('7643','2013-12-08','12:30:00',6.94),('7643','2013-12-08','12:35:00',4.45),('7643','2013-12-08','12:40:00',4.34),('7643','2013-12-08','12:45:00',7),('7643','2013-12-08','12:50:00',6.24),('7643','2013-12-08','12:55:00',6.63),('7643','2013-12-08','13:00:00',7.87),('7643','2013-12-08','13:05:00',6.81),('7643','2013-12-08','13:10:00',5.88),('7643','2013-12-08','13:15:00',7.51),('7643','2013-12-08','13:20:00',6.66),('7643','2013-12-08','13:25:00',4.93),('7643','2013-12-08','13:30:00',2.76),('7643','2013-12-08','13:35:00',2.07),('7643','2013-12-08','13:40:00',2.56),('7643','2013-12-08','13:45:00',3.39),('7643','2013-12-08','13:50:00',4.01),('7643','2013-12-08','13:55:00',4.37),('7643','2013-12-08','14:00:00',3.68),('7643','2013-12-08','14:05:00',2.88),('7643','2013-12-08','14:10:00',2.45),('7643','2013-12-08','14:15:00',2.13),('7643','2013-12-08','14:20:00',1.87),('7643','2013-12-08','14:25:00',1.79),('7643','2013-12-08','14:30:00',1.71),('7643','2013-12-08','14:35:00',1.78),('7643','2013-12-08','14:40:00',1.99),('7643','2013-12-08','14:45:00',2.1),('7643','2013-12-08','14:50:00',1.99),('7643','2013-12-08','14:55:00',1.99),('7643','2013-12-08','15:00:00',1.9),('7643','2013-12-08','15:05:00',1.78),('7643','2013-12-08','15:10:00',1.63),('7643','2013-12-08','15:15:00',1.44),('7643','2013-12-08','15:20:00',1.36),('7643','2013-12-08','15:25:00',1.29),('7643','2013-12-08','15:30:00',1.2),('7643','2013-12-08','15:35:00',1.19),('7643','2013-12-08','15:40:00',1.09),('7643','2013-12-07','08:00:00',1.33),('7643','2013-12-07','08:05:00',1.11),('7643','2013-12-07','08:25:00',1.1),('7643','2013-12-07','08:30:00',1.93),('7643','2013-12-07','08:35:00',1.98),('7643','2013-12-07','08:40:00',2.35),('7643','2013-12-07','08:45:00',2.63),('7643','2013-12-07','08:50:00',2.32),('7643','2013-12-07','08:55:00',2.27),('7643','2013-12-07','09:00:00',2.29),('7643','2013-12-07','09:05:00',2.34),('7643','2013-12-07','09:10:00',2.15),('7643','2013-12-07','09:15:00',2.21),('7643','2013-12-07','09:20:00',2.1),('7643','2013-12-07','09:25:00',2.13),('7643','2013-12-07','09:30:00',2.16),('7643','2013-12-07','09:35:00',2.84),('7643','2013-12-07','09:40:00',3.08),('7643','2013-12-07','09:45:00',2.95),('7643','2013-12-07','09:50:00',3.4),('7643','2013-12-07','09:55:00',3.67),('7643','2013-12-07','10:00:00',3.71),('7643','2013-12-07','10:05:00',3.53),('7643','2013-12-07','10:10:00',3.72),('7643','2013-12-07','10:15:00',3.83),('7643','2013-12-07','10:20:00',3.55),('7643','2013-12-07','10:25:00',3.5),('7643','2013-12-07','10:30:00',3.55),('7643','2013-12-07','10:35:00',4.09),('7643','2013-12-07','10:40:00',4.3),('7643','2013-12-07','10:45:00',4.45),('7643','2013-12-07','10:50:00',4.31),('7643','2013-12-07','10:55:00',4.97),('7643','2013-12-07','11:00:00',5.46),('7643','2013-12-07','11:05:00',4.94),('7643','2013-12-07','11:10:00',5.17),('7643','2013-12-07','11:15:00',7.91),('7643','2013-12-07','11:20:00',5.98),('7643','2013-12-07','11:25:00',5.28),('7643','2013-12-07','11:30:00',3.41),('7643','2013-12-07','11:35:00',3.07),('7643','2013-12-07','11:40:00',2.97),('7643','2013-12-07','11:45:00',2.87),('7643','2013-12-07','11:50:00',2.93),('7643','2013-12-07','11:55:00',2.93),('7643','2013-12-07','12:00:00',2.78),('7643','2013-12-07','12:05:00',2.89),('7643','2013-12-07','12:10:00',2.61),('7643','2013-12-07','12:15:00',2.37),('7643','2013-12-07','12:20:00',2.38),('7643','2013-12-07','12:25:00',2.46),('7643','2013-12-07','12:30:00',2.23),('7643','2013-12-07','12:35:00',2.18),('7643','2013-12-07','12:40:00',2.14),('7643','2013-12-07','12:45:00',2),('7643','2013-12-07','12:50:00',2.39),('7643','2013-12-07','12:55:00',4.6),('7643','2013-12-07','13:00:00',3.04),('7643','2013-12-07','13:05:00',3.75),('7643','2013-12-07','13:10:00',3.94),('7643','2013-12-07','13:15:00',3.68),('7643','2013-12-07','13:20:00',4.48),('7643','2013-12-07','13:25:00',3.62),('7643','2013-12-07','13:30:00',2.72),('7643','2013-12-07','13:35:00',2.46),('7643','2013-12-07','13:40:00',1.87),('7643','2013-12-07','13:45:00',1.23),('7643','2013-12-07','13:50:00',1.02),('7643','2013-12-07','14:20:00',1.15),('7643','2013-12-07','14:25:00',1.35),('7643','2013-12-07','14:30:00',1.31),('7643','2013-12-07','14:35:00',1.08),('7643','2013-12-07','15:05:00',1.23),('7643','2013-12-07','15:10:00',1.49),('7643','2013-12-07','15:15:00',1.32),('7643','2013-12-07','15:20:00',1.87),('7643','2013-12-07','15:25:00',2.84),('7643','2013-12-07','15:30:00',3.43),('7643','2013-12-07','15:35:00',2.36),('7643','2013-12-07','15:40:00',1.51),('7643','2014-04-20','08:00:00',1.04),('7643','2014-04-20','08:05:00',1.12),('7643','2014-04-20','08:10:00',1.36),('7643','2014-04-20','08:15:00',1.57),('7643','2014-04-20','08:20:00',2.06),('7643','2014-04-20','08:25:00',2.26),('7643','2014-04-20','08:30:00',2.99),('7643','2014-04-20','08:35:00',3.1),('7643','2014-04-20','08:40:00',3.23),('7643','2014-04-20','08:45:00',3.06),('7643','2014-04-20','08:50:00',2.94),('7643','2014-04-20','08:55:00',2.87),('7643','2014-04-20','09:00:00',3.29),('7643','2014-04-20','09:05:00',3.28),('7643','2014-04-20','09:10:00',3.45),('7643','2014-04-20','09:15:00',3.69),('7643','2014-04-20','09:20:00',5.43),('7643','2014-04-20','09:25:00',3.8),('7643','2014-04-20','09:30:00',1.94),('7643','2014-04-20','09:35:00',1.89),('7643','2014-04-20','09:40:00',2.62),('7643','2014-04-20','09:45:00',3.09),('7643','2014-04-20','09:50:00',3.39),('7643','2014-04-20','09:55:00',4.04),('7643','2014-04-20','10:00:00',5.98),('7643','2014-04-20','10:05:00',10.25),('7643','2014-04-20','10:10:00',14.31),('7643','2014-04-20','10:15:00',13.44),('7643','2014-04-20','10:20:00',13.03),('7643','2014-04-20','10:25:00',13.1),('7643','2014-04-20','10:30:00',13.13),('7643','2014-04-20','10:35:00',13.03),('7643','2014-04-20','10:40:00',13.41),('7643','2014-04-20','10:45:00',13.53),('7643','2014-04-20','10:50:00',13.66),('7643','2014-04-20','10:55:00',13.79),('7643','2014-04-20','11:00:00',13.94),('7643','2014-04-20','11:05:00',14.06),('7643','2014-04-20','11:10:00',14.14),('7643','2014-04-20','11:15:00',14.25),('7643','2014-04-20','11:20:00',14.46),('7643','2014-04-20','11:25:00',14.62),('7643','2014-04-20','11:30:00',14.72),('7643','2014-04-20','11:35:00',14.82),('7643','2014-04-20','11:40:00',14.92),('7643','2014-04-20','11:45:00',15.13),('7643','2014-04-20','11:50:00',15.19),('7643','2014-04-20','11:55:00',15.22),('7643','2014-04-20','12:00:00',15.43),('7643','2014-04-20','12:05:00',15.54),('7643','2014-04-20','12:10:00',15.62),('7643','2014-04-20','12:15:00',15.72),('7643','2014-04-20','12:20:00',15.86),('7643','2014-04-20','12:25:00',15.95),('7643','2014-04-20','12:30:00',15.99),('7643','2014-04-20','12:35:00',16.04),('7643','2014-04-20','12:40:00',16.04),('7643','2014-04-20','12:45:00',16.12),('7643','2014-04-20','12:50:00',16.16),('7643','2014-04-20','12:55:00',16.25),('7643','2014-04-20','13:00:00',16.2),('7643','2014-04-20','13:05:00',16.16),('7643','2014-04-20','13:10:00',16.14),('7643','2014-04-20','13:15:00',16.06),('7643','2014-04-20','13:20:00',16.13),('7643','2014-04-20','13:25:00',16.17),('7643','2014-04-20','13:30:00',16.19),('7643','2014-04-20','13:35:00',16.16),('7643','2014-04-20','13:40:00',16.17),('7643','2014-04-20','13:45:00',16.39),('7643','2014-04-20','13:50:00',16.46),('7643','2014-04-20','13:55:00',16.46),('7643','2014-04-20','14:00:00',16.45),('7643','2014-04-20','14:05:00',16.41),('7643','2014-04-20','14:10:00',16.23),('7643','2014-04-20','14:15:00',16.24),('7643','2014-04-20','14:20:00',16.18),('7643','2014-04-20','14:25:00',16.02),('7643','2014-04-20','14:30:00',15.85),('7643','2014-04-20','14:35:00',15.69),('7643','2014-04-20','14:40:00',15.56),('7643','2014-04-20','14:45:00',15.41),('7643','2014-04-20','14:50:00',15.2),('7643','2014-04-20','14:55:00',15.15),('7643','2014-04-20','15:00:00',14.99),('7643','2014-04-20','15:05:00',14.79),('7643','2014-04-20','15:10:00',14.61),('7643','2014-04-20','15:15:00',14.4),('7643','2014-04-20','15:20:00',14.14),('7643','2014-04-20','15:25:00',13.82),('7643','2014-04-20','15:30:00',13.68),('7643','2014-04-20','15:35:00',13.45),('7643','2014-04-20','15:40:00',13.21),('7643','2014-04-20','15:45:00',13.07),('7643','2014-04-20','15:50:00',12.9),('7643','2014-04-20','15:55:00',12.69),('7643','2014-04-20','16:00:00',12.46),('7643','2014-04-20','16:05:00',12.13),('7643','2014-04-20','16:10:00',11.88),('7643','2014-04-20','16:15:00',9.36),('7643','2014-04-20','16:20:00',11.8),('7643','2014-04-20','16:25:00',11.24),('7643','2014-04-20','16:30:00',10.64),('7643','2014-04-20','16:35:00',10.7),('7643','2014-04-20','16:40:00',10.46),('7643','2014-04-20','16:45:00',10.24),('7643','2014-04-20','16:50:00',9.94),('7643','2014-04-20','16:55:00',9.59),('7643','2014-04-20','17:00:00',9.22),('7643','2014-04-20','17:05:00',8.91),('7643','2014-04-20','17:10:00',8.59),('7643','2014-04-20','17:15:00',8.26),('7643','2014-04-20','17:20:00',7.95),('7643','2014-04-20','17:25:00',7.59),('7643','2014-04-20','17:30:00',7.24),('7643','2014-04-20','17:35:00',6.85),('7643','2014-04-20','17:40:00',6.14),('7643','2014-04-20','17:45:00',6.11),('7643','2014-04-20','17:50:00',5.74),('7643','2014-04-20','17:55:00',5.32),('7643','2014-04-20','18:00:00',4.96),('7643','2014-04-20','18:05:00',4.51),('7643','2014-04-20','18:10:00',4.05),('7643','2014-04-20','18:15:00',3.76),('7643','2014-04-20','18:20:00',3.38),('7643','2014-04-20','18:25:00',3),('7643','2014-04-20','18:30:00',2.7),('7643','2014-04-20','18:35:00',2.35),('7643','2014-04-20','18:40:00',2.05),('7643','2014-04-20','18:45:00',1.78),('7643','2014-04-20','18:50:00',1.5),('7643','2014-04-20','18:55:00',1.27),('7643','2014-04-20','19:00:00',1.22),('7643','2014-04-20','19:05:00',1.18),('7643','2014-04-20','19:10:00',1),('7643','2013-12-06','08:00:00',1.55),('7643','2013-12-06','08:05:00',1.75),('7643','2013-12-06','08:10:00',2.1),('7643','2013-12-06','08:15:00',2.41),('7643','2013-12-06','08:20:00',2.68),('7643','2013-12-06','08:25:00',3.02),('7643','2013-12-06','08:30:00',3.34),('7643','2013-12-06','08:35:00',3.62),('7643','2013-12-06','08:40:00',3.84),('7643','2013-12-06','08:45:00',4.08),('7643','2013-12-06','08:50:00',4.36),('7643','2013-12-06','08:55:00',4.71),('7643','2013-12-06','09:00:00',5.01),('7643','2013-12-06','09:05:00',5.28),('7643','2013-12-06','09:10:00',5.58),('7643','2013-12-06','09:15:00',5.87),('7643','2013-12-06','09:20:00',6.08),('7643','2013-12-06','09:25:00',6.33),('7643','2013-12-06','09:30:00',6.57),('7643','2013-12-06','09:35:00',6.87),('7643','2013-12-06','09:40:00',7.11),('7643','2013-12-06','09:45:00',7.33),('7643','2013-12-06','09:50:00',7.52),('7643','2013-12-06','09:55:00',7.66),('7643','2013-12-06','10:00:00',7.82),('7643','2013-12-06','10:05:00',7.98),('7643','2013-12-06','10:10:00',8.07),('7643','2013-12-06','10:15:00',8.2),('7643','2013-12-06','10:20:00',8.37),('7643','2013-12-06','10:25:00',8.6),('7643','2013-12-06','10:30:00',8.66),('7643','2013-12-06','10:35:00',8.89),('7643','2013-12-06','10:40:00',9.15),('7643','2013-12-06','10:45:00',9.18),('7643','2013-12-06','10:50:00',9.13),('7643','2013-12-06','10:55:00',9.16),('7643','2013-12-06','11:00:00',9.28),('7643','2013-12-06','11:05:00',9.25),('7643','2013-12-06','11:10:00',9.39),('7643','2013-12-06','11:15:00',9.43),('7643','2013-12-06','11:20:00',9.54),('7643','2013-12-06','11:25:00',9.53),('7643','2013-12-06','11:30:00',9.55),('7643','2013-12-06','11:35:00',9.59),('7643','2013-12-06','11:40:00',9.6),('7643','2013-12-06','11:45:00',9.54),('7643','2013-12-06','11:50:00',9.53),('7643','2013-12-06','11:55:00',9.53),('7643','2013-12-06','12:00:00',9.49),('7643','2013-12-06','12:05:00',9.48),('7643','2013-12-06','12:10:00',9.51),('7643','2013-12-06','12:15:00',9.45),('7643','2013-12-06','12:20:00',9.42),('7643','2013-12-06','12:25:00',9.36),('7643','2013-12-06','12:30:00',9.3),('7643','2013-12-06','12:35:00',9.34),('7643','2013-12-06','12:40:00',9.27),('7643','2013-12-06','12:45:00',9.11),('7643','2013-12-06','12:50:00',9.13),('7643','2013-12-06','12:55:00',8.97),('7643','2013-12-06','13:00:00',9.07),('7643','2013-12-06','13:05:00',8.95),('7643','2013-12-06','13:10:00',8.89),('7643','2013-12-06','13:15:00',8.81),('7643','2013-12-06','13:20:00',8.67),('7643','2013-12-06','13:25:00',8.47),('7643','2013-12-06','13:30:00',8.36),('7643','2013-12-06','13:35:00',8.34),('7643','2013-12-06','13:40:00',8.19),('7643','2013-12-06','13:45:00',7.9),('7643','2013-12-06','13:50:00',7.76),('7643','2013-12-06','13:55:00',7.49),('7643','2013-12-06','14:00:00',7.3),('7643','2013-12-06','14:05:00',7.16),('7643','2013-12-06','14:10:00',6.84),('7643','2013-12-06','14:15:00',6.52),('7643','2013-12-06','14:20:00',6.17),('7643','2013-12-06','14:25:00',5.97),('7643','2013-12-06','14:30:00',5.7),('7643','2013-12-06','14:35:00',5.45),('7643','2013-12-06','14:40:00',5.13),('7643','2013-12-06','14:45:00',4.89),('7643','2013-12-06','14:50:00',4.66),('7643','2013-12-06','14:55:00',4.41),('7643','2013-12-06','15:00:00',4.06),('7643','2013-12-06','15:05:00',3.86),('7643','2013-12-06','15:10:00',3.55),('7643','2013-12-06','15:15:00',3.22),('7643','2013-12-06','15:20:00',2.99),('7643','2013-12-06','15:25:00',2.75),('7643','2013-12-06','15:30:00',2.54),('7643','2013-12-06','15:35:00',2.28),('7643','2013-12-06','15:40:00',2.03),('7643','2013-12-06','15:45:00',1.78),('7643','2013-12-06','15:50:00',1.51),('7643','2013-12-06','15:55:00',1.26),('7643','2013-12-06','16:00:00',1.01),('7643','2013-12-05','08:45:00',1.15),('7643','2013-12-05','08:55:00',1.2),('7643','2013-12-05','09:00:00',1.39),('7643','2013-12-05','09:05:00',1.57),('7643','2013-12-05','09:10:00',1.66),('7643','2013-12-05','09:15:00',2.01),('7643','2013-12-05','09:20:00',2.21),('7643','2013-12-05','09:25:00',2.2),('7643','2013-12-05','09:30:00',1.99),('7643','2013-12-05','09:35:00',1.89),('7643','2013-12-05','09:40:00',2.26),('7643','2013-12-05','09:45:00',2.4),('7643','2013-12-05','09:50:00',2.44),('7643','2013-12-05','09:55:00',2.56),('7643','2013-12-05','10:00:00',2.61),('7643','2013-12-05','10:05:00',3.01),('7643','2013-12-05','10:10:00',3.72),('7643','2013-12-05','10:15:00',3.87),('7643','2013-12-05','10:20:00',3.13),('7643','2013-12-05','10:25:00',2.75),('7643','2013-12-05','10:30:00',2.42),('7643','2013-12-05','10:35:00',2.12),('7643','2013-12-05','10:40:00',1.81),('7643','2013-12-05','10:45:00',1.79),('7643','2013-12-05','10:50:00',2.18),('7643','2013-12-05','10:55:00',2.49),('7643','2013-12-05','11:00:00',2.96),('7643','2013-12-05','11:05:00',3.45),('7643','2013-12-05','11:10:00',3.25),('7643','2013-12-05','11:15:00',3.09),('7643','2013-12-05','11:20:00',3.5),('7643','2013-12-05','11:25:00',3.68),('7643','2013-12-05','11:30:00',3.84),('7643','2013-12-05','11:35:00',4.7),('7643','2013-12-05','11:40:00',5.79),('7643','2013-12-05','11:45:00',6.48),('7643','2013-12-05','11:50:00',7.87),('7643','2013-12-05','11:55:00',7.78),('7643','2013-12-05','12:00:00',7),('7643','2013-12-05','12:05:00',5.96),('7643','2013-12-05','12:10:00',5.76),('7643','2013-12-05','12:15:00',5.53),('7643','2013-12-05','12:20:00',8.31),('7643','2013-12-05','12:25:00',5.64),('7643','2013-12-05','12:30:00',5.8),('7643','2013-12-05','12:35:00',5.77),('7643','2013-12-05','12:40:00',7.56),('7643','2013-12-05','12:45:00',4.71),('7643','2013-12-05','12:50:00',3.85),('7643','2013-12-05','12:55:00',3.37),('7643','2013-12-05','13:00:00',3.2),('7643','2013-12-05','13:05:00',2.86),('7643','2013-12-05','13:10:00',2.49),('7643','2013-12-05','13:15:00',2.41),('7643','2013-12-05','13:20:00',2.27),('7643','2013-12-05','13:25:00',2.44),('7643','2013-12-05','13:30:00',2.82),('7643','2013-12-05','13:35:00',2.92),('7643','2013-12-05','13:40:00',3.45),('7643','2013-12-05','13:45:00',3.55),('7643','2013-12-05','13:50:00',3.46),('7643','2013-12-05','13:55:00',3.06),('7643','2013-12-05','14:00:00',2.63),('7643','2013-12-05','14:05:00',2.51),('7643','2013-12-05','14:10:00',2.69),('7643','2013-12-05','14:15:00',2.58),('7643','2013-12-05','14:20:00',2.76),('7643','2013-12-05','14:25:00',3.14),('7643','2013-12-05','14:30:00',3.05),('7643','2013-12-05','14:35:00',3.09),('7643','2013-12-05','14:40:00',3.51),('7643','2013-12-05','14:45:00',4.76),('7643','2013-12-05','14:50:00',2.96),('7643','2013-12-05','14:55:00',2.58),('7643','2013-12-05','15:00:00',2.36),('7643','2013-12-05','15:05:00',2.44),('7643','2013-12-05','15:10:00',3.49),('7643','2013-12-05','15:15:00',3.02),('7643','2013-12-05','15:20:00',2.01),('7643','2013-12-05','15:25:00',1.9),('7643','2013-12-05','15:30:00',2.68),('7643','2013-12-05','15:35:00',2.62),('7643','2013-12-05','15:40:00',2.69),('7643','2013-12-05','15:45:00',2.25),('7643','2013-12-05','15:50:00',1.97),('7643','2013-12-05','15:55:00',1.19),('7643','2013-12-05','16:00:00',1.1),('7643','2013-12-04','08:00:00',1.68),('7643','2013-12-04','08:05:00',1.92),('7643','2013-12-04','08:10:00',2.23),('7643','2013-12-04','08:15:00',2.52),('7643','2013-12-04','08:20:00',2.84),('7643','2013-12-04','08:25:00',3.11),('7643','2013-12-04','08:30:00',3.43),('7643','2013-12-04','08:35:00',3.76),('7643','2013-12-04','08:40:00',4.08),('7643','2013-12-04','08:45:00',4.41),('7643','2013-12-04','08:50:00',4.71),('7643','2013-12-04','08:55:00',4.98),('7643','2013-12-04','09:00:00',5.27),('7643','2013-12-04','09:05:00',5.58),('7643','2013-12-04','09:10:00',5.86),('7643','2013-12-04','09:15:00',6.11),('7643','2013-12-04','09:20:00',6.38),('7643','2013-12-04','09:25:00',6.6),('7643','2013-12-04','09:30:00',6.83),('7643','2013-12-04','09:35:00',7.04),('7643','2013-12-04','09:40:00',7.28),('7643','2013-12-04','09:45:00',7.49),('7643','2013-12-04','09:50:00',7.75),('7643','2013-12-04','09:55:00',7.94),('7643','2013-12-04','10:00:00',8.11),('7643','2013-12-04','10:05:00',8.3),('7643','2013-12-04','10:10:00',8.46),('7643','2013-12-04','10:15:00',8.64),('7643','2013-12-04','10:20:00',8.87),('7643','2013-12-04','10:25:00',9.01),('7643','2013-12-04','10:30:00',9.19),('7643','2013-12-04','10:35:00',9.24),('7643','2013-12-04','10:40:00',9.34),('7643','2013-12-04','10:45:00',9.34),('7643','2013-12-04','10:50:00',9.6),('7643','2013-12-04','10:55:00',9.65),('7643','2013-12-04','11:00:00',9.72),('7643','2013-12-04','11:05:00',9.81),('7643','2013-12-04','11:10:00',9.77),('7643','2013-12-04','11:15:00',9.95),('7643','2013-12-04','11:20:00',9.93),('7643','2013-12-04','11:25:00',9.99),('7643','2013-12-04','11:30:00',10.07),('7643','2013-12-04','11:35:00',10.07),('7643','2013-12-04','11:40:00',10),('7643','2013-12-04','11:45:00',10),('7643','2013-12-04','11:50:00',9.99),('7643','2013-12-04','11:55:00',10.11),('7643','2013-12-04','12:00:00',9.94),('7643','2013-12-04','12:05:00',9.88),('7643','2013-12-04','12:10:00',9.81),('7643','2013-12-04','12:15:00',9.87),('7643','2013-12-04','12:20:00',9.81),('7643','2013-12-04','12:25:00',9.67),('7643','2013-12-04','12:30:00',9.57),('7643','2013-12-04','12:35:00',9.13),('7643','2013-12-04','12:40:00',9.5),('7643','2013-12-04','12:45:00',9.35),('7643','2013-12-04','12:50:00',8.77),('7643','2013-12-04','12:55:00',8.76),('7643','2013-12-04','13:00:00',8.33),('7643','2013-12-04','13:05:00',9.28),('7643','2013-12-04','13:10:00',9.46),('7643','2013-12-04','13:15:00',9.22),('7643','2013-12-04','13:20:00',9.05),('7643','2013-12-04','13:25:00',8.73),('7643','2013-12-04','13:30:00',8.47),('7643','2013-12-04','13:35:00',8.32),('7643','2013-12-04','13:40:00',7.98),('7643','2013-12-04','13:45:00',7.87),('7643','2013-12-04','13:50:00',7.48),('7643','2013-12-04','13:55:00',7.39),('7643','2013-12-04','14:00:00',7.13),('7643','2013-12-04','14:05:00',6.94),('7643','2013-12-04','14:10:00',6.69),('7643','2013-12-04','14:15:00',6.44),('7643','2013-12-04','14:20:00',6.19),('7643','2013-12-04','14:25:00',6.17),('7643','2013-12-04','14:30:00',5.7),('7643','2013-12-04','14:35:00',5.67),('7643','2013-12-04','14:40:00',5.39),('7643','2013-12-04','14:45:00',5.18),('7643','2013-12-04','14:50:00',4.84),('7643','2013-12-04','14:55:00',4.64),('7643','2013-12-04','15:00:00',4.39),('7643','2013-12-04','15:05:00',4.06),('7643','2013-12-04','15:10:00',3.72),('7643','2013-12-04','15:15:00',3.37),('7643','2013-12-04','15:20:00',3.12),('7643','2013-12-04','15:25:00',2.84),('7643','2013-12-04','15:30:00',2.48),('7643','2013-12-04','15:35:00',2.12),('7643','2013-12-04','15:40:00',1.85),('7643','2013-12-04','15:45:00',1.55),('7643','2013-12-04','15:50:00',1.29),('7643','2013-12-04','15:55:00',1.06),('7643','2013-12-03','08:00:00',1.99),('7643','2013-12-03','08:05:00',2.31),('7643','2013-12-03','08:10:00',2.64),('7643','2013-12-03','08:15:00',2.99),('7643','2013-12-03','08:20:00',3.31),('7643','2013-12-03','08:25:00',3.61),('7643','2013-12-03','08:30:00',3.95),('7643','2013-12-03','08:35:00',4.29),('7643','2013-12-03','08:40:00',4.6),('7643','2013-12-03','08:45:00',4.92),('7643','2013-12-03','08:50:00',5.21),('7643','2013-12-03','08:55:00',5.53),('7643','2013-12-03','09:00:00',5.87),('7643','2013-12-03','09:05:00',6.17),('7643','2013-12-03','09:10:00',6.45),('7643','2013-12-03','09:15:00',6.69),('7643','2013-12-03','09:20:00',6.93),('7643','2013-12-03','09:25:00',7.15),('7643','2013-12-03','09:30:00',7.4),('7643','2013-12-03','09:35:00',7.65),('7643','2013-12-03','09:40:00',7.89),('7643','2013-12-03','09:45:00',8.15),('7643','2013-12-03','09:50:00',8.36),('7643','2013-12-03','09:55:00',8.57),('7643','2013-12-03','10:00:00',8.75),('7643','2013-12-03','10:05:00',8.9),('7643','2013-12-03','10:10:00',9.07),('7643','2013-12-03','10:15:00',9.21),('7643','2013-12-03','10:20:00',9.33),('7643','2013-12-03','10:25:00',9.55),('7643','2013-12-03','10:30:00',9.72),('7643','2013-12-03','10:35:00',9.84),('7643','2013-12-03','10:40:00',9.95),('7643','2013-12-03','10:45:00',10.04),('7643','2013-12-03','10:50:00',10.12),('7643','2013-12-03','10:55:00',10.24),('7643','2013-12-03','11:00:00',10.29),('7643','2013-12-03','11:05:00',10.36),('7643','2013-12-03','11:10:00',10.42),('7643','2013-12-03','11:15:00',10.46),('7643','2013-12-03','11:20:00',10.51),('7643','2013-12-03','11:25:00',10.55),('7643','2013-12-03','11:30:00',10.57),('7643','2013-12-03','11:35:00',10.6),('7643','2013-12-03','11:40:00',10.66),('7643','2013-12-03','11:45:00',10.66),('7643','2013-12-03','11:50:00',10.64),('7643','2013-12-03','11:55:00',10.6),('7643','2013-12-03','12:00:00',10.6),('7643','2013-12-03','12:05:00',10.61),('7643','2013-12-03','12:10:00',10.58),('7643','2013-12-03','12:15:00',10.54),('7643','2013-12-03','12:20:00',10.46),('7643','2013-12-03','12:25:00',10.42),('7643','2013-12-03','12:30:00',10.35),('7643','2013-12-03','12:35:00',10.31),('7643','2013-12-03','12:40:00',10.18),('7643','2013-12-03','12:45:00',10.14),('7643','2013-12-03','12:50:00',10.03),('7643','2013-12-03','12:55:00',9.94),('7643','2013-12-03','13:00:00',9.83),('7643','2013-12-03','13:05:00',9.69),('7643','2013-12-03','13:10:00',9.6),('7643','2013-12-03','13:15:00',9.41),('7643','2013-12-03','13:20:00',9.28),('7643','2013-12-03','13:25:00',9.1),('7643','2013-12-03','13:30:00',8.98),('7643','2013-12-03','13:35:00',8.86),('7643','2013-12-03','13:40:00',8.63),('7643','2013-12-03','13:45:00',8.48),('7643','2013-12-03','13:50:00',8.25),('7643','2013-12-03','13:55:00',8.05),('7643','2013-12-03','14:00:00',7.93),('7643','2013-12-03','14:05:00',7.68),('7643','2013-12-03','14:10:00',7.46),('7643','2013-12-03','14:15:00',7.24),('7643','2013-12-03','14:20:00',7),('7643','2013-12-03','14:25:00',6.68),('7643','2013-12-03','14:30:00',6.41),('7643','2013-12-03','14:35:00',6.19),('7643','2013-12-03','14:40:00',6.04),('7643','2013-12-03','14:45:00',5.78),('7643','2013-12-03','14:50:00',5.46),('7643','2013-12-03','14:55:00',5.2),('7643','2013-12-03','15:00:00',4.88),('7643','2013-12-03','15:05:00',4.51),('7643','2013-12-03','15:10:00',4.19),('7643','2013-12-03','15:15:00',3.88),('7643','2013-12-03','15:20:00',3.57),('7643','2013-12-03','15:25:00',3.27),('7643','2013-12-03','15:30:00',2.96),('7643','2013-12-03','15:35:00',2.66),('7643','2013-12-03','15:40:00',2.38),('7643','2013-12-03','15:45:00',2.07),('7643','2013-12-03','15:50:00',1.77),('7643','2013-12-03','15:55:00',1.51),('7643','2013-12-03','16:00:00',1.24),('7643','2013-12-02','08:50:00',1.11),('7643','2013-12-02','08:55:00',1.31),('7643','2013-12-02','09:00:00',1.36),('7643','2013-12-02','09:05:00',1.74),('7643','2013-12-02','09:10:00',2.43),('7643','2013-12-02','09:15:00',3.39),('7643','2013-12-02','09:20:00',3.67),('7643','2013-12-02','09:25:00',4.34),('7643','2013-12-02','09:30:00',4.91),('7643','2013-12-02','09:35:00',5.11),('7643','2013-12-02','09:40:00',6.26),('7643','2013-12-02','09:45:00',6.52),('7643','2013-12-02','09:50:00',7),('7643','2013-12-02','09:55:00',6.56),('7643','2013-12-02','10:00:00',8.69),('7643','2013-12-02','10:05:00',8.9),('7643','2013-12-02','10:10:00',9.06),('7643','2013-12-02','10:15:00',9.23),('7643','2013-12-02','10:20:00',9.32),('7643','2013-12-02','10:25:00',9.51),('7643','2013-12-02','10:30:00',9.62),('7643','2013-12-02','10:35:00',9.75),('7643','2013-12-02','10:40:00',9.87),('7643','2013-12-02','10:45:00',9.99),('7643','2013-12-02','10:50:00',10.14),('7643','2013-12-02','10:55:00',10.35),('7643','2013-12-02','11:00:00',10.52),('7643','2013-12-02','11:05:00',10.64),('7643','2013-12-02','11:10:00',10.74),('7643','2013-12-02','11:15:00',10.79),('7643','2013-12-02','11:20:00',10.81),('7643','2013-12-02','11:25:00',10.8),('7643','2013-12-02','11:30:00',10.81),('7643','2013-12-02','11:35:00',10.8),('7643','2013-12-02','11:40:00',10.82),('7643','2013-12-02','11:45:00',10.87),('7643','2013-12-02','11:50:00',10.97),('7643','2013-12-02','11:55:00',11),('7643','2013-12-02','12:00:00',10.99),('7643','2013-12-02','12:05:00',11.02),('7643','2013-12-02','12:10:00',11.03),('7643','2013-12-02','12:15:00',11.1),('7643','2013-12-02','12:20:00',11.17),('7643','2013-12-02','12:25:00',11.25),('7643','2013-12-02','12:30:00',11.35),('7643','2013-12-02','12:35:00',11.38),('7643','2013-12-02','12:40:00',11.5),('7643','2013-12-02','12:45:00',11.67),('7643','2013-12-02','12:50:00',12.02),('7643','2013-12-02','12:55:00',12.36),('7643','2013-12-02','13:00:00',12.48),('7643','2013-12-02','13:05:00',12.59),('7643','2013-12-02','13:10:00',12.55),('7643','2013-12-02','13:15:00',12.11),('7643','2013-12-02','13:20:00',11.86),('7643','2013-12-02','13:25:00',11.43),('7643','2013-12-02','13:30:00',10.45),('7643','2013-12-02','13:35:00',10.71),('7643','2013-12-02','13:40:00',10.26),('7643','2013-12-02','13:45:00',9.69),('7643','2013-12-02','13:50:00',9.13),('7643','2013-12-02','13:55:00',8.93),('7643','2013-12-02','14:00:00',8.63),('7643','2013-12-02','14:05:00',8),('7643','2013-12-02','14:10:00',7.76),('7643','2013-12-02','14:15:00',7.24),('7643','2013-12-02','14:20:00',6.18),('7643','2013-12-02','14:25:00',5.74),('7643','2013-12-02','14:30:00',6.2),('7643','2013-12-02','14:35:00',6.23),('7643','2013-12-02','14:40:00',5.97),('7643','2013-12-02','14:45:00',5.67),('7643','2013-12-02','14:50:00',5.37),('7643','2013-12-02','14:55:00',5.06),('7643','2013-12-02','15:00:00',4.75),('7643','2013-12-02','15:05:00',4.45),('7643','2013-12-02','15:10:00',4.15),('7643','2013-12-02','15:15:00',3.83),('7643','2013-12-02','15:20:00',3.53),('7643','2013-12-02','15:25:00',3.18),('7643','2013-12-02','15:30:00',2.88),('7643','2013-12-02','15:35:00',2.57),('7643','2013-12-02','15:40:00',2.25),('7643','2013-12-02','15:45:00',1.94),('7643','2013-12-02','15:50:00',1.64),('7643','2013-12-02','15:55:00',1.38),('7643','2013-12-02','16:00:00',1.1),('7643','2013-12-01','09:35:00',1.06),('7643','2013-12-01','09:40:00',1.39),('7643','2013-12-01','09:45:00',1.12),('7643','2013-12-01','11:15:00',1.24),('7643','2013-12-01','11:20:00',1.45),('7643','2013-12-01','11:25:00',1.54),('7643','2013-12-01','11:30:00',1.6),('7643','2013-12-01','11:35:00',1.49),('7643','2013-12-01','11:40:00',1.29),('7643','2013-12-01','11:45:00',1.1),('7643','2013-12-01','11:50:00',1.15),('7643','2013-12-01','11:55:00',1.59),('7643','2013-12-01','12:00:00',1.83),('7643','2013-12-01','12:05:00',1.62),('7643','2013-12-01','12:10:00',1.44),('7643','2013-12-01','12:15:00',1.31),('7643','2013-12-01','12:20:00',1.3),('7643','2013-12-01','12:25:00',1.42),('7643','2013-12-01','12:30:00',1.67),('7643','2013-12-01','12:35:00',1.81),('7643','2013-12-01','12:40:00',1.66),('7643','2013-12-01','12:45:00',1.31),('7643','2013-12-01','12:50:00',1.07),('7643','2013-12-01','12:55:00',1.13),('7643','2013-12-01','13:00:00',1.33),('7643','2013-12-01','13:05:00',1.34),('7643','2013-12-01','13:10:00',1.12),('7643','2013-12-01','13:30:00',1.05),('7643','2013-12-01','13:35:00',1.57),('7643','2013-12-01','13:40:00',2.07),('7643','2013-12-01','13:45:00',2.11),('7643','2013-12-01','13:50:00',2.1),('7643','2013-12-01','13:55:00',2.32),('7643','2013-12-01','14:00:00',2.28),('7643','2013-12-01','14:05:00',2.11),('7643','2013-12-01','14:10:00',1.56),('7643','2013-12-01','14:15:00',1.31),('7643','2013-12-01','14:20:00',1.48),('7643','2013-12-01','14:25:00',1.44),('7643','2013-11-30','09:10:00',1.07),('7643','2013-11-30','10:50:00',1.1),('7643','2013-11-30','10:55:00',1.29),('7643','2013-11-30','11:00:00',1.91),('7643','2013-11-30','11:05:00',2.14),('7643','2013-11-30','11:10:00',2.02),('7643','2013-11-30','11:15:00',1.69),('7643','2013-11-30','11:20:00',1.77),('7643','2013-11-30','11:25:00',2.18),('7643','2013-11-30','11:30:00',2.94),('7643','2013-11-30','11:35:00',3.76),('7643','2013-11-30','11:40:00',3.63),('7643','2013-11-30','11:45:00',2.81),('7643','2013-11-30','11:50:00',2.93),('7643','2013-11-30','11:55:00',4.4),('7643','2013-11-30','12:00:00',3.84),('7643','2013-11-30','12:05:00',4.67),('7643','2013-11-30','12:10:00',5.98),('7643','2013-11-30','12:15:00',4.05),('7643','2013-11-30','12:20:00',2.12),('7643','2013-11-30','12:25:00',1.71),('7643','2013-11-30','12:30:00',1.53),('7643','2013-11-30','12:35:00',1.42),('7643','2013-11-30','12:40:00',1.71),('7643','2013-11-30','12:45:00',2.62),('7643','2013-11-30','12:50:00',2.6),('7643','2013-11-30','12:55:00',2.6),('7643','2013-11-30','13:00:00',2.65),('7643','2013-11-30','13:05:00',2.14),('7643','2013-11-30','13:10:00',1.54),('7643','2013-11-30','13:15:00',1.59),('7643','2013-11-30','13:20:00',1.55),('7643','2013-11-30','13:25:00',1.31),('7643','2013-11-30','13:30:00',1.42),('7643','2013-11-30','13:35:00',1.7),('7643','2013-11-30','13:40:00',1.66),('7643','2013-11-30','13:45:00',1.47),('7643','2013-11-30','13:50:00',1.79),('7643','2013-11-30','13:55:00',1.87),('7643','2013-11-30','14:00:00',1.9),('7643','2013-11-30','14:05:00',2.1),('7643','2013-11-30','14:10:00',1.99),('7643','2013-11-30','14:15:00',1.22),('7643','2013-11-30','14:25:00',1.12),('7643','2013-11-30','15:00:00',1.3),('7643','2013-11-30','15:05:00',1.7),('7643','2013-11-30','15:10:00',1.66),('7643','2013-11-30','15:15:00',1.2),('7643','2013-11-29','08:45:00',1.6),('7643','2013-11-29','08:50:00',1.98),('7643','2013-11-29','08:55:00',2.82),('7643','2013-11-29','09:00:00',2.92),('7643','2013-11-29','09:05:00',3.56),('7643','2013-11-29','09:10:00',5.79),('7643','2013-11-29','09:15:00',6.55),('7643','2013-11-29','09:20:00',7.17),('7643','2013-11-29','09:25:00',7.22),('7643','2013-11-29','09:30:00',7.42),('7643','2013-11-29','09:35:00',9.27),('7643','2013-11-29','09:40:00',8.31),('7643','2013-11-29','09:45:00',7.3),('7643','2013-11-29','09:50:00',5.48),('7643','2013-11-29','09:55:00',4.81),('7643','2013-11-29','10:00:00',4.69),('7643','2013-11-29','10:05:00',4.01),('7643','2013-11-29','10:10:00',3.81),('7643','2013-11-29','10:15:00',4.15),('7643','2013-11-29','10:20:00',4.5),('7643','2013-11-29','10:25:00',4.4),('7643','2013-11-29','10:30:00',4.6),('7643','2013-11-29','10:35:00',4.93),('7643','2013-11-29','10:40:00',5.36),('7643','2013-11-29','10:45:00',5.38),('7643','2013-11-29','10:50:00',5.44),('7643','2013-11-29','10:55:00',4.43),('7643','2013-11-29','11:00:00',4.13),('7643','2013-11-29','11:05:00',5),('7643','2013-11-29','11:10:00',5.33),('7643','2013-11-29','11:15:00',5.29),('7643','2013-11-29','11:20:00',4.64),('7643','2013-11-29','11:25:00',4.69),('7643','2013-11-29','11:30:00',4.23),('7643','2013-11-29','11:35:00',3.95),('7643','2013-11-29','11:40:00',3.75),('7643','2013-11-29','11:45:00',3.38),('7643','2013-11-29','11:50:00',3.24),('7643','2013-11-29','11:55:00',2.85),('7643','2013-11-29','12:00:00',2.68),('7643','2013-11-29','12:05:00',2.6),('7643','2013-11-29','12:10:00',2.42),('7643','2013-11-29','12:15:00',2.33),('7643','2013-11-29','12:20:00',2.35),('7643','2013-11-29','12:25:00',2.49),('7643','2013-11-29','12:30:00',2.34),('7643','2013-11-29','12:35:00',2.22),('7643','2013-11-29','12:40:00',2.01),('7643','2013-11-29','12:45:00',1.91),('7643','2013-11-29','12:50:00',1.81),('7643','2013-11-29','12:55:00',1.43),('7643','2013-11-29','13:00:00',1.45),('7643','2013-11-29','13:05:00',1.6),('7643','2013-11-29','13:10:00',1.49),('7643','2013-11-29','13:15:00',1.53),('7643','2013-11-29','13:20:00',1.74),('7643','2013-11-29','13:25:00',1.7),('7643','2013-11-29','13:30:00',1.79),('7643','2013-11-29','13:35:00',1.84),('7643','2013-11-29','13:40:00',2.06),('7643','2013-11-29','13:45:00',2.3),('7643','2013-11-29','13:50:00',2.84),('7643','2013-11-29','13:55:00',2.74),('7643','2013-11-29','14:00:00',2.32),('7643','2013-11-29','14:05:00',1.86),('7643','2013-11-29','14:10:00',1.23),('7643','2013-11-29','14:15:00',1),('7643','2013-11-28','07:40:00',1.01),('7643','2013-11-28','07:45:00',1.28),('7643','2013-11-28','07:50:00',1.57),('7643','2013-11-28','07:55:00',1.88),('7643','2013-11-28','08:00:00',2.19),('7643','2013-11-28','08:05:00',2.51),('7643','2013-11-28','08:10:00',2.85),('7643','2013-11-28','08:15:00',3.17),('7643','2013-11-28','08:20:00',3.5),('7643','2013-11-28','08:25:00',3.84),('7643','2013-11-28','08:30:00',4.14),('7643','2013-11-28','08:35:00',4.45),('7643','2013-11-28','08:40:00',4.77),('7643','2013-11-28','08:45:00',5.07),('7643','2013-11-28','08:50:00',5.38),('7643','2013-11-28','08:55:00',5.68),('7643','2013-11-28','09:00:00',5.97),('7643','2013-11-28','09:05:00',6.28),('7643','2013-11-28','09:10:00',6.56),('7643','2013-11-28','09:15:00',6.79),('7643','2013-11-28','09:20:00',7.09),('7643','2013-11-28','09:25:00',7.34),('7643','2013-11-28','09:30:00',7.59),('7643','2013-11-28','09:35:00',7.83),('7643','2013-11-28','09:40:00',8.08),('7643','2013-11-28','09:45:00',8.33),('7643','2013-11-28','09:50:00',8.55),('7643','2013-11-28','09:55:00',8.78),('7643','2013-11-28','10:00:00',8.98),('7643','2013-11-28','10:05:00',9.15),('7643','2013-11-28','10:10:00',9.3),('7643','2013-11-28','10:15:00',9.48),('7643','2013-11-28','10:20:00',9.65),('7643','2013-11-28','10:25:00',9.82),('7643','2013-11-28','10:30:00',9.95),('7643','2013-11-28','10:35:00',10.07),('7643','2013-11-28','10:40:00',10.2),('7643','2013-11-28','10:45:00',10.32),('7643','2013-11-28','10:50:00',10.42),('7643','2013-11-28','10:55:00',10.5),('7643','2013-11-28','11:00:00',10.58),('7643','2013-11-28','11:05:00',10.67),('7643','2013-11-28','11:10:00',10.78),('7643','2013-11-28','11:15:00',10.82),('7643','2013-11-28','11:20:00',10.89),('7643','2013-11-28','11:25:00',10.94),('7643','2013-11-28','11:30:00',10.96),('7643','2013-11-28','11:35:00',11.01),('7643','2013-11-28','11:40:00',11.03),('7643','2013-11-28','11:45:00',11.08),('7643','2013-11-28','11:50:00',11.04),('7643','2013-11-28','11:55:00',11.09),('7643','2013-11-28','12:00:00',11.04),('7643','2013-11-28','12:05:00',10.96),('7643','2013-11-28','12:10:00',10.96),('7643','2013-11-28','12:15:00',10.94),('7643','2013-11-28','12:20:00',10.87),('7643','2013-11-28','12:25:00',10.85),('7643','2013-11-28','12:30:00',10.75),('7643','2013-11-28','12:35:00',10.69),('7643','2013-11-28','12:40:00',10.6),('7643','2013-11-28','12:45:00',10.52),('7643','2013-11-28','12:50:00',10.39),('7643','2013-11-28','12:55:00',10.28),('7643','2013-11-28','13:00:00',10.19),('7643','2013-11-28','13:05:00',10.03),('7643','2013-11-28','13:10:00',9.9),('7643','2013-11-28','13:15:00',9.73),('7643','2013-11-28','13:20:00',9.56),('7643','2013-11-28','13:25:00',9.4),('7643','2013-11-28','13:30:00',9.22),('7643','2013-11-28','13:35:00',9.07),('7643','2013-11-28','13:40:00',8.91),('7643','2013-11-28','13:45:00',8.71),('7643','2013-11-28','13:50:00',8.46),('7643','2013-11-28','13:55:00',8.26),('7643','2013-11-28','14:00:00',8.03),('7643','2013-11-28','14:05:00',7.8),('7643','2013-11-28','14:10:00',7.59),('7643','2013-11-28','14:15:00',7.33),('7643','2013-11-28','14:20:00',7.08),('7643','2013-11-28','14:25:00',6.79),('7643','2013-11-28','14:30:00',6.54),('7643','2013-11-28','14:35:00',6.28),('7643','2013-11-28','14:40:00',5.98),('7643','2013-11-28','14:45:00',5.69),('7643','2013-11-28','14:50:00',5.41),('7643','2013-11-28','14:55:00',5.1),('7643','2013-11-28','15:00:00',4.78),('7643','2013-11-28','15:05:00',4.47),('7643','2013-11-28','15:10:00',4.17),('7643','2013-11-28','15:15:00',3.9),('7643','2013-11-28','15:20:00',3.58),('7643','2013-11-28','15:25:00',3.27),('7643','2013-11-28','15:30:00',2.96),('7643','2013-11-28','15:35:00',2.64),('7643','2013-11-28','15:40:00',2.33),('7643','2013-11-28','15:45:00',2.03),('7643','2013-11-28','15:50:00',1.74),('7643','2013-11-28','15:55:00',1.46),('7643','2013-11-28','16:00:00',1.19),('7643','2013-11-27','09:00:00',1.05),('7643','2013-11-27','09:05:00',1.21),('7643','2013-11-27','09:10:00',1.41),('7643','2013-11-27','09:15:00',1.62),('7643','2013-11-27','09:20:00',1.85),('7643','2013-11-27','09:25:00',2.18),('7643','2013-11-27','09:30:00',2.54),('7643','2013-11-27','09:35:00',2.86),('7643','2013-11-27','09:40:00',3.41),('7643','2013-11-27','09:45:00',3.62),('7643','2013-11-27','09:50:00',3.65),('7643','2013-11-27','09:55:00',3.46),('7643','2013-11-27','10:00:00',2.85),('7643','2013-11-27','10:05:00',2.37),('7643','2013-11-27','10:10:00',1.65),('7643','2013-11-27','10:35:00',1.01),('7643','2013-11-27','10:40:00',1.07),('7643','2013-11-27','10:45:00',1.2),('7643','2013-11-27','10:50:00',1.5),('7643','2013-11-27','10:55:00',1.73),('7643','2013-11-27','11:00:00',1.72),('7643','2013-11-27','11:05:00',1.39),('7643','2013-11-27','11:10:00',1.31),('7643','2013-11-27','11:15:00',1.67),('7643','2013-11-27','11:20:00',2.24),('7643','2013-11-27','11:25:00',2.36),('7643','2013-11-27','11:30:00',1.71),('7643','2013-11-27','11:35:00',1.48),('7643','2013-11-27','11:40:00',1.56),('7643','2013-11-27','11:45:00',1.35),('7643','2013-11-27','11:50:00',1.01),('7643','2013-11-27','11:55:00',1.05),('7643','2013-11-27','12:00:00',1.39),('7643','2013-11-27','12:05:00',1.67),('7643','2013-11-27','12:10:00',1.55),('7643','2013-11-27','12:15:00',1.26),('7643','2013-11-27','12:20:00',1.35),('7643','2013-11-27','12:25:00',1.88),('7643','2013-11-27','12:30:00',2.01),('7643','2013-11-27','12:35:00',1.99),('7643','2013-11-27','12:40:00',2.25),('7643','2013-11-27','12:45:00',2.55),('7643','2013-11-27','12:50:00',3.09),('7643','2013-11-27','12:55:00',3.87),('7643','2013-11-27','13:00:00',3.11),('7643','2013-11-27','13:05:00',1.75),('7643','2013-11-27','13:10:00',1.39),('7643','2013-11-27','13:15:00',1.49),('7643','2013-11-27','13:20:00',1.65),('7643','2013-11-27','13:25:00',3.15),('7643','2013-11-27','13:30:00',2.86),('7643','2013-11-27','13:35:00',3.18),('7643','2013-11-27','13:40:00',3.02),('7643','2013-11-27','13:45:00',2.54),('7643','2013-11-27','13:50:00',2.62),('7643','2013-11-27','13:55:00',1.49),('7643','2013-11-27','14:05:00',1.41),('7643','2013-11-27','14:10:00',2.8),('7643','2013-11-27','14:15:00',2.1),('7643','2013-11-27','14:20:00',1.05),('7643','2013-11-27','14:30:00',1.04),('7643','2014-04-19','07:15:00',1.15),('7643','2014-04-19','07:20:00',1.64),('7643','2014-04-19','07:40:00',2.69),('7643','2014-04-19','07:45:00',2.78),('7643','2014-04-19','07:50:00',3.72),('7643','2014-04-19','07:55:00',4.21),('7643','2014-04-19','08:00:00',4.39),('7643','2014-04-19','08:05:00',4.47),('7643','2014-04-19','08:10:00',4.83),('7643','2014-04-19','08:15:00',5.46),('7643','2014-04-19','08:20:00',6.44),('7643','2014-04-19','08:25:00',8.34),('7643','2014-04-19','08:30:00',8.61),('7643','2014-04-19','08:35:00',9.46),('7643','2014-04-19','08:40:00',9.03),('7643','2014-04-19','08:45:00',6.65),('7643','2014-04-19','08:50:00',6.54),('7643','2014-04-19','08:55:00',3.63),('7643','2014-04-19','09:00:00',6.18),('7643','2014-04-19','09:05:00',2.83),('7643','2014-04-19','09:10:00',7.03),('7643','2014-04-19','09:15:00',10.6),('7643','2014-04-19','09:20:00',10.12),('7643','2014-04-19','09:25:00',11.7),('7643','2014-04-19','09:30:00',13.12),('7643','2014-04-19','09:35:00',10.14),('7643','2014-04-19','09:40:00',7.76),('7643','2014-04-19','09:45:00',5.39),('7643','2014-04-19','09:50:00',6.11),('7643','2014-04-19','09:55:00',7.15),('7643','2014-04-19','10:00:00',8.78),('7643','2014-04-19','10:05:00',10.95),('7643','2014-04-19','10:10:00',10.84),('7643','2014-04-19','10:15:00',12.51),('7643','2014-04-19','10:20:00',12.11),('7643','2014-04-19','10:25:00',10.78),('7643','2014-04-19','10:30:00',9.75),('7643','2014-04-19','10:35:00',10.69),('7643','2014-04-19','10:40:00',10.27),('7643','2014-04-19','10:45:00',10.78),('7643','2014-04-19','10:50:00',11.62),('7643','2014-04-19','10:55:00',11.52),('7643','2014-04-19','11:00:00',11.78),('7643','2014-04-19','11:05:00',13.46),('7643','2014-04-19','11:10:00',13.41),('7643','2014-04-19','11:15:00',15.78),('7643','2014-04-19','11:20:00',15.02),('7643','2014-04-19','11:25:00',7.31),('7643','2014-04-19','11:30:00',17.68),('7643','2014-04-19','11:35:00',13.37),('7643','2014-04-19','11:40:00',10.32),('7643','2014-04-19','11:45:00',14.19),('7643','2014-04-19','11:50:00',9.32),('7643','2014-04-19','11:55:00',6.74),('7643','2014-04-19','12:00:00',11.27),('7643','2014-04-19','12:05:00',14.52),('7643','2014-04-19','12:10:00',10.56),('7643','2014-04-19','12:15:00',6.24),('7643','2014-04-19','12:20:00',8.77),('7643','2014-04-19','12:25:00',19.28),('7643','2014-04-19','12:30:00',17.56),('7643','2014-04-19','12:35:00',16.97),('7643','2014-04-19','12:40:00',17.09),('7643','2014-04-19','12:45:00',17.07),('7643','2014-04-19','12:50:00',17.17),('7643','2014-04-19','12:55:00',17.23),('7643','2014-04-19','13:00:00',17.34),('7643','2014-04-19','13:05:00',17.36),('7643','2014-04-19','13:10:00',17.8),('7643','2014-04-19','13:15:00',17.7),('7643','2014-04-19','13:20:00',17.06),('7643','2014-04-19','13:25:00',16.96),('7643','2014-04-19','13:30:00',16.98),('7643','2014-04-19','13:35:00',17.06),('7643','2014-04-19','13:40:00',17.05),('7643','2014-04-19','13:45:00',17.01),('7643','2014-04-19','13:50:00',16.97),('7643','2014-04-19','13:55:00',16.87),('7643','2014-04-19','14:00:00',16.78),('7643','2014-04-19','14:05:00',16.84),('7643','2014-04-19','14:10:00',16.76),('7643','2014-04-19','14:15:00',17.26),('7643','2014-04-19','14:20:00',13.43),('7643','2014-04-19','14:25:00',12.86),('7643','2014-04-19','14:30:00',12.17),('7643','2014-04-19','14:35:00',9.63),('7643','2014-04-19','14:40:00',9.53),('7643','2014-04-19','14:45:00',10.28),('7643','2014-04-19','14:50:00',10.03),('7643','2014-04-19','14:55:00',11.22),('7643','2014-04-19','15:00:00',14.03),('7643','2014-04-19','15:05:00',13.85),('7643','2014-04-19','15:10:00',15.08),('7643','2014-04-19','15:15:00',14.97),('7643','2014-04-19','15:20:00',14.32),('7643','2014-04-19','15:25:00',14.45),('7643','2014-04-19','15:30:00',14.15),('7643','2014-04-19','15:35:00',13.69),('7643','2014-04-19','15:40:00',14.18),('7643','2014-04-19','15:45:00',12.57),('7643','2014-04-19','15:50:00',9.95),('7643','2014-04-19','15:55:00',13.54),('7643','2014-04-19','16:00:00',12.99),('7643','2014-04-19','16:05:00',12.76),('7643','2014-04-19','16:10:00',12.54),('7643','2014-04-19','16:15:00',12.39),('7643','2014-04-19','16:20:00',12.4),('7643','2014-04-19','16:25:00',10.25),('7643','2014-04-19','16:30:00',12.23),('7643','2014-04-19','16:35:00',11.07),('7643','2014-04-19','16:40:00',9.53),('7643','2014-04-19','16:45:00',8.95),('7643','2014-04-19','16:50:00',9.58),('7643','2014-04-19','16:55:00',10.44),('7643','2014-04-19','17:00:00',9.82),('7643','2014-04-19','17:05:00',9.33),('7643','2014-04-19','17:10:00',8.85),('7643','2014-04-19','17:15:00',8.4),('7643','2014-04-19','17:20:00',8.06),('7643','2014-04-19','17:25:00',7.69),('7643','2014-04-19','17:30:00',7.32),('7643','2014-04-19','17:35:00',6.91),('7643','2014-04-19','17:40:00',6.51),('7643','2014-04-19','17:45:00',6.11),('7643','2014-04-19','17:50:00',5.68),('7643','2014-04-19','17:55:00',5.32),('7643','2014-04-19','18:00:00',4.89),('7643','2014-04-19','18:05:00',4.48),('7643','2014-04-19','18:10:00',4.15),('7643','2014-04-19','18:15:00',3.68),('7643','2014-04-19','18:20:00',2.47),('7643','2014-04-19','18:25:00',1.7),('7643','2014-04-19','18:30:00',2.69),('7643','2014-04-19','18:35:00',2.6),('7643','2014-04-19','18:40:00',2.14),('7643','2014-04-19','18:45:00',1.37),('7643','2013-11-26','08:15:00',1.06),('7643','2013-11-26','08:20:00',1.23),('7643','2013-11-26','08:25:00',1.31),('7643','2013-11-26','08:30:00',1.5),('7643','2013-11-26','08:35:00',1.69),('7643','2013-11-26','08:40:00',1.98),('7643','2013-11-26','08:45:00',2.36),('7643','2013-11-26','08:50:00',2.83),('7643','2013-11-26','08:55:00',2.98),('7643','2013-11-26','09:00:00',2.67),('7643','2013-11-26','09:05:00',2.47),('7643','2013-11-26','09:10:00',2.33),('7643','2013-11-26','09:15:00',2.52),('7643','2013-11-26','09:20:00',3.87),('7643','2013-11-26','09:25:00',3.89),('7643','2013-11-26','09:30:00',3.65),('7643','2013-11-26','09:35:00',3.62),('7643','2013-11-26','09:40:00',4.52),('7643','2013-11-26','09:45:00',3.61),('7643','2013-11-26','09:50:00',3.91),('7643','2013-11-26','09:55:00',5.59),('7643','2013-11-26','10:00:00',4.68),('7643','2013-11-26','10:05:00',4.74),('7643','2013-11-26','10:10:00',4.57),('7643','2013-11-26','10:15:00',4.39),('7643','2013-11-26','10:20:00',4.21),('7643','2013-11-26','10:25:00',4.48),('7643','2013-11-26','10:30:00',4.07),('7643','2013-11-26','10:35:00',4.42),('7643','2013-11-26','10:40:00',5.21),('7643','2013-11-26','10:45:00',5.74),('7643','2013-11-26','10:50:00',5.3),('7643','2013-11-26','10:55:00',4.9),('7643','2013-11-26','11:00:00',5.32),('7643','2013-11-26','11:05:00',5.87),('7643','2013-11-26','11:10:00',8.8),('7643','2013-11-26','11:15:00',5.38),('7643','2013-11-26','11:20:00',5.25),('7643','2013-11-26','11:25:00',5.62),('7643','2013-11-26','11:30:00',9.68),('7643','2013-11-26','11:35:00',7.4),('7643','2013-11-26','11:40:00',6.4),('7643','2013-11-26','11:45:00',5.95),('7643','2013-11-26','11:50:00',9.01),('7643','2013-11-26','11:55:00',13),('7643','2013-11-26','12:00:00',12.36),('7643','2013-11-26','12:05:00',10.59),('7643','2013-11-26','12:10:00',5.08),('7643','2013-11-26','12:15:00',8.09),('7643','2013-11-26','12:20:00',8.45),('7643','2013-11-26','12:25:00',5.29),('7643','2013-11-26','12:30:00',10.1),('7643','2013-11-26','12:35:00',8.27),('7643','2013-11-26','12:40:00',4.61),('7643','2013-11-26','12:45:00',3.72),('7643','2013-11-26','12:50:00',3.7),('7643','2013-11-26','12:55:00',3.71),('7643','2013-11-26','13:00:00',3.81),('7643','2013-11-26','13:05:00',3.81),('7643','2013-11-26','13:10:00',3.78),('7643','2013-11-26','13:15:00',3.64),('7643','2013-11-26','13:20:00',3.51),('7643','2013-11-26','13:25:00',3.39),('7643','2013-11-26','13:30:00',3.51),('7643','2013-11-26','13:35:00',3.53),('7643','2013-11-26','13:40:00',3.89),('7643','2013-11-26','13:45:00',3.61),('7643','2013-11-26','13:50:00',2.8),('7643','2013-11-26','13:55:00',2.4),('7643','2013-11-26','14:00:00',2.51),('7643','2013-11-26','14:05:00',2.16),('7643','2013-11-26','14:10:00',1.83),('7643','2013-11-26','14:15:00',1.57),('7643','2013-11-26','14:20:00',1.54),('7643','2013-11-26','14:25:00',1.27),('7643','2013-11-26','14:35:00',1.02),('7643','2013-11-26','15:45:00',1.02),('7643','2013-11-25','08:00:00',2.52),('7643','2013-11-25','08:05:00',3.25),('7643','2013-11-25','08:10:00',3.54),('7643','2013-11-25','08:15:00',3.23),('7643','2013-11-25','08:20:00',2.62),('7643','2013-11-25','08:25:00',1.06),('7643','2013-11-25','08:30:00',1.36),('7643','2013-11-25','08:35:00',1.66),('7643','2013-11-25','08:40:00',1.84),('7643','2013-11-25','08:45:00',2.95),('7643','2013-11-25','08:50:00',2.91),('7643','2013-11-25','08:55:00',3.32),('7643','2013-11-25','09:00:00',3.35),('7643','2013-11-25','09:05:00',3.97),('7643','2013-11-25','09:10:00',4.84),('7643','2013-11-25','09:15:00',5.68),('7643','2013-11-25','09:20:00',5.03),('7643','2013-11-25','09:25:00',5.12),('7643','2013-11-25','09:30:00',4.7),('7643','2013-11-25','09:35:00',5.51),('7643','2013-11-25','09:40:00',8.02),('7643','2013-11-25','09:45:00',5.44),('7643','2013-11-25','09:50:00',5.77),('7643','2013-11-25','09:55:00',7.75),('7643','2013-11-25','10:00:00',8.89),('7643','2013-11-25','10:05:00',8.66),('7643','2013-11-25','10:10:00',5.29),('7643','2013-11-25','10:15:00',3.49),('7643','2013-11-25','10:20:00',3.11),('7643','2013-11-25','10:25:00',5.92),('7643','2013-11-25','10:30:00',9.85),('7643','2013-11-25','10:35:00',11.09),('7643','2013-11-25','10:40:00',10.99),('7643','2013-11-25','10:45:00',11.23),('7643','2013-11-25','10:50:00',11.22),('7643','2013-11-25','10:55:00',11.56),('7643','2013-11-25','11:00:00',12.24),('7643','2013-11-25','11:05:00',11.66),('7643','2013-11-25','11:10:00',12.72),('7643','2013-11-25','11:15:00',13.74),('7643','2013-11-25','11:20:00',13.25),('7643','2013-11-25','11:25:00',12.9),('7643','2013-11-25','11:30:00',13.15),('7643','2013-11-25','11:35:00',13.7),('7643','2013-11-25','11:40:00',13.04),('7643','2013-11-25','11:45:00',12.86),('7643','2013-11-25','11:50:00',12.17),('7643','2013-11-25','11:55:00',7.06),('7643','2013-11-25','12:00:00',4.2),('7643','2013-11-25','12:05:00',6.64),('7643','2013-11-25','12:10:00',2.99),('7643','2013-11-25','12:15:00',4.35),('7643','2013-11-25','12:20:00',11.94),('7643','2013-11-25','12:25:00',11.83),('7643','2013-11-25','12:30:00',11.48),('7643','2013-11-25','12:35:00',11.46),('7643','2013-11-25','12:40:00',11.47),('7643','2013-11-25','12:45:00',11.31),('7643','2013-11-25','12:50:00',11.29),('7643','2013-11-25','12:55:00',11.19),('7643','2013-11-25','13:00:00',11.12),('7643','2013-11-25','13:05:00',10.98),('7643','2013-11-25','13:10:00',10.84),('7643','2013-11-25','13:15:00',10.68),('7643','2013-11-25','13:20:00',10.51),('7643','2013-11-25','13:25:00',10.35),('7643','2013-11-25','13:30:00',10.17),('7643','2013-11-25','13:35:00',9.98),('7643','2013-11-25','13:40:00',9.85),('7643','2013-11-25','13:45:00',9.7),('7643','2013-11-25','13:50:00',9.76),('7643','2013-11-25','13:55:00',9.35),('7643','2013-11-25','14:00:00',9.55),('7643','2013-11-25','14:05:00',7.49),('7643','2013-11-25','14:10:00',10.94),('7643','2013-11-25','14:15:00',11.32),('7643','2013-11-25','14:20:00',9.43),('7643','2013-11-25','14:25:00',6.37),('7643','2013-11-25','14:30:00',5.08),('7643','2013-11-25','14:35:00',6.84),('7643','2013-11-25','14:40:00',7.1),('7643','2013-11-25','14:45:00',7.33),('7643','2013-11-25','14:50:00',7.78),('7643','2013-11-25','14:55:00',8.2),('7643','2013-11-25','15:00:00',7.7),('7643','2013-11-25','15:05:00',6.75),('7643','2013-11-25','15:10:00',5.65),('7643','2013-11-25','15:15:00',5.05),('7643','2013-11-25','15:20:00',4.59),('7643','2013-11-25','15:25:00',4.17),('7643','2013-11-25','15:30:00',3.73),('7643','2013-11-25','15:35:00',3.37),('7643','2013-11-25','15:40:00',2.97),('7643','2013-11-25','15:45:00',2.67),('7643','2013-11-25','15:50:00',2.5),('7643','2013-11-25','15:55:00',2.19),('7643','2013-11-25','16:00:00',1.26),('7643','2013-11-24','07:40:00',1.31),('7643','2013-11-24','07:45:00',1.78),('7643','2013-11-24','07:50:00',2.03),('7643','2013-11-24','07:55:00',2.33),('7643','2013-11-24','08:00:00',2.64),('7643','2013-11-24','08:05:00',2.96),('7643','2013-11-24','08:10:00',3.3),('7643','2013-11-24','08:15:00',3.64),('7643','2013-11-24','08:20:00',4.18),('7643','2013-11-24','08:25:00',4.71),('7643','2013-11-24','08:30:00',4.97),('7643','2013-11-24','08:35:00',5.38),('7643','2013-11-24','08:40:00',5.68),('7643','2013-11-24','08:45:00',6.18),('7643','2013-11-24','08:50:00',6.71),('7643','2013-11-24','08:55:00',7.35),('7643','2013-11-24','09:00:00',8.11),('7643','2013-11-24','09:05:00',8.38),('7643','2013-11-24','09:10:00',8.57),('7643','2013-11-24','09:15:00',9.03),('7643','2013-11-24','09:20:00',8.82),('7643','2013-11-24','09:25:00',6.09),('7643','2013-11-24','09:30:00',5.96),('7643','2013-11-24','09:35:00',10.05),('7643','2013-11-24','09:40:00',8.86),('7643','2013-11-24','09:45:00',5.48),('7643','2013-11-24','09:50:00',6.9),('7643','2013-11-24','09:55:00',6.16),('7643','2013-11-24','10:00:00',7.19),('7643','2013-11-24','10:05:00',5.87),('7643','2013-11-24','10:10:00',9.31),('7643','2013-11-24','10:15:00',10.21),('7643','2013-11-24','10:20:00',7.28),('7643','2013-11-24','10:25:00',8.14),('7643','2013-11-24','10:30:00',8.58),('7643','2013-11-24','10:35:00',8.02),('7643','2013-11-24','10:40:00',13.2),('7643','2013-11-24','10:45:00',11.57),('7643','2013-11-24','10:50:00',11.56),('7643','2013-11-24','10:55:00',6.72),('7643','2013-11-24','11:00:00',11.38),('7643','2013-11-24','11:05:00',11.84),('7643','2013-11-24','11:10:00',13.49),('7643','2013-11-24','11:15:00',10.95),('7643','2013-11-24','11:20:00',8.55),('7643','2013-11-24','11:25:00',5.2),('7643','2013-11-24','11:30:00',5.47),('7643','2013-11-24','11:35:00',5.15),('7643','2013-11-24','11:40:00',4.62),('7643','2013-11-24','11:45:00',5.19),('7643','2013-11-24','11:50:00',5.22),('7643','2013-11-24','11:55:00',6.11),('7643','2013-11-24','12:00:00',6.58),('7643','2013-11-24','12:05:00',6.73),('7643','2013-11-24','12:10:00',6.58),('7643','2013-11-24','12:15:00',6.49),('7643','2013-11-24','12:20:00',5.72),('7643','2013-11-24','12:25:00',5.71),('7643','2013-11-24','12:30:00',5.06),('7643','2013-11-24','12:35:00',4.6),('7643','2013-11-24','12:40:00',10.71),('7643','2013-11-24','12:45:00',11.78),('7643','2013-11-24','12:50:00',9.44),('7643','2013-11-24','12:55:00',10),('7643','2013-11-24','13:00:00',12.82),('7643','2013-11-24','13:05:00',13.48),('7643','2013-11-24','13:10:00',9.85),('7643','2013-11-24','13:15:00',9.66),('7643','2013-11-24','13:20:00',11.53),('7643','2013-11-24','13:25:00',7.77),('7643','2013-11-24','13:30:00',5.17),('7643','2013-11-24','13:35:00',3.81),('7643','2013-11-24','13:40:00',3.42),('7643','2013-11-24','13:45:00',3.55),('7643','2013-11-24','13:50:00',3.18),('7643','2013-11-24','13:55:00',2.55),('7643','2013-11-24','14:00:00',2.05),('7643','2013-11-24','14:05:00',1.58),('7643','2013-11-24','14:10:00',1.34),('7643','2013-11-24','14:15:00',1.15),('7643','2013-11-24','14:20:00',1.04),('7643','2013-11-24','14:50:00',1.08),('7643','2013-11-24','14:55:00',1.26),('7643','2013-11-24','15:00:00',1.28),('7643','2013-11-24','15:05:00',1.38),('7643','2013-11-24','15:10:00',1.29),('7643','2013-11-24','15:15:00',1.35),('7643','2013-11-24','15:20:00',1.51),('7643','2013-11-24','15:25:00',1.3),('7643','2013-11-23','09:40:00',1.12),('7643','2013-11-23','09:45:00',1.66),('7643','2013-11-23','09:50:00',2.8),('7643','2013-11-23','09:55:00',4.04),('7643','2013-11-23','10:00:00',4.97),('7643','2013-11-23','10:05:00',5.29),('7643','2013-11-23','10:10:00',5.42),('7643','2013-11-23','10:15:00',4.67),('7643','2013-11-23','10:20:00',4.39),('7643','2013-11-23','10:25:00',6.19),('7643','2013-11-23','10:30:00',5.51),('7643','2013-11-23','10:35:00',5.11),('7643','2013-11-23','10:40:00',4.24),('7643','2013-11-23','10:45:00',3.87),('7643','2013-11-23','10:50:00',3.95),('7643','2013-11-23','10:55:00',4.25),('7643','2013-11-23','11:00:00',4.32),('7643','2013-11-23','11:05:00',4.48),('7643','2013-11-23','11:10:00',4.76),('7643','2013-11-23','11:15:00',4.88),('7643','2013-11-23','11:20:00',5.81),('7643','2013-11-23','11:25:00',5.71),('7643','2013-11-23','11:30:00',5.09),('7643','2013-11-23','11:35:00',4.53),('7643','2013-11-23','11:40:00',4.86),('7643','2013-11-23','11:45:00',4.36),('7643','2013-11-23','11:50:00',4.72),('7643','2013-11-23','11:55:00',3.96),('7643','2013-11-23','12:00:00',2.98),('7643','2013-11-23','12:05:00',2.26),('7643','2013-11-23','12:10:00',2.18),('7643','2013-11-23','12:15:00',2.83),('7643','2013-11-23','12:20:00',3.17),('7643','2013-11-23','12:25:00',3.36),('7643','2013-11-23','12:30:00',3.25),('7643','2013-11-23','12:35:00',3.33),('7643','2013-11-23','12:40:00',3.39),('7643','2013-11-23','12:45:00',3.35),('7643','2013-11-23','12:50:00',3.37),('7643','2013-11-23','12:55:00',3.56),('7643','2013-11-23','13:00:00',4.05),('7643','2013-11-23','13:05:00',4.73),('7643','2013-11-23','13:10:00',5.55),('7643','2013-11-23','13:15:00',5.56),('7643','2013-11-23','13:20:00',4.23),('7643','2013-11-23','13:25:00',3.43),('7643','2013-11-23','13:30:00',2.99),('7643','2013-11-23','13:35:00',2.93),('7643','2013-11-23','13:40:00',2.72),('7643','2013-11-23','13:45:00',2.45),('7643','2013-11-23','13:50:00',2.22),('7643','2013-11-23','13:55:00',2.07),('7643','2013-11-23','14:00:00',2.17),('7643','2013-11-23','14:05:00',2.23),('7643','2013-11-23','14:10:00',2.14),('7643','2013-11-23','14:15:00',2.12),('7643','2013-11-23','14:20:00',2.15),('7643','2013-11-23','14:25:00',2.14),('7643','2013-11-23','14:30:00',2.03),('7643','2013-11-23','14:35:00',1.88),('7643','2013-11-23','14:40:00',1.83),('7643','2013-11-23','14:45:00',1.72),('7643','2013-11-23','14:50:00',1.59),('7643','2013-11-23','14:55:00',1.47),('7643','2013-11-23','15:00:00',1.39),('7643','2013-11-23','15:05:00',1.33),('7643','2013-11-23','15:10:00',1.25),('7643','2013-11-23','15:15:00',1.15),('7643','2013-11-23','15:20:00',1.06),('7643','2013-11-22','08:15:00',1.34),('7643','2013-11-22','08:20:00',2.03),('7643','2013-11-22','08:25:00',2.32),('7643','2013-11-22','08:30:00',1.79),('7643','2013-11-22','08:35:00',1.98),('7643','2013-11-22','08:40:00',2.42),('7643','2013-11-22','08:45:00',2.08),('7643','2013-11-22','08:50:00',1.49),('7643','2013-11-22','08:55:00',1.12),('7643','2013-11-22','09:50:00',1.12),('7643','2013-11-22','09:55:00',1.62),('7643','2013-11-22','10:00:00',2.03),('7643','2013-11-22','10:05:00',2.36),('7643','2013-11-22','10:10:00',2.55),('7643','2013-11-22','10:15:00',4.48),('7643','2013-11-22','10:20:00',4.67),('7643','2013-11-22','10:25:00',4.97),('7643','2013-11-22','10:30:00',6.7),('7643','2013-11-22','10:35:00',3.99),('7643','2013-11-22','10:40:00',11.44),('7643','2013-11-22','10:45:00',2.38),('7643','2013-11-22','11:10:00',1.09),('7643','2013-11-22','11:15:00',1.96),('7643','2013-11-22','11:20:00',2.22),('7643','2013-11-22','11:25:00',2.68),('7643','2013-11-22','11:30:00',2.47),('7643','2013-11-22','11:35:00',2.33),('7643','2013-11-22','11:40:00',2.69),('7643','2013-11-22','11:45:00',2.53),('7643','2013-11-22','11:50:00',1.82),('7643','2013-11-22','11:55:00',1.02),('7643','2013-11-22','13:15:00',1.84),('7643','2013-11-22','13:20:00',3.08),('7643','2013-11-22','13:25:00',5.48),('7643','2013-11-22','13:30:00',3.73),('7643','2013-11-22','13:35:00',4.72),('7643','2013-11-22','13:40:00',4.46),('7643','2013-11-22','13:45:00',3.56),('7643','2013-11-22','13:50:00',3.62),('7643','2013-11-22','13:55:00',3.54),('7643','2013-11-22','14:00:00',4.25),('7643','2013-11-22','14:05:00',5.81),('7643','2013-11-22','14:10:00',2.23),('7643','2013-11-22','14:15:00',1.11),('7643','2013-11-22','14:45:00',1.51),('7643','2013-11-22','14:50:00',2.42),('7643','2013-11-22','14:55:00',2.82),('7643','2013-11-22','15:00:00',2.43),('7643','2013-11-22','15:05:00',2.12),('7643','2013-11-22','15:10:00',1.69),('7643','2013-11-22','15:15:00',1.98),('7643','2013-11-22','15:20:00',1.93),('7643','2013-11-22','15:25:00',1.1),('7643','2013-11-22','16:15:00',1.59),('7643','2013-11-22','16:20:00',1.01),('7643','2013-11-21','09:10:00',1.11),('7643','2013-11-21','09:15:00',1.43),('7643','2013-11-21','09:20:00',2),('7643','2013-11-21','09:25:00',1.82),('7643','2013-11-21','09:30:00',1.75),('7643','2013-11-21','09:35:00',1.75),('7643','2013-11-21','09:40:00',1.36),('7643','2013-11-21','09:45:00',1.44),('7643','2013-11-21','09:50:00',1.18),('7643','2013-11-21','09:55:00',1.21),('7643','2013-11-21','10:00:00',1.99),('7643','2013-11-21','10:05:00',1.77),('7643','2013-11-21','10:10:00',1.47),('7643','2013-11-21','11:45:00',1.19),('7643','2013-11-21','12:20:00',1.19),('7643','2013-11-21','13:10:00',1.34),('7643','2013-11-21','13:15:00',1.08),('7643','2013-11-20','08:00:00',1.13),('7643','2013-11-20','08:05:00',1.76),('7643','2013-11-20','08:10:00',3.92),('7643','2013-11-20','08:15:00',4.35),('7643','2013-11-20','08:20:00',2.52),('7643','2013-11-20','08:50:00',1),('7643','2013-11-20','08:55:00',1.18),('7643','2013-11-20','09:05:00',1.88),('7643','2013-11-20','09:10:00',3.4),('7643','2013-11-20','09:15:00',3.93),('7643','2013-11-20','09:20:00',4.81),('7643','2013-11-20','09:25:00',4.09),('7643','2013-11-20','09:30:00',4.52),('7643','2013-11-20','09:35:00',3.45),('7643','2013-11-20','09:40:00',5.56),('7643','2013-11-20','09:45:00',8.68),('7643','2013-11-20','09:50:00',6.7),('7643','2013-11-20','09:55:00',6.81),('7643','2013-11-20','10:00:00',7.86),('7643','2013-11-20','10:05:00',9.88),('7643','2013-11-20','10:10:00',8.48),('7643','2013-11-20','10:15:00',9.11),('7643','2013-11-20','10:20:00',9.5),('7643','2013-11-20','10:25:00',6.2),('7643','2013-11-20','10:30:00',7.18),('7643','2013-11-20','10:35:00',8.85),('7643','2013-11-20','10:40:00',9.27),('7643','2013-11-20','10:45:00',8.94),('7643','2013-11-20','10:50:00',2.43),('7643','2013-11-20','10:55:00',2.09),('7643','2013-11-20','11:00:00',2.46),('7643','2013-11-20','11:05:00',2.49),('7643','2013-11-20','11:10:00',2.8),('7643','2013-11-20','11:15:00',3.32),('7643','2013-11-20','11:20:00',5.32),('7643','2013-11-20','11:25:00',7.47),('7643','2013-11-20','11:30:00',7.95),('7643','2013-11-20','11:35:00',9.87),('7643','2013-11-20','11:40:00',10.51),('7643','2013-11-20','11:45:00',3.24),('7643','2013-11-20','11:50:00',11.04),('7643','2013-11-20','11:55:00',9.01),('7643','2013-11-20','12:00:00',8.01),('7643','2013-11-20','12:05:00',9.06),('7643','2013-11-20','12:10:00',10.84),('7643','2013-11-20','12:15:00',10.71),('7643','2013-11-20','12:20:00',10.76),('7643','2013-11-20','12:25:00',11),('7643','2013-11-20','12:30:00',11.61),('7643','2013-11-20','12:35:00',11.6),('7643','2013-11-20','12:40:00',12.01),('7643','2013-11-20','12:45:00',11.97),('7643','2013-11-20','12:50:00',10.35),('7643','2013-11-20','12:55:00',12.17),('7643','2013-11-20','13:00:00',11.78),('7643','2013-11-20','13:05:00',11.77),('7643','2013-11-20','13:10:00',11.01),('7643','2013-11-20','13:15:00',11.26),('7643','2013-11-20','13:20:00',10.66),('7643','2013-11-20','13:25:00',9.55),('7643','2013-11-20','13:30:00',4.97),('7643','2013-11-20','13:35:00',3.69),('7643','2013-11-20','13:40:00',8),('7643','2013-11-20','13:45:00',9.41),('7643','2013-11-20','13:50:00',4.76),('7643','2013-11-20','13:55:00',4.72),('7643','2013-11-20','14:00:00',9.08),('7643','2013-11-20','14:05:00',7.55),('7643','2013-11-20','14:10:00',4.99),('7643','2013-11-20','14:15:00',2.77),('7643','2013-11-20','14:20:00',1.92),('7643','2013-11-20','14:25:00',3.9),('7643','2013-11-20','14:30:00',1.93),('7643','2013-11-20','14:35:00',1.15),('7643','2013-11-20','14:40:00',3.85),('7643','2013-11-20','14:45:00',5.6),('7643','2013-11-20','14:50:00',5.24),('7643','2013-11-20','14:55:00',3.7),('7643','2013-11-20','15:00:00',4.84),('7643','2013-11-20','15:05:00',4.5),('7643','2013-11-20','15:10:00',4.18),('7643','2013-11-20','15:15:00',3.79),('7643','2013-11-20','15:20:00',3.38),('7643','2013-11-20','15:25:00',3.26),('7643','2013-11-20','15:30:00',1.94),('7643','2013-11-20','15:35:00',1.26),('7643','2013-11-20','15:55:00',1.07),('7643','2013-11-19','08:15:00',1.69),('7643','2013-11-19','08:20:00',4.48),('7643','2013-11-19','08:50:00',1.52),('7643','2013-11-19','08:55:00',3.64),('7643','2013-11-19','09:00:00',4.38),('7643','2013-11-19','09:05:00',1.06),('7643','2013-11-19','09:10:00',1.41),('7643','2013-11-19','09:15:00',6.38),('7643','2013-11-19','09:20:00',6.47),('7643','2013-11-19','09:25:00',6.95),('7643','2013-11-19','09:30:00',8.23),('7643','2013-11-19','09:35:00',4.51),('7643','2013-11-19','09:40:00',2.94),('7643','2013-11-19','09:45:00',1.11),('7643','2013-11-19','09:50:00',1.52),('7643','2013-11-19','09:55:00',2.01),('7643','2013-11-19','10:00:00',5.1),('7643','2013-11-19','10:05:00',3.79),('7643','2013-11-19','10:10:00',3.92),('7643','2013-11-19','10:15:00',7.46),('7643','2013-11-19','10:20:00',2.44),('7643','2013-11-19','10:25:00',2.65),('7643','2013-11-19','10:30:00',3.29),('7643','2013-11-19','10:35:00',2.69),('7643','2013-11-19','10:40:00',2.45),('7643','2013-11-19','10:45:00',1.88),('7643','2013-11-19','10:50:00',2.7),('7643','2013-11-19','10:55:00',2.9),('7643','2013-11-19','11:00:00',2.55),('7643','2013-11-19','11:05:00',2.48),('7643','2013-11-19','11:10:00',2.3),('7643','2013-11-19','11:15:00',2.14),('7643','2013-11-19','11:20:00',3.24),('7643','2013-11-19','11:25:00',3.92),('7643','2013-11-19','11:30:00',3.95),('7643','2013-11-19','11:35:00',3.27),('7643','2013-11-19','11:40:00',3.25),('7643','2013-11-19','11:45:00',11.72),('7643','2013-11-19','11:50:00',13.77),('7643','2013-11-19','11:55:00',8.26),('7643','2013-11-19','12:00:00',4.54),('7643','2013-11-19','12:05:00',1.83),('7643','2013-11-19','12:10:00',1.86),('7643','2013-11-19','12:15:00',3.24),('7643','2013-11-19','12:20:00',5.86),('7643','2013-11-19','12:25:00',3.83),('7643','2013-11-19','12:30:00',3),('7643','2013-11-19','12:35:00',2.42),('7643','2013-11-19','12:40:00',4.49),('7643','2013-11-19','12:45:00',4.38),('7643','2013-11-19','12:50:00',8.13),('7643','2013-11-19','12:55:00',10.04),('7643','2013-11-19','13:00:00',10.92),('7643','2013-11-19','13:05:00',7.19),('7643','2013-11-19','13:10:00',5.13),('7643','2013-11-19','13:15:00',2.44),('7643','2013-11-19','13:20:00',6.52),('7643','2013-11-19','13:25:00',5.59),('7643','2013-11-19','13:30:00',4.73),('7643','2013-11-19','13:35:00',2.01),('7643','2013-11-19','13:40:00',6.52),('7643','2013-11-19','13:45:00',4.24),('7643','2013-11-19','13:50:00',5.23),('7643','2013-11-19','13:55:00',4.67),('7643','2013-11-19','14:00:00',3.32),('7643','2013-11-19','14:05:00',3.43),('7643','2013-11-19','14:10:00',2.92),('7643','2013-11-19','14:15:00',2.5),('7643','2013-11-19','14:20:00',2.87),('7643','2013-11-19','14:25:00',4.11),('7643','2013-11-19','14:30:00',3.57),('7643','2013-11-19','14:35:00',2.74),('7643','2013-11-19','14:40:00',4.2),('7643','2013-11-19','14:45:00',5.6),('7643','2013-11-19','14:50:00',1.64),('7643','2013-11-19','14:55:00',1.1),('7643','2013-11-19','15:00:00',1.19),('7643','2013-11-19','15:05:00',4.02),('7643','2013-11-19','15:10:00',4.87),('7643','2013-11-19','15:15:00',3.53),('7643','2013-11-19','15:20:00',3.46),('7643','2013-11-19','15:25:00',3.31),('7643','2013-11-19','15:30:00',1.68),('7643','2013-11-19','15:35:00',2.09),('7643','2013-11-19','15:40:00',1.34),('7643','2013-11-18','07:50:00',1.2),('7643','2013-11-18','07:55:00',1.19),('7643','2013-11-18','08:10:00',1.3),('7643','2013-11-18','08:25:00',1.18),('7643','2013-11-18','08:30:00',1.81),('7643','2013-11-18','08:35:00',1.36),('7643','2013-11-18','08:55:00',1.15),('7643','2013-11-18','09:00:00',1.82),('7643','2013-11-18','09:05:00',1.79),('7643','2013-11-18','09:10:00',1.61),('7643','2013-11-18','09:15:00',1.57),('7643','2013-11-18','09:20:00',1.09),('7643','2013-11-18','09:30:00',1.55),('7643','2013-11-18','09:35:00',4.08),('7643','2013-11-18','09:40:00',8.1),('7643','2013-11-18','09:45:00',7.79),('7643','2013-11-18','09:50:00',4.58),('7643','2013-11-18','09:55:00',2.58),('7643','2013-11-18','10:00:00',5.24),('7643','2013-11-18','10:05:00',6.03),('7643','2013-11-18','10:10:00',1.92),('7643','2013-11-18','10:15:00',1.59),('7643','2013-11-18','10:20:00',2.34),('7643','2013-11-18','10:25:00',2.18),('7643','2013-11-18','10:30:00',1.49),('7643','2013-11-18','10:45:00',3.28),('7643','2013-11-18','10:50:00',5.69),('7643','2013-11-18','10:55:00',3.36),('7643','2013-11-18','11:00:00',1.88),('7643','2013-11-18','11:05:00',2.47),('7643','2013-11-18','11:10:00',3.29),('7643','2013-11-18','11:15:00',2.92),('7643','2013-11-18','11:20:00',9.54),('7643','2013-11-18','11:25:00',8.86),('7643','2013-11-18','11:30:00',10.41),('7643','2013-11-18','11:35:00',10.43),('7643','2013-11-18','11:40:00',9.04),('7643','2013-11-18','11:45:00',9.98),('7643','2013-11-18','11:50:00',9.68),('7643','2013-11-18','11:55:00',9.92),('7643','2013-11-18','12:00:00',7.8),('7643','2013-11-18','12:05:00',9.19),('7643','2013-11-18','12:10:00',9.5),('7643','2013-11-18','12:15:00',9.78),('7643','2013-11-18','12:20:00',5.11),('7643','2013-11-18','12:25:00',2.36),('7643','2013-11-18','12:30:00',5.73),('7643','2013-11-18','12:35:00',2.06),('7643','2013-11-18','12:40:00',2.23),('7643','2013-11-18','12:45:00',7.37),('7643','2013-11-18','12:50:00',5.84),('7643','2013-11-18','12:55:00',10.97),('7643','2013-11-18','13:00:00',9.5),('7643','2013-11-18','13:05:00',3.07),('7643','2013-11-18','13:10:00',6.84),('7643','2013-11-18','13:15:00',7.42),('7643','2013-11-18','13:20:00',9.28),('7643','2013-11-18','13:25:00',4.22),('7643','2013-11-18','13:30:00',2.43),('7643','2013-11-18','13:35:00',1.71),('7643','2013-11-18','14:25:00',1.32),('7643','2013-11-18','14:30:00',1.85),('7643','2013-11-18','14:35:00',1.76),('7643','2013-11-18','14:40:00',2.08),('7643','2013-11-18','14:45:00',2.15),('7643','2013-11-18','14:50:00',2.11),('7643','2013-11-18','14:55:00',2.33),('7643','2013-11-18','15:00:00',1.32),('7643','2013-11-18','15:15:00',1.06),('7643','2013-11-18','15:20:00',1.59),('7643','2013-11-18','15:25:00',4.63),('7643','2013-11-18','15:30:00',5.79),('7643','2013-11-18','15:35:00',4.29),('7643','2013-11-18','15:40:00',3.44),('7643','2013-11-18','15:45:00',2.93),('7643','2013-11-18','15:50:00',2.32),('7643','2013-11-18','15:55:00',1.7),('7643','2013-11-18','16:00:00',1.25),('7643','2013-11-17','07:35:00',1.36),('7643','2013-11-17','07:40:00',1.39),('7643','2013-11-17','07:45:00',1.26),('7643','2013-11-17','07:50:00',1.56),('7643','2013-11-17','07:55:00',2.25),('7643','2013-11-17','08:00:00',3.11),('7643','2013-11-17','08:05:00',3.22),('7643','2013-11-17','08:10:00',3.31),('7643','2013-11-17','08:15:00',3.46),('7643','2013-11-17','08:20:00',3.6),('7643','2013-11-17','08:25:00',3.86),('7643','2013-11-17','08:30:00',4.39),('7643','2013-11-17','08:35:00',4.24),('7643','2013-11-17','08:40:00',4.11),('7643','2013-11-17','08:45:00',3.94),('7643','2013-11-17','08:50:00',3.5),('7643','2013-11-17','08:55:00',3.47),('7643','2013-11-17','09:00:00',3.49),('7643','2013-11-17','09:05:00',3.17),('7643','2013-11-17','09:10:00',3.05),('7643','2013-11-17','09:15:00',4.61),('7643','2013-11-17','09:20:00',6.06),('7643','2013-11-17','09:25:00',6.35),('7643','2013-11-17','09:30:00',5.67),('7643','2013-11-17','09:35:00',7.62),('7643','2013-11-17','09:40:00',5.92),('7643','2013-11-17','09:45:00',5.06),('7643','2013-11-17','09:50:00',3.95),('7643','2013-11-17','09:55:00',4),('7643','2013-11-17','10:00:00',4.55),('7643','2013-11-17','10:05:00',5.11),('7643','2013-11-17','10:10:00',5.57),('7643','2013-11-17','10:15:00',6.77),('7643','2013-11-17','10:20:00',5.5),('7643','2013-11-17','10:25:00',5.01),('7643','2013-11-17','10:30:00',4.49),('7643','2013-11-17','10:35:00',4.34),('7643','2013-11-17','10:40:00',4.52),('7643','2013-11-17','10:45:00',4.7),('7643','2013-11-17','10:50:00',4.45),('7643','2013-11-17','10:55:00',3.9),('7643','2013-11-17','11:00:00',3.49),('7643','2013-11-17','11:05:00',3.18),('7643','2013-11-17','11:10:00',2.89),('7643','2013-11-17','11:15:00',2.68),('7643','2013-11-17','11:20:00',2.85),('7643','2013-11-17','11:25:00',3.34),('7643','2013-11-17','11:30:00',3.79),('7643','2013-11-17','11:35:00',4.02),('7643','2013-11-17','11:40:00',4.18),('7643','2013-11-17','11:45:00',4.32),('7643','2013-11-17','11:50:00',4.53),('7643','2013-11-17','11:55:00',4.9),('7643','2013-11-17','12:00:00',5.17),('7643','2013-11-17','12:05:00',5.46),('7643','2013-11-17','12:10:00',5.45),('7643','2013-11-17','12:15:00',5.61),('7643','2013-11-17','12:20:00',5.94),('7643','2013-11-17','12:25:00',6.28),('7643','2013-11-17','12:30:00',5.32),('7643','2013-11-17','12:35:00',4.55),('7643','2013-11-17','12:40:00',3.98),('7643','2013-11-17','12:45:00',3.56),('7643','2013-11-17','12:50:00',3.29),('7643','2013-11-17','12:55:00',3.17),('7643','2013-11-17','13:00:00',3.14),('7643','2013-11-17','13:05:00',3.38),('7643','2013-11-17','13:10:00',3.92),('7643','2013-11-17','13:15:00',3.68),('7643','2013-11-17','13:20:00',3.41),('7643','2013-11-17','13:25:00',3.03),('7643','2013-11-17','13:30:00',3.39),('7643','2013-11-17','13:35:00',4.16),('7643','2013-11-17','13:40:00',4.3),('7643','2013-11-17','13:45:00',3.85),('7643','2013-11-17','13:50:00',3.72),('7643','2013-11-17','13:55:00',3.13),('7643','2013-11-17','14:00:00',2.64),('7643','2013-11-17','14:05:00',2.12),('7643','2013-11-17','14:10:00',1.81),('7643','2013-11-17','14:15:00',1.54),('7643','2013-11-17','14:20:00',1.52),('7643','2013-11-17','14:25:00',1.77),('7643','2013-11-17','14:30:00',1.74),('7643','2013-11-17','14:35:00',1.6),('7643','2013-11-17','14:40:00',1.56),('7643','2013-11-17','14:45:00',1.58),('7643','2013-11-17','14:50:00',1.57),('7643','2013-11-17','14:55:00',1.43),('7643','2013-11-17','15:00:00',1.12),('7643','2013-11-17','15:05:00',1.14),('7643','2013-11-17','15:10:00',1.26),('7643','2013-11-17','15:15:00',1.28),('7643','2013-11-17','15:20:00',1.26),('7643','2013-11-17','15:25:00',1.04),('7643','2014-04-18','07:15:00',1.44),('7643','2014-04-18','07:20:00',1.9),('7643','2014-04-18','07:25:00',2.35),('7643','2014-04-18','07:30:00',2.93),('7643','2014-04-18','07:35:00',3.45),('7643','2014-04-18','07:40:00',4.09),('7643','2014-04-18','07:45:00',2.57),('7643','2014-04-18','07:50:00',2.89),('7643','2014-04-18','07:55:00',6.07),('7643','2014-04-18','08:00:00',6.28),('7643','2014-04-18','08:05:00',4.11),('7643','2014-04-18','08:10:00',4.92),('7643','2014-04-18','08:15:00',3.96),('7643','2014-04-18','08:20:00',4.26),('7643','2014-04-18','08:25:00',5.75),('7643','2014-04-18','08:30:00',8.06),('7643','2014-04-18','08:35:00',9.23),('7643','2014-04-18','08:40:00',7.28),('7643','2014-04-18','08:45:00',7.8),('7643','2014-04-18','08:50:00',5.87),('7643','2014-04-18','08:55:00',4.09),('7643','2014-04-18','09:00:00',2.54),('7643','2014-04-18','09:05:00',2.17),('7643','2014-04-18','09:10:00',2.52),('7643','2014-04-18','09:15:00',3.18),('7643','2014-04-18','09:20:00',3.77),('7643','2014-04-18','09:25:00',5.16),('7643','2014-04-18','09:30:00',7.98),('7643','2014-04-18','09:35:00',7.94),('7643','2014-04-18','09:40:00',4.8),('7643','2014-04-18','09:45:00',3.54),('7643','2014-04-18','09:50:00',3.02),('7643','2014-04-18','09:55:00',2.8),('7643','2014-04-18','10:00:00',2.98),('7643','2014-04-18','10:05:00',2.49),('7643','2014-04-18','10:10:00',2.24),('7643','2014-04-18','10:15:00',2.52),('7643','2014-04-18','10:20:00',3.18),('7643','2014-04-18','10:25:00',2.94),('7643','2014-04-18','10:30:00',2.86),('7643','2014-04-18','10:35:00',3.38),('7643','2014-04-18','10:40:00',4.62),('7643','2014-04-18','10:45:00',4.43),('7643','2014-04-18','10:50:00',4.47),('7643','2014-04-18','10:55:00',5.66),('7643','2014-04-18','11:00:00',6.13),('7643','2014-04-18','11:05:00',4.97),('7643','2014-04-18','11:10:00',4.55),('7643','2014-04-18','11:15:00',6.73),('7643','2014-04-18','11:20:00',11.29),('7643','2014-04-18','11:25:00',10.21),('7643','2014-04-18','11:30:00',10.73),('7643','2014-04-18','11:35:00',9.16),('7643','2014-04-18','11:40:00',8.3),('7643','2014-04-18','11:45:00',9.14),('7643','2014-04-18','11:50:00',7.25),('7643','2014-04-18','11:55:00',4.13),('7643','2014-04-18','12:00:00',3.17),('7643','2014-04-18','12:05:00',2.57),('7643','2014-04-18','12:10:00',1.98),('7643','2014-04-18','12:15:00',1.59),('7643','2014-04-18','12:20:00',1.55),('7643','2014-04-18','12:25:00',1.24),('7643','2014-04-18','12:35:00',1.29),('7643','2014-04-18','12:40:00',1.29),('7643','2014-04-18','12:45:00',1.12),('7643','2014-04-18','13:00:00',1.19),('7643','2014-04-18','13:05:00',1.69),('7643','2014-04-18','13:10:00',1.85),('7643','2014-04-18','13:15:00',5.49),('7643','2014-04-18','13:20:00',3.97),('7643','2014-04-18','13:25:00',1.83),('7643','2014-04-18','13:30:00',1.21),('7643','2014-04-18','13:35:00',2.5),('7643','2014-04-18','13:40:00',2.54),('7643','2014-04-18','13:45:00',2.03),('7643','2014-04-18','13:50:00',3.16),('7643','2014-04-18','13:55:00',2.43),('7643','2014-04-18','14:10:00',1.26),('7643','2014-04-18','14:15:00',1.8),('7643','2014-04-18','14:20:00',2.07),('7643','2014-04-18','14:25:00',2.34),('7643','2014-04-18','14:30:00',4.84),('7643','2014-04-18','14:35:00',5.77),('7643','2014-04-18','14:40:00',6.76),('7643','2014-04-18','14:45:00',7.26),('7643','2014-04-18','14:50:00',5.21),('7643','2014-04-18','14:55:00',4.28),('7643','2014-04-18','15:00:00',5.47),('7643','2014-04-18','15:05:00',4.66),('7643','2014-04-18','15:10:00',2.33),('7643','2014-04-18','15:15:00',1),('7643','2014-04-18','15:20:00',2.55),('7643','2014-04-18','15:25:00',4.06),('7643','2014-04-18','15:30:00',4.26),('7643','2014-04-18','15:35:00',2.63),('7643','2014-04-18','15:40:00',1.72),('7643','2014-04-18','15:45:00',3.27),('7643','2014-04-18','15:50:00',13.14),('7643','2014-04-18','15:55:00',11.9),('7643','2014-04-18','16:00:00',6.64),('7643','2014-04-18','16:05:00',6.42),('7643','2014-04-18','16:10:00',6.15),('7643','2014-04-18','16:15:00',6.53),('7643','2014-04-18','16:20:00',8.33),('7643','2014-04-18','16:25:00',8.25),('7643','2014-04-18','16:30:00',11.23),('7643','2014-04-18','16:35:00',6.19),('7643','2014-04-18','16:40:00',4.25),('7643','2014-04-18','16:45:00',3.55),('7643','2014-04-18','16:50:00',2.88),('7643','2014-04-18','16:55:00',1.92),('7643','2014-04-18','17:00:00',2.05),('7643','2014-04-18','17:05:00',2.97),('7643','2014-04-18','17:10:00',3.58),('7643','2014-04-18','17:15:00',3.76),('7643','2014-04-18','17:20:00',6.16),('7643','2014-04-18','17:25:00',5.34),('7643','2014-04-18','17:30:00',4.58),('7643','2014-04-18','17:35:00',3.67),('7643','2014-04-18','17:40:00',2.27),('7643','2014-04-18','17:45:00',1.77),('7643','2014-04-18','17:50:00',1.69),('7643','2014-04-18','17:55:00',1.58),('7643','2014-04-18','18:00:00',1.23),('7643','2014-04-18','18:05:00',1.08),('7643','2013-11-16','08:20:00',1.11),('7643','2013-11-16','08:25:00',1.35),('7643','2013-11-16','08:30:00',1.52),('7643','2013-11-16','08:35:00',1.72),('7643','2013-11-16','08:40:00',2),('7643','2013-11-16','08:45:00',6.21),('7643','2013-11-16','08:50:00',7.11),('7643','2013-11-16','08:55:00',7.71),('7643','2013-11-16','09:00:00',6.26),('7643','2013-11-16','09:05:00',6.63),('7643','2013-11-16','09:10:00',6.78),('7643','2013-11-16','09:15:00',7.26),('7643','2013-11-16','09:20:00',7.35),('7643','2013-11-16','09:25:00',7.55),('7643','2013-11-16','09:30:00',7.68),('7643','2013-11-16','09:35:00',7.74),('7643','2013-11-16','09:40:00',7.92),('7643','2013-11-16','09:45:00',8.06),('7643','2013-11-16','09:50:00',8.24),('7643','2013-11-16','09:55:00',8.4),('7643','2013-11-16','10:00:00',8.6),('7643','2013-11-16','10:05:00',8.77),('7643','2013-11-16','10:10:00',8.94),('7643','2013-11-16','10:15:00',9.1),('7643','2013-11-16','10:20:00',9.21),('7643','2013-11-16','10:25:00',9.33),('7643','2013-11-16','10:30:00',9.45),('7643','2013-11-16','10:35:00',9.54),('7643','2013-11-16','10:40:00',9.63),('7643','2013-11-16','10:45:00',9.72),('7643','2013-11-16','10:50:00',9.76),('7643','2013-11-16','10:55:00',9.79),('7643','2013-11-16','11:00:00',9.89),('7643','2013-11-16','11:05:00',9.93),('7643','2013-11-16','11:10:00',9.99),('7643','2013-11-16','11:15:00',10.03),('7643','2013-11-16','11:20:00',10.01),('7643','2013-11-16','11:25:00',10.04),('7643','2013-11-16','11:30:00',10.08),('7643','2013-11-16','11:35:00',10.09),('7643','2013-11-16','11:40:00',10.1),('7643','2013-11-16','11:45:00',10.12),('7643','2013-11-16','11:50:00',10.11),('7643','2013-11-16','11:55:00',10.07),('7643','2013-11-16','12:00:00',10.03),('7643','2013-11-16','12:05:00',9.99),('7643','2013-11-16','12:10:00',9.95),('7643','2013-11-16','12:15:00',9.92),('7643','2013-11-16','12:20:00',9.94),('7643','2013-11-16','12:25:00',9.93),('7643','2013-11-16','12:30:00',9.9),('7643','2013-11-16','12:35:00',9.86),('7643','2013-11-16','12:40:00',9.72),('7643','2013-11-16','12:45:00',9.64),('7643','2013-11-16','12:50:00',9.52),('7643','2013-11-16','12:55:00',9.41),('7643','2013-11-16','13:00:00',9.24),('7643','2013-11-16','13:05:00',9.12),('7643','2013-11-16','13:10:00',9),('7643','2013-11-16','13:15:00',8.85),('7643','2013-11-16','13:20:00',8.79),('7643','2013-11-16','13:25:00',7.25),('7643','2013-11-16','13:30:00',4.05),('7643','2013-11-16','13:35:00',5.55),('7643','2013-11-16','13:40:00',4.51),('7643','2013-11-16','13:45:00',1.9),('7643','2013-11-16','13:50:00',1.99),('7643','2013-11-16','13:55:00',4.34),('7643','2013-11-16','14:00:00',4.6),('7643','2013-11-16','14:05:00',5.89),('7643','2013-11-16','14:10:00',7.08),('7643','2013-11-16','14:15:00',6.86),('7643','2013-11-16','14:20:00',6.58),('7643','2013-11-16','14:25:00',6.16),('7643','2013-11-16','14:30:00',5.64),('7643','2013-11-16','14:35:00',5.52),('7643','2013-11-16','14:40:00',4.74),('7643','2013-11-16','14:45:00',1.69),('7643','2013-11-16','14:50:00',2.64),('7643','2013-11-16','14:55:00',1.35),('7643','2013-11-16','15:00:00',1.34),('7643','2013-11-16','15:05:00',1.14),('7643','2013-11-16','15:20:00',1.14),('7643','2013-11-16','15:25:00',1.38),('7643','2013-11-16','15:30:00',3.07),('7643','2013-11-16','15:35:00',2.78),('7643','2013-11-16','15:40:00',2.46),('7643','2013-11-16','15:45:00',2.19),('7643','2013-11-16','15:50:00',1.92),('7643','2013-11-16','15:55:00',1.84),('7643','2013-11-16','16:00:00',1.53),('7643','2013-11-15','09:40:00',1.09),('7643','2013-11-15','09:45:00',1.11),('7643','2013-11-15','09:50:00',1.29),('7643','2013-11-15','09:55:00',1.09),('7643','2013-11-15','10:40:00',1.19),('7643','2013-11-15','10:45:00',1.22),('7643','2013-11-15','10:50:00',1.01),('7643','2013-11-15','11:05:00',1.37),('7643','2013-11-15','11:10:00',1.5),('7643','2013-11-15','11:15:00',1.29),('7643','2013-11-15','12:35:00',1.12),('7643','2013-11-15','12:40:00',1.41),('7643','2013-11-15','12:45:00',1.76),('7643','2013-11-15','12:50:00',2.12),('7643','2013-11-15','12:55:00',2.29),('7643','2013-11-15','13:00:00',2.51),('7643','2013-11-15','13:05:00',3.1),('7643','2013-11-15','13:10:00',2.72),('7643','2013-11-15','13:15:00',2.2),('7643','2013-11-15','13:20:00',1.95),('7643','2013-11-15','13:25:00',1.96),('7643','2013-11-15','13:30:00',1.81),('7643','2013-11-15','13:35:00',1.52),('7643','2013-11-15','13:40:00',1.47),('7643','2013-11-15','13:45:00',1.66),('7643','2013-11-15','13:50:00',1.81),('7643','2013-11-15','13:55:00',1.85),('7643','2013-11-15','14:00:00',1.71),('7643','2013-11-15','14:05:00',1.54),('7643','2013-11-15','14:10:00',1.32),('7643','2013-11-15','14:15:00',1.13),('7643','2013-11-15','14:20:00',1.1),('7643','2013-11-15','14:25:00',1.21),('7643','2013-11-15','14:30:00',1.27),('7643','2013-11-15','14:35:00',1.35),('7643','2013-11-15','14:40:00',1.35),('7643','2013-11-15','14:45:00',1.12),('7643','2013-11-14','07:45:00',1.38),('7643','2013-11-14','07:50:00',1.34),('7643','2013-11-14','07:55:00',1.24),('7643','2013-11-14','08:00:00',1.08),('7643','2013-11-14','08:05:00',2.04),('7643','2013-11-14','08:10:00',2.79),('7643','2013-11-14','08:15:00',3.39),('7643','2013-11-14','08:20:00',3.06),('7643','2013-11-14','08:25:00',1.34),('7643','2013-11-14','08:30:00',1.3),('7643','2013-11-14','08:35:00',1.51),('7643','2013-11-14','08:40:00',1.78),('7643','2013-11-14','08:45:00',2.11),('7643','2013-11-14','08:50:00',2.3),('7643','2013-11-14','08:55:00',2.58),('7643','2013-11-14','09:00:00',2.83),('7643','2013-11-14','09:05:00',3.28),('7643','2013-11-14','09:10:00',3.86),('7643','2013-11-14','09:15:00',3.98),('7643','2013-11-14','09:20:00',3.02),('7643','2013-11-14','09:25:00',3.14),('7643','2013-11-14','09:30:00',3.98),('7643','2013-11-14','09:35:00',4.08),('7643','2013-11-14','09:40:00',3.36),('7643','2013-11-14','09:45:00',2.27),('7643','2013-11-14','09:50:00',1.78),('7643','2013-11-14','09:55:00',1.74),('7643','2013-11-14','10:00:00',2.05),('7643','2013-11-14','10:05:00',2.44),('7643','2013-11-14','10:10:00',3.57),('7643','2013-11-14','10:15:00',4.7),('7643','2013-11-14','10:20:00',4.42),('7643','2013-11-14','10:25:00',3.46),('7643','2013-11-14','10:30:00',3.1),('7643','2013-11-14','10:35:00',2.95),('7643','2013-11-14','10:40:00',2.63),('7643','2013-11-14','10:45:00',2.93),('7643','2013-11-14','10:50:00',5.21),('7643','2013-11-14','10:55:00',6.8),('7643','2013-11-14','11:00:00',5.12),('7643','2013-11-14','11:05:00',4.5),('7643','2013-11-14','11:10:00',4.32),('7643','2013-11-14','11:15:00',5.21),('7643','2013-11-14','11:20:00',6.82),('7643','2013-11-14','11:25:00',9.69),('7643','2013-11-14','11:30:00',6.18),('7643','2013-11-14','11:35:00',7.27),('7643','2013-11-14','11:40:00',6.89),('7643','2013-11-14','11:45:00',5.72),('7643','2013-11-14','11:50:00',4.91),('7643','2013-11-14','11:55:00',4.55),('7643','2013-11-14','12:00:00',5),('7643','2013-11-14','12:05:00',4.58),('7643','2013-11-14','12:10:00',4.49),('7643','2013-11-14','12:15:00',4.29),('7643','2013-11-14','12:20:00',5.57),('7643','2013-11-14','12:25:00',7.06),('7643','2013-11-14','12:30:00',5.35),('7643','2013-11-14','12:35:00',4.78),('7643','2013-11-14','12:40:00',4.38),('7643','2013-11-14','12:45:00',4.37),('7643','2013-11-14','12:50:00',5.8),('7643','2013-11-14','12:55:00',5.49),('7643','2013-11-14','13:00:00',5.44),('7643','2013-11-14','13:05:00',4.79),('7643','2013-11-14','13:10:00',4.63),('7643','2013-11-14','13:15:00',3.27),('7643','2013-11-14','13:20:00',3.18),('7643','2013-11-14','13:25:00',3.59),('7643','2013-11-14','13:30:00',4.27),('7643','2013-11-14','13:35:00',4.39),('7643','2013-11-14','13:40:00',5.13),('7643','2013-11-14','13:45:00',6.8),('7643','2013-11-14','13:50:00',7.21),('7643','2013-11-14','13:55:00',4.07),('7643','2013-11-14','14:00:00',4.55),('7643','2013-11-14','14:05:00',3.54),('7643','2013-11-14','14:10:00',2.96),('7643','2013-11-14','14:15:00',2.35),('7643','2013-11-14','14:20:00',1.74),('7643','2013-11-14','14:25:00',1.43),('7643','2013-11-14','14:30:00',1.36),('7643','2013-11-14','14:35:00',1.31),('7643','2013-11-14','14:40:00',1.22),('7643','2013-11-14','14:45:00',1.16),('7643','2013-11-14','14:50:00',1.08),('7643','2013-11-14','14:55:00',1.07),('7643','2013-11-14','15:00:00',1.08),('7643','2013-11-14','15:05:00',1.03),('7643','2013-11-13','08:05:00',1.24),('7643','2013-11-13','08:10:00',1.46),('7643','2013-11-13','08:15:00',2.98),('7643','2013-11-13','08:20:00',4.07),('7643','2013-11-13','08:25:00',4.19),('7643','2013-11-13','08:30:00',2.63),('7643','2013-11-13','08:35:00',2.96),('7643','2013-11-13','08:40:00',3.74),('7643','2013-11-13','08:45:00',2.18),('7643','2013-11-13','08:50:00',3.12),('7643','2013-11-13','08:55:00',4.33),('7643','2013-11-13','09:00:00',5.07),('7643','2013-11-13','09:05:00',7.27),('7643','2013-11-13','09:10:00',6.65),('7643','2013-11-13','09:15:00',7.2),('7643','2013-11-13','09:20:00',7.35),('7643','2013-11-13','09:25:00',7.32),('7643','2013-11-13','09:30:00',7.62),('7643','2013-11-13','09:35:00',7.78),('7643','2013-11-13','09:40:00',7.93),('7643','2013-11-13','09:45:00',8.01),('7643','2013-11-13','09:50:00',1.8),('7643','2013-11-13','09:55:00',2.44),('7643','2013-11-13','10:00:00',3.01),('7643','2013-11-13','10:05:00',6.21),('7643','2013-11-13','10:10:00',2.61),('7643','2013-11-13','10:15:00',8.91),('7643','2013-11-13','10:20:00',9.45),('7643','2013-11-13','10:25:00',9.44),('7643','2013-11-13','10:30:00',9.44),('7643','2013-11-13','10:35:00',9.38),('7643','2013-11-13','10:40:00',9.44),('7643','2013-11-13','10:45:00',9.65),('7643','2013-11-13','10:50:00',9.64),('7643','2013-11-13','10:55:00',9.8),('7643','2013-11-13','11:00:00',9.76),('7643','2013-11-13','11:05:00',10.06),('7643','2013-11-13','11:10:00',10.3),('7643','2013-11-13','11:15:00',10.57),('7643','2013-11-13','11:20:00',10.68),('7643','2013-11-13','11:25:00',10.78),('7643','2013-11-13','11:30:00',10.79),('7643','2013-11-13','11:35:00',10.38),('7643','2013-11-13','11:40:00',9.44),('7643','2013-11-13','11:45:00',6.63),('7643','2013-11-13','11:50:00',6.71),('7643','2013-11-13','11:55:00',5.86),('7643','2013-11-13','12:00:00',12.07),('7643','2013-11-13','12:05:00',7.61),('7643','2013-11-13','12:10:00',4.84),('7643','2013-11-13','12:15:00',5.12),('7643','2013-11-13','12:20:00',4.86),('7643','2013-11-13','12:25:00',4.17),('7643','2013-11-13','12:30:00',3.97),('7643','2013-11-13','12:35:00',4.12),('7643','2013-11-13','12:40:00',3.95),('7643','2013-11-13','12:45:00',4.07),('7643','2013-11-13','12:50:00',4.29),('7643','2013-11-13','12:55:00',4.12),('7643','2013-11-13','13:00:00',4.05),('7643','2013-11-13','13:05:00',3.58),('7643','2013-11-13','13:10:00',3.24),('7643','2013-11-13','13:15:00',3.31),('7643','2013-11-13','13:20:00',3.32),('7643','2013-11-13','13:25:00',3.13),('7643','2013-11-13','13:30:00',3.33),('7643','2013-11-13','13:35:00',3.13),('7643','2013-11-13','13:40:00',2.85),('7643','2013-11-13','13:45:00',2.67),('7643','2013-11-13','13:50:00',2.59),('7643','2013-11-13','13:55:00',2.71),('7643','2013-11-13','14:00:00',2.68),('7643','2013-11-13','14:05:00',3),('7643','2013-11-13','14:10:00',2.78),('7643','2013-11-13','14:15:00',2.56),('7643','2013-11-13','14:20:00',2.5),('7643','2013-11-13','14:25:00',2.36),('7643','2013-11-13','14:30:00',2.27),('7643','2013-11-13','14:35:00',2.04),('7643','2013-11-13','14:40:00',1.82),('7643','2013-11-13','14:45:00',1.66),('7643','2013-11-13','14:50:00',1.53),('7643','2013-11-13','14:55:00',1.53),('7643','2013-11-13','15:00:00',1.55),('7643','2013-11-13','15:05:00',1.64),('7643','2013-11-13','15:10:00',1.52),('7643','2013-11-13','15:15:00',1.39),('7643','2013-11-13','15:20:00',1.31),('7643','2013-11-13','15:35:00',1.17),('7643','2013-11-13','15:40:00',1.12),('7643','2013-11-13','15:45:00',1.04),('7643','2013-11-12','08:05:00',1.19),('7643','2013-11-12','08:10:00',1.52),('7643','2013-11-12','08:15:00',1.93),('7643','2013-11-12','08:20:00',2.17),('7643','2013-11-12','08:25:00',2.16),('7643','2013-11-12','08:30:00',2.8),('7643','2013-11-12','08:35:00',2.78),('7643','2013-11-12','08:40:00',1.53),('7643','2013-11-12','08:45:00',1.27),('7643','2013-11-12','08:50:00',1.18),('7643','2013-11-12','08:55:00',1.15),('7643','2013-11-12','09:50:00',1.1),('7643','2013-11-12','09:55:00',1.99),('7643','2013-11-12','10:00:00',4.38),('7643','2013-11-12','10:05:00',3.74),('7643','2013-11-12','10:10:00',3.74),('7643','2013-11-12','10:15:00',3.62),('7643','2013-11-12','10:20:00',8.81),('7643','2013-11-12','10:25:00',11.09),('7643','2013-11-12','10:30:00',10.71),('7643','2013-11-12','10:35:00',13.52),('7643','2013-11-12','10:40:00',8.6),('7643','2013-11-12','10:45:00',11.1),('7643','2013-11-12','10:50:00',13.33),('7643','2013-11-12','10:55:00',12.15),('7643','2013-11-12','11:00:00',10.37),('7643','2013-11-12','11:05:00',3.43),('7643','2013-11-12','11:10:00',3.4),('7643','2013-11-12','11:15:00',3.66),('7643','2013-11-12','11:20:00',3.57),('7643','2013-11-12','11:25:00',3.85),('7643','2013-11-12','11:30:00',5.87),('7643','2013-11-12','11:35:00',5.03),('7643','2013-11-12','11:40:00',3.47),('7643','2013-11-12','11:45:00',4.1),('7643','2013-11-12','11:50:00',4.49),('7643','2013-11-12','11:55:00',3.87),('7643','2013-11-12','12:00:00',2.77),('7643','2013-11-12','12:05:00',2.6),('7643','2013-11-12','12:10:00',2.86),('7643','2013-11-12','12:15:00',3.13),('7643','2013-11-12','12:20:00',2.8),('7643','2013-11-12','12:25:00',2.58),('7643','2013-11-12','12:30:00',2.15),('7643','2013-11-12','12:35:00',2.35),('7643','2013-11-12','12:40:00',2.65),('7643','2013-11-12','12:45:00',2.34),('7643','2013-11-12','12:50:00',2.39),('7643','2013-11-12','12:55:00',3.51),('7643','2013-11-12','13:00:00',4.13),('7643','2013-11-12','13:05:00',5.08),('7643','2013-11-12','13:10:00',4.51),('7643','2013-11-12','13:15:00',4.06),('7643','2013-11-12','13:20:00',3.1),('7643','2013-11-12','13:25:00',2.65),('7643','2013-11-12','13:30:00',2.79),('7643','2013-11-12','13:35:00',3.13),('7643','2013-11-12','13:40:00',3.67),('7643','2013-11-12','13:45:00',3.38),('7643','2013-11-12','13:50:00',3.28),('7643','2013-11-12','13:55:00',6.55),('7643','2013-11-12','14:00:00',7.03),('7643','2013-11-12','14:05:00',6.88),('7643','2013-11-12','14:10:00',6.12),('7643','2013-11-12','14:15:00',6.55),('7643','2013-11-12','14:20:00',5.85),('7643','2013-11-12','14:25:00',6.12),('7643','2013-11-12','14:30:00',5.55),('7643','2013-11-12','14:35:00',4.08),('7643','2013-11-12','14:40:00',3.35),('7643','2013-11-12','14:45:00',2.99),('7643','2013-11-12','14:50:00',2.77),('7643','2013-11-12','14:55:00',1.61),('7643','2013-11-12','15:00:00',2.35),('7643','2013-11-12','15:05:00',2.03),('7643','2013-11-12','15:10:00',1.13),('7643','2013-11-12','15:15:00',1.24),('7643','2013-11-12','15:20:00',1.18),('7643','2013-11-12','15:25:00',1.16),('7643','2013-11-12','15:30:00',1.06),('7643','2013-11-12','15:35:00',1.06),('7643','2013-11-12','15:40:00',1.18),('7643','2013-11-12','15:45:00',1.09),('7643','2013-11-11','09:05:00',1.18),('7643','2013-11-11','09:10:00',1.64),('7643','2013-11-11','09:15:00',1.68),('7643','2013-11-11','09:20:00',1.25),('7643','2013-11-11','09:25:00',1.45),('7643','2013-11-11','09:30:00',1.68),('7643','2013-11-11','09:35:00',1.73),('7643','2013-11-11','09:40:00',1.49),('7643','2013-11-11','09:45:00',1.23),('7643','2013-11-11','09:50:00',1.16),('7643','2013-11-11','09:55:00',1.46),('7643','2013-11-11','10:00:00',2.81),('7643','2013-11-11','10:05:00',2.15),('7643','2013-11-11','10:20:00',1.13),('7643','2013-11-11','10:25:00',1.26),('7643','2013-11-11','10:30:00',1.2),('7643','2013-11-11','10:35:00',1.23),('7643','2013-11-11','10:40:00',1.51),('7643','2013-11-11','10:45:00',1.82),('7643','2013-11-11','10:50:00',2.12),('7643','2013-11-11','10:55:00',2.38),('7643','2013-11-11','11:00:00',2.59),('7643','2013-11-11','11:05:00',2.38),('7643','2013-11-11','11:10:00',2.94),('7643','2013-11-11','11:15:00',2.93),('7643','2013-11-11','11:20:00',2.91),('7643','2013-11-11','11:25:00',5.43),('7643','2013-11-11','11:30:00',3.19),('7643','2013-11-11','11:35:00',4.29),('7643','2013-11-11','11:40:00',9.87),('7643','2013-11-11','11:45:00',5.91),('7643','2013-11-11','11:50:00',7.22),('7643','2013-11-11','11:55:00',3.86),('7643','2013-11-11','12:00:00',10.41),('7643','2013-11-11','12:05:00',5.02),('7643','2013-11-11','12:10:00',2.78),('7643','2013-11-11','12:15:00',2.83),('7643','2013-11-11','12:20:00',3.1),('7643','2013-11-11','12:25:00',4.12),('7643','2013-11-11','12:30:00',14.82),('7643','2013-11-11','12:35:00',12.28),('7643','2013-11-11','12:40:00',7.45),('7643','2013-11-11','12:45:00',7.12),('7643','2013-11-11','12:50:00',6.65),('7643','2013-11-11','12:55:00',7.2),('7643','2013-11-11','13:00:00',6.68),('7643','2013-11-11','13:05:00',7.15),('7643','2013-11-11','13:10:00',12.56),('7643','2013-11-11','13:15:00',10.23),('7643','2013-11-11','13:20:00',8.22),('7643','2013-11-11','13:25:00',8.52),('7643','2013-11-11','13:30:00',6.51),('7643','2013-11-11','13:35:00',7.44),('7643','2013-11-11','13:40:00',8.97),('7643','2013-11-11','13:45:00',6.71),('7643','2013-11-11','13:50:00',5.43),('7643','2013-11-11','13:55:00',5.2),('7643','2013-11-11','14:00:00',4.92),('7643','2013-11-11','14:05:00',3.91),('7643','2013-11-11','14:10:00',7.14),('7643','2013-11-11','14:15:00',10.11),('7643','2013-11-11','14:20:00',9.89),('7643','2013-11-11','14:25:00',7.98),('7643','2013-11-11','14:30:00',7.96),('7643','2013-11-11','14:35:00',3.39),('7643','2013-11-11','14:40:00',7.03),('7643','2013-11-11','14:45:00',5.95),('7643','2013-11-11','14:50:00',5.9),('7643','2013-11-11','14:55:00',4.59),('7643','2013-11-11','15:00:00',2.91),('7643','2013-11-11','15:05:00',1.97),('7643','2013-11-11','15:10:00',1.88),('7643','2013-11-11','15:15:00',3.42),('7643','2013-11-11','15:20:00',1.86),('7643','2013-11-11','15:25:00',1.16),('7643','2013-11-10','09:15:00',1.17),('7643','2013-11-10','09:25:00',1.31),('7643','2013-11-10','09:31:00',1.59),('7643','2013-11-10','09:35:00',1.34),('7643','2013-11-10','09:40:00',1.28),('7643','2013-11-10','09:45:00',2.61),('7643','2013-11-10','09:50:00',4.67),('7643','2013-11-10','09:55:00',4.32),('7643','2013-11-10','10:00:00',2.98),('7643','2013-11-10','10:05:00',3.31),('7643','2013-11-10','10:10:00',4.55),('7643','2013-11-10','10:15:00',7.31),('7643','2013-11-10','10:20:00',10.25),('7643','2013-11-10','10:25:00',4.57),('7643','2013-11-10','10:31:00',2.6),('7643','2013-11-10','10:35:00',3.16),('7643','2013-11-10','10:40:00',2.12),('7643','2013-11-10','10:45:00',1.76),('7643','2013-11-10','10:50:00',1.79),('7643','2013-11-10','10:55:00',1.95),('7643','2013-11-10','11:00:00',2.94),('7643','2013-11-10','11:05:00',5.14),('7643','2013-11-10','11:10:00',12.02),('7643','2013-11-10','11:15:00',7.1),('7643','2013-11-10','11:20:00',5.89),('7643','2013-11-10','11:25:00',12.04),('7643','2013-11-10','11:31:00',8.49),('7643','2013-11-10','11:35:00',14.08),('7643','2013-11-10','11:40:00',15.11),('7643','2013-11-10','11:45:00',13.42),('7643','2013-11-10','11:50:00',13.52),('7643','2013-11-10','11:55:00',12.52),('7643','2013-11-10','12:00:00',11.93),('7643','2013-11-10','12:05:00',11.64),('7643','2013-11-10','12:10:00',11.17),('7643','2013-11-10','12:15:00',10.7),('7643','2013-11-10','12:20:00',11.89),('7643','2013-11-10','12:25:00',10.39),('7643','2013-11-10','12:31:00',7.64),('7643','2013-11-10','12:35:00',5.19),('7643','2013-11-10','12:40:00',7.95),('7643','2013-11-10','12:45:00',3.27),('7643','2013-11-10','12:50:00',3.09),('7643','2013-11-10','12:55:00',2.88),('7643','2013-11-10','13:00:00',5.19),('7643','2013-11-10','13:05:00',4.34),('7643','2013-11-10','13:10:00',10.84),('7643','2013-11-10','13:15:00',2.57),('7643','2013-11-10','13:20:00',1.22),('7643','2013-11-10','13:25:00',1.76),('7643','2013-11-10','13:31:00',2.7),('7643','2013-11-10','13:35:00',5.33),('7643','2013-11-10','13:40:00',6.39),('7643','2013-11-10','13:45:00',2.47),('7643','2013-11-10','13:50:00',2.66),('7643','2013-11-10','13:55:00',3.03),('7643','2013-11-10','14:00:00',4.17),('7643','2013-11-10','14:05:00',2.9),('7643','2013-11-10','14:10:00',3.46),('7643','2013-11-10','14:15:00',3.82),('7643','2013-11-10','14:20:00',7.25),('7643','2013-11-10','14:25:00',8.17),('7643','2013-11-10','14:30:00',7.52),('7643','2013-11-10','14:35:00',7.25),('7643','2013-11-10','14:40:00',6.06),('7643','2013-11-10','14:45:00',3.29),('7643','2013-11-10','14:50:00',1.99),('7643','2013-11-10','14:55:00',2.15),('7643','2013-11-10','15:00:00',1.77),('7643','2013-11-10','15:05:00',1.46),('7643','2013-11-10','15:10:00',1.02),('7643','2013-11-09','07:25:00',1.11),('7643','2013-11-09','07:30:00',1.6),('7643','2013-11-09','07:35:00',2.39),('7643','2013-11-09','07:40:00',2.84),('7643','2013-11-09','07:45:00',3.33),('7643','2013-11-09','07:50:00',4.02),('7643','2013-11-09','07:55:00',4.1),('7643','2013-11-09','08:00:00',4.21),('7643','2013-11-09','08:05:00',2.77),('7643','2013-11-09','08:10:00',2.27),('7643','2013-11-09','08:15:00',2.7),('7643','2013-11-09','08:20:00',3.02),('7643','2013-11-09','08:25:00',2.69),('7643','2013-11-09','08:30:00',3.67),('7643','2013-11-09','08:35:00',3.47),('7643','2013-11-09','08:40:00',4.94),('7643','2013-11-09','08:45:00',6.32),('7643','2013-11-09','08:50:00',5.97),('7643','2013-11-09','08:55:00',6.99),('7643','2013-11-09','09:00:00',5.87),('7643','2013-11-09','09:05:00',4.88),('7643','2013-11-09','09:10:00',3.77),('7643','2013-11-09','09:15:00',5.7),('7643','2013-11-09','09:20:00',7.1),('7643','2013-11-09','09:25:00',8.1),('7643','2013-11-09','09:30:00',6.83),('7643','2013-11-09','09:35:00',7.01),('7643','2013-11-09','09:40:00',7.62),('7643','2013-11-09','09:45:00',8.37),('7643','2013-11-09','09:50:00',8.74),('7643','2013-11-09','09:55:00',8.57),('7643','2013-11-09','10:00:00',7.92),('7643','2013-11-09','10:05:00',9.06),('7643','2013-11-09','10:10:00',9.57),('7643','2013-11-09','10:15:00',10.07),('7643','2013-11-09','10:20:00',9.16),('7643','2013-11-09','10:25:00',10.61),('7643','2013-11-09','10:30:00',11.44),('7643','2013-11-09','10:35:00',9.66),('7643','2013-11-09','10:40:00',6.8),('7643','2013-11-09','10:45:00',11.16),('7643','2013-11-09','10:50:00',10.48),('7643','2013-11-09','10:55:00',12.25),('7643','2013-11-09','11:00:00',7.54),('7643','2013-11-09','11:05:00',5.04),('7643','2013-11-09','11:10:00',3.91),('7643','2013-11-09','11:15:00',2.31),('7643','2013-11-09','11:20:00',2.94),('7643','2013-11-09','11:25:00',6.64),('7643','2013-11-09','11:30:00',3.37),('7643','2013-11-09','11:35:00',3.73),('7643','2013-11-09','11:40:00',8.25),('7643','2013-11-09','11:45:00',9.17),('7643','2013-11-09','11:50:00',6.18),('7643','2013-11-09','11:55:00',5.16),('7643','2013-11-09','12:00:00',4.22),('7643','2013-11-09','12:05:00',3.88),('7643','2013-11-09','12:10:00',5.66),('7643','2013-11-09','12:15:00',11.36),('7643','2013-11-09','12:20:00',8.87),('7643','2013-11-09','12:25:00',10.64),('7643','2013-11-09','12:30:00',6.89),('7643','2013-11-09','12:35:00',7.33),('7643','2013-11-09','12:40:00',11.34),('7643','2013-11-09','12:45:00',12.16),('7643','2013-11-09','12:50:00',13.07),('7643','2013-11-09','12:55:00',8.32),('7643','2013-11-09','13:00:00',5.14),('7643','2013-11-09','13:05:00',2.61),('7643','2013-11-09','13:10:00',2.9),('7643','2013-11-09','13:15:00',1.95),('7643','2013-11-09','13:20:00',1.43),('7643','2013-11-09','13:30:00',1.29),('7643','2013-11-09','13:35:00',2.95),('7643','2013-11-09','13:40:00',2.47),('7643','2013-11-09','13:45:00',4.52),('7643','2013-11-09','13:50:00',6.71),('7643','2013-11-09','13:55:00',7.78),('7643','2013-11-09','14:00:00',1.83),('7643','2013-11-09','14:05:00',1.63),('7643','2013-11-09','14:10:00',1.06),('7643','2013-11-09','14:15:00',1.17),('7643','2013-11-09','14:20:00',2.15),('7643','2013-11-09','14:25:00',2.13),('7643','2013-11-09','14:30:00',3.09),('7643','2013-11-09','14:35:00',2.25),('7643','2013-11-09','14:45:00',1.09),('7643','2013-11-09','14:50:00',1.39),('7643','2013-11-09','15:00:00',1.17),('7643','2013-11-09','15:05:00',1.63),('7643','2013-11-09','15:10:00',1.39),('7643','2013-11-09','15:30:00',1.33),('7643','2013-11-09','15:35:00',1.24),('7643','2013-11-09','15:40:00',1.18),('7643','2013-11-08','07:40:00',1.11),('7643','2013-11-08','07:45:00',1.02),('7643','2013-11-08','07:50:00',1.05),('7643','2013-11-08','08:35:00',1.09),('7643','2013-11-08','09:00:00',1.07),('7643','2013-11-08','09:05:00',1.07),('7643','2013-11-08','09:10:00',2.69),('7643','2013-11-08','09:15:00',3.37),('7643','2013-11-08','09:20:00',2.75),('7643','2013-11-08','09:25:00',1.23),('7643','2013-11-08','09:30:00',3.2),('7643','2013-11-08','09:35:00',2.93),('7643','2013-11-08','09:40:00',6.85),('7643','2013-11-08','09:45:00',6.19),('7643','2013-11-08','09:50:00',6.86),('7643','2013-11-08','09:55:00',10.46),('7643','2013-11-08','10:00:00',10.02),('7643','2013-11-08','10:05:00',9.93),('7643','2013-11-08','10:10:00',9.39),('7643','2013-11-08','10:15:00',8.82),('7643','2013-11-08','10:20:00',9.29),('7643','2013-11-08','10:25:00',8.41),('7643','2013-11-08','10:30:00',4.02),('7643','2013-11-08','10:35:00',4.8),('7643','2013-11-08','10:40:00',4.79),('7643','2013-11-08','10:45:00',5.26),('7643','2013-11-08','10:50:00',5.94),('7643','2013-11-08','10:55:00',6.95),('7643','2013-11-08','11:00:00',9.38),('7643','2013-11-08','11:05:00',12.62),('7643','2013-11-08','11:10:00',12.13),('7643','2013-11-08','11:15:00',11.09),('7643','2013-11-08','11:20:00',7.31),('7643','2013-11-08','11:25:00',5.19),('7643','2013-11-08','11:30:00',10.09),('7643','2013-11-08','11:35:00',9.4),('7643','2013-11-08','11:40:00',5.1),('7643','2013-11-08','11:45:00',6.55),('7643','2013-11-08','11:50:00',4.57),('7643','2013-11-08','11:55:00',9.94),('7643','2013-11-08','12:00:00',10.04),('7643','2013-11-08','12:05:00',11.57),('7643','2013-11-08','12:10:00',4.23),('7643','2013-11-08','12:15:00',7.41),('7643','2013-11-08','12:20:00',4.2),('7643','2013-11-08','12:25:00',6.46),('7643','2013-11-08','12:30:00',8.07),('7643','2013-11-08','12:35:00',12.34),('7643','2013-11-08','12:40:00',7.32),('7643','2013-11-08','12:45:00',4.34),('7643','2013-11-08','12:50:00',7.73),('7643','2013-11-08','12:55:00',10.34),('7643','2013-11-08','13:00:00',11.49),('7643','2013-11-08','13:05:00',9.22),('7643','2013-11-08','13:10:00',11.25),('7643','2013-11-08','13:15:00',10.95),('7643','2013-11-08','13:20:00',6.42),('7643','2013-11-08','13:25:00',8.22),('7643','2013-11-08','13:30:00',9.87),('7643','2013-11-08','13:35:00',9.64),('7643','2013-11-08','13:40:00',8.88),('7643','2013-11-08','13:45:00',8.72),('7643','2013-11-08','13:50:00',8.72),('7643','2013-11-08','13:55:00',8.62),('7643','2013-11-08','14:00:00',7.91),('7643','2013-11-08','14:05:00',7.37),('7643','2013-11-08','14:10:00',5.15),('7643','2013-11-08','14:15:00',4.51),('7643','2013-11-08','14:20:00',7.99),('7643','2013-11-08','14:25:00',5.56),('7643','2013-11-08','14:30:00',1.93),('7643','2013-11-08','14:35:00',4.21),('7643','2013-11-08','14:40:00',5.03),('7643','2013-11-08','14:45:00',5.21),('7643','2013-11-08','14:50:00',5.55),('7643','2013-11-08','14:55:00',2.31),('7643','2013-11-08','15:00:00',1.2),('7643','2013-11-08','15:05:00',1.29),('7643','2013-11-08','15:10:00',1.29),('7643','2013-11-08','15:15:00',1.19),('7643','2013-11-08','15:20:00',1.19),('7643','2013-11-08','15:30:00',2.4),('7643','2013-11-08','15:35:00',4.1),('7643','2013-11-08','15:40:00',1.61),('7643','2013-11-08','15:45:00',2.59),('7643','2013-11-08','15:50:00',2.11),('7643','2013-11-08','15:55:00',1.08),('7643','2013-11-08','16:00:00',1.32),('7643','2013-11-07','07:55:00',1.08),('7643','2013-11-07','08:00:00',1.01),('7643','2013-11-07','08:25:00',1.04),('7643','2013-11-07','08:45:00',1.55),('7643','2013-11-07','08:50:00',1.59),('7643','2013-11-07','08:55:00',1.26),('7643','2013-11-07','09:00:00',2.08),('7643','2013-11-07','09:05:00',3.46),('7643','2013-11-07','09:10:00',4.93),('7643','2013-11-07','09:15:00',4.21),('7643','2013-11-07','09:20:00',3.13),('7643','2013-11-07','09:25:00',3.72),('7643','2013-11-07','09:30:00',5.6),('7643','2013-11-07','09:35:00',6.15),('7643','2013-11-07','09:40:00',5.94),('7643','2013-11-07','09:45:00',4.65),('7643','2013-11-07','09:50:00',8.75),('7643','2013-11-07','09:55:00',4.79),('7643','2013-11-07','10:00:00',4.8),('7643','2013-11-07','10:05:00',5.41),('7643','2013-11-07','10:10:00',8.89),('7643','2013-11-07','10:15:00',7.22),('7643','2013-11-07','10:20:00',1.6),('7643','2013-11-07','10:25:00',2.02),('7643','2013-11-07','10:30:00',1.8),('7643','2013-11-07','10:35:00',1.12),('7643','2013-11-07','10:40:00',2.62),('7643','2013-11-07','10:45:00',2.52),('7643','2013-11-07','10:50:00',2.72),('7643','2013-11-07','10:55:00',8.26),('7643','2013-11-07','11:00:00',5.95),('7643','2013-11-07','11:05:00',3.73),('7643','2013-11-07','11:10:00',2.27),('7643','2013-11-07','11:15:00',2.18),('7643','2013-11-07','11:20:00',2.38),('7643','2013-11-07','11:25:00',2.19),('7643','2013-11-07','11:30:00',6.84),('7643','2013-11-07','11:35:00',3.72),('7643','2013-11-07','11:40:00',8.05),('7643','2013-11-07','11:45:00',8.64),('7643','2013-11-07','11:50:00',10.75),('7643','2013-11-07','11:55:00',12.21),('7643','2013-11-07','12:00:00',11.49),('7643','2013-11-07','12:05:00',10.69),('7643','2013-11-07','12:10:00',10.65),('7643','2013-11-07','12:15:00',7.35),('7643','2013-11-07','12:20:00',1.42),('7643','2013-11-07','12:25:00',5.15),('7643','2013-11-07','12:30:00',2.2),('7643','2013-11-07','12:35:00',9.4),('7643','2013-11-07','12:40:00',11.58),('7643','2013-11-07','12:45:00',11.29),('7643','2013-11-07','12:50:00',11.47),('7643','2013-11-07','12:55:00',11.4),('7643','2013-11-07','13:00:00',10.72),('7643','2013-11-07','13:05:00',10.3),('7643','2013-11-07','13:10:00',10.54),('7643','2013-11-07','13:15:00',7.48),('7643','2013-11-07','13:20:00',4.97),('7643','2013-11-07','13:25:00',5.23),('7643','2013-11-07','13:30:00',2.87),('7643','2013-11-07','13:35:00',6.86),('7643','2013-11-07','13:40:00',9.44),('7643','2013-11-07','13:45:00',8.96),('7643','2013-11-07','13:50:00',8.32),('7643','2013-11-07','13:55:00',8.58),('7643','2013-11-07','14:00:00',8.25),('7643','2013-11-07','14:05:00',8.01),('7643','2013-11-07','14:10:00',7.77),('7643','2013-11-07','14:15:00',7.57),('7643','2013-11-07','14:20:00',7.2),('7643','2013-11-07','14:25:00',7.04),('7643','2013-11-07','14:30:00',6.95),('7643','2013-11-07','14:35:00',6.82),('7643','2013-11-07','14:40:00',6.42),('7643','2013-11-07','14:45:00',6.16),('7643','2013-11-07','14:50:00',5.9),('7643','2013-11-07','14:55:00',4.8),('7643','2013-11-07','15:00:00',4.8),('7643','2013-11-07','15:05:00',4.96),('7643','2013-11-07','15:10:00',4.81),('7643','2013-11-07','15:15:00',4.49),('7643','2013-11-07','15:20:00',4.09),('7643','2013-11-07','15:25:00',2.27),('7643','2013-11-07','15:30:00',2.49),('7643','2013-11-07','15:35:00',1.02),('7643','2013-11-07','15:55:00',1.71),('7643','2013-11-07','16:00:00',1.37),('7643','2013-11-07','16:05:00',1.39),('7643','2013-11-07','16:10:00',1.19),('7643','2013-11-07','16:15:00',1.02),('7643','2014-04-17','07:15:00',1.07),('7643','2014-04-17','07:20:00',1.37),('7643','2014-04-17','07:25:00',1.57),('7643','2014-04-17','07:30:00',1.55),('7643','2014-04-17','07:35:00',1.53),('7643','2014-04-17','07:40:00',2.07),('7643','2014-04-17','07:45:00',2.01),('7643','2014-04-17','07:50:00',1.73),('7643','2014-04-17','07:55:00',2.09),('7643','2014-04-17','08:00:00',3.53),('7643','2014-04-17','08:05:00',6.57),('7643','2014-04-17','08:10:00',6.06),('7643','2014-04-17','08:15:00',2.69),('7643','2014-04-17','08:20:00',1.99),('7643','2014-04-17','08:25:00',2.18),('7643','2014-04-17','08:30:00',2.39),('7643','2014-04-17','08:35:00',3.87),('7643','2014-04-17','08:40:00',5.51),('7643','2014-04-17','08:45:00',6),('7643','2014-04-17','08:50:00',4.23),('7643','2014-04-17','08:55:00',3.79),('7643','2014-04-17','09:00:00',4.6),('7643','2014-04-17','09:05:00',10.11),('7643','2014-04-17','09:10:00',12.82),('7643','2014-04-17','09:15:00',11.79),('7643','2014-04-17','09:20:00',11.1),('7643','2014-04-17','09:25:00',7.62),('7643','2014-04-17','09:30:00',12.54),('7643','2014-04-17','09:35:00',7.51),('7643','2014-04-17','09:40:00',5.37),('7643','2014-04-17','09:45:00',7.31),('7643','2014-04-17','09:50:00',11.57),('7643','2014-04-17','09:55:00',10.82),('7643','2014-04-17','10:00:00',10.4),('7643','2014-04-17','10:05:00',6.95),('7643','2014-04-17','10:10:00',6.02),('7643','2014-04-17','10:15:00',7.04),('7643','2014-04-17','10:20:00',5.65),('7643','2014-04-17','10:25:00',5.89),('7643','2014-04-17','10:30:00',4.96),('7643','2014-04-17','10:35:00',4.47),('7643','2014-04-17','10:40:00',5.34),('7643','2014-04-17','10:45:00',10.68),('7643','2014-04-17','10:50:00',10.76),('7643','2014-04-17','10:55:00',11.66),('7643','2014-04-17','11:00:00',6.92),('7643','2014-04-17','11:05:00',6.23),('7643','2014-04-17','11:10:00',8.33),('7643','2014-04-17','11:15:00',11.79),('7643','2014-04-17','11:20:00',7.39),('7643','2014-04-17','11:25:00',5.16),('7643','2014-04-17','11:30:00',6.29),('7643','2014-04-17','11:35:00',6.21),('7643','2014-04-17','11:40:00',6.52),('7643','2014-04-17','11:45:00',6.02),('7643','2014-04-17','11:50:00',7.29),('7643','2014-04-17','11:55:00',6.77),('7643','2014-04-17','12:00:00',6.81),('7643','2014-04-17','12:05:00',11.06),('7643','2014-04-17','12:10:00',12.4),('7643','2014-04-17','12:15:00',13.24),('7643','2014-04-17','12:20:00',15.87),('7643','2014-04-17','12:25:00',13.41),('7643','2014-04-17','12:30:00',17.7),('7643','2014-04-17','12:35:00',16.91),('7643','2014-04-17','12:40:00',17.91),('7643','2014-04-17','12:45:00',13.72),('7643','2014-04-17','12:50:00',15.33),('7643','2014-04-17','12:55:00',10.32),('7643','2014-04-17','13:00:00',18.16),('7643','2014-04-17','13:05:00',11.95),('7643','2014-04-17','13:10:00',9.44),('7643','2014-04-17','13:15:00',9.31),('7643','2014-04-17','13:20:00',8.38),('7643','2014-04-17','13:25:00',6.34),('7643','2014-04-17','13:30:00',5.45),('7643','2014-04-17','13:35:00',5.48),('7643','2014-04-17','13:40:00',4.77),('7643','2014-04-17','13:45:00',4.11),('7643','2014-04-17','13:50:00',5.08),('7643','2014-04-17','13:55:00',7.99),('7643','2014-04-17','14:00:00',7.4),('7643','2014-04-17','14:05:00',6.34),('7643','2014-04-17','14:10:00',5.58),('7643','2014-04-17','14:15:00',4.95),('7643','2014-04-17','14:20:00',5.9),('7643','2014-04-17','14:25:00',7.73),('7643','2014-04-17','14:30:00',8.63),('7643','2014-04-17','14:35:00',9.69),('7643','2014-04-17','14:40:00',8.77),('7643','2014-04-17','14:45:00',10.36),('7643','2014-04-17','14:50:00',12.16),('7643','2014-04-17','14:55:00',8.44),('7643','2014-04-17','15:00:00',13.74),('7643','2014-04-17','15:05:00',10.45),('7643','2014-04-17','15:10:00',8.36),('7643','2014-04-17','15:15:00',9.18),('7643','2014-04-17','15:20:00',7.69),('7643','2014-04-17','15:25:00',8.16),('7643','2014-04-17','15:30:00',11.88),('7643','2014-04-17','15:35:00',17.23),('7643','2014-04-17','15:40:00',8.1),('7643','2014-04-17','15:45:00',8.92),('7643','2014-04-17','15:50:00',11.67),('7643','2014-04-17','15:55:00',9.65),('7643','2014-04-17','16:00:00',8.53),('7643','2014-04-17','16:05:00',6.61),('7643','2014-04-17','16:10:00',5.49),('7643','2014-04-17','16:15:00',4.73),('7643','2014-04-17','16:20:00',4.81),('7643','2014-04-17','16:25:00',8.39),('7643','2014-04-17','16:30:00',7.86),('7643','2014-04-17','16:35:00',13.06),('7643','2014-04-17','16:40:00',11.39),('7643','2014-04-17','16:45:00',10.93),('7643','2014-04-17','16:50:00',8.78),('7643','2014-04-17','16:55:00',6.59),('7643','2014-04-17','17:00:00',7.21),('7643','2014-04-17','17:05:00',10.76),('7643','2014-04-17','17:10:00',8.01),('7643','2014-04-17','17:15:00',8.79),('7643','2014-04-17','17:20:00',7.67),('7643','2014-04-17','17:25:00',8.05),('7643','2014-04-17','17:30:00',7.36),('7643','2014-04-17','17:35:00',6.85),('7643','2014-04-17','17:40:00',6.54),('7643','2014-04-17','17:45:00',6.13),('7643','2014-04-17','17:50:00',5.79),('7643','2014-04-17','17:55:00',5.36),('7643','2014-04-17','18:00:00',4.96),('7643','2014-04-17','18:05:00',4.46),('7643','2014-04-17','18:10:00',4.02),('7643','2014-04-17','18:15:00',3.45),('7643','2014-04-17','18:20:00',2.61),('7643','2014-04-17','18:25:00',2.75),('7643','2014-04-17','18:30:00',1.95),('7643','2014-04-17','18:35:00',2.13),('7643','2014-04-17','18:40:00',1.82),('7643','2014-04-17','18:45:00',1.67),('7643','2014-04-17','18:50:00',1.35),('7643','2014-04-17','18:55:00',1.05),('7643','2013-11-06','07:20:00',1.1),('7643','2013-11-06','07:25:00',1.37),('7643','2013-11-06','07:30:00',1.64),('7643','2013-11-06','07:35:00',1.93),('7643','2013-11-06','07:40:00',2.22),('7643','2013-11-06','07:45:00',2.52),('7643','2013-11-06','07:50:00',2.83),('7643','2013-11-06','07:55:00',3.14),('7643','2013-11-06','08:00:00',3.42),('7643','2013-11-06','08:05:00',3.75),('7643','2013-11-06','08:10:00',4.06),('7643','2013-11-06','08:15:00',4.36),('7643','2013-11-06','08:20:00',4.63),('7643','2013-11-06','08:25:00',4.92),('7643','2013-11-06','08:30:00',5.22),('7643','2013-11-06','08:35:00',5.5),('7643','2013-11-06','08:40:00',5.79),('7643','2013-11-06','08:45:00',6.06),('7643','2013-11-06','08:50:00',6.29),('7643','2013-11-06','08:55:00',6.54),('7643','2013-11-06','09:00:00',6.79),('7643','2013-11-06','09:05:00',7.01),('7643','2013-11-06','09:10:00',7.22),('7643','2013-11-06','09:15:00',7.43),('7643','2013-11-06','09:20:00',7.59),('7643','2013-11-06','09:25:00',7.8),('7643','2013-11-06','09:30:00',8.02),('7643','2013-11-06','09:35:00',8.21),('7643','2013-11-06','09:40:00',8.39),('7643','2013-11-06','09:45:00',8.59),('7643','2013-11-06','09:50:00',8.73),('7643','2013-11-06','09:55:00',8.88),('7643','2013-11-06','10:00:00',9.02),('7643','2013-11-06','10:05:00',9.12),('7643','2013-11-06','10:10:00',9.17),('7643','2013-11-06','10:15:00',9.23),('7643','2013-11-06','10:20:00',9.32),('7643','2013-11-06','10:25:00',9.42),('7643','2013-11-06','10:30:00',9.49),('7643','2013-11-06','10:35:00',9.65),('7643','2013-11-06','10:40:00',9.76),('7643','2013-11-06','10:45:00',9.77),('7643','2013-11-06','10:50:00',9.84),('7643','2013-11-06','10:55:00',9.8),('7643','2013-11-06','11:00:00',9.89),('7643','2013-11-06','11:05:00',9.95),('7643','2013-11-06','11:10:00',10.03),('7643','2013-11-06','11:15:00',10.01),('7643','2013-11-06','11:20:00',9.97),('7643','2013-11-06','11:25:00',10),('7643','2013-11-06','11:30:00',9.95),('7643','2013-11-06','11:35:00',9.98),('7643','2013-11-06','11:40:00',9.99),('7643','2013-11-06','11:45:00',10.04),('7643','2013-11-06','11:50:00',9.99),('7643','2013-11-06','11:55:00',10.02),('7643','2013-11-06','12:00:00',9.96),('7643','2013-11-06','12:05:00',9.86),('7643','2013-11-06','12:10:00',9.78),('7643','2013-11-06','12:15:00',9.77),('7643','2013-11-06','12:20:00',9.85),('7643','2013-11-06','12:25:00',9.57),('7643','2013-11-06','12:30:00',9.63),('7643','2013-11-06','12:35:00',9.48),('7643','2013-11-06','12:40:00',9.48),('7643','2013-11-06','12:45:00',9.25),('7643','2013-11-06','12:50:00',9.56),('7643','2013-11-06','12:55:00',9.68),('7643','2013-11-06','13:00:00',10.03),('7643','2013-11-06','13:05:00',9.8),('7643','2013-11-06','13:10:00',9.9),('7643','2013-11-06','13:15:00',10.22),('7643','2013-11-06','13:20:00',4.48),('7643','2013-11-06','13:25:00',2.95),('7643','2013-11-06','13:30:00',3.39),('7643','2013-11-06','13:35:00',7.22),('7643','2013-11-06','13:40:00',5.38),('7643','2013-11-06','13:45:00',5.12),('7643','2013-11-06','13:50:00',9.45),('7643','2013-11-06','13:55:00',6.11),('7643','2013-11-06','14:00:00',4.67),('7643','2013-11-06','14:05:00',5.91),('7643','2013-11-06','14:10:00',4.2),('7643','2013-11-06','14:15:00',3.64),('7643','2013-11-06','14:20:00',4.35),('7643','2013-11-06','14:25:00',3.15),('7643','2013-11-06','14:30:00',4.93),('7643','2013-11-06','14:35:00',6.85),('7643','2013-11-06','14:40:00',6.83),('7643','2013-11-06','14:45:00',6.11),('7643','2013-11-06','14:50:00',5.79),('7643','2013-11-06','14:55:00',5.54),('7643','2013-11-06','15:00:00',5.23),('7643','2013-11-06','15:05:00',4.95),('7643','2013-11-06','15:10:00',4.7),('7643','2013-11-06','15:15:00',4.28),('7643','2013-11-06','15:20:00',4.02),('7643','2013-11-06','15:25:00',3.75),('7643','2013-11-06','15:30:00',3.5),('7643','2013-11-06','15:35:00',3.16),('7643','2013-11-06','15:40:00',2.87),('7643','2013-11-06','15:45:00',2.56),('7643','2013-11-06','15:50:00',2.27),('7643','2013-11-06','15:55:00',2),('7643','2013-11-06','16:00:00',1.73),('7643','2013-11-06','16:05:00',1.47),('7643','2013-11-06','16:10:00',1.22),('7643','2013-11-05','07:55:00',1.49),('7643','2013-11-05','08:00:00',2.69),('7643','2013-11-05','08:05:00',2.91),('7643','2013-11-05','08:10:00',4.18),('7643','2013-11-05','08:15:00',4.89),('7643','2013-11-05','08:20:00',4.58),('7643','2013-11-05','08:25:00',2.11),('7643','2013-11-05','08:30:00',2.22),('7643','2013-11-05','08:35:00',5.81),('7643','2013-11-05','08:40:00',5.97),('7643','2013-11-05','08:45:00',6.29),('7643','2013-11-05','08:50:00',6.84),('7643','2013-11-05','08:55:00',6.55),('7643','2013-11-05','09:00:00',4.57),('7643','2013-11-05','09:05:00',4.84),('7643','2013-11-05','09:10:00',4.2),('7643','2013-11-05','09:15:00',6.2),('7643','2013-11-05','09:20:00',7.4),('7643','2013-11-05','09:25:00',7.86),('7643','2013-11-05','09:30:00',8.37),('7643','2013-11-05','09:35:00',8.55),('7643','2013-11-05','09:40:00',8.73),('7643','2013-11-05','09:45:00',8.91),('7643','2013-11-05','09:50:00',9.06),('7643','2013-11-05','09:55:00',9.23),('7643','2013-11-05','10:00:00',9.35),('7643','2013-11-05','10:05:00',9.47),('7643','2013-11-05','10:10:00',9.65),('7643','2013-11-05','10:15:00',9.77),('7643','2013-11-05','10:20:00',9.89),('7643','2013-11-05','10:25:00',10.1),('7643','2013-11-05','10:30:00',10.21),('7643','2013-11-05','10:35:00',10.28),('7643','2013-11-05','10:40:00',10.35),('7643','2013-11-05','10:45:00',10.42),('7643','2013-11-05','10:50:00',10.5),('7643','2013-11-05','10:55:00',10.53),('7643','2013-11-05','11:00:00',10.65),('7643','2013-11-05','11:05:00',10.71),('7643','2013-11-05','11:10:00',10.69),('7643','2013-11-05','11:15:00',10.76),('7643','2013-11-05','11:20:00',10.75),('7643','2013-11-05','11:25:00',10.83),('7643','2013-11-05','11:30:00',10.88),('7643','2013-11-05','11:35:00',10.84),('7643','2013-11-05','11:40:00',10.84),('7643','2013-11-05','11:45:00',10.9),('7643','2013-11-05','11:50:00',10.95),('7643','2013-11-05','11:55:00',10.89),('7643','2013-11-05','12:00:00',10.87),('7643','2013-11-05','12:05:00',10.84),('7643','2013-11-05','12:10:00',10.81),('7643','2013-11-05','12:15:00',10.7),('7643','2013-11-05','12:20:00',10.68),('7643','2013-11-05','12:25:00',10.64),('7643','2013-11-05','12:30:00',10.56),('7643','2013-11-05','12:35:00',10.54),('7643','2013-11-05','12:40:00',10.46),('7643','2013-11-05','12:45:00',10.42),('7643','2013-11-05','12:50:00',10.35),('7643','2013-11-05','12:55:00',10.23),('7643','2013-11-05','13:00:00',10.1),('7643','2013-11-05','13:05:00',9.98),('7643','2013-11-05','13:10:00',9.79),('7643','2013-11-05','13:15:00',9.65),('7643','2013-11-05','13:20:00',9.52),('7643','2013-11-05','13:25:00',9.42),('7643','2013-11-05','13:30:00',9.31),('7643','2013-11-05','13:35:00',9.09),('7643','2013-11-05','13:40:00',8.88),('7643','2013-11-05','13:45:00',8.75),('7643','2013-11-05','13:50:00',8.51),('7643','2013-11-05','13:55:00',8.45),('7643','2013-11-05','14:00:00',8.3),('7643','2013-11-05','14:05:00',8.06),('7643','2013-11-05','14:10:00',7.86),('7643','2013-11-05','14:15:00',7.71),('7643','2013-11-05','14:20:00',7.49),('7643','2013-11-05','14:25:00',7.28),('7643','2013-11-05','14:30:00',7.02),('7643','2013-11-05','14:35:00',6.77),('7643','2013-11-05','14:40:00',6.53),('7643','2013-11-05','14:45:00',6.27),('7643','2013-11-05','14:50:00',5.98),('7643','2013-11-05','14:55:00',5.66),('7643','2013-11-05','15:00:00',5.37),('7643','2013-11-05','15:05:00',5.09),('7643','2013-11-05','15:10:00',4.82),('7643','2013-11-05','15:15:00',4.55),('7643','2013-11-05','15:20:00',4.25),('7643','2013-11-05','15:25:00',3.95),('7643','2013-11-05','15:30:00',3.61),('7643','2013-11-05','15:35:00',3.29),('7643','2013-11-05','15:40:00',2.97),('7643','2013-11-05','15:45:00',2.65),('7643','2013-11-05','15:50:00',2.37),('7643','2013-11-05','15:55:00',2.09),('7643','2013-11-05','16:00:00',1.82),('7643','2013-11-05','16:05:00',1.55),('7643','2013-11-05','16:10:00',1.32),('7643','2013-11-05','16:15:00',1.09),('7643','2013-11-04','08:10:00',1.23),('7643','2013-11-04','08:15:00',2.02),('7643','2013-11-04','08:20:00',2.45),('7643','2013-11-04','08:25:00',4.68),('7643','2013-11-04','08:30:00',6.09),('7643','2013-11-04','08:35:00',6.81),('7643','2013-11-04','08:40:00',6.99),('7643','2013-11-04','08:45:00',4.72),('7643','2013-11-04','08:50:00',2.32),('7643','2013-11-04','08:55:00',1.85),('7643','2013-11-04','09:00:00',1.07),('7643','2013-11-04','09:30:00',1.15),('7643','2013-11-04','09:35:00',1.54),('7643','2013-11-04','09:40:00',1.51),('7643','2013-11-04','09:45:00',1.71),('7643','2013-11-04','09:50:00',1.93),('7643','2013-11-04','09:55:00',2.2),('7643','2013-11-04','10:00:00',2.54),('7643','2013-11-04','10:05:00',2.22),('7643','2013-11-04','10:10:00',2.13),('7643','2013-11-04','10:15:00',3.38),('7643','2013-11-04','10:20:00',6.42),('7643','2013-11-04','10:25:00',7.99),('7643','2013-11-04','10:30:00',6.54),('7643','2013-11-04','10:35:00',8.02),('7643','2013-11-04','10:40:00',5.62),('7643','2013-11-04','10:45:00',7.82),('7643','2013-11-04','10:50:00',5.57),('7643','2013-11-04','10:55:00',5.16),('7643','2013-11-04','11:00:00',4.09),('7643','2013-11-04','11:05:00',3.05),('7643','2013-11-04','11:10:00',2.37),('7643','2013-11-04','11:15:00',1.91),('7643','2013-11-04','11:20:00',2.09),('7643','2013-11-04','11:25:00',2.45),('7643','2013-11-04','11:30:00',2.8),('7643','2013-11-04','11:35:00',3.8),('7643','2013-11-04','11:40:00',5.11),('7643','2013-11-04','11:45:00',5.21),('7643','2013-11-04','11:50:00',4.74),('7643','2013-11-04','11:55:00',3.88),('7643','2013-11-04','12:00:00',3.88),('7643','2013-11-04','12:05:00',4.72),('7643','2013-11-04','12:10:00',5.77),('7643','2013-11-04','12:15:00',5.5),('7643','2013-11-04','12:20:00',6.77),('7643','2013-11-04','12:25:00',6.2),('7643','2013-11-04','12:30:00',3.89),('7643','2013-11-04','12:35:00',3.06),('7643','2013-11-04','12:40:00',2.68),('7643','2013-11-04','12:45:00',2.43),('7643','2013-11-04','12:50:00',2.14),('7643','2013-11-04','12:55:00',2.95),('7643','2013-11-04','13:00:00',3.37),('7643','2013-11-04','13:05:00',3.02),('7643','2013-11-04','13:10:00',3.05),('7643','2013-11-04','13:15:00',2.31),('7643','2013-11-04','13:20:00',1.96),('7643','2013-11-04','13:25:00',2.32),('7643','2013-11-04','13:30:00',3.79),('7643','2013-11-04','13:35:00',8.02),('7643','2013-11-04','13:40:00',8.33),('7643','2013-11-04','13:45:00',6.67),('7643','2013-11-04','13:50:00',5.86),('7643','2013-11-04','13:55:00',4.06),('7643','2013-11-04','14:00:00',4.55),('7643','2013-11-04','14:05:00',3.52),('7643','2013-11-04','14:10:00',8.53),('7643','2013-11-04','14:15:00',4.26),('7643','2013-11-04','14:20:00',2.49),('7643','2013-11-04','14:25:00',6.48),('7643','2013-11-04','14:30:00',7.23),('7643','2013-11-04','14:35:00',7.19),('7643','2013-11-04','14:40:00',3.9),('7643','2013-11-04','14:45:00',4.48),('7643','2013-11-04','14:50:00',5.38),('7643','2013-11-04','14:55:00',1.14),('7643','2013-11-04','15:00:00',1.59),('7643','2013-11-04','15:05:00',3.85),('7643','2013-11-04','15:10:00',1.42),('7643','2013-11-04','15:15:00',1.41),('7643','2013-11-04','15:20:00',3.04),('7643','2013-11-04','15:30:00',3.05),('7643','2013-11-04','15:35:00',4.18),('7643','2013-11-04','15:40:00',1.37),('7643','2013-11-04','15:45:00',1.15),('7643','2013-11-04','15:50:00',1.19),('7643','2013-11-04','15:55:00',1.19),('7643','2013-11-04','16:00:00',1.22),('7643','2013-11-04','16:05:00',2.62),('7643','2013-11-04','16:10:00',2.38),('7643','2013-11-04','16:15:00',1.21),('7643','2013-11-03','07:50:00',1.44),('7643','2013-11-03','07:55:00',3.08),('7643','2013-11-03','08:00:00',3.43),('7643','2013-11-03','08:05:00',3.68),('7643','2013-11-03','08:10:00',3.96),('7643','2013-11-03','08:15:00',4.26),('7643','2013-11-03','08:20:00',4.85),('7643','2013-11-03','08:25:00',5.04),('7643','2013-11-03','08:30:00',5.08),('7643','2013-11-03','08:35:00',4.7),('7643','2013-11-03','08:40:00',4.54),('7643','2013-11-03','08:45:00',2.59),('7643','2013-11-03','08:50:00',3.85),('7643','2013-11-03','09:00:00',1),('7643','2013-11-03','09:05:00',1.89),('7643','2013-11-03','09:10:00',5.1),('7643','2013-11-03','09:15:00',8.06),('7643','2013-11-03','09:20:00',9.37),('7643','2013-11-03','09:25:00',10.27),('7643','2013-11-03','09:30:00',5.23),('7643','2013-11-03','09:35:00',1.36),('7643','2013-11-03','10:00:00',1.07),('7643','2013-11-03','10:05:00',9.2),('7643','2013-11-03','10:10:00',10.1),('7643','2013-11-03','10:15:00',10.19),('7643','2013-11-03','10:20:00',10.51),('7643','2013-11-03','10:25:00',11.18),('7643','2013-11-03','10:30:00',9.41),('7643','2013-11-03','10:35:00',8.4),('7643','2013-11-03','10:40:00',12.26),('7643','2013-11-03','10:45:00',6.57),('7643','2013-11-03','10:50:00',5.39),('7643','2013-11-03','10:55:00',6.72),('7643','2013-11-03','11:00:00',9.95),('7643','2013-11-03','11:05:00',14.45),('7643','2013-11-03','11:10:00',12.69),('7643','2013-11-03','11:15:00',13.5),('7643','2013-11-03','11:20:00',9.43),('7643','2013-11-03','11:25:00',6.32),('7643','2013-11-03','11:30:00',7.95),('7643','2013-11-03','11:35:00',10.27),('7643','2013-11-03','11:40:00',7.11),('7643','2013-11-03','11:45:00',8.91),('7643','2013-11-03','11:50:00',13.83),('7643','2013-11-03','11:55:00',12.14),('7643','2013-11-03','12:00:00',11.85),('7643','2013-11-03','12:05:00',11.44),('7643','2013-11-03','12:10:00',10.75),('7643','2013-11-03','12:15:00',11.56),('7643','2013-11-03','12:20:00',11.66),('7643','2013-11-03','12:25:00',11.46),('7643','2013-11-03','12:30:00',11.37),('7643','2013-11-03','12:35:00',11.1),('7643','2013-11-03','12:40:00',8.96),('7643','2013-11-03','12:45:00',10.35),('7643','2013-11-03','12:50:00',10.8),('7643','2013-11-03','12:55:00',10.66),('7643','2013-11-03','13:00:00',10.62),('7643','2013-11-03','13:05:00',10.44),('7643','2013-11-03','13:10:00',9.94),('7643','2013-11-03','13:15:00',9.83),('7643','2013-11-03','13:20:00',10.11),('7643','2013-11-03','13:25:00',10.17),('7643','2013-11-03','13:30:00',9.88),('7643','2013-11-03','13:35:00',9.65),('7643','2013-11-03','13:40:00',9.17),('7643','2013-11-03','13:45:00',7.75),('7643','2013-11-03','13:50:00',9.56),('7643','2013-11-03','13:55:00',9.42),('7643','2013-11-03','14:00:00',6.4),('7643','2013-11-03','14:05:00',9.72),('7643','2013-11-03','14:10:00',5.53),('7643','2013-11-03','14:15:00',8.5),('7643','2013-11-03','14:20:00',7.58),('7643','2013-11-03','14:25:00',8.59),('7643','2013-11-03','14:30:00',7.68),('7643','2013-11-03','14:35:00',6.59),('7643','2013-11-03','14:40:00',7.43),('7643','2013-11-03','14:45:00',4.25),('7643','2013-11-03','14:50:00',5.18),('7643','2013-11-03','14:55:00',6.31),('7643','2013-11-03','15:00:00',6.16),('7643','2013-11-03','15:05:00',3.79),('7643','2013-11-03','15:10:00',3.07),('7643','2013-11-03','15:15:00',4.75),('7643','2013-11-03','15:20:00',4.18),('7643','2013-11-03','15:25:00',4.86),('7643','2013-11-03','15:30:00',4.53),('7643','2013-11-03','15:35:00',4.3),('7643','2013-11-03','15:40:00',4.26),('7643','2013-11-03','15:45:00',3.9),('7643','2013-11-03','15:50:00',2.95),('7643','2013-11-03','15:55:00',1.24),('7643','2013-11-02','07:30:00',1.8),('7643','2013-11-02','07:35:00',2.76),('7643','2013-11-02','07:40:00',2.48),('7643','2013-11-02','07:45:00',3.03),('7643','2013-11-02','07:50:00',2.99),('7643','2013-11-02','07:55:00',2.58),('7643','2013-11-02','08:00:00',3.2),('7643','2013-11-02','08:05:00',3.6),('7643','2013-11-02','08:10:00',1.76),('7643','2013-11-02','08:15:00',1.71),('7643','2013-11-02','08:20:00',4.42),('7643','2013-11-02','08:25:00',3.5),('7643','2013-11-02','08:30:00',2.57),('7643','2013-11-02','08:35:00',4.74),('7643','2013-11-02','08:40:00',4.15),('7643','2013-11-02','08:45:00',5.47),('7643','2013-11-02','08:50:00',5.56),('7643','2013-11-02','08:55:00',3.07),('7643','2013-11-02','09:00:00',2.64),('7643','2013-11-02','09:05:00',2.25),('7643','2013-11-02','09:10:00',1.88),('7643','2013-11-02','09:15:00',1.52),('7643','2013-11-02','09:30:00',1.02),('7643','2013-11-02','09:35:00',2.81),('7643','2013-11-02','09:40:00',7.98),('7643','2013-11-02','09:45:00',7.22),('7643','2013-11-02','09:50:00',3.23),('7643','2013-11-02','09:55:00',1.99),('7643','2013-11-02','10:00:00',1.46),('7643','2013-11-02','10:05:00',2.79),('7643','2013-11-02','10:10:00',7.2),('7643','2013-11-02','10:15:00',2.2),('7643','2013-11-02','10:20:00',6.12),('7643','2013-11-02','10:25:00',6.95),('7643','2013-11-02','10:30:00',5.47),('7643','2013-11-02','10:35:00',5.94),('7643','2013-11-02','10:40:00',1.79),('7643','2013-11-02','10:45:00',1.48),('7643','2013-11-02','10:50:00',1.26),('7643','2013-11-02','10:55:00',1.68),('7643','2013-11-02','11:00:00',1.54),('7643','2013-11-02','11:05:00',1.7),('7643','2013-11-02','11:10:00',2.24),('7643','2013-11-02','11:15:00',3.41),('7643','2013-11-02','11:20:00',5.97),('7643','2013-11-02','11:25:00',6.23),('7643','2013-11-02','11:30:00',6.87),('7643','2013-11-02','11:35:00',10.36),('7643','2013-11-02','11:40:00',11.44),('7643','2013-11-02','11:45:00',11.76),('7643','2013-11-02','11:50:00',12.12),('7643','2013-11-02','11:55:00',12.64),('7643','2013-11-02','12:00:00',10.29),('7643','2013-11-02','12:05:00',13.87),('7643','2013-11-02','12:10:00',14.31),('7643','2013-11-02','12:15:00',6.05),('7643','2013-11-02','12:20:00',4.5),('7643','2013-11-02','12:25:00',7.08),('7643','2013-11-02','12:30:00',7.91),('7643','2013-11-02','12:35:00',5.63),('7643','2013-11-02','12:40:00',4.48),('7643','2013-11-02','12:45:00',4.02),('7643','2013-11-02','12:50:00',3.46),('7643','2013-11-02','12:55:00',2.47),('7643','2013-11-02','13:00:00',1.75),('7643','2013-11-02','13:05:00',2.06),('7643','2013-11-02','13:10:00',2.86),('7643','2013-11-02','13:15:00',2.81),('7643','2013-11-02','13:20:00',2.82),('7643','2013-11-02','13:25:00',3.43),('7643','2013-11-02','13:30:00',3.4),('7643','2013-11-02','13:35:00',2.77),('7643','2013-11-02','13:40:00',4.7),('7643','2013-11-02','13:45:00',7.09),('7643','2013-11-02','13:50:00',8.11),('7643','2013-11-02','13:55:00',3.22),('7643','2013-11-02','14:00:00',5.06),('7643','2013-11-02','14:05:00',6.44),('7643','2013-11-02','14:10:00',5.93),('7643','2013-11-02','14:15:00',3.45),('7643','2013-11-02','14:20:00',4.44),('7643','2013-11-02','14:25:00',5.82),('7643','2013-11-02','14:30:00',4.12),('7643','2013-11-02','14:35:00',2.63),('7643','2013-11-02','14:40:00',7.02),('7643','2013-11-02','14:45:00',3.33),('7643','2013-11-02','14:50:00',2.2),('7643','2013-11-02','14:55:00',2.15),('7643','2013-11-02','15:00:00',1.89),('7643','2013-11-02','15:05:00',1.89),('7643','2013-11-02','15:10:00',1.77),('7643','2013-11-02','15:15:00',1.9),('7643','2013-11-02','15:20:00',2.78),('7643','2013-11-02','15:25:00',1.3),('7643','2013-11-02','15:55:00',1.25),('7643','2013-11-02','16:00:00',1.14),('7643','2013-11-02','16:05:00',1.38),('7643','2013-11-02','16:10:00',1.34),('7643','2013-11-01','07:50:00',1.92),('7643','2013-11-01','07:55:00',2.89),('7643','2013-11-01','08:00:00',3.29),('7643','2013-11-01','08:05:00',3.54),('7643','2013-11-01','08:10:00',3.89),('7643','2013-11-01','08:15:00',4.24),('7643','2013-11-01','08:20:00',4.5),('7643','2013-11-01','08:25:00',4.76),('7643','2013-11-01','08:30:00',5.08),('7643','2013-11-01','08:35:00',5.34),('7643','2013-11-01','08:40:00',5.64),('7643','2013-11-01','08:45:00',5.9),('7643','2013-11-01','08:50:00',6.13),('7643','2013-11-01','08:55:00',6.41),('7643','2013-11-01','09:00:00',6.68),('7643','2013-11-01','09:05:00',7.24),('7643','2013-11-01','09:10:00',7.82),('7643','2013-11-01','09:15:00',6.43),('7643','2013-11-01','09:20:00',7.1),('7643','2013-11-01','09:25:00',6.86),('7643','2013-11-01','09:30:00',8.25),('7643','2013-11-01','09:35:00',8.13),('7643','2013-11-01','09:40:00',8.12),('7643','2013-11-01','09:45:00',8.47),('7643','2013-11-01','09:50:00',9.58),('7643','2013-11-01','09:55:00',9.45),('7643','2013-11-01','10:00:00',10.27),('7643','2013-11-01','10:05:00',11.27),('7643','2013-11-01','10:10:00',5.16),('7643','2013-11-01','10:15:00',4.64),('7643','2013-11-01','10:20:00',3.29),('7643','2013-11-01','10:25:00',2.46),('7643','2013-11-01','10:30:00',2.24),('7643','2013-11-01','10:35:00',2.79),('7643','2013-11-01','10:40:00',2.78),('7643','2013-11-01','10:45:00',2.69),('7643','2013-11-01','10:50:00',2.44),('7643','2013-11-01','10:55:00',3.02),('7643','2013-11-01','11:00:00',4.43),('7643','2013-11-01','11:05:00',4.83),('7643','2013-11-01','11:10:00',3.96),('7643','2013-11-01','11:15:00',2.71),('7643','2013-11-01','11:20:00',1.71),('7643','2013-11-01','11:25:00',2.13),('7643','2013-11-01','11:30:00',2.54),('7643','2013-11-01','11:35:00',2.82),('7643','2013-11-01','11:40:00',3.41),('7643','2013-11-01','11:45:00',3.43),('7643','2013-11-01','11:50:00',4.03),('7643','2013-11-01','11:55:00',8.19),('7643','2013-11-01','12:00:00',11.46),('7643','2013-11-01','12:05:00',12.48),('7643','2013-11-01','12:10:00',10.86),('7643','2013-11-01','12:15:00',9.81),('7643','2013-11-01','12:20:00',13.19),('7643','2013-11-01','12:25:00',12.22),('7643','2013-11-01','12:30:00',12.79),('7643','2013-11-01','12:35:00',12.63),('7643','2013-11-01','12:40:00',11.38),('7643','2013-11-01','12:45:00',8.66),('7643','2013-11-01','12:50:00',9.98),('7643','2013-11-01','12:55:00',11.35),('7643','2013-11-01','13:00:00',9.88),('7643','2013-11-01','13:05:00',11.26),('7643','2013-11-01','13:10:00',11.53),('7643','2013-11-01','13:15:00',9.43),('7643','2013-11-01','13:20:00',3.22),('7643','2013-11-01','13:25:00',3.39),('7643','2013-11-01','13:30:00',7.67),('7643','2013-11-01','13:35:00',12.02),('7643','2013-11-01','13:40:00',11.29),('7643','2013-11-01','13:45:00',10.23),('7643','2013-11-01','13:50:00',11.47),('7643','2013-11-01','13:55:00',11.07),('7643','2013-11-01','14:00:00',10.1),('7643','2013-11-01','14:05:00',8.95),('7643','2013-11-01','14:10:00',8.23),('7643','2013-11-01','14:15:00',7.88),('7643','2013-11-01','14:20:00',7.53),('7643','2013-11-01','14:25:00',7.23),('7643','2013-11-01','14:30:00',7.04),('7643','2013-11-01','14:35:00',6.84),('7643','2013-11-01','14:40:00',6.61),('7643','2013-11-01','14:45:00',6.27),('7643','2013-11-01','14:50:00',6.09),('7643','2013-11-01','14:55:00',5.84),('7643','2013-11-01','15:00:00',5.46),('7643','2013-11-01','15:05:00',5.04),('7643','2013-11-01','15:10:00',4.73),('7643','2013-11-01','15:15:00',3.83),('7643','2013-11-01','15:20:00',1.3),('7643','2013-11-01','15:25:00',1.36),('7643','2013-11-01','15:30:00',1.47),('7643','2013-11-01','15:35:00',2.26),('7643','2013-11-01','15:40:00',2.59),('7643','2013-11-01','15:45:00',3.31),('7643','2013-11-01','15:50:00',2.77),('7643','2013-11-01','15:55:00',2.11),('7643','2013-11-01','16:00:00',1.46),('7643','2013-11-01','16:05:00',1.35),('7643','2013-11-01','16:10:00',1.53),('7643','2013-11-01','16:15:00',1.59),('7643','2013-11-01','16:20:00',1.16),('7643','2013-10-31','07:20:00',1.22),('7643','2013-10-31','07:25:00',1.47),('7643','2013-10-31','07:30:00',1.74),('7643','2013-10-31','07:35:00',2.02),('7643','2013-10-31','07:40:00',2.32),('7643','2013-10-31','07:45:00',2.62),('7643','2013-10-31','07:50:00',2.78),('7643','2013-10-31','07:55:00',2.85),('7643','2013-10-31','08:00:00',3.05),('7643','2013-10-31','08:05:00',2.85),('7643','2013-10-31','08:10:00',2.92),('7643','2013-10-31','08:15:00',3.34),('7643','2013-10-31','08:20:00',3.96),('7643','2013-10-31','08:25:00',4.13),('7643','2013-10-31','08:30:00',4.79),('7643','2013-10-31','08:35:00',5.18),('7643','2013-10-31','08:40:00',5.67),('7643','2013-10-31','08:45:00',5.82),('7643','2013-10-31','08:50:00',5.66),('7643','2013-10-31','08:55:00',5.92),('7643','2013-10-31','09:00:00',6.06),('7643','2013-10-31','09:05:00',6.91),('7643','2013-10-31','09:10:00',7.2),('7643','2013-10-31','09:15:00',7.4),('7643','2013-10-31','09:20:00',7.59),('7643','2013-10-31','09:25:00',7.8),('7643','2013-10-31','09:30:00',8),('7643','2013-10-31','09:35:00',8.17),('7643','2013-10-31','09:40:00',8.33),('7643','2013-10-31','09:45:00',8.57),('7643','2013-10-31','09:50:00',8.79),('7643','2013-10-31','09:55:00',8.97),('7643','2013-10-31','10:00:00',9.12),('7643','2013-10-31','10:05:00',9.27),('7643','2013-10-31','10:10:00',9.44),('7643','2013-10-31','10:15:00',9.49),('7643','2013-10-31','10:20:00',9.68),('7643','2013-10-31','10:25:00',9.85),('7643','2013-10-31','10:30:00',9.76),('7643','2013-10-31','10:35:00',9.78),('7643','2013-10-31','10:40:00',10.03),('7643','2013-10-31','10:45:00',9.68),('7643','2013-10-31','10:50:00',9.81),('7643','2013-10-31','10:55:00',9.88),('7643','2013-10-31','11:00:00',10.04),('7643','2013-10-31','11:05:00',9.61),('7643','2013-10-31','11:10:00',8.55),('7643','2013-10-31','11:15:00',9.41),('7643','2013-10-31','11:20:00',10.48),('7643','2013-10-31','11:25:00',11.07),('7643','2013-10-31','11:30:00',11.17),('7643','2013-10-31','11:35:00',10.84),('7643','2013-10-31','11:40:00',10.22),('7643','2013-10-31','11:45:00',9.15),('7643','2013-10-31','11:50:00',10.68),('7643','2013-10-31','11:55:00',11.19),('7643','2013-10-31','12:00:00',11.23),('7643','2013-10-31','12:05:00',10.97),('7643','2013-10-31','12:10:00',9.96),('7643','2013-10-31','12:15:00',10.16),('7643','2013-10-31','12:20:00',4.38),('7643','2013-10-31','12:25:00',7),('7643','2013-10-31','12:30:00',6.89),('7643','2013-10-31','12:35:00',5.9),('7643','2013-10-31','12:40:00',2.13),('7643','2013-10-31','12:45:00',1.81),('7643','2013-10-31','12:50:00',1.84),('7643','2013-10-31','12:55:00',1.88),('7643','2013-10-31','13:00:00',1.93),('7643','2013-10-31','13:05:00',2.32),('7643','2013-10-31','13:10:00',2.79),('7643','2013-10-31','13:15:00',3.69),('7643','2013-10-31','13:20:00',4.96),('7643','2013-10-31','13:25:00',4.73),('7643','2013-10-31','13:30:00',5.85),('7643','2013-10-31','13:35:00',4.76),('7643','2013-10-31','13:40:00',3.82),('7643','2013-10-31','13:45:00',4.44),('7643','2013-10-31','13:50:00',3.18),('7643','2013-10-31','13:55:00',3.48),('7643','2013-10-31','14:00:00',2.82),('7643','2013-10-31','14:05:00',2.72),('7643','2013-10-31','14:10:00',2.71),('7643','2013-10-31','14:15:00',2.69),('7643','2013-10-31','14:20:00',2.43),('7643','2013-10-31','14:25:00',1.96),('7643','2013-10-31','14:30:00',1.75),('7643','2013-10-31','14:35:00',1.54),('7643','2013-10-31','14:40:00',1.41),('7643','2013-10-31','14:45:00',1.38),('7643','2013-10-31','14:50:00',1.32),('7643','2013-10-31','14:55:00',1.27),('7643','2013-10-31','15:00:00',1.23),('7643','2013-10-31','15:05:00',1.21),('7643','2013-10-31','15:10:00',1.19),('7643','2013-10-31','15:15:00',1.14),('7643','2013-10-31','15:20:00',1.12),('7643','2013-10-31','15:25:00',1.12),('7643','2013-10-31','15:30:00',1.11),('7643','2013-10-31','15:35:00',1.1),('7643','2013-10-31','15:40:00',1.07),('7643','2013-10-31','15:45:00',1.04),('7643','2013-10-31','15:50:00',1),('7643','2013-10-30','08:00:00',1.46),('7643','2013-10-30','08:05:00',2.2),('7643','2013-10-30','08:10:00',2.56),('7643','2013-10-30','08:15:00',3.23),('7643','2013-10-30','08:20:00',3.57),('7643','2013-10-30','08:25:00',4.19),('7643','2013-10-30','08:30:00',4.83),('7643','2013-10-30','08:35:00',5.14),('7643','2013-10-30','08:40:00',5.91),('7643','2013-10-30','08:45:00',5.93),('7643','2013-10-30','08:50:00',5.28),('7643','2013-10-30','08:55:00',4.99),('7643','2013-10-30','09:00:00',6.34),('7643','2013-10-30','09:05:00',4.31),('7643','2013-10-30','09:10:00',3.24),('7643','2013-10-30','09:15:00',3.69),('7643','2013-10-30','09:20:00',3.02),('7643','2013-10-30','09:25:00',4.98),('7643','2013-10-30','09:30:00',6.37),('7643','2013-10-30','09:35:00',6.73),('7643','2013-10-30','09:40:00',6.09),('7643','2013-10-30','09:45:00',4.58),('7643','2013-10-30','09:50:00',5.3),('7643','2013-10-30','09:55:00',7.17),('7643','2013-10-30','10:00:00',7.2),('7643','2013-10-30','10:05:00',6.48),('7643','2013-10-30','10:10:00',5.72),('7643','2013-10-30','10:15:00',4.75),('7643','2013-10-30','10:20:00',6.27),('7643','2013-10-30','10:25:00',6.33),('7643','2013-10-30','10:30:00',6.27),('7643','2013-10-30','10:35:00',6.61),('7643','2013-10-30','10:40:00',6.72),('7643','2013-10-30','10:45:00',6.47),('7643','2013-10-30','10:50:00',6.53),('7643','2013-10-30','10:55:00',7.85),('7643','2013-10-30','11:00:00',10.09),('7643','2013-10-30','11:05:00',10.41),('7643','2013-10-30','11:10:00',9.78),('7643','2013-10-30','11:15:00',9.7),('7643','2013-10-30','11:20:00',9.33),('7643','2013-10-30','11:25:00',8.98),('7643','2013-10-30','11:30:00',9.49),('7643','2013-10-30','11:35:00',9.11),('7643','2013-10-30','11:40:00',9.88),('7643','2013-10-30','11:45:00',10.46),('7643','2013-10-30','11:50:00',10.51),('7643','2013-10-30','11:55:00',10.51),('7643','2013-10-30','12:00:00',10.34),('7643','2013-10-30','12:05:00',10.15),('7643','2013-10-30','12:10:00',9.95),('7643','2013-10-30','12:15:00',10.19),('7643','2013-10-30','12:20:00',9.97),('7643','2013-10-30','12:25:00',10.04),('7643','2013-10-30','12:30:00',9.73),('7643','2013-10-30','12:35:00',9.7),('7643','2013-10-30','12:40:00',9.78),('7643','2013-10-30','12:45:00',10.2),('7643','2013-10-30','12:50:00',10.3),('7643','2013-10-30','12:55:00',10.36),('7643','2013-10-30','13:00:00',9.95),('7643','2013-10-30','13:05:00',9.83),('7643','2013-10-30','13:10:00',9.74),('7643','2013-10-30','13:15:00',9.63),('7643','2013-10-30','13:20:00',9.55),('7643','2013-10-30','13:25:00',9.38),('7643','2013-10-30','13:30:00',9.07),('7643','2013-10-30','13:35:00',8.33),('7643','2013-10-30','13:40:00',7.22),('7643','2013-10-30','13:45:00',7.94),('7643','2013-10-30','13:50:00',5.54),('7643','2013-10-30','13:55:00',6.64),('7643','2013-10-30','14:00:00',8.06),('7643','2013-10-30','14:05:00',8.01),('7643','2013-10-30','14:10:00',7.37),('7643','2013-10-30','14:15:00',4.47),('7643','2013-10-30','14:20:00',3.96),('7643','2013-10-30','14:25:00',5.8),('7643','2013-10-30','14:30:00',4.61),('7643','2013-10-30','14:35:00',4.41),('7643','2013-10-30','14:40:00',4.36),('7643','2013-10-30','14:45:00',3.3),('7643','2013-10-30','14:50:00',4.45),('7643','2013-10-30','14:55:00',3.84),('7643','2013-10-30','15:00:00',3.94),('7643','2013-10-30','15:05:00',3.68),('7643','2013-10-30','15:10:00',3.55),('7643','2013-10-30','15:15:00',3.27),('7643','2013-10-30','15:20:00',3.05),('7643','2013-10-30','15:25:00',2.89),('7643','2013-10-30','15:30:00',2.68),('7643','2013-10-30','15:35:00',2.6),('7643','2013-10-30','15:40:00',2.55),('7643','2013-10-30','15:45:00',2.22),('7643','2013-10-30','15:50:00',2.06),('7643','2013-10-30','15:55:00',1.92),('7643','2013-10-30','16:00:00',1.66),('7643','2013-10-30','16:05:00',1.38),('7643','2013-10-30','16:10:00',1.19),('7643','2013-10-30','16:15:00',1.07),('7643','2013-10-30','16:20:00',1.02),('7643','2013-10-29','07:20:00',1.07),('7643','2013-10-29','07:25:00',1.29),('7643','2013-10-29','07:30:00',1.54),('7643','2013-10-29','07:35:00',1.76),('7643','2013-10-29','07:40:00',1.99),('7643','2013-10-29','07:45:00',2.31),('7643','2013-10-29','07:50:00',2.62),('7643','2013-10-29','07:55:00',2.84),('7643','2013-10-29','08:00:00',3.08),('7643','2013-10-29','08:05:00',3.39),('7643','2013-10-29','08:10:00',3.73),('7643','2013-10-29','08:15:00',3.98),('7643','2013-10-29','08:20:00',4.28),('7643','2013-10-29','08:25:00',4.53),('7643','2013-10-29','08:30:00',4.75),('7643','2013-10-29','08:35:00',5.1),('7643','2013-10-29','08:40:00',5.46),('7643','2013-10-29','08:45:00',5.78),('7643','2013-10-29','08:50:00',5.9),('7643','2013-10-29','08:55:00',5.82),('7643','2013-10-29','09:00:00',6.06),('7643','2013-10-29','09:05:00',6.59),('7643','2013-10-29','09:10:00',7.02),('7643','2013-10-29','09:15:00',7.23),('7643','2013-10-29','09:20:00',7.44),('7643','2013-10-29','09:25:00',7.73),('7643','2013-10-29','09:30:00',7.84),('7643','2013-10-29','09:35:00',8.02),('7643','2013-10-29','09:40:00',8.19),('7643','2013-10-29','09:45:00',8.38),('7643','2013-10-29','09:50:00',8.58),('7643','2013-10-29','09:55:00',8.41),('7643','2013-10-29','10:00:00',8.11),('7643','2013-10-29','10:05:00',8.48),('7643','2013-10-29','10:10:00',8.61),('7643','2013-10-29','10:15:00',9.11),('7643','2013-10-29','10:20:00',9.01),('7643','2013-10-29','10:25:00',8.98),('7643','2013-10-29','10:30:00',9.12),('7643','2013-10-29','10:35:00',9.01),('7643','2013-10-29','10:40:00',7.6),('7643','2013-10-29','10:45:00',7),('7643','2013-10-29','10:50:00',3.95),('7643','2013-10-29','10:55:00',4.05),('7643','2013-10-29','11:00:00',6.93),('7643','2013-10-29','11:05:00',8.64),('7643','2013-10-29','11:10:00',8.73),('7643','2013-10-29','11:15:00',9.34),('7643','2013-10-29','11:20:00',9.12),('7643','2013-10-29','11:25:00',4.2),('7643','2013-10-29','11:30:00',4.5),('7643','2013-10-29','11:35:00',5.23),('7643','2013-10-29','11:40:00',4.29),('7643','2013-10-29','11:45:00',4.72),('7643','2013-10-29','11:50:00',9.24),('7643','2013-10-29','11:55:00',3.9),('7643','2013-10-29','12:00:00',3.27),('7643','2013-10-29','12:05:00',3.65),('7643','2013-10-29','12:10:00',3.73),('7643','2013-10-29','12:15:00',3.72),('7643','2013-10-29','12:20:00',3.9),('7643','2013-10-29','12:25:00',7.49),('7643','2013-10-29','12:30:00',10.7),('7643','2013-10-29','12:35:00',6.23),('7643','2013-10-29','12:40:00',4.63),('7643','2013-10-29','12:45:00',8.18),('7643','2013-10-29','12:50:00',8.18),('7643','2013-10-29','12:55:00',7.78),('7643','2013-10-29','13:00:00',5.36),('7643','2013-10-29','13:05:00',8.12),('7643','2013-10-29','13:10:00',9.61),('7643','2013-10-29','13:15:00',9.59),('7643','2013-10-29','13:20:00',9.21),('7643','2013-10-29','13:25:00',9.21),('7643','2013-10-29','13:30:00',9.49),('7643','2013-10-29','13:35:00',8.73),('7643','2013-10-29','13:40:00',8.44),('7643','2013-10-29','13:45:00',9.29),('7643','2013-10-29','13:50:00',9.3),('7643','2013-10-29','13:55:00',8),('7643','2013-10-29','14:00:00',6.05),('7643','2013-10-29','14:05:00',9.18),('7643','2013-10-29','14:10:00',7.6),('7643','2013-10-29','14:15:00',3.42),('7643','2013-10-29','14:20:00',2.65),('7643','2013-10-29','14:25:00',2.95),('7643','2013-10-29','14:30:00',2.18),('7643','2013-10-29','14:35:00',2.12),('7643','2013-10-29','14:40:00',2.5),('7643','2013-10-29','14:45:00',5.72),('7643','2013-10-29','14:50:00',5.8),('7643','2013-10-29','14:55:00',2.64),('7643','2013-10-29','15:00:00',1.63),('7643','2013-10-29','15:05:00',1.57),('7643','2013-10-29','15:10:00',1.26),('7643','2013-10-29','15:15:00',1.85),('7643','2013-10-29','15:20:00',3.11),('7643','2013-10-29','15:25:00',3.54),('7643','2013-10-29','15:30:00',2.31),('7643','2013-10-29','15:35:00',1.07),('7643','2013-10-29','15:55:00',1.5),('7643','2013-10-29','16:00:00',1.81),('7643','2013-10-29','16:05:00',1.4),('7643','2013-10-28','07:45:00',1.16),('7643','2013-10-28','07:50:00',1.43),('7643','2013-10-28','07:55:00',1.63),('7643','2013-10-28','08:00:00',1.83),('7643','2013-10-28','08:05:00',1.87),('7643','2013-10-28','08:10:00',2.15),('7643','2013-10-28','08:15:00',2.47),('7643','2013-10-28','08:20:00',2.83),('7643','2013-10-28','08:25:00',3.21),('7643','2013-10-28','08:30:00',4.38),('7643','2013-10-28','08:35:00',3.79),('7643','2013-10-28','08:40:00',3.97),('7643','2013-10-28','08:45:00',4.21),('7643','2013-10-28','08:50:00',6.22),('7643','2013-10-28','08:55:00',6.61),('7643','2013-10-28','09:00:00',6.81),('7643','2013-10-28','09:05:00',7.07),('7643','2013-10-28','09:10:00',7.31),('7643','2013-10-28','09:15:00',7.38),('7643','2013-10-28','09:20:00',7.32),('7643','2013-10-28','09:25:00',7.87),('7643','2013-10-28','09:30:00',8.13),('7643','2013-10-28','09:35:00',8.36),('7643','2013-10-28','09:40:00',8.66),('7643','2013-10-28','09:45:00',8.81),('7643','2013-10-28','09:50:00',9.05),('7643','2013-10-28','09:55:00',9.27),('7643','2013-10-28','10:00:00',7.82),('7643','2013-10-28','10:05:00',7.89),('7643','2013-10-28','10:10:00',4.82),('7643','2013-10-28','10:15:00',6.41),('7643','2013-10-28','10:20:00',3.98),('7643','2013-10-28','10:25:00',3.81),('7643','2013-10-28','10:30:00',6.91),('7643','2013-10-28','10:35:00',10.71),('7643','2013-10-28','10:40:00',10.9),('7643','2013-10-28','10:45:00',10.9),('7643','2013-10-28','10:50:00',11.21),('7643','2013-10-28','10:55:00',11.53),('7643','2013-10-28','11:00:00',11.34),('7643','2013-10-28','11:05:00',11.57),('7643','2013-10-28','11:10:00',11.32),('7643','2013-10-28','11:15:00',11.21),('7643','2013-10-28','11:20:00',8.07),('7643','2013-10-28','11:25:00',4.5),('7643','2013-10-28','11:30:00',6.62),('7643','2013-10-28','11:35:00',10.96),('7643','2013-10-28','11:40:00',11.09),('7643','2013-10-28','11:45:00',11.1),('7643','2013-10-28','11:50:00',10.97),('7643','2013-10-28','11:55:00',10.67),('7643','2013-10-28','12:00:00',10.46),('7643','2013-10-28','12:05:00',10.59),('7643','2013-10-28','12:10:00',10.35),('7643','2013-10-28','12:15:00',10.57),('7643','2013-10-28','12:20:00',10.24),('7643','2013-10-28','12:25:00',10.34),('7643','2013-10-28','12:30:00',10.02),('7643','2013-10-28','12:35:00',9.53),('7643','2013-10-28','12:40:00',9.94),('7643','2013-10-28','12:45:00',10.03),('7643','2013-10-28','12:50:00',9.92),('7643','2013-10-28','12:55:00',9.7),('7643','2013-10-28','13:00:00',9.4),('7643','2013-10-28','13:05:00',9.09),('7643','2013-10-28','13:10:00',8.95),('7643','2013-10-28','13:15:00',9.31),('7643','2013-10-28','13:20:00',9.13),('7643','2013-10-28','13:25:00',9.12),('7643','2013-10-28','13:30:00',8.9),('7643','2013-10-28','13:35:00',8.97),('7643','2013-10-28','13:40:00',8.89),('7643','2013-10-28','13:45:00',8.57),('7643','2013-10-28','13:50:00',8.07),('7643','2013-10-28','13:55:00',8.08),('7643','2013-10-28','14:00:00',7.88),('7643','2013-10-28','14:05:00',7.64),('7643','2013-10-28','14:10:00',7.47),('7643','2013-10-28','14:15:00',7.28),('7643','2013-10-28','14:20:00',7.07),('7643','2013-10-28','14:25:00',6.73),('7643','2013-10-28','14:30:00',6.53),('7643','2013-10-28','14:35:00',6.31),('7643','2013-10-28','14:40:00',6.06),('7643','2013-10-28','14:45:00',5.84),('7643','2013-10-28','14:50:00',5.57),('7643','2013-10-28','14:55:00',5.26),('7643','2013-10-28','15:00:00',4.9),('7643','2013-10-28','15:05:00',4.66),('7643','2013-10-28','15:10:00',4.58),('7643','2013-10-28','15:15:00',4.35),('7643','2013-10-28','15:20:00',4.04),('7643','2013-10-28','15:25:00',3.69),('7643','2013-10-28','15:30:00',3.47),('7643','2013-10-28','15:35:00',3.19),('7643','2013-10-28','15:40:00',2.9),('7643','2013-10-28','15:45:00',2.61),('7643','2013-10-28','15:50:00',2.34),('7643','2013-10-28','15:55:00',2.12),('7643','2013-10-28','16:00:00',1.89),('7643','2013-10-28','16:05:00',1.63),('7643','2013-10-28','16:10:00',1.41),('7643','2013-10-28','16:15:00',1.2),('7643','2014-04-16','07:20:00',1.09),('7643','2014-04-16','07:25:00',1.38),('7643','2014-04-16','07:30:00',1.39),('7643','2014-04-16','07:35:00',1.18),('7643','2014-04-16','07:40:00',1.25),('7643','2014-04-16','07:45:00',1.55),('7643','2014-04-16','07:50:00',1.7),('7643','2014-04-16','07:55:00',3.26),('7643','2014-04-16','08:00:00',4.56),('7643','2014-04-16','08:05:00',5.06),('7643','2014-04-16','08:10:00',5.49),('7643','2014-04-16','08:15:00',5.88),('7643','2014-04-16','08:20:00',6.02),('7643','2014-04-16','08:25:00',6.65),('7643','2014-04-16','08:30:00',7.05),('7643','2014-04-16','08:35:00',7.39),('7643','2014-04-16','08:40:00',7.75),('7643','2014-04-16','08:45:00',8.09),('7643','2014-04-16','08:50:00',8.51),('7643','2014-04-16','08:55:00',7.75),('7643','2014-04-16','09:00:00',7.49),('7643','2014-04-16','09:05:00',8.76),('7643','2014-04-16','09:10:00',9.9),('7643','2014-04-16','09:15:00',9.56),('7643','2014-04-16','09:20:00',10.56),('7643','2014-04-16','09:25:00',10.99),('7643','2014-04-16','09:30:00',11.3),('7643','2014-04-16','09:35:00',11.57),('7643','2014-04-16','09:40:00',11.94),('7643','2014-04-16','09:45:00',12.31),('7643','2014-04-16','09:50:00',12.53),('7643','2014-04-16','09:55:00',12.96),('7643','2014-04-16','10:00:00',13.46),('7643','2014-04-16','10:05:00',14.5),('7643','2014-04-16','10:10:00',13.78),('7643','2014-04-16','10:15:00',11.65),('7643','2014-04-16','10:20:00',13.81),('7643','2014-04-16','10:25:00',15.65),('7643','2014-04-16','10:30:00',16.66),('7643','2014-04-16','10:35:00',17.28),('7643','2014-04-16','10:40:00',16.18),('7643','2014-04-16','10:45:00',13.94),('7643','2014-04-16','10:50:00',9.99),('7643','2014-04-16','10:55:00',10.2),('7643','2014-04-16','11:00:00',10.2),('7643','2014-04-16','11:05:00',13.72),('7643','2014-04-16','11:10:00',13.52),('7643','2014-04-16','11:15:00',11.2),('7643','2014-04-16','11:20:00',13.3),('7643','2014-04-16','11:25:00',14.98),('7643','2014-04-16','11:30:00',9.76),('7643','2014-04-16','11:35:00',11.32),('7643','2014-04-16','11:40:00',10.08),('7643','2014-04-16','11:45:00',14.34),('7643','2014-04-16','11:50:00',10.45),('7643','2014-04-16','11:55:00',7.9),('7643','2014-04-16','12:00:00',8.55),('7643','2014-04-16','12:05:00',11.53),('7643','2014-04-16','12:10:00',10.73),('7643','2014-04-16','12:15:00',9.69),('7643','2014-04-16','12:20:00',9.16),('7643','2014-04-16','12:25:00',9.7),('7643','2014-04-16','12:30:00',12.44),('7643','2014-04-16','12:35:00',15.13),('7643','2014-04-16','12:40:00',17.74),('7643','2014-04-16','12:45:00',16.82),('7643','2014-04-16','12:50:00',17.66),('7643','2014-04-16','12:55:00',17.89),('7643','2014-04-16','13:00:00',17.88),('7643','2014-04-16','13:05:00',10.24),('7643','2014-04-16','13:10:00',3.91),('7643','2014-04-16','13:15:00',4.49),('7643','2014-04-16','13:20:00',3.84),('7643','2014-04-16','13:25:00',15.67),('7643','2014-04-16','13:30:00',19.21),('7643','2014-04-16','13:35:00',4.25),('7643','2014-04-16','13:40:00',3.73),('7643','2014-04-16','13:45:00',3.43),('7643','2014-04-16','13:50:00',3.85),('7643','2014-04-16','13:55:00',4.36),('7643','2014-04-16','14:00:00',4.28),('7643','2014-04-16','14:05:00',4.46),('7643','2014-04-16','14:10:00',8.76),('7643','2014-04-16','14:15:00',7.57),('7643','2014-04-16','14:20:00',4.99),('7643','2014-04-16','14:25:00',6.38),('7643','2014-04-16','14:30:00',6.01),('7643','2014-04-16','14:35:00',7.03),('7643','2014-04-16','14:40:00',12.49),('7643','2014-04-16','14:45:00',6.18),('7643','2014-04-16','14:50:00',3.53),('7643','2014-04-16','14:55:00',2.95),('7643','2014-04-16','15:00:00',3.23),('7643','2014-04-16','15:05:00',3.7),('7643','2014-04-16','15:10:00',3.66),('7643','2014-04-16','15:15:00',3.34),('7643','2014-04-16','15:20:00',3.29),('7643','2014-04-16','15:25:00',4.09),('7643','2014-04-16','15:30:00',6.38),('7643','2014-04-16','15:35:00',8.73),('7643','2014-04-16','15:40:00',6.82),('7643','2014-04-16','15:45:00',4.84),('7643','2014-04-16','15:50:00',4.34),('7643','2014-04-16','15:55:00',4.95),('7643','2014-04-16','16:00:00',4.51),('7643','2014-04-16','16:05:00',3.6),('7643','2014-04-16','16:10:00',4.01),('7643','2014-04-16','16:15:00',4.26),('7643','2014-04-16','16:20:00',4.16),('7643','2014-04-16','16:25:00',4.4),('7643','2014-04-16','16:30:00',4.7),('7643','2014-04-16','16:35:00',4.17),('7643','2014-04-16','16:40:00',4.68),('7643','2014-04-16','16:45:00',5.96),('7643','2014-04-16','16:50:00',6.24),('7643','2014-04-16','16:55:00',4.58),('7643','2014-04-16','17:00:00',3.8),('7643','2014-04-16','17:05:00',3.2),('7643','2014-04-16','17:10:00',3.14),('7643','2014-04-16','17:15:00',3.49),('7643','2014-04-16','17:20:00',4.22),('7643','2014-04-16','17:25:00',3.61),('7643','2014-04-16','17:30:00',3.64),('7643','2014-04-16','17:35:00',3.62),('7643','2014-04-16','17:40:00',3.54),('7643','2014-04-16','17:45:00',3.22),('7643','2014-04-16','17:50:00',2.63),('7643','2014-04-16','17:55:00',2.54),('7643','2014-04-16','18:00:00',2.07),('7643','2014-04-16','18:05:00',1.52),('7643','2013-10-27','07:20:00',1.23),('7643','2013-10-27','07:25:00',1.87),('7643','2013-10-27','07:30:00',2.61),('7643','2013-10-27','07:35:00',3.09),('7643','2013-10-27','07:40:00',3.03),('7643','2013-10-27','07:45:00',2.01),('7643','2013-10-27','07:50:00',1.28),('7643','2013-10-27','07:55:00',1.36),('7643','2013-10-27','08:00:00',1.37),('7643','2013-10-27','08:05:00',1.97),('7643','2013-10-27','08:10:00',3.11),('7643','2013-10-27','08:15:00',2.27),('7643','2013-10-27','08:20:00',2.36),('7643','2013-10-27','08:25:00',2.14),('7643','2013-10-27','08:30:00',2.14),('7643','2013-10-27','08:35:00',2.28),('7643','2013-10-27','08:40:00',2.27),('7643','2013-10-27','08:45:00',3.16),('7643','2013-10-27','08:50:00',4.83),('7643','2013-10-27','08:55:00',6.33),('7643','2013-10-27','09:00:00',7.14),('7643','2013-10-27','09:05:00',7.87),('7643','2013-10-27','09:10:00',8.46),('7643','2013-10-27','09:15:00',8.72),('7643','2013-10-27','09:20:00',8.47),('7643','2013-10-27','09:25:00',7.81),('7643','2013-10-27','09:30:00',8.83),('7643','2013-10-27','09:35:00',7.19),('7643','2013-10-27','09:40:00',7.07),('7643','2013-10-27','09:45:00',6.45),('7643','2013-10-27','09:50:00',8.88),('7643','2013-10-27','09:55:00',7.63),('7643','2013-10-27','10:00:00',3.69),('7643','2013-10-27','10:05:00',2.89),('7643','2013-10-27','10:10:00',2.96),('7643','2013-10-27','10:15:00',2.87),('7643','2013-10-27','10:20:00',3.08),('7643','2013-10-27','10:25:00',3.1),('7643','2013-10-27','10:30:00',3.15),('7643','2013-10-27','10:35:00',3.13),('7643','2013-10-27','10:40:00',2.59),('7643','2013-10-27','10:45:00',1.83),('7643','2013-10-27','10:50:00',10.98),('7643','2013-10-27','10:55:00',10.77),('7643','2013-10-27','11:00:00',10.76),('7643','2013-10-27','11:05:00',10.89),('7643','2013-10-27','11:10:00',10.84),('7643','2013-10-27','11:15:00',10.9),('7643','2013-10-27','11:20:00',10.95),('7643','2013-10-27','11:25:00',10.93),('7643','2013-10-27','11:30:00',10.71),('7643','2013-10-27','11:35:00',10.88),('7643','2013-10-27','11:40:00',10.81),('7643','2013-10-27','11:45:00',10.84),('7643','2013-10-27','11:50:00',11.02),('7643','2013-10-27','11:55:00',8.66),('7643','2013-10-27','12:00:00',8.05),('7643','2013-10-27','12:05:00',9.2),('7643','2013-10-27','12:10:00',11.34),('7643','2013-10-27','12:15:00',11.44),('7643','2013-10-27','12:20:00',11.74),('7643','2013-10-27','12:25:00',6.52),('7643','2013-10-27','12:30:00',10.57),('7643','2013-10-27','12:35:00',12.93),('7643','2013-10-27','12:40:00',11.88),('7643','2013-10-27','12:45:00',11.61),('7643','2013-10-27','12:50:00',11.92),('7643','2013-10-27','12:55:00',11.29),('7643','2013-10-27','13:00:00',10.54),('7643','2013-10-27','13:05:00',10.35),('7643','2013-10-27','13:10:00',10.38),('7643','2013-10-27','13:15:00',9.95),('7643','2013-10-27','13:20:00',10.08),('7643','2013-10-27','13:25:00',9.03),('7643','2013-10-27','13:30:00',9.77),('7643','2013-10-27','13:35:00',9.34),('7643','2013-10-27','13:40:00',9.39),('7643','2013-10-27','13:45:00',9.37),('7643','2013-10-27','13:50:00',6.96),('7643','2013-10-27','13:55:00',9.03),('7643','2013-10-27','14:00:00',8.84),('7643','2013-10-27','14:05:00',8.75),('7643','2013-10-27','14:10:00',9.13),('7643','2013-10-27','14:15:00',8.47),('7643','2013-10-27','14:20:00',8.18),('7643','2013-10-27','14:25:00',8.45),('7643','2013-10-27','14:30:00',6.94),('7643','2013-10-27','14:35:00',6.01),('7643','2013-10-27','14:40:00',2.97),('7643','2013-10-27','14:45:00',5.64),('7643','2013-10-27','14:50:00',6.49),('7643','2013-10-27','14:55:00',6.07),('7643','2013-10-27','15:00:00',5.9),('7643','2013-10-27','15:05:00',5.63),('7643','2013-10-27','15:10:00',5.27),('7643','2013-10-27','15:15:00',3.69),('7643','2013-10-27','15:20:00',2.21),('7643','2013-10-27','15:25:00',3.87),('7643','2013-10-27','15:30:00',3.54),('7643','2013-10-27','15:35:00',1.62),('7643','2013-10-27','15:40:00',1.79),('7643','2013-10-27','15:45:00',2.87),('7643','2013-10-27','15:50:00',3.54),('7643','2013-10-27','15:55:00',2.74),('7643','2013-10-27','16:00:00',2.28),('7643','2013-10-27','16:05:00',1.37),('7643','2013-10-27','16:10:00',1.37),('7643','2013-10-27','16:15:00',1.3),('7643','2013-10-27','16:20:00',1.29),('7643','2013-10-27','16:25:00',1.01),('7643','2013-10-26','08:00:00',1.16),('7643','2013-10-26','08:05:00',1.24),('7643','2013-10-26','08:10:00',1.46),('7643','2013-10-26','08:15:00',1.63),('7643','2013-10-26','08:20:00',1.79),('7643','2013-10-26','08:25:00',1.6),('7643','2013-10-26','08:30:00',1.39),('7643','2013-10-26','08:35:00',1.43),('7643','2013-10-26','08:40:00',1.65),('7643','2013-10-26','08:45:00',1.92),('7643','2013-10-26','08:50:00',1.99),('7643','2013-10-26','08:55:00',2.21),('7643','2013-10-26','09:00:00',2.53),('7643','2013-10-26','09:05:00',2.4),('7643','2013-10-26','09:10:00',1.91),('7643','2013-10-26','09:15:00',1.69),('7643','2013-10-26','09:20:00',1.8),('7643','2013-10-26','09:25:00',1.96),('7643','2013-10-26','09:30:00',2.21),('7643','2013-10-26','09:35:00',2.43),('7643','2013-10-26','09:40:00',2.71),('7643','2013-10-26','09:45:00',3.05),('7643','2013-10-26','09:50:00',3.25),('7643','2013-10-26','09:55:00',3.49),('7643','2013-10-26','10:00:00',3.78),('7643','2013-10-26','10:05:00',3.99),('7643','2013-10-26','10:10:00',4.22),('7643','2013-10-26','10:15:00',4.33),('7643','2013-10-26','10:20:00',4.99),('7643','2013-10-26','10:25:00',4.77),('7643','2013-10-26','10:30:00',4.7),('7643','2013-10-26','10:35:00',4.6),('7643','2013-10-26','10:40:00',4.47),('7643','2013-10-26','10:45:00',5.02),('7643','2013-10-26','10:50:00',5.1),('7643','2013-10-26','10:55:00',4.64),('7643','2013-10-26','11:00:00',4.21),('7643','2013-10-26','11:05:00',3.61),('7643','2013-10-26','11:10:00',2.86),('7643','2013-10-26','11:15:00',2.27),('7643','2013-10-26','11:20:00',2.03),('7643','2013-10-26','11:25:00',2.33),('7643','2013-10-26','11:30:00',3.18),('7643','2013-10-26','11:35:00',4.5),('7643','2013-10-26','11:40:00',6.81),('7643','2013-10-26','11:45:00',6.79),('7643','2013-10-26','11:50:00',8.32),('7643','2013-10-26','11:55:00',4.13),('7643','2013-10-26','12:00:00',3.72),('7643','2013-10-26','12:05:00',4.3),('7643','2013-10-26','12:10:00',4.52),('7643','2013-10-26','12:15:00',6.08),('7643','2013-10-26','12:20:00',9.03),('7643','2013-10-26','12:25:00',9.36),('7643','2013-10-26','12:30:00',8.28),('7643','2013-10-26','12:35:00',10.67),('7643','2013-10-26','12:40:00',9.73),('7643','2013-10-26','12:45:00',10.48),('7643','2013-10-26','12:50:00',11.28),('7643','2013-10-26','12:55:00',11),('7643','2013-10-26','13:00:00',9.52),('7643','2013-10-26','13:05:00',5.76),('7643','2013-10-26','13:10:00',6.29),('7643','2013-10-26','13:15:00',4.61),('7643','2013-10-26','13:20:00',3.52),('7643','2013-10-26','13:25:00',5.27),('7643','2013-10-26','13:30:00',7.8),('7643','2013-10-26','13:35:00',6.98),('7643','2013-10-26','13:40:00',4.67),('7643','2013-10-26','13:45:00',3.01),('7643','2013-10-26','13:50:00',2.42),('7643','2013-10-26','13:55:00',2.37),('7643','2013-10-26','14:00:00',3.16),('7643','2013-10-26','14:05:00',4.55),('7643','2013-10-26','14:10:00',3.63),('7643','2013-10-26','14:15:00',3.35),('7643','2013-10-26','14:20:00',3.7),('7643','2013-10-26','14:25:00',3.85),('7643','2013-10-26','14:30:00',3.22),('7643','2013-10-26','14:35:00',3.81),('7643','2013-10-26','14:40:00',5.64),('7643','2013-10-26','14:45:00',6.53),('7643','2013-10-26','14:50:00',5.48),('7643','2013-10-26','14:55:00',5.52),('7643','2013-10-26','15:00:00',5.72),('7643','2013-10-26','15:05:00',4.72),('7643','2013-10-26','15:10:00',4.82),('7643','2013-10-26','15:15:00',4.93),('7643','2013-10-26','15:20:00',4.69),('7643','2013-10-26','15:25:00',4.38),('7643','2013-10-26','15:30:00',3.51),('7643','2013-10-26','15:35:00',2.89),('7643','2013-10-26','15:40:00',1.04),('7643','2013-10-26','15:45:00',1.1),('7643','2013-10-26','15:50:00',2.55),('7643','2013-10-26','15:55:00',1.86),('7643','2013-10-26','16:00:00',2.13),('7643','2013-10-26','16:05:00',1.92),('7643','2013-10-26','16:10:00',1.67),('7643','2013-10-26','16:15:00',1.34),('7643','2013-10-25','08:15:00',1.21),('7643','2013-10-25','08:20:00',1.47),('7643','2013-10-25','08:25:00',1.72),('7643','2013-10-25','08:30:00',2.01),('7643','2013-10-25','08:35:00',2.33),('7643','2013-10-25','08:40:00',2.61),('7643','2013-10-25','08:45:00',2.88),('7643','2013-10-25','08:50:00',3.17),('7643','2013-10-25','08:55:00',3.44),('7643','2013-10-25','09:00:00',3.71),('7643','2013-10-25','09:05:00',3.98),('7643','2013-10-25','09:10:00',4.3),('7643','2013-10-25','09:15:00',4.6),('7643','2013-10-25','09:20:00',4.91),('7643','2013-10-25','09:25:00',5.2),('7643','2013-10-25','09:30:00',5.49),('7643','2013-10-25','09:35:00',5.71),('7643','2013-10-25','09:40:00',5.98),('7643','2013-10-25','09:45:00',6.23),('7643','2013-10-25','09:50:00',6.47),('7643','2013-10-25','09:55:00',6.74),('7643','2013-10-25','10:00:00',6.97),('7643','2013-10-25','10:05:00',7.28),('7643','2013-10-25','10:10:00',7.49),('7643','2013-10-25','10:15:00',7.65),('7643','2013-10-25','10:20:00',7.88),('7643','2013-10-25','10:25:00',8.07),('7643','2013-10-25','10:30:00',8.25),('7643','2013-10-25','10:35:00',8.42),('7643','2013-10-25','10:40:00',8.61),('7643','2013-10-25','10:45:00',8.84),('7643','2013-10-25','10:50:00',9.04),('7643','2013-10-25','10:55:00',9.15),('7643','2013-10-25','11:00:00',9.25),('7643','2013-10-25','11:05:00',9.47),('7643','2013-10-25','11:10:00',9.69),('7643','2013-10-25','11:15:00',9.79),('7643','2013-10-25','11:20:00',9.88),('7643','2013-10-25','11:25:00',10.02),('7643','2013-10-25','11:30:00',10.06),('7643','2013-10-25','11:35:00',10.15),('7643','2013-10-25','11:40:00',10.26),('7643','2013-10-25','11:45:00',10.36),('7643','2013-10-25','11:50:00',10.38),('7643','2013-10-25','11:55:00',10.38),('7643','2013-10-25','12:00:00',10.54),('7643','2013-10-25','12:05:00',10.44),('7643','2013-10-25','12:10:00',10.32),('7643','2013-10-25','12:15:00',10.5),('7643','2013-10-25','12:20:00',10.54),('7643','2013-10-25','12:25:00',10.75),('7643','2013-10-25','12:30:00',10.66),('7643','2013-10-25','12:35:00',10.59),('7643','2013-10-25','12:40:00',10.54),('7643','2013-10-25','12:45:00',10.56),('7643','2013-10-25','12:50:00',10.53),('7643','2013-10-25','12:55:00',9.35),('7643','2013-10-25','13:00:00',8.37),('7643','2013-10-25','13:05:00',7.22),('7643','2013-10-25','13:10:00',10.7),('7643','2013-10-25','13:15:00',10.44),('7643','2013-10-25','13:20:00',10.58),('7643','2013-10-25','13:25:00',10.3),('7643','2013-10-25','13:30:00',10.17),('7643','2013-10-25','13:35:00',10.49),('7643','2013-10-25','13:40:00',10.22),('7643','2013-10-25','13:45:00',8.88),('7643','2013-10-25','13:50:00',9.71),('7643','2013-10-25','13:55:00',9.93),('7643','2013-10-25','14:00:00',9.25),('7643','2013-10-25','14:05:00',8.81),('7643','2013-10-25','14:10:00',9.28),('7643','2013-10-25','14:15:00',6.34),('7643','2013-10-25','14:20:00',3.91),('7643','2013-10-25','14:25:00',7.79),('7643','2013-10-25','14:30:00',7.73),('7643','2013-10-25','14:35:00',8.17),('7643','2013-10-25','14:40:00',8.36),('7643','2013-10-25','14:45:00',7.65),('7643','2013-10-25','14:50:00',8.11),('7643','2013-10-25','14:55:00',7.79),('7643','2013-10-25','15:00:00',7.93),('7643','2013-10-25','15:05:00',7.66),('7643','2013-10-25','15:10:00',7.69),('7643','2013-10-25','15:15:00',7.14),('7643','2013-10-25','15:20:00',6.88),('7643','2013-10-25','15:25:00',6.52),('7643','2013-10-25','15:30:00',6.12),('7643','2013-10-25','15:35:00',6.15),('7643','2013-10-25','15:40:00',6.47),('7643','2013-10-25','15:45:00',6.04),('7643','2013-10-25','15:50:00',6.05),('7643','2013-10-25','15:55:00',5.4),('7643','2013-10-25','16:00:00',4.76),('7643','2013-10-25','16:05:00',4.56),('7643','2013-10-25','16:10:00',4.7),('7643','2013-10-25','16:15:00',4.26),('7643','2013-10-25','16:20:00',4.1),('7643','2013-10-25','16:25:00',3.72),('7643','2013-10-25','16:30:00',3.57),('7643','2013-10-25','16:35:00',3.23),('7643','2013-10-25','16:40:00',3.01),('7643','2013-10-25','16:45:00',2.78),('7643','2013-10-25','16:50:00',2.48),('7643','2013-10-25','16:55:00',2.27),('7643','2013-10-25','17:00:00',1.99),('7643','2013-10-25','17:05:00',1.75),('7643','2013-10-25','17:10:00',1.53),('7643','2013-10-25','17:15:00',1.32),('7643','2013-10-25','17:20:00',1.09),('7643','2013-10-24','08:10:00',1.02),('7643','2013-10-24','08:15:00',1.25),('7643','2013-10-24','08:20:00',1.52),('7643','2013-10-24','08:25:00',1.77),('7643','2013-10-24','08:30:00',2.05),('7643','2013-10-24','08:35:00',2.34),('7643','2013-10-24','08:40:00',2.63),('7643','2013-10-24','08:45:00',2.94),('7643','2013-10-24','08:50:00',3.25),('7643','2013-10-24','08:55:00',3.48),('7643','2013-10-24','09:00:00',3.78),('7643','2013-10-24','09:05:00',4.09),('7643','2013-10-24','09:10:00',4.38),('7643','2013-10-24','09:15:00',4.67),('7643','2013-10-24','09:20:00',4.99),('7643','2013-10-24','09:25:00',5.28),('7643','2013-10-24','09:30:00',5.52),('7643','2013-10-24','09:35:00',5.78),('7643','2013-10-24','09:40:00',6.07),('7643','2013-10-24','09:45:00',6.36),('7643','2013-10-24','09:50:00',6.62),('7643','2013-10-24','09:55:00',6.88),('7643','2013-10-24','10:00:00',7.12),('7643','2013-10-24','10:05:00',7.36),('7643','2013-10-24','10:10:00',7.59),('7643','2013-10-24','10:15:00',7.81),('7643','2013-10-24','10:20:00',7.98),('7643','2013-10-24','10:25:00',8.24),('7643','2013-10-24','10:30:00',8.5),('7643','2013-10-24','10:35:00',8.64),('7643','2013-10-24','10:40:00',8.86),('7643','2013-10-24','10:45:00',9.05),('7643','2013-10-24','10:50:00',9.14),('7643','2013-10-24','10:55:00',9.34),('7643','2013-10-24','11:00:00',9.55),('7643','2013-10-24','11:05:00',9.63),('7643','2013-10-24','11:10:00',9.81),('7643','2013-10-24','11:15:00',9.88),('7643','2013-10-24','11:20:00',9.91),('7643','2013-10-24','11:25:00',9.94),('7643','2013-10-24','11:30:00',10.1),('7643','2013-10-24','11:35:00',10.18),('7643','2013-10-24','11:40:00',10.48),('7643','2013-10-24','11:45:00',10.62),('7643','2013-10-24','11:50:00',10.6),('7643','2013-10-24','11:55:00',10.77),('7643','2013-10-24','12:00:00',10.82),('7643','2013-10-24','12:05:00',10.92),('7643','2013-10-24','12:10:00',10.88),('7643','2013-10-24','12:15:00',10.98),('7643','2013-10-24','12:20:00',11.02),('7643','2013-10-24','12:25:00',11.08),('7643','2013-10-24','12:30:00',11.11),('7643','2013-10-24','12:35:00',11),('7643','2013-10-24','12:40:00',11.1),('7643','2013-10-24','12:45:00',11.12),('7643','2013-10-24','12:50:00',11.14),('7643','2013-10-24','12:55:00',11.05),('7643','2013-10-24','13:00:00',10.98),('7643','2013-10-24','13:05:00',10.97),('7643','2013-10-24','13:10:00',10.91),('7643','2013-10-24','13:15:00',10.93),('7643','2013-10-24','13:20:00',10.84),('7643','2013-10-24','13:25:00',10.87),('7643','2013-10-24','13:30:00',10.66),('7643','2013-10-24','13:35:00',10.57),('7643','2013-10-24','13:40:00',10.59),('7643','2013-10-24','13:45:00',10.39),('7643','2013-10-24','13:50:00',10.24),('7643','2013-10-24','13:55:00',10.21),('7643','2013-10-24','14:00:00',10.2),('7643','2013-10-24','14:05:00',9.98),('7643','2013-10-24','14:10:00',9.93),('7643','2013-10-24','14:15:00',9.73),('7643','2013-10-24','14:20:00',9.73),('7643','2013-10-24','14:25:00',9.65),('7643','2013-10-24','14:30:00',9.45),('7643','2013-10-24','14:35:00',9.37),('7643','2013-10-24','14:40:00',9.13),('7643','2013-10-24','14:45:00',8.99),('7643','2013-10-24','14:50:00',8.82),('7643','2013-10-24','14:55:00',8.68),('7643','2013-10-24','15:00:00',8.32),('7643','2013-10-24','15:05:00',8.2),('7643','2013-10-24','15:10:00',8.11),('7643','2013-10-24','15:15:00',7.88),('7643','2013-10-24','15:20:00',7.55),('7643','2013-10-24','15:25:00',7.36),('7643','2013-10-24','15:30:00',7.02),('7643','2013-10-24','15:35:00',6.7),('7643','2013-10-24','15:40:00',6.6),('7643','2013-10-24','15:45:00',6.35),('7643','2013-10-24','15:50:00',6.13),('7643','2013-10-24','15:55:00',5.78),('7643','2013-10-24','16:00:00',5.59),('7643','2013-10-24','16:05:00',5.36),('7643','2013-10-24','16:10:00',5.11),('7643','2013-10-24','16:15:00',4.87),('7643','2013-10-24','16:20:00',4.65),('7643','2013-10-24','16:25:00',4.39),('7643','2013-10-24','16:30:00',4.13),('7643','2013-10-24','16:35:00',3.82),('7643','2013-10-24','16:40:00',3.54),('7643','2013-10-24','16:45:00',3.24),('7643','2013-10-24','16:50:00',2.99),('7643','2013-10-24','16:55:00',2.74),('7643','2013-10-24','17:00:00',2.44),('7643','2013-10-24','17:05:00',2.15),('7643','2013-10-24','17:10:00',1.86),('7643','2013-10-24','17:15:00',1.59),('7643','2013-10-24','17:20:00',1.36),('7643','2013-10-24','17:25:00',1.13),('7643','2013-10-23','08:20:00',1.29),('7643','2013-10-23','08:25:00',2.17),('7643','2013-10-23','08:30:00',2.72),('7643','2013-10-23','08:35:00',1.8),('7643','2013-10-23','08:40:00',1.43),('7643','2013-10-23','08:45:00',1.57),('7643','2013-10-23','08:50:00',2.12),('7643','2013-10-23','08:55:00',3.04),('7643','2013-10-23','09:00:00',3.1),('7643','2013-10-23','09:05:00',3.38),('7643','2013-10-23','09:10:00',3.99),('7643','2013-10-23','09:15:00',5.38),('7643','2013-10-23','09:20:00',5.39),('7643','2013-10-23','09:25:00',3.26),('7643','2013-10-23','09:30:00',3.39),('7643','2013-10-23','09:35:00',3.73),('7643','2013-10-23','09:40:00',3.99),('7643','2013-10-23','09:45:00',4.14),('7643','2013-10-23','09:50:00',4.43),('7643','2013-10-23','09:55:00',4.05),('7643','2013-10-23','10:00:00',3.97),('7643','2013-10-23','10:05:00',3.87),('7643','2013-10-23','10:10:00',3.6),('7643','2013-10-23','10:15:00',3.38),('7643','2013-10-23','10:20:00',5.64),('7643','2013-10-23','10:25:00',3.55),('7643','2013-10-23','10:30:00',2.61),('7643','2013-10-23','10:35:00',5.39),('7643','2013-10-23','10:40:00',4.67),('7643','2013-10-23','10:45:00',7.47),('7643','2013-10-23','10:50:00',5.66),('7643','2013-10-23','10:55:00',7.78),('7643','2013-10-23','11:00:00',9.97),('7643','2013-10-23','11:05:00',12.97),('7643','2013-10-23','11:10:00',10.31),('7643','2013-10-23','11:15:00',8.23),('7643','2013-10-23','11:20:00',6.71),('7643','2013-10-23','11:25:00',6.15),('7643','2013-10-23','11:30:00',5.72),('7643','2013-10-23','11:35:00',4.3),('7643','2013-10-23','11:40:00',4.43),('7643','2013-10-23','11:45:00',4.28),('7643','2013-10-23','11:50:00',5.4),('7643','2013-10-23','11:55:00',10.16),('7643','2013-10-23','12:00:00',6.91),('7643','2013-10-23','12:05:00',5.09),('7643','2013-10-23','12:10:00',4.75),('7643','2013-10-23','12:15:00',4.67),('7643','2013-10-23','12:20:00',4.81),('7643','2013-10-23','12:25:00',5.26),('7643','2013-10-23','12:30:00',5.59),('7643','2013-10-23','12:35:00',6.01),('7643','2013-10-23','12:40:00',6.97),('7643','2013-10-23','12:45:00',9.36),('7643','2013-10-23','12:50:00',8.58),('7643','2013-10-23','12:55:00',9.92),('7643','2013-10-23','13:00:00',13.67),('7643','2013-10-23','13:05:00',12.21),('7643','2013-10-23','13:10:00',10.4),('7643','2013-10-23','13:15:00',8.85),('7643','2013-10-23','13:20:00',9.13),('7643','2013-10-23','13:25:00',6.51),('7643','2013-10-23','13:30:00',5.13),('7643','2013-10-23','13:35:00',4.79),('7643','2013-10-23','13:40:00',4.77),('7643','2013-10-23','13:45:00',4.97),('7643','2013-10-23','13:50:00',6.84),('7643','2013-10-23','13:55:00',6.85),('7643','2013-10-23','14:00:00',8.91),('7643','2013-10-23','14:05:00',6.82),('7643','2013-10-23','14:10:00',5.2),('7643','2013-10-23','14:15:00',4.97),('7643','2013-10-23','14:20:00',5.27),('7643','2013-10-23','14:25:00',5.33),('7643','2013-10-23','14:30:00',5.37),('7643','2013-10-23','14:35:00',5.94),('7643','2013-10-23','14:40:00',5.89),('7643','2013-10-23','14:45:00',6.63),('7643','2013-10-23','14:50:00',7.4),('7643','2013-10-23','14:55:00',3.47),('7643','2013-10-23','15:00:00',3.72),('7643','2013-10-23','15:05:00',3.9),('7643','2013-10-23','15:10:00',8.14),('7643','2013-10-23','15:15:00',5.14),('7643','2013-10-23','15:20:00',4.43),('7643','2013-10-23','15:25:00',4.54),('7643','2013-10-23','15:30:00',3.96),('7643','2013-10-23','15:35:00',9.12),('7643','2013-10-23','15:40:00',7.69),('7643','2013-10-23','15:45:00',6.1),('7643','2013-10-23','15:50:00',4.97),('7643','2013-10-23','15:55:00',2.76),('7643','2013-10-23','16:00:00',2.58),('7643','2013-10-23','16:05:00',2.51),('7643','2013-10-23','16:10:00',2.39),('7643','2013-10-23','16:15:00',2.36),('7643','2013-10-23','16:20:00',2.27),('7643','2013-10-23','16:25:00',1.95),('7643','2013-10-23','16:30:00',1.6),('7643','2013-10-23','16:35:00',1.38),('7643','2013-10-23','16:40:00',1.2),('7643','2013-10-23','16:45:00',1.03),('7643','2013-10-22','09:20:00',1.27),('7643','2013-10-22','09:25:00',1.42),('7643','2013-10-22','09:30:00',1.52),('7643','2013-10-22','09:35:00',1.67),('7643','2013-10-22','09:40:00',1.69),('7643','2013-10-22','09:45:00',2.52),('7643','2013-10-22','09:50:00',2.22),('7643','2013-10-22','09:55:00',2.05),('7643','2013-10-22','10:00:00',2.26),('7643','2013-10-22','10:05:00',2.55),('7643','2013-10-22','10:10:00',2.45),('7643','2013-10-22','10:15:00',3),('7643','2013-10-22','10:20:00',3.3),('7643','2013-10-22','10:25:00',4.13),('7643','2013-10-22','10:30:00',3.92),('7643','2013-10-22','10:35:00',3.68),('7643','2013-10-22','10:40:00',3.37),('7643','2013-10-22','10:45:00',4.44),('7643','2013-10-22','10:50:00',4.31),('7643','2013-10-22','10:55:00',6.03),('7643','2013-10-22','11:00:00',6.83),('7643','2013-10-22','11:05:00',6.37),('7643','2013-10-22','11:10:00',5.68),('7643','2013-10-22','11:15:00',7.16),('7643','2013-10-22','11:20:00',7.71),('7643','2013-10-22','11:25:00',9.34),('7643','2013-10-22','11:30:00',10.62),('7643','2013-10-22','11:35:00',9.71),('7643','2013-10-22','11:40:00',10.35),('7643','2013-10-22','11:45:00',10.25),('7643','2013-10-22','11:50:00',10.52),('7643','2013-10-22','11:55:00',10.38),('7643','2013-10-22','12:00:00',10.49),('7643','2013-10-22','12:05:00',10.83),('7643','2013-10-22','12:10:00',10.8),('7643','2013-10-22','12:15:00',10.55),('7643','2013-10-22','12:20:00',10.16),('7643','2013-10-22','12:25:00',10.58),('7643','2013-10-22','12:30:00',10.16),('7643','2013-10-22','12:35:00',10.43),('7643','2013-10-22','12:40:00',10.68),('7643','2013-10-22','12:45:00',10.26),('7643','2013-10-22','12:50:00',10.01),('7643','2013-10-22','12:55:00',7.36),('7643','2013-10-22','13:00:00',9.51),('7643','2013-10-22','13:05:00',8.73),('7643','2013-10-22','13:10:00',9.84),('7643','2013-10-22','13:15:00',9.19),('7643','2013-10-22','13:20:00',10.08),('7643','2013-10-22','13:25:00',9.94),('7643','2013-10-22','13:30:00',9.88),('7643','2013-10-22','13:35:00',9.7),('7643','2013-10-22','13:40:00',9.47),('7643','2013-10-22','13:45:00',9.49),('7643','2013-10-22','13:50:00',9.83),('7643','2013-10-22','13:55:00',9.73),('7643','2013-10-22','14:00:00',8.09),('7643','2013-10-22','14:05:00',8.6),('7643','2013-10-22','14:10:00',8.98),('7643','2013-10-22','14:15:00',8.85),('7643','2013-10-22','14:20:00',9.1),('7643','2013-10-22','14:25:00',9.28),('7643','2013-10-22','14:30:00',8.98),('7643','2013-10-22','14:35:00',8.9),('7643','2013-10-22','14:40:00',8.23),('7643','2013-10-22','14:45:00',8.38),('7643','2013-10-22','14:50:00',7.94),('7643','2013-10-22','14:55:00',8.63),('7643','2013-10-22','15:00:00',8.39),('7643','2013-10-22','15:05:00',8.29),('7643','2013-10-22','15:10:00',7.8),('7643','2013-10-22','15:15:00',7.77),('7643','2013-10-22','15:20:00',7.76),('7643','2013-10-22','15:25:00',7.71),('7643','2013-10-22','15:30:00',7.27),('7643','2013-10-22','15:35:00',6.82),('7643','2013-10-22','15:40:00',7.1),('7643','2013-10-22','15:45:00',6.98),('7643','2013-10-22','15:50:00',6.18),('7643','2013-10-22','15:55:00',4.75),('7643','2013-10-22','16:00:00',3.99),('7643','2013-10-22','16:05:00',3.44),('7643','2013-10-22','16:10:00',3.28),('7643','2013-10-22','16:15:00',3.56),('7643','2013-10-22','16:20:00',3.2),('7643','2013-10-22','16:25:00',3.09),('7643','2013-10-22','16:30:00',2.79),('7643','2013-10-22','16:35:00',3.53),('7643','2013-10-22','16:40:00',3.6),('7643','2013-10-22','16:45:00',3.09),('7643','2013-10-22','16:50:00',2.7),('7643','2013-10-22','16:55:00',2.39),('7643','2013-10-22','17:00:00',2.28),('7643','2013-10-22','17:05:00',1.88),('7643','2013-10-22','17:10:00',1.58),('7643','2013-10-22','17:15:00',1.22),('7643','2013-10-21','08:10:00',1.11),('7643','2013-10-21','08:15:00',1.35),('7643','2013-10-21','08:20:00',1.6),('7643','2013-10-21','08:25:00',1.85),('7643','2013-10-21','08:30:00',2.11),('7643','2013-10-21','08:35:00',2.4),('7643','2013-10-21','08:40:00',2.69),('7643','2013-10-21','08:45:00',2.97),('7643','2013-10-21','08:50:00',3.27),('7643','2013-10-21','08:55:00',3.57),('7643','2013-10-21','09:00:00',3.84),('7643','2013-10-21','09:05:00',4.13),('7643','2013-10-21','09:10:00',4.46),('7643','2013-10-21','09:15:00',4.73),('7643','2013-10-21','09:20:00',4.99),('7643','2013-10-21','09:25:00',5.27),('7643','2013-10-21','09:30:00',5.56),('7643','2013-10-21','09:35:00',5.86),('7643','2013-10-21','09:40:00',6.15),('7643','2013-10-21','09:45:00',6.41),('7643','2013-10-21','09:50:00',6.65),('7643','2013-10-21','09:55:00',6.92),('7643','2013-10-21','10:00:00',7.13),('7643','2013-10-21','10:05:00',7.42),('7643','2013-10-21','10:10:00',7.58),('7643','2013-10-21','10:15:00',7.77),('7643','2013-10-21','10:20:00',7.98),('7643','2013-10-21','10:25:00',8.23),('7643','2013-10-21','10:30:00',8.45),('7643','2013-10-21','10:35:00',8.61),('7643','2013-10-21','10:40:00',8.77),('7643','2013-10-21','10:45:00',8.92),('7643','2013-10-21','10:50:00',9.08),('7643','2013-10-21','10:55:00',9.31),('7643','2013-10-21','11:00:00',9.27),('7643','2013-10-21','11:05:00',9.54),('7643','2013-10-21','11:10:00',9.48),('7643','2013-10-21','11:15:00',9.77),('7643','2013-10-21','11:20:00',9.8),('7643','2013-10-21','11:25:00',9.93),('7643','2013-10-21','11:30:00',10.02),('7643','2013-10-21','11:35:00',9.98),('7643','2013-10-21','11:40:00',10),('7643','2013-10-21','11:45:00',10.12),('7643','2013-10-21','11:50:00',10.2),('7643','2013-10-21','11:55:00',10.3),('7643','2013-10-21','12:00:00',10.45),('7643','2013-10-21','12:05:00',10.58),('7643','2013-10-21','12:10:00',10.5),('7643','2013-10-21','12:15:00',10.51),('7643','2013-10-21','12:20:00',10.52),('7643','2013-10-21','12:25:00',10.18),('7643','2013-10-21','12:30:00',10.44),('7643','2013-10-21','12:35:00',10.21),('7643','2013-10-21','12:40:00',10.05),('7643','2013-10-21','12:45:00',10.28),('7643','2013-10-21','12:50:00',9.75),('7643','2013-10-21','12:55:00',10.24),('7643','2013-10-21','13:00:00',10.67),('7643','2013-10-21','13:05:00',10.75),('7643','2013-10-21','13:10:00',10.53),('7643','2013-10-21','13:15:00',10.42),('7643','2013-10-21','13:20:00',10.45),('7643','2013-10-21','13:25:00',10.58),('7643','2013-10-21','13:30:00',9.53),('7643','2013-10-21','13:35:00',9.47),('7643','2013-10-21','13:40:00',9.98),('7643','2013-10-21','13:45:00',10.46),('7643','2013-10-21','13:50:00',10.04),('7643','2013-10-21','13:55:00',9.4),('7643','2013-10-21','14:00:00',9.25),('7643','2013-10-21','14:05:00',8.4),('7643','2013-10-21','14:10:00',4.17),('7643','2013-10-21','14:15:00',7.56),('7643','2013-10-21','14:20:00',9.99),('7643','2013-10-21','14:25:00',9.85),('7643','2013-10-21','14:30:00',9.06),('7643','2013-10-21','14:35:00',6.74),('7643','2013-10-21','14:40:00',8.07),('7643','2013-10-21','14:45:00',8.5),('7643','2013-10-21','14:50:00',8.13),('7643','2013-10-21','14:55:00',8.2),('7643','2013-10-21','15:00:00',7.96),('7643','2013-10-21','15:05:00',7.95),('7643','2013-10-21','15:10:00',7.71),('7643','2013-10-21','15:15:00',7.48),('7643','2013-10-21','15:20:00',7.08),('7643','2013-10-21','15:25:00',7.02),('7643','2013-10-21','15:30:00',6.97),('7643','2013-10-21','15:35:00',7.07),('7643','2013-10-21','15:40:00',7.12),('7643','2013-10-21','15:45:00',6.86),('7643','2013-10-21','15:50:00',5.66),('7643','2013-10-21','15:55:00',5.9),('7643','2013-10-21','16:00:00',5.42),('7643','2013-10-21','16:05:00',5.02),('7643','2013-10-21','16:10:00',4.79),('7643','2013-10-21','16:15:00',4.62),('7643','2013-10-21','16:20:00',4.37),('7643','2013-10-21','16:25:00',4.06),('7643','2013-10-21','16:30:00',3.98),('7643','2013-10-21','16:35:00',3.69),('7643','2013-10-21','16:40:00',3.41),('7643','2013-10-21','16:45:00',3.17),('7643','2013-10-21','16:50:00',2.91),('7643','2013-10-21','16:55:00',2.7),('7643','2013-10-21','17:00:00',2.43),('7643','2013-10-21','17:05:00',2.16),('7643','2013-10-21','17:10:00',1.88),('7643','2013-10-21','17:15:00',1.6),('7643','2013-10-21','17:20:00',1.34),('7643','2013-10-21','17:25:00',1.11),('7643','2013-10-20','07:55:00',1.03),('7643','2013-10-20','08:00:00',1.24),('7643','2013-10-20','08:05:00',1.43),('7643','2013-10-20','08:10:00',1.7),('7643','2013-10-20','08:15:00',1.73),('7643','2013-10-20','08:20:00',2.2),('7643','2013-10-20','08:25:00',2.29),('7643','2013-10-20','08:30:00',2.47),('7643','2013-10-20','08:35:00',2.57),('7643','2013-10-20','08:40:00',2.91),('7643','2013-10-20','08:45:00',3.09),('7643','2013-10-20','08:50:00',2.77),('7643','2013-10-20','08:55:00',3.33),('7643','2013-10-20','09:00:00',2.62),('7643','2013-10-20','09:05:00',2.99),('7643','2013-10-20','09:10:00',4.11),('7643','2013-10-20','09:15:00',4.47),('7643','2013-10-20','09:20:00',5.5),('7643','2013-10-20','09:25:00',5.86),('7643','2013-10-20','09:30:00',5.47),('7643','2013-10-20','09:35:00',5.09),('7643','2013-10-20','09:40:00',6.17),('7643','2013-10-20','09:45:00',5.16),('7643','2013-10-20','09:50:00',5.78),('7643','2013-10-20','09:55:00',6.75),('7643','2013-10-20','10:00:00',6.71),('7643','2013-10-20','10:05:00',7.47),('7643','2013-10-20','10:10:00',7.9),('7643','2013-10-20','10:15:00',8.17),('7643','2013-10-20','10:20:00',8.26),('7643','2013-10-20','10:25:00',8.55),('7643','2013-10-20','10:30:00',8.41),('7643','2013-10-20','10:35:00',8.51),('7643','2013-10-20','10:40:00',8.35),('7643','2013-10-20','10:45:00',8.63),('7643','2013-10-20','10:50:00',9.23),('7643','2013-10-20','10:55:00',9.07),('7643','2013-10-20','11:00:00',9.69),('7643','2013-10-20','11:05:00',9.28),('7643','2013-10-20','11:10:00',8.39),('7643','2013-10-20','11:15:00',10.3),('7643','2013-10-20','11:20:00',10.2),('7643','2013-10-20','11:25:00',10.2),('7643','2013-10-20','11:30:00',10.51),('7643','2013-10-20','11:35:00',10.54),('7643','2013-10-20','11:40:00',10.38),('7643','2013-10-20','11:45:00',10.76),('7643','2013-10-20','11:50:00',10.79),('7643','2013-10-20','11:55:00',10.88),('7643','2013-10-20','12:00:00',11.08),('7643','2013-10-20','12:05:00',11.22),('7643','2013-10-20','12:10:00',11.33),('7643','2013-10-20','12:15:00',11.27),('7643','2013-10-20','12:20:00',11.18),('7643','2013-10-20','12:25:00',11.26),('7643','2013-10-20','12:30:00',10.84),('7643','2013-10-20','12:35:00',10.98),('7643','2013-10-20','12:40:00',11.26),('7643','2013-10-20','12:45:00',11.32),('7643','2013-10-20','12:50:00',11.22),('7643','2013-10-20','12:55:00',11.2),('7643','2013-10-20','13:00:00',11.09),('7643','2013-10-20','13:05:00',10.95),('7643','2013-10-20','13:10:00',10.43),('7643','2013-10-20','13:15:00',10.96),('7643','2013-10-20','13:20:00',10.66),('7643','2013-10-20','13:25:00',10.91),('7643','2013-10-20','13:30:00',11.06),('7643','2013-10-20','13:35:00',11.04),('7643','2013-10-20','13:40:00',10.95),('7643','2013-10-20','13:45:00',10.84),('7643','2013-10-20','13:50:00',10.68),('7643','2013-10-20','13:55:00',10.22),('7643','2013-10-20','14:00:00',10.02),('7643','2013-10-20','14:05:00',10.28),('7643','2013-10-20','14:10:00',10.16),('7643','2013-10-20','14:15:00',9.99),('7643','2013-10-20','14:20:00',9.95),('7643','2013-10-20','14:25:00',9.63),('7643','2013-10-20','14:30:00',9.32),('7643','2013-10-20','14:35:00',9.21),('7643','2013-10-20','14:40:00',8.76),('7643','2013-10-20','14:45:00',8.65),('7643','2013-10-20','14:50:00',8.41),('7643','2013-10-20','14:55:00',8.36),('7643','2013-10-20','15:00:00',8.53),('7643','2013-10-20','15:05:00',8.46),('7643','2013-10-20','15:10:00',8.07),('7643','2013-10-20','15:15:00',7.97),('7643','2013-10-20','15:20:00',7.85),('7643','2013-10-20','15:25:00',7.56),('7643','2013-10-20','15:30:00',7.3),('7643','2013-10-20','15:35:00',6.86),('7643','2013-10-20','15:40:00',6.85),('7643','2013-10-20','15:45:00',6.59),('7643','2013-10-20','15:50:00',6.33),('7643','2013-10-20','15:55:00',6.15),('7643','2013-10-20','16:00:00',5.93),('7643','2013-10-20','16:05:00',5.62),('7643','2013-10-20','16:10:00',5.47),('7643','2013-10-20','16:15:00',5.16),('7643','2013-10-20','16:20:00',4.83),('7643','2013-10-20','16:25:00',4.58),('7643','2013-10-20','16:30:00',4.3),('7643','2013-10-20','16:35:00',3.98),('7643','2013-10-20','16:40:00',3.66),('7643','2013-10-20','16:45:00',3.4),('7643','2013-10-20','16:50:00',3.11),('7643','2013-10-20','16:55:00',2.73),('7643','2013-10-20','17:00:00',2.51),('7643','2013-10-20','17:05:00',2.25),('7643','2013-10-20','17:10:00',2.18),('7643','2013-10-20','17:15:00',1.96),('7643','2013-10-20','17:20:00',1.6),('7643','2013-10-20','17:25:00',1.44),('7643','2013-10-20','17:30:00',1.27),('7643','2013-10-20','17:35:00',1.04),('7643','2013-10-19','08:15:00',1.29),('7643','2013-10-19','08:20:00',2.01),('7643','2013-10-19','08:25:00',2.44),('7643','2013-10-19','08:30:00',2.75),('7643','2013-10-19','08:35:00',2.98),('7643','2013-10-19','08:40:00',3.19),('7643','2013-10-19','08:45:00',3.44),('7643','2013-10-19','08:50:00',3.74),('7643','2013-10-19','08:55:00',4.04),('7643','2013-10-19','09:00:00',4.31),('7643','2013-10-19','09:05:00',4.5),('7643','2013-10-19','09:10:00',4.91),('7643','2013-10-19','09:15:00',5.18),('7643','2013-10-19','09:20:00',5.58),('7643','2013-10-19','09:25:00',5.84),('7643','2013-10-19','09:30:00',6.1),('7643','2013-10-19','09:35:00',6.34),('7643','2013-10-19','09:40:00',6.65),('7643','2013-10-19','09:45:00',6.94),('7643','2013-10-19','09:50:00',7.17),('7643','2013-10-19','09:55:00',7.28),('7643','2013-10-19','10:00:00',7.68),('7643','2013-10-19','10:05:00',7.93),('7643','2013-10-19','10:10:00',8.16),('7643','2013-10-19','10:15:00',8.41),('7643','2013-10-19','10:20:00',8.61),('7643','2013-10-19','10:25:00',8.8),('7643','2013-10-19','10:30:00',9.01),('7643','2013-10-19','10:35:00',9.21),('7643','2013-10-19','10:40:00',9.39),('7643','2013-10-19','10:45:00',9.51),('7643','2013-10-19','10:50:00',9.66),('7643','2013-10-19','10:55:00',9.86),('7643','2013-10-19','11:00:00',9.98),('7643','2013-10-19','11:05:00',10.17),('7643','2013-10-19','11:10:00',10.3),('7643','2013-10-19','11:15:00',10.44),('7643','2013-10-19','11:20:00',10.58),('7643','2013-10-19','11:25:00',10.71),('7643','2013-10-19','11:30:00',10.72),('7643','2013-10-19','11:35:00',10.82),('7643','2013-10-19','11:40:00',11),('7643','2013-10-19','11:45:00',10.94),('7643','2013-10-19','11:50:00',10.72),('7643','2013-10-19','11:55:00',11.08),('7643','2013-10-19','12:00:00',11.17),('7643','2013-10-19','12:05:00',11.39),('7643','2013-10-19','12:10:00',10.92),('7643','2013-10-19','12:15:00',4.14),('7643','2013-10-19','12:20:00',3.49),('7643','2013-10-19','12:25:00',9.41),('7643','2013-10-19','12:30:00',7.43),('7643','2013-10-19','12:35:00',13.31),('7643','2013-10-19','12:40:00',7.09),('7643','2013-10-19','12:45:00',10.37),('7643','2013-10-19','12:50:00',7.81),('7643','2013-10-19','12:55:00',8.13),('7643','2013-10-19','13:00:00',6.2),('7643','2013-10-19','13:05:00',6.19),('7643','2013-10-19','13:10:00',8.51),('7643','2013-10-19','13:15:00',7.62),('7643','2013-10-19','13:20:00',5.37),('7643','2013-10-19','13:25:00',7.79),('7643','2013-10-19','13:30:00',6.54),('7643','2013-10-19','13:35:00',4.09),('7643','2013-10-19','13:40:00',8.05),('7643','2013-10-19','13:45:00',6.99),('7643','2013-10-19','13:50:00',4.45),('7643','2013-10-19','13:55:00',4.5),('7643','2013-10-19','14:00:00',7.48),('7643','2013-10-19','14:05:00',3.47),('7643','2013-10-19','14:10:00',4.19),('7643','2013-10-19','14:15:00',6.26),('7643','2013-10-19','14:20:00',3.96),('7643','2013-10-19','14:25:00',2.01),('7643','2013-10-19','14:30:00',1.83),('7643','2013-10-19','14:35:00',1.8),('7643','2013-10-19','14:40:00',2.16),('7643','2013-10-19','14:45:00',2.57),('7643','2013-10-19','14:50:00',2.63),('7643','2013-10-19','14:55:00',2.38),('7643','2013-10-19','15:00:00',2.18),('7643','2013-10-19','15:05:00',1.97),('7643','2013-10-19','15:10:00',1.91),('7643','2013-10-19','15:15:00',1.93),('7643','2013-10-19','15:20:00',1.71),('7643','2013-10-19','15:25:00',1.61),('7643','2013-10-19','15:30:00',1.46),('7643','2013-10-19','15:35:00',1.45),('7643','2013-10-19','15:40:00',1.23),('7643','2013-10-19','15:45:00',1.4),('7643','2013-10-19','15:50:00',1.39),('7643','2013-10-19','15:55:00',1.41),('7643','2013-10-19','16:00:00',1.59),('7643','2013-10-19','16:05:00',1.39),('7643','2013-10-19','16:10:00',1.32),('7643','2013-10-19','16:15:00',1.3),('7643','2013-10-19','16:20:00',1.3),('7643','2013-10-19','16:25:00',1.55),('7643','2013-10-19','16:30:00',1.63),('7643','2013-10-19','16:35:00',1.59),('7643','2013-10-19','16:40:00',2.53),('7643','2013-10-19','16:45:00',3.82),('7643','2013-10-19','16:50:00',4.34),('7643','2013-10-19','16:55:00',4.42),('7643','2013-10-19','17:00:00',4.15),('7643','2013-10-19','17:05:00',3.82),('7643','2013-10-19','17:10:00',3),('7643','2013-10-19','17:15:00',2.46),('7643','2013-10-19','17:20:00',2.02),('7643','2013-10-19','17:25:00',1.62),('7643','2013-10-19','17:30:00',1.28),('7643','2013-10-18','08:15:00',1.36),('7643','2013-10-18','08:20:00',2.16),('7643','2013-10-18','08:25:00',2.47),('7643','2013-10-18','08:30:00',2.62),('7643','2013-10-18','08:35:00',3.28),('7643','2013-10-18','08:40:00',3.79),('7643','2013-10-18','08:45:00',3.89),('7643','2013-10-18','08:50:00',4.63),('7643','2013-10-18','08:55:00',3.47),('7643','2013-10-18','09:00:00',3.4),('7643','2013-10-18','09:05:00',4.22),('7643','2013-10-18','09:10:00',5.59),('7643','2013-10-18','09:15:00',6.55),('7643','2013-10-18','09:20:00',6.79),('7643','2013-10-18','09:25:00',6.91),('7643','2013-10-18','09:30:00',7.11),('7643','2013-10-18','09:35:00',7.32),('7643','2013-10-18','09:40:00',7.67),('7643','2013-10-18','09:45:00',7.95),('7643','2013-10-18','09:50:00',8.21),('7643','2013-10-18','09:55:00',8.74),('7643','2013-10-18','10:00:00',8.23),('7643','2013-10-18','10:05:00',8.33),('7643','2013-10-18','10:10:00',9.09),('7643','2013-10-18','10:15:00',8.51),('7643','2013-10-18','10:20:00',8.77),('7643','2013-10-18','10:25:00',10.22),('7643','2013-10-18','10:30:00',10.38),('7643','2013-10-18','10:35:00',10.42),('7643','2013-10-18','10:40:00',10.45),('7643','2013-10-18','10:45:00',10.26),('7643','2013-10-18','10:50:00',10.53),('7643','2013-10-18','10:55:00',10.78),('7643','2013-10-18','11:00:00',10.93),('7643','2013-10-18','11:05:00',10.9),('7643','2013-10-18','11:10:00',4.9),('7643','2013-10-18','11:15:00',4.5),('7643','2013-10-18','11:20:00',9.47),('7643','2013-10-18','11:25:00',10.54),('7643','2013-10-18','11:30:00',11.96),('7643','2013-10-18','11:35:00',12.2),('7643','2013-10-18','11:40:00',11.72),('7643','2013-10-18','11:45:00',12.21),('7643','2013-10-18','11:50:00',12.25),('7643','2013-10-18','11:55:00',11.73),('7643','2013-10-18','12:00:00',12.47),('7643','2013-10-18','12:05:00',12.43),('7643','2013-10-18','12:10:00',12.22),('7643','2013-10-18','12:15:00',12.2),('7643','2013-10-18','12:20:00',12.43),('7643','2013-10-18','12:25:00',11.43),('7643','2013-10-18','12:30:00',12.22),('7643','2013-10-18','12:35:00',12.49),('7643','2013-10-18','12:40:00',12.84),('7643','2013-10-18','12:45:00',12.97),('7643','2013-10-18','12:50:00',13.27),('7643','2013-10-18','12:55:00',13.19),('7643','2013-10-18','13:00:00',14.27),('7643','2013-10-18','13:05:00',12.38),('7643','2013-10-18','13:10:00',11.87),('7643','2013-10-18','13:15:00',11.76),('7643','2013-10-18','13:20:00',11.56),('7643','2013-10-18','13:25:00',12.38),('7643','2013-10-18','13:30:00',13.84),('7643','2013-10-18','13:35:00',9.9),('7643','2013-10-18','13:40:00',8.34),('7643','2013-10-18','13:45:00',7.07),('7643','2013-10-18','13:50:00',9.34),('7643','2013-10-18','13:55:00',12.04),('7643','2013-10-18','14:00:00',10.62),('7643','2013-10-18','14:05:00',9.02),('7643','2013-10-18','14:10:00',6.34),('7643','2013-10-18','14:15:00',9.03),('7643','2013-10-18','14:20:00',8.53),('7643','2013-10-18','14:25:00',6.55),('7643','2013-10-18','14:30:00',7.85),('7643','2013-10-18','14:35:00',11.5),('7643','2013-10-18','14:40:00',9.59),('7643','2013-10-18','14:45:00',7.41),('7643','2013-10-18','14:50:00',10.96),('7643','2013-10-18','14:55:00',10.57),('7643','2013-10-18','15:00:00',10.25),('7643','2013-10-18','15:05:00',9.8),('7643','2013-10-18','15:10:00',9.68),('7643','2013-10-18','15:15:00',9.48),('7643','2013-10-18','15:20:00',8.72),('7643','2013-10-18','15:25:00',8.39),('7643','2013-10-18','15:30:00',8.01),('7643','2013-10-18','15:35:00',7.87),('7643','2013-10-18','15:40:00',7.39),('7643','2013-10-18','15:45:00',6.45),('7643','2013-10-18','15:50:00',6.4),('7643','2013-10-18','15:55:00',7.3),('7643','2013-10-18','16:00:00',6.03),('7643','2013-10-18','16:05:00',6.35),('7643','2013-10-18','16:10:00',6.16),('7643','2013-10-18','16:15:00',6.32),('7643','2013-10-18','16:20:00',6.14),('7643','2013-10-18','16:25:00',4.24),('7643','2013-10-18','16:30:00',5.44),('7643','2013-10-18','16:35:00',5.49),('7643','2013-10-18','16:40:00',5.22),('7643','2013-10-18','16:45:00',4.98),('7643','2013-10-18','16:50:00',4.53),('7643','2013-10-18','16:55:00',2.09),('7643','2013-10-18','17:00:00',1.8),('7643','2013-10-18','17:05:00',1.91),('7643','2013-10-18','17:10:00',2.1),('7643','2013-10-18','17:15:00',1.46),('7643','2013-10-18','17:20:00',2.3),('7643','2013-10-18','17:25:00',1.67),('7643','2013-10-18','17:30:00',1.49),('7643','2013-10-18','17:35:00',1.21),('7643','2013-10-18','17:40:00',1),('7643','2014-05-03','07:10:00',1.97),('7643','2014-05-03','07:15:00',2.19),('7643','2014-05-03','07:20:00',2.31),('7643','2014-05-03','07:25:00',2.35),('7643','2014-05-03','07:35:00',1.72),('7643','2014-05-03','07:40:00',2.7),('7643','2014-05-03','07:45:00',4.04),('7643','2014-05-03','07:50:00',4.82),('7643','2014-05-03','07:55:00',5.33),('7643','2014-05-03','08:00:00',5.78),('7643','2014-05-03','08:05:00',6.27),('7643','2014-05-03','08:10:00',6.65),('7643','2014-05-03','08:15:00',7.1),('7643','2014-05-03','08:20:00',7.58),('7643','2014-05-03','08:25:00',7.94),('7643','2014-05-03','08:30:00',8.67),('7643','2014-05-03','08:35:00',8.41),('7643','2014-05-03','08:40:00',6.55),('7643','2014-05-03','08:45:00',3.72),('7643','2014-05-03','08:50:00',7.49),('7643','2014-05-03','08:55:00',5.76),('7643','2014-05-03','09:00:00',6.07),('7643','2014-05-03','09:05:00',8.81),('7643','2014-05-03','09:10:00',10.04),('7643','2014-05-03','09:15:00',8.62),('7643','2014-05-03','09:20:00',15.13),('7643','2014-05-03','09:25:00',12.9),('7643','2014-05-03','09:30:00',5.51),('7643','2014-05-03','09:35:00',5.12),('7643','2014-05-03','09:40:00',5.78),('7643','2014-05-03','09:45:00',8.44),('7643','2014-05-03','09:50:00',10.11),('7643','2014-05-03','09:55:00',9.19),('7643','2014-05-03','10:00:00',15.45),('7643','2014-05-03','10:05:00',16.14),('7643','2014-05-03','10:10:00',13.82),('7643','2014-05-03','10:15:00',10.36),('7643','2014-05-03','10:20:00',7.78),('7643','2014-05-03','10:25:00',7.75),('7643','2014-05-03','10:30:00',8.07),('7643','2014-05-03','10:35:00',8.4),('7643','2014-05-03','10:40:00',8.93),('7643','2014-05-03','10:45:00',10.99),('7643','2014-05-03','10:50:00',11.69),('7643','2014-05-03','10:55:00',12.12),('7643','2014-05-03','11:00:00',12.09),('7643','2014-05-03','11:05:00',12.87),('7643','2014-05-03','11:10:00',16.39),('7643','2014-05-03','11:15:00',14.57),('7643','2014-05-03','11:20:00',18.12),('7643','2014-05-03','11:25:00',14.4),('7643','2014-05-03','11:30:00',16.23),('7643','2014-05-03','11:35:00',16.39),('7643','2014-05-03','11:40:00',13.16),('7643','2014-05-03','11:45:00',18.19),('7643','2014-05-03','11:50:00',12),('7643','2014-05-03','11:55:00',14.73),('7643','2014-05-03','12:00:00',13.27),('7643','2014-05-03','12:05:00',13.96),('7643','2014-05-03','12:10:00',7.32),('7643','2014-05-03','12:15:00',6.25),('7643','2014-05-03','12:20:00',6.93),('7643','2014-05-03','12:25:00',6.94),('7643','2014-05-03','12:30:00',17.75),('7643','2014-05-03','12:35:00',16.72),('7643','2014-05-03','12:40:00',11.47),('7643','2014-05-03','12:45:00',13.82),('7643','2014-05-03','12:50:00',12.73),('7643','2014-05-03','12:55:00',9.52),('7643','2014-05-03','13:00:00',7.83),('7643','2014-05-03','13:05:00',7.74),('7643','2014-05-03','13:10:00',7.93),('7643','2014-05-03','13:15:00',7.44),('7643','2014-05-03','13:20:00',6.93),('7643','2014-05-03','13:25:00',5.97),('7643','2014-05-03','13:30:00',6.17),('7643','2014-05-03','13:35:00',6.62),('7643','2014-05-03','13:40:00',6.34),('7643','2014-05-03','13:45:00',5.59),('7643','2014-05-03','13:50:00',5.26),('7643','2014-05-03','13:55:00',5.35),('7643','2014-05-03','14:00:00',5.21),('7643','2014-05-03','14:05:00',5.32),('7643','2014-05-03','14:10:00',5.42),('7643','2014-05-03','14:15:00',5.22),('7643','2014-05-03','14:20:00',4.29),('7643','2014-05-03','14:25:00',3.15),('7643','2014-05-03','14:30:00',2.62),('7643','2014-05-03','14:35:00',2.6),('7643','2014-05-03','14:40:00',2.87),('7643','2014-05-03','14:45:00',3.26),('7643','2014-05-03','14:50:00',4.31),('7643','2014-05-03','14:55:00',6.09),('7643','2014-05-03','15:00:00',7.03),('7643','2014-05-03','15:05:00',11.27),('7643','2014-05-03','15:10:00',15.09),('7643','2014-05-03','15:15:00',12.47),('7643','2014-05-03','15:20:00',6.21),('7643','2014-05-03','15:25:00',5.47),('7643','2014-05-03','15:30:00',4.13),('7643','2014-05-03','15:35:00',3.03),('7643','2014-05-03','15:40:00',2.88),('7643','2014-05-03','15:45:00',3.56),('7643','2014-05-03','15:50:00',4.7),('7643','2014-05-03','15:55:00',4.91),('7643','2014-05-03','16:00:00',4),('7643','2014-05-03','16:05:00',4.21),('7643','2014-05-03','16:10:00',5.23),('7643','2014-05-03','16:15:00',5.14),('7643','2014-05-03','16:20:00',4.33),('7643','2014-05-03','16:25:00',3.49),('7643','2014-05-03','16:30:00',2.66),('7643','2014-05-03','16:35:00',2.18),('7643','2014-05-03','16:40:00',1.93),('7643','2014-05-03','16:45:00',1.83),('7643','2014-05-03','16:50:00',1.92),('7643','2014-05-03','16:55:00',2.07),('7643','2014-05-03','17:00:00',1.83),('7643','2014-05-03','17:05:00',1.51),('7643','2014-05-03','17:10:00',1.73),('7643','2014-05-03','17:15:00',2.17),('7643','2014-05-03','17:20:00',2.54),('7643','2014-05-03','17:25:00',3.68),('7643','2014-05-03','17:30:00',3.53),('7643','2014-05-03','17:35:00',3.44),('7643','2014-05-03','17:40:00',3.81),('7643','2014-05-03','17:45:00',2.87),('7643','2014-05-03','17:50:00',2.37),('7643','2014-05-03','17:55:00',1.88),('7643','2014-05-03','18:00:00',2.04),('7643','2014-05-03','18:05:00',2.55),('7643','2014-05-03','18:10:00',2.21),('7643','2014-05-03','18:15:00',1.62),('7643','2014-05-03','18:20:00',1.57),('7643','2014-05-03','18:25:00',1.66),('7643','2014-05-03','18:30:00',1.17),('7643','2014-04-15','07:15:00',1.2),('7643','2014-04-15','07:20:00',1.54),('7643','2014-04-15','07:25:00',1.82),('7643','2014-04-15','07:30:00',2.01),('7643','2014-04-15','07:35:00',1.6),('7643','2014-04-15','07:40:00',1.51),('7643','2014-04-15','07:45:00',3.19),('7643','2014-04-15','07:50:00',3.52),('7643','2014-04-15','07:55:00',4.1),('7643','2014-04-15','08:00:00',4.49),('7643','2014-04-15','08:05:00',4.88),('7643','2014-04-15','08:10:00',5.31),('7643','2014-04-15','08:15:00',5.79),('7643','2014-04-15','08:20:00',6.26),('7643','2014-04-15','08:25:00',6.76),('7643','2014-04-15','08:30:00',5.08),('7643','2014-04-15','08:35:00',4),('7643','2014-04-15','08:40:00',4.33),('7643','2014-04-15','08:45:00',7.38),('7643','2014-04-15','08:50:00',8.41),('7643','2014-04-15','08:55:00',8.9),('7643','2014-04-15','09:00:00',9.25),('7643','2014-04-15','09:05:00',9.64),('7643','2014-04-15','09:10:00',9.96),('7643','2014-04-15','09:15:00',10.19),('7643','2014-04-15','09:20:00',10.54),('7643','2014-04-15','09:25:00',11.04),('7643','2014-04-15','09:30:00',9.41),('7643','2014-04-15','09:35:00',3.36),('7643','2014-04-15','09:40:00',3.06),('7643','2014-04-15','09:45:00',3.38),('7643','2014-04-15','09:50:00',8.18),('7643','2014-04-15','09:55:00',13.97),('7643','2014-04-15','10:00:00',13.44),('7643','2014-04-15','10:05:00',13.54),('7643','2014-04-15','10:10:00',13.87),('7643','2014-04-15','10:15:00',14.19),('7643','2014-04-15','10:20:00',14.47),('7643','2014-04-15','10:25:00',14.69),('7643','2014-04-15','10:30:00',14.87),('7643','2014-04-15','10:35:00',15.09),('7643','2014-04-15','10:40:00',15.32),('7643','2014-04-15','10:45:00',15.62),('7643','2014-04-15','10:50:00',16.15),('7643','2014-04-15','10:55:00',14.85),('7643','2014-04-15','11:00:00',15.8),('7643','2014-04-15','11:05:00',12.52),('7643','2014-04-15','11:10:00',5.86),('7643','2014-04-15','11:15:00',8.83),('7643','2014-04-15','11:20:00',15.67),('7643','2014-04-15','11:25:00',14.03),('7643','2014-04-15','11:30:00',14.51),('7643','2014-04-15','11:35:00',12.49),('7643','2014-04-15','11:40:00',14.11),('7643','2014-04-15','11:45:00',16.18),('7643','2014-04-15','11:50:00',18.49),('7643','2014-04-15','11:55:00',18.67),('7643','2014-04-15','12:00:00',19),('7643','2014-04-15','12:05:00',11.91),('7643','2014-04-15','12:10:00',13.36),('7643','2014-04-15','12:15:00',9.02),('7643','2014-04-15','12:20:00',15.95),('7643','2014-04-15','12:25:00',6.4),('7643','2014-04-15','12:30:00',8.18),('7643','2014-04-15','12:35:00',17.75),('7643','2014-04-15','12:40:00',19.2),('7643','2014-04-15','12:45:00',18.71),('7643','2014-04-15','12:50:00',17.89),('7643','2014-04-15','12:55:00',12.44),('7643','2014-04-15','13:00:00',9.59),('7643','2014-04-15','13:05:00',4.09),('7643','2014-04-15','13:10:00',2.78),('7643','2014-04-15','13:15:00',3.09),('7643','2014-04-15','13:20:00',5.67),('7643','2014-04-15','13:25:00',4.12),('7643','2014-04-15','13:30:00',3.41),('7643','2014-04-15','13:35:00',5.43),('7643','2014-04-15','13:40:00',9.92),('7643','2014-04-15','13:45:00',17.24),('7643','2014-04-15','13:50:00',15.89),('7643','2014-04-15','13:55:00',12.62),('7643','2014-04-15','14:00:00',6.93),('7643','2014-04-15','14:05:00',10.25),('7643','2014-04-15','14:10:00',17.84),('7643','2014-04-15','14:15:00',19.7),('7643','2014-04-15','14:20:00',18.5),('7643','2014-04-15','14:25:00',14.02),('7643','2014-04-15','14:30:00',15.5),('7643','2014-04-15','14:35:00',17.51),('7643','2014-04-15','14:40:00',17.17),('7643','2014-04-15','14:45:00',14.89),('7643','2014-04-15','14:50:00',16.94),('7643','2014-04-15','14:55:00',7.58),('7643','2014-04-15','15:00:00',6.49),('7643','2014-04-15','15:05:00',12.47),('7643','2014-04-15','15:10:00',19.28),('7643','2014-04-15','15:15:00',12.68),('7643','2014-04-15','15:20:00',2.26),('7643','2014-04-15','15:25:00',4.59),('7643','2014-04-15','15:30:00',12.41),('7643','2014-04-15','15:35:00',16.65),('7643','2014-04-15','15:40:00',16.1),('7643','2014-04-15','15:45:00',15.31),('7643','2014-04-15','15:50:00',14.87),('7643','2014-04-15','15:55:00',14.46),('7643','2014-04-15','16:00:00',13.92),('7643','2014-04-15','16:05:00',13.53),('7643','2014-04-15','16:10:00',13.23),('7643','2014-04-15','16:15:00',12.98),('7643','2014-04-15','16:20:00',12.54),('7643','2014-04-15','16:25:00',12.37),('7643','2014-04-15','16:30:00',12.15),('7643','2014-04-15','16:35:00',11.87),('7643','2014-04-15','16:40:00',11.54),('7643','2014-04-15','16:45:00',11.28),('7643','2014-04-15','16:50:00',10.84),('7643','2014-04-15','16:55:00',10.44),('7643','2014-04-15','17:00:00',10.12),('7643','2014-04-15','17:05:00',9.73),('7643','2014-04-15','17:10:00',9.35),('7643','2014-04-15','17:15:00',9.13),('7643','2014-04-15','17:20:00',8.59),('7643','2014-04-15','17:25:00',8.12),('7643','2014-04-15','17:30:00',7.82),('7643','2014-04-15','17:35:00',7.55),('7643','2014-04-15','17:40:00',7.06),('7643','2014-04-15','17:45:00',6.76),('7643','2014-04-15','17:50:00',6.76),('7643','2014-04-15','17:55:00',6.73),('7643','2014-04-15','18:00:00',5.97),('7643','2014-04-15','18:05:00',5.5),('7643','2014-04-15','18:10:00',4.97),('7643','2014-04-15','18:15:00',4.27),('7643','2014-04-15','18:20:00',4.15),('7643','2014-04-15','18:25:00',3.49),('7643','2014-04-15','18:30:00',3),('7643','2014-04-15','18:35:00',2.56),('7643','2014-04-15','18:40:00',2.62),('7643','2014-04-15','18:45:00',2.75),('7643','2014-04-15','18:50:00',2.67),('7643','2014-04-15','18:55:00',2.15),('7643','2014-04-15','19:00:00',1.21),('7643','2014-04-15','19:05:00',1.18),('7643','2013-10-17','07:55:00',1.09),('7643','2013-10-17','08:00:00',1.4),('7643','2013-10-17','08:05:00',1.71),('7643','2013-10-17','08:10:00',1.99),('7643','2013-10-17','08:15:00',2.12),('7643','2013-10-17','08:20:00',2.32),('7643','2013-10-17','08:25:00',2.64),('7643','2013-10-17','08:30:00',2.63),('7643','2013-10-17','08:35:00',3.07),('7643','2013-10-17','08:40:00',3.5),('7643','2013-10-17','08:45:00',3.92),('7643','2013-10-17','08:50:00',4.09),('7643','2013-10-17','08:55:00',4.26),('7643','2013-10-17','09:00:00',4.78),('7643','2013-10-17','09:05:00',5.33),('7643','2013-10-17','09:10:00',5.72),('7643','2013-10-17','09:15:00',5.91),('7643','2013-10-17','09:20:00',6.44),('7643','2013-10-17','09:25:00',6.64),('7643','2013-10-17','09:30:00',7.01),('7643','2013-10-17','09:35:00',7.33),('7643','2013-10-17','09:40:00',7.65),('7643','2013-10-17','09:45:00',7.91),('7643','2013-10-17','09:50:00',8.13),('7643','2013-10-17','09:55:00',8.43),('7643','2013-10-17','10:00:00',8.62),('7643','2013-10-17','10:05:00',8.85),('7643','2013-10-17','10:10:00',9.05),('7643','2013-10-17','10:15:00',9.24),('7643','2013-10-17','10:20:00',9.37),('7643','2013-10-17','10:25:00',9.65),('7643','2013-10-17','10:30:00',9.92),('7643','2013-10-17','10:35:00',10.13),('7643','2013-10-17','10:40:00',10.33),('7643','2013-10-17','10:45:00',10.43),('7643','2013-10-17','10:50:00',10.61),('7643','2013-10-17','10:55:00',10.73),('7643','2013-10-17','11:00:00',10.74),('7643','2013-10-17','11:05:00',10.47),('7643','2013-10-17','11:10:00',10.43),('7643','2013-10-17','11:15:00',10.47),('7643','2013-10-17','11:20:00',11.44),('7643','2013-10-17','11:25:00',11.19),('7643','2013-10-17','11:30:00',11.41),('7643','2013-10-17','11:35:00',11.57),('7643','2013-10-17','11:40:00',11.93),('7643','2013-10-17','11:45:00',8.64),('7643','2013-10-17','11:50:00',11.5),('7643','2013-10-17','11:55:00',12.11),('7643','2013-10-17','12:00:00',11.79),('7643','2013-10-17','12:05:00',11.96),('7643','2013-10-17','12:10:00',12),('7643','2013-10-17','12:15:00',11.91),('7643','2013-10-17','12:20:00',11.73),('7643','2013-10-17','12:25:00',11.93),('7643','2013-10-17','12:30:00',12.1),('7643','2013-10-17','12:35:00',11.86),('7643','2013-10-17','12:40:00',11.97),('7643','2013-10-17','12:45:00',11.72),('7643','2013-10-17','12:50:00',11.7),('7643','2013-10-17','12:55:00',11.97),('7643','2013-10-17','13:00:00',11.83),('7643','2013-10-17','13:05:00',11.6),('7643','2013-10-17','13:10:00',11.01),('7643','2013-10-17','13:15:00',11.48),('7643','2013-10-17','13:20:00',11.63),('7643','2013-10-17','13:25:00',11.87),('7643','2013-10-17','13:30:00',11.88),('7643','2013-10-17','13:35:00',11.74),('7643','2013-10-17','13:40:00',11.6),('7643','2013-10-17','13:45:00',11.35),('7643','2013-10-17','13:50:00',11.32),('7643','2013-10-17','13:55:00',11.37),('7643','2013-10-17','14:00:00',10.65),('7643','2013-10-17','14:05:00',10.63),('7643','2013-10-17','14:10:00',10.58),('7643','2013-10-17','14:15:00',10.84),('7643','2013-10-17','14:20:00',10.7),('7643','2013-10-17','14:25:00',10.56),('7643','2013-10-17','14:30:00',10.53),('7643','2013-10-17','14:35:00',10),('7643','2013-10-17','14:40:00',10.06),('7643','2013-10-17','14:45:00',9.68),('7643','2013-10-17','14:50:00',9.36),('7643','2013-10-17','14:55:00',9.55),('7643','2013-10-17','15:00:00',8.26),('7643','2013-10-17','15:05:00',7.49),('7643','2013-10-17','15:10:00',8.34),('7643','2013-10-17','15:15:00',8.3),('7643','2013-10-17','15:20:00',8.53),('7643','2013-10-17','15:25:00',8.11),('7643','2013-10-17','15:30:00',7.64),('7643','2013-10-17','15:35:00',7.67),('7643','2013-10-17','15:40:00',7.27),('7643','2013-10-17','15:45:00',6.74),('7643','2013-10-17','15:50:00',6.45),('7643','2013-10-17','15:55:00',5.86),('7643','2013-10-17','16:00:00',6.29),('7643','2013-10-17','16:05:00',5.84),('7643','2013-10-17','16:10:00',5.66),('7643','2013-10-17','16:15:00',5.09),('7643','2013-10-17','16:20:00',4.84),('7643','2013-10-17','16:25:00',4.24),('7643','2013-10-17','16:30:00',3.81),('7643','2013-10-17','16:35:00',3.64),('7643','2013-10-17','16:40:00',2.87),('7643','2013-10-17','16:45:00',2.71),('7643','2013-10-17','16:50:00',2.29),('7643','2013-10-17','16:55:00',2.87),('7643','2013-10-17','17:00:00',2.24),('7643','2013-10-17','17:05:00',2.03),('7643','2013-10-17','17:10:00',2.16),('7643','2013-10-17','17:15:00',1.83),('7643','2013-10-17','17:20:00',1.73),('7643','2013-10-17','17:25:00',1.4),('7643','2013-10-17','17:30:00',1.04),('7643','2013-10-16','08:00:00',1.25),('7643','2013-10-16','08:05:00',1.5),('7643','2013-10-16','08:10:00',1.81),('7643','2013-10-16','08:15:00',2.13),('7643','2013-10-16','08:20:00',2.47),('7643','2013-10-16','08:25:00',2.8),('7643','2013-10-16','08:30:00',3.13),('7643','2013-10-16','08:35:00',3.48),('7643','2013-10-16','08:40:00',3.81),('7643','2013-10-16','08:45:00',4.14),('7643','2013-10-16','08:50:00',4.49),('7643','2013-10-16','08:55:00',4.82),('7643','2013-10-16','09:00:00',5.14),('7643','2013-10-16','09:05:00',5.51),('7643','2013-10-16','09:10:00',5.81),('7643','2013-10-16','09:15:00',6.14),('7643','2013-10-16','09:20:00',6.45),('7643','2013-10-16','09:25:00',6.76),('7643','2013-10-16','09:30:00',7.06),('7643','2013-10-16','09:35:00',7.35),('7643','2013-10-16','09:40:00',7.61),('7643','2013-10-16','09:45:00',7.87),('7643','2013-10-16','09:50:00',8.15),('7643','2013-10-16','09:55:00',8.38),('7643','2013-10-16','10:00:00',8.61),('7643','2013-10-16','10:05:00',8.79),('7643','2013-10-16','10:10:00',8.99),('7643','2013-10-16','10:15:00',9.24),('7643','2013-10-16','10:20:00',9.51),('7643','2013-10-16','10:25:00',9.73),('7643','2013-10-16','10:30:00',9.97),('7643','2013-10-16','10:35:00',10.2),('7643','2013-10-16','10:40:00',10.4),('7643','2013-10-16','10:45:00',10.58),('7643','2013-10-16','10:50:00',10.79),('7643','2013-10-16','10:55:00',10.95),('7643','2013-10-16','11:00:00',11.14),('7643','2013-10-16','11:05:00',11.26),('7643','2013-10-16','11:10:00',11.38),('7643','2013-10-16','11:15:00',11.52),('7643','2013-10-16','11:20:00',11.59),('7643','2013-10-16','11:25:00',11.7),('7643','2013-10-16','11:30:00',11.84),('7643','2013-10-16','11:35:00',12),('7643','2013-10-16','11:40:00',12.16),('7643','2013-10-16','11:45:00',12.19),('7643','2013-10-16','11:50:00',12.25),('7643','2013-10-16','11:55:00',12.32),('7643','2013-10-16','12:00:00',12.35),('7643','2013-10-16','12:05:00',12.36),('7643','2013-10-16','12:10:00',12.45),('7643','2013-10-16','12:15:00',12.49),('7643','2013-10-16','12:20:00',12.49),('7643','2013-10-16','12:25:00',12.56),('7643','2013-10-16','12:30:00',12.54),('7643','2013-10-16','12:35:00',12.61),('7643','2013-10-16','12:40:00',12.68),('7643','2013-10-16','12:45:00',12.66),('7643','2013-10-16','12:50:00',12.63),('7643','2013-10-16','12:55:00',12.63),('7643','2013-10-16','13:00:00',12.62),('7643','2013-10-16','13:05:00',12.62),('7643','2013-10-16','13:10:00',12.46),('7643','2013-10-16','13:15:00',12.38),('7643','2013-10-16','13:20:00',12.44),('7643','2013-10-16','13:25:00',12.37),('7643','2013-10-16','13:30:00',12.22),('7643','2013-10-16','13:35:00',12.23),('7643','2013-10-16','13:40:00',12.1),('7643','2013-10-16','13:45:00',12.04),('7643','2013-10-16','13:50:00',12),('7643','2013-10-16','13:55:00',11.98),('7643','2013-10-16','14:00:00',11.86),('7643','2013-10-16','14:05:00',11.72),('7643','2013-10-16','14:10:00',11.58),('7643','2013-10-16','14:15:00',11.5),('7643','2013-10-16','14:20:00',11.39),('7643','2013-10-16','14:25:00',11.28),('7643','2013-10-16','14:30:00',11.11),('7643','2013-10-16','14:35:00',10.86),('7643','2013-10-16','14:40:00',10.72),('7643','2013-10-16','14:45:00',10.59),('7643','2013-10-16','14:50:00',10.4),('7643','2013-10-16','14:55:00',10.24),('7643','2013-10-16','15:00:00',10.02),('7643','2013-10-16','15:05:00',9.8),('7643','2013-10-16','15:10:00',9.57),('7643','2013-10-16','15:15:00',9.42),('7643','2013-10-16','15:20:00',9.23),('7643','2013-10-16','15:25:00',9),('7643','2013-10-16','15:30:00',8.75),('7643','2013-10-16','15:35:00',8.45),('7643','2013-10-16','15:40:00',8.18),('7643','2013-10-16','15:45:00',7.93),('7643','2013-10-16','15:50:00',7.66),('7643','2013-10-16','15:55:00',7.38),('7643','2013-10-16','16:00:00',7.1),('7643','2013-10-16','16:05:00',6.75),('7643','2013-10-16','16:10:00',6.54),('7643','2013-10-16','16:15:00',6.27),('7643','2013-10-16','16:20:00',6),('7643','2013-10-16','16:25:00',5.73),('7643','2013-10-16','16:30:00',5.42),('7643','2013-10-16','16:35:00',5.09),('7643','2013-10-16','16:40:00',4.76),('7643','2013-10-16','16:45:00',4.42),('7643','2013-10-16','16:50:00',4.08),('7643','2013-10-16','16:55:00',3.76),('7643','2013-10-16','17:00:00',3.44),('7643','2013-10-16','17:05:00',3.14),('7643','2013-10-16','17:10:00',2.83),('7643','2013-10-16','17:15:00',2.52),('7643','2013-10-16','17:20:00',2.19),('7643','2013-10-16','17:25:00',1.89),('7643','2013-10-16','17:30:00',1.6),('7643','2013-10-16','17:35:00',1.33),('7643','2013-10-16','17:40:00',1.08),('7643','2013-10-15','07:50:00',1.07),('7643','2013-10-15','07:55:00',1.26),('7643','2013-10-15','08:00:00',1.41),('7643','2013-10-15','08:30:00',1.61),('7643','2013-10-15','08:35:00',1.48),('7643','2013-10-15','09:00:00',1.07),('7643','2013-10-15','09:05:00',1.2),('7643','2013-10-15','09:10:00',1.14),('7643','2013-10-15','09:15:00',1.41),('7643','2013-10-15','09:20:00',1.54),('7643','2013-10-15','09:25:00',1.17),('7643','2013-10-15','09:30:00',1.29),('7643','2013-10-15','09:35:00',1.83),('7643','2013-10-15','09:40:00',2.1),('7643','2013-10-15','09:45:00',4.92),('7643','2013-10-15','09:50:00',7.32),('7643','2013-10-15','09:55:00',3.06),('7643','2013-10-15','10:00:00',2.94),('7643','2013-10-15','10:05:00',1.84),('7643','2013-10-15','10:15:00',1.24),('7643','2013-10-15','11:05:00',2.48),('7643','2013-10-15','11:10:00',3.12),('7643','2013-10-15','11:15:00',4.56),('7643','2013-10-15','11:20:00',3.87),('7643','2013-10-15','11:25:00',2.24),('7643','2013-10-15','11:30:00',1.97),('7643','2013-10-15','11:35:00',1.23),('7643','2013-10-15','11:50:00',1.38),('7643','2013-10-15','11:55:00',3.86),('7643','2013-10-15','12:00:00',3.6),('7643','2013-10-15','12:05:00',1.26),('7643','2013-10-15','12:10:00',3.02),('7643','2013-10-15','12:15:00',9.41),('7643','2013-10-15','12:20:00',10.99),('7643','2013-10-15','12:25:00',3.63),('7643','2013-10-15','12:30:00',4.39),('7643','2013-10-15','12:35:00',6.21),('7643','2013-10-15','12:40:00',13.2),('7643','2013-10-15','12:45:00',12.39),('7643','2013-10-15','12:50:00',11.89),('7643','2013-10-15','12:55:00',10.48),('7643','2013-10-15','13:00:00',11.13),('7643','2013-10-15','13:05:00',12.27),('7643','2013-10-15','13:10:00',9.43),('7643','2013-10-15','13:15:00',12.51),('7643','2013-10-15','13:20:00',13.18),('7643','2013-10-15','13:25:00',11.75),('7643','2013-10-15','13:30:00',13.25),('7643','2013-10-15','13:35:00',12.63),('7643','2013-10-15','13:40:00',12.38),('7643','2013-10-15','13:45:00',12.37),('7643','2013-10-15','13:50:00',11.68),('7643','2013-10-15','13:55:00',12.74),('7643','2013-10-15','14:00:00',10.79),('7643','2013-10-15','14:05:00',7.19),('7643','2013-10-15','14:10:00',13.24),('7643','2013-10-15','14:15:00',12.6),('7643','2013-10-15','14:20:00',9.71),('7643','2013-10-15','14:25:00',12.62),('7643','2013-10-15','14:30:00',12.24),('7643','2013-10-15','14:35:00',10.89),('7643','2013-10-15','14:40:00',11.11),('7643','2013-10-15','14:45:00',11.28),('7643','2013-10-15','14:50:00',7.03),('7643','2013-10-15','14:55:00',10.73),('7643','2013-10-15','15:00:00',10.86),('7643','2013-10-15','15:05:00',7.87),('7643','2013-10-15','15:10:00',8.14),('7643','2013-10-15','15:15:00',9.35),('7643','2013-10-15','15:20:00',8.07),('7643','2013-10-15','15:25:00',8.56),('7643','2013-10-15','15:30:00',2.81),('7643','2013-10-15','15:35:00',3.32),('7643','2013-10-15','15:40:00',8.96),('7643','2013-10-15','15:45:00',8.24),('7643','2013-10-15','15:50:00',7.78),('7643','2013-10-15','15:55:00',7.52),('7643','2013-10-15','16:00:00',7.21),('7643','2013-10-15','16:05:00',6.98),('7643','2013-10-15','16:10:00',6.54),('7643','2013-10-15','16:15:00',5.97),('7643','2013-10-15','16:20:00',5.99),('7643','2013-10-15','16:25:00',5.63),('7643','2013-10-15','16:30:00',5.27),('7643','2013-10-15','16:35:00',4.16),('7643','2013-10-15','16:40:00',4.87),('7643','2013-10-15','16:45:00',4.44),('7643','2013-10-15','16:50:00',4.16),('7643','2013-10-15','16:55:00',3.86),('7643','2013-10-15','17:00:00',3.5),('7643','2013-10-15','17:05:00',3.19),('7643','2013-10-15','17:10:00',2.88),('7643','2013-10-15','17:15:00',2.56),('7643','2013-10-15','17:20:00',2.3),('7643','2013-10-15','17:25:00',2.09),('7643','2013-10-15','17:30:00',1.83),('7643','2013-10-15','17:35:00',1.72),('7643','2013-10-15','17:40:00',2.12),('7643','2013-10-15','17:45:00',2.13),('7643','2013-10-15','17:50:00',1.65),('7643','2013-10-14','08:00:00',1.21),('7643','2013-10-14','08:05:00',1.37),('7643','2013-10-14','08:10:00',1.25),('7643','2013-10-14','08:15:00',1.35),('7643','2013-10-14','08:20:00',1.62),('7643','2013-10-14','08:25:00',1.81),('7643','2013-10-14','08:30:00',1.96),('7643','2013-10-14','08:35:00',2.03),('7643','2013-10-14','08:40:00',2),('7643','2013-10-14','08:45:00',1.96),('7643','2013-10-14','08:50:00',1.85),('7643','2013-10-14','08:55:00',2.08),('7643','2013-10-14','09:00:00',2.67),('7643','2013-10-14','09:05:00',3.4),('7643','2013-10-14','09:10:00',3.65),('7643','2013-10-14','09:15:00',3.38),('7643','2013-10-14','09:20:00',3.81),('7643','2013-10-14','09:25:00',3.97),('7643','2013-10-14','09:30:00',6.02),('7643','2013-10-14','09:35:00',3.71),('7643','2013-10-14','09:40:00',5.44),('7643','2013-10-14','09:45:00',6.98),('7643','2013-10-14','09:50:00',7.87),('7643','2013-10-14','09:55:00',8.19),('7643','2013-10-14','10:00:00',8.32),('7643','2013-10-14','10:05:00',9.18),('7643','2013-10-14','10:10:00',7.14),('7643','2013-10-14','10:15:00',4.39),('7643','2013-10-14','10:20:00',4.38),('7643','2013-10-14','10:25:00',5.04),('7643','2013-10-14','10:30:00',7.63),('7643','2013-10-14','10:35:00',6.02),('7643','2013-10-14','10:40:00',7.05),('7643','2013-10-14','10:45:00',8.24),('7643','2013-10-14','10:50:00',8.4),('7643','2013-10-14','10:55:00',7.08),('7643','2013-10-14','11:00:00',7.05),('7643','2013-10-14','11:05:00',7.38),('7643','2013-10-14','11:10:00',9.6),('7643','2013-10-14','11:15:00',10.64),('7643','2013-10-14','11:20:00',10.7),('7643','2013-10-14','11:25:00',9.99),('7643','2013-10-14','11:30:00',10.42),('7643','2013-10-14','11:35:00',8.76),('7643','2013-10-14','11:40:00',7.01),('7643','2013-10-14','11:45:00',5.48),('7643','2013-10-14','11:50:00',5.17),('7643','2013-10-14','11:55:00',5.14),('7643','2013-10-14','12:00:00',5.37),('7643','2013-10-14','12:05:00',5.4),('7643','2013-10-14','12:10:00',5.6),('7643','2013-10-14','12:15:00',5.52),('7643','2013-10-14','12:20:00',5.8),('7643','2013-10-14','12:25:00',5.35),('7643','2013-10-14','12:30:00',4.83),('7643','2013-10-14','12:35:00',4.66),('7643','2013-10-14','12:40:00',4.66),('7643','2013-10-14','12:45:00',4.96),('7643','2013-10-14','12:50:00',4.67),('7643','2013-10-14','12:55:00',4.23),('7643','2013-10-14','13:00:00',4.21),('7643','2013-10-14','13:05:00',5.55),('7643','2013-10-14','13:10:00',6.68),('7643','2013-10-14','13:15:00',6.73),('7643','2013-10-14','13:20:00',9.57),('7643','2013-10-14','13:25:00',11.34),('7643','2013-10-14','13:30:00',7.34),('7643','2013-10-14','13:35:00',6.07),('7643','2013-10-14','13:40:00',5.63),('7643','2013-10-14','13:45:00',5.81),('7643','2013-10-14','13:50:00',5.21),('7643','2013-10-14','13:55:00',4.65),('7643','2013-10-14','14:00:00',4.14),('7643','2013-10-14','14:05:00',4.06),('7643','2013-10-14','14:10:00',4.5),('7643','2013-10-14','14:15:00',6.17),('7643','2013-10-14','14:20:00',7.27),('7643','2013-10-14','14:25:00',7.98),('7643','2013-10-14','14:30:00',8.11),('7643','2013-10-14','14:35:00',5.16),('7643','2013-10-14','14:40:00',5.62),('7643','2013-10-14','14:45:00',6.5),('7643','2013-10-14','14:50:00',9.32),('7643','2013-10-14','14:55:00',7.56),('7643','2013-10-14','15:00:00',4.77),('7643','2013-10-14','15:05:00',4.75),('7643','2013-10-14','15:10:00',4.99),('7643','2013-10-14','15:15:00',4.58),('7643','2013-10-14','15:20:00',4.14),('7643','2013-10-14','15:25:00',3.64),('7643','2013-10-14','15:30:00',3.47),('7643','2013-10-14','15:35:00',3.61),('7643','2013-10-14','15:40:00',3.78),('7643','2013-10-14','15:45:00',3.66),('7643','2013-10-14','15:50:00',3.22),('7643','2013-10-14','15:55:00',2.8),('7643','2013-10-14','16:00:00',2.55),('7643','2013-10-14','16:05:00',2.57),('7643','2013-10-14','16:10:00',2.66),('7643','2013-10-14','16:15:00',2.51),('7643','2013-10-14','16:20:00',2.26),('7643','2013-10-14','16:25:00',3.02),('7643','2013-10-14','16:30:00',4.01),('7643','2013-10-14','16:35:00',4.22),('7643','2013-10-14','16:40:00',3.36),('7643','2013-10-14','16:45:00',2.96),('7643','2013-10-14','16:50:00',2.23),('7643','2013-10-14','16:55:00',2.22),('7643','2013-10-14','17:00:00',2.22),('7643','2013-10-14','17:05:00',2.05),('7643','2013-10-14','17:10:00',1.82),('7643','2013-10-14','17:15:00',1.35),('7643','2013-10-13','07:55:00',1.05),('7643','2013-10-13','08:00:00',1.4),('7643','2013-10-13','08:05:00',1.81),('7643','2013-10-13','08:10:00',2.01),('7643','2013-10-13','08:15:00',1.86),('7643','2013-10-13','08:20:00',2.5),('7643','2013-10-13','08:25:00',3.18),('7643','2013-10-13','08:30:00',3.37),('7643','2013-10-13','08:35:00',3.78),('7643','2013-10-13','08:40:00',3.43),('7643','2013-10-13','08:45:00',4.28),('7643','2013-10-13','08:50:00',4.01),('7643','2013-10-13','08:55:00',4.57),('7643','2013-10-13','09:00:00',4.17),('7643','2013-10-13','09:05:00',4.34),('7643','2013-10-13','09:10:00',4.06),('7643','2013-10-13','09:15:00',2.97),('7643','2013-10-13','09:20:00',3.97),('7643','2013-10-13','09:25:00',5.98),('7643','2013-10-13','09:30:00',6.85),('7643','2013-10-13','09:35:00',6.48),('7643','2013-10-13','09:40:00',5.71),('7643','2013-10-13','09:45:00',5.12),('7643','2013-10-13','09:50:00',6.04),('7643','2013-10-13','09:55:00',7.44),('7643','2013-10-13','10:00:00',7.21),('7643','2013-10-13','10:05:00',7.96),('7643','2013-10-13','10:10:00',8.27),('7643','2013-10-13','10:15:00',8.98),('7643','2013-10-13','10:20:00',9.09),('7643','2013-10-13','10:25:00',9.25),('7643','2013-10-13','10:30:00',9.39),('7643','2013-10-13','10:35:00',9.46),('7643','2013-10-13','10:40:00',9.42),('7643','2013-10-13','10:45:00',9.65),('7643','2013-10-13','10:50:00',10.07),('7643','2013-10-13','10:55:00',10.3),('7643','2013-10-13','11:00:00',10.5),('7643','2013-10-13','11:05:00',10.48),('7643','2013-10-13','11:10:00',10.95),('7643','2013-10-13','11:15:00',10.94),('7643','2013-10-13','11:20:00',10.92),('7643','2013-10-13','11:25:00',11.15),('7643','2013-10-13','11:30:00',11.44),('7643','2013-10-13','11:35:00',11.14),('7643','2013-10-13','11:40:00',11.3),('7643','2013-10-13','11:45:00',11.3),('7643','2013-10-13','11:50:00',11.32),('7643','2013-10-13','11:55:00',11.45),('7643','2013-10-13','12:00:00',11.56),('7643','2013-10-13','12:05:00',11.64),('7643','2013-10-13','12:10:00',11.85),('7643','2013-10-13','12:15:00',11.75),('7643','2013-10-13','12:20:00',10.96),('7643','2013-10-13','12:25:00',11.43),('7643','2013-10-13','12:30:00',12.02),('7643','2013-10-13','12:35:00',11.85),('7643','2013-10-13','12:40:00',11.87),('7643','2013-10-13','12:45:00',11.94),('7643','2013-10-13','12:50:00',11.83),('7643','2013-10-13','12:55:00',11.82),('7643','2013-10-13','13:00:00',11.88),('7643','2013-10-13','13:05:00',11.84),('7643','2013-10-13','13:10:00',11.69),('7643','2013-10-13','13:15:00',11.58),('7643','2013-10-13','13:20:00',11.68),('7643','2013-10-13','13:25:00',11.59),('7643','2013-10-13','13:30:00',11.53),('7643','2013-10-13','13:35:00',11.4),('7643','2013-10-13','13:40:00',11.38),('7643','2013-10-13','13:45:00',11.31),('7643','2013-10-13','13:50:00',11.24),('7643','2013-10-13','13:55:00',11.13),('7643','2013-10-13','14:00:00',11.04),('7643','2013-10-13','14:05:00',10.99),('7643','2013-10-13','14:10:00',10.85),('7643','2013-10-13','14:15:00',10.74),('7643','2013-10-13','14:20:00',10.64),('7643','2013-10-13','14:25:00',10.53),('7643','2013-10-13','14:30:00',10.44),('7643','2013-10-13','14:35:00',10.3),('7643','2013-10-13','14:40:00',10.07),('7643','2013-10-13','14:45:00',9.98),('7643','2013-10-13','14:50:00',9.85),('7643','2013-10-13','14:55:00',9.66),('7643','2013-10-13','15:00:00',9.52),('7643','2013-10-13','15:05:00',9.26),('7643','2013-10-13','15:10:00',8.98),('7643','2013-10-13','15:15:00',8.71),('7643','2013-10-13','15:20:00',8.52),('7643','2013-10-13','15:25:00',8.26),('7643','2013-10-13','15:30:00',7.99),('7643','2013-10-13','15:35:00',7.65),('7643','2013-10-13','15:40:00',6.92),('7643','2013-10-13','15:45:00',6.38),('7643','2013-10-13','15:50:00',5.66),('7643','2013-10-13','15:55:00',3.7),('7643','2013-10-13','16:00:00',5.05),('7643','2013-10-13','16:05:00',3.82),('7643','2013-10-13','16:10:00',3.48),('7643','2013-10-13','16:15:00',3.31),('7643','2013-10-13','16:20:00',2.81),('7643','2013-10-13','16:25:00',3.96),('7643','2013-10-13','16:30:00',2.87),('7643','2013-10-13','16:35:00',1.97),('7643','2013-10-13','16:40:00',1.52),('7643','2013-10-13','16:45:00',2.75),('7643','2013-10-13','16:50:00',2.39),('7643','2013-10-13','16:55:00',1.52),('7643','2013-10-13','17:00:00',1.26),('7643','2013-10-13','17:05:00',1.21),('7643','2013-10-13','17:10:00',1.73),('7643','2013-10-13','17:15:00',1.66),('7643','2013-10-13','17:20:00',1.46),('7643','2013-10-13','17:35:00',1.21),('7643','2013-10-13','17:40:00',1.23),('7643','2013-10-12','08:05:00',1.04),('7643','2013-10-12','08:10:00',1.43),('7643','2013-10-12','08:15:00',1.6),('7643','2013-10-12','08:20:00',1.81),('7643','2013-10-12','08:25:00',1.87),('7643','2013-10-12','08:30:00',2.18),('7643','2013-10-12','08:35:00',2.74),('7643','2013-10-12','08:40:00',2.71),('7643','2013-10-12','08:45:00',2.63),('7643','2013-10-12','08:50:00',2.9),('7643','2013-10-12','08:55:00',3.43),('7643','2013-10-12','09:00:00',3.96),('7643','2013-10-12','09:05:00',4.21),('7643','2013-10-12','09:10:00',4.03),('7643','2013-10-12','09:15:00',6.15),('7643','2013-10-12','09:20:00',6.72),('7643','2013-10-12','09:25:00',6.38),('7643','2013-10-12','09:30:00',4.65),('7643','2013-10-12','09:35:00',5.52),('7643','2013-10-12','09:40:00',8.04),('7643','2013-10-12','09:45:00',9.88),('7643','2013-10-12','09:50:00',9.74),('7643','2013-10-12','09:55:00',10.07),('7643','2013-10-12','10:00:00',7.68),('7643','2013-10-12','10:05:00',5.59),('7643','2013-10-12','10:10:00',7.6),('7643','2013-10-12','10:15:00',8.52),('7643','2013-10-12','10:20:00',7.17),('7643','2013-10-12','10:25:00',8.29),('7643','2013-10-12','10:30:00',9.94),('7643','2013-10-12','10:35:00',11.5),('7643','2013-10-12','10:40:00',11.9),('7643','2013-10-12','10:45:00',12.11),('7643','2013-10-12','10:50:00',9.64),('7643','2013-10-12','10:55:00',8.53),('7643','2013-10-12','11:00:00',10.48),('7643','2013-10-12','11:05:00',11.48),('7643','2013-10-12','11:10:00',11.16),('7643','2013-10-12','11:15:00',11.92),('7643','2013-10-12','11:20:00',11.39),('7643','2013-10-12','11:25:00',11.15),('7643','2013-10-12','11:30:00',11.45),('7643','2013-10-12','11:35:00',11.48),('7643','2013-10-12','11:40:00',11.5),('7643','2013-10-12','11:45:00',11.53),('7643','2013-10-12','11:50:00',11.7),('7643','2013-10-12','11:55:00',11.67),('7643','2013-10-12','12:00:00',11.74),('7643','2013-10-12','12:05:00',11.82),('7643','2013-10-12','12:10:00',11.82),('7643','2013-10-12','12:15:00',11.92),('7643','2013-10-12','12:20:00',11.54),('7643','2013-10-12','12:25:00',11.41),('7643','2013-10-12','12:30:00',12),('7643','2013-10-12','12:35:00',12.16),('7643','2013-10-12','12:40:00',12.16),('7643','2013-10-12','12:45:00',11.94),('7643','2013-10-12','12:50:00',11.78),('7643','2013-10-12','12:55:00',11.81),('7643','2013-10-12','13:00:00',11.95),('7643','2013-10-12','13:05:00',11.82),('7643','2013-10-12','13:10:00',11.88),('7643','2013-10-12','13:15:00',12),('7643','2013-10-12','13:20:00',12.08),('7643','2013-10-12','13:25:00',10.43),('7643','2013-10-12','13:30:00',8.93),('7643','2013-10-12','13:35:00',9.53),('7643','2013-10-12','13:40:00',6.77),('7643','2013-10-12','13:45:00',7.04),('7643','2013-10-12','13:50:00',7.9),('7643','2013-10-12','13:55:00',9.23),('7643','2013-10-12','14:00:00',11.77),('7643','2013-10-12','14:05:00',11.48),('7643','2013-10-12','14:10:00',11.14),('7643','2013-10-12','14:15:00',10.48),('7643','2013-10-12','14:20:00',11.33),('7643','2013-10-12','14:25:00',11.38),('7643','2013-10-12','14:30:00',9.98),('7643','2013-10-12','14:35:00',8.81),('7643','2013-10-12','14:40:00',10.03),('7643','2013-10-12','14:45:00',7.67),('7643','2013-10-12','14:50:00',6.24),('7643','2013-10-12','14:55:00',7.63),('7643','2013-10-12','15:00:00',9.12),('7643','2013-10-12','15:05:00',8.01),('7643','2013-10-12','15:10:00',5.54),('7643','2013-10-12','15:15:00',6.98),('7643','2013-10-12','15:20:00',7.71),('7643','2013-10-12','15:25:00',8.66),('7643','2013-10-12','15:30:00',6.34),('7643','2013-10-12','15:35:00',5.56),('7643','2013-10-12','15:40:00',5.31),('7643','2013-10-12','15:45:00',5.36),('7643','2013-10-12','15:50:00',4.75),('7643','2013-10-12','15:55:00',4.53),('7643','2013-10-12','16:00:00',4.63),('7643','2013-10-12','16:05:00',6.26),('7643','2013-10-12','16:10:00',5.49),('7643','2013-10-12','16:15:00',4.61),('7643','2013-10-12','16:20:00',5.37),('7643','2013-10-12','16:25:00',6.51),('7643','2013-10-12','16:30:00',6.28),('7643','2013-10-12','16:35:00',5.24),('7643','2013-10-12','16:40:00',4.25),('7643','2013-10-12','16:45:00',3.16),('7643','2013-10-12','16:50:00',3.41),('7643','2013-10-12','16:55:00',2.86),('7643','2013-10-12','17:00:00',2.05),('7643','2013-10-12','17:05:00',1.95),('7643','2013-10-12','17:10:00',1.62),('7643','2013-10-12','17:15:00',1.58),('7643','2013-10-12','17:20:00',2.29),('7643','2013-10-12','17:25:00',2.86),('7643','2013-10-12','17:30:00',2.01),('7643','2013-10-12','17:35:00',2.24),('7643','2013-10-12','17:40:00',1.83),('7643','2013-10-12','17:45:00',1.41),('7643','2013-10-12','17:50:00',1.11),('7643','2013-10-11','10:35:00',1.24),('7643','2013-10-11','10:40:00',1.54),('7643','2013-10-11','10:45:00',1.75),('7643','2013-10-11','10:50:00',1.93),('7643','2013-10-11','10:55:00',2.11),('7643','2013-10-11','11:00:00',2.37),('7643','2013-10-11','11:05:00',2.57),('7643','2013-10-11','11:10:00',2.72),('7643','2013-10-11','11:15:00',3.09),('7643','2013-10-11','11:20:00',3.65),('7643','2013-10-11','11:25:00',4.04),('7643','2013-10-11','11:30:00',4.73),('7643','2013-10-11','11:35:00',6.11),('7643','2013-10-11','11:40:00',11.1),('7643','2013-10-11','11:45:00',6.13),('7643','2013-10-11','11:50:00',5.31),('7643','2013-10-11','11:55:00',4.65),('7643','2013-10-11','12:00:00',3.09),('7643','2013-10-11','12:05:00',2.16),('7643','2013-10-11','12:10:00',2.69),('7643','2013-10-11','12:15:00',3.91),('7643','2013-10-11','12:20:00',6.88),('7643','2013-10-11','12:25:00',13.81),('7643','2013-10-11','12:30:00',10.54),('7643','2013-10-11','12:35:00',12.12),('7643','2013-10-11','12:40:00',12.14),('7643','2013-10-11','12:45:00',10.85),('7643','2013-10-11','12:50:00',10.12),('7643','2013-10-11','12:55:00',8.66),('7643','2013-10-11','13:00:00',6.61),('7643','2013-10-11','13:05:00',5.24),('7643','2013-10-11','13:10:00',3.05),('7643','2013-10-11','13:15:00',4.15),('7643','2013-10-11','13:20:00',4.97),('7643','2013-10-11','13:25:00',5.47),('7643','2013-10-11','13:30:00',14.87),('7643','2013-10-11','13:35:00',6.25),('7643','2013-10-11','13:40:00',2.54),('7643','2013-10-11','13:45:00',1.31),('7643','2013-10-11','13:50:00',1.08),('7643','2013-10-11','13:55:00',1.87),('7643','2013-10-11','14:00:00',2.44),('7643','2013-10-11','14:05:00',1.06),('7643','2013-10-11','14:50:00',1.14),('7643','2013-10-11','14:55:00',1.14),('7643','2013-10-11','15:00:00',1.29),('7643','2013-10-11','15:05:00',1.74),('7643','2013-10-11','15:10:00',1.95),('7643','2013-10-11','15:15:00',2.11),('7643','2013-10-11','15:20:00',2.24),('7643','2013-10-11','15:25:00',2.63),('7643','2013-10-11','15:30:00',2.84),('7643','2013-10-11','15:35:00',2.67),('7643','2013-10-11','15:40:00',2.41),('7643','2013-10-11','15:45:00',2.28),('7643','2013-10-11','15:50:00',2.56),('7643','2013-10-11','15:55:00',3.34),('7643','2013-10-11','16:00:00',4.08),('7643','2013-10-11','16:05:00',3.84),('7643','2013-10-11','16:10:00',3.98),('7643','2013-10-11','16:15:00',5.94),('7643','2013-10-11','16:20:00',5.56),('7643','2013-10-11','16:25:00',3.27),('7643','2013-10-11','16:30:00',2.08),('7643','2013-10-11','16:35:00',1.63),('7643','2013-10-11','16:40:00',1.39),('7643','2013-10-11','16:45:00',1.5),('7643','2013-10-11','16:50:00',1.36),('7643','2013-10-11','16:55:00',1.77),('7643','2013-10-11','17:00:00',3.38),('7643','2013-10-11','17:05:00',1.93),('7643','2013-10-11','17:10:00',1.88),('7643','2013-10-11','17:15:00',1.1),('7643','2013-10-11','17:20:00',1.81),('7643','2013-10-11','17:25:00',2.02),('7643','2013-10-11','17:30:00',1.16),('7643','2013-10-11','17:35:00',1.26),('7643','2013-10-11','17:40:00',1.26),('7643','2013-10-11','17:45:00',1.05),('7643','2013-10-10','08:10:00',1.54),('7643','2013-10-10','08:15:00',2.04),('7643','2013-10-10','08:20:00',2.12),('7643','2013-10-10','08:25:00',1.41),('7643','2013-10-10','08:30:00',1.03),('7643','2013-10-10','08:35:00',2.48),('7643','2013-10-10','08:40:00',1.31),('7643','2013-10-10','08:50:00',1.09),('7643','2013-10-10','09:05:00',2.33),('7643','2013-10-10','09:15:00',2.49),('7643','2013-10-10','09:20:00',1.84),('7643','2013-10-10','09:25:00',1.43),('7643','2013-10-10','09:30:00',1.01),('7643','2013-10-10','09:35:00',2.98),('7643','2013-10-10','09:40:00',2.15),('7643','2013-10-10','09:45:00',8.27),('7643','2013-10-10','09:50:00',6.94),('7643','2013-10-10','09:55:00',8.7),('7643','2013-10-10','10:00:00',8.91),('7643','2013-10-10','10:05:00',9.17),('7643','2013-10-10','10:10:00',9.35),('7643','2013-10-10','10:15:00',6.68),('7643','2013-10-10','10:20:00',7.23),('7643','2013-10-10','10:25:00',5.82),('7643','2013-10-10','10:30:00',6.44),('7643','2013-10-10','10:35:00',8.14),('7643','2013-10-10','10:40:00',6.1),('7643','2013-10-10','10:45:00',2.51),('7643','2013-10-10','10:50:00',1.65),('7643','2013-10-10','10:55:00',1.57),('7643','2013-10-10','11:00:00',3.81),('7643','2013-10-10','11:05:00',10.39),('7643','2013-10-10','11:10:00',8.38),('7643','2013-10-10','11:15:00',4.13),('7643','2013-10-10','11:20:00',4.13),('7643','2013-10-10','11:25:00',4.09),('7643','2013-10-10','11:30:00',3.38),('7643','2013-10-10','11:35:00',4.2),('7643','2013-10-10','11:40:00',5.42),('7643','2013-10-10','11:45:00',6.02),('7643','2013-10-10','11:50:00',9.02),('7643','2013-10-10','11:55:00',6.26),('7643','2013-10-10','12:00:00',11.41),('7643','2013-10-10','12:05:00',15.47),('7643','2013-10-10','12:10:00',6.37),('7643','2013-10-10','12:15:00',3.7),('7643','2013-10-10','12:20:00',3.77),('7643','2013-10-10','12:25:00',3.75),('7643','2013-10-10','12:30:00',4.56),('7643','2013-10-10','12:35:00',2.17),('7643','2013-10-10','12:40:00',1.93),('7643','2013-10-10','12:45:00',1.43),('7643','2013-10-10','12:55:00',1.44),('7643','2013-10-10','13:00:00',2.53),('7643','2013-10-10','13:05:00',8.95),('7643','2013-10-10','13:10:00',8.36),('7643','2013-10-10','13:15:00',7.5),('7643','2013-10-10','13:20:00',10.54),('7643','2013-10-10','13:25:00',15.29),('7643','2013-10-10','13:30:00',4.45),('7643','2013-10-10','13:35:00',1.93),('7643','2013-10-10','13:40:00',6.64),('7643','2013-10-10','13:45:00',10.91),('7643','2013-10-10','13:50:00',2.42),('7643','2013-10-10','14:35:00',1.47),('7643','2013-10-10','14:50:00',1.16),('7643','2013-10-10','14:55:00',1.54),('7643','2013-10-10','15:10:00',3.07),('7643','2013-10-10','15:15:00',2.19),('7643','2013-10-10','15:25:00',2.36),('7643','2013-10-10','15:30:00',4.36),('7643','2013-10-10','15:35:00',3.78),('7643','2013-10-10','15:40:00',4.31),('7643','2013-10-10','15:45:00',3.32),('7643','2013-10-10','15:50:00',2.39),('7643','2013-10-10','15:55:00',2.94),('7643','2013-10-10','16:00:00',5.95),('7643','2013-10-10','16:05:00',3.61),('7643','2013-10-10','16:10:00',3.21),('7643','2013-10-10','16:15:00',1.65),('7643','2013-10-10','16:20:00',1.42),('7643','2013-10-10','16:25:00',3.09),('7643','2013-10-10','16:30:00',2.98),('7643','2013-10-10','16:35:00',5.86),('7643','2013-10-10','16:40:00',2.18),('7643','2013-10-10','16:45:00',1.14),('7643','2013-10-10','16:50:00',1.24),('7643','2013-10-10','16:55:00',2.53),('7643','2013-10-10','17:00:00',2.07),('7643','2013-10-10','17:05:00',1.04),('7643','2013-10-10','17:15:00',1.41),('7643','2013-10-10','17:45:00',1.62),('7643','2013-10-09','07:55:00',1.22),('7643','2013-10-09','08:00:00',1.33),('7643','2013-10-09','08:10:00',1.25),('7643','2013-10-09','08:35:00',2),('7643','2013-10-09','08:40:00',3.67),('7643','2013-10-09','08:45:00',4.63),('7643','2013-10-09','08:50:00',4.15),('7643','2013-10-09','08:55:00',5.57),('7643','2013-10-09','09:00:00',3.27),('7643','2013-10-09','09:05:00',2.23),('7643','2013-10-09','09:10:00',3.77),('7643','2013-10-09','09:15:00',6.57),('7643','2013-10-09','09:20:00',6.68),('7643','2013-10-09','09:25:00',7.03),('7643','2013-10-09','09:30:00',7.28),('7643','2013-10-09','09:35:00',7.35),('7643','2013-10-09','09:40:00',6.06),('7643','2013-10-09','09:45:00',3.68),('7643','2013-10-09','09:50:00',3.35),('7643','2013-10-09','09:55:00',4.03),('7643','2013-10-09','10:00:00',1.9),('7643','2013-10-09','10:05:00',1.71),('7643','2013-10-09','10:10:00',1.43),('7643','2013-10-09','10:15:00',6),('7643','2013-10-09','10:20:00',9.89),('7643','2013-10-09','10:25:00',9.15),('7643','2013-10-09','10:30:00',8.53),('7643','2013-10-09','10:35:00',1.39),('7643','2013-10-09','10:40:00',2.96),('7643','2013-10-09','10:45:00',6.97),('7643','2013-10-09','10:50:00',4.21),('7643','2013-10-09','10:55:00',2.71),('7643','2013-10-09','11:00:00',1.96),('7643','2013-10-09','11:05:00',3.45),('7643','2013-10-09','11:10:00',3.06),('7643','2013-10-09','11:15:00',5.33),('7643','2013-10-09','11:20:00',9.37),('7643','2013-10-09','11:25:00',14.42),('7643','2013-10-09','11:30:00',4.83),('7643','2013-10-09','11:35:00',2.79),('7643','2013-10-09','11:40:00',6.61),('7643','2013-10-09','11:45:00',11.87),('7643','2013-10-09','11:50:00',7.9),('7643','2013-10-09','11:55:00',10.78),('7643','2013-10-09','12:00:00',4.11),('7643','2013-10-09','12:05:00',3.29),('7643','2013-10-09','12:10:00',2.6),('7643','2013-10-09','12:15:00',2.13),('7643','2013-10-09','12:20:00',3.36),('7643','2013-10-09','12:25:00',11.73),('7643','2013-10-09','12:30:00',10.4),('7643','2013-10-09','12:35:00',15.66),('7643','2013-10-09','12:40:00',12.7),('7643','2013-10-09','12:45:00',13.39),('7643','2013-10-09','12:50:00',7.21),('7643','2013-10-09','12:55:00',7.08),('7643','2013-10-09','13:00:00',7.1),('7643','2013-10-09','13:05:00',14.3),('7643','2013-10-09','13:10:00',4.61),('7643','2013-10-09','13:15:00',5.14),('7643','2013-10-09','13:20:00',7.14),('7643','2013-10-09','13:25:00',8.33),('7643','2013-10-09','13:30:00',9.29),('7643','2013-10-09','13:35:00',5.66),('7643','2013-10-09','13:40:00',12.19),('7643','2013-10-09','13:45:00',11.97),('7643','2013-10-09','13:50:00',13.25),('7643','2013-10-09','13:55:00',13.05),('7643','2013-10-09','14:00:00',11.71),('7643','2013-10-09','14:05:00',6.35),('7643','2013-10-09','14:10:00',7.78),('7643','2013-10-09','14:15:00',8.75),('7643','2013-10-09','14:20:00',13.83),('7643','2013-10-09','14:25:00',8.77),('7643','2013-10-09','14:30:00',10.37),('7643','2013-10-09','14:35:00',9.69),('7643','2013-10-09','14:40:00',12.72),('7643','2013-10-09','14:45:00',8.72),('7643','2013-10-09','14:50:00',10.53),('7643','2013-10-09','14:55:00',11.21),('7643','2013-10-09','15:00:00',11.46),('7643','2013-10-09','15:05:00',11.43),('7643','2013-10-09','15:10:00',11.05),('7643','2013-10-09','15:15:00',8.13),('7643','2013-10-09','15:20:00',8.21),('7643','2013-10-09','15:25:00',4.54),('7643','2013-10-09','15:30:00',8.74),('7643','2013-10-09','15:35:00',4.65),('7643','2013-10-09','15:40:00',3.31),('7643','2013-10-09','15:45:00',4.09),('7643','2013-10-09','15:50:00',2.42),('7643','2013-10-09','15:55:00',2.69),('7643','2013-10-09','16:00:00',4.44),('7643','2013-10-09','16:05:00',2.59),('7643','2013-10-09','16:10:00',3.71),('7643','2013-10-09','16:15:00',8.24),('7643','2013-10-09','16:20:00',4.31),('7643','2013-10-09','16:25:00',6.81),('7643','2013-10-09','16:30:00',4.32),('7643','2013-10-09','16:40:00',4.22),('7643','2013-10-09','16:45:00',5.43),('7643','2013-10-09','16:50:00',5.01),('7643','2013-10-09','16:55:00',4.59),('7643','2013-10-09','17:00:00',4.24),('7643','2013-10-09','17:05:00',3.33),('7643','2013-10-09','17:15:00',2.4),('7643','2013-10-09','17:20:00',3.53),('7643','2013-10-09','17:25:00',1.54),('7643','2013-10-09','17:30:00',1.38),('7643','2013-10-09','17:35:00',1.23),('7643','2013-10-09','17:40:00',1.27),('7643','2013-10-09','17:45:00',1.3),('7643','2013-10-08','08:00:00',1.3),('7643','2013-10-08','08:25:00',2.98),('7643','2013-10-08','08:30:00',3.67),('7643','2013-10-08','08:35:00',3.66),('7643','2013-10-08','08:40:00',4.26),('7643','2013-10-08','08:45:00',4.59),('7643','2013-10-08','08:50:00',4.9),('7643','2013-10-08','08:55:00',5.2),('7643','2013-10-08','09:00:00',5.55),('7643','2013-10-08','09:05:00',5.95),('7643','2013-10-08','09:10:00',6.32),('7643','2013-10-08','09:15:00',6.16),('7643','2013-10-08','09:20:00',5.81),('7643','2013-10-08','09:25:00',7.25),('7643','2013-10-08','09:30:00',7.51),('7643','2013-10-08','09:35:00',7.7),('7643','2013-10-08','09:40:00',7.97),('7643','2013-10-08','09:45:00',8.49),('7643','2013-10-08','09:50:00',8.79),('7643','2013-10-08','09:55:00',9.15),('7643','2013-10-08','10:00:00',9.67),('7643','2013-10-08','10:05:00',10.42),('7643','2013-10-08','10:10:00',10.61),('7643','2013-10-08','10:15:00',8.16),('7643','2013-10-08','10:20:00',3.67),('7643','2013-10-08','10:25:00',4.74),('7643','2013-10-08','10:30:00',6.09),('7643','2013-10-08','10:35:00',6.13),('7643','2013-10-08','10:40:00',7.87),('7643','2013-10-08','10:45:00',9.63),('7643','2013-10-08','10:50:00',11.51),('7643','2013-10-08','10:55:00',8.87),('7643','2013-10-08','11:00:00',11.44),('7643','2013-10-08','11:05:00',13.84),('7643','2013-10-08','11:10:00',14.26),('7643','2013-10-08','11:15:00',14.19),('7643','2013-10-08','11:20:00',12.14),('7643','2013-10-08','11:25:00',12.83),('7643','2013-10-08','11:30:00',13.68),('7643','2013-10-08','11:35:00',14.87),('7643','2013-10-08','11:40:00',9.15),('7643','2013-10-08','11:45:00',11.16),('7643','2013-10-08','11:50:00',12.37),('7643','2013-10-08','11:55:00',10.39),('7643','2013-10-08','12:00:00',11.61),('7643','2013-10-08','12:05:00',4.99),('7643','2013-10-08','12:10:00',8.46),('7643','2013-10-08','12:15:00',5.62),('7643','2013-10-08','12:20:00',7.49),('7643','2013-10-08','12:25:00',13.87),('7643','2013-10-08','12:30:00',12.24),('7643','2013-10-08','12:35:00',9.39),('7643','2013-10-08','12:40:00',6.06),('7643','2013-10-08','12:45:00',4.3),('7643','2013-10-08','12:50:00',2.68),('7643','2013-10-08','12:55:00',4.8),('7643','2013-10-08','13:00:00',3.95),('7643','2013-10-08','13:05:00',3.09),('7643','2013-10-08','13:10:00',5.23),('7643','2013-10-08','13:15:00',8.27),('7643','2013-10-08','13:20:00',7.21),('7643','2013-10-08','13:25:00',9.77),('7643','2013-10-08','13:30:00',7.22),('7643','2013-10-08','13:35:00',7.27),('7643','2013-10-08','13:40:00',7.88),('7643','2013-10-08','13:45:00',12.17),('7643','2013-10-08','13:50:00',12.36),('7643','2013-10-08','13:55:00',15.95),('7643','2013-10-08','14:00:00',10.05),('7643','2013-10-08','14:05:00',4.02),('7643','2013-10-08','14:10:00',4.72),('7643','2013-10-08','14:15:00',2.64),('7643','2013-10-08','14:20:00',2.15),('7643','2013-10-08','14:25:00',2.35),('7643','2013-10-08','14:30:00',2.14),('7643','2013-10-08','14:35:00',1.69),('7643','2013-10-08','14:40:00',1.2),('7643','2013-10-08','14:45:00',1.85),('7643','2013-10-08','14:50:00',2.76),('7643','2013-10-08','14:55:00',4.37),('7643','2013-10-08','15:00:00',6.72),('7643','2013-10-08','15:05:00',12.37),('7643','2013-10-08','15:10:00',11.15),('7643','2013-10-08','15:15:00',11.84),('7643','2013-10-08','15:20:00',10.12),('7643','2013-10-08','15:25:00',4.63),('7643','2013-10-08','15:30:00',9.32),('7643','2013-10-08','15:35:00',6.43),('7643','2013-10-08','15:40:00',9.33),('7643','2013-10-08','15:45:00',3.97),('7643','2013-10-08','15:50:00',6.78),('7643','2013-10-08','15:55:00',1.72),('7643','2013-10-08','16:00:00',1.52),('7643','2013-10-08','16:05:00',1.99),('7643','2013-10-08','16:10:00',3.11),('7643','2013-10-08','16:15:00',4.7),('7643','2013-10-08','16:20:00',5.79),('7643','2013-10-08','16:25:00',4.89),('7643','2013-10-08','16:30:00',5.82),('7643','2013-10-08','16:35:00',3.28),('7643','2013-10-08','16:40:00',7.98),('7643','2013-10-08','16:45:00',2.46),('7643','2013-10-08','16:50:00',1.57),('7643','2013-10-08','16:55:00',1.22),('7643','2013-10-08','17:00:00',1.09),('7643','2013-10-08','17:20:00',1.96),('7643','2013-10-08','17:25:00',2.58),('7643','2013-10-08','17:30:00',3.24),('7643','2013-10-08','17:35:00',3.35),('7643','2013-10-08','17:40:00',2.53),('7643','2013-10-08','17:45:00',2.42),('7643','2013-10-08','17:50:00',1.7),('7643','2013-10-08','17:55:00',1.07),('7643','2014-04-14','07:40:00',1.2),('7643','2014-04-14','07:45:00',1.35),('7643','2014-04-14','07:50:00',1.63),('7643','2014-04-14','07:55:00',2.08),('7643','2014-04-14','08:00:00',2.55),('7643','2014-04-14','08:05:00',2.21),('7643','2014-04-14','08:10:00',1.84),('7643','2014-04-14','08:15:00',1.17),('7643','2014-04-14','08:50:00',1.73),('7643','2014-04-14','08:55:00',2.82),('7643','2014-04-14','09:00:00',5.93),('7643','2014-04-14','09:05:00',7.18),('7643','2014-04-14','09:10:00',7.87),('7643','2014-04-14','09:15:00',5.13),('7643','2014-04-14','09:20:00',6.8),('7643','2014-04-14','09:25:00',8.64),('7643','2014-04-14','09:30:00',5.6),('7643','2014-04-14','09:35:00',3.42),('7643','2014-04-14','09:40:00',2.49),('7643','2014-04-14','09:45:00',4.31),('7643','2014-04-14','09:50:00',10.39),('7643','2014-04-14','09:55:00',5.26),('7643','2014-04-14','10:00:00',9.56),('7643','2014-04-14','10:05:00',5.62),('7643','2014-04-14','10:10:00',6.1),('7643','2014-04-14','10:15:00',6.87),('7643','2014-04-14','10:20:00',5.45),('7643','2014-04-14','10:25:00',5.5),('7643','2014-04-14','10:30:00',15.29),('7643','2014-04-14','10:35:00',12.03),('7643','2014-04-14','10:40:00',9),('7643','2014-04-14','10:45:00',13.98),('7643','2014-04-14','10:50:00',9.61),('7643','2014-04-14','10:55:00',4.34),('7643','2014-04-14','11:00:00',9.86),('7643','2014-04-14','11:05:00',16.12),('7643','2014-04-14','11:10:00',10.67),('7643','2014-04-14','11:15:00',7.42),('7643','2014-04-14','11:20:00',4.78),('7643','2014-04-14','11:25:00',5.98),('7643','2014-04-14','11:30:00',4.18),('7643','2014-04-14','11:35:00',3.55),('7643','2014-04-14','11:40:00',2.51),('7643','2014-04-14','11:45:00',4.5),('7643','2014-04-14','11:50:00',5.48),('7643','2014-04-14','11:55:00',4.13),('7643','2014-04-14','12:00:00',2.73),('7643','2014-04-14','12:05:00',2.79),('7643','2014-04-14','12:10:00',3.96),('7643','2014-04-14','12:15:00',5.42),('7643','2014-04-14','12:20:00',7.39),('7643','2014-04-14','12:25:00',3.62),('7643','2014-04-14','12:30:00',2.15),('7643','2014-04-14','12:35:00',2.73),('7643','2014-04-14','12:40:00',2.28),('7643','2014-04-14','12:45:00',1.69),('7643','2014-04-14','12:50:00',1.74),('7643','2014-04-14','12:55:00',1.65),('7643','2014-04-14','13:00:00',2.24),('7643','2014-04-14','13:05:00',3.73),('7643','2014-04-14','13:10:00',6.15),('7643','2014-04-14','13:15:00',6.31),('7643','2014-04-14','13:20:00',12.51),('7643','2014-04-14','13:25:00',7.7),('7643','2014-04-14','13:30:00',8.03),('7643','2014-04-14','13:35:00',9.98),('7643','2014-04-14','13:40:00',13.16),('7643','2014-04-14','13:45:00',5.56),('7643','2014-04-14','13:50:00',4.39),('7643','2014-04-14','13:55:00',4.23),('7643','2014-04-14','14:00:00',5.41),('7643','2014-04-14','14:05:00',14.06),('7643','2014-04-14','14:10:00',14.83),('7643','2014-04-14','14:15:00',13.9),('7643','2014-04-14','14:20:00',10.42),('7643','2014-04-14','14:25:00',14.56),('7643','2014-04-14','14:30:00',8.99),('7643','2014-04-14','14:35:00',7.9),('7643','2014-04-14','14:40:00',5.38),('7643','2014-04-14','14:45:00',4.19),('7643','2014-04-14','14:50:00',3.34),('7643','2014-04-14','14:55:00',2.87),('7643','2014-04-14','15:00:00',3.53),('7643','2014-04-14','15:05:00',2.52),('7643','2014-04-14','15:10:00',3.63),('7643','2014-04-14','15:15:00',5.36),('7643','2014-04-14','15:20:00',7.48),('7643','2014-04-14','15:25:00',6.66),('7643','2014-04-14','15:30:00',5.21),('7643','2014-04-14','15:35:00',5.09),('7643','2014-04-14','15:40:00',5.29),('7643','2014-04-14','15:45:00',5.05),('7643','2014-04-14','15:50:00',4.83),('7643','2014-04-14','15:55:00',5.32),('7643','2014-04-14','16:00:00',6.04),('7643','2014-04-14','16:05:00',5.27),('7643','2014-04-14','16:10:00',3.41),('7643','2014-04-14','16:15:00',2.58),('7643','2014-04-14','16:20:00',1.67),('7643','2014-04-14','16:25:00',1.05),('7643','2013-10-07','07:45:00',1.09),('7643','2013-10-07','07:50:00',1.29),('7643','2013-10-07','07:55:00',1.94),('7643','2013-10-07','08:00:00',1.73),('7643','2013-10-07','08:05:00',2.6),('7643','2013-10-07','08:10:00',3.18),('7643','2013-10-07','08:15:00',4.17),('7643','2013-10-07','08:20:00',4.38),('7643','2013-10-07','08:25:00',2.38),('7643','2013-10-07','08:30:00',2.38),('7643','2013-10-07','08:35:00',1.53),('7643','2013-10-07','09:25:00',1.06),('7643','2013-10-07','09:30:00',1.07),('7643','2013-10-07','09:35:00',1.2),('7643','2013-10-07','09:40:00',1.31),('7643','2013-10-07','09:45:00',1.5),('7643','2013-10-07','09:50:00',1.97),('7643','2013-10-07','09:55:00',2.5),('7643','2013-10-07','10:00:00',3.53),('7643','2013-10-07','10:05:00',3.41),('7643','2013-10-07','10:10:00',3.36),('7643','2013-10-07','10:15:00',2.6),('7643','2013-10-07','10:20:00',1.88),('7643','2013-10-07','10:25:00',1.49),('7643','2013-10-07','10:30:00',1.65),('7643','2013-10-07','10:35:00',1.71),('7643','2013-10-07','10:40:00',1.51),('7643','2013-10-07','10:45:00',1.04),('7643','2013-10-07','10:50:00',1.18),('7643','2013-10-07','10:55:00',2.63),('7643','2013-10-07','11:00:00',5.48),('7643','2013-10-07','11:05:00',5.25),('7643','2013-10-07','11:10:00',9.28),('7643','2013-10-07','11:15:00',16.15),('7643','2013-10-07','11:20:00',13.12),('7643','2013-10-07','11:25:00',6.33),('7643','2013-10-07','11:30:00',12.36),('7643','2013-10-07','11:35:00',9.81),('7643','2013-10-07','11:40:00',6.05),('7643','2013-10-07','11:45:00',5.38),('7643','2013-10-07','11:50:00',4.01),('7643','2013-10-07','11:55:00',3.36),('7643','2013-10-07','12:00:00',2.3),('7643','2013-10-07','12:05:00',2.86),('7643','2013-10-07','12:10:00',3.79),('7643','2013-10-07','12:15:00',3.97),('7643','2013-10-07','12:20:00',4.09),('7643','2013-10-07','12:25:00',5.18),('7643','2013-10-07','12:30:00',10.19),('7643','2013-10-07','12:35:00',8.83),('7643','2013-10-07','12:40:00',16.51),('7643','2013-10-07','12:45:00',10.87),('7643','2013-10-07','12:50:00',15.24),('7643','2013-10-07','12:55:00',14.92),('7643','2013-10-07','13:00:00',13.09),('7643','2013-10-07','13:05:00',13.81),('7643','2013-10-07','13:10:00',8.63),('7643','2013-10-07','13:15:00',11.73),('7643','2013-10-07','13:20:00',6.97),('7643','2013-10-07','13:25:00',12.02),('7643','2013-10-07','13:30:00',7.21),('7643','2013-10-07','13:35:00',4.23),('7643','2013-10-07','13:40:00',4.29),('7643','2013-10-07','13:45:00',2.98),('7643','2013-10-07','13:50:00',2.72),('7643','2013-10-07','13:55:00',3.46),('7643','2013-10-07','14:00:00',2.96),('7643','2013-10-07','14:05:00',5.61),('7643','2013-10-07','14:10:00',8.25),('7643','2013-10-07','14:15:00',9.18),('7643','2013-10-07','14:20:00',10.34),('7643','2013-10-07','14:25:00',10.57),('7643','2013-10-07','14:30:00',10.12),('7643','2013-10-07','14:35:00',4.01),('7643','2013-10-07','14:40:00',4.81),('7643','2013-10-07','14:45:00',11.74),('7643','2013-10-07','14:50:00',12.25),('7643','2013-10-07','14:55:00',11.43),('7643','2013-10-07','15:00:00',11.12),('7643','2013-10-07','15:05:00',11.07),('7643','2013-10-07','15:10:00',10.27),('7643','2013-10-07','15:15:00',10.82),('7643','2013-10-07','15:20:00',9.38),('7643','2013-10-07','15:25:00',9.16),('7643','2013-10-07','15:30:00',12.34),('7643','2013-10-07','15:35:00',10.89),('7643','2013-10-07','15:40:00',7.89),('7643','2013-10-07','15:45:00',6.76),('7643','2013-10-07','15:50:00',9.63),('7643','2013-10-07','15:55:00',4.85),('7643','2013-10-07','16:00:00',4.71),('7643','2013-10-07','16:05:00',6.11),('7643','2013-10-07','16:10:00',3.95),('7643','2013-10-07','16:15:00',2.43),('7643','2013-10-07','16:20:00',1.5),('7643','2013-10-07','16:25:00',1.6),('7643','2013-10-07','16:30:00',2.53),('7643','2013-10-07','16:35:00',2.35),('7643','2013-10-07','16:40:00',2.28),('7643','2013-10-07','16:45:00',2.83),('7643','2013-10-07','16:50:00',2.28),('7643','2013-10-07','16:55:00',1.23),('7643','2013-10-06','07:45:00',1.07),('7643','2013-10-06','07:50:00',1.36),('7643','2013-10-06','07:55:00',1.63),('7643','2013-10-06','08:00:00',1.89),('7643','2013-10-06','08:05:00',2.15),('7643','2013-10-06','08:10:00',2.43),('7643','2013-10-06','08:15:00',2.42),('7643','2013-10-06','08:20:00',2.89),('7643','2013-10-06','08:25:00',3.28),('7643','2013-10-06','08:30:00',3.69),('7643','2013-10-06','08:35:00',4.74),('7643','2013-10-06','08:40:00',5.34),('7643','2013-10-06','08:45:00',2.59),('7643','2013-10-06','08:50:00',2.24),('7643','2013-10-06','08:55:00',3.98),('7643','2013-10-06','09:00:00',5.94),('7643','2013-10-06','09:05:00',6.21),('7643','2013-10-06','09:10:00',6.45),('7643','2013-10-06','09:15:00',6.71),('7643','2013-10-06','09:20:00',6.73),('7643','2013-10-06','09:25:00',7.24),('7643','2013-10-06','09:30:00',7.52),('7643','2013-10-06','09:35:00',7.8),('7643','2013-10-06','09:40:00',8.04),('7643','2013-10-06','09:45:00',8.28),('7643','2013-10-06','09:50:00',8.57),('7643','2013-10-06','09:55:00',8.78),('7643','2013-10-06','10:00:00',9.03),('7643','2013-10-06','10:05:00',9.28),('7643','2013-10-06','10:10:00',9.44),('7643','2013-10-06','10:15:00',9.69),('7643','2013-10-06','10:20:00',9.91),('7643','2013-10-06','10:25:00',10.24),('7643','2013-10-06','10:30:00',10.48),('7643','2013-10-06','10:35:00',10.82),('7643','2013-10-06','10:40:00',10.87),('7643','2013-10-06','10:45:00',11.14),('7643','2013-10-06','10:50:00',11.3),('7643','2013-10-06','10:55:00',11.4),('7643','2013-10-06','11:00:00',10.23),('7643','2013-10-06','11:05:00',11.26),('7643','2013-10-06','11:10:00',6.09),('7643','2013-10-06','11:15:00',10.12),('7643','2013-10-06','11:20:00',10.96),('7643','2013-10-06','11:25:00',12.27),('7643','2013-10-06','11:30:00',11.79),('7643','2013-10-06','11:35:00',12.29),('7643','2013-10-06','11:40:00',12.4),('7643','2013-10-06','11:45:00',12.58),('7643','2013-10-06','11:50:00',12.61),('7643','2013-10-06','11:55:00',12.85),('7643','2013-10-06','12:00:00',12.76),('7643','2013-10-06','12:05:00',13.18),('7643','2013-10-06','12:10:00',13.59),('7643','2013-10-06','12:15:00',12.02),('7643','2013-10-06','12:20:00',8.43),('7643','2013-10-06','12:25:00',14.87),('7643','2013-10-06','12:30:00',14.07),('7643','2013-10-06','12:35:00',13.69),('7643','2013-10-06','12:40:00',13.93),('7643','2013-10-06','12:45:00',13.84),('7643','2013-10-06','12:50:00',13.87),('7643','2013-10-06','12:55:00',14.09),('7643','2013-10-06','13:00:00',13.75),('7643','2013-10-06','13:05:00',13.72),('7643','2013-10-06','13:10:00',13.85),('7643','2013-10-06','13:15:00',13.47),('7643','2013-10-06','13:20:00',13.27),('7643','2013-10-06','13:25:00',7.41),('7643','2013-10-06','13:30:00',11.3),('7643','2013-10-06','13:35:00',11.05),('7643','2013-10-06','13:40:00',6.93),('7643','2013-10-06','13:45:00',5.25),('7643','2013-10-06','13:50:00',11.18),('7643','2013-10-06','13:55:00',15.99),('7643','2013-10-06','14:00:00',15.24),('7643','2013-10-06','14:05:00',3.54),('7643','2013-10-06','14:10:00',6.37),('7643','2013-10-06','14:15:00',3.56),('7643','2013-10-06','14:20:00',4.61),('7643','2013-10-06','14:25:00',11.4),('7643','2013-10-06','14:30:00',7.3),('7643','2013-10-06','14:35:00',5.52),('7643','2013-10-06','14:40:00',10.16),('7643','2013-10-06','14:45:00',13.52),('7643','2013-10-06','14:50:00',13.39),('7643','2013-10-06','14:55:00',11.63),('7643','2013-10-06','15:00:00',9.26),('7643','2013-10-06','15:05:00',7.02),('7643','2013-10-06','15:10:00',6.47),('7643','2013-10-06','15:15:00',6.06),('7643','2013-10-06','15:20:00',3.4),('7643','2013-10-06','15:25:00',3.22),('7643','2013-10-06','15:30:00',10.37),('7643','2013-10-06','15:35:00',6.63),('7643','2013-10-06','15:40:00',5.06),('7643','2013-10-06','15:45:00',4.63),('7643','2013-10-06','15:50:00',8.39),('7643','2013-10-06','15:55:00',7.32),('7643','2013-10-06','16:00:00',2.04),('7643','2013-10-06','16:05:00',2.09),('7643','2013-10-06','16:10:00',8.16),('7643','2013-10-06','16:15:00',8.49),('7643','2013-10-06','16:20:00',8.04),('7643','2013-10-06','16:25:00',7.67),('7643','2013-10-06','16:30:00',7.18),('7643','2013-10-06','16:35:00',6.9),('7643','2013-10-06','16:40:00',6.65),('7643','2013-10-06','16:45:00',6.17),('7643','2013-10-06','16:50:00',5.93),('7643','2013-10-06','16:55:00',5.26),('7643','2013-10-06','17:00:00',4.72),('7643','2013-10-06','17:05:00',4.26),('7643','2013-10-06','17:10:00',3.82),('7643','2013-10-06','17:15:00',3.46),('7643','2013-10-06','17:20:00',3.13),('7643','2013-10-06','17:25:00',2.88),('7643','2013-10-06','17:30:00',2.56),('7643','2013-10-06','17:35:00',2.23),('7643','2013-10-06','17:40:00',1.9),('7643','2013-10-06','17:45:00',1.61),('7643','2013-10-06','17:50:00',1.33),('7643','2013-10-06','17:55:00',1.06),('7643','2013-10-05','08:25:00',1.04),('7643','2013-10-05','08:35:00',1.12),('7643','2013-10-05','08:40:00',1.26),('7643','2013-10-05','08:45:00',1.24),('7643','2013-10-05','08:50:00',1.92),('7643','2013-10-05','08:55:00',1.78),('7643','2013-10-05','09:00:00',2.1),('7643','2013-10-05','09:05:00',3.7),('7643','2013-10-05','09:10:00',3.24),('7643','2013-10-05','09:15:00',1.94),('7643','2013-10-05','09:20:00',1.61),('7643','2013-10-05','09:25:00',2.2),('7643','2013-10-05','09:30:00',3.9),('7643','2013-10-05','09:35:00',5.33),('7643','2013-10-05','09:40:00',5.03),('7643','2013-10-05','09:45:00',4),('7643','2013-10-05','09:50:00',7.75),('7643','2013-10-05','09:55:00',9.22),('7643','2013-10-05','10:00:00',10.82),('7643','2013-10-05','10:05:00',11.05),('7643','2013-10-05','10:10:00',10.9),('7643','2013-10-05','10:15:00',9.97),('7643','2013-10-05','10:20:00',9.99),('7643','2013-10-05','10:25:00',11.27),('7643','2013-10-05','10:30:00',11),('7643','2013-10-05','10:35:00',10.73),('7643','2013-10-05','10:40:00',9.35),('7643','2013-10-05','10:45:00',7.79),('7643','2013-10-05','10:50:00',8.5),('7643','2013-10-05','10:55:00',9.5),('7643','2013-10-05','11:00:00',9.69),('7643','2013-10-05','11:05:00',10.36),('7643','2013-10-05','11:10:00',10.63),('7643','2013-10-05','11:15:00',9.79),('7643','2013-10-05','11:20:00',10.18),('7643','2013-10-05','11:25:00',11.05),('7643','2013-10-05','11:30:00',10.85),('7643','2013-10-05','11:35:00',10.65),('7643','2013-10-05','11:40:00',9.89),('7643','2013-10-05','11:45:00',7.38),('7643','2013-10-05','11:50:00',7.45),('7643','2013-10-05','11:55:00',9.57),('7643','2013-10-05','12:00:00',9.76),('7643','2013-10-05','12:05:00',9.78),('7643','2013-10-05','12:10:00',11.92),('7643','2013-10-05','12:15:00',11.35),('7643','2013-10-05','12:20:00',11.8),('7643','2013-10-05','12:25:00',10.16),('7643','2013-10-05','12:30:00',9.81),('7643','2013-10-05','12:35:00',10.12),('7643','2013-10-05','12:40:00',9.46),('7643','2013-10-05','12:45:00',9.3),('7643','2013-10-05','12:50:00',10.52),('7643','2013-10-05','12:55:00',12.08),('7643','2013-10-05','13:00:00',12.26),('7643','2013-10-05','13:05:00',12.11),('7643','2013-10-05','13:10:00',10.78),('7643','2013-10-05','13:15:00',10.51),('7643','2013-10-05','13:20:00',9.29),('7643','2013-10-05','13:25:00',4.13),('7643','2013-10-05','13:30:00',2.85),('7643','2013-10-05','13:35:00',2.08),('7643','2013-10-05','13:40:00',2.66),('7643','2013-10-05','13:45:00',7.25),('7643','2013-10-05','13:50:00',13.64),('7643','2013-10-05','13:55:00',10.21),('7643','2013-10-05','14:00:00',7.04),('7643','2013-10-05','14:05:00',6.57),('7643','2013-10-05','14:10:00',7.4),('7643','2013-10-05','14:15:00',5.71),('7643','2013-10-05','14:20:00',5.62),('7643','2013-10-05','14:25:00',6.19),('7643','2013-10-05','14:30:00',7.84),('7643','2013-10-05','14:35:00',8.02),('7643','2013-10-05','14:40:00',6.49),('7643','2013-10-05','14:45:00',6.04),('7643','2013-10-05','14:50:00',6.45),('7643','2013-10-05','14:55:00',9.31),('7643','2013-10-05','15:00:00',7.19),('7643','2013-10-05','15:05:00',5.13),('7643','2013-10-05','15:10:00',4.31),('7643','2013-10-05','15:15:00',3.91),('7643','2013-10-05','15:20:00',3.43),('7643','2013-10-05','15:25:00',2.69),('7643','2013-10-05','15:30:00',2.53),('7643','2013-10-05','15:35:00',2.57),('7643','2013-10-05','15:40:00',2.8),('7643','2013-10-05','15:45:00',3.13),('7643','2013-10-05','15:50:00',3.18),('7643','2013-10-05','15:55:00',4.03),('7643','2013-10-05','16:00:00',3.95),('7643','2013-10-05','16:05:00',2.81),('7643','2013-10-05','16:10:00',2.13),('7643','2013-10-05','16:15:00',1.75),('7643','2013-10-05','16:20:00',2.03),('7643','2013-10-05','16:25:00',1.8),('7643','2013-10-05','16:30:00',1.39),('7643','2013-10-05','16:35:00',1.42),('7643','2013-10-05','16:40:00',1.4),('7643','2013-10-05','16:45:00',1.37),('7643','2013-10-05','16:50:00',1.42),('7643','2013-10-05','16:55:00',1.57),('7643','2013-10-05','17:00:00',2.01),('7643','2013-10-05','17:05:00',2.29),('7643','2013-10-05','17:10:00',3.23),('7643','2013-10-05','17:15:00',3.33),('7643','2013-10-05','17:20:00',2.98),('7643','2013-10-05','17:25:00',2.23),('7643','2013-10-05','17:30:00',1.96),('7643','2013-10-05','17:35:00',1.88),('7643','2013-10-05','17:40:00',1.44),('7643','2013-10-05','17:45:00',1.4),('7643','2013-10-05','17:50:00',1.14),('7643','2013-10-04','07:45:00',1.52),('7643','2013-10-04','07:50:00',1.66),('7643','2013-10-04','07:55:00',1.61),('7643','2013-10-04','08:00:00',1.09),('7643','2013-10-04','08:35:00',1.46),('7643','2013-10-04','08:40:00',2.02),('7643','2013-10-04','08:45:00',1.54),('7643','2013-10-04','08:50:00',1.56),('7643','2013-10-04','08:55:00',1.24),('7643','2013-10-04','09:10:00',1.27),('7643','2013-10-04','14:20:00',1.03),('7643','2013-10-04','14:25:00',1.41),('7643','2013-10-04','14:30:00',1.34),('7643','2013-10-04','14:35:00',1.41),('7643','2013-10-04','14:40:00',1.77),('7643','2013-10-04','14:45:00',1.85),('7643','2013-10-04','14:50:00',2.08),('7643','2013-10-04','14:55:00',1.7),('7643','2013-10-04','15:00:00',1.98),('7643','2013-10-04','15:05:00',2.07),('7643','2013-10-04','15:10:00',1.98),('7643','2013-10-04','15:15:00',1.92),('7643','2013-10-04','15:20:00',1.96),('7643','2013-10-04','15:25:00',2.03),('7643','2013-10-04','15:30:00',2.04),('7643','2013-10-04','15:35:00',2.17),('7643','2013-10-04','15:40:00',2.52),('7643','2013-10-04','15:45:00',2.63),('7643','2013-10-04','15:50:00',2.72),('7643','2013-10-04','15:55:00',2.98),('7643','2013-10-04','16:00:00',3.38),('7643','2013-10-04','16:05:00',4.2),('7643','2013-10-04','16:10:00',4.19),('7643','2013-10-04','16:15:00',3.76),('7643','2013-10-04','16:20:00',3.97),('7643','2013-10-04','16:25:00',3.99),('7643','2013-10-04','16:30:00',3.36),('7643','2013-10-04','16:35:00',3.14),('7643','2013-10-04','16:40:00',3.42),('7643','2013-10-04','16:45:00',3.25),('7643','2013-10-04','16:50:00',3.25),('7643','2013-10-04','16:55:00',2.94),('7643','2013-10-04','17:00:00',2.96),('7643','2013-10-04','17:05:00',2.73),('7643','2013-10-04','17:10:00',2.49),('7643','2013-10-04','17:15:00',2.59),('7643','2013-10-04','17:20:00',2.19),('7643','2013-10-04','17:25:00',1.67),('7643','2013-10-04','17:30:00',1.03),('7643','2013-10-03','07:40:00',1.19),('7643','2013-10-03','07:45:00',1.13),('7643','2013-10-03','08:05:00',1.08),('7643','2013-10-03','08:10:00',1.26),('7643','2013-10-03','08:15:00',1.75),('7643','2013-10-03','08:20:00',1.54),('7643','2013-10-03','08:25:00',1.59),('7643','2013-10-03','08:30:00',2.36),('7643','2013-10-03','08:35:00',2.3),('7643','2013-10-03','08:40:00',2.2),('7643','2013-10-03','08:45:00',2.86),('7643','2013-10-03','08:50:00',2.5),('7643','2013-10-03','08:55:00',2.54),('7643','2013-10-03','09:00:00',2.73),('7643','2013-10-03','09:05:00',2.28),('7643','2013-10-03','09:10:00',2.48),('7643','2013-10-03','09:15:00',2.34),('7643','2013-10-03','09:20:00',2.59),('7643','2013-10-03','09:25:00',3.55),('7643','2013-10-03','09:30:00',4.11),('7643','2013-10-03','09:35:00',4.14),('7643','2013-10-03','09:40:00',4.04),('7643','2013-10-03','09:45:00',4.07),('7643','2013-10-03','09:50:00',4.79),('7643','2013-10-03','09:55:00',10.29),('7643','2013-10-03','10:00:00',7.44),('7643','2013-10-03','10:05:00',5.62),('7643','2013-10-03','10:10:00',5.48),('7643','2013-10-03','10:15:00',6.88),('7643','2013-10-03','10:20:00',5.43),('7643','2013-10-03','10:25:00',6.64),('7643','2013-10-03','10:30:00',9.5),('7643','2013-10-03','10:35:00',7.02),('7643','2013-10-03','10:40:00',9.68),('7643','2013-10-03','10:45:00',7.5),('7643','2013-10-03','10:50:00',6.66),('7643','2013-10-03','10:55:00',10.91),('7643','2013-10-03','11:00:00',7.63),('7643','2013-10-03','11:05:00',6.36),('7643','2013-10-03','11:10:00',5.81),('7643','2013-10-03','11:15:00',11.37),('7643','2013-10-03','11:20:00',11.33),('7643','2013-10-03','11:25:00',10.23),('7643','2013-10-03','11:30:00',13.91),('7643','2013-10-03','11:35:00',13.91),('7643','2013-10-03','11:40:00',13.67),('7643','2013-10-03','11:45:00',13.42),('7643','2013-10-03','11:50:00',13.29),('7643','2013-10-03','11:55:00',13.22),('7643','2013-10-03','12:00:00',13.37),('7643','2013-10-03','12:05:00',13.45),('7643','2013-10-03','12:10:00',13.54),('7643','2013-10-03','12:15:00',12.85),('7643','2013-10-03','12:20:00',12.48),('7643','2013-10-03','12:25:00',13.75),('7643','2013-10-03','12:30:00',13.73),('7643','2013-10-03','12:35:00',12.39),('7643','2013-10-03','12:40:00',13.51),('7643','2013-10-03','12:45:00',13.5),('7643','2013-10-03','12:50:00',12.99),('7643','2013-10-03','12:55:00',13.09),('7643','2013-10-03','13:00:00',13.18),('7643','2013-10-03','13:05:00',13.37),('7643','2013-10-03','13:10:00',13.41),('7643','2013-10-03','13:15:00',14.22),('7643','2013-10-03','13:20:00',13.79),('7643','2013-10-03','13:25:00',12.84),('7643','2013-10-03','13:30:00',13.57),('7643','2013-10-03','13:35:00',12.26),('7643','2013-10-03','13:40:00',13),('7643','2013-10-03','13:45:00',12.74),('7643','2013-10-03','13:50:00',12.63),('7643','2013-10-03','13:55:00',12.59),('7643','2013-10-03','14:00:00',12.57),('7643','2013-10-03','14:05:00',12.41),('7643','2013-10-03','14:10:00',11.33),('7643','2013-10-03','14:15:00',10.21),('7643','2013-10-03','14:20:00',11.15),('7643','2013-10-03','14:25:00',11.94),('7643','2013-10-03','14:30:00',10.51),('7643','2013-10-03','14:35:00',7.57),('7643','2013-10-03','14:40:00',5.95),('7643','2013-10-03','14:45:00',6.88),('7643','2013-10-03','14:50:00',9.05),('7643','2013-10-03','14:55:00',9.32),('7643','2013-10-03','15:00:00',7.88),('7643','2013-10-03','15:05:00',8.87),('7643','2013-10-03','15:10:00',7.71),('7643','2013-10-03','15:15:00',5.98),('7643','2013-10-03','15:20:00',5.2),('7643','2013-10-03','15:25:00',8.27),('7643','2013-10-03','15:30:00',10.02),('7643','2013-10-03','15:35:00',5.5),('7643','2013-10-03','15:40:00',3.17),('7643','2013-10-03','15:45:00',2.64),('7643','2013-10-03','15:50:00',2.46),('7643','2013-10-03','15:55:00',2.77),('7643','2013-10-03','16:00:00',3.44),('7643','2013-10-03','16:05:00',3.89),('7643','2013-10-03','16:10:00',3.66),('7643','2013-10-03','16:15:00',3.27),('7643','2013-10-03','16:20:00',2.81),('7643','2013-10-03','16:25:00',2.35),('7643','2013-10-03','16:30:00',2.18),('7643','2013-10-03','16:35:00',2.17),('7643','2013-10-03','16:40:00',2.07),('7643','2013-10-03','16:45:00',1.94),('7643','2013-10-03','16:50:00',1.92),('7643','2013-10-03','16:55:00',1.85),('7643','2013-10-03','17:00:00',1.74),('7643','2013-10-03','17:05:00',1.78),('7643','2013-10-03','17:10:00',1.59),('7643','2013-10-03','17:15:00',1.18),('7643','2013-10-03','17:20:00',1.01),('7643','2013-10-03','17:25:00',1.01),('7643','2013-10-02','07:45:00',1.1),('7643','2013-10-02','07:50:00',1.38),('7643','2013-10-02','07:55:00',1.69),('7643','2013-10-02','08:00:00',2.01),('7643','2013-10-02','08:05:00',2.34),('7643','2013-10-02','08:10:00',2),('7643','2013-10-02','08:15:00',3.05),('7643','2013-10-02','08:20:00',3.41),('7643','2013-10-02','08:25:00',3.77),('7643','2013-10-02','08:30:00',4.13),('7643','2013-10-02','08:35:00',4.46),('7643','2013-10-02','08:40:00',4.82),('7643','2013-10-02','08:45:00',5.19),('7643','2013-10-02','08:50:00',5.54),('7643','2013-10-02','08:55:00',5.92),('7643','2013-10-02','09:00:00',6.26),('7643','2013-10-02','09:05:00',6.57),('7643','2013-10-02','09:10:00',6.95),('7643','2013-10-02','09:15:00',7.31),('7643','2013-10-02','09:20:00',7.61),('7643','2013-10-02','09:25:00',7.94),('7643','2013-10-02','09:30:00',8.25),('7643','2013-10-02','09:35:00',8.55),('7643','2013-10-02','09:40:00',8.87),('7643','2013-10-02','09:45:00',9.17),('7643','2013-10-02','09:50:00',9.45),('7643','2013-10-02','09:55:00',9.72),('7643','2013-10-02','10:00:00',10.02),('7643','2013-10-02','10:05:00',10.28),('7643','2013-10-02','10:10:00',10.51),('7643','2013-10-02','10:15:00',10.76),('7643','2013-10-02','10:20:00',11),('7643','2013-10-02','10:25:00',11.26),('7643','2013-10-02','10:30:00',11.45),('7643','2013-10-02','10:35:00',11.68),('7643','2013-10-02','10:40:00',11.87),('7643','2013-10-02','10:45:00',12.06),('7643','2013-10-02','10:50:00',12.23),('7643','2013-10-02','10:55:00',12.39),('7643','2013-10-02','11:00:00',12.56),('7643','2013-10-02','11:05:00',12.78),('7643','2013-10-02','11:10:00',12.97),('7643','2013-10-02','11:15:00',13.09),('7643','2013-10-02','11:20:00',13.21),('7643','2013-10-02','11:25:00',13.39),('7643','2013-10-02','11:30:00',13.45),('7643','2013-10-02','11:35:00',13.61),('7643','2013-10-02','11:40:00',13.74),('7643','2013-10-02','11:45:00',13.84),('7643','2013-10-02','11:50:00',13.97),('7643','2013-10-02','11:55:00',14.1),('7643','2013-10-02','12:00:00',14.13),('7643','2013-10-02','12:05:00',14.17),('7643','2013-10-02','12:10:00',14.21),('7643','2013-10-02','12:15:00',14.17),('7643','2013-10-02','12:20:00',14.24),('7643','2013-10-02','12:25:00',14.26),('7643','2013-10-02','12:30:00',14.29),('7643','2013-10-02','12:35:00',14.31),('7643','2013-10-02','12:40:00',14.29),('7643','2013-10-02','12:45:00',14.27),('7643','2013-10-02','12:50:00',14.25),('7643','2013-10-02','12:55:00',14.22),('7643','2013-10-02','13:00:00',14.07),('7643','2013-10-02','13:05:00',13.81),('7643','2013-10-02','13:10:00',14.08),('7643','2013-10-02','13:15:00',14.09),('7643','2013-10-02','13:20:00',14.03),('7643','2013-10-02','13:25:00',13.96),('7643','2013-10-02','13:30:00',14),('7643','2013-10-02','13:35:00',13.98),('7643','2013-10-02','13:40:00',13.9),('7643','2013-10-02','13:45:00',13.75),('7643','2013-10-02','13:50:00',13.75),('7643','2013-10-02','13:55:00',13.73),('7643','2013-10-02','14:00:00',13.62),('7643','2013-10-02','14:05:00',13.45),('7643','2013-10-02','14:10:00',13.37),('7643','2013-10-02','14:15:00',13.23),('7643','2013-10-02','14:20:00',13.1),('7643','2013-10-02','14:25:00',12.95),('7643','2013-10-02','14:30:00',12.86),('7643','2013-10-02','14:35:00',12.72),('7643','2013-10-02','14:40:00',12.48),('7643','2013-10-02','14:45:00',12.27),('7643','2013-10-02','14:50:00',12.08),('7643','2013-10-02','14:55:00',11.85),('7643','2013-10-02','15:00:00',11.7),('7643','2013-10-02','15:05:00',11.51),('7643','2013-10-02','15:10:00',11.28),('7643','2013-10-02','15:15:00',11.14),('7643','2013-10-02','15:20:00',10.93),('7643','2013-10-02','15:25:00',10.65),('7643','2013-10-02','15:30:00',10.46),('7643','2013-10-02','15:35:00',10.18),('7643','2013-10-02','15:40:00',9.9),('7643','2013-10-02','15:45:00',9.61),('7643','2013-10-02','15:50:00',9.36),('7643','2013-10-02','15:55:00',9.12),('7643','2013-10-02','16:00:00',8.82),('7643','2013-10-02','16:05:00',8.51),('7643','2013-10-02','16:10:00',8.24),('7643','2013-10-02','16:15:00',7.91),('7643','2013-10-02','16:20:00',7.62),('7643','2013-10-02','16:25:00',7.3),('7643','2013-10-02','16:30:00',7.01),('7643','2013-10-02','16:35:00',6.66),('7643','2013-10-02','16:40:00',6.33),('7643','2013-10-02','16:45:00',6),('7643','2013-10-02','16:50:00',5.65),('7643','2013-10-02','16:55:00',5.29),('7643','2013-10-02','17:00:00',4.94),('7643','2013-10-02','17:05:00',4.61),('7643','2013-10-02','17:10:00',4.25),('7643','2013-10-02','17:15:00',3.89),('7643','2013-10-02','17:20:00',3.54),('7643','2013-10-02','17:25:00',3.19),('7643','2013-10-02','17:30:00',2.86),('7643','2013-10-02','17:35:00',2.52),('7643','2013-10-02','17:40:00',2.2),('7643','2013-10-02','17:45:00',1.89),('7643','2013-10-02','17:50:00',1.59),('7643','2013-10-02','17:55:00',1.31),('7643','2013-10-02','18:00:00',1.06),('7643','2013-10-01','07:50:00',1.22),('7643','2013-10-01','08:00:00',1.33),('7643','2013-10-01','08:05:00',1.65),('7643','2013-10-01','08:10:00',2.3),('7643','2013-10-01','08:15:00',3.09),('7643','2013-10-01','08:20:00',3.96),('7643','2013-10-01','08:25:00',4.15),('7643','2013-10-01','08:30:00',4.04),('7643','2013-10-01','08:35:00',4.12),('7643','2013-10-01','08:40:00',4.5),('7643','2013-10-01','08:45:00',4.88),('7643','2013-10-01','08:50:00',5.22),('7643','2013-10-01','08:55:00',5.56),('7643','2013-10-01','09:00:00',5.92),('7643','2013-10-01','09:05:00',6.25),('7643','2013-10-01','09:10:00',6.57),('7643','2013-10-01','09:15:00',6.9),('7643','2013-10-01','09:20:00',7.2),('7643','2013-10-01','09:25:00',7.51),('7643','2013-10-01','09:30:00',7.81),('7643','2013-10-01','09:35:00',8.08),('7643','2013-10-01','09:40:00',8.37),('7643','2013-10-01','09:45:00',8.63),('7643','2013-10-01','09:50:00',8.87),('7643','2013-10-01','09:55:00',9.11),('7643','2013-10-01','10:00:00',9.35),('7643','2013-10-01','10:05:00',9.52),('7643','2013-10-01','10:10:00',9.75),('7643','2013-10-01','10:15:00',9.99),('7643','2013-10-01','10:20:00',10.28),('7643','2013-10-01','10:25:00',10.5),('7643','2013-10-01','10:30:00',10.77),('7643','2013-10-01','10:35:00',11.02),('7643','2013-10-01','10:40:00',11.26),('7643','2013-10-01','10:45:00',11.51),('7643','2013-10-01','10:50:00',11.67),('7643','2013-10-01','10:55:00',11.93),('7643','2013-10-01','11:00:00',12.12),('7643','2013-10-01','11:05:00',12.29),('7643','2013-10-01','11:10:00',12.45),('7643','2013-10-01','11:15:00',12.57),('7643','2013-10-01','11:20:00',12.69),('7643','2013-10-01','11:25:00',12.8),('7643','2013-10-01','11:30:00',12.93),('7643','2013-10-01','11:35:00',13.06),('7643','2013-10-01','11:40:00',13.15),('7643','2013-10-01','11:45:00',13.23),('7643','2013-10-01','11:50:00',13.35),('7643','2013-10-01','11:55:00',13.46),('7643','2013-10-01','12:00:00',13.5),('7643','2013-10-01','12:05:00',13.51),('7643','2013-10-01','12:10:00',13.57),('7643','2013-10-01','12:15:00',13.62),('7643','2013-10-01','12:20:00',13.66),('7643','2013-10-01','12:25:00',13.61),('7643','2013-10-01','12:30:00',13.66),('7643','2013-10-01','12:35:00',13.69),('7643','2013-10-01','12:40:00',13.72),('7643','2013-10-01','12:45:00',13.78),('7643','2013-10-01','12:50:00',13.81),('7643','2013-10-01','12:55:00',13.83),('7643','2013-10-01','13:00:00',13.85),('7643','2013-10-01','13:05:00',13.83),('7643','2013-10-01','13:10:00',13.86),('7643','2013-10-01','13:15:00',13.83),('7643','2013-10-01','13:20:00',13.73),('7643','2013-10-01','13:25:00',13.75),('7643','2013-10-01','13:30:00',13.66),('7643','2013-10-01','13:35:00',13.53),('7643','2013-10-01','13:40:00',13.49),('7643','2013-10-01','13:45:00',13.44),('7643','2013-10-01','13:50:00',13.34),('7643','2013-10-01','13:55:00',13.31),('7643','2013-10-01','14:00:00',13.23),('7643','2013-10-01','14:05:00',13.1),('7643','2013-10-01','14:10:00',12.99),('7643','2013-10-01','14:15:00',12.87),('7643','2013-10-01','14:20:00',12.71),('7643','2013-10-01','14:25:00',12.62),('7643','2013-10-01','14:30:00',12.47),('7643','2013-10-01','14:35:00',12.36),('7643','2013-10-01','14:40:00',12.19),('7643','2013-10-01','14:45:00',12.02),('7643','2013-10-01','14:50:00',11.87),('7643','2013-10-01','14:55:00',11.67),('7643','2013-10-01','15:00:00',11.48),('7643','2013-10-01','15:05:00',11.29),('7643','2013-10-01','15:10:00',11.06),('7643','2013-10-01','15:15:00',10.88),('7643','2013-10-01','15:20:00',10.67),('7643','2013-10-01','15:25:00',10.38),('7643','2013-10-01','15:30:00',10.17),('7643','2013-10-01','15:35:00',9.94),('7643','2013-10-01','15:40:00',9.69),('7643','2013-10-01','15:45:00',9.47),('7643','2013-10-01','15:50:00',9.2),('7643','2013-10-01','15:55:00',8.92),('7643','2013-10-01','16:00:00',8.62),('7643','2013-10-01','16:05:00',8.38),('7643','2013-10-01','16:10:00',8.04),('7643','2013-10-01','16:15:00',7.74),('7643','2013-10-01','16:20:00',7.43),('7643','2013-10-01','16:25:00',7.13),('7643','2013-10-01','16:30:00',6.84),('7643','2013-10-01','16:35:00',6.56),('7643','2013-10-01','16:40:00',6.22),('7643','2013-10-01','16:45:00',5.86),('7643','2013-10-01','16:50:00',5.54),('7643','2013-10-01','16:55:00',5.2),('7643','2013-10-01','17:00:00',4.88),('7643','2013-10-01','17:05:00',4.55),('7643','2013-10-01','17:10:00',4.19),('7643','2013-10-01','17:15:00',3.82),('7643','2013-10-01','17:20:00',3.51),('7643','2013-10-01','17:25:00',3.17),('7643','2013-10-01','17:30:00',2.77),('7643','2013-10-01','17:35:00',2.44),('7643','2013-10-01','17:40:00',2.01),('7643','2013-10-01','17:45:00',1.59),('7643','2013-10-01','17:50:00',1.61),('7643','2013-10-01','17:55:00',1.35),('7643','2013-10-01','18:00:00',1.03),('7643','2013-09-30','07:55:00',1.45),('7643','2013-09-30','08:00:00',2.03),('7643','2013-09-30','08:05:00',2.39),('7643','2013-09-30','08:10:00',2.39),('7643','2013-09-30','08:15:00',1.54),('7643','2013-09-30','08:20:00',1.69),('7643','2013-09-30','08:25:00',3.71),('7643','2013-09-30','08:30:00',3.5),('7643','2013-09-30','08:35:00',4.01),('7643','2013-09-30','08:40:00',4.5),('7643','2013-09-30','08:45:00',4.98),('7643','2013-09-30','08:50:00',5.3),('7643','2013-09-30','08:55:00',5.63),('7643','2013-09-30','09:00:00',5.98),('7643','2013-09-30','09:05:00',6.31),('7643','2013-09-30','09:10:00',6.6),('7643','2013-09-30','09:15:00',6.94),('7643','2013-09-30','09:20:00',7.21),('7643','2013-09-30','09:25:00',7.46),('7643','2013-09-30','09:30:00',7.73),('7643','2013-09-30','09:35:00',7.93),('7643','2013-09-30','09:40:00',8.19),('7643','2013-09-30','09:45:00',8.4),('7643','2013-09-30','09:50:00',8.65),('7643','2013-09-30','09:55:00',8.85),('7643','2013-09-30','10:00:00',9.22),('7643','2013-09-30','10:05:00',9.37),('7643','2013-09-30','10:10:00',9.63),('7643','2013-09-30','10:15:00',9.84),('7643','2013-09-30','10:20:00',9.83),('7643','2013-09-30','10:25:00',10.1),('7643','2013-09-30','10:30:00',10.57),('7643','2013-09-30','10:35:00',10.68),('7643','2013-09-30','10:40:00',10.86),('7643','2013-09-30','10:45:00',11.14),('7643','2013-09-30','10:50:00',11.46),('7643','2013-09-30','10:55:00',11.69),('7643','2013-09-30','11:00:00',11.78),('7643','2013-09-30','11:05:00',12.38),('7643','2013-09-30','11:10:00',13.33),('7643','2013-09-30','11:15:00',11.63),('7643','2013-09-30','11:20:00',9.07),('7643','2013-09-30','11:25:00',10.99),('7643','2013-09-30','11:30:00',13.4),('7643','2013-09-30','11:35:00',7.2),('7643','2013-09-30','11:40:00',5.76),('7643','2013-09-30','11:45:00',13.8),('7643','2013-09-30','11:50:00',13.68),('7643','2013-09-30','11:55:00',13.68),('7643','2013-09-30','12:00:00',13.45),('7643','2013-09-30','12:05:00',13.57),('7643','2013-09-30','12:10:00',12.73),('7643','2013-09-30','12:15:00',13.25),('7643','2013-09-30','12:20:00',13.58),('7643','2013-09-30','12:25:00',13.98),('7643','2013-09-30','12:30:00',14.25),('7643','2013-09-30','12:35:00',14.51),('7643','2013-09-30','12:40:00',4.21),('7643','2013-09-30','12:45:00',14.72),('7643','2013-09-30','12:50:00',9.75),('7643','2013-09-30','12:55:00',10.97),('7643','2013-09-30','13:00:00',12.79),('7643','2013-09-30','13:05:00',13.6),('7643','2013-09-30','13:10:00',2.85),('7643','2013-09-30','13:15:00',2.71),('7643','2013-09-30','13:20:00',9.88),('7643','2013-09-30','13:25:00',15.15),('7643','2013-09-30','13:30:00',15.32),('7643','2013-09-30','13:35:00',12.68),('7643','2013-09-30','13:40:00',14.66),('7643','2013-09-30','13:45:00',14.34),('7643','2013-09-30','13:50:00',14),('7643','2013-09-30','13:55:00',13.61),('7643','2013-09-30','14:00:00',12.98),('7643','2013-09-30','14:05:00',12.66),('7643','2013-09-30','14:10:00',12.61),('7643','2013-09-30','14:15:00',12.38),('7643','2013-09-30','14:20:00',12.23),('7643','2013-09-30','14:25:00',12.22),('7643','2013-09-30','14:30:00',11.87),('7643','2013-09-30','14:35:00',11.74),('7643','2013-09-30','14:40:00',11.55),('7643','2013-09-30','14:45:00',11.68),('7643','2013-09-30','14:50:00',11.05),('7643','2013-09-30','14:55:00',11.83),('7643','2013-09-30','15:00:00',11.57),('7643','2013-09-30','15:05:00',11.14),('7643','2013-09-30','15:10:00',10.96),('7643','2013-09-30','15:15:00',10.77),('7643','2013-09-30','15:20:00',10.6),('7643','2013-09-30','15:25:00',10.39),('7643','2013-09-30','15:30:00',10.13),('7643','2013-09-30','15:35:00',9.9),('7643','2013-09-30','15:40:00',9.67),('7643','2013-09-30','15:45:00',9.37),('7643','2013-09-30','15:50:00',9.11),('7643','2013-09-30','15:55:00',8.86),('7643','2013-09-30','16:00:00',8.53),('7643','2013-09-30','16:05:00',8.32),('7643','2013-09-30','16:10:00',8.02),('7643','2013-09-30','16:15:00',7.76),('7643','2013-09-30','16:20:00',7.49),('7643','2013-09-30','16:25:00',7.21),('7643','2013-09-30','16:30:00',6.88),('7643','2013-09-30','16:35:00',6.57),('7643','2013-09-30','16:40:00',6.23),('7643','2013-09-30','16:45:00',5.86),('7643','2013-09-30','16:50:00',5.57),('7643','2013-09-30','16:55:00',5.28),('7643','2013-09-30','17:00:00',4.99),('7643','2013-09-30','17:05:00',4.62),('7643','2013-09-30','17:10:00',4.28),('7643','2013-09-30','17:15:00',3.95),('7643','2013-09-30','17:20:00',3.58),('7643','2013-09-30','17:25:00',3.3),('7643','2013-09-30','17:30:00',2.96),('7643','2013-09-30','17:35:00',2.63),('7643','2013-09-30','17:40:00',2.29),('7643','2013-09-30','17:45:00',1.96),('7643','2013-09-30','17:50:00',1.67),('7643','2013-09-30','17:55:00',1.4),('7643','2013-09-30','18:00:00',1.14),('7643','2013-09-29','08:45:00',1.12),('7643','2013-09-29','08:50:00',1.01),('7643','2013-09-29','08:55:00',1.23),('7643','2013-09-29','09:00:00',1.19),('7643','2013-09-29','09:05:00',1.2),('7643','2013-09-29','09:10:00',1.16),('7643','2013-09-29','09:15:00',1.33),('7643','2013-09-29','09:20:00',1.63),('7643','2013-09-29','09:25:00',1.92),('7643','2013-09-29','09:30:00',1.6),('7643','2013-09-29','09:35:00',2.34),('7643','2013-09-29','09:40:00',2.59),('7643','2013-09-29','09:45:00',3.39),('7643','2013-09-29','09:50:00',4.47),('7643','2013-09-29','09:55:00',3.8),('7643','2013-09-29','10:00:00',3.66),('7643','2013-09-29','10:05:00',3.52),('7643','2013-09-29','10:10:00',3.82),('7643','2013-09-29','10:15:00',3.88),('7643','2013-09-29','10:20:00',3.91),('7643','2013-09-29','10:25:00',4.65),('7643','2013-09-29','10:30:00',5.31),('7643','2013-09-29','10:35:00',6.09),('7643','2013-09-29','10:40:00',7.97),('7643','2013-09-29','10:45:00',11.97),('7643','2013-09-29','10:50:00',12.47),('7643','2013-09-29','10:55:00',11.35),('7643','2013-09-29','11:00:00',7.93),('7643','2013-09-29','11:05:00',10.68),('7643','2013-09-29','11:10:00',7.77),('7643','2013-09-29','11:15:00',10.59),('7643','2013-09-29','11:20:00',10.29),('7643','2013-09-29','11:25:00',11.02),('7643','2013-09-29','11:30:00',6.77),('7643','2013-09-29','11:35:00',6.71),('7643','2013-09-29','11:40:00',13.52),('7643','2013-09-29','11:45:00',8.09),('7643','2013-09-29','11:50:00',6.14),('7643','2013-09-29','11:55:00',5.87),('7643','2013-09-29','12:00:00',5.81),('7643','2013-09-29','12:05:00',7.52),('7643','2013-09-29','12:10:00',4.98),('7643','2013-09-29','12:15:00',12.96),('7643','2013-09-29','12:20:00',14.66),('7643','2013-09-29','12:25:00',14.59),('7643','2013-09-29','12:30:00',14.24),('7643','2013-09-29','12:35:00',11.78),('7643','2013-09-29','12:40:00',14.57),('7643','2013-09-29','12:45:00',6.61),('7643','2013-09-29','12:50:00',14.5),('7643','2013-09-29','12:55:00',14.62),('7643','2013-09-29','13:00:00',14.55),('7643','2013-09-29','13:05:00',14.99),('7643','2013-09-29','13:10:00',14.87),('7643','2013-09-29','13:15:00',15.01),('7643','2013-09-29','13:20:00',15.59),('7643','2013-09-29','13:25:00',15.49),('7643','2013-09-29','13:30:00',15.83),('7643','2013-09-29','13:35:00',12.9),('7643','2013-09-29','13:40:00',14.3),('7643','2013-09-29','13:45:00',10.98),('7643','2013-09-29','13:50:00',8.96),('7643','2013-09-29','13:55:00',6.47),('7643','2013-09-29','14:00:00',8.73),('7643','2013-09-29','14:05:00',5.13),('7643','2013-09-29','14:10:00',4.71),('7643','2013-09-29','14:15:00',4.52),('7643','2013-09-29','14:20:00',3.78),('7643','2013-09-29','14:25:00',4.23),('7643','2013-09-29','14:30:00',9.35),('7643','2013-09-29','14:35:00',9.94),('7643','2013-09-29','14:40:00',13.18),('7643','2013-09-29','14:45:00',14.54),('7643','2013-09-29','14:50:00',10.15),('7643','2013-09-29','14:55:00',9.35),('7643','2013-09-29','15:00:00',6.18),('7643','2013-09-29','15:05:00',7.33),('7643','2013-09-29','15:10:00',13.86),('7643','2013-09-29','15:15:00',12.74),('7643','2013-09-29','15:20:00',5.69),('7643','2013-09-29','15:25:00',10.09),('7643','2013-09-29','15:30:00',10.1),('7643','2013-09-29','15:35:00',10.71),('7643','2013-09-29','15:40:00',11.63),('7643','2013-09-29','15:45:00',8.43),('7643','2013-09-29','15:50:00',1.76),('7643','2013-09-29','15:55:00',1.9),('7643','2013-09-29','16:00:00',1.89),('7643','2013-09-29','16:05:00',1.49),('7643','2013-09-29','16:10:00',3.16),('7643','2013-09-29','16:15:00',4.56),('7643','2013-09-29','16:20:00',8.36),('7643','2013-09-29','16:25:00',4.55),('7643','2013-09-29','16:30:00',2.52),('7643','2013-09-29','16:35:00',2.32),('7643','2013-09-29','16:40:00',5.84),('7643','2013-09-29','16:45:00',5.8),('7643','2013-09-29','16:50:00',4.88),('7643','2013-09-29','16:55:00',3.05),('7643','2013-09-29','17:00:00',3.26),('7643','2013-09-29','17:05:00',2.78),('7643','2013-09-29','17:10:00',2.07),('7643','2013-09-29','17:15:00',2.46),('7643','2013-09-29','17:20:00',4.78),('7643','2013-09-29','17:25:00',3.64),('7643','2013-09-29','17:30:00',3.01),('7643','2013-09-29','17:35:00',2.05),('7643','2013-09-29','17:40:00',1.67),('7643','2013-09-29','17:45:00',1.55),('7643','2013-09-29','17:50:00',1.34),('7643','2013-09-29','17:55:00',1.28),('7643','2013-09-28','07:45:00',1.19),('7643','2013-09-28','07:50:00',1.43),('7643','2013-09-28','07:55:00',1.4),('7643','2013-09-28','08:00:00',1.27),('7643','2013-09-28','08:05:00',1.2),('7643','2013-09-28','08:10:00',1.21),('7643','2013-09-28','08:15:00',1.4),('7643','2013-09-28','08:20:00',1.54),('7643','2013-09-28','08:25:00',1.63),('7643','2013-09-28','08:30:00',1.62),('7643','2013-09-28','08:35:00',1.89),('7643','2013-09-28','08:40:00',2.56),('7643','2013-09-28','08:45:00',3.34),('7643','2013-09-28','08:50:00',4.41),('7643','2013-09-28','08:55:00',3.82),('7643','2013-09-28','09:00:00',3.66),('7643','2013-09-28','09:05:00',3.16),('7643','2013-09-28','09:10:00',3.56),('7643','2013-09-28','09:15:00',4.7),('7643','2013-09-28','09:20:00',3.14),('7643','2013-09-28','09:25:00',3.18),('7643','2013-09-28','09:30:00',3.1),('7643','2013-09-28','09:35:00',2.99),('7643','2013-09-28','09:40:00',2.92),('7643','2013-09-28','09:45:00',3.36),('7643','2013-09-28','09:50:00',3.64),('7643','2013-09-28','09:55:00',3.72),('7643','2013-09-28','10:00:00',4.35),('7643','2013-09-28','10:05:00',6.06),('7643','2013-09-28','10:10:00',7.2),('7643','2013-09-28','10:15:00',9.16),('7643','2013-09-28','10:20:00',8.35),('7643','2013-09-28','10:25:00',7.43),('7643','2013-09-28','10:30:00',8.33),('7643','2013-09-28','10:35:00',8.81),('7643','2013-09-28','10:40:00',8.98),('7643','2013-09-28','10:45:00',9.73),('7643','2013-09-28','10:50:00',10.3),('7643','2013-09-28','10:55:00',10.29),('7643','2013-09-28','11:00:00',10.5),('7643','2013-09-28','11:05:00',10.15),('7643','2013-09-28','11:10:00',10.15),('7643','2013-09-28','11:15:00',10.97),('7643','2013-09-28','11:20:00',10.89),('7643','2013-09-28','11:25:00',10.02),('7643','2013-09-28','11:30:00',10.92),('7643','2013-09-28','11:35:00',10.89),('7643','2013-09-28','11:40:00',11.27),('7643','2013-09-28','11:45:00',11.72),('7643','2013-09-28','11:50:00',12.16),('7643','2013-09-28','11:55:00',12.11),('7643','2013-09-28','12:00:00',12.03),('7643','2013-09-28','12:05:00',11.82),('7643','2013-09-28','12:10:00',10.8),('7643','2013-09-28','12:15:00',13.39),('7643','2013-09-28','12:20:00',10.96),('7643','2013-09-28','12:25:00',6.64),('7643','2013-09-28','12:30:00',6.89),('7643','2013-09-28','12:35:00',6.95),('7643','2013-09-28','12:40:00',5.92),('7643','2013-09-28','12:45:00',5.29),('7643','2013-09-28','12:50:00',5.41),('7643','2013-09-28','12:55:00',4.62),('7643','2013-09-28','13:00:00',4.85),('7643','2013-09-28','13:05:00',3.91),('7643','2013-09-28','13:10:00',4.09),('7643','2013-09-28','13:15:00',3.24),('7643','2013-09-28','13:20:00',3.32),('7643','2013-09-28','13:25:00',5.1),('7643','2013-09-28','13:30:00',8.39),('7643','2013-09-28','13:35:00',5.76),('7643','2013-09-28','13:40:00',5.65),('7643','2013-09-28','13:45:00',5.39),('7643','2013-09-28','13:50:00',5.8),('7643','2013-09-28','13:55:00',8.34),('7643','2013-09-28','14:00:00',7.54),('7643','2013-09-28','14:05:00',10.31),('7643','2013-09-28','14:10:00',4.89),('7643','2013-09-28','14:15:00',6.02),('7643','2013-09-28','14:20:00',7.57),('7643','2013-09-28','14:25:00',5.78),('7643','2013-09-28','14:30:00',4.66),('7643','2013-09-28','14:35:00',4.58),('7643','2013-09-28','14:40:00',4.26),('7643','2013-09-28','14:45:00',2.95),('7643','2013-09-28','14:50:00',3.4),('7643','2013-09-28','14:55:00',3.76),('7643','2013-09-28','15:00:00',4.65),('7643','2013-09-28','15:05:00',2.05),('7643','2013-09-28','15:10:00',1.09),('7643','2013-09-28','15:15:00',2.36),('7643','2013-09-28','15:20:00',3.54),('7643','2013-09-28','15:25:00',2.85),('7643','2013-09-28','15:30:00',2.68),('7643','2013-09-28','15:35:00',2.43),('7643','2013-09-28','15:40:00',3.01),('7643','2013-09-28','15:45:00',2.42),('7643','2013-09-28','15:50:00',2.12),('7643','2013-09-28','15:55:00',3.16),('7643','2013-09-28','16:00:00',4.19),('7643','2013-09-28','16:05:00',3.39),('7643','2013-09-28','16:10:00',2.32),('7643','2013-09-28','16:15:00',1.71),('7643','2013-09-28','16:20:00',2.27),('7643','2013-09-28','16:25:00',2.76),('7643','2013-09-28','16:30:00',3.75),('7643','2013-09-28','16:35:00',3.51),('7643','2013-09-28','16:40:00',3.03),('7643','2013-09-28','16:45:00',2.8),('7643','2013-09-28','16:50:00',1.7),('7643','2013-09-28','16:55:00',1.31),('7643','2013-09-28','17:00:00',1.53),('7643','2013-09-28','17:05:00',2.18),('7643','2013-09-28','17:10:00',1.51),('7643','2013-09-28','17:15:00',1.6),('7643','2013-09-28','17:20:00',1.81),('7643','2013-09-28','17:25:00',1.69),('7643','2013-09-28','17:30:00',1.27),('7643','2014-04-13','07:15:00',1.13),('7643','2014-04-13','07:20:00',1.37),('7643','2014-04-13','07:25:00',1.65),('7643','2014-04-13','07:30:00',1.94),('7643','2014-04-13','07:35:00',2.27),('7643','2014-04-13','07:40:00',2.6),('7643','2014-04-13','07:45:00',2.95),('7643','2014-04-13','07:50:00',3.32),('7643','2014-04-13','07:55:00',3.68),('7643','2014-04-13','08:00:00',4.1),('7643','2014-04-13','08:05:00',4.52),('7643','2014-04-13','08:10:00',4.91),('7643','2014-04-13','08:15:00',5.33),('7643','2014-04-13','08:20:00',5.74),('7643','2014-04-13','08:25:00',6.12),('7643','2014-04-13','08:30:00',6.51),('7643','2014-04-13','08:35:00',6.89),('7643','2014-04-13','08:40:00',7.26),('7643','2014-04-13','08:45:00',7.6),('7643','2014-04-13','08:50:00',7.91),('7643','2014-04-13','08:55:00',8.24),('7643','2014-04-13','09:00:00',8.57),('7643','2014-04-13','09:05:00',8.95),('7643','2014-04-13','09:10:00',9.28),('7643','2014-04-13','09:15:00',9.57),('7643','2014-04-13','09:20:00',9.86),('7643','2014-04-13','09:25:00',10.16),('7643','2014-04-13','09:30:00',10.45),('7643','2014-04-13','09:35:00',10.67),('7643','2014-04-13','09:40:00',10.92),('7643','2014-04-13','09:45:00',11.23),('7643','2014-04-13','09:50:00',11.49),('7643','2014-04-13','09:55:00',11.79),('7643','2014-04-13','10:00:00',12.08),('7643','2014-04-13','10:05:00',12.32),('7643','2014-04-13','10:10:00',12.58),('7643','2014-04-13','10:15:00',12.86),('7643','2014-04-13','10:20:00',13.08),('7643','2014-04-13','10:25:00',13.34),('7643','2014-04-13','10:30:00',13.5),('7643','2014-04-13','10:35:00',13.7),('7643','2014-04-13','10:40:00',13.89),('7643','2014-04-13','10:45:00',14.04),('7643','2014-04-13','10:50:00',14.24),('7643','2014-04-13','10:55:00',14.37),('7643','2014-04-13','11:00:00',14.53),('7643','2014-04-13','11:05:00',14.63),('7643','2014-04-13','11:10:00',14.71),('7643','2014-04-13','11:15:00',14.93),('7643','2014-04-13','11:20:00',15.11),('7643','2014-04-13','11:25:00',15.22),('7643','2014-04-13','11:30:00',15.39),('7643','2014-04-13','11:35:00',15.52),('7643','2014-04-13','11:40:00',15.6),('7643','2014-04-13','11:45:00',15.75),('7643','2014-04-13','11:50:00',15.88),('7643','2014-04-13','11:55:00',15.87),('7643','2014-04-13','12:00:00',15.99),('7643','2014-04-13','12:05:00',16.02),('7643','2014-04-13','12:10:00',16.06),('7643','2014-04-13','12:15:00',16.2),('7643','2014-04-13','12:20:00',16.26),('7643','2014-04-13','12:25:00',16.23),('7643','2014-04-13','12:30:00',16.37),('7643','2014-04-13','12:35:00',16.21),('7643','2014-04-13','12:40:00',16.3),('7643','2014-04-13','12:45:00',16.36),('7643','2014-04-13','12:50:00',16.41),('7643','2014-04-13','12:55:00',16.56),('7643','2014-04-13','13:00:00',16.68),('7643','2014-04-13','13:05:00',16.65),('7643','2014-04-13','13:10:00',16.62),('7643','2014-04-13','13:15:00',16.53),('7643','2014-04-13','13:20:00',16.63),('7643','2014-04-13','13:25:00',16.63),('7643','2014-04-13','13:30:00',16.64),('7643','2014-04-13','13:35:00',16.66),('7643','2014-04-13','13:40:00',16.58),('7643','2014-04-13','13:45:00',16.71),('7643','2014-04-13','13:50:00',16.74),('7643','2014-04-13','13:55:00',16.63),('7643','2014-04-13','14:00:00',16.62),('7643','2014-04-13','14:05:00',16.45),('7643','2014-04-13','14:10:00',16.36),('7643','2014-04-13','14:15:00',16.28),('7643','2014-04-13','14:20:00',16.26),('7643','2014-04-13','14:25:00',16.21),('7643','2014-04-13','14:30:00',16.06),('7643','2014-04-13','14:35:00',16.02),('7643','2014-04-13','14:40:00',15.84),('7643','2014-04-13','14:45:00',15.71),('7643','2014-04-13','14:50:00',15.61),('7643','2014-04-13','14:55:00',15.51),('7643','2014-04-13','15:00:00',15.38),('7643','2014-04-13','15:05:00',15.24),('7643','2014-04-13','15:10:00',15.01),('7643','2014-04-13','15:15:00',14.86),('7643','2014-04-13','15:20:00',14.59),('7643','2014-04-13','15:25:00',14.43),('7643','2014-04-13','15:30:00',14.26),('7643','2014-04-13','15:35:00',13.95),('7643','2014-04-13','15:40:00',13.73),('7643','2014-04-13','15:45:00',13.55),('7643','2014-04-13','15:50:00',13.37),('7643','2014-04-13','15:55:00',13.16),('7643','2014-04-13','16:00:00',12.92),('7643','2014-04-13','16:05:00',12.62),('7643','2014-04-13','16:10:00',12.34),('7643','2014-04-13','16:15:00',12.08),('7643','2014-04-13','16:20:00',11.75),('7643','2014-04-13','16:25:00',11.45),('7643','2014-04-13','16:30:00',11.13),('7643','2014-04-13','16:35:00',10.92),('7643','2014-04-13','16:40:00',10.59),('7643','2014-04-13','16:45:00',10.24),('7643','2014-04-13','16:50:00',9.92),('7643','2014-04-13','16:55:00',9.59),('7643','2014-04-13','17:00:00',9.25),('7643','2014-04-13','17:05:00',8.9),('7643','2014-04-13','17:10:00',8.57),('7643','2014-04-13','17:15:00',8.18),('7643','2014-04-13','17:20:00',7.87),('7643','2014-04-13','17:25:00',7.52),('7643','2014-04-13','17:30:00',7.13),('7643','2014-04-13','17:35:00',6.71),('7643','2014-04-13','17:40:00',6.29),('7643','2014-04-13','17:45:00',5.89),('7643','2014-04-13','17:50:00',5.47),('7643','2014-04-13','17:55:00',5.04),('7643','2014-04-13','18:00:00',4.63),('7643','2014-04-13','18:05:00',4.17),('7643','2014-04-13','18:10:00',3.79),('7643','2014-04-13','18:15:00',3.46),('7643','2014-04-13','18:20:00',3.09),('7643','2014-04-13','18:25:00',2.75),('7643','2014-04-13','18:30:00',2.43),('7643','2014-04-13','18:35:00',2.1),('7643','2014-04-13','18:40:00',1.76),('7643','2014-04-13','18:45:00',1.48),('7643','2014-04-13','18:50:00',1.21),('7643','2013-09-27','07:45:00',1.03),('7643','2013-09-27','07:50:00',1.29),('7643','2013-09-27','07:55:00',1.5),('7643','2013-09-27','08:00:00',1.83),('7643','2013-09-27','08:05:00',2.12),('7643','2013-09-27','08:10:00',2.47),('7643','2013-09-27','08:15:00',2.85),('7643','2013-09-27','08:20:00',3.26),('7643','2013-09-27','08:25:00',2.91),('7643','2013-09-27','08:30:00',3.75),('7643','2013-09-27','08:35:00',3.96),('7643','2013-09-27','08:40:00',4.31),('7643','2013-09-27','08:45:00',4.6),('7643','2013-09-27','08:50:00',4.89),('7643','2013-09-27','08:55:00',5.15),('7643','2013-09-27','09:00:00',5.4),('7643','2013-09-27','09:05:00',5.84),('7643','2013-09-27','09:10:00',6.17),('7643','2013-09-27','09:15:00',6.37),('7643','2013-09-27','09:20:00',6.67),('7643','2013-09-27','09:25:00',7.06),('7643','2013-09-27','09:30:00',7.42),('7643','2013-09-27','09:35:00',6.18),('7643','2013-09-27','09:40:00',7.92),('7643','2013-09-27','09:45:00',7.51),('7643','2013-09-27','09:50:00',3.78),('7643','2013-09-27','09:55:00',9.21),('7643','2013-09-27','10:00:00',8.53),('7643','2013-09-27','10:05:00',5.87),('7643','2013-09-27','10:10:00',4.67),('7643','2013-09-27','10:15:00',3.55),('7643','2013-09-27','10:20:00',3.97),('7643','2013-09-27','10:25:00',7.05),('7643','2013-09-27','10:30:00',7.27),('7643','2013-09-27','10:35:00',10.77),('7643','2013-09-27','10:40:00',10.74),('7643','2013-09-27','10:45:00',9.37),('7643','2013-09-27','10:50:00',6.37),('7643','2013-09-27','10:55:00',8.74),('7643','2013-09-27','11:00:00',13.22),('7643','2013-09-27','11:05:00',9.26),('7643','2013-09-27','11:10:00',11.84),('7643','2013-09-27','11:15:00',12.68),('7643','2013-09-27','11:20:00',7.26),('7643','2013-09-27','11:25:00',12.93),('7643','2013-09-27','11:30:00',13.24),('7643','2013-09-27','11:35:00',13.6),('7643','2013-09-27','11:40:00',12.41),('7643','2013-09-27','11:45:00',5.4),('7643','2013-09-27','11:50:00',6.58),('7643','2013-09-27','11:55:00',4.28),('7643','2013-09-27','12:00:00',14.65),('7643','2013-09-27','12:05:00',13.49),('7643','2013-09-27','12:10:00',8.43),('7643','2013-09-27','12:15:00',9.17),('7643','2013-09-27','12:20:00',13.9),('7643','2013-09-27','12:25:00',5.9),('7643','2013-09-27','12:30:00',4.01),('7643','2013-09-27','12:35:00',9.67),('7643','2013-09-27','12:40:00',5.93),('7643','2013-09-27','12:45:00',4.64),('7643','2013-09-27','12:50:00',13.57),('7643','2013-09-27','12:55:00',15.57),('7643','2013-09-27','13:00:00',14.93),('7643','2013-09-27','13:05:00',14.51),('7643','2013-09-27','13:10:00',8.63),('7643','2013-09-27','13:15:00',8.26),('7643','2013-09-27','13:20:00',14.12),('7643','2013-09-27','13:25:00',14.76),('7643','2013-09-27','13:30:00',13.62),('7643','2013-09-27','13:35:00',7.24),('7643','2013-09-27','13:40:00',5.62),('7643','2013-09-27','13:45:00',9.11),('7643','2013-09-27','13:50:00',10.15),('7643','2013-09-27','13:55:00',5.76),('7643','2013-09-27','14:00:00',7.4),('7643','2013-09-27','14:05:00',10.24),('7643','2013-09-27','14:10:00',13.81),('7643','2013-09-27','14:15:00',14.26),('7643','2013-09-27','14:20:00',14.35),('7643','2013-09-27','14:25:00',14.26),('7643','2013-09-27','14:30:00',13.5),('7643','2013-09-27','14:35:00',13.47),('7643','2013-09-27','14:40:00',13.32),('7643','2013-09-27','14:45:00',13.14),('7643','2013-09-27','14:50:00',12.34),('7643','2013-09-27','14:55:00',11.9),('7643','2013-09-27','15:00:00',12.71),('7643','2013-09-27','15:05:00',12.57),('7643','2013-09-27','15:10:00',12.01),('7643','2013-09-27','15:15:00',11.52),('7643','2013-09-27','15:20:00',12.02),('7643','2013-09-27','15:25:00',11.98),('7643','2013-09-27','15:30:00',11.09),('7643','2013-09-27','15:35:00',10.48),('7643','2013-09-27','15:40:00',9.78),('7643','2013-09-27','15:45:00',7.54),('7643','2013-09-27','15:50:00',5.83),('7643','2013-09-27','15:55:00',8.37),('7643','2013-09-27','16:00:00',9.6),('7643','2013-09-27','16:05:00',9.43),('7643','2013-09-27','16:10:00',9.15),('7643','2013-09-27','16:15:00',9.01),('7643','2013-09-27','16:20:00',8.25),('7643','2013-09-27','16:25:00',7.21),('7643','2013-09-27','16:30:00',6.56),('7643','2013-09-27','16:35:00',6.53),('7643','2013-09-27','16:40:00',6.24),('7643','2013-09-27','16:45:00',5.82),('7643','2013-09-27','16:50:00',5.52),('7643','2013-09-27','16:55:00',5.13),('7643','2013-09-27','17:00:00',4.84),('7643','2013-09-27','17:05:00',4.51),('7643','2013-09-27','17:10:00',4.19),('7643','2013-09-27','17:15:00',3.9),('7643','2013-09-27','17:20:00',3.57),('7643','2013-09-27','17:25:00',3.3),('7643','2013-09-27','17:30:00',3.01),('7643','2013-09-27','17:35:00',2.72),('7643','2013-09-27','17:40:00',2.4),('7643','2013-09-27','17:45:00',1.37),('7643','2013-09-26','07:50:00',1.08),('7643','2013-09-26','07:55:00',1.48),('7643','2013-09-26','08:00:00',1.52),('7643','2013-09-26','08:05:00',1.15),('7643','2013-09-26','08:10:00',1.98),('7643','2013-09-26','08:15:00',1.95),('7643','2013-09-26','08:20:00',2.64),('7643','2013-09-26','08:25:00',3.81),('7643','2013-09-26','08:30:00',3.78),('7643','2013-09-26','08:35:00',4.29),('7643','2013-09-26','08:40:00',4.67),('7643','2013-09-26','08:45:00',4.31),('7643','2013-09-26','08:50:00',4.82),('7643','2013-09-26','08:55:00',5.66),('7643','2013-09-26','09:00:00',6.33),('7643','2013-09-26','09:05:00',4.58),('7643','2013-09-26','09:10:00',3.54),('7643','2013-09-26','09:15:00',4.18),('7643','2013-09-26','09:20:00',2.87),('7643','2013-09-26','09:25:00',3.41),('7643','2013-09-26','09:30:00',2.64),('7643','2013-09-26','09:35:00',2.81),('7643','2013-09-26','09:40:00',3),('7643','2013-09-26','09:45:00',2.95),('7643','2013-09-26','09:50:00',5.6),('7643','2013-09-26','09:55:00',9.54),('7643','2013-09-26','10:00:00',7.74),('7643','2013-09-26','10:05:00',9.05),('7643','2013-09-26','10:10:00',6.63),('7643','2013-09-26','10:15:00',6.54),('7643','2013-09-26','10:20:00',10.85),('7643','2013-09-26','10:25:00',7.05),('7643','2013-09-26','10:30:00',6.49),('7643','2013-09-26','10:35:00',6.63),('7643','2013-09-26','10:40:00',6.84),('7643','2013-09-26','10:45:00',7.53),('7643','2013-09-26','10:50:00',3.72),('7643','2013-09-26','10:55:00',6.27),('7643','2013-09-26','11:00:00',9.23),('7643','2013-09-26','11:05:00',9.69),('7643','2013-09-26','11:10:00',10.35),('7643','2013-09-26','11:15:00',6.33),('7643','2013-09-26','11:20:00',8.17),('7643','2013-09-26','11:25:00',7.27),('7643','2013-09-26','11:30:00',4.96),('7643','2013-09-26','11:35:00',3.56),('7643','2013-09-26','11:40:00',3.87),('7643','2013-09-26','11:45:00',4.58),('7643','2013-09-26','11:50:00',3.62),('7643','2013-09-26','11:55:00',3.66),('7643','2013-09-26','12:00:00',11.78),('7643','2013-09-26','12:05:00',10.16),('7643','2013-09-26','12:10:00',13.75),('7643','2013-09-26','12:15:00',9.35),('7643','2013-09-26','12:20:00',5.46),('7643','2013-09-26','12:25:00',4.19),('7643','2013-09-26','12:30:00',4.06),('7643','2013-09-26','12:35:00',3.9),('7643','2013-09-26','12:40:00',3.16),('7643','2013-09-26','12:45:00',3.47),('7643','2013-09-26','12:50:00',6.48),('7643','2013-09-26','12:55:00',13.37),('7643','2013-09-26','13:00:00',13.28),('7643','2013-09-26','13:05:00',13.04),('7643','2013-09-26','13:10:00',14.06),('7643','2013-09-26','13:15:00',10.42),('7643','2013-09-26','13:20:00',7.77),('7643','2013-09-26','13:25:00',8.14),('7643','2013-09-26','13:30:00',2.99),('7643','2013-09-26','13:35:00',3.09),('7643','2013-09-26','13:40:00',3.12),('7643','2013-09-26','13:45:00',4.13),('7643','2013-09-26','13:50:00',3.23),('7643','2013-09-26','13:55:00',5.48),('7643','2013-09-26','14:00:00',11.61),('7643','2013-09-26','14:05:00',7.14),('7643','2013-09-26','14:10:00',8.62),('7643','2013-09-26','14:15:00',14.09),('7643','2013-09-26','14:20:00',11.21),('7643','2013-09-26','14:25:00',13.02),('7643','2013-09-26','14:30:00',11.69),('7643','2013-09-26','14:35:00',12.02),('7643','2013-09-26','14:40:00',11.29),('7643','2013-09-26','14:45:00',11.97),('7643','2013-09-26','14:50:00',11.82),('7643','2013-09-26','14:55:00',11.57),('7643','2013-09-26','15:00:00',11.6),('7643','2013-09-26','15:05:00',9.03),('7643','2013-09-26','15:10:00',9.5),('7643','2013-09-26','15:15:00',10.81),('7643','2013-09-26','15:20:00',10.65),('7643','2013-09-26','15:25:00',10.27),('7643','2013-09-26','15:30:00',10.25),('7643','2013-09-26','15:35:00',9.81),('7643','2013-09-26','15:40:00',9.74),('7643','2013-09-26','15:45:00',9.46),('7643','2013-09-26','15:50:00',8.86),('7643','2013-09-26','15:55:00',9.18),('7643','2013-09-26','16:00:00',8.58),('7643','2013-09-26','16:05:00',8.45),('7643','2013-09-26','16:10:00',5.62),('7643','2013-09-26','16:15:00',7.89),('7643','2013-09-26','16:20:00',6.08),('7643','2013-09-26','16:25:00',7.32),('7643','2013-09-26','16:30:00',6.92),('7643','2013-09-26','16:35:00',5.88),('7643','2013-09-26','16:40:00',6.51),('7643','2013-09-26','16:45:00',6.23),('7643','2013-09-26','16:50:00',5.39),('7643','2013-09-26','16:55:00',4.81),('7643','2013-09-26','17:00:00',2.77),('7643','2013-09-26','17:05:00',3.34),('7643','2013-09-26','17:10:00',3.02),('7643','2013-09-26','17:15:00',4.38),('7643','2013-09-26','17:20:00',3.97),('7643','2013-09-26','17:25:00',3.69),('7643','2013-09-26','17:30:00',3.43),('7643','2013-09-26','17:35:00',2.96),('7643','2013-09-26','17:40:00',2.44),('7643','2013-09-26','17:45:00',2.22),('7643','2013-09-26','17:50:00',2.09),('7643','2013-09-26','17:55:00',1.79),('7643','2013-09-26','18:00:00',1.46),('7643','2013-09-26','18:05:00',1.17),('7643','2013-09-25','07:45:00',1.29),('7643','2013-09-25','07:50:00',1.76),('7643','2013-09-25','07:55:00',1.96),('7643','2013-09-25','08:00:00',2.15),('7643','2013-09-25','08:05:00',2.32),('7643','2013-09-25','08:10:00',2.75),('7643','2013-09-25','08:15:00',2.92),('7643','2013-09-25','08:20:00',2.29),('7643','2013-09-25','08:25:00',3.65),('7643','2013-09-25','08:30:00',3.31),('7643','2013-09-25','08:35:00',3.58),('7643','2013-09-25','08:40:00',4.74),('7643','2013-09-25','08:45:00',5.05),('7643','2013-09-25','08:50:00',5.45),('7643','2013-09-25','08:55:00',5.77),('7643','2013-09-25','09:00:00',6.07),('7643','2013-09-25','09:05:00',6.35),('7643','2013-09-25','09:10:00',6.77),('7643','2013-09-25','09:15:00',7.09),('7643','2013-09-25','09:20:00',7.36),('7643','2013-09-25','09:25:00',7.58),('7643','2013-09-25','09:30:00',7.88),('7643','2013-09-25','09:35:00',8.15),('7643','2013-09-25','09:40:00',8.4),('7643','2013-09-25','09:45:00',8.71),('7643','2013-09-25','09:50:00',8.93),('7643','2013-09-25','09:55:00',9.18),('7643','2013-09-25','10:00:00',9.45),('7643','2013-09-25','10:05:00',9.61),('7643','2013-09-25','10:10:00',9.77),('7643','2013-09-25','10:15:00',9.94),('7643','2013-09-25','10:20:00',10.17),('7643','2013-09-25','10:25:00',9.94),('7643','2013-09-25','10:30:00',10.34),('7643','2013-09-25','10:35:00',10.69),('7643','2013-09-25','10:40:00',10.88),('7643','2013-09-25','10:45:00',11.08),('7643','2013-09-25','10:50:00',11.08),('7643','2013-09-25','10:55:00',11.22),('7643','2013-09-25','11:00:00',11.19),('7643','2013-09-25','11:05:00',11.44),('7643','2013-09-25','11:10:00',11.55),('7643','2013-09-25','11:15:00',11.66),('7643','2013-09-25','11:20:00',12.05),('7643','2013-09-25','11:25:00',12.12),('7643','2013-09-25','11:30:00',12.09),('7643','2013-09-25','11:35:00',12.22),('7643','2013-09-25','11:40:00',12.41),('7643','2013-09-25','11:45:00',11.92),('7643','2013-09-25','11:50:00',12.56),('7643','2013-09-25','11:55:00',11.9),('7643','2013-09-25','12:00:00',12.61),('7643','2013-09-25','12:05:00',8.68),('7643','2013-09-25','12:10:00',4.4),('7643','2013-09-25','12:15:00',5.51),('7643','2013-09-25','12:20:00',7.39),('7643','2013-09-25','12:25:00',5.23),('7643','2013-09-25','12:30:00',4.69),('7643','2013-09-25','12:35:00',4.69),('7643','2013-09-25','12:40:00',5.04),('7643','2013-09-25','12:45:00',5.92),('7643','2013-09-25','12:50:00',5.67),('7643','2013-09-25','12:55:00',9.79),('7643','2013-09-25','13:00:00',12.6),('7643','2013-09-25','13:05:00',8.38),('7643','2013-09-25','13:10:00',6.05),('7643','2013-09-25','13:15:00',14.1),('7643','2013-09-25','13:20:00',12.26),('7643','2013-09-25','13:25:00',13.07),('7643','2013-09-25','13:30:00',6.91),('7643','2013-09-25','13:35:00',6.72),('7643','2013-09-25','13:40:00',5.65),('7643','2013-09-25','13:45:00',4.75),('7643','2013-09-25','13:50:00',6.49),('7643','2013-09-25','13:55:00',10.52),('7643','2013-09-25','14:00:00',9.07),('7643','2013-09-25','14:05:00',11.72),('7643','2013-09-25','14:10:00',9.88),('7643','2013-09-25','14:15:00',13.1),('7643','2013-09-25','14:20:00',8.03),('7643','2013-09-25','14:25:00',3.06),('7643','2013-09-25','14:30:00',3.76),('7643','2013-09-25','14:35:00',9.09),('7643','2013-09-25','14:40:00',3.47),('7643','2013-09-25','14:45:00',11.65),('7643','2013-09-25','14:50:00',14.14),('7643','2013-09-25','14:55:00',11.58),('7643','2013-09-25','15:00:00',8.31),('7643','2013-09-25','15:05:00',6.88),('7643','2013-09-25','15:10:00',5.83),('7643','2013-09-25','15:15:00',5.22),('7643','2013-09-25','15:20:00',6.29),('7643','2013-09-25','15:25:00',11.75),('7643','2013-09-25','15:30:00',2.79),('7643','2013-09-25','15:35:00',6.03),('7643','2013-09-25','15:40:00',7.7),('7643','2013-09-25','15:45:00',5.2),('7643','2013-09-25','15:50:00',7.05),('7643','2013-09-25','15:55:00',9.68),('7643','2013-09-25','16:00:00',8.93),('7643','2013-09-25','16:05:00',6.89),('7643','2013-09-25','16:10:00',8.51),('7643','2013-09-25','16:15:00',8.05),('7643','2013-09-25','16:20:00',7.59),('7643','2013-09-25','16:25:00',7.31),('7643','2013-09-25','16:30:00',7.19),('7643','2013-09-25','16:35:00',6.78),('7643','2013-09-25','16:40:00',6.51),('7643','2013-09-25','16:45:00',6.14),('7643','2013-09-25','16:50:00',5.79),('7643','2013-09-25','16:55:00',5.49),('7643','2013-09-25','17:00:00',5.1),('7643','2013-09-25','17:05:00',5.05),('7643','2013-09-25','17:10:00',4.8),('7643','2013-09-25','17:15:00',4.37),('7643','2013-09-25','17:20:00',4.17),('7643','2013-09-25','17:25:00',3.91),('7643','2013-09-25','17:30:00',3.48),('7643','2013-09-25','17:35:00',3.05),('7643','2013-09-25','17:40:00',3.07),('7643','2013-09-25','17:45:00',2.67),('7643','2013-09-25','17:50:00',2.32),('7643','2013-09-25','17:55:00',1.79),('7643','2013-09-25','18:00:00',1.46),('7643','2013-09-25','18:05:00',1.18),('7643','2013-09-24','08:00:00',1.17),('7643','2013-09-24','08:05:00',1.77),('7643','2013-09-24','08:10:00',2.68),('7643','2013-09-24','08:15:00',2.22),('7643','2013-09-24','08:20:00',2.29),('7643','2013-09-24','08:25:00',2.74),('7643','2013-09-24','08:30:00',2.53),('7643','2013-09-24','08:35:00',1.94),('7643','2013-09-24','08:40:00',2.27),('7643','2013-09-24','08:45:00',5.63),('7643','2013-09-24','08:50:00',5.39),('7643','2013-09-24','08:55:00',3.06),('7643','2013-09-24','09:00:00',2.46),('7643','2013-09-24','09:05:00',4.01),('7643','2013-09-24','09:10:00',3.77),('7643','2013-09-24','09:15:00',5.4),('7643','2013-09-24','09:20:00',3.53),('7643','2013-09-24','09:25:00',5.04),('7643','2013-09-24','09:30:00',5.05),('7643','2013-09-24','09:35:00',7.9),('7643','2013-09-24','09:40:00',7.58),('7643','2013-09-24','09:45:00',6.79),('7643','2013-09-24','09:50:00',8.89),('7643','2013-09-24','09:55:00',10.03),('7643','2013-09-24','10:00:00',9.37),('7643','2013-09-24','10:05:00',5.52),('7643','2013-09-24','10:10:00',3.06),('7643','2013-09-24','10:15:00',2.63),('7643','2013-09-24','10:20:00',4.21),('7643','2013-09-24','10:25:00',3.55),('7643','2013-09-24','10:30:00',3.21),('7643','2013-09-24','10:35:00',2.5),('7643','2013-09-24','10:40:00',2.56),('7643','2013-09-24','10:45:00',7.11),('7643','2013-09-24','10:50:00',13.46),('7643','2013-09-24','10:55:00',13.93),('7643','2013-09-24','11:00:00',13.38),('7643','2013-09-24','11:05:00',13.02),('7643','2013-09-24','11:10:00',13.35),('7643','2013-09-24','11:15:00',6.85),('7643','2013-09-24','11:20:00',4.49),('7643','2013-09-24','11:25:00',8.48),('7643','2013-09-24','11:30:00',13.11),('7643','2013-09-24','11:35:00',12.94),('7643','2013-09-24','11:40:00',12.73),('7643','2013-09-24','11:45:00',11.2),('7643','2013-09-24','11:50:00',5.94),('7643','2013-09-24','11:55:00',4.14),('7643','2013-09-24','12:00:00',3.29),('7643','2013-09-24','12:05:00',2.95),('7643','2013-09-24','12:10:00',3.76),('7643','2013-09-24','12:15:00',9.29),('7643','2013-09-24','12:20:00',12.39),('7643','2013-09-24','12:25:00',3.25),('7643','2013-09-24','12:30:00',5.78),('7643','2013-09-24','12:35:00',5.3),('7643','2013-09-24','12:40:00',10.02),('7643','2013-09-24','12:45:00',4.28),('7643','2013-09-24','12:50:00',3.63),('7643','2013-09-24','12:55:00',2.86),('7643','2013-09-24','13:00:00',3.33),('7643','2013-09-24','13:05:00',3.33),('7643','2013-09-24','13:10:00',3.29),('7643','2013-09-24','13:15:00',3.45),('7643','2013-09-24','13:20:00',3.94),('7643','2013-09-24','13:25:00',4.04),('7643','2013-09-24','13:30:00',7),('7643','2013-09-24','13:35:00',15.31),('7643','2013-09-24','13:40:00',15.98),('7643','2013-09-24','13:45:00',15.79),('7643','2013-09-24','13:50:00',15.02),('7643','2013-09-24','13:55:00',11.8),('7643','2013-09-24','14:00:00',3.27),('7643','2013-09-24','14:05:00',3.22),('7643','2013-09-24','14:10:00',4.08),('7643','2013-09-24','14:15:00',3.46),('7643','2013-09-24','14:20:00',3.32),('7643','2013-09-24','14:25:00',4.43),('7643','2013-09-24','14:30:00',14.15),('7643','2013-09-24','14:35:00',15.29),('7643','2013-09-24','14:40:00',14.89),('7643','2013-09-24','14:45:00',7.35),('7643','2013-09-24','14:50:00',12.85),('7643','2013-09-24','14:55:00',14.58),('7643','2013-09-24','15:00:00',9.31),('7643','2013-09-24','15:05:00',12.53),('7643','2013-09-24','15:10:00',12.29),('7643','2013-09-24','15:15:00',12.12),('7643','2013-09-24','15:20:00',11.69),('7643','2013-09-24','15:25:00',10.17),('7643','2013-09-24','15:30:00',11.38),('7643','2013-09-24','15:35:00',11.41),('7643','2013-09-24','15:40:00',11.31),('7643','2013-09-24','15:45:00',10.04),('7643','2013-09-24','15:50:00',10.18),('7643','2013-09-24','15:55:00',9.98),('7643','2013-09-24','16:00:00',9.62),('7643','2013-09-24','16:05:00',9.24),('7643','2013-09-24','16:10:00',8.81),('7643','2013-09-24','16:15:00',8.72),('7643','2013-09-24','16:20:00',8.23),('7643','2013-09-24','16:25:00',7.93),('7643','2013-09-24','16:30:00',7.74),('7643','2013-09-24','16:35:00',7.34),('7643','2013-09-24','16:40:00',6.86),('7643','2013-09-24','16:45:00',6.68),('7643','2013-09-24','16:50:00',6.29),('7643','2013-09-24','16:55:00',5.94),('7643','2013-09-24','17:00:00',5.68),('7643','2013-09-24','17:05:00',5.35),('7643','2013-09-24','17:10:00',5.07),('7643','2013-09-24','17:15:00',4.68),('7643','2013-09-24','17:20:00',4.3),('7643','2013-09-24','17:25:00',3.95),('7643','2013-09-24','17:30:00',3.64),('7643','2013-09-24','17:35:00',3.29),('7643','2013-09-24','17:40:00',2.9),('7643','2013-09-24','17:45:00',2.6),('7643','2013-09-24','17:50:00',2.29),('7643','2013-09-24','17:55:00',2.02),('7643','2013-09-24','18:00:00',1.73),('7643','2013-09-24','18:05:00',1.44),('7643','2013-09-24','18:10:00',1.18),('7643','2013-09-23','07:40:00',1.18),('7643','2013-09-23','07:45:00',1.44),('7643','2013-09-23','07:50:00',1.76),('7643','2013-09-23','07:55:00',2.07),('7643','2013-09-23','08:00:00',2.41),('7643','2013-09-23','08:05:00',2.74),('7643','2013-09-23','08:10:00',3.07),('7643','2013-09-23','08:15:00',3.44),('7643','2013-09-23','08:20:00',3.79),('7643','2013-09-23','08:25:00',4.13),('7643','2013-09-23','08:30:00',4.47),('7643','2013-09-23','08:35:00',4.84),('7643','2013-09-23','08:40:00',5.17),('7643','2013-09-23','08:45:00',5.51),('7643','2013-09-23','08:50:00',5.78),('7643','2013-09-23','08:55:00',6.1),('7643','2013-09-23','09:00:00',6.46),('7643','2013-09-23','09:05:00',6.77),('7643','2013-09-23','09:10:00',7.14),('7643','2013-09-23','09:15:00',7.46),('7643','2013-09-23','09:20:00',7.76),('7643','2013-09-23','09:25:00',8.07),('7643','2013-09-23','09:30:00',8.36),('7643','2013-09-23','09:35:00',8.63),('7643','2013-09-23','09:40:00',8.86),('7643','2013-09-23','09:45:00',9.1),('7643','2013-09-23','09:50:00',9.33),('7643','2013-09-23','09:55:00',9.56),('7643','2013-09-23','10:00:00',9.8),('7643','2013-09-23','10:05:00',9.95),('7643','2013-09-23','10:10:00',10.22),('7643','2013-09-23','10:15:00',10.48),('7643','2013-09-23','10:20:00',10.74),('7643','2013-09-23','10:25:00',11.01),('7643','2013-09-23','10:30:00',11.19),('7643','2013-09-23','10:35:00',11.34),('7643','2013-09-23','10:40:00',11.52),('7643','2013-09-23','10:45:00',11.69),('7643','2013-09-23','10:50:00',11.81),('7643','2013-09-23','10:55:00',11.97),('7643','2013-09-23','11:00:00',12.12),('7643','2013-09-23','11:05:00',12.22),('7643','2013-09-23','11:10:00',12.38),('7643','2013-09-23','11:15:00',12.43),('7643','2013-09-23','11:20:00',12.54),('7643','2013-09-23','11:25:00',12.63),('7643','2013-09-23','11:30:00',12.75),('7643','2013-09-23','11:35:00',12.83),('7643','2013-09-23','11:40:00',12.89),('7643','2013-09-23','11:45:00',13.1),('7643','2013-09-23','11:50:00',13.2),('7643','2013-09-23','11:55:00',13.21),('7643','2013-09-23','12:00:00',13.29),('7643','2013-09-23','12:05:00',13.26),('7643','2013-09-23','12:10:00',13.38),('7643','2013-09-23','12:15:00',13.41),('7643','2013-09-23','12:20:00',13.26),('7643','2013-09-23','12:25:00',13.34),('7643','2013-09-23','12:30:00',13.26),('7643','2013-09-23','12:35:00',13.5),('7643','2013-09-23','12:40:00',13.61),('7643','2013-09-23','12:45:00',13.63),('7643','2013-09-23','12:50:00',13.74),('7643','2013-09-23','12:55:00',13.67),('7643','2013-09-23','13:00:00',13.63),('7643','2013-09-23','13:05:00',13.6),('7643','2013-09-23','13:10:00',13.56),('7643','2013-09-23','13:15:00',13.59),('7643','2013-09-23','13:20:00',13.57),('7643','2013-09-23','13:25:00',13.49),('7643','2013-09-23','13:30:00',13.41),('7643','2013-09-23','13:35:00',13.31),('7643','2013-09-23','13:40:00',13.52),('7643','2013-09-23','13:45:00',13.55),('7643','2013-09-23','13:50:00',13.24),('7643','2013-09-23','13:55:00',13.21),('7643','2013-09-23','14:00:00',13.13),('7643','2013-09-23','14:05:00',13.08),('7643','2013-09-23','14:10:00',12.89),('7643','2013-09-23','14:15:00',12.88),('7643','2013-09-23','14:20:00',12.81),('7643','2013-09-23','14:25:00',12.73),('7643','2013-09-23','14:30:00',12.54),('7643','2013-09-23','14:35:00',12.29),('7643','2013-09-23','14:40:00',12.28),('7643','2013-09-23','14:45:00',12.15),('7643','2013-09-23','14:50:00',12.04),('7643','2013-09-23','14:55:00',11.95),('7643','2013-09-23','15:00:00',11.6),('7643','2013-09-23','15:05:00',11.56),('7643','2013-09-23','15:10:00',11.38),('7643','2013-09-23','15:15:00',11.11),('7643','2013-09-23','15:20:00',11.05),('7643','2013-09-23','15:25:00',10.91),('7643','2013-09-23','15:30:00',10.74),('7643','2013-09-23','15:35:00',10.54),('7643','2013-09-23','15:40:00',10.29),('7643','2013-09-23','15:45:00',10.08),('7643','2013-09-23','15:50:00',9.8),('7643','2013-09-23','15:55:00',9.55),('7643','2013-09-23','16:00:00',9.31),('7643','2013-09-23','16:05:00',9.04),('7643','2013-09-23','16:10:00',8.74),('7643','2013-09-23','16:15:00',8.52),('7643','2013-09-23','16:20:00',8.3),('7643','2013-09-23','16:25:00',7.91),('7643','2013-09-23','16:30:00',7.64),('7643','2013-09-23','16:35:00',7.31),('7643','2013-09-23','16:40:00',6.99),('7643','2013-09-23','16:45:00',6.72),('7643','2013-09-23','16:50:00',6.48),('7643','2013-09-23','16:55:00',6.21),('7643','2013-09-23','17:00:00',5.87),('7643','2013-09-23','17:05:00',5.49),('7643','2013-09-23','17:10:00',5.17),('7643','2013-09-23','17:15:00',4.82),('7643','2013-09-23','17:20:00',4.45),('7643','2013-09-23','17:25:00',4.09),('7643','2013-09-23','17:30:00',3.65),('7643','2013-09-23','17:35:00',3.27),('7643','2013-09-23','17:40:00',2.88),('7643','2013-09-23','17:45:00',2.61),('7643','2013-09-23','17:50:00',2.29),('7643','2013-09-23','17:55:00',1.98),('7643','2013-09-23','18:00:00',1.68),('7643','2013-09-23','18:05:00',1.44),('7643','2013-09-23','18:10:00',1.2),('7643','2013-09-22','07:40:00',1.22),('7643','2013-09-22','07:45:00',1.51),('7643','2013-09-22','07:50:00',1.83),('7643','2013-09-22','07:55:00',2.15),('7643','2013-09-22','08:00:00',2.5),('7643','2013-09-22','08:05:00',2.84),('7643','2013-09-22','08:10:00',3.18),('7643','2013-09-22','08:15:00',3.54),('7643','2013-09-22','08:20:00',3.9),('7643','2013-09-22','08:25:00',4.28),('7643','2013-09-22','08:30:00',4.62),('7643','2013-09-22','08:35:00',4.96),('7643','2013-09-22','08:40:00',5.33),('7643','2013-09-22','08:45:00',5.67),('7643','2013-09-22','08:50:00',6),('7643','2013-09-22','08:55:00',6.32),('7643','2013-09-22','09:00:00',6.63),('7643','2013-09-22','09:05:00',7),('7643','2013-09-22','09:10:00',7.34),('7643','2013-09-22','09:15:00',7.61),('7643','2013-09-22','09:20:00',7.94),('7643','2013-09-22','09:25:00',8.21),('7643','2013-09-22','09:30:00',8.49),('7643','2013-09-22','09:35:00',8.76),('7643','2013-09-22','09:40:00',9.06),('7643','2013-09-22','09:45:00',9.31),('7643','2013-09-22','09:50:00',9.55),('7643','2013-09-22','09:55:00',9.82),('7643','2013-09-22','10:00:00',10.04),('7643','2013-09-22','10:05:00',10.26),('7643','2013-09-22','10:10:00',10.5),('7643','2013-09-22','10:15:00',10.67),('7643','2013-09-22','10:20:00',10.93),('7643','2013-09-22','10:25:00',11.08),('7643','2013-09-22','10:30:00',11.29),('7643','2013-09-22','10:35:00',11.52),('7643','2013-09-22','10:40:00',11.71),('7643','2013-09-22','10:45:00',11.89),('7643','2013-09-22','10:50:00',11.99),('7643','2013-09-22','10:55:00',12.16),('7643','2013-09-22','11:00:00',12.32),('7643','2013-09-22','11:05:00',12.55),('7643','2013-09-22','11:10:00',12.73),('7643','2013-09-22','11:15:00',12.92),('7643','2013-09-22','11:20:00',13.1),('7643','2013-09-22','11:25:00',13.3),('7643','2013-09-22','11:30:00',13.36),('7643','2013-09-22','11:35:00',13.46),('7643','2013-09-22','11:40:00',13.61),('7643','2013-09-22','11:45:00',13.65),('7643','2013-09-22','11:50:00',13.8),('7643','2013-09-22','11:55:00',13.89),('7643','2013-09-22','12:00:00',14.04),('7643','2013-09-22','12:05:00',14.2),('7643','2013-09-22','12:10:00',14.29),('7643','2013-09-22','12:15:00',14.31),('7643','2013-09-22','12:20:00',14.32),('7643','2013-09-22','12:25:00',14.28),('7643','2013-09-22','12:30:00',14.25),('7643','2013-09-22','12:35:00',14.19),('7643','2013-09-22','12:40:00',14.14),('7643','2013-09-22','12:45:00',14.17),('7643','2013-09-22','12:50:00',14.06),('7643','2013-09-22','12:55:00',14.21),('7643','2013-09-22','13:00:00',14.26),('7643','2013-09-22','13:05:00',14.22),('7643','2013-09-22','13:10:00',14.15),('7643','2013-09-22','13:15:00',14.05),('7643','2013-09-22','13:20:00',13.86),('7643','2013-09-22','13:25:00',13.96),('7643','2013-09-22','13:30:00',13.94),('7643','2013-09-22','13:35:00',13.89),('7643','2013-09-22','13:40:00',13.78),('7643','2013-09-22','13:45:00',13.8),('7643','2013-09-22','13:50:00',13.66),('7643','2013-09-22','13:55:00',13.51),('7643','2013-09-22','14:00:00',13.29),('7643','2013-09-22','14:05:00',13.11),('7643','2013-09-22','14:10:00',13.14),('7643','2013-09-22','14:15:00',13.23),('7643','2013-09-22','14:20:00',12.92),('7643','2013-09-22','14:25:00',12.87),('7643','2013-09-22','14:30:00',13.2),('7643','2013-09-22','14:35:00',12.69),('7643','2013-09-22','14:40:00',12.14),('7643','2013-09-22','14:45:00',12.39),('7643','2013-09-22','14:50:00',12.33),('7643','2013-09-22','14:55:00',12.11),('7643','2013-09-22','15:00:00',11.89),('7643','2013-09-22','15:05:00',11.91),('7643','2013-09-22','15:10:00',9.21),('7643','2013-09-22','15:15:00',11.14),('7643','2013-09-22','15:20:00',11.06),('7643','2013-09-22','15:25:00',10.79),('7643','2013-09-22','15:30:00',10.66),('7643','2013-09-22','15:35:00',10.3),('7643','2013-09-22','15:40:00',9.95),('7643','2013-09-22','15:45:00',9.89),('7643','2013-09-22','15:50:00',9.87),('7643','2013-09-22','15:55:00',9.35),('7643','2013-09-22','16:00:00',7.42),('7643','2013-09-22','16:05:00',9.03),('7643','2013-09-22','16:10:00',3.66),('7643','2013-09-22','16:15:00',6.61),('7643','2013-09-22','16:20:00',5.86),('7643','2013-09-22','16:25:00',8.18),('7643','2013-09-22','16:30:00',6.46),('7643','2013-09-22','16:35:00',7.12),('7643','2013-09-22','16:40:00',6.79),('7643','2013-09-22','16:45:00',6.57),('7643','2013-09-22','16:50:00',6.19),('7643','2013-09-22','16:55:00',5.93),('7643','2013-09-22','17:00:00',5.67),('7643','2013-09-22','17:05:00',5.37),('7643','2013-09-22','17:10:00',5.04),('7643','2013-09-22','17:15:00',4.7),('7643','2013-09-22','17:20:00',4.38),('7643','2013-09-22','17:25:00',4.05),('7643','2013-09-22','17:30:00',3.73),('7643','2013-09-22','17:35:00',3.42),('7643','2013-09-22','17:40:00',3.06),('7643','2013-09-22','17:45:00',2.71),('7643','2013-09-22','17:50:00',2.33),('7643','2013-09-22','17:55:00',2.02),('7643','2013-09-22','18:00:00',1.75),('7643','2013-09-22','18:05:00',1.48),('7643','2013-09-22','18:10:00',1.23),('7643','2013-09-21','07:35:00',1.22),('7643','2013-09-21','07:40:00',1.47),('7643','2013-09-21','07:45:00',1.73),('7643','2013-09-21','07:50:00',1.97),('7643','2013-09-21','07:55:00',2.29),('7643','2013-09-21','08:00:00',2.62),('7643','2013-09-21','08:05:00',3.03),('7643','2013-09-21','08:10:00',3.46),('7643','2013-09-21','08:15:00',3.38),('7643','2013-09-21','08:20:00',3.38),('7643','2013-09-21','08:25:00',4.34),('7643','2013-09-21','08:30:00',4.6),('7643','2013-09-21','08:35:00',4.89),('7643','2013-09-21','08:40:00',5.18),('7643','2013-09-21','08:45:00',5.53),('7643','2013-09-21','08:50:00',5.86),('7643','2013-09-21','08:55:00',6.23),('7643','2013-09-21','09:00:00',6.54),('7643','2013-09-21','09:05:00',6.87),('7643','2013-09-21','09:10:00',7.24),('7643','2013-09-21','09:15:00',7.58),('7643','2013-09-21','09:20:00',7.89),('7643','2013-09-21','09:25:00',8.22),('7643','2013-09-21','09:30:00',8.52),('7643','2013-09-21','09:35:00',8.79),('7643','2013-09-21','09:40:00',9.02),('7643','2013-09-21','09:45:00',9.27),('7643','2013-09-21','09:50:00',9.55),('7643','2013-09-21','09:55:00',9.85),('7643','2013-09-21','10:00:00',10.11),('7643','2013-09-21','10:05:00',10.39),('7643','2013-09-21','10:10:00',10.62),('7643','2013-09-21','10:15:00',10.88),('7643','2013-09-21','10:20:00',11.13),('7643','2013-09-21','10:25:00',11.38),('7643','2013-09-21','10:30:00',11.6),('7643','2013-09-21','10:35:00',11.78),('7643','2013-09-21','10:40:00',12),('7643','2013-09-21','10:45:00',12.14),('7643','2013-09-21','10:50:00',12.29),('7643','2013-09-21','10:55:00',12.46),('7643','2013-09-21','11:00:00',12.6),('7643','2013-09-21','11:05:00',12.74),('7643','2013-09-21','11:10:00',12.85),('7643','2013-09-21','11:15:00',13.06),('7643','2013-09-21','11:20:00',13.08),('7643','2013-09-21','11:25:00',13.21),('7643','2013-09-21','11:30:00',13.38),('7643','2013-09-21','11:35:00',13.64),('7643','2013-09-21','11:40:00',13.83),('7643','2013-09-21','11:45:00',14),('7643','2013-09-21','11:50:00',14.15),('7643','2013-09-21','11:55:00',14.27),('7643','2013-09-21','12:00:00',14.4),('7643','2013-09-21','12:05:00',14.46),('7643','2013-09-21','12:10:00',14.5),('7643','2013-09-21','12:15:00',14.52),('7643','2013-09-21','12:20:00',14.53),('7643','2013-09-21','12:25:00',14.56),('7643','2013-09-21','12:30:00',14.64),('7643','2013-09-21','12:35:00',14.55),('7643','2013-09-21','12:40:00',14.66),('7643','2013-09-21','12:45:00',14.21),('7643','2013-09-21','12:50:00',14.86),('7643','2013-09-21','12:55:00',14.99),('7643','2013-09-21','13:00:00',14.81),('7643','2013-09-21','13:05:00',14.77),('7643','2013-09-21','13:10:00',12.22),('7643','2013-09-21','13:15:00',13.75),('7643','2013-09-21','13:20:00',14.54),('7643','2013-09-21','13:25:00',14.43),('7643','2013-09-21','13:30:00',14.31),('7643','2013-09-21','13:35:00',14.24),('7643','2013-09-21','13:40:00',14.23),('7643','2013-09-21','13:45:00',14.1),('7643','2013-09-21','13:50:00',14.17),('7643','2013-09-21','13:55:00',13.92),('7643','2013-09-21','14:00:00',13.76),('7643','2013-09-21','14:05:00',13.99),('7643','2013-09-21','14:10:00',13.98),('7643','2013-09-21','14:15:00',13.32),('7643','2013-09-21','14:20:00',10.93),('7643','2013-09-21','14:25:00',13.92),('7643','2013-09-21','14:30:00',14.26),('7643','2013-09-21','14:35:00',13.44),('7643','2013-09-21','14:40:00',9.42),('7643','2013-09-21','14:45:00',11.65),('7643','2013-09-21','14:50:00',12.97),('7643','2013-09-21','14:55:00',12.81),('7643','2013-09-21','15:00:00',12.8),('7643','2013-09-21','15:05:00',13.07),('7643','2013-09-21','15:10:00',12.75),('7643','2013-09-21','15:15:00',13.03),('7643','2013-09-21','15:20:00',13.7),('7643','2013-09-21','15:25:00',8.29),('7643','2013-09-21','15:30:00',4.64),('7643','2013-09-21','15:35:00',3.74),('7643','2013-09-21','15:40:00',8.82),('7643','2013-09-21','15:45:00',11.33),('7643','2013-09-21','15:50:00',10.68),('7643','2013-09-21','15:55:00',10.46),('7643','2013-09-21','16:00:00',11.23),('7643','2013-09-21','16:05:00',11.2),('7643','2013-09-21','16:10:00',10.52),('7643','2013-09-21','16:15:00',11.52),('7643','2013-09-21','16:20:00',8.98),('7643','2013-09-21','16:25:00',5.63),('7643','2013-09-21','16:30:00',4.07),('7643','2013-09-21','16:35:00',3.88),('7643','2013-09-21','16:40:00',3.71),('7643','2013-09-21','16:45:00',7.62),('7643','2013-09-21','16:50:00',8.31),('7643','2013-09-21','16:55:00',6.3),('7643','2013-09-21','17:00:00',3.96),('7643','2013-09-21','17:05:00',6.53),('7643','2013-09-21','17:10:00',5.41),('7643','2013-09-21','17:15:00',4.78),('7643','2013-09-21','17:20:00',1.85),('7643','2013-09-21','17:25:00',1.3),('7643','2013-09-21','17:30:00',2.01),('7643','2013-09-21','17:35:00',3.07),('7643','2013-09-21','17:40:00',2.32),('7643','2013-09-21','18:00:00',1.62),('7643','2013-09-21','18:05:00',1.27),('7643','2013-09-20','07:35:00',1.06),('7643','2013-09-20','07:40:00',1.28),('7643','2013-09-20','07:45:00',1.58),('7643','2013-09-20','07:50:00',1.86),('7643','2013-09-20','07:55:00',2.16),('7643','2013-09-20','08:00:00',2.47),('7643','2013-09-20','08:05:00',2.78),('7643','2013-09-20','08:10:00',3.09),('7643','2013-09-20','08:15:00',3.44),('7643','2013-09-20','08:20:00',3.78),('7643','2013-09-20','08:25:00',4.17),('7643','2013-09-20','08:30:00',4.49),('7643','2013-09-20','08:35:00',4.87),('7643','2013-09-20','08:40:00',5.15),('7643','2013-09-20','08:45:00',5.49),('7643','2013-09-20','08:50:00',5.86),('7643','2013-09-20','08:55:00',6.17),('7643','2013-09-20','09:00:00',6.49),('7643','2013-09-20','09:05:00',6.85),('7643','2013-09-20','09:10:00',7.14),('7643','2013-09-20','09:15:00',7.41),('7643','2013-09-20','09:20:00',7.65),('7643','2013-09-20','09:25:00',8),('7643','2013-09-20','09:30:00',8.31),('7643','2013-09-20','09:35:00',8.56),('7643','2013-09-20','09:40:00',8.8),('7643','2013-09-20','09:45:00',9.12),('7643','2013-09-20','09:50:00',9.41),('7643','2013-09-20','09:55:00',9.62),('7643','2013-09-20','10:00:00',9.81),('7643','2013-09-20','10:05:00',10.05),('7643','2013-09-20','10:10:00',10.34),('7643','2013-09-20','10:15:00',10.55),('7643','2013-09-20','10:20:00',10.78),('7643','2013-09-20','10:25:00',10.98),('7643','2013-09-20','10:30:00',11.14),('7643','2013-09-20','10:35:00',11.29),('7643','2013-09-20','10:40:00',11.5),('7643','2013-09-20','10:45:00',11.71),('7643','2013-09-20','10:50:00',11.91),('7643','2013-09-20','10:55:00',12.08),('7643','2013-09-20','11:00:00',12.24),('7643','2013-09-20','11:05:00',12.37),('7643','2013-09-20','11:10:00',12.55),('7643','2013-09-20','11:15:00',12.67),('7643','2013-09-20','11:20:00',12.83),('7643','2013-09-20','11:25:00',12.96),('7643','2013-09-20','11:30:00',13.16),('7643','2013-09-20','11:35:00',13.18),('7643','2013-09-20','11:40:00',13.26),('7643','2013-09-20','11:45:00',13.4),('7643','2013-09-20','11:50:00',13.53),('7643','2013-09-20','11:55:00',13.36),('7643','2013-09-20','12:00:00',13.63),('7643','2013-09-20','12:05:00',13.89),('7643','2013-09-20','12:10:00',13.93),('7643','2013-09-20','12:15:00',13.82),('7643','2013-09-20','12:20:00',13.77),('7643','2013-09-20','12:25:00',12.54),('7643','2013-09-20','12:30:00',14.23),('7643','2013-09-20','12:35:00',13.97),('7643','2013-09-20','12:40:00',13.34),('7643','2013-09-20','12:45:00',13.7),('7643','2013-09-20','12:50:00',14.01),('7643','2013-09-20','12:55:00',14.12),('7643','2013-09-20','13:00:00',14.11),('7643','2013-09-20','13:05:00',13.75),('7643','2013-09-20','13:10:00',14.09),('7643','2013-09-20','13:15:00',14.41),('7643','2013-09-20','13:20:00',11.87),('7643','2013-09-20','13:25:00',13.41),('7643','2013-09-20','13:30:00',13.68),('7643','2013-09-20','13:35:00',13.64),('7643','2013-09-20','13:40:00',12.36),('7643','2013-09-20','13:45:00',11.99),('7643','2013-09-20','13:50:00',12.34),('7643','2013-09-20','13:55:00',12.26),('7643','2013-09-20','14:00:00',12.71),('7643','2013-09-20','14:05:00',13.42),('7643','2013-09-20','14:10:00',12.82),('7643','2013-09-20','14:15:00',13.48),('7643','2013-09-20','14:20:00',13.4),('7643','2013-09-20','14:25:00',13.14),('7643','2013-09-20','14:30:00',12.93),('7643','2013-09-20','14:35:00',12.79),('7643','2013-09-20','14:40:00',12.67),('7643','2013-09-20','14:45:00',12.44),('7643','2013-09-20','14:50:00',12.3),('7643','2013-09-20','14:55:00',12.11),('7643','2013-09-20','15:00:00',11.94),('7643','2013-09-20','15:05:00',11.79),('7643','2013-09-20','15:10:00',11.44),('7643','2013-09-20','15:15:00',11.24),('7643','2013-09-20','15:20:00',11.23),('7643','2013-09-20','15:25:00',11),('7643','2013-09-20','15:30:00',10.82),('7643','2013-09-20','15:35:00',10.58),('7643','2013-09-20','15:40:00',9.71),('7643','2013-09-20','15:45:00',6.33),('7643','2013-09-20','15:50:00',9.79),('7643','2013-09-20','15:55:00',9.45),('7643','2013-09-20','16:00:00',7.36),('7643','2013-09-20','16:05:00',5.08),('7643','2013-09-20','16:10:00',5.78),('7643','2013-09-20','16:15:00',4.92),('7643','2013-09-20','16:20:00',6.4),('7643','2013-09-20','16:25:00',2.99),('7643','2013-09-20','16:30:00',4.07),('7643','2013-09-20','16:35:00',5.25),('7643','2013-09-20','16:40:00',3.84),('7643','2013-09-20','16:45:00',3),('7643','2013-09-20','16:50:00',3.14),('7643','2013-09-20','16:55:00',4.05),('7643','2013-09-20','17:00:00',3.15),('7643','2013-09-20','17:05:00',3.52),('7643','2013-09-20','17:10:00',3.45),('7643','2013-09-20','17:15:00',3.76),('7643','2013-09-20','17:20:00',2.37),('7643','2013-09-20','17:25:00',1.74),('7643','2013-09-20','17:30:00',2.94),('7643','2013-09-20','17:35:00',3.49),('7643','2013-09-20','17:40:00',3.15),('7643','2013-09-20','17:45:00',3.25),('7643','2013-09-20','17:50:00',2.58),('7643','2013-09-20','17:55:00',2.34),('7643','2013-09-20','18:00:00',2.01),('7643','2013-09-20','18:05:00',1.71),('7643','2013-09-20','18:10:00',1.38),('7643','2013-09-20','18:15:00',1.18),('7643','2013-09-19','08:00:00',1.03),('7643','2013-09-19','08:05:00',1.19),('7643','2013-09-19','08:10:00',1.4),('7643','2013-09-19','08:15:00',1.65),('7643','2013-09-19','08:20:00',1.9),('7643','2013-09-19','08:25:00',2.03),('7643','2013-09-19','08:30:00',3.4),('7643','2013-09-19','08:35:00',6.13),('7643','2013-09-19','08:40:00',6.4),('7643','2013-09-19','08:45:00',5.37),('7643','2013-09-19','08:50:00',3.71),('7643','2013-09-19','08:55:00',3.71),('7643','2013-09-19','09:00:00',4.2),('7643','2013-09-19','09:05:00',4.33),('7643','2013-09-19','09:10:00',4.75),('7643','2013-09-19','09:15:00',5.9),('7643','2013-09-19','09:20:00',4.72),('7643','2013-09-19','09:25:00',5.1),('7643','2013-09-19','09:30:00',4.71),('7643','2013-09-19','09:35:00',4.52),('7643','2013-09-19','09:40:00',4.46),('7643','2013-09-19','09:45:00',4.59),('7643','2013-09-19','09:50:00',4.67),('7643','2013-09-19','09:55:00',6.5),('7643','2013-09-19','10:00:00',6.36),('7643','2013-09-19','10:05:00',8.52),('7643','2013-09-19','10:10:00',7.6),('7643','2013-09-19','10:15:00',12.12),('7643','2013-09-19','10:20:00',12.8),('7643','2013-09-19','10:25:00',13.83),('7643','2013-09-19','10:30:00',15.21),('7643','2013-09-19','10:35:00',13.94),('7643','2013-09-19','10:40:00',13.99),('7643','2013-09-19','10:45:00',15.13),('7643','2013-09-19','10:50:00',11.83),('7643','2013-09-19','10:55:00',10.19),('7643','2013-09-19','11:00:00',6.99),('7643','2013-09-19','11:05:00',6.93),('7643','2013-09-19','11:10:00',7.9),('7643','2013-09-19','11:15:00',11.45),('7643','2013-09-19','11:20:00',9.63),('7643','2013-09-19','11:25:00',8.55),('7643','2013-09-19','11:30:00',8.28),('7643','2013-09-19','11:35:00',13.36),('7643','2013-09-19','11:40:00',10.4),('7643','2013-09-19','11:45:00',15.06),('7643','2013-09-19','11:50:00',14.71),('7643','2013-09-19','11:55:00',14.21),('7643','2013-09-19','12:00:00',13.99),('7643','2013-09-19','12:05:00',14.01),('7643','2013-09-19','12:10:00',14.18),('7643','2013-09-19','12:15:00',14.45),('7643','2013-09-19','12:20:00',14.82),('7643','2013-09-19','12:25:00',13.6),('7643','2013-09-19','12:30:00',14.81),('7643','2013-09-19','12:35:00',9.49),('7643','2013-09-19','12:40:00',12.9),('7643','2013-09-19','12:45:00',6.58),('7643','2013-09-19','12:50:00',12.05),('7643','2013-09-19','12:55:00',14.91),('7643','2013-09-19','13:00:00',14.48),('7643','2013-09-19','13:05:00',14.46),('7643','2013-09-19','13:10:00',14.67),('7643','2013-09-19','13:15:00',9.36),('7643','2013-09-19','13:20:00',9.43),('7643','2013-09-19','13:25:00',12.94),('7643','2013-09-19','13:30:00',14.69),('7643','2013-09-19','13:35:00',10.58),('7643','2013-09-19','13:40:00',14.42),('7643','2013-09-19','13:45:00',14.15),('7643','2013-09-19','13:50:00',13.66),('7643','2013-09-19','13:55:00',12.23),('7643','2013-09-19','14:00:00',13.69),('7643','2013-09-19','14:05:00',13.84),('7643','2013-09-19','14:10:00',12.07),('7643','2013-09-19','14:15:00',7.91),('7643','2013-09-19','14:20:00',4.97),('7643','2013-09-19','14:25:00',12.66),('7643','2013-09-19','14:30:00',14.29),('7643','2013-09-19','14:35:00',14.09),('7643','2013-09-19','14:40:00',13.91),('7643','2013-09-19','14:45:00',13.76),('7643','2013-09-19','14:50:00',13.76),('7643','2013-09-19','14:55:00',13.57),('7643','2013-09-19','15:00:00',9.18),('7643','2013-09-19','15:05:00',6.63),('7643','2013-09-19','15:10:00',11.89),('7643','2013-09-19','15:15:00',11.42),('7643','2013-09-19','15:20:00',9.84),('7643','2013-09-19','15:25:00',7.85),('7643','2013-09-19','15:30:00',9.29),('7643','2013-09-19','15:35:00',11.58),('7643','2013-09-19','15:40:00',11.68),('7643','2013-09-19','15:45:00',11.13),('7643','2013-09-19','15:50:00',10.85),('7643','2013-09-19','15:55:00',11.13),('7643','2013-09-19','16:00:00',6.88),('7643','2013-09-19','16:05:00',5.73),('7643','2013-09-19','16:10:00',6.03),('7643','2013-09-19','16:15:00',7.8),('7643','2013-09-19','16:20:00',7.14),('7643','2013-09-19','16:25:00',5.7),('7643','2013-09-19','16:30:00',2.79),('7643','2013-09-19','16:35:00',2.9),('7643','2013-09-19','16:40:00',3.34),('7643','2013-09-19','16:45:00',6.08),('7643','2013-09-19','16:50:00',7.64),('7643','2013-09-19','16:55:00',6.95),('7643','2013-09-19','17:00:00',5.54),('7643','2013-09-19','17:05:00',8.14),('7643','2013-09-19','17:10:00',8.07),('7643','2013-09-19','17:15:00',7.41),('7643','2013-09-19','17:20:00',7.02),('7643','2013-09-19','17:25:00',5.97),('7643','2013-09-19','17:30:00',5.05),('7643','2013-09-19','17:35:00',3.99),('7643','2013-09-19','17:40:00',3.36),('7643','2013-09-19','17:45:00',3.68),('7643','2013-09-19','17:50:00',3.25),('7643','2013-09-19','17:55:00',2.84),('7643','2013-09-19','18:00:00',3.09),('7643','2013-09-19','18:05:00',2.87),('7643','2013-09-19','18:10:00',3),('7643','2013-09-19','18:15:00',2.81),('7643','2013-09-19','18:20:00',2.09),('7643','2013-09-19','18:25:00',1.6),('7643','2013-09-19','18:30:00',1.03),('7643','2013-09-18','07:35:00',1.1),('7643','2013-09-18','07:40:00',1.71),('7643','2013-09-18','07:45:00',1.61),('7643','2013-09-18','08:00:00',1.09),('7643','2013-09-18','08:05:00',1.68),('7643','2013-09-18','08:10:00',2.66),('7643','2013-09-18','08:15:00',3.61),('7643','2013-09-18','08:20:00',3.83),('7643','2013-09-18','08:25:00',3.72),('7643','2013-09-18','08:30:00',4.66),('7643','2013-09-18','08:35:00',5.22),('7643','2013-09-18','08:40:00',4.21),('7643','2013-09-18','08:45:00',4.82),('7643','2013-09-18','08:50:00',3.26),('7643','2013-09-18','08:55:00',4.82),('7643','2013-09-18','09:00:00',5.92),('7643','2013-09-18','09:05:00',3.76),('7643','2013-09-18','09:10:00',4.91),('7643','2013-09-18','09:15:00',6.43),('7643','2013-09-18','09:20:00',4.83),('7643','2013-09-18','09:25:00',4.28),('7643','2013-09-18','09:30:00',3.1),('7643','2013-09-18','09:35:00',3.1),('7643','2013-09-18','09:40:00',3.11),('7643','2013-09-18','09:45:00',2.82),('7643','2013-09-18','09:50:00',2.48),('7643','2013-09-18','09:55:00',2.59),('7643','2013-09-18','10:00:00',2.61),('7643','2013-09-18','10:05:00',7.88),('7643','2013-09-18','10:10:00',6.67),('7643','2013-09-18','10:15:00',7.78),('7643','2013-09-18','10:20:00',3.28),('7643','2013-09-18','10:25:00',5.24),('7643','2013-09-18','10:30:00',3.43),('7643','2013-09-18','10:35:00',8.62),('7643','2013-09-18','10:40:00',8.62),('7643','2013-09-18','10:45:00',11.29),('7643','2013-09-18','10:50:00',6.97),('7643','2013-09-18','10:55:00',11.5),('7643','2013-09-18','11:00:00',15.28),('7643','2013-09-18','11:05:00',15.14),('7643','2013-09-18','11:10:00',11.83),('7643','2013-09-18','11:15:00',5.77),('7643','2013-09-18','11:20:00',8.22),('7643','2013-09-18','11:25:00',6.39),('7643','2013-09-18','11:30:00',9.54),('7643','2013-09-18','11:35:00',7.09),('7643','2013-09-18','11:40:00',8.64),('7643','2013-09-18','11:45:00',13.14),('7643','2013-09-18','11:50:00',14.13),('7643','2013-09-18','11:55:00',14.93),('7643','2013-09-18','12:00:00',5.36),('7643','2013-09-18','12:05:00',5.16),('7643','2013-09-18','12:10:00',8.07),('7643','2013-09-18','12:15:00',8.92),('7643','2013-09-18','12:20:00',16.46),('7643','2013-09-18','12:25:00',16.02),('7643','2013-09-18','12:30:00',14.75),('7643','2013-09-18','12:35:00',14.98),('7643','2013-09-18','12:40:00',15.23),('7643','2013-09-18','12:45:00',13.01),('7643','2013-09-18','12:50:00',15.7),('7643','2013-09-18','12:55:00',15.31),('7643','2013-09-18','13:00:00',15.3),('7643','2013-09-18','13:05:00',15.34),('7643','2013-09-18','13:10:00',15.96),('7643','2013-09-18','13:15:00',16.01),('7643','2013-09-18','13:20:00',15.4),('7643','2013-09-18','13:25:00',13.28),('7643','2013-09-18','13:30:00',15.33),('7643','2013-09-18','13:35:00',15.3),('7643','2013-09-18','13:40:00',15.99),('7643','2013-09-18','13:45:00',16.49),('7643','2013-09-18','13:50:00',16.44),('7643','2013-09-18','13:55:00',7.96),('7643','2013-09-18','14:00:00',4.9),('7643','2013-09-18','14:05:00',11.87),('7643','2013-09-18','14:10:00',14.75),('7643','2013-09-18','14:15:00',13.4),('7643','2013-09-18','14:20:00',14.05),('7643','2013-09-18','14:25:00',13.69),('7643','2013-09-18','14:30:00',13.49),('7643','2013-09-18','14:35:00',13.38),('7643','2013-09-18','14:40:00',12.96),('7643','2013-09-18','14:45:00',12.96),('7643','2013-09-18','14:50:00',12.78),('7643','2013-09-18','14:55:00',13.31),('7643','2013-09-18','15:00:00',12.88),('7643','2013-09-18','15:05:00',12.4),('7643','2013-09-18','15:10:00',11.43),('7643','2013-09-18','15:15:00',13.04),('7643','2013-09-18','15:20:00',12.03),('7643','2013-09-18','15:25:00',11.61),('7643','2013-09-18','15:30:00',11.06),('7643','2013-09-18','15:35:00',7.94),('7643','2013-09-18','15:40:00',11.79),('7643','2013-09-18','15:45:00',11.47),('7643','2013-09-18','15:50:00',10.77),('7643','2013-09-18','15:55:00',9.64),('7643','2013-09-18','16:00:00',9.88),('7643','2013-09-18','16:05:00',9.72),('7643','2013-09-18','16:10:00',9.17),('7643','2013-09-18','16:15:00',8.95),('7643','2013-09-18','16:20:00',9.36),('7643','2013-09-18','16:25:00',9.1),('7643','2013-09-18','16:30:00',6.76),('7643','2013-09-18','16:35:00',7.11),('7643','2013-09-18','16:40:00',6.94),('7643','2013-09-18','16:45:00',6.42),('7643','2013-09-18','16:50:00',7.63),('7643','2013-09-18','16:55:00',7.24),('7643','2013-09-18','17:00:00',6.14),('7643','2013-09-18','17:05:00',5.69),('7643','2013-09-18','17:10:00',5.68),('7643','2013-09-18','17:15:00',5.25),('7643','2013-09-18','17:20:00',5.02),('7643','2013-09-18','17:25:00',4.36),('7643','2013-09-18','17:30:00',4.04),('7643','2013-09-18','17:35:00',3.33),('7643','2013-09-18','17:40:00',3.17),('7643','2013-09-18','17:45:00',2.79),('7643','2013-09-18','17:50:00',2.8),('7643','2013-09-18','17:55:00',2.57),('7643','2013-09-18','18:00:00',2.25),('7643','2013-09-18','18:05:00',2.04),('7643','2013-09-18','18:10:00',1.73),('7643','2013-09-18','18:15:00',1.6),('7643','2013-09-18','18:20:00',1.36),('7643','2013-09-18','18:25:00',1.14),('7643','2014-04-12','07:40:00',1.06),('7643','2014-04-12','07:45:00',1.13),('7643','2014-04-12','07:50:00',1.26),('7643','2014-04-12','07:55:00',1.59),('7643','2014-04-12','08:00:00',1.76),('7643','2014-04-12','08:05:00',1.92),('7643','2014-04-12','08:10:00',1.66),('7643','2014-04-12','08:15:00',1.6),('7643','2014-04-12','08:20:00',1.37),('7643','2014-04-12','08:25:00',1.71),('7643','2014-04-12','08:30:00',2.42),('7643','2014-04-12','08:35:00',2.44),('7643','2014-04-12','08:40:00',2.28),('7643','2014-04-12','08:45:00',2.42),('7643','2014-04-12','08:50:00',2.51),('7643','2014-04-12','08:55:00',2.74),('7643','2014-04-12','09:00:00',3.49),('7643','2014-04-12','09:05:00',4.55),('7643','2014-04-12','09:10:00',5.6),('7643','2014-04-12','09:15:00',4.98),('7643','2014-04-12','09:20:00',5.59),('7643','2014-04-12','09:25:00',7.73),('7643','2014-04-12','09:30:00',7.28),('7643','2014-04-12','09:35:00',5.59),('7643','2014-04-12','09:40:00',8.26),('7643','2014-04-12','09:45:00',7.62),('7643','2014-04-12','09:50:00',5.83),('7643','2014-04-12','09:55:00',6.04),('7643','2014-04-12','10:00:00',10.35),('7643','2014-04-12','10:05:00',15.31),('7643','2014-04-12','10:10:00',9.43),('7643','2014-04-12','10:15:00',8.65),('7643','2014-04-12','10:20:00',11.94),('7643','2014-04-12','10:25:00',7.34),('7643','2014-04-12','10:30:00',12.63),('7643','2014-04-12','10:35:00',13.88),('7643','2014-04-12','10:40:00',13.59),('7643','2014-04-12','10:45:00',14.41),('7643','2014-04-12','10:50:00',14.47),('7643','2014-04-12','10:55:00',14.37),('7643','2014-04-12','11:00:00',14.53),('7643','2014-04-12','11:05:00',14.67),('7643','2014-04-12','11:10:00',14.02),('7643','2014-04-12','11:15:00',13.09),('7643','2014-04-12','11:20:00',17.84),('7643','2014-04-12','11:25:00',12.57),('7643','2014-04-12','11:30:00',7.08),('7643','2014-04-12','11:35:00',13.49),('7643','2014-04-12','11:40:00',15.58),('7643','2014-04-12','11:45:00',15.11),('7643','2014-04-12','11:50:00',15.36),('7643','2014-04-12','11:55:00',10.83),('7643','2014-04-12','12:00:00',9.91),('7643','2014-04-12','12:05:00',6.55),('7643','2014-04-12','12:10:00',5.81),('7643','2014-04-12','12:15:00',5.46),('7643','2014-04-12','12:20:00',4.79),('7643','2014-04-12','12:25:00',3.54),('7643','2014-04-12','12:30:00',2.46),('7643','2014-04-12','12:35:00',1.9),('7643','2014-04-12','12:40:00',1.66),('7643','2014-04-12','12:45:00',2.01),('7643','2014-04-12','12:50:00',2.39),('7643','2014-04-12','12:55:00',2.72),('7643','2014-04-12','13:00:00',2.86),('7643','2014-04-12','13:05:00',4.55),('7643','2014-04-12','13:10:00',7.36),('7643','2014-04-12','13:15:00',7.11),('7643','2014-04-12','13:20:00',9.09),('7643','2014-04-12','13:25:00',9.94),('7643','2014-04-12','13:30:00',16.64),('7643','2014-04-12','13:35:00',16.23),('7643','2014-04-12','13:40:00',17.33),('7643','2014-04-12','13:45:00',8.37),('7643','2014-04-12','13:50:00',12.55),('7643','2014-04-12','13:55:00',11.98),('7643','2014-04-12','14:00:00',16),('7643','2014-04-12','14:05:00',14.46),('7643','2014-04-12','14:10:00',13.62),('7643','2014-04-12','14:15:00',14.47),('7643','2014-04-12','14:20:00',7.03),('7643','2014-04-12','14:25:00',6.14),('7643','2014-04-12','14:30:00',6.86),('7643','2014-04-12','14:35:00',5.7),('7643','2014-04-12','14:40:00',4.65),('7643','2014-04-12','14:45:00',6.64),('7643','2014-04-12','14:50:00',15.53),('7643','2014-04-12','14:55:00',6.03),('7643','2014-04-12','15:00:00',12.95),('7643','2014-04-12','15:05:00',14.65),('7643','2014-04-12','15:10:00',15.08),('7643','2014-04-12','15:15:00',13.46),('7643','2014-04-12','15:20:00',13.1),('7643','2014-04-12','15:25:00',13.81),('7643','2014-04-12','15:30:00',13.8),('7643','2014-04-12','15:35:00',9.26),('7643','2014-04-12','15:40:00',4.95),('7643','2014-04-12','15:45:00',5.09),('7643','2014-04-12','15:50:00',7.01),('7643','2014-04-12','15:55:00',8.01),('7643','2014-04-12','16:00:00',13.98),('7643','2014-04-12','16:05:00',11.75),('7643','2014-04-12','16:10:00',5.28),('7643','2014-04-12','16:15:00',5.15),('7643','2014-04-12','16:20:00',5.81),('7643','2014-04-12','16:25:00',6.29),('7643','2014-04-12','16:30:00',5.3),('7643','2014-04-12','16:35:00',7.67),('7643','2014-04-12','16:40:00',9.73),('7643','2014-04-12','16:45:00',12.24),('7643','2014-04-12','16:50:00',8.88),('7643','2014-04-12','16:55:00',10.23),('7643','2014-04-12','17:00:00',8.98),('7643','2014-04-12','17:05:00',6.63),('7643','2014-04-12','17:10:00',3.46),('7643','2014-04-12','17:15:00',3.58),('7643','2014-04-12','17:20:00',5.15),('7643','2014-04-12','17:25:00',4.75),('7643','2014-04-12','17:30:00',3.08),('7643','2014-04-12','17:35:00',2.55),('7643','2014-04-12','17:40:00',2.18),('7643','2014-04-12','17:45:00',2.62),('7643','2014-04-12','17:50:00',3.89),('7643','2014-04-12','17:55:00',3.91),('7643','2014-04-12','18:00:00',4.21),('7643','2014-04-12','18:05:00',2.82),('7643','2014-04-12','18:10:00',2.04),('7643','2014-04-12','18:15:00',1.74),('7643','2014-04-12','18:20:00',1.78),('7643','2014-04-12','18:25:00',1.6),('7643','2014-04-12','18:30:00',1.39),('7643','2013-09-17','07:35:00',1.12),('7643','2013-09-17','07:40:00',1.36),('7643','2013-09-17','07:45:00',1.64),('7643','2013-09-17','07:50:00',1.91),('7643','2013-09-17','07:55:00',2.19),('7643','2013-09-17','08:00:00',2.48),('7643','2013-09-17','08:05:00',2.79),('7643','2013-09-17','08:10:00',3.12),('7643','2013-09-17','08:15:00',3.05),('7643','2013-09-17','08:20:00',2.02),('7643','2013-09-17','08:25:00',3.1),('7643','2013-09-17','08:30:00',3.7),('7643','2013-09-17','08:35:00',2.78),('7643','2013-09-17','08:40:00',2.83),('7643','2013-09-17','08:45:00',5.89),('7643','2013-09-17','08:50:00',2.67),('7643','2013-09-17','08:55:00',3.03),('7643','2013-09-17','09:00:00',3.48),('7643','2013-09-17','09:05:00',4.66),('7643','2013-09-17','09:10:00',3.18),('7643','2013-09-17','09:15:00',4.43),('7643','2013-09-17','09:20:00',7.63),('7643','2013-09-17','09:25:00',4.31),('7643','2013-09-17','09:30:00',3.71),('7643','2013-09-17','09:35:00',9.89),('7643','2013-09-17','09:40:00',4.3),('7643','2013-09-17','09:45:00',4.8),('7643','2013-09-17','09:50:00',6.89),('7643','2013-09-17','09:55:00',10.36),('7643','2013-09-17','10:00:00',12.02),('7643','2013-09-17','10:05:00',11.71),('7643','2013-09-17','10:10:00',11.16),('7643','2013-09-17','10:15:00',10.77),('7643','2013-09-17','10:20:00',10.83),('7643','2013-09-17','10:25:00',10.99),('7643','2013-09-17','10:30:00',11.14),('7643','2013-09-17','10:35:00',11.17),('7643','2013-09-17','10:40:00',11.45),('7643','2013-09-17','10:45:00',10.71),('7643','2013-09-17','10:50:00',9.4),('7643','2013-09-17','10:55:00',12.26),('7643','2013-09-17','11:00:00',12.62),('7643','2013-09-17','11:05:00',10.52),('7643','2013-09-17','11:10:00',13.25),('7643','2013-09-17','11:15:00',6.9),('7643','2013-09-17','11:20:00',2.53),('7643','2013-09-17','11:25:00',11.08),('7643','2013-09-17','11:30:00',13.36),('7643','2013-09-17','11:35:00',14.78),('7643','2013-09-17','11:40:00',5.36),('7643','2013-09-17','11:45:00',12.36),('7643','2013-09-17','11:50:00',14.3),('7643','2013-09-17','11:55:00',14.4),('7643','2013-09-17','12:00:00',14.52),('7643','2013-09-17','12:05:00',14.91),('7643','2013-09-17','12:10:00',14.85),('7643','2013-09-17','12:15:00',14.73),('7643','2013-09-17','12:20:00',14.77),('7643','2013-09-17','12:25:00',14.24),('7643','2013-09-17','12:30:00',6.54),('7643','2013-09-17','12:35:00',14.83),('7643','2013-09-17','12:40:00',16.05),('7643','2013-09-17','12:45:00',9.42),('7643','2013-09-17','12:50:00',5.52),('7643','2013-09-17','12:55:00',14.4),('7643','2013-09-17','13:00:00',9.54),('7643','2013-09-17','13:05:00',11.53),('7643','2013-09-17','13:10:00',15.43),('7643','2013-09-17','13:15:00',15.64),('7643','2013-09-17','13:20:00',15.22),('7643','2013-09-17','13:25:00',15.03),('7643','2013-09-17','13:30:00',15.1),('7643','2013-09-17','13:35:00',14.73),('7643','2013-09-17','13:40:00',14.74),('7643','2013-09-17','13:45:00',14.82),('7643','2013-09-17','13:50:00',15.04),('7643','2013-09-17','13:55:00',14.6),('7643','2013-09-17','14:00:00',14.75),('7643','2013-09-17','14:05:00',10.87),('7643','2013-09-17','14:10:00',13.81),('7643','2013-09-17','14:15:00',14.11),('7643','2013-09-17','14:20:00',14.13),('7643','2013-09-17','14:25:00',13.87),('7643','2013-09-17','14:30:00',13.69),('7643','2013-09-17','14:35:00',13.57),('7643','2013-09-17','14:40:00',12.92),('7643','2013-09-17','14:45:00',13.07),('7643','2013-09-17','14:50:00',7.53),('7643','2013-09-17','14:55:00',12.26),('7643','2013-09-17','15:00:00',12.94),('7643','2013-09-17','15:05:00',11.91),('7643','2013-09-17','15:10:00',4.64),('7643','2013-09-17','15:15:00',7.07),('7643','2013-09-17','15:20:00',7.99),('7643','2013-09-17','15:25:00',8.94),('7643','2013-09-17','15:30:00',12.36),('7643','2013-09-17','15:35:00',11.77),('7643','2013-09-17','15:40:00',11.62),('7643','2013-09-17','15:45:00',10.9),('7643','2013-09-17','15:50:00',9.64),('7643','2013-09-17','15:55:00',6.73),('7643','2013-09-17','16:00:00',10.95),('7643','2013-09-17','16:05:00',10.92),('7643','2013-09-17','16:10:00',10.26),('7643','2013-09-17','16:15:00',9.59),('7643','2013-09-17','16:20:00',9.24),('7643','2013-09-17','16:25:00',8.09),('7643','2013-09-17','16:30:00',7.75),('7643','2013-09-17','16:35:00',7.15),('7643','2013-09-17','16:40:00',7.15),('7643','2013-09-17','16:45:00',7.29),('7643','2013-09-17','16:50:00',6.55),('7643','2013-09-17','16:55:00',6.08),('7643','2013-09-17','17:00:00',6.48),('7643','2013-09-17','17:05:00',5.79),('7643','2013-09-17','17:10:00',5.71),('7643','2013-09-17','17:15:00',5.49),('7643','2013-09-17','17:20:00',5.15),('7643','2013-09-17','17:25:00',3.93),('7643','2013-09-17','17:30:00',4.22),('7643','2013-09-17','17:35:00',4.14),('7643','2013-09-17','17:40:00',3.73),('7643','2013-09-17','17:45:00',3.38),('7643','2013-09-17','17:50:00',3.04),('7643','2013-09-17','17:55:00',2.7),('7643','2013-09-17','18:00:00',1.85),('7643','2013-09-17','18:05:00',1.82),('7643','2013-09-17','18:10:00',1.63),('7643','2013-09-17','18:15:00',1.41),('7643','2013-09-17','18:20:00',1.13),('7643','2013-09-16','08:15:00',1.45),('7643','2013-09-16','08:20:00',1.79),('7643','2013-09-16','08:25:00',1.73),('7643','2013-09-16','08:30:00',1.4),('7643','2013-09-16','08:35:00',1.62),('7643','2013-09-16','08:40:00',2.27),('7643','2013-09-16','08:45:00',2.04),('7643','2013-09-16','08:50:00',2),('7643','2013-09-16','08:55:00',2.32),('7643','2013-09-16','09:00:00',2.54),('7643','2013-09-16','09:05:00',2.53),('7643','2013-09-16','09:10:00',2.44),('7643','2013-09-16','09:15:00',2.76),('7643','2013-09-16','09:20:00',5.23),('7643','2013-09-16','09:25:00',3.31),('7643','2013-09-16','09:30:00',4.34),('7643','2013-09-16','09:35:00',3.05),('7643','2013-09-16','09:40:00',4.83),('7643','2013-09-16','09:45:00',7.47),('7643','2013-09-16','09:50:00',5.6),('7643','2013-09-16','09:55:00',5.18),('7643','2013-09-16','10:00:00',8.93),('7643','2013-09-16','10:05:00',7.13),('7643','2013-09-16','10:10:00',6.66),('7643','2013-09-16','10:15:00',2.74),('7643','2013-09-16','10:20:00',3.79),('7643','2013-09-16','10:25:00',9.87),('7643','2013-09-16','10:30:00',13.01),('7643','2013-09-16','10:35:00',6.83),('7643','2013-09-16','10:40:00',8.17),('7643','2013-09-16','10:45:00',7.25),('7643','2013-09-16','10:50:00',14.07),('7643','2013-09-16','10:55:00',11.25),('7643','2013-09-16','11:00:00',8.51),('7643','2013-09-16','11:05:00',9.15),('7643','2013-09-16','11:10:00',12.62),('7643','2013-09-16','11:15:00',10.51),('7643','2013-09-16','11:20:00',9.07),('7643','2013-09-16','11:25:00',6.67),('7643','2013-09-16','11:30:00',6.92),('7643','2013-09-16','11:35:00',11.93),('7643','2013-09-16','11:40:00',12.59),('7643','2013-09-16','11:45:00',12.04),('7643','2013-09-16','11:50:00',13.86),('7643','2013-09-16','11:55:00',10.29),('7643','2013-09-16','12:00:00',13.63),('7643','2013-09-16','12:05:00',9.28),('7643','2013-09-16','12:10:00',6.93),('7643','2013-09-16','12:15:00',7.24),('7643','2013-09-16','12:20:00',7.02),('7643','2013-09-16','12:25:00',14.15),('7643','2013-09-16','12:30:00',10.83),('7643','2013-09-16','12:35:00',8.78),('7643','2013-09-16','12:40:00',12.74),('7643','2013-09-16','12:45:00',14.25),('7643','2013-09-16','12:50:00',12.53),('7643','2013-09-16','12:55:00',9.94),('7643','2013-09-16','13:00:00',9.11),('7643','2013-09-16','13:05:00',4.95),('7643','2013-09-16','13:10:00',9.29),('7643','2013-09-16','13:15:00',11.62),('7643','2013-09-16','13:20:00',9.48),('7643','2013-09-16','13:25:00',8.05),('7643','2013-09-16','13:30:00',5.79),('7643','2013-09-16','13:35:00',6.95),('7643','2013-09-16','13:40:00',10.1),('7643','2013-09-16','13:45:00',5.45),('7643','2013-09-16','13:50:00',3.4),('7643','2013-09-16','13:55:00',4.85),('7643','2013-09-16','14:00:00',7.6),('7643','2013-09-16','14:05:00',4.97),('7643','2013-09-16','14:10:00',3.52),('7643','2013-09-16','14:15:00',4.88),('7643','2013-09-16','14:20:00',3.54),('7643','2013-09-16','14:25:00',7.26),('7643','2013-09-16','14:30:00',4.45),('7643','2013-09-16','14:35:00',4.23),('7643','2013-09-16','14:40:00',3.21),('7643','2013-09-16','14:45:00',2.92),('7643','2013-09-16','14:50:00',5.02),('7643','2013-09-16','14:55:00',11.96),('7643','2013-09-16','15:00:00',13.33),('7643','2013-09-16','15:05:00',10.1),('7643','2013-09-16','15:10:00',9.37),('7643','2013-09-16','15:15:00',10.65),('7643','2013-09-16','15:20:00',11.42),('7643','2013-09-16','15:25:00',10.36),('7643','2013-09-16','15:30:00',10.15),('7643','2013-09-16','15:35:00',4.94),('7643','2013-09-16','15:40:00',3.23),('7643','2013-09-16','15:45:00',3.98),('7643','2013-09-16','15:50:00',6.41),('7643','2013-09-16','15:55:00',8.39),('7643','2013-09-16','16:00:00',4.47),('7643','2013-09-16','16:05:00',7.17),('7643','2013-09-16','16:10:00',5.99),('7643','2013-09-16','16:15:00',6.29),('7643','2013-09-16','16:20:00',3.92),('7643','2013-09-16','16:25:00',2.5),('7643','2013-09-16','16:30:00',1.62),('7643','2013-09-16','16:35:00',2.5),('7643','2013-09-16','16:40:00',4.48),('7643','2013-09-16','16:45:00',5.35),('7643','2013-09-16','16:50:00',4.69),('7643','2013-09-16','16:55:00',3.44),('7643','2013-09-16','17:00:00',5.52),('7643','2013-09-16','17:05:00',6.16),('7643','2013-09-16','17:10:00',5.67),('7643','2013-09-16','17:15:00',5.83),('7643','2013-09-16','17:20:00',4.89),('7643','2013-09-16','17:25:00',4.5),('7643','2013-09-16','17:30:00',4.42),('7643','2013-09-16','17:35:00',3.25),('7643','2013-09-16','17:40:00',3.54),('7643','2013-09-16','17:45:00',2.33),('7643','2013-09-16','17:50:00',2.58),('7643','2013-09-16','17:55:00',2.58),('7643','2013-09-16','18:00:00',1.9),('7643','2013-09-16','18:05:00',2.06),('7643','2013-09-16','18:10:00',1.3),('7643','2013-09-16','18:15:00',1),('7643','2013-09-16','18:20:00',1.43),('7643','2013-09-15','07:25:00',1.19),('7643','2013-09-15','08:05:00',2.29),('7643','2013-09-15','08:10:00',3.8),('7643','2013-09-15','08:15:00',3.87),('7643','2013-09-15','08:20:00',4.06),('7643','2013-09-15','08:25:00',4.44),('7643','2013-09-15','08:30:00',4.7),('7643','2013-09-15','08:35:00',5.16),('7643','2013-09-15','08:40:00',5.83),('7643','2013-09-15','08:45:00',6.2),('7643','2013-09-15','08:50:00',5.48),('7643','2013-09-15','08:55:00',3.7),('7643','2013-09-15','09:00:00',2.72),('7643','2013-09-15','09:05:00',6.88),('7643','2013-09-15','09:10:00',4.92),('7643','2013-09-15','09:15:00',8.67),('7643','2013-09-15','09:20:00',8.16),('7643','2013-09-15','09:25:00',8.49),('7643','2013-09-15','09:30:00',8.16),('7643','2013-09-15','09:35:00',6.72),('7643','2013-09-15','09:40:00',9.33),('7643','2013-09-15','09:45:00',9.59),('7643','2013-09-15','09:50:00',9.67),('7643','2013-09-15','09:55:00',10.04),('7643','2013-09-15','10:00:00',9.33),('7643','2013-09-15','10:05:00',10.73),('7643','2013-09-15','10:10:00',11.76),('7643','2013-09-15','10:15:00',3.91),('7643','2013-09-15','10:20:00',3.73),('7643','2013-09-15','10:25:00',6.2),('7643','2013-09-15','10:30:00',12.91),('7643','2013-09-15','10:35:00',12.99),('7643','2013-09-15','10:40:00',13.76),('7643','2013-09-15','10:45:00',14.37),('7643','2013-09-15','10:50:00',12.47),('7643','2013-09-15','10:55:00',2.83),('7643','2013-09-15','11:00:00',2.7),('7643','2013-09-15','11:05:00',6.71),('7643','2013-09-15','11:10:00',2.78),('7643','2013-09-15','11:15:00',4.49),('7643','2013-09-15','11:20:00',3.35),('7643','2013-09-15','11:25:00',9.78),('7643','2013-09-15','11:30:00',14.75),('7643','2013-09-15','11:35:00',14.46),('7643','2013-09-15','11:40:00',14.53),('7643','2013-09-15','11:45:00',14.63),('7643','2013-09-15','11:50:00',11.12),('7643','2013-09-15','11:55:00',15.02),('7643','2013-09-15','12:00:00',15.31),('7643','2013-09-15','12:05:00',15.94),('7643','2013-09-15','12:10:00',17.02),('7643','2013-09-15','12:15:00',13),('7643','2013-09-15','12:20:00',15.07),('7643','2013-09-15','12:25:00',14.95),('7643','2013-09-15','12:30:00',14.82),('7643','2013-09-15','12:35:00',14.98),('7643','2013-09-15','12:40:00',15.36),('7643','2013-09-15','12:45:00',16.23),('7643','2013-09-15','12:50:00',10.13),('7643','2013-09-15','12:55:00',15.57),('7643','2013-09-15','13:00:00',16.17),('7643','2013-09-15','13:05:00',15.84),('7643','2013-09-15','13:10:00',15.97),('7643','2013-09-15','13:15:00',14.36),('7643','2013-09-15','13:20:00',14.96),('7643','2013-09-15','13:25:00',14.82),('7643','2013-09-15','13:30:00',14.62),('7643','2013-09-15','13:35:00',14.64),('7643','2013-09-15','13:40:00',14.59),('7643','2013-09-15','13:45:00',14.52),('7643','2013-09-15','13:50:00',14.59),('7643','2013-09-15','13:55:00',14.91),('7643','2013-09-15','14:00:00',14.86),('7643','2013-09-15','14:05:00',14.38),('7643','2013-09-15','14:10:00',14.09),('7643','2013-09-15','14:15:00',13.88),('7643','2013-09-15','14:20:00',13.78),('7643','2013-09-15','14:25:00',13.61),('7643','2013-09-15','14:30:00',13.56),('7643','2013-09-15','14:35:00',13.4),('7643','2013-09-15','14:40:00',13.22),('7643','2013-09-15','14:45:00',13.08),('7643','2013-09-15','14:50:00',12.97),('7643','2013-09-15','14:55:00',12.87),('7643','2013-09-15','15:00:00',12.73),('7643','2013-09-15','15:05:00',12.66),('7643','2013-09-15','15:10:00',12.47),('7643','2013-09-15','15:15:00',12.26),('7643','2013-09-15','15:20:00',12.12),('7643','2013-09-15','15:25:00',11.87),('7643','2013-09-15','15:30:00',11.64),('7643','2013-09-15','15:35:00',11.43),('7643','2013-09-15','15:40:00',11.33),('7643','2013-09-15','15:45:00',11.06),('7643','2013-09-15','15:50:00',10.82),('7643','2013-09-15','15:55:00',10.59),('7643','2013-09-15','16:00:00',10.5),('7643','2013-09-15','16:05:00',10.17),('7643','2013-09-15','16:10:00',10.27),('7643','2013-09-15','16:15:00',9.66),('7643','2013-09-15','16:20:00',9.36),('7643','2013-09-15','16:25:00',9.03),('7643','2013-09-15','16:30:00',8.74),('7643','2013-09-15','16:35:00',8.36),('7643','2013-09-15','16:40:00',8.15),('7643','2013-09-15','16:45:00',7.85),('7643','2013-09-15','16:50:00',7.51),('7643','2013-09-15','16:55:00',7.17),('7643','2013-09-15','17:00:00',6.87),('7643','2013-09-15','17:05:00',6.55),('7643','2013-09-15','17:10:00',6.2),('7643','2013-09-15','17:15:00',5.82),('7643','2013-09-15','17:20:00',5.46),('7643','2013-09-15','17:25:00',5.13),('7643','2013-09-15','17:30:00',4.53),('7643','2013-09-15','17:35:00',3.13),('7643','2013-09-15','17:40:00',2.45),('7643','2013-09-15','17:45:00',3.84),('7643','2013-09-15','17:50:00',3.35),('7643','2013-09-15','17:55:00',2.89),('7643','2013-09-15','18:00:00',2.58),('7643','2013-09-15','18:05:00',2.32),('7643','2013-09-15','18:10:00',2.02),('7643','2013-09-15','18:15:00',1.65),('7643','2013-09-15','18:20:00',1.34),('7643','2013-09-15','18:25:00',1.06),('7643','2013-09-14','07:20:00',1.08),('7643','2013-09-14','07:25:00',1.14),('7643','2013-09-14','07:30:00',1.16),('7643','2013-09-14','07:35:00',1.68),('7643','2013-09-14','07:40:00',2.01),('7643','2013-09-14','07:45:00',2.08),('7643','2013-09-14','07:50:00',2.21),('7643','2013-09-14','07:55:00',2.53),('7643','2013-09-14','08:00:00',2.86),('7643','2013-09-14','08:05:00',3.19),('7643','2013-09-14','08:10:00',3.54),('7643','2013-09-14','08:15:00',3.94),('7643','2013-09-14','08:20:00',4.29),('7643','2013-09-14','08:25:00',4.65),('7643','2013-09-14','08:30:00',4.99),('7643','2013-09-14','08:35:00',5.38),('7643','2013-09-14','08:40:00',5.85),('7643','2013-09-14','08:45:00',6.22),('7643','2013-09-14','08:50:00',6.35),('7643','2013-09-14','08:55:00',6.12),('7643','2013-09-14','09:00:00',6.59),('7643','2013-09-14','09:05:00',6.77),('7643','2013-09-14','09:10:00',7.45),('7643','2013-09-14','09:15:00',8.13),('7643','2013-09-14','09:20:00',7.94),('7643','2013-09-14','09:25:00',8.28),('7643','2013-09-14','09:30:00',8.33),('7643','2013-09-14','09:35:00',9.05),('7643','2013-09-14','09:40:00',9.21),('7643','2013-09-14','09:45:00',9.32),('7643','2013-09-14','09:50:00',9.71),('7643','2013-09-14','09:55:00',9.8),('7643','2013-09-14','10:00:00',10.28),('7643','2013-09-14','10:05:00',10.56),('7643','2013-09-14','10:10:00',10.64),('7643','2013-09-14','10:15:00',10.52),('7643','2013-09-14','10:20:00',10.65),('7643','2013-09-14','10:25:00',11.01),('7643','2013-09-14','10:30:00',10.44),('7643','2013-09-14','10:35:00',8.4),('7643','2013-09-14','10:40:00',4.42),('7643','2013-09-14','10:45:00',4.43),('7643','2013-09-14','10:50:00',3.29),('7643','2013-09-14','10:55:00',2.58),('7643','2013-09-14','11:00:00',9.19),('7643','2013-09-14','11:05:00',14.3),('7643','2013-09-14','11:10:00',12.32),('7643','2013-09-14','11:15:00',7.01),('7643','2013-09-14','11:20:00',4.18),('7643','2013-09-14','11:25:00',3.34),('7643','2013-09-14','11:30:00',4.18),('7643','2013-09-14','11:35:00',14.69),('7643','2013-09-14','11:40:00',5.62),('7643','2013-09-14','11:45:00',4.35),('7643','2013-09-14','11:50:00',11.05),('7643','2013-09-14','11:55:00',5.01),('7643','2013-09-14','12:00:00',5.4),('7643','2013-09-14','12:05:00',5.57),('7643','2013-09-14','12:10:00',4.09),('7643','2013-09-14','12:15:00',4.15),('7643','2013-09-14','12:20:00',4.92),('7643','2013-09-14','12:25:00',5.7),('7643','2013-09-14','12:30:00',5.9),('7643','2013-09-14','12:35:00',5.98),('7643','2013-09-14','12:40:00',6.13),('7643','2013-09-14','12:45:00',4.7),('7643','2013-09-14','12:50:00',4.76),('7643','2013-09-14','12:55:00',5.15),('7643','2013-09-14','13:00:00',4.47),('7643','2013-09-14','13:05:00',4.07),('7643','2013-09-14','13:10:00',3.11),('7643','2013-09-14','13:15:00',2.34),('7643','2013-09-14','13:20:00',2.31),('7643','2013-09-14','13:25:00',3.37),('7643','2013-09-14','13:30:00',3.64),('7643','2013-09-14','13:35:00',4.53),('7643','2013-09-14','13:40:00',5.07),('7643','2013-09-14','13:45:00',6.37),('7643','2013-09-14','13:50:00',6.96),('7643','2013-09-14','13:55:00',4.82),('7643','2013-09-14','14:00:00',6.81),('7643','2013-09-14','14:05:00',6.32),('7643','2013-09-14','14:10:00',5.28),('7643','2013-09-14','14:15:00',4.76),('7643','2013-09-14','14:20:00',4.59),('7643','2013-09-14','14:25:00',4.59),('7643','2013-09-14','14:30:00',4.55),('7643','2013-09-14','14:35:00',3.89),('7643','2013-09-14','14:40:00',3.84),('7643','2013-09-14','14:45:00',3.26),('7643','2013-09-14','14:50:00',3.53),('7643','2013-09-14','14:55:00',3.79),('7643','2013-09-14','15:00:00',3.89),('7643','2013-09-14','15:05:00',4.17),('7643','2013-09-14','15:10:00',4.77),('7643','2013-09-14','15:15:00',11.16),('7643','2013-09-14','15:20:00',8.1),('7643','2013-09-14','15:25:00',5.56),('7643','2013-09-14','15:30:00',4.1),('7643','2013-09-14','15:35:00',3.9),('7643','2013-09-14','15:40:00',3.61),('7643','2013-09-14','15:45:00',3.46),('7643','2013-09-14','15:50:00',3.49),('7643','2013-09-14','15:55:00',3.51),('7643','2013-09-14','16:00:00',2.99),('7643','2013-09-14','16:05:00',3.46),('7643','2013-09-14','16:10:00',2.82),('7643','2013-09-14','16:15:00',1.91),('7643','2013-09-14','16:20:00',1.46),('7643','2013-09-14','16:25:00',1.87),('7643','2013-09-14','16:30:00',2.37),('7643','2013-09-14','16:35:00',2.36),('7643','2013-09-14','16:40:00',2.86),('7643','2013-09-14','16:45:00',2.39),('7643','2013-09-14','16:50:00',1.81),('7643','2013-09-14','16:55:00',1.54),('7643','2013-09-14','17:00:00',2.01),('7643','2013-09-14','17:05:00',2.06),('7643','2013-09-14','17:10:00',1.8),('7643','2013-09-14','17:15:00',2.11),('7643','2013-09-14','17:20:00',2.72),('7643','2013-09-14','17:25:00',2.14),('7643','2013-09-14','17:30:00',2.01),('7643','2013-09-14','17:35:00',1.77),('7643','2013-09-14','17:40:00',1.25),('7643','2013-09-14','17:55:00',1.32),('7643','2013-09-14','18:00:00',2.11),('7643','2013-09-14','18:05:00',1.42),('7643','2013-09-14','18:10:00',1.19),('7643','2013-09-14','18:15:00',1.08),('7643','2013-09-13','07:30:00',1.04),('7643','2013-09-13','07:35:00',1.25),('7643','2013-09-13','07:40:00',1.53),('7643','2013-09-13','07:45:00',1.83),('7643','2013-09-13','07:50:00',2.14),('7643','2013-09-13','07:55:00',2.45),('7643','2013-09-13','08:00:00',2.78),('7643','2013-09-13','08:05:00',3.1),('7643','2013-09-13','08:10:00',3.46),('7643','2013-09-13','08:15:00',3.79),('7643','2013-09-13','08:20:00',4.16),('7643','2013-09-13','08:25:00',4.47),('7643','2013-09-13','08:30:00',4.86),('7643','2013-09-13','08:35:00',5.21),('7643','2013-09-13','08:40:00',5.55),('7643','2013-09-13','08:45:00',5.9),('7643','2013-09-13','08:50:00',6.22),('7643','2013-09-13','08:55:00',6.55),('7643','2013-09-13','09:00:00',6.87),('7643','2013-09-13','09:05:00',7.21),('7643','2013-09-13','09:10:00',7.52),('7643','2013-09-13','09:15:00',7.82),('7643','2013-09-13','09:20:00',8.12),('7643','2013-09-13','09:25:00',8.4),('7643','2013-09-13','09:30:00',8.7),('7643','2013-09-13','09:35:00',8.86),('7643','2013-09-13','09:40:00',8.99),('7643','2013-09-13','09:45:00',9.27),('7643','2013-09-13','09:50:00',9.6),('7643','2013-09-13','09:55:00',9.6),('7643','2013-09-13','10:00:00',10.07),('7643','2013-09-13','10:05:00',10.21),('7643','2013-09-13','10:10:00',9.56),('7643','2013-09-13','10:15:00',10),('7643','2013-09-13','10:20:00',10.82),('7643','2013-09-13','10:25:00',11.13),('7643','2013-09-13','10:30:00',11.08),('7643','2013-09-13','10:35:00',11.45),('7643','2013-09-13','10:40:00',12.15),('7643','2013-09-13','10:45:00',13.07),('7643','2013-09-13','10:50:00',12.04),('7643','2013-09-13','10:55:00',13.72),('7643','2013-09-13','11:00:00',14.46),('7643','2013-09-13','11:05:00',11.71),('7643','2013-09-13','11:10:00',8.11),('7643','2013-09-13','11:15:00',3.53),('7643','2013-09-13','11:20:00',2.12),('7643','2013-09-13','11:25:00',9.94),('7643','2013-09-13','11:30:00',14.03),('7643','2013-09-13','11:35:00',9.12),('7643','2013-09-13','11:40:00',9.23),('7643','2013-09-13','11:45:00',12.16),('7643','2013-09-13','11:50:00',13.99),('7643','2013-09-13','11:55:00',14.26),('7643','2013-09-13','12:00:00',12.21),('7643','2013-09-13','12:05:00',13.67),('7643','2013-09-13','12:10:00',11.9),('7643','2013-09-13','12:15:00',12.54),('7643','2013-09-13','12:20:00',6.99),('7643','2013-09-13','12:25:00',2.18),('7643','2013-09-13','12:30:00',2.78),('7643','2013-09-13','12:35:00',5.86),('7643','2013-09-13','12:40:00',13.9),('7643','2013-09-13','12:45:00',5.44),('7643','2013-09-13','12:50:00',3.5),('7643','2013-09-13','12:55:00',3.2),('7643','2013-09-13','13:00:00',3.22),('7643','2013-09-13','13:05:00',2.58),('7643','2013-09-13','13:10:00',3.34),('7643','2013-09-13','13:15:00',8.6),('7643','2013-09-13','13:20:00',13.42),('7643','2013-09-13','13:25:00',10.96),('7643','2013-09-13','13:30:00',16.55),('7643','2013-09-13','13:35:00',5),('7643','2013-09-13','13:40:00',5.45),('7643','2013-09-13','13:45:00',8.76),('7643','2013-09-13','13:50:00',8.66),('7643','2013-09-13','13:55:00',15.48),('7643','2013-09-13','14:00:00',16.14),('7643','2013-09-13','14:05:00',14.89),('7643','2013-09-13','14:10:00',14.6),('7643','2013-09-13','14:15:00',14.42),('7643','2013-09-13','14:20:00',14.12),('7643','2013-09-13','14:25:00',14.01),('7643','2013-09-13','14:30:00',13.99),('7643','2013-09-13','14:35:00',13.66),('7643','2013-09-13','14:40:00',13.5),('7643','2013-09-13','14:45:00',11.69),('7643','2013-09-13','14:50:00',13.33),('7643','2013-09-13','14:55:00',13.15),('7643','2013-09-13','15:00:00',12.97),('7643','2013-09-13','15:05:00',12.65),('7643','2013-09-13','15:10:00',12.45),('7643','2013-09-13','15:15:00',12.23),('7643','2013-09-13','15:20:00',12.11),('7643','2013-09-13','15:25:00',12.01),('7643','2013-09-13','15:30:00',10.85),('7643','2013-09-13','15:35:00',11.61),('7643','2013-09-13','15:40:00',11.4),('7643','2013-09-13','15:45:00',10.15),('7643','2013-09-13','15:50:00',10.93),('7643','2013-09-13','15:55:00',10.61),('7643','2013-09-13','16:00:00',10.3),('7643','2013-09-13','16:05:00',9.92),('7643','2013-09-13','16:10:00',9.7),('7643','2013-09-13','16:15:00',9.39),('7643','2013-09-13','16:20:00',9.24),('7643','2013-09-13','16:25:00',8.94),('7643','2013-09-13','16:30:00',8.71),('7643','2013-09-13','16:35:00',8.41),('7643','2013-09-13','16:40:00',8.08),('7643','2013-09-13','16:45:00',7.8),('7643','2013-09-13','16:50:00',7.52),('7643','2013-09-13','16:55:00',7.23),('7643','2013-09-13','17:00:00',6.95),('7643','2013-09-13','17:05:00',6.7),('7643','2013-09-13','17:10:00',6.25),('7643','2013-09-13','17:15:00',6.03),('7643','2013-09-13','17:20:00',5.62),('7643','2013-09-13','17:25:00',5.29),('7643','2013-09-13','17:30:00',4.85),('7643','2013-09-13','17:35:00',3.85),('7643','2013-09-13','17:40:00',3.77),('7643','2013-09-13','17:45:00',3.89),('7643','2013-09-13','17:50:00',3.54),('7643','2013-09-13','17:55:00',3.15),('7643','2013-09-13','18:00:00',2.71),('7643','2013-09-13','18:05:00',2.39),('7643','2013-09-13','18:10:00',2.06),('7643','2013-09-13','18:15:00',1.89),('7643','2013-09-13','18:20:00',1.54),('7643','2013-09-13','18:25:00',1.19),('7643','2013-09-12','08:00:00',1.03),('7643','2013-09-12','08:05:00',1.22),('7643','2013-09-12','08:10:00',1.64),('7643','2013-09-12','08:15:00',2.08),('7643','2013-09-12','08:20:00',2.55),('7643','2013-09-12','08:25:00',2.94),('7643','2013-09-12','08:30:00',3.8),('7643','2013-09-12','08:35:00',2.57),('7643','2013-09-12','08:40:00',2.65),('7643','2013-09-12','08:45:00',3.06),('7643','2013-09-12','08:50:00',3.45),('7643','2013-09-12','08:55:00',3.8),('7643','2013-09-12','09:00:00',3.72),('7643','2013-09-12','09:05:00',3.6),('7643','2013-09-12','09:10:00',3.54),('7643','2013-09-12','09:15:00',3.72),('7643','2013-09-12','09:20:00',3.71),('7643','2013-09-12','09:25:00',4.03),('7643','2013-09-12','09:30:00',4.39),('7643','2013-09-12','09:35:00',4.79),('7643','2013-09-12','09:40:00',5.21),('7643','2013-09-12','09:45:00',5.1),('7643','2013-09-12','09:50:00',5.94),('7643','2013-09-12','09:55:00',11.45),('7643','2013-09-12','10:00:00',9.07),('7643','2013-09-12','10:05:00',5.71),('7643','2013-09-12','10:10:00',7.58),('7643','2013-09-12','10:15:00',12.57),('7643','2013-09-12','10:20:00',14.19),('7643','2013-09-12','10:25:00',8.34),('7643','2013-09-12','10:30:00',7.32),('7643','2013-09-12','10:35:00',11.99),('7643','2013-09-12','10:40:00',12.3),('7643','2013-09-12','10:45:00',12.27),('7643','2013-09-12','10:50:00',12.43),('7643','2013-09-12','10:55:00',12.59),('7643','2013-09-12','11:00:00',12.72),('7643','2013-09-12','11:05:00',12.88),('7643','2013-09-12','11:10:00',12.93),('7643','2013-09-12','11:15:00',13.07),('7643','2013-09-12','11:20:00',13.25),('7643','2013-09-12','11:25:00',13.34),('7643','2013-09-12','11:30:00',13.53),('7643','2013-09-12','11:35:00',13.62),('7643','2013-09-12','11:40:00',13.75),('7643','2013-09-12','11:45:00',13.86),('7643','2013-09-12','11:50:00',13.85),('7643','2013-09-12','11:55:00',13.98),('7643','2013-09-12','12:00:00',14.14),('7643','2013-09-12','12:05:00',14.45),('7643','2013-09-12','12:10:00',14.59),('7643','2013-09-12','12:15:00',14.6),('7643','2013-09-12','12:20:00',14.61),('7643','2013-09-12','12:25:00',14.78),('7643','2013-09-12','12:30:00',15.17),('7643','2013-09-12','12:35:00',14.82),('7643','2013-09-12','12:40:00',14.73),('7643','2013-09-12','12:45:00',14.83),('7643','2013-09-12','12:50:00',14.93),('7643','2013-09-12','12:55:00',14.87),('7643','2013-09-12','13:00:00',14.65),('7643','2013-09-12','13:05:00',14.53),('7643','2013-09-12','13:10:00',14.57),('7643','2013-09-12','13:15:00',14.46),('7643','2013-09-12','13:20:00',14.41),('7643','2013-09-12','13:25:00',14.47),('7643','2013-09-12','13:30:00',14.41),('7643','2013-09-12','13:35:00',14.38),('7643','2013-09-12','13:40:00',14.36),('7643','2013-09-12','13:45:00',14.26),('7643','2013-09-12','13:50:00',14.19),('7643','2013-09-12','13:55:00',14.19),('7643','2013-09-12','14:00:00',14.13),('7643','2013-09-12','14:05:00',13.99),('7643','2013-09-12','14:10:00',13.79),('7643','2013-09-12','14:15:00',13.6),('7643','2013-09-12','14:20:00',13.6),('7643','2013-09-12','14:25:00',13.7),('7643','2013-09-12','14:30:00',8.21),('7643','2013-09-12','14:35:00',12.49),('7643','2013-09-12','14:40:00',12.99),('7643','2013-09-12','14:45:00',8.46),('7643','2013-09-12','14:50:00',13.58),('7643','2013-09-12','14:55:00',12.78),('7643','2013-09-12','15:00:00',12.64),('7643','2013-09-12','15:05:00',12.51),('7643','2013-09-12','15:10:00',12.51),('7643','2013-09-12','15:15:00',12.3),('7643','2013-09-12','15:20:00',12.03),('7643','2013-09-12','15:25:00',11.89),('7643','2013-09-12','15:30:00',11.79),('7643','2013-09-12','15:35:00',11.62),('7643','2013-09-12','15:40:00',11.45),('7643','2013-09-12','15:45:00',11.24),('7643','2013-09-12','15:50:00',10.99),('7643','2013-09-12','15:55:00',10.73),('7643','2013-09-12','16:00:00',10.44),('7643','2013-09-12','16:05:00',10.19),('7643','2013-09-12','16:10:00',9.95),('7643','2013-09-12','16:15:00',9.68),('7643','2013-09-12','16:20:00',9.41),('7643','2013-09-12','16:25:00',9.18),('7643','2013-09-12','16:30:00',8.87),('7643','2013-09-12','16:35:00',8.54),('7643','2013-09-12','16:40:00',8.21),('7643','2013-09-12','16:45:00',7.9),('7643','2013-09-12','16:50:00',7.59),('7643','2013-09-12','16:55:00',7.23),('7643','2013-09-12','17:00:00',6.89),('7643','2013-09-12','17:05:00',6.6),('7643','2013-09-12','17:10:00',6.24),('7643','2013-09-12','17:15:00',5.94),('7643','2013-09-12','17:20:00',5.59),('7643','2013-09-12','17:25:00',5.23),('7643','2013-09-12','17:30:00',4.86),('7643','2013-09-12','17:35:00',4.52),('7643','2013-09-12','17:40:00',4.17),('7643','2013-09-12','17:45:00',3.85),('7643','2013-09-12','17:50:00',3.5),('7643','2013-09-12','17:55:00',3.17),('7643','2013-09-12','18:00:00',2.84),('7643','2013-09-12','18:05:00',2.5),('7643','2013-09-12','18:10:00',2.17),('7643','2013-09-12','18:15:00',1.87),('7643','2013-09-12','18:20:00',1.56),('7643','2013-09-12','18:25:00',1.29),('7643','2013-09-12','18:30:00',1.01),('7643','2013-09-11','07:25:00',1.28),('7643','2013-09-11','07:30:00',1.44),('7643','2013-09-11','07:35:00',1.31),('7643','2013-09-11','07:40:00',1.45),('7643','2013-09-11','07:45:00',1.72),('7643','2013-09-11','07:50:00',1.74),('7643','2013-09-11','07:55:00',2.49),('7643','2013-09-11','08:00:00',3.45),('7643','2013-09-11','08:05:00',2.84),('7643','2013-09-11','08:10:00',2.24),('7643','2013-09-11','08:15:00',4.52),('7643','2013-09-11','08:20:00',4.5),('7643','2013-09-11','08:25:00',5.4),('7643','2013-09-11','08:30:00',6.13),('7643','2013-09-11','08:35:00',6.06),('7643','2013-09-11','08:40:00',4.58),('7643','2013-09-11','08:45:00',2.71),('7643','2013-09-11','08:50:00',2.42),('7643','2013-09-11','08:55:00',5.92),('7643','2013-09-11','09:00:00',6.89),('7643','2013-09-11','09:05:00',6.67),('7643','2013-09-11','09:10:00',5.04),('7643','2013-09-11','09:15:00',7.75),('7643','2013-09-11','09:20:00',7.85),('7643','2013-09-11','09:25:00',8.47),('7643','2013-09-11','09:30:00',9.06),('7643','2013-09-11','09:35:00',7.05),('7643','2013-09-11','09:40:00',6.88),('7643','2013-09-11','09:45:00',7.51),('7643','2013-09-11','09:50:00',10.3),('7643','2013-09-11','09:55:00',6.14),('7643','2013-09-11','10:00:00',3.99),('7643','2013-09-11','10:05:00',5.19),('7643','2013-09-11','10:10:00',6.32),('7643','2013-09-11','10:15:00',6.52),('7643','2013-09-11','10:20:00',4.67),('7643','2013-09-11','10:25:00',3.38),('7643','2013-09-11','10:30:00',5.64),('7643','2013-09-11','10:35:00',7.34),('7643','2013-09-11','10:40:00',2.99),('7643','2013-09-11','10:45:00',1.37),('7643','2013-09-11','10:50:00',2.28),('7643','2013-09-11','10:55:00',7.34),('7643','2013-09-11','11:00:00',8.38),('7643','2013-09-11','11:05:00',11.12),('7643','2013-09-11','11:10:00',8.81),('7643','2013-09-11','11:15:00',10.99),('7643','2013-09-11','11:20:00',5.5),('7643','2013-09-11','11:25:00',1.09),('7643','2013-09-11','11:40:00',3.55),('7643','2013-09-11','11:45:00',9.88),('7643','2013-09-11','11:50:00',6.17),('7643','2013-09-11','11:55:00',6.25),('7643','2013-09-11','12:00:00',12.49),('7643','2013-09-11','12:05:00',14.16),('7643','2013-09-11','12:10:00',11.7),('7643','2013-09-11','12:15:00',10.42),('7643','2013-09-11','12:20:00',5.14),('7643','2013-09-11','12:25:00',5.93),('7643','2013-09-11','12:30:00',5.46),('7643','2013-09-11','12:35:00',10.47),('7643','2013-09-11','12:40:00',11.97),('7643','2013-09-11','12:45:00',4.1),('7643','2013-09-11','12:50:00',6.61),('7643','2013-09-11','12:55:00',5.87),('7643','2013-09-11','13:00:00',16.86),('7643','2013-09-11','13:05:00',8.3),('7643','2013-09-11','13:10:00',12.93),('7643','2013-09-11','13:15:00',17.03),('7643','2013-09-11','13:20:00',16.95),('7643','2013-09-11','13:25:00',17.02),('7643','2013-09-11','13:30:00',13.84),('7643','2013-09-11','13:35:00',12.15),('7643','2013-09-11','13:40:00',9.9),('7643','2013-09-11','13:45:00',10.02),('7643','2013-09-11','13:50:00',15.77),('7643','2013-09-11','13:55:00',15.22),('7643','2013-09-11','14:00:00',15.28),('7643','2013-09-11','14:05:00',14.35),('7643','2013-09-11','14:10:00',13.11),('7643','2013-09-11','14:15:00',13.82),('7643','2013-09-11','14:20:00',15.25),('7643','2013-09-11','14:25:00',14.89),('7643','2013-09-11','14:30:00',14.8),('7643','2013-09-11','14:35:00',11.39),('7643','2013-09-11','14:40:00',8.94),('7643','2013-09-11','14:45:00',14.17),('7643','2013-09-11','14:50:00',13.76),('7643','2013-09-11','14:55:00',13.43),('7643','2013-09-11','15:00:00',12.78),('7643','2013-09-11','15:05:00',9.36),('7643','2013-09-11','15:10:00',10.64),('7643','2013-09-11','15:15:00',12.47),('7643','2013-09-11','15:20:00',12.37),('7643','2013-09-11','15:25:00',12.09),('7643','2013-09-11','15:30:00',12.15),('7643','2013-09-11','15:35:00',11.89),('7643','2013-09-11','15:40:00',11.71),('7643','2013-09-11','15:45:00',11.59),('7643','2013-09-11','15:50:00',11.28),('7643','2013-09-11','15:55:00',10.99),('7643','2013-09-11','16:00:00',10.94),('7643','2013-09-11','16:05:00',9.39),('7643','2013-09-11','16:10:00',10.4),('7643','2013-09-11','16:15:00',7.04),('7643','2013-09-11','16:20:00',7.73),('7643','2013-09-11','16:25:00',8.09),('7643','2013-09-11','16:30:00',7.52),('7643','2013-09-11','16:35:00',4.71),('7643','2013-09-11','16:40:00',6.88),('7643','2013-09-11','16:45:00',8.48),('7643','2013-09-11','16:50:00',1.8),('7643','2013-09-11','16:55:00',5.85),('7643','2013-09-11','17:00:00',6.38),('7643','2013-09-11','17:05:00',6.5),('7643','2013-09-11','17:10:00',5.86),('7643','2013-09-11','17:15:00',6.5),('7643','2013-09-11','17:20:00',2.94),('7643','2013-09-11','17:25:00',1.62),('7643','2013-09-11','17:30:00',4.6),('7643','2013-09-11','17:35:00',5.35),('7643','2013-09-11','17:40:00',4.71),('7643','2013-09-11','17:45:00',4.53),('7643','2013-09-11','17:50:00',3.49),('7643','2013-09-11','17:55:00',3.51),('7643','2013-09-11','18:00:00',3.02),('7643','2013-09-11','18:10:00',1.66),('7643','2013-09-11','18:15:00',2.36),('7643','2013-09-11','18:20:00',1.96),('7643','2013-09-10','08:00:00',3.02),('7643','2013-09-10','08:05:00',4.07),('7643','2013-09-10','08:10:00',4.38),('7643','2013-09-10','08:15:00',3.58),('7643','2013-09-10','08:20:00',2.11),('7643','2013-09-10','08:25:00',2.16),('7643','2013-09-10','08:30:00',3.24),('7643','2013-09-10','08:35:00',2.73),('7643','2013-09-10','08:40:00',2.78),('7643','2013-09-10','08:45:00',2.35),('7643','2013-09-10','08:50:00',3.63),('7643','2013-09-10','08:55:00',3.68),('7643','2013-09-10','09:00:00',7.53),('7643','2013-09-10','09:05:00',7.11),('7643','2013-09-10','09:10:00',6.56),('7643','2013-09-10','09:15:00',8.49),('7643','2013-09-10','09:20:00',8.12),('7643','2013-09-10','09:25:00',7.19),('7643','2013-09-10','09:30:00',5.38),('7643','2013-09-10','09:35:00',6.31),('7643','2013-09-10','09:40:00',7.31),('7643','2013-09-10','09:45:00',2.72),('7643','2013-09-10','09:50:00',3.16),('7643','2013-09-10','09:55:00',3.09),('7643','2013-09-10','10:00:00',4.12),('7643','2013-09-10','10:05:00',10.58),('7643','2013-09-10','10:10:00',2.36),('7643','2013-09-10','10:15:00',5.96),('7643','2013-09-10','10:20:00',10.14),('7643','2013-09-10','10:25:00',7.49),('7643','2013-09-10','10:30:00',9.71),('7643','2013-09-10','10:35:00',12.48),('7643','2013-09-10','10:40:00',13.24),('7643','2013-09-10','10:45:00',9.85),('7643','2013-09-10','10:50:00',10.96),('7643','2013-09-10','10:55:00',6.27),('7643','2013-09-10','11:00:00',5.63),('7643','2013-09-10','11:05:00',12.11),('7643','2013-09-10','11:10:00',15.42),('7643','2013-09-10','11:15:00',10.71),('7643','2013-09-10','11:20:00',14.12),('7643','2013-09-10','11:25:00',11.24),('7643','2013-09-10','11:30:00',3.51),('7643','2013-09-10','11:35:00',12.6),('7643','2013-09-10','11:40:00',10.42),('7643','2013-09-10','11:45:00',14.75),('7643','2013-09-10','11:50:00',14.83),('7643','2013-09-10','11:55:00',13.31),('7643','2013-09-10','12:00:00',10.7),('7643','2013-09-10','12:05:00',14.86),('7643','2013-09-10','12:10:00',8.11),('7643','2013-09-10','12:15:00',10.52),('7643','2013-09-10','12:20:00',10.91),('7643','2013-09-10','12:25:00',6.74),('7643','2013-09-10','12:30:00',11.69),('7643','2013-09-10','12:35:00',8.03),('7643','2013-09-10','12:40:00',8.22),('7643','2013-09-10','12:45:00',13.53),('7643','2013-09-10','12:50:00',16.5),('7643','2013-09-10','12:55:00',14.9),('7643','2013-09-10','13:00:00',13.52),('7643','2013-09-10','13:05:00',15.58),('7643','2013-09-10','13:10:00',15.57),('7643','2013-09-10','13:15:00',15.85),('7643','2013-09-10','13:20:00',16.34),('7643','2013-09-10','13:25:00',13.33),('7643','2013-09-10','13:30:00',11.72),('7643','2013-09-10','13:35:00',13.61),('7643','2013-09-10','13:40:00',15.49),('7643','2013-09-10','13:45:00',11.08),('7643','2013-09-10','13:50:00',15.07),('7643','2013-09-10','13:55:00',9.53),('7643','2013-09-10','14:00:00',14.47),('7643','2013-09-10','14:05:00',15.03),('7643','2013-09-10','14:10:00',8.32),('7643','2013-09-10','14:15:00',14.83),('7643','2013-09-10','14:20:00',11.55),('7643','2013-09-10','14:25:00',13.01),('7643','2013-09-10','14:30:00',13.82),('7643','2013-09-10','14:35:00',13.92),('7643','2013-09-10','14:40:00',9.61),('7643','2013-09-10','14:45:00',10.07),('7643','2013-09-10','14:50:00',10.99),('7643','2013-09-10','14:55:00',8.76),('7643','2013-09-10','15:00:00',13.39),('7643','2013-09-10','15:05:00',11.08),('7643','2013-09-10','15:10:00',9.77),('7643','2013-09-10','15:15:00',12.83),('7643','2013-09-10','15:20:00',12.8),('7643','2013-09-10','15:25:00',5.06),('7643','2013-09-10','15:30:00',10.04),('7643','2013-09-10','15:35:00',4.62),('7643','2013-09-10','15:40:00',4.24),('7643','2013-09-10','15:45:00',7.86),('7643','2013-09-10','15:50:00',10.17),('7643','2013-09-10','15:55:00',11.44),('7643','2013-09-10','16:00:00',10.91),('7643','2013-09-10','16:05:00',10.07),('7643','2013-09-10','16:10:00',10.65),('7643','2013-09-10','16:15:00',10.45),('7643','2013-09-10','16:20:00',9.71),('7643','2013-09-10','16:25:00',7.39),('7643','2013-09-10','16:30:00',8.11),('7643','2013-09-10','16:35:00',7.57),('7643','2013-09-10','16:40:00',7.43),('7643','2013-09-10','16:45:00',8.64),('7643','2013-09-10','16:50:00',7.55),('7643','2013-09-10','16:55:00',7.03),('7643','2013-09-10','17:00:00',5.9),('7643','2013-09-10','17:05:00',6.91),('7643','2013-09-10','17:10:00',6.53),('7643','2013-09-10','17:15:00',6.1),('7643','2013-09-10','17:20:00',5.78),('7643','2013-09-10','17:25:00',5.44),('7643','2013-09-10','17:30:00',5.06),('7643','2013-09-10','17:35:00',4.73),('7643','2013-09-10','17:40:00',3.8),('7643','2013-09-10','17:45:00',3.85),('7643','2013-09-10','17:50:00',3.83),('7643','2013-09-10','17:55:00',2.71),('7643','2013-09-10','18:00:00',3.29),('7643','2013-09-10','18:05:00',2.84),('7643','2013-09-10','18:10:00',2.48),('7643','2013-09-10','18:15:00',2.09),('7643','2013-09-10','18:20:00',1.4),('7643','2013-09-10','18:25:00',1.42),('7643','2013-09-10','18:30:00',1.15),('7643','2013-09-09','07:45:00',1.34),('7643','2013-09-09','07:50:00',1.9),('7643','2013-09-09','07:55:00',2.61),('7643','2013-09-09','08:00:00',2.84),('7643','2013-09-09','08:05:00',2.23),('7643','2013-09-09','08:10:00',2.62),('7643','2013-09-09','08:15:00',3.15),('7643','2013-09-09','08:20:00',2.48),('7643','2013-09-09','08:25:00',2.01),('7643','2013-09-09','08:30:00',1.83),('7643','2013-09-09','08:35:00',1.75),('7643','2013-09-09','08:40:00',2.18),('7643','2013-09-09','08:45:00',2.74),('7643','2013-09-09','08:50:00',2.92),('7643','2013-09-09','08:55:00',6.29),('7643','2013-09-09','09:00:00',6.61),('7643','2013-09-09','09:05:00',7.56),('7643','2013-09-09','09:10:00',8.74),('7643','2013-09-09','09:15:00',7.36),('7643','2013-09-09','09:20:00',5.3),('7643','2013-09-09','09:25:00',5.46),('7643','2013-09-09','09:30:00',9.49),('7643','2013-09-09','09:35:00',10.84),('7643','2013-09-09','09:40:00',6.31),('7643','2013-09-09','09:45:00',4.94),('7643','2013-09-09','09:50:00',4.44),('7643','2013-09-09','09:55:00',4.13),('7643','2013-09-09','10:00:00',3.07),('7643','2013-09-09','10:05:00',2.74),('7643','2013-09-09','10:10:00',2.3),('7643','2013-09-09','10:15:00',2.21),('7643','2013-09-09','10:20:00',3.16),('7643','2013-09-09','10:25:00',3.51),('7643','2013-09-09','10:30:00',3.66),('7643','2013-09-09','10:35:00',4.15),('7643','2013-09-09','10:40:00',5.37),('7643','2013-09-09','10:45:00',7.29),('7643','2013-09-09','10:50:00',4.45),('7643','2013-09-09','10:55:00',4.65),('7643','2013-09-09','11:00:00',5.49),('7643','2013-09-09','11:05:00',4.54),('7643','2013-09-09','11:10:00',4.93),('7643','2013-09-09','11:15:00',4.31),('7643','2013-09-09','11:20:00',4.62),('7643','2013-09-09','11:25:00',5.29),('7643','2013-09-09','11:30:00',4),('7643','2013-09-09','11:35:00',2.75),('7643','2013-09-09','11:40:00',2.91),('7643','2013-09-09','11:45:00',4.41),('7643','2013-09-09','11:50:00',4.52),('7643','2013-09-09','11:55:00',5.66),('7643','2013-09-09','12:00:00',4.51),('7643','2013-09-09','12:05:00',3.73),('7643','2013-09-09','12:10:00',3.53),('7643','2013-09-09','12:15:00',3.63),('7643','2013-09-09','12:20:00',3.97),('7643','2013-09-09','12:25:00',3.84),('7643','2013-09-09','12:30:00',3.19),('7643','2013-09-09','12:35:00',3.18),('7643','2013-09-09','12:40:00',2.56),('7643','2013-09-09','12:45:00',2.33),('7643','2013-09-09','12:50:00',2.22),('7643','2013-09-09','12:55:00',1.98),('7643','2013-09-09','13:00:00',2.32),('7643','2013-09-09','13:05:00',2.08),('7643','2013-09-09','13:10:00',2),('7643','2013-09-09','13:15:00',2.91),('7643','2013-09-09','13:20:00',3.14),('7643','2013-09-09','13:25:00',3.7),('7643','2013-09-09','13:30:00',3.45),('7643','2013-09-09','13:35:00',3.66),('7643','2013-09-09','13:40:00',6.19),('7643','2013-09-09','13:45:00',10.09),('7643','2013-09-09','13:50:00',6.42),('7643','2013-09-09','13:55:00',5.52),('7643','2013-09-09','14:00:00',3.83),('7643','2013-09-09','14:05:00',4.56),('7643','2013-09-09','14:10:00',4.66),('7643','2013-09-09','14:15:00',5.66),('7643','2013-09-09','14:20:00',5.68),('7643','2013-09-09','14:25:00',7.8),('7643','2013-09-09','14:30:00',7.15),('7643','2013-09-09','14:35:00',5.29),('7643','2013-09-09','14:40:00',6.51),('7643','2013-09-09','14:45:00',6.7),('7643','2013-09-09','14:50:00',7.61),('7643','2013-09-09','14:55:00',6.81),('7643','2013-09-09','15:00:00',9.05),('7643','2013-09-09','15:05:00',8.26),('7643','2013-09-09','15:10:00',5.81),('7643','2013-09-09','15:15:00',5.9),('7643','2013-09-09','15:20:00',7.09),('7643','2013-09-09','15:25:00',6.37),('7643','2013-09-09','15:30:00',7.34),('7643','2013-09-09','15:35:00',6.4),('7643','2013-09-09','15:40:00',4.14),('7643','2013-09-09','15:45:00',3.7),('7643','2013-09-09','15:50:00',3.68),('7643','2013-09-09','15:55:00',3.55),('7643','2013-09-09','16:00:00',3.66),('7643','2013-09-09','16:05:00',4.1),('7643','2013-09-09','16:10:00',4.52),('7643','2013-09-09','16:15:00',5.06),('7643','2013-09-09','16:20:00',3.73),('7643','2013-09-09','16:25:00',3.43),('7643','2013-09-09','16:30:00',2.77),('7643','2013-09-09','16:35:00',1.51),('7643','2013-09-09','16:40:00',1.37),('7643','2013-09-09','16:45:00',1.97),('7643','2013-09-09','16:50:00',2.59),('7643','2013-09-09','16:55:00',2.66),('7643','2013-09-09','17:00:00',2.34),('7643','2013-09-09','17:05:00',2.17),('7643','2013-09-09','17:10:00',2.41),('7643','2013-09-09','17:15:00',2.78),('7643','2013-09-09','17:20:00',2.84),('7643','2013-09-09','17:25:00',2.73),('7643','2013-09-09','17:30:00',2.4),('7643','2013-09-09','17:35:00',1.95),('7643','2013-09-09','17:40:00',1.82),('7643','2013-09-09','17:45:00',2.28),('7643','2013-09-09','17:50:00',2.59),('7643','2013-09-09','17:55:00',2.17),('7643','2013-09-09','18:00:00',1.85),('7643','2013-09-09','18:05:00',1.49),('7643','2013-09-09','18:10:00',1.14),('7643','2013-09-08','07:25:00',1.03),('7643','2013-09-08','07:30:00',1.64),('7643','2013-09-08','07:35:00',2.26),('7643','2013-09-08','07:40:00',2.94),('7643','2013-09-08','07:45:00',3.32),('7643','2013-09-08','07:50:00',3.56),('7643','2013-09-08','07:55:00',3.29),('7643','2013-09-08','08:00:00',3),('7643','2013-09-08','08:05:00',2.16),('7643','2013-09-08','08:10:00',1.98),('7643','2013-09-08','08:15:00',1.95),('7643','2013-09-08','08:20:00',2.01),('7643','2013-09-08','08:25:00',2.12),('7643','2013-09-08','08:30:00',2.1),('7643','2013-09-08','08:35:00',2.01),('7643','2013-09-08','08:40:00',2.31),('7643','2013-09-08','08:45:00',3.02),('7643','2013-09-08','08:50:00',3.47),('7643','2013-09-08','08:55:00',4.08),('7643','2013-09-08','09:00:00',4.12),('7643','2013-09-08','09:05:00',3.7),('7643','2013-09-08','09:10:00',3.1),('7643','2013-09-08','09:15:00',2.04),('7643','2013-09-08','09:20:00',2.63),('7643','2013-09-08','09:25:00',2.54),('7643','2013-09-08','09:30:00',2.59),('7643','2013-09-08','09:35:00',3.84),('7643','2013-09-08','09:40:00',3.57),('7643','2013-09-08','09:45:00',2.83),('7643','2013-09-08','09:50:00',3.05),('7643','2013-09-08','09:55:00',2.82),('7643','2013-09-08','10:00:00',5.24),('7643','2013-09-08','10:05:00',6.48),('7643','2013-09-08','10:10:00',6.56),('7643','2013-09-08','10:15:00',6.3),('7643','2013-09-08','10:20:00',4.87),('7643','2013-09-08','10:25:00',4.57),('7643','2013-09-08','10:30:00',5.83),('7643','2013-09-08','10:35:00',6.35),('7643','2013-09-08','10:40:00',6.4),('7643','2013-09-08','10:45:00',7.04),('7643','2013-09-08','10:50:00',9.04),('7643','2013-09-08','10:55:00',8.97),('7643','2013-09-08','11:00:00',9.76),('7643','2013-09-08','11:05:00',7.76),('7643','2013-09-08','11:10:00',7.02),('7643','2013-09-08','11:15:00',7.06),('7643','2013-09-08','11:20:00',8.39),('7643','2013-09-08','11:25:00',10.02),('7643','2013-09-08','11:30:00',7.96),('7643','2013-09-08','11:35:00',6.9),('7643','2013-09-08','11:40:00',11.57),('7643','2013-09-08','11:45:00',12.88),('7643','2013-09-08','11:50:00',11.87),('7643','2013-09-08','11:55:00',11.01),('7643','2013-09-08','12:00:00',12),('7643','2013-09-08','12:05:00',11.58),('7643','2013-09-08','12:10:00',8.42),('7643','2013-09-08','12:15:00',6.61),('7643','2013-09-08','12:20:00',7.17),('7643','2013-09-08','12:25:00',4.98),('7643','2013-09-08','12:30:00',4.56),('7643','2013-09-08','12:35:00',4.17),('7643','2013-09-08','12:40:00',5.14),('7643','2013-09-08','12:45:00',6.67),('7643','2013-09-08','12:50:00',4.77),('7643','2013-09-08','12:55:00',6.27),('7643','2013-09-08','13:00:00',6.18),('7643','2013-09-08','13:05:00',8.78),('7643','2013-09-08','13:10:00',11.82),('7643','2013-09-08','13:15:00',9.71),('7643','2013-09-08','13:20:00',6.91),('7643','2013-09-08','13:25:00',9.59),('7643','2013-09-08','13:30:00',8.59),('7643','2013-09-08','13:35:00',14.64),('7643','2013-09-08','13:40:00',14.13),('7643','2013-09-08','13:45:00',14.32),('7643','2013-09-08','13:50:00',12.8),('7643','2013-09-08','13:55:00',8.93),('7643','2013-09-08','14:00:00',13.55),('7643','2013-09-08','14:05:00',11.72),('7643','2013-09-08','14:10:00',10.34),('7643','2013-09-08','14:15:00',8.83),('7643','2013-09-08','14:20:00',8.07),('7643','2013-09-08','14:25:00',6.33),('7643','2013-09-08','14:30:00',7.66),('7643','2013-09-08','14:35:00',13.81),('7643','2013-09-08','14:40:00',10.11),('7643','2013-09-08','14:45:00',7.43),('7643','2013-09-08','14:50:00',11.86),('7643','2013-09-08','14:55:00',11.66),('7643','2013-09-08','15:00:00',8.79),('7643','2013-09-08','15:05:00',8.88),('7643','2013-09-08','15:10:00',10.85),('7643','2013-09-08','15:15:00',5.74),('7643','2013-09-08','15:20:00',6.84),('7643','2013-09-08','15:25:00',4.44),('7643','2013-09-08','15:30:00',9.61),('7643','2013-09-08','15:35:00',8.51),('7643','2013-09-08','15:40:00',7.97),('7643','2013-09-08','15:45:00',4.03),('7643','2013-09-08','15:50:00',4.01),('7643','2013-09-08','15:55:00',4.92),('7643','2013-09-08','16:00:00',5.86),('7643','2013-09-08','16:05:00',4.64),('7643','2013-09-08','16:10:00',5.85),('7643','2013-09-08','16:15:00',8.04),('7643','2013-09-08','16:20:00',6.55),('7643','2013-09-08','16:25:00',3.68),('7643','2013-09-08','16:30:00',3.68),('7643','2013-09-08','16:35:00',4.13),('7643','2013-09-08','16:40:00',4.51),('7643','2013-09-08','16:45:00',7.57),('7643','2013-09-08','16:50:00',3.18),('7643','2013-09-08','16:55:00',2.43),('7643','2013-09-08','17:00:00',3.41),('7643','2013-09-08','17:05:00',2.94),('7643','2013-09-08','17:10:00',2.9),('7643','2013-09-08','17:15:00',2.05),('7643','2013-09-08','17:20:00',1.8),('7643','2013-09-08','17:25:00',1.29),('7643','2013-09-08','17:30:00',1.47),('7643','2013-09-08','17:35:00',2.16),('7643','2013-09-08','17:40:00',2.22),('7643','2013-09-08','17:45:00',1.28),('7643','2013-09-08','18:00:00',1.26),('7643','2013-09-08','18:05:00',1.68),('7643','2013-09-08','18:10:00',2.28),('7643','2013-09-08','18:15:00',3.21),('7643','2013-09-08','18:20:00',2.67),('7643','2013-09-08','18:25:00',2.12),('7643','2013-09-08','18:30:00',1.77),('7643','2014-04-11','07:05:00',1.12),('7643','2014-04-11','07:10:00',1.29),('7643','2014-04-11','07:15:00',1.3),('7643','2014-04-11','07:20:00',1.41),('7643','2014-04-11','07:25:00',1.49),('7643','2014-04-11','07:30:00',1.31),('7643','2014-04-11','07:35:00',1.15),('7643','2014-04-11','07:40:00',1.25),('7643','2014-04-11','07:45:00',1.26),('7643','2014-04-11','07:50:00',1.01),('7643','2014-04-11','07:55:00',1.02),('7643','2014-04-11','08:00:00',1.38),('7643','2014-04-11','08:05:00',1.81),('7643','2014-04-11','08:10:00',2.52),('7643','2014-04-11','08:15:00',2.7),('7643','2014-04-11','08:20:00',3.12),('7643','2014-04-11','08:25:00',3.89),('7643','2014-04-11','08:30:00',2.4),('7643','2014-04-11','08:35:00',2.17),('7643','2014-04-11','08:40:00',2.3),('7643','2014-04-11','08:45:00',2.27),('7643','2014-04-11','08:50:00',2.44),('7643','2014-04-11','08:55:00',2.52),('7643','2014-04-11','09:00:00',2.58),('7643','2014-04-11','09:05:00',3.15),('7643','2014-04-11','09:10:00',3.92),('7643','2014-04-11','09:15:00',5.07),('7643','2014-04-11','09:20:00',7.42),('7643','2014-04-11','09:25:00',9.6),('7643','2014-04-11','09:30:00',6.43),('7643','2014-04-11','09:35:00',5.37),('7643','2014-04-11','09:40:00',4.38),('7643','2014-04-11','09:45:00',4.12),('7643','2014-04-11','09:50:00',4.1),('7643','2014-04-11','09:55:00',4.06),('7643','2014-04-11','10:00:00',4.08),('7643','2014-04-11','10:05:00',4.27),('7643','2014-04-11','10:10:00',4.71),('7643','2014-04-11','10:15:00',5.36),('7643','2014-04-11','10:20:00',5.94),('7643','2014-04-11','10:25:00',6.84),('7643','2014-04-11','10:30:00',7.61),('7643','2014-04-11','10:35:00',9.13),('7643','2014-04-11','10:40:00',9.03),('7643','2014-04-11','10:45:00',9.96),('7643','2014-04-11','10:50:00',8.64),('7643','2014-04-11','10:55:00',10.46),('7643','2014-04-11','11:00:00',11.03),('7643','2014-04-11','11:05:00',11.62),('7643','2014-04-11','11:10:00',12.42),('7643','2014-04-11','11:15:00',16.28),('7643','2014-04-11','11:20:00',15.85),('7643','2014-04-11','11:25:00',14.47),('7643','2014-04-11','11:30:00',13.95),('7643','2014-04-11','11:35:00',14.05),('7643','2014-04-11','11:40:00',14.76),('7643','2014-04-11','11:45:00',15.1),('7643','2014-04-11','11:50:00',11.05),('7643','2014-04-11','11:55:00',7.79),('7643','2014-04-11','12:00:00',7.36),('7643','2014-04-11','12:05:00',7.43),('7643','2014-04-11','12:10:00',6.07),('7643','2014-04-11','12:15:00',5.86),('7643','2014-04-11','12:20:00',6.16),('7643','2014-04-11','12:25:00',7.16),('7643','2014-04-11','12:30:00',7.92),('7643','2014-04-11','12:35:00',9.89),('7643','2014-04-11','12:40:00',11.39),('7643','2014-04-11','12:45:00',12.38),('7643','2014-04-11','12:50:00',11.07),('7643','2014-04-11','12:55:00',6.79),('7643','2014-04-11','13:00:00',5.23),('7643','2014-04-11','13:05:00',6.31),('7643','2014-04-11','13:10:00',11.18),('7643','2014-04-11','13:15:00',13.57),('7643','2014-04-11','13:20:00',16.97),('7643','2014-04-11','13:25:00',12.6),('7643','2014-04-11','13:30:00',8.78),('7643','2014-04-11','13:35:00',6.8),('7643','2014-04-11','13:40:00',7.76),('7643','2014-04-11','13:45:00',6.65),('7643','2014-04-11','13:50:00',7.36),('7643','2014-04-11','13:55:00',5.71),('7643','2014-04-11','14:00:00',5.66),('7643','2014-04-11','14:05:00',14.82),('7643','2014-04-11','14:10:00',15.64),('7643','2014-04-11','14:15:00',7.26),('7643','2014-04-11','14:20:00',10.51),('7643','2014-04-11','14:25:00',16.35),('7643','2014-04-11','14:30:00',13.22),('7643','2014-04-11','14:35:00',9.4),('7643','2014-04-11','14:40:00',9.29),('7643','2014-04-11','14:45:00',12.19),('7643','2014-04-11','14:50:00',14.88),('7643','2014-04-11','14:55:00',15.43),('7643','2014-04-11','15:00:00',13.21),('7643','2014-04-11','15:05:00',14.1),('7643','2014-04-11','15:10:00',14.09),('7643','2014-04-11','15:15:00',14.19),('7643','2014-04-11','15:20:00',11.79),('7643','2014-04-11','15:25:00',10.89),('7643','2014-04-11','15:30:00',8.05),('7643','2014-04-11','15:35:00',9.3),('7643','2014-04-11','15:40:00',11.21),('7643','2014-04-11','15:45:00',11.96),('7643','2014-04-11','15:50:00',13.65),('7643','2014-04-11','15:55:00',13.17),('7643','2014-04-11','16:00:00',13.2),('7643','2014-04-11','16:05:00',12.98),('7643','2014-04-11','16:10:00',12.49),('7643','2014-04-11','16:15:00',12.18),('7643','2014-04-11','16:20:00',12.84),('7643','2014-04-11','16:25:00',11.6),('7643','2014-04-11','16:30:00',11.15),('7643','2014-04-11','16:35:00',10.55),('7643','2014-04-11','16:40:00',6.79),('7643','2014-04-11','16:45:00',6.7),('7643','2014-04-11','16:50:00',5.66),('7643','2014-04-11','16:55:00',7.77),('7643','2014-04-11','17:00:00',9.22),('7643','2014-04-11','17:05:00',8.44),('7643','2014-04-11','17:10:00',8.26),('7643','2014-04-11','17:15:00',7.84),('7643','2014-04-11','17:20:00',6.44),('7643','2014-04-11','17:25:00',6.6),('7643','2014-04-11','17:30:00',5.71),('7643','2014-04-11','17:35:00',4.16),('7643','2014-04-11','17:40:00',4.59),('7643','2014-04-11','17:45:00',6.46),('7643','2014-04-11','17:50:00',6.13),('7643','2014-04-11','17:55:00',4.63),('7643','2014-04-11','18:00:00',5.21),('7643','2014-04-11','18:05:00',3.7),('7643','2014-04-11','18:10:00',2.22),('7643','2014-04-11','18:15:00',1.82),('7643','2014-04-11','18:20:00',1.73),('7643','2014-04-11','18:25:00',1.39),('7643','2014-04-11','18:30:00',1.65),('7643','2014-04-11','18:35:00',1.05),('7643','2014-04-11','18:40:00',1.22),('7643','2014-04-11','18:45:00',1.51),('7643','2014-04-11','18:50:00',1.42),('7643','2014-04-11','18:55:00',1.13),('7643','2013-09-07','07:30:00',1.09),('7643','2013-09-07','07:35:00',1.35),('7643','2013-09-07','07:40:00',1.58),('7643','2013-09-07','07:45:00',1.79),('7643','2013-09-07','07:50:00',2),('7643','2013-09-07','07:55:00',2.47),('7643','2013-09-07','08:00:00',2.1),('7643','2013-09-07','08:05:00',1.36),('7643','2013-09-07','08:10:00',1.44),('7643','2013-09-07','08:15:00',1.52),('7643','2013-09-07','08:20:00',2.14),('7643','2013-09-07','08:25:00',2.83),('7643','2013-09-07','08:30:00',2.37),('7643','2013-09-07','08:35:00',2.46),('7643','2013-09-07','08:40:00',2.84),('7643','2013-09-07','08:45:00',3.14),('7643','2013-09-07','08:50:00',3.51),('7643','2013-09-07','08:55:00',3.28),('7643','2013-09-07','09:00:00',4.04),('7643','2013-09-07','09:05:00',3.9),('7643','2013-09-07','09:10:00',4.17),('7643','2013-09-07','09:15:00',4.09),('7643','2013-09-07','09:20:00',4.16),('7643','2013-09-07','09:25:00',6.76),('7643','2013-09-07','09:30:00',6.69),('7643','2013-09-07','09:35:00',7.72),('7643','2013-09-07','09:40:00',6.87),('7643','2013-09-07','09:45:00',8.14),('7643','2013-09-07','09:50:00',9.04),('7643','2013-09-07','09:55:00',9.2),('7643','2013-09-07','10:00:00',9.48),('7643','2013-09-07','10:05:00',9.57),('7643','2013-09-07','10:10:00',9.91),('7643','2013-09-07','10:15:00',9.81),('7643','2013-09-07','10:20:00',9.91),('7643','2013-09-07','10:25:00',10.42),('7643','2013-09-07','10:30:00',7.96),('7643','2013-09-07','10:35:00',10.62),('7643','2013-09-07','10:40:00',11.14),('7643','2013-09-07','10:45:00',11.26),('7643','2013-09-07','10:50:00',11.16),('7643','2013-09-07','10:55:00',11.43),('7643','2013-09-07','11:00:00',11.68),('7643','2013-09-07','11:05:00',11.62),('7643','2013-09-07','11:10:00',11.81),('7643','2013-09-07','11:15:00',11.78),('7643','2013-09-07','11:20:00',10.68),('7643','2013-09-07','11:25:00',11.53),('7643','2013-09-07','11:30:00',12.45),('7643','2013-09-07','11:35:00',12.46),('7643','2013-09-07','11:40:00',12.47),('7643','2013-09-07','11:45:00',12.39),('7643','2013-09-07','11:50:00',12.54),('7643','2013-09-07','11:55:00',12.36),('7643','2013-09-07','12:00:00',12.14),('7643','2013-09-07','12:05:00',12.33),('7643','2013-09-07','12:10:00',12.36),('7643','2013-09-07','12:15:00',12.52),('7643','2013-09-07','12:20:00',12.68),('7643','2013-09-07','12:25:00',13.01),('7643','2013-09-07','12:30:00',13.02),('7643','2013-09-07','12:35:00',13.17),('7643','2013-09-07','12:40:00',9.96),('7643','2013-09-07','12:45:00',12.6),('7643','2013-09-07','12:50:00',12.92),('7643','2013-09-07','12:55:00',13.09),('7643','2013-09-07','13:00:00',13.01),('7643','2013-09-07','13:05:00',13.15),('7643','2013-09-07','13:10:00',13.08),('7643','2013-09-07','13:15:00',12.83),('7643','2013-09-07','13:20:00',12.93),('7643','2013-09-07','13:25:00',12.41),('7643','2013-09-07','13:30:00',11.67),('7643','2013-09-07','13:35:00',9.81),('7643','2013-09-07','13:40:00',8.97),('7643','2013-09-07','13:45:00',7.46),('7643','2013-09-07','13:50:00',9.83),('7643','2013-09-07','13:55:00',10.46),('7643','2013-09-07','14:00:00',12.16),('7643','2013-09-07','14:05:00',12.15),('7643','2013-09-07','14:10:00',13.42),('7643','2013-09-07','14:15:00',11.89),('7643','2013-09-07','14:20:00',12.94),('7643','2013-09-07','14:25:00',14.38),('7643','2013-09-07','14:30:00',12.59),('7643','2013-09-07','14:35:00',13.27),('7643','2013-09-07','14:40:00',12.8),('7643','2013-09-07','14:45:00',12.65),('7643','2013-09-07','14:50:00',12.57),('7643','2013-09-07','14:55:00',12.37),('7643','2013-09-07','15:00:00',12.32),('7643','2013-09-07','15:05:00',10.41),('7643','2013-09-07','15:10:00',6.74),('7643','2013-09-07','15:15:00',8.73),('7643','2013-09-07','15:20:00',11.69),('7643','2013-09-07','15:25:00',11.63),('7643','2013-09-07','15:30:00',11.92),('7643','2013-09-07','15:35:00',11.42),('7643','2013-09-07','15:40:00',10.63),('7643','2013-09-07','15:45:00',10.63),('7643','2013-09-07','15:50:00',10.74),('7643','2013-09-07','15:55:00',8.55),('7643','2013-09-07','16:00:00',8.82),('7643','2013-09-07','16:05:00',8.94),('7643','2013-09-07','16:10:00',8.45),('7643','2013-09-07','16:15:00',8.8),('7643','2013-09-07','16:20:00',8.32),('7643','2013-09-07','16:25:00',8.09),('7643','2013-09-07','16:30:00',8.03),('7643','2013-09-07','16:35:00',7.72),('7643','2013-09-07','16:40:00',6.8),('7643','2013-09-07','16:45:00',4.47),('7643','2013-09-07','16:50:00',4.48),('7643','2013-09-07','16:55:00',4.15),('7643','2013-09-07','17:00:00',4.76),('7643','2013-09-07','17:05:00',6.99),('7643','2013-09-07','17:10:00',6.75),('7643','2013-09-07','17:15:00',6.09),('7643','2013-09-07','17:20:00',5.2),('7643','2013-09-07','17:25:00',5.15),('7643','2013-09-07','17:30:00',4.74),('7643','2013-09-07','17:35:00',2.74),('7643','2013-09-07','17:40:00',2.41),('7643','2013-09-07','17:45:00',3.51),('7643','2013-09-07','17:50:00',3.53),('7643','2013-09-07','17:55:00',3.27),('7643','2013-09-07','18:00:00',2.85),('7643','2013-09-07','18:05:00',2.39),('7643','2013-09-07','18:10:00',2.14),('7643','2013-09-07','18:15:00',1.82),('7643','2013-09-07','18:20:00',1.62),('7643','2013-09-07','18:25:00',1.46),('7643','2013-09-07','18:30:00',1.26),('7643','2013-09-07','18:35:00',1.01),('7643','2013-09-06','07:30:00',1.14),('7643','2013-09-06','07:35:00',1.38),('7643','2013-09-06','07:40:00',1.61),('7643','2013-09-06','07:45:00',1.91),('7643','2013-09-06','07:50:00',2.2),('7643','2013-09-06','07:55:00',2.51),('7643','2013-09-06','08:00:00',2.8),('7643','2013-09-06','08:05:00',3.13),('7643','2013-09-06','08:10:00',3.46),('7643','2013-09-06','08:15:00',3.77),('7643','2013-09-06','08:20:00',4.08),('7643','2013-09-06','08:25:00',4.41),('7643','2013-09-06','08:30:00',4.74),('7643','2013-09-06','08:35:00',5.06),('7643','2013-09-06','08:40:00',5.36),('7643','2013-09-06','08:45:00',5.63),('7643','2013-09-06','08:50:00',5.93),('7643','2013-09-06','08:55:00',6.31),('7643','2013-09-06','09:00:00',6.57),('7643','2013-09-06','09:05:00',6.86),('7643','2013-09-06','09:10:00',7.2),('7643','2013-09-06','09:15:00',7.55),('7643','2013-09-06','09:20:00',7.77),('7643','2013-09-06','09:25:00',8.06),('7643','2013-09-06','09:30:00',8.35),('7643','2013-09-06','09:35:00',8.59),('7643','2013-09-06','09:40:00',8.78),('7643','2013-09-06','09:45:00',9),('7643','2013-09-06','09:50:00',9.27),('7643','2013-09-06','09:55:00',9.55),('7643','2013-09-06','10:00:00',9.77),('7643','2013-09-06','10:05:00',9.94),('7643','2013-09-06','10:10:00',10.16),('7643','2013-09-06','10:15:00',10.21),('7643','2013-09-06','10:20:00',10.49),('7643','2013-09-06','10:25:00',10.63),('7643','2013-09-06','10:30:00',10.86),('7643','2013-09-06','10:35:00',11.14),('7643','2013-09-06','10:40:00',11.22),('7643','2013-09-06','10:45:00',11.29),('7643','2013-09-06','10:50:00',11.42),('7643','2013-09-06','10:55:00',11.64),('7643','2013-09-06','11:00:00',11.84),('7643','2013-09-06','11:05:00',11.99),('7643','2013-09-06','11:10:00',12.15),('7643','2013-09-06','11:15:00',12.32),('7643','2013-09-06','11:20:00',12.32),('7643','2013-09-06','11:25:00',12.49),('7643','2013-09-06','11:30:00',12.64),('7643','2013-09-06','11:35:00',12.87),('7643','2013-09-06','11:40:00',12.91),('7643','2013-09-06','11:45:00',13),('7643','2013-09-06','11:50:00',13.1),('7643','2013-09-06','11:55:00',13.19),('7643','2013-09-06','12:00:00',13.15),('7643','2013-09-06','12:05:00',13.34),('7643','2013-09-06','12:10:00',13.48),('7643','2013-09-06','12:15:00',13.58),('7643','2013-09-06','12:20:00',13.51),('7643','2013-09-06','12:25:00',13.47),('7643','2013-09-06','12:30:00',13.66),('7643','2013-09-06','12:35:00',13.7),('7643','2013-09-06','12:40:00',13.54),('7643','2013-09-06','12:45:00',13.41),('7643','2013-09-06','12:50:00',13.54),('7643','2013-09-06','12:55:00',13.69),('7643','2013-09-06','13:00:00',13.82),('7643','2013-09-06','13:05:00',13.61),('7643','2013-09-06','13:10:00',13.48),('7643','2013-09-06','13:15:00',12.53),('7643','2013-09-06','13:20:00',13.6),('7643','2013-09-06','13:25:00',13.47),('7643','2013-09-06','13:30:00',13.62),('7643','2013-09-06','13:35:00',13.97),('7643','2013-09-06','13:40:00',13.73),('7643','2013-09-06','13:45:00',9.52),('7643','2013-09-06','13:50:00',12.39),('7643','2013-09-06','13:55:00',13.11),('7643','2013-09-06','14:00:00',13.93),('7643','2013-09-06','14:05:00',13.67),('7643','2013-09-06','14:10:00',13.79),('7643','2013-09-06','14:15:00',13.62),('7643','2013-09-06','14:20:00',13.35),('7643','2013-09-06','14:25:00',12.96),('7643','2013-09-06','14:30:00',12.54),('7643','2013-09-06','14:35:00',12.86),('7643','2013-09-06','14:40:00',12.91),('7643','2013-09-06','14:45:00',12.86),('7643','2013-09-06','14:50:00',12.68),('7643','2013-09-06','14:55:00',12.43),('7643','2013-09-06','15:00:00',12.42),('7643','2013-09-06','15:05:00',12.22),('7643','2013-09-06','15:10:00',12.06),('7643','2013-09-06','15:15:00',11.99),('7643','2013-09-06','15:20:00',11.74),('7643','2013-09-06','15:25:00',11.64),('7643','2013-09-06','15:30:00',11.45),('7643','2013-09-06','15:35:00',11.21),('7643','2013-09-06','15:40:00',10.9),('7643','2013-09-06','15:45:00',10.71),('7643','2013-09-06','15:50:00',10.54),('7643','2013-09-06','15:55:00',10.24),('7643','2013-09-06','16:00:00',10.06),('7643','2013-09-06','16:05:00',9.79),('7643','2013-09-06','16:10:00',9.53),('7643','2013-09-06','16:15:00',9.19),('7643','2013-09-06','16:20:00',8.93),('7643','2013-09-06','16:25:00',8.61),('7643','2013-09-06','16:30:00',8.32),('7643','2013-09-06','16:35:00',8.12),('7643','2013-09-06','16:40:00',7.81),('7643','2013-09-06','16:45:00',7.58),('7643','2013-09-06','16:50:00',7.32),('7643','2013-09-06','16:55:00',7.01),('7643','2013-09-06','17:00:00',6.7),('7643','2013-09-06','17:05:00',6.38),('7643','2013-09-06','17:10:00',6.05),('7643','2013-09-06','17:15:00',5.78),('7643','2013-09-06','17:20:00',5.5),('7643','2013-09-06','17:25:00',5.15),('7643','2013-09-06','17:30:00',4.8),('7643','2013-09-06','17:35:00',4.51),('7643','2013-09-06','17:40:00',4.23),('7643','2013-09-06','17:45:00',3.93),('7643','2013-09-06','17:50:00',3.6),('7643','2013-09-06','17:55:00',3.28),('7643','2013-09-06','18:00:00',2.97),('7643','2013-09-06','18:05:00',2.63),('7643','2013-09-06','18:10:00',2.31),('7643','2013-09-06','18:15:00',2.05),('7643','2013-09-06','18:20:00',1.79),('7643','2013-09-06','18:25:00',1.54),('7643','2013-09-06','18:30:00',1.33),('7643','2013-09-06','18:35:00',1.13),('7643','2013-09-05','07:25:00',1.06),('7643','2013-09-05','07:30:00',1.27),('7643','2013-09-05','07:35:00',1.47),('7643','2013-09-05','07:40:00',1.72),('7643','2013-09-05','07:45:00',2),('7643','2013-09-05','07:50:00',2.27),('7643','2013-09-05','07:55:00',2.56),('7643','2013-09-05','08:00:00',2.87),('7643','2013-09-05','08:05:00',3.24),('7643','2013-09-05','08:10:00',3.57),('7643','2013-09-05','08:15:00',3.88),('7643','2013-09-05','08:20:00',4.24),('7643','2013-09-05','08:25:00',4.55),('7643','2013-09-05','08:30:00',4.87),('7643','2013-09-05','08:35:00',5.18),('7643','2013-09-05','08:40:00',5.51),('7643','2013-09-05','08:45:00',5.86),('7643','2013-09-05','08:50:00',6.15),('7643','2013-09-05','08:55:00',6.48),('7643','2013-09-05','09:00:00',6.77),('7643','2013-09-05','09:05:00',7.11),('7643','2013-09-05','09:10:00',7.37),('7643','2013-09-05','09:15:00',7.64),('7643','2013-09-05','09:20:00',7.9),('7643','2013-09-05','09:25:00',8.14),('7643','2013-09-05','09:30:00',8.41),('7643','2013-09-05','09:35:00',8.7),('7643','2013-09-05','09:40:00',8.97),('7643','2013-09-05','09:45:00',9.22),('7643','2013-09-05','09:50:00',9.34),('7643','2013-09-05','09:55:00',9.54),('7643','2013-09-05','10:00:00',9.8),('7643','2013-09-05','10:05:00',10.09),('7643','2013-09-05','10:10:00',10.27),('7643','2013-09-05','10:15:00',10.46),('7643','2013-09-05','10:20:00',10.62),('7643','2013-09-05','10:25:00',10.83),('7643','2013-09-05','10:30:00',11.16),('7643','2013-09-05','10:35:00',11.42),('7643','2013-09-05','10:40:00',11.62),('7643','2013-09-05','10:45:00',11.77),('7643','2013-09-05','10:50:00',11.91),('7643','2013-09-05','10:55:00',12.03),('7643','2013-09-05','11:00:00',12.24),('7643','2013-09-05','11:05:00',12.41),('7643','2013-09-05','11:10:00',12.5),('7643','2013-09-05','11:15:00',12.53),('7643','2013-09-05','11:20:00',12.67),('7643','2013-09-05','11:25:00',12.86),('7643','2013-09-05','11:30:00',12.89),('7643','2013-09-05','11:35:00',12.92),('7643','2013-09-05','11:40:00',13),('7643','2013-09-05','11:45:00',13.12),('7643','2013-09-05','11:50:00',13.14),('7643','2013-09-05','11:55:00',13.22),('7643','2013-09-05','12:00:00',13.34),('7643','2013-09-05','12:05:00',13.51),('7643','2013-09-05','12:10:00',13.57),('7643','2013-09-05','12:15:00',13.49),('7643','2013-09-05','12:20:00',13.84),('7643','2013-09-05','12:25:00',13.97),('7643','2013-09-05','12:30:00',14.08),('7643','2013-09-05','12:35:00',14.08),('7643','2013-09-05','12:40:00',13.86),('7643','2013-09-05','12:45:00',13.77),('7643','2013-09-05','12:50:00',13.78),('7643','2013-09-05','12:55:00',13.79),('7643','2013-09-05','13:00:00',13.87),('7643','2013-09-05','13:05:00',13.91),('7643','2013-09-05','13:10:00',13.88),('7643','2013-09-05','13:15:00',13.79),('7643','2013-09-05','13:20:00',13.81),('7643','2013-09-05','13:25:00',13.82),('7643','2013-09-05','13:30:00',13.68),('7643','2013-09-05','13:35:00',13.62),('7643','2013-09-05','13:40:00',13.59),('7643','2013-09-05','13:45:00',13.52),('7643','2013-09-05','13:50:00',13.53),('7643','2013-09-05','13:55:00',13.4),('7643','2013-09-05','14:00:00',13.23),('7643','2013-09-05','14:05:00',13.03),('7643','2013-09-05','14:10:00',13.12),('7643','2013-09-05','14:15:00',13.09),('7643','2013-09-05','14:20:00',13.02),('7643','2013-09-05','14:25:00',12.73),('7643','2013-09-05','14:30:00',12.64),('7643','2013-09-05','14:35:00',12.28),('7643','2013-09-05','14:40:00',12.02),('7643','2013-09-05','14:45:00',12.44),('7643','2013-09-05','14:50:00',12.93),('7643','2013-09-05','14:55:00',12.62),('7643','2013-09-05','15:00:00',12.27),('7643','2013-09-05','15:05:00',12.08),('7643','2013-09-05','15:10:00',11.9),('7643','2013-09-05','15:15:00',11.7),('7643','2013-09-05','15:20:00',11.58),('7643','2013-09-05','15:25:00',11.29),('7643','2013-09-05','15:30:00',11.04),('7643','2013-09-05','15:35:00',10.85),('7643','2013-09-05','15:40:00',10.82),('7643','2013-09-05','15:45:00',10.61),('7643','2013-09-05','15:50:00',10.44),('7643','2013-09-05','15:55:00',10.19),('7643','2013-09-05','16:00:00',9.99),('7643','2013-09-05','16:05:00',9.68),('7643','2013-09-05','16:10:00',9.44),('7643','2013-09-05','16:15:00',9.2),('7643','2013-09-05','16:20:00',8.98),('7643','2013-09-05','16:25:00',8.82),('7643','2013-09-05','16:30:00',8.62),('7643','2013-09-05','16:35:00',8.38),('7643','2013-09-05','16:40:00',8.07),('7643','2013-09-05','16:45:00',7.72),('7643','2013-09-05','16:50:00',7.35),('7643','2013-09-05','16:55:00',7.04),('7643','2013-09-05','17:00:00',6.84),('7643','2013-09-05','17:05:00',6.44),('7643','2013-09-05','17:10:00',6.22),('7643','2013-09-05','17:15:00',5.91),('7643','2013-09-05','17:20:00',5.55),('7643','2013-09-05','17:25:00',5.2),('7643','2013-09-05','17:30:00',4.85),('7643','2013-09-05','17:35:00',4.57),('7643','2013-09-05','17:40:00',4.26),('7643','2013-09-05','17:45:00',3.91),('7643','2013-09-05','17:50:00',3.5),('7643','2013-09-05','17:55:00',3.28),('7643','2013-09-05','18:00:00',3.04),('7643','2013-09-05','18:05:00',2.74),('7643','2013-09-05','18:10:00',2.44),('7643','2013-09-05','18:15:00',2.13),('7643','2013-09-05','18:20:00',1.82),('7643','2013-09-05','18:25:00',1.56),('7643','2013-09-05','18:30:00',1.34),('7643','2013-09-05','18:35:00',1.14),('7643','2013-09-04','07:25:00',1.1),('7643','2013-09-04','07:30:00',1.36),('7643','2013-09-04','07:35:00',1.63),('7643','2013-09-04','07:40:00',1.93),('7643','2013-09-04','07:45:00',2.25),('7643','2013-09-04','07:50:00',2.55),('7643','2013-09-04','07:55:00',2.88),('7643','2013-09-04','08:00:00',3.21),('7643','2013-09-04','08:05:00',3.58),('7643','2013-09-04','08:10:00',3.94),('7643','2013-09-04','08:15:00',4.3),('7643','2013-09-04','08:20:00',4.66),('7643','2013-09-04','08:25:00',5),('7643','2013-09-04','08:30:00',5.33),('7643','2013-09-04','08:35:00',5.67),('7643','2013-09-04','08:40:00',6.02),('7643','2013-09-04','08:45:00',6.35),('7643','2013-09-04','08:50:00',6.65),('7643','2013-09-04','08:55:00',6.93),('7643','2013-09-04','09:00:00',7.21),('7643','2013-09-04','09:05:00',7.59),('7643','2013-09-04','09:10:00',7.9),('7643','2013-09-04','09:15:00',8.18),('7643','2013-09-04','09:20:00',8.48),('7643','2013-09-04','09:25:00',8.76),('7643','2013-09-04','09:30:00',8.97),('7643','2013-09-04','09:35:00',9.18),('7643','2013-09-04','09:40:00',9.48),('7643','2013-09-04','09:45:00',9.73),('7643','2013-09-04','09:50:00',10),('7643','2013-09-04','09:55:00',10.27),('7643','2013-09-04','10:00:00',10.47),('7643','2013-09-04','10:05:00',10.64),('7643','2013-09-04','10:10:00',10.87),('7643','2013-09-04','10:15:00',11.07),('7643','2013-09-04','10:20:00',11.3),('7643','2013-09-04','10:25:00',11.45),('7643','2013-09-04','10:30:00',11.64),('7643','2013-09-04','10:35:00',11.77),('7643','2013-09-04','10:40:00',11.93),('7643','2013-09-04','10:45:00',12.1),('7643','2013-09-04','10:50:00',12.21),('7643','2013-09-04','10:55:00',12.42),('7643','2013-09-04','11:00:00',12.54),('7643','2013-09-04','11:05:00',12.67),('7643','2013-09-04','11:10:00',12.77),('7643','2013-09-04','11:15:00',12.96),('7643','2013-09-04','11:20:00',13.05),('7643','2013-09-04','11:25:00',13.18),('7643','2013-09-04','11:30:00',13.23),('7643','2013-09-04','11:35:00',13.33),('7643','2013-09-04','11:40:00',13.22),('7643','2013-09-04','11:45:00',13.12),('7643','2013-09-04','11:50:00',13.55),('7643','2013-09-04','11:55:00',13.63),('7643','2013-09-04','12:00:00',13.76),('7643','2013-09-04','12:05:00',13.87),('7643','2013-09-04','12:10:00',13.91),('7643','2013-09-04','12:15:00',14),('7643','2013-09-04','12:20:00',14.11),('7643','2013-09-04','12:25:00',14.11),('7643','2013-09-04','12:30:00',14.11),('7643','2013-09-04','12:35:00',14.19),('7643','2013-09-04','12:40:00',14.22),('7643','2013-09-04','12:45:00',14.22),('7643','2013-09-04','12:50:00',14.18),('7643','2013-09-04','12:55:00',14.18),('7643','2013-09-04','13:00:00',14.18),('7643','2013-09-04','13:05:00',14.2),('7643','2013-09-04','13:10:00',14.2),('7643','2013-09-04','16:30:00',6.88),('7643','2013-09-04','16:35:00',8.91),('7643','2013-09-04','16:40:00',8.8),('7643','2013-09-04','16:45:00',8.61),('7643','2013-09-04','16:50:00',7.14),('7643','2013-09-04','16:55:00',5.74),('7643','2013-09-04','17:00:00',4.58),('7643','2013-09-04','17:05:00',5.07),('7643','2013-09-04','17:10:00',4.93),('7643','2013-09-04','17:15:00',4.49),('7643','2013-09-04','17:20:00',5.04),('7643','2013-09-04','17:25:00',4.99),('7643','2013-09-04','17:30:00',5.08),('7643','2013-09-04','17:35:00',5.11),('7643','2013-09-04','17:40:00',5.43),('7643','2013-09-04','17:45:00',4.75),('7643','2013-09-04','17:50:00',4.15),('7643','2013-09-04','17:55:00',3.6),('7643','2013-09-04','18:00:00',2.74),('7643','2013-09-04','18:05:00',2.42),('7643','2013-09-04','18:10:00',2.22),('7643','2013-09-04','18:15:00',2.08),('7643','2013-09-04','18:20:00',2.42),('7643','2013-09-04','18:25:00',1.93),('7643','2013-09-04','18:30:00',1.45),('7643','2013-09-04','18:35:00',1.35),('7643','2013-09-04','18:40:00',1.17),('7643','2013-09-03','07:25:00',1.1),('7643','2013-09-03','07:30:00',1.37),('7643','2013-09-03','07:35:00',1.64),('7643','2013-09-03','07:40:00',1.94),('7643','2013-09-03','07:45:00',2.26),('7643','2013-09-03','07:50:00',2.58),('7643','2013-09-03','07:55:00',2.92),('7643','2013-09-03','08:00:00',3.25),('7643','2013-09-03','08:05:00',3.62),('7643','2013-09-03','08:10:00',3.97),('7643','2013-09-03','08:15:00',4.33),('7643','2013-09-03','08:20:00',4.67),('7643','2013-09-03','08:25:00',5.01),('7643','2013-09-03','08:30:00',5.34),('7643','2013-09-03','08:35:00',5.67),('7643','2013-09-03','08:40:00',6.01),('7643','2013-09-03','08:45:00',6.35),('7643','2013-09-03','08:50:00',6.69),('7643','2013-09-03','08:55:00',7.01),('7643','2013-09-03','09:00:00',7.31),('7643','2013-09-03','09:05:00',7.67),('7643','2013-09-03','09:10:00',8),('7643','2013-09-03','09:15:00',8.35),('7643','2013-09-03','09:20:00',8.68),('7643','2013-09-03','09:25:00',8.98),('7643','2013-09-03','09:30:00',9.26),('7643','2013-09-03','09:35:00',9.55),('7643','2013-09-03','09:40:00',9.84),('7643','2013-09-03','09:45:00',10.11),('7643','2013-09-03','09:50:00',10.35),('7643','2013-09-03','09:55:00',10.61),('7643','2013-09-03','10:00:00',10.84),('7643','2013-09-03','10:05:00',11.11),('7643','2013-09-03','10:10:00',11.35),('7643','2013-09-03','10:15:00',11.48),('7643','2013-09-03','10:20:00',11.72),('7643','2013-09-03','10:25:00',11.93),('7643','2013-09-03','10:30:00',12.14),('7643','2013-09-03','10:35:00',12.33),('7643','2013-09-03','10:40:00',12.48),('7643','2013-09-03','10:45:00',12.57),('7643','2013-09-03','10:50:00',12.7),('7643','2013-09-03','10:55:00',12.93),('7643','2013-09-03','11:00:00',13.12),('7643','2013-09-03','11:05:00',13.25),('7643','2013-09-03','11:10:00',13.41),('7643','2013-09-03','11:15:00',13.58),('7643','2013-09-03','11:20:00',13.74),('7643','2013-09-03','11:25:00',13.81),('7643','2013-09-03','11:30:00',13.94),('7643','2013-09-03','11:35:00',14.07),('7643','2013-09-03','11:40:00',14.17),('7643','2013-09-03','11:45:00',14.23),('7643','2013-09-03','11:50:00',14.41),('7643','2013-09-03','11:55:00',14.59),('7643','2013-09-03','12:00:00',14.63),('7643','2013-09-03','12:05:00',14.62),('7643','2013-09-03','12:10:00',14.68),('7643','2013-09-03','12:15:00',14.72),('7643','2013-09-03','12:20:00',14.85),('7643','2013-09-03','12:25:00',14.84),('7643','2013-09-03','12:30:00',14.93),('7643','2013-09-03','12:35:00',15.08),('7643','2013-09-03','12:40:00',15.12),('7643','2013-09-03','12:45:00',15.1),('7643','2013-09-03','12:50:00',14.95),('7643','2013-09-03','12:55:00',14.96),('7643','2013-09-03','13:00:00',14.97),('7643','2013-09-03','13:05:00',15.01),('7643','2013-09-03','13:10:00',14.94),('7643','2013-09-03','13:15:00',14.87),('7643','2013-09-03','13:20:00',14.84),('7643','2013-09-03','13:25:00',14.8),('7643','2013-09-03','13:30:00',14.77),('7643','2013-09-03','13:35:00',14.81),('7643','2013-09-03','13:40:00',14.78),('7643','2013-09-03','13:45:00',14.73),('7643','2013-09-03','13:50:00',14.71),('7643','2013-09-03','13:55:00',14.6),('7643','2013-09-03','14:00:00',14.56),('7643','2013-09-03','14:05:00',14.44),('7643','2013-09-03','14:10:00',14.37),('7643','2013-09-03','14:15:00',14.29),('7643','2013-09-03','14:20:00',14.13),('7643','2013-09-03','14:25:00',14.08),('7643','2013-09-03','14:30:00',13.98),('7643','2013-09-03','14:35:00',13.86),('7643','2013-09-03','14:40:00',13.74),('7643','2013-09-03','14:45:00',13.61),('7643','2013-09-03','14:50:00',13.49),('7643','2013-09-03','14:55:00',13.28),('7643','2013-09-03','15:00:00',13.08),('7643','2013-09-03','15:05:00',12.93),('7643','2013-09-03','15:10:00',12.78),('7643','2013-09-03','15:15:00',12.61),('7643','2013-09-03','15:20:00',12.45),('7643','2013-09-03','15:25:00',12.22),('7643','2013-09-03','15:30:00',12.07),('7643','2013-09-03','15:35:00',11.83),('7643','2013-09-03','15:40:00',11.68),('7643','2013-09-03','15:45:00',11.49),('7643','2013-09-03','15:50:00',11.24),('7643','2013-09-03','15:55:00',11.04),('7643','2013-09-03','16:00:00',10.76),('7643','2013-09-03','16:05:00',10.46),('7643','2013-09-03','16:10:00',10.21),('7643','2013-09-03','16:15:00',9.98),('7643','2013-09-03','16:20:00',9.73),('7643','2013-09-03','16:25:00',9.43),('7643','2013-09-03','16:30:00',9.2),('7643','2013-09-03','16:35:00',8.92),('7643','2013-09-03','16:40:00',8.62),('7643','2013-09-03','16:45:00',8.38),('7643','2013-09-03','16:50:00',8.09),('7643','2013-09-03','16:55:00',7.76),('7643','2013-09-03','17:00:00',7.47),('7643','2013-09-03','17:05:00',7.17),('7643','2013-09-03','17:10:00',6.84),('7643','2013-09-03','17:15:00',6.52),('7643','2013-09-03','17:20:00',6.18),('7643','2013-09-03','17:25:00',5.85),('7643','2013-09-03','17:30:00',5.51),('7643','2013-09-03','17:35:00',5.19),('7643','2013-09-03','17:40:00',4.83),('7643','2013-09-03','17:45:00',4.47),('7643','2013-09-03','17:50:00',4.1),('7643','2013-09-03','17:55:00',3.77),('7643','2013-09-03','18:00:00',3.38),('7643','2013-09-03','18:05:00',3.03),('7643','2013-09-03','18:10:00',2.66),('7643','2013-09-03','18:15:00',2.3),('7643','2013-09-03','18:20:00',1.96),('7643','2013-09-03','18:25:00',1.66),('7643','2013-09-03','18:30:00',1.41),('7643','2013-09-03','18:35:00',1.2),('7643','2013-09-02','07:25:00',1.05),('7643','2013-09-02','07:30:00',1.27),('7643','2013-09-02','07:35:00',1.5),('7643','2013-09-02','07:40:00',1.77),('7643','2013-09-02','07:45:00',2.05),('7643','2013-09-02','07:50:00',2.33),('7643','2013-09-02','07:55:00',2.63),('7643','2013-09-02','08:00:00',2.92),('7643','2013-09-02','08:05:00',3.25),('7643','2013-09-02','08:10:00',3.56),('7643','2013-09-02','08:15:00',3.86),('7643','2013-09-02','08:20:00',4.18),('7643','2013-09-02','08:25:00',4.49),('7643','2013-09-02','08:30:00',4.82),('7643','2013-09-02','08:35:00',5.15),('7643','2013-09-02','08:40:00',5.42),('7643','2013-09-02','08:45:00',5.74),('7643','2013-09-02','08:50:00',6.08),('7643','2013-09-02','08:55:00',6.43),('7643','2013-09-02','09:00:00',6.74),('7643','2013-09-02','09:05:00',7.1),('7643','2013-09-02','09:10:00',7.4),('7643','2013-09-02','09:15:00',7.69),('7643','2013-09-02','09:20:00',8.06),('7643','2013-09-02','09:25:00',8.35),('7643','2013-09-02','09:30:00',8.63),('7643','2013-09-02','09:35:00',8.93),('7643','2013-09-02','09:40:00',9.13),('7643','2013-09-02','09:45:00',9.38),('7643','2013-09-02','09:50:00',9.59),('7643','2013-09-02','09:55:00',9.78),('7643','2013-09-02','10:00:00',9.99),('7643','2013-09-02','10:05:00',10.17),('7643','2013-09-02','10:10:00',10.4),('7643','2013-09-02','10:15:00',10.65),('7643','2013-09-02','10:20:00',10.88),('7643','2013-09-02','10:25:00',11.15),('7643','2013-09-02','10:30:00',11.38),('7643','2013-09-02','10:35:00',11.65),('7643','2013-09-02','10:40:00',11.99),('7643','2013-09-02','10:45:00',12.29),('7643','2013-09-02','10:50:00',12.41),('7643','2013-09-02','10:55:00',12.42),('7643','2013-09-02','11:00:00',12.55),('7643','2013-09-02','11:05:00',12.68),('7643','2013-09-02','11:10:00',12.86),('7643','2013-09-02','11:15:00',13.04),('7643','2013-09-02','11:20:00',13.12),('7643','2013-09-02','11:25:00',13.24),('7643','2013-09-02','11:30:00',13.32),('7643','2013-09-02','11:35:00',13.39),('7643','2013-09-02','11:40:00',13.46),('7643','2013-09-02','11:45:00',13.64),('7643','2013-09-02','11:50:00',13.76),('7643','2013-09-02','11:55:00',13.98),('7643','2013-09-02','12:00:00',13.98),('7643','2013-09-02','12:05:00',14.07),('7643','2013-09-02','12:10:00',14.2),('7643','2013-09-02','12:15:00',14.3),('7643','2013-09-02','12:20:00',14.38),('7643','2013-09-02','12:25:00',14.53),('7643','2013-09-02','12:30:00',14.59),('7643','2013-09-02','12:35:00',14.5),('7643','2013-09-02','12:40:00',14.57),('7643','2013-09-02','12:45:00',14.61),('7643','2013-09-02','12:50:00',14.56),('7643','2013-09-02','12:55:00',14.56),('7643','2013-09-02','13:00:00',14.6),('7643','2013-09-02','13:05:00',14.7),('7643','2013-09-02','13:10:00',14.64),('7643','2013-09-02','13:15:00',14.59),('7643','2013-09-02','13:20:00',14.58),('7643','2013-09-02','13:25:00',14.47),('7643','2013-09-02','13:30:00',14.53),('7643','2013-09-02','13:35:00',14.46),('7643','2013-09-02','13:40:00',14.29),('7643','2013-09-02','13:45:00',14.37),('7643','2013-09-02','13:50:00',14.38),('7643','2013-09-02','13:55:00',14.23),('7643','2013-09-02','14:00:00',13.94),('7643','2013-09-02','14:05:00',13.83),('7643','2013-09-02','14:10:00',13.68),('7643','2013-09-02','14:15:00',13.68),('7643','2013-09-02','14:20:00',13.68),('7643','2013-09-02','14:25:00',13.54),('7643','2013-09-02','14:30:00',13.59),('7643','2013-09-02','14:35:00',13.51),('7643','2013-09-02','14:40:00',13.35),('7643','2013-09-02','14:45:00',13.37),('7643','2013-09-02','14:50:00',13.35),('7643','2013-09-02','14:55:00',13.13),('7643','2013-09-02','15:00:00',12.89),('7643','2013-09-02','15:05:00',12.54),('7643','2013-09-02','15:10:00',12.46),('7643','2013-09-02','15:15:00',12.4),('7643','2013-09-02','15:20:00',12.13),('7643','2013-09-02','15:25:00',11.92),('7643','2013-09-02','15:30:00',11.69),('7643','2013-09-02','15:35:00',11.45),('7643','2013-09-02','15:40:00',11.22),('7643','2013-09-02','15:45:00',11.04),('7643','2013-09-02','15:50:00',10.95),('7643','2013-09-02','15:55:00',10.72),('7643','2013-09-02','16:00:00',10.54),('7643','2013-09-02','16:05:00',10.29),('7643','2013-09-02','16:10:00',10.05),('7643','2013-09-02','16:15:00',9.78),('7643','2013-09-02','16:20:00',9.59),('7643','2013-09-02','16:25:00',9.34),('7643','2013-09-02','16:30:00',9.07),('7643','2013-09-02','16:35:00',8.8),('7643','2013-09-02','16:40:00',8.53),('7643','2013-09-02','16:45:00',8.24),('7643','2013-09-02','16:50:00',7.96),('7643','2013-09-02','16:55:00',7.77),('7643','2013-09-02','17:00:00',7.48),('7643','2013-09-02','17:05:00',7.12),('7643','2013-09-02','17:10:00',6.82),('7643','2013-09-02','17:15:00',6.5),('7643','2013-09-02','17:20:00',6.21),('7643','2013-09-02','17:25:00',5.88),('7643','2013-09-02','17:30:00',5.55),('7643','2013-09-02','17:35:00',5.23),('7643','2013-09-02','17:40:00',4.89),('7643','2013-09-02','17:45:00',4.55),('7643','2013-09-02','17:50:00',4.24),('7643','2013-09-02','17:55:00',3.92),('7643','2013-09-02','18:00:00',3.47),('7643','2013-09-02','18:05:00',2.91),('7643','2013-09-02','18:10:00',2.46),('7643','2013-09-02','18:15:00',2.21),('7643','2013-09-02','18:20:00',1.98),('7643','2013-09-02','18:25:00',1.74),('7643','2013-09-02','18:30:00',1.5),('7643','2013-09-02','18:35:00',1.27),('7643','2013-09-02','18:40:00',1.08),('7643','2013-09-01','07:25:00',1.14),('7643','2013-09-01','07:30:00',1.37),('7643','2013-09-01','07:35:00',1.61),('7643','2013-09-01','07:40:00',1.88),('7643','2013-09-01','07:45:00',2.17),('7643','2013-09-01','07:50:00',2.45),('7643','2013-09-01','07:55:00',2.73),('7643','2013-09-01','08:00:00',3.04),('7643','2013-09-01','08:05:00',3.39),('7643','2013-09-01','08:10:00',3.72),('7643','2013-09-01','08:15:00',4.04),('7643','2013-09-01','08:20:00',4.37),('7643','2013-09-01','08:25:00',4.67),('7643','2013-09-01','08:30:00',4.93),('7643','2013-09-01','08:35:00',5.3),('7643','2013-09-01','08:40:00',5.67),('7643','2013-09-01','08:45:00',6.01),('7643','2013-09-01','08:50:00',6.32),('7643','2013-09-01','08:55:00',6.62),('7643','2013-09-01','09:00:00',6.99),('7643','2013-09-01','09:05:00',7.36),('7643','2013-09-01','09:10:00',7.66),('7643','2013-09-01','09:15:00',7.93),('7643','2013-09-01','09:20:00',8.21),('7643','2013-09-01','09:25:00',8.52),('7643','2013-09-01','09:30:00',8.8),('7643','2013-09-01','09:35:00',9.1),('7643','2013-09-01','09:40:00',9.36),('7643','2013-09-01','09:45:00',9.63),('7643','2013-09-01','09:50:00',9.9),('7643','2013-09-01','09:55:00',10.09),('7643','2013-09-01','10:00:00',10.36),('7643','2013-09-01','10:05:00',10.61),('7643','2013-09-01','10:10:00',10.83),('7643','2013-09-01','10:15:00',11.07),('7643','2013-09-01','10:20:00',11.25),('7643','2013-09-01','10:25:00',11.44),('7643','2013-09-01','10:30:00',11.61),('7643','2013-09-01','10:35:00',11.76),('7643','2013-09-01','10:40:00',11.91),('7643','2013-09-01','10:45:00',12.08),('7643','2013-09-01','10:50:00',12.24),('7643','2013-09-01','10:55:00',12.37),('7643','2013-09-01','11:00:00',12.49),('7643','2013-09-01','11:05:00',12.69),('7643','2013-09-01','11:10:00',12.83),('7643','2013-09-01','11:15:00',12.97),('7643','2013-09-01','11:20:00',13.01),('7643','2013-09-01','11:25:00',13.17),('7643','2013-09-01','11:30:00',13.27),('7643','2013-09-01','11:35:00',13.35),('7643','2013-09-01','11:40:00',13.46),('7643','2013-09-01','11:45:00',13.62),('7643','2013-09-01','11:50:00',13.74),('7643','2013-09-01','11:55:00',13.88),('7643','2013-09-01','12:00:00',13.89),('7643','2013-09-01','12:05:00',13.97),('7643','2013-09-01','12:10:00',14.14),('7643','2013-09-01','12:15:00',14.26),('7643','2013-09-01','12:20:00',14.28),('7643','2013-09-01','12:25:00',14.27),('7643','2013-09-01','12:30:00',14.15),('7643','2013-09-01','12:35:00',14.18),('7643','2013-09-01','12:40:00',14.25),('7643','2013-09-01','12:45:00',14.24),('7643','2013-09-01','12:50:00',14.19),('7643','2013-09-01','12:55:00',14.3),('7643','2013-09-01','13:00:00',14.42),('7643','2013-09-01','13:05:00',14.37),('7643','2013-09-01','13:10:00',14.45),('7643','2013-09-01','13:15:00',14.59),('7643','2013-09-01','13:20:00',14.43),('7643','2013-09-01','13:25:00',14.32),('7643','2013-09-01','13:30:00',14.24),('7643','2013-09-01','13:35:00',14.1),('7643','2013-09-01','13:40:00',14.16),('7643','2013-09-01','13:45:00',9.36),('7643','2013-09-01','13:50:00',2.17),('7643','2013-09-01','13:55:00',4.64),('7643','2013-09-01','14:00:00',7.52),('7643','2013-09-01','14:05:00',15.04),('7643','2013-09-01','14:10:00',13.54),('7643','2013-09-01','14:15:00',14.24),('7643','2013-09-01','14:20:00',14.04),('7643','2013-09-01','14:25:00',13.9),('7643','2013-09-01','14:30:00',13.95),('7643','2013-09-01','14:35:00',13.32),('7643','2013-09-01','14:40:00',13.11),('7643','2013-09-01','14:45:00',13.73),('7643','2013-09-01','14:50:00',13.68),('7643','2013-09-01','14:55:00',10.37),('7643','2013-09-01','15:00:00',4.88),('7643','2013-09-01','15:05:00',11.85),('7643','2013-09-01','15:10:00',12.08),('7643','2013-09-01','15:15:00',12.7),('7643','2013-09-01','15:20:00',12.75),('7643','2013-09-01','15:25:00',11.51),('7643','2013-09-01','15:30:00',9.08),('7643','2013-09-01','15:35:00',10.47),('7643','2013-09-01','15:40:00',11.87),('7643','2013-09-01','15:45:00',11.61),('7643','2013-09-01','15:50:00',11.34),('7643','2013-09-01','15:55:00',11.12),('7643','2013-09-01','16:00:00',10.86),('7643','2013-09-01','16:05:00',10.42),('7643','2013-09-01','16:10:00',10.26),('7643','2013-09-01','16:15:00',10.27),('7643','2013-09-01','16:20:00',10.13),('7643','2013-09-01','16:25:00',9.68),('7643','2013-09-01','16:30:00',9.33),('7643','2013-09-01','16:35:00',8.9),('7643','2013-09-01','16:40:00',8.47),('7643','2013-09-01','16:45:00',8.13),('7643','2013-09-01','16:50:00',7.89),('7643','2013-09-01','16:55:00',7.44),('7643','2013-09-01','17:00:00',7),('7643','2013-09-01','17:05:00',6.88),('7643','2013-09-01','17:10:00',6.55),('7643','2013-09-01','17:15:00',6.31),('7643','2013-09-01','17:20:00',5.96),('7643','2013-09-01','17:25:00',5.71),('7643','2013-09-01','17:30:00',5.39),('7643','2013-09-01','17:35:00',5.05),('7643','2013-09-01','17:40:00',4.71),('7643','2013-09-01','17:45:00',4.43),('7643','2013-09-01','17:50:00',4.11),('7643','2013-09-01','17:55:00',3.82),('7643','2013-09-01','18:00:00',3.47),('7643','2013-09-01','18:05:00',3.12),('7643','2013-09-01','18:10:00',2.77),('7643','2013-09-01','18:15:00',2.44),('7643','2013-09-01','18:20:00',2.15),('7643','2013-09-01','18:25:00',1.85),('7643','2013-09-01','18:30:00',1.61),('7643','2013-09-01','18:35:00',1.36),('7643','2013-09-01','18:40:00',1.15),('7643','2013-08-31','07:20:00',1.02),('7643','2013-08-31','07:25:00',1.25),('7643','2013-08-31','07:30:00',1.49),('7643','2013-08-31','07:35:00',1.74),('7643','2013-08-31','07:40:00',2.02),('7643','2013-08-31','07:45:00',2.33),('7643','2013-08-31','07:50:00',2.64),('7643','2013-08-31','07:55:00',2.97),('7643','2013-08-31','08:00:00',3.3),('7643','2013-08-31','08:05:00',3.68),('7643','2013-08-31','08:10:00',4.02),('7643','2013-08-31','08:15:00',4.34),('7643','2013-08-31','08:20:00',4.66),('7643','2013-08-31','08:25:00',4.92),('7643','2013-08-31','08:30:00',4.88),('7643','2013-08-31','08:35:00',5.57),('7643','2013-08-31','08:40:00',5.97),('7643','2013-08-31','08:45:00',6.27),('7643','2013-08-31','08:50:00',6.57),('7643','2013-08-31','08:55:00',6.88),('7643','2013-08-31','09:00:00',7.15),('7643','2013-08-31','09:05:00',7.46),('7643','2013-08-31','09:10:00',7.83),('7643','2013-08-31','09:15:00',8.14),('7643','2013-08-31','09:20:00',8.4),('7643','2013-08-31','09:25:00',8.69),('7643','2013-08-31','09:30:00',9.01),('7643','2013-08-31','09:35:00',9.26),('7643','2013-08-31','09:40:00',9.54),('7643','2013-08-31','09:45:00',9.76),('7643','2013-08-31','09:50:00',10.01),('7643','2013-08-31','09:55:00',10.21),('7643','2013-08-31','10:00:00',10.42),('7643','2013-08-31','10:05:00',10.63),('7643','2013-08-31','10:10:00',10.86),('7643','2013-08-31','10:15:00',11.02),('7643','2013-08-31','10:20:00',11.2),('7643','2013-08-31','10:25:00',11.44),('7643','2013-08-31','10:30:00',11.6),('7643','2013-08-31','10:35:00',11.77),('7643','2013-08-31','10:40:00',11.98),('7643','2013-08-31','10:45:00',12.11),('7643','2013-08-31','10:50:00',12.25),('7643','2013-08-31','10:55:00',12.36),('7643','2013-08-31','11:00:00',12.56),('7643','2013-08-31','11:05:00',12.91),('7643','2013-08-31','11:10:00',12.98),('7643','2013-08-31','11:15:00',13.05),('7643','2013-08-31','11:20:00',12.98),('7643','2013-08-31','11:25:00',13.12),('7643','2013-08-31','11:30:00',13.18),('7643','2013-08-31','11:35:00',13.47),('7643','2013-08-31','11:40:00',13.75),('7643','2013-08-31','11:45:00',13.91),('7643','2013-08-31','11:50:00',13.96),('7643','2013-08-31','11:55:00',14.05),('7643','2013-08-31','12:00:00',14.04),('7643','2013-08-31','12:05:00',13.44),('7643','2013-08-31','12:10:00',14.07),('7643','2013-08-31','12:15:00',14.2),('7643','2013-08-31','12:20:00',14.3),('7643','2013-08-31','12:25:00',13.91),('7643','2013-08-31','12:30:00',14.24),('7643','2013-08-31','12:35:00',14.33),('7643','2013-08-31','12:40:00',14.5),('7643','2013-08-31','12:45:00',14.33),('7643','2013-08-31','12:50:00',14.47),('7643','2013-08-31','12:55:00',14.41),('7643','2013-08-31','13:00:00',14.66),('7643','2013-08-31','13:05:00',14.78),('7643','2013-08-31','13:10:00',14.75),('7643','2013-08-31','13:15:00',12.21),('7643','2013-08-31','13:20:00',14.9),('7643','2013-08-31','13:25:00',14.88),('7643','2013-08-31','13:30:00',14.76),('7643','2013-08-31','13:35:00',14.54),('7643','2013-08-31','13:40:00',14.48),('7643','2013-08-31','13:45:00',14.22),('7643','2013-08-31','13:50:00',12.68),('7643','2013-08-31','13:55:00',12.54),('7643','2013-08-31','14:00:00',11.57),('7643','2013-08-31','14:05:00',10.79),('7643','2013-08-31','14:10:00',12.97),('7643','2013-08-31','14:15:00',13.1),('7643','2013-08-31','14:20:00',12.45),('7643','2013-08-31','14:25:00',11.9),('7643','2013-08-31','14:30:00',12.33),('7643','2013-08-31','14:35:00',12.03),('7643','2013-08-31','14:40:00',12.09),('7643','2013-08-31','14:45:00',12.29),('7643','2013-08-31','14:50:00',12.42),('7643','2013-08-31','14:55:00',11.87),('7643','2013-08-31','15:00:00',11.85),('7643','2013-08-31','15:05:00',11.82),('7643','2013-08-31','15:10:00',11.35),('7643','2013-08-31','15:15:00',10.93),('7643','2013-08-31','15:20:00',10.53),('7643','2013-08-31','15:25:00',9.47),('7643','2013-08-31','15:30:00',7.47),('7643','2013-08-31','15:35:00',8.91),('7643','2013-08-31','15:40:00',10.37),('7643','2013-08-31','15:45:00',8.54),('7643','2013-08-31','15:50:00',6.51),('7643','2013-08-31','15:55:00',8.48),('7643','2013-08-31','16:00:00',9.59),('7643','2013-08-31','16:05:00',9.95),('7643','2013-08-31','16:10:00',10.49),('7643','2013-08-31','16:15:00',9.86),('7643','2013-08-31','16:20:00',9.2),('7643','2013-08-31','16:25:00',8.92),('7643','2013-08-31','16:30:00',9.95),('7643','2013-08-31','16:35:00',9.27),('7643','2013-08-31','16:40:00',9.04),('7643','2013-08-31','16:45:00',8.52),('7643','2013-08-31','16:50:00',7.87),('7643','2013-08-31','16:55:00',7.27),('7643','2013-08-31','17:00:00',6.04),('7643','2013-08-31','17:05:00',6.01),('7643','2013-08-31','17:10:00',5.4),('7643','2013-08-31','17:15:00',4.98),('7643','2013-08-31','17:20:00',5.42),('7643','2013-08-31','17:25:00',5.14),('7643','2013-08-31','17:30:00',4.76),('7643','2013-08-31','17:35:00',4.57),('7643','2013-08-31','17:40:00',4.67),('7643','2013-08-31','17:45:00',3.8),('7643','2013-08-31','17:50:00',3.59),('7643','2013-08-31','17:55:00',3.33),('7643','2013-08-31','18:00:00',3.34),('7643','2013-08-31','18:05:00',3.28),('7643','2013-08-31','18:10:00',3.31),('7643','2013-08-31','18:15:00',3.15),('7643','2013-08-31','18:20:00',2.71),('7643','2013-08-31','18:25:00',2.57),('7643','2013-08-31','18:30:00',2.39),('7643','2013-08-31','18:35:00',2.03),('7643','2013-08-31','18:40:00',2.04),('7643','2013-08-31','18:45:00',1.88),('7643','2013-08-31','18:50:00',1.67),('7643','2013-08-31','18:55:00',1.45),('7643','2013-08-31','19:00:00',1.23),('7643','2013-08-31','19:05:00',1.01),('7643','2013-08-30','07:10:00',1.02),('7643','2013-08-30','07:15:00',1.3),('7643','2013-08-30','07:20:00',1.59),('7643','2013-08-30','07:25:00',1.83),('7643','2013-08-30','07:30:00',1.74),('7643','2013-08-30','07:35:00',1.55),('7643','2013-08-30','07:40:00',1.56),('7643','2013-08-30','07:45:00',1.66),('7643','2013-08-30','07:50:00',2.2),('7643','2013-08-30','07:55:00',2.33),('7643','2013-08-30','08:00:00',2.2),('7643','2013-08-30','08:05:00',2.2),('7643','2013-08-30','08:10:00',1.83),('7643','2013-08-30','08:15:00',2.44),('7643','2013-08-30','08:20:00',3.72),('7643','2013-08-30','08:25:00',4.48),('7643','2013-08-30','08:30:00',5.37),('7643','2013-08-30','08:35:00',5.65),('7643','2013-08-30','08:40:00',6.09),('7643','2013-08-30','08:45:00',6.57),('7643','2013-08-30','08:50:00',7.16),('7643','2013-08-30','08:55:00',7.74),('7643','2013-08-30','09:00:00',8.17),('7643','2013-08-30','09:05:00',7.4),('7643','2013-08-30','09:10:00',6.19),('7643','2013-08-30','09:15:00',7.54),('7643','2013-08-30','09:20:00',8.32),('7643','2013-08-30','09:25:00',9.26),('7643','2013-08-30','09:30:00',9.42),('7643','2013-08-30','09:35:00',9.8),('7643','2013-08-30','09:40:00',10.07),('7643','2013-08-30','09:45:00',9.54),('7643','2013-08-30','09:50:00',9.58),('7643','2013-08-30','09:55:00',10.21),('7643','2013-08-30','10:00:00',10.93),('7643','2013-08-30','10:05:00',10.88),('7643','2013-08-30','10:10:00',11.39),('7643','2013-08-30','10:15:00',11.43),('7643','2013-08-30','10:20:00',11.64),('7643','2013-08-30','10:25:00',11.73),('7643','2013-08-30','10:30:00',12.04),('7643','2013-08-30','10:35:00',12.41),('7643','2013-08-30','10:40:00',12.42),('7643','2013-08-30','10:45:00',12.68),('7643','2013-08-30','10:50:00',13.02),('7643','2013-08-30','10:55:00',13.17),('7643','2013-08-30','11:00:00',13.41),('7643','2013-08-30','11:05:00',13.54),('7643','2013-08-30','11:10:00',13.66),('7643','2013-08-30','11:15:00',13.86),('7643','2013-08-30','11:20:00',13.94),('7643','2013-08-30','11:25:00',14.07),('7643','2013-08-30','11:30:00',14.22),('7643','2013-08-30','11:35:00',14.38),('7643','2013-08-30','11:40:00',14.53),('7643','2013-08-30','11:45:00',14.64),('7643','2013-08-30','11:50:00',14.84),('7643','2013-08-30','11:55:00',14.91),('7643','2013-08-30','12:00:00',12.45),('7643','2013-08-30','12:05:00',11.26),('7643','2013-08-30','12:10:00',12.71),('7643','2013-08-30','12:15:00',14.78),('7643','2013-08-30','12:20:00',14.83),('7643','2013-08-30','12:25:00',14.84),('7643','2013-08-30','12:30:00',14.78),('7643','2013-08-30','12:35:00',14.54),('7643','2013-08-30','12:40:00',14.89),('7643','2013-08-30','12:45:00',14.71),('7643','2013-08-30','12:50:00',14.78),('7643','2013-08-30','12:55:00',14.93),('7643','2013-08-30','13:00:00',14.87),('7643','2013-08-30','13:05:00',14.96),('7643','2013-08-30','13:10:00',14.86),('7643','2013-08-30','13:15:00',14.91),('7643','2013-08-30','13:20:00',14.97),('7643','2013-08-30','13:25:00',14.83),('7643','2013-08-30','13:30:00',14.74),('7643','2013-08-30','13:35:00',14.58),('7643','2013-08-30','13:40:00',14.6),('7643','2013-08-30','13:45:00',14.48),('7643','2013-08-30','13:50:00',14.55),('7643','2013-08-30','13:55:00',14.41),('7643','2013-08-30','14:00:00',14.41),('7643','2013-08-30','14:05:00',14.28),('7643','2013-08-30','14:10:00',14.1),('7643','2013-08-30','14:15:00',13.95),('7643','2013-08-30','14:20:00',13.77),('7643','2013-08-30','14:25:00',13.58),('7643','2013-08-30','14:30:00',13.48),('7643','2013-08-30','14:35:00',12.89),('7643','2013-08-30','14:40:00',13.06),('7643','2013-08-30','14:45:00',13.03),('7643','2013-08-30','14:50:00',13.03),('7643','2013-08-30','14:55:00',12.68),('7643','2013-08-30','15:00:00',12.57),('7643','2013-08-30','15:05:00',12.68),('7643','2013-08-30','15:10:00',12.46),('7643','2013-08-30','15:15:00',12.22),('7643','2013-08-30','15:20:00',12),('7643','2013-08-30','15:25:00',11.81),('7643','2013-08-30','15:30:00',11.74),('7643','2013-08-30','15:35:00',11.34),('7643','2013-08-30','15:40:00',11.42),('7643','2013-08-30','15:45:00',11.27),('7643','2013-08-30','15:50:00',10.96),('7643','2013-08-30','15:55:00',10.64),('7643','2013-08-30','16:00:00',10.48),('7643','2013-08-30','16:05:00',10.2),('7643','2013-08-30','16:10:00',10.08),('7643','2013-08-30','16:15:00',9.92),('7643','2013-08-30','16:20:00',9.66),('7643','2013-08-30','16:25:00',9.38),('7643','2013-08-30','16:30:00',8.95),('7643','2013-08-30','16:35:00',8.93),('7643','2013-08-30','16:40:00',8.68),('7643','2013-08-30','16:45:00',8.18),('7643','2013-08-30','16:50:00',7.84),('7643','2013-08-30','16:55:00',7.65),('7643','2013-08-30','17:00:00',7.3),('7643','2013-08-30','17:05:00',7.25),('7643','2013-08-30','17:10:00',6.99),('7643','2013-08-30','17:15:00',6.55),('7643','2013-08-30','17:20:00',6.2),('7643','2013-08-30','17:25:00',5.89),('7643','2013-08-30','17:30:00',5.53),('7643','2013-08-30','17:35:00',5.05),('7643','2013-08-30','17:40:00',4.86),('7643','2013-08-30','17:45:00',4.47),('7643','2013-08-30','17:50:00',4.07),('7643','2013-08-30','17:55:00',3.54),('7643','2013-08-30','18:00:00',2.22),('7643','2013-08-30','18:05:00',2.36),('7643','2013-08-30','18:10:00',2.41),('7643','2013-08-30','18:15:00',2.07),('7643','2013-08-30','18:20:00',2.11),('7643','2013-08-30','18:25:00',1.74),('7643','2013-08-29','07:20:00',1.25),('7643','2013-08-29','07:25:00',1.52),('7643','2013-08-29','07:30:00',1.82),('7643','2013-08-29','07:35:00',2.14),('7643','2013-08-29','07:40:00',2.52),('7643','2013-08-29','07:45:00',2.67),('7643','2013-08-29','07:50:00',2.74),('7643','2013-08-29','07:55:00',2.95),('7643','2013-08-29','08:00:00',3.39),('7643','2013-08-29','08:05:00',4.21),('7643','2013-08-29','08:10:00',4.75),('7643','2013-08-29','08:15:00',4.58),('7643','2013-08-29','08:20:00',4.88),('7643','2013-08-29','08:25:00',5.05),('7643','2013-08-29','08:30:00',5.24),('7643','2013-08-29','08:35:00',5.53),('7643','2013-08-29','08:40:00',5.68),('7643','2013-08-29','08:45:00',5.13),('7643','2013-08-29','08:50:00',4.66),('7643','2013-08-29','08:55:00',4.63),('7643','2013-08-29','09:00:00',5.34),('7643','2013-08-29','09:05:00',5.93),('7643','2013-08-29','09:10:00',5.23),('7643','2013-08-29','09:15:00',4.89),('7643','2013-08-29','09:20:00',4.38),('7643','2013-08-29','09:25:00',4.62),('7643','2013-08-29','09:30:00',5.99),('7643','2013-08-29','09:35:00',6.86),('7643','2013-08-29','09:40:00',6.55),('7643','2013-08-29','09:45:00',6.71),('7643','2013-08-29','09:50:00',6.73),('7643','2013-08-29','09:55:00',7.07),('7643','2013-08-29','10:00:00',7.11),('7643','2013-08-29','10:05:00',7.19),('7643','2013-08-29','10:10:00',7.11),('7643','2013-08-29','10:15:00',7.51),('7643','2013-08-29','10:20:00',8.13),('7643','2013-08-29','10:25:00',7.38),('7643','2013-08-29','10:30:00',8.18),('7643','2013-08-29','10:35:00',7.82),('7643','2013-08-29','10:40:00',7.35),('7643','2013-08-29','10:45:00',7.13),('7643','2013-08-29','10:50:00',7.64),('7643','2013-08-29','10:55:00',7.27),('7643','2013-08-29','11:00:00',7.67),('7643','2013-08-29','11:05:00',8.13),('7643','2013-08-29','11:10:00',8.48),('7643','2013-08-29','11:15:00',8.61),('7643','2013-08-29','11:20:00',8.65),('7643','2013-08-29','11:25:00',8.98),('7643','2013-08-29','11:30:00',9.5),('7643','2013-08-29','11:35:00',9.13),('7643','2013-08-29','11:40:00',9.82),('7643','2013-08-29','11:45:00',9.6),('7643','2013-08-29','11:50:00',11.06),('7643','2013-08-29','11:55:00',9.83),('7643','2013-08-29','12:00:00',8.84),('7643','2013-08-29','12:05:00',7.45),('7643','2013-08-29','12:10:00',8.03),('7643','2013-08-29','12:15:00',8.9),('7643','2013-08-29','12:20:00',9.7),('7643','2013-08-29','12:25:00',10.91),('7643','2013-08-29','12:30:00',12.12),('7643','2013-08-29','12:35:00',11.6),('7643','2013-08-29','12:40:00',11.18),('7643','2013-08-29','12:45:00',11.64),('7643','2013-08-29','12:50:00',11.52),('7643','2013-08-29','12:55:00',10.74),('7643','2013-08-29','13:00:00',10.4),('7643','2013-08-29','13:05:00',10.33),('7643','2013-08-29','13:10:00',10.39),('7643','2013-08-29','13:15:00',9.61),('7643','2013-08-29','13:20:00',11.31),('7643','2013-08-29','13:25:00',13.25),('7643','2013-08-29','13:30:00',14.59),('7643','2013-08-29','13:35:00',13.55),('7643','2013-08-29','13:40:00',14.49),('7643','2013-08-29','13:45:00',12.89),('7643','2013-08-29','13:50:00',12.94),('7643','2013-08-29','13:55:00',14.31),('7643','2013-08-29','14:00:00',14.76),('7643','2013-08-29','14:05:00',14.1),('7643','2013-08-29','14:10:00',14.36),('7643','2013-08-29','14:15:00',14.29),('7643','2013-08-29','14:20:00',14.18),('7643','2013-08-29','14:25:00',14.18),('7643','2013-08-29','14:30:00',14.02),('7643','2013-08-29','14:35:00',14.17),('7643','2013-08-29','14:40:00',13.6),('7643','2013-08-29','14:45:00',10.77),('7643','2013-08-29','14:50:00',9.08),('7643','2013-08-29','14:55:00',10.51),('7643','2013-08-29','15:00:00',9.29),('7643','2013-08-29','15:05:00',8.38),('7643','2013-08-29','15:10:00',8.48),('7643','2013-08-29','15:15:00',10.38),('7643','2013-08-29','15:20:00',9.01),('7643','2013-08-29','15:25:00',7.96),('7643','2013-08-29','15:30:00',7.86),('7643','2013-08-29','15:35:00',6.31),('7643','2013-08-29','15:40:00',6.74),('7643','2013-08-29','15:45:00',7.88),('7643','2013-08-29','15:50:00',8.66),('7643','2013-08-29','15:55:00',8.71),('7643','2013-08-29','16:00:00',8.1),('7643','2013-08-29','16:05:00',7.1),('7643','2013-08-29','16:10:00',5.9),('7643','2013-08-29','16:15:00',5.18),('7643','2013-08-29','16:20:00',5.81),('7643','2013-08-29','16:25:00',5.94),('7643','2013-08-29','16:30:00',5.86),('7643','2013-08-29','16:35:00',4.86),('7643','2013-08-29','16:40:00',8.96),('7643','2013-08-29','16:45:00',8.95),('7643','2013-08-29','16:50:00',8.31),('7643','2013-08-29','16:55:00',5.53),('7643','2013-08-29','17:00:00',6.85),('7643','2013-08-29','17:05:00',4.85),('7643','2013-08-29','17:10:00',5.52),('7643','2013-08-29','17:15:00',5),('7643','2013-08-29','17:20:00',4.29),('7643','2013-08-29','17:25:00',4.22),('7643','2013-08-29','17:30:00',4.63),('7643','2013-08-29','17:35:00',4.24),('7643','2013-08-29','17:40:00',4.74),('7643','2013-08-29','17:45:00',4.99),('7643','2013-08-29','17:50:00',3.49),('7643','2013-08-29','17:55:00',4.53),('7643','2013-08-29','18:00:00',3.69),('7643','2013-08-29','18:05:00',1.67),('7643','2013-08-29','18:10:00',1.13),('7643','2013-08-29','18:15:00',1.05),('7643','2013-08-29','18:20:00',1.12),('7643','2013-08-29','18:25:00',1.12),('7643','2013-08-29','18:30:00',1.01),('7643','2014-04-10','07:40:00',1.78),('7643','2014-04-10','07:45:00',2.52),('7643','2014-04-10','07:50:00',3.42),('7643','2014-04-10','07:55:00',3.78),('7643','2014-04-10','08:00:00',2.54),('7643','2014-04-10','08:05:00',2.04),('7643','2014-04-10','08:10:00',1.49),('7643','2014-04-10','08:15:00',1.56),('7643','2014-04-10','08:20:00',1.61),('7643','2014-04-10','08:25:00',1.58),('7643','2014-04-10','08:30:00',3.88),('7643','2014-04-10','08:35:00',6.26),('7643','2014-04-10','08:40:00',6.98),('7643','2014-04-10','08:45:00',7.63),('7643','2014-04-10','08:50:00',7.88),('7643','2014-04-10','08:55:00',8.12),('7643','2014-04-10','09:00:00',8.36),('7643','2014-04-10','09:05:00',8.61),('7643','2014-04-10','09:10:00',8.8),('7643','2014-04-10','09:15:00',9.14),('7643','2014-04-10','09:20:00',9.52),('7643','2014-04-10','09:25:00',9.86),('7643','2014-04-10','09:30:00',10.12),('7643','2014-04-10','09:35:00',10.38),('7643','2014-04-10','09:40:00',10.74),('7643','2014-04-10','09:45:00',10.92),('7643','2014-04-10','09:50:00',11.23),('7643','2014-04-10','09:55:00',11.42),('7643','2014-04-10','10:00:00',11.77),('7643','2014-04-10','10:05:00',11.95),('7643','2014-04-10','10:10:00',12.47),('7643','2014-04-10','10:15:00',12.69),('7643','2014-04-10','10:20:00',12.82),('7643','2014-04-10','10:25:00',13.12),('7643','2014-04-10','10:30:00',13.31),('7643','2014-04-10','10:35:00',13.52),('7643','2014-04-10','10:40:00',13.63),('7643','2014-04-10','10:45:00',13.83),('7643','2014-04-10','12:00:00',11.25),('7643','2014-04-10','12:05:00',15.78),('7643','2014-04-10','12:10:00',17.07),('7643','2014-04-10','12:15:00',16.43),('7643','2014-04-10','12:20:00',16.54),('7643','2014-04-10','12:25:00',16.82),('7643','2014-04-10','12:30:00',16.7),('7643','2014-04-10','12:35:00',16.97),('7643','2014-04-10','12:40:00',17.53),('7643','2014-04-10','12:45:00',15.44),('7643','2014-04-10','12:50:00',16.14),('7643','2014-04-10','12:55:00',17.39),('7643','2014-04-10','13:00:00',17.44),('7643','2014-04-10','13:05:00',17.14),('7643','2014-04-10','13:10:00',17.22),('7643','2014-04-10','13:15:00',15.9),('7643','2014-04-10','13:20:00',11.74),('7643','2014-04-10','13:25:00',15.3),('7643','2014-04-10','13:30:00',14.54),('7643','2014-04-10','13:35:00',9.94),('7643','2014-04-10','13:40:00',12.58),('7643','2014-04-10','13:45:00',13.8),('7643','2014-04-10','13:50:00',15.65),('7643','2014-04-10','13:55:00',18.17),('7643','2014-04-10','14:00:00',14.52),('7643','2014-04-10','14:05:00',15.01),('7643','2014-04-10','14:10:00',7.73),('7643','2014-04-10','14:15:00',10.28),('7643','2014-04-10','14:20:00',8.58),('7643','2014-04-10','14:25:00',10.44),('7643','2014-04-10','14:30:00',16.41),('7643','2014-04-10','14:35:00',13.81),('7643','2014-04-10','14:40:00',14.99),('7643','2014-04-10','14:45:00',14.3),('7643','2014-04-10','14:50:00',15.64),('7643','2014-04-10','14:55:00',10.7),('7643','2014-04-10','15:00:00',6.88),('7643','2014-04-10','15:05:00',8.98),('7643','2014-04-10','15:10:00',9.45),('7643','2014-04-10','15:15:00',15.21),('7643','2014-04-10','15:20:00',14.46),('7643','2014-04-10','15:25:00',12.84),('7643','2014-04-10','15:30:00',14.22),('7643','2014-04-10','15:35:00',14),('7643','2014-04-10','15:40:00',13.62),('7643','2014-04-10','15:45:00',13.3),('7643','2014-04-10','15:50:00',13.13),('7643','2014-04-10','15:55:00',13.06),('7643','2014-04-10','16:00:00',12.59),('7643','2014-04-10','16:05:00',12.35),('7643','2014-04-10','16:10:00',12.09),('7643','2014-04-10','16:15:00',11.69),('7643','2014-04-10','16:20:00',11.37),('7643','2014-04-10','16:25:00',11.14),('7643','2014-04-10','16:30:00',10.87),('7643','2014-04-10','16:35:00',10.01),('7643','2014-04-10','16:40:00',9.32),('7643','2014-04-10','16:45:00',10.05),('7643','2014-04-10','16:50:00',9.71),('7643','2014-04-10','16:55:00',6.21),('7643','2014-04-10','17:00:00',8.89),('7643','2014-04-10','17:05:00',5.6),('7643','2014-04-10','17:10:00',7.43),('7643','2014-04-10','17:15:00',6.1),('7643','2014-04-10','17:20:00',6.7),('7643','2014-04-10','17:25:00',7.29),('7643','2014-04-10','17:30:00',7.3),('7643','2014-04-10','17:35:00',7.11),('7643','2014-04-10','17:40:00',6.72),('7643','2014-04-10','17:45:00',6.07),('7643','2014-04-10','17:50:00',5.51),('7643','2014-04-10','17:55:00',5.01),('7643','2014-04-10','18:00:00',4.47),('7643','2014-04-10','18:05:00',4),('7643','2014-04-10','18:10:00',3.67),('7643','2014-04-10','18:15:00',3.51),('7643','2014-04-10','18:20:00',3.25),('7643','2014-04-10','18:25:00',2.91),('7643','2014-04-10','18:30:00',3.03),('7643','2014-04-10','18:35:00',2.81),('7643','2014-04-10','18:40:00',2.43),('7643','2014-04-10','18:45:00',2.02),('7643','2014-04-10','18:50:00',1.76),('7643','2014-04-10','18:55:00',1.48),('7643','2014-04-10','19:00:00',1.06),('7643','2013-08-28','07:20:00',1.01),('7643','2013-08-28','07:25:00',1.37),('7643','2013-08-28','07:30:00',1.77),('7643','2013-08-28','07:35:00',2.11),('7643','2013-08-28','07:40:00',2.43),('7643','2013-08-28','07:45:00',2.65),('7643','2013-08-28','07:50:00',2.92),('7643','2013-08-28','07:55:00',3.25),('7643','2013-08-28','08:00:00',3.67),('7643','2013-08-28','08:05:00',3.97),('7643','2013-08-28','08:10:00',4.45),('7643','2013-08-28','08:15:00',4.91),('7643','2013-08-28','08:20:00',5.5),('7643','2013-08-28','08:25:00',6.19),('7643','2013-08-28','08:30:00',6.98),('7643','2013-08-28','08:35:00',6.76),('7643','2013-08-28','08:40:00',5.23),('7643','2013-08-28','08:45:00',3.95),('7643','2013-08-28','08:50:00',4.61),('7643','2013-08-28','08:55:00',6.24),('7643','2013-08-28','09:00:00',6.05),('7643','2013-08-28','09:05:00',5.91),('7643','2013-08-28','09:10:00',5.77),('7643','2013-08-28','09:15:00',6.13),('7643','2013-08-28','09:20:00',6.06),('7643','2013-08-28','09:25:00',5.49),('7643','2013-08-28','09:30:00',5.68),('7643','2013-08-28','09:35:00',6.22),('7643','2013-08-28','09:40:00',6.21),('7643','2013-08-28','09:45:00',5.58),('7643','2013-08-28','09:50:00',5.34),('7643','2013-08-28','09:55:00',5.6),('7643','2013-08-28','10:00:00',5.98),('7643','2013-08-28','10:05:00',5.63),('7643','2013-08-28','10:10:00',5.5),('7643','2013-08-28','10:15:00',5.44),('7643','2013-08-28','10:20:00',5.49),('7643','2013-08-28','10:25:00',5.56),('7643','2013-08-28','10:30:00',5.69),('7643','2013-08-28','10:35:00',5.36),('7643','2013-08-28','10:40:00',4.96),('7643','2013-08-28','10:45:00',4.58),('7643','2013-08-28','10:50:00',4.49),('7643','2013-08-28','10:55:00',4.95),('7643','2013-08-28','11:00:00',5.32),('7643','2013-08-28','11:05:00',5.36),('7643','2013-08-28','11:10:00',8.02),('7643','2013-08-28','11:15:00',10.09),('7643','2013-08-28','11:20:00',9.57),('7643','2013-08-28','11:25:00',6.81),('7643','2013-08-28','11:30:00',5.84),('7643','2013-08-28','11:35:00',5.08),('7643','2013-08-28','11:40:00',5.61),('7643','2013-08-28','11:45:00',6.65),('7643','2013-08-28','11:50:00',7.01),('7643','2013-08-28','11:55:00',6.73),('7643','2013-08-28','12:00:00',6.73),('7643','2013-08-28','12:05:00',8),('7643','2013-08-28','12:10:00',9.35),('7643','2013-08-28','12:15:00',11.26),('7643','2013-08-28','12:20:00',9.59),('7643','2013-08-28','12:25:00',9.96),('7643','2013-08-28','12:30:00',10.14),('7643','2013-08-28','12:35:00',12.47),('7643','2013-08-28','12:40:00',16.55),('7643','2013-08-28','12:45:00',16.65),('7643','2013-08-28','12:50:00',10.47),('7643','2013-08-28','12:55:00',14.61),('7643','2013-08-28','13:00:00',10.42),('7643','2013-08-28','13:05:00',9.07),('7643','2013-08-28','13:10:00',8.98),('7643','2013-08-28','13:15:00',8.75),('7643','2013-08-28','13:20:00',8.47),('7643','2013-08-28','13:25:00',7.4),('7643','2013-08-28','13:30:00',6.72),('7643','2013-08-28','13:35:00',6.25),('7643','2013-08-28','13:40:00',5.91),('7643','2013-08-28','13:45:00',5.59),('7643','2013-08-28','13:50:00',5.47),('7643','2013-08-28','13:55:00',6.24),('7643','2013-08-28','14:00:00',8.26),('7643','2013-08-28','14:05:00',6.39),('7643','2013-08-28','14:10:00',5.68),('7643','2013-08-28','14:15:00',4.79),('7643','2013-08-28','14:20:00',3.8),('7643','2013-08-28','14:25:00',3.33),('7643','2013-08-28','14:30:00',3.07),('7643','2013-08-28','14:35:00',3.09),('7643','2013-08-28','14:40:00',3.14),('7643','2013-08-28','14:45:00',3.45),('7643','2013-08-28','14:50:00',4.06),('7643','2013-08-28','14:55:00',4.82),('7643','2013-08-28','15:00:00',5.42),('7643','2013-08-28','15:05:00',6.13),('7643','2013-08-28','15:10:00',5.11),('7643','2013-08-28','15:15:00',4.23),('7643','2013-08-28','15:20:00',4.48),('7643','2013-08-28','15:25:00',5.13),('7643','2013-08-28','15:30:00',8.14),('7643','2013-08-28','15:35:00',8.94),('7643','2013-08-28','15:40:00',7.75),('7643','2013-08-28','15:45:00',9.39),('7643','2013-08-28','15:50:00',10.76),('7643','2013-08-28','15:55:00',11.53),('7643','2013-08-28','16:00:00',12.19),('7643','2013-08-28','16:05:00',12.03),('7643','2013-08-28','16:10:00',11.99),('7643','2013-08-28','16:15:00',11.06),('7643','2013-08-28','16:20:00',10.47),('7643','2013-08-28','16:25:00',10.03),('7643','2013-08-28','16:30:00',9.73),('7643','2013-08-28','16:35:00',9.44),('7643','2013-08-28','16:40:00',9.16),('7643','2013-08-28','16:45:00',8.85),('7643','2013-08-28','16:50:00',8.55),('7643','2013-08-28','16:55:00',8.26),('7643','2013-08-28','17:00:00',8),('7643','2013-08-28','17:05:00',7.68),('7643','2013-08-28','17:10:00',7.35),('7643','2013-08-28','17:15:00',6.99),('7643','2013-08-28','17:20:00',6.67),('7643','2013-08-28','17:25:00',6.4),('7643','2013-08-28','17:30:00',6.03),('7643','2013-08-28','17:35:00',5.69),('7643','2013-08-28','17:40:00',5.34),('7643','2013-08-28','17:45:00',4.96),('7643','2013-08-28','17:50:00',4.62),('7643','2013-08-28','17:55:00',4.28),('7643','2013-08-28','18:00:00',3.92),('7643','2013-08-28','18:05:00',3.58),('7643','2013-08-28','18:10:00',3.2),('7643','2013-08-28','18:15:00',2.93),('7643','2013-08-28','18:20:00',2.58),('7643','2013-08-28','18:25:00',2.29),('7643','2013-08-28','18:30:00',2.01),('7643','2013-08-28','18:35:00',1.69),('7643','2013-08-28','18:40:00',1.44),('7643','2013-08-28','18:45:00',1.25),('7643','2013-08-27','07:35:00',1.91),('7643','2013-08-27','07:40:00',2.26),('7643','2013-08-27','07:45:00',1.94),('7643','2013-08-27','07:50:00',2.85),('7643','2013-08-27','07:55:00',3.24),('7643','2013-08-27','08:00:00',3.44),('7643','2013-08-27','08:05:00',3.84),('7643','2013-08-27','08:10:00',4.15),('7643','2013-08-27','08:15:00',4.5),('7643','2013-08-27','08:20:00',4.84),('7643','2013-08-27','08:25:00',5.04),('7643','2013-08-27','08:30:00',5.42),('7643','2013-08-27','08:35:00',6.06),('7643','2013-08-27','08:40:00',3.82),('7643','2013-08-27','08:45:00',4.43),('7643','2013-08-27','08:50:00',5.64),('7643','2013-08-27','08:55:00',3.33),('7643','2013-08-27','09:00:00',6.6),('7643','2013-08-27','09:05:00',5.04),('7643','2013-08-27','09:10:00',4.6),('7643','2013-08-27','09:15:00',7.04),('7643','2013-08-27','09:20:00',4.09),('7643','2013-08-27','09:25:00',2.77),('7643','2013-08-27','09:30:00',2.98),('7643','2013-08-27','09:35:00',8.33),('7643','2013-08-27','09:40:00',10.01),('7643','2013-08-27','09:45:00',10.12),('7643','2013-08-27','09:50:00',10.4),('7643','2013-08-27','09:55:00',10.42),('7643','2013-08-27','10:00:00',10.51),('7643','2013-08-27','10:05:00',10.76),('7643','2013-08-27','10:10:00',11.29),('7643','2013-08-27','10:15:00',9.1),('7643','2013-08-27','10:20:00',11.2),('7643','2013-08-27','10:25:00',12.3),('7643','2013-08-27','10:30:00',6.64),('7643','2013-08-27','10:35:00',4.94),('7643','2013-08-27','10:40:00',6.56),('7643','2013-08-27','10:45:00',9.65),('7643','2013-08-27','10:50:00',13.35),('7643','2013-08-27','10:55:00',13.76),('7643','2013-08-27','11:00:00',8.15),('7643','2013-08-27','11:05:00',9.88),('7643','2013-08-27','11:10:00',14.75),('7643','2013-08-27','11:15:00',9.43),('7643','2013-08-27','11:20:00',14.85),('7643','2013-08-27','11:25:00',14.44),('7643','2013-08-27','11:30:00',14.56),('7643','2013-08-27','11:35:00',14.89),('7643','2013-08-27','11:40:00',15.44),('7643','2013-08-27','11:45:00',15.76),('7643','2013-08-27','11:50:00',13.09),('7643','2013-08-27','11:55:00',12.05),('7643','2013-08-27','12:00:00',6.26),('7643','2013-08-27','12:05:00',16.42),('7643','2013-08-27','12:10:00',15.64),('7643','2013-08-27','12:15:00',9.56),('7643','2013-08-27','12:20:00',15.65),('7643','2013-08-27','12:25:00',15.54),('7643','2013-08-27','12:30:00',15.31),('7643','2013-08-27','12:35:00',15.28),('7643','2013-08-27','12:40:00',15.41),('7643','2013-08-27','12:45:00',15.07),('7643','2013-08-27','12:50:00',15.78),('7643','2013-08-27','12:55:00',15.68),('7643','2013-08-27','13:00:00',15.75),('7643','2013-08-27','13:05:00',16.08),('7643','2013-08-27','13:10:00',16.05),('7643','2013-08-27','13:15:00',16),('7643','2013-08-27','13:20:00',15.66),('7643','2013-08-27','13:25:00',15.57),('7643','2013-08-27','13:30:00',13.05),('7643','2013-08-27','13:35:00',15.68),('7643','2013-08-27','13:40:00',13.06),('7643','2013-08-27','13:45:00',15.17),('7643','2013-08-27','13:50:00',15.69),('7643','2013-08-27','13:55:00',13.33),('7643','2013-08-27','14:00:00',14.81),('7643','2013-08-27','14:05:00',15.37),('7643','2013-08-27','14:10:00',14),('7643','2013-08-27','14:15:00',14.94),('7643','2013-08-27','14:20:00',15.03),('7643','2013-08-27','14:25:00',14.91),('7643','2013-08-27','14:30:00',14.8),('7643','2013-08-27','14:35:00',13.74),('7643','2013-08-27','14:40:00',15.32),('7643','2013-08-27','14:45:00',14.53),('7643','2013-08-27','14:50:00',14.27),('7643','2013-08-27','14:55:00',14.16),('7643','2013-08-27','15:00:00',13.98),('7643','2013-08-27','15:05:00',11.94),('7643','2013-08-27','15:10:00',12.71),('7643','2013-08-27','15:15:00',13.95),('7643','2013-08-27','15:20:00',13.67),('7643','2013-08-27','15:25:00',12.96),('7643','2013-08-27','15:30:00',8.96),('7643','2013-08-27','15:35:00',13.11),('7643','2013-08-27','15:40:00',8.96),('7643','2013-08-27','15:45:00',3.54),('7643','2013-08-27','15:50:00',5.11),('7643','2013-08-27','15:55:00',9.51),('7643','2013-08-27','16:00:00',12.51),('7643','2013-08-27','16:05:00',7.97),('7643','2013-08-27','16:10:00',11.49),('7643','2013-08-27','16:15:00',11.41),('7643','2013-08-27','16:20:00',6.43),('7643','2013-08-27','16:25:00',11.43),('7643','2013-08-27','16:30:00',9.55),('7643','2013-08-27','16:35:00',10.28),('7643','2013-08-27','16:40:00',9.97),('7643','2013-08-27','16:45:00',9.41),('7643','2013-08-27','16:50:00',8.98),('7643','2013-08-27','16:55:00',8.46),('7643','2013-08-27','17:00:00',8.51),('7643','2013-08-27','17:05:00',7.94),('7643','2013-08-27','17:10:00',7.7),('7643','2013-08-27','17:15:00',7.74),('7643','2013-08-27','17:20:00',4.48),('7643','2013-08-27','17:25:00',6.13),('7643','2013-08-27','17:30:00',6.5),('7643','2013-08-27','17:35:00',4.89),('7643','2013-08-27','17:40:00',6),('7643','2013-08-27','17:45:00',3.9),('7643','2013-08-27','17:50:00',1.26),('7643','2013-08-27','17:55:00',2.06),('7643','2013-08-27','18:00:00',2.38),('7643','2013-08-27','18:05:00',2.1),('7643','2013-08-27','18:10:00',2.66),('7643','2013-08-27','18:15:00',3.38),('7643','2013-08-27','18:20:00',1.73),('7643','2013-08-27','18:25:00',2.74),('7643','2013-08-27','18:30:00',1.14),('7643','2013-08-27','18:50:00',1.5),('7643','2013-08-27','18:55:00',1.27),('7643','2013-08-27','19:00:00',1.29),('7643','2013-08-26','07:40:00',1.06),('7643','2013-08-26','07:45:00',1.25),('7643','2013-08-26','07:50:00',1.35),('7643','2013-08-26','07:55:00',1.46),('7643','2013-08-26','08:00:00',1.58),('7643','2013-08-26','08:05:00',1.94),('7643','2013-08-26','08:10:00',2.36),('7643','2013-08-26','08:15:00',2.97),('7643','2013-08-26','08:20:00',4.26),('7643','2013-08-26','08:25:00',5.71),('7643','2013-08-26','08:30:00',5.8),('7643','2013-08-26','08:35:00',4.01),('7643','2013-08-26','08:40:00',3.67),('7643','2013-08-26','08:45:00',4.62),('7643','2013-08-26','08:50:00',3.31),('7643','2013-08-26','08:55:00',3),('7643','2013-08-26','09:00:00',3.53),('7643','2013-08-26','09:05:00',3.76),('7643','2013-08-26','09:10:00',4.97),('7643','2013-08-26','09:15:00',4.93),('7643','2013-08-26','09:20:00',5.73),('7643','2013-08-26','09:25:00',7.58),('7643','2013-08-26','09:30:00',8.23),('7643','2013-08-26','09:35:00',4.99),('7643','2013-08-26','09:40:00',3.77),('7643','2013-08-26','09:45:00',3.85),('7643','2013-08-26','09:50:00',4.04),('7643','2013-08-26','09:55:00',5.26),('7643','2013-08-26','10:00:00',7),('7643','2013-08-26','10:05:00',8.89),('7643','2013-08-26','10:10:00',10.77),('7643','2013-08-26','10:15:00',11.13),('7643','2013-08-26','10:20:00',11.46),('7643','2013-08-26','10:25:00',11.53),('7643','2013-08-26','10:30:00',11.68),('7643','2013-08-26','10:35:00',11.89),('7643','2013-08-26','10:40:00',11.78),('7643','2013-08-26','10:45:00',12),('7643','2013-08-26','10:50:00',12.41),('7643','2013-08-26','10:55:00',12.38),('7643','2013-08-26','11:00:00',12.56),('7643','2013-08-26','11:05:00',12.83),('7643','2013-08-26','11:10:00',12.8),('7643','2013-08-26','11:15:00',12.62),('7643','2013-08-26','11:20:00',12.63),('7643','2013-08-26','11:25:00',12.62),('7643','2013-08-26','11:30:00',12.86),('7643','2013-08-26','11:35:00',13.22),('7643','2013-08-26','11:40:00',12.85),('7643','2013-08-26','11:45:00',15.78),('7643','2013-08-26','11:50:00',10.87),('7643','2013-08-26','11:55:00',14.41),('7643','2013-08-26','12:00:00',15.81),('7643','2013-08-26','12:05:00',14.37),('7643','2013-08-26','12:10:00',13.05),('7643','2013-08-26','12:15:00',13.26),('7643','2013-08-26','12:20:00',13.99),('7643','2013-08-26','12:25:00',13.4),('7643','2013-08-26','12:30:00',13.66),('7643','2013-08-26','12:35:00',11.98),('7643','2013-08-26','12:40:00',15.6),('7643','2013-08-26','12:45:00',11.61),('7643','2013-08-26','12:50:00',9.01),('7643','2013-08-26','12:55:00',8.65),('7643','2013-08-26','13:00:00',5.15),('7643','2013-08-26','13:05:00',6.99),('7643','2013-08-26','13:10:00',8.15),('7643','2013-08-26','13:15:00',10.54),('7643','2013-08-26','13:20:00',8.26),('7643','2013-08-26','13:25:00',6.55),('7643','2013-08-26','13:30:00',8.51),('7643','2013-08-26','13:35:00',6.86),('7643','2013-08-26','13:40:00',8.32),('7643','2013-08-26','13:45:00',10.38),('7643','2013-08-26','13:50:00',14.91),('7643','2013-08-26','13:55:00',12.13),('7643','2013-08-26','14:00:00',16.32),('7643','2013-08-26','14:05:00',10.5),('7643','2013-08-26','14:10:00',6.52),('7643','2013-08-26','14:15:00',8.7),('7643','2013-08-26','14:20:00',9.45),('7643','2013-08-26','14:25:00',5.19),('7643','2013-08-26','14:30:00',3.79),('7643','2013-08-26','14:35:00',4.13),('7643','2013-08-26','14:40:00',4.36),('7643','2013-08-26','14:45:00',4.57),('7643','2013-08-26','14:50:00',3.52),('7643','2013-08-26','14:55:00',2.63),('7643','2013-08-26','15:00:00',2.67),('7643','2013-08-26','15:05:00',2.42),('7643','2013-08-26','15:10:00',2.14),('7643','2013-08-26','15:15:00',2.41),('7643','2013-08-26','15:20:00',2.44),('7643','2013-08-26','15:25:00',2),('7643','2013-08-26','15:30:00',2.02),('7643','2013-08-26','15:35:00',2.11),('7643','2013-08-26','15:40:00',1.78),('7643','2013-08-26','15:45:00',1.58),('7643','2013-08-26','15:50:00',1.57),('7643','2013-08-26','15:55:00',3.63),('7643','2013-08-26','16:00:00',4.85),('7643','2013-08-26','16:05:00',4.95),('7643','2013-08-26','16:10:00',11.89),('7643','2013-08-26','16:15:00',9.89),('7643','2013-08-26','16:20:00',7.94),('7643','2013-08-26','16:25:00',6.58),('7643','2013-08-26','16:30:00',4.02),('7643','2013-08-26','16:35:00',3.73),('7643','2013-08-26','16:40:00',3.47),('7643','2013-08-26','16:45:00',3.39),('7643','2013-08-26','16:50:00',4.06),('7643','2013-08-26','16:55:00',4.66),('7643','2013-08-26','17:00:00',2.33),('7643','2013-08-26','17:05:00',3.82),('7643','2013-08-26','17:10:00',9.43),('7643','2013-08-26','17:15:00',4.73),('7643','2013-08-26','17:20:00',3.23),('7643','2013-08-26','17:25:00',3.17),('7643','2013-08-26','17:30:00',2.46),('7643','2013-08-26','17:35:00',3.13),('7643','2013-08-26','17:40:00',3.17),('7643','2013-08-26','17:45:00',4.22),('7643','2013-08-26','17:50:00',5.28),('7643','2013-08-26','17:55:00',5.27),('7643','2013-08-26','18:00:00',4.46),('7643','2013-08-26','18:05:00',3.41),('7643','2013-08-26','18:10:00',1.22),('7643','2013-08-26','18:15:00',1.39),('7643','2013-08-25','07:20:00',1.4),('7643','2013-08-25','07:25:00',1.91),('7643','2013-08-25','07:30:00',1.89),('7643','2013-08-25','07:35:00',1.61),('7643','2013-08-25','07:40:00',2.12),('7643','2013-08-25','07:45:00',1.9),('7643','2013-08-25','07:50:00',1.62),('7643','2013-08-25','07:55:00',3.16),('7643','2013-08-25','08:00:00',3.01),('7643','2013-08-25','08:05:00',4.85),('7643','2013-08-25','08:10:00',5.19),('7643','2013-08-25','08:15:00',2.96),('7643','2013-08-25','08:20:00',5.75),('7643','2013-08-25','08:25:00',5.07),('7643','2013-08-25','08:30:00',5.91),('7643','2013-08-25','08:35:00',5.13),('7643','2013-08-25','08:40:00',6.08),('7643','2013-08-25','08:45:00',6.42),('7643','2013-08-25','08:50:00',6.65),('7643','2013-08-25','08:55:00',6.96),('7643','2013-08-25','09:00:00',7.28),('7643','2013-08-25','09:05:00',7.6),('7643','2013-08-25','09:10:00',7.92),('7643','2013-08-25','09:15:00',8.17),('7643','2013-08-25','09:20:00',8.29),('7643','2013-08-25','09:25:00',7.31),('7643','2013-08-25','09:30:00',8.46),('7643','2013-08-25','09:35:00',9.15),('7643','2013-08-25','09:40:00',9.43),('7643','2013-08-25','09:45:00',9.59),('7643','2013-08-25','09:50:00',9.91),('7643','2013-08-25','09:55:00',10.22),('7643','2013-08-25','10:00:00',10.22),('7643','2013-08-25','10:05:00',10.49),('7643','2013-08-25','10:10:00',10.74),('7643','2013-08-25','10:15:00',11.01),('7643','2013-08-25','10:20:00',11.16),('7643','2013-08-25','10:25:00',11.45),('7643','2013-08-25','10:30:00',11.59),('7643','2013-08-25','10:35:00',11.64),('7643','2013-08-25','10:40:00',11.88),('7643','2013-08-25','10:45:00',12.23),('7643','2013-08-25','10:50:00',12.35),('7643','2013-08-25','10:55:00',12.5),('7643','2013-08-25','11:00:00',12.71),('7643','2013-08-25','11:05:00',12.77),('7643','2013-08-25','11:10:00',12.8),('7643','2013-08-25','11:15:00',13.08),('7643','2013-08-25','11:20:00',13.16),('7643','2013-08-25','11:25:00',13.13),('7643','2013-08-25','11:30:00',13.34),('7643','2013-08-25','11:35:00',13.56),('7643','2013-08-25','11:40:00',13.64),('7643','2013-08-25','11:45:00',13.74),('7643','2013-08-25','11:50:00',13.9),('7643','2013-08-25','11:55:00',14.05),('7643','2013-08-25','12:00:00',14.09),('7643','2013-08-25','12:05:00',14.15),('7643','2013-08-25','12:10:00',14.22),('7643','2013-08-25','12:15:00',14.28),('7643','2013-08-25','12:20:00',14.3),('7643','2013-08-25','12:25:00',14.15),('7643','2013-08-25','12:30:00',14.11),('7643','2013-08-25','12:35:00',14.2),('7643','2013-08-25','12:40:00',14.4),('7643','2013-08-25','12:45:00',14.49),('7643','2013-08-25','12:50:00',14.52),('7643','2013-08-25','12:55:00',14.61),('7643','2013-08-25','13:00:00',15.18),('7643','2013-08-25','13:05:00',15.12),('7643','2013-08-25','13:10:00',14.17),('7643','2013-08-25','13:15:00',7.63),('7643','2013-08-25','13:20:00',7.68),('7643','2013-08-25','13:25:00',11.85),('7643','2013-08-25','13:30:00',10.72),('7643','2013-08-25','13:35:00',13.71),('7643','2013-08-25','13:40:00',14.72),('7643','2013-08-25','13:45:00',14.59),('7643','2013-08-25','13:50:00',14.64),('7643','2013-08-25','13:55:00',11.07),('7643','2013-08-25','14:00:00',10.83),('7643','2013-08-25','14:05:00',12.48),('7643','2013-08-25','14:10:00',8.92),('7643','2013-08-25','14:15:00',13.67),('7643','2013-08-25','14:20:00',14.04),('7643','2013-08-25','14:25:00',13.87),('7643','2013-08-25','14:30:00',14.01),('7643','2013-08-25','14:35:00',13.13),('7643','2013-08-25','14:40:00',11.83),('7643','2013-08-25','14:45:00',9),('7643','2013-08-25','14:50:00',8.13),('7643','2013-08-25','14:55:00',7.4),('7643','2013-08-25','15:00:00',7.12),('7643','2013-08-25','15:05:00',5.03),('7643','2013-08-25','15:10:00',3.86),('7643','2013-08-25','15:15:00',3.36),('7643','2013-08-25','15:20:00',2.75),('7643','2013-08-25','15:25:00',2.53),('7643','2013-08-25','15:30:00',2.73),('7643','2013-08-25','15:35:00',3.5),('7643','2013-08-25','15:40:00',5.75),('7643','2013-08-25','15:45:00',6.27),('7643','2013-08-25','15:50:00',6.04),('7643','2013-08-25','15:55:00',5.67),('7643','2013-08-25','16:00:00',9.6),('7643','2013-08-25','16:05:00',12.01),('7643','2013-08-25','16:10:00',10.62),('7643','2013-08-25','16:15:00',9.87),('7643','2013-08-25','16:20:00',9.8),('7643','2013-08-25','16:25:00',9.46),('7643','2013-08-25','16:30:00',9.14),('7643','2013-08-25','16:35:00',8.92),('7643','2013-08-25','16:40:00',8.63),('7643','2013-08-25','16:45:00',8.61),('7643','2013-08-25','16:50:00',7.93),('7643','2013-08-25','16:55:00',7.69),('7643','2013-08-25','17:00:00',7.59),('7643','2013-08-25','17:05:00',6.97),('7643','2013-08-25','17:10:00',6.93),('7643','2013-08-25','17:15:00',6.6),('7643','2013-08-25','17:20:00',4.64),('7643','2013-08-25','17:25:00',2.08),('7643','2013-08-25','17:30:00',4.38),('7643','2013-08-25','17:35:00',3.65),('7643','2013-08-25','17:40:00',3.56),('7643','2013-08-25','17:45:00',4.42),('7643','2013-08-25','17:50:00',4.75),('7643','2013-08-25','17:55:00',4.83),('7643','2013-08-25','18:00:00',4.17),('7643','2013-08-25','18:05:00',3.6),('7643','2013-08-25','18:10:00',3.18),('7643','2013-08-25','18:15:00',2.76),('7643','2013-08-25','18:20:00',2.48),('7643','2013-08-25','18:25:00',2.27),('7643','2013-08-25','18:30:00',1.97),('7643','2013-08-25','18:35:00',1.74),('7643','2013-08-25','18:40:00',1.56),('7643','2013-08-25','18:45:00',1.35),('7643','2013-08-25','18:50:00',1.12),('7643','2013-08-24','07:15:00',1.02),('7643','2013-08-24','07:20:00',1.17),('7643','2013-08-24','07:25:00',1.36),('7643','2013-08-24','07:30:00',1.61),('7643','2013-08-24','07:35:00',1.69),('7643','2013-08-24','07:40:00',1.94),('7643','2013-08-24','07:45:00',2.13),('7643','2013-08-24','07:50:00',2.54),('7643','2013-08-24','07:55:00',2.9),('7643','2013-08-24','08:00:00',3.18),('7643','2013-08-24','08:05:00',3.64),('7643','2013-08-24','08:10:00',4.33),('7643','2013-08-24','08:15:00',4.16),('7643','2013-08-24','08:20:00',4.22),('7643','2013-08-24','08:25:00',4.42),('7643','2013-08-24','08:30:00',3.03),('7643','2013-08-24','08:35:00',3.05),('7643','2013-08-24','08:40:00',4.14),('7643','2013-08-24','08:45:00',5.44),('7643','2013-08-24','08:50:00',2.41),('7643','2013-08-24','08:55:00',3.62),('7643','2013-08-24','09:00:00',1.67),('7643','2013-08-24','09:05:00',2.23),('7643','2013-08-24','09:10:00',3.8),('7643','2013-08-24','09:15:00',3.94),('7643','2013-08-24','09:20:00',7.44),('7643','2013-08-24','09:25:00',7.74),('7643','2013-08-24','09:30:00',5.09),('7643','2013-08-24','09:35:00',6.75),('7643','2013-08-24','09:40:00',11.11),('7643','2013-08-24','09:45:00',11.67),('7643','2013-08-24','09:50:00',10.91),('7643','2013-08-24','09:55:00',11.72),('7643','2013-08-24','10:00:00',8.92),('7643','2013-08-24','10:05:00',6.24),('7643','2013-08-24','10:10:00',3.54),('7643','2013-08-24','10:15:00',2.61),('7643','2013-08-24','10:20:00',2.58),('7643','2013-08-24','10:25:00',1.93),('7643','2013-08-24','10:30:00',1.39),('7643','2013-08-24','10:35:00',1.14),('7643','2013-08-24','14:50:00',1.03),('7643','2013-08-24','14:55:00',1.75),('7643','2013-08-24','15:00:00',2.48),('7643','2013-08-24','15:05:00',3.16),('7643','2013-08-24','15:10:00',3.5),('7643','2013-08-24','15:15:00',4.14),('7643','2013-08-24','15:20:00',5.01),('7643','2013-08-24','15:25:00',5.54),('7643','2013-08-24','15:30:00',7.62),('7643','2013-08-24','15:35:00',11.69),('7643','2013-08-24','15:40:00',13.45),('7643','2013-08-24','15:45:00',13.82),('7643','2013-08-24','15:50:00',9.07),('7643','2013-08-24','15:55:00',10.82),('7643','2013-08-24','16:00:00',12.4),('7643','2013-08-24','16:05:00',11.77),('7643','2013-08-24','16:10:00',11.22),('7643','2013-08-24','16:15:00',10.81),('7643','2013-08-24','16:20:00',10.43),('7643','2013-08-24','16:25:00',10.3),('7643','2013-08-24','16:30:00',10),('7643','2013-08-24','16:40:00',5.95),('7643','2013-08-24','16:45:00',4.58),('7643','2013-08-24','16:50:00',6.8),('7643','2013-08-24','16:55:00',9.81),('7643','2013-08-24','17:00:00',8.93),('7643','2013-08-24','17:05:00',8.34),('7643','2013-08-24','17:10:00',7.87),('7643','2013-08-24','17:15:00',7.21),('7643','2013-08-24','17:20:00',6.84),('7643','2013-08-24','17:25:00',6.45),('7643','2013-08-24','17:30:00',6.1),('7643','2013-08-24','17:35:00',5.43),('7643','2013-08-24','17:40:00',4.64),('7643','2013-08-24','17:45:00',5.18),('7643','2013-08-24','17:50:00',4.61),('7643','2013-08-24','17:55:00',4),('7643','2013-08-24','18:00:00',2.97),('7643','2013-08-24','18:05:00',2.74),('7643','2013-08-24','18:10:00',3.06),('7643','2013-08-24','18:15:00',3.19),('7643','2013-08-24','18:20:00',2.99),('7643','2013-08-24','18:25:00',2.68),('7643','2013-08-24','18:30:00',2.17),('7643','2013-08-24','18:35:00',1.62),('7643','2013-08-24','18:40:00',1.05),('7643','2013-08-23','07:20:00',1.19),('7643','2013-08-23','07:25:00',1.36),('7643','2013-08-23','07:30:00',1.57),('7643','2013-08-23','07:35:00',1.79),('7643','2013-08-23','07:40:00',2.04),('7643','2013-08-23','07:45:00',2.32),('7643','2013-08-23','07:50:00',2.45),('7643','2013-08-23','07:55:00',1.82),('7643','2013-08-23','08:00:00',2.26),('7643','2013-08-23','08:05:00',2.82),('7643','2013-08-23','08:10:00',2.78),('7643','2013-08-23','08:15:00',2.9),('7643','2013-08-23','08:20:00',2.23),('7643','2013-08-23','08:25:00',4.07),('7643','2013-08-23','08:30:00',4.93),('7643','2013-08-23','08:35:00',5.08),('7643','2013-08-23','08:40:00',5.5),('7643','2013-08-23','08:45:00',5.98),('7643','2013-08-23','08:50:00',5.58),('7643','2013-08-23','08:55:00',6.5),('7643','2013-08-23','09:00:00',6.92),('7643','2013-08-23','09:05:00',7),('7643','2013-08-23','09:10:00',5.72),('7643','2013-08-23','09:15:00',7.6),('7643','2013-08-23','09:20:00',8.58),('7643','2013-08-23','09:25:00',8.23),('7643','2013-08-23','09:30:00',6.62),('7643','2013-08-23','09:35:00',9.38),('7643','2013-08-23','09:40:00',9.58),('7643','2013-08-23','09:45:00',6.13),('7643','2013-08-23','09:50:00',9.18),('7643','2013-08-23','09:55:00',3.59),('7643','2013-08-23','10:00:00',5),('7643','2013-08-23','10:05:00',9.23),('7643','2013-08-23','10:10:00',10.62),('7643','2013-08-23','10:15:00',10.7),('7643','2013-08-23','10:20:00',11.09),('7643','2013-08-23','10:25:00',11.21),('7643','2013-08-23','10:30:00',11.37),('7643','2013-08-23','10:35:00',11.57),('7643','2013-08-23','10:40:00',11.73),('7643','2013-08-23','10:45:00',11.96),('7643','2013-08-23','10:50:00',10.35),('7643','2013-08-23','10:55:00',12.47),('7643','2013-08-23','11:00:00',12.31),('7643','2013-08-23','11:05:00',12.37),('7643','2013-08-23','11:10:00',12.94),('7643','2013-08-23','11:15:00',12.86),('7643','2013-08-23','11:20:00',12.86),('7643','2013-08-23','11:25:00',13.01),('7643','2013-08-23','11:30:00',13.18),('7643','2013-08-23','11:35:00',13.31),('7643','2013-08-23','11:40:00',13.47),('7643','2013-08-23','11:45:00',13.48),('7643','2013-08-23','11:50:00',13.59),('7643','2013-08-23','11:55:00',13.55),('7643','2013-08-23','12:00:00',13.81),('7643','2013-08-23','12:05:00',13.92),('7643','2013-08-23','12:10:00',14.12),('7643','2013-08-23','12:15:00',14.12),('7643','2013-08-23','12:20:00',14.23),('7643','2013-08-23','12:25:00',14.24),('7643','2013-08-23','12:30:00',14.1),('7643','2013-08-23','12:35:00',14.12),('7643','2013-08-23','12:40:00',14.21),('7643','2013-08-23','12:45:00',14.14),('7643','2013-08-23','12:50:00',14.17),('7643','2013-08-23','12:55:00',14.19),('7643','2013-08-23','13:00:00',13.95),('7643','2013-08-23','13:05:00',14.14),('7643','2013-08-23','13:10:00',14.27),('7643','2013-08-23','13:15:00',14.38),('7643','2013-08-23','13:20:00',14.35),('7643','2013-08-23','13:25:00',14.44),('7643','2013-08-23','13:30:00',14.45),('7643','2013-08-23','13:35:00',14.4),('7643','2013-08-23','13:40:00',14.32),('7643','2013-08-23','13:45:00',14.29),('7643','2013-08-23','13:50:00',14.22),('7643','2013-08-23','13:55:00',14.16),('7643','2013-08-23','14:00:00',14.12),('7643','2013-08-23','14:05:00',14.06),('7643','2013-08-23','14:10:00',13.99),('7643','2013-08-23','14:15:00',13.85),('7643','2013-08-23','14:20:00',13.81),('7643','2013-08-23','14:25:00',13.62),('7643','2013-08-23','14:30:00',13.51),('7643','2013-08-23','14:35:00',13.46),('7643','2013-08-23','14:40:00',13.3),('7643','2013-08-23','14:45:00',13.25),('7643','2013-08-23','14:50:00',13.05),('7643','2013-08-23','14:55:00',13.01),('7643','2013-08-23','15:00:00',12.88),('7643','2013-08-23','15:05:00',12.7),('7643','2013-08-23','15:10:00',12.43),('7643','2013-08-23','15:15:00',12.3),('7643','2013-08-23','15:20:00',12.13),('7643','2013-08-23','15:25:00',12.02),('7643','2013-08-23','15:30:00',11.82),('7643','2013-08-23','15:35:00',11.64),('7643','2013-08-23','15:40:00',11.46),('7643','2013-08-23','15:45:00',11.18),('7643','2013-08-23','15:50:00',10.99),('7643','2013-08-23','15:55:00',10.78),('7643','2013-08-23','16:00:00',10.58),('7643','2013-08-23','16:05:00',10.35),('7643','2013-08-23','16:10:00',10.13),('7643','2013-08-23','16:15:00',9.91),('7643','2013-08-23','16:20:00',9.73),('7643','2013-08-23','16:25:00',9.51),('7643','2013-08-23','16:30:00',9.21),('7643','2013-08-23','16:35:00',8.94),('7643','2013-08-23','16:40:00',8.66),('7643','2013-08-23','16:45:00',8.43),('7643','2013-08-23','16:50:00',8.16),('7643','2013-08-23','16:55:00',7.88),('7643','2013-08-23','17:00:00',7.63),('7643','2013-08-23','17:05:00',7.32),('7643','2013-08-23','17:10:00',7.04),('7643','2013-08-23','17:15:00',6.77),('7643','2013-08-23','17:20:00',6.48),('7643','2013-08-23','17:25:00',6.19),('7643','2013-08-23','17:30:00',5.87),('7643','2013-08-23','17:35:00',5.56),('7643','2013-08-23','17:40:00',5.25),('7643','2013-08-23','17:45:00',4.93),('7643','2013-08-23','17:50:00',4.62),('7643','2013-08-23','17:55:00',4.23),('7643','2013-08-23','18:00:00',3.89),('7643','2013-08-23','18:05:00',3.53),('7643','2013-08-23','18:10:00',3.21),('7643','2013-08-23','18:15:00',2.94),('7643','2013-08-23','18:20:00',2.61),('7643','2013-08-23','18:25:00',2.31),('7643','2013-08-23','18:30:00',2.07),('7643','2013-08-23','18:35:00',1.77),('7643','2013-08-23','18:40:00',1.49),('7643','2013-08-23','18:45:00',1.35),('7643','2013-08-23','18:50:00',1.14),('7643','2013-08-22','07:20:00',1.1),('7643','2013-08-22','07:25:00',1.28),('7643','2013-08-22','07:30:00',1.46),('7643','2013-08-22','07:35:00',1.67),('7643','2013-08-22','07:40:00',1.89),('7643','2013-08-22','07:45:00',2.11),('7643','2013-08-22','07:50:00',2.36),('7643','2013-08-22','07:55:00',2.61),('7643','2013-08-22','08:00:00',2.87),('7643','2013-08-22','08:05:00',3.13),('7643','2013-08-22','08:10:00',3.4),('7643','2013-08-22','08:15:00',3.68),('7643','2013-08-22','08:20:00',4.03),('7643','2013-08-22','08:25:00',4.34),('7643','2013-08-22','08:30:00',4.71),('7643','2013-08-22','08:35:00',4.92),('7643','2013-08-22','08:40:00',5.09),('7643','2013-08-22','08:45:00',5.44),('7643','2013-08-22','08:50:00',5.72),('7643','2013-08-22','08:55:00',5.92),('7643','2013-08-22','09:00:00',6.08),('7643','2013-08-22','09:05:00',6.43),('7643','2013-08-22','09:10:00',6.81),('7643','2013-08-22','09:15:00',7.1),('7643','2013-08-22','09:20:00',7.4),('7643','2013-08-22','09:25:00',7.63),('7643','2013-08-22','09:30:00',7.84),('7643','2013-08-22','09:35:00',8),('7643','2013-08-22','09:40:00',8.18),('7643','2013-08-22','09:45:00',8.49),('7643','2013-08-22','09:50:00',8.78),('7643','2013-08-22','09:55:00',9.02),('7643','2013-08-22','10:00:00',9.21),('7643','2013-08-22','10:05:00',9.43),('7643','2013-08-22','10:10:00',9.66),('7643','2013-08-22','10:15:00',9.86),('7643','2013-08-22','10:20:00',10.03),('7643','2013-08-22','10:25:00',10.25),('7643','2013-08-22','10:30:00',10.14),('7643','2013-08-22','10:35:00',10.16),('7643','2013-08-22','10:40:00',10.64),('7643','2013-08-22','10:45:00',10.92),('7643','2013-08-22','10:50:00',10.84),('7643','2013-08-22','10:55:00',10.85),('7643','2013-08-22','11:00:00',11.5),('7643','2013-08-22','11:05:00',11.79),('7643','2013-08-22','11:10:00',10.92),('7643','2013-08-22','11:15:00',7.04),('7643','2013-08-22','11:20:00',5.86),('7643','2013-08-22','11:25:00',8.82),('7643','2013-08-22','11:30:00',5.82),('7643','2013-08-22','11:35:00',9.24),('7643','2013-08-22','11:40:00',12.96),('7643','2013-08-22','11:45:00',13.5),('7643','2013-08-22','11:50:00',13.41),('7643','2013-08-22','11:55:00',13.47),('7643','2013-08-22','12:00:00',13.79),('7643','2013-08-22','12:05:00',13.59),('7643','2013-08-22','12:10:00',6.11),('7643','2013-08-22','12:15:00',11.34),('7643','2013-08-22','12:20:00',3.68),('7643','2013-08-22','12:25:00',3.45),('7643','2013-08-22','12:30:00',3.06),('7643','2013-08-22','12:35:00',4.49),('7643','2013-08-22','12:40:00',7.29),('7643','2013-08-22','12:45:00',3.26),('7643','2013-08-22','12:50:00',3.15),('7643','2013-08-22','12:55:00',2.91),('7643','2013-08-22','13:00:00',3.29),('7643','2013-08-22','13:05:00',4),('7643','2013-08-22','13:10:00',8.74),('7643','2013-08-22','13:15:00',13.43),('7643','2013-08-22','13:20:00',6.57),('7643','2013-08-22','13:25:00',15.45),('7643','2013-08-22','13:30:00',15.89),('7643','2013-08-22','13:35:00',14.78),('7643','2013-08-22','13:40:00',15.16),('7643','2013-08-22','13:45:00',14.72),('7643','2013-08-22','13:50:00',14.4),('7643','2013-08-22','13:55:00',14.75),('7643','2013-08-22','14:00:00',9.79),('7643','2013-08-22','14:05:00',14.94),('7643','2013-08-22','14:10:00',14.63),('7643','2013-08-22','14:15:00',14.34),('7643','2013-08-22','14:20:00',14),('7643','2013-08-22','14:25:00',11.56),('7643','2013-08-22','14:30:00',13.79),('7643','2013-08-22','14:35:00',13.4),('7643','2013-08-22','14:40:00',13.16),('7643','2013-08-22','14:45:00',13.26),('7643','2013-08-22','14:50:00',13.06),('7643','2013-08-22','14:55:00',13.11),('7643','2013-08-22','15:00:00',12.58),('7643','2013-08-22','15:05:00',11.91),('7643','2013-08-22','15:10:00',12.45),('7643','2013-08-22','15:15:00',12.21),('7643','2013-08-22','15:20:00',11.98),('7643','2013-08-22','15:25:00',11.94),('7643','2013-08-22','15:30:00',12.19),('7643','2013-08-22','15:35:00',11.39),('7643','2013-08-22','15:40:00',11.12),('7643','2013-08-22','15:45:00',11.33),('7643','2013-08-22','15:50:00',10.25),('7643','2013-08-22','15:55:00',10.91),('7643','2013-08-22','16:00:00',10.44),('7643','2013-08-22','16:05:00',9.84),('7643','2013-08-22','16:10:00',9.13),('7643','2013-08-22','16:15:00',9.18),('7643','2013-08-22','16:20:00',10.18),('7643','2013-08-22','16:25:00',9.93),('7643','2013-08-22','16:30:00',9.61),('7643','2013-08-22','16:35:00',9.42),('7643','2013-08-22','16:40:00',9.14),('7643','2013-08-22','16:45:00',8.85),('7643','2013-08-22','16:50:00',8.52),('7643','2013-08-22','16:55:00',8.09),('7643','2013-08-22','17:00:00',7.71),('7643','2013-08-22','17:05:00',7.44),('7643','2013-08-22','17:10:00',7.05),('7643','2013-08-22','17:15:00',6.65),('7643','2013-08-22','17:20:00',6.32),('7643','2013-08-22','17:25:00',6.08),('7643','2013-08-22','17:30:00',5.65),('7643','2013-08-22','17:35:00',5.36),('7643','2013-08-22','17:40:00',5.03),('7643','2013-08-22','17:45:00',4.72),('7643','2013-08-22','17:50:00',4.41),('7643','2013-08-22','17:55:00',4.13),('7643','2013-08-22','18:00:00',3.83),('7643','2013-08-22','18:05:00',3.45),('7643','2013-08-22','18:10:00',2.9),('7643','2013-08-22','18:15:00',2.51),('7643','2013-08-22','18:20:00',2.63),('7643','2013-08-22','18:25:00',2.43),('7643','2013-08-22','18:30:00',2.23),('7643','2013-08-22','18:35:00',1.92),('7643','2013-08-22','18:40:00',1.64),('7643','2013-08-22','18:45:00',1.48),('7643','2013-08-22','18:50:00',1.27),('7643','2013-08-22','18:55:00',1.03),('7643','2013-08-21','07:20:00',1.13),('7643','2013-08-21','07:25:00',1.37),('7643','2013-08-21','07:30:00',1.61),('7643','2013-08-21','07:35:00',1.85),('7643','2013-08-21','07:40:00',2.05),('7643','2013-08-21','07:45:00',2.31),('7643','2013-08-21','07:50:00',2.55),('7643','2013-08-21','07:55:00',2.82),('7643','2013-08-21','08:00:00',3.07),('7643','2013-08-21','08:05:00',3.31),('7643','2013-08-21','08:10:00',3.63),('7643','2013-08-21','08:15:00',3.84),('7643','2013-08-21','08:20:00',4.22),('7643','2013-08-21','08:25:00',4.46),('7643','2013-08-21','08:30:00',4.82),('7643','2013-08-21','08:35:00',5.16),('7643','2013-08-21','08:40:00',5.35),('7643','2013-08-21','08:45:00',5.78),('7643','2013-08-21','08:50:00',6.04),('7643','2013-08-21','08:55:00',6.43),('7643','2013-08-21','09:00:00',6.78),('7643','2013-08-21','09:05:00',7.42),('7643','2013-08-21','09:10:00',7.84),('7643','2013-08-21','09:15:00',8.23),('7643','2013-08-21','09:20:00',8.7),('7643','2013-08-21','09:25:00',8.79),('7643','2013-08-21','09:30:00',6.98),('7643','2013-08-21','09:35:00',4.68),('7643','2013-08-21','09:40:00',5.81),('7643','2013-08-21','09:45:00',7.24),('7643','2013-08-21','09:50:00',9.24),('7643','2013-08-21','09:55:00',9.83),('7643','2013-08-21','10:00:00',10.44),('7643','2013-08-21','10:05:00',10.65),('7643','2013-08-21','10:10:00',10.7),('7643','2013-08-21','10:15:00',10.74),('7643','2013-08-21','10:20:00',10.74),('7643','2013-08-21','10:25:00',10.97),('7643','2013-08-21','10:30:00',11.16),('7643','2013-08-21','10:35:00',11.26),('7643','2013-08-21','10:40:00',11.46),('7643','2013-08-21','10:45:00',11.59),('7643','2013-08-21','10:50:00',11.73),('7643','2013-08-21','10:55:00',11.89),('7643','2013-08-21','11:00:00',12.03),('7643','2013-08-21','11:05:00',12.18),('7643','2013-08-21','11:10:00',12.12),('7643','2013-08-21','11:15:00',12.31),('7643','2013-08-21','11:20:00',12.46),('7643','2013-08-21','11:25:00',12.54),('7643','2013-08-21','11:30:00',12.75),('7643','2013-08-21','11:35:00',12.86),('7643','2013-08-21','11:40:00',12.93),('7643','2013-08-21','11:45:00',13.01),('7643','2013-08-21','11:50:00',13.15),('7643','2013-08-21','11:55:00',13.21),('7643','2013-08-21','12:00:00',13.32),('7643','2013-08-21','12:05:00',13.42),('7643','2013-08-21','12:10:00',13.49),('7643','2013-08-21','12:15:00',13.54),('7643','2013-08-21','12:20:00',13.6),('7643','2013-08-21','12:25:00',13.52),('7643','2013-08-21','12:30:00',13.58),('7643','2013-08-21','12:35:00',13.69),('7643','2013-08-21','12:40:00',13.72),('7643','2013-08-21','12:45:00',13.79),('7643','2013-08-21','12:50:00',13.72),('7643','2013-08-21','12:55:00',13.74),('7643','2013-08-21','13:00:00',13.74),('7643','2013-08-21','13:05:00',13.46),('7643','2013-08-21','13:10:00',13.25),('7643','2013-08-21','13:15:00',13.29),('7643','2013-08-21','13:20:00',13.42),('7643','2013-08-21','13:25:00',13.4),('7643','2013-08-21','13:30:00',13.4),('7643','2013-08-21','13:35:00',13.4),('7643','2013-08-21','13:40:00',13.46),('7643','2013-08-21','13:45:00',13.59),('7643','2013-08-21','13:50:00',13.49),('7643','2013-08-21','13:55:00',13.4),('7643','2013-08-21','14:00:00',13.38),('7643','2013-08-21','14:05:00',13.29),('7643','2013-08-21','14:10:00',13.27),('7643','2013-08-21','14:15:00',13.26),('7643','2013-08-21','14:20:00',13.18),('7643','2013-08-21','14:25:00',13.39),('7643','2013-08-21','14:30:00',13.31),('7643','2013-08-21','14:35:00',13.01),('7643','2013-08-21','14:40:00',12.91),('7643','2013-08-21','14:45:00',12.79),('7643','2013-08-21','14:50:00',12.53),('7643','2013-08-21','14:55:00',9.5),('7643','2013-08-21','15:00:00',12.1),('7643','2013-08-21','15:05:00',12.3),('7643','2013-08-21','15:10:00',12.15),('7643','2013-08-21','15:15:00',11.99),('7643','2013-08-21','15:20:00',11.82),('7643','2013-08-21','15:25:00',11.62),('7643','2013-08-21','15:30:00',11.43),('7643','2013-08-21','15:35:00',11.27),('7643','2013-08-21','15:40:00',11.18),('7643','2013-08-21','15:45:00',11),('7643','2013-08-21','15:50:00',10.84),('7643','2013-08-21','15:55:00',10.58),('7643','2013-08-21','16:00:00',10.26),('7643','2013-08-21','16:05:00',9.91),('7643','2013-08-21','16:10:00',9.72),('7643','2013-08-21','16:15:00',9.59),('7643','2013-08-21','16:20:00',9.32),('7643','2013-08-21','16:25:00',9.11),('7643','2013-08-21','16:30:00',8.9),('7643','2013-08-21','16:35:00',8.58),('7643','2013-08-21','16:40:00',8.29),('7643','2013-08-21','16:45:00',7.98),('7643','2013-08-21','16:50:00',7.77),('7643','2013-08-21','16:55:00',7.53),('7643','2013-08-21','17:00:00',7.16),('7643','2013-08-21','17:05:00',6.92),('7643','2013-08-21','17:10:00',6.57),('7643','2013-08-21','17:15:00',6.27),('7643','2013-08-21','17:20:00',6.01),('7643','2013-08-21','17:25:00',5.76),('7643','2013-08-21','17:30:00',5.47),('7643','2013-08-21','17:35:00',5.17),('7643','2013-08-21','17:40:00',4.88),('7643','2013-08-21','17:45:00',4.56),('7643','2013-08-21','17:50:00',4.21),('7643','2013-08-21','17:55:00',3.99),('7643','2013-08-21','18:00:00',3.74),('7643','2013-08-21','18:05:00',3.42),('7643','2013-08-21','18:10:00',3.27),('7643','2013-08-21','18:15:00',3.32),('7643','2013-08-21','18:20:00',2.93),('7643','2013-08-21','18:25:00',2.2),('7643','2013-08-21','18:30:00',1.91),('7643','2013-08-21','18:35:00',1.7),('7643','2013-08-21','18:40:00',1.67),('7643','2013-08-21','18:45:00',1.54),('7643','2013-08-21','18:50:00',1.32),('7643','2013-08-21','18:55:00',1.13),('7643','2013-08-21','19:00:00',1.03),('7643','2013-08-20','07:45:00',1.03),('7643','2013-08-20','07:50:00',1.24),('7643','2013-08-20','07:55:00',1.36),('7643','2013-08-20','08:00:00',1.43),('7643','2013-08-20','08:05:00',1.53),('7643','2013-08-20','08:10:00',1.67),('7643','2013-08-20','08:15:00',1.95),('7643','2013-08-20','08:20:00',2.31),('7643','2013-08-20','08:25:00',2.81),('7643','2013-08-20','08:30:00',2.86),('7643','2013-08-20','08:35:00',3),('7643','2013-08-20','08:40:00',2.84),('7643','2013-08-20','08:45:00',2.65),('7643','2013-08-20','08:50:00',2.45),('7643','2013-08-20','08:55:00',2.66),('7643','2013-08-20','09:00:00',3.29),('7643','2013-08-20','09:05:00',4.99),('7643','2013-08-20','09:10:00',4.79),('7643','2013-08-20','09:15:00',9.02),('7643','2013-08-20','09:20:00',8.48),('7643','2013-08-20','09:25:00',4.43),('7643','2013-08-20','09:30:00',2.84),('7643','2013-08-20','09:35:00',3.71),('7643','2013-08-20','09:40:00',4.02),('7643','2013-08-20','09:45:00',4.8),('7643','2013-08-20','09:50:00',11.22),('7643','2013-08-20','09:55:00',12.64),('7643','2013-08-20','10:00:00',11.9),('7643','2013-08-20','10:05:00',8.37),('7643','2013-08-20','10:10:00',10.15),('7643','2013-08-20','10:15:00',7.42),('7643','2013-08-20','10:20:00',6.43),('7643','2013-08-20','10:25:00',5.95),('7643','2013-08-20','10:30:00',9.26),('7643','2013-08-20','10:35:00',12.09),('7643','2013-08-20','10:40:00',9.39),('7643','2013-08-20','10:45:00',8.1),('7643','2013-08-20','10:50:00',7.41),('7643','2013-08-20','10:55:00',6.29),('7643','2013-08-20','11:00:00',8.15),('7643','2013-08-20','11:05:00',6.72),('7643','2013-08-20','11:10:00',6.4),('7643','2013-08-20','11:15:00',8.49),('7643','2013-08-20','11:20:00',12.88),('7643','2013-08-20','11:25:00',8.93),('7643','2013-08-20','11:30:00',10.65),('7643','2013-08-20','11:35:00',15.32),('7643','2013-08-20','11:40:00',14.77),('7643','2013-08-20','11:45:00',14.34),('7643','2013-08-20','11:50:00',10.81),('7643','2013-08-20','11:55:00',13.76),('7643','2013-08-20','12:00:00',14.68),('7643','2013-08-20','12:05:00',14.64),('7643','2013-08-20','12:10:00',14.7),('7643','2013-08-20','12:15:00',14.81),('7643','2013-08-20','12:20:00',13.57),('7643','2013-08-20','12:25:00',11.39),('7643','2013-08-20','12:30:00',11.09),('7643','2013-08-20','12:35:00',10.07),('7643','2013-08-20','12:40:00',13.15),('7643','2013-08-20','12:45:00',14.09),('7643','2013-08-20','12:50:00',13.72),('7643','2013-08-20','12:55:00',13.24),('7643','2013-08-20','13:00:00',14),('7643','2013-08-20','13:05:00',14.2),('7643','2013-08-20','13:10:00',14.36),('7643','2013-08-20','13:15:00',14.66),('7643','2013-08-20','13:20:00',14.54),('7643','2013-08-20','13:25:00',14.65),('7643','2013-08-20','13:30:00',14.67),('7643','2013-08-20','13:35:00',14.13),('7643','2013-08-20','13:40:00',13.83),('7643','2013-08-20','13:45:00',12.5),('7643','2013-08-20','13:50:00',13.84),('7643','2013-08-20','13:55:00',13.67),('7643','2013-08-20','14:00:00',12.26),('7643','2013-08-20','14:05:00',13.9),('7643','2013-08-20','14:10:00',13.94),('7643','2013-08-20','14:15:00',12.44),('7643','2013-08-20','14:20:00',8.07),('7643','2013-08-20','14:25:00',8.45),('7643','2013-08-20','14:30:00',12.37),('7643','2013-08-20','14:35:00',12.11),('7643','2013-08-20','14:40:00',12.41),('7643','2013-08-20','14:45:00',12.41),('7643','2013-08-20','14:50:00',11.72),('7643','2013-08-20','14:55:00',11.79),('7643','2013-08-20','15:00:00',12.16),('7643','2013-08-20','15:05:00',12.19),('7643','2013-08-20','15:10:00',11.84),('7643','2013-08-20','15:15:00',11.82),('7643','2013-08-20','15:20:00',11.36),('7643','2013-08-20','15:25:00',11.02),('7643','2013-08-20','15:30:00',10.72),('7643','2013-08-20','15:35:00',10.38),('7643','2013-08-20','15:40:00',9.87),('7643','2013-08-20','15:45:00',9.7),('7643','2013-08-20','15:50:00',10.09),('7643','2013-08-20','15:55:00',9.76),('7643','2013-08-20','16:00:00',9.07),('7643','2013-08-20','16:05:00',8.49),('7643','2013-08-20','16:10:00',8.54),('7643','2013-08-20','16:15:00',8.53),('7643','2013-08-20','16:20:00',9.04),('7643','2013-08-20','16:25:00',8.85),('7643','2013-08-20','16:30:00',9.32),('7643','2013-08-20','16:35:00',9.25),('7643','2013-08-20','16:40:00',8.87),('7643','2013-08-20','16:45:00',8.48),('7643','2013-08-20','16:50:00',8.24),('7643','2013-08-20','16:55:00',7.99),('7643','2013-08-20','17:00:00',7.76),('7643','2013-08-20','17:05:00',7.61),('7643','2013-08-20','17:10:00',7.38),('7643','2013-08-20','17:15:00',7.23),('7643','2013-08-20','17:20:00',7.08),('7643','2013-08-20','17:25:00',6.83),('7643','2013-08-20','17:30:00',6.47),('7643','2013-08-20','17:35:00',6.22),('7643','2013-08-20','17:40:00',5.88),('7643','2013-08-20','17:45:00',5.65),('7643','2013-08-20','17:50:00',5.51),('7643','2013-08-20','17:55:00',5.2),('7643','2013-08-20','18:00:00',4.87),('7643','2013-08-20','18:05:00',4.52),('7643','2013-08-20','18:10:00',4.17),('7643','2013-08-20','18:15:00',3.75),('7643','2013-08-20','18:20:00',3.38),('7643','2013-08-20','18:25:00',3.03),('7643','2013-08-20','18:30:00',2.66),('7643','2013-08-20','18:35:00',2.15),('7643','2013-08-20','18:40:00',1.85),('7643','2013-08-20','18:45:00',1.73),('7643','2013-08-20','18:50:00',1.45),('7643','2013-08-20','18:55:00',1.29),('7643','2013-08-20','19:00:00',1.08),('7643','2013-08-19','07:20:00',1.09),('7643','2013-08-19','07:25:00',1.28),('7643','2013-08-19','07:30:00',1.55),('7643','2013-08-19','07:35:00',1.88),('7643','2013-08-19','07:40:00',2.23),('7643','2013-08-19','07:45:00',2.31),('7643','2013-08-19','07:50:00',2.91),('7643','2013-08-19','07:55:00',3.76),('7643','2013-08-19','08:00:00',3.42),('7643','2013-08-19','08:05:00',2.99),('7643','2013-08-19','08:10:00',2.28),('7643','2013-08-19','08:15:00',2.3),('7643','2013-08-19','08:20:00',2.47),('7643','2013-08-19','08:25:00',2.59),('7643','2013-08-19','08:30:00',2.42),('7643','2013-08-19','08:35:00',2.37),('7643','2013-08-19','08:40:00',2.55),('7643','2013-08-19','08:45:00',2.83),('7643','2013-08-19','08:50:00',3.41),('7643','2013-08-19','08:55:00',3.68),('7643','2013-08-19','09:00:00',3.81),('7643','2013-08-19','09:05:00',4.09),('7643','2013-08-19','09:10:00',3.99),('7643','2013-08-19','09:15:00',3.95),('7643','2013-08-19','09:20:00',3.62),('7643','2013-08-19','09:25:00',6.14),('7643','2013-08-19','09:30:00',8.31),('7643','2013-08-19','09:35:00',8.58),('7643','2013-08-19','09:40:00',9.79),('7643','2013-08-19','09:45:00',11.4),('7643','2013-08-19','09:50:00',8.71),('7643','2013-08-19','09:55:00',8.72),('7643','2013-08-19','10:00:00',5.73),('7643','2013-08-19','10:05:00',5.5),('7643','2013-08-19','10:10:00',11.62),('7643','2013-08-19','10:15:00',8.5),('7643','2013-08-19','10:20:00',8.12),('7643','2013-08-19','10:25:00',7.22),('7643','2013-08-19','10:30:00',3.4),('7643','2013-08-19','10:35:00',3.15),('7643','2013-08-19','10:40:00',3.22),('7643','2013-08-19','10:45:00',3.26),('7643','2013-08-19','10:50:00',9.72),('7643','2013-08-19','10:55:00',8.44),('7643','2013-08-19','11:00:00',2.8),('7643','2013-08-19','11:05:00',2.14),('7643','2013-08-19','11:10:00',2.67),('7643','2013-08-19','11:15:00',10.71),('7643','2013-08-19','11:20:00',14.56),('7643','2013-08-19','11:25:00',12.15),('7643','2013-08-19','11:30:00',3.14),('7643','2013-08-19','11:35:00',8.21),('7643','2013-08-19','11:40:00',14.75),('7643','2013-08-19','11:45:00',15.23),('7643','2013-08-19','11:50:00',16.45),('7643','2013-08-19','11:55:00',12.15),('7643','2013-08-19','12:00:00',5.46),('7643','2013-08-19','12:05:00',5.84),('7643','2013-08-19','12:10:00',4.76),('7643','2013-08-19','12:15:00',3.26),('7643','2013-08-19','12:20:00',3.39),('7643','2013-08-19','12:25:00',4),('7643','2013-08-19','12:30:00',4.71),('7643','2013-08-19','12:35:00',5.02),('7643','2013-08-19','12:40:00',6.02),('7643','2013-08-19','12:45:00',6.07),('7643','2013-08-19','12:50:00',6.23),('7643','2013-08-19','12:55:00',6.49),('7643','2013-08-19','13:00:00',6.17),('7643','2013-08-19','13:05:00',5.82),('7643','2013-08-19','13:10:00',5.68),('7643','2013-08-19','13:15:00',5.98),('7643','2013-08-19','13:20:00',6.16),('7643','2013-08-19','13:25:00',6.48),('7643','2013-08-19','13:30:00',6.89),('7643','2013-08-19','13:35:00',8.72),('7643','2013-08-19','13:40:00',15.01),('7643','2013-08-19','13:45:00',14.53),('7643','2013-08-19','13:50:00',15.65),('7643','2013-08-19','13:55:00',15.05),('7643','2013-08-19','14:00:00',14.76),('7643','2013-08-19','14:05:00',14.45),('7643','2013-08-19','14:10:00',14.71),('7643','2013-08-19','14:15:00',14.35),('7643','2013-08-19','14:20:00',14.23),('7643','2013-08-19','14:25:00',13.13),('7643','2013-08-19','14:30:00',9.96),('7643','2013-08-19','14:35:00',13.3),('7643','2013-08-19','14:40:00',15.27),('7643','2013-08-19','14:45:00',14.66),('7643','2013-08-19','14:50:00',14.25),('7643','2013-08-19','14:55:00',10.31),('7643','2013-08-19','15:00:00',10.78),('7643','2013-08-19','15:05:00',14.34),('7643','2013-08-19','15:10:00',14.18),('7643','2013-08-19','15:15:00',13.95),('7643','2013-08-19','15:20:00',13.46),('7643','2013-08-19','15:25:00',13.29),('7643','2013-08-19','15:30:00',13.34),('7643','2013-08-19','15:35:00',13.3),('7643','2013-08-19','15:40:00',13.44),('7643','2013-08-19','15:45:00',13.97),('7643','2013-08-19','15:50:00',12.56),('7643','2013-08-19','15:55:00',14.26),('7643','2013-08-19','16:00:00',12.73),('7643','2013-08-19','16:05:00',13.31),('7643','2013-08-19','16:10:00',13.1),('7643','2013-08-19','16:15:00',12.83),('7643','2013-08-19','16:20:00',12.57),('7643','2013-08-19','16:25:00',12.1),('7643','2013-08-19','16:30:00',11.18),('7643','2013-08-19','16:35:00',11.27),('7643','2013-08-19','16:40:00',11.48),('7643','2013-08-19','16:45:00',11.11),('7643','2013-08-19','16:50:00',10.09),('7643','2013-08-19','16:55:00',9.48),('7643','2013-08-19','17:00:00',8.71),('7643','2013-08-19','17:05:00',8.2),('7643','2013-08-19','17:10:00',7.78),('7643','2013-08-19','17:15:00',7.29),('7643','2013-08-19','17:20:00',7.05),('7643','2013-08-19','17:25:00',6.78),('7643','2013-08-19','17:30:00',6.46),('7643','2013-08-19','17:35:00',6.19),('7643','2013-08-19','17:40:00',5.91),('7643','2013-08-19','17:45:00',5.59),('7643','2013-08-19','17:50:00',5.04),('7643','2013-08-19','17:55:00',4.62),('7643','2013-08-19','18:00:00',2.93),('7643','2013-08-19','18:05:00',4.06),('7643','2013-08-19','18:10:00',4.13),('7643','2013-08-19','18:15:00',4.05),('7643','2013-08-19','18:20:00',3.85),('7643','2013-08-19','18:25:00',3.61),('7643','2013-08-19','18:30:00',3.52),('7643','2013-08-19','18:35:00',3.19),('7643','2013-08-19','18:40:00',3.01),('7643','2013-08-19','18:45:00',2.89),('7643','2013-08-19','18:50:00',2.51),('7643','2013-08-19','18:55:00',2.36),('7643','2013-08-19','19:00:00',2.13),('7643','2013-08-19','19:05:00',1.72),('7643','2013-08-19','19:10:00',1.4),('7643','2013-08-19','19:15:00',1.11),('7643','2014-04-09','07:20:00',1.13),('7643','2014-04-09','07:25:00',1.4),('7643','2014-04-09','07:30:00',1.75),('7643','2014-04-09','07:35:00',2.08),('7643','2014-04-09','07:40:00',2.35),('7643','2014-04-09','07:45:00',2.77),('7643','2014-04-09','07:50:00',3.25),('7643','2014-04-09','07:55:00',3.58),('7643','2014-04-09','08:00:00',3.95),('7643','2014-04-09','08:05:00',4.41),('7643','2014-04-09','08:10:00',4.82),('7643','2014-04-09','08:15:00',5.23),('7643','2014-04-09','08:20:00',5.63),('7643','2014-04-09','08:25:00',6.06),('7643','2014-04-09','08:30:00',6.45),('7643','2014-04-09','08:35:00',6.83),('7643','2014-04-09','08:40:00',7.24),('7643','2014-04-09','08:45:00',7.63),('7643','2014-04-09','08:50:00',7.95),('7643','2014-04-09','08:55:00',8.25),('7643','2014-04-09','09:00:00',8.52),('7643','2014-04-09','09:05:00',9.06),('7643','2014-04-09','09:10:00',9.39),('7643','2014-04-09','09:15:00',9.57),('7643','2014-04-09','09:20:00',9.62),('7643','2014-04-09','09:25:00',10.31),('7643','2014-04-09','09:30:00',10.69),('7643','2014-04-09','09:35:00',10.98),('7643','2014-04-09','09:40:00',11.22),('7643','2014-04-09','09:45:00',11.45),('7643','2014-04-09','09:50:00',11.77),('7643','2014-04-09','09:55:00',12.05),('7643','2014-04-09','10:00:00',12.33),('7643','2014-04-09','10:05:00',12.47),('7643','2014-04-09','10:10:00',12.84),('7643','2014-04-09','10:15:00',12.82),('7643','2014-04-09','10:20:00',13.11),('7643','2014-04-09','10:25:00',13.33),('7643','2014-04-09','10:30:00',13.45),('7643','2014-04-09','10:35:00',13.97),('7643','2014-04-09','10:40:00',14.18),('7643','2014-04-09','10:45:00',14.13),('7643','2014-04-09','10:50:00',14.06),('7643','2014-04-09','10:55:00',14.35),('7643','2014-04-09','11:00:00',14.51),('7643','2014-04-09','11:05:00',15.04),('7643','2014-04-09','11:10:00',14.59),('7643','2014-04-09','11:15:00',15.23),('7643','2014-04-09','11:20:00',15.62),('7643','2014-04-09','11:25:00',15.84),('7643','2014-04-09','11:30:00',15.84),('7643','2014-04-09','11:35:00',16.01),('7643','2014-04-09','11:40:00',15.66),('7643','2014-04-09','11:45:00',16.02),('7643','2014-04-09','11:50:00',15.5),('7643','2014-04-09','11:55:00',16.29),('7643','2014-04-09','12:00:00',16.14),('7643','2014-04-09','12:05:00',15.11),('7643','2014-04-09','12:10:00',15.7),('7643','2014-04-09','12:15:00',15.9),('7643','2014-04-09','12:20:00',16.05),('7643','2014-04-09','12:25:00',15.6),('7643','2014-04-09','12:30:00',15.88),('7643','2014-04-09','12:35:00',16.66),('7643','2014-04-09','12:40:00',16.4),('7643','2014-04-09','12:45:00',16.47),('7643','2014-04-09','12:50:00',16.15),('7643','2014-04-09','12:55:00',15.93),('7643','2014-04-09','13:00:00',15.76),('7643','2014-04-09','13:05:00',15.16),('7643','2014-04-09','13:10:00',15.69),('7643','2014-04-09','13:15:00',15.95),('7643','2014-04-09','13:20:00',15.22),('7643','2014-04-09','13:25:00',16.8),('7643','2014-04-09','13:30:00',16.28),('7643','2014-04-09','13:35:00',16.66),('7643','2014-04-09','13:40:00',16.01),('7643','2014-04-09','13:45:00',16.61),('7643','2014-04-09','13:50:00',16.46),('7643','2014-04-09','13:55:00',16.3),('7643','2014-04-09','14:00:00',16.15),('7643','2014-04-09','14:05:00',16.06),('7643','2014-04-09','14:10:00',16.01),('7643','2014-04-09','14:15:00',15.93),('7643','2014-04-09','14:20:00',15.94),('7643','2014-04-09','14:25:00',15.94),('7643','2014-04-09','14:30:00',15.81),('7643','2014-04-09','14:35:00',15.67),('7643','2014-04-09','14:40:00',15.52),('7643','2014-04-09','14:45:00',14.11),('7643','2014-04-09','14:50:00',15.58),('7643','2014-04-09','14:55:00',15.21),('7643','2014-04-09','15:00:00',15.01),('7643','2014-04-09','15:05:00',14.79),('7643','2014-04-09','15:10:00',14.48),('7643','2014-04-09','15:15:00',14.37),('7643','2014-04-09','15:20:00',14.25),('7643','2014-04-09','15:25:00',14.02),('7643','2014-04-09','15:30:00',12.69),('7643','2014-04-09','15:35:00',12.43),('7643','2014-04-09','15:40:00',12.72),('7643','2014-04-09','15:45:00',12.54),('7643','2014-04-09','15:50:00',12.73),('7643','2014-04-09','15:55:00',12.5),('7643','2014-04-09','16:00:00',12),('7643','2014-04-09','16:05:00',12.22),('7643','2014-04-09','16:10:00',12.14),('7643','2014-04-09','16:15:00',12.4),('7643','2014-04-09','16:20:00',11.67),('7643','2014-04-09','16:25:00',11.83),('7643','2014-04-09','16:30:00',11.53),('7643','2014-04-09','16:35:00',11.18),('7643','2014-04-09','16:40:00',10.89),('7643','2014-04-09','16:45:00',10.92),('7643','2014-04-09','16:50:00',10.34),('7643','2014-04-09','16:55:00',9.95),('7643','2014-04-09','17:00:00',9.46),('7643','2014-04-09','17:05:00',9.17),('7643','2014-04-09','17:10:00',8.66),('7643','2014-04-09','17:15:00',8.17),('7643','2014-04-09','17:20:00',7.98),('7643','2014-04-09','17:25:00',7.51),('7643','2014-04-09','17:30:00',7.08),('7643','2014-04-09','17:35:00',6.67),('7643','2014-04-09','17:40:00',6.26),('7643','2014-04-09','17:45:00',5.87),('7643','2014-04-09','17:50:00',5.45),('7643','2014-04-09','17:55:00',5),('7643','2014-04-09','18:00:00',4.56),('7643','2014-04-09','18:05:00',4.14),('7643','2014-04-09','18:10:00',3.73),('7643','2014-04-09','18:15:00',3.31),('7643','2014-04-09','18:20:00',2.96),('7643','2014-04-09','18:25:00',2.62),('7643','2014-04-09','18:30:00',2.27),('7643','2014-04-09','18:35:00',1.88),('7643','2014-04-09','18:40:00',1.61),('7643','2014-04-09','18:45:00',1.31),('7643','2013-08-18','07:15:00',1.21),('7643','2013-08-18','07:20:00',1.55),('7643','2013-08-18','07:25:00',1.71),('7643','2013-08-18','07:30:00',1.98),('7643','2013-08-18','07:35:00',1.87),('7643','2013-08-18','07:40:00',2.71),('7643','2013-08-18','07:45:00',2.69),('7643','2013-08-18','07:50:00',2.89),('7643','2013-08-18','07:55:00',3.2),('7643','2013-08-18','08:00:00',3.5),('7643','2013-08-18','08:05:00',3.79),('7643','2013-08-18','08:10:00',4.01),('7643','2013-08-18','08:15:00',4.31),('7643','2013-08-18','08:20:00',4.67),('7643','2013-08-18','08:25:00',5),('7643','2013-08-18','08:30:00',5.26),('7643','2013-08-18','08:35:00',5.47),('7643','2013-08-18','08:40:00',5.79),('7643','2013-08-18','08:45:00',6.17),('7643','2013-08-18','08:50:00',6.54),('7643','2013-08-18','08:55:00',6.88),('7643','2013-08-18','09:00:00',7.19),('7643','2013-08-18','09:05:00',7.47),('7643','2013-08-18','09:10:00',7.71),('7643','2013-08-18','09:15:00',7.92),('7643','2013-08-18','09:20:00',8.21),('7643','2013-08-18','09:25:00',8.41),('7643','2013-08-18','09:30:00',8.68),('7643','2013-08-18','09:35:00',8.99),('7643','2013-08-18','09:40:00',9.17),('7643','2013-08-18','09:45:00',9.41),('7643','2013-08-18','09:50:00',9.67),('7643','2013-08-18','09:55:00',9.93),('7643','2013-08-18','10:00:00',10.18),('7643','2013-08-18','10:05:00',10.35),('7643','2013-08-18','10:10:00',10.57),('7643','2013-08-18','10:15:00',10.67),('7643','2013-08-18','10:20:00',10.91),('7643','2013-08-18','10:25:00',11.1),('7643','2013-08-18','10:30:00',11.26),('7643','2013-08-18','10:35:00',11.51),('7643','2013-08-18','10:40:00',11.64),('7643','2013-08-18','10:45:00',11.9),('7643','2013-08-18','10:50:00',11.97),('7643','2013-08-18','10:55:00',12.14),('7643','2013-08-18','11:00:00',12.25),('7643','2013-08-18','11:05:00',12.3),('7643','2013-08-18','11:10:00',12.54),('7643','2013-08-18','11:15:00',12.58),('7643','2013-08-18','11:20:00',12.53),('7643','2013-08-18','11:25:00',12.45),('7643','2013-08-18','11:30:00',12.86),('7643','2013-08-18','11:35:00',12.75),('7643','2013-08-18','11:40:00',13.12),('7643','2013-08-18','11:45:00',13.2),('7643','2013-08-18','11:50:00',13.29),('7643','2013-08-18','11:55:00',13.38),('7643','2013-08-18','12:00:00',13.29),('7643','2013-08-18','12:05:00',13.41),('7643','2013-08-18','12:10:00',13.58),('7643','2013-08-18','12:15:00',13.79),('7643','2013-08-18','12:20:00',13.96),('7643','2013-08-18','12:25:00',13.88),('7643','2013-08-18','12:30:00',13.83),('7643','2013-08-18','12:35:00',14.03),('7643','2013-08-18','12:40:00',13.98),('7643','2013-08-18','12:45:00',14.19),('7643','2013-08-18','12:50:00',14.26),('7643','2013-08-18','12:55:00',14.35),('7643','2013-08-18','13:00:00',14.34),('7643','2013-08-18','13:05:00',14.48),('7643','2013-08-18','13:10:00',14.46),('7643','2013-08-18','13:15:00',14.39),('7643','2013-08-18','13:20:00',14.52),('7643','2013-08-18','13:25:00',14.49),('7643','2013-08-18','13:30:00',14.44),('7643','2013-08-18','13:35:00',14.45),('7643','2013-08-18','13:40:00',14.29),('7643','2013-08-18','13:45:00',14.35),('7643','2013-08-18','13:50:00',14.34),('7643','2013-08-18','13:55:00',14.32),('7643','2013-08-18','14:00:00',14.19),('7643','2013-08-18','14:05:00',14.11),('7643','2013-08-18','14:10:00',14.17),('7643','2013-08-18','14:15:00',14.08),('7643','2013-08-18','14:20:00',14.06),('7643','2013-08-18','14:25:00',13.96),('7643','2013-08-18','14:30:00',13.78),('7643','2013-08-18','14:35:00',13.77),('7643','2013-08-18','14:40:00',13.69),('7643','2013-08-18','14:45:00',13.58),('7643','2013-08-18','14:50:00',13.47),('7643','2013-08-18','14:55:00',13.36),('7643','2013-08-18','15:00:00',13.2),('7643','2013-08-18','15:05:00',13.05),('7643','2013-08-18','15:10:00',12.94),('7643','2013-08-18','15:15:00',12.83),('7643','2013-08-18','15:20:00',12.67),('7643','2013-08-18','15:25:00',12.45),('7643','2013-08-18','15:30:00',12.27),('7643','2013-08-18','15:35:00',12.07),('7643','2013-08-18','15:40:00',11.92),('7643','2013-08-18','15:45:00',11.7),('7643','2013-08-18','15:50:00',11.52),('7643','2013-08-18','15:55:00',11.31),('7643','2013-08-18','16:00:00',11.09),('7643','2013-08-18','16:05:00',10.9),('7643','2013-08-18','16:10:00',10.69),('7643','2013-08-18','16:15:00',10.51),('7643','2013-08-18','16:20:00',10.24),('7643','2013-08-18','16:25:00',9.91),('7643','2013-08-18','16:30:00',9.7),('7643','2013-08-18','16:35:00',9.46),('7643','2013-08-18','16:40:00',9.21),('7643','2013-08-18','16:45:00',8.96),('7643','2013-08-18','16:50:00',8.72),('7643','2013-08-18','16:55:00',8.43),('7643','2013-08-18','17:00:00',8.12),('7643','2013-08-18','17:05:00',7.84),('7643','2013-08-18','17:10:00',7.52),('7643','2013-08-18','17:15:00',7.25),('7643','2013-08-18','17:20:00',6.95),('7643','2013-08-18','17:25:00',6.65),('7643','2013-08-18','17:30:00',6.33),('7643','2013-08-18','17:35:00',6.04),('7643','2013-08-18','17:40:00',5.77),('7643','2013-08-18','17:45:00',5.41),('7643','2013-08-18','17:50:00',5.05),('7643','2013-08-18','17:55:00',4.74),('7643','2013-08-18','18:00:00',4.36),('7643','2013-08-18','18:05:00',4.01),('7643','2013-08-18','18:10:00',3.72),('7643','2013-08-18','18:15:00',3.35),('7643','2013-08-18','18:20:00',3.05),('7643','2013-08-18','18:25:00',2.79),('7643','2013-08-18','18:30:00',2.47),('7643','2013-08-18','18:35:00',2.15),('7643','2013-08-18','18:40:00',1.96),('7643','2013-08-18','18:45:00',1.72),('7643','2013-08-18','18:50:00',1.47),('7643','2013-08-18','18:55:00',1.2),('7643','2013-08-17','07:15:00',1.12),('7643','2013-08-17','07:20:00',1.33),('7643','2013-08-17','07:25:00',1.57),('7643','2013-08-17','07:30:00',1.83),('7643','2013-08-17','07:35:00',2.06),('7643','2013-08-17','07:40:00',2.34),('7643','2013-08-17','07:45:00',2.65),('7643','2013-08-17','07:50:00',2.97),('7643','2013-08-17','07:55:00',3.29),('7643','2013-08-17','08:00:00',3.6),('7643','2013-08-17','08:05:00',3.91),('7643','2013-08-17','08:10:00',4.23),('7643','2013-08-17','08:15:00',4.57),('7643','2013-08-17','08:20:00',4.9),('7643','2013-08-17','08:25:00',5.21),('7643','2013-08-17','08:30:00',5.5),('7643','2013-08-17','08:35:00',5.81),('7643','2013-08-17','08:40:00',6.14),('7643','2013-08-17','08:45:00',6.37),('7643','2013-08-17','08:50:00',6.69),('7643','2013-08-17','08:55:00',6.97),('7643','2013-08-17','09:00:00',7.25),('7643','2013-08-17','09:05:00',7.59),('7643','2013-08-17','09:10:00',7.91),('7643','2013-08-17','09:15:00',8.23),('7643','2013-08-17','09:20:00',8.5),('7643','2013-08-17','09:25:00',8.78),('7643','2013-08-17','09:30:00',9.08),('7643','2013-08-17','09:35:00',9.27),('7643','2013-08-17','09:40:00',9.66),('7643','2013-08-17','09:45:00',9.69),('7643','2013-08-17','09:50:00',9.31),('7643','2013-08-17','09:55:00',7.4),('7643','2013-08-17','10:00:00',10.42),('7643','2013-08-17','10:05:00',9.32),('7643','2013-08-17','10:10:00',9.67),('7643','2013-08-17','10:15:00',10.95),('7643','2013-08-17','10:20:00',11.06),('7643','2013-08-17','10:25:00',11.17),('7643','2013-08-17','10:30:00',11.34),('7643','2013-08-17','10:35:00',11.48),('7643','2013-08-17','10:40:00',11.65),('7643','2013-08-17','10:45:00',11.66),('7643','2013-08-17','10:50:00',11.76),('7643','2013-08-17','10:55:00',12.1),('7643','2013-08-17','11:00:00',12.22),('7643','2013-08-17','11:05:00',12.36),('7643','2013-08-17','11:10:00',12.3),('7643','2013-08-17','11:15:00',12.47),('7643','2013-08-17','11:20:00',12.71),('7643','2013-08-17','11:25:00',12.63),('7643','2013-08-17','11:30:00',12.68),('7643','2013-08-17','11:35:00',13.03),('7643','2013-08-17','11:40:00',13.25),('7643','2013-08-17','11:45:00',13.19),('7643','2013-08-17','11:50:00',13.32),('7643','2013-08-17','11:55:00',13.49),('7643','2013-08-17','12:00:00',13.54),('7643','2013-08-17','12:05:00',13.96),('7643','2013-08-17','12:10:00',13.76),('7643','2013-08-17','12:15:00',13.95),('7643','2013-08-17','12:20:00',13.99),('7643','2013-08-17','12:25:00',14.3),('7643','2013-08-17','12:30:00',14.57),('7643','2013-08-17','12:35:00',12.6),('7643','2013-08-17','12:40:00',5.92),('7643','2013-08-17','12:45:00',6.79),('7643','2013-08-17','12:50:00',4.81),('7643','2013-08-17','12:55:00',3.84),('7643','2013-08-17','13:00:00',4.43),('7643','2013-08-17','13:05:00',14.87),('7643','2013-08-17','13:10:00',7.91),('7643','2013-08-17','13:15:00',14.6),('7643','2013-08-17','13:20:00',12.44),('7643','2013-08-17','13:25:00',14.84),('7643','2013-08-17','13:30:00',14.64),('7643','2013-08-17','13:35:00',14.55),('7643','2013-08-17','13:40:00',14.48),('7643','2013-08-17','13:45:00',14.32),('7643','2013-08-17','13:50:00',14.3),('7643','2013-08-17','13:55:00',14.19),('7643','2013-08-17','14:00:00',14.17),('7643','2013-08-17','14:05:00',14.29),('7643','2013-08-17','14:10:00',14.01),('7643','2013-08-17','14:15:00',13.98),('7643','2013-08-17','14:20:00',13.97),('7643','2013-08-17','14:25:00',13.77),('7643','2013-08-17','14:30:00',13.8),('7643','2013-08-17','14:35:00',13.77),('7643','2013-08-17','14:40:00',13.66),('7643','2013-08-17','14:45:00',13.58),('7643','2013-08-17','14:50:00',13.41),('7643','2013-08-17','14:55:00',13.28),('7643','2013-08-17','15:00:00',13.13),('7643','2013-08-17','15:05:00',13.05),('7643','2013-08-17','15:10:00',12.91),('7643','2013-08-17','15:15:00',12.83),('7643','2013-08-17','15:20:00',12.6),('7643','2013-08-17','15:25:00',12.41),('7643','2013-08-17','15:30:00',12.24),('7643','2013-08-17','15:35:00',12.03),('7643','2013-08-17','15:40:00',11.83),('7643','2013-08-17','15:45:00',11.67),('7643','2013-08-17','15:50:00',11.52),('7643','2013-08-17','15:55:00',11.3),('7643','2013-08-17','16:00:00',11.04),('7643','2013-08-17','16:05:00',10.83),('7643','2013-08-17','16:10:00',10.63),('7643','2013-08-17','16:15:00',10.39),('7643','2013-08-17','16:20:00',10.15),('7643','2013-08-17','16:25:00',9.9),('7643','2013-08-17','16:30:00',9.69),('7643','2013-08-17','16:35:00',9.47),('7643','2013-08-17','16:40:00',9.19),('7643','2013-08-17','16:45:00',8.96),('7643','2013-08-17','16:50:00',8.71),('7643','2013-08-17','16:55:00',8.46),('7643','2013-08-17','17:00:00',8.2),('7643','2013-08-17','17:05:00',7.89),('7643','2013-08-17','17:10:00',7.58),('7643','2013-08-17','17:15:00',7.31),('7643','2013-08-17','17:20:00',7.05),('7643','2013-08-17','17:25:00',6.76),('7643','2013-08-17','17:30:00',6.44),('7643','2013-08-17','17:35:00',6.12),('7643','2013-08-17','17:40:00',5.79),('7643','2013-08-17','17:45:00',5.4),('7643','2013-08-17','17:50:00',5.04),('7643','2013-08-17','17:55:00',4.73),('7643','2013-08-17','18:00:00',4.36),('7643','2013-08-17','18:05:00',4.08),('7643','2013-08-17','18:10:00',3.76),('7643','2013-08-17','18:15:00',3.46),('7643','2013-08-17','18:20:00',3.17),('7643','2013-08-17','18:25:00',2.85),('7643','2013-08-17','18:30:00',2.51),('7643','2013-08-17','18:35:00',2.27),('7643','2013-08-17','18:40:00',2.03),('7643','2013-08-17','18:45:00',1.77),('7643','2013-08-17','18:50:00',1.54),('7643','2013-08-17','18:55:00',1.28),('7643','2013-08-17','19:00:00',1.02),('7643','2013-08-16','07:15:00',1.12),('7643','2013-08-16','07:20:00',1.34),('7643','2013-08-16','07:25:00',1.56),('7643','2013-08-16','07:30:00',1.8),('7643','2013-08-16','07:35:00',2.02),('7643','2013-08-16','07:40:00',2.29),('7643','2013-08-16','07:45:00',2.58),('7643','2013-08-16','07:50:00',2.9),('7643','2013-08-16','07:55:00',3.22),('7643','2013-08-16','08:00:00',3.49),('7643','2013-08-16','08:05:00',3.75),('7643','2013-08-16','08:10:00',4.06),('7643','2013-08-16','08:15:00',4.38),('7643','2013-08-16','08:20:00',4.67),('7643','2013-08-16','08:25:00',4.98),('7643','2013-08-16','08:30:00',5.28),('7643','2013-08-16','08:35:00',5.6),('7643','2013-08-16','08:40:00',5.97),('7643','2013-08-16','08:45:00',6.26),('7643','2013-08-16','08:50:00',6.59),('7643','2013-08-16','08:55:00',6.92),('7643','2013-08-16','09:00:00',7.23),('7643','2013-08-16','09:05:00',7.56),('7643','2013-08-16','09:10:00',7.86),('7643','2013-08-16','09:15:00',8.07),('7643','2013-08-16','09:20:00',8.37),('7643','2013-08-16','09:25:00',8.68),('7643','2013-08-16','09:30:00',8.93),('7643','2013-08-16','09:35:00',9.18),('7643','2013-08-16','09:40:00',9.44),('7643','2013-08-16','09:45:00',9.62),('7643','2013-08-16','09:50:00',9.89),('7643','2013-08-16','09:55:00',10.12),('7643','2013-08-16','10:00:00',10.36),('7643','2013-08-16','10:05:00',10.57),('7643','2013-08-16','10:10:00',10.74),('7643','2013-08-16','10:15:00',10.95),('7643','2013-08-16','10:20:00',11.14),('7643','2013-08-16','10:25:00',11.31),('7643','2013-08-16','10:30:00',11.44),('7643','2013-08-16','10:35:00',11.61),('7643','2013-08-16','10:40:00',11.74),('7643','2013-08-16','10:45:00',11.89),('7643','2013-08-16','10:50:00',12.19),('7643','2013-08-16','10:55:00',12.38),('7643','2013-08-16','11:00:00',12.41),('7643','2013-08-16','11:05:00',12.45),('7643','2013-08-16','11:10:00',12.61),('7643','2013-08-16','11:15:00',12.86),('7643','2013-08-16','11:20:00',12.89),('7643','2013-08-16','11:25:00',13.01),('7643','2013-08-16','11:30:00',12.98),('7643','2013-08-16','11:35:00',13.11),('7643','2013-08-16','11:40:00',13.18),('7643','2013-08-16','11:45:00',13.46),('7643','2013-08-16','11:50:00',13.72),('7643','2013-08-16','11:55:00',13.64),('7643','2013-08-16','12:00:00',13.57),('7643','2013-08-16','12:05:00',13.35),('7643','2013-08-16','12:10:00',13.8),('7643','2013-08-16','12:15:00',14.16),('7643','2013-08-16','12:20:00',14.26),('7643','2013-08-16','12:25:00',12.46),('7643','2013-08-16','12:30:00',3.85),('7643','2013-08-16','12:35:00',14.14),('7643','2013-08-16','12:40:00',14.9),('7643','2013-08-16','12:45:00',14.47),('7643','2013-08-16','12:50:00',14.31),('7643','2013-08-16','12:55:00',14.49),('7643','2013-08-16','13:00:00',14.49),('7643','2013-08-16','13:05:00',14.53),('7643','2013-08-16','13:10:00',14.69),('7643','2013-08-16','13:15:00',14.22),('7643','2013-08-16','13:20:00',14.39),('7643','2013-08-16','13:25:00',14.93),('7643','2013-08-16','13:30:00',14.97),('7643','2013-08-16','13:35:00',15.11),('7643','2013-08-16','13:40:00',10.96),('7643','2013-08-16','13:45:00',5.92),('7643','2013-08-16','13:50:00',15.38),('7643','2013-08-16','13:55:00',8.99),('7643','2013-08-16','14:00:00',14.16),('7643','2013-08-16','14:05:00',14.56),('7643','2013-08-16','14:10:00',14.34),('7643','2013-08-16','14:15:00',13.89),('7643','2013-08-16','14:20:00',14.35),('7643','2013-08-16','14:25:00',14.07),('7643','2013-08-16','14:30:00',13.93),('7643','2013-08-16','14:35:00',13.62),('7643','2013-08-16','14:40:00',13.68),('7643','2013-08-16','14:45:00',13.46),('7643','2013-08-16','14:50:00',13.43),('7643','2013-08-16','14:55:00',13.14),('7643','2013-08-16','15:00:00',13.15),('7643','2013-08-16','15:05:00',13.07),('7643','2013-08-16','15:10:00',12.84),('7643','2013-08-16','15:15:00',12.52),('7643','2013-08-16','15:20:00',12.52),('7643','2013-08-16','15:25:00',12.33),('7643','2013-08-16','15:30:00',12.27),('7643','2013-08-16','15:35:00',12.06),('7643','2013-08-16','15:40:00',11.88),('7643','2013-08-16','15:45:00',11.7),('7643','2013-08-16','15:50:00',11.48),('7643','2013-08-16','15:55:00',11.33),('7643','2013-08-16','16:00:00',11.1),('7643','2013-08-16','16:05:00',10.9),('7643','2013-08-16','16:10:00',10.78),('7643','2013-08-16','16:15:00',10.59),('7643','2013-08-16','16:20:00',10.21),('7643','2013-08-16','16:25:00',10.15),('7643','2013-08-16','16:30:00',9.54),('7643','2013-08-16','16:35:00',9.56),('7643','2013-08-16','16:40:00',9.48),('7643','2013-08-16','16:45:00',9.13),('7643','2013-08-16','16:50:00',8.69),('7643','2013-08-16','16:55:00',8.63),('7643','2013-08-16','17:00:00',8.39),('7643','2013-08-16','17:05:00',7.99),('7643','2013-08-16','17:10:00',7.66),('7643','2013-08-16','17:15:00',6.7),('7643','2013-08-16','17:20:00',6.91),('7643','2013-08-16','17:25:00',6.98),('7643','2013-08-16','17:30:00',6.81),('7643','2013-08-16','17:35:00',6.54),('7643','2013-08-16','17:40:00',6.2),('7643','2013-08-16','17:45:00',5.84),('7643','2013-08-16','17:50:00',5.44),('7643','2013-08-16','17:55:00',5.07),('7643','2013-08-16','18:00:00',4.65),('7643','2013-08-16','18:05:00',4.37),('7643','2013-08-16','18:10:00',4.02),('7643','2013-08-16','18:15:00',3.72),('7643','2013-08-16','18:20:00',3.4),('7643','2013-08-16','18:25:00',3.04),('7643','2013-08-16','18:30:00',2.67),('7643','2013-08-16','18:35:00',2.42),('7643','2013-08-16','18:40:00',2.15),('7643','2013-08-16','18:45:00',1.89),('7643','2013-08-16','18:50:00',1.63),('7643','2013-08-16','18:55:00',1.34),('7643','2013-08-16','19:00:00',1.07),('7643','2013-08-15','07:15:00',1.16),('7643','2013-08-15','07:20:00',1.37),('7643','2013-08-15','07:25:00',1.62),('7643','2013-08-15','07:30:00',1.85),('7643','2013-08-15','07:35:00',2.09),('7643','2013-08-15','07:40:00',2.36),('7643','2013-08-15','07:45:00',2.64),('7643','2013-08-15','07:50:00',2.94),('7643','2013-08-15','07:55:00',3.25),('7643','2013-08-15','08:00:00',3.55),('7643','2013-08-15','08:05:00',3.86),('7643','2013-08-15','08:10:00',4.19),('7643','2013-08-15','08:15:00',4.53),('7643','2013-08-15','08:20:00',4.85),('7643','2013-08-15','08:25:00',5.19),('7643','2013-08-15','08:30:00',5.51),('7643','2013-08-15','08:35:00',5.83),('7643','2013-08-15','08:40:00',6.14),('7643','2013-08-15','08:45:00',6.36),('7643','2013-08-15','08:50:00',6.69),('7643','2013-08-15','08:55:00',7.08),('7643','2013-08-15','09:00:00',7.4),('7643','2013-08-15','09:05:00',7.74),('7643','2013-08-15','09:10:00',8.02),('7643','2013-08-15','09:15:00',8.38),('7643','2013-08-15','09:20:00',8.68),('7643','2013-08-15','09:25:00',8.96),('7643','2013-08-15','09:30:00',9.22),('7643','2013-08-15','09:35:00',9.52),('7643','2013-08-15','09:40:00',9.8),('7643','2013-08-15','09:45:00',10.01),('7643','2013-08-15','09:50:00',10.28),('7643','2013-08-15','09:55:00',10.51),('7643','2013-08-15','10:00:00',10.76),('7643','2013-08-15','10:05:00',10.99),('7643','2013-08-15','10:10:00',11.21),('7643','2013-08-15','10:15:00',11.4),('7643','2013-08-15','10:20:00',11.56),('7643','2013-08-15','10:25:00',11.75),('7643','2013-08-15','10:30:00',11.96),('7643','2013-08-15','10:35:00',12.15),('7643','2013-08-15','10:40:00',12.32),('7643','2013-08-15','10:45:00',12.43),('7643','2013-08-15','10:50:00',12.59),('7643','2013-08-15','10:55:00',12.77),('7643','2013-08-15','11:00:00',12.87),('7643','2013-08-15','11:05:00',13.02),('7643','2013-08-15','11:10:00',13.18),('7643','2013-08-15','11:15:00',13.31),('7643','2013-08-15','11:20:00',13.39),('7643','2013-08-15','11:25:00',13.42),('7643','2013-08-15','11:30:00',13.54),('7643','2013-08-15','11:35:00',13.72),('7643','2013-08-15','11:40:00',13.81),('7643','2013-08-15','11:45:00',13.87),('7643','2013-08-15','11:50:00',13.86),('7643','2013-08-15','11:55:00',13.99),('7643','2013-08-15','12:00:00',14.12),('7643','2013-08-15','12:05:00',14.25),('7643','2013-08-15','12:10:00',14.25),('7643','2013-08-15','12:15:00',14.28),('7643','2013-08-15','12:20:00',14.29),('7643','2013-08-15','12:25:00',14.38),('7643','2013-08-15','12:30:00',14.41),('7643','2013-08-15','12:35:00',14.41),('7643','2013-08-15','12:40:00',14.37),('7643','2013-08-15','12:45:00',14.51),('7643','2013-08-15','12:50:00',14.59),('7643','2013-08-15','12:55:00',14.58),('7643','2013-08-15','13:00:00',14.56),('7643','2013-08-15','13:05:00',14.45),('7643','2013-08-15','13:10:00',14.47),('7643','2013-08-15','13:15:00',14.54),('7643','2013-08-15','13:20:00',14.5),('7643','2013-08-15','13:25:00',14.4),('7643','2013-08-15','13:30:00',14.3),('7643','2013-08-15','13:35:00',14.28),('7643','2013-08-15','13:40:00',14.23),('7643','2013-08-15','13:45:00',14.15),('7643','2013-08-15','13:50:00',14.24),('7643','2013-08-15','13:55:00',14.19),('7643','2013-08-15','14:00:00',14.11),('7643','2013-08-15','14:05:00',14.11),('7643','2013-08-15','14:10:00',14.08),('7643','2013-08-15','14:15:00',13.97),('7643','2013-08-15','14:20:00',13.86),('7643','2013-08-15','14:25:00',13.76),('7643','2013-08-15','14:30:00',13.71),('7643','2013-08-15','14:35:00',13.56),('7643','2013-08-15','14:40:00',13.37),('7643','2013-08-15','14:45:00',13.32),('7643','2013-08-15','14:50:00',13.25),('7643','2013-08-15','14:55:00',13.05),('7643','2013-08-15','15:00:00',12.83),('7643','2013-08-15','15:05:00',12.51),('7643','2013-08-15','15:10:00',12.48),('7643','2013-08-15','15:15:00',12.52),('7643','2013-08-15','15:20:00',12.43),('7643','2013-08-15','15:25:00',12.39),('7643','2013-08-15','15:30:00',12.27),('7643','2013-08-15','15:35:00',12.09),('7643','2013-08-15','15:40:00',11.89),('7643','2013-08-15','15:45:00',11.75),('7643','2013-08-15','15:50:00',11.57),('7643','2013-08-15','15:55:00',11.41),('7643','2013-08-15','16:00:00',11.27),('7643','2013-08-15','16:05:00',11.02),('7643','2013-08-15','16:10:00',10.75),('7643','2013-08-15','16:15:00',10.52),('7643','2013-08-15','16:20:00',10.32),('7643','2013-08-15','16:25:00',10.13),('7643','2013-08-15','16:30:00',9.87),('7643','2013-08-15','16:35:00',9.61),('7643','2013-08-15','16:40:00',9.4),('7643','2013-08-15','16:45:00',9.12),('7643','2013-08-15','16:50:00',8.8),('7643','2013-08-15','16:55:00',8.52),('7643','2013-08-15','17:00:00',8.24),('7643','2013-08-15','17:05:00',7.99),('7643','2013-08-15','17:10:00',7.68),('7643','2013-08-15','17:15:00',7.32),('7643','2013-08-15','17:20:00',7.02),('7643','2013-08-15','17:25:00',6.72),('7643','2013-08-15','17:30:00',6.42),('7643','2013-08-15','17:35:00',6.11),('7643','2013-08-15','17:40:00',5.76),('7643','2013-08-15','17:45:00',5.4),('7643','2013-08-15','17:50:00',5.07),('7643','2013-08-15','17:55:00',4.66),('7643','2013-08-15','18:00:00',4.32),('7643','2013-08-15','18:05:00',4.11),('7643','2013-08-15','18:10:00',3.79),('7643','2013-08-15','18:15:00',3.5),('7643','2013-08-15','18:20:00',3.22),('7643','2013-08-15','18:25:00',2.91),('7643','2013-08-15','18:30:00',2.5),('7643','2013-08-15','18:35:00',1.77),('7643','2013-08-15','18:40:00',1.33),('7643','2013-08-15','18:50:00',1.41),('7643','2013-08-15','18:55:00',1.26),('7643','2013-08-15','19:00:00',1.06),('7643','2013-08-14','07:35:00',1.05),('7643','2013-08-14','07:40:00',1.27),('7643','2013-08-14','07:45:00',1.74),('7643','2013-08-14','07:50:00',2.19),('7643','2013-08-14','07:55:00',2.56),('7643','2013-08-14','08:00:00',4.57),('7643','2013-08-14','08:05:00',4.77),('7643','2013-08-14','08:10:00',4.76),('7643','2013-08-14','08:15:00',4.56),('7643','2013-08-14','08:20:00',5.11),('7643','2013-08-14','08:25:00',5.36),('7643','2013-08-14','08:30:00',5.68),('7643','2013-08-14','08:35:00',5.98),('7643','2013-08-14','08:40:00',6.3),('7643','2013-08-14','08:45:00',6.55),('7643','2013-08-14','08:50:00',7.02),('7643','2013-08-14','08:55:00',7.21),('7643','2013-08-14','09:00:00',7.61),('7643','2013-08-14','09:05:00',7.09),('7643','2013-08-14','09:10:00',4.25),('7643','2013-08-14','09:15:00',5.76),('7643','2013-08-14','09:20:00',9.29),('7643','2013-08-14','09:25:00',9.12),('7643','2013-08-14','09:30:00',9.29),('7643','2013-08-14','09:35:00',9.55),('7643','2013-08-14','09:40:00',9.84),('7643','2013-08-14','09:45:00',10.08),('7643','2013-08-14','09:50:00',10.4),('7643','2013-08-14','09:55:00',10.63),('7643','2013-08-14','10:00:00',10.85),('7643','2013-08-14','10:05:00',11.06),('7643','2013-08-14','10:10:00',11.22),('7643','2013-08-14','10:15:00',11.46),('7643','2013-08-14','10:20:00',11.72),('7643','2013-08-14','10:25:00',11.94),('7643','2013-08-14','10:30:00',12.14),('7643','2013-08-14','10:35:00',12.28),('7643','2013-08-14','10:40:00',12.51),('7643','2013-08-14','10:45:00',12.51),('7643','2013-08-14','10:50:00',12.27),('7643','2013-08-14','10:55:00',12.64),('7643','2013-08-14','11:00:00',11.28),('7643','2013-08-14','11:05:00',8.92),('7643','2013-08-14','11:10:00',8.99),('7643','2013-08-14','11:15:00',10.36),('7643','2013-08-14','11:20:00',11.52),('7643','2013-08-14','11:25:00',12.26),('7643','2013-08-14','11:30:00',13.34),('7643','2013-08-14','11:35:00',13.99),('7643','2013-08-14','11:40:00',14.86),('7643','2013-08-14','11:45:00',15.07),('7643','2013-08-14','11:50:00',15.42),('7643','2013-08-14','11:55:00',15.28),('7643','2013-08-14','12:00:00',15.26),('7643','2013-08-14','12:05:00',15.26),('7643','2013-08-14','12:10:00',15.11),('7643','2013-08-14','12:15:00',15.18),('7643','2013-08-14','12:20:00',15.19),('7643','2013-08-14','12:25:00',15.2),('7643','2013-08-14','12:30:00',15.09),('7643','2013-08-14','12:35:00',15.21),('7643','2013-08-14','12:40:00',15.13),('7643','2013-08-14','12:45:00',15.19),('7643','2013-08-14','12:50:00',15.05),('7643','2013-08-14','12:55:00',14.68),('7643','2013-08-14','13:00:00',14.71),('7643','2013-08-14','13:05:00',14.33),('7643','2013-08-14','13:10:00',14.25),('7643','2013-08-14','13:15:00',14),('7643','2013-08-14','13:20:00',14.47),('7643','2013-08-14','13:25:00',14.94),('7643','2013-08-14','13:30:00',15),('7643','2013-08-14','13:35:00',14.96),('7643','2013-08-14','13:40:00',14.84),('7643','2013-08-14','13:45:00',14.65),('7643','2013-08-14','13:50:00',14.46),('7643','2013-08-14','13:55:00',14.6),('7643','2013-08-14','14:00:00',14.71),('7643','2013-08-14','14:05:00',14.6),('7643','2013-08-14','14:10:00',14.48),('7643','2013-08-14','14:15:00',14.42),('7643','2013-08-14','14:20:00',14.21),('7643','2013-08-14','14:25:00',13.67),('7643','2013-08-14','14:30:00',13.42),('7643','2013-08-14','14:35:00',13.77),('7643','2013-08-14','14:40:00',13.61),('7643','2013-08-14','14:45:00',13.41),('7643','2013-08-14','14:50:00',13.35),('7643','2013-08-14','14:55:00',13.25),('7643','2013-08-14','15:00:00',13.09),('7643','2013-08-14','15:05:00',12.88),('7643','2013-08-14','15:10:00',12.67),('7643','2013-08-14','15:15:00',12.53),('7643','2013-08-14','15:20:00',12.37),('7643','2013-08-14','15:25:00',12.02),('7643','2013-08-14','15:30:00',12.01),('7643','2013-08-14','15:35:00',11.94),('7643','2013-08-14','15:40:00',11.69),('7643','2013-08-14','15:45:00',11.46),('7643','2013-08-14','15:50:00',11.17),('7643','2013-08-14','15:55:00',11.14),('7643','2013-08-14','16:00:00',10.96),('7643','2013-08-14','16:05:00',10.72),('7643','2013-08-14','16:10:00',10.33),('7643','2013-08-14','16:15:00',10.04),('7643','2013-08-14','16:20:00',10.15),('7643','2013-08-14','16:25:00',9.83),('7643','2013-08-14','16:30:00',9.3),('7643','2013-08-14','16:35:00',9),('7643','2013-08-14','16:40:00',9.03),('7643','2013-08-14','16:45:00',8.78),('7643','2013-08-14','16:50:00',8.42),('7643','2013-08-14','16:55:00',8.12),('7643','2013-08-14','17:00:00',7.9),('7643','2013-08-14','17:05:00',7.65),('7643','2013-08-14','17:10:00',7.28),('7643','2013-08-14','17:15:00',4.88),('7643','2013-08-14','17:20:00',6.49),('7643','2013-08-14','17:25:00',6.68),('7643','2013-08-14','17:30:00',6.4),('7643','2013-08-14','17:35:00',6.03),('7643','2013-08-14','17:40:00',5.64),('7643','2013-08-14','17:45:00',5.44),('7643','2013-08-14','17:50:00',5.12),('7643','2013-08-14','17:55:00',4.72),('7643','2013-08-14','18:00:00',4.39),('7643','2013-08-14','18:05:00',4.1),('7643','2013-08-14','18:10:00',3.73),('7643','2013-08-14','18:15:00',3.43),('7643','2013-08-14','18:20:00',3.23),('7643','2013-08-14','18:25:00',2.95),('7643','2013-08-14','18:30:00',2.66),('7643','2013-08-14','18:35:00',2.44),('7643','2013-08-14','18:40:00',2.29),('7643','2013-08-14','18:45:00',1.87),('7643','2013-08-14','18:50:00',1.16),('7643','2013-08-14','18:55:00',1.03),('7643','2013-08-13','07:15:00',1.14),('7643','2013-08-13','07:20:00',1.39),('7643','2013-08-13','07:25:00',1.65),('7643','2013-08-13','07:30:00',1.89),('7643','2013-08-13','07:35:00',2.13),('7643','2013-08-13','07:40:00',2.43),('7643','2013-08-13','07:45:00',2.7),('7643','2013-08-13','07:50:00',3.05),('7643','2013-08-13','07:55:00',3.38),('7643','2013-08-13','08:00:00',3.63),('7643','2013-08-13','08:05:00',3.9),('7643','2013-08-13','08:10:00',4.27),('7643','2013-08-13','08:15:00',4.57),('7643','2013-08-13','08:20:00',4.49),('7643','2013-08-13','08:25:00',5.05),('7643','2013-08-13','08:30:00',5.41),('7643','2013-08-13','08:35:00',5.72),('7643','2013-08-13','08:40:00',6.17),('7643','2013-08-13','08:45:00',6.29),('7643','2013-08-13','08:50:00',5.55),('7643','2013-08-13','08:55:00',6.55),('7643','2013-08-13','09:00:00',7.42),('7643','2013-08-13','09:05:00',7.66),('7643','2013-08-13','09:10:00',7.88),('7643','2013-08-13','09:15:00',8.35),('7643','2013-08-13','09:20:00',8.69),('7643','2013-08-13','09:25:00',8.28),('7643','2013-08-13','09:30:00',9.24),('7643','2013-08-13','09:35:00',9.51),('7643','2013-08-13','09:40:00',3.92),('7643','2013-08-13','09:45:00',3.64),('7643','2013-08-13','09:50:00',6.72),('7643','2013-08-13','09:55:00',9.38),('7643','2013-08-13','10:00:00',7.19),('7643','2013-08-13','10:05:00',10.87),('7643','2013-08-13','10:10:00',10.34),('7643','2013-08-13','10:15:00',5.8),('7643','2013-08-13','10:20:00',3.46),('7643','2013-08-13','10:25:00',3.66),('7643','2013-08-13','10:30:00',9.32),('7643','2013-08-13','10:35:00',13.14),('7643','2013-08-13','10:40:00',13.2),('7643','2013-08-13','10:45:00',12.94),('7643','2013-08-13','10:50:00',8.75),('7643','2013-08-13','10:55:00',4.89),('7643','2013-08-13','11:00:00',8.67),('7643','2013-08-13','11:05:00',12.28),('7643','2013-08-13','11:10:00',12.76),('7643','2013-08-13','11:15:00',12.59),('7643','2013-08-13','11:20:00',11.85),('7643','2013-08-13','11:25:00',9.73),('7643','2013-08-13','11:30:00',14.05),('7643','2013-08-13','11:35:00',13.79),('7643','2013-08-13','11:40:00',13.64),('7643','2013-08-13','11:45:00',12.47),('7643','2013-08-13','11:50:00',12.78),('7643','2013-08-13','11:55:00',13.26),('7643','2013-08-13','12:00:00',10.44),('7643','2013-08-13','12:05:00',6.74),('7643','2013-08-13','12:10:00',7.52),('7643','2013-08-13','12:15:00',8.72),('7643','2013-08-13','12:20:00',4.29),('7643','2013-08-13','12:25:00',4.59),('7643','2013-08-13','12:30:00',4.41),('7643','2013-08-13','12:35:00',4.38),('7643','2013-08-13','12:40:00',4.61),('7643','2013-08-13','12:45:00',7.37),('7643','2013-08-13','12:50:00',8.7),('7643','2013-08-13','12:55:00',5.94),('7643','2013-08-13','13:00:00',8.18),('7643','2013-08-13','13:05:00',4.3),('7643','2013-08-13','13:10:00',4.2),('7643','2013-08-13','13:15:00',3.4),('7643','2013-08-13','13:20:00',3.22),('7643','2013-08-13','13:25:00',9.55),('7643','2013-08-13','13:30:00',11.59),('7643','2013-08-13','13:35:00',12.3),('7643','2013-08-13','13:40:00',12.64),('7643','2013-08-13','13:45:00',16.13),('7643','2013-08-13','13:50:00',15.95),('7643','2013-08-13','13:55:00',16.42),('7643','2013-08-13','14:00:00',14.96),('7643','2013-08-13','14:05:00',15.43),('7643','2013-08-13','14:10:00',15.41),('7643','2013-08-13','14:15:00',15.02),('7643','2013-08-13','14:20:00',14.67),('7643','2013-08-13','14:25:00',14.85),('7643','2013-08-13','14:30:00',11.02),('7643','2013-08-13','14:35:00',13.18),('7643','2013-08-13','14:40:00',14.27),('7643','2013-08-13','14:45:00',13.91),('7643','2013-08-13','14:50:00',13.5),('7643','2013-08-13','14:55:00',13.71),('7643','2013-08-13','15:00:00',13.83),('7643','2013-08-13','15:05:00',13.25),('7643','2013-08-13','15:10:00',13.41),('7643','2013-08-13','15:15:00',13.28),('7643','2013-08-13','15:20:00',12.27),('7643','2013-08-13','15:25:00',12.56),('7643','2013-08-13','15:30:00',12.54),('7643','2013-08-13','15:35:00',12.27),('7643','2013-08-13','15:40:00',12.18),('7643','2013-08-13','15:45:00',11.99),('7643','2013-08-13','15:50:00',11.89),('7643','2013-08-13','15:55:00',11.53),('7643','2013-08-13','16:00:00',11.26),('7643','2013-08-13','16:05:00',11.13),('7643','2013-08-13','16:10:00',11.05),('7643','2013-08-13','16:15:00',10.87),('7643','2013-08-13','16:20:00',10.73),('7643','2013-08-13','16:25:00',10.3),('7643','2013-08-13','16:30:00',10.16),('7643','2013-08-13','16:35:00',9.93),('7643','2013-08-13','16:40:00',9.6),('7643','2013-08-13','16:45:00',9.36),('7643','2013-08-13','16:50:00',9.08),('7643','2013-08-13','16:55:00',8.84),('7643','2013-08-13','17:00:00',8.53),('7643','2013-08-13','17:05:00',8.23),('7643','2013-08-13','17:10:00',7.93),('7643','2013-08-13','17:15:00',7.66),('7643','2013-08-13','17:20:00',7.34),('7643','2013-08-13','17:25:00',7.03),('7643','2013-08-13','17:30:00',6.71),('7643','2013-08-13','17:35:00',6.42),('7643','2013-08-13','17:40:00',6.06),('7643','2013-08-13','17:45:00',5.69),('7643','2013-08-13','17:50:00',5.36),('7643','2013-08-13','17:55:00',5.03),('7643','2013-08-13','18:00:00',4.65),('7643','2013-08-13','18:05:00',4.42),('7643','2013-08-13','18:10:00',4.05),('7643','2013-08-13','18:15:00',3.74),('7643','2013-08-13','18:20:00',3.74),('7643','2013-08-13','18:25:00',3.61),('7643','2013-08-13','18:30:00',3.19),('7643','2013-08-13','18:35:00',2.82),('7643','2013-08-13','18:40:00',2.55),('7643','2013-08-13','18:45:00',2.59),('7643','2013-08-13','18:50:00',2.55),('7643','2013-08-13','18:55:00',2.31),('7643','2013-08-13','19:00:00',2.11),('7643','2013-08-13','19:05:00',1.59),('7643','2013-08-13','19:10:00',1.24),('7643','2013-08-12','07:10:00',1.09),('7643','2013-08-12','07:15:00',1.29),('7643','2013-08-12','07:20:00',1.47),('7643','2013-08-12','07:25:00',1.72),('7643','2013-08-12','07:30:00',1.99),('7643','2013-08-12','07:35:00',2.23),('7643','2013-08-12','07:40:00',2.5),('7643','2013-08-12','07:45:00',2.76),('7643','2013-08-12','07:50:00',3.12),('7643','2013-08-12','07:55:00',3.45),('7643','2013-08-12','08:00:00',3.7),('7643','2013-08-12','08:05:00',4.08),('7643','2013-08-12','08:10:00',4.29),('7643','2013-08-12','08:15:00',4.64),('7643','2013-08-12','08:20:00',4.91),('7643','2013-08-12','08:25:00',5.27),('7643','2013-08-12','08:30:00',5.6),('7643','2013-08-12','08:35:00',5.94),('7643','2013-08-12','08:40:00',6.24),('7643','2013-08-12','08:45:00',6.44),('7643','2013-08-12','08:50:00',6.84),('7643','2013-08-12','08:55:00',7.12),('7643','2013-08-12','09:00:00',7.47),('7643','2013-08-12','09:05:00',7.73),('7643','2013-08-12','09:10:00',8.07),('7643','2013-08-12','09:15:00',8.36),('7643','2013-08-12','09:20:00',8.62),('7643','2013-08-12','09:25:00',8.94),('7643','2013-08-12','09:30:00',9.18),('7643','2013-08-12','09:35:00',7.82),('7643','2013-08-12','09:40:00',8.59),('7643','2013-08-12','09:45:00',9.84),('7643','2013-08-12','09:50:00',10.09),('7643','2013-08-12','09:55:00',9.84),('7643','2013-08-12','10:00:00',10.5),('7643','2013-08-12','10:05:00',10.77),('7643','2013-08-12','10:10:00',11.03),('7643','2013-08-12','10:15:00',11.21),('7643','2013-08-12','10:20:00',11.19),('7643','2013-08-12','10:25:00',11.3),('7643','2013-08-12','10:30:00',11.21),('7643','2013-08-12','10:35:00',11.58),('7643','2013-08-12','10:40:00',12.07),('7643','2013-08-12','10:45:00',12.17),('7643','2013-08-12','10:50:00',12.29),('7643','2013-08-12','10:55:00',12.4),('7643','2013-08-12','11:00:00',12.68),('7643','2013-08-12','11:05:00',12.76),('7643','2013-08-12','11:10:00',12.91),('7643','2013-08-12','11:15:00',12.96),('7643','2013-08-12','11:20:00',13.18),('7643','2013-08-12','11:25:00',13.26),('7643','2013-08-12','11:30:00',13.31),('7643','2013-08-12','11:35:00',13.29),('7643','2013-08-12','11:40:00',13.46),('7643','2013-08-12','11:45:00',13.37),('7643','2013-08-12','11:50:00',13.88),('7643','2013-08-12','11:55:00',14.16),('7643','2013-08-12','12:00:00',14.22),('7643','2013-08-12','12:05:00',14.34),('7643','2013-08-12','12:10:00',14.66),('7643','2013-08-12','12:15:00',14.61),('7643','2013-08-12','12:20:00',14.63),('7643','2013-08-12','12:25:00',15.13),('7643','2013-08-12','12:30:00',14.95),('7643','2013-08-12','12:35:00',15.13),('7643','2013-08-12','12:40:00',13.48),('7643','2013-08-12','12:45:00',6.75),('7643','2013-08-12','12:50:00',4.4),('7643','2013-08-12','12:55:00',5.94),('7643','2013-08-12','13:00:00',16.69),('7643','2013-08-12','13:05:00',12.73),('7643','2013-08-12','13:10:00',4.17),('7643','2013-08-12','13:15:00',8.99),('7643','2013-08-12','13:20:00',15.96),('7643','2013-08-12','13:25:00',16.39),('7643','2013-08-12','13:30:00',9.35),('7643','2013-08-12','13:35:00',15.19),('7643','2013-08-12','13:40:00',10.36),('7643','2013-08-12','13:45:00',10.93),('7643','2013-08-12','13:50:00',12.15),('7643','2013-08-12','13:55:00',16.5),('7643','2013-08-12','14:00:00',10.01),('7643','2013-08-12','14:05:00',12.88),('7643','2013-08-12','14:10:00',16.52),('7643','2013-08-12','14:15:00',12.27),('7643','2013-08-12','14:20:00',15.38),('7643','2013-08-12','14:25:00',6.36),('7643','2013-08-12','14:30:00',8.67),('7643','2013-08-12','14:35:00',16.22),('7643','2013-08-12','14:40:00',7.1),('7643','2013-08-12','14:45:00',8.15),('7643','2013-08-12','14:50:00',14.27),('7643','2013-08-12','14:55:00',15.57),('7643','2013-08-12','15:00:00',14.21),('7643','2013-08-12','15:05:00',10.82),('7643','2013-08-12','15:10:00',13.46),('7643','2013-08-12','15:15:00',8.34),('7643','2013-08-12','15:20:00',12.59),('7643','2013-08-12','15:25:00',13.18),('7643','2013-08-12','15:30:00',12.31),('7643','2013-08-12','15:35:00',12.55),('7643','2013-08-12','15:40:00',12.74),('7643','2013-08-12','15:45:00',12.14),('7643','2013-08-12','15:50:00',11.86),('7643','2013-08-12','15:55:00',11.59),('7643','2013-08-12','16:00:00',11.43),('7643','2013-08-12','16:05:00',11.21),('7643','2013-08-12','16:10:00',10.96),('7643','2013-08-12','16:15:00',10.73),('7643','2013-08-12','16:20:00',10.51),('7643','2013-08-12','16:25:00',10.31),('7643','2013-08-12','16:30:00',10.06),('7643','2013-08-12','16:35:00',9.8),('7643','2013-08-12','16:40:00',9.51),('7643','2013-08-12','16:45:00',9.24),('7643','2013-08-12','16:50:00',9.01),('7643','2013-08-12','16:55:00',8.73),('7643','2013-08-12','17:00:00',8.5),('7643','2013-08-12','17:05:00',8.25),('7643','2013-08-12','17:10:00',7.98),('7643','2013-08-12','17:15:00',7.66),('7643','2013-08-12','17:20:00',7.35),('7643','2013-08-12','17:25:00',7.09),('7643','2013-08-12','17:30:00',6.76),('7643','2013-08-12','17:35:00',6.42),('7643','2013-08-12','17:40:00',6.02),('7643','2013-08-12','17:45:00',5.69),('7643','2013-08-12','17:50:00',5.4),('7643','2013-08-12','17:55:00',5.02),('7643','2013-08-12','18:00:00',4.68),('7643','2013-08-12','18:05:00',4.39),('7643','2013-08-12','18:10:00',4.01),('7643','2013-08-12','18:15:00',3.73),('7643','2013-08-12','18:20:00',3.47),('7643','2013-08-12','18:25:00',3.13),('7643','2013-08-12','18:30:00',2.84),('7643','2013-08-12','18:35:00',2.56),('7643','2013-08-12','18:40:00',2.29),('7643','2013-08-12','18:45:00',2.03),('7643','2013-08-12','18:50:00',1.77),('7643','2013-08-12','18:55:00',1.51),('7643','2013-08-12','19:00:00',1.26),('7643','2013-08-12','19:05:00',1.05),('7643','2013-08-11','07:10:00',1.08),('7643','2013-08-11','07:15:00',1.28),('7643','2013-08-11','07:20:00',1.49),('7643','2013-08-11','07:25:00',1.72),('7643','2013-08-11','07:30:00',1.96),('7643','2013-08-11','07:35:00',2.23),('7643','2013-08-11','07:40:00',2.5),('7643','2013-08-11','07:45:00',2.77),('7643','2013-08-11','07:50:00',3.07),('7643','2013-08-11','07:55:00',3.4),('7643','2013-08-11','08:00:00',3.69),('7643','2013-08-11','08:05:00',4.01),('7643','2013-08-11','08:10:00',4.32),('7643','2013-08-11','08:15:00',4.62),('7643','2013-08-11','08:20:00',4.94),('7643','2013-08-11','08:25:00',5.25),('7643','2013-08-11','08:30:00',5.56),('7643','2013-08-11','08:35:00',5.86),('7643','2013-08-11','08:40:00',6.14),('7643','2013-08-11','08:45:00',6.38),('7643','2013-08-11','08:50:00',6.73),('7643','2013-08-11','08:55:00',7.05),('7643','2013-08-11','09:00:00',7.35),('7643','2013-08-11','09:05:00',7.6),('7643','2013-08-11','09:10:00',7.94),('7643','2013-08-11','09:15:00',8.2),('7643','2013-08-11','09:20:00',8.47),('7643','2013-08-11','09:25:00',8.77),('7643','2013-08-11','09:30:00',9.01),('7643','2013-08-11','09:35:00',9.28),('7643','2013-08-11','09:40:00',9.5),('7643','2013-08-11','09:45:00',9.71),('7643','2013-08-11','09:50:00',9.94),('7643','2013-08-11','09:55:00',10.19),('7643','2013-08-11','10:00:00',10.36),('7643','2013-08-11','10:05:00',10.56),('7643','2013-08-11','10:10:00',10.74),('7643','2013-08-11','10:15:00',10.94),('7643','2013-08-11','10:20:00',11.14),('7643','2013-08-11','10:25:00',11.37),('7643','2013-08-11','10:30:00',11.57),('7643','2013-08-11','10:35:00',11.72),('7643','2013-08-11','10:40:00',11.83),('7643','2013-08-11','10:45:00',11.95),('7643','2013-08-11','10:50:00',12.11),('7643','2013-08-11','10:55:00',12.3),('7643','2013-08-11','11:00:00',12.44),('7643','2013-08-11','11:05:00',12.52),('7643','2013-08-11','11:10:00',12.46),('7643','2013-08-11','11:15:00',12.82),('7643','2013-08-11','11:20:00',12.71),('7643','2013-08-11','11:25:00',12.98),('7643','2013-08-11','11:30:00',13.24),('7643','2013-08-11','11:35:00',13.37),('7643','2013-08-11','11:40:00',13.53),('7643','2013-08-11','11:45:00',13.6),('7643','2013-08-11','11:50:00',13.72),('7643','2013-08-11','11:55:00',13.8),('7643','2013-08-11','12:00:00',14.28),('7643','2013-08-11','12:05:00',14.36),('7643','2013-08-11','12:10:00',14.43),('7643','2013-08-11','12:15:00',13.11),('7643','2013-08-11','12:20:00',12.15),('7643','2013-08-11','12:25:00',6.36),('7643','2013-08-11','12:30:00',3.16),('7643','2013-08-11','12:35:00',3.48),('7643','2013-08-11','12:40:00',4.3),('7643','2013-08-11','12:45:00',6.07),('7643','2013-08-11','12:50:00',11.68),('7643','2013-08-11','12:55:00',5.3),('7643','2013-08-11','13:00:00',4.81),('7643','2013-08-11','13:05:00',3.07),('7643','2013-08-11','13:10:00',2.69),('7643','2013-08-11','13:15:00',2.65),('7643','2013-08-11','13:20:00',3.32),('7643','2013-08-11','13:25:00',7.39),('7643','2013-08-11','13:30:00',4.27),('7643','2013-08-11','13:35:00',4.69),('7643','2013-08-11','13:40:00',3.77),('7643','2013-08-11','13:45:00',3.54),('7643','2013-08-11','13:50:00',12.86),('7643','2013-08-11','13:55:00',8.48),('7643','2013-08-11','14:00:00',4.37),('7643','2013-08-11','14:05:00',3.45),('7643','2013-08-11','14:10:00',7.77),('7643','2013-08-11','14:15:00',6.09),('7643','2013-08-11','14:20:00',3.82),('7643','2013-08-11','14:25:00',3.05),('7643','2013-08-11','14:30:00',3.11),('7643','2013-08-11','14:35:00',3.77),('7643','2013-08-11','14:40:00',4.13),('7643','2013-08-11','14:45:00',4.96),('7643','2013-08-11','14:50:00',12.48),('7643','2013-08-11','14:55:00',15.82),('7643','2013-08-11','15:00:00',15.09),('7643','2013-08-11','15:05:00',14.51),('7643','2013-08-11','15:10:00',14.04),('7643','2013-08-11','15:15:00',10.52),('7643','2013-08-11','15:20:00',13.13),('7643','2013-08-11','15:25:00',13.2),('7643','2013-08-11','15:30:00',12.71),('7643','2013-08-11','15:35:00',12.23),('7643','2013-08-11','15:40:00',12.26),('7643','2013-08-11','15:45:00',11.86),('7643','2013-08-11','15:50:00',11.95),('7643','2013-08-11','15:55:00',11.72),('7643','2013-08-11','16:00:00',11.38),('7643','2013-08-11','16:05:00',11.19),('7643','2013-08-11','16:10:00',10.98),('7643','2013-08-11','16:15:00',10.7),('7643','2013-08-11','16:20:00',10.37),('7643','2013-08-11','16:25:00',10.17),('7643','2013-08-11','16:30:00',9.93),('7643','2013-08-11','16:35:00',9.79),('7643','2013-08-11','16:40:00',9.33),('7643','2013-08-11','16:45:00',9.15),('7643','2013-08-11','16:50:00',9.03),('7643','2013-08-11','16:55:00',7.93),('7643','2013-08-11','17:00:00',8.18),('7643','2013-08-11','17:05:00',8.12),('7643','2013-08-11','17:10:00',7.88),('7643','2013-08-11','17:15:00',7.53),('7643','2013-08-11','17:20:00',7.2),('7643','2013-08-11','17:25:00',6.92),('7643','2013-08-11','17:30:00',6.71),('7643','2013-08-11','17:35:00',6.32),('7643','2013-08-11','17:40:00',6.05),('7643','2013-08-11','17:45:00',5.71),('7643','2013-08-11','17:50:00',5.35),('7643','2013-08-11','17:55:00',4.95),('7643','2013-08-11','18:00:00',4.72),('7643','2013-08-11','18:05:00',4.48),('7643','2013-08-11','18:10:00',4.07),('7643','2013-08-11','18:15:00',3.79),('7643','2013-08-11','18:20:00',3.57),('7643','2013-08-11','18:25:00',3.32),('7643','2013-08-11','18:30:00',3.04),('7643','2013-08-11','18:35:00',2.76),('7643','2013-08-11','18:40:00',2.5),('7643','2013-08-11','18:45:00',2.26),('7643','2013-08-11','18:50:00',2.04),('7643','2013-08-11','18:55:00',1.74),('7643','2013-08-11','19:00:00',1.47),('7643','2013-08-11','19:05:00',1.25),('7643','2013-08-11','19:10:00',1.03),('7643','2013-08-10','07:10:00',1.09),('7643','2013-08-10','07:15:00',1.27),('7643','2013-08-10','07:20:00',1.51),('7643','2013-08-10','07:25:00',1.76),('7643','2013-08-10','07:30:00',1.97),('7643','2013-08-10','07:35:00',2.24),('7643','2013-08-10','07:40:00',2.52),('7643','2013-08-10','07:45:00',2.85),('7643','2013-08-10','07:50:00',3.19),('7643','2013-08-10','07:55:00',3.53),('7643','2013-08-10','08:00:00',3.84),('7643','2013-08-10','08:05:00',4.17),('7643','2013-08-10','08:10:00',4.47),('7643','2013-08-10','08:15:00',4.79),('7643','2013-08-10','08:20:00',5.11),('7643','2013-08-10','08:25:00',5.38),('7643','2013-08-10','08:30:00',5.7),('7643','2013-08-10','08:35:00',5.96),('7643','2013-08-10','08:40:00',6.29),('7643','2013-08-10','08:45:00',6.6),('7643','2013-08-10','08:50:00',6.91),('7643','2013-08-10','08:55:00',7.18),('7643','2013-08-10','09:00:00',7.52),('7643','2013-08-10','09:05:00',7.75),('7643','2013-08-10','09:10:00',8.08),('7643','2013-08-10','09:15:00',8.27),('7643','2013-08-10','09:20:00',8.59),('7643','2013-08-10','09:25:00',8.95),('7643','2013-08-10','09:30:00',9.16),('7643','2013-08-10','09:35:00',9.46),('7643','2013-08-10','09:40:00',9.73),('7643','2013-08-10','09:45:00',9.99),('7643','2013-08-10','09:50:00',10.22),('7643','2013-08-10','09:55:00',10.49),('7643','2013-08-10','10:00:00',10.71),('7643','2013-08-10','10:05:00',10.97),('7643','2013-08-10','10:10:00',11.23),('7643','2013-08-10','10:15:00',11.45),('7643','2013-08-10','10:20:00',11.62),('7643','2013-08-10','10:25:00',11.79),('7643','2013-08-10','10:30:00',12.07),('7643','2013-08-10','10:35:00',12.14),('7643','2013-08-10','10:40:00',12.31),('7643','2013-08-10','10:45:00',12.49),('7643','2013-08-10','10:50:00',12.71),('7643','2013-08-10','10:55:00',12.81),('7643','2013-08-10','11:00:00',13),('7643','2013-08-10','11:05:00',13.2),('7643','2013-08-10','11:10:00',13.33),('7643','2013-08-10','11:15:00',13.39),('7643','2013-08-10','11:20:00',13.51),('7643','2013-08-10','11:25:00',13.66),('7643','2013-08-10','11:30:00',13.74),('7643','2013-08-10','11:35:00',13.88),('7643','2013-08-10','11:40:00',14.02),('7643','2013-08-10','11:45:00',14.04),('7643','2013-08-10','11:50:00',14.21),('7643','2013-08-10','11:55:00',14.26),('7643','2013-08-10','12:00:00',14.18),('7643','2013-08-10','12:05:00',14.3),('7643','2013-08-10','12:10:00',14.45),('7643','2013-08-10','12:15:00',14.48),('7643','2013-08-10','12:20:00',14.46),('7643','2013-08-10','12:25:00',14.59),('7643','2013-08-10','12:30:00',14.69),('7643','2013-08-10','12:35:00',14.74),('7643','2013-08-10','12:40:00',14.6),('7643','2013-08-10','12:45:00',14.56),('7643','2013-08-10','12:50:00',14.61),('7643','2013-08-10','12:55:00',14.82),('7643','2013-08-10','13:00:00',14.86),('7643','2013-08-10','13:05:00',14.69),('7643','2013-08-10','13:10:00',14.64),('7643','2013-08-10','13:15:00',14.67),('7643','2013-08-10','13:20:00',14.62),('7643','2013-08-10','13:25:00',14.8),('7643','2013-08-10','13:30:00',14.85),('7643','2013-08-10','13:35:00',14.63),('7643','2013-08-10','13:40:00',14.49),('7643','2013-08-10','13:45:00',14.52),('7643','2013-08-10','13:50:00',14.48),('7643','2013-08-10','13:55:00',14.44),('7643','2013-08-10','14:00:00',14.43),('7643','2013-08-10','14:05:00',14.33),('7643','2013-08-10','14:10:00',14.33),('7643','2013-08-10','14:15:00',13.91),('7643','2013-08-10','14:20:00',13.69),('7643','2013-08-10','14:25:00',13.67),('7643','2013-08-10','14:30:00',13.61),('7643','2013-08-10','14:35:00',13.65),('7643','2013-08-10','14:40:00',13.71),('7643','2013-08-10','14:45:00',13.52),('7643','2013-08-10','14:50:00',13.19),('7643','2013-08-10','14:55:00',13.17),('7643','2013-08-10','15:00:00',13.25),('7643','2013-08-10','15:05:00',13),('7643','2013-08-10','15:10:00',12.85),('7643','2013-08-10','15:15:00',12.57),('7643','2013-08-10','15:20:00',12.6),('7643','2013-08-10','15:25:00',12.44),('7643','2013-08-10','15:30:00',12.35),('7643','2013-08-10','15:35:00',11.7),('7643','2013-08-10','15:40:00',11.77),('7643','2013-08-10','15:45:00',11.63),('7643','2013-08-10','15:50:00',11.73),('7643','2013-08-10','15:55:00',11.61),('7643','2013-08-10','16:00:00',11.37),('7643','2013-08-10','16:05:00',11.09),('7643','2013-08-10','16:10:00',10.87),('7643','2013-08-10','16:15:00',10.64),('7643','2013-08-10','16:20:00',10.37),('7643','2013-08-10','16:25:00',10.08),('7643','2013-08-10','16:30:00',9.94),('7643','2013-08-10','16:35:00',9.68),('7643','2013-08-10','16:40:00',9.4),('7643','2013-08-10','16:45:00',9.18),('7643','2013-08-10','16:50:00',8.9),('7643','2013-08-10','16:55:00',8.64),('7643','2013-08-10','17:00:00',8.35),('7643','2013-08-10','17:05:00',8.09),('7643','2013-08-10','17:10:00',7.79),('7643','2013-08-10','17:15:00',7.51),('7643','2013-08-10','17:20:00',7.25),('7643','2013-08-10','17:25:00',6.94),('7643','2013-08-10','17:30:00',6.68),('7643','2013-08-10','17:35:00',6.33),('7643','2013-08-10','17:40:00',5.96),('7643','2013-08-10','17:45:00',5.68),('7643','2013-08-10','17:50:00',5.33),('7643','2013-08-10','17:55:00',4.95),('7643','2013-08-10','18:00:00',4.67),('7643','2013-08-10','18:05:00',4.4),('7643','2013-08-10','18:10:00',3.97),('7643','2013-08-10','18:15:00',3.64),('7643','2013-08-10','18:20:00',3.46),('7643','2013-08-10','18:25:00',3.18),('7643','2013-08-10','18:30:00',2.92),('7643','2013-08-10','18:35:00',2.64),('7643','2013-08-10','18:40:00',2.37),('7643','2013-08-10','18:45:00',2.1),('7643','2013-08-10','18:50:00',1.85),('7643','2013-08-10','18:55:00',1.58),('7643','2013-08-10','19:00:00',1.32),('7643','2013-08-10','19:05:00',1.11),('7643','2013-08-09','07:10:00',1.13),('7643','2013-08-09','07:15:00',1.34),('7643','2013-08-09','07:20:00',1.57),('7643','2013-08-09','07:25:00',1.84),('7643','2013-08-09','07:30:00',2.05),('7643','2013-08-09','07:35:00',2.35),('7643','2013-08-09','07:40:00',2.65),('7643','2013-08-09','07:45:00',2.95),('7643','2013-08-09','07:50:00',3.25),('7643','2013-08-09','07:55:00',3.6),('7643','2013-08-09','08:00:00',3.96),('7643','2013-08-09','08:05:00',4.32),('7643','2013-08-09','08:10:00',4.61),('7643','2013-08-09','08:15:00',4.96),('7643','2013-08-09','08:20:00',5.32),('7643','2013-08-09','08:25:00',5.67),('7643','2013-08-09','08:30:00',5.99),('7643','2013-08-09','08:35:00',6.3),('7643','2013-08-09','08:40:00',6.56),('7643','2013-08-09','08:45:00',6.84),('7643','2013-08-09','08:50:00',7.16),('7643','2013-08-09','08:55:00',7.44),('7643','2013-08-09','09:00:00',7.7),('7643','2013-08-09','09:05:00',7.98),('7643','2013-08-09','09:10:00',8.24),('7643','2013-08-09','09:15:00',8.51),('7643','2013-08-09','09:20:00',8.87),('7643','2013-08-09','09:25:00',9.13),('7643','2013-08-09','09:30:00',7.37),('7643','2013-08-09','09:35:00',9.66),('7643','2013-08-09','09:40:00',9.95),('7643','2013-08-09','09:45:00',10.18),('7643','2013-08-09','09:50:00',10.37),('7643','2013-08-09','09:55:00',10.55),('7643','2013-08-09','10:00:00',10.79),('7643','2013-08-09','10:05:00',10.99),('7643','2013-08-09','10:10:00',11.22),('7643','2013-08-09','10:15:00',11.47),('7643','2013-08-09','10:20:00',11.66),('7643','2013-08-09','10:25:00',11.86),('7643','2013-08-09','10:30:00',12.01),('7643','2013-08-09','10:35:00',12.19),('7643','2013-08-09','10:40:00',12.36),('7643','2013-08-09','10:45:00',12.52),('7643','2013-08-09','10:50:00',12.63),('7643','2013-08-09','10:55:00',12.89),('7643','2013-08-09','11:00:00',13.27),('7643','2013-08-09','11:05:00',13.42),('7643','2013-08-09','11:10:00',13.99),('7643','2013-08-09','11:15:00',8.37),('7643','2013-08-09','11:20:00',13.24),('7643','2013-08-09','11:25:00',7.94),('7643','2013-08-09','11:30:00',11.42),('7643','2013-08-09','11:35:00',14.35),('7643','2013-08-09','11:40:00',14.21),('7643','2013-08-09','11:45:00',14.25),('7643','2013-08-09','11:50:00',14.26),('7643','2013-08-09','11:55:00',14.31),('7643','2013-08-09','12:00:00',14.5),('7643','2013-08-09','12:05:00',14.57),('7643','2013-08-09','12:10:00',14.54),('7643','2013-08-09','12:15:00',14.59),('7643','2013-08-09','12:20:00',14.67),('7643','2013-08-09','12:25:00',14.8),('7643','2013-08-09','12:30:00',14.83),('7643','2013-08-09','12:35:00',14.81),('7643','2013-08-09','12:40:00',14.96),('7643','2013-08-09','12:45:00',15.25),('7643','2013-08-09','12:50:00',15.51),('7643','2013-08-09','12:55:00',15.5),('7643','2013-08-09','13:00:00',15.3),('7643','2013-08-09','13:05:00',15.17),('7643','2013-08-09','13:10:00',15.26),('7643','2013-08-09','13:15:00',15.49),('7643','2013-08-09','13:20:00',15.7),('7643','2013-08-09','13:25:00',15.67),('7643','2013-08-09','13:30:00',15.06),('7643','2013-08-09','13:35:00',12.84),('7643','2013-08-09','13:40:00',4.29),('7643','2013-08-09','13:45:00',2.48),('7643','2013-08-09','13:50:00',16.24),('7643','2013-08-09','13:55:00',15.66),('7643','2013-08-09','14:00:00',12.67),('7643','2013-08-09','14:05:00',7.06),('7643','2013-08-09','14:10:00',11.6),('7643','2013-08-09','14:15:00',15.4),('7643','2013-08-09','14:20:00',9.67),('7643','2013-08-09','14:25:00',4.63),('7643','2013-08-09','14:30:00',4.6),('7643','2013-08-09','14:35:00',4.1),('7643','2013-08-09','14:40:00',3.78),('7643','2013-08-09','14:45:00',3.53),('7643','2013-08-09','14:50:00',3.24),('7643','2013-08-09','14:55:00',3.08),('7643','2013-08-09','15:00:00',3.44),('7643','2013-08-09','15:05:00',3.77),('7643','2013-08-09','15:10:00',4.02),('7643','2013-08-09','15:15:00',4.6),('7643','2013-08-09','15:20:00',4.69),('7643','2013-08-09','15:25:00',4.26),('7643','2013-08-09','15:30:00',4.07),('7643','2013-08-09','15:35:00',4.97),('7643','2013-08-09','15:40:00',4.86),('7643','2013-08-09','15:45:00',5.12),('7643','2013-08-09','15:50:00',6.05),('7643','2013-08-09','15:55:00',7.01),('7643','2013-08-09','16:00:00',6.91),('7643','2013-08-09','16:05:00',13.84),('7643','2013-08-09','16:10:00',7.62),('7643','2013-08-09','16:15:00',6.51),('7643','2013-08-09','16:20:00',10.03),('7643','2013-08-09','16:25:00',4.69),('7643','2013-08-09','16:30:00',6.24),('7643','2013-08-09','16:35:00',11.64),('7643','2013-08-09','16:40:00',10.73),('7643','2013-08-09','16:45:00',10.49),('7643','2013-08-09','16:50:00',9.9),('7643','2013-08-09','16:55:00',9.13),('7643','2013-08-09','17:00:00',8.79),('7643','2013-08-09','17:05:00',4.97),('7643','2013-08-09','17:10:00',3.07),('7643','2013-08-09','17:15:00',3.63),('7643','2013-08-09','17:20:00',3.87),('7643','2013-08-09','17:25:00',4.54),('7643','2013-08-09','17:30:00',2.42),('7643','2013-08-09','17:35:00',1.6),('7643','2013-08-09','17:40:00',1.51),('7643','2013-08-09','17:45:00',1.82),('7643','2013-08-09','17:50:00',2.16),('7643','2013-08-09','17:55:00',3.02),('7643','2013-08-09','18:00:00',2.76),('7643','2013-08-09','18:05:00',1.02),('7643','2013-08-09','18:10:00',1.08),('7643','2013-08-09','18:15:00',1.06),('7643','2013-08-09','18:20:00',1.4),('7643','2013-08-09','18:25:00',1.8),('7643','2013-08-09','18:30:00',1.47),('7643','2013-08-09','18:35:00',1.32),('7643','2014-04-08','07:30:00',1.14),('7643','2014-04-08','07:35:00',1.16),('7643','2014-04-08','07:40:00',1.45),('7643','2014-04-08','07:45:00',1.71),('7643','2014-04-08','07:50:00',1.38),('7643','2014-04-08','07:55:00',2.03),('7643','2014-04-08','08:00:00',3.26),('7643','2014-04-08','08:05:00',4.06),('7643','2014-04-08','08:10:00',3.82),('7643','2014-04-08','08:15:00',3.14),('7643','2014-04-08','08:20:00',4.72),('7643','2014-04-08','08:25:00',3.27),('7643','2014-04-08','08:30:00',2.99),('7643','2014-04-08','08:35:00',2.08),('7643','2014-04-08','08:40:00',1.09),('7643','2014-04-08','08:45:00',1.24),('7643','2014-04-08','08:50:00',1.76),('7643','2014-04-08','08:55:00',2.82),('7643','2014-04-08','09:00:00',3.51),('7643','2014-04-08','09:05:00',3.2),('7643','2014-04-08','09:10:00',3.08),('7643','2014-04-08','09:15:00',3.04),('7643','2014-04-08','09:20:00',3.13),('7643','2014-04-08','09:25:00',3.51),('7643','2014-04-08','09:30:00',3.78),('7643','2014-04-08','09:35:00',3.49),('7643','2014-04-08','09:40:00',3.6),('7643','2014-04-08','09:45:00',4.22),('7643','2014-04-08','09:50:00',8.06),('7643','2014-04-08','09:55:00',11.92),('7643','2014-04-08','10:00:00',11.72),('7643','2014-04-08','10:05:00',11.91),('7643','2014-04-08','10:10:00',12.22),('7643','2014-04-08','10:15:00',12.72),('7643','2014-04-08','10:20:00',12.87),('7643','2014-04-08','10:25:00',11.82),('7643','2014-04-08','10:30:00',13.64),('7643','2014-04-08','10:35:00',15.47),('7643','2014-04-08','10:40:00',6.8),('7643','2014-04-08','10:45:00',4.58),('7643','2014-04-08','10:50:00',3.71),('7643','2014-04-08','10:55:00',6.13),('7643','2014-04-08','11:00:00',16.65),('7643','2014-04-08','11:05:00',16),('7643','2014-04-08','11:10:00',16.11),('7643','2014-04-08','11:15:00',16.87),('7643','2014-04-08','11:20:00',15.46),('7643','2014-04-08','11:25:00',9.55),('7643','2014-04-08','11:30:00',5.77),('7643','2014-04-08','11:35:00',9.95),('7643','2014-04-08','11:40:00',17.76),('7643','2014-04-08','11:45:00',17.88),('7643','2014-04-08','11:50:00',16.62),('7643','2014-04-08','11:55:00',17.12),('7643','2014-04-08','12:00:00',17.76),('7643','2014-04-08','12:05:00',13.94),('7643','2014-04-08','12:10:00',7.58),('7643','2014-04-08','12:15:00',14.39),('7643','2014-04-08','12:20:00',8.07),('7643','2014-04-08','12:25:00',4.1),('7643','2014-04-08','12:30:00',3.28),('7643','2014-04-08','12:35:00',2.93),('7643','2014-04-08','12:40:00',2.72),('7643','2014-04-08','12:45:00',2.33),('7643','2014-04-08','12:50:00',2.15),('7643','2014-04-08','12:55:00',2.35),('7643','2014-04-08','13:00:00',2.25),('7643','2014-04-08','13:05:00',2.15),('7643','2014-04-08','13:10:00',2.36),('7643','2014-04-08','13:15:00',3.09),('7643','2014-04-08','13:20:00',4.8),('7643','2014-04-08','13:25:00',5.53),('7643','2014-04-08','13:30:00',4.79),('7643','2014-04-08','13:35:00',4.53),('7643','2014-04-08','13:40:00',4.31),('7643','2014-04-08','13:45:00',3.89),('7643','2014-04-08','13:50:00',3.32),('7643','2014-04-08','13:55:00',2.78),('7643','2014-04-08','14:00:00',3.4),('7643','2014-04-08','14:05:00',5.79),('7643','2014-04-08','14:10:00',6.77),('7643','2014-04-08','14:15:00',6.3),('7643','2014-04-08','14:20:00',7.08),('7643','2014-04-08','14:25:00',5.67),('7643','2014-04-08','14:30:00',7.6),('7643','2014-04-08','14:35:00',10.7),('7643','2014-04-08','14:40:00',7.48),('7643','2014-04-08','14:45:00',6.39),('7643','2014-04-08','14:50:00',9.36),('7643','2014-04-08','14:55:00',12.76),('7643','2014-04-08','15:00:00',13.78),('7643','2014-04-08','15:05:00',17.08),('7643','2014-04-08','15:10:00',13.28),('7643','2014-04-08','15:15:00',10.21),('7643','2014-04-08','15:20:00',13.71),('7643','2014-04-08','15:25:00',11.56),('7643','2014-04-08','15:30:00',11.63),('7643','2014-04-08','15:35:00',11.23),('7643','2014-04-08','15:40:00',8.41),('7643','2014-04-08','15:45:00',6.74),('7643','2014-04-08','15:50:00',7.91),('7643','2014-04-08','15:55:00',5.11),('7643','2014-04-08','16:00:00',5.28),('7643','2014-04-08','16:05:00',6.27),('7643','2014-04-08','16:10:00',9.93),('7643','2014-04-08','16:15:00',12.58),('7643','2014-04-08','16:20:00',12.28),('7643','2014-04-08','16:25:00',11.53),('7643','2014-04-08','16:30:00',11.75),('7643','2014-04-08','16:35:00',7.74),('7643','2014-04-08','16:40:00',6.19),('7643','2014-04-08','16:45:00',6.27),('7643','2014-04-08','16:50:00',8.61),('7643','2014-04-08','16:55:00',8.04),('7643','2014-04-08','17:00:00',7.4),('7643','2014-04-08','17:05:00',10.69),('7643','2014-04-08','17:10:00',9.05),('7643','2014-04-08','17:15:00',6.33),('7643','2014-04-08','17:20:00',7.84),('7643','2014-04-08','17:25:00',7.74),('7643','2014-04-08','17:30:00',5.37),('7643','2014-04-08','17:35:00',2.51),('7643','2014-04-08','17:40:00',2.66),('7643','2014-04-08','17:45:00',4.19),('7643','2014-04-08','17:50:00',4.39),('7643','2014-04-08','17:55:00',4.33),('7643','2014-04-08','18:00:00',3.83),('7643','2014-04-08','18:05:00',2.68),('7643','2014-04-08','18:10:00',2.57),('7643','2014-04-08','18:15:00',2.24),('7643','2014-04-08','18:20:00',1.42),('7643','2013-08-08','07:10:00',1.22),('7643','2013-08-08','07:15:00',1.5),('7643','2013-08-08','07:20:00',1.78),('7643','2013-08-08','07:25:00',2.13),('7643','2013-08-08','07:30:00',1.67),('7643','2013-08-08','07:35:00',1.96),('7643','2013-08-08','07:40:00',2.04),('7643','2013-08-08','07:45:00',1.64),('7643','2013-08-08','07:50:00',1.62),('7643','2013-08-08','07:55:00',1.87),('7643','2013-08-08','08:00:00',2.82),('7643','2013-08-08','08:05:00',4.44),('7643','2013-08-08','08:10:00',3.25),('7643','2013-08-08','08:15:00',3.09),('7643','2013-08-08','08:20:00',2.86),('7643','2013-08-08','08:25:00',2.88),('7643','2013-08-08','08:30:00',3.47),('7643','2013-08-08','08:35:00',4.09),('7643','2013-08-08','08:40:00',5.31),('7643','2013-08-08','08:45:00',6.17),('7643','2013-08-08','08:50:00',6.42),('7643','2013-08-08','08:55:00',6),('7643','2013-08-08','09:00:00',6.86),('7643','2013-08-08','09:05:00',7.58),('7643','2013-08-08','09:10:00',8.24),('7643','2013-08-08','09:15:00',6.81),('7643','2013-08-08','09:20:00',7.73),('7643','2013-08-08','09:25:00',5.2),('7643','2013-08-08','09:30:00',9.65),('7643','2013-08-08','09:35:00',8.78),('7643','2013-08-08','09:40:00',5.71),('7643','2013-08-08','09:45:00',9.06),('7643','2013-08-08','09:50:00',8.98),('7643','2013-08-08','09:55:00',6.72),('7643','2013-08-08','10:00:00',7.8),('7643','2013-08-08','10:05:00',7.75),('7643','2013-08-08','10:10:00',9.05),('7643','2013-08-08','10:15:00',10.39),('7643','2013-08-08','10:20:00',10.3),('7643','2013-08-08','10:25:00',8.97),('7643','2013-08-08','10:30:00',8.68),('7643','2013-08-08','10:35:00',11.23),('7643','2013-08-08','10:40:00',11.65),('7643','2013-08-08','10:45:00',11.65),('7643','2013-08-08','10:50:00',11.55),('7643','2013-08-08','10:55:00',11.98),('7643','2013-08-08','11:00:00',12.25),('7643','2013-08-08','11:05:00',12.3),('7643','2013-08-08','11:10:00',12.56),('7643','2013-08-08','11:15:00',12.56),('7643','2013-08-08','11:20:00',12.55),('7643','2013-08-08','11:25:00',12.59),('7643','2013-08-08','11:30:00',12.81),('7643','2013-08-08','11:35:00',13.02),('7643','2013-08-08','11:40:00',13.06),('7643','2013-08-08','11:45:00',13.04),('7643','2013-08-08','11:50:00',13.22),('7643','2013-08-08','11:55:00',13.36),('7643','2013-08-08','12:00:00',13.51),('7643','2013-08-08','12:05:00',13.46),('7643','2013-08-08','12:10:00',13.48),('7643','2013-08-08','12:15:00',13.67),('7643','2013-08-08','12:20:00',14.17),('7643','2013-08-08','12:25:00',12.73),('7643','2013-08-08','12:30:00',9.89),('7643','2013-08-08','12:35:00',12.27),('7643','2013-08-08','12:40:00',15.51),('7643','2013-08-08','12:45:00',9.35),('7643','2013-08-08','12:50:00',9.15),('7643','2013-08-08','12:55:00',10.74),('7643','2013-08-08','13:00:00',4.71),('7643','2013-08-08','13:05:00',3.23),('7643','2013-08-08','13:10:00',3.04),('7643','2013-08-08','13:15:00',3.66),('7643','2013-08-08','13:20:00',5.13),('7643','2013-08-08','13:25:00',9.96),('7643','2013-08-08','13:30:00',6.98),('7643','2013-08-08','13:35:00',5.66),('7643','2013-08-08','13:40:00',5.51),('7643','2013-08-08','13:45:00',5.23),('7643','2013-08-08','13:50:00',5.47),('7643','2013-08-08','13:55:00',4.63),('7643','2013-08-08','14:00:00',4.32),('7643','2013-08-08','14:05:00',5.14),('7643','2013-08-08','14:10:00',4.82),('7643','2013-08-08','14:15:00',3.54),('7643','2013-08-08','14:20:00',3.33),('7643','2013-08-08','14:25:00',3.97),('7643','2013-08-08','14:30:00',3.87),('7643','2013-08-08','14:35:00',2.91),('7643','2013-08-08','14:40:00',2.04),('7643','2013-08-08','14:45:00',1.42),('7643','2013-08-08','14:50:00',1.06),('7643','2013-08-08','14:55:00',1.08),('7643','2013-08-08','15:00:00',1.93),('7643','2013-08-08','15:05:00',5.35),('7643','2013-08-08','15:10:00',10.11),('7643','2013-08-08','15:15:00',8.96),('7643','2013-08-08','15:20:00',5.65),('7643','2013-08-08','15:25:00',4.51),('7643','2013-08-08','15:30:00',4.22),('7643','2013-08-08','15:35:00',8.03),('7643','2013-08-08','15:40:00',5.75),('7643','2013-08-08','15:45:00',12.82),('7643','2013-08-08','15:50:00',8),('7643','2013-08-08','15:55:00',8.42),('7643','2013-08-08','16:00:00',4.07),('7643','2013-08-08','16:05:00',2.64),('7643','2013-08-08','16:10:00',2.34),('7643','2013-08-08','16:15:00',2.65),('7643','2013-08-08','16:20:00',2.73),('7643','2013-08-08','16:25:00',3.02),('7643','2013-08-08','16:30:00',2.16),('7643','2013-08-08','16:35:00',2.24),('7643','2013-08-08','16:40:00',2.43),('7643','2013-08-08','16:45:00',3.04),('7643','2013-08-08','16:50:00',5.05),('7643','2013-08-08','16:55:00',7.02),('7643','2013-08-08','17:00:00',5.66),('7643','2013-08-08','17:05:00',6.54),('7643','2013-08-08','17:10:00',3.41),('7643','2013-08-08','17:15:00',2.6),('7643','2013-08-08','17:20:00',2.32),('7643','2013-08-08','17:25:00',2.63),('7643','2013-08-08','17:30:00',3.1),('7643','2013-08-08','17:35:00',3.14),('7643','2013-08-08','17:40:00',2.95),('7643','2013-08-08','17:45:00',2.8),('7643','2013-08-08','17:50:00',2.13),('7643','2013-08-08','17:55:00',1.49),('7643','2013-08-08','18:00:00',1.2),('7643','2013-08-08','18:05:00',1.05),('7643','2013-08-08','18:10:00',1.2),('7643','2013-08-08','18:15:00',1.74),('7643','2013-08-08','18:20:00',1.79),('7643','2013-08-08','18:25:00',1.37),('7643','2013-08-08','18:55:00',1.3),('7643','2013-08-08','19:00:00',1.91),('7643','2013-08-08','19:05:00',2.67),('7643','2013-08-08','19:10:00',2.8),('7643','2013-08-08','19:15:00',2.99),('7643','2013-08-08','19:20:00',3.54),('7643','2013-08-08','19:25:00',3.28),('7643','2013-08-08','19:30:00',1.56),('7643','2013-08-08','19:35:00',1.19),('7643','2013-08-07','07:10:00',1.1),('7643','2013-08-07','07:15:00',1.29),('7643','2013-08-07','07:20:00',1.47),('7643','2013-08-07','07:25:00',1.67),('7643','2013-08-07','07:30:00',1.89),('7643','2013-08-07','07:35:00',2.12),('7643','2013-08-07','07:40:00',2.36),('7643','2013-08-07','07:45:00',2.63),('7643','2013-08-07','07:50:00',2.94),('7643','2013-08-07','07:55:00',3.2),('7643','2013-08-07','08:00:00',3.53),('7643','2013-08-07','08:05:00',3.81),('7643','2013-08-07','08:10:00',4.13),('7643','2013-08-07','08:15:00',4.43),('7643','2013-08-07','08:20:00',4.71),('7643','2013-08-07','08:25:00',5.07),('7643','2013-08-07','08:30:00',5.34),('7643','2013-08-07','08:35:00',5.65),('7643','2013-08-07','08:40:00',5.88),('7643','2013-08-07','08:45:00',6.1),('7643','2013-08-07','08:50:00',6.39),('7643','2013-08-07','08:55:00',6.64),('7643','2013-08-07','09:00:00',6.99),('7643','2013-08-07','09:05:00',7.27),('7643','2013-08-07','09:10:00',7.61),('7643','2013-08-07','09:15:00',7.9),('7643','2013-08-07','09:20:00',8.18),('7643','2013-08-07','09:25:00',8.44),('7643','2013-08-07','09:30:00',8.68),('7643','2013-08-07','09:35:00',8.99),('7643','2013-08-07','09:40:00',9.35),('7643','2013-08-07','09:45:00',9.51),('7643','2013-08-07','09:50:00',9.74),('7643','2013-08-07','09:55:00',10),('7643','2013-08-07','10:00:00',10.15),('7643','2013-08-07','10:05:00',10.35),('7643','2013-08-07','10:10:00',10.54),('7643','2013-08-07','10:15:00',10.72),('7643','2013-08-07','10:20:00',10.88),('7643','2013-08-07','10:25:00',11.04),('7643','2013-08-07','10:30:00',11.23),('7643','2013-08-07','10:35:00',11.4),('7643','2013-08-07','10:40:00',11.6),('7643','2013-08-07','10:45:00',11.73),('7643','2013-08-07','10:50:00',11.88),('7643','2013-08-07','10:55:00',12.01),('7643','2013-08-07','11:00:00',12.25),('7643','2013-08-07','11:05:00',12.36),('7643','2013-08-07','11:10:00',12.45),('7643','2013-08-07','11:15:00',12.57),('7643','2013-08-07','11:20:00',12.66),('7643','2013-08-07','11:25:00',12.66),('7643','2013-08-07','11:30:00',12.76),('7643','2013-08-07','11:35:00',12.83),('7643','2013-08-07','11:40:00',12.89),('7643','2013-08-07','11:45:00',12.96),('7643','2013-08-07','11:50:00',12.99),('7643','2013-08-07','11:55:00',13.18),('7643','2013-08-07','12:00:00',13.26),('7643','2013-08-07','12:05:00',13.42),('7643','2013-08-07','12:10:00',13.21),('7643','2013-08-07','12:15:00',13.42),('7643','2013-08-07','12:20:00',13.53),('7643','2013-08-07','12:25:00',13.61),('7643','2013-08-07','12:30:00',13.6),('7643','2013-08-07','12:35:00',13.49),('7643','2013-08-07','12:40:00',13.78),('7643','2013-08-07','12:45:00',13.94),('7643','2013-08-07','12:50:00',14.1),('7643','2013-08-07','12:55:00',14.08),('7643','2013-08-07','13:00:00',14.05),('7643','2013-08-07','13:05:00',13.87),('7643','2013-08-07','13:10:00',14.03),('7643','2013-08-07','13:15:00',14.15),('7643','2013-08-07','13:20:00',14),('7643','2013-08-07','13:25:00',14.07),('7643','2013-08-07','13:30:00',14.14),('7643','2013-08-07','13:35:00',14.06),('7643','2013-08-07','13:40:00',14.01),('7643','2013-08-07','13:45:00',13.99),('7643','2013-08-07','13:50:00',13.89),('7643','2013-08-07','13:55:00',13.77),('7643','2013-08-07','14:00:00',13.81),('7643','2013-08-07','14:05:00',13.77),('7643','2013-08-07','14:10:00',13.67),('7643','2013-08-07','14:15:00',13.51),('7643','2013-08-07','14:20:00',13.35),('7643','2013-08-07','14:25:00',13.4),('7643','2013-08-07','14:30:00',13.36),('7643','2013-08-07','14:35:00',13.19),('7643','2013-08-07','14:40:00',13.05),('7643','2013-08-07','14:45:00',12.83),('7643','2013-08-07','14:50:00',12.86),('7643','2013-08-07','14:55:00',12.61),('7643','2013-08-07','15:00:00',12.55),('7643','2013-08-07','15:05:00',12.38),('7643','2013-08-07','15:10:00',12.28),('7643','2013-08-07','15:15:00',12.09),('7643','2013-08-07','15:20:00',12),('7643','2013-08-07','15:25:00',11.89),('7643','2013-08-07','15:30:00',11.72),('7643','2013-08-07','15:35:00',11.55),('7643','2013-08-07','15:40:00',11.48),('7643','2013-08-07','15:45:00',11.33),('7643','2013-08-07','15:50:00',11.09),('7643','2013-08-07','15:55:00',10.89),('7643','2013-08-07','16:00:00',10.77),('7643','2013-08-07','16:05:00',10.69),('7643','2013-08-07','16:10:00',10.55),('7643','2013-08-07','16:15:00',10.38),('7643','2013-08-07','16:20:00',10.21),('7643','2013-08-07','16:25:00',9.96),('7643','2013-08-07','16:30:00',9.71),('7643','2013-08-07','16:35:00',9.51),('7643','2013-08-07','16:40:00',9.35),('7643','2013-08-07','16:45:00',9.02),('7643','2013-08-07','16:50:00',8.77),('7643','2013-08-07','16:55:00',8.49),('7643','2013-08-07','17:00:00',8.23),('7643','2013-08-07','17:05:00',7.95),('7643','2013-08-07','17:10:00',7.65),('7643','2013-08-07','17:15:00',7.32),('7643','2013-08-07','17:20:00',6.99),('7643','2013-08-07','17:25:00',6.72),('7643','2013-08-07','17:30:00',6.38),('7643','2013-08-07','17:35:00',6.06),('7643','2013-08-07','17:40:00',5.76),('7643','2013-08-07','17:45:00',5.5),('7643','2013-08-07','17:50:00',5.19),('7643','2013-08-07','17:55:00',4.87),('7643','2013-08-07','18:00:00',4.61),('7643','2013-08-07','18:05:00',4.26),('7643','2013-08-07','18:10:00',3.98),('7643','2013-08-07','18:15:00',3.75),('7643','2013-08-07','18:20:00',3.43),('7643','2013-08-07','18:25:00',3.13),('7643','2013-08-07','18:30:00',2.89),('7643','2013-08-07','18:35:00',2.62),('7643','2013-08-07','18:40:00',2.39),('7643','2013-08-07','18:45:00',2.14),('7643','2013-08-07','18:50:00',1.88),('7643','2013-08-07','18:55:00',1.63),('7643','2013-08-07','19:00:00',1.39),('7643','2013-08-07','19:05:00',1.21),('7643','2013-08-07','19:10:00',1.04),('7643','2013-08-06','07:05:00',1.02),('7643','2013-08-06','07:10:00',1.2),('7643','2013-08-06','07:15:00',1.39),('7643','2013-08-06','07:20:00',1.6),('7643','2013-08-06','07:25:00',1.83),('7643','2013-08-06','07:30:00',2.05),('7643','2013-08-06','07:35:00',2.27),('7643','2013-08-06','07:40:00',2.5),('7643','2013-08-06','07:45:00',2.77),('7643','2013-08-06','07:50:00',3.09),('7643','2013-08-06','07:55:00',3.37),('7643','2013-08-06','08:00:00',3.67),('7643','2013-08-06','08:05:00',4),('7643','2013-08-06','08:10:00',4.33),('7643','2013-08-06','08:15:00',4.63),('7643','2013-08-06','08:20:00',4.95),('7643','2013-08-06','08:25:00',5.29),('7643','2013-08-06','08:30:00',5.57),('7643','2013-08-06','08:35:00',5.83),('7643','2013-08-06','08:40:00',6.15),('7643','2013-08-06','08:45:00',6.48),('7643','2013-08-06','08:50:00',6.8),('7643','2013-08-06','08:55:00',7.05),('7643','2013-08-06','09:00:00',7.34),('7643','2013-08-06','09:05:00',7.61),('7643','2013-08-06','09:10:00',7.89),('7643','2013-08-06','09:15:00',8.18),('7643','2013-08-06','09:20:00',8.35),('7643','2013-08-06','09:25:00',8.55),('7643','2013-08-06','09:30:00',8.89),('7643','2013-08-06','09:35:00',9.11),('7643','2013-08-06','09:40:00',9.52),('7643','2013-08-06','09:45:00',9.73),('7643','2013-08-06','09:50:00',10.03),('7643','2013-08-06','09:55:00',10.14),('7643','2013-08-06','10:00:00',10.28),('7643','2013-08-06','10:05:00',10.47),('7643','2013-08-06','10:10:00',10.71),('7643','2013-08-06','10:15:00',10.93),('7643','2013-08-06','10:20:00',11.15),('7643','2013-08-06','10:25:00',11.32),('7643','2013-08-06','10:30:00',11.51),('7643','2013-08-06','10:35:00',11.63),('7643','2013-08-06','10:40:00',11.73),('7643','2013-08-06','10:45:00',11.92),('7643','2013-08-06','10:50:00',12.05),('7643','2013-08-06','10:55:00',12.13),('7643','2013-08-06','11:00:00',12.27),('7643','2013-08-06','11:05:00',12.43),('7643','2013-08-06','11:10:00',12.52),('7643','2013-08-06','11:15:00',12.71),('7643','2013-08-06','11:20:00',12.75),('7643','2013-08-06','11:25:00',12.88),('7643','2013-08-06','11:30:00',12.99),('7643','2013-08-06','11:35:00',13.04),('7643','2013-08-06','11:40:00',13.06),('7643','2013-08-06','11:45:00',13.2),('7643','2013-08-06','11:50:00',13.18),('7643','2013-08-06','11:55:00',13.22),('7643','2013-08-06','12:00:00',13.43),('7643','2013-08-06','12:05:00',13.64),('7643','2013-08-06','12:10:00',13.74),('7643','2013-08-06','12:15:00',13.84),('7643','2013-08-06','12:20:00',13.59),('7643','2013-08-06','12:25:00',13.67),('7643','2013-08-06','12:30:00',13.66),('7643','2013-08-06','12:35:00',13.74),('7643','2013-08-06','12:40:00',13.8),('7643','2013-08-06','12:45:00',13.6),('7643','2013-08-06','12:50:00',14.01),('7643','2013-08-06','12:55:00',13.97),('7643','2013-08-06','13:00:00',13.91),('7643','2013-08-06','13:05:00',13.87),('7643','2013-08-06','13:10:00',13.83),('7643','2013-08-06','13:15:00',13.8),('7643','2013-08-06','13:20:00',14.13),('7643','2013-08-06','13:25:00',13.84),('7643','2013-08-06','13:30:00',14.14),('7643','2013-08-06','13:35:00',14.01),('7643','2013-08-06','13:40:00',14.03),('7643','2013-08-06','13:45:00',14.29),('7643','2013-08-06','13:50:00',14),('7643','2013-08-06','13:55:00',14.11),('7643','2013-08-06','14:00:00',14.02),('7643','2013-08-06','14:05:00',13.91),('7643','2013-08-06','14:10:00',13.76),('7643','2013-08-06','14:15:00',13.55),('7643','2013-08-06','14:20:00',13.34),('7643','2013-08-06','14:25:00',13.42),('7643','2013-08-06','14:30:00',13.32),('7643','2013-08-06','14:35:00',13.11),('7643','2013-08-06','14:40:00',12.97),('7643','2013-08-06','14:45:00',13.14),('7643','2013-08-06','14:50:00',13.06),('7643','2013-08-06','14:55:00',12.93),('7643','2013-08-06','15:00:00',12.77),('7643','2013-08-06','15:05:00',12.65),('7643','2013-08-06','15:10:00',12.45),('7643','2013-08-06','15:15:00',12.35),('7643','2013-08-06','15:20:00',12.21),('7643','2013-08-06','15:25:00',12.12),('7643','2013-08-06','15:30:00',11.83),('7643','2013-08-06','15:35:00',11.84),('7643','2013-08-06','15:40:00',11.67),('7643','2013-08-06','15:45:00',11.63),('7643','2013-08-06','15:50:00',11.41),('7643','2013-08-06','15:55:00',11.2),('7643','2013-08-06','16:00:00',11.06),('7643','2013-08-06','16:05:00',10.77),('7643','2013-08-06','16:10:00',10.41),('7643','2013-08-06','16:15:00',10.2),('7643','2013-08-06','16:20:00',10.13),('7643','2013-08-06','16:25:00',9.9),('7643','2013-08-06','16:30:00',9.71),('7643','2013-08-06','16:35:00',9.54),('7643','2013-08-06','16:40:00',9.38),('7643','2013-08-06','16:45:00',9.2),('7643','2013-08-06','16:50:00',8.96),('7643','2013-08-06','16:55:00',8.72),('7643','2013-08-06','17:00:00',8.49),('7643','2013-08-06','17:05:00',8.23),('7643','2013-08-06','17:10:00',7.9),('7643','2013-08-06','17:15:00',7.55),('7643','2013-08-06','17:20:00',7.31),('7643','2013-08-06','17:25:00',7.03),('7643','2013-08-06','17:30:00',6.6),('7643','2013-08-06','17:35:00',6.27),('7643','2013-08-06','17:40:00',5.92),('7643','2013-08-06','17:45:00',5.61),('7643','2013-08-06','17:50:00',5.26),('7643','2013-08-06','17:55:00',5.01),('7643','2013-08-06','18:00:00',4.65),('7643','2013-08-06','18:05:00',4.28),('7643','2013-08-06','18:10:00',3.96),('7643','2013-08-06','18:15:00',3.71),('7643','2013-08-06','18:20:00',3.43),('7643','2013-08-06','18:25:00',3.17),('7643','2013-08-06','18:30:00',2.96),('7643','2013-08-06','18:35:00',2.73),('7643','2013-08-06','18:40:00',2.5),('7643','2013-08-06','18:45:00',2.27),('7643','2013-08-06','18:50:00',2.02),('7643','2013-08-06','18:55:00',1.73),('7643','2013-08-06','19:00:00',1.46),('7643','2013-08-06','19:05:00',1.25),('7643','2013-08-06','19:10:00',1.08),('7643','2013-08-05','07:10:00',1.14),('7643','2013-08-05','07:15:00',1.33),('7643','2013-08-05','07:20:00',1.51),('7643','2013-08-05','07:25:00',1.72),('7643','2013-08-05','07:30:00',1.96),('7643','2013-08-05','07:35:00',2.19),('7643','2013-08-05','07:40:00',2.42),('7643','2013-08-05','07:45:00',2.7),('7643','2013-08-05','07:50:00',2.99),('7643','2013-08-05','07:55:00',3.25),('7643','2013-08-05','08:00:00',3.53),('7643','2013-08-05','08:05:00',3.89),('7643','2013-08-05','08:10:00',4.22),('7643','2013-08-05','08:15:00',4.53),('7643','2013-08-05','08:20:00',4.84),('7643','2013-08-05','08:25:00',5.14),('7643','2013-08-05','08:30:00',5.45),('7643','2013-08-05','08:35:00',5.74),('7643','2013-08-05','08:40:00',6.02),('7643','2013-08-05','08:45:00',6.31),('7643','2013-08-05','08:50:00',6.68),('7643','2013-08-05','08:55:00',6.96),('7643','2013-08-05','09:00:00',7.22),('7643','2013-08-05','09:05:00',7.45),('7643','2013-08-05','09:10:00',7.69),('7643','2013-08-05','09:15:00',7.91),('7643','2013-08-05','09:20:00',8.27),('7643','2013-08-05','09:25:00',8.57),('7643','2013-08-05','09:30:00',8.71),('7643','2013-08-05','09:35:00',9),('7643','2013-08-05','09:40:00',9.34),('7643','2013-08-05','09:45:00',9.53),('7643','2013-08-05','09:50:00',9.76),('7643','2013-08-05','09:55:00',10.03),('7643','2013-08-05','10:00:00',10.31),('7643','2013-08-05','10:05:00',10.45),('7643','2013-08-05','10:10:00',10.65),('7643','2013-08-05','10:15:00',10.83),('7643','2013-08-05','10:20:00',10.97),('7643','2013-08-05','10:25:00',11.17),('7643','2013-08-05','10:30:00',11.35),('7643','2013-08-05','10:35:00',11.54),('7643','2013-08-05','10:40:00',11.71),('7643','2013-08-05','10:45:00',11.81),('7643','2013-08-05','10:50:00',11.97),('7643','2013-08-05','10:55:00',12.15),('7643','2013-08-05','11:00:00',12.29),('7643','2013-08-05','11:05:00',12.34),('7643','2013-08-05','11:10:00',12.52),('7643','2013-08-05','11:15:00',12.69),('7643','2013-08-05','11:20:00',12.77),('7643','2013-08-05','11:25:00',12.69),('7643','2013-08-05','11:30:00',12.96),('7643','2013-08-05','11:35:00',13.15),('7643','2013-08-05','11:40:00',13.19),('7643','2013-08-05','11:45:00',13.22),('7643','2013-08-05','11:50:00',13.27),('7643','2013-08-05','11:55:00',13.41),('7643','2013-08-05','12:00:00',13.43),('7643','2013-08-05','12:05:00',13.48),('7643','2013-08-05','12:10:00',13.5),('7643','2013-08-05','12:15:00',13.44),('7643','2013-08-05','12:20:00',13.59),('7643','2013-08-05','12:25:00',13.66),('7643','2013-08-05','12:30:00',13.57),('7643','2013-08-05','12:35:00',13.57),('7643','2013-08-05','12:40:00',13.63),('7643','2013-08-05','12:45:00',13.48),('7643','2013-08-05','12:50:00',13.62),('7643','2013-08-05','12:55:00',13.86),('7643','2013-08-05','13:00:00',13.87),('7643','2013-08-05','13:05:00',13.86),('7643','2013-08-05','13:10:00',13.95),('7643','2013-08-05','13:15:00',14.02),('7643','2013-08-05','13:20:00',13.97),('7643','2013-08-05','13:25:00',14.06),('7643','2013-08-05','13:30:00',14.07),('7643','2013-08-05','13:35:00',14.26),('7643','2013-08-05','13:40:00',14.36),('7643','2013-08-05','13:45:00',14.36),('7643','2013-08-05','13:50:00',14.44),('7643','2013-08-05','13:55:00',14.5),('7643','2013-08-05','14:00:00',14.41),('7643','2013-08-05','14:05:00',14.49),('7643','2013-08-05','14:10:00',14.33),('7643','2013-08-05','14:15:00',14.27),('7643','2013-08-05','14:20:00',14.19),('7643','2013-08-05','14:25:00',14.15),('7643','2013-08-05','14:30:00',14.08),('7643','2013-08-05','14:35:00',14.01),('7643','2013-08-05','14:40:00',13.89),('7643','2013-08-05','14:45:00',13.76),('7643','2013-08-05','14:50:00',13.66),('7643','2013-08-05','14:55:00',13.56),('7643','2013-08-05','15:00:00',13.43),('7643','2013-08-05','15:05:00',13.3),('7643','2013-08-05','15:10:00',13.2),('7643','2013-08-05','15:15:00',13.12),('7643','2013-08-05','15:20:00',13.01),('7643','2013-08-05','15:25:00',12.86),('7643','2013-08-05','15:30:00',12.72),('7643','2013-08-05','15:35:00',12.57),('7643','2013-08-05','15:40:00',12.36),('7643','2013-08-05','15:45:00',12.12),('7643','2013-08-05','15:50:00',11.9),('7643','2013-08-05','15:55:00',11.68),('7643','2013-08-05','16:00:00',11.48),('7643','2013-08-05','16:05:00',11.29),('7643','2013-08-05','16:10:00',11.11),('7643','2013-08-05','16:15:00',10.9),('7643','2013-08-05','16:20:00',10.67),('7643','2013-08-05','16:25:00',10.38),('7643','2013-08-05','16:30:00',10.2),('7643','2013-08-05','16:35:00',9.94),('7643','2013-08-05','16:40:00',9.67),('7643','2013-08-05','16:45:00',9.38),('7643','2013-08-05','16:50:00',9.14),('7643','2013-08-05','16:55:00',8.94),('7643','2013-08-05','17:00:00',8.66),('7643','2013-08-05','17:05:00',8.42),('7643','2013-08-05','17:10:00',8.07),('7643','2013-08-05','17:15:00',7.68),('7643','2013-08-05','17:20:00',7.39),('7643','2013-08-05','17:25:00',7.08),('7643','2013-08-05','17:30:00',6.8),('7643','2013-08-05','17:35:00',6.44),('7643','2013-08-05','17:40:00',6.11),('7643','2013-08-05','17:45:00',5.83),('7643','2013-08-05','17:50:00',5.48),('7643','2013-08-05','17:55:00',5.15),('7643','2013-08-05','18:00:00',4.82),('7643','2013-08-05','18:05:00',4.47),('7643','2013-08-05','18:10:00',4.24),('7643','2013-08-05','18:15:00',3.99),('7643','2013-08-05','18:20:00',3.64),('7643','2013-08-05','18:25:00',3.34),('7643','2013-08-05','18:30:00',3.12),('7643','2013-08-05','18:35:00',2.85),('7643','2013-08-05','18:40:00',2.54),('7643','2013-08-05','18:45:00',2.27),('7643','2013-08-05','18:50:00',1.98),('7643','2013-08-05','18:55:00',1.68),('7643','2013-08-05','19:00:00',1.41),('7643','2013-08-05','19:05:00',1.2),('7643','2013-08-05','19:10:00',1.05),('7643','2013-08-04','07:05:00',1.12),('7643','2013-08-04','07:10:00',1.29),('7643','2013-08-04','07:15:00',1.47),('7643','2013-08-04','07:20:00',1.66),('7643','2013-08-04','07:25:00',1.89),('7643','2013-08-04','07:30:00',2.13),('7643','2013-08-04','07:35:00',2.36),('7643','2013-08-04','07:40:00',2.6),('7643','2013-08-04','07:45:00',2.92),('7643','2013-08-04','07:50:00',3.22),('7643','2013-08-04','07:55:00',3.52),('7643','2013-08-04','08:00:00',3.81),('7643','2013-08-04','08:05:00',4.17),('7643','2013-08-04','08:10:00',4.49),('7643','2013-08-04','08:15:00',4.79),('7643','2013-08-04','08:20:00',5.06),('7643','2013-08-04','08:25:00',5.37),('7643','2013-08-04','08:30:00',5.65),('7643','2013-08-04','08:35:00',5.93),('7643','2013-08-04','08:40:00',6.24),('7643','2013-08-04','08:45:00',6.56),('7643','2013-08-04','08:50:00',6.89),('7643','2013-08-04','08:55:00',7.16),('7643','2013-08-04','09:00:00',7.44),('7643','2013-08-04','09:05:00',7.69),('7643','2013-08-04','09:10:00',7.93),('7643','2013-08-04','09:15:00',8.18),('7643','2013-08-04','09:20:00',8.42),('7643','2013-08-04','09:25:00',8.67),('7643','2013-08-04','09:30:00',8.87),('7643','2013-08-04','09:35:00',9.15),('7643','2013-08-04','09:40:00',9.37),('7643','2013-08-04','09:45:00',9.58),('7643','2013-08-04','09:50:00',9.85),('7643','2013-08-04','09:55:00',10.08),('7643','2013-08-04','10:00:00',10.37),('7643','2013-08-04','10:05:00',10.62),('7643','2013-08-04','10:10:00',10.79),('7643','2013-08-04','10:15:00',11.08),('7643','2013-08-04','10:20:00',11.23),('7643','2013-08-04','10:25:00',11.38),('7643','2013-08-04','10:30:00',11.52),('7643','2013-08-04','10:35:00',11.72),('7643','2013-08-04','10:40:00',11.89),('7643','2013-08-04','10:45:00',12.06),('7643','2013-08-04','10:50:00',12.2),('7643','2013-08-04','10:55:00',12.32),('7643','2013-08-04','11:00:00',12.57),('7643','2013-08-04','11:05:00',12.62),('7643','2013-08-04','11:10:00',12.92),('7643','2013-08-04','11:15:00',12.9),('7643','2013-08-04','11:20:00',13.01),('7643','2013-08-04','11:25:00',13.19),('7643','2013-08-04','11:30:00',13.29),('7643','2013-08-04','11:35:00',13.37),('7643','2013-08-04','11:40:00',13.51),('7643','2013-08-04','11:45:00',13.59),('7643','2013-08-04','11:50:00',13.68),('7643','2013-08-04','11:55:00',13.71),('7643','2013-08-04','12:00:00',13.86),('7643','2013-08-04','12:05:00',13.99),('7643','2013-08-04','12:10:00',14.02),('7643','2013-08-04','12:15:00',14.1),('7643','2013-08-04','12:20:00',14.18),('7643','2013-08-04','12:25:00',14.17),('7643','2013-08-04','12:30:00',14.14),('7643','2013-08-04','12:35:00',14.18),('7643','2013-08-04','12:40:00',14.2),('7643','2013-08-04','12:45:00',14.11),('7643','2013-08-04','12:50:00',14.35),('7643','2013-08-04','12:55:00',14.23),('7643','2013-08-04','13:00:00',14.2),('7643','2013-08-04','13:05:00',14.25),('7643','2013-08-04','13:10:00',14.31),('7643','2013-08-04','13:15:00',14.29),('7643','2013-08-04','13:20:00',14.16),('7643','2013-08-04','13:25:00',14.12),('7643','2013-08-04','13:30:00',14.14),('7643','2013-08-04','13:35:00',14.22),('7643','2013-08-04','13:40:00',14.12),('7643','2013-08-04','13:45:00',13.99),('7643','2013-08-04','13:50:00',13.8),('7643','2013-08-04','13:55:00',13.94),('7643','2013-08-04','14:00:00',14.06),('7643','2013-08-04','14:05:00',14),('7643','2013-08-04','14:10:00',13.95),('7643','2013-08-04','14:15:00',13.74),('7643','2013-08-04','14:20:00',13.74),('7643','2013-08-04','14:25:00',13.51),('7643','2013-08-04','14:30:00',13.47),('7643','2013-08-04','14:35:00',13.46),('7643','2013-08-04','14:40:00',13.34),('7643','2013-08-04','14:45:00',13.35),('7643','2013-08-04','14:50:00',13.22),('7643','2013-08-04','14:55:00',13.17),('7643','2013-08-04','15:00:00',13.05),('7643','2013-08-04','15:05:00',12.98),('7643','2013-08-04','15:10:00',12.96),('7643','2013-08-04','15:15:00',12.85),('7643','2013-08-04','15:20:00',12.66),('7643','2013-08-04','15:25:00',12.54),('7643','2013-08-04','15:30:00',12.4),('7643','2013-08-04','15:35:00',12.24),('7643','2013-08-04','15:40:00',12.1),('7643','2013-08-04','15:45:00',11.91),('7643','2013-08-04','15:50:00',11.83),('7643','2013-08-04','15:55:00',11.69),('7643','2013-08-04','16:00:00',11.52),('7643','2013-08-04','16:05:00',11.31),('7643','2013-08-04','16:10:00',11.15),('7643','2013-08-04','16:15:00',10.88),('7643','2013-08-04','16:20:00',10.54),('7643','2013-08-04','16:25:00',10.29),('7643','2013-08-04','16:30:00',10.09),('7643','2013-08-04','16:35:00',9.91),('7643','2013-08-04','16:40:00',9.65),('7643','2013-08-04','16:45:00',9.36),('7643','2013-08-04','16:50:00',9.12),('7643','2013-08-04','16:55:00',8.82),('7643','2013-08-04','17:00:00',8.6),('7643','2013-08-04','17:05:00',8.32),('7643','2013-08-04','17:10:00',7.97),('7643','2013-08-04','17:15:00',7.69),('7643','2013-08-04','17:20:00',7.36),('7643','2013-08-04','17:25:00',7),('7643','2013-08-04','17:30:00',6.71),('7643','2013-08-04','17:35:00',6.37),('7643','2013-08-04','17:40:00',6.1),('7643','2013-08-04','17:45:00',5.81),('7643','2013-08-04','17:50:00',5.46),('7643','2013-08-04','17:55:00',5.15),('7643','2013-08-04','18:00:00',4.84),('7643','2013-08-04','18:05:00',4.49),('7643','2013-08-04','18:10:00',4.17),('7643','2013-08-04','18:15:00',3.87),('7643','2013-08-04','18:20:00',3.55),('7643','2013-08-04','18:25:00',3.3),('7643','2013-08-04','18:30:00',3.04),('7643','2013-08-04','18:35:00',2.8),('7643','2013-08-04','18:40:00',2.53),('7643','2013-08-04','18:45:00',2.29),('7643','2013-08-04','18:50:00',2.03),('7643','2013-08-04','18:55:00',1.75),('7643','2013-08-04','19:00:00',1.49),('7643','2013-08-04','19:05:00',1.29),('7643','2013-08-04','19:10:00',1.12),('7643','2013-08-03','07:10:00',1.23),('7643','2013-08-03','07:15:00',1.46),('7643','2013-08-03','07:20:00',1.69),('7643','2013-08-03','07:25:00',1.93),('7643','2013-08-03','07:30:00',2.21),('7643','2013-08-03','07:35:00',2.44),('7643','2013-08-03','07:40:00',2.72),('7643','2013-08-03','07:45:00',3.06),('7643','2013-08-03','07:50:00',3.39),('7643','2013-08-03','07:55:00',3.73),('7643','2013-08-03','08:00:00',4.05),('7643','2013-08-03','08:05:00',4.4),('7643','2013-08-03','08:10:00',4.75),('7643','2013-08-03','08:15:00',5.08),('7643','2013-08-03','08:20:00',5.44),('7643','2013-08-03','08:25:00',5.81),('7643','2013-08-03','08:30:00',6.12),('7643','2013-08-03','08:35:00',6.38),('7643','2013-08-03','08:40:00',6.74),('7643','2013-08-03','08:45:00',7.03),('7643','2013-08-03','08:50:00',7.38),('7643','2013-08-03','08:55:00',7.65),('7643','2013-08-03','09:00:00',7.95),('7643','2013-08-03','09:05:00',8.23),('7643','2013-08-03','09:10:00',8.46),('7643','2013-08-03','09:15:00',8.71),('7643','2013-08-03','09:20:00',8.89),('7643','2013-08-03','09:25:00',9.17),('7643','2013-08-03','09:30:00',9.44),('7643','2013-08-03','09:35:00',9.74),('7643','2013-08-03','09:40:00',10.02),('7643','2013-08-03','09:45:00',10.22),('7643','2013-08-03','09:50:00',10.52),('7643','2013-08-03','09:55:00',10.73),('7643','2013-08-03','10:00:00',10.97),('7643','2013-08-03','10:05:00',11.19),('7643','2013-08-03','10:10:00',11.39),('7643','2013-08-03','10:15:00',11.57),('7643','2013-08-03','10:20:00',11.72),('7643','2013-08-03','10:25:00',11.94),('7643','2013-08-03','10:30:00',12.11),('7643','2013-08-03','10:35:00',12.22),('7643','2013-08-03','10:40:00',12.4),('7643','2013-08-03','10:45:00',12.54),('7643','2013-08-03','10:50:00',9.72),('7643','2013-08-03','10:55:00',12.74),('7643','2013-08-03','11:00:00',12.82),('7643','2013-08-03','11:05:00',12.91),('7643','2013-08-03','11:10:00',13.05),('7643','2013-08-03','11:15:00',13.16),('7643','2013-08-03','11:20:00',13.26),('7643','2013-08-03','11:25:00',13.37),('7643','2013-08-03','11:30:00',13.62),('7643','2013-08-03','11:35:00',13.84),('7643','2013-08-03','11:40:00',13.96),('7643','2013-08-03','11:45:00',13.92),('7643','2013-08-03','11:50:00',14.08),('7643','2013-08-03','11:55:00',14.24),('7643','2013-08-03','12:00:00',14.39),('7643','2013-08-03','12:05:00',14.46),('7643','2013-08-03','12:10:00',14.47),('7643','2013-08-03','12:15:00',14.53),('7643','2013-08-03','12:20:00',14.48),('7643','2013-08-03','12:25:00',14.44),('7643','2013-08-03','12:30:00',14.45),('7643','2013-08-03','12:35:00',14.47),('7643','2013-08-03','12:40:00',14.45),('7643','2013-08-03','12:45:00',14.66),('7643','2013-08-03','12:50:00',14.76),('7643','2013-08-03','12:55:00',14.82),('7643','2013-08-03','13:00:00',14.78),('7643','2013-08-03','13:05:00',14.61),('7643','2013-08-03','13:10:00',14.45),('7643','2013-08-03','13:15:00',14.58),('7643','2013-08-03','13:20:00',14.53),('7643','2013-08-03','13:25:00',14.55),('7643','2013-08-03','13:30:00',14.55),('7643','2013-08-03','13:35:00',14.71),('7643','2013-08-03','13:40:00',14.91),('7643','2013-08-03','13:45:00',14.86),('7643','2013-08-03','13:50:00',14.87),('7643','2013-08-03','13:55:00',14.9),('7643','2013-08-03','14:00:00',14.92),('7643','2013-08-03','14:05:00',14.86),('7643','2013-08-03','14:10:00',14.78),('7643','2013-08-03','14:15:00',14.72),('7643','2013-08-03','14:20:00',14.44),('7643','2013-08-03','14:25:00',14.33),('7643','2013-08-03','14:30:00',14.27),('7643','2013-08-03','14:35:00',14.11),('7643','2013-08-03','14:40:00',14.04),('7643','2013-08-03','14:45:00',14.06),('7643','2013-08-03','14:50:00',13.95),('7643','2013-08-03','14:55:00',13.82),('7643','2013-08-03','15:00:00',13.64),('7643','2013-08-03','15:05:00',13.5),('7643','2013-08-03','15:10:00',13.39),('7643','2013-08-03','15:15:00',13.23),('7643','2013-08-03','15:20:00',13.08),('7643','2013-08-03','15:25:00',12.84),('7643','2013-08-03','15:30:00',12.61),('7643','2013-08-03','15:35:00',12.7),('7643','2013-08-03','15:40:00',12.51),('7643','2013-08-03','15:45:00',12.35),('7643','2013-08-03','15:50:00',12.05),('7643','2013-08-03','15:55:00',11.82),('7643','2013-08-03','16:00:00',11.62),('7643','2013-08-03','16:05:00',11.57),('7643','2013-08-03','16:10:00',11.32),('7643','2013-08-03','16:15:00',11.19),('7643','2013-08-03','16:20:00',10.98),('7643','2013-08-03','16:25:00',10.75),('7643','2013-08-03','16:30:00',10.49),('7643','2013-08-03','16:35:00',10.23),('7643','2013-08-03','16:40:00',10.1),('7643','2013-08-03','16:45:00',9.79),('7643','2013-08-03','16:50:00',9.46),('7643','2013-08-03','16:55:00',9.22),('7643','2013-08-03','17:00:00',8.87),('7643','2013-08-03','17:05:00',8.71),('7643','2013-08-03','17:10:00',8.39),('7643','2013-08-03','17:15:00',8.05),('7643','2013-08-03','17:20:00',7.72),('7643','2013-08-03','17:25:00',7.31),('7643','2013-08-03','17:30:00',6.99),('7643','2013-08-03','17:35:00',6.71),('7643','2013-08-03','17:40:00',6.37),('7643','2013-08-03','17:45:00',6.02),('7643','2013-08-03','17:50:00',5.73),('7643','2013-08-03','17:55:00',5.34),('7643','2013-08-03','18:00:00',4.97),('7643','2013-08-03','18:05:00',4.71),('7643','2013-08-03','18:10:00',4.38),('7643','2013-08-03','18:15:00',4.06),('7643','2013-08-03','18:20:00',3.76),('7643','2013-08-03','18:25:00',3.39),('7643','2013-08-03','18:30:00',3.09),('7643','2013-08-03','18:35:00',2.91),('7643','2013-08-03','18:40:00',2.59),('7643','2013-08-03','18:45:00',2.25),('7643','2013-08-03','18:50:00',2.03),('7643','2013-08-03','18:55:00',1.75),('7643','2013-08-03','19:00:00',1.49),('7643','2013-08-03','19:05:00',1.07),('7643','2013-08-03','19:10:00',1.07),('7643','2013-08-02','07:05:00',1.03),('7643','2013-08-02','07:10:00',1.27),('7643','2013-08-02','07:15:00',1.5),('7643','2013-08-02','07:20:00',1.72),('7643','2013-08-02','07:25:00',1.97),('7643','2013-08-02','07:30:00',2.24),('7643','2013-08-02','07:35:00',2.48),('7643','2013-08-02','07:40:00',2.77),('7643','2013-08-02','07:45:00',3.08),('7643','2013-08-02','07:50:00',3.41),('7643','2013-08-02','07:55:00',3.74),('7643','2013-08-02','08:00:00',4.06),('7643','2013-08-02','08:05:00',4.39),('7643','2013-08-02','08:10:00',4.74),('7643','2013-08-02','08:15:00',5.07),('7643','2013-08-02','08:20:00',5.39),('7643','2013-08-02','08:25:00',5.74),('7643','2013-08-02','08:30:00',6.04),('7643','2013-08-02','08:35:00',6.3),('7643','2013-08-02','08:40:00',6.66),('7643','2013-08-02','08:45:00',6.97),('7643','2013-08-02','08:50:00',7.33),('7643','2013-08-02','08:55:00',7.6),('7643','2013-08-02','09:00:00',7.85),('7643','2013-08-02','09:05:00',8.12),('7643','2013-08-02','09:10:00',8.4),('7643','2013-08-02','09:15:00',8.64),('7643','2013-08-02','09:20:00',8.88),('7643','2013-08-02','09:25:00',9.13),('7643','2013-08-02','09:30:00',9.47),('7643','2013-08-02','09:35:00',9.8),('7643','2013-08-02','09:40:00',9.99),('7643','2013-08-02','09:45:00',10.19),('7643','2013-08-02','09:50:00',10.41),('7643','2013-08-02','09:55:00',10.61),('7643','2013-08-02','10:00:00',10.84),('7643','2013-08-02','10:05:00',11.07),('7643','2013-08-02','10:10:00',11.27),('7643','2013-08-02','10:15:00',11.47),('7643','2013-08-02','10:20:00',11.69),('7643','2013-08-02','10:25:00',11.86),('7643','2013-08-02','10:30:00',12.04),('7643','2013-08-02','10:35:00',12.28),('7643','2013-08-02','10:40:00',12.44),('7643','2013-08-02','10:45:00',12.52),('7643','2013-08-02','10:50:00',12.59),('7643','2013-08-02','10:55:00',12.75),('7643','2013-08-02','11:00:00',12.91),('7643','2013-08-02','11:05:00',12.97),('7643','2013-08-02','11:10:00',13.18),('7643','2013-08-02','11:15:00',13.23),('7643','2013-08-02','11:20:00',13.25),('7643','2013-08-02','11:25:00',13.27),('7643','2013-08-02','11:30:00',13.45),('7643','2013-08-02','11:35:00',13.72),('7643','2013-08-02','11:40:00',13.8),('7643','2013-08-02','11:45:00',13.93),('7643','2013-08-02','11:50:00',14.07),('7643','2013-08-02','11:55:00',14.05),('7643','2013-08-02','12:00:00',14.04),('7643','2013-08-02','12:05:00',14.15),('7643','2013-08-02','12:10:00',14.39),('7643','2013-08-02','12:15:00',14.38),('7643','2013-08-02','12:20:00',14.27),('7643','2013-08-02','12:25:00',14.3),('7643','2013-08-02','12:30:00',14.37),('7643','2013-08-02','12:35:00',14.34),('7643','2013-08-02','12:40:00',14.44),('7643','2013-08-02','12:45:00',14.42),('7643','2013-08-02','12:50:00',14.36),('7643','2013-08-02','12:55:00',14.33),('7643','2013-08-02','13:00:00',14.42),('7643','2013-08-02','13:05:00',14.39),('7643','2013-08-02','13:10:00',14.4),('7643','2013-08-02','13:15:00',14.38),('7643','2013-08-02','13:20:00',14.11),('7643','2013-08-02','13:25:00',14.04),('7643','2013-08-02','13:30:00',14.02),('7643','2013-08-02','13:35:00',13.94),('7643','2013-08-02','13:40:00',14.05),('7643','2013-08-02','13:45:00',14.34),('7643','2013-08-02','13:50:00',14.2),('7643','2013-08-02','13:55:00',14.05),('7643','2013-08-02','14:00:00',14),('7643','2013-08-02','14:05:00',13.92),('7643','2013-08-02','14:10:00',13.87),('7643','2013-08-02','14:15:00',13.63),('7643','2013-08-02','14:20:00',13.64),('7643','2013-08-02','14:25:00',13.57),('7643','2013-08-02','14:30:00',13.74),('7643','2013-08-02','14:35:00',14),('7643','2013-08-02','14:40:00',13.88),('7643','2013-08-02','14:45:00',13.89),('7643','2013-08-02','14:50:00',13.73),('7643','2013-08-02','14:55:00',13.62),('7643','2013-08-02','15:00:00',13.52),('7643','2013-08-02','15:05:00',13.38),('7643','2013-08-02','15:10:00',13.24),('7643','2013-08-02','15:15:00',13.13),('7643','2013-08-02','15:20:00',12.94),('7643','2013-08-02','15:25:00',12.9),('7643','2013-08-02','15:30:00',12.82),('7643','2013-08-02','15:35:00',12.63),('7643','2013-08-02','15:40:00',12.45),('7643','2013-08-02','15:45:00',12.25),('7643','2013-08-02','15:50:00',12.07),('7643','2013-08-02','15:55:00',11.9),('7643','2013-08-02','16:00:00',11.65),('7643','2013-08-02','16:05:00',11.37),('7643','2013-08-02','16:10:00',11.16),('7643','2013-08-02','16:15:00',10.83),('7643','2013-08-02','16:20:00',10.65),('7643','2013-08-02','16:25:00',10.45),('7643','2013-08-02','16:30:00',10.31),('7643','2013-08-02','16:35:00',10.1),('7643','2013-08-02','16:40:00',9.85),('7643','2013-08-02','16:45:00',9.51),('7643','2013-08-02','16:50:00',9.3),('7643','2013-08-02','16:55:00',9),('7643','2013-08-02','17:00:00',7.91),('7643','2013-08-02','17:05:00',8.48),('7643','2013-08-02','17:10:00',8.16),('7643','2013-08-02','17:15:00',7.92),('7643','2013-08-02','17:20:00',7.61),('7643','2013-08-02','17:25:00',7.25),('7643','2013-08-02','17:30:00',6.98),('7643','2013-08-02','17:35:00',6.7),('7643','2013-08-02','17:40:00',6.37),('7643','2013-08-02','17:45:00',6),('7643','2013-08-02','17:50:00',5.68),('7643','2013-08-02','17:55:00',5.37),('7643','2013-08-02','18:00:00',4.99),('7643','2013-08-02','18:05:00',4.74),('7643','2013-08-02','18:10:00',4.5),('7643','2013-08-02','18:15:00',4.19),('7643','2013-08-02','18:20:00',3.87),('7643','2013-08-02','18:25:00',3.58),('7643','2013-08-02','18:30:00',3.3),('7643','2013-08-02','18:35:00',3.03),('7643','2013-08-02','18:40:00',2.74),('7643','2013-08-02','18:45:00',2.47),('7643','2013-08-02','18:50:00',2.17),('7643','2013-08-02','18:55:00',1.86),('7643','2013-08-02','19:00:00',1.55),('7643','2013-08-02','19:05:00',1.36),('7643','2013-08-02','19:10:00',1.13),('7643','2013-08-01','07:05:00',1.07),('7643','2013-08-01','07:10:00',1.33),('7643','2013-08-01','07:15:00',1.59),('7643','2013-08-01','07:20:00',1.84),('7643','2013-08-01','07:25:00',2.11),('7643','2013-08-01','07:30:00',2.39),('7643','2013-08-01','07:35:00',2.64),('7643','2013-08-01','07:40:00',3),('7643','2013-08-01','07:45:00',3.29),('7643','2013-08-01','07:50:00',3.61),('7643','2013-08-01','07:55:00',3.96),('7643','2013-08-01','08:00:00',4.31),('7643','2013-08-01','08:05:00',4.67),('7643','2013-08-01','08:10:00',5.02),('7643','2013-08-01','08:15:00',5.37),('7643','2013-08-01','08:20:00',5.71),('7643','2013-08-01','08:25:00',6.06),('7643','2013-08-01','08:30:00',6.39),('7643','2013-08-01','08:35:00',6.64),('7643','2013-08-01','08:40:00',7),('7643','2013-08-01','08:45:00',7.3),('7643','2013-08-01','08:50:00',7.62),('7643','2013-08-01','08:55:00',7.9),('7643','2013-08-01','09:00:00',8.18),('7643','2013-08-01','09:05:00',8.46),('7643','2013-08-01','09:10:00',8.73),('7643','2013-08-01','09:15:00',8.98),('7643','2013-08-01','09:20:00',9.24),('7643','2013-08-01','09:25:00',9.53),('7643','2013-08-01','09:30:00',9.78),('7643','2013-08-01','09:35:00',10.04),('7643','2013-08-01','09:40:00',10.29),('7643','2013-08-01','09:45:00',10.49),('7643','2013-08-01','09:50:00',10.65),('7643','2013-08-01','09:55:00',10.89),('7643','2013-08-01','10:00:00',11.05),('7643','2013-08-01','10:05:00',11.18),('7643','2013-08-01','10:10:00',11.39),('7643','2013-08-01','10:15:00',11.62),('7643','2013-08-01','10:20:00',11.82),('7643','2013-08-01','10:25:00',11.97),('7643','2013-08-01','10:30:00',12.22),('7643','2013-08-01','10:35:00',12.42),('7643','2013-08-01','10:40:00',12.55),('7643','2013-08-01','10:45:00',12.7),('7643','2013-08-01','10:50:00',12.83),('7643','2013-08-01','10:55:00',13.01),('7643','2013-08-01','11:00:00',13.14),('7643','2013-08-01','11:05:00',13.34),('7643','2013-08-01','11:10:00',13.39),('7643','2013-08-01','11:15:00',13.51),('7643','2013-08-01','11:20:00',13.66),('7643','2013-08-01','11:25:00',13.84),('7643','2013-08-01','11:30:00',13.97),('7643','2013-08-01','11:35:00',13.97),('7643','2013-08-01','11:40:00',14.03),('7643','2013-08-01','11:45:00',14.09),('7643','2013-08-01','11:50:00',14.12),('7643','2013-08-01','11:55:00',14.25),('7643','2013-08-01','12:00:00',14.49),('7643','2013-08-01','12:05:00',14.67),('7643','2013-08-01','12:10:00',14.7),('7643','2013-08-01','12:15:00',14.8),('7643','2013-08-01','12:20:00',14.77),('7643','2013-08-01','12:25:00',14.71),('7643','2013-08-01','12:30:00',14.73),('7643','2013-08-01','12:35:00',14.86),('7643','2013-08-01','12:40:00',14.71),('7643','2013-08-01','12:45:00',14.72),('7643','2013-08-01','12:50:00',14.67),('7643','2013-08-01','12:55:00',14.59),('7643','2013-08-01','13:00:00',14.63),('7643','2013-08-01','13:05:00',14.98),('7643','2013-08-01','13:10:00',15.07),('7643','2013-08-01','13:15:00',15.06),('7643','2013-08-01','13:20:00',14.85),('7643','2013-08-01','13:25:00',14.74),('7643','2013-08-01','13:30:00',14.77),('7643','2013-08-01','13:35:00',14.76),('7643','2013-08-01','13:40:00',14.67),('7643','2013-08-01','13:45:00',14.7),('7643','2013-08-01','13:50:00',14.8),('7643','2013-08-01','13:55:00',14.63),('7643','2013-08-01','14:00:00',14.81),('7643','2013-08-01','14:05:00',14.71),('7643','2013-08-01','14:10:00',14.62),('7643','2013-08-01','14:15:00',14.35),('7643','2013-08-01','14:20:00',14.14),('7643','2013-08-01','14:25:00',13.95),('7643','2013-08-01','14:30:00',13.98),('7643','2013-08-01','14:35:00',14.09),('7643','2013-08-01','14:40:00',14.17),('7643','2013-08-01','14:45:00',13.96),('7643','2013-08-01','14:50:00',13.98),('7643','2013-08-01','14:55:00',13.91),('7643','2013-08-01','15:00:00',13.78),('7643','2013-08-01','15:05:00',13.67),('7643','2013-08-01','15:10:00',13.44),('7643','2013-08-01','15:15:00',13.2),('7643','2013-08-01','15:20:00',13.31),('7643','2013-08-01','15:25:00',13.28),('7643','2013-08-01','15:30:00',13.09),('7643','2013-08-01','15:35:00',12.95),('7643','2013-08-01','15:40:00',12.78),('7643','2013-08-01','15:45:00',12.6),('7643','2013-08-01','15:50:00',12.34),('7643','2013-08-01','15:55:00',12.16),('7643','2013-08-01','16:00:00',12.05),('7643','2013-08-01','16:05:00',11.85),('7643','2013-08-01','16:10:00',11.58),('7643','2013-08-01','16:15:00',11.31),('7643','2013-08-01','16:20:00',11.11),('7643','2013-08-01','16:25:00',7.98),('7643','2013-08-01','16:30:00',10.63),('7643','2013-08-01','16:35:00',10.42),('7643','2013-08-01','16:40:00',10.23),('7643','2013-08-01','16:45:00',10),('7643','2013-08-01','16:50:00',9.74),('7643','2013-08-01','16:55:00',9.47),('7643','2013-08-01','17:00:00',9.17),('7643','2013-08-01','17:05:00',8.75),('7643','2013-08-01','17:10:00',8.48),('7643','2013-08-01','17:15:00',8.27),('7643','2013-08-01','17:20:00',8),('7643','2013-08-01','17:25:00',7.66),('7643','2013-08-01','17:30:00',7.28),('7643','2013-08-01','17:35:00',6.87),('7643','2013-08-01','17:40:00',6.57),('7643','2013-08-01','17:45:00',6.17),('7643','2013-08-01','17:50:00',5.77),('7643','2013-08-01','17:55:00',5.54),('7643','2013-08-01','18:00:00',5.23),('7643','2013-08-01','18:05:00',5.02),('7643','2013-08-01','18:10:00',4.7),('7643','2013-08-01','18:15:00',4.34),('7643','2013-08-01','18:20:00',3.99),('7643','2013-08-01','18:25:00',3.74),('7643','2013-08-01','18:30:00',3.44),('7643','2013-08-01','18:35:00',3.13),('7643','2013-08-01','18:40:00',2.84),('7643','2013-08-01','18:45:00',2.55),('7643','2013-08-01','18:50:00',2.26),('7643','2013-08-01','18:55:00',1.94),('7643','2013-08-01','19:00:00',1.62),('7643','2013-08-01','19:05:00',1.38),('7643','2013-08-01','19:10:00',1.24),('7643','2013-08-01','19:15:00',1.04),('7643','2013-07-31','07:05:00',1.1),('7643','2013-07-31','07:10:00',1.37),('7643','2013-07-31','07:15:00',1.62),('7643','2013-07-31','07:20:00',1.89),('7643','2013-07-31','07:25:00',2.17),('7643','2013-07-31','07:30:00',2.44),('7643','2013-07-31','07:35:00',2.76),('7643','2013-07-31','07:40:00',3.08),('7643','2013-07-31','07:45:00',3.36),('7643','2013-07-31','07:50:00',3.66),('7643','2013-07-31','07:55:00',4.01),('7643','2013-07-31','08:00:00',4.37),('7643','2013-07-31','08:05:00',4.72),('7643','2013-07-31','08:10:00',5.05),('7643','2013-07-31','08:15:00',5.4),('7643','2013-07-31','08:20:00',5.77),('7643','2013-07-31','08:25:00',6.14),('7643','2013-07-31','08:30:00',6.49),('7643','2013-07-31','08:35:00',6.83),('7643','2013-07-31','08:40:00',7.2),('7643','2013-07-31','08:45:00',7.5),('7643','2013-07-31','08:50:00',7.83),('7643','2013-07-31','08:55:00',8.1),('7643','2013-07-31','09:00:00',8.35),('7643','2013-07-31','09:05:00',8.68),('7643','2013-07-31','09:10:00',9),('7643','2013-07-31','09:15:00',9.33),('7643','2013-07-31','09:20:00',9.6),('7643','2013-07-31','09:25:00',9.86),('7643','2013-07-31','09:30:00',10.15),('7643','2013-07-31','09:35:00',10.45),('7643','2013-07-31','09:40:00',10.71),('7643','2013-07-31','09:45:00',10.92),('7643','2013-07-31','09:50:00',11.2),('7643','2013-07-31','09:55:00',11.42),('7643','2013-07-31','10:00:00',11.54),('7643','2013-07-31','10:05:00',11.8),('7643','2013-07-31','10:10:00',12.04),('7643','2013-07-31','10:15:00',12.27),('7643','2013-07-31','10:20:00',12.44),('7643','2013-07-31','10:25:00',12.75),('7643','2013-07-31','10:30:00',13),('7643','2013-07-31','10:35:00',13.15),('7643','2013-07-31','10:40:00',13.27),('7643','2013-07-31','10:45:00',13.41),('7643','2013-07-31','10:50:00',13.6),('7643','2013-07-31','10:55:00',13.76),('7643','2013-07-31','11:00:00',13.93),('7643','2013-07-31','11:05:00',14.08),('7643','2013-07-31','11:10:00',14.28),('7643','2013-07-31','11:15:00',14.53),('7643','2013-07-31','11:20:00',14.62),('7643','2013-07-31','11:25:00',14.7),('7643','2013-07-31','11:30:00',14.8),('7643','2013-07-31','11:35:00',14.96),('7643','2013-07-31','11:40:00',15.08),('7643','2013-07-31','11:45:00',15.22),('7643','2013-07-31','11:50:00',15.35),('7643','2013-07-31','11:55:00',15.32),('7643','2013-07-31','12:00:00',15.42),('7643','2013-07-31','12:05:00',15.48),('7643','2013-07-31','12:10:00',15.59),('7643','2013-07-31','12:15:00',15.69),('7643','2013-07-31','12:20:00',15.66),('7643','2013-07-31','12:25:00',15.73),('7643','2013-07-31','12:30:00',15.79),('7643','2013-07-31','12:35:00',15.94),('7643','2013-07-31','12:40:00',15.95),('7643','2013-07-31','12:45:00',15.82),('7643','2013-07-31','12:50:00',16.01),('7643','2013-07-31','12:55:00',15.96),('7643','2013-07-31','13:00:00',15.93),('7643','2013-07-31','13:05:00',15.93),('7643','2013-07-31','13:10:00',15.96),('7643','2013-07-31','13:15:00',15.22),('7643','2013-07-31','13:20:00',16.04),('7643','2013-07-31','13:25:00',15.96),('7643','2013-07-31','13:30:00',15.95),('7643','2013-07-31','13:35:00',15.93),('7643','2013-07-31','13:40:00',15.95),('7643','2013-07-31','13:45:00',14.45),('7643','2013-07-31','13:50:00',15.61),('7643','2013-07-31','13:55:00',15.68),('7643','2013-07-31','14:00:00',14.36),('7643','2013-07-31','14:05:00',15.68),('7643','2013-07-31','14:10:00',15.15),('7643','2013-07-31','14:15:00',15.56),('7643','2013-07-31','14:20:00',13.99),('7643','2013-07-31','14:25:00',14.89),('7643','2013-07-31','14:30:00',14.9),('7643','2013-07-31','14:35:00',12.38),('7643','2013-07-31','14:40:00',14.94),('7643','2013-07-31','14:45:00',14.83),('7643','2013-07-31','14:50:00',14.47),('7643','2013-07-31','14:55:00',14.38),('7643','2013-07-31','15:00:00',14.09),('7643','2013-07-31','15:05:00',13.57),('7643','2013-07-31','15:10:00',14.29),('7643','2013-07-31','15:15:00',12.4),('7643','2013-07-31','15:20:00',9.72),('7643','2013-07-31','15:25:00',13.36),('7643','2013-07-31','15:30:00',13.47),('7643','2013-07-31','15:35:00',13.61),('7643','2013-07-31','15:40:00',8.27),('7643','2013-07-31','15:45:00',13.16),('7643','2013-07-31','15:50:00',12.77),('7643','2013-07-31','15:55:00',12.69),('7643','2013-07-31','16:00:00',12.6),('7643','2013-07-31','16:05:00',12.31),('7643','2013-07-31','16:10:00',11.86),('7643','2013-07-31','16:15:00',11.69),('7643','2013-07-31','16:20:00',11.52),('7643','2013-07-31','16:25:00',11.29),('7643','2013-07-31','16:30:00',10.93),('7643','2013-07-31','16:35:00',10.73),('7643','2013-07-31','16:40:00',10.53),('7643','2013-07-31','16:45:00',10.26),('7643','2013-07-31','16:50:00',10),('7643','2013-07-31','16:55:00',9.74),('7643','2013-07-31','17:00:00',9.4),('7643','2013-07-31','17:05:00',9.07),('7643','2013-07-31','17:10:00',8.74),('7643','2013-07-31','17:15:00',8.48),('7643','2013-07-31','17:20:00',8.11),('7643','2013-07-31','17:25:00',7.78),('7643','2013-07-31','17:30:00',7.44),('7643','2013-07-31','17:35:00',7.23),('7643','2013-07-31','17:40:00',6.86),('7643','2013-07-31','17:45:00',6.48),('7643','2013-07-31','17:50:00',6.19),('7643','2013-07-31','17:55:00',5.84),('7643','2013-07-31','18:00:00',5.47),('7643','2013-07-31','18:05:00',5.26),('7643','2013-07-31','18:10:00',4.9),('7643','2013-07-31','18:15:00',4.56),('7643','2013-07-31','18:20:00',4.26),('7643','2013-07-31','18:25:00',3.93),('7643','2013-07-31','18:30:00',3.62),('7643','2013-07-31','18:35:00',3.31),('7643','2013-07-31','18:40:00',2.99),('7643','2013-07-31','18:45:00',2.69),('7643','2013-07-31','18:50:00',2.36),('7643','2013-07-31','18:55:00',2),('7643','2013-07-31','19:00:00',1.67),('7643','2013-07-31','19:05:00',1.46),('7643','2013-07-31','19:10:00',1.16),('7643','2013-07-30','07:05:00',1.2),('7643','2013-07-30','07:10:00',1.37),('7643','2013-07-30','07:15:00',1.65),('7643','2013-07-30','07:20:00',1.92),('7643','2013-07-30','07:25:00',2.18),('7643','2013-07-30','07:30:00',2.57),('7643','2013-07-30','07:35:00',2.86),('7643','2013-07-30','07:40:00',3.19),('7643','2013-07-30','07:45:00',3.49),('7643','2013-07-30','07:50:00',3.79),('7643','2013-07-30','07:55:00',4.11),('7643','2013-07-30','08:00:00',4.49),('7643','2013-07-30','08:05:00',4.86),('7643','2013-07-30','08:10:00',5.21),('7643','2013-07-30','08:15:00',5.54),('7643','2013-07-30','08:20:00',5.91),('7643','2013-07-30','08:25:00',6.3),('7643','2013-07-30','08:30:00',6.62),('7643','2013-07-30','08:35:00',6.93),('7643','2013-07-30','08:40:00',7.33),('7643','2013-07-30','08:45:00',7.63),('7643','2013-07-30','08:50:00',7.93),('7643','2013-07-30','08:55:00',8.29),('7643','2013-07-30','09:00:00',8.57),('7643','2013-07-30','09:05:00',8.89),('7643','2013-07-30','09:10:00',9.18),('7643','2013-07-30','09:15:00',9.42),('7643','2013-07-30','09:20:00',9.66),('7643','2013-07-30','09:25:00',9.93),('7643','2013-07-30','09:30:00',10.26),('7643','2013-07-30','09:35:00',10.55),('7643','2013-07-30','09:40:00',10.74),('7643','2013-07-30','09:45:00',11.06),('7643','2013-07-30','09:50:00',11.26),('7643','2013-07-30','09:55:00',11.5),('7643','2013-07-30','10:00:00',11.71),('7643','2013-07-30','10:05:00',11.94),('7643','2013-07-30','10:10:00',12.09),('7643','2013-07-30','10:15:00',12.29),('7643','2013-07-30','10:20:00',12.63),('7643','2013-07-30','10:25:00',12.74),('7643','2013-07-30','10:30:00',12.98),('7643','2013-07-30','10:35:00',13.23),('7643','2013-07-30','10:40:00',13.5),('7643','2013-07-30','10:45:00',13.71),('7643','2013-07-30','10:50:00',13.9),('7643','2013-07-30','10:55:00',13.97),('7643','2013-07-30','11:00:00',14.13),('7643','2013-07-30','11:05:00',14.3),('7643','2013-07-30','11:10:00',14.43),('7643','2013-07-30','11:15:00',14.59),('7643','2013-07-30','11:20:00',14.65),('7643','2013-07-30','11:25:00',14.74),('7643','2013-07-30','11:30:00',14.84),('7643','2013-07-30','11:35:00',15),('7643','2013-07-30','11:40:00',15.07),('7643','2013-07-30','11:45:00',15.32),('7643','2013-07-30','11:50:00',15.45),('7643','2013-07-30','11:55:00',15.57),('7643','2013-07-30','12:00:00',15.58),('7643','2013-07-30','12:05:00',15.63),('7643','2013-07-30','12:10:00',15.71),('7643','2013-07-30','12:15:00',15.89),('7643','2013-07-30','12:20:00',15.82),('7643','2013-07-30','12:25:00',16),('7643','2013-07-30','12:30:00',16),('7643','2013-07-30','12:35:00',15.87),('7643','2013-07-30','12:40:00',15.97),('7643','2013-07-30','12:45:00',16.37),('7643','2013-07-30','12:50:00',12.24),('7643','2013-07-30','12:55:00',16.4),('7643','2013-07-30','13:00:00',6.87),('7643','2013-07-30','13:05:00',15.06),('7643','2013-07-30','13:10:00',16.38),('7643','2013-07-30','13:15:00',16.16),('7643','2013-07-30','13:20:00',15.04),('7643','2013-07-30','13:25:00',15.08),('7643','2013-07-30','13:30:00',15.17),('7643','2013-07-30','13:35:00',16.05),('7643','2013-07-30','13:40:00',12.87),('7643','2013-07-30','13:45:00',13.72),('7643','2013-07-30','13:50:00',14.25),('7643','2013-07-30','13:55:00',10.15),('7643','2013-07-30','14:00:00',12.38),('7643','2013-07-30','14:05:00',16.59),('7643','2013-07-30','14:10:00',15.72),('7643','2013-07-30','14:15:00',15.86),('7643','2013-07-30','14:20:00',16.21),('7643','2013-07-30','14:25:00',15.79),('7643','2013-07-30','14:30:00',15.34),('7643','2013-07-30','14:35:00',15.11),('7643','2013-07-30','14:40:00',15.27),('7643','2013-07-30','14:45:00',15.27),('7643','2013-07-30','14:50:00',9.91),('7643','2013-07-30','14:55:00',6.28),('7643','2013-07-30','15:00:00',5.06),('7643','2013-07-30','15:05:00',15.48),('7643','2013-07-30','15:10:00',14.65),('7643','2013-07-30','15:15:00',11.51),('7643','2013-07-30','15:20:00',15),('7643','2013-07-30','15:25:00',13.31),('7643','2013-07-30','15:30:00',13.91),('7643','2013-07-30','15:35:00',12.84),('7643','2013-07-30','15:40:00',9),('7643','2013-07-30','15:45:00',13.39),('7643','2013-07-30','15:50:00',12.94),('7643','2013-07-30','15:55:00',12.62),('7643','2013-07-30','16:00:00',12.38),('7643','2013-07-30','16:05:00',12.4),('7643','2013-07-30','16:10:00',12.23),('7643','2013-07-30','16:15:00',11.96),('7643','2013-07-30','16:20:00',12.02),('7643','2013-07-30','16:25:00',10.42),('7643','2013-07-30','16:30:00',11.17),('7643','2013-07-30','16:35:00',4.97),('7643','2013-07-30','16:40:00',10.58),('7643','2013-07-30','16:45:00',10.17),('7643','2013-07-30','16:50:00',10.07),('7643','2013-07-30','16:55:00',9.77),('7643','2013-07-30','17:00:00',9.54),('7643','2013-07-30','17:05:00',9.21),('7643','2013-07-30','17:10:00',8.63),('7643','2013-07-30','17:15:00',8.44),('7643','2013-07-30','17:20:00',7.98),('7643','2013-07-30','17:25:00',7.74),('7643','2013-07-30','17:30:00',7.36),('7643','2013-07-30','17:35:00',6.99),('7643','2013-07-30','17:40:00',6.77),('7643','2013-07-30','17:45:00',6.33),('7643','2013-07-30','17:50:00',6.17),('7643','2013-07-30','17:55:00',5.76),('7643','2013-07-30','18:00:00',5.43),('7643','2013-07-30','18:05:00',5.26),('7643','2013-07-30','18:10:00',4.89),('7643','2013-07-30','18:15:00',4.6),('7643','2013-07-30','18:20:00',4.31),('7643','2013-07-30','18:25:00',4.03),('7643','2013-07-30','18:30:00',3.74),('7643','2013-07-30','18:35:00',3.42),('7643','2013-07-30','18:40:00',3.1),('7643','2013-07-30','18:45:00',2.81),('7643','2013-07-30','18:50:00',2.47),('7643','2013-07-30','18:55:00',2.11),('7643','2013-07-30','19:00:00',1.77),('7643','2013-07-30','19:05:00',1.55),('7643','2013-07-30','19:10:00',1.24),('7643','2013-07-30','19:15:00',1.06),('7643','2014-04-07','07:25:00',1.02),('7643','2014-04-07','07:35:00',1.04),('7643','2014-04-07','07:40:00',1.36),('7643','2014-04-07','07:45:00',1.82),('7643','2014-04-07','07:50:00',2.91),('7643','2014-04-07','07:55:00',2.44),('7643','2014-04-07','08:00:00',2.48),('7643','2014-04-07','08:05:00',2.38),('7643','2014-04-07','08:10:00',3.01),('7643','2014-04-07','08:15:00',5),('7643','2014-04-07','08:20:00',4.84),('7643','2014-04-07','08:25:00',4.22),('7643','2014-04-07','08:30:00',5.97),('7643','2014-04-07','08:35:00',5.9),('7643','2014-04-07','08:40:00',5.35),('7643','2014-04-07','08:45:00',6.43),('7643','2014-04-07','08:50:00',6.72),('7643','2014-04-07','08:55:00',7.13),('7643','2014-04-07','09:00:00',7.52),('7643','2014-04-07','09:05:00',7.9),('7643','2014-04-07','09:10:00',8.21),('7643','2014-04-07','09:15:00',8.53),('7643','2014-04-07','09:20:00',8.86),('7643','2014-04-07','09:25:00',9.16),('7643','2014-04-07','09:30:00',9.49),('7643','2014-04-07','09:35:00',9.69),('7643','2014-04-07','09:40:00',9.82),('7643','2014-04-07','09:45:00',10.1),('7643','2014-04-07','09:50:00',10.32),('7643','2014-04-07','09:55:00',10.49),('7643','2014-04-07','10:00:00',10.66),('7643','2014-04-07','10:05:00',10.71),('7643','2014-04-07','10:10:00',10.99),('7643','2014-04-07','10:15:00',11.74),('7643','2014-04-07','10:20:00',11.98),('7643','2014-04-07','10:25:00',12.1),('7643','2014-04-07','10:30:00',12.25),('7643','2014-04-07','10:35:00',12.4),('7643','2014-04-07','10:40:00',12.77),('7643','2014-04-07','10:45:00',13.14),('7643','2014-04-07','10:50:00',13.27),('7643','2014-04-07','10:55:00',13.56),('7643','2014-04-07','11:00:00',13.76),('7643','2014-04-07','11:05:00',13.8),('7643','2014-04-07','11:10:00',14.04),('7643','2014-04-07','11:15:00',14.1),('7643','2014-04-07','11:20:00',12.91),('7643','2014-04-07','11:25:00',13.15),('7643','2014-04-07','11:30:00',14.63),('7643','2014-04-07','11:35:00',13.57),('7643','2014-04-07','11:40:00',14.29),('7643','2014-04-07','11:45:00',14.53),('7643','2014-04-07','11:50:00',14.41),('7643','2014-04-07','11:55:00',14.71),('7643','2014-04-07','12:00:00',14.93),('7643','2014-04-07','12:05:00',14.37),('7643','2014-04-07','12:10:00',14.26),('7643','2014-04-07','12:15:00',13.86),('7643','2014-04-07','12:20:00',13.97),('7643','2014-04-07','12:25:00',14.13),('7643','2014-04-07','12:30:00',15.12),('7643','2014-04-07','12:35:00',15.88),('7643','2014-04-07','12:40:00',13.86),('7643','2014-04-07','12:45:00',12.47),('7643','2014-04-07','12:50:00',13.98),('7643','2014-04-07','12:55:00',15.83),('7643','2014-04-07','13:00:00',14.96),('7643','2014-04-07','13:05:00',15.93),('7643','2014-04-07','13:10:00',16.06),('7643','2014-04-07','13:15:00',16.29),('7643','2014-04-07','13:20:00',16.08),('7643','2014-04-07','13:25:00',15.99),('7643','2014-04-07','13:30:00',16.2),('7643','2014-04-07','13:35:00',16.18),('7643','2014-04-07','13:40:00',16.1),('7643','2014-04-07','13:45:00',15.84),('7643','2014-04-07','13:50:00',15.93),('7643','2014-04-07','13:55:00',15.98),('7643','2014-04-07','14:00:00',15.88),('7643','2014-04-07','14:05:00',15.81),('7643','2014-04-07','14:10:00',15.75),('7643','2014-04-07','14:15:00',15.62),('7643','2014-04-07','14:20:00',14.81),('7643','2014-04-07','14:25:00',15.02),('7643','2014-04-07','14:30:00',15.39),('7643','2014-04-07','14:35:00',14.67),('7643','2014-04-07','14:40:00',13.67),('7643','2014-04-07','14:45:00',12.88),('7643','2014-04-07','14:50:00',14.59),('7643','2014-04-07','14:55:00',14.95),('7643','2014-04-07','15:00:00',14.6),('7643','2014-04-07','15:05:00',14.09),('7643','2014-04-07','15:10:00',14.14),('7643','2014-04-07','15:15:00',13.91),('7643','2014-04-07','15:20:00',13.51),('7643','2014-04-07','15:25:00',13.52),('7643','2014-04-07','15:30:00',13.05),('7643','2014-04-07','15:35:00',12.83),('7643','2014-04-07','15:40:00',12.86),('7643','2014-04-07','15:45:00',12.04),('7643','2014-04-07','15:50:00',12.33),('7643','2014-04-07','15:55:00',12.18),('7643','2014-04-07','16:00:00',11.73),('7643','2014-04-07','16:05:00',11.46),('7643','2014-04-07','16:10:00',10.93),('7643','2014-04-07','16:15:00',10.24),('7643','2014-04-07','16:20:00',9.39),('7643','2014-04-07','16:25:00',10.23),('7643','2014-04-07','16:30:00',10.59),('7643','2014-04-07','16:35:00',10.36),('7643','2014-04-07','16:40:00',9.63),('7643','2014-04-07','16:45:00',9.08),('7643','2014-04-07','16:50:00',9.24),('7643','2014-04-07','16:55:00',8.53),('7643','2014-04-07','17:00:00',7.75),('7643','2014-04-07','17:05:00',8.14),('7643','2014-04-07','17:10:00',7.66),('7643','2014-04-07','17:15:00',7.42),('7643','2014-04-07','17:20:00',7.09),('7643','2014-04-07','17:25:00',6.49),('7643','2014-04-07','17:30:00',6.04),('7643','2014-04-07','17:35:00',5.26),('7643','2014-04-07','17:40:00',5.31),('7643','2014-04-07','17:45:00',4.97),('7643','2014-04-07','17:50:00',4.7),('7643','2014-04-07','17:55:00',4.13),('7643','2014-04-07','18:00:00',3.97),('7643','2014-04-07','18:05:00',3.78),('7643','2014-04-07','18:10:00',3.35),('7643','2014-04-07','18:15:00',3.14),('7643','2014-04-07','18:20:00',2.71),('7643','2014-04-07','18:25:00',2.23),('7643','2014-04-07','18:30:00',1.77),('7643','2014-04-07','18:35:00',1.51),('7643','2014-04-07','18:40:00',1.17),('7643','2013-07-29','06:55:00',1.32),('7643','2013-07-29','07:00:00',1.33),('7643','2013-07-29','07:05:00',1.77),('7643','2013-07-29','07:10:00',1.62),('7643','2013-07-29','07:15:00',1.09),('7643','2013-07-29','07:20:00',1.3),('7643','2013-07-29','07:25:00',1.98),('7643','2013-07-29','07:30:00',2.79),('7643','2013-07-29','07:35:00',2.73),('7643','2013-07-29','07:40:00',3.07),('7643','2013-07-29','07:45:00',1.7),('7643','2013-07-29','07:50:00',1.54),('7643','2013-07-29','07:55:00',3.95),('7643','2013-07-29','08:00:00',4.41),('7643','2013-07-29','08:05:00',4.82),('7643','2013-07-29','08:10:00',5.05),('7643','2013-07-29','08:15:00',5.36),('7643','2013-07-29','08:20:00',6.11),('7643','2013-07-29','08:25:00',6.56),('7643','2013-07-29','08:30:00',6.54),('7643','2013-07-29','08:35:00',6.75),('7643','2013-07-29','08:40:00',6.95),('7643','2013-07-29','08:45:00',7.31),('7643','2013-07-29','08:50:00',7.7),('7643','2013-07-29','08:55:00',8.03),('7643','2013-07-29','09:00:00',8.42),('7643','2013-07-29','09:05:00',8.75),('7643','2013-07-29','09:10:00',9),('7643','2013-07-29','09:15:00',9.12),('7643','2013-07-29','09:20:00',9.84),('7643','2013-07-29','09:25:00',10.23),('7643','2013-07-29','09:30:00',10.49),('7643','2013-07-29','09:35:00',10.86),('7643','2013-07-29','09:40:00',11.37),('7643','2013-07-29','09:45:00',11.69),('7643','2013-07-29','09:50:00',11.98),('7643','2013-07-29','09:55:00',12.09),('7643','2013-07-29','10:00:00',11.68),('7643','2013-07-29','10:05:00',12.19),('7643','2013-07-29','10:10:00',12.31),('7643','2013-07-29','10:15:00',12.4),('7643','2013-07-29','10:20:00',10.75),('7643','2013-07-29','10:25:00',11.69),('7643','2013-07-29','10:30:00',12.92),('7643','2013-07-29','10:35:00',6.3),('7643','2013-07-29','10:40:00',13.05),('7643','2013-07-29','10:45:00',13.29),('7643','2013-07-29','10:50:00',13.53),('7643','2013-07-29','10:55:00',12.42),('7643','2013-07-29','11:00:00',13.99),('7643','2013-07-29','11:05:00',14.13),('7643','2013-07-29','11:10:00',14.37),('7643','2013-07-29','11:15:00',14.52),('7643','2013-07-29','11:20:00',12.9),('7643','2013-07-29','11:25:00',2.35),('7643','2013-07-29','11:30:00',2.44),('7643','2013-07-29','11:35:00',7.81),('7643','2013-07-29','11:40:00',15.36),('7643','2013-07-29','11:45:00',15.27),('7643','2013-07-29','11:50:00',14.97),('7643','2013-07-29','11:55:00',14.68),('7643','2013-07-29','12:00:00',14.95),('7643','2013-07-29','12:05:00',14.79),('7643','2013-07-29','12:10:00',15.19),('7643','2013-07-29','12:15:00',15.06),('7643','2013-07-29','12:20:00',14.84),('7643','2013-07-29','12:25:00',15.02),('7643','2013-07-29','12:30:00',15.35),('7643','2013-07-29','12:35:00',15.62),('7643','2013-07-29','12:40:00',13.77),('7643','2013-07-29','12:45:00',7.41),('7643','2013-07-29','12:50:00',16.31),('7643','2013-07-29','12:55:00',16.58),('7643','2013-07-29','13:00:00',16.66),('7643','2013-07-29','13:05:00',11.78),('7643','2013-07-29','13:10:00',15.94),('7643','2013-07-29','13:15:00',9.45),('7643','2013-07-29','13:20:00',17.18),('7643','2013-07-29','13:25:00',16.37),('7643','2013-07-29','13:30:00',15.86),('7643','2013-07-29','13:35:00',16.22),('7643','2013-07-29','13:40:00',14.65),('7643','2013-07-29','13:45:00',15.89),('7643','2013-07-29','13:50:00',16.08),('7643','2013-07-29','13:55:00',16.09),('7643','2013-07-29','14:00:00',15.93),('7643','2013-07-29','14:05:00',16.42),('7643','2013-07-29','14:10:00',16.22),('7643','2013-07-29','14:15:00',15.84),('7643','2013-07-29','14:20:00',15.11),('7643','2013-07-29','14:25:00',15.31),('7643','2013-07-29','14:30:00',15.38),('7643','2013-07-29','14:35:00',15.05),('7643','2013-07-29','14:40:00',14.58),('7643','2013-07-29','14:45:00',14.61),('7643','2013-07-29','14:50:00',14.58),('7643','2013-07-29','14:55:00',14.41),('7643','2013-07-29','15:00:00',14.06),('7643','2013-07-29','15:05:00',13.83),('7643','2013-07-29','15:10:00',13.71),('7643','2013-07-29','15:15:00',13.6),('7643','2013-07-29','15:20:00',13.16),('7643','2013-07-29','15:25:00',12.86),('7643','2013-07-29','15:30:00',12.99),('7643','2013-07-29','15:35:00',12.89),('7643','2013-07-29','15:40:00',12.74),('7643','2013-07-29','15:45:00',12.56),('7643','2013-07-29','15:50:00',12.46),('7643','2013-07-29','15:55:00',12.19),('7643','2013-07-29','16:00:00',12.02),('7643','2013-07-29','16:05:00',11.76),('7643','2013-07-29','16:10:00',11.58),('7643','2013-07-29','16:15:00',11.36),('7643','2013-07-29','16:20:00',11.23),('7643','2013-07-29','16:25:00',10.91),('7643','2013-07-29','16:30:00',10.62),('7643','2013-07-29','16:35:00',10.48),('7643','2013-07-29','16:40:00',10.33),('7643','2013-07-29','16:45:00',9.98),('7643','2013-07-29','16:50:00',9.74),('7643','2013-07-29','16:55:00',9.45),('7643','2013-07-29','17:00:00',9.16),('7643','2013-07-29','17:05:00',8.82),('7643','2013-07-29','17:10:00',8.54),('7643','2013-07-29','17:15:00',8.23),('7643','2013-07-29','17:20:00',7.96),('7643','2013-07-29','17:25:00',7.65),('7643','2013-07-29','17:30:00',7.25),('7643','2013-07-29','17:35:00',7),('7643','2013-07-29','17:40:00',6.72),('7643','2013-07-29','17:45:00',6.34),('7643','2013-07-29','17:50:00',5.95),('7643','2013-07-29','17:55:00',5.63),('7643','2013-07-29','18:00:00',5.35),('7643','2013-07-29','18:05:00',5.01),('7643','2013-07-29','18:10:00',4.74),('7643','2013-07-29','18:15:00',4.38),('7643','2013-07-29','18:20:00',4.11),('7643','2013-07-29','18:25:00',3.88),('7643','2013-07-29','18:30:00',3.52),('7643','2013-07-29','18:35:00',3.23),('7643','2013-07-29','18:40:00',2.96),('7643','2013-07-29','18:45:00',2.69),('7643','2013-07-29','18:50:00',2.36),('7643','2013-07-29','18:55:00',2.04),('7643','2013-07-29','19:00:00',1.76),('7643','2013-07-29','19:05:00',1.53),('7643','2013-07-29','19:10:00',1.36),('7643','2013-07-29','19:15:00',1.16),('7643','2013-07-28','07:00:00',1.12),('7643','2013-07-28','07:05:00',1.3),('7643','2013-07-28','07:10:00',1.51),('7643','2013-07-28','07:15:00',1.68),('7643','2013-07-28','07:20:00',1.87),('7643','2013-07-28','07:25:00',2.08),('7643','2013-07-28','07:30:00',2.34),('7643','2013-07-28','07:35:00',2.61),('7643','2013-07-28','07:40:00',2.88),('7643','2013-07-28','07:45:00',3.15),('7643','2013-07-28','07:50:00',3.42),('7643','2013-07-28','07:55:00',3.74),('7643','2013-07-28','08:00:00',4.05),('7643','2013-07-28','08:05:00',4.36),('7643','2013-07-28','08:10:00',4.62),('7643','2013-07-28','08:15:00',4.92),('7643','2013-07-28','08:20:00',5.25),('7643','2013-07-28','08:25:00',5.49),('7643','2013-07-28','08:30:00',5.72),('7643','2013-07-28','08:35:00',5.98),('7643','2013-07-28','08:40:00',6.32),('7643','2013-07-28','08:45:00',6.62),('7643','2013-07-28','08:50:00',6.89),('7643','2013-07-28','08:55:00',7.18),('7643','2013-07-28','09:00:00',7.56),('7643','2013-07-28','09:05:00',7.83),('7643','2013-07-28','09:10:00',8.09),('7643','2013-07-28','09:15:00',8.34),('7643','2013-07-28','09:20:00',8.62),('7643','2013-07-28','09:25:00',8.82),('7643','2013-07-28','09:30:00',9.07),('7643','2013-07-28','09:35:00',9.39),('7643','2013-07-28','09:40:00',9.73),('7643','2013-07-28','09:45:00',9.99),('7643','2013-07-28','09:50:00',10.15),('7643','2013-07-28','09:55:00',10.37),('7643','2013-07-28','10:00:00',10.61),('7643','2013-07-28','10:05:00',10.91),('7643','2013-07-28','10:10:00',11.11),('7643','2013-07-28','10:15:00',11.22),('7643','2013-07-28','10:20:00',11.56),('7643','2013-07-28','10:25:00',11.63),('7643','2013-07-28','10:30:00',11.79),('7643','2013-07-28','10:35:00',12.01),('7643','2013-07-28','10:40:00',12.34),('7643','2013-07-28','10:45:00',12.4),('7643','2013-07-28','10:50:00',12.46),('7643','2013-07-28','10:55:00',12.7),('7643','2013-07-28','11:00:00',12.82),('7643','2013-07-28','11:05:00',12.73),('7643','2013-07-28','11:10:00',12.84),('7643','2013-07-28','11:15:00',13.1),('7643','2013-07-28','11:20:00',13.15),('7643','2013-07-28','11:25:00',13.34),('7643','2013-07-28','11:30:00',13.41),('7643','2013-07-28','11:35:00',13.4),('7643','2013-07-28','11:40:00',13.49),('7643','2013-07-28','11:45:00',13.61),('7643','2013-07-28','11:50:00',13.7),('7643','2013-07-28','11:55:00',13.79),('7643','2013-07-28','12:00:00',13.88),('7643','2013-07-28','12:05:00',13.85),('7643','2013-07-28','12:10:00',13.95),('7643','2013-07-28','12:15:00',14.29),('7643','2013-07-28','12:20:00',14.14),('7643','2013-07-28','12:25:00',14.11),('7643','2013-07-28','12:30:00',14.22),('7643','2013-07-28','12:35:00',14.23),('7643','2013-07-28','12:40:00',14.42),('7643','2013-07-28','12:45:00',14.52),('7643','2013-07-28','12:50:00',14.49),('7643','2013-07-28','12:55:00',14.21),('7643','2013-07-28','13:00:00',14.21),('7643','2013-07-28','13:05:00',14.39),('7643','2013-07-28','13:10:00',14.35),('7643','2013-07-28','13:15:00',14.49),('7643','2013-07-28','13:20:00',14.72),('7643','2013-07-28','13:25:00',15.02),('7643','2013-07-28','13:30:00',15.06),('7643','2013-07-28','13:35:00',15.16),('7643','2013-07-28','13:40:00',15.15),('7643','2013-07-28','13:45:00',15.2),('7643','2013-07-28','13:50:00',15.17),('7643','2013-07-28','13:55:00',15.11),('7643','2013-07-28','14:00:00',15.02),('7643','2013-07-28','14:05:00',14.88),('7643','2013-07-28','14:10:00',14.85),('7643','2013-07-28','14:15:00',14.81),('7643','2013-07-28','14:20:00',14.8),('7643','2013-07-28','14:25:00',14.52),('7643','2013-07-28','14:30:00',14.39),('7643','2013-07-28','14:35:00',14.32),('7643','2013-07-28','14:40:00',14.21),('7643','2013-07-28','14:45:00',14.2),('7643','2013-07-28','14:50:00',14.07),('7643','2013-07-28','14:55:00',14),('7643','2013-07-28','15:00:00',13.91),('7643','2013-07-28','15:05:00',13.72),('7643','2013-07-28','15:10:00',13.44),('7643','2013-07-28','15:15:00',13.42),('7643','2013-07-28','15:20:00',13.24),('7643','2013-07-28','15:25:00',13.17),('7643','2013-07-28','15:30:00',13),('7643','2013-07-28','15:35:00',12.89),('7643','2013-07-28','15:40:00',12.94),('7643','2013-07-28','15:45:00',13.14),('7643','2013-07-28','15:50:00',11.08),('7643','2013-07-28','15:55:00',7.53),('7643','2013-07-28','16:00:00',6.41),('7643','2013-07-28','16:05:00',9.85),('7643','2013-07-28','16:10:00',11.64),('7643','2013-07-28','16:15:00',8.99),('7643','2013-07-28','16:20:00',9.35),('7643','2013-07-28','16:25:00',8.76),('7643','2013-07-28','16:30:00',11.57),('7643','2013-07-28','16:35:00',9.75),('7643','2013-07-28','16:40:00',7.95),('7643','2013-07-28','16:45:00',10.99),('7643','2013-07-28','16:50:00',9.8),('7643','2013-07-28','16:55:00',6.53),('7643','2013-07-28','17:00:00',4.85),('7643','2013-07-28','17:05:00',6.37),('7643','2013-07-28','17:10:00',4.86),('7643','2013-07-28','17:15:00',3.28),('7643','2013-07-28','17:20:00',7.31),('7643','2013-07-28','17:25:00',7.54),('7643','2013-07-28','17:30:00',4.55),('7643','2013-07-28','17:35:00',3.16),('7643','2013-07-28','17:40:00',3.83),('7643','2013-07-28','17:45:00',6.81),('7643','2013-07-28','17:50:00',6.14),('7643','2013-07-28','17:55:00',5.49),('7643','2013-07-28','18:00:00',4.14),('7643','2013-07-28','18:05:00',2.9),('7643','2013-07-28','18:10:00',4.14),('7643','2013-07-28','18:15:00',3.83),('7643','2013-07-28','18:20:00',4.14),('7643','2013-07-28','18:25:00',3.8),('7643','2013-07-28','18:30:00',3.67),('7643','2013-07-28','18:35:00',3.22),('7643','2013-07-28','18:40:00',2.37),('7643','2013-07-28','18:45:00',1.37),('7643','2013-07-28','18:50:00',1.79),('7643','2013-07-28','18:55:00',1.82),('7643','2013-07-28','19:00:00',2.39),('7643','2013-07-28','19:05:00',2.38),('7643','2013-07-28','19:10:00',1.97),('7643','2013-07-28','19:15:00',1.19),('7643','2013-07-27','07:00:00',1),('7643','2013-07-27','07:05:00',1.19),('7643','2013-07-27','07:10:00',1.41),('7643','2013-07-27','07:15:00',1.61),('7643','2013-07-27','07:20:00',1.81),('7643','2013-07-27','07:25:00',2.07),('7643','2013-07-27','07:30:00',2.32),('7643','2013-07-27','07:35:00',2.62),('7643','2013-07-27','07:40:00',2.82),('7643','2013-07-27','07:45:00',3.13),('7643','2013-07-27','07:50:00',3.38),('7643','2013-07-27','07:55:00',3.67),('7643','2013-07-27','08:00:00',3.99),('7643','2013-07-27','08:05:00',4.34),('7643','2013-07-27','08:10:00',4.64),('7643','2013-07-27','08:15:00',4.96),('7643','2013-07-27','08:20:00',5.29),('7643','2013-07-27','08:25:00',5.6),('7643','2013-07-27','08:30:00',5.89),('7643','2013-07-27','08:35:00',6.25),('7643','2013-07-27','08:40:00',6.54),('7643','2013-07-27','08:45:00',6.86),('7643','2013-07-27','08:50:00',7.13),('7643','2013-07-27','08:55:00',7.44),('7643','2013-07-27','09:00:00',7.7),('7643','2013-07-27','09:05:00',8.02),('7643','2013-07-27','09:10:00',8.36),('7643','2013-07-27','09:15:00',8.63),('7643','2013-07-27','09:20:00',8.78),('7643','2013-07-27','09:25:00',9.11),('7643','2013-07-27','09:30:00',9.4),('7643','2013-07-27','09:35:00',9.63),('7643','2013-07-27','09:40:00',9.92),('7643','2013-07-27','09:45:00',10.01),('7643','2013-07-27','09:50:00',10.2),('7643','2013-07-27','09:55:00',10.41),('7643','2013-07-27','10:00:00',10.61),('7643','2013-07-27','10:05:00',10.84),('7643','2013-07-27','10:10:00',11.02),('7643','2013-07-27','10:15:00',11.11),('7643','2013-07-27','10:20:00',11.36),('7643','2013-07-27','10:25:00',11.52),('7643','2013-07-27','10:30:00',11.82),('7643','2013-07-27','10:35:00',12.03),('7643','2013-07-27','10:40:00',12.16),('7643','2013-07-27','10:45:00',12.41),('7643','2013-07-27','10:50:00',12.54),('7643','2013-07-27','10:55:00',12.68),('7643','2013-07-27','11:00:00',12.85),('7643','2013-07-27','11:05:00',12.94),('7643','2013-07-27','11:10:00',13.01),('7643','2013-07-27','11:15:00',13.09),('7643','2013-07-27','11:20:00',13.22),('7643','2013-07-27','11:25:00',13.18),('7643','2013-07-27','11:30:00',13.24),('7643','2013-07-27','11:35:00',13.19),('7643','2013-07-27','11:40:00',13.52),('7643','2013-07-27','11:45:00',13.64),('7643','2013-07-27','11:50:00',13.72),('7643','2013-07-27','11:55:00',13.83),('7643','2013-07-27','12:00:00',14.03),('7643','2013-07-27','12:05:00',14.03),('7643','2013-07-27','12:10:00',14.09),('7643','2013-07-27','12:15:00',14.31),('7643','2013-07-27','12:20:00',14.19),('7643','2013-07-27','12:25:00',14.13),('7643','2013-07-27','12:30:00',14.04),('7643','2013-07-27','12:35:00',14.5),('7643','2013-07-27','12:40:00',14.53),('7643','2013-07-27','12:45:00',14.38),('7643','2013-07-27','12:50:00',14.21),('7643','2013-07-27','12:55:00',14.25),('7643','2013-07-27','13:00:00',14.48),('7643','2013-07-27','13:05:00',14.16),('7643','2013-07-27','13:10:00',14.57),('7643','2013-07-27','13:15:00',14.96),('7643','2013-07-27','13:20:00',14.82),('7643','2013-07-27','13:25:00',14.8),('7643','2013-07-27','13:30:00',14.73),('7643','2013-07-27','13:35:00',14.92),('7643','2013-07-27','13:40:00',15.07),('7643','2013-07-27','13:45:00',14.79),('7643','2013-07-27','13:50:00',14.83),('7643','2013-07-27','13:55:00',14.75),('7643','2013-07-27','14:00:00',14.66),('7643','2013-07-27','14:05:00',14.49),('7643','2013-07-27','14:10:00',14.36),('7643','2013-07-27','14:15:00',14.52),('7643','2013-07-27','14:20:00',14.26),('7643','2013-07-27','14:25:00',14.29),('7643','2013-07-27','14:30:00',14.21),('7643','2013-07-27','14:35:00',14.18),('7643','2013-07-27','14:40:00',14.04),('7643','2013-07-27','14:45:00',13.87),('7643','2013-07-27','14:50:00',13.82),('7643','2013-07-27','14:55:00',13.69),('7643','2013-07-27','15:00:00',13.41),('7643','2013-07-27','15:05:00',13.36),('7643','2013-07-27','15:10:00',13.31),('7643','2013-07-27','15:15:00',13.16),('7643','2013-07-27','15:20:00',12.83),('7643','2013-07-27','15:25:00',12.75),('7643','2013-07-27','15:30:00',12.64),('7643','2013-07-27','15:35:00',12.54),('7643','2013-07-27','15:40:00',12.4),('7643','2013-07-27','15:45:00',12.2),('7643','2013-07-27','15:50:00',12.09),('7643','2013-07-27','15:55:00',11.87),('7643','2013-07-27','16:00:00',11.66),('7643','2013-07-27','16:05:00',11.64),('7643','2013-07-27','16:10:00',11.46),('7643','2013-07-27','16:15:00',11.26),('7643','2013-07-27','16:20:00',11.12),('7643','2013-07-27','16:25:00',10.9),('7643','2013-07-27','16:30:00',10.77),('7643','2013-07-27','16:35:00',10.6),('7643','2013-07-27','16:40:00',10.37),('7643','2013-07-27','16:45:00',10.04),('7643','2013-07-27','16:50:00',9.74),('7643','2013-07-27','16:55:00',9.52),('7643','2013-07-27','17:00:00',9.25),('7643','2013-07-27','17:05:00',8.94),('7643','2013-07-27','17:10:00',8.64),('7643','2013-07-27','17:15:00',8.38),('7643','2013-07-27','17:20:00',8.08),('7643','2013-07-27','17:25:00',7.71),('7643','2013-07-27','17:30:00',7.4),('7643','2013-07-27','17:35:00',7.14),('7643','2013-07-27','17:40:00',6.81),('7643','2013-07-27','17:45:00',6.53),('7643','2013-07-27','17:50:00',6.16),('7643','2013-07-27','17:55:00',5.77),('7643','2013-07-27','18:00:00',5.46),('7643','2013-07-27','18:05:00',5.18),('7643','2013-07-27','18:10:00',4.86),('7643','2013-07-27','18:15:00',4.52),('7643','2013-07-27','18:20:00',4.18),('7643','2013-07-27','18:25:00',3.81),('7643','2013-07-27','18:30:00',3.62),('7643','2013-07-27','18:35:00',3.31),('7643','2013-07-27','18:40:00',3.01),('7643','2013-07-27','18:45:00',2.73),('7643','2013-07-27','18:50:00',2.44),('7643','2013-07-27','18:55:00',2.13),('7643','2013-07-27','19:00:00',1.84),('7643','2013-07-27','19:05:00',1.6),('7643','2013-07-27','19:10:00',1.35),('7643','2013-07-27','19:15:00',1.19),('7643','2013-07-26','07:00:00',1.1),('7643','2013-07-26','07:05:00',1.29),('7643','2013-07-26','07:10:00',1.49),('7643','2013-07-26','07:15:00',1.67),('7643','2013-07-26','07:20:00',1.85),('7643','2013-07-26','07:25:00',2.12),('7643','2013-07-26','07:30:00',2.36),('7643','2013-07-26','07:35:00',2.64),('7643','2013-07-26','07:40:00',2.88),('7643','2013-07-26','07:45:00',3.17),('7643','2013-07-26','07:50:00',3.49),('7643','2013-07-26','07:55:00',3.81),('7643','2013-07-26','08:00:00',4.14),('7643','2013-07-26','08:05:00',4.49),('7643','2013-07-26','08:10:00',4.76),('7643','2013-07-26','08:15:00',5.12),('7643','2013-07-26','08:20:00',5.47),('7643','2013-07-26','08:25:00',5.78),('7643','2013-07-26','08:30:00',6.05),('7643','2013-07-26','08:35:00',6.4),('7643','2013-07-26','08:40:00',6.68),('7643','2013-07-26','08:45:00',6.93),('7643','2013-07-26','08:50:00',7.23),('7643','2013-07-26','08:55:00',7.57),('7643','2013-07-26','09:00:00',7.93),('7643','2013-07-26','09:05:00',8.17),('7643','2013-07-26','09:10:00',8.45),('7643','2013-07-26','09:15:00',8.71),('7643','2013-07-26','09:20:00',9.05),('7643','2013-07-26','09:25:00',9.3),('7643','2013-07-26','09:30:00',9.52),('7643','2013-07-26','09:35:00',9.76),('7643','2013-07-26','09:40:00',10.03),('7643','2013-07-26','09:45:00',10.3),('7643','2013-07-26','09:50:00',10.49),('7643','2013-07-26','09:55:00',10.76),('7643','2013-07-26','10:00:00',10.98),('7643','2013-07-26','10:05:00',11.23),('7643','2013-07-26','10:10:00',11.46),('7643','2013-07-26','10:15:00',11.67),('7643','2013-07-26','10:20:00',11.76),('7643','2013-07-26','10:25:00',11.89),('7643','2013-07-26','10:30:00',12.03),('7643','2013-07-26','10:35:00',12.24),('7643','2013-07-26','10:40:00',12.37),('7643','2013-07-26','10:45:00',12.46),('7643','2013-07-26','10:50:00',12.73),('7643','2013-07-26','10:55:00',12.85),('7643','2013-07-26','11:00:00',12.87),('7643','2013-07-26','11:05:00',13.05),('7643','2013-07-26','11:10:00',13.02),('7643','2013-07-26','11:15:00',13.13),('7643','2013-07-26','11:20:00',13.38),('7643','2013-07-26','11:25:00',13.74),('7643','2013-07-26','11:30:00',13.91),('7643','2013-07-26','11:35:00',14),('7643','2013-07-26','11:40:00',13.96),('7643','2013-07-26','11:45:00',14.15),('7643','2013-07-26','11:50:00',14.16),('7643','2013-07-26','11:55:00',14.21),('7643','2013-07-26','12:00:00',14.22),('7643','2013-07-26','12:05:00',14.62),('7643','2013-07-26','12:10:00',14.46),('7643','2013-07-26','12:15:00',14.52),('7643','2013-07-26','12:20:00',14.84),('7643','2013-07-26','12:25:00',14.59),('7643','2013-07-26','12:30:00',14.36),('7643','2013-07-26','12:35:00',14.27),('7643','2013-07-26','12:40:00',14.08),('7643','2013-07-26','12:45:00',14.56),('7643','2013-07-26','12:50:00',14.45),('7643','2013-07-26','12:55:00',14.58),('7643','2013-07-26','13:00:00',15.01),('7643','2013-07-26','13:05:00',15.13),('7643','2013-07-26','13:10:00',15.28),('7643','2013-07-26','13:15:00',15.42),('7643','2013-07-26','13:20:00',14.88),('7643','2013-07-26','13:25:00',15.08),('7643','2013-07-26','13:30:00',15.03),('7643','2013-07-26','13:35:00',15.48),('7643','2013-07-26','13:40:00',14.51),('7643','2013-07-26','13:45:00',15.45),('7643','2013-07-26','13:50:00',15.19),('7643','2013-07-26','13:55:00',15.14),('7643','2013-07-26','14:00:00',13.31),('7643','2013-07-26','14:05:00',14.48),('7643','2013-07-26','14:10:00',15.27),('7643','2013-07-26','14:15:00',14.62),('7643','2013-07-26','14:20:00',14.41),('7643','2013-07-26','14:25:00',14.23),('7643','2013-07-26','14:30:00',14.15),('7643','2013-07-26','14:35:00',14.26),('7643','2013-07-26','14:40:00',14.43),('7643','2013-07-26','14:45:00',14.22),('7643','2013-07-26','14:50:00',13.98),('7643','2013-07-26','14:55:00',13.87),('7643','2013-07-26','15:00:00',13.75);
INSERT INTO `solarlog` VALUES ('7643','2013-07-26','15:05:00',13.56),('7643','2013-07-26','15:10:00',13.52),('7643','2013-07-26','15:15:00',13.33),('7643','2013-07-26','15:20:00',13.27),('7643','2013-07-26','15:25:00',13.16),('7643','2013-07-26','15:30:00',12.94),('7643','2013-07-26','15:35:00',12.85),('7643','2013-07-26','15:40:00',12.7),('7643','2013-07-26','15:45:00',12.5),('7643','2013-07-26','15:50:00',12.31),('7643','2013-07-26','15:55:00',12.11),('7643','2013-07-26','16:00:00',11.85),('7643','2013-07-26','16:05:00',11.83),('7643','2013-07-26','16:10:00',11.54),('7643','2013-07-26','16:15:00',11.32),('7643','2013-07-26','16:20:00',11.07),('7643','2013-07-26','16:25:00',10.97),('7643','2013-07-26','16:30:00',10.79),('7643','2013-07-26','16:35:00',10.55),('7643','2013-07-26','16:40:00',10.36),('7643','2013-07-26','16:45:00',10.13),('7643','2013-07-26','16:50:00',9.89),('7643','2013-07-26','16:55:00',9.53),('7643','2013-07-26','17:00:00',9.2),('7643','2013-07-26','17:05:00',8.87),('7643','2013-07-26','17:10:00',8.62),('7643','2013-07-26','17:15:00',8.28),('7643','2013-07-26','17:20:00',8.02),('7643','2013-07-26','17:25:00',7.67),('7643','2013-07-26','17:30:00',7.36),('7643','2013-07-26','17:35:00',7.06),('7643','2013-07-26','17:40:00',6.67),('7643','2013-07-26','17:45:00',6.38),('7643','2013-07-26','17:50:00',6.09),('7643','2013-07-26','17:55:00',5.77),('7643','2013-07-26','18:00:00',5.56),('7643','2013-07-26','18:05:00',5.28),('7643','2013-07-26','18:10:00',4.94),('7643','2013-07-26','18:15:00',4.57),('7643','2013-07-26','18:20:00',4.24),('7643','2013-07-26','18:25:00',3.86),('7643','2013-07-26','18:30:00',3.76),('7643','2013-07-26','18:35:00',3.45),('7643','2013-07-26','18:40:00',3.16),('7643','2013-07-26','18:45:00',2.87),('7643','2013-07-26','18:50:00',2.56),('7643','2013-07-26','18:55:00',2.21),('7643','2013-07-26','19:00:00',1.95),('7643','2013-07-26','19:05:00',1.69),('7643','2013-07-26','19:10:00',1.44),('7643','2013-07-26','19:15:00',1.27),('7643','2013-07-26','19:20:00',1.04),('7643','2013-07-25','07:00:00',1.11),('7643','2013-07-25','07:05:00',1.27),('7643','2013-07-25','07:10:00',1.49),('7643','2013-07-25','07:15:00',1.7),('7643','2013-07-25','07:20:00',1.93),('7643','2013-07-25','07:25:00',2.16),('7643','2013-07-25','07:30:00',2.42),('7643','2013-07-25','07:35:00',2.72),('7643','2013-07-25','07:40:00',2.98),('7643','2013-07-25','07:45:00',3.27),('7643','2013-07-25','07:50:00',3.47),('7643','2013-07-25','07:55:00',3.69),('7643','2013-07-25','08:00:00',3.96),('7643','2013-07-25','08:05:00',4.33),('7643','2013-07-25','08:10:00',4.7),('7643','2013-07-25','08:15:00',4.97),('7643','2013-07-25','08:20:00',5.2),('7643','2013-07-25','08:25:00',5.56),('7643','2013-07-25','08:30:00',5.87),('7643','2013-07-25','08:35:00',6.23),('7643','2013-07-25','08:40:00',6.54),('7643','2013-07-25','08:45:00',6.81),('7643','2013-07-25','08:50:00',7.03),('7643','2013-07-25','08:55:00',7.53),('7643','2013-07-25','09:00:00',7.76),('7643','2013-07-25','09:05:00',8),('7643','2013-07-25','09:10:00',8.27),('7643','2013-07-25','09:15:00',8.57),('7643','2013-07-25','09:20:00',8.79),('7643','2013-07-25','09:25:00',9.05),('7643','2013-07-25','09:30:00',9.42),('7643','2013-07-25','09:35:00',9.28),('7643','2013-07-25','09:40:00',9.65),('7643','2013-07-25','09:45:00',10.08),('7643','2013-07-25','09:50:00',10.4),('7643','2013-07-25','09:55:00',10.58),('7643','2013-07-25','10:00:00',10.81),('7643','2013-07-25','10:05:00',10.81),('7643','2013-07-25','10:10:00',11.02),('7643','2013-07-25','10:15:00',11.13),('7643','2013-07-25','10:20:00',11.59),('7643','2013-07-25','10:25:00',11.78),('7643','2013-07-25','10:30:00',11.84),('7643','2013-07-25','10:35:00',12.1),('7643','2013-07-25','10:40:00',12.3),('7643','2013-07-25','10:45:00',12.39),('7643','2013-07-25','10:50:00',12.63),('7643','2013-07-25','10:55:00',12.89),('7643','2013-07-25','11:00:00',12.85),('7643','2013-07-25','11:05:00',12.28),('7643','2013-07-25','11:10:00',11.58),('7643','2013-07-25','11:15:00',13.21),('7643','2013-07-25','11:20:00',13.33),('7643','2013-07-25','11:25:00',13.79),('7643','2013-07-25','11:30:00',13.9),('7643','2013-07-25','11:35:00',13.36),('7643','2013-07-25','11:40:00',14.1),('7643','2013-07-25','11:45:00',14.33),('7643','2013-07-25','11:50:00',14.29),('7643','2013-07-25','11:55:00',14.61),('7643','2013-07-25','12:00:00',2.9),('7643','2013-07-25','13:45:00',13.62),('7643','2013-07-25','13:50:00',14.81),('7643','2013-07-25','14:30:00',14.67),('7643','2013-07-25','14:35:00',14.67),('7643','2013-07-25','14:40:00',14.7),('7643','2013-07-25','14:45:00',14.31),('7643','2013-07-25','14:50:00',14.33),('7643','2013-07-25','14:55:00',13.95),('7643','2013-07-25','15:00:00',13.98),('7643','2013-07-25','15:05:00',13.8),('7643','2013-07-25','15:10:00',13.63),('7643','2013-07-25','15:15:00',13.65),('7643','2013-07-25','15:20:00',13.4),('7643','2013-07-25','15:25:00',13.14),('7643','2013-07-25','15:30:00',12.99),('7643','2013-07-25','15:35:00',12.92),('7643','2013-07-25','15:40:00',12.87),('7643','2013-07-25','15:45:00',12.79),('7643','2013-07-25','15:50:00',12.52),('7643','2013-07-25','15:55:00',12.25),('7643','2013-07-25','16:00:00',12.01),('7643','2013-07-25','16:05:00',11.86),('7643','2013-07-25','16:10:00',11.62),('7643','2013-07-25','16:15:00',11.4),('7643','2013-07-25','16:20:00',11.23),('7643','2013-07-25','16:25:00',11.02),('7643','2013-07-25','16:30:00',10.81),('7643','2013-07-25','16:35:00',10.51),('7643','2013-07-25','16:40:00',10.33),('7643','2013-07-25','16:45:00',10.14),('7643','2013-07-25','16:50:00',9.77),('7643','2013-07-25','16:55:00',9.38),('7643','2013-07-25','17:00:00',9.08),('7643','2013-07-25','17:05:00',8.86),('7643','2013-07-25','17:10:00',8.65),('7643','2013-07-25','17:15:00',8.21),('7643','2013-07-25','17:20:00',7.92),('7643','2013-07-25','17:25:00',7.67),('7643','2013-07-25','17:30:00',7.22),('7643','2013-07-25','17:35:00',6.95),('7643','2013-07-25','17:40:00',6.7),('7643','2013-07-25','17:45:00',6.37),('7643','2013-07-25','17:50:00',5.89),('7643','2013-07-25','17:55:00',5.6),('7643','2013-07-25','18:00:00',5.24),('7643','2013-07-25','18:05:00',5.03),('7643','2013-07-25','18:10:00',4.74),('7643','2013-07-25','18:15:00',4.4),('7643','2013-07-25','18:20:00',4.05),('7643','2013-07-25','18:25:00',3.88),('7643','2013-07-25','18:30:00',3.63),('7643','2013-07-25','18:35:00',3.31),('7643','2013-07-25','18:40:00',3.03),('7643','2013-07-25','18:45:00',2.75),('7643','2013-07-25','18:50:00',2.5),('7643','2013-07-25','18:55:00',2.19),('7643','2013-07-25','19:00:00',1.89),('7643','2013-07-25','19:05:00',1.66),('7643','2013-07-25','19:10:00',1.48),('7643','2013-07-25','19:15:00',1.3),('7643','2013-07-25','19:20:00',1.11),('7643','2013-07-24','06:55:00',1.02),('7643','2013-07-24','07:00:00',1.19),('7643','2013-07-24','07:05:00',1.35),('7643','2013-07-24','07:10:00',1.57),('7643','2013-07-24','07:15:00',1.74),('7643','2013-07-24','07:20:00',1.95),('7643','2013-07-24','07:25:00',2.21),('7643','2013-07-24','07:30:00',2.43),('7643','2013-07-24','07:35:00',2.66),('7643','2013-07-24','07:40:00',2.95),('7643','2013-07-24','07:45:00',3.25),('7643','2013-07-24','07:50:00',3.55),('7643','2013-07-24','07:55:00',3.82),('7643','2013-07-24','08:00:00',4.13),('7643','2013-07-24','08:05:00',4.42),('7643','2013-07-24','08:10:00',4.7),('7643','2013-07-24','08:15:00',5.04),('7643','2013-07-24','08:20:00',5.28),('7643','2013-07-24','08:25:00',5.74),('7643','2013-07-24','08:30:00',5.9),('7643','2013-07-24','08:35:00',6.11),('7643','2013-07-24','08:40:00',6.54),('7643','2013-07-24','08:45:00',6.68),('7643','2013-07-24','08:50:00',7.35),('7643','2013-07-24','08:55:00',7.54),('7643','2013-07-24','09:00:00',7.84),('7643','2013-07-24','09:05:00',8.4),('7643','2013-07-24','09:10:00',8.51),('7643','2013-07-24','09:15:00',9.05),('7643','2013-07-24','09:20:00',9.31),('7643','2013-07-24','09:25:00',5.14),('7643','2013-07-24','09:30:00',7.23),('7643','2013-07-24','09:35:00',4.99),('7643','2013-07-24','09:40:00',10.2),('7643','2013-07-24','09:45:00',11.47),('7643','2013-07-24','09:50:00',7.38),('7643','2013-07-24','09:55:00',3.32),('7643','2013-07-24','10:00:00',3.25),('7643','2013-07-24','10:05:00',3.92),('7643','2013-07-24','10:10:00',11.22),('7643','2013-07-24','10:15:00',12.18),('7643','2013-07-24','10:20:00',12.49),('7643','2013-07-24','10:25:00',12.83),('7643','2013-07-24','10:30:00',12.08),('7643','2013-07-24','10:35:00',10.48),('7643','2013-07-24','10:40:00',10.16),('7643','2013-07-24','10:45:00',7.71),('7643','2013-07-24','10:50:00',5.73),('7643','2013-07-24','10:55:00',4.51),('7643','2013-07-24','11:00:00',7.05),('7643','2013-07-24','11:05:00',9.79),('7643','2013-07-24','11:10:00',14.68),('7643','2013-07-24','11:15:00',14.24),('7643','2013-07-24','11:20:00',14.29),('7643','2013-07-24','11:25:00',14.52),('7643','2013-07-24','11:30:00',14.76),('7643','2013-07-24','11:35:00',14.43),('7643','2013-07-24','11:40:00',9.77),('7643','2013-07-24','11:45:00',7.39),('7643','2013-07-24','11:50:00',10.69),('7643','2013-07-24','11:55:00',6.6),('7643','2013-07-24','12:00:00',12.78),('7643','2013-07-24','12:05:00',12.95),('7643','2013-07-24','12:10:00',4.5),('7643','2013-07-24','12:15:00',9.05),('7643','2013-07-24','12:20:00',9.93),('7643','2013-07-24','12:25:00',6.76),('7643','2013-07-24','12:30:00',5.49),('7643','2013-07-24','12:35:00',10.92),('7643','2013-07-24','12:40:00',5.32),('7643','2013-07-24','12:45:00',4.63),('7643','2013-07-24','12:50:00',6.95),('7643','2013-07-24','12:55:00',6.01),('7643','2013-07-24','13:00:00',4.78),('7643','2013-07-24','13:05:00',17.19),('7643','2013-07-24','13:10:00',16.69),('7643','2013-07-24','13:15:00',16.2),('7643','2013-07-24','13:20:00',16.36),('7643','2013-07-24','13:25:00',15.87),('7643','2013-07-24','13:30:00',16.08),('7643','2013-07-24','13:35:00',15.51),('7643','2013-07-24','13:40:00',15.65),('7643','2013-07-24','13:45:00',15.08),('7643','2013-07-24','13:50:00',15.38),('7643','2013-07-24','13:55:00',15.59),('7643','2013-07-24','14:00:00',15.28),('7643','2013-07-24','14:05:00',15.53),('7643','2013-07-24','14:10:00',15.68),('7643','2013-07-24','14:15:00',15.74),('7643','2013-07-24','14:20:00',15.61),('7643','2013-07-24','14:25:00',15.55),('7643','2013-07-24','14:30:00',15.33),('7643','2013-07-24','14:35:00',15.19),('7643','2013-07-24','14:40:00',15),('7643','2013-07-24','14:45:00',15),('7643','2013-07-24','14:50:00',15),('7643','2013-07-24','14:55:00',14.87),('7643','2013-07-24','15:00:00',14.74),('7643','2013-07-24','15:05:00',14.51),('7643','2013-07-24','15:10:00',14.28),('7643','2013-07-24','15:15:00',14.05),('7643','2013-07-24','15:20:00',13.9),('7643','2013-07-24','15:25:00',13.74),('7643','2013-07-24','15:30:00',13.72),('7643','2013-07-24','15:35:00',13.61),('7643','2013-07-24','15:40:00',13.35),('7643','2013-07-24','15:45:00',13.14),('7643','2013-07-24','15:50:00',12.91),('7643','2013-07-24','15:55:00',12.82),('7643','2013-07-24','16:00:00',12.67),('7643','2013-07-24','16:05:00',12.45),('7643','2013-07-24','16:10:00',12.21),('7643','2013-07-24','16:15:00',12),('7643','2013-07-24','16:20:00',11.75),('7643','2013-07-24','16:25:00',11.53),('7643','2013-07-24','16:30:00',11.22),('7643','2013-07-24','16:35:00',10.94),('7643','2013-07-24','16:40:00',10.73),('7643','2013-07-24','16:45:00',10.56),('7643','2013-07-24','16:50:00',10.31),('7643','2013-07-24','16:55:00',9.96),('7643','2013-07-24','17:00:00',9.69),('7643','2013-07-24','17:05:00',9.46),('7643','2013-07-24','17:10:00',9.09),('7643','2013-07-24','17:15:00',8.78),('7643','2013-07-24','17:20:00',8.47),('7643','2013-07-24','17:25:00',8.09),('7643','2013-07-24','17:30:00',7.91),('7643','2013-07-24','17:35:00',7.51),('7643','2013-07-24','17:40:00',7.15),('7643','2013-07-24','17:45:00',6.85),('7643','2013-07-24','17:50:00',6.43),('7643','2013-07-24','17:55:00',6.11),('7643','2013-07-24','18:00:00',5.91),('7643','2013-07-24','18:05:00',5.58),('7643','2013-07-24','18:10:00',5.25),('7643','2013-07-24','18:15:00',4.74),('7643','2013-07-24','18:20:00',4.35),('7643','2013-07-24','18:25:00',4.15),('7643','2013-07-24','18:30:00',3.89),('7643','2013-07-24','18:35:00',3.59),('7643','2013-07-24','18:40:00',3.25),('7643','2013-07-24','18:45:00',2.84),('7643','2013-07-24','18:50:00',2.63),('7643','2013-07-24','18:55:00',2.24),('7643','2013-07-24','19:00:00',1.92),('7643','2013-07-24','19:05:00',1.61),('7643','2013-07-24','19:10:00',1.44),('7643','2013-07-24','19:15:00',1.29),('7643','2013-07-24','19:20:00',1.05),('7643','2013-07-23','07:15:00',1.13),('7643','2013-07-23','07:20:00',1.52),('7643','2013-07-23','07:25:00',1.74),('7643','2013-07-23','07:30:00',1.52),('7643','2013-07-23','07:35:00',1.63),('7643','2013-07-23','07:40:00',1.87),('7643','2013-07-23','07:45:00',2.13),('7643','2013-07-23','07:50:00',2.72),('7643','2013-07-23','07:55:00',3.15),('7643','2013-07-23','08:00:00',3.47),('7643','2013-07-23','08:05:00',3.29),('7643','2013-07-23','08:10:00',3.27),('7643','2013-07-23','08:15:00',4.59),('7643','2013-07-23','08:20:00',4.5),('7643','2013-07-23','08:25:00',6.12),('7643','2013-07-23','08:30:00',5.68),('7643','2013-07-23','08:35:00',4.09),('7643','2013-07-23','08:40:00',5.42),('7643','2013-07-23','08:45:00',5.57),('7643','2013-07-23','08:50:00',7.25),('7643','2013-07-23','08:55:00',5.75),('7643','2013-07-23','09:00:00',6.41),('7643','2013-07-23','09:05:00',8.11),('7643','2013-07-23','09:10:00',8.9),('7643','2013-07-23','09:15:00',7.12),('7643','2013-07-23','09:20:00',4.36),('7643','2013-07-23','09:25:00',3.99),('7643','2013-07-23','09:30:00',6.69),('7643','2013-07-23','09:35:00',8.62),('7643','2013-07-23','09:40:00',10.34),('7643','2013-07-23','09:45:00',6.31),('7643','2013-07-23','09:50:00',5.21),('7643','2013-07-23','09:55:00',4.66),('7643','2013-07-23','10:00:00',3.93),('7643','2013-07-23','10:05:00',4.5),('7643','2013-07-23','10:10:00',3.63),('7643','2013-07-23','10:15:00',3.65),('7643','2013-07-23','10:20:00',3.85),('7643','2013-07-23','10:25:00',8.83),('7643','2013-07-23','10:30:00',12.89),('7643','2013-07-23','10:35:00',13.11),('7643','2013-07-23','10:40:00',14.24),('7643','2013-07-23','10:45:00',11.57),('7643','2013-07-23','10:50:00',6.55),('7643','2013-07-23','10:55:00',7.83),('7643','2013-07-23','11:00:00',9.86),('7643','2013-07-23','11:05:00',12.26),('7643','2013-07-23','11:10:00',13.08),('7643','2013-07-23','11:15:00',8.97),('7643','2013-07-23','11:20:00',9.85),('7643','2013-07-23','11:25:00',15.11),('7643','2013-07-23','11:30:00',14.61),('7643','2013-07-23','11:35:00',14.9),('7643','2013-07-23','11:40:00',14.75),('7643','2013-07-23','11:45:00',14.79),('7643','2013-07-23','11:50:00',14.49),('7643','2013-07-23','11:55:00',14.95),('7643','2013-07-23','12:00:00',15.32),('7643','2013-07-23','12:05:00',14.98),('7643','2013-07-23','12:10:00',6.15),('7643','2013-07-23','12:15:00',8.99),('7643','2013-07-23','12:20:00',16.31),('7643','2013-07-23','12:25:00',6.85),('7643','2013-07-23','12:30:00',4.58),('7643','2013-07-23','12:35:00',4.01),('7643','2013-07-23','12:40:00',4.17),('7643','2013-07-23','12:45:00',13.12),('7643','2013-07-23','12:50:00',6.73),('7643','2013-07-23','12:55:00',4.81),('7643','2013-07-23','13:00:00',6.19),('7643','2013-07-23','13:05:00',17.31),('7643','2013-07-23','13:10:00',16.71),('7643','2013-07-23','13:15:00',15.15),('7643','2013-07-23','13:20:00',10.08),('7643','2013-07-23','13:25:00',2.99),('7643','2013-07-23','13:30:00',3.06),('7643','2013-07-23','13:35:00',5.37),('7643','2013-07-23','13:40:00',3.92),('7643','2013-07-23','13:45:00',3.7),('7643','2013-07-23','13:50:00',6.53),('7643','2013-07-23','13:55:00',15.13),('7643','2013-07-23','14:00:00',10.95),('7643','2013-07-23','14:05:00',15.89),('7643','2013-07-23','14:10:00',9.99),('7643','2013-07-23','14:15:00',16.64),('7643','2013-07-23','14:20:00',15.87),('7643','2013-07-23','14:25:00',12),('7643','2013-07-23','14:30:00',11.83),('7643','2013-07-23','14:35:00',9),('7643','2013-07-23','14:40:00',14.52),('7643','2013-07-23','14:45:00',16.08),('7643','2013-07-23','14:50:00',15.74),('7643','2013-07-23','14:55:00',15.5),('7643','2013-07-23','15:00:00',15.18),('7643','2013-07-23','15:05:00',14.96),('7643','2013-07-23','15:10:00',14.77),('7643','2013-07-23','15:15:00',14.67),('7643','2013-07-23','15:20:00',14.39),('7643','2013-07-23','15:25:00',14.24),('7643','2013-07-23','15:30:00',13.49),('7643','2013-07-23','15:35:00',13.12),('7643','2013-07-23','15:40:00',13.68),('7643','2013-07-23','15:45:00',13.26),('7643','2013-07-23','15:50:00',13.03),('7643','2013-07-23','15:55:00',12.94),('7643','2013-07-23','16:00:00',12.79),('7643','2013-07-23','16:05:00',12.38),('7643','2013-07-23','16:10:00',12.24),('7643','2013-07-23','16:15:00',12.19),('7643','2013-07-23','16:20:00',12.32),('7643','2013-07-23','16:25:00',12.04),('7643','2013-07-23','16:30:00',11.67),('7643','2013-07-23','16:35:00',11.46),('7643','2013-07-23','16:40:00',11.25),('7643','2013-07-23','16:45:00',10.85),('7643','2013-07-23','16:50:00',10.49),('7643','2013-07-23','16:55:00',10.74),('7643','2013-07-23','17:00:00',10.48),('7643','2013-07-23','17:05:00',10.09),('7643','2013-07-23','17:10:00',7.78),('7643','2013-07-23','17:15:00',8.44),('7643','2013-07-23','17:20:00',8.77),('7643','2013-07-23','17:25:00',8.28),('7643','2013-07-23','17:30:00',8),('7643','2013-07-23','17:35:00',7.63),('7643','2013-07-23','17:40:00',7.15),('7643','2013-07-23','17:45:00',6.78),('7643','2013-07-23','17:50:00',6.38),('7643','2013-07-23','17:55:00',6.01),('7643','2013-07-23','18:00:00',5.73),('7643','2013-07-23','18:05:00',5.35),('7643','2013-07-23','18:10:00',5.08),('7643','2013-07-23','18:15:00',4.68),('7643','2013-07-23','18:20:00',4.09),('7643','2013-07-23','18:25:00',4.11),('7643','2013-07-23','18:30:00',3.89),('7643','2013-07-23','18:35:00',3.7),('7643','2013-07-23','18:40:00',3.4),('7643','2013-07-23','18:45:00',3.06),('7643','2013-07-23','18:50:00',2.64),('7643','2013-07-23','18:55:00',2.25),('7643','2013-07-23','19:00:00',1.86),('7643','2013-07-23','19:05:00',1.81),('7643','2013-07-23','19:10:00',1.52),('7643','2013-07-23','19:15:00',1.22),('7643','2013-07-23','19:20:00',1.19),('7643','2013-07-23','19:25:00',1.04),('7643','2013-07-22','06:55:00',1.07),('7643','2013-07-22','07:00:00',1.23),('7643','2013-07-22','07:05:00',1.44),('7643','2013-07-22','07:10:00',1.69),('7643','2013-07-22','07:15:00',1.93),('7643','2013-07-22','07:20:00',2.22),('7643','2013-07-22','07:25:00',2.5),('7643','2013-07-22','07:30:00',2.75),('7643','2013-07-22','07:35:00',3.06),('7643','2013-07-22','07:40:00',3.3),('7643','2013-07-22','07:45:00',3.56),('7643','2013-07-22','07:50:00',3.83),('7643','2013-07-22','07:55:00',4.22),('7643','2013-07-22','08:00:00',4.66),('7643','2013-07-22','08:05:00',5.01),('7643','2013-07-22','08:10:00',5.34),('7643','2013-07-22','08:15:00',5.64),('7643','2013-07-22','08:20:00',5.92),('7643','2013-07-22','08:25:00',6.2),('7643','2013-07-22','08:30:00',6.51),('7643','2013-07-22','08:35:00',6.86),('7643','2013-07-22','08:40:00',7.24),('7643','2013-07-22','08:45:00',7.57),('7643','2013-07-22','08:50:00',7.85),('7643','2013-07-22','08:55:00',8.19),('7643','2013-07-22','09:00:00',8.49),('7643','2013-07-22','09:05:00',8.78),('7643','2013-07-22','09:10:00',9.02),('7643','2013-07-22','09:15:00',9.22),('7643','2013-07-22','09:20:00',9.4),('7643','2013-07-22','09:25:00',9.6),('7643','2013-07-22','09:30:00',9.83),('7643','2013-07-22','09:35:00',10.09),('7643','2013-07-22','09:40:00',10.31),('7643','2013-07-22','09:45:00',10.53),('7643','2013-07-22','09:50:00',10.68),('7643','2013-07-22','09:55:00',10.7),('7643','2013-07-22','10:00:00',11.09),('7643','2013-07-22','10:05:00',11.27),('7643','2013-07-22','10:10:00',11.44),('7643','2013-07-22','10:15:00',11.72),('7643','2013-07-22','10:20:00',11.95),('7643','2013-07-22','10:25:00',12.41),('7643','2013-07-22','10:30:00',12.61),('7643','2013-07-22','10:35:00',12.78),('7643','2013-07-22','10:40:00',12.93),('7643','2013-07-22','10:45:00',12.95),('7643','2013-07-22','10:50:00',13.17),('7643','2013-07-22','10:55:00',13.36),('7643','2013-07-22','11:00:00',13.48),('7643','2013-07-22','11:05:00',13.51),('7643','2013-07-22','11:10:00',13.7),('7643','2013-07-22','11:15:00',13.92),('7643','2013-07-22','11:20:00',14.04),('7643','2013-07-22','11:25:00',14.07),('7643','2013-07-22','11:30:00',14.24),('7643','2013-07-22','11:35:00',14.39),('7643','2013-07-22','11:40:00',14.45),('7643','2013-07-22','11:45:00',14.42),('7643','2013-07-22','11:50:00',14.49),('7643','2013-07-22','11:55:00',14.71),('7643','2013-07-22','12:00:00',14.74),('7643','2013-07-22','12:05:00',14.93),('7643','2013-07-22','12:10:00',15.08),('7643','2013-07-22','12:15:00',15.06),('7643','2013-07-22','12:20:00',15.11),('7643','2013-07-22','12:25:00',15.19),('7643','2013-07-22','12:30:00',15.16),('7643','2013-07-22','12:35:00',15.12),('7643','2013-07-22','12:40:00',14.93),('7643','2013-07-22','12:45:00',12.25),('7643','2013-07-22','12:50:00',10.49),('7643','2013-07-22','12:55:00',9.73),('7643','2013-07-22','13:00:00',16.51),('7643','2013-07-22','13:05:00',4.93),('7643','2013-07-22','13:10:00',7.17),('7643','2013-07-22','13:15:00',6.13),('7643','2013-07-22','13:20:00',3.59),('7643','2013-07-22','13:25:00',3.39),('7643','2013-07-22','13:30:00',12.62),('7643','2013-07-22','13:35:00',16.97),('7643','2013-07-22','13:40:00',12.64),('7643','2013-07-22','13:45:00',5.24),('7643','2013-07-22','13:50:00',14.63),('7643','2013-07-22','13:55:00',14.13),('7643','2013-07-22','14:00:00',16.61),('7643','2013-07-22','14:05:00',11.79),('7643','2013-07-22','14:10:00',2.1),('7643','2013-07-22','14:15:00',1.19),('7643','2013-07-22','14:20:00',1.29),('7643','2013-07-22','14:25:00',2.44),('7643','2013-07-22','14:30:00',1.84),('7643','2013-07-22','14:35:00',2.54),('7643','2013-07-22','14:40:00',4.42),('7643','2013-07-22','14:45:00',10.04),('7643','2013-07-22','14:50:00',9.47),('7643','2013-07-22','14:55:00',11.82),('7643','2013-07-22','15:00:00',17.18),('7643','2013-07-22','15:05:00',16.22),('7643','2013-07-22','15:10:00',11.55),('7643','2013-07-22','15:15:00',14.62),('7643','2013-07-22','15:20:00',14.1),('7643','2013-07-22','15:25:00',13.86),('7643','2013-07-22','15:30:00',13.42),('7643','2013-07-22','15:35:00',13.19),('7643','2013-07-22','15:40:00',13.19),('7643','2013-07-22','15:45:00',12.92),('7643','2013-07-22','15:50:00',12.97),('7643','2013-07-22','15:55:00',12.81),('7643','2013-07-22','16:00:00',12.48),('7643','2013-07-22','16:05:00',12.13),('7643','2013-07-22','16:10:00',12.06),('7643','2013-07-22','16:15:00',11.65),('7643','2013-07-22','16:20:00',11.54),('7643','2013-07-22','16:25:00',11.33),('7643','2013-07-22','16:30:00',11.13),('7643','2013-07-22','16:35:00',10.76),('7643','2013-07-22','16:40:00',10.57),('7643','2013-07-22','16:45:00',10.27),('7643','2013-07-22','16:50:00',10.05),('7643','2013-07-22','16:55:00',9.73),('7643','2013-07-22','17:00:00',9.44),('7643','2013-07-22','17:05:00',9.19),('7643','2013-07-22','17:10:00',8.97),('7643','2013-07-22','17:15:00',8.61),('7643','2013-07-22','17:20:00',8.38),('7643','2013-07-22','17:25:00',8.2),('7643','2013-07-22','17:30:00',7.91),('7643','2013-07-22','17:35:00',7.61),('7643','2013-07-22','17:40:00',7.26),('7643','2013-07-22','17:45:00',6.94),('7643','2013-07-22','17:50:00',6.6),('7643','2013-07-22','17:55:00',6.37),('7643','2013-07-22','18:00:00',6.12),('7643','2013-07-22','18:05:00',5.77),('7643','2013-07-22','18:10:00',5.41),('7643','2013-07-22','18:15:00',5.05),('7643','2013-07-22','18:20:00',4.68),('7643','2013-07-22','18:25:00',4.44),('7643','2013-07-22','18:30:00',4.15),('7643','2013-07-22','18:35:00',3.76),('7643','2013-07-22','18:40:00',2.89),('7643','2013-07-22','18:45:00',2.42),('7643','2013-07-22','18:50:00',2.01),('7643','2013-07-22','18:55:00',2.21),('7643','2013-07-22','19:00:00',2),('7643','2013-07-22','19:05:00',1.74),('7643','2013-07-22','19:10:00',1.61),('7643','2013-07-22','19:15:00',1.4),('7643','2013-07-22','19:20:00',1.18),('7643','2013-07-22','19:25:00',1.02),('7643','2013-07-21','06:55:00',1.09),('7643','2013-07-21','07:00:00',1.27),('7643','2013-07-21','07:05:00',1.46),('7643','2013-07-21','07:10:00',1.7),('7643','2013-07-21','07:15:00',1.94),('7643','2013-07-21','07:20:00',2.16),('7643','2013-07-21','07:25:00',2.42),('7643','2013-07-21','07:30:00',2.69),('7643','2013-07-21','07:35:00',2.99),('7643','2013-07-21','07:40:00',3.24),('7643','2013-07-21','07:45:00',3.53),('7643','2013-07-21','07:50:00',3.82),('7643','2013-07-21','07:55:00',4.16),('7643','2013-07-21','08:00:00',4.47),('7643','2013-07-21','08:05:00',4.81),('7643','2013-07-21','08:10:00',5.14),('7643','2013-07-21','08:15:00',5.44),('7643','2013-07-21','08:20:00',5.76),('7643','2013-07-21','08:25:00',6.11),('7643','2013-07-21','08:30:00',6.42),('7643','2013-07-21','08:35:00',6.76),('7643','2013-07-21','08:40:00',7.11),('7643','2013-07-21','08:45:00',7.44),('7643','2013-07-21','08:50:00',7.76),('7643','2013-07-21','08:55:00',8.03),('7643','2013-07-21','09:00:00',8.35),('7643','2013-07-21','09:05:00',8.67),('7643','2013-07-21','09:10:00',8.94),('7643','2013-07-21','09:15:00',9.2),('7643','2013-07-21','09:20:00',9.43),('7643','2013-07-21','09:25:00',9.74),('7643','2013-07-21','09:30:00',9.98),('7643','2013-07-21','09:35:00',10.18),('7643','2013-07-21','09:40:00',10.43),('7643','2013-07-21','09:45:00',10.71),('7643','2013-07-21','09:50:00',11.02),('7643','2013-07-21','09:55:00',11.21),('7643','2013-07-21','10:00:00',11.51),('7643','2013-07-21','10:05:00',11.7),('7643','2013-07-21','10:10:00',11.84),('7643','2013-07-21','10:15:00',12.07),('7643','2013-07-21','10:20:00',12.23),('7643','2013-07-21','10:25:00',12.45),('7643','2013-07-21','10:30:00',12.54),('7643','2013-07-21','10:35:00',12.78),('7643','2013-07-21','10:40:00',12.92),('7643','2013-07-21','10:45:00',12.96),('7643','2013-07-21','10:50:00',13.1),('7643','2013-07-21','10:55:00',13.25),('7643','2013-07-21','11:00:00',13.48),('7643','2013-07-21','11:05:00',13.67),('7643','2013-07-21','11:10:00',13.87),('7643','2013-07-21','11:15:00',13.88),('7643','2013-07-21','11:20:00',13.82),('7643','2013-07-21','11:25:00',13.92),('7643','2013-07-21','11:30:00',14.12),('7643','2013-07-21','11:35:00',14.22),('7643','2013-07-21','11:40:00',14.44),('7643','2013-07-21','11:45:00',14.47),('7643','2013-07-21','11:50:00',14.65),('7643','2013-07-21','11:55:00',14.68),('7643','2013-07-21','12:00:00',14.72),('7643','2013-07-21','12:05:00',14.79),('7643','2013-07-21','12:10:00',14.89),('7643','2013-07-21','12:15:00',15),('7643','2013-07-21','12:20:00',15.01),('7643','2013-07-21','12:25:00',14.95),('7643','2013-07-21','12:30:00',15.08),('7643','2013-07-21','12:35:00',15.2),('7643','2013-07-21','12:40:00',15.14),('7643','2013-07-21','12:45:00',15.12),('7643','2013-07-21','12:50:00',15.15),('7643','2013-07-21','12:55:00',15.21),('7643','2013-07-21','13:00:00',15.32),('7643','2013-07-21','13:05:00',15.52),('7643','2013-07-21','13:10:00',15.51),('7643','2013-07-21','13:15:00',15.29),('7643','2013-07-21','13:20:00',15.15),('7643','2013-07-21','13:25:00',15.19),('7643','2013-07-21','13:30:00',15.09),('7643','2013-07-21','13:35:00',14.97),('7643','2013-07-21','13:40:00',15.29),('7643','2013-07-21','13:45:00',15.27),('7643','2013-07-21','13:50:00',15.23),('7643','2013-07-21','13:55:00',15.14),('7643','2013-07-21','14:00:00',14.88),('7643','2013-07-21','14:05:00',15.12),('7643','2013-07-21','14:10:00',14.95),('7643','2013-07-21','14:15:00',14.82),('7643','2013-07-21','14:20:00',14.84),('7643','2013-07-21','14:25:00',14.63),('7643','2013-07-21','14:30:00',14.66),('7643','2013-07-21','14:35:00',14.73),('7643','2013-07-21','14:40:00',14.73),('7643','2013-07-21','14:45:00',14.57),('7643','2013-07-21','14:50:00',14.29),('7643','2013-07-21','14:55:00',14.14),('7643','2013-07-21','15:00:00',12.13),('7643','2013-07-21','15:05:00',14.17),('7643','2013-07-21','15:10:00',13.94),('7643','2013-07-21','15:15:00',13.75),('7643','2013-07-21','15:20:00',13.45),('7643','2013-07-21','15:25:00',13.53),('7643','2013-07-21','15:30:00',8.1),('7643','2013-07-21','15:35:00',3.5),('7643','2013-07-21','15:40:00',6.93),('7643','2013-07-21','15:45:00',12.88),('7643','2013-07-21','15:50:00',13.81),('7643','2013-07-21','15:55:00',14.08),('7643','2013-07-21','16:00:00',12.61),('7643','2013-07-21','16:05:00',12.17),('7643','2013-07-21','16:10:00',5.68),('7643','2013-07-21','16:15:00',6.68),('7643','2013-07-21','16:20:00',10.97),('7643','2013-07-21','16:25:00',12.71),('7643','2013-07-21','16:30:00',11.81),('7643','2013-07-21','16:35:00',11.13),('7643','2013-07-21','16:40:00',10.46),('7643','2013-07-21','16:45:00',10.24),('7643','2013-07-21','16:50:00',9.92),('7643','2013-07-21','16:55:00',9.89),('7643','2013-07-21','17:00:00',9.5),('7643','2013-07-21','17:05:00',9.25),('7643','2013-07-21','17:10:00',8.95),('7643','2013-07-21','17:15:00',8.68),('7643','2013-07-21','17:20:00',8.29),('7643','2013-07-21','17:25:00',7.6),('7643','2013-07-21','17:30:00',7.51),('7643','2013-07-21','17:35:00',7.48),('7643','2013-07-21','17:40:00',6.83),('7643','2013-07-21','17:45:00',6.01),('7643','2013-07-21','17:50:00',6.06),('7643','2013-07-21','17:55:00',5.91),('7643','2013-07-21','18:00:00',5.84),('7643','2013-07-21','18:05:00',5.46),('7643','2013-07-21','18:10:00',4.95),('7643','2013-07-21','18:15:00',4.53),('7643','2013-07-21','18:20:00',4.27),('7643','2013-07-21','18:25:00',4.06),('7643','2013-07-21','18:30:00',3.82),('7643','2013-07-21','18:35:00',3.52),('7643','2013-07-21','18:40:00',3.16),('7643','2013-07-21','18:45:00',2.94),('7643','2013-07-21','18:50:00',2.63),('7643','2013-07-21','18:55:00',2.29),('7643','2013-07-21','19:00:00',1.79),('7643','2013-07-21','19:05:00',1.88),('7643','2013-07-21','19:10:00',1.78),('7643','2013-07-21','19:15:00',1.5),('7643','2013-07-21','19:20:00',1.23),('7643','2013-07-21','19:25:00',1.15),('7643','2013-07-21','19:30:00',1),('7643','2013-07-20','06:55:00',1.07),('7643','2013-07-20','07:00:00',1.25),('7643','2013-07-20','07:05:00',1.43),('7643','2013-07-20','07:10:00',1.64),('7643','2013-07-20','07:15:00',1.9),('7643','2013-07-20','07:20:00',2.1),('7643','2013-07-20','07:25:00',2.33),('7643','2013-07-20','07:30:00',2.59),('7643','2013-07-20','07:35:00',2.9),('7643','2013-07-20','07:40:00',3.19),('7643','2013-07-20','07:45:00',3.56),('7643','2013-07-20','07:50:00',3.76),('7643','2013-07-20','07:55:00',3.9),('7643','2013-07-20','08:00:00',4.2),('7643','2013-07-20','08:05:00',4.47),('7643','2013-07-20','08:10:00',4.91),('7643','2013-07-20','08:15:00',5.21),('7643','2013-07-20','08:20:00',5.4),('7643','2013-07-20','08:25:00',5.78),('7643','2013-07-20','08:30:00',6.16),('7643','2013-07-20','08:35:00',6.45),('7643','2013-07-20','08:40:00',6.74),('7643','2013-07-20','08:45:00',6.98),('7643','2013-07-20','08:50:00',7.33),('7643','2013-07-20','08:55:00',7.65),('7643','2013-07-20','09:00:00',8.04),('7643','2013-07-20','09:05:00',8.28),('7643','2013-07-20','09:10:00',8.59),('7643','2013-07-20','09:15:00',8.89),('7643','2013-07-20','09:20:00',9.14),('7643','2013-07-20','09:25:00',9.42),('7643','2013-07-20','09:30:00',9.72),('7643','2013-07-20','09:35:00',9.89),('7643','2013-07-20','09:40:00',10.15),('7643','2013-07-20','09:45:00',10.35),('7643','2013-07-20','09:50:00',10.52),('7643','2013-07-20','09:55:00',10.78),('7643','2013-07-20','10:00:00',11.09),('7643','2013-07-20','10:05:00',11.32),('7643','2013-07-20','10:10:00',11.47),('7643','2013-07-20','10:15:00',11.7),('7643','2013-07-20','10:20:00',11.88),('7643','2013-07-20','10:25:00',11.95),('7643','2013-07-20','10:30:00',12.1),('7643','2013-07-20','10:35:00',12.32),('7643','2013-07-20','10:40:00',12.58),('7643','2013-07-20','10:45:00',12.75),('7643','2013-07-20','10:50:00',12.86),('7643','2013-07-20','10:55:00',12.91),('7643','2013-07-20','11:00:00',13.17),('7643','2013-07-20','11:05:00',13.4),('7643','2013-07-20','11:10:00',13.48),('7643','2013-07-20','11:15:00',13.59),('7643','2013-07-20','11:20:00',13.75),('7643','2013-07-20','11:25:00',13.91),('7643','2013-07-20','11:30:00',14.1),('7643','2013-07-20','11:35:00',14.3),('7643','2013-07-20','11:40:00',14.81),('7643','2013-07-20','11:45:00',14.93),('7643','2013-07-20','11:50:00',14.67),('7643','2013-07-20','11:55:00',14.64),('7643','2013-07-20','12:00:00',14.72),('7643','2013-07-20','12:05:00',15.01),('7643','2013-07-20','12:10:00',15.09),('7643','2013-07-20','12:15:00',15.66),('7643','2013-07-20','12:20:00',16.24),('7643','2013-07-20','12:25:00',16.33),('7643','2013-07-20','12:30:00',16.45),('7643','2013-07-20','12:35:00',17),('7643','2013-07-20','12:40:00',17.17),('7643','2013-07-20','12:45:00',16.14),('7643','2013-07-20','12:50:00',14.29),('7643','2013-07-20','12:55:00',17.85),('7643','2013-07-20','13:00:00',15.86),('7643','2013-07-20','13:05:00',17.68),('7643','2013-07-20','13:10:00',16.21),('7643','2013-07-20','13:15:00',12.62),('7643','2013-07-20','13:20:00',16.14),('7643','2013-07-20','13:25:00',17.06),('7643','2013-07-20','13:30:00',16.27),('7643','2013-07-20','13:35:00',15.41),('7643','2013-07-20','13:40:00',12.55),('7643','2013-07-20','13:45:00',4.17),('7643','2013-07-20','13:50:00',3.53),('7643','2013-07-20','13:55:00',2.87),('7643','2013-07-20','14:00:00',2.83),('7643','2013-07-20','14:05:00',3.01),('7643','2013-07-20','14:10:00',2.75),('7643','2013-07-20','14:15:00',2.79),('7643','2013-07-20','14:20:00',3.74),('7643','2013-07-20','14:25:00',4.31),('7643','2013-07-20','14:30:00',4.14),('7643','2013-07-20','14:35:00',4.74),('7643','2013-07-20','14:40:00',4.79),('7643','2013-07-20','14:45:00',7.18),('7643','2013-07-20','14:50:00',14.37),('7643','2013-07-20','14:55:00',7.05),('7643','2013-07-20','15:00:00',7.7),('7643','2013-07-20','15:05:00',6.31),('7643','2013-07-20','15:10:00',5.87),('7643','2013-07-20','15:15:00',15.37),('7643','2013-07-20','15:20:00',16.19),('7643','2013-07-20','15:25:00',6.7),('7643','2013-07-20','15:30:00',5.27),('7643','2013-07-20','15:35:00',5.85),('7643','2013-07-20','15:40:00',9.97),('7643','2013-07-20','15:45:00',10.04),('7643','2013-07-20','15:50:00',12.33),('7643','2013-07-20','15:55:00',8.74),('7643','2013-07-20','16:00:00',5.23),('7643','2013-07-20','16:05:00',3.96),('7643','2013-07-20','16:10:00',3.35),('7643','2013-07-20','16:15:00',2.92),('7643','2013-07-20','16:20:00',2.71),('7643','2013-07-20','16:25:00',2.82),('7643','2013-07-20','16:30:00',2.95),('7643','2013-07-20','16:35:00',3.13),('7643','2013-07-20','16:40:00',3.23),('7643','2013-07-20','16:45:00',3.21),('7643','2013-07-20','16:50:00',3.32),('7643','2013-07-20','16:55:00',3.72),('7643','2013-07-20','17:00:00',4.2),('7643','2013-07-20','17:05:00',4.63),('7643','2013-07-20','17:10:00',4.68),('7643','2013-07-20','17:15:00',3.96),('7643','2013-07-20','17:20:00',3.59),('7643','2013-07-20','17:25:00',3.29),('7643','2013-07-20','17:30:00',3.07),('7643','2013-07-20','17:35:00',2.92),('7643','2013-07-20','17:40:00',2.89),('7643','2013-07-20','17:45:00',2.85),('7643','2013-07-20','17:50:00',2.92),('7643','2013-07-20','17:55:00',3.01),('7643','2013-07-20','18:00:00',3.01),('7643','2013-07-20','18:05:00',2.84),('7643','2013-07-20','18:10:00',2.44),('7643','2013-07-20','18:15:00',2.1),('7643','2013-07-20','18:20:00',1.85),('7643','2013-07-20','18:25:00',1.65),('7643','2013-07-20','18:30:00',1.5),('7643','2013-07-20','18:35:00',1.33),('7643','2013-07-20','18:40:00',1.2),('7643','2013-07-20','18:45:00',1.18),('7643','2013-07-20','18:50:00',1.24),('7643','2013-07-20','18:55:00',1.38),('7643','2013-07-20','19:00:00',1.46),('7643','2013-07-20','19:05:00',1.52),('7643','2013-07-20','19:10:00',1.42),('7643','2013-07-20','19:15:00',1.18),('7643','2014-04-06','07:20:00',1.15),('7643','2014-04-06','07:25:00',1.37),('7643','2014-04-06','07:30:00',1.64),('7643','2014-04-06','07:35:00',1.9),('7643','2014-04-06','07:40:00',2.07),('7643','2014-04-06','07:45:00',2.09),('7643','2014-04-06','07:50:00',1.86),('7643','2014-04-06','07:55:00',1.69),('7643','2014-04-06','08:00:00',1.83),('7643','2014-04-06','08:05:00',2.06),('7643','2014-04-06','08:10:00',2.68),('7643','2014-04-06','08:15:00',3.19),('7643','2014-04-06','08:20:00',3.99),('7643','2014-04-06','08:25:00',3.96),('7643','2014-04-06','08:30:00',4.35),('7643','2014-04-06','08:35:00',6.07),('7643','2014-04-06','08:40:00',6.76),('7643','2014-04-06','08:45:00',6.99),('7643','2014-04-06','08:50:00',5.76),('7643','2014-04-06','08:55:00',4.91),('7643','2014-04-06','09:00:00',4.6),('7643','2014-04-06','09:05:00',4.78),('7643','2014-04-06','09:10:00',5.35),('7643','2014-04-06','09:15:00',6.09),('7643','2014-04-06','09:20:00',5.44),('7643','2014-04-06','09:25:00',5.03),('7643','2014-04-06','09:30:00',4.94),('7643','2014-04-06','09:35:00',4.41),('7643','2014-04-06','09:40:00',4.52),('7643','2014-04-06','09:45:00',4.74),('7643','2014-04-06','09:50:00',4.98),('7643','2014-04-06','09:55:00',5.68),('7643','2014-04-06','10:00:00',5.37),('7643','2014-04-06','10:05:00',5.25),('7643','2014-04-06','10:10:00',5.7),('7643','2014-04-06','10:15:00',5.11),('7643','2014-04-06','10:20:00',5.02),('7643','2014-04-06','10:25:00',5.17),('7643','2014-04-06','10:30:00',5.32),('7643','2014-04-06','10:35:00',5.69),('7643','2014-04-06','10:40:00',5.89),('7643','2014-04-06','10:45:00',6.08),('7643','2014-04-06','10:50:00',6.21),('7643','2014-04-06','10:55:00',6.59),('7643','2014-04-06','11:00:00',7.02),('7643','2014-04-06','11:05:00',7.38),('7643','2014-04-06','11:10:00',8.49),('7643','2014-04-06','11:15:00',9.5),('7643','2014-04-06','11:20:00',8.57),('7643','2014-04-06','11:25:00',7.97),('7643','2014-04-06','11:30:00',8.2),('7643','2014-04-06','11:35:00',7.89),('7643','2014-04-06','11:40:00',7.62),('7643','2014-04-06','11:45:00',7.19),('7643','2014-04-06','11:50:00',6.94),('7643','2014-04-06','11:55:00',6.86),('7643','2014-04-06','12:00:00',7.39),('7643','2014-04-06','12:05:00',9.32),('7643','2014-04-06','12:10:00',10.52),('7643','2014-04-06','12:15:00',13.8),('7643','2014-04-06','12:20:00',16.85),('7643','2014-04-06','12:25:00',16.48),('7643','2014-04-06','12:30:00',10.22),('7643','2014-04-06','12:35:00',9.37),('7643','2014-04-06','12:40:00',10.87),('7643','2014-04-06','12:45:00',15.59),('7643','2014-04-06','12:50:00',15.9),('7643','2014-04-06','12:55:00',15.68),('7643','2014-04-06','13:00:00',15.73),('7643','2014-04-06','13:05:00',15.71),('7643','2014-04-06','13:10:00',15.51),('7643','2014-04-06','13:15:00',15.45),('7643','2014-04-06','13:20:00',15.51),('7643','2014-04-06','13:25:00',15.43),('7643','2014-04-06','13:30:00',15.36),('7643','2014-04-06','13:35:00',15.29),('7643','2014-04-06','13:40:00',15.29),('7643','2014-04-06','13:45:00',15.37),('7643','2014-04-06','13:50:00',15.43),('7643','2014-04-06','13:55:00',15.27),('7643','2014-04-06','14:00:00',15.3),('7643','2014-04-06','14:05:00',15.26),('7643','2014-04-06','14:10:00',14.99),('7643','2014-04-06','14:15:00',14.94),('7643','2014-04-06','14:20:00',14.85),('7643','2014-04-06','14:25:00',15.32),('7643','2014-04-06','14:30:00',15.34),('7643','2014-04-06','14:35:00',14.89),('7643','2014-04-06','14:40:00',14.73),('7643','2014-04-06','14:45:00',14.46),('7643','2014-04-06','14:50:00',13.64),('7643','2014-04-06','14:55:00',12.81),('7643','2014-04-06','15:00:00',12.73),('7643','2014-04-06','15:05:00',14.46),('7643','2014-04-06','15:10:00',14.32),('7643','2014-04-06','15:15:00',12.05),('7643','2014-04-06','15:20:00',14.09),('7643','2014-04-06','15:25:00',14.21),('7643','2014-04-06','15:30:00',13.7),('7643','2014-04-06','15:35:00',13.92),('7643','2014-04-06','15:40:00',13.52),('7643','2014-04-06','15:45:00',13.68),('7643','2014-04-06','15:50:00',14.39),('7643','2014-04-06','15:55:00',13.79),('7643','2014-04-06','16:00:00',9.11),('7643','2014-04-06','16:05:00',5.71),('7643','2014-04-06','16:10:00',12.16),('7643','2014-04-06','16:15:00',11.31),('7643','2014-04-06','16:20:00',10.51),('7643','2014-04-06','16:25:00',10.22),('7643','2014-04-06','16:30:00',9.87),('7643','2014-04-06','16:35:00',7.98),('7643','2014-04-06','16:40:00',4.81),('7643','2014-04-06','16:45:00',7.88),('7643','2014-04-06','16:50:00',7.49),('7643','2014-04-06','16:55:00',9.66),('7643','2014-04-06','17:00:00',9.78),('7643','2014-04-06','17:05:00',8.9),('7643','2014-04-06','17:10:00',5.62),('7643','2014-04-06','17:15:00',6.87),('7643','2014-04-06','17:20:00',3.5),('7643','2014-04-06','17:25:00',2.9),('7643','2014-04-06','17:30:00',2.56),('7643','2014-04-06','17:35:00',2.1),('7643','2014-04-06','17:40:00',1.59),('7643','2014-04-06','17:45:00',1.67),('7643','2014-04-06','17:50:00',2.03),('7643','2014-04-06','17:55:00',4.13),('7643','2014-04-06','18:00:00',3.84),('7643','2014-04-06','18:05:00',3.49),('7643','2014-04-06','18:10:00',3.43),('7643','2014-04-06','18:15:00',3.23),('7643','2014-04-06','18:20:00',2.72),('7643','2014-04-06','18:25:00',2.32),('7643','2014-04-06','18:30:00',2.12),('7643','2014-04-06','18:35:00',1.73),('7643','2014-04-06','18:40:00',1.48),('7643','2014-04-06','18:45:00',1.24),('7643','2014-04-06','18:50:00',1.02),('7643','2013-07-19','06:50:00',1.02),('7643','2013-07-19','06:55:00',1.17),('7643','2013-07-19','07:00:00',1.22),('7643','2013-07-19','07:05:00',1.38),('7643','2013-07-19','07:10:00',1.45),('7643','2013-07-19','07:15:00',1.78),('7643','2013-07-19','07:20:00',1.98),('7643','2013-07-19','07:25:00',2.32),('7643','2013-07-19','07:30:00',2.75),('7643','2013-07-19','07:35:00',3.09),('7643','2013-07-19','07:40:00',3.33),('7643','2013-07-19','07:45:00',3.63),('7643','2013-07-19','07:50:00',3.9),('7643','2013-07-19','07:55:00',4.23),('7643','2013-07-19','08:00:00',4.48),('7643','2013-07-19','08:05:00',4.84),('7643','2013-07-19','08:10:00',5.18),('7643','2013-07-19','08:15:00',5.43),('7643','2013-07-19','08:20:00',5.76),('7643','2013-07-19','08:25:00',6.12),('7643','2013-07-19','08:30:00',6.44),('7643','2013-07-19','08:35:00',6.81),('7643','2013-07-19','08:40:00',7.15),('7643','2013-07-19','08:45:00',7.54),('7643','2013-07-19','08:50:00',7.82),('7643','2013-07-19','08:55:00',8.18),('7643','2013-07-19','09:00:00',8.52),('7643','2013-07-19','09:05:00',8.82),('7643','2013-07-19','09:10:00',9.31),('7643','2013-07-19','09:15:00',9.7),('7643','2013-07-19','09:20:00',9.87),('7643','2013-07-19','09:25:00',9.74),('7643','2013-07-19','09:30:00',9.7),('7643','2013-07-19','09:35:00',9.85),('7643','2013-07-19','09:40:00',9.8),('7643','2013-07-19','09:45:00',10.79),('7643','2013-07-19','09:50:00',10.53),('7643','2013-07-19','09:55:00',10.46),('7643','2013-07-19','10:00:00',11.33),('7643','2013-07-19','10:05:00',11.55),('7643','2013-07-19','10:10:00',11.65),('7643','2013-07-19','10:15:00',11.76),('7643','2013-07-19','10:20:00',12.09),('7643','2013-07-19','10:25:00',12.33),('7643','2013-07-19','10:30:00',12.54),('7643','2013-07-19','10:35:00',12.71),('7643','2013-07-19','10:40:00',12.81),('7643','2013-07-19','10:45:00',12.98),('7643','2013-07-19','10:50:00',13.17),('7643','2013-07-19','10:55:00',13.3),('7643','2013-07-19','11:00:00',13.57),('7643','2013-07-19','11:05:00',13.72),('7643','2013-07-19','11:10:00',13.79),('7643','2013-07-19','11:15:00',13.74),('7643','2013-07-19','11:20:00',13.92),('7643','2013-07-19','11:25:00',14.09),('7643','2013-07-19','11:30:00',13.97),('7643','2013-07-19','11:35:00',14.19),('7643','2013-07-19','11:40:00',14.56),('7643','2013-07-19','11:45:00',14.67),('7643','2013-07-19','11:50:00',14.76),('7643','2013-07-19','11:55:00',14.99),('7643','2013-07-19','12:00:00',14.93),('7643','2013-07-19','12:05:00',15.18),('7643','2013-07-19','12:10:00',15.33),('7643','2013-07-19','12:15:00',15.49),('7643','2013-07-19','12:20:00',15),('7643','2013-07-19','12:25:00',12.68),('7643','2013-07-19','12:30:00',11.78),('7643','2013-07-19','12:35:00',15.54),('7643','2013-07-19','12:40:00',15.34),('7643','2013-07-19','12:45:00',15.48),('7643','2013-07-19','12:50:00',15.68),('7643','2013-07-19','12:55:00',15.98),('7643','2013-07-19','13:00:00',16.06),('7643','2013-07-19','13:05:00',16.23),('7643','2013-07-19','13:10:00',16.13),('7643','2013-07-19','13:15:00',14.09),('7643','2013-07-19','13:20:00',3.8),('7643','2013-07-19','13:25:00',5.11),('7643','2013-07-19','13:30:00',10.7),('7643','2013-07-19','13:35:00',16.99),('7643','2013-07-19','13:40:00',16.85),('7643','2013-07-19','13:45:00',16.58),('7643','2013-07-19','13:50:00',12.5),('7643','2013-07-19','13:55:00',4.11),('7643','2013-07-19','14:00:00',5.14),('7643','2013-07-19','14:05:00',17.13),('7643','2013-07-19','14:10:00',16.13),('7643','2013-07-19','14:15:00',11.32),('7643','2013-07-19','14:20:00',16.19),('7643','2013-07-19','14:25:00',15.72),('7643','2013-07-19','14:30:00',15.38),('7643','2013-07-19','14:35:00',15.74),('7643','2013-07-19','14:40:00',15.96),('7643','2013-07-19','14:45:00',9.8),('7643','2013-07-19','14:50:00',13.47),('7643','2013-07-19','14:55:00',4.31),('7643','2013-07-19','15:00:00',13),('7643','2013-07-19','15:05:00',15.34),('7643','2013-07-19','15:10:00',15.04),('7643','2013-07-19','15:15:00',14.53),('7643','2013-07-19','15:20:00',14.15),('7643','2013-07-19','15:25:00',13.74),('7643','2013-07-19','15:30:00',13.54),('7643','2013-07-19','15:35:00',13.34),('7643','2013-07-19','15:40:00',13.15),('7643','2013-07-19','15:45:00',12.99),('7643','2013-07-19','15:50:00',12.78),('7643','2013-07-19','15:55:00',12.7),('7643','2013-07-19','16:00:00',12.52),('7643','2013-07-19','16:05:00',12.23),('7643','2013-07-19','16:10:00',12.16),('7643','2013-07-19','16:15:00',11.99),('7643','2013-07-19','16:20:00',11.8),('7643','2013-07-19','16:25:00',11.54),('7643','2013-07-19','16:30:00',11.32),('7643','2013-07-19','16:35:00',10.91),('7643','2013-07-19','16:40:00',10.72),('7643','2013-07-19','16:45:00',10.34),('7643','2013-07-19','16:50:00',9.98),('7643','2013-07-19','16:55:00',9.7),('7643','2013-07-19','17:00:00',9.41),('7643','2013-07-19','17:05:00',9.17),('7643','2013-07-19','17:10:00',8.86),('7643','2013-07-19','17:15:00',8.57),('7643','2013-07-19','17:20:00',8.29),('7643','2013-07-19','17:25:00',8.01),('7643','2013-07-19','17:30:00',7.72),('7643','2013-07-19','17:35:00',7.4),('7643','2013-07-19','17:40:00',7.11),('7643','2013-07-19','17:45:00',6.75),('7643','2013-07-19','17:50:00',6.44),('7643','2013-07-19','17:55:00',6.19),('7643','2013-07-19','18:00:00',5.92),('7643','2013-07-19','18:05:00',5.58),('7643','2013-07-19','18:10:00',5.2),('7643','2013-07-19','18:15:00',4.87),('7643','2013-07-19','18:20:00',4.57),('7643','2013-07-19','18:25:00',4.35),('7643','2013-07-19','18:30:00',4.05),('7643','2013-07-19','18:35:00',3.75),('7643','2013-07-19','18:40:00',3.41),('7643','2013-07-19','18:45:00',3.08),('7643','2013-07-19','18:50:00',2.73),('7643','2013-07-19','18:55:00',2.42),('7643','2013-07-19','19:00:00',2.08),('7643','2013-07-19','19:05:00',1.83),('7643','2013-07-19','19:10:00',1.66),('7643','2013-07-19','19:15:00',1.45),('7643','2013-07-19','19:20:00',1.24),('7643','2013-07-19','19:25:00',1.06),('7643','2013-07-18','06:50:00',1.02),('7643','2013-07-18','06:55:00',1.18),('7643','2013-07-18','07:00:00',1.34),('7643','2013-07-18','07:05:00',1.52),('7643','2013-07-18','07:10:00',1.75),('7643','2013-07-18','07:15:00',2.01),('7643','2013-07-18','07:20:00',2.2),('7643','2013-07-18','07:25:00',2.42),('7643','2013-07-18','07:30:00',2.68),('7643','2013-07-18','07:35:00',2.97),('7643','2013-07-18','07:40:00',3.23),('7643','2013-07-18','07:45:00',3.5),('7643','2013-07-18','07:50:00',3.81),('7643','2013-07-18','07:55:00',4.12),('7643','2013-07-18','08:00:00',4.4),('7643','2013-07-18','08:05:00',4.71),('7643','2013-07-18','08:10:00',5),('7643','2013-07-18','08:15:00',5.3),('7643','2013-07-18','08:20:00',5.54),('7643','2013-07-18','08:25:00',5.81),('7643','2013-07-18','08:30:00',6.1),('7643','2013-07-18','08:35:00',6.46),('7643','2013-07-18','08:40:00',6.83),('7643','2013-07-18','08:45:00',7.19),('7643','2013-07-18','08:50:00',7.52),('7643','2013-07-18','08:55:00',7.83),('7643','2013-07-18','09:00:00',8.06),('7643','2013-07-18','09:05:00',8.33),('7643','2013-07-18','09:10:00',8.66),('7643','2013-07-18','09:15:00',8.91),('7643','2013-07-18','09:20:00',9.15),('7643','2013-07-18','09:25:00',9.31),('7643','2013-07-18','09:30:00',9.57),('7643','2013-07-18','09:35:00',9.9),('7643','2013-07-18','09:40:00',9.96),('7643','2013-07-18','09:45:00',10.18),('7643','2013-07-18','09:50:00',10.42),('7643','2013-07-18','09:55:00',10.63),('7643','2013-07-18','10:00:00',10.68),('7643','2013-07-18','10:05:00',10.98),('7643','2013-07-18','10:10:00',11.14),('7643','2013-07-18','10:15:00',11.39),('7643','2013-07-18','10:20:00',11.49),('7643','2013-07-18','10:25:00',11.81),('7643','2013-07-18','10:30:00',11.68),('7643','2013-07-18','10:35:00',12.18),('7643','2013-07-18','10:40:00',12.3),('7643','2013-07-18','10:45:00',12.38),('7643','2013-07-18','10:50:00',12.43),('7643','2013-07-18','10:55:00',12.71),('7643','2013-07-18','11:00:00',12.93),('7643','2013-07-18','11:05:00',13.06),('7643','2013-07-18','11:10:00',13.09),('7643','2013-07-18','11:15:00',13.06),('7643','2013-07-18','11:20:00',13.28),('7643','2013-07-18','11:25:00',13.27),('7643','2013-07-18','11:30:00',13.39),('7643','2013-07-18','11:35:00',13.49),('7643','2013-07-18','11:40:00',13.78),('7643','2013-07-18','11:45:00',14.33),('7643','2013-07-18','11:50:00',14.29),('7643','2013-07-18','11:55:00',14.55),('7643','2013-07-18','12:00:00',8.87),('7643','2013-07-18','12:05:00',11.94),('7643','2013-07-18','12:10:00',12.09),('7643','2013-07-18','12:15:00',15.15),('7643','2013-07-18','12:20:00',15.35),('7643','2013-07-18','12:25:00',14.37),('7643','2013-07-18','12:30:00',13.02),('7643','2013-07-18','12:35:00',15.31),('7643','2013-07-18','12:40:00',14.92),('7643','2013-07-18','12:45:00',15.06),('7643','2013-07-18','12:50:00',15.07),('7643','2013-07-18','12:55:00',13.81),('7643','2013-07-18','13:00:00',10.42),('7643','2013-07-18','13:05:00',15.22),('7643','2013-07-18','13:10:00',14.96),('7643','2013-07-18','13:15:00',12.55),('7643','2013-07-18','13:20:00',7.07),('7643','2013-07-18','13:25:00',14.8),('7643','2013-07-18','13:30:00',16.84),('7643','2013-07-18','13:35:00',16.38),('7643','2013-07-18','13:40:00',16.06),('7643','2013-07-18','13:45:00',16.26),('7643','2013-07-18','13:50:00',14.4),('7643','2013-07-18','13:55:00',13.8),('7643','2013-07-18','14:00:00',14.58),('7643','2013-07-18','14:05:00',16.24),('7643','2013-07-18','14:10:00',13.14),('7643','2013-07-18','14:15:00',15.58),('7643','2013-07-18','14:20:00',15.7),('7643','2013-07-18','14:25:00',16.15),('7643','2013-07-18','14:30:00',16.21),('7643','2013-07-18','14:35:00',14.08),('7643','2013-07-18','14:40:00',12.87),('7643','2013-07-18','14:45:00',10.75),('7643','2013-07-18','14:50:00',12.79),('7643','2013-07-18','14:55:00',14.74),('7643','2013-07-18','15:00:00',15.36),('7643','2013-07-18','15:05:00',14.87),('7643','2013-07-18','15:10:00',15),('7643','2013-07-18','15:15:00',8.07),('7643','2013-07-18','15:20:00',12.6),('7643','2013-07-18','15:25:00',11.56),('7643','2013-07-18','15:30:00',13.76),('7643','2013-07-18','15:35:00',13.84),('7643','2013-07-18','15:40:00',14.45),('7643','2013-07-18','15:45:00',14.08),('7643','2013-07-18','15:50:00',13.75),('7643','2013-07-18','15:55:00',13.34),('7643','2013-07-18','16:00:00',13.14),('7643','2013-07-18','16:05:00',12.83),('7643','2013-07-18','16:10:00',12.77),('7643','2013-07-18','16:15:00',12.59),('7643','2013-07-18','16:20:00',12.42),('7643','2013-07-18','16:25:00',12.14),('7643','2013-07-18','16:30:00',11.91),('7643','2013-07-18','16:35:00',11.74),('7643','2013-07-18','16:40:00',11.51),('7643','2013-07-18','16:45:00',11.16),('7643','2013-07-18','16:50:00',11.04),('7643','2013-07-18','16:55:00',10.97),('7643','2013-07-18','17:00:00',10.17),('7643','2013-07-18','17:05:00',10.29),('7643','2013-07-18','17:10:00',9.15),('7643','2013-07-18','17:15:00',8.29),('7643','2013-07-18','17:20:00',8.37),('7643','2013-07-18','17:25:00',7.16),('7643','2013-07-18','17:30:00',7.72),('7643','2013-07-18','17:35:00',8.25),('7643','2013-07-18','17:40:00',6.23),('7643','2013-07-18','17:45:00',4.71),('7643','2013-07-18','17:50:00',3.41),('7643','2013-07-18','17:55:00',3.13),('7643','2013-07-18','18:00:00',2.81),('7643','2013-07-18','18:05:00',2.42),('7643','2013-07-18','18:10:00',2.06),('7643','2013-07-18','18:15:00',1.7),('7643','2013-07-18','18:20:00',1.38),('7643','2013-07-18','18:25:00',1.55),('7643','2013-07-18','18:30:00',1.74),('7643','2013-07-18','18:35:00',1.86),('7643','2013-07-18','18:40:00',1.94),('7643','2013-07-18','18:45:00',1.92),('7643','2013-07-18','18:50:00',1.84),('7643','2013-07-18','18:55:00',1.79),('7643','2013-07-18','19:00:00',1.71),('7643','2013-07-18','19:05:00',1.58),('7643','2013-07-18','19:10:00',1.43),('7643','2013-07-18','19:15:00',1.29),('7643','2013-07-18','19:20:00',1.12),('7643','2013-07-18','19:25:00',1),('7643','2013-07-18','19:30:00',1),('7643','2013-07-18','19:35:00',1.1),('7643','2013-07-18','19:40:00',1.17),('7643','2013-07-18','19:45:00',1.12),('7643','2013-07-18','19:50:00',1),('7643','2013-07-17','06:55:00',1.15),('7643','2013-07-17','07:00:00',1.33),('7643','2013-07-17','07:05:00',1.52),('7643','2013-07-17','07:10:00',1.79),('7643','2013-07-17','07:15:00',2.03),('7643','2013-07-17','07:20:00',2.27),('7643','2013-07-17','07:25:00',2.55),('7643','2013-07-17','07:30:00',2.84),('7643','2013-07-17','07:35:00',3.14),('7643','2013-07-17','07:40:00',3.44),('7643','2013-07-17','07:45:00',3.77),('7643','2013-07-17','07:50:00',4.1),('7643','2013-07-17','07:55:00',4.43),('7643','2013-07-17','08:00:00',4.69),('7643','2013-07-17','08:05:00',5.03),('7643','2013-07-17','08:10:00',5.35),('7643','2013-07-17','08:15:00',5.65),('7643','2013-07-17','08:20:00',5.89),('7643','2013-07-17','08:25:00',6.22),('7643','2013-07-17','08:30:00',6.57),('7643','2013-07-17','08:35:00',6.91),('7643','2013-07-17','08:40:00',7.24),('7643','2013-07-17','08:45:00',7.58),('7643','2013-07-17','08:50:00',7.87),('7643','2013-07-17','08:55:00',8.2),('7643','2013-07-17','09:00:00',8.46),('7643','2013-07-17','09:05:00',8.75),('7643','2013-07-17','09:10:00',9.02),('7643','2013-07-17','09:15:00',9.27),('7643','2013-07-17','09:20:00',9.5),('7643','2013-07-17','09:25:00',9.78),('7643','2013-07-17','09:30:00',10.05),('7643','2013-07-17','09:35:00',10.31),('7643','2013-07-17','09:40:00',10.56),('7643','2013-07-17','09:45:00',10.74),('7643','2013-07-17','09:50:00',10.94),('7643','2013-07-17','09:55:00',11.13),('7643','2013-07-17','10:00:00',11.35),('7643','2013-07-17','10:05:00',11.55),('7643','2013-07-17','10:10:00',11.81),('7643','2013-07-17','10:15:00',11.9),('7643','2013-07-17','10:20:00',12.09),('7643','2013-07-17','10:25:00',12.32),('7643','2013-07-17','10:30:00',12.56),('7643','2013-07-17','10:35:00',12.76),('7643','2013-07-17','10:40:00',12.99),('7643','2013-07-17','10:45:00',13.03),('7643','2013-07-17','10:50:00',13.24),('7643','2013-07-17','10:55:00',13.36),('7643','2013-07-17','11:00:00',13.47),('7643','2013-07-17','11:05:00',13.6),('7643','2013-07-17','11:10:00',13.72),('7643','2013-07-17','11:15:00',13.75),('7643','2013-07-17','11:20:00',13.92),('7643','2013-07-17','11:25:00',14.13),('7643','2013-07-17','11:30:00',14.31),('7643','2013-07-17','11:35:00',14.26),('7643','2013-07-17','11:40:00',14.22),('7643','2013-07-17','11:45:00',14.34),('7643','2013-07-17','11:50:00',14.55),('7643','2013-07-17','11:55:00',14.9),('7643','2013-07-17','12:00:00',14.9),('7643','2013-07-17','12:05:00',14.79),('7643','2013-07-17','12:10:00',14.86),('7643','2013-07-17','12:15:00',14.93),('7643','2013-07-17','12:20:00',14.88),('7643','2013-07-17','12:25:00',13.59),('7643','2013-07-17','12:30:00',5.87),('7643','2013-07-17','12:35:00',12.58),('7643','2013-07-17','12:40:00',12.52),('7643','2013-07-17','12:45:00',16.3),('7643','2013-07-17','12:50:00',12.57),('7643','2013-07-17','12:55:00',13.11),('7643','2013-07-17','13:00:00',16.08),('7643','2013-07-17','13:05:00',15.77),('7643','2013-07-17','13:10:00',15.6),('7643','2013-07-17','13:15:00',15.51),('7643','2013-07-17','13:20:00',14.54),('7643','2013-07-17','13:25:00',11.69),('7643','2013-07-17','13:30:00',16.4),('7643','2013-07-17','13:35:00',15.68),('7643','2013-07-17','13:40:00',16.19),('7643','2013-07-17','13:45:00',16.41),('7643','2013-07-17','13:50:00',16.07),('7643','2013-07-17','13:55:00',15.72),('7643','2013-07-17','14:00:00',15.56),('7643','2013-07-17','14:05:00',15.46),('7643','2013-07-17','14:10:00',15.14),('7643','2013-07-17','14:15:00',15.21),('7643','2013-07-17','14:20:00',15.38),('7643','2013-07-17','14:25:00',14.97),('7643','2013-07-17','14:30:00',14.84),('7643','2013-07-17','14:35:00',15.07),('7643','2013-07-17','14:40:00',15.01),('7643','2013-07-17','14:45:00',14.67),('7643','2013-07-17','14:50:00',14.44),('7643','2013-07-17','14:55:00',14.23),('7643','2013-07-17','15:00:00',14.34),('7643','2013-07-17','15:05:00',14.46),('7643','2013-07-17','15:10:00',14.33),('7643','2013-07-17','15:15:00',14.05),('7643','2013-07-17','15:20:00',13.96),('7643','2013-07-17','15:25:00',13.83),('7643','2013-07-17','15:30:00',13.63),('7643','2013-07-17','15:35:00',13.5),('7643','2013-07-17','15:40:00',13.35),('7643','2013-07-17','15:45:00',13.16),('7643','2013-07-17','15:50:00',12.93),('7643','2013-07-17','15:55:00',12.64),('7643','2013-07-17','16:00:00',12.52),('7643','2013-07-17','16:05:00',12.27),('7643','2013-07-17','16:10:00',12.04),('7643','2013-07-17','16:15:00',11.84),('7643','2013-07-17','16:20:00',11.56),('7643','2013-07-17','16:25:00',11.36),('7643','2013-07-17','16:30:00',11.05),('7643','2013-07-17','16:35:00',10.79),('7643','2013-07-17','16:40:00',10.49),('7643','2013-07-17','16:45:00',10.17),('7643','2013-07-17','16:50:00',9.94),('7643','2013-07-17','16:55:00',9.74),('7643','2013-07-17','17:00:00',9.4),('7643','2013-07-17','17:05:00',9.12),('7643','2013-07-17','17:10:00',8.81),('7643','2013-07-17','17:15:00',8.44),('7643','2013-07-17','17:20:00',8.18),('7643','2013-07-17','17:25:00',7.91),('7643','2013-07-17','17:30:00',7.46),('7643','2013-07-17','17:35:00',7.12),('7643','2013-07-17','17:40:00',6.63),('7643','2013-07-17','17:45:00',6.23),('7643','2013-07-17','17:50:00',6.14),('7643','2013-07-17','17:55:00',5.77),('7643','2013-07-17','18:00:00',5.31),('7643','2013-07-17','18:05:00',5.1),('7643','2013-07-17','18:10:00',4.67),('7643','2013-07-17','18:15:00',4.52),('7643','2013-07-17','18:20:00',4.12),('7643','2013-07-17','18:25:00',3.96),('7643','2013-07-17','18:30:00',2.63),('7643','2013-07-17','18:35:00',1.38),('7643','2013-07-17','18:40:00',1.28),('7643','2013-07-17','18:45:00',1.79),('7643','2013-07-17','18:50:00',1.84),('7643','2013-07-17','18:55:00',1.5),('7643','2013-07-17','19:00:00',2.13),('7643','2013-07-17','19:05:00',1.69),('7643','2013-07-17','19:10:00',1.18),('7643','2013-07-17','19:15:00',1.49),('7643','2013-07-17','19:20:00',1.49),('7643','2013-07-17','19:25:00',1.17),('7643','2013-07-16','06:50:00',1.05),('7643','2013-07-16','06:55:00',1.23),('7643','2013-07-16','07:00:00',1.43),('7643','2013-07-16','07:05:00',1.64),('7643','2013-07-16','07:10:00',1.88),('7643','2013-07-16','07:15:00',2.16),('7643','2013-07-16','07:20:00',2.36),('7643','2013-07-16','07:25:00',2.6),('7643','2013-07-16','07:30:00',2.91),('7643','2013-07-16','07:35:00',3.21),('7643','2013-07-16','07:40:00',3.46),('7643','2013-07-16','07:45:00',3.83),('7643','2013-07-16','07:50:00',4.15),('7643','2013-07-16','07:55:00',4.51),('7643','2013-07-16','08:00:00',4.79),('7643','2013-07-16','08:05:00',5.22),('7643','2013-07-16','08:10:00',5.57),('7643','2013-07-16','08:15:00',5.87),('7643','2013-07-16','08:20:00',6.19),('7643','2013-07-16','08:25:00',6.5),('7643','2013-07-16','08:30:00',6.77),('7643','2013-07-16','08:35:00',7.23),('7643','2013-07-16','08:40:00',7.61),('7643','2013-07-16','08:45:00',7.93),('7643','2013-07-16','08:50:00',8.3),('7643','2013-07-16','08:55:00',8.59),('7643','2013-07-16','09:00:00',8.9),('7643','2013-07-16','09:05:00',9.18),('7643','2013-07-16','09:10:00',9.53),('7643','2013-07-16','09:15:00',9.85),('7643','2013-07-16','09:20:00',10.14),('7643','2013-07-16','09:25:00',10.5),('7643','2013-07-16','09:30:00',10.71),('7643','2013-07-16','09:35:00',10.91),('7643','2013-07-16','09:40:00',11.23),('7643','2013-07-16','09:45:00',11.48),('7643','2013-07-16','09:50:00',11.6),('7643','2013-07-16','09:55:00',11.74),('7643','2013-07-16','10:00:00',11.96),('7643','2013-07-16','10:05:00',12.18),('7643','2013-07-16','10:10:00',12.33),('7643','2013-07-16','10:15:00',12.55),('7643','2013-07-16','10:20:00',12.73),('7643','2013-07-16','10:25:00',12.91),('7643','2013-07-16','10:30:00',13.13),('7643','2013-07-16','10:35:00',13.31),('7643','2013-07-16','10:40:00',13.36),('7643','2013-07-16','10:45:00',13.62),('7643','2013-07-16','10:50:00',13.81),('7643','2013-07-16','10:55:00',13.86),('7643','2013-07-16','11:00:00',14.09),('7643','2013-07-16','11:05:00',14.3),('7643','2013-07-16','11:10:00',14.41),('7643','2013-07-16','11:15:00',14.47),('7643','2013-07-16','11:20:00',14.63),('7643','2013-07-16','11:25:00',14.66),('7643','2013-07-16','11:30:00',14.73),('7643','2013-07-16','11:35:00',14.84),('7643','2013-07-16','11:40:00',14.91),('7643','2013-07-16','11:45:00',15.02),('7643','2013-07-16','11:50:00',15.17),('7643','2013-07-16','11:55:00',15.34),('7643','2013-07-16','12:00:00',15.43),('7643','2013-07-16','12:05:00',15.48),('7643','2013-07-16','12:10:00',15.63),('7643','2013-07-16','12:15:00',15.54),('7643','2013-07-16','12:20:00',15.57),('7643','2013-07-16','12:25:00',15.74),('7643','2013-07-16','12:30:00',15.83),('7643','2013-07-16','12:35:00',15.84),('7643','2013-07-16','12:40:00',15.8),('7643','2013-07-16','12:45:00',15.88),('7643','2013-07-16','12:50:00',15.79),('7643','2013-07-16','12:55:00',15.88),('7643','2013-07-16','13:00:00',15.86),('7643','2013-07-16','13:05:00',15.67),('7643','2013-07-16','13:10:00',15.71),('7643','2013-07-16','13:15:00',15.65),('7643','2013-07-16','13:20:00',15.6),('7643','2013-07-16','13:25:00',15.43),('7643','2013-07-16','13:30:00',15.54),('7643','2013-07-16','13:35:00',15.46),('7643','2013-07-16','13:40:00',15.5),('7643','2013-07-16','13:45:00',15.49),('7643','2013-07-16','13:50:00',15.55),('7643','2013-07-16','13:55:00',15.55),('7643','2013-07-16','14:00:00',15.66),('7643','2013-07-16','14:05:00',15.56),('7643','2013-07-16','14:10:00',15.39),('7643','2013-07-16','14:15:00',15.29),('7643','2013-07-16','14:20:00',15.1),('7643','2013-07-16','14:25:00',14.91),('7643','2013-07-16','14:30:00',14.82),('7643','2013-07-16','14:35:00',14.69),('7643','2013-07-16','14:40:00',15.28),('7643','2013-07-16','14:45:00',15.05),('7643','2013-07-16','14:50:00',14.58),('7643','2013-07-16','14:55:00',14.27),('7643','2013-07-16','15:00:00',14.3),('7643','2013-07-16','15:05:00',14.22),('7643','2013-07-16','15:10:00',10.94),('7643','2013-07-16','15:15:00',14.22),('7643','2013-07-16','15:20:00',14.22),('7643','2013-07-16','15:25:00',11.12),('7643','2013-07-16','15:30:00',13.86),('7643','2013-07-16','15:35:00',13.7),('7643','2013-07-16','15:40:00',11.99),('7643','2013-07-16','15:45:00',13.35),('7643','2013-07-16','15:50:00',12.67),('7643','2013-07-16','15:55:00',13.24),('7643','2013-07-16','16:00:00',12.84),('7643','2013-07-16','16:05:00',12.7),('7643','2013-07-16','16:10:00',12.54),('7643','2013-07-16','16:15:00',12.24),('7643','2013-07-16','16:20:00',11.89),('7643','2013-07-16','16:25:00',11.53),('7643','2013-07-16','16:30:00',11.29),('7643','2013-07-16','16:35:00',10.24),('7643','2013-07-16','16:40:00',10.58),('7643','2013-07-16','16:45:00',10.44),('7643','2013-07-16','16:50:00',10),('7643','2013-07-16','16:55:00',9.7),('7643','2013-07-16','17:00:00',9.86),('7643','2013-07-16','17:05:00',9.76),('7643','2013-07-16','17:10:00',9.51),('7643','2013-07-16','17:15:00',8.88),('7643','2013-07-16','17:20:00',8.57),('7643','2013-07-16','17:25:00',7.92),('7643','2013-07-16','17:30:00',7.79),('7643','2013-07-16','17:35:00',7.49),('7643','2013-07-16','17:40:00',7.13),('7643','2013-07-16','17:45:00',6.78),('7643','2013-07-16','17:50:00',6.66),('7643','2013-07-16','17:55:00',6.26),('7643','2013-07-16','18:00:00',6),('7643','2013-07-16','18:05:00',5.63),('7643','2013-07-16','18:10:00',5.33),('7643','2013-07-16','18:15:00',4.94),('7643','2013-07-16','18:20:00',4.65),('7643','2013-07-16','18:25:00',4.39),('7643','2013-07-16','18:30:00',4.09),('7643','2013-07-16','18:35:00',3.78),('7643','2013-07-16','18:40:00',3.5),('7643','2013-07-16','18:45:00',3.17),('7643','2013-07-16','18:50:00',2.85),('7643','2013-07-16','18:55:00',2.45),('7643','2013-07-16','19:00:00',2.13),('7643','2013-07-16','19:05:00',1.94),('7643','2013-07-16','19:10:00',1.66),('7643','2013-07-16','19:15:00',1.44),('7643','2013-07-16','19:20:00',1.26),('7643','2013-07-16','19:25:00',1.09),('7643','2013-07-15','06:50:00',1.04),('7643','2013-07-15','06:55:00',1.21),('7643','2013-07-15','07:00:00',1.39),('7643','2013-07-15','07:05:00',1.59),('7643','2013-07-15','07:10:00',1.87),('7643','2013-07-15','07:15:00',2.14),('7643','2013-07-15','07:20:00',2.34),('7643','2013-07-15','07:25:00',2.65),('7643','2013-07-15','07:30:00',3),('7643','2013-07-15','07:35:00',3.31),('7643','2013-07-15','07:40:00',3.57),('7643','2013-07-15','07:45:00',3.89),('7643','2013-07-15','07:50:00',4.2),('7643','2013-07-15','07:55:00',4.47),('7643','2013-07-15','08:00:00',4.7),('7643','2013-07-15','08:05:00',5.02),('7643','2013-07-15','08:10:00',5.34),('7643','2013-07-15','08:15:00',5.66),('7643','2013-07-15','08:20:00',5.9),('7643','2013-07-15','08:25:00',6.24),('7643','2013-07-15','08:30:00',6.58),('7643','2013-07-15','08:35:00',6.89),('7643','2013-07-15','08:40:00',7.18),('7643','2013-07-15','08:45:00',7.49),('7643','2013-07-15','08:50:00',7.79),('7643','2013-07-15','08:55:00',8.17),('7643','2013-07-15','09:00:00',8.48),('7643','2013-07-15','09:05:00',8.69),('7643','2013-07-15','09:10:00',8.99),('7643','2013-07-15','09:15:00',9.26),('7643','2013-07-15','09:20:00',9.51),('7643','2013-07-15','09:25:00',9.8),('7643','2013-07-15','09:30:00',10.1),('7643','2013-07-15','09:35:00',10.3),('7643','2013-07-15','09:40:00',10.63),('7643','2013-07-15','09:45:00',10.86),('7643','2013-07-15','09:50:00',11.18),('7643','2013-07-15','09:55:00',11.44),('7643','2013-07-15','10:00:00',11.61),('7643','2013-07-15','10:05:00',11.86),('7643','2013-07-15','10:10:00',12.1),('7643','2013-07-15','10:15:00',12.33),('7643','2013-07-15','10:20:00',12.5),('7643','2013-07-15','10:25:00',12.68),('7643','2013-07-15','10:30:00',12.89),('7643','2013-07-15','10:35:00',13.04),('7643','2013-07-15','10:40:00',13.25),('7643','2013-07-15','10:45:00',13.39),('7643','2013-07-15','10:50:00',13.54),('7643','2013-07-15','10:55:00',13.7),('7643','2013-07-15','11:00:00',13.87),('7643','2013-07-15','11:05:00',14.05),('7643','2013-07-15','11:10:00',14.21),('7643','2013-07-15','11:15:00',14.22),('7643','2013-07-15','11:20:00',14.28),('7643','2013-07-15','11:25:00',14.51),('7643','2013-07-15','11:30:00',14.74),('7643','2013-07-15','11:35:00',14.8),('7643','2013-07-15','11:40:00',14.88),('7643','2013-07-15','11:45:00',14.98),('7643','2013-07-15','11:50:00',15.32),('7643','2013-07-15','11:55:00',15.44),('7643','2013-07-15','12:00:00',15.49),('7643','2013-07-15','12:05:00',15.52),('7643','2013-07-15','12:10:00',15.55),('7643','2013-07-15','12:15:00',15.68),('7643','2013-07-15','12:20:00',15.75),('7643','2013-07-15','12:25:00',15.72),('7643','2013-07-15','12:30:00',15.69),('7643','2013-07-15','12:35:00',15.62),('7643','2013-07-15','12:40:00',15.6),('7643','2013-07-15','12:45:00',15.55),('7643','2013-07-15','12:50:00',15.5),('7643','2013-07-15','12:55:00',15.41),('7643','2013-07-15','13:00:00',15.31),('7643','2013-07-15','13:05:00',15.43),('7643','2013-07-15','13:10:00',15.53),('7643','2013-07-15','13:15:00',15.75),('7643','2013-07-15','13:20:00',15.52),('7643','2013-07-15','13:25:00',15.47),('7643','2013-07-15','13:30:00',15.35),('7643','2013-07-15','13:35:00',15.41),('7643','2013-07-15','13:40:00',15.55),('7643','2013-07-15','13:45:00',15.89),('7643','2013-07-15','13:50:00',16.07),('7643','2013-07-15','13:55:00',15.83),('7643','2013-07-15','14:00:00',15.38),('7643','2013-07-15','14:05:00',15.2),('7643','2013-07-15','14:10:00',15.74),('7643','2013-07-15','14:15:00',15.7),('7643','2013-07-15','14:20:00',4.57),('7643','2013-07-15','14:25:00',11.55),('7643','2013-07-15','14:30:00',15.58),('7643','2013-07-15','14:35:00',15.38),('7643','2013-07-15','14:40:00',15.29),('7643','2013-07-15','14:45:00',15.08),('7643','2013-07-15','14:50:00',15.1),('7643','2013-07-15','14:55:00',15.02),('7643','2013-07-15','15:00:00',14.96),('7643','2013-07-15','15:05:00',14.57),('7643','2013-07-15','15:10:00',14.31),('7643','2013-07-15','15:15:00',14.12),('7643','2013-07-15','15:20:00',14.06),('7643','2013-07-15','15:25:00',13.89),('7643','2013-07-15','15:30:00',13.88),('7643','2013-07-15','15:35:00',14),('7643','2013-07-15','15:40:00',13.67),('7643','2013-07-15','15:45:00',11.34),('7643','2013-07-15','15:50:00',11.78),('7643','2013-07-15','15:55:00',10.62),('7643','2013-07-15','16:00:00',10.32),('7643','2013-07-15','16:05:00',2.79),('7643','2013-07-15','16:10:00',11.02),('7643','2013-07-15','16:15:00',12.56),('7643','2013-07-15','16:20:00',8.45),('7643','2013-07-15','16:25:00',7.32),('7643','2013-07-15','16:30:00',4.85),('7643','2013-07-15','16:35:00',3.01),('7643','2013-07-15','16:40:00',2.86),('7643','2013-07-15','16:45:00',4.66),('7643','2013-07-15','16:50:00',3.94),('7643','2013-07-15','16:55:00',4.38),('7643','2013-07-15','17:00:00',10.01),('7643','2013-07-15','17:05:00',10.37),('7643','2013-07-15','17:10:00',10.21),('7643','2013-07-15','17:15:00',9.63),('7643','2013-07-15','17:20:00',8.47),('7643','2013-07-15','17:25:00',5.35),('7643','2013-07-15','17:30:00',5.52),('7643','2013-07-15','17:35:00',4.59),('7643','2013-07-15','17:40:00',6.5),('7643','2013-07-15','17:45:00',7.48),('7643','2013-07-15','17:50:00',7.04),('7643','2013-07-15','17:55:00',5.98),('7643','2013-07-15','18:00:00',5.5),('7643','2013-07-15','18:05:00',3.51),('7643','2013-07-15','18:10:00',4.01),('7643','2013-07-15','18:15:00',4.95),('7643','2013-07-15','18:20:00',4.5),('7643','2013-07-15','18:25:00',4.31),('7643','2013-07-15','18:30:00',4.05),('7643','2013-07-15','18:35:00',3.69),('7643','2013-07-15','18:40:00',3.32),('7643','2013-07-15','18:45:00',3.03),('7643','2013-07-15','18:50:00',2.74),('7643','2013-07-15','18:55:00',2.4),('7643','2013-07-15','19:00:00',2.09),('7643','2013-07-15','19:05:00',1.83),('7643','2013-07-15','19:10:00',1.64),('7643','2013-07-15','19:15:00',1.46),('7643','2013-07-15','19:20:00',1.29),('7643','2013-07-15','19:25:00',1.07),('7643','2013-07-14','06:50:00',1.08),('7643','2013-07-14','06:55:00',1.25),('7643','2013-07-14','07:00:00',1.43),('7643','2013-07-14','07:05:00',1.67),('7643','2013-07-14','07:10:00',1.95),('7643','2013-07-14','07:15:00',2.19),('7643','2013-07-14','07:20:00',2.38),('7643','2013-07-14','07:25:00',2.73),('7643','2013-07-14','07:30:00',3.02),('7643','2013-07-14','07:35:00',3.35),('7643','2013-07-14','07:40:00',3.65),('7643','2013-07-14','07:45:00',3.99),('7643','2013-07-14','07:50:00',4.33),('7643','2013-07-14','07:55:00',4.65),('7643','2013-07-14','08:00:00',4.95),('7643','2013-07-14','08:05:00',5.28),('7643','2013-07-14','08:10:00',5.6),('7643','2013-07-14','08:15:00',5.91),('7643','2013-07-14','08:20:00',6.21),('7643','2013-07-14','08:25:00',6.54),('7643','2013-07-14','08:30:00',6.89),('7643','2013-07-14','08:35:00',7.23),('7643','2013-07-14','08:40:00',7.59),('7643','2013-07-14','08:45:00',7.91),('7643','2013-07-14','08:50:00',8.21),('7643','2013-07-14','08:55:00',8.56),('7643','2013-07-14','09:00:00',8.86),('7643','2013-07-14','09:05:00',9.12),('7643','2013-07-14','09:10:00',9.44),('7643','2013-07-14','09:15:00',9.73),('7643','2013-07-14','09:20:00',10.05),('7643','2013-07-14','09:25:00',10.31),('7643','2013-07-14','09:30:00',10.57),('7643','2013-07-14','09:35:00',10.8),('7643','2013-07-14','09:40:00',11.03),('7643','2013-07-14','09:45:00',11.24),('7643','2013-07-14','09:50:00',11.46),('7643','2013-07-14','09:55:00',11.68),('7643','2013-07-14','10:00:00',11.85),('7643','2013-07-14','10:05:00',11.98),('7643','2013-07-14','10:10:00',12.23),('7643','2013-07-14','10:15:00',12.45),('7643','2013-07-14','10:20:00',12.68),('7643','2013-07-14','10:25:00',12.82),('7643','2013-07-14','10:30:00',12.97),('7643','2013-07-14','10:35:00',13.04),('7643','2013-07-14','10:40:00',13.14),('7643','2013-07-14','10:45:00',13.3),('7643','2013-07-14','10:50:00',13.47),('7643','2013-07-14','10:55:00',13.61),('7643','2013-07-14','11:00:00',13.82),('7643','2013-07-14','11:05:00',14.03),('7643','2013-07-14','11:10:00',14.12),('7643','2013-07-14','11:15:00',14.18),('7643','2013-07-14','11:20:00',14.28),('7643','2013-07-14','11:25:00',14.4),('7643','2013-07-14','11:30:00',14.47),('7643','2013-07-14','11:35:00',14.6),('7643','2013-07-14','11:40:00',14.65),('7643','2013-07-14','11:45:00',14.65),('7643','2013-07-14','11:50:00',14.8),('7643','2013-07-14','11:55:00',14.88),('7643','2013-07-14','12:00:00',15.14),('7643','2013-07-14','12:05:00',15.33),('7643','2013-07-14','12:10:00',15.35),('7643','2013-07-14','12:15:00',15.32),('7643','2013-07-14','12:20:00',15.51),('7643','2013-07-14','12:25:00',15.52),('7643','2013-07-14','12:30:00',15.6),('7643','2013-07-14','12:35:00',15.66),('7643','2013-07-14','12:40:00',15.58),('7643','2013-07-14','12:45:00',15.46),('7643','2013-07-14','12:50:00',15.56),('7643','2013-07-14','12:55:00',15.59),('7643','2013-07-14','13:00:00',15.69),('7643','2013-07-14','13:05:00',13.42),('7643','2013-07-14','13:10:00',16.11),('7643','2013-07-14','13:15:00',15.73),('7643','2013-07-14','13:20:00',15.5),('7643','2013-07-14','13:25:00',16.1),('7643','2013-07-14','13:30:00',15.63),('7643','2013-07-14','13:35:00',14.04),('7643','2013-07-14','13:40:00',4.28),('7643','2013-07-14','13:45:00',7.07),('7643','2013-07-14','13:50:00',17),('7643','2013-07-14','13:55:00',17.17),('7643','2013-07-14','14:00:00',16.9),('7643','2013-07-14','14:05:00',14.82),('7643','2013-07-14','14:10:00',3.77),('7643','2013-07-14','14:15:00',5.71),('7643','2013-07-14','14:20:00',8.83),('7643','2013-07-14','14:25:00',16.66),('7643','2013-07-14','14:30:00',15.69),('7643','2013-07-14','14:35:00',9.92),('7643','2013-07-14','14:40:00',15.88),('7643','2013-07-14','14:45:00',15.53),('7643','2013-07-14','14:50:00',15.39),('7643','2013-07-14','14:55:00',15.36),('7643','2013-07-14','15:00:00',15.43),('7643','2013-07-14','15:05:00',14.92),('7643','2013-07-14','15:10:00',14.74),('7643','2013-07-14','15:15:00',14.5),('7643','2013-07-14','15:20:00',13.54),('7643','2013-07-14','15:25:00',13.38),('7643','2013-07-14','15:30:00',13.45),('7643','2013-07-14','15:35:00',7.8),('7643','2013-07-14','15:40:00',14.16),('7643','2013-07-14','15:45:00',13.69),('7643','2013-07-14','15:50:00',13.65),('7643','2013-07-14','15:55:00',13.23),('7643','2013-07-14','16:00:00',12.7),('7643','2013-07-14','16:05:00',12.58),('7643','2013-07-14','16:10:00',12.23),('7643','2013-07-14','16:15:00',12.06),('7643','2013-07-14','16:20:00',11.57),('7643','2013-07-14','16:25:00',11.34),('7643','2013-07-14','16:30:00',11.13),('7643','2013-07-14','16:35:00',11.03),('7643','2013-07-14','16:40:00',10.63),('7643','2013-07-14','16:45:00',10.32),('7643','2013-07-14','16:50:00',10.07),('7643','2013-07-14','16:55:00',9.87),('7643','2013-07-14','17:00:00',9.52),('7643','2013-07-14','17:05:00',9.35),('7643','2013-07-14','17:10:00',9.05),('7643','2013-07-14','17:15:00',8.74),('7643','2013-07-14','17:20:00',8.38),('7643','2013-07-14','17:25:00',8.1),('7643','2013-07-14','17:30:00',7.74),('7643','2013-07-14','17:35:00',7.45),('7643','2013-07-14','17:40:00',7.08),('7643','2013-07-14','17:45:00',6.69),('7643','2013-07-14','17:50:00',6.5),('7643','2013-07-14','17:55:00',6.17),('7643','2013-07-14','18:00:00',5.82),('7643','2013-07-14','18:05:00',5.47),('7643','2013-07-14','18:10:00',5.14),('7643','2013-07-14','18:15:00',4.78),('7643','2013-07-14','18:20:00',4.56),('7643','2013-07-14','18:25:00',4.3),('7643','2013-07-14','18:30:00',4.02),('7643','2013-07-14','18:35:00',3.68),('7643','2013-07-14','18:40:00',3.45),('7643','2013-07-14','18:45:00',3.19),('7643','2013-07-14','18:50:00',2.88),('7643','2013-07-14','18:55:00',2.55),('7643','2013-07-14','19:00:00',2.27),('7643','2013-07-14','19:05:00',2.06),('7643','2013-07-14','19:10:00',1.79),('7643','2013-07-14','19:15:00',1.58),('7643','2013-07-14','19:20:00',1.38),('7643','2013-07-14','19:25:00',1.23),('7643','2013-07-14','19:30:00',1.08),('7643','2013-07-13','07:20:00',1.08),('7643','2013-07-13','07:25:00',1.41),('7643','2013-07-13','07:30:00',1.27),('7643','2013-07-13','07:35:00',1.8),('7643','2013-07-13','07:40:00',2.57),('7643','2013-07-13','07:45:00',2.92),('7643','2013-07-13','07:50:00',4.25),('7643','2013-07-13','07:55:00',5.56),('7643','2013-07-13','08:00:00',4.92),('7643','2013-07-13','08:05:00',6.1),('7643','2013-07-13','08:10:00',6.95),('7643','2013-07-13','08:15:00',5.52),('7643','2013-07-13','08:20:00',7.02),('7643','2013-07-13','08:25:00',5.7),('7643','2013-07-13','08:30:00',3.58),('7643','2013-07-13','08:35:00',4.36),('7643','2013-07-13','08:40:00',4.35),('7643','2013-07-13','08:45:00',3.57),('7643','2013-07-13','08:50:00',3.9),('7643','2013-07-13','08:55:00',4),('7643','2013-07-13','09:00:00',3.75),('7643','2013-07-13','09:05:00',4.5),('7643','2013-07-13','09:10:00',5.52),('7643','2013-07-13','09:15:00',6.9),('7643','2013-07-13','09:20:00',7.71),('7643','2013-07-13','09:25:00',7.89),('7643','2013-07-13','09:30:00',8.73),('7643','2013-07-13','09:35:00',7.22),('7643','2013-07-13','09:40:00',6.33),('7643','2013-07-13','09:45:00',6.38),('7643','2013-07-13','09:50:00',6.12),('7643','2013-07-13','09:55:00',6.24),('7643','2013-07-13','10:00:00',6.22),('7643','2013-07-13','10:05:00',6.86),('7643','2013-07-13','10:10:00',6.65),('7643','2013-07-13','10:15:00',7.03),('7643','2013-07-13','10:20:00',9.36),('7643','2013-07-13','10:25:00',9.99),('7643','2013-07-13','10:30:00',9.98),('7643','2013-07-13','10:35:00',13.03),('7643','2013-07-13','10:40:00',13.87),('7643','2013-07-13','10:45:00',10.48),('7643','2013-07-13','10:50:00',14.96),('7643','2013-07-13','10:55:00',13.06),('7643','2013-07-13','11:00:00',12.74),('7643','2013-07-13','11:05:00',12.24),('7643','2013-07-13','11:10:00',15.11),('7643','2013-07-13','11:15:00',11.04),('7643','2013-07-13','11:20:00',16.26),('7643','2013-07-13','11:25:00',15.45),('7643','2013-07-13','11:30:00',16.25),('7643','2013-07-13','11:35:00',16.2),('7643','2013-07-13','11:40:00',13.31),('7643','2013-07-13','11:45:00',5.47),('7643','2013-07-13','11:50:00',5.82),('7643','2013-07-13','11:55:00',5.78),('7643','2013-07-13','12:00:00',5.96),('7643','2013-07-13','12:05:00',12.77),('7643','2013-07-13','12:10:00',12.64),('7643','2013-07-13','12:15:00',12.73),('7643','2013-07-13','12:20:00',11.81),('7643','2013-07-13','12:25:00',9.38),('7643','2013-07-13','12:30:00',6.82),('7643','2013-07-13','12:35:00',15.55),('7643','2013-07-13','12:40:00',17.49),('7643','2013-07-13','12:45:00',16.34),('7643','2013-07-13','12:50:00',13.92),('7643','2013-07-13','12:55:00',5.62),('7643','2013-07-13','13:00:00',6.11),('7643','2013-07-13','13:05:00',15.51),('7643','2013-07-13','13:10:00',17.23),('7643','2013-07-13','13:15:00',12.68),('7643','2013-07-13','13:20:00',15.78),('7643','2013-07-13','13:25:00',16.8),('7643','2013-07-13','13:30:00',16.37),('7643','2013-07-13','13:35:00',16.47),('7643','2013-07-13','13:40:00',16.57),('7643','2013-07-13','13:45:00',16.4),('7643','2013-07-13','13:50:00',16.52),('7643','2013-07-13','13:55:00',16.31),('7643','2013-07-13','14:00:00',16.34),('7643','2013-07-13','14:05:00',16.45),('7643','2013-07-13','14:10:00',16.36),('7643','2013-07-13','14:15:00',16.24),('7643','2013-07-13','14:20:00',16.11),('7643','2013-07-13','14:25:00',16.04),('7643','2013-07-13','14:30:00',15.92),('7643','2013-07-13','14:35:00',15.74),('7643','2013-07-13','14:40:00',15.48),('7643','2013-07-13','14:45:00',15.21),('7643','2013-07-13','14:50:00',14.95),('7643','2013-07-13','14:55:00',15.11),('7643','2013-07-13','15:00:00',14.85),('7643','2013-07-13','15:05:00',14.76),('7643','2013-07-13','15:10:00',14.62),('7643','2013-07-13','15:15:00',14.46),('7643','2013-07-13','15:20:00',14.25),('7643','2013-07-13','15:25:00',14.08),('7643','2013-07-13','15:30:00',13.87),('7643','2013-07-13','15:35:00',13.61),('7643','2013-07-13','15:40:00',13.54),('7643','2013-07-13','15:45:00',13.33),('7643','2013-07-13','15:50:00',12.1),('7643','2013-07-13','15:55:00',13.11),('7643','2013-07-13','16:00:00',12.72),('7643','2013-07-13','16:05:00',12.68),('7643','2013-07-13','16:10:00',12.5),('7643','2013-07-13','16:15:00',12.34),('7643','2013-07-13','16:20:00',11.25),('7643','2013-07-13','16:25:00',11.9),('7643','2013-07-13','16:30:00',8.78),('7643','2013-07-13','16:35:00',10.98),('7643','2013-07-13','16:40:00',11.51),('7643','2013-07-13','16:45:00',11.21),('7643','2013-07-13','16:50:00',6.98),('7643','2013-07-13','16:55:00',7.79),('7643','2013-07-13','17:00:00',8.34),('7643','2013-07-13','17:05:00',8.57),('7643','2013-07-13','17:10:00',8.4),('7643','2013-07-13','17:15:00',9.57),('7643','2013-07-13','17:20:00',5.49),('7643','2013-07-13','17:25:00',8.35),('7643','2013-07-13','17:30:00',8.44),('7643','2013-07-13','17:35:00',8.27),('7643','2013-07-13','17:40:00',3.53),('7643','2013-07-13','17:45:00',3.98),('7643','2013-07-13','17:50:00',5),('7643','2013-07-13','17:55:00',5.63),('7643','2013-07-13','18:00:00',5.2),('7643','2013-07-13','18:05:00',3.42),('7643','2013-07-13','18:10:00',3.59),('7643','2013-07-13','18:15:00',1.27),('7643','2013-07-13','18:35:00',1.29),('7643','2013-07-13','18:40:00',2.17),('7643','2013-07-13','18:45:00',2.68),('7643','2013-07-13','18:50:00',2.5),('7643','2013-07-13','18:55:00',2.09),('7643','2013-07-13','19:00:00',1.63),('7643','2013-07-13','19:05:00',1.68),('7643','2013-07-13','19:10:00',2.24),('7643','2013-07-13','19:15:00',2.63),('7643','2013-07-13','19:20:00',2.81),('7643','2013-07-13','19:25:00',2.05),('7643','2013-07-13','19:30:00',1.27),('7643','2013-07-12','07:10:00',1.22),('7643','2013-07-12','07:15:00',1.41),('7643','2013-07-12','07:20:00',1.78),('7643','2013-07-12','07:25:00',2.36),('7643','2013-07-12','07:30:00',3.09),('7643','2013-07-12','07:35:00',3.34),('7643','2013-07-12','07:40:00',3.42),('7643','2013-07-12','07:45:00',3.64),('7643','2013-07-12','07:50:00',3.92),('7643','2013-07-12','07:55:00',4.22),('7643','2013-07-12','08:00:00',4.53),('7643','2013-07-12','08:05:00',4.95),('7643','2013-07-12','08:10:00',5.22),('7643','2013-07-12','08:15:00',5.52),('7643','2013-07-12','08:20:00',5.8),('7643','2013-07-12','08:25:00',6.12),('7643','2013-07-12','08:30:00',6.4),('7643','2013-07-12','08:35:00',6.72),('7643','2013-07-12','08:40:00',7.01),('7643','2013-07-12','08:45:00',7.35),('7643','2013-07-12','08:50:00',7.63),('7643','2013-07-12','08:55:00',7.97),('7643','2013-07-12','09:00:00',8.37),('7643','2013-07-12','09:05:00',8.73),('7643','2013-07-12','09:10:00',9.03),('7643','2013-07-12','09:15:00',9.21),('7643','2013-07-12','09:20:00',9.5),('7643','2013-07-12','09:25:00',9.77),('7643','2013-07-12','09:30:00',10.02),('7643','2013-07-12','09:35:00',10.11),('7643','2013-07-12','09:40:00',10.45),('7643','2013-07-12','09:45:00',10.74),('7643','2013-07-12','09:50:00',11.06),('7643','2013-07-12','09:55:00',11.33),('7643','2013-07-12','10:00:00',11.45),('7643','2013-07-12','10:05:00',11.49),('7643','2013-07-12','10:10:00',12),('7643','2013-07-12','10:15:00',12.21),('7643','2013-07-12','10:20:00',12.24),('7643','2013-07-12','10:25:00',12.46),('7643','2013-07-12','10:30:00',12.86),('7643','2013-07-12','10:35:00',12.66),('7643','2013-07-12','10:40:00',12.97),('7643','2013-07-12','10:45:00',8.55),('7643','2013-07-12','10:50:00',8.61),('7643','2013-07-12','10:55:00',14.38),('7643','2013-07-12','11:00:00',14.66),('7643','2013-07-12','11:05:00',14.48),('7643','2013-07-12','11:10:00',14.63),('7643','2013-07-12','11:15:00',10.7),('7643','2013-07-12','11:20:00',13.67),('7643','2013-07-12','11:25:00',11.06),('7643','2013-07-12','11:30:00',15.58),('7643','2013-07-12','11:35:00',14.49),('7643','2013-07-12','11:40:00',11.64),('7643','2013-07-12','11:45:00',11.2),('7643','2013-07-12','11:50:00',4.69),('7643','2013-07-12','11:55:00',11.02),('7643','2013-07-12','12:00:00',14.74),('7643','2013-07-12','12:05:00',4.53),('7643','2013-07-12','12:10:00',13.31),('7643','2013-07-12','12:15:00',16.04),('7643','2013-07-12','12:20:00',8.33),('7643','2013-07-12','12:25:00',14.91),('7643','2013-07-12','12:30:00',13.98),('7643','2013-07-12','12:35:00',15.89),('7643','2013-07-12','12:40:00',16.05),('7643','2013-07-12','12:45:00',16.86),('7643','2013-07-12','12:50:00',16.82),('7643','2013-07-12','12:55:00',10.34),('7643','2013-07-12','13:00:00',14.1),('7643','2013-07-12','13:05:00',15.23),('7643','2013-07-12','13:10:00',16.65),('7643','2013-07-12','13:15:00',16.58),('7643','2013-07-12','13:20:00',16.59),('7643','2013-07-12','13:25:00',16.41),('7643','2013-07-12','13:30:00',16.01),('7643','2013-07-12','13:35:00',16.24),('7643','2013-07-12','13:40:00',16.31),('7643','2013-07-12','13:45:00',16.07),('7643','2013-07-12','13:50:00',16.17),('7643','2013-07-12','13:55:00',15.95),('7643','2013-07-12','14:00:00',16),('7643','2013-07-12','14:05:00',15.97),('7643','2013-07-12','14:10:00',15.95),('7643','2013-07-12','14:15:00',15.75),('7643','2013-07-12','14:20:00',15.59),('7643','2013-07-12','14:25:00',15.5),('7643','2013-07-12','14:30:00',15.49),('7643','2013-07-12','14:35:00',15.46),('7643','2013-07-12','14:40:00',15.29),('7643','2013-07-12','14:45:00',15.27),('7643','2013-07-12','14:50:00',15.31),('7643','2013-07-12','14:55:00',15.01),('7643','2013-07-12','15:00:00',14.94),('7643','2013-07-12','15:05:00',15.02),('7643','2013-07-12','15:10:00',14.9),('7643','2013-07-12','15:15:00',14.74),('7643','2013-07-12','15:20:00',14),('7643','2013-07-12','15:25:00',14.6),('7643','2013-07-12','15:30:00',14.26),('7643','2013-07-12','15:35:00',14.38),('7643','2013-07-12','15:40:00',14.13),('7643','2013-07-12','15:45:00',13.87),('7643','2013-07-12','15:50:00',13.62),('7643','2013-07-12','15:55:00',13.43),('7643','2013-07-12','16:00:00',13.28),('7643','2013-07-12','16:05:00',13),('7643','2013-07-12','16:10:00',12.67),('7643','2013-07-12','16:15:00',12.44),('7643','2013-07-12','16:20:00',12.19),('7643','2013-07-12','16:25:00',12.13),('7643','2013-07-12','16:30:00',11.84),('7643','2013-07-12','16:35:00',11.5),('7643','2013-07-12','16:40:00',11.19),('7643','2013-07-12','16:45:00',10.85),('7643','2013-07-12','16:50:00',10.59),('7643','2013-07-12','16:55:00',10.33),('7643','2013-07-12','17:00:00',10),('7643','2013-07-12','17:05:00',9.54),('7643','2013-07-12','17:10:00',9.5),('7643','2013-07-12','17:15:00',9.11),('7643','2013-07-12','17:20:00',8.51),('7643','2013-07-12','17:25:00',8.54),('7643','2013-07-12','17:30:00',8.01),('7643','2013-07-12','17:35:00',7.64),('7643','2013-07-12','17:40:00',7.43),('7643','2013-07-12','17:45:00',7.1),('7643','2013-07-12','17:50:00',6.77),('7643','2013-07-12','17:55:00',6.74),('7643','2013-07-12','18:00:00',6.23),('7643','2013-07-12','18:05:00',5.75),('7643','2013-07-12','18:10:00',5.53),('7643','2013-07-12','18:15:00',5.14),('7643','2013-07-12','18:20:00',4.92),('7643','2013-07-12','18:25:00',4.73),('7643','2013-07-12','18:30:00',4.3),('7643','2013-07-12','18:35:00',3.92),('7643','2013-07-12','18:40:00',2.74),('7643','2013-07-12','18:45:00',1.87),('7643','2013-07-12','18:50:00',2.62),('7643','2013-07-12','18:55:00',2.88),('7643','2013-07-12','19:00:00',2.59),('7643','2013-07-12','19:05:00',2.24),('7643','2013-07-12','19:10:00',1.88),('7643','2013-07-12','19:15:00',1.24),('7643','2013-07-12','19:20:00',1.04),('7643','2013-07-11','06:45:00',1.01),('7643','2013-07-11','06:50:00',1.24),('7643','2013-07-11','06:55:00',1.51),('7643','2013-07-11','07:00:00',1.59),('7643','2013-07-11','07:05:00',1.79),('7643','2013-07-11','07:10:00',1.85),('7643','2013-07-11','07:15:00',1.9),('7643','2013-07-11','07:20:00',2.34),('7643','2013-07-11','07:25:00',2.56),('7643','2013-07-11','07:30:00',2.65),('7643','2013-07-11','07:35:00',2.6),('7643','2013-07-11','07:40:00',2.13),('7643','2013-07-11','07:45:00',2.51),('7643','2013-07-11','07:50:00',2.79),('7643','2013-07-11','07:55:00',1.97),('7643','2013-07-11','08:00:00',1.59),('7643','2013-07-11','08:05:00',2.57),('7643','2013-07-11','08:10:00',4.99),('7643','2013-07-11','08:15:00',6.2),('7643','2013-07-11','08:20:00',6.99),('7643','2013-07-11','08:25:00',3.4),('7643','2013-07-11','08:30:00',2.61),('7643','2013-07-11','08:35:00',3.18),('7643','2013-07-11','08:40:00',4.24),('7643','2013-07-11','08:45:00',5.47),('7643','2013-07-11','08:50:00',3.76),('7643','2013-07-11','08:55:00',2.73),('7643','2013-07-11','09:00:00',2.54),('7643','2013-07-11','09:05:00',3.13),('7643','2013-07-11','09:10:00',4.26),('7643','2013-07-11','09:15:00',5.52),('7643','2013-07-11','09:20:00',6.22),('7643','2013-07-11','09:25:00',9.19),('7643','2013-07-11','09:30:00',6.87),('7643','2013-07-11','09:35:00',8.53),('7643','2013-07-11','09:40:00',8.01),('7643','2013-07-11','09:45:00',10.22),('7643','2013-07-11','09:50:00',10.67),('7643','2013-07-11','09:55:00',11.14),('7643','2013-07-11','10:00:00',10.89),('7643','2013-07-11','10:05:00',11.71),('7643','2013-07-11','10:10:00',10.6),('7643','2013-07-11','10:15:00',4.72),('7643','2013-07-11','10:20:00',4.46),('7643','2013-07-11','10:25:00',6.72),('7643','2013-07-11','10:30:00',9.09),('7643','2013-07-11','10:35:00',8.33),('7643','2013-07-11','10:40:00',3.46),('7643','2013-07-11','10:45:00',3.2),('7643','2013-07-11','10:50:00',4.03),('7643','2013-07-11','10:55:00',12.13),('7643','2013-07-11','11:00:00',15.86),('7643','2013-07-11','11:05:00',8.38),('7643','2013-07-11','11:10:00',6.03),('7643','2013-07-11','11:15:00',12.11),('7643','2013-07-11','11:20:00',8.25),('7643','2013-07-11','11:25:00',11.84),('7643','2013-07-11','11:30:00',16.51),('7643','2013-07-11','11:35:00',12.31),('7643','2013-07-11','11:40:00',8.8),('7643','2013-07-11','11:45:00',10.61),('7643','2013-07-11','11:50:00',9.12),('7643','2013-07-11','11:55:00',15.37),('7643','2013-07-11','12:00:00',16.48),('7643','2013-07-11','12:05:00',14.59),('7643','2013-07-11','12:10:00',11.56),('7643','2013-07-11','12:15:00',6.09),('7643','2013-07-11','12:20:00',15.04),('7643','2013-07-11','12:25:00',16.72),('7643','2013-07-11','12:30:00',14.84),('7643','2013-07-11','12:35:00',17.79),('7643','2013-07-11','12:40:00',7.95),('7643','2013-07-11','12:45:00',14.29),('7643','2013-07-11','12:50:00',12.51),('7643','2013-07-11','12:55:00',13.28),('7643','2013-07-11','13:00:00',16.89),('7643','2013-07-11','13:05:00',15.13),('7643','2013-07-11','13:10:00',16.53),('7643','2013-07-11','13:15:00',16.45),('7643','2013-07-11','13:20:00',16.45),('7643','2013-07-11','13:25:00',16.03),('7643','2013-07-11','13:30:00',15.66),('7643','2013-07-11','13:35:00',16.06),('7643','2013-07-11','13:40:00',15.59),('7643','2013-07-11','13:45:00',16.14),('7643','2013-07-11','13:50:00',14.39),('7643','2013-07-11','13:55:00',16.61),('7643','2013-07-11','14:00:00',15.17),('7643','2013-07-11','14:05:00',16.86),('7643','2013-07-11','14:10:00',12.58),('7643','2013-07-11','14:15:00',12.55),('7643','2013-07-11','14:20:00',17.14),('7643','2013-07-11','14:25:00',16.55),('7643','2013-07-11','14:30:00',15.87),('7643','2013-07-11','14:35:00',15.13),('7643','2013-07-11','14:40:00',15.01),('7643','2013-07-11','14:45:00',14.95),('7643','2013-07-11','14:50:00',14.79),('7643','2013-07-11','14:55:00',14.98),('7643','2013-07-11','15:00:00',14.64),('7643','2013-07-11','15:05:00',14.45),('7643','2013-07-11','15:10:00',14.59),('7643','2013-07-11','15:15:00',14.38),('7643','2013-07-11','15:20:00',14.22),('7643','2013-07-11','15:25:00',13.99),('7643','2013-07-11','15:30:00',13.8),('7643','2013-07-11','15:35:00',13.47),('7643','2013-07-11','15:40:00',13.75),('7643','2013-07-11','15:45:00',13.48),('7643','2013-07-11','15:50:00',13.04),('7643','2013-07-11','15:55:00',12.92),('7643','2013-07-11','16:00:00',12.73),('7643','2013-07-11','16:05:00',12.33),('7643','2013-07-11','16:10:00',12.19),('7643','2013-07-11','16:15:00',12.02),('7643','2013-07-11','16:20:00',11.82),('7643','2013-07-11','16:25:00',11.65),('7643','2013-07-11','16:30:00',11.34),('7643','2013-07-11','16:35:00',11.12),('7643','2013-07-11','16:40:00',10.78),('7643','2013-07-11','16:45:00',10.61),('7643','2013-07-11','16:50:00',10.36),('7643','2013-07-11','16:55:00',10.05),('7643','2013-07-11','17:00:00',9.74),('7643','2013-07-11','17:05:00',9.46),('7643','2013-07-11','17:10:00',9.17),('7643','2013-07-11','17:15:00',8.86),('7643','2013-07-11','17:20:00',8.37),('7643','2013-07-11','17:25:00',7.98),('7643','2013-07-11','17:30:00',7.75),('7643','2013-07-11','17:35:00',7.43),('7643','2013-07-11','17:40:00',7.14),('7643','2013-07-11','17:45:00',6.76),('7643','2013-07-11','17:50:00',6.53),('7643','2013-07-11','17:55:00',6.35),('7643','2013-07-11','18:00:00',5.93),('7643','2013-07-11','18:05:00',5.63),('7643','2013-07-11','18:10:00',5.29),('7643','2013-07-11','18:15:00',4.93),('7643','2013-07-11','18:20:00',4.66),('7643','2013-07-11','18:25:00',4.43),('7643','2013-07-11','18:30:00',4.09),('7643','2013-07-11','18:35:00',3.82),('7643','2013-07-11','18:40:00',3.53),('7643','2013-07-11','18:45:00',3.22),('7643','2013-07-11','18:50:00',2.85),('7643','2013-07-11','18:55:00',2.53),('7643','2013-07-11','19:00:00',2.26),('7643','2013-07-11','19:05:00',2.03),('7643','2013-07-11','19:10:00',1.76),('7643','2013-07-11','19:15:00',1.59),('7643','2013-07-11','19:20:00',1.32),('7643','2013-07-11','19:30:00',1.08),('7643','2013-07-10','06:45:00',1.01),('7643','2013-07-10','06:50:00',1.18),('7643','2013-07-10','06:55:00',1.34),('7643','2013-07-10','07:00:00',1.51),('7643','2013-07-10','07:05:00',1.7),('7643','2013-07-10','07:10:00',1.88),('7643','2013-07-10','07:15:00',2.15),('7643','2013-07-10','07:20:00',2.4),('7643','2013-07-10','07:25:00',2.67),('7643','2013-07-10','07:30:00',2.94),('7643','2013-07-10','07:35:00',3.22),('7643','2013-07-10','07:40:00',3.55),('7643','2013-07-10','07:45:00',3.72),('7643','2013-07-10','07:50:00',4.04),('7643','2013-07-10','07:55:00',4.36),('7643','2013-07-10','08:00:00',4.67),('7643','2013-07-10','08:05:00',5),('7643','2013-07-10','08:10:00',5.22),('7643','2013-07-10','08:15:00',5.54),('7643','2013-07-10','08:20:00',5.91),('7643','2013-07-10','08:25:00',6.19),('7643','2013-07-10','08:30:00',6.48),('7643','2013-07-10','08:35:00',6.71),('7643','2013-07-10','08:40:00',6.88),('7643','2013-07-10','08:45:00',7.37),('7643','2013-07-10','08:50:00',7.81),('7643','2013-07-10','08:55:00',7.82),('7643','2013-07-10','09:00:00',8.36),('7643','2013-07-10','09:05:00',8.56),('7643','2013-07-10','09:10:00',9.02),('7643','2013-07-10','09:15:00',9.28),('7643','2013-07-10','09:20:00',8.41),('7643','2013-07-10','09:25:00',9.44),('7643','2013-07-10','09:30:00',6.84),('7643','2013-07-10','09:35:00',8),('7643','2013-07-10','09:40:00',11.06),('7643','2013-07-10','09:45:00',10.3),('7643','2013-07-10','09:50:00',9.38),('7643','2013-07-10','09:55:00',7.1),('7643','2013-07-10','10:00:00',5.58),('7643','2013-07-10','10:05:00',9.44),('7643','2013-07-10','10:10:00',11.19),('7643','2013-07-10','10:15:00',11.89),('7643','2013-07-10','10:20:00',12.89),('7643','2013-07-10','10:25:00',13.21),('7643','2013-07-10','10:30:00',9.23),('7643','2013-07-10','10:35:00',4.6),('7643','2013-07-10','10:40:00',4.52),('7643','2013-07-10','10:45:00',4.64),('7643','2013-07-10','10:50:00',13),('7643','2013-07-10','10:55:00',14.93),('7643','2013-07-10','11:00:00',11.51),('7643','2013-07-10','11:05:00',5.73),('7643','2013-07-10','11:10:00',15.65),('7643','2013-07-10','11:15:00',16.03),('7643','2013-07-10','11:20:00',12.08),('7643','2013-07-10','11:25:00',14.62),('7643','2013-07-10','11:30:00',15.5),('7643','2013-07-10','11:35:00',13.54),('7643','2013-07-10','11:40:00',6.43),('7643','2013-07-10','11:45:00',14.1),('7643','2013-07-10','11:50:00',13.73),('7643','2013-07-10','11:55:00',11.35),('7643','2013-07-10','12:00:00',12.21),('7643','2013-07-10','12:05:00',12.74),('7643','2013-07-10','12:10:00',4.48),('7643','2013-07-10','12:15:00',8.99),('7643','2013-07-10','12:20:00',16.31),('7643','2013-07-10','12:25:00',17.19),('7643','2013-07-10','12:30:00',16.95),('7643','2013-07-10','12:35:00',17.03),('7643','2013-07-10','12:40:00',16.89),('7643','2013-07-10','12:45:00',16.74),('7643','2013-07-10','12:50:00',17.05),('7643','2013-07-10','12:55:00',12.91),('7643','2013-07-10','13:00:00',15.28),('7643','2013-07-10','13:05:00',7.32),('7643','2013-07-10','13:10:00',15.82),('7643','2013-07-10','13:15:00',16.67),('7643','2013-07-10','13:20:00',16.73),('7643','2013-07-10','13:25:00',16.39),('7643','2013-07-10','13:30:00',16.62),('7643','2013-07-10','13:35:00',17.04),('7643','2013-07-10','13:40:00',16.79),('7643','2013-07-10','13:45:00',15.37),('7643','2013-07-10','13:50:00',11.13),('7643','2013-07-10','13:55:00',5.14),('7643','2013-07-10','14:00:00',13.81),('7643','2013-07-10','14:05:00',17.13),('7643','2013-07-10','14:10:00',16.37),('7643','2013-07-10','14:15:00',16.65),('7643','2013-07-10','14:20:00',15.79),('7643','2013-07-10','14:25:00',15.66),('7643','2013-07-10','14:30:00',13.04),('7643','2013-07-10','14:35:00',15.76),('7643','2013-07-10','14:40:00',15.64),('7643','2013-07-10','14:45:00',16.08),('7643','2013-07-10','14:50:00',15.31),('7643','2013-07-10','14:55:00',8.04),('7643','2013-07-10','15:00:00',14.33),('7643','2013-07-10','15:05:00',15.19),('7643','2013-07-10','15:10:00',9.13),('7643','2013-07-10','15:15:00',7.7),('7643','2013-07-10','15:20:00',11.52),('7643','2013-07-10','15:25:00',10.84),('7643','2013-07-10','15:30:00',10.24),('7643','2013-07-10','15:35:00',14.26),('7643','2013-07-10','15:40:00',11.04),('7643','2013-07-10','15:45:00',8.73),('7643','2013-07-10','15:50:00',10.78),('7643','2013-07-10','15:55:00',6.57),('7643','2013-07-10','16:00:00',9.62),('7643','2013-07-10','16:05:00',13.45),('7643','2013-07-10','16:10:00',9.47),('7643','2013-07-10','16:15:00',12.57),('7643','2013-07-10','16:20:00',12.37),('7643','2013-07-10','16:25:00',9.86),('7643','2013-07-10','16:30:00',12.18),('7643','2013-07-10','16:35:00',12.02),('7643','2013-07-10','16:40:00',11.76),('7643','2013-07-10','16:45:00',9.3),('7643','2013-07-10','16:50:00',11.5),('7643','2013-07-10','16:55:00',10.17),('7643','2013-07-10','17:00:00',9.63),('7643','2013-07-10','17:05:00',10.45),('7643','2013-07-10','17:10:00',10.08),('7643','2013-07-10','17:15:00',7.22),('7643','2013-07-10','17:20:00',10.01),('7643','2013-07-10','17:25:00',5.99),('7643','2013-07-10','17:30:00',9.04),('7643','2013-07-10','17:35:00',7.42),('7643','2013-07-10','17:40:00',6.89),('7643','2013-07-10','17:45:00',7.3),('7643','2013-07-10','17:50:00',7.06),('7643','2013-07-10','17:55:00',6.77),('7643','2013-07-10','18:00:00',7.37),('7643','2013-07-10','18:05:00',5.37),('7643','2013-07-10','18:10:00',5.67),('7643','2013-07-10','18:15:00',5.77),('7643','2013-07-10','18:20:00',4.31),('7643','2013-07-10','18:25:00',4.32),('7643','2013-07-10','18:30:00',4.42),('7643','2013-07-10','18:35:00',4.15),('7643','2013-07-10','18:40:00',2.86),('7643','2013-07-10','18:45:00',2.49),('7643','2013-07-10','18:50:00',2.09),('7643','2013-07-10','18:55:00',1.75),('7643','2013-07-10','19:00:00',2.32),('7643','2013-07-10','19:05:00',1.88),('7643','2013-07-10','19:10:00',1.57),('7643','2013-07-10','19:15:00',1.54),('7643','2013-07-10','19:20:00',1.34),('7643','2013-07-10','19:25:00',1.2),('7643','2014-05-02','07:05:00',1.52),('7643','2014-05-02','07:10:00',1.8),('7643','2014-05-02','07:15:00',2.1),('7643','2014-05-02','07:20:00',2.41),('7643','2014-05-02','07:25:00',2.76),('7643','2014-05-02','07:30:00',3.13),('7643','2014-05-02','07:35:00',3.51),('7643','2014-05-02','07:40:00',3.95),('7643','2014-05-02','07:45:00',4.37),('7643','2014-05-02','07:50:00',4.82),('7643','2014-05-02','07:55:00',5.43),('7643','2014-05-02','08:00:00',5.67),('7643','2014-05-02','08:05:00',6.69),('7643','2014-05-02','08:10:00',6.54),('7643','2014-05-02','08:15:00',7.03),('7643','2014-05-02','08:20:00',4.53),('7643','2014-05-02','08:25:00',4.01),('7643','2014-05-02','08:30:00',4.08),('7643','2014-05-02','08:35:00',4.11),('7643','2014-05-02','08:40:00',6.14),('7643','2014-05-02','08:45:00',8.81),('7643','2014-05-02','08:50:00',10.24),('7643','2014-05-02','08:55:00',10.72),('7643','2014-05-02','09:00:00',12.21),('7643','2014-05-02','09:05:00',10.15),('7643','2014-05-02','09:10:00',5.58),('7643','2014-05-02','09:15:00',6.63),('7643','2014-05-02','09:20:00',9.23),('7643','2014-05-02','09:25:00',12.01),('7643','2014-05-02','09:30:00',13.9),('7643','2014-05-02','09:35:00',8.56),('7643','2014-05-02','09:40:00',4.88),('7643','2014-05-02','09:45:00',10.95),('7643','2014-05-02','09:50:00',6.44),('7643','2014-05-02','09:55:00',14.77),('7643','2014-05-02','10:00:00',14.32),('7643','2014-05-02','10:05:00',14.31),('7643','2014-05-02','10:10:00',14.85),('7643','2014-05-02','10:15:00',12.11),('7643','2014-05-02','10:20:00',11.88),('7643','2014-05-02','10:25:00',17.83),('7643','2014-05-02','10:30:00',6.33),('7643','2014-05-02','10:35:00',3.57),('7643','2014-05-02','10:40:00',4.09),('7643','2014-05-02','10:45:00',6.85),('7643','2014-05-02','10:50:00',4.64),('7643','2014-05-02','10:55:00',9.08),('7643','2014-05-02','11:00:00',5.32),('7643','2014-05-02','11:05:00',15.34),('7643','2014-05-02','11:10:00',19.71),('7643','2014-05-02','11:15:00',10.96),('7643','2014-05-02','11:20:00',13.96),('7643','2014-05-02','11:25:00',15.74),('7643','2014-05-02','11:30:00',15.93),('7643','2014-05-02','11:35:00',10.25),('7643','2014-05-02','11:40:00',11.79),('7643','2014-05-02','11:45:00',8.76),('7643','2014-05-02','11:50:00',8.78),('7643','2014-05-02','11:55:00',8.59),('7643','2014-05-02','12:00:00',7.19),('7643','2014-05-02','12:05:00',6.17),('7643','2014-05-02','12:10:00',5.62),('7643','2014-05-02','12:15:00',5.04),('7643','2014-05-02','12:20:00',4.64),('7643','2014-05-02','12:25:00',5.1),('7643','2014-05-02','12:30:00',7.07),('7643','2014-05-02','12:35:00',8.4),('7643','2014-05-02','12:40:00',7.55),('7643','2014-05-02','12:45:00',7.66),('7643','2014-05-02','12:50:00',7.45),('7643','2014-05-02','12:55:00',7.51),('7643','2014-05-02','13:00:00',7.58),('7643','2014-05-02','13:05:00',8.1),('7643','2014-05-02','13:10:00',12.57),('7643','2014-05-02','13:15:00',9.59),('7643','2014-05-02','13:20:00',10.58),('7643','2014-05-02','13:25:00',11.73),('7643','2014-05-02','13:30:00',11.23),('7643','2014-05-02','13:35:00',7.67),('7643','2014-05-02','13:40:00',6.65),('7643','2014-05-02','13:45:00',6.57),('7643','2014-05-02','13:50:00',6.67),('7643','2014-05-02','13:55:00',6.8),('7643','2014-05-02','14:00:00',6.79),('7643','2014-05-02','14:05:00',6.99),('7643','2014-05-02','14:10:00',7.77),('7643','2014-05-02','14:15:00',9.41),('7643','2014-05-02','14:20:00',12.09),('7643','2014-05-02','14:25:00',15.49),('7643','2014-05-02','14:30:00',7.18),('7643','2014-05-02','14:35:00',6.26),('7643','2014-05-02','14:40:00',5.01),('7643','2014-05-02','14:45:00',2.78),('7643','2014-05-02','14:50:00',3.09),('7643','2014-05-02','14:55:00',12.87),('7643','2014-05-02','15:00:00',7.43),('7643','2014-05-02','15:05:00',5.02),('7643','2014-05-02','15:10:00',3.8),('7643','2014-05-02','15:15:00',2.62),('7643','2014-05-02','15:20:00',2.19),('7643','2014-05-02','15:25:00',2.1),('7643','2014-05-02','15:30:00',2.12),('7643','2014-05-02','15:35:00',2.13),('7643','2014-05-02','15:40:00',2.09),('7643','2014-05-02','15:45:00',1.82),('7643','2014-05-02','15:50:00',1.46),('7643','2014-05-02','15:55:00',1.26),('7643','2014-05-02','16:00:00',1.13),('7643','2014-05-02','16:05:00',1.12),('7643','2014-05-02','16:10:00',1.26),('7643','2014-05-02','16:15:00',1.54),('7643','2014-05-02','16:20:00',1.87),('7643','2014-05-02','16:25:00',2.24),('7643','2014-05-02','16:30:00',2.58),('7643','2014-05-02','16:35:00',2.9),('7643','2014-05-02','16:40:00',3.23),('7643','2014-05-02','16:45:00',3.49),('7643','2014-05-02','16:50:00',3.6),('7643','2014-05-02','16:55:00',3.62),('7643','2014-05-02','17:00:00',3.66),('7643','2014-05-02','17:05:00',3.65),('7643','2014-05-02','17:10:00',3.67),('7643','2014-05-02','17:15:00',3.64),('7643','2014-05-02','17:20:00',3.58),('7643','2014-05-02','17:25:00',3.59),('7643','2014-05-02','17:30:00',3.5),('7643','2014-05-02','17:35:00',3.3),('7643','2014-05-02','17:40:00',3.31),('7643','2014-05-02','17:45:00',3.47),('7643','2014-05-02','17:50:00',4),('7643','2014-05-02','17:55:00',4.19),('7643','2014-05-02','18:00:00',3.47),('7643','2014-05-02','18:05:00',2.93),('7643','2014-05-02','18:10:00',3.39),('7643','2014-05-02','18:15:00',2.35),('7643','2014-05-02','18:20:00',1.95),('7643','2014-05-02','18:25:00',1.95),('7643','2014-05-02','18:30:00',1.78),('7643','2014-05-02','18:35:00',1.51),('7643','2014-05-02','18:40:00',1.79),('7643','2014-05-02','18:45:00',2.19),('7643','2014-05-02','18:50:00',1.89),('7643','2014-05-02','18:55:00',1.75),('7643','2014-05-02','19:00:00',1.35),('7643','2014-05-02','19:05:00',1.02),('7643','2014-04-05','07:30:00',1),('7643','2014-04-05','07:45:00',1.1),('7643','2014-04-05','07:50:00',2.17),('7643','2014-04-05','07:55:00',1.92),('7643','2014-04-05','08:00:00',1.45),('7643','2014-04-05','08:10:00',1.75),('7643','2014-04-05','08:15:00',4.74),('7643','2014-04-05','08:20:00',5.05),('7643','2014-04-05','08:25:00',5.54),('7643','2014-04-05','08:30:00',5.86),('7643','2014-04-05','08:35:00',6.32),('7643','2014-04-05','08:40:00',6.78),('7643','2014-04-05','08:45:00',6.98),('7643','2014-04-05','08:50:00',6.82),('7643','2014-04-05','08:55:00',4.25),('7643','2014-04-05','09:00:00',6.43),('7643','2014-04-05','09:05:00',8),('7643','2014-04-05','09:10:00',8),('7643','2014-04-05','09:15:00',9.74),('7643','2014-04-05','09:20:00',7.1),('7643','2014-04-05','09:25:00',7.51),('7643','2014-04-05','09:30:00',7.31),('7643','2014-04-05','09:35:00',9.74),('7643','2014-04-05','09:40:00',10.25),('7643','2014-04-05','09:45:00',13.9),('7643','2014-04-05','09:50:00',14.43),('7643','2014-04-05','09:55:00',14.2),('7643','2014-04-05','10:00:00',13.23),('7643','2014-04-05','10:05:00',9.19),('7643','2014-04-05','10:10:00',9.81),('7643','2014-04-05','10:15:00',7.06),('7643','2014-04-05','10:20:00',5.56),('7643','2014-04-05','10:25:00',4.78),('7643','2014-04-05','10:30:00',5.29),('7643','2014-04-05','10:35:00',5.92),('7643','2014-04-05','10:40:00',6.31),('7643','2014-04-05','10:45:00',13.96),('7643','2014-04-05','10:50:00',12.11),('7643','2014-04-05','10:55:00',6.18),('7643','2014-04-05','11:00:00',9.32),('7643','2014-04-05','11:05:00',8.54),('7643','2014-04-05','11:10:00',12.71),('7643','2014-04-05','11:15:00',12.09),('7643','2014-04-05','11:20:00',16.39),('7643','2014-04-05','11:25:00',16.13),('7643','2014-04-05','11:30:00',16.68),('7643','2014-04-05','11:35:00',17.55),('7643','2014-04-05','11:40:00',17.32),('7643','2014-04-05','11:45:00',16.97),('7643','2014-04-05','11:50:00',17.23),('7643','2014-04-05','11:55:00',17.33),('7643','2014-04-05','12:00:00',16.82),('7643','2014-04-05','12:05:00',16.64),('7643','2014-04-05','12:10:00',16.57),('7643','2014-04-05','12:15:00',17.17),('7643','2014-04-05','12:20:00',12.24),('7643','2014-04-05','12:25:00',14.85),('7643','2014-04-05','12:30:00',13.55),('7643','2014-04-05','12:35:00',13.93),('7643','2014-04-05','12:40:00',13.42),('7643','2014-04-05','12:45:00',9.6),('7643','2014-04-05','12:50:00',6.37),('7643','2014-04-05','12:55:00',11.34),('7643','2014-04-05','13:00:00',17.8),('7643','2014-04-05','13:05:00',15.78),('7643','2014-04-05','13:10:00',18.56),('7643','2014-04-05','13:15:00',17.32),('7643','2014-04-05','13:20:00',8.2),('7643','2014-04-05','13:25:00',5.19),('7643','2014-04-05','13:30:00',16.25),('7643','2014-04-05','13:35:00',6.85),('7643','2014-04-05','13:40:00',13.89),('7643','2014-04-05','13:45:00',18.13),('7643','2014-04-05','13:50:00',17.19),('7643','2014-04-05','13:55:00',17.17),('7643','2014-04-05','14:00:00',16.8),('7643','2014-04-05','14:05:00',16.7),('7643','2014-04-05','14:10:00',16.81),('7643','2014-04-05','14:15:00',17.17),('7643','2014-04-05','14:20:00',15.84),('7643','2014-04-05','14:25:00',10.68),('7643','2014-04-05','14:30:00',4.17),('7643','2014-04-05','14:35:00',11.81),('7643','2014-04-05','14:40:00',11.22),('7643','2014-04-05','14:45:00',18.29),('7643','2014-04-05','14:50:00',10.29),('7643','2014-04-05','14:55:00',10.31),('7643','2014-04-05','15:00:00',10.54),('7643','2014-04-05','15:05:00',5.6),('7643','2014-04-05','15:10:00',11.41),('7643','2014-04-05','15:15:00',11.8),('7643','2014-04-05','15:20:00',6.82),('7643','2014-04-05','15:25:00',4.07),('7643','2014-04-05','15:30:00',3.2),('7643','2014-04-05','15:35:00',2.6),('7643','2014-04-05','15:40:00',2.72),('7643','2014-04-05','15:45:00',3.57),('7643','2014-04-05','15:50:00',5.16),('7643','2014-04-05','15:55:00',16.19),('7643','2014-04-05','16:00:00',12.53),('7643','2014-04-05','16:05:00',3.97),('7643','2014-04-05','16:10:00',5.86),('7643','2014-04-05','16:15:00',2.44),('7643','2014-04-05','16:20:00',2.05),('7643','2014-04-05','16:25:00',3.09),('7643','2014-04-05','16:30:00',3.38),('7643','2014-04-05','16:35:00',8.45),('7643','2014-04-05','16:40:00',8.17),('7643','2014-04-05','16:45:00',12.12),('7643','2014-04-05','16:50:00',11.69),('7643','2014-04-05','16:55:00',6.3),('7643','2014-04-05','17:00:00',2.98),('7643','2014-04-05','17:05:00',2.95),('7643','2014-04-05','17:10:00',2.47),('7643','2014-04-05','17:15:00',2.09),('7643','2014-04-05','17:20:00',3.24),('7643','2014-04-05','17:25:00',7.34),('7643','2014-04-05','17:30:00',7.12),('7643','2014-04-05','17:35:00',6.27),('7643','2014-04-05','17:40:00',4.3),('7643','2014-04-05','17:45:00',5.53),('7643','2014-04-05','17:50:00',5.61),('7643','2014-04-05','17:55:00',5.08),('7643','2014-04-05','18:00:00',4.64),('7643','2014-04-05','18:05:00',4.25),('7643','2014-04-05','18:10:00',3.9),('7643','2014-04-05','18:15:00',3.72),('7643','2014-04-05','18:20:00',3.69),('7643','2014-04-05','18:25:00',3.09),('7643','2014-04-05','18:30:00',1.62),('7643','2014-04-05','18:35:00',1.53),('7643','2014-04-05','18:40:00',1.38),('7643','2014-04-05','18:45:00',1.1),('7643','2013-07-09','06:50:00',1.1),('7643','2013-07-09','06:55:00',1.31),('7643','2013-07-09','07:00:00',1.51),('7643','2013-07-09','07:05:00',1.8),('7643','2013-07-09','07:10:00',2.15),('7643','2013-07-09','07:15:00',2.55),('7643','2013-07-09','07:20:00',3.18),('7643','2013-07-09','07:25:00',3.91),('7643','2013-07-09','07:30:00',4.43),('7643','2013-07-09','07:35:00',5.01),('7643','2013-07-09','07:40:00',5.6),('7643','2013-07-09','07:45:00',5.91),('7643','2013-07-09','07:50:00',6.4),('7643','2013-07-09','07:55:00',6.99),('7643','2013-07-09','08:00:00',7.3),('7643','2013-07-09','08:05:00',5.07),('7643','2013-07-09','08:10:00',6.63),('7643','2013-07-09','08:15:00',6.73),('7643','2013-07-09','08:20:00',7.19),('7643','2013-07-09','08:25:00',8.9),('7643','2013-07-09','08:30:00',8.43),('7643','2013-07-09','08:35:00',6.52),('7643','2013-07-09','08:40:00',8.58),('7643','2013-07-09','08:45:00',8.59),('7643','2013-07-09','08:50:00',8.45),('7643','2013-07-09','08:55:00',8.7),('7643','2013-07-09','09:00:00',8.92),('7643','2013-07-09','09:05:00',9.37),('7643','2013-07-09','09:10:00',9.75),('7643','2013-07-09','09:15:00',10.16),('7643','2013-07-09','09:20:00',10.36),('7643','2013-07-09','09:25:00',10.61),('7643','2013-07-09','09:30:00',10.54),('7643','2013-07-09','09:35:00',10.4),('7643','2013-07-09','09:40:00',10.81),('7643','2013-07-09','09:45:00',11.03),('7643','2013-07-09','09:50:00',11.19),('7643','2013-07-09','09:55:00',10.98),('7643','2013-07-09','10:00:00',11.19),('7643','2013-07-09','10:05:00',11.79),('7643','2013-07-09','10:10:00',11.93),('7643','2013-07-09','10:15:00',12.18),('7643','2013-07-09','10:20:00',12.5),('7643','2013-07-09','10:25:00',12.69),('7643','2013-07-09','10:30:00',12.77),('7643','2013-07-09','10:35:00',13.03),('7643','2013-07-09','10:40:00',13.09),('7643','2013-07-09','10:45:00',13.32),('7643','2013-07-09','10:50:00',13.45),('7643','2013-07-09','10:55:00',13.48),('7643','2013-07-09','11:00:00',13.65),('7643','2013-07-09','11:05:00',13.75),('7643','2013-07-09','11:10:00',13.79),('7643','2013-07-09','11:15:00',13.95),('7643','2013-07-09','11:20:00',14),('7643','2013-07-09','11:25:00',14.13),('7643','2013-07-09','11:30:00',14.14),('7643','2013-07-09','11:35:00',14.32),('7643','2013-07-09','11:40:00',14.43),('7643','2013-07-09','11:45:00',14.55),('7643','2013-07-09','11:50:00',14.72),('7643','2013-07-09','11:55:00',14.92),('7643','2013-07-09','12:00:00',14.98),('7643','2013-07-09','12:05:00',15.16),('7643','2013-07-09','12:10:00',15.2),('7643','2013-07-09','12:15:00',15.28),('7643','2013-07-09','12:20:00',15.37),('7643','2013-07-09','12:25:00',15.42),('7643','2013-07-09','12:30:00',15.58),('7643','2013-07-09','12:35:00',15.71),('7643','2013-07-09','12:40:00',15.8),('7643','2013-07-09','12:45:00',15.94),('7643','2013-07-09','12:50:00',15.76),('7643','2013-07-09','12:55:00',15.69),('7643','2013-07-09','13:00:00',15.81),('7643','2013-07-09','13:05:00',15.88),('7643','2013-07-09','13:10:00',15.98),('7643','2013-07-09','13:15:00',15.95),('7643','2013-07-09','13:20:00',15.81),('7643','2013-07-09','13:25:00',15.89),('7643','2013-07-09','13:30:00',15.9),('7643','2013-07-09','13:35:00',15.9),('7643','2013-07-09','13:40:00',15.95),('7643','2013-07-09','13:45:00',16.09),('7643','2013-07-09','13:50:00',16.09),('7643','2013-07-09','13:55:00',16.04),('7643','2013-07-09','14:00:00',16.04),('7643','2013-07-09','14:05:00',15.94),('7643','2013-07-09','14:10:00',15.87),('7643','2013-07-09','14:15:00',15.77),('7643','2013-07-09','14:20:00',15.7),('7643','2013-07-09','14:25:00',15.64),('7643','2013-07-09','14:30:00',15.65),('7643','2013-07-09','14:35:00',15.55),('7643','2013-07-09','14:40:00',15.41),('7643','2013-07-09','14:45:00',15.35),('7643','2013-07-09','14:50:00',15.26),('7643','2013-07-09','14:55:00',15.18),('7643','2013-07-09','15:00:00',15.05),('7643','2013-07-09','15:05:00',14.99),('7643','2013-07-09','15:10:00',14.88),('7643','2013-07-09','15:15:00',14.67),('7643','2013-07-09','15:20:00',14.43),('7643','2013-07-09','15:25:00',14.24),('7643','2013-07-09','15:30:00',14.11),('7643','2013-07-09','15:35:00',14.05),('7643','2013-07-09','15:40:00',13.85),('7643','2013-07-09','15:45:00',13.63),('7643','2013-07-09','15:50:00',13.47),('7643','2013-07-09','15:55:00',13.25),('7643','2013-07-09','16:00:00',13.04),('7643','2013-07-09','16:05:00',12.74),('7643','2013-07-09','16:10:00',12.59),('7643','2013-07-09','16:15:00',12.41),('7643','2013-07-09','16:20:00',12.13),('7643','2013-07-09','16:25:00',11.85),('7643','2013-07-09','16:30:00',11.55),('7643','2013-07-09','16:35:00',11.26),('7643','2013-07-09','16:40:00',10.91),('7643','2013-07-09','16:45:00',10.69),('7643','2013-07-09','16:50:00',10.52),('7643','2013-07-09','16:55:00',10.33),('7643','2013-07-09','17:00:00',10.26),('7643','2013-07-09','17:05:00',10.52),('7643','2013-07-09','17:10:00',8.78),('7643','2013-07-09','17:15:00',5.46),('7643','2013-07-09','17:20:00',6.46),('7643','2013-07-09','17:25:00',4),('7643','2013-07-09','17:30:00',2.44),('7643','2013-07-09','17:35:00',7.99),('7643','2013-07-09','17:40:00',7.26),('7643','2013-07-09','17:45:00',6.83),('7643','2013-07-09','17:50:00',6.83),('7643','2013-07-09','17:55:00',6.52),('7643','2013-07-09','18:00:00',5.2),('7643','2013-07-09','18:05:00',3.78),('7643','2013-07-09','18:10:00',4.63),('7643','2013-07-09','18:15:00',2.29),('7643','2013-07-09','18:20:00',2.55),('7643','2013-07-09','18:25:00',3.82),('7643','2013-07-09','18:30:00',2.03),('7643','2013-07-09','18:35:00',1.72),('7643','2013-07-09','18:40:00',1.7),('7643','2013-07-09','18:45:00',1.48),('7643','2013-07-09','18:50:00',1.25),('7643','2013-07-09','18:55:00',1.09),('7643','2013-07-09','19:00:00',1.45),('7643','2013-07-09','19:05:00',2.11),('7643','2013-07-09','19:10:00',2.09),('7643','2013-07-09','19:15:00',1.92),('7643','2013-07-09','19:20:00',1.55),('7643','2013-07-09','19:25:00',1.2),('7643','2013-07-09','19:30:00',1.01),('7643','2013-07-08','06:55:00',1.24),('7643','2013-07-08','07:00:00',1.49),('7643','2013-07-08','07:05:00',1.81),('7643','2013-07-08','07:10:00',2.15),('7643','2013-07-08','07:15:00',2.37),('7643','2013-07-08','07:20:00',2.61),('7643','2013-07-08','07:25:00',2.3),('7643','2013-07-08','07:30:00',1.81),('7643','2013-07-08','07:35:00',3.46),('7643','2013-07-08','07:40:00',3.8),('7643','2013-07-08','07:45:00',3.98),('7643','2013-07-08','07:50:00',4.32),('7643','2013-07-08','07:55:00',4.63),('7643','2013-07-08','08:00:00',4.9),('7643','2013-07-08','08:05:00',5.23),('7643','2013-07-08','08:10:00',5.51),('7643','2013-07-08','08:15:00',5.81),('7643','2013-07-08','08:20:00',6.07),('7643','2013-07-08','08:25:00',6.38),('7643','2013-07-08','08:30:00',6.69),('7643','2013-07-08','08:35:00',7.05),('7643','2013-07-08','08:40:00',7.37),('7643','2013-07-08','08:45:00',7.65),('7643','2013-07-08','08:50:00',7.97),('7643','2013-07-08','08:55:00',8.27),('7643','2013-07-08','09:00:00',8.56),('7643','2013-07-08','09:05:00',8.87),('7643','2013-07-08','09:10:00',9.16),('7643','2013-07-08','09:15:00',9.43),('7643','2013-07-08','09:20:00',9.7),('7643','2013-07-08','09:25:00',9.92),('7643','2013-07-08','09:30:00',10.27),('7643','2013-07-08','09:35:00',10.55),('7643','2013-07-08','09:40:00',10.75),('7643','2013-07-08','09:45:00',10.97),('7643','2013-07-08','09:50:00',11.21),('7643','2013-07-08','09:55:00',11.46),('7643','2013-07-08','10:00:00',11.57),('7643','2013-07-08','10:05:00',11.73),('7643','2013-07-08','10:10:00',11.97),('7643','2013-07-08','10:15:00',12.1),('7643','2013-07-08','10:20:00',12.27),('7643','2013-07-08','10:25:00',12.42),('7643','2013-07-08','10:30:00',12.62),('7643','2013-07-08','10:35:00',12.89),('7643','2013-07-08','10:40:00',13.01),('7643','2013-07-08','10:45:00',13.17),('7643','2013-07-08','10:50:00',13.45),('7643','2013-07-08','10:55:00',13.64),('7643','2013-07-08','11:00:00',13.88),('7643','2013-07-08','11:05:00',13.81),('7643','2013-07-08','11:10:00',13.54),('7643','2013-07-08','11:15:00',12.01),('7643','2013-07-08','11:20:00',13.22),('7643','2013-07-08','11:25:00',12.55),('7643','2013-07-08','11:30:00',6.91),('7643','2013-07-08','11:35:00',10.23),('7643','2013-07-08','11:40:00',12.03),('7643','2013-07-08','11:45:00',15.87),('7643','2013-07-08','11:50:00',16.4),('7643','2013-07-08','11:55:00',16.58),('7643','2013-07-08','12:00:00',16.57),('7643','2013-07-08','12:05:00',16.53),('7643','2013-07-08','12:10:00',15.78),('7643','2013-07-08','12:15:00',14.7),('7643','2013-07-08','12:20:00',15.21),('7643','2013-07-08','12:25:00',15.12),('7643','2013-07-08','12:30:00',15.18),('7643','2013-07-08','12:35:00',15.11),('7643','2013-07-08','12:40:00',15.14),('7643','2013-07-08','12:45:00',15.47),('7643','2013-07-08','12:50:00',15.68),('7643','2013-07-08','12:55:00',15.73),('7643','2013-07-08','13:00:00',15.83),('7643','2013-07-08','13:05:00',15.99),('7643','2013-07-08','13:10:00',16.3),('7643','2013-07-08','13:15:00',16.07),('7643','2013-07-08','13:20:00',16.04),('7643','2013-07-08','13:25:00',16.2),('7643','2013-07-08','13:30:00',16.58),('7643','2013-07-08','13:35:00',15.3),('7643','2013-07-08','13:40:00',14.81),('7643','2013-07-08','13:45:00',13.09),('7643','2013-07-08','13:50:00',11.75),('7643','2013-07-08','13:55:00',11.29),('7643','2013-07-08','14:00:00',12),('7643','2013-07-08','14:05:00',11.35),('7643','2013-07-08','14:10:00',12.87),('7643','2013-07-08','14:15:00',13.64),('7643','2013-07-08','14:20:00',12.47),('7643','2013-07-08','14:25:00',9.07),('7643','2013-07-08','14:30:00',5.46),('7643','2013-07-08','14:35:00',3.97),('7643','2013-07-08','14:40:00',3.64),('7643','2013-07-08','14:45:00',2.96),('7643','2013-07-08','14:50:00',1.18),('7643','2013-07-08','15:15:00',1.12),('7643','2013-07-08','15:20:00',1.12),('7643','2013-07-08','15:25:00',1.2),('7643','2013-07-08','15:30:00',1.07),('7643','2013-07-08','16:15:00',1.09),('7643','2013-07-08','16:20:00',1.25),('7643','2013-07-08','16:25:00',1.38),('7643','2013-07-08','16:30:00',1.48),('7643','2013-07-08','16:35:00',1.56),('7643','2013-07-08','16:40:00',1.63),('7643','2013-07-08','16:45:00',1.65),('7643','2013-07-08','16:50:00',1.64),('7643','2013-07-08','16:55:00',1.62),('7643','2013-07-08','17:00:00',1.63),('7643','2013-07-08','17:05:00',1.64),('7643','2013-07-08','17:10:00',1.64),('7643','2013-07-08','17:15:00',1.67),('7643','2013-07-08','17:20:00',1.78),('7643','2013-07-08','17:25:00',1.98),('7643','2013-07-08','17:30:00',2.14),('7643','2013-07-08','17:35:00',2.21),('7643','2013-07-08','17:40:00',2.12),('7643','2013-07-08','17:45:00',1.85),('7643','2013-07-08','17:50:00',1.54),('7643','2013-07-08','17:55:00',1.37),('7643','2013-07-08','18:00:00',1.3),('7643','2013-07-08','18:05:00',1.23),('7643','2013-07-08','18:10:00',1.13),('7643','2013-07-08','18:15:00',1.1),('7643','2013-07-08','18:20:00',1.07),('7643','2013-07-08','18:25:00',1.02),('7643','2013-07-07','07:05:00',1.17),('7643','2013-07-07','07:10:00',1.23),('7643','2013-07-07','07:20:00',1.11),('7643','2013-07-07','07:25:00',1.33),('7643','2013-07-07','07:30:00',1.57),('7643','2013-07-07','07:35:00',2.7),('7643','2013-07-07','07:40:00',4.9),('7643','2013-07-07','07:45:00',4.52),('7643','2013-07-07','07:50:00',3.65),('7643','2013-07-07','07:55:00',3.96),('7643','2013-07-07','08:00:00',4.05),('7643','2013-07-07','08:05:00',4.5),('7643','2013-07-07','08:10:00',5.07),('7643','2013-07-07','08:15:00',5.76),('7643','2013-07-07','08:20:00',6.15),('7643','2013-07-07','08:25:00',6.45),('7643','2013-07-07','08:30:00',6.78),('7643','2013-07-07','08:35:00',7.12),('7643','2013-07-07','08:40:00',7.46),('7643','2013-07-07','08:45:00',7.72),('7643','2013-07-07','08:50:00',8.02),('7643','2013-07-07','08:55:00',8.23),('7643','2013-07-07','09:00:00',8.53),('7643','2013-07-07','09:05:00',8.8),('7643','2013-07-07','09:10:00',9.01),('7643','2013-07-07','09:15:00',9.17),('7643','2013-07-07','09:20:00',9.42),('7643','2013-07-07','09:25:00',9.42),('7643','2013-07-07','09:30:00',9.99),('7643','2013-07-07','09:35:00',10.65),('7643','2013-07-07','09:40:00',10.93),('7643','2013-07-07','09:45:00',11.11),('7643','2013-07-07','09:50:00',11.18),('7643','2013-07-07','09:55:00',11.53),('7643','2013-07-07','10:00:00',11.78),('7643','2013-07-07','10:05:00',12.01),('7643','2013-07-07','10:10:00',12.04),('7643','2013-07-07','10:15:00',12.36),('7643','2013-07-07','10:20:00',12.46),('7643','2013-07-07','10:25:00',12.75),('7643','2013-07-07','10:30:00',12.94),('7643','2013-07-07','10:35:00',12.96),('7643','2013-07-07','10:40:00',13.16),('7643','2013-07-07','10:45:00',13.32),('7643','2013-07-07','10:50:00',13.38),('7643','2013-07-07','10:55:00',13.5),('7643','2013-07-07','11:00:00',13.63),('7643','2013-07-07','11:05:00',13.84),('7643','2013-07-07','11:10:00',14.06),('7643','2013-07-07','11:15:00',14.25),('7643','2013-07-07','11:20:00',14.53),('7643','2013-07-07','11:25:00',14.63),('7643','2013-07-07','11:30:00',14.81),('7643','2013-07-07','11:35:00',15.03),('7643','2013-07-07','11:40:00',14.22),('7643','2013-07-07','11:45:00',14.96),('7643','2013-07-07','11:50:00',15.19),('7643','2013-07-07','11:55:00',14.94),('7643','2013-07-07','12:00:00',15.28),('7643','2013-07-07','12:05:00',15.75),('7643','2013-07-07','12:10:00',15.96),('7643','2013-07-07','12:15:00',16.16),('7643','2013-07-07','12:20:00',16.63),('7643','2013-07-07','12:25:00',16.25),('7643','2013-07-07','12:30:00',15.03),('7643','2013-07-07','12:35:00',16.22),('7643','2013-07-07','12:40:00',15.97),('7643','2013-07-07','12:45:00',15.92),('7643','2013-07-07','12:50:00',16.03),('7643','2013-07-07','12:55:00',16.29),('7643','2013-07-07','13:00:00',16.72),('7643','2013-07-07','13:05:00',16.22),('7643','2013-07-07','13:10:00',17.23),('7643','2013-07-07','13:15:00',17.26),('7643','2013-07-07','13:20:00',13.04),('7643','2013-07-07','13:25:00',4.57),('7643','2013-07-07','13:30:00',2.69),('7643','2013-07-07','13:35:00',1.55),('7643','2013-07-07','13:40:00',1.27),('7643','2013-07-07','13:45:00',1.31),('7643','2013-07-07','13:50:00',1.45),('7643','2013-07-07','13:55:00',1.7),('7643','2013-07-07','14:00:00',2.19),('7643','2013-07-07','14:05:00',2.71),('7643','2013-07-07','14:10:00',2.89),('7643','2013-07-07','14:15:00',2.94),('7643','2013-07-07','14:20:00',2.97),('7643','2013-07-07','14:25:00',3.15),('7643','2013-07-07','14:30:00',3.51),('7643','2013-07-07','14:35:00',4),('7643','2013-07-07','14:40:00',4.1),('7643','2013-07-07','14:45:00',3.87),('7643','2013-07-07','14:50:00',3.75),('7643','2013-07-07','14:55:00',3.68),('7643','2013-07-07','15:00:00',3.41),('7643','2013-07-07','15:05:00',3.08),('7643','2013-07-07','15:10:00',2.81),('7643','2013-07-07','15:15:00',2.51),('7643','2013-07-07','15:20:00',1.93),('7643','2013-07-07','15:25:00',1.6),('7643','2013-07-07','15:30:00',1.27),('7643','2013-07-07','16:05:00',1.03),('7643','2013-07-07','16:10:00',1.2),('7643','2013-07-07','16:15:00',1.03),('7643','2013-07-07','17:10:00',1.16),('7643','2013-07-07','17:15:00',1.77),('7643','2013-07-07','17:20:00',2.38),('7643','2013-07-07','17:25:00',2.94),('7643','2013-07-07','17:30:00',3.42),('7643','2013-07-07','17:35:00',3.73),('7643','2013-07-07','17:40:00',3.84),('7643','2013-07-07','17:45:00',3.84),('7643','2013-07-07','17:50:00',3.84),('7643','2013-07-07','17:55:00',3.68),('7643','2013-07-07','18:00:00',3.44),('7643','2013-07-07','18:05:00',3.07),('7643','2013-07-07','18:10:00',2.89),('7643','2013-07-07','18:15:00',3.04),('7643','2013-07-07','18:20:00',3.21),('7643','2013-07-07','18:25:00',2.94),('7643','2013-07-07','18:30:00',2.92),('7643','2013-07-07','18:35:00',3.2),('7643','2013-07-07','18:40:00',4.59),('7643','2013-07-07','18:45:00',4.34),('7643','2013-07-07','18:50:00',3.69),('7643','2013-07-07','18:55:00',3.15),('7643','2013-07-07','19:00:00',2.74),('7643','2013-07-07','19:05:00',2.11),('7643','2013-07-07','19:10:00',1.71),('7643','2013-07-07','19:15:00',1.35),('7643','2013-07-07','19:20:00',1.25),('7643','2013-07-06','06:50:00',1.13),('7643','2013-07-06','06:55:00',1.31),('7643','2013-07-06','07:00:00',1.58),('7643','2013-07-06','07:05:00',1.82),('7643','2013-07-06','07:10:00',2.13),('7643','2013-07-06','07:15:00',2.39),('7643','2013-07-06','07:20:00',2.69),('7643','2013-07-06','07:25:00',3.01),('7643','2013-07-06','07:30:00',3.3),('7643','2013-07-06','07:35:00',3.63),('7643','2013-07-06','07:40:00',3.96),('7643','2013-07-06','07:45:00',4.32),('7643','2013-07-06','07:50:00',4.64),('7643','2013-07-06','07:55:00',4.95),('7643','2013-07-06','08:00:00',5.3),('7643','2013-07-06','08:05:00',5.6),('7643','2013-07-06','08:10:00',5.9),('7643','2013-07-06','08:15:00',5.48),('7643','2013-07-06','08:20:00',4.67),('7643','2013-07-06','08:25:00',5.25),('7643','2013-07-06','08:30:00',6.56),('7643','2013-07-06','08:35:00',7.85),('7643','2013-07-06','08:40:00',5.72),('7643','2013-07-06','08:45:00',3),('7643','2013-07-06','08:50:00',7.58),('7643','2013-07-06','08:55:00',8.77),('7643','2013-07-06','09:00:00',9.24),('7643','2013-07-06','09:05:00',8.52),('7643','2013-07-06','09:10:00',8.94),('7643','2013-07-06','09:15:00',9.03),('7643','2013-07-06','09:20:00',5.37),('7643','2013-07-06','09:25:00',8.47),('7643','2013-07-06','09:30:00',10.68),('7643','2013-07-06','09:35:00',10.92),('7643','2013-07-06','09:40:00',10.23),('7643','2013-07-06','09:45:00',12.07),('7643','2013-07-06','09:50:00',11.94),('7643','2013-07-06','09:55:00',12.27),('7643','2013-07-06','10:00:00',12.28),('7643','2013-07-06','10:05:00',11.68),('7643','2013-07-06','10:10:00',12.33),('7643','2013-07-06','10:15:00',12.2),('7643','2013-07-06','10:20:00',11.78),('7643','2013-07-06','10:25:00',11.26),('7643','2013-07-06','10:30:00',11.95),('7643','2013-07-06','10:35:00',13.93),('7643','2013-07-06','10:40:00',12.5),('7643','2013-07-06','10:45:00',13.44),('7643','2013-07-06','10:50:00',13.88),('7643','2013-07-06','10:55:00',13.98),('7643','2013-07-06','11:00:00',14.2),('7643','2013-07-06','11:05:00',14.43),('7643','2013-07-06','11:10:00',14.62),('7643','2013-07-06','11:15:00',14.57),('7643','2013-07-06','11:20:00',13.71),('7643','2013-07-06','11:25:00',12.48),('7643','2013-07-06','11:30:00',13.16),('7643','2013-07-06','11:35:00',12.71),('7643','2013-07-06','11:40:00',13.26),('7643','2013-07-06','11:45:00',10.49),('7643','2013-07-06','11:50:00',10.49),('7643','2013-07-06','11:55:00',7.55),('7643','2013-07-06','12:00:00',9.91),('7643','2013-07-06','12:05:00',14.95),('7643','2013-07-06','12:10:00',15.34),('7643','2013-07-06','12:15:00',16.25),('7643','2013-07-06','12:20:00',15.95),('7643','2013-07-06','12:25:00',14.83),('7643','2013-07-06','12:30:00',15.3),('7643','2013-07-06','12:35:00',15.91),('7643','2013-07-06','12:40:00',16.34),('7643','2013-07-06','12:45:00',16.34),('7643','2013-07-06','12:50:00',15.87),('7643','2013-07-06','12:55:00',16.69),('7643','2013-07-06','13:00:00',15.95),('7643','2013-07-06','13:05:00',15.59),('7643','2013-07-06','13:10:00',16.3),('7643','2013-07-06','13:15:00',15.92),('7643','2013-07-06','13:20:00',16),('7643','2013-07-06','13:25:00',10.22),('7643','2013-07-06','13:30:00',15.76),('7643','2013-07-06','13:35:00',16.61),('7643','2013-07-06','13:40:00',16.73),('7643','2013-07-06','13:45:00',17.16),('7643','2013-07-06','13:50:00',17.55),('7643','2013-07-06','13:55:00',8.36),('7643','2013-07-06','14:00:00',10.37),('7643','2013-07-06','14:05:00',16.15),('7643','2013-07-06','14:10:00',7.91),('7643','2013-07-06','14:15:00',7.85),('7643','2013-07-06','14:20:00',4.12),('7643','2013-07-06','14:25:00',3.44),('7643','2013-07-06','14:30:00',3.18),('7643','2013-07-06','14:35:00',3.04),('7643','2013-07-06','14:40:00',2.85),('7643','2013-07-06','14:45:00',2.66),('7643','2013-07-06','14:50:00',2.61),('7643','2013-07-06','14:55:00',2.89),('7643','2013-07-06','15:00:00',3.47),('7643','2013-07-06','15:05:00',3.96),('7643','2013-07-06','15:10:00',3.39),('7643','2013-07-06','15:15:00',2.46),('7643','2013-07-06','15:20:00',2.59),('7643','2013-07-06','15:25:00',2.26),('7643','2013-07-06','15:30:00',1.55),('7643','2013-07-06','15:35:00',1.09),('7643','2013-07-06','16:30:00',1.21),('7643','2013-07-06','16:35:00',1.59),('7643','2013-07-06','16:40:00',1.87),('7643','2013-07-06','16:45:00',2.15),('7643','2013-07-06','16:50:00',2.59),('7643','2013-07-06','16:55:00',3.06),('7643','2013-07-06','17:00:00',3.38),('7643','2013-07-06','17:05:00',3.59),('7643','2013-07-06','17:10:00',3.71),('7643','2013-07-06','17:15:00',3.79),('7643','2013-07-06','17:20:00',3.8),('7643','2013-07-06','17:25:00',3.72),('7643','2013-07-06','17:30:00',3.59),('7643','2013-07-06','17:35:00',3.37),('7643','2013-07-06','17:40:00',3.22),('7643','2013-07-06','17:45:00',3.16),('7643','2013-07-06','17:50:00',3.1),('7643','2013-07-06','17:55:00',2.99),('7643','2013-07-06','18:00:00',2.92),('7643','2013-07-06','18:05:00',2.9),('7643','2013-07-06','18:10:00',2.83),('7643','2013-07-06','18:15:00',2.78),('7643','2013-07-06','18:20:00',2.8),('7643','2013-07-06','18:25:00',2.72),('7643','2013-07-06','18:30:00',2.58),('7643','2013-07-06','18:35:00',2.39),('7643','2013-07-06','18:40:00',2.21),('7643','2013-07-06','18:45:00',2.05),('7643','2013-07-06','18:50:00',2),('7643','2013-07-06','18:55:00',1.96),('7643','2013-07-06','19:00:00',1.82),('7643','2013-07-06','19:05:00',1.6),('7643','2013-07-06','19:10:00',1.38),('7643','2013-07-06','19:15:00',1.16),('7643','2013-07-05','06:45:00',1.02),('7643','2013-07-05','06:50:00',1.19),('7643','2013-07-05','06:55:00',1.36),('7643','2013-07-05','07:00:00',1.56),('7643','2013-07-05','07:05:00',1.82),('7643','2013-07-05','07:10:00',2.13),('7643','2013-07-05','07:15:00',2.39),('7643','2013-07-05','07:20:00',2.65),('7643','2013-07-05','07:25:00',2.91),('7643','2013-07-05','07:30:00',3.18),('7643','2013-07-05','07:35:00',3.46),('7643','2013-07-05','07:40:00',3.77),('7643','2013-07-05','07:45:00',4.12),('7643','2013-07-05','07:50:00',4.45),('7643','2013-07-05','07:55:00',4.74),('7643','2013-07-05','08:00:00',5.1),('7643','2013-07-05','08:05:00',5.38),('7643','2013-07-05','08:10:00',5.67),('7643','2013-07-05','08:15:00',5.98),('7643','2013-07-05','08:20:00',6.26),('7643','2013-07-05','08:25:00',6.54),('7643','2013-07-05','08:30:00',6.85),('7643','2013-07-05','08:35:00',7.23),('7643','2013-07-05','08:40:00',7.58),('7643','2013-07-05','08:45:00',7.82),('7643','2013-07-05','08:50:00',8.18),('7643','2013-07-05','08:55:00',8.49),('7643','2013-07-05','09:00:00',8.75),('7643','2013-07-05','09:05:00',9.1),('7643','2013-07-05','09:10:00',9.4),('7643','2013-07-05','09:15:00',9.69),('7643','2013-07-05','09:20:00',10.01),('7643','2013-07-05','09:25:00',10.32),('7643','2013-07-05','09:30:00',10.48),('7643','2013-07-05','09:35:00',10.67),('7643','2013-07-05','09:40:00',10.89),('7643','2013-07-05','09:45:00',11.15),('7643','2013-07-05','09:50:00',11.45),('7643','2013-07-05','09:55:00',11.63),('7643','2013-07-05','10:00:00',11.86),('7643','2013-07-05','10:05:00',12.1),('7643','2013-07-05','10:10:00',12.34),('7643','2013-07-05','10:15:00',12.61),('7643','2013-07-05','10:20:00',12.77),('7643','2013-07-05','10:25:00',12.89),('7643','2013-07-05','10:30:00',13.06),('7643','2013-07-05','10:35:00',13.25),('7643','2013-07-05','10:40:00',13.41),('7643','2013-07-05','10:45:00',13.62),('7643','2013-07-05','10:50:00',13.87),('7643','2013-07-05','10:55:00',14.08),('7643','2013-07-05','11:00:00',14.15),('7643','2013-07-05','11:05:00',14.29),('7643','2013-07-05','11:10:00',14.38),('7643','2013-07-05','11:15:00',14.43),('7643','2013-07-05','11:20:00',14.55),('7643','2013-07-05','11:25:00',14.76),('7643','2013-07-05','11:30:00',14.65),('7643','2013-07-05','11:35:00',14.8),('7643','2013-07-05','11:40:00',14.91),('7643','2013-07-05','11:45:00',15.08),('7643','2013-07-05','11:50:00',15.19),('7643','2013-07-05','11:55:00',15.25),('7643','2013-07-05','12:00:00',15.23),('7643','2013-07-05','12:05:00',15.59),('7643','2013-07-05','12:10:00',15.85),('7643','2013-07-05','12:15:00',15.78),('7643','2013-07-05','12:20:00',16.05),('7643','2013-07-05','12:25:00',16.17),('7643','2013-07-05','12:30:00',16.26),('7643','2013-07-05','12:35:00',16.09),('7643','2013-07-05','12:40:00',16.09),('7643','2013-07-05','12:45:00',16.22),('7643','2013-07-05','12:50:00',16.14),('7643','2013-07-05','12:55:00',16.21),('7643','2013-07-05','13:00:00',16.23),('7643','2013-07-05','13:05:00',16.4),('7643','2013-07-05','13:10:00',16.49),('7643','2013-07-05','13:15:00',16.5),('7643','2013-07-05','13:20:00',16.33),('7643','2013-07-05','13:25:00',16.14),('7643','2013-07-05','13:30:00',16.31),('7643','2013-07-05','13:35:00',16.27),('7643','2013-07-05','13:40:00',16.33),('7643','2013-07-05','13:45:00',16.28),('7643','2013-07-05','13:50:00',16.12),('7643','2013-07-05','13:55:00',16.15),('7643','2013-07-05','14:00:00',16.23),('7643','2013-07-05','14:05:00',16.16),('7643','2013-07-05','14:10:00',16.04),('7643','2013-07-05','14:15:00',9.78),('7643','2013-07-05','14:20:00',12.17),('7643','2013-07-05','14:25:00',16.24),('7643','2013-07-05','14:30:00',15.8),('7643','2013-07-05','14:35:00',15.73),('7643','2013-07-05','14:40:00',15.53),('7643','2013-07-05','14:45:00',15.49),('7643','2013-07-05','14:50:00',15.19),('7643','2013-07-05','14:55:00',14.82),('7643','2013-07-05','15:00:00',13.48),('7643','2013-07-05','15:05:00',12.84),('7643','2013-07-05','15:10:00',15.42),('7643','2013-07-05','15:15:00',14.96),('7643','2013-07-05','15:20:00',14.6),('7643','2013-07-05','15:25:00',14.7),('7643','2013-07-05','15:30:00',14.71),('7643','2013-07-05','15:35:00',9.48),('7643','2013-07-05','15:40:00',3.12),('7643','2013-07-05','15:45:00',2.22),('7643','2013-07-05','15:50:00',1.15),('7643','2013-07-05','16:15:00',1.24),('7643','2013-07-05','16:20:00',1.52),('7643','2013-07-05','16:40:00',1.63),('7643','2013-07-05','16:45:00',2.29),('7643','2013-07-05','16:50:00',3.38),('7643','2013-07-05','16:55:00',4.3),('7643','2013-07-05','17:00:00',3.48),('7643','2013-07-05','17:05:00',3.65),('7643','2013-07-05','17:10:00',3.33),('7643','2013-07-05','17:15:00',3.62),('7643','2013-07-05','17:20:00',3.7),('7643','2013-07-05','17:25:00',3.67),('7643','2013-07-05','17:30:00',4.18),('7643','2013-07-05','17:35:00',4.03),('7643','2013-07-05','17:40:00',3.46),('7643','2013-07-05','17:45:00',3.21),('7643','2013-07-05','17:50:00',2.78),('7643','2013-07-05','17:55:00',2.68),('7643','2013-07-05','18:00:00',2.54),('7643','2013-07-05','18:05:00',2.38),('7643','2013-07-05','18:10:00',2.29),('7643','2013-07-05','18:15:00',2.03),('7643','2013-07-05','18:20:00',1.88),('7643','2013-07-05','18:25:00',1.86),('7643','2013-07-05','18:30:00',1.77),('7643','2013-07-05','18:35:00',1.7),('7643','2013-07-05','18:40:00',1.64),('7643','2013-07-05','18:45:00',1.52),('7643','2013-07-05','18:50:00',1.3),('7643','2013-07-05','19:15:00',1.8),('7643','2013-07-05','19:20:00',1.73),('7643','2013-07-05','19:25:00',1.28),('7643','2013-07-05','19:30:00',1.1),('7643','2013-07-04','06:50:00',1.2),('7643','2013-07-04','06:55:00',1.4),('7643','2013-07-04','07:00:00',1.6),('7643','2013-07-04','07:05:00',1.85),('7643','2013-07-04','07:10:00',2.18),('7643','2013-07-04','07:15:00',2.46),('7643','2013-07-04','07:20:00',2.71),('7643','2013-07-04','07:25:00',2.61),('7643','2013-07-04','07:30:00',3.19),('7643','2013-07-04','07:35:00',3.63),('7643','2013-07-04','07:40:00',3.95),('7643','2013-07-04','07:45:00',4.27),('7643','2013-07-04','07:50:00',4.55),('7643','2013-07-04','07:55:00',4.83),('7643','2013-07-04','08:00:00',5.24),('7643','2013-07-04','08:05:00',5.54),('7643','2013-07-04','08:10:00',5.79),('7643','2013-07-04','08:15:00',6.08),('7643','2013-07-04','08:20:00',6.28),('7643','2013-07-04','08:25:00',6.56),('7643','2013-07-04','08:30:00',6.89),('7643','2013-07-04','08:35:00',7.25),('7643','2013-07-04','08:40:00',7.53),('7643','2013-07-04','08:45:00',7.73),('7643','2013-07-04','08:50:00',8.11),('7643','2013-07-04','08:55:00',8.41),('7643','2013-07-04','09:00:00',8.72),('7643','2013-07-04','09:05:00',9.02),('7643','2013-07-04','09:10:00',9.32),('7643','2013-07-04','09:15:00',9.65),('7643','2013-07-04','09:20:00',9.95),('7643','2013-07-04','09:25:00',10.27),('7643','2013-07-04','09:30:00',10.55),('7643','2013-07-04','09:35:00',10.79),('7643','2013-07-04','09:40:00',11.04),('7643','2013-07-04','09:45:00',11.24),('7643','2013-07-04','09:50:00',11.44),('7643','2013-07-04','09:55:00',11.61),('7643','2013-07-04','10:00:00',11.86),('7643','2013-07-04','10:05:00',12.06),('7643','2013-07-04','10:10:00',12.28),('7643','2013-07-04','10:15:00',12.44),('7643','2013-07-04','10:20:00',12.65),('7643','2013-07-04','10:25:00',12.8),('7643','2013-07-04','10:30:00',12.99),('7643','2013-07-04','10:35:00',13.14),('7643','2013-07-04','10:40:00',13.2),('7643','2013-07-04','10:45:00',13.27),('7643','2013-07-04','10:50:00',13.43),('7643','2013-07-04','10:55:00',13.64),('7643','2013-07-04','11:00:00',13.79),('7643','2013-07-04','11:05:00',13.85),('7643','2013-07-04','11:10:00',13.89),('7643','2013-07-04','11:15:00',14.08),('7643','2013-07-04','11:20:00',14.05),('7643','2013-07-04','11:25:00',14.37),('7643','2013-07-04','11:30:00',14.59),('7643','2013-07-04','11:35:00',14.77),('7643','2013-07-04','11:40:00',14.83),('7643','2013-07-04','11:45:00',14.94),('7643','2013-07-04','11:50:00',15.05),('7643','2013-07-04','11:55:00',15.15),('7643','2013-07-04','12:00:00',15.11),('7643','2013-07-04','12:05:00',15.22),('7643','2013-07-04','12:10:00',15.25),('7643','2013-07-04','12:15:00',15.28),('7643','2013-07-04','12:20:00',15.65),('7643','2013-07-04','12:25:00',8.87),('7643','2013-07-04','12:30:00',15.6),('7643','2013-07-04','12:35:00',16.1),('7643','2013-07-04','12:40:00',15.33),('7643','2013-07-04','12:45:00',15.7),('7643','2013-07-04','12:50:00',15.67),('7643','2013-07-04','12:55:00',15.81),('7643','2013-07-04','13:00:00',16.04),('7643','2013-07-04','13:05:00',5.78),('7643','2013-07-04','13:10:00',14.23),('7643','2013-07-04','13:15:00',16.58),('7643','2013-07-04','13:20:00',14.16),('7643','2013-07-04','13:25:00',13.32),('7643','2013-07-04','13:30:00',16.42),('7643','2013-07-04','13:35:00',16.3),('7643','2013-07-04','13:40:00',16.17),('7643','2013-07-04','13:45:00',16.41),('7643','2013-07-04','13:50:00',16.01),('7643','2013-07-04','13:55:00',16.23),('7643','2013-07-04','14:00:00',16.45),('7643','2013-07-04','14:05:00',15.48),('7643','2013-07-04','14:10:00',15.93),('7643','2013-07-04','14:15:00',15.78),('7643','2013-07-04','14:20:00',15.56),('7643','2013-07-04','14:25:00',15.91),('7643','2013-07-04','14:30:00',15.34),('7643','2013-07-04','14:35:00',15.6),('7643','2013-07-04','14:40:00',15.4),('7643','2013-07-04','14:45:00',11.11),('7643','2013-07-04','14:50:00',15.47),('7643','2013-07-04','14:55:00',15.01),('7643','2013-07-04','15:00:00',11.36),('7643','2013-07-04','15:05:00',9.16),('7643','2013-07-04','15:10:00',15.39),('7643','2013-07-04','15:15:00',11.99),('7643','2013-07-04','15:20:00',14.43),('7643','2013-07-04','15:25:00',9.8),('7643','2013-07-04','15:30:00',11.63),('7643','2013-07-04','15:35:00',14.42),('7643','2013-07-04','15:40:00',14.03),('7643','2013-07-04','15:45:00',14.1),('7643','2013-07-04','15:50:00',13.77),('7643','2013-07-04','15:55:00',13.36),('7643','2013-07-04','16:00:00',13.03),('7643','2013-07-04','16:05:00',12.93),('7643','2013-07-04','16:10:00',12.45),('7643','2013-07-04','16:15:00',12.31),('7643','2013-07-04','16:20:00',12.16),('7643','2013-07-04','16:25:00',11.88),('7643','2013-07-04','16:30:00',11.65),('7643','2013-07-04','16:35:00',11.4),('7643','2013-07-04','16:40:00',11.08),('7643','2013-07-04','16:45:00',11),('7643','2013-07-04','16:50:00',10.48),('7643','2013-07-04','16:55:00',10.12),('7643','2013-07-04','17:00:00',8.48),('7643','2013-07-04','17:05:00',9.65),('7643','2013-07-04','17:10:00',9.58),('7643','2013-07-04','17:15:00',9.4),('7643','2013-07-04','17:20:00',9.11),('7643','2013-07-04','17:25:00',8.64),('7643','2013-07-04','17:30:00',8.29),('7643','2013-07-04','17:35:00',7.72),('7643','2013-07-04','17:40:00',7.19),('7643','2013-07-04','17:45:00',6.9),('7643','2013-07-04','17:50:00',6.62),('7643','2013-07-04','17:55:00',6.56),('7643','2013-07-04','18:00:00',6.36),('7643','2013-07-04','18:05:00',5.98),('7643','2013-07-04','18:10:00',5.09),('7643','2013-07-04','18:15:00',1.58),('7643','2013-07-04','18:20:00',3.15),('7643','2013-07-04','18:25:00',1.14),('7643','2013-07-04','18:30:00',1.62),('7643','2013-07-04','18:35:00',3.58),('7643','2013-07-04','18:40:00',3.55),('7643','2013-07-04','18:45:00',3.3),('7643','2013-07-04','18:50:00',2.96),('7643','2013-07-04','18:55:00',2.58),('7643','2013-07-04','19:00:00',2.31),('7643','2013-07-04','19:05:00',2.04),('7643','2013-07-04','19:10:00',1.81),('7643','2013-07-04','19:15:00',1.63),('7643','2013-07-04','19:20:00',1.37),('7643','2013-07-04','19:25:00',1.16),('7643','2013-07-03','07:15:00',1.04),('7643','2013-07-03','07:20:00',1.34),('7643','2013-07-03','07:25:00',1.26),('7643','2013-07-03','07:45:00',1.28),('7643','2013-07-03','07:50:00',1.55),('7643','2013-07-03','07:55:00',1.72),('7643','2013-07-03','08:00:00',1.87),('7643','2013-07-03','08:05:00',1.75),('7643','2013-07-03','08:10:00',1.36),('7643','2013-07-03','08:15:00',1.16),('7643','2013-07-03','08:20:00',1.18),('7643','2013-07-03','08:25:00',1.24),('7643','2013-07-03','08:30:00',1.46),('7643','2013-07-03','08:35:00',1.68),('7643','2013-07-03','08:40:00',1.79),('7643','2013-07-03','08:45:00',2.07),('7643','2013-07-03','08:50:00',2.74),('7643','2013-07-03','08:55:00',3.46),('7643','2013-07-03','09:00:00',3.43),('7643','2013-07-03','09:05:00',2.83),('7643','2013-07-03','09:10:00',2.49),('7643','2013-07-03','09:15:00',2.56),('7643','2013-07-03','09:20:00',2.47),('7643','2013-07-03','09:25:00',2.68),('7643','2013-07-03','09:30:00',2.82),('7643','2013-07-03','09:35:00',2.77),('7643','2013-07-03','09:40:00',2.33),('7643','2013-07-03','09:45:00',1.9),('7643','2013-07-03','09:50:00',1.66),('7643','2013-07-03','09:55:00',1.52),('7643','2013-07-03','10:00:00',1.46),('7643','2013-07-03','10:05:00',1.57),('7643','2013-07-03','10:10:00',1.92),('7643','2013-07-03','10:15:00',2.25),('7643','2013-07-03','10:20:00',2.5),('7643','2013-07-03','10:25:00',2.59),('7643','2013-07-03','10:30:00',2.6),('7643','2013-07-03','10:35:00',2.72),('7643','2013-07-03','10:40:00',2.65),('7643','2013-07-03','10:45:00',2.34),('7643','2013-07-03','10:50:00',2.09),('7643','2013-07-03','10:55:00',2.25),('7643','2013-07-03','11:00:00',2.67),('7643','2013-07-03','11:05:00',3.03),('7643','2013-07-03','11:10:00',3.63),('7643','2013-07-03','11:15:00',3.97),('7643','2013-07-03','11:20:00',3.77),('7643','2013-07-03','11:25:00',3.96),('7643','2013-07-03','11:30:00',4.34),('7643','2013-07-03','11:35:00',4.98),('7643','2013-07-03','11:40:00',5.63),('7643','2013-07-03','11:45:00',6.17),('7643','2013-07-03','11:50:00',6.38),('7643','2013-07-03','11:55:00',5.73),('7643','2013-07-03','12:00:00',5.14),('7643','2013-07-03','12:05:00',5.94),('7643','2013-07-03','12:10:00',7.72),('7643','2013-07-03','12:15:00',9.06),('7643','2013-07-03','12:20:00',10),('7643','2013-07-03','12:25:00',15.38),('7643','2013-07-03','12:30:00',10.71),('7643','2013-07-03','12:35:00',10.69),('7643','2013-07-03','12:40:00',6.88),('7643','2013-07-03','12:45:00',5.35),('7643','2013-07-03','12:50:00',4.22),('7643','2013-07-03','12:55:00',3.7),('7643','2013-07-03','13:00:00',3.86),('7643','2013-07-03','13:05:00',4.54),('7643','2013-07-03','13:10:00',5.7),('7643','2013-07-03','13:15:00',6.7),('7643','2013-07-03','13:20:00',7.43),('7643','2013-07-03','13:25:00',9.13),('7643','2013-07-03','13:30:00',8.54),('7643','2013-07-03','13:35:00',8.16),('7643','2013-07-03','13:40:00',11.55),('7643','2013-07-03','13:45:00',8.51),('7643','2013-07-03','13:50:00',10.12),('7643','2013-07-03','13:55:00',10.65),('7643','2013-07-03','14:00:00',8.55),('7643','2013-07-03','14:05:00',8.07),('7643','2013-07-03','14:10:00',7.98),('7643','2013-07-03','14:15:00',8.24),('7643','2013-07-03','14:20:00',11.38),('7643','2013-07-03','14:25:00',7.26),('7643','2013-07-03','14:30:00',7.44),('7643','2013-07-03','14:35:00',7.82),('7643','2013-07-03','14:40:00',11.32),('7643','2013-07-03','14:45:00',18.38),('7643','2013-07-03','14:50:00',12),('7643','2013-07-03','14:55:00',8.15),('7643','2013-07-03','15:00:00',12.53),('7643','2013-07-03','15:05:00',11.09),('7643','2013-07-03','15:10:00',9.17),('7643','2013-07-03','15:15:00',15.19),('7643','2013-07-03','15:20:00',13.92),('7643','2013-07-03','15:25:00',13.16),('7643','2013-07-03','15:30:00',11.15),('7643','2013-07-03','15:35:00',9.72),('7643','2013-07-03','15:40:00',10.2),('7643','2013-07-03','15:45:00',14.19),('7643','2013-07-03','15:50:00',8.76),('7643','2013-07-03','15:55:00',8.32),('7643','2013-07-03','16:00:00',8.49),('7643','2013-07-03','16:05:00',8.98),('7643','2013-07-03','16:10:00',7.25),('7643','2013-07-03','16:15:00',6.2),('7643','2013-07-03','16:20:00',6.8),('7643','2013-07-03','16:25:00',7.69),('7643','2013-07-03','16:30:00',8.95),('7643','2013-07-03','16:35:00',8.45),('7643','2013-07-03','16:40:00',7.26),('7643','2013-07-03','16:45:00',5.73),('7643','2013-07-03','16:50:00',5.64),('7643','2013-07-03','16:55:00',5.52),('7643','2013-07-03','17:00:00',4.84),('7643','2013-07-03','17:05:00',4.56),('7643','2013-07-03','17:10:00',6.14),('7643','2013-07-03','17:15:00',8.63),('7643','2013-07-03','17:20:00',9.15),('7643','2013-07-03','17:25:00',9.2),('7643','2013-07-03','17:30:00',8.54),('7643','2013-07-03','17:35:00',8.61),('7643','2013-07-03','17:40:00',8.61),('7643','2013-07-03','17:45:00',8.16),('7643','2013-07-03','17:50:00',8.05),('7643','2013-07-03','17:55:00',7.77),('7643','2013-07-03','18:00:00',7.51),('7643','2013-07-03','18:05:00',7.2),('7643','2013-07-03','18:10:00',6.97),('7643','2013-07-03','18:15:00',6.62),('7643','2013-07-03','18:20:00',6.16),('7643','2013-07-03','18:25:00',5.69),('7643','2013-07-03','18:30:00',3.77),('7643','2013-07-03','18:35:00',3.02),('7643','2013-07-03','18:40:00',1.5),('7643','2013-07-02','06:45:00',1.01),('7643','2013-07-02','06:50:00',1.2),('7643','2013-07-02','06:55:00',1.41),('7643','2013-07-02','07:00:00',1.68),('7643','2013-07-02','07:05:00',1.91),('7643','2013-07-02','07:10:00',2.23),('7643','2013-07-02','07:15:00',2.52),('7643','2013-07-02','07:20:00',2.8),('7643','2013-07-02','07:25:00',3.12),('7643','2013-07-02','07:30:00',3.44),('7643','2013-07-02','07:35:00',3.76),('7643','2013-07-02','07:40:00',4.08),('7643','2013-07-02','07:45:00',4.44),('7643','2013-07-02','07:50:00',4.79),('7643','2013-07-02','07:55:00',5.08),('7643','2013-07-02','08:00:00',5.43),('7643','2013-07-02','08:05:00',5.77),('7643','2013-07-02','08:10:00',6.01),('7643','2013-07-02','08:15:00',6.33),('7643','2013-07-02','08:20:00',6.62),('7643','2013-07-02','08:25:00',6.89),('7643','2013-07-02','08:30:00',7.24),('7643','2013-07-02','08:35:00',7.64),('7643','2013-07-02','08:40:00',7.95),('7643','2013-07-02','08:45:00',8.25),('7643','2013-07-02','08:50:00',8.61),('7643','2013-07-02','08:55:00',8.87),('7643','2013-07-02','09:00:00',9.04),('7643','2013-07-02','09:05:00',9.48),('7643','2013-07-02','09:10:00',9.76),('7643','2013-07-02','09:15:00',10.03),('7643','2013-07-02','09:20:00',10.28),('7643','2013-07-02','09:25:00',10.53),('7643','2013-07-02','09:30:00',10.68),('7643','2013-07-02','09:35:00',10.9),('7643','2013-07-02','09:40:00',11.09),('7643','2013-07-02','09:45:00',11.32),('7643','2013-07-02','09:50:00',11.57),('7643','2013-07-02','09:55:00',11.74),('7643','2013-07-02','10:00:00',11.96),('7643','2013-07-02','10:05:00',11.95),('7643','2013-07-02','10:10:00',12.21),('7643','2013-07-02','10:15:00',12.45),('7643','2013-07-02','10:20:00',12.63),('7643','2013-07-02','10:25:00',12.8),('7643','2013-07-02','10:30:00',12.94),('7643','2013-07-02','10:35:00',13.01),('7643','2013-07-02','10:40:00',13.25),('7643','2013-07-02','10:45:00',13.45),('7643','2013-07-02','10:50:00',13.51),('7643','2013-07-02','10:55:00',13.67),('7643','2013-07-02','11:00:00',13.89),('7643','2013-07-02','11:05:00',13.96),('7643','2013-07-02','11:10:00',14.08),('7643','2013-07-02','11:15:00',14.34),('7643','2013-07-02','11:20:00',14.6),('7643','2013-07-02','11:25:00',14.77),('7643','2013-07-02','11:30:00',14.61),('7643','2013-07-02','11:35:00',14.56),('7643','2013-07-02','11:40:00',14.75),('7643','2013-07-02','11:45:00',12.23),('7643','2013-07-02','11:50:00',15.67),('7643','2013-07-02','11:55:00',15.4),('7643','2013-07-02','12:00:00',15.54),('7643','2013-07-02','12:05:00',15.73),('7643','2013-07-02','12:10:00',15.8),('7643','2013-07-02','12:15:00',15.79),('7643','2013-07-02','12:20:00',15.84),('7643','2013-07-02','12:25:00',15.88),('7643','2013-07-02','12:30:00',16.07),('7643','2013-07-02','12:35:00',16.15),('7643','2013-07-02','12:40:00',16.13),('7643','2013-07-02','12:45:00',16.24),('7643','2013-07-02','12:50:00',16.19),('7643','2013-07-02','12:55:00',16.39),('7643','2013-07-02','13:00:00',16.43),('7643','2013-07-02','13:05:00',16.55),('7643','2013-07-02','13:10:00',16.47),('7643','2013-07-02','13:15:00',16.42),('7643','2013-07-02','13:20:00',16.34),('7643','2013-07-02','13:25:00',16.24),('7643','2013-07-02','13:30:00',16.31),('7643','2013-07-02','13:35:00',16.2),('7643','2013-07-02','13:40:00',16.23),('7643','2013-07-02','13:45:00',16.25),('7643','2013-07-02','13:50:00',16.23),('7643','2013-07-02','13:55:00',16.18),('7643','2013-07-02','14:00:00',16.05),('7643','2013-07-02','14:05:00',16.07),('7643','2013-07-02','14:10:00',16.04),('7643','2013-07-02','14:15:00',15.99),('7643','2013-07-02','14:20:00',16.03),('7643','2013-07-02','14:25:00',16.01),('7643','2013-07-02','14:30:00',16),('7643','2013-07-02','14:35:00',15.9),('7643','2013-07-02','14:40:00',15.81),('7643','2013-07-02','14:45:00',15.59),('7643','2013-07-02','14:50:00',15.51),('7643','2013-07-02','14:55:00',15.41),('7643','2013-07-02','15:00:00',15.27),('7643','2013-07-02','15:05:00',15.15),('7643','2013-07-02','15:10:00',15),('7643','2013-07-02','15:15:00',14.92),('7643','2013-07-02','15:20:00',14.77),('7643','2013-07-02','15:25:00',14.6),('7643','2013-07-02','15:30:00',14.43),('7643','2013-07-02','15:35:00',14.2),('7643','2013-07-02','15:40:00',14.05),('7643','2013-07-02','15:45:00',13.82),('7643','2013-07-02','15:50:00',13.68),('7643','2013-07-02','15:55:00',13.51),('7643','2013-07-02','16:00:00',13.29),('7643','2013-07-02','16:05:00',13.13),('7643','2013-07-02','16:10:00',12.93),('7643','2013-07-02','16:15:00',12.69),('7643','2013-07-02','16:20:00',12.47),('7643','2013-07-02','16:25:00',12.18),('7643','2013-07-02','16:30:00',11.95),('7643','2013-07-02','16:35:00',11.7),('7643','2013-07-02','16:40:00',11.46),('7643','2013-07-02','16:45:00',11.22),('7643','2013-07-02','16:50:00',10.87),('7643','2013-07-02','16:55:00',10.65),('7643','2013-07-02','17:00:00',10.39),('7643','2013-07-02','17:05:00',10.12),('7643','2013-07-02','17:10:00',9.82),('7643','2013-07-02','17:15:00',9.45),('7643','2013-07-02','17:20:00',9.09),('7643','2013-07-02','17:25:00',8.81),('7643','2013-07-02','17:30:00',8.53),('7643','2013-07-02','17:35:00',8.14),('7643','2013-07-02','17:40:00',7.88),('7643','2013-07-02','17:45:00',7.62),('7643','2013-07-02','17:50:00',7.31),('7643','2013-07-02','17:55:00',6.96),('7643','2013-07-02','18:00:00',6.61),('7643','2013-07-02','18:05:00',6.15),('7643','2013-07-02','18:10:00',5.81),('7643','2013-07-02','18:15:00',5.63),('7643','2013-07-02','18:20:00',5.32),('7643','2013-07-02','18:25:00',5),('7643','2013-07-02','18:30:00',4.68),('7643','2013-07-02','18:35:00',4.36),('7643','2013-07-02','18:40:00',4.01),('7643','2013-07-02','18:45:00',3.64),('7643','2013-07-02','18:50:00',3.2),('7643','2013-07-02','18:55:00',2.87),('7643','2013-07-02','19:00:00',2.58),('7643','2013-07-02','19:05:00',2.22),('7643','2013-07-02','19:10:00',2),('7643','2013-07-02','19:15:00',1.75),('7643','2013-07-02','19:20:00',1.43),('7643','2013-07-02','19:25:00',1.19),('7643','2013-07-02','19:30:00',1.02),('7643','2013-07-01','06:45:00',1.04),('7643','2013-07-01','06:50:00',1.21),('7643','2013-07-01','06:55:00',1.39),('7643','2013-07-01','07:00:00',1.6),('7643','2013-07-01','07:05:00',1.89),('7643','2013-07-01','07:10:00',2.2),('7643','2013-07-01','07:15:00',2.49),('7643','2013-07-01','07:20:00',2.76),('7643','2013-07-01','07:25:00',3.07),('7643','2013-07-01','07:30:00',3.37),('7643','2013-07-01','07:35:00',3.69),('7643','2013-07-01','07:40:00',3.98),('7643','2013-07-01','07:45:00',4.37),('7643','2013-07-01','07:50:00',4.69),('7643','2013-07-01','07:55:00',4.99),('7643','2013-07-01','08:00:00',5.32),('7643','2013-07-01','08:05:00',5.6),('7643','2013-07-01','08:10:00',5.92),('7643','2013-07-01','08:15:00',6.25),('7643','2013-07-01','08:20:00',6.49),('7643','2013-07-01','08:25:00',6.8),('7643','2013-07-01','08:30:00',7.13),('7643','2013-07-01','08:35:00',7.53),('7643','2013-07-01','08:40:00',7.84),('7643','2013-07-01','08:45:00',8.15),('7643','2013-07-01','08:50:00',8.5),('7643','2013-07-01','08:55:00',8.82),('7643','2013-07-01','09:00:00',9.04),('7643','2013-07-01','09:05:00',9.32),('7643','2013-07-01','09:10:00',9.65),('7643','2013-07-01','09:15:00',9.93),('7643','2013-07-01','09:20:00',10.23),('7643','2013-07-01','09:25:00',10.44),('7643','2013-07-01','09:30:00',10.64),('7643','2013-07-01','09:35:00',10.88),('7643','2013-07-01','09:40:00',11.08),('7643','2013-07-01','09:45:00',11.3),('7643','2013-07-01','09:50:00',11.55),('7643','2013-07-01','09:55:00',11.77),('7643','2013-07-01','10:00:00',12),('7643','2013-07-01','10:05:00',12.08),('7643','2013-07-01','10:10:00',12.24),('7643','2013-07-01','10:15:00',12.4),('7643','2013-07-01','10:20:00',12.56),('7643','2013-07-01','10:25:00',12.75),('7643','2013-07-01','10:30:00',12.9),('7643','2013-07-01','10:35:00',13.07),('7643','2013-07-01','10:40:00',13.22),('7643','2013-07-01','10:45:00',13.37),('7643','2013-07-01','10:50:00',13.53),('7643','2013-07-01','10:55:00',13.61),('7643','2013-07-01','11:00:00',13.65),('7643','2013-07-01','11:05:00',13.79),('7643','2013-07-01','11:10:00',13.86),('7643','2013-07-01','11:15:00',13.92),('7643','2013-07-01','11:20:00',14.01),('7643','2013-07-01','11:25:00',14.11),('7643','2013-07-01','11:30:00',14.45),('7643','2013-07-01','11:35:00',14.59),('7643','2013-07-01','11:40:00',14.52),('7643','2013-07-01','11:45:00',14.64),('7643','2013-07-01','11:50:00',14.92),('7643','2013-07-01','11:55:00',14.85),('7643','2013-07-01','12:00:00',14.78),('7643','2013-07-01','12:05:00',14.82),('7643','2013-07-01','12:10:00',15.05),('7643','2013-07-01','12:15:00',15.38),('7643','2013-07-01','12:20:00',15.44),('7643','2013-07-01','12:25:00',15.56),('7643','2013-07-01','12:30:00',15.66),('7643','2013-07-01','12:35:00',15.64),('7643','2013-07-01','12:40:00',15.75),('7643','2013-07-01','12:45:00',16.11),('7643','2013-07-01','12:50:00',16.72),('7643','2013-07-01','12:55:00',13.02),('7643','2013-07-01','13:00:00',8.47),('7643','2013-07-01','13:05:00',6.2),('7643','2013-07-01','13:10:00',10.49),('7643','2013-07-01','13:15:00',16.44),('7643','2013-07-01','13:20:00',16.55),('7643','2013-07-01','13:25:00',16.66),('7643','2013-07-01','13:30:00',16.2),('7643','2013-07-01','13:35:00',16.21),('7643','2013-07-01','13:40:00',16.47),('7643','2013-07-01','13:45:00',16.05),('7643','2013-07-01','13:50:00',15.38),('7643','2013-07-01','13:55:00',15.58),('7643','2013-07-01','14:00:00',15.79),('7643','2013-07-01','14:05:00',15.64),('7643','2013-07-01','14:10:00',15.36),('7643','2013-07-01','14:15:00',15.44),('7643','2013-07-01','14:20:00',15.7),('7643','2013-07-01','14:25:00',15.68),('7643','2013-07-01','14:30:00',15.52),('7643','2013-07-01','14:35:00',15.38),('7643','2013-07-01','14:40:00',15.34),('7643','2013-07-01','14:45:00',15.18),('7643','2013-07-01','14:50:00',15.07),('7643','2013-07-01','14:55:00',14.93),('7643','2013-07-01','15:00:00',14.85),('7643','2013-07-01','15:05:00',14.87),('7643','2013-07-01','15:10:00',14.75),('7643','2013-07-01','15:15:00',14.53),('7643','2013-07-01','15:20:00',14.44),('7643','2013-07-01','15:25:00',14.29),('7643','2013-07-01','15:30:00',14.07),('7643','2013-07-01','15:35:00',14.05),('7643','2013-07-01','15:40:00',13.84),('7643','2013-07-01','15:45:00',13.6),('7643','2013-07-01','15:50:00',13.44),('7643','2013-07-01','15:55:00',13.22),('7643','2013-07-01','16:00:00',13.02),('7643','2013-07-01','16:05:00',12.86),('7643','2013-07-01','16:10:00',12.62),('7643','2013-07-01','16:15:00',12.37),('7643','2013-07-01','16:20:00',12.11),('7643','2013-07-01','16:25:00',11.83),('7643','2013-07-01','16:30:00',11.52),('7643','2013-07-01','16:35:00',11.25),('7643','2013-07-01','16:40:00',11.09),('7643','2013-07-01','16:45:00',10.78),('7643','2013-07-01','16:50:00',10.4),('7643','2013-07-01','16:55:00',10.22),('7643','2013-07-01','17:00:00',10.11),('7643','2013-07-01','17:05:00',9.72),('7643','2013-07-01','17:10:00',9.41),('7643','2013-07-01','17:15:00',9.08),('7643','2013-07-01','17:20:00',8.67),('7643','2013-07-01','17:25:00',8.37),('7643','2013-07-01','17:30:00',8.09),('7643','2013-07-01','17:35:00',7.74),('7643','2013-07-01','17:40:00',7.46),('7643','2013-07-01','17:45:00',7.18),('7643','2013-07-01','17:50:00',6.91),('7643','2013-07-01','17:55:00',6.59),('7643','2013-07-01','18:00:00',6.25),('7643','2013-07-01','18:05:00',5.9),('7643','2013-07-01','18:10:00',5.65),('7643','2013-07-01','18:15:00',5.39),('7643','2013-07-01','18:20:00',5.09),('7643','2013-07-01','18:25:00',4.74),('7643','2013-07-01','18:30:00',4.41),('7643','2013-07-01','18:35:00',4.12),('7643','2013-07-01','18:40:00',3.81),('7643','2013-07-01','18:45:00',3.44),('7643','2013-07-01','18:50:00',3.05),('7643','2013-07-01','18:55:00',2.77),('7643','2013-07-01','19:00:00',2.5),('7643','2013-07-01','19:05:00',2.17),('7643','2013-07-01','19:10:00',1.96),('7643','2013-07-01','19:15:00',1.73),('7643','2013-07-01','19:20:00',1.46),('7643','2013-07-01','19:25:00',1.26),('7643','2013-07-01','19:30:00',1.08),('7643','2013-06-30','06:45:00',1.12),('7643','2013-06-30','06:50:00',1.3),('7643','2013-06-30','06:55:00',1.47),('7643','2013-06-30','07:00:00',1.66),('7643','2013-06-30','07:05:00',1.93),('7643','2013-06-30','07:10:00',2.25),('7643','2013-06-30','07:15:00',2.58),('7643','2013-06-30','07:20:00',2.9),('7643','2013-06-30','07:25:00',3.16),('7643','2013-06-30','07:30:00',3.46),('7643','2013-06-30','07:35:00',3.82),('7643','2013-06-30','07:40:00',4.06),('7643','2013-06-30','07:45:00',4.4),('7643','2013-06-30','07:50:00',4.75),('7643','2013-06-30','07:55:00',5.09),('7643','2013-06-30','08:00:00',5.46),('7643','2013-06-30','08:05:00',5.73),('7643','2013-06-30','08:10:00',6.07),('7643','2013-06-30','08:15:00',6.4),('7643','2013-06-30','08:20:00',6.63),('7643','2013-06-30','08:25:00',6.95),('7643','2013-06-30','08:30:00',7.29),('7643','2013-06-30','08:35:00',7.72),('7643','2013-06-30','08:40:00',8.04),('7643','2013-06-30','08:45:00',8.33),('7643','2013-06-30','08:50:00',8.67),('7643','2013-06-30','08:55:00',8.98),('7643','2013-06-30','09:00:00',9.3),('7643','2013-06-30','09:05:00',9.57),('7643','2013-06-30','09:10:00',9.93),('7643','2013-06-30','09:15:00',10.28),('7643','2013-06-30','09:20:00',10.57),('7643','2013-06-30','09:25:00',10.82),('7643','2013-06-30','09:30:00',11.11),('7643','2013-06-30','09:35:00',11.35),('7643','2013-06-30','09:40:00',11.5),('7643','2013-06-30','09:45:00',11.69),('7643','2013-06-30','09:50:00',11.9),('7643','2013-06-30','09:55:00',12.08),('7643','2013-06-30','10:00:00',12.22),('7643','2013-06-30','10:05:00',12.37),('7643','2013-06-30','10:10:00',12.56),('7643','2013-06-30','10:15:00',12.76),('7643','2013-06-30','10:20:00',13),('7643','2013-06-30','10:25:00',13.26),('7643','2013-06-30','10:30:00',13.46),('7643','2013-06-30','10:35:00',13.68),('7643','2013-06-30','10:40:00',13.99),('7643','2013-06-30','10:45:00',14.1),('7643','2013-06-30','10:50:00',14.14),('7643','2013-06-30','10:55:00',14.22),('7643','2013-06-30','11:00:00',14.28),('7643','2013-06-30','11:05:00',14.6),('7643','2013-06-30','11:10:00',14.81),('7643','2013-06-30','11:15:00',15.02),('7643','2013-06-30','11:20:00',15.01),('7643','2013-06-30','11:25:00',14.98),('7643','2013-06-30','11:30:00',15.1),('7643','2013-06-30','11:35:00',15.43),('7643','2013-06-30','11:40:00',15.66),('7643','2013-06-30','11:45:00',15.74),('7643','2013-06-30','11:50:00',15.71),('7643','2013-06-30','11:55:00',15.69),('7643','2013-06-30','12:00:00',15.7),('7643','2013-06-30','12:05:00',15.83),('7643','2013-06-30','12:10:00',15.83),('7643','2013-06-30','12:15:00',15.77),('7643','2013-06-30','12:20:00',15.81),('7643','2013-06-30','12:25:00',15.94),('7643','2013-06-30','12:30:00',15.95),('7643','2013-06-30','12:35:00',16.03),('7643','2013-06-30','12:40:00',16.04),('7643','2013-06-30','12:45:00',16.07),('7643','2013-06-30','12:50:00',16.03),('7643','2013-06-30','12:55:00',16),('7643','2013-06-30','13:00:00',16),('7643','2013-06-30','13:05:00',16.19),('7643','2013-06-30','13:10:00',16.26),('7643','2013-06-30','13:15:00',16.23),('7643','2013-06-30','13:20:00',16.05),('7643','2013-06-30','13:25:00',16.16),('7643','2013-06-30','13:30:00',16.23),('7643','2013-06-30','13:35:00',16.18),('7643','2013-06-30','13:40:00',15.98),('7643','2013-06-30','13:45:00',15.82),('7643','2013-06-30','13:50:00',15.73),('7643','2013-06-30','13:55:00',16.02),('7643','2013-06-30','14:00:00',15.86),('7643','2013-06-30','14:05:00',16.14),('7643','2013-06-30','14:10:00',16.12),('7643','2013-06-30','14:15:00',16.11),('7643','2013-06-30','14:20:00',16.01),('7643','2013-06-30','14:25:00',15.78),('7643','2013-06-30','14:30:00',15.63),('7643','2013-06-30','14:35:00',15.58),('7643','2013-06-30','14:40:00',15.59),('7643','2013-06-30','14:45:00',15.43),('7643','2013-06-30','14:50:00',15.23),('7643','2013-06-30','14:55:00',15.11),('7643','2013-06-30','15:00:00',14.94),('7643','2013-06-30','15:05:00',14.62),('7643','2013-06-30','15:10:00',14.63),('7643','2013-06-30','15:15:00',14.54),('7643','2013-06-30','15:20:00',14.33),('7643','2013-06-30','15:25:00',14.19),('7643','2013-06-30','15:30:00',14.07),('7643','2013-06-30','15:35:00',13.75),('7643','2013-06-30','15:40:00',13.58),('7643','2013-06-30','15:45:00',13.56),('7643','2013-06-30','15:50:00',13.29),('7643','2013-06-30','15:55:00',13.07),('7643','2013-06-30','16:00:00',12.86),('7643','2013-06-30','16:05:00',12.71),('7643','2013-06-30','16:10:00',12.44),('7643','2013-06-30','16:15:00',12.15),('7643','2013-06-30','16:20:00',11.82),('7643','2013-06-30','16:25:00',11.52),('7643','2013-06-30','16:30:00',11.34),('7643','2013-06-30','16:35:00',11.14),('7643','2013-06-30','16:40:00',10.88),('7643','2013-06-30','16:45:00',10.64),('7643','2013-06-30','16:50:00',10.41),('7643','2013-06-30','16:55:00',10.22),('7643','2013-06-30','17:00:00',10.02),('7643','2013-06-30','17:05:00',9.71),('7643','2013-06-30','17:10:00',9.4),('7643','2013-06-30','17:15:00',9.04),('7643','2013-06-30','17:20:00',8.6),('7643','2013-06-30','17:25:00',8.28),('7643','2013-06-30','17:30:00',7.97),('7643','2013-06-30','17:35:00',7.62),('7643','2013-06-30','17:40:00',7.38),('7643','2013-06-30','17:45:00',7.21),('7643','2013-06-30','17:50:00',6.95),('7643','2013-06-30','17:55:00',6.65),('7643','2013-06-30','18:00:00',5.79),('7643','2013-06-30','18:05:00',5.78),('7643','2013-06-30','18:10:00',5.55),('7643','2013-06-30','18:15:00',4.51),('7643','2013-06-30','18:20:00',4.53),('7643','2013-06-30','18:25:00',4.9),('7643','2013-06-30','18:30:00',4.62),('7643','2013-06-30','18:35:00',4.25),('7643','2013-06-30','18:40:00',3.74),('7643','2013-06-30','18:45:00',3.44),('7643','2013-06-30','18:50:00',3.04),('7643','2013-06-30','18:55:00',2.61),('7643','2013-06-30','19:00:00',2.43),('7643','2013-06-30','19:05:00',2.17),('7643','2013-06-30','19:10:00',1.97),('7643','2013-06-30','19:15:00',1.51),('7643','2013-06-30','19:20:00',1.51),('7643','2013-06-30','19:25:00',1.35),('7643','2013-06-30','19:30:00',1.13),('7643','2014-04-04','07:20:00',1.03),('7643','2014-04-04','07:25:00',1.23),('7643','2014-04-04','07:30:00',1.09),('7643','2014-04-04','07:35:00',1.18),('7643','2014-04-04','07:40:00',1.13),('7643','2014-04-04','08:30:00',1.36),('7643','2014-04-04','08:35:00',2.26),('7643','2014-04-04','08:40:00',2.11),('7643','2014-04-04','08:45:00',1.98),('7643','2014-04-04','08:50:00',1.79),('7643','2014-04-04','08:55:00',1.93),('7643','2014-04-04','09:00:00',2.53),('7643','2014-04-04','09:05:00',3.29),('7643','2014-04-04','09:10:00',3.7),('7643','2014-04-04','09:15:00',5.16),('7643','2014-04-04','09:20:00',6.43),('7643','2014-04-04','09:25:00',10.18),('7643','2014-04-04','09:30:00',13.86),('7643','2014-04-04','09:35:00',13.35),('7643','2014-04-04','09:40:00',12.89),('7643','2014-04-04','09:45:00',11.23),('7643','2014-04-04','09:50:00',6.49),('7643','2014-04-04','09:55:00',7.14),('7643','2014-04-04','10:00:00',8.95),('7643','2014-04-04','10:05:00',9.2),('7643','2014-04-04','10:10:00',8.64),('7643','2014-04-04','10:15:00',8.05),('7643','2014-04-04','10:20:00',11.1),('7643','2014-04-04','10:25:00',10.53),('7643','2014-04-04','10:30:00',10.71),('7643','2014-04-04','10:35:00',12.48),('7643','2014-04-04','10:40:00',13.71),('7643','2014-04-04','10:45:00',12.3),('7643','2014-04-04','10:50:00',9.22),('7643','2014-04-04','10:55:00',11.56),('7643','2014-04-04','11:00:00',14.2),('7643','2014-04-04','11:05:00',15.1),('7643','2014-04-04','11:10:00',15.6),('7643','2014-04-04','11:15:00',16.5),('7643','2014-04-04','11:20:00',16.56),('7643','2014-04-04','11:25:00',10.88),('7643','2014-04-04','11:30:00',8.2),('7643','2014-04-04','11:35:00',11.07),('7643','2014-04-04','11:40:00',14.61),('7643','2014-04-04','11:45:00',16.5),('7643','2014-04-04','11:50:00',17.62),('7643','2014-04-04','11:55:00',16.46),('7643','2014-04-04','12:00:00',11.81),('7643','2014-04-04','12:05:00',12.01),('7643','2014-04-04','12:10:00',13.05),('7643','2014-04-04','12:15:00',14.49),('7643','2014-04-04','12:20:00',13.81),('7643','2014-04-04','12:25:00',10.64),('7643','2014-04-04','12:30:00',10.66),('7643','2014-04-04','12:35:00',11.81),('7643','2014-04-04','12:40:00',16.87),('7643','2014-04-04','12:45:00',19.05),('7643','2014-04-04','12:50:00',18.78),('7643','2014-04-04','12:55:00',14.76),('7643','2014-04-04','13:00:00',15.67),('7643','2014-04-04','13:05:00',15.79),('7643','2014-04-04','13:10:00',15.06),('7643','2014-04-04','13:15:00',5.98),('7643','2014-04-04','13:20:00',14.66),('7643','2014-04-04','13:25:00',17.54),('7643','2014-04-04','13:30:00',13.66),('7643','2014-04-04','13:35:00',17.71),('7643','2014-04-04','13:40:00',11.41),('7643','2014-04-04','13:45:00',7.97),('7643','2014-04-04','13:50:00',15.12),('7643','2014-04-04','13:55:00',13.64),('7643','2014-04-04','14:00:00',13.03),('7643','2014-04-04','14:05:00',19.28),('7643','2014-04-04','14:10:00',10.08),('7643','2014-04-04','14:15:00',3.48),('7643','2014-04-04','14:20:00',3.77),('7643','2014-04-04','14:25:00',11.49),('7643','2014-04-04','14:30:00',7.43),('7643','2014-04-04','14:35:00',4.98),('7643','2014-04-04','14:40:00',3.16),('7643','2014-04-04','14:45:00',2.84),('7643','2014-04-04','14:50:00',3.49),('7643','2014-04-04','14:55:00',16.11),('7643','2014-04-04','15:00:00',13.61),('7643','2014-04-04','15:05:00',14.41),('7643','2014-04-04','15:10:00',9.09),('7643','2014-04-04','15:15:00',9.52),('7643','2014-04-04','15:20:00',17.42),('7643','2014-04-04','15:25:00',11.5),('7643','2014-04-04','15:30:00',5.59),('7643','2014-04-04','15:35:00',5.8),('7643','2014-04-04','15:40:00',13.41),('7643','2014-04-04','15:45:00',5.86),('7643','2014-04-04','15:50:00',6.9),('7643','2014-04-04','15:55:00',4.79),('7643','2014-04-04','16:00:00',5.03),('7643','2014-04-04','16:05:00',5.86),('7643','2014-04-04','16:10:00',4.9),('7643','2014-04-04','16:15:00',11.42),('7643','2014-04-04','16:20:00',13.68),('7643','2014-04-04','16:25:00',11.31),('7643','2014-04-04','16:30:00',6.67),('7643','2014-04-04','16:35:00',11.86),('7643','2014-04-04','16:40:00',6.16),('7643','2014-04-04','16:45:00',7.58),('7643','2014-04-04','16:50:00',5.99),('7643','2014-04-04','16:55:00',6.92),('7643','2014-04-04','17:00:00',8.19),('7643','2014-04-04','17:05:00',8.05),('7643','2014-04-04','17:10:00',7.25),('7643','2014-04-04','17:15:00',5.67),('7643','2014-04-04','17:20:00',5.23),('7643','2014-04-04','17:25:00',5.43),('7643','2014-04-04','17:30:00',5.02),('7643','2014-04-04','17:35:00',4.62),('7643','2014-04-04','17:40:00',4.44),('7643','2014-04-04','17:45:00',3.61),('7643','2014-04-04','17:50:00',4.8),('7643','2014-04-04','17:55:00',4.75),('7643','2014-04-04','18:00:00',4.58),('7643','2014-04-04','18:05:00',4.05),('7643','2014-04-04','18:10:00',3.98),('7643','2014-04-04','18:15:00',4.07),('7643','2014-04-04','18:20:00',3.82),('7643','2014-04-04','18:25:00',2.9),('7643','2014-04-04','18:30:00',1.89),('7643','2014-04-04','18:35:00',1.69),('7643','2014-04-04','18:40:00',1.48),('7643','2014-04-04','18:45:00',1.08),('7643','2013-06-29','06:45:00',1.11),('7643','2013-06-29','06:50:00',1.31),('7643','2013-06-29','06:55:00',1.53),('7643','2013-06-29','07:00:00',1.79),('7643','2013-06-29','07:05:00',2.06),('7643','2013-06-29','07:10:00',2.37),('7643','2013-06-29','07:15:00',2.7),('7643','2013-06-29','07:20:00',2.97),('7643','2013-06-29','07:25:00',3.33),('7643','2013-06-29','07:30:00',3.65),('7643','2013-06-29','07:35:00',4.04),('7643','2013-06-29','07:40:00',4.38),('7643','2013-06-29','07:45:00',4.74),('7643','2013-06-29','07:50:00',5.04),('7643','2013-06-29','07:55:00',5.4),('7643','2013-06-29','08:00:00',5.75),('7643','2013-06-29','08:05:00',6.06),('7643','2013-06-29','08:10:00',6.38),('7643','2013-06-29','08:15:00',6.67),('7643','2013-06-29','08:20:00',6.9),('7643','2013-06-29','08:25:00',7.27),('7643','2013-06-29','08:30:00',7.65),('7643','2013-06-29','08:35:00',8.03),('7643','2013-06-29','08:40:00',8.32),('7643','2013-06-29','08:45:00',8.64),('7643','2013-06-29','08:50:00',8.95),('7643','2013-06-29','08:55:00',9.27),('7643','2013-06-29','09:00:00',9.58),('7643','2013-06-29','09:05:00',9.86),('7643','2013-06-29','09:10:00',10.21),('7643','2013-06-29','09:15:00',10.52),('7643','2013-06-29','09:20:00',10.82),('7643','2013-06-29','09:25:00',11.07),('7643','2013-06-29','09:30:00',11.31),('7643','2013-06-29','09:35:00',11.6),('7643','2013-06-29','09:40:00',11.82),('7643','2013-06-29','09:45:00',12.02),('7643','2013-06-29','09:50:00',12.29),('7643','2013-06-29','09:55:00',12.53),('7643','2013-06-29','10:00:00',12.67),('7643','2013-06-29','10:05:00',12.85),('7643','2013-06-29','10:10:00',13.08),('7643','2013-06-29','10:15:00',13.26),('7643','2013-06-29','10:20:00',13.47),('7643','2013-06-29','10:25:00',13.67),('7643','2013-06-29','10:30:00',13.79),('7643','2013-06-29','10:35:00',13.96),('7643','2013-06-29','10:40:00',14.13),('7643','2013-06-29','10:45:00',14.31),('7643','2013-06-29','10:50:00',14.42),('7643','2013-06-29','10:55:00',14.53),('7643','2013-06-29','11:00:00',14.82),('7643','2013-06-29','11:05:00',14.9),('7643','2013-06-29','11:10:00',14.96),('7643','2013-06-29','11:15:00',14.99),('7643','2013-06-29','11:20:00',15.04),('7643','2013-06-29','11:25:00',15.09),('7643','2013-06-29','11:30:00',15.29),('7643','2013-06-29','11:35:00',15.46),('7643','2013-06-29','11:40:00',15.58),('7643','2013-06-29','11:45:00',15.66),('7643','2013-06-29','11:50:00',15.74),('7643','2013-06-29','11:55:00',15.87),('7643','2013-06-29','12:00:00',15.9),('7643','2013-06-29','12:05:00',15.94),('7643','2013-06-29','12:10:00',16.04),('7643','2013-06-29','12:15:00',16.15),('7643','2013-06-29','12:20:00',16.2),('7643','2013-06-29','12:25:00',16.27),('7643','2013-06-29','12:30:00',16.28),('7643','2013-06-29','12:35:00',16.36),('7643','2013-06-29','12:40:00',16.31),('7643','2013-06-29','12:45:00',16.42),('7643','2013-06-29','12:50:00',16.71),('7643','2013-06-29','12:55:00',16.74),('7643','2013-06-29','13:00:00',16.68),('7643','2013-06-29','13:05:00',16.63),('7643','2013-06-29','13:10:00',16.63),('7643','2013-06-29','13:15:00',16.63),('7643','2013-06-29','13:20:00',16.59),('7643','2013-06-29','13:25:00',16.73),('7643','2013-06-29','13:30:00',16.67),('7643','2013-06-29','13:35:00',16.49),('7643','2013-06-29','13:40:00',16.64),('7643','2013-06-29','13:45:00',16.64),('7643','2013-06-29','13:50:00',16.72),('7643','2013-06-29','13:55:00',16.26),('7643','2013-06-29','14:00:00',16.23),('7643','2013-06-29','14:05:00',16.38),('7643','2013-06-29','14:10:00',16.34),('7643','2013-06-29','14:15:00',16.11),('7643','2013-06-29','14:20:00',16),('7643','2013-06-29','14:25:00',15.81),('7643','2013-06-29','14:30:00',15.7),('7643','2013-06-29','14:35:00',15.58),('7643','2013-06-29','14:40:00',15.63),('7643','2013-06-29','14:45:00',15.52),('7643','2013-06-29','14:50:00',15.45),('7643','2013-06-29','14:55:00',15.41),('7643','2013-06-29','15:00:00',15.22),('7643','2013-06-29','15:05:00',14.93),('7643','2013-06-29','15:10:00',14.93),('7643','2013-06-29','15:15:00',14.86),('7643','2013-06-29','15:20:00',14.89),('7643','2013-06-29','15:25:00',14.64),('7643','2013-06-29','15:30:00',14.4),('7643','2013-06-29','15:35:00',14.37),('7643','2013-06-29','15:40:00',14.23),('7643','2013-06-29','15:45:00',14.16),('7643','2013-06-29','15:50:00',13.98),('7643','2013-06-29','15:55:00',13.61),('7643','2013-06-29','16:00:00',13.45),('7643','2013-06-29','16:05:00',13.3),('7643','2013-06-29','16:10:00',13.2),('7643','2013-06-29','16:15:00',12.95),('7643','2013-06-29','16:20:00',12.85),('7643','2013-06-29','16:25:00',13.14),('7643','2013-06-29','16:30:00',13.26),('7643','2013-06-29','16:35:00',11.97),('7643','2013-06-29','16:40:00',11.19),('7643','2013-06-29','16:45:00',11.1),('7643','2013-06-29','16:50:00',10.8),('7643','2013-06-29','16:55:00',10.45),('7643','2013-06-29','17:00:00',10.1),('7643','2013-06-29','17:05:00',9.84),('7643','2013-06-29','17:10:00',9.61),('7643','2013-06-29','17:15:00',9.18),('7643','2013-06-29','17:20:00',8.78),('7643','2013-06-29','17:25:00',8.41),('7643','2013-06-29','17:30:00',7.99),('7643','2013-06-29','17:35:00',7.54),('7643','2013-06-29','17:40:00',7.49),('7643','2013-06-29','17:45:00',7.22),('7643','2013-06-29','17:50:00',6.98),('7643','2013-06-29','17:55:00',6.62),('7643','2013-06-29','18:00:00',6.29),('7643','2013-06-29','18:05:00',5.79),('7643','2013-06-29','18:10:00',5.62),('7643','2013-06-29','18:15:00',5.41),('7643','2013-06-29','18:20:00',5.12),('7643','2013-06-29','18:25:00',4.77),('7643','2013-06-29','18:30:00',4.42),('7643','2013-06-29','18:35:00',4.1),('7643','2013-06-29','18:40:00',3.87),('7643','2013-06-29','18:45:00',3.5),('7643','2013-06-29','18:50:00',3.12),('7643','2013-06-29','18:55:00',2.82),('7643','2013-06-29','19:00:00',2.49),('7643','2013-06-29','19:05:00',2.25),('7643','2013-06-29','19:10:00',2.11),('7643','2013-06-29','19:15:00',1.86),('7643','2013-06-29','19:20:00',1.57),('7643','2013-06-29','19:25:00',1.38),('7643','2013-06-29','19:30:00',1.2),('7643','2013-06-29','19:35:00',1.03),('7643','2013-06-28','07:20:00',1.76),('7643','2013-06-28','07:25:00',2.75),('7643','2013-06-28','07:30:00',4.2),('7643','2013-06-28','07:35:00',5.26),('7643','2013-06-28','07:40:00',5.55),('7643','2013-06-28','07:45:00',5.58),('7643','2013-06-28','07:50:00',5.77),('7643','2013-06-28','07:55:00',6.36),('7643','2013-06-28','08:00:00',7.21),('7643','2013-06-28','08:05:00',7.81),('7643','2013-06-28','08:10:00',8.19),('7643','2013-06-28','08:15:00',6.86),('7643','2013-06-28','08:20:00',4.76),('7643','2013-06-28','08:25:00',8),('7643','2013-06-28','08:30:00',8.12),('7643','2013-06-28','08:35:00',8.33),('7643','2013-06-28','08:40:00',5.79),('7643','2013-06-28','08:45:00',8.2),('7643','2013-06-28','08:50:00',9.06),('7643','2013-06-28','08:55:00',9.29),('7643','2013-06-28','09:00:00',9.45),('7643','2013-06-28','09:05:00',9.78),('7643','2013-06-28','09:10:00',10.11),('7643','2013-06-28','09:15:00',10.4),('7643','2013-06-28','09:20:00',10.72),('7643','2013-06-28','09:25:00',10.95),('7643','2013-06-28','09:30:00',11.03),('7643','2013-06-28','09:35:00',11.33),('7643','2013-06-28','09:40:00',11.71),('7643','2013-06-28','09:45:00',11.84),('7643','2013-06-28','09:50:00',12.11),('7643','2013-06-28','09:55:00',12.39),('7643','2013-06-28','10:00:00',12.51),('7643','2013-06-28','10:05:00',12.73),('7643','2013-06-28','10:10:00',12.86),('7643','2013-06-28','10:15:00',13.15),('7643','2013-06-28','10:20:00',13.24),('7643','2013-06-28','10:25:00',13.52),('7643','2013-06-28','10:30:00',13.75),('7643','2013-06-28','10:35:00',13.89),('7643','2013-06-28','10:40:00',14.02),('7643','2013-06-28','10:45:00',14.25),('7643','2013-06-28','10:50:00',14.42),('7643','2013-06-28','10:55:00',14.55),('7643','2013-06-28','11:00:00',14.72),('7643','2013-06-28','11:05:00',15.02),('7643','2013-06-28','11:10:00',15.38),('7643','2013-06-28','11:15:00',15.69),('7643','2013-06-28','11:20:00',10.87),('7643','2013-06-28','11:25:00',16.69),('7643','2013-06-28','11:30:00',16.7),('7643','2013-06-28','11:35:00',12.73),('7643','2013-06-28','11:40:00',13.76),('7643','2013-06-28','11:45:00',10.01),('7643','2013-06-28','11:50:00',9.2),('7643','2013-06-28','11:55:00',18.32),('7643','2013-06-28','12:00:00',12.44),('7643','2013-06-28','12:05:00',17.1),('7643','2013-06-28','12:10:00',17.28),('7643','2013-06-28','12:15:00',17.64),('7643','2013-06-28','12:20:00',6.31),('7643','2013-06-28','12:25:00',12.19),('7643','2013-06-28','12:30:00',17.79),('7643','2013-06-28','12:35:00',17.53),('7643','2013-06-28','12:40:00',17.63),('7643','2013-06-28','12:45:00',18.21),('7643','2013-06-28','12:50:00',10.9),('7643','2013-06-28','12:55:00',10.86),('7643','2013-06-28','13:00:00',12.47),('7643','2013-06-28','13:05:00',11.94),('7643','2013-06-28','13:10:00',16.58),('7643','2013-06-28','13:15:00',14.56),('7643','2013-06-28','13:20:00',8.52),('7643','2013-06-28','13:25:00',16.58),('7643','2013-06-28','13:30:00',13.81),('7643','2013-06-28','13:35:00',3.27),('7643','2013-06-28','13:40:00',3.27),('7643','2013-06-28','13:45:00',6.54),('7643','2013-06-28','13:50:00',11.77),('7643','2013-06-28','13:55:00',13.36),('7643','2013-06-28','14:00:00',17.73),('7643','2013-06-28','14:05:00',18.23),('7643','2013-06-28','14:10:00',18.47),('7643','2013-06-28','14:15:00',18.44),('7643','2013-06-28','14:20:00',18.75),('7643','2013-06-28','14:25:00',11.58),('7643','2013-06-28','14:30:00',18.73),('7643','2013-06-28','14:35:00',17.75),('7643','2013-06-28','14:40:00',17.84),('7643','2013-06-28','14:45:00',17.98),('7643','2013-06-28','14:50:00',18.21),('7643','2013-06-28','14:55:00',5),('7643','2013-06-28','15:00:00',9.26),('7643','2013-06-28','15:05:00',9.63),('7643','2013-06-28','15:10:00',6.3),('7643','2013-06-28','15:15:00',5.96),('7643','2013-06-28','15:20:00',3.69),('7643','2013-06-28','15:25:00',2.5),('7643','2013-06-28','15:30:00',2.03),('7643','2013-06-28','15:35:00',2.03),('7643','2013-06-28','15:40:00',2.06),('7643','2013-06-28','15:45:00',1.77),('7643','2013-06-28','16:20:00',1.31),('7643','2013-06-28','16:25:00',1.67),('7643','2013-06-28','16:30:00',2.11),('7643','2013-06-28','16:35:00',2.93),('7643','2013-06-28','16:40:00',4.17),('7643','2013-06-28','16:45:00',5.74),('7643','2013-06-28','16:50:00',9.42),('7643','2013-06-28','16:55:00',6.77),('7643','2013-06-28','17:00:00',3.94),('7643','2013-06-28','17:05:00',4.92),('7643','2013-06-28','17:10:00',4.34),('7643','2013-06-28','17:15:00',3.78),('7643','2013-06-28','17:20:00',4.44),('7643','2013-06-28','17:25:00',5.1),('7643','2013-06-28','17:30:00',9.44),('7643','2013-06-28','17:35:00',9.58),('7643','2013-06-28','17:40:00',3.85),('7643','2013-06-28','17:45:00',6.88),('7643','2013-06-28','17:50:00',7.45),('7643','2013-06-28','17:55:00',7.04),('7643','2013-06-28','18:00:00',6.56),('7643','2013-06-28','18:05:00',6.26),('7643','2013-06-28','18:10:00',5.87),('7643','2013-06-28','18:15:00',5.67),('7643','2013-06-28','18:20:00',5.23),('7643','2013-06-28','18:25:00',4.85),('7643','2013-06-28','18:30:00',4.25),('7643','2013-06-28','18:35:00',4.49),('7643','2013-06-28','18:40:00',4.49),('7643','2013-06-28','18:45:00',2.88),('7643','2013-06-28','18:50:00',1.38),('7643','2013-06-28','18:55:00',1.21),('7643','2013-06-28','19:00:00',1.32),('7643','2013-06-28','19:05:00',1.89),('7643','2013-06-28','19:10:00',2.23),('7643','2013-06-28','19:15:00',1.59),('7643','2013-06-28','19:20:00',1.27),('7643','2013-06-28','19:25:00',1.29),('7643','2013-06-28','19:30:00',1.02),('7643','2013-06-27','06:55:00',1.17),('7643','2013-06-27','07:00:00',1.39),('7643','2013-06-27','07:05:00',1.67),('7643','2013-06-27','07:10:00',2.54),('7643','2013-06-27','07:15:00',2.76),('7643','2013-06-27','07:20:00',2.97),('7643','2013-06-27','07:25:00',3.28),('7643','2013-06-27','07:30:00',3.69),('7643','2013-06-27','07:35:00',3.85),('7643','2013-06-27','07:40:00',3.99),('7643','2013-06-27','07:45:00',4.68),('7643','2013-06-27','07:50:00',5),('7643','2013-06-27','07:55:00',5.3),('7643','2013-06-27','08:00:00',5.47),('7643','2013-06-27','08:05:00',5.36),('7643','2013-06-27','08:10:00',5.47),('7643','2013-06-27','08:15:00',6.24),('7643','2013-06-27','08:20:00',6.58),('7643','2013-06-27','08:25:00',6.37),('7643','2013-06-27','08:30:00',7.11),('7643','2013-06-27','08:35:00',7.57),('7643','2013-06-27','08:40:00',7.87),('7643','2013-06-27','08:45:00',8.14),('7643','2013-06-27','08:50:00',8.54),('7643','2013-06-27','08:55:00',8.8),('7643','2013-06-27','09:00:00',9.04),('7643','2013-06-27','09:05:00',9.58),('7643','2013-06-27','09:10:00',10.27),('7643','2013-06-27','09:15:00',5.34),('7643','2013-06-27','09:20:00',4.18),('7643','2013-06-27','09:25:00',3.38),('7643','2013-06-27','09:30:00',12),('7643','2013-06-27','09:35:00',10.88),('7643','2013-06-27','09:40:00',12.1),('7643','2013-06-27','09:45:00',6.56),('7643','2013-06-27','09:50:00',10.28),('7643','2013-06-27','09:55:00',13.86),('7643','2013-06-27','10:00:00',10.56),('7643','2013-06-27','10:05:00',11.08),('7643','2013-06-27','10:10:00',13.86),('7643','2013-06-27','10:15:00',14.59),('7643','2013-06-27','10:20:00',13.61),('7643','2013-06-27','10:25:00',4.97),('7643','2013-06-27','10:30:00',4.91),('7643','2013-06-27','10:35:00',15.89),('7643','2013-06-27','10:40:00',12.8),('7643','2013-06-27','10:45:00',9.45),('7643','2013-06-27','10:50:00',14.88),('7643','2013-06-27','10:55:00',7.41),('7643','2013-06-27','11:00:00',9.25),('7643','2013-06-27','11:05:00',15.91),('7643','2013-06-27','11:10:00',9.85),('7643','2013-06-27','11:15:00',7.93),('7643','2013-06-27','11:20:00',4.71),('7643','2013-06-27','11:25:00',9.86),('7643','2013-06-27','11:30:00',16.42),('7643','2013-06-27','11:35:00',11.44),('7643','2013-06-27','11:40:00',6.9),('7643','2013-06-27','11:45:00',13.63),('7643','2013-06-27','11:50:00',16.8),('7643','2013-06-27','11:55:00',17.89),('7643','2013-06-27','12:00:00',14.19),('7643','2013-06-27','12:05:00',18.36),('7643','2013-06-27','12:10:00',14.84),('7643','2013-06-27','12:15:00',17.64),('7643','2013-06-27','12:20:00',15.2),('7643','2013-06-27','12:25:00',17.45),('7643','2013-06-27','12:30:00',15.84),('7643','2013-06-27','12:35:00',17.64),('7643','2013-06-27','12:40:00',17.63),('7643','2013-06-27','12:45:00',16.8),('7643','2013-06-27','12:50:00',11.06),('7643','2013-06-27','12:55:00',16.32),('7643','2013-06-27','13:00:00',9.16),('7643','2013-06-27','13:05:00',15.8),('7643','2013-06-27','13:10:00',15.96),('7643','2013-06-27','13:15:00',17.51),('7643','2013-06-27','13:20:00',17.27),('7643','2013-06-27','13:25:00',17.02),('7643','2013-06-27','13:30:00',15.98),('7643','2013-06-27','13:35:00',17.39),('7643','2013-06-27','13:40:00',16.5),('7643','2013-06-27','13:45:00',16.6),('7643','2013-06-27','13:50:00',14.79),('7643','2013-06-27','13:55:00',16.19),('7643','2013-06-27','14:00:00',13.82),('7643','2013-06-27','14:05:00',15.33),('7643','2013-06-27','14:10:00',14.59),('7643','2013-06-27','14:15:00',16.17),('7643','2013-06-27','14:20:00',18.02),('7643','2013-06-27','14:25:00',17.36),('7643','2013-06-27','14:30:00',14.24),('7643','2013-06-27','14:35:00',16.28),('7643','2013-06-27','14:40:00',12.1),('7643','2013-06-27','14:45:00',12.87),('7643','2013-06-27','14:50:00',15.21),('7643','2013-06-27','14:55:00',13.42),('7643','2013-06-27','15:00:00',14.23),('7643','2013-06-27','15:05:00',15.9),('7643','2013-06-27','15:10:00',11.43),('7643','2013-06-27','15:15:00',7.15),('7643','2013-06-27','15:20:00',4.54),('7643','2013-06-27','15:25:00',13.63),('7643','2013-06-27','15:30:00',13.87),('7643','2013-06-27','15:35:00',16.06),('7643','2013-06-27','15:40:00',11.24),('7643','2013-06-27','15:45:00',8.15),('7643','2013-06-27','15:50:00',14.26),('7643','2013-06-27','15:55:00',10.72),('7643','2013-06-27','16:00:00',13.11),('7643','2013-06-27','16:05:00',14.79),('7643','2013-06-27','16:10:00',11.41),('7643','2013-06-27','16:15:00',12.81),('7643','2013-06-27','16:20:00',7.87),('7643','2013-06-27','16:25:00',6.3),('7643','2013-06-27','16:30:00',5.9),('7643','2013-06-27','16:35:00',7.52),('7643','2013-06-27','16:40:00',5.81),('7643','2013-06-27','16:45:00',3),('7643','2013-06-27','16:50:00',4.31),('7643','2013-06-27','16:55:00',5.29),('7643','2013-06-27','17:00:00',10.69),('7643','2013-06-27','17:05:00',10.16),('7643','2013-06-27','17:10:00',9.7),('7643','2013-06-27','17:15:00',8.56),('7643','2013-06-27','17:20:00',8.71),('7643','2013-06-27','17:25:00',8.69),('7643','2013-06-27','17:30:00',7.94),('7643','2013-06-27','17:35:00',7.81),('7643','2013-06-27','17:40:00',7.52),('7643','2013-06-27','17:45:00',7.37),('7643','2013-06-27','17:50:00',7.12),('7643','2013-06-27','17:55:00',6.72),('7643','2013-06-27','18:00:00',6.39),('7643','2013-06-27','18:05:00',5.98),('7643','2013-06-27','18:10:00',5.69),('7643','2013-06-27','18:15:00',5.65),('7643','2013-06-27','18:20:00',5.41),('7643','2013-06-27','18:25:00',5.08),('7643','2013-06-27','18:30:00',4.58),('7643','2013-06-27','18:35:00',4.18),('7643','2013-06-27','18:40:00',3.81),('7643','2013-06-27','18:45:00',3.61),('7643','2013-06-27','18:50:00',3.1),('7643','2013-06-27','18:55:00',2.72),('7643','2013-06-27','19:00:00',2.48),('7643','2013-06-27','19:05:00',2.2),('7643','2013-06-27','19:10:00',1.81),('7643','2013-06-27','19:15:00',1.22),('7643','2013-06-27','19:20:00',1.43),('7643','2013-06-27','19:25:00',1.55),('7643','2013-06-27','19:30:00',1.18),('7643','2013-06-27','19:35:00',1.02),('7643','2013-06-27','19:40:00',1.08),('7643','2013-06-27','19:45:00',1.11),('7643','2013-06-26','07:25:00',2.26),('7643','2013-06-26','07:30:00',3.33),('7643','2013-06-26','07:35:00',3.81),('7643','2013-06-26','07:40:00',4.08),('7643','2013-06-26','07:45:00',4.43),('7643','2013-06-26','07:50:00',4.88),('7643','2013-06-26','07:55:00',5.3),('7643','2013-06-26','08:00:00',5.57),('7643','2013-06-26','08:05:00',5.86),('7643','2013-06-26','08:10:00',6.23),('7643','2013-06-26','08:15:00',6.43),('7643','2013-06-26','08:20:00',6.75),('7643','2013-06-26','08:25:00',7.02),('7643','2013-06-26','08:30:00',7.32),('7643','2013-06-26','08:35:00',7.62),('7643','2013-06-26','08:40:00',7.9),('7643','2013-06-26','08:45:00',8.25),('7643','2013-06-26','08:50:00',8.58),('7643','2013-06-26','08:55:00',9.02),('7643','2013-06-26','09:00:00',9.44),('7643','2013-06-26','09:05:00',9.7),('7643','2013-06-26','09:10:00',10.03),('7643','2013-06-26','09:15:00',10.37),('7643','2013-06-26','09:20:00',10.79),('7643','2013-06-26','09:25:00',10.9),('7643','2013-06-26','09:30:00',11.2),('7643','2013-06-26','09:35:00',11.47),('7643','2013-06-26','09:40:00',11.66),('7643','2013-06-26','09:45:00',11.83),('7643','2013-06-26','09:50:00',12.23),('7643','2013-06-26','09:55:00',12.62),('7643','2013-06-26','10:00:00',13.01),('7643','2013-06-26','10:05:00',13.43),('7643','2013-06-26','10:10:00',13.1),('7643','2013-06-26','10:15:00',13.46),('7643','2013-06-26','10:20:00',13.52),('7643','2013-06-26','10:25:00',13.5),('7643','2013-06-26','10:30:00',13.77),('7643','2013-06-26','10:35:00',14.15),('7643','2013-06-26','10:40:00',14.72),('7643','2013-06-26','10:45:00',15),('7643','2013-06-26','10:50:00',14.98),('7643','2013-06-26','10:55:00',15.03),('7643','2013-06-26','11:00:00',14.99),('7643','2013-06-26','11:05:00',15.3),('7643','2013-06-26','11:10:00',10.89),('7643','2013-06-26','11:15:00',15.34),('7643','2013-06-26','11:20:00',15.88),('7643','2013-06-26','11:25:00',15.65),('7643','2013-06-26','11:30:00',15.66),('7643','2013-06-26','11:35:00',16.15),('7643','2013-06-26','11:40:00',16.55),('7643','2013-06-26','11:45:00',7.22),('7643','2013-06-26','11:50:00',4.64),('7643','2013-06-26','11:55:00',5.69),('7643','2013-06-26','12:00:00',8.05),('7643','2013-06-26','12:05:00',4.79),('7643','2013-06-26','12:10:00',5.02),('7643','2013-06-26','12:15:00',4.33),('7643','2013-06-26','12:20:00',4.53),('7643','2013-06-26','12:25:00',5.66),('7643','2013-06-26','12:30:00',5.79),('7643','2013-06-26','12:35:00',8.19),('7643','2013-06-26','12:40:00',8.16),('7643','2013-06-26','12:45:00',9.55),('7643','2013-06-26','12:50:00',6.33),('7643','2013-06-26','12:55:00',5.06),('7643','2013-06-26','13:00:00',3.51),('7643','2013-06-26','13:05:00',3.78),('7643','2013-06-26','13:10:00',4.72),('7643','2013-06-26','13:15:00',5.33),('7643','2013-06-26','13:20:00',5.44),('7643','2013-06-26','13:25:00',5.78),('7643','2013-06-26','13:30:00',5.14),('7643','2013-06-26','13:35:00',5.25),('7643','2013-06-26','13:40:00',4.29),('7643','2013-06-26','13:45:00',4.15),('7643','2013-06-26','13:50:00',4.5),('7643','2013-06-26','13:55:00',4.48),('7643','2013-06-26','14:00:00',4.92),('7643','2013-06-26','14:05:00',5.03),('7643','2013-06-26','14:10:00',7.93),('7643','2013-06-26','14:15:00',12.04),('7643','2013-06-26','14:20:00',7.59),('7643','2013-06-26','14:25:00',9),('7643','2013-06-26','14:30:00',15.7),('7643','2013-06-26','14:35:00',11.27),('7643','2013-06-26','14:40:00',8.23),('7643','2013-06-26','14:45:00',5.53),('7643','2013-06-26','14:50:00',6.46),('7643','2013-06-26','14:55:00',16.01),('7643','2013-06-26','15:00:00',15.4),('7643','2013-06-26','15:05:00',14.9),('7643','2013-06-26','15:10:00',14.6),('7643','2013-06-26','15:15:00',14.48),('7643','2013-06-26','15:20:00',14.31),('7643','2013-06-26','15:25:00',14.44),('7643','2013-06-26','15:30:00',14.18),('7643','2013-06-26','15:35:00',14.07),('7643','2013-06-26','15:40:00',13.85),('7643','2013-06-26','15:45:00',13.64),('7643','2013-06-26','15:50:00',13.46),('7643','2013-06-26','15:55:00',13.26),('7643','2013-06-26','16:00:00',12.85),('7643','2013-06-26','16:05:00',12.53),('7643','2013-06-26','16:10:00',12.34),('7643','2013-06-26','16:15:00',12.14),('7643','2013-06-26','16:20:00',11.95),('7643','2013-06-26','16:25:00',11.76),('7643','2013-06-26','16:30:00',11.57),('7643','2013-06-26','16:35:00',10.73),('7643','2013-06-26','16:40:00',10.64),('7643','2013-06-26','16:45:00',10.72),('7643','2013-06-26','16:50:00',10.3),('7643','2013-06-26','16:55:00',10.06),('7643','2013-06-26','17:00:00',9.87),('7643','2013-06-26','17:05:00',9.52),('7643','2013-06-26','17:10:00',8.96),('7643','2013-06-26','17:15:00',8.52),('7643','2013-06-26','17:20:00',8.69),('7643','2013-06-26','17:25:00',8.39),('7643','2013-06-26','17:30:00',8.2),('7643','2013-06-26','17:35:00',7.87),('7643','2013-06-26','17:40:00',5.18),('7643','2013-06-26','17:45:00',2.85),('7643','2013-06-26','17:50:00',6.57),('7643','2013-06-26','17:55:00',6.47),('7643','2013-06-26','18:00:00',6.06),('7643','2013-06-26','18:05:00',5.69),('7643','2013-06-26','18:10:00',5.31),('7643','2013-06-26','18:15:00',5.03),('7643','2013-06-26','18:20:00',4.78),('7643','2013-06-26','18:25:00',4.75),('7643','2013-06-26','18:30:00',4.44),('7643','2013-06-26','18:35:00',4.11),('7643','2013-06-26','18:40:00',3.57),('7643','2013-06-26','18:45:00',3.25),('7643','2013-06-26','18:50:00',2.99),('7643','2013-06-26','18:55:00',2.74),('7643','2013-06-26','19:00:00',2.45),('7643','2013-06-26','19:05:00',2.14),('7643','2013-06-26','19:10:00',1.91),('7643','2013-06-26','19:15:00',1.71),('7643','2013-06-26','19:20:00',1.44),('7643','2013-06-26','19:25:00',1.05),('7643','2013-06-25','06:45:00',1.08),('7643','2013-06-25','06:50:00',1.28),('7643','2013-06-25','06:55:00',1.54),('7643','2013-06-25','07:00:00',1.77),('7643','2013-06-25','07:05:00',2.05),('7643','2013-06-25','07:10:00',2.35),('7643','2013-06-25','07:15:00',2.65),('7643','2013-06-25','07:20:00',2.96),('7643','2013-06-25','07:25:00',3.26),('7643','2013-06-25','07:30:00',3.59),('7643','2013-06-25','07:35:00',3.97),('7643','2013-06-25','07:40:00',4.28),('7643','2013-06-25','07:45:00',4.66),('7643','2013-06-25','07:50:00',5.02),('7643','2013-06-25','07:55:00',5.28),('7643','2013-06-25','08:00:00',5.52),('7643','2013-06-25','08:05:00',5.81),('7643','2013-06-25','08:10:00',6.18),('7643','2013-06-25','08:15:00',6.45),('7643','2013-06-25','08:20:00',6.64),('7643','2013-06-25','08:25:00',7.02),('7643','2013-06-25','08:30:00',7.34),('7643','2013-06-25','08:35:00',7.66),('7643','2013-06-25','08:40:00',7.93),('7643','2013-06-25','08:45:00',8.26),('7643','2013-06-25','08:50:00',8.54),('7643','2013-06-25','08:55:00',8.82),('7643','2013-06-25','09:00:00',9.09),('7643','2013-06-25','09:05:00',9.42),('7643','2013-06-25','09:10:00',9.7),('7643','2013-06-25','09:15:00',10),('7643','2013-06-25','09:20:00',10.26),('7643','2013-06-25','09:25:00',10.64),('7643','2013-06-25','09:30:00',10.92),('7643','2013-06-25','09:35:00',11.14),('7643','2013-06-25','09:40:00',11.35),('7643','2013-06-25','09:45:00',11.57),('7643','2013-06-25','09:50:00',11.63),('7643','2013-06-25','09:55:00',11.87),('7643','2013-06-25','10:00:00',12.12),('7643','2013-06-25','10:05:00',12.39),('7643','2013-06-25','10:10:00',12.5),('7643','2013-06-25','10:15:00',12.72),('7643','2013-06-25','10:20:00',12.98),('7643','2013-06-25','10:25:00',13.13),('7643','2013-06-25','10:30:00',13.27),('7643','2013-06-25','10:35:00',13.51),('7643','2013-06-25','10:40:00',13.73),('7643','2013-06-25','10:45:00',13.82),('7643','2013-06-25','10:50:00',13.93),('7643','2013-06-25','10:55:00',14.07),('7643','2013-06-25','11:00:00',14.27),('7643','2013-06-25','11:05:00',14.36),('7643','2013-06-25','11:10:00',14.48),('7643','2013-06-25','11:15:00',14.53),('7643','2013-06-25','11:20:00',14.61),('7643','2013-06-25','11:25:00',14.76),('7643','2013-06-25','11:30:00',14.88),('7643','2013-06-25','11:35:00',14.99),('7643','2013-06-25','11:40:00',15.12),('7643','2013-06-25','11:45:00',15.33),('7643','2013-06-25','11:50:00',15.42),('7643','2013-06-25','11:55:00',15.53),('7643','2013-06-25','12:00:00',15.41),('7643','2013-06-25','12:05:00',15.29),('7643','2013-06-25','12:10:00',15.52),('7643','2013-06-25','12:15:00',15.74),('7643','2013-06-25','12:20:00',15.63),('7643','2013-06-25','12:25:00',15.45),('7643','2013-06-25','12:30:00',15.2),('7643','2013-06-25','12:35:00',12.46),('7643','2013-06-25','12:40:00',16),('7643','2013-06-25','12:45:00',16.73),('7643','2013-06-25','12:50:00',16.24),('7643','2013-06-25','12:55:00',15.24),('7643','2013-06-25','13:00:00',3.57),('7643','2013-06-25','13:05:00',9.11),('7643','2013-06-25','13:10:00',12.74),('7643','2013-06-25','13:15:00',17.52),('7643','2013-06-25','13:20:00',17.12),('7643','2013-06-25','13:25:00',15.57),('7643','2013-06-25','13:30:00',6.89),('7643','2013-06-25','13:35:00',3.57),('7643','2013-06-25','13:40:00',3.59),('7643','2013-06-25','13:45:00',4.07),('7643','2013-06-25','13:50:00',4.45),('7643','2013-06-25','13:55:00',6.1),('7643','2013-06-25','14:00:00',9.89),('7643','2013-06-25','14:05:00',15.61),('7643','2013-06-25','14:10:00',5.19),('7643','2013-06-25','14:15:00',9.23),('7643','2013-06-25','14:20:00',16.45),('7643','2013-06-25','14:25:00',9.37),('7643','2013-06-25','14:30:00',9.02),('7643','2013-06-25','14:35:00',6.16),('7643','2013-06-25','14:40:00',4.9),('7643','2013-06-25','14:45:00',9.92),('7643','2013-06-25','14:50:00',15.45),('7643','2013-06-25','14:55:00',16.74),('7643','2013-06-25','15:00:00',15.51),('7643','2013-06-25','15:05:00',15.18),('7643','2013-06-25','15:10:00',14.82),('7643','2013-06-25','15:15:00',14.58),('7643','2013-06-25','15:20:00',14.3),('7643','2013-06-25','15:25:00',14.16),('7643','2013-06-25','15:30:00',14.04),('7643','2013-06-25','15:35:00',14.29),('7643','2013-06-25','15:40:00',13.84),('7643','2013-06-25','15:45:00',13.5),('7643','2013-06-25','15:50:00',8.56),('7643','2013-06-25','15:55:00',13.37),('7643','2013-06-25','16:00:00',13.33),('7643','2013-06-25','16:05:00',12.92),('7643','2013-06-25','16:10:00',12.78),('7643','2013-06-25','16:15:00',12.56),('7643','2013-06-25','16:20:00',12.19),('7643','2013-06-25','16:25:00',11.95),('7643','2013-06-25','16:30:00',11.7),('7643','2013-06-25','16:35:00',11.49),('7643','2013-06-25','16:40:00',11.02),('7643','2013-06-25','16:45:00',10.78),('7643','2013-06-25','16:50:00',10.53),('7643','2013-06-25','16:55:00',10.23),('7643','2013-06-25','17:00:00',10.04),('7643','2013-06-25','17:05:00',9.82),('7643','2013-06-25','17:10:00',9.49),('7643','2013-06-25','17:15:00',9.02),('7643','2013-06-25','17:20:00',8.61),('7643','2013-06-25','17:25:00',8.31),('7643','2013-06-25','17:30:00',8.03),('7643','2013-06-25','17:35:00',7.74),('7643','2013-06-25','17:40:00',7.49),('7643','2013-06-25','17:45:00',7.17),('7643','2013-06-25','17:50:00',6.84),('7643','2013-06-25','17:55:00',6.51),('7643','2013-06-25','18:00:00',6.27),('7643','2013-06-25','18:05:00',6.42),('7643','2013-06-25','18:10:00',6.66),('7643','2013-06-25','18:15:00',2.83),('7643','2013-06-25','18:20:00',2.95),('7643','2013-06-25','18:25:00',2.87),('7643','2013-06-25','18:30:00',1.75),('7643','2013-06-25','18:35:00',1.51),('7643','2013-06-25','18:40:00',1.29),('7643','2013-06-25','18:45:00',1.13),('7643','2013-06-25','18:50:00',1.19),('7643','2013-06-25','18:55:00',1.25),('7643','2013-06-25','19:00:00',2.06),('7643','2013-06-25','19:05:00',1.54),('7643','2013-06-25','19:10:00',1.74),('7643','2013-06-25','19:15:00',2.06),('7643','2013-06-25','19:20:00',2.15),('7643','2013-06-25','19:25:00',1.88),('7643','2013-06-25','19:30:00',1.35),('7643','2013-06-25','19:35:00',1),('7643','2013-06-24','06:40:00',1.02),('7643','2013-06-24','06:45:00',1.2),('7643','2013-06-24','06:50:00',1.36),('7643','2013-06-24','06:55:00',1.54),('7643','2013-06-24','07:00:00',1.78),('7643','2013-06-24','07:05:00',2.04),('7643','2013-06-24','07:10:00',2.36),('7643','2013-06-24','07:15:00',2.62),('7643','2013-06-24','07:20:00',2.91),('7643','2013-06-24','07:25:00',3.13),('7643','2013-06-24','07:30:00',3.49),('7643','2013-06-24','07:35:00',3.89),('7643','2013-06-24','07:40:00',4.26),('7643','2013-06-24','07:45:00',4.62),('7643','2013-06-24','07:50:00',3.96),('7643','2013-06-24','07:55:00',5.62),('7643','2013-06-24','08:00:00',6.02),('7643','2013-06-24','08:05:00',6.85),('7643','2013-06-24','08:10:00',6.32),('7643','2013-06-24','08:15:00',4),('7643','2013-06-24','08:20:00',3.22),('7643','2013-06-24','08:25:00',6.93),('7643','2013-06-24','08:30:00',7.5),('7643','2013-06-24','08:35:00',7.82),('7643','2013-06-24','08:40:00',8.19),('7643','2013-06-24','08:45:00',8.53),('7643','2013-06-24','08:50:00',8.67),('7643','2013-06-24','08:55:00',8.99),('7643','2013-06-24','09:00:00',9.47),('7643','2013-06-24','09:05:00',9.79),('7643','2013-06-24','09:10:00',10.04),('7643','2013-06-24','09:15:00',10.4),('7643','2013-06-24','09:20:00',10.7),('7643','2013-06-24','09:25:00',10.99),('7643','2013-06-24','09:30:00',11.04),('7643','2013-06-24','09:35:00',10.29),('7643','2013-06-24','09:40:00',2.64),('7643','2013-06-24','09:45:00',2.8),('7643','2013-06-24','09:50:00',12.52),('7643','2013-06-24','09:55:00',13.56),('7643','2013-06-24','10:00:00',6.64),('7643','2013-06-24','10:05:00',13.99),('7643','2013-06-24','10:10:00',12.75),('7643','2013-06-24','10:15:00',14.6),('7643','2013-06-24','10:20:00',13.85),('7643','2013-06-24','10:25:00',9.96),('7643','2013-06-24','10:30:00',14.76),('7643','2013-06-24','10:35:00',15.06),('7643','2013-06-24','10:40:00',15.35),('7643','2013-06-24','10:45:00',14.84),('7643','2013-06-24','10:50:00',15.1),('7643','2013-06-24','10:55:00',14.96),('7643','2013-06-24','11:00:00',15.55),('7643','2013-06-24','11:05:00',16.33),('7643','2013-06-24','11:10:00',16.54),('7643','2013-06-24','11:15:00',14.5),('7643','2013-06-24','11:20:00',7.87),('7643','2013-06-24','11:25:00',8.86),('7643','2013-06-24','11:30:00',9.76),('7643','2013-06-24','11:35:00',18.34),('7643','2013-06-24','11:40:00',17.53),('7643','2013-06-24','11:45:00',17.32),('7643','2013-06-24','11:50:00',17.36),('7643','2013-06-24','11:55:00',16.75),('7643','2013-06-24','12:00:00',13.14),('7643','2013-06-24','12:05:00',5.34),('7643','2013-06-24','12:10:00',5.3),('7643','2013-06-24','12:15:00',4.74),('7643','2013-06-24','12:20:00',4.33),('7643','2013-06-24','12:25:00',3.83),('7643','2013-06-24','12:30:00',3.65),('7643','2013-06-24','12:35:00',4.08),('7643','2013-06-24','12:40:00',6.08),('7643','2013-06-24','12:45:00',5.42),('7643','2013-06-24','12:50:00',5.13),('7643','2013-06-24','12:55:00',6.41),('7643','2013-06-24','13:00:00',16.85),('7643','2013-06-24','13:05:00',16.39),('7643','2013-06-24','13:10:00',15.93),('7643','2013-06-24','13:15:00',17.33),('7643','2013-06-24','13:20:00',17.37),('7643','2013-06-24','13:25:00',17.2),('7643','2013-06-24','13:30:00',12.91),('7643','2013-06-24','13:35:00',15.19),('7643','2013-06-24','13:40:00',16.44),('7643','2013-06-24','13:45:00',12.88),('7643','2013-06-24','13:50:00',13.01),('7643','2013-06-24','13:55:00',8),('7643','2013-06-24','14:00:00',13.83),('7643','2013-06-24','14:05:00',17.77),('7643','2013-06-24','14:10:00',14.93),('7643','2013-06-24','14:15:00',15.22),('7643','2013-06-24','14:20:00',17.01),('7643','2013-06-24','14:25:00',16.51),('7643','2013-06-24','14:30:00',15.63),('7643','2013-06-24','14:35:00',15.93),('7643','2013-06-24','14:40:00',13.9),('7643','2013-06-24','14:45:00',16.01),('7643','2013-06-24','14:50:00',15.79),('7643','2013-06-24','14:55:00',15.7),('7643','2013-06-24','15:00:00',15.37),('7643','2013-06-24','15:05:00',15.06),('7643','2013-06-24','15:10:00',15.06),('7643','2013-06-24','15:15:00',15.15),('7643','2013-06-24','15:20:00',14.82),('7643','2013-06-24','15:25:00',14.48),('7643','2013-06-24','15:30:00',14.2),('7643','2013-06-24','15:35:00',13.95),('7643','2013-06-24','15:40:00',13.75),('7643','2013-06-24','15:45:00',13.46),('7643','2013-06-24','15:50:00',13.3),('7643','2013-06-24','15:55:00',13.08),('7643','2013-06-24','16:00:00',12.97),('7643','2013-06-24','16:05:00',12.78),('7643','2013-06-24','16:10:00',12.55),('7643','2013-06-24','16:15:00',12.33),('7643','2013-06-24','16:20:00',12),('7643','2013-06-24','16:25:00',11.72),('7643','2013-06-24','16:30:00',11.47),('7643','2013-06-24','16:35:00',11.23),('7643','2013-06-24','16:40:00',10.97),('7643','2013-06-24','16:45:00',10.75),('7643','2013-06-24','16:50:00',10.43),('7643','2013-06-24','16:55:00',10.2),('7643','2013-06-24','17:00:00',9.92),('7643','2013-06-24','17:05:00',9.65),('7643','2013-06-24','17:10:00',9.3),('7643','2013-06-24','17:15:00',8.97),('7643','2013-06-24','17:20:00',8.6),('7643','2013-06-24','17:25:00',8.32),('7643','2013-06-24','17:30:00',8),('7643','2013-06-24','17:35:00',7.64),('7643','2013-06-24','17:40:00',7.43),('7643','2013-06-24','17:45:00',7.09),('7643','2013-06-24','17:50:00',6.79),('7643','2013-06-24','17:55:00',6.51),('7643','2013-06-24','18:00:00',6.18),('7643','2013-06-24','18:05:00',5.79),('7643','2013-06-24','18:10:00',5.51),('7643','2013-06-24','18:15:00',5.18),('7643','2013-06-24','18:20:00',4.91),('7643','2013-06-24','18:25:00',4.6),('7643','2013-06-24','18:30:00',4.31),('7643','2013-06-24','18:35:00',4.04),('7643','2013-06-24','18:40:00',3.73),('7643','2013-06-24','18:45:00',3.34),('7643','2013-06-24','18:50:00',2.95),('7643','2013-06-24','18:55:00',2.65),('7643','2013-06-24','19:00:00',2.43),('7643','2013-06-24','19:05:00',2.14),('7643','2013-06-24','19:10:00',1.96),('7643','2013-06-24','19:15:00',1.72),('7643','2013-06-24','19:20:00',1.47),('7643','2013-06-24','19:25:00',1.3),('7643','2013-06-24','19:30:00',1.12),('7643','2013-06-23','07:00:00',1.06),('7643','2013-06-23','07:05:00',1.57),('7643','2013-06-23','07:10:00',2.96),('7643','2013-06-23','07:15:00',1.35),('7643','2013-06-23','07:20:00',1.57),('7643','2013-06-23','07:25:00',2.78),('7643','2013-06-23','07:30:00',2.54),('7643','2013-06-23','07:35:00',1.62),('7643','2013-06-23','07:40:00',1.91),('7643','2013-06-23','07:45:00',1.18),('7643','2013-06-23','07:50:00',2.92),('7643','2013-06-23','07:55:00',2.44),('7643','2013-06-23','08:15:00',1.16),('7643','2013-06-23','08:20:00',1.64),('7643','2013-06-23','08:25:00',1.28),('7643','2013-06-23','08:30:00',1.53),('7643','2013-06-23','08:35:00',2.9),('7643','2013-06-23','08:40:00',3.9),('7643','2013-06-23','08:45:00',9.25),('7643','2013-06-23','08:50:00',9.54),('7643','2013-06-23','08:55:00',9.88),('7643','2013-06-23','09:00:00',8.54),('7643','2013-06-23','09:05:00',10.55),('7643','2013-06-23','09:10:00',7.19),('7643','2013-06-23','09:15:00',10.69),('7643','2013-06-23','09:20:00',11.98),('7643','2013-06-23','09:25:00',11.61),('7643','2013-06-23','09:30:00',13.87),('7643','2013-06-23','09:35:00',8.65),('7643','2013-06-23','09:40:00',4.85),('7643','2013-06-23','09:45:00',10.8),('7643','2013-06-23','09:50:00',13.12),('7643','2013-06-23','09:55:00',12.95),('7643','2013-06-23','10:00:00',13.18),('7643','2013-06-23','10:05:00',13.38),('7643','2013-06-23','10:10:00',12.84),('7643','2013-06-23','10:15:00',12.47),('7643','2013-06-23','10:20:00',10.68),('7643','2013-06-23','10:25:00',15.41),('7643','2013-06-23','10:30:00',14.87),('7643','2013-06-23','10:35:00',15.63),('7643','2013-06-23','10:40:00',11.94),('7643','2013-06-23','10:45:00',8.06),('7643','2013-06-23','10:50:00',16.17),('7643','2013-06-23','10:55:00',7.96),('7643','2013-06-23','11:00:00',17.5),('7643','2013-06-23','11:05:00',16.51),('7643','2013-06-23','11:10:00',6.42),('7643','2013-06-23','11:15:00',9.09),('7643','2013-06-23','11:20:00',16.58),('7643','2013-06-23','11:25:00',5.59),('7643','2013-06-23','11:30:00',9.26),('7643','2013-06-23','11:35:00',5.46),('7643','2013-06-23','11:40:00',4.93),('7643','2013-06-23','11:45:00',6.04),('7643','2013-06-23','11:50:00',11.28),('7643','2013-06-23','11:55:00',8.18),('7643','2013-06-23','12:00:00',14.99),('7643','2013-06-23','12:05:00',16.32),('7643','2013-06-23','12:10:00',11.09),('7643','2013-06-23','12:15:00',11.67),('7643','2013-06-23','12:20:00',16.72),('7643','2013-06-23','12:25:00',19.37),('7643','2013-06-23','12:30:00',12.37),('7643','2013-06-23','12:35:00',14.93),('7643','2013-06-23','12:40:00',16.26),('7643','2013-06-23','12:45:00',11.89),('7643','2013-06-23','12:50:00',14.98),('7643','2013-06-23','12:55:00',17.03),('7643','2013-06-23','13:00:00',11.66),('7643','2013-06-23','13:05:00',15.68),('7643','2013-06-23','13:10:00',15.78),('7643','2013-06-23','13:15:00',13.09),('7643','2013-06-23','13:20:00',11.48),('7643','2013-06-23','13:25:00',11.99),('7643','2013-06-23','13:30:00',17.31),('7643','2013-06-23','13:35:00',16.25),('7643','2013-06-23','13:40:00',16.35),('7643','2013-06-23','13:45:00',14.31),('7643','2013-06-23','13:50:00',17.58),('7643','2013-06-23','13:55:00',17.14),('7643','2013-06-23','14:00:00',16.85),('7643','2013-06-23','14:05:00',16.99),('7643','2013-06-23','14:10:00',16.94),('7643','2013-06-23','14:15:00',16.87),('7643','2013-06-23','14:20:00',16.79),('7643','2013-06-23','14:25:00',16.76),('7643','2013-06-23','14:30:00',15.09),('7643','2013-06-23','14:35:00',16.85),('7643','2013-06-23','14:40:00',16.82),('7643','2013-06-23','14:45:00',16.48),('7643','2013-06-23','14:50:00',12.72),('7643','2013-06-23','14:55:00',14.37),('7643','2013-06-23','15:00:00',11.97),('7643','2013-06-23','15:05:00',10.67),('7643','2013-06-23','15:10:00',12.14),('7643','2013-06-23','15:15:00',14.82),('7643','2013-06-23','15:20:00',12.74),('7643','2013-06-23','15:25:00',11.86),('7643','2013-06-23','15:30:00',11.18),('7643','2013-06-23','15:35:00',11.84),('7643','2013-06-23','15:40:00',6.52),('7643','2013-06-23','15:45:00',15.81),('7643','2013-06-23','15:50:00',12.34),('7643','2013-06-23','15:55:00',14.5),('7643','2013-06-23','16:00:00',15.67),('7643','2013-06-23','16:05:00',12.97),('7643','2013-06-23','16:10:00',15.08),('7643','2013-06-23','16:15:00',14.34),('7643','2013-06-23','16:20:00',9.99),('7643','2013-06-23','16:25:00',7.61),('7643','2013-06-23','16:30:00',7.38),('7643','2013-06-23','16:35:00',11.14),('7643','2013-06-23','16:40:00',9.57),('7643','2013-06-23','16:45:00',7.5),('7643','2013-06-23','16:50:00',6.42),('7643','2013-06-23','16:55:00',5.03),('7643','2013-06-23','17:00:00',4.16),('7643','2013-06-23','17:05:00',8.42),('7643','2013-06-23','17:10:00',4.59),('7643','2013-06-23','17:15:00',11.21),('7643','2013-06-23','17:20:00',7.16),('7643','2013-06-23','17:25:00',6.87),('7643','2013-06-23','17:30:00',4.86),('7643','2013-06-23','17:35:00',3.56),('7643','2013-06-23','17:40:00',3.07),('7643','2013-06-23','17:45:00',2.94),('7643','2013-06-23','17:50:00',4.67),('7643','2013-06-23','17:55:00',4.25),('7643','2013-06-23','18:00:00',7.46),('7643','2013-06-23','18:05:00',7.25),('7643','2013-06-23','18:10:00',6.41),('7643','2013-06-23','18:15:00',5.21),('7643','2013-06-23','18:20:00',5.57),('7643','2013-06-23','18:25:00',3.63),('7643','2013-06-23','18:30:00',4.06),('7643','2013-06-23','18:35:00',4.57),('7643','2013-06-23','18:40:00',2.86),('7643','2013-06-23','18:45:00',3.81),('7643','2013-06-23','18:50:00',3.33),('7643','2013-06-23','18:55:00',2.76),('7643','2013-06-23','19:00:00',2.58),('7643','2013-06-23','19:05:00',2.42),('7643','2013-06-23','19:10:00',2.27),('7643','2013-06-23','19:15:00',2),('7643','2013-06-23','19:20:00',1.6),('7643','2013-06-23','19:25:00',1.43),('7643','2013-06-23','19:30:00',1.3),('7643','2013-06-23','19:35:00',1.09),('7643','2013-06-22','07:30:00',1.41),('7643','2013-06-22','07:35:00',1.54),('7643','2013-06-22','07:40:00',1.41),('7643','2013-06-22','07:45:00',1.04),('7643','2013-06-22','07:50:00',1.01),('7643','2013-06-22','07:55:00',1.04),('7643','2013-06-22','08:25:00',1.13),('7643','2013-06-22','08:30:00',1.74),('7643','2013-06-22','08:35:00',2.24),('7643','2013-06-22','08:40:00',2.68),('7643','2013-06-22','08:45:00',3.89),('7643','2013-06-22','08:50:00',5.6),('7643','2013-06-22','08:55:00',3.8),('7643','2013-06-22','09:00:00',6.35),('7643','2013-06-22','09:05:00',6.34),('7643','2013-06-22','09:10:00',2.1),('7643','2013-06-22','09:15:00',2.75),('7643','2013-06-22','09:20:00',6.6),('7643','2013-06-22','09:25:00',9.86),('7643','2013-06-22','09:30:00',11.03),('7643','2013-06-22','09:35:00',11.58),('7643','2013-06-22','09:40:00',12.74),('7643','2013-06-22','09:45:00',8.47),('7643','2013-06-22','09:50:00',4.4),('7643','2013-06-22','09:55:00',6.84),('7643','2013-06-22','10:00:00',13.8),('7643','2013-06-22','10:05:00',12.49),('7643','2013-06-22','10:10:00',13.77),('7643','2013-06-22','10:15:00',11.83),('7643','2013-06-22','10:20:00',7.05),('7643','2013-06-22','10:25:00',9.39),('7643','2013-06-22','10:30:00',5.58),('7643','2013-06-22','10:35:00',11.8),('7643','2013-06-22','10:40:00',14.75),('7643','2013-06-22','10:45:00',13.81),('7643','2013-06-22','10:50:00',13.76),('7643','2013-06-22','10:55:00',13.87),('7643','2013-06-22','11:00:00',14.15),('7643','2013-06-22','11:05:00',14.26),('7643','2013-06-22','11:10:00',14.45),('7643','2013-06-22','11:15:00',14.45),('7643','2013-06-22','11:20:00',14.9),('7643','2013-06-22','11:25:00',14.88),('7643','2013-06-22','11:30:00',14.73),('7643','2013-06-22','11:35:00',14.45),('7643','2013-06-22','11:40:00',14.78),('7643','2013-06-22','11:45:00',15.01),('7643','2013-06-22','11:50:00',15.48),('7643','2013-06-22','11:55:00',15.24),('7643','2013-06-22','12:00:00',15.35),('7643','2013-06-22','12:05:00',16.1),('7643','2013-06-22','12:10:00',15.89),('7643','2013-06-22','12:15:00',15.85),('7643','2013-06-22','12:20:00',16.13),('7643','2013-06-22','12:25:00',16.36),('7643','2013-06-22','12:30:00',16.29),('7643','2013-06-22','12:35:00',16.16),('7643','2013-06-22','12:40:00',16.18),('7643','2013-06-22','12:45:00',16.22),('7643','2013-06-22','12:50:00',16.27),('7643','2013-06-22','12:55:00',16.43),('7643','2013-06-22','13:00:00',16.47),('7643','2013-06-22','13:05:00',16.46),('7643','2013-06-22','13:10:00',16.43),('7643','2013-06-22','13:15:00',16.37),('7643','2013-06-22','13:20:00',16.26),('7643','2013-06-22','13:25:00',16.34),('7643','2013-06-22','13:30:00',16.27),('7643','2013-06-22','13:35:00',16.38),('7643','2013-06-22','13:40:00',16.48),('7643','2013-06-22','13:45:00',16.43),('7643','2013-06-22','13:50:00',16.39),('7643','2013-06-22','13:55:00',16.43),('7643','2013-06-22','14:00:00',16.38),('7643','2013-06-22','14:05:00',16.19),('7643','2013-06-22','14:10:00',16.2),('7643','2013-06-22','14:15:00',16.18),('7643','2013-06-22','14:20:00',15.95),('7643','2013-06-22','14:25:00',15.91),('7643','2013-06-22','14:30:00',15.95),('7643','2013-06-22','14:35:00',15.89),('7643','2013-06-22','14:40:00',15.82),('7643','2013-06-22','14:45:00',15.78),('7643','2013-06-22','14:50:00',15.67),('7643','2013-06-22','14:55:00',15.44),('7643','2013-06-22','15:00:00',15.39),('7643','2013-06-22','15:05:00',15.26),('7643','2013-06-22','15:10:00',15.08),('7643','2013-06-22','15:15:00',14.91),('7643','2013-06-22','15:20:00',14.68),('7643','2013-06-22','15:25:00',14.65),('7643','2013-06-22','15:30:00',14.47),('7643','2013-06-22','15:35:00',14.29),('7643','2013-06-22','15:40:00',14.01),('7643','2013-06-22','15:45:00',13.82),('7643','2013-06-22','15:50:00',13.62),('7643','2013-06-22','15:55:00',13.42),('7643','2013-06-22','16:00:00',13.19),('7643','2013-06-22','16:05:00',12.92),('7643','2013-06-22','16:10:00',12.71),('7643','2013-06-22','16:15:00',12.46),('7643','2013-06-22','16:20:00',12.28),('7643','2013-06-22','16:25:00',11.92),('7643','2013-06-22','16:30:00',11.71),('7643','2013-06-22','16:35:00',11.43),('7643','2013-06-22','16:40:00',11.21),('7643','2013-06-22','16:45:00',11.02),('7643','2013-06-22','16:50:00',10.74),('7643','2013-06-22','16:55:00',10.37),('7643','2013-06-22','17:00:00',10.13),('7643','2013-06-22','17:05:00',9.88),('7643','2013-06-22','17:10:00',9.58),('7643','2013-06-22','17:15:00',9.22),('7643','2013-06-22','17:20:00',8.35),('7643','2013-06-22','17:25:00',8.56),('7643','2013-06-22','17:30:00',8.16),('7643','2013-06-22','17:35:00',7.96),('7643','2013-06-22','17:40:00',7.67),('7643','2013-06-22','17:45:00',7.44),('7643','2013-06-22','17:50:00',7.11),('7643','2013-06-22','17:55:00',6.75),('7643','2013-06-22','18:00:00',6.45),('7643','2013-06-22','18:05:00',6.11),('7643','2013-06-22','18:10:00',5.79),('7643','2013-06-22','18:15:00',5.39),('7643','2013-06-22','18:20:00',5.07),('7643','2013-06-22','18:25:00',4.84),('7643','2013-06-22','18:30:00',4.44),('7643','2013-06-22','18:35:00',4.03),('7643','2013-06-22','18:40:00',3.2),('7643','2013-06-22','18:45:00',3.45),('7643','2013-06-22','18:50:00',3.11),('7643','2013-06-22','18:55:00',2.67),('7643','2013-06-22','19:00:00',2.13),('7643','2013-06-22','19:05:00',2.05),('7643','2013-06-22','19:10:00',1.84),('7643','2013-06-22','19:15:00',1.63),('7643','2013-06-21','06:40:00',1.04),('7643','2013-06-21','06:45:00',1.21),('7643','2013-06-21','06:50:00',1.37),('7643','2013-06-21','06:55:00',1.54),('7643','2013-06-21','07:00:00',1.77),('7643','2013-06-21','07:05:00',2.02),('7643','2013-06-21','07:10:00',2.3),('7643','2013-06-21','07:15:00',2.56),('7643','2013-06-21','07:20:00',2.84),('7643','2013-06-21','07:25:00',3.11),('7643','2013-06-21','07:30:00',3.42),('7643','2013-06-21','07:35:00',3.69),('7643','2013-06-21','07:40:00',3.96),('7643','2013-06-21','07:45:00',4.29),('7643','2013-06-21','07:50:00',4.59),('7643','2013-06-21','07:55:00',4.89),('7643','2013-06-21','08:00:00',5.17),('7643','2013-06-21','08:05:00',5.39),('7643','2013-06-21','08:10:00',5.66),('7643','2013-06-21','08:15:00',5.9),('7643','2013-06-21','08:20:00',6.26),('7643','2013-06-21','08:25:00',6.61),('7643','2013-06-21','08:30:00',7.04),('7643','2013-06-21','08:35:00',7.32),('7643','2013-06-21','08:40:00',7.69),('7643','2013-06-21','08:45:00',8.07),('7643','2013-06-21','08:50:00',8.32),('7643','2013-06-21','08:55:00',8.6),('7643','2013-06-21','09:00:00',8.85),('7643','2013-06-21','09:05:00',9.07),('7643','2013-06-21','09:10:00',9.36),('7643','2013-06-21','09:15:00',9.64),('7643','2013-06-21','09:20:00',9.89),('7643','2013-06-21','09:25:00',10.08),('7643','2013-06-21','09:30:00',10.3),('7643','2013-06-21','09:35:00',10.6),('7643','2013-06-21','09:40:00',10.85),('7643','2013-06-21','09:45:00',11.05),('7643','2013-06-21','09:50:00',11.25),('7643','2013-06-21','09:55:00',11.51),('7643','2013-06-21','10:00:00',11.69),('7643','2013-06-21','10:05:00',12.06),('7643','2013-06-21','10:10:00',12.26),('7643','2013-06-21','10:15:00',12.41),('7643','2013-06-21','10:20:00',12.72),('7643','2013-06-21','10:25:00',12.92),('7643','2013-06-21','10:30:00',12.9),('7643','2013-06-21','10:35:00',13.07),('7643','2013-06-21','10:40:00',13.3),('7643','2013-06-21','10:45:00',13.54),('7643','2013-06-21','10:50:00',13.76),('7643','2013-06-21','10:55:00',13.93),('7643','2013-06-21','11:00:00',14.01),('7643','2013-06-21','11:05:00',14.12),('7643','2013-06-21','11:10:00',14.25),('7643','2013-06-21','11:15:00',14.33),('7643','2013-06-21','11:20:00',14.48),('7643','2013-06-21','11:25:00',14.64),('7643','2013-06-21','11:30:00',14.71),('7643','2013-06-21','11:35:00',14.9),('7643','2013-06-21','11:40:00',15.02),('7643','2013-06-21','11:45:00',15.06),('7643','2013-06-21','11:50:00',15.14),('7643','2013-06-21','11:55:00',15.26),('7643','2013-06-21','12:00:00',15.28),('7643','2013-06-21','12:05:00',15.12),('7643','2013-06-21','12:10:00',14.87),('7643','2013-06-21','12:15:00',15.5),('7643','2013-06-21','12:20:00',15.45),('7643','2013-06-21','12:25:00',15.25),('7643','2013-06-21','12:30:00',15.62),('7643','2013-06-21','12:35:00',15.8),('7643','2013-06-21','12:40:00',15.9),('7643','2013-06-21','12:45:00',15.66),('7643','2013-06-21','12:50:00',15.51),('7643','2013-06-21','12:55:00',15.37),('7643','2013-06-21','13:00:00',15.29),('7643','2013-06-21','13:05:00',15.34),('7643','2013-06-21','13:10:00',15.01),('7643','2013-06-21','13:15:00',14.83),('7643','2013-06-21','13:20:00',14.48),('7643','2013-06-21','13:25:00',14.69),('7643','2013-06-21','13:30:00',16.21),('7643','2013-06-21','13:35:00',16.54),('7643','2013-06-21','13:40:00',15.24),('7643','2013-06-21','13:45:00',15.34),('7643','2013-06-21','13:50:00',16.03),('7643','2013-06-21','13:55:00',13.4),('7643','2013-06-21','14:00:00',9.06),('7643','2013-06-21','14:05:00',17.5),('7643','2013-06-21','14:10:00',16.63),('7643','2013-06-21','14:15:00',16.46),('7643','2013-06-21','14:20:00',13.76),('7643','2013-06-21','14:25:00',16.39),('7643','2013-06-21','14:30:00',12.24),('7643','2013-06-21','14:35:00',8.61),('7643','2013-06-21','14:40:00',6.58),('7643','2013-06-21','14:45:00',7.32),('7643','2013-06-21','14:50:00',14.13),('7643','2013-06-21','14:55:00',13.81),('7643','2013-06-21','15:00:00',14.99),('7643','2013-06-21','15:05:00',12.48),('7643','2013-06-21','15:10:00',14.34),('7643','2013-06-21','15:15:00',15.68),('7643','2013-06-21','15:20:00',14.19),('7643','2013-06-21','15:25:00',13.18),('7643','2013-06-21','15:30:00',8.71),('7643','2013-06-21','15:35:00',7.45),('7643','2013-06-21','15:40:00',6.77),('7643','2013-06-21','15:45:00',9.6),('7643','2013-06-21','15:50:00',9.74),('7643','2013-06-21','15:55:00',9.22),('7643','2013-06-21','16:00:00',7.66),('7643','2013-06-21','16:05:00',4.77),('7643','2013-06-21','16:10:00',4.62),('7643','2013-06-21','16:15:00',5.94),('7643','2013-06-21','16:20:00',7.14),('7643','2013-06-21','16:25:00',4.99),('7643','2013-06-21','16:30:00',3.81),('7643','2013-06-21','16:35:00',3.21),('7643','2013-06-21','16:40:00',2.92),('7643','2013-06-21','16:45:00',2.78),('7643','2013-06-21','16:50:00',3.03),('7643','2013-06-21','16:55:00',4.23),('7643','2013-06-21','17:00:00',5.54),('7643','2013-06-21','17:05:00',5.27),('7643','2013-06-21','17:10:00',7.27),('7643','2013-06-21','17:15:00',10.72),('7643','2013-06-21','17:20:00',9.99),('7643','2013-06-21','17:25:00',10.01),('7643','2013-06-21','17:30:00',7.66),('7643','2013-06-21','17:35:00',7.39),('7643','2013-06-21','17:40:00',8.05),('7643','2013-06-21','17:45:00',7.85),('7643','2013-06-21','17:50:00',7.23),('7643','2013-06-21','17:55:00',6.91),('7643','2013-06-21','18:00:00',6.33),('7643','2013-06-21','18:05:00',5.17),('7643','2013-06-21','18:10:00',3.63),('7643','2013-06-21','18:15:00',3.44),('7643','2013-06-21','18:20:00',3.53),('7643','2013-06-21','18:25:00',2.24),('7643','2013-06-21','18:30:00',1.7),('7643','2013-06-21','18:35:00',2.05),('7643','2013-06-21','18:40:00',2.1),('7643','2013-06-21','18:45:00',1.61),('7643','2013-06-21','18:50:00',1.4),('7643','2013-06-21','18:55:00',1.44),('7643','2013-06-21','19:00:00',1.68),('7643','2013-06-21','19:05:00',1.36),('7643','2013-06-21','19:10:00',1.39),('7643','2013-06-21','19:15:00',1.85),('7643','2013-06-21','19:20:00',1.82),('7643','2013-06-21','19:25:00',1.76),('7643','2013-06-21','19:30:00',1.4),('7643','2013-06-21','19:35:00',1.31),('7643','2013-06-21','19:40:00',1.25),('7643','2013-06-21','19:45:00',1.05),('7643','2013-06-20','06:40:00',1.02),('7643','2013-06-20','06:45:00',1.18),('7643','2013-06-20','06:50:00',1.36),('7643','2013-06-20','06:55:00',1.54),('7643','2013-06-20','07:00:00',1.76),('7643','2013-06-20','07:05:00',2.02),('7643','2013-06-20','07:10:00',2.32),('7643','2013-06-20','07:15:00',2.57),('7643','2013-06-20','07:20:00',2.82),('7643','2013-06-20','07:25:00',3.09),('7643','2013-06-20','07:30:00',3.37),('7643','2013-06-20','07:35:00',3.65),('7643','2013-06-20','07:40:00',3.94),('7643','2013-06-20','07:45:00',4.28),('7643','2013-06-20','07:50:00',4.57),('7643','2013-06-20','07:55:00',4.9),('7643','2013-06-20','08:00:00',5.18),('7643','2013-06-20','08:05:00',5.45),('7643','2013-06-20','08:10:00',5.71),('7643','2013-06-20','08:15:00',5.96),('7643','2013-06-20','08:20:00',6.27),('7643','2013-06-20','08:25:00',6.51),('7643','2013-06-20','08:30:00',6.86),('7643','2013-06-20','08:35:00',7.23),('7643','2013-06-20','08:40:00',7.51),('7643','2013-06-20','08:45:00',7.72),('7643','2013-06-20','08:50:00',7.94),('7643','2013-06-20','08:55:00',8.22),('7643','2013-06-20','09:00:00',8.48),('7643','2013-06-20','09:05:00',8.79),('7643','2013-06-20','09:10:00',8.98),('7643','2013-06-20','09:15:00',9.3),('7643','2013-06-20','09:20:00',9.64),('7643','2013-06-20','09:25:00',9.81),('7643','2013-06-20','09:30:00',9.96),('7643','2013-06-20','09:35:00',10.23),('7643','2013-06-20','09:40:00',10.39),('7643','2013-06-20','09:45:00',10.43),('7643','2013-06-20','09:50:00',10.69),('7643','2013-06-20','09:55:00',10.85),('7643','2013-06-20','10:00:00',11.09),('7643','2013-06-20','10:05:00',11.32),('7643','2013-06-20','10:10:00',11.15),('7643','2013-06-20','10:15:00',11.28),('7643','2013-06-20','10:20:00',11.66),('7643','2013-06-20','10:25:00',11.97),('7643','2013-06-20','10:30:00',12.15),('7643','2013-06-20','10:35:00',12.27),('7643','2013-06-20','10:40:00',12.39),('7643','2013-06-20','10:45:00',12.59),('7643','2013-06-20','10:50:00',12.8),('7643','2013-06-20','10:55:00',12.91),('7643','2013-06-20','11:00:00',12.96),('7643','2013-06-20','11:05:00',13),('7643','2013-06-20','11:10:00',13.02),('7643','2013-06-20','11:15:00',13.43),('7643','2013-06-20','11:20:00',13.64),('7643','2013-06-20','11:25:00',13.75),('7643','2013-06-20','11:30:00',13.9),('7643','2013-06-20','11:35:00',13.96),('7643','2013-06-20','11:40:00',13.95),('7643','2013-06-20','11:45:00',14.02),('7643','2013-06-20','11:50:00',14.26),('7643','2013-06-20','11:55:00',14.36),('7643','2013-06-20','12:00:00',14.46),('7643','2013-06-20','12:05:00',14.62),('7643','2013-06-20','12:10:00',14.5),('7643','2013-06-20','12:15:00',14.34),('7643','2013-06-20','12:20:00',14.5),('7643','2013-06-20','12:25:00',14.58),('7643','2013-06-20','12:30:00',14.77),('7643','2013-06-20','12:35:00',14.62),('7643','2013-06-20','12:40:00',14.52),('7643','2013-06-20','12:45:00',14.45),('7643','2013-06-20','12:50:00',14.71),('7643','2013-06-20','12:55:00',14.36),('7643','2013-06-20','13:00:00',14.55),('7643','2013-06-20','13:05:00',14.67),('7643','2013-06-20','13:10:00',14.29),('7643','2013-06-20','13:15:00',14.56),('7643','2013-06-20','13:20:00',14.74),('7643','2013-06-20','13:25:00',14.89),('7643','2013-06-20','13:30:00',14.98),('7643','2013-06-20','13:35:00',15.12),('7643','2013-06-20','13:40:00',15.12),('7643','2013-06-20','13:45:00',15.19),('7643','2013-06-20','13:50:00',15.2),('7643','2013-06-20','13:55:00',14.89),('7643','2013-06-20','14:00:00',14.88),('7643','2013-06-20','14:05:00',14.96),('7643','2013-06-20','14:10:00',14.9),('7643','2013-06-20','14:15:00',14.81),('7643','2013-06-20','14:20:00',14.94),('7643','2013-06-20','14:25:00',14.95),('7643','2013-06-20','14:30:00',14.97),('7643','2013-06-20','14:35:00',14.87),('7643','2013-06-20','14:40:00',14.7),('7643','2013-06-20','14:45:00',14.68),('7643','2013-06-20','14:50:00',14.73),('7643','2013-06-20','14:55:00',14.61),('7643','2013-06-20','15:00:00',14.48),('7643','2013-06-20','15:05:00',14.37),('7643','2013-06-20','15:10:00',14.16),('7643','2013-06-20','15:15:00',13.92),('7643','2013-06-20','15:20:00',13.77),('7643','2013-06-20','15:25:00',13.66),('7643','2013-06-20','15:30:00',13.59),('7643','2013-06-20','15:35:00',13.46),('7643','2013-06-20','15:40:00',13.29),('7643','2013-06-20','15:45:00',13.09),('7643','2013-06-20','15:50:00',12.93),('7643','2013-06-20','15:55:00',12.73),('7643','2013-06-20','16:00:00',12.56),('7643','2013-06-20','16:05:00',12.36),('7643','2013-06-20','16:10:00',12.17),('7643','2013-06-20','16:15:00',11.9),('7643','2013-06-20','16:20:00',11.61),('7643','2013-06-20','16:25:00',11.38),('7643','2013-06-20','16:30:00',11.16),('7643','2013-06-20','16:35:00',10.96),('7643','2013-06-20','16:40:00',10.67),('7643','2013-06-20','16:45:00',10.4),('7643','2013-06-20','16:50:00',10.14),('7643','2013-06-20','16:55:00',9.94),('7643','2013-06-20','17:00:00',9.69),('7643','2013-06-20','17:05:00',9.4),('7643','2013-06-20','17:10:00',9.08),('7643','2013-06-20','17:15:00',8.74),('7643','2013-06-20','17:20:00',8.4),('7643','2013-06-20','17:25:00',8.12),('7643','2013-06-20','17:30:00',7.75),('7643','2013-06-20','17:35:00',7.56),('7643','2013-06-20','17:40:00',7.3),('7643','2013-06-20','17:45:00',6.99),('7643','2013-06-20','17:50:00',6.68),('7643','2013-06-20','17:55:00',6.34),('7643','2013-06-20','18:00:00',5.98),('7643','2013-06-20','18:05:00',5.68),('7643','2013-06-20','18:10:00',5.42),('7643','2013-06-20','18:15:00',5.13),('7643','2013-06-20','18:20:00',4.78),('7643','2013-06-20','18:25:00',4.46),('7643','2013-06-20','18:30:00',4.15),('7643','2013-06-20','18:35:00',3.84),('7643','2013-06-20','18:40:00',3.49),('7643','2013-06-20','18:45:00',3.12),('7643','2013-06-20','18:50:00',2.78),('7643','2013-06-20','18:55:00',2.52),('7643','2013-06-20','19:00:00',2.24),('7643','2013-06-20','19:05:00',2.02),('7643','2013-06-20','19:10:00',1.79),('7643','2013-06-20','19:15:00',1.53),('7643','2013-06-20','19:20:00',1.3),('7643','2013-06-20','19:25:00',1.14),('7643','2014-04-03','08:30:00',1.35),('7643','2014-04-03','08:35:00',2.12),('7643','2014-04-03','08:40:00',2.89),('7643','2014-04-03','08:45:00',2.99),('7643','2014-04-03','08:50:00',3.27),('7643','2014-04-03','08:55:00',3.2),('7643','2014-04-03','09:00:00',3.23),('7643','2014-04-03','09:05:00',5.15),('7643','2014-04-03','09:10:00',7.03),('7643','2014-04-03','09:15:00',6.25),('7643','2014-04-03','09:20:00',4.27),('7643','2014-04-03','09:25:00',3.61),('7643','2014-04-03','09:30:00',3.47),('7643','2014-04-03','09:35:00',3.56),('7643','2014-04-03','09:40:00',3.39),('7643','2014-04-03','09:45:00',3.42),('7643','2014-04-03','09:50:00',3.14),('7643','2014-04-03','09:55:00',2.19),('7643','2014-04-03','10:00:00',1.46),('7643','2014-04-03','10:05:00',1.3),('7643','2014-04-03','10:10:00',1.12),('7643','2014-04-03','10:15:00',1.53),('7643','2014-04-03','10:20:00',1.23),('7643','2014-04-03','10:25:00',1.11),('7643','2014-04-03','10:30:00',1.19),('7643','2014-04-03','10:55:00',1.77),('7643','2014-04-03','11:00:00',1.17),('7643','2014-04-03','11:15:00',2.05),('7643','2014-04-03','11:20:00',2.12),('7643','2014-04-03','11:25:00',1.47),('7643','2014-04-03','11:30:00',1.08),('7643','2014-04-03','12:15:00',1.79),('7643','2014-04-03','12:20:00',1.28),('7643','2014-04-03','12:30:00',1.12),('7643','2014-04-03','12:40:00',1.25),('7643','2014-04-03','12:45:00',1.88),('7643','2014-04-03','12:50:00',2.59),('7643','2014-04-03','12:55:00',2.3),('7643','2014-04-03','13:00:00',2.68),('7643','2014-04-03','13:05:00',2.04),('7643','2014-04-03','13:10:00',2.56),('7643','2014-04-03','13:15:00',2.71),('7643','2014-04-03','13:20:00',6.18),('7643','2014-04-03','13:25:00',9.92),('7643','2014-04-03','13:30:00',9.93),('7643','2014-04-03','13:35:00',11.67),('7643','2014-04-03','13:40:00',17.04),('7643','2014-04-03','13:45:00',14.9),('7643','2014-04-03','13:50:00',14.31),('7643','2014-04-03','13:55:00',10.11),('7643','2014-04-03','14:00:00',9.12),('7643','2014-04-03','14:05:00',16.35),('7643','2014-04-03','14:10:00',11.1),('7643','2014-04-03','14:15:00',16.88),('7643','2014-04-03','14:20:00',12.19),('7643','2014-04-03','14:25:00',13.39),('7643','2014-04-03','14:30:00',5.58),('7643','2014-04-03','14:35:00',13.73),('7643','2014-04-03','14:40:00',6.45),('7643','2014-04-03','14:45:00',12.95),('7643','2014-04-03','14:50:00',13.7),('7643','2014-04-03','14:55:00',15.49),('7643','2014-04-03','15:00:00',15.66),('7643','2014-04-03','15:05:00',15.78),('7643','2014-04-03','15:10:00',15.99),('7643','2014-04-03','15:15:00',13.85),('7643','2014-04-03','15:20:00',9.06),('7643','2014-04-03','15:25:00',7.43),('7643','2014-04-03','15:30:00',7.19),('7643','2014-04-03','15:35:00',6.81),('7643','2014-04-03','15:40:00',11.23),('7643','2014-04-03','15:45:00',8.32),('7643','2014-04-03','15:50:00',7.9),('7643','2014-04-03','15:55:00',11.92),('7643','2014-04-03','16:00:00',9.6),('7643','2014-04-03','16:05:00',6.13),('7643','2014-04-03','16:10:00',7.51),('7643','2014-04-03','16:15:00',6.42),('7643','2014-04-03','16:20:00',3.98),('7643','2014-04-03','16:25:00',3.67),('7643','2014-04-03','16:30:00',9.48),('7643','2014-04-03','16:35:00',7.25),('7643','2014-04-03','16:40:00',5.22),('7643','2014-04-03','16:45:00',10.95),('7643','2014-04-03','16:50:00',11.85),('7643','2014-04-03','16:55:00',8.67),('7643','2014-04-03','17:00:00',7.76),('7643','2014-04-03','17:05:00',7.93),('7643','2014-04-03','17:10:00',8.28),('7643','2014-04-03','17:15:00',8.63),('7643','2014-04-03','17:20:00',6.78),('7643','2014-04-03','17:25:00',7.35),('7643','2014-04-03','17:30:00',7.3),('7643','2014-04-03','17:35:00',5.22),('7643','2014-04-03','17:40:00',6.41),('7643','2014-04-03','17:45:00',5.95),('7643','2014-04-03','17:50:00',5.66),('7643','2014-04-03','17:55:00',5.16),('7643','2014-04-03','18:00:00',4.53),('7643','2014-04-03','18:05:00',4.07),('7643','2014-04-03','18:10:00',3.6),('7643','2014-04-03','18:15:00',3.18),('7643','2014-04-03','18:20:00',2.73),('7643','2014-04-03','18:25:00',2.39),('7643','2014-04-03','18:30:00',2.12),('7643','2014-04-03','18:35:00',1.83),('7643','2014-04-03','18:40:00',1.54),('7643','2014-04-03','18:45:00',1.17),('7643','2014-04-03','18:50:00',1.13),('7643','2013-06-19','06:45:00',1.09),('7643','2013-06-19','06:50:00',1.22),('7643','2013-06-19','06:55:00',1.41),('7643','2013-06-19','07:00:00',1.65),('7643','2013-06-19','07:05:00',1.92),('7643','2013-06-19','07:10:00',2.21),('7643','2013-06-19','07:15:00',2.45),('7643','2013-06-19','07:20:00',2.66),('7643','2013-06-19','07:25:00',2.9),('7643','2013-06-19','07:30:00',3.12),('7643','2013-06-19','07:35:00',3.11),('7643','2013-06-19','07:40:00',3.46),('7643','2013-06-19','07:45:00',3.79),('7643','2013-06-19','07:50:00',4.29),('7643','2013-06-19','07:55:00',4.68),('7643','2013-06-19','08:00:00',5.07),('7643','2013-06-19','08:05:00',5.39),('7643','2013-06-19','08:10:00',5.75),('7643','2013-06-19','08:15:00',6.01),('7643','2013-06-19','08:20:00',6.34),('7643','2013-06-19','08:25:00',6.61),('7643','2013-06-19','08:30:00',6.99),('7643','2013-06-19','08:35:00',7.33),('7643','2013-06-19','08:40:00',7.62),('7643','2013-06-19','08:45:00',7.9),('7643','2013-06-19','08:50:00',8.13),('7643','2013-06-19','08:55:00',8.4),('7643','2013-06-19','09:00:00',8.71),('7643','2013-06-19','09:05:00',9.06),('7643','2013-06-19','09:10:00',9.3),('7643','2013-06-19','09:15:00',9.51),('7643','2013-06-19','09:20:00',9.81),('7643','2013-06-19','09:25:00',9.99),('7643','2013-06-19','09:30:00',10.26),('7643','2013-06-19','09:35:00',10.43),('7643','2013-06-19','09:40:00',10.73),('7643','2013-06-19','09:45:00',10.99),('7643','2013-06-19','09:50:00',11.2),('7643','2013-06-19','09:55:00',11.39),('7643','2013-06-19','10:00:00',11.52),('7643','2013-06-19','10:05:00',11.75),('7643','2013-06-19','10:10:00',11.94),('7643','2013-06-19','10:15:00',12),('7643','2013-06-19','10:20:00',12.2),('7643','2013-06-19','10:25:00',12.5),('7643','2013-06-19','10:30:00',12.64),('7643','2013-06-19','10:35:00',12.79),('7643','2013-06-19','10:40:00',12.89),('7643','2013-06-19','10:45:00',12.92),('7643','2013-06-19','10:50:00',13.06),('7643','2013-06-19','10:55:00',13.23),('7643','2013-06-19','11:00:00',13.41),('7643','2013-06-19','11:05:00',13.5),('7643','2013-06-19','11:10:00',13.55),('7643','2013-06-19','11:15:00',13.42),('7643','2013-06-19','11:20:00',13.32),('7643','2013-06-19','11:25:00',13.57),('7643','2013-06-19','11:30:00',13.83),('7643','2013-06-19','11:35:00',14.11),('7643','2013-06-19','11:40:00',14.22),('7643','2013-06-19','11:45:00',14.28),('7643','2013-06-19','11:50:00',14),('7643','2013-06-19','11:55:00',13.99),('7643','2013-06-19','12:00:00',14.26),('7643','2013-06-19','12:05:00',14.31),('7643','2013-06-19','12:10:00',14.02),('7643','2013-06-19','12:15:00',14.11),('7643','2013-06-19','12:20:00',14.21),('7643','2013-06-19','12:25:00',14.82),('7643','2013-06-19','12:30:00',14.93),('7643','2013-06-19','12:35:00',15.3),('7643','2013-06-19','12:40:00',13.12),('7643','2013-06-19','12:45:00',15.1),('7643','2013-06-19','12:50:00',13.84),('7643','2013-06-19','12:55:00',7.86),('7643','2013-06-19','13:00:00',15.39),('7643','2013-06-19','13:05:00',15.77),('7643','2013-06-19','13:10:00',14.97),('7643','2013-06-19','13:15:00',14.96),('7643','2013-06-19','13:20:00',14.84),('7643','2013-06-19','13:25:00',12.45),('7643','2013-06-19','13:30:00',14.07),('7643','2013-06-19','13:35:00',15.21),('7643','2013-06-19','13:40:00',15.21),('7643','2013-06-19','13:45:00',15.2),('7643','2013-06-19','13:50:00',15.31),('7643','2013-06-19','13:55:00',15.11),('7643','2013-06-19','14:00:00',15.43),('7643','2013-06-19','14:05:00',15.6),('7643','2013-06-19','14:10:00',15.25),('7643','2013-06-19','14:15:00',15.39),('7643','2013-06-19','14:20:00',15.48),('7643','2013-06-19','14:25:00',15.29),('7643','2013-06-19','14:30:00',15.19),('7643','2013-06-19','14:35:00',15.31),('7643','2013-06-19','14:40:00',15.39),('7643','2013-06-19','14:45:00',15.22),('7643','2013-06-19','14:50:00',15.17),('7643','2013-06-19','14:55:00',15.1),('7643','2013-06-19','15:00:00',14.94),('7643','2013-06-19','15:05:00',14.76),('7643','2013-06-19','15:10:00',14.62),('7643','2013-06-19','15:15:00',14.44),('7643','2013-06-19','15:20:00',14.24),('7643','2013-06-19','15:25:00',14.01),('7643','2013-06-19','15:30:00',13.91),('7643','2013-06-19','15:35:00',13.7),('7643','2013-06-19','15:40:00',13.57),('7643','2013-06-19','15:45:00',13.34),('7643','2013-06-19','15:50:00',13.08),('7643','2013-06-19','15:55:00',12.94),('7643','2013-06-19','16:00:00',12.76),('7643','2013-06-19','16:05:00',12.53),('7643','2013-06-19','16:10:00',12.32),('7643','2013-06-19','16:15:00',12.18),('7643','2013-06-19','16:20:00',11.94),('7643','2013-06-19','16:25:00',11.6),('7643','2013-06-19','16:30:00',11.35),('7643','2013-06-19','16:35:00',11.22),('7643','2013-06-19','16:40:00',10.89),('7643','2013-06-19','16:45:00',10.61),('7643','2013-06-19','16:50:00',10.28),('7643','2013-06-19','16:55:00',9.99),('7643','2013-06-19','17:00:00',9.74),('7643','2013-06-19','17:05:00',9.42),('7643','2013-06-19','17:10:00',9.17),('7643','2013-06-19','17:15:00',8.82),('7643','2013-06-19','17:20:00',8.49),('7643','2013-06-19','17:25:00',8.17),('7643','2013-06-19','17:30:00',7.85),('7643','2013-06-19','17:35:00',7.58),('7643','2013-06-19','17:40:00',7.35),('7643','2013-06-19','17:45:00',7.11),('7643','2013-06-19','17:50:00',6.84),('7643','2013-06-19','17:55:00',6.46),('7643','2013-06-19','18:00:00',6.11),('7643','2013-06-19','18:05:00',5.83),('7643','2013-06-19','18:10:00',5.56),('7643','2013-06-19','18:15:00',5.24),('7643','2013-06-19','18:20:00',4.94),('7643','2013-06-19','18:25:00',4.61),('7643','2013-06-19','18:30:00',4.29),('7643','2013-06-19','18:35:00',3.94),('7643','2013-06-19','18:40:00',3.57),('7643','2013-06-19','18:45:00',3.17),('7643','2013-06-19','18:50:00',2.81),('7643','2013-06-19','18:55:00',2.54),('7643','2013-06-19','19:00:00',2.23),('7643','2013-06-19','19:05:00',1.97),('7643','2013-06-19','19:10:00',1.76),('7643','2013-06-19','19:15:00',1.53),('7643','2013-06-19','19:20:00',1.26),('7643','2013-06-19','19:25:00',1.12),('7643','2013-06-18','06:45:00',1.11),('7643','2013-06-18','06:50:00',1.28),('7643','2013-06-18','06:55:00',1.48),('7643','2013-06-18','07:00:00',1.7),('7643','2013-06-18','07:05:00',1.95),('7643','2013-06-18','07:10:00',2.22),('7643','2013-06-18','07:15:00',2.47),('7643','2013-06-18','07:20:00',2.74),('7643','2013-06-18','07:25:00',3),('7643','2013-06-18','07:30:00',3.29),('7643','2013-06-18','07:35:00',3.56),('7643','2013-06-18','07:40:00',3.84),('7643','2013-06-18','07:45:00',4.1),('7643','2013-06-18','07:50:00',4.37),('7643','2013-06-18','07:55:00',4.7),('7643','2013-06-18','08:00:00',5),('7643','2013-06-18','08:05:00',5.3),('7643','2013-06-18','08:10:00',5.62),('7643','2013-06-18','08:15:00',5.82),('7643','2013-06-18','08:20:00',6.17),('7643','2013-06-18','08:25:00',6.44),('7643','2013-06-18','08:30:00',6.78),('7643','2013-06-18','08:35:00',7.11),('7643','2013-06-18','08:40:00',7.39),('7643','2013-06-18','08:45:00',7.66),('7643','2013-06-18','08:50:00',7.95),('7643','2013-06-18','08:55:00',8.28),('7643','2013-06-18','09:00:00',8.57),('7643','2013-06-18','09:05:00',8.87),('7643','2013-06-18','09:10:00',9.16),('7643','2013-06-18','09:15:00',9.46),('7643','2013-06-18','09:20:00',9.72),('7643','2013-06-18','09:25:00',9.96),('7643','2013-06-18','09:30:00',10.13),('7643','2013-06-18','09:35:00',10.32),('7643','2013-06-18','09:40:00',10.5),('7643','2013-06-18','09:45:00',10.69),('7643','2013-06-18','09:50:00',10.87),('7643','2013-06-18','09:55:00',11.1),('7643','2013-06-18','10:00:00',11.31),('7643','2013-06-18','10:05:00',11.51),('7643','2013-06-18','10:10:00',11.64),('7643','2013-06-18','10:15:00',11.79),('7643','2013-06-18','10:20:00',11.81),('7643','2013-06-18','10:25:00',11.89),('7643','2013-06-18','10:30:00',12.17),('7643','2013-06-18','10:35:00',12.27),('7643','2013-06-18','10:40:00',12.46),('7643','2013-06-18','10:45:00',12.56),('7643','2013-06-18','10:50:00',12.74),('7643','2013-06-18','10:55:00',12.94),('7643','2013-06-18','11:00:00',13.09),('7643','2013-06-18','11:05:00',13.02),('7643','2013-06-18','11:10:00',13.21),('7643','2013-06-18','11:15:00',13.28),('7643','2013-06-18','11:20:00',13.37),('7643','2013-06-18','11:25:00',13.58),('7643','2013-06-18','11:30:00',13.58),('7643','2013-06-18','11:35:00',13.74),('7643','2013-06-18','11:40:00',13.49),('7643','2013-06-18','11:45:00',13.74),('7643','2013-06-18','11:50:00',13.89),('7643','2013-06-18','11:55:00',13.99),('7643','2013-06-18','12:00:00',14.3),('7643','2013-06-18','12:05:00',14.05),('7643','2013-06-18','12:10:00',14.45),('7643','2013-06-18','12:15:00',14.1),('7643','2013-06-18','12:20:00',13.96),('7643','2013-06-18','12:25:00',14.33),('7643','2013-06-18','12:30:00',14.5),('7643','2013-06-18','12:35:00',14.83),('7643','2013-06-18','12:40:00',15.16),('7643','2013-06-18','12:45:00',15.1),('7643','2013-06-18','12:50:00',14.96),('7643','2013-06-18','12:55:00',15.11),('7643','2013-06-18','13:00:00',15.05),('7643','2013-06-18','13:05:00',14.94),('7643','2013-06-18','13:10:00',14.92),('7643','2013-06-18','13:15:00',14.89),('7643','2013-06-18','13:20:00',14.87),('7643','2013-06-18','13:25:00',15.05),('7643','2013-06-18','13:30:00',15.32),('7643','2013-06-18','13:35:00',15.23),('7643','2013-06-18','13:40:00',15.29),('7643','2013-06-18','13:45:00',15.17),('7643','2013-06-18','13:50:00',15.19),('7643','2013-06-18','13:55:00',15.34),('7643','2013-06-18','14:00:00',15.27),('7643','2013-06-18','14:05:00',15.26),('7643','2013-06-18','14:10:00',15.14),('7643','2013-06-18','14:15:00',15.06),('7643','2013-06-18','14:20:00',15.02),('7643','2013-06-18','14:25:00',14.9),('7643','2013-06-18','14:30:00',14.77),('7643','2013-06-18','14:35:00',14.59),('7643','2013-06-18','14:40:00',14.45),('7643','2013-06-18','14:45:00',14.34),('7643','2013-06-18','14:50:00',14.24),('7643','2013-06-18','14:55:00',14.13),('7643','2013-06-18','15:00:00',14.1),('7643','2013-06-18','15:05:00',14),('7643','2013-06-18','15:10:00',13.8),('7643','2013-06-18','15:15:00',13.69),('7643','2013-06-18','15:20:00',13.54),('7643','2013-06-18','15:25:00',13.36),('7643','2013-06-18','15:30:00',13.24),('7643','2013-06-18','15:35:00',13.04),('7643','2013-06-18','15:40:00',12.82),('7643','2013-06-18','15:45:00',12.61),('7643','2013-06-18','15:50:00',12.45),('7643','2013-06-18','15:55:00',12.19),('7643','2013-06-18','16:00:00',12.01),('7643','2013-06-18','16:05:00',11.79),('7643','2013-06-18','16:10:00',11.58),('7643','2013-06-18','16:15:00',11.33),('7643','2013-06-18','16:20:00',11.08),('7643','2013-06-18','16:25:00',10.89),('7643','2013-06-18','16:30:00',10.67),('7643','2013-06-18','16:35:00',10.54),('7643','2013-06-18','16:40:00',10.21),('7643','2013-06-18','16:45:00',10.04),('7643','2013-06-18','16:50:00',9.79),('7643','2013-06-18','16:55:00',9.6),('7643','2013-06-18','17:00:00',9.33),('7643','2013-06-18','17:05:00',8.97),('7643','2013-06-18','17:10:00',8.67),('7643','2013-06-18','17:15:00',8.42),('7643','2013-06-18','17:20:00',8.25),('7643','2013-06-18','17:25:00',7.98),('7643','2013-06-18','17:30:00',7.63),('7643','2013-06-18','17:35:00',7.43),('7643','2013-06-18','17:40:00',7.21),('7643','2013-06-18','17:45:00',6.88),('7643','2013-06-18','17:50:00',6.58),('7643','2013-06-18','17:55:00',6.26),('7643','2013-06-18','18:00:00',5.85),('7643','2013-06-18','18:05:00',5.53),('7643','2013-06-18','18:10:00',5.25),('7643','2013-06-18','18:15:00',4.92),('7643','2013-06-18','18:20:00',4.63),('7643','2013-06-18','18:25:00',4.32),('7643','2013-06-18','18:30:00',3.99),('7643','2013-06-18','18:35:00',3.6),('7643','2013-06-18','18:40:00',3.08),('7643','2013-06-18','18:45:00',2.78),('7643','2013-06-18','18:50:00',2.51),('7643','2013-06-18','18:55:00',2.21),('7643','2013-06-18','19:00:00',1.97),('7643','2013-06-18','19:05:00',1.88),('7643','2013-06-18','19:10:00',1.7),('7643','2013-06-18','19:15:00',1.44),('7643','2013-06-18','19:20:00',1.19),('7643','2013-06-18','19:25:00',1.03),('7643','2013-06-17','06:45:00',1.1),('7643','2013-06-17','06:50:00',1.25),('7643','2013-06-17','06:55:00',1.41),('7643','2013-06-17','07:00:00',1.63),('7643','2013-06-17','07:05:00',1.9),('7643','2013-06-17','07:10:00',2.17),('7643','2013-06-17','07:15:00',2.4),('7643','2013-06-17','07:20:00',2.64),('7643','2013-06-17','07:25:00',2.9),('7643','2013-06-17','07:30:00',3.24),('7643','2013-06-17','07:35:00',3.54),('7643','2013-06-17','07:40:00',3.81),('7643','2013-06-17','07:45:00',4.14),('7643','2013-06-17','07:50:00',4.41),('7643','2013-06-17','07:55:00',4.69),('7643','2013-06-17','08:00:00',4.94),('7643','2013-06-17','08:05:00',5.21),('7643','2013-06-17','08:10:00',5.53),('7643','2013-06-17','08:15:00',5.8),('7643','2013-06-17','08:20:00',6.15),('7643','2013-06-17','08:25:00',6.42),('7643','2013-06-17','08:30:00',6.72),('7643','2013-06-17','08:35:00',7),('7643','2013-06-17','08:40:00',7.31),('7643','2013-06-17','08:45:00',7.56),('7643','2013-06-17','08:50:00',7.8),('7643','2013-06-17','08:55:00',8.09),('7643','2013-06-17','09:00:00',8.37),('7643','2013-06-17','09:05:00',8.62),('7643','2013-06-17','09:10:00',8.89),('7643','2013-06-17','09:15:00',9.2),('7643','2013-06-17','09:20:00',9.46),('7643','2013-06-17','09:25:00',9.72),('7643','2013-06-17','09:30:00',9.87),('7643','2013-06-17','09:35:00',10.13),('7643','2013-06-17','09:40:00',10.33),('7643','2013-06-17','09:45:00',10.55),('7643','2013-06-17','09:50:00',10.85),('7643','2013-06-17','09:55:00',11.06),('7643','2013-06-17','10:00:00',11.22),('7643','2013-06-17','10:05:00',11.31),('7643','2013-06-17','10:10:00',11.46),('7643','2013-06-17','10:15:00',11.72),('7643','2013-06-17','10:20:00',11.99),('7643','2013-06-17','10:25:00',12.19),('7643','2013-06-17','10:30:00',12.4),('7643','2013-06-17','10:35:00',12.5),('7643','2013-06-17','10:40:00',12.45),('7643','2013-06-17','10:45:00',12.74),('7643','2013-06-17','10:50:00',12.79),('7643','2013-06-17','10:55:00',12.71),('7643','2013-06-17','11:00:00',13.03),('7643','2013-06-17','11:05:00',13.23),('7643','2013-06-17','11:10:00',13.42),('7643','2013-06-17','11:15:00',13.55),('7643','2013-06-17','11:20:00',13.56),('7643','2013-06-17','11:25:00',13.68),('7643','2013-06-17','11:30:00',13.65),('7643','2013-06-17','11:35:00',13.64),('7643','2013-06-17','11:40:00',13.82),('7643','2013-06-17','11:45:00',13.79),('7643','2013-06-17','11:50:00',13.84),('7643','2013-06-17','11:55:00',13.5),('7643','2013-06-17','12:00:00',13.75),('7643','2013-06-17','12:05:00',13.97),('7643','2013-06-17','12:10:00',13.74),('7643','2013-06-17','12:15:00',13.65),('7643','2013-06-17','12:20:00',13.72),('7643','2013-06-17','12:25:00',13),('7643','2013-06-17','12:30:00',13.75),('7643','2013-06-17','12:35:00',10.63),('7643','2013-06-17','12:40:00',13.54),('7643','2013-06-17','12:45:00',6.54),('7643','2013-06-17','12:50:00',14.18),('7643','2013-06-17','12:55:00',14.96),('7643','2013-06-17','13:00:00',12.67),('7643','2013-06-17','13:05:00',15.08),('7643','2013-06-17','13:10:00',15.37),('7643','2013-06-17','13:15:00',14.32),('7643','2013-06-17','13:20:00',13.45),('7643','2013-06-17','13:25:00',11.02),('7643','2013-06-17','13:30:00',9.69),('7643','2013-06-17','13:35:00',14.23),('7643','2013-06-17','13:40:00',14.47),('7643','2013-06-17','13:45:00',15.14),('7643','2013-06-17','13:50:00',15.15),('7643','2013-06-17','13:55:00',15.62),('7643','2013-06-17','14:00:00',15.55),('7643','2013-06-17','14:05:00',15.44),('7643','2013-06-17','14:10:00',15.22),('7643','2013-06-17','14:15:00',15),('7643','2013-06-17','14:20:00',14.9),('7643','2013-06-17','14:25:00',14.89),('7643','2013-06-17','14:30:00',14.74),('7643','2013-06-17','14:35:00',14.81),('7643','2013-06-17','14:40:00',14.82),('7643','2013-06-17','14:45:00',14.71),('7643','2013-06-17','14:50:00',14.44),('7643','2013-06-17','14:55:00',14.36),('7643','2013-06-17','15:00:00',14.31),('7643','2013-06-17','15:05:00',14.19),('7643','2013-06-17','15:10:00',14.05),('7643','2013-06-17','15:15:00',13.82),('7643','2013-06-17','15:20:00',13.67),('7643','2013-06-17','15:25:00',13.67),('7643','2013-06-17','15:30:00',13.47),('7643','2013-06-17','15:35:00',13.32),('7643','2013-06-17','15:40:00',13.29),('7643','2013-06-17','15:45:00',13.14),('7643','2013-06-17','15:50:00',12.96),('7643','2013-06-17','15:55:00',12.74),('7643','2013-06-17','16:00:00',12.77),('7643','2013-06-17','16:05:00',12.7),('7643','2013-06-17','16:10:00',12.4),('7643','2013-06-17','16:15:00',12.19),('7643','2013-06-17','16:20:00',12.05),('7643','2013-06-17','16:25:00',11.55),('7643','2013-06-17','16:30:00',11.25),('7643','2013-06-17','16:35:00',10.52),('7643','2013-06-17','16:40:00',10.62),('7643','2013-06-17','16:45:00',10.06),('7643','2013-06-17','16:50:00',9.98),('7643','2013-06-17','16:55:00',9.69),('7643','2013-06-17','17:00:00',9.44),('7643','2013-06-17','17:05:00',9.1),('7643','2013-06-17','17:10:00',8.82),('7643','2013-06-17','17:15:00',8.55),('7643','2013-06-17','17:20:00',8.26),('7643','2013-06-17','17:25:00',8.02),('7643','2013-06-17','17:30:00',7.63),('7643','2013-06-17','17:35:00',7.37),('7643','2013-06-17','17:40:00',7.16),('7643','2013-06-17','17:45:00',6.87),('7643','2013-06-17','17:50:00',6.55),('7643','2013-06-17','17:55:00',6.26),('7643','2013-06-17','18:00:00',5.84),('7643','2013-06-17','18:05:00',5.6),('7643','2013-06-17','18:10:00',5.38),('7643','2013-06-17','18:15:00',5.11),('7643','2013-06-17','18:20:00',4.88),('7643','2013-06-17','18:25:00',4.54),('7643','2013-06-17','18:30:00',4.24),('7643','2013-06-17','18:35:00',3.93),('7643','2013-06-17','18:40:00',3.58),('7643','2013-06-17','18:45:00',3.21),('7643','2013-06-17','18:50:00',2.82),('7643','2013-06-17','18:55:00',2.44),('7643','2013-06-17','19:00:00',2.18),('7643','2013-06-17','19:05:00',2.06),('7643','2013-06-17','19:10:00',1.88),('7643','2013-06-17','19:15:00',1.63),('7643','2013-06-17','19:20:00',1.41),('7643','2013-06-17','19:25:00',1.25),('7643','2013-06-17','19:30:00',1.1),('7643','2013-06-16','06:45:00',1.13),('7643','2013-06-16','06:50:00',1.3),('7643','2013-06-16','06:55:00',1.54),('7643','2013-06-16','07:00:00',1.75),('7643','2013-06-16','07:05:00',2.03),('7643','2013-06-16','07:10:00',2.3),('7643','2013-06-16','07:15:00',2.58),('7643','2013-06-16','07:20:00',2.87),('7643','2013-06-16','07:25:00',3.16),('7643','2013-06-16','07:30:00',3.46),('7643','2013-06-16','07:35:00',3.76),('7643','2013-06-16','07:40:00',4.1),('7643','2013-06-16','07:45:00',4.41),('7643','2013-06-16','07:50:00',4.71),('7643','2013-06-16','07:55:00',5.01),('7643','2013-06-16','08:00:00',5.33),('7643','2013-06-16','08:05:00',5.61),('7643','2013-06-16','08:10:00',5.92),('7643','2013-06-16','08:15:00',6.14),('7643','2013-06-16','08:20:00',6.54),('7643','2013-06-16','08:25:00',6.83),('7643','2013-06-16','08:30:00',7.13),('7643','2013-06-16','08:35:00',7.48),('7643','2013-06-16','08:40:00',7.75),('7643','2013-06-16','08:45:00',8.04),('7643','2013-06-16','08:50:00',8.31),('7643','2013-06-16','08:55:00',8.61),('7643','2013-06-16','09:00:00',8.92),('7643','2013-06-16','09:05:00',9.28),('7643','2013-06-16','09:10:00',9.57),('7643','2013-06-16','09:15:00',9.86),('7643','2013-06-16','09:20:00',10.09),('7643','2013-06-16','09:25:00',10.3),('7643','2013-06-16','09:30:00',10.52),('7643','2013-06-16','09:35:00',10.71),('7643','2013-06-16','09:40:00',10.94),('7643','2013-06-16','09:45:00',11.19),('7643','2013-06-16','09:50:00',11.33),('7643','2013-06-16','09:55:00',11.53),('7643','2013-06-16','10:00:00',11.67),('7643','2013-06-16','10:05:00',11.83),('7643','2013-06-16','10:10:00',11.94),('7643','2013-06-16','10:15:00',12.17),('7643','2013-06-16','10:20:00',12.38),('7643','2013-06-16','10:25:00',12.46),('7643','2013-06-16','10:30:00',12.58),('7643','2013-06-16','10:35:00',12.82),('7643','2013-06-16','10:40:00',12.98),('7643','2013-06-16','10:45:00',13.14),('7643','2013-06-16','10:50:00',13.25),('7643','2013-06-16','10:55:00',13.3),('7643','2013-06-16','11:00:00',13.53),('7643','2013-06-16','11:05:00',13.61),('7643','2013-06-16','11:10:00',13.64),('7643','2013-06-16','11:15:00',13.77),('7643','2013-06-16','11:20:00',13.9),('7643','2013-06-16','11:25:00',14.02),('7643','2013-06-16','11:30:00',13.93),('7643','2013-06-16','11:35:00',14.2),('7643','2013-06-16','11:40:00',14.04),('7643','2013-06-16','11:45:00',14.14),('7643','2013-06-16','11:50:00',14.39),('7643','2013-06-16','11:55:00',14.43),('7643','2013-06-16','12:00:00',14.38),('7643','2013-06-16','12:05:00',14.44),('7643','2013-06-16','12:10:00',14.68),('7643','2013-06-16','12:15:00',14.71),('7643','2013-06-16','12:20:00',14.79),('7643','2013-06-16','12:25:00',14.74),('7643','2013-06-16','12:30:00',14.73),('7643','2013-06-16','12:35:00',14.63),('7643','2013-06-16','12:40:00',14.8),('7643','2013-06-16','12:45:00',14.61),('7643','2013-06-16','12:50:00',14.73),('7643','2013-06-16','12:55:00',14.88),('7643','2013-06-16','13:00:00',15.03),('7643','2013-06-16','13:05:00',15.24),('7643','2013-06-16','13:10:00',15.26),('7643','2013-06-16','13:15:00',15.29),('7643','2013-06-16','13:20:00',15.11),('7643','2013-06-16','13:25:00',15.02),('7643','2013-06-16','13:30:00',15.15),('7643','2013-06-16','13:35:00',15.1),('7643','2013-06-16','13:40:00',15.21),('7643','2013-06-16','13:45:00',15.27),('7643','2013-06-16','13:50:00',15.07),('7643','2013-06-16','13:55:00',15.08),('7643','2013-06-16','14:00:00',15.09),('7643','2013-06-16','14:05:00',15.09),('7643','2013-06-16','14:10:00',14.98),('7643','2013-06-16','14:15:00',14.9),('7643','2013-06-16','14:20:00',14.78),('7643','2013-06-16','14:25:00',14.81),('7643','2013-06-16','14:30:00',14.67),('7643','2013-06-16','14:35:00',14.67),('7643','2013-06-16','14:40:00',14.57),('7643','2013-06-16','14:45:00',14.5),('7643','2013-06-16','14:50:00',14.36),('7643','2013-06-16','14:55:00',14.23),('7643','2013-06-16','15:00:00',14.11),('7643','2013-06-16','15:05:00',13.99),('7643','2013-06-16','15:10:00',13.85),('7643','2013-06-16','15:15:00',13.66),('7643','2013-06-16','15:20:00',13.55),('7643','2013-06-16','15:25:00',13.44),('7643','2013-06-16','15:30:00',13.26),('7643','2013-06-16','15:35:00',13.19),('7643','2013-06-16','15:40:00',13),('7643','2013-06-16','15:45:00',12.77),('7643','2013-06-16','15:50:00',12.65),('7643','2013-06-16','15:55:00',12.47),('7643','2013-06-16','16:00:00',12.29),('7643','2013-06-16','16:05:00',12.16),('7643','2013-06-16','16:10:00',11.91),('7643','2013-06-16','16:15:00',11.75),('7643','2013-06-16','16:20:00',11.5),('7643','2013-06-16','16:25:00',11.27),('7643','2013-06-16','16:30:00',11.05),('7643','2013-06-16','16:35:00',10.78),('7643','2013-06-16','16:40:00',10.52),('7643','2013-06-16','16:45:00',10.27),('7643','2013-06-16','16:50:00',10.04),('7643','2013-06-16','16:55:00',9.85),('7643','2013-06-16','17:00:00',9.58),('7643','2013-06-16','17:05:00',9.27),('7643','2013-06-16','17:10:00',8.95),('7643','2013-06-16','17:15:00',8.66),('7643','2013-06-16','17:20:00',8.43),('7643','2013-06-16','17:25:00',8.17),('7643','2013-06-16','17:30:00',7.83),('7643','2013-06-16','17:35:00',7.59),('7643','2013-06-16','17:40:00',7.4),('7643','2013-06-16','17:45:00',7.09),('7643','2013-06-16','17:50:00',6.8),('7643','2013-06-16','17:55:00',6.47),('7643','2013-06-16','18:00:00',6.09),('7643','2013-06-16','18:05:00',5.88),('7643','2013-06-16','18:10:00',5.61),('7643','2013-06-16','18:15:00',5.3),('7643','2013-06-16','18:20:00',4.99),('7643','2013-06-16','18:25:00',4.48),('7643','2013-06-16','18:30:00',4.41),('7643','2013-06-16','18:35:00',3.86),('7643','2013-06-16','18:40:00',3.83),('7643','2013-06-16','18:45:00',3.58),('7643','2013-06-16','18:50:00',3.26),('7643','2013-06-16','18:55:00',2.93),('7643','2013-06-16','19:00:00',2.64),('7643','2013-06-16','19:05:00',2.46),('7643','2013-06-16','19:10:00',2.22),('7643','2013-06-16','19:15:00',1.93),('7643','2013-06-16','19:20:00',1.67),('7643','2013-06-16','19:25:00',1.47),('7643','2013-06-16','19:30:00',1.3),('7643','2013-06-16','19:35:00',1.11),('7643','2013-06-15','06:45:00',1.16),('7643','2013-06-15','06:50:00',1.35),('7643','2013-06-15','06:55:00',1.6),('7643','2013-06-15','07:00:00',1.81),('7643','2013-06-15','07:05:00',2.09),('7643','2013-06-15','07:10:00',2.38),('7643','2013-06-15','07:15:00',2.65),('7643','2013-06-15','07:20:00',2.96),('7643','2013-06-15','07:25:00',3.25),('7643','2013-06-15','07:30:00',3.57),('7643','2013-06-15','07:35:00',3.88),('7643','2013-06-15','07:40:00',4.22),('7643','2013-06-15','07:45:00',4.53),('7643','2013-06-15','07:50:00',4.79),('7643','2013-06-15','07:55:00',5.1),('7643','2013-06-15','08:00:00',5.4),('7643','2013-06-15','08:05:00',5.72),('7643','2013-06-15','08:10:00',6.03),('7643','2013-06-15','08:15:00',6.22),('7643','2013-06-15','08:20:00',6.59),('7643','2013-06-15','08:25:00',6.94),('7643','2013-06-15','08:30:00',7.28),('7643','2013-06-15','08:35:00',7.59),('7643','2013-06-15','08:40:00',7.97),('7643','2013-06-15','08:45:00',8.26),('7643','2013-06-15','08:50:00',8.42),('7643','2013-06-15','08:55:00',8.72),('7643','2013-06-15','09:00:00',9.1),('7643','2013-06-15','09:05:00',9.46),('7643','2013-06-15','09:10:00',9.73),('7643','2013-06-15','09:15:00',10.1),('7643','2013-06-15','09:20:00',10.35),('7643','2013-06-15','09:25:00',10.55),('7643','2013-06-15','09:30:00',10.69),('7643','2013-06-15','09:35:00',10.79),('7643','2013-06-15','09:40:00',11.07),('7643','2013-06-15','09:45:00',11.25),('7643','2013-06-15','09:50:00',11.43),('7643','2013-06-15','09:55:00',11.65),('7643','2013-06-15','10:00:00',11.83),('7643','2013-06-15','10:05:00',12.02),('7643','2013-06-15','10:10:00',12.3),('7643','2013-06-15','10:15:00',12.26),('7643','2013-06-15','10:20:00',12.45),('7643','2013-06-15','10:25:00',12.68),('7643','2013-06-15','10:30:00',12.94),('7643','2013-06-15','10:35:00',13.07),('7643','2013-06-15','10:40:00',13.19),('7643','2013-06-15','10:45:00',13.3),('7643','2013-06-15','10:50:00',13.47),('7643','2013-06-15','10:55:00',13.7),('7643','2013-06-15','11:00:00',13.86),('7643','2013-06-15','11:05:00',13.77),('7643','2013-06-15','11:10:00',13.96),('7643','2013-06-15','11:15:00',14.15),('7643','2013-06-15','11:20:00',14.34),('7643','2013-06-15','11:25:00',14.48),('7643','2013-06-15','11:30:00',14.52),('7643','2013-06-15','11:35:00',14.68),('7643','2013-06-15','11:40:00',14.78),('7643','2013-06-15','11:45:00',14.82),('7643','2013-06-15','11:50:00',14.9),('7643','2013-06-15','11:55:00',14.93),('7643','2013-06-15','12:00:00',15.11),('7643','2013-06-15','12:05:00',15.24),('7643','2013-06-15','12:10:00',15.36),('7643','2013-06-15','12:15:00',15.5),('7643','2013-06-15','12:20:00',15.64),('7643','2013-06-15','12:25:00',15.62),('7643','2013-06-15','12:30:00',15.56),('7643','2013-06-15','12:35:00',15.59),('7643','2013-06-15','12:40:00',15.58),('7643','2013-06-15','12:45:00',15.55),('7643','2013-06-15','12:50:00',15.44),('7643','2013-06-15','12:55:00',15.49),('7643','2013-06-15','13:00:00',15.6),('7643','2013-06-15','13:05:00',15.73),('7643','2013-06-15','13:10:00',15.74),('7643','2013-06-15','13:15:00',15.95),('7643','2013-06-15','13:20:00',15.92),('7643','2013-06-15','13:25:00',15.91),('7643','2013-06-15','13:30:00',15.82),('7643','2013-06-15','13:35:00',16),('7643','2013-06-15','13:40:00',15.97),('7643','2013-06-15','13:45:00',15.85),('7643','2013-06-15','13:50:00',15.72),('7643','2013-06-15','13:55:00',15.82),('7643','2013-06-15','14:00:00',15.77),('7643','2013-06-15','14:05:00',15.66),('7643','2013-06-15','14:10:00',15.66),('7643','2013-06-15','14:15:00',15.61),('7643','2013-06-15','14:20:00',15.57),('7643','2013-06-15','14:25:00',15.41),('7643','2013-06-15','14:30:00',15.37),('7643','2013-06-15','14:35:00',15.21),('7643','2013-06-15','14:40:00',15.14),('7643','2013-06-15','14:45:00',14.95),('7643','2013-06-15','14:50:00',14.94),('7643','2013-06-15','14:55:00',14.81),('7643','2013-06-15','15:00:00',14.67),('7643','2013-06-15','15:05:00',14.53),('7643','2013-06-15','15:10:00',14.38),('7643','2013-06-15','15:15:00',14.24),('7643','2013-06-15','15:20:00',14.14),('7643','2013-06-15','15:25:00',14.05),('7643','2013-06-15','15:30:00',13.82),('7643','2013-06-15','15:35:00',13.65),('7643','2013-06-15','15:40:00',13.48),('7643','2013-06-15','15:45:00',13.34),('7643','2013-06-15','15:50:00',13.13),('7643','2013-06-15','15:55:00',12.96),('7643','2013-06-15','16:00:00',12.72),('7643','2013-06-15','16:05:00',12.54),('7643','2013-06-15','16:10:00',12.33),('7643','2013-06-15','16:15:00',12.09),('7643','2013-06-15','16:20:00',11.82),('7643','2013-06-15','16:25:00',11.51),('7643','2013-06-15','16:30:00',11.28),('7643','2013-06-15','16:35:00',11.05),('7643','2013-06-15','16:40:00',10.75),('7643','2013-06-15','16:45:00',10.42),('7643','2013-06-15','16:50:00',10.19),('7643','2013-06-15','16:55:00',9.97),('7643','2013-06-15','17:00:00',9.69),('7643','2013-06-15','17:05:00',9.39),('7643','2013-06-15','17:10:00',9.05),('7643','2013-06-15','17:15:00',8.67),('7643','2013-06-15','17:20:00',8.39),('7643','2013-06-15','17:25:00',8.1),('7643','2013-06-15','17:30:00',7.83),('7643','2013-06-15','17:35:00',7.55),('7643','2013-06-15','17:40:00',7.26),('7643','2013-06-15','17:45:00',6.89),('7643','2013-06-15','17:50:00',6.56),('7643','2013-06-15','17:55:00',6.19),('7643','2013-06-15','18:00:00',5.89),('7643','2013-06-15','18:05:00',5.66),('7643','2013-06-15','18:10:00',5.39),('7643','2013-06-15','18:15:00',5.07),('7643','2013-06-15','18:20:00',4.73),('7643','2013-06-15','18:25:00',4.46),('7643','2013-06-15','18:30:00',4.16),('7643','2013-06-15','18:35:00',3.85),('7643','2013-06-15','18:40:00',3.53),('7643','2013-06-15','18:45:00',3.15),('7643','2013-06-15','18:50:00',2.83),('7643','2013-06-15','18:55:00',2.56),('7643','2013-06-15','19:00:00',2.25),('7643','2013-06-15','19:05:00',2.03),('7643','2013-06-15','19:10:00',1.8),('7643','2013-06-15','19:15:00',1.53),('7643','2013-06-15','19:20:00',1.27),('7643','2013-06-15','19:25:00',1.12),('7643','2013-06-14','06:40:00',1.04),('7643','2013-06-14','06:45:00',1.2),('7643','2013-06-14','06:50:00',1.37),('7643','2013-06-14','06:55:00',1.54),('7643','2013-06-14','07:00:00',1.77),('7643','2013-06-14','07:05:00',2.05),('7643','2013-06-14','07:10:00',2.35),('7643','2013-06-14','07:15:00',2.59),('7643','2013-06-14','07:20:00',2.86),('7643','2013-06-14','07:25:00',3.09),('7643','2013-06-14','07:30:00',3.42),('7643','2013-06-14','07:35:00',3.71),('7643','2013-06-14','07:40:00',4),('7643','2013-06-14','07:45:00',4.34),('7643','2013-06-14','07:50:00',4.64),('7643','2013-06-14','07:55:00',4.94),('7643','2013-06-14','08:00:00',5.22),('7643','2013-06-14','08:05:00',5.54),('7643','2013-06-14','08:10:00',5.89),('7643','2013-06-14','08:15:00',6.14),('7643','2013-06-14','08:20:00',6.48),('7643','2013-06-14','08:25:00',6.63),('7643','2013-06-14','08:30:00',6.76),('7643','2013-06-14','08:35:00',7.35),('7643','2013-06-14','08:40:00',7.31),('7643','2013-06-14','08:45:00',3.47),('7643','2013-06-14','08:50:00',7.21),('7643','2013-06-14','08:55:00',8.81),('7643','2013-06-14','09:00:00',7.59),('7643','2013-06-14','09:05:00',9.1),('7643','2013-06-14','09:10:00',9.71),('7643','2013-06-14','09:15:00',9.83),('7643','2013-06-14','09:20:00',10.03),('7643','2013-06-14','09:25:00',10.28),('7643','2013-06-14','09:30:00',10.77),('7643','2013-06-14','09:35:00',10.52),('7643','2013-06-14','09:40:00',8.1),('7643','2013-06-14','09:45:00',10.96),('7643','2013-06-14','09:50:00',11.11),('7643','2013-06-14','09:55:00',11.78),('7643','2013-06-14','10:00:00',12.36),('7643','2013-06-14','10:05:00',12.1),('7643','2013-06-14','10:10:00',12.31),('7643','2013-06-14','10:15:00',6.58),('7643','2013-06-14','10:20:00',7.68),('7643','2013-06-14','10:25:00',4.64),('7643','2013-06-14','10:30:00',10.5),('7643','2013-06-14','10:35:00',14.18),('7643','2013-06-14','10:40:00',13.46),('7643','2013-06-14','10:45:00',13.12),('7643','2013-06-14','10:50:00',11.71),('7643','2013-06-14','10:55:00',11.34),('7643','2013-06-14','11:00:00',11.1),('7643','2013-06-14','11:05:00',7.72),('7643','2013-06-14','11:10:00',14.18),('7643','2013-06-14','11:15:00',15.88),('7643','2013-06-14','11:20:00',12.85),('7643','2013-06-14','11:25:00',7.82),('7643','2013-06-14','11:30:00',7.23),('7643','2013-06-14','11:35:00',11.09),('7643','2013-06-14','11:40:00',15.8),('7643','2013-06-14','11:45:00',16.61),('7643','2013-06-14','11:50:00',14.69),('7643','2013-06-14','11:55:00',16.28),('7643','2013-06-14','12:00:00',15.88),('7643','2013-06-14','12:05:00',16.02),('7643','2013-06-14','12:10:00',16.3),('7643','2013-06-14','12:15:00',16.45),('7643','2013-06-14','12:20:00',16.19),('7643','2013-06-14','12:25:00',15.72),('7643','2013-06-14','12:30:00',15.94),('7643','2013-06-14','12:35:00',16.09),('7643','2013-06-14','12:40:00',16.02),('7643','2013-06-14','12:45:00',16.1),('7643','2013-06-14','12:50:00',16.07),('7643','2013-06-14','12:55:00',16.17),('7643','2013-06-14','13:00:00',16.15),('7643','2013-06-14','13:05:00',16.15),('7643','2013-06-14','13:10:00',16.08),('7643','2013-06-14','13:15:00',16.02),('7643','2013-06-14','13:20:00',15.87),('7643','2013-06-14','13:25:00',16),('7643','2013-06-14','13:30:00',15.86),('7643','2013-06-14','13:35:00',15.71),('7643','2013-06-14','13:40:00',15.89),('7643','2013-06-14','13:45:00',15.8),('7643','2013-06-14','13:50:00',15.75),('7643','2013-06-14','13:55:00',15.61),('7643','2013-06-14','14:00:00',15.69),('7643','2013-06-14','14:05:00',15.62),('7643','2013-06-14','14:10:00',15.61),('7643','2013-06-14','14:15:00',15.45),('7643','2013-06-14','14:20:00',15.36),('7643','2013-06-14','14:25:00',15.37),('7643','2013-06-14','14:30:00',15.31),('7643','2013-06-14','14:35:00',15.22),('7643','2013-06-14','14:40:00',15.2),('7643','2013-06-14','14:45:00',14.93),('7643','2013-06-14','14:50:00',14.9),('7643','2013-06-14','14:55:00',14.76),('7643','2013-06-14','15:00:00',14.37),('7643','2013-06-14','15:05:00',14.37),('7643','2013-06-14','15:10:00',14.31),('7643','2013-06-14','15:15:00',14.2),('7643','2013-06-14','15:20:00',14.27),('7643','2013-06-14','15:25:00',14.1),('7643','2013-06-14','15:30:00',13.98),('7643','2013-06-14','15:35:00',13.77),('7643','2013-06-14','15:40:00',13.57),('7643','2013-06-14','15:45:00',13.35),('7643','2013-06-14','15:50:00',13.09),('7643','2013-06-14','15:55:00',12.95),('7643','2013-06-14','16:00:00',12.77),('7643','2013-06-14','16:05:00',12.47),('7643','2013-06-14','16:10:00',12.21),('7643','2013-06-14','16:15:00',12.01),('7643','2013-06-14','16:20:00',11.71),('7643','2013-06-14','16:25:00',11.43),('7643','2013-06-14','16:30:00',11.24),('7643','2013-06-14','16:35:00',10.96),('7643','2013-06-14','16:40:00',10.75),('7643','2013-06-14','16:45:00',10.45),('7643','2013-06-14','16:50:00',10.2),('7643','2013-06-14','16:55:00',9.93),('7643','2013-06-14','17:00:00',9.69),('7643','2013-06-14','17:05:00',9.32),('7643','2013-06-14','17:10:00',9.04),('7643','2013-06-14','17:15:00',8.63),('7643','2013-06-14','17:20:00',8.39),('7643','2013-06-14','17:25:00',8.05),('7643','2013-06-14','17:30:00',7.65),('7643','2013-06-14','17:35:00',7.48),('7643','2013-06-14','17:40:00',7.27),('7643','2013-06-14','17:45:00',6.86),('7643','2013-06-14','17:50:00',6.51),('7643','2013-06-14','17:55:00',6.16),('7643','2013-06-14','18:00:00',5.78),('7643','2013-06-14','18:05:00',5.54),('7643','2013-06-14','18:10:00',5.28),('7643','2013-06-14','18:15:00',5.01),('7643','2013-06-14','18:20:00',4.69),('7643','2013-06-14','18:25:00',4.37),('7643','2013-06-14','18:30:00',4.05),('7643','2013-06-14','18:35:00',3.79),('7643','2013-06-14','18:40:00',3.45),('7643','2013-06-14','18:45:00',3.07),('7643','2013-06-14','18:50:00',2.71),('7643','2013-06-14','18:55:00',2.37),('7643','2013-06-14','19:00:00',2.14),('7643','2013-06-14','19:05:00',2.03),('7643','2013-06-14','19:10:00',1.78),('7643','2013-06-14','19:15:00',1.54),('7643','2013-06-14','19:20:00',1.3),('7643','2013-06-14','19:25:00',1.16),('7643','2013-06-14','19:30:00',1.01),('7643','2013-06-13','06:45:00',1.18),('7643','2013-06-13','06:50:00',1.39),('7643','2013-06-13','06:55:00',1.68),('7643','2013-06-13','07:00:00',1.93),('7643','2013-06-13','07:05:00',2.24),('7643','2013-06-13','07:10:00',2.55),('7643','2013-06-13','07:15:00',2.87),('7643','2013-06-13','07:20:00',3.19),('7643','2013-06-13','07:25:00',3.52),('7643','2013-06-13','07:30:00',3.84),('7643','2013-06-13','07:35:00',4.18),('7643','2013-06-13','07:40:00',4.58),('7643','2013-06-13','07:45:00',4.88),('7643','2013-06-13','07:50:00',5.18),('7643','2013-06-13','07:55:00',5.55),('7643','2013-06-13','08:00:00',5.85),('7643','2013-06-13','08:05:00',6.13),('7643','2013-06-13','08:10:00',6.44),('7643','2013-06-13','08:15:00',6.68),('7643','2013-06-13','08:20:00',7.02),('7643','2013-06-13','08:25:00',7.33),('7643','2013-06-13','08:30:00',7.71),('7643','2013-06-13','08:35:00',8),('7643','2013-06-13','08:40:00',8.32),('7643','2013-06-13','08:45:00',8.66),('7643','2013-06-13','08:50:00',8.96),('7643','2013-06-13','08:55:00',9.26),('7643','2013-06-13','09:00:00',9.57),('7643','2013-06-13','09:05:00',9.92),('7643','2013-06-13','09:10:00',10.21),('7643','2013-06-13','09:15:00',10.49),('7643','2013-06-13','09:20:00',10.69),('7643','2013-06-13','09:25:00',10.9),('7643','2013-06-13','09:30:00',11.03),('7643','2013-06-13','09:35:00',11.36),('7643','2013-06-13','09:40:00',11.63),('7643','2013-06-13','09:45:00',11.87),('7643','2013-06-13','09:50:00',12.11),('7643','2013-06-13','09:55:00',12.3),('7643','2013-06-13','10:00:00',12.47),('7643','2013-06-13','10:05:00',12.6),('7643','2013-06-13','10:10:00',12.62),('7643','2013-06-13','10:15:00',12.81),('7643','2013-06-13','10:20:00',13.07),('7643','2013-06-13','10:25:00',13.15),('7643','2013-06-13','10:30:00',13.35),('7643','2013-06-13','10:35:00',13.78),('7643','2013-06-13','10:40:00',13.95),('7643','2013-06-13','10:45:00',13.99),('7643','2013-06-13','10:50:00',13.96),('7643','2013-06-13','10:55:00',14.01),('7643','2013-06-13','11:00:00',14.03),('7643','2013-06-13','11:05:00',14.15),('7643','2013-06-13','11:10:00',14.41),('7643','2013-06-13','11:15:00',14.58),('7643','2013-06-13','11:20:00',14.59),('7643','2013-06-13','11:25:00',14.46),('7643','2013-06-13','11:30:00',15.23),('7643','2013-06-13','11:35:00',15.32),('7643','2013-06-13','11:40:00',15.18),('7643','2013-06-13','11:45:00',15.23),('7643','2013-06-13','11:50:00',15.41),('7643','2013-06-13','11:55:00',15.31),('7643','2013-06-13','12:00:00',15.38),('7643','2013-06-13','12:05:00',15.44),('7643','2013-06-13','12:10:00',15.49),('7643','2013-06-13','12:15:00',15.51),('7643','2013-06-13','12:20:00',15.64),('7643','2013-06-13','12:25:00',15.63),('7643','2013-06-13','12:30:00',15.52),('7643','2013-06-13','12:35:00',15.84),('7643','2013-06-13','12:40:00',15.92),('7643','2013-06-13','12:45:00',15.97),('7643','2013-06-13','12:50:00',15.88),('7643','2013-06-13','12:55:00',15.75),('7643','2013-06-13','13:00:00',15.64),('7643','2013-06-13','13:05:00',15.75),('7643','2013-06-13','13:10:00',15.82),('7643','2013-06-13','13:15:00',16.34),('7643','2013-06-13','13:20:00',16.38),('7643','2013-06-13','13:25:00',16.34),('7643','2013-06-13','13:30:00',16.11),('7643','2013-06-13','13:35:00',16.19),('7643','2013-06-13','13:40:00',15.82),('7643','2013-06-13','13:45:00',15.97),('7643','2013-06-13','13:50:00',16.2),('7643','2013-06-13','13:55:00',16.21),('7643','2013-06-13','14:00:00',16),('7643','2013-06-13','14:05:00',15.97),('7643','2013-06-13','14:10:00',16.08),('7643','2013-06-13','14:15:00',15.74),('7643','2013-06-13','14:20:00',15.6),('7643','2013-06-13','14:25:00',15.5),('7643','2013-06-13','14:30:00',15.58),('7643','2013-06-13','14:35:00',15.55),('7643','2013-06-13','14:40:00',15.5),('7643','2013-06-13','14:45:00',15.29),('7643','2013-06-13','14:50:00',15.05),('7643','2013-06-13','14:55:00',15.11),('7643','2013-06-13','15:00:00',14.99),('7643','2013-06-13','15:05:00',14.9),('7643','2013-06-13','15:10:00',14.68),('7643','2013-06-13','15:15:00',14.53),('7643','2013-06-13','15:20:00',14.4),('7643','2013-06-13','15:25:00',14.22),('7643','2013-06-13','15:30:00',14.03),('7643','2013-06-13','15:35:00',13.91),('7643','2013-06-13','15:40:00',13.79),('7643','2013-06-13','15:45:00',13.61),('7643','2013-06-13','15:50:00',13.47),('7643','2013-06-13','15:55:00',13.28),('7643','2013-06-13','16:00:00',13.04),('7643','2013-06-13','16:05:00',12.8),('7643','2013-06-13','16:10:00',12.58),('7643','2013-06-13','16:15:00',12.27),('7643','2013-06-13','16:20:00',11.99),('7643','2013-06-13','16:25:00',11.66),('7643','2013-06-13','16:30:00',11.42),('7643','2013-06-13','16:35:00',11.18),('7643','2013-06-13','16:40:00',10.76),('7643','2013-06-13','16:45:00',10.59),('7643','2013-06-13','16:50:00',10.34),('7643','2013-06-13','16:55:00',10.1),('7643','2013-06-13','17:00:00',9.83),('7643','2013-06-13','17:05:00',9.15),('7643','2013-06-13','17:10:00',8.99),('7643','2013-06-13','17:15:00',8.86),('7643','2013-06-13','17:20:00',8.51),('7643','2013-06-13','17:25:00',8.16),('7643','2013-06-13','17:30:00',7.69),('7643','2013-06-13','17:35:00',7.57),('7643','2013-06-13','17:40:00',7.45),('7643','2013-06-13','17:45:00',7.16),('7643','2013-06-13','17:50:00',6.85),('7643','2013-06-13','17:55:00',6.46),('7643','2013-06-13','18:00:00',6.08),('7643','2013-06-13','18:05:00',5.91),('7643','2013-06-13','18:10:00',5.57),('7643','2013-06-13','18:15:00',5.3),('7643','2013-06-13','18:20:00',4.97),('7643','2013-06-13','18:25:00',4.65),('7643','2013-06-13','18:30:00',4.34),('7643','2013-06-13','18:35:00',4.01),('7643','2013-06-13','18:40:00',3.67),('7643','2013-06-13','18:45:00',3.29),('7643','2013-06-13','18:50:00',2.93),('7643','2013-06-13','18:55:00',2.63),('7643','2013-06-13','19:00:00',2.33),('7643','2013-06-13','19:05:00',2.1),('7643','2013-06-13','19:10:00',1.84),('7643','2013-06-13','19:15:00',1.55),('7643','2013-06-13','19:20:00',1.29),('7643','2013-06-13','19:25:00',1.13),('7643','2013-06-12','06:45:00',1.19),('7643','2013-06-12','06:50:00',1.42),('7643','2013-06-12','06:55:00',1.71),('7643','2013-06-12','07:00:00',1.95),('7643','2013-06-12','07:05:00',2.27),('7643','2013-06-12','07:10:00',2.58),('7643','2013-06-12','07:15:00',2.91),('7643','2013-06-12','07:20:00',3.23),('7643','2013-06-12','07:25:00',3.56),('7643','2013-06-12','07:30:00',3.9),('7643','2013-06-12','07:35:00',4.26),('7643','2013-06-12','07:40:00',4.64),('7643','2013-06-12','07:45:00',4.95),('7643','2013-06-12','07:50:00',5.26),('7643','2013-06-12','07:55:00',5.59),('7643','2013-06-12','08:00:00',5.91),('7643','2013-06-12','08:05:00',6.23),('7643','2013-06-12','08:10:00',6.53),('7643','2013-06-12','08:15:00',6.71),('7643','2013-06-12','08:20:00',6.98),('7643','2013-06-12','08:25:00',7.29),('7643','2013-06-12','08:30:00',7.74),('7643','2013-06-12','08:35:00',8.1),('7643','2013-06-12','08:40:00',8.38),('7643','2013-06-12','08:45:00',8.74),('7643','2013-06-12','08:50:00',9.01),('7643','2013-06-12','08:55:00',9.34),('7643','2013-06-12','09:00:00',9.67),('7643','2013-06-12','09:05:00',10),('7643','2013-06-12','09:10:00',10.28),('7643','2013-06-12','09:15:00',10.68),('7643','2013-06-12','09:20:00',10.96),('7643','2013-06-12','09:25:00',11.29),('7643','2013-06-12','09:30:00',11.58),('7643','2013-06-12','09:35:00',11.79),('7643','2013-06-12','09:40:00',12),('7643','2013-06-12','09:45:00',12.22),('7643','2013-06-12','09:50:00',12.38),('7643','2013-06-12','09:55:00',12.66),('7643','2013-06-12','10:00:00',12.87),('7643','2013-06-12','10:05:00',13.05),('7643','2013-06-12','10:10:00',13.24),('7643','2013-06-12','10:15:00',13.43),('7643','2013-06-12','10:20:00',13.57),('7643','2013-06-12','10:25:00',13.75),('7643','2013-06-12','10:30:00',14.02),('7643','2013-06-12','10:35:00',14.18),('7643','2013-06-12','10:40:00',14.28),('7643','2013-06-12','10:45:00',14.54),('7643','2013-06-12','10:50:00',14.7),('7643','2013-06-12','10:55:00',14.83),('7643','2013-06-12','11:00:00',14.92),('7643','2013-06-12','11:05:00',15.15),('7643','2013-06-12','11:10:00',15.31),('7643','2013-06-12','11:15:00',15.4),('7643','2013-06-12','11:20:00',15.51),('7643','2013-06-12','11:25:00',15.63),('7643','2013-06-12','11:30:00',15.66),('7643','2013-06-12','11:35:00',15.85),('7643','2013-06-12','11:40:00',15.98),('7643','2013-06-12','11:45:00',16.21),('7643','2013-06-12','11:50:00',16.22),('7643','2013-06-12','11:55:00',16.23),('7643','2013-06-12','12:00:00',16.29),('7643','2013-06-12','12:05:00',16.5),('7643','2013-06-12','12:10:00',16.51),('7643','2013-06-12','12:15:00',16.56),('7643','2013-06-12','12:20:00',16.59),('7643','2013-06-12','12:25:00',16.74),('7643','2013-06-12','12:30:00',16.74),('7643','2013-06-12','12:35:00',16.71),('7643','2013-06-12','12:40:00',16.74),('7643','2013-06-12','12:45:00',16.79),('7643','2013-06-12','12:50:00',16.84),('7643','2013-06-12','12:55:00',16.73),('7643','2013-06-12','13:00:00',16.75),('7643','2013-06-12','13:05:00',16.8),('7643','2013-06-12','13:10:00',16.72),('7643','2013-06-12','13:15:00',16.63),('7643','2013-06-12','13:20:00',16.46),('7643','2013-06-12','13:25:00',16.63),('7643','2013-06-12','13:30:00',16.5),('7643','2013-06-12','13:35:00',16.48),('7643','2013-06-12','13:40:00',16.49),('7643','2013-06-12','13:45:00',16.47),('7643','2013-06-12','13:50:00',16.44),('7643','2013-06-12','13:55:00',16.45),('7643','2013-06-12','14:00:00',16.49),('7643','2013-06-12','14:05:00',16.37),('7643','2013-06-12','14:10:00',16.18),('7643','2013-06-12','14:15:00',16.08),('7643','2013-06-12','14:20:00',16.08),('7643','2013-06-12','14:25:00',14.88),('7643','2013-06-12','14:30:00',15.1),('7643','2013-06-12','14:35:00',10.91),('7643','2013-06-12','14:40:00',15.4),('7643','2013-06-12','14:45:00',15.82),('7643','2013-06-12','14:50:00',15.41),('7643','2013-06-12','14:55:00',15.33),('7643','2013-06-12','15:00:00',15.26),('7643','2013-06-12','15:05:00',15.07),('7643','2013-06-12','15:10:00',14.85),('7643','2013-06-12','15:15:00',14.63),('7643','2013-06-12','15:20:00',14.41),('7643','2013-06-12','15:25:00',14.34),('7643','2013-06-12','15:30:00',14.21),('7643','2013-06-12','15:35:00',14.03),('7643','2013-06-12','15:40:00',13.74),('7643','2013-06-12','15:45:00',13.59),('7643','2013-06-12','15:50:00',13.42),('7643','2013-06-12','15:55:00',13.23),('7643','2013-06-12','16:00:00',13.04),('7643','2013-06-12','16:05:00',12.82),('7643','2013-06-12','16:10:00',12.49),('7643','2013-06-12','16:15:00',12.21),('7643','2013-06-12','16:20:00',11.88),('7643','2013-06-12','16:25:00',11.61),('7643','2013-06-12','16:30:00',11.43),('7643','2013-06-12','16:35:00',11.16),('7643','2013-06-12','16:40:00',10.84),('7643','2013-06-12','16:45:00',10.55),('7643','2013-06-12','16:50:00',10.15),('7643','2013-06-12','16:55:00',9.94),('7643','2013-06-12','17:00:00',9.71),('7643','2013-06-12','17:05:00',9.32),('7643','2013-06-12','17:10:00',9.03),('7643','2013-06-12','17:15:00',8.71),('7643','2013-06-12','17:20:00',8.44),('7643','2013-06-12','17:25:00',8.23),('7643','2013-06-12','17:30:00',7.87),('7643','2013-06-12','17:35:00',7.6),('7643','2013-06-12','17:40:00',7.43),('7643','2013-06-12','17:45:00',7.13),('7643','2013-06-12','17:50:00',6.84),('7643','2013-06-12','17:55:00',6.42),('7643','2013-06-12','18:00:00',6.03),('7643','2013-06-12','18:05:00',5.71),('7643','2013-06-12','18:10:00',5.39),('7643','2013-06-12','18:15:00',5.15),('7643','2013-06-12','18:20:00',4.89),('7643','2013-06-12','18:25:00',4.59),('7643','2013-06-12','18:30:00',4.27),('7643','2013-06-12','18:35:00',3.93),('7643','2013-06-12','18:40:00',3.54),('7643','2013-06-12','18:45:00',3.14),('7643','2013-06-12','18:50:00',2.83),('7643','2013-06-12','18:55:00',2.55),('7643','2013-06-12','19:00:00',2.23),('7643','2013-06-12','19:05:00',1.99),('7643','2013-06-12','19:10:00',1.77),('7643','2013-06-12','19:15:00',1.5),('7643','2013-06-12','19:20:00',1.27),('7643','2013-06-12','19:25:00',1.1),('7643','2013-06-11','06:45:00',1.18),('7643','2013-06-11','06:50:00',1.41),('7643','2013-06-11','06:55:00',1.7),('7643','2013-06-11','07:00:00',1.95),('7643','2013-06-11','07:05:00',2.27),('7643','2013-06-11','07:10:00',2.59),('7643','2013-06-11','07:15:00',2.91),('7643','2013-06-11','07:20:00',3.25),('7643','2013-06-11','07:25:00',3.58),('7643','2013-06-11','07:30:00',3.92),('7643','2013-06-11','07:35:00',4.25),('7643','2013-06-11','07:40:00',4.62),('7643','2013-06-11','07:45:00',4.97),('7643','2013-06-11','07:50:00',5.33),('7643','2013-06-11','07:55:00',5.69),('7643','2013-06-11','08:00:00',5.97),('7643','2013-06-11','08:05:00',6.28),('7643','2013-06-11','08:10:00',6.58),('7643','2013-06-11','08:15:00',6.88),('7643','2013-06-11','08:20:00',7.28),('7643','2013-06-11','08:25:00',7.64),('7643','2013-06-11','08:30:00',8),('7643','2013-06-11','08:35:00',8.28),('7643','2013-06-11','08:40:00',8.6),('7643','2013-06-11','08:45:00',8.99),('7643','2013-06-11','08:50:00',9.34),('7643','2013-06-11','08:55:00',9.64),('7643','2013-06-11','09:00:00',9.96),('7643','2013-06-11','09:05:00',10.33),('7643','2013-06-11','09:10:00',10.68),('7643','2013-06-11','09:15:00',10.95),('7643','2013-06-11','09:20:00',11.21),('7643','2013-06-11','09:25:00',11.45),('7643','2013-06-11','09:30:00',11.71),('7643','2013-06-11','09:35:00',11.92),('7643','2013-06-11','09:40:00',12.19),('7643','2013-06-11','09:45:00',12.41),('7643','2013-06-11','09:50:00',12.67),('7643','2013-06-11','09:55:00',12.93),('7643','2013-06-11','10:00:00',13.05),('7643','2013-06-11','10:05:00',13.18),('7643','2013-06-11','10:10:00',13.36),('7643','2013-06-11','10:15:00',13.49),('7643','2013-06-11','10:20:00',13.7),('7643','2013-06-11','10:25:00',13.93),('7643','2013-06-11','10:30:00',14.15),('7643','2013-06-11','10:35:00',14.21),('7643','2013-06-11','10:40:00',14.31),('7643','2013-06-11','10:45:00',14.54),('7643','2013-06-11','10:50:00',14.78),('7643','2013-06-11','10:55:00',14.98),('7643','2013-06-11','11:00:00',15.28),('7643','2013-06-11','11:05:00',15.34),('7643','2013-06-11','11:10:00',15.49),('7643','2013-06-11','11:15:00',15.64),('7643','2013-06-11','11:20:00',15.69),('7643','2013-06-11','11:25:00',15.73),('7643','2013-06-11','11:30:00',15.85),('7643','2013-06-11','11:35:00',15.92),('7643','2013-06-11','11:40:00',15.99),('7643','2013-06-11','11:45:00',16.08),('7643','2013-06-11','11:50:00',16.07),('7643','2013-06-11','11:55:00',16.47),('7643','2013-06-11','12:00:00',16.41),('7643','2013-06-11','12:05:00',16.58),('7643','2013-06-11','12:10:00',16.53),('7643','2013-06-11','12:15:00',16.65),('7643','2013-06-11','12:20:00',16.79),('7643','2013-06-11','12:25:00',17.48),('7643','2013-06-11','12:30:00',14.15),('7643','2013-06-11','12:35:00',17.81),('7643','2013-06-11','12:40:00',7.99),('7643','2013-06-11','12:45:00',10.25),('7643','2013-06-11','12:50:00',18.1),('7643','2013-06-11','12:55:00',12.62),('7643','2013-06-11','13:00:00',14.97),('7643','2013-06-11','13:05:00',11.95),('7643','2013-06-11','13:10:00',17.44),('7643','2013-06-11','13:15:00',16.99),('7643','2013-06-11','13:20:00',16.65),('7643','2013-06-11','13:25:00',16.47),('7643','2013-06-11','13:30:00',16.57),('7643','2013-06-11','13:35:00',16.7),('7643','2013-06-11','13:40:00',16.76),('7643','2013-06-11','13:45:00',16.88),('7643','2013-06-11','13:50:00',16.81),('7643','2013-06-11','13:55:00',17.08),('7643','2013-06-11','14:00:00',17.02),('7643','2013-06-11','14:05:00',11.77),('7643','2013-06-11','14:10:00',12.59),('7643','2013-06-11','14:15:00',17.87),('7643','2013-06-11','14:20:00',9.8),('7643','2013-06-11','14:25:00',6.16),('7643','2013-06-11','14:30:00',17.21),('7643','2013-06-11','14:35:00',17.03),('7643','2013-06-11','14:40:00',16.84),('7643','2013-06-11','14:45:00',16.53),('7643','2013-06-11','14:50:00',16.47),('7643','2013-06-11','14:55:00',16.78),('7643','2013-06-11','15:00:00',16.56),('7643','2013-06-11','15:05:00',15.81),('7643','2013-06-11','15:10:00',15.85),('7643','2013-06-11','15:15:00',12.98),('7643','2013-06-11','15:20:00',15.64),('7643','2013-06-11','15:25:00',14.83),('7643','2013-06-11','15:30:00',14.75),('7643','2013-06-11','15:35:00',14.65),('7643','2013-06-11','15:40:00',14.42),('7643','2013-06-11','15:45:00',14.35),('7643','2013-06-11','15:50:00',13.92),('7643','2013-06-11','15:55:00',13.87),('7643','2013-06-11','16:00:00',13.41),('7643','2013-06-11','16:05:00',12.98),('7643','2013-06-11','16:10:00',13.04),('7643','2013-06-11','16:15:00',12.71),('7643','2013-06-11','16:20:00',12.28),('7643','2013-06-11','16:25:00',12.21),('7643','2013-06-11','16:30:00',11.98),('7643','2013-06-11','16:35:00',11.58),('7643','2013-06-11','16:40:00',11.43),('7643','2013-06-11','16:45:00',10.67),('7643','2013-06-11','16:50:00',10.73),('7643','2013-06-11','16:55:00',10.38),('7643','2013-06-11','17:00:00',9.93),('7643','2013-06-11','17:05:00',9.79),('7643','2013-06-11','17:10:00',9.53),('7643','2013-06-11','17:15:00',9.15),('7643','2013-06-11','17:20:00',8.72),('7643','2013-06-11','17:25:00',8.44),('7643','2013-06-11','17:30:00',8.17),('7643','2013-06-11','17:35:00',7.95),('7643','2013-06-11','17:40:00',7.79),('7643','2013-06-11','17:45:00',7.37),('7643','2013-06-11','17:50:00',5.21),('7643','2013-06-11','17:55:00',2.28),('7643','2013-06-11','18:00:00',2.74),('7643','2013-06-11','18:05:00',6.17),('7643','2013-06-11','18:10:00',5.69),('7643','2013-06-11','18:15:00',5.43),('7643','2013-06-11','18:20:00',5.1),('7643','2013-06-11','18:25:00',4.35),('7643','2013-06-11','18:30:00',4.32),('7643','2013-06-11','18:35:00',4),('7643','2013-06-11','18:40:00',3.63),('7643','2013-06-11','18:45:00',3.17),('7643','2013-06-11','18:50:00',2.8),('7643','2013-06-11','18:55:00',2.53),('7643','2013-06-11','19:00:00',2.25),('7643','2013-06-11','19:05:00',1.99),('7643','2013-06-11','19:10:00',1.11),('7643','2013-06-11','19:15:00',1.27),('7643','2013-06-11','19:20:00',1.3),('7643','2013-06-11','19:25:00',1.08),('7643','2013-06-10','06:45:00',1.14),('7643','2013-06-10','06:50:00',1.36),('7643','2013-06-10','06:55:00',1.55),('7643','2013-06-10','07:00:00',1.76),('7643','2013-06-10','07:05:00',1.84),('7643','2013-06-10','07:10:00',2.01),('7643','2013-06-10','07:15:00',2.31),('7643','2013-06-10','07:20:00',2.82),('7643','2013-06-10','07:25:00',4.19),('7643','2013-06-10','07:30:00',3.97),('7643','2013-06-10','07:35:00',4.21),('7643','2013-06-10','07:40:00',3.97),('7643','2013-06-10','07:45:00',3),('7643','2013-06-10','07:50:00',5.53),('7643','2013-06-10','07:55:00',4.59),('7643','2013-06-10','08:00:00',4.95),('7643','2013-06-10','08:05:00',6.87),('7643','2013-06-10','08:10:00',7.37),('7643','2013-06-10','08:15:00',6.17),('7643','2013-06-10','08:20:00',2.69),('7643','2013-06-10','08:25:00',3.62),('7643','2013-06-10','08:30:00',3.84),('7643','2013-06-10','08:35:00',1.93),('7643','2013-06-10','08:40:00',7.52),('7643','2013-06-10','08:45:00',9.71),('7643','2013-06-10','08:50:00',7.37),('7643','2013-06-10','08:55:00',9.9),('7643','2013-06-10','09:00:00',4.84),('7643','2013-06-10','09:05:00',2.59),('7643','2013-06-10','09:10:00',7.59),('7643','2013-06-10','09:15:00',11.61),('7643','2013-06-10','09:20:00',11.77),('7643','2013-06-10','09:25:00',12.78),('7643','2013-06-10','09:30:00',8.81),('7643','2013-06-10','09:35:00',8.64),('7643','2013-06-10','09:40:00',2.89),('7643','2013-06-10','09:45:00',7.35),('7643','2013-06-10','09:50:00',12.51),('7643','2013-06-10','09:55:00',13.7),('7643','2013-06-10','10:00:00',13.84),('7643','2013-06-10','10:05:00',13.6),('7643','2013-06-10','10:10:00',13.38),('7643','2013-06-10','10:15:00',14.02),('7643','2013-06-10','10:20:00',14.32),('7643','2013-06-10','10:25:00',14.48),('7643','2013-06-10','10:30:00',14.41),('7643','2013-06-10','10:35:00',14.56),('7643','2013-06-10','10:40:00',13.6),('7643','2013-06-10','10:45:00',9.58),('7643','2013-06-10','10:50:00',14.19),('7643','2013-06-10','10:55:00',3.57),('7643','2013-06-10','11:00:00',9.51),('7643','2013-06-10','11:05:00',16.63),('7643','2013-06-10','11:10:00',7.05),('7643','2013-06-10','11:15:00',9.43),('7643','2013-06-10','11:20:00',16.17),('7643','2013-06-10','11:25:00',16.35),('7643','2013-06-10','11:30:00',16.39),('7643','2013-06-10','11:35:00',16.21),('7643','2013-06-10','11:40:00',16.26),('7643','2013-06-10','11:45:00',16.5),('7643','2013-06-10','11:50:00',16.68),('7643','2013-06-10','11:55:00',16.7),('7643','2013-06-10','12:00:00',16.87),('7643','2013-06-10','12:05:00',17.44),('7643','2013-06-10','12:10:00',16.67),('7643','2013-06-10','12:15:00',16.97),('7643','2013-06-10','12:20:00',17.09),('7643','2013-06-10','12:25:00',17.02),('7643','2013-06-10','12:30:00',17.12),('7643','2013-06-10','12:35:00',17.13),('7643','2013-06-10','12:40:00',17.16),('7643','2013-06-10','12:45:00',17.18),('7643','2013-06-10','12:50:00',17.39),('7643','2013-06-10','12:55:00',17.42),('7643','2013-06-10','13:00:00',17.4),('7643','2013-06-10','13:05:00',17.5),('7643','2013-06-10','13:10:00',17.49),('7643','2013-06-10','13:15:00',17.41),('7643','2013-06-10','13:20:00',17.46),('7643','2013-06-10','13:25:00',17.35),('7643','2013-06-10','13:30:00',17.42),('7643','2013-06-10','13:35:00',17.49),('7643','2013-06-10','13:40:00',17.62),('7643','2013-06-10','13:45:00',17.52),('7643','2013-06-10','13:50:00',17.76),('7643','2013-06-10','13:55:00',16.7),('7643','2013-06-10','14:00:00',17.36),('7643','2013-06-10','14:05:00',17.3),('7643','2013-06-10','14:10:00',17.08),('7643','2013-06-10','14:15:00',16.86),('7643','2013-06-10','14:20:00',16.76),('7643','2013-06-10','14:25:00',16.6),('7643','2013-06-10','14:30:00',16.56),('7643','2013-06-10','14:35:00',16.44),('7643','2013-06-10','14:40:00',16.27),('7643','2013-06-10','14:45:00',16.15),('7643','2013-06-10','14:50:00',15.96),('7643','2013-06-10','14:55:00',15.88),('7643','2013-06-10','15:00:00',15.72),('7643','2013-06-10','15:05:00',15.6),('7643','2013-06-10','15:10:00',15.43),('7643','2013-06-10','15:15:00',15.25),('7643','2013-06-10','15:20:00',15.14),('7643','2013-06-10','15:25:00',14.89),('7643','2013-06-10','15:30:00',14.76),('7643','2013-06-10','15:35:00',14.78),('7643','2013-06-10','15:40:00',14.7),('7643','2013-06-10','15:45:00',14.79),('7643','2013-06-10','15:50:00',14.16),('7643','2013-06-10','15:55:00',13.97),('7643','2013-06-10','16:00:00',13.85),('7643','2013-06-10','16:05:00',13.6),('7643','2013-06-10','16:10:00',13.31),('7643','2013-06-10','16:15:00',12.97),('7643','2013-06-10','16:20:00',12.69),('7643','2013-06-10','16:25:00',12.45),('7643','2013-06-10','16:30:00',12.25),('7643','2013-06-10','16:35:00',12),('7643','2013-06-10','16:40:00',11.99),('7643','2013-06-10','16:45:00',12.54),('7643','2013-06-10','16:50:00',12.68),('7643','2013-06-10','16:55:00',12.23),('7643','2013-06-10','17:00:00',11.01),('7643','2013-06-10','17:05:00',7.72),('7643','2013-06-10','17:10:00',3.68),('7643','2013-06-10','17:15:00',2.52),('7643','2013-06-10','17:20:00',2.04),('7643','2013-06-10','17:25:00',1.56),('7643','2013-06-10','17:30:00',1.25),('7643','2013-06-10','19:10:00',1.29),('7643','2013-06-10','19:15:00',1.87),('7643','2013-06-10','19:20:00',1.82),('7643','2013-06-10','19:25:00',1.63),('7643','2013-06-10','19:30:00',2.05),('7643','2013-06-10','19:35:00',1.69),('7643','2014-04-02','07:45:00',1.12),('7643','2014-04-02','07:50:00',1.27),('7643','2014-04-02','07:55:00',1.42),('7643','2014-04-02','08:00:00',1.61),('7643','2014-04-02','08:05:00',1.81),('7643','2014-04-02','08:10:00',1.99),('7643','2014-04-02','08:15:00',2.1),('7643','2014-04-02','08:20:00',2.28),('7643','2014-04-02','08:25:00',2.37),('7643','2014-04-02','08:30:00',2.57),('7643','2014-04-02','08:35:00',2.75),('7643','2014-04-02','08:40:00',3.03),('7643','2014-04-02','08:45:00',3.56),('7643','2014-04-02','08:50:00',3.68),('7643','2014-04-02','08:55:00',4.26),('7643','2014-04-02','09:00:00',4.74),('7643','2014-04-02','09:05:00',5.17),('7643','2014-04-02','09:10:00',5),('7643','2014-04-02','09:15:00',4.59),('7643','2014-04-02','09:20:00',4.6),('7643','2014-04-02','09:25:00',4.92),('7643','2014-04-02','09:30:00',5.76),('7643','2014-04-02','09:35:00',7.05),('7643','2014-04-02','09:40:00',7.54),('7643','2014-04-02','09:45:00',7.42),('7643','2014-04-02','09:50:00',7.09),('7643','2014-04-02','09:55:00',7.37),('7643','2014-04-02','10:00:00',8.8),('7643','2014-04-02','10:05:00',10.42),('7643','2014-04-02','10:10:00',11.18),('7643','2014-04-02','10:15:00',12.49),('7643','2014-04-02','10:20:00',12.9),('7643','2014-04-02','10:25:00',11.01),('7643','2014-04-02','10:30:00',10.46),('7643','2014-04-02','10:35:00',11.3),('7643','2014-04-02','10:40:00',9.08),('7643','2014-04-02','10:45:00',9.5),('7643','2014-04-02','10:50:00',7.86),('7643','2014-04-02','10:55:00',8.39),('7643','2014-04-02','11:00:00',7.9),('7643','2014-04-02','11:05:00',6.48),('7643','2014-04-02','11:10:00',6.12),('7643','2014-04-02','11:15:00',5.71),('7643','2014-04-02','11:20:00',5.43),('7643','2014-04-02','11:25:00',5.05),('7643','2014-04-02','11:30:00',5.02),('7643','2014-04-02','11:35:00',5.36),('7643','2014-04-02','11:40:00',5.91),('7643','2014-04-02','11:45:00',6.84),('7643','2014-04-02','11:50:00',8.44),('7643','2014-04-02','11:55:00',9.46),('7643','2014-04-02','12:00:00',8.88),('7643','2014-04-02','12:05:00',8.86),('7643','2014-04-02','12:10:00',8.57),('7643','2014-04-02','12:15:00',8.35),('7643','2014-04-02','12:20:00',9.35),('7643','2014-04-02','12:25:00',11.21),('7643','2014-04-02','12:30:00',15.65),('7643','2014-04-02','12:35:00',14.58),('7643','2014-04-02','12:40:00',16.72),('7643','2014-04-02','12:45:00',9.2),('7643','2014-04-02','12:50:00',10.56),('7643','2014-04-02','12:55:00',10.33),('7643','2014-04-02','13:00:00',10.28),('7643','2014-04-02','13:05:00',13.95),('7643','2014-04-02','13:10:00',9.25),('7643','2014-04-02','13:15:00',18.27),('7643','2014-04-02','13:20:00',7.88),('7643','2014-04-02','13:25:00',11.15),('7643','2014-04-02','13:30:00',11.24),('7643','2014-04-02','13:35:00',17.41),('7643','2014-04-02','13:40:00',15.86),('7643','2014-04-02','13:45:00',8.92),('7643','2014-04-02','13:50:00',7.88),('7643','2014-04-02','13:55:00',10.37),('7643','2014-04-02','14:00:00',14.74),('7643','2014-04-02','14:05:00',13.77),('7643','2014-04-02','14:10:00',10.46),('7643','2014-04-02','14:15:00',14.16),('7643','2014-04-02','14:20:00',14.84),('7643','2014-04-02','14:25:00',15.08),('7643','2014-04-02','14:30:00',15.05),('7643','2014-04-02','14:35:00',15.58),('7643','2014-04-02','14:40:00',15.07),('7643','2014-04-02','14:45:00',14.74),('7643','2014-04-02','14:50:00',14.35),('7643','2014-04-02','14:55:00',14.09),('7643','2014-04-02','15:00:00',13.93),('7643','2014-04-02','15:05:00',13.69),('7643','2014-04-02','15:10:00',13.61),('7643','2014-04-02','15:15:00',13.53),('7643','2014-04-02','15:20:00',13.5),('7643','2014-04-02','15:25:00',13.4),('7643','2014-04-02','15:30:00',13.18),('7643','2014-04-02','15:35:00',13),('7643','2014-04-02','15:40:00',12.78),('7643','2014-04-02','15:45:00',12.74),('7643','2014-04-02','15:50:00',12.52),('7643','2014-04-02','15:55:00',12.45),('7643','2014-04-02','16:00:00',12.29),('7643','2014-04-02','16:05:00',12.02),('7643','2014-04-02','16:10:00',11.92),('7643','2014-04-02','16:15:00',11.47),('7643','2014-04-02','16:20:00',11.31),('7643','2014-04-02','16:25:00',10.95),('7643','2014-04-02','16:30:00',10.62),('7643','2014-04-02','16:35:00',10.34),('7643','2014-04-02','16:40:00',10.08),('7643','2014-04-02','16:45:00',9.56),('7643','2014-04-02','16:50:00',7.29),('7643','2014-04-02','16:55:00',5.86),('7643','2014-04-02','17:00:00',4.31),('7643','2014-04-02','17:05:00',3.97),('7643','2014-04-02','17:10:00',3.47),('7643','2014-04-02','17:15:00',3.24),('7643','2014-04-02','17:20:00',3.31),('7643','2014-04-02','17:25:00',3.52),('7643','2014-04-02','17:30:00',3.49),('7643','2014-04-02','17:35:00',2.09),('7643','2014-04-02','17:40:00',1.83),('7643','2014-04-02','17:45:00',3.85),('7643','2014-04-02','17:50:00',5.29),('7643','2014-04-02','17:55:00',4.64),('7643','2014-04-02','18:00:00',4.18),('7643','2014-04-02','18:05:00',3.75),('7643','2014-04-02','18:10:00',3.35),('7643','2014-04-02','18:15:00',2.95),('7643','2014-04-02','18:20:00',2.53),('7643','2014-04-02','18:25:00',1.92),('7643','2014-04-02','18:30:00',1.21),('7643','2014-04-02','18:35:00',1.2),('7643','2014-04-02','18:40:00',1.15),('7643','2014-04-02','18:45:00',1.09),('7643','2013-06-09','07:05:00',1.79),('7643','2013-06-09','07:10:00',2.61),('7643','2013-06-09','07:15:00',1.61),('7643','2013-06-09','07:20:00',2.43),('7643','2013-06-09','07:25:00',2.46),('7643','2013-06-09','07:30:00',4.21),('7643','2013-06-09','07:35:00',5.93),('7643','2013-06-09','07:40:00',4.27),('7643','2013-06-09','07:45:00',2.87),('7643','2013-06-09','07:50:00',2.81),('7643','2013-06-09','07:55:00',2.72),('7643','2013-06-09','08:00:00',4.26),('7643','2013-06-09','08:05:00',5.53),('7643','2013-06-09','08:10:00',7.34),('7643','2013-06-09','08:15:00',6.99),('7643','2013-06-09','08:20:00',7.85),('7643','2013-06-09','08:25:00',4.82),('7643','2013-06-09','08:30:00',5.2),('7643','2013-06-09','08:35:00',4.4),('7643','2013-06-09','08:40:00',3.6),('7643','2013-06-09','08:45:00',3.41),('7643','2013-06-09','08:50:00',4.37),('7643','2013-06-09','08:55:00',3.86),('7643','2013-06-09','09:00:00',4.74),('7643','2013-06-09','09:05:00',4.44),('7643','2013-06-09','09:10:00',6.84),('7643','2013-06-09','09:15:00',3.77),('7643','2013-06-09','09:20:00',7.39),('7643','2013-06-09','09:25:00',6.28),('7643','2013-06-09','09:30:00',5.61),('7643','2013-06-09','09:35:00',13.4),('7643','2013-06-09','09:40:00',8.42),('7643','2013-06-09','09:45:00',12.92),('7643','2013-06-09','09:50:00',8.45),('7643','2013-06-09','09:55:00',7.04),('7643','2013-06-09','10:00:00',9.22),('7643','2013-06-09','10:05:00',11.26),('7643','2013-06-09','10:10:00',11.63),('7643','2013-06-09','10:15:00',13.77),('7643','2013-06-09','10:20:00',11.7),('7643','2013-06-09','10:25:00',11.84),('7643','2013-06-09','10:30:00',6.96),('7643','2013-06-09','10:35:00',6.94),('7643','2013-06-09','10:40:00',5.78),('7643','2013-06-09','10:45:00',5.05),('7643','2013-06-09','10:50:00',6.48),('7643','2013-06-09','10:55:00',11.05),('7643','2013-06-09','11:00:00',9.92),('7643','2013-06-09','11:05:00',6.73),('7643','2013-06-09','11:10:00',9.29),('7643','2013-06-09','11:15:00',14.01),('7643','2013-06-09','11:20:00',12.29),('7643','2013-06-09','11:25:00',15.96),('7643','2013-06-09','11:30:00',15.4),('7643','2013-06-09','11:35:00',16.76),('7643','2013-06-09','11:40:00',12.89),('7643','2013-06-09','11:45:00',14.2),('7643','2013-06-09','11:50:00',6.94),('7643','2013-06-09','11:55:00',10.61),('7643','2013-06-09','12:00:00',18.25),('7643','2013-06-09','12:05:00',10.62),('7643','2013-06-09','12:10:00',17.11),('7643','2013-06-09','12:15:00',16.41),('7643','2013-06-09','12:20:00',17.94),('7643','2013-06-09','12:25:00',16.36),('7643','2013-06-09','12:30:00',15.28),('7643','2013-06-09','12:35:00',11.68),('7643','2013-06-09','12:40:00',10.65),('7643','2013-06-09','12:45:00',13.36),('7643','2013-06-09','12:50:00',11.3),('7643','2013-06-09','12:55:00',6.8),('7643','2013-06-09','13:00:00',8.54),('7643','2013-06-09','13:05:00',18.66),('7643','2013-06-09','13:10:00',13.49),('7643','2013-06-09','13:15:00',13.29),('7643','2013-06-09','13:20:00',11.56),('7643','2013-06-09','13:25:00',14.27),('7643','2013-06-09','13:30:00',15.02),('7643','2013-06-09','13:35:00',19.16),('7643','2013-06-09','13:40:00',13.77),('7643','2013-06-09','13:45:00',15.91),('7643','2013-06-09','13:50:00',9.88),('7643','2013-06-09','13:55:00',11.29),('7643','2013-06-09','14:00:00',17.9),('7643','2013-06-09','14:05:00',16.86),('7643','2013-06-09','14:10:00',17.33),('7643','2013-06-09','14:15:00',17.69),('7643','2013-06-09','14:20:00',17.17),('7643','2013-06-09','14:25:00',17.02),('7643','2013-06-09','14:30:00',16.6),('7643','2013-06-09','14:35:00',16.55),('7643','2013-06-09','14:40:00',14.55),('7643','2013-06-09','14:45:00',16.66),('7643','2013-06-09','14:50:00',16.17),('7643','2013-06-09','14:55:00',16.06),('7643','2013-06-09','15:00:00',15.92),('7643','2013-06-09','15:05:00',15.71),('7643','2013-06-09','15:10:00',15.55),('7643','2013-06-09','15:15:00',15.32),('7643','2013-06-09','15:20:00',15.33),('7643','2013-06-09','15:25:00',15.13),('7643','2013-06-09','15:30:00',14.98),('7643','2013-06-09','15:35:00',14.86),('7643','2013-06-09','15:40:00',14.66),('7643','2013-06-09','15:45:00',14.42),('7643','2013-06-09','15:50:00',14.2),('7643','2013-06-09','15:55:00',14.07),('7643','2013-06-09','16:00:00',13.78),('7643','2013-06-09','16:05:00',13.61),('7643','2013-06-09','16:10:00',13.41),('7643','2013-06-09','16:15:00',13.09),('7643','2013-06-09','16:20:00',12.75),('7643','2013-06-09','16:25:00',12.44),('7643','2013-06-09','16:30:00',12.1),('7643','2013-06-09','16:35:00',12.07),('7643','2013-06-09','16:40:00',11.76),('7643','2013-06-09','16:45:00',11.41),('7643','2013-06-09','16:50:00',11.12),('7643','2013-06-09','16:55:00',10.89),('7643','2013-06-09','17:00:00',10.63),('7643','2013-06-09','17:05:00',10.4),('7643','2013-06-09','17:10:00',9.98),('7643','2013-06-09','17:15:00',9.54),('7643','2013-06-09','17:20:00',9.16),('7643','2013-06-09','17:25:00',8.87),('7643','2013-06-09','17:30:00',8.48),('7643','2013-06-09','17:35:00',8.16),('7643','2013-06-09','17:40:00',7.97),('7643','2013-06-09','17:45:00',7.66),('7643','2013-06-09','17:50:00',7.29),('7643','2013-06-09','17:55:00',6.96),('7643','2013-06-09','18:00:00',6.55),('7643','2013-06-09','18:05:00',6.14),('7643','2013-06-09','18:10:00',5.9),('7643','2013-06-09','18:15:00',5.57),('7643','2013-06-09','18:20:00',5.25),('7643','2013-06-09','18:25:00',4.9),('7643','2013-06-09','18:30:00',4.55),('7643','2013-06-09','18:35:00',4.24),('7643','2013-06-09','18:40:00',3.81),('7643','2013-06-09','18:45:00',3.35),('7643','2013-06-09','18:50:00',2.98),('7643','2013-06-09','18:55:00',2.7),('7643','2013-06-09','19:00:00',2.34),('7643','2013-06-09','19:05:00',2.04),('7643','2013-06-09','19:10:00',1.83),('7643','2013-06-09','19:15:00',1.5),('7643','2013-06-09','19:20:00',1.26),('7643','2013-06-09','19:25:00',1.08),('7643','2013-06-08','06:30:00',1.03),('7643','2013-06-08','07:05:00',1.11),('7643','2013-06-08','07:10:00',2.16),('7643','2013-06-08','07:15:00',1.93),('7643','2013-06-08','07:20:00',1.33),('7643','2013-06-08','07:25:00',2.68),('7643','2013-06-08','07:30:00',2.9),('7643','2013-06-08','07:35:00',5.15),('7643','2013-06-08','07:40:00',4.72),('7643','2013-06-08','07:45:00',2.35),('7643','2013-06-08','07:50:00',3.38),('7643','2013-06-08','07:55:00',5.4),('7643','2013-06-08','08:00:00',5.99),('7643','2013-06-08','08:05:00',6.02),('7643','2013-06-08','08:10:00',6.83),('7643','2013-06-08','08:15:00',7.2),('7643','2013-06-08','08:20:00',6.87),('7643','2013-06-08','08:25:00',6.9),('7643','2013-06-08','08:30:00',7.31),('7643','2013-06-08','08:35:00',7.79),('7643','2013-06-08','08:40:00',7.98),('7643','2013-06-08','08:45:00',8.47),('7643','2013-06-08','08:50:00',8.8),('7643','2013-06-08','08:55:00',9.18),('7643','2013-06-08','09:00:00',9.4),('7643','2013-06-08','09:05:00',9.69),('7643','2013-06-08','09:10:00',9.91),('7643','2013-06-08','09:15:00',10.23),('7643','2013-06-08','09:20:00',10.58),('7643','2013-06-08','09:25:00',10.64),('7643','2013-06-08','09:30:00',11.05),('7643','2013-06-08','09:35:00',11.07),('7643','2013-06-08','09:40:00',11.35),('7643','2013-06-08','09:45:00',11.78),('7643','2013-06-08','09:50:00',11.96),('7643','2013-06-08','09:55:00',12.19),('7643','2013-06-08','10:00:00',12.35),('7643','2013-06-08','10:05:00',12.55),('7643','2013-06-08','10:10:00',12.69),('7643','2013-06-08','10:15:00',12.88),('7643','2013-06-08','10:20:00',12.95),('7643','2013-06-08','10:25:00',13.19),('7643','2013-06-08','10:30:00',13.53),('7643','2013-06-08','10:35:00',13.57),('7643','2013-06-08','10:40:00',13.68),('7643','2013-06-08','10:45:00',13.8),('7643','2013-06-08','10:50:00',14),('7643','2013-06-08','10:55:00',14.2),('7643','2013-06-08','11:00:00',14.23),('7643','2013-06-08','11:05:00',14.21),('7643','2013-06-08','11:10:00',14.28),('7643','2013-06-08','11:15:00',14.8),('7643','2013-06-08','11:20:00',14.78),('7643','2013-06-08','11:25:00',14.84),('7643','2013-06-08','11:30:00',14.88),('7643','2013-06-08','11:35:00',14.84),('7643','2013-06-08','11:40:00',15.02),('7643','2013-06-08','11:45:00',15.32),('7643','2013-06-08','11:50:00',15.41),('7643','2013-06-08','11:55:00',15.31),('7643','2013-06-08','12:00:00',15.27),('7643','2013-06-08','12:05:00',15.6),('7643','2013-06-08','12:10:00',15.56),('7643','2013-06-08','12:15:00',15.53),('7643','2013-06-08','12:20:00',15.66),('7643','2013-06-08','12:25:00',15.66),('7643','2013-06-08','12:30:00',15.78),('7643','2013-06-08','12:35:00',15.74),('7643','2013-06-08','12:40:00',16.01),('7643','2013-06-08','12:45:00',15.37),('7643','2013-06-08','12:50:00',16.03),('7643','2013-06-08','12:55:00',13.35),('7643','2013-06-08','13:00:00',13.49),('7643','2013-06-08','13:05:00',12.78),('7643','2013-06-08','13:10:00',16.9),('7643','2013-06-08','13:15:00',16.27),('7643','2013-06-08','13:20:00',12.33),('7643','2013-06-08','13:25:00',13.7),('7643','2013-06-08','13:30:00',16.34),('7643','2013-06-08','13:35:00',16.84),('7643','2013-06-08','13:40:00',17.25),('7643','2013-06-08','13:45:00',17.32),('7643','2013-06-08','13:50:00',17.91),('7643','2013-06-08','13:55:00',16.71),('7643','2013-06-08','14:00:00',12.92),('7643','2013-06-08','14:05:00',17.25),('7643','2013-06-08','14:10:00',17.39),('7643','2013-06-08','14:15:00',11.42),('7643','2013-06-08','14:20:00',7.78),('7643','2013-06-08','14:25:00',4.47),('7643','2013-06-08','14:30:00',5.79),('7643','2013-06-08','14:35:00',14.76),('7643','2013-06-08','14:40:00',13.22),('7643','2013-06-08','14:45:00',14.52),('7643','2013-06-08','14:50:00',15.68),('7643','2013-06-08','14:55:00',15.74),('7643','2013-06-08','15:00:00',15.35),('7643','2013-06-08','15:05:00',14.66),('7643','2013-06-08','15:10:00',14.83),('7643','2013-06-08','15:15:00',14.36),('7643','2013-06-08','15:20:00',14.33),('7643','2013-06-08','15:25:00',14.41),('7643','2013-06-08','15:30:00',13.12),('7643','2013-06-08','15:35:00',13.79),('7643','2013-06-08','15:40:00',11.04),('7643','2013-06-08','15:45:00',11.54),('7643','2013-06-08','15:50:00',12.61),('7643','2013-06-08','15:55:00',13.5),('7643','2013-06-08','16:00:00',9.8),('7643','2013-06-08','16:05:00',12.59),('7643','2013-06-08','16:10:00',11.27),('7643','2013-06-08','16:15:00',7.31),('7643','2013-06-08','16:20:00',5.56),('7643','2013-06-08','16:25:00',8.01),('7643','2013-06-08','16:30:00',5.18),('7643','2013-06-08','16:35:00',3.65),('7643','2013-06-08','16:40:00',3.47),('7643','2013-06-08','16:45:00',3.44),('7643','2013-06-08','16:50:00',3.37),('7643','2013-06-08','16:55:00',3.14),('7643','2013-06-08','17:00:00',3.29),('7643','2013-06-08','17:05:00',3.8),('7643','2013-06-08','17:10:00',3.63),('7643','2013-06-08','17:15:00',2.97),('7643','2013-06-08','17:20:00',3.28),('7643','2013-06-08','17:25:00',2.52),('7643','2013-06-08','17:30:00',2.08),('7643','2013-06-08','17:35:00',2.38),('7643','2013-06-08','17:40:00',2.8),('7643','2013-06-08','17:45:00',2.52),('7643','2013-06-08','17:50:00',1.86),('7643','2013-06-08','17:55:00',2.04),('7643','2013-06-08','18:00:00',3.54),('7643','2013-06-08','18:05:00',3.12),('7643','2013-06-08','18:10:00',4.31),('7643','2013-06-08','18:15:00',4.31),('7643','2013-06-08','18:20:00',3.78),('7643','2013-06-08','18:25:00',1.8),('7643','2013-06-08','18:30:00',3.57),('7643','2013-06-08','18:35:00',2.05),('7643','2013-06-08','18:40:00',1.62),('7643','2013-06-08','18:45:00',2.05),('7643','2013-06-08','18:50:00',2.39),('7643','2013-06-08','18:55:00',1.82),('7643','2013-06-08','19:00:00',1.19),('7643','2013-06-07','06:45:00',1.17),('7643','2013-06-07','06:50:00',1.4),('7643','2013-06-07','06:55:00',1.67),('7643','2013-06-07','07:00:00',1.91),('7643','2013-06-07','07:05:00',2.24),('7643','2013-06-07','07:10:00',2.55),('7643','2013-06-07','07:15:00',2.82),('7643','2013-06-07','07:20:00',3.12),('7643','2013-06-07','07:25:00',3.4),('7643','2013-06-07','07:30:00',3.77),('7643','2013-06-07','07:35:00',4.07),('7643','2013-06-07','07:40:00',4.42),('7643','2013-06-07','07:45:00',4.76),('7643','2013-06-07','07:50:00',5.06),('7643','2013-06-07','07:55:00',5.38),('7643','2013-06-07','08:00:00',5.64),('7643','2013-06-07','08:05:00',5.96),('7643','2013-06-07','08:10:00',6.28),('7643','2013-06-07','08:15:00',6.53),('7643','2013-06-07','08:20:00',6.82),('7643','2013-06-07','08:25:00',7.15),('7643','2013-06-07','08:30:00',7.56),('7643','2013-06-07','08:35:00',7.88),('7643','2013-06-07','08:40:00',8.13),('7643','2013-06-07','08:45:00',8.51),('7643','2013-06-07','08:50:00',8.85),('7643','2013-06-07','08:55:00',9.17),('7643','2013-06-07','09:00:00',9.47),('7643','2013-06-07','09:05:00',9.82),('7643','2013-06-07','09:10:00',10.13),('7643','2013-06-07','09:15:00',10.33),('7643','2013-06-07','09:20:00',10.46),('7643','2013-06-07','09:25:00',10.81),('7643','2013-06-07','09:30:00',11.04),('7643','2013-06-07','09:35:00',11.17),('7643','2013-06-07','09:40:00',11.52),('7643','2013-06-07','09:45:00',11.56),('7643','2013-06-07','09:50:00',11.56),('7643','2013-06-07','09:55:00',12.13),('7643','2013-06-07','10:00:00',12.15),('7643','2013-06-07','10:05:00',8.23),('7643','2013-06-07','10:10:00',5.03),('7643','2013-06-07','10:15:00',13.27),('7643','2013-06-07','10:20:00',13.45),('7643','2013-06-07','10:25:00',13.67),('7643','2013-06-07','10:30:00',13.7),('7643','2013-06-07','10:35:00',13.84),('7643','2013-06-07','10:40:00',14.03),('7643','2013-06-07','10:45:00',14.56),('7643','2013-06-07','10:50:00',14.79),('7643','2013-06-07','10:55:00',15.41),('7643','2013-06-07','11:00:00',5.7),('7643','2013-06-07','11:05:00',8.75),('7643','2013-06-07','11:10:00',6.61),('7643','2013-06-07','11:15:00',14.99),('7643','2013-06-07','11:20:00',16.82),('7643','2013-06-07','11:25:00',16.77),('7643','2013-06-07','11:30:00',15.82),('7643','2013-06-07','11:35:00',12.69),('7643','2013-06-07','11:40:00',16.59),('7643','2013-06-07','11:45:00',16.29),('7643','2013-06-07','11:50:00',16.47),('7643','2013-06-07','11:55:00',16.89),('7643','2013-06-07','12:00:00',9.86),('7643','2013-06-07','12:05:00',11.96),('7643','2013-06-07','12:10:00',4.08),('7643','2013-06-07','12:15:00',8.02),('7643','2013-06-07','12:20:00',16.89),('7643','2013-06-07','12:25:00',4.18),('7643','2013-06-07','12:30:00',16.1),('7643','2013-06-07','12:35:00',12.98),('7643','2013-06-07','12:40:00',17.03),('7643','2013-06-07','12:45:00',14.47),('7643','2013-06-07','12:50:00',9.58),('7643','2013-06-07','12:55:00',17.69),('7643','2013-06-07','13:00:00',17.44),('7643','2013-06-07','13:05:00',13.8),('7643','2013-06-07','13:10:00',8.38),('7643','2013-06-07','13:15:00',15.99),('7643','2013-06-07','13:20:00',16.81),('7643','2013-06-07','13:25:00',17.45),('7643','2013-06-07','13:30:00',17.45),('7643','2013-06-07','13:35:00',17.2),('7643','2013-06-07','13:40:00',16.94),('7643','2013-06-07','13:45:00',16.98),('7643','2013-06-07','13:50:00',16.93),('7643','2013-06-07','13:55:00',16.77),('7643','2013-06-07','14:00:00',16.57),('7643','2013-06-07','14:05:00',16.53),('7643','2013-06-07','14:10:00',16.45),('7643','2013-06-07','14:15:00',16.51),('7643','2013-06-07','14:20:00',16.4),('7643','2013-06-07','14:25:00',16.27),('7643','2013-06-07','14:30:00',16.22),('7643','2013-06-07','14:35:00',16.07),('7643','2013-06-07','14:40:00',16.09),('7643','2013-06-07','14:45:00',15.99),('7643','2013-06-07','14:50:00',15.98),('7643','2013-06-07','14:55:00',15.87),('7643','2013-06-07','15:00:00',15.67),('7643','2013-06-07','15:05:00',15.09),('7643','2013-06-07','15:10:00',14.08),('7643','2013-06-07','15:15:00',14.39),('7643','2013-06-07','15:20:00',15.19),('7643','2013-06-07','15:25:00',14.26),('7643','2013-06-07','15:30:00',14.13),('7643','2013-06-07','15:35:00',14.63),('7643','2013-06-07','15:40:00',14.36),('7643','2013-06-07','15:45:00',14.81),('7643','2013-06-07','15:50:00',13.55),('7643','2013-06-07','15:55:00',13.69),('7643','2013-06-07','16:00:00',13.65),('7643','2013-06-07','16:05:00',13.53),('7643','2013-06-07','16:10:00',13.39),('7643','2013-06-07','16:15:00',13.2),('7643','2013-06-07','16:20:00',13.06),('7643','2013-06-07','16:25:00',12.41),('7643','2013-06-07','16:30:00',11.86),('7643','2013-06-07','16:35:00',11.47),('7643','2013-06-07','16:40:00',11.25),('7643','2013-06-07','16:45:00',10.96),('7643','2013-06-07','16:50:00',9.49),('7643','2013-06-07','16:55:00',9.1),('7643','2013-06-07','17:00:00',10.25),('7643','2013-06-07','17:05:00',9.08),('7643','2013-06-07','17:10:00',10.41),('7643','2013-06-07','17:15:00',10.17),('7643','2013-06-07','17:20:00',9.51),('7643','2013-06-07','17:25:00',8.99),('7643','2013-06-07','17:30:00',6.74),('7643','2013-06-07','17:35:00',4.65),('7643','2013-06-07','17:40:00',7.12),('7643','2013-06-07','17:45:00',8.06),('7643','2013-06-07','17:50:00',7),('7643','2013-06-07','17:55:00',7.22),('7643','2013-06-07','18:00:00',5.75),('7643','2013-06-07','18:05:00',5.2),('7643','2013-06-07','18:10:00',4.18),('7643','2013-06-07','18:15:00',4.21),('7643','2013-06-07','18:20:00',4.41),('7643','2013-06-07','18:25:00',3.71),('7643','2013-06-07','18:30:00',2.59),('7643','2013-06-07','18:35:00',2.27),('7643','2013-06-07','18:40:00',1.69),('7643','2013-06-07','18:45:00',1.42),('7643','2013-06-07','18:50:00',1.31),('7643','2013-06-07','18:55:00',1.34),('7643','2013-06-07','19:00:00',1.42),('7643','2013-06-07','19:05:00',1.47),('7643','2013-06-07','19:10:00',1.5),('7643','2013-06-07','19:15:00',1.52),('7643','2013-06-07','19:20:00',1.48),('7643','2013-06-07','19:25:00',1.4),('7643','2013-06-07','19:30:00',1.36),('7643','2013-06-07','19:35:00',1.24),('7643','2013-06-07','19:40:00',1.01),('7643','2013-06-06','06:45:00',1.21),('7643','2013-06-06','06:50:00',1.44),('7643','2013-06-06','06:55:00',1.72),('7643','2013-06-06','07:00:00',1.97),('7643','2013-06-06','07:05:00',2.31),('7643','2013-06-06','07:10:00',2.61),('7643','2013-06-06','07:15:00',2.96),('7643','2013-06-06','07:20:00',3.31),('7643','2013-06-06','07:25:00',3.61),('7643','2013-06-06','07:30:00',3.97),('7643','2013-06-06','07:35:00',4.33),('7643','2013-06-06','07:40:00',4.72),('7643','2013-06-06','07:45:00',5.08),('7643','2013-06-06','07:50:00',5.41),('7643','2013-06-06','07:55:00',5.75),('7643','2013-06-06','08:00:00',6.02),('7643','2013-06-06','08:05:00',6.34),('7643','2013-06-06','08:10:00',6.69),('7643','2013-06-06','08:15:00',6.95),('7643','2013-06-06','08:20:00',7.28),('7643','2013-06-06','08:25:00',7.67),('7643','2013-06-06','08:30:00',8.1),('7643','2013-06-06','08:35:00',8.43),('7643','2013-06-06','08:40:00',8.75),('7643','2013-06-06','08:45:00',9.19),('7643','2013-06-06','08:50:00',9.51),('7643','2013-06-06','08:55:00',9.84),('7643','2013-06-06','09:00:00',10.12),('7643','2013-06-06','09:05:00',10.43),('7643','2013-06-06','09:10:00',10.76),('7643','2013-06-06','09:15:00',11.12),('7643','2013-06-06','09:20:00',11.36),('7643','2013-06-06','09:25:00',11.62),('7643','2013-06-06','09:30:00',11.92),('7643','2013-06-06','09:35:00',12.21),('7643','2013-06-06','09:40:00',12.45),('7643','2013-06-06','09:45:00',12.72),('7643','2013-06-06','09:50:00',12.96),('7643','2013-06-06','09:55:00',13.17),('7643','2013-06-06','10:00:00',13.36),('7643','2013-06-06','10:05:00',13.59),('7643','2013-06-06','10:10:00',13.77),('7643','2013-06-06','10:15:00',14),('7643','2013-06-06','10:20:00',14.15),('7643','2013-06-06','10:25:00',14.28),('7643','2013-06-06','10:30:00',14.53),('7643','2013-06-06','10:35:00',14.69),('7643','2013-06-06','10:40:00',14.85),('7643','2013-06-06','10:45:00',15),('7643','2013-06-06','10:50:00',15.09),('7643','2013-06-06','10:55:00',15.22),('7643','2013-06-06','11:00:00',15.39),('7643','2013-06-06','11:05:00',15.56),('7643','2013-06-06','11:10:00',15.69),('7643','2013-06-06','11:15:00',15.7),('7643','2013-06-06','11:20:00',15.82),('7643','2013-06-06','11:25:00',15.94),('7643','2013-06-06','11:30:00',16.14),('7643','2013-06-06','11:35:00',16.32),('7643','2013-06-06','11:40:00',16.42),('7643','2013-06-06','11:45:00',16.41),('7643','2013-06-06','11:50:00',16.54),('7643','2013-06-06','11:55:00',16.58),('7643','2013-06-06','12:00:00',16.67),('7643','2013-06-06','12:05:00',16.72),('7643','2013-06-06','12:10:00',16.73),('7643','2013-06-06','12:15:00',16.84),('7643','2013-06-06','12:20:00',16.93),('7643','2013-06-06','12:25:00',16.83),('7643','2013-06-06','12:30:00',16.84),('7643','2013-06-06','12:35:00',16.76),('7643','2013-06-06','12:40:00',16.89),('7643','2013-06-06','12:45:00',17.03),('7643','2013-06-06','12:50:00',16.89),('7643','2013-06-06','12:55:00',16.99),('7643','2013-06-06','13:00:00',17.12),('7643','2013-06-06','13:05:00',16.99),('7643','2013-06-06','13:10:00',16.89),('7643','2013-06-06','13:15:00',16.86),('7643','2013-06-06','13:20:00',16.74),('7643','2013-06-06','13:25:00',16.78),('7643','2013-06-06','13:30:00',16.74),('7643','2013-06-06','13:35:00',16.69),('7643','2013-06-06','13:40:00',16.69),('7643','2013-06-06','13:45:00',16.6),('7643','2013-06-06','13:50:00',16.47),('7643','2013-06-06','13:55:00',16.34),('7643','2013-06-06','14:00:00',16.19),('7643','2013-06-06','14:05:00',16.06),('7643','2013-06-06','14:10:00',15.96),('7643','2013-06-06','14:15:00',15.99),('7643','2013-06-06','14:20:00',15.79),('7643','2013-06-06','14:25:00',15.58),('7643','2013-06-06','14:30:00',15.43),('7643','2013-06-06','14:35:00',15.38),('7643','2013-06-06','14:40:00',15.44),('7643','2013-06-06','14:45:00',15.38),('7643','2013-06-06','14:50:00',15.39),('7643','2013-06-06','14:55:00',15.28),('7643','2013-06-06','15:00:00',15.17),('7643','2013-06-06','15:05:00',15.14),('7643','2013-06-06','15:10:00',15.13),('7643','2013-06-06','15:15:00',14.81),('7643','2013-06-06','15:20:00',14.61),('7643','2013-06-06','15:25:00',14.73),('7643','2013-06-06','15:30:00',14.64),('7643','2013-06-06','15:35:00',14.36),('7643','2013-06-06','15:40:00',14.09),('7643','2013-06-06','15:45:00',13.83),('7643','2013-06-06','15:50:00',13.61),('7643','2013-06-06','15:55:00',13.55),('7643','2013-06-06','16:00:00',13.38),('7643','2013-06-06','16:05:00',12.95),('7643','2013-06-06','16:10:00',12.48),('7643','2013-06-06','16:15:00',12.01),('7643','2013-06-06','16:20:00',11.72),('7643','2013-06-06','16:25:00',11.81),('7643','2013-06-06','16:30:00',11.83),('7643','2013-06-06','16:35:00',11.57),('7643','2013-06-06','16:40:00',11.27),('7643','2013-06-06','16:45:00',11.01),('7643','2013-06-06','16:50:00',10.77),('7643','2013-06-06','16:55:00',10.53),('7643','2013-06-06','17:00:00',10.2),('7643','2013-06-06','17:05:00',9.83),('7643','2013-06-06','17:10:00',9.47),('7643','2013-06-06','17:15:00',9.01),('7643','2013-06-06','17:20:00',8.48),('7643','2013-06-06','17:25:00',8.33),('7643','2013-06-06','17:30:00',7.99),('7643','2013-06-06','17:35:00',7.83),('7643','2013-06-06','17:40:00',7.6),('7643','2013-06-06','17:45:00',7.45),('7643','2013-06-06','17:50:00',7.2),('7643','2013-06-06','17:55:00',6.7),('7643','2013-06-06','18:00:00',6.21),('7643','2013-06-06','18:05:00',6),('7643','2013-06-06','18:10:00',5.72),('7643','2013-06-06','18:15:00',5.3),('7643','2013-06-06','18:20:00',4.89),('7643','2013-06-06','18:25:00',4.42),('7643','2013-06-06','18:30:00',4.15),('7643','2013-06-06','18:35:00',3.84),('7643','2013-06-06','18:40:00',3.47),('7643','2013-06-06','18:45:00',3.04),('7643','2013-06-06','18:50:00',2.7),('7643','2013-06-06','18:55:00',2.47),('7643','2013-06-06','19:00:00',2.2),('7643','2013-06-06','19:05:00',1.89),('7643','2013-06-06','19:15:00',1.16),('7643','2013-06-05','06:50:00',1.19),('7643','2013-06-05','06:55:00',2.29),('7643','2013-06-05','07:00:00',3.07),('7643','2013-06-05','07:05:00',3.53),('7643','2013-06-05','07:10:00',3.33),('7643','2013-06-05','07:15:00',3.85),('7643','2013-06-05','07:20:00',2.54),('7643','2013-06-05','07:25:00',2.7),('7643','2013-06-05','07:30:00',2.4),('7643','2013-06-05','07:35:00',2.22),('7643','2013-06-05','07:40:00',2.57),('7643','2013-06-05','07:45:00',2.74),('7643','2013-06-05','07:50:00',4.09),('7643','2013-06-05','07:55:00',5.99),('7643','2013-06-05','08:00:00',6.49),('7643','2013-06-05','08:05:00',4.69),('7643','2013-06-05','08:10:00',6.46),('7643','2013-06-05','08:15:00',5.62),('7643','2013-06-05','08:20:00',6.08),('7643','2013-06-05','08:25:00',7.69),('7643','2013-06-05','08:30:00',7.98),('7643','2013-06-05','08:35:00',8.19),('7643','2013-06-05','08:40:00',8.38),('7643','2013-06-05','08:45:00',8.72),('7643','2013-06-05','08:50:00',5.94),('7643','2013-06-05','09:00:00',3.79),('7643','2013-06-05','09:05:00',10.03),('7643','2013-06-05','09:10:00',10.44),('7643','2013-06-05','09:15:00',10.74),('7643','2013-06-05','09:20:00',10.97),('7643','2013-06-05','09:25:00',11.34),('7643','2013-06-05','09:30:00',11.42),('7643','2013-06-05','09:35:00',11.71),('7643','2013-06-05','09:40:00',11.88),('7643','2013-06-05','09:45:00',11.9),('7643','2013-06-05','09:50:00',12.43),('7643','2013-06-05','09:55:00',12.71),('7643','2013-06-05','10:00:00',12.93),('7643','2013-06-05','10:05:00',12.92),('7643','2013-06-05','10:10:00',13.09),('7643','2013-06-05','10:15:00',13.47),('7643','2013-06-05','10:20:00',13.61),('7643','2013-06-05','10:25:00',13.87),('7643','2013-06-05','10:30:00',14.07),('7643','2013-06-05','10:35:00',14.09),('7643','2013-06-05','10:40:00',14.39),('7643','2013-06-05','10:45:00',14.51),('7643','2013-06-05','10:50:00',14.69),('7643','2013-06-05','10:55:00',14.82),('7643','2013-06-05','11:00:00',14.97),('7643','2013-06-05','11:05:00',14.85),('7643','2013-06-05','11:10:00',15.25),('7643','2013-06-05','11:15:00',15.29),('7643','2013-06-05','11:20:00',15.41),('7643','2013-06-05','11:25:00',15.44),('7643','2013-06-05','11:30:00',15.76),('7643','2013-06-05','11:35:00',15.83),('7643','2013-06-05','11:40:00',15.88),('7643','2013-06-05','11:45:00',16.06),('7643','2013-06-05','11:50:00',15.93),('7643','2013-06-05','11:55:00',15.68),('7643','2013-06-05','12:00:00',15.99),('7643','2013-06-05','12:05:00',7.7),('7643','2013-06-05','12:10:00',15.18),('7643','2013-06-05','12:15:00',16.4),('7643','2013-06-05','12:20:00',16.4),('7643','2013-06-05','12:25:00',16.64),('7643','2013-06-05','12:30:00',16.25),('7643','2013-06-05','12:35:00',16.48),('7643','2013-06-05','12:40:00',16.51),('7643','2013-06-05','12:45:00',15.95),('7643','2013-06-05','12:50:00',16.43),('7643','2013-06-05','12:55:00',16.86),('7643','2013-06-05','13:00:00',16.88),('7643','2013-06-05','13:05:00',16.64),('7643','2013-06-05','13:10:00',16.72),('7643','2013-06-05','13:15:00',16.82),('7643','2013-06-05','13:20:00',16.96),('7643','2013-06-05','13:25:00',16.83),('7643','2013-06-05','13:30:00',16.56),('7643','2013-06-05','13:35:00',16.73),('7643','2013-06-05','13:40:00',16.31),('7643','2013-06-05','13:45:00',5.9),('7643','2013-06-05','13:50:00',12.67),('7643','2013-06-05','13:55:00',17.15),('7643','2013-06-05','14:00:00',17.02),('7643','2013-06-05','14:05:00',16.96),('7643','2013-06-05','14:10:00',16.74),('7643','2013-06-05','14:15:00',16.87),('7643','2013-06-05','14:20:00',16.79),('7643','2013-06-05','14:25:00',9.61),('7643','2013-06-05','14:30:00',15.21),('7643','2013-06-05','14:35:00',11.1),('7643','2013-06-05','14:40:00',7.4),('7643','2013-06-05','14:45:00',12.65),('7643','2013-06-05','14:50:00',16.6),('7643','2013-06-05','14:55:00',16.53),('7643','2013-06-05','15:00:00',16.41),('7643','2013-06-05','15:05:00',16.41),('7643','2013-06-05','15:10:00',13.8),('7643','2013-06-05','15:15:00',15.62),('7643','2013-06-05','15:20:00',15.39),('7643','2013-06-05','15:25:00',8.76),('7643','2013-06-05','15:30:00',14.44),('7643','2013-06-05','15:35:00',14.01),('7643','2013-06-05','15:40:00',14.27),('7643','2013-06-05','15:45:00',14.46),('7643','2013-06-05','15:50:00',11.72),('7643','2013-06-05','15:55:00',13.12),('7643','2013-06-05','16:00:00',10.97),('7643','2013-06-05','16:05:00',13.42),('7643','2013-06-05','16:10:00',12.39),('7643','2013-06-05','16:15:00',12.03),('7643','2013-06-05','16:20:00',11.6),('7643','2013-06-05','16:25:00',11.77),('7643','2013-06-05','16:30:00',11.77),('7643','2013-06-05','16:35:00',11.54),('7643','2013-06-05','16:40:00',11.31),('7643','2013-06-05','16:45:00',10.55),('7643','2013-06-05','16:50:00',10.45),('7643','2013-06-05','16:55:00',9.96),('7643','2013-06-05','17:00:00',9.66),('7643','2013-06-05','17:05:00',9.3),('7643','2013-06-05','17:10:00',9.13),('7643','2013-06-05','17:15:00',8.79),('7643','2013-06-05','17:20:00',8.28),('7643','2013-06-05','17:25:00',8.13),('7643','2013-06-05','17:30:00',7.9),('7643','2013-06-05','17:35:00',7.56),('7643','2013-06-05','17:40:00',7.24),('7643','2013-06-05','17:45:00',6.94),('7643','2013-06-05','17:50:00',6.56),('7643','2013-06-05','17:55:00',6.17),('7643','2013-06-05','18:00:00',5.87),('7643','2013-06-05','18:05:00',5.48),('7643','2013-06-05','18:10:00',5.23),('7643','2013-06-05','18:15:00',4.93),('7643','2013-06-05','18:20:00',4.6),('7643','2013-06-05','18:25:00',4.28),('7643','2013-06-05','18:30:00',4.01),('7643','2013-06-05','18:35:00',3.77),('7643','2013-06-05','18:40:00',3.47),('7643','2013-06-05','18:45:00',3.04),('7643','2013-06-05','18:50:00',2.68),('7643','2013-06-05','18:55:00',2.47),('7643','2013-06-05','19:00:00',2.14),('7643','2013-06-05','19:05:00',1.84),('7643','2013-06-05','19:10:00',1.72),('7643','2013-06-05','19:15:00',1.47),('7643','2013-06-05','19:20:00',1.32),('7643','2013-06-05','19:25:00',1.16),('7643','2013-06-05','19:30:00',1.02),('7643','2013-06-04','06:30:00',1.06),('7643','2013-06-04','06:35:00',1.37),('7643','2013-06-04','06:40:00',1.63),('7643','2013-06-04','06:45:00',1.72),('7643','2013-06-04','06:50:00',1.85),('7643','2013-06-04','06:55:00',2.26),('7643','2013-06-04','07:00:00',2.23),('7643','2013-06-04','07:05:00',2.33),('7643','2013-06-04','07:10:00',1.64),('7643','2013-06-04','07:15:00',2.02),('7643','2013-06-04','07:20:00',2.83),('7643','2013-06-04','07:25:00',2.46),('7643','2013-06-04','07:30:00',1.96),('7643','2013-06-04','07:35:00',2.78),('7643','2013-06-04','07:40:00',2.32),('7643','2013-06-04','07:45:00',2.67),('7643','2013-06-04','07:50:00',4.92),('7643','2013-06-04','07:55:00',6.23),('7643','2013-06-04','08:00:00',6.56),('7643','2013-06-04','08:05:00',6.18),('7643','2013-06-04','08:10:00',5.58),('7643','2013-06-04','08:15:00',6.57),('7643','2013-06-04','08:20:00',6.97),('7643','2013-06-04','08:25:00',7.52),('7643','2013-06-04','08:30:00',7.91),('7643','2013-06-04','08:35:00',8.19),('7643','2013-06-04','08:40:00',8.47),('7643','2013-06-04','08:45:00',8.88),('7643','2013-06-04','08:50:00',9.24),('7643','2013-06-04','08:55:00',9.63),('7643','2013-06-04','09:00:00',9.92),('7643','2013-06-04','09:05:00',10.14),('7643','2013-06-04','09:10:00',10.86),('7643','2013-06-04','09:15:00',10.96),('7643','2013-06-04','09:20:00',12.08),('7643','2013-06-04','09:25:00',12.34),('7643','2013-06-04','09:30:00',12.9),('7643','2013-06-04','09:35:00',13.74),('7643','2013-06-04','09:40:00',14.31),('7643','2013-06-04','09:45:00',10.82),('7643','2013-06-04','09:50:00',9.64),('7643','2013-06-04','09:55:00',6.64),('7643','2013-06-04','10:00:00',12.74),('7643','2013-06-04','10:05:00',15.36),('7643','2013-06-04','10:10:00',15.14),('7643','2013-06-04','10:15:00',15.45),('7643','2013-06-04','10:20:00',6.96),('7643','2013-06-04','10:25:00',4.77),('7643','2013-06-04','10:30:00',4.71),('7643','2013-06-04','10:35:00',4.57),('7643','2013-06-04','10:40:00',8.39),('7643','2013-06-04','10:45:00',10.99),('7643','2013-06-04','10:50:00',6.84),('7643','2013-06-04','10:55:00',12.66),('7643','2013-06-04','11:00:00',15.18),('7643','2013-06-04','11:05:00',6.41),('7643','2013-06-04','11:10:00',6.5),('7643','2013-06-04','11:15:00',7.86),('7643','2013-06-04','11:20:00',4.9),('7643','2013-06-04','11:25:00',3.98),('7643','2013-06-04','11:30:00',3.96),('7643','2013-06-04','11:35:00',4.4),('7643','2013-06-04','11:40:00',5.07),('7643','2013-06-04','11:45:00',14.17),('7643','2013-06-04','11:50:00',9.16),('7643','2013-06-04','11:55:00',15.66),('7643','2013-06-04','12:00:00',18.59),('7643','2013-06-04','12:05:00',18.13),('7643','2013-06-04','12:10:00',18.09),('7643','2013-06-04','12:15:00',18.35),('7643','2013-06-04','12:20:00',18.53),('7643','2013-06-04','12:25:00',17.87),('7643','2013-06-04','12:30:00',8.85),('7643','2013-06-04','12:35:00',13.55),('7643','2013-06-04','12:40:00',15.09),('7643','2013-06-04','12:45:00',18.42),('7643','2013-06-04','12:50:00',8.07),('7643','2013-06-04','12:55:00',9.61),('7643','2013-06-04','13:00:00',14.85),('7643','2013-06-04','13:05:00',19.49),('7643','2013-06-04','13:10:00',10.87),('7643','2013-06-04','13:15:00',11.63),('7643','2013-06-04','13:20:00',9.67),('7643','2013-06-04','13:25:00',15.8),('7643','2013-06-04','13:30:00',19.88),('7643','2013-06-04','13:35:00',19.1),('7643','2013-06-04','13:40:00',18.58),('7643','2013-06-04','13:45:00',18.4),('7643','2013-06-04','13:50:00',17.8),('7643','2013-06-04','13:55:00',17.72),('7643','2013-06-04','14:00:00',17.29),('7643','2013-06-04','14:05:00',16.22),('7643','2013-06-04','14:10:00',17.09),('7643','2013-06-04','14:15:00',16.94),('7643','2013-06-04','14:20:00',16.99),('7643','2013-06-04','14:25:00',16.77),('7643','2013-06-04','14:30:00',16.67),('7643','2013-06-04','14:35:00',16.54),('7643','2013-06-04','14:40:00',16.45),('7643','2013-06-04','14:45:00',16.37),('7643','2013-06-04','14:50:00',16.38),('7643','2013-06-04','14:55:00',16.23),('7643','2013-06-04','15:00:00',15.82),('7643','2013-06-04','15:05:00',15.6),('7643','2013-06-04','15:10:00',15.45),('7643','2013-06-04','15:15:00',15.49),('7643','2013-06-04','15:20:00',15.3),('7643','2013-06-04','15:25:00',15.28),('7643','2013-06-04','15:30:00',15.26),('7643','2013-06-04','15:35:00',15.42),('7643','2013-06-04','15:40:00',15.11),('7643','2013-06-04','15:45:00',14.66),('7643','2013-06-04','15:50:00',14.26),('7643','2013-06-04','15:55:00',14.05),('7643','2013-06-04','16:00:00',13.9),('7643','2013-06-04','16:05:00',13.65),('7643','2013-06-04','16:10:00',13.27),('7643','2013-06-04','16:15:00',13.06),('7643','2013-06-04','16:20:00',12.87),('7643','2013-06-04','16:25:00',12.43),('7643','2013-06-04','16:30:00',12.29),('7643','2013-06-04','16:35:00',11.97),('7643','2013-06-04','16:40:00',11.66),('7643','2013-06-04','16:45:00',11.34),('7643','2013-06-04','16:50:00',11.03),('7643','2013-06-04','16:55:00',10.77),('7643','2013-06-04','17:00:00',10.47),('7643','2013-06-04','17:05:00',8.39),('7643','2013-06-04','17:10:00',8.73),('7643','2013-06-04','17:15:00',6.01),('7643','2013-06-04','17:20:00',6.53),('7643','2013-06-04','17:25:00',6.75),('7643','2013-06-04','17:30:00',7.68),('7643','2013-06-04','17:35:00',7.13),('7643','2013-06-04','17:40:00',6.63),('7643','2013-06-04','17:45:00',7.3),('7643','2013-06-04','17:50:00',6.95),('7643','2013-06-04','17:55:00',6.44),('7643','2013-06-04','18:00:00',5.84),('7643','2013-06-04','18:05:00',5.74),('7643','2013-06-04','18:10:00',4.12),('7643','2013-06-04','18:15:00',3.88),('7643','2013-06-04','18:20:00',3.19),('7643','2013-06-04','18:25:00',2.46),('7643','2013-06-04','18:30:00',4.37),('7643','2013-06-04','18:35:00',4.43),('7643','2013-06-04','18:40:00',3.61),('7643','2013-06-04','18:45:00',2.18),('7643','2013-06-04','18:50:00',1.96),('7643','2013-06-04','18:55:00',1.96),('7643','2013-06-04','19:00:00',2.06),('7643','2013-06-04','19:05:00',2.06),('7643','2013-06-04','19:10:00',1.86),('7643','2013-06-04','19:15:00',1.43),('7643','2013-06-03','06:55:00',1.06),('7643','2013-06-03','07:00:00',1.35),('7643','2013-06-03','07:05:00',2.54),('7643','2013-06-03','07:10:00',2.75),('7643','2013-06-03','07:15:00',3.05),('7643','2013-06-03','07:20:00',3.3),('7643','2013-06-03','07:25:00',3.53),('7643','2013-06-03','07:30:00',3.93),('7643','2013-06-03','07:35:00',4.32),('7643','2013-06-03','07:40:00',4.85),('7643','2013-06-03','07:45:00',5.62),('7643','2013-06-03','07:50:00',6.19),('7643','2013-06-03','07:55:00',6.66),('7643','2013-06-03','08:00:00',7.37),('7643','2013-06-03','08:05:00',8.02),('7643','2013-06-03','08:10:00',8.31),('7643','2013-06-03','08:15:00',8.5),('7643','2013-06-03','08:20:00',8.6),('7643','2013-06-03','08:25:00',8.83),('7643','2013-06-03','08:30:00',8.12),('7643','2013-06-03','08:35:00',9.97),('7643','2013-06-03','08:40:00',7.58),('7643','2013-06-03','08:45:00',7.72),('7643','2013-06-03','08:50:00',5.31),('7643','2013-06-03','08:55:00',5.05),('7643','2013-06-03','09:00:00',6.2),('7643','2013-06-03','09:05:00',6.67),('7643','2013-06-03','09:10:00',9.38),('7643','2013-06-03','09:15:00',12.03),('7643','2013-06-03','09:20:00',13.22),('7643','2013-06-03','09:25:00',12.5),('7643','2013-06-03','09:30:00',10.98),('7643','2013-06-03','09:35:00',9.76),('7643','2013-06-03','09:40:00',6.36),('7643','2013-06-03','09:45:00',6.78),('7643','2013-06-03','09:50:00',6.8),('7643','2013-06-03','09:55:00',6.91),('7643','2013-06-03','10:00:00',9.56),('7643','2013-06-03','10:05:00',9.65),('7643','2013-06-03','10:10:00',10.86),('7643','2013-06-03','10:15:00',8.98),('7643','2013-06-03','10:20:00',6.94),('7643','2013-06-03','10:25:00',6.81),('7643','2013-06-03','10:30:00',6.38),('7643','2013-06-03','10:35:00',6.47),('7643','2013-06-03','10:40:00',6.94),('7643','2013-06-03','10:45:00',7.97),('7643','2013-06-03','10:50:00',10.5),('7643','2013-06-03','10:55:00',13.1),('7643','2013-06-03','11:00:00',8.82),('7643','2013-06-03','11:05:00',9.03),('7643','2013-06-03','11:10:00',14.91),('7643','2013-06-03','11:15:00',12.17),('7643','2013-06-03','11:20:00',8.85),('7643','2013-06-03','11:25:00',10.37),('7643','2013-06-03','11:30:00',13.47),('7643','2013-06-03','11:35:00',12.26),('7643','2013-06-03','11:40:00',11.77),('7643','2013-06-03','11:45:00',14.97),('7643','2013-06-03','11:50:00',18.03),('7643','2013-06-03','11:55:00',12.18),('7643','2013-06-03','12:00:00',15.38),('7643','2013-06-03','12:05:00',16.05),('7643','2013-06-03','12:10:00',10.1),('7643','2013-06-03','12:15:00',11.16),('7643','2013-06-03','12:20:00',9.08),('7643','2013-06-03','12:25:00',7.82),('7643','2013-06-03','12:30:00',10.15),('7643','2013-06-03','12:35:00',15.14),('7643','2013-06-03','12:40:00',9.31),('7643','2013-06-03','12:45:00',12.16),('7643','2013-06-03','12:50:00',12.04),('7643','2013-06-03','12:55:00',7.86),('7643','2013-06-03','13:00:00',10.06),('7643','2013-06-03','13:05:00',6.13),('7643','2013-06-03','13:10:00',5.1),('7643','2013-06-03','13:15:00',5.22),('7643','2013-06-03','13:20:00',4.1),('7643','2013-06-03','13:25:00',4.51),('7643','2013-06-03','13:30:00',6.05),('7643','2013-06-03','13:35:00',8.51),('7643','2013-06-03','13:40:00',12.61),('7643','2013-06-03','13:45:00',16.15),('7643','2013-06-03','13:50:00',19.78),('7643','2013-06-03','13:55:00',18.32),('7643','2013-06-03','14:00:00',6.42),('7643','2013-06-03','14:05:00',14.38),('7643','2013-06-03','14:10:00',13.5),('7643','2013-06-03','14:15:00',15.04),('7643','2013-06-03','14:20:00',13.35),('7643','2013-06-03','14:25:00',10.18),('7643','2013-06-03','14:30:00',5.1),('7643','2013-06-03','14:35:00',5.68),('7643','2013-06-03','14:40:00',10.61),('7643','2013-06-03','14:45:00',4.82),('7643','2013-06-03','14:50:00',3.98),('7643','2013-06-03','14:55:00',13.01),('7643','2013-06-03','15:00:00',19.82),('7643','2013-06-03','15:05:00',19.12),('7643','2013-06-03','15:10:00',7.82),('7643','2013-06-03','15:15:00',4.49),('7643','2013-06-03','15:20:00',3.83),('7643','2013-06-03','15:25:00',3),('7643','2013-06-03','15:30:00',1.75),('7643','2013-06-03','17:10:00',1.08),('7643','2013-06-03','17:15:00',2.86),('7643','2013-06-03','17:20:00',3),('7643','2013-06-03','17:25:00',2.51),('7643','2013-06-03','17:30:00',1.83),('7643','2013-06-03','17:35:00',1.92),('7643','2013-06-03','17:40:00',3.81),('7643','2013-06-03','17:45:00',2.2),('7643','2013-06-03','17:50:00',2.27),('7643','2013-06-03','17:55:00',2.51),('7643','2013-06-03','18:00:00',2.74),('7643','2013-06-03','18:05:00',3.25),('7643','2013-06-03','18:10:00',3.48),('7643','2013-06-03','18:15:00',3.12),('7643','2013-06-03','18:20:00',2.78),('7643','2013-06-03','18:25:00',2.61),('7643','2013-06-03','18:30:00',2.15),('7643','2013-06-03','18:35:00',1.91),('7643','2013-06-03','18:40:00',2.29),('7643','2013-06-03','18:45:00',2.84),('7643','2013-06-03','18:50:00',2.65),('7643','2013-06-03','18:55:00',2.19),('7643','2013-06-03','19:00:00',1.95),('7643','2013-06-03','19:05:00',1.85),('7643','2013-06-03','19:10:00',1.65),('7643','2013-06-03','19:15:00',1.29),('7643','2013-06-03','19:20:00',1.22),('7643','2013-06-03','19:25:00',1.13),('7643','2013-06-03','19:30:00',1.02),('7643','2013-06-02','06:45:00',1.11),('7643','2013-06-02','06:50:00',1.27),('7643','2013-06-02','06:55:00',1.8),('7643','2013-06-02','07:00:00',2.09),('7643','2013-06-02','07:05:00',2.37),('7643','2013-06-02','07:10:00',1.97),('7643','2013-06-02','07:15:00',2.5),('7643','2013-06-02','07:20:00',2),('7643','2013-06-02','07:25:00',2.83),('7643','2013-06-02','07:30:00',1.71),('7643','2013-06-02','07:35:00',1.65),('7643','2013-06-02','07:40:00',4.23),('7643','2013-06-02','07:45:00',4.55),('7643','2013-06-02','07:50:00',5.3),('7643','2013-06-02','07:55:00',5.77),('7643','2013-06-02','08:00:00',6.09),('7643','2013-06-02','08:05:00',6.31),('7643','2013-06-02','08:10:00',6.6),('7643','2013-06-02','08:15:00',6.95),('7643','2013-06-02','08:20:00',7.25),('7643','2013-06-02','08:25:00',7.64),('7643','2013-06-02','08:30:00',7.92),('7643','2013-06-02','08:35:00',8.31),('7643','2013-06-02','08:40:00',8.58),('7643','2013-06-02','08:45:00',9.06),('7643','2013-06-02','08:50:00',9.28),('7643','2013-06-02','08:55:00',9.58),('7643','2013-06-02','09:00:00',9.82),('7643','2013-06-02','09:05:00',9.08),('7643','2013-06-02','09:10:00',10.16),('7643','2013-06-02','09:15:00',11.53),('7643','2013-06-02','09:20:00',12.41),('7643','2013-06-02','09:25:00',9.13),('7643','2013-06-02','09:30:00',8.33),('7643','2013-06-02','09:35:00',6.83),('7643','2013-06-02','09:40:00',10.41),('7643','2013-06-02','09:45:00',9.66),('7643','2013-06-02','09:50:00',13.32),('7643','2013-06-02','09:55:00',11.04),('7643','2013-06-02','10:00:00',15.35),('7643','2013-06-02','10:05:00',14.84),('7643','2013-06-02','10:10:00',11.09),('7643','2013-06-02','10:15:00',7.5),('7643','2013-06-02','10:20:00',7.52),('7643','2013-06-02','10:25:00',4.48),('7643','2013-06-02','10:30:00',4.39),('7643','2013-06-02','10:35:00',4.84),('7643','2013-06-02','10:40:00',6.09),('7643','2013-06-02','10:45:00',6.39),('7643','2013-06-02','10:50:00',6.57),('7643','2013-06-02','10:55:00',7),('7643','2013-06-02','11:00:00',9.69),('7643','2013-06-02','11:05:00',6.07),('7643','2013-06-02','11:10:00',5.08),('7643','2013-06-02','11:15:00',5.11),('7643','2013-06-02','11:20:00',6.5),('7643','2013-06-02','11:25:00',6.63),('7643','2013-06-02','11:30:00',6.08),('7643','2013-06-02','11:35:00',5.95),('7643','2013-06-02','11:40:00',10.83),('7643','2013-06-02','11:45:00',10.35),('7643','2013-06-02','11:50:00',5.81),('7643','2013-06-02','11:55:00',6.77),('7643','2013-06-02','12:00:00',8.26),('7643','2013-06-02','12:05:00',7.79),('7643','2013-06-02','12:10:00',7.28),('7643','2013-06-02','12:15:00',6.08),('7643','2013-06-02','12:20:00',5.54),('7643','2013-06-02','12:25:00',5.5),('7643','2013-06-02','12:30:00',8.19),('7643','2013-06-02','12:35:00',19.93),('7643','2013-06-02','12:40:00',13.71),('7643','2013-06-02','12:45:00',8.99),('7643','2013-06-02','12:50:00',8.35),('7643','2013-06-02','12:55:00',11.93),('7643','2013-06-02','13:00:00',7.72),('7643','2013-06-02','13:05:00',7.36),('7643','2013-06-02','13:10:00',8.11),('7643','2013-06-02','13:15:00',18.56),('7643','2013-06-02','13:20:00',19.29),('7643','2013-06-02','13:25:00',16.57),('7643','2013-06-02','13:30:00',15),('7643','2013-06-02','13:35:00',18.24),('7643','2013-06-02','13:40:00',15.59),('7643','2013-06-02','13:45:00',10.11),('7643','2013-06-02','13:50:00',14.2),('7643','2013-06-02','13:55:00',11.3),('7643','2013-06-02','14:00:00',16.48),('7643','2013-06-02','14:05:00',11.14),('7643','2013-06-02','14:10:00',9.57),('7643','2013-06-02','14:15:00',9.39),('7643','2013-06-02','14:20:00',8.48),('7643','2013-06-02','14:25:00',16.16),('7643','2013-06-02','14:30:00',18.42),('7643','2013-06-02','14:35:00',16.04),('7643','2013-06-02','14:40:00',12.82),('7643','2013-06-02','14:45:00',11.29),('7643','2013-06-02','14:50:00',9.46),('7643','2013-06-02','14:55:00',17.01),('7643','2013-06-02','15:00:00',17.66),('7643','2013-06-02','15:05:00',10.62),('7643','2013-06-02','15:10:00',16.53),('7643','2013-06-02','15:15:00',15.73),('7643','2013-06-02','15:20:00',11.79),('7643','2013-06-02','15:25:00',15.55),('7643','2013-06-02','15:30:00',15.2),('7643','2013-06-02','15:35:00',14.95),('7643','2013-06-02','15:40:00',14.74),('7643','2013-06-02','15:45:00',14.38),('7643','2013-06-02','15:50:00',14.32),('7643','2013-06-02','15:55:00',14.16),('7643','2013-06-02','16:00:00',13.92),('7643','2013-06-02','16:05:00',13.75),('7643','2013-06-02','16:10:00',13.6),('7643','2013-06-02','16:15:00',13.19),('7643','2013-06-02','16:20:00',12.48),('7643','2013-06-02','16:25:00',12.75),('7643','2013-06-02','16:30:00',12.96),('7643','2013-06-02','16:35:00',12.09),('7643','2013-06-02','16:40:00',12.16),('7643','2013-06-02','16:45:00',10.66),('7643','2013-06-02','16:50:00',8.08),('7643','2013-06-02','16:55:00',6.98),('7643','2013-06-02','17:00:00',8.25),('7643','2013-06-02','17:05:00',10.04),('7643','2013-06-02','17:10:00',8.92),('7643','2013-06-02','17:15:00',9.53),('7643','2013-06-02','17:20:00',8.54),('7643','2013-06-02','17:25:00',5.43),('7643','2013-06-02','17:30:00',3.13),('7643','2013-06-02','17:35:00',2.38),('7643','2013-06-02','17:40:00',2.38),('7643','2013-06-02','17:45:00',2.18),('7643','2013-06-02','17:50:00',2.64),('7643','2013-06-02','17:55:00',2.6),('7643','2013-06-02','18:00:00',2.19),('7643','2013-06-02','18:05:00',2),('7643','2013-06-02','18:10:00',1.81),('7643','2013-06-02','18:15:00',1.53),('7643','2013-06-02','18:20:00',1.08),('7643','2013-06-02','18:25:00',1.02),('7643','2013-06-02','18:30:00',1.23),('7643','2013-06-02','18:35:00',1.48),('7643','2013-06-02','18:40:00',1.55),('7643','2013-06-02','18:45:00',1.6),('7643','2013-06-02','18:50:00',1.57),('7643','2013-06-02','18:55:00',1.12),('7643','2013-06-01','06:40:00',1.19),('7643','2013-06-01','06:45:00',1.63),('7643','2013-06-01','06:50:00',2.45),('7643','2013-06-01','06:55:00',3.31),('7643','2013-06-01','07:00:00',3.5),('7643','2013-06-01','07:05:00',2.3),('7643','2013-06-01','07:10:00',1.72),('7643','2013-06-01','07:15:00',1.68),('7643','2013-06-01','07:20:00',1.56),('7643','2013-06-01','07:25:00',1.03),('7643','2013-06-01','07:40:00',1.15),('7643','2013-06-01','07:45:00',1.29),('7643','2013-06-01','07:50:00',1.02),('7643','2013-06-01','08:00:00',1.2),('7643','2013-06-01','08:15:00',1.18),('7643','2013-06-01','08:20:00',1.87),('7643','2013-06-01','08:25:00',2.88),('7643','2013-06-01','08:30:00',3.14),('7643','2013-06-01','08:35:00',3.38),('7643','2013-06-01','08:40:00',3.37),('7643','2013-06-01','08:45:00',3.62),('7643','2013-06-01','08:50:00',4.06),('7643','2013-06-01','08:55:00',3.6),('7643','2013-06-01','09:00:00',3.53),('7643','2013-06-01','09:05:00',3.78),('7643','2013-06-01','09:10:00',4.28),('7643','2013-06-01','09:15:00',4.5),('7643','2013-06-01','09:20:00',8.43),('7643','2013-06-01','09:25:00',13.32),('7643','2013-06-01','09:30:00',12.85),('7643','2013-06-01','09:35:00',12.71),('7643','2013-06-01','09:40:00',12.63),('7643','2013-06-01','09:45:00',12.72),('7643','2013-06-01','09:50:00',13.01),('7643','2013-06-01','09:55:00',13.14),('7643','2013-06-01','10:00:00',13.36),('7643','2013-06-01','10:05:00',13.31),('7643','2013-06-01','10:10:00',13.76),('7643','2013-06-01','10:15:00',13.99),('7643','2013-06-01','10:20:00',14.14),('7643','2013-06-01','10:25:00',14.24),('7643','2013-06-01','10:30:00',15.14),('7643','2013-06-01','10:35:00',16.15),('7643','2013-06-01','10:40:00',16.31),('7643','2013-06-01','10:45:00',15.5),('7643','2013-06-01','10:50:00',9.11),('7643','2013-06-01','10:55:00',11.87),('7643','2013-06-01','11:00:00',16.46),('7643','2013-06-01','11:05:00',14.03),('7643','2013-06-01','11:10:00',17.61),('7643','2013-06-01','11:15:00',12.67),('7643','2013-06-01','11:20:00',16.23),('7643','2013-06-01','11:25:00',15.8),('7643','2013-06-01','11:30:00',11.47),('7643','2013-06-01','11:35:00',6.21),('7643','2013-06-01','11:40:00',6.97),('7643','2013-06-01','11:45:00',5.35),('7643','2013-06-01','11:50:00',8.26),('7643','2013-06-01','11:55:00',10.01),('7643','2013-06-01','12:00:00',15.05),('7643','2013-06-01','12:05:00',8.34),('7643','2013-06-01','12:10:00',8.13),('7643','2013-06-01','12:15:00',17.29),('7643','2013-06-01','12:20:00',7.38),('7643','2013-06-01','12:25:00',6.37),('7643','2013-06-01','12:30:00',10.03),('7643','2013-06-01','12:35:00',8.6),('7643','2013-06-01','12:40:00',15.81),('7643','2013-06-01','12:45:00',19.01),('7643','2013-06-01','12:50:00',6.81),('7643','2013-06-01','12:55:00',16.76),('7643','2013-06-01','13:00:00',7.97),('7643','2013-06-01','13:05:00',5.59),('7643','2013-06-01','13:10:00',8.65),('7643','2013-06-01','13:15:00',19.43),('7643','2013-06-01','13:20:00',18.31),('7643','2013-06-01','13:25:00',17.81),('7643','2013-06-01','13:30:00',17.48),('7643','2013-06-01','13:35:00',17.55),('7643','2013-06-01','13:40:00',17.38),('7643','2013-06-01','13:45:00',17.26),('7643','2013-06-01','13:50:00',17.24),('7643','2013-06-01','13:55:00',17.15),('7643','2013-06-01','14:00:00',16.98),('7643','2013-06-01','14:05:00',16.92),('7643','2013-06-01','14:10:00',16.36),('7643','2013-06-01','14:15:00',16.81),('7643','2013-06-01','14:20:00',16.95),('7643','2013-06-01','14:25:00',16.89),('7643','2013-06-01','14:30:00',16.69),('7643','2013-06-01','14:35:00',16.47),('7643','2013-06-01','14:40:00',16.32),('7643','2013-06-01','14:45:00',16.18),('7643','2013-06-01','14:50:00',16.12),('7643','2013-06-01','14:55:00',15.96),('7643','2013-06-01','15:00:00',15.94),('7643','2013-06-01','15:05:00',15.73),('7643','2013-06-01','15:10:00',15.43),('7643','2013-06-01','15:15:00',15.49),('7643','2013-06-01','15:20:00',15.43),('7643','2013-06-01','15:25:00',14.62),('7643','2013-06-01','15:30:00',13.97),('7643','2013-06-01','15:35:00',11.72),('7643','2013-06-01','15:40:00',15.47),('7643','2013-06-01','15:45:00',14.66),('7643','2013-06-01','15:50:00',14.42),('7643','2013-06-01','15:55:00',11.06),('7643','2013-06-01','16:00:00',14.46),('7643','2013-06-01','16:05:00',13.53),('7643','2013-06-01','16:10:00',11.82),('7643','2013-06-01','16:15:00',8.41),('7643','2013-06-01','16:20:00',12.46),('7643','2013-06-01','16:25:00',12.63),('7643','2013-06-01','16:30:00',12.26),('7643','2013-06-01','16:35:00',11.76),('7643','2013-06-01','16:40:00',11.78),('7643','2013-06-01','16:45:00',11.27),('7643','2013-06-01','16:50:00',11.63),('7643','2013-06-01','16:55:00',11.1),('7643','2013-06-01','17:00:00',10.73),('7643','2013-06-01','17:05:00',10.33),('7643','2013-06-01','17:10:00',9.7),('7643','2013-06-01','17:15:00',9.38),('7643','2013-06-01','17:20:00',8.82),('7643','2013-06-01','17:25:00',8.78),('7643','2013-06-01','17:30:00',4.41),('7643','2013-06-01','17:35:00',7.84),('7643','2013-06-01','17:40:00',5.09),('7643','2013-06-01','17:45:00',6.01),('7643','2013-06-01','17:50:00',5.34),('7643','2013-06-01','17:55:00',3.8),('7643','2013-06-01','18:00:00',5.93),('7643','2013-06-01','18:05:00',2.67),('7643','2013-06-01','18:10:00',3.13),('7643','2013-06-01','18:15:00',2.65),('7643','2013-06-01','18:20:00',2.51),('7643','2013-06-01','18:25:00',2.41),('7643','2013-06-01','18:30:00',2.61),('7643','2013-06-01','18:35:00',2.39),('7643','2013-06-01','18:40:00',2.09),('7643','2013-06-01','18:45:00',2.09),('7643','2013-06-01','18:50:00',2.09),('7643','2013-06-01','18:55:00',1.53),('7643','2013-06-01','19:00:00',1.49),('7643','2013-06-01','19:05:00',1.22),('7643','2013-06-01','19:10:00',1.1),('7643','2013-06-01','19:15:00',1.11),('7643','2013-06-01','19:20:00',1.37),('7643','2013-06-01','19:25:00',1.05),('7643','2013-05-31','06:40:00',1.03),('7643','2013-05-31','06:45:00',1.22),('7643','2013-05-31','06:50:00',1.46),('7643','2013-05-31','06:55:00',1.74),('7643','2013-05-31','07:00:00',1.97),('7643','2013-05-31','07:05:00',2.31),('7643','2013-05-31','07:10:00',2.54),('7643','2013-05-31','07:15:00',2.87),('7643','2013-05-31','07:20:00',3.28),('7643','2013-05-31','07:25:00',3.62),('7643','2013-05-31','07:30:00',4.05),('7643','2013-05-31','07:35:00',4.43),('7643','2013-05-31','07:40:00',4.91),('7643','2013-05-31','07:45:00',5.86),('7643','2013-05-31','07:50:00',4.1),('7643','2013-05-31','07:55:00',4.39),('7643','2013-05-31','08:00:00',2.62),('7643','2013-05-31','08:05:00',2.25),('7643','2013-05-31','08:10:00',2.88),('7643','2013-05-31','08:15:00',6.3),('7643','2013-05-31','08:20:00',6.09),('7643','2013-05-31','08:25:00',3.42),('7643','2013-05-31','08:30:00',4.6),('7643','2013-05-31','08:35:00',5.25),('7643','2013-05-31','08:40:00',3.19),('7643','2013-05-31','08:45:00',2.16),('7643','2013-05-31','08:50:00',2.47),('7643','2013-05-31','08:55:00',2.54),('7643','2013-05-31','09:00:00',2.75),('7643','2013-05-31','09:05:00',2.11),('7643','2013-05-31','09:10:00',1.51),('7643','2013-05-31','09:15:00',1.69),('7643','2013-05-31','09:20:00',1.64),('7643','2013-05-31','09:25:00',1.78),('7643','2013-05-31','09:30:00',1.85),('7643','2013-05-31','09:35:00',1.71),('7643','2013-05-31','09:40:00',2.18),('7643','2013-05-31','09:45:00',3.18),('7643','2013-05-31','09:50:00',3.68),('7643','2013-05-31','09:55:00',2.77),('7643','2013-05-31','10:00:00',2.6),('7643','2013-05-31','10:05:00',2.9),('7643','2013-05-31','10:10:00',2.77),('7643','2013-05-31','10:15:00',2.36),('7643','2013-05-31','10:20:00',1.97),('7643','2013-05-31','10:25:00',1.35),('7643','2013-05-31','10:30:00',2.3),('7643','2013-05-31','10:35:00',4.16),('7643','2013-05-31','10:40:00',4.15),('7643','2013-05-31','10:45:00',2.75),('7643','2013-05-31','10:50:00',5.21),('7643','2013-05-31','10:55:00',9.28),('7643','2013-05-31','11:00:00',2.45),('7643','2013-05-31','11:05:00',1.58),('7643','2013-05-31','11:10:00',1.2),('7643','2013-05-31','11:15:00',1.52),('7643','2013-05-31','11:20:00',1.27),('7643','2013-05-31','11:25:00',1.53),('7643','2013-05-31','11:30:00',2.03),('7643','2013-05-31','11:35:00',1.87),('7643','2013-05-31','11:40:00',1.78),('7643','2013-05-31','11:45:00',2.62),('7643','2013-05-31','11:50:00',5.44),('7643','2013-05-31','11:55:00',6.87),('7643','2013-05-31','12:00:00',12.42),('7643','2013-05-31','12:05:00',12.7),('7643','2013-05-31','12:10:00',13.28),('7643','2013-05-31','12:15:00',6.2),('7643','2013-05-31','12:20:00',4.59),('7643','2013-05-31','12:25:00',4.69),('7643','2013-05-31','12:30:00',4.49),('7643','2013-05-31','12:35:00',3.49),('7643','2013-05-31','12:40:00',4.11),('7643','2013-05-31','12:45:00',6.5),('7643','2013-05-31','12:50:00',6.89),('7643','2013-05-31','12:55:00',6.97),('7643','2013-05-31','13:00:00',8.79),('7643','2013-05-31','13:05:00',9.25),('7643','2013-05-31','13:10:00',9.56),('7643','2013-05-31','13:15:00',10.38),('7643','2013-05-31','13:20:00',8.9),('7643','2013-05-31','13:25:00',6.79),('7643','2013-05-31','13:30:00',5.89),('7643','2013-05-31','13:35:00',4.67),('7643','2013-05-31','13:40:00',4.25),('7643','2013-05-31','13:45:00',4.92),('7643','2013-05-31','13:50:00',5.28),('7643','2013-05-31','13:55:00',5.94),('7643','2013-05-31','14:00:00',7.63),('7643','2013-05-31','14:05:00',9.43),('7643','2013-05-31','14:10:00',9.18),('7643','2013-05-31','14:15:00',9.74),('7643','2013-05-31','14:20:00',9.46),('7643','2013-05-31','14:25:00',6.13),('7643','2013-05-31','14:30:00',5.04),('7643','2013-05-31','14:35:00',5.18),('7643','2013-05-31','14:40:00',5.01),('7643','2013-05-31','14:45:00',4.91),('7643','2013-05-31','14:50:00',4.4),('7643','2013-05-31','14:55:00',3.38),('7643','2013-05-31','15:00:00',3.25),('7643','2013-05-31','15:05:00',3.23),('7643','2013-05-31','15:10:00',2.44),('7643','2013-05-31','15:15:00',2.31),('7643','2013-05-31','15:20:00',1.96),('7643','2013-05-31','15:25:00',1.47),('7643','2013-05-31','15:40:00',1.21),('7643','2013-05-31','15:45:00',1.75),('7643','2013-05-31','15:50:00',1.72),('7643','2013-05-31','15:55:00',1.69),('7643','2013-05-31','16:00:00',1.84),('7643','2013-05-31','16:05:00',2.17),('7643','2013-05-31','16:10:00',2.08),('7643','2013-05-31','16:15:00',2.32),('7643','2013-05-31','16:20:00',2.66),('7643','2013-05-31','16:25:00',2.08),('7643','2013-05-31','16:30:00',2.36),('7643','2013-05-31','16:35:00',2.66),('7643','2013-05-31','16:40:00',3.07),('7643','2013-05-31','16:45:00',2.65),('7643','2013-05-31','16:50:00',2.58),('7643','2013-05-31','16:55:00',2.57),('7643','2013-05-31','17:00:00',1.46),('7643','2013-05-31','18:25:00',1.69),('7643','2013-05-31','18:30:00',3.25),('7643','2013-05-31','18:35:00',3.94),('7643','2013-05-31','18:40:00',2.9),('7643','2013-05-31','18:45:00',2.17),('7643','2013-05-31','18:50:00',1.99),('7643','2013-05-31','18:55:00',2.27),('7643','2013-05-31','19:00:00',3.8),('7643','2013-05-31','19:05:00',3.4),('7643','2013-05-31','19:10:00',1.95),('7643','2014-04-01','07:35:00',1.15),('7643','2014-04-01','07:40:00',1.65),('7643','2014-04-01','07:45:00',1.66),('7643','2014-04-01','07:50:00',1.44),('7643','2014-04-01','07:55:00',2.02),('7643','2014-04-01','08:00:00',3.58),('7643','2014-04-01','08:05:00',3.91),('7643','2014-04-01','08:10:00',3.12),('7643','2014-04-01','08:15:00',2.59),('7643','2014-04-01','08:20:00',4.36),('7643','2014-04-01','08:25:00',2.97),('7643','2014-04-01','08:30:00',1.7),('7643','2014-04-01','08:35:00',2.35),('7643','2014-04-01','08:40:00',2.8),('7643','2014-04-01','08:45:00',3.03),('7643','2014-04-01','08:50:00',3.67),('7643','2014-04-01','08:55:00',8),('7643','2014-04-01','09:00:00',4.43),('7643','2014-04-01','09:05:00',4.43),('7643','2014-04-01','09:10:00',3.74),('7643','2014-04-01','09:15:00',3.99),('7643','2014-04-01','09:20:00',3.68),('7643','2014-04-01','09:25:00',3.26),('7643','2014-04-01','09:30:00',2.63),('7643','2014-04-01','09:35:00',3.15),('7643','2014-04-01','09:40:00',3.54),('7643','2014-04-01','09:45:00',2.87),('7643','2014-04-01','09:50:00',2.4),('7643','2014-04-01','09:55:00',2.82),('7643','2014-04-01','10:00:00',7.94),('7643','2014-04-01','10:05:00',8.81),('7643','2014-04-01','10:10:00',9.86),('7643','2014-04-01','10:15:00',9.98),('7643','2014-04-01','10:20:00',13.42),('7643','2014-04-01','10:25:00',13.38),('7643','2014-04-01','10:30:00',13.51),('7643','2014-04-01','10:35:00',4.05),('7643','2014-04-01','10:40:00',3.23),('7643','2014-04-01','10:45:00',3.22),('7643','2014-04-01','10:50:00',3.64),('7643','2014-04-01','10:55:00',13.4),('7643','2014-04-01','11:00:00',14.99),('7643','2014-04-01','11:05:00',12.48),('7643','2014-04-01','11:10:00',10.08),('7643','2014-04-01','11:15:00',5.1),('7643','2014-04-01','11:20:00',14.79),('7643','2014-04-01','11:25:00',16.14),('7643','2014-04-01','11:30:00',16.79),('7643','2014-04-01','11:35:00',15.31),('7643','2014-04-01','11:40:00',6.29),('7643','2014-04-01','11:45:00',4.47),('7643','2014-04-01','11:50:00',8.22),('7643','2014-04-01','11:55:00',10.25),('7643','2014-04-01','12:00:00',8.59),('7643','2014-04-01','12:05:00',18.75),('7643','2014-04-01','12:10:00',5.48),('7643','2014-04-01','12:15:00',4.59),('7643','2014-04-01','12:20:00',10.46),('7643','2014-04-01','12:25:00',10.28),('7643','2014-04-01','12:30:00',4.37),('7643','2014-04-01','12:35:00',15.19),('7643','2014-04-01','12:40:00',15.63),('7643','2014-04-01','12:45:00',18.08),('7643','2014-04-01','12:50:00',15.12),('7643','2014-04-01','12:55:00',10.32),('7643','2014-04-01','13:00:00',9.03),('7643','2014-04-01','13:05:00',8.47),('7643','2014-04-01','13:10:00',16.84),('7643','2014-04-01','13:15:00',18.43),('7643','2014-04-01','13:20:00',15.91),('7643','2014-04-01','13:25:00',17.63),('7643','2014-04-01','13:30:00',16.01),('7643','2014-04-01','13:35:00',17.39),('7643','2014-04-01','13:40:00',17.79),('7643','2014-04-01','13:45:00',17),('7643','2014-04-01','13:50:00',16.54),('7643','2014-04-01','13:55:00',16.51),('7643','2014-04-01','14:00:00',16.48),('7643','2014-04-01','14:05:00',16.07),('7643','2014-04-01','14:10:00',13.91),('7643','2014-04-01','14:15:00',16.26),('7643','2014-04-01','14:20:00',16),('7643','2014-04-01','14:25:00',15.86),('7643','2014-04-01','14:30:00',15.9),('7643','2014-04-01','14:35:00',15.65),('7643','2014-04-01','14:40:00',13.52),('7643','2014-04-01','14:45:00',15.67),('7643','2014-04-01','14:50:00',15.05),('7643','2014-04-01','14:55:00',13.95),('7643','2014-04-01','15:00:00',14.38),('7643','2014-04-01','15:05:00',13.23),('7643','2014-04-01','15:10:00',13.49),('7643','2014-04-01','15:15:00',13.62),('7643','2014-04-01','15:20:00',13.68),('7643','2014-04-01','15:25:00',13.47),('7643','2014-04-01','15:30:00',12.72),('7643','2014-04-01','15:35:00',12.33),('7643','2014-04-01','15:40:00',12.73),('7643','2014-04-01','15:45:00',13.02),('7643','2014-04-01','15:50:00',12.89),('7643','2014-04-01','15:55:00',11.32),('7643','2014-04-01','16:00:00',11.71),('7643','2014-04-01','16:05:00',11.69),('7643','2014-04-01','16:10:00',11.47),('7643','2014-04-01','16:15:00',11.1),('7643','2014-04-01','16:20:00',10.71),('7643','2014-04-01','16:25:00',10.53),('7643','2014-04-01','16:30:00',10.47),('7643','2014-04-01','16:35:00',10.13),('7643','2014-04-01','16:40:00',9.8),('7643','2014-04-01','16:45:00',9.46),('7643','2014-04-01','16:50:00',8.66),('7643','2014-04-01','16:55:00',8.52),('7643','2014-04-01','17:00:00',8.75),('7643','2014-04-01','17:05:00',7.85),('7643','2014-04-01','17:10:00',7.48),('7643','2014-04-01','17:15:00',6.66),('7643','2014-04-01','17:20:00',6.62),('7643','2014-04-01','17:25:00',6.3),('7643','2014-04-01','17:30:00',5.67),('7643','2014-04-01','17:35:00',5.49),('7643','2014-04-01','17:40:00',4.17),('7643','2014-04-01','17:45:00',4.05),('7643','2014-04-01','17:50:00',4.94),('7643','2014-04-01','17:55:00',4.24),('7643','2014-04-01','18:00:00',3.88),('7643','2014-04-01','18:05:00',2.53),('7643','2014-04-01','18:10:00',2.18),('7643','2014-04-01','18:15:00',2.06),('7643','2014-04-01','18:20:00',2.18),('7643','2014-04-01','18:25:00',1.93),('7643','2014-04-01','18:30:00',1.49),('7643','2014-04-01','18:35:00',1.13),('7643','2013-05-30','06:40:00',1.09),('7643','2013-05-30','06:45:00',1.26),('7643','2013-05-30','06:50:00',1.53),('7643','2013-05-30','06:55:00',1.8),('7643','2013-05-30','07:00:00',2.06),('7643','2013-05-30','07:05:00',2.38),('7643','2013-05-30','07:10:00',2.61),('7643','2013-05-30','07:15:00',2.91),('7643','2013-05-30','07:20:00',3.31),('7643','2013-05-30','07:25:00',3.69),('7643','2013-05-30','07:30:00',4.09),('7643','2013-05-30','07:35:00',4.39),('7643','2013-05-30','07:40:00',4.89),('7643','2013-05-30','07:45:00',5.24),('7643','2013-05-30','07:50:00',5.6),('7643','2013-05-30','07:55:00',6.05),('7643','2013-05-30','08:00:00',6.49),('7643','2013-05-30','08:05:00',6.72),('7643','2013-05-30','08:10:00',7.04),('7643','2013-05-30','08:15:00',7.28),('7643','2013-05-30','08:20:00',7.62),('7643','2013-05-30','08:25:00',8.05),('7643','2013-05-30','08:30:00',8.59),('7643','2013-05-30','08:35:00',8.92),('7643','2013-05-30','08:40:00',9.01),('7643','2013-05-30','08:45:00',3.65),('7643','2013-05-30','08:50:00',11.41),('7643','2013-05-30','08:55:00',6.1),('7643','2013-05-30','09:00:00',3.61),('7643','2013-05-30','09:05:00',2.94),('7643','2013-05-30','09:10:00',4.11),('7643','2013-05-30','09:15:00',3.33),('7643','2013-05-30','09:20:00',2.95),('7643','2013-05-30','09:25:00',3.42),('7643','2013-05-30','09:30:00',8.63),('7643','2013-05-30','09:35:00',14.98),('7643','2013-05-30','09:40:00',8.2),('7643','2013-05-30','09:45:00',12.7),('7643','2013-05-30','09:50:00',14.4),('7643','2013-05-30','09:55:00',14.59),('7643','2013-05-30','10:00:00',15.14),('7643','2013-05-30','10:05:00',10.48),('7643','2013-05-30','10:10:00',7.81),('7643','2013-05-30','10:15:00',13.07),('7643','2013-05-30','10:20:00',12.38),('7643','2013-05-30','10:25:00',5.58),('7643','2013-05-30','10:30:00',9.05),('7643','2013-05-30','10:35:00',10.82),('7643','2013-05-30','10:40:00',14.01),('7643','2013-05-30','10:45:00',15.53),('7643','2013-05-30','10:50:00',11.8),('7643','2013-05-30','10:55:00',16.28),('7643','2013-05-30','11:00:00',6.08),('7643','2013-05-30','11:05:00',5.91),('7643','2013-05-30','11:10:00',19.86),('7643','2013-05-30','11:15:00',17.11),('7643','2013-05-30','11:20:00',5.4),('7643','2013-05-30','11:25:00',7.19),('7643','2013-05-30','11:30:00',12.36),('7643','2013-05-30','11:35:00',9.89),('7643','2013-05-30','11:40:00',4.39),('7643','2013-05-30','11:45:00',12.26),('7643','2013-05-30','11:50:00',16.35),('7643','2013-05-30','11:55:00',9.93),('7643','2013-05-30','12:00:00',8.74),('7643','2013-05-30','12:05:00',17),('7643','2013-05-30','12:10:00',16.34),('7643','2013-05-30','12:15:00',6.19),('7643','2013-05-30','12:20:00',5.66),('7643','2013-05-30','12:25:00',13.31),('7643','2013-05-30','12:30:00',6.46),('7643','2013-05-30','12:35:00',5.76),('7643','2013-05-30','12:40:00',13.52),('7643','2013-05-30','12:45:00',9.72),('7643','2013-05-30','12:50:00',3.19),('7643','2013-05-30','12:55:00',4.75),('7643','2013-05-30','13:00:00',13),('7643','2013-05-30','13:05:00',8.55),('7643','2013-05-30','13:10:00',2.66),('7643','2013-05-30','13:15:00',2.34),('7643','2013-05-30','13:20:00',3.81),('7643','2013-05-30','13:25:00',6.42),('7643','2013-05-30','13:30:00',14.77),('7643','2013-05-30','13:35:00',19.07),('7643','2013-05-30','13:40:00',7.87),('7643','2013-05-30','13:45:00',4.85),('7643','2013-05-30','13:50:00',2.59),('7643','2013-05-30','13:55:00',3.29),('7643','2013-05-30','14:00:00',7.22),('7643','2013-05-30','14:05:00',3.07),('7643','2013-05-30','14:10:00',2.41),('7643','2013-05-30','14:15:00',1.39),('7643','2013-05-30','14:20:00',2.39),('7643','2013-05-30','14:25:00',2.83),('7643','2013-05-30','14:30:00',1.19),('7643','2013-05-30','14:45:00',2.17),('7643','2013-05-30','14:50:00',2.98),('7643','2013-05-30','14:55:00',2.42),('7643','2013-05-30','15:00:00',2.9),('7643','2013-05-30','15:05:00',5.57),('7643','2013-05-30','15:10:00',6.35),('7643','2013-05-30','15:15:00',9.06),('7643','2013-05-30','15:20:00',18.54),('7643','2013-05-30','15:25:00',13.52),('7643','2013-05-30','15:30:00',11),('7643','2013-05-30','15:35:00',8.01),('7643','2013-05-30','15:40:00',6.77),('7643','2013-05-30','15:45:00',6),('7643','2013-05-30','15:50:00',8.6),('7643','2013-05-30','15:55:00',8.2),('7643','2013-05-30','16:00:00',6.08),('7643','2013-05-30','16:05:00',5),('7643','2013-05-30','16:10:00',3.92),('7643','2013-05-30','16:15:00',3.46),('7643','2013-05-30','16:20:00',3.91),('7643','2013-05-30','16:25:00',5.09),('7643','2013-05-30','16:30:00',4.84),('7643','2013-05-30','16:35:00',4.07),('7643','2013-05-30','16:40:00',4.52),('7643','2013-05-30','16:45:00',4.67),('7643','2013-05-30','16:50:00',3.26),('7643','2013-05-30','16:55:00',2.45),('7643','2013-05-30','17:00:00',2.27),('7643','2013-05-30','17:05:00',2.29),('7643','2013-05-30','17:10:00',2.18),('7643','2013-05-30','17:15:00',2.29),('7643','2013-05-30','17:20:00',2.6),('7643','2013-05-30','17:25:00',2.84),('7643','2013-05-30','17:30:00',2.8),('7643','2013-05-30','17:35:00',2.34),('7643','2013-05-30','17:40:00',2.01),('7643','2013-05-30','17:45:00',2.15),('7643','2013-05-30','17:50:00',2),('7643','2013-05-30','17:55:00',1.73),('7643','2013-05-30','18:00:00',1.62),('7643','2013-05-30','18:05:00',1.88),('7643','2013-05-30','18:10:00',1.9),('7643','2013-05-30','18:15:00',1.72),('7643','2013-05-30','18:20:00',1.36),('7643','2013-05-30','18:25:00',1.02),('7643','2013-05-30','18:30:00',1.48),('7643','2013-05-30','18:35:00',1.91),('7643','2013-05-30','19:00:00',1.62),('7643','2013-05-30','19:05:00',1.63),('7643','2013-05-30','19:10:00',1.7),('7643','2013-05-30','19:15:00',1.11),('7643','2013-05-30','19:25:00',1.45),('7643','2013-05-30','19:30:00',1.46),('7643','2013-05-30','19:35:00',1.16),('7643','2013-05-30','19:40:00',1.16),('7643','2013-05-30','19:45:00',1.08),('7643','2013-05-29','07:30:00',1.22),('7643','2013-05-29','07:35:00',1.65),('7643','2013-05-29','07:40:00',2.28),('7643','2013-05-29','07:45:00',2.9),('7643','2013-05-29','07:50:00',4.02),('7643','2013-05-29','07:55:00',3.33),('7643','2013-05-29','08:00:00',2.54),('7643','2013-05-29','08:05:00',1.78),('7643','2013-05-29','08:10:00',2.24),('7643','2013-05-29','08:15:00',2.65),('7643','2013-05-29','08:20:00',3.13),('7643','2013-05-29','08:25:00',6.05),('7643','2013-05-29','08:30:00',4.25),('7643','2013-05-29','08:35:00',3.03),('7643','2013-05-29','08:40:00',9.69),('7643','2013-05-29','08:45:00',9.76),('7643','2013-05-29','08:50:00',9.99),('7643','2013-05-29','08:55:00',10.24),('7643','2013-05-29','09:00:00',10.46),('7643','2013-05-29','09:05:00',10.61),('7643','2013-05-29','09:10:00',11.1),('7643','2013-05-29','09:15:00',11.56),('7643','2013-05-29','09:20:00',11.86),('7643','2013-05-29','09:25:00',11.92),('7643','2013-05-29','09:30:00',12.38),('7643','2013-05-29','09:35:00',12.25),('7643','2013-05-29','09:40:00',13.2),('7643','2013-05-29','09:45:00',13.36),('7643','2013-05-29','09:50:00',12.48),('7643','2013-05-29','09:55:00',8.83),('7643','2013-05-29','10:00:00',6.01),('7643','2013-05-29','10:05:00',4.9),('7643','2013-05-29','10:10:00',9.24),('7643','2013-05-29','10:15:00',8.01),('7643','2013-05-29','10:20:00',16.89),('7643','2013-05-29','10:25:00',4.95),('7643','2013-05-29','10:30:00',5.83),('7643','2013-05-29','10:35:00',6.43),('7643','2013-05-29','10:40:00',12.66),('7643','2013-05-29','10:45:00',11.71),('7643','2013-05-29','10:50:00',16.2),('7643','2013-05-29','10:55:00',13.26),('7643','2013-05-29','11:00:00',18.03),('7643','2013-05-29','11:05:00',19.06),('7643','2013-05-29','11:10:00',7.99),('7643','2013-05-29','11:15:00',7.48),('7643','2013-05-29','11:20:00',14.55),('7643','2013-05-29','11:25:00',7.94),('7643','2013-05-29','11:30:00',15.07),('7643','2013-05-29','11:35:00',18.31),('7643','2013-05-29','11:40:00',19.23),('7643','2013-05-29','11:45:00',14.94),('7643','2013-05-29','11:50:00',15.18),('7643','2013-05-29','11:55:00',6.02),('7643','2013-05-29','12:00:00',16.26),('7643','2013-05-29','12:05:00',19.04),('7643','2013-05-29','12:10:00',9.23),('7643','2013-05-29','12:15:00',15.89),('7643','2013-05-29','12:20:00',13.22),('7643','2013-05-29','12:25:00',16.22),('7643','2013-05-29','12:30:00',15.06),('7643','2013-05-29','12:35:00',11.69),('7643','2013-05-29','12:40:00',17.99),('7643','2013-05-29','12:45:00',9.39),('7643','2013-05-29','12:50:00',18.77),('7643','2013-05-29','12:55:00',18.29),('7643','2013-05-29','13:00:00',14.98),('7643','2013-05-29','13:05:00',14.99),('7643','2013-05-29','13:10:00',8.46),('7643','2013-05-29','13:15:00',10.84),('7643','2013-05-29','13:20:00',6.83),('7643','2013-05-29','13:25:00',7.7),('7643','2013-05-29','13:30:00',8.94),('7643','2013-05-29','13:35:00',6.44),('7643','2013-05-29','13:40:00',17.72),('7643','2013-05-29','13:45:00',14.68),('7643','2013-05-29','13:50:00',6.02),('7643','2013-05-29','13:55:00',8.19),('7643','2013-05-29','14:00:00',11.79),('7643','2013-05-29','14:05:00',19.5),('7643','2013-05-29','14:10:00',16.76),('7643','2013-05-29','14:15:00',19.19),('7643','2013-05-29','14:20:00',12.27),('7643','2013-05-29','14:25:00',16.31),('7643','2013-05-29','14:30:00',16.8),('7643','2013-05-29','14:35:00',17.63),('7643','2013-05-29','14:40:00',18.16),('7643','2013-05-29','14:45:00',18.15),('7643','2013-05-29','14:50:00',18.14),('7643','2013-05-29','14:55:00',17.55),('7643','2013-05-29','15:00:00',16.57),('7643','2013-05-29','15:05:00',16.2),('7643','2013-05-29','15:10:00',5.86),('7643','2013-05-29','15:15:00',15.6),('7643','2013-05-29','15:20:00',17.45),('7643','2013-05-29','15:25:00',16.98),('7643','2013-05-29','15:30:00',14.86),('7643','2013-05-29','15:35:00',13.66),('7643','2013-05-29','15:40:00',17.84),('7643','2013-05-29','15:45:00',16.99),('7643','2013-05-29','15:50:00',8.49),('7643','2013-05-29','15:55:00',11.83),('7643','2013-05-29','16:00:00',17.83),('7643','2013-05-29','16:05:00',15.61),('7643','2013-05-29','16:10:00',15.44),('7643','2013-05-29','16:15:00',14.45),('7643','2013-05-29','16:20:00',13.28),('7643','2013-05-29','16:25:00',9.67),('7643','2013-05-29','16:30:00',10.38),('7643','2013-05-29','16:35:00',8.3),('7643','2013-05-29','16:40:00',5.51),('7643','2013-05-29','16:45:00',9.81),('7643','2013-05-29','16:50:00',10.24),('7643','2013-05-29','16:55:00',9.85),('7643','2013-05-29','17:00:00',7.29),('7643','2013-05-29','17:05:00',7.28),('7643','2013-05-29','17:10:00',3.11),('7643','2013-05-29','17:15:00',4.14),('7643','2013-05-29','17:20:00',4.91),('7643','2013-05-29','17:25:00',4.35),('7643','2013-05-29','17:30:00',4.44),('7643','2013-05-29','17:35:00',2.52),('7643','2013-05-29','17:40:00',1.99),('7643','2013-05-29','17:45:00',1.73),('7643','2013-05-29','17:50:00',1.26),('7643','2013-05-29','17:55:00',1.97),('7643','2013-05-29','18:00:00',3.28),('7643','2013-05-29','18:05:00',3.58),('7643','2013-05-29','18:10:00',3.55),('7643','2013-05-29','18:15:00',2.85),('7643','2013-05-29','18:20:00',2.43),('7643','2013-05-29','18:25:00',2.7),('7643','2013-05-29','18:30:00',3.07),('7643','2013-05-29','18:35:00',4.5),('7643','2013-05-29','18:40:00',4.58),('7643','2013-05-29','18:45:00',4.79),('7643','2013-05-29','18:50:00',4.87),('7643','2013-05-29','18:55:00',2.43),('7643','2013-05-29','19:00:00',2.15),('7643','2013-05-29','19:05:00',1.96),('7643','2013-05-29','19:40:00',1),('7643','2013-05-28','06:40:00',1.01),('7643','2013-05-28','06:45:00',1.17),('7643','2013-05-28','06:50:00',1.35),('7643','2013-05-28','06:55:00',1.56),('7643','2013-05-28','07:00:00',1.87),('7643','2013-05-28','07:05:00',2.19),('7643','2013-05-28','07:10:00',2.48),('7643','2013-05-28','07:15:00',2.89),('7643','2013-05-28','07:20:00',3.22),('7643','2013-05-28','07:25:00',3.56),('7643','2013-05-28','07:30:00',3.91),('7643','2013-05-28','07:35:00',4.34),('7643','2013-05-28','07:40:00',4.68),('7643','2013-05-28','07:45:00',5.03),('7643','2013-05-28','07:50:00',5.34),('7643','2013-05-28','07:55:00',5.7),('7643','2013-05-28','08:00:00',6.07),('7643','2013-05-28','08:05:00',6.38),('7643','2013-05-28','08:10:00',6.74),('7643','2013-05-28','08:15:00',7.02),('7643','2013-05-28','08:20:00',7.4),('7643','2013-05-28','08:25:00',7.76),('7643','2013-05-28','08:30:00',8.12),('7643','2013-05-28','08:35:00',8.51),('7643','2013-05-28','08:40:00',8.86),('7643','2013-05-28','08:45:00',9.22),('7643','2013-05-28','08:50:00',9.59),('7643','2013-05-28','08:55:00',9.9),('7643','2013-05-28','09:00:00',10.24),('7643','2013-05-28','09:05:00',10.53),('7643','2013-05-28','09:10:00',10.87),('7643','2013-05-28','09:15:00',11.19),('7643','2013-05-28','09:20:00',11.42),('7643','2013-05-28','09:25:00',11.68),('7643','2013-05-28','09:30:00',11.89),('7643','2013-05-28','09:35:00',12.18),('7643','2013-05-28','09:40:00',12.56),('7643','2013-05-28','09:45:00',12.81),('7643','2013-05-28','09:50:00',13.03),('7643','2013-05-28','09:55:00',13.3),('7643','2013-05-28','10:00:00',13.47),('7643','2013-05-28','10:05:00',13.74),('7643','2013-05-28','10:10:00',13.96),('7643','2013-05-28','10:15:00',14.17),('7643','2013-05-28','10:20:00',14.43),('7643','2013-05-28','10:25:00',14.62),('7643','2013-05-28','10:30:00',14.86),('7643','2013-05-28','10:35:00',15.07),('7643','2013-05-28','10:40:00',15.33),('7643','2013-05-28','10:45:00',15.44),('7643','2013-05-28','10:50:00',15.76),('7643','2013-05-28','10:55:00',15.95),('7643','2013-05-28','11:00:00',15.95),('7643','2013-05-28','11:05:00',16.11),('7643','2013-05-28','11:10:00',16.53),('7643','2013-05-28','11:15:00',11.82),('7643','2013-05-28','11:20:00',17.58),('7643','2013-05-28','11:25:00',18.31),('7643','2013-05-28','11:30:00',13.42),('7643','2013-05-28','11:35:00',16.47),('7643','2013-05-28','11:40:00',16.56),('7643','2013-05-28','11:45:00',15.51),('7643','2013-05-28','11:50:00',11.4),('7643','2013-05-28','11:55:00',16.17),('7643','2013-05-28','12:00:00',15.2),('7643','2013-05-28','12:05:00',11.64),('7643','2013-05-28','12:10:00',16.83),('7643','2013-05-28','12:15:00',15.15),('7643','2013-05-28','12:20:00',14.36),('7643','2013-05-28','12:25:00',18.55),('7643','2013-05-28','12:30:00',18.1),('7643','2013-05-28','12:35:00',18.13),('7643','2013-05-28','12:40:00',18.05),('7643','2013-05-28','12:45:00',16.18),('7643','2013-05-28','12:50:00',17.11),('7643','2013-05-28','12:55:00',17.72),('7643','2013-05-28','13:00:00',18.23),('7643','2013-05-28','13:05:00',17.59),('7643','2013-05-28','13:10:00',17.47),('7643','2013-05-28','13:15:00',17.57),('7643','2013-05-28','13:20:00',14.27),('7643','2013-05-28','13:25:00',18.64),('7643','2013-05-28','13:30:00',19.07),('7643','2013-05-28','13:35:00',17.38),('7643','2013-05-28','13:40:00',19.18),('7643','2013-05-28','13:45:00',16.96),('7643','2013-05-28','13:50:00',15.31),('7643','2013-05-28','13:55:00',15.35),('7643','2013-05-28','14:00:00',17.99),('7643','2013-05-28','14:05:00',17.67),('7643','2013-05-28','14:10:00',17.19),('7643','2013-05-28','14:15:00',17.77),('7643','2013-05-28','14:20:00',17.65),('7643','2013-05-28','14:25:00',17.19),('7643','2013-05-28','14:30:00',17.7),('7643','2013-05-28','14:35:00',9.88),('7643','2013-05-28','14:40:00',16.96),('7643','2013-05-28','14:45:00',17.79),('7643','2013-05-28','14:50:00',16.88),('7643','2013-05-28','14:55:00',15.41),('7643','2013-05-28','15:00:00',15.2),('7643','2013-05-28','15:05:00',18.07),('7643','2013-05-28','15:10:00',13.96),('7643','2013-05-28','15:15:00',8.87),('7643','2013-05-28','15:20:00',12.83),('7643','2013-05-28','15:25:00',11.76),('7643','2013-05-28','15:30:00',10.99),('7643','2013-05-28','15:35:00',10.92),('7643','2013-05-28','15:40:00',9.83),('7643','2013-05-28','15:45:00',11.97),('7643','2013-05-28','15:50:00',12.02),('7643','2013-05-28','15:55:00',11.34),('7643','2013-05-28','16:00:00',10.03),('7643','2013-05-28','16:05:00',10.45),('7643','2013-05-28','16:10:00',8.54),('7643','2013-05-28','16:15:00',7.91),('7643','2013-05-28','16:20:00',7.9),('7643','2013-05-28','16:25:00',7.54),('7643','2013-05-28','16:30:00',7.04),('7643','2013-05-28','16:35:00',6.83),('7643','2013-05-28','16:40:00',7.72),('7643','2013-05-28','16:45:00',7.29),('7643','2013-05-28','16:50:00',5.55),('7643','2013-05-28','16:55:00',5.53),('7643','2013-05-28','17:00:00',5.26),('7643','2013-05-28','17:05:00',2.55),('7643','2013-05-28','17:10:00',1.5),('7643','2013-05-28','17:15:00',1.46),('7643','2013-05-28','17:20:00',1.66),('7643','2013-05-28','17:25:00',2.23),('7643','2013-05-28','17:30:00',2.62),('7643','2013-05-28','17:35:00',3.89),('7643','2013-05-28','17:40:00',5.6),('7643','2013-05-28','17:45:00',4.15),('7643','2013-05-28','17:50:00',3.1),('7643','2013-05-28','17:55:00',2.48),('7643','2013-05-28','18:00:00',2.85),('7643','2013-05-28','18:05:00',3.52),('7643','2013-05-28','18:10:00',3.56),('7643','2013-05-28','18:15:00',7.04),('7643','2013-05-28','18:20:00',5.97),('7643','2013-05-28','18:25:00',1.84),('7643','2013-05-28','18:30:00',1.5),('7643','2013-05-28','18:35:00',1.64),('7643','2013-05-28','18:40:00',1.42),('7643','2013-05-28','18:50:00',1.58),('7643','2013-05-28','18:55:00',1.8),('7643','2013-05-28','19:00:00',1.45),('7643','2013-05-28','19:05:00',2),('7643','2013-05-28','19:10:00',2.07),('7643','2013-05-28','19:15:00',2.25),('7643','2013-05-28','19:20:00',1.82),('7643','2013-05-28','19:25:00',1.54),('7643','2013-05-28','19:30:00',1.3),('7643','2013-05-28','19:35:00',1.02),('7643','2013-05-28','19:40:00',1.01),('7643','2013-05-27','06:35:00',1.28),('7643','2013-05-27','06:40:00',1.74),('7643','2013-05-27','06:45:00',2.07),('7643','2013-05-27','06:50:00',2.22),('7643','2013-05-27','06:55:00',2),('7643','2013-05-27','07:00:00',1.61),('7643','2013-05-27','07:05:00',1.73),('7643','2013-05-27','07:10:00',2.48),('7643','2013-05-27','07:15:00',3.39),('7643','2013-05-27','07:20:00',4.04),('7643','2013-05-27','07:25:00',4.3),('7643','2013-05-27','07:30:00',3.41),('7643','2013-05-27','07:35:00',3.27),('7643','2013-05-27','07:40:00',4.07),('7643','2013-05-27','07:45:00',4.44),('7643','2013-05-27','07:50:00',4.3),('7643','2013-05-27','07:55:00',4.52),('7643','2013-05-27','08:00:00',4.62),('7643','2013-05-27','08:05:00',4.94),('7643','2013-05-27','08:10:00',5.67),('7643','2013-05-27','08:15:00',6.5),('7643','2013-05-27','08:20:00',7.07),('7643','2013-05-27','08:25:00',6.46),('7643','2013-05-27','08:30:00',6.97),('7643','2013-05-27','08:35:00',6.46),('7643','2013-05-27','08:40:00',5.73),('7643','2013-05-27','08:45:00',5.3),('7643','2013-05-27','08:50:00',6.04),('7643','2013-05-27','08:55:00',5.94),('7643','2013-05-27','09:00:00',6.57),('7643','2013-05-27','09:05:00',6.92),('7643','2013-05-27','09:10:00',6.35),('7643','2013-05-27','09:15:00',5.98),('7643','2013-05-27','09:20:00',7.07),('7643','2013-05-27','09:25:00',8.37),('7643','2013-05-27','09:30:00',8.96),('7643','2013-05-27','09:35:00',9.11),('7643','2013-05-27','09:40:00',8.74),('7643','2013-05-27','09:45:00',7.95),('7643','2013-05-27','09:50:00',8.1),('7643','2013-05-27','09:55:00',8.96),('7643','2013-05-27','10:00:00',8.24),('7643','2013-05-27','10:05:00',8.83),('7643','2013-05-27','10:10:00',9.79),('7643','2013-05-27','10:15:00',10.17),('7643','2013-05-27','10:20:00',10.76),('7643','2013-05-27','10:25:00',10.43),('7643','2013-05-27','10:30:00',11.75),('7643','2013-05-27','10:35:00',11.86),('7643','2013-05-27','10:40:00',10.47),('7643','2013-05-27','10:45:00',10.11),('7643','2013-05-27','10:50:00',11.02),('7643','2013-05-27','10:55:00',9.18),('7643','2013-05-27','11:00:00',9.24),('7643','2013-05-27','11:05:00',9.22),('7643','2013-05-27','11:10:00',10.11),('7643','2013-05-27','11:15:00',7.76),('7643','2013-05-27','11:20:00',8.93),('7643','2013-05-27','11:25:00',7.15),('7643','2013-05-27','11:30:00',14.44),('7643','2013-05-27','11:35:00',11.15),('7643','2013-05-27','11:40:00',15.57),('7643','2013-05-27','11:45:00',13.3),('7643','2013-05-27','11:50:00',4.42),('7643','2013-05-27','11:55:00',6.05),('7643','2013-05-27','12:00:00',5.89),('7643','2013-05-27','12:05:00',7.01),('7643','2013-05-27','12:10:00',12.06),('7643','2013-05-27','12:15:00',10.62),('7643','2013-05-27','12:20:00',8.99),('7643','2013-05-27','12:25:00',9.32),('7643','2013-05-27','12:30:00',10.43),('7643','2013-05-27','12:35:00',9.95),('7643','2013-05-27','12:40:00',10.15),('7643','2013-05-27','12:45:00',11.63),('7643','2013-05-27','12:50:00',10.28),('7643','2013-05-27','12:55:00',10.31),('7643','2013-05-27','13:00:00',10.67),('7643','2013-05-27','13:05:00',11.26),('7643','2013-05-27','13:10:00',11.67),('7643','2013-05-27','13:15:00',11.37),('7643','2013-05-27','13:20:00',12.77),('7643','2013-05-27','13:25:00',7.15),('7643','2013-05-27','13:30:00',8.27),('7643','2013-05-27','13:35:00',6.91),('7643','2013-05-27','13:40:00',7.54),('7643','2013-05-27','13:45:00',7.55),('7643','2013-05-27','13:50:00',11.82),('7643','2013-05-27','13:55:00',10.64),('7643','2013-05-27','14:00:00',10.01),('7643','2013-05-27','14:05:00',10.56),('7643','2013-05-27','14:10:00',15.28),('7643','2013-05-27','14:15:00',15.07),('7643','2013-05-27','14:20:00',10.04),('7643','2013-05-27','14:25:00',10.98),('7643','2013-05-27','14:30:00',13.12),('7643','2013-05-27','14:35:00',12.19),('7643','2013-05-27','14:40:00',13.2),('7643','2013-05-27','14:45:00',14.7),('7643','2013-05-27','14:50:00',10.52),('7643','2013-05-27','14:55:00',9.25),('7643','2013-05-27','15:00:00',9.09),('7643','2013-05-27','15:05:00',14.71),('7643','2013-05-27','15:10:00',6.3),('7643','2013-05-27','15:15:00',10.97),('7643','2013-05-27','15:20:00',12.44),('7643','2013-05-27','15:25:00',7.86),('7643','2013-05-27','15:30:00',5.74),('7643','2013-05-27','15:35:00',5.95),('7643','2013-05-27','15:40:00',11.05),('7643','2013-05-27','15:45:00',14.54),('7643','2013-05-27','15:50:00',11.96),('7643','2013-05-27','15:55:00',8.9),('7643','2013-05-27','16:00:00',6.45),('7643','2013-05-27','16:05:00',5.22),('7643','2013-05-27','16:10:00',5.51),('7643','2013-05-27','16:15:00',5.65),('7643','2013-05-27','16:20:00',8.66),('7643','2013-05-27','16:25:00',8.98),('7643','2013-05-27','16:30:00',10.04),('7643','2013-05-27','16:35:00',11.72),('7643','2013-05-27','16:40:00',10.91),('7643','2013-05-27','16:45:00',10.45),('7643','2013-05-27','16:50:00',10.16),('7643','2013-05-27','16:55:00',9.83),('7643','2013-05-27','17:00:00',9.73),('7643','2013-05-27','17:05:00',9.44),('7643','2013-05-27','17:10:00',9),('7643','2013-05-27','17:15:00',8.79),('7643','2013-05-27','17:20:00',8.4),('7643','2013-05-27','17:25:00',7.95),('7643','2013-05-27','17:30:00',7.65),('7643','2013-05-27','17:35:00',7.35),('7643','2013-05-27','17:40:00',5.53),('7643','2013-05-27','17:45:00',6.64),('7643','2013-05-27','17:50:00',6.35),('7643','2013-05-27','17:55:00',5.99),('7643','2013-05-27','18:00:00',6),('7643','2013-05-27','18:05:00',5.5),('7643','2013-05-27','18:10:00',5.24),('7643','2013-05-27','18:15:00',2.15),('7643','2013-05-27','18:20:00',1.37),('7643','2013-05-27','18:25:00',1.47),('7643','2013-05-27','18:30:00',2.28),('7643','2013-05-27','18:35:00',3.61),('7643','2013-05-27','18:40:00',3.25),('7643','2013-05-27','18:45:00',2.86),('7643','2013-05-27','18:50:00',2.5),('7643','2013-05-27','18:55:00',2.2),('7643','2013-05-27','19:00:00',2.02),('7643','2013-05-27','19:05:00',1.79),('7643','2013-05-27','19:10:00',1.55),('7643','2013-05-27','19:15:00',1.33),('7643','2013-05-27','19:20:00',1.16),('7643','2013-05-26','06:40:00',1.12),('7643','2013-05-26','06:45:00',1.48),('7643','2013-05-26','06:50:00',1.79),('7643','2013-05-26','06:55:00',1.78),('7643','2013-05-26','07:00:00',1.74),('7643','2013-05-26','07:05:00',2.5),('7643','2013-05-26','07:10:00',2.19),('7643','2013-05-26','07:15:00',1.69),('7643','2013-05-26','07:20:00',1.44),('7643','2013-05-26','07:25:00',3.89),('7643','2013-05-26','07:30:00',4.03),('7643','2013-05-26','07:35:00',4.57),('7643','2013-05-26','07:40:00',4.89),('7643','2013-05-26','07:45:00',4.74),('7643','2013-05-26','07:50:00',5.58),('7643','2013-05-26','07:55:00',3.95),('7643','2013-05-26','08:00:00',4.61),('7643','2013-05-26','08:05:00',6.79),('7643','2013-05-26','08:10:00',7.1),('7643','2013-05-26','08:15:00',5.25),('7643','2013-05-26','08:20:00',6.65),('7643','2013-05-26','08:25:00',6.65),('7643','2013-05-26','08:30:00',8.52),('7643','2013-05-26','08:35:00',8.78),('7643','2013-05-26','08:40:00',9.24),('7643','2013-05-26','08:45:00',9.98),('7643','2013-05-26','08:50:00',9.87),('7643','2013-05-26','08:55:00',9.36),('7643','2013-05-26','09:00:00',11.57),('7643','2013-05-26','09:05:00',11.46),('7643','2013-05-26','09:10:00',9.26),('7643','2013-05-26','09:15:00',9.69),('7643','2013-05-26','09:20:00',11.03),('7643','2013-05-26','09:25:00',5.45),('7643','2013-05-26','09:30:00',10.21),('7643','2013-05-26','09:35:00',13.09),('7643','2013-05-26','09:40:00',13.16),('7643','2013-05-26','09:45:00',13.4),('7643','2013-05-26','09:50:00',13.58),('7643','2013-05-26','09:55:00',12.48),('7643','2013-05-26','10:00:00',9.47),('7643','2013-05-26','10:05:00',14.87),('7643','2013-05-26','10:10:00',14.9),('7643','2013-05-26','10:15:00',15.23),('7643','2013-05-26','10:20:00',13.71),('7643','2013-05-26','10:25:00',6.69),('7643','2013-05-26','10:30:00',15.19),('7643','2013-05-26','10:35:00',7.38),('7643','2013-05-26','10:40:00',14.24),('7643','2013-05-26','10:45:00',11.61),('7643','2013-05-26','10:50:00',11.48),('7643','2013-05-26','10:55:00',6.15),('7643','2013-05-26','11:00:00',11.57),('7643','2013-05-26','11:05:00',17.2),('7643','2013-05-26','11:10:00',15.5),('7643','2013-05-26','11:15:00',11.38),('7643','2013-05-26','11:20:00',10.14),('7643','2013-05-26','11:25:00',19.74),('7643','2013-05-26','11:30:00',8.59),('7643','2013-05-26','11:35:00',10.05),('7643','2013-05-26','11:40:00',13.93),('7643','2013-05-26','11:45:00',14.12),('7643','2013-05-26','11:50:00',7.65),('7643','2013-05-26','11:55:00',9.63),('7643','2013-05-26','12:00:00',17.18),('7643','2013-05-26','12:05:00',9.69),('7643','2013-05-26','12:10:00',15.22),('7643','2013-05-26','12:15:00',17.56),('7643','2013-05-26','12:20:00',19.91),('7643','2013-05-26','12:25:00',18.46),('7643','2013-05-26','12:30:00',17.44),('7643','2013-05-26','12:35:00',14.58),('7643','2013-05-26','12:40:00',19.35),('7643','2013-05-26','12:45:00',15.61),('7643','2013-05-26','12:50:00',15.22),('7643','2013-05-26','12:55:00',18.13),('7643','2013-05-26','13:00:00',12.23),('7643','2013-05-26','13:05:00',5),('7643','2013-05-26','13:10:00',16.59),('7643','2013-05-26','13:15:00',9.38),('7643','2013-05-26','13:20:00',15.06),('7643','2013-05-26','13:25:00',18.65),('7643','2013-05-26','13:30:00',18.58),('7643','2013-05-26','13:35:00',16.44),('7643','2013-05-26','13:40:00',18.88),('7643','2013-05-26','13:45:00',18.39),('7643','2013-05-26','13:50:00',13.81),('7643','2013-05-26','13:55:00',15.6),('7643','2013-05-26','14:00:00',17.9),('7643','2013-05-26','14:05:00',17.85),('7643','2013-05-26','14:10:00',16.91),('7643','2013-05-26','14:15:00',15.47),('7643','2013-05-26','14:20:00',9.46),('7643','2013-05-26','14:25:00',17.48),('7643','2013-05-26','14:30:00',17.29),('7643','2013-05-26','14:35:00',17.11),('7643','2013-05-26','14:40:00',8.44),('7643','2013-05-26','14:45:00',18.9),('7643','2013-05-26','14:50:00',17.57),('7643','2013-05-26','14:55:00',14.72),('7643','2013-05-26','15:00:00',11.34),('7643','2013-05-26','15:05:00',10.02),('7643','2013-05-26','15:10:00',16.81),('7643','2013-05-26','15:15:00',11.57),('7643','2013-05-26','15:20:00',14.2),('7643','2013-05-26','15:25:00',13),('7643','2013-05-26','15:30:00',14.21),('7643','2013-05-26','15:35:00',16.19),('7643','2013-05-26','15:40:00',13.21),('7643','2013-05-26','15:45:00',11.88),('7643','2013-05-26','15:50:00',15.07),('7643','2013-05-26','15:55:00',9.78),('7643','2013-05-26','16:00:00',11.87),('7643','2013-05-26','16:05:00',8.49),('7643','2013-05-26','16:10:00',10.15),('7643','2013-05-26','16:15:00',8.92),('7643','2013-05-26','16:20:00',14.65),('7643','2013-05-26','16:25:00',14.04),('7643','2013-05-26','16:30:00',12.74),('7643','2013-05-26','16:35:00',11.22),('7643','2013-05-26','16:40:00',5.37),('7643','2013-05-26','16:45:00',4.66),('7643','2013-05-26','16:50:00',4.79),('7643','2013-05-26','16:55:00',5.15),('7643','2013-05-26','17:00:00',5.42),('7643','2013-05-26','17:05:00',5.54),('7643','2013-05-26','17:10:00',7.11),('7643','2013-05-26','17:15:00',5.61),('7643','2013-05-26','17:20:00',4.81),('7643','2013-05-26','17:25:00',4.38),('7643','2013-05-26','17:30:00',4.27),('7643','2013-05-26','17:35:00',3.98),('7643','2013-05-26','17:40:00',3.68),('7643','2013-05-26','17:45:00',3.45),('7643','2013-05-26','17:50:00',3.3),('7643','2013-05-26','17:55:00',3.36),('7643','2013-05-26','18:00:00',3.34),('7643','2013-05-26','18:05:00',3.01),('7643','2013-05-26','18:10:00',3.09),('7643','2013-05-26','18:15:00',3.46),('7643','2013-05-26','18:20:00',4.37),('7643','2013-05-26','18:25:00',6.43),('7643','2013-05-26','18:30:00',5.19),('7643','2013-05-26','18:35:00',3.68),('7643','2013-05-26','18:40:00',2.4),('7643','2013-05-26','18:45:00',3.16),('7643','2013-05-26','18:50:00',2.42),('7643','2013-05-26','18:55:00',3.14),('7643','2013-05-26','19:00:00',3.3),('7643','2013-05-26','19:05:00',3.11),('7643','2013-05-26','19:10:00',2.65),('7643','2013-05-26','19:15:00',2.01),('7643','2013-05-26','19:20:00',1.79),('7643','2013-05-26','19:25:00',1.77),('7643','2013-05-26','19:30:00',1.74),('7643','2013-05-26','19:35:00',1.63),('7643','2013-05-26','19:40:00',1.15),('7643','2013-05-25','06:50:00',1.05),('7643','2013-05-25','06:55:00',1.24),('7643','2013-05-25','07:20:00',3.4),('7643','2013-05-25','07:25:00',2.85),('7643','2013-05-25','07:35:00',4.22),('7643','2013-05-25','07:40:00',4.93),('7643','2013-05-25','07:45:00',5.65),('7643','2013-05-25','07:50:00',7.75),('7643','2013-05-25','07:55:00',3.09),('7643','2013-05-25','08:00:00',2.04),('7643','2013-05-25','08:05:00',7.2),('7643','2013-05-25','08:10:00',7.12),('7643','2013-05-25','08:15:00',2.44),('7643','2013-05-25','08:20:00',3.13),('7643','2013-05-25','08:25:00',3.68),('7643','2013-05-25','08:30:00',9.31),('7643','2013-05-25','08:35:00',6.68),('7643','2013-05-25','08:40:00',8),('7643','2013-05-25','08:45:00',11.06),('7643','2013-05-25','08:50:00',12.25),('7643','2013-05-25','08:55:00',3.71),('7643','2013-05-25','09:00:00',6.09),('7643','2013-05-25','09:05:00',2.98),('7643','2013-05-25','09:10:00',9.47),('7643','2013-05-25','09:15:00',5.13),('7643','2013-05-25','09:20:00',3.07),('7643','2013-05-25','09:25:00',5.46),('7643','2013-05-25','09:30:00',2.99),('7643','2013-05-25','09:35:00',3.81),('7643','2013-05-25','09:40:00',3.61),('7643','2013-05-25','09:45:00',8.91),('7643','2013-05-25','09:50:00',3.01),('7643','2013-05-25','09:55:00',3.77),('7643','2013-05-25','10:00:00',5.39),('7643','2013-05-25','10:05:00',11.04),('7643','2013-05-25','10:10:00',16.2),('7643','2013-05-25','10:15:00',10.28),('7643','2013-05-25','10:20:00',11.84),('7643','2013-05-25','10:25:00',11.31),('7643','2013-05-25','10:30:00',14.46),('7643','2013-05-25','10:35:00',15.9),('7643','2013-05-25','10:40:00',16.1),('7643','2013-05-25','10:45:00',16.28),('7643','2013-05-25','10:50:00',16.74),('7643','2013-05-25','10:55:00',15.01),('7643','2013-05-25','11:00:00',16.47),('7643','2013-05-25','11:05:00',17.05),('7643','2013-05-25','11:10:00',17.22),('7643','2013-05-25','11:15:00',17.23),('7643','2013-05-25','11:20:00',16.17),('7643','2013-05-25','11:25:00',17.64),('7643','2013-05-25','11:30:00',17.06),('7643','2013-05-25','11:35:00',17.76),('7643','2013-05-25','11:40:00',17.3),('7643','2013-05-25','11:45:00',16.55),('7643','2013-05-25','11:50:00',18.41),('7643','2013-05-25','11:55:00',18.07),('7643','2013-05-25','12:00:00',17.12),('7643','2013-05-25','12:05:00',17.96),('7643','2013-05-25','12:10:00',13.87),('7643','2013-05-25','12:15:00',13.69),('7643','2013-05-25','12:20:00',12.2),('7643','2013-05-25','12:25:00',17.82),('7643','2013-05-25','12:30:00',19.13),('7643','2013-05-25','12:35:00',18.99),('7643','2013-05-25','12:40:00',18.05),('7643','2013-05-25','12:45:00',19.19),('7643','2013-05-25','12:50:00',18.46),('7643','2013-05-25','12:55:00',18.26),('7643','2013-05-25','13:00:00',16.99),('7643','2013-05-25','13:05:00',16.94),('7643','2013-05-25','13:10:00',18.99),('7643','2013-05-25','13:15:00',19.21),('7643','2013-05-25','13:20:00',19.09),('7643','2013-05-25','13:25:00',18.77),('7643','2013-05-25','13:30:00',18.12),('7643','2013-05-25','13:35:00',18.98),('7643','2013-05-25','13:40:00',18.64),('7643','2013-05-25','13:45:00',18.61),('7643','2013-05-25','13:50:00',18.51),('7643','2013-05-25','13:55:00',18.27),('7643','2013-05-25','14:00:00',18.39),('7643','2013-05-25','14:05:00',17.82),('7643','2013-05-25','14:10:00',18),('7643','2013-05-25','14:15:00',18.06),('7643','2013-05-25','14:20:00',17.92),('7643','2013-05-25','14:25:00',17.74),('7643','2013-05-25','14:30:00',17.68),('7643','2013-05-25','14:35:00',17.59),('7643','2013-05-25','14:40:00',17.55),('7643','2013-05-25','14:45:00',17.33),('7643','2013-05-25','14:50:00',17.21),('7643','2013-05-25','14:55:00',16.96),('7643','2013-05-25','15:00:00',16.78),('7643','2013-05-25','15:05:00',16.69),('7643','2013-05-25','15:10:00',16.51),('7643','2013-05-25','15:15:00',16.41),('7643','2013-05-25','15:20:00',16.16),('7643','2013-05-25','15:25:00',15.96),('7643','2013-05-25','15:30:00',15.76),('7643','2013-05-25','15:35:00',15.56),('7643','2013-05-25','15:40:00',15.41),('7643','2013-05-25','15:45:00',15.12),('7643','2013-05-25','15:50:00',14.89),('7643','2013-05-25','15:55:00',14.62),('7643','2013-05-25','16:00:00',14.45),('7643','2013-05-25','16:05:00',14.15),('7643','2013-05-25','16:10:00',13.97),('7643','2013-05-25','16:15:00',13.69),('7643','2013-05-25','16:20:00',13.41),('7643','2013-05-25','16:25:00',13.17),('7643','2013-05-25','16:30:00',12.84),('7643','2013-05-25','16:35:00',12.43),('7643','2013-05-25','16:40:00',12.06),('7643','2013-05-25','16:45:00',11.91),('7643','2013-05-25','16:50:00',11.55),('7643','2013-05-25','16:55:00',11.22),('7643','2013-05-25','17:00:00',10.9),('7643','2013-05-25','17:05:00',10.64),('7643','2013-05-25','17:10:00',10.08),('7643','2013-05-25','17:15:00',9.68),('7643','2013-05-25','17:20:00',9.37),('7643','2013-05-25','17:25:00',8.99),('7643','2013-05-25','17:30:00',8.69),('7643','2013-05-25','17:35:00',8.25),('7643','2013-05-25','17:40:00',8.02),('7643','2013-05-25','17:45:00',7.67),('7643','2013-05-25','17:50:00',7.29),('7643','2013-05-25','17:55:00',6.89),('7643','2013-05-25','18:00:00',6.54),('7643','2013-05-25','18:05:00',6.18),('7643','2013-05-25','18:10:00',5.82),('7643','2013-05-25','18:15:00',5.48),('7643','2013-05-25','18:20:00',5.12),('7643','2013-05-25','18:25:00',4.74),('7643','2013-05-25','18:30:00',4.38),('7643','2013-05-25','18:35:00',3.98),('7643','2013-05-25','18:40:00',3.51),('7643','2013-05-25','18:45:00',3.05),('7643','2013-05-25','18:50:00',2.6),('7643','2013-05-25','18:55:00',2.22),('7643','2013-05-25','19:00:00',2.11),('7643','2013-05-25','19:05:00',1.86),('7643','2013-05-25','19:10:00',1.53),('7643','2013-05-25','19:15:00',1.26),('7643','2013-05-25','19:20:00',1.05),('7643','2013-05-24','18:40:00',1.82),('7643','2013-05-24','18:45:00',1.24),('7643','2013-05-24','19:00:00',1.01),('7643','2013-05-24','19:10:00',1.19),('7643','2013-05-23','09:25:00',6.48),('7643','2013-05-23','09:30:00',6.85),('7643','2013-05-23','09:35:00',3),('7643','2013-05-23','09:40:00',5.64),('7643','2013-05-23','09:45:00',4.76),('7643','2013-05-23','09:50:00',5.2),('7643','2013-05-23','09:55:00',10.71),('7643','2013-05-23','10:00:00',7.33),('7643','2013-05-23','10:05:00',3.07),('7643','2013-05-23','10:10:00',2.68),('7643','2013-05-23','10:15:00',1.91),('7643','2013-05-23','10:20:00',3.78),('7643','2013-05-23','10:25:00',9.37),('7643','2013-05-23','10:30:00',16.56),('7643','2013-05-23','10:35:00',15.24),('7643','2013-05-23','10:40:00',14.45),('7643','2013-05-23','10:45:00',14.91),('7643','2013-05-23','10:50:00',9.88),('7643','2013-05-23','10:55:00',15.08),('7643','2013-05-23','11:00:00',10.76),('7643','2013-05-23','11:05:00',12.87),('7643','2013-05-23','11:10:00',17.31),('7643','2013-05-23','11:15:00',15.1),('7643','2013-05-23','11:20:00',15.96),('7643','2013-05-23','11:25:00',15.22),('7643','2013-05-23','11:30:00',10.94),('7643','2013-05-23','11:35:00',4.75),('7643','2013-05-23','11:40:00',3.54),('7643','2013-05-23','11:45:00',8.94),('7643','2013-05-23','11:50:00',18.11),('7643','2013-05-23','11:55:00',15.37),('7643','2013-05-23','12:00:00',7.38),('7643','2013-05-23','12:05:00',11.05),('7643','2013-05-23','12:10:00',12.72),('7643','2013-05-23','12:15:00',8),('7643','2013-05-23','12:20:00',8.09),('7643','2013-05-23','12:25:00',15.82),('7643','2013-05-23','12:30:00',16.07),('7643','2013-05-23','12:35:00',8.15),('7643','2013-05-23','12:40:00',10.31),('7643','2013-05-23','12:45:00',13.97),('7643','2013-05-23','12:50:00',11.67),('7643','2013-05-23','12:55:00',8.98),('7643','2013-05-23','13:00:00',8.72),('7643','2013-05-23','13:05:00',7.91),('7643','2013-05-23','13:10:00',10.22),('7643','2013-05-23','13:15:00',11.1),('7643','2013-05-23','13:20:00',12.71),('7643','2013-05-23','13:25:00',10.44),('7643','2013-05-23','13:30:00',8.83),('7643','2013-05-23','13:35:00',14.05),('7643','2013-05-23','13:40:00',11.09),('7643','2013-05-23','13:45:00',5.26),('7643','2013-05-23','13:50:00',5),('7643','2013-05-23','13:55:00',14.3),('7643','2013-05-23','14:00:00',11.43),('7643','2013-05-23','14:05:00',8.41),('7643','2013-05-23','14:10:00',4.35),('7643','2013-05-23','14:15:00',13.36),('7643','2013-05-23','14:20:00',10.67),('7643','2013-05-23','14:25:00',14.7),('7643','2013-05-23','14:30:00',11.21),('7643','2013-05-23','14:35:00',11.16),('7643','2013-05-23','14:40:00',9.36),('7643','2013-05-23','14:45:00',8.49),('7643','2013-05-23','14:50:00',5.08),('7643','2013-05-23','14:55:00',6.34),('7643','2013-05-23','15:00:00',2.56),('7643','2013-05-21','06:45:00',1.24),('7643','2013-05-21','06:50:00',1.06),('7643','2013-05-21','06:55:00',1.18),('7643','2013-05-21','07:00:00',1.26),('7643','2013-05-21','07:05:00',1.37),('7643','2013-05-21','07:10:00',1.5),('7643','2013-05-21','07:15:00',1.56),('7643','2013-05-21','07:20:00',1.97),('7643','2013-05-21','07:25:00',2.34),('7643','2013-05-21','07:30:00',2.23),('7643','2013-05-21','07:35:00',2.13),('7643','2013-05-21','07:40:00',2.48),('7643','2013-05-21','07:45:00',2.75),('7643','2013-05-21','07:50:00',3.56),('7643','2013-05-21','07:55:00',4.02),('7643','2013-05-21','08:00:00',4.97),('7643','2013-05-21','08:05:00',5.72),('7643','2013-05-21','08:10:00',4.52),('7643','2013-05-21','08:15:00',7.83),('7643','2013-05-21','08:20:00',7.65),('7643','2013-05-21','08:25:00',7.32),('7643','2013-05-21','08:30:00',8.1),('7643','2013-05-21','08:35:00',9.69),('7643','2013-05-21','08:40:00',5.28),('7643','2013-05-21','08:45:00',7.05),('7643','2013-05-21','08:50:00',4.78),('7643','2013-05-21','08:55:00',1.43),('7643','2013-05-21','09:00:00',1.22),('7643','2013-05-21','09:05:00',1.66),('7643','2013-05-21','09:10:00',2.45),('7643','2013-05-21','09:15:00',3.28),('7643','2013-05-21','09:20:00',3.13),('7643','2013-05-21','09:25:00',4.05),('7643','2013-05-21','09:30:00',10.86),('7643','2013-05-21','09:35:00',11.49),('7643','2013-05-21','09:40:00',11.42),('7643','2013-05-21','09:45:00',11.55),('7643','2013-05-21','09:50:00',11.74),('7643','2013-05-21','09:55:00',11.94),('7643','2013-05-21','10:00:00',12.22),('7643','2013-05-21','10:05:00',12.46),('7643','2013-05-21','10:10:00',12.65),('7643','2013-05-21','10:15:00',12.86),('7643','2013-05-21','10:20:00',12.75),('7643','2013-05-21','10:25:00',13.68),('7643','2013-05-21','10:30:00',13.62),('7643','2013-05-21','10:35:00',13.8),('7643','2013-05-21','10:40:00',14.24),('7643','2013-05-21','10:45:00',14.25),('7643','2013-05-21','10:50:00',14.15),('7643','2013-05-21','10:55:00',14.33),('7643','2013-05-21','11:00:00',14.69),('7643','2013-05-21','11:05:00',15.21),('7643','2013-05-21','11:10:00',13.69),('7643','2013-05-21','11:15:00',14.57),('7643','2013-05-21','11:20:00',15.4),('7643','2013-05-21','11:25:00',15.45),('7643','2013-05-21','11:30:00',13.81),('7643','2013-05-21','11:35:00',12.23),('7643','2013-05-21','11:40:00',14.24),('7643','2013-05-21','11:45:00',15.5),('7643','2013-05-21','11:50:00',9.89),('7643','2013-05-21','11:55:00',8.71),('7643','2013-05-21','12:00:00',11.57),('7643','2013-05-21','12:05:00',8.85),('7643','2013-05-21','12:10:00',8.45),('7643','2013-05-21','12:15:00',12.46),('7643','2013-05-21','12:20:00',17.27),('7643','2013-05-21','12:25:00',11.53),('7643','2013-05-21','12:30:00',8.53),('7643','2013-05-21','12:35:00',9.35),('7643','2013-05-21','12:40:00',5.94),('7643','2013-05-21','12:45:00',2.49),('7643','2013-05-21','12:50:00',1.38),('7643','2013-05-21','12:55:00',1.94),('7643','2013-05-21','13:00:00',5.34),('7643','2013-05-21','13:05:00',17.22),('7643','2013-05-21','13:10:00',8.75),('7643','2013-05-21','13:15:00',9.05),('7643','2013-05-21','13:20:00',8.57),('7643','2013-05-21','13:25:00',4.44),('7643','2013-05-21','13:30:00',7.38),('7643','2013-05-21','13:35:00',12.78),('7643','2013-05-21','13:40:00',12.05),('7643','2013-05-21','13:45:00',10.02),('7643','2013-05-21','13:50:00',9.22),('7643','2013-05-21','13:55:00',9.38),('7643','2013-05-21','14:00:00',10.29),('7643','2013-05-21','14:05:00',14.51),('7643','2013-05-21','14:10:00',15.03),('7643','2013-05-21','14:15:00',16.52),('7643','2013-05-21','14:20:00',16.07),('7643','2013-05-21','14:25:00',15.86),('7643','2013-05-21','14:30:00',15.73),('7643','2013-05-21','14:35:00',15.59),('7643','2013-05-21','14:40:00',15.41),('7643','2013-05-21','14:45:00',15.26),('7643','2013-05-21','14:50:00',15.09),('7643','2013-05-21','14:55:00',15),('7643','2013-05-21','15:00:00',14.79),('7643','2013-05-21','15:05:00',14.62),('7643','2013-05-21','15:10:00',14.47),('7643','2013-05-21','15:15:00',14.23),('7643','2013-05-21','15:20:00',13.48),('7643','2013-05-21','15:25:00',8.89),('7643','2013-05-21','15:30:00',6.25),('7643','2014-03-31','12:35:00',13.63),('7643','2014-03-31','12:40:00',16.61),('7643','2014-03-31','12:45:00',16.74),('7643','2014-03-31','12:50:00',14.96),('7643','2014-03-31','12:55:00',17.03),('7643','2014-03-31','13:00:00',16.87),('7643','2014-03-31','13:05:00',17.05),('7643','2014-03-31','13:10:00',15.45),('7643','2014-03-31','13:15:00',16.38),('7643','2014-03-31','13:20:00',15.82),('7643','2014-03-31','13:25:00',16.8),('7643','2014-03-31','13:30:00',16.79),('7643','2014-03-31','13:35:00',16.93),('7643','2014-03-31','13:40:00',15.81),('7643','2014-03-31','13:45:00',17.09),('7643','2014-03-31','13:50:00',16.76),('7643','2014-03-31','13:55:00',16.7),('7643','2014-03-31','14:00:00',16.49),('7643','2014-03-31','14:05:00',16.46),('7643','2014-03-31','14:10:00',16.31),('7643','2014-03-31','14:15:00',9.67),('7643','2014-03-31','14:20:00',14.9),('7643','2014-03-31','14:25:00',15.83),('7643','2014-03-31','14:30:00',13.78),('7643','2014-03-31','14:35:00',16.55),('7643','2014-03-31','14:40:00',12.56),('7643','2014-03-31','14:45:00',16.8),('7643','2014-03-31','14:50:00',16.5),('7643','2014-03-31','14:55:00',10.71),('7643','2014-03-31','15:00:00',16.11),('7643','2014-03-31','15:05:00',11.59),('7643','2014-03-31','15:10:00',11.09),('7643','2014-03-31','15:15:00',12.08),('7643','2014-03-31','15:20:00',15.07),('7643','2014-03-31','15:25:00',11.78),('7643','2014-03-31','15:30:00',11.76),('7643','2014-03-31','15:35:00',12.4),('7643','2014-03-31','15:40:00',12.38),('7643','2014-03-31','15:45:00',10.16),('7643','2014-03-31','15:50:00',14.39),('7643','2014-03-31','15:55:00',12.77),('7643','2014-03-31','16:00:00',10.66),('7643','2014-03-31','16:05:00',12.96),('7643','2014-03-31','16:10:00',12.57),('7643','2014-03-31','16:15:00',11.39),('7643','2014-03-31','16:20:00',6.73),('7643','2014-03-31','16:25:00',10.42),('7643','2014-03-31','16:30:00',10.04),('7643','2014-03-31','16:35:00',11.07),('7643','2014-03-31','16:40:00',10.89),('7643','2014-03-31','16:45:00',7.76),('7643','2014-03-31','16:50:00',5.48),('7643','2014-03-31','16:55:00',9.28),('7643','2014-03-31','17:00:00',7.05),('7643','2014-03-31','17:05:00',8.62),('7643','2014-03-31','17:10:00',7.42),('7643','2014-03-31','17:15:00',7.83),('7643','2014-03-31','17:20:00',6.86),('7643','2014-03-31','17:25:00',7.02),('7643','2014-03-31','17:30:00',6.59),('7643','2014-03-31','17:35:00',6.11),('7643','2014-03-31','17:40:00',5.74),('7643','2014-03-31','17:45:00',5.37),('7643','2014-03-31','17:50:00',4.97),('7643','2014-03-31','17:55:00',4.42),('7643','2014-03-31','18:00:00',4.03),('7643','2014-03-31','18:05:00',3.7),('7643','2014-03-31','18:10:00',3.23),('7643','2014-03-31','18:15:00',2.85),('7643','2014-03-31','18:20:00',2.29),('7643','2014-03-31','18:25:00',2.09),('7643','2014-03-31','18:30:00',1.1),('7643','2013-05-20','06:40:00',1.06),('7643','2013-05-20','06:45:00',1.24),('7643','2013-05-20','06:50:00',1.42),('7643','2013-05-20','06:55:00',1.63),('7643','2013-05-20','07:00:00',1.85),('7643','2013-05-20','07:05:00',2.13),('7643','2013-05-20','07:10:00',2.41),('7643','2013-05-20','07:15:00',2.01),('7643','2013-05-20','07:20:00',2.99),('7643','2013-05-20','07:25:00',3.36),('7643','2013-05-20','07:30:00',3.92),('7643','2013-05-20','07:35:00',4.87),('7643','2013-05-20','07:40:00',5.58),('7643','2013-05-20','07:45:00',4.87),('7643','2013-05-20','07:50:00',3.88),('7643','2013-05-20','07:55:00',3.64),('7643','2013-05-20','08:00:00',4.61),('7643','2013-05-20','08:05:00',3.62),('7643','2013-05-20','08:10:00',4.89),('7643','2013-05-20','08:15:00',7.07),('7643','2013-05-20','08:20:00',5.89),('7643','2013-05-20','08:25:00',7.28),('7643','2013-05-20','08:30:00',5.23),('7643','2013-05-20','08:35:00',4.7),('7643','2013-05-20','08:40:00',5.61),('7643','2013-05-20','08:45:00',4.74),('7643','2013-05-20','08:50:00',5.12),('7643','2013-05-20','08:55:00',6.97),('7643','2013-05-20','09:00:00',5.99),('7643','2013-05-20','09:05:00',5.14),('7643','2013-05-20','09:10:00',5.62),('7643','2013-05-20','09:15:00',6.24),('7643','2013-05-20','09:20:00',8.73),('7643','2013-05-20','09:25:00',9.53),('7643','2013-05-20','09:30:00',7.49),('7643','2013-05-20','09:35:00',8.06),('7643','2013-05-20','09:40:00',7.56),('7643','2013-05-20','09:45:00',6.38),('7643','2013-05-20','09:50:00',6.05),('7643','2013-05-20','09:55:00',6.97),('7643','2013-05-20','10:00:00',7.51),('7643','2013-05-20','10:05:00',8.45),('7643','2013-05-20','10:10:00',9.06),('7643','2013-05-20','10:15:00',8.42),('7643','2013-05-20','10:20:00',8.03),('7643','2013-05-20','10:25:00',7.13),('7643','2013-05-20','10:30:00',6.69),('7643','2013-05-20','10:35:00',7.11),('7643','2013-05-20','10:40:00',8.16),('7643','2013-05-20','10:45:00',11.68),('7643','2013-05-20','10:50:00',7.86),('7643','2013-05-20','10:55:00',6.03),('7643','2013-05-20','11:00:00',7.51),('7643','2013-05-20','11:05:00',7.89),('7643','2013-05-20','11:10:00',11.91),('7643','2013-05-20','11:15:00',14.93),('7643','2013-05-20','11:20:00',11.56),('7643','2013-05-20','11:25:00',14.67),('7643','2013-05-20','11:30:00',10.27),('7643','2013-05-20','11:35:00',11.9),('7643','2013-05-20','11:40:00',11.45),('7643','2013-05-20','11:45:00',13),('7643','2013-05-20','11:50:00',9.3),('7643','2013-05-20','11:55:00',14.53),('7643','2013-05-20','12:00:00',13.56),('7643','2013-05-20','12:05:00',13.28),('7643','2013-05-20','12:10:00',10.76),('7643','2013-05-20','12:15:00',13.11),('7643','2013-05-20','12:20:00',8.94),('7643','2013-05-20','12:25:00',12.74),('7643','2013-05-20','12:30:00',14.71),('7643','2013-05-20','12:35:00',10.07),('7643','2013-05-20','12:40:00',15.21),('7643','2013-05-20','12:45:00',15.41),('7643','2013-05-20','12:50:00',9.23),('7643','2013-05-20','12:55:00',15.83),('7643','2013-05-20','13:00:00',15.31),('7643','2013-05-20','13:05:00',15.76),('7643','2013-05-20','13:10:00',10.37),('7643','2013-05-20','13:15:00',15.6),('7643','2013-05-20','13:20:00',12.86),('7643','2013-05-20','13:25:00',12.27),('7643','2013-05-20','13:30:00',11.87),('7643','2013-05-20','13:35:00',5.52),('7643','2013-05-20','13:40:00',3.29),('7643','2013-05-20','13:45:00',2.24),('7643','2013-05-20','13:50:00',1.5),('7643','2013-05-20','13:55:00',1.43),('7643','2013-05-20','14:00:00',2.42),('7643','2013-05-20','14:05:00',4.09),('7643','2013-05-20','14:10:00',6.43),('7643','2013-05-20','14:15:00',7.41),('7643','2013-05-20','14:20:00',6.67),('7643','2013-05-20','14:25:00',10.21),('7643','2013-05-20','14:30:00',8.4),('7643','2013-05-20','14:35:00',7.33),('7643','2013-05-20','14:40:00',7.19),('7643','2013-05-20','14:45:00',5.83),('7643','2013-05-20','14:50:00',3.81),('7643','2013-05-20','14:55:00',2.91),('7643','2013-05-20','15:00:00',1.72),('7643','2013-05-20','15:05:00',2.07),('7643','2013-05-20','15:10:00',2.38),('7643','2013-05-20','15:15:00',3.97),('7643','2013-05-20','15:20:00',5.53),('7643','2013-05-20','15:25:00',5.82),('7643','2013-05-20','15:30:00',8.05),('7643','2013-05-20','15:35:00',6.12),('7643','2013-05-20','15:40:00',4.82),('7643','2013-05-20','15:45:00',5.01),('7643','2013-05-20','15:50:00',4.54),('7643','2013-05-20','15:55:00',4.55),('7643','2013-05-20','16:00:00',4.56),('7643','2013-05-20','16:05:00',4.45),('7643','2013-05-20','16:10:00',4.79),('7643','2013-05-20','16:15:00',4.26),('7643','2013-05-20','16:20:00',3.5),('7643','2013-05-20','16:25:00',4.78),('7643','2013-05-20','16:30:00',6.19),('7643','2013-05-20','16:35:00',6.81),('7643','2013-05-20','16:40:00',7.65),('7643','2013-05-20','16:45:00',6.54),('7643','2013-05-20','16:50:00',4.1),('7643','2013-05-20','16:55:00',2.19),('7643','2013-05-20','17:00:00',2.51),('7643','2013-05-20','17:05:00',2.75),('7643','2013-05-20','17:10:00',2.28),('7643','2013-05-20','17:15:00',1.51),('7643','2013-05-19','06:45:00',1.04),('7643','2013-05-19','06:50:00',1.38),('7643','2013-05-19','06:55:00',1.76),('7643','2013-05-19','07:00:00',2.12),('7643','2013-05-19','07:05:00',2.3),('7643','2013-05-19','07:10:00',2.58),('7643','2013-05-19','07:15:00',2.83),('7643','2013-05-19','07:20:00',3.09),('7643','2013-05-19','07:25:00',3.07),('7643','2013-05-19','07:30:00',3.67),('7643','2013-05-19','07:35:00',4.12),('7643','2013-05-19','07:40:00',4.41),('7643','2013-05-19','07:45:00',4.74),('7643','2013-05-19','07:50:00',5.04),('7643','2013-05-19','07:55:00',5.39),('7643','2013-05-19','08:00:00',6.08),('7643','2013-05-19','08:05:00',4.53),('7643','2013-05-19','08:10:00',4.58),('7643','2013-05-19','08:15:00',4.7),('7643','2013-05-19','08:20:00',3.67),('7643','2013-05-19','08:25:00',4.26),('7643','2013-05-19','08:30:00',3.82),('7643','2013-05-19','08:35:00',2.47),('7643','2013-05-19','08:40:00',2.52),('7643','2013-05-19','08:45:00',6.32),('7643','2013-05-19','08:50:00',7.95),('7643','2013-05-19','08:55:00',11.32),('7643','2013-05-19','09:00:00',11.54),('7643','2013-05-19','09:05:00',12.15),('7643','2013-05-19','09:10:00',12.61),('7643','2013-05-19','09:15:00',8.87),('7643','2013-05-19','09:20:00',9.85),('7643','2013-05-19','09:25:00',4.29),('7643','2013-05-19','09:30:00',2.92),('7643','2013-05-19','09:35:00',8.12),('7643','2013-05-19','09:40:00',2.72),('7643','2013-05-19','09:45:00',2.28),('7643','2013-05-19','09:50:00',5.97),('7643','2013-05-19','09:55:00',2.86),('7643','2013-05-19','10:00:00',3.28),('7643','2013-05-19','10:05:00',5.23),('7643','2013-05-19','10:10:00',8.96),('7643','2013-05-19','10:15:00',3.67),('7643','2013-05-19','10:20:00',2.96),('7643','2013-05-19','10:25:00',4.17),('7643','2013-05-19','10:30:00',6.4),('7643','2013-05-19','10:35:00',6),('7643','2013-05-19','10:40:00',7.1),('7643','2013-05-19','10:45:00',4.33),('7643','2013-05-19','10:50:00',13.2),('7643','2013-05-19','10:55:00',12.26),('7643','2013-05-19','11:00:00',10.47),('7643','2013-05-19','11:05:00',13.6),('7643','2013-05-19','11:10:00',18.64),('7643','2013-05-19','11:15:00',18.1),('7643','2013-05-19','11:20:00',15.03),('7643','2013-05-19','11:25:00',12.13),('7643','2013-05-19','11:30:00',7.18),('7643','2013-05-19','11:35:00',12.85),('7643','2013-05-19','11:40:00',4.53),('7643','2013-05-19','11:45:00',6.48),('7643','2013-05-19','11:50:00',3.56),('7643','2013-05-19','11:55:00',13.09),('7643','2013-05-19','12:00:00',10.04),('7643','2013-05-19','12:05:00',10.3),('7643','2013-05-19','12:10:00',16.38),('7643','2013-05-19','12:15:00',6.42),('7643','2013-05-19','12:20:00',11.48),('7643','2013-05-19','12:25:00',12.33),('7643','2013-05-19','12:30:00',12.91),('7643','2013-05-19','12:35:00',5.78),('7643','2013-05-19','12:40:00',18.75),('7643','2013-05-19','12:45:00',18.99),('7643','2013-05-19','12:50:00',6.13),('7643','2013-05-19','12:55:00',7.49),('7643','2013-05-19','13:00:00',10.06),('7643','2013-05-19','13:05:00',12.84),('7643','2013-05-19','13:10:00',7.59),('7643','2013-05-19','13:15:00',4.86),('7643','2013-05-19','13:20:00',10.09),('7643','2013-05-19','13:25:00',13.33),('7643','2013-05-19','13:30:00',14.05),('7643','2013-05-19','13:35:00',12.37),('7643','2013-05-19','13:40:00',11.52),('7643','2013-05-19','13:45:00',7.92),('7643','2013-05-19','13:50:00',19.23),('7643','2013-05-19','13:55:00',16.09),('7643','2013-05-19','14:00:00',17.55),('7643','2013-05-19','14:05:00',7.11),('7643','2013-05-19','14:10:00',6.83),('7643','2013-05-19','14:15:00',19.16),('7643','2013-05-19','14:20:00',9.37),('7643','2013-05-19','14:25:00',9.24),('7643','2013-05-19','14:30:00',13.83),('7643','2013-05-19','14:35:00',5.56),('7643','2013-05-19','14:40:00',7.92),('7643','2013-05-19','14:45:00',7.69),('7643','2013-05-19','14:50:00',15.67),('7643','2013-05-19','14:55:00',8.05),('7643','2013-05-19','15:00:00',13.71),('7643','2013-05-19','15:05:00',6.48),('7643','2013-05-19','15:10:00',16.32),('7643','2013-05-19','15:15:00',10.14),('7643','2013-05-19','15:20:00',12.99),('7643','2013-05-19','15:25:00',10.37),('7643','2013-05-19','15:30:00',5.69),('7643','2013-05-19','15:35:00',16.31),('7643','2013-05-19','15:40:00',9.57),('7643','2013-05-19','15:45:00',5.2),('7643','2013-05-19','15:50:00',10.92),('7643','2013-05-19','15:55:00',6.34),('7643','2013-05-19','16:00:00',9.44),('7643','2013-05-19','16:05:00',9.76),('7643','2013-05-19','16:10:00',8.47),('7643','2013-05-19','16:15:00',10.21),('7643','2013-05-19','16:20:00',13.83),('7643','2013-05-19','16:25:00',13.31),('7643','2013-05-19','16:30:00',12.66),('7643','2013-05-19','16:35:00',11.96),('7643','2013-05-19','16:40:00',11.91),('7643','2013-05-19','16:45:00',11.02),('7643','2013-05-19','16:50:00',10.7),('7643','2013-05-19','16:55:00',10.29),('7643','2013-05-19','17:00:00',10.06),('7643','2013-05-19','17:05:00',10.2),('7643','2013-05-19','17:10:00',6.64),('7643','2013-05-19','17:15:00',5.11),('7643','2013-05-19','17:20:00',6.78),('7643','2013-05-19','17:25:00',8.75),('7643','2013-05-19','17:30:00',9.56),('7643','2013-05-19','17:35:00',7.82),('7643','2013-05-19','17:40:00',7.06),('7643','2013-05-19','17:45:00',6.69),('7643','2013-05-19','17:50:00',6.44),('7643','2013-05-19','17:55:00',6.13),('7643','2013-05-19','18:00:00',5.67),('7643','2013-05-19','18:05:00',6.24),('7643','2013-05-19','18:10:00',4.83),('7643','2013-05-19','18:15:00',5.55),('7643','2013-05-19','18:20:00',4.71),('7643','2013-05-19','18:25:00',4.15),('7643','2013-05-19','18:30:00',3.74),('7643','2013-05-19','18:35:00',3.39),('7643','2013-05-19','18:40:00',2.83),('7643','2013-05-19','18:45:00',2.63),('7643','2013-05-19','18:50:00',2.2),('7643','2013-05-19','18:55:00',1.94),('7643','2013-05-19','19:00:00',1.78),('7643','2013-05-19','19:05:00',1.59),('7643','2013-05-19','19:10:00',1.31),('7643','2013-05-19','19:15:00',1.1),('7643','2013-05-18','06:50:00',1.01),('7643','2013-05-18','06:55:00',1.23),('7643','2013-05-18','07:00:00',1.46),('7643','2013-05-18','07:05:00',1.54),('7643','2013-05-18','07:10:00',1.44),('7643','2013-05-18','07:15:00',1.37),('7643','2013-05-18','07:20:00',1.32),('7643','2013-05-18','07:25:00',1.17),('7643','2013-05-18','07:55:00',1.16),('7643','2013-05-18','08:05:00',1.8),('7643','2013-05-18','08:10:00',2.11),('7643','2013-05-18','08:15:00',2.59),('7643','2013-05-18','08:20:00',2.49),('7643','2013-05-18','08:25:00',2.24),('7643','2013-05-18','08:30:00',3.3),('7643','2013-05-18','08:40:00',3.28),('7643','2013-05-18','08:45:00',3.72),('7643','2013-05-18','08:50:00',4.34),('7643','2013-05-18','08:55:00',6.75),('7643','2013-05-18','09:00:00',5.45),('7643','2013-05-18','09:05:00',4.24),('7643','2013-05-18','09:10:00',4.71),('7643','2013-05-18','09:15:00',5.18),('7643','2013-05-18','09:20:00',4.06),('7643','2013-05-18','09:25:00',2.1),('7643','2013-05-18','09:30:00',2.38),('7643','2013-05-18','09:35:00',2.88),('7643','2013-05-18','09:40:00',3.76),('7643','2013-05-18','09:45:00',4.68),('7643','2013-05-18','09:50:00',3.31),('7643','2013-05-18','09:55:00',3.58),('7643','2013-05-18','10:00:00',5.84),('7643','2013-05-18','10:05:00',6.2),('7643','2013-05-18','10:10:00',7.96),('7643','2013-05-18','10:15:00',12.64),('7643','2013-05-18','10:20:00',9.19),('7643','2013-05-18','10:25:00',12),('7643','2013-05-18','10:30:00',12.79),('7643','2013-05-18','10:35:00',6.9),('7643','2013-05-18','10:40:00',11.74),('7643','2013-05-18','10:45:00',10.65),('7643','2013-05-18','10:50:00',6.53),('7643','2013-05-18','10:55:00',7.23),('7643','2013-05-18','11:00:00',7.82),('7643','2013-05-18','11:05:00',13.94),('7643','2013-05-18','11:10:00',9.77),('7643','2013-05-18','11:15:00',14.23),('7643','2013-05-18','11:20:00',17.07),('7643','2013-05-18','11:25:00',17.21),('7643','2013-05-18','11:30:00',17.13),('7643','2013-05-18','11:35:00',17.19),('7643','2013-05-18','11:40:00',17.75),('7643','2013-05-18','11:45:00',17.77),('7643','2013-05-18','11:50:00',17.62),('7643','2013-05-18','11:55:00',17.96),('7643','2013-05-18','12:00:00',17.95),('7643','2013-05-18','12:05:00',17.82),('7643','2013-05-18','12:10:00',17.9),('7643','2013-05-18','12:15:00',17.98),('7643','2013-05-18','12:20:00',18.81),('7643','2013-05-18','12:25:00',18.27),('7643','2013-05-18','12:30:00',15.51),('7643','2013-05-18','12:35:00',18.56),('7643','2013-05-18','12:40:00',18.67),('7643','2013-05-18','12:45:00',17.78),('7643','2013-05-18','12:50:00',12.91),('7643','2013-05-18','12:55:00',10.2),('7643','2013-05-18','13:00:00',14.58),('7643','2013-05-18','13:05:00',14.1),('7643','2013-05-18','13:10:00',14.16),('7643','2013-05-18','13:15:00',13.59),('7643','2013-05-18','13:20:00',17.05),('7643','2013-05-18','13:25:00',16.23),('7643','2013-05-18','13:30:00',17.92),('7643','2013-05-18','13:35:00',17.58),('7643','2013-05-18','13:40:00',17.56),('7643','2013-05-18','13:45:00',17.59),('7643','2013-05-18','13:50:00',17.52),('7643','2013-05-18','13:55:00',17.42),('7643','2013-05-18','14:00:00',17.38),('7643','2013-05-18','14:05:00',17.31),('7643','2013-05-18','14:10:00',17.29),('7643','2013-05-18','14:15:00',17.23),('7643','2013-05-18','14:20:00',17.12),('7643','2013-05-18','14:25:00',17.05),('7643','2013-05-18','14:30:00',16.84),('7643','2013-05-18','14:35:00',16.67),('7643','2013-05-18','14:40:00',16.51),('7643','2013-05-18','14:45:00',16.48),('7643','2013-05-18','14:50:00',16.39),('7643','2013-05-18','14:55:00',16.26),('7643','2013-05-18','15:00:00',16.14),('7643','2013-05-18','15:05:00',15.97),('7643','2013-05-18','15:10:00',15.73),('7643','2013-05-18','15:15:00',15.61),('7643','2013-05-18','15:20:00',15.36),('7643','2013-05-18','15:25:00',15.29),('7643','2013-05-18','15:30:00',15.12),('7643','2013-05-18','15:35:00',14.86),('7643','2013-05-18','15:40:00',14.49),('7643','2013-05-18','15:45:00',14.28),('7643','2013-05-18','15:50:00',14.26),('7643','2013-05-18','15:55:00',13.96),('7643','2013-05-18','16:00:00',13.71),('7643','2013-05-18','16:05:00',13.51),('7643','2013-05-18','16:10:00',13.26),('7643','2013-05-18','16:15:00',13.01),('7643','2013-05-18','16:20:00',12.65),('7643','2013-05-18','16:25:00',12.44),('7643','2013-05-18','16:30:00',12.09),('7643','2013-05-18','16:35:00',11.87),('7643','2013-05-18','16:40:00',11.56),('7643','2013-05-18','16:45:00',11.27),('7643','2013-05-18','16:50:00',10.97),('7643','2013-05-18','16:55:00',10.65),('7643','2013-05-18','17:00:00',10.43),('7643','2013-05-18','17:05:00',10.06),('7643','2013-05-18','17:10:00',9.7),('7643','2013-05-18','17:15:00',9.29),('7643','2013-05-18','17:20:00',9),('7643','2013-05-18','17:25:00',8.58),('7643','2013-05-18','17:30:00',8.16),('7643','2013-05-18','17:35:00',7.88),('7643','2013-05-18','17:40:00',7.4),('7643','2013-05-18','17:45:00',6.98),('7643','2013-05-18','17:50:00',6.84),('7643','2013-05-18','17:55:00',6.48),('7643','2013-05-18','18:00:00',6.1),('7643','2013-05-18','18:05:00',5.78),('7643','2013-05-18','18:10:00',5.4),('7643','2013-05-18','18:15:00',5.03),('7643','2013-05-18','18:20:00',4.68),('7643','2013-05-18','18:25:00',4.36),('7643','2013-05-18','18:30:00',3.98),('7643','2013-05-18','18:35:00',3.65),('7643','2013-05-18','18:40:00',3.22),('7643','2013-05-18','18:45:00',2.75),('7643','2013-05-18','18:50:00',2.47),('7643','2013-05-18','18:55:00',2.14),('7643','2013-05-18','19:00:00',1.79),('7643','2013-05-18','19:05:00',1.6),('7643','2013-05-18','19:10:00',1.27),('7643','2013-05-18','19:15:00',1.04),('7643','2013-05-17','06:45:00',1.08),('7643','2013-05-17','06:50:00',1.27),('7643','2013-05-17','06:55:00',1.48),('7643','2013-05-17','07:00:00',1.75),('7643','2013-05-17','07:05:00',2.02),('7643','2013-05-17','07:10:00',2.32),('7643','2013-05-17','07:15:00',2.64),('7643','2013-05-17','07:20:00',2.94),('7643','2013-05-17','07:25:00',3.27),('7643','2013-05-17','07:30:00',3.65),('7643','2013-05-17','07:35:00',4.03),('7643','2013-05-17','07:40:00',4.53),('7643','2013-05-17','07:45:00',4.73),('7643','2013-05-17','07:50:00',4.7),('7643','2013-05-17','07:55:00',7.06),('7643','2013-05-17','08:00:00',7.68),('7643','2013-05-17','08:05:00',7.27),('7643','2013-05-17','08:10:00',3.75),('7643','2013-05-17','08:15:00',3.63),('7643','2013-05-17','08:20:00',4.64),('7643','2013-05-17','08:25:00',9.63),('7643','2013-05-17','08:30:00',8.72),('7643','2013-05-17','08:35:00',6.92),('7643','2013-05-17','08:40:00',8.74),('7643','2013-05-17','08:45:00',8.78),('7643','2013-05-17','08:50:00',9.09),('7643','2013-05-17','08:55:00',9.4),('7643','2013-05-17','09:00:00',9.73),('7643','2013-05-17','09:05:00',9.92),('7643','2013-05-17','09:10:00',10.37),('7643','2013-05-17','09:15:00',10.65),('7643','2013-05-17','09:20:00',10.89),('7643','2013-05-17','09:25:00',11.08),('7643','2013-05-17','09:30:00',11.36),('7643','2013-05-17','09:35:00',11.6),('7643','2013-05-17','09:40:00',11.81),('7643','2013-05-17','09:45:00',12.03),('7643','2013-05-17','09:50:00',12.2),('7643','2013-05-17','09:55:00',12.49),('7643','2013-05-17','10:00:00',12.65),('7643','2013-05-17','10:05:00',12.82),('7643','2013-05-17','10:10:00',13.08),('7643','2013-05-17','10:15:00',13.35),('7643','2013-05-17','10:20:00',13.47),('7643','2013-05-17','10:25:00',13.6),('7643','2013-05-17','10:30:00',13.86),('7643','2013-05-17','10:35:00',13.88),('7643','2013-05-17','10:40:00',14.11),('7643','2013-05-17','10:45:00',14.38),('7643','2013-05-17','10:50:00',14.49),('7643','2013-05-17','10:55:00',14.85),('7643','2013-05-17','11:00:00',15.56),('7643','2013-05-17','11:05:00',15.25),('7643','2013-05-17','11:10:00',12.54),('7643','2013-05-17','11:15:00',15.84),('7643','2013-05-17','11:20:00',16.12),('7643','2013-05-17','11:25:00',15.22),('7643','2013-05-17','11:30:00',15.78),('7643','2013-05-17','11:35:00',15.17),('7643','2013-05-17','11:40:00',15.52),('7643','2013-05-17','11:45:00',15.48),('7643','2013-05-17','11:50:00',15.34),('7643','2013-05-17','11:55:00',15.81),('7643','2013-05-17','12:00:00',16.54),('7643','2013-05-17','12:05:00',15.65),('7643','2013-05-17','12:10:00',15.65),('7643','2013-05-17','12:15:00',15.74),('7643','2013-05-17','12:20:00',15.85),('7643','2013-05-17','12:25:00',15.94),('7643','2013-05-17','12:30:00',12.32),('7643','2013-05-17','12:35:00',16.28),('7643','2013-05-17','12:40:00',16.08),('7643','2013-05-17','12:45:00',15.31),('7643','2013-05-17','12:50:00',16.06),('7643','2013-05-17','12:55:00',15.96),('7643','2013-05-17','13:00:00',15.78),('7643','2013-05-17','13:05:00',15.77),('7643','2013-05-17','13:10:00',15.93),('7643','2013-05-17','13:15:00',15.94),('7643','2013-05-17','13:20:00',15.91),('7643','2013-05-17','13:25:00',16.03),('7643','2013-05-17','13:30:00',16.15),('7643','2013-05-17','13:35:00',15.07),('7643','2013-05-17','13:40:00',16.36),('7643','2013-05-17','13:45:00',17.01),('7643','2013-05-17','13:50:00',13.46),('7643','2013-05-17','13:55:00',12.99),('7643','2013-05-17','14:00:00',13.95),('7643','2013-05-17','14:05:00',13.26),('7643','2013-05-17','14:10:00',17.07),('7643','2013-05-17','14:15:00',16.46),('7643','2013-05-17','14:20:00',15.98),('7643','2013-05-17','14:25:00',15.63),('7643','2013-05-17','14:30:00',15.82),('7643','2013-05-17','14:35:00',14.4),('7643','2013-05-17','14:40:00',16.17),('7643','2013-05-17','14:45:00',15.42),('7643','2013-05-17','14:50:00',12.83),('7643','2013-05-17','14:55:00',13.36),('7643','2013-05-17','15:00:00',13.86),('7643','2013-05-17','15:05:00',13.92),('7643','2013-05-17','15:10:00',13.6),('7643','2013-05-17','15:15:00',13.32),('7643','2013-05-17','15:20:00',12.99),('7643','2013-05-17','15:25:00',12.78),('7643','2013-05-17','15:30:00',12.67),('7643','2013-05-17','15:35:00',12.53),('7643','2013-05-17','15:40:00',12.3),('7643','2013-05-17','15:45:00',11.99),('7643','2013-05-17','15:50:00',11.86),('7643','2013-05-17','15:55:00',11.61),('7643','2013-05-17','16:00:00',11.48),('7643','2013-05-17','16:05:00',11.31),('7643','2013-05-17','16:10:00',10.97),('7643','2013-05-17','16:15:00',10.69),('7643','2013-05-17','16:20:00',10.49),('7643','2013-05-17','16:25:00',10.26),('7643','2013-05-17','16:30:00',9.98),('7643','2013-05-17','16:35:00',9.73),('7643','2013-05-17','16:40:00',9.44),('7643','2013-05-17','16:45:00',9.19),('7643','2013-05-17','16:50:00',8.84),('7643','2013-05-17','16:55:00',8.61),('7643','2013-05-17','17:00:00',8.32),('7643','2013-05-17','17:05:00',8.01),('7643','2013-05-17','17:10:00',7.78),('7643','2013-05-17','17:15:00',7.48),('7643','2013-05-17','17:20:00',7.2),('7643','2013-05-17','17:25:00',6.89),('7643','2013-05-17','17:30:00',6.54),('7643','2013-05-17','17:35:00',6.2),('7643','2013-05-17','17:40:00',5.9),('7643','2013-05-17','17:45:00',5.65),('7643','2013-05-17','17:50:00',5.43),('7643','2013-05-17','17:55:00',5.17),('7643','2013-05-17','18:00:00',4.83),('7643','2013-05-17','18:05:00',4.51),('7643','2013-05-17','18:10:00',4.27),('7643','2013-05-17','18:15:00',3.97),('7643','2013-05-17','18:20:00',3.68),('7643','2013-05-17','18:25:00',3.39),('7643','2013-05-17','18:30:00',3.15),('7643','2013-05-17','18:35:00',2.9),('7643','2013-05-17','18:40:00',2.64),('7643','2013-05-17','18:45:00',2.38),('7643','2013-05-17','18:50:00',2.13),('7643','2013-05-17','18:55:00',1.91),('7643','2013-05-17','19:00:00',1.72),('7643','2013-05-17','19:05:00',1.55),('7643','2013-05-17','19:10:00',1.38),('7643','2013-05-17','19:15:00',1.21),('7643','2013-05-17','19:20:00',1.05),('7643','2013-05-16','07:00:00',1.07),('7643','2013-05-16','07:05:00',2.37),('7643','2013-05-16','07:10:00',2.7),('7643','2013-05-16','07:15:00',2.24),('7643','2013-05-16','07:20:00',3.03),('7643','2013-05-16','07:25:00',3.06),('7643','2013-05-16','07:30:00',2.38),('7643','2013-05-16','07:35:00',1.79),('7643','2013-05-16','07:40:00',4.08),('7643','2013-05-16','07:45:00',3.73),('7643','2013-05-16','07:50:00',3.42),('7643','2013-05-16','07:55:00',3.64),('7643','2013-05-16','08:00:00',4.86),('7643','2013-05-16','08:05:00',3.26),('7643','2013-05-16','08:10:00',3.04),('7643','2013-05-16','08:15:00',5.84),('7643','2013-05-16','08:20:00',7.9),('7643','2013-05-16','08:25:00',5.5),('7643','2013-05-16','08:30:00',3.6),('7643','2013-05-16','08:35:00',2.31),('7643','2013-05-16','08:40:00',1.27),('7643','2013-05-16','09:00:00',1.49),('7643','2013-05-16','09:05:00',2.32),('7643','2013-05-16','09:10:00',2.67),('7643','2013-05-16','09:15:00',2.32),('7643','2013-05-16','09:20:00',2.96),('7643','2013-05-16','09:25:00',4.32),('7643','2013-05-16','09:30:00',1.56),('7643','2013-05-16','09:35:00',1.31),('7643','2013-05-16','10:05:00',1.38),('7643','2013-05-16','10:10:00',1.71),('7643','2013-05-16','10:15:00',2.47),('7643','2013-05-16','10:20:00',3.23),('7643','2013-05-16','10:25:00',4.72),('7643','2013-05-16','10:30:00',5.94),('7643','2013-05-16','10:35:00',5),('7643','2013-05-16','10:40:00',5.64),('7643','2013-05-16','10:45:00',5.97),('7643','2013-05-16','10:50:00',10.06),('7643','2013-05-16','10:55:00',11.51),('7643','2013-05-16','11:00:00',8.49),('7643','2013-05-16','11:05:00',8.23),('7643','2013-05-16','11:10:00',5.46),('7643','2013-05-16','11:15:00',7.01),('7643','2013-05-16','11:20:00',7.65),('7643','2013-05-16','11:25:00',6.33),('7643','2013-05-16','11:30:00',8.72),('7643','2013-05-16','11:35:00',12.8),('7643','2013-05-16','11:40:00',6.5),('7643','2013-05-16','11:45:00',6.08),('7643','2013-05-16','11:50:00',7.54),('7643','2013-05-16','11:55:00',8.23),('7643','2013-05-16','12:00:00',6.63),('7643','2013-05-16','12:05:00',10.97),('7643','2013-05-16','12:10:00',12.06),('7643','2013-05-16','12:15:00',11.83),('7643','2013-05-16','12:20:00',9.34),('7643','2013-05-16','12:25:00',14.3),('7643','2013-05-16','12:30:00',10.32),('7643','2013-05-16','12:35:00',11.67),('7643','2013-05-16','12:40:00',18.51),('7643','2013-05-16','12:45:00',14.74),('7643','2013-05-16','12:50:00',18.14),('7643','2013-05-16','12:55:00',17.19),('7643','2013-05-16','13:00:00',14.53),('7643','2013-05-16','13:05:00',16.09),('7643','2013-05-16','13:10:00',12.84),('7643','2013-05-16','13:15:00',17.67),('7643','2013-05-16','13:20:00',17.48),('7643','2013-05-16','13:25:00',16.43),('7643','2013-05-16','13:30:00',11.5),('7643','2013-05-16','13:35:00',15.36),('7643','2013-05-16','13:40:00',15.36),('7643','2013-05-16','13:45:00',17.72),('7643','2013-05-16','13:50:00',17.12),('7643','2013-05-16','13:55:00',15.36),('7643','2013-05-16','14:00:00',15.92),('7643','2013-05-16','14:05:00',11.96),('7643','2013-05-16','14:10:00',14.35),('7643','2013-05-16','14:15:00',16.81),('7643','2013-05-16','14:20:00',17.72),('7643','2013-05-16','14:25:00',14.47),('7643','2013-05-16','14:30:00',14.66),('7643','2013-05-16','14:35:00',14.29),('7643','2013-05-16','14:40:00',10.58),('7643','2013-05-16','14:45:00',16.16),('7643','2013-05-16','14:50:00',10.43),('7643','2013-05-16','14:55:00',14.03),('7643','2013-05-16','15:00:00',11.45),('7643','2013-05-16','15:05:00',12.85),('7643','2013-05-16','15:10:00',7.91),('7643','2013-05-16','15:15:00',12.31),('7643','2013-05-16','15:20:00',9.55),('7643','2013-05-16','15:25:00',12.67),('7643','2013-05-16','15:30:00',10.77),('7643','2013-05-16','15:35:00',14.51),('7643','2013-05-16','15:40:00',15.52),('7643','2013-05-16','15:45:00',6.37),('7643','2013-05-16','15:50:00',9.09),('7643','2013-05-16','15:55:00',12.78),('7643','2013-05-16','16:00:00',6.68),('7643','2013-05-16','16:05:00',5.68),('7643','2013-05-16','16:10:00',8.15),('7643','2013-05-16','16:15:00',12.35),('7643','2013-05-16','16:20:00',12.67),('7643','2013-05-16','16:25:00',12.45),('7643','2013-05-16','16:30:00',11.38),('7643','2013-05-16','16:35:00',12.83),('7643','2013-05-16','16:40:00',13.22),('7643','2013-05-16','16:45:00',11.83),('7643','2013-05-16','16:50:00',10.86),('7643','2013-05-16','16:55:00',10.16),('7643','2013-05-16','17:00:00',9.89),('7643','2013-05-16','17:05:00',9.59),('7643','2013-05-16','17:10:00',9.31),('7643','2013-05-16','17:15:00',8.9),('7643','2013-05-16','17:20:00',8.55),('7643','2013-05-16','17:25:00',8.25),('7643','2013-05-16','17:30:00',7.82),('7643','2013-05-16','17:35:00',7.46),('7643','2013-05-16','17:40:00',7.23),('7643','2013-05-16','17:45:00',6.88),('7643','2013-05-16','17:50:00',6.55),('7643','2013-05-16','17:55:00',6.26),('7643','2013-05-16','18:00:00',5.95),('7643','2013-05-16','18:05:00',5.53),('7643','2013-05-16','18:10:00',5.16),('7643','2013-05-16','18:15:00',4.76),('7643','2013-05-16','18:20:00',4.46),('7643','2013-05-16','18:25:00',4.16),('7643','2013-05-16','18:30:00',3.79),('7643','2013-05-16','18:35:00',3.46),('7643','2013-05-16','18:40:00',3.03),('7643','2013-05-16','18:45:00',2.62),('7643','2013-05-16','18:50:00',2.3),('7643','2013-05-16','18:55:00',2.1),('7643','2013-05-16','19:00:00',1.17),('7643','2013-05-16','19:05:00',1.39),('7643','2013-05-15','09:10:00',1.69),('7643','2013-05-15','09:15:00',3.3),('7643','2013-05-15','09:20:00',4.19),('7643','2013-05-15','09:25:00',6.11),('7643','2013-05-15','09:30:00',5.98),('7643','2013-05-15','09:35:00',7.22),('7643','2013-05-15','09:40:00',8.24),('7643','2013-05-15','09:45:00',9.77),('7643','2013-05-15','09:50:00',4.67),('7643','2013-05-15','09:55:00',4.84),('7643','2013-05-15','10:00:00',5.95),('7643','2013-05-15','10:05:00',4.92),('7643','2013-05-15','10:10:00',4.57),('7643','2013-05-15','10:15:00',5.99),('7643','2013-05-15','10:20:00',8.16),('7643','2013-05-15','10:25:00',10.1),('7643','2013-05-15','10:30:00',7.58),('7643','2013-05-15','10:35:00',5.37),('7643','2013-05-15','10:40:00',5.28),('7643','2013-05-15','10:45:00',4.83),('7643','2013-05-15','10:50:00',5.76),('7643','2013-05-15','10:55:00',7.65),('7643','2013-05-15','11:00:00',15.76),('7643','2013-05-15','11:05:00',13),('7643','2013-05-15','11:10:00',11.12),('7643','2013-05-15','11:15:00',6.08),('7643','2013-05-15','11:20:00',3.98),('7643','2013-05-15','11:25:00',4.62),('7643','2013-05-15','11:30:00',5.61),('7643','2013-05-15','11:35:00',8.71),('7643','2013-05-15','11:40:00',15.34),('7643','2013-05-15','11:45:00',13.43),('7643','2013-05-15','11:50:00',11.46),('7643','2013-05-15','11:55:00',8.03),('7643','2013-05-15','12:00:00',6.58),('7643','2013-05-15','12:05:00',6.24),('7643','2013-05-15','12:10:00',6.6),('7643','2013-05-15','12:15:00',10.68),('7643','2013-05-15','12:20:00',7.28),('7643','2013-05-15','12:25:00',8.67),('7643','2013-05-15','12:30:00',12.12),('7643','2013-05-15','12:35:00',13.81),('7643','2013-05-15','12:40:00',12.08),('7643','2013-05-15','12:45:00',12.5),('7643','2013-05-15','12:50:00',10.55),('7643','2013-05-15','12:55:00',17.31),('7643','2013-05-15','13:00:00',15.09),('7643','2013-05-15','13:05:00',14.52),('7643','2013-05-15','13:10:00',15.83),('7643','2013-05-15','13:15:00',14.61),('7643','2013-05-15','13:20:00',16.27),('7643','2013-05-15','13:25:00',15.81),('7643','2013-05-15','13:30:00',15.54),('7643','2013-05-15','13:35:00',15.47),('7643','2013-05-15','13:40:00',15.27),('7643','2013-05-15','13:45:00',15.21),('7643','2013-05-15','13:50:00',15.09),('7643','2013-05-15','13:55:00',15.21),('7643','2013-05-15','14:00:00',15.11),('7643','2013-05-15','14:05:00',14.98),('7643','2013-05-15','14:10:00',14.78),('7643','2013-05-15','14:15:00',14.66),('7643','2013-05-15','14:20:00',14.72),('7643','2013-05-15','14:25:00',14.26),('7643','2013-05-15','14:30:00',14.2),('7643','2013-05-15','14:35:00',13.93),('7643','2013-05-15','14:40:00',13.89),('7643','2013-05-15','14:45:00',13.78),('7643','2013-05-15','14:50:00',13.14),('7643','2013-05-15','14:55:00',11.8),('7643','2013-05-15','15:00:00',13.29),('7643','2013-05-15','15:05:00',13.34),('7643','2013-05-15','15:10:00',13.38),('7643','2013-05-15','15:15:00',11.8),('7643','2013-05-15','15:20:00',12.68),('7643','2013-05-15','15:25:00',12.68),('7643','2013-05-15','15:30:00',12.31),('7643','2013-05-15','15:35:00',11.9),('7643','2013-05-15','15:40:00',12.19),('7643','2013-05-15','15:45:00',11.74),('7643','2013-05-15','15:50:00',11.66),('7643','2013-05-15','15:55:00',11.64),('7643','2013-05-15','16:00:00',11.48),('7643','2013-05-15','16:05:00',10.91),('7643','2013-05-15','16:10:00',10.92),('7643','2013-05-15','16:15:00',10.11),('7643','2013-05-15','16:20:00',10.67),('7643','2013-05-15','16:25:00',10.2),('7643','2013-05-15','16:30:00',10.12),('7643','2013-05-15','16:35:00',9.53),('7643','2013-05-15','16:40:00',5.91),('7643','2013-05-15','16:45:00',5.36),('7643','2013-05-15','16:50:00',7.88),('7643','2013-05-15','16:55:00',5.41),('7643','2013-05-15','17:00:00',5.28),('7643','2013-05-15','17:05:00',3.23),('7643','2013-05-15','17:10:00',3.05),('7643','2013-05-15','17:15:00',4.36),('7643','2013-05-15','17:20:00',5.25),('7643','2013-05-15','17:25:00',5.12),('7643','2013-05-15','17:30:00',6.67),('7643','2013-05-15','17:35:00',6.82),('7643','2013-05-15','17:40:00',5.31),('7643','2013-05-15','17:45:00',3.68),('7643','2013-05-15','17:50:00',2.29),('7643','2013-05-15','17:55:00',1.49),('7643','2013-05-15','18:00:00',1.35),('7643','2013-05-15','18:05:00',1.53),('7643','2013-05-15','18:10:00',1.58),('7643','2013-05-15','18:15:00',1.63),('7643','2013-05-15','18:20:00',1.84),('7643','2013-05-15','18:25:00',2.03),('7643','2013-05-15','18:30:00',2.35),('7643','2013-05-15','18:35:00',2.64),('7643','2013-05-15','18:40:00',2.65),('7643','2013-05-15','18:45:00',2.99),('7643','2013-05-15','18:50:00',3.25),('7643','2013-05-15','18:55:00',3.3),('7643','2013-05-15','19:00:00',3.5),('7643','2013-05-15','19:05:00',3.38),('7643','2013-05-15','19:10:00',2.79),('7643','2013-05-15','19:15:00',2.34),('7643','2013-05-15','19:20:00',2),('7643','2013-05-15','19:25:00',1.56),('7643','2013-05-15','19:30:00',1.18),('7643','2013-05-14','06:55:00',1.37),('7643','2013-05-14','07:00:00',1.52),('7643','2013-05-14','07:05:00',1.49),('7643','2013-05-14','07:10:00',2.22),('7643','2013-05-14','07:15:00',2.56),('7643','2013-05-14','07:20:00',2.89),('7643','2013-05-14','07:25:00',3.31),('7643','2013-05-14','07:30:00',3.75),('7643','2013-05-14','07:35:00',4.1),('7643','2013-05-14','07:40:00',4.47),('7643','2013-05-14','07:45:00',5.09),('7643','2013-05-14','07:50:00',5.28),('7643','2013-05-14','07:55:00',5.01),('7643','2013-05-14','08:00:00',5.33),('7643','2013-05-14','08:05:00',5.19),('7643','2013-05-14','08:10:00',6.08),('7643','2013-05-14','08:15:00',6.58),('7643','2013-05-14','08:20:00',6.68),('7643','2013-05-14','08:25:00',7),('7643','2013-05-14','08:30:00',7.25),('7643','2013-05-14','08:35:00',7.83),('7643','2013-05-14','08:40:00',8.27),('7643','2013-05-14','08:45:00',8.62),('7643','2013-05-14','08:50:00',8.95),('7643','2013-05-14','08:55:00',9.22),('7643','2013-05-14','09:00:00',8.9),('7643','2013-05-14','09:05:00',9.61),('7643','2013-05-14','09:10:00',9.57),('7643','2013-05-14','09:15:00',9.86),('7643','2013-05-14','09:20:00',9.86),('7643','2013-05-14','09:25:00',8.08),('7643','2013-05-14','09:30:00',10.92),('7643','2013-05-14','09:35:00',11.12),('7643','2013-05-14','09:40:00',11.12),('7643','2013-05-14','09:45:00',11.45),('7643','2013-05-14','09:50:00',11.77),('7643','2013-05-14','09:55:00',11.88),('7643','2013-05-14','10:00:00',12.23),('7643','2013-05-14','10:05:00',12.55),('7643','2013-05-14','10:10:00',12.85),('7643','2013-05-14','10:15:00',12.6),('7643','2013-05-14','10:20:00',13.23),('7643','2013-05-14','10:25:00',13.49),('7643','2013-05-14','10:30:00',12.98),('7643','2013-05-14','10:35:00',13.49),('7643','2013-05-14','10:40:00',14.02),('7643','2013-05-14','10:45:00',14.13),('7643','2013-05-14','10:50:00',14.11),('7643','2013-05-14','10:55:00',13.58),('7643','2013-05-14','11:00:00',13.89),('7643','2013-05-14','11:05:00',14.56),('7643','2013-05-14','11:10:00',14.68),('7643','2013-05-14','11:15:00',15.06),('7643','2013-05-14','11:20:00',14.22),('7643','2013-05-14','11:25:00',14.76),('7643','2013-05-14','11:30:00',15.7),('7643','2013-05-14','11:35:00',14.47),('7643','2013-05-14','11:40:00',12.16),('7643','2013-05-14','11:45:00',11.44),('7643','2013-05-14','11:50:00',10.23),('7643','2013-05-14','11:55:00',7.36),('7643','2013-05-14','12:00:00',7.77),('7643','2013-05-14','12:05:00',13.58),('7643','2013-05-14','12:10:00',17.68),('7643','2013-05-14','12:15:00',16.14),('7643','2013-05-14','12:20:00',10.57),('7643','2013-05-14','12:25:00',13.11),('7643','2013-05-14','12:30:00',10.88),('7643','2013-05-14','12:35:00',10.9),('7643','2013-05-14','12:40:00',17.74),('7643','2013-05-14','12:45:00',9.35),('7643','2013-05-14','12:50:00',9.31),('7643','2013-05-14','12:55:00',10.81),('7643','2013-05-14','13:00:00',10.78),('7643','2013-05-14','13:05:00',12.43),('7643','2013-05-14','13:10:00',11.37),('7643','2013-05-14','13:15:00',8.8),('7643','2013-05-14','13:20:00',10.56),('7643','2013-05-14','13:25:00',10.15),('7643','2013-05-14','13:30:00',11.17),('7643','2013-05-14','13:35:00',9.26),('7643','2013-05-14','13:40:00',9.97),('7643','2013-05-14','13:45:00',9.58),('7643','2013-05-14','13:50:00',8.08),('7643','2013-05-14','13:55:00',7.72),('7643','2013-05-14','14:00:00',6.65),('7643','2013-05-14','14:05:00',5.82),('7643','2013-05-14','14:10:00',6.06),('7643','2013-05-14','14:15:00',6.09),('7643','2013-05-14','14:20:00',6.28),('7643','2013-05-14','14:25:00',6.08),('7643','2013-05-14','14:30:00',5.39),('7643','2013-05-14','14:35:00',5.29),('7643','2013-05-14','14:40:00',5.72),('7643','2013-05-14','14:45:00',5.45),('7643','2013-05-14','14:50:00',5.49),('7643','2013-05-14','14:55:00',5.54),('7643','2013-05-14','15:00:00',5.38),('7643','2013-05-14','15:05:00',4.19),('7643','2013-05-14','15:10:00',3.26),('7643','2013-05-14','15:15:00',3.12),('7643','2013-05-14','15:20:00',2.95),('7643','2013-05-14','15:25:00',2.66),('7643','2013-05-14','15:30:00',2.84),('7643','2013-05-14','15:35:00',2.8),('7643','2013-05-14','15:40:00',3.04),('7643','2013-05-14','15:45:00',4),('7643','2013-05-14','15:50:00',5.52),('7643','2013-05-14','15:55:00',7.12),('7643','2013-05-14','16:00:00',7.06),('7643','2013-05-14','16:05:00',6.59),('7643','2013-05-14','16:10:00',5.89),('7643','2013-05-14','16:15:00',5.16),('7643','2013-05-14','16:20:00',5.69),('7643','2013-05-14','16:25:00',5.85),('7643','2013-05-14','16:30:00',5.32),('7643','2013-05-14','16:35:00',4.87),('7643','2013-05-14','16:40:00',4.49),('7643','2013-05-14','16:45:00',4.33),('7643','2013-05-14','16:50:00',4.36),('7643','2013-05-14','16:55:00',5.02),('7643','2013-05-14','17:00:00',5.95),('7643','2013-05-14','17:05:00',7.16),('7643','2013-05-14','17:10:00',6.8),('7643','2013-05-14','17:15:00',9.84),('7643','2013-05-14','17:20:00',6.85),('7643','2013-05-14','17:25:00',3.28),('7643','2013-05-14','17:30:00',3.43),('7643','2013-05-14','17:35:00',3.1),('7643','2013-05-14','17:40:00',2.84),('7643','2013-05-14','17:45:00',3),('7643','2013-05-14','17:50:00',3.1),('7643','2013-05-14','17:55:00',3.03),('7643','2013-05-14','18:00:00',2.76),('7643','2013-05-14','18:05:00',2.23),('7643','2013-05-14','18:10:00',1.63),('7643','2013-05-14','18:15:00',1.48),('7643','2013-05-14','18:20:00',1.63),('7643','2013-05-14','18:25:00',1.81),('7643','2013-05-14','18:30:00',1.62),('7643','2013-05-14','18:45:00',1.15),('7643','2013-05-14','18:50:00',1.07),('7643','2013-05-14','18:55:00',1),('7643','2013-05-14','19:10:00',1.22),('7643','2013-05-14','19:15:00',1.01),('7643','2013-05-13','06:50:00',1.13),('7643','2013-05-13','06:55:00',1.37),('7643','2013-05-13','07:00:00',1.65),('7643','2013-05-13','07:05:00',1.96),('7643','2013-05-13','07:10:00',2.29),('7643','2013-05-13','07:15:00',2.61),('7643','2013-05-13','07:20:00',2.92),('7643','2013-05-13','07:25:00',3.31),('7643','2013-05-13','07:30:00',3.66),('7643','2013-05-13','07:35:00',3.99),('7643','2013-05-13','07:40:00',4.34),('7643','2013-05-13','07:45:00',4.7),('7643','2013-05-13','07:50:00',5.12),('7643','2013-05-13','07:55:00',5.5),('7643','2013-05-13','08:00:00',5.89),('7643','2013-05-13','08:05:00',6.24),('7643','2013-05-13','08:10:00',6.61),('7643','2013-05-13','08:15:00',7.02),('7643','2013-05-13','08:20:00',7.25),('7643','2013-05-13','08:25:00',7.64),('7643','2013-05-13','08:30:00',8.08),('7643','2013-05-13','08:35:00',8.45),('7643','2013-05-13','08:40:00',8.79),('7643','2013-05-13','08:45:00',9.07),('7643','2013-05-13','08:50:00',9.37),('7643','2013-05-13','08:55:00',9.64),('7643','2013-05-13','09:00:00',9.93),('7643','2013-05-13','09:05:00',10.18),('7643','2013-05-13','09:10:00',10.49),('7643','2013-05-13','09:15:00',10.78),('7643','2013-05-13','09:20:00',11.08),('7643','2013-05-13','09:25:00',11.32),('7643','2013-05-13','09:30:00',11.56),('7643','2013-05-13','09:35:00',11.83),('7643','2013-05-13','09:40:00',12.07),('7643','2013-05-13','09:45:00',12.28),('7643','2013-05-13','09:50:00',12.52),('7643','2013-05-13','09:55:00',12.82),('7643','2013-05-13','10:00:00',13.06),('7643','2013-05-13','10:05:00',13.29),('7643','2013-05-13','10:10:00',13.51),('7643','2013-05-13','10:15:00',13.59),('7643','2013-05-13','10:20:00',13.9),('7643','2013-05-13','10:25:00',14.07),('7643','2013-05-13','10:30:00',14.17),('7643','2013-05-13','10:35:00',14.31),('7643','2013-05-13','10:40:00',14.45),('7643','2013-05-13','10:45:00',14.57),('7643','2013-05-13','10:50:00',14.75),('7643','2013-05-13','10:55:00',14.99),('7643','2013-05-13','11:00:00',15.12),('7643','2013-05-13','11:05:00',15.17),('7643','2013-05-13','11:10:00',15.38),('7643','2013-05-13','11:15:00',15.43),('7643','2013-05-13','11:20:00',15.45),('7643','2013-05-13','11:25:00',15.47),('7643','2013-05-13','11:30:00',15.63),('7643','2013-05-13','11:35:00',15.74),('7643','2013-05-13','11:40:00',15.74),('7643','2013-05-13','11:45:00',15.96),('7643','2013-05-13','11:50:00',16.14),('7643','2013-05-13','11:55:00',16.17),('7643','2013-05-13','12:00:00',16.15),('7643','2013-05-13','12:05:00',16.18),('7643','2013-05-13','12:10:00',16.22),('7643','2013-05-13','12:15:00',16.26),('7643','2013-05-13','12:20:00',16.44),('7643','2013-05-13','12:25:00',16.52),('7643','2013-05-13','12:30:00',16.71),('7643','2013-05-13','12:35:00',16.74),('7643','2013-05-13','12:40:00',16.66),('7643','2013-05-13','12:45:00',16.6),('7643','2013-05-13','12:50:00',16.72),('7643','2013-05-13','12:55:00',16.8),('7643','2013-05-13','13:00:00',16.72),('7643','2013-05-13','13:05:00',16.63),('7643','2013-05-13','13:10:00',16.73),('7643','2013-05-13','13:15:00',16.8),('7643','2013-05-13','13:20:00',16.65),('7643','2013-05-13','13:25:00',16.52),('7643','2013-05-13','13:30:00',16.37),('7643','2013-05-13','13:35:00',16.24),('7643','2013-05-13','13:40:00',16.2),('7643','2013-05-13','13:45:00',16.22),('7643','2013-05-13','13:50:00',16.12),('7643','2013-05-13','13:55:00',16.03),('7643','2013-05-13','14:00:00',16.01),('7643','2013-05-13','14:05:00',16.05),('7643','2013-05-13','14:10:00',15.95),('7643','2013-05-13','14:15:00',15.86),('7643','2013-05-13','14:20:00',15.63),('7643','2013-05-13','14:25:00',15.49),('7643','2013-05-13','14:30:00',15.4),('7643','2013-05-13','14:35:00',15.31),('7643','2013-05-13','14:40:00',15.33),('7643','2013-05-13','14:45:00',15.31),('7643','2013-05-13','14:50:00',15.32),('7643','2013-05-13','14:55:00',15.35),('7643','2013-05-13','15:00:00',15.36),('7643','2013-05-13','15:05:00',15.33),('7643','2013-05-13','15:10:00',15.15),('7643','2013-05-13','15:15:00',14.94),('7643','2013-05-13','15:20:00',14.75),('7643','2013-05-13','15:25:00',14.6),('7643','2013-05-13','15:30:00',14.46),('7643','2013-05-13','15:35:00',14.21),('7643','2013-05-13','15:40:00',14.05),('7643','2013-05-13','15:45:00',13.83),('7643','2013-05-13','15:50:00',13.58),('7643','2013-05-13','15:55:00',13.29),('7643','2013-05-13','16:00:00',13.05),('7643','2013-05-13','16:05:00',12.85),('7643','2013-05-13','16:10:00',12.63),('7643','2013-05-13','16:15:00',12.35),('7643','2013-05-13','16:20:00',12.09),('7643','2013-05-13','16:25:00',11.82),('7643','2013-05-13','16:30:00',11.56),('7643','2013-05-13','16:35:00',11.27),('7643','2013-05-13','16:40:00',10.98),('7643','2013-05-13','16:45:00',10.7),('7643','2013-05-13','16:50:00',10.43),('7643','2013-05-13','16:55:00',10.11),('7643','2013-05-13','17:00:00',9.73),('7643','2013-05-13','17:05:00',9.36),('7643','2013-05-13','17:10:00',9.03),('7643','2013-05-13','17:15:00',8.64),('7643','2013-05-13','17:20:00',8.3),('7643','2013-05-13','17:25:00',7.97),('7643','2013-05-13','17:30:00',7.6),('7643','2013-05-13','17:35:00',7.24),('7643','2013-05-13','17:40:00',6.87),('7643','2013-05-13','17:45:00',6.42),('7643','2013-05-13','17:50:00',6.2),('7643','2013-05-13','17:55:00',5.82),('7643','2013-05-13','18:00:00',5.52),('7643','2013-05-13','18:05:00',5.15),('7643','2013-05-13','18:10:00',4.7),('7643','2013-05-13','18:15:00',4.26),('7643','2013-05-13','18:20:00',4.08),('7643','2013-05-13','18:25:00',3.81),('7643','2013-05-13','18:30:00',3.5),('7643','2013-05-13','18:35:00',3.21),('7643','2013-05-13','18:40:00',2.83),('7643','2013-05-13','18:45:00',2.42),('7643','2013-05-13','18:50:00',2.12),('7643','2013-05-13','18:55:00',1.85),('7643','2013-05-13','19:00:00',1.46),('7643','2013-05-13','19:05:00',1.37),('7643','2013-05-13','19:10:00',1.1),('7643','2013-05-12','06:50:00',1.15),('7643','2013-05-12','06:55:00',1.4),('7643','2013-05-12','07:00:00',1.74),('7643','2013-05-12','07:05:00',1.94),('7643','2013-05-12','07:10:00',2.17),('7643','2013-05-12','07:15:00',2.5),('7643','2013-05-12','07:20:00',2.04),('7643','2013-05-12','07:25:00',2.24),('7643','2013-05-12','07:30:00',3.18),('7643','2013-05-12','07:35:00',3.47),('7643','2013-05-12','07:40:00',3.84),('7643','2013-05-12','07:45:00',4.24),('7643','2013-05-12','07:50:00',4.54),('7643','2013-05-12','07:55:00',3.91),('7643','2013-05-12','08:00:00',4.93),('7643','2013-05-12','08:05:00',5.56),('7643','2013-05-12','08:10:00',6),('7643','2013-05-12','08:15:00',6.37),('7643','2013-05-12','08:20:00',6.71),('7643','2013-05-12','08:25:00',6.85),('7643','2013-05-12','08:30:00',7.24),('7643','2013-05-12','08:35:00',7.55),('7643','2013-05-12','08:40:00',8.06),('7643','2013-05-12','08:45:00',8.31),('7643','2013-05-12','08:50:00',8.62),('7643','2013-05-12','08:55:00',8.91),('7643','2013-05-12','09:00:00',9.16),('7643','2013-05-12','09:05:00',9.49),('7643','2013-05-12','09:10:00',9.88),('7643','2013-05-12','09:15:00',10.15),('7643','2013-05-12','09:20:00',10.54),('7643','2013-05-12','09:25:00',10.76),('7643','2013-05-12','09:30:00',11.03),('7643','2013-05-12','09:35:00',11.28),('7643','2013-05-12','09:40:00',11.61),('7643','2013-05-12','09:45:00',11.83),('7643','2013-05-12','09:50:00',12.32),('7643','2013-05-12','09:55:00',12.86),('7643','2013-05-12','10:00:00',13.15),('7643','2013-05-12','10:05:00',13.2),('7643','2013-05-12','10:10:00',13.33),('7643','2013-05-12','10:15:00',14.07),('7643','2013-05-12','10:20:00',14.43),('7643','2013-05-12','10:25:00',7.9),('7643','2013-05-12','10:30:00',13.36),('7643','2013-05-12','10:35:00',10.5),('7643','2013-05-12','10:40:00',3.63),('7643','2013-05-12','10:45:00',9.75),('7643','2013-05-12','10:50:00',15.38),('7643','2013-05-12','10:55:00',7.48),('7643','2013-05-12','11:00:00',9.61),('7643','2013-05-12','11:05:00',9.08),('7643','2013-05-12','11:10:00',6.69),('7643','2013-05-12','11:15:00',9.6),('7643','2013-05-12','11:20:00',5.93),('7643','2013-05-12','11:25:00',7.63),('7643','2013-05-12','11:30:00',6.64),('7643','2013-05-12','11:35:00',11.02),('7643','2013-05-12','11:40:00',8.02),('7643','2013-05-12','11:45:00',10.91),('7643','2013-05-12','11:50:00',7.41),('7643','2013-05-12','11:55:00',6.42),('7643','2013-05-12','12:00:00',6.23),('7643','2013-05-12','12:05:00',6.04),('7643','2013-05-12','12:10:00',10.48),('7643','2013-05-12','12:15:00',11.15),('7643','2013-05-12','12:20:00',5.94),('7643','2013-05-12','12:25:00',5.37),('7643','2013-05-12','12:30:00',9.2),('7643','2013-05-12','12:35:00',16.25),('7643','2013-05-12','12:40:00',13.01),('7643','2013-05-12','12:45:00',10.24),('7643','2013-05-12','12:50:00',13.49),('7643','2013-05-12','12:55:00',13.71),('7643','2013-05-12','13:00:00',18.52),('7643','2013-05-12','13:05:00',12.73),('7643','2013-05-12','13:10:00',15.41),('7643','2013-05-12','13:15:00',17.58),('7643','2013-05-12','13:20:00',12.91),('7643','2013-05-12','13:25:00',18.05),('7643','2013-05-12','13:30:00',18.34),('7643','2013-05-12','13:35:00',14.65),('7643','2013-05-12','13:40:00',13.4),('7643','2013-05-12','13:45:00',5.64),('7643','2013-05-12','13:50:00',5.81),('7643','2013-05-12','13:55:00',4.27),('7643','2013-05-12','14:00:00',4.23),('7643','2013-05-12','14:05:00',4.96),('7643','2013-05-12','14:10:00',19.18),('7643','2013-05-12','14:15:00',18.11),('7643','2013-05-12','14:20:00',16.93),('7643','2013-05-12','14:25:00',13.35),('7643','2013-05-12','14:30:00',3.03),('7643','2013-05-12','14:35:00',11.99),('7643','2013-05-12','14:40:00',17.43),('7643','2013-05-12','14:45:00',15.56),('7643','2013-05-12','14:50:00',4.05),('7643','2013-05-12','14:55:00',10.64),('7643','2013-05-12','15:00:00',15.97),('7643','2013-05-12','15:05:00',13.35),('7643','2013-05-12','15:10:00',5.35),('7643','2013-05-12','15:15:00',3.41),('7643','2013-05-12','15:20:00',3.97),('7643','2013-05-12','15:25:00',3.31),('7643','2013-05-12','15:30:00',2.91),('7643','2013-05-12','15:35:00',2.48),('7643','2013-05-12','15:40:00',2.74),('7643','2013-05-12','15:45:00',2.71),('7643','2013-05-12','15:50:00',2.61),('7643','2013-05-12','15:55:00',2.46),('7643','2013-05-12','16:00:00',3.94),('7643','2013-05-12','16:05:00',4.33),('7643','2013-05-12','16:10:00',7.38),('7643','2013-05-12','16:15:00',4.98),('7643','2013-05-12','16:20:00',5.29),('7643','2013-05-12','16:25:00',5.16),('7643','2013-05-12','16:30:00',8.62),('7643','2013-05-12','16:35:00',4.71),('7643','2013-05-12','16:40:00',6.78),('7643','2013-05-12','16:45:00',8.41),('7643','2013-05-12','16:50:00',12.58),('7643','2013-05-12','16:55:00',11.86),('7643','2013-05-12','17:00:00',10.84),('7643','2013-05-12','17:05:00',10.06),('7643','2013-05-12','17:10:00',7.57),('7643','2013-05-12','17:15:00',10.79),('7643','2013-05-12','17:20:00',11.33),('7643','2013-05-12','17:25:00',10.21),('7643','2013-05-12','17:30:00',9.39),('7643','2013-05-12','17:35:00',8.7),('7643','2013-05-12','17:40:00',7.98),('7643','2013-05-12','17:45:00',7.72),('7643','2013-05-12','17:50:00',6.32),('7643','2013-05-12','17:55:00',3.51),('7643','2013-05-12','18:00:00',2.74),('7643','2013-05-12','18:05:00',2.42),('7643','2013-05-12','18:10:00',2.35),('7643','2013-05-12','18:15:00',3.13),('7643','2013-05-12','18:20:00',1.84),('7643','2013-05-12','18:25:00',1.5),('7643','2013-05-12','18:30:00',1.52),('7643','2013-05-12','18:35:00',1.29),('7643','2013-05-12','18:40:00',1.42),('7643','2013-05-12','18:45:00',1.25),('7643','2013-05-12','18:50:00',1.14),('7643','2013-05-12','18:55:00',1.22),('7643','2013-05-12','19:00:00',1.36),('7643','2013-05-11','07:10:00',1.26),('7643','2013-05-11','07:15:00',1.5),('7643','2013-05-11','07:20:00',1.68),('7643','2013-05-11','07:25:00',1.59),('7643','2013-05-11','07:30:00',1.54),('7643','2013-05-11','07:35:00',1.79),('7643','2013-05-11','07:40:00',1.76),('7643','2013-05-11','07:45:00',2),('7643','2013-05-11','07:50:00',2.12),('7643','2013-05-11','07:55:00',2.49),('7643','2013-05-11','08:00:00',2.9),('7643','2013-05-11','08:05:00',4.78),('7643','2013-05-11','08:10:00',6.73),('7643','2013-05-11','08:15:00',6.42),('7643','2013-05-11','08:20:00',4.87),('7643','2013-05-11','08:25:00',4.39),('7643','2013-05-11','08:30:00',3.52),('7643','2013-05-11','08:35:00',3.08),('7643','2013-05-11','08:40:00',3.26),('7643','2013-05-11','08:45:00',3.91),('7643','2013-05-11','08:50:00',5.4),('7643','2013-05-11','08:55:00',3.86),('7643','2013-05-11','09:00:00',4.86),('7643','2013-05-11','09:05:00',7.03),('7643','2013-05-11','09:10:00',4.44),('7643','2013-05-11','09:15:00',9.4),('7643','2013-05-11','09:20:00',8.84),('7643','2013-05-11','09:25:00',9.81),('7643','2013-05-11','09:30:00',11.98),('7643','2013-05-11','09:35:00',5.41),('7643','2013-05-11','09:40:00',6.03),('7643','2013-05-11','09:45:00',15.25),('7643','2013-05-11','09:50:00',14.17),('7643','2013-05-11','09:55:00',12.18),('7643','2013-05-11','10:00:00',10.05),('7643','2013-05-11','10:05:00',4.98),('7643','2013-05-11','10:10:00',9.82),('7643','2013-05-11','10:15:00',3.43),('7643','2013-05-11','10:20:00',3.36),('7643','2013-05-11','10:25:00',3.84),('7643','2013-05-11','10:30:00',5.58),('7643','2013-05-11','10:35:00',4.04),('7643','2013-05-11','10:40:00',3.36),('7643','2013-05-11','10:45:00',3.42),('7643','2013-05-11','10:50:00',7.27),('7643','2013-05-11','10:55:00',14.16),('7643','2013-05-11','11:00:00',3.53),('7643','2013-05-11','11:05:00',3.48),('7643','2013-05-11','11:10:00',7.03),('7643','2013-05-11','11:15:00',16.92),('7643','2013-05-11','11:20:00',5.75),('7643','2013-05-11','11:25:00',6.67),('7643','2013-05-11','11:30:00',17.43),('7643','2013-05-11','11:35:00',15.55),('7643','2013-05-11','11:40:00',12.7),('7643','2013-05-11','11:45:00',16.05),('7643','2013-05-11','11:50:00',17.05),('7643','2013-05-11','11:55:00',5.97),('7643','2013-05-11','12:00:00',13.24),('7643','2013-05-11','12:05:00',16.69),('7643','2013-05-11','12:10:00',17.73),('7643','2013-05-11','12:15:00',7.16),('7643','2013-05-11','12:20:00',4.18),('7643','2013-05-11','12:25:00',3.73),('7643','2013-05-11','12:30:00',3.67),('7643','2013-05-11','12:35:00',5.49),('7643','2013-05-11','12:40:00',8.64),('7643','2013-05-11','12:45:00',15.96),('7643','2013-05-11','12:50:00',16.96),('7643','2013-05-11','12:55:00',7.84),('7643','2013-05-11','13:00:00',5.24),('7643','2013-05-11','13:05:00',5.9),('7643','2013-05-11','13:10:00',9.77),('7643','2013-05-11','13:15:00',8.77),('7643','2013-05-11','13:20:00',6.7),('7643','2013-05-11','13:25:00',10.53),('7643','2013-05-11','13:30:00',18.56),('7643','2013-05-11','13:35:00',15.46),('7643','2013-05-11','13:40:00',14.66),('7643','2013-05-11','13:45:00',18.23),('7643','2013-05-11','13:50:00',11.62),('7643','2013-05-11','13:55:00',13.63),('7643','2013-05-11','14:00:00',9.84),('7643','2013-05-11','14:05:00',15.39),('7643','2013-05-11','14:10:00',12.73),('7643','2013-05-11','14:15:00',14.73),('7643','2013-05-11','14:20:00',18.24),('7643','2013-05-11','14:25:00',17.74),('7643','2013-05-11','14:30:00',17.29),('7643','2013-05-11','14:35:00',12.63),('7643','2013-05-11','14:40:00',15.17),('7643','2013-05-11','14:45:00',16.65),('7643','2013-05-11','14:50:00',15.96),('7643','2013-05-11','14:55:00',16.37),('7643','2013-05-11','15:00:00',16.35),('7643','2013-05-11','15:05:00',14.16),('7643','2013-05-11','15:10:00',15.65),('7643','2013-05-11','15:15:00',15.89),('7643','2013-05-11','15:20:00',11.24),('7643','2013-05-11','15:25:00',14.06),('7643','2013-05-11','15:30:00',12.12),('7643','2013-05-11','15:35:00',14.34),('7643','2013-05-11','15:40:00',14.04),('7643','2013-05-11','15:45:00',13.23),('7643','2013-05-11','15:50:00',13.45),('7643','2013-05-11','15:55:00',13.18),('7643','2013-05-11','16:00:00',12.86),('7643','2013-05-11','16:05:00',12.7),('7643','2013-05-11','16:10:00',12.42),('7643','2013-05-11','16:15:00',12.18),('7643','2013-05-11','16:20:00',11.91),('7643','2013-05-11','16:25:00',11.56),('7643','2013-05-11','16:30:00',11.44),('7643','2013-05-11','16:35:00',11.26),('7643','2013-05-11','16:40:00',11.36),('7643','2013-05-11','16:45:00',11.29),('7643','2013-05-11','16:50:00',11.71),('7643','2013-05-11','16:55:00',12.74),('7643','2013-05-11','17:00:00',12.66),('7643','2013-05-11','17:05:00',11.93),('7643','2013-05-11','17:10:00',11.95),('7643','2013-05-11','17:15:00',8.48),('7643','2013-05-11','17:20:00',10.51),('7643','2013-05-11','17:25:00',9.22),('7643','2013-05-11','17:30:00',7.23),('7643','2013-05-11','17:35:00',6.15),('7643','2013-05-11','17:40:00',7.97),('7643','2013-05-11','17:45:00',3.79),('7643','2013-05-11','17:50:00',4.29),('7643','2013-05-11','17:55:00',3.43),('7643','2013-05-11','18:00:00',4.28),('7643','2013-05-11','18:05:00',6.38),('7643','2013-05-11','18:10:00',5.73),('7643','2013-05-11','18:15:00',5.86),('7643','2013-05-11','18:20:00',3.88),('7643','2013-05-11','18:25:00',4.91),('7643','2013-05-11','18:30:00',3.68),('7643','2013-05-11','18:35:00',3.89),('7643','2013-05-11','18:40:00',3.71),('7643','2013-05-11','18:45:00',2.56),('7643','2013-05-11','18:50:00',2.28),('7643','2013-05-11','18:55:00',2.38),('7643','2013-05-11','19:00:00',2.59),('7643','2013-05-11','19:05:00',2.23),('7643','2013-05-11','19:10:00',1.98),('7643','2013-05-11','19:15:00',2.18),('7643','2013-05-11','19:20:00',2.1),('7643','2013-05-11','19:25:00',1.54),('7643','2013-05-11','19:30:00',1.43),('7643','2014-03-30','07:35:00',1.23),('7643','2014-03-30','07:40:00',1.5),('7643','2014-03-30','07:45:00',1.8),('7643','2014-03-30','07:50:00',2.1),('7643','2014-03-30','07:55:00',2.44),('7643','2014-03-30','08:00:00',2.81),('7643','2014-03-30','08:05:00',3.16),('7643','2014-03-30','08:10:00',3.55),('7643','2014-03-30','08:15:00',3.93),('7643','2014-03-30','08:20:00',4.33),('7643','2014-03-30','08:25:00',4.73),('7643','2014-03-30','08:30:00',5.11),('7643','2014-03-30','08:35:00',5.48),('7643','2014-03-30','08:40:00',5.86),('7643','2014-03-30','08:45:00',6.23),('7643','2014-03-30','08:50:00',6.57),('7643','2014-03-30','08:55:00',7.05),('7643','2014-03-30','09:00:00',7.45),('7643','2014-03-30','09:05:00',7.77),('7643','2014-03-30','09:10:00',8.13),('7643','2014-03-30','09:15:00',8.51),('7643','2014-03-30','09:20:00',8.83),('7643','2014-03-30','09:25:00',9.22),('7643','2014-03-30','09:30:00',9.51),('7643','2014-03-30','09:35:00',9.79),('7643','2014-03-30','09:40:00',10.05),('7643','2014-03-30','09:45:00',10.29),('7643','2014-03-30','09:50:00',10.57),('7643','2014-03-30','09:55:00',10.84),('7643','2014-03-30','10:00:00',11.05),('7643','2014-03-30','10:05:00',11.36),('7643','2014-03-30','10:10:00',11.65),('7643','2014-03-30','10:15:00',11.86),('7643','2014-03-30','10:20:00',12.03),('7643','2014-03-30','10:25:00',12.23),('7643','2014-03-30','10:30:00',12.32),('7643','2014-03-30','10:35:00',12.58),('7643','2014-03-30','10:40:00',12.82),('7643','2014-03-30','10:45:00',13.01),('7643','2014-03-30','10:50:00',13.3),('7643','2014-03-30','10:55:00',13.48),('7643','2014-03-30','11:00:00',13.66),('7643','2014-03-30','11:05:00',13.83),('7643','2014-03-30','11:10:00',13.91),('7643','2014-03-30','11:15:00',14.15),('7643','2014-03-30','11:20:00',14.28),('7643','2014-03-30','11:25:00',14.39),('7643','2014-03-30','11:30:00',14.46),('7643','2014-03-30','11:35:00',14.55),('7643','2014-03-30','11:40:00',14.7),('7643','2014-03-30','11:45:00',14.64),('7643','2014-03-30','11:50:00',14.83),('7643','2014-03-30','11:55:00',15.08),('7643','2014-03-30','12:00:00',15.27),('7643','2014-03-30','12:05:00',15.23),('7643','2014-03-30','12:10:00',15.28),('7643','2014-03-30','12:15:00',15.38),('7643','2014-03-30','12:20:00',15.56),('7643','2014-03-30','12:25:00',15.6),('7643','2014-03-30','12:30:00',15.63),('7643','2014-03-30','12:35:00',15.73),('7643','2014-03-30','12:40:00',15.8),('7643','2014-03-30','12:45:00',15.8),('7643','2014-03-30','12:50:00',15.75),('7643','2014-03-30','12:55:00',15.64),('7643','2014-03-30','13:00:00',15.72),('7643','2014-03-30','13:05:00',15.88),('7643','2014-03-30','13:10:00',15.87),('7643','2014-03-30','13:15:00',15.82),('7643','2014-03-30','13:20:00',15.82),('7643','2014-03-30','13:25:00',15.81),('7643','2014-03-30','13:30:00',15.91),('7643','2014-03-30','13:35:00',15.89),('7643','2014-03-30','13:40:00',15.79),('7643','2014-03-30','13:45:00',15.86),('7643','2014-03-30','13:50:00',15.76),('7643','2014-03-30','13:55:00',15.73),('7643','2014-03-30','14:00:00',15.58),('7643','2014-03-30','14:05:00',15.51),('7643','2014-03-30','14:10:00',15.47),('7643','2014-03-30','14:15:00',15.45),('7643','2014-03-30','14:20:00',15.37),('7643','2014-03-30','14:25:00',15.32),('7643','2014-03-30','14:30:00',15.25),('7643','2014-03-30','14:35:00',15.16),('7643','2014-03-30','14:40:00',15.09),('7643','2014-03-30','14:45:00',15.03),('7643','2014-03-30','14:50:00',14.91),('7643','2014-03-30','14:55:00',14.58),('7643','2014-03-30','15:00:00',14.55),('7643','2014-03-30','15:05:00',14.37),('7643','2014-03-30','15:10:00',14.29),('7643','2014-03-30','15:15:00',14.16),('7643','2014-03-30','15:20:00',13.89),('7643','2014-03-30','15:25:00',13.68),('7643','2014-03-30','15:30:00',13.44),('7643','2014-03-30','15:35:00',13.14),('7643','2014-03-30','15:40:00',12.95),('7643','2014-03-30','15:45:00',12.68),('7643','2014-03-30','15:50:00',12.42),('7643','2014-03-30','15:55:00',12.16),('7643','2014-03-30','16:00:00',11.94),('7643','2014-03-30','16:05:00',11.64),('7643','2014-03-30','16:10:00',11.32),('7643','2014-03-30','16:15:00',11.02),('7643','2014-03-30','16:20:00',10.77),('7643','2014-03-30','16:25:00',10.47),('7643','2014-03-30','16:30:00',10.19),('7643','2014-03-30','16:35:00',9.88),('7643','2014-03-30','16:40:00',9.54),('7643','2014-03-30','16:45:00',9.31),('7643','2014-03-30','16:50:00',8.96),('7643','2014-03-30','16:55:00',8.63),('7643','2014-03-30','17:00:00',8.24),('7643','2014-03-30','17:05:00',7.92),('7643','2014-03-30','17:10:00',7.63),('7643','2014-03-30','17:15:00',7.24),('7643','2014-03-30','17:20:00',6.85),('7643','2014-03-30','17:25:00',6.45),('7643','2014-03-30','17:30:00',6.09),('7643','2014-03-30','17:35:00',5.75),('7643','2014-03-30','17:40:00',5.36),('7643','2014-03-30','17:45:00',5.06),('7643','2014-03-30','17:50:00',4.66),('7643','2014-03-30','17:55:00',4.26),('7643','2014-03-30','18:00:00',3.88),('7643','2014-03-30','18:05:00',3.48),('7643','2014-03-30','18:10:00',3.07),('7643','2014-03-30','18:15:00',2.77),('7643','2014-03-30','18:20:00',2.42),('7643','2014-03-30','18:25:00',2.11),('7643','2014-03-30','18:30:00',1.78),('7643','2014-03-30','18:35:00',1.57),('7643','2014-03-30','18:40:00',1.44),('7643','2014-03-30','18:45:00',1.2),('7643','2013-05-10','07:10:00',1.61),('7643','2013-05-10','07:15:00',2.17),('7643','2013-05-10','07:20:00',2.61),('7643','2013-05-10','07:25:00',2.83),('7643','2013-05-10','07:30:00',3.09),('7643','2013-05-10','07:35:00',3.13),('7643','2013-05-10','07:40:00',3.29),('7643','2013-05-10','07:45:00',4.23),('7643','2013-05-10','07:50:00',4.88),('7643','2013-05-10','07:55:00',5.49),('7643','2013-05-10','08:00:00',5.5),('7643','2013-05-10','08:05:00',4.36),('7643','2013-05-10','08:10:00',2.73),('7643','2013-05-10','08:15:00',6.15),('7643','2013-05-10','08:20:00',5.1),('7643','2013-05-10','08:25:00',3.43),('7643','2013-05-10','08:30:00',3.4),('7643','2013-05-10','08:35:00',5.06),('7643','2013-05-10','08:40:00',2.57),('7643','2013-05-10','08:45:00',1.54),('7643','2013-05-10','08:50:00',1.93),('7643','2013-05-10','08:55:00',2.41),('7643','2013-05-10','09:00:00',2.54),('7643','2013-05-10','09:05:00',3.62),('7643','2013-05-10','09:10:00',3.51),('7643','2013-05-10','09:15:00',4.07),('7643','2013-05-10','09:20:00',6.95),('7643','2013-05-10','09:25:00',5.65),('7643','2013-05-10','09:30:00',9.2),('7643','2013-05-10','09:35:00',13.93),('7643','2013-05-10','09:40:00',8.68),('7643','2013-05-10','09:45:00',8.66),('7643','2013-05-10','09:50:00',4.92),('7643','2013-05-10','09:55:00',4.65),('7643','2013-05-10','10:00:00',5.56),('7643','2013-05-10','10:05:00',5.07),('7643','2013-05-10','10:10:00',3.79),('7643','2013-05-10','10:15:00',2.98),('7643','2013-05-10','10:20:00',3.8),('7643','2013-05-10','10:25:00',3.48),('7643','2013-05-10','10:30:00',4.42),('7643','2013-05-10','10:35:00',4.71),('7643','2013-05-10','10:40:00',3.66),('7643','2013-05-10','10:45:00',3.08),('7643','2013-05-10','10:50:00',4.2),('7643','2013-05-10','10:55:00',13.94),('7643','2013-05-10','11:00:00',8.07),('7643','2013-05-10','11:05:00',9.46),('7643','2013-05-10','11:10:00',4.56),('7643','2013-05-10','11:15:00',3.33),('7643','2013-05-10','11:20:00',2.84),('7643','2013-05-10','11:25:00',3.31),('7643','2013-05-10','11:30:00',5.17),('7643','2013-05-10','11:35:00',12.58),('7643','2013-05-10','11:40:00',7.97),('7643','2013-05-10','11:45:00',17.64),('7643','2013-05-10','11:50:00',9.87),('7643','2013-05-10','11:55:00',3.94),('7643','2013-05-10','12:00:00',4.9),('7643','2013-05-10','12:05:00',7.19),('7643','2013-05-10','12:10:00',5.42),('7643','2013-05-10','12:15:00',5.33),('7643','2013-05-10','12:20:00',7.31),('7643','2013-05-10','12:25:00',17.78),('7643','2013-05-10','12:30:00',12.65),('7643','2013-05-10','12:35:00',6.46),('7643','2013-05-10','12:40:00',7.81),('7643','2013-05-10','12:45:00',8.01),('7643','2013-05-10','12:50:00',8.46),('7643','2013-05-10','12:55:00',6.32),('7643','2013-05-10','13:00:00',6.06),('7643','2013-05-10','13:05:00',8.37),('7643','2013-05-10','13:10:00',4.58),('7643','2013-05-10','13:15:00',2.8),('7643','2013-05-10','13:20:00',3.38),('7643','2013-05-10','13:25:00',4.27),('7643','2013-05-10','13:30:00',4.26),('7643','2013-05-10','13:35:00',3.77),('7643','2013-05-10','13:40:00',2.96),('7643','2013-05-10','13:45:00',1.9),('7643','2013-05-10','13:50:00',2.45),('7643','2013-05-10','13:55:00',2.87),('7643','2013-05-10','14:00:00',6.51),('7643','2013-05-10','14:05:00',10.56),('7643','2013-05-10','14:10:00',12.03),('7643','2013-05-10','14:15:00',13.6),('7643','2013-05-10','14:20:00',18.32),('7643','2013-05-10','14:25:00',16.3),('7643','2013-05-10','14:30:00',12.11),('7643','2013-05-10','14:35:00',13.75),('7643','2013-05-10','14:40:00',17.45),('7643','2013-05-10','14:45:00',15.52),('7643','2013-05-10','14:50:00',17.12),('7643','2013-05-10','14:55:00',16.55),('7643','2013-05-10','15:00:00',16.02),('7643','2013-05-10','15:05:00',15.59),('7643','2013-05-10','15:10:00',14.38),('7643','2013-05-10','15:15:00',15.43),('7643','2013-05-10','15:20:00',12.79),('7643','2013-05-10','15:25:00',15.07),('7643','2013-05-10','15:30:00',14.41),('7643','2013-05-10','15:35:00',14.64),('7643','2013-05-10','15:40:00',13.48),('7643','2013-05-10','15:45:00',13.77),('7643','2013-05-10','15:50:00',14.71),('7643','2013-05-10','15:55:00',13.32),('7643','2013-05-10','16:00:00',9.96),('7643','2013-05-10','16:05:00',12.06),('7643','2013-05-10','16:10:00',9.83),('7643','2013-05-10','16:15:00',12.33),('7643','2013-05-10','16:20:00',10.63),('7643','2013-05-10','16:25:00',12.5),('7643','2013-05-10','16:30:00',12.1),('7643','2013-05-10','16:35:00',11.8),('7643','2013-05-10','16:40:00',11.05),('7643','2013-05-10','16:45:00',10.94),('7643','2013-05-10','16:50:00',10.13),('7643','2013-05-10','16:55:00',9.05),('7643','2013-05-10','17:00:00',9.19),('7643','2013-05-10','17:05:00',9.64),('7643','2013-05-10','17:10:00',8.27),('7643','2013-05-10','17:15:00',6.32),('7643','2013-05-10','17:20:00',8.95),('7643','2013-05-10','17:25:00',5.22),('7643','2013-05-10','17:30:00',7.01),('7643','2013-05-10','17:35:00',5.4),('7643','2013-05-10','17:40:00',7.26),('7643','2013-05-10','17:45:00',7.36),('7643','2013-05-10','17:50:00',5.04),('7643','2013-05-10','17:55:00',5.85),('7643','2013-05-10','18:00:00',2.95),('7643','2013-05-10','18:05:00',4.66),('7643','2013-05-10','18:10:00',6.56),('7643','2013-05-10','18:15:00',4.72),('7643','2013-05-10','18:20:00',2.9),('7643','2013-05-10','18:25:00',4.47),('7643','2013-05-10','18:30:00',3.91),('7643','2013-05-10','18:35:00',2.82),('7643','2013-05-10','18:40:00',2.47),('7643','2013-05-10','18:45:00',2.62),('7643','2013-05-10','18:50:00',1.9),('7643','2013-05-10','18:55:00',2.45),('7643','2013-05-10','19:00:00',1.85),('7643','2013-05-10','19:05:00',1.01),('7643','2013-05-10','19:10:00',1.04),('7643','2013-05-09','06:45:00',1.02),('7643','2013-05-09','06:50:00',1.08),('7643','2013-05-09','06:55:00',1.48),('7643','2013-05-09','07:00:00',2.01),('7643','2013-05-09','07:05:00',2.09),('7643','2013-05-09','07:10:00',2.31),('7643','2013-05-09','07:15:00',2.61),('7643','2013-05-09','07:20:00',2.08),('7643','2013-05-09','07:25:00',2.06),('7643','2013-05-09','07:30:00',3.34),('7643','2013-05-09','07:35:00',2.92),('7643','2013-05-09','07:40:00',3.52),('7643','2013-05-09','07:45:00',3.44),('7643','2013-05-09','07:50:00',2.89),('7643','2013-05-09','07:55:00',3.45),('7643','2013-05-09','08:00:00',6.12),('7643','2013-05-09','08:05:00',6.97),('7643','2013-05-09','08:10:00',7),('7643','2013-05-09','08:15:00',8.32),('7643','2013-05-09','08:20:00',7.67),('7643','2013-05-09','08:25:00',7.58),('7643','2013-05-09','08:30:00',7.03),('7643','2013-05-09','08:35:00',7.92),('7643','2013-05-09','08:40:00',4.12),('7643','2013-05-09','08:45:00',2.39),('7643','2013-05-09','08:50:00',2.37),('7643','2013-05-09','08:55:00',2.24),('7643','2013-05-09','09:00:00',5.1),('7643','2013-05-09','09:05:00',8.34),('7643','2013-05-09','09:10:00',10.21),('7643','2013-05-09','09:15:00',10.58),('7643','2013-05-09','09:20:00',10.18),('7643','2013-05-09','09:25:00',9.81),('7643','2013-05-09','09:30:00',9.06),('7643','2013-05-09','09:35:00',11.03),('7643','2013-05-09','09:40:00',10.67),('7643','2013-05-09','09:45:00',11.2),('7643','2013-05-09','09:50:00',11.7),('7643','2013-05-09','09:55:00',10.49),('7643','2013-05-09','10:00:00',9.41),('7643','2013-05-09','10:05:00',13.88),('7643','2013-05-09','10:10:00',8.23),('7643','2013-05-09','10:15:00',9.3),('7643','2013-05-09','10:20:00',8.54),('7643','2013-05-09','10:25:00',4.47),('7643','2013-05-09','10:30:00',4.37),('7643','2013-05-09','10:35:00',8.19),('7643','2013-05-09','10:40:00',14.92),('7643','2013-05-09','10:45:00',15.19),('7643','2013-05-09','10:50:00',15.4),('7643','2013-05-09','10:55:00',14.41),('7643','2013-05-09','11:00:00',15.29),('7643','2013-05-09','11:05:00',15.17),('7643','2013-05-09','11:10:00',15.2),('7643','2013-05-09','11:15:00',14.59),('7643','2013-05-09','11:20:00',16.61),('7643','2013-05-09','11:25:00',14.52),('7643','2013-05-09','11:30:00',13.52),('7643','2013-05-09','11:35:00',14.89),('7643','2013-05-09','11:40:00',9.86),('7643','2013-05-09','11:45:00',9.33),('7643','2013-05-09','11:50:00',11.86),('7643','2013-05-09','11:55:00',14.67),('7643','2013-05-09','12:00:00',16.07),('7643','2013-05-09','12:05:00',12.93),('7643','2013-05-09','12:10:00',11.15),('7643','2013-05-09','12:15:00',10.45),('7643','2013-05-09','12:20:00',11.54),('7643','2013-05-09','12:25:00',9.41),('7643','2013-05-09','12:30:00',7.97),('7643','2013-05-09','12:35:00',8.95),('7643','2013-05-09','12:40:00',13.49),('7643','2013-05-09','12:45:00',16.66),('7643','2013-05-09','12:50:00',13.26),('7643','2013-05-09','12:55:00',12.36),('7643','2013-05-09','13:00:00',16.55),('7643','2013-05-09','13:05:00',13.92),('7643','2013-05-09','13:10:00',16.34),('7643','2013-05-09','13:15:00',17.64),('7643','2013-05-09','13:20:00',12.57),('7643','2013-05-09','13:25:00',10.74),('7643','2013-05-09','13:30:00',12.27),('7643','2013-05-09','13:35:00',16.82),('7643','2013-05-09','13:40:00',14.96),('7643','2013-05-09','13:45:00',14.27),('7643','2013-05-09','13:50:00',9.33),('7643','2013-05-09','13:55:00',8.05),('7643','2013-05-09','14:00:00',7.3),('7643','2013-05-09','14:05:00',7.48),('7643','2013-05-09','14:10:00',8.84),('7643','2013-05-09','14:15:00',10.3),('7643','2013-05-09','14:20:00',9.82),('7643','2013-05-09','14:25:00',9.7),('7643','2013-05-09','14:30:00',9.96),('7643','2013-05-09','14:35:00',11.41),('7643','2013-05-09','14:40:00',10.63),('7643','2013-05-09','14:45:00',8.07),('7643','2013-05-09','14:50:00',5.65),('7643','2013-05-09','14:55:00',4.75),('7643','2013-05-09','15:00:00',4.47),('7643','2013-05-09','15:05:00',4.73),('7643','2013-05-09','15:10:00',6.26),('7643','2013-05-09','15:15:00',10.48),('7643','2013-05-09','15:20:00',11.33),('7643','2013-05-09','15:25:00',7.64),('7643','2013-05-09','15:30:00',6.98),('7643','2013-05-09','15:35:00',7.31),('7643','2013-05-09','15:40:00',7.69),('7643','2013-05-09','15:45:00',7.41),('7643','2013-05-09','15:50:00',6.68),('7643','2013-05-09','15:55:00',6.32),('7643','2013-05-09','16:00:00',6.06),('7643','2013-05-09','16:05:00',5.88),('7643','2013-05-09','16:10:00',5.73),('7643','2013-05-09','16:15:00',5.38),('7643','2013-05-09','16:20:00',4.82),('7643','2013-05-09','16:25:00',4.74),('7643','2013-05-09','16:30:00',4.99),('7643','2013-05-09','16:35:00',5.31),('7643','2013-05-09','16:40:00',5.08),('7643','2013-05-09','16:45:00',5.01),('7643','2013-05-09','16:50:00',5.07),('7643','2013-05-09','16:55:00',4.32),('7643','2013-05-09','17:00:00',3.41),('7643','2013-05-09','17:05:00',3.27),('7643','2013-05-09','17:10:00',4.17),('7643','2013-05-09','17:15:00',5.08),('7643','2013-05-09','17:20:00',7.98),('7643','2013-05-09','17:25:00',7.3),('7643','2013-05-09','17:30:00',6.69),('7643','2013-05-09','17:35:00',7.88),('7643','2013-05-09','17:40:00',5.18),('7643','2013-05-09','17:45:00',4.94),('7643','2013-05-09','17:50:00',4.23),('7643','2013-05-09','17:55:00',3.61),('7643','2013-05-09','18:00:00',3.37),('7643','2013-05-09','18:05:00',3.29),('7643','2013-05-09','18:10:00',2.98),('7643','2013-05-09','18:15:00',2.56),('7643','2013-05-09','18:20:00',2.61),('7643','2013-05-09','18:25:00',2.43),('7643','2013-05-09','18:30:00',1.9),('7643','2013-05-09','18:35:00',1.5),('7643','2013-05-09','18:40:00',1.27),('7643','2013-05-09','18:45:00',1.16),('7643','2013-05-09','18:50:00',1.1),('7643','2013-05-08','06:55:00',1.37),('7643','2013-05-08','07:00:00',1.79),('7643','2013-05-08','07:05:00',2.24),('7643','2013-05-08','07:10:00',2.43),('7643','2013-05-08','07:15:00',2.37),('7643','2013-05-08','07:20:00',2.59),('7643','2013-05-08','07:25:00',2.87),('7643','2013-05-08','07:30:00',3.22),('7643','2013-05-08','07:35:00',3.55),('7643','2013-05-08','07:40:00',3.92),('7643','2013-05-08','07:45:00',4.3),('7643','2013-05-08','07:50:00',4.64),('7643','2013-05-08','07:55:00',5),('7643','2013-05-08','08:00:00',5.33),('7643','2013-05-08','08:05:00',5.69),('7643','2013-05-08','08:10:00',6.01),('7643','2013-05-08','08:15:00',6.24),('7643','2013-05-08','08:20:00',6.64),('7643','2013-05-08','08:25:00',6.94),('7643','2013-05-08','08:30:00',7.23),('7643','2013-05-08','08:35:00',7.56),('7643','2013-05-08','08:40:00',7.91),('7643','2013-05-08','08:45:00',8.22),('7643','2013-05-08','08:50:00',8.53),('7643','2013-05-08','08:55:00',8.81),('7643','2013-05-08','09:00:00',9.14),('7643','2013-05-08','09:05:00',9.4),('7643','2013-05-08','09:10:00',9.59),('7643','2013-05-08','09:15:00',10.01),('7643','2013-05-08','09:20:00',10.33),('7643','2013-05-08','09:25:00',10.6),('7643','2013-05-08','09:30:00',10.96),('7643','2013-05-08','09:35:00',11.19),('7643','2013-05-08','09:40:00',11.48),('7643','2013-05-08','09:45:00',11.79),('7643','2013-05-08','09:50:00',12.01),('7643','2013-05-08','09:55:00',12.25),('7643','2013-05-08','10:00:00',12.47),('7643','2013-05-08','10:05:00',12.69),('7643','2013-05-08','10:10:00',12.84),('7643','2013-05-08','10:15:00',13.13),('7643','2013-05-08','10:20:00',13.25),('7643','2013-05-08','10:25:00',13.48),('7643','2013-05-08','10:30:00',13.68),('7643','2013-05-08','10:35:00',13.75),('7643','2013-05-08','10:40:00',13.98),('7643','2013-05-08','10:45:00',14.09),('7643','2013-05-08','10:50:00',14.18),('7643','2013-05-08','10:55:00',14.45),('7643','2013-05-08','11:00:00',14.59),('7643','2013-05-08','11:05:00',14.72),('7643','2013-05-08','11:10:00',14.94),('7643','2013-05-08','11:15:00',15.05),('7643','2013-05-08','11:20:00',15.08),('7643','2013-05-08','11:25:00',15.18),('7643','2013-05-08','11:30:00',15.16),('7643','2013-05-08','11:35:00',15.21),('7643','2013-05-08','11:40:00',15.4),('7643','2013-05-08','11:45:00',15.59),('7643','2013-05-08','11:50:00',15.57),('7643','2013-05-08','11:55:00',15.6),('7643','2013-05-08','12:00:00',15.71),('7643','2013-05-08','12:05:00',15.94),('7643','2013-05-08','12:10:00',15.96),('7643','2013-05-08','12:15:00',16.1),('7643','2013-05-08','12:20:00',16),('7643','2013-05-08','12:25:00',13.03),('7643','2013-05-08','12:30:00',14.79),('7643','2013-05-08','12:35:00',16.21),('7643','2013-05-08','12:40:00',12.43),('7643','2013-05-08','12:45:00',9.75),('7643','2013-05-08','12:50:00',12.02),('7643','2013-05-08','12:55:00',16.85),('7643','2013-05-08','13:00:00',16.48),('7643','2013-05-08','13:05:00',16.16),('7643','2013-05-08','13:10:00',16.2),('7643','2013-05-08','13:15:00',16.11),('7643','2013-05-08','13:20:00',16.11),('7643','2013-05-08','13:25:00',15.93),('7643','2013-05-08','13:30:00',16.14),('7643','2013-05-08','13:35:00',16.22),('7643','2013-05-08','13:40:00',16.27),('7643','2013-05-08','13:45:00',16.42),('7643','2013-05-08','13:50:00',16.19),('7643','2013-05-08','13:55:00',16.05),('7643','2013-05-08','14:00:00',15.61),('7643','2013-05-08','14:05:00',15.13),('7643','2013-05-08','14:10:00',15.15),('7643','2013-05-08','14:15:00',13.74),('7643','2013-05-08','14:20:00',15.93),('7643','2013-05-08','14:25:00',16.06),('7643','2013-05-08','14:30:00',15.35),('7643','2013-05-08','14:35:00',15.28),('7643','2013-05-08','14:40:00',15.27),('7643','2013-05-08','14:45:00',15.2),('7643','2013-05-08','14:50:00',15.01),('7643','2013-05-08','14:55:00',15.1),('7643','2013-05-08','15:00:00',14.93),('7643','2013-05-08','15:05:00',14.56),('7643','2013-05-08','15:10:00',14.4),('7643','2013-05-08','15:15:00',14.26),('7643','2013-05-08','15:20:00',14.05),('7643','2013-05-08','15:25:00',13.76),('7643','2013-05-08','15:30:00',13.74),('7643','2013-05-08','15:35:00',13.53),('7643','2013-05-08','15:40:00',13.36),('7643','2013-05-08','15:45:00',13.15),('7643','2013-05-08','15:50:00',12.99),('7643','2013-05-08','15:55:00',12.73),('7643','2013-05-08','16:00:00',12.4),('7643','2013-05-08','16:05:00',12.27),('7643','2013-05-08','16:10:00',11.97),('7643','2013-05-08','16:15:00',11.69),('7643','2013-05-08','16:20:00',11.52),('7643','2013-05-08','16:25:00',11.21),('7643','2013-05-08','16:30:00',10.97),('7643','2013-05-08','16:35:00',10.71),('7643','2013-05-08','16:40:00',10.32),('7643','2013-05-08','16:45:00',9.89),('7643','2013-05-08','16:50:00',9.61),('7643','2013-05-08','16:55:00',9.35),('7643','2013-05-08','17:00:00',9.1),('7643','2013-05-08','17:05:00',8.82),('7643','2013-05-08','17:10:00',8.48),('7643','2013-05-08','17:15:00',8.09),('7643','2013-05-08','17:20:00',7.72),('7643','2013-05-08','17:25:00',7.38),('7643','2013-05-08','17:30:00',7.1),('7643','2013-05-08','17:35:00',6.69),('7643','2013-05-08','17:40:00',6.35),('7643','2013-05-08','17:45:00',6.09),('7643','2013-05-08','17:50:00',5.71),('7643','2013-05-08','17:55:00',5.3),('7643','2013-05-08','18:00:00',5.07),('7643','2013-05-08','18:05:00',4.72),('7643','2013-05-08','18:10:00',4.34),('7643','2013-05-08','18:15:00',4.05),('7643','2013-05-08','18:20:00',3.76),('7643','2013-05-08','18:25:00',3.42),('7643','2013-05-08','18:30:00',3.12),('7643','2013-05-08','18:35:00',2.84),('7643','2013-05-08','18:40:00',2.49),('7643','2013-05-08','18:45:00',2.15),('7643','2013-05-08','18:50:00',1.83),('7643','2013-05-08','18:55:00',1.58),('7643','2013-05-08','19:00:00',1.38),('7643','2013-05-08','19:05:00',1.17),('7643','2013-05-08','19:10:00',1.02),('7643','2013-05-07','07:20:00',1.01),('7643','2013-05-07','07:25:00',1.57),('7643','2013-05-07','07:30:00',2.27),('7643','2013-05-07','07:40:00',1.04),('7643','2013-05-07','07:45:00',1.16),('7643','2013-05-07','07:50:00',1.44),('7643','2013-05-07','07:55:00',2.49),('7643','2013-05-07','08:00:00',1.83),('7643','2013-05-07','08:05:00',5.05),('7643','2013-05-07','08:10:00',6.78),('7643','2013-05-07','08:15:00',6.97),('7643','2013-05-07','08:20:00',7.17),('7643','2013-05-07','08:25:00',6.96),('7643','2013-05-07','08:30:00',7.61),('7643','2013-05-07','08:35:00',7.82),('7643','2013-05-07','08:40:00',8.21),('7643','2013-05-07','08:45:00',8.94),('7643','2013-05-07','08:50:00',10.14),('7643','2013-05-07','08:55:00',10.5),('7643','2013-05-07','09:00:00',9.92),('7643','2013-05-07','09:05:00',11.2),('7643','2013-05-07','09:10:00',10.47),('7643','2013-05-07','09:15:00',6.45),('7643','2013-05-07','09:20:00',4.12),('7643','2013-05-07','09:25:00',2.26),('7643','2013-05-07','09:30:00',2.34),('7643','2013-05-07','09:35:00',2.89),('7643','2013-05-07','09:40:00',3.96),('7643','2013-05-07','09:45:00',4.91),('7643','2013-05-07','09:50:00',4.56),('7643','2013-05-07','09:55:00',3.95),('7643','2013-05-07','10:00:00',9.9),('7643','2013-05-07','10:05:00',14.57),('7643','2013-05-07','10:10:00',8.48),('7643','2013-05-07','10:15:00',6.5),('7643','2013-05-07','10:20:00',8.4),('7643','2013-05-07','10:25:00',9.98),('7643','2013-05-07','10:30:00',4.95),('7643','2013-05-07','10:35:00',3.48),('7643','2013-05-07','10:40:00',3.39),('7643','2013-05-07','10:45:00',3.35),('7643','2013-05-07','10:50:00',3.17),('7643','2013-05-07','10:55:00',4.01),('7643','2013-05-07','11:00:00',6.55),('7643','2013-05-07','11:05:00',8.35),('7643','2013-05-07','11:10:00',15.03),('7643','2013-05-07','11:15:00',15.62),('7643','2013-05-07','11:20:00',15.82),('7643','2013-05-07','11:25:00',15.89),('7643','2013-05-07','11:30:00',16.4),('7643','2013-05-07','11:35:00',16.86),('7643','2013-05-07','11:40:00',17.02),('7643','2013-05-07','11:45:00',15.66),('7643','2013-05-07','11:50:00',6.91),('7643','2013-05-07','11:55:00',6),('7643','2013-05-07','12:00:00',14.97),('7643','2013-05-07','12:05:00',6.02),('7643','2013-05-07','12:10:00',2.51),('7643','2013-05-07','12:15:00',2.71),('7643','2013-05-07','12:20:00',3.42),('7643','2013-05-07','12:25:00',5.84),('7643','2013-05-07','12:30:00',9.68),('7643','2013-05-07','12:35:00',4.36),('7643','2013-05-07','12:40:00',4.72),('7643','2013-05-07','12:45:00',4.84),('7643','2013-05-07','12:50:00',11.85),('7643','2013-05-07','12:55:00',11.33),('7643','2013-05-07','13:00:00',12.02),('7643','2013-05-07','13:05:00',14.43),('7643','2013-05-07','13:10:00',17.23),('7643','2013-05-07','13:15:00',14.88),('7643','2013-05-07','13:20:00',4.15),('7643','2013-05-07','13:25:00',5.03),('7643','2013-05-07','13:30:00',3.58),('7643','2013-05-07','13:35:00',3.36),('7643','2013-05-07','13:40:00',3.7),('7643','2013-05-07','13:45:00',14.52),('7643','2013-05-07','13:50:00',17.38),('7643','2013-05-07','13:55:00',15.85),('7643','2013-05-07','14:00:00',14.23),('7643','2013-05-07','14:05:00',8.56),('7643','2013-05-07','14:10:00',6.9),('7643','2013-05-07','14:15:00',5.81),('7643','2013-05-07','14:20:00',15.08),('7643','2013-05-07','14:25:00',6.32),('7643','2013-05-07','14:30:00',16.96),('7643','2013-05-07','14:35:00',12.82),('7643','2013-05-07','14:40:00',6.36),('7643','2013-05-07','14:45:00',12.78),('7643','2013-05-07','14:50:00',16.91),('7643','2013-05-07','14:55:00',15.91),('7643','2013-05-07','15:00:00',14.95),('7643','2013-05-07','15:05:00',15.05),('7643','2013-05-07','15:10:00',14.14),('7643','2013-05-07','15:15:00',13.45),('7643','2013-05-07','15:20:00',14.52),('7643','2013-05-07','15:25:00',14.35),('7643','2013-05-07','15:30:00',14.06),('7643','2013-05-07','15:35:00',13.66),('7643','2013-05-07','15:40:00',13.27),('7643','2013-05-07','15:45:00',13.11),('7643','2013-05-07','15:50:00',12.91),('7643','2013-05-07','15:55:00',12.75),('7643','2013-05-07','16:00:00',12.6),('7643','2013-05-07','16:05:00',12.38),('7643','2013-05-07','16:10:00',12.18),('7643','2013-05-07','16:15:00',11.85),('7643','2013-05-07','16:20:00',11.54),('7643','2013-05-07','16:25:00',11.3),('7643','2013-05-07','16:30:00',11.38),('7643','2013-05-07','16:35:00',10.62),('7643','2013-05-07','16:40:00',10.43),('7643','2013-05-07','16:45:00',11.04),('7643','2013-05-07','16:50:00',10.62),('7643','2013-05-07','16:55:00',10.67),('7643','2013-05-07','17:00:00',8.89),('7643','2013-05-07','17:05:00',10.81),('7643','2013-05-07','17:10:00',10.46),('7643','2013-05-07','17:15:00',9.71),('7643','2013-05-07','17:20:00',8.67),('7643','2013-05-07','17:25:00',6.4),('7643','2013-05-07','17:30:00',8.6),('7643','2013-05-07','17:35:00',8.16),('7643','2013-05-07','17:40:00',7.79),('7643','2013-05-07','17:45:00',7.95),('7643','2013-05-07','17:50:00',7.96),('7643','2013-05-07','17:55:00',6.66),('7643','2013-05-07','18:00:00',3.19),('7643','2013-05-07','18:05:00',2.92),('7643','2013-05-07','18:10:00',3.3),('7643','2013-05-07','18:15:00',5.2),('7643','2013-05-07','18:20:00',5.06),('7643','2013-05-07','18:25:00',4.59),('7643','2013-05-07','18:30:00',3.96),('7643','2013-05-07','18:35:00',3.55),('7643','2013-05-07','18:40:00',2.21),('7643','2013-05-07','18:45:00',1.2),('7643','2013-05-07','19:00:00',1.44),('7643','2013-05-07','19:05:00',1.27),('7643','2013-05-06','06:55:00',1.12),('7643','2013-05-06','07:00:00',1.35),('7643','2013-05-06','07:05:00',1.62),('7643','2013-05-06','07:10:00',1.94),('7643','2013-05-06','07:15:00',2.24),('7643','2013-05-06','07:20:00',2.55),('7643','2013-05-06','07:25:00',2.9),('7643','2013-05-06','07:30:00',3.24),('7643','2013-05-06','07:35:00',3.62),('7643','2013-05-06','07:40:00',3.97),('7643','2013-05-06','07:45:00',4.33),('7643','2013-05-06','07:50:00',4.68),('7643','2013-05-06','07:55:00',5.02),('7643','2013-05-06','08:00:00',5.45),('7643','2013-05-06','08:05:00',5.76),('7643','2013-05-06','08:10:00',6.16),('7643','2013-05-06','08:15:00',6.5),('7643','2013-05-06','08:20:00',6.79),('7643','2013-05-06','08:25:00',7.06),('7643','2013-05-06','08:30:00',7.35),('7643','2013-05-06','08:35:00',7.8),('7643','2013-05-06','08:40:00',8.17),('7643','2013-05-06','08:45:00',8.46),('7643','2013-05-06','08:50:00',9.11),('7643','2013-05-06','08:55:00',9.7),('7643','2013-05-06','09:00:00',9.93),('7643','2013-05-06','09:05:00',10.17),('7643','2013-05-06','09:10:00',9.29),('7643','2013-05-06','09:15:00',6.27),('7643','2013-05-06','09:20:00',5.4),('7643','2013-05-06','09:25:00',2.81),('7643','2013-05-06','09:30:00',4.4),('7643','2013-05-06','09:35:00',11.41),('7643','2013-05-06','09:40:00',4.94),('7643','2013-05-06','09:45:00',4.67),('7643','2013-05-06','09:50:00',5.67),('7643','2013-05-06','09:55:00',6.82),('7643','2013-05-06','10:00:00',4.82),('7643','2013-05-06','10:05:00',4.97),('7643','2013-05-06','10:10:00',3.36),('7643','2013-05-06','10:15:00',2.63),('7643','2013-05-06','10:20:00',2.26),('7643','2013-05-06','10:25:00',2.17),('7643','2013-05-06','10:30:00',2.07),('7643','2013-05-06','10:35:00',1.85),('7643','2013-05-06','10:40:00',1.91),('7643','2013-05-06','10:45:00',1.75),('7643','2013-05-06','10:50:00',1.98),('7643','2013-05-06','10:55:00',2.55),('7643','2013-05-06','11:00:00',3.32),('7643','2013-05-06','11:05:00',3.88),('7643','2013-05-06','11:10:00',4.32),('7643','2013-05-06','11:15:00',5.02),('7643','2013-05-06','11:20:00',7.35),('7643','2013-05-06','11:25:00',11.96),('7643','2013-05-06','11:30:00',3.24),('7643','2013-05-06','11:35:00',2.19),('7643','2013-05-06','11:40:00',1.59),('7643','2013-05-06','11:45:00',1.65),('7643','2013-05-06','11:50:00',1.8),('7643','2013-05-06','11:55:00',2.11),('7643','2013-05-06','12:00:00',2.36),('7643','2013-05-06','12:05:00',2.69),('7643','2013-05-06','12:10:00',6.84),('7643','2013-05-06','12:15:00',3.71),('7643','2013-05-06','12:20:00',3.68),('7643','2013-05-06','12:25:00',4.85),('7643','2013-05-06','12:30:00',6.86),('7643','2013-05-06','12:35:00',3.66),('7643','2013-05-06','12:40:00',3.35),('7643','2013-05-06','12:45:00',2.46),('7643','2013-05-06','12:50:00',1.91),('7643','2013-05-06','12:55:00',1.96),('7643','2013-05-06','13:00:00',1.57),('7643','2013-05-06','13:05:00',2.28),('7643','2013-05-06','13:10:00',2.87),('7643','2013-05-06','13:15:00',4.35),('7643','2013-05-06','13:20:00',7.81),('7643','2013-05-06','13:25:00',12.61),('7643','2013-05-06','13:30:00',18.45),('7643','2013-05-06','13:35:00',13.52),('7643','2013-05-06','13:40:00',15.14),('7643','2013-05-06','13:45:00',15.55),('7643','2013-05-06','13:50:00',18.28),('7643','2013-05-06','13:55:00',17.23),('7643','2013-05-06','14:00:00',17.45),('7643','2013-05-06','14:05:00',17.22),('7643','2013-05-06','14:10:00',17.22),('7643','2013-05-06','14:15:00',16.17),('7643','2013-05-06','14:20:00',17.19),('7643','2013-05-06','14:25:00',17.31),('7643','2013-05-06','14:30:00',15.68),('7643','2013-05-06','14:35:00',16.77),('7643','2013-05-06','14:40:00',14.11),('7643','2013-05-06','14:45:00',17.35),('7643','2013-05-06','14:50:00',16.04),('7643','2013-05-06','14:55:00',11.05),('7643','2013-05-06','15:00:00',17.89),('7643','2013-05-06','15:05:00',15.29),('7643','2013-05-06','15:10:00',13.77),('7643','2013-05-06','15:15:00',13.85),('7643','2013-05-06','15:20:00',14.26),('7643','2013-05-06','15:25:00',10.56),('7643','2013-05-06','15:30:00',12.97),('7643','2013-05-06','15:35:00',12.94),('7643','2013-05-06','15:40:00',6.35),('7643','2013-05-06','15:45:00',6.08),('7643','2013-05-06','15:50:00',4.85),('7643','2013-05-06','15:55:00',7.15),('7643','2013-05-06','16:00:00',10.91),('7643','2013-05-06','16:05:00',10.41),('7643','2013-05-06','16:10:00',4.55),('7643','2013-05-06','16:15:00',8.46),('7643','2013-05-06','16:20:00',15.86),('7643','2013-05-06','16:25:00',14.75),('7643','2013-05-06','16:30:00',14.17),('7643','2013-05-06','16:35:00',13.97),('7643','2013-05-06','16:40:00',13.93),('7643','2013-05-06','16:45:00',10.35),('7643','2013-05-06','16:50:00',12.11),('7643','2013-05-06','16:55:00',10.74),('7643','2013-05-06','17:00:00',10.13),('7643','2013-05-06','17:05:00',10.44),('7643','2013-05-06','17:10:00',6.47),('7643','2013-05-06','17:15:00',4.48),('7643','2013-05-06','17:20:00',4.26),('7643','2013-05-06','17:25:00',4.39),('7643','2013-05-06','17:30:00',3.75),('7643','2013-05-06','17:35:00',3.8),('7643','2013-05-06','17:40:00',3.4),('7643','2013-05-06','17:45:00',3.14),('7643','2013-05-06','17:50:00',2.71),('7643','2013-05-06','17:55:00',2.11),('7643','2013-05-06','18:00:00',1.75),('7643','2013-05-06','18:05:00',1.58),('7643','2013-05-06','18:10:00',1.4),('7643','2013-05-06','18:15:00',1.31),('7643','2013-05-06','18:20:00',1.41),('7643','2013-05-06','18:25:00',1.54),('7643','2013-05-06','18:30:00',1.53),('7643','2013-05-06','18:35:00',1.65),('7643','2013-05-06','18:40:00',2.13),('7643','2013-05-06','18:45:00',2.7),('7643','2013-05-06','18:50:00',2.14),('7643','2013-05-06','18:55:00',1.35),('7643','2013-05-05','07:55:00',1.02),('7643','2013-05-05','08:00:00',1.4),('7643','2013-05-05','08:05:00',1.64),('7643','2013-05-05','08:10:00',1.92),('7643','2013-05-05','08:15:00',2.23),('7643','2013-05-05','08:20:00',2.54),('7643','2013-05-05','08:25:00',4.13),('7643','2013-05-05','08:30:00',5),('7643','2013-05-05','08:35:00',3.91),('7643','2013-05-05','08:40:00',3.28),('7643','2013-05-05','08:45:00',2.64),('7643','2013-05-05','08:50:00',3.87),('7643','2013-05-05','08:55:00',7.08),('7643','2013-05-05','09:00:00',7.65),('7643','2013-05-05','09:05:00',5.03),('7643','2013-05-05','09:10:00',5.8),('7643','2013-05-05','09:15:00',4.4),('7643','2013-05-05','09:20:00',4.35),('7643','2013-05-05','09:25:00',3.79),('7643','2013-05-05','09:30:00',3.47),('7643','2013-05-05','09:35:00',2.48),('7643','2013-05-05','09:40:00',1.49),('7643','2013-05-05','09:50:00',2.09),('7643','2013-05-05','09:55:00',3.9),('7643','2013-05-05','10:00:00',6.71),('7643','2013-05-05','10:05:00',4.84),('7643','2013-05-05','10:10:00',4.3),('7643','2013-05-05','10:15:00',5.74),('7643','2013-05-05','10:20:00',6.74),('7643','2013-05-05','10:25:00',6.06),('7643','2013-05-05','10:30:00',7.17),('7643','2013-05-05','10:35:00',6.35),('7643','2013-05-05','10:40:00',6.43),('7643','2013-05-05','10:45:00',12.28),('7643','2013-05-05','10:50:00',8.6),('7643','2013-05-05','10:55:00',7.45),('7643','2013-05-05','11:00:00',7.73),('7643','2013-05-05','11:05:00',7.58),('7643','2013-05-05','11:10:00',7.33),('7643','2013-05-05','11:15:00',6.67),('7643','2013-05-05','11:20:00',7.63),('7643','2013-05-05','11:25:00',8.46),('7643','2013-05-05','11:30:00',8.2),('7643','2013-05-05','11:35:00',6.18),('7643','2013-05-05','11:40:00',14.47),('7643','2013-05-05','11:45:00',13.98),('7643','2013-05-05','11:50:00',9.43),('7643','2013-05-05','11:55:00',5.29),('7643','2013-05-05','12:00:00',9.47),('7643','2013-05-05','12:05:00',6.79),('7643','2013-05-05','12:10:00',11.66),('7643','2013-05-05','12:15:00',8.59),('7643','2013-05-05','12:20:00',8.67),('7643','2013-05-05','12:25:00',11.59),('7643','2013-05-05','12:30:00',11.91),('7643','2013-05-05','12:35:00',16.21),('7643','2013-05-05','12:40:00',12.22),('7643','2013-05-05','12:45:00',9.21),('7643','2013-05-05','12:50:00',10.06),('7643','2013-05-05','12:55:00',13.34),('7643','2013-05-05','13:00:00',9.21),('7643','2013-05-05','13:05:00',8.7),('7643','2013-05-05','13:10:00',17.09),('7643','2013-05-05','13:15:00',15.29),('7643','2013-05-05','13:20:00',17.98),('7643','2013-05-05','13:25:00',14.71),('7643','2013-05-05','13:30:00',10.76),('7643','2013-05-05','13:35:00',10.82),('7643','2013-05-05','13:40:00',16.77),('7643','2013-05-05','13:45:00',10.74),('7643','2013-05-05','13:50:00',14.5),('7643','2013-05-05','13:55:00',17.4),('7643','2013-05-05','14:00:00',18.15),('7643','2013-05-05','14:05:00',12.91),('7643','2013-05-05','14:10:00',7.37),('7643','2013-05-05','14:15:00',10.56),('7643','2013-05-05','14:20:00',16.38),('7643','2013-05-05','14:25:00',15.6),('7643','2013-05-05','14:30:00',13.33),('7643','2013-05-05','14:35:00',18.08),('7643','2013-05-05','14:40:00',12.84),('7643','2013-05-05','14:45:00',11.94),('7643','2013-05-05','14:50:00',12.43),('7643','2013-05-05','14:55:00',13.45),('7643','2013-05-05','15:00:00',8.93),('7643','2013-05-05','15:05:00',12.04),('7643','2013-05-05','15:10:00',10.05),('7643','2013-05-05','15:15:00',7.74),('7643','2013-05-05','15:20:00',10.81),('7643','2013-05-05','15:25:00',4.94),('7643','2013-05-05','15:30:00',14.13),('7643','2013-05-05','15:35:00',9.01),('7643','2013-05-05','15:40:00',11.77),('7643','2013-05-05','15:45:00',5.63),('7643','2013-05-05','15:50:00',5.57),('7643','2013-05-05','15:55:00',9.25),('7643','2013-05-05','16:00:00',5.09),('7643','2013-05-05','16:05:00',6.38),('7643','2013-05-05','16:10:00',4.77),('7643','2013-05-05','16:15:00',4.5),('7643','2013-05-05','16:20:00',7.55),('7643','2013-05-05','16:25:00',8.94),('7643','2013-05-05','16:30:00',9.96),('7643','2013-05-05','16:35:00',7.46),('7643','2013-05-05','16:40:00',13.49),('7643','2013-05-05','16:45:00',8.01),('7643','2013-05-05','16:50:00',8.24),('7643','2013-05-05','16:55:00',7.66),('7643','2013-05-05','17:00:00',5.87),('7643','2013-05-05','17:05:00',2.28),('7643','2013-05-05','17:10:00',2),('7643','2013-05-05','17:15:00',6.54),('7643','2013-05-05','17:20:00',3.92),('7643','2013-05-05','17:25:00',2.53),('7643','2013-05-05','17:30:00',2.47),('7643','2013-05-05','17:35:00',6.6),('7643','2013-05-05','17:40:00',4.62),('7643','2013-05-05','17:45:00',3.66),('7643','2013-05-05','17:50:00',3.86),('7643','2013-05-05','17:55:00',2.53),('7643','2013-05-05','18:00:00',3.5),('7643','2013-05-05','18:05:00',5.56),('7643','2013-05-05','18:10:00',3.48),('7643','2013-05-05','18:15:00',1.81),('7643','2013-05-05','18:20:00',4.02),('7643','2013-05-05','18:25:00',3.86),('7643','2013-05-05','18:30:00',3.54),('7643','2013-05-05','18:35:00',2.1),('7643','2013-05-05','18:40:00',1.18),('7643','2013-05-05','18:45:00',1.19),('7643','2013-05-05','18:50:00',1.03),('7643','2013-05-04','07:10:00',1.49),('7643','2013-05-04','07:15:00',2.17),('7643','2013-05-04','07:20:00',2.37),('7643','2013-05-04','07:25:00',2.19),('7643','2013-05-04','07:30:00',2.16),('7643','2013-05-04','07:35:00',2.1),('7643','2013-05-04','07:40:00',2.7),('7643','2013-05-04','07:45:00',3.87),('7643','2013-05-04','07:50:00',4.08),('7643','2013-05-04','07:55:00',4.19),('7643','2013-05-04','08:00:00',4.62),('7643','2013-05-04','08:05:00',5.14),('7643','2013-05-04','08:10:00',5.53),('7643','2013-05-04','08:15:00',5.88),('7643','2013-05-04','08:20:00',6.73),('7643','2013-05-04','08:25:00',8.17),('7643','2013-05-04','08:30:00',8.04),('7643','2013-05-04','08:35:00',7.75),('7643','2013-05-04','08:40:00',7.93),('7643','2013-05-04','08:45:00',6.19),('7643','2013-05-04','08:50:00',5.12),('7643','2013-05-04','08:55:00',4.66),('7643','2013-05-04','09:00:00',5),('7643','2013-05-04','09:05:00',5.35),('7643','2013-05-04','09:10:00',6.35),('7643','2013-05-04','09:15:00',8.13),('7643','2013-05-04','09:20:00',6.6),('7643','2013-05-04','09:25:00',7.48),('7643','2013-05-04','09:30:00',6.42),('7643','2013-05-04','09:35:00',6.37),('7643','2013-05-04','09:40:00',8.84),('7643','2013-05-04','09:45:00',9.3),('7643','2013-05-04','09:50:00',8.72),('7643','2013-05-04','09:55:00',12.63),('7643','2013-05-04','10:00:00',8.33),('7643','2013-05-04','10:05:00',8.16),('7643','2013-05-04','10:10:00',8.03),('7643','2013-05-04','10:15:00',7.52),('7643','2013-05-04','10:20:00',10.81),('7643','2013-05-04','10:25:00',8.69),('7643','2013-05-04','10:30:00',9.74),('7643','2013-05-04','10:35:00',9.19),('7643','2013-05-04','10:40:00',9.61),('7643','2013-05-04','10:45:00',9.44),('7643','2013-05-04','10:50:00',7.7),('7643','2013-05-04','10:55:00',6.3),('7643','2013-05-04','11:00:00',5.78),('7643','2013-05-04','11:05:00',7.49),('7643','2013-05-04','11:10:00',6.61),('7643','2013-05-04','11:15:00',6.49),('7643','2013-05-04','11:20:00',9.09),('7643','2013-05-04','11:25:00',12.86),('7643','2013-05-04','11:30:00',10.71),('7643','2013-05-04','11:35:00',13.95),('7643','2013-05-04','11:40:00',12.55),('7643','2013-05-04','11:45:00',11.35),('7643','2013-05-04','11:50:00',9.84),('7643','2013-05-04','11:55:00',10.78),('7643','2013-05-04','12:00:00',8.91),('7643','2013-05-04','12:05:00',9.72),('7643','2013-05-04','12:10:00',9.05),('7643','2013-05-04','12:15:00',10.51),('7643','2013-05-04','12:20:00',10.96),('7643','2013-05-04','12:25:00',14.42),('7643','2013-05-04','12:30:00',14.08),('7643','2013-05-04','12:35:00',16.43),('7643','2013-05-04','12:40:00',13.91),('7643','2013-05-04','12:45:00',14.31),('7643','2013-05-04','12:50:00',12.84),('7643','2013-05-04','12:55:00',13.14),('7643','2013-05-04','13:00:00',13.95),('7643','2013-05-04','13:05:00',15.13),('7643','2013-05-04','13:10:00',13.3),('7643','2013-05-04','13:15:00',16.47),('7643','2013-05-04','13:20:00',12.57),('7643','2013-05-04','13:25:00',8.59),('7643','2013-05-04','13:30:00',7.39),('7643','2013-05-04','13:35:00',14.33),('7643','2013-05-04','13:40:00',16.65),('7643','2013-05-04','13:45:00',16.03),('7643','2013-05-04','13:50:00',16.09),('7643','2013-05-04','13:55:00',16.06),('7643','2013-05-04','14:00:00',16.41),('7643','2013-05-04','14:05:00',16.67),('7643','2013-05-04','14:10:00',12.53),('7643','2013-05-04','14:15:00',12.24),('7643','2013-05-04','14:20:00',14.6),('7643','2013-05-04','14:25:00',14.64),('7643','2013-05-04','14:30:00',14.24),('7643','2013-05-04','14:35:00',14.03),('7643','2013-05-04','14:40:00',13.9),('7643','2013-05-04','14:45:00',13.81),('7643','2013-05-04','14:50:00',13.64),('7643','2013-05-04','14:55:00',13.5),('7643','2013-05-04','15:00:00',13.46),('7643','2013-05-04','15:05:00',13.28),('7643','2013-05-04','15:10:00',13.13),('7643','2013-05-04','15:15:00',13.05),('7643','2013-05-04','15:20:00',12.82),('7643','2013-05-04','15:25:00',12.76),('7643','2013-05-04','15:30:00',12.63),('7643','2013-05-04','15:35:00',12.41),('7643','2013-05-04','15:40:00',12.18),('7643','2013-05-04','15:45:00',11.98),('7643','2013-05-04','15:50:00',11.78),('7643','2013-05-04','15:55:00',11.59),('7643','2013-05-04','16:00:00',11.41),('7643','2013-05-04','16:05:00',11.19),('7643','2013-05-04','16:10:00',10.98),('7643','2013-05-04','16:15:00',10.77),('7643','2013-05-04','16:20:00',10.53),('7643','2013-05-04','16:25:00',10.27),('7643','2013-05-04','16:30:00',10.01),('7643','2013-05-04','16:35:00',9.73),('7643','2013-05-04','16:40:00',9.46),('7643','2013-05-04','16:45:00',9.21),('7643','2013-05-04','16:50:00',8.93),('7643','2013-05-04','16:55:00',8.61),('7643','2013-05-04','17:00:00',8.31),('7643','2013-05-04','17:05:00',8.02),('7643','2013-05-04','17:10:00',7.73),('7643','2013-05-04','17:15:00',7.47),('7643','2013-05-04','17:20:00',7.13),('7643','2013-05-04','17:25:00',6.75),('7643','2013-05-04','17:30:00',6.4),('7643','2013-05-04','17:35:00',6.08),('7643','2013-05-04','17:40:00',5.73),('7643','2013-05-04','17:45:00',5.45),('7643','2013-05-04','17:50:00',5.09),('7643','2013-05-04','17:55:00',4.7),('7643','2013-05-04','18:00:00',4.42),('7643','2013-05-04','18:05:00',4.14),('7643','2013-05-04','18:10:00',3.84),('7643','2013-05-04','18:15:00',3.56),('7643','2013-05-04','18:20:00',3.25),('7643','2013-05-04','18:25:00',2.89),('7643','2013-05-04','18:30:00',2.74),('7643','2013-05-04','18:35:00',2.54),('7643','2013-05-04','18:40:00',2.29),('7643','2013-05-04','18:45:00',2.02),('7643','2013-05-04','18:50:00',1.75),('7643','2013-05-04','18:55:00',1.52),('7643','2013-05-04','19:00:00',1.35),('7643','2013-05-04','19:05:00',1.19),('7643','2013-05-04','19:10:00',1.02),('7643','2013-05-03','07:00:00',1.03),('7643','2013-05-03','07:05:00',1.12),('7643','2013-05-03','07:10:00',1.36),('7643','2013-05-03','07:15:00',1.05),('7643','2013-05-03','07:30:00',1.21),('7643','2013-05-03','07:35:00',2.33),('7643','2013-05-03','07:40:00',3.29),('7643','2013-05-03','07:45:00',3.4),('7643','2013-05-03','07:50:00',3.8),('7643','2013-05-03','07:55:00',4.38),('7643','2013-05-03','08:00:00',4.79),('7643','2013-05-03','08:05:00',5.09),('7643','2013-05-03','08:10:00',5.39),('7643','2013-05-03','08:15:00',5.67),('7643','2013-05-03','08:20:00',5.95),('7643','2013-05-03','08:25:00',6.14),('7643','2013-05-03','08:30:00',6.35),('7643','2013-05-03','08:35:00',6.57),('7643','2013-05-03','08:40:00',6.9),('7643','2013-05-03','08:45:00',7.21),('7643','2013-05-03','08:50:00',7.46),('7643','2013-05-03','08:55:00',7.83),('7643','2013-05-03','09:00:00',8.06),('7643','2013-05-03','09:05:00',8.33),('7643','2013-05-03','09:10:00',8.71),('7643','2013-05-03','09:15:00',8.94),('7643','2013-05-03','09:20:00',9.41),('7643','2013-05-03','09:25:00',9.51),('7643','2013-05-03','09:30:00',9.61),('7643','2013-05-03','09:35:00',10.03),('7643','2013-05-03','09:40:00',10.38),('7643','2013-05-03','09:45:00',10.77),('7643','2013-05-03','09:50:00',10.99),('7643','2013-05-03','09:55:00',11.19),('7643','2013-05-03','10:00:00',11.5),('7643','2013-05-03','10:05:00',11.65),('7643','2013-05-03','10:10:00',11.93),('7643','2013-05-03','10:15:00',12.23),('7643','2013-05-03','10:20:00',12.38),('7643','2013-05-03','10:25:00',12.59),('7643','2013-05-03','10:30:00',12.73),('7643','2013-05-03','10:35:00',12.88),('7643','2013-05-03','10:40:00',12.83),('7643','2013-05-03','10:45:00',12.86),('7643','2013-05-03','10:50:00',12.74),('7643','2013-05-03','10:55:00',12.61),('7643','2013-05-03','11:00:00',12.69),('7643','2013-05-03','11:05:00',12.75),('7643','2013-05-03','11:10:00',12.19),('7643','2013-05-03','11:15:00',11.81),('7643','2013-05-03','11:20:00',12.75),('7643','2013-05-03','11:25:00',12.97),('7643','2013-05-03','11:30:00',12.53),('7643','2013-05-03','11:35:00',12.79),('7643','2013-05-03','11:40:00',12.38),('7643','2013-05-03','11:45:00',12.87),('7643','2013-05-03','11:50:00',12.72),('7643','2013-05-03','11:55:00',12.85),('7643','2013-05-03','12:00:00',12.52),('7643','2013-05-03','12:05:00',13.13),('7643','2013-05-03','12:10:00',13.32),('7643','2013-05-03','12:15:00',13.61),('7643','2013-05-03','12:20:00',13.93),('7643','2013-05-03','12:25:00',14.15),('7643','2013-05-03','12:30:00',14.21),('7643','2013-05-03','12:35:00',14.4),('7643','2013-05-03','12:40:00',14.25),('7643','2013-05-03','12:45:00',14.45),('7643','2013-05-03','12:50:00',13.96),('7643','2013-05-03','12:55:00',13.55),('7643','2013-05-03','13:00:00',13.29),('7643','2013-05-03','13:05:00',12.04),('7643','2013-05-03','13:10:00',13.46),('7643','2013-05-03','13:15:00',15.06),('7643','2013-05-03','13:20:00',15.31),('7643','2013-05-03','13:25:00',14.2),('7643','2013-05-03','13:30:00',14.43),('7643','2013-05-03','13:35:00',13.89),('7643','2013-05-03','13:40:00',13.87),('7643','2013-05-03','13:45:00',13.82),('7643','2013-05-03','13:50:00',12.23),('7643','2013-05-03','13:55:00',13.09),('7643','2013-05-03','14:00:00',13.09),('7643','2013-05-03','14:05:00',13.62),('7643','2013-05-03','14:10:00',13),('7643','2013-05-03','14:15:00',13.33),('7643','2013-05-03','14:20:00',13.38),('7643','2013-05-03','14:25:00',12.47),('7643','2013-05-03','14:30:00',12.97),('7643','2013-05-03','14:35:00',12.21),('7643','2013-05-03','14:40:00',12.69),('7643','2013-05-03','14:45:00',12.48),('7643','2013-05-03','14:50:00',11.92),('7643','2013-05-03','14:55:00',12.32),('7643','2013-05-03','15:00:00',12.48),('7643','2013-05-03','15:05:00',12.69),('7643','2013-05-03','15:10:00',11.9),('7643','2013-05-03','15:15:00',12.19),('7643','2013-05-03','15:20:00',12.39),('7643','2013-05-03','15:25:00',12.47),('7643','2013-05-03','15:30:00',12.33),('7643','2013-05-03','15:35:00',11.66),('7643','2013-05-03','15:40:00',11.73),('7643','2013-05-03','15:45:00',11.73),('7643','2013-05-03','15:50:00',11.58),('7643','2013-05-03','15:55:00',11.34),('7643','2013-05-03','16:00:00',11.04),('7643','2013-05-03','16:05:00',10.85),('7643','2013-05-03','16:10:00',10.63),('7643','2013-05-03','16:15:00',10.31),('7643','2013-05-03','16:20:00',10.08),('7643','2013-05-03','16:25:00',9.85),('7643','2013-05-03','16:30:00',9.65),('7643','2013-05-03','16:35:00',9.4),('7643','2013-05-03','16:40:00',9.09),('7643','2013-05-03','16:45:00',8.78),('7643','2013-05-03','16:50:00',8.51),('7643','2013-05-03','16:55:00',8.24),('7643','2013-05-03','17:00:00',8),('7643','2013-05-03','17:05:00',7.46),('7643','2013-05-03','17:10:00',5.94),('7643','2013-05-03','17:15:00',6.85),('7643','2013-05-03','17:20:00',6.9),('7643','2013-05-03','17:25:00',6.58),('7643','2013-05-03','17:30:00',6.04),('7643','2013-05-03','17:35:00',5.62),('7643','2013-05-03','17:40:00',5.22),('7643','2013-05-03','17:45:00',5.13),('7643','2013-05-03','17:50:00',4.98),('7643','2013-05-03','17:55:00',4.68),('7643','2013-05-03','18:00:00',4.47),('7643','2013-05-03','18:05:00',4.21),('7643','2013-05-03','18:10:00',3.64),('7643','2013-05-03','18:15:00',2.78),('7643','2013-05-03','18:20:00',2.37),('7643','2013-05-03','18:25:00',2.08),('7643','2013-05-03','18:30:00',1.68),('7643','2013-05-03','18:35:00',1.39),('7643','2013-05-03','18:40:00',1.28),('7643','2013-05-03','18:45:00',1.09),('7643','2013-05-02','07:15:00',1.36),('7643','2013-05-02','07:20:00',1.45),('7643','2013-05-02','07:25:00',1.76),('7643','2013-05-02','07:30:00',1.73),('7643','2013-05-02','07:35:00',1.69),('7643','2013-05-02','07:40:00',1.79),('7643','2013-05-02','07:45:00',2.04),('7643','2013-05-02','07:50:00',2.35),('7643','2013-05-02','07:55:00',2.73),('7643','2013-05-02','08:00:00',3.46),('7643','2013-05-02','08:05:00',4.89),('7643','2013-05-02','08:10:00',6),('7643','2013-05-02','08:15:00',6.71),('7643','2013-05-02','08:20:00',6.55),('7643','2013-05-02','08:25:00',6.88),('7643','2013-05-02','08:30:00',7.05),('7643','2013-05-02','08:35:00',7.17),('7643','2013-05-02','08:40:00',7.5),('7643','2013-05-02','08:45:00',7.78),('7643','2013-05-02','08:50:00',7.69),('7643','2013-05-02','08:55:00',7.74),('7643','2013-05-02','09:00:00',8.38),('7643','2013-05-02','09:05:00',8.88),('7643','2013-05-02','09:10:00',8.93),('7643','2013-05-02','09:15:00',9.3),('7643','2013-05-02','09:20:00',9.49),('7643','2013-05-02','09:25:00',9.71),('7643','2013-05-02','09:30:00',10.08),('7643','2013-05-02','09:35:00',10.44),('7643','2013-05-02','09:40:00',10.71),('7643','2013-05-02','09:45:00',10.92),('7643','2013-05-02','09:50:00',11.11),('7643','2013-05-02','09:55:00',11.38),('7643','2013-05-02','10:00:00',11.62),('7643','2013-05-02','10:05:00',11.88),('7643','2013-05-02','10:10:00',12.06),('7643','2013-05-02','10:15:00',12.21),('7643','2013-05-02','10:20:00',12.36),('7643','2013-05-02','10:25:00',12.5),('7643','2013-05-02','10:30:00',12.8),('7643','2013-05-02','10:35:00',13.01),('7643','2013-05-02','10:40:00',13.16),('7643','2013-05-02','10:45:00',13.2),('7643','2013-05-02','10:50:00',13.24),('7643','2013-05-02','10:55:00',13.37),('7643','2013-05-02','11:00:00',13.56),('7643','2013-05-02','11:05:00',13.71),('7643','2013-05-02','11:10:00',13.85),('7643','2013-05-02','11:15:00',13.86),('7643','2013-05-02','11:20:00',14.05),('7643','2013-05-02','11:25:00',14.28),('7643','2013-05-02','11:30:00',14.41),('7643','2013-05-02','11:35:00',14.47),('7643','2013-05-02','11:40:00',14.64),('7643','2013-05-02','11:45:00',14.73),('7643','2013-05-02','11:50:00',14.81),('7643','2013-05-02','11:55:00',14.85),('7643','2013-05-02','12:00:00',14.83),('7643','2013-05-02','12:05:00',14.84),('7643','2013-05-02','12:10:00',15.04),('7643','2013-05-02','12:15:00',15.09),('7643','2013-05-02','12:20:00',15.11),('7643','2013-05-02','12:25:00',15.15),('7643','2013-05-02','12:30:00',15.15),('7643','2013-05-02','12:35:00',15.15),('7643','2013-05-02','12:40:00',15.17),('7643','2013-05-02','12:45:00',15.22),('7643','2013-05-02','12:50:00',15.37),('7643','2013-05-02','12:55:00',15.35),('7643','2013-05-02','13:00:00',15.2),('7643','2013-05-02','13:05:00',15.19),('7643','2013-05-02','13:10:00',15.2),('7643','2013-05-02','13:15:00',15.13),('7643','2013-05-02','13:20:00',15.13),('7643','2013-05-02','13:25:00',15.27),('7643','2013-05-02','13:30:00',15.07),('7643','2013-05-02','13:35:00',14.86),('7643','2013-05-02','13:40:00',14.45),('7643','2013-05-02','13:45:00',14.42),('7643','2013-05-02','13:50:00',14.28),('7643','2013-05-02','13:55:00',14.41),('7643','2013-05-02','14:00:00',14.37),('7643','2013-05-02','14:05:00',13.68),('7643','2013-05-02','14:10:00',13.95),('7643','2013-05-02','14:15:00',13.48),('7643','2013-05-02','14:20:00',13.95),('7643','2013-05-02','14:25:00',13.91),('7643','2013-05-02','14:30:00',13.59),('7643','2013-05-02','14:35:00',14),('7643','2013-05-02','14:40:00',13.69),('7643','2013-05-02','14:45:00',13.61),('7643','2013-05-02','14:50:00',13.54),('7643','2013-05-02','14:55:00',13.52),('7643','2013-05-02','15:00:00',13.45),('7643','2013-05-02','15:05:00',13.27),('7643','2013-05-02','15:10:00',13.28),('7643','2013-05-02','15:15:00',13.08),('7643','2013-05-02','15:20:00',13.01),('7643','2013-05-02','15:25:00',12.87),('7643','2013-05-02','15:30:00',12.63),('7643','2013-05-02','15:35:00',12.5),('7643','2013-05-02','15:40:00',12.3),('7643','2013-05-02','15:45:00',12.21),('7643','2013-05-02','15:50:00',11.77),('7643','2013-05-02','15:55:00',11.6),('7643','2013-05-02','16:00:00',11.5),('7643','2013-05-02','16:05:00',11.34),('7643','2013-05-02','16:10:00',11.03),('7643','2013-05-02','16:15:00',10.78),('7643','2013-05-02','16:20:00',10.28),('7643','2013-05-02','16:25:00',10.03),('7643','2013-05-02','16:30:00',10.06),('7643','2013-05-02','16:35:00',9.85),('7643','2013-05-02','16:40:00',9.5),('7643','2013-05-02','16:45:00',9.13),('7643','2013-05-02','16:50:00',8.86),('7643','2013-05-02','16:55:00',8.61),('7643','2013-05-02','17:00:00',8.33),('7643','2013-05-02','17:05:00',7.98),('7643','2013-05-02','17:10:00',7.64),('7643','2013-05-02','17:15:00',7.31),('7643','2013-05-02','17:20:00',6.89),('7643','2013-05-02','17:25:00',6.47),('7643','2013-05-02','17:30:00',6.13),('7643','2013-05-02','17:35:00',5.79),('7643','2013-05-02','17:40:00',5.29),('7643','2013-05-02','17:45:00',4.92),('7643','2013-05-02','17:50:00',4.71),('7643','2013-05-02','17:55:00',4.44),('7643','2013-05-02','18:00:00',4.22),('7643','2013-05-02','18:05:00',3.93),('7643','2013-05-02','18:10:00',3.68),('7643','2013-05-02','18:15:00',3.4),('7643','2013-05-02','18:20:00',3.11),('7643','2013-05-02','18:25:00',2.86),('7643','2013-05-02','18:30:00',2.56),('7643','2013-05-02','18:35:00',2.31),('7643','2013-05-02','18:40:00',2.09),('7643','2013-05-02','18:45:00',1.85),('7643','2013-05-02','18:50:00',1.61),('7643','2013-05-02','18:55:00',1.38),('7643','2013-05-02','19:00:00',1.19),('7643','2013-05-02','19:05:00',1.01),('7643','2013-05-01','08:30:00',1.29),('7643','2013-05-01','08:35:00',2.02),('7643','2013-05-01','08:40:00',2.94),('7643','2013-05-01','08:45:00',2.77),('7643','2013-05-01','08:50:00',2.87),('7643','2013-05-01','08:55:00',4.44),('7643','2013-05-01','09:00:00',7.2),('7643','2013-05-01','09:05:00',6.12),('7643','2013-05-01','09:10:00',3.3),('7643','2013-05-01','09:15:00',3.03),('7643','2013-05-01','09:20:00',3.56),('7643','2013-05-01','09:25:00',5.56),('7643','2013-05-01','09:30:00',6.12),('7643','2013-05-01','09:35:00',8.14),('7643','2013-05-01','09:40:00',5.27),('7643','2013-05-01','09:45:00',9.24),('7643','2013-05-01','09:50:00',4.64),('7643','2013-05-01','09:55:00',3.5),('7643','2013-05-01','10:00:00',3.84),('7643','2013-05-01','10:05:00',5.65),('7643','2013-05-01','10:10:00',5.27),('7643','2013-05-01','10:15:00',5.47),('7643','2013-05-01','10:20:00',5.61),('7643','2013-05-01','10:25:00',7.9),('7643','2013-05-01','10:30:00',12.41),('7643','2013-05-01','10:35:00',9.61),('7643','2013-05-01','10:40:00',13.92),('7643','2013-05-01','10:45:00',9.74),('7643','2013-05-01','10:50:00',12.27),('7643','2013-05-01','10:55:00',14.39),('7643','2013-05-01','11:00:00',14.91),('7643','2013-05-01','11:05:00',14.58),('7643','2013-05-01','11:10:00',10.73),('7643','2013-05-01','11:15:00',11.22),('7643','2013-05-01','11:20:00',10.81),('7643','2013-05-01','11:25:00',14.74),('7643','2013-05-01','11:30:00',14.68),('7643','2013-05-01','11:35:00',14.44),('7643','2013-05-01','11:40:00',14.29),('7643','2013-05-01','11:45:00',14.32),('7643','2013-05-01','11:50:00',14.36),('7643','2013-05-01','11:55:00',14.39),('7643','2013-05-01','12:00:00',14.33),('7643','2013-05-01','12:05:00',14.34),('7643','2013-05-01','12:10:00',14.34),('7643','2013-05-01','12:15:00',14.44),('7643','2013-05-01','12:20:00',14.42),('7643','2013-05-01','12:25:00',14.58),('7643','2013-05-01','12:30:00',14.95),('7643','2013-05-01','12:35:00',15.12),('7643','2013-05-01','12:40:00',15.28),('7643','2013-05-01','12:45:00',15.27),('7643','2013-05-01','12:50:00',15.39),('7643','2013-05-01','12:55:00',15.39),('7643','2013-05-01','13:00:00',15.47),('7643','2013-05-01','13:05:00',15.51),('7643','2013-05-01','13:10:00',15.66),('7643','2013-05-01','13:15:00',15.66),('7643','2013-05-01','13:20:00',15.71),('7643','2013-05-01','13:25:00',15.7),('7643','2013-05-01','13:30:00',15.64),('7643','2013-05-01','13:35:00',15.61),('7643','2013-05-01','13:40:00',15.69),('7643','2013-05-01','13:45:00',15.6),('7643','2013-05-01','13:50:00',15.44),('7643','2013-05-01','13:55:00',15.38),('7643','2013-05-01','14:00:00',15.22),('7643','2013-05-01','14:05:00',15.03),('7643','2013-05-01','14:10:00',14.96),('7643','2013-05-01','14:15:00',14.91),('7643','2013-05-01','14:20:00',14.67),('7643','2013-05-01','14:25:00',14.54),('7643','2013-05-01','14:30:00',14.41),('7643','2013-05-01','14:35:00',14.33),('7643','2013-05-01','14:40:00',14.22),('7643','2013-05-01','14:45:00',14.12),('7643','2013-05-01','14:50:00',14.02),('7643','2013-05-01','14:55:00',13.88),('7643','2013-05-01','15:00:00',13.71),('7643','2013-05-01','15:05:00',13.46),('7643','2013-05-01','15:10:00',13.36),('7643','2013-05-01','15:15:00',13.2),('7643','2013-05-01','15:20:00',13.03),('7643','2013-05-01','15:25:00',12.81),('7643','2013-05-01','15:30:00',12.34),('7643','2013-05-01','15:35:00',12.14),('7643','2013-05-01','15:40:00',11.92),('7643','2013-05-01','15:45:00',11.86),('7643','2013-05-01','15:50:00',11.65),('7643','2013-05-01','15:55:00',11.38),('7643','2013-05-01','16:00:00',11.14),('7643','2013-05-01','16:05:00',11.11),('7643','2013-05-01','16:10:00',10.89),('7643','2013-05-01','16:15:00',10.62),('7643','2013-05-01','16:20:00',10.34),('7643','2013-05-01','16:25:00',10.17),('7643','2013-05-01','16:30:00',9.89),('7643','2013-05-01','16:35:00',9.59),('7643','2013-05-01','16:40:00',9.31),('7643','2013-05-01','16:45:00',9.02),('7643','2013-05-01','16:50:00',8.84),('7643','2013-05-01','16:55:00',8.56),('7643','2013-05-01','17:00:00',8.25),('7643','2013-05-01','17:05:00',7.97),('7643','2013-05-01','17:10:00',7.69),('7643','2013-05-01','17:15:00',7.4),('7643','2013-05-01','17:20:00',7.12),('7643','2013-05-01','17:25:00',6.79),('7643','2013-05-01','17:30:00',6.43),('7643','2013-05-01','17:35:00',6.09),('7643','2013-05-01','17:40:00',5.74),('7643','2013-05-01','17:45:00',5.39),('7643','2013-05-01','17:50:00',5.08),('7643','2013-05-01','17:55:00',4.73),('7643','2013-05-01','18:00:00',4.38),('7643','2013-05-01','18:05:00',4.11),('7643','2013-05-01','18:10:00',3.85),('7643','2013-05-01','18:15:00',3.54),('7643','2013-05-01','18:20:00',3.24),('7643','2013-05-01','18:25:00',2.95),('7643','2013-05-01','18:30:00',2.68),('7643','2013-05-01','18:35:00',2.42),('7643','2013-05-01','18:40:00',2.16),('7643','2013-05-01','18:45:00',1.9),('7643','2013-05-01','18:50:00',1.61),('7643','2013-05-01','18:55:00',1.37),('7643','2013-05-01','19:00:00',1.17),('7643','2013-05-01','19:05:00',1),('7643','2013-04-30','07:00:00',1.07),('7643','2013-04-30','07:05:00',1.27),('7643','2013-04-30','07:10:00',1.46),('7643','2013-04-30','07:15:00',1.64),('7643','2013-04-30','07:20:00',1.82),('7643','2013-04-30','07:25:00',1.98),('7643','2013-04-30','07:30:00',2.4),('7643','2013-04-30','07:35:00',2.63),('7643','2013-04-30','07:40:00',2.89),('7643','2013-04-30','07:45:00',3.23),('7643','2013-04-30','07:50:00',3.56),('7643','2013-04-30','07:55:00',3.86),('7643','2013-04-30','08:00:00',4.17),('7643','2013-04-30','08:05:00',4.4),('7643','2013-04-30','08:10:00',4.61),('7643','2013-04-30','08:15:00',4.95),('7643','2013-04-30','08:20:00',5.32),('7643','2013-04-30','08:25:00',5.66),('7643','2013-04-30','08:30:00',6.09),('7643','2013-04-30','08:35:00',6.38),('7643','2013-04-30','08:40:00',6.69),('7643','2013-04-30','08:45:00',6.94),('7643','2013-04-30','08:50:00',7.38),('7643','2013-04-30','08:55:00',7.73),('7643','2013-04-30','09:00:00',8.07),('7643','2013-04-30','09:05:00',8.38),('7643','2013-04-30','09:10:00',8.58),('7643','2013-04-30','09:15:00',8.81),('7643','2013-04-30','09:20:00',8.99),('7643','2013-04-30','09:25:00',9.18),('7643','2013-04-30','09:30:00',9.34),('7643','2013-04-30','09:35:00',9.51),('7643','2013-04-30','09:40:00',9.8),('7643','2013-04-30','09:45:00',10.07),('7643','2013-04-30','09:50:00',10.29),('7643','2013-04-30','09:55:00',10.52),('7643','2013-04-30','10:00:00',10.71),('7643','2013-04-30','10:05:00',10.82),('7643','2013-04-30','10:10:00',11.18),('7643','2013-04-30','10:15:00',11.44),('7643','2013-04-30','10:20:00',11.67),('7643','2013-04-30','10:25:00',11.84),('7643','2013-04-30','10:30:00',12.03),('7643','2013-04-30','10:35:00',12.14),('7643','2013-04-30','10:40:00',12.67),('7643','2013-04-30','10:45:00',13.28),('7643','2013-04-30','10:50:00',13.41),('7643','2013-04-30','10:55:00',13.47),('7643','2013-04-30','11:00:00',13.62),('7643','2013-04-30','11:05:00',13.74),('7643','2013-04-30','11:10:00',13.88),('7643','2013-04-30','11:15:00',13),('7643','2013-04-30','11:20:00',12.38),('7643','2013-04-30','11:25:00',12.04),('7643','2013-04-30','11:30:00',11.78),('7643','2013-04-30','11:35:00',12.61),('7643','2013-04-30','11:40:00',11.16),('7643','2013-04-30','11:45:00',10.91),('7643','2013-04-30','11:50:00',12.83),('7643','2013-04-30','11:55:00',14.94),('7643','2013-04-30','12:00:00',14.67),('7643','2013-04-30','12:05:00',14.41),('7643','2013-04-30','12:10:00',14.39),('7643','2013-04-30','12:15:00',14.44),('7643','2013-04-30','12:20:00',14.59),('7643','2013-04-30','12:25:00',14.77),('7643','2013-04-30','12:30:00',14.85),('7643','2013-04-30','12:35:00',15.04),('7643','2013-04-30','12:40:00',15.35),('7643','2013-04-30','12:45:00',13.13),('7643','2013-04-30','12:50:00',12.51),('7643','2013-04-30','12:55:00',5.52),('7643','2013-04-30','13:00:00',7.31),('7643','2013-04-30','13:05:00',6.86),('7643','2013-04-30','13:10:00',10.02),('7643','2013-04-30','13:15:00',16.99),('7643','2013-04-30','13:20:00',17.02),('7643','2013-04-30','13:25:00',14.23),('7643','2013-04-30','13:30:00',10.68),('7643','2013-04-30','13:35:00',12.32),('7643','2013-04-30','13:40:00',16.53),('7643','2013-04-30','13:45:00',16.46),('7643','2013-04-30','13:50:00',15.62),('7643','2013-04-30','13:55:00',15.17),('7643','2013-04-30','14:00:00',14.9),('7643','2013-04-30','14:05:00',14.49),('7643','2013-04-30','14:10:00',14.31),('7643','2013-04-30','14:15:00',12.26),('7643','2013-04-30','14:20:00',15.05),('7643','2013-04-30','14:25:00',15.08),('7643','2013-04-30','14:30:00',15.14),('7643','2013-04-30','14:35:00',14.58),('7643','2013-04-30','14:40:00',12.91),('7643','2013-04-30','14:45:00',13.82),('7643','2013-04-30','14:50:00',11.31),('7643','2013-04-30','14:55:00',10.63),('7643','2013-04-30','15:00:00',11.93),('7643','2013-04-30','15:05:00',12.57),('7643','2013-04-30','15:10:00',12.99),('7643','2013-04-30','15:15:00',12.54),('7643','2013-04-30','15:20:00',12.04),('7643','2013-04-30','15:25:00',12.63),('7643','2013-04-30','15:30:00',10.32),('7643','2013-04-30','15:35:00',8.92),('7643','2013-04-30','15:40:00',8.81),('7643','2013-04-30','15:45:00',8.7),('7643','2013-04-30','15:50:00',6.4),('7643','2013-04-30','15:55:00',6.21),('7643','2013-04-30','16:00:00',7.64),('7643','2013-04-30','16:05:00',7.31),('7643','2013-04-30','16:10:00',6.53),('7643','2013-04-30','16:15:00',5.91),('7643','2013-04-30','16:20:00',5.05),('7643','2013-04-30','16:25:00',4.01),('7643','2013-04-30','16:30:00',3.75),('7643','2013-04-30','16:35:00',3.99),('7643','2013-04-30','16:40:00',4.3),('7643','2013-04-30','16:45:00',4),('7643','2013-04-30','16:50:00',3.48),('7643','2013-04-30','16:55:00',3.19),('7643','2013-04-30','17:00:00',3.24),('7643','2013-04-30','17:05:00',3.29),('7643','2013-04-30','17:10:00',3.35),('7643','2013-04-30','17:15:00',3.34),('7643','2013-04-30','17:20:00',3),('7643','2013-04-30','17:25:00',2.54),('7643','2013-04-30','17:30:00',2.16),('7643','2013-04-30','17:35:00',1.99),('7643','2013-04-30','17:40:00',1.82),('7643','2013-04-30','17:45:00',1.64),('7643','2013-04-30','17:50:00',1.42),('7643','2013-04-30','17:55:00',1.27),('7643','2013-04-30','18:00:00',1.16),('7643','2013-04-30','18:05:00',1.21),('7643','2013-04-30','18:10:00',1.34),('7643','2013-04-30','18:15:00',1.41),('7643','2013-04-30','18:20:00',1.38),('7643','2013-04-30','18:25:00',1.1),('7643','2013-04-29','07:30:00',1.07),('7643','2013-04-29','07:35:00',1.32),('7643','2013-04-29','07:40:00',1.39),('7643','2013-04-29','07:45:00',1.43),('7643','2013-04-29','07:50:00',1.52),('7643','2013-04-29','07:55:00',1.57),('7643','2013-04-29','08:00:00',1.52),('7643','2013-04-29','08:05:00',1.09),('7643','2013-04-29','08:10:00',1.18),('7643','2013-04-29','08:15:00',1.68),('7643','2013-04-29','08:20:00',2.07),('7643','2013-04-29','08:25:00',2.15),('7643','2013-04-29','08:30:00',2.78),('7643','2013-04-29','08:35:00',3.21),('7643','2013-04-29','08:40:00',3.06),('7643','2013-04-29','08:45:00',3.22),('7643','2013-04-29','08:50:00',4.21),('7643','2013-04-29','08:55:00',5.84),('7643','2013-04-29','09:00:00',6.45),('7643','2013-04-29','09:05:00',5.71),('7643','2013-04-29','09:10:00',8.66),('7643','2013-04-29','09:15:00',9.77),('7643','2013-04-29','09:20:00',9.85),('7643','2013-04-29','09:25:00',10.47),('7643','2013-04-29','09:30:00',10.25),('7643','2013-04-29','09:35:00',8.29),('7643','2013-04-29','09:40:00',5.89),('7643','2013-04-29','09:45:00',7.45),('7643','2013-04-29','09:50:00',9.75),('7643','2013-04-29','09:55:00',10.76),('7643','2013-04-29','10:00:00',12.55),('7643','2013-04-29','10:05:00',12.01),('7643','2013-04-29','10:10:00',10.56),('7643','2013-04-29','10:15:00',9.34),('7643','2013-04-29','10:20:00',8.49),('7643','2013-04-29','10:25:00',8.75),('7643','2013-04-29','10:30:00',7.75),('7643','2013-04-29','10:35:00',7.08),('7643','2013-04-29','10:40:00',5.99),('7643','2013-04-29','10:45:00',4.79),('7643','2013-04-29','10:50:00',5.26),('7643','2013-04-29','10:55:00',5.52),('7643','2013-04-29','11:00:00',5.68),('7643','2013-04-29','11:05:00',6.44),('7643','2013-04-29','11:10:00',6.53),('7643','2013-04-29','11:15:00',6.98),('7643','2013-04-29','11:20:00',7.88),('7643','2013-04-29','11:25:00',7.24),('7643','2013-04-29','11:30:00',7.04),('7643','2013-04-29','11:35:00',7.5),('7643','2013-04-29','11:40:00',7.22),('7643','2013-04-29','11:45:00',6.28),('7643','2013-04-29','11:50:00',6.51),('7643','2013-04-29','11:55:00',6.63),('7643','2013-04-29','12:00:00',6.54),('7643','2013-04-29','12:05:00',6.6),('7643','2013-04-29','12:10:00',6.42),('7643','2013-04-29','12:15:00',5.95),('7643','2013-04-29','12:20:00',5.24),('7643','2013-04-29','12:25:00',4.81),('7643','2013-04-29','12:30:00',4.92),('7643','2013-04-29','12:35:00',9.39),('7643','2013-04-29','12:40:00',16.34),('7643','2013-04-29','12:45:00',17.3),('7643','2013-04-29','12:50:00',16.61),('7643','2013-04-29','12:55:00',14.26),('7643','2013-04-29','13:00:00',15.55),('7643','2013-04-29','13:05:00',15.3),('7643','2013-04-29','13:10:00',15.55),('7643','2013-04-29','13:15:00',15.41),('7643','2013-04-29','13:20:00',15.22),('7643','2013-04-29','13:25:00',15.15),('7643','2013-04-29','13:30:00',15.09),('7643','2013-04-29','13:35:00',15.02),('7643','2013-04-29','13:40:00',14.87),('7643','2013-04-29','13:45:00',14.82),('7643','2013-04-29','13:50:00',14.76),('7643','2013-04-29','13:55:00',14.63),('7643','2013-04-29','14:00:00',14.53),('7643','2013-04-29','14:05:00',14.43),('7643','2013-04-29','14:10:00',14.33),('7643','2013-04-29','14:15:00',14.23),('7643','2013-04-29','14:20:00',14.21),('7643','2013-04-29','14:25:00',14.08),('7643','2013-04-29','14:30:00',14),('7643','2013-04-29','14:35:00',13.85),('7643','2013-04-29','14:40:00',13.64),('7643','2013-04-29','14:45:00',13.39),('7643','2013-04-29','14:50:00',13.18),('7643','2013-04-29','14:55:00',12.95),('7643','2013-04-29','15:00:00',12.8),('7643','2013-04-29','15:05:00',12.6),('7643','2013-04-29','15:10:00',12.41),('7643','2013-04-29','15:15:00',12.17),('7643','2013-04-29','15:20:00',11.99),('7643','2013-04-29','15:25:00',11.77),('7643','2013-04-29','15:30:00',11.62),('7643','2013-04-29','15:35:00',11.57),('7643','2013-04-29','15:40:00',11.34),('7643','2013-04-29','15:45:00',11.1),('7643','2013-04-29','15:50:00',10.89),('7643','2013-04-29','15:55:00',10.64),('7643','2013-04-29','16:00:00',10.41),('7643','2013-04-29','16:05:00',10.21),('7643','2013-04-29','16:10:00',10.01),('7643','2013-04-29','16:15:00',9.81),('7643','2013-04-29','16:20:00',9.55),('7643','2013-04-29','16:25:00',9.32),('7643','2013-04-29','16:30:00',9.16),('7643','2013-04-29','16:35:00',8.61),('7643','2013-04-29','16:40:00',7.36),('7643','2013-04-29','16:45:00',7.22),('7643','2013-04-29','16:50:00',7.01),('7643','2013-04-29','16:55:00',7.65),('7643','2013-04-29','17:00:00',7.14),('7643','2013-04-29','17:05:00',7.05),('7643','2013-04-29','17:10:00',6.01),('7643','2013-04-29','17:15:00',3.09),('7643','2013-04-29','17:20:00',4.77),('7643','2013-04-29','17:25:00',5.73),('7643','2013-04-29','17:30:00',5.51),('7643','2013-04-29','17:35:00',5.31),('7643','2013-04-29','17:40:00',4.99),('7643','2013-04-29','17:45:00',4.68),('7643','2013-04-29','17:50:00',4.36),('7643','2013-04-29','17:55:00',4.01),('7643','2013-04-29','18:00:00',3.74),('7643','2013-04-29','18:05:00',3.5),('7643','2013-04-29','18:10:00',3.26),('7643','2013-04-29','18:15:00',2.98),('7643','2013-04-29','18:20:00',2.72),('7643','2013-04-29','18:25:00',2.48),('7643','2013-04-29','18:30:00',2.25),('7643','2013-04-29','18:35:00',2.06),('7643','2013-04-29','18:40:00',1.85),('7643','2013-04-29','18:45:00',1.66),('7643','2013-04-29','18:50:00',1.48),('7643','2013-04-29','18:55:00',1.28),('7643','2013-04-29','19:00:00',1.1),('7643','2013-04-28','07:05:00',1.07),('7643','2013-04-28','07:10:00',1.55),('7643','2013-04-28','07:15:00',2.08),('7643','2013-04-28','07:20:00',2.57),('7643','2013-04-28','07:25:00',3),('7643','2013-04-28','07:30:00',3.15),('7643','2013-04-28','07:35:00',3.06),('7643','2013-04-28','07:40:00',2.82),('7643','2013-04-28','07:45:00',3.15),('7643','2013-04-28','07:50:00',3.35),('7643','2013-04-28','07:55:00',3.9),('7643','2013-04-28','08:00:00',4.58),('7643','2013-04-28','08:05:00',4.97),('7643','2013-04-28','08:10:00',4.8),('7643','2013-04-28','08:15:00',4.91),('7643','2013-04-28','08:20:00',5.27),('7643','2013-04-28','08:25:00',5.91),('7643','2013-04-28','08:30:00',6.73),('7643','2013-04-28','08:35:00',7.58),('7643','2013-04-28','08:40:00',7.67),('7643','2013-04-28','08:45:00',7.47),('7643','2013-04-28','08:50:00',8.02),('7643','2013-04-28','08:55:00',8.02),('7643','2013-04-28','09:00:00',6.21),('7643','2013-04-28','09:05:00',8.61),('7643','2013-04-28','09:10:00',9.47),('7643','2013-04-28','09:15:00',9.98),('7643','2013-04-28','09:20:00',9.36),('7643','2013-04-28','09:25:00',9.24),('7643','2013-04-28','09:30:00',9.1),('7643','2013-04-28','09:35:00',9.78),('7643','2013-04-28','09:40:00',9.96),('7643','2013-04-28','09:45:00',10.31),('7643','2013-04-28','09:50:00',10.92),('7643','2013-04-28','09:55:00',10.17),('7643','2013-04-28','10:00:00',10.62),('7643','2013-04-28','10:05:00',10.36),('7643','2013-04-28','10:10:00',10.38),('7643','2013-04-28','10:15:00',8.81),('7643','2013-04-28','10:20:00',8.61),('7643','2013-04-28','10:25:00',10.33),('7643','2013-04-28','10:30:00',10.38),('7643','2013-04-28','10:35:00',12.26),('7643','2013-04-28','10:40:00',12.39),('7643','2013-04-28','10:45:00',12.65),('7643','2013-04-28','10:50:00',12.04),('7643','2013-04-28','10:55:00',11.2),('7643','2013-04-28','11:00:00',12.66),('7643','2013-04-28','11:05:00',12.13),('7643','2013-04-28','11:10:00',12.04),('7643','2013-04-28','11:15:00',11.11),('7643','2013-04-28','11:20:00',12.86),('7643','2013-04-28','11:25:00',13.24),('7643','2013-04-28','11:30:00',13.99),('7643','2013-04-28','11:35:00',13.17),('7643','2013-04-28','11:40:00',13.34),('7643','2013-04-28','11:45:00',13.14),('7643','2013-04-28','11:50:00',14.47),('7643','2013-04-28','11:55:00',14.3),('7643','2013-04-28','12:00:00',14.92),('7643','2013-04-28','12:05:00',14.75),('7643','2013-04-28','12:10:00',14.26),('7643','2013-04-28','12:15:00',14.32),('7643','2013-04-28','12:20:00',14.48),('7643','2013-04-28','12:25:00',14.24),('7643','2013-04-28','12:30:00',14.63),('7643','2013-04-28','12:35:00',14.97),('7643','2013-04-28','12:40:00',15.21),('7643','2013-04-28','12:45:00',15.2),('7643','2013-04-28','12:50:00',15.03),('7643','2013-04-28','12:55:00',14.67),('7643','2013-04-28','13:00:00',14.99),('7643','2013-04-28','13:05:00',14.75),('7643','2013-04-28','13:10:00',14.55),('7643','2013-04-28','13:15:00',13.71),('7643','2013-04-28','13:20:00',14.66),('7643','2013-04-28','13:25:00',15.45),('7643','2013-04-28','13:30:00',15.09),('7643','2013-04-28','13:35:00',14.95),('7643','2013-04-28','13:40:00',14.8),('7643','2013-04-28','13:45:00',14.81),('7643','2013-04-28','13:50:00',14.45),('7643','2013-04-28','13:55:00',15.37),('7643','2013-04-28','14:00:00',14.39),('7643','2013-04-28','14:05:00',14.48),('7643','2013-04-28','14:10:00',14.53),('7643','2013-04-28','14:15:00',14.89),('7643','2013-04-28','14:20:00',14.79),('7643','2013-04-28','14:25:00',14.38),('7643','2013-04-28','14:30:00',13.73),('7643','2013-04-28','14:35:00',13.35),('7643','2013-04-28','14:40:00',12.69),('7643','2013-04-28','14:45:00',13.76),('7643','2013-04-28','14:50:00',13.22),('7643','2013-04-28','14:55:00',13.66),('7643','2013-04-28','15:00:00',13.16),('7643','2013-04-28','15:05:00',13.97),('7643','2013-04-28','15:10:00',12.98),('7643','2013-04-28','15:15:00',11.97),('7643','2013-04-28','15:20:00',12.66),('7643','2013-04-28','15:25:00',13.2),('7643','2013-04-28','15:30:00',12.83),('7643','2013-04-28','15:35:00',11.35),('7643','2013-04-28','15:40:00',10.24),('7643','2013-04-28','15:45:00',9.84),('7643','2013-04-28','15:50:00',10.17),('7643','2013-04-28','15:55:00',10.84),('7643','2013-04-28','16:00:00',10.57),('7643','2013-04-28','16:05:00',11.37),('7643','2013-04-28','16:10:00',10.51),('7643','2013-04-28','16:15:00',12.51),('7643','2013-04-28','16:20:00',11.96),('7643','2013-04-28','16:25:00',9.16),('7643','2013-04-28','16:30:00',9.63),('7643','2013-04-28','16:35:00',9.71),('7643','2013-04-28','16:40:00',10.19),('7643','2013-04-28','16:45:00',9.99),('7643','2013-04-28','16:50:00',10.22),('7643','2013-04-28','16:55:00',10.62),('7643','2013-04-28','17:00:00',9.68),('7643','2013-04-28','17:05:00',8.33),('7643','2013-04-28','17:10:00',8.59),('7643','2013-04-28','17:15:00',7.51),('7643','2013-04-28','17:20:00',6.26),('7643','2013-04-28','17:25:00',5.87),('7643','2013-04-28','17:30:00',5.64),('7643','2013-04-28','17:35:00',4.84),('7643','2013-04-28','17:40:00',4.01),('7643','2013-04-28','17:45:00',3.94),('7643','2013-04-28','17:50:00',4.7),('7643','2013-04-28','17:55:00',5.21),('7643','2013-04-28','18:00:00',5.03),('7643','2013-04-28','18:05:00',5.51),('7643','2013-04-28','18:10:00',4.92),('7643','2013-04-28','18:15:00',4.64),('7643','2013-04-28','18:20:00',3.85),('7643','2013-04-28','18:25:00',3.68),('7643','2013-04-28','18:30:00',3.34),('7643','2013-04-28','18:35:00',2.48),('7643','2013-04-28','18:40:00',2.11),('7643','2013-04-28','18:45:00',1.59),('7643','2013-04-28','18:50:00',1.06),('7643','2013-04-27','07:00:00',1.05),('7643','2013-04-27','07:05:00',1.26),('7643','2013-04-27','07:10:00',1.49),('7643','2013-04-27','07:15:00',1.74),('7643','2013-04-27','07:20:00',2),('7643','2013-04-27','07:25:00',2.25),('7643','2013-04-27','07:30:00',2.58),('7643','2013-04-27','07:35:00',2.92),('7643','2013-04-27','07:40:00',3.29),('7643','2013-04-27','07:45:00',3.69),('7643','2013-04-27','07:50:00',4.04),('7643','2013-04-27','07:55:00',4.35),('7643','2013-04-27','08:00:00',4.64),('7643','2013-04-27','08:05:00',5.12),('7643','2013-04-27','08:10:00',5.55),('7643','2013-04-27','08:15:00',5.85),('7643','2013-04-27','08:20:00',4.61),('7643','2013-04-27','08:40:00',4.2),('7643','2013-04-27','08:45:00',7.59),('7643','2013-04-27','09:40:00',10.86),('7643','2013-04-27','09:45:00',11.11),('7643','2013-04-27','09:50:00',11.37),('7643','2013-04-27','09:55:00',11.64),('7643','2013-04-27','10:00:00',11.89),('7643','2013-04-27','10:05:00',12.02),('7643','2013-04-27','10:10:00',12.14),('7643','2013-04-27','10:15:00',12.07),('7643','2013-04-27','10:20:00',12.54),('7643','2013-04-27','10:25:00',12.99),('7643','2013-04-27','10:30:00',12.88),('7643','2013-04-27','10:35:00',13.22),('7643','2013-04-27','10:40:00',12.06),('7643','2013-04-27','10:45:00',13.68),('7643','2013-04-27','10:50:00',13.66),('7643','2013-04-27','10:55:00',13.75),('7643','2013-04-27','11:00:00',13.86),('7643','2013-04-27','11:05:00',13.99),('7643','2013-04-27','11:10:00',14.34),('7643','2013-04-27','11:15:00',14.43),('7643','2013-04-27','11:20:00',14.29),('7643','2013-04-27','11:25:00',14.61),('7643','2013-04-27','11:30:00',14.69),('7643','2013-04-27','11:35:00',14.31),('7643','2013-04-27','11:40:00',14.58),('7643','2013-04-27','11:45:00',13.87),('7643','2013-04-27','11:50:00',14.15),('7643','2013-04-27','11:55:00',14.62),('7643','2013-04-27','12:00:00',13.09),('7643','2013-04-27','12:05:00',12.96),('7643','2013-04-27','12:10:00',14.48),('7643','2013-04-27','12:15:00',14.82),('7643','2013-04-27','12:20:00',14.62),('7643','2013-04-27','12:25:00',13.2),('7643','2013-04-27','12:30:00',12.29),('7643','2013-04-27','12:35:00',10.78),('7643','2013-04-27','12:40:00',11.44),('7643','2013-04-27','12:45:00',15.14),('7643','2013-04-27','12:50:00',15.37),('7643','2013-04-27','12:55:00',14.28),('7643','2013-04-27','13:00:00',14.63),('7643','2013-04-27','13:05:00',15.98),('7643','2013-04-27','13:10:00',15.36),('7643','2013-04-27','13:15:00',13.95),('7643','2013-04-27','13:20:00',14.57),('7643','2013-04-27','13:25:00',14.06),('7643','2013-04-27','13:30:00',15.32),('7643','2013-04-27','13:35:00',15.33),('7643','2013-04-27','13:40:00',16.34),('7643','2013-04-27','13:45:00',15.23),('7643','2013-04-27','13:50:00',12.23),('7643','2013-04-27','13:55:00',14.49),('7643','2013-04-27','14:00:00',15.72),('7643','2013-04-27','14:05:00',15.24),('7643','2013-04-27','14:10:00',14.5),('7643','2013-04-27','14:15:00',14.72),('7643','2013-04-27','14:20:00',14.66),('7643','2013-04-27','14:25:00',14.61),('7643','2013-04-27','14:30:00',14.45),('7643','2013-04-27','14:35:00',14.39),('7643','2013-04-27','14:40:00',14.15),('7643','2013-04-27','14:45:00',13.98),('7643','2013-04-27','14:50:00',13.87),('7643','2013-04-27','14:55:00',13.75),('7643','2013-04-27','15:00:00',13.67),('7643','2013-04-27','15:05:00',13.54),('7643','2013-04-27','15:10:00',13.4),('7643','2013-04-27','15:15:00',13.18),('7643','2013-04-27','15:20:00',12.94),('7643','2013-04-27','15:25:00',12.74),('7643','2013-04-27','15:30:00',12.59),('7643','2013-04-27','15:35:00',12.45),('7643','2013-04-27','15:40:00',12.36),('7643','2013-04-27','15:45:00',12.13),('7643','2013-04-27','15:50:00',11.91),('7643','2013-04-27','15:55:00',11.64),('7643','2013-04-27','16:00:00',11.42),('7643','2013-04-27','16:05:00',11.21),('7643','2013-04-27','16:10:00',10.96),('7643','2013-04-27','16:15:00',10.69),('7643','2013-04-27','16:20:00',10.43),('7643','2013-04-27','16:25:00',10.2),('7643','2013-04-27','16:30:00',9.98),('7643','2013-04-27','16:35:00',9.73),('7643','2013-04-27','16:40:00',9.43),('7643','2013-04-27','16:45:00',9.18),('7643','2013-04-27','16:50:00',8.93),('7643','2013-04-27','16:55:00',8.55),('7643','2013-04-27','17:00:00',8.3),('7643','2013-04-27','17:05:00',7.66),('7643','2013-04-27','17:10:00',7.32),('7643','2013-04-27','17:15:00',7.57),('7643','2013-04-27','17:20:00',7.15),('7643','2013-04-27','17:25:00',6.95),('7643','2013-04-27','17:30:00',5.94),('7643','2013-04-27','17:35:00',5.78),('7643','2013-04-27','17:40:00',5.39),('7643','2013-04-27','17:45:00',5.42),('7643','2013-04-27','17:50:00',5.17),('7643','2013-04-27','17:55:00',4.47),('7643','2013-04-27','18:00:00',4.33),('7643','2013-04-27','18:05:00',4.1),('7643','2013-04-27','18:10:00',2.83),('7643','2013-04-27','18:15:00',2.76),('7643','2013-04-27','18:20:00',3.27),('7643','2013-04-27','18:25:00',3.15),('7643','2013-04-27','18:30:00',2.54),('7643','2013-04-27','18:35:00',2.3),('7643','2013-04-27','18:40:00',2.12),('7643','2013-04-27','18:45:00',1.71),('7643','2013-04-27','18:50:00',1.64),('7643','2013-04-27','18:55:00',1.54),('7643','2013-04-27','19:00:00',1.46),('7643','2013-04-27','19:05:00',1.34),('7643','2013-04-27','19:10:00',1.22),('7643','2013-04-27','19:15:00',1.06),('7643','2013-04-26','07:30:00',1.12),('7643','2013-04-26','07:35:00',1.63),('7643','2013-04-26','07:40:00',1.67),('7643','2013-04-26','07:45:00',1.46),('7643','2013-04-26','07:50:00',1.42),('7643','2013-04-26','09:55:00',1.46),('7643','2013-04-26','10:00:00',1.33),('7643','2013-04-26','10:05:00',1.27),('7643','2013-04-26','10:10:00',1.09),('7643','2013-04-26','10:15:00',1.09),('7643','2013-04-26','10:20:00',1.13),('7643','2013-04-26','10:25:00',1.21),('7643','2013-04-26','10:40:00',1.12),('7643','2013-04-26','10:45:00',1.2),('7643','2013-04-26','10:50:00',1.09),('7643','2013-04-26','10:55:00',1.03),('7643','2013-04-26','11:00:00',1.09),('7643','2013-04-26','11:15:00',1.11),('7643','2013-04-26','11:20:00',1.03),('7643','2013-04-26','11:25:00',1.03),('7643','2013-04-26','11:30:00',1.15),('7643','2013-04-26','11:35:00',1.33),('7643','2013-04-26','11:40:00',1.57),('7643','2013-04-26','11:45:00',1.87),('7643','2013-04-26','11:50:00',2.16),('7643','2013-04-26','12:00:00',2.46),('7643','2013-04-26','12:05:00',2.41),('7643','2013-04-26','12:10:00',2.25),('7643','2013-04-26','12:15:00',2.11),('7643','2013-04-26','12:20:00',1.93),('7643','2013-04-26','12:25:00',1.91),('7643','2013-04-26','12:30:00',2.09),('7643','2013-04-26','12:35:00',2.32),('7643','2013-04-26','12:40:00',2.91),('7643','2013-04-26','12:45:00',3.15),('7643','2013-04-26','12:50:00',3.61),('7643','2013-04-26','12:55:00',4.78),('7643','2013-04-26','13:00:00',5.13),('7643','2013-04-26','13:05:00',3.9),('7643','2013-04-26','13:10:00',3.97),('7643','2013-04-26','13:15:00',5.07),('7643','2013-04-26','13:20:00',5.13),('7643','2013-04-26','13:25:00',3.99),('7643','2013-04-26','13:30:00',4.42),('7643','2013-04-26','13:35:00',5.38),('7643','2013-04-26','13:40:00',7.07),('7643','2013-04-26','13:45:00',4.28),('7643','2013-04-26','13:50:00',4),('7643','2013-04-26','13:55:00',3.04),('7643','2013-04-26','14:00:00',2.45),('7643','2013-04-26','14:05:00',2.86),('7643','2013-04-26','14:10:00',2.11),('7643','2013-04-26','14:15:00',2.03),('7643','2013-04-26','14:20:00',2.41),('7643','2013-04-26','14:25:00',5.18),('7643','2013-04-26','14:30:00',8.13),('7643','2013-04-26','14:35:00',6.52),('7643','2013-04-26','14:40:00',4.83),('7643','2013-04-26','14:45:00',4.56),('7643','2013-04-26','14:50:00',2.82),('7643','2013-04-26','14:55:00',3.59),('7643','2013-04-26','15:00:00',4.68),('7643','2013-04-26','15:05:00',7.88),('7643','2013-04-26','15:10:00',5.47),('7643','2013-04-26','15:15:00',4.61),('7643','2013-04-26','15:20:00',2.55),('7643','2013-04-26','15:25:00',2.29),('7643','2013-04-26','15:30:00',1.19),('7643','2013-04-26','15:35:00',1.31),('7643','2013-04-26','15:40:00',1.77),('7643','2013-04-26','15:45:00',1.5),('7643','2013-04-26','15:50:00',2.57),('7643','2013-04-26','16:30:00',2.23),('7643','2013-04-26','16:35:00',2.53),('7643','2013-04-26','16:40:00',3.46),('7643','2013-04-26','16:45:00',4.66),('7643','2013-04-26','16:55:00',9.26),('7643','2013-04-26','17:00:00',10),('7643','2013-04-26','17:05:00',5.36),('7643','2013-04-26','17:10:00',2.76),('7643','2013-04-26','17:15:00',1.96),('7643','2013-04-26','17:20:00',3.73),('7643','2013-04-26','17:25:00',2.45),('7643','2013-04-26','17:30:00',1.95),('7643','2013-04-26','17:35:00',2.67),('7643','2013-04-26','17:40:00',4.96),('7643','2013-04-26','17:50:00',2.1),('7643','2013-04-26','17:55:00',2.04),('7643','2013-04-26','18:00:00',2.11),('7643','2013-04-26','18:05:00',2.33),('7643','2013-04-26','18:10:00',1.94),('7643','2013-04-26','18:15:00',2.14),('7643','2013-04-26','18:20:00',1.81),('7643','2013-04-26','18:25:00',1.33),('7643','2013-04-26','18:30:00',1.12),('7643','2013-04-26','18:55:00',1.08),('7643','2013-04-25','06:50:00',1.11),('7643','2013-04-25','06:55:00',1.43),('7643','2013-04-25','07:00:00',1.7),('7643','2013-04-25','07:05:00',1.92),('7643','2013-04-25','07:10:00',2.11),('7643','2013-04-25','07:15:00',2.28),('7643','2013-04-25','07:20:00',2.32),('7643','2013-04-25','07:25:00',2.35),('7643','2013-04-25','07:30:00',2.34),('7643','2013-04-25','07:35:00',2.11),('7643','2013-04-25','07:40:00',2.06),('7643','2013-04-25','07:45:00',2.11),('7643','2013-04-25','07:50:00',2.45),('7643','2013-04-25','07:55:00',2.79),('7643','2013-04-25','08:00:00',3.08),('7643','2013-04-25','08:05:00',3.63),('7643','2013-04-25','08:10:00',4.72),('7643','2013-04-25','08:15:00',5.19),('7643','2013-04-25','08:20:00',5.41),('7643','2013-04-25','08:25:00',5.64),('7643','2013-04-25','08:30:00',5.86),('7643','2013-04-25','08:35:00',6.38),('7643','2013-04-25','08:40:00',6.65),('7643','2013-04-25','08:45:00',7.05),('7643','2013-04-25','08:50:00',7.11),('7643','2013-04-25','08:55:00',5.43),('7643','2013-04-25','09:00:00',6.45),('7643','2013-04-25','09:05:00',8.25),('7643','2013-04-25','09:10:00',6.98),('7643','2013-04-25','09:15:00',4.38),('7643','2013-04-25','09:20:00',4.38),('7643','2013-04-25','09:25:00',5.13),('7643','2013-04-25','09:30:00',6.01),('7643','2013-04-25','09:35:00',7.11),('7643','2013-04-25','09:40:00',7.9),('7643','2013-04-25','09:45:00',10.44),('7643','2013-04-25','09:50:00',9.75),('7643','2013-04-25','09:55:00',6.8),('7643','2013-04-25','10:00:00',7.58),('7643','2013-04-25','10:05:00',9.94),('7643','2013-04-25','10:10:00',11.74),('7643','2013-04-25','10:15:00',12.14),('7643','2013-04-25','10:20:00',11.74),('7643','2013-04-25','10:25:00',9.83),('7643','2013-04-25','10:30:00',13.15),('7643','2013-04-25','10:35:00',13.52),('7643','2013-04-25','10:40:00',13.13),('7643','2013-04-25','10:45:00',10.72),('7643','2013-04-25','10:50:00',8.85),('7643','2013-04-25','10:55:00',8.93),('7643','2013-04-25','11:00:00',11.89),('7643','2013-04-25','11:05:00',13.38),('7643','2013-04-25','11:10:00',12.13),('7643','2013-04-25','11:15:00',13.8),('7643','2013-04-25','11:20:00',10.27),('7643','2013-04-25','11:25:00',11.98),('7643','2013-04-25','11:30:00',12.02),('7643','2013-04-25','11:35:00',13.4),('7643','2013-04-25','11:40:00',12.48),('7643','2013-04-25','11:45:00',12.51),('7643','2013-04-25','11:50:00',9.82),('7643','2013-04-25','11:55:00',9.88),('7643','2013-04-25','12:00:00',11.03),('7643','2013-04-25','12:05:00',9.54),('7643','2013-04-25','12:10:00',8.74),('7643','2013-04-25','12:15:00',10.39),('7643','2013-04-25','12:20:00',9.55),('7643','2013-04-25','12:25:00',7.47),('7643','2013-04-25','12:30:00',6.74),('7643','2013-04-25','12:35:00',8.62),('7643','2013-04-25','12:40:00',13.08),('7643','2013-04-25','12:45:00',13.13),('7643','2013-04-25','12:50:00',7.9),('7643','2013-04-25','12:55:00',7.27),('7643','2013-04-25','13:00:00',5.27),('7643','2013-04-25','13:05:00',5.08),('7643','2013-04-25','13:10:00',6.15),('7643','2013-04-25','13:15:00',8.49),('7643','2013-04-25','13:20:00',6.24),('7643','2013-04-25','13:25:00',7.83),('7643','2013-04-25','13:30:00',9.9),('7643','2013-04-25','13:35:00',8.68),('7643','2013-04-25','13:40:00',10.08),('7643','2013-04-25','13:45:00',9.01),('7643','2013-04-25','13:50:00',9.56),('7643','2013-04-25','13:55:00',9.65),('7643','2013-04-25','14:00:00',10.32),('7643','2013-04-25','14:05:00',13.25),('7643','2013-04-25','14:10:00',13.77),('7643','2013-04-25','14:15:00',11.99),('7643','2013-04-25','14:20:00',13.56),('7643','2013-04-25','14:25:00',13.07),('7643','2013-04-25','14:30:00',15.11),('7643','2013-04-25','14:35:00',11.32),('7643','2013-04-25','14:40:00',6.36),('7643','2013-04-25','14:45:00',7.08),('7643','2013-04-25','14:50:00',14.99),('7643','2013-04-25','14:55:00',15.52),('7643','2013-04-25','15:00:00',14.22),('7643','2013-04-25','15:05:00',9.88),('7643','2013-04-25','15:10:00',5.05),('7643','2013-04-25','15:15:00',5.96),('7643','2013-04-25','15:20:00',5.43),('7643','2013-04-25','15:25:00',6.02),('7643','2013-04-25','15:30:00',8.52),('7643','2013-04-25','15:35:00',7),('7643','2013-04-25','15:40:00',7.13),('7643','2013-04-25','15:45:00',7.27),('7643','2013-04-25','15:50:00',6.83),('7643','2013-04-25','15:55:00',4.16),('7643','2013-04-25','16:00:00',2.13),('7643','2013-04-25','16:05:00',1.64),('7643','2013-04-25','16:10:00',1.32),('7643','2013-04-25','16:15:00',1.09),('7643','2013-04-25','16:20:00',1.28),('7643','2013-04-25','16:25:00',1.54),('7643','2013-04-25','16:30:00',1.77),('7643','2013-04-25','16:35:00',2.15),('7643','2013-04-25','16:40:00',2.06),('7643','2013-04-25','16:45:00',1.43),('7643','2013-04-25','17:00:00',1.02),('7643','2013-04-25','17:05:00',1.08),('7643','2013-04-24','07:10:00',1.08),('7643','2013-04-24','07:15:00',1.25),('7643','2013-04-24','07:20:00',1.4),('7643','2013-04-24','07:25:00',1.54),('7643','2013-04-24','07:30:00',1.7),('7643','2013-04-24','07:35:00',2.16),('7643','2013-04-24','07:40:00',2.32),('7643','2013-04-24','07:45:00',2.81),('7643','2013-04-24','07:50:00',2.72),('7643','2013-04-24','07:55:00',2.61),('7643','2013-04-24','08:00:00',2.98),('7643','2013-04-24','08:05:00',4.01),('7643','2013-04-24','08:10:00',4.2),('7643','2013-04-24','08:15:00',5.32),('7643','2013-04-24','08:20:00',4.51),('7643','2013-04-24','08:25:00',3.68),('7643','2013-04-24','08:30:00',3.86),('7643','2013-04-24','08:35:00',3.96),('7643','2013-04-24','08:40:00',4.11),('7643','2013-04-24','08:45:00',5.17),('7643','2013-04-24','08:50:00',8.23),('7643','2013-04-24','08:55:00',9.38),('7643','2013-04-24','09:00:00',7.86),('7643','2013-04-24','09:05:00',5.72),('7643','2013-04-24','09:10:00',5.3),('7643','2013-04-24','09:15:00',4.83),('7643','2013-04-24','09:20:00',5.07),('7643','2013-04-24','09:25:00',6.12),('7643','2013-04-24','09:30:00',5.39),('7643','2013-04-24','09:35:00',6.01),('7643','2013-04-24','09:40:00',8.25),('7643','2013-04-24','09:45:00',10.3),('7643','2013-04-24','09:50:00',12.04),('7643','2013-04-24','09:55:00',12.11),('7643','2013-04-24','10:00:00',12.27),('7643','2013-04-24','10:05:00',11.66),('7643','2013-04-24','10:10:00',10.82),('7643','2013-04-24','10:15:00',10.52),('7643','2013-04-24','10:20:00',12.48),('7643','2013-04-24','10:25:00',12.74),('7643','2013-04-24','10:30:00',13.32),('7643','2013-04-24','10:35:00',13.53),('7643','2013-04-24','10:40:00',13.53),('7643','2013-04-24','10:45:00',12.67),('7643','2013-04-24','10:50:00',12.88),('7643','2013-04-24','10:55:00',13.86),('7643','2013-04-24','11:00:00',14.37),('7643','2013-04-24','11:05:00',14.41),('7643','2013-04-24','11:10:00',14.6),('7643','2013-04-24','11:15:00',14.67),('7643','2013-04-24','11:20:00',14.77),('7643','2013-04-24','11:25:00',14.98),('7643','2013-04-24','11:30:00',15.16),('7643','2013-04-24','11:35:00',14.96),('7643','2013-04-24','11:40:00',15.27),('7643','2013-04-24','11:45:00',15.49),('7643','2013-04-24','11:50:00',15.64),('7643','2013-04-24','11:55:00',15.42),('7643','2013-04-24','12:00:00',15.24),('7643','2013-04-24','12:05:00',15.26),('7643','2013-04-24','12:10:00',15.55),('7643','2013-04-24','12:15:00',15.72),('7643','2013-04-24','12:20:00',15.76),('7643','2013-04-24','12:25:00',15.71),('7643','2013-04-24','12:30:00',15.84),('7643','2013-04-24','12:35:00',15.95),('7643','2013-04-24','12:40:00',15.89),('7643','2013-04-24','12:45:00',15.88),('7643','2013-04-24','12:50:00',15.76),('7643','2013-04-24','12:55:00',15.9),('7643','2013-04-24','13:00:00',16.08),('7643','2013-04-24','13:05:00',16.28),('7643','2013-04-24','13:10:00',16.14),('7643','2013-04-24','13:15:00',14.48),('7643','2013-04-24','13:20:00',13.55),('7643','2013-04-24','13:25:00',12.96),('7643','2013-04-24','13:30:00',10.67),('7643','2013-04-24','13:35:00',10.42),('7643','2013-04-24','13:40:00',9),('7643','2013-04-24','13:45:00',8.3),('7643','2013-04-24','13:50:00',7.78),('7643','2013-04-24','13:55:00',8.35),('7643','2013-04-24','14:00:00',8.46),('7643','2013-04-24','14:05:00',7.95),('7643','2013-04-24','14:10:00',8.59),('7643','2013-04-24','14:15:00',9.01),('7643','2013-04-24','14:20:00',9.25),('7643','2013-04-24','14:25:00',9.29),('7643','2013-04-24','14:30:00',10.85),('7643','2013-04-24','14:35:00',12.99),('7643','2013-04-24','14:40:00',13.37),('7643','2013-04-24','14:45:00',13.41),('7643','2013-04-24','14:50:00',12.19),('7643','2013-04-24','14:55:00',12.28),('7643','2013-04-24','15:00:00',12.2),('7643','2013-04-24','15:05:00',10.88),('7643','2013-04-24','15:10:00',11.02),('7643','2013-04-24','15:15:00',12.25),('7643','2013-04-24','15:20:00',12.91),('7643','2013-04-24','15:25:00',13.52),('7643','2013-04-24','15:30:00',13.24),('7643','2013-04-24','15:35:00',12.31),('7643','2013-04-24','15:40:00',11.76),('7643','2013-04-24','15:45:00',10.73),('7643','2013-04-24','15:50:00',10.1),('7643','2013-04-24','15:55:00',9.84),('7643','2013-04-24','16:00:00',9.91),('7643','2013-04-24','16:05:00',7.99),('7643','2013-04-24','16:10:00',8.67),('7643','2013-04-24','16:15:00',8.1),('7643','2013-04-24','16:20:00',8.3),('7643','2013-04-24','16:25:00',7.3),('7643','2013-04-24','16:30:00',7.1),('7643','2013-04-24','16:35:00',8.85),('7643','2013-04-24','16:40:00',7.93),('7643','2013-04-24','16:45:00',7.21),('7643','2013-04-24','16:50:00',6.5),('7643','2013-04-24','16:55:00',7.28),('7643','2013-04-24','17:00:00',6.57),('7643','2013-04-24','17:05:00',8.51),('7643','2013-04-24','17:10:00',8.96),('7643','2013-04-24','17:15:00',8.23),('7643','2013-04-24','17:20:00',7.88),('7643','2013-04-24','17:25:00',6.72),('7643','2013-04-24','17:30:00',5.07),('7643','2013-04-24','17:35:00',4.94),('7643','2013-04-24','17:40:00',5.14),('7643','2013-04-24','17:45:00',4.19),('7643','2013-04-24','17:50:00',3.56),('7643','2013-04-24','17:55:00',3.08),('7643','2013-04-24','18:00:00',3),('7643','2013-04-24','18:05:00',2.8),('7643','2013-04-24','18:10:00',2.6),('7643','2013-04-24','18:15:00',2.36),('7643','2013-04-24','18:20:00',2.14),('7643','2013-04-24','18:25:00',1.93),('7643','2013-04-24','18:30:00',1.75),('7643','2013-04-24','18:35:00',1.6),('7643','2013-04-24','18:40:00',1.47),('7643','2013-04-24','18:45:00',1.36),('7643','2013-04-24','18:50:00',1.24),('7643','2013-04-24','18:55:00',1.1),('7643','2013-04-23','07:15:00',1.08),('7643','2013-04-23','07:20:00',1.29),('7643','2013-04-23','07:25:00',1.44),('7643','2013-04-23','07:30:00',1.67),('7643','2013-04-23','07:35:00',2.15),('7643','2013-04-23','07:40:00',2.69),('7643','2013-04-23','07:45:00',3.17),('7643','2013-04-23','07:50:00',3.64),('7643','2013-04-23','07:55:00',4.04),('7643','2013-04-23','08:00:00',4.24),('7643','2013-04-23','08:05:00',4.47),('7643','2013-04-23','08:10:00',5.13),('7643','2013-04-23','08:15:00',5.87),('7643','2013-04-23','08:20:00',6.14),('7643','2013-04-23','08:25:00',6.64),('7643','2013-04-23','08:30:00',6.65),('7643','2013-04-23','08:35:00',6.42),('7643','2013-04-23','08:40:00',6.64),('7643','2013-04-23','08:45:00',6.87),('7643','2013-04-23','08:50:00',7.29),('7643','2013-04-23','08:55:00',7.52),('7643','2013-04-23','09:00:00',8.56),('7643','2013-04-23','09:05:00',8.88),('7643','2013-04-23','09:10:00',8.82),('7643','2013-04-23','09:15:00',9.01),('7643','2013-04-23','09:20:00',7.9),('7643','2013-04-23','09:25:00',9.73),('7643','2013-04-23','09:30:00',11.54),('7643','2013-04-23','09:35:00',11.22),('7643','2013-04-23','09:40:00',10.21),('7643','2013-04-23','09:45:00',9.74),('7643','2013-04-23','09:50:00',10.51),('7643','2013-04-23','09:55:00',11.99),('7643','2013-04-23','10:00:00',12.58),('7643','2013-04-23','10:05:00',12.91),('7643','2013-04-23','10:10:00',13.03),('7643','2013-04-23','10:15:00',13.13),('7643','2013-04-23','10:20:00',12.78),('7643','2013-04-23','10:25:00',12.56),('7643','2013-04-23','10:30:00',12.47),('7643','2013-04-23','10:35:00',12.52),('7643','2013-04-23','10:40:00',13.93),('7643','2013-04-23','10:45:00',14.11),('7643','2013-04-23','10:50:00',14.34),('7643','2013-04-23','10:55:00',14.82),('7643','2013-04-23','11:00:00',14.86),('7643','2013-04-23','11:05:00',14.41),('7643','2013-04-23','11:10:00',15.48),('7643','2013-04-23','11:15:00',15.74),('7643','2013-04-23','11:20:00',16.12),('7643','2013-04-23','11:25:00',16.44),('7643','2013-04-23','11:30:00',15.96),('7643','2013-04-23','11:35:00',12.9),('7643','2013-04-23','11:40:00',10.51),('7643','2013-04-23','11:45:00',10.98),('7643','2013-04-23','11:50:00',8.21),('7643','2013-04-23','11:55:00',12.03),('7643','2013-04-23','12:00:00',13.64),('7643','2013-04-23','12:05:00',8.89),('7643','2013-04-23','12:10:00',10.63),('7643','2013-04-23','12:15:00',15.65),('7643','2013-04-23','12:20:00',18),('7643','2013-04-23','12:25:00',15.56),('7643','2013-04-23','12:30:00',15.06),('7643','2013-04-23','12:35:00',15.68),('7643','2013-04-23','12:40:00',14.83),('7643','2013-04-23','12:45:00',14.87),('7643','2013-04-23','12:50:00',15.92),('7643','2013-04-23','12:55:00',15.52),('7643','2013-04-23','13:00:00',15.38),('7643','2013-04-23','13:05:00',13.41),('7643','2013-04-23','13:10:00',17.05),('7643','2013-04-23','13:15:00',16.13),('7643','2013-04-23','13:20:00',15.13),('7643','2013-04-23','13:25:00',15.59),('7643','2013-04-23','13:30:00',14.59),('7643','2013-04-23','13:35:00',15.73),('7643','2013-04-23','13:40:00',16.58),('7643','2013-04-23','13:45:00',15.06),('7643','2013-04-23','13:50:00',10.3),('7643','2013-04-23','13:55:00',16.26),('7643','2013-04-23','14:00:00',16.39),('7643','2013-04-23','14:05:00',11.34),('7643','2013-04-23','14:10:00',11.03),('7643','2013-04-23','14:15:00',16.1),('7643','2013-04-23','14:20:00',14.6),('7643','2013-04-23','14:25:00',15.07),('7643','2013-04-23','14:30:00',14.14),('7643','2013-04-23','14:35:00',12.71),('7643','2013-04-23','14:40:00',12.15),('7643','2013-04-23','14:45:00',11.74),('7643','2013-04-23','14:50:00',10.58),('7643','2013-04-23','14:55:00',9.13),('7643','2013-04-23','15:00:00',9.96),('7643','2013-04-23','15:05:00',9.02),('7643','2013-04-23','15:10:00',8.52),('7643','2013-04-23','15:15:00',8.98),('7643','2013-04-23','15:20:00',9.5),('7643','2013-04-23','15:25:00',8.07),('7643','2013-04-23','15:30:00',6.7),('7643','2013-04-23','15:35:00',6.55),('7643','2013-04-23','15:40:00',6.38),('7643','2013-04-23','15:45:00',6.44),('7643','2013-04-23','15:50:00',6.56),('7643','2013-04-23','15:55:00',8.09),('7643','2013-04-23','16:00:00',10.54),('7643','2013-04-23','16:05:00',10.65),('7643','2013-04-23','16:10:00',10.68),('7643','2013-04-23','16:15:00',9.52),('7643','2013-04-23','16:20:00',12.36),('7643','2013-04-23','16:25:00',9.56),('7643','2013-04-23','16:30:00',8.46),('7643','2013-04-23','16:35:00',6.96),('7643','2013-04-23','16:40:00',9.48),('7643','2013-04-23','16:45:00',9.9),('7643','2013-04-23','16:50:00',8.7),('7643','2013-04-23','16:55:00',10.26),('7643','2013-04-23','17:00:00',10.5),('7643','2013-04-23','17:05:00',9.74),('7643','2013-04-23','17:10:00',9.2),('7643','2013-04-23','17:15:00',7.12),('7643','2013-04-23','17:20:00',6.36),('7643','2013-04-23','17:25:00',6.04),('7643','2013-04-23','17:30:00',3.62),('7643','2013-04-23','17:35:00',3.14),('7643','2013-04-23','17:40:00',2.53),('7643','2013-04-23','17:45:00',3.27),('7643','2013-04-23','17:50:00',3.84),('7643','2013-04-23','17:55:00',5.04),('7643','2013-04-23','18:00:00',4.08),('7643','2013-04-23','18:05:00',3.97),('7643','2013-04-23','18:10:00',3.42),('7643','2013-04-23','18:15:00',2.33),('7643','2013-04-23','18:20:00',3.3),('7643','2013-04-23','18:25:00',3.01),('7643','2013-04-23','18:30:00',2.12),('7643','2013-04-23','18:35:00',1.5),('7643','2013-04-23','18:40:00',1.52),('7643','2013-04-23','18:45:00',1.31),('7643','2013-04-23','18:50:00',1.24),('7643','2013-04-23','18:55:00',1.09),('7643','2013-04-22','07:05:00',1.05),('7643','2013-04-22','07:10:00',1.31),('7643','2013-04-22','07:15:00',1.57),('7643','2013-04-22','07:20:00',1.89),('7643','2013-04-22','07:25:00',2.2),('7643','2013-04-22','07:30:00',2.5),('7643','2013-04-22','07:35:00',2.87),('7643','2013-04-22','07:40:00',3.25),('7643','2013-04-22','07:45:00',3.61),('7643','2013-04-22','07:50:00',4.02),('7643','2013-04-22','07:55:00',4.43),('7643','2013-04-22','08:00:00',4.88),('7643','2013-04-22','08:05:00',5.26),('7643','2013-04-22','08:10:00',5.65),('7643','2013-04-22','08:15:00',6.1),('7643','2013-04-22','08:20:00',6.5),('7643','2013-04-22','08:25:00',6.85),('7643','2013-04-22','08:30:00',7.23),('7643','2013-04-22','08:35:00',7.64),('7643','2013-04-22','08:40:00',7.97),('7643','2013-04-22','08:45:00',8.3),('7643','2013-04-22','08:50:00',8.63),('7643','2013-04-22','08:55:00',8.96),('7643','2013-04-22','09:00:00',9.3),('7643','2013-04-22','09:05:00',9.66),('7643','2013-04-22','09:10:00',10),('7643','2013-04-22','09:15:00',10.4),('7643','2013-04-22','09:20:00',10.7),('7643','2013-04-22','09:25:00',10.96),('7643','2013-04-22','09:30:00',11.22),('7643','2013-04-22','09:35:00',11.53),('7643','2013-04-22','09:40:00',10.67),('7643','2013-04-22','09:45:00',10.63),('7643','2013-04-22','09:50:00',12.51),('7643','2013-04-22','09:55:00',12.69),('7643','2013-04-22','10:00:00',12.8),('7643','2013-04-22','10:05:00',12.87),('7643','2013-04-22','10:10:00',13.11),('7643','2013-04-22','10:15:00',13.34),('7643','2013-04-22','10:20:00',13.6),('7643','2013-04-22','10:25:00',13.78),('7643','2013-04-22','10:30:00',13.93),('7643','2013-04-22','10:35:00',14.18),('7643','2013-04-22','10:40:00',14.43),('7643','2013-04-22','10:45:00',14.34),('7643','2013-04-22','10:50:00',14.44),('7643','2013-04-22','10:55:00',14.67),('7643','2013-04-22','11:00:00',14.74),('7643','2013-04-22','11:05:00',14.89),('7643','2013-04-22','11:10:00',15.09),('7643','2013-04-22','11:15:00',15.22),('7643','2013-04-22','11:20:00',15.28),('7643','2013-04-22','11:25:00',15.48),('7643','2013-04-22','11:30:00',15.61),('7643','2013-04-22','11:35:00',15.69),('7643','2013-04-22','11:40:00',15.69),('7643','2013-04-22','11:45:00',15.76),('7643','2013-04-22','11:50:00',15.87),('7643','2013-04-22','11:55:00',15.88),('7643','2013-04-22','12:00:00',15.88),('7643','2013-04-22','12:05:00',15.73),('7643','2013-04-22','12:10:00',15.99),('7643','2013-04-22','12:15:00',15.98),('7643','2013-04-22','12:20:00',16.01),('7643','2013-04-22','12:25:00',16.05),('7643','2013-04-22','12:30:00',10.73),('7643','2013-04-22','12:35:00',17.53),('7643','2013-04-22','12:40:00',13.08),('7643','2013-04-22','12:45:00',6.01),('7643','2013-04-22','12:50:00',12.25),('7643','2013-04-22','12:55:00',8.36),('7643','2013-04-22','13:00:00',11.51),('7643','2013-04-22','13:05:00',7.39),('7643','2013-04-22','13:10:00',5.77),('7643','2013-04-22','13:15:00',17.31),('7643','2013-04-22','13:20:00',17.73),('7643','2013-04-22','13:25:00',17.5),('7643','2013-04-22','13:30:00',16.95),('7643','2013-04-22','13:35:00',17.12),('7643','2013-04-22','13:40:00',16.85),('7643','2013-04-22','13:45:00',11.85),('7643','2013-04-22','13:50:00',15.14),('7643','2013-04-22','13:55:00',14.48),('7643','2013-04-22','14:00:00',6.71),('7643','2013-04-22','14:05:00',17.8),('7643','2013-04-22','14:10:00',10.8),('7643','2013-04-22','14:15:00',15.38),('7643','2013-04-22','14:20:00',14.97),('7643','2013-04-22','14:25:00',13.97),('7643','2013-04-22','14:30:00',15.89),('7643','2013-04-22','14:35:00',15.97),('7643','2013-04-22','14:40:00',15.8),('7643','2013-04-22','14:45:00',12.74),('7643','2013-04-22','14:50:00',7.99),('7643','2013-04-22','14:55:00',8.95),('7643','2013-04-22','15:00:00',8.5),('7643','2013-04-22','15:05:00',9.44),('7643','2013-04-22','15:10:00',11.3),('7643','2013-04-22','15:15:00',11.35),('7643','2013-04-22','15:20:00',10.36),('7643','2013-04-22','15:25:00',9.52),('7643','2013-04-22','15:30:00',9.22),('7643','2013-04-22','15:35:00',9.08),('7643','2013-04-22','15:40:00',8.56),('7643','2013-04-22','15:45:00',8.62),('7643','2013-04-22','15:50:00',7.03),('7643','2013-04-22','15:55:00',6.15),('7643','2013-04-22','16:00:00',6.81),('7643','2013-04-22','16:05:00',6.62),('7643','2013-04-22','16:10:00',6.37),('7643','2013-04-22','16:15:00',5.94),('7643','2013-04-22','16:20:00',4.6),('7643','2013-04-22','16:25:00',4.57),('7643','2013-04-22','16:30:00',4.18),('7643','2013-04-22','16:35:00',4.22),('7643','2013-04-22','16:40:00',4.45),('7643','2013-04-22','16:45:00',4.33),('7643','2013-04-22','16:50:00',3.81),('7643','2013-04-22','16:55:00',4.14),('7643','2013-04-22','17:00:00',3.9),('7643','2013-04-22','17:05:00',4.13),('7643','2013-04-22','17:10:00',5.72),('7643','2013-04-22','17:15:00',8.73),('7643','2013-04-22','17:20:00',5.48),('7643','2013-04-22','17:25:00',7.28),('7643','2013-04-22','17:30:00',5.64),('7643','2013-04-22','17:35:00',5.17),('7643','2013-04-22','17:40:00',5),('7643','2013-04-22','17:45:00',4.32),('7643','2013-04-22','17:50:00',4.08),('7643','2013-04-22','17:55:00',2.38),('7643','2013-04-22','18:00:00',2.79),('7643','2013-04-22','18:05:00',2.34),('7643','2013-04-22','18:10:00',1.93),('7643','2013-04-22','18:15:00',1.87),('7643','2013-04-22','18:20:00',1.62),('7643','2013-04-22','18:25:00',1.72),('7643','2013-04-22','18:30:00',1.73),('7643','2013-04-22','18:35:00',1.74),('7643','2013-04-22','18:40:00',1.72),('7643','2013-04-22','18:45:00',1.27),('7643','2013-04-22','18:50:00',1.15),('7643','2013-04-22','18:55:00',1.14),('7643','2013-04-21','08:40:00',1.54),('7643','2013-04-21','08:45:00',2.07),('7643','2013-04-21','08:50:00',1.37),('7643','2013-04-21','08:55:00',1.26),('7643','2013-04-21','09:00:00',2.35),('7643','2013-04-21','09:05:00',2.42),('7643','2013-04-21','09:10:00',2.64),('7643','2013-04-21','09:15:00',2.46),('7643','2013-04-21','09:20:00',2.48),('7643','2013-04-21','09:25:00',2.88),('7643','2013-04-21','09:30:00',4.06),('7643','2013-04-21','09:35:00',3.7),('7643','2013-04-21','09:40:00',2.84),('7643','2013-04-21','09:45:00',2.07),('7643','2013-04-21','10:30:00',1.95),('7643','2013-04-21','10:35:00',8.49),('7643','2013-04-21','10:40:00',14.88),('7643','2013-04-21','10:45:00',18.73),('7643','2013-04-21','10:50:00',8.42),('7643','2013-04-21','10:55:00',8.5),('7643','2013-04-21','11:00:00',7.7),('7643','2013-04-21','11:05:00',7.31),('7643','2013-04-21','11:10:00',8.84),('7643','2013-04-21','11:15:00',5.4),('7643','2013-04-21','11:20:00',5.56),('7643','2013-04-21','11:25:00',7.29),('7643','2013-04-21','11:30:00',11.53),('7643','2013-04-21','11:35:00',14.22),('7643','2013-04-21','11:40:00',13.36),('7643','2013-04-21','11:45:00',7.67),('7643','2013-04-21','11:50:00',6.7),('7643','2013-04-21','11:55:00',15.3),('7643','2013-04-21','12:00:00',14.46),('7643','2013-04-21','12:05:00',10.99),('7643','2013-04-21','12:10:00',18.33),('7643','2013-04-21','12:15:00',13.47),('7643','2013-04-21','12:20:00',13.78),('7643','2013-04-21','12:25:00',8.94),('7643','2013-04-21','12:30:00',10),('7643','2013-04-21','12:35:00',12.07),('7643','2013-04-21','12:40:00',17.58),('7643','2013-04-21','12:45:00',17.52),('7643','2013-04-21','12:50:00',18),('7643','2013-04-21','12:55:00',18.03),('7643','2013-04-21','13:00:00',17.91),('7643','2013-04-21','13:05:00',13.77),('7643','2013-04-21','13:10:00',17.06),('7643','2013-04-21','13:15:00',16.53),('7643','2013-04-21','13:20:00',14.47),('7643','2013-04-21','13:25:00',7.53),('7643','2013-04-21','13:30:00',10.17),('7643','2013-04-21','13:35:00',8.73),('7643','2013-04-21','13:40:00',9.91),('7643','2013-04-21','13:45:00',14.27),('7643','2013-04-21','13:50:00',4.26),('7643','2013-04-21','13:55:00',6.26),('7643','2013-04-21','14:00:00',4.52),('7643','2013-04-21','14:05:00',5.28),('7643','2013-04-21','14:10:00',4.68),('7643','2013-04-21','14:15:00',4.43),('7643','2013-04-21','14:20:00',19.79),('7643','2013-04-21','14:25:00',14.43),('7643','2013-04-21','14:30:00',18.91),('7643','2013-04-21','14:35:00',12.44),('7643','2013-04-21','14:40:00',18.03),('7643','2013-04-21','14:45:00',17.42),('7643','2013-04-21','14:50:00',17.57),('7643','2013-04-21','14:55:00',15.58),('7643','2013-04-21','15:00:00',15.77),('7643','2013-04-21','15:05:00',16.31),('7643','2013-04-21','15:10:00',5.61),('7643','2013-04-21','15:15:00',3.19),('7643','2013-04-21','15:20:00',4.18),('7643','2013-04-21','15:25:00',8.73),('7643','2013-04-21','15:30:00',7.49),('7643','2013-04-21','15:35:00',3.75),('7643','2013-04-21','15:40:00',8.53),('7643','2013-04-21','15:45:00',13.17),('7643','2013-04-21','15:50:00',9.24),('7643','2013-04-21','15:55:00',4.5),('7643','2013-04-21','16:00:00',3.03),('7643','2013-04-21','16:05:00',2.8),('7643','2013-04-21','16:10:00',2.74),('7643','2013-04-21','16:15:00',2.87),('7643','2013-04-21','16:20:00',2.55),('7643','2013-04-21','16:25:00',1.52),('7643','2013-04-21','16:30:00',2.01),('7643','2013-04-21','16:35:00',2.57),('7643','2013-04-21','16:40:00',4.38),('7643','2013-04-21','16:45:00',5.03),('7643','2013-04-21','16:50:00',3.04),('7643','2013-04-21','16:55:00',1.81),('7643','2013-04-21','17:00:00',1.74),('7643','2013-04-21','17:05:00',1.97),('7643','2013-04-21','17:10:00',1.82),('7643','2013-04-21','17:15:00',1.1),('7643','2013-04-21','17:20:00',1.3),('7643','2013-04-21','17:25:00',2.12),('7643','2013-04-21','17:30:00',3.16),('7643','2013-04-21','17:35:00',3.48),('7643','2013-04-21','17:40:00',2.55),('7643','2013-04-21','17:45:00',1.67),('7643','2013-04-21','17:50:00',1.39),('7643','2013-04-21','17:55:00',1.09),('7643','2013-04-21','18:00:00',1.13),('7643','2013-04-21','18:05:00',1.63),('7643','2013-04-21','18:10:00',2.27),('7643','2013-04-21','18:15:00',1.84),('7643','2013-04-21','18:20:00',2.74),('7643','2013-04-21','18:25:00',2.46),('7643','2013-04-21','18:30:00',1.57),('7643','2013-04-21','18:35:00',1.48),('7643','2013-04-21','18:40:00',1.27),('7643','2013-04-21','18:45:00',1.33),('7643','2013-04-21','18:50:00',1.96),('7643','2013-04-21','18:55:00',1.67),('7643','2013-04-21','19:00:00',1.46),('7643','2013-04-21','19:05:00',1.1),('7643','2014-03-28','06:40:00',1.22),('7643','2014-03-28','06:45:00',1.54),('7643','2014-03-28','06:50:00',1.84),('7643','2014-03-28','06:55:00',2.12),('7643','2014-03-28','07:00:00',2.48),('7643','2014-03-28','07:05:00',2.9),('7643','2014-03-28','07:10:00',3.32),('7643','2014-03-28','07:15:00',3.75),('7643','2014-03-28','07:20:00',4.1),('7643','2014-03-28','07:25:00',4.42),('7643','2014-03-28','07:30:00',4.81),('7643','2014-03-28','07:35:00',5.19),('7643','2014-03-28','07:40:00',5.67),('7643','2014-03-28','07:45:00',6.03),('7643','2014-03-28','07:50:00',6.48),('7643','2014-03-28','07:55:00',6.81),('7643','2014-03-28','08:00:00',7.18),('7643','2014-03-28','08:05:00',7.59),('7643','2014-03-28','08:10:00',7.97),('7643','2014-03-28','08:15:00',8.28),('7643','2014-03-28','08:20:00',8.61),('7643','2014-03-28','08:25:00',8.94),('7643','2014-03-28','08:30:00',9.19),('7643','2014-03-28','08:35:00',9.49),('7643','2014-03-28','08:40:00',9.76),('7643','2014-03-28','08:45:00',10.04),('7643','2014-03-28','08:50:00',10.32),('7643','2014-03-28','08:55:00',10.46),('7643','2014-03-28','09:00:00',10.72),('7643','2014-03-28','09:05:00',11.09),('7643','2014-03-28','09:10:00',11.42),('7643','2014-03-28','09:15:00',11.68),('7643','2014-03-28','09:20:00',11.92),('7643','2014-03-28','09:25:00',12.18),('7643','2014-03-28','09:30:00',12.36),('7643','2014-03-28','09:35:00',12.7),('7643','2014-03-28','09:40:00',12.99),('7643','2014-03-28','09:45:00',13.1),('7643','2014-03-28','09:50:00',13.41),('7643','2014-03-28','09:55:00',13.64),('7643','2014-03-28','10:00:00',13.8),('7643','2014-03-28','10:05:00',14.04),('7643','2014-03-28','10:10:00',14.29),('7643','2014-03-28','10:15:00',14.54),('7643','2014-03-28','10:20:00',14.64),('7643','2014-03-28','10:25:00',14.8),('7643','2014-03-28','10:30:00',14.82),('7643','2014-03-28','10:35:00',14.86),('7643','2014-03-28','10:40:00',15),('7643','2014-03-28','10:45:00',15.13),('7643','2014-03-28','10:50:00',15.45),('7643','2014-03-28','10:55:00',15.63),('7643','2014-03-28','11:00:00',15.59),('7643','2014-03-28','11:05:00',15.72),('7643','2014-03-28','11:10:00',15.76),('7643','2014-03-28','11:15:00',16.02),('7643','2014-03-28','11:20:00',16.03),('7643','2014-03-28','11:25:00',16.03),('7643','2014-03-28','11:30:00',15.94),('7643','2014-03-28','11:35:00',16.04),('7643','2014-03-28','11:40:00',15.64),('7643','2014-03-28','11:45:00',16.29),('7643','2014-03-28','11:50:00',16.22),('7643','2014-03-28','11:55:00',16.1),('7643','2014-03-28','12:00:00',16.22),('7643','2014-03-28','12:05:00',16.25),('7643','2014-03-28','12:10:00',16.15),('7643','2014-03-28','12:15:00',16.15),('7643','2014-03-28','12:20:00',16.24),('7643','2014-03-28','12:25:00',16.23),('7643','2014-03-28','12:30:00',16.33),('7643','2014-03-28','12:35:00',16.29),('7643','2014-03-28','12:40:00',16.08),('7643','2014-03-28','12:45:00',16.19),('7643','2014-03-28','12:50:00',16.05),('7643','2014-03-28','12:55:00',15.98),('7643','2014-03-28','13:00:00',15.92),('7643','2014-03-28','13:05:00',15.82),('7643','2014-03-28','13:10:00',15.67),('7643','2014-03-28','13:15:00',15.46),('7643','2014-03-28','13:20:00',15.43),('7643','2014-03-28','13:25:00',15.13),('7643','2014-03-28','13:30:00',15.01),('7643','2014-03-28','13:35:00',14.74),('7643','2014-03-28','13:40:00',14.59),('7643','2014-03-28','13:45:00',14.37),('7643','2014-03-28','13:50:00',14.29),('7643','2014-03-28','13:55:00',14.17),('7643','2014-03-28','14:00:00',14.01),('7643','2014-03-28','14:05:00',13.84),('7643','2014-03-28','14:10:00',13.84),('7643','2014-03-28','14:15:00',13.46),('7643','2014-03-28','14:20:00',11.94),('7643','2014-03-28','14:25:00',13.28),('7643','2014-03-28','14:30:00',12.74),('7643','2014-03-28','14:35:00',12.07),('7643','2014-03-28','14:40:00',12.01),('7643','2014-03-28','14:45:00',11.97),('7643','2014-03-28','14:50:00',11.81),('7643','2014-03-28','14:55:00',11.96),('7643','2014-03-28','15:00:00',11.69),('7643','2014-03-28','15:05:00',11.3),('7643','2014-03-28','15:10:00',10.7),('7643','2014-03-28','15:15:00',10.78),('7643','2014-03-28','15:20:00',10.59),('7643','2014-03-28','15:25:00',10.22),('7643','2014-03-28','15:30:00',9.6),('7643','2014-03-28','15:35:00',9.17),('7643','2014-03-28','15:40:00',9.04),('7643','2014-03-28','15:45:00',8.84),('7643','2014-03-28','15:50:00',8.5),('7643','2014-03-28','15:55:00',8.26),('7643','2014-03-28','16:00:00',7.95),('7643','2014-03-28','16:05:00',7.58),('7643','2014-03-28','16:10:00',7.19),('7643','2014-03-28','16:15:00',6.91),('7643','2014-03-28','16:20:00',6.24),('7643','2014-03-28','16:25:00',6.07),('7643','2014-03-28','16:30:00',5.75),('7643','2014-03-28','16:35:00',5.22),('7643','2014-03-28','16:40:00',4.59),('7643','2014-03-28','16:45:00',3.54),('7643','2014-03-28','16:50:00',3.84),('7643','2014-03-28','16:55:00',3.96),('7643','2014-03-28','17:00:00',3.63),('7643','2014-03-28','17:05:00',3.24),('7643','2014-03-28','17:10:00',2.93),('7643','2014-03-28','17:15:00',2.6),('7643','2014-03-28','17:20:00',2.23),('7643','2014-03-28','17:25:00',1.91),('7643','2014-03-28','17:30:00',1.59),('7643','2014-03-28','17:35:00',1.29),('7643','2013-04-20','07:30:00',1.01),('7643','2013-04-20','07:35:00',1.27),('7643','2013-04-20','07:40:00',1.33),('7643','2013-04-20','07:45:00',1.47),('7643','2013-04-20','07:50:00',1.71),('7643','2013-04-20','07:55:00',2.52),('7643','2013-04-20','08:00:00',2.79),('7643','2013-04-20','08:05:00',3.26),('7643','2013-04-20','08:10:00',3.74),('7643','2013-04-20','08:15:00',4.4),('7643','2013-04-20','08:20:00',3.46),('7643','2013-04-20','08:25:00',3.96),('7643','2013-04-20','08:30:00',3.44),('7643','2013-04-20','08:35:00',4.28),('7643','2013-04-20','08:40:00',4.86),('7643','2013-04-20','08:45:00',4.98),('7643','2013-04-20','08:50:00',4.69),('7643','2013-04-20','08:55:00',6.86),('7643','2013-04-20','09:00:00',5.31),('7643','2013-04-20','09:05:00',5.92),('7643','2013-04-20','09:10:00',9.17),('7643','2013-04-20','09:15:00',8.88),('7643','2013-04-20','09:20:00',5.25),('7643','2013-04-20','09:25:00',6.13),('7643','2013-04-20','09:30:00',10.79),('7643','2013-04-20','09:35:00',11.1),('7643','2013-04-20','09:40:00',10.78),('7643','2013-04-20','09:45:00',11.93),('7643','2013-04-20','09:50:00',13.21),('7643','2013-04-20','09:55:00',10.59),('7643','2013-04-20','10:00:00',9.99),('7643','2013-04-20','10:05:00',8.83),('7643','2013-04-20','10:10:00',7.57),('7643','2013-04-20','10:15:00',6.59),('7643','2013-04-20','10:20:00',11.02),('7643','2013-04-20','10:25:00',10.62),('7643','2013-04-20','10:30:00',11.54),('7643','2013-04-20','10:35:00',8.38),('7643','2013-04-20','10:40:00',11.5),('7643','2013-04-20','10:45:00',9.89),('7643','2013-04-20','10:50:00',12.87),('7643','2013-04-20','10:55:00',12.07),('7643','2013-04-20','11:35:00',10.62),('7643','2013-04-20','11:40:00',13.8),('7643','2013-04-20','11:45:00',14.6),('7643','2013-04-20','11:50:00',12.68),('7643','2013-04-20','11:55:00',11.27),('7643','2013-04-20','12:00:00',9.2),('7643','2013-04-20','12:05:00',8.64),('7643','2013-04-20','12:10:00',8.41),('7643','2013-04-20','12:15:00',7.91),('7643','2013-04-20','12:20:00',7.28),('7643','2013-04-20','12:25:00',7),('7643','2013-04-20','12:30:00',7.73),('7643','2013-04-20','12:35:00',7.78),('7643','2013-04-20','12:40:00',8.11),('7643','2013-04-20','12:45:00',7.92),('7643','2013-04-20','12:50:00',7.31),('7643','2013-04-20','12:55:00',7.25),('7643','2013-04-20','13:00:00',8.33),('7643','2013-04-20','13:05:00',9.95),('7643','2013-04-20','13:10:00',9.69),('7643','2013-04-20','13:15:00',9.1),('7643','2013-04-20','13:20:00',8.44),('7643','2013-04-20','13:25:00',8.1),('7643','2013-04-20','13:30:00',13.22),('7643','2013-04-20','13:35:00',13.22),('7643','2013-04-20','13:40:00',10.91),('7643','2013-04-20','13:45:00',10.87),('7643','2013-04-20','13:50:00',8.77),('7643','2013-04-20','13:55:00',15.21),('7643','2013-04-20','14:00:00',16.55),('7643','2013-04-20','14:05:00',16.05),('7643','2013-04-20','14:10:00',16),('7643','2013-04-20','14:15:00',14.11),('7643','2013-04-20','14:20:00',18.04),('7643','2013-04-20','14:25:00',14.41),('7643','2013-04-20','14:30:00',14.17),('7643','2013-04-20','14:35:00',15.22),('7643','2013-04-20','14:40:00',16.71),('7643','2013-04-20','14:45:00',12.69),('7643','2013-04-20','14:50:00',8.02),('7643','2013-04-20','14:55:00',7.08),('7643','2013-04-20','15:00:00',11.64),('7643','2013-04-20','15:05:00',16),('7643','2013-04-20','15:10:00',15.25),('7643','2013-04-20','15:15:00',11.88),('7643','2013-04-20','15:20:00',7.71),('7643','2013-04-20','15:25:00',6.9),('7643','2013-04-20','15:30:00',5.99),('7643','2013-04-20','15:35:00',5.04),('7643','2013-04-20','15:40:00',5.21),('7643','2013-04-20','15:45:00',4.32),('7643','2013-04-20','15:50:00',3.74),('7643','2013-04-20','15:55:00',3.4),('7643','2013-04-20','16:00:00',3.02),('7643','2013-04-20','16:05:00',2.66),('7643','2013-04-20','16:10:00',2.55),('7643','2013-04-20','16:15:00',2.63),('7643','2013-04-20','16:20:00',2.14),('7643','2013-04-20','16:25:00',1.65),('7643','2013-04-20','16:30:00',1.68),('7643','2013-04-20','16:35:00',2.13),('7643','2013-04-20','16:40:00',2.05),('7643','2013-04-20','16:45:00',1.64),('7643','2013-04-20','16:50:00',1.83),('7643','2013-04-20','16:55:00',2.59),('7643','2013-04-20','17:00:00',3.18),('7643','2013-04-20','17:05:00',3.17),('7643','2013-04-20','17:10:00',2.65),('7643','2013-04-20','17:15:00',2.62),('7643','2013-04-20','17:20:00',2.29),('7643','2013-04-20','17:25:00',2.05),('7643','2013-04-20','17:30:00',1.79),('7643','2013-04-20','17:35:00',1.7),('7643','2013-04-20','17:40:00',1.77),('7643','2013-04-20','17:45:00',1.97),('7643','2013-04-20','17:50:00',1.65),('7643','2013-04-20','17:55:00',1.8),('7643','2013-04-20','18:00:00',1.59),('7643','2013-04-20','18:05:00',1.31),('7643','2013-04-20','18:10:00',1.11),('7643','2013-04-20','18:15:00',1.25),('7643','2013-04-20','18:20:00',1.15),('7643','2013-04-19','07:10:00',1.18),('7643','2013-04-19','07:15:00',1.44),('7643','2013-04-19','07:20:00',1.45),('7643','2013-04-19','07:25:00',1.94),('7643','2013-04-19','07:30:00',2.43),('7643','2013-04-19','07:35:00',3.12),('7643','2013-04-19','07:40:00',3.39),('7643','2013-04-19','07:45:00',2.73),('7643','2013-04-19','07:50:00',2.77),('7643','2013-04-19','07:55:00',3.55),('7643','2013-04-19','08:00:00',3.98),('7643','2013-04-19','08:05:00',4.37),('7643','2013-04-19','08:10:00',4.84),('7643','2013-04-19','08:15:00',4.48),('7643','2013-04-19','08:20:00',4.29),('7643','2013-04-19','08:25:00',4.71),('7643','2013-04-19','08:30:00',5.26),('7643','2013-04-19','08:35:00',5.83),('7643','2013-04-19','08:40:00',6.53),('7643','2013-04-19','08:45:00',6.65),('7643','2013-04-19','08:50:00',6.63),('7643','2013-04-19','08:55:00',6.39),('7643','2013-04-19','09:00:00',8.02),('7643','2013-04-19','09:05:00',8.28),('7643','2013-04-19','09:10:00',7.68),('7643','2013-04-19','09:15:00',6.55),('7643','2013-04-19','09:20:00',9.15),('7643','2013-04-19','09:25:00',8.81),('7643','2013-04-19','09:30:00',7.37),('7643','2013-04-19','09:35:00',4.3),('7643','2013-04-19','09:40:00',4.05),('7643','2013-04-19','09:45:00',4.22),('7643','2013-04-19','09:50:00',3.92),('7643','2013-04-19','09:55:00',2.97),('7643','2013-04-19','10:00:00',2.17),('7643','2013-04-19','10:05:00',1.87),('7643','2013-04-19','10:10:00',1.76),('7643','2013-04-19','10:15:00',1.77),('7643','2013-04-19','10:20:00',1.83),('7643','2013-04-19','10:25:00',1.89),('7643','2013-04-19','10:30:00',2.24),('7643','2013-04-19','10:35:00',2.91),('7643','2013-04-19','10:40:00',4.98),('7643','2013-04-19','10:45:00',11.68),('7643','2013-04-19','10:50:00',7.71),('7643','2013-04-19','10:55:00',7.7),('7643','2013-04-19','11:00:00',7.43),('7643','2013-04-19','11:05:00',7.47),('7643','2013-04-19','11:10:00',13.59),('7643','2013-04-19','11:15:00',16.43),('7643','2013-04-19','11:20:00',7.51),('7643','2013-04-19','11:25:00',14.21),('7643','2013-04-19','11:30:00',16.19),('7643','2013-04-19','11:35:00',8.79),('7643','2013-04-19','11:40:00',6.43),('7643','2013-04-19','11:45:00',8.53),('7643','2013-04-19','11:50:00',8.6),('7643','2013-04-19','11:55:00',16.65),('7643','2013-04-19','12:00:00',15.19),('7643','2013-04-19','12:05:00',12.16),('7643','2013-04-19','12:10:00',15.85),('7643','2013-04-19','12:15:00',6.48),('7643','2013-04-19','12:20:00',16.15),('7643','2013-04-19','12:25:00',14.64),('7643','2013-04-19','12:30:00',16.87),('7643','2013-04-19','12:35:00',12.91),('7643','2013-04-19','12:40:00',16.94),('7643','2013-04-19','12:45:00',16.7),('7643','2013-04-19','12:50:00',16.94),('7643','2013-04-19','12:55:00',7.77),('7643','2013-04-19','13:00:00',12.78),('7643','2013-04-19','13:05:00',17),('7643','2013-04-19','13:10:00',16.64),('7643','2013-04-19','13:15:00',9.55),('7643','2013-04-19','13:20:00',14.16),('7643','2013-04-19','13:25:00',16.34),('7643','2013-04-19','13:30:00',13.99),('7643','2013-04-19','13:35:00',12.27),('7643','2013-04-19','13:40:00',15.34),('7643','2013-04-19','13:45:00',10.84),('7643','2013-04-19','13:50:00',11.33),('7643','2013-04-19','13:55:00',15.39),('7643','2013-04-19','14:00:00',8.93),('7643','2013-04-19','14:05:00',15.71),('7643','2013-04-19','14:10:00',15.14),('7643','2013-04-19','14:15:00',15.23),('7643','2013-04-19','14:20:00',14.98),('7643','2013-04-19','14:25:00',14.74),('7643','2013-04-19','14:30:00',14.57),('7643','2013-04-19','14:35:00',14.49),('7643','2013-04-19','14:40:00',14.35),('7643','2013-04-19','14:45:00',14.36),('7643','2013-04-19','14:50:00',14.45),('7643','2013-04-19','14:55:00',14.44),('7643','2013-04-19','15:00:00',14.27),('7643','2013-04-19','15:05:00',13.82),('7643','2013-04-19','15:10:00',7.01),('7643','2013-04-19','15:15:00',10.92),('7643','2013-04-19','15:20:00',9.48),('7643','2013-04-19','15:25:00',12.18),('7643','2013-04-19','15:30:00',7.03),('7643','2013-04-19','15:35:00',3.17),('7643','2013-04-19','15:40:00',2.8),('7643','2013-04-19','15:45:00',2.82),('7643','2013-04-19','15:50:00',2.7),('7643','2013-04-19','15:55:00',2.56),('7643','2013-04-19','16:00:00',2.8),('7643','2013-04-19','16:05:00',3.57),('7643','2013-04-19','16:10:00',5.21),('7643','2013-04-19','16:15:00',7.27),('7643','2013-04-19','16:20:00',7.39),('7643','2013-04-19','16:25:00',9.92),('7643','2013-04-19','16:30:00',10.8),('7643','2013-04-19','16:35:00',9.08),('7643','2013-04-19','16:40:00',10.91),('7643','2013-04-19','16:45:00',10.64),('7643','2013-04-19','16:50:00',9.7),('7643','2013-04-19','16:55:00',9.13),('7643','2013-04-19','17:00:00',8.52),('7643','2013-04-19','17:05:00',8.14),('7643','2013-04-19','17:10:00',7.93),('7643','2013-04-19','17:15:00',7.15),('7643','2013-04-19','17:20:00',6.72),('7643','2013-04-19','17:25:00',6.23),('7643','2013-04-19','17:30:00',7.02),('7643','2013-04-19','17:35:00',7.04),('7643','2013-04-19','17:40:00',6.43),('7643','2013-04-19','17:45:00',2.93),('7643','2013-04-19','17:50:00',3.32),('7643','2013-04-19','17:55:00',5.66),('7643','2013-04-19','18:00:00',4.68),('7643','2013-04-19','18:05:00',3.96),('7643','2013-04-19','18:10:00',4.51),('7643','2013-04-19','18:15:00',3.67),('7643','2013-04-19','18:20:00',2.51),('7643','2013-04-19','18:25:00',1.59),('7643','2013-04-19','18:30:00',1.48),('7643','2013-04-19','18:35:00',1.31),('7643','2013-04-19','18:40:00',1.69),('7643','2013-04-19','18:45:00',1.1),('7643','2013-04-18','07:30:00',1.12),('7643','2013-04-18','07:35:00',1.5),('7643','2013-04-18','07:40:00',2.27),('7643','2013-04-18','07:45:00',2.75),('7643','2013-04-18','07:50:00',1.73),('7643','2013-04-18','07:55:00',1.94),('7643','2013-04-18','08:00:00',3.03),('7643','2013-04-18','08:05:00',4.3),('7643','2013-04-18','08:10:00',2.97),('7643','2013-04-18','08:15:00',2.86),('7643','2013-04-18','08:20:00',5.12),('7643','2013-04-18','08:25:00',5.24),('7643','2013-04-18','08:30:00',5.5),('7643','2013-04-18','08:35:00',5.64),('7643','2013-04-18','08:40:00',6.42),('7643','2013-04-18','08:45:00',6.74),('7643','2013-04-18','08:50:00',7.08),('7643','2013-04-18','08:55:00',7.49),('7643','2013-04-18','09:00:00',7.73),('7643','2013-04-18','09:05:00',7.92),('7643','2013-04-18','09:10:00',8.14),('7643','2013-04-18','09:15:00',8.41),('7643','2013-04-18','09:20:00',8.72),('7643','2013-04-18','09:25:00',8.97),('7643','2013-04-18','09:30:00',9.19),('7643','2013-04-18','09:35:00',9.44),('7643','2013-04-18','09:40:00',9.85),('7643','2013-04-18','09:45:00',9.98),('7643','2013-04-18','09:50:00',10.13),('7643','2013-04-18','09:55:00',10.28),('7643','2013-04-18','10:00:00',10.61),('7643','2013-04-18','10:05:00',10.62),('7643','2013-04-18','10:10:00',10.73),('7643','2013-04-18','10:15:00',11.38),('7643','2013-04-18','10:20:00',9.68),('7643','2013-04-18','10:25:00',11.06),('7643','2013-04-18','10:30:00',10.46),('7643','2013-04-18','10:35:00',9.66),('7643','2013-04-18','10:40:00',12.26),('7643','2013-04-18','10:45:00',12.45),('7643','2013-04-18','10:50:00',12.55),('7643','2013-04-18','10:55:00',12.7),('7643','2013-04-18','11:00:00',12.76),('7643','2013-04-18','11:05:00',12.85),('7643','2013-04-18','11:10:00',12.92),('7643','2013-04-18','11:15:00',13),('7643','2013-04-18','11:20:00',13.09),('7643','2013-04-18','11:25:00',13.29),('7643','2013-04-18','11:30:00',13.46),('7643','2013-04-18','11:35:00',13.61),('7643','2013-04-18','11:40:00',13.85),('7643','2013-04-18','11:45:00',13.65),('7643','2013-04-18','11:50:00',14.07),('7643','2013-04-18','11:55:00',14.24),('7643','2013-04-18','12:00:00',14.35),('7643','2013-04-18','12:05:00',14.32),('7643','2013-04-18','12:10:00',14.36),('7643','2013-04-18','12:15:00',14.2),('7643','2013-04-18','12:20:00',14.41),('7643','2013-04-18','12:25:00',14.39),('7643','2013-04-18','12:30:00',14.35),('7643','2013-04-18','12:35:00',14.69),('7643','2013-04-18','12:40:00',14.77),('7643','2013-04-18','12:45:00',14.81),('7643','2013-04-18','12:50:00',14.62),('7643','2013-04-18','12:55:00',14.4),('7643','2013-04-18','13:00:00',14.85),('7643','2013-04-18','13:05:00',14.55),('7643','2013-04-18','13:10:00',14.83),('7643','2013-04-18','13:15:00',14.9),('7643','2013-04-18','13:20:00',14.82),('7643','2013-04-18','13:25:00',14.71),('7643','2013-04-18','13:30:00',14.96),('7643','2013-04-18','13:35:00',14.55),('7643','2013-04-18','13:40:00',14.42),('7643','2013-04-18','13:45:00',14.62),('7643','2013-04-18','13:50:00',14.34),('7643','2013-04-18','13:55:00',14.27),('7643','2013-04-18','14:00:00',14.34),('7643','2013-04-18','14:05:00',13.98),('7643','2013-04-18','14:10:00',14.15),('7643','2013-04-18','14:15:00',13.95),('7643','2013-04-18','14:20:00',13.9),('7643','2013-04-18','14:25:00',13.83),('7643','2013-04-18','14:30:00',13.72),('7643','2013-04-18','14:35:00',13.42),('7643','2013-04-18','14:40:00',13.38),('7643','2013-04-18','14:45:00',13.28),('7643','2013-04-18','14:50:00',13.17),('7643','2013-04-18','14:55:00',13.02),('7643','2013-04-18','15:00:00',12.78),('7643','2013-04-18','15:05:00',12.55),('7643','2013-04-18','15:10:00',12.45),('7643','2013-04-18','15:15:00',12.48),('7643','2013-04-18','15:20:00',12.14),('7643','2013-04-18','15:25:00',12.12),('7643','2013-04-18','15:30:00',11.87),('7643','2013-04-18','15:35:00',11.82),('7643','2013-04-18','15:40:00',11.61),('7643','2013-04-18','15:45:00',11.37),('7643','2013-04-18','15:50:00',11.18),('7643','2013-04-18','15:55:00',11.04),('7643','2013-04-18','16:00:00',10.77),('7643','2013-04-18','16:05:00',10.56),('7643','2013-04-18','16:10:00',10.2),('7643','2013-04-18','16:15:00',9.92),('7643','2013-04-18','16:20:00',9.7),('7643','2013-04-18','16:25:00',9.51),('7643','2013-04-18','16:30:00',9.17),('7643','2013-04-18','16:35:00',8.85),('7643','2013-04-18','16:40:00',8.62),('7643','2013-04-18','16:45:00',8.37),('7643','2013-04-18','16:50:00',8.05),('7643','2013-04-18','16:55:00',7.72),('7643','2013-04-18','17:00:00',7.41),('7643','2013-04-18','17:05:00',7.11),('7643','2013-04-18','17:10:00',6.72),('7643','2013-04-18','17:15:00',6.44),('7643','2013-04-18','17:20:00',6.13),('7643','2013-04-18','17:25:00',5.82),('7643','2013-04-18','17:30:00',5.55),('7643','2013-04-18','17:35:00',5.22),('7643','2013-04-18','17:40:00',4.9),('7643','2013-04-18','17:45:00',4.56),('7643','2013-04-18','17:50:00',4.15),('7643','2013-04-18','17:55:00',3.85),('7643','2013-04-18','18:00:00',3.6),('7643','2013-04-18','18:05:00',3.32),('7643','2013-04-18','18:10:00',3.02),('7643','2013-04-18','18:15:00',2.73),('7643','2013-04-18','18:20:00',2.5),('7643','2013-04-18','18:25:00',2.33),('7643','2013-04-18','18:30:00',2.06),('7643','2013-04-18','18:35:00',1.83),('7643','2013-04-18','18:40:00',1.66),('7643','2013-04-18','18:45:00',1.45),('7643','2013-04-18','18:50:00',1.23),('7643','2013-04-18','18:55:00',1.02),('7643','2013-04-17','06:55:00',1),('7643','2013-04-17','07:00:00',1.2),('7643','2013-04-17','07:05:00',1.42),('7643','2013-04-17','07:10:00',1.61),('7643','2013-04-17','07:15:00',1.28),('7643','2013-04-17','07:20:00',1.22),('7643','2013-04-17','07:25:00',1.31),('7643','2013-04-17','07:30:00',1.46),('7643','2013-04-17','07:35:00',1.57),('7643','2013-04-17','07:40:00',1.89),('7643','2013-04-17','07:45:00',1.96),('7643','2013-04-17','07:50:00',2.18),('7643','2013-04-17','07:55:00',2.2),('7643','2013-04-17','08:00:00',2.56),('7643','2013-04-17','08:05:00',3.21),('7643','2013-04-17','08:10:00',3.91),('7643','2013-04-17','08:15:00',4.4),('7643','2013-04-17','08:20:00',4.49),('7643','2013-04-17','08:25:00',4.5),('7643','2013-04-17','08:30:00',5.01),('7643','2013-04-17','08:35:00',5.3),('7643','2013-04-17','08:40:00',5.07),('7643','2013-04-17','08:45:00',5.29),('7643','2013-04-17','08:50:00',5.9),('7643','2013-04-17','08:55:00',6.87),('7643','2013-04-17','09:00:00',6.38),('7643','2013-04-17','09:05:00',7.42),('7643','2013-04-17','09:10:00',7.56),('7643','2013-04-17','09:15:00',7.55),('7643','2013-04-17','09:20:00',8.47),('7643','2013-04-17','09:25:00',8.72),('7643','2013-04-17','09:30:00',9.07),('7643','2013-04-17','09:35:00',9.38),('7643','2013-04-17','09:40:00',10.78),('7643','2013-04-17','09:45:00',9.71),('7643','2013-04-17','09:50:00',8.38),('7643','2013-04-17','09:55:00',8.65),('7643','2013-04-17','10:00:00',10.27),('7643','2013-04-17','10:05:00',11.34),('7643','2013-04-17','10:10:00',11.54),('7643','2013-04-17','10:15:00',12.16),('7643','2013-04-17','10:20:00',12.24),('7643','2013-04-17','10:25:00',12.18),('7643','2013-04-17','10:30:00',12.44),('7643','2013-04-17','10:35:00',12.53),('7643','2013-04-17','10:40:00',12.74),('7643','2013-04-17','10:45:00',12.89),('7643','2013-04-17','10:50:00',13.08),('7643','2013-04-17','10:55:00',13.28),('7643','2013-04-17','11:00:00',13.44),('7643','2013-04-17','11:05:00',13.62),('7643','2013-04-17','11:10:00',13.74),('7643','2013-04-17','11:15:00',13.89),('7643','2013-04-17','11:20:00',14.06),('7643','2013-04-17','11:25:00',14.17),('7643','2013-04-17','11:30:00',14.23),('7643','2013-04-17','11:35:00',14.3),('7643','2013-04-17','11:40:00',14.24),('7643','2013-04-17','11:45:00',14.41),('7643','2013-04-17','11:50:00',14.34),('7643','2013-04-17','11:55:00',14.69),('7643','2013-04-17','12:00:00',14.57),('7643','2013-04-17','12:05:00',15),('7643','2013-04-17','12:10:00',15.1),('7643','2013-04-17','12:15:00',15.12),('7643','2013-04-17','12:20:00',15.3),('7643','2013-04-17','12:25:00',15.34),('7643','2013-04-17','12:30:00',15.38),('7643','2013-04-17','12:35:00',15.46),('7643','2013-04-17','12:40:00',15.38),('7643','2013-04-17','12:45:00',15.5),('7643','2013-04-17','12:50:00',15.49),('7643','2013-04-17','12:55:00',15.43),('7643','2013-04-17','13:00:00',15.51),('7643','2013-04-17','13:05:00',15.51),('7643','2013-04-17','13:10:00',15.42),('7643','2013-04-17','13:15:00',15.43),('7643','2013-04-17','13:20:00',15.46),('7643','2013-04-17','13:25:00',15.47),('7643','2013-04-17','13:30:00',15.48),('7643','2013-04-17','13:35:00',15.42),('7643','2013-04-17','13:40:00',15.37),('7643','2013-04-17','13:45:00',15.35),('7643','2013-04-17','13:50:00',15.35),('7643','2013-04-17','13:55:00',15.31),('7643','2013-04-17','14:00:00',15.17),('7643','2013-04-17','14:05:00',15.09),('7643','2013-04-17','14:10:00',15),('7643','2013-04-17','14:15:00',14.94),('7643','2013-04-17','14:20:00',14.86),('7643','2013-04-17','14:25:00',14.74),('7643','2013-04-17','14:30:00',14.71),('7643','2013-04-17','14:35:00',14.67),('7643','2013-04-17','14:40:00',14.48),('7643','2013-04-17','14:45:00',14.21),('7643','2013-04-17','14:50:00',14),('7643','2013-04-17','14:55:00',13.93),('7643','2013-04-17','15:00:00',13.75),('7643','2013-04-17','15:05:00',13.59),('7643','2013-04-17','15:10:00',13.43),('7643','2013-04-17','15:15:00',13.25),('7643','2013-04-17','15:20:00',13.09),('7643','2013-04-17','15:25:00',12.78),('7643','2013-04-17','15:30:00',12.55),('7643','2013-04-17','15:35:00',12.39),('7643','2013-04-17','15:40:00',12.2),('7643','2013-04-17','15:45:00',11.99),('7643','2013-04-17','15:50:00',11.78),('7643','2013-04-17','15:55:00',11.58),('7643','2013-04-17','16:00:00',11.25),('7643','2013-04-17','16:05:00',11.06),('7643','2013-04-17','16:10:00',10.84),('7643','2013-04-17','16:15:00',10.6),('7643','2013-04-17','16:20:00',10.29),('7643','2013-04-17','16:25:00',9.9),('7643','2013-04-17','16:30:00',9.58),('7643','2013-04-17','16:35:00',9.33),('7643','2013-04-17','16:40:00',8.98),('7643','2013-04-17','16:45:00',8.81),('7643','2013-04-17','16:50:00',8.56),('7643','2013-04-17','16:55:00',8.28),('7643','2013-04-17','17:00:00',7.87),('7643','2013-04-17','17:05:00',7.47),('7643','2013-04-17','17:10:00',7.2),('7643','2013-04-17','17:15:00',6.94),('7643','2013-04-17','17:20:00',6.6),('7643','2013-04-17','17:25:00',6.29),('7643','2013-04-17','17:30:00',5.99),('7643','2013-04-17','17:35:00',5.67),('7643','2013-04-17','17:40:00',5.32),('7643','2013-04-17','17:45:00',5.01),('7643','2013-04-17','17:50:00',4.66),('7643','2013-04-17','17:55:00',4.33),('7643','2013-04-17','18:00:00',3.96),('7643','2013-04-17','18:05:00',3.63),('7643','2013-04-17','18:10:00',3.26),('7643','2013-04-17','18:15:00',2.89),('7643','2013-04-17','18:20:00',2.65),('7643','2013-04-17','18:25:00',2.33),('7643','2013-04-17','18:30:00',2.01),('7643','2013-04-17','18:35:00',1.77),('7643','2013-04-17','18:40:00',1.54),('7643','2013-04-17','18:45:00',1.29),('7643','2013-04-17','18:50:00',1.08),('7643','2013-04-16','07:15:00',1.24),('7643','2013-04-16','07:20:00',1.52),('7643','2013-04-16','07:25:00',1.77),('7643','2013-04-16','07:30:00',2.05),('7643','2013-04-16','07:35:00',2.37),('7643','2013-04-16','07:40:00',2.65),('7643','2013-04-16','07:45:00',2.95),('7643','2013-04-16','07:50:00',3.25),('7643','2013-04-16','07:55:00',3.61),('7643','2013-04-16','08:00:00',3.94),('7643','2013-04-16','08:05:00',4.25),('7643','2013-04-16','08:10:00',4.6),('7643','2013-04-16','08:15:00',4.94),('7643','2013-04-16','08:20:00',5.3),('7643','2013-04-16','08:25:00',5.64),('7643','2013-04-16','08:30:00',5.97),('7643','2013-04-16','08:35:00',6.28),('7643','2013-04-16','08:40:00',6.59),('7643','2013-04-16','08:45:00',6.93),('7643','2013-04-16','08:50:00',7.23),('7643','2013-04-16','08:55:00',7.53),('7643','2013-04-16','09:00:00',7.89),('7643','2013-04-16','09:05:00',8.19),('7643','2013-04-16','09:10:00',8.5),('7643','2013-04-16','09:15:00',8.84),('7643','2013-04-16','09:20:00',9.12),('7643','2013-04-16','09:25:00',9.43),('7643','2013-04-16','09:30:00',9.69),('7643','2013-04-16','09:35:00',9.93),('7643','2013-04-16','09:40:00',10.24),('7643','2013-04-16','09:45:00',10.56),('7643','2013-04-16','09:50:00',10.8),('7643','2013-04-16','09:55:00',11.03),('7643','2013-04-16','10:00:00',11.26),('7643','2013-04-16','10:05:00',11.5),('7643','2013-04-16','10:10:00',11.71),('7643','2013-04-16','10:15:00',11.95),('7643','2013-04-16','10:20:00',12.09),('7643','2013-04-16','10:25:00',12.31),('7643','2013-04-16','10:30:00',12.55),('7643','2013-04-16','10:35:00',12.67),('7643','2013-04-16','10:40:00',12.88),('7643','2013-04-16','10:45:00',13.11),('7643','2013-04-16','10:50:00',13.3),('7643','2013-04-16','10:55:00',13.39),('7643','2013-04-16','11:00:00',13.59),('7643','2013-04-16','11:05:00',13.75),('7643','2013-04-16','11:10:00',13.91),('7643','2013-04-16','11:15:00',14.14),('7643','2013-04-16','11:20:00',14.21),('7643','2013-04-16','11:25:00',14.29),('7643','2013-04-16','11:30:00',14.41),('7643','2013-04-16','11:35:00',14.44),('7643','2013-04-16','11:40:00',14.51),('7643','2013-04-16','11:45:00',14.61),('7643','2013-04-16','11:50:00',14.74),('7643','2013-04-16','11:55:00',14.96),('7643','2013-04-16','12:00:00',15.04),('7643','2013-04-16','12:05:00',15.03),('7643','2013-04-16','12:10:00',15.07),('7643','2013-04-16','12:15:00',15.23),('7643','2013-04-16','12:20:00',15.35),('7643','2013-04-16','12:25:00',15.31),('7643','2013-04-16','12:30:00',15.46),('7643','2013-04-16','12:35:00',15.5),('7643','2013-04-16','12:40:00',15.53),('7643','2013-04-16','12:45:00',15.53),('7643','2013-04-16','12:50:00',15.48),('7643','2013-04-16','12:55:00',15.52),('7643','2013-04-16','13:00:00',15.54),('7643','2013-04-16','13:05:00',15.55),('7643','2013-04-16','13:10:00',15.44),('7643','2013-04-16','13:15:00',15.61),('7643','2013-04-16','13:20:00',15.65),('7643','2013-04-16','13:25:00',15.72),('7643','2013-04-16','13:30:00',15.6),('7643','2013-04-16','13:35:00',15.24),('7643','2013-04-16','13:40:00',15.71),('7643','2013-04-16','13:45:00',14.55),('7643','2013-04-16','13:50:00',14.5),('7643','2013-04-16','13:55:00',15.68),('7643','2013-04-16','14:00:00',15.15),('7643','2013-04-16','14:05:00',16.36),('7643','2013-04-16','14:10:00',15.95),('7643','2013-04-16','14:15:00',14.41),('7643','2013-04-16','14:20:00',13.83),('7643','2013-04-16','14:25:00',14),('7643','2013-04-16','14:30:00',13.42),('7643','2013-04-16','14:35:00',15.68),('7643','2013-04-16','14:40:00',15.19),('7643','2013-04-16','14:45:00',12.79),('7643','2013-04-16','14:50:00',14.68),('7643','2013-04-16','14:55:00',15.26),('7643','2013-04-16','15:00:00',15.11),('7643','2013-04-16','15:05:00',15.34),('7643','2013-04-16','15:10:00',15.91),('7643','2013-04-16','15:15:00',14.76),('7643','2013-04-16','15:20:00',7.85),('7643','2013-04-16','15:25:00',7.95),('7643','2013-04-16','15:30:00',12.33),('7643','2013-04-16','15:35:00',13.3),('7643','2013-04-16','15:40:00',13.28),('7643','2013-04-16','15:45:00',13.24),('7643','2013-04-16','15:50:00',13.19),('7643','2013-04-16','15:55:00',13.28),('7643','2013-04-16','16:00:00',12.93),('7643','2013-04-16','16:05:00',9.19),('7643','2013-04-16','16:10:00',11.84),('7643','2013-04-16','16:15:00',11.43),('7643','2013-04-16','16:20:00',10.93),('7643','2013-04-16','16:25:00',10.52),('7643','2013-04-16','16:30:00',10.27),('7643','2013-04-16','16:35:00',10.22),('7643','2013-04-16','16:40:00',9.5),('7643','2013-04-16','16:45:00',9.69),('7643','2013-04-16','16:50:00',9),('7643','2013-04-16','16:55:00',8.49),('7643','2013-04-16','17:00:00',8.08),('7643','2013-04-16','17:05:00',7.7),('7643','2013-04-16','17:10:00',7.37),('7643','2013-04-16','17:15:00',7.06),('7643','2013-04-16','17:20:00',6.71),('7643','2013-04-16','17:25:00',6.37),('7643','2013-04-16','17:30:00',6.02),('7643','2013-04-16','17:35:00',5.69),('7643','2013-04-16','17:40:00',5.38),('7643','2013-04-16','17:45:00',5.06),('7643','2013-04-16','17:50:00',4.7),('7643','2013-04-16','17:55:00',4.35),('7643','2013-04-16','18:00:00',3.97),('7643','2013-04-16','18:05:00',3.64),('7643','2013-04-16','18:10:00',3.33),('7643','2013-04-16','18:15:00',2.99),('7643','2013-04-16','18:20:00',2.65),('7643','2013-04-16','18:25:00',2.41),('7643','2013-04-16','18:30:00',2.11),('7643','2013-04-16','18:35:00',1.81),('7643','2013-04-16','18:40:00',1.61),('7643','2013-04-16','18:45:00',1.4),('7643','2013-04-16','18:50:00',1.15),('7643','2013-04-15','07:20:00',1.12),('7643','2013-04-15','07:35:00',1.25),('7643','2013-04-15','07:40:00',2.18),('7643','2013-04-15','07:45:00',2.49),('7643','2013-04-15','07:50:00',2.82),('7643','2013-04-15','07:55:00',3.13),('7643','2013-04-15','08:00:00',3.16),('7643','2013-04-15','08:05:00',3.82),('7643','2013-04-15','08:10:00',4.19),('7643','2013-04-15','08:15:00',3.29),('7643','2013-04-15','08:20:00',2.52),('7643','2013-04-15','08:25:00',2.98),('7643','2013-04-15','08:30:00',3.17),('7643','2013-04-15','08:35:00',3.04),('7643','2013-04-15','08:40:00',3.13),('7643','2013-04-15','08:45:00',3.33),('7643','2013-04-15','08:50:00',3.7),('7643','2013-04-15','08:55:00',3.85),('7643','2013-04-15','09:00:00',4.16),('7643','2013-04-15','09:05:00',3.62),('7643','2013-04-15','09:10:00',4.53),('7643','2013-04-15','09:15:00',4.7),('7643','2013-04-15','09:20:00',4.63),('7643','2013-04-15','09:25:00',6.04),('7643','2013-04-15','09:30:00',6.2),('7643','2013-04-15','09:35:00',5.91),('7643','2013-04-15','09:40:00',5),('7643','2013-04-15','09:45:00',5.22),('7643','2013-04-15','09:50:00',5.05),('7643','2013-04-15','09:55:00',4.87),('7643','2013-04-15','10:00:00',4.67),('7643','2013-04-15','10:05:00',4.63),('7643','2013-04-15','10:10:00',4.86),('7643','2013-04-15','10:15:00',5.21),('7643','2013-04-15','10:20:00',5.47),('7643','2013-04-15','10:25:00',5.61),('7643','2013-04-15','10:30:00',5.68),('7643','2013-04-15','10:35:00',5.77),('7643','2013-04-15','10:40:00',5.63),('7643','2013-04-15','10:45:00',5.36),('7643','2013-04-15','10:50:00',5.41),('7643','2013-04-15','10:55:00',5.79),('7643','2013-04-15','11:00:00',6.3),('7643','2013-04-15','11:05:00',6.51),('7643','2013-04-15','11:10:00',6.51),('7643','2013-04-15','11:15:00',6.75),('7643','2013-04-15','11:20:00',6.9),('7643','2013-04-15','11:25:00',6.76),('7643','2013-04-15','11:30:00',6.69),('7643','2013-04-15','11:35:00',6.53),('7643','2013-04-15','11:40:00',7.15),('7643','2013-04-15','11:45:00',8.58),('7643','2013-04-15','11:50:00',9.18),('7643','2013-04-15','11:55:00',9.56),('7643','2013-04-15','12:00:00',9.7),('7643','2013-04-15','12:05:00',10.91),('7643','2013-04-15','12:10:00',11.68),('7643','2013-04-15','12:15:00',16.23),('7643','2013-04-15','12:20:00',11.67),('7643','2013-04-15','12:25:00',10.79),('7643','2013-04-15','12:30:00',13.38),('7643','2013-04-15','12:35:00',15.7),('7643','2013-04-15','12:40:00',16),('7643','2013-04-15','12:45:00',15.57),('7643','2013-04-15','12:50:00',12.3),('7643','2013-04-15','12:55:00',14.99),('7643','2013-04-15','13:00:00',15.66),('7643','2013-04-15','13:05:00',14.96),('7643','2013-04-15','13:10:00',15.06),('7643','2013-04-15','13:15:00',15.06),('7643','2013-04-15','13:20:00',15.26),('7643','2013-04-15','13:25:00',15.28),('7643','2013-04-15','13:30:00',15.12),('7643','2013-04-15','13:35:00',15.1),('7643','2013-04-15','13:40:00',14.97),('7643','2013-04-15','13:45:00',14.71),('7643','2013-04-15','13:50:00',14.67),('7643','2013-04-15','13:55:00',14.35),('7643','2013-04-15','14:00:00',14.48),('7643','2013-04-15','14:05:00',14.68),('7643','2013-04-15','14:10:00',14.7),('7643','2013-04-15','14:15:00',14.76),('7643','2013-04-15','14:20:00',14.4),('7643','2013-04-15','14:45:00',13.99),('7643','2013-04-15','14:50:00',13.46),('7643','2013-04-15','14:55:00',13.1),('7643','2013-04-15','15:00:00',13.5),('7643','2013-04-15','15:05:00',13.32),('7643','2013-04-15','15:10:00',13.27),('7643','2013-04-15','15:15:00',13.09),('7643','2013-04-15','15:20:00',12.95),('7643','2013-04-15','15:25:00',12.3),('7643','2013-04-15','15:30:00',12.05),('7643','2013-04-15','15:35:00',12.06),('7643','2013-04-15','15:40:00',12.05),('7643','2013-04-15','15:45:00',11.83),('7643','2013-04-15','15:50:00',11.71),('7643','2013-04-15','15:55:00',11.36),('7643','2013-04-15','16:00:00',10.79),('7643','2013-04-15','16:05:00',10.85),('7643','2013-04-15','16:10:00',10.62),('7643','2013-04-15','16:15:00',9.95),('7643','2013-04-15','16:20:00',10.14),('7643','2013-04-15','16:25:00',9.89),('7643','2013-04-15','16:30:00',9.67),('7643','2013-04-15','16:35:00',9.52),('7643','2013-04-15','16:40:00',9.91),('7643','2013-04-15','16:45:00',9.93),('7643','2013-04-15','16:50:00',8.88),('7643','2013-04-15','16:55:00',7.91),('7643','2013-04-15','17:00:00',7.92),('7643','2013-04-15','17:05:00',8.04),('7643','2013-04-15','17:10:00',8.16),('7643','2013-04-15','17:15:00',7.85),('7643','2013-04-15','17:20:00',7.55),('7643','2013-04-15','17:25:00',7.4),('7643','2013-04-15','17:30:00',6.36),('7643','2013-04-15','17:35:00',6.91),('7643','2013-04-15','17:40:00',6.64),('7643','2013-04-15','17:45:00',6),('7643','2013-04-15','17:50:00',5.38),('7643','2013-04-15','17:55:00',4.5),('7643','2013-04-15','18:00:00',2.78),('7643','2013-04-15','18:05:00',2.6),('7643','2013-04-15','18:10:00',2.29),('7643','2013-04-15','18:15:00',2.7),('7643','2013-04-15','18:20:00',2.21),('7643','2013-04-15','18:25:00',1.94),('7643','2013-04-15','18:30:00',1.86),('7643','2013-04-15','18:35:00',1.67),('7643','2013-04-15','18:40:00',1.52),('7643','2013-04-15','18:45:00',1.36),('7643','2013-04-15','18:50:00',1.15),('7643','2013-04-14','07:15:00',1.15),('7643','2013-04-14','07:20:00',1.42),('7643','2013-04-14','07:25:00',1.71),('7643','2013-04-14','07:30:00',2),('7643','2013-04-14','07:35:00',2.31),('7643','2013-04-14','07:40:00',2.6),('7643','2013-04-14','07:45:00',2.89),('7643','2013-04-14','07:50:00',3.21),('7643','2013-04-14','07:55:00',3.55),('7643','2013-04-14','08:00:00',3.9),('7643','2013-04-14','08:05:00',4.26),('7643','2013-04-14','08:10:00',4.6),('7643','2013-04-14','08:15:00',4.91),('7643','2013-04-14','08:20:00',5.24),('7643','2013-04-14','08:25:00',5.58),('7643','2013-04-14','08:30:00',5.95),('7643','2013-04-14','08:35:00',6.27),('7643','2013-04-14','08:40:00',6.59),('7643','2013-04-14','08:45:00',6.86),('7643','2013-04-14','08:50:00',7.22),('7643','2013-04-14','08:55:00',7.52),('7643','2013-04-14','09:00:00',7.87),('7643','2013-04-14','09:05:00',8.21),('7643','2013-04-14','09:10:00',8.53),('7643','2013-04-14','09:15:00',8.81),('7643','2013-04-14','09:20:00',9.1),('7643','2013-04-14','09:25:00',9.39),('7643','2013-04-14','09:30:00',9.71),('7643','2013-04-14','09:35:00',9.96),('7643','2013-04-14','09:40:00',10.19),('7643','2013-04-14','09:45:00',10.37),('7643','2013-04-14','09:50:00',10.69),('7643','2013-04-14','09:55:00',10.96),('7643','2013-04-14','10:00:00',11.19),('7643','2013-04-14','10:05:00',11.44),('7643','2013-04-14','10:10:00',11.7),('7643','2013-04-14','10:15:00',11.91),('7643','2013-04-14','10:20:00',12.11),('7643','2013-04-14','10:25:00',12.34),('7643','2013-04-14','10:30:00',12.5),('7643','2013-04-14','10:35:00',12.68),('7643','2013-04-14','10:40:00',12.84),('7643','2013-04-14','10:45:00',13.05),('7643','2013-04-14','10:50:00',13.21),('7643','2013-04-14','10:55:00',13.4),('7643','2013-04-14','11:00:00',13.6),('7643','2013-04-14','11:05:00',13.69),('7643','2013-04-14','11:10:00',13.89),('7643','2013-04-14','11:15:00',13.99),('7643','2013-04-14','11:20:00',14.12),('7643','2013-04-14','11:25:00',14.16),('7643','2013-04-14','11:30:00',14.37),('7643','2013-04-14','11:35:00',14.4),('7643','2013-04-14','11:40:00',14.48),('7643','2013-04-14','11:45:00',14.65),('7643','2013-04-14','11:50:00',14.8),('7643','2013-04-14','11:55:00',14.94),('7643','2013-04-14','12:00:00',14.95),('7643','2013-04-14','12:05:00',15.04),('7643','2013-04-14','12:10:00',15.11),('7643','2013-04-14','12:15:00',15.17),('7643','2013-04-14','12:20:00',15.19),('7643','2013-04-14','12:25:00',15.26),('7643','2013-04-14','12:30:00',15.26),('7643','2013-04-14','12:35:00',15.43),('7643','2013-04-14','12:40:00',15.41),('7643','2013-04-14','12:45:00',15.38),('7643','2013-04-14','12:50:00',15.41),('7643','2013-04-14','12:55:00',15.21),('7643','2013-04-14','13:00:00',15.25),('7643','2013-04-14','13:05:00',15.23),('7643','2013-04-14','13:10:00',15.3),('7643','2013-04-14','13:15:00',15.44),('7643','2013-04-14','13:20:00',15.45),('7643','2013-04-14','13:25:00',15.38),('7643','2013-04-14','13:30:00',15.31),('7643','2013-04-14','13:35:00',15.19),('7643','2013-04-14','13:40:00',15.2),('7643','2013-04-14','13:45:00',15.05),('7643','2013-04-14','13:50:00',15.09),('7643','2013-04-14','13:55:00',15.12),('7643','2013-04-14','14:00:00',15.25),('7643','2013-04-14','14:05:00',15.14),('7643','2013-04-14','14:10:00',15.16),('7643','2013-04-14','14:15:00',15.15),('7643','2013-04-14','14:20:00',15.14),('7643','2013-04-14','14:25:00',14.99),('7643','2013-04-14','14:30:00',14.83),('7643','2013-04-14','14:35:00',14.76),('7643','2013-04-14','14:40:00',14.63),('7643','2013-04-14','14:45:00',14.54),('7643','2013-04-14','14:50:00',14.35),('7643','2013-04-14','14:55:00',14.18),('7643','2013-04-14','15:00:00',14.01),('7643','2013-04-14','15:05:00',13.8),('7643','2013-04-14','15:10:00',13.66),('7643','2013-04-14','15:15:00',13.46),('7643','2013-04-14','15:20:00',13.24),('7643','2013-04-14','15:25:00',13.09),('7643','2013-04-14','15:30:00',12.89),('7643','2013-04-14','15:35:00',12.71),('7643','2013-04-14','15:40:00',12.48),('7643','2013-04-14','15:45:00',12.28),('7643','2013-04-14','15:50:00',12.02),('7643','2013-04-14','15:55:00',11.8),('7643','2013-04-14','16:00:00',11.52),('7643','2013-04-14','16:05:00',11.24),('7643','2013-04-14','16:10:00',10.98),('7643','2013-04-14','16:15:00',10.66),('7643','2013-04-14','16:20:00',10.34),('7643','2013-04-14','16:25:00',10.06),('7643','2013-04-14','16:30:00',9.77),('7643','2013-04-14','16:35:00',9.48),('7643','2013-04-14','16:40:00',9.22),('7643','2013-04-14','16:45:00',8.92),('7643','2013-04-14','16:50:00',8.58),('7643','2013-04-14','16:55:00',8.24),('7643','2013-04-14','17:00:00',7.94),('7643','2013-04-14','17:05:00',7.65),('7643','2013-04-14','17:10:00',7.32),('7643','2013-04-14','17:15:00',6.99),('7643','2013-04-14','17:20:00',6.66),('7643','2013-04-14','17:25:00',6.37),('7643','2013-04-14','17:30:00',6.02),('7643','2013-04-14','17:35:00',5.7),('7643','2013-04-14','17:40:00',5.36),('7643','2013-04-14','17:45:00',5.04),('7643','2013-04-14','17:50:00',4.72),('7643','2013-04-14','17:55:00',4.36),('7643','2013-04-14','18:00:00',4.01),('7643','2013-04-14','18:05:00',3.6),('7643','2013-04-14','18:10:00',3.26),('7643','2013-04-14','18:15:00',2.98),('7643','2013-04-14','18:20:00',2.62),('7643','2013-04-14','18:25:00',2.35),('7643','2013-04-14','18:30:00',2.08),('7643','2013-04-14','18:35:00',1.77),('7643','2013-04-14','18:40:00',1.51),('7643','2013-04-14','18:45:00',1.35),('7643','2013-04-14','18:50:00',1.11),('7643','2013-04-13','07:20:00',1.23),('7643','2013-04-13','07:25:00',1.5),('7643','2013-04-13','09:15:00',6.4),('7643','2013-04-13','09:20:00',8.51),('7643','2013-04-13','09:25:00',8.9),('7643','2013-04-13','09:30:00',9.2),('7643','2013-04-13','09:35:00',9.43),('7643','2013-04-13','09:40:00',9.73),('7643','2013-04-13','09:45:00',10.04),('7643','2013-04-13','09:50:00',10.32),('7643','2013-04-13','09:55:00',10.55),('7643','2013-04-13','10:00:00',10.8),('7643','2013-04-13','10:05:00',11.08),('7643','2013-04-13','10:10:00',11.28),('7643','2013-04-13','10:15:00',11.57),('7643','2013-04-13','10:20:00',11.76),('7643','2013-04-13','10:25:00',11.94),('7643','2013-04-13','10:30:00',12.13),('7643','2013-04-13','10:35:00',12.34),('7643','2013-04-13','10:40:00',12.58),('7643','2013-04-13','10:45:00',12.73),('7643','2013-04-13','10:50:00',12.95),('7643','2013-04-13','10:55:00',13.18),('7643','2013-04-13','11:00:00',13.38),('7643','2013-04-13','11:05:00',13.48),('7643','2013-04-13','11:10:00',13.63),('7643','2013-04-13','11:15:00',13.82),('7643','2013-04-13','11:20:00',13.9),('7643','2013-04-13','11:25:00',13.91),('7643','2013-04-13','11:30:00',14.11),('7643','2013-04-13','11:35:00',14.21),('7643','2013-04-13','11:40:00',14.43),('7643','2013-04-13','11:45:00',14.5),('7643','2013-04-13','11:50:00',14.56),('7643','2013-04-13','11:55:00',14.62),('7643','2013-04-13','12:00:00',14.73),('7643','2013-04-13','12:05:00',14.87),('7643','2013-04-13','12:10:00',14.96),('7643','2013-04-13','12:15:00',15.09),('7643','2013-04-13','12:20:00',15.13),('7643','2013-04-13','12:25:00',15.11),('7643','2013-04-13','12:30:00',15.03),('7643','2013-04-13','12:35:00',15.27),('7643','2013-04-13','12:40:00',14.72),('7643','2013-04-13','13:00:00',14.12),('7643','2013-04-13','13:05:00',8.86),('7643','2013-04-13','13:10:00',6.83),('7643','2013-04-13','13:15:00',15.74),('7643','2013-04-13','13:20:00',16.21),('7643','2013-04-13','13:25:00',15.65),('7643','2013-04-13','13:30:00',15.46),('7643','2013-04-13','13:35:00',15.4),('7643','2013-04-13','13:40:00',15.18),('7643','2013-04-13','13:45:00',15.14),('7643','2013-04-13','13:50:00',14.94),('7643','2013-04-13','13:55:00',14.77),('7643','2013-04-13','14:00:00',14.58),('7643','2013-04-13','14:05:00',14.77),('7643','2013-04-13','14:10:00',14.68),('7643','2013-04-13','14:15:00',14.79),('7643','2013-04-13','14:20:00',14.68),('7643','2013-04-13','14:25:00',14.45),('7643','2013-04-13','14:30:00',14.45),('7643','2013-04-13','14:35:00',14.63),('7643','2013-04-13','14:40:00',14.71),('7643','2013-04-13','14:45:00',14.91),('7643','2013-04-13','14:50:00',14.92),('7643','2013-04-13','14:55:00',14.36),('7643','2013-04-13','15:00:00',13.91),('7643','2013-04-13','15:05:00',13.87),('7643','2013-04-13','15:10:00',10.73),('7643','2013-04-13','15:15:00',5.01),('7643','2013-04-13','15:20:00',11.63),('7643','2013-04-13','15:25:00',11.39),('7643','2013-04-13','15:30:00',11.32),('7643','2013-04-13','15:35:00',13.04),('7643','2013-04-13','15:40:00',12.83),('7643','2013-04-13','15:45:00',12.71),('7643','2013-04-13','15:50:00',12.3),('7643','2013-04-13','15:55:00',8.29),('7643','2013-04-13','16:00:00',11.12),('7643','2013-04-13','16:05:00',10.69),('7643','2013-04-13','16:10:00',10.74),('7643','2013-04-13','16:15:00',10.16),('7643','2013-04-13','16:20:00',9.83),('7643','2013-04-13','16:25:00',9.84),('7643','2013-04-13','16:30:00',9.57),('7643','2013-04-13','16:35:00',9.15),('7643','2013-04-13','16:40:00',8.87),('7643','2013-04-13','16:45:00',8.6),('7643','2013-04-13','16:50:00',8.32),('7643','2013-04-13','16:55:00',8.03),('7643','2013-04-13','17:00:00',7.68),('7643','2013-04-13','17:05:00',7.31),('7643','2013-04-13','17:10:00',7.13),('7643','2013-04-13','17:15:00',6.71),('7643','2013-04-13','17:20:00',6.35),('7643','2013-04-13','17:25:00',6.01),('7643','2013-04-13','17:30:00',5.74),('7643','2013-04-13','17:35:00',5.47),('7643','2013-04-13','17:40:00',5.15),('7643','2013-04-13','17:45:00',4.87),('7643','2013-04-13','17:50:00',4.54),('7643','2013-04-13','17:55:00',4.14),('7643','2013-04-13','18:00:00',3.8),('7643','2013-04-13','18:05:00',3.5),('7643','2013-04-13','18:10:00',3.15),('7643','2013-04-13','18:15:00',2.81),('7643','2013-04-13','18:20:00',2.52),('7643','2013-04-13','18:25:00',2.29),('7643','2013-04-13','18:30:00',2),('7643','2013-04-13','18:35:00',1.73),('7643','2013-04-13','18:40:00',1.52),('7643','2013-04-13','18:45:00',1.3),('7643','2013-04-13','18:50:00',1.07),('7643','2013-04-12','07:25:00',1.03),('7643','2013-04-12','07:30:00',1.49),('7643','2013-04-12','07:35:00',1.95),('7643','2013-04-12','07:40:00',2.24),('7643','2013-04-12','07:45:00',2.57),('7643','2013-04-12','07:50:00',2.87),('7643','2013-04-12','07:55:00',3.21),('7643','2013-04-12','08:00:00',3.59),('7643','2013-04-12','08:05:00',3.74),('7643','2013-04-12','08:10:00',4.16),('7643','2013-04-12','08:15:00',3.69),('7643','2013-04-12','08:20:00',2.86),('7643','2013-04-12','08:25:00',2.2),('7643','2013-04-12','08:30:00',2.12),('7643','2013-04-12','08:35:00',2.03),('7643','2013-04-12','08:40:00',2.11),('7643','2013-04-12','08:45:00',2.73),('7643','2013-04-12','08:50:00',3.63),('7643','2013-04-12','08:55:00',4.05),('7643','2013-04-12','09:00:00',4.08),('7643','2013-04-12','09:05:00',4.84),('7643','2013-04-12','09:10:00',5.98),('7643','2013-04-12','09:15:00',4.14),('7643','2013-04-12','09:20:00',5.33),('7643','2013-04-12','09:25:00',9.71),('7643','2013-04-12','09:30:00',9.15),('7643','2013-04-12','09:35:00',9.34),('7643','2013-04-12','09:40:00',8.51),('7643','2013-04-12','09:45:00',10.14),('7643','2013-04-12','09:50:00',10.31),('7643','2013-04-12','09:55:00',10.66),('7643','2013-04-12','10:00:00',10.87),('7643','2013-04-12','10:05:00',11.24),('7643','2013-04-12','10:10:00',12.14),('7643','2013-04-12','10:15:00',10.05),('7643','2013-04-12','10:20:00',7.09),('7643','2013-04-12','10:25:00',9.07),('7643','2013-04-12','10:30:00',12.16),('7643','2013-04-12','10:35:00',6.68),('7643','2013-04-12','10:40:00',13.82),('7643','2013-04-12','10:45:00',8.84),('7643','2013-04-12','10:50:00',7.77),('7643','2013-04-12','10:55:00',7.81),('7643','2013-04-12','11:00:00',5.63),('7643','2013-04-12','11:05:00',7.27),('7643','2013-04-12','11:10:00',14.9),('7643','2013-04-12','11:15:00',8.07),('7643','2013-04-12','11:20:00',16.16),('7643','2013-04-12','11:25:00',10.61),('7643','2013-04-12','11:30:00',10.2),('7643','2013-04-12','11:35:00',15.99),('7643','2013-04-12','11:40:00',15.64),('7643','2013-04-12','11:45:00',15.64),('7643','2013-04-12','11:50:00',16.58),('7643','2013-04-12','11:55:00',16.03),('7643','2013-04-12','12:00:00',16.06),('7643','2013-04-12','12:05:00',9.27),('7643','2013-04-12','12:10:00',15.87),('7643','2013-04-12','12:15:00',14.3),('7643','2013-04-12','12:20:00',12.47),('7643','2013-04-12','12:25:00',7.09),('7643','2013-04-12','12:30:00',16.87),('7643','2013-04-12','12:35:00',16.33),('7643','2013-04-12','12:40:00',16.38),('7643','2013-04-12','12:45:00',16.01),('7643','2013-04-12','12:50:00',15.52),('7643','2013-04-12','12:55:00',15.83),('7643','2013-04-12','13:00:00',15.66),('7643','2013-04-12','13:05:00',15.91),('7643','2013-04-12','13:10:00',12.84),('7643','2013-04-12','13:15:00',15.23),('7643','2013-04-12','13:20:00',16.16),('7643','2013-04-12','13:25:00',13.9),('7643','2013-04-12','13:30:00',12.46),('7643','2013-04-12','13:35:00',6.47),('7643','2013-04-12','13:40:00',8.95),('7643','2013-04-12','13:45:00',8.29),('7643','2013-04-12','13:50:00',6.78),('7643','2013-04-12','13:55:00',6),('7643','2013-04-12','14:00:00',5.76),('7643','2013-04-12','14:05:00',10.08),('7643','2013-04-12','14:10:00',6.99),('7643','2013-04-12','14:15:00',6.93),('7643','2013-04-12','14:20:00',11.46),('7643','2013-04-12','14:25:00',7.58),('7643','2013-04-12','14:30:00',14.06),('7643','2013-04-12','14:35:00',14.24),('7643','2013-04-12','14:40:00',13.74),('7643','2013-04-12','14:45:00',13.84),('7643','2013-04-12','14:50:00',13.22),('7643','2013-04-12','14:55:00',13.35),('7643','2013-04-12','15:00:00',12.15),('7643','2013-04-12','15:05:00',11.24),('7643','2013-04-12','15:10:00',11.59),('7643','2013-04-12','15:15:00',10.54),('7643','2013-04-12','15:20:00',10.59),('7643','2013-04-12','15:25:00',9.82),('7643','2013-04-12','15:30:00',10),('7643','2013-04-12','15:35:00',9.69),('7643','2013-04-12','15:40:00',10.06),('7643','2013-04-12','15:45:00',10.19),('7643','2013-04-12','15:50:00',9.77),('7643','2013-04-12','15:55:00',9.98),('7643','2013-04-12','16:00:00',9.71),('7643','2013-04-12','16:05:00',9.23),('7643','2013-04-12','16:10:00',8.64),('7643','2013-04-12','16:15:00',8.94),('7643','2013-04-12','16:20:00',8.56),('7643','2013-04-12','16:25:00',7.92),('7643','2013-04-12','16:30:00',7.52),('7643','2013-04-12','16:35:00',7.09),('7643','2013-04-12','16:40:00',6.73),('7643','2013-04-12','16:45:00',6.34),('7643','2013-04-12','16:50:00',6.53),('7643','2013-04-12','16:55:00',5.41),('7643','2013-04-12','17:00:00',4.58),('7643','2013-04-12','17:05:00',4.3),('7643','2013-04-12','17:10:00',6.02),('7643','2013-04-12','17:15:00',7.06),('7643','2013-04-12','17:20:00',5.86),('7643','2013-04-12','17:25:00',6.56),('7643','2013-04-12','17:30:00',5.73),('7643','2013-04-12','17:35:00',5.71),('7643','2013-04-12','17:40:00',5.43),('7643','2013-04-12','17:45:00',4.86),('7643','2013-04-12','17:50:00',4.24),('7643','2013-04-12','17:55:00',4.53),('7643','2013-04-12','18:00:00',3.48),('7643','2013-04-12','18:05:00',3.39),('7643','2013-04-12','18:10:00',3.04),('7643','2013-04-12','18:15:00',2.97),('7643','2013-04-12','18:20:00',2.72),('7643','2013-04-12','18:25:00',2.52),('7643','2013-04-12','18:30:00',2.28),('7643','2013-04-12','18:35:00',1.93),('7643','2013-04-12','18:40:00',1.64),('7643','2013-04-12','18:45:00',1.38),('7643','2013-04-12','18:50:00',1.14),('7643','2013-04-11','07:40:00',1.26),('7643','2013-04-11','07:45:00',1.73),('7643','2013-04-11','07:50:00',2.85),('7643','2013-04-11','07:55:00',3.4),('7643','2013-04-11','08:00:00',3.71),('7643','2013-04-11','08:05:00',4.53),('7643','2013-04-11','08:10:00',4.44),('7643','2013-04-11','08:15:00',3.45),('7643','2013-04-11','08:20:00',4.25),('7643','2013-04-11','08:25:00',3.25),('7643','2013-04-11','08:30:00',3.26),('7643','2013-04-11','08:35:00',4.65),('7643','2013-04-11','08:40:00',3.98),('7643','2013-04-11','08:45:00',4.46),('7643','2013-04-11','08:50:00',5.1),('7643','2013-04-11','08:55:00',7.11),('7643','2013-04-11','09:00:00',7.84),('7643','2013-04-11','09:05:00',7.25),('7643','2013-04-11','09:10:00',5.96),('7643','2013-04-11','09:15:00',6.83),('7643','2013-04-11','09:20:00',6.57),('7643','2013-04-11','09:25:00',4.71),('7643','2013-04-11','09:30:00',5.37),('7643','2013-04-11','09:35:00',4.37),('7643','2013-04-11','09:40:00',4.62),('7643','2013-04-11','09:45:00',5.51),('7643','2013-04-11','09:50:00',4.11),('7643','2013-04-11','09:55:00',3.29),('7643','2013-04-11','10:00:00',2.94),('7643','2013-04-11','10:05:00',3.16),('7643','2013-04-11','10:10:00',3.11),('7643','2013-04-11','10:15:00',3.79),('7643','2013-04-11','10:20:00',6.85),('7643','2013-04-11','10:25:00',4.39),('7643','2013-04-11','10:30:00',3.6),('7643','2013-04-11','10:35:00',4.34),('7643','2013-04-11','10:40:00',5.8),('7643','2013-04-11','10:45:00',12.64),('7643','2013-04-11','10:50:00',15.3),('7643','2013-04-11','10:55:00',17),('7643','2013-04-11','11:00:00',11.56),('7643','2013-04-11','11:05:00',12),('7643','2013-04-11','11:10:00',6.75),('7643','2013-04-11','11:15:00',14.76),('7643','2013-04-11','11:20:00',14.03),('7643','2013-04-11','11:25:00',13.75),('7643','2013-04-11','11:30:00',12.5),('7643','2013-04-11','11:35:00',15.95),('7643','2013-04-11','11:40:00',16.72),('7643','2013-04-11','11:45:00',12.56),('7643','2013-04-11','11:50:00',15.21),('7643','2013-04-11','11:55:00',15.91),('7643','2013-04-11','12:00:00',15.83),('7643','2013-04-11','12:05:00',15.2),('7643','2013-04-11','12:10:00',14.92),('7643','2013-04-11','12:15:00',15.57),('7643','2013-04-11','12:20:00',16),('7643','2013-04-11','12:25:00',16.09),('7643','2013-04-11','12:30:00',15.92),('7643','2013-04-11','12:35:00',15.83),('7643','2013-04-11','12:40:00',15.23),('7643','2013-04-11','12:45:00',15.52),('7643','2013-04-11','12:50:00',15.68),('7643','2013-04-11','12:55:00',15.74),('7643','2013-04-11','13:00:00',15.87),('7643','2013-04-11','13:05:00',15.91),('7643','2013-04-11','13:10:00',15.94),('7643','2013-04-11','13:15:00',15.91),('7643','2013-04-11','13:20:00',15.95),('7643','2013-04-11','13:25:00',15.95),('7643','2013-04-11','13:30:00',15.78),('7643','2013-04-11','13:35:00',15.97),('7643','2013-04-11','13:40:00',15.83),('7643','2013-04-11','13:45:00',15.83),('7643','2013-04-11','13:50:00',15.72),('7643','2013-04-11','13:55:00',15.65),('7643','2013-04-11','14:00:00',15.52),('7643','2013-04-11','14:05:00',15.44),('7643','2013-04-11','14:10:00',15.36),('7643','2013-04-11','14:15:00',15.23),('7643','2013-04-11','14:20:00',15.12),('7643','2013-04-11','14:25:00',14.91),('7643','2013-04-11','14:30:00',14.71),('7643','2013-04-11','14:35:00',14.59),('7643','2013-04-11','14:40:00',14.48),('7643','2013-04-11','14:45:00',14.3),('7643','2013-04-11','14:50:00',14.16),('7643','2013-04-11','14:55:00',13.99),('7643','2013-04-11','15:00:00',13.87),('7643','2013-04-11','15:05:00',13.69),('7643','2013-04-11','15:10:00',13.45),('7643','2013-04-11','15:15:00',13.35),('7643','2013-04-11','15:20:00',13.07),('7643','2013-04-11','15:25:00',12.9),('7643','2013-04-11','15:30:00',12.67),('7643','2013-04-11','15:35:00',12.46),('7643','2013-04-11','15:40:00',12.2),('7643','2013-04-11','15:45:00',11.98),('7643','2013-04-11','15:50:00',11.79),('7643','2013-04-11','15:55:00',11.51),('7643','2013-04-11','16:00:00',11.29),('7643','2013-04-11','16:05:00',11.1),('7643','2013-04-11','16:10:00',10.91),('7643','2013-04-11','16:15:00',9.62),('7643','2013-04-11','16:20:00',10.39),('7643','2013-04-11','16:25:00',10.13),('7643','2013-04-11','16:30:00',6.4),('7643','2013-04-11','16:35:00',4.15),('7643','2013-04-11','16:40:00',6.1),('7643','2013-04-11','16:45:00',9.26),('7643','2013-04-11','16:50:00',8.53),('7643','2013-04-11','16:55:00',8.2),('7643','2013-04-11','17:00:00',7.88),('7643','2013-04-11','17:05:00',7.58),('7643','2013-04-11','17:10:00',7.24),('7643','2013-04-11','17:15:00',6.86),('7643','2013-04-11','17:20:00',6.55),('7643','2013-04-11','17:25:00',6.2),('7643','2013-04-11','17:30:00',5.92),('7643','2013-04-11','17:35:00',5.62),('7643','2013-04-11','17:40:00',5.3),('7643','2013-04-11','17:45:00',4.95),('7643','2013-04-11','17:50:00',4.58),('7643','2013-04-11','17:55:00',4.21),('7643','2013-04-11','18:00:00',3.85),('7643','2013-04-11','18:05:00',3.49),('7643','2013-04-11','18:10:00',3.04),('7643','2013-04-11','18:15:00',2.72),('7643','2013-04-11','18:20:00',2.43),('7643','2013-04-11','18:25:00',2.19),('7643','2013-04-11','18:30:00',1.45),('7643','2013-04-11','18:35:00',1.54),('7643','2013-04-11','18:40:00',1.35),('7643','2013-04-11','18:50:00',1.05),('7643','2014-03-27','06:45:00',1.16),('7643','2014-03-27','06:50:00',1.54),('7643','2014-03-27','06:55:00',1.78),('7643','2014-03-27','07:00:00',2.28),('7643','2014-03-27','07:05:00',3.08),('7643','2014-03-27','07:10:00',3.67),('7643','2014-03-27','07:15:00',4.03),('7643','2014-03-27','07:20:00',4.3),('7643','2014-03-27','07:25:00',4.51),('7643','2014-03-27','07:30:00',4.44),('7643','2014-03-27','07:35:00',5.47),('7643','2014-03-27','07:40:00',5.64),('7643','2014-03-27','07:45:00',6.32),('7643','2014-03-27','07:50:00',6.77),('7643','2014-03-27','07:55:00',7.08),('7643','2014-03-27','08:00:00',7.39),('7643','2014-03-27','08:05:00',7.79),('7643','2014-03-27','08:10:00',8.2),('7643','2014-03-27','08:15:00',8.65),('7643','2014-03-27','08:20:00',9.02),('7643','2014-03-27','08:25:00',9.29),('7643','2014-03-27','08:30:00',9.6),('7643','2014-03-27','08:35:00',9.91),('7643','2014-03-27','08:40:00',10.26),('7643','2014-03-27','08:45:00',10.55),('7643','2014-03-27','08:50:00',10.85),('7643','2014-03-27','08:55:00',11.24),('7643','2014-03-27','09:00:00',11.35),('7643','2014-03-27','09:05:00',11.87),('7643','2014-03-27','09:10:00',12.61),('7643','2014-03-27','09:15:00',12.69),('7643','2014-03-27','09:20:00',11.11),('7643','2014-03-27','09:25:00',13.26),('7643','2014-03-27','09:30:00',14.07),('7643','2014-03-27','09:35:00',13.4),('7643','2014-03-27','09:40:00',8.67),('7643','2014-03-27','09:45:00',6.4),('7643','2014-03-27','09:50:00',9.13),('7643','2014-03-27','09:55:00',13.48),('7643','2014-03-27','10:00:00',15.06),('7643','2014-03-27','10:05:00',14.9),('7643','2014-03-27','10:10:00',13.28),('7643','2014-03-27','10:15:00',11.06),('7643','2014-03-27','10:20:00',10.55),('7643','2014-03-27','10:25:00',13.69),('7643','2014-03-27','10:30:00',15.12),('7643','2014-03-27','10:35:00',13.62),('7643','2014-03-27','10:40:00',14.03),('7643','2014-03-27','10:45:00',11.25),('7643','2014-03-27','10:50:00',15.2),('7643','2014-03-27','10:55:00',16.09),('7643','2014-03-27','11:00:00',16.21),('7643','2014-03-27','11:05:00',16),('7643','2014-03-27','11:10:00',9.69),('7643','2014-03-27','11:15:00',13.08),('7643','2014-03-27','11:20:00',13.82),('7643','2014-03-27','11:25:00',8.78),('7643','2014-03-27','11:30:00',10.07),('7643','2014-03-27','11:35:00',14.5),('7643','2014-03-27','11:40:00',9.92),('7643','2014-03-27','11:45:00',4.9),('7643','2014-03-27','11:50:00',4.99),('7643','2014-03-27','11:55:00',4.77),('7643','2014-03-27','12:00:00',5.39),('7643','2014-03-27','12:05:00',5.66),('7643','2014-03-27','12:10:00',18.7),('7643','2014-03-27','12:15:00',18.64),('7643','2014-03-27','12:20:00',18.7),('7643','2014-03-27','12:25:00',8.3),('7643','2014-03-27','12:30:00',4.02),('7643','2014-03-27','12:35:00',12.17),('7643','2014-03-27','12:40:00',14.78),('7643','2014-03-27','12:45:00',16.76),('7643','2014-03-27','12:50:00',17.03),('7643','2014-03-27','12:55:00',17.61),('7643','2014-03-27','13:00:00',18.12),('7643','2014-03-27','13:05:00',10.09),('7643','2014-03-27','13:10:00',6.06),('7643','2014-03-27','13:15:00',6.1),('7643','2014-03-27','13:20:00',14.83),('7643','2014-03-27','13:25:00',11.28),('7643','2014-03-27','13:30:00',7.5),('7643','2014-03-27','13:35:00',16.9),('7643','2014-03-27','13:40:00',16.38),('7643','2014-03-27','13:45:00',15.97),('7643','2014-03-27','13:50:00',15.57),('7643','2014-03-27','13:55:00',14.73),('7643','2014-03-27','14:00:00',15.11),('7643','2014-03-27','14:05:00',14.88),('7643','2014-03-27','14:10:00',14.19),('7643','2014-03-27','14:15:00',14.45),('7643','2014-03-27','14:20:00',14.3),('7643','2014-03-27','14:25:00',14.01),('7643','2014-03-27','14:30:00',13.83),('7643','2014-03-27','14:35:00',13.62),('7643','2014-03-27','14:40:00',13.43),('7643','2014-03-27','14:45:00',13.22),('7643','2014-03-27','14:50:00',13.04),('7643','2014-03-27','14:55:00',12.74),('7643','2014-03-27','15:00:00',12.63),('7643','2014-03-27','15:05:00',12.33),('7643','2014-03-27','15:10:00',11.97),('7643','2014-03-27','15:15:00',11.65),('7643','2014-03-27','15:20:00',11.39),('7643','2014-03-27','15:25:00',11),('7643','2014-03-27','15:30:00',10.73),('7643','2014-03-27','15:35:00',10.42),('7643','2014-03-27','15:40:00',10.13),('7643','2014-03-27','15:45:00',10.06),('7643','2014-03-27','15:50:00',9.87),('7643','2014-03-27','15:55:00',9.47),('7643','2014-03-27','16:00:00',9.74),('7643','2014-03-27','16:05:00',9.84),('7643','2014-03-27','16:10:00',9.52),('7643','2014-03-27','16:15:00',9.26),('7643','2014-03-27','16:20:00',8.08),('7643','2014-03-27','16:25:00',7.01),('7643','2014-03-27','16:30:00',6.13),('7643','2014-03-27','16:35:00',4.23),('7643','2014-03-27','16:40:00',4.74),('7643','2014-03-27','16:45:00',4.67),('7643','2014-03-27','16:50:00',4.92),('7643','2014-03-27','16:55:00',1.17),('7643','2014-03-27','17:00:00',1.99),('7643','2014-03-27','17:05:00',3.39),('7643','2014-03-27','17:10:00',3.17),('7643','2014-03-27','17:15:00',3.15),('7643','2014-03-27','17:20:00',3.39),('7643','2014-03-27','17:25:00',2.18),('7643','2014-03-27','17:30:00',1.21),('7643','2014-03-27','17:35:00',1.39),('7643','2014-03-27','17:40:00',1.33),('7643','2014-03-27','17:45:00',1.46),('7643','2014-03-27','17:50:00',1.11),('7643','2013-04-09','07:15:00',1.18),('7643','2013-04-09','07:20:00',1.44),('7643','2013-04-09','07:25:00',1.59),('7643','2013-04-09','07:30:00',1.54),('7643','2013-04-09','07:35:00',1.57),('7643','2013-04-09','07:40:00',1.37),('7643','2013-04-09','07:55:00',1.03),('7643','2013-04-09','08:00:00',1.44),('7643','2013-04-09','08:05:00',1.68),('7643','2013-04-09','08:10:00',1.75),('7643','2013-04-09','08:15:00',1.4),('7643','2013-04-09','08:20:00',1.1),('7643','2013-04-09','08:35:00',1.41),('7643','2013-04-09','08:40:00',1.5),('7643','2013-04-09','08:45:00',1.08),('7643','2013-04-09','08:50:00',1.45),('7643','2013-04-09','08:55:00',6.1),('7643','2013-04-09','09:00:00',7.33),('7643','2013-04-09','09:05:00',8.07),('7643','2013-04-09','09:10:00',8.6),('7643','2013-04-09','09:15:00',8.38),('7643','2013-04-09','09:20:00',8.75),('7643','2013-04-09','09:25:00',9.08),('7643','2013-04-09','09:30:00',9.49),('7643','2013-04-09','09:35:00',9.85),('7643','2013-04-09','09:40:00',10.09),('7643','2013-04-09','09:45:00',10.49),('7643','2013-04-09','09:50:00',10.81),('7643','2013-04-09','09:55:00',11.21),('7643','2013-04-09','10:00:00',11.43),('7643','2013-04-09','10:05:00',11.81),('7643','2013-04-09','10:10:00',12.32),('7643','2013-04-09','10:15:00',13.17),('7643','2013-04-09','10:20:00',13.15),('7643','2013-04-09','10:25:00',13.34),('7643','2013-04-09','10:30:00',13.42),('7643','2013-04-09','10:35:00',13.5),('7643','2013-04-09','10:40:00',13.63),('7643','2013-04-09','10:45:00',13.96),('7643','2013-04-09','10:50:00',13.23),('7643','2013-04-09','10:55:00',12.96),('7643','2013-04-09','11:00:00',13.29),('7643','2013-04-09','11:05:00',13.08),('7643','2013-04-09','11:10:00',12.12),('7643','2013-04-09','11:15:00',12.06),('7643','2013-04-09','11:20:00',14.21),('7643','2013-04-09','11:25:00',14.72),('7643','2013-04-09','11:30:00',14.92),('7643','2013-04-09','11:35:00',15.03),('7643','2013-04-09','11:40:00',14.11),('7643','2013-04-09','11:45:00',15.32),('7643','2013-04-09','11:50:00',15.39),('7643','2013-04-09','11:55:00',15.51),('7643','2013-04-09','12:00:00',15.58),('7643','2013-04-09','12:05:00',15.69),('7643','2013-04-09','12:10:00',15.8),('7643','2013-04-09','12:15:00',15.89),('7643','2013-04-09','12:20:00',16.05),('7643','2013-04-09','12:25:00',16.26),('7643','2013-04-09','12:30:00',16.43),('7643','2013-04-09','12:35:00',16.39),('7643','2013-04-09','12:40:00',16.3),('7643','2013-04-09','12:45:00',16.4),('7643','2013-04-09','12:50:00',16.54),('7643','2013-04-09','12:55:00',16.71),('7643','2013-04-09','13:00:00',17.17),('7643','2013-04-09','13:05:00',16.97),('7643','2013-04-09','13:10:00',14.14),('7643','2013-04-09','13:15:00',9.7),('7643','2013-04-09','13:20:00',9.43),('7643','2013-04-09','13:25:00',6.87),('7643','2013-04-09','13:30:00',10.99),('7643','2013-04-09','13:35:00',10.56),('7643','2013-04-09','13:40:00',13.39),('7643','2013-04-09','13:45:00',11.89),('7643','2013-04-09','13:50:00',17.34),('7643','2013-04-09','13:55:00',6.31),('7643','2013-04-09','14:00:00',15.38),('7643','2013-04-09','14:05:00',13.31),('7643','2013-04-09','14:10:00',15.47),('7643','2013-04-09','14:15:00',16.07),('7643','2013-04-09','14:20:00',16.23),('7643','2013-04-09','14:25:00',16.03),('7643','2013-04-09','14:30:00',15.68),('7643','2013-04-09','14:35:00',14.57),('7643','2013-04-09','14:40:00',15.42),('7643','2013-04-09','14:45:00',8.35),('7643','2013-04-09','14:50:00',12.85),('7643','2013-04-09','14:55:00',15.48),('7643','2013-04-09','15:00:00',9.94),('7643','2013-04-09','15:05:00',9.82),('7643','2013-04-09','15:10:00',10.5),('7643','2013-04-09','15:15:00',11.91),('7643','2013-04-09','15:20:00',10.35),('7643','2013-04-09','15:25:00',11.46),('7643','2013-04-09','15:30:00',12.96),('7643','2013-04-09','15:35:00',11.7),('7643','2013-04-09','15:40:00',12.9),('7643','2013-04-09','15:45:00',12.75),('7643','2013-04-09','15:50:00',12.59),('7643','2013-04-09','15:55:00',12.83),('7643','2013-04-09','16:00:00',12.25),('7643','2013-04-09','16:05:00',11.8),('7643','2013-04-09','16:10:00',12.11),('7643','2013-04-09','16:15:00',9.49),('7643','2013-04-09','16:20:00',11.31),('7643','2013-04-09','16:25:00',10.16),('7643','2013-04-09','16:30:00',10.38),('7643','2013-04-09','16:35:00',7.02),('7643','2013-04-09','16:40:00',9.88),('7643','2013-04-09','16:45:00',8.73),('7643','2013-04-09','16:50:00',7.98),('7643','2013-04-09','16:55:00',6.65),('7643','2013-04-09','17:00:00',7.86),('7643','2013-04-09','17:05:00',8.04),('7643','2013-04-09','17:10:00',3.58),('7643','2013-04-09','17:15:00',6.42),('7643','2013-04-09','17:20:00',7.38),('7643','2013-04-09','17:25:00',5.03),('7643','2013-04-09','17:30:00',6.17),('7643','2013-04-09','17:35:00',4.29),('7643','2013-04-09','17:40:00',6.08),('7643','2013-04-09','17:45:00',5.16),('7643','2013-04-09','17:50:00',5.29),('7643','2013-04-09','17:55:00',4.47),('7643','2013-04-09','18:00:00',4.27),('7643','2013-04-09','18:05:00',3.08),('7643','2013-04-09','18:10:00',2.62),('7643','2013-04-09','18:15:00',2.9),('7643','2013-04-09','18:20:00',2.22),('7643','2013-04-09','18:25:00',1.28),('7643','2013-04-08','07:25:00',1.18),('7643','2013-04-08','07:30:00',1.51),('7643','2013-04-08','07:35:00',1.98),('7643','2013-04-08','07:40:00',2.53),('7643','2013-04-08','07:45:00',2.03),('7643','2013-04-08','07:50:00',2.6),('7643','2013-04-08','07:55:00',3.44),('7643','2013-04-08','08:00:00',2.97),('7643','2013-04-08','08:05:00',3.14),('7643','2013-04-08','08:10:00',2.91),('7643','2013-04-08','08:15:00',2.68),('7643','2013-04-08','08:20:00',4.32),('7643','2013-04-08','08:25:00',2.88),('7643','2013-04-08','08:30:00',4.27),('7643','2013-04-08','08:35:00',3.59),('7643','2013-04-08','08:40:00',1.89),('7643','2013-04-08','08:45:00',2.02),('7643','2013-04-08','08:50:00',2.57),('7643','2013-04-08','08:55:00',2.36),('7643','2013-04-08','09:00:00',2.82),('7643','2013-04-08','09:05:00',3.67),('7643','2013-04-08','09:10:00',3.72),('7643','2013-04-08','09:15:00',4.1),('7643','2013-04-08','09:20:00',3.79),('7643','2013-04-08','09:25:00',4.05),('7643','2013-04-08','09:30:00',4.97),('7643','2013-04-08','09:35:00',4.27),('7643','2013-04-08','09:40:00',2.69),('7643','2013-04-08','09:45:00',5.39),('7643','2013-04-08','09:50:00',7.57),('7643','2013-04-08','09:55:00',11.92),('7643','2013-04-08','10:00:00',11.79),('7643','2013-04-08','10:05:00',6.51),('7643','2013-04-08','10:10:00',7.26),('7643','2013-04-08','10:15:00',7.91),('7643','2013-04-08','10:20:00',7.06),('7643','2013-04-08','10:25:00',4.79),('7643','2013-04-08','10:30:00',2.63),('7643','2013-04-08','10:35:00',12.82),('7643','2013-04-08','10:40:00',12.47),('7643','2013-04-08','10:45:00',13.68),('7643','2013-04-08','10:50:00',15.56),('7643','2013-04-08','10:55:00',12.68),('7643','2013-04-08','11:00:00',15.71),('7643','2013-04-08','11:05:00',11.45),('7643','2013-04-08','11:10:00',14.92),('7643','2013-04-08','11:15:00',8.98),('7643','2013-04-08','11:20:00',3.25),('7643','2013-04-08','11:25:00',9.13),('7643','2013-04-08','11:30:00',13.98),('7643','2013-04-08','11:35:00',15.15),('7643','2013-04-08','11:40:00',9.37),('7643','2013-04-08','11:45:00',12.04),('7643','2013-04-08','11:50:00',13.06),('7643','2013-04-08','11:55:00',12.38),('7643','2013-04-08','12:00:00',17.41),('7643','2013-04-08','12:05:00',17.02),('7643','2013-04-08','12:10:00',17.06),('7643','2013-04-08','12:15:00',16.94),('7643','2013-04-08','12:20:00',17.33),('7643','2013-04-08','12:25:00',16.47),('7643','2013-04-08','12:30:00',16.75),('7643','2013-04-08','12:35:00',17.33),('7643','2013-04-08','12:40:00',17),('7643','2013-04-08','12:45:00',17.57),('7643','2013-04-08','12:50:00',17.24),('7643','2013-04-08','12:55:00',16.99),('7643','2013-04-08','13:00:00',15.53),('7643','2013-04-08','13:05:00',17.55),('7643','2013-04-08','13:10:00',17.82),('7643','2013-04-08','13:15:00',9.56),('7643','2013-04-08','13:20:00',10.51),('7643','2013-04-08','13:25:00',10.87),('7643','2013-04-08','13:30:00',9.89),('7643','2013-04-08','13:35:00',4.52),('7643','2013-04-08','13:40:00',15.74),('7643','2013-04-08','13:45:00',16.68),('7643','2013-04-08','13:50:00',12.22),('7643','2013-04-08','13:55:00',16.29),('7643','2013-04-08','14:00:00',15.36),('7643','2013-04-08','14:05:00',15.69),('7643','2013-04-08','14:10:00',8.26),('7643','2013-04-08','14:15:00',11.66),('7643','2013-04-08','14:20:00',10.84),('7643','2013-04-08','14:25:00',13.61),('7643','2013-04-08','14:30:00',11.18),('7643','2013-04-08','14:35:00',13.94),('7643','2013-04-08','14:40:00',11.58),('7643','2013-04-08','14:45:00',13.56),('7643','2013-04-08','14:50:00',13.02),('7643','2013-04-08','14:55:00',11.48),('7643','2013-04-08','15:00:00',15.59),('7643','2013-04-08','15:05:00',12.42),('7643','2013-04-08','15:10:00',14.71),('7643','2013-04-08','15:15:00',13.89),('7643','2013-04-08','15:20:00',12.04),('7643','2013-04-08','15:25:00',14.76),('7643','2013-04-08','15:30:00',14.16),('7643','2013-04-08','15:35:00',14.23),('7643','2013-04-08','15:40:00',10.15),('7643','2013-04-08','15:45:00',13.93),('7643','2013-04-08','15:50:00',13.64),('7643','2013-04-08','15:55:00',10.67),('7643','2013-04-08','16:00:00',9.76),('7643','2013-04-08','16:05:00',6.57),('7643','2013-04-08','16:10:00',9.32),('7643','2013-04-08','16:15:00',3.29),('7643','2013-04-08','16:20:00',2.6),('7643','2013-04-08','16:25:00',3.95),('7643','2013-04-08','16:30:00',3.6),('7643','2013-04-08','16:35:00',3.63),('7643','2013-04-08','16:40:00',3.66),('7643','2013-04-08','16:45:00',4.47),('7643','2013-04-08','16:50:00',11.38),('7643','2013-04-08','16:55:00',7.42),('7643','2013-04-08','17:00:00',4.85),('7643','2013-04-08','17:05:00',2.77),('7643','2013-04-08','17:10:00',2.19),('7643','2013-04-08','17:15:00',3.48),('7643','2013-04-08','17:20:00',5.52),('7643','2013-04-08','17:25:00',3.83),('7643','2013-04-08','17:30:00',3.01),('7643','2013-04-08','17:35:00',2.39),('7643','2013-04-08','17:40:00',3.42),('7643','2013-04-08','17:45:00',3.3),('7643','2013-04-08','17:50:00',2.29),('7643','2013-04-08','17:55:00',1.98),('7643','2013-04-08','18:00:00',2.15),('7643','2013-04-08','18:05:00',2.18),('7643','2013-04-08','18:10:00',2.02),('7643','2013-04-08','18:15:00',2.66),('7643','2013-04-08','18:20:00',3.03),('7643','2013-04-08','18:25:00',1.37),('7643','2013-04-08','18:30:00',1.21),('7643','2013-04-08','18:35:00',1.17),('7643','2013-04-08','18:40:00',1.06),('7643','2013-04-07','07:30:00',1.42),('7643','2013-04-07','07:35:00',1.37),('7643','2013-04-07','07:40:00',1.55),('7643','2013-04-07','07:45:00',1.57),('7643','2013-04-07','07:50:00',1.59),('7643','2013-04-07','07:55:00',1.92),('7643','2013-04-07','08:00:00',2.06),('7643','2013-04-07','08:05:00',2.08),('7643','2013-04-07','08:10:00',3.21),('7643','2013-04-07','08:15:00',2.84),('7643','2013-04-07','08:20:00',2.72),('7643','2013-04-07','08:25:00',2.97),('7643','2013-04-07','08:30:00',2.86),('7643','2013-04-07','08:35:00',3.07),('7643','2013-04-07','08:40:00',6.01),('7643','2013-04-07','08:45:00',3.92),('7643','2013-04-07','08:50:00',5.36),('7643','2013-04-07','08:55:00',7),('7643','2013-04-07','09:00:00',5.17),('7643','2013-04-07','09:05:00',6.18),('7643','2013-04-07','09:10:00',9.66),('7643','2013-04-07','09:15:00',7.3),('7643','2013-04-07','09:20:00',6.97),('7643','2013-04-07','09:25:00',9.38),('7643','2013-04-07','09:30:00',9.9),('7643','2013-04-07','09:35:00',10.34),('7643','2013-04-07','09:40:00',10.36),('7643','2013-04-07','09:45:00',10.69),('7643','2013-04-07','09:50:00',6.69),('7643','2013-04-07','09:55:00',6.86),('7643','2013-04-07','10:00:00',11.31),('7643','2013-04-07','10:05:00',12.22),('7643','2013-04-07','10:10:00',11.47),('7643','2013-04-07','10:15:00',11.83),('7643','2013-04-07','10:20:00',11.66),('7643','2013-04-07','10:25:00',11.9),('7643','2013-04-07','10:30:00',12.24),('7643','2013-04-07','10:35:00',11.6),('7643','2013-04-07','10:40:00',13.05),('7643','2013-04-07','10:45:00',13.71),('7643','2013-04-07','10:50:00',13.63),('7643','2013-04-07','10:55:00',13.06),('7643','2013-04-07','11:00:00',13.76),('7643','2013-04-07','11:05:00',12.1),('7643','2013-04-07','11:10:00',11.46),('7643','2013-04-07','11:15:00',10.37),('7643','2013-04-07','11:20:00',8.91),('7643','2013-04-07','11:25:00',7.56),('7643','2013-04-07','11:30:00',8.5),('7643','2013-04-07','11:35:00',11.18),('7643','2013-04-07','11:40:00',12.43),('7643','2013-04-07','11:45:00',10.74),('7643','2013-04-07','11:50:00',9.96),('7643','2013-04-07','11:55:00',8.6),('7643','2013-04-07','12:00:00',8.16),('7643','2013-04-07','12:05:00',7.71),('7643','2013-04-07','12:10:00',8.21),('7643','2013-04-07','12:15:00',9.74),('7643','2013-04-07','12:20:00',9.99),('7643','2013-04-07','12:25:00',9.91),('7643','2013-04-07','12:30:00',11.29),('7643','2013-04-07','12:35:00',8.17),('7643','2013-04-07','12:40:00',9.46),('7643','2013-04-07','12:45:00',11.88),('7643','2013-04-07','12:50:00',9.18),('7643','2013-04-07','12:55:00',6.09),('7643','2013-04-07','13:00:00',5.73),('7643','2013-04-07','13:05:00',7.19),('7643','2013-04-07','13:10:00',9.74),('7643','2013-04-07','13:15:00',13.04),('7643','2013-04-07','13:20:00',13.65),('7643','2013-04-07','13:25:00',11.12),('7643','2013-04-07','13:30:00',10.86),('7643','2013-04-07','13:35:00',11.36),('7643','2013-04-07','13:40:00',10.94),('7643','2013-04-07','13:45:00',12.21),('7643','2013-04-07','13:50:00',9.85),('7643','2013-04-07','13:55:00',14.34),('7643','2013-04-07','14:00:00',14.22),('7643','2013-04-07','14:05:00',13.07),('7643','2013-04-07','14:10:00',12.7),('7643','2013-04-07','14:15:00',14.25),('7643','2013-04-07','14:20:00',12.97),('7643','2013-04-07','14:25:00',14.97),('7643','2013-04-07','14:30:00',14.53),('7643','2013-04-07','14:35:00',13.46),('7643','2013-04-07','14:40:00',13.59),('7643','2013-04-07','14:45:00',14.57),('7643','2013-04-07','14:50:00',13.62),('7643','2013-04-07','14:55:00',14.51),('7643','2013-04-07','15:00:00',11.53),('7643','2013-04-07','15:05:00',11.09),('7643','2013-04-07','15:10:00',10.76),('7643','2013-04-07','15:15:00',11.47),('7643','2013-04-07','15:20:00',11.16),('7643','2013-04-07','15:25:00',13.09),('7643','2013-04-07','15:30:00',13.53),('7643','2013-04-07','15:35:00',12.83),('7643','2013-04-07','15:40:00',12.4),('7643','2013-04-07','15:45:00',12.16),('7643','2013-04-07','15:50:00',11.96),('7643','2013-04-07','15:55:00',11.65),('7643','2013-04-07','16:00:00',11.39),('7643','2013-04-07','16:05:00',10.79),('7643','2013-04-07','16:10:00',10.08),('7643','2013-04-07','16:15:00',10.7),('7643','2013-04-07','16:20:00',10.7),('7643','2013-04-07','16:25:00',10.17),('7643','2013-04-07','16:30:00',9.86),('7643','2013-04-07','16:35:00',9.57),('7643','2013-04-07','16:40:00',9.33),('7643','2013-04-07','16:45:00',9.03),('7643','2013-04-07','16:50:00',8.74),('7643','2013-04-07','16:55:00',8.39),('7643','2013-04-07','17:00:00',8.12),('7643','2013-04-07','17:05:00',7.82),('7643','2013-04-07','17:10:00',7.28),('7643','2013-04-07','17:15:00',6.93),('7643','2013-04-07','17:20:00',6.51),('7643','2013-04-07','17:25:00',6.66),('7643','2013-04-07','17:30:00',6.17),('7643','2013-04-07','17:35:00',5.71),('7643','2013-04-07','17:40:00',5.15),('7643','2013-04-07','17:45:00',4.71),('7643','2013-04-07','17:50:00',3.83),('7643','2013-04-07','17:55:00',3.33),('7643','2013-04-07','18:00:00',3.51),('7643','2013-04-07','18:05:00',2.4),('7643','2013-04-07','18:10:00',1.8),('7643','2013-04-07','18:15:00',2.58),('7643','2013-04-07','18:20:00',3.74),('7643','2013-04-07','18:25:00',3.33),('7643','2013-04-07','18:30:00',2.08),('7643','2013-04-07','18:35:00',1.04),('7643','2013-04-06','07:50:00',1.14),('7643','2013-04-06','07:55:00',1.3),('7643','2013-04-06','08:00:00',1.5),('7643','2013-04-06','08:05:00',1.76),('7643','2013-04-06','08:10:00',2.11),('7643','2013-04-06','08:15:00',2.49),('7643','2013-04-06','08:20:00',3.03),('7643','2013-04-06','08:25:00',3.53),('7643','2013-04-06','08:30:00',4),('7643','2013-04-06','08:35:00',4.43),('7643','2013-04-06','08:40:00',4.74),('7643','2013-04-06','08:45:00',4.82),('7643','2013-04-06','08:50:00',4.92),('7643','2013-04-06','08:55:00',5.07),('7643','2013-04-06','09:00:00',4.92),('7643','2013-04-06','09:05:00',5.2),('7643','2013-04-06','09:10:00',5.61),('7643','2013-04-06','09:15:00',5.63),('7643','2013-04-06','09:20:00',5.96),('7643','2013-04-06','09:25:00',5.77),('7643','2013-04-06','09:30:00',5.53),('7643','2013-04-06','09:35:00',5.31),('7643','2013-04-06','09:40:00',5.32),('7643','2013-04-06','09:45:00',6.86),('7643','2013-04-06','09:50:00',7.7),('7643','2013-04-06','09:55:00',8.49),('7643','2013-04-06','10:00:00',9.91),('7643','2013-04-06','10:05:00',10.26),('7643','2013-04-06','10:10:00',10.18),('7643','2013-04-06','10:15:00',10.5),('7643','2013-04-06','10:20:00',10.6),('7643','2013-04-06','10:25:00',10.44),('7643','2013-04-06','10:30:00',9.11),('7643','2013-04-06','10:35:00',10.34),('7643','2013-04-06','10:40:00',10.28),('7643','2013-04-06','10:45:00',10.04),('7643','2013-04-06','10:50:00',9.54),('7643','2013-04-06','10:55:00',8.46),('7643','2013-04-06','11:00:00',7.72),('7643','2013-04-06','11:05:00',6.91),('7643','2013-04-06','11:10:00',8.35),('7643','2013-04-06','11:15:00',11.5),('7643','2013-04-06','11:20:00',13.19),('7643','2013-04-06','11:25:00',14.3),('7643','2013-04-06','11:30:00',13.4),('7643','2013-04-06','11:35:00',12.73),('7643','2013-04-06','11:40:00',11.01),('7643','2013-04-06','11:45:00',9.13),('7643','2013-04-06','11:50:00',8.67),('7643','2013-04-06','11:55:00',8.94),('7643','2013-04-06','12:00:00',9.38),('7643','2013-04-06','12:05:00',9.1),('7643','2013-04-06','12:10:00',9.97),('7643','2013-04-06','12:15:00',9.56),('7643','2013-04-06','12:20:00',10.77),('7643','2013-04-06','12:25:00',11.55),('7643','2013-04-06','12:30:00',9.99),('7643','2013-04-06','12:35:00',10.96),('7643','2013-04-06','12:40:00',10.2),('7643','2013-04-06','12:45:00',8.92),('7643','2013-04-06','12:50:00',9.98),('7643','2013-04-06','12:55:00',10.22),('7643','2013-04-06','13:00:00',12.44),('7643','2013-04-06','13:05:00',13.26),('7643','2013-04-06','13:10:00',12.38),('7643','2013-04-06','13:15:00',11.38),('7643','2013-04-06','13:20:00',10.86),('7643','2013-04-06','13:25:00',12.51),('7643','2013-04-06','13:30:00',11.96),('7643','2013-04-06','13:35:00',11.37),('7643','2013-04-06','13:40:00',12.77),('7643','2013-04-06','13:45:00',12.42),('7643','2013-04-06','13:50:00',11.6),('7643','2013-04-06','13:55:00',11.8),('7643','2013-04-06','14:00:00',12.48),('7643','2013-04-06','14:05:00',11.35),('7643','2013-04-06','14:10:00',9.67),('7643','2013-04-06','14:15:00',9.06),('7643','2013-04-06','14:20:00',8.6),('7643','2013-04-06','14:25:00',7.96),('7643','2013-04-06','14:30:00',8.97),('7643','2013-04-06','14:35:00',9.31),('7643','2013-04-06','14:40:00',8.77),('7643','2013-04-06','14:45:00',7.92),('7643','2013-04-06','14:50:00',8.33),('7643','2013-04-06','14:55:00',8.67),('7643','2013-04-06','15:00:00',7.39),('7643','2013-04-06','15:05:00',10.54),('7643','2013-04-06','15:10:00',10.95),('7643','2013-04-06','15:15:00',11.06),('7643','2013-04-06','15:20:00',10.29),('7643','2013-04-06','15:25:00',10.25),('7643','2013-04-06','15:30:00',11.47),('7643','2013-04-06','15:35:00',10.24),('7643','2013-04-06','15:40:00',10.8),('7643','2013-04-06','15:45:00',10.14),('7643','2013-04-06','15:50:00',9.57),('7643','2013-04-06','15:55:00',9.45),('7643','2013-04-06','16:00:00',8.98),('7643','2013-04-06','16:05:00',7.87),('7643','2013-04-06','16:10:00',6.7),('7643','2013-04-06','16:15:00',5.93),('7643','2013-04-06','16:20:00',5.57),('7643','2013-04-06','16:25:00',4.96),('7643','2013-04-06','16:30:00',4.96),('7643','2013-04-06','16:35:00',6.1),('7643','2013-04-06','16:40:00',6.3),('7643','2013-04-06','16:45:00',7.45),('7643','2013-04-06','16:50:00',8.29),('7643','2013-04-06','16:55:00',8.26),('7643','2013-04-06','17:00:00',7.65),('7643','2013-04-06','17:05:00',6.26),('7643','2013-04-06','17:10:00',4.26),('7643','2013-04-06','17:15:00',3.25),('7643','2013-04-06','17:20:00',5.02),('7643','2013-04-06','17:25:00',7.06),('7643','2013-04-06','17:30:00',6.44),('7643','2013-04-06','17:35:00',6.09),('7643','2013-04-06','17:40:00',6.01),('7643','2013-04-06','17:45:00',5.67),('7643','2013-04-06','17:50:00',5.21),('7643','2013-04-06','17:55:00',4.47),('7643','2013-04-06','18:00:00',3.19),('7643','2013-04-06','18:05:00',2.37),('7643','2013-04-06','18:10:00',2.29),('7643','2013-04-06','18:15:00',1.77),('7643','2013-04-06','18:20:00',1.55),('7643','2013-04-06','18:25:00',1.41),('7643','2013-04-06','18:30:00',1.29),('7643','2013-04-06','18:35:00',1.19),('7643','2013-04-06','18:40:00',1.09),('7643','2013-04-05','07:25:00',1.02),('7643','2013-04-05','07:30:00',1.3),('7643','2013-04-05','07:35:00',1.61),('7643','2013-04-05','07:40:00',1.92),('7643','2013-04-05','07:45:00',2.26),('7643','2013-04-05','07:50:00',2.62),('7643','2013-04-05','07:55:00',2.96),('7643','2013-04-05','08:00:00',3.32),('7643','2013-04-05','08:05:00',3.67),('7643','2013-04-05','08:10:00',4.08),('7643','2013-04-05','08:15:00',4.44),('7643','2013-04-05','08:20:00',4.79),('7643','2013-04-05','08:25:00',5.09),('7643','2013-04-05','08:30:00',5.43),('7643','2013-04-05','08:35:00',5.74),('7643','2013-04-05','08:40:00',6.03),('7643','2013-04-05','08:45:00',6.27),('7643','2013-04-05','08:50:00',6.55),('7643','2013-04-05','08:55:00',6.83),('7643','2013-04-05','09:00:00',7.19),('7643','2013-04-05','09:05:00',7.55),('7643','2013-04-05','09:10:00',7.89),('7643','2013-04-05','09:15:00',8.18),('7643','2013-04-05','09:20:00',8.5),('7643','2013-04-05','09:25:00',8.76),('7643','2013-04-05','09:30:00',9.12),('7643','2013-04-05','09:35:00',9.23),('7643','2013-04-05','09:40:00',9.61),('7643','2013-04-05','09:45:00',9.74),('7643','2013-04-05','09:50:00',10.05),('7643','2013-04-05','09:55:00',10.46),('7643','2013-04-05','10:00:00',10.67),('7643','2013-04-05','10:05:00',10.99),('7643','2013-04-05','10:10:00',11.18),('7643','2013-04-05','10:15:00',11.4),('7643','2013-04-05','10:20:00',11.69),('7643','2013-04-05','10:25:00',11.79),('7643','2013-04-05','10:30:00',12.04),('7643','2013-04-05','10:35:00',12.25),('7643','2013-04-05','10:40:00',12.46),('7643','2013-04-05','10:45:00',12.7),('7643','2013-04-05','10:50:00',12.86),('7643','2013-04-05','10:55:00',13.05),('7643','2013-04-05','11:00:00',13.29),('7643','2013-04-05','11:05:00',13.46),('7643','2013-04-05','11:10:00',13.68),('7643','2013-04-05','11:15:00',13.78),('7643','2013-04-05','11:20:00',13.95),('7643','2013-04-05','11:25:00',14.17),('7643','2013-04-05','11:30:00',14.1),('7643','2013-04-05','11:35:00',14.17),('7643','2013-04-05','11:40:00',14.38),('7643','2013-04-05','11:45:00',14.44),('7643','2013-04-05','11:50:00',14.46),('7643','2013-04-05','11:55:00',14.75),('7643','2013-04-05','12:00:00',14.71),('7643','2013-04-05','12:05:00',14.71),('7643','2013-04-05','12:10:00',14.82),('7643','2013-04-05','12:15:00',14.87),('7643','2013-04-05','12:20:00',14.97),('7643','2013-04-05','12:25:00',12.29),('7643','2013-04-05','12:30:00',14.3),('7643','2013-04-05','12:35:00',15.44),('7643','2013-04-05','12:40:00',15.42),('7643','2013-04-05','12:45:00',15.6),('7643','2013-04-05','12:50:00',15.74),('7643','2013-04-05','12:55:00',15.77),('7643','2013-04-05','13:00:00',15.66),('7643','2013-04-05','13:05:00',15.6),('7643','2013-04-05','13:10:00',9.64),('7643','2013-04-05','13:15:00',7.39),('7643','2013-04-05','13:20:00',4.13),('7643','2013-04-05','13:25:00',3.74),('7643','2013-04-05','13:30:00',13.52),('7643','2013-04-05','13:35:00',13.01),('7643','2013-04-05','13:40:00',16.98),('7643','2013-04-05','13:45:00',8.42),('7643','2013-04-05','13:50:00',14.97),('7643','2013-04-05','13:55:00',16.69),('7643','2013-04-05','14:00:00',15.97),('7643','2013-04-05','14:05:00',15.58),('7643','2013-04-05','14:10:00',16.64),('7643','2013-04-05','14:15:00',11.16),('7643','2013-04-05','14:20:00',4.33),('7643','2013-04-05','14:25:00',4.99),('7643','2013-04-05','14:30:00',11.6),('7643','2013-04-05','14:35:00',9),('7643','2013-04-05','14:40:00',7.87),('7643','2013-04-05','14:45:00',15.29),('7643','2013-04-05','14:50:00',14.53),('7643','2013-04-05','14:55:00',14.76),('7643','2013-04-05','15:00:00',14.05),('7643','2013-04-05','15:05:00',13.79),('7643','2013-04-05','15:10:00',13.19),('7643','2013-04-05','15:15:00',12.91),('7643','2013-04-05','15:20:00',12.8),('7643','2013-04-05','15:25:00',12.67),('7643','2013-04-05','15:30:00',12.04),('7643','2013-04-05','15:35:00',11.68),('7643','2013-04-05','15:40:00',11.75),('7643','2013-04-05','15:45:00',10.93),('7643','2013-04-05','15:50:00',9.86),('7643','2013-04-05','15:55:00',10.95),('7643','2013-04-05','16:00:00',10.38),('7643','2013-04-05','16:05:00',10.72),('7643','2013-04-05','16:10:00',10.95),('7643','2013-04-05','16:15:00',9.3),('7643','2013-04-05','16:20:00',8.41),('7643','2013-04-05','16:25:00',7.26),('7643','2013-04-05','16:30:00',8.83),('7643','2013-04-05','16:35:00',7.92),('7643','2013-04-05','16:40:00',6.51),('7643','2013-04-05','16:45:00',8.46),('7643','2013-04-05','16:50:00',7.95),('7643','2013-04-05','16:55:00',6.92),('7643','2013-04-05','17:00:00',6.74),('7643','2013-04-05','17:05:00',6.12),('7643','2013-04-05','17:10:00',5.33),('7643','2013-04-05','17:15:00',4.25),('7643','2013-04-05','17:20:00',3.33),('7643','2013-04-05','17:25:00',3.58),('7643','2013-04-05','17:30:00',3.43),('7643','2013-04-05','17:35:00',2.87),('7643','2013-04-05','17:40:00',2.76),('7643','2013-04-05','17:45:00',2.63),('7643','2013-04-05','17:50:00',2.59),('7643','2013-04-05','17:55:00',2.36),('7643','2013-04-05','18:00:00',2.09),('7643','2013-04-05','18:05:00',1.87),('7643','2013-04-05','18:10:00',1.68),('7643','2013-04-05','18:15:00',1.52),('7643','2013-04-05','18:20:00',1.38),('7643','2013-04-05','18:25:00',1.24),('7643','2013-04-05','18:30:00',1.13),('7643','2013-04-05','18:35:00',1.01),('7643','2013-04-04','08:00:00',1.74),('7643','2013-04-04','08:05:00',2.89),('7643','2013-04-04','08:10:00',3.33),('7643','2013-04-04','08:15:00',5.14),('7643','2013-04-04','08:20:00',5.28),('7643','2013-04-04','08:25:00',3.53),('7643','2013-04-04','08:30:00',2.09),('7643','2013-04-04','08:35:00',1.39),('7643','2013-04-04','08:40:00',2.64),('7643','2013-04-04','08:45:00',3.17),('7643','2013-04-04','08:50:00',2.24),('7643','2013-04-04','08:55:00',7.53),('7643','2013-04-04','09:00:00',4.32),('7643','2013-04-04','09:05:00',9.39),('7643','2013-04-04','09:10:00',6.56),('7643','2013-04-04','09:15:00',9.13),('7643','2013-04-04','09:20:00',7.93),('7643','2013-04-04','09:25:00',3.67),('7643','2013-04-04','09:30:00',3.18),('7643','2013-04-04','09:35:00',3.53),('7643','2013-04-04','09:40:00',5.59),('7643','2013-04-04','09:45:00',7.6),('7643','2013-04-04','09:50:00',4.5),('7643','2013-04-04','09:55:00',3.83),('7643','2013-04-04','10:00:00',5.5),('7643','2013-04-04','10:05:00',3.31),('7643','2013-04-04','10:10:00',10.79),('7643','2013-04-04','10:15:00',10.16),('7643','2013-04-04','10:20:00',4.15),('7643','2013-04-04','10:25:00',7.55),('7643','2013-04-04','10:30:00',7.71),('7643','2013-04-04','10:35:00',5.08),('7643','2013-04-04','10:40:00',11.06),('7643','2013-04-04','10:45:00',6.49),('7643','2013-04-04','10:50:00',9.85),('7643','2013-04-04','10:55:00',6.68),('7643','2013-04-04','11:00:00',5.78),('7643','2013-04-04','11:05:00',11.62),('7643','2013-04-04','11:10:00',12.8),('7643','2013-04-04','11:15:00',13.75),('7643','2013-04-04','11:20:00',12.79),('7643','2013-04-04','11:25:00',14.67),('7643','2013-04-04','11:30:00',15.77),('7643','2013-04-04','11:35:00',12.18),('7643','2013-04-04','11:40:00',13.41),('7643','2013-04-04','11:45:00',16),('7643','2013-04-04','11:50:00',16.11),('7643','2013-04-04','11:55:00',15.94),('7643','2013-04-04','12:00:00',16.43),('7643','2013-04-04','12:05:00',10.3),('7643','2013-04-04','12:10:00',8.29),('7643','2013-04-04','12:15:00',10.27),('7643','2013-04-04','12:20:00',5.47),('7643','2013-04-04','12:25:00',8.51),('7643','2013-04-04','12:30:00',4.78),('7643','2013-04-04','12:35:00',5.44),('7643','2013-04-04','12:40:00',5.99),('7643','2013-04-04','12:45:00',9.55),('7643','2013-04-04','12:50:00',17.99),('7643','2013-04-04','12:55:00',16.35),('7643','2013-04-04','13:00:00',10.38),('7643','2013-04-04','13:05:00',14.46),('7643','2013-04-04','13:10:00',11.74),('7643','2013-04-04','13:15:00',15.68),('7643','2013-04-04','13:20:00',13.33),('7643','2013-04-04','13:25:00',15.48),('7643','2013-04-04','13:30:00',12.66),('7643','2013-04-04','13:35:00',16.46),('7643','2013-04-04','13:40:00',13.93),('7643','2013-04-04','13:45:00',11.2),('7643','2013-04-04','13:50:00',17.23),('7643','2013-04-04','13:55:00',15.19),('7643','2013-04-04','14:00:00',13.24),('7643','2013-04-04','14:05:00',17.57),('7643','2013-04-04','14:10:00',17.17),('7643','2013-04-04','14:15:00',12.26),('7643','2013-04-04','14:20:00',13.72),('7643','2013-04-04','14:25:00',13.64),('7643','2013-04-04','14:30:00',16.37),('7643','2013-04-04','14:35:00',13.98),('7643','2013-04-04','14:40:00',13.89),('7643','2013-04-04','14:45:00',14.4),('7643','2013-04-04','14:50:00',8.98),('7643','2013-04-04','14:55:00',17.48),('7643','2013-04-04','15:00:00',15.41),('7643','2013-04-04','15:05:00',16.61),('7643','2013-04-04','15:10:00',12.22),('7643','2013-04-04','15:15:00',6.14),('7643','2013-04-04','15:20:00',6.24),('7643','2013-04-04','15:25:00',9.38),('7643','2013-04-04','15:30:00',7.9),('7643','2013-04-04','15:35:00',5.57),('7643','2013-04-04','15:40:00',4.58),('7643','2013-04-04','15:45:00',5.58),('7643','2013-04-04','15:50:00',8.29),('7643','2013-04-04','15:55:00',6.3),('7643','2013-04-04','16:00:00',6.58),('7643','2013-04-04','16:05:00',6.05),('7643','2013-04-04','16:10:00',6.13),('7643','2013-04-04','16:15:00',8.12),('7643','2013-04-04','16:20:00',8.85),('7643','2013-04-04','16:25:00',7.29),('7643','2013-04-04','16:30:00',6),('7643','2013-04-04','16:35:00',9.6),('7643','2013-04-04','16:40:00',5.56),('7643','2013-04-04','16:45:00',6.16),('7643','2013-04-04','16:50:00',10.61),('7643','2013-04-04','16:55:00',6.42),('7643','2013-04-04','17:00:00',5.18),('7643','2013-04-04','17:05:00',3.87),('7643','2013-04-04','17:10:00',7.57),('7643','2013-04-04','17:15:00',9.3),('7643','2013-04-04','17:20:00',8.07),('7643','2013-04-04','17:25:00',7.38),('7643','2013-04-04','17:30:00',6.78),('7643','2013-04-04','17:35:00',3.48),('7643','2013-04-04','17:40:00',5.41),('7643','2013-04-04','17:45:00',1.91),('7643','2013-04-04','17:50:00',2.38),('7643','2013-04-04','17:55:00',5.46),('7643','2013-04-04','18:00:00',3.64),('7643','2013-04-04','18:05:00',1.54),('7643','2013-04-04','18:10:00',1.2),('7643','2013-04-04','18:15:00',1.9),('7643','2013-04-04','18:20:00',2.95),('7643','2013-04-04','18:25:00',2.36),('7643','2013-04-04','18:30:00',1.68),('7643','2013-04-04','18:35:00',1.38),('7643','2013-04-04','18:40:00',1.38),('7643','2013-04-04','18:45:00',1.13),('7643','2013-04-03','07:40:00',1.07),('7643','2013-04-03','07:45:00',1.11),('7643','2013-04-03','07:50:00',1.35),('7643','2013-04-03','07:55:00',1.79),('7643','2013-04-03','08:00:00',2.03),('7643','2013-04-03','08:05:00',2.45),('7643','2013-04-03','08:10:00',2.08),('7643','2013-04-03','08:15:00',2.18),('7643','2013-04-03','08:20:00',2.31),('7643','2013-04-03','08:25:00',2.41),('7643','2013-04-03','08:30:00',2.52),('7643','2013-04-03','08:35:00',3.36),('7643','2013-04-03','08:40:00',3.15),('7643','2013-04-03','08:45:00',3.03),('7643','2013-04-03','08:50:00',3.05),('7643','2013-04-03','08:55:00',5.25),('7643','2013-04-03','09:00:00',7.85),('7643','2013-04-03','09:05:00',5.78),('7643','2013-04-03','09:10:00',5.22),('7643','2013-04-03','09:15:00',5.13),('7643','2013-04-03','09:20:00',4.92),('7643','2013-04-03','09:25:00',3.77),('7643','2013-04-03','09:30:00',5.63),('7643','2013-04-03','09:35:00',9.98),('7643','2013-04-03','09:40:00',9.55),('7643','2013-04-03','09:45:00',8.32),('7643','2013-04-03','09:50:00',4.36),('7643','2013-04-03','09:55:00',4.65),('7643','2013-04-03','10:00:00',7.08),('7643','2013-04-03','10:05:00',9.51),('7643','2013-04-03','10:10:00',8.22),('7643','2013-04-03','10:15:00',5.87),('7643','2013-04-03','10:20:00',7.03),('7643','2013-04-03','10:25:00',14.11),('7643','2013-04-03','10:30:00',12.22),('7643','2013-04-03','10:35:00',7.2),('7643','2013-04-03','10:40:00',15.04),('7643','2013-04-03','10:45:00',8.3),('7643','2013-04-03','10:50:00',8.2),('7643','2013-04-03','10:55:00',14.84),('7643','2013-04-03','11:00:00',9.67),('7643','2013-04-03','11:05:00',4.78),('7643','2013-04-03','11:10:00',3.97),('7643','2013-04-03','11:15:00',5.27),('7643','2013-04-03','11:20:00',5.26),('7643','2013-04-03','11:25:00',3.93),('7643','2013-04-03','11:30:00',4.37),('7643','2013-04-03','11:35:00',6.48),('7643','2013-04-03','11:40:00',11.12),('7643','2013-04-03','11:45:00',13.55),('7643','2013-04-03','11:50:00',15.45),('7643','2013-04-03','11:55:00',15.89),('7643','2013-04-03','12:00:00',15.87),('7643','2013-04-03','12:05:00',15.21),('7643','2013-04-03','12:10:00',15.42),('7643','2013-04-03','12:15:00',14.87),('7643','2013-04-03','12:20:00',12.03),('7643','2013-04-03','12:25:00',11.58),('7643','2013-04-03','12:30:00',11.81),('7643','2013-04-03','12:35:00',14.9),('7643','2013-04-03','12:40:00',11.42),('7643','2013-04-03','12:45:00',16.3),('7643','2013-04-03','12:50:00',16.07),('7643','2013-04-03','12:55:00',14.97),('7643','2013-04-03','13:00:00',14.75),('7643','2013-04-03','13:05:00',14.59),('7643','2013-04-03','13:10:00',15.44),('7643','2013-04-03','13:15:00',15.95),('7643','2013-04-03','13:20:00',15.41),('7643','2013-04-03','13:25:00',15.87),('7643','2013-04-03','13:30:00',15.57),('7643','2013-04-03','13:35:00',13.93),('7643','2013-04-03','13:40:00',11.76),('7643','2013-04-03','13:45:00',12.67),('7643','2013-04-03','13:50:00',12.62),('7643','2013-04-03','13:55:00',9.4),('7643','2013-04-03','14:00:00',10.07),('7643','2013-04-03','14:05:00',13.46),('7643','2013-04-03','14:10:00',15),('7643','2013-04-03','14:15:00',15.02),('7643','2013-04-03','14:20:00',14.75),('7643','2013-04-03','14:25:00',13.53),('7643','2013-04-03','14:30:00',14.34),('7643','2013-04-03','14:35:00',14.34),('7643','2013-04-03','14:40:00',14.38),('7643','2013-04-03','14:45:00',14.15),('7643','2013-04-03','14:50:00',13.95),('7643','2013-04-03','14:55:00',13.82),('7643','2013-04-03','15:00:00',13.67),('7643','2013-04-03','15:05:00',13.28),('7643','2013-04-03','15:10:00',12.49),('7643','2013-04-03','15:15:00',12.56),('7643','2013-04-03','15:20:00',12.63),('7643','2013-04-03','15:25:00',12.96),('7643','2013-04-03','15:30:00',12.61),('7643','2013-04-03','15:35:00',12.32),('7643','2013-04-03','15:40:00',12),('7643','2013-04-03','15:45:00',11.75),('7643','2013-04-03','15:50:00',11.25),('7643','2013-04-03','15:55:00',11.19),('7643','2013-04-03','16:00:00',10.92),('7643','2013-04-03','16:05:00',10.59),('7643','2013-04-03','16:10:00',10.02),('7643','2013-04-03','16:15:00',9.35),('7643','2013-04-03','16:20:00',8.79),('7643','2013-04-03','16:25:00',7.95),('7643','2013-04-03','16:30:00',7.45),('7643','2013-04-03','16:35:00',6.98),('7643','2013-04-03','16:40:00',7.21),('7643','2013-04-03','16:45:00',6.99),('7643','2013-04-03','16:50:00',5.83),('7643','2013-04-03','16:55:00',6.88),('7643','2013-04-03','17:00:00',6.35),('7643','2013-04-03','17:05:00',6.68),('7643','2013-04-03','17:10:00',5.81),('7643','2013-04-03','17:15:00',5.31),('7643','2013-04-03','17:20:00',3.93),('7643','2013-04-03','17:25:00',3.88),('7643','2013-04-03','17:30:00',2.88),('7643','2013-04-03','17:35:00',2.52),('7643','2013-04-03','17:40:00',2.99),('7643','2013-04-03','17:45:00',2.84),('7643','2013-04-03','17:50:00',3.42),('7643','2013-04-03','17:55:00',4.05),('7643','2013-04-03','18:00:00',3.17),('7643','2013-04-03','18:05:00',2.72),('7643','2013-04-03','18:10:00',1.37),('7643','2013-04-03','18:15:00',1.39),('7643','2013-04-03','18:20:00',1.22),('7643','2013-04-03','18:25:00',1.04),('7643','2013-04-02','07:41:00',1.69),('7643','2013-04-02','07:45:00',1.99),('7643','2013-04-02','07:50:00',2.36),('7643','2013-04-02','07:55:00',2.7),('7643','2013-04-02','08:00:00',3.09),('7643','2013-04-02','08:05:00',3.5),('7643','2013-04-02','08:10:00',3.88),('7643','2013-04-02','08:15:00',4.46),('7643','2013-04-02','08:20:00',4.96),('7643','2013-04-02','08:25:00',5.04),('7643','2013-04-02','08:30:00',5.94),('7643','2013-04-02','08:35:00',4.85),('7643','2013-04-02','08:40:00',3.56),('7643','2013-04-02','08:45:00',5.38),('7643','2013-04-02','08:50:00',5.42),('7643','2013-04-02','08:55:00',8.08),('7643','2013-04-02','09:00:00',8.24),('7643','2013-04-02','09:05:00',8.72),('7643','2013-04-02','09:10:00',9.17),('7643','2013-04-02','09:15:00',9.88),('7643','2013-04-02','09:20:00',5.41),('7643','2013-04-02','09:25:00',8.77),('7643','2013-04-02','09:30:00',6.71),('7643','2013-04-02','09:35:00',9.75),('7643','2013-04-02','09:40:00',9.51),('7643','2013-04-02','09:45:00',11.81),('7643','2013-04-02','09:50:00',8.69),('7643','2013-04-02','09:55:00',12.04),('7643','2013-04-02','10:00:00',9.39),('7643','2013-04-02','10:05:00',4.79),('7643','2013-04-02','10:10:00',4.36),('7643','2013-04-02','10:15:00',5.08),('7643','2013-04-02','10:20:00',9.78),('7643','2013-04-02','10:25:00',15.81),('7643','2013-04-02','10:30:00',13.68),('7643','2013-04-02','10:35:00',10.9),('7643','2013-04-02','10:40:00',7.14),('7643','2013-04-02','10:45:00',4.62),('7643','2013-04-02','10:50:00',8.55),('7643','2013-04-02','10:55:00',4.74),('7643','2013-04-02','11:00:00',12.09),('7643','2013-04-02','11:05:00',11.77),('7643','2013-04-02','11:10:00',12.05),('7643','2013-04-02','11:15:00',11.55),('7643','2013-04-02','11:20:00',12.7),('7643','2013-04-02','11:25:00',7.42),('7643','2013-04-02','11:30:00',6.7),('7643','2013-04-02','11:35:00',8.79),('7643','2013-04-02','11:40:00',8.92),('7643','2013-04-02','11:45:00',5.72),('7643','2013-04-02','11:50:00',12.9),('7643','2013-04-02','11:55:00',12.78),('7643','2013-04-02','12:00:00',10.6),('7643','2013-04-02','12:05:00',18.27),('7643','2013-04-02','12:10:00',13.25),('7643','2013-04-02','12:15:00',8.92),('7643','2013-04-02','12:20:00',13.2),('7643','2013-04-02','12:25:00',16.68),('7643','2013-04-02','12:30:00',18.62),('7643','2013-04-02','12:35:00',16.14),('7643','2013-04-02','12:40:00',17.84),('7643','2013-04-02','12:45:00',18.32),('7643','2013-04-02','12:50:00',18.72),('7643','2013-04-02','12:55:00',15.99),('7643','2013-04-02','13:00:00',15.26),('7643','2013-04-02','13:05:00',13.66),('7643','2013-04-02','13:10:00',12.51),('7643','2013-04-02','13:15:00',18.65),('7643','2013-04-02','13:20:00',14.13),('7643','2013-04-02','13:25:00',14.09),('7643','2013-04-02','13:30:00',11.73),('7643','2013-04-02','13:35:00',14.96),('7643','2013-04-02','13:40:00',15.07),('7643','2013-04-02','13:45:00',11.3),('7643','2013-04-02','13:50:00',16.34),('7643','2013-04-02','13:55:00',10.15),('7643','2013-04-02','14:00:00',14.98),('7643','2013-04-02','14:05:00',18.81),('7643','2013-04-02','14:10:00',18.22),('7643','2013-04-02','14:15:00',15.38),('7643','2013-04-02','14:20:00',10.84),('7643','2013-04-02','14:25:00',11.72),('7643','2013-04-02','14:30:00',13.5),('7643','2013-04-02','14:35:00',16.73),('7643','2013-04-02','14:40:00',11.24),('7643','2013-04-02','14:45:00',7.27),('7643','2013-04-02','14:50:00',14),('7643','2013-04-02','14:55:00',12.83),('7643','2013-04-02','15:00:00',13.33),('7643','2013-04-02','15:05:00',12.98),('7643','2013-04-02','15:10:00',14.54),('7643','2013-04-02','15:15:00',18.22),('7643','2013-04-02','15:20:00',12.74),('7643','2013-04-02','15:25:00',12.65),('7643','2013-04-02','15:30:00',8.39),('7643','2013-04-02','15:35:00',10.31),('7643','2013-04-02','15:40:00',13.53),('7643','2013-04-02','15:45:00',12.33),('7643','2013-04-02','15:50:00',14.67),('7643','2013-04-02','15:55:00',14.05),('7643','2013-04-02','16:00:00',13.62),('7643','2013-04-02','16:05:00',13.14),('7643','2013-04-02','16:10:00',12.74),('7643','2013-04-02','16:15:00',11.72),('7643','2013-04-02','16:20:00',11.99),('7643','2013-04-02','16:25:00',11.33),('7643','2013-04-02','16:30:00',11.4),('7643','2013-04-02','16:35:00',11),('7643','2013-04-02','16:40:00',10.45),('7643','2013-04-02','16:45:00',10.11),('7643','2013-04-02','16:50:00',9.81),('7643','2013-04-02','16:55:00',9.49),('7643','2013-04-02','17:00:00',9.09),('7643','2013-04-02','17:05:00',8.74),('7643','2013-04-02','17:10:00',8.37),('7643','2013-04-02','17:15:00',7.99),('7643','2013-04-02','17:20:00',7.59),('7643','2013-04-02','17:25:00',7.11),('7643','2013-04-02','17:30:00',6.86),('7643','2013-04-02','17:35:00',6.41),('7643','2013-04-02','17:40:00',6.02),('7643','2013-04-02','17:45:00',5.6),('7643','2013-04-02','17:50:00',5.19),('7643','2013-04-02','17:55:00',4.82),('7643','2013-04-02','18:00:00',4.39),('7643','2013-04-02','18:05:00',3.95),('7643','2013-04-02','18:10:00',3.51),('7643','2013-04-02','18:15:00',3.11),('7643','2013-04-02','18:20:00',2.7),('7643','2013-04-02','18:25:00',2.31),('7643','2013-04-02','18:30:00',2),('7643','2013-04-02','18:35:00',1.66),('7643','2013-04-02','18:40:00',1.39),('7643','2013-04-02','18:45:00',1.12),('7643','2013-04-01','08:25:00',1.06),('7643','2013-04-01','08:30:00',2.03),('7643','2013-04-01','08:35:00',2.41),('7643','2013-04-01','08:40:00',6.64),('7643','2013-04-01','08:45:00',7.14),('7643','2013-04-01','08:50:00',5.13),('7643','2013-04-01','08:55:00',4.73),('7643','2013-04-01','09:00:00',7.73),('7643','2013-04-01','09:05:00',8.15),('7643','2013-04-01','09:10:00',8.78),('7643','2013-04-01','09:15:00',9.1),('7643','2013-04-01','09:20:00',5.85),('7643','2013-04-01','09:25:00',5.19),('7643','2013-04-01','09:30:00',11.1),('7643','2013-04-01','09:35:00',9.04),('7643','2013-04-01','09:40:00',10.01),('7643','2013-04-01','09:45:00',11.91),('7643','2013-04-01','09:50:00',5.46),('7643','2013-04-01','09:55:00',6.23),('7643','2013-04-01','10:00:00',5.5),('7643','2013-04-01','10:05:00',11.19),('7643','2013-04-01','10:10:00',6.24),('7643','2013-04-01','10:15:00',7.6),('7643','2013-04-01','10:20:00',8.78),('7643','2013-04-01','10:25:00',6.11),('7643','2013-04-01','10:30:00',2.52),('7643','2013-04-01','10:35:00',5.56),('7643','2013-04-01','10:40:00',5.75),('7643','2013-04-01','10:45:00',12.07),('7643','2013-04-01','10:50:00',15.26),('7643','2013-04-01','10:55:00',8.48),('7643','2013-04-01','11:00:00',3.53),('7643','2013-04-01','11:05:00',10.42),('7643','2013-04-01','11:10:00',10.43),('7643','2013-04-01','11:15:00',4.86),('7643','2013-04-01','11:20:00',3.53),('7643','2013-04-01','11:25:00',3.77),('7643','2013-04-01','11:30:00',4.09),('7643','2013-04-01','11:35:00',5),('7643','2013-04-01','11:40:00',2.61),('7643','2013-04-01','11:45:00',6.18),('7643','2013-04-01','11:50:00',7.91),('7643','2013-04-01','11:55:00',5.44),('7643','2013-04-01','12:00:00',4.14),('7643','2013-04-01','12:05:00',9.2),('7643','2013-04-01','12:10:00',12.38),('7643','2013-04-01','12:15:00',9.08),('7643','2013-04-01','12:20:00',1.84),('7643','2013-04-01','12:30:00',3.23),('7643','2013-04-01','12:35:00',6.19),('7643','2013-04-01','12:40:00',9.88),('7643','2013-04-01','12:45:00',9.22),('7643','2013-04-01','12:50:00',8),('7643','2013-04-01','12:55:00',8.24),('7643','2013-04-01','13:00:00',7.91),('7643','2013-04-01','13:05:00',9.93),('7643','2013-04-01','13:10:00',12.76),('7643','2013-04-01','13:15:00',8.41),('7643','2013-04-01','13:20:00',7.05),('7643','2013-04-01','13:25:00',13.26),('7643','2013-04-01','13:30:00',9.91),('7643','2013-04-01','13:35:00',6.99),('7643','2013-04-01','13:40:00',8.85),('7643','2013-04-01','13:45:00',9.24),('7643','2013-04-01','13:50:00',7.46),('7643','2013-04-01','13:55:00',6.92),('7643','2013-04-01','14:00:00',9.42),('7643','2013-04-01','14:05:00',9.36),('7643','2013-04-01','14:10:00',14.27),('7643','2013-04-01','14:15:00',9.32),('7643','2013-04-01','14:20:00',16.2),('7643','2013-04-01','14:25:00',17.96),('7643','2013-04-01','14:30:00',13.52),('7643','2013-04-01','14:35:00',7.07),('7643','2013-04-01','14:40:00',8.92),('7643','2013-04-01','14:45:00',8.36),('7643','2013-04-01','14:50:00',7.39),('7643','2013-04-01','14:55:00',6.09),('7643','2013-04-01','15:00:00',6.01),('7643','2013-04-01','15:05:00',2.82),('7643','2013-04-01','15:10:00',1.77),('7643','2013-04-01','15:15:00',2.09),('7643','2013-04-01','15:20:00',3.33),('7643','2013-04-01','15:25:00',2.03),('7643','2013-04-01','15:30:00',1.99),('7643','2013-04-01','15:35:00',2.55),('7643','2013-04-01','15:40:00',3.18),('7643','2013-04-01','15:45:00',4.3),('7643','2013-04-01','15:50:00',1.94),('7643','2013-04-01','15:55:00',1.95),('7643','2013-04-01','16:00:00',3.52),('7643','2013-04-01','16:05:00',4.26),('7643','2013-04-01','16:10:00',3.21),('7643','2013-04-01','16:15:00',3.79),('7643','2013-04-01','16:20:00',3.97),('7643','2013-04-01','16:25:00',3.3),('7643','2013-04-01','16:30:00',3.36),('7643','2013-04-01','16:35:00',3.73),('7643','2013-04-01','16:40:00',3.26),('7643','2013-04-01','16:45:00',3.13),('7643','2013-04-01','16:50:00',2.17),('7643','2013-04-01','16:55:00',2.54),('7643','2013-04-01','17:00:00',2.75),('7643','2013-04-01','17:05:00',2.6),('7643','2013-04-01','17:15:00',1.12),('7643','2013-04-01','17:20:00',1.38),('7643','2013-04-01','17:35:00',2.04),('7643','2013-04-01','17:40:00',4.22),('7643','2013-04-01','17:45:00',4.03),('7643','2013-04-01','17:50:00',1.14),('7643','2013-04-01','18:00:00',1.57),('7643','2013-04-01','18:05:00',1.5),('7643','2014-05-01','07:00:00',1.18),('7643','2014-05-01','07:05:00',1.54),('7643','2014-05-01','07:10:00',2.32),('7643','2014-05-01','07:15:00',2.54),('7643','2014-05-01','07:20:00',1.53),('7643','2014-05-01','07:25:00',2.1),('7643','2014-05-01','07:30:00',3.49),('7643','2014-05-01','07:35:00',3.42),('7643','2014-05-01','07:40:00',3.82),('7643','2014-05-01','07:45:00',4.25),('7643','2014-05-01','07:50:00',3.79),('7643','2014-05-01','07:55:00',1.58),('7643','2014-05-01','08:00:00',3.31),('7643','2014-05-01','08:05:00',4.27),('7643','2014-05-01','08:10:00',3.65),('7643','2014-05-01','08:15:00',6.58),('7643','2014-05-01','08:20:00',6.53),('7643','2014-05-01','08:25:00',6.48),('7643','2014-05-01','08:30:00',4.35),('7643','2014-05-01','08:35:00',1.95),('7643','2014-05-01','08:40:00',2.32),('7643','2014-05-01','08:45:00',3.95),('7643','2014-05-01','08:50:00',5.76),('7643','2014-05-01','08:55:00',2.76),('7643','2014-05-01','09:00:00',1.88),('7643','2014-05-01','09:05:00',1.98),('7643','2014-05-01','09:10:00',2.47),('7643','2014-05-01','09:15:00',3.78),('7643','2014-05-01','09:20:00',4.85),('7643','2014-05-01','09:25:00',5.42),('7643','2014-05-01','09:30:00',5.88),('7643','2014-05-01','09:35:00',5.68),('7643','2014-05-01','09:40:00',4.95),('7643','2014-05-01','09:45:00',5.47),('7643','2014-05-01','09:50:00',5.43),('7643','2014-05-01','09:55:00',5.45),('7643','2014-05-01','10:00:00',6.33),('7643','2014-05-01','10:05:00',6.49),('7643','2014-05-01','10:10:00',7.66),('7643','2014-05-01','10:15:00',7.04),('7643','2014-05-01','10:20:00',6.21),('7643','2014-05-01','10:25:00',4.45),('7643','2014-05-01','10:30:00',3.43),('7643','2014-05-01','10:35:00',3.25),('7643','2014-05-01','10:40:00',3.44),('7643','2014-05-01','10:45:00',4.27),('7643','2014-05-01','10:50:00',3.91),('7643','2014-05-01','10:55:00',3.29),('7643','2014-05-01','11:00:00',2.07),('7643','2014-05-01','11:05:00',1.48),('7643','2014-05-01','11:10:00',1.32),('7643','2014-05-01','11:15:00',1.42),('7643','2014-05-01','11:20:00',1.8),('7643','2014-05-01','11:25:00',1.97),('7643','2014-05-01','11:30:00',1.91),('7643','2014-05-01','11:35:00',1.68),('7643','2014-05-01','11:40:00',1.29),('7643','2014-05-01','12:20:00',1.97),('7643','2014-05-01','12:25:00',2.87),('7643','2014-05-01','12:30:00',3.71),('7643','2014-05-01','12:35:00',4.2),('7643','2014-05-01','12:40:00',3.71),('7643','2014-05-01','12:45:00',4.13),('7643','2014-05-01','12:50:00',6.43),('7643','2014-05-01','12:55:00',6.36),('7643','2014-05-01','13:00:00',6.16),('7643','2014-05-01','13:05:00',7.57),('7643','2014-05-01','13:10:00',7.99),('7643','2014-05-01','13:15:00',8.25),('7643','2014-05-01','13:20:00',13.3),('7643','2014-05-01','13:25:00',10.05),('7643','2014-05-01','13:30:00',11.82),('7643','2014-05-01','13:35:00',7.67),('7643','2014-05-01','13:40:00',9.31),('7643','2014-05-01','13:45:00',8.31),('7643','2014-05-01','13:50:00',5.21),('7643','2014-05-01','13:55:00',5.55),('7643','2014-05-01','14:00:00',5.46),('7643','2014-05-01','14:05:00',7.39),('7643','2014-05-01','14:10:00',5.33),('7643','2014-05-01','14:15:00',2.43),('7643','2014-05-01','14:20:00',2.01),('7643','2014-05-01','14:25:00',3.03),('7643','2014-05-01','14:30:00',5.81),('7643','2014-05-01','14:35:00',8.48),('7643','2014-05-01','14:40:00',10.11),('7643','2014-05-01','14:45:00',7.97),('7643','2014-05-01','14:50:00',5.78),('7643','2014-05-01','14:55:00',7.19),('7643','2014-05-01','15:00:00',13.65),('7643','2014-05-01','15:05:00',8.17),('7643','2014-05-01','15:10:00',10.56),('7643','2014-05-01','15:15:00',14.74),('7643','2014-05-01','15:20:00',5.97),('7643','2014-05-01','15:25:00',4.67),('7643','2014-05-01','15:30:00',4.77),('7643','2014-05-01','15:35:00',10.54),('7643','2014-05-01','15:40:00',16.51),('7643','2014-05-01','15:45:00',5.74),('7643','2014-05-01','15:50:00',2.98),('7643','2014-05-01','15:55:00',3.1),('7643','2014-05-01','16:00:00',4.35),('7643','2014-05-01','16:05:00',6.67),('7643','2014-05-01','16:10:00',4.56),('7643','2014-05-01','16:15:00',3.15),('7643','2014-05-01','16:20:00',10.47),('7643','2014-05-01','16:25:00',2.5),('7643','2014-05-01','16:30:00',1.12),('7643','2014-05-01','16:35:00',1.14),('7643','2014-05-01','16:45:00',1.04),('7643','2014-05-01','16:50:00',1.68),('7643','2014-05-01','16:55:00',1.93),('7643','2014-05-01','17:00:00',1.97),('7643','2014-05-01','17:05:00',2.98),('7643','2014-05-01','17:10:00',2.53),('7643','2014-05-01','17:15:00',3.53),('7643','2014-05-01','17:20:00',4.11),('7643','2014-05-01','17:25:00',4.84),('7643','2014-05-01','17:30:00',3.67),('7643','2014-05-01','17:35:00',2.74),('7643','2014-05-01','17:40:00',2.31),('7643','2014-05-01','17:45:00',1.87),('7643','2014-05-01','17:50:00',1.5),('7643','2014-05-01','17:55:00',1.42),('7643','2014-05-01','18:00:00',1.42),('7643','2014-05-01','18:05:00',1.52),('7643','2014-05-01','18:10:00',1.4),('7643','2014-05-01','18:15:00',1),('7643','2014-03-26','07:25:00',1.25),('7643','2014-03-26','07:30:00',1.57),('7643','2014-03-26','07:35:00',1.73),('7643','2014-03-26','07:40:00',2.13),('7643','2014-03-26','07:45:00',2.64),('7643','2014-03-26','07:50:00',2.94),('7643','2014-03-26','07:55:00',4.24),('7643','2014-03-26','08:00:00',5.07),('7643','2014-03-26','08:05:00',5.12),('7643','2014-03-26','08:10:00',2.34),('7643','2014-03-26','08:20:00',1.04),('7643','2014-03-26','08:45:00',1.29),('7643','2014-03-26','08:50:00',1.57),('7643','2014-03-26','08:55:00',1.35),('7643','2014-03-26','09:00:00',1.33),('7643','2014-03-26','09:05:00',1.59),('7643','2014-03-26','09:10:00',2.48),('7643','2014-03-26','09:15:00',3.11),('7643','2014-03-26','09:20:00',3.01),('7643','2014-03-26','09:25:00',2.86),('7643','2014-03-26','09:30:00',2.36),('7643','2014-03-26','09:35:00',1.67),('7643','2014-03-26','09:40:00',1.55),('7643','2014-03-26','09:45:00',1.67),('7643','2014-03-26','09:50:00',2.07),('7643','2014-03-26','09:55:00',3),('7643','2014-03-26','10:00:00',3.38),('7643','2014-03-26','10:05:00',3.63),('7643','2014-03-26','10:10:00',4.92),('7643','2014-03-26','10:15:00',3.85),('7643','2014-03-26','10:20:00',5.63),('7643','2014-03-26','10:25:00',6.86),('7643','2014-03-26','10:30:00',8),('7643','2014-03-26','10:35:00',7.56),('7643','2014-03-26','10:40:00',9.96),('7643','2014-03-26','10:45:00',4.98),('7643','2014-03-26','10:50:00',2.85),('7643','2014-03-26','10:55:00',2.78),('7643','2014-03-26','11:00:00',3.35),('7643','2014-03-26','11:05:00',2.42),('7643','2014-03-26','11:10:00',10.62),('7643','2014-03-26','11:15:00',16.98),('7643','2014-03-26','11:20:00',10.33),('7643','2014-03-26','11:25:00',3.03),('7643','2014-03-26','11:30:00',2.94),('7643','2014-03-26','11:35:00',1.28),('7643','2014-03-26','11:45:00',1.56),('7643','2014-03-26','11:50:00',3.29),('7643','2014-03-26','11:55:00',5.39),('7643','2014-03-26','12:00:00',5.49),('7643','2014-03-26','12:05:00',3.7),('7643','2014-03-26','12:10:00',6.19),('7643','2014-03-26','12:15:00',4.49),('7643','2014-03-26','12:20:00',3.98),('7643','2014-03-26','12:25:00',1.98),('7643','2014-03-26','12:45:00',1.59),('7643','2014-03-26','12:50:00',2.48),('7643','2014-03-26','12:55:00',3.22),('7643','2014-03-26','13:00:00',3.4),('7643','2014-03-26','13:05:00',3.77),('7643','2014-03-26','13:10:00',5.55),('7643','2014-03-26','13:15:00',7.69),('7643','2014-03-26','13:20:00',8.51),('7643','2014-03-26','13:25:00',9.24),('7643','2014-03-26','13:30:00',7.94),('7643','2014-03-26','13:35:00',7.43),('7643','2014-03-26','13:40:00',7.05),('7643','2014-03-26','13:45:00',6.63),('7643','2014-03-26','13:50:00',8.37),('7643','2014-03-26','13:55:00',10.79),('7643','2014-03-26','14:00:00',9.6),('7643','2014-03-26','14:05:00',4.46),('7643','2014-03-26','14:10:00',3.57),('7643','2014-03-26','14:15:00',8.67),('7643','2014-03-26','14:20:00',13.42),('7643','2014-03-26','14:25:00',14.25),('7643','2014-03-26','14:30:00',11.89),('7643','2014-03-26','14:35:00',9.8),('7643','2014-03-26','14:40:00',6.59),('7643','2014-03-26','14:45:00',6.39),('7643','2014-03-26','14:50:00',9),('7643','2014-03-26','14:55:00',9.49),('7643','2014-03-26','15:00:00',7.17),('7643','2014-03-26','15:05:00',6.19),('7643','2014-03-26','15:10:00',2.11),('7643','2014-03-26','15:15:00',1.57),('7643','2014-03-26','15:20:00',4.24),('7643','2014-03-26','15:25:00',8.49),('7643','2014-03-26','15:30:00',9.27),('7643','2014-03-26','15:35:00',4.82),('7643','2014-03-26','15:40:00',3.28),('7643','2014-03-26','15:45:00',2.44),('7643','2014-03-26','15:50:00',3.9),('7643','2014-03-26','15:55:00',3.6),('7643','2014-03-26','16:00:00',2.97),('7643','2014-03-26','16:05:00',3.57),('7643','2014-03-26','16:10:00',4.78),('7643','2014-03-26','16:15:00',4.65),('7643','2014-03-26','16:20:00',3.38),('7643','2014-03-26','16:25:00',3.88),('7643','2014-03-26','16:30:00',4.18),('7643','2014-03-26','16:35:00',3.23),('7643','2014-03-26','16:40:00',3.81),('7643','2014-03-26','16:45:00',3.85),('7643','2014-03-26','16:50:00',2.17),('7643','2014-03-26','16:55:00',2.67),('7643','2014-03-26','17:00:00',2.77),('7643','2014-03-26','17:05:00',2.69),('7643','2014-03-26','17:10:00',2.07),('7643','2014-03-26','17:15:00',2.13),('7643','2014-03-26','17:20:00',1.69),('7643','2013-03-31','07:41:00',1.03),('7643','2013-03-31','07:45:00',1.24),('7643','2013-03-31','07:50:00',1.32),('7643','2013-03-31','07:55:00',1.33),('7643','2013-03-31','08:00:00',2.15),('7643','2013-03-31','08:05:00',1.69),('7643','2013-03-31','08:10:00',1.25),('7643','2013-03-31','08:15:00',1.55),('7643','2013-03-31','08:20:00',2.92),('7643','2013-03-31','08:25:00',5.1),('7643','2013-03-31','08:30:00',4.58),('7643','2013-03-31','08:35:00',6.11),('7643','2013-03-31','08:40:00',7.41),('7643','2013-03-31','08:45:00',4.93),('7643','2013-03-31','08:50:00',7.53),('7643','2013-03-31','08:55:00',7.96),('7643','2013-03-31','09:00:00',7.77),('7643','2013-03-31','09:05:00',8.16),('7643','2013-03-31','09:10:00',8.8),('7643','2013-03-31','09:15:00',9.14),('7643','2013-03-31','09:20:00',8.78),('7643','2013-03-31','09:25:00',9.53),('7643','2013-03-31','09:30:00',9.22),('7643','2013-03-31','09:35:00',6.76),('7643','2013-03-31','09:40:00',9.56),('7643','2013-03-31','09:45:00',11.31),('7643','2013-03-31','09:50:00',11.07),('7643','2013-03-31','09:55:00',10.45),('7643','2013-03-31','10:00:00',11.72),('7643','2013-03-31','10:05:00',12.07),('7643','2013-03-31','10:10:00',11.16),('7643','2013-03-31','10:15:00',11.23),('7643','2013-03-31','10:20:00',12.84),('7643','2013-03-31','10:25:00',10.45),('7643','2013-03-31','10:30:00',10.13),('7643','2013-03-31','10:35:00',4.8),('7643','2013-03-31','10:40:00',10.41),('7643','2013-03-31','10:45:00',13.79),('7643','2013-03-31','10:50:00',3.46),('7643','2013-03-31','10:55:00',3.65),('7643','2013-03-31','11:00:00',4.2),('7643','2013-03-31','11:05:00',5.53),('7643','2013-03-31','11:10:00',9.41),('7643','2013-03-31','11:15:00',10.22),('7643','2013-03-31','11:20:00',14.43),('7643','2013-03-31','11:25:00',11.01),('7643','2013-03-31','11:30:00',8.86),('7643','2013-03-31','11:35:00',7.54),('7643','2013-03-31','11:40:00',12.67),('7643','2013-03-31','11:45:00',12.6),('7643','2013-03-31','11:50:00',9.73),('7643','2013-03-31','11:55:00',8.7),('7643','2013-03-31','12:00:00',11.62),('7643','2013-03-31','12:05:00',7.63),('7643','2013-03-31','12:10:00',9.24),('7643','2013-03-31','12:15:00',7.63),('7643','2013-03-31','12:20:00',6.83),('7643','2013-03-31','12:25:00',7.23),('7643','2013-03-31','12:30:00',9.78),('7643','2013-03-31','12:35:00',9.28),('7643','2013-03-31','12:40:00',8.93),('7643','2013-03-31','12:45:00',10.3),('7643','2013-03-31','12:50:00',10.96),('7643','2013-03-31','12:55:00',11.85),('7643','2013-03-31','13:00:00',11.19),('7643','2013-03-31','13:05:00',12.37),('7643','2013-03-31','13:10:00',10.81),('7643','2013-03-31','13:15:00',11.7),('7643','2013-03-31','13:20:00',11.36),('7643','2013-03-31','13:25:00',10.29),('7643','2013-03-31','13:30:00',11.24),('7643','2013-03-31','13:35:00',10.29),('7643','2013-03-31','13:40:00',13.67),('7643','2013-03-31','13:45:00',14.74),('7643','2013-03-31','13:50:00',16.31),('7643','2013-03-31','13:55:00',15.49),('7643','2013-03-31','14:00:00',9.24),('7643','2013-03-31','14:05:00',6.89),('7643','2013-03-31','14:10:00',8.82),('7643','2013-03-31','14:15:00',9.99),('7643','2013-03-31','14:20:00',10.57),('7643','2013-03-31','14:25:00',16.64),('7643','2013-03-31','14:30:00',9.93),('7643','2013-03-31','14:35:00',8.32),('7643','2013-03-31','14:40:00',7.41),('7643','2013-03-31','14:45:00',7.16),('7643','2013-03-31','14:50:00',7.83),('7643','2013-03-31','14:55:00',8.47),('7643','2013-03-31','15:00:00',7.51),('7643','2013-03-31','15:05:00',7.53),('7643','2013-03-31','15:10:00',7.69),('7643','2013-03-31','15:15:00',8.28),('7643','2013-03-31','15:20:00',8.59),('7643','2013-03-31','15:25:00',8.53),('7643','2013-03-31','15:30:00',7.73),('7643','2013-03-31','15:35:00',9.96),('7643','2013-03-31','15:40:00',9.35),('7643','2013-03-31','15:45:00',9.62),('7643','2013-03-31','15:50:00',10.8),('7643','2013-03-31','15:55:00',8.07),('7643','2013-03-31','16:00:00',7.35),('7643','2013-03-31','16:05:00',5.92),('7643','2013-03-31','16:10:00',4.95),('7643','2013-03-31','16:15:00',4.05),('7643','2013-03-31','16:20:00',3.78),('7643','2013-03-31','16:25:00',3.47),('7643','2013-03-31','16:30:00',2.94),('7643','2013-03-31','16:35:00',3.04),('7643','2013-03-31','16:40:00',2.82),('7643','2013-03-31','16:45:00',2.37),('7643','2013-03-31','16:50:00',1.47),('7643','2013-03-31','16:55:00',1.04),('7643','2013-03-30','08:00:00',1.07),('7643','2013-03-30','08:05:00',1.2),('7643','2013-03-30','08:10:00',1.02),('7643','2013-03-30','08:15:00',1.73),('7643','2013-03-30','08:20:00',3.33),('7643','2013-03-30','08:25:00',2.39),('7643','2013-03-30','08:30:00',3.49),('7643','2013-03-30','08:35:00',4.58),('7643','2013-03-30','08:40:00',3.84),('7643','2013-03-30','08:45:00',4.51),('7643','2013-03-30','08:50:00',4.03),('7643','2013-03-30','08:55:00',3.94),('7643','2013-03-30','09:00:00',4.85),('7643','2013-03-30','09:05:00',4.31),('7643','2013-03-30','09:10:00',4.26),('7643','2013-03-30','09:15:00',4.36),('7643','2013-03-30','09:20:00',8.86),('7643','2013-03-30','09:25:00',11.28),('7643','2013-03-30','09:30:00',7.98),('7643','2013-03-30','09:35:00',7.11),('7643','2013-03-30','09:40:00',4.09),('7643','2013-03-30','09:45:00',9.68),('7643','2013-03-30','09:50:00',5.18),('7643','2013-03-30','09:55:00',7.26),('7643','2013-03-30','10:00:00',8.74),('7643','2013-03-30','10:05:00',3.06),('7643','2013-03-30','10:10:00',1.89),('7643','2013-03-30','10:15:00',3.27),('7643','2013-03-30','10:20:00',7.31),('7643','2013-03-30','10:25:00',9.39),('7643','2013-03-30','10:30:00',11.96),('7643','2013-03-30','10:35:00',11.9),('7643','2013-03-30','10:40:00',2.72),('7643','2013-03-30','10:45:00',4.03),('7643','2013-03-30','10:50:00',7.18),('7643','2013-03-30','10:55:00',4.22),('7643','2013-03-30','11:00:00',2.65),('7643','2013-03-30','11:05:00',2.59),('7643','2013-03-30','11:10:00',5.42),('7643','2013-03-30','11:15:00',5.23),('7643','2013-03-30','11:20:00',4.34),('7643','2013-03-30','11:25:00',4.99),('7643','2013-03-30','11:30:00',3.53),('7643','2013-03-30','11:35:00',4.94),('7643','2013-03-30','11:40:00',6.23),('7643','2013-03-30','11:45:00',4.71),('7643','2013-03-30','11:50:00',5.48),('7643','2013-03-30','11:55:00',6.4),('7643','2013-03-30','12:00:00',5.74),('7643','2013-03-30','12:05:00',5.3),('7643','2013-03-30','12:10:00',5.21),('7643','2013-03-30','12:15:00',5.24),('7643','2013-03-30','12:20:00',4.94),('7643','2013-03-30','12:25:00',5.68),('7643','2013-03-30','12:30:00',6.67),('7643','2013-03-30','12:35:00',10.42),('7643','2013-03-30','12:40:00',8.19),('7643','2013-03-30','12:45:00',5.43),('7643','2013-03-30','12:50:00',5.98),('7643','2013-03-30','12:55:00',7.5),('7643','2013-03-30','13:00:00',9.28),('7643','2013-03-30','13:05:00',9.67),('7643','2013-03-30','13:10:00',10.17),('7643','2013-03-30','13:15:00',8.16),('7643','2013-03-30','13:20:00',15.03),('7643','2013-03-30','13:25:00',12.01),('7643','2013-03-30','13:30:00',3.01),('7643','2013-03-30','13:35:00',3.14),('7643','2013-03-30','13:40:00',5.41),('7643','2013-03-30','13:45:00',7.31),('7643','2013-03-30','13:50:00',8.74),('7643','2013-03-30','13:55:00',10.03),('7643','2013-03-30','14:00:00',6.59),('7643','2013-03-30','14:05:00',11.04),('7643','2013-03-30','14:10:00',7.89),('7643','2013-03-30','14:15:00',13.99),('7643','2013-03-30','14:20:00',6.04),('7643','2013-03-30','14:25:00',6.69),('7643','2013-03-30','14:30:00',16.77),('7643','2013-03-30','14:35:00',16.88),('7643','2013-03-30','14:40:00',16.91),('7643','2013-03-30','14:45:00',13.21),('7643','2013-03-30','14:50:00',13.77),('7643','2013-03-30','14:55:00',11.31),('7643','2013-03-30','15:00:00',10.04),('7643','2013-03-30','15:05:00',7.29),('7643','2013-03-30','15:10:00',11.83),('7643','2013-03-30','15:15:00',11.4),('7643','2013-03-30','15:20:00',16.65),('7643','2013-03-30','15:25:00',10.75),('7643','2013-03-30','15:30:00',9.87),('7643','2013-03-30','15:35:00',12.63),('7643','2013-03-30','15:40:00',16.16),('7643','2013-03-30','15:45:00',10.49),('7643','2013-03-30','15:50:00',3.79),('7643','2013-03-30','15:55:00',3.02),('7643','2013-03-30','16:00:00',12.53),('7643','2013-03-30','16:05:00',5.16),('7643','2013-03-30','16:10:00',5.52),('7643','2013-03-30','16:15:00',6.92),('7643','2013-03-30','16:20:00',6.61),('7643','2013-03-30','16:25:00',4.89),('7643','2013-03-30','16:30:00',3.99),('7643','2013-03-30','16:35:00',4.14),('7643','2013-03-30','16:40:00',4.96),('7643','2013-03-30','16:45:00',3.82),('7643','2013-03-30','16:50:00',3.41),('7643','2013-03-30','16:55:00',2.98),('7643','2013-03-30','17:00:00',4.3),('7643','2013-03-30','17:05:00',7.8),('7643','2013-03-30','17:10:00',6.88),('7643','2013-03-30','17:15:00',4.19),('7643','2013-03-30','17:20:00',4.15),('7643','2013-03-30','17:25:00',4.61),('7643','2013-03-30','17:30:00',4.81),('7643','2013-03-30','17:35:00',4.68),('7643','2013-03-30','17:40:00',3.03),('7643','2013-03-30','17:45:00',3.14),('7643','2013-03-30','17:50:00',3.42),('7643','2013-03-30','17:55:00',5.68),('7643','2013-03-30','18:00:00',3.5),('7643','2013-03-30','18:10:00',1.57),('7643','2013-03-30','18:15:00',4.46),('7643','2013-03-30','18:20:00',2.89),('7643','2013-03-30','18:25:00',1.09),('7643','2013-03-30','18:30:00',1.44),('7643','2013-03-30','18:35:00',1.19),('7643','2013-03-30','18:50:00',1.05),('7643','2013-03-29','06:50:00',1.08),('7643','2013-03-29','06:55:00',1.24),('7643','2013-03-29','07:00:00',1.33),('7643','2013-03-29','07:05:00',1.68),('7643','2013-03-29','07:10:00',1.57),('7643','2013-03-29','07:15:00',1.12),('7643','2013-03-29','07:20:00',1.57),('7643','2013-03-29','07:25:00',1.97),('7643','2013-03-29','07:30:00',2.07),('7643','2013-03-29','07:35:00',1.84),('7643','2013-03-29','07:40:00',1.31),('7643','2013-03-29','07:45:00',1.51),('7643','2013-03-29','07:50:00',2.49),('7643','2013-03-29','07:55:00',3.49),('7643','2013-03-29','08:00:00',2.68),('7643','2013-03-29','08:05:00',2.29),('7643','2013-03-29','08:10:00',2.38),('7643','2013-03-29','08:15:00',3.13),('7643','2013-03-29','08:20:00',3.14),('7643','2013-03-29','08:25:00',3.26),('7643','2013-03-29','08:30:00',3.35),('7643','2013-03-29','08:35:00',4.13),('7643','2013-03-29','08:40:00',4.11),('7643','2013-03-29','08:45:00',3.37),('7643','2013-03-29','08:50:00',3.46),('7643','2013-03-29','08:55:00',2.98),('7643','2013-03-29','09:00:00',2.94),('7643','2013-03-29','09:05:00',7.11),('7643','2013-03-29','09:10:00',6.27),('7643','2013-03-29','09:15:00',7.79),('7643','2013-03-29','09:20:00',15.39),('7643','2013-03-29','09:25:00',9.99),('7643','2013-03-29','09:30:00',4.87),('7643','2013-03-29','09:35:00',5.76),('7643','2013-03-29','09:40:00',5.2),('7643','2013-03-29','09:45:00',4.88),('7643','2013-03-29','09:50:00',3.87),('7643','2013-03-29','09:55:00',4.66),('7643','2013-03-29','10:00:00',6.32),('7643','2013-03-29','10:05:00',6.47),('7643','2013-03-29','10:10:00',7),('7643','2013-03-29','10:15:00',6.39),('7643','2013-03-29','10:20:00',5.4),('7643','2013-03-29','10:25:00',5.24),('7643','2013-03-29','10:30:00',6.08),('7643','2013-03-29','10:35:00',7.38),('7643','2013-03-29','10:40:00',9.68),('7643','2013-03-29','10:45:00',11.78),('7643','2013-03-29','10:50:00',12.6),('7643','2013-03-29','10:55:00',8.48),('7643','2013-03-29','11:00:00',11.46),('7643','2013-03-29','11:05:00',14.04),('7643','2013-03-29','11:10:00',17.65),('7643','2013-03-29','11:15:00',10.3),('7643','2013-03-29','11:20:00',18.82),('7643','2013-03-29','11:25:00',18.02),('7643','2013-03-29','11:30:00',9.68),('7643','2013-03-29','11:35:00',11.78),('7643','2013-03-29','11:40:00',8.59),('7643','2013-03-29','11:45:00',13.43),('7643','2013-03-29','11:50:00',15.04),('7643','2013-03-29','11:55:00',13.74),('7643','2013-03-29','12:00:00',17.21),('7643','2013-03-29','12:05:00',9.77),('7643','2013-03-29','12:10:00',7.43),('7643','2013-03-29','12:15:00',7.48),('7643','2013-03-29','12:20:00',7.22),('7643','2013-03-29','12:25:00',4.17),('7643','2013-03-29','12:30:00',4.51),('7643','2013-03-29','12:35:00',3.71),('7643','2013-03-29','12:40:00',2.2),('7643','2013-03-29','12:45:00',3.41),('7643','2013-03-29','12:50:00',3.29),('7643','2013-03-29','12:55:00',1.34),('7643','2013-03-29','13:00:00',1.06),('7643','2013-03-29','13:05:00',2.29),('7643','2013-03-29','13:10:00',3.8),('7643','2013-03-29','13:15:00',10.57),('7643','2013-03-29','13:20:00',8.81),('7643','2013-03-29','13:25:00',5.25),('7643','2013-03-29','13:30:00',2.93),('7643','2013-03-29','13:35:00',2.4),('7643','2013-03-29','13:40:00',2.49),('7643','2013-03-29','13:45:00',4.4),('7643','2013-03-29','13:50:00',10.26),('7643','2013-03-29','13:55:00',12.95),('7643','2013-03-29','14:00:00',7.58),('7643','2013-03-29','14:05:00',8.42),('7643','2013-03-29','14:10:00',4.21),('7643','2013-03-29','14:15:00',6.1),('7643','2013-03-29','14:20:00',6.93),('7643','2013-03-29','14:25:00',5.3),('7643','2013-03-29','14:30:00',5.65),('7643','2013-03-29','14:35:00',5.97),('7643','2013-03-29','14:40:00',4.22),('7643','2013-03-29','14:45:00',4.44),('7643','2013-03-29','14:50:00',5.93),('7643','2013-03-29','14:55:00',3.73),('7643','2013-03-29','15:00:00',3.08),('7643','2013-03-29','15:05:00',2.47),('7643','2013-03-29','15:10:00',2.33),('7643','2013-03-29','15:15:00',2.63),('7643','2013-03-29','15:20:00',3.57),('7643','2013-03-29','15:25:00',3.43),('7643','2013-03-29','15:30:00',2.65),('7643','2013-03-29','15:35:00',2.33),('7643','2013-03-29','15:40:00',3.05),('7643','2013-03-29','15:45:00',2.72),('7643','2013-03-29','15:50:00',2.72),('7643','2013-03-29','15:55:00',2.29),('7643','2013-03-29','16:00:00',1.46),('7643','2013-03-29','16:05:00',1.31),('7643','2013-03-29','16:15:00',1.01),('7643','2013-03-29','16:20:00',1.46),('7643','2013-03-29','16:25:00',1.34),('7643','2013-03-29','16:30:00',1.2),('7643','2013-03-29','16:45:00',1.03),('7643','2013-03-29','16:50:00',1.55),('7643','2013-03-29','16:55:00',1.12),('7643','2013-03-28','06:35:00',1.17),('7643','2013-03-28','06:45:00',1.28),('7643','2013-03-28','06:50:00',2.04),('7643','2013-03-28','06:55:00',1.93),('7643','2013-03-28','07:00:00',2.52),('7643','2013-03-28','07:05:00',2.82),('7643','2013-03-28','07:10:00',3.24),('7643','2013-03-28','07:15:00',3.55),('7643','2013-03-28','07:20:00',3.95),('7643','2013-03-28','07:25:00',4.5),('7643','2013-03-28','07:30:00',4.91),('7643','2013-03-28','07:35:00',4.62),('7643','2013-03-28','07:40:00',5.66),('7643','2013-03-28','07:45:00',6),('7643','2013-03-28','07:50:00',6.54),('7643','2013-03-28','07:55:00',4.15),('7643','2013-03-28','08:00:00',5.53),('7643','2013-03-28','08:05:00',6.77),('7643','2013-03-28','08:10:00',8.33),('7643','2013-03-28','08:16:00',8.23),('7643','2013-03-28','08:20:00',8.59),('7643','2013-03-28','08:25:00',8.92),('7643','2013-03-28','08:30:00',9.21),('7643','2013-03-28','08:35:00',9.53),('7643','2013-03-28','08:40:00',9.68),('7643','2013-03-28','08:45:00',9.44),('7643','2013-03-28','08:50:00',9.63),('7643','2013-03-28','08:55:00',9.4),('7643','2013-03-28','09:00:00',9.38),('7643','2013-03-28','09:05:00',10.4),('7643','2013-03-28','09:10:00',10.81),('7643','2013-03-28','09:15:00',11.9),('7643','2013-03-28','09:20:00',12.57),('7643','2013-03-28','09:25:00',11.75),('7643','2013-03-28','09:30:00',13.18),('7643','2013-03-28','09:35:00',13.17),('7643','2013-03-28','09:40:00',13.14),('7643','2013-03-28','09:45:00',12.05),('7643','2013-03-28','09:50:00',12.39),('7643','2013-03-28','09:55:00',13.06),('7643','2013-03-28','10:00:00',13.29),('7643','2013-03-28','10:05:00',12.36),('7643','2013-03-28','10:10:00',10.78),('7643','2013-03-28','10:15:00',13.36),('7643','2013-03-28','10:20:00',12.37),('7643','2013-03-28','10:25:00',11.79),('7643','2013-03-28','10:30:00',12.02),('7643','2013-03-28','10:35:00',12.97),('7643','2013-03-28','10:40:00',11.04),('7643','2013-03-28','10:45:00',11.6),('7643','2013-03-28','10:50:00',13.88),('7643','2013-03-28','10:55:00',14.04),('7643','2013-03-28','11:00:00',15.83),('7643','2013-03-28','11:05:00',15.34),('7643','2013-03-28','11:10:00',16.9),('7643','2013-03-28','11:15:00',17),('7643','2013-03-28','11:20:00',9.63),('7643','2013-03-28','11:25:00',13.56),('7643','2013-03-28','11:30:00',15),('7643','2013-03-28','11:35:00',14.2),('7643','2013-03-28','11:40:00',16.52),('7643','2013-03-28','11:45:00',16.55),('7643','2013-03-28','11:50:00',16.58),('7643','2013-03-28','11:55:00',16.61),('7643','2013-03-28','12:00:00',16.6),('7643','2013-03-28','12:05:00',16.96),('7643','2013-03-28','12:10:00',16.85),('7643','2013-03-28','12:15:00',15.53),('7643','2013-03-28','12:20:00',16.53),('7643','2013-03-28','12:25:00',16.16),('7643','2013-03-28','12:30:00',15.02),('7643','2013-03-28','12:35:00',15.84),('7643','2013-03-28','12:40:00',16.12),('7643','2013-03-28','12:45:00',12.97),('7643','2013-03-28','12:50:00',12.57),('7643','2013-03-28','12:55:00',14.2),('7643','2013-03-28','13:00:00',11.01),('7643','2013-03-28','13:05:00',10.65),('7643','2013-03-28','13:10:00',15.43),('7643','2013-03-28','13:15:00',13.22),('7643','2013-03-28','13:20:00',13.42),('7643','2013-03-28','13:25:00',16),('7643','2013-03-28','13:30:00',14.62),('7643','2013-03-28','13:35:00',12.9),('7643','2013-03-28','13:40:00',12.84),('7643','2013-03-28','13:45:00',13.15),('7643','2013-03-28','13:50:00',12.7),('7643','2013-03-28','13:55:00',13.21),('7643','2013-03-28','14:00:00',13.16),('7643','2013-03-28','14:05:00',11.19),('7643','2013-03-28','14:10:00',8.57),('7643','2013-03-28','14:15:00',9.2),('7643','2013-03-28','14:20:00',9.32),('7643','2013-03-28','14:25:00',9.55),('7643','2013-03-28','14:30:00',8.06),('7643','2013-03-28','14:35:00',7.97),('7643','2013-03-28','14:40:00',7.53),('7643','2013-03-28','14:45:00',7.01),('7643','2013-03-28','14:50:00',6.68),('7643','2013-03-28','14:55:00',6.5),('7643','2013-03-28','15:00:00',5.76),('7643','2013-03-28','15:05:00',5.81),('7643','2013-03-28','15:10:00',5.53),('7643','2013-03-28','15:15:00',5.38),('7643','2013-03-28','15:20:00',5.1),('7643','2013-03-28','15:25:00',4.58),('7643','2013-03-28','15:30:00',4.22),('7643','2013-03-28','15:35:00',4.05),('7643','2013-03-28','15:40:00',3.87),('7643','2013-03-28','15:45:00',3.74),('7643','2013-03-28','15:50:00',3.98),('7643','2013-03-28','15:55:00',4.65),('7643','2013-03-28','16:00:00',6.17),('7643','2013-03-28','16:05:00',5.72),('7643','2013-03-28','16:10:00',4.27),('7643','2013-03-28','16:15:00',3.66),('7643','2013-03-28','16:20:00',3.34),('7643','2013-03-28','16:25:00',3.62),('7643','2013-03-28','16:30:00',4.11),('7643','2013-03-28','16:35:00',3.95),('7643','2013-03-28','16:40:00',7.41),('7643','2013-03-28','16:45:00',6.1),('7643','2013-03-28','16:50:00',4.49),('7643','2013-03-28','16:55:00',3.51),('7643','2013-03-28','17:00:00',3.97),('7643','2013-03-28','17:05:00',3.09),('7643','2013-03-28','17:10:00',2),('7643','2013-03-28','17:15:00',1.99),('7643','2013-03-28','17:20:00',3.03),('7643','2013-03-28','17:25:00',3.01),('7643','2013-03-28','17:30:00',2.61),('7643','2013-03-28','17:35:00',2.04),('7643','2013-03-28','17:40:00',1.32),('7643','2013-03-27','07:25:00',1.17),('7643','2013-03-27','07:30:00',1.95),('7643','2013-03-27','07:35:00',1.82),('7643','2013-03-27','07:40:00',2.11),('7643','2013-03-27','07:45:00',2.04),('7643','2013-03-27','07:50:00',1.32),('7643','2013-03-27','08:25:00',1),('7643','2013-03-27','08:30:00',1.01),('7643','2013-03-27','08:35:00',1.31),('7643','2013-03-27','08:40:00',1.85),('7643','2013-03-27','08:45:00',1.98),('7643','2013-03-27','08:50:00',2.19),('7643','2013-03-27','08:55:00',2.67),('7643','2013-03-27','09:00:00',2.79),('7643','2013-03-27','09:05:00',3.97),('7643','2013-03-27','09:10:00',7.95),('7643','2013-03-27','09:15:00',12.38),('7643','2013-03-27','09:20:00',5.88),('7643','2013-03-27','09:25:00',5.7),('7643','2013-03-27','09:30:00',4),('7643','2013-03-27','09:35:00',3.52),('7643','2013-03-27','09:40:00',3.07),('7643','2013-03-27','09:45:00',3.61),('7643','2013-03-27','09:50:00',3.66),('7643','2013-03-27','09:55:00',4.04),('7643','2013-03-27','10:00:00',4.34),('7643','2013-03-27','10:05:00',3.21),('7643','2013-03-27','10:10:00',2.31),('7643','2013-03-27','10:15:00',2.35),('7643','2013-03-27','10:20:00',1.94),('7643','2013-03-27','10:25:00',2.08),('7643','2013-03-27','10:30:00',2.19),('7643','2013-03-27','10:35:00',2.05),('7643','2013-03-27','10:40:00',1.99),('7643','2013-03-27','10:45:00',1.82),('7643','2013-03-27','10:50:00',1.91),('7643','2013-03-27','10:55:00',3.08),('7643','2013-03-27','11:00:00',4.2),('7643','2013-03-27','11:05:00',2.89),('7643','2013-03-27','11:10:00',2.06),('7643','2013-03-27','11:15:00',1.82),('7643','2013-03-27','11:20:00',2.09),('7643','2013-03-27','11:25:00',2.68),('7643','2013-03-27','11:30:00',3.62),('7643','2013-03-27','11:35:00',5.75),('7643','2013-03-27','11:40:00',7.09),('7643','2013-03-27','11:45:00',4.9),('7643','2013-03-27','11:50:00',5.4),('7643','2013-03-27','11:55:00',8.67),('7643','2013-03-27','12:00:00',6.57),('7643','2013-03-27','12:05:00',4.71),('7643','2013-03-27','12:10:00',4.49),('7643','2013-03-27','12:15:00',5.04),('7643','2013-03-27','12:20:00',4.87),('7643','2013-03-27','12:25:00',4.23),('7643','2013-03-27','12:30:00',3.8),('7643','2013-03-27','12:35:00',3.44),('7643','2013-03-27','12:40:00',4.64),('7643','2013-03-27','12:45:00',6.26),('7643','2013-03-27','12:50:00',12.11),('7643','2013-03-27','12:55:00',13.53),('7643','2013-03-27','13:00:00',12.44),('7643','2013-03-27','13:05:00',12.05),('7643','2013-03-27','13:10:00',15.46),('7643','2013-03-27','13:15:00',13.43),('7643','2013-03-27','13:20:00',11.69),('7643','2013-03-27','13:25:00',14.87),('7643','2013-03-27','13:30:00',11.51),('7643','2013-03-27','13:35:00',9.84),('7643','2013-03-27','13:40:00',8.97),('7643','2013-03-27','13:45:00',8.35),('7643','2013-03-27','13:50:00',10.37),('7643','2013-03-27','13:55:00',7.08),('7643','2013-03-27','14:00:00',6.8),('7643','2013-03-27','14:05:00',9),('7643','2013-03-27','14:10:00',6.2),('7643','2013-03-27','14:15:00',5.97),('7643','2013-03-27','14:20:00',5.76),('7643','2013-03-27','14:25:00',6.5),('7643','2013-03-27','14:30:00',7.29),('7643','2013-03-27','14:35:00',6.43),('7643','2013-03-27','14:40:00',4.94),('7643','2013-03-27','14:45:00',4.81),('7643','2013-03-27','14:50:00',4.06),('7643','2013-03-27','14:55:00',3.45),('7643','2013-03-27','15:00:00',4.39),('7643','2013-03-27','15:05:00',5.09),('7643','2013-03-27','15:10:00',7.87),('7643','2013-03-27','15:15:00',7.3),('7643','2013-03-27','15:20:00',9.03),('7643','2013-03-27','15:25:00',6.62),('7643','2013-03-27','15:30:00',5.58),('7643','2013-03-27','15:35:00',9.47),('7643','2013-03-27','15:40:00',6.68),('7643','2013-03-27','15:45:00',7.08),('7643','2013-03-27','15:50:00',4.94),('7643','2013-03-27','15:55:00',9.56),('7643','2013-03-27','16:00:00',5.03),('7643','2013-03-27','16:05:00',3.28),('7643','2013-03-27','16:10:00',7.78),('7643','2013-03-27','16:15:00',2.55),('7643','2013-03-27','16:20:00',1.82),('7643','2013-03-27','16:25:00',2.5),('7643','2013-03-27','16:30:00',3.35),('7643','2013-03-27','16:35:00',6.02),('7643','2013-03-27','16:40:00',3.54),('7643','2013-03-27','16:45:00',4.17),('7643','2013-03-27','16:50:00',2.27),('7643','2013-03-27','16:55:00',2.52),('7643','2013-03-27','17:00:00',5.32),('7643','2013-03-27','17:05:00',4.54),('7643','2013-03-27','17:10:00',3.61),('7643','2013-03-27','17:15:00',3.05),('7643','2013-03-27','17:20:00',2.45),('7643','2013-03-27','17:25:00',1.9),('7643','2013-03-27','17:30:00',1.28),('7643','2013-03-26','06:35:00',1.02),('7643','2013-03-26','06:40:00',1.23),('7643','2013-03-26','06:45:00',1.47),('7643','2013-03-26','06:50:00',1.77),('7643','2013-03-26','06:55:00',2.02),('7643','2013-03-26','07:00:00',2.31),('7643','2013-03-26','07:05:00',2.6),('7643','2013-03-26','07:10:00',2.99),('7643','2013-03-26','07:15:00',3.39),('7643','2013-03-26','07:20:00',3.76),('7643','2013-03-26','07:25:00',4.19),('7643','2013-03-26','07:30:00',4.59),('7643','2013-03-26','07:35:00',4.74),('7643','2013-03-26','07:40:00',5),('7643','2013-03-26','07:45:00',3.33),('7643','2013-03-26','07:50:00',2.4),('7643','2013-03-26','07:55:00',4.53),('7643','2013-03-26','08:00:00',5.07),('7643','2013-03-26','08:05:00',5.8),('7643','2013-03-26','08:10:00',5.17),('7643','2013-03-26','08:15:00',5.61),('7643','2013-03-26','08:20:00',5.03),('7643','2013-03-26','08:25:00',5.81),('7643','2013-03-26','08:30:00',8.31),('7643','2013-03-26','08:35:00',6.48),('7643','2013-03-26','08:40:00',5.09),('7643','2013-03-26','08:45:00',4.44),('7643','2013-03-26','08:50:00',5.06),('7643','2013-03-26','08:55:00',7.06),('7643','2013-03-26','09:00:00',5.12),('7643','2013-03-26','09:05:00',4.56),('7643','2013-03-26','09:10:00',3.6),('7643','2013-03-26','09:15:00',7.15),('7643','2013-03-26','09:20:00',8.83),('7643','2013-03-26','09:25:00',5.9),('7643','2013-03-26','09:30:00',4.21),('7643','2013-03-26','09:35:00',3.58),('7643','2013-03-26','09:40:00',3.91),('7643','2013-03-26','09:45:00',7.35),('7643','2013-03-26','09:50:00',9.68),('7643','2013-03-26','09:55:00',5.88),('7643','2013-03-26','10:00:00',7.17),('7643','2013-03-26','10:05:00',4.33),('7643','2013-03-26','10:10:00',6.11),('7643','2013-03-26','10:15:00',6.95),('7643','2013-03-26','10:20:00',6.16),('7643','2013-03-26','10:25:00',7.2),('7643','2013-03-26','10:30:00',8.67),('7643','2013-03-26','10:35:00',5.92),('7643','2013-03-26','10:40:00',7.07),('7643','2013-03-26','10:45:00',8.08),('7643','2013-03-26','10:50:00',7.19),('7643','2013-03-26','10:55:00',7.36),('7643','2013-03-26','11:00:00',5.79),('7643','2013-03-26','11:05:00',6.12),('7643','2013-03-26','11:10:00',6.63),('7643','2013-03-26','11:15:00',6.91),('7643','2013-03-26','11:20:00',7.15),('7643','2013-03-26','11:25:00',6.72),('7643','2013-03-26','11:30:00',7.53),('7643','2013-03-26','11:35:00',7.09),('7643','2013-03-26','11:40:00',6.78),('7643','2013-03-26','11:45:00',6.74),('7643','2013-03-26','11:50:00',6.47),('7643','2013-03-26','11:55:00',9.9),('7643','2013-03-26','12:00:00',11.98),('7643','2013-03-26','12:05:00',11.59),('7643','2013-03-26','12:10:00',10.35),('7643','2013-03-26','12:15:00',7.13),('7643','2013-03-26','12:20:00',7.89),('7643','2013-03-26','12:25:00',6.39),('7643','2013-03-26','12:30:00',13.28),('7643','2013-03-26','12:35:00',18.18),('7643','2013-03-26','12:40:00',18.3),('7643','2013-03-26','12:45:00',17.3),('7643','2013-03-26','12:50:00',12.49),('7643','2013-03-26','12:55:00',9.81),('7643','2013-03-26','13:00:00',5.72),('7643','2013-03-26','13:05:00',9.62),('7643','2013-03-26','13:10:00',11.6),('7643','2013-03-26','13:15:00',7.07),('7643','2013-03-26','13:20:00',5.45),('7643','2013-03-26','13:25:00',5.27),('7643','2013-03-26','13:30:00',9.32),('7643','2013-03-26','13:35:00',9.23),('7643','2013-03-26','13:40:00',7.26),('7643','2013-03-26','13:45:00',9.11),('7643','2013-03-26','13:50:00',10.64),('7643','2013-03-26','13:55:00',9.47),('7643','2013-03-26','14:00:00',7.37),('7643','2013-03-26','14:05:00',5.86),('7643','2013-03-26','14:10:00',6.18),('7643','2013-03-26','14:15:00',6.98),('7643','2013-03-26','14:20:00',8.18),('7643','2013-03-26','14:25:00',7.1),('7643','2013-03-26','14:30:00',5.67),('7643','2013-03-26','14:35:00',6.15),('7643','2013-03-26','14:40:00',9.27),('7643','2013-03-26','14:45:00',9.14),('7643','2013-03-26','14:50:00',6.03),('7643','2013-03-26','14:55:00',4.95),('7643','2013-03-26','15:00:00',3.98),('7643','2013-03-26','15:05:00',4.71),('7643','2013-03-26','15:10:00',5.64),('7643','2013-03-26','15:15:00',3.98),('7643','2013-03-26','15:20:00',3.86),('7643','2013-03-26','15:25:00',3.87),('7643','2013-03-26','15:30:00',2.85),('7643','2013-03-26','15:35:00',2.54),('7643','2013-03-26','15:40:00',1.95),('7643','2013-03-26','15:45:00',1.25),('7643','2013-03-26','15:50:00',1.77),('7643','2013-03-26','15:55:00',2.12),('7643','2013-03-26','16:00:00',2.21),('7643','2013-03-26','16:05:00',2.39),('7643','2013-03-26','16:10:00',2.76),('7643','2013-03-26','16:15:00',2.8),('7643','2013-03-26','16:20:00',2.66),('7643','2013-03-26','16:25:00',2.84),('7643','2013-03-26','16:30:00',2.89),('7643','2013-03-26','16:35:00',2.91),('7643','2013-03-26','16:40:00',3.45),('7643','2013-03-26','16:45:00',4.37),('7643','2013-03-26','16:50:00',3.71),('7643','2013-03-26','16:55:00',4.44),('7643','2013-03-26','17:00:00',4.37),('7643','2013-03-26','17:05:00',5.18),('7643','2013-03-26','17:10:00',4.51),('7643','2013-03-26','17:15:00',2.8),('7643','2013-03-25','06:50:00',1.05),('7643','2013-03-25','06:55:00',1.24),('7643','2013-03-25','07:00:00',1.32),('7643','2013-03-25','07:05:00',1.49),('7643','2013-03-25','07:10:00',1.78),('7643','2013-03-25','07:15:00',2.03),('7643','2013-03-25','07:20:00',2.07),('7643','2013-03-25','07:30:00',1.01),('7643','2013-03-25','07:35:00',2.04),('7643','2013-03-25','07:40:00',2.63),('7643','2013-03-25','07:45:00',4.03),('7643','2013-03-25','07:50:00',7.18),('7643','2013-03-25','07:55:00',7.22),('7643','2013-03-25','08:00:00',2.46),('7643','2013-03-25','08:05:00',2.04),('7643','2013-03-25','08:10:00',2.51),('7643','2013-03-25','08:15:00',2.43),('7643','2013-03-25','08:20:00',2.24),('7643','2013-03-25','08:25:00',2.36),('7643','2013-03-25','08:30:00',3.19),('7643','2013-03-25','08:35:00',5.08),('7643','2013-03-25','08:40:00',5.73),('7643','2013-03-25','08:45:00',3.37),('7643','2013-03-25','08:50:00',2.12),('7643','2013-03-25','08:55:00',2.06),('7643','2013-03-25','09:00:00',1.92),('7643','2013-03-25','09:05:00',2.46),('7643','2013-03-25','09:10:00',3.8),('7643','2013-03-25','09:15:00',6.11),('7643','2013-03-25','09:20:00',4.08),('7643','2013-03-25','09:25:00',2.24),('7643','2013-03-25','09:30:00',1.76),('7643','2013-03-25','09:35:00',1.69),('7643','2013-03-25','09:40:00',1.87),('7643','2013-03-25','09:45:00',1.69),('7643','2013-03-25','09:50:00',2.7),('7643','2013-03-25','09:55:00',7.99),('7643','2013-03-25','10:00:00',4.97),('7643','2013-03-25','10:05:00',2.34),('7643','2013-03-25','10:10:00',2.84),('7643','2013-03-25','10:15:00',2.06),('7643','2013-03-25','10:20:00',1.92),('7643','2013-03-25','10:25:00',2.7),('7643','2013-03-25','10:30:00',1.24),('7643','2013-03-25','10:35:00',1.72),('7643','2013-03-25','10:40:00',2.07),('7643','2013-03-25','10:45:00',2.14),('7643','2013-03-25','10:50:00',3.4),('7643','2013-03-25','10:55:00',3.13),('7643','2013-03-25','11:00:00',3.83),('7643','2013-03-25','11:05:00',4.01),('7643','2013-03-25','11:10:00',9.06),('7643','2013-03-25','11:15:00',8.86),('7643','2013-03-25','11:20:00',7.8),('7643','2013-03-25','11:25:00',4.17),('7643','2013-03-25','11:30:00',3.05),('7643','2013-03-25','11:35:00',1.73),('7643','2013-03-25','11:40:00',1.43),('7643','2013-03-25','11:45:00',3.46),('7643','2013-03-25','11:50:00',8.54),('7643','2013-03-25','11:55:00',4.26),('7643','2013-03-25','12:00:00',3.8),('7643','2013-03-25','12:05:00',4.41),('7643','2013-03-25','12:10:00',4.71),('7643','2013-03-25','12:15:00',5.22),('7643','2013-03-25','12:20:00',5.5),('7643','2013-03-25','12:25:00',7.75),('7643','2013-03-25','12:30:00',7.02),('7643','2013-03-25','12:35:00',10.68),('7643','2013-03-25','12:40:00',8.44),('7643','2013-03-25','12:45:00',10.45),('7643','2013-03-25','12:50:00',7.41),('7643','2013-03-25','12:55:00',3.95),('7643','2013-03-25','13:00:00',6.35),('7643','2013-03-25','13:05:00',9.15),('7643','2013-03-25','13:10:00',9.04),('7643','2013-03-25','13:15:00',7.15),('7643','2013-03-25','13:20:00',5.02),('7643','2013-03-25','13:25:00',7.89),('7643','2013-03-25','13:30:00',6.82),('7643','2013-03-25','13:35:00',6.55),('7643','2013-03-25','13:40:00',7.91),('7643','2013-03-25','13:45:00',7.17),('7643','2013-03-25','13:50:00',6.27),('7643','2013-03-25','13:55:00',5.95),('7643','2013-03-25','14:00:00',5.72),('7643','2013-03-25','14:05:00',5.4),('7643','2013-03-25','14:10:00',5.47),('7643','2013-03-25','14:15:00',5.07),('7643','2013-03-25','14:20:00',4.46),('7643','2013-03-25','14:25:00',3.85),('7643','2013-03-25','14:30:00',3.26),('7643','2013-03-25','14:35:00',2.98),('7643','2013-03-25','14:40:00',3.18),('7643','2013-03-25','14:45:00',3.29),('7643','2013-03-25','14:50:00',2.98),('7643','2013-03-25','14:55:00',2.96),('7643','2013-03-25','15:00:00',2.92),('7643','2013-03-25','15:05:00',3.05),('7643','2013-03-25','15:10:00',2.99),('7643','2013-03-25','15:15:00',2.64),('7643','2013-03-25','15:20:00',2.88),('7643','2013-03-25','15:25:00',2.86),('7643','2013-03-25','15:30:00',3.11),('7643','2013-03-25','15:35:00',3.39),('7643','2013-03-25','15:40:00',3.02),('7643','2013-03-25','15:45:00',2.04),('7643','2013-03-25','15:50:00',2.03),('7643','2013-03-25','15:55:00',1.11),('7643','2013-03-25','16:15:00',1.13),('7643','2013-03-25','16:20:00',1.02),('7643','2013-03-24','08:10:00',2.01),('7643','2013-03-24','08:15:00',3.19),('7643','2013-03-24','08:20:00',6.55),('7643','2013-03-24','08:25:00',6.97),('7643','2013-03-24','08:30:00',6.11),('7643','2013-03-24','08:35:00',2.03),('7643','2013-03-24','08:40:00',2.42),('7643','2013-03-24','08:45:00',4.04),('7643','2013-03-24','08:50:00',3.34),('7643','2013-03-24','08:55:00',4.12),('7643','2013-03-24','09:00:00',4.17),('7643','2013-03-24','09:05:00',3.93),('7643','2013-03-24','09:10:00',3.97),('7643','2013-03-24','09:15:00',3.95),('7643','2013-03-24','09:20:00',9.25),('7643','2013-03-24','09:25:00',11.78),('7643','2013-03-24','09:30:00',5.1),('7643','2013-03-24','09:35:00',3.44),('7643','2013-03-24','09:40:00',2.45),('7643','2013-03-24','09:45:00',2.86),('7643','2013-03-24','09:50:00',13.15),('7643','2013-03-24','09:55:00',14.51),('7643','2013-03-24','10:00:00',14.97),('7643','2013-03-24','10:05:00',5.56),('7643','2013-03-24','10:10:00',3.27),('7643','2013-03-24','10:15:00',3.86),('7643','2013-03-24','10:20:00',6.06),('7643','2013-03-24','10:25:00',9.67),('7643','2013-03-24','10:30:00',8.8),('7643','2013-03-24','10:35:00',6.65),('7643','2013-03-24','10:40:00',7.16),('7643','2013-03-24','10:45:00',10.12),('7643','2013-03-24','10:50:00',9.9),('7643','2013-03-24','10:55:00',9.2),('7643','2013-03-24','11:00:00',8.7),('7643','2013-03-24','11:05:00',6.96),('7643','2013-03-24','11:10:00',8.27),('7643','2013-03-24','11:15:00',11.12),('7643','2013-03-24','11:20:00',16.58),('7643','2013-03-24','11:25:00',12),('7643','2013-03-24','11:30:00',9.44),('7643','2013-03-24','11:35:00',12.06),('7643','2013-03-24','11:40:00',6.1),('7643','2013-03-24','11:45:00',6.31),('7643','2013-03-24','11:50:00',8.16),('7643','2013-03-24','11:55:00',13.86),('7643','2013-03-24','12:00:00',14.83),('7643','2013-03-24','12:05:00',12.44),('7643','2013-03-24','12:10:00',19.6),('7643','2013-03-24','12:15:00',13.89),('7643','2013-03-24','12:20:00',9.72),('7643','2013-03-24','12:25:00',13.72),('7643','2013-03-24','12:30:00',16.28),('7643','2013-03-24','12:35:00',12.4),('7643','2013-03-24','12:40:00',9.9),('7643','2013-03-24','12:45:00',9.67),('7643','2013-03-24','12:50:00',11.74),('7643','2013-03-24','12:55:00',9.35),('7643','2013-03-24','13:00:00',9.19),('7643','2013-03-24','13:05:00',19.07),('7643','2013-03-24','13:10:00',15.23),('7643','2013-03-24','13:15:00',13.05),('7643','2013-03-24','13:20:00',13.83),('7643','2013-03-24','13:25:00',9.58),('7643','2013-03-24','13:30:00',12.03),('7643','2013-03-24','13:35:00',4.42),('7643','2013-03-24','13:40:00',4.44),('7643','2013-03-24','13:45:00',6.61),('7643','2013-03-24','13:50:00',8.29),('7643','2013-03-24','13:55:00',6.53),('7643','2013-03-24','14:00:00',3.98),('7643','2013-03-24','14:05:00',3.95),('7643','2013-03-24','14:10:00',8.9),('7643','2013-03-24','14:15:00',6.17),('7643','2013-03-24','14:20:00',9.46),('7643','2013-03-24','14:25:00',19.14),('7643','2013-03-24','14:30:00',11.01),('7643','2013-03-24','14:35:00',9.89),('7643','2013-03-24','14:40:00',6.58),('7643','2013-03-24','14:45:00',6.98),('7643','2013-03-24','14:50:00',6.13),('7643','2013-03-24','14:55:00',8.47),('7643','2013-03-24','15:00:00',7.96),('7643','2013-03-24','15:05:00',8.91),('7643','2013-03-24','15:10:00',12.26),('7643','2013-03-24','15:15:00',9.21),('7643','2013-03-24','15:20:00',6.93),('7643','2013-03-24','15:25:00',10.61),('7643','2013-03-24','15:30:00',9.11),('7643','2013-03-24','15:35:00',7.4),('7643','2013-03-24','15:40:00',12.25),('7643','2013-03-24','15:45:00',9.83),('7643','2013-03-24','15:50:00',7.03),('7643','2013-03-24','15:55:00',5.39),('7643','2013-03-24','16:00:00',10.59),('7643','2013-03-24','16:05:00',4.72),('7643','2013-03-24','16:10:00',3.55),('7643','2013-03-24','16:15:00',4.77),('7643','2013-03-24','16:20:00',2.92),('7643','2013-03-24','16:25:00',2.11),('7643','2013-03-24','16:30:00',4.15),('7643','2013-03-24','16:35:00',7.71),('7643','2013-03-24','16:40:00',6.3),('7643','2013-03-24','16:45:00',4.62),('7643','2013-03-24','16:50:00',2.79),('7643','2013-03-24','16:55:00',1.92),('7643','2013-03-24','17:00:00',1.43),('7643','2013-03-24','17:05:00',1.24),('7643','2013-03-24','17:10:00',1.23),('7643','2013-03-24','17:15:00',1.31),('7643','2013-03-24','17:20:00',1.17),('7643','2013-03-24','17:25:00',1.04),('7643','2013-03-23','06:50:00',1.11),('7643','2013-03-23','06:55:00',1.55),('7643','2013-03-23','07:00:00',1.62),('7643','2013-03-23','07:05:00',1.98),('7643','2013-03-23','07:10:00',2.34),('7643','2013-03-23','07:15:00',2.34),('7643','2013-03-23','07:20:00',3.14),('7643','2013-03-23','07:25:00',3.2),('7643','2013-03-23','07:30:00',3.17),('7643','2013-03-23','07:35:00',3.55),('7643','2013-03-23','07:40:00',3.76),('7643','2013-03-23','07:45:00',4.19),('7643','2013-03-23','07:50:00',4.83),('7643','2013-03-23','07:55:00',5.62),('7643','2013-03-23','08:00:00',6.55),('7643','2013-03-23','08:05:00',6.95),('7643','2013-03-23','08:10:00',7.12),('7643','2013-03-23','08:15:00',7.6),('7643','2013-03-23','08:20:00',7.95),('7643','2013-03-23','08:25:00',8.28),('7643','2013-03-23','08:30:00',8.55),('7643','2013-03-23','08:35:00',8.8),('7643','2013-03-23','08:40:00',9.04),('7643','2013-03-23','08:45:00',9.32),('7643','2013-03-23','08:50:00',9.44),('7643','2013-03-23','08:55:00',9.7),('7643','2013-03-23','09:00:00',9.95),('7643','2013-03-23','09:05:00',10.33),('7643','2013-03-23','09:10:00',10.56),('7643','2013-03-23','09:15:00',10.79),('7643','2013-03-23','09:20:00',10.99),('7643','2013-03-23','09:25:00',11.23),('7643','2013-03-23','09:30:00',11.45),('7643','2013-03-23','09:35:00',11.59),('7643','2013-03-23','09:40:00',11.79),('7643','2013-03-23','09:45:00',12.08),('7643','2013-03-23','09:50:00',12.28),('7643','2013-03-23','09:55:00',12.49),('7643','2013-03-23','10:00:00',12.45),('7643','2013-03-23','10:05:00',12.89),('7643','2013-03-23','10:10:00',13.12),('7643','2013-03-23','10:15:00',13.26),('7643','2013-03-23','10:20:00',13.4),('7643','2013-03-23','10:25:00',13.59),('7643','2013-03-23','10:30:00',13.8),('7643','2013-03-23','10:35:00',13.82),('7643','2013-03-23','10:40:00',13.83),('7643','2013-03-23','10:45:00',13.89),('7643','2013-03-23','10:50:00',13.94),('7643','2013-03-23','10:55:00',14.07),('7643','2013-03-23','11:00:00',14.15),('7643','2013-03-23','11:05:00',14.3),('7643','2013-03-23','11:10:00',14.39),('7643','2013-03-23','11:15:00',14.43),('7643','2013-03-23','11:20:00',14.44),('7643','2013-03-23','11:25:00',14.5),('7643','2013-03-23','11:30:00',14.57),('7643','2013-03-23','11:35:00',14.59),('7643','2013-03-23','11:40:00',14.65),('7643','2013-03-23','11:45:00',14.68),('7643','2013-03-23','11:50:00',14.69),('7643','2013-03-23','11:55:00',14.73),('7643','2013-03-23','12:00:00',14.86),('7643','2013-03-23','12:05:00',14.9),('7643','2013-03-23','12:10:00',15.17),('7643','2013-03-23','12:15:00',15.27),('7643','2013-03-23','12:20:00',15.55),('7643','2013-03-23','12:25:00',15.72),('7643','2013-03-23','12:30:00',15.68),('7643','2013-03-23','12:35:00',15.67),('7643','2013-03-23','12:40:00',15.47),('7643','2013-03-23','12:45:00',15.53),('7643','2013-03-23','12:50:00',15.53),('7643','2013-03-23','12:55:00',15.4),('7643','2013-03-23','13:00:00',15.3),('7643','2013-03-23','13:05:00',15.37),('7643','2013-03-23','13:10:00',15.27),('7643','2013-03-23','13:15:00',15.17),('7643','2013-03-23','13:20:00',15.11),('7643','2013-03-23','13:25:00',14.88),('7643','2013-03-23','13:30:00',14.75),('7643','2013-03-23','13:35:00',14.64),('7643','2013-03-23','13:40:00',14.55),('7643','2013-03-23','13:45:00',14.38),('7643','2013-03-23','13:50:00',14.23),('7643','2013-03-23','13:55:00',14.09),('7643','2013-03-23','14:00:00',13.88),('7643','2013-03-23','14:05:00',13.63),('7643','2013-03-23','14:10:00',13.34),('7643','2013-03-23','14:15:00',13.22),('7643','2013-03-23','14:20:00',13.01),('7643','2013-03-23','14:25:00',12.74),('7643','2013-03-23','14:30:00',12.34),('7643','2013-03-23','14:35:00',11.91),('7643','2013-03-23','14:40:00',11.79),('7643','2013-03-23','14:45:00',11.62),('7643','2013-03-23','14:50:00',11.07),('7643','2013-03-23','14:55:00',10.96),('7643','2013-03-23','15:00:00',10.67),('7643','2013-03-23','15:05:00',10.44),('7643','2013-03-23','15:10:00',9.9),('7643','2013-03-23','15:15:00',10.63),('7643','2013-03-23','15:20:00',10.16),('7643','2013-03-23','15:25:00',9.57),('7643','2013-03-23','15:30:00',8.6),('7643','2013-03-23','15:35:00',8.6),('7643','2013-03-23','15:40:00',8.53),('7643','2013-03-23','15:45:00',6.91),('7643','2013-03-23','15:50:00',5.24),('7643','2013-03-23','15:55:00',4.79),('7643','2013-03-23','16:00:00',4.62),('7643','2013-03-23','16:05:00',5.4),('7643','2013-03-23','16:10:00',3.88),('7643','2013-03-23','16:15:00',5.23),('7643','2013-03-23','16:20:00',4.1),('7643','2013-03-23','16:25:00',3.94),('7643','2013-03-23','16:30:00',4.33),('7643','2013-03-23','16:35:00',3.89),('7643','2013-03-23','16:40:00',3.06),('7643','2013-03-23','16:45:00',2.95),('7643','2013-03-23','16:50:00',2.39),('7643','2013-03-23','16:55:00',1.85),('7643','2013-03-23','17:00:00',1.82),('7643','2013-03-23','17:05:00',1.55),('7643','2013-03-23','17:10:00',1.4),('7643','2013-03-23','17:15:00',1.04),('7643','2013-03-22','06:45:00',1.16),('7643','2013-03-22','06:50:00',1.5),('7643','2013-03-22','06:55:00',1.79),('7643','2013-03-22','07:00:00',2.13),('7643','2013-03-22','07:05:00',2.43),('7643','2013-03-22','07:10:00',2.87),('7643','2013-03-22','07:15:00',3.26),('7643','2013-03-22','07:20:00',3.51),('7643','2013-03-22','07:25:00',3.67),('7643','2013-03-22','07:30:00',3.9),('7643','2013-03-22','07:35:00',4.09),('7643','2013-03-22','07:40:00',4.67),('7643','2013-03-22','07:45:00',4.73),('7643','2013-03-22','07:50:00',5.19),('7643','2013-03-22','07:55:00',5.89),('7643','2013-03-22','08:00:00',6.5),('7643','2013-03-22','08:05:00',7.1),('7643','2013-03-22','08:10:00',7.39),('7643','2013-03-22','08:15:00',7.73),('7643','2013-03-22','08:20:00',8.01),('7643','2013-03-22','08:25:00',8.29),('7643','2013-03-22','08:30:00',8.4),('7643','2013-03-22','08:35:00',8.75),('7643','2013-03-22','08:40:00',9.15),('7643','2013-03-22','08:45:00',9.47),('7643','2013-03-22','08:50:00',9.64),('7643','2013-03-22','08:55:00',10.18),('7643','2013-03-22','09:00:00',10.47),('7643','2013-03-22','09:05:00',10.88),('7643','2013-03-22','09:10:00',10.92),('7643','2013-03-22','09:15:00',11.19),('7643','2013-03-22','09:20:00',11.47),('7643','2013-03-22','09:25:00',11.75),('7643','2013-03-22','09:30:00',12.05),('7643','2013-03-22','09:35:00',12.2),('7643','2013-03-22','09:40:00',11.63),('7643','2013-03-22','09:45:00',12.45),('7643','2013-03-22','09:50:00',12.41),('7643','2013-03-22','09:55:00',12.53),('7643','2013-03-22','10:00:00',12.71),('7643','2013-03-22','10:05:00',13.26),('7643','2013-03-22','10:10:00',13.53),('7643','2013-03-22','10:15:00',13.46),('7643','2013-03-22','10:20:00',13.21),('7643','2013-03-22','10:25:00',13.47),('7643','2013-03-22','10:30:00',14.02),('7643','2013-03-22','10:35:00',14.43),('7643','2013-03-22','10:40:00',14.23),('7643','2013-03-22','10:45:00',14.08),('7643','2013-03-22','10:50:00',14.05),('7643','2013-03-22','10:55:00',13.65),('7643','2013-03-22','11:00:00',13.35),('7643','2013-03-22','11:05:00',13.12),('7643','2013-03-22','11:10:00',11.01),('7643','2013-03-22','11:15:00',12.2),('7643','2013-03-22','11:20:00',13.52),('7643','2013-03-22','11:25:00',14.1),('7643','2013-03-22','11:30:00',14),('7643','2013-03-22','11:35:00',14.77),('7643','2013-03-22','11:40:00',14.91),('7643','2013-03-22','11:45:00',14.69),('7643','2013-03-22','11:50:00',14.4),('7643','2013-03-22','11:55:00',14.96),('7643','2013-03-22','12:00:00',15.02),('7643','2013-03-22','12:05:00',14.97),('7643','2013-03-22','12:10:00',15.03),('7643','2013-03-22','12:15:00',15.19),('7643','2013-03-22','12:20:00',15.4),('7643','2013-03-22','12:25:00',15.08),('7643','2013-03-22','12:30:00',15.45),('7643','2013-03-22','12:35:00',15.46),('7643','2013-03-22','12:40:00',14.89),('7643','2013-03-22','12:45:00',14.93),('7643','2013-03-22','12:50:00',15.28),('7643','2013-03-22','12:55:00',15.05),('7643','2013-03-22','13:00:00',11.98),('7643','2013-03-22','13:05:00',15.19),('7643','2013-03-22','13:10:00',14.9),('7643','2013-03-22','13:15:00',14.36),('7643','2013-03-22','13:20:00',14.42),('7643','2013-03-22','13:25:00',14.5),('7643','2013-03-22','13:30:00',13.73),('7643','2013-03-22','13:35:00',12.47),('7643','2013-03-22','13:40:00',13.75),('7643','2013-03-22','13:45:00',13.84),('7643','2013-03-22','13:50:00',13.86),('7643','2013-03-22','13:55:00',13.65),('7643','2013-03-22','14:00:00',13.42),('7643','2013-03-22','14:05:00',13.59),('7643','2013-03-22','14:10:00',13.07),('7643','2013-03-22','14:15:00',12.71),('7643','2013-03-22','14:20:00',13.06),('7643','2013-03-22','14:25:00',12.79),('7643','2013-03-22','14:30:00',12.83),('7643','2013-03-22','14:35:00',12.39),('7643','2013-03-22','14:40:00',12.01),('7643','2013-03-22','14:45:00',11.29),('7643','2013-03-22','14:50:00',11.15),('7643','2013-03-22','14:55:00',11.28),('7643','2013-03-22','15:00:00',10.8),('7643','2013-03-22','15:05:00',9.97),('7643','2013-03-22','15:10:00',10.5),('7643','2013-03-22','15:15:00',9.79),('7643','2013-03-22','15:20:00',9.77),('7643','2013-03-22','15:25:00',9.71),('7643','2013-03-22','15:30:00',8.87),('7643','2013-03-22','15:35:00',8.78),('7643','2013-03-22','15:40:00',8.26),('7643','2013-03-22','15:45:00',7.67),('7643','2013-03-22','15:50:00',7.23),('7643','2013-03-22','15:55:00',7.06),('7643','2013-03-22','16:00:00',6.6),('7643','2013-03-22','16:05:00',5.81),('7643','2013-03-22','16:10:00',7.39),('7643','2013-03-22','16:15:00',6.56),('7643','2013-03-22','16:20:00',5.67),('7643','2013-03-22','16:25:00',5.76),('7643','2013-03-22','16:30:00',4.31),('7643','2013-03-22','16:35:00',4.61),('7643','2013-03-22','16:40:00',4.06),('7643','2013-03-22','16:45:00',4.04),('7643','2013-03-22','16:50:00',3.34),('7643','2013-03-22','16:55:00',3.32),('7643','2013-03-22','17:00:00',3.79),('7643','2013-03-22','17:05:00',3.85),('7643','2013-03-22','17:10:00',3.24),('7643','2013-03-22','17:15:00',2.56),('7643','2013-03-22','17:20:00',2.18),('7643','2013-03-22','17:25:00',1.9),('7643','2013-03-22','17:30:00',1.54),('7643','2013-03-22','17:35:00',1.07),('7643','2014-03-25','06:40:00',1.17),('7643','2014-03-25','06:45:00',1.4),('7643','2014-03-25','06:50:00',1.42),('7643','2014-03-25','06:55:00',1.98),('7643','2014-03-25','07:00:00',2.39),('7643','2014-03-25','07:05:00',2.02),('7643','2014-03-25','07:10:00',3.13),('7643','2014-03-25','07:15:00',3.52),('7643','2014-03-25','07:20:00',3.85),('7643','2014-03-25','07:25:00',4.29),('7643','2014-03-25','07:30:00',4.75),('7643','2014-03-25','07:35:00',5.21),('7643','2014-03-25','07:40:00',5.61),('7643','2014-03-25','07:45:00',6.08),('7643','2014-03-25','07:50:00',6.42),('7643','2014-03-25','07:55:00',6.84),('7643','2014-03-25','08:00:00',7.27),('7643','2014-03-25','08:05:00',7.68),('7643','2014-03-25','08:10:00',8.19),('7643','2014-03-25','08:15:00',9.03),('7643','2014-03-25','08:20:00',8.29),('7643','2014-03-25','08:25:00',4.79),('7643','2014-03-25','08:30:00',4.25),('7643','2014-03-25','08:35:00',3.51),('7643','2014-03-25','08:40:00',4.11),('7643','2014-03-25','08:45:00',4.59),('7643','2014-03-25','08:50:00',5.51),('7643','2014-03-25','08:55:00',5.02),('7643','2014-03-25','09:00:00',5.5),('7643','2014-03-25','09:05:00',5.14),('7643','2014-03-25','09:10:00',6.21),('7643','2014-03-25','09:15:00',5.24),('7643','2014-03-25','09:20:00',4.66),('7643','2014-03-25','09:25:00',6.85),('7643','2014-03-25','09:30:00',13.67),('7643','2014-03-25','09:35:00',13.31),('7643','2014-03-25','09:40:00',13.39),('7643','2014-03-25','09:45:00',13.52),('7643','2014-03-25','09:50:00',13.8),('7643','2014-03-25','09:55:00',13.51),('7643','2014-03-25','10:00:00',8.69),('7643','2014-03-25','10:05:00',14.44),('7643','2014-03-25','10:10:00',15.8),('7643','2014-03-25','10:15:00',15.84),('7643','2014-03-25','10:20:00',16.27),('7643','2014-03-25','10:25:00',14.68),('7643','2014-03-25','10:30:00',14.57),('7643','2014-03-25','10:35:00',12.66),('7643','2014-03-25','10:40:00',4.52),('7643','2014-03-25','10:45:00',13.38),('7643','2014-03-25','10:50:00',13.22),('7643','2014-03-25','10:55:00',12.28),('7643','2014-03-25','11:00:00',15.12),('7643','2014-03-25','11:05:00',13.7),('7643','2014-03-25','11:10:00',18.31),('7643','2014-03-25','11:15:00',18.4),('7643','2014-03-25','11:20:00',9.55),('7643','2014-03-25','11:25:00',4.83),('7643','2014-03-25','11:30:00',6.25),('7643','2014-03-25','11:35:00',7.15),('7643','2014-03-25','11:40:00',7.09),('7643','2014-03-25','11:45:00',10.18),('7643','2014-03-25','11:50:00',11.84),('7643','2014-03-25','11:55:00',17.55),('7643','2014-03-25','12:00:00',19.04),('7643','2014-03-25','12:05:00',15.85),('7643','2014-03-25','12:10:00',11.31),('7643','2014-03-25','12:15:00',6.01),('7643','2014-03-25','12:20:00',7.08),('7643','2014-03-25','12:25:00',6.84),('7643','2014-03-25','12:30:00',6.78),('7643','2014-03-25','12:35:00',6.49),('7643','2014-03-25','12:40:00',7.35),('7643','2014-03-25','12:45:00',8.21),('7643','2014-03-25','12:50:00',5.81),('7643','2014-03-25','12:55:00',4.94),('7643','2014-03-25','13:00:00',4.68),('7643','2014-03-25','13:05:00',4.64),('7643','2014-03-25','13:10:00',3.69),('7643','2014-03-25','13:15:00',2.67),('7643','2014-03-25','13:20:00',4.59),('7643','2014-03-25','13:25:00',17.55),('7643','2014-03-25','13:30:00',14.88),('7643','2014-03-25','13:35:00',11.43),('7643','2014-03-25','13:40:00',8.33),('7643','2014-03-25','13:45:00',3.16),('7643','2014-03-25','13:50:00',2.96),('7643','2014-03-25','13:55:00',8.91),('7643','2014-03-25','14:00:00',11),('7643','2014-03-25','14:05:00',17.7),('7643','2014-03-25','14:10:00',13.24),('7643','2014-03-25','14:15:00',5.01),('7643','2014-03-25','14:20:00',3.86),('7643','2014-03-25','14:25:00',3.09),('7643','2014-03-25','14:30:00',2.71),('7643','2014-03-25','14:35:00',2.38),('7643','2014-03-25','14:40:00',2.59),('7643','2014-03-25','14:45:00',8.13),('7643','2014-03-25','14:50:00',12.74),('7643','2014-03-25','14:55:00',13.77),('7643','2014-03-25','15:00:00',11.41),('7643','2014-03-25','15:05:00',12.34),('7643','2014-03-25','15:10:00',12.88),('7643','2014-03-25','15:15:00',12.74),('7643','2014-03-25','15:20:00',11.62),('7643','2014-03-25','15:25:00',12.68),('7643','2014-03-25','15:30:00',12.63),('7643','2014-03-25','15:35:00',12.04),('7643','2014-03-25','15:40:00',9.11),('7643','2014-03-25','15:45:00',9.26),('7643','2014-03-25','15:50:00',7.6),('7643','2014-03-25','15:55:00',7.35),('7643','2014-03-25','16:00:00',4.79),('7643','2014-03-25','16:05:00',4.26),('7643','2014-03-25','16:10:00',4.29),('7643','2014-03-25','16:15:00',4.25),('7643','2014-03-25','16:20:00',3.85),('7643','2014-03-25','16:25:00',2.81),('7643','2014-03-25','16:30:00',2.27),('7643','2014-03-25','16:35:00',2.28),('7643','2014-03-25','16:40:00',1.76),('7643','2014-03-25','16:45:00',1.68),('7643','2014-03-25','16:50:00',1.75),('7643','2014-03-25','16:55:00',1.56),('7643','2014-03-25','17:00:00',1.24),('7643','2014-03-25','17:05:00',1.07),('7643','2013-03-21','06:45:00',1.01),('7643','2013-03-21','06:50:00',1.29),('7643','2013-03-21','06:55:00',1.59),('7643','2013-03-21','07:00:00',1.93),('7643','2013-03-21','07:05:00',2.24),('7643','2013-03-21','07:10:00',2.55),('7643','2013-03-21','07:15:00',2.93),('7643','2013-03-21','07:20:00',3.34),('7643','2013-03-21','07:25:00',3.72),('7643','2013-03-21','07:30:00',4.13),('7643','2013-03-21','07:35:00',4.56),('7643','2013-03-21','07:40:00',5),('7643','2013-03-21','07:45:00',5.38),('7643','2013-03-21','07:50:00',5.72),('7643','2013-03-21','07:55:00',6.07),('7643','2013-03-21','08:00:00',6.44),('7643','2013-03-21','08:05:00',6.83),('7643','2013-03-21','08:10:00',7.24),('7643','2013-03-21','08:15:00',7.59),('7643','2013-03-21','08:20:00',7.95),('7643','2013-03-21','08:25:00',8.25),('7643','2013-03-21','08:30:00',8.59),('7643','2013-03-21','08:35:00',8.87),('7643','2013-03-21','08:40:00',9.11),('7643','2013-03-21','08:45:00',9.41),('7643','2013-03-21','08:50:00',9.71),('7643','2013-03-21','08:55:00',9.98),('7643','2013-03-21','09:00:00',10.17),('7643','2013-03-21','09:05:00',10.41),('7643','2013-03-21','09:10:00',10.72),('7643','2013-03-21','09:15:00',11.09),('7643','2013-03-21','09:20:00',11.12),('7643','2013-03-21','09:25:00',11.44),('7643','2013-03-21','09:30:00',11.63),('7643','2013-03-21','09:35:00',11.88),('7643','2013-03-21','09:40:00',12.1),('7643','2013-03-21','09:45:00',12.29),('7643','2013-03-21','09:50:00',12.58),('7643','2013-03-21','09:55:00',12.61),('7643','2013-03-21','10:00:00',12.95),('7643','2013-03-21','10:05:00',13.19),('7643','2013-03-21','10:10:00',13.41),('7643','2013-03-21','10:15:00',13.5),('7643','2013-03-21','10:20:00',13.51),('7643','2013-03-21','10:25:00',13.93),('7643','2013-03-21','10:30:00',14.31),('7643','2013-03-21','10:35:00',14.49),('7643','2013-03-21','10:40:00',14.52),('7643','2013-03-21','10:45:00',14.63),('7643','2013-03-21','10:50:00',14.13),('7643','2013-03-21','10:55:00',14.83),('7643','2013-03-21','11:00:00',14.94),('7643','2013-03-21','11:05:00',14.92),('7643','2013-03-21','11:10:00',15.14),('7643','2013-03-21','11:15:00',15.38),('7643','2013-03-21','11:20:00',15.33),('7643','2013-03-21','11:25:00',15.47),('7643','2013-03-21','11:30:00',15.6),('7643','2013-03-21','11:35:00',15.65),('7643','2013-03-21','11:40:00',15.58),('7643','2013-03-21','11:45:00',15.93),('7643','2013-03-21','11:50:00',15.91),('7643','2013-03-21','11:55:00',15.94),('7643','2013-03-21','12:00:00',15.98),('7643','2013-03-21','12:05:00',16.04),('7643','2013-03-21','12:10:00',16.04),('7643','2013-03-21','12:15:00',16.02),('7643','2013-03-21','12:20:00',16),('7643','2013-03-21','12:25:00',16.13),('7643','2013-03-21','12:30:00',16.02),('7643','2013-03-21','12:35:00',16.02),('7643','2013-03-21','12:40:00',16.01),('7643','2013-03-21','12:45:00',15.82),('7643','2013-03-21','12:50:00',15.53),('7643','2013-03-21','12:55:00',14.98),('7643','2013-03-21','13:00:00',15.95),('7643','2013-03-21','13:05:00',15.36),('7643','2013-03-21','13:10:00',15.73),('7643','2013-03-21','13:15:00',15.65),('7643','2013-03-21','13:20:00',15.47),('7643','2013-03-21','13:25:00',14.6),('7643','2013-03-21','13:30:00',14.38),('7643','2013-03-21','13:35:00',14.88),('7643','2013-03-21','13:40:00',12.79),('7643','2013-03-21','13:45:00',12.94),('7643','2013-03-21','13:50:00',14.96),('7643','2013-03-21','13:55:00',14.63),('7643','2013-03-21','14:00:00',14.22),('7643','2013-03-21','14:05:00',14.03),('7643','2013-03-21','14:10:00',13.89),('7643','2013-03-21','14:15:00',13.6),('7643','2013-03-21','14:20:00',13.46),('7643','2013-03-21','14:25:00',13.25),('7643','2013-03-21','14:30:00',13.08),('7643','2013-03-21','14:35:00',12.78),('7643','2013-03-21','14:40:00',12.43),('7643','2013-03-21','14:45:00',12.29),('7643','2013-03-21','14:50:00',12.17),('7643','2013-03-21','14:55:00',11.92),('7643','2013-03-21','15:00:00',11.68),('7643','2013-03-21','15:05:00',11.34),('7643','2013-03-21','15:10:00',10.09),('7643','2013-03-21','15:15:00',8.39),('7643','2013-03-21','15:20:00',8.15),('7643','2013-03-21','15:25:00',8.5),('7643','2013-03-21','15:30:00',7.98),('7643','2013-03-21','15:35:00',8.86),('7643','2013-03-21','15:40:00',8.43),('7643','2013-03-21','15:45:00',7.49),('7643','2013-03-21','15:50:00',7.96),('7643','2013-03-21','15:55:00',7.17),('7643','2013-03-21','16:00:00',5.17),('7643','2013-03-21','16:05:00',5.24),('7643','2013-03-21','16:10:00',5.97),('7643','2013-03-21','16:15:00',7.08),('7643','2013-03-21','16:20:00',5.72),('7643','2013-03-21','16:25:00',5.76),('7643','2013-03-21','16:30:00',6.14),('7643','2013-03-21','16:35:00',6.11),('7643','2013-03-21','16:40:00',5.86),('7643','2013-03-21','16:45:00',5.45),('7643','2013-03-21','16:50:00',5.14),('7643','2013-03-21','16:55:00',4.68),('7643','2013-03-21','17:00:00',4.07),('7643','2013-03-21','17:05:00',3.62),('7643','2013-03-21','17:10:00',3.17),('7643','2013-03-21','17:15:00',2.83),('7643','2013-03-21','17:20:00',2.53),('7643','2013-03-21','17:25:00',1.69),('7643','2013-03-21','17:30:00',1.56),('7643','2013-03-21','17:35:00',1.28),('7643','2013-03-21','17:40:00',1.03),('7643','2013-03-20','07:05:00',1.01),('7643','2013-03-20','07:10:00',1.06),('7643','2013-03-20','07:15:00',1.69),('7643','2013-03-20','07:20:00',1.16),('7643','2013-03-20','07:25:00',1.99),('7643','2013-03-20','07:30:00',2.41),('7643','2013-03-20','07:35:00',3.15),('7643','2013-03-20','07:40:00',5.08),('7643','2013-03-20','07:45:00',5.66),('7643','2013-03-20','07:50:00',6.12),('7643','2013-03-20','07:55:00',3.4),('7643','2013-03-20','08:00:00',1.88),('7643','2013-03-20','08:05:00',1.7),('7643','2013-03-20','08:10:00',4.32),('7643','2013-03-20','08:15:00',7.31),('7643','2013-03-20','08:20:00',8.51),('7643','2013-03-20','08:25:00',8.98),('7643','2013-03-20','08:30:00',8.74),('7643','2013-03-20','08:35:00',9.22),('7643','2013-03-20','08:40:00',10.07),('7643','2013-03-20','08:45:00',10.07),('7643','2013-03-20','08:50:00',10.17),('7643','2013-03-20','08:55:00',10.14),('7643','2013-03-20','09:00:00',10.82),('7643','2013-03-20','09:05:00',11.52),('7643','2013-03-20','09:10:00',13),('7643','2013-03-20','09:15:00',12.52),('7643','2013-03-20','09:20:00',10.56),('7643','2013-03-20','09:25:00',11.52),('7643','2013-03-20','09:30:00',10.81),('7643','2013-03-20','09:35:00',12.86),('7643','2013-03-20','09:40:00',12.4),('7643','2013-03-20','09:45:00',13.17),('7643','2013-03-20','09:50:00',13.48),('7643','2013-03-20','09:55:00',13.69),('7643','2013-03-20','10:00:00',13.9),('7643','2013-03-20','10:05:00',13.97),('7643','2013-03-20','10:10:00',14.12),('7643','2013-03-20','10:15:00',14.25),('7643','2013-03-20','10:20:00',14.36),('7643','2013-03-20','10:25:00',14.44),('7643','2013-03-20','10:30:00',14.6),('7643','2013-03-20','10:35:00',14.79),('7643','2013-03-20','10:40:00',14.93),('7643','2013-03-20','10:45:00',14.89),('7643','2013-03-20','10:50:00',14.9),('7643','2013-03-20','10:55:00',9.21),('7643','2013-03-20','11:00:00',14.4),('7643','2013-03-20','11:05:00',15.63),('7643','2013-03-20','11:10:00',15.72),('7643','2013-03-20','11:15:00',15.93),('7643','2013-03-20','11:20:00',16.03),('7643','2013-03-20','11:25:00',16.3),('7643','2013-03-20','11:30:00',16.31),('7643','2013-03-20','11:35:00',16.37),('7643','2013-03-20','11:40:00',16.35),('7643','2013-03-20','11:45:00',16.45),('7643','2013-03-20','11:50:00',16.49),('7643','2013-03-20','11:55:00',16.59),('7643','2013-03-20','12:00:00',16.66),('7643','2013-03-20','12:05:00',16.7),('7643','2013-03-20','12:10:00',16.7),('7643','2013-03-20','12:15:00',16.66),('7643','2013-03-20','12:20:00',16.62),('7643','2013-03-20','12:25:00',16.73),('7643','2013-03-20','12:30:00',16.68),('7643','2013-03-20','12:35:00',16.49),('7643','2013-03-20','12:40:00',16.42),('7643','2013-03-20','12:45:00',16.26),('7643','2013-03-20','12:50:00',16.25),('7643','2013-03-20','12:55:00',16.22),('7643','2013-03-20','13:00:00',16.11),('7643','2013-03-20','13:05:00',15.98),('7643','2013-03-20','13:10:00',15.91),('7643','2013-03-20','13:15:00',15.8),('7643','2013-03-20','13:20:00',15.68),('7643','2013-03-20','13:25:00',15.58),('7643','2013-03-20','13:30:00',15.46),('7643','2013-03-20','13:35:00',15.3),('7643','2013-03-20','13:40:00',15.16),('7643','2013-03-20','13:45:00',14.96),('7643','2013-03-20','13:50:00',14.83),('7643','2013-03-20','13:55:00',14.58),('7643','2013-03-20','14:00:00',14.4),('7643','2013-03-20','14:05:00',14.06),('7643','2013-03-20','14:10:00',13.96),('7643','2013-03-20','14:15:00',13.77),('7643','2013-03-20','14:20:00',13.53),('7643','2013-03-20','14:25:00',13.3),('7643','2013-03-20','14:30:00',13.01),('7643','2013-03-20','14:35:00',12.78),('7643','2013-03-20','14:40:00',12.64),('7643','2013-03-20','14:45:00',12.43),('7643','2013-03-20','14:50:00',12.23),('7643','2013-03-20','14:55:00',12),('7643','2013-03-20','15:00:00',11.71),('7643','2013-03-20','15:05:00',11.43),('7643','2013-03-20','15:10:00',11.16),('7643','2013-03-20','15:15:00',10.83),('7643','2013-03-20','15:20:00',10.53),('7643','2013-03-20','15:25:00',10.25),('7643','2013-03-20','15:30:00',9.97),('7643','2013-03-20','15:35:00',9.63),('7643','2013-03-20','15:40:00',9.26),('7643','2013-03-20','15:45:00',8.93),('7643','2013-03-20','15:50:00',8.62),('7643','2013-03-20','15:55:00',8.26),('7643','2013-03-20','16:00:00',7.91),('7643','2013-03-20','16:05:00',7.58),('7643','2013-03-20','16:10:00',7.21),('7643','2013-03-20','16:15:00',6.85),('7643','2013-03-20','16:20:00',6.5),('7643','2013-03-20','16:25:00',6.09),('7643','2013-03-20','16:30:00',5.68),('7643','2013-03-20','16:35:00',5.28),('7643','2013-03-20','16:40:00',4.84),('7643','2013-03-20','16:45:00',4.55),('7643','2013-03-20','16:50:00',4.19),('7643','2013-03-20','16:55:00',3.79),('7643','2013-03-20','17:00:00',3.41),('7643','2013-03-20','17:05:00',3.06),('7643','2013-03-20','17:10:00',2.76),('7643','2013-03-20','17:15:00',2.37),('7643','2013-03-20','17:20:00',2.04),('7643','2013-03-20','17:25:00',1.7),('7643','2013-03-20','17:30:00',1.39),('7643','2013-03-20','17:35:00',1.12),('7643','2013-03-19','06:50:00',1.14),('7643','2013-03-19','06:55:00',1.44),('7643','2013-03-19','07:00:00',1.75),('7643','2013-03-19','07:05:00',2.08),('7643','2013-03-19','07:10:00',2.44),('7643','2013-03-19','07:15:00',2.84),('7643','2013-03-19','07:20:00',3.23),('7643','2013-03-19','07:25:00',3.65),('7643','2013-03-19','07:30:00',4.12),('7643','2013-03-19','07:35:00',4.63),('7643','2013-03-19','07:40:00',4.51),('7643','2013-03-19','07:45:00',4.93),('7643','2013-03-19','07:50:00',5.02),('7643','2013-03-19','07:55:00',6.12),('7643','2013-03-19','08:00:00',5.27),('7643','2013-03-19','08:05:00',5.06),('7643','2013-03-19','08:10:00',6.82),('7643','2013-03-19','08:15:00',7.2),('7643','2013-03-19','08:20:00',7.49),('7643','2013-03-19','08:25:00',7.92),('7643','2013-03-19','08:30:00',8.38),('7643','2013-03-19','08:35:00',8.5),('7643','2013-03-19','08:40:00',8.37),('7643','2013-03-19','08:45:00',8.82),('7643','2013-03-19','08:50:00',9.25),('7643','2013-03-19','08:55:00',9.11),('7643','2013-03-19','09:00:00',9.9),('7643','2013-03-19','09:05:00',12.1),('7643','2013-03-19','09:10:00',11.16),('7643','2013-03-19','09:15:00',10.18),('7643','2013-03-19','09:20:00',11.05),('7643','2013-03-19','09:25:00',11.77),('7643','2013-03-19','09:30:00',11.74),('7643','2013-03-19','09:35:00',11.38),('7643','2013-03-19','09:40:00',12.05),('7643','2013-03-19','09:45:00',12.37),('7643','2013-03-19','09:50:00',12.55),('7643','2013-03-19','09:55:00',12.56),('7643','2013-03-19','10:00:00',13.02),('7643','2013-03-19','10:05:00',13.01),('7643','2013-03-19','10:10:00',11.21),('7643','2013-03-19','10:15:00',10.38),('7643','2013-03-19','10:20:00',10.88),('7643','2013-03-19','10:25:00',9.6),('7643','2013-03-19','10:30:00',11.31),('7643','2013-03-19','10:35:00',15.25),('7643','2013-03-19','10:40:00',11.74),('7643','2013-03-19','10:45:00',9.21),('7643','2013-03-19','10:50:00',11.74),('7643','2013-03-19','10:55:00',11.01),('7643','2013-03-19','11:00:00',11.28),('7643','2013-03-19','11:05:00',12.3),('7643','2013-03-19','11:10:00',9.99),('7643','2013-03-19','11:15:00',9.6),('7643','2013-03-19','11:20:00',10.37),('7643','2013-03-19','11:25:00',9.94),('7643','2013-03-19','11:30:00',9.25),('7643','2013-03-19','11:35:00',10.25),('7643','2013-03-19','11:40:00',8.33),('7643','2013-03-19','11:45:00',7.84),('7643','2013-03-19','11:50:00',7.41),('7643','2013-03-19','11:55:00',8.37),('7643','2013-03-19','12:00:00',8.05),('7643','2013-03-19','12:05:00',9.12),('7643','2013-03-19','12:10:00',7.23),('7643','2013-03-19','12:15:00',6.29),('7643','2013-03-19','12:20:00',5.76),('7643','2013-03-19','12:25:00',4.78),('7643','2013-03-19','12:30:00',3.87),('7643','2013-03-19','12:35:00',4.98),('7643','2013-03-19','12:40:00',3.5),('7643','2013-03-19','12:45:00',3.8),('7643','2013-03-19','12:50:00',5.47),('7643','2013-03-19','12:55:00',6.35),('7643','2013-03-19','13:00:00',6.92),('7643','2013-03-19','13:05:00',5.41),('7643','2013-03-19','13:10:00',5.45),('7643','2013-03-19','13:15:00',4.35),('7643','2013-03-19','13:20:00',4.69),('7643','2013-03-19','13:25:00',4.94),('7643','2013-03-19','13:30:00',5.37),('7643','2013-03-19','13:35:00',5.08),('7643','2013-03-19','13:40:00',6.42),('7643','2013-03-19','13:45:00',7.54),('7643','2013-03-19','13:50:00',6.28),('7643','2013-03-19','13:55:00',5.86),('7643','2013-03-19','14:00:00',5.81),('7643','2013-03-19','14:05:00',4.97),('7643','2013-03-19','14:10:00',4.7),('7643','2013-03-19','14:15:00',6.2),('7643','2013-03-19','14:20:00',7.87),('7643','2013-03-19','14:25:00',7.05),('7643','2013-03-19','14:30:00',6.03),('7643','2013-03-19','14:35:00',5.01),('7643','2013-03-19','14:40:00',3.98),('7643','2013-03-19','14:45:00',3.89),('7643','2013-03-19','14:50:00',3.14),('7643','2013-03-19','14:55:00',2.58),('7643','2013-03-19','15:00:00',2.84),('7643','2013-03-19','15:05:00',2.49),('7643','2013-03-19','15:10:00',2.24),('7643','2013-03-19','15:15:00',1.93),('7643','2013-03-19','15:20:00',1.68),('7643','2013-03-19','15:25:00',1.69),('7643','2013-03-19','15:30:00',2.09),('7643','2013-03-19','15:35:00',1.89),('7643','2013-03-19','15:40:00',1.26),('7643','2013-03-18','06:55:00',1.05),('7643','2013-03-18','07:00:00',1.52),('7643','2013-03-18','07:05:00',3.02),('7643','2013-03-18','07:10:00',3.41),('7643','2013-03-18','07:15:00',3.59),('7643','2013-03-18','07:20:00',3.08),('7643','2013-03-18','07:25:00',3.4),('7643','2013-03-18','07:30:00',3.75),('7643','2013-03-18','07:35:00',4.1),('7643','2013-03-18','07:40:00',4.46),('7643','2013-03-18','07:45:00',4.85),('7643','2013-03-18','07:50:00',5.27),('7643','2013-03-18','07:55:00',5.34),('7643','2013-03-18','08:00:00',3.58),('7643','2013-03-18','08:05:00',5.06),('7643','2013-03-18','08:10:00',6.51),('7643','2013-03-18','08:15:00',7.11),('7643','2013-03-18','08:20:00',7.36),('7643','2013-03-18','08:25:00',7.69),('7643','2013-03-18','08:30:00',8.15),('7643','2013-03-18','08:35:00',8.31),('7643','2013-03-18','08:40:00',8.85),('7643','2013-03-18','08:45:00',7.99),('7643','2013-03-18','08:50:00',9.53),('7643','2013-03-18','08:55:00',9.1),('7643','2013-03-18','09:00:00',10.12),('7643','2013-03-18','09:05:00',10.48),('7643','2013-03-18','09:10:00',10.67),('7643','2013-03-18','09:15:00',11.14),('7643','2013-03-18','09:20:00',10.14),('7643','2013-03-18','09:25:00',9.19),('7643','2013-03-18','09:30:00',11.52),('7643','2013-03-18','09:35:00',11.08),('7643','2013-03-18','09:40:00',12.59),('7643','2013-03-18','09:45:00',13.12),('7643','2013-03-18','09:50:00',10.83),('7643','2013-03-18','09:55:00',12.15),('7643','2013-03-18','10:00:00',10.57),('7643','2013-03-18','10:05:00',12.14),('7643','2013-03-18','10:10:00',13.42),('7643','2013-03-18','10:15:00',14),('7643','2013-03-18','10:20:00',14.29),('7643','2013-03-18','10:25:00',13.05),('7643','2013-03-18','10:30:00',14.61),('7643','2013-03-18','10:35:00',14.74),('7643','2013-03-18','10:40:00',14.76),('7643','2013-03-18','10:45:00',15.01),('7643','2013-03-18','10:50:00',15.09),('7643','2013-03-18','10:55:00',15.54),('7643','2013-03-18','11:00:00',15.8),('7643','2013-03-18','11:05:00',15.58),('7643','2013-03-18','11:10:00',15.21),('7643','2013-03-18','11:15:00',15.95),('7643','2013-03-18','11:20:00',16.07),('7643','2013-03-18','11:25:00',15.95),('7643','2013-03-18','11:30:00',16.02),('7643','2013-03-18','11:35:00',10.07),('7643','2013-03-18','11:40:00',14.6),('7643','2013-03-18','11:45:00',14.87),('7643','2013-03-18','11:50:00',16.55),('7643','2013-03-18','11:55:00',16.63),('7643','2013-03-18','12:00:00',16.4),('7643','2013-03-18','12:05:00',16.24),('7643','2013-03-18','12:10:00',16.24),('7643','2013-03-18','12:15:00',15.39),('7643','2013-03-18','12:20:00',16.31),('7643','2013-03-18','12:25:00',16.15),('7643','2013-03-18','12:30:00',15.74),('7643','2013-03-18','12:35:00',16.09),('7643','2013-03-18','12:40:00',16.05),('7643','2013-03-18','12:45:00',15.83),('7643','2013-03-18','12:50:00',16.1),('7643','2013-03-18','12:55:00',16.02),('7643','2013-03-18','13:00:00',15.9),('7643','2013-03-18','13:05:00',15.73),('7643','2013-03-18','13:10:00',15.52),('7643','2013-03-18','13:15:00',15.37),('7643','2013-03-18','13:20:00',15.35),('7643','2013-03-18','13:25:00',15.23),('7643','2013-03-18','13:30:00',15.12),('7643','2013-03-18','13:35:00',15.01),('7643','2013-03-18','13:40:00',14.61),('7643','2013-03-18','13:45:00',14.62),('7643','2013-03-18','13:50:00',14.55),('7643','2013-03-18','13:55:00',14.36),('7643','2013-03-18','14:00:00',14.25),('7643','2013-03-18','14:05:00',14.01),('7643','2013-03-18','14:10:00',13.77),('7643','2013-03-18','14:15:00',13.58),('7643','2013-03-18','14:20:00',13.43),('7643','2013-03-18','14:25:00',13.23),('7643','2013-03-18','14:30:00',13),('7643','2013-03-18','14:35:00',12.67),('7643','2013-03-18','14:40:00',12.55),('7643','2013-03-18','14:45:00',12.25),('7643','2013-03-18','14:50:00',12.03),('7643','2013-03-18','14:55:00',11.81),('7643','2013-03-18','15:00:00',11.55),('7643','2013-03-18','15:05:00',11.22),('7643','2013-03-18','15:10:00',10.93),('7643','2013-03-18','15:15:00',10.62),('7643','2013-03-18','15:20:00',10.38),('7643','2013-03-18','15:25:00',10.04),('7643','2013-03-18','15:30:00',9.77),('7643','2013-03-18','15:35:00',9.47),('7643','2013-03-18','15:40:00',9.11),('7643','2013-03-18','15:45:00',8.78),('7643','2013-03-18','15:50:00',8.51),('7643','2013-03-18','15:55:00',8.12),('7643','2013-03-18','16:00:00',7.8),('7643','2013-03-18','16:05:00',7.44),('7643','2013-03-18','16:10:00',7.04),('7643','2013-03-18','16:15:00',6.66),('7643','2013-03-18','16:20:00',6.29),('7643','2013-03-18','16:25:00',5.95),('7643','2013-03-18','16:30:00',5.64),('7643','2013-03-18','16:35:00',5.31),('7643','2013-03-18','16:40:00',4.93),('7643','2013-03-18','16:45:00',3.98),('7643','2013-03-18','16:50:00',3.1),('7643','2013-03-18','16:55:00',3.3),('7643','2013-03-18','17:00:00',2.7),('7643','2013-03-18','17:05:00',2.44),('7643','2013-03-18','17:10:00',2.32),('7643','2013-03-18','17:15:00',2.72),('7643','2013-03-18','17:20:00',2.34),('7643','2013-03-18','17:25:00',1.88),('7643','2013-03-18','17:30:00',1.4),('7643','2013-03-18','17:35:00',1.23),('7643','2013-03-17','07:00:00',1.04),('7643','2013-03-17','07:05:00',1.16),('7643','2013-03-17','07:10:00',1.15),('7643','2013-03-17','07:15:00',1.23),('7643','2013-03-17','07:20:00',1.4),('7643','2013-03-17','07:25:00',1.24),('7643','2013-03-17','07:50:00',1.25),('7643','2013-03-17','07:55:00',1.56),('7643','2013-03-17','08:00:00',1.58),('7643','2013-03-17','08:05:00',1.56),('7643','2013-03-17','08:10:00',1.44),('7643','2013-03-17','08:15:00',1.58),('7643','2013-03-17','08:20:00',1.97),('7643','2013-03-17','08:25:00',2.37),('7643','2013-03-17','08:30:00',2.77),('7643','2013-03-17','08:35:00',2.53),('7643','2013-03-17','08:40:00',2.41),('7643','2013-03-17','08:45:00',3.42),('7643','2013-03-17','08:50:00',2.94),('7643','2013-03-17','08:55:00',2.55),('7643','2013-03-17','09:00:00',1.76),('7643','2013-03-17','09:05:00',1.3),('7643','2013-03-17','09:10:00',1.12),('7643','2013-03-17','09:15:00',1.22),('7643','2013-03-17','09:20:00',1.57),('7643','2013-03-17','09:25:00',1.65),('7643','2013-03-17','09:30:00',1.88),('7643','2013-03-17','09:35:00',2.07),('7643','2013-03-17','09:40:00',2.32),('7643','2013-03-17','09:45:00',2.51),('7643','2013-03-17','09:50:00',2.59),('7643','2013-03-17','09:55:00',3.55),('7643','2013-03-17','10:00:00',4.58),('7643','2013-03-17','10:05:00',5.83),('7643','2013-03-17','10:10:00',5.67),('7643','2013-03-17','10:15:00',4.86),('7643','2013-03-17','10:20:00',6.17),('7643','2013-03-17','10:25:00',8.22),('7643','2013-03-17','10:30:00',7.59),('7643','2013-03-17','10:35:00',5.89),('7643','2013-03-17','10:40:00',5.31),('7643','2013-03-17','10:45:00',5.43),('7643','2013-03-17','10:50:00',5.29),('7643','2013-03-17','10:55:00',4.39),('7643','2013-03-17','11:00:00',4.71),('7643','2013-03-17','11:05:00',5.17),('7643','2013-03-17','11:10:00',5.99),('7643','2013-03-17','11:15:00',6.52),('7643','2013-03-17','11:20:00',6.76),('7643','2013-03-17','11:25:00',7.25),('7643','2013-03-17','11:30:00',8.71),('7643','2013-03-17','11:35:00',7.43),('7643','2013-03-17','11:40:00',6.95),('7643','2013-03-17','11:45:00',5.79),('7643','2013-03-17','11:50:00',4.71),('7643','2013-03-17','11:55:00',5.59),('7643','2013-03-17','12:00:00',5.93),('7643','2013-03-17','12:05:00',10.17),('7643','2013-03-17','12:10:00',9.39),('7643','2013-03-17','12:15:00',10.97),('7643','2013-03-17','12:20:00',10.09),('7643','2013-03-17','12:25:00',7.35),('7643','2013-03-17','12:30:00',13.69),('7643','2013-03-17','12:35:00',14.68),('7643','2013-03-17','12:40:00',12.18),('7643','2013-03-17','12:45:00',10.1),('7643','2013-03-17','12:50:00',14.34),('7643','2013-03-17','12:55:00',15.77),('7643','2013-03-17','13:00:00',13.35),('7643','2013-03-17','13:05:00',6.92),('7643','2013-03-17','13:10:00',4.52),('7643','2013-03-17','13:15:00',3.38),('7643','2013-03-17','13:20:00',3.81),('7643','2013-03-17','13:25:00',7.19),('7643','2013-03-17','13:30:00',5.29),('7643','2013-03-17','13:35:00',4.45),('7643','2013-03-17','13:40:00',7.53),('7643','2013-03-17','13:45:00',6.8),('7643','2013-03-17','13:50:00',6.27),('7643','2013-03-17','13:55:00',5.95),('7643','2013-03-17','14:00:00',6.42),('7643','2013-03-17','14:05:00',10.45),('7643','2013-03-17','14:10:00',9.47),('7643','2013-03-17','14:15:00',4.82),('7643','2013-03-17','14:20:00',4.74),('7643','2013-03-17','14:25:00',6.95),('7643','2013-03-17','14:30:00',3.16),('7643','2013-03-17','14:35:00',4.14),('7643','2013-03-17','14:40:00',4.65),('7643','2013-03-17','14:45:00',4.45),('7643','2013-03-17','14:50:00',2.51),('7643','2013-03-17','14:55:00',3.45),('7643','2013-03-17','15:00:00',4.01),('7643','2013-03-17','15:05:00',3.36),('7643','2013-03-17','15:10:00',2.46),('7643','2013-03-17','15:15:00',3.22),('7643','2013-03-17','15:20:00',2.52),('7643','2013-03-17','15:25:00',2.23),('7643','2013-03-17','15:30:00',2.09),('7643','2013-03-17','15:35:00',1.94),('7643','2013-03-17','15:40:00',1.53),('7643','2013-03-17','15:45:00',1.64),('7643','2013-03-17','15:50:00',1.41),('7643','2013-03-17','15:55:00',1.19),('7643','2013-03-17','16:00:00',1.22),('7643','2013-03-17','16:05:00',1.11),('7643','2013-03-16','06:45:00',1.13),('7643','2013-03-16','07:00:00',1.04),('7643','2013-03-16','07:05:00',1.4),('7643','2013-03-16','07:10:00',1.66),('7643','2013-03-16','07:15:00',1.61),('7643','2013-03-16','07:20:00',1.26),('7643','2013-03-16','07:25:00',1.32),('7643','2013-03-16','07:30:00',1.55),('7643','2013-03-16','07:35:00',1.55),('7643','2013-03-16','07:40:00',1.73),('7643','2013-03-16','07:45:00',1.89),('7643','2013-03-16','07:50:00',2.27),('7643','2013-03-16','07:55:00',2.42),('7643','2013-03-16','08:00:00',2.67),('7643','2013-03-16','08:05:00',2.99),('7643','2013-03-16','08:10:00',3.56),('7643','2013-03-16','08:15:00',4.04),('7643','2013-03-16','08:20:00',4.65),('7643','2013-03-16','08:25:00',6),('7643','2013-03-16','08:30:00',5.24),('7643','2013-03-16','08:35:00',4.57),('7643','2013-03-16','08:40:00',4.68),('7643','2013-03-16','08:45:00',5.64),('7643','2013-03-16','08:50:00',5.51),('7643','2013-03-16','08:55:00',5.19),('7643','2013-03-16','09:00:00',5.08),('7643','2013-03-16','09:05:00',5.81),('7643','2013-03-16','09:10:00',6.63),('7643','2013-03-16','09:15:00',7.38),('7643','2013-03-16','09:20:00',5.98),('7643','2013-03-16','09:25:00',4.95),('7643','2013-03-16','09:30:00',5.39),('7643','2013-03-16','09:35:00',6.14),('7643','2013-03-16','09:40:00',5.9),('7643','2013-03-16','09:45:00',6),('7643','2013-03-16','09:50:00',6.73),('7643','2013-03-16','09:55:00',7.36),('7643','2013-03-16','10:00:00',8.15),('7643','2013-03-16','10:05:00',6.7),('7643','2013-03-16','10:10:00',6.5),('7643','2013-03-16','10:15:00',7.13),('7643','2013-03-16','10:20:00',7.27),('7643','2013-03-16','10:25:00',7.6),('7643','2013-03-16','10:30:00',7.37),('7643','2013-03-16','10:35:00',7.05),('7643','2013-03-16','10:40:00',6.64),('7643','2013-03-16','10:45:00',7.01),('7643','2013-03-16','10:50:00',6.91),('7643','2013-03-16','10:55:00',6.33),('7643','2013-03-16','11:00:00',6.35),('7643','2013-03-16','11:05:00',5.4),('7643','2013-03-16','11:10:00',5.12),('7643','2013-03-16','11:15:00',5.41),('7643','2013-03-16','11:20:00',6.19),('7643','2013-03-16','11:25:00',6.52),('7643','2013-03-16','11:30:00',5.9),('7643','2013-03-16','11:35:00',5.75),('7643','2013-03-16','11:40:00',5.37),('7643','2013-03-16','11:45:00',5.06),('7643','2013-03-16','11:50:00',4.64),('7643','2013-03-16','11:55:00',4.15),('7643','2013-03-16','12:00:00',4.11),('7643','2013-03-16','12:05:00',4.25),('7643','2013-03-16','12:10:00',5.39),('7643','2013-03-16','12:15:00',7.24),('7643','2013-03-16','12:20:00',8.94),('7643','2013-03-16','12:25:00',13.13),('7643','2013-03-16','12:30:00',13.46),('7643','2013-03-16','12:35:00',9.89),('7643','2013-03-16','12:40:00',10.74),('7643','2013-03-16','12:45:00',9.41),('7643','2013-03-16','12:50:00',8.39),('7643','2013-03-16','12:55:00',6.64),('7643','2013-03-16','13:00:00',7.92),('7643','2013-03-16','13:05:00',8.85),('7643','2013-03-16','13:10:00',9.78),('7643','2013-03-16','13:15:00',9.97),('7643','2013-03-16','13:20:00',8.13),('7643','2013-03-16','13:25:00',6.92),('7643','2013-03-16','13:30:00',10.42),('7643','2013-03-16','13:35:00',11.8),('7643','2013-03-16','13:40:00',7.79),('7643','2013-03-16','13:45:00',7.09),('7643','2013-03-16','13:50:00',5.48),('7643','2013-03-16','13:55:00',8.41),('7643','2013-03-16','14:00:00',8.41),('7643','2013-03-16','14:05:00',8.14),('7643','2013-03-16','14:10:00',9.7),('7643','2013-03-16','14:15:00',10.6),('7643','2013-03-16','14:20:00',10.34),('7643','2013-03-16','14:25:00',9.21),('7643','2013-03-16','14:30:00',9.03),('7643','2013-03-16','14:35:00',7.3),('7643','2013-03-16','14:40:00',5.65),('7643','2013-03-16','14:45:00',5.01),('7643','2013-03-16','14:50:00',4.33),('7643','2013-03-16','14:55:00',4.46),('7643','2013-03-16','15:00:00',5.88),('7643','2013-03-16','15:05:00',6.51),('7643','2013-03-16','15:10:00',8.4),('7643','2013-03-16','15:15:00',7.79),('7643','2013-03-16','15:20:00',8.92),('7643','2013-03-16','15:25:00',6.62),('7643','2013-03-16','15:30:00',4.95),('7643','2013-03-16','15:35:00',5.11),('7643','2013-03-16','15:40:00',5.41),('7643','2013-03-16','15:45:00',5.17),('7643','2013-03-16','15:50:00',3.42),('7643','2013-03-16','15:55:00',3.13),('7643','2013-03-16','16:00:00',2.24),('7643','2013-03-16','16:05:00',1.23),('7643','2013-03-16','16:10:00',1.1),('7643','2013-03-16','16:15:00',1.53),('7643','2013-03-16','16:20:00',2.1),('7643','2013-03-16','16:30:00',1.27),('7643','2013-03-16','16:35:00',1.58),('7643','2013-03-16','16:40:00',2.81),('7643','2013-03-16','16:45:00',4.47),('7643','2013-03-16','16:50:00',1.57),('7643','2013-03-16','16:55:00',1.26),('7643','2013-03-16','17:00:00',1.43),('7643','2013-03-16','17:05:00',1.25),('7643','2013-03-16','17:10:00',1.21),('7643','2013-03-16','17:15:00',1.08),('7643','2013-03-15','07:25:00',1.12),('7643','2013-03-15','07:30:00',1.49),('7643','2013-03-15','07:35:00',1.73),('7643','2013-03-15','07:40:00',1.93),('7643','2013-03-15','07:45:00',2.38),('7643','2013-03-15','07:50:00',3.7),('7643','2013-03-15','07:55:00',3.34),('7643','2013-03-15','08:00:00',3.92),('7643','2013-03-15','08:05:00',3.95),('7643','2013-03-15','08:10:00',4.99),('7643','2013-03-15','08:15:00',8.55),('7643','2013-03-15','08:20:00',9.37),('7643','2013-03-15','08:25:00',9.01),('7643','2013-03-15','08:30:00',8.81),('7643','2013-03-15','08:35:00',9.23),('7643','2013-03-15','08:40:00',9.73),('7643','2013-03-15','08:45:00',9.67),('7643','2013-03-15','08:50:00',10.46),('7643','2013-03-15','08:55:00',11),('7643','2013-03-15','09:00:00',10.83),('7643','2013-03-15','09:05:00',11.03),('7643','2013-03-15','09:10:00',9.55),('7643','2013-03-15','09:15:00',12.02),('7643','2013-03-15','09:20:00',11.98),('7643','2013-03-15','09:25:00',8.07),('7643','2013-03-15','09:30:00',11.56),('7643','2013-03-15','09:35:00',12.85),('7643','2013-03-15','09:40:00',12.68),('7643','2013-03-15','09:45:00',10.8),('7643','2013-03-15','09:50:00',13.98),('7643','2013-03-15','09:55:00',14.05),('7643','2013-03-15','10:00:00',10.83),('7643','2013-03-15','10:05:00',8.61),('7643','2013-03-15','10:10:00',12.07),('7643','2013-03-15','10:15:00',9.39),('7643','2013-03-15','10:20:00',7.98),('7643','2013-03-15','10:25:00',12.28),('7643','2013-03-15','10:30:00',9.12),('7643','2013-03-15','10:35:00',12.97),('7643','2013-03-15','10:40:00',15.36),('7643','2013-03-15','10:45:00',15.77),('7643','2013-03-15','10:50:00',15.78),('7643','2013-03-15','10:55:00',15.8),('7643','2013-03-15','11:00:00',15.86),('7643','2013-03-15','11:05:00',15.81),('7643','2013-03-15','11:10:00',16.02),('7643','2013-03-15','11:15:00',16.22),('7643','2013-03-15','11:20:00',16.16),('7643','2013-03-15','11:25:00',16.22),('7643','2013-03-15','11:30:00',16.28),('7643','2013-03-15','11:35:00',16.36),('7643','2013-03-15','11:40:00',16.37),('7643','2013-03-15','11:45:00',16.31),('7643','2013-03-15','11:50:00',16.39),('7643','2013-03-15','11:55:00',16.47),('7643','2013-03-15','12:00:00',16.45),('7643','2013-03-15','12:05:00',16.31),('7643','2013-03-15','12:10:00',16.41),('7643','2013-03-15','12:15:00',16.4),('7643','2013-03-15','12:20:00',16.37),('7643','2013-03-15','12:25:00',16.29),('7643','2013-03-15','12:30:00',16.29),('7643','2013-03-15','12:35:00',16.05),('7643','2013-03-15','12:40:00',16.15),('7643','2013-03-15','12:45:00',16.15),('7643','2013-03-15','12:50:00',16.1),('7643','2013-03-15','12:55:00',15.88),('7643','2013-03-15','13:00:00',15.81),('7643','2013-03-15','13:05:00',15.62),('7643','2013-03-15','13:10:00',15.44),('7643','2013-03-15','13:15:00',15.42),('7643','2013-03-15','13:20:00',14.58),('7643','2013-03-15','13:25:00',8.18),('7643','2013-03-15','13:30:00',3.01),('7643','2013-03-15','13:35:00',7.6),('7643','2013-03-15','13:40:00',16.05),('7643','2013-03-15','13:45:00',15.37),('7643','2013-03-15','13:50:00',12.02),('7643','2013-03-15','13:55:00',3.29),('7643','2013-03-15','14:00:00',13.71),('7643','2013-03-15','14:05:00',15.46),('7643','2013-03-15','14:10:00',13.25),('7643','2013-03-15','14:15:00',10.6),('7643','2013-03-15','14:20:00',11.26),('7643','2013-03-15','14:25:00',3.64),('7643','2013-03-15','14:30:00',4.3),('7643','2013-03-15','14:35:00',11.32),('7643','2013-03-15','14:40:00',9.77),('7643','2013-03-15','14:45:00',9.77),('7643','2013-03-15','14:50:00',3.12),('7643','2013-03-15','14:55:00',2.61),('7643','2013-03-15','15:00:00',2.43),('7643','2013-03-15','15:05:00',2.31),('7643','2013-03-15','15:10:00',2.14),('7643','2013-03-15','15:15:00',2.05),('7643','2013-03-15','15:20:00',2.08),('7643','2013-03-15','15:25:00',2.3),('7643','2013-03-15','15:30:00',2.11),('7643','2013-03-15','15:35:00',2.44),('7643','2013-03-15','15:40:00',2.83),('7643','2013-03-15','15:45:00',3.73),('7643','2013-03-15','15:50:00',2.36),('7643','2013-03-15','15:55:00',1.66),('7643','2013-03-15','16:00:00',2.52),('7643','2013-03-15','16:05:00',5.12),('7643','2013-03-15','16:10:00',5.12),('7643','2013-03-15','16:15:00',6.15),('7643','2013-03-15','16:20:00',5.26),('7643','2013-03-15','16:25:00',2.2),('7643','2013-03-15','16:30:00',2.32),('7643','2013-03-15','16:35:00',2.22),('7643','2013-03-15','16:40:00',1.97),('7643','2013-03-15','16:45:00',1.71),('7643','2013-03-15','16:50:00',1.7),('7643','2013-03-15','16:55:00',3.2),('7643','2013-03-15','17:00:00',3.53),('7643','2013-03-15','17:05:00',3.28),('7643','2013-03-15','17:10:00',2.85),('7643','2013-03-15','17:15:00',2.59),('7643','2013-03-15','17:20:00',2.35),('7643','2013-03-15','17:25:00',2.01),('7643','2013-03-15','17:30:00',1.67),('7643','2013-03-15','17:35:00',1.43),('7643','2013-03-15','17:40:00',1.19),('7643','2013-03-14','09:30:00',1.05),('7643','2013-03-14','09:35:00',1.18),('7643','2013-03-14','09:40:00',1.24),('7643','2013-03-14','09:45:00',1.37),('7643','2013-03-14','09:50:00',1.7),('7643','2013-03-14','09:55:00',1.86),('7643','2013-03-14','10:00:00',2.17),('7643','2013-03-14','10:05:00',2.08),('7643','2013-03-14','10:10:00',2.23),('7643','2013-03-14','10:15:00',2.51),('7643','2013-03-14','10:20:00',2.26),('7643','2013-03-14','10:25:00',2.47),('7643','2013-03-14','10:30:00',3.25),('7643','2013-03-14','10:35:00',3.68),('7643','2013-03-14','10:40:00',4.28),('7643','2013-03-14','10:45:00',5.16),('7643','2013-03-14','10:50:00',5.04),('7643','2013-03-14','10:55:00',5.53),('7643','2013-03-14','11:00:00',5.43),('7643','2013-03-14','11:05:00',4.9),('7643','2013-03-14','11:10:00',4.64),('7643','2013-03-14','11:15:00',4.06),('7643','2013-03-14','11:20:00',4.88),('7643','2013-03-14','11:25:00',5.82),('7643','2013-03-14','11:30:00',6.47),('7643','2013-03-14','11:35:00',7.75),('7643','2013-03-14','11:40:00',9.38),('7643','2013-03-14','11:45:00',9.44),('7643','2013-03-14','11:50:00',7.56),('7643','2013-03-14','11:55:00',7.81),('7643','2013-03-14','12:00:00',7.08),('7643','2013-03-14','12:05:00',6.91),('7643','2013-03-14','12:10:00',7.1),('7643','2013-03-14','12:15:00',6.33),('7643','2013-03-14','12:20:00',6.42),('7643','2013-03-14','12:25:00',6.48),('7643','2013-03-14','12:30:00',6.75),('7643','2013-03-14','12:35:00',7.7),('7643','2013-03-14','12:40:00',6.95),('7643','2013-03-14','12:45:00',6.13),('7643','2013-03-14','12:50:00',5.75),('7643','2013-03-14','12:55:00',5.33),('7643','2013-03-14','13:00:00',4.88),('7643','2013-03-14','13:05:00',4.58),('7643','2013-03-14','13:10:00',4.62),('7643','2013-03-14','13:15:00',4.98),('7643','2013-03-14','13:20:00',5.33),('7643','2013-03-14','13:25:00',5.81),('7643','2013-03-14','13:30:00',5.77),('7643','2013-03-14','13:35:00',5.32),('7643','2013-03-14','13:40:00',5.57),('7643','2013-03-14','13:45:00',6.07),('7643','2013-03-14','13:50:00',5.08),('7643','2013-03-14','13:55:00',4.37),('7643','2013-03-14','14:00:00',3.89),('7643','2013-03-14','14:05:00',3.49),('7643','2013-03-14','14:10:00',2.94),('7643','2013-03-14','14:15:00',2.53),('7643','2013-03-14','14:20:00',2.24),('7643','2013-03-14','14:25:00',1.95),('7643','2013-03-14','14:30:00',1.81),('7643','2013-03-14','14:35:00',1.8),('7643','2013-03-14','14:40:00',1.99),('7643','2013-03-14','14:45:00',2.51),('7643','2013-03-14','14:50:00',3.49),('7643','2013-03-14','14:55:00',4.18),('7643','2013-03-14','15:00:00',4.5),('7643','2013-03-14','15:05:00',4.41),('7643','2013-03-14','15:10:00',4.34),('7643','2013-03-14','15:15:00',4.7),('7643','2013-03-14','15:20:00',4.76),('7643','2013-03-14','15:25:00',5.15),('7643','2013-03-14','15:30:00',4.76),('7643','2013-03-14','15:35:00',4.01),('7643','2013-03-14','15:40:00',3.3),('7643','2013-03-14','15:45:00',3.32),('7643','2013-03-14','15:50:00',3.26),('7643','2013-03-14','15:55:00',3.07),('7643','2013-03-14','16:00:00',3.56),('7643','2013-03-14','16:05:00',2.97),('7643','2013-03-14','16:10:00',2.57),('7643','2013-03-14','16:15:00',2.65),('7643','2013-03-14','16:20:00',2.3),('7643','2013-03-14','16:25:00',1.58),('7643','2013-03-14','16:30:00',1.47),('7643','2013-03-14','16:35:00',1.3),('7643','2013-03-14','16:40:00',1.1),('7643','2013-03-14','17:00:00',1.04),('7643','2013-03-14','17:05:00',1.19),('7643','2013-03-14','17:10:00',1.35),('7643','2013-03-14','17:15:00',2.5),('7643','2013-03-14','17:20:00',2.37),('7643','2013-03-14','17:25:00',1.81),('7643','2013-03-14','17:30:00',1.41),('7643','2013-03-13','07:15:00',1.03),('7643','2013-03-13','07:20:00',1.12),('7643','2013-03-13','08:10:00',1.22),('7643','2013-03-13','08:15:00',1.93),('7643','2013-03-13','08:20:00',2.75),('7643','2013-03-13','08:25:00',3.01),('7643','2013-03-13','08:30:00',2.58),('7643','2013-03-13','08:35:00',1.66),('7643','2013-03-13','08:40:00',1.36),('7643','2013-03-13','09:20:00',1.1),('7643','2013-03-13','09:25:00',1.33),('7643','2013-03-13','09:30:00',1.33),('7643','2013-03-13','09:35:00',1.06),('7643','2013-03-13','09:40:00',1.1),('7643','2013-03-13','09:45:00',1.21),('7643','2013-03-13','09:50:00',1.16),('7643','2013-03-13','10:15:00',1.51),('7643','2013-03-13','10:20:00',2.26),('7643','2013-03-13','10:25:00',2.33),('7643','2013-03-13','10:30:00',2.37),('7643','2013-03-13','10:35:00',2.44),('7643','2013-03-13','10:40:00',2.23),('7643','2013-03-13','10:45:00',1.77),('7643','2013-03-13','10:50:00',1.44),('7643','2013-03-13','10:55:00',1.24),('7643','2013-03-13','11:00:00',1.26),('7643','2013-03-13','11:05:00',1.29),('7643','2013-03-13','11:10:00',1.35),('7643','2013-03-13','11:15:00',1.34),('7643','2013-03-13','11:20:00',1.35),('7643','2013-03-13','11:25:00',2.13),('7643','2013-03-13','11:30:00',2.73),('7643','2013-03-13','11:35:00',3.18),('7643','2013-03-13','11:40:00',3.18),('7643','2013-03-13','11:45:00',3.3),('7643','2013-03-13','11:50:00',3.15),('7643','2013-03-13','11:55:00',2.87),('7643','2013-03-13','12:00:00',2.59),('7643','2013-03-13','12:05:00',2.32),('7643','2013-03-13','12:10:00',2.15),('7643','2013-03-13','12:15:00',2.17),('7643','2013-03-13','12:20:00',2.27),('7643','2013-03-13','12:25:00',2.4),('7643','2013-03-13','12:30:00',2.54),('7643','2013-03-13','12:35:00',2.52),('7643','2013-03-13','12:40:00',2.37),('7643','2013-03-13','12:45:00',2.68),('7643','2013-03-13','12:50:00',3.09),('7643','2013-03-13','12:55:00',3.71),('7643','2013-03-13','13:00:00',3.44),('7643','2013-03-13','13:05:00',3.5),('7643','2013-03-13','13:10:00',3.75),('7643','2013-03-13','13:15:00',3.97),('7643','2013-03-13','13:20:00',4.39),('7643','2013-03-13','13:25:00',4.31),('7643','2013-03-13','13:30:00',4.29),('7643','2013-03-13','13:35:00',4.41),('7643','2013-03-13','13:40:00',4.12),('7643','2013-03-13','13:45:00',5.2),('7643','2013-03-13','13:50:00',6.44),('7643','2013-03-13','13:55:00',8.32),('7643','2013-03-13','14:00:00',7.09),('7643','2013-03-13','14:05:00',7.16),('7643','2013-03-13','14:10:00',5.9),('7643','2013-03-13','14:15:00',4.67),('7643','2013-03-13','14:20:00',4.17),('7643','2013-03-13','14:25:00',4.13),('7643','2013-03-13','14:30:00',4.01),('7643','2013-03-13','14:35:00',3.25),('7643','2013-03-13','14:40:00',2.44),('7643','2013-03-13','14:45:00',2.06),('7643','2013-03-13','14:50:00',2.08),('7643','2013-03-13','14:55:00',2.23),('7643','2013-03-13','15:00:00',2.37),('7643','2013-03-13','15:05:00',3.28),('7643','2013-03-13','15:10:00',4.87),('7643','2013-03-13','15:15:00',5.07),('7643','2013-03-13','15:20:00',4.67),('7643','2013-03-13','15:25:00',4.79),('7643','2013-03-13','15:30:00',4.69),('7643','2013-03-13','15:35:00',3.89),('7643','2013-03-13','15:40:00',2.91),('7643','2013-03-13','15:45:00',2.43),('7643','2013-03-13','15:50:00',1.78),('7643','2013-03-13','15:55:00',1.05),('7643','2013-03-13','16:25:00',1.48),('7643','2013-03-13','16:30:00',1.98),('7643','2013-03-13','16:35:00',1.63),('7643','2013-03-13','16:40:00',1.31),('7643','2013-03-12','07:05:00',1.82),('7643','2013-03-12','07:10:00',2.09),('7643','2013-03-12','07:15:00',2.06),('7643','2013-03-12','07:20:00',2.5),('7643','2013-03-12','07:25:00',2.09),('7643','2013-03-12','07:30:00',1.39),('7643','2013-03-12','07:35:00',2.49),('7643','2013-03-12','07:40:00',2.33),('7643','2013-03-12','07:45:00',1.99),('7643','2013-03-12','07:50:00',1.37),('7643','2013-03-12','07:55:00',1.46),('7643','2013-03-12','08:00:00',1.51),('7643','2013-03-12','08:05:00',1.92),('7643','2013-03-12','08:10:00',2.16),('7643','2013-03-12','08:15:00',1.27),('7643','2013-03-12','08:20:00',1.35),('7643','2013-03-12','08:25:00',2.47),('7643','2013-03-12','08:30:00',1.63),('7643','2013-03-12','08:35:00',1.73),('7643','2013-03-12','08:40:00',2.54),('7643','2013-03-12','08:45:00',3.14),('7643','2013-03-12','08:50:00',4.5),('7643','2013-03-12','08:55:00',4.48),('7643','2013-03-12','09:00:00',3.03),('7643','2013-03-12','09:05:00',3),('7643','2013-03-12','09:10:00',4.86),('7643','2013-03-12','09:15:00',4.2),('7643','2013-03-12','09:20:00',4.22),('7643','2013-03-12','09:25:00',3.38),('7643','2013-03-12','09:30:00',3.11),('7643','2013-03-12','09:35:00',2.58),('7643','2013-03-12','09:40:00',2.73),('7643','2013-03-12','09:45:00',3.84),('7643','2013-03-12','09:50:00',2.66),('7643','2013-03-12','09:55:00',1.48),('7643','2013-03-12','10:00:00',2.5),('7643','2013-03-12','10:05:00',3.75),('7643','2013-03-12','10:10:00',5.18),('7643','2013-03-12','10:15:00',10.21),('7643','2013-03-12','10:20:00',7.3),('7643','2013-03-12','10:25:00',8.93),('7643','2013-03-12','10:30:00',15.27),('7643','2013-03-12','10:35:00',15.1),('7643','2013-03-12','10:40:00',9.37),('7643','2013-03-12','10:45:00',4.95),('7643','2013-03-12','10:50:00',4.83),('7643','2013-03-12','10:55:00',4.71),('7643','2013-03-12','11:00:00',4.56),('7643','2013-03-12','11:05:00',2.99),('7643','2013-03-12','11:10:00',3.56),('7643','2013-03-12','11:15:00',3.66),('7643','2013-03-12','11:20:00',3.27),('7643','2013-03-12','11:25:00',3.16),('7643','2013-03-12','11:30:00',4.88),('7643','2013-03-12','11:35:00',4.7),('7643','2013-03-12','11:40:00',4.47),('7643','2013-03-12','11:45:00',4.82),('7643','2013-03-12','11:50:00',4.46),('7643','2013-03-12','11:55:00',3.52),('7643','2013-03-12','12:00:00',2.28),('7643','2013-03-12','12:05:00',1.69),('7643','2013-03-12','12:10:00',1.46),('7643','2013-03-12','12:15:00',1.58),('7643','2013-03-12','12:20:00',1.63),('7643','2013-03-12','12:25:00',1.87),('7643','2013-03-12','12:30:00',2.54),('7643','2013-03-12','12:35:00',2.86),('7643','2013-03-12','12:40:00',3.12),('7643','2013-03-12','12:45:00',4.06),('7643','2013-03-12','12:50:00',5.02),('7643','2013-03-12','12:55:00',4.48),('7643','2013-03-12','13:00:00',4.36),('7643','2013-03-12','13:05:00',4.18),('7643','2013-03-12','13:10:00',3.78),('7643','2013-03-12','13:15:00',3.31),('7643','2013-03-12','13:20:00',2.79),('7643','2013-03-12','13:25:00',2.51),('7643','2013-03-12','13:30:00',2.85),('7643','2013-03-12','13:35:00',3.71),('7643','2013-03-12','13:40:00',3.22),('7643','2013-03-12','13:45:00',2.86),('7643','2013-03-12','13:50:00',2.69),('7643','2013-03-12','13:55:00',2.51),('7643','2013-03-12','14:00:00',2.14),('7643','2013-03-12','14:05:00',2.11),('7643','2013-03-12','14:10:00',1.9),('7643','2013-03-12','14:15:00',1.58),('7643','2013-03-12','14:20:00',1.47),('7643','2013-03-12','14:25:00',2.16),('7643','2013-03-12','14:30:00',2.39),('7643','2013-03-12','14:35:00',2.22),('7643','2013-03-12','14:40:00',2.17),('7643','2013-03-12','14:45:00',2.69),('7643','2013-03-12','14:50:00',2.98),('7643','2013-03-12','14:55:00',2.49),('7643','2013-03-12','15:00:00',2.64),('7643','2013-03-12','15:05:00',3.04),('7643','2013-03-12','15:10:00',3.12),('7643','2013-03-12','15:15:00',2.25),('7643','2013-03-12','15:20:00',1.32),('7643','2013-03-12','15:25:00',1.33),('7643','2013-03-12','15:30:00',1.09),('7643','2014-03-24','06:35:00',1.23),('7643','2014-03-24','06:40:00',1.53),('7643','2014-03-24','06:45:00',1.84),('7643','2014-03-24','06:50:00',2.02),('7643','2014-03-24','06:55:00',2.36),('7643','2014-03-24','07:00:00',2.21),('7643','2014-03-24','07:05:00',2.38),('7643','2014-03-24','07:10:00',3.54),('7643','2014-03-24','07:15:00',4.38),('7643','2014-03-24','07:20:00',5.13),('7643','2014-03-24','07:25:00',5.58),('7643','2014-03-24','07:30:00',6.02),('7643','2014-03-24','07:35:00',4.73),('7643','2014-03-24','07:40:00',4.37),('7643','2014-03-24','07:45:00',4.79),('7643','2014-03-24','07:50:00',5.13),('7643','2014-03-24','07:55:00',5.17),('7643','2014-03-24','08:00:00',4.88),('7643','2014-03-24','08:05:00',5.02),('7643','2014-03-24','08:10:00',5.4),('7643','2014-03-24','08:15:00',5.72),('7643','2014-03-24','08:20:00',5.18),('7643','2014-03-24','08:25:00',4.63),('7643','2014-03-24','08:30:00',4.12),('7643','2014-03-24','08:35:00',4.18),('7643','2014-03-24','08:40:00',5.03),('7643','2014-03-24','08:45:00',7.11),('7643','2014-03-24','08:50:00',7.6),('7643','2014-03-24','08:55:00',8.05),('7643','2014-03-24','09:00:00',7.25),('7643','2014-03-24','09:05:00',7.02),('7643','2014-03-24','09:10:00',7.13),('7643','2014-03-24','09:15:00',9.33),('7643','2014-03-24','09:20:00',10.14),('7643','2014-03-24','09:25:00',8.81),('7643','2014-03-24','09:30:00',7.79),('7643','2014-03-24','09:35:00',7.19),('7643','2014-03-24','09:40:00',7.35),('7643','2014-03-24','09:45:00',6.82),('7643','2014-03-24','09:50:00',7.03),('7643','2014-03-24','09:55:00',8.08),('7643','2014-03-24','10:00:00',9.42),('7643','2014-03-24','10:05:00',10),('7643','2014-03-24','10:10:00',10.67),('7643','2014-03-24','10:15:00',11.63),('7643','2014-03-24','10:20:00',11.6),('7643','2014-03-24','10:25:00',11.21),('7643','2014-03-24','10:30:00',12.05),('7643','2014-03-24','10:35:00',10.05),('7643','2014-03-24','10:40:00',8.27),('7643','2014-03-24','10:45:00',7.52),('7643','2014-03-24','10:50:00',7.33),('7643','2014-03-24','10:55:00',7.32),('7643','2014-03-24','11:00:00',7.83),('7643','2014-03-24','11:05:00',8.91),('7643','2014-03-24','11:10:00',10),('7643','2014-03-24','11:15:00',11.59),('7643','2014-03-24','11:20:00',12.32),('7643','2014-03-24','11:25:00',11.21),('7643','2014-03-24','11:30:00',8.47),('7643','2014-03-24','11:35:00',12.16),('7643','2014-03-24','11:40:00',9.01),('7643','2014-03-24','11:45:00',9.42),('7643','2014-03-24','11:50:00',7.58),('7643','2014-03-24','11:55:00',6.65),('7643','2014-03-24','12:00:00',4.81),('7643','2014-03-24','12:05:00',3.14),('7643','2014-03-24','12:10:00',3.16),('7643','2014-03-24','12:15:00',3.67),('7643','2014-03-24','12:20:00',4.94),('7643','2014-03-24','12:25:00',5.21),('7643','2014-03-24','12:30:00',3.7),('7643','2014-03-24','12:35:00',2.65),('7643','2014-03-24','12:40:00',2.44),('7643','2014-03-24','12:45:00',1.9),('7643','2014-03-24','12:50:00',1.12),('7643','2014-03-24','13:05:00',1.03),('7643','2014-03-24','13:10:00',1.32),('7643','2014-03-24','13:15:00',1.47),('7643','2014-03-24','13:20:00',1.55),('7643','2014-03-24','13:25:00',1.75),('7643','2014-03-24','13:30:00',2.74),('7643','2014-03-24','13:35:00',3.7),('7643','2014-03-24','13:40:00',3.52),('7643','2014-03-24','13:45:00',3.09),('7643','2014-03-24','13:50:00',3.04),('7643','2014-03-24','13:55:00',2.9),('7643','2014-03-24','14:00:00',2.52),('7643','2014-03-24','14:05:00',2.82),('7643','2014-03-24','14:10:00',3.36),('7643','2014-03-24','14:15:00',3.53),('7643','2014-03-24','14:20:00',2.59),('7643','2014-03-24','14:25:00',1.98),('7643','2014-03-24','14:30:00',2.03),('7643','2014-03-24','14:35:00',2.39),('7643','2014-03-24','14:40:00',2.19),('7643','2014-03-24','14:45:00',2.26),('7643','2014-03-24','14:50:00',1.77),('7643','2014-03-24','14:55:00',1.73),('7643','2014-03-24','15:00:00',1.82),('7643','2014-03-24','15:05:00',1.34),('7643','2014-03-24','15:10:00',1.34),('7643','2014-03-24','15:15:00',2.22),('7643','2014-03-24','15:20:00',2.12),('7643','2014-03-24','15:25:00',1.78),('7643','2014-03-24','15:30:00',1.49),('7643','2014-03-24','15:35:00',1.5),('7643','2014-03-24','15:40:00',1.29),('7643','2014-03-24','15:45:00',1.32),('7643','2014-03-24','15:50:00',1.1),('7643','2014-03-24','15:55:00',1.25),('7643','2014-03-24','16:00:00',1.06),('7643','2013-03-11','08:15:00',1.26),('7643','2013-03-11','08:20:00',7.02),('7643','2013-03-11','08:25:00',7.4),('7643','2013-03-11','08:30:00',7.71),('7643','2013-03-11','08:35:00',7.36),('7643','2013-03-11','08:40:00',7.38),('7643','2013-03-11','08:45:00',9.77),('7643','2013-03-11','08:50:00',6.88),('7643','2013-03-11','08:55:00',2.74),('7643','2013-03-11','09:00:00',5.29),('7643','2013-03-11','09:05:00',10.24),('7643','2013-03-11','09:10:00',10.43),('7643','2013-03-11','09:15:00',10.65),('7643','2013-03-11','09:20:00',10.88),('7643','2013-03-11','09:25:00',11.19),('7643','2013-03-11','09:30:00',11.58),('7643','2013-03-11','09:35:00',11.74),('7643','2013-03-11','09:40:00',11.53),('7643','2013-03-11','09:45:00',10.11),('7643','2013-03-11','09:50:00',5.04),('7643','2013-03-11','09:55:00',11.76),('7643','2013-03-11','10:00:00',9.82),('7643','2013-03-11','10:05:00',10.83),('7643','2013-03-11','10:10:00',13.87),('7643','2013-03-11','10:15:00',14.57),('7643','2013-03-11','10:20:00',6.58),('7643','2013-03-11','10:25:00',10.97),('7643','2013-03-11','10:30:00',5.17),('7643','2013-03-11','10:35:00',9.58),('7643','2013-03-11','10:40:00',10.46),('7643','2013-03-11','10:45:00',7.2),('7643','2013-03-11','10:50:00',10.71),('7643','2013-03-11','10:55:00',14.59),('7643','2013-03-11','11:00:00',16.28),('7643','2013-03-11','11:05:00',17.1),('7643','2013-03-11','11:10:00',11.6),('7643','2013-03-11','11:15:00',13.49),('7643','2013-03-11','11:20:00',14.93),('7643','2013-03-11','11:25:00',7.19),('7643','2013-03-11','11:30:00',5.59),('7643','2013-03-11','11:35:00',7.03),('7643','2013-03-11','11:40:00',8.29),('7643','2013-03-11','11:45:00',8.75),('7643','2013-03-11','11:50:00',9.68),('7643','2013-03-11','11:55:00',12.18),('7643','2013-03-11','12:00:00',3.48),('7643','2013-03-11','12:05:00',2.45),('7643','2013-03-11','12:10:00',12.97),('7643','2013-03-11','12:15:00',9.61),('7643','2013-03-11','12:20:00',9.29),('7643','2013-03-11','12:25:00',7.32),('7643','2013-03-11','12:30:00',13.39),('7643','2013-03-11','12:35:00',9.85),('7643','2013-03-11','12:40:00',16.6),('7643','2013-03-11','12:45:00',5.72),('7643','2013-03-11','12:50:00',7.56),('7643','2013-03-11','12:55:00',12.97),('7643','2013-03-11','13:00:00',12.96),('7643','2013-03-11','13:05:00',17.28),('7643','2013-03-11','13:10:00',10.21),('7643','2013-03-11','13:15:00',5.2),('7643','2013-03-11','13:20:00',10.87),('7643','2013-03-11','13:25:00',8.67),('7643','2013-03-11','13:30:00',5.15),('7643','2013-03-11','13:35:00',6.39),('7643','2013-03-11','13:40:00',4.53),('7643','2013-03-11','13:45:00',3.16),('7643','2013-03-11','13:50:00',3.6),('7643','2013-03-11','13:55:00',5.74),('7643','2013-03-11','14:00:00',6.88),('7643','2013-03-11','14:05:00',14.26),('7643','2013-03-11','14:10:00',8.31),('7643','2013-03-11','14:15:00',4.03),('7643','2013-03-11','14:20:00',3.99),('7643','2013-03-11','14:25:00',1.78),('7643','2013-03-11','14:30:00',2.02),('7643','2013-03-11','14:35:00',2.93),('7643','2013-03-11','14:40:00',1.33),('7643','2013-03-11','15:00:00',2.45),('7643','2013-03-11','15:05:00',1.59),('7643','2013-03-11','15:10:00',2.61),('7643','2013-03-11','15:15:00',2.17),('7643','2013-03-11','15:20:00',2.82),('7643','2013-03-11','15:25:00',2.92),('7643','2013-03-11','15:30:00',2.24),('7643','2013-03-11','15:35:00',1.84),('7643','2013-03-11','15:40:00',1.17),('7643','2013-03-11','15:50:00',1.4),('7643','2013-03-10','07:05:00',1.15),('7643','2013-03-10','07:10:00',1.51),('7643','2013-03-10','07:15:00',1.92),('7643','2013-03-10','07:20:00',2.25),('7643','2013-03-10','07:25:00',2.75),('7643','2013-03-10','07:30:00',3.09),('7643','2013-03-10','07:35:00',2.69),('7643','2013-03-10','07:40:00',3.14),('7643','2013-03-10','07:45:00',2.86),('7643','2013-03-10','07:50:00',1.79),('7643','2013-03-10','07:55:00',1.29),('7643','2013-03-10','08:00:00',2.18),('7643','2013-03-10','08:05:00',1.69),('7643','2013-03-10','08:10:00',6.07),('7643','2013-03-10','08:15:00',6.48),('7643','2013-03-10','08:20:00',6.84),('7643','2013-03-10','08:25:00',7.25),('7643','2013-03-10','08:30:00',7.57),('7643','2013-03-10','08:35:00',7.98),('7643','2013-03-10','08:40:00',8.23),('7643','2013-03-10','08:45:00',8.56),('7643','2013-03-10','08:50:00',8.92),('7643','2013-03-10','08:55:00',9.19),('7643','2013-03-10','09:00:00',9.44),('7643','2013-03-10','09:05:00',9.81),('7643','2013-03-10','09:10:00',10.01),('7643','2013-03-10','09:15:00',10.51),('7643','2013-03-10','09:20:00',9.58),('7643','2013-03-10','09:25:00',6.33),('7643','2013-03-10','09:30:00',4.96),('7643','2013-03-10','09:35:00',12.67),('7643','2013-03-10','09:40:00',12.76),('7643','2013-03-10','09:45:00',9.28),('7643','2013-03-10','09:50:00',6.08),('7643','2013-03-10','09:55:00',3.37),('7643','2013-03-10','10:00:00',3.02),('7643','2013-03-10','10:05:00',3.41),('7643','2013-03-10','10:10:00',4.03),('7643','2013-03-10','10:15:00',4.06),('7643','2013-03-10','10:20:00',4.62),('7643','2013-03-10','10:25:00',5.4),('7643','2013-03-10','10:30:00',4.98),('7643','2013-03-10','10:35:00',6.61),('7643','2013-03-10','10:40:00',10.06),('7643','2013-03-10','10:45:00',10.95),('7643','2013-03-10','10:50:00',13.05),('7643','2013-03-10','10:55:00',7.47),('7643','2013-03-10','11:00:00',5.86),('7643','2013-03-10','11:05:00',5.07),('7643','2013-03-10','11:10:00',5.92),('7643','2013-03-10','11:15:00',5.8),('7643','2013-03-10','11:20:00',4.98),('7643','2013-03-10','11:25:00',4.78),('7643','2013-03-10','11:30:00',7.19),('7643','2013-03-10','11:35:00',15.95),('7643','2013-03-10','11:40:00',9.66),('7643','2013-03-10','11:45:00',14.46),('7643','2013-03-10','11:50:00',8.47),('7643','2013-03-10','11:55:00',7.44),('7643','2013-03-10','12:00:00',6.64),('7643','2013-03-10','12:05:00',6.16),('7643','2013-03-10','12:10:00',5.33),('7643','2013-03-10','12:15:00',2.56),('7643','2013-03-10','12:20:00',3.06),('7643','2013-03-10','12:25:00',3.5),('7643','2013-03-10','12:30:00',3.7),('7643','2013-03-10','12:35:00',4.56),('7643','2013-03-10','12:40:00',4.65),('7643','2013-03-10','12:45:00',4.92),('7643','2013-03-10','12:50:00',11.18),('7643','2013-03-10','12:55:00',14.68),('7643','2013-03-10','13:00:00',8.65),('7643','2013-03-10','13:05:00',8.24),('7643','2013-03-10','13:10:00',15.88),('7643','2013-03-10','13:15:00',12.65),('7643','2013-03-10','13:20:00',12.12),('7643','2013-03-10','13:25:00',12.92),('7643','2013-03-10','13:30:00',13.79),('7643','2013-03-10','13:35:00',13.38),('7643','2013-03-10','13:40:00',8.38),('7643','2013-03-10','13:45:00',10.26),('7643','2013-03-10','13:50:00',14.58),('7643','2013-03-10','13:55:00',7.81),('7643','2013-03-10','14:00:00',3.88),('7643','2013-03-10','14:05:00',3.44),('7643','2013-03-10','14:10:00',3.01),('7643','2013-03-10','14:15:00',2.12),('7643','2013-03-10','14:20:00',1.93),('7643','2013-03-10','14:25:00',5.18),('7643','2013-03-10','14:30:00',4.44),('7643','2013-03-10','14:35:00',3.73),('7643','2013-03-10','14:40:00',4.5),('7643','2013-03-10','14:45:00',4.34),('7643','2013-03-10','14:50:00',2.29),('7643','2013-03-10','14:55:00',2.22),('7643','2013-03-10','15:00:00',2.06),('7643','2013-03-10','15:05:00',2.07),('7643','2013-03-10','15:10:00',1.96),('7643','2013-03-10','15:15:00',2.08),('7643','2013-03-10','15:20:00',2.22),('7643','2013-03-10','15:25:00',2.27),('7643','2013-03-10','15:30:00',2.85),('7643','2013-03-10','15:35:00',3.42),('7643','2013-03-10','15:40:00',4.01),('7643','2013-03-10','15:45:00',9.55),('7643','2013-03-10','15:50:00',9.01),('7643','2013-03-10','15:55:00',8.97),('7643','2013-03-10','16:00:00',7.48),('7643','2013-03-10','16:05:00',4.91),('7643','2013-03-10','16:10:00',5.89),('7643','2013-03-10','16:15:00',4.93),('7643','2013-03-10','16:20:00',6.16),('7643','2013-03-10','16:25:00',5.66),('7643','2013-03-10','16:30:00',5.66),('7643','2013-03-10','16:35:00',4.41),('7643','2013-03-10','16:40:00',3.03),('7643','2013-03-10','16:45:00',5.14),('7643','2013-03-10','16:50:00',4.03),('7643','2013-03-10','16:55:00',1.35),('7643','2013-03-10','17:05:00',1.72),('7643','2013-03-10','17:10:00',1.59),('7643','2013-03-10','17:15:00',1.71),('7643','2013-03-10','17:20:00',1.84),('7643','2013-03-10','17:25:00',1.58),('7643','2013-03-10','17:30:00',1.04),('7643','2013-03-09','07:05:00',1.2),('7643','2013-03-09','07:10:00',1.51),('7643','2013-03-09','07:15:00',1.64),('7643','2013-03-09','07:20:00',1.41),('7643','2013-03-09','07:25:00',1.34),('7643','2013-03-09','07:30:00',1.83),('7643','2013-03-09','07:35:00',3.02),('7643','2013-03-09','07:40:00',3.11),('7643','2013-03-09','07:45:00',3.63),('7643','2013-03-09','07:50:00',4.39),('7643','2013-03-09','07:55:00',4.95),('7643','2013-03-09','08:00:00',5.3),('7643','2013-03-09','08:05:00',5.75),('7643','2013-03-09','08:10:00',6.27),('7643','2013-03-09','08:15:00',6.38),('7643','2013-03-09','08:20:00',6.87),('7643','2013-03-09','08:25:00',7.23),('7643','2013-03-09','08:30:00',7.51),('7643','2013-03-09','08:35:00',7.86),('7643','2013-03-09','08:40:00',8.21),('7643','2013-03-09','08:45:00',8.5),('7643','2013-03-09','08:50:00',8.8),('7643','2013-03-09','08:55:00',9.15),('7643','2013-03-09','09:00:00',9.45),('7643','2013-03-09','09:05:00',9.74),('7643','2013-03-09','09:10:00',9.97),('7643','2013-03-09','09:15:00',10.3),('7643','2013-03-09','09:20:00',10.48),('7643','2013-03-09','09:25:00',10.75),('7643','2013-03-09','09:30:00',11.04),('7643','2013-03-09','09:35:00',11.35),('7643','2013-03-09','09:40:00',11.95),('7643','2013-03-09','09:45:00',12.63),('7643','2013-03-09','09:50:00',11.94),('7643','2013-03-09','09:55:00',13.9),('7643','2013-03-09','10:00:00',12.24),('7643','2013-03-09','10:05:00',6.43),('7643','2013-03-09','10:10:00',8.09),('7643','2013-03-09','10:15:00',7.37),('7643','2013-03-09','10:20:00',12.25),('7643','2013-03-09','10:25:00',4.94),('7643','2013-03-09','10:30:00',11.9),('7643','2013-03-09','10:35:00',12.74),('7643','2013-03-09','10:40:00',13.46),('7643','2013-03-09','10:45:00',9.98),('7643','2013-03-09','10:50:00',10.43),('7643','2013-03-09','10:55:00',10.83),('7643','2013-03-09','11:00:00',10.15),('7643','2013-03-09','11:05:00',10.76),('7643','2013-03-09','11:10:00',14.64),('7643','2013-03-09','11:15:00',5.58),('7643','2013-03-09','11:20:00',12.74),('7643','2013-03-09','11:25:00',16.77),('7643','2013-03-09','11:30:00',6.88),('7643','2013-03-09','11:35:00',12.3),('7643','2013-03-09','11:40:00',6.46),('7643','2013-03-09','11:45:00',6.4),('7643','2013-03-09','11:50:00',16.86),('7643','2013-03-09','11:55:00',15.87),('7643','2013-03-09','12:00:00',15.73),('7643','2013-03-09','12:05:00',15.37),('7643','2013-03-09','12:10:00',11.38),('7643','2013-03-09','12:15:00',13.39),('7643','2013-03-09','12:20:00',10.63),('7643','2013-03-09','12:25:00',12.76),('7643','2013-03-09','12:30:00',4.93),('7643','2013-03-09','12:35:00',5.15),('7643','2013-03-09','12:40:00',15.29),('7643','2013-03-09','12:45:00',16.93),('7643','2013-03-09','12:50:00',10.34),('7643','2013-03-09','12:55:00',15.99),('7643','2013-03-09','13:00:00',15.1),('7643','2013-03-09','13:05:00',13.8),('7643','2013-03-09','13:10:00',14.24),('7643','2013-03-09','13:15:00',14.74),('7643','2013-03-09','13:20:00',14.71),('7643','2013-03-09','13:25:00',13.49),('7643','2013-03-09','13:30:00',12.81),('7643','2013-03-09','13:35:00',14.14),('7643','2013-03-09','13:40:00',8),('7643','2013-03-09','13:45:00',9.26),('7643','2013-03-09','13:50:00',7.04),('7643','2013-03-09','13:55:00',6.69),('7643','2013-03-09','14:00:00',5.82),('7643','2013-03-09','14:05:00',7.3),('7643','2013-03-09','14:10:00',8.38),('7643','2013-03-09','14:15:00',9.75),('7643','2013-03-09','14:20:00',9.58),('7643','2013-03-09','14:25:00',7.24),('7643','2013-03-09','14:30:00',9.13),('7643','2013-03-09','14:35:00',13.51),('7643','2013-03-09','14:40:00',10.42),('7643','2013-03-09','14:45:00',6.1),('7643','2013-03-09','14:50:00',6.82),('7643','2013-03-09','14:55:00',6.28),('7643','2013-03-09','15:00:00',4.79),('7643','2013-03-09','15:05:00',5.29),('7643','2013-03-09','15:10:00',5.24),('7643','2013-03-09','15:15:00',3.37),('7643','2013-03-09','15:20:00',3.41),('7643','2013-03-09','15:25:00',2.17),('7643','2013-03-09','15:30:00',1.97),('7643','2013-03-09','15:35:00',2.1),('7643','2013-03-09','15:40:00',2.21),('7643','2013-03-09','15:45:00',2.15),('7643','2013-03-09','15:50:00',3.38),('7643','2013-03-09','15:55:00',2.73),('7643','2013-03-09','16:00:00',1.91),('7643','2013-03-09','16:05:00',1.48),('7643','2013-03-09','16:10:00',1.19),('7643','2013-03-08','07:35:00',1.16),('7643','2013-03-08','07:40:00',1.86),('7643','2013-03-08','07:45:00',1.73),('7643','2013-03-08','07:50:00',2.12),('7643','2013-03-08','07:55:00',2.74),('7643','2013-03-08','08:00:00',4.63),('7643','2013-03-08','08:05:00',6.38),('7643','2013-03-08','08:10:00',6.09),('7643','2013-03-08','08:15:00',6.29),('7643','2013-03-08','08:20:00',5.88),('7643','2013-03-08','08:25:00',7.02),('7643','2013-03-08','08:30:00',7.35),('7643','2013-03-08','08:35:00',7.18),('7643','2013-03-08','08:40:00',7.44),('7643','2013-03-08','08:45:00',3.73),('7643','2013-03-08','08:50:00',3.47),('7643','2013-03-08','08:55:00',3.89),('7643','2013-03-08','09:00:00',6.18),('7643','2013-03-08','09:05:00',2.71),('7643','2013-03-08','09:10:00',2.61),('7643','2013-03-08','09:15:00',3.7),('7643','2013-03-08','09:20:00',2.98),('7643','2013-03-08','09:25:00',4.74),('7643','2013-03-08','09:30:00',6.79),('7643','2013-03-08','09:35:00',6.07),('7643','2013-03-08','09:40:00',13.37),('7643','2013-03-08','09:45:00',11.08),('7643','2013-03-08','09:50:00',8.95),('7643','2013-03-08','09:55:00',14.19),('7643','2013-03-08','10:00:00',6.05),('7643','2013-03-08','10:05:00',4.68),('7643','2013-03-08','10:10:00',5.44),('7643','2013-03-08','10:15:00',4.29),('7643','2013-03-08','10:20:00',8.14),('7643','2013-03-08','10:25:00',4.71),('7643','2013-03-08','10:30:00',4.98),('7643','2013-03-08','10:35:00',4.36),('7643','2013-03-08','10:40:00',8.54),('7643','2013-03-08','10:45:00',5.92),('7643','2013-03-08','10:50:00',12.15),('7643','2013-03-08','10:55:00',7.99),('7643','2013-03-08','11:00:00',9.9),('7643','2013-03-08','11:05:00',8.69),('7643','2013-03-08','11:10:00',11.88),('7643','2013-03-08','11:15:00',16.12),('7643','2013-03-08','11:20:00',15.39),('7643','2013-03-08','11:25:00',10.13),('7643','2013-03-08','11:30:00',8.21),('7643','2013-03-08','11:35:00',16.14),('7643','2013-03-08','11:40:00',10.09),('7643','2013-03-08','11:45:00',8.02),('7643','2013-03-08','11:50:00',15.98),('7643','2013-03-08','11:55:00',14.78),('7643','2013-03-08','12:00:00',11.66),('7643','2013-03-08','12:05:00',10.06),('7643','2013-03-08','12:10:00',8.75),('7643','2013-03-08','12:15:00',5.08),('7643','2013-03-08','12:20:00',6.13),('7643','2013-03-08','12:25:00',6.73),('7643','2013-03-08','12:30:00',5.25),('7643','2013-03-08','12:35:00',7.81),('7643','2013-03-08','12:40:00',5.42),('7643','2013-03-08','12:45:00',9.66),('7643','2013-03-08','12:50:00',8.01),('7643','2013-03-08','12:55:00',13.34),('7643','2013-03-08','13:00:00',15.26),('7643','2013-03-08','13:05:00',13.58),('7643','2013-03-08','13:10:00',12.9),('7643','2013-03-08','13:15:00',17.04),('7643','2013-03-08','13:20:00',14.67),('7643','2013-03-08','13:25:00',7.66),('7643','2013-03-08','13:30:00',15.02),('7643','2013-03-08','13:35:00',5.76),('7643','2013-03-08','13:40:00',5.26),('7643','2013-03-08','13:45:00',9.09),('7643','2013-03-08','13:50:00',8.62),('7643','2013-03-08','13:55:00',4.19),('7643','2013-03-08','14:00:00',4.96),('7643','2013-03-08','14:05:00',14.99),('7643','2013-03-08','14:10:00',14.43),('7643','2013-03-08','14:15:00',13.23),('7643','2013-03-08','14:20:00',12.68),('7643','2013-03-08','14:25:00',12.4),('7643','2013-03-08','14:30:00',12.28),('7643','2013-03-08','14:35:00',11.97),('7643','2013-03-08','14:40:00',11.73),('7643','2013-03-08','14:45:00',11.48),('7643','2013-03-08','14:50:00',11.22),('7643','2013-03-08','14:55:00',11.02),('7643','2013-03-08','15:00:00',10.78),('7643','2013-03-08','15:05:00',10.54),('7643','2013-03-08','15:10:00',10.28),('7643','2013-03-08','15:15:00',9.96),('7643','2013-03-08','15:20:00',9.65),('7643','2013-03-08','15:25:00',9.29),('7643','2013-03-08','15:30:00',9.03),('7643','2013-03-08','15:35:00',8.56),('7643','2013-03-08','15:40:00',8.52),('7643','2013-03-08','15:45:00',8.18),('7643','2013-03-08','15:50:00',7.74),('7643','2013-03-08','15:55:00',6.95),('7643','2013-03-08','16:00:00',6.42),('7643','2013-03-08','16:05:00',6.6),('7643','2013-03-08','16:10:00',5.5),('7643','2013-03-08','16:15:00',6.1),('7643','2013-03-08','16:20:00',5.09),('7643','2013-03-08','16:25:00',5.68),('7643','2013-03-08','16:30:00',4.96),('7643','2013-03-08','16:35:00',4.02),('7643','2013-03-08','16:40:00',3.57),('7643','2013-03-08','16:45:00',2.65),('7643','2013-03-08','16:50:00',2.41),('7643','2013-03-08','16:55:00',1.29),('7643','2013-03-08','17:00:00',1.14),('7643','2013-03-08','17:05:00',1.03),('7643','2013-03-07','07:50:00',1.31),('7643','2013-03-07','07:55:00',1.09),('7643','2013-03-07','08:05:00',1.46),('7643','2013-03-07','08:10:00',4.05),('7643','2013-03-07','08:15:00',3.76),('7643','2013-03-07','08:20:00',2.12),('7643','2013-03-07','08:25:00',2.64),('7643','2013-03-07','08:30:00',5.31),('7643','2013-03-07','08:35:00',6.06),('7643','2013-03-07','08:40:00',3.13),('7643','2013-03-07','08:45:00',2.54),('7643','2013-03-07','08:50:00',4.47),('7643','2013-03-07','08:55:00',4.01),('7643','2013-03-07','09:00:00',2.48),('7643','2013-03-07','09:05:00',2.07),('7643','2013-03-07','09:10:00',2.57),('7643','2013-03-07','09:15:00',3.55),('7643','2013-03-07','09:20:00',2.94),('7643','2013-03-07','09:25:00',2.82),('7643','2013-03-07','09:30:00',5.94),('7643','2013-03-07','09:35:00',6.54),('7643','2013-03-07','09:40:00',4.72),('7643','2013-03-07','09:45:00',9.77),('7643','2013-03-07','09:50:00',10.56),('7643','2013-03-07','09:55:00',6.97),('7643','2013-03-07','10:00:00',3.73),('7643','2013-03-07','10:05:00',3.98),('7643','2013-03-07','10:10:00',4.86),('7643','2013-03-07','10:15:00',5.3),('7643','2013-03-07','10:20:00',6.01),('7643','2013-03-07','10:25:00',5.35),('7643','2013-03-07','10:30:00',7.44),('7643','2013-03-07','10:35:00',12.21),('7643','2013-03-07','10:40:00',8.09),('7643','2013-03-07','10:45:00',4.27),('7643','2013-03-07','10:50:00',5.17),('7643','2013-03-07','10:55:00',4.43),('7643','2013-03-07','11:00:00',4.14),('7643','2013-03-07','11:05:00',3.01),('7643','2013-03-07','11:10:00',1.97),('7643','2013-03-07','11:15:00',1.66),('7643','2013-03-07','11:20:00',1.79),('7643','2013-03-07','11:25:00',1.95),('7643','2013-03-07','11:30:00',2.81),('7643','2013-03-07','11:35:00',7.31),('7643','2013-03-07','11:40:00',9.41),('7643','2013-03-07','11:45:00',7.68),('7643','2013-03-07','11:50:00',6.66),('7643','2013-03-07','11:55:00',6.94),('7643','2013-03-07','12:00:00',7.19),('7643','2013-03-07','12:05:00',4.19),('7643','2013-03-07','12:10:00',3.21),('7643','2013-03-07','12:15:00',3.37),('7643','2013-03-07','12:20:00',5.39),('7643','2013-03-07','12:25:00',4.38),('7643','2013-03-07','12:30:00',3.99),('7643','2013-03-07','12:35:00',5.74),('7643','2013-03-07','12:40:00',8.79),('7643','2013-03-07','12:45:00',9.52),('7643','2013-03-07','12:50:00',9.69),('7643','2013-03-07','12:55:00',7.67),('7643','2013-03-07','13:00:00',8.47),('7643','2013-03-07','13:05:00',9.49),('7643','2013-03-07','13:10:00',5.6),('7643','2013-03-07','13:15:00',4.55),('7643','2013-03-07','13:20:00',4.37),('7643','2013-03-07','13:25:00',5.63),('7643','2013-03-07','13:30:00',6.94),('7643','2013-03-07','13:35:00',4.98),('7643','2013-03-07','13:40:00',4.57),('7643','2013-03-07','13:45:00',2.6),('7643','2013-03-07','13:50:00',2.26),('7643','2013-03-07','13:55:00',3.45),('7643','2013-03-07','14:00:00',2.01),('7643','2013-03-07','15:55:00',1.04),('7643','2013-03-07','16:00:00',1.21),('7643','2013-03-07','16:05:00',1.24),('7643','2013-03-07','16:10:00',1.17),('7643','2013-03-07','16:35:00',1.08),('7643','2013-03-07','16:40:00',1.38),('7643','2013-03-07','16:45:00',1.16),('7643','2013-03-07','16:50:00',1.72),('7643','2013-03-07','16:55:00',2.29),('7643','2013-03-07','17:00:00',2.02),('7643','2013-03-07','17:05:00',1.91),('7643','2013-03-07','17:10:00',4.04),('7643','2013-03-07','17:15:00',4.35),('7643','2013-03-07','17:20:00',2.09),('7643','2013-03-07','17:25:00',1.37),('7643','2013-03-06','08:15:00',1.13),('7643','2013-03-06','08:20:00',1.43),('7643','2013-03-06','08:25:00',1.4),('7643','2013-03-06','08:30:00',1.35),('7643','2013-03-06','08:35:00',2.21),('7643','2013-03-06','08:40:00',3.23),('7643','2013-03-06','08:45:00',3.12),('7643','2013-03-06','08:50:00',3.78),('7643','2013-03-06','08:55:00',3.02),('7643','2013-03-06','09:00:00',2.97),('7643','2013-03-06','09:05:00',3.08),('7643','2013-03-06','09:10:00',2.39),('7643','2013-03-06','09:15:00',2.77),('7643','2013-03-06','09:20:00',3.7),('7643','2013-03-06','09:25:00',1.84),('7643','2013-03-06','09:30:00',1.74),('7643','2013-03-06','09:45:00',1.26),('7643','2013-03-06','09:50:00',1.43),('7643','2013-03-06','09:55:00',1.99),('7643','2013-03-06','10:00:00',1.7),('7643','2013-03-06','10:05:00',1.03),('7643','2013-03-06','10:10:00',1.34),('7643','2013-03-06','10:15:00',1.29),('7643','2013-03-06','10:20:00',1),('7643','2013-03-06','10:25:00',2.1),('7643','2013-03-06','10:30:00',3.4),('7643','2013-03-06','10:35:00',1.94),('7643','2013-03-06','10:40:00',1.74),('7643','2013-03-06','10:45:00',1.76),('7643','2013-03-06','10:50:00',3.64),('7643','2013-03-06','10:55:00',4.42),('7643','2013-03-06','11:00:00',3.9),('7643','2013-03-06','11:05:00',5.48),('7643','2013-03-06','11:10:00',4.07),('7643','2013-03-06','11:15:00',2.41),('7643','2013-03-06','11:20:00',1.87),('7643','2013-03-06','11:25:00',2.81),('7643','2013-03-06','11:30:00',5.42),('7643','2013-03-06','11:35:00',6.65),('7643','2013-03-06','11:40:00',5.86),('7643','2013-03-06','11:45:00',6.15),('7643','2013-03-06','11:50:00',6.42),('7643','2013-03-06','11:55:00',5.12),('7643','2013-03-06','12:00:00',4.03),('7643','2013-03-06','12:05:00',3.83),('7643','2013-03-06','12:10:00',2.01),('7643','2013-03-06','12:20:00',1.5),('7643','2013-03-06','12:25:00',3.2),('7643','2013-03-06','12:30:00',3.68),('7643','2013-03-06','12:35:00',3.5),('7643','2013-03-06','12:40:00',5.66),('7643','2013-03-06','12:45:00',7.77),('7643','2013-03-06','12:50:00',6.32),('7643','2013-03-06','12:55:00',5.67),('7643','2013-03-06','13:00:00',6.14),('7643','2013-03-06','13:05:00',5.51),('7643','2013-03-06','13:10:00',4.56),('7643','2013-03-06','13:15:00',5.95),('7643','2013-03-06','13:20:00',7.59),('7643','2013-03-06','13:25:00',6.7),('7643','2013-03-06','13:30:00',5.91),('7643','2013-03-06','13:35:00',4.97),('7643','2013-03-06','13:40:00',2.86),('7643','2013-03-06','13:45:00',2.26),('7643','2013-03-06','13:50:00',2.34),('7643','2013-03-06','13:55:00',2.72),('7643','2013-03-06','14:00:00',2.26),('7643','2013-03-06','14:05:00',3.34),('7643','2013-03-06','14:10:00',3.45),('7643','2013-03-06','14:15:00',2.56),('7643','2013-03-06','14:20:00',2.59),('7643','2013-03-06','14:25:00',2.58),('7643','2013-03-06','14:30:00',2.45),('7643','2013-03-06','14:35:00',1.52),('7643','2013-03-06','14:40:00',1.38),('7643','2013-03-06','14:45:00',2.39),('7643','2013-03-06','14:50:00',2.36),('7643','2013-03-06','14:55:00',2),('7643','2013-03-06','15:20:00',2.12),('7643','2013-03-06','15:25:00',2.5),('7643','2013-03-06','15:30:00',1.89),('7643','2013-03-06','15:35:00',2.03),('7643','2013-03-06','15:40:00',2.57),('7643','2013-03-06','15:45:00',2.12),('7643','2013-03-06','15:50:00',1.61),('7643','2013-03-06','15:55:00',1.81),('7643','2013-03-06','16:00:00',1.62),('7643','2013-03-06','16:05:00',2.62),('7643','2013-03-06','16:10:00',2.57),('7643','2013-03-06','16:15:00',2.31),('7643','2013-03-06','16:20:00',2.2),('7643','2013-03-06','16:25:00',1.98),('7643','2013-03-06','16:30:00',1.74),('7643','2013-03-06','16:35:00',2.21),('7643','2013-03-06','16:40:00',4.16),('7643','2013-03-06','16:45:00',2.5),('7643','2013-03-06','16:50:00',1.5),('7643','2013-03-05','07:45:00',1.03),('7643','2013-03-05','07:50:00',1.08),('7643','2013-03-05','08:20:00',1.51),('7643','2013-03-05','08:25:00',1.93),('7643','2013-03-05','08:30:00',1.86),('7643','2013-03-05','08:35:00',1.88),('7643','2013-03-05','08:40:00',1.2),('7643','2013-03-05','09:00:00',1.05),('7643','2013-03-05','09:05:00',1.71),('7643','2013-03-05','09:10:00',2.06),('7643','2013-03-05','09:15:00',1.48),('7643','2013-03-05','09:20:00',1.71),('7643','2013-03-05','09:25:00',2.06),('7643','2013-03-05','09:30:00',1.56),('7643','2013-03-05','09:35:00',1.05),('7643','2013-03-05','09:40:00',1.12),('7643','2013-03-05','09:45:00',1.49),('7643','2013-03-05','09:50:00',1.69),('7643','2013-03-05','09:55:00',1.62),('7643','2013-03-05','10:00:00',1.13),('7643','2013-03-05','10:05:00',1.16),('7643','2013-03-05','10:10:00',1.07),('7643','2013-03-05','10:50:00',1.1),('7643','2013-03-05','11:40:00',1),('7643','2013-03-05','11:45:00',1.15),('7643','2013-03-05','11:50:00',1.34),('7643','2013-03-05','11:55:00',1.43),('7643','2013-03-05','12:00:00',1.33),('7643','2013-03-05','15:20:00',1.13),('7643','2013-03-05','15:35:00',1.17),('7643','2013-03-05','15:40:00',1.66),('7643','2013-03-05','15:45:00',1.35),('7643','2013-03-05','15:50:00',1.48),('7643','2013-03-05','15:55:00',1.75),('7643','2013-03-05','16:00:00',2.04),('7643','2013-03-05','16:05:00',2.06),('7643','2013-03-05','16:10:00',1.73),('7643','2013-03-05','16:15:00',1.53),('7643','2013-03-05','16:20:00',1.4),('7643','2013-03-05','16:25:00',1.27),('7643','2013-03-05','16:30:00',1.19),('7643','2013-03-05','16:35:00',1.22),('7643','2013-03-04','07:05:00',1.1),('7643','2013-03-04','07:10:00',1.12),('7643','2013-03-04','07:30:00',1.3),('7643','2013-03-04','07:35:00',1.95),('7643','2013-03-04','07:40:00',1.84),('7643','2013-03-04','07:45:00',1.94),('7643','2013-03-04','07:50:00',1.89),('7643','2013-03-04','07:55:00',1.9),('7643','2013-03-04','08:00:00',2.16),('7643','2013-03-04','08:05:00',2.93),('7643','2013-03-04','08:10:00',3.58),('7643','2013-03-04','08:15:00',5.11),('7643','2013-03-04','08:20:00',3.93),('7643','2013-03-04','08:25:00',5.27),('7643','2013-03-04','08:30:00',7.97),('7643','2013-03-04','08:35:00',6.68),('7643','2013-03-04','08:40:00',7.03),('7643','2013-03-04','08:45:00',5.74),('7643','2013-03-04','08:50:00',6.34),('7643','2013-03-04','08:55:00',5.86),('7643','2013-03-04','09:00:00',6.41),('7643','2013-03-04','09:05:00',6.53),('7643','2013-03-04','09:10:00',6.09),('7643','2013-03-04','09:15:00',5.73),('7643','2013-03-04','09:20:00',5.68),('7643','2013-03-04','09:25:00',5.58),('7643','2013-03-04','09:30:00',5.9),('7643','2013-03-04','09:35:00',6.39),('7643','2013-03-04','09:40:00',6.79),('7643','2013-03-04','09:45:00',6.87),('7643','2013-03-04','09:50:00',6.96),('7643','2013-03-04','09:55:00',6.56),('7643','2013-03-04','10:00:00',6.25),('7643','2013-03-04','10:05:00',6.95),('7643','2013-03-04','10:10:00',7.24),('7643','2013-03-04','10:15:00',7.51),('7643','2013-03-04','10:20:00',8.23),('7643','2013-03-04','10:25:00',7.67),('7643','2013-03-04','10:30:00',7.33),('7643','2013-03-04','10:35:00',8.88),('7643','2013-03-04','10:40:00',9.13),('7643','2013-03-04','10:45:00',9.49),('7643','2013-03-04','10:50:00',10.14),('7643','2013-03-04','10:55:00',10.39),('7643','2013-03-04','11:00:00',9.64),('7643','2013-03-04','11:05:00',10.34),('7643','2013-03-04','11:10:00',10.81),('7643','2013-03-04','11:15:00',10.61),('7643','2013-03-04','11:20:00',10.32),('7643','2013-03-04','11:25:00',9.88),('7643','2013-03-04','11:30:00',10),('7643','2013-03-04','11:35:00',10.98),('7643','2013-03-04','11:40:00',12.16),('7643','2013-03-04','11:45:00',11.75),('7643','2013-03-04','11:50:00',11.77),('7643','2013-03-04','11:55:00',12.03),('7643','2013-03-04','12:00:00',12.46),('7643','2013-03-04','12:05:00',12.8),('7643','2013-03-04','12:10:00',13.23),('7643','2013-03-04','12:15:00',10.71),('7643','2013-03-04','12:20:00',12.11),('7643','2013-03-04','12:25:00',12.13),('7643','2013-03-04','12:30:00',10.31),('7643','2013-03-04','12:35:00',10.37),('7643','2013-03-04','12:40:00',9.43),('7643','2013-03-04','12:45:00',10.27),('7643','2013-03-04','12:50:00',8.84),('7643','2013-03-04','12:55:00',7.98),('7643','2013-03-04','13:00:00',6.52),('7643','2013-03-04','13:05:00',6.2),('7643','2013-03-04','13:10:00',6.59),('7643','2013-03-04','13:15:00',7.05),('7643','2013-03-04','13:20:00',6.81),('7643','2013-03-04','13:25:00',6.07),('7643','2013-03-04','13:30:00',5.56),('7643','2013-03-04','13:35:00',5.24),('7643','2013-03-04','13:40:00',4.97),('7643','2013-03-04','13:45:00',4.51),('7643','2013-03-04','13:50:00',4.09),('7643','2013-03-04','13:55:00',3.83),('7643','2013-03-04','14:00:00',3.78),('7643','2013-03-04','14:05:00',3.88),('7643','2013-03-04','14:10:00',4.05),('7643','2013-03-04','14:15:00',3.8),('7643','2013-03-04','14:20:00',3.55),('7643','2013-03-04','14:25:00',3.59),('7643','2013-03-04','14:30:00',3.49),('7643','2013-03-04','14:35:00',3.53),('7643','2013-03-04','14:40:00',3.66),('7643','2013-03-04','14:45:00',3.76),('7643','2013-03-04','14:50:00',3.67),('7643','2013-03-04','14:55:00',3.31),('7643','2013-03-04','15:00:00',2.97),('7643','2013-03-04','15:05:00',2.76),('7643','2013-03-04','15:10:00',2.3),('7643','2013-03-04','15:15:00',1.94),('7643','2013-03-04','15:20:00',2.19),('7643','2013-03-04','15:25:00',2.58),('7643','2013-03-04','15:30:00',3.08),('7643','2013-03-04','15:35:00',3.22),('7643','2013-03-04','15:40:00',3.35),('7643','2013-03-04','15:45:00',4.21),('7643','2013-03-04','15:50:00',4.27),('7643','2013-03-04','15:55:00',3.54),('7643','2013-03-04','16:00:00',3.12),('7643','2013-03-04','16:05:00',2.7),('7643','2013-03-04','16:10:00',2.16),('7643','2013-03-04','16:15:00',1.93),('7643','2013-03-04','16:20:00',1.59),('7643','2013-03-04','16:25:00',1.27),('7643','2013-03-04','16:30:00',1.21),('7643','2013-03-04','16:35:00',1.15),('7643','2013-03-03','07:15:00',1.2),('7643','2013-03-03','07:20:00',1.48),('7643','2013-03-03','07:25:00',1.79),('7643','2013-03-03','07:30:00',2.12),('7643','2013-03-03','07:35:00',2.49),('7643','2013-03-03','07:40:00',2.88),('7643','2013-03-03','07:45:00',3.26),('7643','2013-03-03','07:50:00',3.63),('7643','2013-03-03','07:55:00',4.03),('7643','2013-03-03','08:00:00',4.42),('7643','2013-03-03','08:05:00',4.82),('7643','2013-03-03','08:10:00',5.22),('7643','2013-03-03','08:15:00',5.6),('7643','2013-03-03','08:20:00',5.93),('7643','2013-03-03','08:25:00',6.31),('7643','2013-03-03','08:30:00',6.68),('7643','2013-03-03','08:35:00',7.02),('7643','2013-03-03','08:40:00',7.39),('7643','2013-03-03','08:45:00',7.75),('7643','2013-03-03','08:50:00',8.06),('7643','2013-03-03','08:55:00',8.37),('7643','2013-03-03','09:00:00',8.65),('7643','2013-03-03','09:05:00',8.97),('7643','2013-03-03','09:10:00',9.27),('7643','2013-03-03','09:15:00',9.52),('7643','2013-03-03','09:20:00',9.8),('7643','2013-03-03','09:25:00',10.1),('7643','2013-03-03','09:30:00',10.39),('7643','2013-03-03','09:35:00',10.62),('7643','2013-03-03','09:40:00',10.91),('7643','2013-03-03','09:45:00',11.11),('7643','2013-03-03','09:50:00',11.36),('7643','2013-03-03','09:55:00',11.6),('7643','2013-03-03','10:00:00',11.84),('7643','2013-03-03','10:05:00',12.03),('7643','2013-03-03','10:10:00',12.2),('7643','2013-03-03','10:17:00',12.36),('7643','2013-03-03','10:20:00',12.53),('7643','2013-03-03','10:25:00',12.78),('7643','2013-03-03','10:30:00',12.95),('7643','2013-03-03','10:35:00',13.12),('7643','2013-03-03','10:40:00',13.22),('7643','2013-03-03','10:45:00',13.32),('7643','2013-03-03','10:50:00',13.53),('7643','2013-03-03','10:55:00',13.72),('7643','2013-03-03','11:00:00',13.65),('7643','2013-03-03','11:05:00',13.7),('7643','2013-03-03','11:10:00',13.71),('7643','2013-03-03','11:15:00',13.85),('7643','2013-03-03','11:20:00',13.84),('7643','2013-03-03','11:25:00',14.05),('7643','2013-03-03','11:30:00',14.13),('7643','2013-03-03','11:35:00',14.22),('7643','2013-03-03','11:40:00',14.24),('7643','2013-03-03','11:45:00',14.28),('7643','2013-03-03','11:50:00',14.11),('7643','2013-03-03','11:55:00',14.42),('7643','2013-03-03','12:00:00',14.33),('7643','2013-03-03','12:05:00',14.16),('7643','2013-03-03','12:10:00',14.19),('7643','2013-03-03','12:15:00',14.4),('7643','2013-03-03','12:20:00',14.46),('7643','2013-03-03','12:25:00',14.42),('7643','2013-03-03','12:30:00',14.34),('7643','2013-03-03','12:35:00',14.38),('7643','2013-03-03','12:40:00',14.35),('7643','2013-03-03','12:45:00',14.18),('7643','2013-03-03','12:50:00',14.18),('7643','2013-03-03','12:55:00',14.12),('7643','2013-03-03','13:00:00',13.55),('7643','2013-03-03','13:05:00',13.56),('7643','2013-03-03','13:10:00',13.49),('7643','2013-03-03','13:15:00',13.52),('7643','2013-03-03','13:20:00',13.47),('7643','2013-03-03','13:25:00',12.17),('7643','2013-03-03','13:30:00',13.16),('7643','2013-03-03','13:35:00',13.73),('7643','2013-03-03','13:40:00',12.89),('7643','2013-03-03','13:45:00',11.91),('7643','2013-03-03','13:50:00',12.87),('7643','2013-03-03','13:55:00',12.57),('7643','2013-03-03','14:00:00',12.43),('7643','2013-03-03','14:05:00',12.21),('7643','2013-03-03','14:10:00',11.79),('7643','2013-03-03','14:15:00',11.64),('7643','2013-03-03','14:20:00',10.82),('7643','2013-03-03','14:25:00',7.93),('7643','2013-03-03','14:30:00',9.7),('7643','2013-03-03','14:35:00',10.69),('7643','2013-03-03','14:40:00',10.69),('7643','2013-03-03','14:45:00',10.34),('7643','2013-03-03','14:50:00',10.01),('7643','2013-03-03','14:55:00',10.08),('7643','2013-03-03','15:00:00',9.69),('7643','2013-03-03','15:05:00',9.26),('7643','2013-03-03','15:10:00',9.19),('7643','2013-03-03','15:15:00',8.76),('7643','2013-03-03','15:20:00',8.49),('7643','2013-03-03','15:25:00',8.05),('7643','2013-03-03','15:30:00',7.89),('7643','2013-03-03','15:35:00',7.65),('7643','2013-03-03','15:40:00',7.45),('7643','2013-03-03','15:45:00',7.09),('7643','2013-03-03','15:50:00',6.64),('7643','2013-03-03','15:55:00',6.3),('7643','2013-03-03','16:00:00',6.11),('7643','2013-03-03','16:05:00',5.81),('7643','2013-03-03','16:10:00',5.39),('7643','2013-03-03','16:15:00',5.06),('7643','2013-03-03','16:20:00',4.8),('7643','2013-03-03','16:25:00',4.61),('7643','2013-03-03','16:30:00',4.32),('7643','2013-03-03','16:35:00',3.98),('7643','2013-03-03','16:40:00',3.6),('7643','2013-03-03','16:45:00',3.24),('7643','2013-03-03','16:50:00',2.9),('7643','2013-03-03','16:55:00',2.55),('7643','2013-03-03','17:00:00',2.22),('7643','2013-03-03','17:05:00',1.88),('7643','2013-03-03','17:10:00',1.62),('7643','2013-03-03','17:15:00',1.35),('7643','2013-03-03','17:20:00',1.1),('7643','2013-03-02','07:15:00',1.3),('7643','2013-03-02','07:20:00',1.64),('7643','2013-03-02','07:25:00',1.98),('7643','2013-03-02','07:30:00',2.37),('7643','2013-03-02','07:35:00',2.74),('7643','2013-03-02','07:40:00',3.14),('7643','2013-03-02','07:45:00',3.54),('7643','2013-03-02','07:50:00',3.9),('7643','2013-03-02','07:55:00',4.3),('7643','2013-03-02','08:00:00',4.69),('7643','2013-03-02','08:05:00',5.08),('7643','2013-03-02','08:10:00',5.47),('7643','2013-03-02','08:15:00',5.87),('7643','2013-03-02','08:20:00',6.26),('7643','2013-03-02','08:25:00',6.66),('7643','2013-03-02','08:30:00',7.03),('7643','2013-03-02','08:35:00',7.4),('7643','2013-03-02','08:40:00',7.76),('7643','2013-03-02','08:45:00',8.1),('7643','2013-03-02','08:50:00',8.43),('7643','2013-03-02','08:55:00',8.76),('7643','2013-03-02','09:00:00',9.05),('7643','2013-03-02','09:05:00',9.34),('7643','2013-03-02','09:10:00',9.62),('7643','2013-03-02','09:15:00',9.88),('7643','2013-03-02','09:20:00',10.19),('7643','2013-03-02','09:25:00',10.46),('7643','2013-03-02','09:30:00',10.76),('7643','2013-03-02','09:35:00',11.02),('7643','2013-03-02','09:40:00',11.28),('7643','2013-03-02','09:45:00',11.62),('7643','2013-03-02','09:50:00',11.98),('7643','2013-03-02','09:55:00',12.26),('7643','2013-03-02','10:00:00',12.5),('7643','2013-03-02','10:05:00',12.74),('7643','2013-03-02','10:10:00',12.93),('7643','2013-03-02','10:15:00',13.06),('7643','2013-03-02','10:20:00',13.3),('7643','2013-03-02','10:25:00',13.56),('7643','2013-03-02','10:30:00',13.67),('7643','2013-03-02','10:35:00',13.8),('7643','2013-03-02','10:40:00',13.96),('7643','2013-03-02','10:45:00',14.07),('7643','2013-03-02','10:50:00',14.14),('7643','2013-03-02','10:55:00',14.21),('7643','2013-03-02','11:00:00',14.26),('7643','2013-03-02','11:05:00',14.32),('7643','2013-03-02','11:10:00',14.34),('7643','2013-03-02','11:15:00',14.47),('7643','2013-03-02','11:20:00',14.56),('7643','2013-03-02','11:25:00',14.56),('7643','2013-03-02','11:30:00',14.6),('7643','2013-03-02','11:35:00',14.62),('7643','2013-03-02','11:40:00',14.77),('7643','2013-03-02','11:45:00',14.8),('7643','2013-03-02','11:50:00',14.95),('7643','2013-03-02','11:55:00',14.82),('7643','2013-03-02','12:00:00',14.82),('7643','2013-03-02','12:05:00',14.8),('7643','2013-03-02','12:10:00',14.81),('7643','2013-03-02','12:15:00',14.74),('7643','2013-03-02','12:20:00',14.76),('7643','2013-03-02','12:25:00',14.68),('7643','2013-03-02','12:30:00',14.7),('7643','2013-03-02','12:35:00',14.7),('7643','2013-03-02','12:40:00',14.73),('7643','2013-03-02','12:45:00',14.67),('7643','2013-03-02','12:50:00',14.62),('7643','2013-03-02','12:55:00',14.55),('7643','2013-03-02','13:00:00',14.45),('7643','2013-03-02','13:05:00',14.37),('7643','2013-03-02','13:10:00',14.31),('7643','2013-03-02','13:15:00',14.16),('7643','2013-03-02','13:20:00',14.06),('7643','2013-03-02','13:25:00',14.07),('7643','2013-03-02','13:30:00',13.98),('7643','2013-03-02','13:35:00',13.8),('7643','2013-03-02','13:40:00',13.7),('7643','2013-03-02','13:45:00',13.55),('7643','2013-03-02','13:50:00',13.28),('7643','2013-03-02','13:55:00',13.18),('7643','2013-03-02','14:00:00',13),('7643','2013-03-02','14:05:00',12.76),('7643','2013-03-02','14:10:00',12.67),('7643','2013-03-02','14:15:00',12.53),('7643','2013-03-02','14:20:00',12.37),('7643','2013-03-02','14:25:00',12.08),('7643','2013-03-02','14:30:00',11.87),('7643','2013-03-02','14:35:00',11.65),('7643','2013-03-02','14:40:00',11.47),('7643','2013-03-02','14:45:00',11.21),('7643','2013-03-02','14:50:00',10.99),('7643','2013-03-02','14:55:00',10.69),('7643','2013-03-02','15:00:00',10.4),('7643','2013-03-02','15:05:00',10.12),('7643','2013-03-02','15:10:00',9.82),('7643','2013-03-02','15:15:00',9.61),('7643','2013-03-02','15:20:00',9.34),('7643','2013-03-02','15:25:00',9.06),('7643','2013-03-02','15:30:00',8.78),('7643','2013-03-02','15:35:00',8.47),('7643','2013-03-02','15:40:00',8.09),('7643','2013-03-02','15:45:00',7.78),('7643','2013-03-02','15:50:00',7.43),('7643','2013-03-02','15:55:00',7.1),('7643','2013-03-02','16:00:00',6.76),('7643','2013-03-02','16:05:00',6.39),('7643','2013-03-02','16:10:00',6.06),('7643','2013-03-02','16:15:00',5.67),('7643','2013-03-02','16:20:00',5.3),('7643','2013-03-02','16:25:00',4.95),('7643','2013-03-02','16:30:00',4.59),('7643','2013-03-02','16:35:00',4.19),('7643','2013-03-02','16:40:00',3.83),('7643','2013-03-02','16:45:00',3.45),('7643','2013-03-02','16:50:00',3.07),('7643','2013-03-02','16:55:00',2.71),('7643','2013-03-02','17:00:00',2.34),('7643','2013-03-02','17:05:00',2.01),('7643','2013-03-02','17:10:00',1.68),('7643','2013-03-02','17:15:00',1.37),('7643','2013-03-02','17:20:00',1.08),('7643','2014-03-23','07:05:00',1.67),('7643','2014-03-23','07:10:00',1.59),('7643','2014-03-23','07:30:00',1.56),('7643','2014-03-23','07:35:00',2.47),('7643','2014-03-23','07:40:00',1.85),('7643','2014-03-23','07:45:00',4.68),('7643','2014-03-23','07:50:00',3.28),('7643','2014-03-23','07:55:00',2.98),('7643','2014-03-23','08:00:00',1.47),('7643','2014-03-23','08:10:00',1.92),('7643','2014-03-23','08:15:00',1.17),('7643','2014-03-23','08:20:00',1.71),('7643','2014-03-23','08:25:00',1.26),('7643','2014-03-23','08:30:00',2.05),('7643','2014-03-23','08:35:00',3.19),('7643','2014-03-23','08:40:00',3.41),('7643','2014-03-23','08:45:00',2.83),('7643','2014-03-23','08:50:00',2.95),('7643','2014-03-23','08:55:00',6.33),('7643','2014-03-23','09:00:00',7.16),('7643','2014-03-23','09:05:00',5.93),('7643','2014-03-23','09:10:00',2.63),('7643','2014-03-23','09:15:00',3.6),('7643','2014-03-23','09:20:00',8.14),('7643','2014-03-23','09:25:00',3.29),('7643','2014-03-23','09:30:00',5.9),('7643','2014-03-23','09:35:00',3.48),('7643','2014-03-23','09:40:00',6.03),('7643','2014-03-23','09:45:00',4.51),('7643','2014-03-23','09:50:00',3.99),('7643','2014-03-23','09:55:00',2.52),('7643','2014-03-23','10:00:00',7.83),('7643','2014-03-23','10:05:00',9.26),('7643','2014-03-23','10:10:00',14.22),('7643','2014-03-23','10:15:00',10.91),('7643','2014-03-23','10:20:00',3.65),('7643','2014-03-23','10:25:00',2.96),('7643','2014-03-23','10:30:00',2.83),('7643','2014-03-23','10:35:00',5.5),('7643','2014-03-23','10:40:00',4.59),('7643','2014-03-23','10:45:00',6.67),('7643','2014-03-23','10:50:00',18.59),('7643','2014-03-23','10:55:00',15.16),('7643','2014-03-23','11:00:00',6.33),('7643','2014-03-23','11:05:00',10.32),('7643','2014-03-23','11:10:00',11.17),('7643','2014-03-23','11:15:00',11.3),('7643','2014-03-23','11:20:00',8.78),('7643','2014-03-23','11:25:00',10.31),('7643','2014-03-23','11:30:00',12.9),('7643','2014-03-23','11:35:00',7.26),('7643','2014-03-23','11:40:00',3.11),('7643','2014-03-23','11:45:00',2.39),('7643','2014-03-23','11:50:00',2.22),('7643','2014-03-23','11:55:00',2.88),('7643','2014-03-23','12:00:00',2.66),('7643','2014-03-23','12:05:00',1.44),('7643','2014-03-23','12:15:00',1.62),('7643','2014-03-23','12:20:00',2.3),('7643','2014-03-23','12:25:00',2.62),('7643','2014-03-23','12:30:00',4.04),('7643','2014-03-23','12:35:00',6.99),('7643','2014-03-23','12:40:00',7.55),('7643','2014-03-23','12:45:00',6.89),('7643','2014-03-23','12:50:00',5.76),('7643','2014-03-23','12:55:00',5.32),('7643','2014-03-23','13:00:00',5.43),('7643','2014-03-23','13:05:00',5.39),('7643','2014-03-23','13:10:00',4.81),('7643','2014-03-23','13:15:00',3.76),('7643','2014-03-23','13:20:00',3.63),('7643','2014-03-23','13:25:00',4.44),('7643','2014-03-23','13:30:00',5.3),('7643','2014-03-23','13:35:00',4.81),('7643','2014-03-23','13:40:00',2.61),('7643','2014-03-23','13:45:00',3.08),('7643','2014-03-23','13:50:00',5.1),('7643','2014-03-23','13:55:00',5),('7643','2014-03-23','14:00:00',4.65),('7643','2014-03-23','14:05:00',4),('7643','2014-03-23','14:10:00',4.72),('7643','2014-03-23','14:15:00',6.2),('7643','2014-03-23','14:20:00',8.14),('7643','2014-03-23','14:25:00',7.98),('7643','2014-03-23','14:30:00',7.09),('7643','2014-03-23','14:35:00',8.92),('7643','2014-03-23','14:40:00',11.21),('7643','2014-03-23','14:45:00',13.06),('7643','2014-03-23','14:50:00',13.61),('7643','2014-03-23','14:55:00',11.97),('7643','2014-03-23','15:00:00',10.87),('7643','2014-03-23','15:05:00',9.59),('7643','2014-03-23','15:10:00',8.51),('7643','2014-03-23','15:15:00',5.72),('7643','2014-03-23','15:20:00',6.55),('7643','2014-03-23','15:25:00',5.73),('7643','2014-03-23','15:30:00',6.52),('7643','2014-03-23','15:35:00',5.52),('7643','2014-03-23','15:40:00',4.91),('7643','2014-03-23','15:45:00',4.15),('7643','2014-03-23','15:50:00',4.89),('7643','2014-03-23','15:55:00',5.93),('7643','2014-03-23','16:00:00',10.94),('7643','2014-03-23','16:05:00',5.19),('7643','2014-03-23','16:10:00',4.4),('7643','2014-03-23','16:15:00',3.52),('7643','2014-03-23','16:20:00',2.25),('7643','2014-03-23','17:30:00',1.25),('7643','2014-03-23','17:35:00',1.34),('7643','2014-03-23','17:40:00',1.26),('7643','2014-03-23','17:45:00',1.11),('7643','2013-03-01','07:40:00',1.01),('7643','2013-03-01','07:45:00',1.01),('7643','2013-03-01','07:50:00',1.12),('7643','2013-03-01','07:55:00',1.22),('7643','2013-03-01','08:00:00',1.42),('7643','2013-03-01','08:05:00',1.44),('7643','2013-03-01','08:10:00',1.21),('7643','2013-03-01','08:15:00',1.02),('7643','2013-03-01','08:20:00',1.04),('7643','2013-03-01','08:25:00',1.13),('7643','2013-03-01','08:30:00',1.38),('7643','2013-03-01','08:35:00',1.52),('7643','2013-03-01','08:40:00',1.54),('7643','2013-03-01','08:45:00',1.79),('7643','2013-03-01','08:50:00',1.92),('7643','2013-03-01','08:55:00',1.97),('7643','2013-03-01','09:00:00',2.07),('7643','2013-03-01','09:05:00',1.73),('7643','2013-03-01','09:10:00',1.32),('7643','2013-03-01','09:15:00',1.21),('7643','2013-03-01','09:20:00',1.52),('7643','2013-03-01','09:25:00',1.5),('7643','2013-03-01','09:30:00',1.52),('7643','2013-03-01','09:35:00',1.7),('7643','2013-03-01','09:40:00',2.2),('7643','2013-03-01','09:45:00',2.44),('7643','2013-03-01','09:50:00',2.57),('7643','2013-03-01','09:55:00',2.22),('7643','2013-03-01','10:00:00',2.23),('7643','2013-03-01','10:05:00',2.24),('7643','2013-03-01','10:10:00',2.03),('7643','2013-03-01','10:15:00',2.2),('7643','2013-03-01','10:20:00',2.58),('7643','2013-03-01','10:25:00',2.58),('7643','2013-03-01','10:30:00',2.72),('7643','2013-03-01','10:35:00',3.11),('7643','2013-03-01','10:40:00',3.43),('7643','2013-03-01','10:45:00',3.41),('7643','2013-03-01','10:50:00',3.79),('7643','2013-03-01','10:55:00',4),('7643','2013-03-01','11:00:00',4.19),('7643','2013-03-01','11:05:00',4.1),('7643','2013-03-01','11:10:00',4.56),('7643','2013-03-01','11:15:00',5.14),('7643','2013-03-01','11:20:00',4.59),('7643','2013-03-01','11:25:00',3.98),('7643','2013-03-01','11:30:00',3.71),('7643','2013-03-01','11:35:00',3.9),('7643','2013-03-01','11:40:00',4.35),('7643','2013-03-01','11:45:00',3.94),('7643','2013-03-01','11:50:00',3.97),('7643','2013-03-01','11:55:00',3.69),('7643','2013-03-01','12:00:00',3.68),('7643','2013-03-01','12:05:00',4.3),('7643','2013-03-01','12:10:00',4.4),('7643','2013-03-01','12:15:00',4.51),('7643','2013-03-01','12:20:00',4.12),('7643','2013-03-01','12:25:00',4.43),('7643','2013-03-01','12:30:00',4.61),('7643','2013-03-01','12:35:00',5.19),('7643','2013-03-01','12:40:00',5.36),('7643','2013-03-01','12:45:00',4.94),('7643','2013-03-01','12:50:00',4.77),('7643','2013-03-01','12:55:00',5.59),('7643','2013-03-01','13:00:00',5.46),('7643','2013-03-01','13:05:00',4.89),('7643','2013-03-01','13:10:00',4.1),('7643','2013-03-01','13:15:00',3.52),('7643','2013-03-01','13:20:00',3.33),('7643','2013-03-01','13:25:00',3.24),('7643','2013-03-01','13:30:00',3.47),('7643','2013-03-01','13:35:00',3.47),('7643','2013-03-01','13:40:00',3.76),('7643','2013-03-01','13:45:00',4.16),('7643','2013-03-01','13:50:00',4.02),('7643','2013-03-01','13:55:00',4.3),('7643','2013-03-01','14:00:00',4.98),('7643','2013-03-01','14:05:00',4.97),('7643','2013-03-01','14:10:00',4.22),('7643','2013-03-01','14:15:00',3.72),('7643','2013-03-01','14:20:00',3.55),('7643','2013-03-01','14:25:00',3.04),('7643','2013-03-01','14:30:00',2.06),('7643','2013-03-01','14:35:00',1.59),('7643','2013-03-01','14:40:00',1.63),('7643','2013-03-01','14:45:00',1.72),('7643','2013-03-01','14:50:00',2.36),('7643','2013-03-01','14:55:00',2.6),('7643','2013-03-01','15:00:00',2.67),('7643','2013-03-01','15:05:00',3),('7643','2013-03-01','15:10:00',2.89),('7643','2013-03-01','15:15:00',2.91),('7643','2013-03-01','15:20:00',2.77),('7643','2013-03-01','15:25:00',2.66),('7643','2013-03-01','15:30:00',3.01),('7643','2013-03-01','15:35:00',2.95),('7643','2013-03-01','15:40:00',2.89),('7643','2013-03-01','15:45:00',3.14),('7643','2013-03-01','15:50:00',2.68),('7643','2013-03-01','15:55:00',2.56),('7643','2013-03-01','16:00:00',2.33),('7643','2013-03-01','16:05:00',2.07),('7643','2013-03-01','16:10:00',1.76),('7643','2013-03-01','16:15:00',1.89),('7643','2013-03-01','16:20:00',1.69),('7643','2013-03-01','16:25:00',1.54),('7643','2013-03-01','16:30:00',1.5),('7643','2013-03-01','16:35:00',1.17),('7643','2013-03-01','16:40:00',1.28),('7643','2013-03-01','17:05:00',1.01),('7643','2013-03-01','17:10:00',1.05),('7643','2013-02-28','07:15:00',1.11),('7643','2013-02-28','07:20:00',1.19),('7643','2013-02-28','07:25:00',1.29),('7643','2013-02-28','07:30:00',1.37),('7643','2013-02-28','07:35:00',1.55),('7643','2013-02-28','07:40:00',1.87),('7643','2013-02-28','07:45:00',2.21),('7643','2013-02-28','07:50:00',2.6),('7643','2013-02-28','07:55:00',3.52),('7643','2013-02-28','08:00:00',3.96),('7643','2013-02-28','08:05:00',4.14),('7643','2013-02-28','08:10:00',4.1),('7643','2013-02-28','08:15:00',4.37),('7643','2013-02-28','08:20:00',4.67),('7643','2013-02-28','08:25:00',4.67),('7643','2013-02-28','08:30:00',5.02),('7643','2013-02-28','08:35:00',5.41),('7643','2013-02-28','08:40:00',5.84),('7643','2013-02-28','08:45:00',6.17),('7643','2013-02-28','08:50:00',6.4),('7643','2013-02-28','08:55:00',6.95),('7643','2013-02-28','09:00:00',7.37),('7643','2013-02-28','09:05:00',8.05),('7643','2013-02-28','09:10:00',8.03),('7643','2013-02-28','09:15:00',8.11),('7643','2013-02-28','09:20:00',8.37),('7643','2013-02-28','09:25:00',8.09),('7643','2013-02-28','09:30:00',8.95),('7643','2013-02-28','09:35:00',8.8),('7643','2013-02-28','09:40:00',9.54),('7643','2013-02-28','09:45:00',10.07),('7643','2013-02-28','09:50:00',9.97),('7643','2013-02-28','09:55:00',9.98),('7643','2013-02-28','10:00:00',10.3),('7643','2013-02-28','10:05:00',10.38),('7643','2013-02-28','10:10:00',10.07),('7643','2013-02-28','10:15:00',8.56),('7643','2013-02-28','10:20:00',8.53),('7643','2013-02-28','10:25:00',9.04),('7643','2013-02-28','10:30:00',10.12),('7643','2013-02-28','10:35:00',10.55),('7643','2013-02-28','10:40:00',9.61),('7643','2013-02-28','10:45:00',8.98),('7643','2013-02-28','10:50:00',8.35),('7643','2013-02-28','10:55:00',7.82),('7643','2013-02-28','11:00:00',6.82),('7643','2013-02-28','11:05:00',5.92),('7643','2013-02-28','11:10:00',5.73),('7643','2013-02-28','11:15:00',6.47),('7643','2013-02-28','11:20:00',6.8),('7643','2013-02-28','11:25:00',6.77),('7643','2013-02-28','11:30:00',6.94),('7643','2013-02-28','11:35:00',6.98),('7643','2013-02-28','11:40:00',6.56),('7643','2013-02-28','11:45:00',6.25),('7643','2013-02-28','11:50:00',6.2),('7643','2013-02-28','11:55:00',5.91),('7643','2013-02-28','12:00:00',5.64),('7643','2013-02-28','12:05:00',5.37),('7643','2013-02-28','12:10:00',4.98),('7643','2013-02-28','12:15:00',4.51),('7643','2013-02-28','12:20:00',4.23),('7643','2013-02-28','12:25:00',4.19),('7643','2013-02-28','12:30:00',4.32),('7643','2013-02-28','12:35:00',4.29),('7643','2013-02-28','12:40:00',4.14),('7643','2013-02-28','12:45:00',4.14),('7643','2013-02-28','12:50:00',4.23),('7643','2013-02-28','12:55:00',4.48),('7643','2013-02-28','13:00:00',4.76),('7643','2013-02-28','13:05:00',4.82),('7643','2013-02-28','13:10:00',5),('7643','2013-02-28','13:15:00',5.36),('7643','2013-02-28','13:20:00',5.8),('7643','2013-02-28','13:25:00',6.35),('7643','2013-02-28','13:30:00',6.2),('7643','2013-02-28','13:35:00',5.76),('7643','2013-02-28','13:40:00',5.47),('7643','2013-02-28','13:45:00',5.42),('7643','2013-02-28','13:50:00',5.38),('7643','2013-02-28','13:55:00',5.16),('7643','2013-02-28','14:00:00',4.98),('7643','2013-02-28','14:05:00',4.76),('7643','2013-02-28','14:10:00',4.47),('7643','2013-02-28','14:15:00',4.22),('7643','2013-02-28','14:20:00',4.07),('7643','2013-02-28','14:25:00',4.09),('7643','2013-02-28','14:30:00',4.2),('7643','2013-02-28','14:35:00',4.22),('7643','2013-02-28','14:40:00',4.02),('7643','2013-02-28','14:45:00',3.75),('7643','2013-02-28','14:50:00',3.55),('7643','2013-02-28','14:55:00',3.51),('7643','2013-02-28','15:00:00',3.52),('7643','2013-02-28','15:05:00',3.39),('7643','2013-02-28','15:10:00',3.09),('7643','2013-02-28','15:15:00',2.84),('7643','2013-02-28','15:20:00',2.67),('7643','2013-02-28','15:25:00',2.37),('7643','2013-02-28','15:30:00',2.13),('7643','2013-02-28','15:35:00',2.16),('7643','2013-02-28','15:40:00',2.38),('7643','2013-02-28','15:45:00',2.36),('7643','2013-02-28','15:50:00',2.22),('7643','2013-02-28','15:55:00',2.16),('7643','2013-02-28','16:00:00',2.18),('7643','2013-02-28','16:05:00',2.17),('7643','2013-02-28','16:10:00',2.06),('7643','2013-02-28','16:15:00',1.87),('7643','2013-02-28','16:20:00',1.58),('7643','2013-02-28','16:25:00',1.35),('7643','2013-02-28','16:30:00',1.25),('7643','2013-02-28','16:35:00',1.17),('7643','2013-02-28','16:40:00',1.08),('7643','2013-02-27','07:20:00',1.04),('7643','2013-02-27','07:25:00',1.31),('7643','2013-02-27','07:30:00',1.6),('7643','2013-02-27','07:35:00',1.92),('7643','2013-02-27','07:40:00',2.24),('7643','2013-02-27','07:45:00',2.58),('7643','2013-02-27','07:50:00',2.95),('7643','2013-02-27','07:55:00',3.31),('7643','2013-02-27','08:00:00',3.63),('7643','2013-02-27','08:05:00',4),('7643','2013-02-27','08:10:00',4.34),('7643','2013-02-27','08:15:00',4.7),('7643','2013-02-27','08:20:00',5.06),('7643','2013-02-27','08:25:00',5.39),('7643','2013-02-27','08:30:00',5.73),('7643','2013-02-27','08:35:00',6.07),('7643','2013-02-27','08:40:00',6.51),('7643','2013-02-27','08:45:00',6.92),('7643','2013-02-27','08:50:00',7.32),('7643','2013-02-27','08:55:00',7.71),('7643','2013-02-27','09:00:00',8.06),('7643','2013-02-27','09:05:00',8.32),('7643','2013-02-27','09:10:00',8.52),('7643','2013-02-27','09:15:00',8.78),('7643','2013-02-27','09:20:00',9.18),('7643','2013-02-27','09:25:00',9.43),('7643','2013-02-27','09:30:00',9.77),('7643','2013-02-27','09:35:00',10.05),('7643','2013-02-27','09:40:00',10.3),('7643','2013-02-27','09:45:00',10.55),('7643','2013-02-27','09:50:00',9.99),('7643','2013-02-27','09:55:00',10.85),('7643','2013-02-27','10:00:00',11.09),('7643','2013-02-27','10:05:00',11.22),('7643','2013-02-27','10:10:00',11.38),('7643','2013-02-27','10:15:00',11.56),('7643','2013-02-27','10:20:00',11.81),('7643','2013-02-27','10:25:00',11.77),('7643','2013-02-27','10:30:00',11.92),('7643','2013-02-27','10:35:00',12.3),('7643','2013-02-27','10:40:00',12.55),('7643','2013-02-27','10:45:00',12.74),('7643','2013-02-27','10:50:00',12.79),('7643','2013-02-27','10:55:00',12.89),('7643','2013-02-27','11:00:00',13.01),('7643','2013-02-27','11:05:00',13.35),('7643','2013-02-27','11:10:00',13.16),('7643','2013-02-27','11:15:00',13.32),('7643','2013-02-27','11:20:00',13.68),('7643','2013-02-27','11:25:00',13.85),('7643','2013-02-27','11:30:00',13.87),('7643','2013-02-27','11:35:00',13.69),('7643','2013-02-27','11:40:00',13.66),('7643','2013-02-27','11:45:00',13.83),('7643','2013-02-27','11:50:00',13.69),('7643','2013-02-27','11:55:00',13.12),('7643','2013-02-27','12:00:00',12.97),('7643','2013-02-27','12:05:00',13.5),('7643','2013-02-27','12:10:00',13.96),('7643','2013-02-27','12:15:00',14.01),('7643','2013-02-27','12:20:00',13.9),('7643','2013-02-27','12:25:00',13.63),('7643','2013-02-27','12:30:00',12.95),('7643','2013-02-27','12:35:00',13.32),('7643','2013-02-27','12:40:00',13.68),('7643','2013-02-27','12:45:00',13.68),('7643','2013-02-27','12:50:00',13.64),('7643','2013-02-27','12:55:00',13.76),('7643','2013-02-27','13:00:00',13.15),('7643','2013-02-27','13:05:00',13.48),('7643','2013-02-27','13:10:00',13.47),('7643','2013-02-27','13:15:00',13.59),('7643','2013-02-27','13:20:00',13.67),('7643','2013-02-27','13:25:00',13.52),('7643','2013-02-27','13:30:00',12.88),('7643','2013-02-27','13:35:00',13.17),('7643','2013-02-27','13:40:00',12.99),('7643','2013-02-27','13:45:00',13.16),('7643','2013-02-27','13:50:00',13.23),('7643','2013-02-27','13:55:00',13.66),('7643','2013-02-27','14:00:00',13.7),('7643','2013-02-27','14:05:00',13.2),('7643','2013-02-27','14:10:00',13.08),('7643','2013-02-27','14:15:00',12.57),('7643','2013-02-27','14:20:00',11.58),('7643','2013-02-27','14:25:00',11.13),('7643','2013-02-27','14:30:00',10.69),('7643','2013-02-27','14:35:00',10.12),('7643','2013-02-27','14:40:00',10.49),('7643','2013-02-27','14:45:00',10.33),('7643','2013-02-27','14:50:00',9.92),('7643','2013-02-27','14:55:00',9.65),('7643','2013-02-27','15:00:00',9.5),('7643','2013-02-27','15:05:00',8.99),('7643','2013-02-27','15:10:00',8.72),('7643','2013-02-27','15:15:00',8.57),('7643','2013-02-27','15:20:00',8.42),('7643','2013-02-27','15:25:00',7.83),('7643','2013-02-27','15:30:00',7.23),('7643','2013-02-27','15:35:00',6.94),('7643','2013-02-27','15:40:00',6.68),('7643','2013-02-27','15:45:00',6.48),('7643','2013-02-27','15:50:00',6.28),('7643','2013-02-27','15:55:00',5.96),('7643','2013-02-27','16:00:00',5.65),('7643','2013-02-27','16:05:00',5.26),('7643','2013-02-27','16:10:00',4.93),('7643','2013-02-27','16:15:00',4.63),('7643','2013-02-27','16:20:00',4.24),('7643','2013-02-27','16:25:00',3.96),('7643','2013-02-27','16:30:00',3.59),('7643','2013-02-27','16:35:00',3.44),('7643','2013-02-27','16:40:00',3.15),('7643','2013-02-27','16:45:00',2.86),('7643','2013-02-27','16:50:00',2.58),('7643','2013-02-27','16:55:00',2.28),('7643','2013-02-27','17:00:00',1.96),('7643','2013-02-27','17:05:00',1.63),('7643','2013-02-27','17:10:00',1.31),('7643','2013-02-27','17:15:00',1.05),('7643','2013-02-26','07:25:00',1.25),('7643','2013-02-26','07:30:00',1.52),('7643','2013-02-26','07:35:00',1.79),('7643','2013-02-26','07:40:00',2.09),('7643','2013-02-26','07:45:00',2.42),('7643','2013-02-26','07:50:00',2.74),('7643','2013-02-26','07:55:00',3.11),('7643','2013-02-26','08:00:00',3.51),('7643','2013-02-26','08:05:00',3.84),('7643','2013-02-26','08:10:00',4.17),('7643','2013-02-26','08:15:00',4.53),('7643','2013-02-26','08:20:00',4.93),('7643','2013-02-26','08:25:00',5.33),('7643','2013-02-26','08:30:00',5.7),('7643','2013-02-26','08:35:00',6.08),('7643','2013-02-26','08:40:00',6.32),('7643','2013-02-26','08:45:00',6.66),('7643','2013-02-26','08:50:00',7.03),('7643','2013-02-26','08:55:00',7.34),('7643','2013-02-26','09:00:00',7.68),('7643','2013-02-26','09:05:00',8.12),('7643','2013-02-26','09:10:00',8.39),('7643','2013-02-26','09:15:00',8.62),('7643','2013-02-26','09:20:00',8.92),('7643','2013-02-26','09:25:00',9.25),('7643','2013-02-26','09:30:00',9.48),('7643','2013-02-26','09:35:00',9.76),('7643','2013-02-26','09:40:00',10.01),('7643','2013-02-26','09:45:00',10.29),('7643','2013-02-26','09:50:00',10.49),('7643','2013-02-26','09:55:00',10.7),('7643','2013-02-26','10:00:00',10.94),('7643','2013-02-26','10:05:00',11.14),('7643','2013-02-26','10:10:00',11.32),('7643','2013-02-26','10:15:00',11.57),('7643','2013-02-26','10:20:00',11.8),('7643','2013-02-26','10:25:00',11.9),('7643','2013-02-26','10:30:00',12.03),('7643','2013-02-26','10:35:00',12.4),('7643','2013-02-26','10:40:00',12.32),('7643','2013-02-26','10:45:00',12.53),('7643','2013-02-26','10:50:00',12.61),('7643','2013-02-26','10:55:00',12.89),('7643','2013-02-26','11:00:00',12.94),('7643','2013-02-26','11:05:00',12.94),('7643','2013-02-26','11:10:00',12.84),('7643','2013-02-26','11:15:00',13.06),('7643','2013-02-26','11:20:00',12.68),('7643','2013-02-26','11:25:00',13.61),('7643','2013-02-26','11:30:00',13.91),('7643','2013-02-26','11:35:00',11.65),('7643','2013-02-26','11:40:00',10.32),('7643','2013-02-26','11:45:00',6.51),('7643','2013-02-26','11:50:00',5.95),('7643','2013-02-26','11:55:00',9.16),('7643','2013-02-26','12:00:00',4.68),('7643','2013-02-26','12:05:00',15.17),('7643','2013-02-26','12:10:00',14.5),('7643','2013-02-26','12:15:00',6.94),('7643','2013-02-26','12:20:00',15.07),('7643','2013-02-26','12:25:00',15.22),('7643','2013-02-26','12:30:00',14.23),('7643','2013-02-26','12:35:00',14.18),('7643','2013-02-26','12:40:00',14.49),('7643','2013-02-26','12:45:00',14.01),('7643','2013-02-26','12:50:00',14.12),('7643','2013-02-26','12:55:00',13.72),('7643','2013-02-26','13:00:00',13.9),('7643','2013-02-26','13:05:00',14.05),('7643','2013-02-26','13:10:00',13.94),('7643','2013-02-26','13:15:00',13.29),('7643','2013-02-26','13:20:00',9.73),('7643','2013-02-26','13:25:00',10.14),('7643','2013-02-26','13:30:00',10.78),('7643','2013-02-26','13:35:00',13.82),('7643','2013-02-26','13:40:00',13.87),('7643','2013-02-26','13:45:00',13.51),('7643','2013-02-26','13:50:00',12.86),('7643','2013-02-26','13:55:00',10.09),('7643','2013-02-26','14:00:00',8.91),('7643','2013-02-26','14:05:00',8.94),('7643','2013-02-26','14:10:00',10.48),('7643','2013-02-26','14:15:00',10.09),('7643','2013-02-26','14:20:00',9.3),('7643','2013-02-26','14:25:00',8.81),('7643','2013-02-26','14:30:00',10.87),('7643','2013-02-26','14:35:00',11.07),('7643','2013-02-26','14:40:00',10.72),('7643','2013-02-26','14:45:00',10.88),('7643','2013-02-26','14:50:00',10.33),('7643','2013-02-26','14:55:00',9.36),('7643','2013-02-26','15:00:00',9.91),('7643','2013-02-26','15:05:00',9.72),('7643','2013-02-26','15:10:00',9.28),('7643','2013-02-26','15:15:00',8.94),('7643','2013-02-26','15:20:00',8.38),('7643','2013-02-26','15:25:00',8.33),('7643','2013-02-26','15:30:00',8.19),('7643','2013-02-26','15:35:00',7.79),('7643','2013-02-26','15:40:00',7.38),('7643','2013-02-26','15:45:00',7.05),('7643','2013-02-26','15:50:00',6.82),('7643','2013-02-26','15:55:00',6.51),('7643','2013-02-26','16:00:00',6.18),('7643','2013-02-26','16:05:00',5.81),('7643','2013-02-26','16:10:00',5.44),('7643','2013-02-26','16:15:00',5.04),('7643','2013-02-26','16:20:00',4.74),('7643','2013-02-26','16:25:00',4.42),('7643','2013-02-26','16:30:00',3.96),('7643','2013-02-26','16:35:00',3.6),('7643','2013-02-26','16:40:00',3.26),('7643','2013-02-26','16:45:00',2.91),('7643','2013-02-26','16:50:00',2.6),('7643','2013-02-26','16:55:00',2.27),('7643','2013-02-26','17:00:00',1.92),('7643','2013-02-26','17:05:00',1.65),('7643','2013-02-26','17:10:00',1.38),('7643','2013-02-26','17:15:00',1.16),('7643','2013-02-25','08:15:00',1.13),('7643','2013-02-25','08:20:00',1.26),('7643','2013-02-25','08:25:00',1.3),('7643','2013-02-25','08:30:00',1.36),('7643','2013-02-25','08:35:00',1.52),('7643','2013-02-25','08:40:00',1.72),('7643','2013-02-25','08:45:00',1.92),('7643','2013-02-25','08:50:00',2.23),('7643','2013-02-25','08:55:00',2.6),('7643','2013-02-25','09:00:00',2.87),('7643','2013-02-25','09:05:00',3.06),('7643','2013-02-25','09:10:00',3.35),('7643','2013-02-25','09:15:00',3.58),('7643','2013-02-25','09:20:00',3.9),('7643','2013-02-25','09:25:00',4.3),('7643','2013-02-25','09:30:00',5.3),('7643','2013-02-25','09:35:00',6.63),('7643','2013-02-25','09:40:00',7.2),('7643','2013-02-25','09:45:00',7.15),('7643','2013-02-25','09:50:00',7.56),('7643','2013-02-25','09:55:00',8.17),('7643','2013-02-25','10:00:00',7.75),('7643','2013-02-25','10:05:00',7.72),('7643','2013-02-25','10:10:00',9.01),('7643','2013-02-25','10:15:00',10.58),('7643','2013-02-25','10:20:00',12.52),('7643','2013-02-25','10:25:00',13.55),('7643','2013-02-25','10:30:00',13.31),('7643','2013-02-25','10:35:00',12.07),('7643','2013-02-25','10:40:00',6.41),('7643','2013-02-25','10:45:00',5.6),('7643','2013-02-25','10:50:00',6.52),('7643','2013-02-25','10:55:00',6.75),('7643','2013-02-25','11:00:00',8.37),('7643','2013-02-25','11:05:00',7.64),('7643','2013-02-25','11:10:00',7.03),('7643','2013-02-25','11:15:00',6.68),('7643','2013-02-25','11:20:00',6.63),('7643','2013-02-25','11:25:00',6.1),('7643','2013-02-25','11:30:00',5.79),('7643','2013-02-25','11:35:00',5.62),('7643','2013-02-25','11:40:00',5.97),('7643','2013-02-25','11:45:00',6.07),('7643','2013-02-25','11:51:00',6.63),('7643','2013-02-25','11:55:00',6.65),('7643','2013-02-25','12:00:00',6.25),('7643','2013-02-25','12:05:00',5.97),('7643','2013-02-25','12:10:00',6.17),('7643','2013-02-25','12:15:00',5.54),('7643','2013-02-25','12:20:00',5.47),('7643','2013-02-25','12:25:00',4.99),('7643','2013-02-25','12:30:00',4.91),('7643','2013-02-25','12:35:00',4.53),('7643','2013-02-25','12:40:00',4.19),('7643','2013-02-25','12:45:00',3.74),('7643','2013-02-25','12:50:00',3.43),('7643','2013-02-25','12:55:00',3.72),('7643','2013-02-25','13:00:00',3.69),('7643','2013-02-25','13:05:00',3.25),('7643','2013-02-25','13:10:00',2.98),('7643','2013-02-25','13:15:00',3.29),('7643','2013-02-25','13:20:00',3.56),('7643','2013-02-25','13:25:00',3.69),('7643','2013-02-25','13:30:00',3.82),('7643','2013-02-25','13:35:00',3.84),('7643','2013-02-25','13:40:00',3.79),('7643','2013-02-25','13:45:00',3.35),('7643','2013-02-25','13:50:00',3.22),('7643','2013-02-25','13:55:00',3.18),('7643','2013-02-25','14:00:00',2.84),('7643','2013-02-25','14:05:00',2.59),('7643','2013-02-25','14:10:00',2.7),('7643','2013-02-25','14:15:00',3.07),('7643','2013-02-25','14:20:00',1.65),('7643','2013-02-25','14:25:00',1.19),('7643','2013-02-25','15:55:00',1.14),('7643','2013-02-25','16:00:00',1.22),('7643','2013-02-25','16:05:00',1.23),('7643','2013-02-25','16:10:00',1.24),('7643','2013-02-25','16:15:00',1.27),('7643','2013-02-25','16:20:00',1.28),('7643','2013-02-25','16:25:00',1.26),('7643','2013-02-25','16:30:00',1.22),('7643','2013-02-25','16:35:00',1.11),('7643','2013-02-25','16:40:00',1.04),('7643','2013-02-25','16:45:00',1.04),('7643','2013-02-24','08:30:00',1.35),('7643','2013-02-24','08:35:00',2.44),('7643','2013-02-24','08:40:00',4.18),('7643','2013-02-24','08:45:00',4.07),('7643','2013-02-24','08:50:00',4.45),('7643','2013-02-24','08:55:00',3.41),('7643','2013-02-24','09:00:00',5.22),('7643','2013-02-24','09:05:00',3.03),('7643','2013-02-24','09:10:00',3.28),('7643','2013-02-24','09:15:00',3.34),('7643','2013-02-24','09:20:00',3.73),('7643','2013-02-24','09:25:00',5.14),('7643','2013-02-24','09:30:00',5.54),('7643','2013-02-24','09:35:00',5.53),('7643','2013-02-24','09:40:00',4.08),('7643','2013-02-24','09:45:00',2.92),('7643','2013-02-24','09:50:00',2.51),('7643','2013-02-24','09:55:00',1.44),('7643','2013-02-24','10:20:00',1.11),('7643','2013-02-24','10:25:00',1.74),('7643','2013-02-24','10:30:00',1.72),('7643','2013-02-24','10:35:00',1.83),('7643','2013-02-24','10:40:00',3.06),('7643','2013-02-24','10:45:00',6.58),('7643','2013-02-24','10:50:00',11.73),('7643','2013-02-24','10:55:00',17.51),('7643','2013-02-24','11:00:00',17.29),('7643','2013-02-24','11:05:00',9.97),('7643','2013-02-24','11:10:00',7.95),('7643','2013-02-24','11:15:00',6.6),('7643','2013-02-24','11:20:00',4.26),('7643','2013-02-24','11:25:00',3.97),('7643','2013-02-24','11:30:00',5.25),('7643','2013-02-24','11:35:00',4.58),('7643','2013-02-24','11:40:00',5.08),('7643','2013-02-24','11:45:00',6.69),('7643','2013-02-24','11:50:00',11.03),('7643','2013-02-24','11:55:00',17.69),('7643','2013-02-24','12:00:00',8.71),('7643','2013-02-24','12:05:00',8.35),('7643','2013-02-24','12:10:00',7.6),('7643','2013-02-24','12:15:00',10.92),('7643','2013-02-24','12:20:00',17.14),('7643','2013-02-24','12:25:00',16.58),('7643','2013-02-24','12:30:00',14.46),('7643','2013-02-24','12:35:00',14.9),('7643','2013-02-24','12:40:00',15.68),('7643','2013-02-24','12:45:00',15.02),('7643','2013-02-24','12:50:00',14.46),('7643','2013-02-24','12:55:00',14.25),('7643','2013-02-24','13:00:00',14.7),('7643','2013-02-24','13:05:00',9.46),('7643','2013-02-24','13:10:00',9.65),('7643','2013-02-24','13:15:00',12.05),('7643','2013-02-24','13:20:00',9.06),('7643','2013-02-24','13:25:00',6.56),('7643','2013-02-24','13:30:00',5.93),('7643','2013-02-24','13:35:00',4.33),('7643','2013-02-24','13:40:00',3.74),('7643','2013-02-24','13:45:00',3.4),('7643','2013-02-24','13:50:00',3.54),('7643','2013-02-24','13:55:00',2.97),('7643','2013-02-24','14:00:00',2.44),('7643','2013-02-24','14:05:00',1.74),('7643','2013-02-24','14:10:00',1.49),('7643','2013-02-24','14:15:00',1.44),('7643','2013-02-24','14:20:00',1.43),('7643','2013-02-24','14:25:00',1.46),('7643','2013-02-24','14:30:00',2.16),('7643','2013-02-24','14:35:00',2.98),('7643','2013-02-24','14:40:00',3.32),('7643','2013-02-24','14:45:00',3.02),('7643','2013-02-24','14:50:00',2.96),('7643','2013-02-24','14:55:00',2.91),('7643','2013-02-24','15:00:00',2.86),('7643','2013-02-24','15:05:00',2.91),('7643','2013-02-24','15:10:00',2.74),('7643','2013-02-24','15:15:00',2.61),('7643','2013-02-24','15:20:00',2.37),('7643','2013-02-24','15:25:00',1.81),('7643','2013-02-24','15:30:00',1.19),('7643','2013-02-24','15:45:00',1.39),('7643','2013-02-24','15:50:00',1.96),('7643','2013-02-24','15:55:00',2.33),('7643','2013-02-24','16:00:00',2.38),('7643','2013-02-24','16:05:00',2.19),('7643','2013-02-24','16:10:00',1.93),('7643','2013-02-24','16:15:00',1.41),('7643','2013-02-24','16:20:00',1.09),('7643','2013-02-24','16:25:00',1.48),('7643','2013-02-24','16:30:00',2.15),('7643','2013-02-24','16:35:00',2.66),('7643','2013-02-24','16:40:00',2.39),('7643','2013-02-24','16:45:00',2.23),('7643','2013-02-24','16:50:00',2.08),('7643','2013-02-24','16:55:00',2.91),('7643','2013-02-24','17:00:00',2.47),('7643','2013-02-24','17:05:00',1.94),('7643','2013-02-24','17:10:00',1.56),('7643','2013-02-24','17:15:00',1.22),('7643','2013-02-23','07:50:00',1.31),('7643','2013-02-23','07:55:00',1.85),('7643','2013-02-23','08:00:00',2.85),('7643','2013-02-23','08:05:00',3.3),('7643','2013-02-23','08:10:00',1.39),('7643','2013-02-23','08:16:00',1.78),('7643','2013-02-23','08:20:00',2.07),('7643','2013-02-23','08:25:00',2.33),('7643','2013-02-23','08:30:00',1.96),('7643','2013-02-23','08:35:00',1.79),('7643','2013-02-23','08:40:00',1.32),('7643','2013-02-23','08:45:00',2.4),('7643','2013-02-23','08:50:00',2.59),('7643','2013-02-23','08:55:00',2.92),('7643','2013-02-23','09:00:00',2.13),('7643','2013-02-23','09:05:00',1.69),('7643','2013-02-23','09:10:00',1.4),('7643','2013-02-23','09:25:00',1.36),('7643','2013-02-23','09:30:00',1.26),('7643','2013-02-23','09:35:00',1.03),('7643','2013-02-23','09:45:00',1.48),('7643','2013-02-23','09:50:00',1.36),('7643','2013-02-23','09:55:00',1.42),('7643','2013-02-23','10:00:00',1.96),('7643','2013-02-23','10:05:00',1.6),('7643','2013-02-23','10:10:00',1.6),('7643','2013-02-23','10:15:00',1.48),('7643','2013-02-23','10:20:00',1.43),('7643','2013-02-23','10:25:00',1.96),('7643','2013-02-23','10:30:00',2.11),('7643','2013-02-23','10:35:00',2.43),('7643','2013-02-23','10:40:00',3.01),('7643','2013-02-23','10:45:00',3.46),('7643','2013-02-23','10:50:00',4.91),('7643','2013-02-23','10:55:00',4.55),('7643','2013-02-23','11:00:00',3.49),('7643','2013-02-23','11:05:00',3.45),('7643','2013-02-23','11:10:00',3.1),('7643','2013-02-23','11:15:00',3.19),('7643','2013-02-23','11:20:00',3.21),('7643','2013-02-23','11:25:00',3.26),('7643','2013-02-23','11:30:00',3.66),('7643','2013-02-23','11:35:00',2.86),('7643','2013-02-23','11:40:00',3.15),('7643','2013-02-23','11:45:00',3.38),('7643','2013-02-23','11:50:00',3.45),('7643','2013-02-23','11:55:00',3.39),('7643','2013-02-23','12:00:00',2.99),('7643','2013-02-23','12:05:00',2.94),('7643','2013-02-23','12:10:00',2.5),('7643','2013-02-23','12:15:00',1.93),('7643','2013-02-23','12:20:00',1.86),('7643','2013-02-23','12:25:00',1.5),('7643','2013-02-23','12:30:00',2.17),('7643','2013-02-23','12:35:00',3.53),('7643','2013-02-23','12:40:00',4.2),('7643','2013-02-23','12:45:00',4.92),('7643','2013-02-23','12:50:00',4.65),('7643','2013-02-23','12:55:00',3.91),('7643','2013-02-23','13:00:00',4.24),('7643','2013-02-23','13:05:00',6.36),('7643','2013-02-23','13:10:00',6.15),('7643','2013-02-23','13:15:00',5.42),('7643','2013-02-23','13:20:00',5.66),('7643','2013-02-23','13:25:00',4.27),('7643','2013-02-23','13:30:00',3.46),('7643','2013-02-23','13:35:00',4.57),('7643','2013-02-23','13:40:00',5.8),('7643','2013-02-23','13:45:00',5.88),('7643','2013-02-23','13:50:00',4.27),('7643','2013-02-23','13:55:00',3.56),('7643','2013-02-23','14:00:00',4.01),('7643','2013-02-23','14:05:00',6.87),('7643','2013-02-23','14:10:00',6.67),('7643','2013-02-23','14:15:00',4.14),('7643','2013-02-23','14:20:00',3.94),('7643','2013-02-23','14:25:00',3.36),('7643','2013-02-23','14:30:00',4.27),('7643','2013-02-23','14:35:00',4.59),('7643','2013-02-23','14:40:00',3.03),('7643','2013-02-23','14:45:00',3.23),('7643','2013-02-23','14:50:00',2.58),('7643','2013-02-23','14:55:00',2.33),('7643','2013-02-23','15:00:00',2.34),('7643','2013-02-23','15:05:00',3.28),('7643','2013-02-23','15:10:00',8.62),('7643','2013-02-23','15:15:00',6.43),('7643','2013-02-23','15:20:00',3.57),('7643','2013-02-23','15:25:00',7.11),('7643','2013-02-23','15:30:00',4.92),('7643','2013-02-23','15:35:00',7.25),('7643','2013-02-23','15:40:00',6.03),('7643','2013-02-23','15:45:00',5.24),('7643','2013-02-23','15:50:00',5.21),('7643','2013-02-23','15:55:00',4.63),('7643','2013-02-23','16:00:00',7.51),('7643','2013-02-23','16:05:00',4.83),('7643','2013-02-23','16:10:00',2.11),('7643','2013-02-23','16:15:00',1.8),('7643','2013-02-23','16:20:00',2.59),('7643','2013-02-23','16:25:00',2.17),('7643','2013-02-23','16:30:00',1.46),('7643','2013-02-23','16:35:00',1.53),('7643','2013-02-23','16:40:00',3.42),('7643','2013-02-23','16:45:00',3.33),('7643','2013-02-23','16:50:00',1.39),('7643','2013-02-23','16:55:00',1.16),('7643','2013-02-22','07:25:00',1.08),('7643','2013-02-22','07:30:00',1.48),('7643','2013-02-22','07:35:00',1.82),('7643','2013-02-22','07:40:00',2.13),('7643','2013-02-22','07:45:00',2.56),('7643','2013-02-22','07:50:00',3.04),('7643','2013-02-22','07:55:00',3.54),('7643','2013-02-22','08:00:00',3.97),('7643','2013-02-22','08:05:00',4.49),('7643','2013-02-22','08:10:00',5.58),('7643','2013-02-22','08:15:00',6.84),('7643','2013-02-22','08:20:00',4.28),('7643','2013-02-22','08:25:00',2.57),('7643','2013-02-22','08:30:00',2.41),('7643','2013-02-22','08:35:00',2.2),('7643','2013-02-22','08:40:00',1.98),('7643','2013-02-22','08:45:00',2.29),('7643','2013-02-22','08:50:00',3.2),('7643','2013-02-22','08:55:00',4.02),('7643','2013-02-22','09:00:00',4.79),('7643','2013-02-22','09:05:00',5.36),('7643','2013-02-22','09:10:00',3.74),('7643','2013-02-22','09:15:00',2.96),('7643','2013-02-22','09:20:00',2.11),('7643','2013-02-22','09:25:00',1.48),('7643','2013-02-22','09:30:00',2.35),('7643','2013-02-22','09:35:00',2.74),('7643','2013-02-22','09:40:00',3.8),('7643','2013-02-22','09:45:00',5.24),('7643','2013-02-22','09:50:00',5.26),('7643','2013-02-22','09:55:00',5.11),('7643','2013-02-22','10:00:00',4.12),('7643','2013-02-22','10:05:00',3.88),('7643','2013-02-22','10:10:00',3.35),('7643','2013-02-22','10:15:00',2.57),('7643','2013-02-22','10:20:00',2.72),('7643','2013-02-22','10:25:00',3.91),('7643','2013-02-22','10:30:00',3.36),('7643','2013-02-22','10:35:00',3.32),('7643','2013-02-22','10:40:00',3.04),('7643','2013-02-22','10:45:00',3.12),('7643','2013-02-22','10:50:00',3.04),('7643','2013-02-22','10:55:00',2.36),('7643','2013-02-22','11:00:00',1.89),('7643','2013-02-22','11:05:00',2.22),('7643','2013-02-22','11:10:00',2.01),('7643','2013-02-22','11:15:00',1.9),('7643','2013-02-22','11:20:00',2.57),('7643','2013-02-22','11:25:00',2.18),('7643','2013-02-22','11:30:00',2.27),('7643','2013-02-22','11:35:00',3.23),('7643','2013-02-22','11:40:00',3.35),('7643','2013-02-22','11:45:00',3.07),('7643','2013-02-22','11:50:00',2.45),('7643','2013-02-22','11:55:00',2.2),('7643','2013-02-22','12:00:00',1.98),('7643','2013-02-22','12:05:00',2.73),('7643','2013-02-22','12:10:00',2.71),('7643','2013-02-22','12:15:00',2.39),('7643','2013-02-22','12:20:00',2.54),('7643','2013-02-22','12:25:00',2.18),('7643','2013-02-22','12:30:00',2.38),('7643','2013-02-22','12:35:00',1.5),('7643','2013-02-22','12:40:00',1.62),('7643','2013-02-22','12:45:00',1.68),('7643','2013-02-22','12:50:00',1.82),('7643','2013-02-22','12:55:00',1.86),('7643','2013-02-22','13:00:00',1.49),('7643','2013-02-22','13:05:00',1.62),('7643','2013-02-22','13:10:00',2.08),('7643','2013-02-22','13:15:00',2.15),('7643','2013-02-22','13:20:00',1.87),('7643','2013-02-22','13:25:00',2.03),('7643','2013-02-22','13:30:00',1.22),('7643','2013-02-22','13:35:00',1.2),('7643','2013-02-22','13:40:00',1.42),('7643','2013-02-22','13:45:00',1.37),('7643','2013-02-22','13:50:00',2.03),('7643','2013-02-22','13:55:00',3.64),('7643','2013-02-22','14:00:00',3.93),('7643','2013-02-22','14:05:00',6.76),('7643','2013-02-22','14:10:00',5.9),('7643','2013-02-22','14:15:00',1.93),('7643','2013-02-22','14:20:00',1.42),('7643','2013-02-22','14:25:00',1.57),('7643','2013-02-22','14:30:00',1.3),('7643','2013-02-22','14:40:00',1.06),('7643','2013-02-22','14:45:00',2.9),('7643','2013-02-22','14:50:00',2.91),('7643','2013-02-22','14:55:00',1.89),('7643','2013-02-22','15:00:00',1.74),('7643','2013-02-22','15:05:00',2.1),('7643','2013-02-22','15:10:00',2.44),('7643','2013-02-22','15:15:00',1.1),('7643','2013-02-22','15:20:00',1.31),('7643','2013-02-22','15:25:00',1.6),('7643','2013-02-22','15:45:00',1.43),('7643','2013-02-22','15:50:00',1.03),('7643','2013-02-21','08:20:00',1.18),('7643','2013-02-21','08:55:00',1.1),('7643','2013-02-21','09:00:00',1.32),('7643','2013-02-21','09:05:00',1.23),('7643','2013-02-21','09:10:00',1.18),('7643','2013-02-21','09:15:00',1.16),('7643','2013-02-21','09:20:00',1.17),('7643','2013-02-21','09:25:00',1.22),('7643','2013-02-21','09:30:00',1.57),('7643','2013-02-21','09:35:00',3.14),('7643','2013-02-21','09:40:00',3.56),('7643','2013-02-21','09:45:00',2.36),('7643','2013-02-21','09:50:00',2.48),('7643','2013-02-21','09:55:00',2.09),('7643','2013-02-21','10:00:00',1.78),('7643','2013-02-21','10:05:00',1.98),('7643','2013-02-21','10:10:00',1.7),('7643','2013-02-21','10:15:00',2.6),('7643','2013-02-21','10:20:00',2.42),('7643','2013-02-21','10:25:00',1.15),('7643','2013-02-21','11:05:00',1.43),('7643','2013-02-21','11:10:00',1.45),('7643','2013-02-21','11:15:00',1.04),('7643','2013-02-21','11:20:00',1.34),('7643','2013-02-21','11:25:00',1.47),('7643','2013-02-21','11:30:00',1.95),('7643','2013-02-21','11:35:00',2.2),('7643','2013-02-21','11:40:00',2.11),('7643','2013-02-21','11:45:00',1.74),('7643','2013-02-21','11:50:00',1.66),('7643','2013-02-21','11:55:00',2),('7643','2013-02-21','12:00:00',2.08),('7643','2013-02-21','12:05:00',1.82),('7643','2013-02-21','12:10:00',1.65),('7643','2013-02-21','12:15:00',1.82),('7643','2013-02-21','12:20:00',1.51),('7643','2013-02-21','12:25:00',1.31),('7643','2013-02-21','12:40:00',1.13),('7643','2013-02-21','12:45:00',2.05),('7643','2013-02-21','12:50:00',2.62),('7643','2013-02-21','12:55:00',2.99),('7643','2013-02-21','13:00:00',2.55),('7643','2013-02-21','13:05:00',1.31),('7643','2013-02-21','13:40:00',1.74),('7643','2013-02-21','13:45:00',1.53),('7643','2013-02-21','13:55:00',1.68),('7643','2013-02-21','14:00:00',1.66),('7643','2013-02-21','14:05:00',1.69),('7643','2013-02-21','14:10:00',2.29),('7643','2013-02-21','14:15:00',2.78),('7643','2013-02-21','14:20:00',3.2),('7643','2013-02-21','14:25:00',2.04),('7643','2013-02-21','14:30:00',3.47),('7643','2013-02-21','14:35:00',4.56),('7643','2013-02-21','14:40:00',4.83),('7643','2013-02-21','14:45:00',4.05),('7643','2013-02-21','14:50:00',3.02),('7643','2013-02-21','14:55:00',5.22),('7643','2013-02-21','15:00:00',2.96),('7643','2013-02-21','15:05:00',1.29),('7643','2013-02-21','15:45:00',1.89),('7643','2013-02-21','15:50:00',2.94),('7643','2013-02-21','15:55:00',2.07),('7643','2013-02-21','16:00:00',1.46),('7643','2013-02-21','16:05:00',1.13),('7643','2013-02-21','16:10:00',2.02),('7643','2013-02-21','16:15:00',1.78),('7643','2013-02-21','16:20:00',4.44),('7643','2013-02-21','16:25:00',5.12),('7643','2013-02-21','16:30:00',4.44),('7643','2013-02-21','16:35:00',2.15),('7643','2013-02-21','16:40:00',1.32),('7643','2013-02-20','08:40:00',1.01),('7643','2013-02-20','08:50:00',1.01),('7643','2013-02-20','08:55:00',1.04),('7643','2013-02-20','09:00:00',1.17),('7643','2013-02-20','09:05:00',1.13),('7643','2013-02-20','09:10:00',1.23),('7643','2013-02-20','09:15:00',1.3),('7643','2013-02-20','09:20:00',1.52),('7643','2013-02-20','09:25:00',1.72),('7643','2013-02-20','09:30:00',1.9),('7643','2013-02-20','09:35:00',1.9),('7643','2013-02-20','09:40:00',2.13),('7643','2013-02-20','09:45:00',2.75),('7643','2013-02-20','09:50:00',3.03),('7643','2013-02-20','09:55:00',3.06),('7643','2013-02-20','10:00:00',2.91),('7643','2013-02-20','10:05:00',2.85),('7643','2013-02-20','10:10:00',2.91),('7643','2013-02-20','10:15:00',2.81),('7643','2013-02-20','10:20:00',2.8),('7643','2013-02-20','10:25:00',2.77),('7643','2013-02-20','10:30:00',2.79),('7643','2013-02-20','10:35:00',2.89),('7643','2013-02-20','10:40:00',2.99),('7643','2013-02-20','10:45:00',2.88),('7643','2013-02-20','10:50:00',2.83),('7643','2013-02-20','10:55:00',2.91),('7643','2013-02-20','11:00:00',2.61),('7643','2013-02-20','11:05:00',2.4),('7643','2013-02-20','11:10:00',2.31),('7643','2013-02-20','11:15:00',2.44),('7643','2013-02-20','11:20:00',2.88),('7643','2013-02-20','11:25:00',3.23),('7643','2013-02-20','11:30:00',3.47),('7643','2013-02-20','11:35:00',3.65),('7643','2013-02-20','11:40:00',3.62),('7643','2013-02-20','11:45:00',3.8),('7643','2013-02-20','11:50:00',4.19),('7643','2013-02-20','11:55:00',4.36),('7643','2013-02-20','12:00:00',4.33),('7643','2013-02-20','12:05:00',4.29),('7643','2013-02-20','12:10:00',4.49),('7643','2013-02-20','12:15:00',4.77),('7643','2013-02-20','12:20:00',5.16),('7643','2013-02-20','12:25:00',5.07),('7643','2013-02-20','12:30:00',4.75),('7643','2013-02-20','12:35:00',4.49),('7643','2013-02-20','12:40:00',4.32),('7643','2013-02-20','12:45:00',4.35),('7643','2013-02-20','12:50:00',4.43),('7643','2013-02-20','12:55:00',4.79),('7643','2013-02-20','13:00:00',4.91),('7643','2013-02-20','13:05:00',4.56),('7643','2013-02-20','13:10:00',4.27),('7643','2013-02-20','13:15:00',4.31),('7643','2013-02-20','13:20:00',4.44),('7643','2013-02-20','13:25:00',4.56),('7643','2013-02-20','13:30:00',4.65),('7643','2013-02-20','13:35:00',4.7),('7643','2013-02-20','13:40:00',4.56),('7643','2013-02-20','13:45:00',4.35),('7643','2013-02-20','13:50:00',4.43),('7643','2013-02-20','13:55:00',4.48),('7643','2013-02-20','14:00:00',4.51),('7643','2013-02-20','14:05:00',4.33),('7643','2013-02-20','14:10:00',4.03),('7643','2013-02-20','14:15:00',3.59),('7643','2013-02-20','14:20:00',3.17),('7643','2013-02-20','14:25:00',2.89),('7643','2013-02-20','14:30:00',2.96),('7643','2013-02-20','14:35:00',3.01),('7643','2013-02-20','14:40:00',2.91),('7643','2013-02-20','14:45:00',2.81),('7643','2013-02-20','14:50:00',2.71),('7643','2013-02-20','14:55:00',2.42),('7643','2013-02-20','15:00:00',2.11),('7643','2013-02-20','15:05:00',1.96),('7643','2013-02-20','15:10:00',1.97),('7643','2013-02-20','15:15:00',1.94),('7643','2013-02-20','15:20:00',1.91),('7643','2013-02-20','15:25:00',1.9),('7643','2013-02-20','15:30:00',1.93),('7643','2013-02-20','15:35:00',1.88),('7643','2013-02-20','15:40:00',1.95),('7643','2013-02-20','15:45:00',2.14),('7643','2013-02-20','15:50:00',2.46),('7643','2013-02-20','15:55:00',2.82),('7643','2013-02-20','16:00:00',3.27),('7643','2013-02-20','16:05:00',3.58),('7643','2013-02-20','16:10:00',3.12),('7643','2013-02-20','16:15:00',3.27),('7643','2013-02-20','16:20:00',4.78),('7643','2013-02-20','16:25:00',5.83),('7643','2013-02-20','16:30:00',5.35),('7643','2013-02-20','16:35:00',4.57),('7643','2013-02-20','16:40:00',3.63),('7643','2013-02-20','16:45:00',2.95),('7643','2013-02-20','16:50:00',2.45),('7643','2013-02-20','16:55:00',2.05),('7643','2013-02-20','17:00:00',1.69),('7643','2013-02-20','17:05:00',1.37),('7643','2013-02-20','17:10:00',1.03),('7643','2014-03-22','06:50:00',1.13),('7643','2014-03-22','06:55:00',1.19),('7643','2014-03-22','07:05:00',1.26),('7643','2014-03-22','07:10:00',1.54),('7643','2014-03-22','07:15:00',1.24),('7643','2014-03-22','07:20:00',1.24),('7643','2014-03-22','07:45:00',1.01),('7643','2014-03-22','07:55:00',1.26),('7643','2014-03-22','08:00:00',1.94),('7643','2014-03-22','08:05:00',2.46),('7643','2014-03-22','08:10:00',2.69),('7643','2014-03-22','08:15:00',2.75),('7643','2014-03-22','08:20:00',3.02),('7643','2014-03-22','08:25:00',3.4),('7643','2014-03-22','08:30:00',3.89),('7643','2014-03-22','08:35:00',4.4),('7643','2014-03-22','08:40:00',3.1),('7643','2014-03-22','08:45:00',3.35),('7643','2014-03-22','08:50:00',4.66),('7643','2014-03-22','08:55:00',6.24),('7643','2014-03-22','09:00:00',3.88),('7643','2014-03-22','09:05:00',6.56),('7643','2014-03-22','09:10:00',10.61),('7643','2014-03-22','09:15:00',10.48),('7643','2014-03-22','09:20:00',7.2),('7643','2014-03-22','09:25:00',4.14),('7643','2014-03-22','09:30:00',5.43),('7643','2014-03-22','09:35:00',5.45),('7643','2014-03-22','09:40:00',4.88),('7643','2014-03-22','09:45:00',3.69),('7643','2014-03-22','09:50:00',3.24),('7643','2014-03-22','09:55:00',2.87),('7643','2014-03-22','10:00:00',2.68),('7643','2014-03-22','10:05:00',2.59),('7643','2014-03-22','10:10:00',3.15),('7643','2014-03-22','10:15:00',2.48),('7643','2014-03-22','10:20:00',2.91),('7643','2014-03-22','10:25:00',4.49),('7643','2014-03-22','10:30:00',3.89),('7643','2014-03-22','10:35:00',3.07),('7643','2014-03-22','10:40:00',4.57),('7643','2014-03-22','10:45:00',4.2),('7643','2014-03-22','10:50:00',4.42),('7643','2014-03-22','10:55:00',6.52),('7643','2014-03-22','11:00:00',5.1),('7643','2014-03-22','11:05:00',4.01),('7643','2014-03-22','11:10:00',5.34),('7643','2014-03-22','11:15:00',3.31),('7643','2014-03-22','11:20:00',2.85),('7643','2014-03-22','11:25:00',3.93),('7643','2014-03-22','11:30:00',3.2),('7643','2014-03-22','11:35:00',4.86),('7643','2014-03-22','11:40:00',10.14),('7643','2014-03-22','11:45:00',3.69),('7643','2014-03-22','11:50:00',1.95),('7643','2014-03-22','11:55:00',3.47),('7643','2014-03-22','12:00:00',3.52),('7643','2014-03-22','12:05:00',2),('7643','2014-03-22','12:15:00',1.21),('7643','2014-03-22','12:20:00',1.07),('7643','2014-03-22','12:25:00',1.36),('7643','2014-03-22','12:30:00',2.06),('7643','2014-03-22','12:35:00',2.56),('7643','2014-03-22','12:40:00',2.11),('7643','2014-03-22','12:45:00',1.38),('7643','2014-03-22','13:05:00',1.83),('7643','2014-03-22','13:10:00',1.87),('7643','2014-03-22','13:15:00',1.84),('7643','2014-03-22','13:35:00',1.53),('7643','2014-03-22','13:40:00',3.02),('7643','2014-03-22','13:45:00',8.28),('7643','2014-03-22','13:50:00',6.8),('7643','2014-03-22','13:55:00',4.04),('7643','2014-03-22','14:00:00',3.68),('7643','2014-03-22','14:05:00',2.57),('7643','2014-03-22','14:10:00',1.58),('7643','2014-03-22','14:15:00',1.94),('7643','2014-03-22','14:20:00',1.23),('7643','2014-03-22','14:25:00',1.31),('7643','2014-03-22','14:30:00',1.47),('7643','2014-03-22','14:35:00',1.33),('7643','2014-03-22','14:45:00',1.14),('7643','2014-03-22','14:50:00',4.03),('7643','2014-03-22','14:55:00',3.74),('7643','2014-03-22','15:00:00',2.17),('7643','2014-03-22','15:05:00',3.54),('7643','2014-03-22','15:10:00',5.16),('7643','2014-03-22','15:15:00',7.61),('7643','2014-03-22','15:20:00',6.18),('7643','2014-03-22','15:25:00',6.72),('7643','2014-03-22','15:30:00',3.4),('7643','2014-03-22','15:35:00',3.96),('7643','2014-03-22','15:40:00',3.45),('7643','2014-03-22','15:45:00',2.82),('7643','2014-03-22','15:50:00',1.06),('7643','2014-03-22','17:35:00',1.26),('7643','2014-03-22','17:40:00',1.27),('7643','2013-02-19','07:50:00',1.26),('7643','2013-02-19','07:55:00',1.83),('7643','2013-02-19','08:00:00',1.73),('7643','2013-02-19','08:05:00',1.68),('7643','2013-02-19','08:10:00',1.84),('7643','2013-02-19','08:15:00',3.73),('7643','2013-02-19','08:20:00',4.79),('7643','2013-02-19','08:25:00',5.13),('7643','2013-02-19','08:30:00',5.53),('7643','2013-02-19','08:35:00',5.95),('7643','2013-02-19','08:40:00',6.33),('7643','2013-02-19','08:45:00',6.72),('7643','2013-02-19','08:50:00',7.1),('7643','2013-02-19','08:55:00',7.44),('7643','2013-02-19','09:00:00',7.92),('7643','2013-02-19','09:05:00',4.48),('7643','2013-02-19','09:10:00',5.51),('7643','2013-02-19','09:15:00',5.57),('7643','2013-02-19','09:20:00',4.57),('7643','2013-02-19','09:25:00',5.8),('7643','2013-02-19','09:30:00',8.12),('7643','2013-02-19','09:35:00',5.3),('7643','2013-02-19','09:40:00',4.48),('7643','2013-02-19','09:45:00',5.87),('7643','2013-02-19','09:50:00',6.34),('7643','2013-02-19','09:55:00',5.65),('7643','2013-02-19','10:00:00',3.69),('7643','2013-02-19','10:05:00',6.14),('7643','2013-02-19','10:10:00',4.22),('7643','2013-02-19','10:15:00',5.64),('7643','2013-02-19','10:20:00',3.08),('7643','2013-02-19','10:25:00',2.97),('7643','2013-02-19','10:30:00',2.81),('7643','2013-02-19','10:35:00',2.64),('7643','2013-02-19','10:40:00',3.32),('7643','2013-02-19','10:45:00',4.85),('7643','2013-02-19','10:50:00',14.06),('7643','2013-02-19','10:55:00',9.83),('7643','2013-02-19','11:00:00',2.91),('7643','2013-02-19','11:05:00',11.23),('7643','2013-02-19','11:10:00',11.7),('7643','2013-02-19','11:15:00',13.31),('7643','2013-02-19','11:20:00',4.56),('7643','2013-02-19','11:25:00',14.65),('7643','2013-02-19','11:30:00',15.51),('7643','2013-02-19','11:35:00',16.82),('7643','2013-02-19','11:40:00',16.97),('7643','2013-02-19','11:45:00',14.13),('7643','2013-02-19','11:50:00',15.29),('7643','2013-02-19','11:55:00',11.82),('7643','2013-02-19','12:00:00',15.75),('7643','2013-02-19','12:05:00',16.55),('7643','2013-02-19','12:10:00',14.62),('7643','2013-02-19','12:15:00',5.14),('7643','2013-02-19','12:20:00',6.04),('7643','2013-02-19','12:25:00',13.72),('7643','2013-02-19','12:30:00',16.89),('7643','2013-02-19','12:35:00',14.11),('7643','2013-02-19','12:40:00',7.94),('7643','2013-02-19','12:45:00',4.31),('7643','2013-02-19','12:50:00',4.29),('7643','2013-02-19','12:55:00',5.21),('7643','2013-02-19','13:00:00',14.29),('7643','2013-02-19','13:05:00',15.94),('7643','2013-02-19','13:10:00',15.52),('7643','2013-02-19','13:15:00',8.16),('7643','2013-02-19','13:20:00',4.42),('7643','2013-02-19','13:25:00',7.73),('7643','2013-02-19','13:30:00',13.29),('7643','2013-02-19','13:35:00',9.56),('7643','2013-02-19','13:40:00',6.48),('7643','2013-02-19','13:45:00',5.37),('7643','2013-02-19','13:50:00',5.84),('7643','2013-02-19','13:55:00',4.51),('7643','2013-02-19','14:00:00',7.84),('7643','2013-02-19','14:05:00',3.9),('7643','2013-02-19','14:10:00',3.83),('7643','2013-02-19','14:15:00',3.52),('7643','2013-02-19','14:20:00',2.89),('7643','2013-02-19','14:25:00',2.39),('7643','2013-02-19','14:30:00',3.02),('7643','2013-02-19','14:35:00',3.58),('7643','2013-02-19','14:40:00',3.87),('7643','2013-02-19','14:45:00',3.58),('7643','2013-02-19','14:50:00',3.37),('7643','2013-02-19','14:55:00',3.42),('7643','2013-02-19','15:00:00',3.27),('7643','2013-02-19','15:05:00',3.72),('7643','2013-02-19','15:10:00',3.83),('7643','2013-02-19','15:15:00',5.86),('7643','2013-02-19','15:20:00',7.93),('7643','2013-02-19','15:25:00',8.27),('7643','2013-02-19','15:30:00',4.32),('7643','2013-02-19','15:35:00',2.87),('7643','2013-02-19','15:40:00',2.4),('7643','2013-02-19','15:45:00',2.58),('7643','2013-02-19','15:50:00',2.91),('7643','2013-02-19','15:55:00',3.6),('7643','2013-02-19','16:00:00',5.72),('7643','2013-02-19','16:05:00',7.18),('7643','2013-02-19','16:10:00',6.65),('7643','2013-02-19','16:15:00',6.08),('7643','2013-02-19','16:20:00',5.41),('7643','2013-02-19','16:25:00',4.59),('7643','2013-02-19','16:30:00',4.29),('7643','2013-02-19','16:35:00',3.26),('7643','2013-02-19','16:40:00',2.27),('7643','2013-02-19','16:45:00',2.2),('7643','2013-02-19','16:50:00',1.87),('7643','2013-02-19','16:55:00',1.71),('7643','2013-02-19','17:00:00',1.59),('7643','2013-02-19','17:05:00',1.44),('7643','2013-02-19','17:10:00',1.09),('7643','2013-02-18','07:30:00',1.11),('7643','2013-02-18','07:35:00',1.4),('7643','2013-02-18','07:40:00',1.68),('7643','2013-02-18','07:45:00',2.02),('7643','2013-02-18','07:50:00',2.38),('7643','2013-02-18','07:55:00',2.73),('7643','2013-02-18','08:00:00',3.12),('7643','2013-02-18','08:05:00',3.49),('7643','2013-02-18','08:10:00',3.86),('7643','2013-02-18','08:15:00',4.26),('7643','2013-02-18','08:20:00',4.65),('7643','2013-02-18','08:25:00',5.05),('7643','2013-02-18','08:30:00',5.44),('7643','2013-02-18','08:35:00',5.83),('7643','2013-02-18','08:40:00',6.15),('7643','2013-02-18','08:45:00',6.5),('7643','2013-02-18','08:50:00',6.88),('7643','2013-02-18','08:55:00',7.19),('7643','2013-02-18','09:00:00',7.49),('7643','2013-02-18','09:05:00',7.8),('7643','2013-02-18','09:10:00',8.11),('7643','2013-02-18','09:15:00',8.4),('7643','2013-02-18','09:20:00',8.74),('7643','2013-02-18','09:25:00',9.01),('7643','2013-02-18','09:30:00',9.26),('7643','2013-02-18','09:35:00',9.51),('7643','2013-02-18','09:40:00',9.73),('7643','2013-02-18','09:45:00',9.99),('7643','2013-02-18','09:50:00',10.22),('7643','2013-02-18','09:55:00',10.51),('7643','2013-02-18','10:00:00',10.66),('7643','2013-02-18','10:05:00',10.92),('7643','2013-02-18','10:10:00',11.2),('7643','2013-02-18','10:15:00',11.38),('7643','2013-02-18','10:20:00',11.64),('7643','2013-02-18','10:25:00',11.84),('7643','2013-02-18','10:30:00',11.98),('7643','2013-02-18','10:35:00',12.14),('7643','2013-02-18','10:40:00',12.38),('7643','2013-02-18','10:45:00',12.44),('7643','2013-02-18','10:50:00',12.52),('7643','2013-02-18','10:55:00',12.59),('7643','2013-02-18','11:00:00',12.81),('7643','2013-02-18','11:05:00',13),('7643','2013-02-18','11:10:00',13.16),('7643','2013-02-18','11:15:00',13.18),('7643','2013-02-18','11:20:00',13.24),('7643','2013-02-18','11:25:00',13.42),('7643','2013-02-18','11:30:00',13.44),('7643','2013-02-18','11:35:00',13.53),('7643','2013-02-18','11:40:00',13.64),('7643','2013-02-18','11:45:00',13.6),('7643','2013-02-18','11:50:00',13.67),('7643','2013-02-18','11:55:00',13.82),('7643','2013-02-18','12:00:00',13.9),('7643','2013-02-18','12:05:00',13.88),('7643','2013-02-18','12:10:00',13.82),('7643','2013-02-18','12:15:00',13.7),('7643','2013-02-18','12:20:00',13.59),('7643','2013-02-18','12:25:00',13.31),('7643','2013-02-18','12:30:00',13.4),('7643','2013-02-18','12:35:00',13.42),('7643','2013-02-18','12:40:00',13.47),('7643','2013-02-18','12:45:00',13.45),('7643','2013-02-18','12:50:00',13.47),('7643','2013-02-18','12:55:00',13.48),('7643','2013-02-18','13:00:00',13.49),('7643','2013-02-18','13:05:00',13.31),('7643','2013-02-18','13:10:00',13.27),('7643','2013-02-18','13:15:00',13.16),('7643','2013-02-18','13:20:00',12.99),('7643','2013-02-18','13:25:00',12.93),('7643','2013-02-18','13:30:00',12.95),('7643','2013-02-18','13:35:00',12.78),('7643','2013-02-18','13:40:00',12.73),('7643','2013-02-18','13:45:00',12.6),('7643','2013-02-18','13:50:00',12.38),('7643','2013-02-18','13:55:00',12.36),('7643','2013-02-18','14:00:00',12),('7643','2013-02-18','14:05:00',11.67),('7643','2013-02-18','14:10:00',11.48),('7643','2013-02-18','14:15:00',11.31),('7643','2013-02-18','14:20:00',10.77),('7643','2013-02-18','14:25:00',5.96),('7643','2013-02-18','14:30:00',3.83),('7643','2013-02-18','14:35:00',10.23),('7643','2013-02-18','14:40:00',10.24),('7643','2013-02-18','14:45:00',9.79),('7643','2013-02-18','14:50:00',9.77),('7643','2013-02-18','14:55:00',9.37),('7643','2013-02-18','15:00:00',9.17),('7643','2013-02-18','15:05:00',8.95),('7643','2013-02-18','15:10:00',8.78),('7643','2013-02-18','15:15:00',8.57),('7643','2013-02-18','15:20:00',8.07),('7643','2013-02-18','15:25:00',7.75),('7643','2013-02-18','15:30:00',7.32),('7643','2013-02-18','15:35:00',7.03),('7643','2013-02-18','15:40:00',6.83),('7643','2013-02-18','15:45:00',6.58),('7643','2013-02-18','15:50:00',6.19),('7643','2013-02-18','15:55:00',5.84),('7643','2013-02-18','16:00:00',5.56),('7643','2013-02-18','16:05:00',5.2),('7643','2013-02-18','16:10:00',4.86),('7643','2013-02-18','16:15:00',4.52),('7643','2013-02-18','16:20:00',4.14),('7643','2013-02-18','16:25:00',3.77),('7643','2013-02-18','16:30:00',3.44),('7643','2013-02-18','16:35:00',3.15),('7643','2013-02-18','16:40:00',2.75),('7643','2013-02-18','16:45:00',2.37),('7643','2013-02-18','16:50:00',2.09),('7643','2013-02-18','16:55:00',1.77),('7643','2013-02-18','17:00:00',1.48),('7643','2013-02-18','17:05:00',1.23),('7643','2013-02-17','07:50:00',1.36),('7643','2013-02-17','07:55:00',2.36),('7643','2013-02-17','08:00:00',2.87),('7643','2013-02-17','08:05:00',3.21),('7643','2013-02-17','08:10:00',3.61),('7643','2013-02-17','08:15:00',3.95),('7643','2013-02-17','08:20:00',4.29),('7643','2013-02-17','08:25:00',4.63),('7643','2013-02-17','08:30:00',5.07),('7643','2013-02-17','08:35:00',5.48),('7643','2013-02-17','08:40:00',5.77),('7643','2013-02-17','08:45:00',6.1),('7643','2013-02-17','08:50:00',6.38),('7643','2013-02-17','08:55:00',6.71),('7643','2013-02-17','09:00:00',7.04),('7643','2013-02-17','09:05:00',7.37),('7643','2013-02-17','09:10:00',7.72),('7643','2013-02-17','09:15:00',8.09),('7643','2013-02-17','09:20:00',8.52),('7643','2013-02-17','09:25:00',9.37),('7643','2013-02-17','09:30:00',8.71),('7643','2013-02-17','09:35:00',4.65),('7643','2013-02-17','09:40:00',3.71),('7643','2013-02-17','09:45:00',2.86),('7643','2013-02-17','09:50:00',7.3),('7643','2013-02-17','09:55:00',2.9),('7643','2013-02-17','10:00:00',3.25),('7643','2013-02-17','10:05:00',4.22),('7643','2013-02-17','10:10:00',3.25),('7643','2013-02-17','10:15:00',2.01),('7643','2013-02-17','10:20:00',2.06),('7643','2013-02-17','10:25:00',2.04),('7643','2013-02-17','10:30:00',2.38),('7643','2013-02-17','10:35:00',2.8),('7643','2013-02-17','10:40:00',3.24),('7643','2013-02-17','10:45:00',3.12),('7643','2013-02-17','10:50:00',2.71),('7643','2013-02-17','10:55:00',3.78),('7643','2013-02-17','11:00:00',4.85),('7643','2013-02-17','11:05:00',4.8),('7643','2013-02-17','11:10:00',5.02),('7643','2013-02-17','11:15:00',4.48),('7643','2013-02-17','11:20:00',5.15),('7643','2013-02-17','11:25:00',5.93),('7643','2013-02-17','11:30:00',5.17),('7643','2013-02-17','11:35:00',5.29),('7643','2013-02-17','11:40:00',5.18),('7643','2013-02-17','11:45:00',4.91),('7643','2013-02-17','11:50:00',5.29),('7643','2013-02-17','11:55:00',6.2),('7643','2013-02-17','12:00:00',6.87),('7643','2013-02-17','12:05:00',6),('7643','2013-02-17','12:10:00',5.51),('7643','2013-02-17','12:15:00',5.35),('7643','2013-02-17','12:20:00',5.16),('7643','2013-02-17','12:25:00',5.35),('7643','2013-02-17','12:30:00',4.98),('7643','2013-02-17','12:35:00',4.65),('7643','2013-02-17','12:40:00',4.95),('7643','2013-02-17','12:45:00',5.93),('7643','2013-02-17','12:50:00',5.92),('7643','2013-02-17','12:55:00',5.45),('7643','2013-02-17','13:00:00',5.37),('7643','2013-02-17','13:05:00',5.46),('7643','2013-02-17','13:10:00',5.36),('7643','2013-02-17','13:15:00',6.48),('7643','2013-02-17','13:20:00',5.43),('7643','2013-02-17','13:25:00',6.02),('7643','2013-02-17','13:30:00',6.06),('7643','2013-02-17','13:35:00',5.26),('7643','2013-02-17','13:40:00',4.97),('7643','2013-02-17','13:45:00',4.38),('7643','2013-02-17','13:50:00',4.63),('7643','2013-02-17','13:55:00',5.81),('7643','2013-02-17','14:00:00',5.53),('7643','2013-02-17','14:05:00',4.93),('7643','2013-02-17','14:10:00',4.67),('7643','2013-02-17','14:15:00',3.91),('7643','2013-02-17','14:20:00',4.41),('7643','2013-02-17','14:25:00',2.94),('7643','2013-02-17','14:30:00',2.19),('7643','2013-02-17','14:35:00',2.05),('7643','2013-02-17','14:40:00',1.89),('7643','2013-02-17','14:45:00',1.73),('7643','2013-02-17','14:50:00',1.37),('7643','2013-02-17','14:55:00',1.19),('7643','2013-02-17','15:00:00',1.47),('7643','2013-02-17','15:05:00',2.07),('7643','2013-02-17','15:10:00',2.1),('7643','2013-02-17','15:15:00',1.74),('7643','2013-02-17','15:20:00',1.62),('7643','2013-02-17','15:25:00',1.6),('7643','2013-02-17','15:30:00',1.79),('7643','2013-02-17','15:35:00',2.47),('7643','2013-02-17','15:40:00',2.36),('7643','2013-02-17','15:45:00',1.94),('7643','2013-02-17','15:50:00',1.7),('7643','2013-02-17','15:55:00',1.56),('7643','2013-02-16','07:35:00',1.16),('7643','2013-02-16','07:40:00',1.4),('7643','2013-02-16','07:45:00',1.61),('7643','2013-02-16','07:50:00',1.93),('7643','2013-02-16','07:55:00',2.28),('7643','2013-02-16','08:00:00',2.67),('7643','2013-02-16','08:05:00',3.04),('7643','2013-02-16','08:10:00',3.41),('7643','2013-02-16','08:15:00',3.83),('7643','2013-02-16','08:20:00',4.24),('7643','2013-02-16','08:25:00',4.58),('7643','2013-02-16','08:30:00',5.14),('7643','2013-02-16','08:35:00',5.72),('7643','2013-02-16','08:40:00',6.23),('7643','2013-02-16','08:45:00',6.25),('7643','2013-02-16','08:50:00',5.43),('7643','2013-02-16','08:55:00',6.38),('7643','2013-02-16','09:00:00',6.95),('7643','2013-02-16','09:05:00',6.8),('7643','2013-02-16','09:10:00',7.47),('7643','2013-02-16','09:15:00',7.88),('7643','2013-02-16','09:20:00',8.24),('7643','2013-02-16','09:25:00',8.46),('7643','2013-02-16','09:30:00',8.65),('7643','2013-02-16','09:35:00',8.78),('7643','2013-02-16','09:40:00',9.07),('7643','2013-02-16','09:45:00',9.41),('7643','2013-02-16','09:50:00',9.72),('7643','2013-02-16','09:55:00',10.01),('7643','2013-02-16','10:00:00',10.28),('7643','2013-02-16','10:05:00',10.45),('7643','2013-02-16','10:10:00',10.65),('7643','2013-02-16','10:15:00',10.84),('7643','2013-02-16','10:20:00',11.02),('7643','2013-02-16','10:25:00',11.15),('7643','2013-02-16','10:30:00',11.38),('7643','2013-02-16','10:35:00',11.58),('7643','2013-02-16','10:40:00',11.75),('7643','2013-02-16','10:45:00',11.8),('7643','2013-02-16','10:50:00',11.96),('7643','2013-02-16','10:55:00',12.15),('7643','2013-02-16','11:00:00',12.49),('7643','2013-02-16','11:05:00',12.5),('7643','2013-02-16','11:10:00',12.38),('7643','2013-02-16','11:15:00',12.47),('7643','2013-02-16','11:20:00',12.55),('7643','2013-02-16','11:25:00',12.63),('7643','2013-02-16','11:30:00',12.82),('7643','2013-02-16','11:35:00',12.96),('7643','2013-02-16','11:40:00',13.12),('7643','2013-02-16','11:45:00',13.11),('7643','2013-02-16','11:50:00',13.18),('7643','2013-02-16','11:55:00',13.22),('7643','2013-02-16','12:00:00',13.26),('7643','2013-02-16','12:05:00',13.34),('7643','2013-02-16','12:10:00',13.37),('7643','2013-02-16','12:15:00',13.38),('7643','2013-02-16','12:20:00',13.26),('7643','2013-02-16','12:25:00',13.19),('7643','2013-02-16','12:30:00',13.04),('7643','2013-02-16','12:35:00',13.02),('7643','2013-02-16','12:40:00',12.99),('7643','2013-02-16','12:45:00',12.96),('7643','2013-02-16','12:50:00',13.08),('7643','2013-02-16','12:55:00',12.93),('7643','2013-02-16','13:00:00',12.73),('7643','2013-02-16','13:05:00',12.63),('7643','2013-02-16','13:10:00',12.45),('7643','2013-02-16','13:15:00',12.28),('7643','2013-02-16','13:20:00',8.4),('7643','2013-02-16','13:25:00',2.83),('7643','2013-02-16','13:30:00',4.43),('7643','2013-02-16','13:35:00',11.94),('7643','2013-02-16','13:40:00',12.01),('7643','2013-02-16','13:45:00',11.21),('7643','2013-02-16','13:50:00',10.61),('7643','2013-02-16','13:55:00',10.18),('7643','2013-02-16','14:00:00',2.21),('7643','2013-02-16','14:05:00',2.06),('7643','2013-02-16','14:10:00',5.99),('7643','2013-02-16','14:15:00',6.39),('7643','2013-02-16','14:20:00',2.97),('7643','2013-02-16','14:25:00',2.38),('7643','2013-02-16','14:30:00',4.26),('7643','2013-02-16','14:35:00',3.13),('7643','2013-02-16','14:40:00',2.96),('7643','2013-02-16','14:45:00',2.01),('7643','2013-02-16','14:50:00',2.99),('7643','2013-02-16','14:55:00',2.4),('7643','2013-02-16','15:00:00',4.04),('7643','2013-02-16','15:05:00',8.77),('7643','2013-02-16','15:10:00',6.98),('7643','2013-02-16','15:15:00',9.8),('7643','2013-02-16','15:20:00',8.94),('7643','2013-02-16','15:25:00',7.5),('7643','2013-02-16','15:30:00',6.27),('7643','2013-02-16','15:35:00',8.01),('7643','2013-02-16','15:40:00',7.95),('7643','2013-02-16','15:45:00',7.43),('7643','2013-02-16','15:50:00',6.92),('7643','2013-02-16','15:55:00',6.6),('7643','2013-02-16','16:00:00',5.97),('7643','2013-02-16','16:05:00',5.55),('7643','2013-02-16','16:10:00',2.72),('7643','2013-02-16','16:15:00',1.87),('7643','2013-02-16','16:20:00',3.94),('7643','2013-02-16','16:25:00',4.41),('7643','2013-02-16','16:30:00',4.66),('7643','2013-02-16','16:35:00',3.36),('7643','2013-02-16','16:40:00',2.16),('7643','2013-02-16','16:45:00',1.57),('7643','2013-02-15','07:40:00',1.26),('7643','2013-02-15','07:55:00',2.14),('7643','2013-02-15','08:00:00',2.73),('7643','2013-02-15','08:05:00',3.1),('7643','2013-02-15','08:10:00',3.41),('7643','2013-02-15','08:15:00',3.75),('7643','2013-02-15','08:20:00',4.06),('7643','2013-02-15','08:25:00',4.47),('7643','2013-02-15','08:30:00',4.85),('7643','2013-02-15','08:35:00',5.28),('7643','2013-02-15','08:40:00',5.65),('7643','2013-02-15','08:45:00',6),('7643','2013-02-15','08:50:00',3.37),('7643','2013-02-15','08:55:00',1.54),('7643','2013-02-15','09:00:00',2.12),('7643','2013-02-15','09:05:00',2.24),('7643','2013-02-15','09:10:00',2.69),('7643','2013-02-15','09:15:00',7.52),('7643','2013-02-15','09:20:00',8.53),('7643','2013-02-15','09:25:00',8.84),('7643','2013-02-15','09:30:00',8.04),('7643','2013-02-15','09:35:00',9.02),('7643','2013-02-15','09:40:00',9.44),('7643','2013-02-15','09:45:00',9.66),('7643','2013-02-15','09:50:00',10.02),('7643','2013-02-15','09:55:00',10.17),('7643','2013-02-15','10:00:00',10.34),('7643','2013-02-15','10:05:00',10.44),('7643','2013-02-15','10:10:00',10.84),('7643','2013-02-15','10:15:00',11.06),('7643','2013-02-15','10:20:00',11.27),('7643','2013-02-15','10:25:00',11.41),('7643','2013-02-15','10:30:00',11.64),('7643','2013-02-15','10:35:00',12.07),('7643','2013-02-15','10:40:00',11.25),('7643','2013-02-15','10:45:00',12.77),('7643','2013-02-15','10:50:00',12.62),('7643','2013-02-15','10:55:00',11.04),('7643','2013-02-15','11:00:00',12.92),('7643','2013-02-15','11:05:00',11.85),('7643','2013-02-15','11:10:00',9.56),('7643','2013-02-15','11:15:00',12.8),('7643','2013-02-15','11:20:00',11.14),('7643','2013-02-15','11:25:00',12.52),('7643','2013-02-15','11:30:00',13.31),('7643','2013-02-15','11:35:00',13.39),('7643','2013-02-15','11:40:00',13.44),('7643','2013-02-15','11:45:00',13.52),('7643','2013-02-15','11:50:00',13.72),('7643','2013-02-15','11:55:00',13.74),('7643','2013-02-15','12:00:00',13.72),('7643','2013-02-15','12:05:00',13.63),('7643','2013-02-15','12:10:00',13.52),('7643','2013-02-15','12:15:00',13.69),('7643','2013-02-15','12:20:00',13.67),('7643','2013-02-15','12:25:00',13.69),('7643','2013-02-15','12:30:00',13.66),('7643','2013-02-15','12:35:00',13.66),('7643','2013-02-15','12:40:00',13.62),('7643','2013-02-15','12:45:00',13.65),('7643','2013-02-15','12:50:00',13.71),('7643','2013-02-15','12:55:00',13.45),('7643','2013-02-15','13:00:00',13.5),('7643','2013-02-15','13:05:00',13.41),('7643','2013-02-15','13:10:00',13.28),('7643','2013-02-15','13:15:00',13.25),('7643','2013-02-15','13:20:00',13.17),('7643','2013-02-15','13:25:00',12.91),('7643','2013-02-15','13:30:00',12.93),('7643','2013-02-15','13:35:00',12.67),('7643','2013-02-15','13:40:00',12.76),('7643','2013-02-15','13:45:00',12.85),('7643','2013-02-15','13:50:00',12.72),('7643','2013-02-15','13:55:00',12.32),('7643','2013-02-15','14:00:00',12.17),('7643','2013-02-15','14:05:00',11.97),('7643','2013-02-15','14:10:00',11.82),('7643','2013-02-15','14:15:00',11.08),('7643','2013-02-15','14:20:00',3.33),('7643','2013-02-15','14:25:00',3.56),('7643','2013-02-15','14:30:00',3.96),('7643','2013-02-15','14:35:00',3.73),('7643','2013-02-15','14:40:00',3.85),('7643','2013-02-15','14:45:00',4.06),('7643','2013-02-15','14:50:00',4.01),('7643','2013-02-15','14:55:00',3.38),('7643','2013-02-15','15:00:00',3.24),('7643','2013-02-15','15:05:00',3.29),('7643','2013-02-15','15:10:00',3.28),('7643','2013-02-15','15:15:00',3.64),('7643','2013-02-15','15:20:00',4.49),('7643','2013-02-15','15:25:00',4.1),('7643','2013-02-15','15:30:00',6.53),('7643','2013-02-15','15:35:00',5.72),('7643','2013-02-15','15:40:00',8.05),('7643','2013-02-15','15:45:00',8.65),('7643','2013-02-15','15:50:00',8.15),('7643','2013-02-15','15:55:00',4.44),('7643','2013-02-15','16:00:00',5.14),('7643','2013-02-15','16:05:00',6.21),('7643','2013-02-15','16:10:00',5.3),('7643','2013-02-15','16:15:00',2.69),('7643','2013-02-15','16:20:00',2.33),('7643','2013-02-15','16:25:00',3.18),('7643','2013-02-15','16:30:00',2.2),('7643','2013-02-15','16:35:00',1.62),('7643','2013-02-15','16:40:00',1.31),('7643','2013-02-15','16:45:00',1.04),('7643','2013-02-14','07:35:00',1.21),('7643','2013-02-14','07:40:00',1.54),('7643','2013-02-14','07:45:00',1.83),('7643','2013-02-14','07:50:00',2.16),('7643','2013-02-14','07:55:00',2.8),('7643','2013-02-14','08:00:00',3.07),('7643','2013-02-14','08:05:00',2.85),('7643','2013-02-14','08:10:00',2.84),('7643','2013-02-14','08:15:00',3.23),('7643','2013-02-14','08:20:00',2.46),('7643','2013-02-14','08:25:00',2.07),('7643','2013-02-14','08:30:00',1.83),('7643','2013-02-14','08:35:00',1.58),('7643','2013-02-14','08:40:00',1.58),('7643','2013-02-14','08:45:00',1.65),('7643','2013-02-14','08:50:00',1.98),('7643','2013-02-14','08:55:00',2.63),('7643','2013-02-14','09:00:00',2.39),('7643','2013-02-14','09:05:00',2.83),('7643','2013-02-14','09:10:00',2.54),('7643','2013-02-14','09:15:00',3.07),('7643','2013-02-14','09:20:00',3.66),('7643','2013-02-14','09:25:00',4.77),('7643','2013-02-14','09:30:00',4.28),('7643','2013-02-14','09:35:00',3.84),('7643','2013-02-14','09:40:00',4.04),('7643','2013-02-14','09:45:00',3.77),('7643','2013-02-14','09:50:00',3.88),('7643','2013-02-14','09:55:00',4.87),('7643','2013-02-14','10:00:00',6.65),('7643','2013-02-14','10:05:00',7.51),('7643','2013-02-14','10:10:00',5.19),('7643','2013-02-14','10:15:00',4.63),('7643','2013-02-14','10:20:00',6.17),('7643','2013-02-14','10:25:00',9.13),('7643','2013-02-14','10:30:00',7.49),('7643','2013-02-14','10:35:00',11.03),('7643','2013-02-14','10:40:00',10.92),('7643','2013-02-14','10:45:00',11.2),('7643','2013-02-14','10:50:00',11.47),('7643','2013-02-14','10:55:00',7.24),('7643','2013-02-14','11:00:00',7.05),('7643','2013-02-14','11:05:00',7.42),('7643','2013-02-14','11:10:00',7.82),('7643','2013-02-14','11:15:00',10.5),('7643','2013-02-14','11:20:00',13.28),('7643','2013-02-14','11:25:00',13.18),('7643','2013-02-14','11:30:00',13),('7643','2013-02-14','11:35:00',10.6),('7643','2013-02-14','11:40:00',8.11),('7643','2013-02-14','11:45:00',7.79),('7643','2013-02-14','11:50:00',14.55),('7643','2013-02-14','11:55:00',13.41),('7643','2013-02-14','12:00:00',11.02),('7643','2013-02-14','12:05:00',11.48),('7643','2013-02-14','12:10:00',11.04),('7643','2013-02-14','12:15:00',11.16),('7643','2013-02-14','12:20:00',14.97),('7643','2013-02-14','12:25:00',13.53),('7643','2013-02-14','12:30:00',13.73),('7643','2013-02-14','12:35:00',13.75),('7643','2013-02-14','12:40:00',13.53),('7643','2013-02-14','12:45:00',13.43),('7643','2013-02-14','12:50:00',13.27),('7643','2013-02-14','12:55:00',11.33),('7643','2013-02-14','13:00:00',13.44),('7643','2013-02-14','13:05:00',13.34),('7643','2013-02-14','13:10:00',13.18),('7643','2013-02-14','13:15:00',13.37),('7643','2013-02-14','13:20:00',12.74),('7643','2013-02-14','13:25:00',12.62),('7643','2013-02-14','13:30:00',9.38),('7643','2013-02-14','13:35:00',9.24),('7643','2013-02-14','13:40:00',12.39),('7643','2013-02-14','13:45:00',9.88),('7643','2013-02-14','13:50:00',10.16),('7643','2013-02-14','13:55:00',11.61),('7643','2013-02-14','14:00:00',8.1),('7643','2013-02-14','14:05:00',12.15),('7643','2013-02-14','14:10:00',14.18),('7643','2013-02-14','14:15:00',9.04),('7643','2013-02-14','14:20:00',10.18),('7643','2013-02-14','14:25:00',7.34),('7643','2013-02-14','14:30:00',7.09),('7643','2013-02-14','14:35:00',10.26),('7643','2013-02-14','14:40:00',10.88),('7643','2013-02-14','14:45:00',9.39),('7643','2013-02-14','14:50:00',5.66),('7643','2013-02-14','14:55:00',4.52),('7643','2013-02-14','15:00:00',6.6),('7643','2013-02-14','15:05:00',5.08),('7643','2013-02-14','15:10:00',4.89),('7643','2013-02-14','15:15:00',6.26),('7643','2013-02-14','15:20:00',5),('7643','2013-02-14','15:25:00',5.48),('7643','2013-02-14','15:30:00',6.25),('7643','2013-02-14','15:35:00',5.1),('7643','2013-02-14','15:40:00',5.01),('7643','2013-02-14','15:45:00',4.65),('7643','2013-02-14','15:50:00',3.24),('7643','2013-02-14','15:55:00',3.01),('7643','2013-02-14','16:00:00',2.69),('7643','2013-02-14','16:05:00',2.56),('7643','2013-02-14','16:10:00',2.34),('7643','2013-02-14','16:15:00',2.08),('7643','2013-02-14','16:20:00',1.75),('7643','2013-02-14','16:25:00',1.48),('7643','2013-02-14','16:30:00',1.35),('7643','2013-02-14','16:35:00',1.34),('7643','2013-02-14','16:40:00',1.44),('7643','2013-02-14','16:45:00',1.9),('7643','2013-02-14','16:50:00',1.6),('7643','2013-02-14','16:55:00',1.13),('7643','2013-02-13','07:35:00',1.21),('7643','2013-02-13','07:40:00',1.49),('7643','2013-02-13','07:45:00',1.81),('7643','2013-02-13','07:50:00',2.18),('7643','2013-02-13','07:55:00',2.55),('7643','2013-02-13','08:00:00',2.94),('7643','2013-02-13','08:05:00',3.33),('7643','2013-02-13','08:10:00',3.69),('7643','2013-02-13','08:15:00',4.03),('7643','2013-02-13','08:20:00',4.39),('7643','2013-02-13','08:25:00',4.8),('7643','2013-02-13','08:30:00',5.16),('7643','2013-02-13','08:35:00',5.6),('7643','2013-02-13','08:40:00',5.95),('7643','2013-02-13','08:45:00',6.31),('7643','2013-02-13','08:50:00',6.66),('7643','2013-02-13','08:55:00',7),('7643','2013-02-13','09:00:00',7.34),('7643','2013-02-13','09:05:00',7.68),('7643','2013-02-13','09:10:00',7.99),('7643','2013-02-13','09:15:00',8.35),('7643','2013-02-13','09:20:00',8.66),('7643','2013-02-13','09:25:00',8.97),('7643','2013-02-13','09:30:00',9.26),('7643','2013-02-13','09:35:00',9.54),('7643','2013-02-13','09:40:00',9.84),('7643','2013-02-13','09:45:00',10.09),('7643','2013-02-13','09:50:00',10.36),('7643','2013-02-13','09:55:00',10.6),('7643','2013-02-13','10:00:00',10.86),('7643','2013-02-13','10:05:00',11.12),('7643','2013-02-13','10:10:00',11.36),('7643','2013-02-13','10:15:00',11.58),('7643','2013-02-13','10:20:00',11.76),('7643','2013-02-13','10:25:00',11.94),('7643','2013-02-13','10:30:00',12.12),('7643','2013-02-13','10:35:00',12.29),('7643','2013-02-13','10:40:00',12.46),('7643','2013-02-13','10:45:00',12.64),('7643','2013-02-13','10:50:00',12.82),('7643','2013-02-13','10:55:00',12.93),('7643','2013-02-13','11:00:00',13.07),('7643','2013-02-13','11:05:00',13.19),('7643','2013-02-13','11:10:00',13.31),('7643','2013-02-13','11:15:00',13.38),('7643','2013-02-13','11:20:00',13.47),('7643','2013-02-13','11:25:00',13.57),('7643','2013-02-13','11:30:00',13.66),('7643','2013-02-13','11:35:00',13.73),('7643','2013-02-13','11:40:00',13.76),('7643','2013-02-13','11:45:00',13.77),('7643','2013-02-13','11:50:00',13.88),('7643','2013-02-13','11:55:00',13.93),('7643','2013-02-13','12:00:00',13.97),('7643','2013-02-13','12:05:00',13.98),('7643','2013-02-13','12:10:00',13.95),('7643','2013-02-13','12:15:00',14.01),('7643','2013-02-13','12:20:00',13.97),('7643','2013-02-13','12:25:00',13.92),('7643','2013-02-13','12:30:00',13.84),('7643','2013-02-13','12:35:00',13.84),('7643','2013-02-13','12:40:00',13.84),('7643','2013-02-13','12:45:00',13.75),('7643','2013-02-13','12:50:00',13.65),('7643','2013-02-13','12:55:00',13.63),('7643','2013-02-13','13:00:00',13.52),('7643','2013-02-13','13:05:00',13.39),('7643','2013-02-13','13:10:00',13.43),('7643','2013-02-13','13:15:00',13.41),('7643','2013-02-13','13:20:00',13.25),('7643','2013-02-13','13:25:00',13.11),('7643','2013-02-13','13:30:00',12.98),('7643','2013-02-13','13:35:00',12.84),('7643','2013-02-13','13:40:00',12.72),('7643','2013-02-13','13:45:00',12.54),('7643','2013-02-13','13:50:00',12.38),('7643','2013-02-13','13:55:00',12.21),('7643','2013-02-13','14:00:00',12.01),('7643','2013-02-13','14:05:00',11.87),('7643','2013-02-13','14:10:00',11.63),('7643','2013-02-13','14:15:00',11.44),('7643','2013-02-13','14:20:00',11.26),('7643','2013-02-13','14:25:00',10.98),('7643','2013-02-13','14:30:00',10.76),('7643','2013-02-13','14:35:00',10.48),('7643','2013-02-13','14:40:00',10.28),('7643','2013-02-13','14:45:00',10.04),('7643','2013-02-13','14:50:00',9.75),('7643','2013-02-13','14:55:00',9.47),('7643','2013-02-13','15:00:00',9.22),('7643','2013-02-13','15:05:00',8.91),('7643','2013-02-13','15:10:00',8.58),('7643','2013-02-13','15:15:00',8.37),('7643','2013-02-13','15:20:00',7.99),('7643','2013-02-13','15:25:00',7.66),('7643','2013-02-13','15:30:00',7.4),('7643','2013-02-13','15:35:00',7.03),('7643','2013-02-13','15:40:00',6.67),('7643','2013-02-13','15:45:00',6.38),('7643','2013-02-13','15:50:00',6.05),('7643','2013-02-13','15:55:00',5.68),('7643','2013-02-13','16:00:00',5.31),('7643','2013-02-13','16:05:00',4.96),('7643','2013-02-13','16:10:00',4.57),('7643','2013-02-13','16:15:00',4.21),('7643','2013-02-13','16:20:00',3.84),('7643','2013-02-13','16:25:00',3.48),('7643','2013-02-13','16:30:00',3.11),('7643','2013-02-13','16:35:00',2.75),('7643','2013-02-13','16:40:00',2.4),('7643','2013-02-13','16:45:00',2.07),('7643','2013-02-13','16:50:00',1.74),('7643','2013-02-13','16:55:00',1.43),('7643','2013-02-13','17:00:00',1.14),('7643','2013-02-12','08:15:00',1.19),('7643','2013-02-12','08:20:00',1.38),('7643','2013-02-12','08:25:00',1.56),('7643','2013-02-12','08:30:00',1.76),('7643','2013-02-12','08:35:00',1.97),('7643','2013-02-12','08:40:00',2.21),('7643','2013-02-12','08:45:00',2.5),('7643','2013-02-12','08:50:00',2.82),('7643','2013-02-12','08:55:00',3.4),('7643','2013-02-12','09:00:00',4.06),('7643','2013-02-12','09:05:00',4.75),('7643','2013-02-12','09:10:00',5.12),('7643','2013-02-12','09:15:00',5.19),('7643','2013-02-12','09:20:00',5.13),('7643','2013-02-12','09:25:00',5.31),('7643','2013-02-12','09:30:00',6.47),('7643','2013-02-12','09:35:00',7.82),('7643','2013-02-12','09:40:00',8.8),('7643','2013-02-12','09:45:00',9.37),('7643','2013-02-12','09:50:00',9.75),('7643','2013-02-12','09:55:00',9.63),('7643','2013-02-12','10:00:00',9.18),('7643','2013-02-12','10:05:00',10.1),('7643','2013-02-12','10:10:00',10.48),('7643','2013-02-12','10:15:00',11.2),('7643','2013-02-12','10:20:00',11.46),('7643','2013-02-12','10:25:00',11.93),('7643','2013-02-12','10:30:00',12.35),('7643','2013-02-12','10:35:00',12.41),('7643','2013-02-12','10:40:00',12.43),('7643','2013-02-12','10:45:00',13.07),('7643','2013-02-12','10:50:00',13.3),('7643','2013-02-12','10:55:00',13.36),('7643','2013-02-12','11:00:00',13.5),('7643','2013-02-12','11:05:00',12.87),('7643','2013-02-12','11:10:00',12.96),('7643','2013-02-12','11:15:00',13.46),('7643','2013-02-12','11:20:00',12.82),('7643','2013-02-12','11:25:00',11.62),('7643','2013-02-12','11:30:00',9.82),('7643','2013-02-12','11:35:00',7.38),('7643','2013-02-12','11:40:00',7.31),('7643','2013-02-12','11:45:00',8),('7643','2013-02-12','11:50:00',10.13),('7643','2013-02-12','11:55:00',6.48),('7643','2013-02-12','12:00:00',4.14),('7643','2013-02-12','12:05:00',5.26),('7643','2013-02-12','12:10:00',10.71),('7643','2013-02-12','12:15:00',6.79),('7643','2013-02-12','12:20:00',9.02),('7643','2013-02-12','12:25:00',4.76),('7643','2013-02-12','12:30:00',3.9),('7643','2013-02-12','12:35:00',4.9),('7643','2013-02-12','12:40:00',4.22),('7643','2013-02-12','12:45:00',7.97),('7643','2013-02-12','12:50:00',10.52),('7643','2013-02-12','12:55:00',11.07),('7643','2013-02-12','13:00:00',9.32),('7643','2013-02-12','13:05:00',11.3),('7643','2013-02-12','13:10:00',9.75),('7643','2013-02-12','13:15:00',5.49),('7643','2013-02-12','13:20:00',13.55),('7643','2013-02-12','13:25:00',13.1),('7643','2013-02-12','13:30:00',13.89),('7643','2013-02-12','13:35:00',13.26),('7643','2013-02-12','13:40:00',11.72),('7643','2013-02-12','13:45:00',10.34),('7643','2013-02-12','13:50:00',10.5),('7643','2013-02-12','13:55:00',10.45),('7643','2013-02-12','14:00:00',11.75),('7643','2013-02-12','14:05:00',12.54),('7643','2013-02-12','14:10:00',11.47),('7643','2013-02-12','14:15:00',10.99),('7643','2013-02-12','14:20:00',10.21),('7643','2013-02-12','14:25:00',9.84),('7643','2013-02-12','14:30:00',10.59),('7643','2013-02-12','14:35:00',10.82),('7643','2013-02-12','14:40:00',10.39),('7643','2013-02-12','14:45:00',9.73),('7643','2013-02-12','14:50:00',9.89),('7643','2013-02-12','14:55:00',9.56),('7643','2013-02-12','15:00:00',9.28),('7643','2013-02-12','15:05:00',8.97),('7643','2013-02-12','15:10:00',8.6),('7643','2013-02-12','15:15:00',8.26),('7643','2013-02-12','15:20:00',8.03),('7643','2013-02-12','15:25:00',7.74),('7643','2013-02-12','15:30:00',7.46),('7643','2013-02-12','15:35:00',7.18),('7643','2013-02-12','15:40:00',6.81),('7643','2013-02-12','15:45:00',6.44),('7643','2013-02-12','15:50:00',6.1),('7643','2013-02-12','15:55:00',5.7),('7643','2013-02-12','16:00:00',5.32),('7643','2013-02-12','16:05:00',5.09),('7643','2013-02-12','16:10:00',4.72),('7643','2013-02-12','16:15:00',4.45),('7643','2013-02-12','16:20:00',3.99),('7643','2013-02-12','16:25:00',3.51),('7643','2013-02-12','16:30:00',3.14),('7643','2013-02-12','16:35:00',2.86),('7643','2013-02-12','16:40:00',2.53),('7643','2013-02-12','16:45:00',2.17),('7643','2013-02-12','16:50:00',1.66),('7643','2013-02-12','16:55:00',1.43),('7643','2013-02-11','11:25:00',1.1),('7643','2013-02-11','11:30:00',1.14),('7643','2013-02-11','11:35:00',1.34),('7643','2013-02-11','11:40:00',1.61),('7643','2013-02-11','11:45:00',1.76),('7643','2013-02-11','11:50:00',1.81),('7643','2013-02-11','11:55:00',1.7),('7643','2013-02-11','12:00:00',1.42),('7643','2013-02-11','12:05:00',1.58),('7643','2013-02-11','12:10:00',2.05),('7643','2013-02-11','12:15:00',2.1),('7643','2013-02-11','12:20:00',2.08),('7643','2013-02-11','12:25:00',2.08),('7643','2013-02-11','12:30:00',2.09),('7643','2013-02-11','12:35:00',1.88),('7643','2013-02-11','12:40:00',1.77),('7643','2013-02-11','12:45:00',1.61),('7643','2013-02-11','12:50:00',1.68),('7643','2013-02-11','12:55:00',1.52),('7643','2013-02-11','13:00:00',1.39),('7643','2013-02-11','13:05:00',1.45),('7643','2013-02-11','13:10:00',1.26),('7643','2013-02-11','13:15:00',1.33),('7643','2013-02-11','13:20:00',1.46),('7643','2013-02-11','13:25:00',1.47),('7643','2013-02-11','13:30:00',1.71),('7643','2013-02-11','13:35:00',1.74),('7643','2013-02-11','13:40:00',1.64),('7643','2013-02-11','13:45:00',1.61),('7643','2013-02-11','13:50:00',1.43),('7643','2013-02-11','13:55:00',1.23),('7643','2013-02-11','14:00:00',1.16),('7643','2013-02-11','14:05:00',1.12),('7643','2013-02-11','14:10:00',1.14),('7643','2013-02-11','14:15:00',1.08),('7643','2013-02-11','14:20:00',1.02),('7643','2013-02-11','14:25:00',1.18),('7643','2013-02-11','14:30:00',1.26),('7643','2013-02-11','14:35:00',1.11),('7643','2013-02-11','14:40:00',1.07),('7643','2013-02-11','14:45:00',1.07),('7643','2013-02-11','14:50:00',1.06),('7643','2013-02-11','14:55:00',1.1),('7643','2013-02-11','15:00:00',1.18),('7643','2013-02-11','15:05:00',1.18),('7643','2013-02-11','15:10:00',1.06),('7643','2013-02-11','15:15:00',1.04),('7643','2013-02-11','15:20:00',1.01),('7643','2013-02-10','08:20:00',1.26),('7643','2013-02-10','08:35:00',1.15),('7643','2013-02-10','08:40:00',1.16),('7643','2013-02-10','08:45:00',1.2),('7643','2013-02-10','08:50:00',1.16),('7643','2013-02-10','08:55:00',1.34),('7643','2013-02-10','09:00:00',1.76),('7643','2013-02-10','09:05:00',1.9),('7643','2013-02-10','09:10:00',1.77),('7643','2013-02-10','09:15:00',2.01),('7643','2013-02-10','09:20:00',1.94),('7643','2013-02-10','09:25:00',1.95),('7643','2013-02-10','09:30:00',2.55),('7643','2013-02-10','09:35:00',2.39),('7643','2013-02-10','09:40:00',2.08),('7643','2013-02-10','09:45:00',1.75),('7643','2013-02-10','09:50:00',1.68),('7643','2013-02-10','09:55:00',1.84),('7643','2013-02-10','10:00:00',2.03),('7643','2013-02-10','10:05:00',2.05),('7643','2013-02-10','10:10:00',2.27),('7643','2013-02-10','10:15:00',2.81),('7643','2013-02-10','10:20:00',3.51),('7643','2013-02-10','10:25:00',3.7),('7643','2013-02-10','10:30:00',4.03),('7643','2013-02-10','10:35:00',4.66),('7643','2013-02-10','10:40:00',4.03),('7643','2013-02-10','10:45:00',3.08),('7643','2013-02-10','10:50:00',2.7),('7643','2013-02-10','10:55:00',2.66),('7643','2013-02-10','11:00:00',4.06),('7643','2013-02-10','11:05:00',5.11),('7643','2013-02-10','11:10:00',5.27),('7643','2013-02-10','11:15:00',5.34),('7643','2013-02-10','11:20:00',4.29),('7643','2013-02-10','11:25:00',2.99),('7643','2013-02-10','11:30:00',1.54),('7643','2013-02-10','11:35:00',2.13),('7643','2013-02-10','11:40:00',2.54),('7643','2013-02-10','11:45:00',3.57),('7643','2013-02-10','11:50:00',2.49),('7643','2013-02-10','11:55:00',2.15),('7643','2013-02-10','12:00:00',1.46),('7643','2013-02-10','12:05:00',1.25),('7643','2013-02-10','12:10:00',1.41),('7643','2013-02-10','12:15:00',1.42),('7643','2013-02-10','12:20:00',1.3),('7643','2013-02-10','12:25:00',1.55),('7643','2013-02-10','12:30:00',1.16),('7643','2013-02-10','12:35:00',1.86),('7643','2013-02-10','12:40:00',2.66),('7643','2013-02-10','12:45:00',4.54),('7643','2013-02-10','12:50:00',2.47),('7643','2013-02-10','12:55:00',2.08),('7643','2013-02-10','13:00:00',1.54),('7643','2013-02-10','13:05:00',1.42),('7643','2013-02-10','13:15:00',1.07),('7643','2013-02-10','13:50:00',1.5),('7643','2013-02-10','13:55:00',3.01),('7643','2013-02-10','14:00:00',3.52),('7643','2013-02-10','14:05:00',3.79),('7643','2013-02-10','14:10:00',4.12),('7643','2013-02-10','14:15:00',3.45),('7643','2013-02-10','14:20:00',3.64),('7643','2013-02-10','14:25:00',5.46),('7643','2013-02-10','14:30:00',7.29),('7643','2013-02-10','14:35:00',3.93),('7643','2013-02-10','14:40:00',5.65),('7643','2013-02-10','14:45:00',4.8),('7643','2013-02-10','14:50:00',3.15),('7643','2013-02-10','14:55:00',2.73),('7643','2013-02-10','15:00:00',2.02),('7643','2013-02-10','15:05:00',3.11),('7643','2013-02-10','15:10:00',4.19),('7643','2013-02-10','15:15:00',2.44),('7643','2013-02-10','15:20:00',2.48),('7643','2013-02-10','15:25:00',2.53),('7643','2013-02-10','15:30:00',2.28),('7643','2013-02-10','15:35:00',2.47),('7643','2013-02-10','15:40:00',2.63),('7643','2013-02-10','15:45:00',2.78),('7643','2013-02-10','15:50:00',2.45),('7643','2013-02-10','15:55:00',1.65),('7643','2013-02-10','16:20:00',1.06),('7643','2013-02-10','16:35:00',1.05),('7643','2014-03-21','07:00:00',1.04),('7643','2014-03-21','07:05:00',1.04),('7643','2014-03-21','07:10:00',1.1),('7643','2014-03-21','07:15:00',1.31),('7643','2014-03-21','07:20:00',1.35),('7643','2014-03-21','07:25:00',1.66),('7643','2014-03-21','07:30:00',2.09),('7643','2014-03-21','07:35:00',3.32),('7643','2014-03-21','07:40:00',5.35),('7643','2014-03-21','07:45:00',5.03),('7643','2014-03-21','07:50:00',4.53),('7643','2014-03-21','07:55:00',2.58),('7643','2014-03-21','08:00:00',1.95),('7643','2014-03-21','08:05:00',2.34),('7643','2014-03-21','08:10:00',4.12),('7643','2014-03-21','08:15:00',5.87),('7643','2014-03-21','08:20:00',7.04),('7643','2014-03-21','08:25:00',6.93),('7643','2014-03-21','08:30:00',7.64),('7643','2014-03-21','08:35:00',3.57),('7643','2014-03-21','08:40:00',6.52),('7643','2014-03-21','08:45:00',9.59),('7643','2014-03-21','08:50:00',7.06),('7643','2014-03-21','08:55:00',7.47),('7643','2014-03-21','09:00:00',9.25),('7643','2014-03-21','09:05:00',4.77),('7643','2014-03-21','09:10:00',5.57),('7643','2014-03-21','09:15:00',4.84),('7643','2014-03-21','09:20:00',5.15),('7643','2014-03-21','09:25:00',6.01),('7643','2014-03-21','09:30:00',8.12),('7643','2014-03-21','09:35:00',6.21),('7643','2014-03-21','09:40:00',8.34),('7643','2014-03-21','09:45:00',12.21),('7643','2014-03-21','09:50:00',12.29),('7643','2014-03-21','09:55:00',12.71),('7643','2014-03-21','10:00:00',13.08),('7643','2014-03-21','10:05:00',13.2),('7643','2014-03-21','10:10:00',13.94),('7643','2014-03-21','10:15:00',8.55),('7643','2014-03-21','10:20:00',4.81),('7643','2014-03-21','10:25:00',4.2),('7643','2014-03-21','10:30:00',4.56),('7643','2014-03-21','10:35:00',6.44),('7643','2014-03-21','10:40:00',8.89),('7643','2014-03-21','10:45:00',12.2),('7643','2014-03-21','10:50:00',11.7),('7643','2014-03-21','10:55:00',6.52),('7643','2014-03-21','11:00:00',4.63),('7643','2014-03-21','11:05:00',6.1),('7643','2014-03-21','11:10:00',4.41),('7643','2014-03-21','11:15:00',5.93),('7643','2014-03-21','11:20:00',7.98),('7643','2014-03-21','11:25:00',16.47),('7643','2014-03-21','11:30:00',9.34),('7643','2014-03-21','11:35:00',6.24),('7643','2014-03-21','11:40:00',10.23),('7643','2014-03-21','11:45:00',8.75),('7643','2014-03-21','11:50:00',8.46),('7643','2014-03-21','11:55:00',12.72),('7643','2014-03-21','12:00:00',13.1),('7643','2014-03-21','12:05:00',6.9),('7643','2014-03-21','12:10:00',7.36),('7643','2014-03-21','12:15:00',13.43),('7643','2014-03-21','12:20:00',18.27),('7643','2014-03-21','12:25:00',9.74),('7643','2014-03-21','12:30:00',7.14),('7643','2014-03-21','12:35:00',11.3),('7643','2014-03-21','12:40:00',11.9),('7643','2014-03-21','12:45:00',11.4),('7643','2014-03-21','12:50:00',15.36),('7643','2014-03-21','12:55:00',10.26),('7643','2014-03-21','13:00:00',11.19),('7643','2014-03-21','13:05:00',9.73),('7643','2014-03-21','13:10:00',12.77),('7643','2014-03-21','13:15:00',14.21),('7643','2014-03-21','13:20:00',13.27),('7643','2014-03-21','13:25:00',10.57),('7643','2014-03-21','13:30:00',13.05),('7643','2014-03-21','13:35:00',14.94),('7643','2014-03-21','13:40:00',13.52),('7643','2014-03-21','13:45:00',12.68),('7643','2014-03-21','13:50:00',9.68),('7643','2014-03-21','13:55:00',7.64),('7643','2014-03-21','14:00:00',14.75),('7643','2014-03-21','14:05:00',11),('7643','2014-03-21','14:10:00',14.01),('7643','2014-03-21','14:15:00',13.51),('7643','2014-03-21','14:20:00',13.35),('7643','2014-03-21','14:25:00',12.8),('7643','2014-03-21','14:30:00',12.46),('7643','2014-03-21','14:35:00',12.28),('7643','2014-03-21','14:40:00',12),('7643','2014-03-21','14:45:00',11.83),('7643','2014-03-21','14:50:00',11.67),('7643','2014-03-21','14:55:00',11.37),('7643','2014-03-21','15:00:00',11.1),('7643','2014-03-21','15:05:00',10.98),('7643','2014-03-21','15:10:00',10.49),('7643','2014-03-21','15:15:00',9.99),('7643','2014-03-21','15:20:00',10.06),('7643','2014-03-21','15:25:00',8.5),('7643','2014-03-21','15:30:00',5.56),('7643','2014-03-21','15:35:00',6.79),('7643','2014-03-21','15:40:00',6.6),('7643','2014-03-21','15:45:00',6.8),('7643','2014-03-21','15:50:00',10.2),('7643','2014-03-21','15:55:00',10.07),('7643','2014-03-21','16:00:00',7.74),('7643','2014-03-21','16:05:00',7.79),('7643','2014-03-21','16:10:00',7.32),('7643','2014-03-21','16:15:00',5.39),('7643','2014-03-21','16:20:00',5.11),('7643','2014-03-21','16:25:00',3.35),('7643','2014-03-21','16:30:00',2.89),('7643','2014-03-21','16:35:00',1.97),('7643','2014-03-21','16:40:00',2.06),('7643','2014-03-21','16:45:00',1.55),('7643','2014-03-21','16:50:00',1.66),('7643','2014-03-21','16:55:00',2.17),('7643','2014-03-21','17:00:00',2.48),('7643','2014-03-21','17:05:00',2.14),('7643','2014-03-21','17:10:00',1.46),('7643','2014-03-21','17:25:00',1.39),('7643','2014-03-21','17:30:00',1.42),('7643','2014-03-21','17:35:00',1.16),('7643','2013-02-09','08:55:00',1.21),('7643','2013-02-09','09:00:00',1.56),('7643','2013-02-09','09:05:00',2.04),('7643','2013-02-09','09:10:00',2.21),('7643','2013-02-09','09:15:00',2.52),('7643','2013-02-09','09:20:00',2.18),('7643','2013-02-09','09:25:00',1.69),('7643','2013-02-09','09:30:00',1.94),('7643','2013-02-09','09:35:00',2.22),('7643','2013-02-09','09:40:00',3.58),('7643','2013-02-09','09:45:00',2.69),('7643','2013-02-09','09:50:00',6.63),('7643','2013-02-09','09:55:00',6.32),('7643','2013-02-09','10:00:00',8),('7643','2013-02-09','10:05:00',10.96),('7643','2013-02-09','10:10:00',10.46),('7643','2013-02-09','10:15:00',11.22),('7643','2013-02-09','10:20:00',11.39),('7643','2013-02-09','10:25:00',11.65),('7643','2013-02-09','10:30:00',11.9),('7643','2013-02-09','10:35:00',12.09),('7643','2013-02-09','10:40:00',12.19),('7643','2013-02-09','10:45:00',12.36),('7643','2013-02-09','10:50:00',12.5),('7643','2013-02-09','10:55:00',12.62),('7643','2013-02-09','11:00:00',12.75),('7643','2013-02-09','11:05:00',12.77),('7643','2013-02-09','11:10:00',12.92),('7643','2013-02-09','11:15:00',13.08),('7643','2013-02-09','11:20:00',13.16),('7643','2013-02-09','11:25:00',13.24),('7643','2013-02-09','11:30:00',13.34),('7643','2013-02-09','11:35:00',13.39),('7643','2013-02-09','11:40:00',13.52),('7643','2013-02-09','11:45:00',13.58),('7643','2013-02-09','11:50:00',13.57),('7643','2013-02-09','11:55:00',13.75),('7643','2013-02-09','12:00:00',13.83),('7643','2013-02-09','12:05:00',13.75),('7643','2013-02-09','12:10:00',13.75),('7643','2013-02-09','12:15:00',13.89),('7643','2013-02-09','12:20:00',13.86),('7643','2013-02-09','12:25:00',13.85),('7643','2013-02-09','12:30:00',13.83),('7643','2013-02-09','12:35:00',13.73),('7643','2013-02-09','12:40:00',13.62),('7643','2013-02-09','12:45:00',13.58),('7643','2013-02-09','12:50:00',13.51),('7643','2013-02-09','12:55:00',13.48),('7643','2013-02-09','13:00:00',13.33),('7643','2013-02-09','13:05:00',13.03),('7643','2013-02-09','13:10:00',12.91),('7643','2013-02-09','13:15:00',12.94),('7643','2013-02-09','13:20:00',12.77),('7643','2013-02-09','13:25:00',12.69),('7643','2013-02-09','13:30:00',12.63),('7643','2013-02-09','13:35:00',12.34),('7643','2013-02-09','13:40:00',12.12),('7643','2013-02-09','13:45:00',11.94),('7643','2013-02-09','13:50:00',11.86),('7643','2013-02-09','13:55:00',11.72),('7643','2013-02-09','14:00:00',11.39),('7643','2013-02-09','14:05:00',11.14),('7643','2013-02-09','14:10:00',10.96),('7643','2013-02-09','14:15:00',10.74),('7643','2013-02-09','14:20:00',10.61),('7643','2013-02-09','14:25:00',10.29),('7643','2013-02-09','14:30:00',10.14),('7643','2013-02-09','14:35:00',9.99),('7643','2013-02-09','14:40:00',8.29),('7643','2013-02-09','14:45:00',9.59),('7643','2013-02-09','14:50:00',9.37),('7643','2013-02-09','14:55:00',8.96),('7643','2013-02-09','15:00:00',5.03),('7643','2013-02-09','15:05:00',5.76),('7643','2013-02-09','15:10:00',5.86),('7643','2013-02-09','15:15:00',6.3),('7643','2013-02-09','15:20:00',3.63),('7643','2013-02-09','15:25:00',7.45),('7643','2013-02-09','15:30:00',6.69),('7643','2013-02-09','15:35:00',6.33),('7643','2013-02-09','15:40:00',3.43),('7643','2013-02-09','15:45:00',2.51),('7643','2013-02-09','15:50:00',1.7),('7643','2013-02-09','15:55:00',1.21),('7643','2013-02-09','16:00:00',1.22),('7643','2013-02-09','16:05:00',1.41),('7643','2013-02-09','16:10:00',1.36),('7643','2013-02-09','16:15:00',1.32),('7643','2013-02-09','16:20:00',1.89),('7643','2013-02-09','16:25:00',3.24),('7643','2013-02-09','16:30:00',3.14),('7643','2013-02-09','16:35:00',3.53),('7643','2013-02-09','16:40:00',2.65),('7643','2013-02-08','08:50:00',1.18),('7643','2013-02-08','08:55:00',1.27),('7643','2013-02-08','09:00:00',1.38),('7643','2013-02-08','09:05:00',1.66),('7643','2013-02-08','09:10:00',2.08),('7643','2013-02-08','09:15:00',2.27),('7643','2013-02-08','09:20:00',2.37),('7643','2013-02-08','09:25:00',2.74),('7643','2013-02-08','09:30:00',3.28),('7643','2013-02-08','09:35:00',3.52),('7643','2013-02-08','09:40:00',3.01),('7643','2013-02-08','09:45:00',2.66),('7643','2013-02-08','09:50:00',2.71),('7643','2013-02-08','09:55:00',2.65),('7643','2013-02-08','10:00:00',2.41),('7643','2013-02-08','10:05:00',2.26),('7643','2013-02-08','10:10:00',2.07),('7643','2013-02-08','10:15:00',1.94),('7643','2013-02-08','10:20:00',1.88),('7643','2013-02-08','10:25:00',1.91),('7643','2013-02-08','10:30:00',2.02),('7643','2013-02-08','10:35:00',2.18),('7643','2013-02-08','10:40:00',2.47),('7643','2013-02-08','10:45:00',3.06),('7643','2013-02-08','10:50:00',3.27),('7643','2013-02-08','10:55:00',3.5),('7643','2013-02-08','11:00:00',3.74),('7643','2013-02-08','11:05:00',3.87),('7643','2013-02-08','11:10:00',4),('7643','2013-02-08','11:15:00',4.2),('7643','2013-02-08','11:20:00',4.33),('7643','2013-02-08','11:25:00',4.41),('7643','2013-02-08','11:30:00',4.5),('7643','2013-02-08','11:35:00',4.36),('7643','2013-02-08','11:40:00',4.26),('7643','2013-02-08','11:45:00',4.35),('7643','2013-02-08','11:50:00',4.33),('7643','2013-02-08','11:55:00',4.19),('7643','2013-02-08','12:00:00',4.25),('7643','2013-02-08','12:05:00',4.22),('7643','2013-02-08','12:10:00',4.17),('7643','2013-02-08','12:15:00',4.21),('7643','2013-02-08','12:20:00',4.29),('7643','2013-02-08','12:25:00',4.31),('7643','2013-02-08','12:30:00',4.38),('7643','2013-02-08','12:35:00',4.64),('7643','2013-02-08','12:40:00',4.75),('7643','2013-02-08','12:45:00',4.76),('7643','2013-02-08','12:50:00',4.83),('7643','2013-02-08','12:55:00',4.77),('7643','2013-02-08','13:00:00',5.07),('7643','2013-02-08','13:05:00',5.84),('7643','2013-02-08','13:10:00',6.48),('7643','2013-02-08','13:15:00',7.13),('7643','2013-02-08','13:20:00',7.96),('7643','2013-02-08','13:25:00',8.51),('7643','2013-02-08','13:30:00',9.93),('7643','2013-02-08','13:35:00',9.95),('7643','2013-02-08','13:40:00',10.55),('7643','2013-02-08','13:45:00',11.17),('7643','2013-02-08','13:50:00',12.15),('7643','2013-02-08','13:55:00',11.47),('7643','2013-02-08','14:00:00',12.2),('7643','2013-02-08','14:05:00',10.75),('7643','2013-02-08','14:10:00',9.62),('7643','2013-02-08','14:15:00',10.23),('7643','2013-02-08','14:20:00',13.15),('7643','2013-02-08','14:25:00',13.25),('7643','2013-02-08','14:30:00',12.05),('7643','2013-02-08','14:35:00',10.93),('7643','2013-02-08','14:40:00',9.91),('7643','2013-02-08','14:45:00',9.25),('7643','2013-02-08','14:50:00',8.88),('7643','2013-02-08','14:55:00',9),('7643','2013-02-08','15:00:00',8.61),('7643','2013-02-08','15:05:00',8.22),('7643','2013-02-08','15:10:00',7.9),('7643','2013-02-08','15:15:00',7.64),('7643','2013-02-08','15:20:00',7.18),('7643','2013-02-08','15:25:00',6.71),('7643','2013-02-08','15:30:00',6.2),('7643','2013-02-08','15:35:00',6.26),('7643','2013-02-08','15:40:00',5.35),('7643','2013-02-08','15:45:00',3.73),('7643','2013-02-08','15:50:00',5.29),('7643','2013-02-08','15:55:00',5.08),('7643','2013-02-08','16:00:00',1.92),('7643','2013-02-08','16:05:00',1.43),('7643','2013-02-08','16:10:00',1.1),('7643','2013-02-08','16:15:00',1.08),('7643','2013-02-08','16:20:00',1.88),('7643','2013-02-08','16:25:00',2.73),('7643','2013-02-08','16:30:00',2.62),('7643','2013-02-08','16:35:00',2.36),('7643','2013-02-08','16:40:00',2.26),('7643','2013-02-08','16:45:00',1.8),('7643','2013-02-08','16:50:00',1.46),('7643','2013-02-08','16:55:00',1.59),('7643','2013-02-08','17:00:00',1.52),('7643','2013-02-08','17:05:00',1.2),('7643','2013-02-07','08:30:00',1.12),('7643','2013-02-07','08:35:00',1.37),('7643','2013-02-07','08:40:00',1.6),('7643','2013-02-07','08:45:00',1.77),('7643','2013-02-07','08:50:00',1.92),('7643','2013-02-07','08:55:00',2.21),('7643','2013-02-07','09:00:00',2.17),('7643','2013-02-07','09:05:00',2.04),('7643','2013-02-07','09:10:00',1.87),('7643','2013-02-07','09:15:00',2.01),('7643','2013-02-07','09:20:00',2.31),('7643','2013-02-07','09:25:00',2.63),('7643','2013-02-07','09:30:00',3.16),('7643','2013-02-07','09:35:00',6.61),('7643','2013-02-07','09:40:00',11.77),('7643','2013-02-07','09:45:00',9.38),('7643','2013-02-07','09:50:00',11.8),('7643','2013-02-07','09:55:00',11.62),('7643','2013-02-07','10:00:00',12.04),('7643','2013-02-07','10:05:00',12.86),('7643','2013-02-07','10:10:00',12.96),('7643','2013-02-07','10:15:00',12.81),('7643','2013-02-07','10:20:00',9.26),('7643','2013-02-07','10:25:00',10.74),('7643','2013-02-07','10:30:00',12.91),('7643','2013-02-07','10:35:00',5.27),('7643','2013-02-07','10:40:00',7.94),('7643','2013-02-07','10:45:00',12.18),('7643','2013-02-07','10:50:00',14.07),('7643','2013-02-07','10:55:00',13.74),('7643','2013-02-07','11:00:00',13.37),('7643','2013-02-07','11:05:00',13.17),('7643','2013-02-07','11:10:00',13.22),('7643','2013-02-07','11:15:00',13.23),('7643','2013-02-07','11:20:00',13.3),('7643','2013-02-07','11:25:00',13.33),('7643','2013-02-07','11:30:00',13.35),('7643','2013-02-07','11:35:00',13.38),('7643','2013-02-07','11:40:00',13.49),('7643','2013-02-07','11:45:00',13.47),('7643','2013-02-07','11:50:00',13.51),('7643','2013-02-07','11:55:00',13.51),('7643','2013-02-07','12:00:00',13.55),('7643','2013-02-07','12:05:00',13.61),('7643','2013-02-07','12:10:00',13.64),('7643','2013-02-07','12:15:00',13.64),('7643','2013-02-07','12:20:00',13.62),('7643','2013-02-07','12:25:00',13.65),('7643','2013-02-07','12:30:00',13.61),('7643','2013-02-07','12:35:00',13.63),('7643','2013-02-07','12:40:00',14),('7643','2013-02-07','12:45:00',14.76),('7643','2013-02-07','12:50:00',10.56),('7643','2013-02-07','12:55:00',7.79),('7643','2013-02-07','13:00:00',7.74),('7643','2013-02-07','13:05:00',6.96),('7643','2013-02-07','13:10:00',7.69),('7643','2013-02-07','13:15:00',7.34),('7643','2013-02-07','13:20:00',7.43),('7643','2013-02-07','13:25:00',7.24),('7643','2013-02-07','13:30:00',7.12),('7643','2013-02-07','13:35:00',9.39),('7643','2013-02-07','13:40:00',7.67),('7643','2013-02-07','13:45:00',6.03),('7643','2013-02-07','13:50:00',6.24),('7643','2013-02-07','13:55:00',6.28),('7643','2013-02-07','14:00:00',5.79),('7643','2013-02-07','14:05:00',5.77),('7643','2013-02-07','14:10:00',5.19),('7643','2013-02-07','14:15:00',4.69),('7643','2013-02-07','14:20:00',4.68),('7643','2013-02-07','14:25:00',5.05),('7643','2013-02-07','14:30:00',6.57),('7643','2013-02-07','14:35:00',7.62),('7643','2013-02-07','14:40:00',13.08),('7643','2013-02-07','14:45:00',12.43),('7643','2013-02-07','14:50:00',7.79),('7643','2013-02-07','14:55:00',8.75),('7643','2013-02-07','15:00:00',8.98),('7643','2013-02-07','15:05:00',11.76),('7643','2013-02-07','15:10:00',11.41),('7643','2013-02-07','15:15:00',10.23),('7643','2013-02-07','15:20:00',8.08),('7643','2013-02-07','15:25:00',8.21),('7643','2013-02-07','15:30:00',7.44),('7643','2013-02-07','15:35:00',6.99),('7643','2013-02-07','15:40:00',6.59),('7643','2013-02-07','15:45:00',6.25),('7643','2013-02-07','15:50:00',5.89),('7643','2013-02-07','15:55:00',5.45),('7643','2013-02-07','16:00:00',5.06),('7643','2013-02-07','16:05:00',4.63),('7643','2013-02-07','16:10:00',4.3),('7643','2013-02-07','16:15:00',3.46),('7643','2013-02-07','16:20:00',1.57),('7643','2013-02-07','16:30:00',1.06),('7643','2013-02-07','16:35:00',1.19),('7643','2013-02-07','16:40:00',1.03),('7643','2013-02-06','08:00:00',1.08),('7643','2013-02-06','09:10:00',1),('7643','2013-02-06','09:15:00',1.99),('7643','2013-02-06','09:20:00',2.31),('7643','2013-02-06','09:25:00',1.95),('7643','2013-02-06','09:30:00',1.93),('7643','2013-02-06','09:35:00',1.91),('7643','2013-02-06','09:40:00',1.97),('7643','2013-02-06','09:45:00',2.13),('7643','2013-02-06','09:50:00',2.3),('7643','2013-02-06','09:55:00',1.62),('7643','2013-02-06','10:00:00',1.25),('7643','2013-02-06','10:05:00',1.04),('7643','2013-02-06','10:20:00',1.46),('7643','2013-02-06','10:25:00',2.62),('7643','2013-02-06','10:30:00',2.49),('7643','2013-02-06','10:35:00',3.32),('7643','2013-02-06','10:40:00',4.19),('7643','2013-02-06','10:45:00',5.76),('7643','2013-02-06','10:50:00',2.8),('7643','2013-02-06','10:55:00',4.98),('7643','2013-02-06','11:00:00',5.33),('7643','2013-02-06','11:05:00',5.05),('7643','2013-02-06','11:10:00',3.4),('7643','2013-02-06','11:15:00',2.11),('7643','2013-02-06','11:20:00',1.51),('7643','2013-02-06','11:25:00',1.64),('7643','2013-02-06','11:30:00',2.08),('7643','2013-02-06','11:35:00',1.91),('7643','2013-02-06','12:20:00',2.6),('7643','2013-02-06','12:25:00',11.47),('7643','2013-02-06','12:30:00',8.33),('7643','2013-02-06','12:35:00',3.81),('7643','2013-02-06','12:40:00',2.24),('7643','2013-02-06','12:45:00',2.54),('7643','2013-02-06','12:50:00',2.74),('7643','2013-02-06','12:55:00',2.13),('7643','2013-02-06','13:00:00',1.78),('7643','2013-02-06','13:05:00',2.07),('7643','2013-02-06','13:10:00',2.63),('7643','2013-02-06','13:15:00',4.71),('7643','2013-02-06','13:20:00',5.14),('7643','2013-02-06','13:25:00',5.63),('7643','2013-02-06','13:30:00',4.17),('7643','2013-02-06','13:35:00',2.93),('7643','2013-02-06','13:40:00',3.3),('7643','2013-02-06','13:45:00',3.34),('7643','2013-02-06','13:50:00',3.42),('7643','2013-02-06','13:55:00',3.98),('7643','2013-02-06','14:00:00',4.93),('7643','2013-02-06','14:05:00',7.21),('7643','2013-02-06','14:10:00',11.66),('7643','2013-02-06','14:15:00',10.39),('7643','2013-02-06','14:20:00',7.65),('7643','2013-02-06','14:25:00',4.13),('7643','2013-02-06','14:30:00',3.3),('7643','2013-02-06','14:35:00',4.8),('7643','2013-02-06','14:40:00',5.54),('7643','2013-02-06','14:45:00',7.2),('7643','2013-02-06','14:50:00',5.98),('7643','2013-02-06','14:55:00',4.23),('7643','2013-02-06','15:00:00',7.47),('7643','2013-02-06','15:05:00',8.89),('7643','2013-02-06','15:10:00',10.01),('7643','2013-02-06','15:15:00',9),('7643','2013-02-06','15:20:00',5.76),('7643','2013-02-06','15:25:00',6.59),('7643','2013-02-06','15:30:00',4.98),('7643','2013-02-06','15:35:00',3.85),('7643','2013-02-06','15:40:00',2.73),('7643','2013-02-06','15:45:00',1.89),('7643','2013-02-06','15:50:00',2.04),('7643','2013-02-06','15:55:00',2),('7643','2013-02-06','16:00:00',1.55),('7643','2013-02-06','16:05:00',1.49),('7643','2013-02-06','16:10:00',1.1),('7643','2013-02-05','07:50:00',1.45),('7643','2013-02-05','07:55:00',1.63),('7643','2013-02-05','08:00:00',1.37),('7643','2013-02-05','08:05:00',1.3),('7643','2013-02-05','08:10:00',1.55),('7643','2013-02-05','08:15:00',1.6),('7643','2013-02-05','08:20:00',1.83),('7643','2013-02-05','08:25:00',1.9),('7643','2013-02-05','08:30:00',2.08),('7643','2013-02-05','08:35:00',2.64),('7643','2013-02-05','08:40:00',3.17),('7643','2013-02-05','08:45:00',4.1),('7643','2013-02-05','08:50:00',5.32),('7643','2013-02-05','08:55:00',4.02),('7643','2013-02-05','09:00:00',4.49),('7643','2013-02-05','09:05:00',4.84),('7643','2013-02-05','09:10:00',6.19),('7643','2013-02-05','09:15:00',3.88),('7643','2013-02-05','09:20:00',3.94),('7643','2013-02-05','09:25:00',4.38),('7643','2013-02-05','09:30:00',6.14),('7643','2013-02-05','09:35:00',4.46),('7643','2013-02-05','09:40:00',6.52),('7643','2013-02-05','09:45:00',4.77),('7643','2013-02-05','09:50:00',4.99),('7643','2013-02-05','09:55:00',6.38),('7643','2013-02-05','10:00:00',5.21),('7643','2013-02-05','10:05:00',7.19),('7643','2013-02-05','10:10:00',6.02),('7643','2013-02-05','10:15:00',5.27),('7643','2013-02-05','10:20:00',4.85),('7643','2013-02-05','10:25:00',6.57),('7643','2013-02-05','10:30:00',5.79),('7643','2013-02-05','10:35:00',7.58),('7643','2013-02-05','10:40:00',5.82),('7643','2013-02-05','10:45:00',4.24),('7643','2013-02-05','10:50:00',7.71),('7643','2013-02-05','10:55:00',8.75),('7643','2013-02-05','11:00:00',6.83),('7643','2013-02-05','11:05:00',5.29),('7643','2013-02-05','11:10:00',6.24),('7643','2013-02-05','11:15:00',5.42),('7643','2013-02-05','11:20:00',7.88),('7643','2013-02-05','11:25:00',11.97),('7643','2013-02-05','11:30:00',6.85),('7643','2013-02-05','11:35:00',5.72),('7643','2013-02-05','11:40:00',6.2),('7643','2013-02-05','11:45:00',6.29),('7643','2013-02-05','11:50:00',6.42),('7643','2013-02-05','11:55:00',5.82),('7643','2013-02-05','12:00:00',5.16),('7643','2013-02-05','12:05:00',4.34),('7643','2013-02-05','12:10:00',3.29),('7643','2013-02-05','12:15:00',3.97),('7643','2013-02-05','12:20:00',3.91),('7643','2013-02-05','12:25:00',3.83),('7643','2013-02-05','12:30:00',3.23),('7643','2013-02-05','12:35:00',2.81),('7643','2013-02-05','12:40:00',2.42),('7643','2013-02-05','12:45:00',2.35),('7643','2013-02-05','12:50:00',2.36),('7643','2013-02-05','12:55:00',2.35),('7643','2013-02-05','13:00:00',2.18),('7643','2013-02-05','13:05:00',2.09),('7643','2013-02-05','13:10:00',2.44),('7643','2013-02-05','13:15:00',2.93),('7643','2013-02-05','13:20:00',3.26),('7643','2013-02-05','13:25:00',3.61),('7643','2013-02-05','13:30:00',4.33),('7643','2013-02-05','13:35:00',4.65),('7643','2013-02-05','13:40:00',4.15),('7643','2013-02-05','13:45:00',3.63),('7643','2013-02-05','13:50:00',6.01),('7643','2013-02-05','13:55:00',5.04),('7643','2013-02-05','14:00:00',5.77),('7643','2013-02-05','14:05:00',4.81),('7643','2013-02-05','14:10:00',2.86),('7643','2013-02-05','14:15:00',1.53),('7643','2013-02-05','14:25:00',1.42),('7643','2013-02-05','14:30:00',5.89),('7643','2013-02-05','14:35:00',8.68),('7643','2013-02-05','14:40:00',5.94),('7643','2013-02-05','14:45:00',2.3),('7643','2013-02-05','15:05:00',1.08),('7643','2013-02-05','15:10:00',1.29),('7643','2013-02-05','15:15:00',1.96),('7643','2013-02-05','15:20:00',2.25),('7643','2013-02-05','15:25:00',3.22),('7643','2013-02-05','15:30:00',2.14),('7643','2013-02-05','15:35:00',1.12),('7643','2013-02-05','15:40:00',1.33),('7643','2013-02-05','15:45:00',2.19),('7643','2013-02-05','15:50:00',2.9),('7643','2013-02-05','15:55:00',1.51),('7643','2013-02-05','16:00:00',1.47),('7643','2013-02-05','16:05:00',1.49),('7643','2013-02-05','16:10:00',1.51),('7643','2013-02-05','16:15:00',1.5),('7643','2013-02-05','16:20:00',1.27),('7643','2013-02-04','07:45:00',1.08),('7643','2013-02-04','07:50:00',1.27),('7643','2013-02-04','07:55:00',1.51),('7643','2013-02-04','08:00:00',1.87),('7643','2013-02-04','08:05:00',2.18),('7643','2013-02-04','08:10:00',2.48),('7643','2013-02-04','08:15:00',2.82),('7643','2013-02-04','08:20:00',3.14),('7643','2013-02-04','08:25:00',3.51),('7643','2013-02-04','08:30:00',3.97),('7643','2013-02-04','08:35:00',4.51),('7643','2013-02-04','08:40:00',4.83),('7643','2013-02-04','08:45:00',5.15),('7643','2013-02-04','08:50:00',5.45),('7643','2013-02-04','08:55:00',5.8),('7643','2013-02-04','09:00:00',6.08),('7643','2013-02-04','09:05:00',6.31),('7643','2013-02-04','09:10:00',6.7),('7643','2013-02-04','09:15:00',7.06),('7643','2013-02-04','09:20:00',7.42),('7643','2013-02-04','09:25:00',7.75),('7643','2013-02-04','09:30:00',8),('7643','2013-02-04','09:35:00',8.34),('7643','2013-02-04','09:40:00',8.61),('7643','2013-02-04','09:45:00',8.8),('7643','2013-02-04','09:50:00',9.14),('7643','2013-02-04','09:55:00',9.3),('7643','2013-02-04','10:00:00',9.47),('7643','2013-02-04','10:05:00',9.7),('7643','2013-02-04','10:10:00',9.15),('7643','2013-02-04','10:15:00',9.32),('7643','2013-02-04','10:20:00',10.26),('7643','2013-02-04','10:25:00',10.56),('7643','2013-02-04','10:30:00',10.71),('7643','2013-02-04','10:35:00',10.85),('7643','2013-02-04','10:40:00',10.94),('7643','2013-02-04','10:45:00',10.9),('7643','2013-02-04','10:50:00',11.09),('7643','2013-02-04','10:55:00',11.16),('7643','2013-02-04','11:00:00',11.28),('7643','2013-02-04','11:05:00',11.35),('7643','2013-02-04','11:10:00',11.55),('7643','2013-02-04','11:15:00',11.6),('7643','2013-02-04','11:20:00',11.63),('7643','2013-02-04','11:25:00',11.72),('7643','2013-02-04','11:30:00',11.96),('7643','2013-02-04','11:35:00',11.14),('7643','2013-02-04','11:40:00',9.96),('7643','2013-02-04','11:45:00',8.41),('7643','2013-02-04','11:50:00',6.73),('7643','2013-02-04','11:55:00',5.42),('7643','2013-02-04','12:00:00',4.5),('7643','2013-02-04','12:05:00',4.67),('7643','2013-02-04','12:10:00',6.78),('7643','2013-02-04','12:15:00',6.5),('7643','2013-02-04','12:20:00',4.67),('7643','2013-02-04','12:25:00',4.42),('7643','2013-02-04','12:30:00',4.24),('7643','2013-02-04','12:35:00',5.02),('7643','2013-02-04','12:40:00',7.47),('7643','2013-02-04','12:45:00',7.23),('7643','2013-02-04','12:50:00',9.73),('7643','2013-02-04','12:55:00',3.71),('7643','2013-02-04','13:00:00',2.5),('7643','2013-02-04','13:05:00',2.91),('7643','2013-02-04','13:10:00',3.71),('7643','2013-02-04','13:15:00',4.8),('7643','2013-02-04','13:20:00',4.73),('7643','2013-02-04','13:25:00',4.4),('7643','2013-02-04','13:30:00',4.74),('7643','2013-02-04','13:35:00',3.49),('7643','2013-02-04','13:40:00',3.34),('7643','2013-02-04','13:45:00',4.54),('7643','2013-02-04','13:50:00',4.9),('7643','2013-02-04','13:55:00',4.19),('7643','2013-02-04','14:00:00',3.99),('7643','2013-02-04','14:05:00',4.28),('7643','2013-02-04','14:10:00',3.58),('7643','2013-02-04','14:15:00',3.69),('7643','2013-02-04','14:20:00',4.07),('7643','2013-02-04','14:25:00',5.86),('7643','2013-02-04','14:30:00',7.03),('7643','2013-02-04','14:35:00',4.97),('7643','2013-02-04','14:40:00',8.52),('7643','2013-02-04','14:45:00',6.91),('7643','2013-02-04','14:50:00',3.62),('7643','2013-02-04','14:55:00',3.24),('7643','2013-02-04','15:00:00',2.87),('7643','2013-02-04','15:05:00',3.98),('7643','2013-02-04','15:10:00',3.15),('7643','2013-02-04','15:15:00',2.4),('7643','2013-02-04','15:20:00',1.53),('7643','2013-02-04','15:25:00',1.07),('7643','2013-02-04','15:30:00',1.13),('7643','2013-02-03','07:45:00',1.13),('7643','2013-02-03','07:50:00',1.42),('7643','2013-02-03','07:55:00',1.76),('7643','2013-02-03','08:00:00',2.11),('7643','2013-02-03','08:05:00',2.51),('7643','2013-02-03','08:10:00',2.88),('7643','2013-02-03','08:15:00',3.26),('7643','2013-02-03','08:20:00',3.64),('7643','2013-02-03','08:25:00',4.03),('7643','2013-02-03','08:30:00',4.44),('7643','2013-02-03','08:35:00',4.84),('7643','2013-02-03','08:40:00',5.13),('7643','2013-02-03','08:45:00',5.47),('7643','2013-02-03','08:50:00',5.86),('7643','2013-02-03','08:55:00',5.39),('7643','2013-02-03','09:00:00',6.64),('7643','2013-02-03','09:05:00',7.11),('7643','2013-02-03','09:10:00',7.58),('7643','2013-02-03','09:15:00',7.83),('7643','2013-02-03','09:20:00',7.82),('7643','2013-02-03','09:25:00',7.69),('7643','2013-02-03','09:30:00',8.45),('7643','2013-02-03','09:35:00',8.47),('7643','2013-02-03','09:40:00',8.69),('7643','2013-02-03','09:45:00',7.96),('7643','2013-02-03','09:50:00',9.12),('7643','2013-02-03','09:55:00',10.07),('7643','2013-02-03','10:00:00',10.31),('7643','2013-02-03','10:05:00',10.53),('7643','2013-02-03','10:10:00',10.91),('7643','2013-02-03','10:15:00',11.28),('7643','2013-02-03','10:20:00',10.8),('7643','2013-02-03','10:25:00',11.21),('7643','2013-02-03','10:30:00',10.83),('7643','2013-02-03','10:35:00',10.17),('7643','2013-02-03','10:40:00',10.77),('7643','2013-02-03','10:45:00',11.8),('7643','2013-02-03','10:50:00',11.99),('7643','2013-02-03','10:55:00',11.97),('7643','2013-02-03','11:00:00',12.1),('7643','2013-02-03','11:05:00',12.34),('7643','2013-02-03','11:10:00',12.45),('7643','2013-02-03','11:15:00',12.52),('7643','2013-02-03','11:20:00',12.55),('7643','2013-02-03','11:25:00',12.67),('7643','2013-02-03','11:30:00',12.71),('7643','2013-02-03','11:35:00',12.79),('7643','2013-02-03','11:40:00',12.79),('7643','2013-02-03','11:45:00',12.86),('7643','2013-02-03','11:50:00',12.92),('7643','2013-02-03','11:55:00',12.94),('7643','2013-02-03','12:00:00',12.92),('7643','2013-02-03','12:05:00',12.98),('7643','2013-02-03','12:10:00',13.11),('7643','2013-02-03','12:15:00',13.06),('7643','2013-02-03','12:20:00',13),('7643','2013-02-03','12:25:00',12.95),('7643','2013-02-03','12:30:00',12.91),('7643','2013-02-03','12:35:00',12.83),('7643','2013-02-03','12:40:00',12.83),('7643','2013-02-03','12:45:00',12.83),('7643','2013-02-03','12:50:00',12.7),('7643','2013-02-03','12:55:00',12.59),('7643','2013-02-03','13:00:00',12.55),('7643','2013-02-03','13:05:00',12.58),('7643','2013-02-03','13:10:00',12.51),('7643','2013-02-03','13:15:00',12.43),('7643','2013-02-03','13:20:00',12.28),('7643','2013-02-03','13:25:00',12.16),('7643','2013-02-03','13:30:00',12.03),('7643','2013-02-03','13:35:00',11.88),('7643','2013-02-03','13:40:00',11.71),('7643','2013-02-03','13:45:00',11.61),('7643','2013-02-03','13:50:00',11.5),('7643','2013-02-03','13:55:00',11.44),('7643','2013-02-03','14:00:00',11.23),('7643','2013-02-03','14:05:00',11.07),('7643','2013-02-03','14:10:00',10.89),('7643','2013-02-03','14:15:00',10.67),('7643','2013-02-03','14:20:00',10.48),('7643','2013-02-03','14:25:00',10.26),('7643','2013-02-03','14:30:00',10.05),('7643','2013-02-03','14:35:00',9.76),('7643','2013-02-03','14:40:00',9.51),('7643','2013-02-03','14:45:00',9.31),('7643','2013-02-03','14:50:00',9.05),('7643','2013-02-03','14:55:00',8.73),('7643','2013-02-03','15:00:00',8.48),('7643','2013-02-03','15:05:00',8.19),('7643','2013-02-03','15:10:00',7.89),('7643','2013-02-03','15:15:00',7.57),('7643','2013-02-03','15:20:00',7.25),('7643','2013-02-03','15:25:00',6.98),('7643','2013-02-03','15:30:00',6.65),('7643','2013-02-03','15:35:00',6.31),('7643','2013-02-03','15:40:00',5.97),('7643','2013-02-03','15:45:00',5.64),('7643','2013-02-03','15:50:00',5.29),('7643','2013-02-03','15:55:00',4.94),('7643','2013-02-03','16:00:00',4.59),('7643','2013-02-03','16:05:00',4.27),('7643','2013-02-03','16:10:00',3.92),('7643','2013-02-03','16:15:00',3.53),('7643','2013-02-03','16:20:00',3.17),('7643','2013-02-03','16:25:00',2.8),('7643','2013-02-03','16:30:00',2.43),('7643','2013-02-03','16:35:00',2.05),('7643','2013-02-03','16:40:00',1.73),('7643','2013-02-03','16:45:00',1.42),('7643','2013-02-03','16:50:00',1.15),('7643','2013-02-02','08:05:00',1.98),('7643','2013-02-02','08:40:00',2.22),('7643','2013-02-02','08:45:00',2.45),('7643','2013-02-02','08:50:00',2.32),('7643','2013-02-02','08:55:00',1.63),('7643','2013-02-02','09:00:00',2.38),('7643','2013-02-02','09:05:00',2.34),('7643','2013-02-02','09:10:00',2.09),('7643','2013-02-02','09:15:00',2.86),('7643','2013-02-02','09:20:00',3.65),('7643','2013-02-02','09:25:00',4.53),('7643','2013-02-02','09:30:00',3.59),('7643','2013-02-02','09:35:00',3.11),('7643','2013-02-02','09:40:00',5.74),('7643','2013-02-02','09:45:00',7.84),('7643','2013-02-02','09:50:00',7.78),('7643','2013-02-02','09:55:00',6.36),('7643','2013-02-02','10:00:00',8.87),('7643','2013-02-02','10:05:00',3.9),('7643','2013-02-02','10:10:00',2.14),('7643','2013-02-02','10:15:00',1.95),('7643','2013-02-02','10:20:00',4.2),('7643','2013-02-02','10:25:00',2.31),('7643','2013-02-02','10:30:00',2.32),('7643','2013-02-02','10:35:00',1.6),('7643','2013-02-02','10:40:00',2.32),('7643','2013-02-02','11:10:00',1.32),('7643','2013-02-02','11:15:00',2.56),('7643','2013-02-02','11:20:00',4.86),('7643','2013-02-02','11:25:00',2.65),('7643','2013-02-02','11:30:00',1.15),('7643','2013-02-02','11:35:00',1.79),('7643','2013-02-02','11:40:00',1.63),('7643','2013-02-02','11:45:00',2.67),('7643','2013-02-02','11:50:00',3.46),('7643','2013-02-02','11:55:00',4.04),('7643','2013-02-02','12:00:00',4.24),('7643','2013-02-02','12:05:00',4.24),('7643','2013-02-02','12:10:00',3.98),('7643','2013-02-02','12:15:00',3.11),('7643','2013-02-02','12:20:00',2.53),('7643','2013-02-02','12:25:00',1.76),('7643','2013-02-02','12:30:00',1.46),('7643','2013-02-02','12:40:00',1.35),('7643','2013-02-02','12:50:00',1.68),('7643','2013-02-02','12:55:00',1.53),('7643','2013-02-02','13:45:00',1.43),('7643','2013-02-02','13:50:00',1.92),('7643','2013-02-02','13:55:00',1.74),('7643','2013-02-02','14:00:00',1.5),('7643','2013-02-02','14:35:00',1.01),('7643','2013-02-02','14:50:00',1.45),('7643','2013-02-02','14:55:00',1.9),('7643','2013-02-02','15:00:00',1.63),('7643','2013-02-02','15:05:00',1.26),('7643','2013-02-01','08:00:00',1.06),('7643','2013-02-01','08:05:00',1.05),('7643','2013-02-01','08:10:00',1.25),('7643','2013-02-01','08:15:00',1.37),('7643','2013-02-01','08:20:00',1.28),('7643','2013-02-01','08:25:00',1.11),('7643','2013-02-01','09:35:00',1.11),('7643','2013-02-01','09:40:00',1.29),('7643','2013-02-01','09:45:00',1.66),('7643','2013-02-01','09:50:00',1.53),('7643','2013-02-01','09:55:00',1.87),('7643','2013-02-01','10:00:00',1.86),('7643','2013-02-01','10:05:00',1.96),('7643','2013-02-01','10:10:00',2.41),('7643','2013-02-01','10:15:00',3.62),('7643','2013-02-01','10:20:00',4.09),('7643','2013-02-01','10:25:00',3.82),('7643','2013-02-01','10:30:00',4.37),('7643','2013-02-01','10:35:00',4.99),('7643','2013-02-01','10:40:00',5.48),('7643','2013-02-01','10:45:00',5.88),('7643','2013-02-01','10:50:00',5.17),('7643','2013-02-01','10:55:00',6.85),('7643','2013-02-01','11:00:00',7.93),('7643','2013-02-01','11:05:00',7.14),('7643','2013-02-01','11:10:00',7.56),('7643','2013-02-01','11:15:00',7.77),('7643','2013-02-01','11:20:00',7.54),('7643','2013-02-01','11:25:00',8.89),('7643','2013-02-01','11:30:00',8.21),('7643','2013-02-01','11:35:00',6.8),('7643','2013-02-01','11:40:00',6.71),('7643','2013-02-01','11:45:00',4.38),('7643','2013-02-01','11:50:00',4.04),('7643','2013-02-01','11:55:00',4.37),('7643','2013-02-01','12:00:00',3.27),('7643','2013-02-01','12:05:00',2.27),('7643','2013-02-01','12:10:00',1.89),('7643','2013-02-01','12:15:00',1.66),('7643','2013-02-01','12:20:00',1.51),('7643','2013-02-01','12:25:00',1.69),('7643','2013-02-01','12:30:00',1.17),('7643','2013-02-01','12:35:00',1.6),('7643','2013-02-01','12:40:00',1.68),('7643','2013-02-01','12:45:00',1.67),('7643','2013-02-01','12:50:00',2.75),('7643','2013-02-01','12:55:00',9.02),('7643','2013-02-01','13:00:00',5.89),('7643','2013-02-01','13:05:00',3.66),('7643','2013-02-01','13:10:00',6.15),('7643','2013-02-01','13:15:00',8.39),('7643','2013-02-01','13:20:00',7.14),('7643','2013-02-01','13:25:00',6.24),('7643','2013-02-01','13:30:00',4.86),('7643','2013-02-01','13:35:00',8.32),('7643','2013-02-01','13:40:00',10.21),('7643','2013-02-01','13:45:00',8.16),('7643','2013-02-01','13:50:00',7.61),('7643','2013-02-01','13:55:00',4.47),('7643','2013-02-01','14:00:00',2.26),('7643','2013-02-01','14:05:00',1.73),('7643','2013-02-01','14:10:00',1.46),('7643','2013-02-01','14:15:00',1.06),('7643','2013-02-01','14:20:00',1.1),('7643','2013-02-01','14:25:00',1.45),('7643','2013-02-01','14:30:00',1.57),('7643','2013-02-01','14:40:00',1.42),('7643','2013-01-31','08:15:00',1.19),('7643','2013-01-31','08:20:00',3.06),('7643','2013-01-31','08:25:00',3.45),('7643','2013-01-31','08:30:00',2.86),('7643','2013-01-31','08:35:00',3.69),('7643','2013-01-31','08:40:00',3.88),('7643','2013-01-31','08:45:00',4.32),('7643','2013-01-31','08:50:00',1.61),('7643','2013-01-31','08:55:00',3.76),('7643','2013-01-31','09:00:00',5.1),('7643','2013-01-31','09:05:00',6.34),('7643','2013-01-31','09:10:00',7.01),('7643','2013-01-31','09:15:00',2.22),('7643','2013-01-31','09:20:00',2.99),('7643','2013-01-31','09:25:00',6.39),('7643','2013-01-31','09:30:00',2.68),('7643','2013-01-31','09:35:00',4.52),('7643','2013-01-31','09:40:00',5.61),('7643','2013-01-31','09:45:00',3.72),('7643','2013-01-31','09:50:00',3.49),('7643','2013-01-31','09:55:00',3.56),('7643','2013-01-31','10:00:00',5.37),('7643','2013-01-31','10:05:00',3.18),('7643','2013-01-31','10:10:00',3.86),('7643','2013-01-31','10:15:00',4.21),('7643','2013-01-31','10:20:00',7.39),('7643','2013-01-31','10:25:00',7.11),('7643','2013-01-31','10:30:00',10.11),('7643','2013-01-31','10:35:00',6.21),('7643','2013-01-31','10:40:00',3.44),('7643','2013-01-31','10:45:00',4.96),('7643','2013-01-31','10:50:00',11.47),('7643','2013-01-31','10:55:00',6.24),('7643','2013-01-31','11:00:00',11.7),('7643','2013-01-31','11:05:00',8.37),('7643','2013-01-31','11:10:00',12.44),('7643','2013-01-31','11:15:00',12.14),('7643','2013-01-31','11:20:00',13.7),('7643','2013-01-31','11:25:00',9.33),('7643','2013-01-31','11:30:00',6.35),('7643','2013-01-31','11:35:00',10.06),('7643','2013-01-31','11:40:00',14.89),('7643','2013-01-31','11:45:00',10.34),('7643','2013-01-31','11:50:00',6.97),('7643','2013-01-31','11:55:00',4.86),('7643','2013-01-31','12:00:00',5.46),('7643','2013-01-31','12:05:00',7.26),('7643','2013-01-31','12:10:00',9.16),('7643','2013-01-31','12:15:00',10.03),('7643','2013-01-31','12:20:00',14.23),('7643','2013-01-31','12:25:00',11.82),('7643','2013-01-31','12:30:00',4.18),('7643','2013-01-31','12:35:00',7.64),('7643','2013-01-31','12:40:00',8.71),('7643','2013-01-31','12:45:00',7.47),('7643','2013-01-31','12:50:00',10.86),('7643','2013-01-31','12:55:00',9.45),('7643','2013-01-31','13:00:00',13.11),('7643','2013-01-31','13:05:00',12.63),('7643','2013-01-31','13:10:00',10.74),('7643','2013-01-31','13:15:00',11.62),('7643','2013-01-31','13:20:00',10.65),('7643','2013-01-31','13:25:00',7.69),('7643','2013-01-31','13:30:00',10.82),('7643','2013-01-31','13:35:00',7.5),('7643','2013-01-31','13:40:00',6.9),('7643','2013-01-31','13:45:00',9.56),('7643','2013-01-31','13:50:00',8.93),('7643','2013-01-31','13:55:00',4.3),('7643','2013-01-31','14:00:00',3.47),('7643','2013-01-31','14:05:00',3.27),('7643','2013-01-31','14:10:00',4.71),('7643','2013-01-31','14:15:00',9.7),('7643','2013-01-31','14:20:00',11.11),('7643','2013-01-31','14:25:00',9.59),('7643','2013-01-31','14:30:00',9.45),('7643','2013-01-31','14:35:00',9.27),('7643','2013-01-31','14:40:00',7.78),('7643','2013-01-31','14:45:00',4.14),('7643','2013-01-31','14:50:00',3.94),('7643','2013-01-31','14:55:00',6.24),('7643','2013-01-31','15:00:00',6.2),('7643','2013-01-31','15:05:00',8.86),('7643','2013-01-31','15:10:00',5.1),('7643','2013-01-31','15:15:00',6.86),('7643','2013-01-31','15:20:00',6.83),('7643','2013-01-31','15:25:00',5.19),('7643','2013-01-31','15:30:00',2.83),('7643','2013-01-31','15:35:00',4.97),('7643','2013-01-31','15:40:00',4.38),('7643','2013-01-31','15:45:00',3.89),('7643','2013-01-31','15:50:00',3.19),('7643','2013-01-31','15:55:00',4.73),('7643','2013-01-31','16:00:00',2.29),('7643','2013-01-31','16:05:00',1.6),('7643','2013-01-31','16:10:00',1.33),('7643','2014-03-20','06:50:00',1.3),('7643','2014-03-20','06:55:00',1.46),('7643','2014-03-20','07:00:00',1.68),('7643','2014-03-20','07:05:00',1.57),('7643','2014-03-20','07:10:00',1.77),('7643','2014-03-20','07:15:00',2.07),('7643','2014-03-20','07:20:00',2.74),('7643','2014-03-20','07:25:00',2.94),('7643','2014-03-20','07:30:00',2.86),('7643','2014-03-20','07:35:00',3.58),('7643','2014-03-20','07:40:00',4.04),('7643','2014-03-20','07:45:00',4.55),('7643','2014-03-20','07:50:00',5.09),('7643','2014-03-20','07:55:00',5.51),('7643','2014-03-20','08:00:00',5.82),('7643','2014-03-20','08:05:00',6.03),('7643','2014-03-20','08:10:00',6.49),('7643','2014-03-20','08:15:00',6.88),('7643','2014-03-20','08:20:00',7.2),('7643','2014-03-20','08:25:00',7.62),('7643','2014-03-20','08:30:00',8.07),('7643','2014-03-20','08:35:00',8.43),('7643','2014-03-20','08:40:00',8.58),('7643','2014-03-20','08:45:00',8.86),('7643','2014-03-20','08:50:00',9.23),('7643','2014-03-20','08:55:00',9.66),('7643','2014-03-20','09:00:00',10.01),('7643','2014-03-20','09:05:00',10.07),('7643','2014-03-20','09:10:00',10.5),('7643','2014-03-20','09:15:00',10.78),('7643','2014-03-20','09:20:00',11.15),('7643','2014-03-20','09:25:00',10.69),('7643','2014-03-20','09:30:00',11.44),('7643','2014-03-20','09:35:00',11.63),('7643','2014-03-20','09:40:00',11.83),('7643','2014-03-20','09:45:00',12.02),('7643','2014-03-20','09:50:00',12.1),('7643','2014-03-20','09:55:00',12.34),('7643','2014-03-20','10:00:00',12.43),('7643','2014-03-20','10:05:00',12.59),('7643','2014-03-20','10:10:00',12.77),('7643','2014-03-20','10:15:00',13.02),('7643','2014-03-20','10:20:00',13),('7643','2014-03-20','10:25:00',13.4),('7643','2014-03-20','10:30:00',13.51),('7643','2014-03-20','10:35:00',13.82),('7643','2014-03-20','10:40:00',13.86),('7643','2014-03-20','10:45:00',13.74),('7643','2014-03-20','10:50:00',13.73),('7643','2014-03-20','10:55:00',14.04),('7643','2014-03-20','11:00:00',14.15),('7643','2014-03-20','11:05:00',13.88),('7643','2014-03-20','11:10:00',13.88),('7643','2014-03-20','11:15:00',13.78),('7643','2014-03-20','11:20:00',13.73),('7643','2014-03-20','11:25:00',12.58),('7643','2014-03-20','11:30:00',11.17),('7643','2014-03-20','11:35:00',10.42),('7643','2014-03-20','11:40:00',5.87),('7643','2014-03-20','11:45:00',11.16),('7643','2014-03-20','11:50:00',15.5),('7643','2014-03-20','11:55:00',14.94),('7643','2014-03-20','12:00:00',11.15),('7643','2014-03-20','12:05:00',14.9),('7643','2014-03-20','12:10:00',15.62),('7643','2014-03-20','12:15:00',15.96),('7643','2014-03-20','12:20:00',15.55),('7643','2014-03-20','12:25:00',15.1),('7643','2014-03-20','12:30:00',14.86),('7643','2014-03-20','12:35:00',14.99),('7643','2014-03-20','12:40:00',15.21),('7643','2014-03-20','12:45:00',15.09),('7643','2014-03-20','12:50:00',15.02),('7643','2014-03-20','12:55:00',14.86),('7643','2014-03-20','13:00:00',14.8),('7643','2014-03-20','13:05:00',14.8),('7643','2014-03-20','13:10:00',14.68),('7643','2014-03-20','13:15:00',14.67),('7643','2014-03-20','13:20:00',14.55),('7643','2014-03-20','13:25:00',14.45),('7643','2014-03-20','13:30:00',14.34),('7643','2014-03-20','13:35:00',14.2),('7643','2014-03-20','13:40:00',14.24),('7643','2014-03-20','13:45:00',14.11),('7643','2014-03-20','13:50:00',14.03),('7643','2014-03-20','13:55:00',13.81),('7643','2014-03-20','14:00:00',13.71),('7643','2014-03-20','14:05:00',13.61),('7643','2014-03-20','14:10:00',13.43),('7643','2014-03-20','14:15:00',13.29),('7643','2014-03-20','14:20:00',13.14),('7643','2014-03-20','14:25:00',12.92),('7643','2014-03-20','14:30:00',12.26),('7643','2014-03-20','14:35:00',11.73),('7643','2014-03-20','14:40:00',11.88),('7643','2014-03-20','14:45:00',11.44),('7643','2014-03-20','14:50:00',9.51),('7643','2014-03-20','14:55:00',4.94),('7643','2014-03-20','15:00:00',2.85),('7643','2014-03-20','15:05:00',6.92),('7643','2014-03-20','15:10:00',12.14),('7643','2014-03-20','15:15:00',12.56),('7643','2014-03-20','15:20:00',11.65),('7643','2014-03-20','15:25:00',11.55),('7643','2014-03-20','15:30:00',11.69),('7643','2014-03-20','15:35:00',10.92),('7643','2014-03-20','15:40:00',10.89),('7643','2014-03-20','15:45:00',10.57),('7643','2014-03-20','15:50:00',10.22),('7643','2014-03-20','15:55:00',9.39),('7643','2014-03-20','16:00:00',9.12),('7643','2014-03-20','16:05:00',8.34),('7643','2014-03-20','16:10:00',7.91),('7643','2014-03-20','16:15:00',7.16),('7643','2014-03-20','16:20:00',6.55),('7643','2014-03-20','16:25:00',6.03),('7643','2014-03-20','16:30:00',5.56),('7643','2014-03-20','16:35:00',5.23),('7643','2014-03-20','16:40:00',4.83),('7643','2014-03-20','16:45:00',4.46),('7643','2014-03-20','16:50:00',4.06),('7643','2014-03-20','16:55:00',3.69),('7643','2014-03-20','17:00:00',3.08),('7643','2014-03-20','17:05:00',2.82),('7643','2014-03-20','17:10:00',2.42),('7643','2014-03-20','17:15:00',2.01),('7643','2014-03-20','17:20:00',1.71),('7643','2014-03-20','17:25:00',1.43),('7643','2014-03-20','17:30:00',1.2),('7643','2013-01-30','08:45:00',1.31),('7643','2013-01-30','08:50:00',1.81),('7643','2013-01-30','08:55:00',1.74),('7643','2013-01-30','09:00:00',2.15),('7643','2013-01-30','09:05:00',2.95),('7643','2013-01-30','09:10:00',3.48),('7643','2013-01-30','09:15:00',2.16),('7643','2013-01-30','09:20:00',3.01),('7643','2013-01-30','09:25:00',5.17),('7643','2013-01-30','09:30:00',8.41),('7643','2013-01-30','09:35:00',7.52),('7643','2013-01-30','09:40:00',7.89),('7643','2013-01-30','09:45:00',8.06),('7643','2013-01-30','09:50:00',8.16),('7643','2013-01-30','09:55:00',8.76),('7643','2013-01-30','10:00:00',8.81),('7643','2013-01-30','10:05:00',8.91),('7643','2013-01-30','10:10:00',8.88),('7643','2013-01-30','10:15:00',9.11),('7643','2013-01-30','10:20:00',9.56),('7643','2013-01-30','10:25:00',10.1),('7643','2013-01-30','10:30:00',10.41),('7643','2013-01-30','10:35:00',10.71),('7643','2013-01-30','10:40:00',10.32),('7643','2013-01-30','10:45:00',7.68),('7643','2013-01-30','10:50:00',11.19),('7643','2013-01-30','10:55:00',11.7),('7643','2013-01-30','11:00:00',11.77),('7643','2013-01-30','11:05:00',10.28),('7643','2013-01-30','11:10:00',12.07),('7643','2013-01-30','11:15:00',11.99),('7643','2013-01-30','11:20:00',12.45),('7643','2013-01-30','11:25:00',12.39),('7643','2013-01-30','11:30:00',11.8),('7643','2013-01-30','11:35:00',11.33),('7643','2013-01-30','11:40:00',11.71),('7643','2013-01-30','11:45:00',11.8),('7643','2013-01-30','11:50:00',11.72),('7643','2013-01-30','11:55:00',11.65),('7643','2013-01-30','12:00:00',11.68),('7643','2013-01-30','12:05:00',11.76),('7643','2013-01-30','12:10:00',11.84),('7643','2013-01-30','12:15:00',11.78),('7643','2013-01-30','12:20:00',11.84),('7643','2013-01-30','12:25:00',11.52),('7643','2013-01-30','12:30:00',11.69),('7643','2013-01-30','12:35:00',11.7),('7643','2013-01-30','12:40:00',11.59),('7643','2013-01-30','12:45:00',11.59),('7643','2013-01-30','12:50:00',11.51),('7643','2013-01-30','12:55:00',11.46),('7643','2013-01-30','13:00:00',11.38),('7643','2013-01-30','13:05:00',11.36),('7643','2013-01-30','13:10:00',10.92),('7643','2013-01-30','13:15:00',11),('7643','2013-01-30','13:20:00',10.86),('7643','2013-01-30','13:25:00',10.69),('7643','2013-01-30','13:30:00',10.68),('7643','2013-01-30','13:35:00',10.35),('7643','2013-01-30','13:40:00',10.24),('7643','2013-01-30','13:45:00',10.28),('7643','2013-01-30','13:50:00',10.82),('7643','2013-01-30','13:55:00',10.42),('7643','2013-01-30','14:00:00',10.18),('7643','2013-01-30','14:05:00',9.7),('7643','2013-01-30','14:10:00',9.28),('7643','2013-01-30','14:15:00',9.07),('7643','2013-01-30','14:20:00',8.98),('7643','2013-01-30','14:25:00',8.8),('7643','2013-01-30','14:30:00',8.58),('7643','2013-01-30','14:35:00',8.39),('7643','2013-01-30','14:40:00',8.07),('7643','2013-01-30','14:45:00',7.88),('7643','2013-01-30','14:50:00',7.68),('7643','2013-01-30','14:55:00',7.17),('7643','2013-01-30','15:00:00',7.02),('7643','2013-01-30','15:05:00',6.89),('7643','2013-01-30','15:10:00',6.62),('7643','2013-01-30','15:15:00',6.51),('7643','2013-01-30','15:20:00',6.29),('7643','2013-01-30','15:25:00',5.87),('7643','2013-01-30','15:30:00',5.61),('7643','2013-01-30','15:35:00',5.53),('7643','2013-01-30','15:40:00',5.17),('7643','2013-01-30','15:45:00',4.69),('7643','2013-01-30','15:50:00',4.31),('7643','2013-01-30','15:55:00',4.02),('7643','2013-01-30','16:00:00',3.41),('7643','2013-01-30','16:05:00',2.76),('7643','2013-01-30','16:10:00',3.05),('7643','2013-01-30','16:15:00',2.71),('7643','2013-01-30','16:20:00',2.39),('7643','2013-01-30','16:25:00',2.04),('7643','2013-01-30','16:30:00',2.02),('7643','2013-01-30','16:35:00',1.71),('7643','2013-01-30','16:40:00',1.4),('7643','2013-01-30','16:45:00',1.15),('7643','2013-01-29','08:30:00',1.29),('7643','2013-01-29','08:35:00',1.59),('7643','2013-01-29','08:40:00',1.56),('7643','2013-01-29','08:45:00',1.3),('7643','2013-01-29','08:50:00',1.3),('7643','2013-01-29','08:55:00',1.66),('7643','2013-01-29','09:00:00',1.51),('7643','2013-01-29','09:05:00',1.54),('7643','2013-01-29','09:10:00',2.06),('7643','2013-01-29','09:15:00',2.76),('7643','2013-01-29','09:20:00',1.65),('7643','2013-01-29','09:25:00',2.25),('7643','2013-01-29','09:30:00',2.81),('7643','2013-01-29','09:35:00',3.14),('7643','2013-01-29','09:40:00',2.86),('7643','2013-01-29','09:45:00',2.29),('7643','2013-01-29','09:50:00',1.58),('7643','2013-01-29','09:55:00',1.73),('7643','2013-01-29','10:00:00',3.31),('7643','2013-01-29','10:05:00',3.25),('7643','2013-01-29','10:10:00',6.02),('7643','2013-01-29','10:15:00',4.41),('7643','2013-01-29','10:20:00',6.04),('7643','2013-01-29','10:25:00',6.72),('7643','2013-01-29','10:30:00',6.35),('7643','2013-01-29','10:35:00',5.42),('7643','2013-01-29','10:40:00',5.43),('7643','2013-01-29','10:45:00',5.68),('7643','2013-01-29','10:50:00',10.98),('7643','2013-01-29','10:55:00',7.2),('7643','2013-01-29','11:00:00',9.96),('7643','2013-01-29','11:05:00',10.58),('7643','2013-01-29','11:10:00',10.54),('7643','2013-01-29','11:15:00',10.94),('7643','2013-01-29','11:20:00',11.04),('7643','2013-01-29','11:25:00',11.19),('7643','2013-01-29','11:30:00',11.2),('7643','2013-01-29','11:35:00',11.38),('7643','2013-01-29','11:40:00',10.62),('7643','2013-01-29','11:45:00',10.43),('7643','2013-01-29','11:50:00',9.93),('7643','2013-01-29','11:55:00',9.48),('7643','2013-01-29','12:00:00',8),('7643','2013-01-29','12:05:00',9.59),('7643','2013-01-29','12:10:00',9.36),('7643','2013-01-29','12:15:00',12.65),('7643','2013-01-29','12:20:00',5.49),('7643','2013-01-29','12:25:00',3.67),('7643','2013-01-29','12:30:00',2.99),('7643','2013-01-29','12:35:00',3.89),('7643','2013-01-29','12:40:00',5.6),('7643','2013-01-29','12:45:00',4.25),('7643','2013-01-29','12:50:00',13.65),('7643','2013-01-29','12:55:00',13.38),('7643','2013-01-29','13:00:00',12.67),('7643','2013-01-29','13:05:00',13.09),('7643','2013-01-29','13:10:00',10.22),('7643','2013-01-29','13:15:00',12.43),('7643','2013-01-29','13:20:00',12.47),('7643','2013-01-29','13:25:00',12.12),('7643','2013-01-29','13:30:00',11.4),('7643','2013-01-29','13:35:00',7.13),('7643','2013-01-29','13:40:00',9.97),('7643','2013-01-29','13:45:00',12.22),('7643','2013-01-29','13:50:00',11.04),('7643','2013-01-29','13:55:00',9.68),('7643','2013-01-29','14:00:00',11.14),('7643','2013-01-29','14:05:00',9.87),('7643','2013-01-29','14:10:00',8.57),('7643','2013-01-29','14:15:00',3.86),('7643','2013-01-29','14:20:00',4.13),('7643','2013-01-29','14:25:00',7.86),('7643','2013-01-29','14:30:00',8.24),('7643','2013-01-29','14:35:00',8.34),('7643','2013-01-29','14:40:00',8.92),('7643','2013-01-29','14:45:00',7.01),('7643','2013-01-29','14:50:00',3.72),('7643','2013-01-29','14:55:00',3.63),('7643','2013-01-29','15:00:00',5.87),('7643','2013-01-29','15:05:00',5.56),('7643','2013-01-29','15:10:00',3.41),('7643','2013-01-29','15:15:00',2.95),('7643','2013-01-29','15:20:00',2.61),('7643','2013-01-29','15:25:00',2.27),('7643','2013-01-29','15:30:00',2.22),('7643','2013-01-29','15:35:00',1.98),('7643','2013-01-29','15:40:00',1.51),('7643','2013-01-29','15:45:00',1.32),('7643','2013-01-29','15:50:00',1.33),('7643','2013-01-29','15:55:00',1.37),('7643','2013-01-29','16:00:00',1.31),('7643','2013-01-29','16:05:00',1.06),('7643','2013-01-29','16:10:00',1.3),('7643','2013-01-29','16:15:00',1.7),('7643','2013-01-29','16:20:00',1.77),('7643','2013-01-29','16:25:00',1.53),('7643','2013-01-29','16:30:00',1.68),('7643','2013-01-29','16:35:00',1.38),('7643','2013-01-29','16:40:00',1.18),('7643','2013-01-29','16:45:00',1.3),('7643','2013-01-29','16:50:00',1.06),('7643','2013-01-28','08:00:00',1.52),('7643','2013-01-28','08:05:00',1.85),('7643','2013-01-28','08:10:00',2.17),('7643','2013-01-28','08:15:00',2.51),('7643','2013-01-28','08:20:00',2.8),('7643','2013-01-28','08:25:00',3.14),('7643','2013-01-28','08:30:00',3.5),('7643','2013-01-28','08:35:00',3.59),('7643','2013-01-28','08:40:00',4.22),('7643','2013-01-28','08:45:00',4.56),('7643','2013-01-28','08:50:00',4.88),('7643','2013-01-28','08:55:00',5.21),('7643','2013-01-28','09:00:00',5.56),('7643','2013-01-28','09:05:00',5.92),('7643','2013-01-28','09:10:00',6.2),('7643','2013-01-28','09:15:00',6.48),('7643','2013-01-28','09:20:00',6.76),('7643','2013-01-28','09:25:00',7.02),('7643','2013-01-28','09:30:00',7.34),('7643','2013-01-28','09:35:00',7.53),('7643','2013-01-28','09:40:00',7.89),('7643','2013-01-28','09:45:00',8.21),('7643','2013-01-28','09:50:00',8.48),('7643','2013-01-28','09:55:00',8.67),('7643','2013-01-28','10:00:00',8.9),('7643','2013-01-28','10:05:00',9.21),('7643','2013-01-28','10:10:00',9.53),('7643','2013-01-28','10:15:00',9.79),('7643','2013-01-28','10:20:00',10.02),('7643','2013-01-28','10:25:00',10.25),('7643','2013-01-28','10:30:00',10.41),('7643','2013-01-28','10:35:00',10.55),('7643','2013-01-28','10:40:00',10.76),('7643','2013-01-28','10:45:00',10.95),('7643','2013-01-28','10:50:00',11.09),('7643','2013-01-28','10:55:00',11.14),('7643','2013-01-28','11:00:00',11.18),('7643','2013-01-28','11:05:00',11.24),('7643','2013-01-28','11:10:00',11.28),('7643','2013-01-28','11:15:00',11.49),('7643','2013-01-28','11:20:00',11.56),('7643','2013-01-28','11:25:00',11.52),('7643','2013-01-28','11:30:00',11.42),('7643','2013-01-28','11:35:00',11.89),('7643','2013-01-28','11:40:00',12.1),('7643','2013-01-28','11:45:00',12.05),('7643','2013-01-28','11:50:00',12.07),('7643','2013-01-28','11:55:00',12.04),('7643','2013-01-28','12:00:00',11.94),('7643','2013-01-28','12:05:00',12.01),('7643','2013-01-28','12:10:00',12.22),('7643','2013-01-28','12:15:00',12),('7643','2013-01-28','12:20:00',12),('7643','2013-01-28','12:25:00',12.14),('7643','2013-01-28','12:30:00',11.99),('7643','2013-01-28','12:35:00',11.8),('7643','2013-01-28','12:40:00',11.83),('7643','2013-01-28','12:45:00',11.7),('7643','2013-01-28','12:50:00',11.62),('7643','2013-01-28','12:55:00',11.77),('7643','2013-01-28','13:00:00',11.58),('7643','2013-01-28','13:05:00',11.4),('7643','2013-01-28','13:10:00',11.34),('7643','2013-01-28','13:15:00',11.26),('7643','2013-01-28','13:20:00',11),('7643','2013-01-28','13:25:00',11.12),('7643','2013-01-28','13:30:00',11),('7643','2013-01-28','13:35:00',10.87),('7643','2013-01-28','13:40:00',10.68),('7643','2013-01-28','13:45:00',10.63),('7643','2013-01-28','13:50:00',10.36),('7643','2013-01-28','13:55:00',10.13),('7643','2013-01-28','14:00:00',9.97),('7643','2013-01-28','14:05:00',9.67),('7643','2013-01-28','14:10:00',9.26),('7643','2013-01-28','14:15:00',9.39),('7643','2013-01-28','14:20:00',9.44),('7643','2013-01-28','14:25:00',9.23),('7643','2013-01-28','14:30:00',8.97),('7643','2013-01-28','14:35:00',8.67),('7643','2013-01-28','14:40:00',8.43),('7643','2013-01-28','14:45:00',8.25),('7643','2013-01-28','14:50:00',7.99),('7643','2013-01-28','14:55:00',7.72),('7643','2013-01-28','15:00:00',7.33),('7643','2013-01-28','15:05:00',7.08),('7643','2013-01-28','15:10:00',6.76),('7643','2013-01-28','15:15:00',6.49),('7643','2013-01-28','15:20:00',6.16),('7643','2013-01-28','15:25:00',5.79),('7643','2013-01-28','15:30:00',5.48),('7643','2013-01-28','15:35:00',5.22),('7643','2013-01-28','15:40:00',4.99),('7643','2013-01-28','15:45:00',4.67),('7643','2013-01-28','15:50:00',4.32),('7643','2013-01-28','15:55:00',4.08),('7643','2013-01-28','16:00:00',3.85),('7643','2013-01-28','16:05:00',3.54),('7643','2013-01-28','16:10:00',3.3),('7643','2013-01-28','16:15:00',2.98),('7643','2013-01-28','16:20:00',2.69),('7643','2013-01-28','16:25:00',2.35),('7643','2013-01-28','16:30:00',2.05),('7643','2013-01-28','16:35:00',1.74),('7643','2013-01-28','16:40:00',1.41),('7643','2013-01-28','16:45:00',1.14),('7643','2013-01-27','08:15:00',1.07),('7643','2013-01-27','08:20:00',1.31),('7643','2013-01-27','08:25:00',1.62),('7643','2013-01-27','08:30:00',1.87),('7643','2013-01-27','08:35:00',1.95),('7643','2013-01-27','08:40:00',1.95),('7643','2013-01-27','08:45:00',1.63),('7643','2013-01-27','08:50:00',1.43),('7643','2013-01-27','08:55:00',1.31),('7643','2013-01-27','09:00:00',1.09),('7643','2013-01-27','09:20:00',1.15),('7643','2013-01-27','09:25:00',1.21),('7643','2013-01-27','09:30:00',1.38),('7643','2013-01-27','09:35:00',1.47),('7643','2013-01-27','09:40:00',1.5),('7643','2013-01-27','09:45:00',1.66),('7643','2013-01-27','09:50:00',1.76),('7643','2013-01-27','09:55:00',1.64),('7643','2013-01-27','10:00:00',1.51),('7643','2013-01-27','10:05:00',1.68),('7643','2013-01-27','10:10:00',1.95),('7643','2013-01-27','10:15:00',1.92),('7643','2013-01-27','10:20:00',1.95),('7643','2013-01-27','10:25:00',1.87),('7643','2013-01-27','10:30:00',1.6),('7643','2013-01-27','10:35:00',1.48),('7643','2013-01-27','10:40:00',1.49),('7643','2013-01-27','10:45:00',1.72),('7643','2013-01-27','10:50:00',2.07),('7643','2013-01-27','10:55:00',2.34),('7643','2013-01-27','11:00:00',2.74),('7643','2013-01-27','11:05:00',3.11),('7643','2013-01-27','11:10:00',3.24),('7643','2013-01-27','11:15:00',2.75),('7643','2013-01-27','11:20:00',2.71),('7643','2013-01-27','11:25:00',2.58),('7643','2013-01-27','11:30:00',2.39),('7643','2013-01-27','11:35:00',2.23),('7643','2013-01-27','11:40:00',2.12),('7643','2013-01-27','11:45:00',2.11),('7643','2013-01-27','11:50:00',2.06),('7643','2013-01-27','11:55:00',1.93),('7643','2013-01-27','12:00:00',1.64),('7643','2013-01-27','12:05:00',1.53),('7643','2013-01-27','12:10:00',1.55),('7643','2013-01-27','12:15:00',1.65),('7643','2013-01-27','12:20:00',1.86),('7643','2013-01-27','12:25:00',2.01),('7643','2013-01-27','12:30:00',2.18),('7643','2013-01-27','12:35:00',2.5),('7643','2013-01-27','12:40:00',3.06),('7643','2013-01-27','12:45:00',3.93),('7643','2013-01-27','12:50:00',4.73),('7643','2013-01-27','12:55:00',4.48),('7643','2013-01-27','13:00:00',4.15),('7643','2013-01-27','13:05:00',3.99),('7643','2013-01-27','13:10:00',3.64),('7643','2013-01-27','13:15:00',3.46),('7643','2013-01-27','13:20:00',3.54),('7643','2013-01-27','13:25:00',3.62),('7643','2013-01-27','13:30:00',3.5),('7643','2013-01-27','13:35:00',3.16),('7643','2013-01-27','13:40:00',2.78),('7643','2013-01-27','13:45:00',2.56),('7643','2013-01-27','13:50:00',2.38),('7643','2013-01-27','13:55:00',2.34),('7643','2013-01-27','14:00:00',2.5),('7643','2013-01-27','14:05:00',2.6),('7643','2013-01-27','14:10:00',2.51),('7643','2013-01-27','14:15:00',2.31),('7643','2013-01-27','14:20:00',2.1),('7643','2013-01-27','14:25:00',1.84),('7643','2013-01-27','14:30:00',1.71),('7643','2013-01-27','14:35:00',1.6),('7643','2013-01-27','14:40:00',1.69),('7643','2013-01-27','14:45:00',1.88),('7643','2013-01-27','14:50:00',1.77),('7643','2013-01-27','14:55:00',1.6),('7643','2013-01-27','15:00:00',1.27),('7643','2013-01-27','15:05:00',1.04),('7643','2013-01-26','08:00:00',1.38),('7643','2013-01-26','08:05:00',1.69),('7643','2013-01-26','08:10:00',2.02),('7643','2013-01-26','08:15:00',2.35),('7643','2013-01-26','08:20:00',2.67),('7643','2013-01-26','08:25:00',3.1),('7643','2013-01-26','08:30:00',3.75),('7643','2013-01-26','08:35:00',4.35),('7643','2013-01-26','08:40:00',4.79),('7643','2013-01-26','08:45:00',4.89),('7643','2013-01-26','08:50:00',4.68),('7643','2013-01-26','08:55:00',5.14),('7643','2013-01-26','09:00:00',5.46),('7643','2013-01-26','09:05:00',5.73),('7643','2013-01-26','09:10:00',5.97),('7643','2013-01-26','09:15:00',6.24),('7643','2013-01-26','09:20:00',6.59),('7643','2013-01-26','09:25:00',6.91),('7643','2013-01-26','09:30:00',7.17),('7643','2013-01-26','09:35:00',7.46),('7643','2013-01-26','09:40:00',7.75),('7643','2013-01-26','09:45:00',8.01),('7643','2013-01-26','09:50:00',8.24),('7643','2013-01-26','09:55:00',8.54),('7643','2013-01-26','10:00:00',8.77),('7643','2013-01-26','10:05:00',9.02),('7643','2013-01-26','10:10:00',9.19),('7643','2013-01-26','10:15:00',9.43),('7643','2013-01-26','10:20:00',9.56),('7643','2013-01-26','10:25:00',9.8),('7643','2013-01-26','10:30:00',9.99),('7643','2013-01-26','10:35:00',10.18),('7643','2013-01-26','10:40:00',10.27),('7643','2013-01-26','10:45:00',10.45),('7643','2013-01-26','10:50:00',10.64),('7643','2013-01-26','10:55:00',10.73),('7643','2013-01-26','11:00:00',10.91),('7643','2013-01-26','11:05:00',11.01),('7643','2013-01-26','11:10:00',11.1),('7643','2013-01-26','11:15:00',11.25),('7643','2013-01-26','11:20:00',11.29),('7643','2013-01-26','11:25:00',11.36),('7643','2013-01-26','11:30:00',11.37),('7643','2013-01-26','11:35:00',11.46),('7643','2013-01-26','11:40:00',11.56),('7643','2013-01-26','11:45:00',11.66),('7643','2013-01-26','11:50:00',11.73),('7643','2013-01-26','11:55:00',11.72),('7643','2013-01-26','12:00:00',11.75),('7643','2013-01-26','12:05:00',11.79),('7643','2013-01-26','12:10:00',11.72),('7643','2013-01-26','12:15:00',11.77),('7643','2013-01-26','12:20:00',11.94),('7643','2013-01-26','12:25:00',11.77),('7643','2013-01-26','12:30:00',11.77),('7643','2013-01-26','12:35:00',11.62),('7643','2013-01-26','12:40:00',11.71),('7643','2013-01-26','12:45:00',11.65),('7643','2013-01-26','12:50:00',11.79),('7643','2013-01-26','12:55:00',11.66),('7643','2013-01-26','13:00:00',11.65),('7643','2013-01-26','13:05:00',11.62),('7643','2013-01-26','13:10:00',11.54),('7643','2013-01-26','13:15:00',11.38),('7643','2013-01-26','13:20:00',11.04),('7643','2013-01-26','13:25:00',10.92),('7643','2013-01-26','13:30:00',10.55),('7643','2013-01-26','13:35:00',10.47),('7643','2013-01-26','13:40:00',10.35),('7643','2013-01-26','13:45:00',10.17),('7643','2013-01-26','13:50:00',9.95),('7643','2013-01-26','13:55:00',9.94),('7643','2013-01-26','14:00:00',9.74),('7643','2013-01-26','14:05:00',9.5),('7643','2013-01-26','14:10:00',9.25),('7643','2013-01-26','14:15:00',8.93),('7643','2013-01-26','14:20:00',8.91),('7643','2013-01-26','14:25:00',8.63),('7643','2013-01-26','14:30:00',8.34),('7643','2013-01-26','14:35:00',8.06),('7643','2013-01-26','14:40:00',7.82),('7643','2013-01-26','14:45:00',7.63),('7643','2013-01-26','14:50:00',7.63),('7643','2013-01-26','14:55:00',7.39),('7643','2013-01-26','15:00:00',7.12),('7643','2013-01-26','15:05:00',6.79),('7643','2013-01-26','15:10:00',6.39),('7643','2013-01-26','15:15:00',6.08),('7643','2013-01-26','15:20:00',5.79),('7643','2013-01-26','15:25:00',5.47),('7643','2013-01-26','15:30:00',5.18),('7643','2013-01-26','15:35:00',4.87),('7643','2013-01-26','15:40:00',4.55),('7643','2013-01-26','15:45:00',4.23),('7643','2013-01-26','15:50:00',4.05),('7643','2013-01-26','15:55:00',3.77),('7643','2013-01-26','16:00:00',3.48),('7643','2013-01-26','16:05:00',3.27),('7643','2013-01-26','16:10:00',2.85),('7643','2013-01-26','16:15:00',2.44),('7643','2013-01-26','16:20:00',2.08),('7643','2013-01-26','16:25:00',1.81),('7643','2013-01-26','16:30:00',1.53),('7643','2013-01-26','16:35:00',1.31),('7643','2013-01-26','16:40:00',1.08),('7643','2013-01-25','08:15:00',1.02),('7643','2013-01-25','08:20:00',1.14),('7643','2013-01-25','08:30:00',1),('7643','2013-01-25','08:35:00',1.2),('7643','2013-01-25','08:40:00',1.17),('7643','2013-01-25','08:45:00',1.59),('7643','2013-01-25','08:50:00',2.11),('7643','2013-01-25','08:55:00',3.11),('7643','2013-01-25','09:00:00',5.37),('7643','2013-01-25','09:05:00',4.09),('7643','2013-01-25','09:10:00',4.43),('7643','2013-01-25','09:15:00',3.93),('7643','2013-01-25','09:20:00',4.15),('7643','2013-01-25','09:25:00',3.64),('7643','2013-01-25','09:30:00',2.91),('7643','2013-01-25','09:35:00',3.56),('7643','2013-01-25','09:40:00',3.19),('7643','2013-01-25','09:45:00',2.62),('7643','2013-01-25','09:50:00',3.93),('7643','2013-01-25','09:55:00',6.22),('7643','2013-01-25','10:00:00',3.73),('7643','2013-01-25','10:05:00',3.74),('7643','2013-01-25','10:10:00',3.27),('7643','2013-01-25','10:15:00',3.66),('7643','2013-01-25','10:20:00',4.75),('7643','2013-01-25','10:25:00',4.89),('7643','2013-01-25','10:30:00',3.04),('7643','2013-01-25','10:35:00',2.91),('7643','2013-01-25','10:40:00',3.4),('7643','2013-01-25','10:45:00',3.48),('7643','2013-01-25','10:50:00',4.21),('7643','2013-01-25','10:55:00',4.45),('7643','2013-01-25','11:00:00',3.32),('7643','2013-01-25','11:05:00',3.88),('7643','2013-01-25','11:10:00',3.6),('7643','2013-01-25','11:15:00',3.39),('7643','2013-01-25','11:20:00',3.22),('7643','2013-01-25','11:25:00',3.61),('7643','2013-01-25','11:30:00',3.63),('7643','2013-01-25','11:35:00',3.51),('7643','2013-01-25','11:40:00',3.52),('7643','2013-01-25','11:45:00',3.21),('7643','2013-01-25','11:50:00',3.29),('7643','2013-01-25','11:55:00',3.35),('7643','2013-01-25','12:00:00',2.89),('7643','2013-01-25','12:05:00',2.78),('7643','2013-01-25','12:10:00',2.74),('7643','2013-01-25','12:15:00',2.78),('7643','2013-01-25','12:20:00',2.83),('7643','2013-01-25','12:25:00',3.64),('7643','2013-01-25','12:30:00',3.46),('7643','2013-01-25','12:35:00',3.38),('7643','2013-01-25','12:40:00',3.19),('7643','2013-01-25','12:45:00',3.06),('7643','2013-01-25','12:50:00',3.28),('7643','2013-01-25','12:55:00',2.43),('7643','2013-01-25','13:00:00',1.86),('7643','2013-01-25','13:05:00',2.36),('7643','2013-01-25','13:10:00',2.31),('7643','2013-01-25','13:15:00',1.76),('7643','2013-01-25','13:20:00',1.6),('7643','2013-01-25','13:25:00',1.7),('7643','2013-01-25','13:30:00',1.86),('7643','2013-01-25','13:35:00',2.42),('7643','2013-01-25','13:40:00',2.58),('7643','2013-01-25','13:45:00',2.44),('7643','2013-01-25','13:50:00',2.21),('7643','2013-01-25','13:55:00',2.17),('7643','2013-01-25','14:00:00',1.91),('7643','2013-01-25','14:05:00',1.77),('7643','2013-01-25','14:10:00',1.81),('7643','2013-01-25','14:15:00',1.71),('7643','2013-01-25','14:20:00',1.91),('7643','2013-01-25','14:25:00',2.08),('7643','2013-01-25','14:30:00',2.13),('7643','2013-01-25','14:35:00',1.81),('7643','2013-01-25','14:40:00',1.47),('7643','2013-01-25','14:45:00',1.28),('7643','2013-01-25','14:50:00',1.18),('7643','2013-01-25','14:55:00',1.2),('7643','2013-01-25','15:00:00',1.07),('7643','2013-01-25','15:30:00',1.01),('7643','2013-01-24','08:15:00',1.1),('7643','2013-01-24','08:20:00',2.15),('7643','2013-01-24','08:25:00',3.18),('7643','2013-01-24','08:30:00',3.48),('7643','2013-01-24','08:35:00',4.16),('7643','2013-01-24','08:40:00',4.59),('7643','2013-01-24','08:45:00',4.96),('7643','2013-01-24','08:50:00',4.98),('7643','2013-01-24','08:55:00',5.19),('7643','2013-01-24','09:00:00',6.11),('7643','2013-01-24','09:05:00',5.09),('7643','2013-01-24','09:10:00',5.51),('7643','2013-01-24','09:15:00',6.6),('7643','2013-01-24','09:20:00',7.24),('7643','2013-01-24','09:25:00',7.69),('7643','2013-01-24','09:30:00',8.14),('7643','2013-01-24','09:35:00',7.71),('7643','2013-01-24','09:40:00',7.65),('7643','2013-01-24','09:45:00',7.75),('7643','2013-01-24','09:50:00',9.6),('7643','2013-01-24','09:55:00',9.74),('7643','2013-01-24','10:00:00',9.95),('7643','2013-01-24','10:05:00',9.98),('7643','2013-01-24','10:10:00',10.22),('7643','2013-01-24','10:15:00',10.24),('7643','2013-01-24','10:20:00',10.33),('7643','2013-01-24','10:25:00',10.5),('7643','2013-01-24','10:30:00',9.59),('7643','2013-01-24','10:35:00',6.58),('7643','2013-01-24','10:40:00',7.24),('7643','2013-01-24','10:45:00',11.4),('7643','2013-01-24','10:50:00',7.63),('7643','2013-01-24','10:55:00',12.24),('7643','2013-01-24','11:00:00',6.88),('7643','2013-01-24','11:05:00',8.09),('7643','2013-01-24','11:10:00',10.55),('7643','2013-01-24','11:15:00',11.95),('7643','2013-01-24','11:20:00',11.85),('7643','2013-01-24','11:25:00',11.82),('7643','2013-01-24','11:30:00',11.87),('7643','2013-01-24','11:35:00',12.07),('7643','2013-01-24','11:40:00',12.02),('7643','2013-01-24','11:45:00',12.13),('7643','2013-01-24','11:50:00',12.25),('7643','2013-01-24','11:55:00',12.25),('7643','2013-01-24','12:00:00',12.14),('7643','2013-01-24','12:05:00',12.14),('7643','2013-01-24','12:10:00',12.35),('7643','2013-01-24','12:15:00',12.42),('7643','2013-01-24','12:20:00',12.46),('7643','2013-01-24','12:25:00',12.5),('7643','2013-01-24','12:30:00',12.3),('7643','2013-01-24','12:35:00',10.59),('7643','2013-01-24','12:40:00',11.09),('7643','2013-01-24','12:45:00',11.87),('7643','2013-01-24','12:50:00',11.98),('7643','2013-01-24','12:55:00',11.61),('7643','2013-01-24','13:00:00',11.65),('7643','2013-01-24','13:05:00',11.54),('7643','2013-01-24','13:10:00',11.42),('7643','2013-01-24','13:15:00',11.41),('7643','2013-01-24','13:20:00',11.45),('7643','2013-01-24','13:25:00',11.59),('7643','2013-01-24','13:30:00',11.74),('7643','2013-01-24','13:35:00',11.47),('7643','2013-01-24','13:40:00',11.29),('7643','2013-01-24','13:45:00',11.04),('7643','2013-01-24','13:50:00',10.71),('7643','2013-01-24','13:55:00',10.43),('7643','2013-01-24','14:00:00',10.1),('7643','2013-01-24','14:05:00',9.71),('7643','2013-01-24','14:10:00',8.89),('7643','2013-01-24','14:15:00',8.61),('7643','2013-01-24','14:20:00',7.93),('7643','2013-01-24','14:25:00',8.05),('7643','2013-01-24','14:30:00',7.45),('7643','2013-01-24','14:35:00',7.07),('7643','2013-01-24','14:40:00',6.83),('7643','2013-01-24','14:45:00',6.65),('7643','2013-01-24','14:50:00',6.69),('7643','2013-01-24','14:55:00',6.42),('7643','2013-01-24','15:00:00',5.87),('7643','2013-01-24','15:05:00',5.52),('7643','2013-01-24','15:10:00',5.53),('7643','2013-01-24','15:15:00',5.32),('7643','2013-01-24','15:20:00',5.19),('7643','2013-01-24','15:25:00',5.17),('7643','2013-01-24','15:30:00',5.15),('7643','2013-01-24','15:35:00',5.32),('7643','2013-01-24','15:40:00',4.89),('7643','2013-01-24','15:45:00',4.36),('7643','2013-01-24','15:50:00',4.77),('7643','2013-01-24','15:55:00',4.28),('7643','2013-01-24','16:00:00',2.99),('7643','2013-01-24','16:05:00',1.98),('7643','2013-01-24','16:10:00',1.87),('7643','2013-01-24','16:15:00',2.17),('7643','2013-01-24','16:20:00',2.05),('7643','2013-01-24','16:25:00',1.66),('7643','2013-01-24','16:30:00',1.48),('7643','2013-01-24','16:35:00',1.16),('7643','2013-01-23','08:40:00',1.2),('7643','2013-01-23','08:45:00',1.63),('7643','2013-01-23','08:50:00',2.22),('7643','2013-01-23','08:55:00',2.67),('7643','2013-01-23','09:00:00',3.16),('7643','2013-01-23','09:05:00',2.11),('7643','2013-01-23','09:10:00',2.08),('7643','2013-01-23','09:15:00',2.35),('7643','2013-01-23','09:20:00',3.03),('7643','2013-01-23','09:25:00',3.31),('7643','2013-01-23','09:30:00',3.32),('7643','2013-01-23','09:35:00',2.83),('7643','2013-01-23','09:40:00',3.49),('7643','2013-01-23','09:45:00',5.99),('7643','2013-01-23','09:50:00',4.21),('7643','2013-01-23','09:55:00',8.42),('7643','2013-01-23','10:00:00',8.93),('7643','2013-01-23','10:05:00',9.34),('7643','2013-01-23','10:10:00',10.12),('7643','2013-01-23','10:15:00',9.63),('7643','2013-01-23','10:20:00',10.35),('7643','2013-01-23','10:25:00',10.42),('7643','2013-01-23','10:30:00',10.63),('7643','2013-01-23','10:35:00',10.64),('7643','2013-01-23','10:40:00',10.84),('7643','2013-01-23','10:45:00',10.98),('7643','2013-01-23','10:50:00',10.65),('7643','2013-01-23','10:55:00',8.91),('7643','2013-01-23','11:00:00',5.61),('7643','2013-01-23','11:05:00',4.12),('7643','2013-01-23','11:10:00',2.35),('7643','2013-01-23','11:15:00',1.71),('7643','2013-01-23','11:20:00',1.78),('7643','2013-01-23','11:25:00',1.77),('7643','2013-01-23','11:30:00',1.75),('7643','2013-01-23','11:35:00',1.89),('7643','2013-01-23','11:40:00',1.9),('7643','2013-01-23','11:45:00',1.82),('7643','2013-01-23','11:50:00',1.74),('7643','2013-01-23','11:55:00',1.64),('7643','2013-01-23','12:00:00',1.54),('7643','2013-01-23','12:05:00',1.5),('7643','2013-01-23','12:10:00',1.46),('7643','2013-01-23','12:15:00',1.41),('7643','2013-01-23','12:20:00',1.46),('7643','2013-01-23','12:25:00',1.59),('7643','2013-01-23','12:30:00',1.79),('7643','2013-01-23','12:35:00',2.12),('7643','2013-01-23','12:40:00',2.6),('7643','2013-01-23','12:45:00',3.09),('7643','2013-01-23','12:50:00',3.39),('7643','2013-01-23','12:55:00',3.54),('7643','2013-01-23','13:00:00',3.55),('7643','2013-01-23','13:05:00',3.45),('7643','2013-01-23','13:10:00',3.17),('7643','2013-01-23','13:15:00',3.02),('7643','2013-01-23','13:20:00',3.02),('7643','2013-01-23','13:25:00',3.13),('7643','2013-01-23','13:30:00',3.26),('7643','2013-01-23','13:35:00',3.22),('7643','2013-01-23','13:40:00',3.22),('7643','2013-01-23','13:45:00',3.31),('7643','2013-01-23','13:50:00',3.4),('7643','2013-01-23','13:55:00',3.58),('7643','2013-01-23','14:00:00',4.62),('7643','2013-01-23','14:05:00',4.53),('7643','2013-01-23','14:10:00',4.33),('7643','2013-01-23','14:15:00',5.12),('7643','2013-01-23','14:20:00',7.43),('7643','2013-01-23','14:25:00',12.68),('7643','2013-01-23','14:30:00',11.1),('7643','2013-01-23','14:35:00',7.94),('7643','2013-01-23','14:40:00',5.28),('7643','2013-01-23','14:45:00',7.54),('7643','2013-01-23','14:50:00',7.94),('7643','2013-01-23','14:55:00',8.15),('7643','2013-01-23','15:00:00',4.82),('7643','2013-01-23','15:05:00',4.37),('7643','2013-01-23','15:10:00',2.84),('7643','2013-01-23','15:15:00',2.73),('7643','2013-01-23','15:20:00',5.15),('7643','2013-01-23','15:25:00',5.42),('7643','2013-01-23','15:30:00',5.49),('7643','2013-01-23','15:35:00',4.61),('7643','2013-01-23','15:40:00',2.57),('7643','2013-01-23','15:45:00',4.36),('7643','2013-01-23','15:50:00',4.49),('7643','2013-01-23','15:55:00',4.01),('7643','2013-01-23','16:00:00',3.62),('7643','2013-01-23','16:05:00',2.91),('7643','2013-01-23','16:10:00',2.37),('7643','2013-01-23','16:15:00',2.49),('7643','2013-01-23','16:20:00',2.17),('7643','2013-01-23','16:25:00',1.38),('7643','2013-01-22','09:35:00',1.72),('7643','2013-01-22','09:40:00',1.46),('7643','2013-01-22','09:45:00',2.25),('7643','2013-01-22','09:50:00',2.78),('7643','2013-01-22','09:55:00',7.05),('7643','2013-01-22','10:00:00',3.37),('7643','2013-01-22','10:05:00',2.63),('7643','2013-01-22','10:10:00',1.94),('7643','2013-01-22','10:15:00',2.99),('7643','2013-01-22','10:20:00',2.99),('7643','2013-01-22','10:25:00',4.61),('7643','2013-01-22','10:30:00',9.26),('7643','2013-01-22','10:35:00',10.08),('7643','2013-01-22','10:40:00',5.05),('7643','2013-01-22','10:45:00',7.05),('7643','2013-01-22','10:50:00',9.16),('7643','2013-01-22','10:55:00',6.93),('7643','2013-01-22','11:00:00',2.76),('7643','2013-01-22','11:05:00',1.75),('7643','2013-01-22','11:10:00',2.09),('7643','2013-01-22','11:15:00',1.69),('7643','2013-01-22','11:20:00',1.05),('7643','2013-01-22','12:45:00',1.11),('7643','2013-01-22','13:20:00',1.16),('7643','2013-01-22','13:35:00',1.16),('7643','2013-01-22','13:40:00',1.14),('7643','2013-01-21','08:00:00',1.25),('7643','2013-01-21','08:05:00',2.4),('7643','2013-01-21','08:10:00',2.38),('7643','2013-01-21','08:15:00',1.64),('7643','2013-01-21','08:20:00',2.19),('7643','2013-01-21','08:25:00',2.23),('7643','2013-01-21','08:30:00',1.49),('7643','2013-01-21','08:35:00',2.89),('7643','2013-01-21','08:40:00',1.89),('7643','2013-01-21','08:45:00',4),('7643','2013-01-21','08:50:00',4.42),('7643','2013-01-21','08:55:00',2.52),('7643','2013-01-21','09:00:00',3.83),('7643','2013-01-21','09:05:00',5.87),('7643','2013-01-21','09:10:00',2.05),('7643','2013-01-21','09:15:00',2.15),('7643','2013-01-21','09:20:00',1.37),('7643','2013-01-21','09:25:00',2.96),('7643','2013-01-21','09:30:00',7.04),('7643','2013-01-21','09:35:00',8.13),('7643','2013-01-21','09:40:00',6.5),('7643','2013-01-21','09:45:00',9.92),('7643','2013-01-21','09:50:00',6.38),('7643','2013-01-21','09:55:00',7.32),('7643','2013-01-21','10:00:00',5.43),('7643','2013-01-21','10:05:00',9.45),('7643','2013-01-21','10:10:00',9.86),('7643','2013-01-21','10:15:00',8.71),('7643','2013-01-21','10:20:00',9.99),('7643','2013-01-21','10:25:00',10.15),('7643','2013-01-21','10:30:00',10.61),('7643','2013-01-21','10:35:00',11.08),('7643','2013-01-21','10:40:00',11.53),('7643','2013-01-21','10:45:00',10.39),('7643','2013-01-21','10:50:00',9.12),('7643','2013-01-21','10:55:00',5.64),('7643','2013-01-21','11:00:00',4),('7643','2013-01-21','11:05:00',2.58),('7643','2013-01-21','11:10:00',4.39),('7643','2013-01-21','11:15:00',6.93),('7643','2013-01-21','11:20:00',7.05),('7643','2013-01-21','11:25:00',4.56),('7643','2013-01-21','11:30:00',3.08),('7643','2013-01-21','11:35:00',2.71),('7643','2013-01-21','11:40:00',2.1),('7643','2013-01-21','11:45:00',5.38),('7643','2013-01-21','11:50:00',8.9),('7643','2013-01-21','11:55:00',4.07),('7643','2013-01-21','12:00:00',3.07),('7643','2013-01-21','12:05:00',3.73),('7643','2013-01-21','12:10:00',10.18),('7643','2013-01-21','12:15:00',11.05),('7643','2013-01-21','12:20:00',6.2),('7643','2013-01-21','12:25:00',9.49),('7643','2013-01-21','12:30:00',4.56),('7643','2013-01-21','12:35:00',3.87),('7643','2013-01-21','12:40:00',13.18),('7643','2013-01-21','12:45:00',3.73),('7643','2013-01-21','12:50:00',3.93),('7643','2013-01-21','12:55:00',4.61),('7643','2013-01-21','13:00:00',8.69),('7643','2013-01-21','13:05:00',13.26),('7643','2013-01-21','13:10:00',9.45),('7643','2013-01-21','13:15:00',3.61),('7643','2013-01-21','13:20:00',11.62),('7643','2013-01-21','13:25:00',2.9),('7643','2013-01-21','13:30:00',4.1),('7643','2013-01-21','13:35:00',2.08),('7643','2013-01-21','13:40:00',3.39),('7643','2013-01-21','13:45:00',3.8),('7643','2013-01-21','13:50:00',4.79),('7643','2013-01-21','13:55:00',2.16),('7643','2013-01-21','14:00:00',2.44),('7643','2013-01-21','14:05:00',2.72),('7643','2013-01-21','14:10:00',4.68),('7643','2013-01-21','14:15:00',4.66),('7643','2013-01-21','14:20:00',3.86),('7643','2013-01-21','14:25:00',7.52),('7643','2013-01-21','14:30:00',2.73),('7643','2013-01-21','14:35:00',6.28),('7643','2013-01-21','14:40:00',5.26),('7643','2013-01-21','14:45:00',7.07),('7643','2013-01-21','14:50:00',5.32),('7643','2013-01-21','14:55:00',2.02),('7643','2013-01-21','15:00:00',2.1),('7643','2013-01-21','15:05:00',2.83),('7643','2013-01-21','15:10:00',1.54),('7643','2013-01-21','15:15:00',1.66),('7643','2013-01-21','15:20:00',1.62),('7643','2013-01-21','15:25:00',1.36),('7643','2013-01-21','15:30:00',1.76),('7643','2013-01-21','15:35:00',1.4),('7643','2013-01-21','15:40:00',1.7),('7643','2013-01-21','15:45:00',1.18),('7643','2013-01-21','15:50:00',1.2),('7643','2014-03-19','06:50:00',1.33),('7643','2014-03-19','06:55:00',1.52),('7643','2014-03-19','07:00:00',1.8),('7643','2014-03-19','07:05:00',2.13),('7643','2014-03-19','07:10:00',2.52),('7643','2014-03-19','07:15:00',2.95),('7643','2014-03-19','07:20:00',3.29),('7643','2014-03-19','07:25:00',3.62),('7643','2014-03-19','07:30:00',3.64),('7643','2014-03-19','07:35:00',4.32),('7643','2014-03-19','07:40:00',4.81),('7643','2014-03-19','07:45:00',5.2),('7643','2014-03-19','07:50:00',5.49),('7643','2014-03-19','07:55:00',5.84),('7643','2014-03-19','08:00:00',6.25),('7643','2014-03-19','08:05:00',6.61),('7643','2014-03-19','08:10:00',6.83),('7643','2014-03-19','08:15:00',7.02),('7643','2014-03-19','08:20:00',7.19),('7643','2014-03-19','08:25:00',7.49),('7643','2014-03-19','08:30:00',7.91),('7643','2014-03-19','08:35:00',8.36),('7643','2014-03-19','08:40:00',8.82),('7643','2014-03-19','08:45:00',9.21),('7643','2014-03-19','08:50:00',9.48),('7643','2014-03-19','08:55:00',9.65),('7643','2014-03-19','09:00:00',9.84),('7643','2014-03-19','09:05:00',10.13),('7643','2014-03-19','09:10:00',10.63),('7643','2014-03-19','09:15:00',10.78),('7643','2014-03-19','09:20:00',11.1),('7643','2014-03-19','09:25:00',11.21),('7643','2014-03-19','09:30:00',11.29),('7643','2014-03-19','09:35:00',11.8),('7643','2014-03-19','09:40:00',11.71),('7643','2014-03-19','09:45:00',11.92),('7643','2014-03-19','09:50:00',11.89),('7643','2014-03-19','09:55:00',12.1),('7643','2014-03-19','10:00:00',12.6),('7643','2014-03-19','10:05:00',13.09),('7643','2014-03-19','10:10:00',13.25),('7643','2014-03-19','10:15:00',13.1),('7643','2014-03-19','10:20:00',13.24),('7643','2014-03-19','10:25:00',13.46),('7643','2014-03-19','10:30:00',13.54),('7643','2014-03-19','10:35:00',13.29),('7643','2014-03-19','10:40:00',12.94),('7643','2014-03-19','10:45:00',12.9),('7643','2014-03-19','10:50:00',13.87),('7643','2014-03-19','10:55:00',14.49),('7643','2014-03-19','11:00:00',14.69),('7643','2014-03-19','11:05:00',14.6),('7643','2014-03-19','11:10:00',14.43),('7643','2014-03-19','11:15:00',13.75),('7643','2014-03-19','11:20:00',14.38),('7643','2014-03-19','11:25:00',14.46),('7643','2014-03-19','11:30:00',14.86),('7643','2014-03-19','11:35:00',15.25),('7643','2014-03-19','11:40:00',14.99),('7643','2014-03-19','11:45:00',15.17),('7643','2014-03-19','11:50:00',15.01),('7643','2014-03-19','11:55:00',14.03),('7643','2014-03-19','12:00:00',13.38),('7643','2014-03-19','12:05:00',14.61),('7643','2014-03-19','12:10:00',14.95),('7643','2014-03-19','12:15:00',15.03),('7643','2014-03-19','12:20:00',14.53),('7643','2014-03-19','12:25:00',13.89),('7643','2014-03-19','12:30:00',14.57),('7643','2014-03-19','12:35:00',14.85),('7643','2014-03-19','12:40:00',14.85),('7643','2014-03-19','12:45:00',15.28),('7643','2014-03-19','12:50:00',15.2),('7643','2014-03-19','12:55:00',14.82),('7643','2014-03-19','13:00:00',14.77),('7643','2014-03-19','13:05:00',14.64),('7643','2014-03-19','13:10:00',14.33),('7643','2014-03-19','13:15:00',14.4),('7643','2014-03-19','13:20:00',14.51),('7643','2014-03-19','13:25:00',14.14),('7643','2014-03-19','13:30:00',14.33),('7643','2014-03-19','13:35:00',13.91),('7643','2014-03-19','13:40:00',12.89),('7643','2014-03-19','13:45:00',12.59),('7643','2014-03-19','13:50:00',12.16),('7643','2014-03-19','13:55:00',11.42),('7643','2014-03-19','14:00:00',11.55),('7643','2014-03-19','14:05:00',12.61),('7643','2014-03-19','14:10:00',12.17),('7643','2014-03-19','14:15:00',11.6),('7643','2014-03-19','14:20:00',11.58),('7643','2014-03-19','14:25:00',11.58),('7643','2014-03-19','14:30:00',9.87),('7643','2014-03-19','14:35:00',9.12),('7643','2014-03-19','14:40:00',10.26),('7643','2014-03-19','14:45:00',10),('7643','2014-03-19','14:50:00',9.58),('7643','2014-03-19','14:55:00',9.13),('7643','2014-03-19','15:00:00',8.3),('7643','2014-03-19','15:05:00',8.26),('7643','2014-03-19','15:10:00',8.27),('7643','2014-03-19','15:15:00',7.84),('7643','2014-03-19','15:20:00',8.36),('7643','2014-03-19','15:25:00',7.74),('7643','2014-03-19','15:30:00',7.27),('7643','2014-03-19','15:35:00',7.11),('7643','2014-03-19','15:40:00',6.4),('7643','2014-03-19','15:45:00',6.35),('7643','2014-03-19','15:50:00',5.73),('7643','2014-03-19','15:55:00',5.11),('7643','2014-03-19','16:00:00',4.26),('7643','2014-03-19','16:05:00',3.92),('7643','2014-03-19','16:10:00',4.12),('7643','2014-03-19','16:15:00',3.98),('7643','2014-03-19','16:20:00',4.22),('7643','2014-03-19','16:25:00',4.27),('7643','2014-03-19','16:30:00',3.84),('7643','2014-03-19','16:35:00',3.52),('7643','2014-03-19','16:40:00',3.26),('7643','2014-03-19','16:45:00',2.42),('7643','2014-03-19','16:50:00',2.04),('7643','2014-03-19','16:55:00',1.78),('7643','2014-03-19','17:00:00',1.69),('7643','2014-03-19','17:05:00',1.78),('7643','2014-03-19','17:10:00',1.66),('7643','2014-03-19','17:15:00',1.45),('7643','2014-03-19','17:20:00',1.24),('7643','2014-03-19','17:25:00',1.08),('7643','2013-01-20','09:55:00',1),('7643','2013-01-20','10:00:00',1.26),('7643','2013-01-20','10:05:00',1.65),('7643','2013-01-20','10:10:00',2.08),('7643','2013-01-20','10:15:00',2.42),('7643','2013-01-20','10:20:00',2.13),('7643','2013-01-20','10:25:00',2.1),('7643','2013-01-20','10:30:00',2.11),('7643','2013-01-20','10:35:00',1.65),('7643','2013-01-20','10:40:00',1.77),('7643','2013-01-20','10:45:00',1.8),('7643','2013-01-20','10:50:00',1.76),('7643','2013-01-20','10:55:00',1.98),('7643','2013-01-20','11:00:00',3.16),('7643','2013-01-20','11:05:00',2.88),('7643','2013-01-20','11:10:00',3.96),('7643','2013-01-20','11:15:00',4.57),('7643','2013-01-20','11:20:00',3.59),('7643','2013-01-20','11:25:00',3.56),('7643','2013-01-20','11:30:00',2.48),('7643','2013-01-20','11:35:00',1.63),('7643','2013-01-20','11:40:00',2.86),('7643','2013-01-20','11:45:00',3.24),('7643','2013-01-20','11:50:00',4.26),('7643','2013-01-20','11:55:00',13.15),('7643','2013-01-20','12:00:00',11.62),('7643','2013-01-20','12:05:00',11.23),('7643','2013-01-20','12:10:00',11.01),('7643','2013-01-20','12:15:00',10.54),('7643','2013-01-20','12:20:00',4.42),('7643','2013-01-20','12:25:00',6.39),('7643','2013-01-20','12:30:00',2.62),('7643','2013-01-20','12:35:00',2.71),('7643','2013-01-20','12:40:00',4.09),('7643','2013-01-20','12:45:00',2.55),('7643','2013-01-20','12:50:00',4.41),('7643','2013-01-20','12:55:00',3.23),('7643','2013-01-20','13:00:00',3.27),('7643','2013-01-20','13:05:00',7.49),('7643','2013-01-20','13:10:00',5.33),('7643','2013-01-20','13:15:00',3.48),('7643','2013-01-20','13:20:00',3.41),('7643','2013-01-20','13:25:00',3.03),('7643','2013-01-20','13:30:00',11.85),('7643','2013-01-20','13:35:00',12.42),('7643','2013-01-20','13:40:00',10.78),('7643','2013-01-20','13:45:00',4.04),('7643','2013-01-20','13:50:00',8.09),('7643','2013-01-20','13:55:00',12.49),('7643','2013-01-20','14:00:00',8.97),('7643','2013-01-20','14:05:00',9.83),('7643','2013-01-20','14:10:00',8.74),('7643','2013-01-20','14:15:00',6.14),('7643','2013-01-20','14:20:00',7.3),('7643','2013-01-20','14:25:00',7.94),('7643','2013-01-20','14:30:00',5.12),('7643','2013-01-20','14:35:00',3.2),('7643','2013-01-20','14:40:00',2.17),('7643','2013-01-20','14:45:00',1.63),('7643','2013-01-20','14:50:00',1.94),('7643','2013-01-20','14:55:00',1.42),('7643','2013-01-20','15:00:00',1.31),('7643','2013-01-20','15:05:00',1.64),('7643','2013-01-20','15:10:00',1.23),('7643','2013-01-20','15:35:00',1.54),('7643','2013-01-20','15:40:00',1.49),('7643','2013-01-20','15:45:00',1.75),('7643','2013-01-20','15:50:00',1.68),('7643','2013-01-20','15:55:00',1.05),('7643','2013-01-19','08:20:00',1.34),('7643','2013-01-19','08:25:00',1.71),('7643','2013-01-19','08:30:00',2.25),('7643','2013-01-19','08:35:00',2.55),('7643','2013-01-19','08:40:00',2.47),('7643','2013-01-19','08:45:00',1.89),('7643','2013-01-19','08:50:00',1.42),('7643','2013-01-19','08:55:00',1.31),('7643','2013-01-19','09:00:00',1.67),('7643','2013-01-19','09:05:00',2.01),('7643','2013-01-19','09:10:00',1.75),('7643','2013-01-19','09:15:00',1.38),('7643','2013-01-19','09:20:00',1.28),('7643','2013-01-19','09:25:00',1.43),('7643','2013-01-19','09:30:00',1.56),('7643','2013-01-19','09:35:00',1.16),('7643','2013-01-19','09:40:00',1.07),('7643','2013-01-19','09:45:00',1.36),('7643','2013-01-19','09:50:00',1.29),('7643','2013-01-19','09:55:00',1.6),('7643','2013-01-19','10:00:00',2.07),('7643','2013-01-19','10:05:00',2.13),('7643','2013-01-19','10:10:00',1.54),('7643','2013-01-19','10:15:00',1.18),('7643','2013-01-19','10:20:00',1.78),('7643','2013-01-19','10:25:00',2.28),('7643','2013-01-19','10:30:00',2.7),('7643','2013-01-19','10:35:00',2.18),('7643','2013-01-19','10:40:00',2.64),('7643','2013-01-19','10:45:00',3.04),('7643','2013-01-19','10:50:00',3.66),('7643','2013-01-19','10:55:00',4.13),('7643','2013-01-19','11:00:00',4.5),('7643','2013-01-19','11:05:00',4.46),('7643','2013-01-19','11:10:00',4.79),('7643','2013-01-19','11:15:00',6.49),('7643','2013-01-19','11:20:00',5.13),('7643','2013-01-19','11:25:00',7.11),('7643','2013-01-19','11:30:00',9.21),('7643','2013-01-19','11:35:00',6.86),('7643','2013-01-19','11:40:00',4.01),('7643','2013-01-19','11:45:00',3.79),('7643','2013-01-19','11:50:00',2.67),('7643','2013-01-19','11:55:00',2.01),('7643','2013-01-19','12:00:00',2.25),('7643','2013-01-19','12:05:00',2.13),('7643','2013-01-19','12:10:00',2.45),('7643','2013-01-19','12:15:00',2.98),('7643','2013-01-19','12:20:00',3.39),('7643','2013-01-19','12:25:00',3.57),('7643','2013-01-19','12:30:00',3.34),('7643','2013-01-19','12:35:00',3.09),('7643','2013-01-19','12:40:00',2.88),('7643','2013-01-19','12:45:00',2.81),('7643','2013-01-19','12:50:00',2.72),('7643','2013-01-19','12:55:00',2.68),('7643','2013-01-19','13:00:00',2.57),('7643','2013-01-19','13:05:00',2.44),('7643','2013-01-19','13:10:00',2.47),('7643','2013-01-19','13:15:00',2.72),('7643','2013-01-19','13:20:00',2.76),('7643','2013-01-19','13:25:00',2.84),('7643','2013-01-19','13:30:00',2.58),('7643','2013-01-19','13:35:00',2.86),('7643','2013-01-19','13:40:00',3.38),('7643','2013-01-19','13:45:00',3.25),('7643','2013-01-19','13:50:00',3.15),('7643','2013-01-19','13:55:00',2.79),('7643','2013-01-19','14:00:00',2.42),('7643','2013-01-19','14:05:00',2.11),('7643','2013-01-19','14:10:00',1.86),('7643','2013-01-19','14:15:00',2.1),('7643','2013-01-19','14:20:00',2.59),('7643','2013-01-19','14:25:00',2.24),('7643','2013-01-19','14:30:00',1.69),('7643','2013-01-19','14:35:00',1.42),('7643','2013-01-19','14:40:00',1.38),('7643','2013-01-19','14:45:00',1.41),('7643','2013-01-19','14:50:00',1.38),('7643','2013-01-19','14:55:00',1.11),('7643','2013-01-19','15:00:00',1.06),('7643','2013-01-18','08:25:00',1.04),('7643','2013-01-18','08:30:00',1.11),('7643','2013-01-18','08:35:00',1.22),('7643','2013-01-18','08:40:00',1.42),('7643','2013-01-18','08:45:00',1.69),('7643','2013-01-18','08:50:00',1.9),('7643','2013-01-18','08:55:00',2.05),('7643','2013-01-18','09:00:00',2.26),('7643','2013-01-18','09:05:00',2.5),('7643','2013-01-18','09:10:00',3.4),('7643','2013-01-18','09:15:00',5.35),('7643','2013-01-18','09:20:00',4.91),('7643','2013-01-18','09:25:00',3.97),('7643','2013-01-18','09:30:00',2.72),('7643','2013-01-18','09:35:00',2.45),('7643','2013-01-18','09:40:00',2.17),('7643','2013-01-18','09:45:00',2.9),('7643','2013-01-18','09:50:00',4.03),('7643','2013-01-18','09:55:00',5.83),('7643','2013-01-18','10:00:00',5.14),('7643','2013-01-18','10:05:00',4.03),('7643','2013-01-18','10:10:00',2.75),('7643','2013-01-18','10:15:00',1.9),('7643','2013-01-18','10:20:00',1.63),('7643','2013-01-18','10:25:00',2.18),('7643','2013-01-18','10:30:00',2.05),('7643','2013-01-18','10:35:00',3.38),('7643','2013-01-18','10:40:00',4.31),('7643','2013-01-18','10:45:00',4.93),('7643','2013-01-18','10:50:00',5.4),('7643','2013-01-18','10:55:00',2.66),('7643','2013-01-18','11:00:00',2.8),('7643','2013-01-18','11:05:00',3.06),('7643','2013-01-18','11:10:00',3.26),('7643','2013-01-18','11:15:00',3.47),('7643','2013-01-18','11:20:00',4.21),('7643','2013-01-18','11:25:00',4.34),('7643','2013-01-18','11:30:00',3.55),('7643','2013-01-18','11:35:00',2.4),('7643','2013-01-18','11:40:00',2.19),('7643','2013-01-18','11:45:00',2.46),('7643','2013-01-18','11:50:00',2.69),('7643','2013-01-18','11:55:00',2.49),('7643','2013-01-18','12:00:00',2.12),('7643','2013-01-18','12:05:00',2.11),('7643','2013-01-18','12:10:00',2.33),('7643','2013-01-18','12:15:00',2.5),('7643','2013-01-18','12:20:00',2.29),('7643','2013-01-18','12:25:00',1.86),('7643','2013-01-18','12:30:00',1.5),('7643','2013-01-18','12:35:00',1.29),('7643','2013-01-18','14:25:00',1.02),('7643','2013-01-18','14:30:00',1.84),('7643','2013-01-18','14:35:00',2.3),('7643','2013-01-18','14:40:00',1.5),('7643','2013-01-18','15:15:00',1.22),('7643','2013-01-17','08:35:00',1.2),('7643','2013-01-17','08:40:00',1.55),('7643','2013-01-17','08:45:00',2.15),('7643','2013-01-17','08:50:00',2.37),('7643','2013-01-17','08:57:00',2.47),('7643','2013-01-17','09:00:00',1.83),('7643','2013-01-17','09:05:00',1.52),('7643','2013-01-17','09:10:00',1.08),('7643','2013-01-17','09:20:00',1.24),('7643','2013-01-17','09:25:00',1.31),('7643','2013-01-17','09:35:00',1.65),('7643','2013-01-17','09:40:00',1.65),('7643','2013-01-17','09:45:00',1.39),('7643','2013-01-17','09:50:00',1.64),('7643','2013-01-17','09:55:00',2.08),('7643','2013-01-17','10:00:00',2.16),('7643','2013-01-17','10:05:00',2.22),('7643','2013-01-17','10:10:00',3),('7643','2013-01-17','10:15:00',9.11),('7643','2013-01-17','10:20:00',8.95),('7643','2013-01-17','10:25:00',6.56),('7643','2013-01-17','10:30:00',5.2),('7643','2013-01-17','10:35:00',4.05),('7643','2013-01-17','10:40:00',3.21),('7643','2013-01-17','10:45:00',2.91),('7643','2013-01-17','10:50:00',2.98),('7643','2013-01-17','10:55:00',3.01),('7643','2013-01-17','11:00:00',3.18),('7643','2013-01-17','11:05:00',3.34),('7643','2013-01-17','11:10:00',3.4),('7643','2013-01-17','11:15:00',3.26),('7643','2013-01-17','11:20:00',2.88),('7643','2013-01-17','11:25:00',2.94),('7643','2013-01-17','11:30:00',3.74),('7643','2013-01-17','11:35:00',4.52),('7643','2013-01-17','11:40:00',4.4),('7643','2013-01-17','11:45:00',3.66),('7643','2013-01-17','11:50:00',2.99),('7643','2013-01-17','11:55:00',3.04),('7643','2013-01-17','12:00:00',3.34),('7643','2013-01-17','12:05:00',3.32),('7643','2013-01-17','12:10:00',3.77),('7643','2013-01-17','12:15:00',3.83),('7643','2013-01-17','12:20:00',3.73),('7643','2013-01-17','12:25:00',3.88),('7643','2013-01-17','12:30:00',3.91),('7643','2013-01-17','12:35:00',4.68),('7643','2013-01-17','12:40:00',5.39),('7643','2013-01-17','12:45:00',5.6),('7643','2013-01-17','12:50:00',7.87),('7643','2013-01-17','12:55:00',7.49),('7643','2013-01-17','13:00:00',9.55),('7643','2013-01-17','13:05:00',8.96),('7643','2013-01-17','13:10:00',8.35),('7643','2013-01-17','13:15:00',8.96),('7643','2013-01-17','13:20:00',7.21),('7643','2013-01-17','13:25:00',5.84),('7643','2013-01-17','13:30:00',5.44),('7643','2013-01-17','13:35:00',5.36),('7643','2013-01-17','13:40:00',6.3),('7643','2013-01-17','13:45:00',7.99),('7643','2013-01-17','13:50:00',10.86),('7643','2013-01-17','13:55:00',11.29),('7643','2013-01-17','14:00:00',11.74),('7643','2013-01-17','14:05:00',10.07),('7643','2013-01-17','14:10:00',10.84),('7643','2013-01-17','14:15:00',6.93),('7643','2013-01-17','14:20:00',7.1),('7643','2013-01-17','14:25:00',5.61),('7643','2013-01-17','14:30:00',4.36),('7643','2013-01-17','14:35:00',3.69),('7643','2013-01-17','14:40:00',3.36),('7643','2013-01-17','14:45:00',3.97),('7643','2013-01-17','14:50:00',4.12),('7643','2013-01-17','14:55:00',3.4),('7643','2013-01-17','15:00:00',2.88),('7643','2013-01-17','15:05:00',3.08),('7643','2013-01-17','15:10:00',2.97),('7643','2013-01-17','15:15:00',3.3),('7643','2013-01-17','15:20:00',3.61),('7643','2013-01-17','15:25:00',4.17),('7643','2013-01-17','15:30:00',3.52),('7643','2013-01-17','15:35:00',2.56),('7643','2013-01-17','15:40:00',1.8),('7643','2013-01-17','15:45:00',2.87),('7643','2013-01-17','15:50:00',3.16),('7643','2013-01-17','15:55:00',3.25),('7643','2013-01-17','16:00:00',2.9),('7643','2013-01-17','16:05:00',2.72),('7643','2013-01-17','16:10:00',2.58),('7643','2013-01-17','16:15:00',2.43),('7643','2013-01-17','16:20:00',2.03),('7643','2013-01-17','16:25:00',1.72),('7643','2013-01-17','16:30:00',1.35),('7643','2013-01-17','16:35:00',1.03),('7643','2013-01-16','08:50:00',1.16),('7643','2013-01-16','08:55:00',1.32),('7643','2013-01-16','09:00:00',1.32),('7643','2013-01-16','09:05:00',1.77),('7643','2013-01-16','09:10:00',2.53),('7643','2013-01-16','09:15:00',2.73),('7643','2013-01-16','09:20:00',2.65),('7643','2013-01-16','09:25:00',2.39),('7643','2013-01-16','09:30:00',2.65),('7643','2013-01-16','09:35:00',2.97),('7643','2013-01-16','09:40:00',3.22),('7643','2013-01-16','09:45:00',4.01),('7643','2013-01-16','09:50:00',4.95),('7643','2013-01-16','09:55:00',4.63),('7643','2013-01-16','10:00:00',3.32),('7643','2013-01-16','10:05:00',3.48),('7643','2013-01-16','10:10:00',4.21),('7643','2013-01-16','10:15:00',4.95),('7643','2013-01-16','10:20:00',5.01),('7643','2013-01-16','10:25:00',6.34),('7643','2013-01-16','10:30:00',6.7),('7643','2013-01-16','10:35:00',6.2),('7643','2013-01-16','10:40:00',5.81),('7643','2013-01-16','10:45:00',6.32),('7643','2013-01-16','10:50:00',5.98),('7643','2013-01-16','10:55:00',7.18),('7643','2013-01-16','11:00:00',6.43),('7643','2013-01-16','11:05:00',6.16),('7643','2013-01-16','11:10:00',7.35),('7643','2013-01-16','11:15:00',7.34),('7643','2013-01-16','11:20:00',6.97),('7643','2013-01-16','11:25:00',6.05),('7643','2013-01-16','11:30:00',5.34),('7643','2013-01-16','11:35:00',5.98),('7643','2013-01-16','11:40:00',6.21),('7643','2013-01-16','11:45:00',5.39),('7643','2013-01-16','11:50:00',5.95),('7643','2013-01-16','11:55:00',6.41),('7643','2013-01-16','12:00:00',7.06),('7643','2013-01-16','12:05:00',7.15),('7643','2013-01-16','12:10:00',7.41),('7643','2013-01-16','12:15:00',8.36),('7643','2013-01-16','12:20:00',7.44),('7643','2013-01-16','12:25:00',6.03),('7643','2013-01-16','12:30:00',4.84),('7643','2013-01-16','12:35:00',5.83),('7643','2013-01-16','12:40:00',5.98),('7643','2013-01-16','12:45:00',4.53),('7643','2013-01-16','12:50:00',3.19),('7643','2013-01-16','12:55:00',3.11),('7643','2013-01-16','13:00:00',6.71),('7643','2013-01-16','13:05:00',5.57),('7643','2013-01-16','13:10:00',4.25),('7643','2013-01-16','13:15:00',5.6),('7643','2013-01-16','13:20:00',6.02),('7643','2013-01-16','13:25:00',5.5),('7643','2013-01-16','13:30:00',4.79),('7643','2013-01-16','13:35:00',5.87),('7643','2013-01-16','13:40:00',7.92),('7643','2013-01-16','13:45:00',6.91),('7643','2013-01-16','13:50:00',5.37),('7643','2013-01-16','13:55:00',3.49),('7643','2013-01-16','14:00:00',3.62),('7643','2013-01-16','14:05:00',3.88),('7643','2013-01-16','14:10:00',3.53),('7643','2013-01-16','14:15:00',2.13),('7643','2013-01-16','14:20:00',2.36),('7643','2013-01-16','14:25:00',3.18),('7643','2013-01-16','14:30:00',4.26),('7643','2013-01-16','14:35:00',5.57),('7643','2013-01-16','14:40:00',3.5),('7643','2013-01-16','14:45:00',1.31),('7643','2013-01-16','14:50:00',1.3),('7643','2013-01-16','14:55:00',2.65),('7643','2013-01-16','15:00:00',2.9),('7643','2013-01-16','15:05:00',1.94),('7643','2013-01-16','15:10:00',1.11),('7643','2013-01-16','15:15:00',1.15),('7643','2013-01-16','15:20:00',1.42),('7643','2013-01-16','15:25:00',1.5),('7643','2013-01-16','15:30:00',1.33),('7643','2013-01-16','15:35:00',1.24),('7643','2013-01-16','15:40:00',1.23),('7643','2013-01-16','15:45:00',1.37),('7643','2013-01-16','15:50:00',1.1),('7643','2013-01-15','08:40:00',1.92),('7643','2013-01-15','08:45:00',1.73),('7643','2013-01-15','09:00:00',1.18),('7643','2013-01-15','09:10:00',1.68),('7643','2013-01-15','09:15:00',4.3),('7643','2013-01-15','09:20:00',4.01),('7643','2013-01-15','09:25:00',6.13),('7643','2013-01-15','09:30:00',6.86),('7643','2013-01-15','09:35:00',7.23),('7643','2013-01-15','09:40:00',7.62),('7643','2013-01-15','09:45:00',5.08),('7643','2013-01-15','09:50:00',2.77),('7643','2013-01-15','09:55:00',3.53),('7643','2013-01-15','10:00:00',3.89),('7643','2013-01-15','10:05:00',2.37),('7643','2013-01-15','10:10:00',1.93),('7643','2013-01-15','10:20:00',1.3),('7643','2013-01-15','10:25:00',2.03),('7643','2013-01-15','10:30:00',2.75),('7643','2013-01-15','10:35:00',6.75),('7643','2013-01-15','10:40:00',7.79),('7643','2013-01-15','10:45:00',9.15),('7643','2013-01-15','10:50:00',2.55),('7643','2013-01-15','10:55:00',7.26),('7643','2013-01-15','11:00:00',3.03),('7643','2013-01-15','11:05:00',2.7),('7643','2013-01-15','11:10:00',1.66),('7643','2013-01-15','11:20:00',1.12),('7643','2013-01-15','11:25:00',6.17),('7643','2013-01-15','11:30:00',1.62),('7643','2013-01-15','12:00:00',5.43),('7643','2013-01-15','12:05:00',4.67),('7643','2013-01-15','12:10:00',5.49),('7643','2013-01-15','12:15:00',12.8),('7643','2013-01-15','12:20:00',12.64),('7643','2013-01-15','12:25:00',5.38),('7643','2013-01-15','12:30:00',1.73),('7643','2013-01-15','13:00:00',2.42),('7643','2013-01-15','13:05:00',8.07),('7643','2013-01-15','13:10:00',14.55),('7643','2013-01-15','13:15:00',15),('7643','2013-01-15','13:20:00',11.01),('7643','2013-01-15','13:25:00',7.25),('7643','2013-01-15','13:30:00',2.64),('7643','2013-01-15','13:35:00',1.15),('7643','2013-01-15','13:50:00',1.81),('7643','2013-01-15','13:55:00',9.93),('7643','2013-01-15','14:00:00',6.09),('7643','2013-01-15','14:05:00',5.46),('7643','2013-01-15','14:10:00',2.89),('7643','2013-01-15','15:00:00',1.44),('7643','2013-01-15','15:05:00',3.11),('7643','2013-01-15','15:10:00',3.04),('7643','2013-01-15','15:15:00',2.67),('7643','2013-01-15','15:20:00',1.24),('7643','2013-01-15','15:25:00',1.11),('7643','2013-01-15','15:30:00',1.05),('7643','2013-01-15','15:45:00',1.01),('7643','2013-01-15','15:50:00',1.12),('7643','2013-01-15','15:55:00',1.24),('7643','2013-01-15','16:00:00',1.11),('7643','2013-01-15','16:05:00',2.52),('7643','2013-01-15','16:10:00',2.17),('7643','2013-01-15','16:15:00',1.8),('7643','2013-01-15','16:20:00',1.04),('7643','2013-01-14','08:05:00',1.12),('7643','2013-01-14','08:10:00',1.02),('7643','2013-01-14','08:15:00',1.67),('7643','2013-01-14','08:20:00',1.32),('7643','2013-01-14','08:25:00',1.52),('7643','2013-01-14','08:30:00',1.7),('7643','2013-01-14','08:35:00',1.82),('7643','2013-01-14','08:40:00',1.72),('7643','2013-01-14','08:45:00',1.76),('7643','2013-01-14','08:50:00',1.67),('7643','2013-01-14','08:55:00',2.39),('7643','2013-01-14','09:00:00',2.35),('7643','2013-01-14','09:05:00',1.67),('7643','2013-01-14','09:10:00',1.79),('7643','2013-01-14','09:15:00',2.12),('7643','2013-01-14','09:20:00',1.47),('7643','2013-01-14','09:40:00',1.29),('7643','2013-01-14','09:45:00',1.93),('7643','2013-01-14','09:50:00',2.45),('7643','2013-01-14','09:55:00',3.61),('7643','2013-01-14','10:00:00',3.73),('7643','2013-01-14','10:05:00',2.87),('7643','2013-01-14','10:10:00',3.64),('7643','2013-01-14','10:15:00',3.29),('7643','2013-01-14','10:20:00',3.74),('7643','2013-01-14','10:25:00',3.81),('7643','2013-01-14','10:30:00',2.81),('7643','2013-01-14','10:35:00',3.13),('7643','2013-01-14','10:40:00',3.58),('7643','2013-01-14','10:45:00',4.22),('7643','2013-01-14','10:50:00',5.31),('7643','2013-01-14','10:55:00',5.73),('7643','2013-01-14','11:00:00',5.16),('7643','2013-01-14','11:05:00',5.7),('7643','2013-01-14','11:10:00',5.93),('7643','2013-01-14','11:15:00',5.63),('7643','2013-01-14','11:20:00',5.98),('7643','2013-01-14','11:25:00',5.83),('7643','2013-01-14','11:30:00',5.53),('7643','2013-01-14','11:35:00',5),('7643','2013-01-14','11:40:00',4.62),('7643','2013-01-14','11:45:00',3.94),('7643','2013-01-14','11:50:00',3.66),('7643','2013-01-14','11:55:00',4.03),('7643','2013-01-14','12:00:00',3.85),('7643','2013-01-14','12:05:00',3.68),('7643','2013-01-14','12:10:00',3.57),('7643','2013-01-14','12:15:00',4.23),('7643','2013-01-14','12:20:00',4.87),('7643','2013-01-14','12:25:00',4.7),('7643','2013-01-14','12:30:00',4.29),('7643','2013-01-14','12:35:00',4.24),('7643','2013-01-14','12:40:00',4.77),('7643','2013-01-14','12:45:00',4.97),('7643','2013-01-14','12:50:00',4.6),('7643','2013-01-14','12:55:00',4.12),('7643','2013-01-14','13:00:00',3.41),('7643','2013-01-14','13:05:00',3.58),('7643','2013-01-14','13:10:00',3.55),('7643','2013-01-14','13:15:00',3.68),('7643','2013-01-14','13:20:00',3.7),('7643','2013-01-14','13:25:00',3.6),('7643','2013-01-14','13:30:00',4.01),('7643','2013-01-14','13:35:00',4.09),('7643','2013-01-14','13:40:00',4.61),('7643','2013-01-14','13:45:00',4.31),('7643','2013-01-14','13:50:00',4.27),('7643','2013-01-14','13:55:00',4.91),('7643','2013-01-14','14:00:00',9.12),('7643','2013-01-14','14:05:00',10.69),('7643','2013-01-14','14:10:00',9.96),('7643','2013-01-14','14:15:00',10.62),('7643','2013-01-14','14:20:00',10.98),('7643','2013-01-14','14:25:00',10.46),('7643','2013-01-14','14:30:00',8.26),('7643','2013-01-14','14:35:00',7.14),('7643','2013-01-14','14:40:00',7.77),('7643','2013-01-14','14:45:00',7.48),('7643','2013-01-14','14:50:00',6.3),('7643','2013-01-14','14:55:00',4.74),('7643','2013-01-14','15:00:00',6.82),('7643','2013-01-14','15:05:00',6.89),('7643','2013-01-14','15:10:00',5.92),('7643','2013-01-14','15:15:00',3.11),('7643','2013-01-14','15:20:00',2.61),('7643','2013-01-14','15:25:00',3.5),('7643','2013-01-14','15:30:00',3.13),('7643','2013-01-14','15:35:00',3.01),('7643','2013-01-14','15:40:00',2.73),('7643','2013-01-14','15:45:00',2.6),('7643','2013-01-14','15:50:00',2.62),('7643','2013-01-14','15:55:00',2.56),('7643','2013-01-14','16:00:00',2.96),('7643','2013-01-14','16:05:00',3.34),('7643','2013-01-14','16:10:00',3.06),('7643','2013-01-14','16:15:00',2.67),('7643','2013-01-14','16:20:00',2.26),('7643','2013-01-14','16:25:00',1.88),('7643','2013-01-14','16:30:00',1.55),('7643','2013-01-14','16:35:00',1.16),('7643','2013-01-13','09:30:00',1.08),('7643','2013-01-13','09:35:00',1.3),('7643','2013-01-13','09:40:00',1.49),('7643','2013-01-13','09:45:00',2),('7643','2013-01-13','09:50:00',2.21),('7643','2013-01-13','09:55:00',1.84),('7643','2013-01-13','10:00:00',1.12),('7643','2013-01-13','10:05:00',1.02),('7643','2013-01-13','10:10:00',1.03),('7643','2013-01-13','10:20:00',1.03),('7643','2013-01-13','10:25:00',2.02),('7643','2013-01-13','10:30:00',1.42),('7643','2013-01-13','10:35:00',1.31),('7643','2013-01-13','10:45:00',1.48),('7643','2013-01-13','10:50:00',1.22),('7643','2013-01-13','10:55:00',1.73),('7643','2013-01-13','11:00:00',1.56),('7643','2013-01-13','11:05:00',1.76),('7643','2013-01-13','11:10:00',1.67),('7643','2013-01-13','11:15:00',1.81),('7643','2013-01-13','11:20:00',2.65),('7643','2013-01-13','11:25:00',2.68),('7643','2013-01-13','11:30:00',1.97),('7643','2013-01-13','11:35:00',2),('7643','2013-01-13','11:40:00',1.91),('7643','2013-01-13','11:45:00',1.64),('7643','2013-01-13','11:50:00',2.29),('7643','2013-01-13','11:55:00',1.81),('7643','2013-01-13','12:00:00',1.46),('7643','2013-01-13','12:05:00',1.29),('7643','2013-01-13','12:10:00',1.27),('7643','2013-01-13','12:15:00',1.68),('7643','2013-01-13','12:20:00',2.3),('7643','2013-01-13','12:25:00',3.16),('7643','2013-01-13','12:30:00',3.26),('7643','2013-01-13','12:35:00',2.93),('7643','2013-01-13','12:40:00',3.33),('7643','2013-01-13','12:45:00',3.66),('7643','2013-01-13','12:50:00',4.55),('7643','2013-01-13','12:55:00',4.27),('7643','2013-01-13','13:00:00',4.44),('7643','2013-01-13','13:05:00',4.25),('7643','2013-01-13','13:10:00',3.95),('7643','2013-01-13','13:15:00',3.32),('7643','2013-01-13','13:20:00',2.32),('7643','2013-01-13','13:25:00',1.36),('7643','2013-01-13','13:30:00',1.75),('7643','2013-01-13','13:35:00',2.54),('7643','2013-01-13','13:40:00',2.19),('7643','2013-01-13','13:45:00',1.16),('7643','2013-01-13','14:15:00',1.55),('7643','2013-01-13','14:20:00',1.3),('7643','2013-01-13','15:10:00',1.5),('7643','2013-01-13','15:15:00',5.02),('7643','2013-01-13','15:20:00',3.28),('7643','2013-01-13','15:25:00',3.31),('7643','2013-01-13','15:30:00',2.17),('7643','2013-01-13','15:35:00',1.35),('7643','2013-01-13','15:40:00',1.15),('7643','2013-01-13','15:45:00',1.12),('7643','2013-01-13','15:50:00',1.86),('7643','2013-01-13','15:55:00',1.41),('7643','2013-01-12','09:10:00',2.44),('7643','2013-01-12','09:15:00',6.45),('7643','2013-01-12','09:20:00',6.7),('7643','2013-01-12','09:25:00',6.71),('7643','2013-01-12','09:30:00',7.11),('7643','2013-01-12','09:35:00',7.36),('7643','2013-01-12','09:40:00',4.58),('7643','2013-01-12','09:45:00',2.8),('7643','2013-01-12','09:50:00',5.57),('7643','2013-01-12','09:55:00',7.07),('7643','2013-01-12','10:00:00',7.2),('7643','2013-01-12','10:05:00',7.59),('7643','2013-01-12','10:10:00',4.78),('7643','2013-01-12','10:15:00',3.04),('7643','2013-01-12','10:20:00',4.33),('7643','2013-01-12','10:25:00',6.32),('7643','2013-01-12','10:30:00',7.76),('7643','2013-01-12','10:35:00',3.65),('7643','2013-01-12','10:40:00',1.83),('7643','2013-01-12','10:45:00',1.44),('7643','2013-01-12','11:55:00',1.27),('7643','2013-01-12','12:00:00',1.37),('7643','2013-01-12','12:05:00',1.46),('7643','2013-01-12','12:10:00',1.45),('7643','2013-01-12','12:15:00',1.84),('7643','2013-01-12','12:20:00',1.95),('7643','2013-01-12','12:25:00',1.5),('7643','2013-01-12','12:30:00',1.6),('7643','2013-01-12','12:35:00',1.41),('7643','2013-01-12','12:40:00',1.64),('7643','2013-01-12','12:45:00',1.51),('7643','2013-01-12','13:40:00',1.01),('7643','2013-01-12','14:50:00',1.02),('7643','2013-01-11','08:05:00',1.19),('7643','2013-01-11','08:10:00',1.46),('7643','2013-01-11','08:15:00',1.72),('7643','2013-01-11','08:20:00',2.02),('7643','2013-01-11','08:25:00',2.33),('7643','2013-01-11','08:30:00',2.65),('7643','2013-01-11','08:35:00',2.96),('7643','2013-01-11','08:40:00',3.31),('7643','2013-01-11','08:45:00',3.6),('7643','2013-01-11','08:50:00',3.89),('7643','2013-01-11','08:55:00',4.21),('7643','2013-01-11','09:00:00',4.59),('7643','2013-01-11','09:05:00',4.91),('7643','2013-01-11','09:10:00',5.15),('7643','2013-01-11','09:15:00',5.4),('7643','2013-01-11','09:20:00',5.65),('7643','2013-01-11','09:25:00',5.98),('7643','2013-01-11','09:30:00',6.21),('7643','2013-01-11','09:35:00',6.38),('7643','2013-01-11','09:40:00',6.63),('7643','2013-01-11','09:45:00',6.84),('7643','2013-01-11','09:50:00',7.1),('7643','2013-01-11','09:55:00',7.33),('7643','2013-01-11','10:00:00',7.57),('7643','2013-01-11','10:05:00',7.95),('7643','2013-01-11','10:10:00',8.14),('7643','2013-01-11','10:15:00',8.35),('7643','2013-01-11','10:20:00',8.48),('7643','2013-01-11','10:25:00',8.68),('7643','2013-01-11','10:30:00',8.86),('7643','2013-01-11','10:35:00',9),('7643','2013-01-11','10:40:00',9.16),('7643','2013-01-11','10:45:00',9.38),('7643','2013-01-11','10:50:00',9.52),('7643','2013-01-11','10:55:00',9.62),('7643','2013-01-11','11:00:00',9.69),('7643','2013-01-11','11:05:00',9.55),('7643','2013-01-11','11:10:00',9.71),('7643','2013-01-11','11:15:00',9.8),('7643','2013-01-11','11:20:00',9.97),('7643','2013-01-11','11:25:00',9.96),('7643','2013-01-11','11:30:00',9.95),('7643','2013-01-11','11:35:00',10.06),('7643','2013-01-11','11:40:00',10.14),('7643','2013-01-11','11:45:00',10.24),('7643','2013-01-11','11:50:00',10.34),('7643','2013-01-11','11:55:00',10.33),('7643','2013-01-11','12:00:00',10.22),('7643','2013-01-11','12:05:00',10.15),('7643','2013-01-11','12:10:00',10.08),('7643','2013-01-11','12:15:00',10.2),('7643','2013-01-11','12:20:00',10.06),('7643','2013-01-11','12:25:00',9.95),('7643','2013-01-11','12:30:00',10.12),('7643','2013-01-11','12:35:00',7.9),('7643','2013-01-11','12:40:00',6.68),('7643','2013-01-11','12:45:00',1.96),('7643','2013-01-11','12:50:00',8.17),('7643','2013-01-11','12:55:00',5.66),('7643','2013-01-11','13:00:00',10.11),('7643','2013-01-11','13:05:00',9.69),('7643','2013-01-11','13:10:00',7.87),('7643','2013-01-11','13:15:00',8.06),('7643','2013-01-11','13:20:00',4.39),('7643','2013-01-11','13:25:00',8.53),('7643','2013-01-11','13:30:00',7.77),('7643','2013-01-11','13:35:00',9.12),('7643','2013-01-11','13:40:00',3),('7643','2013-01-11','13:45:00',6.63),('7643','2013-01-11','13:50:00',9.08),('7643','2013-01-11','13:55:00',9.56),('7643','2013-01-11','14:00:00',4.81),('7643','2013-01-11','14:05:00',8.04),('7643','2013-01-11','14:10:00',8.91),('7643','2013-01-11','14:15:00',8.12),('7643','2013-01-11','14:20:00',7.61),('7643','2013-01-11','14:25:00',7.44),('7643','2013-01-11','14:30:00',6.96),('7643','2013-01-11','14:35:00',6.72),('7643','2013-01-11','14:40:00',6.45),('7643','2013-01-11','14:45:00',6.13),('7643','2013-01-11','14:50:00',5.99),('7643','2013-01-11','14:55:00',5.81),('7643','2013-01-11','15:00:00',5.49),('7643','2013-01-11','15:05:00',5.07),('7643','2013-01-11','15:10:00',4.57),('7643','2013-01-11','15:15:00',3.6),('7643','2013-01-11','15:20:00',3.94),('7643','2013-01-11','15:25:00',3.92),('7643','2013-01-11','15:30:00',2.01),('7643','2013-01-11','15:35:00',3.37),('7643','2013-01-11','15:40:00',2.86),('7643','2013-01-11','15:45:00',2.79),('7643','2013-01-11','15:50:00',2.64),('7643','2013-01-11','15:55:00',2.42),('7643','2013-01-11','16:00:00',2.15),('7643','2013-01-11','16:05:00',1.91),('7643','2013-01-11','16:10:00',1.64),('7643','2013-01-11','16:15:00',1.33),('7643','2013-01-11','16:20:00',1.07),('7643','2014-03-18','06:50:00',1),('7643','2014-03-18','06:55:00',1.18),('7643','2014-03-18','07:00:00',1.47),('7643','2014-03-18','07:05:00',1.57),('7643','2014-03-18','07:10:00',1.42),('7643','2014-03-18','07:15:00',1.52),('7643','2014-03-18','07:20:00',2.22),('7643','2014-03-18','07:25:00',2.27),('7643','2014-03-18','07:30:00',1.89),('7643','2014-03-18','07:35:00',1.14),('7643','2014-03-18','07:40:00',1.05),('7643','2014-03-18','07:45:00',1.08),('7643','2014-03-18','07:50:00',1.44),('7643','2014-03-18','07:55:00',1.61),('7643','2014-03-18','08:00:00',1.58),('7643','2014-03-18','08:05:00',1.63),('7643','2014-03-18','08:10:00',1.69),('7643','2014-03-18','08:15:00',1.62),('7643','2014-03-18','08:20:00',1.7),('7643','2014-03-18','08:25:00',1.95),('7643','2014-03-18','08:30:00',2.17),('7643','2014-03-18','08:35:00',2.47),('7643','2014-03-18','08:40:00',2.91),('7643','2014-03-18','08:45:00',3.07),('7643','2014-03-18','08:50:00',3.32),('7643','2014-03-18','08:55:00',3.77),('7643','2014-03-18','09:00:00',4.19),('7643','2014-03-18','09:05:00',4.71),('7643','2014-03-18','09:10:00',5.5),('7643','2014-03-18','09:15:00',5.77),('7643','2014-03-18','09:20:00',6.56),('7643','2014-03-18','09:25:00',8.65),('7643','2014-03-18','09:30:00',6.76),('7643','2014-03-18','09:35:00',10.58),('7643','2014-03-18','09:40:00',9.66),('7643','2014-03-18','09:45:00',12.82),('7643','2014-03-18','09:50:00',14.78),('7643','2014-03-18','09:55:00',9.66),('7643','2014-03-18','10:00:00',6.12),('7643','2014-03-18','10:05:00',4.62),('7643','2014-03-18','10:10:00',3.82),('7643','2014-03-18','10:15:00',3.25),('7643','2014-03-18','10:20:00',3.59),('7643','2014-03-18','10:25:00',3.7),('7643','2014-03-18','10:30:00',4.5),('7643','2014-03-18','10:35:00',6.4),('7643','2014-03-18','10:40:00',12.34),('7643','2014-03-18','10:45:00',12.96),('7643','2014-03-18','10:50:00',10.38),('7643','2014-03-18','10:55:00',5.21),('7643','2014-03-18','11:00:00',4.62),('7643','2014-03-18','11:05:00',10.19),('7643','2014-03-18','11:10:00',15.24),('7643','2014-03-18','11:15:00',7.81),('7643','2014-03-18','11:20:00',7.36),('7643','2014-03-18','11:25:00',8.41),('7643','2014-03-18','11:30:00',8.45),('7643','2014-03-18','11:35:00',11.39),('7643','2014-03-18','11:40:00',8.31),('7643','2014-03-18','11:45:00',8.36),('7643','2014-03-18','11:50:00',6.97),('7643','2014-03-18','11:55:00',6.53),('7643','2014-03-18','12:00:00',10.66),('7643','2014-03-18','12:05:00',10.93),('7643','2014-03-18','12:10:00',16.62),('7643','2014-03-18','12:15:00',16.79),('7643','2014-03-18','12:20:00',13.64),('7643','2014-03-18','12:25:00',15.91),('7643','2014-03-18','12:30:00',16.37),('7643','2014-03-18','12:35:00',15.82),('7643','2014-03-18','12:40:00',15.71),('7643','2014-03-18','12:45:00',15.37),('7643','2014-03-18','12:50:00',13.09),('7643','2014-03-18','12:55:00',9.25),('7643','2014-03-18','13:00:00',15.27),('7643','2014-03-18','13:05:00',14.34),('7643','2014-03-18','13:10:00',15.01),('7643','2014-03-18','13:15:00',14.95),('7643','2014-03-18','13:20:00',7.47),('7643','2014-03-18','13:25:00',10.08),('7643','2014-03-18','13:30:00',14.6),('7643','2014-03-18','13:35:00',14.61),('7643','2014-03-18','13:40:00',14.38),('7643','2014-03-18','13:45:00',14.38),('7643','2014-03-18','13:50:00',13.91),('7643','2014-03-18','13:55:00',13.57),('7643','2014-03-18','14:00:00',13.46),('7643','2014-03-18','14:05:00',13.27),('7643','2014-03-18','14:10:00',13.27),('7643','2014-03-18','14:15:00',12.89),('7643','2014-03-18','14:20:00',12.74),('7643','2014-03-18','14:25:00',12.65),('7643','2014-03-18','14:30:00',12.2),('7643','2014-03-18','14:35:00',12.24),('7643','2014-03-18','14:40:00',12.09),('7643','2014-03-18','14:45:00',11.86),('7643','2014-03-18','14:50:00',11.48),('7643','2014-03-18','14:55:00',11.22),('7643','2014-03-18','15:00:00',11.01),('7643','2014-03-18','15:05:00',10.63),('7643','2014-03-18','15:10:00',10.38),('7643','2014-03-18','15:15:00',10.3),('7643','2014-03-18','15:20:00',9.91),('7643','2014-03-18','15:25:00',9.76),('7643','2014-03-18','15:30:00',9.35),('7643','2014-03-18','15:35:00',8.86),('7643','2014-03-18','15:40:00',8.77),('7643','2014-03-18','15:45:00',8.53),('7643','2014-03-18','15:50:00',8.11),('7643','2014-03-18','15:55:00',7.95),('7643','2014-03-18','16:00:00',7.48),('7643','2014-03-18','16:05:00',7.18),('7643','2014-03-18','16:10:00',6.92),('7643','2014-03-18','16:15:00',6.54),('7643','2014-03-18','16:20:00',6.13),('7643','2014-03-18','16:25:00',5.51),('7643','2014-03-18','16:30:00',5.18),('7643','2014-03-18','16:35:00',4.65),('7643','2014-03-18','16:40:00',4.29),('7643','2014-03-18','16:45:00',4.07),('7643','2014-03-18','16:50:00',3.4),('7643','2014-03-18','16:55:00',3.11),('7643','2014-03-18','17:00:00',2.43),('7643','2014-03-18','17:05:00',2.02),('7643','2014-03-18','17:10:00',1.79),('7643','2014-03-18','17:15:00',1.86),('7643','2014-03-18','17:20:00',1.67);
INSERT INTO `solarlog` VALUES ('7643','2014-03-18','17:25:00',1.5),('7643','2014-03-18','17:30:00',1.15),('7643','2013-01-10','09:00:00',1.38),('7643','2013-01-10','09:05:00',1.41),('7643','2013-01-10','09:10:00',1.57),('7643','2013-01-10','09:15:00',1.54),('7643','2013-01-10','09:20:00',1.78),('7643','2013-01-10','09:25:00',1.72),('7643','2013-01-10','09:30:00',1.81),('7643','2013-01-10','09:35:00',2),('7643','2013-01-10','09:40:00',2.06),('7643','2013-01-10','09:45:00',2.86),('7643','2013-01-10','09:50:00',3.71),('7643','2013-01-10','09:55:00',2.77),('7643','2013-01-10','10:00:00',4.54),('7643','2013-01-10','10:05:00',4.55),('7643','2013-01-10','10:10:00',5.28),('7643','2013-01-10','10:15:00',5.49),('7643','2013-01-10','10:20:00',4.98),('7643','2013-01-10','10:25:00',8.61),('7643','2013-01-10','10:30:00',8.71),('7643','2013-01-10','10:35:00',8.84),('7643','2013-01-10','10:40:00',8.99),('7643','2013-01-10','10:45:00',9.1),('7643','2013-01-10','10:50:00',9.27),('7643','2013-01-10','10:55:00',9.38),('7643','2013-01-10','11:00:00',9.5),('7643','2013-01-10','11:05:00',9.52),('7643','2013-01-10','11:10:00',9.46),('7643','2013-01-10','11:15:00',9.48),('7643','2013-01-10','11:20:00',9.29),('7643','2013-01-10','11:25:00',6.86),('7643','2013-01-10','11:30:00',3.65),('7643','2013-01-10','11:35:00',6.4),('7643','2013-01-10','11:40:00',3.81),('7643','2013-01-10','11:45:00',5.63),('7643','2013-01-10','11:50:00',5.63),('7643','2013-01-10','11:55:00',4.32),('7643','2013-01-10','12:00:00',3.5),('7643','2013-01-10','12:05:00',2.71),('7643','2013-01-10','12:10:00',2.07),('7643','2013-01-10','12:15:00',2.56),('7643','2013-01-10','12:20:00',2.87),('7643','2013-01-10','12:25:00',2.1),('7643','2013-01-10','12:30:00',1.34),('7643','2013-01-10','12:40:00',1.17),('7643','2013-01-10','12:45:00',1.67),('7643','2013-01-10','12:50:00',2.91),('7643','2013-01-10','12:55:00',8.54),('7643','2013-01-10','13:00:00',4.99),('7643','2013-01-10','13:05:00',4.37),('7643','2013-01-10','13:10:00',7.1),('7643','2013-01-10','13:15:00',5.01),('7643','2013-01-10','13:20:00',3.3),('7643','2013-01-10','13:25:00',2.3),('7643','2013-01-10','13:30:00',4.26),('7643','2013-01-10','13:35:00',9.89),('7643','2013-01-10','13:40:00',8.66),('7643','2013-01-10','13:45:00',4.81),('7643','2013-01-10','13:50:00',2.55),('7643','2013-01-10','13:55:00',1.58),('7643','2013-01-10','14:00:00',1.55),('7643','2013-01-10','14:05:00',1.32),('7643','2013-01-10','14:20:00',4.47),('7643','2013-01-10','14:25:00',4.75),('7643','2013-01-10','14:30:00',3.14),('7643','2013-01-10','14:35:00',2.91),('7643','2013-01-10','14:40:00',2.55),('7643','2013-01-10','14:45:00',4.48),('7643','2013-01-10','14:50:00',6.53),('7643','2013-01-10','14:55:00',3.39),('7643','2013-01-10','15:00:00',5.71),('7643','2013-01-10','15:05:00',5.79),('7643','2013-01-10','15:10:00',2.67),('7643','2013-01-10','15:20:00',1.23),('7643','2013-01-10','15:40:00',1.48),('7643','2013-01-10','15:45:00',2.03),('7643','2013-01-10','15:50:00',1.31),('7643','2013-01-09','09:55:00',1.43),('7643','2013-01-09','10:00:00',1.89),('7643','2013-01-09','10:05:00',2.02),('7643','2013-01-09','10:10:00',1.85),('7643','2013-01-09','10:15:00',1.47),('7643','2013-01-09','10:20:00',1.59),('7643','2013-01-09','10:25:00',1.99),('7643','2013-01-09','10:30:00',1.83),('7643','2013-01-09','10:35:00',1.56),('7643','2013-01-09','10:40:00',1.17),('7643','2013-01-09','11:05:00',1.15),('7643','2013-01-09','11:15:00',1.1),('7643','2013-01-09','11:20:00',2.38),('7643','2013-01-09','11:25:00',2.97),('7643','2013-01-09','11:30:00',3.67),('7643','2013-01-09','11:35:00',2.9),('7643','2013-01-09','11:40:00',1.84),('7643','2013-01-09','11:45:00',2.02),('7643','2013-01-09','11:50:00',3.12),('7643','2013-01-09','11:55:00',4.56),('7643','2013-01-09','12:00:00',4.73),('7643','2013-01-09','12:05:00',4.61),('7643','2013-01-09','12:10:00',4.15),('7643','2013-01-09','12:15:00',3.25),('7643','2013-01-09','12:20:00',2.16),('7643','2013-01-09','12:25:00',1.76),('7643','2013-01-09','12:30:00',1.7),('7643','2013-01-09','12:35:00',1.67),('7643','2013-01-09','12:40:00',1.74),('7643','2013-01-09','12:45:00',1.9),('7643','2013-01-09','12:50:00',1.74),('7643','2013-01-09','12:55:00',1.48),('7643','2013-01-09','13:00:00',1.11),('7643','2013-01-09','13:05:00',1.08),('7643','2013-01-09','13:10:00',1.49),('7643','2013-01-09','13:15:00',2.04),('7643','2013-01-09','13:20:00',1.93),('7643','2013-01-09','13:25:00',1.56),('7643','2013-01-09','13:30:00',1.72),('7643','2013-01-09','13:35:00',1.8),('7643','2013-01-09','13:40:00',1.95),('7643','2013-01-09','13:45:00',2.21),('7643','2013-01-09','13:50:00',2.12),('7643','2013-01-09','13:55:00',2.27),('7643','2013-01-09','14:00:00',2.51),('7643','2013-01-09','14:05:00',2.01),('7643','2013-01-09','14:10:00',1.53),('7643','2013-01-09','14:15:00',1.13),('7643','2013-01-09','14:30:00',1.47),('7643','2013-01-09','14:35:00',1.72),('7643','2013-01-09','15:10:00',1.12),('7643','2013-01-08','09:10:00',1.04),('7643','2013-01-08','09:15:00',1.13),('7643','2013-01-08','09:20:00',1.18),('7643','2013-01-08','09:25:00',1.3),('7643','2013-01-08','09:30:00',1.57),('7643','2013-01-08','09:35:00',2.83),('7643','2013-01-08','09:40:00',3.8),('7643','2013-01-08','09:45:00',2.45),('7643','2013-01-08','09:50:00',2.26),('7643','2013-01-08','09:55:00',2.13),('7643','2013-01-08','10:00:00',2.1),('7643','2013-01-08','10:05:00',2.2),('7643','2013-01-08','10:10:00',2.3),('7643','2013-01-08','10:15:00',2.54),('7643','2013-01-08','10:20:00',2.87),('7643','2013-01-08','10:25:00',2.76),('7643','2013-01-08','10:30:00',3.28),('7643','2013-01-08','10:35:00',3.34),('7643','2013-01-08','10:40:00',3.46),('7643','2013-01-08','10:45:00',4.67),('7643','2013-01-08','10:50:00',4.04),('7643','2013-01-08','10:55:00',6.7),('7643','2013-01-08','11:00:00',3.7),('7643','2013-01-08','11:05:00',4.25),('7643','2013-01-08','11:10:00',4.66),('7643','2013-01-08','11:15:00',10.73),('7643','2013-01-08','11:20:00',7.71),('7643','2013-01-08','11:25:00',4.5),('7643','2013-01-08','11:30:00',5.23),('7643','2013-01-08','11:35:00',5.16),('7643','2013-01-08','11:40:00',4.45),('7643','2013-01-08','11:45:00',4.07),('7643','2013-01-08','11:50:00',5.22),('7643','2013-01-08','11:55:00',6.27),('7643','2013-01-08','12:00:00',5.18),('7643','2013-01-08','12:05:00',4.66),('7643','2013-01-08','12:10:00',4.23),('7643','2013-01-08','12:15:00',4.12),('7643','2013-01-08','12:20:00',4.1),('7643','2013-01-08','12:25:00',3.83),('7643','2013-01-08','12:30:00',3.53),('7643','2013-01-08','12:35:00',3.82),('7643','2013-01-08','12:40:00',3.67),('7643','2013-01-08','12:45:00',3.51),('7643','2013-01-08','12:50:00',3.65),('7643','2013-01-08','12:55:00',4.18),('7643','2013-01-08','13:00:00',5.23),('7643','2013-01-08','13:05:00',6.71),('7643','2013-01-08','13:10:00',7.44),('7643','2013-01-08','13:15:00',4.5),('7643','2013-01-08','13:20:00',4.2),('7643','2013-01-08','13:25:00',3.57),('7643','2013-01-08','13:30:00',3.2),('7643','2013-01-08','13:35:00',3.13),('7643','2013-01-08','13:40:00',3.18),('7643','2013-01-08','13:45:00',3.19),('7643','2013-01-08','13:50:00',2.79),('7643','2013-01-08','13:55:00',2.64),('7643','2013-01-08','14:00:00',2.75),('7643','2013-01-08','14:05:00',2.55),('7643','2013-01-08','14:10:00',2.41),('7643','2013-01-08','14:15:00',2.21),('7643','2013-01-08','14:20:00',1.99),('7643','2013-01-08','14:25:00',1.82),('7643','2013-01-08','14:30:00',1.66),('7643','2013-01-08','14:35:00',1.72),('7643','2013-01-08','14:40:00',1.71),('7643','2013-01-08','14:45:00',1.4),('7643','2013-01-08','14:50:00',1.22),('7643','2013-01-08','14:55:00',1.16),('7643','2013-01-08','15:00:00',1.11),('7643','2013-01-08','15:05:00',1.06),('7643','2013-01-08','15:45:00',1.3),('7643','2013-01-08','15:50:00',1.26),('7643','2013-01-07','08:20:00',1.01),('7643','2013-01-07','08:25:00',1.79),('7643','2013-01-07','08:30:00',2.79),('7643','2013-01-07','08:35:00',4.27),('7643','2013-01-07','08:40:00',4.55),('7643','2013-01-07','08:45:00',4.91),('7643','2013-01-07','08:50:00',5.24),('7643','2013-01-07','08:55:00',5.79),('7643','2013-01-07','09:00:00',6.14),('7643','2013-01-07','09:05:00',6.06),('7643','2013-01-07','09:10:00',3.86),('7643','2013-01-07','09:15:00',4.92),('7643','2013-01-07','09:20:00',6.07),('7643','2013-01-07','09:25:00',6.41),('7643','2013-01-07','09:30:00',5.82),('7643','2013-01-07','09:35:00',4.55),('7643','2013-01-07','09:40:00',7),('7643','2013-01-07','09:45:00',7.97),('7643','2013-01-07','09:50:00',8.39),('7643','2013-01-07','09:55:00',8.24),('7643','2013-01-07','10:00:00',7.62),('7643','2013-01-07','10:05:00',7.37),('7643','2013-01-07','10:10:00',7.48),('7643','2013-01-07','10:15:00',7.81),('7643','2013-01-07','10:20:00',7.26),('7643','2013-01-07','10:25:00',7.96),('7643','2013-01-07','10:30:00',7.91),('7643','2013-01-07','10:35:00',8.6),('7643','2013-01-07','10:40:00',9.21),('7643','2013-01-07','10:45:00',9.11),('7643','2013-01-07','10:50:00',9.3),('7643','2013-01-07','10:55:00',9.44),('7643','2013-01-07','11:00:00',9.28),('7643','2013-01-07','11:05:00',9.66),('7643','2013-01-07','11:10:00',9.74),('7643','2013-01-07','11:15:00',9.77),('7643','2013-01-07','11:20:00',9.83),('7643','2013-01-07','11:25:00',9.93),('7643','2013-01-07','11:30:00',10.05),('7643','2013-01-07','11:35:00',10.08),('7643','2013-01-07','11:40:00',9.84),('7643','2013-01-07','11:45:00',11.77),('7643','2013-01-07','11:50:00',9.34),('7643','2013-01-07','11:55:00',6.87),('7643','2013-01-07','12:00:00',6.06),('7643','2013-01-07','12:05:00',5.78),('7643','2013-01-07','12:10:00',6.08),('7643','2013-01-07','12:15:00',5.61),('7643','2013-01-07','12:20:00',4.95),('7643','2013-01-07','12:25:00',4.84),('7643','2013-01-07','12:30:00',4.67),('7643','2013-01-07','12:35:00',4.56),('7643','2013-01-07','12:40:00',5.73),('7643','2013-01-07','12:45:00',7.16),('7643','2013-01-07','12:50:00',9.16),('7643','2013-01-07','12:55:00',7.41),('7643','2013-01-07','13:00:00',3.31),('7643','2013-01-07','13:05:00',3.06),('7643','2013-01-07','13:10:00',3.16),('7643','2013-01-07','13:15:00',3.58),('7643','2013-01-07','13:20:00',4.98),('7643','2013-01-07','13:25:00',3.64),('7643','2013-01-07','13:30:00',3.09),('7643','2013-01-07','13:35:00',2.97),('7643','2013-01-07','13:40:00',3.53),('7643','2013-01-07','13:45:00',3.8),('7643','2013-01-07','13:50:00',5.18),('7643','2013-01-07','13:55:00',6.39),('7643','2013-01-07','14:00:00',5.06),('7643','2013-01-07','14:05:00',5.03),('7643','2013-01-07','14:10:00',3.1),('7643','2013-01-07','14:15:00',2.98),('7643','2013-01-07','14:20:00',2.78),('7643','2013-01-07','14:25:00',3),('7643','2013-01-07','14:30:00',3.52),('7643','2013-01-07','14:35:00',3.24),('7643','2013-01-07','14:40:00',3.75),('7643','2013-01-07','14:45:00',2.76),('7643','2013-01-07','14:50:00',2.18),('7643','2013-01-07','14:55:00',2.16),('7643','2013-01-07','15:00:00',1.92),('7643','2013-01-07','15:05:00',2.22),('7643','2013-01-07','15:10:00',2.83),('7643','2013-01-07','15:15:00',3.38),('7643','2013-01-07','15:20:00',3.07),('7643','2013-01-07','15:25:00',2.08),('7643','2013-01-07','15:30:00',2.04),('7643','2013-01-07','15:35:00',2.35),('7643','2013-01-07','15:40:00',2.33),('7643','2013-01-07','15:45:00',1.99),('7643','2013-01-07','15:50:00',1.39),('7643','2013-01-07','15:55:00',1.02),('7643','2013-01-06','08:10:00',1.23),('7643','2013-01-06','08:15:00',1.5),('7643','2013-01-06','08:20:00',1.77),('7643','2013-01-06','08:25:00',2.04),('7643','2013-01-06','08:30:00',2.35),('7643','2013-01-06','08:35:00',2.64),('7643','2013-01-06','08:40:00',2.97),('7643','2013-01-06','08:45:00',3.28),('7643','2013-01-06','08:50:00',3.63),('7643','2013-01-06','08:55:00',4.02),('7643','2013-01-06','09:00:00',4.17),('7643','2013-01-06','09:05:00',3.81),('7643','2013-01-06','09:10:00',3.95),('7643','2013-01-06','09:15:00',3.21),('7643','2013-01-06','09:20:00',5.01),('7643','2013-01-06','09:25:00',5.68),('7643','2013-01-06','09:30:00',5.89),('7643','2013-01-06','09:35:00',6.24),('7643','2013-01-06','09:40:00',6.49),('7643','2013-01-06','09:45:00',6.82),('7643','2013-01-06','09:50:00',7.1),('7643','2013-01-06','09:55:00',7.28),('7643','2013-01-06','10:00:00',7.45),('7643','2013-01-06','10:05:00',7.89),('7643','2013-01-06','10:10:00',8.18),('7643','2013-01-06','10:15:00',8.36),('7643','2013-01-06','10:20:00',8.4),('7643','2013-01-06','10:25:00',8.46),('7643','2013-01-06','10:30:00',8.77),('7643','2013-01-06','10:35:00',8.89),('7643','2013-01-06','10:40:00',9.04),('7643','2013-01-06','10:45:00',9.05),('7643','2013-01-06','10:50:00',9.09),('7643','2013-01-06','10:55:00',9.1),('7643','2013-01-06','11:00:00',9.06),('7643','2013-01-06','11:05:00',9.17),('7643','2013-01-06','11:10:00',9.38),('7643','2013-01-06','11:15:00',9.63),('7643','2013-01-06','11:20:00',9.69),('7643','2013-01-06','11:25:00',9.86),('7643','2013-01-06','11:30:00',9.94),('7643','2013-01-06','11:35:00',9.92),('7643','2013-01-06','11:40:00',9.94),('7643','2013-01-06','11:45:00',10.03),('7643','2013-01-06','11:50:00',10.05),('7643','2013-01-06','11:55:00',10),('7643','2013-01-06','12:00:00',10.08),('7643','2013-01-06','12:05:00',10.22),('7643','2013-01-06','12:10:00',10.2),('7643','2013-01-06','12:15:00',10.13),('7643','2013-01-06','12:20:00',10.13),('7643','2013-01-06','12:25:00',10.14),('7643','2013-01-06','12:30:00',10.11),('7643','2013-01-06','12:35:00',10.02),('7643','2013-01-06','12:40:00',9.91),('7643','2013-01-06','12:45:00',9.84),('7643','2013-01-06','12:50:00',9.85),('7643','2013-01-06','12:55:00',9.73),('7643','2013-01-06','13:00:00',9.63),('7643','2013-01-06','13:05:00',9.53),('7643','2013-01-06','13:10:00',9.38),('7643','2013-01-06','13:15:00',9.19),('7643','2013-01-06','13:20:00',9.06),('7643','2013-01-06','13:25:00',9.01),('7643','2013-01-06','13:30:00',8.95),('7643','2013-01-06','13:35:00',8.8),('7643','2013-01-06','13:40:00',8.61),('7643','2013-01-06','13:45:00',8.46),('7643','2013-01-06','13:50:00',8.26),('7643','2013-01-06','13:55:00',8.12),('7643','2013-01-06','14:00:00',7.99),('7643','2013-01-06','14:05:00',7.79),('7643','2013-01-06','14:10:00',7.63),('7643','2013-01-06','14:15:00',7.41),('7643','2013-01-06','14:20:00',7.33),('7643','2013-01-06','14:25:00',7.07),('7643','2013-01-06','14:30:00',6.74),('7643','2013-01-06','14:35:00',6.59),('7643','2013-01-06','14:40:00',6.38),('7643','2013-01-06','14:45:00',6.01),('7643','2013-01-06','14:50:00',5.84),('7643','2013-01-06','14:55:00',5.55),('7643','2013-01-06','15:00:00',5.17),('7643','2013-01-06','15:05:00',5.02),('7643','2013-01-06','15:10:00',4.62),('7643','2013-01-06','15:15:00',4.45),('7643','2013-01-06','15:20:00',4.41),('7643','2013-01-06','15:25:00',4.22),('7643','2013-01-06','15:30:00',3.98),('7643','2013-01-06','15:35:00',3.71),('7643','2013-01-06','15:40:00',3.39),('7643','2013-01-06','15:45:00',3.07),('7643','2013-01-06','15:50:00',2.76),('7643','2013-01-06','15:55:00',2.44),('7643','2013-01-06','16:00:00',2.14),('7643','2013-01-06','16:05:00',1.84),('7643','2013-01-06','16:10:00',1.55),('7643','2013-01-06','16:15:00',1.28),('7643','2013-01-06','16:20:00',1.01),('7643','2013-01-05','08:05:00',1.24),('7643','2013-01-05','08:10:00',1.52),('7643','2013-01-05','08:15:00',1.79),('7643','2013-01-05','08:20:00',2.07),('7643','2013-01-05','08:25:00',2.37),('7643','2013-01-05','08:30:00',2.69),('7643','2013-01-05','08:35:00',3),('7643','2013-01-05','08:40:00',3.31),('7643','2013-01-05','08:45:00',3.64),('7643','2013-01-05','08:50:00',3.96),('7643','2013-01-05','08:55:00',4.28),('7643','2013-01-05','09:00:00',4.6),('7643','2013-01-05','09:05:00',4.9),('7643','2013-01-05','09:10:00',5.17),('7643','2013-01-05','09:15:00',5.46),('7643','2013-01-05','09:20:00',5.73),('7643','2013-01-05','09:25:00',5.98),('7643','2013-01-05','09:30:00',6.25),('7643','2013-01-05','09:35:00',6.48),('7643','2013-01-05','09:40:00',6.75),('7643','2013-01-05','09:45:00',6.95),('7643','2013-01-05','09:50:00',7.23),('7643','2013-01-05','09:55:00',7.47),('7643','2013-01-05','10:00:00',7.77),('7643','2013-01-05','10:05:00',7.98),('7643','2013-01-05','10:10:00',8.19),('7643','2013-01-05','10:15:00',8.37),('7643','2013-01-05','10:20:00',8.47),('7643','2013-01-05','10:25:00',8.71),('7643','2013-01-05','10:30:00',8.82),('7643','2013-01-05','10:35:00',8.98),('7643','2013-01-05','10:40:00',9.19),('7643','2013-01-05','10:45:00',9.33),('7643','2013-01-05','10:50:00',9.39),('7643','2013-01-05','10:55:00',9.57),('7643','2013-01-05','11:00:00',9.64),('7643','2013-01-05','11:05:00',9.69),('7643','2013-01-05','11:10:00',9.78),('7643','2013-01-05','11:15:00',9.84),('7643','2013-01-05','11:20:00',9.93),('7643','2013-01-05','11:25:00',9.98),('7643','2013-01-05','11:30:00',10.04),('7643','2013-01-05','11:35:00',10.09),('7643','2013-01-05','11:40:00',10.09),('7643','2013-01-05','11:45:00',10.1),('7643','2013-01-05','11:50:00',10.16),('7643','2013-01-05','11:55:00',10.22),('7643','2013-01-05','12:00:00',10.24),('7643','2013-01-05','12:05:00',10.25),('7643','2013-01-05','12:10:00',10.22),('7643','2013-01-05','12:15:00',10.1),('7643','2013-01-05','12:20:00',10.01),('7643','2013-01-05','12:25:00',9.91),('7643','2013-01-05','12:30:00',9.87),('7643','2013-01-05','12:35:00',9.75),('7643','2013-01-05','12:40:00',9.58),('7643','2013-01-05','12:45:00',9.74),('7643','2013-01-05','12:50:00',9.82),('7643','2013-01-05','12:55:00',9.85),('7643','2013-01-05','13:00:00',9.75),('7643','2013-01-05','13:05:00',9.69),('7643','2013-01-05','13:10:00',9.61),('7643','2013-01-05','13:15:00',9.52),('7643','2013-01-05','13:20:00',9.39),('7643','2013-01-05','13:25:00',9.28),('7643','2013-01-05','13:30:00',9.25),('7643','2013-01-05','13:35:00',9.11),('7643','2013-01-05','13:40:00',8.96),('7643','2013-01-05','13:45:00',8.83),('7643','2013-01-05','13:50:00',8.57),('7643','2013-01-05','13:55:00',8.33),('7643','2013-01-05','14:00:00',8.29),('7643','2013-01-05','14:05:00',8.29),('7643','2013-01-05','14:10:00',7.5),('7643','2013-01-05','14:15:00',6.43),('7643','2013-01-05','14:20:00',6.71),('7643','2013-01-05','14:25:00',6.63),('7643','2013-01-05','14:30:00',6.8),('7643','2013-01-05','14:35:00',6.52),('7643','2013-01-05','14:40:00',6.23),('7643','2013-01-05','14:45:00',5.96),('7643','2013-01-05','14:50:00',5.7),('7643','2013-01-05','14:55:00',5.4),('7643','2013-01-05','15:00:00',5.1),('7643','2013-01-05','15:05:00',4.76),('7643','2013-01-05','15:10:00',4.43),('7643','2013-01-05','15:15:00',4.31),('7643','2013-01-05','15:20:00',4.04),('7643','2013-01-05','15:25:00',3.76),('7643','2013-01-05','15:30:00',3.48),('7643','2013-01-05','15:35:00',3.18),('7643','2013-01-05','15:40:00',2.87),('7643','2013-01-05','15:45:00',2.63),('7643','2013-01-05','15:50:00',2.38),('7643','2013-01-05','15:55:00',2.12),('7643','2013-01-05','16:00:00',1.9),('7643','2013-01-05','16:05:00',1.61),('7643','2013-01-05','16:10:00',1.36),('7643','2013-01-05','16:15:00',1.09),('7643','2013-01-04','08:35:00',1.52),('7643','2013-01-04','08:40:00',1.78),('7643','2013-01-04','08:45:00',2.22),('7643','2013-01-04','08:50:00',1.99),('7643','2013-01-04','08:55:00',1.93),('7643','2013-01-04','09:00:00',2.02),('7643','2013-01-04','09:05:00',2.29),('7643','2013-01-04','09:10:00',2.4),('7643','2013-01-04','09:15:00',2.33),('7643','2013-01-04','09:20:00',2.22),('7643','2013-01-04','09:25:00',2.42),('7643','2013-01-04','09:30:00',2.41),('7643','2013-01-04','09:35:00',2.67),('7643','2013-01-04','09:40:00',2.75),('7643','2013-01-04','09:45:00',2.7),('7643','2013-01-04','09:50:00',2.64),('7643','2013-01-04','09:55:00',2.78),('7643','2013-01-04','10:00:00',3.1),('7643','2013-01-04','10:05:00',3.7),('7643','2013-01-04','10:10:00',4.26),('7643','2013-01-04','10:15:00',4.54),('7643','2013-01-04','10:20:00',4.17),('7643','2013-01-04','10:25:00',3.52),('7643','2013-01-04','10:30:00',3.64),('7643','2013-01-04','10:35:00',4.16),('7643','2013-01-04','10:40:00',4.49),('7643','2013-01-04','10:45:00',4.37),('7643','2013-01-04','10:50:00',5.09),('7643','2013-01-04','10:55:00',8.43),('7643','2013-01-04','11:00:00',7.27),('7643','2013-01-04','11:05:00',8.12),('7643','2013-01-04','11:10:00',8.28),('7643','2013-01-04','11:15:00',6.74),('7643','2013-01-04','11:20:00',8.96),('7643','2013-01-04','11:25:00',9.47),('7643','2013-01-04','11:30:00',9.6),('7643','2013-01-04','11:35:00',8.95),('7643','2013-01-04','11:40:00',8.08),('7643','2013-01-04','11:45:00',8.21),('7643','2013-01-04','11:50:00',7.11),('7643','2013-01-04','11:55:00',6.44),('7643','2013-01-04','12:00:00',5.93),('7643','2013-01-04','12:05:00',5.82),('7643','2013-01-04','12:10:00',5.68),('7643','2013-01-04','12:15:00',5.86),('7643','2013-01-04','12:20:00',5.25),('7643','2013-01-04','12:25:00',4.45),('7643','2013-01-04','12:30:00',4.58),('7643','2013-01-04','12:35:00',6.29),('7643','2013-01-04','12:40:00',7.65),('7643','2013-01-04','12:45:00',8.89),('7643','2013-01-04','12:50:00',5.56),('7643','2013-01-04','12:55:00',4.6),('7643','2013-01-04','13:00:00',4.9),('7643','2013-01-04','13:05:00',4.48),('7643','2013-01-04','13:10:00',4.34),('7643','2013-01-04','13:15:00',4),('7643','2013-01-04','13:20:00',4.01),('7643','2013-01-04','13:25:00',3.94),('7643','2013-01-04','13:30:00',6.98),('7643','2013-01-04','13:35:00',6.32),('7643','2013-01-04','13:40:00',4.4),('7643','2013-01-04','13:45:00',3.57),('7643','2013-01-04','13:50:00',3.91),('7643','2013-01-04','13:55:00',4.41),('7643','2013-01-04','14:00:00',4.16),('7643','2013-01-04','14:05:00',6.17),('7643','2013-01-04','14:10:00',5.81),('7643','2013-01-04','14:15:00',4.43),('7643','2013-01-04','14:20:00',4.07),('7643','2013-01-04','14:25:00',2.76),('7643','2013-01-04','14:30:00',4.48),('7643','2013-01-04','14:35:00',4.43),('7643','2013-01-04','14:40:00',4.86),('7643','2013-01-04','14:45:00',5.01),('7643','2013-01-04','14:50:00',3.47),('7643','2013-01-04','14:55:00',2.41),('7643','2013-01-04','15:00:00',4.15),('7643','2013-01-04','15:05:00',3.54),('7643','2013-01-04','15:10:00',1.52),('7643','2013-01-04','15:15:00',1.27),('7643','2013-01-04','15:40:00',1.77),('7643','2013-01-04','15:45:00',1.56),('7643','2013-01-04','15:50:00',1.26),('7643','2013-01-04','15:55:00',1.14),('7643','2013-01-03','08:10:00',1.35),('7643','2013-01-03','08:15:00',1.62),('7643','2013-01-03','08:20:00',1.82),('7643','2013-01-03','08:25:00',1.6),('7643','2013-01-03','08:30:00',1.26),('7643','2013-01-03','08:35:00',2.15),('7643','2013-01-03','08:40:00',2.61),('7643','2013-01-03','08:45:00',3.73),('7643','2013-01-03','08:50:00',4.06),('7643','2013-01-03','08:55:00',4.01),('7643','2013-01-03','09:00:00',4.17),('7643','2013-01-03','09:05:00',4.51),('7643','2013-01-03','09:10:00',4.9),('7643','2013-01-03','09:15:00',3.86),('7643','2013-01-03','09:20:00',5.02),('7643','2013-01-03','09:25:00',4.7),('7643','2013-01-03','09:30:00',4.64),('7643','2013-01-03','09:35:00',4.38),('7643','2013-01-03','09:40:00',4.56),('7643','2013-01-03','09:45:00',4.78),('7643','2013-01-03','09:50:00',5.12),('7643','2013-01-03','09:55:00',6.56),('7643','2013-01-03','10:00:00',8.1),('7643','2013-01-03','10:05:00',8.33),('7643','2013-01-03','10:10:00',7.1),('7643','2013-01-03','10:15:00',8.38),('7643','2013-01-03','10:20:00',7.21),('7643','2013-01-03','10:25:00',8.34),('7643','2013-01-03','10:30:00',8.96),('7643','2013-01-03','10:35:00',9.11),('7643','2013-01-03','10:40:00',9.34),('7643','2013-01-03','10:45:00',9.86),('7643','2013-01-03','10:50:00',10.41),('7643','2013-01-03','10:55:00',10.78),('7643','2013-01-03','11:00:00',9.42),('7643','2013-01-03','11:05:00',5.85),('7643','2013-01-03','11:10:00',3.54),('7643','2013-01-03','11:15:00',3.71),('7643','2013-01-03','11:20:00',4.57),('7643','2013-01-03','11:25:00',3.56),('7643','2013-01-03','11:30:00',3.51),('7643','2013-01-03','11:35:00',5.34),('7643','2013-01-03','11:40:00',4.2),('7643','2013-01-03','11:45:00',6.24),('7643','2013-01-03','11:50:00',9.82),('7643','2013-01-03','11:55:00',11.5),('7643','2013-01-03','12:00:00',11.79),('7643','2013-01-03','12:05:00',10.16),('7643','2013-01-03','12:10:00',8.07),('7643','2013-01-03','12:15:00',5.37),('7643','2013-01-03','12:20:00',4.37),('7643','2013-01-03','12:25:00',5),('7643','2013-01-03','12:30:00',7.23),('7643','2013-01-03','12:35:00',6.78),('7643','2013-01-03','12:40:00',9.79),('7643','2013-01-03','12:45:00',10.29),('7643','2013-01-03','12:50:00',10.38),('7643','2013-01-03','12:55:00',10.29),('7643','2013-01-03','13:00:00',9.84),('7643','2013-01-03','13:05:00',9.47),('7643','2013-01-03','13:10:00',9.3),('7643','2013-01-03','13:15:00',8.06),('7643','2013-01-03','13:20:00',8.99),('7643','2013-01-03','13:25:00',8.67),('7643','2013-01-03','13:30:00',8.41),('7643','2013-01-03','13:35:00',8.4),('7643','2013-01-03','13:40:00',8.1),('7643','2013-01-03','13:45:00',8.05),('7643','2013-01-03','13:50:00',7.9),('7643','2013-01-03','13:55:00',7.75),('7643','2013-01-03','14:00:00',7.57),('7643','2013-01-03','14:05:00',7.42),('7643','2013-01-03','14:10:00',7.17),('7643','2013-01-03','14:15:00',6.97),('7643','2013-01-03','14:20:00',6.76),('7643','2013-01-03','14:25:00',6.59),('7643','2013-01-03','14:30:00',6.43),('7643','2013-01-03','14:35:00',6.25),('7643','2013-01-03','14:40:00',5.97),('7643','2013-01-03','14:45:00',5.61),('7643','2013-01-03','14:50:00',5.19),('7643','2013-01-03','14:55:00',5.04),('7643','2013-01-03','15:00:00',4.86),('7643','2013-01-03','15:05:00',4.43),('7643','2013-01-03','15:10:00',3.88),('7643','2013-01-03','15:15:00',3.93),('7643','2013-01-03','15:20:00',3.69),('7643','2013-01-03','15:25:00',3.49),('7643','2013-01-03','15:30:00',3.21),('7643','2013-01-03','15:35:00',2.98),('7643','2013-01-03','15:40:00',2.8),('7643','2013-01-03','15:45:00',2.57),('7643','2013-01-03','15:50:00',1.39),('7643','2013-01-03','16:00:00',1.21),('7643','2013-01-03','16:10:00',1.1),('7643','2013-01-02','08:05:00',1.03),('7643','2013-01-02','08:10:00',1.31),('7643','2013-01-02','08:15:00',1.62),('7643','2013-01-02','08:20:00',1.93),('7643','2013-01-02','08:25:00',2.1),('7643','2013-01-02','08:30:00',2.5),('7643','2013-01-02','08:35:00',2.75),('7643','2013-01-02','08:40:00',3.22),('7643','2013-01-02','08:45:00',3.52),('7643','2013-01-02','08:50:00',3.77),('7643','2013-01-02','08:55:00',4.08),('7643','2013-01-02','09:00:00',4.48),('7643','2013-01-02','09:05:00',4.83),('7643','2013-01-02','09:10:00',5.16),('7643','2013-01-02','09:15:00',5.49),('7643','2013-01-02','09:20:00',5.78),('7643','2013-01-02','09:25:00',6.06),('7643','2013-01-02','09:30:00',6.32),('7643','2013-01-02','09:35:00',6.59),('7643','2013-01-02','09:40:00',7.08),('7643','2013-01-02','09:45:00',7.64),('7643','2013-01-02','09:50:00',8.29),('7643','2013-01-02','09:55:00',8.87),('7643','2013-01-02','10:00:00',9.34),('7643','2013-01-02','10:05:00',9.13),('7643','2013-01-02','10:10:00',8.86),('7643','2013-01-02','10:15:00',9.36),('7643','2013-01-02','10:20:00',8.8),('7643','2013-01-02','10:25:00',9.69),('7643','2013-01-02','10:30:00',7.82),('7643','2013-01-02','10:35:00',7.53),('7643','2013-01-02','10:40:00',6.76),('7643','2013-01-02','10:45:00',6.33),('7643','2013-01-02','10:50:00',6.53),('7643','2013-01-02','10:55:00',5.92),('7643','2013-01-02','11:00:00',6.43),('7643','2013-01-02','11:05:00',6.22),('7643','2013-01-02','11:10:00',6.18),('7643','2013-01-02','11:15:00',5.64),('7643','2013-01-02','11:20:00',5.04),('7643','2013-01-02','11:25:00',4.73),('7643','2013-01-02','11:30:00',4.66),('7643','2013-01-02','11:35:00',5.6),('7643','2013-01-02','11:40:00',10.5),('7643','2013-01-02','11:45:00',10.78),('7643','2013-01-02','11:50:00',10.6),('7643','2013-01-02','11:55:00',10.45),('7643','2013-01-02','12:00:00',10.34),('7643','2013-01-02','12:05:00',10.28),('7643','2013-01-02','12:10:00',10.26),('7643','2013-01-02','12:15:00',10.23),('7643','2013-01-02','12:20:00',10.27),('7643','2013-01-02','12:25:00',10.24),('7643','2013-01-02','12:30:00',10.18),('7643','2013-01-02','12:35:00',10.15),('7643','2013-01-02','12:40:00',10.05),('7643','2013-01-02','12:45:00',9.97),('7643','2013-01-02','12:50:00',9.92),('7643','2013-01-02','12:55:00',9.82),('7643','2013-01-02','13:00:00',9.75),('7643','2013-01-02','13:05:00',9.65),('7643','2013-01-02','13:10:00',9.56),('7643','2013-01-02','13:15:00',9.39),('7643','2013-01-02','13:20:00',9.3),('7643','2013-01-02','13:25:00',9.19),('7643','2013-01-02','13:30:00',8.99),('7643','2013-01-02','13:35:00',8.89),('7643','2013-01-02','13:40:00',8.75),('7643','2013-01-02','13:45:00',8.57),('7643','2013-01-02','13:50:00',8.4),('7643','2013-01-02','13:55:00',8.24),('7643','2013-01-02','14:00:00',8.06),('7643','2013-01-02','14:05:00',7.87),('7643','2013-01-02','14:10:00',7.7),('7643','2013-01-02','14:15:00',7.53),('7643','2013-01-02','14:20:00',7.29),('7643','2013-01-02','14:25:00',7.06),('7643','2013-01-02','14:30:00',6.87),('7643','2013-01-02','14:35:00',6.63),('7643','2013-01-02','14:40:00',6.38),('7643','2013-01-02','14:45:00',6.14),('7643','2013-01-02','14:50:00',5.9),('7643','2013-01-02','14:55:00',5.63),('7643','2013-01-02','15:00:00',5.37),('7643','2013-01-02','15:05:00',5.01),('7643','2013-01-02','15:10:00',4.68),('7643','2013-01-02','15:15:00',4.37),('7643','2013-01-02','15:20:00',3.86),('7643','2013-01-02','15:25:00',3.75),('7643','2013-01-02','15:30:00',3.6),('7643','2013-01-02','15:35:00',3.31),('7643','2013-01-02','15:40:00',2.91),('7643','2013-01-02','15:45:00',2.78),('7643','2013-01-02','15:50:00',2.49),('7643','2013-01-02','15:55:00',2.2),('7643','2013-01-02','16:00:00',1.85),('7643','2013-01-02','16:05:00',1.59),('7643','2013-01-02','16:10:00',1.3),('7643','2013-01-01','09:30:00',1.26),('7643','2013-01-01','09:35:00',1.84),('7643','2013-01-01','09:40:00',2.17),('7643','2013-01-01','09:45:00',2.41),('7643','2013-01-01','09:50:00',2.16),('7643','2013-01-01','09:55:00',2.1),('7643','2013-01-01','10:00:00',2.35),('7643','2013-01-01','10:05:00',2.23),('7643','2013-01-01','10:10:00',1.88),('7643','2013-01-01','10:15:00',1.69),('7643','2013-01-01','10:20:00',1.51),('7643','2013-01-01','10:25:00',1.25),('7643','2013-01-01','10:40:00',1.04),('7643','2013-01-01','10:45:00',1.16),('7643','2013-01-01','10:50:00',1.37),('7643','2013-01-01','10:55:00',1.15),('7643','2013-01-01','11:00:00',1.12),('7643','2013-01-01','11:05:00',1.53),('7643','2013-01-01','11:10:00',2.01),('7643','2013-01-01','11:15:00',1.15),('7643','2013-01-01','12:30:00',1.36),('7643','2013-01-01','13:20:00',1),('7643','2013-01-01','13:25:00',1.05),('7643','2013-01-01','13:30:00',1.34),('7643','2013-01-01','13:35:00',1.04),('7643','2013-01-01','13:40:00',2.92),('7643','2013-01-01','13:45:00',3.23),('7643','2013-01-01','13:50:00',3.28),('7643','2013-01-01','13:55:00',2.68),('7643','2013-01-01','14:00:00',2.38),('7643','2013-01-01','14:05:00',1.56),('7643','2014-03-17','07:10:00',1.15),('7643','2014-03-17','07:15:00',1.55),('7643','2014-03-17','07:20:00',1.41),('7643','2014-03-17','07:25:00',1.56),('7643','2014-03-17','07:30:00',1.66),('7643','2014-03-17','07:35:00',1.83),('7643','2014-03-17','07:40:00',2.14),('7643','2014-03-17','07:45:00',2.61),('7643','2014-03-17','07:50:00',5.33),('7643','2014-03-17','07:55:00',5.82),('7643','2014-03-17','08:00:00',4),('7643','2014-03-17','08:05:00',3.14),('7643','2014-03-17','08:10:00',3.33),('7643','2014-03-17','08:15:00',3.78),('7643','2014-03-17','08:20:00',4.92),('7643','2014-03-17','08:25:00',3.73),('7643','2014-03-17','08:30:00',3.57),('7643','2014-03-17','08:35:00',3),('7643','2014-03-17','08:40:00',3.23),('7643','2014-03-17','08:45:00',3.32),('7643','2014-03-17','08:50:00',6.95),('7643','2014-03-17','08:55:00',9.78),('7643','2014-03-17','09:00:00',9.5),('7643','2014-03-17','09:05:00',5.22),('7643','2014-03-17','09:10:00',5.52),('7643','2014-03-17','09:15:00',10.16),('7643','2014-03-17','09:20:00',12.13),('7643','2014-03-17','09:25:00',9.82),('7643','2014-03-17','09:30:00',4.94),('7643','2014-03-17','09:35:00',5.04),('7643','2014-03-17','09:40:00',5.32),('7643','2014-03-17','09:45:00',6.06),('7643','2014-03-17','09:50:00',7.15),('7643','2014-03-17','09:55:00',9.08),('7643','2014-03-17','10:00:00',6.29),('7643','2014-03-17','10:05:00',11.6),('7643','2014-03-17','10:10:00',12.34),('7643','2014-03-17','10:15:00',10.46),('7643','2014-03-17','10:20:00',15.33),('7643','2014-03-17','10:25:00',16.82),('7643','2014-03-17','10:30:00',10.91),('7643','2014-03-17','10:35:00',16.4),('7643','2014-03-17','10:40:00',13.08),('7643','2014-03-17','10:45:00',12.99),('7643','2014-03-17','10:50:00',17.17),('7643','2014-03-17','10:55:00',10.92),('7643','2014-03-17','11:00:00',11.19),('7643','2014-03-17','11:05:00',11.21),('7643','2014-03-17','11:10:00',8.56),('7643','2014-03-17','11:15:00',6.04),('7643','2014-03-17','11:20:00',8.22),('7643','2014-03-17','11:25:00',15.7),('7643','2014-03-17','11:30:00',12.97),('7643','2014-03-17','11:35:00',9.64),('7643','2014-03-17','11:40:00',10.57),('7643','2014-03-17','11:45:00',6.96),('7643','2014-03-17','11:50:00',8.45),('7643','2014-03-17','11:55:00',7.9),('7643','2014-03-17','12:00:00',6.71),('7643','2014-03-17','12:05:00',6.79),('7643','2014-03-17','12:10:00',7.37),('7643','2014-03-17','12:15:00',10.72),('7643','2014-03-17','12:20:00',11.37),('7643','2014-03-17','12:25:00',10.85),('7643','2014-03-17','12:30:00',7.32),('7643','2014-03-17','12:35:00',15.77),('7643','2014-03-17','12:40:00',9.4),('7643','2014-03-17','12:45:00',8.63),('7643','2014-03-17','12:50:00',6.18),('7643','2014-03-17','12:55:00',8.53),('7643','2014-03-17','13:00:00',16.06),('7643','2014-03-17','13:05:00',16.28),('7643','2014-03-17','13:10:00',15.54),('7643','2014-03-17','13:15:00',15.48),('7643','2014-03-17','13:20:00',15.15),('7643','2014-03-17','13:25:00',14.29),('7643','2014-03-17','13:30:00',12.22),('7643','2014-03-17','13:35:00',14.44),('7643','2014-03-17','13:40:00',14.31),('7643','2014-03-17','13:45:00',14.28),('7643','2014-03-17','13:50:00',13.83),('7643','2014-03-17','13:55:00',13.88),('7643','2014-03-17','14:00:00',13.68),('7643','2014-03-17','14:05:00',13.31),('7643','2014-03-17','14:10:00',13.48),('7643','2014-03-17','14:15:00',13.21),('7643','2014-03-17','14:20:00',13.13),('7643','2014-03-17','14:25:00',12.94),('7643','2014-03-17','14:30:00',12.74),('7643','2014-03-17','14:35:00',12.44),('7643','2014-03-17','14:40:00',12.24),('7643','2014-03-17','14:45:00',11.94),('7643','2014-03-17','14:50:00',11.8),('7643','2014-03-17','14:55:00',11.62),('7643','2014-03-17','15:00:00',11.27),('7643','2014-03-17','15:05:00',10.97),('7643','2014-03-17','15:10:00',10.65),('7643','2014-03-17','15:15:00',10.4),('7643','2014-03-17','15:20:00',10.18),('7643','2014-03-17','15:25:00',9.88),('7643','2014-03-17','15:30:00',9.53),('7643','2014-03-17','15:35:00',9.15),('7643','2014-03-17','15:40:00',8.85),('7643','2014-03-17','15:45:00',8.43),('7643','2014-03-17','15:50:00',8.15),('7643','2014-03-17','15:55:00',7.82),('7643','2014-03-17','16:00:00',7.59),('7643','2014-03-17','16:05:00',7.34),('7643','2014-03-17','16:10:00',6.88),('7643','2014-03-17','16:15:00',6.5),('7643','2014-03-17','16:20:00',6.07),('7643','2014-03-17','16:25:00',5.73),('7643','2014-03-17','16:30:00',5.48),('7643','2014-03-17','16:35:00',5.07),('7643','2014-03-17','16:40:00',4.6),('7643','2014-03-17','16:45:00',4.22),('7643','2014-03-17','16:50:00',3.79),('7643','2014-03-17','16:55:00',3.42),('7643','2014-03-17','17:00:00',3.12),('7643','2014-03-17','17:05:00',2.75),('7643','2014-03-17','17:10:00',2.41),('7643','2014-03-17','17:15:00',2.06),('7643','2014-03-17','17:20:00',1.74),('7643','2014-03-17','17:25:00',1.45),('7643','2014-03-17','17:30:00',1.19),('7643','2012-12-31','08:05:00',1.1),('7643','2012-12-31','08:10:00',1.32),('7643','2012-12-31','08:15:00',1.53),('7643','2012-12-31','08:20:00',1.76),('7643','2012-12-31','08:25:00',2.03),('7643','2012-12-31','08:30:00',2.32),('7643','2012-12-31','08:35:00',2.62),('7643','2012-12-31','08:40:00',2.94),('7643','2012-12-31','08:45:00',3.28),('7643','2012-12-31','08:50:00',3.69),('7643','2012-12-31','08:55:00',3.95),('7643','2012-12-31','09:00:00',4.26),('7643','2012-12-31','09:05:00',4.6),('7643','2012-12-31','09:10:00',4.87),('7643','2012-12-31','09:15:00',5.15),('7643','2012-12-31','09:20:00',5.44),('7643','2012-12-31','09:25:00',5.72),('7643','2012-12-31','09:30:00',5.98),('7643','2012-12-31','09:35:00',6.21),('7643','2012-12-31','09:40:00',6.44),('7643','2012-12-31','09:45:00',6.69),('7643','2012-12-31','09:50:00',6.92),('7643','2012-12-31','09:55:00',7.08),('7643','2012-12-31','10:00:00',7.23),('7643','2012-12-31','10:05:00',7.52),('7643','2012-12-31','10:10:00',7.75),('7643','2012-12-31','10:15:00',7.9),('7643','2012-12-31','10:20:00',8.04),('7643','2012-12-31','10:25:00',8.28),('7643','2012-12-31','10:30:00',8.49),('7643','2012-12-31','10:35:00',8.54),('7643','2012-12-31','10:40:00',8.84),('7643','2012-12-31','10:45:00',9.36),('7643','2012-12-31','10:50:00',9.92),('7643','2012-12-31','10:55:00',5.47),('7643','2012-12-31','11:00:00',3.36),('7643','2012-12-31','11:05:00',9.21),('7643','2012-12-31','11:10:00',10.18),('7643','2012-12-31','11:15:00',8.36),('7643','2012-12-31','11:20:00',6.79),('7643','2012-12-31','11:25:00',9.3),('7643','2012-12-31','11:30:00',11.19),('7643','2012-12-31','11:35:00',5.54),('7643','2012-12-31','11:40:00',6.3),('7643','2012-12-31','11:45:00',8.43),('7643','2012-12-31','11:50:00',9.17),('7643','2012-12-31','11:55:00',6.71),('7643','2012-12-31','12:00:00',5.69),('7643','2012-12-31','12:05:00',4.5),('7643','2012-12-31','12:10:00',4.95),('7643','2012-12-31','12:15:00',5.04),('7643','2012-12-31','12:20:00',4.65),('7643','2012-12-31','12:25:00',4.49),('7643','2012-12-31','12:30:00',4.03),('7643','2012-12-31','12:35:00',4),('7643','2012-12-31','12:40:00',4.49),('7643','2012-12-31','12:45:00',5.02),('7643','2012-12-31','12:50:00',5.18),('7643','2012-12-31','12:55:00',4.63),('7643','2012-12-31','13:00:00',3.68),('7643','2012-12-31','13:05:00',4.13),('7643','2012-12-31','13:10:00',3.24),('7643','2012-12-31','13:15:00',2.8),('7643','2012-12-31','13:20:00',3.13),('7643','2012-12-31','13:25:00',2.73),('7643','2012-12-31','13:30:00',2.34),('7643','2012-12-31','13:35:00',1.78),('7643','2012-12-31','13:40:00',1.39),('7643','2012-12-31','13:45:00',1.31),('7643','2012-12-31','13:50:00',1.04),('7643','2012-12-30','08:00:00',1.25),('7643','2012-12-30','08:05:00',1.42),('7643','2012-12-30','08:10:00',1.73),('7643','2012-12-30','08:15:00',1.97),('7643','2012-12-30','08:20:00',2.21),('7643','2012-12-30','08:25:00',2.59),('7643','2012-12-30','08:30:00',2.95),('7643','2012-12-30','08:35:00',3.02),('7643','2012-12-30','08:40:00',1.82),('7643','2012-12-30','08:45:00',1.95),('7643','2012-12-30','08:50:00',2.22),('7643','2012-12-30','08:55:00',2.6),('7643','2012-12-30','09:00:00',3.25),('7643','2012-12-30','09:05:00',3.64),('7643','2012-12-30','09:10:00',3.67),('7643','2012-12-30','09:15:00',4.98),('7643','2012-12-30','09:20:00',5.47),('7643','2012-12-30','09:25:00',6.38),('7643','2012-12-30','09:30:00',6.69),('7643','2012-12-30','09:35:00',2.53),('7643','2012-12-30','09:40:00',2.52),('7643','2012-12-30','09:45:00',1.53),('7643','2012-12-30','09:50:00',1.78),('7643','2012-12-30','09:55:00',2.39),('7643','2012-12-30','10:00:00',5.33),('7643','2012-12-30','10:05:00',3.15),('7643','2012-12-30','10:10:00',5.49),('7643','2012-12-30','10:15:00',8.01),('7643','2012-12-30','10:20:00',9.07),('7643','2012-12-30','10:25:00',9.09),('7643','2012-12-30','10:30:00',9.17),('7643','2012-12-30','10:35:00',9.29),('7643','2012-12-30','10:40:00',9.4),('7643','2012-12-30','10:45:00',9.3),('7643','2012-12-30','10:50:00',9.15),('7643','2012-12-30','10:55:00',9.52),('7643','2012-12-30','11:00:00',9.65),('7643','2012-12-30','11:05:00',9.62),('7643','2012-12-30','11:10:00',9.34),('7643','2012-12-30','11:15:00',9.54),('7643','2012-12-30','11:20:00',9.95),('7643','2012-12-30','11:25:00',10.05),('7643','2012-12-30','11:30:00',10.17),('7643','2012-12-30','11:35:00',10.16),('7643','2012-12-30','11:40:00',10.36),('7643','2012-12-30','11:45:00',10.36),('7643','2012-12-30','11:50:00',10.31),('7643','2012-12-30','11:55:00',10.35),('7643','2012-12-30','12:00:00',10.47),('7643','2012-12-30','12:05:00',10.47),('7643','2012-12-30','12:10:00',10.45),('7643','2012-12-30','12:15:00',10.57),('7643','2012-12-30','12:20:00',10.56),('7643','2012-12-30','12:25:00',10.51),('7643','2012-12-30','12:30:00',10.4),('7643','2012-12-30','12:35:00',10.33),('7643','2012-12-30','12:40:00',10.29),('7643','2012-12-30','12:45:00',10.21),('7643','2012-12-30','12:50:00',10.12),('7643','2012-12-30','12:55:00',10.04),('7643','2012-12-30','13:00:00',9.93),('7643','2012-12-30','13:05:00',9.83),('7643','2012-12-30','13:10:00',9.75),('7643','2012-12-30','13:15:00',9.57),('7643','2012-12-30','13:20:00',9.47),('7643','2012-12-30','13:25:00',9.38),('7643','2012-12-30','13:30:00',9.26),('7643','2012-12-30','13:35:00',9.03),('7643','2012-12-30','13:40:00',8.81),('7643','2012-12-30','13:45:00',8.69),('7643','2012-12-30','13:50:00',8.49),('7643','2012-12-30','13:55:00',8.31),('7643','2012-12-30','14:00:00',8.04),('7643','2012-12-30','14:05:00',7.8),('7643','2012-12-30','14:10:00',7.65),('7643','2012-12-30','14:15:00',7.47),('7643','2012-12-30','14:20:00',7.24),('7643','2012-12-30','14:25:00',6.98),('7643','2012-12-30','14:30:00',6.74),('7643','2012-12-30','14:35:00',6.56),('7643','2012-12-30','14:40:00',6.33),('7643','2012-12-30','14:45:00',6.03),('7643','2012-12-30','14:50:00',5.73),('7643','2012-12-30','14:55:00',5.47),('7643','2012-12-30','15:00:00',5.18),('7643','2012-12-30','15:05:00',4.89),('7643','2012-12-30','15:10:00',4.54),('7643','2012-12-30','15:15:00',4.21),('7643','2012-12-30','15:20:00',3.94),('7643','2012-12-30','15:25:00',3.69),('7643','2012-12-30','15:30:00',3.45),('7643','2012-12-30','15:35:00',3.15),('7643','2012-12-30','15:40:00',2.9),('7643','2012-12-30','15:45:00',2.6),('7643','2012-12-30','15:50:00',2.25),('7643','2012-12-30','15:55:00',1.92),('7643','2012-12-30','16:00:00',1.65),('7643','2012-12-30','16:05:00',1.38),('7643','2012-12-30','16:10:00',1.13),('7643','2012-12-29','08:00:00',1),('7643','2012-12-29','08:05:00',1.27),('7643','2012-12-29','08:10:00',1.54),('7643','2012-12-29','08:15:00',1.8),('7643','2012-12-29','08:20:00',2.08),('7643','2012-12-29','08:25:00',2.38),('7643','2012-12-29','08:30:00',2.72),('7643','2012-12-29','08:35:00',3.01),('7643','2012-12-29','08:40:00',3.33),('7643','2012-12-29','08:45:00',3.67),('7643','2012-12-29','08:50:00',3.96),('7643','2012-12-29','08:55:00',4.27),('7643','2012-12-29','09:00:00',4.57),('7643','2012-12-29','09:05:00',4.88),('7643','2012-12-29','09:10:00',5.15),('7643','2012-12-29','09:15:00',5.48),('7643','2012-12-29','09:20:00',5.73),('7643','2012-12-29','09:25:00',5.99),('7643','2012-12-29','09:30:00',6.26),('7643','2012-12-29','09:35:00',6.51),('7643','2012-12-29','09:40:00',6.74),('7643','2012-12-29','09:45:00',7),('7643','2012-12-29','09:50:00',7.18),('7643','2012-12-29','09:55:00',7.39),('7643','2012-12-29','10:00:00',7.67),('7643','2012-12-29','10:05:00',7.94),('7643','2012-12-29','10:10:00',8.19),('7643','2012-12-29','10:15:00',8.33),('7643','2012-12-29','10:20:00',8.53),('7643','2012-12-29','10:25:00',8.68),('7643','2012-12-29','10:30:00',8.84),('7643','2012-12-29','10:35:00',8.99),('7643','2012-12-29','10:40:00',9.13),('7643','2012-12-29','10:45:00',9.3),('7643','2012-12-29','10:50:00',9.39),('7643','2012-12-29','10:55:00',9.49),('7643','2012-12-29','11:00:00',9.62),('7643','2012-12-29','11:05:00',9.71),('7643','2012-12-29','11:10:00',9.78),('7643','2012-12-29','11:15:00',9.86),('7643','2012-12-29','11:20:00',9.91),('7643','2012-12-29','11:25:00',9.94),('7643','2012-12-29','11:30:00',10.01),('7643','2012-12-29','11:35:00',10.13),('7643','2012-12-29','11:40:00',10.13),('7643','2012-12-29','11:45:00',10.17),('7643','2012-12-29','11:50:00',10.14),('7643','2012-12-29','11:55:00',10.18),('7643','2012-12-29','12:00:00',10.14),('7643','2012-12-29','12:05:00',10.15),('7643','2012-12-29','12:10:00',10.18),('7643','2012-12-29','12:15:00',10.11),('7643','2012-12-29','12:20:00',10.16),('7643','2012-12-29','12:25:00',10.16),('7643','2012-12-29','12:30:00',10),('7643','2012-12-29','12:35:00',9.96),('7643','2012-12-29','12:40:00',9.84),('7643','2012-12-29','12:45:00',9.75),('7643','2012-12-29','12:50:00',9.64),('7643','2012-12-29','12:55:00',9.55),('7643','2012-12-29','13:00:00',9.63),('7643','2012-12-29','13:05:00',9.65),('7643','2012-12-29','13:10:00',9.55),('7643','2012-12-29','13:15:00',9.48),('7643','2012-12-29','13:20:00',9.35),('7643','2012-12-29','13:25:00',9.24),('7643','2012-12-29','13:30:00',9.12),('7643','2012-12-29','13:35:00',8.97),('7643','2012-12-29','13:40:00',8.86),('7643','2012-12-29','13:45:00',8.74),('7643','2012-12-29','13:50:00',8.54),('7643','2012-12-29','13:55:00',8.34),('7643','2012-12-29','14:00:00',8.18),('7643','2012-12-29','14:05:00',7.97),('7643','2012-12-29','14:10:00',7.72),('7643','2012-12-29','14:15:00',7.52),('7643','2012-12-29','14:20:00',7.31),('7643','2012-12-29','14:25:00',7.06),('7643','2012-12-29','14:30:00',6.77),('7643','2012-12-29','14:35:00',6.57),('7643','2012-12-29','14:40:00',6.27),('7643','2012-12-29','14:45:00',6.01),('7643','2012-12-29','14:50:00',5.75),('7643','2012-12-29','14:55:00',5.46),('7643','2012-12-29','15:00:00',5.16),('7643','2012-12-29','15:05:00',4.84),('7643','2012-12-29','15:10:00',4.58),('7643','2012-12-29','15:15:00',4.28),('7643','2012-12-29','15:20:00',3.98),('7643','2012-12-29','15:25:00',3.71),('7643','2012-12-29','15:30:00',3.42),('7643','2012-12-29','15:35:00',3.14),('7643','2012-12-29','15:40:00',2.82),('7643','2012-12-29','15:45:00',2.53),('7643','2012-12-29','15:50:00',2.25),('7643','2012-12-29','15:55:00',1.99),('7643','2012-12-29','16:00:00',1.7),('7643','2012-12-29','16:05:00',1.41),('7643','2012-12-29','16:10:00',1.15),('7643','2012-12-28','08:10:00',1.51),('7643','2012-12-28','08:15:00',1.83),('7643','2012-12-28','08:20:00',2.14),('7643','2012-12-28','08:25:00',2.51),('7643','2012-12-28','08:30:00',2.83),('7643','2012-12-28','08:35:00',3.19),('7643','2012-12-28','08:40:00',3.63),('7643','2012-12-28','08:45:00',3.98),('7643','2012-12-28','08:50:00',4.3),('7643','2012-12-28','08:55:00',4.53),('7643','2012-12-28','09:00:00',4.73),('7643','2012-12-28','09:05:00',5.02),('7643','2012-12-28','09:10:00',5.34),('7643','2012-12-28','09:15:00',5.62),('7643','2012-12-28','09:20:00',5.88),('7643','2012-12-28','09:25:00',6.11),('7643','2012-12-28','09:30:00',6.36),('7643','2012-12-28','09:35:00',6.63),('7643','2012-12-28','09:40:00',6.89),('7643','2012-12-28','09:45:00',7.18),('7643','2012-12-28','09:50:00',7.47),('7643','2012-12-28','09:55:00',7.7),('7643','2012-12-28','10:00:00',7.94),('7643','2012-12-28','10:05:00',8.17),('7643','2012-12-28','10:10:00',8.38),('7643','2012-12-28','10:15:00',8.6),('7643','2012-12-28','10:20:00',8.76),('7643','2012-12-28','10:25:00',8.95),('7643','2012-12-28','10:30:00',9.1),('7643','2012-12-28','10:35:00',9.22),('7643','2012-12-28','10:40:00',9.41),('7643','2012-12-28','10:45:00',9.56),('7643','2012-12-28','10:50:00',9.73),('7643','2012-12-28','10:55:00',9.84),('7643','2012-12-28','11:00:00',9.89),('7643','2012-12-28','11:05:00',9.98),('7643','2012-12-28','11:10:00',10.06),('7643','2012-12-28','11:15:00',10.18),('7643','2012-12-28','11:20:00',10.28),('7643','2012-12-28','11:25:00',10.32),('7643','2012-12-28','11:30:00',10.35),('7643','2012-12-28','11:35:00',10.41),('7643','2012-12-28','11:40:00',10.39),('7643','2012-12-28','11:45:00',10.47),('7643','2012-12-28','11:50:00',10.52),('7643','2012-12-28','11:55:00',10.5),('7643','2012-12-28','12:00:00',10.52),('7643','2012-12-28','12:05:00',10.59),('7643','2012-12-28','12:10:00',10.63),('7643','2012-12-28','12:15:00',10.52),('7643','2012-12-28','12:20:00',10.41),('7643','2012-12-28','12:25:00',10.34),('7643','2012-12-28','12:30:00',10.37),('7643','2012-12-28','12:35:00',10.41),('7643','2012-12-28','12:40:00',10.35),('7643','2012-12-28','12:45:00',10.1),('7643','2012-12-28','12:50:00',10.02),('7643','2012-12-28','12:55:00',10.02),('7643','2012-12-28','13:00:00',10),('7643','2012-12-28','13:05:00',9.96),('7643','2012-12-28','13:10:00',9.86),('7643','2012-12-28','13:15:00',9.76),('7643','2012-12-28','13:20:00',9.64),('7643','2012-12-28','13:25:00',9.46),('7643','2012-12-28','13:30:00',9.29),('7643','2012-12-28','13:35:00',9.15),('7643','2012-12-28','13:40:00',9.01),('7643','2012-12-28','13:45:00',8.88),('7643','2012-12-28','13:50:00',8.72),('7643','2012-12-28','13:55:00',8.53),('7643','2012-12-28','14:00:00',8.32),('7643','2012-12-28','14:05:00',8.07),('7643','2012-12-28','14:10:00',7.88),('7643','2012-12-28','14:15:00',7.72),('7643','2012-12-28','14:20:00',7.5),('7643','2012-12-28','14:25:00',7.24),('7643','2012-12-28','14:30:00',6.96),('7643','2012-12-28','14:35:00',6.7),('7643','2012-12-28','14:40:00',6.47),('7643','2012-12-28','14:45:00',6.23),('7643','2012-12-28','14:50:00',5.97),('7643','2012-12-28','14:55:00',5.68),('7643','2012-12-28','15:00:00',5.41),('7643','2012-12-28','15:05:00',5.12),('7643','2012-12-28','15:10:00',4.81),('7643','2012-12-28','15:15:00',4.51),('7643','2012-12-28','15:20:00',4.19),('7643','2012-12-28','15:25:00',3.88),('7643','2012-12-28','15:30:00',3.56),('7643','2012-12-28','15:35:00',3.24),('7643','2012-12-28','15:40:00',2.91),('7643','2012-12-28','15:45:00',2.61),('7643','2012-12-28','15:50:00',2.3),('7643','2012-12-28','15:55:00',2),('7643','2012-12-28','16:00:00',1.71),('7643','2012-12-28','16:05:00',1.44),('7643','2012-12-28','16:10:00',1.16),('7643','2012-12-27','08:40:00',2.68),('7643','2012-12-27','08:45:00',3.17),('7643','2012-12-27','08:50:00',3.47),('7643','2012-12-27','08:55:00',3.81),('7643','2012-12-27','09:00:00',4.11),('7643','2012-12-27','09:05:00',4.49),('7643','2012-12-27','09:10:00',4.81),('7643','2012-12-27','09:15:00',5.21),('7643','2012-12-27','09:20:00',5.42),('7643','2012-12-27','09:25:00',5.59),('7643','2012-12-27','09:30:00',5.82),('7643','2012-12-27','09:35:00',6.07),('7643','2012-12-27','09:40:00',6.28),('7643','2012-12-27','09:45:00',6.45),('7643','2012-12-27','09:50:00',6.61),('7643','2012-12-27','09:55:00',6.82),('7643','2012-12-27','10:00:00',7.14),('7643','2012-12-27','10:05:00',7.3),('7643','2012-12-27','10:10:00',7.62),('7643','2012-12-27','10:15:00',7.94),('7643','2012-12-27','10:20:00',8.14),('7643','2012-12-27','10:25:00',8.3),('7643','2012-12-27','10:30:00',8.54),('7643','2012-12-27','10:35:00',8.77),('7643','2012-12-27','10:40:00',8.79),('7643','2012-12-27','10:45:00',8.94),('7643','2012-12-27','10:50:00',9.01),('7643','2012-12-27','10:55:00',9.12),('7643','2012-12-27','11:00:00',9.28),('7643','2012-12-27','11:05:00',9.4),('7643','2012-12-27','11:10:00',9.69),('7643','2012-12-27','11:15:00',9.69),('7643','2012-12-27','11:20:00',9.76),('7643','2012-12-27','11:25:00',9.82),('7643','2012-12-27','11:30:00',9.41),('7643','2012-12-27','11:35:00',10.03),('7643','2012-12-27','11:40:00',10.05),('7643','2012-12-27','11:45:00',10.1),('7643','2012-12-27','11:50:00',10.22),('7643','2012-12-27','11:55:00',8.75),('7643','2012-12-27','12:00:00',9.08),('7643','2012-12-27','12:05:00',7.53),('7643','2012-12-27','12:10:00',9.22),('7643','2012-12-27','12:15:00',9.95),('7643','2012-12-27','12:20:00',9.6),('7643','2012-12-27','12:25:00',9.24),('7643','2012-12-27','12:30:00',9.85),('7643','2012-12-27','12:35:00',9.75),('7643','2012-12-27','12:40:00',9.09),('7643','2012-12-27','12:45:00',6.85),('7643','2012-12-27','12:50:00',9.78),('7643','2012-12-27','12:55:00',9.59),('7643','2012-12-27','13:00:00',9.5),('7643','2012-12-27','13:05:00',9.29),('7643','2012-12-27','13:10:00',9.17),('7643','2012-12-27','13:15:00',9.01),('7643','2012-12-27','13:20:00',8.9),('7643','2012-12-27','13:25:00',8.77),('7643','2012-12-27','13:30:00',8.64),('7643','2012-12-27','13:35:00',8.44),('7643','2012-12-27','13:40:00',8.3),('7643','2012-12-27','13:45:00',8.15),('7643','2012-12-27','13:50:00',8.06),('7643','2012-12-27','13:55:00',7.79),('7643','2012-12-27','14:00:00',7.56),('7643','2012-12-27','14:05:00',7.19),('7643','2012-12-27','14:10:00',6.1),('7643','2012-12-27','14:15:00',6.58),('7643','2012-12-27','14:20:00',6.42),('7643','2012-12-27','14:25:00',6.47),('7643','2012-12-27','14:30:00',6.11),('7643','2012-12-27','14:35:00',5.61),('7643','2012-12-27','14:40:00',2.71),('7643','2012-12-27','14:45:00',4.42),('7643','2012-12-27','14:50:00',5.24),('7643','2012-12-27','14:55:00',4.99),('7643','2012-12-27','15:00:00',4.75),('7643','2012-12-27','15:05:00',4.51),('7643','2012-12-27','15:10:00',4.22),('7643','2012-12-27','15:15:00',3.93),('7643','2012-12-27','15:20:00',3.63),('7643','2012-12-27','15:25:00',3.34),('7643','2012-12-27','15:30:00',3.09),('7643','2012-12-27','15:35:00',2.79),('7643','2012-12-27','15:40:00',2.5),('7643','2012-12-27','15:45:00',2.18),('7643','2012-12-27','15:50:00',1.88),('7643','2012-12-27','15:55:00',1.63),('7643','2012-12-27','16:00:00',1.42),('7643','2012-12-27','16:05:00',1.19),('7643','2012-12-26','08:45:00',1.03),('7643','2012-12-26','08:50:00',1.22),('7643','2012-12-26','08:55:00',1.67),('7643','2012-12-26','09:00:00',1.77),('7643','2012-12-26','09:05:00',1.31),('7643','2012-12-26','09:10:00',1.5),('7643','2012-12-26','09:15:00',2.15),('7643','2012-12-26','09:20:00',3.28),('7643','2012-12-26','09:25:00',4.15),('7643','2012-12-26','09:30:00',5.4),('7643','2012-12-26','09:35:00',6.41),('7643','2012-12-26','09:40:00',6.31),('7643','2012-12-26','09:45:00',6.55),('7643','2012-12-26','09:50:00',6.96),('7643','2012-12-26','09:55:00',7.14),('7643','2012-12-26','10:00:00',6.65),('7643','2012-12-26','10:05:00',5.34),('7643','2012-12-26','10:10:00',6.52),('7643','2012-12-26','10:15:00',8.18),('7643','2012-12-26','10:20:00',7.53),('7643','2012-12-26','10:25:00',7.59),('7643','2012-12-26','10:30:00',7.72),('7643','2012-12-26','10:35:00',7.85),('7643','2012-12-26','10:40:00',8.21),('7643','2012-12-26','10:45:00',8.58),('7643','2012-12-26','10:50:00',8.19),('7643','2012-12-26','10:55:00',8.34),('7643','2012-12-26','11:00:00',8.82),('7643','2012-12-26','11:05:00',9.19),('7643','2012-12-26','11:10:00',9.1),('7643','2012-12-26','11:15:00',7.37),('7643','2012-12-26','11:20:00',3.64),('7643','2012-12-26','11:25:00',2.83),('7643','2012-12-26','11:50:00',2.38),('7643','2012-12-26','11:55:00',9.56),('7643','2012-12-26','12:00:00',9.72),('7643','2012-12-26','12:05:00',9.63),('7643','2012-12-26','12:10:00',10.1),('7643','2012-12-26','12:15:00',9.16),('7643','2012-12-26','12:20:00',5.54),('7643','2012-12-26','12:25:00',9.29),('7643','2012-12-26','12:30:00',9.27),('7643','2012-12-26','12:35:00',9.82),('7643','2012-12-26','12:40:00',9.55),('7643','2012-12-26','12:45:00',10.69),('7643','2012-12-26','12:50:00',10.45),('7643','2012-12-26','12:55:00',8.93),('7643','2012-12-26','13:00:00',9.51),('7643','2012-12-26','13:05:00',10.07),('7643','2012-12-26','13:10:00',9.67),('7643','2012-12-26','13:15:00',10.05),('7643','2012-12-26','13:20:00',9.95),('7643','2012-12-26','13:25:00',9.71),('7643','2012-12-26','13:30:00',9.39),('7643','2012-12-26','13:35:00',4.12),('7643','2012-12-26','13:40:00',2.03),('7643','2012-12-26','13:45:00',2),('7643','2012-12-26','13:50:00',1.21),('7643','2012-12-26','13:55:00',1.86),('7643','2012-12-26','14:00:00',4.2),('7643','2012-12-26','14:05:00',6.18),('7643','2012-12-26','14:10:00',8.22),('7643','2012-12-26','14:15:00',7.7),('7643','2012-12-26','14:20:00',6.92),('7643','2012-12-26','14:25:00',6.61),('7643','2012-12-26','14:30:00',6.43),('7643','2012-12-26','14:35:00',6.19),('7643','2012-12-26','14:40:00',5.88),('7643','2012-12-26','14:45:00',5.11),('7643','2012-12-26','14:50:00',1.7),('7643','2012-12-26','14:55:00',4.67),('7643','2012-12-26','15:00:00',5.28),('7643','2012-12-26','15:05:00',4.56),('7643','2012-12-26','15:10:00',1.67),('7643','2012-12-26','15:15:00',1.31),('7643','2012-12-26','15:20:00',1.11),('7643','2012-12-26','15:25:00',1.61),('7643','2012-12-26','15:30:00',2.73),('7643','2012-12-26','15:35:00',2.21),('7643','2012-12-26','15:40:00',2.63),('7643','2012-12-26','15:45:00',2.26),('7643','2012-12-26','15:50:00',1.66),('7643','2012-12-26','15:55:00',1.54),('7643','2012-12-26','16:00:00',1.1),('7643','2012-12-25','08:30:00',1.01),('7643','2012-12-25','08:35:00',1.08),('7643','2012-12-25','08:40:00',1.31),('7643','2012-12-25','08:55:00',1.21),('7643','2012-12-25','09:00:00',1.79),('7643','2012-12-25','09:05:00',1.17),('7643','2012-12-25','09:10:00',2.56),('7643','2012-12-25','09:15:00',3.99),('7643','2012-12-25','09:20:00',5.43),('7643','2012-12-25','09:25:00',5.68),('7643','2012-12-25','09:30:00',5.89),('7643','2012-12-25','09:35:00',6.09),('7643','2012-12-25','09:40:00',6.39),('7643','2012-12-25','09:45:00',6.64),('7643','2012-12-25','09:50:00',6.86),('7643','2012-12-25','09:55:00',7.1),('7643','2012-12-25','10:00:00',7.31),('7643','2012-12-25','10:05:00',7.52),('7643','2012-12-25','10:10:00',7.71),('7643','2012-12-25','10:15:00',7.8),('7643','2012-12-25','10:20:00',7.94),('7643','2012-12-25','10:25:00',7.95),('7643','2012-12-25','10:30:00',8.12),('7643','2012-12-25','10:35:00',8.27),('7643','2012-12-25','10:40:00',8.44),('7643','2012-12-25','10:45:00',8.49),('7643','2012-12-25','10:50:00',8.61),('7643','2012-12-25','10:55:00',8.76),('7643','2012-12-25','11:00:00',8.85),('7643','2012-12-25','11:05:00',8.94),('7643','2012-12-25','11:10:00',9),('7643','2012-12-25','11:15:00',9.07),('7643','2012-12-25','11:20:00',9.11),('7643','2012-12-25','11:25:00',9.15),('7643','2012-12-25','11:30:00',9.2),('7643','2012-12-25','11:35:00',9.24),('7643','2012-12-25','11:40:00',9.35),('7643','2012-12-25','11:45:00',9.47),('7643','2012-12-25','11:50:00',9.62),('7643','2012-12-25','11:55:00',9.76),('7643','2012-12-25','12:00:00',9.9),('7643','2012-12-25','12:05:00',9.89),('7643','2012-12-25','12:10:00',9.85),('7643','2012-12-25','12:15:00',9.9),('7643','2012-12-25','12:20:00',9.92),('7643','2012-12-25','12:25:00',9.94),('7643','2012-12-25','12:30:00',9.84),('7643','2012-12-25','12:35:00',9.85),('7643','2012-12-25','12:40:00',8.54),('7643','2012-12-25','12:45:00',9.72),('7643','2012-12-25','12:50:00',9.35),('7643','2012-12-25','12:55:00',9.55),('7643','2012-12-25','13:00:00',9.63),('7643','2012-12-25','13:05:00',9.5),('7643','2012-12-25','13:10:00',9.52),('7643','2012-12-25','13:15:00',9.31),('7643','2012-12-25','13:20:00',9.57),('7643','2012-12-25','13:25:00',9.64),('7643','2012-12-25','13:30:00',10.21),('7643','2012-12-25','13:35:00',10.12),('7643','2012-12-25','13:40:00',10.02),('7643','2012-12-25','13:45:00',10.13),('7643','2012-12-25','13:50:00',9.13),('7643','2012-12-25','13:55:00',9.66),('7643','2012-12-25','14:00:00',9.44),('7643','2012-12-25','14:05:00',8.59),('7643','2012-12-25','14:10:00',2.93),('7643','2012-12-25','14:15:00',3.34),('7643','2012-12-25','14:20:00',1.44),('7643','2012-12-25','14:25:00',1.51),('7643','2012-12-25','14:30:00',1.21),('7643','2012-12-25','14:40:00',1.02),('7643','2012-12-24','09:00:00',1.13),('7643','2012-12-24','09:05:00',1.13),('7643','2012-12-24','09:10:00',1.13),('7643','2012-12-24','09:15:00',1.21),('7643','2012-12-24','09:20:00',1.46),('7643','2012-12-24','09:25:00',1.31),('7643','2012-12-24','09:30:00',1.36),('7643','2012-12-24','09:35:00',1.49),('7643','2012-12-24','09:40:00',1.52),('7643','2012-12-24','09:45:00',1.48),('7643','2012-12-24','09:50:00',1.55),('7643','2012-12-24','09:55:00',1.65),('7643','2012-12-24','10:00:00',1.94),('7643','2012-12-24','10:05:00',2.27),('7643','2012-12-24','10:10:00',2.53),('7643','2012-12-24','10:15:00',2.64),('7643','2012-12-24','10:20:00',2.77),('7643','2012-12-24','10:25:00',2.96),('7643','2012-12-24','10:30:00',2.81),('7643','2012-12-24','10:35:00',2.77),('7643','2012-12-24','10:40:00',2.71),('7643','2012-12-24','10:45:00',2.66),('7643','2012-12-24','10:50:00',2.64),('7643','2012-12-24','10:55:00',2.75),('7643','2012-12-24','11:00:00',2.76),('7643','2012-12-24','11:05:00',2.95),('7643','2012-12-24','11:10:00',2.98),('7643','2012-12-24','11:15:00',2.98),('7643','2012-12-24','11:20:00',3.22),('7643','2012-12-24','11:25:00',3.44),('7643','2012-12-24','11:30:00',3.26),('7643','2012-12-24','11:35:00',3.16),('7643','2012-12-24','11:40:00',2.92),('7643','2012-12-24','11:45:00',3.03),('7643','2012-12-24','11:50:00',3.27),('7643','2012-12-24','11:55:00',3.52),('7643','2012-12-24','12:00:00',3.47),('7643','2012-12-24','12:05:00',3.18),('7643','2012-12-24','12:10:00',3.16),('7643','2012-12-24','12:15:00',3.07),('7643','2012-12-24','12:20:00',3.06),('7643','2012-12-24','12:25:00',3.15),('7643','2012-12-24','12:30:00',2.89),('7643','2012-12-24','12:35:00',2.75),('7643','2012-12-24','12:40:00',2.72),('7643','2012-12-24','12:45:00',2.73),('7643','2012-12-24','12:50:00',2.82),('7643','2012-12-24','12:55:00',3.11),('7643','2012-12-24','13:00:00',2.95),('7643','2012-12-24','13:05:00',3.16),('7643','2012-12-24','13:10:00',3.22),('7643','2012-12-24','13:15:00',3.32),('7643','2012-12-24','13:20:00',3.2),('7643','2012-12-24','13:25:00',2.81),('7643','2012-12-24','13:30:00',2.49),('7643','2012-12-24','13:35:00',2.24),('7643','2012-12-24','13:40:00',2.42),('7643','2012-12-24','13:45:00',2.13),('7643','2012-12-24','13:50:00',2.02),('7643','2012-12-24','13:55:00',1.57),('7643','2012-12-24','14:00:00',1.92),('7643','2012-12-24','14:05:00',1.93),('7643','2012-12-24','14:10:00',1.65),('7643','2012-12-24','14:15:00',1.57),('7643','2012-12-24','14:20:00',1.44),('7643','2012-12-24','14:25:00',1.4),('7643','2012-12-24','14:30:00',1.75),('7643','2012-12-24','14:35:00',2),('7643','2012-12-24','14:40:00',3.56),('7643','2012-12-24','14:45:00',4.2),('7643','2012-12-24','14:50:00',3.76),('7643','2012-12-24','14:55:00',3.72),('7643','2012-12-24','15:00:00',3.59),('7643','2012-12-24','15:05:00',2.66),('7643','2012-12-24','15:10:00',3.04),('7643','2012-12-24','15:15:00',2.96),('7643','2012-12-24','15:20:00',2.58),('7643','2012-12-24','15:25:00',2.26),('7643','2012-12-24','15:30:00',1.92),('7643','2012-12-24','15:35:00',1.93),('7643','2012-12-24','15:40:00',1.93),('7643','2012-12-24','15:45:00',1.54),('7643','2012-12-24','15:50:00',1.26),('7643','2012-12-23','09:25:00',1.07),('7643','2012-12-23','09:30:00',1.04),('7643','2012-12-23','09:35:00',1.03),('7643','2012-12-23','09:40:00',1.09),('7643','2012-12-23','09:45:00',1.15),('7643','2012-12-23','09:50:00',1.15),('7643','2012-12-23','09:55:00',1.25),('7643','2012-12-23','10:00:00',1.35),('7643','2012-12-23','10:05:00',1.47),('7643','2012-12-23','10:10:00',1.48),('7643','2012-12-23','10:15:00',1.47),('7643','2012-12-23','10:20:00',1.37),('7643','2012-12-23','10:25:00',1.38),('7643','2012-12-23','10:30:00',1.46),('7643','2012-12-23','10:35:00',1.58),('7643','2012-12-23','10:40:00',1.47),('7643','2012-12-23','10:45:00',1.65),('7643','2012-12-23','10:50:00',1.7),('7643','2012-12-23','10:55:00',1.72),('7643','2012-12-23','11:00:00',1.68),('7643','2012-12-23','11:05:00',1.8),('7643','2012-12-23','11:10:00',1.95),('7643','2012-12-23','11:15:00',2.01),('7643','2012-12-23','11:20:00',2.18),('7643','2012-12-23','11:25:00',2.1),('7643','2012-12-23','11:30:00',2.29),('7643','2012-12-23','11:35:00',2.36),('7643','2012-12-23','11:40:00',2.32),('7643','2012-12-23','11:45:00',2.28),('7643','2012-12-23','11:50:00',2.17),('7643','2012-12-23','11:55:00',2.19),('7643','2012-12-23','12:00:00',2.44),('7643','2012-12-23','12:05:00',2.79),('7643','2012-12-23','12:10:00',3.04),('7643','2012-12-23','12:15:00',2.88),('7643','2012-12-23','12:20:00',2.76),('7643','2012-12-23','12:25:00',2.77),('7643','2012-12-23','12:30:00',2.72),('7643','2012-12-23','12:35:00',2.71),('7643','2012-12-23','12:40:00',2.71),('7643','2012-12-23','12:45:00',2.53),('7643','2012-12-23','12:50:00',2.34),('7643','2012-12-23','12:55:00',2.27),('7643','2012-12-23','13:00:00',2.22),('7643','2012-12-23','13:05:00',2.01),('7643','2012-12-23','13:10:00',1.98),('7643','2012-12-23','13:15:00',1.85),('7643','2012-12-23','13:20:00',1.64),('7643','2012-12-23','13:25:00',1.73),('7643','2012-12-23','13:30:00',1.36),('7643','2012-12-23','13:35:00',1.26),('7643','2012-12-23','13:40:00',1.36),('7643','2012-12-23','13:45:00',1.45),('7643','2012-12-23','13:50:00',1.4),('7643','2012-12-23','13:55:00',1.39),('7643','2012-12-23','14:00:00',1.41),('7643','2012-12-23','14:05:00',1.36),('7643','2012-12-23','14:10:00',1.36),('7643','2012-12-23','14:15:00',1.35),('7643','2012-12-23','14:20:00',1.35),('7643','2012-12-23','14:25:00',1.24),('7643','2012-12-23','14:30:00',1.14),('7643','2012-12-23','14:35:00',1.08),('7643','2012-12-23','14:40:00',1.03),('7643','2012-12-22','08:00:00',1.05),('7643','2012-12-22','08:05:00',1.32),('7643','2012-12-22','08:10:00',1.56),('7643','2012-12-22','08:15:00',1.82),('7643','2012-12-22','08:20:00',2.1),('7643','2012-12-22','08:25:00',2.36),('7643','2012-12-22','08:30:00',2.7),('7643','2012-12-22','08:35:00',2.96),('7643','2012-12-22','08:40:00',3.28),('7643','2012-12-22','08:45:00',3.63),('7643','2012-12-22','08:50:00',3.98),('7643','2012-12-22','08:55:00',4.35),('7643','2012-12-22','09:00:00',4.69),('7643','2012-12-22','09:05:00',5.03),('7643','2012-12-22','09:10:00',5.26),('7643','2012-12-22','09:15:00',5.36),('7643','2012-12-22','09:20:00',5.62),('7643','2012-12-22','09:25:00',6.01),('7643','2012-12-22','09:30:00',6.14),('7643','2012-12-22','09:35:00',6.46),('7643','2012-12-22','09:40:00',6.69),('7643','2012-12-22','09:45:00',6.93),('7643','2012-12-22','09:50:00',7.13),('7643','2012-12-22','09:55:00',7.28),('7643','2012-12-22','10:00:00',7.44),('7643','2012-12-22','10:05:00',7.73),('7643','2012-12-22','10:10:00',7.81),('7643','2012-12-22','10:15:00',7.94),('7643','2012-12-22','10:20:00',8.14),('7643','2012-12-22','10:25:00',8.11),('7643','2012-12-22','10:30:00',8.21),('7643','2012-12-22','10:35:00',8.45),('7643','2012-12-22','10:40:00',8.62),('7643','2012-12-22','10:45:00',8.88),('7643','2012-12-22','10:50:00',8.95),('7643','2012-12-22','10:55:00',8.53),('7643','2012-12-22','11:00:00',9.12),('7643','2012-12-22','11:05:00',9.25),('7643','2012-12-22','11:10:00',9.27),('7643','2012-12-22','11:15:00',9.37),('7643','2012-12-22','11:20:00',9.59),('7643','2012-12-22','11:25:00',8.74),('7643','2012-12-22','11:30:00',9.32),('7643','2012-12-22','11:35:00',9.89),('7643','2012-12-22','11:40:00',9.86),('7643','2012-12-22','11:45:00',9.69),('7643','2012-12-22','11:50:00',9.96),('7643','2012-12-22','11:55:00',9.35),('7643','2012-12-22','12:00:00',8.72),('7643','2012-12-22','12:05:00',8.85),('7643','2012-12-22','12:10:00',8.85),('7643','2012-12-22','12:15:00',7.14),('7643','2012-12-22','12:20:00',6.59),('7643','2012-12-22','12:25:00',4.59),('7643','2012-12-22','12:30:00',4.32),('7643','2012-12-22','12:35:00',3.82),('7643','2012-12-22','12:40:00',4.92),('7643','2012-12-22','12:45:00',4.46),('7643','2012-12-22','12:50:00',6.16),('7643','2012-12-22','12:55:00',8.12),('7643','2012-12-22','13:00:00',9.15),('7643','2012-12-22','13:05:00',8.08),('7643','2012-12-22','13:10:00',9.15),('7643','2012-12-22','13:15:00',6.37),('7643','2012-12-22','13:20:00',5.41),('7643','2012-12-22','13:25:00',5.61),('7643','2012-12-22','13:30:00',4.5),('7643','2012-12-22','13:35:00',3.71),('7643','2012-12-22','13:40:00',6.42),('7643','2012-12-22','13:45:00',6.28),('7643','2012-12-22','13:50:00',5.82),('7643','2012-12-22','13:55:00',5.08),('7643','2012-12-22','14:00:00',7.06),('7643','2012-12-22','14:05:00',6.65),('7643','2012-12-22','14:10:00',6.15),('7643','2012-12-22','14:15:00',6.43),('7643','2012-12-22','14:20:00',5.12),('7643','2012-12-22','14:25:00',4.06),('7643','2012-12-22','14:30:00',3.98),('7643','2012-12-22','14:35:00',4.95),('7643','2012-12-22','14:40:00',5.33),('7643','2012-12-22','14:45:00',5.5),('7643','2012-12-22','14:50:00',4.03),('7643','2012-12-22','14:55:00',2.86),('7643','2012-12-22','15:00:00',2.36),('7643','2012-12-22','15:05:00',2.31),('7643','2012-12-22','15:10:00',2.76),('7643','2012-12-22','15:15:00',1.74),('7643','2012-12-22','15:20:00',1.35),('7643','2012-12-22','15:25:00',1.01),('7643','2012-12-22','15:30:00',1.15),('7643','2012-12-22','15:35:00',1.12),('7643','2012-12-22','15:45:00',1.31),('7643','2012-12-22','15:50:00',1.36),('7643','2012-12-22','16:05:00',1.15),('7643','2014-04-30','07:40:00',2.73),('7643','2014-04-30','07:45:00',3.44),('7643','2014-04-30','07:50:00',4.56),('7643','2014-04-30','07:55:00',5.1),('7643','2014-04-30','08:00:00',5.65),('7643','2014-04-30','08:05:00',5.99),('7643','2014-04-30','08:10:00',6.05),('7643','2014-04-30','08:15:00',6.64),('7643','2014-04-30','08:20:00',6.99),('7643','2014-04-30','08:25:00',7.35),('7643','2014-04-30','08:30:00',7.67),('7643','2014-04-30','08:35:00',8.06),('7643','2014-04-30','08:40:00',8.36),('7643','2014-04-30','08:45:00',8.74),('7643','2014-04-30','08:50:00',9.16),('7643','2014-04-30','08:55:00',10.59),('7643','2014-04-30','09:00:00',6.97),('7643','2014-04-30','09:05:00',7.14),('7643','2014-04-30','09:10:00',5.7),('7643','2014-04-30','09:15:00',8.03),('7643','2014-04-30','09:20:00',5.14),('7643','2014-04-30','09:25:00',11.21),('7643','2014-04-30','09:30:00',12.39),('7643','2014-04-30','09:35:00',12.75),('7643','2014-04-30','09:40:00',11.9),('7643','2014-04-30','09:45:00',9.82),('7643','2014-04-30','09:50:00',6.49),('7643','2014-04-30','09:55:00',8.46),('7643','2014-04-30','10:00:00',7.89),('7643','2014-04-30','10:05:00',6.3),('7643','2014-04-30','10:10:00',14.86),('7643','2014-04-30','10:15:00',8.72),('7643','2014-04-30','10:20:00',9.04),('7643','2014-04-30','10:25:00',11.06),('7643','2014-04-30','10:30:00',10.18),('7643','2014-04-30','10:35:00',9.81),('7643','2014-04-30','10:40:00',11.24),('7643','2014-04-30','10:45:00',13.62),('7643','2014-04-30','10:50:00',16.53),('7643','2014-04-30','10:55:00',16.1),('7643','2014-04-30','11:00:00',16.39),('7643','2014-04-30','11:05:00',8.43),('7643','2014-04-30','11:10:00',10.96),('7643','2014-04-30','11:15:00',9.16),('7643','2014-04-30','11:20:00',18.08),('7643','2014-04-30','11:25:00',7.95),('7643','2014-04-30','11:30:00',11.64),('7643','2014-04-30','11:35:00',18.4),('7643','2014-04-30','11:40:00',18.16),('7643','2014-04-30','11:45:00',10.75),('7643','2014-04-30','11:50:00',12.55),('7643','2014-04-30','11:55:00',18.62),('7643','2014-04-30','12:00:00',17.31),('7643','2014-04-30','12:05:00',12.13),('7643','2014-04-30','12:10:00',17.63),('7643','2014-04-30','12:15:00',16.66),('7643','2014-04-30','12:20:00',17.25),('7643','2014-04-30','12:25:00',6.85),('7643','2014-04-30','12:30:00',13.35),('7643','2014-04-30','12:35:00',18.74),('7643','2014-04-30','12:40:00',18.24),('7643','2014-04-30','12:45:00',18.21),('7643','2014-04-30','12:50:00',9.67),('7643','2014-04-30','12:55:00',12.81),('7643','2014-04-30','13:00:00',18.87),('7643','2014-04-30','13:05:00',18.07),('7643','2014-04-30','13:10:00',18.11),('7643','2014-04-30','13:15:00',17),('7643','2014-04-30','13:20:00',17.66),('7643','2014-04-30','13:25:00',12.88),('7643','2014-04-30','13:30:00',7.52),('7643','2014-04-30','13:35:00',19.33),('7643','2014-04-30','13:40:00',18.39),('7643','2014-04-30','13:45:00',18.5),('7643','2014-04-30','13:50:00',18.89),('7643','2014-04-30','13:55:00',18.47),('7643','2014-04-30','14:00:00',14.19),('7643','2014-04-30','14:05:00',18.39),('7643','2014-04-30','14:10:00',18.34),('7643','2014-04-30','14:15:00',17.83),('7643','2014-04-30','14:20:00',17.46),('7643','2014-04-30','14:25:00',17.92),('7643','2014-04-30','14:30:00',16.95),('7643','2014-04-30','14:35:00',16.61),('7643','2014-04-30','14:40:00',16.56),('7643','2014-04-30','14:45:00',18.02),('7643','2014-04-30','14:50:00',17.64),('7643','2014-04-30','14:55:00',17.13),('7643','2014-04-30','15:00:00',17.67),('7643','2014-04-30','15:05:00',16.72),('7643','2014-04-30','15:10:00',9.64),('7643','2014-04-30','15:15:00',14.63),('7643','2014-04-30','15:20:00',15.82),('7643','2014-04-30','15:25:00',15.64),('7643','2014-04-30','15:30:00',15.15),('7643','2014-04-30','15:35:00',14.92),('7643','2014-04-30','15:40:00',14.6),('7643','2014-04-30','15:45:00',13.98),('7643','2014-04-30','15:50:00',14.29),('7643','2014-04-30','15:55:00',13.78),('7643','2014-04-30','16:00:00',13.59),('7643','2014-04-30','16:05:00',13.55),('7643','2014-04-30','16:10:00',12.96),('7643','2014-04-30','16:15:00',12.77),('7643','2014-04-30','16:20:00',12.18),('7643','2014-04-30','16:25:00',11.03),('7643','2014-04-30','16:30:00',11.56),('7643','2014-04-30','16:35:00',11.62),('7643','2014-04-30','16:40:00',10.99),('7643','2014-04-30','16:45:00',9.23),('7643','2014-04-30','16:50:00',8.63),('7643','2014-04-30','16:55:00',9.05),('7643','2014-04-30','17:00:00',9.47),('7643','2014-04-30','17:05:00',8.97),('7643','2014-04-30','17:10:00',9.65),('7643','2014-04-30','17:15:00',9.03),('7643','2014-04-30','17:20:00',8.64),('7643','2014-04-30','17:25:00',8.16),('7643','2014-04-30','17:30:00',7.72),('7643','2014-04-30','17:35:00',7.39),('7643','2014-04-30','17:40:00',6.99),('7643','2014-04-30','17:45:00',6.63),('7643','2014-04-30','17:50:00',6.23),('7643','2014-04-30','17:55:00',6.09),('7643','2014-04-30','18:00:00',5.72),('7643','2014-04-30','18:05:00',5.36),('7643','2014-04-30','18:10:00',4.74),('7643','2014-04-30','18:15:00',4.24),('7643','2014-04-30','18:20:00',3.89),('7643','2014-04-30','18:25:00',3.68),('7643','2014-04-30','18:30:00',3.35),('7643','2014-04-30','18:35:00',2.95),('7643','2014-04-30','18:40:00',2.53),('7643','2014-04-30','18:45:00',2.18),('7643','2014-04-30','18:50:00',1.77),('7643','2014-04-30','18:55:00',1.53),('7643','2014-04-30','19:00:00',1.23),('7643','2014-04-30','19:05:00',1.01),('7643','2014-03-16','08:05:00',1.03),('7643','2014-03-16','08:10:00',1.16),('7643','2014-03-16','08:15:00',1.6),('7643','2014-03-16','08:20:00',1.78),('7643','2014-03-16','08:25:00',1.95),('7643','2014-03-16','08:30:00',2.24),('7643','2014-03-16','08:35:00',2.35),('7643','2014-03-16','08:40:00',2.62),('7643','2014-03-16','08:45:00',2.72),('7643','2014-03-16','08:50:00',2.81),('7643','2014-03-16','08:55:00',3.17),('7643','2014-03-16','09:00:00',3.22),('7643','2014-03-16','09:05:00',3.5),('7643','2014-03-16','09:10:00',3.8),('7643','2014-03-16','09:15:00',4.51),('7643','2014-03-16','09:20:00',5.01),('7643','2014-03-16','09:25:00',5.96),('7643','2014-03-16','09:30:00',7.4),('7643','2014-03-16','09:35:00',6.96),('7643','2014-03-16','09:40:00',5.19),('7643','2014-03-16','09:45:00',4.97),('7643','2014-03-16','09:50:00',6.78),('7643','2014-03-16','09:55:00',7.25),('7643','2014-03-16','10:00:00',7.62),('7643','2014-03-16','10:05:00',6.22),('7643','2014-03-16','10:10:00',7.46),('7643','2014-03-16','10:15:00',6.54),('7643','2014-03-16','10:20:00',8.49),('7643','2014-03-16','10:25:00',6.25),('7643','2014-03-16','10:30:00',5.33),('7643','2014-03-16','10:35:00',5.56),('7643','2014-03-16','10:40:00',5.29),('7643','2014-03-16','10:45:00',6.59),('7643','2014-03-16','10:50:00',5.62),('7643','2014-03-16','10:55:00',5.85),('7643','2014-03-16','11:00:00',5.7),('7643','2014-03-16','11:05:00',5.38),('7643','2014-03-16','11:10:00',7.21),('7643','2014-03-16','11:15:00',6.34),('7643','2014-03-16','11:20:00',4.91),('7643','2014-03-16','11:25:00',5.08),('7643','2014-03-16','11:30:00',6.25),('7643','2014-03-16','11:35:00',5.12),('7643','2014-03-16','11:40:00',4.66),('7643','2014-03-16','11:45:00',4.43),('7643','2014-03-16','11:50:00',8.46),('7643','2014-03-16','11:55:00',6.89),('7643','2014-03-16','12:00:00',7.85),('7643','2014-03-16','12:05:00',6.95),('7643','2014-03-16','12:10:00',6.75),('7643','2014-03-16','12:15:00',6.51),('7643','2014-03-16','12:20:00',7.28),('7643','2014-03-16','12:25:00',16.03),('7643','2014-03-16','12:30:00',8.68),('7643','2014-03-16','12:35:00',14.37),('7643','2014-03-16','12:40:00',8.27),('7643','2014-03-16','12:45:00',6.45),('7643','2014-03-16','12:50:00',10.39),('7643','2014-03-16','12:55:00',14.6),('7643','2014-03-16','13:00:00',16),('7643','2014-03-16','13:05:00',13.39),('7643','2014-03-16','13:10:00',12.54),('7643','2014-03-16','13:15:00',14.84),('7643','2014-03-16','13:20:00',14.91),('7643','2014-03-16','13:25:00',14.46),('7643','2014-03-16','13:30:00',7.52),('7643','2014-03-16','13:35:00',12.89),('7643','2014-03-16','13:40:00',14.86),('7643','2014-03-16','13:45:00',14.94),('7643','2014-03-16','13:50:00',13.61),('7643','2014-03-16','13:55:00',13.79),('7643','2014-03-16','14:00:00',12.91),('7643','2014-03-16','14:05:00',12.27),('7643','2014-03-16','14:10:00',7.79),('7643','2014-03-16','14:15:00',4.56),('7643','2014-03-16','14:20:00',7.75),('7643','2014-03-16','14:25:00',6.07),('7643','2014-03-16','14:30:00',12.38),('7643','2014-03-16','14:35:00',9.5),('7643','2014-03-16','14:40:00',10.02),('7643','2014-03-16','14:45:00',11.73),('7643','2014-03-16','14:50:00',12.06),('7643','2014-03-16','14:55:00',11.57),('7643','2014-03-16','15:00:00',11.03),('7643','2014-03-16','15:05:00',10.57),('7643','2014-03-16','15:10:00',10.5),('7643','2014-03-16','15:15:00',10.36),('7643','2014-03-16','15:20:00',4.66),('7643','2014-03-16','15:25:00',9.13),('7643','2014-03-16','15:30:00',9.26),('7643','2014-03-16','15:35:00',7.93),('7643','2014-03-16','15:40:00',8.33),('7643','2014-03-16','15:45:00',7.94),('7643','2014-03-16','15:50:00',7.14),('7643','2014-03-16','15:55:00',7.4),('7643','2014-03-16','16:00:00',7.07),('7643','2014-03-16','16:05:00',6.73),('7643','2014-03-16','16:10:00',6),('7643','2014-03-16','16:15:00',3.69),('7643','2014-03-16','16:20:00',5.97),('7643','2014-03-16','16:25:00',5.9),('7643','2014-03-16','16:30:00',5.32),('7643','2014-03-16','16:35:00',4.76),('7643','2014-03-16','16:40:00',4.34),('7643','2014-03-16','16:45:00',3.69),('7643','2014-03-16','16:50:00',3.47),('7643','2014-03-16','16:55:00',1.8),('7643','2014-03-16','17:00:00',1.89),('7643','2014-03-16','17:05:00',2.21),('7643','2014-03-16','17:10:00',1.89),('7643','2014-03-16','17:15:00',1.51),('7643','2014-03-16','17:20:00',1.34),('7643','2012-12-21','09:15:00',1.14),('7643','2012-12-21','09:20:00',1.55),('7643','2012-12-21','09:25:00',2.08),('7643','2012-12-21','09:30:00',2.62),('7643','2012-12-21','09:35:00',3.33),('7643','2012-12-21','09:40:00',2.82),('7643','2012-12-21','09:45:00',2.32),('7643','2012-12-21','09:50:00',2.41),('7643','2012-12-21','09:55:00',2.71),('7643','2012-12-21','10:00:00',2.69),('7643','2012-12-21','10:05:00',2.78),('7643','2012-12-21','10:10:00',2.97),('7643','2012-12-21','10:15:00',3.07),('7643','2012-12-21','10:20:00',3.57),('7643','2012-12-21','10:25:00',8.21),('7643','2012-12-21','10:30:00',9.12),('7643','2012-12-21','10:35:00',10.88),('7643','2012-12-21','10:40:00',10.59),('7643','2012-12-21','10:45:00',10.4),('7643','2012-12-21','10:50:00',10.31),('7643','2012-12-21','10:55:00',10.43),('7643','2012-12-21','11:00:00',4.25),('7643','2012-12-21','11:05:00',1.98),('7643','2012-12-21','11:10:00',1.77),('7643','2012-12-21','11:15:00',1.7),('7643','2012-12-21','11:20:00',2.31),('7643','2012-12-21','11:25:00',1.91),('7643','2012-12-21','11:30:00',2.51),('7643','2012-12-21','11:35:00',3.15),('7643','2012-12-21','11:40:00',4.32),('7643','2012-12-21','11:45:00',6.36),('7643','2012-12-21','11:50:00',10.25),('7643','2012-12-21','11:55:00',5.77),('7643','2012-12-21','12:00:00',9.17),('7643','2012-12-21','12:05:00',6.92),('7643','2012-12-21','12:10:00',3.16),('7643','2012-12-21','12:15:00',3.49),('7643','2012-12-21','12:20:00',2.48),('7643','2012-12-21','12:25:00',2.47),('7643','2012-12-21','12:30:00',2.55),('7643','2012-12-21','12:35:00',2.73),('7643','2012-12-21','12:40:00',3.16),('7643','2012-12-21','12:45:00',8.07),('7643','2012-12-21','12:50:00',9.54),('7643','2012-12-21','12:55:00',8.89),('7643','2012-12-21','13:00:00',9.96),('7643','2012-12-21','13:05:00',11.26),('7643','2012-12-21','13:10:00',11.43),('7643','2012-12-21','13:15:00',11.58),('7643','2012-12-21','13:20:00',11.76),('7643','2012-12-21','13:25:00',11.55),('7643','2012-12-21','13:30:00',10.69),('7643','2012-12-21','13:35:00',10.39),('7643','2012-12-21','13:40:00',9.59),('7643','2012-12-21','13:45:00',3.33),('7643','2012-12-21','13:50:00',2.97),('7643','2012-12-21','13:55:00',3.75),('7643','2012-12-21','14:00:00',3.47),('7643','2012-12-21','14:05:00',4.66),('7643','2012-12-21','14:10:00',4.68),('7643','2012-12-21','14:15:00',5.58),('7643','2012-12-21','14:20:00',7),('7643','2012-12-21','14:25:00',1.89),('7643','2012-12-21','14:30:00',1.49),('7643','2012-12-21','14:35:00',1.26),('7643','2012-12-21','14:40:00',1.17),('7643','2012-12-21','14:45:00',1.37),('7643','2012-12-21','14:50:00',1.79),('7643','2012-12-21','14:55:00',2.18),('7643','2012-12-21','15:00:00',3.01),('7643','2012-12-21','15:05:00',1.75),('7643','2012-12-21','15:10:00',1.49),('7643','2012-12-21','15:15:00',1.33),('7643','2012-12-21','15:20:00',1.09),('7643','2012-12-21','15:35:00',1.19),('7643','2012-12-21','15:40:00',1.27),('7643','2012-12-21','15:45:00',1.58),('7643','2012-12-21','15:50:00',1.14),('7643','2012-12-21','15:55:00',1.65),('7643','2012-12-21','16:00:00',1.21),('7643','2012-12-21','16:05:00',1.15),('7643','2014-03-15','07:00:00',1.16),('7643','2014-03-15','07:05:00',1.42),('7643','2014-03-15','07:10:00',1.67),('7643','2014-03-15','07:15:00',1.98),('7643','2014-03-15','07:20:00',2.26),('7643','2014-03-15','07:25:00',2.51),('7643','2014-03-15','07:30:00',2.74),('7643','2014-03-15','07:35:00',3.02),('7643','2014-03-15','07:40:00',3.12),('7643','2014-03-15','07:45:00',3.44),('7643','2014-03-15','07:50:00',3.8),('7643','2014-03-15','07:55:00',4.37),('7643','2014-03-15','08:00:00',4.87),('7643','2014-03-15','08:05:00',5.21),('7643','2014-03-15','08:10:00',5.35),('7643','2014-03-15','08:15:00',5.58),('7643','2014-03-15','08:20:00',6.02),('7643','2014-03-15','08:25:00',6.37),('7643','2014-03-15','08:30:00',6.77),('7643','2014-03-15','08:35:00',7.07),('7643','2014-03-15','08:40:00',7.29),('7643','2014-03-15','08:45:00',7.7),('7643','2014-03-15','08:50:00',8.07),('7643','2014-03-15','08:55:00',8.16),('7643','2014-03-15','09:00:00',8.11),('7643','2014-03-15','09:05:00',8.43),('7643','2014-03-15','09:10:00',8.99),('7643','2014-03-15','09:15:00',9.64),('7643','2014-03-15','09:20:00',9.86),('7643','2014-03-15','09:25:00',9.81),('7643','2014-03-15','09:30:00',10.02),('7643','2014-03-15','09:35:00',10.09),('7643','2014-03-15','09:40:00',10.08),('7643','2014-03-15','09:45:00',10.71),('7643','2014-03-15','09:50:00',11.6),('7643','2014-03-15','09:55:00',11.33),('7643','2014-03-15','10:00:00',11.63),('7643','2014-03-15','10:05:00',11.44),('7643','2014-03-15','10:10:00',11.75),('7643','2014-03-15','10:15:00',12.22),('7643','2014-03-15','10:20:00',12.26),('7643','2014-03-15','10:25:00',12.22),('7643','2014-03-15','10:30:00',12.7),('7643','2014-03-15','10:45:00',13.28),('7643','2014-03-15','10:50:00',13.31),('7643','2014-03-15','13:55:00',12.86),('7643','2014-03-15','14:00:00',12.83),('7643','2014-03-15','14:05:00',12.33),('7643','2014-03-15','14:10:00',12.29),('7643','2014-03-15','14:15:00',11.85),('7643','2014-03-15','14:20:00',11.95),('7643','2014-03-15','14:25:00',11.71),('7643','2014-03-15','14:30:00',11.66),('7643','2014-03-15','14:35:00',11.35),('7643','2014-03-15','14:40:00',11.13),('7643','2014-03-15','14:45:00',10.76),('7643','2014-03-15','14:50:00',10.16),('7643','2014-03-15','14:55:00',10.06),('7643','2014-03-15','15:00:00',10.66),('7643','2014-03-15','15:05:00',10.03),('7643','2014-03-15','15:10:00',9.27),('7643','2014-03-15','15:15:00',8.65),('7643','2014-03-15','15:20:00',7.38),('7643','2014-03-15','15:25:00',8.15),('7643','2014-03-15','15:30:00',7.73),('7643','2014-03-15','15:35:00',7.03),('7643','2014-03-15','15:40:00',5.48),('7643','2014-03-15','15:45:00',5.55),('7643','2014-03-15','15:50:00',6.3),('7643','2014-03-15','15:55:00',5.85),('7643','2014-03-15','16:00:00',5.05),('7643','2014-03-15','16:05:00',5.86),('7643','2014-03-15','16:10:00',6.16),('7643','2014-03-15','16:15:00',6.05),('7643','2014-03-15','16:20:00',5.26),('7643','2014-03-15','16:25:00',5.43),('7643','2014-03-15','16:30:00',5.34),('7643','2014-03-15','16:35:00',4.79),('7643','2014-03-15','16:40:00',4.14),('7643','2014-03-15','16:45:00',3.69),('7643','2014-03-15','16:50:00',3.33),('7643','2014-03-15','16:55:00',2.75),('7643','2014-03-15','17:00:00',2.14),('7643','2014-03-15','17:05:00',2.02),('7643','2014-03-15','17:10:00',1.78),('7643','2014-03-15','17:15:00',1.33),('7643','2014-03-15','17:20:00',1.12),('7643','2014-03-15','17:25:00',1.03),('7643','2014-03-14','07:05:00',1.19),('7643','2014-03-14','07:10:00',1.42),('7643','2014-03-14','07:15:00',1.67),('7643','2014-03-14','07:20:00',1.92),('7643','2014-03-14','07:25:00',2.19),('7643','2014-03-14','07:30:00',2.49),('7643','2014-03-14','07:35:00',2.78),('7643','2014-03-14','07:40:00',3.07),('7643','2014-03-14','07:45:00',3.38),('7643','2014-03-14','07:50:00',3.72),('7643','2014-03-14','07:55:00',4.06),('7643','2014-03-14','08:00:00',4.45),('7643','2014-03-14','08:05:00',4.79),('7643','2014-03-14','08:10:00',5.11),('7643','2014-03-14','08:15:00',5.5),('7643','2014-03-14','08:20:00',5.83),('7643','2014-03-14','08:25:00',6.16),('7643','2014-03-14','08:30:00',6.49),('7643','2014-03-14','08:35:00',6.86),('7643','2014-03-14','08:40:00',7.18),('7643','2014-03-14','08:45:00',7.47),('7643','2014-03-14','08:50:00',7.78),('7643','2014-03-14','08:55:00',8.07),('7643','2014-03-14','09:00:00',8.4),('7643','2014-03-14','09:05:00',8.65),('7643','2014-03-14','09:10:00',9.02),('7643','2014-03-14','09:15:00',9.34),('7643','2014-03-14','09:20:00',9.62),('7643','2014-03-14','09:25:00',9.79),('7643','2014-03-14','09:30:00',10.04),('7643','2014-03-14','09:35:00',10.32),('7643','2014-03-14','09:40:00',10.52),('7643','2014-03-14','09:45:00',10.59),('7643','2014-03-14','09:50:00',10.78),('7643','2014-03-14','09:55:00',10.95),('7643','2014-03-14','10:00:00',11.17),('7643','2014-03-14','10:05:00',11.2),('7643','2014-03-14','10:10:00',11.45),('7643','2014-03-14','10:15:00',11.66),('7643','2014-03-14','10:20:00',11.68),('7643','2014-03-14','10:25:00',11.93),('7643','2014-03-14','10:30:00',12.26),('7643','2014-03-14','10:35:00',12.4),('7643','2014-03-14','10:40:00',12.59),('7643','2014-03-14','10:45:00',12.46),('7643','2014-03-14','10:50:00',13),('7643','2014-03-14','10:55:00',12.8),('7643','2014-03-14','11:00:00',12.74),('7643','2014-03-14','11:05:00',13.03),('7643','2014-03-14','11:10:00',13.27),('7643','2014-03-14','11:15:00',13.22),('7643','2014-03-14','11:20:00',13.64),('7643','2014-03-14','11:25:00',13.79),('7643','2014-03-14','11:30:00',14.1),('7643','2014-03-14','11:35:00',13.86),('7643','2014-03-14','11:40:00',13.91),('7643','2014-03-14','11:45:00',14.07),('7643','2014-03-14','11:50:00',14.15),('7643','2014-03-14','11:55:00',13.8),('7643','2014-03-14','12:00:00',13.97),('7643','2014-03-14','12:05:00',13.94),('7643','2014-03-14','12:10:00',13.96),('7643','2014-03-14','12:15:00',14.22),('7643','2014-03-14','12:20:00',14.19),('7643','2014-03-14','12:25:00',14.27),('7643','2014-03-14','12:30:00',14.45),('7643','2014-03-14','12:35:00',14.54),('7643','2014-03-14','12:40:00',14.46),('7643','2014-03-14','12:45:00',14.32),('7643','2014-03-14','12:50:00',14.3),('7643','2014-03-14','12:55:00',14.42),('7643','2014-03-14','13:00:00',14.27),('7643','2014-03-14','13:05:00',14.27),('7643','2014-03-14','13:10:00',14.31),('7643','2014-03-14','13:15:00',14.18),('7643','2014-03-14','13:20:00',14.12),('7643','2014-03-14','13:25:00',13.92),('7643','2014-03-14','13:30:00',13.89),('7643','2014-03-14','13:35:00',13.92),('7643','2014-03-14','13:40:00',13.73),('7643','2014-03-14','13:45:00',13.61),('7643','2014-03-14','13:50:00',13.25),('7643','2014-03-14','13:55:00',13.34),('7643','2014-03-14','14:00:00',13.27),('7643','2014-03-14','14:05:00',13.16),('7643','2014-03-14','14:10:00',12.98),('7643','2014-03-14','14:15:00',12.77),('7643','2014-03-14','14:20:00',12.58),('7643','2014-03-14','14:25:00',12.37),('7643','2014-03-14','14:30:00',12.16),('7643','2014-03-14','14:35:00',11.92),('7643','2014-03-14','14:40:00',11.65),('7643','2014-03-14','14:45:00',11.34),('7643','2014-03-14','14:50:00',11.01),('7643','2014-03-14','14:55:00',10.84),('7643','2014-03-14','15:00:00',10.65),('7643','2014-03-14','15:05:00',10.4),('7643','2014-03-14','15:10:00',10.09),('7643','2014-03-14','15:15:00',9.76),('7643','2014-03-14','15:20:00',9.43),('7643','2014-03-14','15:25:00',9.17),('7643','2014-03-14','15:30:00',8.78),('7643','2014-03-14','15:35:00',8.48),('7643','2014-03-14','15:40:00',8.13),('7643','2014-03-14','15:45:00',7.86),('7643','2014-03-14','15:50:00',7.51),('7643','2014-03-14','15:55:00',7.15),('7643','2014-03-14','16:00:00',6.78),('7643','2014-03-14','16:05:00',6.18),('7643','2014-03-14','16:10:00',5.99),('7643','2014-03-14','16:15:00',5.55),('7643','2014-03-14','16:20:00',5.3),('7643','2014-03-14','16:25:00',4.81),('7643','2014-03-14','16:30:00',4.54),('7643','2014-03-14','16:35:00',4.03),('7643','2014-03-14','16:40:00',3.61),('7643','2014-03-14','16:45:00',3.43),('7643','2014-03-14','16:50:00',3.04),('7643','2014-03-14','16:55:00',2.77),('7643','2014-03-14','17:00:00',2.49),('7643','2014-03-14','17:05:00',2.18),('7643','2014-03-14','17:10:00',1.92),('7643','2014-03-14','17:15:00',1.66),('7643','2014-03-14','17:20:00',1.42),('7643','2014-03-14','17:25:00',1.19),('7643','2014-03-13','07:10:00',1.07),('7643','2014-03-13','07:15:00',1.19),('7643','2014-03-13','07:20:00',1.33),('7643','2014-03-13','07:25:00',1.49),('7643','2014-03-13','07:30:00',1.7),('7643','2014-03-13','07:35:00',1.93),('7643','2014-03-13','07:40:00',2.15),('7643','2014-03-13','07:45:00',2.38),('7643','2014-03-13','07:50:00',2.6),('7643','2014-03-13','07:55:00',2.82),('7643','2014-03-13','08:00:00',3.01),('7643','2014-03-13','08:05:00',3.24),('7643','2014-03-13','08:10:00',3.58),('7643','2014-03-13','08:15:00',4.11),('7643','2014-03-13','08:20:00',4.54),('7643','2014-03-13','08:25:00',4.8),('7643','2014-03-13','08:30:00',5.18),('7643','2014-03-13','08:35:00',5.19),('7643','2014-03-13','08:40:00',4.89),('7643','2014-03-13','08:45:00',4.18),('7643','2014-03-13','08:50:00',4.05),('7643','2014-03-13','08:55:00',4.25),('7643','2014-03-13','09:00:00',4.61),('7643','2014-03-13','09:05:00',5.27),('7643','2014-03-13','09:10:00',5.84),('7643','2014-03-13','09:15:00',5.87),('7643','2014-03-13','09:20:00',5.84),('7643','2014-03-13','09:25:00',6.29),('7643','2014-03-13','09:30:00',6.28),('7643','2014-03-13','09:35:00',7.65),('7643','2014-03-13','09:40:00',9.59),('7643','2014-03-13','09:45:00',11.15),('7643','2014-03-13','09:50:00',12.96),('7643','2014-03-13','09:55:00',13.38),('7643','2014-03-13','10:00:00',14.17),('7643','2014-03-13','10:05:00',13.87),('7643','2014-03-13','10:10:00',13.61),('7643','2014-03-13','10:15:00',13.18),('7643','2014-03-13','10:20:00',12.86),('7643','2014-03-13','10:25:00',12.46),('7643','2014-03-13','10:30:00',12.45),('7643','2014-03-13','10:35:00',13.15),('7643','2014-03-13','10:40:00',13.34),('7643','2014-03-13','10:45:00',11.7),('7643','2014-03-13','10:50:00',7.4),('7643','2014-03-13','10:55:00',10.85),('7643','2014-03-13','11:00:00',13.11),('7643','2014-03-13','11:05:00',13.82),('7643','2014-03-13','11:10:00',14.94),('7643','2014-03-13','11:15:00',14.91),('7643','2014-03-13','11:20:00',14.51),('7643','2014-03-13','11:25:00',14.24),('7643','2014-03-13','11:30:00',14.38),('7643','2014-03-13','11:35:00',14.48),('7643','2014-03-13','11:40:00',14.33),('7643','2014-03-13','11:45:00',14.93),('7643','2014-03-13','11:50:00',15.09),('7643','2014-03-13','11:55:00',15.09),('7643','2014-03-13','12:00:00',15.13),('7643','2014-03-13','12:05:00',15.07),('7643','2014-03-13','12:10:00',14.27),('7643','2014-03-13','12:15:00',13.11),('7643','2014-03-13','12:20:00',10.54),('7643','2014-03-13','12:25:00',9.39),('7643','2014-03-13','12:30:00',8.69),('7643','2014-03-13','12:35:00',7.53),('7643','2014-03-13','12:40:00',9.3),('7643','2014-03-13','12:45:00',10.31),('7643','2014-03-13','12:50:00',12.45),('7643','2014-03-13','12:55:00',12.17),('7643','2014-03-13','13:00:00',8.49),('7643','2014-03-13','13:05:00',7.86),('7643','2014-03-13','13:10:00',9.33),('7643','2014-03-13','13:15:00',10.86),('7643','2014-03-13','13:20:00',11.02),('7643','2014-03-13','13:25:00',10.36),('7643','2014-03-13','13:30:00',9.45),('7643','2014-03-13','13:35:00',8.42),('7643','2014-03-13','13:40:00',7.97),('7643','2014-03-13','13:45:00',8.21),('7643','2014-03-13','13:50:00',7.9),('7643','2014-03-13','13:55:00',8.2),('7643','2014-03-13','14:00:00',9.55),('7643','2014-03-13','14:05:00',10.65),('7643','2014-03-13','14:10:00',10.34),('7643','2014-03-13','14:15:00',10.74),('7643','2014-03-13','14:20:00',11.39),('7643','2014-03-13','14:25:00',11.01),('7643','2014-03-13','14:30:00',10.08),('7643','2014-03-13','14:35:00',9.35),('7643','2014-03-13','14:40:00',7.66),('7643','2014-03-13','14:45:00',6.19),('7643','2014-03-13','14:50:00',5.51),('7643','2014-03-13','14:55:00',5.11),('7643','2014-03-13','15:00:00',4.72),('7643','2014-03-13','15:05:00',4.69),('7643','2014-03-13','15:10:00',4.52),('7643','2014-03-13','15:15:00',4.58),('7643','2014-03-13','15:20:00',4.97),('7643','2014-03-13','15:25:00',5.26),('7643','2014-03-13','15:30:00',5.85),('7643','2014-03-13','15:35:00',6.11),('7643','2014-03-13','15:40:00',5.47),('7643','2014-03-13','15:45:00',4.76),('7643','2014-03-13','15:50:00',4.32),('7643','2014-03-13','15:55:00',4.42),('7643','2014-03-13','16:00:00',4.1),('7643','2014-03-13','16:05:00',3.96),('7643','2014-03-13','16:10:00',3.51),('7643','2014-03-13','16:15:00',2.9),('7643','2014-03-13','16:20:00',2.57),('7643','2014-03-13','16:25:00',2.37),('7643','2014-03-13','16:30:00',2.27),('7643','2014-03-13','16:35:00',2.11),('7643','2014-03-13','16:40:00',1.98),('7643','2014-03-13','16:45:00',1.87),('7643','2014-03-13','16:50:00',1.77),('7643','2014-03-13','16:55:00',1.73),('7643','2014-03-13','17:00:00',1.66),('7643','2014-03-13','17:05:00',1.48),('7643','2014-03-13','17:10:00',1.34),('7643','2014-03-13','17:15:00',1.16),('7643','2014-03-12','07:00:00',1.06),('7643','2014-03-12','07:05:00',1.32),('7643','2014-03-12','07:10:00',1.61),('7643','2014-03-12','07:15:00',1.93),('7643','2014-03-12','07:20:00',2.27),('7643','2014-03-12','07:25:00',2.62),('7643','2014-03-12','07:30:00',2.96),('7643','2014-03-12','07:35:00',3.3),('7643','2014-03-12','07:40:00',3.65),('7643','2014-03-12','07:45:00',4.02),('7643','2014-03-12','07:50:00',4.4),('7643','2014-03-12','07:55:00',4.79),('7643','2014-03-12','08:00:00',5.16),('7643','2014-03-12','08:05:00',5.52),('7643','2014-03-12','08:10:00',5.89),('7643','2014-03-12','08:15:00',6.24),('7643','2014-03-12','08:20:00',6.57),('7643','2014-03-12','08:25:00',6.92),('7643','2014-03-12','08:30:00',7.19),('7643','2014-03-12','08:35:00',7.53),('7643','2014-03-12','08:40:00',7.87),('7643','2014-03-12','08:45:00',8.16),('7643','2014-03-12','08:50:00',8.45),('7643','2014-03-12','08:55:00',8.75),('7643','2014-03-12','09:00:00',9.08),('7643','2014-03-12','09:05:00',9.35),('7643','2014-03-12','09:10:00',9.63),('7643','2014-03-12','09:15:00',9.87),('7643','2014-03-12','09:20:00',10.11),('7643','2014-03-12','09:25:00',10.35),('7643','2014-03-12','09:30:00',10.6),('7643','2014-03-12','09:35:00',10.84),('7643','2014-03-12','09:40:00',11.11),('7643','2014-03-12','09:45:00',11.35),('7643','2014-03-12','09:50:00',11.54),('7643','2014-03-12','09:55:00',11.79),('7643','2014-03-12','10:00:00',12.01),('7643','2014-03-12','10:05:00',12.17),('7643','2014-03-12','10:10:00',12.34),('7643','2014-03-12','10:15:00',12.55),('7643','2014-03-12','10:20:00',12.65),('7643','2014-03-12','10:25:00',12.73),('7643','2014-03-12','10:30:00',12.93),('7643','2014-03-12','10:35:00',13.05),('7643','2014-03-12','10:40:00',13.12),('7643','2014-03-12','10:45:00',13.25),('7643','2014-03-12','10:50:00',13.31),('7643','2014-03-12','10:55:00',13.46),('7643','2014-03-12','11:00:00',13.51),('7643','2014-03-12','11:05:00',13.57),('7643','2014-03-12','11:10:00',13.71),('7643','2014-03-12','11:15:00',13.73),('7643','2014-03-12','11:20:00',13.88),('7643','2014-03-12','11:25:00',13.88),('7643','2014-03-12','11:30:00',13.88),('7643','2014-03-12','11:35:00',13.96),('7643','2014-03-12','11:40:00',13.97),('7643','2014-03-12','11:45:00',14.1),('7643','2014-03-12','11:50:00',14.14),('7643','2014-03-12','11:55:00',14.24),('7643','2014-03-12','12:00:00',14.3),('7643','2014-03-12','12:05:00',14.1),('7643','2014-03-12','12:10:00',13.96),('7643','2014-03-12','12:15:00',13.96),('7643','2014-03-12','12:20:00',13.96),('7643','2014-03-12','12:25:00',14.06),('7643','2014-03-12','12:30:00',14.08),('7643','2014-03-12','12:35:00',14.08),('7643','2014-03-12','12:40:00',13.98),('7643','2014-03-12','12:45:00',13.86),('7643','2014-03-12','12:50:00',13.78),('7643','2014-03-12','12:55:00',13.75),('7643','2014-03-12','13:00:00',13.61),('7643','2014-03-12','13:05:00',13.44),('7643','2014-03-12','13:10:00',13.22),('7643','2014-03-12','13:15:00',13.09),('7643','2014-03-12','13:20:00',13.16),('7643','2014-03-12','13:25:00',13.22),('7643','2014-03-12','13:30:00',13.19),('7643','2014-03-12','13:35:00',13.04),('7643','2014-03-12','13:40:00',12.9),('7643','2014-03-12','13:45:00',12.74),('7643','2014-03-12','13:50:00',12.54),('7643','2014-03-12','13:55:00',12.34),('7643','2014-03-12','14:00:00',12.22),('7643','2014-03-12','14:05:00',12.03),('7643','2014-03-12','14:10:00',11.91),('7643','2014-03-12','14:15:00',11.74),('7643','2014-03-12','14:20:00',11.6),('7643','2014-03-12','14:25:00',11.37),('7643','2014-03-12','14:30:00',11.15),('7643','2014-03-12','14:35:00',10.96),('7643','2014-03-12','14:40:00',10.73),('7643','2014-03-12','14:45:00',10.42),('7643','2014-03-12','14:50:00',10.25),('7643','2014-03-12','14:55:00',10),('7643','2014-03-12','15:00:00',9.73),('7643','2014-03-12','15:05:00',9.49),('7643','2014-03-12','15:10:00',9.24),('7643','2014-03-12','15:15:00',8.95),('7643','2014-03-12','15:20:00',8.72),('7643','2014-03-12','15:25:00',8.43),('7643','2014-03-12','15:30:00',8.16),('7643','2014-03-12','15:35:00',7.75),('7643','2014-03-12','15:40:00',7.18),('7643','2014-03-12','15:45:00',6.88),('7643','2014-03-12','15:50:00',6.61),('7643','2014-03-12','15:55:00',6.32),('7643','2014-03-12','16:00:00',6),('7643','2014-03-12','16:05:00',5.84),('7643','2014-03-12','16:10:00',5.49),('7643','2014-03-12','16:15:00',5.15),('7643','2014-03-12','16:20:00',4.86),('7643','2014-03-12','16:25:00',4.63),('7643','2014-03-12','16:30:00',4.36),('7643','2014-03-12','16:35:00',4.08),('7643','2014-03-12','16:40:00',3.77),('7643','2014-03-12','16:45:00',3.4),('7643','2014-03-12','16:50:00',3.1),('7643','2014-03-12','16:55:00',2.8),('7643','2014-03-12','17:00:00',2.44),('7643','2014-03-12','17:05:00',2.03),('7643','2014-03-12','17:10:00',1.57),('7643','2014-03-12','17:15:00',1.31),('7643','2014-03-12','17:20:00',1.06),('7643','2014-03-11','07:05:00',1.2),('7643','2014-03-11','07:10:00',1.48),('7643','2014-03-11','07:15:00',1.8),('7643','2014-03-11','07:20:00',2.11),('7643','2014-03-11','07:25:00',2.47),('7643','2014-03-11','07:30:00',2.82),('7643','2014-03-11','07:35:00',3.18),('7643','2014-03-11','07:40:00',3.54),('7643','2014-03-11','07:45:00',3.91),('7643','2014-03-11','07:50:00',4.26),('7643','2014-03-11','07:55:00',4.61),('7643','2014-03-11','08:00:00',4.97),('7643','2014-03-11','08:05:00',5.34),('7643','2014-03-11','08:10:00',5.71),('7643','2014-03-11','08:15:00',6.06),('7643','2014-03-11','08:20:00',6.39),('7643','2014-03-11','08:25:00',6.75),('7643','2014-03-11','08:30:00',7.07),('7643','2014-03-11','08:35:00',7.41),('7643','2014-03-11','08:40:00',7.76),('7643','2014-03-11','08:45:00',8.07),('7643','2014-03-11','08:50:00',8.38),('7643','2014-03-11','08:55:00',8.68),('7643','2014-03-11','09:00:00',8.97),('7643','2014-03-11','09:05:00',9.24),('7643','2014-03-11','09:10:00',9.54),('7643','2014-03-11','09:15:00',9.82),('7643','2014-03-11','09:20:00',10.11),('7643','2014-03-11','09:25:00',10.34),('7643','2014-03-11','09:30:00',10.57),('7643','2014-03-11','09:35:00',10.79),('7643','2014-03-11','09:40:00',11.02),('7643','2014-03-11','09:45:00',11.31),('7643','2014-03-11','09:50:00',11.48),('7643','2014-03-11','09:55:00',11.7),('7643','2014-03-11','10:00:00',11.98),('7643','2014-03-11','10:05:00',12.12),('7643','2014-03-11','10:10:00',12.33),('7643','2014-03-11','10:15:00',12.53),('7643','2014-03-11','10:20:00',12.66),('7643','2014-03-11','10:25:00',12.8),('7643','2014-03-11','10:30:00',12.98),('7643','2014-03-11','10:35:00',13.2),('7643','2014-03-11','10:40:00',13.38),('7643','2014-03-11','10:45:00',13.57),('7643','2014-03-11','10:50:00',13.69),('7643','2014-03-11','10:55:00',13.79),('7643','2014-03-11','11:00:00',13.93),('7643','2014-03-11','11:05:00',14.15),('7643','2014-03-11','11:10:00',14.28),('7643','2014-03-11','11:15:00',14.35),('7643','2014-03-11','11:20:00',14.48),('7643','2014-03-11','11:25:00',14.54),('7643','2014-03-11','11:30:00',14.6),('7643','2014-03-11','11:35:00',14.68),('7643','2014-03-11','11:40:00',14.73),('7643','2014-03-11','11:45:00',14.73),('7643','2014-03-11','11:50:00',14.75),('7643','2014-03-11','11:55:00',14.78),('7643','2014-03-11','12:00:00',14.74),('7643','2014-03-11','12:05:00',14.73),('7643','2014-03-11','12:10:00',14.7),('7643','2014-03-11','12:15:00',14.63),('7643','2014-03-11','12:20:00',14.59),('7643','2014-03-11','12:25:00',14.63),('7643','2014-03-11','12:30:00',14.57),('7643','2014-03-11','12:35:00',14.54),('7643','2014-03-11','12:40:00',14.37),('7643','2014-03-11','12:45:00',14.39),('7643','2014-03-11','12:50:00',14.29),('7643','2014-03-11','12:55:00',14.17),('7643','2014-03-11','13:00:00',14.15),('7643','2014-03-11','13:05:00',13.96),('7643','2014-03-11','13:10:00',13.87),('7643','2014-03-11','13:15:00',13.86),('7643','2014-03-11','13:20:00',13.72),('7643','2014-03-11','13:25:00',13.65),('7643','2014-03-11','13:30:00',13.44),('7643','2014-03-11','13:35:00',13.35),('7643','2014-03-11','13:40:00',13.22),('7643','2014-03-11','13:45:00',13.02),('7643','2014-03-11','13:50:00',13),('7643','2014-03-11','13:55:00',12.79),('7643','2014-03-11','14:00:00',12.64),('7643','2014-03-11','14:05:00',12.64),('7643','2014-03-11','14:10:00',12.3),('7643','2014-03-11','14:15:00',12.17),('7643','2014-03-11','14:20:00',11.97),('7643','2014-03-11','14:25:00',11.71),('7643','2014-03-11','14:30:00',11.55),('7643','2014-03-11','14:35:00',11.12),('7643','2014-03-11','14:40:00',10.82),('7643','2014-03-11','14:45:00',10.51),('7643','2014-03-11','14:50:00',10.34),('7643','2014-03-11','14:55:00',9.85),('7643','2014-03-11','15:00:00',9.52),('7643','2014-03-11','15:05:00',9.42),('7643','2014-03-11','15:10:00',9.18),('7643','2014-03-11','15:15:00',8.9),('7643','2014-03-11','15:20:00',8.7),('7643','2014-03-11','15:25:00',8.38),('7643','2014-03-11','15:30:00',7.94),('7643','2014-03-11','15:35:00',7.66),('7643','2014-03-11','15:40:00',7.47),('7643','2014-03-11','15:45:00',7.19),('7643','2014-03-11','15:50:00',6.95),('7643','2014-03-11','15:55:00',6.68),('7643','2014-03-11','16:00:00',6.45),('7643','2014-03-11','16:05:00',6),('7643','2014-03-11','16:10:00',5.65),('7643','2014-03-11','16:15:00',5.35),('7643','2014-03-11','16:20:00',5.03),('7643','2014-03-11','16:25:00',4.63),('7643','2014-03-11','16:30:00',4.28),('7643','2014-03-11','16:35:00',4),('7643','2014-03-11','16:40:00',3.68),('7643','2014-03-11','16:45:00',3.32),('7643','2014-03-11','16:50:00',2.96),('7643','2014-03-11','16:55:00',2.63),('7643','2014-03-11','17:00:00',2.32),('7643','2014-03-11','17:05:00',1.99),('7643','2014-03-11','17:10:00',1.72),('7643','2014-03-11','17:15:00',1.47),('7643','2014-03-11','17:20:00',1.22),('7643','2014-03-10','07:25:00',1.25),('7643','2014-03-10','07:30:00',1.34),('7643','2014-03-10','07:35:00',1.43),('7643','2014-03-10','07:40:00',1.71),('7643','2014-03-10','07:45:00',1.97),('7643','2014-03-10','07:50:00',1.94),('7643','2014-03-10','07:55:00',2.02),('7643','2014-03-10','08:00:00',2.08),('7643','2014-03-10','08:05:00',1.67),('7643','2014-03-10','08:10:00',1.35),('7643','2014-03-10','08:15:00',1.5),('7643','2014-03-10','08:20:00',1.67),('7643','2014-03-10','08:25:00',1.55),('7643','2014-03-10','08:30:00',1.6),('7643','2014-03-10','08:35:00',1.37),('7643','2014-03-10','08:40:00',1.12),('7643','2014-03-10','08:45:00',1.26),('7643','2014-03-10','08:50:00',1.51),('7643','2014-03-10','08:55:00',1.62),('7643','2014-03-10','09:00:00',1.61),('7643','2014-03-10','09:05:00',1.54),('7643','2014-03-10','09:10:00',1.54),('7643','2014-03-10','09:15:00',1.48),('7643','2014-03-10','09:20:00',1.4),('7643','2014-03-10','09:25:00',1.33),('7643','2014-03-10','09:30:00',1.33),('7643','2014-03-10','09:35:00',1.3),('7643','2014-03-10','09:40:00',1.26),('7643','2014-03-10','09:45:00',1.2),('7643','2014-03-10','09:50:00',1.26),('7643','2014-03-10','09:55:00',1.37),('7643','2014-03-10','10:00:00',1.44),('7643','2014-03-10','10:05:00',1.71),('7643','2014-03-10','10:10:00',2.03),('7643','2014-03-10','10:15:00',2.52),('7643','2014-03-10','10:20:00',3.08),('7643','2014-03-10','10:25:00',3.14),('7643','2014-03-10','10:30:00',3.23),('7643','2014-03-10','10:35:00',3.31),('7643','2014-03-10','10:40:00',3.25),('7643','2014-03-10','10:45:00',3.02),('7643','2014-03-10','10:50:00',2.68),('7643','2014-03-10','10:55:00',2.84),('7643','2014-03-10','11:00:00',3.29),('7643','2014-03-10','11:05:00',3.39),('7643','2014-03-10','11:10:00',3.44),('7643','2014-03-10','11:15:00',3.54),('7643','2014-03-10','11:20:00',3.21),('7643','2014-03-10','11:25:00',3.24),('7643','2014-03-10','11:30:00',3.25),('7643','2014-03-10','11:35:00',3.6),('7643','2014-03-10','11:40:00',3.81),('7643','2014-03-10','11:45:00',3.82),('7643','2014-03-10','11:50:00',3.27),('7643','2014-03-10','11:55:00',3.55),('7643','2014-03-10','12:00:00',3.74),('7643','2014-03-10','12:05:00',3.79),('7643','2014-03-10','12:10:00',4),('7643','2014-03-10','12:15:00',4.44),('7643','2014-03-10','12:20:00',4.78),('7643','2014-03-10','12:25:00',4.34),('7643','2014-03-10','12:30:00',4.13),('7643','2014-03-10','12:35:00',4.37),('7643','2014-03-10','12:40:00',4.72),('7643','2014-03-10','12:45:00',4.53),('7643','2014-03-10','12:50:00',4.46),('7643','2014-03-10','12:55:00',4.18),('7643','2014-03-10','13:00:00',3.77),('7643','2014-03-10','13:05:00',4.41),('7643','2014-03-10','13:10:00',4.61),('7643','2014-03-10','13:15:00',4.51),('7643','2014-03-10','13:20:00',4.55),('7643','2014-03-10','13:25:00',3.88),('7643','2014-03-10','13:30:00',3.81),('7643','2014-03-10','13:35:00',3.6),('7643','2014-03-10','13:40:00',3.73),('7643','2014-03-10','13:45:00',4.83),('7643','2014-03-10','13:50:00',5.81),('7643','2014-03-10','13:55:00',6.89),('7643','2014-03-10','14:00:00',6.94),('7643','2014-03-10','14:05:00',7.32),('7643','2014-03-10','14:10:00',8.97),('7643','2014-03-10','14:15:00',9.61),('7643','2014-03-10','14:20:00',7.56),('7643','2014-03-10','14:25:00',6.9),('7643','2014-03-10','14:30:00',4.76),('7643','2014-03-10','14:35:00',4.91),('7643','2014-03-10','14:40:00',4.84),('7643','2014-03-10','14:45:00',4.98),('7643','2014-03-10','14:50:00',4.61),('7643','2014-03-10','14:55:00',4.72),('7643','2014-03-10','15:00:00',5.56),('7643','2014-03-10','15:05:00',6.22),('7643','2014-03-10','15:10:00',6.54),('7643','2014-03-10','15:15:00',5.41),('7643','2014-03-10','15:20:00',5.07),('7643','2014-03-10','15:25:00',4.56),('7643','2014-03-10','15:30:00',4.39),('7643','2014-03-10','15:35:00',3.94),('7643','2014-03-10','15:40:00',3.93),('7643','2014-03-10','15:45:00',3.71),('7643','2014-03-10','15:50:00',3.73),('7643','2014-03-10','15:55:00',3.13),('7643','2014-03-10','16:00:00',2.83),('7643','2014-03-10','16:05:00',2.82),('7643','2014-03-10','16:10:00',2.89),('7643','2014-03-10','16:15:00',2.75),('7643','2014-03-10','16:20:00',2.71),('7643','2014-03-10','16:25:00',2.38),('7643','2014-03-10','16:30:00',2.16),('7643','2014-03-10','16:35:00',1.9),('7643','2014-03-10','16:40:00',1.72),('7643','2014-03-10','16:45:00',1.49),('7643','2014-03-10','16:50:00',1.27),('7643','2014-03-10','16:55:00',1.04),('7643','2014-03-09','07:55:00',1.01),('7643','2014-03-09','08:00:00',1.26),('7643','2014-03-09','08:05:00',1.58),('7643','2014-03-09','08:10:00',1.83),('7643','2014-03-09','08:15:00',2.02),('7643','2014-03-09','08:20:00',2.17),('7643','2014-03-09','08:25:00',2.37),('7643','2014-03-09','08:30:00',2.6),('7643','2014-03-09','08:35:00',3.02),('7643','2014-03-09','08:40:00',3.26),('7643','2014-03-09','08:45:00',3.21),('7643','2014-03-09','08:50:00',3.33),('7643','2014-03-09','08:55:00',3.33),('7643','2014-03-09','09:00:00',3.44),('7643','2014-03-09','09:05:00',3.77),('7643','2014-03-09','09:10:00',3.86),('7643','2014-03-09','09:15:00',3.48),('7643','2014-03-09','09:20:00',3.4),('7643','2014-03-09','09:25:00',3.46),('7643','2014-03-09','09:30:00',3.66),('7643','2014-03-09','09:35:00',3.5),('7643','2014-03-09','09:40:00',3.57),('7643','2014-03-09','09:45:00',3.28),('7643','2014-03-09','09:50:00',2.88),('7643','2014-03-09','09:55:00',2.76),('7643','2014-03-09','10:00:00',2.47),('7643','2014-03-09','10:05:00',2.66),('7643','2014-03-09','10:10:00',3.41),('7643','2014-03-09','10:15:00',4),('7643','2014-03-09','10:20:00',3.35),('7643','2014-03-09','10:25:00',3.23),('7643','2014-03-09','10:30:00',3.96),('7643','2014-03-09','10:35:00',4.49),('7643','2014-03-09','10:40:00',3.13),('7643','2014-03-09','10:45:00',1.98),('7643','2014-03-09','10:50:00',1.32),('7643','2014-03-09','10:55:00',1.29),('7643','2014-03-09','11:00:00',1.45),('7643','2014-03-09','11:05:00',1.95),('7643','2014-03-09','11:10:00',2.58),('7643','2014-03-09','11:15:00',3.15),('7643','2014-03-09','11:20:00',3.52),('7643','2014-03-09','11:25:00',3.24),('7643','2014-03-09','11:30:00',2.8),('7643','2014-03-09','11:35:00',1.84),('7643','2014-03-09','11:40:00',1.33),('7643','2014-03-09','11:45:00',1.27),('7643','2014-03-09','11:50:00',1.34),('7643','2014-03-09','11:55:00',1.28),('7643','2014-03-09','12:00:00',1.34),('7643','2014-03-09','12:05:00',1.62),('7643','2014-03-09','12:10:00',1.75),('7643','2014-03-09','12:15:00',1.87),('7643','2014-03-09','12:20:00',2.03),('7643','2014-03-09','12:25:00',2.18),('7643','2014-03-09','12:30:00',2.47),('7643','2014-03-09','12:35:00',2.83),('7643','2014-03-09','12:40:00',3.2),('7643','2014-03-09','12:45:00',3.68),('7643','2014-03-09','12:50:00',4.08),('7643','2014-03-09','12:55:00',4.37),('7643','2014-03-09','13:00:00',4.61),('7643','2014-03-09','13:05:00',4.76),('7643','2014-03-09','13:10:00',5.51),('7643','2014-03-09','13:15:00',6.43),('7643','2014-03-09','13:20:00',5.84),('7643','2014-03-09','13:25:00',5.24),('7643','2014-03-09','13:30:00',4.43),('7643','2014-03-09','13:35:00',3.7),('7643','2014-03-09','13:40:00',3.31),('7643','2014-03-09','13:45:00',3.08),('7643','2014-03-09','13:50:00',4.44),('7643','2014-03-09','13:55:00',3.71),('7643','2014-03-09','14:00:00',3.78),('7643','2014-03-09','14:05:00',5.53),('7643','2014-03-09','14:10:00',6.47),('7643','2014-03-09','14:15:00',9.5),('7643','2014-03-09','14:20:00',6.1),('7643','2014-03-09','14:25:00',5.74),('7643','2014-03-09','14:30:00',4.86),('7643','2014-03-09','14:35:00',8.89),('7643','2014-03-09','14:40:00',10.47),('7643','2014-03-09','14:45:00',7.8),('7643','2014-03-09','14:50:00',8.05),('7643','2014-03-09','14:55:00',5.6),('7643','2014-03-09','15:00:00',5.82),('7643','2014-03-09','15:05:00',4.19),('7643','2014-03-09','15:10:00',3.55),('7643','2014-03-09','15:15:00',4.24),('7643','2014-03-09','15:20:00',8.3),('7643','2014-03-09','15:25:00',7.79),('7643','2014-03-09','15:30:00',4.95),('7643','2014-03-09','15:35:00',4.22),('7643','2014-03-09','15:40:00',4.31),('7643','2014-03-09','15:45:00',3.64),('7643','2014-03-09','15:50:00',3.3),('7643','2014-03-09','15:55:00',3.19),('7643','2014-03-09','16:00:00',3.5),('7643','2014-03-09','16:05:00',3.66),('7643','2014-03-09','16:10:00',2.93),('7643','2014-03-09','16:15:00',2.66),('7643','2014-03-09','16:20:00',2.78),('7643','2014-03-09','16:25:00',3.33),('7643','2014-03-09','16:30:00',3.56),('7643','2014-03-09','16:35:00',2.31),('7643','2014-03-09','16:40:00',1.85),('7643','2014-03-09','16:45:00',1.44),('7643','2014-03-09','16:50:00',1.85),('7643','2014-03-09','16:55:00',2.83),('7643','2014-03-09','17:00:00',2.23),('7643','2014-03-09','17:05:00',1.43),('7643','2014-03-08','07:35:00',1.73),('7643','2014-03-08','07:40:00',2.51),('7643','2014-03-08','07:45:00',2.5),('7643','2014-03-08','07:50:00',3.86),('7643','2014-03-08','07:55:00',4.24),('7643','2014-03-08','08:00:00',4.63),('7643','2014-03-08','08:05:00',4.98),('7643','2014-03-08','08:10:00',5.37),('7643','2014-03-08','08:15:00',5.6),('7643','2014-03-08','08:20:00',4.28),('7643','2014-03-08','08:25:00',3.44),('7643','2014-03-08','08:30:00',4.25),('7643','2014-03-08','08:35:00',4.48),('7643','2014-03-08','08:40:00',4.79),('7643','2014-03-08','08:45:00',2.65),('7643','2014-03-08','08:50:00',4.55),('7643','2014-03-08','08:55:00',5.87),('7643','2014-03-08','09:00:00',7.16),('7643','2014-03-08','09:05:00',5.38),('7643','2014-03-08','09:10:00',2.04),('7643','2014-03-08','09:15:00',5.06),('7643','2014-03-08','09:20:00',10.13),('7643','2014-03-08','09:25:00',10.66),('7643','2014-03-08','09:30:00',7.89),('7643','2014-03-08','09:35:00',9.23),('7643','2014-03-08','09:40:00',11.92),('7643','2014-03-08','09:45:00',12.11),('7643','2014-03-08','09:50:00',12.25),('7643','2014-03-08','09:55:00',12.22),('7643','2014-03-08','10:00:00',12.33),('7643','2014-03-08','10:05:00',12.52),('7643','2014-03-08','10:10:00',12.83),('7643','2014-03-08','10:15:00',12.9),('7643','2014-03-08','10:20:00',12.89),('7643','2014-03-08','10:25:00',12.16),('7643','2014-03-08','10:30:00',13.45),('7643','2014-03-08','10:35:00',13.55),('7643','2014-03-08','10:40:00',13.73),('7643','2014-03-08','10:45:00',13.83),('7643','2014-03-08','10:50:00',14),('7643','2014-03-08','10:55:00',14.65),('7643','2014-03-08','11:00:00',14.04),('7643','2014-03-08','11:05:00',14.31),('7643','2014-03-08','11:10:00',16.07),('7643','2014-03-08','11:15:00',16.87),('7643','2014-03-08','11:20:00',14.6),('7643','2014-03-08','11:25:00',9.67),('7643','2014-03-08','11:30:00',7.36),('7643','2014-03-08','11:35:00',15.33),('7643','2014-03-08','11:40:00',7.71),('7643','2014-03-08','11:45:00',8.57),('7643','2014-03-08','11:50:00',12.37),('7643','2014-03-08','11:55:00',14.95),('7643','2014-03-08','12:00:00',14.09),('7643','2014-03-08','12:05:00',17.49),('7643','2014-03-08','12:10:00',17.26),('7643','2014-03-08','12:15:00',16.92),('7643','2014-03-08','12:20:00',16.69),('7643','2014-03-08','12:25:00',16.43),('7643','2014-03-08','12:30:00',16.53),('7643','2014-03-08','12:35:00',16.87),('7643','2014-03-08','12:40:00',16.21),('7643','2014-03-08','12:45:00',15.97),('7643','2014-03-08','12:50:00',16.14),('7643','2014-03-08','12:55:00',16.19),('7643','2014-03-08','13:00:00',16.43),('7643','2014-03-08','13:05:00',16.37),('7643','2014-03-08','13:10:00',16.14),('7643','2014-03-08','13:15:00',14.96),('7643','2014-03-08','13:20:00',14.81),('7643','2014-03-08','13:25:00',14.88),('7643','2014-03-08','13:30:00',14.71),('7643','2014-03-08','13:35:00',11.63),('7643','2014-03-08','13:40:00',2.89),('7643','2014-03-08','13:45:00',3.02),('7643','2014-03-08','13:50:00',4.55),('7643','2014-03-08','13:55:00',10.99),('7643','2014-03-08','14:00:00',14.21),('7643','2014-03-08','14:05:00',13.51),('7643','2014-03-08','14:10:00',13.25),('7643','2014-03-08','14:15:00',11.58),('7643','2014-03-08','14:20:00',11.83),('7643','2014-03-08','14:25:00',7.71),('7643','2014-03-08','14:30:00',3.79),('7643','2014-03-08','14:35:00',5.39),('7643','2014-03-08','14:40:00',9.39),('7643','2014-03-08','14:45:00',12.09),('7643','2014-03-08','14:50:00',11.51),('7643','2014-03-08','14:55:00',11.09),('7643','2014-03-08','15:00:00',10.7),('7643','2014-03-08','15:05:00',7.25),('7643','2014-03-08','15:10:00',9.72),('7643','2014-03-08','15:15:00',9.72),('7643','2014-03-08','15:20:00',9.42),('7643','2014-03-08','15:25:00',9.33),('7643','2014-03-08','15:30:00',9.19),('7643','2014-03-08','15:35:00',8.62),('7643','2014-03-08','15:40:00',8.2),('7643','2014-03-08','15:45:00',5.58),('7643','2014-03-08','15:50:00',4.3),('7643','2014-03-08','15:55:00',7.09),('7643','2014-03-08','16:00:00',6.95),('7643','2014-03-08','16:05:00',6.27),('7643','2014-03-08','16:10:00',4.76),('7643','2014-03-08','16:15:00',2.87),('7643','2014-03-08','16:20:00',3.73),('7643','2014-03-08','16:25:00',4.5),('7643','2014-03-08','16:30:00',4.44),('7643','2014-03-08','16:35:00',4.24),('7643','2014-03-08','16:40:00',4.03),('7643','2014-03-08','16:45:00',3.43),('7643','2014-03-08','16:50:00',3.03),('7643','2014-03-08','16:55:00',2.67),('7643','2014-03-08','17:00:00',2.24),('7643','2014-03-08','17:05:00',1.77),('7643','2014-03-08','17:10:00',1.64),('7643','2014-03-08','17:15:00',1.38),('7643','2014-03-08','17:20:00',1.12),('7643','2014-03-07','07:10:00',1.17),('7643','2014-03-07','07:15:00',1.47),('7643','2014-03-07','07:20:00',1.8),('7643','2014-03-07','07:25:00',2.14),('7643','2014-03-07','07:30:00',2.47),('7643','2014-03-07','07:35:00',2.83),('7643','2014-03-07','07:40:00',3.17),('7643','2014-03-07','07:45:00',3.51),('7643','2014-03-07','07:50:00',3.87),('7643','2014-03-07','07:55:00',4.21),('7643','2014-03-07','08:00:00',4.6),('7643','2014-03-07','08:05:00',4.92),('7643','2014-03-07','08:10:00',5.29),('7643','2014-03-07','08:15:00',5.65),('7643','2014-03-07','08:20:00',6.03),('7643','2014-03-07','08:25:00',6.39),('7643','2014-03-07','08:30:00',6.72),('7643','2014-03-07','08:35:00',7.05),('7643','2014-03-07','08:40:00',7.39),('7643','2014-03-07','08:45:00',7.71),('7643','2014-03-07','08:50:00',8.07),('7643','2014-03-07','08:55:00',8.39),('7643','2014-03-07','09:00:00',8.68),('7643','2014-03-07','09:05:00',8.96),('7643','2014-03-07','09:10:00',9.28),('7643','2014-03-07','09:15:00',9.58),('7643','2014-03-07','09:20:00',9.87),('7643','2014-03-07','09:25:00',10.13),('7643','2014-03-07','09:30:00',10.36),('7643','2014-03-07','09:35:00',10.59),('7643','2014-03-07','09:40:00',10.83),('7643','2014-03-07','09:45:00',11.09),('7643','2014-03-07','09:50:00',11.37),('7643','2014-03-07','09:55:00',11.57),('7643','2014-03-07','10:00:00',11.73),('7643','2014-03-07','10:05:00',11.92),('7643','2014-03-07','10:10:00',12.14),('7643','2014-03-07','10:15:00',12.42),('7643','2014-03-07','10:20:00',12.6),('7643','2014-03-07','10:25:00',12.82),('7643','2014-03-07','10:30:00',13.05),('7643','2014-03-07','10:35:00',13.25),('7643','2014-03-07','10:40:00',13.4),('7643','2014-03-07','10:45:00',13.55),('7643','2014-03-07','10:50:00',13.65),('7643','2014-03-07','10:55:00',13.73),('7643','2014-03-07','11:00:00',13.81),('7643','2014-03-07','11:05:00',13.86),('7643','2014-03-07','11:10:00',14.05),('7643','2014-03-07','11:15:00',14.28),('7643','2014-03-07','11:20:00',14.5),('7643','2014-03-07','11:25:00',14.92),('7643','2014-03-07','11:30:00',15.71),('7643','2014-03-07','11:35:00',12.97),('7643','2014-03-07','11:40:00',9.82),('7643','2014-03-07','11:45:00',5.2),('7643','2014-03-07','11:50:00',6.07),('7643','2014-03-07','11:55:00',13.97),('7643','2014-03-07','12:00:00',4.74),('7643','2014-03-07','12:05:00',3.77),('7643','2014-03-07','12:10:00',3.82),('7643','2014-03-07','12:15:00',4.2),('7643','2014-03-07','12:20:00',4.95),('7643','2014-03-07','12:25:00',5.43),('7643','2014-03-07','12:30:00',6.4),('7643','2014-03-07','12:35:00',13.18),('7643','2014-03-07','12:40:00',7.94),('7643','2014-03-07','12:45:00',8.42),('7643','2014-03-07','12:50:00',11.83),('7643','2014-03-07','12:55:00',13.22),('7643','2014-03-07','13:00:00',6.45),('7643','2014-03-07','13:05:00',5.79),('7643','2014-03-07','13:10:00',4.95),('7643','2014-03-07','13:15:00',3.89),('7643','2014-03-07','13:20:00',3.43),('7643','2014-03-07','13:25:00',4.13),('7643','2014-03-07','13:30:00',8.33),('7643','2014-03-07','13:35:00',6.62),('7643','2014-03-07','13:40:00',10.71),('7643','2014-03-07','13:45:00',9.44),('7643','2014-03-07','13:50:00',6.46),('7643','2014-03-07','13:55:00',4.67),('7643','2014-03-07','14:00:00',3.74),('7643','2014-03-07','14:05:00',3.6),('7643','2014-03-07','14:10:00',3.28),('7643','2014-03-07','14:15:00',2.73),('7643','2014-03-07','14:20:00',2.66),('7643','2014-03-07','14:25:00',2.58),('7643','2014-03-07','14:30:00',2.89),('7643','2014-03-07','14:35:00',3.43),('7643','2014-03-07','14:40:00',3.73),('7643','2014-03-07','14:45:00',3.43),('7643','2014-03-07','14:50:00',3.53),('7643','2014-03-07','14:55:00',3.64),('7643','2014-03-07','15:00:00',3.1),('7643','2014-03-07','15:05:00',2.86),('7643','2014-03-07','15:10:00',3.11),('7643','2014-03-07','15:15:00',4.32),('7643','2014-03-07','15:20:00',6.67),('7643','2014-03-07','15:25:00',7.09),('7643','2014-03-07','15:30:00',5.35),('7643','2014-03-07','15:35:00',2.48),('7643','2014-03-07','15:40:00',2.33),('7643','2014-03-07','15:45:00',2.42),('7643','2014-03-07','15:50:00',2.94),('7643','2014-03-07','15:55:00',3.25),('7643','2014-03-07','16:00:00',4.62),('7643','2014-03-07','16:05:00',4.29),('7643','2014-03-07','16:10:00',2.34),('7643','2014-03-07','16:15:00',2.5),('7643','2014-03-07','16:20:00',2.64),('7643','2014-03-07','16:25:00',2.53),('7643','2014-03-07','16:30:00',4.71),('7643','2014-03-07','16:35:00',4.56),('7643','2014-03-07','16:40:00',3.85),('7643','2014-03-07','16:45:00',3.5),('7643','2014-03-07','16:50:00',3.17),('7643','2014-03-07','16:55:00',2.76),('7643','2014-03-07','17:00:00',2.43),('7643','2014-03-07','17:05:00',2.08),('7643','2014-03-07','17:10:00',1.77),('7643','2014-03-07','17:15:00',1.51),('7643','2014-03-07','17:20:00',1.2),('7643','2014-04-29','07:00:00',1.15),('7643','2014-04-29','07:05:00',1.35),('7643','2014-04-29','07:10:00',1.6),('7643','2014-04-29','07:15:00',1.92),('7643','2014-04-29','07:20:00',2.17),('7643','2014-04-29','07:25:00',2.47),('7643','2014-04-29','07:30:00',2.86),('7643','2014-04-29','07:35:00',3.19),('7643','2014-04-29','07:40:00',3.56),('7643','2014-04-29','07:45:00',3.98),('7643','2014-04-29','07:50:00',4.38),('7643','2014-04-29','07:55:00',4.74),('7643','2014-04-29','08:00:00',5.16),('7643','2014-04-29','08:05:00',5.52),('7643','2014-04-29','08:10:00',6.07),('7643','2014-04-29','08:15:00',6.36),('7643','2014-04-29','08:20:00',6.73),('7643','2014-04-29','08:25:00',7.04),('7643','2014-04-29','08:30:00',7.4),('7643','2014-04-29','08:35:00',7.76),('7643','2014-04-29','08:40:00',8.01),('7643','2014-04-29','08:45:00',8.11),('7643','2014-04-29','08:50:00',8.74),('7643','2014-04-29','08:55:00',9.32),('7643','2014-04-29','09:00:00',9.58),('7643','2014-04-29','09:05:00',9.96),('7643','2014-04-29','09:10:00',10.77),('7643','2014-04-29','09:15:00',12.32),('7643','2014-04-29','09:20:00',7.06),('7643','2014-04-29','09:25:00',6.24),('7643','2014-04-29','09:30:00',4.42),('7643','2014-04-29','09:35:00',5.88),('7643','2014-04-29','09:40:00',12.83),('7643','2014-04-29','09:45:00',12.65),('7643','2014-04-29','09:50:00',8.91),('7643','2014-04-29','09:55:00',10.6),('7643','2014-04-29','10:00:00',14.11),('7643','2014-04-29','10:05:00',15.59),('7643','2014-04-29','10:10:00',5.18),('7643','2014-04-29','10:15:00',12.09),('7643','2014-04-29','10:20:00',7.97),('7643','2014-04-29','10:25:00',7.41),('7643','2014-04-29','10:30:00',7.51),('7643','2014-04-29','10:35:00',8.39),('7643','2014-04-29','10:40:00',8.4),('7643','2014-04-29','10:45:00',7.05),('7643','2014-04-29','10:50:00',6.23),('7643','2014-04-29','10:55:00',16.08),('7643','2014-04-29','11:00:00',15.86),('7643','2014-04-29','11:05:00',11.96),('7643','2014-04-29','11:10:00',12.24),('7643','2014-04-29','11:15:00',9.35),('7643','2014-04-29','11:20:00',6.46),('7643','2014-04-29','11:25:00',7.97),('7643','2014-04-29','11:30:00',9.59),('7643','2014-04-29','11:35:00',8.01),('7643','2014-04-29','11:40:00',12.36),('7643','2014-04-29','11:45:00',6.84),('7643','2014-04-29','11:50:00',11.51),('7643','2014-04-29','11:55:00',10.58),('7643','2014-04-29','12:00:00',15.08),('7643','2014-04-29','12:05:00',6.31),('7643','2014-04-29','12:10:00',5.98),('7643','2014-04-29','12:15:00',7.54),('7643','2014-04-29','12:20:00',8.17),('7643','2014-04-29','12:25:00',6.57),('7643','2014-04-29','12:30:00',9.07),('7643','2014-04-29','12:35:00',6.29),('7643','2014-04-29','12:40:00',7.1),('7643','2014-04-29','12:45:00',6.05),('7643','2014-04-29','12:50:00',6.89),('7643','2014-04-29','12:55:00',15.53),('7643','2014-04-29','13:00:00',17.85),('7643','2014-04-29','13:05:00',12.46),('7643','2014-04-29','13:10:00',13.88),('7643','2014-04-29','13:15:00',9.08),('7643','2014-04-29','13:20:00',9.01),('7643','2014-04-29','13:25:00',9.32),('7643','2014-04-29','13:30:00',9.24),('7643','2014-04-29','13:35:00',8.4),('7643','2014-04-29','13:40:00',11.59),('7643','2014-04-29','13:45:00',13.21),('7643','2014-04-29','13:50:00',9.6),('7643','2014-04-29','13:55:00',15.95),('7643','2014-04-29','14:00:00',8.98),('7643','2014-04-29','14:05:00',8.99),('7643','2014-04-29','14:10:00',6.33),('7643','2014-04-29','14:15:00',6.99),('7643','2014-04-29','14:20:00',11.91),('7643','2014-04-29','14:25:00',13.66),('7643','2014-04-29','14:30:00',18.57),('7643','2014-04-29','14:35:00',16.88),('7643','2014-04-29','14:40:00',9.42),('7643','2014-04-29','14:45:00',6.1),('7643','2014-04-29','14:50:00',6.26),('7643','2014-04-29','14:55:00',7.05),('7643','2014-04-29','15:00:00',6.02),('7643','2014-04-29','15:05:00',5.77),('7643','2014-04-29','15:10:00',5.47),('7643','2014-04-29','15:15:00',5.16),('7643','2014-04-29','15:20:00',4.45),('7643','2014-04-29','15:25:00',4.64),('7643','2014-04-29','15:30:00',6.77),('7643','2014-04-29','15:35:00',10.69),('7643','2014-04-29','15:40:00',13.08),('7643','2014-04-29','15:45:00',14.65),('7643','2014-04-29','15:50:00',17.29),('7643','2014-04-29','15:55:00',9.26),('7643','2014-04-29','16:00:00',6.28),('7643','2014-04-29','16:05:00',8.55),('7643','2014-04-29','16:10:00',6.99),('7643','2014-04-29','16:15:00',10.5),('7643','2014-04-29','16:20:00',9.15),('7643','2014-04-29','16:25:00',7.17),('7643','2014-04-29','16:30:00',14.03),('7643','2014-04-29','16:35:00',5.1),('7643','2014-04-29','16:40:00',12.18),('7643','2014-04-29','16:45:00',7.16),('7643','2014-04-29','16:50:00',6.58),('7643','2014-04-29','16:55:00',8.2),('7643','2014-04-29','17:00:00',7.93),('7643','2014-04-29','17:05:00',10.54),('7643','2014-04-29','17:10:00',7.19),('7643','2014-04-29','17:15:00',8.49),('7643','2014-04-29','17:20:00',4.31),('7643','2014-04-29','17:25:00',2.42),('7643','2014-04-29','17:30:00',3.23),('7643','2014-04-29','17:35:00',5.14),('7643','2014-04-29','17:40:00',5.06),('7643','2014-04-29','17:45:00',3.09),('7643','2014-04-29','17:50:00',3.04),('7643','2014-04-29','17:55:00',2.65),('7643','2014-04-29','18:00:00',2.4),('7643','2014-04-29','18:05:00',1.76),('7643','2014-04-29','18:10:00',2.04),('7643','2014-04-29','18:15:00',1.38),('7643','2014-04-29','18:25:00',1.38),('7643','2014-04-29','18:30:00',1.63),('7643','2014-04-29','18:35:00',2.03),('7643','2014-04-29','18:40:00',1.94),('7643','2014-04-29','18:45:00',2.11),('7643','2014-04-29','18:50:00',1.96),('7643','2014-04-29','18:55:00',1.39),('7643','2014-04-29','19:00:00',1.16),('7643','2014-04-29','19:05:00',1.29),('7643','2014-04-29','19:10:00',1.32),('7643','2014-03-06','07:45:00',1.38),('7643','2014-03-06','07:50:00',1.41),('7643','2014-03-06','08:15:00',1),('7643','2014-03-06','08:45:00',1.28),('7643','2014-03-06','08:50:00',1.33),('7643','2014-03-06','08:55:00',1.45),('7643','2014-03-06','09:00:00',1.48),('7643','2014-03-06','09:05:00',1.15),('7643','2014-03-06','09:10:00',1.01),('7643','2014-03-06','09:15:00',1.02),('7643','2014-03-06','09:20:00',1.42),('7643','2014-03-06','09:25:00',1.78),('7643','2014-03-06','09:30:00',2.03),('7643','2014-03-06','09:35:00',2.51),('7643','2014-03-06','09:40:00',2.06),('7643','2014-03-06','09:45:00',1.47),('7643','2014-03-06','09:50:00',1.82),('7643','2014-03-06','09:55:00',2.36),('7643','2014-03-06','10:00:00',2.04),('7643','2014-03-06','10:05:00',2.19),('7643','2014-03-06','10:10:00',2.26),('7643','2014-03-06','10:15:00',2.23),('7643','2014-03-06','10:20:00',2.38),('7643','2014-03-06','10:25:00',1.96),('7643','2014-03-06','10:30:00',2.45),('7643','2014-03-06','10:35:00',2.89),('7643','2014-03-06','10:40:00',2.44),('7643','2014-03-06','10:45:00',2.24),('7643','2014-03-06','10:50:00',2.31),('7643','2014-03-06','10:55:00',2.5),('7643','2014-03-06','11:00:00',2.88),('7643','2014-03-06','11:05:00',2.45),('7643','2014-03-06','11:10:00',2.13),('7643','2014-03-06','11:15:00',2.3),('7643','2014-03-06','11:20:00',2.87),('7643','2014-03-06','11:25:00',2.88),('7643','2014-03-06','11:30:00',3.54),('7643','2014-03-06','11:35:00',3.19),('7643','2014-03-06','11:40:00',3.13),('7643','2014-03-06','11:45:00',8.58),('7643','2014-03-06','11:50:00',14.04),('7643','2014-03-06','11:55:00',16.04),('7643','2014-03-06','12:00:00',17.8),('7643','2014-03-06','12:05:00',16.8),('7643','2014-03-06','12:10:00',16.75),('7643','2014-03-06','12:15:00',16.03),('7643','2014-03-06','12:20:00',16.31),('7643','2014-03-06','12:25:00',16.17),('7643','2014-03-06','12:30:00',16.45),('7643','2014-03-06','12:35:00',15.8),('7643','2014-03-06','12:40:00',11.3),('7643','2014-03-06','12:45:00',12.62),('7643','2014-03-06','12:50:00',6.9),('7643','2014-03-06','12:55:00',2.94),('7643','2014-03-06','13:00:00',6.86),('7643','2014-03-06','13:05:00',12.61),('7643','2014-03-06','13:10:00',4.85),('7643','2014-03-06','13:15:00',4.95),('7643','2014-03-06','13:20:00',10.31),('7643','2014-03-06','13:25:00',13.25),('7643','2014-03-06','13:30:00',10.16),('7643','2014-03-06','13:35:00',11.18),('7643','2014-03-06','13:40:00',12.06),('7643','2014-03-06','13:45:00',9.11),('7643','2014-03-06','13:50:00',5.06),('7643','2014-03-06','13:55:00',4.15),('7643','2014-03-06','14:00:00',4.02),('7643','2014-03-06','14:05:00',3.91),('7643','2014-03-06','14:10:00',3.92),('7643','2014-03-06','14:15:00',3.82),('7643','2014-03-06','14:20:00',3.61),('7643','2014-03-06','14:25:00',3.55),('7643','2014-03-06','14:30:00',3.73),('7643','2014-03-06','14:35:00',3.94),('7643','2014-03-06','14:40:00',4.08),('7643','2014-03-06','14:45:00',3.91),('7643','2014-03-06','14:50:00',5.1),('7643','2014-03-06','14:55:00',7.89),('7643','2014-03-06','15:00:00',10.02),('7643','2014-03-06','15:05:00',11.62),('7643','2014-03-06','15:10:00',11.65),('7643','2014-03-06','15:15:00',11.9),('7643','2014-03-06','15:20:00',12.25),('7643','2014-03-06','15:25:00',11.74),('7643','2014-03-06','15:30:00',11.2),('7643','2014-03-06','15:35:00',10.44),('7643','2014-03-06','15:40:00',8.74),('7643','2014-03-06','15:45:00',4.08),('7643','2014-03-06','15:50:00',2.68),('7643','2014-03-06','15:55:00',2.65),('7643','2014-03-06','16:00:00',6.38),('7643','2014-03-06','16:05:00',6.99),('7643','2014-03-06','16:10:00',6.84),('7643','2014-03-06','16:15:00',6.83),('7643','2014-03-06','16:20:00',6.19),('7643','2014-03-06','16:25:00',5.78),('7643','2014-03-06','16:30:00',5.21),('7643','2014-03-06','16:35:00',4.86),('7643','2014-03-06','16:40:00',4.89),('7643','2014-03-06','16:45:00',4.53),('7643','2014-03-06','16:50:00',4.22),('7643','2014-03-06','16:55:00',3.96),('7643','2014-03-06','17:00:00',3.69),('7643','2014-03-06','17:05:00',3.29),('7643','2014-03-06','17:10:00',2.83),('7643','2014-03-06','17:15:00',2.38),('7643','2014-03-06','17:20:00',1.99),('7643','2014-03-06','17:25:00',1.27),('7643','2014-03-05','07:20:00',1.04),('7643','2014-03-05','07:25:00',1.23),('7643','2014-03-05','07:30:00',1.1),('7643','2014-03-05','07:40:00',1.11),('7643','2014-03-05','07:45:00',1.32),('7643','2014-03-05','07:50:00',1.54),('7643','2014-03-05','07:55:00',2.54),('7643','2014-03-05','08:00:00',3.73),('7643','2014-03-05','08:05:00',4.27),('7643','2014-03-05','08:10:00',6.48),('7643','2014-03-05','08:15:00',6.76),('7643','2014-03-05','08:20:00',5.81),('7643','2014-03-05','08:25:00',4.73),('7643','2014-03-05','08:30:00',2.41),('7643','2014-03-05','08:35:00',3.26),('7643','2014-03-05','08:40:00',3.57),('7643','2014-03-05','08:45:00',3.27),('7643','2014-03-05','08:50:00',3.83),('7643','2014-03-05','08:55:00',3.35),('7643','2014-03-05','09:00:00',3.36),('7643','2014-03-05','09:05:00',3.08),('7643','2014-03-05','09:10:00',3),('7643','2014-03-05','09:15:00',3.65),('7643','2014-03-05','09:20:00',3.92),('7643','2014-03-05','09:25:00',3.48),('7643','2014-03-05','09:30:00',4),('7643','2014-03-05','09:35:00',4.74),('7643','2014-03-05','09:40:00',5.84),('7643','2014-03-05','09:45:00',6.68),('7643','2014-03-05','09:50:00',7.03),('7643','2014-03-05','09:55:00',7.19),('7643','2014-03-05','10:00:00',6.81),('7643','2014-03-05','10:05:00',8.76),('7643','2014-03-05','10:10:00',11.41),('7643','2014-03-05','10:15:00',13.08),('7643','2014-03-05','10:20:00',11.07),('7643','2014-03-05','10:25:00',8.66),('7643','2014-03-05','10:30:00',5.52),('7643','2014-03-05','10:35:00',6.1),('7643','2014-03-05','10:40:00',7.37),('7643','2014-03-05','10:45:00',8.26),('7643','2014-03-05','10:50:00',4.81),('7643','2014-03-05','10:55:00',6.65),('7643','2014-03-05','11:00:00',7.25),('7643','2014-03-05','11:05:00',8.85),('7643','2014-03-05','11:10:00',6.15),('7643','2014-03-05','11:15:00',11.25),('7643','2014-03-05','11:20:00',5.28),('7643','2014-03-05','11:25:00',5.85),('7643','2014-03-05','11:30:00',6.95),('7643','2014-03-05','11:35:00',4.92),('7643','2014-03-05','11:40:00',7.13),('7643','2014-03-05','11:45:00',13.31),('7643','2014-03-05','11:50:00',13.76),('7643','2014-03-05','11:55:00',16.19),('7643','2014-03-05','12:00:00',6.07),('7643','2014-03-05','12:05:00',12.52),('7643','2014-03-05','12:10:00',17.57),('7643','2014-03-05','12:15:00',12.31),('7643','2014-03-05','12:20:00',7.94),('7643','2014-03-05','12:25:00',17.45),('7643','2014-03-05','12:30:00',17.3),('7643','2014-03-05','12:35:00',8.64),('7643','2014-03-05','12:40:00',5.58),('7643','2014-03-05','12:45:00',4.09),('7643','2014-03-05','12:50:00',3.72),('7643','2014-03-05','12:55:00',4.41),('7643','2014-03-05','13:00:00',4.7),('7643','2014-03-05','13:05:00',4.86),('7643','2014-03-05','13:10:00',4.54),('7643','2014-03-05','13:15:00',5.89),('7643','2014-03-05','13:20:00',4.54),('7643','2014-03-05','13:25:00',4.07),('7643','2014-03-05','13:30:00',4.41),('7643','2014-03-05','13:35:00',4.37),('7643','2014-03-05','13:40:00',4.61),('7643','2014-03-05','13:45:00',3.84),('7643','2014-03-05','13:50:00',3.47),('7643','2014-03-05','13:55:00',3.24),('7643','2014-03-05','14:00:00',3.32),('7643','2014-03-05','14:05:00',3.78),('7643','2014-03-05','14:10:00',3.79),('7643','2014-03-05','14:15:00',3.71),('7643','2014-03-05','14:20:00',4.33),('7643','2014-03-05','14:25:00',4.28),('7643','2014-03-05','14:30:00',4.34),('7643','2014-03-05','14:35:00',4.58),('7643','2014-03-05','14:40:00',3.93),('7643','2014-03-05','14:45:00',3.02),('7643','2014-03-05','14:50:00',3.46),('7643','2014-03-05','14:55:00',3.19),('7643','2014-03-05','15:00:00',3.27),('7643','2014-03-05','15:05:00',3.86),('7643','2014-03-05','15:10:00',3.97),('7643','2014-03-05','15:15:00',3.08),('7643','2014-03-05','15:20:00',2.07),('7643','2014-03-05','15:25:00',2.02),('7643','2014-03-05','15:30:00',2.19),('7643','2014-03-05','15:35:00',2.27),('7643','2014-03-05','15:40:00',1.93),('7643','2014-03-05','15:45:00',1.5),('7643','2014-03-05','15:50:00',1.5),('7643','2014-03-05','15:55:00',1.93),('7643','2014-03-05','16:00:00',2.42),('7643','2014-03-05','16:05:00',2.44),('7643','2014-03-05','16:10:00',2.31),('7643','2014-03-05','16:15:00',2.39),('7643','2014-03-05','16:20:00',2.96),('7643','2014-03-05','16:25:00',4.74),('7643','2014-03-05','16:30:00',2.25),('7643','2014-03-05','16:35:00',1.88),('7643','2014-03-05','16:40:00',1.55),('7643','2014-03-05','16:45:00',1.85),('7643','2014-03-05','16:50:00',3.17),('7643','2014-03-05','16:55:00',3.14),('7643','2014-03-05','17:00:00',2.25),('7643','2014-03-05','17:05:00',1.48),('7643','2014-03-05','17:10:00',1.98),('7643','2014-03-05','17:15:00',1.93),('7643','2014-03-05','17:20:00',1.4),('7643','2014-03-05','17:25:00',1.05),('7643','2014-03-04','07:05:00',1.25),('7643','2014-03-04','07:10:00',1.65),('7643','2014-03-04','07:15:00',1.92),('7643','2014-03-04','07:20:00',2.17),('7643','2014-03-04','07:25:00',2.51),('7643','2014-03-04','07:30:00',3.14),('7643','2014-03-04','07:35:00',3.55),('7643','2014-03-04','07:40:00',4.05),('7643','2014-03-04','07:45:00',4.47),('7643','2014-03-04','07:50:00',4.84),('7643','2014-03-04','07:55:00',5.16),('7643','2014-03-04','08:00:00',5.38),('7643','2014-03-04','08:05:00',5.56),('7643','2014-03-04','08:10:00',5.47),('7643','2014-03-04','08:15:00',5.8),('7643','2014-03-04','08:20:00',3.56),('7643','2014-03-04','08:25:00',2.31),('7643','2014-03-04','08:30:00',6.81),('7643','2014-03-04','08:35:00',7.72),('7643','2014-03-04','08:40:00',9),('7643','2014-03-04','08:45:00',8.77),('7643','2014-03-04','08:50:00',3.14),('7643','2014-03-04','08:55:00',3.55),('7643','2014-03-04','09:00:00',10.14),('7643','2014-03-04','09:05:00',5.63),('7643','2014-03-04','09:10:00',2.84),('7643','2014-03-04','09:15:00',6.48),('7643','2014-03-04','09:20:00',10.31),('7643','2014-03-04','09:25:00',10.39),('7643','2014-03-04','09:30:00',10.53),('7643','2014-03-04','09:35:00',10.86),('7643','2014-03-04','09:40:00',11.04),('7643','2014-03-04','09:45:00',11.27),('7643','2014-03-04','09:50:00',11.43),('7643','2014-03-04','09:55:00',11.65),('7643','2014-03-04','10:00:00',11.88),('7643','2014-03-04','10:05:00',12.08),('7643','2014-03-04','10:10:00',12.42),('7643','2014-03-04','10:15:00',12.54),('7643','2014-03-04','10:20:00',12.65),('7643','2014-03-04','10:25:00',12.82),('7643','2014-03-04','10:30:00',12.95),('7643','2014-03-04','10:35:00',13.09),('7643','2014-03-04','10:40:00',13.2),('7643','2014-03-04','10:45:00',13.35),('7643','2014-03-04','10:50:00',13.49),('7643','2014-03-04','10:55:00',13.62),('7643','2014-03-04','11:00:00',13.81),('7643','2014-03-04','11:05:00',14.09),('7643','2014-03-04','11:10:00',14.2),('7643','2014-03-04','11:15:00',14.22),('7643','2014-03-04','11:20:00',14.3),('7643','2014-03-04','11:25:00',14.42),('7643','2014-03-04','11:30:00',14.69),('7643','2014-03-04','11:35:00',14.8),('7643','2014-03-04','11:40:00',15.49),('7643','2014-03-04','11:45:00',15.05),('7643','2014-03-04','11:50:00',14.86),('7643','2014-03-04','11:55:00',12.31),('7643','2014-03-04','12:00:00',12.99),('7643','2014-03-04','12:05:00',12.36),('7643','2014-03-04','12:10:00',5.48),('7643','2014-03-04','12:15:00',5.71),('7643','2014-03-04','12:20:00',2.79),('7643','2014-03-04','12:25:00',3.28),('7643','2014-03-04','12:30:00',3.88),('7643','2014-03-04','12:35:00',6.86),('7643','2014-03-04','12:40:00',5.16),('7643','2014-03-04','12:45:00',4.68),('7643','2014-03-04','12:50:00',6.97),('7643','2014-03-04','12:55:00',5.29),('7643','2014-03-04','13:00:00',6.63),('7643','2014-03-04','13:05:00',8.84),('7643','2014-03-04','13:10:00',11.92),('7643','2014-03-04','13:15:00',12.08),('7643','2014-03-04','13:20:00',6.8),('7643','2014-03-04','13:25:00',4.68),('7643','2014-03-04','13:30:00',4.51),('7643','2014-03-04','13:35:00',4.95),('7643','2014-03-04','13:40:00',5.81),('7643','2014-03-04','13:45:00',5.52),('7643','2014-03-04','13:50:00',4.53),('7643','2014-03-04','13:55:00',4.02),('7643','2014-03-04','14:00:00',3.69),('7643','2014-03-04','14:05:00',3.64),('7643','2014-03-04','14:10:00',3.8),('7643','2014-03-04','14:15:00',4.36),('7643','2014-03-04','14:20:00',4.57),('7643','2014-03-04','14:25:00',4.95),('7643','2014-03-04','14:30:00',5.32),('7643','2014-03-04','14:35:00',4.63),('7643','2014-03-04','14:40:00',5.12),('7643','2014-03-04','14:45:00',5.8),('7643','2014-03-04','14:50:00',8.83),('7643','2014-03-04','14:55:00',5.27),('7643','2014-03-04','15:00:00',3.58),('7643','2014-03-04','15:05:00',3.12),('7643','2014-03-04','15:10:00',3.17),('7643','2014-03-04','15:15:00',3.07),('7643','2014-03-04','15:20:00',2.75),('7643','2014-03-04','15:25:00',2.78),('7643','2014-03-04','15:30:00',3.61),('7643','2014-03-04','15:35:00',4.51),('7643','2014-03-04','15:40:00',7.92),('7643','2014-03-04','15:45:00',6.58),('7643','2014-03-04','15:50:00',5.31),('7643','2014-03-04','15:55:00',8.75),('7643','2014-03-04','16:00:00',10.41),('7643','2014-03-04','16:05:00',9.43),('7643','2014-03-04','16:10:00',7.97),('7643','2014-03-04','16:15:00',5.52),('7643','2014-03-04','16:20:00',2),('7643','2014-03-04','16:25:00',1.33),('7643','2014-03-04','16:30:00',1.14),('7643','2014-03-03','08:45:00',1.23),('7643','2014-03-03','08:50:00',2.16),('7643','2014-03-03','09:00:00',1.72),('7643','2014-03-03','09:05:00',4.11),('7643','2014-03-03','09:10:00',3.6),('7643','2014-03-03','09:15:00',6.86),('7643','2014-03-03','09:20:00',9.41),('7643','2014-03-03','09:25:00',4.16),('7643','2014-03-03','09:30:00',3.77),('7643','2014-03-03','09:35:00',3.84),('7643','2014-03-03','09:40:00',7.25),('7643','2014-03-03','09:45:00',7.47),('7643','2014-03-03','09:50:00',2.56),('7643','2014-03-03','09:55:00',7.73),('7643','2014-03-03','10:00:00',5.8),('7643','2014-03-03','10:05:00',4.14),('7643','2014-03-03','10:10:00',2.05),('7643','2014-03-03','10:15:00',1.94),('7643','2014-03-03','10:20:00',3.17),('7643','2014-03-03','10:25:00',14.45),('7643','2014-03-03','10:30:00',10.33),('7643','2014-03-03','10:35:00',12.28),('7643','2014-03-03','10:40:00',15.44),('7643','2014-03-03','10:45:00',15.11),('7643','2014-03-03','10:50:00',3.79),('7643','2014-03-03','10:55:00',9.95),('7643','2014-03-03','11:00:00',8.29),('7643','2014-03-03','11:05:00',6.23),('7643','2014-03-03','11:10:00',10.24),('7643','2014-03-03','11:15:00',17.38),('7643','2014-03-03','11:20:00',13.16),('7643','2014-03-03','11:25:00',4.51),('7643','2014-03-03','11:30:00',3.32),('7643','2014-03-03','11:35:00',2.37),('7643','2014-03-03','11:40:00',3.19),('7643','2014-03-03','11:45:00',8.69),('7643','2014-03-03','11:50:00',17.91),('7643','2014-03-03','11:55:00',15.74),('7643','2014-03-03','12:00:00',15.25),('7643','2014-03-03','12:05:00',14.98),('7643','2014-03-03','12:10:00',14.84),('7643','2014-03-03','12:15:00',14.69),('7643','2014-03-03','12:20:00',14.69),('7643','2014-03-03','12:25:00',14.74),('7643','2014-03-03','12:30:00',14.57),('7643','2014-03-03','12:35:00',14.52),('7643','2014-03-03','12:40:00',14.64),('7643','2014-03-03','12:45:00',13.56),('7643','2014-03-03','12:50:00',11.65),('7643','2014-03-03','12:55:00',12.13),('7643','2014-03-03','13:00:00',13),('7643','2014-03-03','13:05:00',13.88),('7643','2014-03-03','13:10:00',15.46),('7643','2014-03-03','13:15:00',12.96),('7643','2014-03-03','13:20:00',4.79),('7643','2014-03-03','13:25:00',3.63),('7643','2014-03-03','13:30:00',3.91),('7643','2014-03-03','13:35:00',3.11),('7643','2014-03-03','13:40:00',2),('7643','2014-03-03','13:45:00',2.83),('7643','2014-03-03','13:50:00',4.29),('7643','2014-03-03','13:55:00',4.13),('7643','2014-03-03','14:00:00',2.61),('7643','2014-03-03','14:05:00',5.37),('7643','2014-03-03','14:10:00',9.96),('7643','2014-03-03','14:15:00',10.24),('7643','2014-03-03','14:20:00',8.03),('7643','2014-03-03','14:25:00',13.31),('7643','2014-03-03','14:30:00',12.4),('7643','2014-03-03','14:35:00',11.78),('7643','2014-03-03','14:40:00',11.49),('7643','2014-03-03','14:45:00',11.41),('7643','2014-03-03','14:50:00',10.85),('7643','2014-03-03','14:55:00',5.09),('7643','2014-03-03','15:00:00',6.43),('7643','2014-03-03','15:05:00',10.31),('7643','2014-03-03','15:10:00',10.05),('7643','2014-03-03','15:15:00',9.55),('7643','2014-03-03','15:20:00',5.65),('7643','2014-03-03','15:25:00',9.32),('7643','2014-03-03','15:30:00',5.61),('7643','2014-03-03','15:35:00',9.87),('7643','2014-03-03','15:40:00',8.93),('7643','2014-03-03','15:45:00',6.32),('7643','2014-03-03','15:50:00',6.97),('7643','2014-03-03','15:55:00',2.75),('7643','2014-03-03','16:00:00',2.6),('7643','2014-03-03','16:05:00',3.51),('7643','2014-03-03','16:10:00',3.68),('7643','2014-03-03','16:15:00',3.04),('7643','2014-03-03','16:20:00',3.75),('7643','2014-03-03','16:25:00',4.71),('7643','2014-03-03','16:30:00',3.5),('7643','2014-03-03','16:35:00',3.34),('7643','2014-03-03','16:40:00',3.45),('7643','2014-03-03','16:45:00',3.66),('7643','2014-03-03','16:50:00',3.35),('7643','2014-03-03','16:55:00',2.59),('7643','2014-03-03','17:00:00',1.96),('7643','2014-03-03','17:05:00',1.67),('7643','2014-03-03','17:10:00',1.2),('7643','2014-03-02','07:15:00',1.17),('7643','2014-03-02','07:20:00',1.52),('7643','2014-03-02','07:25:00',1.88),('7643','2014-03-02','07:30:00',2.28),('7643','2014-03-02','07:35:00',2.61),('7643','2014-03-02','07:40:00',2.95),('7643','2014-03-02','07:45:00',3.3),('7643','2014-03-02','07:50:00',3.64),('7643','2014-03-02','07:55:00',3.22),('7643','2014-03-02','08:00:00',3.47),('7643','2014-03-02','08:05:00',3.52),('7643','2014-03-02','08:10:00',4.95),('7643','2014-03-02','08:15:00',5.54),('7643','2014-03-02','08:20:00',5.89),('7643','2014-03-02','08:25:00',6.16),('7643','2014-03-02','08:30:00',6.56),('7643','2014-03-02','08:35:00',6.84),('7643','2014-03-02','08:40:00',7.32),('7643','2014-03-02','08:45:00',7.6),('7643','2014-03-02','08:50:00',7.5),('7643','2014-03-02','08:55:00',8.43),('7643','2014-03-02','09:00:00',8.74),('7643','2014-03-02','09:05:00',8.79),('7643','2014-03-02','09:10:00',8.48),('7643','2014-03-02','09:15:00',8.47),('7643','2014-03-02','09:20:00',9.36),('7643','2014-03-02','09:25:00',9.9),('7643','2014-03-02','09:30:00',9.61),('7643','2014-03-02','09:35:00',8.94),('7643','2014-03-02','09:40:00',8.06),('7643','2014-03-02','09:45:00',8.42),('7643','2014-03-02','09:50:00',8.45),('7643','2014-03-02','09:55:00',9.97),('7643','2014-03-02','10:00:00',10.92),('7643','2014-03-02','10:05:00',11.61),('7643','2014-03-02','10:10:00',11.66),('7643','2014-03-02','10:15:00',11.84),('7643','2014-03-02','10:20:00',12.02),('7643','2014-03-02','10:25:00',12.18),('7643','2014-03-02','10:30:00',12.43),('7643','2014-03-02','10:35:00',12.6),('7643','2014-03-02','10:40:00',12.7),('7643','2014-03-02','10:45:00',12.71),('7643','2014-03-02','10:50:00',12.97),('7643','2014-03-02','10:55:00',13.1),('7643','2014-03-02','11:00:00',13.19),('7643','2014-03-02','11:05:00',13.22),('7643','2014-03-02','11:10:00',13.29),('7643','2014-03-02','11:15:00',13.4),('7643','2014-03-02','11:20:00',13.5),('7643','2014-03-02','11:25:00',13.65),('7643','2014-03-02','11:30:00',13.9),('7643','2014-03-02','11:35:00',9.46),('7643','2014-03-02','11:40:00',8.09),('7643','2014-03-02','11:45:00',14.01),('7643','2014-03-02','11:50:00',14.54),('7643','2014-03-02','11:55:00',14.55),('7643','2014-03-02','12:00:00',14.42),('7643','2014-03-02','12:05:00',14.5),('7643','2014-03-02','12:10:00',14.59),('7643','2014-03-02','12:15:00',14.56),('7643','2014-03-02','12:20:00',14.57),('7643','2014-03-02','12:25:00',14.58),('7643','2014-03-02','12:30:00',14.5),('7643','2014-03-02','12:35:00',14.44),('7643','2014-03-02','12:40:00',14.42),('7643','2014-03-02','12:45:00',14.34),('7643','2014-03-02','12:50:00',14.25),('7643','2014-03-02','12:55:00',14.16),('7643','2014-03-02','13:00:00',14.1),('7643','2014-03-02','13:05:00',13.96),('7643','2014-03-02','13:10:00',13.9),('7643','2014-03-02','13:15:00',13.79),('7643','2014-03-02','13:20:00',13.76),('7643','2014-03-02','13:25:00',13.67),('7643','2014-03-02','13:30:00',13.63),('7643','2014-03-02','13:35:00',13.52),('7643','2014-03-02','13:40:00',13.33),('7643','2014-03-02','13:45:00',13.22),('7643','2014-03-02','13:50:00',13.12),('7643','2014-03-02','13:55:00',12.87),('7643','2014-03-02','14:00:00',12.79),('7643','2014-03-02','14:05:00',12.63),('7643','2014-03-02','14:10:00',12.63),('7643','2014-03-02','14:15:00',12.61),('7643','2014-03-02','14:20:00',12.31),('7643','2014-03-02','14:25:00',11.55),('7643','2014-03-02','14:30:00',11.88),('7643','2014-03-02','14:35:00',11.73),('7643','2014-03-02','14:40:00',11.33),('7643','2014-03-02','14:45:00',11.05),('7643','2014-03-02','14:50:00',10.72),('7643','2014-03-02','14:55:00',10.49),('7643','2014-03-02','15:00:00',10.17),('7643','2014-03-02','15:05:00',9.9),('7643','2014-03-02','15:10:00',9.68),('7643','2014-03-02','15:15:00',9.25),('7643','2014-03-02','15:20:00',9.15),('7643','2014-03-02','15:25:00',8.91),('7643','2014-03-02','15:30:00',8.54),('7643','2014-03-02','15:35:00',8.2),('7643','2014-03-02','15:40:00',7.89),('7643','2014-03-02','15:45:00',7.55),('7643','2014-03-02','15:50:00',7.14),('7643','2014-03-02','15:55:00',6.78),('7643','2014-03-02','16:00:00',6.47),('7643','2014-03-02','16:05:00',6.13),('7643','2014-03-02','16:10:00',5.81),('7643','2014-03-02','16:15:00',5.49),('7643','2014-03-02','16:20:00',5.14),('7643','2014-03-02','16:25:00',4.73),('7643','2014-03-02','16:30:00',4.37),('7643','2014-03-02','16:35:00',3.97),('7643','2014-03-02','16:40:00',3.68),('7643','2014-03-02','16:45:00',3.44),('7643','2014-03-02','16:50:00',1.81),('7643','2014-03-02','16:55:00',2.69),('7643','2014-03-02','17:00:00',2.83),('7643','2014-03-02','17:05:00',2.32),('7643','2014-03-02','17:10:00',1.37),('7643','2014-03-02','17:15:00',1.1),('7643','2014-03-01','07:20:00',1.74),('7643','2014-03-01','07:25:00',1.43),('7643','2014-03-01','07:30:00',1.15),('7643','2014-03-01','07:35:00',1.06),('7643','2014-03-01','07:40:00',1.01),('7643','2014-03-01','07:45:00',2.12),('7643','2014-03-01','07:50:00',1.94),('7643','2014-03-01','07:55:00',1.76),('7643','2014-03-01','08:00:00',3.1),('7643','2014-03-01','08:05:00',4.55),('7643','2014-03-01','08:10:00',6.37),('7643','2014-03-01','08:15:00',6.91),('7643','2014-03-01','08:20:00',7.03),('7643','2014-03-01','08:25:00',6.4),('7643','2014-03-01','08:30:00',6.5),('7643','2014-03-01','08:35:00',6.81),('7643','2014-03-01','08:40:00',7.23),('7643','2014-03-01','08:45:00',7.64),('7643','2014-03-01','08:50:00',8.01),('7643','2014-03-01','08:55:00',8.3),('7643','2014-03-01','09:00:00',8.61),('7643','2014-03-01','09:05:00',8.99),('7643','2014-03-01','09:10:00',9.48),('7643','2014-03-01','09:15:00',9.83),('7643','2014-03-01','09:20:00',7.7),('7643','2014-03-01','09:25:00',10.07),('7643','2014-03-01','09:30:00',11.09),('7643','2014-03-01','09:35:00',11.1),('7643','2014-03-01','09:40:00',10.65),('7643','2014-03-01','09:45:00',5.54),('7643','2014-03-01','09:50:00',2.5),('7643','2014-03-01','09:55:00',3.26),('7643','2014-03-01','10:00:00',8.18),('7643','2014-03-01','10:05:00',5.74),('7643','2014-03-01','10:10:00',5.57),('7643','2014-03-01','10:15:00',4.24),('7643','2014-03-01','10:20:00',4.37),('7643','2014-03-01','10:25:00',4.67),('7643','2014-03-01','10:30:00',5.4),('7643','2014-03-01','10:35:00',5.62),('7643','2014-03-01','10:40:00',7.73),('7643','2014-03-01','10:45:00',4.42),('7643','2014-03-01','10:50:00',4.3),('7643','2014-03-01','10:55:00',4.38),('7643','2014-03-01','11:00:00',8.74),('7643','2014-03-01','11:05:00',11.42),('7643','2014-03-01','11:10:00',5.8),('7643','2014-03-01','11:15:00',4.58),('7643','2014-03-01','11:20:00',5.53),('7643','2014-03-01','11:25:00',7.16),('7643','2014-03-01','11:30:00',7.38),('7643','2014-03-01','11:35:00',11.51),('7643','2014-03-01','11:40:00',11.38),('7643','2014-03-01','11:45:00',14.54),('7643','2014-03-01','11:50:00',17.9),('7643','2014-03-01','11:55:00',15.91),('7643','2014-03-01','12:00:00',9.8),('7643','2014-03-01','12:05:00',6.64),('7643','2014-03-01','12:10:00',7.39),('7643','2014-03-01','12:15:00',12.63),('7643','2014-03-01','12:20:00',9.33),('7643','2014-03-01','12:25:00',6.87),('7643','2014-03-01','12:30:00',5.35),('7643','2014-03-01','12:35:00',4.23),('7643','2014-03-01','12:40:00',3.68),('7643','2014-03-01','12:45:00',3.66),('7643','2014-03-01','12:50:00',4.09),('7643','2014-03-01','12:55:00',4.76),('7643','2014-03-01','13:00:00',5.32),('7643','2014-03-01','13:05:00',5.45),('7643','2014-03-01','13:10:00',5.4),('7643','2014-03-01','13:15:00',5.27),('7643','2014-03-01','13:20:00',4.98),('7643','2014-03-01','13:25:00',4.39),('7643','2014-03-01','13:30:00',3.92),('7643','2014-03-01','13:35:00',3.3),('7643','2014-03-01','13:40:00',3.02),('7643','2014-03-01','13:45:00',2.86),('7643','2014-03-01','13:50:00',3.06),('7643','2014-03-01','13:55:00',3.59),('7643','2014-03-01','14:00:00',4.62),('7643','2014-03-01','14:05:00',5),('7643','2014-03-01','14:10:00',4.78),('7643','2014-03-01','14:15:00',4.56),('7643','2014-03-01','14:20:00',4.29),('7643','2014-03-01','14:25:00',4.37),('7643','2014-03-01','14:30:00',4.6),('7643','2014-03-01','14:35:00',4.56),('7643','2014-03-01','14:40:00',4.66),('7643','2014-03-01','14:45:00',4.77),('7643','2014-03-01','14:50:00',4.69),('7643','2014-03-01','14:55:00',4.59),('7643','2014-03-01','15:00:00',4.73),('7643','2014-03-01','15:05:00',5.23),('7643','2014-03-01','15:10:00',5.15),('7643','2014-03-01','15:15:00',5.1),('7643','2014-03-01','15:20:00',5.3),('7643','2014-03-01','15:25:00',5.39),('7643','2014-03-01','15:30:00',4.99),('7643','2014-03-01','15:35:00',5.39),('7643','2014-03-01','15:40:00',4.8),('7643','2014-03-01','15:45:00',4.18),('7643','2014-03-01','15:50:00',3.92),('7643','2014-03-01','15:55:00',3.39),('7643','2014-03-01','16:00:00',3.03),('7643','2014-03-01','16:05:00',2.76),('7643','2014-03-01','16:10:00',2.39),('7643','2014-03-01','16:15:00',2.1),('7643','2014-03-01','16:20:00',1.97),('7643','2014-03-01','16:25:00',1.81),('7643','2014-03-01','16:30:00',1.63),('7643','2014-03-01','16:35:00',1.54),('7643','2014-03-01','16:40:00',1.48),('7643','2014-03-01','16:45:00',1.46),('7643','2014-03-01','16:50:00',1.45),('7643','2014-03-01','16:55:00',1.47),('7643','2014-03-01','17:00:00',1.41),('7643','2014-02-28','09:50:00',1.61),('7643','2014-02-28','09:55:00',1.66),('7643','2014-02-28','10:00:00',1.25),('7643','2014-02-28','10:05:00',1.46),('7643','2014-02-28','10:10:00',1.36),('7643','2014-02-28','10:15:00',1.34),('7643','2014-02-28','10:20:00',1.37),('7643','2014-02-28','10:25:00',1.37),('7643','2014-02-28','10:30:00',1.18),('7643','2014-02-28','11:50:00',1.04),('7643','2014-02-28','11:55:00',1.45),('7643','2014-02-28','12:00:00',1.64),('7643','2014-02-28','12:05:00',1.55),('7643','2014-02-28','12:10:00',1.49),('7643','2014-02-28','12:15:00',1.56),('7643','2014-02-28','12:20:00',1.64),('7643','2014-02-28','12:25:00',1.65),('7643','2014-02-28','12:30:00',1.79),('7643','2014-02-28','12:35:00',1.58),('7643','2014-02-28','12:40:00',1.85),('7643','2014-02-28','12:45:00',1.64),('7643','2014-02-28','13:05:00',1.63),('7643','2014-02-28','13:10:00',1.68),('7643','2014-02-28','13:15:00',1.29),('7643','2014-02-28','13:20:00',1.38),('7643','2014-02-28','13:25:00',1.18),('7643','2014-02-28','13:30:00',1.11),('7643','2014-02-28','13:35:00',1.15),('7643','2014-02-28','14:20:00',1.37),('7643','2014-02-28','14:25:00',1.36),('7643','2014-02-28','14:30:00',1.09),('7643','2014-02-28','14:35:00',1.4),('7643','2014-02-28','14:40:00',1.91),('7643','2014-02-28','14:45:00',2.35),('7643','2014-02-28','14:50:00',2.41),('7643','2014-02-28','14:55:00',2.17),('7643','2014-02-28','15:00:00',1.95),('7643','2014-02-28','16:10:00',1.12),('7643','2014-02-28','16:15:00',1.35),('7643','2014-02-28','16:20:00',1.45),('7643','2014-02-28','16:25:00',1.04),('7643','2014-02-28','17:00:00',1.17),('7643','2014-02-28','17:05:00',1.1),('7643','2014-02-27','07:40:00',1.8),('7643','2014-02-27','07:45:00',2.81),('7643','2014-02-27','07:50:00',3.24),('7643','2014-02-27','07:55:00',3.85),('7643','2014-02-27','08:00:00',4.88),('7643','2014-02-27','08:05:00',4.09),('7643','2014-02-27','08:10:00',4.06),('7643','2014-02-27','08:15:00',3.54),('7643','2014-02-27','08:20:00',7.11),('7643','2014-02-27','08:25:00',6.12),('7643','2014-02-27','08:30:00',2.24),('7643','2014-02-27','08:35:00',8.21),('7643','2014-02-27','08:40:00',4.2),('7643','2014-02-27','08:55:00',1.17),('7643','2014-02-27','09:00:00',1.31),('7643','2014-02-27','09:05:00',1.3),('7643','2014-02-27','09:10:00',2.63),('7643','2014-02-27','09:15:00',4.37),('7643','2014-02-27','09:20:00',4.76),('7643','2014-02-27','09:25:00',4.86),('7643','2014-02-27','09:30:00',6.97),('7643','2014-02-27','09:35:00',4.44),('7643','2014-02-27','09:40:00',7.49),('7643','2014-02-27','09:45:00',11.44),('7643','2014-02-27','09:50:00',12.94),('7643','2014-02-27','09:55:00',11.57),('7643','2014-02-27','10:00:00',5.06),('7643','2014-02-27','10:05:00',4.39),('7643','2014-02-27','10:10:00',6.64),('7643','2014-02-27','10:15:00',4.76),('7643','2014-02-27','10:20:00',5.9),('7643','2014-02-27','10:25:00',13.73),('7643','2014-02-27','10:30:00',14.13),('7643','2014-02-27','10:35:00',11.7),('7643','2014-02-27','10:40:00',5.12),('7643','2014-02-27','10:45:00',2.97),('7643','2014-02-27','10:50:00',1.71),('7643','2014-02-27','10:55:00',1.51),('7643','2014-02-27','11:00:00',1.93),('7643','2014-02-27','11:05:00',2.51),('7643','2014-02-27','11:10:00',2.29),('7643','2014-02-27','11:15:00',2.97),('7643','2014-02-27','11:20:00',4.35),('7643','2014-02-27','11:25:00',4.41),('7643','2014-02-27','11:30:00',3.66),('7643','2014-02-27','11:35:00',2.68),('7643','2014-02-27','11:40:00',2.3),('7643','2014-02-27','11:45:00',3.06),('7643','2014-02-27','11:50:00',3.99),('7643','2014-02-27','11:55:00',4.17),('7643','2014-02-27','12:00:00',5.17),('7643','2014-02-27','12:05:00',7.42),('7643','2014-02-27','12:10:00',8.57),('7643','2014-02-27','12:15:00',5),('7643','2014-02-27','12:20:00',3.92),('7643','2014-02-27','12:25:00',4.73),('7643','2014-02-27','12:30:00',7.34),('7643','2014-02-27','12:35:00',11.03),('7643','2014-02-27','12:40:00',11.02),('7643','2014-02-27','12:45:00',4.3),('7643','2014-02-27','12:50:00',8.22),('7643','2014-02-27','12:55:00',6.08),('7643','2014-02-27','13:00:00',9.3),('7643','2014-02-27','13:05:00',7.12),('7643','2014-02-27','13:10:00',6.04),('7643','2014-02-27','13:15:00',4.03),('7643','2014-02-27','13:20:00',2.06),('7643','2014-02-27','13:40:00',1.05),('7643','2014-02-27','13:45:00',3.18),('7643','2014-02-27','13:50:00',12.39),('7643','2014-02-27','13:55:00',14.96),('7643','2014-02-27','14:00:00',7.4),('7643','2014-02-27','14:05:00',3.97),('7643','2014-02-27','14:10:00',3.27),('7643','2014-02-27','14:15:00',6.36),('7643','2014-02-27','14:20:00',6.75),('7643','2014-02-27','14:25:00',8.84),('7643','2014-02-27','14:30:00',6.56),('7643','2014-02-27','14:35:00',5.29),('7643','2014-02-27','14:40:00',4.7),('7643','2014-02-27','14:45:00',4.65),('7643','2014-02-27','14:50:00',4.99),('7643','2014-02-27','14:55:00',5.54),('7643','2014-02-27','15:00:00',8.17),('7643','2014-02-27','15:05:00',4.24),('7643','2014-02-27','15:10:00',2.13),('7643','2014-02-27','15:15:00',1.37),('7643','2014-02-27','15:20:00',1.91),('7643','2014-02-27','15:25:00',6.93),('7643','2014-02-27','15:30:00',7.68),('7643','2014-02-27','15:35:00',8.87),('7643','2014-02-27','15:40:00',7.25),('7643','2014-02-27','15:45:00',2.48),('7643','2014-02-27','15:50:00',1.49),('7643','2014-02-27','16:10:00',3.29),('7643','2014-02-27','16:15:00',7.01),('7643','2014-02-27','16:20:00',6.11),('7643','2014-02-27','16:25:00',3.23),('7643','2014-02-27','16:30:00',2.09),('7643','2014-02-27','16:35:00',3.47),('7643','2014-02-27','16:40:00',4.41),('7643','2014-02-27','16:45:00',5.33),('7643','2014-02-27','16:50:00',4.57),('7643','2014-02-27','16:55:00',1.69),('7643','2014-02-26','09:35:00',1.13),('7643','2014-02-26','09:40:00',1.19),('7643','2014-02-26','09:45:00',1.38),('7643','2014-02-26','09:50:00',1.5),('7643','2014-02-26','09:55:00',1.55),('7643','2014-02-26','10:00:00',1.7),('7643','2014-02-26','10:05:00',1.64),('7643','2014-02-26','10:10:00',1.72),('7643','2014-02-26','10:15:00',1.67),('7643','2014-02-26','10:20:00',1.72),('7643','2014-02-26','10:25:00',1.9),('7643','2014-02-26','10:30:00',2.76),('7643','2014-02-26','10:35:00',3.44),('7643','2014-02-26','10:40:00',3.91),('7643','2014-02-26','10:45:00',4.35),('7643','2014-02-26','10:50:00',4.61),('7643','2014-02-26','10:55:00',4.94),('7643','2014-02-26','11:00:00',5.52),('7643','2014-02-26','11:05:00',6.34),('7643','2014-02-26','11:10:00',5.91),('7643','2014-02-26','11:15:00',5.75),('7643','2014-02-26','11:20:00',5.37),('7643','2014-02-26','11:25:00',5.8),('7643','2014-02-26','11:30:00',7.24),('7643','2014-02-26','11:35:00',6.87),('7643','2014-02-26','11:40:00',5.56),('7643','2014-02-26','11:45:00',4.81),('7643','2014-02-26','11:50:00',4.58),('7643','2014-02-26','11:55:00',4.61),('7643','2014-02-26','12:00:00',4.48),('7643','2014-02-26','12:05:00',4.51),('7643','2014-02-26','12:10:00',3.78),('7643','2014-02-26','12:15:00',4.17),('7643','2014-02-26','12:20:00',4.59),('7643','2014-02-26','12:25:00',4.72),('7643','2014-02-26','12:30:00',4.37),('7643','2014-02-26','12:35:00',4.24),('7643','2014-02-26','12:40:00',4.13),('7643','2014-02-26','12:45:00',4.06),('7643','2014-02-26','12:50:00',3.95),('7643','2014-02-26','12:55:00',4.04),('7643','2014-02-26','13:00:00',4.26),('7643','2014-02-26','13:05:00',3.93),('7643','2014-02-26','13:10:00',4.1),('7643','2014-02-26','13:15:00',4.61),('7643','2014-02-26','13:20:00',4.61),('7643','2014-02-26','13:25:00',4.89),('7643','2014-02-26','13:30:00',5.46),('7643','2014-02-26','13:35:00',6.04),('7643','2014-02-26','13:40:00',6.12),('7643','2014-02-26','13:45:00',6.15),('7643','2014-02-26','13:50:00',6.54),('7643','2014-02-26','13:55:00',7.15),('7643','2014-02-26','14:00:00',7.18),('7643','2014-02-26','14:05:00',6.4),('7643','2014-02-26','14:10:00',5.5),('7643','2014-02-26','14:15:00',5.09),('7643','2014-02-26','14:20:00',5.18),('7643','2014-02-26','14:25:00',5.3),('7643','2014-02-26','14:30:00',5.79),('7643','2014-02-26','14:35:00',5.63),('7643','2014-02-26','14:40:00',4.95),('7643','2014-02-26','14:45:00',4.9),('7643','2014-02-26','14:50:00',4.53),('7643','2014-02-26','14:55:00',4.2),('7643','2014-02-26','15:00:00',4.29),('7643','2014-02-26','15:05:00',3.91),('7643','2014-02-26','15:10:00',4.21),('7643','2014-02-26','15:15:00',5.02),('7643','2014-02-26','15:20:00',5.49),('7643','2014-02-26','15:25:00',4.85),('7643','2014-02-26','15:30:00',4.78),('7643','2014-02-26','15:35:00',4.96),('7643','2014-02-26','15:40:00',4.37),('7643','2014-02-26','15:45:00',3.2),('7643','2014-02-26','15:50:00',2.81),('7643','2014-02-26','15:55:00',2.3),('7643','2014-02-26','16:00:00',2.35),('7643','2014-02-26','16:05:00',2.34),('7643','2014-02-26','16:10:00',2.1),('7643','2014-02-26','16:15:00',1.58),('7643','2014-02-26','16:20:00',1.38),('7643','2014-02-26','16:25:00',1.63),('7643','2014-02-26','16:30:00',1.9),('7643','2014-02-26','16:35:00',2.6),('7643','2014-02-26','16:40:00',4.21),('7643','2014-02-26','16:45:00',3.15),('7643','2014-02-26','16:50:00',4.01),('7643','2014-02-26','16:55:00',3.91),('7643','2014-02-26','17:00:00',3.32),('7643','2014-02-26','17:05:00',2.54),('7643','2014-02-26','17:10:00',1.83),('7643','2014-02-26','17:15:00',1.01),('7643','2014-02-25','07:25:00',1.19),('7643','2014-02-25','07:30:00',1.53),('7643','2014-02-25','07:35:00',1.77),('7643','2014-02-25','07:40:00',1.98),('7643','2014-02-25','07:45:00',2.19),('7643','2014-02-25','07:50:00',2.44),('7643','2014-02-25','07:55:00',2.99),('7643','2014-02-25','08:00:00',3.61),('7643','2014-02-25','08:05:00',3.92),('7643','2014-02-25','08:10:00',4.45),('7643','2014-02-25','08:15:00',4.88),('7643','2014-02-25','08:20:00',5.22),('7643','2014-02-25','08:25:00',5.55),('7643','2014-02-25','08:30:00',5.77),('7643','2014-02-25','08:35:00',6.31),('7643','2014-02-25','08:40:00',6.73),('7643','2014-02-25','08:45:00',7.52),('7643','2014-02-25','08:50:00',7.67),('7643','2014-02-25','08:55:00',7.69),('7643','2014-02-25','09:00:00',7.78),('7643','2014-02-25','09:05:00',7.85),('7643','2014-02-25','09:10:00',7.73),('7643','2014-02-25','09:15:00',8.56),('7643','2014-02-25','09:20:00',8.86),('7643','2014-02-25','09:25:00',9.28),('7643','2014-02-25','09:30:00',8.82),('7643','2014-02-25','09:35:00',9.03),('7643','2014-02-25','09:40:00',6.06),('7643','2014-02-25','09:45:00',9.9),('7643','2014-02-25','09:50:00',8),('7643','2014-02-25','09:55:00',5.1),('7643','2014-02-25','10:00:00',4.95),('7643','2014-02-25','10:05:00',4.05),('7643','2014-02-25','10:10:00',3.06),('7643','2014-02-25','10:15:00',3.02),('7643','2014-02-25','10:20:00',3.66),('7643','2014-02-25','10:25:00',3.8),('7643','2014-02-25','10:30:00',3.79),('7643','2014-02-25','10:35:00',3.38),('7643','2014-02-25','10:40:00',2.8),('7643','2014-02-25','10:45:00',2.35),('7643','2014-02-25','10:50:00',2.17),('7643','2014-02-25','10:55:00',2.69),('7643','2014-02-25','11:00:00',3.29),('7643','2014-02-25','11:05:00',3.68),('7643','2014-02-25','11:10:00',3.72),('7643','2014-02-25','11:15:00',3.6),('7643','2014-02-25','11:20:00',2.61),('7643','2014-02-25','11:25:00',2.04),('7643','2014-02-25','11:30:00',2.18),('7643','2014-02-25','11:35:00',2.53),('7643','2014-02-25','11:40:00',2.37),('7643','2014-02-25','11:45:00',2.37),('7643','2014-02-25','11:50:00',2.96),('7643','2014-02-25','11:55:00',3.15),('7643','2014-02-25','12:00:00',4.28),('7643','2014-02-25','12:05:00',7.43),('7643','2014-02-25','12:10:00',9.28),('7643','2014-02-25','12:15:00',4.79),('7643','2014-02-25','12:20:00',3.96),('7643','2014-02-25','12:25:00',4.52),('7643','2014-02-25','12:30:00',7.43),('7643','2014-02-25','12:35:00',6.64),('7643','2014-02-25','12:40:00',7.33),('7643','2014-02-25','12:45:00',7.69),('7643','2014-02-25','12:50:00',10.84),('7643','2014-02-25','12:55:00',5.92),('7643','2014-02-25','13:00:00',8.71),('7643','2014-02-25','13:05:00',11.92),('7643','2014-02-25','13:10:00',10.91),('7643','2014-02-25','13:15:00',11.19),('7643','2014-02-25','13:20:00',11.99),('7643','2014-02-25','13:25:00',11.59),('7643','2014-02-25','13:30:00',14.32),('7643','2014-02-25','13:35:00',13.31),('7643','2014-02-25','13:40:00',13.11),('7643','2014-02-25','13:45:00',11.22),('7643','2014-02-25','13:50:00',10.52),('7643','2014-02-25','13:55:00',6.22),('7643','2014-02-25','14:00:00',13.52),('7643','2014-02-25','14:05:00',10.85),('7643','2014-02-25','14:10:00',6.19),('7643','2014-02-25','14:15:00',10.31),('7643','2014-02-25','14:20:00',11.66),('7643','2014-02-25','14:25:00',12.84),('7643','2014-02-25','14:30:00',7.57),('7643','2014-02-25','14:35:00',7.26),('7643','2014-02-25','14:40:00',11.82),('7643','2014-02-25','14:45:00',11.41),('7643','2014-02-25','14:50:00',3.02),('7643','2014-02-25','14:55:00',10.63),('7643','2014-02-25','15:00:00',10.37),('7643','2014-02-25','15:05:00',5.4),('7643','2014-02-25','15:10:00',9.42),('7643','2014-02-25','15:15:00',8.14),('7643','2014-02-25','15:20:00',6.83),('7643','2014-02-25','15:25:00',4.66),('7643','2014-02-25','15:30:00',4.56),('7643','2014-02-25','15:35:00',6.09),('7643','2014-02-25','15:40:00',5.78),('7643','2014-02-25','15:45:00',4.72),('7643','2014-02-25','15:50:00',4.4),('7643','2014-02-25','15:55:00',5.55),('7643','2014-02-25','16:00:00',6.44),('7643','2014-02-25','16:05:00',5.97),('7643','2014-02-25','16:10:00',4.04),('7643','2014-02-25','16:15:00',2.77),('7643','2014-02-25','16:20:00',3.15),('7643','2014-02-25','16:25:00',2.27),('7643','2014-02-25','16:30:00',1.76),('7643','2014-02-25','16:35:00',1.57),('7643','2014-02-25','16:40:00',1.28),('7643','2014-04-28','09:00:00',1.01),('7643','2014-04-28','09:05:00',1.3),('7643','2014-04-28','09:10:00',1.47),('7643','2014-04-28','09:15:00',1.79),('7643','2014-04-28','09:20:00',1.68),('7643','2014-04-28','09:25:00',1.35),('7643','2014-04-28','09:30:00',1.37),('7643','2014-04-28','09:35:00',1.55),('7643','2014-04-28','09:40:00',1.96),('7643','2014-04-28','09:45:00',2.71),('7643','2014-04-28','09:50:00',3.66),('7643','2014-04-28','09:55:00',4.15),('7643','2014-04-28','10:00:00',4.19),('7643','2014-04-28','10:05:00',6.75),('7643','2014-04-28','10:10:00',14.81),('7643','2014-04-28','10:15:00',11.75),('7643','2014-04-28','10:20:00',11.95),('7643','2014-04-28','10:25:00',13.33),('7643','2014-04-28','10:30:00',15.37),('7643','2014-04-28','10:35:00',15.59),('7643','2014-04-28','10:40:00',15.66),('7643','2014-04-28','10:45:00',15.66),('7643','2014-04-28','10:50:00',15.95),('7643','2014-04-28','10:55:00',15.48),('7643','2014-04-28','11:00:00',15.6),('7643','2014-04-28','11:05:00',15.6),('7643','2014-04-28','11:10:00',15.9),('7643','2014-04-28','11:15:00',15.76),('7643','2014-04-28','11:20:00',14.79),('7643','2014-04-28','11:25:00',13.44),('7643','2014-04-28','11:30:00',13.87),('7643','2014-04-28','11:35:00',11.76),('7643','2014-04-28','11:40:00',17.83),('7643','2014-04-28','11:45:00',11.2),('7643','2014-04-28','11:50:00',5.18),('7643','2014-04-28','11:55:00',4.48),('7643','2014-04-28','12:00:00',5.05),('7643','2014-04-28','12:05:00',7.06),('7643','2014-04-28','12:10:00',9.98),('7643','2014-04-28','12:15:00',15.54),('7643','2014-04-28','12:20:00',7.77),('7643','2014-04-28','12:25:00',11.81),('7643','2014-04-28','12:30:00',11.2),('7643','2014-04-28','12:35:00',14.56),('7643','2014-04-28','12:40:00',19),('7643','2014-04-28','12:45:00',8.72),('7643','2014-04-28','12:50:00',17.21),('7643','2014-04-28','12:55:00',14.37),('7643','2014-04-28','13:00:00',8.34),('7643','2014-04-28','13:05:00',6.83),('7643','2014-04-28','13:10:00',7.04),('7643','2014-04-28','13:15:00',10.89),('7643','2014-04-28','13:20:00',9.71),('7643','2014-04-28','13:25:00',10.49),('7643','2014-04-28','13:30:00',16.09),('7643','2014-04-28','13:35:00',6.59),('7643','2014-04-28','13:40:00',5.77),('7643','2014-04-28','13:45:00',5.89),('7643','2014-04-28','13:50:00',9.25),('7643','2014-04-28','13:55:00',7.02),('7643','2014-04-28','14:00:00',2.72),('7643','2014-04-28','14:05:00',1.68),('7643','2014-04-28','14:10:00',1.39),('7643','2014-04-28','14:15:00',1.46),('7643','2014-04-28','14:20:00',1.83),('7643','2014-04-28','14:25:00',2.34),('7643','2014-04-28','14:30:00',2.4),('7643','2014-04-28','14:35:00',2.62),('7643','2014-04-28','14:40:00',2.87),('7643','2014-04-28','14:45:00',2.49),('7643','2014-04-28','14:50:00',1.96),('7643','2014-04-28','14:55:00',1.98),('7643','2014-04-28','15:00:00',2.89),('7643','2014-04-28','15:05:00',4.53),('7643','2014-04-28','15:10:00',3.25),('7643','2014-04-28','15:15:00',2.01),('7643','2014-04-28','15:20:00',1.53),('7643','2014-04-28','15:25:00',1.97),('7643','2014-04-28','15:30:00',2.32),('7643','2014-04-28','15:35:00',2.22),('7643','2014-04-28','15:40:00',1.48),('7643','2014-04-28','15:45:00',1.28),('7643','2014-04-28','15:50:00',1.36),('7643','2014-04-28','15:55:00',1.59),('7643','2014-04-28','16:00:00',1.73),('7643','2014-04-28','16:05:00',2.14),('7643','2014-04-28','16:10:00',2.53),('7643','2014-04-28','16:15:00',3.23),('7643','2014-04-28','16:20:00',3.78),('7643','2014-04-28','16:25:00',4.35),('7643','2014-04-28','16:30:00',3.87),('7643','2014-04-28','16:35:00',3.19),('7643','2014-04-28','16:40:00',2.55),('7643','2014-04-28','16:45:00',2.3),('7643','2014-04-28','16:50:00',2.5),('7643','2014-04-28','16:55:00',2.9),('7643','2014-04-28','17:00:00',3.44),('7643','2014-04-28','17:05:00',4.49),('7643','2014-04-28','17:10:00',4.55),('7643','2014-04-28','17:15:00',3.51),('7643','2014-04-28','17:20:00',3.25),('7643','2014-04-28','17:25:00',5.67),('7643','2014-04-28','17:30:00',6.29),('7643','2014-04-28','17:35:00',6.26),('7643','2014-04-28','17:40:00',5.92),('7643','2014-04-28','17:45:00',7.19),('7643','2014-04-28','17:50:00',4.29),('7643','2014-04-28','17:55:00',1.83),('7643','2014-04-28','18:00:00',2.38),('7643','2014-04-28','18:05:00',2.84),('7643','2014-04-28','18:10:00',2.12),('7643','2014-04-28','18:15:00',1.16),('7643','2014-04-28','18:30:00',1.47),('7643','2014-04-28','18:35:00',1.45),('7643','2014-04-28','18:40:00',1.2),('7643','2014-04-28','19:00:00',1.17),('7643','2014-02-24','07:25:00',1.18),('7643','2014-02-24','07:30:00',1.45),('7643','2014-02-24','07:35:00',1.74),('7643','2014-02-24','07:40:00',2.06),('7643','2014-02-24','07:45:00',2.39),('7643','2014-02-24','07:50:00',2.75),('7643','2014-02-24','07:55:00',3.1),('7643','2014-02-24','08:00:00',3.45),('7643','2014-02-24','08:05:00',3.79),('7643','2014-02-24','08:10:00',4.14),('7643','2014-02-24','08:15:00',4.51),('7643','2014-02-24','08:20:00',4.88),('7643','2014-02-24','08:25:00',5.24),('7643','2014-02-24','08:30:00',5.61),('7643','2014-02-24','08:35:00',5.93),('7643','2014-02-24','08:40:00',6.25),('7643','2014-02-24','08:45:00',6.63),('7643','2014-02-24','08:50:00',6.94),('7643','2014-02-24','08:55:00',7.26),('7643','2014-02-24','09:00:00',7.58),('7643','2014-02-24','09:05:00',7.89),('7643','2014-02-24','09:10:00',8.12),('7643','2014-02-24','09:15:00',8.41),('7643','2014-02-24','09:20:00',8.67),('7643','2014-02-24','09:25:00',8.86),('7643','2014-02-24','09:30:00',9.16),('7643','2014-02-24','09:35:00',9.36),('7643','2014-02-24','09:40:00',9.6),('7643','2014-02-24','09:45:00',9.8),('7643','2014-02-24','09:50:00',10.03),('7643','2014-02-24','09:55:00',10.23),('7643','2014-02-24','10:00:00',10.38),('7643','2014-02-24','10:05:00',10.6),('7643','2014-02-24','10:10:00',10.82),('7643','2014-02-24','10:15:00',11.01),('7643','2014-02-24','10:20:00',11.21),('7643','2014-02-24','10:25:00',11.36),('7643','2014-02-24','10:30:00',11.41),('7643','2014-02-24','10:35:00',11.46),('7643','2014-02-24','10:40:00',11.63),('7643','2014-02-24','10:45:00',11.76),('7643','2014-02-24','10:50:00',11.8),('7643','2014-02-24','10:55:00',11.99),('7643','2014-02-24','11:00:00',12.11),('7643','2014-02-24','11:05:00',12.2),('7643','2014-02-24','11:10:00',12.36),('7643','2014-02-24','11:15:00',12.4),('7643','2014-02-24','11:20:00',12.63),('7643','2014-02-24','11:25:00',12.64),('7643','2014-02-24','11:30:00',12.64),('7643','2014-02-24','11:35:00',12.77),('7643','2014-02-24','11:40:00',12.74),('7643','2014-02-24','11:45:00',12.79),('7643','2014-02-24','11:50:00',12.8),('7643','2014-02-24','11:55:00',12.79),('7643','2014-02-24','12:00:00',12.59),('7643','2014-02-24','12:05:00',13.06),('7643','2014-02-24','12:10:00',13.12),('7643','2014-02-24','12:15:00',13.14),('7643','2014-02-24','12:20:00',13.03),('7643','2014-02-24','12:25:00',12.94),('7643','2014-02-24','12:30:00',12.98),('7643','2014-02-24','12:35:00',12.96),('7643','2014-02-24','12:40:00',12.97),('7643','2014-02-24','12:45:00',12.9),('7643','2014-02-24','12:50:00',12.97),('7643','2014-02-24','12:55:00',13.1),('7643','2014-02-24','13:00:00',12.72),('7643','2014-02-24','13:05:00',12.94),('7643','2014-02-24','13:10:00',12.78),('7643','2014-02-24','13:15:00',7.46),('7643','2014-02-24','13:20:00',3.41),('7643','2014-02-24','13:25:00',3.13),('7643','2014-02-24','13:30:00',3.18),('7643','2014-02-24','13:35:00',4.65),('7643','2014-02-24','13:40:00',5.07),('7643','2014-02-24','13:45:00',3.92),('7643','2014-02-24','13:50:00',3.66),('7643','2014-02-24','13:55:00',4.42),('7643','2014-02-24','14:00:00',4.76),('7643','2014-02-24','14:05:00',4.12),('7643','2014-02-24','14:10:00',3.61),('7643','2014-02-24','14:15:00',3.99),('7643','2014-02-24','14:20:00',4.11),('7643','2014-02-24','14:25:00',4.57),('7643','2014-02-24','14:30:00',5.11),('7643','2014-02-24','14:35:00',8.49),('7643','2014-02-24','14:40:00',10.58),('7643','2014-02-24','14:45:00',10.42),('7643','2014-02-24','14:50:00',10.14),('7643','2014-02-24','14:55:00',6.07),('7643','2014-02-24','15:00:00',9.09),('7643','2014-02-24','15:05:00',8.83),('7643','2014-02-24','15:10:00',8.82),('7643','2014-02-24','15:15:00',8.34),('7643','2014-02-24','15:20:00',8.03),('7643','2014-02-24','15:25:00',6.96),('7643','2014-02-24','15:30:00',6.09),('7643','2014-02-24','15:35:00',5.56),('7643','2014-02-24','15:40:00',6.17),('7643','2014-02-24','15:45:00',4.43),('7643','2014-02-24','15:50:00',3.3),('7643','2014-02-24','15:55:00',3.69),('7643','2014-02-24','16:00:00',3.31),('7643','2014-02-24','16:05:00',3.65),('7643','2014-02-24','16:10:00',3.46),('7643','2014-02-24','16:15:00',3.69),('7643','2014-02-24','16:20:00',3.91),('7643','2014-02-24','16:25:00',3.18),('7643','2014-02-24','16:30:00',1.72),('7643','2014-02-24','16:35:00',1.25),('7643','2014-02-24','16:40:00',1.12),('7643','2014-02-23','07:20:00',1.05),('7643','2014-02-23','07:25:00',1.34),('7643','2014-02-23','07:30:00',1.65),('7643','2014-02-23','07:35:00',1.92),('7643','2014-02-23','07:40:00',2.15),('7643','2014-02-23','07:45:00',1.35),('7643','2014-02-23','07:50:00',2.27),('7643','2014-02-23','07:55:00',3.23),('7643','2014-02-23','08:00:00',3.79),('7643','2014-02-23','08:05:00',4.52),('7643','2014-02-23','08:10:00',5.16),('7643','2014-02-23','08:15:00',5.65),('7643','2014-02-23','08:20:00',6.07),('7643','2014-02-23','08:25:00',6.54),('7643','2014-02-23','08:30:00',7.01),('7643','2014-02-23','08:35:00',7.44),('7643','2014-02-23','08:40:00',6.59),('7643','2014-02-23','08:45:00',7.99),('7643','2014-02-23','08:50:00',7.54),('7643','2014-02-23','08:55:00',7.46),('7643','2014-02-23','09:00:00',7.55),('7643','2014-02-23','09:05:00',7.79),('7643','2014-02-23','09:10:00',8.09),('7643','2014-02-23','09:15:00',8.4),('7643','2014-02-23','09:20:00',8.64),('7643','2014-02-23','09:25:00',8.86),('7643','2014-02-23','09:30:00',9.21),('7643','2014-02-23','09:35:00',9.4),('7643','2014-02-23','09:40:00',9.62),('7643','2014-02-23','09:45:00',9.89),('7643','2014-02-23','09:50:00',10.13),('7643','2014-02-23','09:55:00',10.33),('7643','2014-02-23','10:00:00',10.54),('7643','2014-02-23','10:05:00',10.76),('7643','2014-02-23','10:10:00',10.99),('7643','2014-02-23','10:15:00',11.22),('7643','2014-02-23','10:20:00',11.39),('7643','2014-02-23','10:25:00',11.57),('7643','2014-02-23','10:30:00',11.74),('7643','2014-02-23','10:35:00',11.9),('7643','2014-02-23','10:40:00',12.03),('7643','2014-02-23','10:45:00',12.27),('7643','2014-02-23','10:50:00',12.43),('7643','2014-02-23','10:55:00',12.52),('7643','2014-02-23','11:00:00',12.62),('7643','2014-02-23','11:05:00',12.79),('7643','2014-02-23','11:10:00',12.95),('7643','2014-02-23','11:15:00',12.96),('7643','2014-02-23','11:20:00',12.95),('7643','2014-02-23','11:25:00',13.23),('7643','2014-02-23','11:30:00',14.58),('7643','2014-02-23','11:35:00',10.22),('7643','2014-02-23','11:40:00',13.7),('7643','2014-02-23','11:45:00',15),('7643','2014-02-23','11:50:00',12.33),('7643','2014-02-23','11:55:00',8.91),('7643','2014-02-23','12:00:00',13.31),('7643','2014-02-23','12:05:00',10.75),('7643','2014-02-23','12:10:00',12.08),('7643','2014-02-23','12:15:00',13.08),('7643','2014-02-23','12:20:00',8.44),('7643','2014-02-23','12:25:00',14.26),('7643','2014-02-23','12:30:00',12.87),('7643','2014-02-23','12:35:00',7.07),('7643','2014-02-23','12:40:00',12.15),('7643','2014-02-23','12:45:00',11.72),('7643','2014-02-23','12:50:00',14.32),('7643','2014-02-23','12:55:00',14),('7643','2014-02-23','13:00:00',14.04),('7643','2014-02-23','13:05:00',13.22),('7643','2014-02-23','13:10:00',14.77),('7643','2014-02-23','13:15:00',16.58),('7643','2014-02-23','13:20:00',8.19),('7643','2014-02-23','13:25:00',3.97),('7643','2014-02-23','13:30:00',3.51),('7643','2014-02-23','13:35:00',3.22),('7643','2014-02-23','13:40:00',3.03),('7643','2014-02-23','13:45:00',2.82),('7643','2014-02-23','13:50:00',2.68),('7643','2014-02-23','13:55:00',2.84),('7643','2014-02-23','14:00:00',3.08),('7643','2014-02-23','14:05:00',3.22),('7643','2014-02-23','14:10:00',3.42),('7643','2014-02-23','14:15:00',3.45),('7643','2014-02-23','14:20:00',3.41),('7643','2014-02-23','14:25:00',3.52),('7643','2014-02-23','14:30:00',3.73),('7643','2014-02-23','14:35:00',3.68),('7643','2014-02-23','14:40:00',3.68),('7643','2014-02-23','14:45:00',4),('7643','2014-02-23','14:50:00',3.72),('7643','2014-02-23','14:55:00',3.06),('7643','2014-02-23','15:00:00',2.9),('7643','2014-02-23','15:05:00',3.08),('7643','2014-02-23','15:10:00',3.38),('7643','2014-02-23','15:15:00',3.54),('7643','2014-02-23','15:20:00',4.14),('7643','2014-02-23','15:25:00',5.31),('7643','2014-02-23','15:30:00',5.96),('7643','2014-02-23','15:35:00',8.44),('7643','2014-02-23','15:40:00',9.37),('7643','2014-02-23','15:45:00',8.85),('7643','2014-02-23','15:50:00',8.39),('7643','2014-02-23','15:55:00',7.21),('7643','2014-02-23','16:00:00',7.54),('7643','2014-02-23','16:05:00',7.57),('7643','2014-02-23','16:10:00',6.99),('7643','2014-02-23','16:15:00',6.33),('7643','2014-02-23','16:20:00',5.25),('7643','2014-02-23','16:25:00',4.14),('7643','2014-02-23','16:30:00',2.09),('7643','2014-02-23','16:35:00',1.51),('7643','2014-02-23','16:45:00',2.26),('7643','2014-02-23','16:50:00',2.28),('7643','2014-02-23','16:55:00',2.04),('7643','2014-02-23','17:00:00',1.75),('7643','2014-02-23','17:05:00',1.45),('7643','2014-02-23','17:10:00',1.18),('7643','2014-02-23','17:15:00',1.01),('7643','2014-02-22','07:30:00',1.31),('7643','2014-02-22','07:35:00',1.5),('7643','2014-02-22','07:40:00',1.84),('7643','2014-02-22','07:45:00',2.27),('7643','2014-02-22','07:50:00',2.63),('7643','2014-02-22','07:55:00',2.97),('7643','2014-02-22','08:00:00',3.3),('7643','2014-02-22','08:05:00',3.66),('7643','2014-02-22','08:10:00',4.01),('7643','2014-02-22','08:15:00',4.38),('7643','2014-02-22','08:20:00',4.74),('7643','2014-02-22','08:25:00',5.07),('7643','2014-02-22','08:30:00',5.41),('7643','2014-02-22','08:35:00',5.75),('7643','2014-02-22','08:40:00',6.09),('7643','2014-02-22','08:45:00',6.42),('7643','2014-02-22','08:50:00',6.74),('7643','2014-02-22','08:55:00',7.04),('7643','2014-02-22','09:00:00',7.38),('7643','2014-02-22','09:05:00',7.74),('7643','2014-02-22','09:10:00',8.09),('7643','2014-02-22','09:15:00',8.43),('7643','2014-02-22','09:20:00',8.73),('7643','2014-02-22','09:25:00',8.63),('7643','2014-02-22','09:30:00',8.05),('7643','2014-02-22','09:35:00',9.36),('7643','2014-02-22','09:40:00',9.62),('7643','2014-02-22','09:45:00',9.78),('7643','2014-02-22','09:50:00',10.02),('7643','2014-02-22','09:55:00',10.14),('7643','2014-02-22','10:00:00',10.24),('7643','2014-02-22','10:05:00',10.49),('7643','2014-02-22','10:10:00',10.68),('7643','2014-02-22','10:15:00',10.81),('7643','2014-02-22','10:20:00',11.13),('7643','2014-02-22','10:25:00',11.35),('7643','2014-02-22','10:30:00',11.57),('7643','2014-02-22','10:35:00',11.8),('7643','2014-02-22','10:40:00',11.91),('7643','2014-02-22','10:45:00',12.09),('7643','2014-02-22','10:50:00',11.99),('7643','2014-02-22','10:55:00',12.06),('7643','2014-02-22','11:00:00',12.35),('7643','2014-02-22','11:05:00',12.54),('7643','2014-02-22','11:10:00',12.76),('7643','2014-02-22','11:15:00',12.76),('7643','2014-02-22','11:20:00',12.86),('7643','2014-02-22','11:25:00',11.26),('7643','2014-02-22','11:30:00',12.29),('7643','2014-02-22','11:35:00',13.52),('7643','2014-02-22','11:40:00',13.6),('7643','2014-02-22','11:45:00',13.26),('7643','2014-02-22','11:50:00',8.4),('7643','2014-02-22','11:55:00',13.69),('7643','2014-02-22','12:00:00',8.57),('7643','2014-02-22','12:05:00',12.78),('7643','2014-02-22','12:10:00',14.75),('7643','2014-02-22','12:15:00',14.61),('7643','2014-02-22','12:20:00',13.61),('7643','2014-02-22','12:25:00',8.85),('7643','2014-02-22','12:30:00',9.45),('7643','2014-02-22','12:35:00',14.96),('7643','2014-02-22','12:40:00',8.78),('7643','2014-02-22','12:45:00',9.03),('7643','2014-02-22','12:50:00',6.98),('7643','2014-02-22','12:55:00',7.51),('7643','2014-02-22','13:00:00',8.57),('7643','2014-02-22','13:05:00',13.15),('7643','2014-02-22','13:10:00',13.38),('7643','2014-02-22','13:15:00',13.16),('7643','2014-02-22','13:20:00',13.02),('7643','2014-02-22','13:25:00',13.04),('7643','2014-02-22','13:30:00',12.77),('7643','2014-02-22','13:35:00',8),('7643','2014-02-22','13:40:00',9.79),('7643','2014-02-22','13:45:00',10.83),('7643','2014-02-22','13:50:00',9.79),('7643','2014-02-22','13:55:00',2.75),('7643','2014-02-22','14:00:00',10.16),('7643','2014-02-22','14:05:00',10.44),('7643','2014-02-22','14:10:00',12.09),('7643','2014-02-22','14:15:00',9.95),('7643','2014-02-22','14:20:00',6.34),('7643','2014-02-22','14:25:00',8.75),('7643','2014-02-22','14:30:00',11.53),('7643','2014-02-22','14:35:00',9.09),('7643','2014-02-22','14:40:00',4.52),('7643','2014-02-22','14:45:00',4.36),('7643','2014-02-22','14:50:00',4.28),('7643','2014-02-22','14:55:00',2.5),('7643','2014-02-22','15:00:00',2.2),('7643','2014-02-22','15:05:00',1.73),('7643','2014-02-22','15:10:00',1.28),('7643','2014-02-22','15:15:00',1.01),('7643','2014-02-21','08:30:00',1.39),('7643','2014-02-21','08:35:00',1.55),('7643','2014-02-21','08:40:00',2.3),('7643','2014-02-21','08:45:00',1.84),('7643','2014-02-21','08:50:00',1.68),('7643','2014-02-21','08:55:00',1.06),('7643','2014-02-21','09:00:00',1.83),('7643','2014-02-21','09:05:00',3.12),('7643','2014-02-21','09:10:00',4.68),('7643','2014-02-21','09:15:00',2.04),('7643','2014-02-21','09:20:00',2.22),('7643','2014-02-21','09:25:00',2.93),('7643','2014-02-21','09:30:00',2.73),('7643','2014-02-21','09:35:00',2.94),('7643','2014-02-21','09:40:00',3.07),('7643','2014-02-21','09:45:00',3.01),('7643','2014-02-21','09:50:00',3.46),('7643','2014-02-21','09:55:00',3.58),('7643','2014-02-21','10:00:00',5.64),('7643','2014-02-21','10:05:00',8.91),('7643','2014-02-21','10:10:00',7.97),('7643','2014-02-21','10:15:00',8.87),('7643','2014-02-21','10:20:00',4.83),('7643','2014-02-21','10:25:00',7.74),('7643','2014-02-21','10:30:00',9.86),('7643','2014-02-21','10:35:00',6.36),('7643','2014-02-21','10:40:00',5.86),('7643','2014-02-21','10:45:00',10.93),('7643','2014-02-21','10:50:00',13.93),('7643','2014-02-21','10:55:00',4.58),('7643','2014-02-21','11:00:00',2.91),('7643','2014-02-21','11:05:00',2.13),('7643','2014-02-21','11:10:00',2.99),('7643','2014-02-21','11:15:00',2.76),('7643','2014-02-21','11:20:00',1.9),('7643','2014-02-21','11:25:00',1.48),('7643','2014-02-21','11:30:00',1.33),('7643','2014-02-21','11:45:00',1.1),('7643','2014-02-21','11:50:00',1.95),('7643','2014-02-21','11:55:00',2.71),('7643','2014-02-21','12:00:00',3.69),('7643','2014-02-21','12:05:00',4.17),('7643','2014-02-21','12:10:00',5.09),('7643','2014-02-21','12:15:00',8.03),('7643','2014-02-21','12:20:00',6.81),('7643','2014-02-21','12:25:00',6.81),('7643','2014-02-21','12:30:00',3.98),('7643','2014-02-21','12:35:00',4.01),('7643','2014-02-21','12:40:00',4.63),('7643','2014-02-21','12:45:00',13.67),('7643','2014-02-21','12:50:00',11.37),('7643','2014-02-21','12:55:00',5.57),('7643','2014-02-21','13:00:00',5.22),('7643','2014-02-21','13:05:00',6.39),('7643','2014-02-21','13:10:00',15.88),('7643','2014-02-21','13:15:00',9.92),('7643','2014-02-21','13:20:00',5.53),('7643','2014-02-21','13:25:00',3.96),('7643','2014-02-21','13:30:00',4.12),('7643','2014-02-21','13:35:00',5.52),('7643','2014-02-21','13:40:00',6.62),('7643','2014-02-21','13:45:00',5.63),('7643','2014-02-21','13:50:00',4.84),('7643','2014-02-21','13:55:00',13.31),('7643','2014-02-21','14:00:00',13.06),('7643','2014-02-21','14:05:00',8.72),('7643','2014-02-21','14:10:00',7.47),('7643','2014-02-21','14:15:00',7.15),('7643','2014-02-21','14:20:00',11.5),('7643','2014-02-21','14:25:00',8.88),('7643','2014-02-21','14:30:00',9.68),('7643','2014-02-21','14:35:00',3.32),('7643','2014-02-21','14:40:00',9.3),('7643','2014-02-21','14:45:00',11.07),('7643','2014-02-21','14:50:00',10.74),('7643','2014-02-21','14:55:00',2.98),('7643','2014-02-21','15:00:00',5.63),('7643','2014-02-21','15:05:00',8.03),('7643','2014-02-21','15:10:00',5.15),('7643','2014-02-21','15:15:00',3.98),('7643','2014-02-21','15:20:00',6.12),('7643','2014-02-21','15:25:00',3.44),('7643','2014-02-21','15:30:00',7.69),('7643','2014-02-21','15:35:00',6.26),('7643','2014-02-21','15:40:00',1.64),('7643','2014-02-21','15:45:00',6.65),('7643','2014-02-21','15:50:00',6.5),('7643','2014-02-21','15:55:00',5.48),('7643','2014-02-21','16:00:00',5.96),('7643','2014-02-21','16:05:00',4.04),('7643','2014-02-21','16:10:00',3.92),('7643','2014-02-21','16:15:00',4.72),('7643','2014-02-21','16:20:00',4.29),('7643','2014-02-21','16:25:00',3.91),('7643','2014-02-21','16:30:00',3.49),('7643','2014-02-21','16:35:00',3.22),('7643','2014-02-21','16:40:00',2.82),('7643','2014-02-21','16:45:00',2.63),('7643','2014-02-21','16:50:00',2.28),('7643','2014-02-21','16:55:00',1.66),('7643','2014-02-21','17:00:00',1.53),('7643','2014-02-21','17:05:00',1.28),('7643','2014-02-20','08:05:00',1.02),('7643','2014-02-20','08:10:00',1.22),('7643','2014-02-20','08:15:00',1.42),('7643','2014-02-20','08:20:00',1.62),('7643','2014-02-20','08:25:00',1.8),('7643','2014-02-20','08:30:00',1.97),('7643','2014-02-20','08:35:00',2.11),('7643','2014-02-20','08:40:00',2.3),('7643','2014-02-20','08:45:00',2.5),('7643','2014-02-20','08:50:00',2.59),('7643','2014-02-20','08:55:00',2.71),('7643','2014-02-20','09:00:00',2.62),('7643','2014-02-20','09:05:00',2.6),('7643','2014-02-20','09:10:00',2.67),('7643','2014-02-20','09:15:00',2.7),('7643','2014-02-20','09:20:00',3.01),('7643','2014-02-20','09:25:00',3.19),('7643','2014-02-20','09:30:00',3.27),('7643','2014-02-20','09:35:00',3.46),('7643','2014-02-20','09:40:00',3.63),('7643','2014-02-20','09:45:00',3.92),('7643','2014-02-20','09:50:00',4.48),('7643','2014-02-20','09:55:00',4.35),('7643','2014-02-20','10:00:00',4.41),('7643','2014-02-20','10:05:00',5.21),('7643','2014-02-20','10:10:00',5.11),('7643','2014-02-20','10:15:00',5.71),('7643','2014-02-20','10:20:00',7.61),('7643','2014-02-20','10:25:00',9.32),('7643','2014-02-20','10:30:00',10.93),('7643','2014-02-20','10:35:00',8.03),('7643','2014-02-20','10:40:00',7.1),('7643','2014-02-20','10:45:00',6.7),('7643','2014-02-20','10:50:00',5.74),('7643','2014-02-20','10:55:00',8.25),('7643','2014-02-20','11:00:00',6.9),('7643','2014-02-20','11:05:00',5.41),('7643','2014-02-20','11:10:00',5.49),('7643','2014-02-20','11:15:00',6.19),('7643','2014-02-20','11:20:00',6.25),('7643','2014-02-20','11:25:00',8.48),('7643','2014-02-20','11:30:00',14.32),('7643','2014-02-20','11:35:00',9.02),('7643','2014-02-20','11:40:00',10.02),('7643','2014-02-20','11:45:00',9.2),('7643','2014-02-20','11:50:00',6.46),('7643','2014-02-20','11:55:00',11.67),('7643','2014-02-20','12:00:00',15.75),('7643','2014-02-20','12:05:00',15.53),('7643','2014-02-20','12:10:00',11.96),('7643','2014-02-20','12:15:00',5.58),('7643','2014-02-20','12:20:00',5.48),('7643','2014-02-20','12:25:00',5.58),('7643','2014-02-20','12:30:00',5.33),('7643','2014-02-20','12:35:00',4.34),('7643','2014-02-20','12:40:00',3.79),('7643','2014-02-20','12:45:00',3.09),('7643','2014-02-20','12:50:00',2.97),('7643','2014-02-20','12:55:00',2.66),('7643','2014-02-20','13:00:00',1.83),('7643','2014-02-20','13:05:00',1.04),('7643','2014-02-20','13:35:00',1.14),('7643','2014-02-20','13:40:00',1.43),('7643','2014-02-20','13:45:00',1.66),('7643','2014-02-20','13:50:00',1.82),('7643','2014-02-20','13:55:00',1.84),('7643','2014-02-20','14:00:00',1.75),('7643','2014-02-20','14:05:00',1.78),('7643','2014-02-20','14:10:00',1.97),('7643','2014-02-20','14:15:00',2.2),('7643','2014-02-20','14:20:00',2.42),('7643','2014-02-20','14:25:00',2.47),('7643','2014-02-20','14:30:00',2.51),('7643','2014-02-20','14:35:00',2.4),('7643','2014-02-20','14:40:00',2.65),('7643','2014-02-20','14:45:00',3.02),('7643','2014-02-20','14:50:00',2.99),('7643','2014-02-20','14:55:00',3.18),('7643','2014-02-20','15:00:00',3.43),('7643','2014-02-20','15:05:00',6.33),('7643','2014-02-20','15:10:00',2.9),('7643','2014-02-20','15:15:00',2.21),('7643','2014-02-20','15:20:00',2.83),('7643','2014-02-20','15:25:00',4.19),('7643','2014-02-20','15:30:00',6.83),('7643','2014-02-20','15:35:00',6.94),('7643','2014-02-20','15:40:00',6.53),('7643','2014-02-20','15:45:00',6.34),('7643','2014-02-20','15:50:00',5.93),('7643','2014-02-20','15:55:00',5.39),('7643','2014-02-20','16:00:00',5.2),('7643','2014-02-20','16:05:00',4.85),('7643','2014-02-20','16:10:00',4.48),('7643','2014-02-20','16:15:00',4.13),('7643','2014-02-20','16:20:00',3.82),('7643','2014-02-20','16:25:00',3.47),('7643','2014-02-20','16:30:00',3.14),('7643','2014-02-20','16:35:00',2.82),('7643','2014-02-20','16:40:00',2.51),('7643','2014-02-20','16:45:00',2.19),('7643','2014-02-20','16:50:00',1.95),('7643','2014-02-20','16:55:00',1.72),('7643','2014-02-20','17:00:00',1.48),('7643','2014-02-20','17:05:00',1.23),('7643','2014-02-20','17:10:00',1.02),('7643','2014-02-19','08:10:00',1.11),('7643','2014-02-19','08:15:00',1.29),('7643','2014-02-19','08:20:00',1.36),('7643','2014-02-19','08:40:00',1.07),('7643','2014-02-19','08:50:00',1.04),('7643','2014-02-19','08:55:00',1.19),('7643','2014-02-19','09:00:00',1.29),('7643','2014-02-19','09:05:00',1.26),('7643','2014-02-19','09:10:00',1.42),('7643','2014-02-19','09:35:00',1.21),('7643','2014-02-19','09:40:00',1.16),('7643','2014-02-19','10:00:00',1.07),('7643','2014-02-19','10:05:00',1.59),('7643','2014-02-19','10:10:00',1.87),('7643','2014-02-19','10:15:00',1.32),('7643','2014-02-19','10:25:00',1.22),('7643','2014-02-19','10:30:00',1.39),('7643','2014-02-19','10:35:00',1.21),('7643','2014-02-19','10:40:00',1.25),('7643','2014-02-19','10:45:00',1.98),('7643','2014-02-19','10:50:00',2.03),('7643','2014-02-19','10:55:00',2.43),('7643','2014-02-19','11:00:00',1.6),('7643','2014-02-19','11:05:00',1.02),('7643','2014-02-19','11:15:00',1.75),('7643','2014-02-19','11:20:00',2.99),('7643','2014-02-19','11:25:00',3.57),('7643','2014-02-19','11:30:00',3.51),('7643','2014-02-19','11:35:00',2.95),('7643','2014-02-19','11:40:00',2.02),('7643','2014-02-19','11:45:00',2.23),('7643','2014-02-19','11:50:00',2.26),('7643','2014-02-19','11:55:00',2.75),('7643','2014-02-19','12:00:00',3.38),('7643','2014-02-19','12:05:00',2.34),('7643','2014-02-19','12:10:00',2.14),('7643','2014-02-19','12:15:00',1.98),('7643','2014-02-19','12:20:00',2.46),('7643','2014-02-19','12:25:00',3.15),('7643','2014-02-19','12:30:00',3.55),('7643','2014-02-19','12:35:00',3.41),('7643','2014-02-19','12:40:00',3.51),('7643','2014-02-19','12:45:00',3.05),('7643','2014-02-19','12:50:00',3.12),('7643','2014-02-19','12:55:00',4.08),('7643','2014-02-19','13:00:00',4.79),('7643','2014-02-19','13:05:00',2.81),('7643','2014-02-19','13:10:00',2.36),('7643','2014-02-19','13:15:00',4.36),('7643','2014-02-19','13:20:00',3.87),('7643','2014-02-19','13:25:00',2.99),('7643','2014-02-19','13:30:00',4.12),('7643','2014-02-19','13:35:00',3.75),('7643','2014-02-19','13:40:00',2.3),('7643','2014-02-19','13:45:00',1.87),('7643','2014-02-19','13:50:00',1.91),('7643','2014-02-19','13:55:00',2.18),('7643','2014-02-19','14:00:00',3.23),('7643','2014-02-19','14:05:00',2.17),('7643','2014-02-19','14:10:00',1.61),('7643','2014-02-19','14:15:00',2.2),('7643','2014-02-19','14:20:00',1.91),('7643','2014-02-19','14:25:00',1.84),('7643','2014-02-19','14:30:00',1.79),('7643','2014-02-19','14:35:00',1.52),('7643','2014-02-19','14:40:00',1.2),('7643','2014-02-19','14:45:00',1.24),('7643','2014-02-19','14:50:00',1.74),('7643','2014-02-19','15:25:00',1.06),('7643','2014-02-18','08:20:00',1.06),('7643','2014-02-18','08:25:00',1.33),('7643','2014-02-18','08:30:00',1.75),('7643','2014-02-18','08:35:00',2.22),('7643','2014-02-18','08:40:00',2.39),('7643','2014-02-18','08:45:00',2.62),('7643','2014-02-18','08:50:00',2.39),('7643','2014-02-18','08:55:00',2.34),('7643','2014-02-18','09:00:00',2.52),('7643','2014-02-18','09:05:00',2.53),('7643','2014-02-18','09:10:00',2.43),('7643','2014-02-18','09:15:00',2.75),('7643','2014-02-18','09:20:00',3.17),('7643','2014-02-18','09:25:00',3.65),('7643','2014-02-18','09:30:00',3.78),('7643','2014-02-18','09:35:00',4.41),('7643','2014-02-18','09:40:00',4.69),('7643','2014-02-18','09:45:00',5.6),('7643','2014-02-18','09:50:00',5.25),('7643','2014-02-18','09:55:00',4.82),('7643','2014-02-18','10:00:00',4.65),('7643','2014-02-18','10:05:00',4.64),('7643','2014-02-18','10:10:00',4.99),('7643','2014-02-18','10:15:00',5.22),('7643','2014-02-18','10:20:00',4.68),('7643','2014-02-18','10:25:00',4.82),('7643','2014-02-18','10:30:00',5.27),('7643','2014-02-18','10:35:00',5.52),('7643','2014-02-18','10:40:00',6.46),('7643','2014-02-18','10:45:00',7.2),('7643','2014-02-18','10:50:00',6.45),('7643','2014-02-18','10:55:00',5.69),('7643','2014-02-18','11:00:00',5.18),('7643','2014-02-18','11:05:00',5.59),('7643','2014-02-18','11:10:00',6.54),('7643','2014-02-18','11:15:00',6.26),('7643','2014-02-18','11:20:00',6.75),('7643','2014-02-18','11:25:00',6.45),('7643','2014-02-18','11:30:00',6.24),('7643','2014-02-18','11:35:00',5.95),('7643','2014-02-18','11:40:00',5.39),('7643','2014-02-18','11:45:00',5.41),('7643','2014-02-18','11:50:00',5.04),('7643','2014-02-18','11:55:00',4.29),('7643','2014-02-18','12:00:00',4.81),('7643','2014-02-18','12:05:00',5.5),('7643','2014-02-18','12:10:00',5.34),('7643','2014-02-18','12:15:00',5.16),('7643','2014-02-18','12:20:00',4.38),('7643','2014-02-18','12:25:00',5.07),('7643','2014-02-18','12:30:00',6.11),('7643','2014-02-18','12:35:00',4.9),('7643','2014-02-18','12:40:00',4.8),('7643','2014-02-18','12:45:00',4.77),('7643','2014-02-18','12:50:00',3.68),('7643','2014-02-18','12:55:00',2.99),('7643','2014-02-18','13:00:00',3.57),('7643','2014-02-18','13:05:00',4.11),('7643','2014-02-18','13:10:00',3.87),('7643','2014-02-18','13:15:00',4.2),('7643','2014-02-18','13:20:00',4.64),('7643','2014-02-18','13:25:00',4.93),('7643','2014-02-18','13:30:00',4.91),('7643','2014-02-18','13:35:00',6.06),('7643','2014-02-18','13:40:00',5.69),('7643','2014-02-18','13:45:00',6.27),('7643','2014-02-18','13:50:00',7.25),('7643','2014-02-18','13:55:00',6.86),('7643','2014-02-18','14:00:00',6.14),('7643','2014-02-18','14:05:00',7.01),('7643','2014-02-18','14:10:00',5.75),('7643','2014-02-18','14:15:00',5.15),('7643','2014-02-18','14:20:00',7.83),('7643','2014-02-18','14:25:00',6.22),('7643','2014-02-18','14:30:00',5.62),('7643','2014-02-18','14:35:00',6.18),('7643','2014-02-18','14:40:00',5.04),('7643','2014-02-18','14:45:00',4.94),('7643','2014-02-18','14:50:00',6.13),('7643','2014-02-18','14:55:00',5.68),('7643','2014-02-18','15:00:00',4.58),('7643','2014-02-18','15:05:00',4.52),('7643','2014-02-18','15:10:00',4.16),('7643','2014-02-18','15:15:00',5),('7643','2014-02-18','15:20:00',3.82),('7643','2014-02-18','15:25:00',4.32),('7643','2014-02-18','15:30:00',3.67),('7643','2014-02-18','15:35:00',3.28),('7643','2014-02-18','15:40:00',3.4),('7643','2014-02-18','15:45:00',3.43),('7643','2014-02-18','15:50:00',4.27),('7643','2014-02-18','15:55:00',3.54),('7643','2014-02-18','16:00:00',3.11),('7643','2014-02-18','16:05:00',2.88),('7643','2014-02-18','16:10:00',2.62),('7643','2014-02-18','16:15:00',2.57),('7643','2014-02-18','16:20:00',1.99),('7643','2014-02-18','16:25:00',1.54),('7643','2014-02-18','16:30:00',1.53),('7643','2014-02-18','16:35:00',1.32),('7643','2014-02-18','16:45:00',1.3),('7643','2014-02-18','16:50:00',1.03),('7643','2014-02-17','07:40:00',1.55),('7643','2014-02-17','07:45:00',1.86),('7643','2014-02-17','07:50:00',2.21),('7643','2014-02-17','07:55:00',2.55),('7643','2014-02-17','08:00:00',2.89),('7643','2014-02-17','08:05:00',3.24),('7643','2014-02-17','08:10:00',3.59),('7643','2014-02-17','08:15:00',3.92),('7643','2014-02-17','08:20:00',4.27),('7643','2014-02-17','08:25:00',4.61),('7643','2014-02-17','08:30:00',4.95),('7643','2014-02-17','08:35:00',5.28),('7643','2014-02-17','08:40:00',5.59),('7643','2014-02-17','08:45:00',5.91),('7643','2014-02-17','08:50:00',5.98),('7643','2014-02-17','08:55:00',6.5),('7643','2014-02-17','09:00:00',6.75),('7643','2014-02-17','09:05:00',7.04),('7643','2014-02-17','09:10:00',7.33),('7643','2014-02-17','09:15:00',7.62),('7643','2014-02-17','09:20:00',7.9),('7643','2014-02-17','09:25:00',8.11),('7643','2014-02-17','09:30:00',8.42),('7643','2014-02-17','09:35:00',8.63),('7643','2014-02-17','09:40:00',8.84),('7643','2014-02-17','09:45:00',9.05),('7643','2014-02-17','09:50:00',9.28),('7643','2014-02-17','09:55:00',9.54),('7643','2014-02-17','10:00:00',9.78),('7643','2014-02-17','10:05:00',9.95),('7643','2014-02-17','10:10:00',10.15),('7643','2014-02-17','10:15:00',10.29),('7643','2014-02-17','10:20:00',10.46),('7643','2014-02-17','10:25:00',10.57),('7643','2014-02-17','10:30:00',10.77),('7643','2014-02-17','10:35:00',10.93),('7643','2014-02-17','10:40:00',11.05),('7643','2014-02-17','10:45:00',11.18),('7643','2014-02-17','10:50:00',11.29),('7643','2014-02-17','10:55:00',11.51),('7643','2014-02-17','11:00:00',11.53),('7643','2014-02-17','11:05:00',9.83),('7643','2014-02-17','11:10:00',9.51),('7643','2014-02-17','11:15:00',9.11),('7643','2014-02-17','11:20:00',10.63),('7643','2014-02-17','11:25:00',11.89),('7643','2014-02-17','11:30:00',10.93),('7643','2014-02-17','11:35:00',9.9),('7643','2014-02-17','11:40:00',8.06),('7643','2014-02-17','11:45:00',8.3),('7643','2014-02-17','11:50:00',7.03),('7643','2014-02-17','11:55:00',5.75),('7643','2014-02-17','12:00:00',5.5),('7643','2014-02-17','12:05:00',5.55),('7643','2014-02-17','12:10:00',6.46),('7643','2014-02-17','12:15:00',6.94),('7643','2014-02-17','12:20:00',6.72),('7643','2014-02-17','12:25:00',7.9),('7643','2014-02-17','12:30:00',8.94),('7643','2014-02-17','12:35:00',6.64),('7643','2014-02-17','12:40:00',5.98),('7643','2014-02-17','12:45:00',5.74),('7643','2014-02-17','12:50:00',6.16),('7643','2014-02-17','12:55:00',6.75),('7643','2014-02-17','13:00:00',5.12),('7643','2014-02-17','13:05:00',4.82),('7643','2014-02-17','13:10:00',5.26),('7643','2014-02-17','13:15:00',7.06),('7643','2014-02-17','13:20:00',7.52),('7643','2014-02-17','13:25:00',8.92),('7643','2014-02-17','13:30:00',6.38),('7643','2014-02-17','13:35:00',5.32),('7643','2014-02-17','13:40:00',6.93),('7643','2014-02-17','13:45:00',8.19),('7643','2014-02-17','13:50:00',6.19),('7643','2014-02-17','13:55:00',6.22),('7643','2014-02-17','14:00:00',7.22),('7643','2014-02-17','14:05:00',10.23),('7643','2014-02-17','14:10:00',5.9),('7643','2014-02-17','14:15:00',4.58),('7643','2014-02-17','14:20:00',4.08),('7643','2014-02-17','14:25:00',4.21),('7643','2014-02-17','14:30:00',5.35),('7643','2014-02-17','14:35:00',5.07),('7643','2014-02-17','14:40:00',4.17),('7643','2014-02-17','14:45:00',3.86),('7643','2014-02-17','14:50:00',3.62),('7643','2014-02-17','14:55:00',3.44),('7643','2014-02-17','15:00:00',3.21),('7643','2014-02-17','15:05:00',3.06),('7643','2014-02-17','15:10:00',3.02),('7643','2014-02-17','15:15:00',2.82),('7643','2014-02-17','15:20:00',2.5),('7643','2014-02-17','15:25:00',2.62),('7643','2014-02-17','15:30:00',2.96),('7643','2014-02-17','15:35:00',3.79),('7643','2014-02-17','15:40:00',4.85),('7643','2014-02-17','15:45:00',5.09),('7643','2014-02-17','15:50:00',4.01),('7643','2014-02-17','15:55:00',3.64),('7643','2014-02-17','16:00:00',3.67),('7643','2014-02-17','16:05:00',4.14),('7643','2014-02-17','16:10:00',3.46),('7643','2014-02-17','16:15:00',2.4),('7643','2014-02-17','16:20:00',2.04),('7643','2014-02-17','16:25:00',1.6),('7643','2014-02-17','16:30:00',2.11),('7643','2014-02-17','16:35:00',2.38),('7643','2014-02-17','16:40:00',2.02),('7643','2014-02-17','16:45:00',1.48),('7643','2014-02-17','16:50:00',1.59),('7643','2014-02-17','16:55:00',1.57),('7643','2014-02-17','17:00:00',1.49),('7643','2014-02-16','07:35:00',1.18),('7643','2014-02-16','07:40:00',1.41),('7643','2014-02-16','07:45:00',1.67),('7643','2014-02-16','07:50:00',1.93),('7643','2014-02-16','07:55:00',2.23),('7643','2014-02-16','08:00:00',2.52),('7643','2014-02-16','08:05:00',2.8),('7643','2014-02-16','08:10:00',3.11),('7643','2014-02-16','08:15:00',3.41),('7643','2014-02-16','08:20:00',3.72),('7643','2014-02-16','08:25:00',4.08),('7643','2014-02-16','08:30:00',4.38),('7643','2014-02-16','08:35:00',4.64),('7643','2014-02-16','08:40:00',4.94),('7643','2014-02-16','08:45:00',5.3),('7643','2014-02-16','08:50:00',5.52),('7643','2014-02-16','08:55:00',5.79),('7643','2014-02-16','09:00:00',6.05),('7643','2014-02-16','09:05:00',6.27),('7643','2014-02-16','09:10:00',6.66),('7643','2014-02-16','09:15:00',7),('7643','2014-02-16','09:20:00',7.29),('7643','2014-02-16','09:25:00',7.57),('7643','2014-02-16','09:30:00',7.88),('7643','2014-02-16','09:35:00',8.09),('7643','2014-02-16','09:40:00',8.29),('7643','2014-02-16','09:45:00',8.49),('7643','2014-02-16','09:50:00',8.63),('7643','2014-02-16','09:55:00',8.82),('7643','2014-02-16','10:00:00',9.09),('7643','2014-02-16','10:05:00',9.31),('7643','2014-02-16','10:10:00',9.47),('7643','2014-02-16','10:15:00',9.62),('7643','2014-02-16','10:20:00',9.66),('7643','2014-02-16','10:25:00',9.75),('7643','2014-02-16','10:30:00',9.9),('7643','2014-02-16','10:35:00',9.94),('7643','2014-02-16','10:40:00',9.99),('7643','2014-02-16','10:45:00',10.07),('7643','2014-02-16','10:50:00',10.13),('7643','2014-02-16','10:55:00',10.35),('7643','2014-02-16','11:00:00',10.44),('7643','2014-02-16','11:05:00',10.5),('7643','2014-02-16','11:10:00',10.62),('7643','2014-02-16','11:15:00',10.77),('7643','2014-02-16','11:20:00',11.03),('7643','2014-02-16','11:25:00',11.25),('7643','2014-02-16','11:30:00',11.48),('7643','2014-02-16','11:35:00',11.69),('7643','2014-02-16','11:40:00',11.84),('7643','2014-02-16','11:45:00',11.84),('7643','2014-02-16','11:50:00',11.85),('7643','2014-02-16','11:55:00',11.87),('7643','2014-02-16','12:00:00',11.95),('7643','2014-02-16','12:05:00',11.97),('7643','2014-02-16','12:10:00',11.92),('7643','2014-02-16','12:15:00',11.87),('7643','2014-02-16','12:20:00',11.87),('7643','2014-02-16','12:25:00',11.9),('7643','2014-02-16','12:30:00',11.81),('7643','2014-02-16','12:35:00',11.77),('7643','2014-02-16','12:40:00',11.74),('7643','2014-02-16','12:45:00',11.68),('7643','2014-02-16','12:50:00',11.61),('7643','2014-02-16','12:55:00',11.52),('7643','2014-02-16','13:00:00',11.49),('7643','2014-02-16','13:05:00',11.34),('7643','2014-02-16','13:10:00',11.3),('7643','2014-02-16','13:15:00',11.19),('7643','2014-02-16','13:20:00',11.07),('7643','2014-02-16','13:25:00',11.01),('7643','2014-02-16','13:30:00',10.98),('7643','2014-02-16','13:35:00',10.9),('7643','2014-02-16','13:40:00',10.8),('7643','2014-02-16','13:45:00',10.5),('7643','2014-02-16','13:50:00',10.55),('7643','2014-02-16','13:55:00',10.37),('7643','2014-02-16','14:00:00',10.15),('7643','2014-02-16','14:05:00',10.06),('7643','2014-02-16','14:10:00',9.56),('7643','2014-02-16','14:15:00',9.27),('7643','2014-02-16','14:20:00',9.58),('7643','2014-02-16','14:25:00',9.18),('7643','2014-02-16','14:30:00',8.89),('7643','2014-02-16','14:35:00',8.62),('7643','2014-02-16','14:40:00',7.9),('7643','2014-02-16','14:45:00',8.6),('7643','2014-02-16','14:50:00',8.01),('7643','2014-02-16','14:55:00',8.02),('7643','2014-02-16','15:00:00',7.5),('7643','2014-02-16','15:05:00',7.35),('7643','2014-02-16','15:10:00',7.17),('7643','2014-02-16','15:15:00',7.19),('7643','2014-02-16','15:20:00',7),('7643','2014-02-16','15:25:00',6.46),('7643','2014-02-16','15:30:00',6.32),('7643','2014-02-16','15:35:00',5.98),('7643','2014-02-16','15:40:00',5.51),('7643','2014-02-16','15:45:00',5.45),('7643','2014-02-16','15:50:00',5.12),('7643','2014-02-16','15:55:00',4.81),('7643','2014-02-16','16:00:00',4.41),('7643','2014-02-16','16:05:00',4.18),('7643','2014-02-16','16:10:00',3.88),('7643','2014-02-16','16:15:00',3.52),('7643','2014-02-16','16:20:00',3.22),('7643','2014-02-16','16:25:00',2.96),('7643','2014-02-16','16:30:00',2.62),('7643','2014-02-16','16:35:00',2.26),('7643','2014-02-16','16:40:00',2.02),('7643','2014-02-16','16:45:00',1.74),('7643','2014-02-16','16:50:00',1.5),('7643','2014-02-16','16:55:00',1.21),('7643','2014-02-15','07:35:00',1.15),('7643','2014-02-15','07:40:00',1.44),('7643','2014-02-15','07:45:00',1.72),('7643','2014-02-15','07:50:00',2.05),('7643','2014-02-15','07:55:00',2.38),('7643','2014-02-15','08:00:00',2.74),('7643','2014-02-15','08:05:00',3.09),('7643','2014-02-15','08:10:00',3.44),('7643','2014-02-15','08:15:00',3.78),('7643','2014-02-15','08:20:00',4.15),('7643','2014-02-15','08:25:00',4.54),('7643','2014-02-15','08:30:00',4.94),('7643','2014-02-15','08:35:00',5.31),('7643','2014-02-15','08:40:00',5.38),('7643','2014-02-15','08:45:00',6.08),('7643','2014-02-15','08:50:00',5.72),('7643','2014-02-15','08:55:00',6.54),('7643','2014-02-15','09:00:00',7.04),('7643','2014-02-15','09:05:00',7.33),('7643','2014-02-15','09:10:00',7.12),('7643','2014-02-15','09:15:00',5.87),('7643','2014-02-15','09:20:00',7.56),('7643','2014-02-15','09:25:00',7.67),('7643','2014-02-15','09:30:00',7.99),('7643','2014-02-15','09:35:00',6.69),('7643','2014-02-15','09:40:00',8.54),('7643','2014-02-15','09:45:00',9),('7643','2014-02-15','09:50:00',9.41),('7643','2014-02-15','09:55:00',9.1),('7643','2014-02-15','10:00:00',8.97),('7643','2014-02-15','10:05:00',9.96),('7643','2014-02-15','10:10:00',10.2),('7643','2014-02-15','10:15:00',10.37),('7643','2014-02-15','10:20:00',10.61),('7643','2014-02-15','10:25:00',10.85),('7643','2014-02-15','10:30:00',10.98),('7643','2014-02-15','10:35:00',11.36),('7643','2014-02-15','10:40:00',11.68),('7643','2014-02-15','10:45:00',11.55),('7643','2014-02-15','10:50:00',10.26),('7643','2014-02-15','10:55:00',9.8),('7643','2014-02-15','11:00:00',11.65),('7643','2014-02-15','11:05:00',11.96),('7643','2014-02-15','11:10:00',11.39),('7643','2014-02-15','11:15:00',11.7),('7643','2014-02-15','11:20:00',11.35),('7643','2014-02-15','11:25:00',11.27),('7643','2014-02-15','11:30:00',11.57),('7643','2014-02-15','11:35:00',12.16),('7643','2014-02-15','11:40:00',12.13),('7643','2014-02-15','11:45:00',10.9),('7643','2014-02-15','11:50:00',12.26),('7643','2014-02-15','11:55:00',10.38),('7643','2014-02-15','12:00:00',12.41),('7643','2014-02-15','12:05:00',12.27),('7643','2014-02-15','12:10:00',12.36),('7643','2014-02-15','12:15:00',12.25),('7643','2014-02-15','12:20:00',12.22),('7643','2014-02-15','12:25:00',12.08),('7643','2014-02-15','12:30:00',12.27),('7643','2014-02-15','12:35:00',12.18),('7643','2014-02-15','12:40:00',12.1),('7643','2014-02-15','12:45:00',11.99),('7643','2014-02-15','12:50:00',11.99),('7643','2014-02-15','12:55:00',12.04),('7643','2014-02-15','13:00:00',11.91),('7643','2014-02-15','13:05:00',11.79),('7643','2014-02-15','13:10:00',11.43),('7643','2014-02-15','13:15:00',11.54),('7643','2014-02-15','13:20:00',11.75),('7643','2014-02-15','13:25:00',11.49),('7643','2014-02-15','13:30:00',11.34),('7643','2014-02-15','13:35:00',11.2),('7643','2014-02-15','13:40:00',11.08),('7643','2014-02-15','13:45:00',11.13),('7643','2014-02-15','13:50:00',10.92),('7643','2014-02-15','13:55:00',10.89),('7643','2014-02-15','14:00:00',10.9),('7643','2014-02-15','14:05:00',10.79),('7643','2014-02-15','14:10:00',10.59),('7643','2014-02-15','14:15:00',10.37),('7643','2014-02-15','14:20:00',10.28),('7643','2014-02-15','14:25:00',10.19),('7643','2014-02-15','14:30:00',9.96),('7643','2014-02-15','14:35:00',9.73),('7643','2014-02-15','14:40:00',9.34),('7643','2014-02-15','14:45:00',9.25),('7643','2014-02-15','14:50:00',8.99),('7643','2014-02-15','14:55:00',8.83),('7643','2014-02-15','15:00:00',8.49),('7643','2014-02-15','15:05:00',8.34),('7643','2014-02-15','15:10:00',7.95),('7643','2014-02-15','15:15:00',7.71),('7643','2014-02-15','15:20:00',7.37),('7643','2014-02-15','15:25:00',7),('7643','2014-02-15','15:30:00',6.78),('7643','2014-02-15','15:35:00',5.95),('7643','2014-02-15','15:40:00',5.37),('7643','2014-02-15','15:45:00',6.05),('7643','2014-02-15','15:50:00',4.91),('7643','2014-02-15','15:55:00',1.88),('7643','2014-02-15','16:00:00',1.36),('7643','2014-02-15','16:05:00',1.52),('7643','2014-02-15','16:10:00',2.46),('7643','2014-02-15','16:15:00',3.56),('7643','2014-02-15','16:20:00',3.88),('7643','2014-02-15','16:25:00',4.39),('7643','2014-02-15','16:30:00',4.31),('7643','2014-02-15','16:35:00',3.46),('7643','2014-02-15','16:40:00',2.46),('7643','2014-02-15','16:45:00',1.78),('7643','2014-02-15','16:50:00',1.17),('7643','2014-02-15','17:00:00',1.01),('7643','2014-02-15','17:05:00',1.05),('7643','2014-04-27','07:10:00',1),('7643','2014-04-27','07:15:00',1.36),('7643','2014-04-27','07:20:00',1.97),('7643','2014-04-27','07:25:00',1.76),('7643','2014-04-27','07:30:00',1.68),('7643','2014-04-27','07:35:00',1.84),('7643','2014-04-27','07:40:00',2),('7643','2014-04-27','07:45:00',2.23),('7643','2014-04-27','07:50:00',2.33),('7643','2014-04-27','07:55:00',2.61),('7643','2014-04-27','08:00:00',3.01),('7643','2014-04-27','08:05:00',2.3),('7643','2014-04-27','08:10:00',1.48),('7643','2014-04-27','08:15:00',5.97),('7643','2014-04-27','08:20:00',6.42),('7643','2014-04-27','08:25:00',6.38),('7643','2014-04-27','08:30:00',5.26),('7643','2014-04-27','08:35:00',4.74),('7643','2014-04-27','08:40:00',4.46),('7643','2014-04-27','08:45:00',4.44),('7643','2014-04-27','08:50:00',5.65),('7643','2014-04-27','08:55:00',5.53),('7643','2014-04-27','09:00:00',4.16),('7643','2014-04-27','09:05:00',3.71),('7643','2014-04-27','09:10:00',10.41),('7643','2014-04-27','09:15:00',11.45),('7643','2014-04-27','09:20:00',11.23),('7643','2014-04-27','09:25:00',12.98),('7643','2014-04-27','09:30:00',6.5),('7643','2014-04-27','09:35:00',8.69),('7643','2014-04-27','09:40:00',8.06),('7643','2014-04-27','09:45:00',6.46),('7643','2014-04-27','09:50:00',8.88),('7643','2014-04-27','09:55:00',5.45),('7643','2014-04-27','10:00:00',7.96),('7643','2014-04-27','10:05:00',9.34),('7643','2014-04-27','10:10:00',9),('7643','2014-04-27','10:15:00',8.58),('7643','2014-04-27','10:20:00',7.04),('7643','2014-04-27','10:25:00',5.7),('7643','2014-04-27','10:30:00',2.47),('7643','2014-04-27','10:35:00',1.68),('7643','2014-04-27','10:40:00',3.16),('7643','2014-04-27','10:45:00',5.68),('7643','2014-04-27','10:50:00',7.87),('7643','2014-04-27','10:55:00',7.65),('7643','2014-04-27','11:00:00',7.3),('7643','2014-04-27','11:05:00',8.92),('7643','2014-04-27','11:10:00',10.28),('7643','2014-04-27','11:15:00',10.09),('7643','2014-04-27','11:20:00',8.93),('7643','2014-04-27','11:25:00',7.3),('7643','2014-04-27','11:30:00',7.87),('7643','2014-04-27','11:35:00',7.41),('7643','2014-04-27','11:40:00',5.97),('7643','2014-04-27','11:45:00',6.06),('7643','2014-04-27','11:50:00',7.04),('7643','2014-04-27','11:55:00',7.71),('7643','2014-04-27','12:00:00',6.84),('7643','2014-04-27','12:05:00',5.22),('7643','2014-04-27','12:10:00',7.09),('7643','2014-04-27','12:15:00',10.81),('7643','2014-04-27','12:20:00',11.63),('7643','2014-04-27','12:25:00',10.84),('7643','2014-04-27','12:30:00',10.49),('7643','2014-04-27','12:35:00',9.71),('7643','2014-04-27','12:40:00',8.7),('7643','2014-04-27','12:45:00',7.45),('7643','2014-04-27','12:50:00',9.02),('7643','2014-04-27','12:55:00',8.45),('7643','2014-04-27','13:00:00',8.76),('7643','2014-04-27','13:05:00',9.99),('7643','2014-04-27','13:10:00',14.89),('7643','2014-04-27','13:15:00',9.12),('7643','2014-04-27','13:20:00',8.67),('7643','2014-04-27','13:25:00',9.67),('7643','2014-04-27','13:30:00',18.35),('7643','2014-04-27','13:35:00',13.64),('7643','2014-04-27','13:40:00',14.39),('7643','2014-04-27','13:45:00',10.74),('7643','2014-04-27','13:50:00',15.74),('7643','2014-04-27','13:55:00',11.48),('7643','2014-04-27','14:00:00',6.6),('7643','2014-04-27','14:05:00',10.86),('7643','2014-04-27','14:10:00',12.87),('7643','2014-04-27','14:15:00',12.12),('7643','2014-04-27','14:20:00',16.77),('7643','2014-04-27','14:25:00',9.98),('7643','2014-04-27','14:30:00',11.68),('7643','2014-04-27','14:35:00',14.48),('7643','2014-04-27','14:40:00',14.96),('7643','2014-04-27','14:45:00',11.39),('7643','2014-04-27','14:50:00',10.34),('7643','2014-04-27','14:55:00',14.88),('7643','2014-04-27','15:00:00',15.78),('7643','2014-04-27','15:05:00',14.19),('7643','2014-04-27','15:10:00',8.3),('7643','2014-04-27','15:15:00',7.12),('7643','2014-04-27','15:20:00',5.35),('7643','2014-04-27','15:25:00',7.08),('7643','2014-04-27','15:30:00',7.35),('7643','2014-04-27','15:35:00',12.48),('7643','2014-04-27','15:40:00',12.28),('7643','2014-04-27','15:45:00',12.72),('7643','2014-04-27','15:50:00',8.56),('7643','2014-04-27','15:55:00',4.12),('7643','2014-04-27','16:00:00',9.33),('7643','2014-04-27','16:05:00',12.55),('7643','2014-04-27','16:10:00',15.4),('7643','2014-04-27','16:15:00',12.55),('7643','2014-04-27','16:20:00',5.67),('7643','2014-04-27','16:25:00',6.26),('7643','2014-04-27','16:30:00',12.26),('7643','2014-04-27','16:35:00',12.05),('7643','2014-04-27','16:40:00',3.16),('7643','2014-04-27','16:45:00',2.55),('7643','2014-04-27','16:50:00',2.37),('7643','2014-04-27','16:55:00',4.45),('7643','2014-04-27','17:00:00',3.81),('7643','2014-04-27','17:05:00',1.93),('7643','2014-04-27','17:10:00',1.23),('7643','2014-04-27','17:15:00',1.31),('7643','2014-04-27','17:20:00',2.34),('7643','2014-04-27','17:25:00',3.49),('7643','2014-04-27','17:30:00',3.46),('7643','2014-04-27','17:35:00',4.04),('7643','2014-04-27','17:40:00',5.63),('7643','2014-04-27','17:45:00',3.65),('7643','2014-04-27','17:50:00',2.75),('7643','2014-04-27','17:55:00',2.68),('7643','2014-04-27','18:00:00',2.25),('7643','2014-04-27','18:05:00',1.71),('7643','2014-04-27','18:10:00',1.81),('7643','2014-04-27','18:15:00',1.91),('7643','2014-04-27','18:20:00',1.76),('7643','2014-04-27','18:25:00',1.9),('7643','2014-04-27','18:30:00',1.89),('7643','2014-04-27','18:35:00',1.78),('7643','2014-04-27','18:40:00',1.72),('7643','2014-04-27','18:45:00',1.09),('7643','2014-02-14','07:40:00',1.22),('7643','2014-02-14','07:45:00',1.54),('7643','2014-02-14','07:50:00',1.83),('7643','2014-02-14','07:55:00',2.18),('7643','2014-02-14','08:00:00',2.53),('7643','2014-02-14','08:05:00',2.87),('7643','2014-02-14','08:10:00',3.21),('7643','2014-02-14','08:15:00',3.52),('7643','2014-02-14','08:20:00',3.86),('7643','2014-02-14','08:25:00',4.17),('7643','2014-02-14','08:30:00',4.45),('7643','2014-02-14','08:35:00',4.78),('7643','2014-02-14','08:40:00',5.13),('7643','2014-02-14','08:45:00',5.36),('7643','2014-02-14','08:50:00',5.63),('7643','2014-02-14','08:55:00',5.78),('7643','2014-02-14','09:00:00',6.35),('7643','2014-02-14','09:05:00',6.64),('7643','2014-02-14','09:10:00',6.88),('7643','2014-02-14','09:15:00',7.18),('7643','2014-02-14','09:20:00',7.52),('7643','2014-02-14','09:25:00',7.81),('7643','2014-02-14','09:30:00',8.05),('7643','2014-02-14','09:35:00',8.34),('7643','2014-02-14','09:40:00',8.58),('7643','2014-02-14','09:45:00',8.76),('7643','2014-02-14','09:50:00',8.95),('7643','2014-02-14','09:55:00',9.21),('7643','2014-02-14','10:00:00',9.45),('7643','2014-02-14','10:05:00',9.62),('7643','2014-02-14','10:10:00',9.8),('7643','2014-02-14','10:15:00',9.98),('7643','2014-02-14','10:20:00',10.18),('7643','2014-02-14','10:25:00',10.28),('7643','2014-02-14','10:30:00',10.36),('7643','2014-02-14','10:35:00',10.49),('7643','2014-02-14','10:40:00',10.61),('7643','2014-02-14','10:45:00',10.73),('7643','2014-02-14','10:50:00',10.92),('7643','2014-02-14','10:55:00',10.94),('7643','2014-02-14','11:00:00',11.47),('7643','2014-02-14','11:05:00',11.53),('7643','2014-02-14','11:10:00',10.46),('7643','2014-02-14','11:15:00',12.38),('7643','2014-02-14','11:20:00',11.27),('7643','2014-02-14','11:25:00',4.73),('7643','2014-02-14','11:30:00',7.41),('7643','2014-02-14','11:35:00',8.43),('7643','2014-02-14','11:40:00',13.98),('7643','2014-02-14','11:45:00',11.89),('7643','2014-02-14','11:50:00',9.6),('7643','2014-02-14','11:55:00',11.25),('7643','2014-02-14','12:00:00',10.18),('7643','2014-02-14','12:05:00',9.56),('7643','2014-02-14','12:10:00',13.58),('7643','2014-02-14','12:15:00',14.49),('7643','2014-02-14','12:20:00',13.65),('7643','2014-02-14','12:25:00',12.98),('7643','2014-02-14','12:30:00',12.75),('7643','2014-02-14','12:35:00',9.68),('7643','2014-02-14','12:40:00',14.23),('7643','2014-02-14','12:45:00',14.44),('7643','2014-02-14','12:50:00',13.45),('7643','2014-02-14','12:55:00',6.52),('7643','2014-02-14','13:00:00',13.49),('7643','2014-02-14','13:05:00',12.95),('7643','2014-02-14','13:10:00',12.79),('7643','2014-02-14','13:15:00',12.61),('7643','2014-02-14','13:20:00',12.26),('7643','2014-02-14','13:25:00',11.92),('7643','2014-02-14','13:30:00',11.47),('7643','2014-02-14','13:35:00',11.51),('7643','2014-02-14','13:40:00',11.35),('7643','2014-02-14','13:45:00',11.12),('7643','2014-02-14','13:50:00',11.01),('7643','2014-02-14','13:55:00',10.8),('7643','2014-02-14','14:00:00',10.74),('7643','2014-02-14','14:05:00',10.51),('7643','2014-02-14','14:10:00',10.24),('7643','2014-02-14','14:15:00',10.18),('7643','2014-02-14','14:20:00',9.98),('7643','2014-02-14','14:25:00',9.72),('7643','2014-02-14','14:30:00',9.54),('7643','2014-02-14','14:35:00',9.38),('7643','2014-02-14','14:40:00',9.09),('7643','2014-02-14','14:45:00',8.86),('7643','2014-02-14','14:50:00',8.68),('7643','2014-02-14','14:55:00',8.43),('7643','2014-02-14','15:00:00',7.98),('7643','2014-02-14','15:05:00',7.7),('7643','2014-02-14','15:10:00',7.47),('7643','2014-02-14','15:15:00',7.35),('7643','2014-02-14','15:20:00',7.15),('7643','2014-02-14','15:25:00',6.83),('7643','2014-02-14','15:30:00',6.55),('7643','2014-02-14','15:35:00',6.35),('7643','2014-02-14','15:40:00',6.08),('7643','2014-02-14','15:45:00',5.8),('7643','2014-02-14','15:50:00',5.45),('7643','2014-02-14','15:55:00',5.13),('7643','2014-02-14','16:00:00',4.83),('7643','2014-02-14','16:05:00',4.52),('7643','2014-02-14','16:10:00',4.18),('7643','2014-02-14','16:15:00',3.85),('7643','2014-02-14','16:20:00',3.49),('7643','2014-02-14','16:25:00',3.15),('7643','2014-02-14','16:30:00',2.85),('7643','2014-02-14','16:35:00',2.54),('7643','2014-02-14','16:40:00',2.2),('7643','2014-02-14','16:45:00',1.89),('7643','2014-02-14','16:50:00',1.62),('7643','2014-02-14','16:55:00',1.35),('7643','2014-02-14','17:00:00',1.08),('7643','2014-02-13','08:40:00',3.33),('7643','2014-02-13','08:45:00',3.94),('7643','2014-02-13','08:50:00',5.63),('7643','2014-02-13','08:55:00',6.01),('7643','2014-02-13','09:00:00',6.3),('7643','2014-02-13','09:05:00',6.7),('7643','2014-02-13','09:10:00',6.21),('7643','2014-02-13','09:15:00',4.81),('7643','2014-02-13','09:20:00',5.41),('7643','2014-02-13','09:25:00',5.52),('7643','2014-02-13','09:30:00',7.06),('7643','2014-02-13','09:35:00',8.57),('7643','2014-02-13','09:40:00',4.99),('7643','2014-02-13','09:45:00',5.46),('7643','2014-02-13','09:50:00',9.45),('7643','2014-02-13','09:55:00',9.96),('7643','2014-02-13','10:00:00',9.01),('7643','2014-02-13','10:05:00',10),('7643','2014-02-13','10:10:00',10.62),('7643','2014-02-13','10:15:00',8.26),('7643','2014-02-13','10:20:00',10.45),('7643','2014-02-13','10:25:00',11.47),('7643','2014-02-13','10:30:00',11.14),('7643','2014-02-13','10:35:00',10.98),('7643','2014-02-13','10:40:00',11.3),('7643','2014-02-13','10:45:00',11.53),('7643','2014-02-13','10:50:00',11.76),('7643','2014-02-13','10:55:00',11.84),('7643','2014-02-13','11:00:00',11.69),('7643','2014-02-13','11:05:00',12.06),('7643','2014-02-13','11:10:00',12.14),('7643','2014-02-13','11:15:00',12.17),('7643','2014-02-13','11:20:00',12.37),('7643','2014-02-13','11:25:00',12.45),('7643','2014-02-13','11:30:00',12.52),('7643','2014-02-13','11:35:00',12.73),('7643','2014-02-13','11:40:00',12.65),('7643','2014-02-13','11:45:00',12.78),('7643','2014-02-13','11:50:00',11.35),('7643','2014-02-13','11:55:00',12.7),('7643','2014-02-13','12:00:00',12.86),('7643','2014-02-13','12:05:00',10.11),('7643','2014-02-13','12:10:00',12.92),('7643','2014-02-13','12:15:00',12.79),('7643','2014-02-13','12:20:00',12.66),('7643','2014-02-13','12:25:00',12.72),('7643','2014-02-13','12:30:00',12.71),('7643','2014-02-13','12:35:00',12.65),('7643','2014-02-13','12:40:00',12.58),('7643','2014-02-13','12:45:00',12.55),('7643','2014-02-13','12:50:00',12.51),('7643','2014-02-13','12:55:00',12.4),('7643','2014-02-13','13:00:00',12.42),('7643','2014-02-13','13:05:00',12.3),('7643','2014-02-13','13:10:00',12.27),('7643','2014-02-13','13:15:00',12.16),('7643','2014-02-13','13:20:00',12.03),('7643','2014-02-13','13:25:00',11.93),('7643','2014-02-13','13:30:00',11.75),('7643','2014-02-13','13:35:00',11.65),('7643','2014-02-13','13:40:00',11.52),('7643','2014-02-13','13:45:00',11.35),('7643','2014-02-13','13:50:00',11.31),('7643','2014-02-13','13:55:00',11.18),('7643','2014-02-13','14:00:00',11.02),('7643','2014-02-13','14:05:00',10.82),('7643','2014-02-13','14:10:00',10.6),('7643','2014-02-13','14:15:00',10.3),('7643','2014-02-13','14:20:00',10.13),('7643','2014-02-13','14:25:00',9.98),('7643','2014-02-13','14:30:00',9.77),('7643','2014-02-13','14:35:00',9.58),('7643','2014-02-13','14:40:00',9.35),('7643','2014-02-13','14:45:00',9.02),('7643','2014-02-13','14:50:00',8.78),('7643','2014-02-13','14:55:00',8.53),('7643','2014-02-13','15:00:00',8.26),('7643','2014-02-13','15:05:00',8.01),('7643','2014-02-13','15:10:00',7.76),('7643','2014-02-13','15:15:00',7.49),('7643','2014-02-13','15:20:00',7.22),('7643','2014-02-13','15:25:00',6.94),('7643','2014-02-13','15:30:00',6.64),('7643','2014-02-13','15:35:00',6.32),('7643','2014-02-13','15:40:00',6.01),('7643','2014-02-13','15:45:00',5.69),('7643','2014-02-13','15:50:00',5.36),('7643','2014-02-13','15:55:00',5.01),('7643','2014-02-13','16:00:00',4.72),('7643','2014-02-13','16:05:00',4.44),('7643','2014-02-13','16:10:00',4.02),('7643','2014-02-13','16:15:00',3.66),('7643','2014-02-13','16:20:00',3.42),('7643','2014-02-13','16:25:00',3.05),('7643','2014-02-13','16:30:00',2.71),('7643','2014-02-13','16:35:00',2.38),('7643','2014-02-13','16:40:00',2.12),('7643','2014-02-13','16:45:00',1.85),('7643','2014-02-13','16:50:00',1.51),('7643','2014-02-13','16:55:00',1.23),('7643','2014-02-12','07:40:00',1.13),('7643','2014-02-12','07:45:00',1.41),('7643','2014-02-12','07:50:00',1.7),('7643','2014-02-12','07:55:00',2.08),('7643','2014-02-12','08:00:00',2.42),('7643','2014-02-12','08:05:00',2.78),('7643','2014-02-12','08:10:00',3.2),('7643','2014-02-12','08:15:00',3.69),('7643','2014-02-12','08:20:00',4.18),('7643','2014-02-12','08:25:00',4.25),('7643','2014-02-12','08:30:00',4.57),('7643','2014-02-12','08:35:00',4.81),('7643','2014-02-12','08:40:00',5.06),('7643','2014-02-12','08:45:00',5.5),('7643','2014-02-12','08:50:00',5.88),('7643','2014-02-12','08:55:00',6.2),('7643','2014-02-12','09:00:00',6.58),('7643','2014-02-12','09:05:00',6.9),('7643','2014-02-12','09:10:00',7.25),('7643','2014-02-12','09:15:00',7.41),('7643','2014-02-12','09:20:00',7.73),('7643','2014-02-12','09:25:00',7.95),('7643','2014-02-12','09:30:00',8.21),('7643','2014-02-12','09:35:00',8.5),('7643','2014-02-12','09:40:00',8.71),('7643','2014-02-12','09:45:00',8.83),('7643','2014-02-12','09:50:00',9.06),('7643','2014-02-12','09:55:00',9.3),('7643','2014-02-12','10:00:00',9.58),('7643','2014-02-12','10:05:00',9.77),('7643','2014-02-12','10:10:00',9.99),('7643','2014-02-12','10:15:00',10.13),('7643','2014-02-12','10:20:00',10.26),('7643','2014-02-12','10:25:00',10.33),('7643','2014-02-12','10:30:00',10.6),('7643','2014-02-12','10:35:00',10.71),('7643','2014-02-12','10:40:00',10.7),('7643','2014-02-12','10:45:00',10.88),('7643','2014-02-12','10:50:00',11.07),('7643','2014-02-12','10:55:00',11.17),('7643','2014-02-12','11:00:00',11.36),('7643','2014-02-12','11:05:00',11.39),('7643','2014-02-12','11:10:00',11.72),('7643','2014-02-12','11:15:00',11.79),('7643','2014-02-12','11:20:00',10.81),('7643','2014-02-12','11:25:00',11.32),('7643','2014-02-12','11:30:00',11.1),('7643','2014-02-12','11:35:00',11.86),('7643','2014-02-12','11:40:00',8.24),('7643','2014-02-12','11:45:00',13.2),('7643','2014-02-12','11:50:00',8.43),('7643','2014-02-12','11:55:00',13.66),('7643','2014-02-12','12:00:00',9.17),('7643','2014-02-12','12:05:00',7.03),('7643','2014-02-12','12:10:00',12.56),('7643','2014-02-12','12:15:00',11.82),('7643','2014-02-12','12:20:00',9.74),('7643','2014-02-12','12:25:00',10.44),('7643','2014-02-12','12:30:00',15.07),('7643','2014-02-12','12:35:00',14.53),('7643','2014-02-12','12:40:00',11.92),('7643','2014-02-12','12:45:00',2.98),('7643','2014-02-12','12:50:00',6.06),('7643','2014-02-12','12:55:00',5.19),('7643','2014-02-12','13:00:00',7.1),('7643','2014-02-12','13:05:00',13.16),('7643','2014-02-12','13:10:00',12.76),('7643','2014-02-12','13:15:00',12.36),('7643','2014-02-12','13:20:00',12.34),('7643','2014-02-12','13:25:00',12.12),('7643','2014-02-12','13:30:00',12.1),('7643','2014-02-12','13:35:00',11.91),('7643','2014-02-12','13:40:00',11.71),('7643','2014-02-12','13:45:00',11.63),('7643','2014-02-12','13:50:00',11.46),('7643','2014-02-12','13:55:00',11.37),('7643','2014-02-12','14:00:00',11.13),('7643','2014-02-12','14:05:00',10.95),('7643','2014-02-12','14:10:00',10.79),('7643','2014-02-12','14:15:00',10.55),('7643','2014-02-12','14:20:00',10.28),('7643','2014-02-12','14:25:00',10.14),('7643','2014-02-12','14:30:00',9.9),('7643','2014-02-12','14:35:00',9.8),('7643','2014-02-12','14:40:00',7),('7643','2014-02-12','14:45:00',8.67),('7643','2014-02-12','14:50:00',5.31),('7643','2014-02-12','14:55:00',9.38),('7643','2014-02-12','15:00:00',9.44),('7643','2014-02-12','15:05:00',6.96),('7643','2014-02-12','15:10:00',8.44),('7643','2014-02-12','15:15:00',6.93),('7643','2014-02-12','15:20:00',7.78),('7643','2014-02-12','15:25:00',7.46),('7643','2014-02-12','15:30:00',3.99),('7643','2014-02-12','15:35:00',7.09),('7643','2014-02-12','15:40:00',6.68),('7643','2014-02-12','15:45:00',6.26),('7643','2014-02-12','15:50:00',4.31),('7643','2014-02-12','15:55:00',4.28),('7643','2014-02-12','16:00:00',2.15),('7643','2014-02-12','16:05:00',4.21),('7643','2014-02-12','16:10:00',4.66),('7643','2014-02-12','16:15:00',2.85),('7643','2014-02-12','16:20:00',1.12),('7643','2014-02-12','16:25:00',1.35),('7643','2014-02-12','16:30:00',1.34),('7643','2014-02-12','16:35:00',1.39),('7643','2014-02-12','16:55:00',1.28),('7643','2014-02-11','08:15:00',1.5),('7643','2014-02-11','08:20:00',3.25),('7643','2014-02-11','08:40:00',1.22),('7643','2014-02-11','08:45:00',5),('7643','2014-02-11','08:50:00',5.76),('7643','2014-02-11','08:55:00',6.09),('7643','2014-02-11','09:00:00',1.91),('7643','2014-02-11','09:05:00',2.27),('7643','2014-02-11','09:10:00',3.77),('7643','2014-02-11','09:15:00',7.06),('7643','2014-02-11','09:20:00',6.6),('7643','2014-02-11','09:25:00',7.46),('7643','2014-02-11','09:30:00',3.68),('7643','2014-02-11','09:35:00',2.45),('7643','2014-02-11','09:40:00',5.51),('7643','2014-02-11','09:45:00',9.48),('7643','2014-02-11','09:50:00',8.9),('7643','2014-02-11','09:55:00',5.15),('7643','2014-02-11','10:00:00',3.76),('7643','2014-02-11','10:05:00',5.69),('7643','2014-02-11','10:10:00',5.3),('7643','2014-02-11','10:15:00',4.19),('7643','2014-02-11','10:20:00',3.91),('7643','2014-02-11','10:25:00',4.19),('7643','2014-02-11','10:30:00',5.59),('7643','2014-02-11','10:35:00',7.88),('7643','2014-02-11','10:40:00',5.15),('7643','2014-02-11','10:45:00',7.27),('7643','2014-02-11','10:50:00',5.64),('7643','2014-02-11','10:55:00',5.49),('7643','2014-02-11','11:00:00',5.84),('7643','2014-02-11','11:05:00',11.28),('7643','2014-02-11','11:10:00',6.33),('7643','2014-02-11','11:15:00',5.76),('7643','2014-02-11','11:20:00',6.86),('7643','2014-02-11','11:25:00',6.05),('7643','2014-02-11','11:30:00',7.24),('7643','2014-02-11','11:35:00',6.89),('7643','2014-02-11','11:40:00',4.78),('7643','2014-02-11','11:45:00',3.58),('7643','2014-02-11','11:50:00',3.44),('7643','2014-02-11','11:55:00',2.9),('7643','2014-02-11','12:00:00',2.76),('7643','2014-02-11','12:05:00',3.73),('7643','2014-02-11','12:10:00',4.48),('7643','2014-02-11','12:15:00',4.77),('7643','2014-02-11','12:20:00',4.73),('7643','2014-02-11','12:25:00',4.97),('7643','2014-02-11','12:30:00',5.3),('7643','2014-02-11','12:35:00',5.05),('7643','2014-02-11','12:40:00',4.91),('7643','2014-02-11','12:45:00',5.47),('7643','2014-02-11','12:50:00',6.55),('7643','2014-02-11','12:55:00',6.59),('7643','2014-02-11','13:00:00',6.67),('7643','2014-02-11','13:05:00',5.55),('7643','2014-02-11','13:10:00',5.66),('7643','2014-02-11','13:15:00',5.28),('7643','2014-02-11','13:20:00',4.91),('7643','2014-02-11','13:25:00',6.01),('7643','2014-02-11','13:30:00',8.06),('7643','2014-02-11','13:35:00',12.62),('7643','2014-02-11','13:40:00',11.15),('7643','2014-02-11','13:45:00',9.72),('7643','2014-02-11','13:50:00',10.8),('7643','2014-02-11','13:55:00',9.57),('7643','2014-02-11','14:00:00',11.72),('7643','2014-02-11','14:05:00',11.82),('7643','2014-02-11','14:10:00',11.57),('7643','2014-02-11','14:15:00',10.93),('7643','2014-02-11','14:20:00',8.86),('7643','2014-02-11','14:25:00',10.43),('7643','2014-02-11','14:30:00',7.42),('7643','2014-02-11','14:35:00',10.16),('7643','2014-02-11','14:40:00',6.52),('7643','2014-02-11','14:45:00',9.22),('7643','2014-02-11','14:50:00',10.19),('7643','2014-02-11','14:55:00',9.31),('7643','2014-02-11','15:00:00',5.72),('7643','2014-02-11','15:05:00',4.06),('7643','2014-02-11','15:10:00',5.04),('7643','2014-02-11','15:15:00',4.09),('7643','2014-02-11','15:20:00',5.75),('7643','2014-02-11','15:25:00',4.66),('7643','2014-02-11','15:30:00',3.38),('7643','2014-02-11','15:35:00',7.8),('7643','2014-02-11','15:40:00',6.98),('7643','2014-02-11','15:45:00',5.44),('7643','2014-02-11','15:50:00',5.34),('7643','2014-02-11','15:55:00',2.4),('7643','2014-02-11','16:00:00',2.36),('7643','2014-02-11','16:05:00',1.88),('7643','2014-02-11','16:10:00',1.4),('7643','2014-02-11','16:15:00',1.31),('7643','2014-02-11','16:20:00',1.06),('7643','2014-02-10','08:25:00',1.12),('7643','2014-02-10','08:30:00',1.23),('7643','2014-02-10','08:35:00',1.36),('7643','2014-02-10','08:40:00',1.49),('7643','2014-02-10','08:45:00',1.52),('7643','2014-02-10','08:50:00',1.58),('7643','2014-02-10','08:55:00',1.78),('7643','2014-02-10','09:00:00',2.2),('7643','2014-02-10','09:05:00',2.44),('7643','2014-02-10','09:10:00',2.34),('7643','2014-02-10','09:15:00',2.9),('7643','2014-02-10','09:20:00',4.33),('7643','2014-02-10','09:25:00',4.82),('7643','2014-02-10','09:30:00',4.75),('7643','2014-02-10','09:35:00',4.75),('7643','2014-02-10','09:40:00',4.65),('7643','2014-02-10','09:45:00',4.46),('7643','2014-02-10','09:50:00',4.96),('7643','2014-02-10','09:55:00',5.17),('7643','2014-02-10','10:00:00',4.38),('7643','2014-02-10','10:05:00',4.82),('7643','2014-02-10','10:10:00',5.42),('7643','2014-02-10','10:15:00',6.37),('7643','2014-02-10','10:20:00',7.22),('7643','2014-02-10','10:25:00',7.57),('7643','2014-02-10','10:30:00',8.19),('7643','2014-02-10','10:35:00',9.43),('7643','2014-02-10','10:40:00',9.71),('7643','2014-02-10','10:45:00',8.74),('7643','2014-02-10','10:50:00',8.87),('7643','2014-02-10','10:55:00',7.66),('7643','2014-02-10','11:00:00',8.42),('7643','2014-02-10','11:05:00',7.73),('7643','2014-02-10','11:10:00',9.52),('7643','2014-02-10','11:15:00',9.31),('7643','2014-02-10','11:20:00',8.99),('7643','2014-02-10','11:25:00',8.92),('7643','2014-02-10','11:30:00',9.6),('7643','2014-02-10','11:35:00',7.24),('7643','2014-02-10','11:40:00',5.58),('7643','2014-02-10','11:45:00',6.42),('7643','2014-02-10','11:50:00',7.79),('7643','2014-02-10','11:55:00',5.77),('7643','2014-02-10','12:00:00',4.81),('7643','2014-02-10','12:05:00',5.66),('7643','2014-02-10','12:10:00',6.7),('7643','2014-02-10','12:15:00',5.78),('7643','2014-02-10','12:20:00',6.66),('7643','2014-02-10','12:25:00',8.78),('7643','2014-02-10','12:30:00',8.4),('7643','2014-02-10','12:35:00',7.13),('7643','2014-02-10','12:40:00',5.45),('7643','2014-02-10','12:45:00',6.38),('7643','2014-02-10','12:50:00',5.07),('7643','2014-02-10','12:55:00',6.38),('7643','2014-02-10','13:00:00',6.77),('7643','2014-02-10','13:05:00',8.38),('7643','2014-02-10','13:10:00',10.16),('7643','2014-02-10','13:15:00',9.79),('7643','2014-02-10','13:20:00',11.7),('7643','2014-02-10','13:25:00',10.75),('7643','2014-02-10','13:30:00',9.53),('7643','2014-02-10','13:35:00',9.09),('7643','2014-02-10','13:40:00',10.74),('7643','2014-02-10','13:45:00',8.23),('7643','2014-02-10','13:50:00',6.32),('7643','2014-02-10','13:55:00',5.09),('7643','2014-02-10','14:00:00',7.15),('7643','2014-02-10','14:05:00',7.43),('7643','2014-02-10','14:10:00',6.5),('7643','2014-02-10','14:15:00',7.21),('7643','2014-02-10','14:20:00',5.03),('7643','2014-02-10','14:25:00',4.56),('7643','2014-02-10','14:30:00',5.66),('7643','2014-02-10','14:35:00',5.18),('7643','2014-02-10','14:40:00',4.05),('7643','2014-02-10','14:45:00',3.85),('7643','2014-02-10','14:50:00',3.2),('7643','2014-02-10','14:55:00',3.33),('7643','2014-02-10','15:00:00',3.22),('7643','2014-02-10','15:05:00',3.3),('7643','2014-02-10','15:10:00',3.55),('7643','2014-02-10','15:15:00',4.45),('7643','2014-02-10','15:20:00',5.63),('7643','2014-02-10','15:25:00',3.86),('7643','2014-02-10','15:30:00',3.18),('7643','2014-02-10','15:35:00',3.28),('7643','2014-02-10','15:40:00',3.04),('7643','2014-02-10','15:45:00',2.49),('7643','2014-02-10','15:50:00',2.24),('7643','2014-02-10','15:55:00',2.27),('7643','2014-02-10','16:00:00',2.65),('7643','2014-02-10','16:05:00',3.42),('7643','2014-02-10','16:10:00',2.99),('7643','2014-02-10','16:15:00',2.85),('7643','2014-02-10','16:20:00',2.89),('7643','2014-02-10','16:25:00',3.11),('7643','2014-02-10','16:30:00',2.93),('7643','2014-02-10','16:35:00',2.54),('7643','2014-02-10','16:40:00',2.23),('7643','2014-02-10','16:45:00',1.76),('7643','2014-02-10','16:50:00',1.3),('7643','2014-02-09','09:20:00',1.21),('7643','2014-02-09','09:25:00',1.82),('7643','2014-02-09','09:30:00',1.2),('7643','2014-02-09','09:50:00',1.03),('7643','2014-02-09','09:55:00',1.3),('7643','2014-02-09','10:00:00',1.42),('7643','2014-02-09','10:05:00',1.72),('7643','2014-02-09','10:10:00',1.84),('7643','2014-02-09','10:15:00',1.48),('7643','2014-02-09','10:20:00',1.77),('7643','2014-02-09','10:25:00',2.04),('7643','2014-02-09','10:30:00',2.03),('7643','2014-02-09','10:35:00',1.89),('7643','2014-02-09','10:40:00',1.27),('7643','2014-02-09','10:45:00',1.03),('7643','2014-02-09','10:50:00',1.34),('7643','2014-02-09','10:55:00',1.7),('7643','2014-02-09','11:00:00',1.61),('7643','2014-02-09','11:05:00',1.59),('7643','2014-02-09','11:10:00',1.46),('7643','2014-02-09','11:15:00',1.44),('7643','2014-02-09','11:20:00',1.38),('7643','2014-02-09','11:25:00',1.31),('7643','2014-02-09','11:30:00',1.24),('7643','2014-02-09','11:35:00',1.26),('7643','2014-02-09','11:40:00',1.56),('7643','2014-02-09','11:45:00',1.75),('7643','2014-02-09','11:50:00',1.72),('7643','2014-02-09','11:55:00',1.56),('7643','2014-02-09','12:00:00',1.78),('7643','2014-02-09','12:05:00',1.17),('7643','2014-02-09','12:10:00',1.67),('7643','2014-02-09','12:15:00',1.27),('7643','2014-02-09','12:20:00',1.63),('7643','2014-02-09','12:25:00',3.13),('7643','2014-02-09','12:30:00',2.55),('7643','2014-02-09','12:35:00',1.86),('7643','2014-02-09','12:40:00',1.79),('7643','2014-02-09','12:45:00',1.6),('7643','2014-02-09','12:50:00',2.25),('7643','2014-02-09','12:55:00',3.35),('7643','2014-02-09','13:00:00',4.47),('7643','2014-02-09','13:05:00',3.77),('7643','2014-02-09','13:10:00',2.83),('7643','2014-02-09','13:15:00',2.78),('7643','2014-02-09','13:20:00',2.59),('7643','2014-02-09','13:25:00',2.42),('7643','2014-02-09','13:30:00',2.78),('7643','2014-02-09','13:35:00',3.1),('7643','2014-02-09','13:40:00',3.08),('7643','2014-02-09','13:45:00',3.07),('7643','2014-02-09','13:50:00',2.92),('7643','2014-02-09','13:55:00',3.45),('7643','2014-02-09','14:00:00',3.59),('7643','2014-02-09','14:05:00',3.11),('7643','2014-02-09','14:10:00',2.98),('7643','2014-02-09','14:15:00',3.08),('7643','2014-02-09','14:20:00',3.14),('7643','2014-02-09','14:25:00',3.33),('7643','2014-02-09','14:30:00',3.67),('7643','2014-02-09','14:35:00',3.93),('7643','2014-02-09','14:40:00',4.06),('7643','2014-02-09','14:45:00',3.57),('7643','2014-02-09','14:50:00',2.95),('7643','2014-02-09','14:55:00',2.63),('7643','2014-02-09','15:00:00',2.58),('7643','2014-02-09','15:05:00',2.8),('7643','2014-02-09','15:10:00',2.67),('7643','2014-02-09','15:15:00',2.64),('7643','2014-02-09','15:20:00',2.7),('7643','2014-02-09','15:25:00',2.86),('7643','2014-02-09','15:30:00',2.63),('7643','2014-02-09','15:35:00',2.13),('7643','2014-02-09','15:40:00',1.71),('7643','2014-02-09','15:45:00',1.54),('7643','2014-02-09','15:50:00',1.59),('7643','2014-02-09','15:55:00',1.49),('7643','2014-02-09','16:00:00',1.18),('7643','2014-02-08','10:10:00',1.11),('7643','2014-02-08','10:45:00',1.75),('7643','2014-02-08','10:50:00',1.3),('7643','2014-02-08','10:55:00',1.28),('7643','2014-02-08','11:00:00',2.61),('7643','2014-02-08','11:05:00',2.55),('7643','2014-02-08','11:10:00',2.08),('7643','2014-02-08','11:15:00',2.08),('7643','2014-02-08','11:20:00',2.14),('7643','2014-02-08','11:25:00',3.39),('7643','2014-02-08','11:30:00',4.11),('7643','2014-02-08','11:35:00',4.93),('7643','2014-02-08','11:40:00',3.01),('7643','2014-02-08','11:45:00',1.25),('7643','2014-02-08','11:50:00',1.5),('7643','2014-02-08','11:55:00',1.77),('7643','2014-02-08','12:00:00',1.31),('7643','2014-02-08','12:05:00',1.47),('7643','2014-02-08','12:10:00',1.51),('7643','2014-02-08','12:15:00',2.81),('7643','2014-02-08','12:20:00',2.18),('7643','2014-02-08','12:25:00',5.25),('7643','2014-02-08','12:30:00',5.66),('7643','2014-02-08','12:35:00',4.08),('7643','2014-02-08','12:40:00',2.67),('7643','2014-02-08','12:45:00',7.46),('7643','2014-02-08','12:50:00',2.81),('7643','2014-02-08','12:55:00',5.8),('7643','2014-02-08','13:00:00',9.94),('7643','2014-02-08','13:05:00',10.64),('7643','2014-02-08','13:10:00',9.02),('7643','2014-02-08','13:15:00',5.69),('7643','2014-02-08','13:20:00',2.64),('7643','2014-02-08','13:25:00',3.93),('7643','2014-02-08','13:30:00',2.98),('7643','2014-02-08','13:35:00',2.82),('7643','2014-02-08','13:40:00',6.1),('7643','2014-02-08','13:45:00',11.14),('7643','2014-02-08','13:50:00',5.88),('7643','2014-02-08','13:55:00',9.29),('7643','2014-02-08','14:00:00',6.81),('7643','2014-02-08','14:05:00',9.92),('7643','2014-02-08','14:10:00',9.99),('7643','2014-02-08','14:15:00',4.95),('7643','2014-02-08','14:20:00',4.33),('7643','2014-02-08','14:25:00',5.92),('7643','2014-02-08','14:30:00',8.26),('7643','2014-02-08','14:35:00',7.1),('7643','2014-02-08','14:40:00',5.2),('7643','2014-02-08','14:45:00',3.29),('7643','2014-02-08','14:50:00',7.24),('7643','2014-02-08','14:55:00',3.59),('7643','2014-02-08','15:00:00',3.71),('7643','2014-02-08','15:05:00',1.98),('7643','2014-02-08','15:10:00',3.57),('7643','2014-02-08','15:15:00',6.05),('7643','2014-02-08','15:20:00',6.68),('7643','2014-02-08','15:25:00',6.39),('7643','2014-02-08','15:30:00',4.27),('7643','2014-02-08','15:35:00',3.83),('7643','2014-02-08','15:40:00',4.53),('7643','2014-02-08','15:45:00',4.54),('7643','2014-02-08','15:50:00',4.81),('7643','2014-02-08','15:55:00',4.43),('7643','2014-02-08','16:00:00',3.4),('7643','2014-02-08','16:05:00',3.45),('7643','2014-02-08','16:10:00',3.4),('7643','2014-02-08','16:15:00',3.06),('7643','2014-02-08','16:20:00',2.55),('7643','2014-02-08','16:25:00',2.05),('7643','2014-02-08','16:30:00',1.29),('7643','2014-02-08','16:35:00',1.26),('7643','2014-02-08','16:40:00',1.6),('7643','2014-02-08','16:45:00',1.36),('7643','2014-02-08','16:50:00',1.09),('7643','2014-02-07','09:35:00',1.36),('7643','2014-02-07','09:40:00',1.86),('7643','2014-02-07','09:45:00',2.88),('7643','2014-02-07','09:50:00',6.52),('7643','2014-02-07','09:55:00',4.98),('7643','2014-02-07','10:00:00',2.99),('7643','2014-02-07','10:05:00',3.01),('7643','2014-02-07','10:10:00',2.9),('7643','2014-02-07','10:15:00',5.9),('7643','2014-02-07','10:20:00',6.19),('7643','2014-02-07','10:25:00',4.48),('7643','2014-02-07','10:30:00',7.44),('7643','2014-02-07','10:35:00',10.84),('7643','2014-02-07','10:40:00',5.84),('7643','2014-02-07','10:45:00',5.57),('7643','2014-02-07','10:50:00',6.65),('7643','2014-02-07','10:55:00',11.61),('7643','2014-02-07','11:00:00',6.14),('7643','2014-02-07','11:05:00',11.82),('7643','2014-02-07','11:10:00',7.04),('7643','2014-02-07','11:15:00',6.38),('7643','2014-02-07','11:20:00',6.91),('7643','2014-02-07','11:25:00',2.84),('7643','2014-02-07','11:30:00',4.58),('7643','2014-02-07','11:35:00',14.58),('7643','2014-02-07','11:40:00',10.38),('7643','2014-02-07','11:45:00',2.52),('7643','2014-02-07','11:50:00',3.04),('7643','2014-02-07','11:55:00',14.64),('7643','2014-02-07','12:00:00',8.06),('7643','2014-02-07','12:05:00',4.5),('7643','2014-02-07','12:10:00',7.87),('7643','2014-02-07','12:15:00',14.48),('7643','2014-02-07','12:20:00',5.37),('7643','2014-02-07','12:25:00',5.63),('7643','2014-02-07','12:30:00',14.01),('7643','2014-02-07','12:35:00',7.12),('7643','2014-02-07','12:40:00',9.52),('7643','2014-02-07','12:45:00',11.03),('7643','2014-02-07','12:50:00',12.08),('7643','2014-02-07','12:55:00',10.9),('7643','2014-02-07','13:00:00',6.33),('7643','2014-02-07','13:05:00',5.33),('7643','2014-02-07','13:10:00',5.45),('7643','2014-02-07','13:15:00',14.82),('7643','2014-02-07','13:20:00',14.6),('7643','2014-02-07','13:25:00',12.32),('7643','2014-02-07','13:30:00',11.78),('7643','2014-02-07','13:35:00',7.59),('7643','2014-02-07','13:40:00',11.06),('7643','2014-02-07','13:45:00',12.5),('7643','2014-02-07','13:50:00',11.45),('7643','2014-02-07','13:55:00',11.21),('7643','2014-02-07','14:00:00',10.95),('7643','2014-02-07','14:05:00',11.17),('7643','2014-02-07','14:10:00',6.87),('7643','2014-02-07','14:15:00',5.03),('7643','2014-02-07','14:20:00',7.51),('7643','2014-02-07','14:25:00',6.32),('7643','2014-02-07','14:30:00',11.31),('7643','2014-02-07','14:35:00',7.75),('7643','2014-02-07','14:40:00',9.76),('7643','2014-02-07','14:45:00',4.18),('7643','2014-02-07','14:50:00',8.79),('7643','2014-02-07','14:55:00',7.2),('7643','2014-02-07','15:00:00',4.73),('7643','2014-02-07','15:05:00',2.85),('7643','2014-02-07','15:10:00',4.22),('7643','2014-02-07','15:15:00',5.22),('7643','2014-02-07','15:20:00',8.18),('7643','2014-02-07','15:25:00',2.75),('7643','2014-02-07','15:30:00',1.2),('7643','2014-02-07','15:35:00',1.79),('7643','2014-02-07','15:40:00',6.51),('7643','2014-02-07','15:45:00',6.44),('7643','2014-02-07','15:50:00',5.46),('7643','2014-02-07','15:55:00',4.71),('7643','2014-02-07','16:00:00',2.68),('7643','2014-02-07','16:05:00',3.48),('7643','2014-02-07','16:10:00',3.71),('7643','2014-02-07','16:15:00',3.17),('7643','2014-02-07','16:20:00',1.53),('7643','2014-02-07','16:25:00',1.44),('7643','2014-02-07','16:40:00',1.04),('7643','2014-02-06','08:00:00',1.23),('7643','2014-02-06','08:05:00',1.58),('7643','2014-02-06','08:10:00',1.76),('7643','2014-02-06','08:15:00',1.42),('7643','2014-02-06','08:20:00',1.75),('7643','2014-02-06','08:25:00',3.6),('7643','2014-02-06','08:30:00',3.63),('7643','2014-02-06','08:35:00',3.89),('7643','2014-02-06','08:40:00',4.59),('7643','2014-02-06','08:45:00',4.97),('7643','2014-02-06','08:50:00',5.27),('7643','2014-02-06','08:55:00',5.61),('7643','2014-02-06','09:00:00',5.9),('7643','2014-02-06','09:05:00',6.21),('7643','2014-02-06','09:10:00',6.5),('7643','2014-02-06','09:15:00',6.82),('7643','2014-02-06','09:20:00',7.06),('7643','2014-02-06','09:25:00',7.3),('7643','2014-02-06','09:30:00',7.59),('7643','2014-02-06','09:35:00',7.8),('7643','2014-02-06','09:40:00',8.04),('7643','2014-02-06','09:45:00',8.24),('7643','2014-02-06','09:50:00',8.51),('7643','2014-02-06','09:55:00',8.67),('7643','2014-02-06','10:00:00',8.89),('7643','2014-02-06','10:05:00',9.07),('7643','2014-02-06','10:10:00',9.3),('7643','2014-02-06','10:15:00',9.67),('7643','2014-02-06','10:20:00',9.79),('7643','2014-02-06','10:25:00',10.01),('7643','2014-02-06','10:30:00',9.6),('7643','2014-02-06','10:35:00',9.19),('7643','2014-02-06','10:40:00',10.93),('7643','2014-02-06','10:45:00',11.35),('7643','2014-02-06','10:50:00',11.44),('7643','2014-02-06','10:55:00',8.58),('7643','2014-02-06','11:00:00',11.83),('7643','2014-02-06','11:05:00',10.41),('7643','2014-02-06','11:10:00',10.65),('7643','2014-02-06','11:15:00',12.27),('7643','2014-02-06','11:20:00',13.04),('7643','2014-02-06','11:25:00',12.48),('7643','2014-02-06','11:30:00',12.39),('7643','2014-02-06','11:35:00',10.79),('7643','2014-02-06','11:40:00',12.66),('7643','2014-02-06','11:45:00',12.92),('7643','2014-02-06','11:50:00',13.19),('7643','2014-02-06','11:55:00',13.92),('7643','2014-02-06','12:00:00',14.22),('7643','2014-02-06','12:05:00',11.23),('7643','2014-02-06','12:10:00',11.75),('7643','2014-02-06','12:15:00',7.18),('7643','2014-02-06','12:20:00',6.85),('7643','2014-02-06','12:25:00',14.42),('7643','2014-02-06','12:30:00',10.83),('7643','2014-02-06','12:35:00',3.48),('7643','2014-02-06','12:40:00',7.13),('7643','2014-02-06','12:45:00',4.7),('7643','2014-02-06','12:50:00',9.15),('7643','2014-02-06','12:55:00',8.74),('7643','2014-02-06','13:00:00',9.14),('7643','2014-02-06','13:05:00',12.14),('7643','2014-02-06','13:10:00',13.45),('7643','2014-02-06','13:15:00',9.11),('7643','2014-02-06','13:20:00',6.4),('7643','2014-02-06','13:25:00',4.9),('7643','2014-02-06','13:30:00',9.41),('7643','2014-02-06','13:35:00',8.44),('7643','2014-02-06','13:40:00',4.67),('7643','2014-02-06','13:45:00',11.37),('7643','2014-02-06','13:50:00',8.45),('7643','2014-02-06','13:55:00',7.45),('7643','2014-02-06','14:00:00',9.98),('7643','2014-02-06','14:05:00',11.49),('7643','2014-02-06','14:10:00',10.74),('7643','2014-02-06','14:15:00',10.04),('7643','2014-02-06','14:20:00',4.16),('7643','2014-02-06','14:25:00',3),('7643','2014-02-06','14:30:00',4.48),('7643','2014-02-06','14:35:00',4.22),('7643','2014-02-06','14:40:00',8.7),('7643','2014-02-06','14:45:00',8.31),('7643','2014-02-06','14:50:00',8.71),('7643','2014-02-06','14:55:00',8.31),('7643','2014-02-06','15:00:00',7.91),('7643','2014-02-06','15:05:00',7.78),('7643','2014-02-06','15:10:00',7.46),('7643','2014-02-06','15:15:00',7.01),('7643','2014-02-06','15:20:00',6.4),('7643','2014-02-06','15:25:00',6.55),('7643','2014-02-06','15:30:00',6.24),('7643','2014-02-06','15:35:00',5.9),('7643','2014-02-06','15:40:00',5.61),('7643','2014-02-06','15:45:00',5.26),('7643','2014-02-06','15:50:00',4.95),('7643','2014-02-06','15:55:00',4.67),('7643','2014-02-06','16:00:00',4.32),('7643','2014-02-06','16:05:00',4.02),('7643','2014-02-06','16:10:00',3.71),('7643','2014-02-06','16:15:00',3.35),('7643','2014-02-06','16:20:00',3),('7643','2014-02-06','16:25:00',2.7),('7643','2014-02-06','16:30:00',2.37),('7643','2014-02-06','16:35:00',2.05),('7643','2014-02-06','16:40:00',1.7),('7643','2014-02-06','16:45:00',1.45),('7643','2014-02-06','16:50:00',1.17),('7643','2014-02-05','08:05:00',1.49),('7643','2014-02-05','08:10:00',1.38),('7643','2014-02-05','08:15:00',2.18),('7643','2014-02-05','08:20:00',2.76),('7643','2014-02-05','08:25:00',2.75),('7643','2014-02-05','08:30:00',2.74),('7643','2014-02-05','08:35:00',2.16),('7643','2014-02-05','08:40:00',4.3),('7643','2014-02-05','08:45:00',4.87),('7643','2014-02-05','08:50:00',5.37),('7643','2014-02-05','08:55:00',6.19),('7643','2014-02-05','09:00:00',7.35),('7643','2014-02-05','09:05:00',8.23),('7643','2014-02-05','09:10:00',6.47),('7643','2014-02-05','09:15:00',6.29),('7643','2014-02-05','09:20:00',2.65),('7643','2014-02-05','09:25:00',2.12),('7643','2014-02-05','09:30:00',6.95),('7643','2014-02-05','09:35:00',8.21),('7643','2014-02-05','09:40:00',8.38),('7643','2014-02-05','09:45:00',8.53),('7643','2014-02-05','09:50:00',8.76),('7643','2014-02-05','09:55:00',8.9),('7643','2014-02-05','10:00:00',9.06),('7643','2014-02-05','10:05:00',9.3),('7643','2014-02-05','10:10:00',9.53),('7643','2014-02-05','10:15:00',9.75),('7643','2014-02-05','10:20:00',9.92),('7643','2014-02-05','10:25:00',9.71),('7643','2014-02-05','10:30:00',10.4),('7643','2014-02-05','10:35:00',8.85),('7643','2014-02-05','10:40:00',8.45),('7643','2014-02-05','10:45:00',9.64),('7643','2014-02-05','10:50:00',5.51),('7643','2014-02-05','10:55:00',6.13),('7643','2014-02-05','11:00:00',7.13),('7643','2014-02-05','11:05:00',6.76),('7643','2014-02-05','11:10:00',4.8),('7643','2014-02-05','11:15:00',5.24),('7643','2014-02-05','11:20:00',9.04),('7643','2014-02-05','11:25:00',11.77),('7643','2014-02-05','11:30:00',12.55),('7643','2014-02-05','11:35:00',12.19),('7643','2014-02-05','11:40:00',12.07),('7643','2014-02-05','11:45:00',12.1),('7643','2014-02-05','11:50:00',12.25),('7643','2014-02-05','11:55:00',12.23),('7643','2014-02-05','12:00:00',12.37),('7643','2014-02-05','12:05:00',12.7),('7643','2014-02-05','12:10:00',12.74),('7643','2014-02-05','12:15:00',12.22),('7643','2014-02-05','12:20:00',12.39),('7643','2014-02-05','12:25:00',12.31),('7643','2014-02-05','12:30:00',12.11),('7643','2014-02-05','12:35:00',9.46),('7643','2014-02-05','12:40:00',12.37),('7643','2014-02-05','12:45:00',12.47),('7643','2014-02-05','12:50:00',12.08),('7643','2014-02-05','12:55:00',12.03),('7643','2014-02-05','13:00:00',12.03),('7643','2014-02-05','13:05:00',9.1),('7643','2014-02-05','13:10:00',12.38),('7643','2014-02-05','13:15:00',12.35),('7643','2014-02-05','13:20:00',11.94),('7643','2014-02-05','13:25:00',8.83),('7643','2014-02-05','13:30:00',7.51),('7643','2014-02-05','13:35:00',10.46),('7643','2014-02-05','13:40:00',11.6),('7643','2014-02-05','13:45:00',11.29),('7643','2014-02-05','13:50:00',11.16),('7643','2014-02-05','13:55:00',10.85),('7643','2014-02-05','14:00:00',8.45),('7643','2014-02-05','14:05:00',10.05),('7643','2014-02-05','14:10:00',3.97),('7643','2014-02-05','14:15:00',9.39),('7643','2014-02-05','14:20:00',6.45),('7643','2014-02-05','14:25:00',9.41),('7643','2014-02-05','14:30:00',4.69),('7643','2014-02-05','14:35:00',6.72),('7643','2014-02-05','14:40:00',9.31),('7643','2014-02-05','14:45:00',8.52),('7643','2014-02-05','14:50:00',6.95),('7643','2014-02-05','14:55:00',8.5),('7643','2014-02-05','15:00:00',8.03),('7643','2014-02-05','15:05:00',7.66),('7643','2014-02-05','15:10:00',7.4),('7643','2014-02-05','15:15:00',7.3),('7643','2014-02-05','15:20:00',7.27),('7643','2014-02-05','15:25:00',6.52),('7643','2014-02-05','15:30:00',6.07),('7643','2014-02-05','15:35:00',5.77),('7643','2014-02-05','15:40:00',5.44),('7643','2014-02-05','15:45:00',5.14),('7643','2014-02-05','15:50:00',4.8),('7643','2014-02-05','15:55:00',4.47),('7643','2014-02-05','16:00:00',4.09),('7643','2014-02-05','16:05:00',3.8),('7643','2014-02-05','16:10:00',3.51),('7643','2014-02-05','16:15:00',3.19),('7643','2014-02-05','16:20:00',2.84),('7643','2014-02-05','16:25:00',2.56),('7643','2014-02-05','16:30:00',2.26),('7643','2014-02-05','16:35:00',1.95),('7643','2014-02-05','16:40:00',1.66),('7643','2014-02-05','16:45:00',1.38),('7643','2014-02-05','16:50:00',1.13),('7643','2014-04-26','08:25:00',1.15),('7643','2014-04-26','08:30:00',1.24),('7643','2014-04-26','08:35:00',1.36),('7643','2014-04-26','08:40:00',1.42),('7643','2014-04-26','08:45:00',1.72),('7643','2014-04-26','08:50:00',2.61),('7643','2014-04-26','08:55:00',3.52),('7643','2014-04-26','09:00:00',3.03),('7643','2014-04-26','09:05:00',1.38),('7643','2014-04-26','09:10:00',1.28),('7643','2014-04-26','09:15:00',2.42),('7643','2014-04-26','09:20:00',3.2),('7643','2014-04-26','09:25:00',3.06),('7643','2014-04-26','09:30:00',2.4),('7643','2014-04-26','09:35:00',1.93),('7643','2014-04-26','09:40:00',2.49),('7643','2014-04-26','09:45:00',3.43),('7643','2014-04-26','09:50:00',2.94),('7643','2014-04-26','09:55:00',2.86),('7643','2014-04-26','10:00:00',4.06),('7643','2014-04-26','10:05:00',3.94),('7643','2014-04-26','10:10:00',4.18),('7643','2014-04-26','10:15:00',3.46),('7643','2014-04-26','10:20:00',3.11),('7643','2014-04-26','10:25:00',2.61),('7643','2014-04-26','10:30:00',1.87),('7643','2014-04-26','10:35:00',1.66),('7643','2014-04-26','10:40:00',1.84),('7643','2014-04-26','10:45:00',1.44),('7643','2014-04-26','10:50:00',1.87),('7643','2014-04-26','10:55:00',3),('7643','2014-04-26','11:00:00',4.43),('7643','2014-04-26','11:05:00',5.25),('7643','2014-04-26','11:10:00',6.59),('7643','2014-04-26','11:15:00',6.5),('7643','2014-04-26','11:20:00',4.77),('7643','2014-04-26','11:25:00',3.33),('7643','2014-04-26','11:30:00',4.13),('7643','2014-04-26','11:35:00',6.81),('7643','2014-04-26','11:40:00',7.19),('7643','2014-04-26','11:45:00',12.65),('7643','2014-04-26','11:50:00',10.15),('7643','2014-04-26','11:55:00',9.9),('7643','2014-04-26','12:00:00',10.07),('7643','2014-04-26','12:05:00',10.85),('7643','2014-04-26','12:10:00',12.79),('7643','2014-04-26','12:15:00',11.94),('7643','2014-04-26','12:20:00',10.83),('7643','2014-04-26','12:25:00',11.36),('7643','2014-04-26','12:30:00',10.08),('7643','2014-04-26','12:35:00',10.35),('7643','2014-04-26','12:40:00',9.17),('7643','2014-04-26','12:45:00',10.48),('7643','2014-04-26','12:50:00',8),('7643','2014-04-26','12:55:00',6.47),('7643','2014-04-26','13:00:00',8.15),('7643','2014-04-26','13:05:00',8.2),('7643','2014-04-26','13:10:00',6.67),('7643','2014-04-26','13:15:00',6.91),('7643','2014-04-26','13:20:00',9.7),('7643','2014-04-26','13:25:00',8.93),('7643','2014-04-26','13:30:00',8.01),('7643','2014-04-26','13:35:00',6.89),('7643','2014-04-26','13:40:00',6.57),('7643','2014-04-26','13:45:00',6.25),('7643','2014-04-26','13:50:00',6.11),('7643','2014-04-26','13:55:00',5.52),('7643','2014-04-26','14:00:00',7.43),('7643','2014-04-26','14:05:00',8.72),('7643','2014-04-26','14:10:00',6.49),('7643','2014-04-26','14:15:00',6.1),('7643','2014-04-26','14:20:00',7.01),('7643','2014-04-26','14:25:00',8.69),('7643','2014-04-26','14:30:00',9.16),('7643','2014-04-26','14:35:00',8.89),('7643','2014-04-26','14:40:00',8.93),('7643','2014-04-26','14:45:00',7.75),('7643','2014-04-26','14:50:00',7.36),('7643','2014-04-26','14:55:00',7.98),('7643','2014-04-26','15:00:00',8.48),('7643','2014-04-26','15:05:00',12.33),('7643','2014-04-26','15:10:00',16.98),('7643','2014-04-26','15:15:00',11.94),('7643','2014-04-26','15:20:00',7.6),('7643','2014-04-26','15:25:00',4.61),('7643','2014-04-26','15:30:00',3.61),('7643','2014-04-26','15:35:00',3.91),('7643','2014-04-26','15:40:00',3.96),('7643','2014-04-26','15:45:00',3.47),('7643','2014-04-26','15:50:00',3.41),('7643','2014-04-26','15:55:00',2.2),('7643','2014-04-26','16:20:00',1.03),('7643','2014-04-26','16:25:00',1.45),('7643','2014-04-26','16:30:00',1.42),('7643','2014-04-26','16:35:00',1.94),('7643','2014-04-26','16:40:00',1.32),('7643','2014-04-26','17:15:00',1.13),('7643','2014-04-26','17:45:00',1.05),('7643','2014-04-26','17:55:00',1.16),('7643','2014-04-26','18:00:00',1.18),('7643','2014-02-04','09:20:00',1.03),('7643','2014-02-04','09:55:00',1.32),('7643','2014-02-04','10:00:00',1.4),('7643','2014-02-04','10:05:00',1.54),('7643','2014-02-04','10:10:00',3.05),('7643','2014-02-04','10:15:00',6.04),('7643','2014-02-04','10:20:00',10.86),('7643','2014-02-04','10:25:00',10.29),('7643','2014-02-04','10:30:00',3.4),('7643','2014-02-04','10:35:00',4.54),('7643','2014-02-04','10:40:00',3.04),('7643','2014-02-04','10:45:00',1.59),('7643','2014-02-04','10:50:00',3.16),('7643','2014-02-04','10:55:00',3.18),('7643','2014-02-04','11:00:00',2.35),('7643','2014-02-04','11:05:00',1.7),('7643','2014-02-04','11:10:00',4.17),('7643','2014-02-04','11:15:00',9.61),('7643','2014-02-04','11:20:00',12.63),('7643','2014-02-04','11:25:00',8.13),('7643','2014-02-04','11:30:00',4.39),('7643','2014-02-04','11:35:00',2.23),('7643','2014-02-04','11:40:00',1.24),('7643','2014-02-04','11:50:00',1.27),('7643','2014-02-04','11:55:00',1.16),('7643','2014-02-04','12:00:00',1.05),('7643','2014-02-04','12:35:00',1.26),('7643','2014-02-04','12:50:00',1.74),('7643','2014-02-04','12:55:00',4.23),('7643','2014-02-04','13:00:00',3.44),('7643','2014-02-04','13:05:00',3.47),('7643','2014-02-04','13:10:00',4.25),('7643','2014-02-04','13:15:00',3.67),('7643','2014-02-04','13:20:00',4.35),('7643','2014-02-04','13:25:00',6.61),('7643','2014-02-04','13:30:00',6.33),('7643','2014-02-04','13:35:00',7.59),('7643','2014-02-04','13:40:00',7.55),('7643','2014-02-04','13:45:00',7.56),('7643','2014-02-04','13:50:00',6.39),('7643','2014-02-04','13:55:00',4.44),('7643','2014-02-04','14:00:00',3.34),('7643','2014-02-04','14:05:00',2.28),('7643','2014-02-04','14:10:00',1.74),('7643','2014-02-04','14:15:00',1.97),('7643','2014-02-04','14:20:00',1.61),('7643','2014-02-04','14:25:00',1.31),('7643','2014-02-04','14:30:00',5.72),('7643','2014-02-04','14:35:00',6.4),('7643','2014-02-04','14:40:00',2.7),('7643','2014-02-04','14:45:00',1.88),('7643','2014-02-04','14:50:00',1.96),('7643','2014-02-04','14:55:00',1.67),('7643','2014-02-04','15:00:00',1.94),('7643','2014-02-04','15:05:00',1.91),('7643','2014-02-04','15:10:00',1.78),('7643','2014-02-04','15:15:00',1.28),('7643','2014-02-04','15:25:00',1.1),('7643','2014-02-04','15:30:00',1.88),('7643','2014-02-04','15:35:00',1.26),('7643','2014-02-03','08:20:00',1.16),('7643','2014-02-03','08:25:00',1.32),('7643','2014-02-03','08:30:00',1.62),('7643','2014-02-03','08:35:00',1.91),('7643','2014-02-03','08:40:00',1.97),('7643','2014-02-03','08:45:00',2.07),('7643','2014-02-03','08:50:00',2.13),('7643','2014-02-03','08:55:00',2.33),('7643','2014-02-03','09:00:00',2.52),('7643','2014-02-03','09:05:00',2.72),('7643','2014-02-03','09:10:00',3),('7643','2014-02-03','09:15:00',3.68),('7643','2014-02-03','09:20:00',5.88),('7643','2014-02-03','09:25:00',8.27),('7643','2014-02-03','09:30:00',8.24),('7643','2014-02-03','09:35:00',8.09),('7643','2014-02-03','09:40:00',8.8),('7643','2014-02-03','09:45:00',8.4),('7643','2014-02-03','09:50:00',6.4),('7643','2014-02-03','09:55:00',8.39),('7643','2014-02-03','10:00:00',9.58),('7643','2014-02-03','10:05:00',9.05),('7643','2014-02-03','10:10:00',4.9),('7643','2014-02-03','10:15:00',7.78),('7643','2014-02-03','10:20:00',5.28),('7643','2014-02-03','10:25:00',3.44),('7643','2014-02-03','10:30:00',2.37),('7643','2014-02-03','10:35:00',3.49),('7643','2014-02-03','10:40:00',5.03),('7643','2014-02-03','10:45:00',6.65),('7643','2014-02-03','10:50:00',9.65),('7643','2014-02-03','10:55:00',10.25),('7643','2014-02-03','11:00:00',6.03),('7643','2014-02-03','11:05:00',4.03),('7643','2014-02-03','11:10:00',3.89),('7643','2014-02-03','11:15:00',3.4),('7643','2014-02-03','11:20:00',3.09),('7643','2014-02-03','11:25:00',3.31),('7643','2014-02-03','11:30:00',3.45),('7643','2014-02-03','11:35:00',2.46),('7643','2014-02-03','11:40:00',4.33),('7643','2014-02-03','11:45:00',2.42),('7643','2014-02-03','11:50:00',5.88),('7643','2014-02-03','11:55:00',13.15),('7643','2014-02-03','12:00:00',12.72),('7643','2014-02-03','12:05:00',4.91),('7643','2014-02-03','12:10:00',5.98),('7643','2014-02-03','12:15:00',5.98),('7643','2014-02-03','12:20:00',5.41),('7643','2014-02-03','12:25:00',5.18),('7643','2014-02-03','12:30:00',4.42),('7643','2014-02-03','12:35:00',3.21),('7643','2014-02-03','12:40:00',2.96),('7643','2014-02-03','12:45:00',4.04),('7643','2014-02-03','12:50:00',4.36),('7643','2014-02-03','12:55:00',3.45),('7643','2014-02-03','13:00:00',4.32),('7643','2014-02-03','13:05:00',4.59),('7643','2014-02-03','13:10:00',3.55),('7643','2014-02-03','13:15:00',4.21),('7643','2014-02-03','13:20:00',4.85),('7643','2014-02-03','13:25:00',3.98),('7643','2014-02-03','13:30:00',3.02),('7643','2014-02-03','13:35:00',2.87),('7643','2014-02-03','13:40:00',2.84),('7643','2014-02-03','13:45:00',2.99),('7643','2014-02-03','13:50:00',3.68),('7643','2014-02-03','13:55:00',3.32),('7643','2014-02-03','14:00:00',2.45),('7643','2014-02-03','14:05:00',2.12),('7643','2014-02-03','14:10:00',2.74),('7643','2014-02-03','14:15:00',3.12),('7643','2014-02-03','14:20:00',3.05),('7643','2014-02-03','14:25:00',2.16),('7643','2014-02-03','14:30:00',1.07),('7643','2014-02-03','15:00:00',1.14),('7643','2014-02-03','15:05:00',1.54),('7643','2014-02-03','15:10:00',1.83),('7643','2014-02-03','15:15:00',1.65),('7643','2014-02-03','15:20:00',1.18),('7643','2014-02-03','15:25:00',1.02),('7643','2014-02-02','08:20:00',1.01),('7643','2014-02-02','08:25:00',1.19),('7643','2014-02-02','08:30:00',1.18),('7643','2014-02-02','08:35:00',1.11),('7643','2014-02-02','08:40:00',1.24),('7643','2014-02-02','08:45:00',1.55),('7643','2014-02-02','08:50:00',1.57),('7643','2014-02-02','08:55:00',1.52),('7643','2014-02-02','09:00:00',1.77),('7643','2014-02-02','09:05:00',1.83),('7643','2014-02-02','09:10:00',1.68),('7643','2014-02-02','09:15:00',1.76),('7643','2014-02-02','09:20:00',1.93),('7643','2014-02-02','09:25:00',2.11),('7643','2014-02-02','09:30:00',2.18),('7643','2014-02-02','09:35:00',2.33),('7643','2014-02-02','09:40:00',2.61),('7643','2014-02-02','09:45:00',2.96),('7643','2014-02-02','09:50:00',3.39),('7643','2014-02-02','09:55:00',2.99),('7643','2014-02-02','10:00:00',2.71),('7643','2014-02-02','10:05:00',2.78),('7643','2014-02-02','10:10:00',3.31),('7643','2014-02-02','10:15:00',3.89),('7643','2014-02-02','10:20:00',3.82),('7643','2014-02-02','10:25:00',3.81),('7643','2014-02-02','10:30:00',3.96),('7643','2014-02-02','10:35:00',3.97),('7643','2014-02-02','10:40:00',4.15),('7643','2014-02-02','10:45:00',4.15),('7643','2014-02-02','10:50:00',4.13),('7643','2014-02-02','10:55:00',4.05),('7643','2014-02-02','11:00:00',3.81),('7643','2014-02-02','11:05:00',3.59),('7643','2014-02-02','11:10:00',3.66),('7643','2014-02-02','11:15:00',3.77),('7643','2014-02-02','11:20:00',3.99),('7643','2014-02-02','11:25:00',4.27),('7643','2014-02-02','11:30:00',4.67),('7643','2014-02-02','11:35:00',4.73),('7643','2014-02-02','11:40:00',4.6),('7643','2014-02-02','11:45:00',4.57),('7643','2014-02-02','11:50:00',4.46),('7643','2014-02-02','11:55:00',3.83),('7643','2014-02-02','12:00:00',3.28),('7643','2014-02-02','12:05:00',3.36),('7643','2014-02-02','12:10:00',3.45),('7643','2014-02-02','12:15:00',3.65),('7643','2014-02-02','12:20:00',3.41),('7643','2014-02-02','12:25:00',2.97),('7643','2014-02-02','12:30:00',2.42),('7643','2014-02-02','12:35:00',2.14),('7643','2014-02-02','12:40:00',2.3),('7643','2014-02-02','12:45:00',1.64),('7643','2014-02-02','12:50:00',1.58),('7643','2014-02-02','12:55:00',2.33),('7643','2014-02-02','13:00:00',2.44),('7643','2014-02-02','13:05:00',2.33),('7643','2014-02-02','13:10:00',2.52),('7643','2014-02-02','13:15:00',2.77),('7643','2014-02-02','13:20:00',2.85),('7643','2014-02-02','13:25:00',3.07),('7643','2014-02-02','13:30:00',3.21),('7643','2014-02-02','13:35:00',3.05),('7643','2014-02-02','13:40:00',2.79),('7643','2014-02-02','13:45:00',2.69),('7643','2014-02-02','13:50:00',2.84),('7643','2014-02-02','13:55:00',2.88),('7643','2014-02-02','14:00:00',3.08),('7643','2014-02-02','14:05:00',3.24),('7643','2014-02-02','14:10:00',3.29),('7643','2014-02-02','14:15:00',3.14),('7643','2014-02-02','14:20:00',2.87),('7643','2014-02-02','14:25:00',3.22),('7643','2014-02-02','14:30:00',3.42),('7643','2014-02-02','14:35:00',3.44),('7643','2014-02-02','14:40:00',3.41),('7643','2014-02-02','14:45:00',3.23),('7643','2014-02-02','14:50:00',2.93),('7643','2014-02-02','14:55:00',2.41),('7643','2014-02-02','15:00:00',1.68),('7643','2014-02-02','15:05:00',1.39),('7643','2014-02-02','15:10:00',1.51),('7643','2014-02-02','15:15:00',1.64),('7643','2014-02-02','15:20:00',1.82),('7643','2014-02-02','15:25:00',1.88),('7643','2014-02-02','15:30:00',1.62),('7643','2014-02-02','15:35:00',1.35),('7643','2014-02-02','15:40:00',1.13),('7643','2014-02-01','09:40:00',1.09),('7643','2014-02-01','09:45:00',1.28),('7643','2014-02-01','09:50:00',1.31),('7643','2014-02-01','09:55:00',1.44),('7643','2014-02-01','10:00:00',1.59),('7643','2014-02-01','10:05:00',1.56),('7643','2014-02-01','10:10:00',1.52),('7643','2014-02-01','10:15:00',1.28),('7643','2014-02-01','10:20:00',1.16),('7643','2014-02-01','10:25:00',1.15),('7643','2014-02-01','10:30:00',1.08),('7643','2014-02-01','10:35:00',1.14),('7643','2014-02-01','10:40:00',1.3),('7643','2014-02-01','10:45:00',1.25),('7643','2014-02-01','10:50:00',1.05),('7643','2014-02-01','11:05:00',1.06),('7643','2014-02-01','11:10:00',1.29),('7643','2014-02-01','11:15:00',1.68),('7643','2014-02-01','11:20:00',1.96),('7643','2014-02-01','11:25:00',2.32),('7643','2014-02-01','11:30:00',2.51),('7643','2014-02-01','11:35:00',2.35),('7643','2014-02-01','11:40:00',2.43),('7643','2014-02-01','11:45:00',2.66),('7643','2014-02-01','11:50:00',2.89),('7643','2014-02-01','11:55:00',3.26),('7643','2014-02-01','12:00:00',3.6),('7643','2014-02-01','12:05:00',3.68),('7643','2014-02-01','12:10:00',3.51),('7643','2014-02-01','12:15:00',3.07),('7643','2014-02-01','12:20:00',2.63),('7643','2014-02-01','12:25:00',2.36),('7643','2014-02-01','12:30:00',2.38),('7643','2014-02-01','12:35:00',2.31),('7643','2014-02-01','12:40:00',2.09),('7643','2014-02-01','12:45:00',1.82),('7643','2014-02-01','12:50:00',1.6),('7643','2014-02-01','12:55:00',1.59),('7643','2014-02-01','13:00:00',1.66),('7643','2014-02-01','13:05:00',1.74),('7643','2014-02-01','13:10:00',1.83),('7643','2014-02-01','13:15:00',2.15),('7643','2014-02-01','13:20:00',2.43),('7643','2014-02-01','13:25:00',2.34),('7643','2014-02-01','13:30:00',1.94),('7643','2014-02-01','13:35:00',1.49),('7643','2014-02-01','13:40:00',1.46),('7643','2014-02-01','13:45:00',1.5),('7643','2014-02-01','13:50:00',1.74),('7643','2014-02-01','13:55:00',1.89),('7643','2014-02-01','14:00:00',1.86),('7643','2014-02-01','14:05:00',1.91),('7643','2014-02-01','14:10:00',1.74),('7643','2014-02-01','14:15:00',1.66),('7643','2014-02-01','14:20:00',1.96),('7643','2014-02-01','14:25:00',1.94),('7643','2014-02-01','14:30:00',1.77),('7643','2014-02-01','14:35:00',1.69),('7643','2014-02-01','14:40:00',1.59),('7643','2014-02-01','14:45:00',1.55),('7643','2014-02-01','14:50:00',1.64),('7643','2014-02-01','14:55:00',1.78),('7643','2014-02-01','15:00:00',1.92),('7643','2014-02-01','15:05:00',1.99),('7643','2014-02-01','15:10:00',1.98),('7643','2014-02-01','15:15:00',1.84),('7643','2014-02-01','15:20:00',1.72),('7643','2014-02-01','15:25:00',1.51),('7643','2014-02-01','15:30:00',1.21),('7643','2014-02-01','15:35:00',1.02),('7643','2014-01-31','08:45:00',1.93),('7643','2014-01-31','08:50:00',2.21),('7643','2014-01-31','08:55:00',1.86),('7643','2014-01-31','09:00:00',1.72),('7643','2014-01-31','09:05:00',1.85),('7643','2014-01-31','09:10:00',1.9),('7643','2014-01-31','09:15:00',2.2),('7643','2014-01-31','09:20:00',2.17),('7643','2014-01-31','09:25:00',2.25),('7643','2014-01-31','09:30:00',1.83),('7643','2014-01-31','09:35:00',1.49),('7643','2014-01-31','09:40:00',1.46),('7643','2014-01-31','09:45:00',1.71),('7643','2014-01-31','09:50:00',1.81),('7643','2014-01-31','09:55:00',1.89),('7643','2014-01-31','10:00:00',1.6),('7643','2014-01-31','10:05:00',1.58),('7643','2014-01-31','10:10:00',1.78),('7643','2014-01-31','10:15:00',2.33),('7643','2014-01-31','10:20:00',2.67),('7643','2014-01-31','10:25:00',2.41),('7643','2014-01-31','10:30:00',2.3),('7643','2014-01-31','10:35:00',2.28),('7643','2014-01-31','10:40:00',2.43),('7643','2014-01-31','10:45:00',2.66),('7643','2014-01-31','10:50:00',2.83),('7643','2014-01-31','10:55:00',3.23),('7643','2014-01-31','11:00:00',4.36),('7643','2014-01-31','11:05:00',4.16),('7643','2014-01-31','11:10:00',3.09),('7643','2014-01-31','11:15:00',4.11),('7643','2014-01-31','11:20:00',6.81),('7643','2014-01-31','11:25:00',4.84),('7643','2014-01-31','11:30:00',8.5),('7643','2014-01-31','11:35:00',6.54),('7643','2014-01-31','11:40:00',3.84),('7643','2014-01-31','11:45:00',2.58),('7643','2014-01-31','11:50:00',3.19),('7643','2014-01-31','11:55:00',7.5),('7643','2014-01-31','12:00:00',5.64),('7643','2014-01-31','12:05:00',5.75),('7643','2014-01-31','12:10:00',7.89),('7643','2014-01-31','12:15:00',5.06),('7643','2014-01-31','12:20:00',8.48),('7643','2014-01-31','12:25:00',4.75),('7643','2014-01-31','12:30:00',2.66),('7643','2014-01-31','12:35:00',3.89),('7643','2014-01-31','12:40:00',6.72),('7643','2014-01-31','12:45:00',8.47),('7643','2014-01-31','12:50:00',7.21),('7643','2014-01-31','12:55:00',4.65),('7643','2014-01-31','13:00:00',5.33),('7643','2014-01-31','13:05:00',3.79),('7643','2014-01-31','13:10:00',2.75),('7643','2014-01-31','13:15:00',2.27),('7643','2014-01-31','13:20:00',2.14),('7643','2014-01-31','13:25:00',2.32),('7643','2014-01-31','13:30:00',2.45),('7643','2014-01-31','13:35:00',2.38),('7643','2014-01-31','13:40:00',2.17),('7643','2014-01-31','13:45:00',2.23),('7643','2014-01-31','13:50:00',2.16),('7643','2014-01-31','13:55:00',1.57),('7643','2014-01-31','14:00:00',1.27),('7643','2014-01-31','14:05:00',1.28),('7643','2014-01-31','14:10:00',1.48),('7643','2014-01-31','14:15:00',1.22),('7643','2014-01-31','14:55:00',1.13),('7643','2014-01-31','15:00:00',1.14),('7643','2014-01-31','15:05:00',1.34),('7643','2014-01-31','15:10:00',1.28),('7643','2014-01-31','15:15:00',1.14),('7643','2014-01-30','10:10:00',1.03),('7643','2014-01-30','10:15:00',2.03),('7643','2014-01-30','10:20:00',2.28),('7643','2014-01-30','10:25:00',2.39),('7643','2014-01-30','10:30:00',3.02),('7643','2014-01-30','10:35:00',2.44),('7643','2014-01-30','10:40:00',1.12),('7643','2014-01-30','10:55:00',1.16),('7643','2014-01-30','11:00:00',1.54),('7643','2014-01-30','11:05:00',1.84),('7643','2014-01-30','11:10:00',1.87),('7643','2014-01-30','11:15:00',1.6),('7643','2014-01-30','11:20:00',1.72),('7643','2014-01-30','11:25:00',1.65),('7643','2014-01-30','11:30:00',1.81),('7643','2014-01-30','11:35:00',2.21),('7643','2014-01-30','11:40:00',2.49),('7643','2014-01-30','11:45:00',2.65),('7643','2014-01-30','11:50:00',2.77),('7643','2014-01-30','11:55:00',2.42),('7643','2014-01-30','12:00:00',2.02),('7643','2014-01-30','12:05:00',1.98),('7643','2014-01-30','12:10:00',2.28),('7643','2014-01-30','12:15:00',2.55),('7643','2014-01-30','12:20:00',2.46),('7643','2014-01-30','12:25:00',2.59),('7643','2014-01-30','12:30:00',2.66),('7643','2014-01-30','12:35:00',2.97),('7643','2014-01-30','12:40:00',2.35),('7643','2014-01-30','12:45:00',1.77),('7643','2014-01-30','12:50:00',1.62),('7643','2014-01-30','12:55:00',1.52),('7643','2014-01-30','13:00:00',1.6),('7643','2014-01-30','13:05:00',1.47),('7643','2014-01-30','13:10:00',1.25),('7643','2014-01-30','13:15:00',1.1),('7643','2014-01-30','13:20:00',1.27),('7643','2014-01-30','13:25:00',1.53),('7643','2014-01-30','13:30:00',1.58),('7643','2014-01-30','13:35:00',1.41),('7643','2014-01-30','13:40:00',1.99),('7643','2014-01-30','13:45:00',2.7),('7643','2014-01-30','13:50:00',3.31),('7643','2014-01-30','13:55:00',2.66),('7643','2014-01-30','14:00:00',1.92),('7643','2014-01-30','14:05:00',2.01),('7643','2014-01-30','14:10:00',2.18),('7643','2014-01-30','14:15:00',2.51),('7643','2014-01-30','14:20:00',2.35),('7643','2014-01-30','14:25:00',1.59),('7643','2014-01-30','14:30:00',1.15),('7643','2014-01-30','14:35:00',1.47),('7643','2014-01-30','14:40:00',2.06),('7643','2014-01-30','14:45:00',2.77),('7643','2014-01-30','14:50:00',1.52),('7643','2014-01-29','08:30:00',1.07),('7643','2014-01-29','08:35:00',1.21),('7643','2014-01-29','08:40:00',1.37),('7643','2014-01-29','08:45:00',1.54),('7643','2014-01-29','08:50:00',1.8),('7643','2014-01-29','08:55:00',2.03),('7643','2014-01-29','09:00:00',2.22),('7643','2014-01-29','09:05:00',2.39),('7643','2014-01-29','09:10:00',2.57),('7643','2014-01-29','09:15:00',2.92),('7643','2014-01-29','09:20:00',3.23),('7643','2014-01-29','09:25:00',3.39),('7643','2014-01-29','09:30:00',3.17),('7643','2014-01-29','09:35:00',3.15),('7643','2014-01-29','09:40:00',3.86),('7643','2014-01-29','09:45:00',3.25),('7643','2014-01-29','09:50:00',5.11),('7643','2014-01-29','09:55:00',8.09),('7643','2014-01-29','10:00:00',7.41),('7643','2014-01-29','10:05:00',5.92),('7643','2014-01-29','10:10:00',7.14),('7643','2014-01-29','10:15:00',8.98),('7643','2014-01-29','10:20:00',7.73),('7643','2014-01-29','10:25:00',9.2),('7643','2014-01-29','10:30:00',9.63),('7643','2014-01-29','10:35:00',9.69),('7643','2014-01-29','10:40:00',9.57),('7643','2014-01-29','10:45:00',8.82),('7643','2014-01-29','10:50:00',10.8),('7643','2014-01-29','10:55:00',12.66),('7643','2014-01-29','11:00:00',12.2),('7643','2014-01-29','11:05:00',11.59),('7643','2014-01-29','11:10:00',11.29),('7643','2014-01-29','11:15:00',11.09),('7643','2014-01-29','11:20:00',7.65),('7643','2014-01-29','11:25:00',9.56),('7643','2014-01-29','11:30:00',9.2),('7643','2014-01-29','11:35:00',8.61),('7643','2014-01-29','11:40:00',5),('7643','2014-01-29','11:45:00',9.72),('7643','2014-01-29','11:50:00',7.54),('7643','2014-01-29','11:55:00',12.16),('7643','2014-01-29','12:00:00',6.41),('7643','2014-01-29','12:05:00',10.81),('7643','2014-01-29','12:10:00',8.64),('7643','2014-01-29','12:15:00',7.9),('7643','2014-01-29','12:20:00',11.78),('7643','2014-01-29','12:25:00',10.17),('7643','2014-01-29','12:30:00',9.04),('7643','2014-01-29','12:35:00',9.72),('7643','2014-01-29','12:40:00',7.68),('7643','2014-01-29','12:45:00',11.8),('7643','2014-01-29','12:50:00',11.27),('7643','2014-01-29','12:55:00',10.53),('7643','2014-01-29','13:00:00',7.53),('7643','2014-01-29','13:05:00',12.34),('7643','2014-01-29','13:10:00',8.89),('7643','2014-01-29','13:15:00',10.02),('7643','2014-01-29','13:20:00',8.2),('7643','2014-01-29','13:25:00',10.99),('7643','2014-01-29','13:30:00',9.19),('7643','2014-01-29','13:35:00',8.29),('7643','2014-01-29','13:40:00',9.63),('7643','2014-01-29','13:45:00',11.01),('7643','2014-01-29','13:50:00',10.07),('7643','2014-01-29','13:55:00',9.25),('7643','2014-01-29','14:00:00',8.81),('7643','2014-01-29','14:05:00',8.6),('7643','2014-01-29','14:10:00',8.44),('7643','2014-01-29','14:15:00',7.17),('7643','2014-01-29','14:20:00',6.44),('7643','2014-01-29','14:25:00',6.87),('7643','2014-01-29','14:30:00',7.36),('7643','2014-01-29','14:35:00',7.2),('7643','2014-01-29','14:40:00',8.08),('7643','2014-01-29','14:45:00',7.61),('7643','2014-01-29','14:50:00',7.93),('7643','2014-01-29','14:55:00',7.54),('7643','2014-01-29','15:00:00',7.3),('7643','2014-01-29','15:05:00',7.14),('7643','2014-01-29','15:10:00',6.78),('7643','2014-01-29','15:15:00',6.28),('7643','2014-01-29','15:20:00',6.42),('7643','2014-01-29','15:25:00',6.42),('7643','2014-01-29','15:30:00',5.8),('7643','2014-01-29','15:35:00',5.72),('7643','2014-01-29','15:40:00',5.21),('7643','2014-01-29','15:45:00',3.21),('7643','2014-01-29','15:50:00',2.49),('7643','2014-01-29','15:55:00',1.11),('7643','2014-01-28','08:25:00',1.02),('7643','2014-01-28','08:30:00',1.38),('7643','2014-01-28','08:35:00',1.55),('7643','2014-01-28','08:40:00',1.58),('7643','2014-01-28','08:45:00',1.32),('7643','2014-01-28','08:50:00',1.19),('7643','2014-01-28','08:55:00',1.39),('7643','2014-01-28','09:00:00',1.71),('7643','2014-01-28','09:05:00',2.07),('7643','2014-01-28','09:10:00',2.65),('7643','2014-01-28','09:15:00',3.6),('7643','2014-01-28','09:20:00',5.64),('7643','2014-01-28','09:25:00',3.73),('7643','2014-01-28','09:30:00',5.04),('7643','2014-01-28','09:35:00',7.99),('7643','2014-01-28','09:40:00',6.75),('7643','2014-01-28','09:45:00',7.38),('7643','2014-01-28','09:50:00',6.54),('7643','2014-01-28','09:55:00',6.68),('7643','2014-01-28','10:00:00',5.2),('7643','2014-01-28','10:05:00',5.05),('7643','2014-01-28','10:10:00',5.98),('7643','2014-01-28','10:15:00',6.9),('7643','2014-01-28','10:20:00',4.95),('7643','2014-01-28','10:25:00',10),('7643','2014-01-28','10:30:00',10.91),('7643','2014-01-28','10:35:00',8.73),('7643','2014-01-28','10:40:00',7.86),('7643','2014-01-28','10:45:00',7.75),('7643','2014-01-28','10:50:00',7.4),('7643','2014-01-28','10:55:00',6.75),('7643','2014-01-28','11:00:00',6.93),('7643','2014-01-28','11:05:00',7.93),('7643','2014-01-28','11:10:00',7.04),('7643','2014-01-28','11:15:00',7.06),('7643','2014-01-28','11:20:00',7.39),('7643','2014-01-28','11:25:00',7.16),('7643','2014-01-28','11:30:00',10.42),('7643','2014-01-28','11:35:00',10.12),('7643','2014-01-28','11:40:00',7.5),('7643','2014-01-28','11:45:00',4.61),('7643','2014-01-28','11:50:00',3.86),('7643','2014-01-28','11:55:00',1.82),('7643','2014-01-28','12:05:00',1.19),('7643','2014-01-28','12:40:00',1.11),('7643','2014-01-28','12:45:00',3.53),('7643','2014-01-28','12:50:00',9.99),('7643','2014-01-28','12:55:00',12.08),('7643','2014-01-28','13:00:00',9.02),('7643','2014-01-28','13:05:00',3.41),('7643','2014-01-28','13:10:00',1.81),('7643','2014-01-28','13:15:00',1.04),('7643','2014-01-28','13:20:00',1.22),('7643','2014-01-28','13:25:00',1.93),('7643','2014-01-28','13:30:00',3.23),('7643','2014-01-28','13:35:00',6.21),('7643','2014-01-28','13:40:00',8.21),('7643','2014-01-28','13:45:00',3.6),('7643','2014-01-28','13:50:00',7.84),('7643','2014-01-28','13:55:00',8.17),('7643','2014-01-28','14:00:00',3.66),('7643','2014-01-28','14:05:00',2.35),('7643','2014-01-28','14:10:00',2.01),('7643','2014-01-28','14:15:00',1.53),('7643','2014-01-28','14:20:00',1.91),('7643','2014-01-28','14:25:00',2.01),('7643','2014-01-28','14:30:00',3.15),('7643','2014-01-28','14:35:00',2.85),('7643','2014-01-28','14:40:00',3.49),('7643','2014-01-28','14:45:00',2.59),('7643','2014-01-28','14:50:00',1.42),('7643','2014-01-28','14:55:00',1.28),('7643','2014-01-28','15:00:00',1.7),('7643','2014-01-28','15:05:00',2.51),('7643','2014-01-28','15:10:00',4.56),('7643','2014-01-28','15:15:00',5.7),('7643','2014-01-28','15:20:00',3.95),('7643','2014-01-28','15:25:00',2.01),('7643','2014-01-28','15:30:00',1.37),('7643','2014-01-27','08:30:00',1.05),('7643','2014-01-27','08:35:00',1.33),('7643','2014-01-27','08:45:00',1.12),('7643','2014-01-27','08:50:00',1.49),('7643','2014-01-27','08:55:00',1.5),('7643','2014-01-27','09:00:00',2.36),('7643','2014-01-27','09:05:00',3.63),('7643','2014-01-27','09:10:00',4.76),('7643','2014-01-27','09:15:00',4.74),('7643','2014-01-27','09:20:00',5.16),('7643','2014-01-27','09:25:00',5.44),('7643','2014-01-27','09:30:00',5.3),('7643','2014-01-27','09:35:00',6.05),('7643','2014-01-27','09:40:00',5.37),('7643','2014-01-27','09:45:00',6.15),('7643','2014-01-27','09:50:00',7.38),('7643','2014-01-27','09:55:00',8.04),('7643','2014-01-27','10:00:00',8.59),('7643','2014-01-27','10:05:00',8.3),('7643','2014-01-27','10:10:00',8.23),('7643','2014-01-27','10:15:00',8.5),('7643','2014-01-27','10:20:00',9.03),('7643','2014-01-27','10:25:00',9.54),('7643','2014-01-27','10:30:00',9.46),('7643','2014-01-27','10:35:00',9.83),('7643','2014-01-27','10:40:00',10.09),('7643','2014-01-27','10:45:00',8.86),('7643','2014-01-27','10:50:00',9.63),('7643','2014-01-27','10:55:00',10.07),('7643','2014-01-27','11:00:00',7.92),('7643','2014-01-27','11:05:00',10.57),('7643','2014-01-27','11:10:00',5.71),('7643','2014-01-27','11:15:00',7.44),('7643','2014-01-27','11:20:00',3.33),('7643','2014-01-27','11:25:00',3.41),('7643','2014-01-27','11:30:00',9.62),('7643','2014-01-27','11:35:00',8.3),('7643','2014-01-27','11:40:00',12.15),('7643','2014-01-27','11:45:00',9.67),('7643','2014-01-27','11:50:00',4.77),('7643','2014-01-27','11:55:00',2.24),('7643','2014-01-27','12:00:00',5.97),('7643','2014-01-27','12:05:00',12.53),('7643','2014-01-27','12:10:00',9.87),('7643','2014-01-27','12:15:00',10.21),('7643','2014-01-27','12:20:00',5.62),('7643','2014-01-27','12:25:00',4.5),('7643','2014-01-27','12:30:00',4.3),('7643','2014-01-27','12:35:00',5.54),('7643','2014-01-27','12:40:00',6.88),('7643','2014-01-27','12:45:00',6.59),('7643','2014-01-27','12:50:00',11.74),('7643','2014-01-27','12:55:00',11.52),('7643','2014-01-27','13:00:00',11.54),('7643','2014-01-27','13:05:00',13.3),('7643','2014-01-27','13:10:00',8.89),('7643','2014-01-27','13:15:00',10.01),('7643','2014-01-27','13:20:00',10.15),('7643','2014-01-27','13:25:00',10.95),('7643','2014-01-27','13:30:00',10.99),('7643','2014-01-27','13:35:00',11.97),('7643','2014-01-27','13:40:00',11.49),('7643','2014-01-27','13:45:00',11.07),('7643','2014-01-27','13:50:00',10.71),('7643','2014-01-27','13:55:00',10.49),('7643','2014-01-27','14:00:00',10.31),('7643','2014-01-27','14:05:00',10.02),('7643','2014-01-27','14:10:00',9.84),('7643','2014-01-27','14:15:00',9.65),('7643','2014-01-27','14:20:00',9.41),('7643','2014-01-27','14:25:00',9.54),('7643','2014-01-27','14:30:00',9.55),('7643','2014-01-27','14:35:00',8.66),('7643','2014-01-27','14:40:00',8.08),('7643','2014-01-27','14:45:00',8.34),('7643','2014-01-27','14:50:00',7.91),('7643','2014-01-27','14:55:00',7.66),('7643','2014-01-27','15:00:00',7.38),('7643','2014-01-27','15:05:00',7.11),('7643','2014-01-27','15:10:00',6.77),('7643','2014-01-27','15:15:00',6.46),('7643','2014-01-27','15:20:00',6.18),('7643','2014-01-27','15:25:00',5.83),('7643','2014-01-27','15:30:00',5.51),('7643','2014-01-27','15:35:00',5.15),('7643','2014-01-27','15:40:00',4.81),('7643','2014-01-27','15:45:00',4.5),('7643','2014-01-27','15:50:00',4.19),('7643','2014-01-27','15:55:00',3.85),('7643','2014-01-27','16:00:00',3.53),('7643','2014-01-27','16:05:00',3.2),('7643','2014-01-27','16:10:00',2.78),('7643','2014-01-27','16:15:00',2.53),('7643','2014-01-27','16:20:00',2.22),('7643','2014-01-27','16:25:00',1.91),('7643','2014-01-27','16:30:00',1.19),('7643','2014-01-26','08:10:00',1.09),('7643','2014-01-26','08:15:00',1.17),('7643','2014-01-26','08:20:00',1.33),('7643','2014-01-26','08:25:00',1.51),('7643','2014-01-26','08:30:00',1.82),('7643','2014-01-26','08:35:00',1.78),('7643','2014-01-26','08:40:00',1.68),('7643','2014-01-26','08:45:00',1.64),('7643','2014-01-26','08:50:00',1.57),('7643','2014-01-26','08:55:00',1.66),('7643','2014-01-26','09:00:00',1.73),('7643','2014-01-26','09:05:00',1.48),('7643','2014-01-26','09:10:00',1.33),('7643','2014-01-26','09:25:00',1.4),('7643','2014-01-26','09:30:00',1.45),('7643','2014-01-26','09:35:00',1.61),('7643','2014-01-26','09:40:00',2.33),('7643','2014-01-26','09:45:00',2.49),('7643','2014-01-26','09:50:00',2.71),('7643','2014-01-26','09:55:00',2.8),('7643','2014-01-26','10:00:00',2.85),('7643','2014-01-26','10:05:00',2.93),('7643','2014-01-26','10:10:00',2.77),('7643','2014-01-26','10:15:00',2.85),('7643','2014-01-26','10:20:00',2.8),('7643','2014-01-26','10:25:00',3.34),('7643','2014-01-26','10:30:00',3.33),('7643','2014-01-26','10:35:00',3.31),('7643','2014-01-26','10:40:00',2.98),('7643','2014-01-26','10:45:00',3.31),('7643','2014-01-26','10:50:00',3.29),('7643','2014-01-26','10:55:00',3.01),('7643','2014-01-26','11:00:00',3.29),('7643','2014-01-26','11:05:00',3.63),('7643','2014-01-26','11:10:00',3.13),('7643','2014-01-26','11:15:00',3.03),('7643','2014-01-26','11:20:00',3.79),('7643','2014-01-26','11:25:00',3.81),('7643','2014-01-26','11:30:00',3.25),('7643','2014-01-26','11:35:00',2.69),('7643','2014-01-26','11:40:00',2.89),('7643','2014-01-26','11:45:00',2.08),('7643','2014-01-26','11:50:00',2.08),('7643','2014-01-26','11:55:00',1.98),('7643','2014-01-26','12:00:00',2.29),('7643','2014-01-26','12:05:00',2.69),('7643','2014-01-26','12:10:00',2.49),('7643','2014-01-26','12:15:00',2.08),('7643','2014-01-26','12:20:00',1.77),('7643','2014-01-26','12:25:00',1.59),('7643','2014-01-26','12:30:00',1.79),('7643','2014-01-26','12:35:00',1.87),('7643','2014-01-26','12:40:00',1.71),('7643','2014-01-26','12:45:00',2.27),('7643','2014-01-26','12:50:00',3.06),('7643','2014-01-26','12:55:00',2.97),('7643','2014-01-26','13:00:00',2.67),('7643','2014-01-26','13:05:00',2.72),('7643','2014-01-26','13:10:00',2.79),('7643','2014-01-26','13:15:00',2.38),('7643','2014-01-26','13:20:00',2.26),('7643','2014-01-26','13:25:00',2.41),('7643','2014-01-26','13:30:00',2.82),('7643','2014-01-26','13:35:00',2.35),('7643','2014-01-26','13:40:00',1.62),('7643','2014-01-26','13:45:00',1.06),('7643','2014-01-26','14:40:00',1.08),('7643','2014-01-26','14:45:00',1.07),('7643','2014-01-26','15:00:00',1.05),('7643','2014-01-26','15:05:00',1.06),('8348','2014-05-05','06:45:00',1.2),('8348','2014-05-05','06:50:00',1.41),('8348','2014-05-05','06:55:00',1.52),('8348','2014-05-05','07:00:00',1.62),('8348','2014-05-05','07:05:00',1.74),('8348','2014-05-05','07:10:00',1.87),('8348','2014-05-05','07:15:00',1.97),('8348','2014-05-05','07:20:00',2.08),('8348','2014-05-05','07:25:00',2.24),('8348','2014-05-05','07:30:00',2.4),('8348','2014-05-05','07:35:00',2.71),('8348','2014-05-05','07:40:00',3.08),('8348','2014-05-05','07:45:00',3.26),('8348','2014-05-05','07:50:00',3.44),('8348','2014-05-05','07:55:00',3.62),('8348','2014-05-05','08:00:00',3.77),('8348','2014-05-05','08:05:00',3.87),('8348','2014-05-05','08:10:00',4.06),('8348','2014-05-05','08:15:00',4.19),('8348','2014-05-05','08:20:00',4.35),('8348','2014-05-05','08:25:00',4.49),('8348','2014-05-05','08:30:00',4.69),('8348','2014-05-05','08:35:00',4.81),('8348','2014-05-05','08:40:00',4.91),('8348','2014-05-05','08:45:00',5.06),('8348','2014-05-05','08:50:00',5.17),('8348','2014-05-05','08:55:00',5.3),('8348','2014-05-05','09:00:00',5.43),('8348','2014-05-05','09:05:00',5.57),('8348','2014-05-05','09:10:00',5.68),('8348','2014-05-05','09:15:00',5.76),('8348','2014-05-05','09:20:00',5.81),('8348','2014-05-05','09:25:00',5.93),('8348','2014-05-05','09:30:00',6.02),('8348','2014-05-05','09:35:00',6.16),('8348','2014-05-05','09:40:00',6.22),('8348','2014-05-05','09:45:00',6.29),('8348','2014-05-05','09:50:00',6.4),('8348','2014-05-05','09:55:00',6.42),('8348','2014-05-05','10:00:00',6.56),('8348','2014-05-05','10:05:00',6.58),('8348','2014-05-05','10:10:00',6.68),('8348','2014-05-05','10:15:00',6.84),('8348','2014-05-05','10:20:00',6.85),('8348','2014-05-05','10:25:00',6.68),('8348','2014-05-05','10:30:00',6.94),('8348','2014-05-05','10:35:00',6.94),('8348','2014-05-05','10:40:00',7),('8348','2014-05-05','10:45:00',7.15),('8348','2014-05-05','10:50:00',7.17),('8348','2014-05-05','10:55:00',6.52),('8348','2014-05-05','11:00:00',7.48),('8348','2014-05-05','11:05:00',6.07),('8348','2014-05-05','11:10:00',2.84),('8348','2014-05-05','11:15:00',4.66),('8348','2014-05-05','11:20:00',3.78),('8348','2014-05-05','11:25:00',5.71),('8348','2014-05-05','11:30:00',7.78),('8348','2014-05-05','11:35:00',3.95),('8348','2014-05-05','11:40:00',2.6),('8348','2014-05-05','11:45:00',5.48),('8348','2014-05-05','11:50:00',8.33),('8348','2014-05-05','11:55:00',3.27),('8348','2014-05-05','12:00:00',4.97),('8348','2014-05-05','12:05:00',6.02),('8348','2014-05-05','12:10:00',8.07),('8348','2014-05-05','12:15:00',7.9),('8348','2014-05-05','12:20:00',7.78),('8348','2014-05-05','12:25:00',7.6),('8348','2014-05-05','12:30:00',7.59),('8348','2014-05-05','12:35:00',7.63),('8348','2014-05-05','12:40:00',7.67),('8348','2014-05-05','12:45:00',7.66),('8348','2014-05-05','12:50:00',7.65),('8348','2014-05-05','12:55:00',7.65),('8348','2014-05-05','13:00:00',7.6),('8348','2014-05-05','13:05:00',7.79),('8348','2014-05-05','13:10:00',8.09),('8348','2014-05-05','13:15:00',8.32),('8348','2014-05-05','13:20:00',8.54),('8348','2014-05-05','13:25:00',7.47),('8348','2014-05-05','13:30:00',4.87),('8348','2014-05-05','13:35:00',4.12),('8348','2014-05-05','13:40:00',2.92),('8348','2014-05-05','13:45:00',2.51),('8348','2014-05-05','13:50:00',2.61),('8348','2014-05-05','13:55:00',2.93),('8348','2014-05-05','14:00:00',4.14),('8348','2014-05-05','14:05:00',4.16),('8348','2014-05-05','14:10:00',2.82),('8348','2014-05-05','14:15:00',2.57),('8348','2014-05-05','14:20:00',2.46),('8348','2014-05-05','14:25:00',4.15),('8348','2014-05-05','14:30:00',7.69),('8348','2014-05-05','14:35:00',3.4),('8348','2014-05-05','14:40:00',2.65),('8348','2014-05-05','14:45:00',5.73),('8348','2014-05-05','14:50:00',2.26),('8348','2014-05-05','14:55:00',3.36),('8348','2014-05-05','15:00:00',3.6),('8348','2014-05-05','15:05:00',5.33),('8348','2014-05-05','15:10:00',2.5),('8348','2014-05-05','15:15:00',2.47),('8348','2014-05-05','15:20:00',2.52),('8348','2014-05-05','15:25:00',2.01),('8348','2014-05-05','15:30:00',3.73),('8348','2014-05-05','15:35:00',4.38),('8348','2014-05-05','15:40:00',2.55),('8348','2014-05-05','15:45:00',5.69),('8348','2014-05-05','15:50:00',5.78),('8348','2014-05-05','15:55:00',5.48),('8348','2014-05-05','16:00:00',5.08),('8348','2014-05-05','16:05:00',4.8),('8348','2014-05-05','16:10:00',4.89),('8348','2014-05-05','16:15:00',4.74),('8348','2014-05-05','16:20:00',4.63),('8348','2014-05-05','16:25:00',4.36),('8348','2014-05-05','16:30:00',4.13),('8348','2014-05-05','16:35:00',3.99),('8348','2014-05-05','16:40:00',3.84),('8348','2014-05-05','16:45:00',3.65),('8348','2014-05-05','16:50:00',3.49),('8348','2014-05-05','16:55:00',3.36),('8348','2014-05-05','17:00:00',3.15),('8348','2014-05-05','17:05:00',3),('8348','2014-05-05','17:10:00',2.87),('8348','2014-05-05','17:15:00',2.67),('8348','2014-05-05','17:20:00',2.5),('8348','2014-05-05','17:25:00',2.34),('8348','2014-05-05','17:30:00',2.18),('8348','2014-05-05','17:35:00',2.04),('8348','2014-05-05','17:40:00',1.88),('8348','2014-05-05','17:45:00',1.72),('8348','2014-05-05','17:50:00',1.56),('8348','2014-05-05','17:55:00',1.39),('8348','2014-05-05','18:00:00',1.23),('8348','2014-05-05','18:05:00',1.08),('8348','2014-04-26','07:00:00',1.02),('8348','2014-04-26','07:05:00',1.09),('8348','2014-04-26','07:10:00',1.18),('8348','2014-04-26','07:15:00',1.22),('8348','2014-04-26','07:20:00',1.27),('8348','2014-04-26','07:25:00',1.31),('8348','2014-04-26','07:30:00',1.17),('8348','2014-04-26','07:35:00',1.26),('8348','2014-04-26','07:40:00',1.4),('8348','2014-04-26','07:45:00',1.52),('8348','2014-04-26','07:50:00',1.63),('8348','2014-04-26','07:55:00',1.58),('8348','2014-04-26','08:00:00',1.63),('8348','2014-04-26','08:05:00',1.83),('8348','2014-04-26','08:10:00',1.58),('8348','2014-04-26','08:15:00',1.38),('8348','2014-04-26','08:20:00',1.41),('8348','2014-04-26','08:25:00',1.42),('8348','2014-04-26','08:30:00',1.42),('8348','2014-04-26','08:35:00',1.57),('8348','2014-04-26','08:40:00',1.64),('8348','2014-04-26','08:45:00',1.44),('8348','2014-04-26','08:50:00',1.73),('8348','2014-04-26','08:55:00',2.49),('8348','2014-04-26','09:00:00',2.58),('8348','2014-04-26','09:05:00',2.35),('8348','2014-04-26','09:10:00',2.3),('8348','2014-04-26','09:15:00',2.33),('8348','2014-04-26','09:20:00',2.72),('8348','2014-04-26','09:25:00',2.8),('8348','2014-04-26','09:30:00',3.56),('8348','2014-04-26','09:35:00',3.7),('8348','2014-04-26','09:40:00',3.15),('8348','2014-04-26','09:45:00',3.4),('8348','2014-04-26','09:50:00',4.1),('8348','2014-04-26','09:55:00',5.74),('8348','2014-04-26','10:00:00',6.15),('8348','2014-04-26','10:05:00',5.77),('8348','2014-04-26','10:10:00',5.58),('8348','2014-04-26','10:15:00',5.49),('8348','2014-04-26','10:20:00',4.57),('8348','2014-04-26','10:25:00',5.17),('8348','2014-04-26','10:30:00',5.16),('8348','2014-04-26','10:35:00',5.13),('8348','2014-04-26','10:40:00',4.87),('8348','2014-04-26','10:45:00',5.34),('8348','2014-04-26','10:50:00',5.42),('8348','2014-04-26','10:55:00',4.95),('8348','2014-04-26','11:00:00',5.24),('8348','2014-04-26','11:05:00',5.21),('8348','2014-04-26','11:10:00',5.53),('8348','2014-04-26','11:15:00',5.08),('8348','2014-04-26','11:20:00',4.69),('8348','2014-04-26','11:25:00',3.69),('8348','2014-04-26','11:30:00',4.13),('8348','2014-04-26','11:35:00',5.81),('8348','2014-04-26','11:40:00',6.18),('8348','2014-04-26','11:45:00',5.45),('8348','2014-04-26','11:50:00',7.16),('8348','2014-04-26','11:55:00',7.4),('8348','2014-04-26','12:00:00',6.94),('8348','2014-04-26','12:05:00',5.01),('8348','2014-04-26','12:10:00',5.94),('8348','2014-04-26','12:15:00',7.65),('8348','2014-04-26','12:20:00',7.95),('8348','2014-04-26','12:25:00',4.81),('8348','2014-04-26','12:30:00',3.03),('8348','2014-04-26','12:35:00',3.92),('8348','2014-04-26','12:40:00',8.01),('8348','2014-04-26','12:45:00',7.44),('8348','2014-04-26','12:50:00',7.49),('8348','2014-04-26','12:55:00',7.83),('8348','2014-04-26','13:00:00',4.81),('8348','2014-04-26','13:05:00',1.41),('8348','2014-04-26','13:10:00',4.82),('8348','2014-04-26','13:15:00',2.03),('8348','2014-04-26','13:20:00',1.14),('8348','2014-04-26','13:25:00',1.75),('8348','2014-04-26','13:30:00',1.78),('8348','2014-04-26','13:35:00',2.82),('8348','2014-04-26','13:40:00',3.73),('8348','2014-04-26','13:45:00',1.42),('8348','2014-04-26','16:40:00',1.2),('8348','2014-04-26','16:45:00',1.54),('8348','2014-04-26','16:50:00',1.61),('8348','2014-04-26','16:55:00',1.47),('8348','2014-04-26','17:30:00',1.09),('8348','2014-04-26','17:35:00',1.34),('8348','2014-04-26','17:40:00',1.76),('8348','2014-04-26','17:45:00',1.99),('8348','2014-04-26','17:50:00',1.47),('8348','2014-04-25','06:45:00',1.04),('8348','2014-04-25','06:50:00',1.25),('8348','2014-04-25','06:55:00',1.58),('8348','2014-04-25','07:00:00',1.72),('8348','2014-04-25','07:05:00',1.69),('8348','2014-04-25','07:10:00',1.75),('8348','2014-04-25','07:15:00',1.7),('8348','2014-04-25','07:20:00',1.83),('8348','2014-04-25','07:25:00',1.94),('8348','2014-04-25','07:30:00',2.03),('8348','2014-04-25','07:35:00',2.15),('8348','2014-04-25','07:40:00',2.27),('8348','2014-04-25','07:45:00',2.44),('8348','2014-04-25','07:50:00',2.79),('8348','2014-04-25','07:55:00',3.12),('8348','2014-04-25','08:00:00',3.5),('8348','2014-04-25','08:05:00',2.83),('8348','2014-04-25','08:10:00',2.73),('8348','2014-04-25','08:15:00',2.25),('8348','2014-04-25','08:20:00',1.61),('8348','2014-04-25','08:25:00',2.05),('8348','2014-04-25','08:30:00',2.06),('8348','2014-04-25','08:35:00',2.09),('8348','2014-04-25','08:40:00',1.64),('8348','2014-04-25','08:45:00',1.66),('8348','2014-04-25','08:50:00',1.64),('8348','2014-04-25','08:55:00',1.78),('8348','2014-04-25','09:00:00',2.15),('8348','2014-04-25','09:05:00',2.08),('8348','2014-04-25','09:10:00',2.12),('8348','2014-04-25','09:15:00',2.16),('8348','2014-04-25','09:20:00',2.33),('8348','2014-04-25','09:25:00',2.51),('8348','2014-04-25','09:30:00',3.58),('8348','2014-04-25','09:35:00',5.16),('8348','2014-04-25','09:40:00',4.93),('8348','2014-04-25','09:45:00',5.62),('8348','2014-04-25','09:50:00',4.58),('8348','2014-04-25','09:55:00',4.13),('8348','2014-04-25','10:00:00',4.73),('8348','2014-04-25','10:05:00',2.53),('8348','2014-04-25','10:10:00',2.23),('8348','2014-04-25','10:15:00',5.66),('8348','2014-04-25','10:20:00',6.67),('8348','2014-04-25','10:25:00',6.66),('8348','2014-04-25','10:30:00',4.79),('8348','2014-04-25','10:35:00',4.79),('8348','2014-04-25','10:40:00',6.46),('8348','2014-04-25','10:45:00',3.82),('8348','2014-04-25','10:50:00',2.67),('8348','2014-04-25','10:55:00',3.37),('8348','2014-04-25','11:00:00',3.72),('8348','2014-04-25','11:05:00',5.4),('8348','2014-04-25','11:10:00',5.61),('8348','2014-04-25','11:15:00',6.27),('8348','2014-04-25','11:20:00',4.33),('8348','2014-04-25','11:25:00',2.28),('8348','2014-04-25','11:30:00',6.2),('8348','2014-04-25','11:35:00',7.78),('8348','2014-04-25','11:40:00',6.53),('8348','2014-04-25','11:45:00',7.87),('8348','2014-04-25','11:50:00',2.49),('8348','2014-04-25','11:55:00',2.54),('8348','2014-04-25','12:00:00',5.93),('8348','2014-04-25','12:05:00',2.47),('8348','2014-04-25','12:10:00',5.68),('8348','2014-04-25','12:15:00',2.12),('8348','2014-04-25','12:20:00',2),('8348','2014-04-25','12:25:00',2.34),('8348','2014-04-25','12:30:00',2.63),('8348','2014-04-25','12:35:00',1.98),('8348','2014-04-25','12:40:00',4.97),('8348','2014-04-25','12:45:00',2.44),('8348','2014-04-25','12:50:00',2.31),('8348','2014-04-25','12:55:00',4.3),('8348','2014-04-25','13:00:00',2.54),('8348','2014-04-25','13:05:00',2.7),('8348','2014-04-25','13:10:00',2.27),('8348','2014-04-25','13:15:00',3.3),('8348','2014-04-25','13:20:00',5.9),('8348','2014-04-25','13:25:00',4.6),('8348','2014-04-25','13:30:00',6.82),('8348','2014-04-25','13:35:00',5.89),('8348','2014-04-25','13:40:00',7.12),('8348','2014-04-25','13:45:00',7.03),('8348','2014-04-25','13:50:00',7),('8348','2014-04-25','13:55:00',6.87),('8348','2014-04-25','14:00:00',6.82),('8348','2014-04-25','14:05:00',6.73),('8348','2014-04-25','14:10:00',6.66),('8348','2014-04-25','14:15:00',6.67),('8348','2014-04-25','14:20:00',6.38),('8348','2014-04-25','14:25:00',6.39),('8348','2014-04-25','14:30:00',6.17),('8348','2014-04-25','14:35:00',6.26),('8348','2014-04-25','14:40:00',6.27),('8348','2014-04-25','14:45:00',6.06),('8348','2014-04-25','14:50:00',5.97),('8348','2014-04-25','14:55:00',5.9),('8348','2014-04-25','15:00:00',5.85),('8348','2014-04-25','15:05:00',5.63),('8348','2014-04-25','15:10:00',5.53),('8348','2014-04-25','15:15:00',5.27),('8348','2014-04-25','15:20:00',4.85),('8348','2014-04-25','15:25:00',5.01),('8348','2014-04-25','15:30:00',5.19),('8348','2014-04-25','15:35:00',5.15),('8348','2014-04-25','15:40:00',5.2),('8348','2014-04-25','15:45:00',5.02),('8348','2014-04-25','15:50:00',4.65),('8348','2014-04-25','15:55:00',3.98),('8348','2014-04-25','16:00:00',3.78),('8348','2014-04-25','16:05:00',4.2),('8348','2014-04-25','16:10:00',3.71),('8348','2014-04-25','16:15:00',3.7),('8348','2014-04-25','16:20:00',2.73),('8348','2014-04-25','16:25:00',2.02),('8348','2014-04-25','16:30:00',1.97),('8348','2014-04-25','16:35:00',2.06),('8348','2014-04-25','16:40:00',2.06),('8348','2014-04-25','16:45:00',1.74),('8348','2014-04-25','16:50:00',1.56),('8348','2014-04-25','16:55:00',1.46),('8348','2014-04-25','17:00:00',1.39),('8348','2014-04-25','17:05:00',1.4),('8348','2014-04-25','17:10:00',1.42),('8348','2014-04-25','17:15:00',1.18),('8348','2014-04-25','17:20:00',1.17),('8348','2014-04-25','17:25:00',1.2),('8348','2014-04-25','17:30:00',1.13),('8348','2014-04-25','17:35:00',1.08),('8348','2014-04-25','17:40:00',1),('8348','2014-04-25','18:10:00',1.05),('8348','2014-04-24','06:45:00',1.01),('8348','2014-04-24','06:50:00',1.1),('8348','2014-04-24','06:55:00',1.19),('8348','2014-04-24','07:00:00',1.45),('8348','2014-04-24','07:05:00',1.5),('8348','2014-04-24','07:10:00',1.58),('8348','2014-04-24','07:15:00',1.67),('8348','2014-04-24','07:20:00',1.77),('8348','2014-04-24','07:25:00',1.88),('8348','2014-04-24','07:30:00',1.96),('8348','2014-04-24','07:35:00',2.1),('8348','2014-04-24','07:40:00',2.25),('8348','2014-04-24','07:45:00',2.39),('8348','2014-04-24','07:50:00',2.73),('8348','2014-04-24','07:55:00',3),('8348','2014-04-24','08:00:00',3.15),('8348','2014-04-24','08:05:00',3.26),('8348','2014-04-24','08:10:00',3.45),('8348','2014-04-24','08:15:00',3.6),('8348','2014-04-24','08:20:00',3.72),('8348','2014-04-24','08:25:00',3.87),('8348','2014-04-24','08:30:00',3.99),('8348','2014-04-24','08:35:00',4.1),('8348','2014-04-24','08:40:00',4.26),('8348','2014-04-24','08:45:00',4.37),('8348','2014-04-24','08:50:00',4.49),('8348','2014-04-24','08:55:00',4.58),('8348','2014-04-24','09:00:00',4.7),('8348','2014-04-24','09:05:00',4.84),('8348','2014-04-24','09:10:00',4.96),('8348','2014-04-24','09:15:00',5.04),('8348','2014-04-24','09:20:00',5.08),('8348','2014-04-24','09:25:00',5.17),('8348','2014-04-24','09:30:00',5.29),('8348','2014-04-24','09:35:00',5.36),('8348','2014-04-24','09:40:00',5.46),('8348','2014-04-24','09:45:00',5.55),('8348','2014-04-24','09:50:00',5.63),('8348','2014-04-24','09:55:00',5.8),('8348','2014-04-24','10:00:00',5.87),('8348','2014-04-24','10:05:00',5.86),('8348','2014-04-24','10:10:00',5.97),('8348','2014-04-24','10:15:00',6.03),('8348','2014-04-24','10:20:00',6.09),('8348','2014-04-24','10:25:00',6.18),('8348','2014-04-24','10:30:00',6.25),('8348','2014-04-24','10:35:00',6.25),('8348','2014-04-24','10:40:00',5.73),('8348','2014-04-24','10:45:00',5.73),('8348','2014-04-24','10:50:00',6.49),('8348','2014-04-24','10:55:00',6.47),('8348','2014-04-24','11:00:00',6.54),('8348','2014-04-24','11:05:00',6.67),('8348','2014-04-24','11:10:00',6.76),('8348','2014-04-24','11:15:00',6.8),('8348','2014-04-24','11:20:00',6.78),('8348','2014-04-24','11:25:00',6.82),('8348','2014-04-24','11:30:00',6.9),('8348','2014-04-24','11:35:00',7.04),('8348','2014-04-24','11:40:00',6.57),('8348','2014-04-24','11:45:00',6.84),('8348','2014-04-24','11:50:00',7.03),('8348','2014-04-24','11:55:00',6.98),('8348','2014-04-24','12:00:00',7.11),('8348','2014-04-24','12:05:00',7.1),('8348','2014-04-24','12:10:00',7.2),('8348','2014-04-24','12:15:00',7.4),('8348','2014-04-24','12:20:00',7.32),('8348','2014-04-24','12:25:00',7.24),('8348','2014-04-24','12:30:00',7.36),('8348','2014-04-24','12:35:00',3.66),('8348','2014-04-24','12:40:00',3.16),('8348','2014-04-24','12:45:00',4.55),('8348','2014-04-24','12:50:00',8.36),('8348','2014-04-24','12:55:00',7.44),('8348','2014-04-24','13:00:00',3.77),('8348','2014-04-24','13:05:00',7.53),('8348','2014-04-24','13:10:00',8.23),('8348','2014-04-24','13:15:00',5.45),('8348','2014-04-24','13:20:00',6.57),('8348','2014-04-24','13:25:00',6.7),('8348','2014-04-24','13:30:00',7.16),('8348','2014-04-24','13:35:00',7.55),('8348','2014-04-24','13:40:00',5.85),('8348','2014-04-24','13:45:00',4.46),('8348','2014-04-24','13:50:00',3.55),('8348','2014-04-24','13:55:00',8.13),('8348','2014-04-24','14:00:00',8.2),('8348','2014-04-24','14:05:00',8.08),('8348','2014-04-24','14:10:00',8.09),('8348','2014-04-24','14:15:00',7.76),('8348','2014-04-24','14:20:00',4.58),('8348','2014-04-24','14:25:00',3.97),('8348','2014-04-24','14:30:00',4.97),('8348','2014-04-24','14:35:00',4.64),('8348','2014-04-24','14:40:00',4.09),('8348','2014-04-24','14:45:00',3.86),('8348','2014-04-24','14:50:00',4.24),('8348','2014-04-24','14:55:00',4.81),('8348','2014-04-24','15:00:00',7.41),('8348','2014-04-24','15:05:00',6.74),('8348','2014-04-24','15:10:00',5.49),('8348','2014-04-24','15:15:00',6.17),('8348','2014-04-24','15:20:00',5.65),('8348','2014-04-24','15:25:00',5.99),('8348','2014-04-24','15:30:00',5.29),('8348','2014-04-24','15:35:00',3.4),('8348','2014-04-24','15:40:00',3.8),('8348','2014-04-24','15:45:00',3.29),('8348','2014-04-24','15:50:00',2.79),('8348','2014-04-24','15:55:00',2.69),('8348','2014-04-24','16:00:00',2.6),('8348','2014-04-24','16:05:00',2.36),('8348','2014-04-24','16:10:00',2.24),('8348','2014-04-24','16:15:00',2),('8348','2014-04-24','16:20:00',1.98),('8348','2014-04-24','16:25:00',1.95),('8348','2014-04-24','16:30:00',1.89),('8348','2014-04-24','16:35:00',1.76),('8348','2014-04-24','16:40:00',1.5),('8348','2014-04-24','16:45:00',1.02),('8348','2014-04-23','09:40:00',1.06),('8348','2014-04-23','09:45:00',1.08),('8348','2014-04-23','10:15:00',1.05),('8348','2014-04-23','10:20:00',1.01),('8348','2014-04-23','10:35:00',1.07),('8348','2014-04-23','10:40:00',1.14),('8348','2014-04-23','10:45:00',1.23),('8348','2014-04-23','10:50:00',1.01),('8348','2014-04-23','11:50:00',1.01),('8348','2014-04-23','11:55:00',1.09),('8348','2014-04-23','12:00:00',1.2),('8348','2014-04-23','12:05:00',1.41),('8348','2014-04-23','12:10:00',1.74),('8348','2014-04-23','12:15:00',2.01),('8348','2014-04-23','12:20:00',2.15),('8348','2014-04-23','12:25:00',2.28),('8348','2014-04-23','12:30:00',2.47),('8348','2014-04-23','12:35:00',2.58),('8348','2014-04-23','12:40:00',2.76),('8348','2014-04-23','12:45:00',2.86),('8348','2014-04-23','12:50:00',2.86),('8348','2014-04-23','12:55:00',2.86),('8348','2014-04-23','13:00:00',2.69),('8348','2014-04-23','13:05:00',2.7),('8348','2014-04-23','13:10:00',2.6),('8348','2014-04-23','13:15:00',2.23),('8348','2014-04-23','13:20:00',1.93),('8348','2014-04-23','13:25:00',1.75),('8348','2014-04-23','13:30:00',1.65),('8348','2014-04-23','13:35:00',1.57),('8348','2014-04-23','13:40:00',1.62),('8348','2014-04-23','13:45:00',1.87),('8348','2014-04-23','13:50:00',2.27),('8348','2014-04-23','13:55:00',2.63),('8348','2014-04-23','14:00:00',2.96),('8348','2014-04-23','14:05:00',3.06),('8348','2014-04-23','14:10:00',3.01),('8348','2014-04-23','14:15:00',3.02),('8348','2014-04-23','14:20:00',2.58),('8348','2014-04-23','14:25:00',2.42),('8348','2014-04-23','14:30:00',2.38),('8348','2014-04-23','14:35:00',2.26),('8348','2014-04-23','14:40:00',2.23),('8348','2014-04-23','14:45:00',2.6),('8348','2014-04-23','14:50:00',1.88),('8348','2014-04-23','14:55:00',1.74),('8348','2014-04-23','15:00:00',1.48),('8348','2014-04-23','15:05:00',1.41),('8348','2014-04-23','15:10:00',1.24),('8348','2014-04-23','15:15:00',1.08),('8348','2014-04-22','06:45:00',1.06),('8348','2014-04-22','06:50:00',1.16),('8348','2014-04-22','06:55:00',1.25),('8348','2014-04-22','07:00:00',1.34),('8348','2014-04-22','07:05:00',1.51),('8348','2014-04-22','07:10:00',1.65),('8348','2014-04-22','07:15:00',1.75),('8348','2014-04-22','07:20:00',1.85),('8348','2014-04-22','07:25:00',1.96),('8348','2014-04-22','07:30:00',2.1),('8348','2014-04-22','07:35:00',2.2),('8348','2014-04-22','07:40:00',2.37),('8348','2014-04-22','07:45:00',2.52),('8348','2014-04-22','07:50:00',2.72),('8348','2014-04-22','07:55:00',2.98),('8348','2014-04-22','08:00:00',3.1),('8348','2014-04-22','08:05:00',3.39),('8348','2014-04-22','08:10:00',3.09),('8348','2014-04-22','08:15:00',2.94),('8348','2014-04-22','08:20:00',3.69),('8348','2014-04-22','08:25:00',4.09),('8348','2014-04-22','08:30:00',3.1),('8348','2014-04-22','08:35:00',4.18),('8348','2014-04-22','08:40:00',4.33),('8348','2014-04-22','08:45:00',4.76),('8348','2014-04-22','08:50:00',3.91),('8348','2014-04-22','08:55:00',2.48),('8348','2014-04-22','09:00:00',2.35),('8348','2014-04-22','09:05:00',2.53),('8348','2014-04-22','09:10:00',3.32),('8348','2014-04-22','09:15:00',3.35),('8348','2014-04-22','09:20:00',5.01),('8348','2014-04-22','09:25:00',3.77),('8348','2014-04-22','09:30:00',5.68),('8348','2014-04-22','09:35:00',5.94),('8348','2014-04-22','09:40:00',5.53),('8348','2014-04-22','09:45:00',6.17),('8348','2014-04-22','09:50:00',6.56),('8348','2014-04-22','09:55:00',5),('8348','2014-04-22','10:00:00',3.44),('8348','2014-04-22','10:05:00',3.87),('8348','2014-04-22','10:10:00',2.94),('8348','2014-04-22','10:15:00',2.51),('8348','2014-04-22','10:20:00',2.19),('8348','2014-04-22','10:25:00',2.14),('8348','2014-04-22','10:30:00',1.92),('8348','2014-04-22','10:35:00',2.02),('8348','2014-04-22','10:40:00',1.87),('8348','2014-04-22','10:45:00',1.6),('8348','2014-04-22','10:50:00',1.66),('8348','2014-04-22','10:55:00',1.59),('8348','2014-04-22','11:00:00',1.75),('8348','2014-04-22','11:05:00',2.14),('8348','2014-04-22','11:10:00',2.16),('8348','2014-04-22','11:15:00',2.17),('8348','2014-04-22','11:20:00',2.26),('8348','2014-04-22','11:25:00',2.41),('8348','2014-04-22','11:30:00',2.79),('8348','2014-04-22','11:35:00',2.41),('8348','2014-04-22','11:40:00',1.83),('8348','2014-04-22','11:45:00',1.54),('8348','2014-04-22','11:50:00',1.33),('8348','2014-04-22','11:55:00',1.28),('8348','2014-04-22','12:00:00',1.29),('8348','2014-04-22','12:05:00',1.42),('8348','2014-04-22','12:10:00',1.68),('8348','2014-04-22','12:15:00',2.54),('8348','2014-04-22','12:20:00',3.91),('8348','2014-04-22','12:25:00',4.48),('8348','2014-04-22','12:30:00',4.95),('8348','2014-04-22','12:35:00',4.62),('8348','2014-04-22','12:40:00',5.62),('8348','2014-04-22','12:45:00',5.71),('8348','2014-04-22','12:50:00',4.79),('8348','2014-04-22','12:55:00',2.76),('8348','2014-04-22','13:00:00',2.43),('8348','2014-04-22','13:05:00',3.09),('8348','2014-04-22','13:10:00',6.36),('8348','2014-04-22','13:15:00',5.83),('8348','2014-04-22','13:20:00',6.73),('8348','2014-04-22','13:25:00',4.73),('8348','2014-04-22','13:30:00',3.58),('8348','2014-04-22','13:35:00',4.19),('8348','2014-04-22','13:40:00',5.88),('8348','2014-04-22','13:45:00',7.07),('8348','2014-04-22','13:50:00',6.22),('8348','2014-04-22','13:55:00',5.07),('8348','2014-04-22','14:00:00',2.39),('8348','2014-04-22','14:05:00',2.27),('8348','2014-04-22','14:10:00',2.13),('8348','2014-04-22','14:15:00',2.11),('8348','2014-04-22','14:20:00',2.35),('8348','2014-04-22','14:25:00',2.56),('8348','2014-04-22','14:30:00',3.17),('8348','2014-04-22','14:35:00',4.46),('8348','2014-04-22','14:40:00',3.93),('8348','2014-04-22','14:45:00',3.49),('8348','2014-04-22','14:50:00',4.02),('8348','2014-04-22','14:55:00',3.3),('8348','2014-04-22','15:00:00',3.96),('8348','2014-04-22','15:05:00',2.72),('8348','2014-04-22','15:10:00',2.61),('8348','2014-04-22','15:15:00',2.46),('8348','2014-04-22','15:20:00',2.9),('8348','2014-04-22','15:25:00',2.79),('8348','2014-04-22','15:30:00',2.34),('8348','2014-04-22','15:35:00',2.64),('8348','2014-04-22','15:40:00',3.38),('8348','2014-04-22','15:45:00',3.04),('8348','2014-04-22','15:50:00',2.35),('8348','2014-04-22','15:55:00',2.06),('8348','2014-04-22','16:00:00',2.3),('8348','2014-04-22','16:05:00',2.66),('8348','2014-04-22','16:10:00',2.04),('8348','2014-04-22','16:15:00',1.82),('8348','2014-04-22','16:20:00',1.38),('8348','2014-04-22','16:25:00',1.17),('8348','2014-04-22','16:30:00',1.12),('8348','2014-04-22','16:35:00',1.26),('8348','2014-04-22','16:40:00',1.28),('8348','2014-04-22','16:45:00',1.11),('8348','2014-04-22','16:50:00',1.02),('8348','2014-04-21','07:25:00',1.08),('8348','2014-04-21','07:30:00',1.49),('8348','2014-04-21','07:35:00',1.49),('8348','2014-04-21','07:40:00',1.64),('8348','2014-04-21','07:45:00',1.6),('8348','2014-04-21','07:50:00',1.54),('8348','2014-04-21','07:55:00',1.52),('8348','2014-04-21','08:00:00',1.73),('8348','2014-04-21','08:05:00',1.73),('8348','2014-04-21','08:10:00',1.72),('8348','2014-04-21','08:15:00',1.76),('8348','2014-04-21','08:20:00',2.75),('8348','2014-04-21','08:25:00',2.52),('8348','2014-04-21','08:35:00',1),('8348','2014-04-21','08:40:00',1.52),('8348','2014-04-21','08:45:00',1.67),('8348','2014-04-21','08:50:00',1.72),('8348','2014-04-21','08:55:00',1.8),('8348','2014-04-21','09:00:00',2.31),('8348','2014-04-21','09:05:00',5.28),('8348','2014-04-21','09:10:00',5.04),('8348','2014-04-21','09:15:00',5.51),('8348','2014-04-21','09:20:00',5.27),('8348','2014-04-21','09:25:00',5.31),('8348','2014-04-21','09:30:00',5.31),('8348','2014-04-21','09:35:00',5.37),('8348','2014-04-21','09:40:00',5.42),('8348','2014-04-21','09:45:00',5.5),('8348','2014-04-21','09:50:00',5.57),('8348','2014-04-21','09:55:00',5.66),('8348','2014-04-21','10:00:00',5.73),('8348','2014-04-21','10:05:00',5.8),('8348','2014-04-21','10:10:00',5.87),('8348','2014-04-21','10:15:00',5.93),('8348','2014-04-21','10:20:00',5.99),('8348','2014-04-21','10:25:00',6.1),('8348','2014-04-21','10:30:00',6.15),('8348','2014-04-21','10:35:00',6.22),('8348','2014-04-21','10:40:00',6.34),('8348','2014-04-21','10:45:00',6.37),('8348','2014-04-21','10:50:00',6.4),('8348','2014-04-21','10:55:00',6.52),('8348','2014-04-21','11:00:00',6.59),('8348','2014-04-21','11:05:00',6.67),('8348','2014-04-21','11:10:00',6.68),('8348','2014-04-21','11:15:00',6.73),('8348','2014-04-21','11:20:00',6.82),('8348','2014-04-21','11:25:00',6.91),('8348','2014-04-21','11:30:00',6.95),('8348','2014-04-21','11:35:00',6.93),('8348','2014-04-21','11:40:00',6.99),('8348','2014-04-21','11:45:00',7.02),('8348','2014-04-21','11:50:00',7.09),('8348','2014-04-21','11:55:00',7.11),('8348','2014-04-21','12:00:00',7.11),('8348','2014-04-21','12:05:00',7.19),('8348','2014-04-21','12:10:00',7.17),('8348','2014-04-21','12:15:00',7.17),('8348','2014-04-21','12:20:00',7.21),('8348','2014-04-21','12:25:00',7.2),('8348','2014-04-21','12:30:00',7.18),('8348','2014-04-21','12:35:00',7.15),('8348','2014-04-21','12:40:00',7.21),('8348','2014-04-21','12:45:00',7.34),('8348','2014-04-21','12:50:00',7.37),('8348','2014-04-21','12:55:00',7.39),('8348','2014-04-21','13:00:00',7.36),('8348','2014-04-21','13:05:00',7.36),('8348','2014-04-21','13:10:00',7.36),('8348','2014-04-21','13:15:00',7.3),('8348','2014-04-21','13:20:00',7.22),('8348','2014-04-21','13:25:00',7.22),('8348','2014-04-21','13:30:00',7.18),('8348','2014-04-21','13:35:00',7.12),('8348','2014-04-21','13:40:00',7.11),('8348','2014-04-21','13:45:00',7.05),('8348','2014-04-21','13:50:00',6.99),('8348','2014-04-21','13:55:00',6.93),('8348','2014-04-21','14:00:00',6.87),('8348','2014-04-21','14:05:00',6.86),('8348','2014-04-21','14:10:00',6.78),('8348','2014-04-21','14:15:00',6.67),('8348','2014-04-21','14:20:00',6.64),('8348','2014-04-21','14:25:00',6.57),('8348','2014-04-21','14:30:00',6.46),('8348','2014-04-21','14:35:00',6.38),('8348','2014-04-21','14:40:00',6.29),('8348','2014-04-21','14:45:00',6.18),('8348','2014-04-21','14:50:00',6.13),('8348','2014-04-21','14:55:00',6.06),('8348','2014-04-21','15:00:00',5.99),('8348','2014-04-21','15:05:00',5.94),('8348','2014-04-21','15:10:00',5.83),('8348','2014-04-21','15:15:00',5.12),('8348','2014-04-21','15:20:00',5.68),('8348','2014-04-21','15:25:00',5.19),('8348','2014-04-21','15:30:00',4.88),('8348','2014-04-21','15:35:00',5.33),('8348','2014-04-21','15:40:00',5.19),('8348','2014-04-21','15:45:00',5.08),('8348','2014-04-21','15:50:00',4.95),('8348','2014-04-21','15:55:00',4.8),('8348','2014-04-21','16:00:00',4.65),('8348','2014-04-21','16:05:00',4.54),('8348','2014-04-21','16:10:00',4.42),('8348','2014-04-21','16:15:00',4.26),('8348','2014-04-21','16:20:00',4.11),('8348','2014-04-21','16:25:00',4),('8348','2014-04-21','16:30:00',3.89),('8348','2014-04-21','16:35:00',3.74),('8348','2014-04-21','16:40:00',3.43),('8348','2014-04-21','16:45:00',3.4),('8348','2014-04-21','16:50:00',3.22),('8348','2014-04-21','16:55:00',3.09),('8348','2014-04-21','17:00:00',2.9),('8348','2014-04-21','17:05:00',2.72),('8348','2014-04-21','17:10:00',2.55),('8348','2014-04-21','17:15:00',2.39),('8348','2014-04-21','17:20:00',2.23),('8348','2014-04-21','17:25:00',2.07),('8348','2014-04-21','17:30:00',1.89),('8348','2014-04-21','17:35:00',1.71),('8348','2014-04-21','17:40:00',1.55),('8348','2014-04-21','17:45:00',1.4),('8348','2014-04-21','17:50:00',1.28),('8348','2014-04-21','17:55:00',1.17),('8348','2014-04-21','18:00:00',1.09),('8348','2014-04-21','18:05:00',1.02),('8348','2014-04-20','06:45:00',1.05),('8348','2014-04-20','06:50:00',1.26),('8348','2014-04-20','06:55:00',1.42),('8348','2014-04-20','07:00:00',1.3),('8348','2014-04-20','07:05:00',1.37),('8348','2014-04-20','07:10:00',1.58),('8348','2014-04-20','07:15:00',1.77),('8348','2014-04-20','07:20:00',2.24),('8348','2014-04-20','07:25:00',3.08),('8348','2014-04-20','07:30:00',3.11),('8348','2014-04-20','07:35:00',2.95),('8348','2014-04-20','07:40:00',1.51),('8348','2014-04-20','07:45:00',2.49),('8348','2014-04-20','07:50:00',2.44),('8348','2014-04-20','07:55:00',2.12),('8348','2014-04-20','08:00:00',2.6),('8348','2014-04-20','08:05:00',1.89),('8348','2014-04-20','08:10:00',3.6),('8348','2014-04-20','08:15:00',4.03),('8348','2014-04-20','08:20:00',4.05),('8348','2014-04-20','08:25:00',4.74),('8348','2014-04-20','08:30:00',5.22),('8348','2014-04-20','08:35:00',5.25),('8348','2014-04-20','08:40:00',3.42),('8348','2014-04-20','08:45:00',2.41),('8348','2014-04-20','08:50:00',2.66),('8348','2014-04-20','08:55:00',3.19),('8348','2014-04-20','09:00:00',3.85),('8348','2014-04-20','09:05:00',4.83),('8348','2014-04-20','09:10:00',4.42),('8348','2014-04-20','09:15:00',4.9),('8348','2014-04-20','09:20:00',5.08),('8348','2014-04-20','09:25:00',4.65),('8348','2014-04-20','09:30:00',4.39),('8348','2014-04-20','09:35:00',4.66),('8348','2014-04-20','09:40:00',4.52),('8348','2014-04-20','09:45:00',4.62),('8348','2014-04-20','09:50:00',5.11),('8348','2014-04-20','09:55:00',4.98),('8348','2014-04-20','10:00:00',5.81),('8348','2014-04-20','10:05:00',5.87),('8348','2014-04-20','10:10:00',5.92),('8348','2014-04-20','10:15:00',6),('8348','2014-04-20','10:20:00',2.39),('8348','2014-04-20','10:25:00',7.38),('8348','2014-04-20','10:30:00',7.21),('8348','2014-04-20','10:35:00',6.69),('8348','2014-04-20','10:40:00',5.99),('8348','2014-04-20','10:45:00',3.51),('8348','2014-04-20','10:50:00',4.2),('8348','2014-04-20','10:55:00',2.39),('8348','2014-04-20','11:00:00',7.83),('8348','2014-04-20','11:05:00',7.52),('8348','2014-04-20','11:10:00',5.74),('8348','2014-04-20','11:15:00',3.87),('8348','2014-04-20','11:20:00',3.81),('8348','2014-04-20','11:25:00',6.28),('8348','2014-04-20','11:30:00',7.6),('8348','2014-04-20','11:35:00',7.38),('8348','2014-04-20','11:40:00',7.37),('8348','2014-04-20','11:45:00',7.45),('8348','2014-04-20','11:50:00',7.5),('8348','2014-04-20','11:55:00',7.51),('8348','2014-04-20','12:00:00',7.56),('8348','2014-04-20','12:05:00',7.61),('8348','2014-04-20','12:10:00',7.5),('8348','2014-04-20','12:15:00',7.83),('8348','2014-04-20','12:20:00',7.47),('8348','2014-04-20','12:25:00',7.45),('8348','2014-04-20','12:30:00',7.52),('8348','2014-04-20','12:35:00',7.55),('8348','2014-04-20','12:40:00',7.59),('8348','2014-04-20','12:45:00',7.55),('8348','2014-04-20','12:50:00',7.54),('8348','2014-04-20','12:55:00',7.48),('8348','2014-04-20','13:00:00',7.42),('8348','2014-04-20','13:05:00',7.42),('8348','2014-04-20','13:10:00',7.49),('8348','2014-04-20','13:15:00',7.82),('8348','2014-04-20','13:20:00',6.01),('8348','2014-04-20','13:25:00',5.6),('8348','2014-04-20','13:30:00',5.43),('8348','2014-04-20','13:35:00',4.48),('8348','2014-04-20','13:40:00',4.41),('8348','2014-04-20','13:45:00',4.82),('8348','2014-04-20','13:50:00',4.63),('8348','2014-04-20','13:55:00',5.18),('8348','2014-04-20','14:00:00',6.98),('8348','2014-04-20','14:05:00',6.35),('8348','2014-04-20','14:10:00',6.74),('8348','2014-04-20','14:15:00',6.86),('8348','2014-04-20','14:20:00',6.61),('8348','2014-04-20','14:25:00',6.67),('8348','2014-04-20','14:30:00',6.56),('8348','2014-04-20','14:35:00',6.46),('8348','2014-04-20','14:40:00',6.56),('8348','2014-04-20','14:45:00',5.51),('8348','2014-04-20','14:50:00',4.61),('8348','2014-04-20','14:55:00',6.38),('8348','2014-04-20','15:00:00',6.14),('8348','2014-04-20','15:05:00',6.02),('8348','2014-04-20','15:10:00',5.97),('8348','2014-04-20','15:15:00',5.91),('8348','2014-04-20','15:20:00',5.84),('8348','2014-04-20','15:25:00',4.89),('8348','2014-04-20','15:30:00',5.57),('8348','2014-04-20','15:35:00',5.38),('8348','2014-04-20','15:40:00',5.42),('8348','2014-04-20','15:45:00',4.73),('8348','2014-04-20','15:50:00',5.04),('8348','2014-04-20','15:55:00',5.12),('8348','2014-04-20','16:00:00',4.84),('8348','2014-04-20','16:05:00',4.64),('8348','2014-04-20','16:10:00',4.44),('8348','2014-04-20','16:15:00',4.26),('8348','2014-04-20','16:20:00',4.14),('8348','2014-04-20','16:25:00',3.98),('8348','2014-04-20','16:30:00',3.84),('8348','2014-04-20','16:35:00',3.68),('8348','2014-04-20','16:40:00',3.52),('8348','2014-04-20','16:45:00',3.31),('8348','2014-04-20','16:50:00',3.13),('8348','2014-04-20','16:55:00',3.03),('8348','2014-04-20','17:00:00',2.86),('8348','2014-04-20','17:05:00',2.71),('8348','2014-04-20','17:10:00',2.54),('8348','2014-04-20','17:15:00',2.26),('8348','2014-04-20','17:20:00',1.62),('8348','2014-04-20','17:25:00',1.22),('8348','2014-04-20','17:30:00',1.79),('8348','2014-04-20','17:35:00',1.83),('8348','2014-04-20','17:40:00',1.58),('8348','2013-11-21','09:40:00',1.11),('8348','2013-11-21','09:45:00',1.43),('8348','2013-11-21','09:50:00',1.15),('8348','2013-11-21','09:55:00',1.34),('8348','2013-11-21','10:00:00',1.05),('8348','2013-11-21','10:05:00',1.53),('8348','2013-11-21','10:10:00',1.67),('8348','2013-11-21','10:15:00',1.87),('8348','2013-11-21','10:20:00',1.74),('8348','2013-11-21','10:25:00',1.15),('8348','2013-11-21','10:30:00',1.86),('8348','2013-11-21','10:35:00',1.92),('8348','2013-11-21','10:40:00',2.11),('8348','2013-11-21','10:45:00',1.46),('8348','2013-11-21','11:15:00',1.12),('8348','2013-11-21','11:20:00',1.27),('8348','2013-11-21','11:25:00',1.72),('8348','2013-11-21','11:30:00',2.24),('8348','2013-11-21','11:35:00',1.49),('8348','2013-11-21','11:40:00',1.92),('8348','2013-11-21','11:45:00',2.06),('8348','2013-11-21','11:50:00',2.25),('8348','2013-11-21','11:55:00',2.32),('8348','2013-11-21','12:00:00',1.31),('8348','2013-11-21','12:05:00',2.17),('8348','2013-11-21','12:10:00',2.32),('8348','2013-11-21','12:15:00',2.32),('8348','2013-11-21','12:20:00',2.36),('8348','2013-11-21','12:25:00',2.43),('8348','2013-11-21','12:30:00',2.6),('8348','2013-11-21','12:35:00',2.67),('8348','2013-11-21','12:40:00',2.71),('8348','2013-11-21','12:45:00',2.63),('8348','2013-11-21','12:50:00',2.62),('8348','2013-11-21','12:55:00',2.75),('8348','2013-11-21','13:00:00',2.61),('8348','2013-11-21','13:05:00',2.26),('8348','2013-11-21','13:10:00',1.45),('8348','2013-11-21','13:15:00',2.54),('8348','2013-11-21','13:20:00',2.41),('8348','2013-11-21','13:25:00',1.85),('8348','2013-11-21','13:40:00',1.26),('8348','2013-11-21','13:45:00',2.17),('8348','2013-11-21','13:50:00',1.24),('8348','2013-11-21','13:55:00',2.19),('8348','2013-11-21','14:00:00',1.98),('8348','2013-11-21','14:25:00',1.31),('8348','2013-11-21','14:40:00',1.44),('8348','2013-11-21','14:45:00',1.37),('8348','2013-11-21','14:50:00',1.32),('8348','2013-11-21','15:00:00',1.09),('8348','2013-11-21','15:05:00',1.11),('8348','2013-11-21','15:10:00',1.04),('8348','2013-11-20','09:15:00',1.14),('8348','2013-11-20','09:20:00',1.22),('8348','2013-11-20','09:25:00',1.33),('8348','2013-11-20','09:30:00',1.4),('8348','2013-11-20','10:00:00',1.47),('8348','2013-11-20','10:15:00',1.49),('8348','2013-11-20','11:25:00',1.14),('8348','2013-11-20','11:30:00',1.07),('8348','2013-11-20','11:35:00',1.06),('8348','2013-11-20','11:40:00',1.16),('8348','2013-11-20','11:45:00',3.19),('8348','2013-11-20','11:50:00',2.59),('8348','2013-11-20','11:55:00',1.33),('8348','2013-11-20','12:20:00',2),('8348','2013-11-20','12:25:00',1.38),('8348','2013-11-20','12:45:00',1.02),('8348','2013-11-20','12:50:00',1.17),('8348','2013-11-20','12:55:00',1.72),('8348','2013-11-20','13:00:00',1.66),('8348','2013-11-20','13:05:00',1.43),('8348','2013-11-20','13:20:00',1.21),('8348','2013-11-20','13:25:00',1.06),('8348','2013-11-20','13:40:00',1.2),('8348','2013-11-20','13:45:00',1.37),('8348','2013-11-20','13:50:00',1.62),('8348','2013-11-20','13:55:00',1),('8348','2013-11-20','14:20:00',1.06),('8348','2013-11-20','14:25:00',1.1),('8348','2013-11-20','14:45:00',1.21),('8348','2013-11-20','15:05:00',1.3),('8348','2013-11-20','15:10:00',1.22),('8348','2013-11-20','15:15:00',1.01),('8348','2013-11-19','09:40:00',1.49),('8348','2013-11-19','09:45:00',1.45),('8348','2013-11-19','10:05:00',1.05),('8348','2013-11-19','10:50:00',1.26),('8348','2013-11-19','11:20:00',2.34),('8348','2013-11-19','11:25:00',1.77),('8348','2013-11-19','11:30:00',1.54),('8348','2013-11-19','11:35:00',2.19),('8348','2013-11-19','11:40:00',1.87),('8348','2013-11-19','11:45:00',2.15),('8348','2013-11-19','11:50:00',2.12),('8348','2013-11-19','11:55:00',2.05),('8348','2013-11-19','12:00:00',1.67),('8348','2013-11-19','12:05:00',2.17),('8348','2013-11-19','12:10:00',2.05),('8348','2013-11-19','12:15:00',2.12),('8348','2013-11-19','12:20:00',1.25),('8348','2013-11-19','12:30:00',1.19),('8348','2013-11-19','12:45:00',1.92),('8348','2013-11-19','12:50:00',1.92),('8348','2013-11-19','12:55:00',2.58),('8348','2013-11-19','13:00:00',1.1),('8348','2013-11-19','13:05:00',1.03),('8348','2013-11-19','13:15:00',1.81),('8348','2013-11-19','13:20:00',1.97),('8348','2013-11-19','15:25:00',1.12),('8348','2013-11-19','15:30:00',1.45),('8348','2013-11-19','15:35:00',1.05),('8348','2013-11-18','09:20:00',1.16),('8348','2013-11-18','09:25:00',1.23),('8348','2013-11-18','09:30:00',1.14),('8348','2013-11-18','09:35:00',1.5),('8348','2013-11-18','09:40:00',1.18),('8348','2013-11-18','09:45:00',1.08),('8348','2013-11-18','10:00:00',1.02),('8348','2013-11-18','10:05:00',1.16),('8348','2013-11-18','10:10:00',1.34),('8348','2013-11-18','10:15:00',1.43),('8348','2013-11-18','10:20:00',1.22),('8348','2013-11-18','10:25:00',1.12),('8348','2013-11-18','10:30:00',1.06),('8348','2013-11-18','10:35:00',1.04),('8348','2013-11-18','10:40:00',1.09),('8348','2013-11-18','10:45:00',1.13),('8348','2013-11-18','10:50:00',1.07),('8348','2013-11-18','11:35:00',1.01),('8348','2013-11-18','11:40:00',1.04),('8348','2013-11-18','11:45:00',1.07),('8348','2013-11-18','11:50:00',1.12),('8348','2013-11-18','11:55:00',1.19),('8348','2013-11-18','12:00:00',1.25),('8348','2013-11-18','12:05:00',1.31),('8348','2013-11-18','12:10:00',1.29),('8348','2013-11-18','12:15:00',1.34),('8348','2013-11-18','12:20:00',1.41),('8348','2013-11-18','12:25:00',1.47),('8348','2013-11-18','12:30:00',1.32),('8348','2013-11-18','12:35:00',1.17),('8348','2013-11-18','12:40:00',1),('8348','2013-11-18','13:40:00',1.04),('8348','2014-04-19','06:30:00',1.03),('8348','2014-04-19','06:35:00',1.19),('8348','2014-04-19','06:40:00',1.37),('8348','2014-04-19','06:45:00',1.04),('8348','2014-04-19','06:50:00',1.37),('8348','2014-04-19','06:55:00',2.54),('8348','2014-04-19','07:00:00',2.07),('8348','2014-04-19','07:05:00',1.79),('8348','2014-04-19','07:10:00',2.24),('8348','2014-04-19','07:15:00',1.85),('8348','2014-04-19','07:20:00',2.07),('8348','2014-04-19','07:25:00',2.49),('8348','2014-04-19','07:30:00',3.05),('8348','2014-04-19','07:35:00',3.27),('8348','2014-04-19','07:40:00',2.99),('8348','2014-04-19','07:45:00',3.02),('8348','2014-04-19','07:50:00',2.51),('8348','2014-04-19','07:55:00',1.69),('8348','2014-04-19','08:00:00',1.06),('8348','2014-04-19','08:10:00',1.15),('8348','2014-04-19','08:15:00',1.49),('8348','2014-04-19','08:20:00',1.88),('8348','2014-04-19','08:25:00',2.54),('8348','2014-04-19','08:30:00',3.68),('8348','2014-04-19','08:35:00',3.53),('8348','2014-04-19','08:40:00',2.14),('8348','2014-04-19','08:45:00',1.59),('8348','2014-04-19','08:50:00',1.35),('8348','2014-04-19','08:55:00',1.26),('8348','2014-04-19','09:00:00',1.32),('8348','2014-04-19','09:05:00',1.07),('8348','2014-04-19','09:15:00',1.16),('8348','2014-04-19','09:20:00',1.41),('8348','2014-04-19','09:25:00',1.37),('8348','2014-04-19','09:30:00',1.39),('8348','2014-04-19','09:35:00',1.68),('8348','2014-04-19','09:40:00',2.22),('8348','2014-04-19','09:45:00',2.13),('8348','2014-04-19','09:50:00',2.27),('8348','2014-04-19','09:55:00',2.9),('8348','2014-04-19','10:00:00',2.9),('8348','2014-04-19','10:05:00',2.29),('8348','2014-04-19','10:10:00',2.28),('8348','2014-04-19','10:15:00',3.35),('8348','2014-04-19','10:20:00',5.88),('8348','2014-04-19','10:25:00',5.01),('8348','2014-04-19','10:30:00',4.44),('8348','2014-04-19','10:35:00',4.7),('8348','2014-04-19','10:40:00',4.85),('8348','2014-04-19','10:45:00',3.72),('8348','2014-04-19','10:50:00',3),('8348','2014-04-19','10:55:00',1.9),('8348','2014-04-19','11:00:00',1.54),('8348','2014-04-19','11:05:00',1.24),('8348','2014-04-19','12:05:00',1.19),('8348','2014-04-19','12:10:00',1.18),('8348','2014-04-19','12:15:00',2.65),('8348','2014-04-19','12:20:00',2.56),('8348','2014-04-19','12:25:00',1.36),('8348','2014-04-19','12:35:00',1.52),('8348','2014-04-19','12:40:00',1.46),('8348','2014-04-19','12:45:00',1.07),('8348','2014-04-19','12:50:00',1.48),('8348','2014-04-19','12:55:00',1.7),('8348','2014-04-19','13:25:00',1.15),('8348','2014-04-19','13:30:00',2.53),('8348','2014-04-19','13:35:00',2.64),('8348','2014-04-19','13:40:00',3.21),('8348','2014-04-19','13:45:00',3.31),('8348','2014-04-19','13:50:00',2.08),('8348','2014-04-19','13:55:00',1.82),('8348','2014-04-19','14:00:00',2.51),('8348','2014-04-19','14:05:00',2.34),('8348','2014-04-19','14:10:00',1.11),('8348','2014-04-19','14:20:00',1.18),('8348','2014-04-19','14:25:00',1.96),('8348','2014-04-19','14:30:00',1.95),('8348','2014-04-19','14:35:00',1.13),('8348','2014-04-19','14:45:00',2.02),('8348','2014-04-19','14:50:00',5.35),('8348','2014-04-19','14:55:00',5.38),('8348','2014-04-19','15:00:00',4.05),('8348','2014-04-19','15:05:00',3.98),('8348','2014-04-19','15:10:00',3.45),('8348','2014-04-19','15:15:00',3.1),('8348','2014-04-19','15:20:00',3.47),('8348','2014-04-19','15:25:00',3.55),('8348','2014-04-19','15:30:00',5.73),('8348','2014-04-19','15:35:00',2.96),('8348','2014-04-19','15:40:00',2.07),('8348','2014-04-19','15:45:00',1.84),('8348','2014-04-19','15:50:00',1.37),('8348','2014-04-19','16:00:00',1.1),('8348','2014-04-19','16:05:00',1.69),('8348','2014-04-19','16:10:00',1.75),('8348','2014-04-19','16:15:00',2.02),('8348','2014-04-19','16:20:00',3.54),('8348','2014-04-19','16:25:00',2.48),('8348','2014-04-19','16:30:00',2.27),('8348','2014-04-19','16:35:00',1.75),('8348','2014-04-19','16:40:00',1.11),('8348','2013-11-17','08:45:00',1.04),('8348','2013-11-17','08:50:00',1.19),('8348','2013-11-17','08:55:00',1.27),('8348','2013-11-17','09:00:00',1.18),('8348','2013-11-17','09:05:00',1.09),('8348','2013-11-17','09:10:00',1.12),('8348','2013-11-17','09:15:00',1.18),('8348','2013-11-17','09:20:00',1.28),('8348','2013-11-17','09:25:00',1.34),('8348','2013-11-17','09:30:00',1.4),('8348','2013-11-17','09:35:00',1.38),('8348','2013-11-17','09:40:00',1.43),('8348','2013-11-17','09:45:00',1.47),('8348','2013-11-17','09:50:00',1.5),('8348','2013-11-17','09:55:00',1.56),('8348','2013-11-17','10:00:00',1.61),('8348','2013-11-17','10:05:00',1.65),('8348','2013-11-17','10:10:00',1.69),('8348','2013-11-17','10:15:00',1.73),('8348','2013-11-17','10:20:00',1.77),('8348','2013-11-17','10:25:00',1.8),('8348','2013-11-17','10:30:00',1.83),('8348','2013-11-17','10:35:00',1.86),('8348','2013-11-17','10:40:00',1.9),('8348','2013-11-17','10:45:00',1.92),('8348','2013-11-17','10:50:00',1.95),('8348','2013-11-17','10:55:00',1.97),('8348','2013-11-17','11:00:00',1.99),('8348','2013-11-17','11:05:00',2.02),('8348','2013-11-17','11:10:00',2.04),('8348','2013-11-17','11:15:00',2.06),('8348','2013-11-17','11:20:00',2.08),('8348','2013-11-17','11:25:00',2.09),('8348','2013-11-17','11:30:00',2.1),('8348','2013-11-17','11:35:00',2.1),('8348','2013-11-17','11:40:00',2.1),('8348','2013-11-17','11:45:00',2.13),('8348','2013-11-17','11:50:00',2.14),('8348','2013-11-17','11:55:00',2.14),('8348','2013-11-17','12:00:00',2.13),('8348','2013-11-17','12:05:00',2.13),('8348','2013-11-17','12:10:00',2.13),('8348','2013-11-17','12:15:00',2.11),('8348','2013-11-17','12:20:00',2.11),('8348','2013-11-17','12:25:00',2.11),('8348','2013-11-17','12:30:00',2.1),('8348','2013-11-17','12:35:00',2.1),('8348','2013-11-17','12:40:00',2.1),('8348','2013-11-17','12:45:00',2.09),('8348','2013-11-17','12:50:00',2.09),('8348','2013-11-17','12:55:00',2.07),('8348','2013-11-17','13:00:00',2.05),('8348','2013-11-17','13:05:00',2.02),('8348','2013-11-17','13:10:00',1.99),('8348','2013-11-17','13:15:00',1.97),('8348','2013-11-17','13:20:00',1.94),('8348','2013-11-17','13:25:00',1.95),('8348','2013-11-17','13:30:00',1.95),('8348','2013-11-17','13:35:00',1.66),('8348','2013-11-17','13:40:00',1.35),('8348','2013-11-17','14:00:00',1.52),('8348','2013-11-17','14:05:00',1.35),('8348','2013-11-17','14:10:00',1.62),('8348','2013-11-17','14:15:00',1.57),('8348','2013-11-17','14:20:00',1.51),('8348','2013-11-17','14:25:00',1.47),('8348','2013-11-17','14:30:00',1.37),('8348','2013-11-17','14:35:00',1.34),('8348','2013-11-17','14:40:00',1.26),('8348','2013-11-17','14:45:00',1.26),('8348','2013-11-15','09:15:00',1.07),('8348','2013-11-15','09:30:00',1.03),('8348','2013-11-15','09:35:00',1.13),('8348','2013-11-15','10:15:00',1.13),('8348','2013-11-15','10:20:00',1.13),('8348','2013-11-15','10:55:00',1.3),('8348','2013-11-15','11:00:00',1.19),('8348','2013-11-15','11:05:00',1.09),('8348','2013-11-15','11:10:00',1.05),('8348','2013-11-15','11:15:00',1.13),('8348','2013-11-15','11:20:00',1.45),('8348','2013-11-15','11:25:00',1.77),('8348','2013-11-15','11:30:00',1.5),('8348','2013-11-15','11:35:00',1.52),('8348','2013-11-15','11:40:00',1.8),('8348','2013-11-15','11:45:00',1.34),('8348','2013-11-15','11:50:00',1.16),('8348','2013-11-15','11:55:00',1.06),('8348','2013-11-15','12:00:00',1.06),('8348','2013-11-15','12:05:00',1.2),('8348','2013-11-15','12:15:00',1.06),('8348','2013-11-15','12:20:00',1.16),('8348','2013-11-15','12:25:00',1.55),('8348','2013-11-15','12:30:00',1.23),('8348','2013-11-15','12:35:00',1.06),('8348','2013-11-15','12:50:00',1.06),('8348','2013-11-15','12:55:00',1.27),('8348','2013-11-15','13:00:00',1.36),('8348','2013-11-15','13:05:00',1.16),('8348','2013-11-15','13:10:00',1.05),('8348','2013-11-15','13:35:00',1.05),('8348','2013-11-15','13:40:00',1.09),('8348','2013-11-15','13:45:00',1.47),('8348','2013-11-15','13:50:00',1.73),('8348','2013-11-15','13:55:00',1.1),('8348','2013-11-14','09:00:00',1.03),('8348','2013-11-14','09:20:00',1.31),('8348','2013-11-14','09:25:00',1.34),('8348','2013-11-14','09:30:00',1.37),('8348','2013-11-14','09:35:00',1.42),('8348','2013-11-14','09:40:00',1.47),('8348','2013-11-14','09:45:00',1.51),('8348','2013-11-14','09:50:00',1.33),('8348','2013-11-14','09:55:00',1.02),('8348','2013-11-14','10:05:00',1.13),('8348','2013-11-14','10:10:00',1.39),('8348','2013-11-14','10:15:00',1.78),('8348','2013-11-14','10:20:00',1.84),('8348','2013-11-14','10:25:00',1.83),('8348','2013-11-14','10:30:00',1.86),('8348','2013-11-14','10:35:00',1.88),('8348','2013-11-14','10:40:00',1.91),('8348','2013-11-14','10:45:00',1.91),('8348','2013-11-14','10:50:00',1.96),('8348','2013-11-14','10:55:00',1.95),('8348','2013-11-14','11:00:00',2),('8348','2013-11-14','11:05:00',2.11),('8348','2013-11-14','11:10:00',2.16),('8348','2013-11-14','11:15:00',2.21),('8348','2013-11-14','11:20:00',2.26),('8348','2013-11-14','11:25:00',2.3),('8348','2013-11-14','11:30:00',2.27),('8348','2013-11-14','11:35:00',2.09),('8348','2013-11-14','11:40:00',2),('8348','2013-11-14','11:45:00',1.58),('8348','2013-11-14','11:50:00',1.67),('8348','2013-11-14','11:55:00',1.36),('8348','2013-11-14','12:00:00',2.41),('8348','2013-11-14','12:05:00',1.29),('8348','2013-11-14','12:10:00',1.23),('8348','2013-11-14','12:15:00',1.27),('8348','2013-11-14','12:20:00',1.15),('8348','2013-11-14','12:35:00',1),('8348','2013-11-14','12:45:00',1),('8348','2013-11-14','12:50:00',1.04),('8348','2013-11-14','12:55:00',1.02),('8348','2013-11-14','13:00:00',1),('8348','2013-11-14','13:55:00',1.04),('8348','2013-11-13','10:20:00',1.71),('8348','2013-11-13','10:25:00',2.72),('8348','2013-11-13','10:30:00',2.35),('8348','2013-11-13','10:35:00',2.82),('8348','2013-11-13','10:40:00',2.65),('8348','2013-11-13','10:45:00',2.4),('8348','2013-11-13','10:50:00',2.81),('8348','2013-11-13','10:55:00',2.43),('8348','2013-11-13','11:00:00',1.61),('8348','2013-11-13','11:50:00',1.09),('8348','2013-11-13','11:55:00',1.01),('8348','2013-11-13','13:05:00',1.22),('8348','2013-11-13','13:10:00',1.14),('8348','2013-11-13','13:15:00',1.1),('8348','2013-11-13','13:55:00',1.43),('8348','2013-11-13','14:00:00',1.64),('8348','2013-11-13','14:05:00',1.58),('8348','2013-11-13','14:10:00',1.47),('8348','2013-11-13','14:15:00',1.51),('8348','2013-11-13','14:20:00',1.39),('8348','2013-11-13','14:25:00',1.45),('8348','2013-11-13','14:30:00',1.38),('8348','2013-11-13','14:35:00',1.02),('8348','2013-11-12','11:25:00',1.18),('8348','2013-11-12','11:40:00',2.23),('8348','2013-11-12','11:45:00',1.31),('8348','2013-11-12','11:50:00',1.49),('8348','2013-11-12','12:00:00',2.28),('8348','2013-11-12','12:05:00',1.21),('8348','2013-11-12','12:30:00',3.02),('8348','2013-11-12','12:35:00',2.74),('8348','2013-11-12','12:40:00',1.77),('8348','2013-11-12','12:45:00',1.69),('8348','2013-11-12','12:50:00',1.56),('8348','2013-11-12','12:55:00',1.98),('8348','2013-11-12','13:00:00',1.78),('8348','2013-11-12','13:05:00',1.89),('8348','2013-11-12','13:10:00',2.71),('8348','2013-11-12','13:15:00',3.25),('8348','2013-11-12','13:20:00',2.49),('8348','2013-11-12','13:25:00',2.69),('8348','2013-11-12','13:30:00',1.68),('8348','2013-11-12','13:35:00',1.75),('8348','2013-11-12','13:40:00',2.5),('8348','2013-11-12','13:45:00',1.55),('8348','2013-11-12','13:50:00',1.08),('8348','2013-11-12','13:55:00',1.19),('8348','2013-11-12','14:00:00',1.21),('8348','2013-11-12','14:05:00',1.12),('8348','2013-11-12','14:10:00',2.12),('8348','2013-11-12','14:15:00',2.4),('8348','2013-11-12','14:20:00',2.22),('8348','2013-11-12','14:25:00',1.07),('8348','2013-11-12','14:30:00',1.67),('8348','2013-11-12','14:35:00',1.11),('8348','2013-11-12','14:40:00',1.66),('8348','2013-11-12','14:45:00',1.53),('8348','2013-11-12','14:50:00',1.23),('8348','2013-11-12','15:20:00',1.06),('8348','2013-11-11','09:50:00',1.09),('8348','2013-11-11','09:55:00',1.16),('8348','2013-11-11','10:05:00',1.07),('8348','2013-11-11','10:10:00',1.09),('8348','2013-11-11','10:15:00',1.36),('8348','2013-11-11','10:20:00',1.78),('8348','2013-11-11','10:25:00',1.33),('8348','2013-11-11','11:05:00',1.18),('8348','2013-11-11','11:10:00',2.65),('8348','2013-11-11','11:15:00',2.07),('8348','2013-11-11','11:20:00',1.57),('8348','2013-11-11','11:25:00',2.34),('8348','2013-11-11','11:30:00',2.54),('8348','2013-11-11','11:35:00',2.35),('8348','2013-11-11','11:40:00',3.32),('8348','2013-11-11','11:45:00',2.58),('8348','2013-11-11','11:50:00',3.01),('8348','2013-11-11','11:55:00',2.84),('8348','2013-11-11','12:00:00',2.64),('8348','2013-11-11','12:05:00',2.54),('8348','2013-11-11','12:10:00',2.48),('8348','2013-11-11','12:15:00',2.48),('8348','2013-11-11','12:20:00',2.55),('8348','2013-11-11','12:25:00',2.5),('8348','2013-11-11','12:30:00',1.55),('8348','2013-11-11','12:35:00',1.09),('8348','2013-11-11','12:40:00',1.65),('8348','2013-11-11','12:45:00',1.62),('8348','2013-11-11','13:00:00',1.03),('8348','2013-11-11','13:10:00',2.23),('8348','2013-11-11','13:15:00',1.71),('8348','2013-11-11','13:35:00',1.06),('8348','2013-11-11','13:40:00',1.67),('8348','2013-11-11','13:45:00',1.17),('8348','2013-11-11','14:00:00',1.11),('8348','2013-11-11','14:05:00',1.49),('8348','2013-11-11','14:15:00',1.07),('8348','2013-11-11','14:20:00',1.56),('8348','2013-11-11','14:25:00',2.01),('8348','2013-11-11','14:30:00',1.79),('8348','2013-11-11','14:35:00',1.7),('8348','2013-11-11','14:40:00',1.55),('8348','2013-11-10','08:40:00',1.03),('8348','2013-11-10','08:50:00',1.2),('8348','2013-11-10','08:55:00',1.34),('8348','2013-11-10','09:00:00',1.12),('8348','2013-11-10','09:15:00',1.15),('8348','2013-11-10','09:20:00',1.41),('8348','2013-11-10','09:25:00',1.52),('8348','2013-11-10','09:30:00',1.34),('8348','2013-11-10','09:35:00',1.33),('8348','2013-11-10','09:40:00',1.44),('8348','2013-11-10','09:45:00',1.61),('8348','2013-11-10','09:50:00',1.69),('8348','2013-11-10','09:55:00',1.74),('8348','2013-11-10','10:00:00',1.79),('8348','2013-11-10','10:05:00',1.97),('8348','2013-11-10','10:10:00',2.05),('8348','2013-11-10','10:15:00',2.1),('8348','2013-11-10','10:20:00',1.99),('8348','2013-11-10','10:25:00',2.25),('8348','2013-11-10','10:30:00',2.37),('8348','2013-11-10','10:35:00',2.04),('8348','2013-11-10','10:40:00',2.22),('8348','2013-11-10','10:45:00',1.64),('8348','2013-11-10','10:50:00',2.38),('8348','2013-11-10','10:55:00',2.26),('8348','2013-11-10','11:00:00',2.12),('8348','2013-11-10','11:05:00',1.57),('8348','2013-11-10','11:10:00',1.04),('8348','2013-11-10','11:25:00',1.1),('8348','2013-11-10','11:35:00',1.02),('8348','2013-11-10','11:40:00',1.35),('8348','2013-11-10','11:45:00',1.64),('8348','2013-11-10','11:50:00',1.04),('8348','2013-11-10','11:55:00',1.34),('8348','2013-11-10','12:05:00',1.38),('8348','2013-11-10','12:10:00',1.92),('8348','2013-11-10','12:15:00',2.43),('8348','2013-11-10','12:20:00',2.48),('8348','2013-11-10','12:25:00',2.35),('8348','2013-11-10','12:30:00',1.51),('8348','2013-11-10','12:35:00',2.06),('8348','2013-11-10','12:40:00',2.57),('8348','2013-11-10','12:45:00',2.79),('8348','2013-11-10','12:50:00',2.73),('8348','2013-11-10','12:55:00',1.19),('8348','2013-11-10','13:00:00',1.06),('8348','2013-11-10','13:50:00',2.15),('8348','2013-11-10','13:55:00',1.68),('8348','2013-11-09','09:40:00',1.79),('8348','2013-11-09','09:45:00',1.31),('8348','2013-11-09','09:50:00',2.14),('8348','2013-11-09','09:55:00',2.08),('8348','2013-11-09','10:00:00',1.96),('8348','2013-11-09','10:05:00',1.8),('8348','2013-11-09','10:10:00',1.36),('8348','2013-11-09','10:15:00',1.76),('8348','2013-11-09','10:20:00',1.73),('8348','2013-11-09','10:25:00',1.67),('8348','2013-11-09','10:35:00',1.2),('8348','2013-11-09','10:40:00',1.16),('8348','2013-11-09','10:45:00',1.18),('8348','2013-11-09','10:50:00',1.3),('8348','2013-11-09','10:55:00',1.89),('8348','2013-11-09','11:00:00',1.72),('8348','2013-11-09','11:05:00',2.69),('8348','2013-11-09','11:10:00',2.5),('8348','2013-11-09','11:15:00',2.99),('8348','2013-11-09','11:20:00',1.74),('8348','2013-11-09','11:25:00',1.48),('8348','2013-11-09','11:30:00',1.37),('8348','2013-11-09','11:35:00',1.74),('8348','2013-11-09','11:40:00',2.23),('8348','2013-11-09','11:45:00',1.62),('8348','2013-11-09','11:50:00',2.34),('8348','2013-11-09','11:55:00',2.18),('8348','2013-11-09','12:00:00',2.46),('8348','2013-11-09','12:05:00',3.04),('8348','2013-11-09','12:10:00',1.57),('8348','2013-11-09','12:15:00',1.56),('8348','2013-11-09','12:20:00',1.01),('8348','2013-11-09','12:25:00',1.42),('8348','2013-11-09','12:30:00',2.21),('8348','2013-11-09','12:35:00',2.41),('8348','2013-11-09','12:40:00',2.35),('8348','2013-11-09','12:45:00',1.72),('8348','2013-11-09','12:50:00',2.02),('8348','2013-11-09','12:55:00',1.55),('8348','2013-11-09','13:00:00',2.78),('8348','2013-11-09','13:05:00',2.07),('8348','2013-11-09','13:10:00',2.65),('8348','2013-11-09','13:15:00',2.57),('8348','2013-11-09','13:20:00',1.3),('8348','2013-11-09','13:25:00',2.2),('8348','2013-11-09','13:30:00',2.31),('8348','2013-11-09','13:35:00',2.25),('8348','2013-11-09','13:40:00',2.11),('8348','2013-11-09','13:45:00',2.07),('8348','2013-11-09','13:50:00',2.1),('8348','2013-11-09','13:55:00',2.05),('8348','2013-11-09','14:00:00',1.99),('8348','2013-11-09','14:05:00',1.8),('8348','2013-11-09','14:10:00',1.17),('8348','2013-11-09','14:15:00',1.25),('8348','2013-11-09','14:20:00',1.87),('8348','2013-11-09','14:25:00',1.49),('8348','2013-11-09','14:35:00',1.03),('8348','2013-11-09','14:40:00',1.17),('8348','2013-11-09','14:50:00',1.36),('8348','2013-11-08','09:20:00',1.52),('8348','2013-11-08','09:25:00',1.69),('8348','2013-11-08','09:30:00',1.87),('8348','2013-11-08','09:35:00',1.75),('8348','2013-11-08','09:45:00',1.09),('8348','2013-11-08','09:50:00',1.42),('8348','2013-11-08','10:05:00',1.39),('8348','2013-11-08','10:10:00',1.12),('8348','2013-11-08','10:40:00',1.43),('8348','2013-11-08','10:45:00',1.26),('8348','2013-11-08','10:50:00',1.82),('8348','2013-11-08','11:20:00',1.65),('8348','2013-11-08','11:25:00',2.04),('8348','2013-11-08','11:30:00',2.8),('8348','2013-11-08','11:35:00',2.32),('8348','2013-11-08','11:40:00',2.67),('8348','2013-11-08','11:45:00',2.53),('8348','2013-11-08','11:50:00',2.66),('8348','2013-11-08','11:55:00',2.4),('8348','2013-11-08','12:00:00',2.36),('8348','2013-11-08','12:05:00',2.36),('8348','2013-11-08','12:10:00',2.33),('8348','2013-11-08','12:15:00',1.12),('8348','2013-11-08','12:20:00',2.01),('8348','2013-11-08','12:35:00',1.13),('8348','2013-11-08','12:40:00',2.07),('8348','2013-11-08','12:45:00',2.06),('8348','2013-11-08','12:50:00',2.52),('8348','2013-11-08','12:55:00',2.61),('8348','2013-11-08','13:00:00',2.51),('8348','2013-11-08','13:05:00',2.44),('8348','2013-11-08','13:10:00',2.57),('8348','2013-11-08','13:15:00',1.79),('8348','2013-11-08','13:20:00',1.21),('8348','2013-11-08','13:25:00',2.25),('8348','2013-11-08','13:30:00',1.74),('8348','2013-11-08','13:35:00',2.25),('8348','2013-11-08','13:40:00',2.17),('8348','2013-11-08','13:45:00',2.08),('8348','2013-11-08','13:50:00',2.06),('8348','2013-11-08','13:55:00',2.06),('8348','2013-11-08','14:00:00',2),('8348','2013-11-08','14:05:00',1.91),('8348','2013-11-08','14:10:00',1.87),('8348','2013-11-08','14:25:00',1.21),('8348','2013-11-08','14:30:00',1.37),('8348','2013-11-08','14:35:00',1.75),('8348','2013-11-08','14:40:00',1.49),('8348','2013-11-08','14:45:00',1.51),('8348','2013-11-08','14:50:00',1.06),('8348','2013-11-08','15:05:00',1.28),('8348','2013-11-08','15:10:00',1.21),('8348','2014-04-18','07:00:00',1.17),('8348','2014-04-18','07:05:00',2.12),('8348','2014-04-18','07:10:00',2.13),('8348','2014-04-18','07:15:00',1.01),('8348','2014-04-18','07:35:00',1.51),('8348','2014-04-18','07:40:00',2.25),('8348','2014-04-18','07:45:00',2.3),('8348','2014-04-18','07:50:00',1.9),('8348','2014-04-18','07:55:00',1.79),('8348','2014-04-18','08:00:00',2.04),('8348','2014-04-18','08:05:00',3.77),('8348','2014-04-18','08:10:00',4.95),('8348','2014-04-18','08:15:00',4.46),('8348','2014-04-18','08:20:00',4.16),('8348','2014-04-18','08:25:00',2.77),('8348','2014-04-18','08:30:00',4.84),('8348','2014-04-18','08:35:00',2.8),('8348','2014-04-18','08:40:00',1.82),('8348','2014-04-18','08:45:00',3.12),('8348','2014-04-18','08:50:00',4.81),('8348','2014-04-18','08:55:00',5.19),('8348','2014-04-18','09:00:00',4.34),('8348','2014-04-18','09:05:00',2.89),('8348','2014-04-18','09:10:00',2.61),('8348','2014-04-18','09:15:00',2.79),('8348','2014-04-18','09:20:00',2.65),('8348','2014-04-18','09:25:00',2.75),('8348','2014-04-18','09:30:00',2.32),('8348','2014-04-18','09:35:00',2.14),('8348','2014-04-18','09:40:00',2.52),('8348','2014-04-18','09:45:00',4.2),('8348','2014-04-18','09:50:00',5.22),('8348','2014-04-18','09:55:00',5.19),('8348','2014-04-18','10:00:00',3.37),('8348','2014-04-18','10:05:00',3.01),('8348','2014-04-18','10:10:00',3.51),('8348','2014-04-18','10:15:00',5.16),('8348','2014-04-18','10:20:00',3.3),('8348','2014-04-18','10:25:00',2.53),('8348','2014-04-18','10:30:00',3.01),('8348','2014-04-18','10:35:00',2.94),('8348','2014-04-18','10:40:00',3.09),('8348','2014-04-18','10:45:00',3),('8348','2014-04-18','10:50:00',3.62),('8348','2014-04-18','10:55:00',3.27),('8348','2014-04-18','11:00:00',3.35),('8348','2014-04-18','11:05:00',6.03),('8348','2014-04-18','11:10:00',6),('8348','2014-04-18','11:15:00',6.07),('8348','2014-04-18','11:20:00',6.77),('8348','2014-04-18','11:25:00',4.85),('8348','2014-04-18','11:30:00',7.71),('8348','2014-04-18','11:35:00',7.47),('8348','2014-04-18','11:40:00',7.52),('8348','2014-04-18','11:45:00',6.48),('8348','2014-04-18','11:50:00',6.4),('8348','2014-04-18','11:55:00',4.95),('8348','2014-04-18','12:00:00',7.62),('8348','2014-04-18','12:05:00',5.02),('8348','2014-04-18','12:10:00',4.73),('8348','2014-04-18','12:15:00',4.48),('8348','2014-04-18','12:20:00',4.22),('8348','2014-04-18','12:25:00',3.08),('8348','2014-04-18','12:30:00',2.52),('8348','2014-04-18','12:35:00',2.54),('8348','2014-04-18','12:40:00',2.42),('8348','2014-04-18','12:45:00',2.1),('8348','2014-04-18','12:50:00',2.59),('8348','2014-04-18','12:55:00',4.33),('8348','2014-04-18','13:00:00',3.72),('8348','2014-04-18','13:05:00',3.09),('8348','2014-04-18','13:10:00',2.73),('8348','2014-04-18','13:15:00',2.44),('8348','2014-04-18','13:20:00',2.88),('8348','2014-04-18','13:25:00',3.66),('8348','2014-04-18','13:30:00',4.11),('8348','2014-04-18','13:35:00',4.72),('8348','2014-04-18','13:40:00',4.22),('8348','2014-04-18','13:45:00',4.97),('8348','2014-04-18','13:50:00',5.92),('8348','2014-04-18','13:55:00',4.79),('8348','2014-04-18','14:00:00',8),('8348','2014-04-18','14:05:00',4.72),('8348','2014-04-18','14:10:00',3.42),('8348','2014-04-18','14:15:00',4.06),('8348','2014-04-18','14:20:00',3.48),('8348','2014-04-18','14:25:00',4.16),('8348','2014-04-18','14:30:00',6.21),('8348','2014-04-18','14:35:00',6.07),('8348','2014-04-18','14:40:00',5.73),('8348','2014-04-18','14:45:00',4.23),('8348','2014-04-18','14:50:00',4.92),('8348','2014-04-18','14:55:00',5.21),('8348','2014-04-18','15:00:00',4.38),('8348','2014-04-18','15:05:00',3.46),('8348','2014-04-18','15:10:00',2.71),('8348','2014-04-18','15:15:00',2.35),('8348','2014-04-18','15:20:00',2.51),('8348','2014-04-18','15:25:00',3.93),('8348','2014-04-18','15:30:00',4.23),('8348','2014-04-18','15:35:00',4.66),('8348','2014-04-18','15:40:00',5.92),('8348','2014-04-18','15:45:00',5.4),('8348','2014-04-18','15:50:00',5.4),('8348','2014-04-18','15:55:00',4.6),('8348','2014-04-18','16:00:00',5.03),('8348','2014-04-18','16:05:00',5.36),('8348','2014-04-18','16:10:00',4.77),('8348','2014-04-18','16:15:00',3.92),('8348','2014-04-18','16:20:00',4.15),('8348','2014-04-18','16:25:00',4.15),('8348','2014-04-18','16:30:00',3.87),('8348','2014-04-18','16:35:00',3.69),('8348','2014-04-18','16:40:00',3.53),('8348','2014-04-18','16:45:00',3.35),('8348','2014-04-18','16:50:00',3.26),('8348','2014-04-18','16:55:00',3.12),('8348','2014-04-18','17:00:00',2.99),('8348','2014-04-18','17:05:00',2.7),('8348','2014-04-18','17:10:00',2.51),('8348','2014-04-18','17:15:00',2.31),('8348','2014-04-18','17:20:00',2.14),('8348','2014-04-18','17:25:00',1.89),('8348','2014-04-18','17:30:00',1.42),('8348','2014-04-18','17:35:00',1.59),('8348','2014-04-18','17:40:00',1.42),('8348','2014-04-18','17:45:00',1.36),('8348','2014-04-18','17:50:00',1.17),('8348','2014-04-18','17:55:00',1.03),('8348','2013-11-07','08:55:00',1.06),('8348','2013-11-07','09:00:00',1.12),('8348','2013-11-07','09:05:00',1.18),('8348','2013-11-07','09:10:00',1.25),('8348','2013-11-07','09:15:00',1.32),('8348','2013-11-07','09:20:00',1.38),('8348','2013-11-07','09:25:00',1.43),('8348','2013-11-07','09:30:00',1.49),('8348','2013-11-07','09:35:00',1.53),('8348','2013-11-07','09:40:00',1.57),('8348','2013-11-07','09:45:00',1.62),('8348','2013-11-07','09:50:00',1.67),('8348','2013-11-07','09:55:00',1.7),('8348','2013-11-07','10:00:00',1.73),('8348','2013-11-07','10:05:00',1.77),('8348','2013-11-07','10:10:00',1.8),('8348','2013-11-07','10:15:00',1.83),('8348','2013-11-07','10:20:00',1.86),('8348','2013-11-07','10:25:00',1.89),('8348','2013-11-07','10:30:00',1.92),('8348','2013-11-07','10:35:00',1.95),('8348','2013-11-07','10:40:00',1.97),('8348','2013-11-07','10:45:00',1.99),('8348','2013-11-07','10:50:00',2.01),('8348','2013-11-07','10:55:00',2.01),('8348','2013-11-07','11:00:00',2.03),('8348','2013-11-07','11:05:00',2.06),('8348','2013-11-07','11:10:00',2.07),('8348','2013-11-07','11:15:00',2.09),('8348','2013-11-07','11:20:00',2.09),('8348','2013-11-07','11:25:00',2.09),('8348','2013-11-07','11:30:00',2.11),('8348','2013-11-07','11:35:00',2.13),('8348','2013-11-07','11:40:00',2.12),('8348','2013-11-07','11:45:00',2.16),('8348','2013-11-07','11:50:00',2.17),('8348','2013-11-07','11:55:00',2.14),('8348','2013-11-07','12:00:00',2.15),('8348','2013-11-07','12:05:00',2.12),('8348','2013-11-07','12:10:00',2.12),('8348','2013-11-07','12:15:00',2.14),('8348','2013-11-07','12:20:00',2.15),('8348','2013-11-07','12:25:00',2.14),('8348','2013-11-07','12:30:00',2.15),('8348','2013-11-07','12:35:00',2.18),('8348','2013-11-07','12:40:00',2.13),('8348','2013-11-07','12:45:00',2.13),('8348','2013-11-07','12:50:00',2.12),('8348','2013-11-07','12:55:00',2.18),('8348','2013-11-07','13:00:00',2.19),('8348','2013-11-07','13:05:00',1.27),('8348','2013-11-07','13:10:00',1.26),('8348','2013-11-07','13:15:00',1.45),('8348','2013-11-07','13:30:00',1.88),('8348','2013-11-07','13:35:00',2.27),('8348','2013-11-07','13:40:00',2.23),('8348','2013-11-07','13:45:00',1.13),('8348','2013-11-07','13:50:00',2.23),('8348','2013-11-07','13:55:00',1.47),('8348','2013-11-07','14:00:00',1.38),('8348','2013-11-07','14:05:00',1.12),('8348','2013-11-07','14:10:00',1.11),('8348','2013-11-07','14:15:00',1.28),('8348','2013-11-07','14:25:00',1.67),('8348','2013-11-07','14:30:00',1.52),('8348','2013-11-07','14:35:00',1.4),('8348','2013-11-07','14:40:00',1.59),('8348','2013-11-07','14:45:00',1.49),('8348','2013-11-07','14:50:00',1.44),('8348','2013-11-07','14:55:00',1.39),('8348','2013-11-07','15:00:00',1.32),('8348','2013-11-07','15:05:00',1.27),('8348','2013-11-07','15:10:00',1.19),('8348','2013-11-07','15:15:00',1.13),('8348','2013-11-07','15:20:00',1.05),('8348','2013-11-06','08:50:00',1.08),('8348','2013-11-06','08:55:00',1.08),('8348','2013-11-06','09:15:00',1.13),('8348','2013-11-06','09:20:00',1.27),('8348','2013-11-06','09:25:00',1.46),('8348','2013-11-06','09:30:00',1.54),('8348','2013-11-06','09:35:00',1.6),('8348','2013-11-06','09:40:00',1.64),('8348','2013-11-06','09:45:00',1.69),('8348','2013-11-06','09:50:00',1.73),('8348','2013-11-06','09:55:00',1.78),('8348','2013-11-06','10:00:00',1.82),('8348','2013-11-06','10:05:00',1.86),('8348','2013-11-06','10:10:00',1.9),('8348','2013-11-06','10:15:00',1.94),('8348','2013-11-06','10:20:00',1.99),('8348','2013-11-06','10:25:00',2.02),('8348','2013-11-06','10:30:00',2.05),('8348','2013-11-06','10:35:00',2.08),('8348','2013-11-06','10:40:00',2.09),('8348','2013-11-06','10:45:00',2.11),('8348','2013-11-06','10:50:00',2.14),('8348','2013-11-06','10:55:00',2.18),('8348','2013-11-06','11:00:00',2.2),('8348','2013-11-06','11:05:00',2.21),('8348','2013-11-06','11:10:00',2.23),('8348','2013-11-06','11:15:00',2.25),('8348','2013-11-06','11:20:00',2.26),('8348','2013-11-06','11:25:00',2.29),('8348','2013-11-06','11:30:00',2.29),('8348','2013-11-06','11:35:00',2.3),('8348','2013-11-06','11:40:00',2.31),('8348','2013-11-06','11:45:00',2.32),('8348','2013-11-06','11:50:00',2.32),('8348','2013-11-06','11:55:00',2.33),('8348','2013-11-06','12:00:00',2.35),('8348','2013-11-06','12:05:00',2.35),('8348','2013-11-06','12:10:00',2.33),('8348','2013-11-06','12:15:00',2.33),('8348','2013-11-06','12:20:00',2.33),('8348','2013-11-06','12:25:00',2.33),('8348','2013-11-06','12:30:00',2.33),('8348','2013-11-06','12:35:00',2.31),('8348','2013-11-06','12:40:00',2.31),('8348','2013-11-06','12:45:00',2.31),('8348','2013-11-06','12:50:00',2.29),('8348','2013-11-06','12:55:00',2.28),('8348','2013-11-06','13:00:00',2.27),('8348','2013-11-06','13:05:00',2.24),('8348','2013-11-06','13:10:00',2.22),('8348','2013-11-06','13:15:00',2.2),('8348','2013-11-06','13:20:00',2.18),('8348','2013-11-06','13:25:00',2.15),('8348','2013-11-06','13:30:00',2.12),('8348','2013-11-06','13:35:00',2.09),('8348','2013-11-06','13:40:00',2.05),('8348','2013-11-06','13:45:00',2.01),('8348','2013-11-06','13:50:00',2),('8348','2013-11-06','13:55:00',1.96),('8348','2013-11-06','14:00:00',1.92),('8348','2013-11-06','14:05:00',1.88),('8348','2013-11-06','14:10:00',1.86),('8348','2013-11-06','14:15:00',1.82),('8348','2013-11-06','14:20:00',1.78),('8348','2013-11-06','14:25:00',1.73),('8348','2013-11-06','14:30:00',1.68),('8348','2013-11-06','14:35:00',1.64),('8348','2013-11-06','14:40:00',1.59),('8348','2013-11-06','14:45:00',1.52),('8348','2013-11-06','14:50:00',1.46),('8348','2013-11-06','14:55:00',1.4),('8348','2013-11-06','15:00:00',1.34),('8348','2013-11-06','15:05:00',1.29),('8348','2013-11-06','15:10:00',1.23),('8348','2013-11-06','15:15:00',1.18),('8348','2013-11-06','15:20:00',1.11),('8348','2013-11-06','15:25:00',1.04),('8348','2013-11-05','08:30:00',1.01),('8348','2013-11-05','08:35:00',1.15),('8348','2013-11-05','08:40:00',1.18),('8348','2013-11-05','10:20:00',1.32),('8348','2013-11-05','10:25:00',1.79),('8348','2013-11-05','10:30:00',1.41),('8348','2013-11-05','10:35:00',1.97),('8348','2013-11-05','10:40:00',1.58),('8348','2013-11-05','10:45:00',1.56),('8348','2013-11-05','10:50:00',1.32),('8348','2013-11-05','10:55:00',1.14),('8348','2013-11-05','11:40:00',1.31),('8348','2013-11-05','11:45:00',1.29),('8348','2013-11-05','11:50:00',1.2),('8348','2013-11-05','11:55:00',1.05),('8348','2013-11-05','12:10:00',1.33),('8348','2013-11-05','12:15:00',1.31),('8348','2013-11-05','12:20:00',1.66),('8348','2013-11-05','12:25:00',1.43),('8348','2013-11-05','12:30:00',1.16),('8348','2013-11-05','13:30:00',1.02),('8348','2013-11-05','13:35:00',2.06),('8348','2013-11-05','13:40:00',2.24),('8348','2013-11-05','13:45:00',2.02),('8348','2013-11-05','13:50:00',1.22),('8348','2013-11-05','13:55:00',1.39),('8348','2013-11-05','14:00:00',1.29),('8348','2013-11-05','14:05:00',2.5),('8348','2013-11-05','14:10:00',2.41),('8348','2013-11-05','14:15:00',1.36),('8348','2013-11-05','14:30:00',1.55),('8348','2013-11-05','14:35:00',1.53),('8348','2013-11-04','09:10:00',1.4),('8348','2013-11-04','09:15:00',1.69),('8348','2013-11-04','09:20:00',1.76),('8348','2013-11-04','09:25:00',2.09),('8348','2013-11-04','09:30:00',1.1),('8348','2013-11-04','10:00:00',1.22),('8348','2013-11-04','10:05:00',1.99),('8348','2013-11-04','10:10:00',2.02),('8348','2013-11-04','10:15:00',2.1),('8348','2013-11-04','10:20:00',2.15),('8348','2013-11-04','10:25:00',2.42),('8348','2013-11-04','10:30:00',2.6),('8348','2013-11-04','10:35:00',1.97),('8348','2013-11-04','10:40:00',2.63),('8348','2013-11-04','10:45:00',1.95),('8348','2013-11-04','10:50:00',1.81),('8348','2013-11-04','10:55:00',2.24),('8348','2013-11-04','11:00:00',1.9),('8348','2013-11-04','11:05:00',2.77),('8348','2013-11-04','11:10:00',1.05),('8348','2013-11-04','11:15:00',1.74),('8348','2013-11-04','11:20:00',1.05),('8348','2013-11-04','11:30:00',2.07),('8348','2013-11-04','11:35:00',2.24),('8348','2013-11-04','11:40:00',1.78),('8348','2013-11-04','11:45:00',2.34),('8348','2013-11-04','11:50:00',3.23),('8348','2013-11-04','11:55:00',2.86),('8348','2013-11-04','12:00:00',2.82),('8348','2013-11-04','12:05:00',2.64),('8348','2013-11-04','12:10:00',2.58),('8348','2013-11-04','12:15:00',2.54),('8348','2013-11-04','12:20:00',2.27),('8348','2013-11-04','12:25:00',2.52),('8348','2013-11-04','12:30:00',2.5),('8348','2013-11-04','12:35:00',2.52),('8348','2013-11-04','12:40:00',2.5),('8348','2013-11-04','12:45:00',2.48),('8348','2013-11-04','12:50:00',2.44),('8348','2013-11-04','12:55:00',2.4),('8348','2013-11-04','13:00:00',2.4),('8348','2013-11-04','13:05:00',2.4),('8348','2013-11-04','13:10:00',2.37),('8348','2013-11-04','13:15:00',2.31),('8348','2013-11-04','13:20:00',1.99),('8348','2013-11-04','13:25:00',2.36),('8348','2013-11-04','13:30:00',2.3),('8348','2013-11-04','13:35:00',2.24),('8348','2013-11-04','13:40:00',1.91),('8348','2013-11-04','13:45:00',2.31),('8348','2013-11-04','13:50:00',2.23),('8348','2013-11-04','13:55:00',1.76),('8348','2013-11-04','14:00:00',1),('8348','2013-11-04','14:05:00',1.75),('8348','2013-11-04','14:10:00',2.14),('8348','2013-11-04','14:15:00',1.85),('8348','2013-11-04','14:20:00',1.89),('8348','2013-11-04','14:25:00',1.15),('8348','2013-11-04','14:35:00',2.04),('8348','2013-11-04','14:40:00',1.75),('8348','2013-11-04','14:45:00',1.74),('8348','2013-11-04','14:50:00',1.67),('8348','2013-11-04','14:55:00',1.45),('8348','2013-11-04','15:00:00',1.51),('8348','2013-11-04','15:10:00',1.11),('8348','2013-11-04','15:15:00',1.21),('8348','2013-11-04','15:20:00',1.15),('8348','2013-11-04','15:25:00',1.14),('8348','2013-11-04','15:35:00',1.05),('8348','2013-11-03','08:55:00',1.01),('8348','2013-11-03','09:40:00',1.95),('8348','2013-11-03','09:45:00',1.23),('8348','2013-11-03','10:10:00',1.33),('8348','2013-11-03','10:20:00',2.06),('8348','2013-11-03','10:25:00',1.71),('8348','2013-11-03','10:30:00',2.1),('8348','2013-11-03','10:35:00',1.49),('8348','2013-11-03','11:20:00',1.52),('8348','2013-11-03','11:25:00',1.58),('8348','2013-11-03','11:30:00',1.68),('8348','2013-11-03','11:35:00',2.31),('8348','2013-11-03','11:40:00',2.67),('8348','2013-11-03','11:45:00',2.79),('8348','2013-11-03','11:50:00',2.8),('8348','2013-11-03','11:55:00',1.9),('8348','2013-11-03','12:00:00',1.86),('8348','2013-11-03','12:05:00',2.46),('8348','2013-11-03','12:10:00',2),('8348','2013-11-03','12:15:00',1.41),('8348','2013-11-03','12:25:00',1.29),('8348','2013-11-03','12:30:00',1.08),('8348','2013-11-03','12:40:00',1.24),('8348','2013-11-03','12:45:00',1.01),('8348','2013-11-03','12:50:00',1),('8348','2013-11-03','13:40:00',1.13),('8348','2013-11-03','13:45:00',1.54),('8348','2013-11-03','13:55:00',1.19),('8348','2013-11-03','14:00:00',1.02),('8348','2013-11-03','14:05:00',1.69),('8348','2013-11-03','14:10:00',1.91),('8348','2013-11-03','14:15:00',2.1),('8348','2013-11-03','14:20:00',1.67),('8348','2013-11-03','14:25:00',1.7),('8348','2013-11-03','14:30:00',1.08),('8348','2013-11-03','14:35:00',1.4),('8348','2013-11-03','14:40:00',1.77),('8348','2013-11-03','14:45:00',1.5),('8348','2013-11-03','14:50:00',1.15),('8348','2013-11-03','15:05:00',1.01),('8348','2013-11-02','08:50:00',1.01),('8348','2013-11-02','08:55:00',1.07),('8348','2013-11-02','09:00:00',1.16),('8348','2013-11-02','09:05:00',1.3),('8348','2013-11-02','09:10:00',1.4),('8348','2013-11-02','09:20:00',1.35),('8348','2013-11-02','09:25:00',1.53),('8348','2013-11-02','09:30:00',1.53),('8348','2013-11-02','09:35:00',1.54),('8348','2013-11-02','09:40:00',1.55),('8348','2013-11-02','09:45:00',1.46),('8348','2013-11-02','09:50:00',1.9),('8348','2013-11-02','09:55:00',1.85),('8348','2013-11-02','10:00:00',2.09),('8348','2013-11-02','10:05:00',1.8),('8348','2013-11-02','10:10:00',1.07),('8348','2013-11-02','11:00:00',1.05),('8348','2013-11-02','11:05:00',1.25),('8348','2013-11-02','11:10:00',1.14),('8348','2013-11-02','11:55:00',1.59),('8348','2013-11-02','12:00:00',2.9),('8348','2013-11-02','12:05:00',2.81),('8348','2013-11-02','12:10:00',2.67),('8348','2013-11-02','12:15:00',2.55),('8348','2013-11-02','12:20:00',2.92),('8348','2013-11-02','12:25:00',2.69),('8348','2013-11-02','12:30:00',3.18),('8348','2013-11-02','12:35:00',2.92),('8348','2013-11-02','12:40:00',2.53),('8348','2013-11-02','12:45:00',1.77),('8348','2013-11-02','12:50:00',2.5),('8348','2013-11-02','12:55:00',2.57),('8348','2013-11-02','13:00:00',1.88),('8348','2013-11-02','13:05:00',2.47),('8348','2013-11-02','13:10:00',3.01),('8348','2013-11-02','13:15:00',1.3),('8348','2013-11-02','13:35:00',1.98),('8348','2013-11-02','13:40:00',2.75),('8348','2013-11-02','13:45:00',2.53),('8348','2013-11-02','13:50:00',2.84),('8348','2013-11-02','13:55:00',2.69),('8348','2013-11-02','14:00:00',2.45),('8348','2013-11-02','14:05:00',2.14),('8348','2013-11-02','14:10:00',1.98),('8348','2013-11-02','14:15:00',1.89),('8348','2013-11-02','14:20:00',1.84),('8348','2013-11-02','14:25:00',1.78),('8348','2013-11-02','14:30:00',1.74),('8348','2013-11-02','14:35:00',1.67),('8348','2013-11-02','14:40:00',1.62),('8348','2013-11-02','14:45:00',1.55),('8348','2013-11-02','14:50:00',1.54),('8348','2013-11-02','14:55:00',1.2),('8348','2013-11-02','15:00:00',1.25),('8348','2013-11-01','09:00:00',1.08),('8348','2013-11-01','09:05:00',1.22),('8348','2013-11-01','09:10:00',1.31),('8348','2013-11-01','09:15:00',1.36),('8348','2013-11-01','09:20:00',1.41),('8348','2013-11-01','09:25:00',1.47),('8348','2013-11-01','09:30:00',1.51),('8348','2013-11-01','09:35:00',1.56),('8348','2013-11-01','09:40:00',1.62),('8348','2013-11-01','09:45:00',1.67),('8348','2013-11-01','09:50:00',1.73),('8348','2013-11-01','09:55:00',1.77),('8348','2013-11-01','10:00:00',1.82),('8348','2013-11-01','10:05:00',1.86),('8348','2013-11-01','10:10:00',1.9),('8348','2013-11-01','10:15:00',1.93),('8348','2013-11-01','10:20:00',1.97),('8348','2013-11-01','10:25:00',2.01),('8348','2013-11-01','10:30:00',1.98),('8348','2013-11-01','10:35:00',2.01),('8348','2013-11-01','10:40:00',2.07),('8348','2013-11-01','10:45:00',2.04),('8348','2013-11-01','10:50:00',2.06),('8348','2013-11-01','10:55:00',2.05),('8348','2013-11-01','11:00:00',2.14),('8348','2013-11-01','11:05:00',1.94),('8348','2013-11-01','11:10:00',1.77),('8348','2013-11-01','11:15:00',1.83),('8348','2013-11-01','11:20:00',2.25),('8348','2013-11-01','11:25:00',2.37),('8348','2013-11-01','11:30:00',2.38),('8348','2013-11-01','11:35:00',2.26),('8348','2013-11-01','11:40:00',2.05),('8348','2013-11-01','11:45:00',2.18),('8348','2013-11-01','11:50:00',2.43),('8348','2013-11-01','11:55:00',2.47),('8348','2013-11-01','12:00:00',2.43),('8348','2013-11-01','12:05:00',2.33),('8348','2013-11-01','12:10:00',2.22),('8348','2013-11-01','12:15:00',2.11),('8348','2013-11-01','12:20:00',2.1),('8348','2013-11-01','12:25:00',2.13),('8348','2013-11-01','12:30:00',1.94),('8348','2013-11-01','12:35:00',1.05),('8348','2013-11-01','13:20:00',1.13),('8348','2013-11-01','13:35:00',1.09),('8348','2013-11-01','13:40:00',1.11),('8348','2013-10-31','08:40:00',1.07),('8348','2013-10-31','08:45:00',1.09),('8348','2013-10-31','08:50:00',1.16),('8348','2013-10-31','08:55:00',1.13),('8348','2013-10-31','09:00:00',1.13),('8348','2013-10-31','09:05:00',1.07),('8348','2013-10-31','09:20:00',1.2),('8348','2013-10-31','09:30:00',1.08),('8348','2013-10-31','09:35:00',1.38),('8348','2013-10-31','09:40:00',1.33),('8348','2013-10-31','09:45:00',1.33),('8348','2013-10-31','09:50:00',1.35),('8348','2013-10-31','09:55:00',1.36),('8348','2013-10-31','10:00:00',1.42),('8348','2013-10-31','10:05:00',1.41),('8348','2013-10-31','10:10:00',1.27),('8348','2013-10-31','10:15:00',1.24),('8348','2013-10-31','10:20:00',1.19),('8348','2013-10-31','10:25:00',1.29),('8348','2013-10-31','10:30:00',1.3),('8348','2013-10-31','10:35:00',1.45),('8348','2013-10-31','10:40:00',1.54),('8348','2013-10-31','10:45:00',1.42),('8348','2013-10-31','10:50:00',1.42),('8348','2013-10-31','10:55:00',1.56),('8348','2013-10-31','11:00:00',1.9),('8348','2013-10-31','11:05:00',2.18),('8348','2013-10-31','11:10:00',2.03),('8348','2013-10-31','11:15:00',1.8),('8348','2013-10-31','11:20:00',2.18),('8348','2013-10-31','11:25:00',1.95),('8348','2013-10-31','11:30:00',2.09),('8348','2013-10-31','11:35:00',2.01),('8348','2013-10-31','11:40:00',2.18),('8348','2013-10-31','11:45:00',2.32),('8348','2013-10-31','11:50:00',2.29),('8348','2013-10-31','11:55:00',2.29),('8348','2013-10-31','12:00:00',2.26),('8348','2013-10-31','12:05:00',2.17),('8348','2013-10-31','12:10:00',2.28),('8348','2013-10-31','12:15:00',2.28),('8348','2013-10-31','12:20:00',2.23),('8348','2013-10-31','12:25:00',2.24),('8348','2013-10-31','12:30:00',2.18),('8348','2013-10-31','12:35:00',2.12),('8348','2013-10-31','12:40:00',2.2),('8348','2013-10-31','12:45:00',2.24),('8348','2013-10-31','12:50:00',2.32),('8348','2013-10-31','12:55:00',2.34),('8348','2013-10-31','13:00:00',2.29),('8348','2013-10-31','13:05:00',2.23),('8348','2013-10-31','13:10:00',2.17),('8348','2013-10-31','13:15:00',2.17),('8348','2013-10-31','13:20:00',2.16),('8348','2013-10-31','13:25:00',2.13),('8348','2013-10-31','13:30:00',2.1),('8348','2013-10-31','13:35:00',2.06),('8348','2013-10-31','13:40:00',1.95),('8348','2013-10-31','13:45:00',1.93),('8348','2013-10-31','13:50:00',1.52),('8348','2013-10-31','13:55:00',1.27),('8348','2013-10-31','14:00:00',1.83),('8348','2013-10-31','14:05:00',1.78),('8348','2013-10-31','14:10:00',1.69),('8348','2013-10-31','14:15:00',1.48),('8348','2013-10-31','14:20:00',1.01),('8348','2013-10-31','14:25:00',1.49),('8348','2013-10-31','14:30:00',1.15),('8348','2013-10-31','15:00:00',1.03),('8348','2013-10-30','08:45:00',1.01),('8348','2013-10-30','08:50:00',1.05),('8348','2013-10-30','08:55:00',1.02),('8348','2013-10-30','09:00:00',1.1),('8348','2013-10-30','09:05:00',1.2),('8348','2013-10-30','09:10:00',1.32),('8348','2013-10-30','09:15:00',1.38),('8348','2013-10-30','09:20:00',1.43),('8348','2013-10-30','09:25:00',1.47),('8348','2013-10-30','09:30:00',1.51),('8348','2013-10-30','09:35:00',1.55),('8348','2013-10-30','09:40:00',1.62),('8348','2013-10-30','09:45:00',1.66),('8348','2013-10-30','09:50:00',1.71),('8348','2013-10-30','09:55:00',1.66),('8348','2013-10-30','10:00:00',1.52),('8348','2013-10-30','10:05:00',1.56),('8348','2013-10-30','10:10:00',1.8),('8348','2013-10-30','10:15:00',2),('8348','2013-10-30','10:20:00',1.95),('8348','2013-10-30','10:25:00',1.88),('8348','2013-10-30','10:30:00',1.9),('8348','2013-10-30','10:35:00',1.9),('8348','2013-10-30','10:40:00',1.99),('8348','2013-10-30','10:45:00',2.17),('8348','2013-10-30','10:50:00',1.38),('8348','2013-10-30','10:55:00',1.03),('8348','2013-10-30','11:00:00',2.14),('8348','2013-10-30','11:05:00',1.98),('8348','2013-10-30','11:10:00',2.23),('8348','2013-10-30','11:15:00',2.28),('8348','2013-10-30','11:20:00',1.71),('8348','2013-10-30','11:25:00',1.1),('8348','2013-10-30','11:30:00',1),('8348','2013-10-30','11:45:00',1.07),('8348','2013-10-30','11:50:00',1.53),('8348','2013-10-30','12:10:00',1.01),('8348','2013-10-30','12:15:00',1.37),('8348','2013-10-30','12:20:00',1.96),('8348','2013-10-30','12:25:00',2.64),('8348','2013-10-30','12:30:00',1.51),('8348','2013-10-30','12:35:00',1.25),('8348','2013-10-30','12:40:00',1.13),('8348','2013-10-30','12:45:00',1.85),('8348','2013-10-30','12:50:00',1.72),('8348','2013-10-30','12:55:00',2.29),('8348','2013-10-30','13:00:00',1.1),('8348','2013-10-30','13:05:00',1.16),('8348','2013-10-30','13:10:00',1.35),('8348','2013-10-30','13:15:00',2),('8348','2013-10-30','13:20:00',2),('8348','2013-10-30','13:25:00',2.14),('8348','2013-10-30','13:30:00',1.42),('8348','2013-10-30','13:40:00',1.92),('8348','2013-10-30','13:45:00',2.03),('8348','2013-10-30','13:55:00',1.21),('8348','2013-10-30','14:00:00',1.97),('8348','2013-10-30','14:05:00',2.08),('8348','2013-10-30','14:10:00',2.05),('8348','2013-10-30','14:35:00',1.12),('8348','2013-10-30','14:40:00',1.6),('8348','2013-10-30','14:45:00',1.47),('8348','2013-10-30','15:15:00',1.11),('8348','2013-10-30','15:20:00',1.1),('8348','2013-10-29','08:45:00',1.07),('8348','2013-10-29','08:50:00',1.07),('8348','2013-10-29','08:55:00',1.13),('8348','2013-10-29','09:00:00',1.21),('8348','2013-10-29','09:05:00',1.28),('8348','2013-10-29','09:10:00',1.34),('8348','2013-10-29','09:15:00',1.41),('8348','2013-10-29','09:20:00',1.46),('8348','2013-10-29','09:25:00',1.53),('8348','2013-10-29','09:30:00',1.59),('8348','2013-10-29','09:35:00',1.62),('8348','2013-10-29','09:40:00',1.68),('8348','2013-10-29','09:45:00',1.7),('8348','2013-10-29','09:50:00',1.72),('8348','2013-10-29','09:55:00',1.68),('8348','2013-10-29','10:05:00',1.29),('8348','2013-10-29','10:10:00',1.04),('8348','2013-10-29','10:15:00',1.19),('8348','2013-10-29','10:25:00',1.56),('8348','2013-10-29','10:30:00',2.14),('8348','2013-10-29','10:35:00',2.37),('8348','2013-10-29','10:40:00',2.43),('8348','2013-10-29','10:45:00',2.49),('8348','2013-10-29','10:50:00',2.51),('8348','2013-10-29','10:55:00',2.5),('8348','2013-10-29','11:00:00',2.52),('8348','2013-10-29','11:05:00',2.36),('8348','2013-10-29','11:10:00',1.28),('8348','2013-10-29','11:20:00',1.09),('8348','2013-10-29','11:25:00',2.47),('8348','2013-10-29','11:30:00',2.45),('8348','2013-10-29','11:35:00',2.49),('8348','2013-10-29','11:40:00',2.45),('8348','2013-10-29','11:45:00',2.49),('8348','2013-10-29','11:50:00',2.5),('8348','2013-10-29','11:55:00',2.39),('8348','2013-10-29','12:00:00',2.34),('8348','2013-10-29','12:05:00',2.25),('8348','2013-10-29','12:10:00',2.32),('8348','2013-10-29','12:15:00',2.29),('8348','2013-10-29','12:20:00',2.27),('8348','2013-10-29','12:25:00',2.25),('8348','2013-10-29','12:30:00',2.25),('8348','2013-10-29','12:35:00',2.25),('8348','2013-10-29','12:40:00',2.3),('8348','2013-10-29','12:45:00',2.3),('8348','2013-10-29','12:50:00',2.23),('8348','2013-10-29','12:55:00',2.22),('8348','2013-10-29','13:00:00',2.13),('8348','2013-10-29','13:05:00',2.2),('8348','2013-10-29','13:10:00',2.14),('8348','2013-10-29','13:15:00',2.13),('8348','2013-10-29','13:20:00',2.15),('8348','2013-10-29','13:25:00',2.06),('8348','2013-10-29','13:30:00',2.11),('8348','2013-10-29','13:35:00',2.11),('8348','2013-10-29','13:40:00',2.05),('8348','2013-10-29','13:45:00',1.93),('8348','2013-10-29','13:50:00',1.94),('8348','2013-10-29','13:55:00',1.84),('8348','2013-10-29','14:00:00',1.71),('8348','2013-10-29','14:05:00',1.85),('8348','2013-10-29','14:10:00',1.81),('8348','2013-10-29','14:15:00',1.8),('8348','2013-10-29','14:20:00',1.77),('8348','2013-10-29','14:25:00',1.68),('8348','2013-10-29','14:30:00',1.62),('8348','2013-10-29','14:35:00',1.56),('8348','2013-10-29','14:40:00',1.51),('8348','2013-10-29','14:45:00',1.45),('8348','2013-10-29','14:50:00',1.41),('8348','2013-10-29','14:55:00',1.33),('8348','2013-10-29','15:00:00',1.27),('8348','2013-10-29','15:05:00',1.21),('8348','2013-10-29','15:10:00',1.16),('8348','2013-10-29','15:15:00',1.13),('8348','2013-10-29','15:20:00',1.06),('8348','2014-04-17','07:00:00',1.2),('8348','2014-04-17','07:05:00',1.32),('8348','2014-04-17','07:10:00',1.49),('8348','2014-04-17','07:15:00',1.71),('8348','2014-04-17','07:20:00',1.73),('8348','2014-04-17','07:25:00',1.87),('8348','2014-04-17','07:30:00',1.98),('8348','2014-04-17','07:35:00',2.1),('8348','2014-04-17','07:40:00',2.21),('8348','2014-04-17','07:45:00',2.36),('8348','2014-04-17','07:50:00',2.51),('8348','2014-04-17','07:55:00',2.32),('8348','2014-04-17','08:00:00',2.56),('8348','2014-04-17','08:05:00',3.15),('8348','2014-04-17','08:10:00',3.53),('8348','2014-04-17','08:15:00',3.52),('8348','2014-04-17','08:20:00',3.82),('8348','2014-04-17','08:25:00',4.1),('8348','2014-04-17','08:30:00',4.25),('8348','2014-04-17','08:35:00',4.44),('8348','2014-04-17','08:40:00',4.57),('8348','2014-04-17','08:45:00',4.71),('8348','2014-04-17','08:50:00',4.84),('8348','2014-04-17','08:55:00',5.01),('8348','2014-04-17','09:00:00',5.25),('8348','2014-04-17','09:05:00',5.75),('8348','2014-04-17','09:10:00',5.51),('8348','2014-04-17','09:15:00',4.36),('8348','2014-04-17','09:20:00',5.99),('8348','2014-04-17','09:25:00',6.33),('8348','2014-04-17','09:30:00',6.61),('8348','2014-04-17','09:35:00',7),('8348','2014-04-17','09:40:00',6.25),('8348','2014-04-17','09:45:00',5.58),('8348','2014-04-17','09:50:00',4.35),('8348','2014-04-17','09:55:00',4.02),('8348','2014-04-17','10:00:00',4.6),('8348','2014-04-17','10:05:00',5.12),('8348','2014-04-17','10:10:00',5.15),('8348','2014-04-17','10:15:00',4.37),('8348','2014-04-17','10:20:00',5.63),('8348','2014-04-17','10:25:00',6.45),('8348','2014-04-17','10:30:00',4.26),('8348','2014-04-17','10:35:00',4.21),('8348','2014-04-17','10:40:00',4.49),('8348','2014-04-17','10:45:00',6.52),('8348','2014-04-17','10:50:00',4.8),('8348','2014-04-17','10:55:00',3.76),('8348','2014-04-17','11:00:00',4.76),('8348','2014-04-17','11:05:00',5.12),('8348','2014-04-17','11:10:00',4.74),('8348','2014-04-17','11:15:00',4.1),('8348','2014-04-17','11:20:00',4.14),('8348','2014-04-17','11:25:00',4.48),('8348','2014-04-17','11:30:00',5.7),('8348','2014-04-17','11:35:00',6.42),('8348','2014-04-17','11:40:00',7.41),('8348','2014-04-17','11:45:00',7.09),('8348','2014-04-17','11:50:00',6.84),('8348','2014-04-17','11:55:00',7.6),('8348','2014-04-17','12:00:00',7.23),('8348','2014-04-17','12:05:00',3.92),('8348','2014-04-17','12:10:00',1.61),('8348','2014-04-17','12:15:00',1.65),('8348','2014-04-17','12:20:00',4.94),('8348','2014-04-17','12:25:00',8.19),('8348','2014-04-17','12:30:00',7.46),('8348','2014-04-17','12:35:00',2.26),('8348','2014-04-17','12:40:00',1.63),('8348','2014-04-17','12:45:00',1.72),('8348','2014-04-17','12:50:00',2.19),('8348','2014-04-17','12:55:00',2.72),('8348','2014-04-17','13:00:00',1.89),('8348','2014-04-17','13:05:00',2.1),('8348','2014-04-17','13:10:00',5.13),('8348','2014-04-17','13:15:00',5.26),('8348','2014-04-17','13:20:00',2.88),('8348','2014-04-17','13:25:00',3.58),('8348','2014-04-17','13:30:00',3.18),('8348','2014-04-17','13:35:00',4.12),('8348','2014-04-17','13:40:00',6.34),('8348','2014-04-17','13:45:00',2.28),('8348','2014-04-17','13:50:00',1.44),('8348','2014-04-17','13:55:00',1.3),('8348','2014-04-17','14:00:00',1.42),('8348','2014-04-17','14:05:00',1.55),('8348','2014-04-17','14:10:00',1.46),('8348','2014-04-17','14:15:00',1.47),('8348','2014-04-17','14:20:00',1.72),('8348','2014-04-17','14:25:00',2.29),('8348','2014-04-17','14:30:00',3.46),('8348','2014-04-17','14:35:00',4.21),('8348','2014-04-17','14:40:00',3.08),('8348','2014-04-17','14:45:00',2.29),('8348','2014-04-17','14:50:00',2.21),('8348','2014-04-17','14:55:00',2.51),('8348','2014-04-17','15:00:00',2.03),('8348','2014-04-17','15:05:00',1.65),('8348','2014-04-17','15:10:00',1.88),('8348','2014-04-17','15:15:00',1.89),('8348','2014-04-17','15:20:00',1.85),('8348','2014-04-17','15:25:00',2.1),('8348','2014-04-17','15:30:00',2.12),('8348','2014-04-17','15:35:00',1.95),('8348','2014-04-17','15:40:00',2.28),('8348','2014-04-17','15:45:00',2.87),('8348','2014-04-17','15:50:00',2.8),('8348','2014-04-17','15:55:00',2.15),('8348','2014-04-17','16:00:00',1.83),('8348','2014-04-17','16:05:00',1.54),('8348','2014-04-17','16:10:00',1.55),('8348','2014-04-17','16:15:00',1.78),('8348','2014-04-17','16:20:00',2),('8348','2014-04-17','16:25:00',1.72),('8348','2014-04-17','16:30:00',1.8),('8348','2014-04-17','16:35:00',1.89),('8348','2014-04-17','16:40:00',1.81),('8348','2014-04-17','16:45:00',1.61),('8348','2014-04-17','16:50:00',1.29),('8348','2014-04-17','16:55:00',1.23),('8348','2013-10-28','08:50:00',1.03),('8348','2013-10-28','08:55:00',1.13),('8348','2013-10-28','09:00:00',1.3),('8348','2013-10-28','09:05:00',1.52),('8348','2013-10-28','09:10:00',1.6),('8348','2013-10-28','09:15:00',1.2),('8348','2013-10-28','09:20:00',1.02),('8348','2013-10-28','09:25:00',1.75),('8348','2013-10-28','09:30:00',1.79),('8348','2013-10-28','09:35:00',1.04),('8348','2013-10-28','09:40:00',1.45),('8348','2013-10-28','09:45:00',1.81),('8348','2013-10-28','09:50:00',1.74),('8348','2013-10-28','10:50:00',2.25),('8348','2013-10-28','10:55:00',2.25),('8348','2013-10-28','11:00:00',2.29),('8348','2013-10-28','11:05:00',2.3),('8348','2013-10-28','11:10:00',2.33),('8348','2013-10-28','11:15:00',2.33),('8348','2013-10-28','11:20:00',2.35),('8348','2013-10-28','11:25:00',2.37),('8348','2013-10-28','11:30:00',2.37),('8348','2013-10-28','11:35:00',2.37),('8348','2013-10-28','11:40:00',2.37),('8348','2013-10-28','11:45:00',2.39),('8348','2013-10-28','11:50:00',2.4),('8348','2013-10-28','11:55:00',2.35),('8348','2013-10-28','12:00:00',2.09),('8348','2013-10-28','12:05:00',2.34),('8348','2013-10-28','12:10:00',2.21),('8348','2013-10-28','12:15:00',2.52),('8348','2013-10-28','12:20:00',2.6),('8348','2013-10-28','12:25:00',2.31),('8348','2013-10-28','12:30:00',2.59),('8348','2013-10-28','12:35:00',2.89),('8348','2013-10-28','12:40:00',2.6),('8348','2013-10-28','12:45:00',2.65),('8348','2013-10-28','12:50:00',2.66),('8348','2013-10-28','12:55:00',2.48),('8348','2013-10-28','13:00:00',2.4),('8348','2013-10-28','13:05:00',2.38),('8348','2013-10-28','13:10:00',2.38),('8348','2013-10-28','13:15:00',2.34),('8348','2013-10-28','13:20:00',2.29),('8348','2013-10-28','13:25:00',2.29),('8348','2013-10-28','13:30:00',2.25),('8348','2013-10-28','13:35:00',2.18),('8348','2013-10-28','13:40:00',2.14),('8348','2013-10-28','13:45:00',2.09),('8348','2013-10-28','13:50:00',2.16),('8348','2013-10-28','13:55:00',2.13),('8348','2013-10-28','14:00:00',2.17),('8348','2013-10-28','14:05:00',2.12),('8348','2013-10-28','14:10:00',2.11),('8348','2013-10-28','14:15:00',2.03),('8348','2013-10-28','14:20:00',1.88),('8348','2013-10-28','14:25:00',2.07),('8348','2013-10-28','14:30:00',1.63),('8348','2013-10-28','14:35:00',1.83),('8348','2013-10-28','14:40:00',1.19),('8348','2013-10-28','14:45:00',1.73),('8348','2013-10-28','14:50:00',1.57),('8348','2013-10-28','14:55:00',1.51),('8348','2013-10-28','15:00:00',1.46),('8348','2013-10-28','15:05:00',1.41),('8348','2013-10-28','15:10:00',1.34),('8348','2013-10-28','15:15:00',1.22),('8348','2013-10-28','15:45:00',1.05),('8348','2013-10-27','10:10:00',1),('8348','2013-10-27','10:15:00',1.06),('8348','2013-10-27','10:20:00',1.19),('8348','2013-10-27','10:25:00',1.12),('8348','2013-10-27','10:30:00',1.1),('8348','2013-10-27','10:35:00',1.13),('8348','2013-10-27','10:40:00',1.15),('8348','2013-10-27','10:45:00',1.32),('8348','2013-10-27','10:50:00',1.29),('8348','2013-10-27','10:55:00',1.13),('8348','2013-10-27','11:00:00',1.09),('8348','2013-10-27','11:35:00',1.34),('8348','2013-10-27','11:40:00',2.06),('8348','2013-10-27','11:45:00',2.67),('8348','2013-10-27','11:50:00',1.22),('8348','2013-10-27','11:55:00',1.01),('8348','2013-10-27','12:00:00',1.03),('8348','2013-10-27','12:05:00',1.14),('8348','2013-10-27','12:15:00',1.21),('8348','2013-10-27','12:20:00',2.2),('8348','2013-10-27','12:25:00',2.1),('8348','2013-10-27','12:30:00',2.24),('8348','2013-10-27','12:35:00',2.68),('8348','2013-10-27','12:40:00',1.45),('8348','2013-10-27','12:45:00',1.74),('8348','2013-10-27','12:50:00',1.88),('8348','2013-10-27','12:55:00',2.07),('8348','2013-10-27','13:00:00',1.11),('8348','2013-10-27','13:05:00',1.13),('8348','2013-10-27','13:10:00',1.93),('8348','2013-10-27','13:25:00',2.3),('8348','2013-10-27','13:30:00',2.19),('8348','2013-10-27','13:35:00',2.19),('8348','2013-10-27','13:40:00',1.24),('8348','2013-10-27','14:00:00',1.13),('8348','2013-10-27','14:15:00',1.32),('8348','2013-10-27','14:20:00',1.01),('8348','2013-10-27','14:25:00',1.16),('8348','2013-10-27','14:30:00',1.7),('8348','2013-10-27','14:35:00',1.22),('8348','2013-10-27','14:40:00',1.39),('8348','2013-10-27','14:45:00',1.06),('8348','2013-10-27','15:00:00',1.34),('8348','2013-10-27','15:05:00',1.03),('8348','2013-10-27','15:10:00',1.31),('8348','2013-10-27','15:15:00',1.25),('8348','2013-10-27','15:20:00',1.19),('8348','2013-10-27','15:25:00',1.11),('8348','2013-10-27','15:30:00',1),('8348','2013-10-26','09:45:00',1.03),('8348','2013-10-26','09:50:00',1.1),('8348','2013-10-26','09:55:00',1.19),('8348','2013-10-26','10:00:00',1.26),('8348','2013-10-26','10:05:00',1.34),('8348','2013-10-26','10:10:00',1.4),('8348','2013-10-26','10:15:00',1.45),('8348','2013-10-26','10:20:00',1.5),('8348','2013-10-26','10:25:00',1.55),('8348','2013-10-26','10:30:00',1.6),('8348','2013-10-26','10:35:00',1.65),('8348','2013-10-26','10:40:00',1.7),('8348','2013-10-26','10:45:00',1.75),('8348','2013-10-26','10:50:00',1.8),('8348','2013-10-26','10:55:00',1.84),('8348','2013-10-26','11:00:00',1.88),('8348','2013-10-26','11:05:00',1.93),('8348','2013-10-26','11:10:00',1.95),('8348','2013-10-26','11:15:00',1.97),('8348','2013-10-26','11:20:00',1.98),('8348','2013-10-26','11:25:00',2.03),('8348','2013-10-26','11:30:00',2.07),('8348','2013-10-26','11:35:00',2.08),('8348','2013-10-26','11:40:00',2.1),('8348','2013-10-26','11:45:00',2.16),('8348','2013-10-26','11:50:00',2.17),('8348','2013-10-26','11:55:00',2.15),('8348','2013-10-26','12:00:00',2.18),('8348','2013-10-26','12:05:00',2.25),('8348','2013-10-26','12:10:00',2.27),('8348','2013-10-26','12:15:00',2.26),('8348','2013-10-26','12:20:00',2.29),('8348','2013-10-26','12:25:00',2.3),('8348','2013-10-26','12:30:00',2.29),('8348','2013-10-26','12:35:00',2.25),('8348','2013-10-26','12:40:00',2.32),('8348','2013-10-26','12:45:00',2.31),('8348','2013-10-26','12:50:00',2.29),('8348','2013-10-26','12:55:00',2.33),('8348','2013-10-26','13:00:00',2.3),('8348','2013-10-26','13:05:00',2.31),('8348','2013-10-26','13:10:00',2.08),('8348','2013-10-26','13:15:00',2.19),('8348','2013-10-26','13:20:00',2.25),('8348','2013-10-26','13:25:00',1.75),('8348','2013-10-26','13:30:00',2.33),('8348','2013-10-26','13:35:00',2.45),('8348','2013-10-26','13:40:00',2.41),('8348','2013-10-26','13:45:00',2.2),('8348','2013-10-26','13:50:00',2.23),('8348','2013-10-26','13:55:00',2.2),('8348','2013-10-26','14:00:00',2.16),('8348','2013-10-26','14:05:00',1.92),('8348','2013-10-26','14:10:00',2.15),('8348','2013-10-26','14:15:00',1.96),('8348','2013-10-26','14:20:00',1.81),('8348','2013-10-26','14:25:00',1.01),('8348','2013-10-26','14:30:00',1.59),('8348','2013-10-26','14:35:00',2.12),('8348','2013-10-26','14:40:00',1.88),('8348','2013-10-26','14:45:00',1.96),('8348','2013-10-26','14:50:00',1.9),('8348','2013-10-26','14:55:00',1.83),('8348','2013-10-26','15:00:00',1.82),('8348','2013-10-26','15:05:00',1.78),('8348','2013-10-26','15:10:00',1.76),('8348','2013-10-26','15:15:00',1.65),('8348','2013-10-26','15:20:00',1.47),('8348','2013-10-26','15:25:00',1.51),('8348','2013-10-26','15:30:00',1.52),('8348','2013-10-26','15:35:00',1.68),('8348','2013-10-26','15:40:00',1.59),('8348','2013-10-26','15:45:00',1.56),('8348','2013-10-26','15:50:00',1.44),('8348','2013-10-26','15:55:00',1.26),('8348','2013-10-26','16:00:00',1.19),('8348','2013-10-26','16:05:00',1.16),('8348','2013-10-26','16:10:00',1.16),('8348','2013-10-26','16:15:00',1.07),('8348','2013-10-26','16:20:00',1.07),('8348','2013-10-25','09:40:00',1.02),('8348','2013-10-25','09:45:00',1.08),('8348','2013-10-25','09:50:00',1.14),('8348','2013-10-25','09:55:00',1.2),('8348','2013-10-25','10:00:00',1.29),('8348','2013-10-25','10:05:00',1.36),('8348','2013-10-25','10:10:00',1.42),('8348','2013-10-25','10:15:00',1.47),('8348','2013-10-25','10:20:00',1.53),('8348','2013-10-25','10:25:00',1.6),('8348','2013-10-25','10:30:00',1.65),('8348','2013-10-25','10:35:00',1.7),('8348','2013-10-25','10:40:00',1.73),('8348','2013-10-25','10:45:00',1.77),('8348','2013-10-25','10:50:00',1.82),('8348','2013-10-25','10:55:00',1.86),('8348','2013-10-25','11:00:00',1.89),('8348','2013-10-25','11:05:00',1.94),('8348','2013-10-25','11:10:00',1.96),('8348','2013-10-25','11:15:00',1.99),('8348','2013-10-25','11:20:00',2.02),('8348','2013-10-25','11:25:00',2.04),('8348','2013-10-25','11:30:00',2.11),('8348','2013-10-25','11:35:00',2.14),('8348','2013-10-25','11:40:00',2.17),('8348','2013-10-25','11:45:00',2.2),('8348','2013-10-25','11:50:00',2.24),('8348','2013-10-25','11:55:00',2.27),('8348','2013-10-25','12:00:00',2.29),('8348','2013-10-25','12:05:00',2.3),('8348','2013-10-25','12:10:00',2.34),('8348','2013-10-25','12:15:00',2.35),('8348','2013-10-25','12:20:00',2.38),('8348','2013-10-25','12:25:00',2.4),('8348','2013-10-25','12:30:00',2.41),('8348','2013-10-25','12:35:00',2.42),('8348','2013-10-25','12:40:00',2.41),('8348','2013-10-25','12:45:00',2.4),('8348','2013-10-25','12:50:00',2.41),('8348','2013-10-25','12:55:00',2.43),('8348','2013-10-25','13:00:00',2.44),('8348','2013-10-25','13:05:00',2.43),('8348','2013-10-25','13:10:00',2.42),('8348','2013-10-25','13:15:00',2.38),('8348','2013-10-25','13:20:00',2.36),('8348','2013-10-25','13:25:00',2.34),('8348','2013-10-25','13:30:00',2.37),('8348','2013-10-25','13:35:00',2.37),('8348','2013-10-25','13:40:00',2.35),('8348','2013-10-25','13:45:00',2.33),('8348','2013-10-25','13:50:00',2.3),('8348','2013-10-25','13:55:00',2.29),('8348','2013-10-25','14:00:00',2.3),('8348','2013-10-25','14:05:00',2.3),('8348','2013-10-25','14:10:00',2.29),('8348','2013-10-25','14:15:00',2.27),('8348','2013-10-25','14:20:00',2.24),('8348','2013-10-25','14:25:00',2.22),('8348','2013-10-25','14:30:00',2.23),('8348','2013-10-25','14:35:00',2.21),('8348','2013-10-25','14:40:00',2.16),('8348','2013-10-25','14:45:00',2.11),('8348','2013-10-25','14:50:00',2.09),('8348','2013-10-25','14:55:00',2.06),('8348','2013-10-25','15:00:00',2.01),('8348','2013-10-25','15:05:00',1.97),('8348','2013-10-25','15:10:00',1.91),('8348','2013-10-25','15:15:00',1.85),('8348','2013-10-25','15:20:00',1.82),('8348','2013-10-25','15:25:00',1.74),('8348','2013-10-25','15:30:00',1.67),('8348','2013-10-25','15:35:00',1.64),('8348','2013-10-25','15:40:00',1.63),('8348','2013-10-25','15:45:00',1.59),('8348','2013-10-25','15:50:00',1.52),('8348','2013-10-25','15:55:00',1.48),('8348','2013-10-25','16:00:00',1.43),('8348','2013-10-25','16:05:00',1.39),('8348','2013-10-25','16:10:00',1.32),('8348','2013-10-25','16:15:00',1.27),('8348','2013-10-25','16:20:00',1.22),('8348','2013-10-25','16:25:00',1.16),('8348','2013-10-25','16:30:00',1.1),('8348','2013-10-25','16:35:00',1.03),('8348','2013-10-24','09:15:00',1.07),('8348','2013-10-24','10:35:00',1.46),('8348','2013-10-24','10:40:00',1.03),('8348','2013-10-24','10:45:00',1.94),('8348','2013-10-24','10:50:00',1.52),('8348','2013-10-24','10:55:00',1.79),('8348','2013-10-24','11:00:00',2.25),('8348','2013-10-24','11:05:00',2.44),('8348','2013-10-24','11:10:00',2.33),('8348','2013-10-24','11:15:00',1.6),('8348','2013-10-24','11:20:00',1.36),('8348','2013-10-24','11:25:00',1.74),('8348','2013-10-24','11:30:00',1.29),('8348','2013-10-24','11:45:00',1.05),('8348','2013-10-24','11:50:00',1.66),('8348','2013-10-24','11:55:00',2.23),('8348','2013-10-24','12:00:00',1.46),('8348','2013-10-24','12:05:00',1.23),('8348','2013-10-24','12:10:00',1.17),('8348','2013-10-24','12:15:00',1.17),('8348','2013-10-24','12:20:00',1.23),('8348','2013-10-24','12:25:00',1.34),('8348','2013-10-24','12:30:00',1.39),('8348','2013-10-24','12:35:00',1.5),('8348','2013-10-24','12:40:00',1.68),('8348','2013-10-24','12:45:00',1.84),('8348','2013-10-24','12:50:00',1.71),('8348','2013-10-24','12:55:00',2.16),('8348','2013-10-24','13:00:00',2.53),('8348','2013-10-24','13:05:00',2.73),('8348','2013-10-24','13:10:00',2.38),('8348','2013-10-24','13:15:00',1.79),('8348','2013-10-24','13:20:00',2.19),('8348','2013-10-24','13:25:00',1.78),('8348','2013-10-24','13:30:00',1.17),('8348','2013-10-24','13:35:00',1.13),('8348','2013-10-24','13:40:00',1.14),('8348','2013-10-24','13:45:00',1.22),('8348','2013-10-24','13:50:00',1.4),('8348','2013-10-24','13:55:00',1.86),('8348','2013-10-24','14:00:00',2.06),('8348','2013-10-24','14:05:00',1.45),('8348','2013-10-24','14:10:00',1.24),('8348','2013-10-24','14:15:00',1.19),('8348','2013-10-24','14:20:00',1.26),('8348','2013-10-24','14:25:00',1.32),('8348','2013-10-24','14:30:00',1.37),('8348','2013-10-24','14:35:00',1.71),('8348','2013-10-24','14:40:00',1.81),('8348','2013-10-24','14:45:00',1.85),('8348','2013-10-24','14:50:00',1.8),('8348','2013-10-24','15:05:00',1.21),('8348','2013-10-24','15:10:00',2.13),('8348','2013-10-24','15:15:00',1.1),('8348','2013-10-24','15:20:00',1.1),('8348','2013-10-24','15:25:00',1.07),('8348','2013-10-24','15:30:00',1.09),('8348','2013-10-24','15:35:00',2.07),('8348','2013-10-24','15:40:00',1.98),('8348','2013-10-24','15:45:00',1.69),('8348','2013-10-24','15:50:00',1.16),('8348','2013-10-23','10:40:00',1.13),('8348','2013-10-23','10:45:00',1.12),('8348','2013-10-23','10:50:00',1.35),('8348','2013-10-23','10:55:00',1.32),('8348','2013-10-23','11:00:00',1.21),('8348','2013-10-23','11:05:00',1.61),('8348','2013-10-23','11:10:00',1.14),('8348','2013-10-23','11:15:00',1.69),('8348','2013-10-23','11:20:00',2.18),('8348','2013-10-23','11:25:00',2.08),('8348','2013-10-23','11:30:00',2.13),('8348','2013-10-23','11:35:00',2.12),('8348','2013-10-23','11:40:00',2.19),('8348','2013-10-23','11:45:00',2.2),('8348','2013-10-23','11:50:00',1.7),('8348','2013-10-23','11:55:00',2.19),('8348','2013-10-23','12:00:00',2.27),('8348','2013-10-23','12:05:00',2.25),('8348','2013-10-23','12:10:00',2.17),('8348','2013-10-23','12:15:00',2.06),('8348','2013-10-23','12:20:00',2.04),('8348','2013-10-23','12:25:00',2.34),('8348','2013-10-23','12:30:00',2.31),('8348','2013-10-23','12:35:00',2.28),('8348','2013-10-23','12:40:00',2.22),('8348','2013-10-23','12:45:00',2.05),('8348','2013-10-23','12:50:00',1.5),('8348','2013-10-23','12:55:00',1.67),('8348','2013-10-23','13:00:00',2.23),('8348','2013-10-23','13:05:00',2.17),('8348','2013-10-23','13:10:00',2.29),('8348','2013-10-23','13:15:00',2.23),('8348','2013-10-23','13:20:00',2.19),('8348','2013-10-23','13:25:00',2.3),('8348','2013-10-23','13:30:00',2.22),('8348','2013-10-23','13:35:00',2.2),('8348','2013-10-23','13:40:00',2.19),('8348','2013-10-23','13:45:00',2.08),('8348','2013-10-23','13:50:00',1.86),('8348','2013-10-23','13:55:00',1.84),('8348','2013-10-23','14:00:00',1.94),('8348','2013-10-23','14:05:00',1.71),('8348','2013-10-23','14:10:00',1.96),('8348','2013-10-23','14:15:00',2.18),('8348','2013-10-23','14:20:00',2.13),('8348','2013-10-23','14:25:00',1.93),('8348','2013-10-23','14:30:00',1.97),('8348','2013-10-23','14:35:00',1.9),('8348','2013-10-23','14:40:00',2.09),('8348','2013-10-23','14:45:00',1.97),('8348','2013-10-23','14:50:00',1.77),('8348','2013-10-23','14:55:00',1.57),('8348','2013-10-23','15:00:00',1.84),('8348','2013-10-23','15:05:00',1.97),('8348','2013-10-23','15:10:00',1.9),('8348','2013-10-23','15:15:00',1.91),('8348','2013-10-23','15:20:00',1.89),('8348','2013-10-23','15:25:00',1.85),('8348','2013-10-23','15:30:00',1.74),('8348','2013-10-23','15:35:00',1.63),('8348','2013-10-23','15:40:00',1.76),('8348','2013-10-23','15:45:00',1.72),('8348','2013-10-23','15:50:00',1.56),('8348','2013-10-23','15:55:00',1.17),('8348','2013-10-23','16:00:00',1.01),('8348','2013-10-22','09:40:00',1.04),('8348','2013-10-22','09:45:00',1.1),('8348','2013-10-22','09:50:00',1.19),('8348','2013-10-22','09:55:00',1.25),('8348','2013-10-22','10:00:00',1.33),('8348','2013-10-22','10:05:00',1.39),('8348','2013-10-22','10:10:00',1.44),('8348','2013-10-22','10:15:00',1.49),('8348','2013-10-22','10:20:00',1.55),('8348','2013-10-22','10:25:00',1.6),('8348','2013-10-22','10:30:00',1.65),('8348','2013-10-22','10:35:00',1.71),('8348','2013-10-22','10:40:00',1.75),('8348','2013-10-22','10:45:00',1.78),('8348','2013-10-22','10:50:00',1.81),('8348','2013-10-22','10:55:00',1.85),('8348','2013-10-22','11:00:00',1.89),('8348','2013-10-22','11:05:00',1.94),('8348','2013-10-22','11:10:00',1.97),('8348','2013-10-22','11:15:00',1.98),('8348','2013-10-22','11:20:00',2),('8348','2013-10-22','11:25:00',2.02),('8348','2013-10-22','11:30:00',2.05),('8348','2013-10-22','11:35:00',2.05),('8348','2013-10-22','11:40:00',2.08),('8348','2013-10-22','11:45:00',2.1),('8348','2013-10-22','11:50:00',2.13),('8348','2013-10-22','11:55:00',2.18),('8348','2013-10-22','12:00:00',2.21),('8348','2013-10-22','12:05:00',2.21),('8348','2013-10-22','12:10:00',2.22),('8348','2013-10-22','12:15:00',2.25),('8348','2013-10-22','12:20:00',2.26),('8348','2013-10-22','12:25:00',2.23),('8348','2013-10-22','12:30:00',2.28),('8348','2013-10-22','12:35:00',2.3),('8348','2013-10-22','12:40:00',2.29),('8348','2013-10-22','12:45:00',2.21),('8348','2013-10-22','12:50:00',2.3),('8348','2013-10-22','12:55:00',2.26),('8348','2013-10-22','13:00:00',2.2),('8348','2013-10-22','13:05:00',2.17),('8348','2013-10-22','13:10:00',2.33),('8348','2013-10-22','13:15:00',2.28),('8348','2013-10-22','13:20:00',2.35),('8348','2013-10-22','13:25:00',2.37),('8348','2013-10-22','13:30:00',2.36),('8348','2013-10-22','13:35:00',2.32),('8348','2013-10-22','13:40:00',2.3),('8348','2013-10-22','13:45:00',2.19),('8348','2013-10-22','13:50:00',2.17),('8348','2013-10-22','13:55:00',2.2),('8348','2013-10-22','14:00:00',2.14),('8348','2013-10-22','14:05:00',2.25),('8348','2013-10-22','14:10:00',2.27),('8348','2013-10-22','14:15:00',2.29),('8348','2013-10-22','14:20:00',2.34),('8348','2013-10-22','14:25:00',1.91),('8348','2013-10-22','14:30:00',1.87),('8348','2013-10-22','14:35:00',1.82),('8348','2013-10-22','14:40:00',1.71),('8348','2013-10-22','14:45:00',1.87),('8348','2013-10-22','14:50:00',2),('8348','2013-10-22','14:55:00',1.94),('8348','2013-10-22','15:00:00',1.92),('8348','2013-10-22','15:05:00',1.89),('8348','2013-10-22','15:10:00',1.85),('8348','2013-10-22','15:15:00',1.68),('8348','2013-10-22','15:20:00',1.75),('8348','2013-10-22','15:25:00',1.69),('8348','2013-10-22','15:30:00',1.72),('8348','2013-10-22','15:35:00',1.7),('8348','2013-10-22','15:40:00',1.68),('8348','2013-10-22','15:45:00',1.57),('8348','2013-10-22','15:50:00',1.54),('8348','2013-10-22','15:55:00',1.41),('8348','2013-10-22','16:00:00',1.35),('8348','2013-10-22','16:05:00',1.27),('8348','2013-10-22','16:10:00',1.3),('8348','2013-10-22','16:15:00',1.2),('8348','2013-10-22','16:20:00',1.13),('8348','2013-10-22','16:25:00',1.1),('8348','2013-10-22','16:30:00',1.05),('8348','2013-10-21','09:40:00',1.05),('8348','2013-10-21','09:45:00',1),('8348','2013-10-21','09:50:00',1.08),('8348','2013-10-21','09:55:00',1.25),('8348','2013-10-21','10:00:00',1.24),('8348','2013-10-21','10:05:00',1.46),('8348','2013-10-21','10:10:00',1.51),('8348','2013-10-21','10:15:00',1.58),('8348','2013-10-21','10:20:00',1.6),('8348','2013-10-21','10:25:00',1.7),('8348','2013-10-21','10:30:00',1.65),('8348','2013-10-21','10:35:00',1.71),('8348','2013-10-21','10:40:00',1.69),('8348','2013-10-21','10:45:00',1.74),('8348','2013-10-21','10:50:00',1.85),('8348','2013-10-21','10:55:00',1.83),('8348','2013-10-21','11:00:00',1.99),('8348','2013-10-21','11:05:00',1.73),('8348','2013-10-21','11:10:00',1.78),('8348','2013-10-21','11:15:00',2.12),('8348','2013-10-21','11:20:00',2.11),('8348','2013-10-21','11:25:00',2.12),('8348','2013-10-21','11:30:00',2.18),('8348','2013-10-21','11:35:00',2.18),('8348','2013-10-21','11:40:00',2.16),('8348','2013-10-21','11:45:00',2.26),('8348','2013-10-21','11:50:00',2.28),('8348','2013-10-21','11:55:00',2.29),('8348','2013-10-21','12:00:00',2.37),('8348','2013-10-21','12:05:00',2.4),('8348','2013-10-21','12:10:00',2.43),('8348','2013-10-21','12:15:00',2.43),('8348','2013-10-21','12:20:00',2.42),('8348','2013-10-21','12:25:00',2.41),('8348','2013-10-21','12:30:00',2.3),('8348','2013-10-21','12:35:00',2.4),('8348','2013-10-21','12:40:00',2.46),('8348','2013-10-21','12:45:00',2.46),('8348','2013-10-21','12:50:00',2.45),('8348','2013-10-21','12:55:00',2.45),('8348','2013-10-21','13:00:00',2.42),('8348','2013-10-21','13:05:00',2.4),('8348','2013-10-21','13:10:00',2.33),('8348','2013-10-21','13:15:00',2.39),('8348','2013-10-21','13:20:00',2.37),('8348','2013-10-21','13:25:00',2.41),('8348','2013-10-21','13:30:00',2.48),('8348','2013-10-21','13:35:00',2.45),('8348','2013-10-21','13:40:00',2.42),('8348','2013-10-21','13:45:00',2.39),('8348','2013-10-21','13:50:00',2.32),('8348','2013-10-21','13:55:00',2.31),('8348','2013-10-21','14:00:00',2.3),('8348','2013-10-21','14:05:00',2.36),('8348','2013-10-21','14:10:00',2.31),('8348','2013-10-21','14:15:00',2.28),('8348','2013-10-21','14:20:00',2.29),('8348','2013-10-21','14:25:00',2.24),('8348','2013-10-21','14:30:00',2.22),('8348','2013-10-21','14:35:00',2.21),('8348','2013-10-21','14:40:00',2.09),('8348','2013-10-21','14:45:00',2.04),('8348','2013-10-21','14:50:00',2),('8348','2013-10-21','14:55:00',2),('8348','2013-10-21','15:00:00',2.03),('8348','2013-10-21','15:05:00',1.96),('8348','2013-10-21','15:10:00',1.95),('8348','2013-10-21','15:15:00',1.92),('8348','2013-10-21','15:20:00',1.87),('8348','2013-10-21','15:25:00',1.83),('8348','2013-10-21','15:30:00',1.71),('8348','2013-10-21','15:35:00',1.69),('8348','2013-10-21','15:40:00',1.7),('8348','2013-10-21','15:45:00',1.63),('8348','2013-10-21','15:50:00',1.57),('8348','2013-10-21','15:55:00',1.52),('8348','2013-10-21','16:00:00',1.5),('8348','2013-10-21','16:05:00',1.43),('8348','2013-10-21','16:10:00',1.4),('8348','2013-10-21','16:15:00',1.32),('8348','2013-10-21','16:20:00',1.26),('8348','2013-10-21','16:25:00',1.19),('8348','2013-10-21','16:30:00',1.12),('8348','2013-10-21','16:35:00',1.06),('8348','2013-10-20','09:30:00',1.01),('8348','2013-10-20','09:35:00',1.07),('8348','2013-10-20','09:40:00',1.12),('8348','2013-10-20','09:45:00',1.19),('8348','2013-10-20','09:50:00',1.26),('8348','2013-10-20','09:55:00',1.35),('8348','2013-10-20','10:00:00',1.43),('8348','2013-10-20','10:05:00',1.49),('8348','2013-10-20','10:10:00',1.55),('8348','2013-10-20','10:15:00',1.6),('8348','2013-10-20','10:20:00',1.65),('8348','2013-10-20','10:25:00',1.7),('8348','2013-10-20','10:30:00',1.75),('8348','2013-10-20','10:35:00',1.81),('8348','2013-10-20','10:40:00',1.84),('8348','2013-10-20','10:45:00',1.88),('8348','2013-10-20','10:50:00',1.92),('8348','2013-10-20','10:55:00',1.97),('8348','2013-10-20','11:00:00',2.01),('8348','2013-10-20','11:05:00',2.07),('8348','2013-10-20','11:10:00',2.1),('8348','2013-10-20','11:15:00',2.11),('8348','2013-10-20','11:20:00',2.17),('8348','2013-10-20','11:25:00',2.19),('8348','2013-10-20','11:30:00',2.23),('8348','2013-10-20','11:35:00',2.27),('8348','2013-10-20','11:40:00',2.28),('8348','2013-10-20','11:45:00',2.31),('8348','2013-10-20','11:50:00',2.35),('8348','2013-10-20','11:55:00',2.4),('8348','2013-10-20','12:00:00',2.37),('8348','2013-10-20','12:05:00',2.42),('8348','2013-10-20','12:10:00',2.42),('8348','2013-10-20','12:15:00',2.55),('8348','2013-10-20','12:20:00',2.52),('8348','2013-10-20','12:30:00',2.69),('8348','2013-10-20','12:35:00',2.53),('8348','2013-10-20','12:40:00',1.53),('8348','2013-10-20','12:45:00',1.53),('8348','2013-10-20','12:50:00',1.97),('8348','2013-10-20','12:55:00',1.89),('8348','2013-10-20','13:00:00',1.63),('8348','2013-10-20','13:05:00',2.9),('8348','2013-10-20','13:10:00',2.61),('8348','2013-10-20','13:20:00',1.04),('8348','2013-10-20','13:25:00',1.62),('8348','2013-10-20','13:30:00',1.38),('8348','2013-10-20','13:35:00',2.02),('8348','2013-10-20','13:40:00',1.08),('8348','2013-10-20','13:45:00',1.68),('8348','2013-10-20','13:55:00',2.36),('8348','2013-10-20','14:10:00',1.07),('8348','2013-10-20','16:50:00',1.17),('8348','2013-10-20','16:55:00',1.23),('8348','2013-10-20','17:00:00',1.16),('8348','2013-10-20','17:05:00',1.05),('8348','2013-10-19','09:15:00',1.1),('8348','2013-10-19','09:20:00',1.12),('8348','2013-10-19','09:25:00',1.15),('8348','2013-10-19','09:30:00',1.18),('8348','2013-10-19','09:35:00',1.25),('8348','2013-10-19','09:40:00',1.32),('8348','2013-10-19','09:45:00',1.42),('8348','2013-10-19','09:50:00',1.51),('8348','2013-10-19','09:55:00',1.61),('8348','2013-10-19','10:00:00',1.61),('8348','2013-10-19','10:05:00',1.58),('8348','2013-10-19','10:10:00',1.7),('8348','2013-10-19','10:15:00',1.71),('8348','2013-10-19','10:20:00',1.88),('8348','2013-10-19','10:25:00',1.95),('8348','2013-10-19','10:30:00',2),('8348','2013-10-19','10:35:00',2.02),('8348','2013-10-19','10:40:00',2.04),('8348','2013-10-19','10:45:00',2.05),('8348','2013-10-19','10:50:00',2.11),('8348','2013-10-19','10:55:00',2.19),('8348','2013-10-19','11:00:00',2.18),('8348','2013-10-19','11:05:00',2.08),('8348','2013-10-19','11:10:00',1.06),('8348','2013-10-19','11:20:00',1.98),('8348','2013-10-19','11:25:00',2.6),('8348','2013-10-19','11:30:00',2.49),('8348','2013-10-19','11:35:00',2.51),('8348','2013-10-19','11:40:00',2.39),('8348','2013-10-19','11:45:00',2.54),('8348','2013-10-19','11:50:00',2.41),('8348','2013-10-19','11:55:00',2.5),('8348','2013-10-19','12:00:00',2.65),('8348','2013-10-19','12:05:00',2.66),('8348','2013-10-19','12:10:00',2.63),('8348','2013-10-19','12:15:00',2.66),('8348','2013-10-19','12:20:00',2.65),('8348','2013-10-19','12:25:00',2.44),('8348','2013-10-19','12:30:00',2.65),('8348','2013-10-19','12:35:00',2.73),('8348','2013-10-19','12:40:00',2.83),('8348','2013-10-19','12:45:00',2.89),('8348','2013-10-19','12:50:00',2.92),('8348','2013-10-19','12:55:00',3),('8348','2013-10-19','13:00:00',3.08),('8348','2013-10-19','13:05:00',2.3),('8348','2013-10-19','13:10:00',2.78),('8348','2013-10-19','13:15:00',2.63),('8348','2013-10-19','13:20:00',2.68),('8348','2013-10-19','13:25:00',3.01),('8348','2013-10-19','13:30:00',3.01),('8348','2013-10-19','13:35:00',2.24),('8348','2013-10-19','13:40:00',1.96),('8348','2013-10-19','13:45:00',2.2),('8348','2013-10-19','13:50:00',2.44),('8348','2013-10-19','13:55:00',3.09),('8348','2013-10-19','14:00:00',2.46),('8348','2013-10-19','14:05:00',1.99),('8348','2013-10-19','14:10:00',1.65),('8348','2013-10-19','14:15:00',2.03),('8348','2013-10-19','14:20:00',1.73),('8348','2013-10-19','14:25:00',1.57),('8348','2013-10-19','14:30:00',2.16),('8348','2013-10-19','14:35:00',2.78),('8348','2013-10-19','14:40:00',2.08),('8348','2013-10-19','14:45:00',1.8),('8348','2013-10-19','14:50:00',2.59),('8348','2013-10-19','14:55:00',2.48),('8348','2013-10-19','15:00:00',2.41),('8348','2013-10-19','15:05:00',2.34),('8348','2013-10-19','15:10:00',2.31),('8348','2013-10-19','15:15:00',2.25),('8348','2013-10-19','15:20:00',2.1),('8348','2013-10-19','15:25:00',2.04),('8348','2013-10-19','15:30:00',1.94),('8348','2013-10-19','15:35:00',1.96),('8348','2013-10-19','15:40:00',1.79),('8348','2013-10-19','15:45:00',1.52),('8348','2013-10-19','15:50:00',1.69),('8348','2013-10-19','15:55:00',1.83),('8348','2013-10-19','16:00:00',1.51),('8348','2013-10-19','16:05:00',1.61),('8348','2013-10-19','16:10:00',1.55),('8348','2013-10-19','16:15:00',1.67),('8348','2013-10-19','16:20:00',1.46),('8348','2013-10-19','16:25:00',1.13),('8348','2013-10-19','16:30:00',1.44),('8348','2013-10-19','16:35:00',1.45),('8348','2013-10-19','16:40:00',1.4),('8348','2013-10-19','16:45:00',1.26),('8348','2013-10-19','16:50:00',1.21),('8348','2014-05-04','06:45:00',1.24),('8348','2014-05-04','06:50:00',1.54),('8348','2014-05-04','06:55:00',1.64),('8348','2014-05-04','07:00:00',1.72),('8348','2014-05-04','07:05:00',1.9),('8348','2014-05-04','07:10:00',1.96),('8348','2014-05-04','07:15:00',2.13),('8348','2014-05-04','07:20:00',2.25),('8348','2014-05-04','07:25:00',2.42),('8348','2014-05-04','07:30:00',2.79),('8348','2014-05-04','07:35:00',2.93),('8348','2014-05-04','07:40:00',2.97),('8348','2014-05-04','07:45:00',1.88),('8348','2014-05-04','07:50:00',2.33),('8348','2014-05-04','07:55:00',2.13),('8348','2014-05-04','08:00:00',2.37),('8348','2014-05-04','08:05:00',3.69),('8348','2014-05-04','08:10:00',3.52),('8348','2014-05-04','08:15:00',3.85),('8348','2014-05-04','08:20:00',5.95),('8348','2014-05-04','08:25:00',5.32),('8348','2014-05-04','08:30:00',2.8),('8348','2014-05-04','08:35:00',2.12),('8348','2014-05-04','08:40:00',2.62),('8348','2014-05-04','08:45:00',3.88),('8348','2014-05-04','08:50:00',3.48),('8348','2014-05-04','08:55:00',4.07),('8348','2014-05-04','09:00:00',6.25),('8348','2014-05-04','09:05:00',5.13),('8348','2014-05-04','09:10:00',5.41),('8348','2014-05-04','09:15:00',4.29),('8348','2014-05-04','09:20:00',3.32),('8348','2014-05-04','09:25:00',3.33),('8348','2014-05-04','09:30:00',3.51),('8348','2014-05-04','09:35:00',3.68),('8348','2014-05-04','09:40:00',3.84),('8348','2014-05-04','09:45:00',5.09),('8348','2014-05-04','09:50:00',5.41),('8348','2014-05-04','09:55:00',4.39),('8348','2014-05-04','10:00:00',4),('8348','2014-05-04','10:05:00',5.29),('8348','2014-05-04','10:10:00',8.13),('8348','2014-05-04','10:15:00',5.55),('8348','2014-05-04','10:20:00',7.64),('8348','2014-05-04','10:25:00',7.18),('8348','2014-05-04','10:30:00',6.66),('8348','2014-05-04','10:35:00',5.97),('8348','2014-05-04','10:40:00',5.26),('8348','2014-05-04','10:45:00',6.91),('8348','2014-05-04','10:50:00',6.23),('8348','2014-05-04','10:55:00',6.59),('8348','2014-05-04','11:00:00',4.65),('8348','2014-05-04','11:05:00',4.39),('8348','2014-05-04','11:10:00',3.23),('8348','2014-05-04','11:15:00',2.89),('8348','2014-05-04','11:20:00',2.92),('8348','2014-05-04','11:25:00',3.38),('8348','2014-05-04','11:30:00',7.61),('8348','2014-05-04','11:35:00',7.86),('8348','2014-05-04','11:40:00',7.84),('8348','2014-05-04','11:45:00',7.46),('8348','2014-05-04','11:50:00',9.5),('8348','2014-05-04','11:55:00',8.74),('8348','2014-05-04','12:00:00',3.87),('8348','2014-05-04','12:05:00',3.58),('8348','2014-05-04','12:10:00',9.28),('8348','2014-05-04','12:15:00',4.47),('8348','2014-05-04','12:20:00',2.93),('8348','2014-05-04','12:25:00',2.92),('8348','2014-05-04','12:30:00',2.73),('8348','2014-05-04','12:35:00',2.98),('8348','2014-05-04','12:40:00',2.92),('8348','2014-05-04','12:45:00',2.58),('8348','2014-05-04','12:50:00',2.51),('8348','2014-05-04','12:55:00',2.62),('8348','2014-05-04','13:00:00',2.68),('8348','2014-05-04','13:05:00',2.71),('8348','2014-05-04','13:10:00',2.56),('8348','2014-05-04','13:15:00',2.24),('8348','2014-05-04','13:20:00',1.7),('8348','2014-05-04','13:25:00',1.25),('8348','2014-05-04','13:30:00',1.15),('8348','2014-05-04','13:35:00',1.23),('8348','2014-05-04','13:40:00',1.45),('8348','2014-05-04','13:45:00',1.7),('8348','2014-05-04','13:50:00',2.35),('8348','2014-05-04','13:55:00',3.39),('8348','2014-05-04','14:00:00',3.61),('8348','2014-05-04','14:05:00',4.55),('8348','2014-05-04','14:10:00',5.59),('8348','2014-05-04','14:15:00',4.16),('8348','2014-05-04','14:20:00',3.16),('8348','2014-05-04','14:25:00',2.55),('8348','2014-05-04','14:30:00',2.08),('8348','2014-05-04','14:35:00',1.54),('8348','2014-05-04','14:40:00',1.41),('8348','2014-05-04','14:45:00',1.72),('8348','2014-05-04','14:50:00',2.07),('8348','2014-05-04','14:55:00',2.08),('8348','2014-05-04','15:00:00',1.74),('8348','2014-05-04','15:05:00',1.86),('8348','2014-05-04','15:10:00',2.24),('8348','2014-05-04','15:15:00',2.13),('8348','2014-05-04','15:20:00',1.76),('8348','2014-05-04','15:25:00',1.34),('8348','2014-05-04','15:30:00',1.02),('8348','2014-05-04','16:20:00',1.2),('8348','2014-05-04','16:25:00',1.74),('8348','2014-05-04','16:30:00',1.81),('8348','2014-05-04','16:35:00',1.92),('8348','2014-05-04','16:40:00',1.85),('8348','2014-05-04','16:45:00',1.41),('8348','2014-05-04','16:50:00',1.12),('8348','2014-05-04','17:05:00',1.19),('8348','2014-04-16','06:55:00',1.05),('8348','2014-04-16','07:00:00',1.15),('8348','2014-04-16','07:05:00',1.24),('8348','2014-04-16','07:10:00',1.36),('8348','2014-04-16','07:15:00',1.64),('8348','2014-04-16','07:20:00',1.77),('8348','2014-04-16','07:25:00',1.85),('8348','2014-04-16','07:30:00',1.46),('8348','2014-04-16','07:35:00',1.24),('8348','2014-04-16','07:40:00',1.27),('8348','2014-04-16','07:45:00',2.09),('8348','2014-04-16','07:50:00',2.28),('8348','2014-04-16','07:55:00',2.61),('8348','2014-04-16','08:00:00',2.98),('8348','2014-04-16','08:05:00',3.33),('8348','2014-04-16','08:10:00',3.49),('8348','2014-04-16','08:15:00',3.65),('8348','2014-04-16','08:20:00',3.8),('8348','2014-04-16','08:25:00',4.07),('8348','2014-04-16','08:30:00',2.69),('8348','2014-04-16','08:35:00',1.52),('8348','2014-04-16','08:40:00',1.51),('8348','2014-04-16','08:45:00',1.58),('8348','2014-04-16','08:50:00',1.67),('8348','2014-04-16','08:55:00',5.39),('8348','2014-04-16','09:00:00',5.23),('8348','2014-04-16','09:05:00',5.3),('8348','2014-04-16','09:10:00',5.42),('8348','2014-04-16','09:15:00',5.56),('8348','2014-04-16','09:20:00',5.69),('8348','2014-04-16','09:25:00',5.8),('8348','2014-04-16','09:30:00',5.9),('8348','2014-04-16','09:35:00',6),('8348','2014-04-16','09:40:00',6.11),('8348','2014-04-16','09:45:00',6.24),('8348','2014-04-16','09:50:00',6.55),('8348','2014-04-16','09:55:00',5.98),('8348','2014-04-16','10:00:00',6.48),('8348','2014-04-16','10:05:00',3.59),('8348','2014-04-16','10:10:00',2.63),('8348','2014-04-16','10:15:00',3.7),('8348','2014-04-16','10:20:00',6.81),('8348','2014-04-16','10:25:00',4.91),('8348','2014-04-16','10:30:00',6.08),('8348','2014-04-16','10:35:00',4.68),('8348','2014-04-16','10:40:00',5.19),('8348','2014-04-16','10:45:00',6.87),('8348','2014-04-16','10:50:00',7.28),('8348','2014-04-16','10:55:00',8.13),('8348','2014-04-16','11:00:00',8.19),('8348','2014-04-16','11:05:00',5.06),('8348','2014-04-16','11:10:00',7.29),('8348','2014-04-16','11:15:00',8.01),('8348','2014-04-16','11:20:00',4.2),('8348','2014-04-16','11:25:00',2.36),('8348','2014-04-16','11:30:00',3.88),('8348','2014-04-16','11:35:00',7.97),('8348','2014-04-16','11:40:00',7.98),('8348','2014-04-16','11:45:00',8.12),('8348','2014-04-16','11:50:00',6.97),('8348','2014-04-16','11:55:00',2.02),('8348','2014-04-16','12:00:00',6.02),('8348','2014-04-16','12:05:00',2.9),('8348','2014-04-16','12:10:00',1.59),('8348','2014-04-16','12:15:00',1.67),('8348','2014-04-16','12:20:00',2.7),('8348','2014-04-16','12:25:00',2.17),('8348','2014-04-16','12:30:00',1.74),('8348','2014-04-16','12:35:00',3.2),('8348','2014-04-16','12:40:00',4.46),('8348','2014-04-16','12:45:00',9.28),('8348','2014-04-16','12:50:00',7.95),('8348','2014-04-16','12:55:00',5.5),('8348','2014-04-16','13:00:00',3.08),('8348','2014-04-16','13:05:00',7.16),('8348','2014-04-16','13:10:00',9.12),('8348','2014-04-16','13:15:00',8.81),('8348','2014-04-16','13:20:00',8.42),('8348','2014-04-16','13:25:00',7.81),('8348','2014-04-16','13:30:00',7.87),('8348','2014-04-16','13:35:00',7.6),('8348','2014-04-16','13:40:00',7.33),('8348','2014-04-16','13:45:00',7.19),('8348','2014-04-16','13:50:00',7.53),('8348','2014-04-16','13:55:00',2.28),('8348','2014-04-16','14:00:00',2.5),('8348','2014-04-16','14:05:00',6.79),('8348','2014-04-16','14:10:00',8.56),('8348','2014-04-16','14:15:00',4.48),('8348','2014-04-16','14:20:00',1.16),('8348','2014-04-16','14:25:00',2.37),('8348','2014-04-16','14:30:00',6.17),('8348','2014-04-16','14:35:00',7.52),('8348','2014-04-16','14:40:00',7.25),('8348','2014-04-16','14:45:00',7.04),('8348','2014-04-16','14:50:00',6.79),('8348','2014-04-16','14:55:00',6.63),('8348','2014-04-16','15:00:00',6.48),('8348','2014-04-16','15:05:00',6.35),('8348','2014-04-16','15:10:00',6.19),('8348','2014-04-16','15:15:00',6.1),('8348','2014-04-16','15:20:00',6.06),('8348','2014-04-16','15:25:00',5.9),('8348','2014-04-16','15:30:00',5.8),('8348','2014-04-16','15:35:00',5.68),('8348','2014-04-16','15:40:00',5.56),('8348','2014-04-16','15:45:00',5.45),('8348','2014-04-16','15:50:00',5.28),('8348','2014-04-16','15:55:00',5.1),('8348','2014-04-16','16:00:00',4.97),('8348','2014-04-16','16:05:00',4.81),('8348','2014-04-16','16:10:00',4.67),('8348','2014-04-16','16:15:00',4.57),('8348','2014-04-16','16:20:00',4.4),('8348','2014-04-16','16:25:00',4.2),('8348','2014-04-16','16:30:00',4.08),('8348','2014-04-16','16:35:00',3.94),('8348','2014-04-16','16:40:00',3.67),('8348','2014-04-16','16:45:00',3.57),('8348','2014-04-16','16:50:00',3.54),('8348','2014-04-16','16:55:00',3.52),('8348','2014-04-16','17:00:00',3.25),('8348','2014-04-16','17:05:00',2.81),('8348','2014-04-16','17:10:00',2.51),('8348','2014-04-16','17:15:00',2.38),('8348','2014-04-16','17:20:00',2.56),('8348','2014-04-16','17:25:00',2.25),('8348','2014-04-16','17:30:00',2.05),('8348','2014-04-16','17:35:00',1.88),('8348','2014-04-16','17:40:00',1.87),('8348','2014-04-16','17:45:00',1.87),('8348','2014-04-16','17:50:00',1.87),('8348','2014-04-16','17:55:00',1.44),('8348','2014-04-16','18:05:00',1.1),('8348','2013-10-18','09:20:00',1.02),('8348','2013-10-18','09:25:00',1.04),('8348','2013-10-18','09:30:00',1.15),('8348','2013-10-18','09:35:00',1.22),('8348','2013-10-18','09:40:00',1.27),('8348','2013-10-18','09:45:00',1.35),('8348','2013-10-18','09:50:00',1.44),('8348','2013-10-18','09:55:00',1.53),('8348','2013-10-18','10:00:00',1.58),('8348','2013-10-18','10:05:00',1.66),('8348','2013-10-18','10:10:00',1.7),('8348','2013-10-18','10:15:00',1.76),('8348','2013-10-18','10:20:00',1.79),('8348','2013-10-18','10:25:00',1.86),('8348','2013-10-18','10:30:00',1.92),('8348','2013-10-18','10:35:00',1.97),('8348','2013-10-18','10:40:00',2.01),('8348','2013-10-18','10:45:00',2.07),('8348','2013-10-18','10:50:00',2.11),('8348','2013-10-18','10:55:00',2.15),('8348','2013-10-18','11:00:00',2.17),('8348','2013-10-18','11:05:00',2.13),('8348','2013-10-18','11:10:00',2.14),('8348','2013-10-18','11:15:00',2.18),('8348','2013-10-18','11:20:00',2.34),('8348','2013-10-18','11:25:00',2.29),('8348','2013-10-18','11:30:00',2.37),('8348','2013-10-18','11:35:00',2.42),('8348','2013-10-18','11:40:00',2.49),('8348','2013-10-18','11:45:00',2.45),('8348','2013-10-18','11:50:00',2.44),('8348','2013-10-18','11:55:00',2.54),('8348','2013-10-18','12:00:00',2.46),('8348','2013-10-18','12:05:00',2.56),('8348','2013-10-18','12:10:00',2.58),('8348','2013-10-18','12:15:00',2.54),('8348','2013-10-18','12:20:00',2.53),('8348','2013-10-18','12:25:00',2.59),('8348','2013-10-18','12:30:00',2.62),('8348','2013-10-18','12:35:00',2.57),('8348','2013-10-18','12:40:00',2.6),('8348','2013-10-18','12:45:00',2.53),('8348','2013-10-18','12:50:00',2.55),('8348','2013-10-18','12:55:00',2.62),('8348','2013-10-18','13:00:00',2.6),('8348','2013-10-18','13:05:00',2.54),('8348','2013-10-18','13:10:00',2.46),('8348','2013-10-18','13:15:00',2.58),('8348','2013-10-18','13:20:00',2.62),('8348','2013-10-18','13:25:00',2.66),('8348','2013-10-18','13:30:00',2.65),('8348','2013-10-18','13:35:00',2.64),('8348','2013-10-18','13:40:00',2.66),('8348','2013-10-18','13:45:00',2.57),('8348','2013-10-18','13:50:00',2.57),('8348','2013-10-18','13:55:00',2.55),('8348','2013-10-18','14:00:00',2.38),('8348','2013-10-18','14:05:00',2.45),('8348','2013-10-18','14:10:00',2.41),('8348','2013-10-18','14:15:00',2.47),('8348','2013-10-18','14:20:00',2.45),('8348','2013-10-18','14:25:00',2.43),('8348','2013-10-18','14:30:00',2.4),('8348','2013-10-18','14:35:00',2.31),('8348','2013-10-18','14:40:00',2.32),('8348','2013-10-18','14:45:00',2.27),('8348','2013-10-18','14:50:00',2.21),('8348','2013-10-18','14:55:00',2.28),('8348','2013-10-18','15:00:00',1.96),('8348','2013-10-18','15:05:00',1.81),('8348','2013-10-18','15:10:00',1.98),('8348','2013-10-18','15:15:00',1.98),('8348','2013-10-18','15:20:00',2.07),('8348','2013-10-18','15:25:00',1.96),('8348','2013-10-18','15:30:00',1.9),('8348','2013-10-18','15:35:00',1.89),('8348','2013-10-18','15:40:00',1.83),('8348','2013-10-18','15:45:00',1.65),('8348','2013-10-18','15:50:00',1.65),('8348','2013-10-18','15:55:00',1.52),('8348','2013-10-18','16:00:00',1.6),('8348','2013-10-18','16:05:00',1.5),('8348','2013-10-18','16:10:00',1.44),('8348','2013-10-18','16:15:00',1.32),('8348','2013-10-18','16:20:00',1.25),('8348','2013-10-18','16:25:00',1.1),('8348','2013-10-18','16:30:00',1.01),('8348','2013-10-17','09:20:00',1.03),('8348','2013-10-17','09:25:00',1.07),('8348','2013-10-17','09:30:00',1.15),('8348','2013-10-17','09:35:00',1.21),('8348','2013-10-17','09:40:00',1.27),('8348','2013-10-17','09:45:00',1.35),('8348','2013-10-17','09:50:00',1.43),('8348','2013-10-17','09:55:00',1.53),('8348','2013-10-17','10:00:00',1.59),('8348','2013-10-17','10:05:00',1.64),('8348','2013-10-17','10:10:00',1.7),('8348','2013-10-17','10:15:00',1.76),('8348','2013-10-17','10:20:00',1.82),('8348','2013-10-17','10:25:00',1.88),('8348','2013-10-17','10:30:00',1.93),('8348','2013-10-17','10:35:00',2),('8348','2013-10-17','10:40:00',2.04),('8348','2013-10-17','10:45:00',2.1),('8348','2013-10-17','10:50:00',2.15),('8348','2013-10-17','10:55:00',2.19),('8348','2013-10-17','11:00:00',2.24),('8348','2013-10-17','11:05:00',2.28),('8348','2013-10-17','11:10:00',2.32),('8348','2013-10-17','11:15:00',2.35),('8348','2013-10-17','11:20:00',2.38),('8348','2013-10-17','11:25:00',2.42),('8348','2013-10-17','11:30:00',2.46),('8348','2013-10-17','11:35:00',2.5),('8348','2013-10-17','11:40:00',2.53),('8348','2013-10-17','11:45:00',2.54),('8348','2013-10-17','11:50:00',2.57),('8348','2013-10-17','11:55:00',2.59),('8348','2013-10-17','12:00:00',2.61),('8348','2013-10-17','12:05:00',2.62),('8348','2013-10-17','12:10:00',2.64),('8348','2013-10-17','12:15:00',2.67),('8348','2013-10-17','12:20:00',2.67),('8348','2013-10-17','12:25:00',2.68),('8348','2013-10-17','12:30:00',2.7),('8348','2013-10-17','12:35:00',2.73),('8348','2013-10-17','12:40:00',2.74),('8348','2013-10-17','12:45:00',2.76),('8348','2013-10-17','12:50:00',2.77),('8348','2013-10-17','12:55:00',2.76),('8348','2013-10-17','13:00:00',2.76),('8348','2013-10-17','13:05:00',2.76),('8348','2013-10-17','13:10:00',2.76),('8348','2013-10-17','13:15:00',2.77),('8348','2013-10-17','13:20:00',2.75),('8348','2013-10-17','13:25:00',2.75),('8348','2013-10-17','13:30:00',2.73),('8348','2013-10-17','13:35:00',2.73),('8348','2013-10-17','13:40:00',2.71),('8348','2013-10-17','13:45:00',2.7),('8348','2013-10-17','13:50:00',2.69),('8348','2013-10-17','13:55:00',2.69),('8348','2013-10-17','14:00:00',2.67),('8348','2013-10-17','14:05:00',2.65),('8348','2013-10-17','14:10:00',2.63),('8348','2013-10-17','14:15:00',2.62),('8348','2013-10-17','14:20:00',2.6),('8348','2013-10-17','14:25:00',2.56),('8348','2013-10-17','14:30:00',2.52),('8348','2013-10-17','14:35:00',2.51),('8348','2013-10-17','14:40:00',2.48),('8348','2013-10-17','14:45:00',2.45),('8348','2013-10-17','14:50:00',2.41),('8348','2013-10-17','14:55:00',2.37),('8348','2013-10-17','15:00:00',2.34),('8348','2013-10-17','15:05:00',2.3),('8348','2013-10-17','15:10:00',2.29),('8348','2013-10-17','15:15:00',2.24),('8348','2013-10-17','15:20:00',2.19),('8348','2013-10-17','15:25:00',2.15),('8348','2013-10-17','15:30:00',2.1),('8348','2013-10-17','15:35:00',2.05),('8348','2013-10-17','15:40:00',2),('8348','2013-10-17','15:45:00',1.94),('8348','2013-10-17','15:50:00',1.87),('8348','2013-10-17','15:55:00',1.83),('8348','2013-10-17','16:00:00',1.77),('8348','2013-10-17','16:05:00',1.71),('8348','2013-10-17','16:10:00',1.67),('8348','2013-10-17','16:15:00',1.61),('8348','2013-10-17','16:20:00',1.56),('8348','2013-10-17','16:25:00',1.5),('8348','2013-10-17','16:30:00',1.42),('8348','2013-10-17','16:35:00',1.35),('8348','2013-10-17','16:40:00',1.29),('8348','2013-10-17','16:45:00',1.21),('8348','2013-10-17','16:50:00',1.14),('8348','2013-10-17','16:55:00',1.07),('8348','2013-10-16','09:45:00',1.28),('8348','2013-10-16','09:50:00',1.12),('8348','2013-10-16','11:15:00',1.23),('8348','2013-10-16','11:55:00',1.06),('8348','2013-10-16','12:10:00',1.09),('8348','2013-10-16','12:15:00',2.99),('8348','2013-10-16','12:20:00',2.35),('8348','2013-10-16','12:35:00',1.1),('8348','2013-10-16','12:40:00',3.23),('8348','2013-10-16','12:45:00',2.75),('8348','2013-10-16','12:50:00',2.45),('8348','2013-10-16','12:55:00',2.32),('8348','2013-10-16','13:00:00',2.26),('8348','2013-10-16','13:05:00',2.93),('8348','2013-10-16','13:10:00',2.72),('8348','2013-10-16','13:15:00',2.23),('8348','2013-10-16','13:20:00',2.92),('8348','2013-10-16','13:25:00',3.1),('8348','2013-10-16','13:30:00',2.97),('8348','2013-10-16','13:35:00',2.82),('8348','2013-10-16','13:40:00',2.85),('8348','2013-10-16','13:45:00',2.8),('8348','2013-10-16','13:50:00',2.71),('8348','2013-10-16','13:55:00',2.98),('8348','2013-10-16','14:00:00',2.38),('8348','2013-10-16','14:05:00',2.06),('8348','2013-10-16','14:10:00',2.89),('8348','2013-10-16','14:15:00',2.78),('8348','2013-10-16','14:20:00',2.81),('8348','2013-10-16','14:25:00',2.34),('8348','2013-10-16','14:30:00',2.65),('8348','2013-10-16','14:35:00',1.45),('8348','2013-10-16','14:40:00',2.67),('8348','2013-10-16','14:45:00',2.68),('8348','2013-10-16','14:50:00',2.54),('8348','2013-10-16','14:55:00',1.74),('8348','2013-10-16','15:00:00',2.46),('8348','2013-10-16','15:05:00',2.44),('8348','2013-10-16','15:10:00',2.49),('8348','2013-10-16','15:15:00',2.33),('8348','2013-10-16','15:20:00',2.25),('8348','2013-10-16','15:25:00',1.64),('8348','2013-10-16','15:35:00',1.79),('8348','2013-10-16','15:40:00',2.15),('8348','2013-10-16','15:45:00',1.99),('8348','2013-10-16','15:50:00',1.92),('8348','2013-10-16','15:55:00',1.88),('8348','2013-10-16','16:00:00',1.82),('8348','2013-10-16','16:05:00',1.76),('8348','2013-10-16','16:10:00',1.48),('8348','2013-10-16','16:15:00',1.63),('8348','2013-10-16','16:20:00',1.55),('8348','2013-10-16','16:25:00',1.48),('8348','2013-10-16','16:30:00',1.39),('8348','2013-10-16','16:35:00',1.24),('8348','2013-10-16','16:40:00',1.3),('8348','2013-10-16','16:45:00',1.2),('8348','2013-10-16','16:50:00',1.14),('8348','2013-10-16','16:55:00',1.08),('8348','2013-10-15','09:30:00',1.06),('8348','2013-10-15','09:45:00',1.33),('8348','2013-10-15','09:50:00',1.54),('8348','2013-10-15','09:55:00',1.66),('8348','2013-10-15','10:00:00',1.66),('8348','2013-10-15','10:05:00',1.82),('8348','2013-10-15','10:10:00',1.45),('8348','2013-10-15','10:25:00',1.17),('8348','2013-10-15','10:30:00',1.55),('8348','2013-10-15','10:35:00',1.32),('8348','2013-10-15','10:40:00',1.62),('8348','2013-10-15','10:45:00',1.84),('8348','2013-10-15','10:50:00',1.74),('8348','2013-10-15','10:55:00',1.53),('8348','2013-10-15','11:00:00',1.53),('8348','2013-10-15','11:05:00',1.65),('8348','2013-10-15','11:10:00',2.15),('8348','2013-10-15','11:15:00',2.28),('8348','2013-10-15','11:20:00',2.34),('8348','2013-10-15','11:25:00',2.19),('8348','2013-10-15','11:30:00',2.3),('8348','2013-10-15','11:35:00',1.9),('8348','2013-10-15','11:40:00',1.56),('8348','2013-10-15','11:45:00',1.32),('8348','2013-10-15','11:50:00',1.27),('8348','2013-10-15','11:55:00',1.26),('8348','2013-10-15','12:00:00',1.32),('8348','2013-10-15','12:05:00',1.32),('8348','2013-10-15','12:10:00',1.34),('8348','2013-10-15','12:15:00',1.32),('8348','2013-10-15','12:20:00',1.37),('8348','2013-10-15','12:25:00',1.24),('8348','2013-10-15','12:30:00',1.15),('8348','2013-10-15','12:35:00',1.14),('8348','2013-10-15','12:40:00',1.11),('8348','2013-10-15','12:45:00',1.24),('8348','2013-10-15','12:50:00',1.17),('8348','2013-10-15','12:55:00',1.07),('8348','2013-10-15','13:00:00',1.06),('8348','2013-10-15','13:05:00',1.39),('8348','2013-10-15','13:10:00',1.58),('8348','2013-10-15','13:15:00',1.6),('8348','2013-10-15','13:20:00',2.26),('8348','2013-10-15','13:25:00',2.61),('8348','2013-10-15','13:30:00',1.66),('8348','2013-10-15','13:35:00',1.43),('8348','2013-10-15','13:40:00',1.39),('8348','2013-10-15','13:45:00',1.41),('8348','2013-10-15','13:50:00',1.31),('8348','2013-10-15','13:55:00',1.16),('8348','2013-10-15','14:00:00',1.06),('8348','2013-10-15','14:05:00',1.06),('8348','2013-10-15','14:10:00',1.17),('8348','2013-10-15','14:15:00',1.63),('8348','2013-10-15','14:20:00',1.79),('8348','2013-10-15','14:25:00',1.98),('8348','2013-10-15','14:30:00',1.83),('8348','2013-10-15','14:35:00',1.23),('8348','2013-10-15','14:40:00',1.78),('8348','2013-10-15','14:45:00',1.93),('8348','2013-10-15','14:50:00',2.1),('8348','2013-10-15','14:55:00',1.75),('8348','2013-10-15','15:00:00',1.18),('8348','2013-10-15','15:05:00',1.19),('8348','2013-10-15','15:10:00',1.23),('8348','2013-10-15','15:15:00',1.12),('8348','2013-10-15','15:20:00',1.02),('8348','2013-10-15','16:30:00',1.06),('8348','2013-10-15','16:35:00',1.08),('8348','2013-10-14','09:25:00',1.05),('8348','2013-10-14','09:30:00',1.18),('8348','2013-10-14','09:35:00',1.15),('8348','2013-10-14','09:40:00',1.03),('8348','2013-10-14','09:50:00',1.18),('8348','2013-10-14','09:55:00',1.39),('8348','2013-10-14','10:00:00',1.38),('8348','2013-10-14','10:05:00',1.52),('8348','2013-10-14','10:10:00',1.63),('8348','2013-10-14','10:15:00',1.74),('8348','2013-10-14','10:20:00',1.78),('8348','2013-10-14','10:25:00',1.82),('8348','2013-10-14','10:30:00',1.87),('8348','2013-10-14','10:35:00',1.9),('8348','2013-10-14','10:40:00',1.88),('8348','2013-10-14','10:45:00',1.94),('8348','2013-10-14','10:50:00',2.03),('8348','2013-10-14','10:55:00',2.07),('8348','2013-10-14','11:00:00',2.12),('8348','2013-10-14','11:05:00',2.13),('8348','2013-10-14','11:10:00',2.24),('8348','2013-10-14','11:15:00',2.23),('8348','2013-10-14','11:20:00',2.24),('8348','2013-10-14','11:25:00',2.32),('8348','2013-10-14','11:30:00',2.39),('8348','2013-10-14','11:35:00',2.35),('8348','2013-10-14','11:40:00',2.38),('8348','2013-10-14','11:45:00',2.35),('8348','2013-10-14','11:50:00',2.4),('8348','2013-10-14','11:55:00',2.41),('8348','2013-10-14','12:00:00',2.45),('8348','2013-10-14','12:05:00',2.46),('8348','2013-10-14','12:10:00',2.51),('8348','2013-10-14','12:15:00',2.48),('8348','2013-10-14','12:20:00',2.32),('8348','2013-10-14','12:25:00',2.46),('8348','2013-10-14','12:30:00',2.59),('8348','2013-10-14','12:35:00',2.58),('8348','2013-10-14','12:40:00',2.58),('8348','2013-10-14','12:45:00',2.59),('8348','2013-10-14','12:50:00',2.59),('8348','2013-10-14','12:55:00',2.59),('8348','2013-10-14','13:00:00',2.58),('8348','2013-10-14','13:05:00',2.59),('8348','2013-10-14','13:10:00',2.59),('8348','2013-10-14','13:15:00',2.59),('8348','2013-10-14','13:20:00',2.59),('8348','2013-10-14','13:25:00',2.58),('8348','2013-10-14','13:30:00',2.57),('8348','2013-10-14','13:35:00',2.56),('8348','2013-10-14','13:40:00',2.57),('8348','2013-10-14','13:45:00',2.56),('8348','2013-10-14','13:50:00',2.54),('8348','2013-10-14','13:55:00',2.52),('8348','2013-10-14','14:00:00',2.51),('8348','2013-10-14','14:05:00',2.5),('8348','2013-10-14','14:10:00',2.48),('8348','2013-10-14','14:15:00',2.47),('8348','2013-10-14','14:20:00',2.44),('8348','2013-10-14','14:25:00',2.41),('8348','2013-10-14','14:30:00',2.39),('8348','2013-10-14','14:35:00',2.36),('8348','2013-10-14','14:40:00',2.35),('8348','2013-10-14','14:45:00',2.32),('8348','2013-10-14','14:50:00',2.3),('8348','2013-10-14','14:55:00',2.25),('8348','2013-10-14','15:00:00',2.21),('8348','2013-10-14','15:05:00',2.17),('8348','2013-10-14','15:10:00',2.12),('8348','2013-10-14','15:15:00',2.08),('8348','2013-10-14','15:20:00',2.04),('8348','2013-10-14','15:25:00',1.98),('8348','2013-10-14','15:30:00',1.92),('8348','2013-10-14','15:35:00',1.86),('8348','2013-10-14','15:40:00',1.65),('8348','2013-10-14','15:45:00',1.43),('8348','2013-10-14','15:50:00',1.48),('8348','2013-10-14','15:55:00',1.08),('8348','2013-10-14','16:00:00',1.33),('8348','2013-10-14','16:05:00',1.08),('8348','2013-10-13','09:15:00',1.14),('8348','2013-10-13','09:20:00',1.22),('8348','2013-10-13','09:25:00',1.12),('8348','2013-10-13','09:35:00',1.08),('8348','2013-10-13','09:40:00',1.42),('8348','2013-10-13','09:45:00',1.89),('8348','2013-10-13','09:50:00',1.94),('8348','2013-10-13','09:55:00',2.02),('8348','2013-10-13','10:00:00',1.57),('8348','2013-10-13','10:05:00',1.21),('8348','2013-10-13','10:10:00',1.61),('8348','2013-10-13','10:15:00',1.77),('8348','2013-10-13','10:20:00',1.49),('8348','2013-10-13','10:25:00',1.64),('8348','2013-10-13','10:30:00',2.09),('8348','2013-10-13','10:35:00',2.42),('8348','2013-10-13','10:40:00',2.51),('8348','2013-10-13','10:45:00',2.57),('8348','2013-10-13','10:50:00',2.34),('8348','2013-10-13','10:55:00',1.81),('8348','2013-10-13','11:00:00',2.32),('8348','2013-10-13','11:05:00',2.26),('8348','2013-10-13','11:10:00',2.38),('8348','2013-10-13','11:15:00',2.49),('8348','2013-10-13','11:20:00',2.39),('8348','2013-10-13','11:25:00',2.34),('8348','2013-10-13','11:30:00',2.41),('8348','2013-10-13','11:35:00',2.4),('8348','2013-10-13','11:40:00',2.41),('8348','2013-10-13','11:45:00',2.42),('8348','2013-10-13','11:50:00',2.46),('8348','2013-10-13','11:55:00',2.47),('8348','2013-10-13','12:00:00',2.5),('8348','2013-10-13','12:05:00',2.51),('8348','2013-10-13','12:10:00',2.52),('8348','2013-10-13','12:15:00',2.55),('8348','2013-10-13','12:20:00',2.51),('8348','2013-10-13','12:25:00',2.48),('8348','2013-10-13','12:30:00',2.59),('8348','2013-10-13','12:35:00',2.62),('8348','2013-10-13','12:40:00',2.63),('8348','2013-10-13','12:45:00',2.61),('8348','2013-10-13','12:50:00',2.6),('8348','2013-10-13','12:55:00',2.6),('8348','2013-10-13','13:00:00',2.61),('8348','2013-10-13','13:05:00',2.61),('8348','2013-10-13','13:10:00',2.66),('8348','2013-10-13','13:15:00',2.68),('8348','2013-10-13','13:20:00',2.69),('8348','2013-10-13','13:25:00',2.43),('8348','2013-10-13','13:30:00',2.02),('8348','2013-10-13','13:35:00',2.39),('8348','2013-10-13','13:40:00',1.53),('8348','2013-10-13','13:45:00',1.79),('8348','2013-10-13','13:50:00',1.97),('8348','2013-10-13','13:55:00',2.05),('8348','2013-10-13','14:00:00',2.56),('8348','2013-10-13','14:05:00',2.63),('8348','2013-10-13','14:10:00',2.62),('8348','2013-10-13','14:15:00',2.48),('8348','2013-10-13','14:20:00',2.64),('8348','2013-10-13','14:25:00',2.62),('8348','2013-10-13','14:30:00',2.37),('8348','2013-10-13','14:35:00',1.93),('8348','2013-10-13','14:40:00',2.33),('8348','2013-10-13','14:45:00',1.91),('8348','2013-10-13','14:50:00',1.52),('8348','2013-10-13','14:55:00',1.82),('8348','2013-10-13','15:00:00',2.26),('8348','2013-10-13','15:05:00',2.06),('8348','2013-10-13','15:10:00',1.46),('8348','2013-10-13','15:15:00',1.6),('8348','2013-10-13','15:20:00',1.88),('8348','2013-10-13','15:25:00',1.97),('8348','2013-10-13','15:30:00',1.51),('8348','2013-10-13','15:35:00',1.38),('8348','2013-10-13','15:40:00',1.35),('8348','2013-10-13','15:45:00',1.26),('8348','2013-10-13','15:50:00',1.21),('8348','2013-10-13','15:55:00',1.15),('8348','2013-10-13','16:00:00',1.3),('8348','2013-10-13','16:05:00',1.58),('8348','2013-10-13','16:10:00',1.35),('8348','2013-10-13','16:15:00',1.16),('8348','2013-10-13','16:20:00',1.2),('8348','2013-10-13','16:25:00',1.62),('8348','2013-10-13','16:30:00',1.61),('8348','2013-10-13','16:35:00',1.43),('8348','2013-10-13','16:40:00',1.07),('8348','2013-10-12','11:25:00',1.08),('8348','2013-10-12','11:30:00',1.25),('8348','2013-10-12','11:35:00',1.69),('8348','2013-10-12','11:40:00',2.51),('8348','2013-10-12','11:45:00',1.37),('8348','2013-10-12','11:50:00',1.26),('8348','2013-10-12','11:55:00',1.08),('8348','2013-10-12','12:15:00',1),('8348','2013-10-12','12:20:00',1.67),('8348','2013-10-12','12:25:00',2.96),('8348','2013-10-12','12:30:00',2.2),('8348','2013-10-12','12:35:00',2.6),('8348','2013-10-12','12:40:00',2.69),('8348','2013-10-12','12:45:00',2.45),('8348','2013-10-12','12:50:00',2.45),('8348','2013-10-12','12:55:00',2.18),('8348','2013-10-12','13:00:00',1.71),('8348','2013-10-12','13:15:00',1.04),('8348','2013-10-12','13:20:00',1.23),('8348','2013-10-12','13:25:00',1.38),('8348','2013-10-12','13:30:00',2.95),('8348','2013-10-12','13:35:00',1.32),('8348','2013-10-12','16:00:00',1.03),('8348','2013-10-12','16:10:00',1.02),('8348','2013-10-12','16:15:00',1.67),('8348','2013-10-12','16:20:00',1.64),('8348','2013-10-11','09:45:00',1.48),('8348','2013-10-11','09:50:00',1.56),('8348','2013-10-11','09:55:00',1.63),('8348','2013-10-11','10:00:00',1.7),('8348','2013-10-11','10:05:00',1.77),('8348','2013-10-11','10:10:00',1.84),('8348','2013-10-11','10:15:00',1.69),('8348','2013-10-11','10:20:00',1.8),('8348','2013-10-11','10:25:00',1.86),('8348','2013-10-11','10:30:00',2.16),('8348','2013-10-11','10:35:00',2.36),('8348','2013-10-11','10:40:00',1.65),('8348','2013-10-11','11:05:00',2.21),('8348','2013-10-11','11:10:00',1.83),('8348','2013-10-11','11:35:00',1.04),('8348','2013-10-11','11:40:00',2.06),('8348','2013-10-11','11:45:00',1.55),('8348','2013-10-11','11:50:00',1.76),('8348','2013-10-11','11:55:00',1.68),('8348','2013-10-11','12:00:00',2.06),('8348','2013-10-11','12:05:00',2.94),('8348','2013-10-11','12:10:00',1.58),('8348','2013-10-11','12:15:00',1.11),('8348','2013-10-11','12:25:00',1.16),('8348','2013-10-11','12:30:00',1.56),('8348','2013-10-11','13:05:00',1.86),('8348','2013-10-11','13:10:00',1.47),('8348','2013-10-11','13:15:00',1.18),('8348','2013-10-11','13:20:00',1.77),('8348','2013-10-11','13:25:00',3.91),('8348','2013-10-11','13:30:00',1.49),('8348','2013-10-11','13:40:00',2.42),('8348','2013-10-11','13:45:00',3.07),('8348','2013-10-11','13:50:00',1.23),('8348','2013-10-11','15:35:00',1.03),('8348','2013-10-11','15:40:00',1.47),('8348','2013-10-11','15:45:00',1.03),('8348','2013-10-11','16:00:00',2.07),('8348','2013-10-11','16:05:00',1.03),('8348','2013-10-11','16:35:00',1.03),('8348','2013-10-11','17:00:00',1.03),('8348','2013-10-10','09:15:00',1.07),('8348','2013-10-10','09:20:00',1.11),('8348','2013-10-10','09:25:00',1.14),('8348','2013-10-10','09:30:00',1.22),('8348','2013-10-10','09:40:00',1.18),('8348','2013-10-10','09:45:00',1.25),('8348','2013-10-10','09:50:00',1.25),('8348','2013-10-10','09:55:00',1.47),('8348','2013-10-10','10:10:00',1.06),('8348','2013-10-10','10:15:00',1.9),('8348','2013-10-10','10:20:00',1.93),('8348','2013-10-10','10:25:00',1.72),('8348','2013-10-10','10:35:00',1.02),('8348','2013-10-10','10:40:00',1.42),('8348','2013-10-10','10:45:00',2.11),('8348','2013-10-10','10:50:00',2.25),('8348','2013-10-10','10:55:00',1.79),('8348','2013-10-10','11:05:00',1.33),('8348','2013-10-10','11:20:00',1.25),('8348','2013-10-10','11:25:00',2.72),('8348','2013-10-10','11:30:00',1.28),('8348','2013-10-10','11:35:00',2.12),('8348','2013-10-10','11:40:00',1.58),('8348','2013-10-10','11:50:00',1.89),('8348','2013-10-10','11:55:00',2.54),('8348','2013-10-10','12:00:00',2.96),('8348','2013-10-10','12:05:00',3.01),('8348','2013-10-10','12:10:00',1.48),('8348','2013-10-10','12:20:00',1.64),('8348','2013-10-10','12:25:00',3.4),('8348','2013-10-10','12:35:00',2.46),('8348','2013-10-10','12:40:00',3.32),('8348','2013-10-10','12:45:00',2.41),('8348','2013-10-10','12:50:00',1.08),('8348','2013-10-10','12:55:00',2.61),('8348','2013-10-10','13:00:00',3.55),('8348','2013-10-10','13:05:00',3.45),('8348','2013-10-10','13:10:00',3.27),('8348','2013-10-10','13:15:00',1.69),('8348','2013-10-10','13:20:00',1.35),('8348','2013-10-10','13:25:00',3),('8348','2013-10-10','13:30:00',3.26),('8348','2013-10-10','13:35:00',2.19),('8348','2013-10-10','13:40:00',1.43),('8348','2013-10-10','13:45:00',2.47),('8348','2013-10-10','13:50:00',3.44),('8348','2013-10-10','13:55:00',3.1),('8348','2013-10-10','14:00:00',3.02),('8348','2013-10-10','14:05:00',3.09),('8348','2013-10-10','14:10:00',2.33),('8348','2013-10-10','14:15:00',1.89),('8348','2013-10-10','14:20:00',2.65),('8348','2013-10-10','14:25:00',3.22),('8348','2013-10-10','14:30:00',3.25),('8348','2013-10-10','14:35:00',3.19),('8348','2013-10-10','14:40:00',3.03),('8348','2013-10-10','14:45:00',2.88),('8348','2013-10-10','14:50:00',2.78),('8348','2013-10-10','14:55:00',2.59),('8348','2013-10-10','15:00:00',2.59),('8348','2013-10-10','15:05:00',2.71),('8348','2013-10-10','15:10:00',2.7),('8348','2013-10-10','15:15:00',1.96),('8348','2013-10-10','15:20:00',1.84),('8348','2013-10-10','15:25:00',2.22),('8348','2013-10-10','15:30:00',2.24),('8348','2013-10-10','15:35:00',1.28),('8348','2013-10-10','15:40:00',1.93),('8348','2013-10-10','15:45:00',1.33),('8348','2013-10-10','15:50:00',1.15),('8348','2013-10-10','15:55:00',1.58),('8348','2013-10-10','16:00:00',1.16),('8348','2013-10-10','16:15:00',1.01),('8348','2013-10-10','16:20:00',1.22),('8348','2013-10-10','16:25:00',1.42),('8348','2013-10-10','16:30:00',1.23),('8348','2013-10-10','16:45:00',1.4),('8348','2013-10-10','16:50:00',1.22),('8348','2013-10-10','16:55:00',1.29),('8348','2013-10-10','17:00:00',1.14),('8348','2013-10-10','17:20:00',1.03),('8348','2013-10-09','09:10:00',1.02),('8348','2013-10-09','09:20:00',1.01),('8348','2013-10-09','09:25:00',1.19),('8348','2013-10-09','09:30:00',1.27),('8348','2013-10-09','09:35:00',1.37),('8348','2013-10-09','09:40:00',1.5),('8348','2013-10-09','09:45:00',1.6),('8348','2013-10-09','09:50:00',1.67),('8348','2013-10-09','09:55:00',1.76),('8348','2013-10-09','10:00:00',1.9),('8348','2013-10-09','10:05:00',1.99),('8348','2013-10-09','10:10:00',1.75),('8348','2013-10-09','10:15:00',1.14),('8348','2013-10-09','10:30:00',1.04),('8348','2013-10-09','10:35:00',1.1),('8348','2013-10-09','10:40:00',1.02),('8348','2013-10-09','10:45:00',1.15),('8348','2013-10-09','10:50:00',2.86),('8348','2013-10-09','10:55:00',2.56),('8348','2013-10-09','11:00:00',2.22),('8348','2013-10-09','11:05:00',3.12),('8348','2013-10-09','11:10:00',3.2),('8348','2013-10-09','11:15:00',3.13),('8348','2013-10-09','11:20:00',3),('8348','2013-10-09','11:25:00',2.53),('8348','2013-10-09','11:30:00',3.22),('8348','2013-10-09','11:35:00',3.36),('8348','2013-10-09','11:40:00',3.34),('8348','2013-10-09','11:45:00',3.01),('8348','2013-10-09','11:50:00',2.85),('8348','2013-10-09','11:55:00',2.93),('8348','2013-10-09','12:00:00',1.6),('8348','2013-10-09','12:05:00',1.78),('8348','2013-10-09','12:10:00',1.65),('8348','2013-10-09','12:15:00',3.76),('8348','2013-10-09','12:20:00',3.22),('8348','2013-10-09','12:25:00',2.31),('8348','2013-10-09','12:30:00',1.37),('8348','2013-10-09','12:35:00',1.7),('8348','2013-10-09','12:40:00',1.39),('8348','2013-10-09','13:15:00',1.1),('8348','2013-10-09','13:20:00',1.6),('8348','2013-10-09','13:25:00',2.89),('8348','2013-10-09','13:30:00',3.15),('8348','2013-10-09','13:35:00',2.68),('8348','2013-10-09','13:40:00',2.23),('8348','2013-10-09','13:45:00',2.28),('8348','2013-10-09','13:50:00',1.67),('8348','2013-10-09','13:55:00',2.62),('8348','2013-10-09','14:00:00',3.19),('8348','2013-10-09','14:05:00',1.86),('8348','2013-10-09','14:10:00',1.29),('8348','2013-10-09','14:55:00',2.37),('8348','2013-10-09','15:00:00',1.02),('8348','2013-10-09','15:05:00',3),('8348','2013-10-09','15:10:00',2.75),('8348','2013-10-09','15:15:00',2.72),('8348','2013-10-09','15:20:00',2.42),('8348','2013-10-09','15:25:00',2.63),('8348','2013-10-09','15:30:00',1.9),('8348','2013-10-09','15:35:00',1.62),('8348','2013-10-09','15:40:00',1.8),('8348','2013-10-09','15:45:00',1.2),('8348','2013-10-09','15:50:00',1.03),('8348','2013-10-09','16:15:00',1.15),('8348','2013-10-09','16:20:00',1.49),('8348','2013-10-09','16:25:00',1.7),('8348','2013-10-09','16:30:00',2.13),('8348','2013-10-09','16:35:00',1.56),('8348','2013-10-09','16:40:00',1.44),('8348','2013-10-09','17:35:00',1.21),('8348','2014-04-15','07:00:00',1.21),('8348','2014-04-15','07:55:00',1.24),('8348','2014-04-15','08:00:00',2.84),('8348','2014-04-15','08:05:00',2.91),('8348','2014-04-15','08:10:00',2.19),('8348','2014-04-15','08:15:00',3.43),('8348','2014-04-15','08:20:00',3.99),('8348','2014-04-15','08:25:00',4.44),('8348','2014-04-15','08:30:00',4.08),('8348','2014-04-15','08:35:00',1.86),('8348','2014-04-15','08:40:00',1.02),('8348','2014-04-15','08:45:00',2.06),('8348','2014-04-15','08:50:00',4.82),('8348','2014-04-15','08:55:00',1.61),('8348','2014-04-15','09:00:00',2.31),('8348','2014-04-15','09:05:00',2.71),('8348','2014-04-15','09:10:00',3.02),('8348','2014-04-15','09:15:00',3.5),('8348','2014-04-15','09:20:00',3.96),('8348','2014-04-15','09:25:00',2.91),('8348','2014-04-15','09:30:00',5.79),('8348','2014-04-15','09:35:00',3.92),('8348','2014-04-15','09:40:00',3.97),('8348','2014-04-15','09:45:00',4.54),('8348','2014-04-15','09:50:00',4.89),('8348','2014-04-15','09:55:00',3.12),('8348','2014-04-15','10:00:00',3.41),('8348','2014-04-15','10:05:00',5.56),('8348','2014-04-15','10:10:00',3.52),('8348','2014-04-15','10:15:00',2.53),('8348','2014-04-15','10:20:00',1.85),('8348','2014-04-15','10:25:00',2.9),('8348','2014-04-15','10:30:00',2.2),('8348','2014-04-15','10:35:00',1.82),('8348','2014-04-15','10:40:00',1.13),('8348','2014-04-15','10:45:00',1.72),('8348','2014-04-15','10:50:00',2.57),('8348','2014-04-15','10:55:00',1.91),('8348','2014-04-15','11:00:00',1.27),('8348','2014-04-15','11:05:00',1.44),('8348','2014-04-15','11:10:00',1.88),('8348','2014-04-15','11:15:00',3.02),('8348','2014-04-15','11:20:00',3.08),('8348','2014-04-15','11:25:00',1.62),('8348','2014-04-15','11:30:00',1.09),('8348','2014-04-15','11:35:00',1.31),('8348','2014-04-15','11:40:00',1.13),('8348','2014-04-15','12:05:00',1.64),('8348','2014-04-15','12:10:00',2.6),('8348','2014-04-15','12:15:00',3.73),('8348','2014-04-15','12:20:00',4.76),('8348','2014-04-15','12:25:00',3.35),('8348','2014-04-15','12:30:00',4.92),('8348','2014-04-15','12:35:00',5.05),('8348','2014-04-15','12:40:00',3.1),('8348','2014-04-15','12:45:00',1.53),('8348','2014-04-15','12:50:00',1.25),('8348','2014-04-15','12:55:00',1.71),('8348','2014-04-15','13:00:00',4.86),('8348','2014-04-15','13:05:00',3.14),('8348','2014-04-15','13:10:00',3.29),('8348','2014-04-15','13:15:00',6.86),('8348','2014-04-15','13:20:00',6.65),('8348','2014-04-15','13:25:00',5.98),('8348','2014-04-15','13:30:00',3.8),('8348','2014-04-15','13:35:00',3.02),('8348','2014-04-15','13:40:00',4.33),('8348','2014-04-15','13:45:00',4.13),('8348','2014-04-15','13:50:00',5.8),('8348','2014-04-15','13:55:00',3.29),('8348','2014-04-15','14:00:00',1.61),('8348','2014-04-15','14:05:00',2.14),('8348','2014-04-15','14:10:00',2.14),('8348','2014-04-15','14:15:00',4.8),('8348','2014-04-15','14:20:00',3.5),('8348','2014-04-15','14:25:00',4.09),('8348','2014-04-15','14:30:00',2.95),('8348','2014-04-15','14:35:00',2.76),('8348','2014-04-15','14:40:00',2.71),('8348','2014-04-15','14:45:00',2.55),('8348','2014-04-15','14:50:00',2.65),('8348','2014-04-15','14:55:00',2.63),('8348','2014-04-15','15:00:00',2.61),('8348','2014-04-15','15:05:00',2.74),('8348','2014-04-15','15:10:00',1.54),('8348','2014-04-15','15:15:00',1.17),('8348','2013-10-08','10:55:00',1.01),('8348','2013-10-08','11:00:00',1.51),('8348','2013-10-08','11:10:00',1.57),('8348','2013-10-08','11:15:00',2.62),('8348','2013-10-08','11:20:00',3.3),('8348','2013-10-08','11:25:00',1.84),('8348','2013-10-08','11:30:00',2.23),('8348','2013-10-08','11:35:00',1.62),('8348','2013-10-08','11:40:00',1.39),('8348','2013-10-08','11:45:00',1.26),('8348','2013-10-08','12:20:00',1),('8348','2013-10-08','12:25:00',1.32),('8348','2013-10-08','12:30:00',2.35),('8348','2013-10-08','12:35:00',1.85),('8348','2013-10-08','12:40:00',3.53),('8348','2013-10-08','12:45:00',3.5),('8348','2013-10-08','12:50:00',2.83),('8348','2013-10-08','12:55:00',2.9),('8348','2013-10-08','13:00:00',3.28),('8348','2013-10-08','13:05:00',2.57),('8348','2013-10-08','13:10:00',1.51),('8348','2013-10-08','13:15:00',2.89),('8348','2013-10-08','13:20:00',1.26),('8348','2013-10-08','13:25:00',2.37),('8348','2013-10-08','13:30:00',1.44),('8348','2013-10-08','13:35:00',1.25),('8348','2013-10-08','13:40:00',1.03),('8348','2013-10-08','14:05:00',1.17),('8348','2013-10-08','14:10:00',1.67),('8348','2013-10-08','14:15:00',1.91),('8348','2013-10-08','14:20:00',2.41),('8348','2013-10-08','14:25:00',2.54),('8348','2013-10-08','14:30:00',2.42),('8348','2013-10-08','14:35:00',1.19),('8348','2013-10-08','14:40:00',1.36),('8348','2013-10-08','14:45:00',2.6),('8348','2013-10-08','14:50:00',2.91),('8348','2013-10-08','14:55:00',2.74),('8348','2013-10-08','15:00:00',2.67),('8348','2013-10-08','15:05:00',2.64),('8348','2013-10-08','15:10:00',2.68),('8348','2013-10-08','15:15:00',2.64),('8348','2013-10-08','15:20:00',1.68),('8348','2013-10-08','15:25:00',3.08),('8348','2013-10-08','15:30:00',3.06),('8348','2013-10-08','15:35:00',2.69),('8348','2013-10-08','15:40:00',1.78),('8348','2013-10-08','15:45:00',1.35),('8348','2013-10-08','15:50:00',2.03),('8348','2013-10-08','15:55:00',1.34),('8348','2013-10-08','16:00:00',1.04),('8348','2013-10-07','09:05:00',1.11),('8348','2013-10-07','09:10:00',1.03),('8348','2013-10-07','09:15:00',1.08),('8348','2013-10-07','09:20:00',1.15),('8348','2013-10-07','09:25:00',1.21),('8348','2013-10-07','09:30:00',1.29),('8348','2013-10-07','09:35:00',1.35),('8348','2013-10-07','09:40:00',1.44),('8348','2013-10-07','09:45:00',1.53),('8348','2013-10-07','09:50:00',1.6),('8348','2013-10-07','09:55:00',1.65),('8348','2013-10-07','10:00:00',1.71),('8348','2013-10-07','10:05:00',1.77),('8348','2013-10-07','10:10:00',1.78),('8348','2013-10-07','10:15:00',1.89),('8348','2013-10-07','10:20:00',1.94),('8348','2013-10-07','10:25:00',1.87),('8348','2013-10-07','10:30:00',2.07),('8348','2013-10-07','10:35:00',2.24),('8348','2013-10-07','10:40:00',2.19),('8348','2013-10-07','10:45:00',2.21),('8348','2013-10-07','10:50:00',2.25),('8348','2013-10-07','10:55:00',2.04),('8348','2013-10-07','11:00:00',2.56),('8348','2013-10-07','11:05:00',2.46),('8348','2013-10-07','11:10:00',1.48),('8348','2013-10-07','11:15:00',2.44),('8348','2013-10-07','11:20:00',2.42),('8348','2013-10-07','11:25:00',2.46),('8348','2013-10-07','11:30:00',2.57),('8348','2013-10-07','11:35:00',2.59),('8348','2013-10-07','11:40:00',2.62),('8348','2013-10-07','11:45:00',2.45),('8348','2013-10-07','11:50:00',2.71),('8348','2013-10-07','11:55:00',2.73),('8348','2013-10-07','12:00:00',2.74),('8348','2013-10-07','12:05:00',2.82),('8348','2013-10-07','12:10:00',2.88),('8348','2013-10-07','12:15:00',2.36),('8348','2013-10-07','12:20:00',1.04),('8348','2013-10-07','12:25:00',3.23),('8348','2013-10-07','12:30:00',3.28),('8348','2013-10-07','12:35:00',3.06),('8348','2013-10-07','12:40:00',2.92),('8348','2013-10-07','12:45:00',3.12),('8348','2013-10-07','12:50:00',2.88),('8348','2013-10-07','12:55:00',2.5),('8348','2013-10-07','13:00:00',3.23),('8348','2013-10-07','13:05:00',3.02),('8348','2013-10-07','13:10:00',3.25),('8348','2013-10-07','13:15:00',3.18),('8348','2013-10-07','13:20:00',3.39),('8348','2013-10-07','13:25:00',1.78),('8348','2013-10-07','13:30:00',1.43),('8348','2013-10-07','13:35:00',1.48),('8348','2013-10-07','13:40:00',2.11),('8348','2013-10-07','13:45:00',1.64),('8348','2013-10-07','13:50:00',1.26),('8348','2013-10-07','13:55:00',3.65),('8348','2013-10-07','14:00:00',3.37),('8348','2013-10-07','14:05:00',2.75),('8348','2013-10-07','14:10:00',1.27),('8348','2013-10-07','14:20:00',1.31),('8348','2013-10-07','14:25:00',1.23),('8348','2013-10-07','14:30:00',1.68),('8348','2013-10-07','14:35:00',3.43),('8348','2013-10-07','14:40:00',3.1),('8348','2013-10-07','14:45:00',1.79),('8348','2013-10-07','14:50:00',2.72),('8348','2013-10-07','14:55:00',2.78),('8348','2013-10-07','15:00:00',2.96),('8348','2013-10-07','15:05:00',1.98),('8348','2013-10-07','15:10:00',2.82),('8348','2013-10-07','15:15:00',1.95),('8348','2013-10-07','15:20:00',1.86),('8348','2013-10-07','15:25:00',2.48),('8348','2013-10-07','15:30:00',1.28),('8348','2013-10-07','15:35:00',1.4),('8348','2013-10-07','15:40:00',1.52),('8348','2013-10-07','15:45:00',2.85),('8348','2013-10-07','15:50:00',2.63),('8348','2013-10-07','15:55:00',1.14),('8348','2013-10-07','16:00:00',1.16),('8348','2013-10-07','16:05:00',2.04),('8348','2013-10-07','16:10:00',2.22),('8348','2013-10-07','16:15:00',2.07),('8348','2013-10-07','16:20:00',1.53),('8348','2013-10-07','16:25:00',1.52),('8348','2013-10-07','16:30:00',1.27),('8348','2013-10-07','16:35:00',1.13),('8348','2013-10-07','16:40:00',1.69),('8348','2013-10-07','16:45:00',1.61),('8348','2013-10-07','16:50:00',1.51),('8348','2013-10-07','16:55:00',1.39),('8348','2013-10-07','17:00:00',1.01),('8348','2013-10-07','17:05:00',1.18),('8348','2013-10-07','17:10:00',1.1),('8348','2013-10-07','17:15:00',1.03),('8348','2013-10-06','09:35:00',1.2),('8348','2013-10-06','09:40:00',1.09),('8348','2013-10-06','09:50:00',1.63),('8348','2013-10-06','09:55:00',1.87),('8348','2013-10-06','10:00:00',2.18),('8348','2013-10-06','10:05:00',2.23),('8348','2013-10-06','10:10:00',2.18),('8348','2013-10-06','10:15:00',2.02),('8348','2013-10-06','10:20:00',2.07),('8348','2013-10-06','10:25:00',2.3),('8348','2013-10-06','10:30:00',2.28),('8348','2013-10-06','10:35:00',2.25),('8348','2013-10-06','10:40:00',1.94),('8348','2013-10-06','10:45:00',1.58),('8348','2013-10-06','10:50:00',1.75),('8348','2013-10-06','10:55:00',1.83),('8348','2013-10-06','11:00:00',1.94),('8348','2013-10-06','11:05:00',2.15),('8348','2013-10-06','11:10:00',2.25),('8348','2013-10-06','11:15:00',2.22),('8348','2013-10-06','11:20:00',2.26),('8348','2013-10-06','11:25:00',2.33),('8348','2013-10-06','11:30:00',2.28),('8348','2013-10-06','11:35:00',2.25),('8348','2013-10-06','11:40:00',2.34),('8348','2013-10-06','11:45:00',1.68),('8348','2013-10-06','11:50:00',1.72),('8348','2013-10-06','11:55:00',2.16),('8348','2013-10-06','12:00:00',2.1),('8348','2013-10-06','12:05:00',2.06),('8348','2013-10-06','12:10:00',2.29),('8348','2013-10-06','12:15:00',2.59),('8348','2013-10-06','12:20:00',2.61),('8348','2013-10-06','12:25:00',2.21),('8348','2013-10-06','12:30:00',2.07),('8348','2013-10-06','12:35:00',2.21),('8348','2013-10-06','12:40:00',2.13),('8348','2013-10-06','12:45:00',2.18),('8348','2013-10-06','12:50:00',2.34),('8348','2013-10-06','12:55:00',2.61),('8348','2013-10-06','13:00:00',2.03),('8348','2013-10-06','13:05:00',2.56),('8348','2013-10-06','13:10:00',2.6),('8348','2013-10-06','13:15:00',3.24),('8348','2013-10-06','13:20:00',1.51),('8348','2013-10-06','13:45:00',1.11),('8348','2013-10-06','13:50:00',3.19),('8348','2013-10-06','13:55:00',2.25),('8348','2013-10-06','14:00:00',2.11),('8348','2013-10-06','14:05:00',2.66),('8348','2013-10-06','14:10:00',2.04),('8348','2013-10-06','14:15:00',1.52),('8348','2013-10-06','14:20:00',1.53),('8348','2013-10-06','14:25:00',1.73),('8348','2013-10-06','14:30:00',2.02),('8348','2013-10-06','14:35:00',1.79),('8348','2013-10-06','14:40:00',1.41),('8348','2013-10-06','14:45:00',1.56),('8348','2013-10-06','14:50:00',1.72),('8348','2013-10-06','14:55:00',2.06),('8348','2013-10-06','15:00:00',1.9),('8348','2013-10-06','15:05:00',1.37),('8348','2013-10-06','15:10:00',1.1),('8348','2013-10-06','15:15:00',1.11),('8348','2013-10-05','16:05:00',1.12),('8348','2013-10-05','16:10:00',1.09),('8348','2013-10-05','16:20:00',1.03),('8348','2013-10-05','16:25:00',1.01),('8348','2013-10-04','09:50:00',1.13),('8348','2013-10-04','09:55:00',2.22),('8348','2013-10-04','10:00:00',1.61),('8348','2013-10-04','10:05:00',1.24),('8348','2013-10-04','10:10:00',1.29),('8348','2013-10-04','10:15:00',1.48),('8348','2013-10-04','10:20:00',1.23),('8348','2013-10-04','10:25:00',1.62),('8348','2013-10-04','10:30:00',2.11),('8348','2013-10-04','10:35:00',1.41),('8348','2013-10-04','10:40:00',2.04),('8348','2013-10-04','10:45:00',1.6),('8348','2013-10-04','10:50:00',1.62),('8348','2013-10-04','10:55:00',2.51),('8348','2013-10-04','11:00:00',1.73),('8348','2013-10-04','11:05:00',1.41),('8348','2013-10-04','11:10:00',1.46),('8348','2013-10-04','11:15:00',2.23),('8348','2013-10-04','11:20:00',2.46),('8348','2013-10-04','11:25:00',2.31),('8348','2013-10-04','11:30:00',2.83),('8348','2013-10-04','11:35:00',2.98),('8348','2013-10-04','11:40:00',2.88),('8348','2013-10-04','11:45:00',2.84),('8348','2013-10-04','11:50:00',2.83),('8348','2013-10-04','11:55:00',2.82),('8348','2013-10-04','12:00:00',2.86),('8348','2013-10-04','12:05:00',2.88),('8348','2013-10-04','12:10:00',2.89),('8348','2013-10-04','12:15:00',2.68),('8348','2013-10-04','12:20:00',2.84),('8348','2013-10-04','12:25:00',2.99),('8348','2013-10-04','12:30:00',3.01),('8348','2013-10-04','12:35:00',2.75),('8348','2013-10-04','12:40:00',2.93),('8348','2013-10-04','12:45:00',2.95),('8348','2013-10-04','12:50:00',2.86),('8348','2013-10-04','12:55:00',2.89),('8348','2013-10-04','13:00:00',2.9),('8348','2013-10-04','13:05:00',2.97),('8348','2013-10-04','13:10:00',3),('8348','2013-10-04','13:15:00',3.14),('8348','2013-10-04','13:20:00',3.05),('8348','2013-10-04','13:25:00',2.85),('8348','2013-10-04','13:30:00',3.07),('8348','2013-10-04','13:35:00',3.01),('8348','2013-10-04','13:40:00',2.91),('8348','2013-10-04','13:45:00',2.87),('8348','2013-10-04','13:50:00',2.85),('8348','2013-10-04','13:55:00',2.85),('8348','2013-10-04','14:00:00',2.87),('8348','2013-10-04','14:05:00',2.86),('8348','2013-10-04','14:10:00',2.59),('8348','2013-10-04','14:15:00',2.34),('8348','2013-10-04','14:20:00',2.65),('8348','2013-10-04','14:25:00',2.79),('8348','2013-10-04','14:30:00',2.44),('8348','2013-10-04','14:35:00',1.67),('8348','2013-10-04','14:40:00',1.45),('8348','2013-10-04','14:45:00',1.69),('8348','2013-10-04','14:50:00',2.2),('8348','2013-10-04','14:55:00',2.18),('8348','2013-10-04','15:00:00',1.91),('8348','2013-10-04','15:05:00',2.12),('8348','2013-10-04','15:10:00',1.81),('8348','2013-10-04','15:15:00',1.43),('8348','2013-10-04','15:20:00',1.31),('8348','2013-10-04','15:25:00',2.15),('8348','2013-10-04','15:30:00',2.2),('8348','2013-10-04','15:35:00',1.16),('8348','2013-10-04','16:05:00',1.01),('8348','2013-10-03','09:05:00',1.03),('8348','2013-10-03','09:10:00',1.1),('8348','2013-10-03','09:15:00',1.16),('8348','2013-10-03','09:20:00',1.26),('8348','2013-10-03','09:25:00',1.35),('8348','2013-10-03','09:30:00',1.42),('8348','2013-10-03','09:35:00',1.51),('8348','2013-10-03','09:40:00',1.61),('8348','2013-10-03','09:45:00',1.7),('8348','2013-10-03','09:50:00',1.76),('8348','2013-10-03','09:55:00',1.83),('8348','2013-10-03','10:00:00',1.9),('8348','2013-10-03','10:05:00',1.98),('8348','2013-10-03','10:10:00',2.04),('8348','2013-10-03','10:15:00',2.1),('8348','2013-10-03','10:20:00',2.17),('8348','2013-10-03','10:25:00',2.23),('8348','2013-10-03','10:30:00',2.29),('8348','2013-10-03','10:35:00',2.35),('8348','2013-10-03','10:40:00',2.39),('8348','2013-10-03','10:45:00',2.45),('8348','2013-10-03','10:50:00',2.49),('8348','2013-10-03','10:55:00',2.54),('8348','2013-10-03','11:00:00',2.59),('8348','2013-10-03','11:05:00',2.63),('8348','2013-10-03','11:10:00',2.67),('8348','2013-10-03','11:15:00',2.72),('8348','2013-10-03','11:20:00',2.76),('8348','2013-10-03','11:25:00',2.8),('8348','2013-10-03','11:30:00',2.83),('8348','2013-10-03','11:35:00',2.87),('8348','2013-10-03','11:40:00',2.92),('8348','2013-10-03','11:45:00',2.94),('8348','2013-10-03','11:50:00',2.98),('8348','2013-10-03','11:55:00',3.01),('8348','2013-10-03','12:00:00',3.03),('8348','2013-10-03','12:05:00',3.06),('8348','2013-10-03','12:10:00',3.06),('8348','2013-10-03','12:15:00',3.07),('8348','2013-10-03','12:20:00',3.09),('8348','2013-10-03','12:25:00',3.11),('8348','2013-10-03','12:30:00',3.12),('8348','2013-10-03','12:35:00',3.14),('8348','2013-10-03','12:40:00',3.16),('8348','2013-10-03','12:45:00',3.16),('8348','2013-10-03','12:50:00',3.17),('8348','2013-10-03','12:55:00',3.17),('8348','2013-10-03','13:00:00',3.15),('8348','2013-10-03','13:05:00',3.1),('8348','2013-10-03','13:10:00',3.14),('8348','2013-10-03','13:15:00',3.14),('8348','2013-10-03','13:20:00',3.15),('8348','2013-10-03','13:25:00',3.14),('8348','2013-10-03','13:30:00',3.16),('8348','2013-10-03','13:35:00',3.15),('8348','2013-10-03','13:40:00',3.13),('8348','2013-10-03','13:45:00',3.11),('8348','2013-10-03','13:50:00',3.09),('8348','2013-10-03','13:55:00',3.1),('8348','2013-10-03','14:00:00',3.1),('8348','2013-10-03','14:05:00',3.1),('8348','2013-10-03','14:10:00',3.08),('8348','2013-10-03','14:15:00',3.06),('8348','2013-10-03','14:20:00',3.03),('8348','2013-10-03','14:25:00',3),('8348','2013-10-03','14:30:00',2.98),('8348','2013-10-03','14:35:00',2.95),('8348','2013-10-03','14:40:00',2.91),('8348','2013-10-03','14:45:00',2.88),('8348','2013-10-03','14:50:00',2.86),('8348','2013-10-03','14:55:00',2.83),('8348','2013-10-03','15:00:00',2.77),('8348','2013-10-03','15:05:00',2.74),('8348','2013-10-03','15:10:00',2.7),('8348','2013-10-03','15:15:00',2.66),('8348','2013-10-03','15:20:00',2.61),('8348','2013-10-03','15:25:00',2.58),('8348','2013-10-03','15:30:00',2.53),('8348','2013-10-03','15:35:00',2.47),('8348','2013-10-03','15:40:00',2.41),('8348','2013-10-03','15:45:00',2.36),('8348','2013-10-03','15:50:00',2.31),('8348','2013-10-03','15:55:00',2.26),('8348','2013-10-03','16:00:00',2.2),('8348','2013-10-03','16:05:00',2.14),('8348','2013-10-03','16:10:00',2.08),('8348','2013-10-03','16:15:00',2.02),('8348','2013-10-03','16:20:00',1.95),('8348','2013-10-03','16:25:00',1.89),('8348','2013-10-03','16:30:00',1.82),('8348','2013-10-03','16:35:00',1.75),('8348','2013-10-03','16:40:00',1.68),('8348','2013-10-03','16:45:00',1.61),('8348','2013-10-03','16:50:00',1.53),('8348','2013-10-03','16:55:00',1.45),('8348','2013-10-03','17:00:00',1.38),('8348','2013-10-03','17:05:00',1.3),('8348','2013-10-03','17:10:00',1.23),('8348','2013-10-03','17:15:00',1.14),('8348','2013-10-03','17:20:00',1.06),('8348','2013-10-02','09:10:00',1.05),('8348','2013-10-02','09:15:00',1.15),('8348','2013-10-02','09:20:00',1.22),('8348','2013-10-02','09:25:00',1.3),('8348','2013-10-02','09:30:00',1.36),('8348','2013-10-02','09:35:00',1.45),('8348','2013-10-02','09:40:00',1.55),('8348','2013-10-02','09:45:00',1.62),('8348','2013-10-02','09:50:00',1.68),('8348','2013-10-02','09:55:00',1.75),('8348','2013-10-02','10:00:00',1.8),('8348','2013-10-02','10:05:00',1.86),('8348','2013-10-02','10:10:00',1.92),('8348','2013-10-02','10:15:00',1.97),('8348','2013-10-02','10:20:00',2.04),('8348','2013-10-02','10:25:00',2.1),('8348','2013-10-02','10:30:00',2.15),('8348','2013-10-02','10:35:00',2.21),('8348','2013-10-02','10:40:00',2.28),('8348','2013-10-02','10:45:00',2.34),('8348','2013-10-02','10:50:00',2.4),('8348','2013-10-02','10:55:00',2.45),('8348','2013-10-02','11:00:00',2.5),('8348','2013-10-02','11:05:00',2.55),('8348','2013-10-02','11:10:00',2.59),('8348','2013-10-02','11:15:00',2.63),('8348','2013-10-02','11:20:00',2.66),('8348','2013-10-02','11:25:00',2.69),('8348','2013-10-02','11:30:00',2.73),('8348','2013-10-02','11:35:00',2.75),('8348','2013-10-02','11:40:00',2.78),('8348','2013-10-02','11:45:00',2.82),('8348','2013-10-02','11:50:00',2.85),('8348','2013-10-02','11:55:00',2.88),('8348','2013-10-02','12:00:00',2.9),('8348','2013-10-02','12:05:00',2.91),('8348','2013-10-02','12:10:00',2.93),('8348','2013-10-02','12:15:00',2.95),('8348','2013-10-02','12:20:00',2.97),('8348','2013-10-02','12:25:00',2.97),('8348','2013-10-02','12:30:00',3),('8348','2013-10-02','12:35:00',3.02),('8348','2013-10-02','12:40:00',3.03),('8348','2013-10-02','12:45:00',3.04),('8348','2013-10-02','12:50:00',3.05),('8348','2013-10-02','12:55:00',3.07),('8348','2013-10-02','13:00:00',3.06),('8348','2013-10-02','13:05:00',3.08),('8348','2013-10-02','13:10:00',3.09),('8348','2013-10-02','13:15:00',3.07),('8348','2013-10-02','13:20:00',3.07),('8348','2013-10-02','13:25:00',3.07),('8348','2013-10-02','13:30:00',3.08),('8348','2013-10-02','13:35:00',3.06),('8348','2013-10-02','13:40:00',3.06),('8348','2013-10-02','13:45:00',3.05),('8348','2013-10-02','13:50:00',3.04),('8348','2013-10-02','13:55:00',3.03),('8348','2013-10-02','14:00:00',3.01),('8348','2013-10-02','14:05:00',3),('8348','2013-10-02','14:10:00',2.99),('8348','2013-10-02','14:15:00',2.97),('8348','2013-10-02','14:20:00',2.94),('8348','2013-10-02','14:25:00',2.92),('8348','2013-10-02','14:30:00',2.9),('8348','2013-10-02','14:35:00',2.87),('8348','2013-10-02','14:40:00',2.84),('8348','2013-10-02','14:45:00',2.81),('8348','2013-10-02','14:50:00',2.79),('8348','2013-10-02','14:55:00',2.77),('8348','2013-10-02','15:00:00',2.74),('8348','2013-10-02','15:05:00',2.69),('8348','2013-10-02','15:10:00',2.65),('8348','2013-10-02','15:15:00',2.61),('8348','2013-10-02','15:20:00',2.57),('8348','2013-10-02','15:25:00',2.51),('8348','2013-10-02','15:30:00',2.47),('8348','2013-10-02','15:35:00',2.42),('8348','2013-10-02','15:40:00',2.39),('8348','2013-10-02','15:45:00',2.34),('8348','2013-10-02','15:50:00',2.28),('8348','2013-10-02','15:55:00',2.22),('8348','2013-10-02','16:00:00',2.16),('8348','2013-10-02','16:05:00',2.11),('8348','2013-10-02','16:10:00',2.05),('8348','2013-10-02','16:15:00',1.99),('8348','2013-10-02','16:20:00',1.91),('8348','2013-10-02','16:25:00',1.85),('8348','2013-10-02','16:30:00',1.79),('8348','2013-10-02','16:35:00',1.73),('8348','2013-10-02','16:40:00',1.66),('8348','2013-10-02','16:45:00',1.58),('8348','2013-10-02','16:50:00',1.5),('8348','2013-10-02','16:55:00',1.43),('8348','2013-10-02','17:00:00',1.36),('8348','2013-10-02','17:05:00',1.28),('8348','2013-10-02','17:10:00',1.19),('8348','2013-10-02','17:15:00',1.11),('8348','2013-10-02','17:20:00',1.03),('8348','2013-10-01','09:05:00',1.02),('8348','2013-10-01','09:10:00',1.09),('8348','2013-10-01','09:15:00',1.16),('8348','2013-10-01','09:20:00',1.23),('8348','2013-10-01','09:25:00',1.3),('8348','2013-10-01','09:30:00',1.37),('8348','2013-10-01','09:35:00',1.45),('8348','2013-10-01','09:40:00',1.53),('8348','2013-10-01','09:45:00',1.6),('8348','2013-10-01','09:50:00',1.67),('8348','2013-10-01','09:55:00',1.72),('8348','2013-10-01','10:00:00',1.78),('8348','2013-10-01','10:05:00',1.82),('8348','2013-10-01','10:10:00',1.87),('8348','2013-10-01','10:15:00',1.96),('8348','2013-10-01','10:20:00',2.04),('8348','2013-10-01','10:25:00',2.08),('8348','2013-10-01','10:30:00',2.13),('8348','2013-10-01','10:35:00',2.19),('8348','2013-10-01','10:40:00',2.23),('8348','2013-10-01','10:45:00',2.27),('8348','2013-10-01','10:50:00',2.34),('8348','2013-10-01','10:55:00',2.38),('8348','2013-10-01','11:00:00',2.46),('8348','2013-10-01','11:05:00',2.66),('8348','2013-10-01','11:10:00',2.07),('8348','2013-10-01','11:15:00',1.06),('8348','2013-10-01','11:20:00',2.82),('8348','2013-10-01','11:25:00',2.57),('8348','2013-10-01','11:35:00',2.43),('8348','2013-10-01','11:40:00',2.97),('8348','2013-10-01','11:45:00',2.95),('8348','2013-10-01','11:50:00',2.59),('8348','2013-10-01','11:55:00',2.21),('8348','2013-10-01','12:00:00',3.03),('8348','2013-10-01','12:05:00',2.97),('8348','2013-10-01','12:10:00',3.01),('8348','2013-10-01','12:15:00',3.1),('8348','2013-10-01','12:20:00',3.14),('8348','2013-10-01','12:25:00',3.15),('8348','2013-10-01','12:30:00',2.95),('8348','2013-10-01','12:35:00',2.11),('8348','2013-10-01','12:40:00',1.93),('8348','2013-10-01','12:45:00',3.33),('8348','2013-10-01','12:50:00',3.17),('8348','2013-10-01','12:55:00',2.69),('8348','2013-10-01','13:00:00',3.21),('8348','2013-10-01','13:05:00',2.39),('8348','2013-10-01','13:15:00',1.86),('8348','2013-10-01','13:20:00',3.46),('8348','2013-10-01','13:25:00',3.57),('8348','2013-10-01','13:30:00',2.63),('8348','2013-10-01','13:35:00',3.44),('8348','2013-10-01','13:40:00',3.13),('8348','2013-10-01','13:45:00',3.18),('8348','2013-10-01','13:50:00',3.21),('8348','2013-10-01','13:55:00',3.06),('8348','2013-10-01','14:00:00',2.99),('8348','2013-10-01','14:05:00',2.99),('8348','2013-10-01','14:10:00',2.96),('8348','2013-10-01','14:15:00',2.91),('8348','2013-10-01','14:20:00',2.9),('8348','2013-10-01','14:25:00',2.91),('8348','2013-10-01','14:30:00',2.87),('8348','2013-10-01','14:35:00',2.84),('8348','2013-10-01','14:40:00',2.88),('8348','2013-10-01','14:45:00',2.93),('8348','2013-10-01','14:50:00',2.92),('8348','2013-10-01','14:55:00',2.84),('8348','2013-10-01','15:00:00',2.85),('8348','2013-10-01','15:05:00',2.74),('8348','2013-10-01','15:10:00',2.66),('8348','2013-10-01','15:15:00',2.62),('8348','2013-10-01','15:20:00',2.58),('8348','2013-10-01','15:25:00',2.55),('8348','2013-10-01','15:30:00',2.5),('8348','2013-10-01','15:35:00',2.46),('8348','2013-10-01','15:40:00',2.41),('8348','2013-10-01','15:45:00',2.35),('8348','2013-10-01','15:50:00',2.3),('8348','2013-10-01','15:55:00',2.24),('8348','2013-10-01','16:00:00',2.18),('8348','2013-10-01','16:05:00',2.13),('8348','2013-10-01','16:10:00',2.06),('8348','2013-10-01','16:15:00',2),('8348','2013-10-01','16:20:00',1.94),('8348','2013-10-01','16:25:00',1.88),('8348','2013-10-01','16:30:00',1.81),('8348','2013-10-01','16:35:00',1.74),('8348','2013-10-01','16:40:00',1.66),('8348','2013-10-01','16:45:00',1.59),('8348','2013-10-01','16:50:00',1.52),('8348','2013-10-01','16:55:00',1.46),('8348','2013-10-01','17:00:00',1.38),('8348','2013-10-01','17:05:00',1.3),('8348','2013-10-01','17:10:00',1.24),('8348','2013-10-01','17:15:00',1.14),('8348','2013-10-01','17:20:00',1.09),('8348','2013-10-01','17:25:00',1.01),('8348','2013-09-30','09:50:00',1.07),('8348','2013-09-30','10:25:00',1.08),('8348','2013-09-30','10:30:00',1.21),('8348','2013-09-30','10:35:00',1.33),('8348','2013-09-30','10:40:00',1.67),('8348','2013-09-30','10:45:00',2.45),('8348','2013-09-30','10:50:00',2.55),('8348','2013-09-30','10:55:00',2.38),('8348','2013-09-30','11:00:00',2.01),('8348','2013-09-30','11:05:00',2.19),('8348','2013-09-30','11:10:00',2.48),('8348','2013-09-30','11:15:00',2.17),('8348','2013-09-30','11:20:00',2.59),('8348','2013-09-30','11:25:00',1.56),('8348','2013-09-30','11:30:00',2.04),('8348','2013-09-30','11:40:00',3.28),('8348','2013-09-30','11:45:00',1.5),('8348','2013-09-30','11:50:00',1.35),('8348','2013-09-30','11:55:00',1.18),('8348','2013-09-30','12:00:00',1.51),('8348','2013-09-30','12:05:00',2.36),('8348','2013-09-30','12:10:00',2.34),('8348','2013-09-30','12:15:00',3.21),('8348','2013-09-30','12:20:00',3.34),('8348','2013-09-30','12:25:00',3.28),('8348','2013-09-30','12:30:00',3.14),('8348','2013-09-30','12:35:00',3.13),('8348','2013-09-30','12:40:00',3.03),('8348','2013-09-30','12:45:00',2.91),('8348','2013-09-30','12:50:00',3.2),('8348','2013-09-30','12:55:00',3.22),('8348','2013-09-30','13:00:00',2.98),('8348','2013-09-30','13:05:00',3.39),('8348','2013-09-30','13:10:00',3.16),('8348','2013-09-30','13:15:00',2.83),('8348','2013-09-30','13:20:00',3.71),('8348','2013-09-30','13:25:00',3.86),('8348','2013-09-30','13:30:00',3.56),('8348','2013-09-30','13:35:00',2.69),('8348','2013-09-30','13:40:00',2.56),('8348','2013-09-30','13:45:00',1.21),('8348','2013-09-30','13:50:00',3.19),('8348','2013-09-30','13:55:00',2.24),('8348','2013-09-30','14:00:00',1.26),('8348','2013-09-30','14:05:00',1.21),('8348','2013-09-30','14:10:00',1.19),('8348','2013-09-30','14:15:00',1.11),('8348','2013-09-30','14:25:00',1.06),('8348','2013-09-30','14:30:00',2.3),('8348','2013-09-30','14:35:00',2.46),('8348','2013-09-30','14:40:00',3.41),('8348','2013-09-30','14:45:00',2.66),('8348','2013-09-30','14:50:00',3.15),('8348','2013-09-30','14:55:00',1.64),('8348','2013-09-30','15:00:00',2.11),('8348','2013-09-30','15:05:00',2.56),('8348','2013-09-30','15:10:00',2.91),('8348','2013-09-30','15:15:00',1.38),('8348','2013-09-30','15:20:00',1.39),('8348','2013-09-30','15:25:00',2.98),('8348','2013-09-30','15:30:00',1.38),('8348','2013-09-30','15:35:00',2.68),('8348','2013-09-30','15:40:00',2.97),('8348','2013-09-30','15:45:00',1.57),('8348','2013-09-30','16:10:00',1.45),('8348','2013-09-30','16:15:00',1.76),('8348','2013-09-30','16:20:00',1.24),('8348','2013-09-30','16:45:00',1.18),('8348','2013-09-29','10:00:00',1.06),('8348','2013-09-29','10:05:00',1.38),('8348','2013-09-29','10:10:00',1.58),('8348','2013-09-29','10:15:00',1.98),('8348','2013-09-29','10:20:00',1.61),('8348','2013-09-29','10:25:00',1.54),('8348','2013-09-29','10:30:00',1.8),('8348','2013-09-29','10:35:00',1.95),('8348','2013-09-29','10:40:00',2.1),('8348','2013-09-29','10:45:00',2.08),('8348','2013-09-29','10:50:00',2.16),('8348','2013-09-29','10:55:00',2.15),('8348','2013-09-29','11:00:00',2.21),('8348','2013-09-29','11:05:00',2.15),('8348','2013-09-29','11:10:00',2.16),('8348','2013-09-29','11:15:00',2.34),('8348','2013-09-29','11:20:00',2.31),('8348','2013-09-29','11:25:00',2.19),('8348','2013-09-29','11:30:00',2.38),('8348','2013-09-29','11:35:00',2.35),('8348','2013-09-29','11:40:00',2.39),('8348','2013-09-29','11:45:00',2.43),('8348','2013-09-29','11:50:00',2.62),('8348','2013-09-29','11:55:00',2.64),('8348','2013-09-29','12:00:00',2.36),('8348','2013-09-29','12:05:00',2.42),('8348','2013-09-29','12:10:00',2.81),('8348','2013-09-29','12:15:00',3.03),('8348','2013-09-29','12:20:00',1.97),('8348','2013-09-29','12:25:00',1.61),('8348','2013-09-29','12:30:00',1.66),('8348','2013-09-29','12:35:00',1.62),('8348','2013-09-29','12:40:00',1.4),('8348','2013-09-29','12:45:00',1.23),('8348','2013-09-29','12:50:00',1.21),('8348','2013-09-29','12:55:00',1.07),('8348','2013-09-29','13:00:00',1.02),('8348','2013-09-29','13:25:00',1.22),('8348','2013-09-29','13:30:00',1.7),('8348','2013-09-29','13:35:00',1.65),('8348','2013-09-29','13:40:00',1.55),('8348','2013-09-29','13:45:00',1.4),('8348','2013-09-29','13:50:00',1.51),('8348','2013-09-29','13:55:00',1.75),('8348','2013-09-29','14:00:00',1.65),('8348','2013-09-29','14:05:00',2.05),('8348','2013-09-29','14:10:00',1.24),('8348','2013-09-29','14:15:00',1.48),('8348','2013-09-29','14:20:00',2.17),('8348','2013-09-29','14:25:00',1.24),('8348','2013-09-29','14:30:00',1.07),('8348','2013-09-29','15:00:00',1.1),('8348','2013-09-29','16:00:00',1.03),('8348','2013-09-29','16:30:00',1.03),('8348','2014-04-14','06:55:00',1.02),('8348','2014-04-14','07:00:00',1.11),('8348','2014-04-14','07:05:00',1.2),('8348','2014-04-14','07:10:00',1.3),('8348','2014-04-14','07:15:00',1.46),('8348','2014-04-14','07:20:00',1.67),('8348','2014-04-14','07:25:00',1.76),('8348','2014-04-14','07:30:00',1.89),('8348','2014-04-14','07:35:00',1.99),('8348','2014-04-14','07:40:00',2.11),('8348','2014-04-14','07:45:00',2.22),('8348','2014-04-14','07:50:00',2.34),('8348','2014-04-14','07:55:00',2.48),('8348','2014-04-14','08:00:00',2.69),('8348','2014-04-14','08:05:00',3.03),('8348','2014-04-14','08:10:00',3.27),('8348','2014-04-14','08:15:00',3.43),('8348','2014-04-14','08:20:00',3.59),('8348','2014-04-14','08:25:00',3.74),('8348','2014-04-14','08:30:00',3.86),('8348','2014-04-14','08:35:00',4.05),('8348','2014-04-14','08:40:00',4.21),('8348','2014-04-14','08:45:00',4.33),('8348','2014-04-14','08:50:00',4.47),('8348','2014-04-14','08:55:00',4.59),('8348','2014-04-14','09:00:00',4.72),('8348','2014-04-14','09:05:00',4.83),('8348','2014-04-14','09:10:00',4.96),('8348','2014-04-14','09:15:00',5.08),('8348','2014-04-14','09:20:00',5.21),('8348','2014-04-14','09:25:00',5.3),('8348','2014-04-14','09:30:00',5.4),('8348','2014-04-14','09:35:00',5.48),('8348','2014-04-14','09:40:00',5.62),('8348','2014-04-14','09:45:00',5.7),('8348','2014-04-14','09:50:00',5.8),('8348','2014-04-14','09:55:00',5.9),('8348','2014-04-14','10:00:00',5.97),('8348','2014-04-14','10:05:00',6.04),('8348','2014-04-14','10:10:00',6.1),('8348','2014-04-14','10:15:00',6.19),('8348','2014-04-14','10:20:00',6.23),('8348','2014-04-14','10:25:00',6.29),('8348','2014-04-14','10:30:00',6.44),('8348','2014-04-14','10:35:00',6.5),('8348','2014-04-14','10:40:00',6.55),('8348','2014-04-14','10:45:00',6.63),('8348','2014-04-14','10:50:00',6.7),('8348','2014-04-14','10:55:00',6.74),('8348','2014-04-14','11:00:00',6.78),('8348','2014-04-14','11:05:00',6.83),('8348','2014-04-14','11:10:00',6.86),('8348','2014-04-14','11:15:00',6.91),('8348','2014-04-14','11:20:00',6.95),('8348','2014-04-14','11:25:00',7.03),('8348','2014-04-14','11:30:00',7.04),('8348','2014-04-14','11:35:00',7.07),('8348','2014-04-14','11:40:00',7.11),('8348','2014-04-14','11:45:00',7.17),('8348','2014-04-14','11:50:00',7.14),('8348','2014-04-14','11:55:00',7.25),('8348','2014-04-14','12:00:00',7.3),('8348','2014-04-14','12:05:00',7.33),('8348','2014-04-14','12:10:00',7.21),('8348','2014-04-14','12:15:00',7.33),('8348','2014-04-14','12:20:00',7.37),('8348','2014-04-14','12:25:00',7.4),('8348','2014-04-14','12:30:00',7.41),('8348','2014-04-14','12:35:00',7.47),('8348','2014-04-14','12:40:00',7.49),('8348','2014-04-14','12:45:00',7.45),('8348','2014-04-14','12:50:00',7.38),('8348','2014-04-14','12:55:00',7.4),('8348','2014-04-14','13:00:00',7.42),('8348','2014-04-14','13:05:00',7.38),('8348','2014-04-14','13:10:00',7.39),('8348','2014-04-14','13:15:00',7.4),('8348','2014-04-14','13:20:00',7.39),('8348','2014-04-14','13:25:00',7.41),('8348','2014-04-14','13:30:00',7.35),('8348','2014-04-14','13:35:00',7.3),('8348','2014-04-14','13:40:00',7.27),('8348','2014-04-14','13:45:00',7.2),('8348','2014-04-14','13:50:00',7.15),('8348','2014-04-14','13:55:00',7.07),('8348','2014-04-14','14:00:00',7.03),('8348','2014-04-14','14:05:00',7),('8348','2014-04-14','14:10:00',6.97),('8348','2014-04-14','14:15:00',6.91),('8348','2014-04-14','14:20:00',6.84),('8348','2014-04-14','14:25:00',6.75),('8348','2014-04-14','14:30:00',6.69),('8348','2014-04-14','14:35:00',6.59),('8348','2014-04-14','14:40:00',6.53),('8348','2014-04-14','14:45:00',6.41),('8348','2014-04-14','14:50:00',6.28),('8348','2014-04-14','14:55:00',6.22),('8348','2014-04-14','15:00:00',6.11),('8348','2014-04-14','15:05:00',6),('8348','2014-04-14','15:10:00',5.91),('8348','2014-04-14','15:15:00',5.8),('8348','2014-04-14','15:20:00',5.69),('8348','2014-04-14','15:25:00',5.58),('8348','2014-04-14','15:30:00',5.46),('8348','2014-04-14','15:35:00',5.34),('8348','2014-04-14','15:40:00',5.2),('8348','2014-04-14','15:45:00',5.06),('8348','2014-04-14','15:50:00',4.95),('8348','2014-04-14','15:55:00',4.81),('8348','2014-04-14','16:00:00',4.66),('8348','2014-04-14','16:05:00',4.51),('8348','2014-04-14','16:10:00',4.35),('8348','2014-04-14','16:15:00',4.22),('8348','2014-04-14','16:20:00',4.07),('8348','2014-04-14','16:25:00',3.93),('8348','2014-04-14','16:30:00',3.74),('8348','2014-04-14','16:35:00',3.53),('8348','2014-04-14','16:40:00',3.37),('8348','2014-04-14','16:45:00',3.24),('8348','2014-04-14','16:50:00',3.05),('8348','2014-04-14','16:55:00',2.87),('8348','2014-04-14','17:00:00',2.72),('8348','2014-04-14','17:05:00',2.55),('8348','2014-04-14','17:10:00',2.39),('8348','2014-04-14','17:15:00',2.18),('8348','2014-04-14','17:20:00',2.04),('8348','2014-04-14','17:25:00',1.9),('8348','2014-04-14','17:30:00',1.73),('8348','2014-04-14','17:35:00',1.56),('8348','2014-04-14','17:40:00',1.41),('8348','2014-04-14','17:45:00',1.23),('8348','2014-04-14','17:50:00',1.05),('8348','2013-09-28','09:05:00',1),('8348','2013-09-28','09:10:00',1.08),('8348','2013-09-28','09:15:00',1.13),('8348','2013-09-28','09:20:00',1.15),('8348','2013-09-28','09:25:00',1.27),('8348','2013-09-28','09:30:00',1.37),('8348','2013-09-28','09:35:00',1.44),('8348','2013-09-28','09:40:00',1.53),('8348','2013-09-28','09:45:00',1.63),('8348','2013-09-28','09:50:00',1.73),('8348','2013-09-28','09:55:00',1.62),('8348','2013-09-28','10:00:00',1.65),('8348','2013-09-28','10:05:00',1.04),('8348','2013-09-28','10:15:00',1.15),('8348','2013-09-28','10:20:00',1.73),('8348','2013-09-28','10:25:00',1.03),('8348','2013-09-28','10:30:00',2.32),('8348','2013-09-28','10:35:00',1.44),('8348','2013-09-28','10:40:00',1.41),('8348','2013-09-28','10:45:00',2.38),('8348','2013-09-28','10:50:00',2.83),('8348','2013-09-28','10:55:00',1.95),('8348','2013-09-28','11:00:00',1.06),('8348','2013-09-28','11:15:00',2.33),('8348','2013-09-28','11:20:00',2.95),('8348','2013-09-28','11:25:00',3.05),('8348','2013-09-28','11:30:00',2.9),('8348','2013-09-28','11:35:00',1.83),('8348','2013-09-28','11:40:00',1.23),('8348','2013-09-28','11:50:00',1.27),('8348','2013-09-28','11:55:00',1.15),('8348','2013-09-28','12:00:00',2.31),('8348','2013-09-28','12:05:00',3.1),('8348','2013-09-28','12:10:00',2.85),('8348','2013-09-28','12:15:00',2.82),('8348','2013-09-28','12:20:00',2.99),('8348','2013-09-28','12:25:00',1.91),('8348','2013-09-28','12:30:00',2.67),('8348','2013-09-28','12:35:00',1.91),('8348','2013-09-28','12:40:00',2.5),('8348','2013-09-28','12:45:00',2.81),('8348','2013-09-28','12:50:00',1.16),('8348','2013-09-28','12:55:00',3.27),('8348','2013-09-28','13:00:00',3.39),('8348','2013-09-28','13:05:00',1.26),('8348','2013-09-28','13:10:00',1.03),('8348','2013-09-28','13:15:00',1.26),('8348','2013-09-28','13:20:00',1.51),('8348','2013-09-28','13:25:00',2.78),('8348','2013-09-28','13:30:00',2),('8348','2013-09-28','13:35:00',1.4),('8348','2013-09-28','13:40:00',1.37),('8348','2013-09-28','13:45:00',2.41),('8348','2013-09-28','13:50:00',1.31),('8348','2013-09-28','13:55:00',1.3),('8348','2013-09-28','14:00:00',1.23),('8348','2013-09-28','14:05:00',1.53),('8348','2013-09-28','14:10:00',1.92),('8348','2013-09-28','14:15:00',2.78),('8348','2013-09-28','14:20:00',3.45),('8348','2013-09-28','14:25:00',2.84),('8348','2013-09-28','14:30:00',3.14),('8348','2013-09-28','14:35:00',3.25),('8348','2013-09-28','14:40:00',3.2),('8348','2013-09-28','14:45:00',3.17),('8348','2013-09-28','14:50:00',1.56),('8348','2013-09-28','14:55:00',2.37),('8348','2013-09-28','15:00:00',3.09),('8348','2013-09-28','15:05:00',2.12),('8348','2013-09-28','15:10:00',2.73),('8348','2013-09-28','15:15:00',2.37),('8348','2013-09-28','15:20:00',2.61),('8348','2013-09-28','15:25:00',2.72),('8348','2013-09-28','15:30:00',2.65),('8348','2013-09-28','15:35:00',2.51),('8348','2013-09-28','15:40:00',2.47),('8348','2013-09-28','15:45:00',2.31),('8348','2013-09-28','15:50:00',2.01),('8348','2013-09-28','15:55:00',1.88),('8348','2013-09-28','16:00:00',2.21),('8348','2013-09-28','16:05:00',2.22),('8348','2013-09-28','16:10:00',2.23),('8348','2013-09-28','16:15:00',2),('8348','2013-09-28','16:25:00',1.7),('8348','2013-09-28','16:30:00',1.73),('8348','2013-09-28','16:35:00',1.71),('8348','2013-09-28','16:40:00',1.64),('8348','2013-09-28','16:45:00',1.57),('8348','2013-09-28','16:50:00',1.52),('8348','2013-09-28','16:55:00',1.45),('8348','2013-09-28','17:00:00',1.35),('8348','2013-09-28','17:05:00',1.29),('8348','2013-09-28','17:10:00',1.21),('8348','2013-09-28','17:15:00',1.13),('8348','2013-09-28','17:20:00',1.06),('8348','2013-09-27','08:55:00',1.11),('8348','2013-09-27','09:50:00',1.19),('8348','2013-09-27','09:55:00',1.37),('8348','2013-09-27','10:00:00',1.56),('8348','2013-09-27','10:05:00',2.02),('8348','2013-09-27','10:10:00',1.38),('8348','2013-09-27','10:15:00',1.3),('8348','2013-09-27','10:20:00',1.85),('8348','2013-09-27','10:25:00',1.53),('8348','2013-09-27','10:30:00',1.15),('8348','2013-09-27','10:45:00',1.6),('8348','2013-09-27','10:50:00',1.65),('8348','2013-09-27','10:55:00',2.29),('8348','2013-09-27','11:00:00',2.4),('8348','2013-09-27','11:05:00',2.33),('8348','2013-09-27','11:10:00',1.67),('8348','2013-09-27','11:15:00',2.42),('8348','2013-09-27','11:20:00',2.73),('8348','2013-09-27','11:25:00',2.38),('8348','2013-09-27','11:30:00',2.4),('8348','2013-09-27','11:45:00',1.31),('8348','2013-09-27','11:50:00',1.2),('8348','2013-09-27','11:55:00',1.82),('8348','2013-09-27','12:00:00',2.26),('8348','2013-09-27','12:05:00',1.56),('8348','2013-09-27','12:10:00',2.83),('8348','2013-09-27','12:15:00',1.12),('8348','2013-09-27','12:45:00',2.76),('8348','2013-09-27','12:50:00',2.71),('8348','2013-09-27','12:55:00',3.02),('8348','2013-09-27','13:00:00',2.98),('8348','2013-09-27','13:05:00',2.36),('8348','2013-09-27','13:10:00',2.45),('8348','2013-09-27','13:15:00',1.93),('8348','2013-09-27','13:20:00',2.66),('8348','2013-09-27','13:25:00',1.58),('8348','2013-09-27','13:40:00',2.25),('8348','2013-09-27','13:45:00',2.29),('8348','2013-09-27','13:50:00',1.54),('8348','2013-09-27','13:55:00',1.25),('8348','2013-09-27','14:00:00',1.58),('8348','2013-09-27','14:05:00',3.26),('8348','2013-09-27','14:10:00',2.77),('8348','2013-09-27','14:15:00',2.56),('8348','2013-09-27','14:20:00',3.13),('8348','2013-09-27','14:25:00',3.08),('8348','2013-09-27','14:30:00',2.89),('8348','2013-09-27','14:35:00',2.92),('8348','2013-09-27','14:40:00',2.94),('8348','2013-09-27','14:45:00',2.84),('8348','2013-09-27','14:50:00',2.72),('8348','2013-09-27','14:55:00',2.57),('8348','2013-09-27','15:00:00',2.42),('8348','2013-09-27','15:05:00',1.51),('8348','2013-09-27','15:10:00',2.4),('8348','2013-09-27','15:15:00',2.68),('8348','2013-09-27','15:20:00',1.28),('8348','2013-09-27','15:25:00',2.05),('8348','2013-09-27','15:30:00',2.65),('8348','2013-09-27','15:35:00',2.12),('8348','2013-09-27','15:40:00',2.2),('8348','2013-09-27','15:45:00',1.31),('8348','2013-09-27','15:50:00',2.19),('8348','2013-09-27','15:55:00',2.36),('8348','2013-09-27','16:00:00',1.42),('8348','2013-09-27','16:05:00',1.54),('8348','2013-09-27','16:15:00',1.61),('8348','2013-09-27','16:20:00',2.04),('8348','2013-09-27','16:25:00',1.74),('8348','2013-09-27','16:30:00',1.68),('8348','2013-09-27','16:35:00',1.78),('8348','2013-09-27','16:40:00',1.68),('8348','2013-09-27','16:45:00',1.66),('8348','2013-09-27','16:50:00',1.58),('8348','2013-09-27','16:55:00',1.26),('8348','2013-09-27','17:10:00',1.35),('8348','2013-09-27','17:15:00',1.34),('8348','2013-09-27','17:20:00',1.17),('8348','2013-09-27','17:25:00',1.07),('8348','2013-09-26','09:00:00',1.01),('8348','2013-09-26','09:05:00',1.08),('8348','2013-09-26','09:10:00',1.15),('8348','2013-09-26','09:15:00',1.24),('8348','2013-09-26','09:20:00',1.32),('8348','2013-09-26','09:25:00',1.37),('8348','2013-09-26','09:30:00',1.44),('8348','2013-09-26','09:35:00',1.53),('8348','2013-09-26','09:40:00',1.6),('8348','2013-09-26','09:45:00',1.67),('8348','2013-09-26','09:50:00',1.74),('8348','2013-09-26','09:55:00',1.79),('8348','2013-09-26','10:00:00',1.83),('8348','2013-09-26','10:05:00',1.88),('8348','2013-09-26','10:10:00',1.96),('8348','2013-09-26','10:15:00',1.98),('8348','2013-09-26','10:20:00',1.97),('8348','2013-09-26','10:25:00',2.04),('8348','2013-09-26','10:30:00',2.1),('8348','2013-09-26','10:35:00',2.2),('8348','2013-09-26','10:40:00',2.18),('8348','2013-09-26','10:45:00',2.24),('8348','2013-09-26','10:50:00',2.32),('8348','2013-09-26','10:55:00',2.4),('8348','2013-09-26','11:00:00',2.36),('8348','2013-09-26','11:05:00',2.36),('8348','2013-09-26','11:10:00',2.4),('8348','2013-09-26','11:15:00',2.48),('8348','2013-09-26','11:20:00',2.54),('8348','2013-09-26','11:25:00',2.49),('8348','2013-09-26','11:30:00',2.47),('8348','2013-09-26','11:35:00',1.45),('8348','2013-09-26','11:40:00',2.12),('8348','2013-09-26','11:45:00',2.73),('8348','2013-09-26','11:50:00',2.55),('8348','2013-09-26','11:55:00',1.79),('8348','2013-09-26','12:00:00',2.95),('8348','2013-09-26','12:05:00',2.18),('8348','2013-09-26','12:15:00',1.05),('8348','2013-09-26','12:20:00',1.28),('8348','2013-09-26','12:25:00',1.08),('8348','2013-09-26','12:30:00',1.29),('8348','2013-09-26','12:35:00',1.4),('8348','2013-09-26','12:40:00',1.42),('8348','2013-09-26','12:45:00',1.38),('8348','2013-09-26','12:50:00',1.34),('8348','2013-09-26','12:55:00',2.5),('8348','2013-09-26','13:00:00',3.05),('8348','2013-09-26','13:05:00',2.29),('8348','2013-09-26','13:10:00',1.47),('8348','2013-09-26','13:15:00',2.74),('8348','2013-09-26','13:20:00',3.47),('8348','2013-09-26','13:25:00',2.89),('8348','2013-09-26','13:30:00',1.94),('8348','2013-09-26','13:35:00',1.77),('8348','2013-09-26','13:40:00',2.01),('8348','2013-09-26','13:45:00',1.25),('8348','2013-09-26','13:50:00',1.69),('8348','2013-09-26','13:55:00',1.67),('8348','2013-09-26','14:00:00',2.53),('8348','2013-09-26','14:05:00',2.43),('8348','2013-09-26','14:10:00',3.09),('8348','2013-09-26','14:15:00',3.41),('8348','2013-09-26','14:20:00',2.09),('8348','2013-09-26','14:30:00',1.85),('8348','2013-09-26','14:35:00',1.84),('8348','2013-09-26','14:40:00',1.42),('8348','2013-09-26','14:45:00',3.39),('8348','2013-09-26','14:50:00',2.86),('8348','2013-09-26','14:55:00',1.25),('8348','2013-09-26','15:00:00',1),('8348','2013-09-26','15:05:00',1.34),('8348','2013-09-26','15:15:00',1.12),('8348','2013-09-26','15:20:00',1.91),('8348','2013-09-26','15:25:00',1.95),('8348','2013-09-26','15:35:00',1.96),('8348','2013-09-26','15:45:00',1.96),('8348','2013-09-26','15:50:00',2.54),('8348','2013-09-26','15:55:00',2.34),('8348','2013-09-26','16:00:00',2.26),('8348','2013-09-26','16:05:00',2.19),('8348','2013-09-26','16:10:00',2.13),('8348','2013-09-26','16:15:00',2.02),('8348','2013-09-26','16:20:00',2.01),('8348','2013-09-26','16:25:00',2.01),('8348','2013-09-26','16:30:00',1.89),('8348','2013-09-26','16:35:00',1.81),('8348','2013-09-26','16:40:00',1.73),('8348','2013-09-26','16:45:00',1.66),('8348','2013-09-26','16:50:00',1.58),('8348','2013-09-26','16:55:00',1.52),('8348','2013-09-26','17:00:00',1.42),('8348','2013-09-26','17:05:00',1.37),('8348','2013-09-26','17:10:00',1.35),('8348','2013-09-26','17:15:00',1.25),('8348','2013-09-26','17:25:00',1),('8348','2013-09-26','17:30:00',1.06),('8348','2013-09-25','09:05:00',1.09),('8348','2013-09-25','09:10:00',1.64),('8348','2013-09-25','09:15:00',1.18),('8348','2013-09-25','09:25:00',1.21),('8348','2013-09-25','09:30:00',1.43),('8348','2013-09-25','09:35:00',1.51),('8348','2013-09-25','09:40:00',1.57),('8348','2013-09-25','09:50:00',1.26),('8348','2013-09-25','09:55:00',1.55),('8348','2013-09-25','10:00:00',1.94),('8348','2013-09-25','10:05:00',1),('8348','2013-09-25','10:20:00',1.31),('8348','2013-09-25','10:25:00',1.77),('8348','2013-09-25','10:30:00',1.14),('8348','2013-09-25','10:35:00',1.06),('8348','2013-09-25','10:40:00',1.36),('8348','2013-09-25','10:45:00',2.66),('8348','2013-09-25','10:50:00',2.98),('8348','2013-09-25','10:55:00',2.75),('8348','2013-09-25','11:00:00',1.41),('8348','2013-09-25','11:10:00',1.38),('8348','2013-09-25','11:15:00',2.19),('8348','2013-09-25','11:20:00',2.7),('8348','2013-09-25','11:25:00',2.73),('8348','2013-09-25','11:30:00',2.62),('8348','2013-09-25','11:35:00',1.8),('8348','2013-09-25','11:40:00',2.44),('8348','2013-09-25','11:45:00',2.91),('8348','2013-09-25','11:50:00',2.5),('8348','2013-09-25','11:55:00',1.56),('8348','2013-09-25','12:15:00',3.24),('8348','2013-09-25','12:20:00',2.4),('8348','2013-09-25','12:25:00',1.7),('8348','2013-09-25','12:30:00',2.57),('8348','2013-09-25','12:35:00',3.15),('8348','2013-09-25','12:40:00',1.9),('8348','2013-09-25','12:50:00',1.05),('8348','2013-09-25','13:00:00',1.02),('8348','2013-09-25','13:05:00',2.49),('8348','2013-09-25','13:25:00',1.28),('8348','2013-09-25','13:30:00',1.06),('8348','2013-09-25','13:35:00',2.92),('8348','2013-09-25','13:40:00',3.7),('8348','2013-09-25','13:45:00',3.68),('8348','2013-09-25','13:50:00',3.61),('8348','2013-09-25','13:55:00',2.33),('8348','2013-09-25','14:10:00',1.13),('8348','2013-09-25','14:30:00',1.55),('8348','2013-09-25','14:35:00',1.6),('8348','2013-09-25','14:40:00',3.64),('8348','2013-09-25','14:45:00',1.55),('8348','2013-09-25','14:50:00',2.88),('8348','2013-09-25','14:55:00',2.7),('8348','2013-09-25','15:00:00',3.16),('8348','2013-09-25','15:05:00',3.16),('8348','2013-09-25','15:10:00',2.93),('8348','2013-09-25','15:15:00',2.87),('8348','2013-09-25','15:20:00',2.65),('8348','2013-09-25','15:25:00',2.7),('8348','2013-09-25','15:30:00',1.74),('8348','2013-09-25','15:35:00',2.88),('8348','2013-09-25','15:40:00',2.81),('8348','2013-09-25','15:45:00',2.53),('8348','2013-09-25','15:50:00',2.56),('8348','2013-09-25','15:55:00',2.52),('8348','2013-09-25','16:00:00',2.46),('8348','2013-09-25','16:05:00',2.38),('8348','2013-09-25','16:10:00',2.3),('8348','2013-09-25','16:15:00',2.22),('8348','2013-09-25','16:20:00',2.15),('8348','2013-09-25','16:30:00',2.08),('8348','2013-09-25','16:35:00',1.97),('8348','2013-09-25','16:40:00',1.86),('8348','2013-09-25','16:45:00',1.78),('8348','2013-09-25','16:50:00',1.71),('8348','2013-09-25','16:55:00',1.62),('8348','2013-09-25','17:00:00',1.57),('8348','2013-09-25','17:05:00',1.49),('8348','2013-09-25','17:10:00',1.41),('8348','2013-09-25','17:15:00',1.33),('8348','2013-09-25','17:20:00',1.25),('8348','2013-09-25','17:25:00',1.16),('8348','2013-09-25','17:30:00',1.11),('8348','2013-09-25','17:35:00',1.02),('8348','2013-09-24','08:55:00',1.01),('8348','2013-09-24','09:00:00',1.07),('8348','2013-09-24','09:05:00',1.12),('8348','2013-09-24','09:10:00',1.21),('8348','2013-09-24','09:15:00',1.29),('8348','2013-09-24','09:20:00',1.36),('8348','2013-09-24','09:25:00',1.44),('8348','2013-09-24','09:30:00',1.53),('8348','2013-09-24','09:35:00',1.61),('8348','2013-09-24','09:40:00',1.67),('8348','2013-09-24','09:45:00',1.72),('8348','2013-09-24','09:50:00',1.8),('8348','2013-09-24','09:55:00',1.86),('8348','2013-09-24','10:00:00',1.92),('8348','2013-09-24','10:05:00',1.97),('8348','2013-09-24','10:10:00',2.04),('8348','2013-09-24','10:15:00',2.1),('8348','2013-09-24','10:20:00',2.15),('8348','2013-09-24','10:25:00',2.21),('8348','2013-09-24','10:30:00',2.25),('8348','2013-09-24','10:35:00',2.3),('8348','2013-09-24','10:40:00',2.36),('8348','2013-09-24','10:45:00',2.4),('8348','2013-09-24','10:50:00',2.43),('8348','2013-09-24','10:55:00',2.47),('8348','2013-09-24','11:00:00',2.51),('8348','2013-09-24','11:05:00',2.54),('8348','2013-09-24','11:10:00',2.57),('8348','2013-09-24','11:15:00',2.59),('8348','2013-09-24','11:20:00',2.65),('8348','2013-09-24','11:25:00',2.7),('8348','2013-09-24','11:30:00',2.75),('8348','2013-09-24','11:35:00',2.76),('8348','2013-09-24','11:40:00',2.81),('8348','2013-09-24','11:45:00',2.82),('8348','2013-09-24','11:50:00',2.82),('8348','2013-09-24','11:55:00',2.85),('8348','2013-09-24','12:00:00',2.86),('8348','2013-09-24','12:05:00',2.9),('8348','2013-09-24','12:10:00',2.93),('8348','2013-09-24','12:15:00',2.92),('8348','2013-09-24','12:20:00',2.92),('8348','2013-09-24','12:25:00',2.93),('8348','2013-09-24','12:30:00',2.95),('8348','2013-09-24','12:35:00',3.03),('8348','2013-09-24','12:40:00',3.05),('8348','2013-09-24','12:45:00',3.04),('8348','2013-09-24','12:50:00',3.03),('8348','2013-09-24','12:55:00',3.06),('8348','2013-09-24','13:00:00',3.06),('8348','2013-09-24','13:05:00',3.08),('8348','2013-09-24','13:10:00',3.1),('8348','2013-09-24','13:15:00',3.08),('8348','2013-09-24','13:20:00',3.1),('8348','2013-09-24','13:25:00',3.1),('8348','2013-09-24','13:30:00',3.12),('8348','2013-09-24','13:35:00',3.1),('8348','2013-09-24','13:40:00',3.11),('8348','2013-09-24','13:45:00',3.11),('8348','2013-09-24','13:50:00',3.07),('8348','2013-09-24','13:55:00',3.05),('8348','2013-09-24','14:00:00',3.05),('8348','2013-09-24','14:05:00',3.05),('8348','2013-09-24','14:10:00',3.06),('8348','2013-09-24','14:15:00',3.03),('8348','2013-09-24','14:20:00',3.02),('8348','2013-09-24','14:25:00',3),('8348','2013-09-24','14:30:00',2.99),('8348','2013-09-24','14:35:00',2.96),('8348','2013-09-24','14:40:00',2.95),('8348','2013-09-24','14:45:00',2.92),('8348','2013-09-24','14:50:00',2.87),('8348','2013-09-24','14:55:00',2.84),('8348','2013-09-24','15:00:00',2.8),('8348','2013-09-24','15:05:00',2.81),('8348','2013-09-24','15:10:00',2.77),('8348','2013-09-24','15:15:00',2.73),('8348','2013-09-24','15:20:00',2.72),('8348','2013-09-24','15:25:00',2.71),('8348','2013-09-24','15:30:00',2.66),('8348','2013-09-24','15:35:00',2.61),('8348','2013-09-24','15:40:00',2.56),('8348','2013-09-24','15:45:00',2.53),('8348','2013-09-24','15:50:00',2.47),('8348','2013-09-24','15:55:00',2.41),('8348','2013-09-24','16:00:00',2.36),('8348','2013-09-24','16:05:00',2.31),('8348','2013-09-24','16:10:00',2.25),('8348','2013-09-24','16:15:00',2.21),('8348','2013-09-24','16:20:00',2.15),('8348','2013-09-24','16:25:00',2.08),('8348','2013-09-24','16:30:00',2.01),('8348','2013-09-24','16:35:00',1.94),('8348','2013-09-24','16:40:00',1.87),('8348','2013-09-24','16:45:00',1.81),('8348','2013-09-24','16:50:00',1.76),('8348','2013-09-24','16:55:00',1.69),('8348','2013-09-24','17:00:00',1.61),('8348','2013-09-24','17:05:00',1.54),('8348','2013-09-24','17:10:00',1.45),('8348','2013-09-24','17:15:00',1.38),('8348','2013-09-24','17:20:00',1.3),('8348','2013-09-24','17:25:00',1.22),('8348','2013-09-24','17:30:00',1.11),('8348','2013-09-24','17:35:00',1),('8348','2013-09-23','08:55:00',1.02),('8348','2013-09-23','09:00:00',1.08),('8348','2013-09-23','09:05:00',1.15),('8348','2013-09-23','09:10:00',1.24),('8348','2013-09-23','09:15:00',1.33),('8348','2013-09-23','09:20:00',1.4),('8348','2013-09-23','09:25:00',1.48),('8348','2013-09-23','09:30:00',1.57),('8348','2013-09-23','09:35:00',1.64),('8348','2013-09-23','09:40:00',1.71),('8348','2013-09-23','09:45:00',1.77),('8348','2013-09-23','09:50:00',1.84),('8348','2013-09-23','09:55:00',1.89),('8348','2013-09-23','10:00:00',1.95),('8348','2013-09-23','10:05:00',2.02),('8348','2013-09-23','10:10:00',2.07),('8348','2013-09-23','10:15:00',2.13),('8348','2013-09-23','10:20:00',2.18),('8348','2013-09-23','10:25:00',2.24),('8348','2013-09-23','10:30:00',2.29),('8348','2013-09-23','10:35:00',2.35),('8348','2013-09-23','10:40:00',2.4),('8348','2013-09-23','10:45:00',2.44),('8348','2013-09-23','10:50:00',2.5),('8348','2013-09-23','10:55:00',2.54),('8348','2013-09-23','11:00:00',2.57),('8348','2013-09-23','11:05:00',2.62),('8348','2013-09-23','11:10:00',2.68),('8348','2013-09-23','11:15:00',2.74),('8348','2013-09-23','11:20:00',2.78),('8348','2013-09-23','11:25:00',2.81),('8348','2013-09-23','11:30:00',2.85),('8348','2013-09-23','11:35:00',2.88),('8348','2013-09-23','11:40:00',2.92),('8348','2013-09-23','11:45:00',2.93),('8348','2013-09-23','11:50:00',2.96),('8348','2013-09-23','11:55:00',2.99),('8348','2013-09-23','12:00:00',3.03),('8348','2013-09-23','12:05:00',3.06),('8348','2013-09-23','12:10:00',3.1),('8348','2013-09-23','12:15:00',3.13),('8348','2013-09-23','12:20:00',3.13),('8348','2013-09-23','12:25:00',3.13),('8348','2013-09-23','12:30:00',3.12),('8348','2013-09-23','12:35:00',3.14),('8348','2013-09-23','12:40:00',3.14),('8348','2013-09-23','12:45:00',3.16),('8348','2013-09-23','12:50:00',3.15),('8348','2013-09-23','12:55:00',3.15),('8348','2013-09-23','13:00:00',3.17),('8348','2013-09-23','13:05:00',3.14),('8348','2013-09-23','13:10:00',3.14),('8348','2013-09-23','13:15:00',3.12),('8348','2013-09-23','13:20:00',3.12),('8348','2013-09-23','13:25:00',3.1),('8348','2013-09-23','13:30:00',3.13),('8348','2013-09-23','13:35:00',3.1),('8348','2013-09-23','13:40:00',3.11),('8348','2013-09-23','13:45:00',3.1),('8348','2013-09-23','13:50:00',3.09),('8348','2013-09-23','13:55:00',3.08),('8348','2013-09-23','14:00:00',3.05),('8348','2013-09-23','14:05:00',2.99),('8348','2013-09-23','14:10:00',3),('8348','2013-09-23','14:15:00',2.97),('8348','2013-09-23','14:20:00',3.01),('8348','2013-09-23','14:25:00',3),('8348','2013-09-23','14:30:00',3.02),('8348','2013-09-23','14:35:00',2.93),('8348','2013-09-23','14:40:00',2.9),('8348','2013-09-23','14:45:00',2.86),('8348','2013-09-23','14:50:00',2.68),('8348','2013-09-23','14:55:00',2.82),('8348','2013-09-23','15:00:00',2.86),('8348','2013-09-23','15:05:00',2.82),('8348','2013-09-23','15:10:00',1.68),('8348','2013-09-23','15:15:00',2.42),('8348','2013-09-23','15:20:00',2.29),('8348','2013-09-23','15:25:00',2.62),('8348','2013-09-23','15:30:00',2.61),('8348','2013-09-23','15:35:00',2.56),('8348','2013-09-23','15:40:00',2.52),('8348','2013-09-23','15:45:00',2.47),('8348','2013-09-23','15:50:00',2.39),('8348','2013-09-23','15:55:00',2.19),('8348','2013-09-23','16:00:00',2.24),('8348','2013-09-23','16:05:00',2.23),('8348','2013-09-23','16:10:00',2.17),('8348','2013-09-23','16:15:00',2.12),('8348','2013-09-23','16:20:00',2.01),('8348','2013-09-23','16:25:00',1.96),('8348','2013-09-23','16:30:00',1.74),('8348','2013-09-23','16:35:00',1.87),('8348','2013-09-23','16:40:00',1.8),('8348','2013-09-23','16:45:00',1.75),('8348','2013-09-23','16:50:00',1.68),('8348','2013-09-23','16:55:00',1.61),('8348','2013-09-23','17:00:00',1.55),('8348','2013-09-23','17:05:00',1.48),('8348','2013-09-23','17:10:00',1.41),('8348','2013-09-23','17:15:00',1.34),('8348','2013-09-23','17:20:00',1.27),('8348','2013-09-23','17:25:00',1.2),('8348','2013-09-23','17:30:00',1.13),('8348','2013-09-23','17:35:00',1.06),('8348','2013-09-22','08:55:00',1),('8348','2013-09-22','09:00:00',1.07),('8348','2013-09-22','09:05:00',1.14),('8348','2013-09-22','09:10:00',1.24),('8348','2013-09-22','09:15:00',1.33),('8348','2013-09-22','09:20:00',1.4),('8348','2013-09-22','09:25:00',1.48),('8348','2013-09-22','09:30:00',1.58),('8348','2013-09-22','09:35:00',1.65),('8348','2013-09-22','09:40:00',1.71),('8348','2013-09-22','09:45:00',1.78),('8348','2013-09-22','09:50:00',1.84),('8348','2013-09-22','09:55:00',1.91),('8348','2013-09-22','10:00:00',1.98),('8348','2013-09-22','10:05:00',2.05),('8348','2013-09-22','10:10:00',2.12),('8348','2013-09-22','10:15:00',2.18),('8348','2013-09-22','10:20:00',2.23),('8348','2013-09-22','10:25:00',2.29),('8348','2013-09-22','10:30:00',2.36),('8348','2013-09-22','10:35:00',2.41),('8348','2013-09-22','10:40:00',2.45),('8348','2013-09-22','10:45:00',2.5),('8348','2013-09-22','10:50:00',2.54),('8348','2013-09-22','10:55:00',2.58),('8348','2013-09-22','11:00:00',2.63),('8348','2013-09-22','11:05:00',2.66),('8348','2013-09-22','11:10:00',2.69),('8348','2013-09-22','11:15:00',2.73),('8348','2013-09-22','11:20:00',2.79),('8348','2013-09-22','11:25:00',2.83),('8348','2013-09-22','11:30:00',2.88),('8348','2013-09-22','11:35:00',2.94),('8348','2013-09-22','11:40:00',2.97),('8348','2013-09-22','11:45:00',2.99),('8348','2013-09-22','11:50:00',3.03),('8348','2013-09-22','11:55:00',3.06),('8348','2013-09-22','12:00:00',3.08),('8348','2013-09-22','12:05:00',3.1),('8348','2013-09-22','12:10:00',3.11),('8348','2013-09-22','12:15:00',3.13),('8348','2013-09-22','12:20:00',3.16),('8348','2013-09-22','12:25:00',3.19),('8348','2013-09-22','12:30:00',3.19),('8348','2013-09-22','12:35:00',3.2),('8348','2013-09-22','12:40:00',3.23),('8348','2013-09-22','12:45:00',3.23),('8348','2013-09-22','12:50:00',3.25),('8348','2013-09-22','12:55:00',3.28),('8348','2013-09-22','13:00:00',3.25),('8348','2013-09-22','13:05:00',3.25),('8348','2013-09-22','13:10:00',3.29),('8348','2013-09-22','13:15:00',3.27),('8348','2013-09-22','13:20:00',3.25),('8348','2013-09-22','13:25:00',3.21),('8348','2013-09-22','13:30:00',3.23),('8348','2013-09-22','13:35:00',3.21),('8348','2013-09-22','13:40:00',3.2),('8348','2013-09-22','13:45:00',3.23),('8348','2013-09-22','13:50:00',3.25),('8348','2013-09-22','13:55:00',2.84),('8348','2013-09-22','14:00:00',3.2),('8348','2013-09-22','14:05:00',3.24),('8348','2013-09-22','14:10:00',3.26),('8348','2013-09-22','14:15:00',3.32),('8348','2013-09-22','14:20:00',1.92),('8348','2013-09-22','14:25:00',3.15),('8348','2013-09-22','14:30:00',1.45),('8348','2013-09-22','14:35:00',3.23),('8348','2013-09-22','14:40:00',2.88),('8348','2013-09-22','14:45:00',2.95),('8348','2013-09-22','14:50:00',3.03),('8348','2013-09-22','14:55:00',3.02),('8348','2013-09-22','15:00:00',3.06),('8348','2013-09-22','15:05:00',3.13),('8348','2013-09-22','15:10:00',3.03),('8348','2013-09-22','15:15:00',2.95),('8348','2013-09-22','15:20:00',3.15),('8348','2013-09-22','15:25:00',1.34),('8348','2013-09-22','15:40:00',3.06),('8348','2013-09-22','15:45:00',2.71),('8348','2013-09-22','15:50:00',2.59),('8348','2013-09-22','15:55:00',2.6),('8348','2013-09-22','16:00:00',2.79),('8348','2013-09-22','16:05:00',2.45),('8348','2013-09-22','16:10:00',2.99),('8348','2013-09-22','16:15:00',2.67),('8348','2013-09-22','16:20:00',1.73),('8348','2013-09-22','16:25:00',1.35),('8348','2013-09-22','16:30:00',1.22),('8348','2013-09-22','16:45:00',1.86),('8348','2013-09-22','16:50:00',1.38),('8348','2013-09-22','16:55:00',1.59),('8348','2013-09-22','17:00:00',1.11),('8348','2013-09-22','17:05:00',1.86),('8348','2013-09-22','17:10:00',1.36),('8348','2013-09-21','08:55:00',1.03),('8348','2013-09-21','09:00:00',1.09),('8348','2013-09-21','09:05:00',1.16),('8348','2013-09-21','09:10:00',1.25),('8348','2013-09-21','09:15:00',1.32),('8348','2013-09-21','09:20:00',1.38),('8348','2013-09-21','09:25:00',1.46),('8348','2013-09-21','09:30:00',1.56),('8348','2013-09-21','09:35:00',1.63),('8348','2013-09-21','09:40:00',1.69),('8348','2013-09-21','09:45:00',1.76),('8348','2013-09-21','09:50:00',1.83),('8348','2013-09-21','09:55:00',1.88),('8348','2013-09-21','10:00:00',1.95),('8348','2013-09-21','10:05:00',2.01),('8348','2013-09-21','10:10:00',2.06),('8348','2013-09-21','10:15:00',2.11),('8348','2013-09-21','10:20:00',2.16),('8348','2013-09-21','10:25:00',2.22),('8348','2013-09-21','10:30:00',2.28),('8348','2013-09-21','10:35:00',2.32),('8348','2013-09-21','10:40:00',2.36),('8348','2013-09-21','10:45:00',2.41),('8348','2013-09-21','10:50:00',2.46),('8348','2013-09-21','10:55:00',2.51),('8348','2013-09-21','11:00:00',2.54),('8348','2013-09-21','11:05:00',2.59),('8348','2013-09-21','11:10:00',2.62),('8348','2013-09-21','11:15:00',2.66),('8348','2013-09-21','11:20:00',2.7),('8348','2013-09-21','11:25:00',2.75),('8348','2013-09-21','11:30:00',2.78),('8348','2013-09-21','11:35:00',2.81),('8348','2013-09-21','11:40:00',2.84),('8348','2013-09-21','11:45:00',2.88),('8348','2013-09-21','11:50:00',2.92),('8348','2013-09-21','11:55:00',2.87),('8348','2013-09-21','12:00:00',2.96),('8348','2013-09-21','12:05:00',3),('8348','2013-09-21','12:10:00',3.01),('8348','2013-09-21','12:15:00',3.04),('8348','2013-09-21','12:20:00',2.97),('8348','2013-09-21','12:25:00',2.77),('8348','2013-09-21','12:30:00',3.13),('8348','2013-09-21','12:35:00',3.05),('8348','2013-09-21','12:40:00',2.82),('8348','2013-09-21','12:45:00',2.98),('8348','2013-09-21','12:50:00',3.1),('8348','2013-09-21','12:55:00',3.13),('8348','2013-09-21','13:00:00',3.14),('8348','2013-09-21','13:05:00',3.02),('8348','2013-09-21','13:10:00',3.12),('8348','2013-09-21','13:15:00',3.21),('8348','2013-09-21','13:20:00',2.66),('8348','2013-09-21','13:25:00',3.01),('8348','2013-09-21','13:30:00',3.02),('8348','2013-09-21','13:35:00',3.06),('8348','2013-09-21','13:40:00',2.7),('8348','2013-09-21','13:45:00',2.69),('8348','2013-09-21','13:50:00',2.82),('8348','2013-09-21','13:55:00',2.84),('8348','2013-09-21','14:00:00',2.92),('8348','2013-09-21','14:05:00',3.03),('8348','2013-09-21','14:10:00',2.92),('8348','2013-09-21','14:15:00',3.04),('8348','2013-09-21','14:20:00',3.06),('8348','2013-09-21','14:25:00',3.03),('8348','2013-09-21','14:30:00',2.98),('8348','2013-09-21','14:35:00',2.96),('8348','2013-09-21','14:40:00',2.93),('8348','2013-09-21','14:45:00',2.88),('8348','2013-09-21','14:50:00',2.88),('8348','2013-09-21','14:55:00',2.84),('8348','2013-09-21','15:00:00',2.81),('8348','2013-09-21','15:05:00',2.78),('8348','2013-09-21','15:10:00',2.68),('8348','2013-09-21','15:15:00',2.68),('8348','2013-09-21','15:20:00',2.67),('8348','2013-09-21','15:25:00',2.62),('8348','2013-09-21','15:30:00',2.59),('8348','2013-09-21','15:35:00',2.56),('8348','2013-09-21','15:40:00',2.34),('8348','2013-09-21','15:45:00',1.94),('8348','2013-09-21','15:50:00',2.31),('8348','2013-09-21','15:55:00',2.4),('8348','2013-09-21','16:00:00',1.84),('8348','2013-09-21','16:05:00',1.18),('8348','2013-09-21','16:10:00',1.52),('8348','2013-09-21','16:15:00',1.32),('8348','2013-09-21','16:20:00',1.55),('8348','2013-09-21','16:30:00',1.16),('8348','2013-09-21','16:35:00',1.35),('8348','2013-09-21','17:05:00',1.01),('8348','2013-09-21','17:15:00',1.11),('8348','2013-09-21','17:35:00',1.01),('8348','2013-09-20','08:40:00',1.1),('8348','2013-09-20','08:45:00',1),('8348','2013-09-20','09:05:00',1.04),('8348','2013-09-20','09:20:00',1.27),('8348','2013-09-20','09:25:00',1.47),('8348','2013-09-20','09:30:00',1.05),('8348','2013-09-20','09:35:00',1.03),('8348','2013-09-20','09:40:00',1.04),('8348','2013-09-20','09:45:00',1.13),('8348','2013-09-20','09:50:00',1.13),('8348','2013-09-20','09:55:00',1.24),('8348','2013-09-20','10:00:00',1.34),('8348','2013-09-20','10:05:00',2.31),('8348','2013-09-20','10:10:00',1.6),('8348','2013-09-20','10:15:00',2.52),('8348','2013-09-20','10:20:00',2.11),('8348','2013-09-20','10:25:00',1.53),('8348','2013-09-20','10:30:00',1.59),('8348','2013-09-20','10:35:00',1.8),('8348','2013-09-20','10:40:00',1.84),('8348','2013-09-20','10:45:00',1.8),('8348','2013-09-20','10:50:00',2.21),('8348','2013-09-20','10:55:00',1.87),('8348','2013-09-20','11:00:00',1.8),('8348','2013-09-20','11:05:00',1.65),('8348','2013-09-20','11:10:00',1.95),('8348','2013-09-20','11:15:00',2.06),('8348','2013-09-20','11:20:00',1.99),('8348','2013-09-20','11:25:00',2.59),('8348','2013-09-20','11:30:00',1.94),('8348','2013-09-20','11:35:00',3.13),('8348','2013-09-20','11:40:00',1.75),('8348','2013-09-20','11:45:00',3.32),('8348','2013-09-20','11:50:00',3.22),('8348','2013-09-20','11:55:00',3.1),('8348','2013-09-20','12:00:00',3.04),('8348','2013-09-20','12:05:00',3.02),('8348','2013-09-20','12:10:00',3.05),('8348','2013-09-20','12:15:00',3.11),('8348','2013-09-20','12:20:00',3.19),('8348','2013-09-20','12:25:00',2.92),('8348','2013-09-20','12:30:00',3.17),('8348','2013-09-20','12:35:00',2.72),('8348','2013-09-20','12:40:00',2.83),('8348','2013-09-20','12:45:00',2.6),('8348','2013-09-20','12:50:00',3.1),('8348','2013-09-20','12:55:00',3.22),('8348','2013-09-20','13:00:00',2.19),('8348','2013-09-20','13:05:00',3.2),('8348','2013-09-20','13:10:00',3.16),('8348','2013-09-20','13:15:00',2.25),('8348','2013-09-20','13:20:00',2.83),('8348','2013-09-20','13:25:00',2.09),('8348','2013-09-20','13:30:00',3.18),('8348','2013-09-20','13:35:00',2.57),('8348','2013-09-20','13:40:00',2.79),('8348','2013-09-20','13:45:00',3.29),('8348','2013-09-20','13:50:00',3.16),('8348','2013-09-20','13:55:00',2.91),('8348','2013-09-20','14:00:00',3.16),('8348','2013-09-20','14:05:00',2.6),('8348','2013-09-20','14:10:00',3.19),('8348','2013-09-20','14:15:00',3.08),('8348','2013-09-20','14:25:00',2.81),('8348','2013-09-20','14:30:00',3.3),('8348','2013-09-20','14:35:00',3.2),('8348','2013-09-20','14:40:00',2.05),('8348','2013-09-20','14:45:00',2.93),('8348','2013-09-20','14:50:00',3.08),('8348','2013-09-20','14:55:00',3.06),('8348','2013-09-20','15:00:00',2.7),('8348','2013-09-20','15:05:00',2.16),('8348','2013-09-20','15:10:00',2.4),('8348','2013-09-20','15:15:00',1.69),('8348','2013-09-20','15:30:00',1.71),('8348','2013-09-20','15:35:00',2.24),('8348','2013-09-20','15:40:00',2.03),('8348','2013-09-20','15:45:00',2.53),('8348','2013-09-20','15:50:00',2.69),('8348','2013-09-20','15:55:00',2.76),('8348','2013-09-20','16:00:00',2.8),('8348','2013-09-20','16:05:00',2.18),('8348','2013-09-20','16:10:00',1.66),('8348','2013-09-20','16:15:00',1.7),('8348','2013-09-20','16:20:00',1.44),('8348','2013-09-20','16:25:00',1.47),('8348','2013-09-20','16:45:00',1.06),('8348','2013-09-20','16:50:00',1.2),('8348','2013-09-20','16:55:00',2.08),('8348','2013-09-20','17:00:00',2.06),('8348','2013-09-20','17:05:00',2.17),('8348','2013-09-20','17:10:00',2.16),('8348','2013-09-20','17:15:00',1.93),('8348','2013-09-20','17:20:00',1.87),('8348','2013-09-20','17:25:00',1.67),('8348','2013-09-20','17:30:00',1.42),('8348','2013-09-20','17:35:00',1.23),('8348','2013-09-20','17:40:00',1.16),('8348','2013-09-20','17:45:00',1.15),('8348','2013-09-20','17:50:00',1.04),('8348','2013-09-20','18:00:00',1.02),('8348','2013-09-19','08:50:00',1.02),('8348','2013-09-19','09:10:00',1.14),('8348','2013-09-19','09:15:00',1.44),('8348','2013-09-19','09:20:00',1.04),('8348','2013-09-19','10:05:00',1.74),('8348','2013-09-19','10:10:00',1.69),('8348','2013-09-19','10:15:00',1.45),('8348','2013-09-19','10:25:00',1.1),('8348','2013-09-19','10:35:00',2.39),('8348','2013-09-19','10:40:00',2.55),('8348','2013-09-19','10:45:00',1.66),('8348','2013-09-19','10:50:00',1.5),('8348','2013-09-19','10:55:00',2.27),('8348','2013-09-19','11:00:00',2.67),('8348','2013-09-19','11:05:00',2.34),('8348','2013-09-19','11:10:00',1.49),('8348','2013-09-19','11:15:00',1.57),('8348','2013-09-19','11:20:00',2.06),('8348','2013-09-19','11:25:00',1.88),('8348','2013-09-19','11:30:00',3.66),('8348','2013-09-19','11:35:00',3.07),('8348','2013-09-19','11:40:00',2.38),('8348','2013-09-19','11:45:00',2.69),('8348','2013-09-19','11:50:00',2.93),('8348','2013-09-19','11:55:00',2.89),('8348','2013-09-19','12:00:00',2.97),('8348','2013-09-19','12:05:00',1.9),('8348','2013-09-19','12:10:00',2.69),('8348','2013-09-19','12:15:00',1.61),('8348','2013-09-19','12:20:00',3.69),('8348','2013-09-19','12:25:00',3.79),('8348','2013-09-19','12:30:00',3.55),('8348','2013-09-19','12:35:00',3.34),('8348','2013-09-19','12:40:00',2.96),('8348','2013-09-19','12:45:00',1.93),('8348','2013-09-19','12:50:00',3.64),('8348','2013-09-19','12:55:00',3.58),('8348','2013-09-19','13:00:00',3.61),('8348','2013-09-19','13:05:00',3.64),('8348','2013-09-19','13:10:00',3.81),('8348','2013-09-19','13:15:00',3.52),('8348','2013-09-19','13:20:00',3.02),('8348','2013-09-19','13:25:00',2.01),('8348','2013-09-19','13:30:00',3.6),('8348','2013-09-19','13:35:00',3.63),('8348','2013-09-19','13:40:00',3.88),('8348','2013-09-19','13:45:00',3.23),('8348','2013-09-19','13:50:00',1.34),('8348','2013-09-19','13:55:00',1.05),('8348','2013-09-19','14:00:00',1.2),('8348','2013-09-19','14:05:00',3.26),('8348','2013-09-19','14:10:00',3.48),('8348','2013-09-19','14:15:00',3.36),('8348','2013-09-19','14:20:00',3.31),('8348','2013-09-19','14:25:00',3.12),('8348','2013-09-19','14:30:00',3.22),('8348','2013-09-19','14:35:00',3.19),('8348','2013-09-19','14:40:00',3.18),('8348','2013-09-19','14:45:00',2.93),('8348','2013-09-19','14:50:00',3),('8348','2013-09-19','14:55:00',3.2),('8348','2013-09-19','15:00:00',3.15),('8348','2013-09-19','15:05:00',2.66),('8348','2013-09-19','15:10:00',2.35),('8348','2013-09-19','15:15:00',3.14),('8348','2013-09-19','15:20:00',3),('8348','2013-09-19','15:25:00',2.45),('8348','2013-09-19','15:30:00',2.25),('8348','2013-09-19','15:35:00',1.52),('8348','2013-09-19','15:40:00',2.91),('8348','2013-09-19','15:45:00',2.74),('8348','2013-09-19','15:50:00',2.64),('8348','2013-09-19','15:55:00',2.43),('8348','2013-09-19','16:00:00',2.54),('8348','2013-09-19','16:05:00',2.42),('8348','2013-09-19','16:10:00',1.41),('8348','2013-09-19','16:15:00',2.23),('8348','2013-09-19','16:20:00',2.42),('8348','2013-09-19','16:25:00',2.25),('8348','2013-09-19','16:30:00',1.72),('8348','2013-09-19','16:35:00',1.33),('8348','2013-09-19','16:40:00',1.14),('8348','2013-09-19','16:45:00',1.22),('8348','2013-09-19','16:50:00',1.35),('8348','2013-09-19','16:55:00',1.74),('8348','2013-09-19','17:00:00',1.65),('8348','2013-09-19','17:05:00',1.68),('8348','2013-09-19','17:10:00',1.58),('8348','2013-09-19','17:15:00',1.5),('8348','2013-09-19','17:20:00',1.45),('8348','2013-09-19','17:25:00',1.32),('8348','2013-09-19','17:30:00',1.22),('8348','2014-04-13','07:30:00',1.17),('8348','2014-04-13','07:35:00',1.18),('8348','2014-04-13','07:40:00',1.24),('8348','2014-04-13','07:45:00',1.27),('8348','2014-04-13','07:50:00',1.19),('8348','2014-04-13','07:55:00',1.28),('8348','2014-04-13','08:00:00',1.64),('8348','2014-04-13','08:05:00',2.2),('8348','2014-04-13','08:10:00',2.53),('8348','2014-04-13','08:15:00',2.22),('8348','2014-04-13','08:20:00',2.49),('8348','2014-04-13','08:25:00',3.37),('8348','2014-04-13','08:30:00',3.12),('8348','2014-04-13','08:35:00',2.63),('8348','2014-04-13','08:40:00',3.74),('8348','2014-04-13','08:45:00',2.9),('8348','2014-04-13','08:50:00',2.48),('8348','2014-04-13','08:55:00',2.65),('8348','2014-04-13','09:00:00',4.88),('8348','2014-04-13','09:05:00',5.97),('8348','2014-04-13','09:10:00',4.06),('8348','2014-04-13','09:15:00',4.09),('8348','2014-04-13','09:20:00',5.45),('8348','2014-04-13','09:25:00',3.09),('8348','2014-04-13','09:30:00',5.57),('8348','2014-04-13','09:35:00',5.44),('8348','2014-04-13','09:40:00',5.34),('8348','2014-04-13','09:45:00',5.8),('8348','2014-04-13','09:50:00',5.87),('8348','2014-04-13','09:55:00',5.87),('8348','2014-04-13','10:00:00',5.99),('8348','2014-04-13','10:05:00',6.14),('8348','2014-04-13','10:10:00',5.9),('8348','2014-04-13','10:15:00',6.5),('8348','2014-04-13','10:20:00',7.56),('8348','2014-04-13','10:25:00',4.1),('8348','2014-04-13','10:30:00',3.44),('8348','2014-04-13','10:35:00',4.93),('8348','2014-04-13','10:40:00',6.88),('8348','2014-04-13','10:45:00',6.14),('8348','2014-04-13','10:50:00',6.34),('8348','2014-04-13','10:55:00',4.32),('8348','2014-04-13','11:00:00',4.25),('8348','2014-04-13','11:05:00',2.93),('8348','2014-04-13','11:10:00',2.6),('8348','2014-04-13','11:15:00',2.37),('8348','2014-04-13','11:20:00',2.08),('8348','2014-04-13','11:25:00',1.51),('8348','2014-04-13','11:30:00',1.07),('8348','2014-04-13','11:45:00',1.01),('8348','2014-04-13','11:50:00',1.15),('8348','2014-04-13','11:55:00',1.25),('8348','2014-04-13','12:00:00',1.39),('8348','2014-04-13','12:05:00',2.53),('8348','2014-04-13','12:10:00',3.61),('8348','2014-04-13','12:15:00',3.52),('8348','2014-04-13','12:20:00',4.64),('8348','2014-04-13','12:25:00',5.16),('8348','2014-04-13','12:30:00',7.9),('8348','2014-04-13','12:35:00',7.12),('8348','2014-04-13','12:40:00',6.54),('8348','2014-04-13','12:45:00',3.53),('8348','2014-04-13','12:50:00',5),('8348','2014-04-13','12:55:00',5.3),('8348','2014-04-13','13:00:00',7.31),('8348','2014-04-13','13:05:00',6.85),('8348','2014-04-13','13:10:00',7.18),('8348','2014-04-13','13:15:00',7.12),('8348','2014-04-13','13:20:00',3.62),('8348','2014-04-13','13:25:00',3.05),('8348','2014-04-13','13:30:00',3.04),('8348','2014-04-13','13:35:00',3.01),('8348','2014-04-13','13:40:00',2.57),('8348','2014-04-13','13:45:00',4.82),('8348','2014-04-13','13:50:00',7.49),('8348','2014-04-13','13:55:00',5.85),('8348','2014-04-13','14:00:00',5.68),('8348','2014-04-13','14:05:00',6.77),('8348','2014-04-13','14:10:00',7),('8348','2014-04-13','14:15:00',6.14),('8348','2014-04-13','14:20:00',6.08),('8348','2014-04-13','14:25:00',6.22),('8348','2014-04-13','14:30:00',5.92),('8348','2014-04-13','14:35:00',4.3),('8348','2014-04-13','14:40:00',2.71),('8348','2014-04-13','14:45:00',2.85),('8348','2014-04-13','14:50:00',3.43),('8348','2014-04-13','14:55:00',3.58),('8348','2014-04-13','15:00:00',6.39),('8348','2014-04-13','15:05:00',4.02),('8348','2014-04-13','15:10:00',2.33),('8348','2014-04-13','15:15:00',2.91),('8348','2014-04-13','15:20:00',2.67),('8348','2014-04-13','15:25:00',2.67),('8348','2014-04-13','15:30:00',2.4),('8348','2014-04-13','15:35:00',3.22),('8348','2014-04-13','15:40:00',5.02),('8348','2014-04-13','15:45:00',5.42),('8348','2014-04-13','15:50:00',3.65),('8348','2014-04-13','15:55:00',4.7),('8348','2014-04-13','16:00:00',4.41),('8348','2014-04-13','16:05:00',2.62),('8348','2014-04-13','16:10:00',1.85),('8348','2014-04-13','16:15:00',2.37),('8348','2014-04-13','16:20:00',3.27),('8348','2014-04-13','16:25:00',2.46),('8348','2014-04-13','16:30:00',1.51),('8348','2014-04-13','16:35:00',1.29),('8348','2014-04-13','16:40:00',1.23),('8348','2014-04-13','16:45:00',1.66),('8348','2014-04-13','16:50:00',2.07),('8348','2014-04-13','16:55:00',2.31),('8348','2014-04-13','17:00:00',1.77),('8348','2014-04-13','17:05:00',2.09),('8348','2014-04-13','17:10:00',1.01),('8348','2014-04-13','17:20:00',1.03),('8348','2013-09-18','08:55:00',1.14),('8348','2013-09-18','09:05:00',1.31),('8348','2013-09-18','09:15:00',1.17),('8348','2013-09-18','09:20:00',1.57),('8348','2013-09-18','09:25:00',1.68),('8348','2013-09-18','09:30:00',1.12),('8348','2013-09-18','09:35:00',1.35),('8348','2013-09-18','09:40:00',1.64),('8348','2013-09-18','09:55:00',1.8),('8348','2013-09-18','10:00:00',1.93),('8348','2013-09-18','10:05:00',2.24),('8348','2013-09-18','10:10:00',2.19),('8348','2013-09-18','10:15:00',2.1),('8348','2013-09-18','10:20:00',2.16),('8348','2013-09-18','10:25:00',2.22),('8348','2013-09-18','10:30:00',2.27),('8348','2013-09-18','10:35:00',2.31),('8348','2013-09-18','10:40:00',2.35),('8348','2013-09-18','10:45:00',2.38),('8348','2013-09-18','10:50:00',2.39),('8348','2013-09-18','10:55:00',1.44),('8348','2013-09-18','11:00:00',2.72),('8348','2013-09-18','11:05:00',2.28),('8348','2013-09-18','11:10:00',2.98),('8348','2013-09-18','11:15:00',2.88),('8348','2013-09-18','11:20:00',2.26),('8348','2013-09-18','11:25:00',3.17),('8348','2013-09-18','11:30:00',3.13),('8348','2013-09-18','11:35:00',2.84),('8348','2013-09-18','11:40:00',1.88),('8348','2013-09-18','11:45:00',2.27),('8348','2013-09-18','11:50:00',3.09),('8348','2013-09-18','11:55:00',3.15),('8348','2013-09-18','12:00:00',2.83),('8348','2013-09-18','12:05:00',2.73),('8348','2013-09-18','12:10:00',3.31),('8348','2013-09-18','12:15:00',3.37),('8348','2013-09-18','12:20:00',3.32),('8348','2013-09-18','12:25:00',2.49),('8348','2013-09-18','12:30:00',1.82),('8348','2013-09-18','12:35:00',2.84),('8348','2013-09-18','12:40:00',3.34),('8348','2013-09-18','12:45:00',2.41),('8348','2013-09-18','12:50:00',3.54),('8348','2013-09-18','12:55:00',3.52),('8348','2013-09-18','13:00:00',2.23),('8348','2013-09-18','13:05:00',2.75),('8348','2013-09-18','13:10:00',3.48),('8348','2013-09-18','13:15:00',3.37),('8348','2013-09-18','13:20:00',3.45),('8348','2013-09-18','13:25:00',3.48),('8348','2013-09-18','13:30:00',3.48),('8348','2013-09-18','13:35:00',3.43),('8348','2013-09-18','13:40:00',3.42),('8348','2013-09-18','13:45:00',3.31),('8348','2013-09-18','13:50:00',1.56),('8348','2013-09-18','13:55:00',3.21),('8348','2013-09-18','14:00:00',3.53),('8348','2013-09-18','14:05:00',3.4),('8348','2013-09-18','14:10:00',3.39),('8348','2013-09-18','14:15:00',3.06),('8348','2013-09-18','14:20:00',3.32),('8348','2013-09-18','14:25:00',3.29),('8348','2013-09-18','14:30:00',3.22),('8348','2013-09-18','14:35:00',3.2),('8348','2013-09-18','14:40:00',3.2),('8348','2013-09-18','14:45:00',3.13),('8348','2013-09-18','14:50:00',3.22),('8348','2013-09-18','14:55:00',2.92),('8348','2013-09-18','15:00:00',3.11),('8348','2013-09-18','15:05:00',3.08),('8348','2013-09-18','15:10:00',1.44),('8348','2013-09-18','15:15:00',2.04),('8348','2013-09-18','15:20:00',2.56),('8348','2013-09-18','15:25:00',3.07),('8348','2013-09-18','15:30:00',3),('8348','2013-09-18','15:35:00',2.95),('8348','2013-09-18','15:40:00',2.9),('8348','2013-09-18','15:45:00',2.27),('8348','2013-09-18','15:50:00',2.23),('8348','2013-09-18','15:55:00',2.3),('8348','2013-09-18','16:00:00',2.39),('8348','2013-09-18','16:05:00',2.42),('8348','2013-09-18','16:10:00',2.66),('8348','2013-09-18','16:15:00',2.52),('8348','2013-09-18','16:20:00',2.35),('8348','2013-09-18','16:25:00',2.06),('8348','2013-09-18','16:30:00',1.98),('8348','2013-09-18','16:35:00',1.9),('8348','2013-09-18','16:40:00',1.94),('8348','2013-09-18','16:45:00',1.88),('8348','2013-09-18','16:50:00',1.69),('8348','2013-09-18','16:55:00',1.68),('8348','2013-09-18','17:00:00',1.78),('8348','2013-09-18','17:05:00',1.55),('8348','2013-09-18','17:10:00',1.59),('8348','2013-09-18','17:15:00',1.54),('8348','2013-09-18','17:20:00',1.49),('8348','2013-09-18','17:25:00',1.28),('8348','2013-09-18','17:30:00',1.36),('8348','2013-09-18','17:35:00',1.23),('8348','2013-09-18','17:40:00',1.16),('8348','2013-09-18','17:45:00',1.07),('8348','2013-09-17','09:40:00',1.15),('8348','2013-09-17','09:45:00',1.79),('8348','2013-09-17','09:50:00',1.09),('8348','2013-09-17','09:55:00',1.33),('8348','2013-09-17','10:00:00',1.68),('8348','2013-09-17','10:05:00',1.37),('8348','2013-09-17','10:10:00',1.62),('8348','2013-09-17','10:25:00',1.79),('8348','2013-09-17','10:30:00',2.39),('8348','2013-09-17','10:35:00',1.43),('8348','2013-09-17','10:40:00',1.33),('8348','2013-09-17','10:45:00',2.17),('8348','2013-09-17','10:50:00',3.08),('8348','2013-09-17','10:55:00',2.34),('8348','2013-09-17','11:00:00',1.81),('8348','2013-09-17','11:05:00',1.38),('8348','2013-09-17','11:10:00',2.96),('8348','2013-09-17','11:15:00',2.37),('8348','2013-09-17','11:20:00',1.97),('8348','2013-09-17','11:25:00',1.58),('8348','2013-09-17','11:30:00',1.58),('8348','2013-09-17','11:35:00',2.8),('8348','2013-09-17','11:40:00',2.9),('8348','2013-09-17','11:45:00',2.9),('8348','2013-09-17','11:50:00',2.98),('8348','2013-09-17','11:55:00',2.81),('8348','2013-09-17','12:00:00',2.93),('8348','2013-09-17','12:05:00',3.12),('8348','2013-09-17','12:10:00',1.58),('8348','2013-09-17','12:15:00',2.04),('8348','2013-09-17','12:20:00',2.02),('8348','2013-09-17','12:25:00',3.42),('8348','2013-09-17','12:30:00',2.66),('8348','2013-09-17','12:35:00',1.82),('8348','2013-09-17','12:40:00',3.12),('8348','2013-09-17','12:45:00',2.86),('8348','2013-09-17','12:50:00',2.27),('8348','2013-09-17','12:55:00',2.38),('8348','2013-09-17','13:00:00',2.15),('8348','2013-09-17','13:05:00',1.32),('8348','2013-09-17','13:10:00',2.38),('8348','2013-09-17','13:15:00',2.69),('8348','2013-09-17','13:20:00',2.11),('8348','2013-09-17','13:25:00',1.82),('8348','2013-09-17','13:30:00',1.57),('8348','2013-09-17','13:35:00',1.65),('8348','2013-09-17','13:40:00',2.33),('8348','2013-09-17','13:45:00',1.62),('8348','2013-09-17','13:55:00',1.17),('8348','2013-09-17','14:00:00',1.63),('8348','2013-09-17','14:05:00',1),('8348','2013-09-17','14:15:00',1.24),('8348','2013-09-17','14:25:00',1.69),('8348','2013-09-17','14:35:00',1.05),('8348','2013-09-17','14:55:00',3.02),('8348','2013-09-17','15:00:00',3.15),('8348','2013-09-17','15:05:00',2.5),('8348','2013-09-17','15:10:00',2.43),('8348','2013-09-17','15:15:00',2.5),('8348','2013-09-17','15:20:00',2.67),('8348','2013-09-17','15:25:00',2.54),('8348','2013-09-17','15:30:00',2),('8348','2013-09-17','15:45:00',1.43),('8348','2013-09-17','15:50:00',1.75),('8348','2013-09-17','15:55:00',2.06),('8348','2013-09-17','16:00:00',1.29),('8348','2013-09-17','16:05:00',1.64),('8348','2013-09-17','16:10:00',1.64),('8348','2013-09-17','16:15:00',1.68),('8348','2013-09-17','16:40:00',1.16),('8348','2013-09-17','16:45:00',1.38),('8348','2013-09-17','16:50:00',1.19),('8348','2013-09-17','17:00:00',1.48),('8348','2013-09-17','17:05:00',1.62),('8348','2013-09-17','17:10:00',1.5),('8348','2013-09-17','17:15:00',1.56),('8348','2013-09-17','17:20:00',1.35),('8348','2013-09-17','17:25:00',1.34),('8348','2013-09-17','17:30:00',1.32),('8348','2013-09-16','09:05:00',1.39),('8348','2013-09-16','09:10:00',1.52),('8348','2013-09-16','09:15:00',1.38),('8348','2013-09-16','09:20:00',1.34),('8348','2013-09-16','09:25:00',1.16),('8348','2013-09-16','09:30:00',1.56),('8348','2013-09-16','09:35:00',1.64),('8348','2013-09-16','09:40:00',1.72),('8348','2013-09-16','09:45:00',1.82),('8348','2013-09-16','09:50:00',1.9),('8348','2013-09-16','09:55:00',2),('8348','2013-09-16','10:00:00',2.06),('8348','2013-09-16','10:05:00',2.16),('8348','2013-09-16','10:10:00',1.8),('8348','2013-09-16','10:15:00',1.22),('8348','2013-09-16','10:20:00',1.74),('8348','2013-09-16','10:25:00',1.9),('8348','2013-09-16','10:30:00',2.65),('8348','2013-09-16','10:35:00',2.82),('8348','2013-09-16','10:40:00',3.03),('8348','2013-09-16','10:45:00',3.13),('8348','2013-09-16','10:50:00',1.73),('8348','2013-09-16','11:05:00',1.9),('8348','2013-09-16','11:15:00',2.29),('8348','2013-09-16','11:25:00',1.22),('8348','2013-09-16','11:30:00',3.23),('8348','2013-09-16','11:35:00',3.19),('8348','2013-09-16','11:40:00',3.31),('8348','2013-09-16','11:45:00',2.25),('8348','2013-09-16','11:50:00',2.71),('8348','2013-09-16','11:55:00',3.29),('8348','2013-09-16','12:00:00',3.36),('8348','2013-09-16','12:05:00',3.64),('8348','2013-09-16','12:10:00',2.51),('8348','2013-09-16','12:15:00',3.59),('8348','2013-09-16','12:20:00',3.34),('8348','2013-09-16','12:25:00',3.33),('8348','2013-09-16','12:30:00',3.33),('8348','2013-09-16','12:35:00',3.4),('8348','2013-09-16','12:40:00',3.63),('8348','2013-09-16','12:45:00',2.94),('8348','2013-09-16','12:50:00',2.52),('8348','2013-09-16','12:55:00',2.09),('8348','2013-09-16','13:00:00',1.39),('8348','2013-09-16','13:05:00',2.68),('8348','2013-09-16','13:10:00',3.56),('8348','2013-09-16','13:15:00',3.42),('8348','2013-09-16','13:20:00',3.43),('8348','2013-09-16','13:25:00',3.39),('8348','2013-09-16','13:30:00',3.38),('8348','2013-09-16','13:35:00',3.45),('8348','2013-09-16','13:40:00',3.43),('8348','2013-09-16','13:45:00',3.39),('8348','2013-09-16','13:50:00',3.46),('8348','2013-09-16','13:55:00',3.54),('8348','2013-09-16','14:00:00',2.34),('8348','2013-09-16','14:05:00',3.42),('8348','2013-09-16','14:10:00',3.33),('8348','2013-09-16','14:15:00',3.27),('8348','2013-09-16','14:20:00',3.22),('8348','2013-09-16','14:25:00',3.23),('8348','2013-09-16','14:30:00',3.2),('8348','2013-09-16','14:35:00',3.17),('8348','2013-09-16','14:40:00',3.13),('8348','2013-09-16','14:45:00',3.12),('8348','2013-09-16','14:50:00',3.11),('8348','2013-09-16','14:55:00',3.1),('8348','2013-09-16','15:00:00',3.07),('8348','2013-09-16','15:05:00',3.06),('8348','2013-09-16','15:10:00',3.05),('8348','2013-09-16','15:15:00',3.02),('8348','2013-09-16','15:20:00',2.98),('8348','2013-09-16','15:25:00',2.93),('8348','2013-09-16','15:30:00',2.89),('8348','2013-09-16','15:35:00',2.84),('8348','2013-09-16','15:40:00',2.81),('8348','2013-09-16','15:45:00',2.76),('8348','2013-09-16','15:50:00',2.72),('8348','2013-09-16','15:55:00',2.67),('8348','2013-09-16','16:00:00',2.37),('8348','2013-09-16','16:05:00',1.41),('8348','2013-09-16','16:10:00',2.6),('8348','2013-09-16','16:15:00',2.47),('8348','2013-09-16','16:20:00',2.4),('8348','2013-09-16','16:25:00',2.34),('8348','2013-09-16','16:30:00',2.28),('8348','2013-09-16','16:35:00',2.2),('8348','2013-09-16','16:40:00',2.15),('8348','2013-09-16','16:45:00',2.09),('8348','2013-09-16','16:50:00',2.02),('8348','2013-09-16','16:55:00',1.94),('8348','2013-09-16','17:00:00',1.88),('8348','2013-09-16','17:05:00',1.8),('8348','2013-09-16','17:10:00',1.72),('8348','2013-09-16','17:15:00',1.63),('8348','2013-09-16','17:20:00',1.56),('8348','2013-09-16','17:25:00',1.49),('8348','2013-09-16','17:30:00',1.44),('8348','2013-09-16','17:35:00',1.35),('8348','2013-09-16','17:40:00',1.23),('8348','2013-09-16','17:45:00',1.15),('8348','2013-09-16','17:50:00',1.04),('8348','2013-09-15','08:45:00',1.04),('8348','2013-09-15','08:50:00',1.06),('8348','2013-09-15','08:55:00',1.05),('8348','2013-09-15','09:00:00',1.13),('8348','2013-09-15','09:05:00',1.13),('8348','2013-09-15','09:10:00',1.31),('8348','2013-09-15','09:15:00',1.48),('8348','2013-09-15','09:20:00',1.47),('8348','2013-09-15','09:25:00',1.58),('8348','2013-09-15','09:30:00',1.62),('8348','2013-09-15','09:35:00',1.74),('8348','2013-09-15','09:40:00',1.81),('8348','2013-09-15','09:45:00',1.83),('8348','2013-09-15','09:50:00',1.92),('8348','2013-09-15','09:55:00',1.98),('8348','2013-09-15','10:00:00',2.08),('8348','2013-09-15','10:05:00',2.14),('8348','2013-09-15','10:10:00',2.16),('8348','2013-09-15','10:15:00',2.1),('8348','2013-09-15','10:20:00',2.18),('8348','2013-09-15','10:25:00',2.28),('8348','2013-09-15','10:30:00',2.17),('8348','2013-09-15','10:35:00',1.66),('8348','2013-09-15','10:40:00',1.29),('8348','2013-09-15','10:50:00',1.33),('8348','2013-09-15','10:55:00',2.7),('8348','2013-09-15','11:00:00',2.84),('8348','2013-09-15','11:05:00',3.06),('8348','2013-09-15','11:10:00',2.78),('8348','2013-09-15','11:15:00',1.31),('8348','2013-09-15','11:20:00',1.09),('8348','2013-09-15','11:25:00',1.73),('8348','2013-09-15','11:30:00',2.08),('8348','2013-09-15','11:35:00',1.8),('8348','2013-09-15','11:40:00',1.24),('8348','2013-09-15','11:45:00',1.42),('8348','2013-09-15','11:50:00',3.53),('8348','2013-09-15','11:55:00',1.15),('8348','2013-09-15','12:00:00',1.05),('8348','2013-09-15','12:05:00',1.02),('8348','2013-09-15','12:10:00',1.01),('8348','2013-09-15','12:15:00',1.09),('8348','2013-09-15','12:20:00',1.33),('8348','2013-09-15','12:25:00',1.56),('8348','2013-09-15','12:30:00',1.48),('8348','2013-09-15','12:35:00',1.34),('8348','2013-09-15','12:40:00',1.23),('8348','2013-09-15','12:50:00',1.18),('8348','2013-09-15','12:55:00',1.24),('8348','2013-09-15','13:00:00',1.15),('8348','2013-09-15','13:35:00',1.12),('8348','2013-09-15','13:40:00',1.29),('8348','2013-09-15','13:45:00',2.44),('8348','2013-09-15','13:50:00',2.23),('8348','2013-09-15','13:55:00',1.1),('8348','2013-09-15','14:00:00',1.62),('8348','2013-09-15','14:05:00',1.53),('8348','2013-09-15','14:10:00',1.44),('8348','2013-09-15','14:15:00',1.37),('8348','2013-09-15','14:20:00',1.28),('8348','2013-09-15','14:25:00',1.25),('8348','2013-09-15','14:30:00',1.19),('8348','2013-09-15','14:40:00',1.05),('8348','2013-09-15','14:55:00',1),('8348','2013-09-15','15:00:00',1.02),('8348','2013-09-15','15:05:00',1.08),('8348','2013-09-15','15:10:00',1.23),('8348','2013-09-15','15:15:00',2.32),('8348','2013-09-15','15:20:00',1.86),('8348','2013-09-15','15:25:00',1.34),('8348','2013-09-14','08:50:00',1.03),('8348','2013-09-14','08:55:00',1.11),('8348','2013-09-14','09:00:00',1.18),('8348','2013-09-14','09:05:00',1.25),('8348','2013-09-14','09:10:00',1.35),('8348','2013-09-14','09:15:00',1.42),('8348','2013-09-14','09:20:00',1.5),('8348','2013-09-14','09:25:00',1.58),('8348','2013-09-14','09:30:00',1.66),('8348','2013-09-14','09:35:00',1.72),('8348','2013-09-14','09:40:00',1.78),('8348','2013-09-14','09:45:00',1.85),('8348','2013-09-14','09:50:00',1.87),('8348','2013-09-14','09:55:00',1.98),('8348','2013-09-14','10:00:00',2.03),('8348','2013-09-14','10:05:00',2.02),('8348','2013-09-14','10:10:00',1.98),('8348','2013-09-14','10:15:00',2.03),('8348','2013-09-14','10:20:00',2.19),('8348','2013-09-14','10:25:00',2.28),('8348','2013-09-14','10:30:00',2.33),('8348','2013-09-14','10:35:00',2.43),('8348','2013-09-14','10:40:00',2.58),('8348','2013-09-14','10:45:00',2.23),('8348','2013-09-14','10:50:00',2.9),('8348','2013-09-14','10:55:00',2.74),('8348','2013-09-14','11:00:00',1.72),('8348','2013-09-14','11:15:00',1.7),('8348','2013-09-14','11:25:00',2.3),('8348','2013-09-14','11:30:00',3.08),('8348','2013-09-14','11:35:00',3.24),('8348','2013-09-14','11:40:00',3.24),('8348','2013-09-14','11:45:00',3.24),('8348','2013-09-14','11:50:00',3.39),('8348','2013-09-14','11:55:00',1.37),('8348','2013-09-14','12:15:00',1.05),('8348','2013-09-14','12:30:00',1.32),('8348','2013-09-14','12:35:00',1.47),('8348','2013-09-14','12:40:00',1.95),('8348','2013-09-14','13:10:00',1.87),('8348','2013-09-14','13:15:00',3.8),('8348','2013-09-14','13:20:00',3.49),('8348','2013-09-14','13:25:00',3.27),('8348','2013-09-14','13:30:00',3.55),('8348','2013-09-14','13:35:00',2.57),('8348','2013-09-14','13:40:00',2.71),('8348','2013-09-14','13:45:00',2.88),('8348','2013-09-14','13:50:00',2.53),('8348','2013-09-14','13:55:00',3.36),('8348','2013-09-14','14:00:00',3.65),('8348','2013-09-14','14:05:00',3.43),('8348','2013-09-14','14:10:00',3.34),('8348','2013-09-14','14:15:00',3.35),('8348','2013-09-14','14:20:00',3.27),('8348','2013-09-14','14:25:00',3.25),('8348','2013-09-14','14:30:00',3.24),('8348','2013-09-14','14:35:00',3.23),('8348','2013-09-14','14:40:00',3.22),('8348','2013-09-14','14:45:00',3.17),('8348','2013-09-14','14:50:00',3.15),('8348','2013-09-14','14:55:00',3.13),('8348','2013-09-14','15:00:00',3.1),('8348','2013-09-14','15:05:00',3.02),('8348','2013-09-14','15:10:00',3.01),('8348','2013-09-14','15:15:00',2.97),('8348','2013-09-14','15:20:00',2.93),('8348','2013-09-14','15:25:00',2.93),('8348','2013-09-14','15:30:00',2.88),('8348','2013-09-14','15:35:00',2.82),('8348','2013-09-14','15:40:00',2.81),('8348','2013-09-14','15:45:00',2.76),('8348','2013-09-14','15:50:00',2.68),('8348','2013-09-14','15:55:00',2.65),('8348','2013-09-14','16:00:00',2.59),('8348','2013-09-14','16:05:00',2.55),('8348','2013-09-14','16:10:00',2.46),('8348','2013-09-14','16:15:00',2.41),('8348','2013-09-14','16:20:00',2.34),('8348','2013-09-14','16:25:00',2.31),('8348','2013-09-14','16:30:00',2.26),('8348','2013-09-14','16:35:00',2.21),('8348','2013-09-14','16:40:00',2.15),('8348','2013-09-14','16:45:00',2.06),('8348','2013-09-14','16:50:00',2.01),('8348','2013-09-14','16:55:00',1.94),('8348','2013-09-14','17:00:00',1.86),('8348','2013-09-14','17:05:00',1.79),('8348','2013-09-14','17:10:00',1.75),('8348','2013-09-14','17:15:00',1.68),('8348','2013-09-14','17:20:00',1.39),('8348','2013-09-14','17:25:00',1.49),('8348','2013-09-14','17:30:00',1.42),('8348','2013-09-14','17:35:00',1.33),('8348','2013-09-14','17:40:00',1.25),('8348','2013-09-14','17:45:00',1.19),('8348','2013-09-14','17:50:00',1.12),('8348','2013-09-13','09:30:00',1.03),('8348','2013-09-13','09:35:00',1.13),('8348','2013-09-13','09:40:00',1.22),('8348','2013-09-13','09:45:00',1.13),('8348','2013-09-13','09:50:00',1.27),('8348','2013-09-13','09:55:00',1.62),('8348','2013-09-13','10:00:00',2.06),('8348','2013-09-13','10:10:00',1.68),('8348','2013-09-13','10:15:00',2.86),('8348','2013-09-13','10:20:00',2.3),('8348','2013-09-13','10:25:00',1.18),('8348','2013-09-13','10:30:00',2.26),('8348','2013-09-13','10:35:00',2.59),('8348','2013-09-13','10:40:00',2.48),('8348','2013-09-13','10:45:00',2.55),('8348','2013-09-13','10:50:00',2.59),('8348','2013-09-13','10:55:00',2.63),('8348','2013-09-13','11:00:00',2.66),('8348','2013-09-13','11:05:00',2.71),('8348','2013-09-13','11:10:00',2.74),('8348','2013-09-13','11:15:00',2.77),('8348','2013-09-13','11:20:00',2.82),('8348','2013-09-13','11:25:00',2.85),('8348','2013-09-13','11:30:00',2.9),('8348','2013-09-13','11:35:00',2.93),('8348','2013-09-13','11:40:00',2.95),('8348','2013-09-13','11:45:00',2.97),('8348','2013-09-13','11:50:00',3.03),('8348','2013-09-13','11:55:00',3.04),('8348','2013-09-13','12:00:00',3.03),('8348','2013-09-13','12:05:00',3.05),('8348','2013-09-13','12:10:00',2.99),('8348','2013-09-13','12:15:00',3.13),('8348','2013-09-13','12:20:00',3.13),('8348','2013-09-13','12:25:00',2.95),('8348','2013-09-13','12:30:00',3.33),('8348','2013-09-13','12:35:00',3.29),('8348','2013-09-13','12:40:00',3.28),('8348','2013-09-13','12:45:00',3.29),('8348','2013-09-13','12:50:00',3.3),('8348','2013-09-13','12:55:00',3.29),('8348','2013-09-13','13:00:00',3.28),('8348','2013-09-13','13:05:00',3.26),('8348','2013-09-13','13:10:00',3.28),('8348','2013-09-13','13:15:00',3.27),('8348','2013-09-13','13:20:00',3.24),('8348','2013-09-13','13:25:00',3.2),('8348','2013-09-13','13:30:00',3.19),('8348','2013-09-13','13:35:00',3.2),('8348','2013-09-13','13:40:00',3.21),('8348','2013-09-13','13:45:00',3.19),('8348','2013-09-13','13:50:00',3.19),('8348','2013-09-13','13:55:00',3.24),('8348','2013-09-13','14:00:00',3.26),('8348','2013-09-13','14:05:00',3.22),('8348','2013-09-13','14:10:00',3.19),('8348','2013-09-13','14:15:00',3.21),('8348','2013-09-13','14:20:00',3.22),('8348','2013-09-13','14:25:00',2.82),('8348','2013-09-13','14:30:00',2.4),('8348','2013-09-13','14:35:00',3.16),('8348','2013-09-13','14:40:00',3.12),('8348','2013-09-13','14:45:00',2.82),('8348','2013-09-13','14:50:00',2.43),('8348','2013-09-13','14:55:00',2.87),('8348','2013-09-13','15:00:00',3.06),('8348','2013-09-13','15:05:00',3.04),('8348','2013-09-13','15:10:00',3.03),('8348','2013-09-13','15:15:00',3.02),('8348','2013-09-13','15:20:00',2.95),('8348','2013-09-13','15:25:00',2.92),('8348','2013-09-13','15:30:00',2.88),('8348','2013-09-13','15:35:00',2.82),('8348','2013-09-13','15:40:00',2.8),('8348','2013-09-13','15:45:00',2.78),('8348','2013-09-13','15:50:00',2.74),('8348','2013-09-13','15:55:00',2.69),('8348','2013-09-13','16:00:00',2.63),('8348','2013-09-13','16:05:00',2.59),('8348','2013-09-13','16:10:00',2.51),('8348','2013-09-13','16:15:00',2.49),('8348','2013-09-13','16:20:00',2.42),('8348','2013-09-13','16:25:00',2.36),('8348','2013-09-13','16:30:00',2.3),('8348','2013-09-13','16:35:00',2.24),('8348','2013-09-13','16:40:00',2.18),('8348','2013-09-13','16:45:00',2.1),('8348','2013-09-13','16:50:00',2.04),('8348','2013-09-13','16:55:00',1.95),('8348','2013-09-13','17:00:00',1.88),('8348','2013-09-13','17:05:00',1.8),('8348','2013-09-13','17:10:00',1.73),('8348','2013-09-13','17:15:00',1.66),('8348','2013-09-13','17:20:00',1.59),('8348','2013-09-13','17:25:00',1.51),('8348','2013-09-13','17:30:00',1.43),('8348','2013-09-13','17:35:00',1.34),('8348','2013-09-13','17:40:00',1.26),('8348','2013-09-13','17:45:00',1.19),('8348','2013-09-13','17:50:00',1.11),('8348','2013-09-13','17:55:00',1.03),('8348','2013-09-12','08:30:00',1.1),('8348','2013-09-12','08:35:00',1.04),('8348','2013-09-12','09:00:00',1.2),('8348','2013-09-12','09:05:00',1.2),('8348','2013-09-12','09:15:00',1.41),('8348','2013-09-12','09:20:00',1.54),('8348','2013-09-12','09:25:00',1.75),('8348','2013-09-12','09:30:00',1.91),('8348','2013-09-12','09:35:00',1.85),('8348','2013-09-12','09:40:00',1.56),('8348','2013-09-12','09:45:00',1.9),('8348','2013-09-12','09:50:00',1.5),('8348','2013-09-12','09:55:00',1.02),('8348','2013-09-12','10:05:00',1.26),('8348','2013-09-12','10:10:00',1.49),('8348','2013-09-12','10:15:00',1.45),('8348','2013-09-12','10:20:00',1.04),('8348','2013-09-12','10:25:00',1.13),('8348','2013-09-12','10:30:00',1.99),('8348','2013-09-12','10:35:00',1.55),('8348','2013-09-12','10:55:00',1.67),('8348','2013-09-12','11:00:00',2.18),('8348','2013-09-12','11:05:00',3.11),('8348','2013-09-12','11:10:00',2.48),('8348','2013-09-12','11:15:00',2.2),('8348','2013-09-12','11:40:00',1.18),('8348','2013-09-12','11:45:00',1.63),('8348','2013-09-12','11:50:00',1.46),('8348','2013-09-12','11:55:00',2.76),('8348','2013-09-12','12:00:00',2.67),('8348','2013-09-12','12:05:00',3.15),('8348','2013-09-12','12:10:00',2.72),('8348','2013-09-12','12:15:00',3.18),('8348','2013-09-12','12:20:00',1.26),('8348','2013-09-12','12:25:00',1.64),('8348','2013-09-12','12:30:00',1.42),('8348','2013-09-12','12:35:00',2.72),('8348','2013-09-12','12:40:00',3.15),('8348','2013-09-12','12:50:00',2.42),('8348','2013-09-12','12:55:00',1.68),('8348','2013-09-12','13:00:00',3.75),('8348','2013-09-12','13:05:00',2.25),('8348','2013-09-12','13:10:00',2),('8348','2013-09-12','13:15:00',3.51),('8348','2013-09-12','13:20:00',3.9),('8348','2013-09-12','13:25:00',3.93),('8348','2013-09-12','13:30:00',3.05),('8348','2013-09-12','13:35:00',2.45),('8348','2013-09-12','13:40:00',2.85),('8348','2013-09-12','13:45:00',3.12),('8348','2013-09-12','13:50:00',3.6),('8348','2013-09-12','13:55:00',3.48),('8348','2013-09-12','14:00:00',3.51),('8348','2013-09-12','14:05:00',2.9),('8348','2013-09-12','14:10:00',2.86),('8348','2013-09-12','14:15:00',3.46),('8348','2013-09-12','14:20:00',3.52),('8348','2013-09-12','14:25:00',3.4),('8348','2013-09-12','14:30:00',3.44),('8348','2013-09-12','14:35:00',2.32),('8348','2013-09-12','14:40:00',2.94),('8348','2013-09-12','14:45:00',3.28),('8348','2013-09-12','14:50:00',3.25),('8348','2013-09-12','14:55:00',3.22),('8348','2013-09-12','15:00:00',3.23),('8348','2013-09-12','15:05:00',2.76),('8348','2013-09-12','15:10:00',2.15),('8348','2013-09-12','15:15:00',2.91),('8348','2013-09-12','15:20:00',3.05),('8348','2013-09-12','15:25:00',2.68),('8348','2013-09-12','15:30:00',2.98),('8348','2013-09-12','15:35:00',2.91),('8348','2013-09-12','15:40:00',2.89),('8348','2013-09-12','15:45:00',2.87),('8348','2013-09-12','15:50:00',2.77),('8348','2013-09-12','15:55:00',2.74),('8348','2013-09-12','16:00:00',2.82),('8348','2013-09-12','16:05:00',1.59),('8348','2013-09-12','16:10:00',2.69),('8348','2013-09-12','16:15:00',2.18),('8348','2013-09-12','16:20:00',1.67),('8348','2013-09-12','16:25:00',1.47),('8348','2013-09-12','16:30:00',1.48),('8348','2013-09-12','16:40:00',1.99),('8348','2013-09-12','16:45:00',2.39),('8348','2013-09-12','16:50:00',1.09),('8348','2013-09-12','16:55:00',1.5),('8348','2013-09-12','17:00:00',1.33),('8348','2013-09-12','17:05:00',1.82),('8348','2013-09-12','17:10:00',1.65),('8348','2013-09-12','17:15:00',1.77),('8348','2013-09-12','17:20:00',1.37),('8348','2013-09-12','17:30:00',1.6),('8348','2013-09-12','17:35:00',1.49),('8348','2013-09-12','17:40:00',1.39),('8348','2013-09-12','17:45:00',1.31),('8348','2013-09-12','17:50:00',1.16),('8348','2013-09-12','17:55:00',1.09),('8348','2013-09-11','09:00:00',1.37),('8348','2013-09-11','09:05:00',1.52),('8348','2013-09-11','09:10:00',1.55),('8348','2013-09-11','09:15:00',1.59),('8348','2013-09-11','09:20:00',1.98),('8348','2013-09-11','09:25:00',1.41),('8348','2013-09-11','09:30:00',1.04),('8348','2013-09-11','09:35:00',1.31),('8348','2013-09-11','09:40:00',1.12),('8348','2013-09-11','10:05:00',1.78),('8348','2013-09-11','10:15:00',1.9),('8348','2013-09-11','10:20:00',2.36),('8348','2013-09-11','10:25:00',1.84),('8348','2013-09-11','10:30:00',2.39),('8348','2013-09-11','10:35:00',2.56),('8348','2013-09-11','10:40:00',1.67),('8348','2013-09-11','10:45:00',1.35),('8348','2013-09-11','10:50:00',2.56),('8348','2013-09-11','10:55:00',1.21),('8348','2013-09-11','11:00:00',1.24),('8348','2013-09-11','11:05:00',1.32),('8348','2013-09-11','11:10:00',2.62),('8348','2013-09-11','11:15:00',2.28),('8348','2013-09-11','11:20:00',2.6),('8348','2013-09-11','11:25:00',2.17),('8348','2013-09-11','11:35:00',1.94),('8348','2013-09-11','11:40:00',3.03),('8348','2013-09-11','11:45:00',3.24),('8348','2013-09-11','11:50:00',2.93),('8348','2013-09-11','11:55:00',2.67),('8348','2013-09-11','12:00:00',2.81),('8348','2013-09-11','12:05:00',3.07),('8348','2013-09-11','12:10:00',1.98),('8348','2013-09-11','12:15:00',1.58),('8348','2013-09-11','12:20:00',1.81),('8348','2013-09-11','12:25:00',2.74),('8348','2013-09-11','12:30:00',2.99),('8348','2013-09-11','12:35:00',2.24),('8348','2013-09-11','12:45:00',1.52),('8348','2013-09-11','12:50:00',3.56),('8348','2013-09-11','12:55:00',1.81),('8348','2013-09-11','13:00:00',2.74),('8348','2013-09-11','13:05:00',3.22),('8348','2013-09-11','13:10:00',3.47),('8348','2013-09-11','13:15:00',3.84),('8348','2013-09-11','13:20:00',3.51),('8348','2013-09-11','13:25:00',3.26),('8348','2013-09-11','13:30:00',3.02),('8348','2013-09-11','13:35:00',1.82),('8348','2013-09-11','13:40:00',2.6),('8348','2013-09-11','13:45:00',2.63),('8348','2013-09-11','13:50:00',3.25),('8348','2013-09-11','13:55:00',2.38),('8348','2013-09-11','14:00:00',2.92),('8348','2013-09-11','14:05:00',3.62),('8348','2013-09-11','14:10:00',3),('8348','2013-09-11','14:15:00',3.49),('8348','2013-09-11','14:20:00',2.35),('8348','2013-09-11','14:25:00',3.12),('8348','2013-09-11','14:30:00',2.69),('8348','2013-09-11','14:35:00',2.79),('8348','2013-09-11','14:40:00',1.57),('8348','2013-09-11','14:45:00',3.09),('8348','2013-09-11','14:50:00',3.61),('8348','2013-09-11','14:55:00',2.96),('8348','2013-09-11','15:00:00',2.23),('8348','2013-09-11','15:05:00',3.24),('8348','2013-09-11','15:10:00',2.15),('8348','2013-09-11','15:15:00',3.07),('8348','2013-09-11','15:20:00',2.8),('8348','2013-09-11','15:25:00',2.77),('8348','2013-09-11','15:30:00',3.19),('8348','2013-09-11','15:35:00',1.08),('8348','2013-09-11','15:40:00',1.92),('8348','2013-09-11','15:45:00',2.38),('8348','2013-09-11','15:50:00',3),('8348','2013-09-11','15:55:00',2.06),('8348','2013-09-11','16:00:00',2.24),('8348','2013-09-11','16:05:00',2.82),('8348','2013-09-11','16:10:00',2.54),('8348','2013-09-11','16:15:00',2.61),('8348','2013-09-11','16:20:00',2.54),('8348','2013-09-11','16:25:00',2.39),('8348','2013-09-11','16:30:00',1.18),('8348','2013-09-11','16:35:00',1.63),('8348','2013-09-11','16:40:00',1.26),('8348','2013-09-11','16:45:00',2.34),('8348','2013-09-11','16:50:00',2.08),('8348','2013-09-11','16:55:00',1.94),('8348','2013-09-11','17:00:00',1.94),('8348','2013-09-11','17:05:00',1.87),('8348','2013-09-11','17:10:00',1.81),('8348','2013-09-11','17:15:00',1.72),('8348','2013-09-11','17:20:00',1.65),('8348','2013-09-11','17:25:00',1.57),('8348','2013-09-11','17:30:00',1.49),('8348','2013-09-11','17:35:00',1.41),('8348','2013-09-11','17:40:00',1.36),('8348','2013-09-11','17:45:00',1.2),('8348','2013-09-11','18:00:00',1.07),('8348','2013-09-10','08:55:00',1.05),('8348','2013-09-10','09:00:00',1.21),('8348','2013-09-10','09:05:00',1.2),('8348','2013-09-10','09:10:00',1.65),('8348','2013-09-10','09:15:00',1.47),('8348','2013-09-10','09:20:00',1.27),('8348','2013-09-10','09:25:00',1.31),('8348','2013-09-10','09:30:00',2.01),('8348','2013-09-10','09:35:00',2.15),('8348','2013-09-10','09:40:00',1.35),('8348','2013-09-10','09:45:00',1.16),('8348','2013-09-10','09:50:00',1.07),('8348','2013-09-10','10:40:00',1.34),('8348','2013-09-10','10:45:00',1.83),('8348','2013-09-10','10:50:00',1.12),('8348','2013-09-10','10:55:00',1.16),('8348','2013-09-10','11:00:00',1.43),('8348','2013-09-10','11:05:00',1.27),('8348','2013-09-10','11:10:00',1.25),('8348','2013-09-10','11:15:00',1.07),('8348','2013-09-10','11:20:00',1.17),('8348','2013-09-10','11:25:00',1.32),('8348','2013-09-10','11:45:00',1.24),('8348','2013-09-10','11:50:00',1.19),('8348','2013-09-10','11:55:00',1.51),('8348','2013-09-10','12:00:00',1.31),('8348','2013-09-10','13:25:00',1.01),('8348','2013-09-10','13:40:00',1.6),('8348','2013-09-10','13:45:00',2.42),('8348','2013-09-10','13:50:00',1.63),('8348','2013-09-10','13:55:00',1.4),('8348','2013-09-10','14:00:00',1.03),('8348','2013-09-10','14:05:00',1.19),('8348','2013-09-10','14:10:00',1.21),('8348','2013-09-10','14:15:00',1.46),('8348','2013-09-10','14:20:00',1.45),('8348','2013-09-10','14:25:00',1.97),('8348','2013-09-10','14:30:00',1.73),('8348','2013-09-10','14:35:00',1.29),('8348','2013-09-10','14:40:00',1.56),('8348','2013-09-10','14:45:00',1.65),('8348','2013-09-10','14:50:00',1.95),('8348','2013-09-10','14:55:00',1.75),('8348','2013-09-10','15:00:00',2.2),('8348','2013-09-10','15:05:00',2.01),('8348','2013-09-10','15:10:00',1.55),('8348','2013-09-10','15:15:00',1.41),('8348','2013-09-10','15:20:00',1.83),('8348','2013-09-10','15:25:00',1.61),('8348','2013-09-10','15:30:00',1.88),('8348','2013-09-10','15:35:00',1.67),('8348','2013-09-10','15:40:00',1.08),('8348','2013-09-10','16:10:00',1.2),('8348','2013-09-10','16:15:00',1.33),('8348','2013-09-09','08:55:00',1.01),('8348','2013-09-09','09:00:00',1.06),('8348','2013-09-09','10:00:00',1.17),('8348','2013-09-09','10:05:00',1.5),('8348','2013-09-09','10:10:00',1.53),('8348','2013-09-09','10:15:00',1.39),('8348','2013-09-09','10:20:00',1.34),('8348','2013-09-09','10:25:00',1.22),('8348','2013-09-09','10:30:00',1.3),('8348','2013-09-09','10:35:00',1.3),('8348','2013-09-09','10:40:00',1.48),('8348','2013-09-09','10:45:00',1.68),('8348','2013-09-09','10:50:00',2.15),('8348','2013-09-09','10:55:00',2.08),('8348','2013-09-09','11:00:00',2.29),('8348','2013-09-09','11:05:00',1.74),('8348','2013-09-09','11:10:00',1.64),('8348','2013-09-09','11:15:00',1.86),('8348','2013-09-09','11:20:00',2.08),('8348','2013-09-09','11:25:00',2.17),('8348','2013-09-09','11:30:00',1.77),('8348','2013-09-09','11:35:00',1.8),('8348','2013-09-09','11:40:00',2.68),('8348','2013-09-09','11:45:00',2.46),('8348','2013-09-09','11:50:00',2.57),('8348','2013-09-09','11:55:00',2.63),('8348','2013-09-09','12:00:00',2.42),('8348','2013-09-09','12:05:00',2.68),('8348','2013-09-09','12:10:00',2.46),('8348','2013-09-09','12:15:00',2.14),('8348','2013-09-09','12:20:00',1.34),('8348','2013-09-09','12:25:00',1.02),('8348','2013-09-09','12:40:00',1.22),('8348','2013-09-09','12:45:00',1.34),('8348','2013-09-09','12:50:00',1.08),('8348','2013-09-09','12:55:00',1.25),('8348','2013-09-09','13:00:00',1.3),('8348','2013-09-09','13:05:00',2.13),('8348','2013-09-09','13:10:00',1.64),('8348','2013-09-09','13:15:00',2.63),('8348','2013-09-09','13:20:00',2.66),('8348','2013-09-09','13:25:00',2.44),('8348','2013-09-09','13:30:00',3.01),('8348','2013-09-09','13:35:00',3.35),('8348','2013-09-09','13:40:00',2.71),('8348','2013-09-09','13:45:00',3.31),('8348','2013-09-09','13:50:00',3.08),('8348','2013-09-09','13:55:00',3.3),('8348','2013-09-09','14:00:00',3.17),('8348','2013-09-09','14:05:00',3.06),('8348','2013-09-09','14:10:00',3.38),('8348','2013-09-09','14:15:00',2.39),('8348','2013-09-09','14:20:00',1.8),('8348','2013-09-09','14:25:00',1.49),('8348','2013-09-09','14:30:00',1.54),('8348','2013-09-09','14:35:00',3.42),('8348','2013-09-09','14:40:00',3.31),('8348','2013-09-09','14:45:00',2.29),('8348','2013-09-09','14:50:00',3),('8348','2013-09-09','14:55:00',2.57),('8348','2013-09-09','15:00:00',2.35),('8348','2013-09-09','15:05:00',2.25),('8348','2013-09-09','15:10:00',2.21),('8348','2013-09-09','15:15:00',1.16),('8348','2013-09-09','15:20:00',1.89),('8348','2013-09-09','15:25:00',1.1),('8348','2013-09-09','15:30:00',2.73),('8348','2013-09-09','15:35:00',1.97),('8348','2013-09-09','15:40:00',2.51),('8348','2013-09-09','15:45:00',1.11),('8348','2013-09-09','15:50:00',1.19),('8348','2013-09-09','15:55:00',1.23),('8348','2013-09-09','16:00:00',1.44),('8348','2013-09-09','16:05:00',1.25),('8348','2013-09-09','16:10:00',1.52),('8348','2013-09-09','16:15:00',2.06),('8348','2013-09-09','16:20:00',1.52),('8348','2013-09-09','16:25:00',1.02),('8348','2013-09-09','16:30:00',1.01),('8348','2013-09-09','16:35:00',1.12),('8348','2013-09-09','16:40:00',1.3),('8348','2013-09-09','16:45:00',1.62),('8348','2014-04-12','07:10:00',1.12),('8348','2014-04-12','07:15:00',1.15),('8348','2014-04-12','07:20:00',1.1),('8348','2014-04-12','07:25:00',1.26),('8348','2014-04-12','07:50:00',1.07),('8348','2014-04-12','07:55:00',1.07),('8348','2014-04-12','08:00:00',1.06),('8348','2014-04-12','08:05:00',1.28),('8348','2014-04-12','08:10:00',1.85),('8348','2014-04-12','08:15:00',2.51),('8348','2014-04-12','08:20:00',3.43),('8348','2014-04-12','08:25:00',4.13),('8348','2014-04-12','08:30:00',3.07),('8348','2014-04-12','08:35:00',2.88),('8348','2014-04-12','08:40:00',2.44),('8348','2014-04-12','08:45:00',2.42),('8348','2014-04-12','08:50:00',2.57),('8348','2014-04-12','08:55:00',2.63),('8348','2014-04-12','09:00:00',2.69),('8348','2014-04-12','09:05:00',2.61),('8348','2014-04-12','09:10:00',2.79),('8348','2014-04-12','09:15:00',3.01),('8348','2014-04-12','09:20:00',3.31),('8348','2014-04-12','09:25:00',3.45),('8348','2014-04-12','09:30:00',3.51),('8348','2014-04-12','09:35:00',3.99),('8348','2014-04-12','09:40:00',3.91),('8348','2014-04-12','09:45:00',4.56),('8348','2014-04-12','09:50:00',4.87),('8348','2014-04-12','09:55:00',4.92),('8348','2014-04-12','10:00:00',3.25),('8348','2014-04-12','10:05:00',4.74),('8348','2014-04-12','10:10:00',4.29),('8348','2014-04-12','10:15:00',6.82),('8348','2014-04-12','10:20:00',6.89),('8348','2014-04-12','10:25:00',6.01),('8348','2014-04-12','10:30:00',5.58),('8348','2014-04-12','10:35:00',6.36),('8348','2014-04-12','10:40:00',6.29),('8348','2014-04-12','10:45:00',6.43),('8348','2014-04-12','10:50:00',5.27),('8348','2014-04-12','10:55:00',6.53),('8348','2014-04-12','11:00:00',3.94),('8348','2014-04-12','11:05:00',2.92),('8348','2014-04-12','11:10:00',4.73),('8348','2014-04-12','11:15:00',3.74),('8348','2014-04-12','11:20:00',4.05),('8348','2014-04-12','11:25:00',5.56),('8348','2014-04-12','11:30:00',4.7),('8348','2014-04-12','11:35:00',4.7),('8348','2014-04-12','11:40:00',5.21),('8348','2014-04-12','11:45:00',5.11),('8348','2014-04-12','11:50:00',3.32),('8348','2014-04-12','11:55:00',4.51),('8348','2014-04-12','12:00:00',4.15),('8348','2014-04-12','12:05:00',6.01),('8348','2014-04-12','12:10:00',5.12),('8348','2014-04-12','12:15:00',6.89),('8348','2014-04-12','12:20:00',7.51),('8348','2014-04-12','12:25:00',7.62),('8348','2014-04-12','12:30:00',7.4),('8348','2014-04-12','12:35:00',2.8),('8348','2014-04-12','12:40:00',2.67),('8348','2014-04-12','12:45:00',7.57),('8348','2014-04-12','12:50:00',6.88),('8348','2014-04-12','12:55:00',2.91),('8348','2014-04-12','13:00:00',5.46),('8348','2014-04-12','13:05:00',7.52),('8348','2014-04-12','13:10:00',7.36),('8348','2014-04-12','13:15:00',6.6),('8348','2014-04-12','13:20:00',6.45),('8348','2014-04-12','13:25:00',4.65),('8348','2014-04-12','13:30:00',4.53),('8348','2014-04-12','13:35:00',2.42),('8348','2014-04-12','13:40:00',2.46),('8348','2014-04-12','13:45:00',4.16),('8348','2014-04-12','13:50:00',6.36),('8348','2014-04-12','13:55:00',4.51),('8348','2014-04-12','14:00:00',5.77),('8348','2014-04-12','14:05:00',6.22),('8348','2014-04-12','14:10:00',6.53),('8348','2014-04-12','14:15:00',6.48),('8348','2014-04-12','14:20:00',4.89),('8348','2014-04-12','14:25:00',4.84),('8348','2014-04-12','14:30:00',3.88),('8348','2014-04-12','14:35:00',4.62),('8348','2014-04-12','14:40:00',5.4),('8348','2014-04-12','14:45:00',5.74),('8348','2014-04-12','14:50:00',6.35),('8348','2014-04-12','14:55:00',6.18),('8348','2014-04-12','15:00:00',6.21),('8348','2014-04-12','15:05:00',6.11),('8348','2014-04-12','15:10:00',5.87),('8348','2014-04-12','15:15:00',5.9),('8348','2014-04-12','15:20:00',6.02),('8348','2014-04-12','15:25:00',5.45),('8348','2014-04-12','15:30:00',5.28),('8348','2014-04-12','15:35:00',4.85),('8348','2014-04-12','15:40:00',4.43),('8348','2014-04-12','15:45:00',4.73),('8348','2014-04-12','15:50:00',2.9),('8348','2014-04-12','15:55:00',4.42),('8348','2014-04-12','16:00:00',4.43),('8348','2014-04-12','16:05:00',4.23),('8348','2014-04-12','16:10:00',4.21),('8348','2014-04-12','16:15:00',3.94),('8348','2014-04-12','16:20:00',3.21),('8348','2014-04-12','16:25:00',3.6),('8348','2014-04-12','16:30:00',3.67),('8348','2014-04-12','16:35:00',2.94),('8348','2014-04-12','16:40:00',3.37),('8348','2014-04-12','16:45:00',3.66),('8348','2014-04-12','16:50:00',3.22),('8348','2014-04-12','16:55:00',3.01),('8348','2014-04-12','17:00:00',2.45),('8348','2014-04-12','17:05:00',1.52),('8348','2014-04-12','17:50:00',1.01),('8348','2013-09-08','09:15:00',1.28),('8348','2013-09-08','09:20:00',1.31),('8348','2013-09-08','09:25:00',1.43),('8348','2013-09-08','09:30:00',1.34),('8348','2013-09-08','09:35:00',1.25),('8348','2013-09-08','09:40:00',1.59),('8348','2013-09-08','09:45:00',1.72),('8348','2013-09-08','09:50:00',1.81),('8348','2013-09-08','09:55:00',1.8),('8348','2013-09-08','10:00:00',1.86),('8348','2013-09-08','10:05:00',1.9),('8348','2013-09-08','10:10:00',2.02),('8348','2013-09-08','10:15:00',2.09),('8348','2013-09-08','10:20:00',2.13),('8348','2013-09-08','10:25:00',2.16),('8348','2013-09-08','10:30:00',2.18),('8348','2013-09-08','10:35:00',2.21),('8348','2013-09-08','10:40:00',2.33),('8348','2013-09-08','10:45:00',2.39),('8348','2013-09-08','10:50:00',2.43),('8348','2013-09-08','10:55:00',2.44),('8348','2013-09-08','11:00:00',2.46),('8348','2013-09-08','11:05:00',2.4),('8348','2013-09-08','11:10:00',2.45),('8348','2013-09-08','11:15:00',2.52),('8348','2013-09-08','11:20:00',2.59),('8348','2013-09-08','11:25:00',2.6),('8348','2013-09-08','11:30:00',2.61),('8348','2013-09-08','11:35:00',2.6),('8348','2013-09-08','11:40:00',2.63),('8348','2013-09-08','11:45:00',2.67),('8348','2013-09-08','11:50:00',2.74),('8348','2013-09-08','11:55:00',2.74),('8348','2013-09-08','12:00:00',2.71),('8348','2013-09-08','12:05:00',2.72),('8348','2013-09-08','12:10:00',2.7),('8348','2013-09-08','12:15:00',2.88),('8348','2013-09-08','12:20:00',2.85),('8348','2013-09-08','12:25:00',2.87),('8348','2013-09-08','12:30:00',2.92),('8348','2013-09-08','12:35:00',2.86),('8348','2013-09-08','12:40:00',2.82),('8348','2013-09-08','12:45:00',2.94),('8348','2013-09-08','12:50:00',2.92),('8348','2013-09-08','12:55:00',2.96),('8348','2013-09-08','13:00:00',2.94),('8348','2013-09-08','13:05:00',3),('8348','2013-09-08','13:10:00',3),('8348','2013-09-08','13:15:00',2.95),('8348','2013-09-08','13:20:00',2.98),('8348','2013-09-08','13:25:00',2.75),('8348','2013-09-08','13:30:00',2.72),('8348','2013-09-08','13:35:00',2.7),('8348','2013-09-08','13:40:00',2.02),('8348','2013-09-08','13:45:00',1.84),('8348','2013-09-08','13:50:00',2.26),('8348','2013-09-08','13:55:00',2.34),('8348','2013-09-08','14:00:00',2.82),('8348','2013-09-08','14:05:00',2.89),('8348','2013-09-08','14:10:00',3.16),('8348','2013-09-08','14:15:00',2.81),('8348','2013-09-08','14:20:00',2.97),('8348','2013-09-08','14:25:00',3.36),('8348','2013-09-08','14:30:00',2.97),('8348','2013-09-08','14:35:00',3.17),('8348','2013-09-08','14:40:00',3.09),('8348','2013-09-08','14:45:00',3.08),('8348','2013-09-08','14:50:00',3.04),('8348','2013-09-08','14:55:00',2.99),('8348','2013-09-08','15:00:00',2.99),('8348','2013-09-08','15:05:00',2.45),('8348','2013-09-08','15:10:00',1.68),('8348','2013-09-08','15:15:00',2.29),('8348','2013-09-08','15:20:00',2.86),('8348','2013-09-08','15:25:00',2.9),('8348','2013-09-08','15:30:00',2.91),('8348','2013-09-08','15:35:00',2.8),('8348','2013-09-08','15:40:00',2.6),('8348','2013-09-08','15:45:00',2.67),('8348','2013-09-08','15:50:00',2.63),('8348','2013-09-08','15:55:00',2.13),('8348','2013-09-08','16:00:00',2.27),('8348','2013-09-08','16:05:00',2.24),('8348','2013-09-08','16:10:00',2.01),('8348','2013-09-08','16:15:00',2.35),('8348','2013-09-08','16:20:00',2.13),('8348','2013-09-08','16:25:00',2.05),('8348','2013-09-08','16:30:00',2.17),('8348','2013-09-08','16:35:00',2),('8348','2013-09-08','16:40:00',1.67),('8348','2013-09-08','16:45:00',1.17),('8348','2013-09-08','16:50:00',1.2),('8348','2013-09-08','16:55:00',1.08),('8348','2013-09-08','17:00:00',1.24),('8348','2013-09-08','17:05:00',1.91),('8348','2013-09-08','17:10:00',1.81),('8348','2013-09-08','17:15:00',1.66),('8348','2013-09-08','17:20:00',1.45),('8348','2013-09-08','17:25:00',1.44),('8348','2013-09-08','17:30:00',1.32),('8348','2013-09-08','17:45:00',1.07),('8348','2013-09-08','17:50:00',1.07),('8348','2013-09-07','08:50:00',1.01),('8348','2013-09-07','08:55:00',1.06),('8348','2013-09-07','09:00:00',1.16),('8348','2013-09-07','09:05:00',1.24),('8348','2013-09-07','09:10:00',1.31),('8348','2013-09-07','09:15:00',1.4),('8348','2013-09-07','09:20:00',1.47),('8348','2013-09-07','09:25:00',1.55),('8348','2013-09-07','09:30:00',1.61),('8348','2013-09-07','09:35:00',1.68),('8348','2013-09-07','09:40:00',1.73),('8348','2013-09-07','09:45:00',1.78),('8348','2013-09-07','09:50:00',1.84),('8348','2013-09-07','09:55:00',1.9),('8348','2013-09-07','10:00:00',1.95),('8348','2013-09-07','10:05:00',2.01),('8348','2013-09-07','10:10:00',2.06),('8348','2013-09-07','10:15:00',2.13),('8348','2013-09-07','10:20:00',2.17),('8348','2013-09-07','10:25:00',2.22),('8348','2013-09-07','10:30:00',2.25),('8348','2013-09-07','10:35:00',2.31),('8348','2013-09-07','10:40:00',2.35),('8348','2013-09-07','10:45:00',2.39),('8348','2013-09-07','10:50:00',2.43),('8348','2013-09-07','10:55:00',2.48),('8348','2013-09-07','11:00:00',2.52),('8348','2013-09-07','11:05:00',2.57),('8348','2013-09-07','11:10:00',2.61),('8348','2013-09-07','11:15:00',2.64),('8348','2013-09-07','11:20:00',2.67),('8348','2013-09-07','11:25:00',2.7),('8348','2013-09-07','11:30:00',2.74),('8348','2013-09-07','11:35:00',2.76),('8348','2013-09-07','11:40:00',2.81),('8348','2013-09-07','11:45:00',2.85),('8348','2013-09-07','11:50:00',2.87),('8348','2013-09-07','11:55:00',2.86),('8348','2013-09-07','12:00:00',2.87),('8348','2013-09-07','12:05:00',2.91),('8348','2013-09-07','12:10:00',2.91),('8348','2013-09-07','12:15:00',2.93),('8348','2013-09-07','12:20:00',2.96),('8348','2013-09-07','12:25:00',2.98),('8348','2013-09-07','12:30:00',3),('8348','2013-09-07','12:35:00',3.03),('8348','2013-09-07','12:40:00',3.03),('8348','2013-09-07','12:45:00',3.06),('8348','2013-09-07','12:50:00',3.07),('8348','2013-09-07','12:55:00',3.1),('8348','2013-09-07','13:00:00',3.1),('8348','2013-09-07','13:05:00',3.08),('8348','2013-09-07','13:10:00',3.1),('8348','2013-09-07','13:15:00',3.12),('8348','2013-09-07','13:20:00',3.1),('8348','2013-09-07','13:25:00',3),('8348','2013-09-07','13:30:00',3.13),('8348','2013-09-07','13:35:00',3.14),('8348','2013-09-07','13:40:00',3.08),('8348','2013-09-07','13:45:00',3.11),('8348','2013-09-07','13:50:00',3.13),('8348','2013-09-07','13:55:00',2.96),('8348','2013-09-07','14:00:00',3.16),('8348','2013-09-07','14:05:00',3.18),('8348','2013-09-07','14:10:00',3.21),('8348','2013-09-07','14:15:00',3.17),('8348','2013-09-07','14:20:00',3.1),('8348','2013-09-07','14:25:00',3.06),('8348','2013-09-07','14:30:00',3.09),('8348','2013-09-07','14:35:00',3.12),('8348','2013-09-07','14:40:00',3.1),('8348','2013-09-07','14:45:00',3.05),('8348','2013-09-07','14:50:00',3.03),('8348','2013-09-07','14:55:00',3.01),('8348','2013-09-07','15:00:00',3),('8348','2013-09-07','15:05:00',2.95),('8348','2013-09-07','15:10:00',2.91),('8348','2013-09-07','15:15:00',2.94),('8348','2013-09-07','15:20:00',2.89),('8348','2013-09-07','15:25:00',2.85),('8348','2013-09-07','15:30:00',2.82),('8348','2013-09-07','15:35:00',2.77),('8348','2013-09-07','15:40:00',2.7),('8348','2013-09-07','15:45:00',2.67),('8348','2013-09-07','15:50:00',2.62),('8348','2013-09-07','15:55:00',2.58),('8348','2013-09-07','16:00:00',2.54),('8348','2013-09-07','16:05:00',2.49),('8348','2013-09-07','16:10:00',2.44),('8348','2013-09-07','16:15:00',2.38),('8348','2013-09-07','16:20:00',2.32),('8348','2013-09-07','16:25:00',2.25),('8348','2013-09-07','16:30:00',2.2),('8348','2013-09-07','16:35:00',2.15),('8348','2013-09-07','16:40:00',2.08),('8348','2013-09-07','16:45:00',2.02),('8348','2013-09-07','16:50:00',1.95),('8348','2013-09-07','16:55:00',1.89),('8348','2013-09-07','17:00:00',1.83),('8348','2013-09-07','17:05:00',1.77),('8348','2013-09-07','17:10:00',1.7),('8348','2013-09-07','17:15:00',1.62),('8348','2013-09-07','17:20:00',1.55),('8348','2013-09-07','17:25:00',1.47),('8348','2013-09-07','17:30:00',1.38),('8348','2013-09-07','17:35:00',1.34),('8348','2013-09-07','17:40:00',1.26),('8348','2013-09-07','17:45:00',1.2),('8348','2013-09-07','17:50:00',1.13),('8348','2013-09-07','17:55:00',1.04),('8348','2013-09-06','08:45:00',1),('8348','2013-09-06','08:50:00',1.06),('8348','2013-09-06','08:55:00',1.13),('8348','2013-09-06','09:00:00',1.21),('8348','2013-09-06','09:05:00',1.3),('8348','2013-09-06','09:10:00',1.36),('8348','2013-09-06','09:15:00',1.45),('8348','2013-09-06','09:20:00',1.51),('8348','2013-09-06','09:25:00',1.57),('8348','2013-09-06','09:30:00',1.63),('8348','2013-09-06','09:35:00',1.7),('8348','2013-09-06','09:40:00',1.77),('8348','2013-09-06','09:45:00',1.83),('8348','2013-09-06','09:50:00',1.87),('8348','2013-09-06','09:55:00',1.93),('8348','2013-09-06','10:00:00',2),('8348','2013-09-06','10:05:00',2.07),('8348','2013-09-06','10:10:00',2.12),('8348','2013-09-06','10:15:00',2.16),('8348','2013-09-06','10:20:00',2.21),('8348','2013-09-06','10:25:00',2.27),('8348','2013-09-06','10:30:00',2.31),('8348','2013-09-06','10:35:00',2.38),('8348','2013-09-06','10:40:00',2.42),('8348','2013-09-06','10:45:00',2.44),('8348','2013-09-06','10:50:00',2.48),('8348','2013-09-06','10:55:00',2.52),('8348','2013-09-06','11:00:00',2.57),('8348','2013-09-06','11:05:00',2.63),('8348','2013-09-06','11:10:00',2.64),('8348','2013-09-06','11:15:00',2.68),('8348','2013-09-06','11:20:00',2.71),('8348','2013-09-06','11:25:00',2.74),('8348','2013-09-06','11:30:00',2.79),('8348','2013-09-06','11:35:00',2.81),('8348','2013-09-06','11:40:00',2.85),('8348','2013-09-06','11:45:00',2.88),('8348','2013-09-06','11:50:00',2.92),('8348','2013-09-06','11:55:00',2.92),('8348','2013-09-06','12:00:00',2.93),('8348','2013-09-06','12:05:00',2.95),('8348','2013-09-06','12:10:00',2.97),('8348','2013-09-06','12:15:00',3),('8348','2013-09-06','12:20:00',3.01),('8348','2013-09-06','12:25:00',3.01),('8348','2013-09-06','12:30:00',3.04),('8348','2013-09-06','12:35:00',3.07),('8348','2013-09-06','12:40:00',3.1),('8348','2013-09-06','12:45:00',3.09),('8348','2013-09-06','12:50:00',3.06),('8348','2013-09-06','12:55:00',3.08),('8348','2013-09-06','13:00:00',3.09),('8348','2013-09-06','13:05:00',3.1),('8348','2013-09-06','13:10:00',3.11),('8348','2013-09-06','13:15:00',3.11),('8348','2013-09-06','13:20:00',3.1),('8348','2013-09-06','13:25:00',3.1),('8348','2013-09-06','13:30:00',3.09),('8348','2013-09-06','13:35:00',3.08),('8348','2013-09-06','13:40:00',3.04),('8348','2013-09-06','13:45:00',3.05),('8348','2013-09-06','13:50:00',3.07),('8348','2013-09-06','13:55:00',3.07),('8348','2013-09-06','14:00:00',3.06),('8348','2013-09-06','14:05:00',3.02),('8348','2013-09-06','14:10:00',3.02),('8348','2013-09-06','14:15:00',3.01),('8348','2013-09-06','14:20:00',3),('8348','2013-09-06','14:25:00',2.97),('8348','2013-09-06','14:30:00',2.96),('8348','2013-09-06','14:35:00',2.86),('8348','2013-09-06','14:40:00',2.89),('8348','2013-09-06','14:45:00',2.93),('8348','2013-09-06','14:50:00',2.96),('8348','2013-09-06','14:55:00',2.97),('8348','2013-09-06','15:00:00',2.97),('8348','2013-09-06','15:05:00',2.91),('8348','2013-09-06','15:10:00',2.86),('8348','2013-09-06','15:15:00',2.88),('8348','2013-09-06','15:20:00',2.84),('8348','2013-09-06','15:25:00',2.81),('8348','2013-09-06','15:30:00',2.75),('8348','2013-09-06','15:35:00',2.72),('8348','2013-09-06','15:40:00',2.68),('8348','2013-09-06','15:45:00',2.67),('8348','2013-09-06','15:50:00',2.62),('8348','2013-09-06','15:55:00',2.59),('8348','2013-09-06','16:00:00',2.54),('8348','2013-09-06','16:05:00',2.47),('8348','2013-09-06','16:10:00',2.42),('8348','2013-09-06','16:15:00',2.37),('8348','2013-09-06','16:20:00',2.33),('8348','2013-09-06','16:25:00',2.29),('8348','2013-09-06','16:30:00',2.25),('8348','2013-09-06','16:35:00',2.18),('8348','2013-09-06','16:40:00',2.12),('8348','2013-09-06','16:45:00',2.06),('8348','2013-09-06','16:50:00',1.97),('8348','2013-09-06','16:55:00',1.9),('8348','2013-09-06','17:00:00',1.86),('8348','2013-09-06','17:05:00',1.77),('8348','2013-09-06','17:10:00',1.71),('8348','2013-09-06','17:15:00',1.67),('8348','2013-09-06','17:20:00',1.57),('8348','2013-09-06','17:25:00',1.48),('8348','2013-09-06','17:30:00',1.38),('8348','2013-09-06','17:35:00',1.32),('8348','2013-09-06','17:40:00',1.27),('8348','2013-09-06','17:45:00',1.18),('8348','2013-09-06','17:50:00',1.07),('8348','2013-09-06','17:55:00',1),('8348','2013-09-05','08:45:00',1.06),('8348','2013-09-05','08:50:00',1.13),('8348','2013-09-05','08:55:00',1.18),('8348','2013-09-05','09:00:00',1.29),('8348','2013-09-05','09:05:00',1.38),('8348','2013-09-05','09:10:00',1.45),('8348','2013-09-05','09:15:00',1.54),('8348','2013-09-05','09:20:00',1.62),('8348','2013-09-05','09:25:00',1.68),('8348','2013-09-05','09:30:00',1.75),('8348','2013-09-05','09:35:00',1.8),('8348','2013-09-05','09:40:00',1.86),('8348','2013-09-05','09:45:00',1.93),('8348','2013-09-05','09:50:00',2),('8348','2013-09-05','09:55:00',2.06),('8348','2013-09-05','10:00:00',2.11),('8348','2013-09-05','10:05:00',2.17),('8348','2013-09-05','10:10:00',2.22),('8348','2013-09-05','10:15:00',2.27),('8348','2013-09-05','10:20:00',2.32),('8348','2013-09-05','10:25:00',2.37),('8348','2013-09-05','10:30:00',2.41),('8348','2013-09-05','10:35:00',2.45),('8348','2013-09-05','10:40:00',2.51),('8348','2013-09-05','10:45:00',2.54),('8348','2013-09-05','10:50:00',2.59),('8348','2013-09-05','10:55:00',2.64),('8348','2013-09-05','11:00:00',2.69),('8348','2013-09-05','11:05:00',2.74),('8348','2013-09-05','11:10:00',2.76),('8348','2013-09-05','11:15:00',2.78),('8348','2013-09-05','11:20:00',2.82),('8348','2013-09-05','11:25:00',2.81),('8348','2013-09-05','11:30:00',2.86),('8348','2013-09-05','11:35:00',2.91),('8348','2013-09-05','11:40:00',2.88),('8348','2013-09-05','11:45:00',2.89),('8348','2013-09-05','11:50:00',2.96),('8348','2013-09-05','11:55:00',3.01),('8348','2013-09-05','12:00:00',3.03),('8348','2013-09-05','12:05:00',3.04),('8348','2013-09-05','12:10:00',3.05),('8348','2013-09-05','12:15:00',3.08),('8348','2013-09-05','12:20:00',3.09),('8348','2013-09-05','12:25:00',3.11),('8348','2013-09-05','12:30:00',3.15),('8348','2013-09-05','12:35:00',3.15),('8348','2013-09-05','12:40:00',3.14),('8348','2013-09-05','12:45:00',3.16),('8348','2013-09-05','12:50:00',3.2),('8348','2013-09-05','12:55:00',3.21),('8348','2013-09-05','13:00:00',3.19),('8348','2013-09-05','13:05:00',3.18),('8348','2013-09-05','13:10:00',3.2),('8348','2013-09-05','13:15:00',3.2),('8348','2013-09-05','13:20:00',3.2),('8348','2013-09-05','13:25:00',3.22),('8348','2013-09-05','13:30:00',3.27),('8348','2013-09-05','13:35:00',3.25),('8348','2013-09-05','13:40:00',3.2),('8348','2013-09-05','13:45:00',3.19),('8348','2013-09-05','13:50:00',3.16),('8348','2013-09-05','13:55:00',3.14),('8348','2013-09-05','14:00:00',3.17),('8348','2013-09-05','14:05:00',3.17),('8348','2013-09-05','14:10:00',3.18),('8348','2013-09-05','14:15:00',3.2),('8348','2013-09-05','14:20:00',3.16),('8348','2013-09-05','14:25:00',3.1),('8348','2013-09-05','14:30:00',3.1),('8348','2013-09-05','14:35:00',3.06),('8348','2013-09-05','14:40:00',3.03),('8348','2013-09-05','14:45:00',3.04),('8348','2013-09-05','14:50:00',3.03),('8348','2013-09-05','14:55:00',3.05),('8348','2013-09-05','15:00:00',3.06),('8348','2013-09-05','15:05:00',3.05),('8348','2013-09-05','15:10:00',3.01),('8348','2013-09-05','15:15:00',2.98),('8348','2013-09-05','15:20:00',2.96),('8348','2013-09-05','15:25:00',2.92),('8348','2013-09-05','15:30:00',2.87),('8348','2013-09-05','15:35:00',2.84),('8348','2013-09-05','15:40:00',2.79),('8348','2013-09-05','15:45:00',2.73),('8348','2013-09-05','15:50:00',2.69),('8348','2013-09-05','15:55:00',2.69),('8348','2013-09-05','16:00:00',2.65),('8348','2013-09-05','16:05:00',2.61),('8348','2013-09-05','16:10:00',2.57),('8348','2013-09-05','16:15:00',2.52),('8348','2013-09-05','16:20:00',2.46),('8348','2013-09-05','16:25:00',2.41),('8348','2013-09-05','16:30:00',2.37),('8348','2013-09-05','16:35:00',2.35),('8348','2013-09-05','16:40:00',2.31),('8348','2013-09-05','16:45:00',2.28),('8348','2013-09-05','16:50:00',1.99),('8348','2013-09-05','16:55:00',1.61),('8348','2013-09-05','17:00:00',1.24),('8348','2013-09-05','17:05:00',1.33),('8348','2013-09-05','17:10:00',1.38),('8348','2013-09-05','17:15:00',1.19),('8348','2013-09-05','17:20:00',1.35),('8348','2013-09-05','17:25:00',1.37),('8348','2013-09-05','17:30:00',1.33),('8348','2013-09-05','17:35:00',1.4),('8348','2013-09-05','17:40:00',1.54),('8348','2013-09-05','17:45:00',1.41),('8348','2013-09-05','17:50:00',1.28),('8348','2013-09-05','17:55:00',1.08),('8348','2013-09-04','08:45:00',1.06),('8348','2013-09-04','08:50:00',1.11),('8348','2013-09-04','08:55:00',1.2),('8348','2013-09-04','09:00:00',1.3),('8348','2013-09-04','09:05:00',1.38),('8348','2013-09-04','09:10:00',1.46),('8348','2013-09-04','09:15:00',1.57),('8348','2013-09-04','09:20:00',1.65),('8348','2013-09-04','09:25:00',1.73),('8348','2013-09-04','09:30:00',1.8),('8348','2013-09-04','09:35:00',1.87),('8348','2013-09-04','09:40:00',1.94),('8348','2013-09-04','09:45:00',2),('8348','2013-09-04','09:50:00',2.07),('8348','2013-09-04','09:55:00',2.13),('8348','2013-09-04','10:00:00',2.19),('8348','2013-09-04','10:05:00',2.25),('8348','2013-09-04','10:10:00',2.31),('8348','2013-09-04','10:15:00',2.36),('8348','2013-09-04','10:20:00',2.39),('8348','2013-09-04','10:25:00',2.44),('8348','2013-09-04','10:30:00',2.49),('8348','2013-09-04','10:35:00',2.55),('8348','2013-09-04','10:40:00',2.6),('8348','2013-09-04','10:45:00',2.65),('8348','2013-09-04','10:50:00',2.7),('8348','2013-09-04','10:55:00',2.75),('8348','2013-09-04','11:00:00',2.79),('8348','2013-09-04','11:05:00',2.84),('8348','2013-09-04','11:10:00',2.87),('8348','2013-09-04','11:15:00',2.9),('8348','2013-09-04','11:20:00',2.93),('8348','2013-09-04','11:25:00',2.96),('8348','2013-09-04','11:30:00',3),('8348','2013-09-04','11:35:00',3.03),('8348','2013-09-04','11:40:00',3.07),('8348','2013-09-04','11:45:00',3.09),('8348','2013-09-04','11:50:00',3.12),('8348','2013-09-04','11:55:00',3.16),('8348','2013-09-04','12:00:00',3.19),('8348','2013-09-04','12:05:00',3.2),('8348','2013-09-04','12:10:00',3.22),('8348','2013-09-04','12:15:00',3.22),('8348','2013-09-04','12:20:00',3.24),('8348','2013-09-04','12:25:00',3.28),('8348','2013-09-04','12:30:00',3.29),('8348','2013-09-04','12:35:00',3.32),('8348','2013-09-04','12:40:00',3.31),('8348','2013-09-04','12:45:00',3.32),('8348','2013-09-04','12:50:00',3.33),('8348','2013-09-04','12:55:00',3.33),('8348','2013-09-04','13:00:00',3.33),('8348','2013-09-04','13:05:00',3.33),('8348','2013-09-04','13:10:00',3.35),('8348','2013-09-04','13:15:00',3.35),('8348','2013-09-04','13:20:00',3.35),('8348','2013-09-04','13:25:00',3.36),('8348','2013-09-04','13:30:00',3.36),('8348','2013-09-04','13:35:00',3.37),('8348','2013-09-04','13:40:00',3.38),('8348','2013-09-04','13:45:00',3.35),('8348','2013-09-04','13:50:00',3.34),('8348','2013-09-04','13:55:00',3.33),('8348','2013-09-04','14:00:00',3.31),('8348','2013-09-04','14:05:00',3.32),('8348','2013-09-04','14:10:00',3.31),('8348','2013-09-04','14:15:00',3.3),('8348','2013-09-04','14:20:00',3.27),('8348','2013-09-04','14:25:00',3.27),('8348','2013-09-04','14:30:00',3.26),('8348','2013-09-04','14:35:00',3.23),('8348','2013-09-04','14:40:00',3.2),('8348','2013-09-04','14:45:00',3.18),('8348','2013-09-04','14:50:00',3.16),('8348','2013-09-04','14:55:00',3.13),('8348','2013-09-04','15:00:00',3.09),('8348','2013-09-04','15:05:00',3.06),('8348','2013-09-04','15:10:00',3.04),('8348','2013-09-04','15:15:00',3.02),('8348','2013-09-04','15:20:00',3),('8348','2013-09-04','15:25:00',2.95),('8348','2013-09-04','15:30:00',2.93),('8348','2013-09-04','15:35:00',2.89),('8348','2013-09-04','15:40:00',2.84),('8348','2013-09-04','15:45:00',2.79),('8348','2013-09-04','15:50:00',2.76),('8348','2013-09-04','15:55:00',2.7),('8348','2013-09-04','16:00:00',2.65),('8348','2013-09-04','16:05:00',2.6),('8348','2013-09-04','16:10:00',2.56),('8348','2013-09-04','16:15:00',2.51),('8348','2013-09-04','16:20:00',2.46),('8348','2013-09-04','16:25:00',2.39),('8348','2013-09-04','16:30:00',2.35),('8348','2013-09-04','16:35:00',2.31),('8348','2013-09-04','16:40:00',2.24),('8348','2013-09-04','16:45:00',2.18),('8348','2013-09-04','16:50:00',2.11),('8348','2013-09-04','16:55:00',2.06),('8348','2013-09-04','17:00:00',1.99),('8348','2013-09-04','17:05:00',1.92),('8348','2013-09-04','17:10:00',1.85),('8348','2013-09-04','17:15:00',1.79),('8348','2013-09-04','17:20:00',1.72),('8348','2013-09-04','17:25:00',1.65),('8348','2013-09-04','17:30:00',1.58),('8348','2013-09-04','17:35:00',1.5),('8348','2013-09-04','17:40:00',1.42),('8348','2013-09-04','17:45:00',1.34),('8348','2013-09-04','17:50:00',1.26),('8348','2013-09-04','17:55:00',1.18),('8348','2013-09-04','18:00:00',1.09),('8348','2013-09-04','18:05:00',1.01),('8348','2013-09-03','08:45:00',1),('8348','2013-09-03','08:50:00',1.07),('8348','2013-09-03','08:55:00',1.15),('8348','2013-09-03','09:00:00',1.23),('8348','2013-09-03','09:05:00',1.3),('8348','2013-09-03','09:10:00',1.37),('8348','2013-09-03','09:15:00',1.47),('8348','2013-09-03','09:20:00',1.55),('8348','2013-09-03','09:25:00',1.63),('8348','2013-09-03','09:30:00',1.7),('8348','2013-09-03','09:35:00',1.75),('8348','2013-09-03','09:40:00',1.82),('8348','2013-09-03','09:45:00',1.88),('8348','2013-09-03','09:50:00',1.94),('8348','2013-09-03','09:55:00',2),('8348','2013-09-03','10:00:00',2.05),('8348','2013-09-03','10:05:00',2.1),('8348','2013-09-03','10:10:00',2.16),('8348','2013-09-03','10:15:00',2.22),('8348','2013-09-03','10:20:00',2.29),('8348','2013-09-03','10:25:00',2.33),('8348','2013-09-03','10:30:00',2.39),('8348','2013-09-03','10:35:00',2.47),('8348','2013-09-03','10:40:00',2.55),('8348','2013-09-03','10:45:00',2.58),('8348','2013-09-03','10:50:00',2.61),('8348','2013-09-03','10:55:00',2.63),('8348','2013-09-03','11:00:00',2.65),('8348','2013-09-03','11:05:00',2.69),('8348','2013-09-03','11:10:00',2.74),('8348','2013-09-03','11:15:00',2.79),('8348','2013-09-03','11:20:00',2.82),('8348','2013-09-03','11:25:00',2.85),('8348','2013-09-03','11:30:00',2.88),('8348','2013-09-03','11:35:00',2.9),('8348','2013-09-03','11:40:00',2.92),('8348','2013-09-03','11:45:00',2.96),('8348','2013-09-03','11:50:00',2.99),('8348','2013-09-03','11:55:00',3.04),('8348','2013-09-03','12:00:00',3.06),('8348','2013-09-03','12:05:00',3.08),('8348','2013-09-03','12:10:00',3.11),('8348','2013-09-03','12:15:00',3.14),('8348','2013-09-03','12:20:00',3.17),('8348','2013-09-03','12:25:00',3.19),('8348','2013-09-03','12:30:00',3.21),('8348','2013-09-03','12:35:00',3.21),('8348','2013-09-03','12:40:00',3.24),('8348','2013-09-03','12:45:00',3.25),('8348','2013-09-03','12:50:00',3.25),('8348','2013-09-03','12:55:00',3.25),('8348','2013-09-03','13:00:00',3.26),('8348','2013-09-03','13:05:00',3.26),('8348','2013-09-03','13:10:00',3.28),('8348','2013-09-03','13:15:00',3.29),('8348','2013-09-03','13:20:00',3.26),('8348','2013-09-03','13:25:00',3.25),('8348','2013-09-03','13:30:00',3.26),('8348','2013-09-03','13:35:00',3.28),('8348','2013-09-03','13:40:00',3.25),('8348','2013-09-03','13:45:00',3.24),('8348','2013-09-03','13:50:00',3.26),('8348','2013-09-03','13:55:00',3.25),('8348','2013-09-03','14:00:00',3.18),('8348','2013-09-03','14:05:00',3.15),('8348','2013-09-03','14:10:00',3.17),('8348','2013-09-03','14:15:00',3.15),('8348','2013-09-03','14:20:00',3.14),('8348','2013-09-03','14:25:00',3.13),('8348','2013-09-03','14:30:00',3.14),('8348','2013-09-03','14:35:00',3.16),('8348','2013-09-03','14:40:00',3.13),('8348','2013-09-03','14:45:00',3.1),('8348','2013-09-03','14:50:00',3.12),('8348','2013-09-03','14:55:00',3.09),('8348','2013-09-03','15:00:00',3.04),('8348','2013-09-03','15:05:00',2.99),('8348','2013-09-03','15:10:00',2.96),('8348','2013-09-03','15:15:00',2.96),('8348','2013-09-03','15:20:00',2.93),('8348','2013-09-03','15:25:00',2.89),('8348','2013-09-03','15:30:00',2.85),('8348','2013-09-03','15:35:00',2.79),('8348','2013-09-03','15:40:00',2.73),('8348','2013-09-03','15:45:00',2.69),('8348','2013-09-03','15:50:00',2.69),('8348','2013-09-03','15:55:00',2.64),('8348','2013-09-03','16:00:00',2.62),('8348','2013-09-03','16:05:00',2.59),('8348','2013-09-03','16:10:00',2.53),('8348','2013-09-03','16:15:00',2.46),('8348','2013-09-03','16:20:00',2.41),('8348','2013-09-03','16:25:00',2.37),('8348','2013-09-03','16:30:00',2.32),('8348','2013-09-03','16:35:00',2.27),('8348','2013-09-03','16:40:00',2.21),('8348','2013-09-03','16:45:00',2.16),('8348','2013-09-03','16:50:00',2.1),('8348','2013-09-03','16:55:00',2.05),('8348','2013-09-03','17:00:00',1.98),('8348','2013-09-03','17:05:00',1.91),('8348','2013-09-03','17:10:00',1.85),('8348','2013-09-03','17:15:00',1.78),('8348','2013-09-03','17:20:00',1.73),('8348','2013-09-03','17:25:00',1.66),('8348','2013-09-03','17:30:00',1.6),('8348','2013-09-03','17:35:00',1.52),('8348','2013-09-03','17:40:00',1.44),('8348','2013-09-03','17:45:00',1.38),('8348','2013-09-03','17:50:00',1.3),('8348','2013-09-03','17:55:00',1.19),('8348','2013-09-03','18:00:00',1.02),('8348','2013-09-02','08:45:00',1.05),('8348','2013-09-02','08:50:00',1.12),('8348','2013-09-02','08:55:00',1.18),('8348','2013-09-02','09:00:00',1.28),('8348','2013-09-02','09:05:00',1.36),('8348','2013-09-02','09:10:00',1.43),('8348','2013-09-02','09:15:00',1.53),('8348','2013-09-02','09:20:00',1.6),('8348','2013-09-02','09:25:00',1.67),('8348','2013-09-02','09:30:00',1.74),('8348','2013-09-02','09:35:00',1.81),('8348','2013-09-02','09:40:00',1.87),('8348','2013-09-02','09:45:00',1.93),('8348','2013-09-02','09:50:00',1.99),('8348','2013-09-02','09:55:00',2.04),('8348','2013-09-02','10:00:00',2.09),('8348','2013-09-02','10:05:00',2.15),('8348','2013-09-02','10:10:00',2.22),('8348','2013-09-02','10:15:00',2.28),('8348','2013-09-02','10:20:00',2.33),('8348','2013-09-02','10:25:00',2.38),('8348','2013-09-02','10:30:00',2.43),('8348','2013-09-02','10:35:00',2.48),('8348','2013-09-02','10:40:00',2.53),('8348','2013-09-02','10:45:00',2.57),('8348','2013-09-02','10:50:00',2.6),('8348','2013-09-02','10:55:00',2.63),('8348','2013-09-02','11:00:00',2.68),('8348','2013-09-02','11:05:00',2.72),('8348','2013-09-02','11:10:00',2.75),('8348','2013-09-02','11:15:00',2.79),('8348','2013-09-02','11:20:00',2.83),('8348','2013-09-02','11:25:00',2.87),('8348','2013-09-02','11:30:00',2.88),('8348','2013-09-02','11:35:00',2.91),('8348','2013-09-02','11:40:00',2.93),('8348','2013-09-02','11:45:00',2.94),('8348','2013-09-02','11:50:00',2.97),('8348','2013-09-02','11:55:00',2.99),('8348','2013-09-02','12:00:00',3.02),('8348','2013-09-02','12:05:00',3.05),('8348','2013-09-02','12:10:00',3.09),('8348','2013-09-02','12:15:00',3.1),('8348','2013-09-02','12:20:00',3.12),('8348','2013-09-02','12:25:00',3.14),('8348','2013-09-02','12:30:00',3.11),('8348','2013-09-02','12:35:00',3.15),('8348','2013-09-02','12:40:00',3.14),('8348','2013-09-02','12:45:00',3.17),('8348','2013-09-02','12:50:00',3.19),('8348','2013-09-02','12:55:00',3.2),('8348','2013-09-02','13:00:00',3.23),('8348','2013-09-02','13:05:00',3.24),('8348','2013-09-02','13:10:00',3.24),('8348','2013-09-02','13:15:00',3.23),('8348','2013-09-02','13:20:00',3.2),('8348','2013-09-02','13:25:00',3.21),('8348','2013-09-02','13:30:00',3.17),('8348','2013-09-02','13:35:00',3.19),('8348','2013-09-02','13:40:00',3.18),('8348','2013-09-02','13:45:00',1.34),('8348','2013-09-02','13:50:00',2.17),('8348','2013-09-02','13:55:00',1.37),('8348','2013-09-02','14:00:00',3.2),('8348','2013-09-02','14:05:00',3.36),('8348','2013-09-02','14:10:00',3.28),('8348','2013-09-02','14:15:00',3.23),('8348','2013-09-02','14:20:00',3.22),('8348','2013-09-02','14:25:00',3.22),('8348','2013-09-02','14:30:00',3.14),('8348','2013-09-02','14:35:00',3.11),('8348','2013-09-02','14:40:00',3.14),('8348','2013-09-02','14:45:00',3.21),('8348','2013-09-02','14:50:00',1.91),('8348','2013-09-02','15:00:00',1.28),('8348','2013-09-02','15:05:00',3.12),('8348','2013-09-02','15:10:00',2.94),('8348','2013-09-02','15:15:00',2.39),('8348','2013-09-02','15:25:00',2.1),('8348','2013-09-02','15:30:00',2.8),('8348','2013-09-02','15:35:00',2.1),('8348','2013-09-02','15:40:00',2.42),('8348','2013-09-02','15:45:00',2.8),('8348','2013-09-02','15:50:00',2.85),('8348','2013-09-02','15:55:00',2.75),('8348','2013-09-02','16:00:00',2.7),('8348','2013-09-02','16:05:00',2.62),('8348','2013-09-02','16:10:00',2.59),('8348','2013-09-02','16:15:00',2.57),('8348','2013-09-02','16:20:00',2.53),('8348','2013-09-02','16:25:00',2.45),('8348','2013-09-02','16:30:00',2.38),('8348','2013-09-02','16:35:00',2.33),('8348','2013-09-02','16:40:00',2.24),('8348','2013-09-02','16:45:00',2.17),('8348','2013-09-02','16:50:00',2.1),('8348','2013-09-02','16:55:00',1.99),('8348','2013-09-02','17:00:00',1.92),('8348','2013-09-02','17:05:00',1.86),('8348','2013-09-02','17:10:00',1.79),('8348','2013-09-02','17:15:00',1.74),('8348','2013-09-02','17:20:00',1.67),('8348','2013-09-02','17:25:00',1.61),('8348','2013-09-02','17:30:00',1.53),('8348','2013-09-02','17:35:00',1.45),('8348','2013-09-02','17:40:00',1.38),('8348','2013-09-02','17:45:00',1.32),('8348','2013-09-02','17:50:00',1.24),('8348','2013-09-02','17:55:00',1.18),('8348','2013-09-02','18:00:00',1.11),('8348','2013-09-02','18:05:00',1.03),('8348','2013-09-01','08:40:00',1.01),('8348','2013-09-01','08:45:00',1.09),('8348','2013-09-01','08:50:00',1.13),('8348','2013-09-01','08:55:00',1.25),('8348','2013-09-01','09:00:00',1.32),('8348','2013-09-01','09:05:00',1.39),('8348','2013-09-01','09:10:00',1.49),('8348','2013-09-01','09:15:00',1.57),('8348','2013-09-01','09:20:00',1.64),('8348','2013-09-01','09:25:00',1.7),('8348','2013-09-01','09:30:00',1.78),('8348','2013-09-01','09:35:00',1.85),('8348','2013-09-01','09:40:00',1.91),('8348','2013-09-01','09:45:00',1.97),('8348','2013-09-01','09:50:00',2.03),('8348','2013-09-01','09:55:00',2.08),('8348','2013-09-01','10:00:00',2.14),('8348','2013-09-01','10:05:00',2.18),('8348','2013-09-01','10:10:00',2.25),('8348','2013-09-01','10:15:00',2.29),('8348','2013-09-01','10:20:00',2.33),('8348','2013-09-01','10:25:00',2.39),('8348','2013-09-01','10:30:00',2.43),('8348','2013-09-01','10:35:00',2.48),('8348','2013-09-01','10:40:00',2.52),('8348','2013-09-01','10:45:00',2.58),('8348','2013-09-01','10:50:00',2.61),('8348','2013-09-01','10:55:00',2.67),('8348','2013-09-01','11:00:00',2.72),('8348','2013-09-01','11:05:00',2.76),('8348','2013-09-01','11:10:00',2.79),('8348','2013-09-01','11:15:00',2.81),('8348','2013-09-01','11:20:00',2.82),('8348','2013-09-01','11:25:00',2.86),('8348','2013-09-01','11:30:00',2.88),('8348','2013-09-01','11:35:00',2.91),('8348','2013-09-01','11:40:00',2.98),('8348','2013-09-01','11:45:00',3.02),('8348','2013-09-01','11:50:00',3.02),('8348','2013-09-01','11:55:00',3.05),('8348','2013-09-01','12:00:00',3.07),('8348','2013-09-01','12:05:00',3.05),('8348','2013-09-01','12:10:00',3.09),('8348','2013-09-01','12:15:00',3.11),('8348','2013-09-01','12:20:00',3.15),('8348','2013-09-01','12:25:00',3.1),('8348','2013-09-01','12:30:00',3.19),('8348','2013-09-01','12:35:00',3.17),('8348','2013-09-01','12:40:00',3.19),('8348','2013-09-01','12:45:00',3.19),('8348','2013-09-01','12:50:00',3.21),('8348','2013-09-01','12:55:00',3.22),('8348','2013-09-01','13:00:00',3.29),('8348','2013-09-01','13:05:00',3.22),('8348','2013-09-01','13:10:00',3.23),('8348','2013-09-01','13:15:00',3.19),('8348','2013-09-01','13:20:00',3.28),('8348','2013-09-01','13:25:00',3.3),('8348','2013-09-01','13:30:00',3.37),('8348','2013-09-01','13:35:00',3.31),('8348','2013-09-01','13:40:00',3.33),('8348','2013-09-01','13:45:00',3.19),('8348','2013-09-01','13:50:00',2.75),('8348','2013-09-01','13:55:00',2.95),('8348','2013-09-01','14:00:00',2.6),('8348','2013-09-01','14:05:00',2.67),('8348','2013-09-01','14:10:00',2.97),('8348','2013-09-01','14:15:00',2.93),('8348','2013-09-01','14:20:00',2.7),('8348','2013-09-01','14:25:00',2.78),('8348','2013-09-01','14:35:00',2.79),('8348','2013-09-01','14:40:00',2.8),('8348','2013-09-01','14:45:00',2.86),('8348','2013-09-01','14:50:00',2.86),('8348','2013-09-01','14:55:00',2.73),('8348','2013-09-01','15:00:00',2.77),('8348','2013-09-01','15:05:00',2.71),('8348','2013-09-01','15:10:00',2.74),('8348','2013-09-01','15:15:00',2.72),('8348','2013-09-01','15:20:00',2.62),('8348','2013-09-01','15:25:00',2.3),('8348','2013-09-01','15:30:00',1.99),('8348','2013-09-01','15:35:00',2.14),('8348','2013-09-01','15:40:00',2.48),('8348','2013-09-01','15:45:00',2.29),('8348','2013-09-01','15:50:00',1.78),('8348','2013-09-01','15:55:00',1.87),('8348','2013-09-01','16:00:00',2.33),('8348','2013-09-01','16:05:00',2.48),('8348','2013-09-01','16:10:00',2.52),('8348','2013-09-01','16:15:00',2.44),('8348','2013-09-01','16:20:00',2.29),('8348','2013-09-01','16:25:00',2.34),('8348','2013-09-01','16:30:00',2.49),('8348','2013-09-01','16:35:00',2.38),('8348','2013-09-01','16:40:00',2.33),('8348','2013-09-01','16:45:00',2.12),('8348','2013-09-01','16:50:00',2.06),('8348','2013-09-01','16:55:00',1.87),('8348','2013-09-01','17:00:00',1.54),('8348','2013-09-01','17:05:00',1.59),('8348','2013-09-01','17:10:00',1.28),('8348','2013-09-01','17:15:00',1.37),('8348','2013-09-01','17:20:00',1.47),('8348','2013-09-01','17:25:00',1.42),('8348','2013-09-01','17:30:00',1.24),('8348','2013-09-01','17:35:00',1.27),('8348','2013-09-01','17:40:00',1.33),('8348','2013-09-01','17:45:00',1.11),('8348','2013-09-01','17:50:00',1.01),('8348','2013-09-01','18:10:00',1.03),('8348','2013-08-31','08:40:00',1.06),('8348','2013-08-31','08:45:00',1.15),('8348','2013-08-31','08:50:00',1.25),('8348','2013-08-31','08:55:00',1.45),('8348','2013-08-31','09:00:00',1.52),('8348','2013-08-31','09:05:00',1.4),('8348','2013-08-31','09:10:00',1.17),('8348','2013-08-31','09:15:00',1.46),('8348','2013-08-31','09:20:00',1.66),('8348','2013-08-31','09:25:00',1.82),('8348','2013-08-31','09:30:00',1.88),('8348','2013-08-31','09:35:00',1.98),('8348','2013-08-31','09:40:00',2.02),('8348','2013-08-31','09:45:00',1.9),('8348','2013-08-31','09:50:00',1.96),('8348','2013-08-31','09:55:00',2.12),('8348','2013-08-31','10:00:00',2.26),('8348','2013-08-31','10:05:00',2.25),('8348','2013-08-31','10:10:00',2.37),('8348','2013-08-31','10:15:00',2.38),('8348','2013-08-31','10:20:00',2.44),('8348','2013-08-31','10:25:00',2.48),('8348','2013-08-31','10:30:00',2.55),('8348','2013-08-31','10:35:00',2.61),('8348','2013-08-31','10:40:00',2.63),('8348','2013-08-31','10:45:00',2.69),('8348','2013-08-31','10:50:00',2.77),('8348','2013-08-31','10:55:00',2.81),('8348','2013-08-31','11:00:00',2.86),('8348','2013-08-31','11:05:00',2.9),('8348','2013-08-31','11:10:00',2.92),('8348','2013-08-31','11:15:00',2.97),('8348','2013-08-31','11:20:00',3),('8348','2013-08-31','11:25:00',3.03),('8348','2013-08-31','11:30:00',3.07),('8348','2013-08-31','11:35:00',3.11),('8348','2013-08-31','11:40:00',3.16),('8348','2013-08-31','11:45:00',3.18),('8348','2013-08-31','11:50:00',3.2),('8348','2013-08-31','11:55:00',3.23),('8348','2013-08-31','12:00:00',3.22),('8348','2013-08-31','12:05:00',3.07),('8348','2013-08-31','12:10:00',3.1),('8348','2013-08-31','12:15:00',3.22),('8348','2013-08-31','12:20:00',3.24),('8348','2013-08-31','12:25:00',3.26),('8348','2013-08-31','12:30:00',3.24),('8348','2013-08-31','12:35:00',3.3),('8348','2013-08-31','12:40:00',3.31),('8348','2013-08-31','12:45:00',3.28),('8348','2013-08-31','12:50:00',3.28),('8348','2013-08-31','12:55:00',3.32),('8348','2013-08-31','13:00:00',3.34),('8348','2013-08-31','13:05:00',3.35),('8348','2013-08-31','13:10:00',3.34),('8348','2013-08-31','13:15:00',3.35),('8348','2013-08-31','13:20:00',3.3),('8348','2013-08-31','13:25:00',3.3),('8348','2013-08-31','13:30:00',3.36),('8348','2013-08-31','13:35:00',3.33),('8348','2013-08-31','13:40:00',3.31),('8348','2013-08-31','13:45:00',3.28),('8348','2013-08-31','13:50:00',3.32),('8348','2013-08-31','13:55:00',3.28),('8348','2013-08-31','14:00:00',3.28),('8348','2013-08-31','14:05:00',3.26),('8348','2013-08-31','14:10:00',3.24),('8348','2013-08-31','14:15:00',3.24),('8348','2013-08-31','14:20:00',3.21),('8348','2013-08-31','14:25:00',3.17),('8348','2013-08-31','14:30:00',3.18),('8348','2013-08-31','14:35:00',3.04),('8348','2013-08-31','14:40:00',3.07),('8348','2013-08-31','14:45:00',3.06),('8348','2013-08-31','14:50:00',3.06),('8348','2013-08-31','14:55:00',2.98),('8348','2013-08-31','15:00:00',2.96),('8348','2013-08-31','15:05:00',2.98),('8348','2013-08-31','15:10:00',2.95),('8348','2013-08-31','15:15:00',2.92),('8348','2013-08-31','15:20:00',2.88),('8348','2013-08-31','15:25:00',2.84),('8348','2013-08-31','15:30:00',2.86),('8348','2013-08-31','15:35:00',2.76),('8348','2013-08-31','15:40:00',2.74),('8348','2013-08-31','15:45:00',2.71),('8348','2013-08-31','15:50:00',2.67),('8348','2013-08-31','15:55:00',2.63),('8348','2013-08-31','16:00:00',2.61),('8348','2013-08-31','16:05:00',2.58),('8348','2013-08-31','16:10:00',2.53),('8348','2013-08-31','16:15:00',2.48),('8348','2013-08-31','16:20:00',2.43),('8348','2013-08-31','16:25:00',2.37),('8348','2013-08-31','16:30:00',2.3),('8348','2013-08-31','16:35:00',2.3),('8348','2013-08-31','16:40:00',2.21),('8348','2013-08-31','16:45:00',2.11),('8348','2013-08-31','16:50:00',2.05),('8348','2013-08-31','16:55:00',2.02),('8348','2013-08-31','17:00:00',1.93),('8348','2013-08-31','17:05:00',1.94),('8348','2013-08-31','17:10:00',1.88),('8348','2013-08-31','17:15:00',1.78),('8348','2013-08-31','17:20:00',1.73),('8348','2013-08-31','17:25:00',1.67),('8348','2013-08-31','17:30:00',1.58),('8348','2013-08-31','17:35:00',1.46),('8348','2013-08-31','17:40:00',1.44),('8348','2013-08-31','17:45:00',1.32),('8348','2013-08-31','17:50:00',1.29),('8348','2013-08-31','17:55:00',1.14),('8348','2013-08-30','08:25:00',1.01),('8348','2013-08-30','08:30:00',1.06),('8348','2013-08-30','08:35:00',1.14),('8348','2013-08-30','08:40:00',1.18),('8348','2013-08-30','08:45:00',1.08),('8348','2013-08-30','08:50:00',1.01),('8348','2013-08-30','08:55:00',1.03),('8348','2013-08-30','09:00:00',1.19),('8348','2013-08-30','09:05:00',1.3),('8348','2013-08-30','09:10:00',1.17),('8348','2013-08-30','09:15:00',1.09),('8348','2013-08-30','09:25:00',1.05),('8348','2013-08-30','09:30:00',1.35),('8348','2013-08-30','09:35:00',1.46),('8348','2013-08-30','09:40:00',1.44),('8348','2013-08-30','09:45:00',1.47),('8348','2013-08-30','09:50:00',1.49),('8348','2013-08-30','09:55:00',1.57),('8348','2013-08-30','10:00:00',1.61),('8348','2013-08-30','10:05:00',1.6),('8348','2013-08-30','10:10:00',1.63),('8348','2013-08-30','10:15:00',1.74),('8348','2013-08-30','10:20:00',1.78),('8348','2013-08-30','10:25:00',1.67),('8348','2013-08-30','10:30:00',1.86),('8348','2013-08-30','10:35:00',1.79),('8348','2013-08-30','10:40:00',1.71),('8348','2013-08-30','10:45:00',1.66),('8348','2013-08-30','10:50:00',1.77),('8348','2013-08-30','10:55:00',1.69),('8348','2013-08-30','11:00:00',1.76),('8348','2013-08-30','11:05:00',1.87),('8348','2013-08-30','11:10:00',1.97),('8348','2013-08-30','11:15:00',1.98),('8348','2013-08-30','11:20:00',2),('8348','2013-08-30','11:25:00',2.06),('8348','2013-08-30','11:30:00',2.18),('8348','2013-08-30','11:35:00',2.06),('8348','2013-08-30','11:40:00',2.25),('8348','2013-08-30','11:45:00',2.2),('8348','2013-08-30','11:50:00',2.54),('8348','2013-08-30','11:55:00',2.22),('8348','2013-08-30','12:00:00',2.02),('8348','2013-08-30','12:05:00',1.76),('8348','2013-08-30','12:10:00',1.94),('8348','2013-08-30','12:15:00',2.1),('8348','2013-08-30','12:20:00',2.24),('8348','2013-08-30','12:25:00',2.55),('8348','2013-08-30','12:30:00',2.78),('8348','2013-08-30','12:35:00',2.65),('8348','2013-08-30','12:40:00',2.59),('8348','2013-08-30','12:45:00',2.68),('8348','2013-08-30','12:50:00',2.61),('8348','2013-08-30','12:55:00',2.45),('8348','2013-08-30','13:00:00',2.44),('8348','2013-08-30','13:05:00',2.41),('8348','2013-08-30','13:10:00',2.42),('8348','2013-08-30','13:15:00',2.47),('8348','2013-08-30','13:20:00',2.7),('8348','2013-08-30','13:25:00',3.16),('8348','2013-08-30','13:30:00',3.39),('8348','2013-08-30','13:35:00',3.13),('8348','2013-08-30','13:40:00',3.33),('8348','2013-08-30','13:45:00',3.02),('8348','2013-08-30','13:50:00',3.03),('8348','2013-08-30','13:55:00',3.28),('8348','2013-08-30','14:00:00',3.39),('8348','2013-08-30','14:05:00',3.26),('8348','2013-08-30','14:10:00',3.25),('8348','2013-08-30','14:15:00',3.23),('8348','2013-08-30','14:20:00',3.33),('8348','2013-08-30','14:25:00',3.29),('8348','2013-08-30','14:30:00',3.27),('8348','2013-08-30','14:35:00',3.3),('8348','2013-08-30','14:40:00',3.13),('8348','2013-08-30','14:45:00',2.62),('8348','2013-08-30','14:50:00',2.25),('8348','2013-08-30','14:55:00',2.51),('8348','2013-08-30','15:00:00',2.19),('8348','2013-08-30','15:05:00',2.01),('8348','2013-08-30','15:10:00',1.99),('8348','2013-08-30','15:15:00',2.54),('8348','2013-08-30','15:20:00',2.19),('8348','2013-08-30','15:25:00',2),('8348','2013-08-30','15:30:00',1.83),('8348','2013-08-30','15:35:00',1.58),('8348','2013-08-30','15:40:00',1.7),('8348','2013-08-30','15:45:00',2.01),('8348','2013-08-30','15:50:00',2.13),('8348','2013-08-30','15:55:00',2.06),('8348','2013-08-30','16:00:00',1.96),('8348','2013-08-30','16:05:00',1.73),('8348','2013-08-30','16:10:00',1.43),('8348','2013-08-30','16:15:00',1.33),('8348','2013-08-30','16:20:00',1.52),('8348','2013-08-30','16:25:00',1.5),('8348','2013-08-30','16:30:00',1.68),('8348','2013-08-30','16:35:00',1.42),('8348','2013-08-30','16:40:00',2.24),('8348','2013-08-30','16:45:00',2.07),('8348','2013-08-30','16:50:00',2.2),('8348','2013-08-30','16:55:00',1.39),('8348','2013-08-30','17:00:00',1.45),('8348','2013-08-30','17:05:00',1.21),('8348','2013-08-30','17:10:00',1.5),('8348','2013-08-30','17:15:00',1.34),('8348','2013-08-30','17:20:00',1.17),('8348','2013-08-30','17:25:00',1.24),('8348','2013-08-30','17:30:00',1.1),('8348','2013-08-30','17:35:00',1.44),('8348','2013-08-30','17:40:00',1.21),('8348','2013-08-30','17:45:00',1.39),('8348','2013-08-30','17:50:00',1.06),('8348','2013-08-30','17:55:00',1.4),('8348','2013-08-30','18:00:00',1.15),('8348','2014-04-11','06:50:00',1.09),('8348','2014-04-11','06:55:00',1.12),('8348','2014-04-11','07:30:00',1.49),('8348','2014-04-11','07:35:00',1.85),('8348','2014-04-11','07:40:00',2.35),('8348','2014-04-11','07:45:00',2.41),('8348','2014-04-11','07:50:00',2.42),('8348','2014-04-11','07:55:00',2.49),('8348','2014-04-11','08:00:00',2.54),('8348','2014-04-11','08:05:00',2.72),('8348','2014-04-11','08:10:00',3.05),('8348','2014-04-11','08:15:00',3.28),('8348','2014-04-11','08:20:00',3.43),('8348','2014-04-11','08:25:00',3.58),('8348','2014-04-11','08:30:00',3.75),('8348','2014-04-11','08:35:00',3.9),('8348','2014-04-11','08:40:00',4.05),('8348','2014-04-11','08:45:00',4.22),('8348','2014-04-11','08:50:00',4.31),('8348','2014-04-11','08:55:00',4.53),('8348','2014-04-11','09:00:00',4.66),('8348','2014-04-11','09:05:00',4.78),('8348','2014-04-11','09:10:00',4.98),('8348','2014-04-11','09:15:00',5.07),('8348','2014-04-11','09:20:00',5.19),('8348','2014-04-11','09:25:00',5.3),('8348','2014-04-11','09:30:00',5.41),('8348','2014-04-11','09:35:00',5.52),('8348','2014-04-11','09:40:00',5.6),('8348','2014-04-11','09:45:00',5.76),('8348','2014-04-11','09:50:00',5.88),('8348','2014-04-11','09:55:00',5.97),('8348','2014-04-11','10:00:00',6.12),('8348','2014-04-11','10:05:00',6.18),('8348','2014-04-11','10:10:00',6.23),('8348','2014-04-11','10:15:00',6.31),('8348','2014-04-11','10:20:00',6.49),('8348','2014-04-11','10:25:00',6.56),('8348','2014-04-11','10:30:00',6.62),('8348','2014-04-11','10:35:00',6.73),('8348','2014-04-11','10:40:00',6.62),('8348','2014-04-11','10:45:00',6.82),('8348','2014-04-11','10:50:00',6.03),('8348','2014-04-11','10:55:00',7.22),('8348','2014-04-11','11:00:00',7.36),('8348','2014-04-11','11:05:00',6.63),('8348','2014-04-11','11:10:00',7.62),('8348','2014-04-11','11:15:00',7.41),('8348','2014-04-11','11:20:00',5.88),('8348','2014-04-11','11:25:00',7.1),('8348','2014-04-11','11:30:00',7.67),('8348','2014-04-11','11:35:00',6.99),('8348','2014-04-11','11:40:00',7.52),('8348','2014-04-11','11:45:00',7.96),('8348','2014-04-11','11:50:00',7.75),('8348','2014-04-11','11:55:00',7.72),('8348','2014-04-11','12:00:00',5.59),('8348','2014-04-11','12:05:00',4.36),('8348','2014-04-11','12:10:00',4.05),('8348','2014-04-11','12:15:00',6.97),('8348','2014-04-11','12:20:00',6.68),('8348','2014-04-11','12:25:00',8.08),('8348','2014-04-11','12:30:00',4.5),('8348','2014-04-11','12:35:00',7.86),('8348','2014-04-11','12:40:00',7.19),('8348','2014-04-11','12:45:00',7.58),('8348','2014-04-11','12:50:00',5.17),('8348','2014-04-11','12:55:00',7.37),('8348','2014-04-11','13:00:00',4.9),('8348','2014-04-11','13:05:00',6.57),('8348','2014-04-11','13:10:00',7.01),('8348','2014-04-11','13:15:00',7.27),('8348','2014-04-11','13:20:00',5.99),('8348','2014-04-11','13:25:00',6.1),('8348','2014-04-11','13:30:00',7.13),('8348','2014-04-11','13:35:00',7.97),('8348','2014-04-11','13:40:00',4.94),('8348','2014-04-11','13:45:00',6.14),('8348','2014-04-11','13:50:00',7.97),('8348','2014-04-11','13:55:00',6.19),('8348','2014-04-11','14:00:00',8.32),('8348','2014-04-11','14:05:00',8.06),('8348','2014-04-11','14:10:00',7.27),('8348','2014-04-11','14:15:00',6.22),('8348','2014-04-11','14:20:00',7.07),('8348','2014-04-11','14:25:00',6.96),('8348','2014-04-11','14:30:00',6.6),('8348','2014-04-11','14:35:00',4.55),('8348','2014-04-11','14:40:00',6.4),('8348','2014-04-11','14:45:00',6.32),('8348','2014-04-11','14:50:00',6.32),('8348','2014-04-11','14:55:00',6.23),('8348','2014-04-11','15:00:00',6.07),('8348','2014-04-11','15:05:00',5.92),('8348','2014-04-11','15:10:00',5.82),('8348','2014-04-11','15:15:00',5.54),('8348','2014-04-11','15:20:00',5.5),('8348','2014-04-11','15:25:00',5.41),('8348','2014-04-11','15:30:00',5.32),('8348','2014-04-11','15:35:00',4.86),('8348','2014-04-11','15:40:00',4.95),('8348','2014-04-11','15:45:00',5.05),('8348','2014-04-11','15:50:00',2.44),('8348','2014-04-11','15:55:00',2.9),('8348','2014-04-11','16:00:00',4.91),('8348','2014-04-11','16:05:00',4.14),('8348','2014-04-11','16:10:00',4.27),('8348','2014-04-11','16:15:00',4.13),('8348','2014-04-11','16:20:00',3.86),('8348','2014-04-11','16:25:00',3.86),('8348','2014-04-11','16:30:00',3.89),('8348','2014-04-11','16:35:00',3.75),('8348','2014-04-11','16:40:00',3.6),('8348','2014-04-11','16:45:00',3.22),('8348','2014-04-11','16:50:00',2.97),('8348','2014-04-11','16:55:00',2.77),('8348','2014-04-11','17:00:00',2.56),('8348','2014-04-11','17:05:00',2.37),('8348','2014-04-11','17:10:00',2.23),('8348','2014-04-11','17:15:00',2.11),('8348','2014-04-11','17:20:00',1.99),('8348','2014-04-11','17:25:00',1.86),('8348','2014-04-11','17:30:00',1.96),('8348','2014-04-11','17:35:00',1.73),('8348','2014-04-11','17:40:00',1.51),('8348','2014-04-11','17:45:00',1.3),('8348','2014-04-11','17:50:00',1.19),('8348','2014-04-11','17:55:00',1.06),('8348','2013-08-29','08:25:00',1.08),('8348','2013-08-29','08:30:00',1.27),('8348','2013-08-29','08:35:00',1.3),('8348','2013-08-29','08:40:00',1.09),('8348','2013-08-29','08:50:00',1.06),('8348','2013-08-29','08:55:00',1.31),('8348','2013-08-29','09:00:00',1.31),('8348','2013-08-29','09:05:00',1.29),('8348','2013-08-29','09:10:00',1.27),('8348','2013-08-29','09:15:00',1.35),('8348','2013-08-29','09:20:00',1.36),('8348','2013-08-29','09:25:00',1.27),('8348','2013-08-29','09:30:00',1.31),('8348','2013-08-29','09:35:00',1.44),('8348','2013-08-29','09:40:00',1.49),('8348','2013-08-29','09:45:00',1.31),('8348','2013-08-29','09:50:00',1.27),('8348','2013-08-29','09:55:00',1.32),('8348','2013-08-29','10:00:00',1.39),('8348','2013-08-29','10:05:00',1.34),('8348','2013-08-29','10:10:00',1.32),('8348','2013-08-29','10:15:00',1.32),('8348','2013-08-29','10:20:00',1.35),('8348','2013-08-29','10:25:00',1.35),('8348','2013-08-29','10:30:00',1.38),('8348','2013-08-29','10:35:00',1.31),('8348','2013-08-29','10:40:00',1.2),('8348','2013-08-29','10:45:00',1.13),('8348','2013-08-29','10:50:00',1.13),('8348','2013-08-29','10:55:00',1.26),('8348','2013-08-29','11:00:00',1.34),('8348','2013-08-29','11:05:00',1.36),('8348','2013-08-29','11:10:00',1.93),('8348','2013-08-29','11:15:00',2.17),('8348','2013-08-29','11:20:00',2.01),('8348','2013-08-29','11:25:00',1.57),('8348','2013-08-29','11:30:00',1.32),('8348','2013-08-29','11:35:00',1.24),('8348','2013-08-29','11:40:00',1.41),('8348','2013-08-29','11:45:00',1.63),('8348','2013-08-29','11:50:00',1.69),('8348','2013-08-29','11:55:00',1.61),('8348','2013-08-29','12:00:00',1.58),('8348','2013-08-29','12:05:00',1.76),('8348','2013-08-29','12:10:00',2.14),('8348','2013-08-29','12:15:00',2.47),('8348','2013-08-29','12:20:00',2.27),('8348','2013-08-29','12:25:00',2.32),('8348','2013-08-29','12:30:00',2.26),('8348','2013-08-29','12:35:00',2.72),('8348','2013-08-29','12:40:00',3.75),('8348','2013-08-29','12:45:00',3.85),('8348','2013-08-29','12:50:00',2.38),('8348','2013-08-29','12:55:00',2.85),('8348','2013-08-29','13:00:00',2.36),('8348','2013-08-29','13:05:00',2.21),('8348','2013-08-29','13:10:00',2.17),('8348','2013-08-29','13:15:00',2.07),('8348','2013-08-29','13:20:00',2.07),('8348','2013-08-29','13:25:00',1.78),('8348','2013-08-29','13:30:00',1.64),('8348','2013-08-29','13:35:00',1.56),('8348','2013-08-29','13:40:00',1.5),('8348','2013-08-29','13:45:00',1.4),('8348','2013-08-29','13:50:00',1.37),('8348','2013-08-29','13:55:00',1.6),('8348','2013-08-29','14:00:00',2.11),('8348','2013-08-29','14:05:00',1.51),('8348','2013-08-29','14:10:00',1.35),('8348','2013-08-29','14:15:00',1.11),('8348','2013-08-29','14:50:00',1.11),('8348','2013-08-29','14:55:00',1.27),('8348','2013-08-29','15:00:00',1.4),('8348','2013-08-29','15:05:00',1.59),('8348','2013-08-29','15:10:00',1.25),('8348','2013-08-29','15:15:00',1.08),('8348','2013-08-29','15:20:00',1.21),('8348','2013-08-29','15:25:00',1.41),('8348','2013-08-29','15:30:00',2.25),('8348','2013-08-29','15:35:00',2.11),('8348','2013-08-29','15:40:00',2.01),('8348','2013-08-29','15:45:00',2.12),('8348','2013-08-29','15:50:00',2.7),('8348','2013-08-29','15:55:00',3.14),('8348','2013-08-29','16:00:00',2.86),('8348','2013-08-29','16:05:00',3.03),('8348','2013-08-29','16:10:00',2.96),('8348','2013-08-29','16:15:00',2.76),('8348','2013-08-29','16:20:00',2.64),('8348','2013-08-29','16:25:00',2.55),('8348','2013-08-29','16:30:00',2.42),('8348','2013-08-29','16:35:00',2.43),('8348','2013-08-29','16:40:00',2.37),('8348','2013-08-29','16:45:00',2.32),('8348','2013-08-29','16:50:00',2.24),('8348','2013-08-29','16:55:00',2.18),('8348','2013-08-29','17:00:00',2.13),('8348','2013-08-29','17:05:00',2.07),('8348','2013-08-29','17:10:00',2),('8348','2013-08-29','17:15:00',1.92),('8348','2013-08-29','17:20:00',1.85),('8348','2013-08-29','17:25:00',1.78),('8348','2013-08-29','17:30:00',1.71),('8348','2013-08-29','17:35:00',1.63),('8348','2013-08-29','17:40:00',1.56),('8348','2013-08-29','17:45:00',1.46),('8348','2013-08-29','17:50:00',1.39),('8348','2013-08-29','17:55:00',1.32),('8348','2013-08-29','18:00:00',1.24),('8348','2013-08-29','18:05:00',1.17),('8348','2013-08-29','18:10:00',1.09),('8348','2013-08-29','18:15:00',1.03),('8348','2013-08-28','08:35:00',1.08),('8348','2013-08-28','08:40:00',1.15),('8348','2013-08-28','08:45:00',1.18),('8348','2013-08-28','09:00:00',1.08),('8348','2013-08-28','09:15:00',1.31),('8348','2013-08-28','09:20:00',1.03),('8348','2013-08-28','09:30:00',1.06),('8348','2013-08-28','09:35:00',1.98),('8348','2013-08-28','09:40:00',1.97),('8348','2013-08-28','09:45:00',2.02),('8348','2013-08-28','09:50:00',2.1),('8348','2013-08-28','09:55:00',2.12),('8348','2013-08-28','10:00:00',2.16),('8348','2013-08-28','10:05:00',2.21),('8348','2013-08-28','10:10:00',2.3),('8348','2013-08-28','10:15:00',2.45),('8348','2013-08-28','10:20:00',2.3),('8348','2013-08-28','10:25:00',1.33),('8348','2013-08-28','10:30:00',2.02),('8348','2013-08-28','10:35:00',1.76),('8348','2013-08-28','10:40:00',1.75),('8348','2013-08-28','10:45:00',2.73),('8348','2013-08-28','10:50:00',2.57),('8348','2013-08-28','10:55:00',2.94),('8348','2013-08-28','11:00:00',2.02),('8348','2013-08-28','11:05:00',2.85),('8348','2013-08-28','11:10:00',1.59),('8348','2013-08-28','11:15:00',1.9),('8348','2013-08-28','11:20:00',2.64),('8348','2013-08-28','11:25:00',3.31),('8348','2013-08-28','11:30:00',3.37),('8348','2013-08-28','11:35:00',2.98),('8348','2013-08-28','11:40:00',3.47),('8348','2013-08-28','11:45:00',2.49),('8348','2013-08-28','11:50:00',2.6),('8348','2013-08-28','11:55:00',2.24),('8348','2013-08-28','12:00:00',2.84),('8348','2013-08-28','12:05:00',2.59),('8348','2013-08-28','12:10:00',3.51),('8348','2013-08-28','12:15:00',3.58),('8348','2013-08-28','12:20:00',3.5),('8348','2013-08-28','12:25:00',3.37),('8348','2013-08-28','12:30:00',3.5),('8348','2013-08-28','12:35:00',3.49),('8348','2013-08-28','12:40:00',3.53),('8348','2013-08-28','12:45:00',3.65),('8348','2013-08-28','12:50:00',3.61),('8348','2013-08-28','12:55:00',3.56),('8348','2013-08-28','13:00:00',3.63),('8348','2013-08-28','13:05:00',2.82),('8348','2013-08-28','13:10:00',3.44),('8348','2013-08-28','13:15:00',3.74),('8348','2013-08-28','13:20:00',3.64),('8348','2013-08-28','13:25:00',3.67),('8348','2013-08-28','13:30:00',3.66),('8348','2013-08-28','13:35:00',3.38),('8348','2013-08-28','13:40:00',3.69),('8348','2013-08-28','13:45:00',2.78),('8348','2013-08-28','13:50:00',3.73),('8348','2013-08-28','13:55:00',3.55),('8348','2013-08-28','14:00:00',3.67),('8348','2013-08-28','14:05:00',3.63),('8348','2013-08-28','14:10:00',3.61),('8348','2013-08-28','14:15:00',3.61),('8348','2013-08-28','14:20:00',3.57),('8348','2013-08-28','14:25:00',3.56),('8348','2013-08-28','14:30:00',3.41),('8348','2013-08-28','14:35:00',2.59),('8348','2013-08-28','14:40:00',3.63),('8348','2013-08-28','14:45:00',3.46),('8348','2013-08-28','14:50:00',3.44),('8348','2013-08-28','14:55:00',3.42),('8348','2013-08-28','15:00:00',3.36),('8348','2013-08-28','15:05:00',3.36),('8348','2013-08-28','15:10:00',3.42),('8348','2013-08-28','15:15:00',3.38),('8348','2013-08-28','15:20:00',3.36),('8348','2013-08-28','15:25:00',2.95),('8348','2013-08-28','15:30:00',2.3),('8348','2013-08-28','15:35:00',2.05),('8348','2013-08-28','15:40:00',1.88),('8348','2013-08-28','15:45:00',2.27),('8348','2013-08-28','15:50:00',2.73),('8348','2013-08-28','15:55:00',2.43),('8348','2013-08-28','16:00:00',2.92),('8348','2013-08-28','16:05:00',3.14),('8348','2013-08-28','16:10:00',3),('8348','2013-08-28','16:15:00',2.4),('8348','2013-08-28','16:20:00',2.32),('8348','2013-08-28','16:25:00',2.84),('8348','2013-08-28','16:30:00',2.73),('8348','2013-08-28','16:35:00',2.58),('8348','2013-08-28','16:40:00',2.63),('8348','2013-08-28','16:45:00',2.49),('8348','2013-08-28','16:50:00',2.38),('8348','2013-08-28','16:55:00',2.28),('8348','2013-08-28','17:00:00',2.27),('8348','2013-08-28','17:05:00',2.15),('8348','2013-08-28','17:10:00',1.18),('8348','2013-08-28','17:15:00',1.67),('8348','2013-08-28','17:20:00',1.67),('8348','2013-08-28','17:25:00',1.2),('8348','2013-08-28','17:30:00',1.18),('8348','2013-08-28','17:35:00',1.38),('8348','2013-08-28','17:40:00',1.48),('8348','2013-08-28','18:15:00',1.05),('8348','2013-08-27','08:25:00',1.11),('8348','2013-08-27','08:30:00',1.1),('8348','2013-08-27','09:15:00',1.02),('8348','2013-08-27','09:20:00',1.19),('8348','2013-08-27','09:25:00',1.54),('8348','2013-08-27','09:30:00',1.74),('8348','2013-08-27','09:35:00',1.03),('8348','2013-08-27','09:55:00',1.17),('8348','2013-08-27','10:00:00',1.5),('8348','2013-08-27','10:05:00',1.83),('8348','2013-08-27','10:10:00',2.21),('8348','2013-08-27','10:15:00',2.24),('8348','2013-08-27','10:20:00',2.38),('8348','2013-08-27','10:25:00',2.4),('8348','2013-08-27','10:30:00',2.42),('8348','2013-08-27','10:35:00',2.48),('8348','2013-08-27','10:40:00',2.52),('8348','2013-08-27','10:45:00',2.58),('8348','2013-08-27','10:50:00',2.6),('8348','2013-08-27','10:55:00',2.64),('8348','2013-08-27','11:00:00',2.7),('8348','2013-08-27','11:05:00',2.74),('8348','2013-08-27','11:10:00',2.71),('8348','2013-08-27','11:15:00',2.49),('8348','2013-08-27','11:20:00',2.77),('8348','2013-08-27','11:25:00',2.72),('8348','2013-08-27','11:30:00',2.77),('8348','2013-08-27','11:35:00',2.84),('8348','2013-08-27','11:40:00',2.74),('8348','2013-08-27','11:45:00',3.33),('8348','2013-08-27','11:50:00',3.09),('8348','2013-08-27','11:55:00',3.34),('8348','2013-08-27','12:00:00',3.45),('8348','2013-08-27','12:05:00',3.36),('8348','2013-08-27','12:10:00',2.65),('8348','2013-08-27','12:15:00',3.09),('8348','2013-08-27','12:20:00',3.32),('8348','2013-08-27','12:25:00',3.23),('8348','2013-08-27','12:30:00',2.95),('8348','2013-08-27','12:35:00',3.03),('8348','2013-08-27','12:40:00',3.58),('8348','2013-08-27','12:45:00',2.64),('8348','2013-08-27','12:50:00',1.99),('8348','2013-08-27','12:55:00',1.59),('8348','2013-08-27','13:00:00',1.22),('8348','2013-08-27','13:05:00',1.37),('8348','2013-08-27','13:10:00',1.82),('8348','2013-08-27','13:15:00',1.45),('8348','2013-08-27','13:20:00',1.86),('8348','2013-08-27','13:25:00',1.99),('8348','2013-08-27','13:30:00',2.39),('8348','2013-08-27','13:35:00',1.73),('8348','2013-08-27','13:40:00',1.72),('8348','2013-08-27','13:45:00',1.82),('8348','2013-08-27','13:50:00',3.43),('8348','2013-08-27','13:55:00',2.85),('8348','2013-08-27','14:00:00',2.58),('8348','2013-08-27','14:05:00',2.23),('8348','2013-08-27','14:10:00',2.45),('8348','2013-08-27','14:15:00',2.98),('8348','2013-08-27','14:20:00',1.98),('8348','2013-08-27','14:25:00',1.23),('8348','2013-08-27','14:30:00',1.13),('8348','2013-08-27','14:35:00',1.03),('8348','2013-08-27','14:40:00',1.14),('8348','2013-08-27','14:45:00',1.18),('8348','2013-08-27','15:55:00',1.26),('8348','2013-08-27','16:00:00',1.39),('8348','2013-08-27','16:05:00',1.41),('8348','2013-08-27','16:10:00',3.05),('8348','2013-08-27','16:15:00',3.04),('8348','2013-08-27','16:20:00',1.63),('8348','2013-08-27','16:25:00',1.61),('8348','2013-08-27','16:35:00',1.14),('8348','2013-08-27','16:40:00',1.17),('8348','2013-08-27','16:45:00',1.65),('8348','2013-08-27','16:50:00',2.61),('8348','2013-08-27','16:55:00',1.89),('8348','2013-08-27','17:05:00',1.02),('8348','2013-08-27','17:10:00',2.47),('8348','2013-08-27','17:15:00',1.22),('8348','2013-08-27','17:45:00',1.32),('8348','2013-08-27','17:50:00',1.52),('8348','2013-08-27','17:55:00',1.51),('8348','2013-08-27','18:00:00',1.31),('8348','2013-08-26','08:20:00',1.03),('8348','2013-08-26','08:30:00',1.03),('8348','2013-08-26','08:40:00',1.1),('8348','2013-08-26','08:45:00',1.12),('8348','2013-08-26','08:50:00',1.23),('8348','2013-08-26','08:55:00',1.29),('8348','2013-08-26','09:00:00',1.38),('8348','2013-08-26','09:05:00',1.45),('8348','2013-08-26','09:10:00',1.53),('8348','2013-08-26','09:15:00',1.61),('8348','2013-08-26','09:20:00',1.67),('8348','2013-08-26','09:25:00',1.73),('8348','2013-08-26','09:30:00',1.8),('8348','2013-08-26','09:35:00',1.85),('8348','2013-08-26','09:40:00',1.91),('8348','2013-08-26','09:45:00',1.97),('8348','2013-08-26','09:50:00',2.05),('8348','2013-08-26','09:55:00',2.09),('8348','2013-08-26','10:00:00',2.13),('8348','2013-08-26','10:05:00',2.21),('8348','2013-08-26','10:10:00',2.23),('8348','2013-08-26','10:15:00',2.29),('8348','2013-08-26','10:20:00',2.37),('8348','2013-08-26','10:25:00',2.42),('8348','2013-08-26','10:30:00',2.46),('8348','2013-08-26','10:35:00',2.5),('8348','2013-08-26','10:40:00',2.55),('8348','2013-08-26','10:45:00',2.6),('8348','2013-08-26','10:50:00',2.66),('8348','2013-08-26','10:55:00',2.7),('8348','2013-08-26','11:00:00',2.76),('8348','2013-08-26','11:05:00',2.77),('8348','2013-08-26','11:10:00',2.8),('8348','2013-08-26','11:15:00',2.87),('8348','2013-08-26','11:20:00',2.89),('8348','2013-08-26','11:25:00',2.91),('8348','2013-08-26','11:30:00',2.98),('8348','2013-08-26','11:35:00',3.03),('8348','2013-08-26','11:40:00',3.04),('8348','2013-08-26','11:45:00',3.04),('8348','2013-08-26','11:50:00',2.74),('8348','2013-08-26','11:55:00',3.08),('8348','2013-08-26','12:00:00',3.12),('8348','2013-08-26','12:05:00',3.18),('8348','2013-08-26','12:10:00',3.19),('8348','2013-08-26','12:15:00',3.19),('8348','2013-08-26','12:20:00',3.16),('8348','2013-08-26','12:25:00',3.15),('8348','2013-08-26','12:30:00',3.17),('8348','2013-08-26','12:35:00',3.23),('8348','2013-08-26','12:40:00',3.26),('8348','2013-08-26','12:45:00',3.3),('8348','2013-08-26','12:50:00',3.31),('8348','2013-08-26','12:55:00',3.32),('8348','2013-08-26','13:00:00',3.53),('8348','2013-08-26','13:05:00',3.9),('8348','2013-08-26','13:10:00',3.3),('8348','2013-08-26','13:15:00',3.26),('8348','2013-08-26','13:20:00',2.57),('8348','2013-08-26','13:25:00',2.55),('8348','2013-08-26','13:30:00',2.49),('8348','2013-08-26','13:35:00',3.26),('8348','2013-08-26','13:40:00',3.38),('8348','2013-08-26','13:45:00',3.42),('8348','2013-08-26','13:50:00',3.48),('8348','2013-08-26','13:55:00',2.59),('8348','2013-08-26','14:00:00',2.63),('8348','2013-08-26','14:05:00',3.42),('8348','2013-08-26','14:10:00',2.51),('8348','2013-08-26','14:15:00',3.46),('8348','2013-08-26','14:20:00',3.33),('8348','2013-08-26','14:25:00',3.28),('8348','2013-08-26','14:30:00',3.26),('8348','2013-08-26','14:35:00',3.15),('8348','2013-08-26','14:40:00',2.91),('8348','2013-08-26','14:45:00',2.21),('8348','2013-08-26','14:50:00',1.87),('8348','2013-08-26','14:55:00',1.73),('8348','2013-08-26','15:00:00',1.64),('8348','2013-08-26','15:05:00',1.26),('8348','2013-08-26','15:40:00',1.42),('8348','2013-08-26','15:45:00',1.53),('8348','2013-08-26','15:50:00',1.54),('8348','2013-08-26','15:55:00',1.43),('8348','2013-08-26','16:00:00',2.04),('8348','2013-08-26','16:05:00',3.08),('8348','2013-08-26','16:10:00',2.71),('8348','2013-08-26','16:15:00',2.52),('8348','2013-08-26','16:20:00',2.51),('8348','2013-08-26','16:25:00',2.42),('8348','2013-08-26','16:30:00',2.36),('8348','2013-08-26','16:35:00',2.32),('8348','2013-08-26','16:40:00',2.28),('8348','2013-08-26','16:45:00',2.23),('8348','2013-08-26','16:50:00',2.08),('8348','2013-08-26','16:55:00',2.06),('8348','2013-08-26','17:00:00',2.03),('8348','2013-08-26','17:05:00',1.86),('8348','2013-08-26','17:10:00',1.89),('8348','2013-08-26','17:15:00',1.82),('8348','2013-08-26','17:20:00',1.39),('8348','2013-08-26','17:30:00',1.36),('8348','2013-08-26','17:35:00',1.03),('8348','2013-08-26','17:40:00',1.06),('8348','2013-08-26','17:45:00',1.26),('8348','2013-08-26','17:50:00',1.44),('8348','2013-08-26','17:55:00',1.42),('8348','2013-08-26','18:00:00',1.26),('8348','2013-08-26','18:05:00',1.11),('8348','2013-08-26','18:10:00',1.01),('8348','2013-08-25','08:45:00',1.34),('8348','2013-08-25','09:20:00',1.74),('8348','2013-08-25','09:25:00',1.77),('8348','2013-08-25','09:30:00',1.51),('8348','2013-08-25','09:35:00',1.14),('8348','2013-08-25','09:40:00',2.27),('8348','2013-08-25','09:45:00',2.68),('8348','2013-08-25','09:50:00',2.42),('8348','2013-08-25','09:55:00',2.55),('8348','2013-08-25','10:00:00',1.85),('8348','2013-08-25','10:05:00',1.22),('8348','2013-08-25','15:15:00',1.11),('8348','2013-08-25','15:20:00',1.3),('8348','2013-08-25','15:25:00',1.41),('8348','2013-08-25','15:30:00',1.99),('8348','2013-08-25','15:35:00',2.96),('8348','2013-08-25','15:40:00',3.12),('8348','2013-08-25','15:45:00',3.26),('8348','2013-08-25','15:50:00',2.3),('8348','2013-08-25','15:55:00',2.08),('8348','2013-08-25','16:00:00',3.11),('8348','2013-08-25','16:05:00',2.87),('8348','2013-08-25','16:10:00',2.75),('8348','2013-08-25','16:15:00',2.66),('8348','2013-08-25','16:20:00',2.6),('8348','2013-08-25','16:25:00',2.58),('8348','2013-08-25','16:30:00',2.54),('8348','2013-08-25','16:35:00',2.43),('8348','2013-08-25','16:40:00',1.83),('8348','2013-08-25','16:45:00',1.34),('8348','2013-08-25','16:50:00',1.84),('8348','2013-08-25','16:55:00',2.46),('8348','2013-08-25','17:00:00',2.32),('8348','2013-08-25','17:05:00',2.19),('8348','2013-08-25','17:10:00',2.1),('8348','2013-08-25','17:15:00',1.92),('8348','2013-08-25','17:20:00',1.85),('8348','2013-08-25','17:25:00',1.78),('8348','2013-08-25','17:30:00',1.69),('8348','2013-08-25','17:35:00',1.43),('8348','2013-08-25','17:40:00',1.3),('8348','2013-08-25','17:45:00',1.53),('8348','2013-08-25','17:50:00',1.37),('8348','2013-08-25','17:55:00',1.17),('8348','2013-08-25','18:10:00',1.02),('8348','2013-08-25','18:15:00',1.06),('8348','2013-08-25','18:20:00',1),('8348','2013-08-24','08:40:00',1.05),('8348','2013-08-24','08:45:00',1.11),('8348','2013-08-24','08:50:00',1.23),('8348','2013-08-24','08:55:00',1.27),('8348','2013-08-24','09:00:00',1.4),('8348','2013-08-24','09:05:00',1.62),('8348','2013-08-24','09:10:00',1.2),('8348','2013-08-24','09:15:00',1.06),('8348','2013-08-24','09:20:00',1.22),('8348','2013-08-24','09:25:00',1.71),('8348','2013-08-24','09:30:00',1.67),('8348','2013-08-24','09:35:00',1.69),('8348','2013-08-24','09:40:00',1.04),('8348','2013-08-24','09:45:00',1.96),('8348','2013-08-24','09:50:00',1.83),('8348','2013-08-24','09:55:00',2.14),('8348','2013-08-24','10:00:00',2.23),('8348','2013-08-24','10:05:00',2.24),('8348','2013-08-24','10:10:00',2.31),('8348','2013-08-24','10:15:00',2.33),('8348','2013-08-24','10:20:00',2.4),('8348','2013-08-24','10:25:00',2.43),('8348','2013-08-24','10:30:00',2.49),('8348','2013-08-24','10:35:00',2.53),('8348','2013-08-24','10:40:00',2.58),('8348','2013-08-24','10:45:00',2.62),('8348','2013-08-24','10:50:00',1.82),('8348','2013-08-24','10:55:00',2.81),('8348','2013-08-24','11:00:00',2.77),('8348','2013-08-24','11:05:00',2.84),('8348','2013-08-24','11:10:00',2.88),('8348','2013-08-24','11:15:00',2.91),('8348','2013-08-24','11:20:00',2.96),('8348','2013-08-24','11:25:00',2.93),('8348','2013-08-24','11:30:00',2.99),('8348','2013-08-24','11:35:00',3.02),('8348','2013-08-24','11:40:00',3.05),('8348','2013-08-24','11:45:00',3.08),('8348','2013-08-24','11:50:00',3.13),('8348','2013-08-24','11:55:00',3.13),('8348','2013-08-24','12:00:00',3.15),('8348','2013-08-24','12:05:00',3.16),('8348','2013-08-24','12:10:00',3.2),('8348','2013-08-24','12:15:00',3.24),('8348','2013-08-24','12:20:00',3.26),('8348','2013-08-24','12:25:00',3.27),('8348','2013-08-24','12:30:00',3.27),('8348','2013-08-24','12:35:00',3.29),('8348','2013-08-24','12:40:00',3.3),('8348','2013-08-24','12:45:00',3.33),('8348','2013-08-24','12:50:00',3.32),('8348','2013-08-24','12:55:00',3.3),('8348','2013-08-24','13:00:00',3.27),('8348','2013-08-24','13:05:00',3.3),('8348','2013-08-24','13:10:00',3.37),('8348','2013-08-24','13:15:00',3.35),('8348','2013-08-24','13:20:00',3.37),('8348','2013-08-24','13:25:00',3.41),('8348','2013-08-24','13:30:00',3.44),('8348','2013-08-24','13:35:00',3.45),('8348','2013-08-24','13:40:00',3.42),('8348','2013-08-24','13:45:00',3.43),('8348','2013-08-24','13:50:00',3.43),('8348','2013-08-24','13:55:00',3.41),('8348','2013-08-24','14:00:00',3.38),('8348','2013-08-24','14:05:00',3.4),('8348','2013-08-24','14:10:00',3.39),('8348','2013-08-24','14:15:00',3.38),('8348','2013-08-24','14:20:00',3.37),('8348','2013-08-24','14:25:00',3.35),('8348','2013-08-24','14:30:00',3.36),('8348','2013-08-24','14:35:00',3.34),('8348','2013-08-24','14:40:00',3.3),('8348','2013-08-24','14:45:00',3.27),('8348','2013-08-24','14:50:00',3.24),('8348','2013-08-24','14:55:00',3.23),('8348','2013-08-24','15:00:00',3.2),('8348','2013-08-24','15:05:00',3.19),('8348','2013-08-24','15:10:00',3.14),('8348','2013-08-24','15:15:00',3.11),('8348','2013-08-24','15:20:00',3.06),('8348','2013-08-24','15:25:00',3.05),('8348','2013-08-24','15:30:00',3.02),('8348','2013-08-24','15:35:00',2.99),('8348','2013-08-24','15:40:00',2.93),('8348','2013-08-24','15:45:00',2.89),('8348','2013-08-24','15:50:00',2.86),('8348','2013-08-24','15:55:00',2.82),('8348','2013-08-24','16:00:00',2.78),('8348','2013-08-24','16:05:00',2.72),('8348','2013-08-24','16:10:00',2.68),('8348','2013-08-24','16:15:00',2.62),('8348','2013-08-24','16:20:00',2.59),('8348','2013-08-24','16:25:00',2.49),('8348','2013-08-24','16:30:00',2.46),('8348','2013-08-24','16:35:00',2.43),('8348','2013-08-24','16:40:00',2.36),('8348','2013-08-24','16:45:00',2.27),('8348','2013-08-24','16:50:00',2.25),('8348','2013-08-24','16:55:00',2.18),('8348','2013-08-24','17:00:00',2.1),('8348','2013-08-24','17:05:00',2.07),('8348','2013-08-24','17:10:00',2.01),('8348','2013-08-24','17:15:00',1.95),('8348','2013-08-24','17:20:00',1.88),('8348','2013-08-24','17:25:00',1.81),('8348','2013-08-24','17:30:00',1.75),('8348','2013-08-24','17:35:00',1.67),('8348','2013-08-24','17:40:00',1.59),('8348','2013-08-24','17:45:00',1.52),('8348','2013-08-24','17:50:00',1.45),('8348','2013-08-24','17:55:00',1.37),('8348','2013-08-24','18:00:00',1.3),('8348','2013-08-24','18:05:00',1.22),('8348','2013-08-24','18:10:00',1.14),('8348','2013-08-24','18:15:00',1.06),('8348','2013-08-23','08:45:00',1.08),('8348','2013-08-23','08:50:00',1.13),('8348','2013-08-23','08:55:00',1.2),('8348','2013-08-23','09:00:00',1.26),('8348','2013-08-23','09:05:00',1.35),('8348','2013-08-23','09:10:00',1.42),('8348','2013-08-23','09:15:00',1.48),('8348','2013-08-23','09:20:00',1.55),('8348','2013-08-23','09:25:00',1.61),('8348','2013-08-23','09:30:00',1.65),('8348','2013-08-23','09:35:00',1.71),('8348','2013-08-23','09:40:00',1.76),('8348','2013-08-23','09:45:00',1.82),('8348','2013-08-23','09:50:00',1.88),('8348','2013-08-23','09:55:00',1.92),('8348','2013-08-23','10:00:00',1.97),('8348','2013-08-23','10:05:00',2.02),('8348','2013-08-23','10:10:00',2.08),('8348','2013-08-23','10:15:00',2.13),('8348','2013-08-23','10:20:00',2.19),('8348','2013-08-23','10:25:00',2.21),('8348','2013-08-23','10:30:00',2.25),('8348','2013-08-23','10:35:00',2.31),('8348','2013-08-23','10:40:00',2.36),('8348','2013-08-23','10:45:00',2.4),('8348','2013-08-23','10:50:00',2.38),('8348','2013-08-23','10:55:00',2.5),('8348','2013-08-23','11:00:00',2.53),('8348','2013-08-23','11:05:00',2.56),('8348','2013-08-23','11:10:00',1.95),('8348','2013-08-23','11:15:00',1.18),('8348','2013-08-23','11:20:00',1.18),('8348','2013-08-23','11:25:00',1.72),('8348','2013-08-23','11:30:00',1.79),('8348','2013-08-23','11:35:00',2.76),('8348','2013-08-23','11:40:00',3.1),('8348','2013-08-23','11:45:00',2.95),('8348','2013-08-23','11:50:00',3),('8348','2013-08-23','11:55:00',1.27),('8348','2013-08-23','12:00:00',1.17),('8348','2013-08-23','12:05:00',1.17),('8348','2013-08-23','12:10:00',2.57),('8348','2013-08-23','12:15:00',1.99),('8348','2013-08-23','12:35:00',1.19),('8348','2013-08-23','12:40:00',1.41),('8348','2013-08-23','12:45:00',2.01),('8348','2013-08-23','12:50:00',1.17),('8348','2013-08-23','12:55:00',1.75),('8348','2013-08-23','13:00:00',1),('8348','2013-08-23','13:05:00',2.24),('8348','2013-08-23','13:10:00',1.49),('8348','2013-08-23','13:15:00',2.18),('8348','2013-08-23','13:20:00',1.9),('8348','2013-08-23','13:25:00',2.99),('8348','2013-08-23','13:30:00',3.21),('8348','2013-08-23','13:35:00',2.47),('8348','2013-08-23','13:40:00',3.13),('8348','2013-08-23','13:45:00',2.18),('8348','2013-08-23','13:50:00',1.86),('8348','2013-08-23','13:55:00',3.7),('8348','2013-08-23','14:00:00',3.52),('8348','2013-08-23','14:05:00',3.21),('8348','2013-08-23','14:10:00',3.4),('8348','2013-08-23','14:15:00',3.42),('8348','2013-08-23','14:20:00',3.22),('8348','2013-08-23','14:25:00',3.22),('8348','2013-08-23','14:30:00',3.37),('8348','2013-08-23','14:35:00',3.32),('8348','2013-08-23','14:40:00',3.31),('8348','2013-08-23','14:45:00',3.29),('8348','2013-08-23','14:50:00',3.19),('8348','2013-08-23','14:55:00',3.14),('8348','2013-08-23','15:00:00',3.07),('8348','2013-08-23','15:05:00',2.99),('8348','2013-08-23','15:10:00',3.11),('8348','2013-08-23','15:15:00',3.02),('8348','2013-08-23','15:20:00',3.03),('8348','2013-08-23','15:25:00',3.04),('8348','2013-08-23','15:30:00',3.11),('8348','2013-08-23','15:35:00',2.89),('8348','2013-08-23','15:40:00',2.89),('8348','2013-08-23','15:45:00',2.88),('8348','2013-08-23','15:50:00',2.66),('8348','2013-08-23','15:55:00',2.79),('8348','2013-08-23','16:00:00',2.67),('8348','2013-08-23','16:05:00',2.52),('8348','2013-08-23','16:10:00',2.31),('8348','2013-08-23','16:15:00',2.45),('8348','2013-08-23','16:20:00',2.7),('8348','2013-08-23','16:25:00',2.56),('8348','2013-08-23','16:30:00',2.49),('8348','2013-08-23','16:35:00',2.54),('8348','2013-08-23','16:40:00',2.48),('8348','2013-08-23','16:45:00',2.41),('8348','2013-08-23','16:50:00',2.33),('8348','2013-08-23','16:55:00',2.24),('8348','2013-08-23','17:00:00',2.15),('8348','2013-08-23','17:05:00',2.05),('8348','2013-08-23','17:10:00',1.98),('8348','2013-08-23','17:15:00',1.91),('8348','2013-08-23','17:20:00',1.82),('8348','2013-08-23','17:25:00',1.76),('8348','2013-08-23','17:30:00',1.68),('8348','2013-08-23','17:35:00',1.61),('8348','2013-08-23','17:40:00',1.52),('8348','2013-08-23','17:45:00',1.47),('8348','2013-08-23','17:50:00',1.39),('8348','2013-08-23','17:55:00',1.33),('8348','2013-08-23','18:00:00',1.24),('8348','2013-08-23','18:05:00',1.17),('8348','2013-08-23','18:10:00',1.03),('8348','2013-08-22','08:40:00',1.03),('8348','2013-08-22','08:45:00',1.12),('8348','2013-08-22','08:50:00',1.18),('8348','2013-08-22','08:55:00',1.3),('8348','2013-08-22','09:00:00',1.39),('8348','2013-08-22','09:05:00',1.53),('8348','2013-08-22','09:10:00',1.64),('8348','2013-08-22','09:15:00',1.72),('8348','2013-08-22','09:20:00',1.83),('8348','2013-08-22','09:25:00',1.87),('8348','2013-08-22','09:30:00',1.76),('8348','2013-08-22','09:35:00',1.09),('8348','2013-08-22','09:40:00',1.15),('8348','2013-08-22','09:45:00',1.74),('8348','2013-08-22','09:50:00',2.09),('8348','2013-08-22','09:55:00',1.72),('8348','2013-08-22','10:00:00',2.35),('8348','2013-08-22','10:05:00',2.35),('8348','2013-08-22','10:10:00',2.36),('8348','2013-08-22','10:15:00',2.36),('8348','2013-08-22','10:20:00',2.35),('8348','2013-08-22','10:25:00',2.4),('8348','2013-08-22','10:30:00',2.47),('8348','2013-08-22','10:35:00',2.49),('8348','2013-08-22','10:40:00',2.54),('8348','2013-08-22','10:45:00',2.57),('8348','2013-08-22','10:50:00',2.6),('8348','2013-08-22','10:55:00',2.66),('8348','2013-08-22','11:00:00',2.7),('8348','2013-08-22','11:05:00',2.72),('8348','2013-08-22','11:10:00',2.75),('8348','2013-08-22','11:15:00',2.76),('8348','2013-08-22','11:20:00',2.79),('8348','2013-08-22','11:25:00',2.83),('8348','2013-08-22','11:30:00',2.86),('8348','2013-08-22','11:35:00',2.9),('8348','2013-08-22','11:40:00',2.93),('8348','2013-08-22','11:45:00',2.95),('8348','2013-08-22','11:50:00',2.97),('8348','2013-08-22','11:55:00',3),('8348','2013-08-22','12:00:00',3.01),('8348','2013-08-22','12:05:00',3.05),('8348','2013-08-22','12:10:00',3.04),('8348','2013-08-22','12:15:00',3.06),('8348','2013-08-22','12:20:00',3.1),('8348','2013-08-22','12:25:00',3.1),('8348','2013-08-22','12:30:00',3.1),('8348','2013-08-22','12:35:00',3.12),('8348','2013-08-22','12:40:00',3.14),('8348','2013-08-22','12:45:00',3.14),('8348','2013-08-22','12:50:00',3.13),('8348','2013-08-22','12:55:00',3.14),('8348','2013-08-22','13:00:00',3.14),('8348','2013-08-22','13:05:00',3.12),('8348','2013-08-22','13:10:00',3.09),('8348','2013-08-22','13:15:00',3.1),('8348','2013-08-22','13:20:00',3.17),('8348','2013-08-22','13:25:00',3.17),('8348','2013-08-22','13:30:00',3.17),('8348','2013-08-22','13:35:00',3.15),('8348','2013-08-22','13:40:00',3.15),('8348','2013-08-22','13:45:00',3.16),('8348','2013-08-22','13:50:00',3.14),('8348','2013-08-22','13:55:00',3.15),('8348','2013-08-22','14:00:00',3.13),('8348','2013-08-22','14:05:00',3.12),('8348','2013-08-22','14:10:00',3.12),('8348','2013-08-22','14:15:00',3.15),('8348','2013-08-22','14:20:00',3.17),('8348','2013-08-22','14:25:00',3.16),('8348','2013-08-22','14:30:00',2.62),('8348','2013-08-22','14:35:00',2.84),('8348','2013-08-22','14:40:00',3.18),('8348','2013-08-22','14:45:00',3.05),('8348','2013-08-22','14:50:00',3.07),('8348','2013-08-22','14:55:00',3.09),('8348','2013-08-22','15:00:00',3.05),('8348','2013-08-22','15:05:00',3.06),('8348','2013-08-22','15:10:00',3.07),('8348','2013-08-22','15:15:00',2.96),('8348','2013-08-22','15:20:00',3.01),('8348','2013-08-22','15:25:00',2.97),('8348','2013-08-22','15:30:00',2.91),('8348','2013-08-22','15:35:00',2.85),('8348','2013-08-22','15:40:00',2.85),('8348','2013-08-22','15:45:00',2.83),('8348','2013-08-22','15:50:00',2.79),('8348','2013-08-22','15:55:00',2.74),('8348','2013-08-22','16:00:00',2.68),('8348','2013-08-22','16:05:00',2.59),('8348','2013-08-22','16:10:00',2.56),('8348','2013-08-22','16:15:00',2.55),('8348','2013-08-22','16:20:00',2.5),('8348','2013-08-22','16:25:00',2.45),('8348','2013-08-22','16:30:00',2.4),('8348','2013-08-22','16:35:00',2.33),('8348','2013-08-22','16:40:00',2.26),('8348','2013-08-22','16:45:00',2.19),('8348','2013-08-22','16:50:00',2.13),('8348','2013-08-22','16:55:00',2.09),('8348','2013-08-22','17:00:00',2.03),('8348','2013-08-22','17:05:00',1.95),('8348','2013-08-22','17:10:00',1.89),('8348','2013-08-22','17:15:00',1.8),('8348','2013-08-22','17:20:00',1.73),('8348','2013-08-22','17:25:00',1.68),('8348','2013-08-22','17:30:00',1.62),('8348','2013-08-22','17:35:00',1.55),('8348','2013-08-22','17:40:00',1.48),('8348','2013-08-22','17:45:00',1.39),('8348','2013-08-22','17:50:00',1.31),('8348','2013-08-22','17:55:00',1.26),('8348','2013-08-22','18:00:00',1.2),('8348','2013-08-22','18:05:00',1.14),('8348','2013-08-22','18:10:00',1.1),('8348','2013-08-22','18:15:00',1.1),('8348','2013-08-21','09:05:00',1.2),('8348','2013-08-21','09:10:00',1.19),('8348','2013-08-21','09:15:00',1.84),('8348','2013-08-21','09:20:00',2.05),('8348','2013-08-21','09:25:00',1.08),('8348','2013-08-21','09:45:00',1.03),('8348','2013-08-21','09:50:00',2.02),('8348','2013-08-21','09:55:00',2.92),('8348','2013-08-21','10:00:00',2.74),('8348','2013-08-21','10:05:00',2.28),('8348','2013-08-21','10:10:00',2.23),('8348','2013-08-21','10:15:00',2.16),('8348','2013-08-21','10:20:00',1.83),('8348','2013-08-21','10:25:00',1.5),('8348','2013-08-21','10:30:00',1.8),('8348','2013-08-21','10:35:00',2.64),('8348','2013-08-21','10:40:00',2.16),('8348','2013-08-21','10:45:00',1.55),('8348','2013-08-21','10:50:00',1.77),('8348','2013-08-21','10:55:00',1.43),('8348','2013-08-21','11:00:00',1.9),('8348','2013-08-21','11:05:00',1.6),('8348','2013-08-21','11:10:00',1.44),('8348','2013-08-21','11:15:00',1.76),('8348','2013-08-21','11:20:00',2.49),('8348','2013-08-21','11:25:00',2.08),('8348','2013-08-21','11:30:00',2.28),('8348','2013-08-21','11:35:00',3.35),('8348','2013-08-21','11:40:00',3.39),('8348','2013-08-21','11:45:00',3.32),('8348','2013-08-21','11:50:00',3.01),('8348','2013-08-21','11:55:00',3.07),('8348','2013-08-21','12:00:00',3.36),('8348','2013-08-21','12:05:00',3.35),('8348','2013-08-21','12:10:00',3.34),('8348','2013-08-21','12:15:00',3.37),('8348','2013-08-21','12:20:00',3.22),('8348','2013-08-21','12:25:00',2.32),('8348','2013-08-21','12:30:00',1.94),('8348','2013-08-21','12:35:00',1.78),('8348','2013-08-21','12:40:00',2.91),('8348','2013-08-21','12:45:00',3.25),('8348','2013-08-21','12:50:00',3.23),('8348','2013-08-21','12:55:00',3.11),('8348','2013-08-21','13:00:00',3.27),('8348','2013-08-21','13:05:00',3.3),('8348','2013-08-21','13:10:00',3.32),('8348','2013-08-21','13:15:00',3.39),('8348','2013-08-21','13:20:00',3.4),('8348','2013-08-21','13:25:00',3.41),('8348','2013-08-21','13:30:00',3.4),('8348','2013-08-21','13:35:00',3.38),('8348','2013-08-21','13:40:00',3.2),('8348','2013-08-21','13:45:00',3.26),('8348','2013-08-21','13:50:00',3.27),('8348','2013-08-21','13:55:00',3.18),('8348','2013-08-21','14:00:00',2.99),('8348','2013-08-21','14:05:00',3.31),('8348','2013-08-21','14:10:00',3.36),('8348','2013-08-21','14:15:00',3.22),('8348','2013-08-21','14:20:00',2.12),('8348','2013-08-21','14:25:00',2.02),('8348','2013-08-21','14:30:00',2.96),('8348','2013-08-21','14:35:00',3),('8348','2013-08-21','14:40:00',3.04),('8348','2013-08-21','14:45:00',3.01),('8348','2013-08-21','14:50:00',2.9),('8348','2013-08-21','14:55:00',2.92),('8348','2013-08-21','15:00:00',3.03),('8348','2013-08-21','15:05:00',2.99),('8348','2013-08-21','15:10:00',2.88),('8348','2013-08-21','15:15:00',2.83),('8348','2013-08-21','15:20:00',2.78),('8348','2013-08-21','15:25:00',2.76),('8348','2013-08-21','15:30:00',2.69),('8348','2013-08-21','15:35:00',2.58),('8348','2013-08-21','15:40:00',2.45),('8348','2013-08-21','15:45:00',2.52),('8348','2013-08-21','15:50:00',2.56),('8348','2013-08-21','15:55:00',2.44),('8348','2013-08-21','16:00:00',2.32),('8348','2013-08-21','16:05:00',2.26),('8348','2013-08-21','16:10:00',2.22),('8348','2013-08-21','16:15:00',2.28),('8348','2013-08-21','16:20:00',2.4),('8348','2013-08-21','16:25:00',2.34),('8348','2013-08-21','16:30:00',2.48),('8348','2013-08-21','16:35:00',2.41),('8348','2013-08-21','16:40:00',2.33),('8348','2013-08-21','16:45:00',2.28),('8348','2013-08-21','16:50:00',2.22),('8348','2013-08-21','16:55:00',2.18),('8348','2013-08-21','17:00:00',2.13),('8348','2013-08-21','17:05:00',2.09),('8348','2013-08-21','17:10:00',2.04),('8348','2013-08-21','17:15:00',1.99),('8348','2013-08-21','17:20:00',1.99),('8348','2013-08-21','17:25:00',1.91),('8348','2013-08-21','17:30:00',1.83),('8348','2013-08-21','17:35:00',1.78),('8348','2013-08-21','17:40:00',1.72),('8348','2013-08-21','17:45:00',1.67),('8348','2013-08-21','17:50:00',1.64),('8348','2013-08-21','17:55:00',1.56),('8348','2013-08-21','18:00:00',1.49),('8348','2013-08-21','18:05:00',1.41),('8348','2013-08-21','18:10:00',1.3),('8348','2013-08-21','18:15:00',1.23),('8348','2013-08-21','18:20:00',1.13),('8348','2013-08-21','18:25:00',1.03),('8348','2013-08-20','09:20:00',1.01),('8348','2013-08-20','09:25:00',1.54),('8348','2013-08-20','09:30:00',2.06),('8348','2013-08-20','09:35:00',2.18),('8348','2013-08-20','09:40:00',2.43),('8348','2013-08-20','09:45:00',2.03),('8348','2013-08-20','09:50:00',1.7),('8348','2013-08-20','09:55:00',2.41),('8348','2013-08-20','10:00:00',2.9),('8348','2013-08-20','10:05:00',1.69),('8348','2013-08-20','10:10:00',1.43),('8348','2013-08-20','10:15:00',1.95),('8348','2013-08-20','10:20:00',1.81),('8348','2013-08-20','10:40:00',1.03),('8348','2013-08-20','10:45:00',2.08),('8348','2013-08-20','10:50:00',2.75),('8348','2013-08-20','10:55:00',2.43),('8348','2013-08-20','11:10:00',1.29),('8348','2013-08-20','11:15:00',3.1),('8348','2013-08-20','11:20:00',3.3),('8348','2013-08-20','11:25:00',2.81),('8348','2013-08-20','11:30:00',2.07),('8348','2013-08-20','11:35:00',3.11),('8348','2013-08-20','11:40:00',3.36),('8348','2013-08-20','11:45:00',3.43),('8348','2013-08-20','11:50:00',3.82),('8348','2013-08-20','11:55:00',3.71),('8348','2013-08-20','12:00:00',1.59),('8348','2013-08-20','12:05:00',1.25),('8348','2013-08-20','12:10:00',1.1),('8348','2013-08-20','12:30:00',1.25),('8348','2013-08-20','12:35:00',1.48),('8348','2013-08-20','12:40:00',1.61),('8348','2013-08-20','12:45:00',1.62),('8348','2013-08-20','12:50:00',1.65),('8348','2013-08-20','12:55:00',1.69),('8348','2013-08-20','13:00:00',1.67),('8348','2013-08-20','13:05:00',1.51),('8348','2013-08-20','13:10:00',1.45),('8348','2013-08-20','13:15:00',1.47),('8348','2013-08-20','13:20:00',1.53),('8348','2013-08-20','13:25:00',1.6),('8348','2013-08-20','13:30:00',1.76),('8348','2013-08-20','13:35:00',2.36),('8348','2013-08-20','13:40:00',3.52),('8348','2013-08-20','13:45:00',3.04),('8348','2013-08-20','13:50:00',3.77),('8348','2013-08-20','13:55:00',3.62),('8348','2013-08-20','14:00:00',3.58),('8348','2013-08-20','14:05:00',3.46),('8348','2013-08-20','14:10:00',3.02),('8348','2013-08-20','14:15:00',3.51),('8348','2013-08-20','14:20:00',3.54),('8348','2013-08-20','14:25:00',3.03),('8348','2013-08-20','14:30:00',2.86),('8348','2013-08-20','14:35:00',2.88),('8348','2013-08-20','14:40:00',3.36),('8348','2013-08-20','14:45:00',3.36),('8348','2013-08-20','14:50:00',3.44),('8348','2013-08-20','14:55:00',3.33),('8348','2013-08-20','15:00:00',2.94),('8348','2013-08-20','15:05:00',3.56),('8348','2013-08-20','15:10:00',3.46),('8348','2013-08-20','15:15:00',3.47),('8348','2013-08-20','15:20:00',3.4),('8348','2013-08-20','15:25:00',3.37),('8348','2013-08-20','15:30:00',3.35),('8348','2013-08-20','15:35:00',3.33),('8348','2013-08-20','15:40:00',3.39),('8348','2013-08-20','15:45:00',3.51),('8348','2013-08-20','15:50:00',3.64),('8348','2013-08-20','15:55:00',3.65),('8348','2013-08-20','16:00:00',3.47),('8348','2013-08-20','16:05:00',3.41),('8348','2013-08-20','16:10:00',3.36),('8348','2013-08-20','16:15:00',3.35),('8348','2013-08-20','16:20:00',3.3),('8348','2013-08-20','16:25:00',3.2),('8348','2013-08-20','16:30:00',2.88),('8348','2013-08-20','16:35:00',2.91),('8348','2013-08-20','16:40:00',3.02),('8348','2013-08-20','16:45:00',2.89),('8348','2013-08-20','16:50:00',2.73),('8348','2013-08-20','16:55:00',2.55),('8348','2013-08-20','17:00:00',2.39),('8348','2013-08-20','17:05:00',2.29),('8348','2013-08-20','17:10:00',2.21),('8348','2013-08-20','17:15:00',2.07),('8348','2013-08-20','17:20:00',2.04),('8348','2013-08-20','17:25:00',1.96),('8348','2013-08-20','17:30:00',1.9),('8348','2013-08-20','17:35:00',1.83),('8348','2013-08-20','17:40:00',1.76),('8348','2013-08-20','17:45:00',1.71),('8348','2013-08-20','17:50:00',1.56),('8348','2013-08-20','17:55:00',1.44),('8348','2013-08-20','18:00:00',1.32),('8348','2013-08-20','18:05:00',1.31),('8348','2013-08-20','18:10:00',1.32),('8348','2013-08-20','18:15:00',1.31),('8348','2013-08-20','18:20:00',1.28),('8348','2013-08-20','18:25:00',1.23),('8348','2013-08-20','18:30:00',1.21),('8348','2013-08-20','18:35:00',1.11),('8348','2014-04-10','07:05:00',1.06),('8348','2014-04-10','07:10:00',1.14),('8348','2014-04-10','07:15:00',1.24),('8348','2014-04-10','07:20:00',1.37),('8348','2014-04-10','07:25:00',1.63),('8348','2014-04-10','07:30:00',1.73),('8348','2014-04-10','07:35:00',1.84),('8348','2014-04-10','07:40:00',1.98),('8348','2014-04-10','07:45:00',2.13),('8348','2014-04-10','07:50:00',2.24),('8348','2014-04-10','07:55:00',2.32),('8348','2014-04-10','08:00:00',2.46),('8348','2014-04-10','08:05:00',2.68),('8348','2014-04-10','08:10:00',3.12),('8348','2014-04-10','08:15:00',3.31),('8348','2014-04-10','08:20:00',3.4),('8348','2014-04-10','08:25:00',3.71),('8348','2014-04-10','08:30:00',3.91),('8348','2014-04-10','08:35:00',4.09),('8348','2014-04-10','08:40:00',4.2),('8348','2014-04-10','08:45:00',4.34),('8348','2014-04-10','08:50:00',4.5),('8348','2014-04-10','08:55:00',4.64),('8348','2014-04-10','09:00:00',4.75),('8348','2014-04-10','09:05:00',4.85),('8348','2014-04-10','09:10:00',5.03),('8348','2014-04-10','09:15:00',5.06),('8348','2014-04-10','09:20:00',5.21),('8348','2014-04-10','09:25:00',5.29),('8348','2014-04-10','09:30:00',5.38),('8348','2014-04-10','09:35:00',5.6),('8348','2014-04-10','09:40:00',5.71),('8348','2014-04-10','09:45:00',5.74),('8348','2014-04-10','09:50:00',5.66),('8348','2014-04-10','09:55:00',5.83),('8348','2014-04-10','10:00:00',5.9),('8348','2014-04-10','10:05:00',6.11),('8348','2014-04-10','10:10:00',6.01),('8348','2014-04-10','10:15:00',6.24),('8348','2014-04-10','10:20:00',6.43),('8348','2014-04-10','10:25:00',6.57),('8348','2014-04-10','10:30:00',6.62),('8348','2014-04-10','10:35:00',6.7),('8348','2014-04-10','10:40:00',6.49),('8348','2014-04-10','10:45:00',6.71),('8348','2014-04-10','10:50:00',6.53),('8348','2014-04-10','10:55:00',6.85),('8348','2014-04-10','11:00:00',6.73),('8348','2014-04-10','11:05:00',6.36),('8348','2014-04-10','11:10:00',6.68),('8348','2014-04-10','11:15:00',6.73),('8348','2014-04-10','11:20:00',6.85),('8348','2014-04-10','11:25:00',6.52),('8348','2014-04-10','11:30:00',6.69),('8348','2014-04-10','11:35:00',7.08),('8348','2014-04-10','11:40:00',6.83),('8348','2014-04-10','11:45:00',7.01),('8348','2014-04-10','11:50:00',6.93),('8348','2014-04-10','11:55:00',6.89),('8348','2014-04-10','12:00:00',6.76),('8348','2014-04-10','12:05:00',6.6),('8348','2014-04-10','12:10:00',6.76),('8348','2014-04-10','12:15:00',6.73),('8348','2014-04-10','12:20:00',6.56),('8348','2014-04-10','12:25:00',7.11),('8348','2014-04-10','12:30:00',7.04),('8348','2014-04-10','12:35:00',7.2),('8348','2014-04-10','12:40:00',6.88),('8348','2014-04-10','12:45:00',7.21),('8348','2014-04-10','12:50:00',7.18),('8348','2014-04-10','12:55:00',7.14),('8348','2014-04-10','13:00:00',7.14),('8348','2014-04-10','13:05:00',7.07),('8348','2014-04-10','13:10:00',7.09),('8348','2014-04-10','13:15:00',7.1),('8348','2014-04-10','13:20:00',7.09),('8348','2014-04-10','13:25:00',6.99),('8348','2014-04-10','13:30:00',6.92),('8348','2014-04-10','13:35:00',6.89),('8348','2014-04-10','13:40:00',6.79),('8348','2014-04-10','13:45:00',6.17),('8348','2014-04-10','13:50:00',6.84),('8348','2014-04-10','13:55:00',6.78),('8348','2014-04-10','14:00:00',6.83),('8348','2014-04-10','14:05:00',6.77),('8348','2014-04-10','14:10:00',6.59),('8348','2014-04-10','14:15:00',6.55),('8348','2014-04-10','14:20:00',6.47),('8348','2014-04-10','14:25:00',6.41),('8348','2014-04-10','14:30:00',5.85),('8348','2014-04-10','14:35:00',5.69),('8348','2014-04-10','14:40:00',5.81),('8348','2014-04-10','14:45:00',5.81),('8348','2014-04-10','14:50:00',5.9),('8348','2014-04-10','14:55:00',5.86),('8348','2014-04-10','15:00:00',5.66),('8348','2014-04-10','15:05:00',5.78),('8348','2014-04-10','15:10:00',5.85),('8348','2014-04-10','15:15:00',6),('8348','2014-04-10','15:20:00',5.71),('8348','2014-04-10','15:25:00',5.69),('8348','2014-04-10','15:30:00',5.62),('8348','2014-04-10','15:35:00',5.44),('8348','2014-04-10','15:40:00',5.41),('8348','2014-04-10','15:45:00',5.39),('8348','2014-04-10','15:50:00',5.06),('8348','2014-04-10','15:55:00',4.91),('8348','2014-04-10','16:00:00',4.75),('8348','2014-04-10','16:05:00',4.63),('8348','2014-04-10','16:10:00',4.41),('8348','2014-04-10','16:15:00',4.19),('8348','2014-04-10','16:20:00',4.11),('8348','2014-04-10','16:25:00',3.9),('8348','2014-04-10','16:30:00',3.66),('8348','2014-04-10','16:35:00',3.52),('8348','2014-04-10','16:40:00',3.35),('8348','2014-04-10','16:45:00',3.18),('8348','2014-04-10','16:50:00',3),('8348','2014-04-10','16:55:00',2.82),('8348','2014-04-10','17:00:00',2.65),('8348','2014-04-10','17:05:00',2.47),('8348','2014-04-10','17:10:00',2.3),('8348','2014-04-10','17:15:00',2.14),('8348','2014-04-10','17:20:00',1.98),('8348','2014-04-10','17:25:00',1.8),('8348','2014-04-10','17:30:00',1.63),('8348','2014-04-10','17:35:00',1.41),('8348','2014-04-10','17:40:00',1.27),('8348','2014-04-10','17:45:00',1.06),('8348','2013-08-19','08:35:00',1.02),('8348','2013-08-19','08:40:00',1.08),('8348','2013-08-19','08:45:00',1.17),('8348','2013-08-19','08:50:00',1.27),('8348','2013-08-19','08:55:00',1.33),('8348','2013-08-19','09:00:00',1.44),('8348','2013-08-19','09:05:00',1.52),('8348','2013-08-19','09:10:00',1.58),('8348','2013-08-19','09:15:00',1.63),('8348','2013-08-19','09:20:00',1.7),('8348','2013-08-19','09:25:00',1.78),('8348','2013-08-19','09:30:00',1.85),('8348','2013-08-19','09:35:00',1.87),('8348','2013-08-19','09:40:00',1.94),('8348','2013-08-19','09:45:00',2.01),('8348','2013-08-19','09:50:00',2.06),('8348','2013-08-19','09:55:00',2.13),('8348','2013-08-19','10:00:00',2.18),('8348','2013-08-19','10:05:00',2.23),('8348','2013-08-19','10:10:00',2.28),('8348','2013-08-19','10:15:00',2.32),('8348','2013-08-19','10:20:00',2.38),('8348','2013-08-19','10:25:00',2.44),('8348','2013-08-19','10:30:00',2.5),('8348','2013-08-19','10:35:00',2.53),('8348','2013-08-19','10:40:00',2.57),('8348','2013-08-19','10:45:00',2.61),('8348','2013-08-19','10:50:00',2.64),('8348','2013-08-19','10:55:00',2.68),('8348','2013-08-19','11:00:00',2.68),('8348','2013-08-19','11:05:00',2.74),('8348','2013-08-19','11:10:00',2.78),('8348','2013-08-19','11:15:00',2.81),('8348','2013-08-19','11:20:00',2.85),('8348','2013-08-19','11:25:00',2.88),('8348','2013-08-19','11:30:00',2.91),('8348','2013-08-19','11:35:00',2.94),('8348','2013-08-19','11:40:00',2.95),('8348','2013-08-19','11:45:00',2.97),('8348','2013-08-19','11:50:00',3.01),('8348','2013-08-19','11:55:00',3),('8348','2013-08-19','12:00:00',3),('8348','2013-08-19','12:05:00',3.1),('8348','2013-08-19','12:10:00',3.12),('8348','2013-08-19','12:15:00',3.19),('8348','2013-08-19','12:20:00',3.21),('8348','2013-08-19','12:25:00',3.2),('8348','2013-08-19','12:30:00',3.23),('8348','2013-08-19','12:35:00',3.23),('8348','2013-08-19','12:40:00',3.23),('8348','2013-08-19','12:45:00',3.26),('8348','2013-08-19','12:50:00',3.27),('8348','2013-08-19','12:55:00',3.32),('8348','2013-08-19','13:00:00',3.34),('8348','2013-08-19','13:05:00',3.38),('8348','2013-08-19','13:10:00',3.38),('8348','2013-08-19','13:15:00',3.38),('8348','2013-08-19','13:20:00',3.41),('8348','2013-08-19','13:25:00',3.39),('8348','2013-08-19','13:30:00',3.42),('8348','2013-08-19','13:35:00',3.46),('8348','2013-08-19','13:40:00',3.45),('8348','2013-08-19','13:45:00',3.45),('8348','2013-08-19','13:50:00',3.46),('8348','2013-08-19','13:55:00',3.44),('8348','2013-08-19','14:00:00',3.41),('8348','2013-08-19','14:05:00',3.4),('8348','2013-08-19','14:10:00',3.41),('8348','2013-08-19','14:15:00',3.39),('8348','2013-08-19','14:20:00',3.4),('8348','2013-08-19','14:25:00',3.39),('8348','2013-08-19','14:30:00',3.41),('8348','2013-08-19','14:35:00',3.4),('8348','2013-08-19','14:40:00',3.37),('8348','2013-08-19','14:45:00',3.36),('8348','2013-08-19','14:50:00',3.33),('8348','2013-08-19','14:55:00',3.32),('8348','2013-08-19','15:00:00',3.29),('8348','2013-08-19','15:05:00',3.26),('8348','2013-08-19','15:10:00',3.23),('8348','2013-08-19','15:15:00',3.19),('8348','2013-08-19','15:20:00',3.17),('8348','2013-08-19','15:25:00',3.15),('8348','2013-08-19','15:30:00',3.11),('8348','2013-08-19','15:35:00',3.1),('8348','2013-08-19','15:40:00',3.07),('8348','2013-08-19','15:45:00',3.03),('8348','2013-08-19','15:50:00',2.98),('8348','2013-08-19','15:55:00',2.95),('8348','2013-08-19','16:00:00',2.9),('8348','2013-08-19','16:05:00',2.81),('8348','2013-08-19','16:10:00',2.74),('8348','2013-08-19','16:15:00',2.63),('8348','2013-08-19','16:20:00',2.71),('8348','2013-08-19','16:25:00',2.65),('8348','2013-08-19','16:30:00',2.6),('8348','2013-08-19','16:35:00',2.54),('8348','2013-08-19','16:40:00',2.48),('8348','2013-08-19','16:45:00',2.44),('8348','2013-08-19','16:50:00',2.38),('8348','2013-08-19','16:55:00',2.34),('8348','2013-08-19','17:00:00',2.27),('8348','2013-08-19','17:05:00',2.2),('8348','2013-08-19','17:10:00',2.14),('8348','2013-08-19','17:15:00',2.07),('8348','2013-08-19','17:20:00',2.01),('8348','2013-08-19','17:25:00',1.94),('8348','2013-08-19','17:30:00',1.87),('8348','2013-08-19','17:35:00',1.8),('8348','2013-08-19','17:40:00',1.74),('8348','2013-08-19','17:45:00',1.67),('8348','2013-08-19','17:50:00',1.59),('8348','2013-08-19','17:55:00',1.52),('8348','2013-08-19','18:00:00',1.45),('8348','2013-08-19','18:05:00',1.37),('8348','2013-08-19','18:10:00',1.3),('8348','2013-08-19','18:15:00',1.22),('8348','2013-08-19','18:20:00',1.14),('8348','2013-08-19','18:25:00',1.06),('8348','2013-08-18','08:30:00',1.01),('8348','2013-08-18','08:35:00',1.07),('8348','2013-08-18','08:40:00',1.14),('8348','2013-08-18','08:45:00',1.22),('8348','2013-08-18','08:50:00',1.32),('8348','2013-08-18','08:55:00',1.39),('8348','2013-08-18','09:00:00',1.47),('8348','2013-08-18','09:05:00',1.56),('8348','2013-08-18','09:10:00',1.63),('8348','2013-08-18','09:15:00',1.7),('8348','2013-08-18','09:20:00',1.76),('8348','2013-08-18','09:25:00',1.83),('8348','2013-08-18','09:30:00',1.91),('8348','2013-08-18','09:35:00',1.96),('8348','2013-08-18','09:40:00',2.05),('8348','2013-08-18','09:45:00',1.96),('8348','2013-08-18','09:50:00',2.11),('8348','2013-08-18','09:55:00',1.61),('8348','2013-08-18','10:00:00',2.16),('8348','2013-08-18','10:05:00',1.8),('8348','2013-08-18','10:10:00',2.22),('8348','2013-08-18','10:15:00',2.39),('8348','2013-08-18','10:20:00',2.43),('8348','2013-08-18','10:25:00',2.47),('8348','2013-08-18','10:30:00',2.51),('8348','2013-08-18','10:35:00',2.54),('8348','2013-08-18','10:40:00',2.56),('8348','2013-08-18','10:45:00',2.62),('8348','2013-08-18','10:50:00',2.65),('8348','2013-08-18','10:55:00',2.59),('8348','2013-08-18','11:00:00',2.65),('8348','2013-08-18','11:05:00',2.77),('8348','2013-08-18','11:10:00',2.8),('8348','2013-08-18','11:15:00',2.83),('8348','2013-08-18','11:20:00',2.86),('8348','2013-08-18','11:25:00',2.86),('8348','2013-08-18','11:30:00',2.87),('8348','2013-08-18','11:35:00',2.9),('8348','2013-08-18','11:40:00',2.95),('8348','2013-08-18','11:45:00',3),('8348','2013-08-18','11:50:00',3),('8348','2013-08-18','11:55:00',3.02),('8348','2013-08-18','12:00:00',3.01),('8348','2013-08-18','12:05:00',2.98),('8348','2013-08-18','12:10:00',3.06),('8348','2013-08-18','12:15:00',3.26),('8348','2013-08-18','12:20:00',3.33),('8348','2013-08-18','12:25:00',2.9),('8348','2013-08-18','12:30:00',2.11),('8348','2013-08-18','12:45:00',2.69),('8348','2013-08-18','12:50:00',2.38),('8348','2013-08-18','12:55:00',1.28),('8348','2013-08-18','13:00:00',1.6),('8348','2013-08-18','13:05:00',3.59),('8348','2013-08-18','13:10:00',3.53),('8348','2013-08-18','13:15:00',3.31),('8348','2013-08-18','13:20:00',3.44),('8348','2013-08-18','13:25:00',3.38),('8348','2013-08-18','13:30:00',3.38),('8348','2013-08-18','13:35:00',3.36),('8348','2013-08-18','13:40:00',3.41),('8348','2013-08-18','13:45:00',2.98),('8348','2013-08-18','13:50:00',3.46),('8348','2013-08-18','13:55:00',3.39),('8348','2013-08-18','14:00:00',3.48),('8348','2013-08-18','14:05:00',3.43),('8348','2013-08-18','14:10:00',3.41),('8348','2013-08-18','14:15:00',3.39),('8348','2013-08-18','14:20:00',3.4),('8348','2013-08-18','14:25:00',3.37),('8348','2013-08-18','14:30:00',3.38),('8348','2013-08-18','14:35:00',3.37),('8348','2013-08-18','14:40:00',3.34),('8348','2013-08-18','14:45:00',3.32),('8348','2013-08-18','14:50:00',3.32),('8348','2013-08-18','14:55:00',3.3),('8348','2013-08-18','15:00:00',3.29),('8348','2013-08-18','15:05:00',3.25),('8348','2013-08-18','15:10:00',3.23),('8348','2013-08-18','15:15:00',3.2),('8348','2013-08-18','15:20:00',3.16),('8348','2013-08-18','15:25:00',3.13),('8348','2013-08-18','15:30:00',3.1),('8348','2013-08-18','15:35:00',3.07),('8348','2013-08-18','15:40:00',3.05),('8348','2013-08-18','15:45:00',3),('8348','2013-08-18','15:50:00',2.95),('8348','2013-08-18','15:55:00',2.91),('8348','2013-08-18','16:00:00',2.88),('8348','2013-08-18','16:05:00',2.84),('8348','2013-08-18','16:10:00',2.78),('8348','2013-08-18','16:15:00',2.75),('8348','2013-08-18','16:20:00',2.69),('8348','2013-08-18','16:25:00',2.64),('8348','2013-08-18','16:30:00',2.59),('8348','2013-08-18','16:35:00',2.56),('8348','2013-08-18','16:40:00',2.49),('8348','2013-08-18','16:45:00',2.43),('8348','2013-08-18','16:50:00',2.38),('8348','2013-08-18','16:55:00',2.32),('8348','2013-08-18','17:00:00',2.28),('8348','2013-08-18','17:05:00',2.22),('8348','2013-08-18','17:10:00',2.15),('8348','2013-08-18','17:15:00',2.09),('8348','2013-08-18','17:20:00',2.03),('8348','2013-08-18','17:25:00',1.97),('8348','2013-08-18','17:30:00',1.89),('8348','2013-08-18','17:35:00',1.82),('8348','2013-08-18','17:40:00',1.75),('8348','2013-08-18','17:45:00',1.67),('8348','2013-08-18','17:50:00',1.6),('8348','2013-08-18','17:55:00',1.52),('8348','2013-08-18','18:00:00',1.44),('8348','2013-08-18','18:05:00',1.38),('8348','2013-08-18','18:10:00',1.31),('8348','2013-08-18','18:15:00',1.23),('8348','2013-08-18','18:20:00',1.15),('8348','2013-08-18','18:25:00',1.07),('8348','2013-08-17','08:35:00',1.04),('8348','2013-08-17','08:40:00',1.13),('8348','2013-08-17','08:45:00',1.21),('8348','2013-08-17','08:50:00',1.31),('8348','2013-08-17','08:55:00',1.39),('8348','2013-08-17','09:00:00',1.48),('8348','2013-08-17','09:05:00',1.56),('8348','2013-08-17','09:10:00',1.62),('8348','2013-08-17','09:15:00',1.68),('8348','2013-08-17','09:20:00',1.74),('8348','2013-08-17','09:25:00',1.81),('8348','2013-08-17','09:30:00',1.88),('8348','2013-08-17','09:35:00',1.94),('8348','2013-08-17','09:40:00',2),('8348','2013-08-17','09:45:00',2.06),('8348','2013-08-17','09:50:00',2.11),('8348','2013-08-17','09:55:00',2.16),('8348','2013-08-17','10:00:00',2.22),('8348','2013-08-17','10:05:00',2.27),('8348','2013-08-17','10:10:00',2.32),('8348','2013-08-17','10:15:00',2.36),('8348','2013-08-17','10:20:00',2.42),('8348','2013-08-17','10:25:00',2.46),('8348','2013-08-17','10:30:00',2.51),('8348','2013-08-17','10:35:00',2.57),('8348','2013-08-17','10:40:00',2.61),('8348','2013-08-17','10:45:00',2.65),('8348','2013-08-17','10:50:00',2.69),('8348','2013-08-17','10:55:00',2.72),('8348','2013-08-17','11:00:00',2.75),('8348','2013-08-17','11:05:00',2.8),('8348','2013-08-17','11:10:00',2.83),('8348','2013-08-17','11:15:00',2.83),('8348','2013-08-17','11:20:00',2.87),('8348','2013-08-17','11:25:00',2.9),('8348','2013-08-17','11:30:00',2.94),('8348','2013-08-17','11:35:00',2.97),('8348','2013-08-17','11:40:00',3.03),('8348','2013-08-17','11:45:00',3.08),('8348','2013-08-17','11:50:00',3.13),('8348','2013-08-17','11:55:00',3.08),('8348','2013-08-17','12:00:00',3.09),('8348','2013-08-17','12:05:00',3.14),('8348','2013-08-17','12:10:00',3.15),('8348','2013-08-17','12:15:00',2.96),('8348','2013-08-17','12:20:00',1.98),('8348','2013-08-17','12:25:00',3.17),('8348','2013-08-17','12:30:00',3.29),('8348','2013-08-17','12:35:00',2.52),('8348','2013-08-17','12:40:00',1.57),('8348','2013-08-17','12:45:00',3.44),('8348','2013-08-17','12:50:00',3.43),('8348','2013-08-17','12:55:00',3.4),('8348','2013-08-17','13:00:00',3.48),('8348','2013-08-17','13:05:00',3.47),('8348','2013-08-17','13:10:00',3.41),('8348','2013-08-17','13:15:00',3.39),('8348','2013-08-17','13:20:00',3.47),('8348','2013-08-17','13:25:00',3.44),('8348','2013-08-17','13:30:00',3.53),('8348','2013-08-17','13:35:00',2.75),('8348','2013-08-17','13:45:00',2.17),('8348','2013-08-17','13:55:00',2.47),('8348','2013-08-17','14:00:00',3.68),('8348','2013-08-17','14:05:00',2.56),('8348','2013-08-17','14:10:00',3.52),('8348','2013-08-17','14:15:00',3.22),('8348','2013-08-17','14:20:00',3.41),('8348','2013-08-17','14:25:00',3.39),('8348','2013-08-17','14:30:00',3.37),('8348','2013-08-17','14:35:00',3.34),('8348','2013-08-17','14:40:00',3.31),('8348','2013-08-17','14:45:00',3.35),('8348','2013-08-17','14:50:00',3.32),('8348','2013-08-17','14:55:00',3.25),('8348','2013-08-17','15:00:00',3.28),('8348','2013-08-17','15:05:00',3.26),('8348','2013-08-17','15:10:00',3.22),('8348','2013-08-17','15:15:00',3.18),('8348','2013-08-17','15:20:00',3.19),('8348','2013-08-17','15:25:00',3.13),('8348','2013-08-17','15:30:00',3.11),('8348','2013-08-17','15:35:00',3.11),('8348','2013-08-17','15:40:00',3.07),('8348','2013-08-17','15:45:00',3.01),('8348','2013-08-17','15:50:00',2.97),('8348','2013-08-17','15:55:00',2.95),('8348','2013-08-17','16:00:00',2.92),('8348','2013-08-17','16:05:00',2.85),('8348','2013-08-17','16:10:00',2.82),('8348','2013-08-17','16:15:00',2.79),('8348','2013-08-17','16:20:00',2.74),('8348','2013-08-17','16:25:00',2.69),('8348','2013-08-17','16:30:00',2.67),('8348','2013-08-17','16:35:00',2.63),('8348','2013-08-17','16:40:00',2.55),('8348','2013-08-17','16:45:00',2.46),('8348','2013-08-17','16:50:00',2.39),('8348','2013-08-17','16:55:00',2.39),('8348','2013-08-17','17:00:00',2.33),('8348','2013-08-17','17:05:00',2.25),('8348','2013-08-17','17:10:00',2.13),('8348','2013-08-17','17:15:00',1.92),('8348','2013-08-17','17:20:00',1.99),('8348','2013-08-17','17:25:00',2.03),('8348','2013-08-17','17:30:00',2),('8348','2013-08-17','17:35:00',1.94),('8348','2013-08-17','17:40:00',1.86),('8348','2013-08-17','17:45:00',1.78),('8348','2013-08-17','17:50:00',1.68),('8348','2013-08-17','17:55:00',1.62),('8348','2013-08-17','18:00:00',1.54),('8348','2013-08-17','18:05:00',1.46),('8348','2013-08-17','18:10:00',1.37),('8348','2013-08-17','18:15:00',1.28),('8348','2013-08-17','18:20:00',1.21),('8348','2013-08-17','18:25:00',1.13),('8348','2013-08-17','18:30:00',1.05),('8348','2013-08-16','08:30:00',1.03),('8348','2013-08-16','08:35:00',1.07),('8348','2013-08-16','08:40:00',1.18),('8348','2013-08-16','08:45:00',1.26),('8348','2013-08-16','08:50:00',1.34),('8348','2013-08-16','08:55:00',1.43),('8348','2013-08-16','09:00:00',1.53),('8348','2013-08-16','09:05:00',1.6),('8348','2013-08-16','09:10:00',1.68),('8348','2013-08-16','09:15:00',1.75),('8348','2013-08-16','09:20:00',1.82),('8348','2013-08-16','09:25:00',1.89),('8348','2013-08-16','09:30:00',1.96),('8348','2013-08-16','09:35:00',2.03),('8348','2013-08-16','09:40:00',2.09),('8348','2013-08-16','09:45:00',2.15),('8348','2013-08-16','09:50:00',2.21),('8348','2013-08-16','09:55:00',2.27),('8348','2013-08-16','10:00:00',2.32),('8348','2013-08-16','10:05:00',2.37),('8348','2013-08-16','10:10:00',2.44),('8348','2013-08-16','10:15:00',2.49),('8348','2013-08-16','10:20:00',2.54),('8348','2013-08-16','10:25:00',2.59),('8348','2013-08-16','10:30:00',2.64),('8348','2013-08-16','10:35:00',2.69),('8348','2013-08-16','10:40:00',2.73),('8348','2013-08-16','10:45:00',2.77),('8348','2013-08-16','10:50:00',2.8),('8348','2013-08-16','10:55:00',2.84),('8348','2013-08-16','11:00:00',2.89),('8348','2013-08-16','11:05:00',2.92),('8348','2013-08-16','11:10:00',2.96),('8348','2013-08-16','11:15:00',2.98),('8348','2013-08-16','11:20:00',3.01),('8348','2013-08-16','11:25:00',3.03),('8348','2013-08-16','11:30:00',3.05),('8348','2013-08-16','11:35:00',3.09),('8348','2013-08-16','11:40:00',3.11),('8348','2013-08-16','11:45:00',3.12),('8348','2013-08-16','11:50:00',3.14),('8348','2013-08-16','11:55:00',3.15),('8348','2013-08-16','12:00:00',3.17),('8348','2013-08-16','12:05:00',3.2),('8348','2013-08-16','12:10:00',3.23),('8348','2013-08-16','12:15:00',3.23),('8348','2013-08-16','12:20:00',3.25),('8348','2013-08-16','12:25:00',3.26),('8348','2013-08-16','12:30:00',3.28),('8348','2013-08-16','12:35:00',3.28),('8348','2013-08-16','12:40:00',3.28),('8348','2013-08-16','12:45:00',3.29),('8348','2013-08-16','12:50:00',3.28),('8348','2013-08-16','12:55:00',3.29),('8348','2013-08-16','13:00:00',3.31),('8348','2013-08-16','13:05:00',3.3),('8348','2013-08-16','13:10:00',3.3),('8348','2013-08-16','13:15:00',3.29),('8348','2013-08-16','13:20:00',3.32),('8348','2013-08-16','13:25:00',3.32),('8348','2013-08-16','13:30:00',3.33),('8348','2013-08-16','13:35:00',3.33),('8348','2013-08-16','13:40:00',3.31),('8348','2013-08-16','13:45:00',3.31),('8348','2013-08-16','13:50:00',3.31),('8348','2013-08-16','13:55:00',3.3),('8348','2013-08-16','14:00:00',3.29),('8348','2013-08-16','14:05:00',3.28),('8348','2013-08-16','14:10:00',3.26),('8348','2013-08-16','14:15:00',3.26),('8348','2013-08-16','14:20:00',3.26),('8348','2013-08-16','14:25:00',3.24),('8348','2013-08-16','14:30:00',3.21),('8348','2013-08-16','14:35:00',3.18),('8348','2013-08-16','14:40:00',3.18),('8348','2013-08-16','14:45:00',3.19),('8348','2013-08-16','14:50:00',3.19),('8348','2013-08-16','14:55:00',3.15),('8348','2013-08-16','15:00:00',3.1),('8348','2013-08-16','15:05:00',3.11),('8348','2013-08-16','15:10:00',3.15),('8348','2013-08-16','15:15:00',3.12),('8348','2013-08-16','15:20:00',3.12),('8348','2013-08-16','15:25:00',3.13),('8348','2013-08-16','15:30:00',3.11),('8348','2013-08-16','15:35:00',3.08),('8348','2013-08-16','15:40:00',3.02),('8348','2013-08-16','15:45:00',3.01),('8348','2013-08-16','15:50:00',2.99),('8348','2013-08-16','15:55:00',2.95),('8348','2013-08-16','16:00:00',2.91),('8348','2013-08-16','16:05:00',2.88),('8348','2013-08-16','16:10:00',2.83),('8348','2013-08-16','16:15:00',2.77),('8348','2013-08-16','16:20:00',2.72),('8348','2013-08-16','16:25:00',2.68),('8348','2013-08-16','16:30:00',2.64),('8348','2013-08-16','16:35:00',2.6),('8348','2013-08-16','16:40:00',2.55),('8348','2013-08-16','16:45:00',2.49),('8348','2013-08-16','16:50:00',2.43),('8348','2013-08-16','16:55:00',2.37),('8348','2013-08-16','17:00:00',2.3),('8348','2013-08-16','17:05:00',2.24),('8348','2013-08-16','17:10:00',2.17),('8348','2013-08-16','17:15:00',2.1),('8348','2013-08-16','17:20:00',2.04),('8348','2013-08-16','17:25:00',1.97),('8348','2013-08-16','17:30:00',1.89),('8348','2013-08-16','17:35:00',1.83),('8348','2013-08-16','17:40:00',1.77),('8348','2013-08-16','17:45:00',1.69),('8348','2013-08-16','17:50:00',1.62),('8348','2013-08-16','17:55:00',1.54),('8348','2013-08-16','18:00:00',1.46),('8348','2013-08-16','18:05:00',1.39),('8348','2013-08-16','18:10:00',1.32),('8348','2013-08-16','18:15:00',1.25),('8348','2013-08-16','18:20:00',1.18),('8348','2013-08-16','18:25:00',1.1),('8348','2013-08-15','08:30:00',1.06),('8348','2013-08-15','08:35:00',1.1),('8348','2013-08-15','08:40:00',1.2),('8348','2013-08-15','08:45:00',1.3),('8348','2013-08-15','08:50:00',1.37),('8348','2013-08-15','08:55:00',1.47),('8348','2013-08-15','09:00:00',1.63),('8348','2013-08-15','09:05:00',1.56),('8348','2013-08-15','09:10:00',1.57),('8348','2013-08-15','09:15:00',1.5),('8348','2013-08-15','09:20:00',1.9),('8348','2013-08-15','09:25:00',1.85),('8348','2013-08-15','09:30:00',1.95),('8348','2013-08-15','09:35:00',2.02),('8348','2013-08-15','09:40:00',2.09),('8348','2013-08-15','09:45:00',2.16),('8348','2013-08-15','09:50:00',2.21),('8348','2013-08-15','09:55:00',2.27),('8348','2013-08-15','10:00:00',2.33),('8348','2013-08-15','10:05:00',2.39),('8348','2013-08-15','10:10:00',2.44),('8348','2013-08-15','10:15:00',2.49),('8348','2013-08-15','10:20:00',2.55),('8348','2013-08-15','10:25:00',2.61),('8348','2013-08-15','10:30:00',2.66),('8348','2013-08-15','10:35:00',2.69),('8348','2013-08-15','10:40:00',2.73),('8348','2013-08-15','10:45:00',2.79),('8348','2013-08-15','10:50:00',2.78),('8348','2013-08-15','10:55:00',2.58),('8348','2013-08-15','11:00:00',2.38),('8348','2013-08-15','11:05:00',2.57),('8348','2013-08-15','11:10:00',1.98),('8348','2013-08-15','11:15:00',1.95),('8348','2013-08-15','11:20:00',2.27),('8348','2013-08-15','11:25:00',2.7),('8348','2013-08-15','11:30:00',2.99),('8348','2013-08-15','11:35:00',3.24),('8348','2013-08-15','11:40:00',3.32),('8348','2013-08-15','11:45:00',3.4),('8348','2013-08-15','11:50:00',3.44),('8348','2013-08-15','11:55:00',3.46),('8348','2013-08-15','12:00:00',3.46),('8348','2013-08-15','12:05:00',3.43),('8348','2013-08-15','12:10:00',3.42),('8348','2013-08-15','12:15:00',3.4),('8348','2013-08-15','12:20:00',3.45),('8348','2013-08-15','12:25:00',3.44),('8348','2013-08-15','12:30:00',3.44),('8348','2013-08-15','12:35:00',3.46),('8348','2013-08-15','12:40:00',3.45),('8348','2013-08-15','12:45:00',3.45),('8348','2013-08-15','12:50:00',3.43),('8348','2013-08-15','12:55:00',3.35),('8348','2013-08-15','13:00:00',3.25),('8348','2013-08-15','13:05:00',3.33),('8348','2013-08-15','13:10:00',3.32),('8348','2013-08-15','13:15:00',3.28),('8348','2013-08-15','13:20:00',3.25),('8348','2013-08-15','13:25:00',3.33),('8348','2013-08-15','13:30:00',3.42),('8348','2013-08-15','13:35:00',3.47),('8348','2013-08-15','13:40:00',3.46),('8348','2013-08-15','13:45:00',3.43),('8348','2013-08-15','13:50:00',3.39),('8348','2013-08-15','13:55:00',3.33),('8348','2013-08-15','14:00:00',3.32),('8348','2013-08-15','14:05:00',3.34),('8348','2013-08-15','14:10:00',3.35),('8348','2013-08-15','14:15:00',3.37),('8348','2013-08-15','14:20:00',3.37),('8348','2013-08-15','14:25:00',3.33),('8348','2013-08-15','14:30:00',3.26),('8348','2013-08-15','14:35:00',3.28),('8348','2013-08-15','14:40:00',3.25),('8348','2013-08-15','14:45:00',3.24),('8348','2013-08-15','14:50:00',3.21),('8348','2013-08-15','14:55:00',3.15),('8348','2013-08-15','15:00:00',3.11),('8348','2013-08-15','15:05:00',3.1),('8348','2013-08-15','15:10:00',3.1),('8348','2013-08-15','15:15:00',3.09),('8348','2013-08-15','15:20:00',3.05),('8348','2013-08-15','15:25:00',3),('8348','2013-08-15','15:30:00',2.99),('8348','2013-08-15','15:35:00',2.96),('8348','2013-08-15','15:40:00',2.91),('8348','2013-08-15','15:45:00',2.86),('8348','2013-08-15','15:50:00',2.81),('8348','2013-08-15','15:55:00',2.78),('8348','2013-08-15','16:00:00',2.75),('8348','2013-08-15','16:05:00',2.7),('8348','2013-08-15','16:10:00',2.63),('8348','2013-08-15','16:15:00',2.6),('8348','2013-08-15','16:20:00',2.62),('8348','2013-08-15','16:25:00',2.54),('8348','2013-08-15','16:30:00',2.46),('8348','2013-08-15','16:35:00',2.35),('8348','2013-08-15','16:40:00',2.36),('8348','2013-08-15','16:45:00',2.32),('8348','2013-08-15','16:50:00',2.25),('8348','2013-08-15','16:55:00',2.18),('8348','2013-08-15','17:00:00',2.15),('8348','2013-08-15','17:05:00',2.11),('8348','2013-08-15','17:10:00',2.04),('8348','2013-08-15','17:15:00',2.02),('8348','2013-08-15','17:20:00',1.96),('8348','2013-08-15','17:25:00',1.84),('8348','2013-08-15','17:30:00',1.82),('8348','2013-08-15','17:35:00',1.74),('8348','2013-08-15','17:40:00',1.67),('8348','2013-08-15','17:45:00',1.6),('8348','2013-08-15','17:50:00',1.53),('8348','2013-08-15','17:55:00',1.47),('8348','2013-08-15','18:00:00',1.41),('8348','2013-08-15','18:05:00',1.33),('8348','2013-08-15','18:10:00',1.23),('8348','2013-08-15','18:15:00',1.17),('8348','2013-08-15','18:20:00',1.12),('8348','2013-08-15','18:25:00',1.04),('8348','2013-08-14','08:30:00',1.01),('8348','2013-08-14','08:35:00',1.08),('8348','2013-08-14','08:40:00',1.26),('8348','2013-08-14','08:45:00',1.27),('8348','2013-08-14','08:50:00',1.25),('8348','2013-08-14','08:55:00',1.35),('8348','2013-08-14','09:00:00',1.55),('8348','2013-08-14','09:05:00',1.64),('8348','2013-08-14','09:10:00',1.69),('8348','2013-08-14','09:15:00',1.79),('8348','2013-08-14','09:20:00',1.86),('8348','2013-08-14','09:25:00',1.82),('8348','2013-08-14','09:30:00',2),('8348','2013-08-14','09:35:00',2.16),('8348','2013-08-14','09:40:00',1.55),('8348','2013-08-14','09:45:00',1.5),('8348','2013-08-14','09:55:00',1.42),('8348','2013-08-14','10:00:00',2.46),('8348','2013-08-14','10:05:00',2.29),('8348','2013-08-14','10:10:00',2.33),('8348','2013-08-14','10:15:00',2.29),('8348','2013-08-14','10:20:00',2.31),('8348','2013-08-14','10:25:00',2.74),('8348','2013-08-14','10:30:00',2.9),('8348','2013-08-14','10:35:00',2.86),('8348','2013-08-14','10:40:00',1.5),('8348','2013-08-14','10:55:00',1.01),('8348','2013-08-14','11:00:00',1.8),('8348','2013-08-14','11:05:00',2.37),('8348','2013-08-14','11:10:00',2.9),('8348','2013-08-14','11:15:00',2.93),('8348','2013-08-14','11:20:00',2.79),('8348','2013-08-14','11:25:00',2.81),('8348','2013-08-14','11:30:00',3.4),('8348','2013-08-14','11:35:00',2.79),('8348','2013-08-14','11:40:00',2.62),('8348','2013-08-14','11:45:00',1.28),('8348','2013-08-14','11:50:00',1.93),('8348','2013-08-14','11:55:00',2.26),('8348','2013-08-14','12:00:00',2.29),('8348','2013-08-14','12:05:00',2.74),('8348','2013-08-14','12:10:00',1.4),('8348','2013-08-14','12:15:00',1.16),('8348','2013-08-14','12:20:00',1.03),('8348','2013-08-14','12:25:00',1.75),('8348','2013-08-14','12:30:00',2.51),('8348','2013-08-14','12:35:00',1.14),('8348','2013-08-14','12:40:00',1.16),('8348','2013-08-14','12:45:00',1.19),('8348','2013-08-14','12:50:00',1.64),('8348','2013-08-14','12:55:00',1.71),('8348','2013-08-14','13:00:00',1.75),('8348','2013-08-14','13:15:00',1.02),('8348','2013-08-14','13:25:00',1.58),('8348','2013-08-14','13:30:00',3.49),('8348','2013-08-14','13:35:00',1.64),('8348','2013-08-14','13:40:00',2.09),('8348','2013-08-14','13:45:00',3.86),('8348','2013-08-14','13:50:00',3.88),('8348','2013-08-14','13:55:00',1.82),('8348','2013-08-14','14:00:00',2.41),('8348','2013-08-14','14:05:00',4),('8348','2013-08-14','14:10:00',3.83),('8348','2013-08-14','14:15:00',3.68),('8348','2013-08-14','14:20:00',3.62),('8348','2013-08-14','14:25:00',2.23),('8348','2013-08-14','14:30:00',3.76),('8348','2013-08-14','14:35:00',3.65),('8348','2013-08-14','14:40:00',3.5),('8348','2013-08-14','14:45:00',3.43),('8348','2013-08-14','14:50:00',3.52),('8348','2013-08-14','14:55:00',3.2),('8348','2013-08-14','15:00:00',3.31),('8348','2013-08-14','15:05:00',3.32),('8348','2013-08-14','15:10:00',3.22),('8348','2013-08-14','15:15:00',3.35),('8348','2013-08-14','15:20:00',3.32),('8348','2013-08-14','15:25:00',3.25),('8348','2013-08-14','15:30:00',3.16),('8348','2013-08-14','15:35:00',3.09),('8348','2013-08-14','15:40:00',3.11),('8348','2013-08-14','15:45:00',3.05),('8348','2013-08-14','15:50:00',3.01),('8348','2013-08-14','15:55:00',2.97),('8348','2013-08-14','16:00:00',2.94),('8348','2013-08-14','16:05:00',2.91),('8348','2013-08-14','16:10:00',2.89),('8348','2013-08-14','16:15:00',2.86),('8348','2013-08-14','16:20:00',2.81),('8348','2013-08-14','16:25:00',2.76),('8348','2013-08-14','16:30:00',2.7),('8348','2013-08-14','16:35:00',2.66),('8348','2013-08-14','16:40:00',2.6),('8348','2013-08-14','16:45:00',2.55),('8348','2013-08-14','16:50:00',2.48),('8348','2013-08-14','16:55:00',2.43),('8348','2013-08-14','17:00:00',2.35),('8348','2013-08-14','17:05:00',2.28),('8348','2013-08-14','17:10:00',2.23),('8348','2013-08-14','17:15:00',2.15),('8348','2013-08-14','17:20:00',2.08),('8348','2013-08-14','17:25:00',2.02),('8348','2013-08-14','17:30:00',1.95),('8348','2013-08-14','17:35:00',1.89),('8348','2013-08-14','17:40:00',1.83),('8348','2013-08-14','17:45:00',1.75),('8348','2013-08-14','17:50:00',1.68),('8348','2013-08-14','17:55:00',1.6),('8348','2013-08-14','18:00:00',1.52),('8348','2013-08-14','18:05:00',1.45),('8348','2013-08-14','18:10:00',1.35),('8348','2013-08-14','18:15:00',1.27),('8348','2013-08-14','18:20:00',1.24),('8348','2013-08-14','18:25:00',1.24),('8348','2013-08-14','18:30:00',1.17),('8348','2013-08-14','18:35:00',1.03),('8348','2013-08-13','08:30:00',1.07),('8348','2013-08-13','08:35:00',1.12),('8348','2013-08-13','08:40:00',1.19),('8348','2013-08-13','08:45:00',1.3),('8348','2013-08-13','08:50:00',1.37),('8348','2013-08-13','08:55:00',1.47),('8348','2013-08-13','09:00:00',1.56),('8348','2013-08-13','09:05:00',1.62),('8348','2013-08-13','09:10:00',1.69),('8348','2013-08-13','09:15:00',1.74),('8348','2013-08-13','09:20:00',1.79),('8348','2013-08-13','09:25:00',1.86),('8348','2013-08-13','09:30:00',1.93),('8348','2013-08-13','09:35:00',2),('8348','2013-08-13','09:40:00',2.03),('8348','2013-08-13','09:45:00',2.1),('8348','2013-08-13','09:50:00',2.19),('8348','2013-08-13','09:55:00',2.27),('8348','2013-08-13','10:00:00',2.31),('8348','2013-08-13','10:05:00',2.38),('8348','2013-08-13','10:10:00',2.38),('8348','2013-08-13','10:15:00',2.44),('8348','2013-08-13','10:20:00',2.47),('8348','2013-08-13','10:25:00',2.55),('8348','2013-08-13','10:30:00',2.61),('8348','2013-08-13','10:35:00',2.63),('8348','2013-08-13','10:40:00',2.68),('8348','2013-08-13','10:45:00',2.71),('8348','2013-08-13','10:50:00',2.74),('8348','2013-08-13','10:55:00',2.78),('8348','2013-08-13','11:00:00',2.82),('8348','2013-08-13','11:05:00',2.86),('8348','2013-08-13','11:10:00',2.88),('8348','2013-08-13','11:15:00',2.89),('8348','2013-08-13','11:20:00',2.95),('8348','2013-08-13','11:25:00',2.97),('8348','2013-08-13','11:30:00',3),('8348','2013-08-13','11:35:00',3),('8348','2013-08-13','11:40:00',3.05),('8348','2013-08-13','11:45:00',3.09),('8348','2013-08-13','11:50:00',3.13),('8348','2013-08-13','11:55:00',3.21),('8348','2013-08-13','12:00:00',3.24),('8348','2013-08-13','12:05:00',3.19),('8348','2013-08-13','12:10:00',3.29),('8348','2013-08-13','12:15:00',3.08),('8348','2013-08-13','12:20:00',2.48),('8348','2013-08-13','12:25:00',3.46),('8348','2013-08-13','12:30:00',3.53),('8348','2013-08-13','12:35:00',3.51),('8348','2013-08-13','12:40:00',2.3),('8348','2013-08-13','12:45:00',3.45),('8348','2013-08-13','12:50:00',2.86),('8348','2013-08-13','12:55:00',1.1),('8348','2013-08-13','13:00:00',1.03),('8348','2013-08-13','13:05:00',1.19),('8348','2013-08-13','13:10:00',3.5),('8348','2013-08-13','13:15:00',3.04),('8348','2013-08-13','13:20:00',3.01),('8348','2013-08-13','13:25:00',3.81),('8348','2013-08-13','13:30:00',3.8),('8348','2013-08-13','13:35:00',3.75),('8348','2013-08-13','13:40:00',3.78),('8348','2013-08-13','13:45:00',1.67),('8348','2013-08-13','13:50:00',1.6),('8348','2013-08-13','13:55:00',2.67),('8348','2013-08-13','14:00:00',3.86),('8348','2013-08-13','14:05:00',3.75),('8348','2013-08-13','14:10:00',3.7),('8348','2013-08-13','14:15:00',3.69),('8348','2013-08-13','14:20:00',3.3),('8348','2013-08-13','14:25:00',3.65),('8348','2013-08-13','14:30:00',3.1),('8348','2013-08-13','14:35:00',3.79),('8348','2013-08-13','14:40:00',2.58),('8348','2013-08-13','14:45:00',3.48),('8348','2013-08-13','14:50:00',3.16),('8348','2013-08-13','14:55:00',3.46),('8348','2013-08-13','15:00:00',3.43),('8348','2013-08-13','15:05:00',3.5),('8348','2013-08-13','15:10:00',3.21),('8348','2013-08-13','15:15:00',3.31),('8348','2013-08-13','15:20:00',3.18),('8348','2013-08-13','15:25:00',3.25),('8348','2013-08-13','15:30:00',3.21),('8348','2013-08-13','15:35:00',3.21),('8348','2013-08-13','15:40:00',3.1),('8348','2013-08-13','15:45:00',3.09),('8348','2013-08-13','15:50:00',3.02),('8348','2013-08-13','15:55:00',2.98),('8348','2013-08-13','16:00:00',2.95),('8348','2013-08-13','16:05:00',2.9),('8348','2013-08-13','16:10:00',2.85),('8348','2013-08-13','16:15:00',2.82),('8348','2013-08-13','16:20:00',2.79),('8348','2013-08-13','16:25:00',2.74),('8348','2013-08-13','16:30:00',2.67),('8348','2013-08-13','16:35:00',2.63),('8348','2013-08-13','16:40:00',2.59),('8348','2013-08-13','16:45:00',2.52),('8348','2013-08-13','16:50:00',2.46),('8348','2013-08-13','16:55:00',2.4),('8348','2013-08-13','17:00:00',2.34),('8348','2013-08-13','17:05:00',2.3),('8348','2013-08-13','17:10:00',2.23),('8348','2013-08-13','17:15:00',2.15),('8348','2013-08-13','17:20:00',2.09),('8348','2013-08-13','17:25:00',2.02),('8348','2013-08-13','17:30:00',1.94),('8348','2013-08-13','17:35:00',1.88),('8348','2013-08-13','17:40:00',1.83),('8348','2013-08-13','17:45:00',1.74),('8348','2013-08-13','17:50:00',1.68),('8348','2013-08-13','17:55:00',1.6),('8348','2013-08-13','18:00:00',1.53),('8348','2013-08-13','18:05:00',1.45),('8348','2013-08-13','18:10:00',1.37),('8348','2013-08-13','18:15:00',1.29),('8348','2013-08-13','18:20:00',1.23),('8348','2013-08-13','18:25:00',1.15),('8348','2013-08-13','18:30:00',1.06),('8348','2013-08-12','08:30:00',1.05),('8348','2013-08-12','08:35:00',1.12),('8348','2013-08-12','08:40:00',1.18),('8348','2013-08-12','08:45:00',1.29),('8348','2013-08-12','08:50:00',1.37),('8348','2013-08-12','08:55:00',1.45),('8348','2013-08-12','09:00:00',1.52),('8348','2013-08-12','09:05:00',1.59),('8348','2013-08-12','09:10:00',1.66),('8348','2013-08-12','09:15:00',1.72),('8348','2013-08-12','09:20:00',1.79),('8348','2013-08-12','09:25:00',1.85),('8348','2013-08-12','09:30:00',1.91),('8348','2013-08-12','09:35:00',1.97),('8348','2013-08-12','09:40:00',2.03),('8348','2013-08-12','09:45:00',2.08),('8348','2013-08-12','09:50:00',2.14),('8348','2013-08-12','09:55:00',2.19),('8348','2013-08-12','10:00:00',2.25),('8348','2013-08-12','10:05:00',2.29),('8348','2013-08-12','10:10:00',2.34),('8348','2013-08-12','10:15:00',2.38),('8348','2013-08-12','10:20:00',2.44),('8348','2013-08-12','10:25:00',2.51),('8348','2013-08-12','10:30:00',2.55),('8348','2013-08-12','10:35:00',2.57),('8348','2013-08-12','10:40:00',2.61),('8348','2013-08-12','10:45:00',2.64),('8348','2013-08-12','10:50:00',2.69),('8348','2013-08-12','10:55:00',2.73),('8348','2013-08-12','11:00:00',2.75),('8348','2013-08-12','11:05:00',2.75),('8348','2013-08-12','11:10:00',2.8),('8348','2013-08-12','11:15:00',2.83),('8348','2013-08-12','11:20:00',2.85),('8348','2013-08-12','11:25:00',2.89),('8348','2013-08-12','11:30:00',2.95),('8348','2013-08-12','11:35:00',3),('8348','2013-08-12','11:40:00',3.06),('8348','2013-08-12','11:45:00',3.11),('8348','2013-08-12','11:50:00',3.15),('8348','2013-08-12','11:55:00',3.11),('8348','2013-08-12','12:00:00',3.13),('8348','2013-08-12','12:05:00',3.3),('8348','2013-08-12','12:10:00',3.29),('8348','2013-08-12','12:15:00',2.94),('8348','2013-08-12','12:20:00',1.04),('8348','2013-08-12','12:25:00',1.08),('8348','2013-08-12','12:30:00',1.04),('8348','2013-08-12','12:35:00',2.83),('8348','2013-08-12','12:40:00',2.29),('8348','2013-08-12','12:45:00',2.06),('8348','2013-08-12','12:50:00',1.2),('8348','2013-08-12','13:20:00',1.02),('8348','2013-08-12','13:25:00',1.93),('8348','2013-08-12','13:30:00',1.18),('8348','2013-08-12','13:35:00',1.14),('8348','2013-08-12','13:40:00',1.01),('8348','2013-08-12','13:45:00',1.03),('8348','2013-08-12','13:50:00',3.02),('8348','2013-08-12','13:55:00',3.9),('8348','2013-08-12','14:00:00',2.55),('8348','2013-08-12','14:05:00',2.18),('8348','2013-08-12','14:10:00',2.49),('8348','2013-08-12','14:15:00',1.02),('8348','2013-08-12','14:35:00',1.01),('8348','2013-08-12','14:40:00',1.1),('8348','2013-08-12','14:45:00',1.11),('8348','2013-08-12','14:50:00',3.07),('8348','2013-08-12','14:55:00',3.8),('8348','2013-08-12','15:00:00',2.62),('8348','2013-08-12','15:05:00',2.86),('8348','2013-08-12','15:10:00',1.98),('8348','2013-08-12','15:15:00',3.49),('8348','2013-08-12','15:20:00',3.31),('8348','2013-08-12','15:25:00',2.97),('8348','2013-08-12','15:30:00',3.21),('8348','2013-08-12','15:35:00',3.11),('8348','2013-08-12','15:40:00',3.12),('8348','2013-08-12','15:45:00',3.05),('8348','2013-08-12','15:50:00',3.04),('8348','2013-08-12','15:55:00',2.97),('8348','2013-08-12','16:00:00',2.91),('8348','2013-08-12','16:05:00',2.85),('8348','2013-08-12','16:10:00',2.8),('8348','2013-08-12','16:15:00',2.77),('8348','2013-08-12','16:20:00',2.73),('8348','2013-08-12','16:25:00',2.7),('8348','2013-08-12','16:30:00',2.66),('8348','2013-08-12','16:35:00',2.57),('8348','2013-08-12','16:40:00',2.47),('8348','2013-08-12','16:45:00',2.44),('8348','2013-08-12','16:50:00',2.43),('8348','2013-08-12','16:55:00',2.38),('8348','2013-08-12','17:00:00',2.33),('8348','2013-08-12','17:05:00',2.26),('8348','2013-08-12','17:10:00',2.18),('8348','2013-08-12','17:15:00',2.12),('8348','2013-08-12','17:20:00',2.05),('8348','2013-08-12','17:25:00',2),('8348','2013-08-12','17:30:00',1.93),('8348','2013-08-12','17:35:00',1.87),('8348','2013-08-12','17:40:00',1.78),('8348','2013-08-12','17:45:00',1.71),('8348','2013-08-12','17:50:00',1.65),('8348','2013-08-12','17:55:00',1.58),('8348','2013-08-12','18:00:00',1.52),('8348','2013-08-12','18:05:00',1.44),('8348','2013-08-12','18:10:00',1.37),('8348','2013-08-12','18:15:00',1.29),('8348','2013-08-12','18:20:00',1.22),('8348','2013-08-12','18:25:00',1.16),('8348','2013-08-12','18:30:00',1.08),('8348','2013-08-12','18:35:00',1),('8348','2013-08-11','08:25:00',1),('8348','2013-08-11','08:30:00',1.07),('8348','2013-08-11','08:35:00',1.15),('8348','2013-08-11','08:40:00',1.19),('8348','2013-08-11','08:45:00',1.32),('8348','2013-08-11','08:50:00',1.4),('8348','2013-08-11','08:55:00',1.49),('8348','2013-08-11','09:00:00',1.57),('8348','2013-08-11','09:05:00',1.63),('8348','2013-08-11','09:10:00',1.69),('8348','2013-08-11','09:15:00',1.77),('8348','2013-08-11','09:20:00',1.83),('8348','2013-08-11','09:25:00',1.89),('8348','2013-08-11','09:30:00',1.96),('8348','2013-08-11','09:35:00',2.01),('8348','2013-08-11','09:40:00',2.07),('8348','2013-08-11','09:45:00',2.13),('8348','2013-08-11','09:50:00',2.19),('8348','2013-08-11','09:55:00',2.24),('8348','2013-08-11','10:00:00',2.3),('8348','2013-08-11','10:05:00',2.36),('8348','2013-08-11','10:10:00',2.42),('8348','2013-08-11','10:15:00',2.47),('8348','2013-08-11','10:20:00',2.52),('8348','2013-08-11','10:25:00',2.57),('8348','2013-08-11','10:30:00',2.62),('8348','2013-08-11','10:35:00',2.65),('8348','2013-08-11','10:40:00',2.69),('8348','2013-08-11','10:45:00',2.73),('8348','2013-08-11','10:50:00',2.77),('8348','2013-08-11','10:55:00',2.81),('8348','2013-08-11','11:00:00',2.86),('8348','2013-08-11','11:05:00',2.92),('8348','2013-08-11','11:10:00',2.97),('8348','2013-08-11','11:15:00',2.97),('8348','2013-08-11','11:20:00',2.99),('8348','2013-08-11','11:25:00',3.04),('8348','2013-08-11','11:30:00',3.08),('8348','2013-08-11','11:35:00',3.1),('8348','2013-08-11','11:40:00',3.11),('8348','2013-08-11','11:45:00',3.13),('8348','2013-08-11','11:50:00',3.15),('8348','2013-08-11','11:55:00',3.18),('8348','2013-08-11','12:00:00',3.21),('8348','2013-08-11','12:05:00',3.22),('8348','2013-08-11','12:10:00',3.22),('8348','2013-08-11','12:15:00',3.25),('8348','2013-08-11','12:20:00',3.27),('8348','2013-08-11','12:25:00',3.29),('8348','2013-08-11','12:30:00',3.31),('8348','2013-08-11','12:35:00',3.34),('8348','2013-08-11','12:40:00',3.35),('8348','2013-08-11','12:45:00',3.35),('8348','2013-08-11','12:50:00',3.32),('8348','2013-08-11','12:55:00',3.35),('8348','2013-08-11','13:00:00',3.36),('8348','2013-08-11','13:05:00',3.39),('8348','2013-08-11','13:10:00',3.36),('8348','2013-08-11','13:15:00',3.32),('8348','2013-08-11','13:20:00',3.3),('8348','2013-08-11','13:25:00',3.37),('8348','2013-08-11','13:30:00',3.4),('8348','2013-08-11','13:35:00',3.39),('8348','2013-08-11','13:40:00',3.38),('8348','2013-08-11','13:45:00',3.37),('8348','2013-08-11','13:50:00',3.35),('8348','2013-08-11','13:55:00',3.33),('8348','2013-08-11','14:00:00',3.34),('8348','2013-08-11','14:05:00',3.33),('8348','2013-08-11','14:10:00',3.33),('8348','2013-08-11','14:15:00',3.32),('8348','2013-08-11','14:20:00',3.27),('8348','2013-08-11','14:25:00',3.26),('8348','2013-08-11','14:30:00',3.25),('8348','2013-08-11','14:35:00',3.21),('8348','2013-08-11','14:40:00',3.27),('8348','2013-08-11','14:45:00',3.25),('8348','2013-08-11','14:50:00',3.13),('8348','2013-08-11','14:55:00',3.03),('8348','2013-08-11','15:05:00',3.24),('8348','2013-08-11','15:10:00',3.22),('8348','2013-08-11','15:15:00',3.08),('8348','2013-08-11','15:20:00',3.03),('8348','2013-08-11','15:25:00',3.09),('8348','2013-08-11','15:30:00',2.54),('8348','2013-08-11','15:35:00',2.96),('8348','2013-08-11','15:40:00',2.94),('8348','2013-08-11','15:45:00',2.96),('8348','2013-08-11','15:50:00',2.99),('8348','2013-08-11','15:55:00',2.98),('8348','2013-08-11','16:00:00',2.94),('8348','2013-08-11','16:05:00',2.88),('8348','2013-08-11','16:10:00',2.82),('8348','2013-08-11','16:15:00',2.78),('8348','2013-08-11','16:20:00',2.74),('8348','2013-08-11','16:25:00',2.68),('8348','2013-08-11','16:30:00',2.62),('8348','2013-08-11','16:35:00',2.59),('8348','2013-08-11','16:40:00',2.54),('8348','2013-08-11','16:45:00',2.48),('8348','2013-08-11','16:50:00',2.43),('8348','2013-08-11','16:55:00',2.38),('8348','2013-08-11','17:00:00',2.32),('8348','2013-08-11','17:05:00',2.26),('8348','2013-08-11','17:10:00',2.2),('8348','2013-08-11','17:15:00',2.14),('8348','2013-08-11','17:20:00',2.08),('8348','2013-08-11','17:25:00',2.01),('8348','2013-08-11','17:30:00',1.95),('8348','2013-08-11','17:35:00',1.88),('8348','2013-08-11','17:40:00',1.81),('8348','2013-08-11','17:45:00',1.74),('8348','2013-08-11','17:50:00',1.67),('8348','2013-08-11','17:55:00',1.6),('8348','2013-08-11','18:00:00',1.52),('8348','2013-08-11','18:05:00',1.44),('8348','2013-08-11','18:10:00',1.34),('8348','2013-08-11','18:15:00',1.26),('8348','2013-08-11','18:20:00',1.21),('8348','2013-08-11','18:25:00',1.14),('8348','2013-08-11','18:30:00',1.07),('8348','2013-08-10','08:25:00',1.04),('8348','2013-08-10','08:30:00',1.11),('8348','2013-08-10','08:35:00',1.2),('8348','2013-08-10','08:40:00',1.24),('8348','2013-08-10','08:45:00',1.34),('8348','2013-08-10','08:50:00',1.43),('8348','2013-08-10','08:55:00',1.52),('8348','2013-08-10','09:00:00',1.58),('8348','2013-08-10','09:05:00',1.66),('8348','2013-08-10','09:10:00',1.73),('8348','2013-08-10','09:15:00',1.8),('8348','2013-08-10','09:20:00',1.86),('8348','2013-08-10','09:25:00',1.92),('8348','2013-08-10','09:30:00',1.98),('8348','2013-08-10','09:35:00',2.04),('8348','2013-08-10','09:40:00',2.09),('8348','2013-08-10','09:45:00',2.15),('8348','2013-08-10','09:50:00',2.21),('8348','2013-08-10','09:55:00',2.28),('8348','2013-08-10','10:00:00',2.32),('8348','2013-08-10','10:05:00',2.37),('8348','2013-08-10','10:10:00',2.18),('8348','2013-08-10','10:15:00',2.22),('8348','2013-08-10','10:20:00',2.5),('8348','2013-08-10','10:25:00',2.55),('8348','2013-08-10','10:30:00',2.62),('8348','2013-08-10','10:35:00',2.66),('8348','2013-08-10','10:40:00',2.71),('8348','2013-08-10','10:45:00',2.74),('8348','2013-08-10','10:50:00',2.79),('8348','2013-08-10','10:55:00',2.85),('8348','2013-08-10','11:00:00',2.94),('8348','2013-08-10','11:05:00',2.98),('8348','2013-08-10','11:10:00',2.94),('8348','2013-08-10','11:15:00',3.09),('8348','2013-08-10','11:20:00',2.42),('8348','2013-08-10','11:25:00',2.18),('8348','2013-08-10','11:30:00',2.63),('8348','2013-08-10','11:35:00',3),('8348','2013-08-10','11:40:00',3.18),('8348','2013-08-10','11:45:00',3.2),('8348','2013-08-10','11:50:00',3.21),('8348','2013-08-10','11:55:00',3.23),('8348','2013-08-10','12:00:00',3.24),('8348','2013-08-10','12:05:00',3.27),('8348','2013-08-10','12:10:00',3.28),('8348','2013-08-10','12:15:00',3.32),('8348','2013-08-10','12:20:00',3.32),('8348','2013-08-10','12:25:00',3.36),('8348','2013-08-10','12:30:00',3.36),('8348','2013-08-10','12:35:00',3.38),('8348','2013-08-10','12:40:00',3.42),('8348','2013-08-10','12:45:00',3.29),('8348','2013-08-10','12:50:00',3.55),('8348','2013-08-10','12:55:00',3.54),('8348','2013-08-10','13:00:00',3.52),('8348','2013-08-10','13:05:00',3.43),('8348','2013-08-10','13:10:00',3.52),('8348','2013-08-10','13:15:00',3.63),('8348','2013-08-10','13:20:00',3.74),('8348','2013-08-10','13:25:00',3.77),('8348','2013-08-10','13:30:00',3.43),('8348','2013-08-10','13:35:00',1.82),('8348','2013-08-10','13:45:00',1.1),('8348','2013-08-10','13:50:00',3.81),('8348','2013-08-10','13:55:00',3.69),('8348','2013-08-10','14:00:00',3.81),('8348','2013-08-10','14:05:00',3.93),('8348','2013-08-10','14:10:00',3.56),('8348','2013-08-10','14:15:00',3.33),('8348','2013-08-10','14:20:00',2.28),('8348','2013-08-10','14:25:00',1.15),('8348','2013-08-10','14:30:00',1.11),('8348','2013-08-10','15:10:00',1.01),('8348','2013-08-10','15:15:00',1.14),('8348','2013-08-10','15:20:00',1.11),('8348','2013-08-10','15:35:00',1.21),('8348','2013-08-10','15:40:00',1.15),('8348','2013-08-10','15:45:00',1.29),('8348','2013-08-10','15:50:00',1.59),('8348','2013-08-10','15:55:00',1.76),('8348','2013-08-10','16:00:00',2.41),('8348','2013-08-10','16:05:00',3.79),('8348','2013-08-10','16:10:00',2.23),('8348','2013-08-10','16:15:00',2.31),('8348','2013-08-10','16:20:00',3.19),('8348','2013-08-10','16:25:00',1.01),('8348','2013-08-10','16:30:00',1.47),('8348','2013-08-10','16:35:00',2.03),('8348','2013-08-10','16:40:00',2.65),('8348','2013-08-10','16:45:00',2.75),('8348','2013-08-10','16:50:00',2.62),('8348','2013-08-10','16:55:00',2.44),('8348','2013-08-10','17:00:00',2.21),('8348','2013-08-10','17:05:00',1.51),('8348','2013-08-10','17:10:00',1),('8348','2013-08-10','17:15:00',1.14),('8348','2013-08-10','17:20:00',1.24),('8348','2013-08-10','17:25:00',1.49),('8348','2013-08-10','17:55:00',1.02),('8348','2014-04-09','07:00:00',1.29),('8348','2014-04-09','07:05:00',1.59),('8348','2014-04-09','07:10:00',1.4),('8348','2014-04-09','07:15:00',1.27),('8348','2014-04-09','07:20:00',1.56),('8348','2014-04-09','07:25:00',1.26),('8348','2014-04-09','07:30:00',1.34),('8348','2014-04-09','07:50:00',1.01),('8348','2014-04-09','07:55:00',1.51),('8348','2014-04-09','08:00:00',1.49),('8348','2014-04-09','08:05:00',1.48),('8348','2014-04-09','08:10:00',1.45),('8348','2014-04-09','08:15:00',1.42),('8348','2014-04-09','08:20:00',1.47),('8348','2014-04-09','08:25:00',1.67),('8348','2014-04-09','08:30:00',1.73),('8348','2014-04-09','08:35:00',1.48),('8348','2014-04-09','08:40:00',1.35),('8348','2014-04-09','08:45:00',1.82),('8348','2014-04-09','08:50:00',3.17),('8348','2014-04-09','08:55:00',4.53),('8348','2014-04-09','09:00:00',4.52),('8348','2014-04-09','09:05:00',4.58),('8348','2014-04-09','09:10:00',4.81),('8348','2014-04-09','09:15:00',5.06),('8348','2014-04-09','09:20:00',5.28),('8348','2014-04-09','09:25:00',5.57),('8348','2014-04-09','09:30:00',6.18),('8348','2014-04-09','09:35:00',4.59),('8348','2014-04-09','09:40:00',3.02),('8348','2014-04-09','09:45:00',2.27),('8348','2014-04-09','09:50:00',3.76),('8348','2014-04-09','09:55:00',2.24),('8348','2014-04-09','10:00:00',5.85),('8348','2014-04-09','10:05:00',7.09),('8348','2014-04-09','10:10:00',7.28),('8348','2014-04-09','10:15:00',7.37),('8348','2014-04-09','10:20:00',3.52),('8348','2014-04-09','10:25:00',1.86),('8348','2014-04-09','10:30:00',1.69),('8348','2014-04-09','10:35:00',4.29),('8348','2014-04-09','10:40:00',7.71),('8348','2014-04-09','10:45:00',5.58),('8348','2014-04-09','10:50:00',4.53),('8348','2014-04-09','10:55:00',7.26),('8348','2014-04-09','11:00:00',7.46),('8348','2014-04-09','11:05:00',7.25),('8348','2014-04-09','11:10:00',3.49),('8348','2014-04-09','11:15:00',2.62),('8348','2014-04-09','11:20:00',2.19),('8348','2014-04-09','11:25:00',1.71),('8348','2014-04-09','11:30:00',1.49),('8348','2014-04-09','11:35:00',1.31),('8348','2014-04-09','11:40:00',1.2),('8348','2014-04-09','11:45:00',1.08),('8348','2014-04-09','11:50:00',1.16),('8348','2014-04-09','11:55:00',1.17),('8348','2014-04-09','12:05:00',1.01),('8348','2014-04-09','12:10:00',1.26),('8348','2014-04-09','12:15:00',1.86),('8348','2014-04-09','12:20:00',2.71),('8348','2014-04-09','12:25:00',2.81),('8348','2014-04-09','12:30:00',2.4),('8348','2014-04-09','12:35:00',2.41),('8348','2014-04-09','12:40:00',2.05),('8348','2014-04-09','12:45:00',1.74),('8348','2014-04-09','12:50:00',1.67),('8348','2014-04-09','12:55:00',1.55),('8348','2014-04-09','13:00:00',1.83),('8348','2014-04-09','13:05:00',3.75),('8348','2014-04-09','13:10:00',4.88),('8348','2014-04-09','13:15:00',4.11),('8348','2014-04-09','13:20:00',3.07),('8348','2014-04-09','13:25:00',3.07),('8348','2014-04-09','13:30:00',5.9),('8348','2014-04-09','13:35:00',5.3),('8348','2014-04-09','13:40:00',5.08),('8348','2014-04-09','13:45:00',4.52),('8348','2014-04-09','13:50:00',3.68),('8348','2014-04-09','13:55:00',4.72),('8348','2014-04-09','14:00:00',5.56),('8348','2014-04-09','14:05:00',8.07),('8348','2014-04-09','14:10:00',7),('8348','2014-04-09','14:15:00',7.63),('8348','2014-04-09','14:20:00',6.21),('8348','2014-04-09','14:25:00',5.04),('8348','2014-04-09','14:30:00',3.66),('8348','2014-04-09','14:35:00',3.05),('8348','2014-04-09','14:40:00',3.95),('8348','2014-04-09','14:45:00',3.57),('8348','2014-04-09','14:50:00',2.45),('8348','2014-04-09','14:55:00',2.16),('8348','2014-04-09','15:00:00',2.23),('8348','2014-04-09','15:05:00',3.81),('8348','2014-04-09','15:10:00',5.82),('8348','2014-04-09','15:15:00',5.64),('8348','2014-04-09','15:20:00',5.44),('8348','2014-04-09','15:25:00',5.25),('8348','2014-04-09','15:30:00',3.36),('8348','2014-04-09','15:35:00',3.71),('8348','2014-04-09','15:40:00',3.56),('8348','2014-04-09','15:45:00',4.23),('8348','2014-04-09','15:50:00',3.27),('8348','2014-04-09','15:55:00',2.9),('8348','2014-04-09','16:00:00',3.87),('8348','2014-04-09','16:05:00',5.19),('8348','2014-04-09','16:10:00',4.38),('8348','2014-04-09','16:15:00',3.95),('8348','2014-04-09','16:20:00',3.81),('8348','2014-04-09','16:25:00',3.74),('8348','2014-04-09','16:30:00',2.61),('8348','2014-04-09','16:35:00',1.29),('8348','2014-04-09','16:40:00',1.39),('8348','2014-04-09','16:45:00',2.38),('8348','2014-04-09','16:50:00',2.19),('8348','2014-04-09','16:55:00',2.19),('8348','2014-04-09','17:00:00',1.82),('8348','2014-04-09','17:05:00',1.22),('8348','2014-04-09','17:10:00',1.42),('8348','2014-04-09','17:15:00',1.08),('8348','2013-08-09','08:40:00',1.05),('8348','2013-08-09','08:45:00',1.27),('8348','2013-08-09','08:50:00',1.34),('8348','2013-08-09','08:55:00',1.43),('8348','2013-08-09','09:00:00',1.52),('8348','2013-08-09','09:05:00',1.58),('8348','2013-08-09','09:10:00',1.47),('8348','2013-08-09','09:15:00',1.74),('8348','2013-08-09','09:20:00',1.59),('8348','2013-08-09','09:25:00',1.54),('8348','2013-08-09','09:30:00',1.77),('8348','2013-08-09','09:35:00',1.77),('8348','2013-08-09','09:40:00',1.27),('8348','2013-08-09','09:45:00',1.74),('8348','2013-08-09','09:50:00',1.9),('8348','2013-08-09','09:55:00',1.07),('8348','2013-08-09','10:00:00',1.47),('8348','2013-08-09','10:05:00',1.45),('8348','2013-08-09','10:10:00',1.77),('8348','2013-08-09','10:15:00',2.26),('8348','2013-08-09','10:20:00',2.24),('8348','2013-08-09','10:25:00',2.33),('8348','2013-08-09','10:30:00',2.39),('8348','2013-08-09','10:35:00',2.43),('8348','2013-08-09','10:40:00',2.48),('8348','2013-08-09','10:45:00',2.48),('8348','2013-08-09','10:50:00',2.51),('8348','2013-08-09','10:55:00',2.61),('8348','2013-08-09','11:00:00',2.61),('8348','2013-08-09','11:05:00',2.67),('8348','2013-08-09','11:10:00',2.68),('8348','2013-08-09','11:15:00',2.73),('8348','2013-08-09','11:20:00',2.78),('8348','2013-08-09','11:25:00',2.78),('8348','2013-08-09','11:30:00',2.84),('8348','2013-08-09','11:35:00',2.84),('8348','2013-08-09','11:40:00',2.87),('8348','2013-08-09','11:45:00',2.88),('8348','2013-08-09','11:50:00',2.93),('8348','2013-08-09','11:55:00',2.95),('8348','2013-08-09','12:00:00',2.99),('8348','2013-08-09','12:05:00',3.02),('8348','2013-08-09','12:10:00',3.02),('8348','2013-08-09','12:15:00',3.09),('8348','2013-08-09','12:20:00',3.22),('8348','2013-08-09','12:25:00',2.68),('8348','2013-08-09','12:30:00',2.12),('8348','2013-08-09','12:35:00',2.47),('8348','2013-08-09','12:40:00',3.2),('8348','2013-08-09','12:45:00',2.37),('8348','2013-08-09','12:50:00',2.22),('8348','2013-08-09','12:55:00',2.6),('8348','2013-08-09','13:00:00',1.23),('8348','2013-08-09','13:20:00',1.31),('8348','2013-08-09','13:25:00',1.92),('8348','2013-08-09','13:30:00',1.74),('8348','2013-08-09','13:35:00',1.34),('8348','2013-08-09','13:40:00',1.35),('8348','2013-08-09','13:45:00',1.26),('8348','2013-08-09','13:50:00',1.35),('8348','2013-08-09','13:55:00',1.19),('8348','2013-08-09','14:00:00',1.13),('8348','2013-08-09','14:05:00',1.12),('8348','2013-08-09','14:10:00',1.36),('8348','2013-08-09','15:05:00',1.08),('8348','2013-08-09','15:10:00',2.51),('8348','2013-08-09','15:15:00',2.39),('8348','2013-08-09','15:20:00',1.38),('8348','2013-08-09','15:25:00',1.11),('8348','2013-08-09','15:30:00',1.08),('8348','2013-08-09','15:35:00',1.81),('8348','2013-08-09','15:40:00',1.51),('8348','2013-08-09','15:45:00',2.55),('8348','2013-08-09','15:50:00',1.94),('8348','2013-08-09','15:55:00',1.67),('8348','2013-08-09','16:00:00',1.09),('8348','2013-08-09','16:50:00',1.37),('8348','2013-08-09','16:55:00',2.37),('8348','2013-08-09','17:00:00',1.29),('8348','2013-08-09','17:05:00',1.79),('8348','2013-08-08','08:30:00',1.01),('8348','2013-08-08','08:35:00',1.08),('8348','2013-08-08','08:40:00',1.16),('8348','2013-08-08','08:45:00',1.21),('8348','2013-08-08','08:50:00',1.3),('8348','2013-08-08','08:55:00',1.39),('8348','2013-08-08','09:00:00',1.46),('8348','2013-08-08','09:05:00',1.52),('8348','2013-08-08','09:10:00',1.57),('8348','2013-08-08','09:15:00',1.64),('8348','2013-08-08','09:20:00',1.7),('8348','2013-08-08','09:25:00',1.77),('8348','2013-08-08','09:30:00',1.83),('8348','2013-08-08','09:35:00',1.89),('8348','2013-08-08','09:40:00',1.94),('8348','2013-08-08','09:45:00',2),('8348','2013-08-08','09:50:00',2.05),('8348','2013-08-08','09:55:00',2.1),('8348','2013-08-08','10:00:00',2.16),('8348','2013-08-08','10:05:00',2.19),('8348','2013-08-08','10:10:00',2.24),('8348','2013-08-08','10:15:00',2.31),('8348','2013-08-08','10:20:00',2.36),('8348','2013-08-08','10:25:00',2.38),('8348','2013-08-08','10:30:00',2.43),('8348','2013-08-08','10:35:00',2.48),('8348','2013-08-08','10:40:00',2.51),('8348','2013-08-08','10:45:00',2.55),('8348','2013-08-08','10:50:00',2.59),('8348','2013-08-08','10:55:00',2.62),('8348','2013-08-08','11:00:00',2.66),('8348','2013-08-08','11:05:00',2.7),('8348','2013-08-08','11:10:00',2.72),('8348','2013-08-08','11:15:00',2.75),('8348','2013-08-08','11:20:00',2.73),('8348','2013-08-08','11:25:00',2.75),('8348','2013-08-08','11:30:00',2.8),('8348','2013-08-08','11:35:00',2.84),('8348','2013-08-08','11:40:00',2.87),('8348','2013-08-08','11:45:00',2.89),('8348','2013-08-08','11:50:00',2.91),('8348','2013-08-08','11:55:00',2.97),('8348','2013-08-08','12:00:00',2.97),('8348','2013-08-08','12:05:00',2.97),('8348','2013-08-08','12:10:00',3.02),('8348','2013-08-08','12:15:00',3.05),('8348','2013-08-08','12:20:00',3.07),('8348','2013-08-08','12:25:00',3.08),('8348','2013-08-08','12:30:00',3.07),('8348','2013-08-08','12:35:00',3.16),('8348','2013-08-08','12:40:00',3.17),('8348','2013-08-08','12:45:00',3.2),('8348','2013-08-08','12:50:00',3.2),('8348','2013-08-08','12:55:00',3.24),('8348','2013-08-08','13:00:00',3.25),('8348','2013-08-08','13:05:00',3.28),('8348','2013-08-08','13:10:00',3.3),('8348','2013-08-08','13:15:00',3.31),('8348','2013-08-08','13:20:00',3.35),('8348','2013-08-08','13:25:00',3.33),('8348','2013-08-08','13:30:00',3.29),('8348','2013-08-08','13:35:00',3.3),('8348','2013-08-08','13:40:00',3.27),('8348','2013-08-08','13:45:00',3.29),('8348','2013-08-08','13:50:00',3.3),('8348','2013-08-08','13:55:00',3.25),('8348','2013-08-08','14:00:00',3.26),('8348','2013-08-08','14:05:00',3.25),('8348','2013-08-08','14:10:00',3.23),('8348','2013-08-08','14:15:00',3.22),('8348','2013-08-08','14:20:00',3.2),('8348','2013-08-08','14:25:00',3.2),('8348','2013-08-08','14:30:00',3.2),('8348','2013-08-08','14:35:00',3.19),('8348','2013-08-08','14:40:00',3.14),('8348','2013-08-08','14:45:00',3.15),('8348','2013-08-08','14:50:00',3.11),('8348','2013-08-08','14:55:00',3.07),('8348','2013-08-08','15:00:00',3.03),('8348','2013-08-08','15:05:00',3.02),('8348','2013-08-08','15:10:00',2.99),('8348','2013-08-08','15:15:00',2.99),('8348','2013-08-08','15:20:00',2.96),('8348','2013-08-08','15:25:00',2.94),('8348','2013-08-08','15:30:00',2.89),('8348','2013-08-08','15:35:00',2.87),('8348','2013-08-08','15:40:00',2.84),('8348','2013-08-08','15:45:00',2.83),('8348','2013-08-08','15:50:00',2.79),('8348','2013-08-08','15:55:00',2.77),('8348','2013-08-08','16:00:00',2.73),('8348','2013-08-08','16:05:00',2.71),('8348','2013-08-08','16:10:00',2.68),('8348','2013-08-08','16:15:00',2.65),('8348','2013-08-08','16:20:00',2.62),('8348','2013-08-08','16:25:00',2.59),('8348','2013-08-08','16:30:00',2.55),('8348','2013-08-08','16:35:00',2.5),('8348','2013-08-08','16:40:00',2.44),('8348','2013-08-08','16:45:00',2.38),('8348','2013-08-08','16:50:00',2.31),('8348','2013-08-08','16:55:00',2.26),('8348','2013-08-08','17:00:00',2.22),('8348','2013-08-08','17:05:00',2.14),('8348','2013-08-08','17:10:00',2.08),('8348','2013-08-08','17:15:00',2.03),('8348','2013-08-08','17:20:00',1.96),('8348','2013-08-08','17:25:00',1.89),('8348','2013-08-08','17:30:00',1.82),('8348','2013-08-08','17:35:00',1.75),('8348','2013-08-08','17:40:00',1.69),('8348','2013-08-08','17:45:00',1.63),('8348','2013-08-08','17:50:00',1.57),('8348','2013-08-08','17:55:00',1.5),('8348','2013-08-08','18:00:00',1.44),('8348','2013-08-08','18:05:00',1.38),('8348','2013-08-08','18:10:00',1.31),('8348','2013-08-08','18:15:00',1.23),('8348','2013-08-08','18:20:00',1.16),('8348','2013-08-08','18:25:00',1.09),('8348','2013-08-08','18:30:00',1.02),('8348','2013-08-07','08:30:00',1.04),('8348','2013-08-07','08:35:00',1.11),('8348','2013-08-07','08:40:00',1.21),('8348','2013-08-07','08:45:00',1.27),('8348','2013-08-07','08:50:00',1.36),('8348','2013-08-07','08:55:00',1.44),('8348','2013-08-07','09:00:00',1.49),('8348','2013-08-07','09:05:00',1.55),('8348','2013-08-07','09:10:00',1.61),('8348','2013-08-07','09:15:00',1.67),('8348','2013-08-07','09:20:00',1.73),('8348','2013-08-07','09:25:00',1.79),('8348','2013-08-07','09:30:00',1.85),('8348','2013-08-07','09:35:00',1.92),('8348','2013-08-07','09:40:00',1.98),('8348','2013-08-07','09:45:00',2.04),('8348','2013-08-07','09:50:00',2.08),('8348','2013-08-07','09:55:00',2.13),('8348','2013-08-07','10:00:00',2.18),('8348','2013-08-07','10:05:00',2.2),('8348','2013-08-07','10:10:00',2.29),('8348','2013-08-07','10:15:00',2.33),('8348','2013-08-07','10:20:00',2.37),('8348','2013-08-07','10:25:00',2.41),('8348','2013-08-07','10:30:00',2.45),('8348','2013-08-07','10:35:00',2.51),('8348','2013-08-07','10:40:00',2.56),('8348','2013-08-07','10:45:00',2.58),('8348','2013-08-07','10:50:00',2.61),('8348','2013-08-07','10:55:00',2.64),('8348','2013-08-07','11:00:00',2.67),('8348','2013-08-07','11:05:00',2.72),('8348','2013-08-07','11:10:00',2.77),('8348','2013-08-07','11:15:00',2.8),('8348','2013-08-07','11:20:00',2.83),('8348','2013-08-07','11:25:00',2.85),('8348','2013-08-07','11:30:00',2.85),('8348','2013-08-07','11:35:00',2.88),('8348','2013-08-07','11:40:00',2.89),('8348','2013-08-07','11:45:00',2.93),('8348','2013-08-07','11:50:00',2.94),('8348','2013-08-07','11:55:00',2.98),('8348','2013-08-07','12:00:00',3),('8348','2013-08-07','12:05:00',3.02),('8348','2013-08-07','12:10:00',3.06),('8348','2013-08-07','12:15:00',3.09),('8348','2013-08-07','12:20:00',3.04),('8348','2013-08-07','12:25:00',3.07),('8348','2013-08-07','12:30:00',3.11),('8348','2013-08-07','12:35:00',3.06),('8348','2013-08-07','12:40:00',3.01),('8348','2013-08-07','12:45:00',3.1),('8348','2013-08-07','12:50:00',3.08),('8348','2013-08-07','12:55:00',3.18),('8348','2013-08-07','13:00:00',3.17),('8348','2013-08-07','13:05:00',3.23),('8348','2013-08-07','13:10:00',3.18),('8348','2013-08-07','13:15:00',3.25),('8348','2013-08-07','13:20:00',3.19),('8348','2013-08-07','13:25:00',3.28),('8348','2013-08-07','13:30:00',3.26),('8348','2013-08-07','13:35:00',3.29),('8348','2013-08-07','13:40:00',3.35),('8348','2013-08-07','13:45:00',3.28),('8348','2013-08-07','13:50:00',3.26),('8348','2013-08-07','13:55:00',3.34),('8348','2013-08-07','14:00:00',3.28),('8348','2013-08-07','14:05:00',3.32),('8348','2013-08-07','14:10:00',3.25),('8348','2013-08-07','14:15:00',3.27),('8348','2013-08-07','14:20:00',3.19),('8348','2013-08-07','14:25:00',3.17),('8348','2013-08-07','14:30:00',3.14),('8348','2013-08-07','14:35:00',3.13),('8348','2013-08-07','14:40:00',3.18),('8348','2013-08-07','14:45:00',3.19),('8348','2013-08-07','14:50:00',3.19),('8348','2013-08-07','14:55:00',3.12),('8348','2013-08-07','15:00:00',3.12),('8348','2013-08-07','15:05:00',3.09),('8348','2013-08-07','15:10:00',3.07),('8348','2013-08-07','15:15:00',3.08),('8348','2013-08-07','15:20:00',3.04),('8348','2013-08-07','15:25:00',2.98),('8348','2013-08-07','15:30:00',2.96),('8348','2013-08-07','15:35:00',2.91),('8348','2013-08-07','15:40:00',2.88),('8348','2013-08-07','15:45:00',2.89),('8348','2013-08-07','15:50:00',2.84),('8348','2013-08-07','15:55:00',2.8),('8348','2013-08-07','16:00:00',2.75),('8348','2013-08-07','16:05:00',2.72),('8348','2013-08-07','16:10:00',2.68),('8348','2013-08-07','16:15:00',2.65),('8348','2013-08-07','16:20:00',2.62),('8348','2013-08-07','16:25:00',2.58),('8348','2013-08-07','16:30:00',2.54),('8348','2013-08-07','16:35:00',2.48),('8348','2013-08-07','16:40:00',2.44),('8348','2013-08-07','16:45:00',2.39),('8348','2013-08-07','16:50:00',2.37),('8348','2013-08-07','16:55:00',2.32),('8348','2013-08-07','17:00:00',2.26),('8348','2013-08-07','17:05:00',2.17),('8348','2013-08-07','17:10:00',2.13),('8348','2013-08-07','17:15:00',2.05),('8348','2013-08-07','17:20:00',2),('8348','2013-08-07','17:25:00',1.95),('8348','2013-08-07','17:30:00',1.88),('8348','2013-08-07','17:35:00',1.81),('8348','2013-08-07','17:40:00',1.73),('8348','2013-08-07','17:45:00',1.67),('8348','2013-08-07','17:50:00',1.61),('8348','2013-08-07','17:55:00',1.54),('8348','2013-08-07','18:00:00',1.48),('8348','2013-08-07','18:05:00',1.4),('8348','2013-08-07','18:10:00',1.3),('8348','2013-08-07','18:15:00',1.21),('8348','2013-08-07','18:20:00',1.16),('8348','2013-08-07','18:25:00',1.1),('8348','2013-08-07','18:30:00',1.05),('8348','2013-08-06','08:30:00',1.04),('8348','2013-08-06','08:35:00',1.09),('8348','2013-08-06','08:40:00',1.19),('8348','2013-08-06','08:45:00',1.26),('8348','2013-08-06','08:50:00',1.35),('8348','2013-08-06','08:55:00',1.41),('8348','2013-08-06','09:00:00',1.48),('8348','2013-08-06','09:05:00',1.55),('8348','2013-08-06','09:10:00',1.61),('8348','2013-08-06','09:15:00',1.67),('8348','2013-08-06','09:20:00',1.73),('8348','2013-08-06','09:25:00',1.79),('8348','2013-08-06','09:30:00',1.85),('8348','2013-08-06','09:35:00',1.92),('8348','2013-08-06','09:40:00',1.96),('8348','2013-08-06','09:45:00',2.01),('8348','2013-08-06','09:50:00',2.08),('8348','2013-08-06','09:55:00',2.13),('8348','2013-08-06','10:00:00',2.18),('8348','2013-08-06','10:05:00',2.22),('8348','2013-08-06','10:10:00',2.26),('8348','2013-08-06','10:15:00',2.31),('8348','2013-08-06','10:20:00',2.36),('8348','2013-08-06','10:25:00',2.41),('8348','2013-08-06','10:30:00',2.44),('8348','2013-08-06','10:35:00',2.47),('8348','2013-08-06','10:40:00',2.52),('8348','2013-08-06','10:45:00',2.54),('8348','2013-08-06','10:50:00',2.59),('8348','2013-08-06','10:55:00',2.63),('8348','2013-08-06','11:00:00',2.66),('8348','2013-08-06','11:05:00',2.71),('8348','2013-08-06','11:10:00',2.75),('8348','2013-08-06','11:15:00',2.78),('8348','2013-08-06','11:20:00',2.82),('8348','2013-08-06','11:25:00',2.83),('8348','2013-08-06','11:30:00',2.87),('8348','2013-08-06','11:35:00',2.91),('8348','2013-08-06','11:40:00',2.92),('8348','2013-08-06','11:45:00',2.92),('8348','2013-08-06','11:50:00',2.95),('8348','2013-08-06','11:55:00',2.98),('8348','2013-08-06','12:00:00',2.99),('8348','2013-08-06','12:05:00',2.99),('8348','2013-08-06','12:10:00',3.03),('8348','2013-08-06','12:15:00',3.02),('8348','2013-08-06','12:20:00',3.02),('8348','2013-08-06','12:25:00',3.05),('8348','2013-08-06','12:30:00',3.07),('8348','2013-08-06','12:35:00',3.08),('8348','2013-08-06','12:40:00',3.09),('8348','2013-08-06','12:45:00',3.12),('8348','2013-08-06','12:50:00',3.17),('8348','2013-08-06','12:55:00',3.16),('8348','2013-08-06','13:00:00',3.18),('8348','2013-08-06','13:05:00',3.2),('8348','2013-08-06','13:10:00',3.23),('8348','2013-08-06','13:15:00',3.26),('8348','2013-08-06','13:20:00',3.29),('8348','2013-08-06','13:25:00',3.26),('8348','2013-08-06','13:30:00',3.3),('8348','2013-08-06','13:35:00',3.33),('8348','2013-08-06','13:40:00',3.36),('8348','2013-08-06','13:45:00',3.4),('8348','2013-08-06','13:50:00',3.42),('8348','2013-08-06','13:55:00',3.42),('8348','2013-08-06','14:00:00',3.42),('8348','2013-08-06','14:05:00',3.44),('8348','2013-08-06','14:10:00',3.44),('8348','2013-08-06','14:15:00',3.42),('8348','2013-08-06','14:20:00',3.4),('8348','2013-08-06','14:25:00',3.4),('8348','2013-08-06','14:30:00',3.38),('8348','2013-08-06','14:35:00',3.34),('8348','2013-08-06','14:40:00',3.33),('8348','2013-08-06','14:45:00',3.31),('8348','2013-08-06','14:50:00',3.31),('8348','2013-08-06','14:55:00',3.3),('8348','2013-08-06','15:00:00',3.29),('8348','2013-08-06','15:05:00',3.26),('8348','2013-08-06','15:10:00',3.24),('8348','2013-08-06','15:15:00',3.22),('8348','2013-08-06','15:20:00',3.21),('8348','2013-08-06','15:25:00',3.18),('8348','2013-08-06','15:30:00',3.14),('8348','2013-08-06','15:35:00',3.12),('8348','2013-08-06','15:40:00',3.08),('8348','2013-08-06','15:45:00',3.04),('8348','2013-08-06','15:50:00',2.99),('8348','2013-08-06','15:55:00',2.95),('8348','2013-08-06','16:00:00',2.9),('8348','2013-08-06','16:05:00',2.86),('8348','2013-08-06','16:10:00',2.82),('8348','2013-08-06','16:15:00',2.78),('8348','2013-08-06','16:20:00',2.74),('8348','2013-08-06','16:25:00',2.68),('8348','2013-08-06','16:30:00',2.64),('8348','2013-08-06','16:35:00',2.59),('8348','2013-08-06','16:40:00',2.54),('8348','2013-08-06','16:45:00',2.48),('8348','2013-08-06','16:50:00',2.43),('8348','2013-08-06','16:55:00',2.37),('8348','2013-08-06','17:00:00',2.31),('8348','2013-08-06','17:05:00',2.28),('8348','2013-08-06','17:10:00',2.2),('8348','2013-08-06','17:15:00',2.13),('8348','2013-08-06','17:20:00',2.05),('8348','2013-08-06','17:25:00',1.98),('8348','2013-08-06','17:30:00',1.93),('8348','2013-08-06','17:35:00',1.87),('8348','2013-08-06','17:40:00',1.78),('8348','2013-08-06','17:45:00',1.72),('8348','2013-08-06','17:50:00',1.66),('8348','2013-08-06','17:55:00',1.59),('8348','2013-08-06','18:00:00',1.52),('8348','2013-08-06','18:05:00',1.45),('8348','2013-08-06','18:10:00',1.38),('8348','2013-08-06','18:15:00',1.31),('8348','2013-08-06','18:20:00',1.24),('8348','2013-08-06','18:25:00',1.16),('8348','2013-08-06','18:30:00',1.11),('8348','2013-08-06','18:35:00',1.04),('8348','2013-08-05','08:25:00',1.02),('8348','2013-08-05','08:30:00',1.08),('8348','2013-08-05','08:35:00',1.14),('8348','2013-08-05','08:40:00',1.23),('8348','2013-08-05','08:45:00',1.3),('8348','2013-08-05','08:50:00',1.39),('8348','2013-08-05','08:55:00',1.46),('8348','2013-08-05','09:00:00',1.52),('8348','2013-08-05','09:05:00',1.59),('8348','2013-08-05','09:10:00',1.64),('8348','2013-08-05','09:15:00',1.7),('8348','2013-08-05','09:20:00',1.76),('8348','2013-08-05','09:25:00',1.82),('8348','2013-08-05','09:30:00',1.87),('8348','2013-08-05','09:35:00',1.92),('8348','2013-08-05','09:40:00',1.98),('8348','2013-08-05','09:45:00',2.04),('8348','2013-08-05','09:50:00',2.09),('8348','2013-08-05','09:55:00',2.15),('8348','2013-08-05','10:00:00',2.21),('8348','2013-08-05','10:05:00',2.26),('8348','2013-08-05','10:10:00',2.31),('8348','2013-08-05','10:15:00',2.36),('8348','2013-08-05','10:20:00',2.42),('8348','2013-08-05','10:25:00',2.47),('8348','2013-08-05','10:30:00',2.49),('8348','2013-08-05','10:35:00',2.54),('8348','2013-08-05','10:40:00',2.59),('8348','2013-08-05','10:45:00',2.64),('8348','2013-08-05','10:50:00',2.7),('8348','2013-08-05','10:55:00',2.74),('8348','2013-08-05','11:00:00',2.78),('8348','2013-08-05','11:05:00',2.83),('8348','2013-08-05','11:10:00',2.84),('8348','2013-08-05','11:15:00',2.88),('8348','2013-08-05','11:20:00',2.92),('8348','2013-08-05','11:25:00',2.94),('8348','2013-08-05','11:30:00',2.98),('8348','2013-08-05','11:35:00',2.98),('8348','2013-08-05','11:40:00',3.01),('8348','2013-08-05','11:45:00',3.08),('8348','2013-08-05','11:50:00',3.08),('8348','2013-08-05','11:55:00',3.11),('8348','2013-08-05','12:00:00',3.13),('8348','2013-08-05','12:05:00',3.13),('8348','2013-08-05','12:10:00',3.15),('8348','2013-08-05','12:15:00',3.15),('8348','2013-08-05','12:20:00',3.16),('8348','2013-08-05','12:25:00',3.17),('8348','2013-08-05','12:30:00',3.2),('8348','2013-08-05','12:35:00',3.25),('8348','2013-08-05','12:40:00',3.25),('8348','2013-08-05','12:45:00',3.23),('8348','2013-08-05','12:50:00',3.25),('8348','2013-08-05','12:55:00',3.27),('8348','2013-08-05','13:00:00',3.25),('8348','2013-08-05','13:05:00',3.24),('8348','2013-08-05','13:10:00',3.25),('8348','2013-08-05','13:15:00',3.26),('8348','2013-08-05','13:20:00',3.25),('8348','2013-08-05','13:25:00',3.31),('8348','2013-08-05','13:30:00',3.3),('8348','2013-08-05','13:35:00',3.3),('8348','2013-08-05','13:40:00',3.32),('8348','2013-08-05','13:45:00',3.24),('8348','2013-08-05','13:50:00',3.28),('8348','2013-08-05','13:55:00',3.32),('8348','2013-08-05','14:00:00',3.28),('8348','2013-08-05','14:05:00',3.3),('8348','2013-08-05','14:10:00',3.32),('8348','2013-08-05','14:15:00',3.3),('8348','2013-08-05','14:20:00',3.27),('8348','2013-08-05','14:25:00',3.25),('8348','2013-08-05','14:30:00',3.25),('8348','2013-08-05','14:35:00',3.22),('8348','2013-08-05','14:40:00',3.23),('8348','2013-08-05','14:45:00',3.22),('8348','2013-08-05','14:50:00',3.21),('8348','2013-08-05','14:55:00',3.19),('8348','2013-08-05','15:00:00',3.18),('8348','2013-08-05','15:05:00',3.18),('8348','2013-08-05','15:10:00',3.16),('8348','2013-08-05','15:15:00',3.15),('8348','2013-08-05','15:20:00',3.13),('8348','2013-08-05','15:25:00',3.11),('8348','2013-08-05','15:30:00',3.09),('8348','2013-08-05','15:35:00',3.06),('8348','2013-08-05','15:40:00',3.02),('8348','2013-08-05','15:45:00',2.99),('8348','2013-08-05','15:50:00',2.93),('8348','2013-08-05','15:55:00',2.9),('8348','2013-08-05','16:00:00',2.89),('8348','2013-08-05','16:05:00',2.88),('8348','2013-08-05','16:10:00',2.82),('8348','2013-08-05','16:15:00',2.75),('8348','2013-08-05','16:20:00',2.7),('8348','2013-08-05','16:25:00',2.65),('8348','2013-08-05','16:30:00',2.61),('8348','2013-08-05','16:35:00',2.59),('8348','2013-08-05','16:40:00',2.53),('8348','2013-08-05','16:45:00',2.48),('8348','2013-08-05','16:50:00',2.41),('8348','2013-08-05','16:55:00',2.35),('8348','2013-08-05','17:00:00',2.29),('8348','2013-08-05','17:05:00',2.24),('8348','2013-08-05','17:10:00',2.18),('8348','2013-08-05','17:15:00',2.11),('8348','2013-08-05','17:20:00',2.05),('8348','2013-08-05','17:25:00',1.98),('8348','2013-08-05','17:30:00',1.92),('8348','2013-08-05','17:35:00',1.86),('8348','2013-08-05','17:40:00',1.81),('8348','2013-08-05','17:45:00',1.73),('8348','2013-08-05','17:50:00',1.66),('8348','2013-08-05','17:55:00',1.58),('8348','2013-08-05','18:00:00',1.5),('8348','2013-08-05','18:05:00',1.42),('8348','2013-08-05','18:10:00',1.35),('8348','2013-08-05','18:15:00',1.27),('8348','2013-08-05','18:20:00',1.2),('8348','2013-08-05','18:25:00',1.14),('8348','2013-08-05','18:30:00',1.07),('8348','2013-08-04','08:25:00',1.03),('8348','2013-08-04','08:30:00',1.15),('8348','2013-08-04','08:35:00',1.22),('8348','2013-08-04','08:40:00',1.3),('8348','2013-08-04','08:45:00',1.38),('8348','2013-08-04','08:50:00',1.47),('8348','2013-08-04','08:55:00',1.54),('8348','2013-08-04','09:00:00',1.61),('8348','2013-08-04','09:05:00',1.68),('8348','2013-08-04','09:10:00',1.74),('8348','2013-08-04','09:15:00',1.79),('8348','2013-08-04','09:20:00',1.85),('8348','2013-08-04','09:25:00',1.92),('8348','2013-08-04','09:30:00',1.99),('8348','2013-08-04','09:35:00',2.05),('8348','2013-08-04','09:40:00',2.1),('8348','2013-08-04','09:45:00',2.16),('8348','2013-08-04','09:50:00',2.21),('8348','2013-08-04','09:55:00',2.27),('8348','2013-08-04','10:00:00',2.32),('8348','2013-08-04','10:05:00',2.37),('8348','2013-08-04','10:10:00',2.42),('8348','2013-08-04','10:15:00',2.47),('8348','2013-08-04','10:20:00',2.52),('8348','2013-08-04','10:25:00',2.56),('8348','2013-08-04','10:30:00',2.6),('8348','2013-08-04','10:35:00',2.64),('8348','2013-08-04','10:40:00',2.69),('8348','2013-08-04','10:45:00',2.73),('8348','2013-08-04','10:50:00',2.76),('8348','2013-08-04','10:55:00',2.79),('8348','2013-08-04','11:00:00',2.82),('8348','2013-08-04','11:05:00',2.86),('8348','2013-08-04','11:10:00',2.88),('8348','2013-08-04','11:15:00',2.92),('8348','2013-08-04','11:20:00',2.96),('8348','2013-08-04','11:25:00',3.01),('8348','2013-08-04','11:30:00',3.05),('8348','2013-08-04','11:35:00',3.08),('8348','2013-08-04','11:40:00',3.09),('8348','2013-08-04','11:45:00',3.12),('8348','2013-08-04','11:50:00',3.17),('8348','2013-08-04','11:55:00',3.19),('8348','2013-08-04','12:00:00',3.22),('8348','2013-08-04','12:05:00',3.24),('8348','2013-08-04','12:10:00',3.22),('8348','2013-08-04','12:15:00',3.27),('8348','2013-08-04','12:20:00',3.25),('8348','2013-08-04','12:25:00',3.25),('8348','2013-08-04','12:30:00',3.26),('8348','2013-08-04','12:35:00',3.31),('8348','2013-08-04','12:40:00',3.33),('8348','2013-08-04','12:45:00',3.37),('8348','2013-08-04','12:50:00',3.39),('8348','2013-08-04','12:55:00',3.37),('8348','2013-08-04','13:00:00',3.36),('8348','2013-08-04','13:05:00',3.33),('8348','2013-08-04','13:10:00',3.32),('8348','2013-08-04','13:15:00',3.36),('8348','2013-08-04','13:20:00',3.33),('8348','2013-08-04','13:25:00',3.35),('8348','2013-08-04','13:30:00',3.36),('8348','2013-08-04','13:35:00',3.44),('8348','2013-08-04','13:40:00',3.51),('8348','2013-08-04','13:45:00',3.51),('8348','2013-08-04','13:50:00',3.51),('8348','2013-08-04','13:55:00',3.5),('8348','2013-08-04','14:00:00',3.53),('8348','2013-08-04','14:05:00',3.51),('8348','2013-08-04','14:10:00',3.51),('8348','2013-08-04','14:15:00',3.48),('8348','2013-08-04','14:20:00',3.46),('8348','2013-08-04','14:25:00',3.44),('8348','2013-08-04','14:30:00',3.43),('8348','2013-08-04','14:35:00',3.4),('8348','2013-08-04','14:40:00',3.4),('8348','2013-08-04','14:45:00',3.36),('8348','2013-08-04','14:50:00',3.34),('8348','2013-08-04','14:55:00',3.34),('8348','2013-08-04','15:00:00',3.31),('8348','2013-08-04','15:05:00',3.28),('8348','2013-08-04','15:10:00',3.28),('8348','2013-08-04','15:15:00',3.26),('8348','2013-08-04','15:20:00',3.23),('8348','2013-08-04','15:25:00',3.17),('8348','2013-08-04','15:30:00',3.13),('8348','2013-08-04','15:35:00',3.15),('8348','2013-08-04','15:40:00',3.08),('8348','2013-08-04','15:45:00',3.05),('8348','2013-08-04','15:50:00',3.02),('8348','2013-08-04','15:55:00',2.99),('8348','2013-08-04','16:00:00',2.94),('8348','2013-08-04','16:05:00',2.94),('8348','2013-08-04','16:10:00',2.89),('8348','2013-08-04','16:15:00',2.87),('8348','2013-08-04','16:20:00',2.84),('8348','2013-08-04','16:25:00',2.77),('8348','2013-08-04','16:30:00',2.71),('8348','2013-08-04','16:35:00',2.66),('8348','2013-08-04','16:40:00',2.62),('8348','2013-08-04','16:45:00',2.54),('8348','2013-08-04','16:50:00',2.48),('8348','2013-08-04','16:55:00',2.42),('8348','2013-08-04','17:00:00',2.37),('8348','2013-08-04','17:05:00',2.34),('8348','2013-08-04','17:10:00',2.28),('8348','2013-08-04','17:15:00',2.2),('8348','2013-08-04','17:20:00',2.14),('8348','2013-08-04','17:25:00',2.08),('8348','2013-08-04','17:30:00',2.01),('8348','2013-08-04','17:35:00',1.94),('8348','2013-08-04','17:40:00',1.87),('8348','2013-08-04','17:45:00',1.8),('8348','2013-08-04','17:50:00',1.74),('8348','2013-08-04','17:55:00',1.65),('8348','2013-08-04','18:00:00',1.58),('8348','2013-08-04','18:05:00',1.49),('8348','2013-08-04','18:10:00',1.41),('8348','2013-08-04','18:15:00',1.34),('8348','2013-08-04','18:20:00',1.28),('8348','2013-08-04','18:25:00',1.19),('8348','2013-08-04','18:30:00',1.12),('8348','2013-08-04','18:35:00',1.04),('8348','2013-08-03','08:25:00',1.03),('8348','2013-08-03','08:30:00',1.15),('8348','2013-08-03','08:35:00',1.21),('8348','2013-08-03','08:40:00',1.29),('8348','2013-08-03','08:45:00',1.38),('8348','2013-08-03','08:50:00',1.46),('8348','2013-08-03','08:55:00',1.53),('8348','2013-08-03','09:00:00',1.59),('8348','2013-08-03','09:05:00',1.66),('8348','2013-08-03','09:10:00',1.72),('8348','2013-08-03','09:15:00',1.79),('8348','2013-08-03','09:20:00',1.85),('8348','2013-08-03','09:25:00',1.92),('8348','2013-08-03','09:30:00',1.97),('8348','2013-08-03','09:35:00',2.03),('8348','2013-08-03','09:40:00',2.08),('8348','2013-08-03','09:45:00',2.14),('8348','2013-08-03','09:50:00',2.19),('8348','2013-08-03','09:55:00',2.25),('8348','2013-08-03','10:00:00',2.3),('8348','2013-08-03','10:05:00',2.36),('8348','2013-08-03','10:10:00',2.4),('8348','2013-08-03','10:15:00',2.47),('8348','2013-08-03','10:20:00',2.52),('8348','2013-08-03','10:25:00',2.56),('8348','2013-08-03','10:30:00',2.6),('8348','2013-08-03','10:35:00',2.64),('8348','2013-08-03','10:40:00',2.68),('8348','2013-08-03','10:45:00',2.72),('8348','2013-08-03','10:50:00',2.76),('8348','2013-08-03','10:55:00',2.79),('8348','2013-08-03','11:00:00',2.8),('8348','2013-08-03','11:05:00',2.85),('8348','2013-08-03','11:10:00',2.93),('8348','2013-08-03','11:15:00',2.94),('8348','2013-08-03','11:20:00',2.98),('8348','2013-08-03','11:25:00',2.98),('8348','2013-08-03','11:30:00',3.04),('8348','2013-08-03','11:35:00',3.04),('8348','2013-08-03','11:40:00',3.04),('8348','2013-08-03','11:45:00',3.11),('8348','2013-08-03','11:50:00',3.13),('8348','2013-08-03','11:55:00',3.14),('8348','2013-08-03','12:00:00',3.16),('8348','2013-08-03','12:05:00',3.16),('8348','2013-08-03','12:10:00',3.17),('8348','2013-08-03','12:15:00',3.14),('8348','2013-08-03','12:20:00',3.18),('8348','2013-08-03','12:25:00',3.19),('8348','2013-08-03','12:30:00',3.19),('8348','2013-08-03','12:35:00',3.21),('8348','2013-08-03','12:40:00',3.2),('8348','2013-08-03','12:45:00',3.23),('8348','2013-08-03','12:50:00',3.27),('8348','2013-08-03','12:55:00',3.28),('8348','2013-08-03','13:00:00',3.33),('8348','2013-08-03','13:05:00',3.33),('8348','2013-08-03','13:10:00',3.28),('8348','2013-08-03','13:15:00',3.26),('8348','2013-08-03','13:20:00',3.22),('8348','2013-08-03','13:25:00',3.25),('8348','2013-08-03','13:30:00',3.25),('8348','2013-08-03','13:35:00',3.26),('8348','2013-08-03','13:40:00',3.32),('8348','2013-08-03','13:45:00',3.35),('8348','2013-08-03','13:50:00',3.36),('8348','2013-08-03','13:55:00',3.35),('8348','2013-08-03','14:00:00',3.37),('8348','2013-08-03','14:05:00',3.34),('8348','2013-08-03','14:10:00',3.28),('8348','2013-08-03','14:15:00',3.19),('8348','2013-08-03','14:20:00',3.22),('8348','2013-08-03','14:25:00',3.24),('8348','2013-08-03','14:30:00',3.31),('8348','2013-08-03','14:35:00',3.4),('8348','2013-08-03','14:40:00',3.38),('8348','2013-08-03','14:45:00',3.37),('8348','2013-08-03','14:50:00',3.37),('8348','2013-08-03','14:55:00',3.38),('8348','2013-08-03','15:00:00',3.34),('8348','2013-08-03','15:05:00',3.3),('8348','2013-08-03','15:10:00',3.23),('8348','2013-08-03','15:15:00',3.2),('8348','2013-08-03','15:20:00',3.19),('8348','2013-08-03','15:25:00',3.19),('8348','2013-08-03','15:30:00',3.17),('8348','2013-08-03','15:35:00',3.14),('8348','2013-08-03','15:40:00',3.1),('8348','2013-08-03','15:45:00',3.08),('8348','2013-08-03','15:50:00',3.07),('8348','2013-08-03','15:55:00',3.01),('8348','2013-08-03','16:00:00',2.96),('8348','2013-08-03','16:05:00',2.91),('8348','2013-08-03','16:10:00',2.86),('8348','2013-08-03','16:15:00',2.79),('8348','2013-08-03','16:20:00',2.73),('8348','2013-08-03','16:25:00',2.68),('8348','2013-08-03','16:30:00',2.66),('8348','2013-08-03','16:35:00',2.63),('8348','2013-08-03','16:40:00',2.59),('8348','2013-08-03','16:45:00',2.54),('8348','2013-08-03','16:50:00',2.48),('8348','2013-08-03','16:55:00',2.45),('8348','2013-08-03','17:00:00',2.38),('8348','2013-08-03','17:05:00',2.32),('8348','2013-08-03','17:10:00',2.26),('8348','2013-08-03','17:15:00',2.19),('8348','2013-08-03','17:20:00',2.13),('8348','2013-08-03','17:25:00',2.07),('8348','2013-08-03','17:30:00',2.01),('8348','2013-08-03','17:35:00',1.96),('8348','2013-08-03','17:40:00',1.88),('8348','2013-08-03','17:45:00',1.81),('8348','2013-08-03','17:50:00',1.73),('8348','2013-08-03','17:55:00',1.66),('8348','2013-08-03','18:00:00',1.58),('8348','2013-08-03','18:05:00',1.52),('8348','2013-08-03','18:10:00',1.45),('8348','2013-08-03','18:15:00',1.37),('8348','2013-08-03','18:20:00',1.31),('8348','2013-08-03','18:25:00',1.24),('8348','2013-08-03','18:30:00',1.17),('8348','2013-08-03','18:35:00',1.1),('8348','2013-08-03','18:40:00',1.02),('8348','2013-08-02','08:20:00',1.02),('8348','2013-08-02','08:25:00',1.08),('8348','2013-08-02','08:30:00',1.2),('8348','2013-08-02','08:35:00',1.28),('8348','2013-08-02','08:40:00',1.36),('8348','2013-08-02','08:45:00',1.43),('8348','2013-08-02','08:50:00',1.53),('8348','2013-08-02','08:55:00',1.59),('8348','2013-08-02','09:00:00',1.66),('8348','2013-08-02','09:05:00',1.73),('8348','2013-08-02','09:10:00',1.79),('8348','2013-08-02','09:15:00',1.85),('8348','2013-08-02','09:20:00',1.92),('8348','2013-08-02','09:25:00',1.98),('8348','2013-08-02','09:30:00',2.04),('8348','2013-08-02','09:35:00',2.09),('8348','2013-08-02','09:40:00',2.15),('8348','2013-08-02','09:45:00',2.2),('8348','2013-08-02','09:50:00',2.25),('8348','2013-08-02','09:55:00',2.32),('8348','2013-08-02','10:00:00',2.36),('8348','2013-08-02','10:05:00',2.4),('8348','2013-08-02','10:10:00',2.46),('8348','2013-08-02','10:15:00',2.51),('8348','2013-08-02','10:20:00',2.56),('8348','2013-08-02','10:25:00',2.6),('8348','2013-08-02','10:30:00',2.64),('8348','2013-08-02','10:35:00',2.68),('8348','2013-08-02','10:40:00',2.72),('8348','2013-08-02','10:45:00',2.77),('8348','2013-08-02','10:50:00',2.81),('8348','2013-08-02','10:55:00',2.83),('8348','2013-08-02','11:00:00',2.87),('8348','2013-08-02','11:05:00',2.91),('8348','2013-08-02','11:10:00',2.93),('8348','2013-08-02','11:15:00',2.96),('8348','2013-08-02','11:20:00',2.99),('8348','2013-08-02','11:25:00',3.04),('8348','2013-08-02','11:30:00',3.06),('8348','2013-08-02','11:35:00',3.09),('8348','2013-08-02','11:40:00',3.11),('8348','2013-08-02','11:45:00',3.12),('8348','2013-08-02','11:50:00',3.15),('8348','2013-08-02','11:55:00',3.2),('8348','2013-08-02','12:00:00',3.23),('8348','2013-08-02','12:05:00',3.23),('8348','2013-08-02','12:10:00',3.26),('8348','2013-08-02','12:15:00',3.28),('8348','2013-08-02','12:20:00',3.29),('8348','2013-08-02','12:25:00',3.3),('8348','2013-08-02','12:30:00',3.29),('8348','2013-08-02','12:35:00',3.28),('8348','2013-08-02','12:40:00',3.28),('8348','2013-08-02','12:45:00',3.31),('8348','2013-08-02','12:50:00',3.34),('8348','2013-08-02','12:55:00',3.35),('8348','2013-08-02','13:00:00',3.4),('8348','2013-08-02','13:05:00',3.41),('8348','2013-08-02','13:10:00',3.43),('8348','2013-08-02','13:15:00',3.41),('8348','2013-08-02','13:20:00',3.39),('8348','2013-08-02','13:25:00',3.37),('8348','2013-08-02','13:30:00',3.39),('8348','2013-08-02','13:35:00',3.43),('8348','2013-08-02','13:40:00',3.45),('8348','2013-08-02','13:45:00',3.42),('8348','2013-08-02','13:50:00',3.43),('8348','2013-08-02','13:55:00',3.42),('8348','2013-08-02','14:00:00',3.39),('8348','2013-08-02','14:05:00',3.41),('8348','2013-08-02','14:10:00',3.35),('8348','2013-08-02','14:15:00',3.31),('8348','2013-08-02','14:20:00',3.29),('8348','2013-08-02','14:25:00',3.26),('8348','2013-08-02','14:30:00',3.28),('8348','2013-08-02','14:35:00',3.36),('8348','2013-08-02','14:40:00',3.4),('8348','2013-08-02','14:45:00',3.42),('8348','2013-08-02','14:50:00',3.41),('8348','2013-08-02','14:55:00',3.39),('8348','2013-08-02','15:00:00',3.38),('8348','2013-08-02','15:05:00',3.36),('8348','2013-08-02','15:10:00',3.31),('8348','2013-08-02','15:15:00',3.24),('8348','2013-08-02','15:20:00',3.27),('8348','2013-08-02','15:25:00',3.27),('8348','2013-08-02','15:30:00',3.24),('8348','2013-08-02','15:35:00',3.22),('8348','2013-08-02','15:40:00',3.17),('8348','2013-08-02','15:45:00',3.14),('8348','2013-08-02','15:50:00',3.12),('8348','2013-08-02','15:55:00',3.06),('8348','2013-08-02','16:00:00',3.04),('8348','2013-08-02','16:05:00',2.99),('8348','2013-08-02','16:10:00',2.93),('8348','2013-08-02','16:15:00',2.9),('8348','2013-08-02','16:20:00',2.86),('8348','2013-08-02','16:25:00',2.81),('8348','2013-08-02','16:30:00',2.77),('8348','2013-08-02','16:35:00',2.74),('8348','2013-08-02','16:40:00',2.68),('8348','2013-08-02','16:45:00',2.61),('8348','2013-08-02','16:50:00',2.57),('8348','2013-08-02','16:55:00',2.49),('8348','2013-08-02','17:00:00',2.42),('8348','2013-08-02','17:05:00',2.37),('8348','2013-08-02','17:10:00',2.31),('8348','2013-08-02','17:15:00',2.26),('8348','2013-08-02','17:20:00',2.2),('8348','2013-08-02','17:25:00',2.14),('8348','2013-08-02','17:30:00',2.06),('8348','2013-08-02','17:35:00',2),('8348','2013-08-02','17:40:00',1.95),('8348','2013-08-02','17:45:00',1.87),('8348','2013-08-02','17:50:00',1.79),('8348','2013-08-02','17:55:00',1.72),('8348','2013-08-02','18:00:00',1.65),('8348','2013-08-02','18:05:00',1.58),('8348','2013-08-02','18:10:00',1.51),('8348','2013-08-02','18:15:00',1.43),('8348','2013-08-02','18:20:00',1.36),('8348','2013-08-02','18:25:00',1.29),('8348','2013-08-02','18:30:00',1.21),('8348','2013-08-02','18:35:00',1.13),('8348','2013-08-02','18:40:00',1.05),('8348','2013-08-01','08:20:00',1.02),('8348','2013-08-01','08:25:00',1.1),('8348','2013-08-01','08:30:00',1.22),('8348','2013-08-01','08:35:00',1.31),('8348','2013-08-01','08:40:00',1.36),('8348','2013-08-01','08:45:00',1.47),('8348','2013-08-01','08:50:00',1.56),('8348','2013-08-01','08:55:00',1.63),('8348','2013-08-01','09:00:00',1.7),('8348','2013-08-01','09:05:00',1.76),('8348','2013-08-01','09:10:00',1.84),('8348','2013-08-01','09:15:00',1.91),('8348','2013-08-01','09:20:00',1.97),('8348','2013-08-01','09:25:00',2.04),('8348','2013-08-01','09:30:00',2.1),('8348','2013-08-01','09:35:00',2.16),('8348','2013-08-01','09:40:00',2.23),('8348','2013-08-01','09:45:00',2.29),('8348','2013-08-01','09:50:00',2.35),('8348','2013-08-01','09:55:00',2.4),('8348','2013-08-01','10:00:00',2.47),('8348','2013-08-01','10:05:00',2.53),('8348','2013-08-01','10:10:00',2.59),('8348','2013-08-01','10:15:00',2.65),('8348','2013-08-01','10:20:00',2.68),('8348','2013-08-01','10:25:00',2.74),('8348','2013-08-01','10:30:00',2.79),('8348','2013-08-01','10:35:00',2.83),('8348','2013-08-01','10:40:00',2.87),('8348','2013-08-01','10:45:00',2.91),('8348','2013-08-01','10:50:00',2.97),('8348','2013-08-01','10:55:00',3.01),('8348','2013-08-01','11:00:00',3.05),('8348','2013-08-01','11:05:00',3.11),('8348','2013-08-01','11:10:00',3.15),('8348','2013-08-01','11:15:00',3.19),('8348','2013-08-01','11:20:00',3.2),('8348','2013-08-01','11:25:00',3.24),('8348','2013-08-01','11:30:00',3.26),('8348','2013-08-01','11:35:00',3.3),('8348','2013-08-01','11:40:00',3.35),('8348','2013-08-01','11:45:00',3.37),('8348','2013-08-01','11:50:00',3.4),('8348','2013-08-01','11:55:00',3.42),('8348','2013-08-01','12:00:00',3.45),('8348','2013-08-01','12:05:00',3.47),('8348','2013-08-01','12:10:00',3.46),('8348','2013-08-01','12:15:00',3.5),('8348','2013-08-01','12:20:00',3.51),('8348','2013-08-01','12:25:00',3.53),('8348','2013-08-01','12:30:00',3.54),('8348','2013-08-01','12:35:00',3.57),('8348','2013-08-01','12:40:00',3.58),('8348','2013-08-01','12:45:00',3.58),('8348','2013-08-01','12:50:00',3.62),('8348','2013-08-01','12:55:00',3.61),('8348','2013-08-01','13:00:00',3.6),('8348','2013-08-01','13:05:00',3.59),('8348','2013-08-01','13:10:00',3.61),('8348','2013-08-01','13:15:00',3.48),('8348','2013-08-01','13:20:00',3.61),('8348','2013-08-01','13:25:00',3.65),('8348','2013-08-01','13:30:00',3.67),('8348','2013-08-01','13:35:00',2.96),('8348','2013-08-01','13:40:00',3.69),('8348','2013-08-01','13:45:00',3.66),('8348','2013-08-01','13:50:00',3.5),('8348','2013-08-01','13:55:00',3.62),('8348','2013-08-01','14:00:00',3.67),('8348','2013-08-01','14:05:00',3.6),('8348','2013-08-01','14:10:00',3.57),('8348','2013-08-01','14:15:00',3.52),('8348','2013-08-01','14:20:00',3.5),('8348','2013-08-01','14:25:00',3.5),('8348','2013-08-01','14:30:00',3.5),('8348','2013-08-01','14:35:00',3.06),('8348','2013-08-01','14:40:00',3.36),('8348','2013-08-01','14:45:00',3.5),('8348','2013-08-01','14:50:00',2.31),('8348','2013-08-01','14:55:00',3.46),('8348','2013-08-01','15:00:00',3.37),('8348','2013-08-01','15:05:00',3.39),('8348','2013-08-01','15:10:00',3.29),('8348','2013-08-01','15:15:00',3.26),('8348','2013-08-01','15:20:00',3.36),('8348','2013-08-01','15:25:00',3.32),('8348','2013-08-01','15:30:00',3.24),('8348','2013-08-01','15:35:00',3.24),('8348','2013-08-01','15:40:00',2.19),('8348','2013-08-01','15:45:00',3.17),('8348','2013-08-01','15:50:00',3.12),('8348','2013-08-01','15:55:00',3.11),('8348','2013-08-01','16:00:00',3.11),('8348','2013-08-01','16:05:00',3.07),('8348','2013-08-01','16:10:00',2.98),('8348','2013-08-01','16:15:00',2.92),('8348','2013-08-01','16:20:00',2.89),('8348','2013-08-01','16:25:00',2.83),('8348','2013-08-01','16:30:00',2.78),('8348','2013-08-01','16:35:00',2.73),('8348','2013-08-01','16:40:00',2.68),('8348','2013-08-01','16:45:00',2.62),('8348','2013-08-01','16:50:00',2.57),('8348','2013-08-01','16:55:00',2.52),('8348','2013-08-01','17:00:00',2.46),('8348','2013-08-01','17:05:00',2.4),('8348','2013-08-01','17:10:00',2.34),('8348','2013-08-01','17:15:00',2.28),('8348','2013-08-01','17:20:00',2.23),('8348','2013-08-01','17:25:00',2.16),('8348','2013-08-01','17:30:00',2.11),('8348','2013-08-01','17:35:00',2.05),('8348','2013-08-01','17:40:00',1.97),('8348','2013-08-01','17:45:00',1.9),('8348','2013-08-01','17:50:00',1.83),('8348','2013-08-01','17:55:00',1.78),('8348','2013-08-01','18:00:00',1.71),('8348','2013-08-01','18:05:00',1.63),('8348','2013-08-01','18:10:00',1.56),('8348','2013-08-01','18:15:00',1.49),('8348','2013-08-01','18:20:00',1.42),('8348','2013-08-01','18:25:00',1.34),('8348','2013-08-01','18:30:00',1.27),('8348','2013-08-01','18:35:00',1.19),('8348','2013-08-01','18:40:00',1.11),('8348','2013-08-01','18:45:00',1.04),('8348','2013-07-31','08:20:00',1.05),('8348','2013-07-31','08:25:00',1.15),('8348','2013-07-31','08:30:00',1.21),('8348','2013-07-31','08:35:00',1.34),('8348','2013-07-31','08:40:00',1.41),('8348','2013-07-31','08:45:00',1.52),('8348','2013-07-31','08:50:00',1.6),('8348','2013-07-31','08:55:00',1.67),('8348','2013-07-31','09:00:00',1.74),('8348','2013-07-31','09:05:00',1.8),('8348','2013-07-31','09:10:00',1.88),('8348','2013-07-31','09:15:00',1.94),('8348','2013-07-31','09:20:00',2),('8348','2013-07-31','09:25:00',2.06),('8348','2013-07-31','09:30:00',2.13),('8348','2013-07-31','09:35:00',2.2),('8348','2013-07-31','09:40:00',2.26),('8348','2013-07-31','09:45:00',2.31),('8348','2013-07-31','09:50:00',2.36),('8348','2013-07-31','09:55:00',2.41),('8348','2013-07-31','10:00:00',2.46),('8348','2013-07-31','10:05:00',2.52),('8348','2013-07-31','10:10:00',2.58),('8348','2013-07-31','10:15:00',2.66),('8348','2013-07-31','10:20:00',2.7),('8348','2013-07-31','10:25:00',2.72),('8348','2013-07-31','10:30:00',2.76),('8348','2013-07-31','10:35:00',2.83),('8348','2013-07-31','10:40:00',2.9),('8348','2013-07-31','10:45:00',2.96),('8348','2013-07-31','10:50:00',3),('8348','2013-07-31','10:55:00',3.05),('8348','2013-07-31','11:00:00',3.09),('8348','2013-07-31','11:05:00',3.13),('8348','2013-07-31','11:10:00',3.16),('8348','2013-07-31','11:15:00',3.19),('8348','2013-07-31','11:20:00',3.23),('8348','2013-07-31','11:25:00',3.27),('8348','2013-07-31','11:30:00',3.3),('8348','2013-07-31','11:35:00',3.32),('8348','2013-07-31','11:40:00',3.34),('8348','2013-07-31','11:45:00',3.38),('8348','2013-07-31','11:50:00',3.45),('8348','2013-07-31','11:55:00',3.48),('8348','2013-07-31','12:00:00',3.46),('8348','2013-07-31','12:05:00',3.45),('8348','2013-07-31','12:10:00',3.45),('8348','2013-07-31','12:15:00',3.51),('8348','2013-07-31','12:20:00',3.51),('8348','2013-07-31','12:25:00',3.6),('8348','2013-07-31','12:30:00',3.57),('8348','2013-07-31','12:35:00',3.56),('8348','2013-07-31','12:40:00',3.62),('8348','2013-07-31','12:45:00',2.98),('8348','2013-07-31','12:50:00',2.01),('8348','2013-07-31','12:55:00',3.41),('8348','2013-07-31','13:00:00',1.41),('8348','2013-07-31','13:05:00',3.33),('8348','2013-07-31','13:10:00',3.57),('8348','2013-07-31','13:15:00',3.69),('8348','2013-07-31','13:20:00',3.6),('8348','2013-07-31','13:25:00',3.18),('8348','2013-07-31','13:30:00',3.67),('8348','2013-07-31','13:35:00',3.66),('8348','2013-07-31','13:40:00',3.66),('8348','2013-07-31','13:45:00',3.73),('8348','2013-07-31','13:50:00',3.8),('8348','2013-07-31','13:55:00',1.75),('8348','2013-07-31','14:00:00',3.68),('8348','2013-07-31','14:05:00',3.72),('8348','2013-07-31','14:10:00',3.22),('8348','2013-07-31','14:15:00',3.16),('8348','2013-07-31','14:20:00',3.23),('8348','2013-07-31','14:25:00',3.17),('8348','2013-07-31','14:30:00',3.62),('8348','2013-07-31','14:35:00',3.53),('8348','2013-07-31','14:40:00',3.57),('8348','2013-07-31','14:45:00',3.51),('8348','2013-07-31','14:50:00',3.24),('8348','2013-07-31','14:55:00',2.21),('8348','2013-07-31','15:00:00',1.7),('8348','2013-07-31','15:05:00',3.64),('8348','2013-07-31','15:10:00',3.29),('8348','2013-07-31','15:15:00',2.51),('8348','2013-07-31','15:20:00',3.24),('8348','2013-07-31','15:25:00',3.09),('8348','2013-07-31','15:30:00',3.23),('8348','2013-07-31','15:35:00',3.34),('8348','2013-07-31','15:40:00',3.3),('8348','2013-07-31','15:45:00',3.19),('8348','2013-07-31','15:50:00',3.15),('8348','2013-07-31','15:55:00',3.09),('8348','2013-07-31','16:00:00',3.02),('8348','2013-07-31','16:05:00',3.03),('8348','2013-07-31','16:10:00',3.02),('8348','2013-07-31','16:15:00',2.95),('8348','2013-07-31','16:20:00',2.97),('8348','2013-07-31','16:25:00',2.97),('8348','2013-07-31','16:30:00',2.9),('8348','2013-07-31','16:35:00',2.71),('8348','2013-07-31','16:40:00',2.65),('8348','2013-07-31','16:45:00',2.59),('8348','2013-07-31','16:50:00',2.56),('8348','2013-07-31','16:55:00',2.5),('8348','2013-07-31','17:00:00',2.38),('8348','2013-07-31','17:05:00',2.15),('8348','2013-07-31','17:10:00',2.32),('8348','2013-07-31','17:15:00',1.86),('8348','2013-07-31','17:20:00',1.85),('8348','2013-07-31','17:25:00',2.18),('8348','2013-07-31','17:30:00',2.05),('8348','2013-07-31','17:35:00',1.97),('8348','2013-07-31','17:40:00',1.96),('8348','2013-07-31','17:45:00',1.86),('8348','2013-07-31','17:50:00',1.81),('8348','2013-07-31','17:55:00',1.74),('8348','2013-07-31','18:00:00',1.68),('8348','2013-07-31','18:05:00',1.61),('8348','2013-07-31','18:10:00',1.54),('8348','2013-07-31','18:15:00',1.49),('8348','2013-07-31','18:20:00',1.43),('8348','2013-07-31','18:25:00',1.37),('8348','2013-07-31','18:30:00',1.3),('8348','2013-07-31','18:35:00',1.23),('8348','2013-07-31','18:40:00',1.15),('8348','2013-07-31','18:45:00',1.07),('8348','2014-04-08','06:50:00',1.04),('8348','2014-04-08','07:00:00',1.05),('8348','2014-04-08','07:05:00',1.13),('8348','2014-04-08','07:10:00',1.33),('8348','2014-04-08','07:15:00',1.67),('8348','2014-04-08','07:20:00',1.84),('8348','2014-04-08','07:25:00',1.4),('8348','2014-04-08','07:30:00',1.76),('8348','2014-04-08','07:35:00',1.74),('8348','2014-04-08','07:40:00',1.56),('8348','2014-04-08','07:45:00',1.99),('8348','2014-04-08','07:50:00',2.06),('8348','2014-04-08','07:55:00',2.19),('8348','2014-04-08','08:00:00',2.35),('8348','2014-04-08','08:05:00',2.46),('8348','2014-04-08','08:10:00',2.67),('8348','2014-04-08','08:15:00',2.97),('8348','2014-04-08','08:20:00',3.17),('8348','2014-04-08','08:25:00',3.34),('8348','2014-04-08','08:30:00',3.48),('8348','2014-04-08','08:35:00',3.59),('8348','2014-04-08','08:40:00',3.68),('8348','2014-04-08','08:45:00',3.84),('8348','2014-04-08','08:50:00',3.95),('8348','2014-04-08','08:55:00',4.04),('8348','2014-04-08','09:00:00',4.13),('8348','2014-04-08','09:05:00',4.17),('8348','2014-04-08','09:10:00',4.34),('8348','2014-04-08','09:15:00',4.62),('8348','2014-04-08','09:20:00',4.7),('8348','2014-04-08','09:25:00',4.78),('8348','2014-04-08','09:30:00',4.94),('8348','2014-04-08','09:35:00',5.04),('8348','2014-04-08','09:40:00',5.04),('8348','2014-04-08','09:45:00',5.07),('8348','2014-04-08','09:50:00',5.24),('8348','2014-04-08','09:55:00',5.33),('8348','2014-04-08','10:00:00',5.25),('8348','2014-04-08','10:05:00',5.6),('8348','2014-04-08','10:10:00',5.72),('8348','2014-04-08','10:15:00',5.78),('8348','2014-04-08','10:20:00',5.99),('8348','2014-04-08','10:25:00',6.01),('8348','2014-04-08','10:30:00',5.83),('8348','2014-04-08','10:35:00',5.76),('8348','2014-04-08','10:40:00',6.1),('8348','2014-04-08','10:45:00',6.2),('8348','2014-04-08','10:50:00',6.1),('8348','2014-04-08','10:55:00',6.32),('8348','2014-04-08','11:00:00',6.4),('8348','2014-04-08','11:05:00',6.24),('8348','2014-04-08','11:10:00',6.18),('8348','2014-04-08','11:15:00',5.83),('8348','2014-04-08','11:20:00',5.98),('8348','2014-04-08','11:25:00',5.89),('8348','2014-04-08','11:30:00',7.03),('8348','2014-04-08','11:35:00',6.92),('8348','2014-04-08','11:40:00',5.79),('8348','2014-04-08','11:45:00',4.81),('8348','2014-04-08','11:50:00',6.02),('8348','2014-04-08','11:55:00',6.84),('8348','2014-04-08','12:00:00',6.46),('8348','2014-04-08','12:05:00',6.91),('8348','2014-04-08','12:10:00',6.97),('8348','2014-04-08','12:15:00',7.17),('8348','2014-04-08','12:20:00',7.08),('8348','2014-04-08','12:25:00',7.1),('8348','2014-04-08','12:30:00',7.16),('8348','2014-04-08','12:35:00',7.23),('8348','2014-04-08','12:40:00',7.21),('8348','2014-04-08','12:45:00',7.08),('8348','2014-04-08','12:50:00',7.17),('8348','2014-04-08','12:55:00',7.17),('8348','2014-04-08','13:00:00',7.09),('8348','2014-04-08','13:05:00',7.1),('8348','2014-04-08','13:10:00',7.18),('8348','2014-04-08','13:15:00',7.14),('8348','2014-04-08','13:20:00',6.66),('8348','2014-04-08','13:25:00',6.76),('8348','2014-04-08','13:30:00',7.06),('8348','2014-04-08','13:35:00',6.63),('8348','2014-04-08','13:40:00',6.27),('8348','2014-04-08','13:45:00',5.99),('8348','2014-04-08','13:50:00',6.69),('8348','2014-04-08','13:55:00',6.92),('8348','2014-04-08','14:00:00',6.75),('8348','2014-04-08','14:05:00',6.62),('8348','2014-04-08','14:10:00',6.65),('8348','2014-04-08','14:15:00',6.55),('8348','2014-04-08','14:20:00',6.39),('8348','2014-04-08','14:25:00',6.33),('8348','2014-04-08','14:30:00',5.74),('8348','2014-04-08','14:35:00',6.13),('8348','2014-04-08','14:40:00',6.1),('8348','2014-04-08','14:45:00',5.78),('8348','2014-04-08','14:50:00',5.93),('8348','2014-04-08','14:55:00',5.84),('8348','2014-04-08','15:00:00',5.59),('8348','2014-04-08','15:05:00',5.48),('8348','2014-04-08','15:10:00',5.28),('8348','2014-04-08','15:15:00',4.99),('8348','2014-04-08','15:20:00',4.56),('8348','2014-04-08','15:25:00',4.97),('8348','2014-04-08','15:30:00',5.19),('8348','2014-04-08','15:35:00',5.06),('8348','2014-04-08','15:40:00',4.74),('8348','2014-04-08','15:45:00',4.55),('8348','2014-04-08','15:50:00',4.65),('8348','2014-04-08','15:55:00',4.25),('8348','2014-04-08','16:00:00',4.02),('8348','2014-04-08','16:05:00',4.17),('8348','2014-04-08','16:10:00',3.94),('8348','2014-04-08','16:15:00',3.82),('8348','2014-04-08','16:20:00',3.68),('8348','2014-04-08','16:25:00',3.36),('8348','2014-04-08','16:30:00',3.11),('8348','2014-04-08','16:35:00',2.86),('8348','2014-04-08','16:40:00',2.84),('8348','2014-04-08','16:45:00',2.7),('8348','2014-04-08','16:50:00',2.59),('8348','2014-04-08','16:55:00',2.32),('8348','2014-04-08','17:00:00',2.32),('8348','2014-04-08','17:05:00',2.25),('8348','2014-04-08','17:10:00',2.04),('8348','2014-04-08','17:15:00',1.96),('8348','2014-04-08','17:20:00',1.73),('8348','2014-04-08','17:25:00',1.4),('8348','2014-04-08','17:30:00',1.14),('8348','2013-07-30','08:15:00',1.05),('8348','2013-07-30','08:20:00',1.21),('8348','2013-07-30','08:25:00',1.21),('8348','2013-07-30','08:30:00',1.25),('8348','2013-07-30','08:35:00',1.31),('8348','2013-07-30','08:40:00',1.39),('8348','2013-07-30','08:45:00',1.48),('8348','2013-07-30','08:50:00',1.56),('8348','2013-07-30','08:55:00',1.65),('8348','2013-07-30','09:00:00',1.72),('8348','2013-07-30','09:05:00',1.73),('8348','2013-07-30','09:10:00',1.87),('8348','2013-07-30','09:15:00',2),('8348','2013-07-30','09:20:00',2.11),('8348','2013-07-30','09:25:00',2.05),('8348','2013-07-30','09:30:00',1.47),('8348','2013-07-30','09:35:00',2.08),('8348','2013-07-30','09:40:00',1.78),('8348','2013-07-30','09:45:00',2.09),('8348','2013-07-30','09:50:00',2.43),('8348','2013-07-30','09:55:00',1.68),('8348','2013-07-30','10:00:00',1.98),('8348','2013-07-30','10:05:00',2.58),('8348','2013-07-30','10:10:00',2.69),('8348','2013-07-30','10:15:00',2.72),('8348','2013-07-30','10:20:00',2.8),('8348','2013-07-30','10:25:00',2.84),('8348','2013-07-30','10:30:00',2.86),('8348','2013-07-30','10:35:00',2.86),('8348','2013-07-30','10:40:00',2.85),('8348','2013-07-30','10:45:00',2.93),('8348','2013-07-30','10:50:00',2.88),('8348','2013-07-30','10:55:00',2.89),('8348','2013-07-30','11:00:00',2.98),('8348','2013-07-30','11:05:00',3.04),('8348','2013-07-30','11:10:00',2.46),('8348','2013-07-30','11:15:00',1.22),('8348','2013-07-30','11:20:00',2.5),('8348','2013-07-30','11:25:00',1.49),('8348','2013-07-30','11:30:00',1.74),('8348','2013-07-30','11:35:00',3.48),('8348','2013-07-30','11:40:00',3.39),('8348','2013-07-30','11:45:00',3.34),('8348','2013-07-30','11:50:00',3.43),('8348','2013-07-30','11:55:00',3.09),('8348','2013-07-30','12:00:00',3.28),('8348','2013-07-30','12:05:00',3.33),('8348','2013-07-30','12:10:00',3.26),('8348','2013-07-30','12:15:00',3.29),('8348','2013-07-30','12:20:00',3.41),('8348','2013-07-30','12:25:00',3.5),('8348','2013-07-30','12:30:00',3.53),('8348','2013-07-30','12:35:00',3.45),('8348','2013-07-30','12:40:00',1.08),('8348','2013-07-30','12:45:00',2.19),('8348','2013-07-30','12:50:00',3.81),('8348','2013-07-30','12:55:00',3.79),('8348','2013-07-30','13:00:00',2.8),('8348','2013-07-30','13:05:00',3.21),('8348','2013-07-30','13:10:00',3.04),('8348','2013-07-30','13:15:00',2.45),('8348','2013-07-30','13:20:00',3.8),('8348','2013-07-30','13:25:00',3.7),('8348','2013-07-30','13:30:00',3.96),('8348','2013-07-30','13:35:00',3.88),('8348','2013-07-30','13:40:00',3.87),('8348','2013-07-30','13:45:00',3.75),('8348','2013-07-30','13:50:00',3.86),('8348','2013-07-30','13:55:00',3.82),('8348','2013-07-30','14:00:00',3.74),('8348','2013-07-30','14:05:00',3.5),('8348','2013-07-30','14:10:00',3.81),('8348','2013-07-30','14:15:00',3.47),('8348','2013-07-30','14:20:00',3.65),('8348','2013-07-30','14:25:00',3.62),('8348','2013-07-30','14:30:00',3.56),('8348','2013-07-30','14:35:00',3.6),('8348','2013-07-30','14:40:00',3.58),('8348','2013-07-30','14:45:00',2.31),('8348','2013-07-30','14:50:00',3.57),('8348','2013-07-30','14:55:00',3.43),('8348','2013-07-30','15:00:00',3.47),('8348','2013-07-30','15:05:00',3.43),('8348','2013-07-30','15:10:00',3.29),('8348','2013-07-30','15:15:00',3.32),('8348','2013-07-30','15:20:00',3.31),('8348','2013-07-30','15:25:00',3.19),('8348','2013-07-30','15:30:00',3.25),('8348','2013-07-30','15:35:00',3.25),('8348','2013-07-30','15:40:00',3.2),('8348','2013-07-30','15:45:00',3.15),('8348','2013-07-30','15:50:00',3.11),('8348','2013-07-30','15:55:00',3.06),('8348','2013-07-30','16:00:00',3.05),('8348','2013-07-30','16:05:00',2.99),('8348','2013-07-30','16:10:00',2.92),('8348','2013-07-30','16:15:00',2.88),('8348','2013-07-30','16:20:00',2.85),('8348','2013-07-30','16:25:00',2.81),('8348','2013-07-30','16:30:00',2.73),('8348','2013-07-30','16:35:00',2.71),('8348','2013-07-30','16:40:00',2.68),('8348','2013-07-30','16:45:00',2.63),('8348','2013-07-30','16:50:00',2.56),('8348','2013-07-30','16:55:00',2.51),('8348','2013-07-30','17:00:00',2.47),('8348','2013-07-30','17:05:00',2.4),('8348','2013-07-30','17:10:00',2.33),('8348','2013-07-30','17:15:00',2.27),('8348','2013-07-30','17:20:00',2.22),('8348','2013-07-30','17:25:00',2.18),('8348','2013-07-30','17:30:00',2.09),('8348','2013-07-30','17:35:00',2.02),('8348','2013-07-30','17:40:00',1.96),('8348','2013-07-30','17:45:00',1.89),('8348','2013-07-30','17:50:00',1.8),('8348','2013-07-30','17:55:00',1.7),('8348','2013-07-30','18:00:00',1.64),('8348','2013-07-30','18:05:00',1.58),('8348','2013-07-30','18:10:00',1.51),('8348','2013-07-30','18:15:00',1.44),('8348','2013-07-30','18:20:00',1.37),('8348','2013-07-30','18:25:00',1.31),('8348','2013-07-30','18:30:00',1.22),('8348','2013-07-30','18:35:00',1.13),('8348','2013-07-30','18:40:00',1.05),('8348','2013-07-29','08:20:00',1.01),('8348','2013-07-29','08:25:00',1.06),('8348','2013-07-29','08:30:00',1.11),('8348','2013-07-29','08:35:00',1.16),('8348','2013-07-29','08:40:00',1.26),('8348','2013-07-29','08:45:00',1.36),('8348','2013-07-29','08:50:00',1.45),('8348','2013-07-29','08:55:00',1.5),('8348','2013-07-29','09:00:00',1.56),('8348','2013-07-29','09:05:00',1.63),('8348','2013-07-29','09:10:00',1.68),('8348','2013-07-29','09:15:00',1.74),('8348','2013-07-29','09:20:00',1.79),('8348','2013-07-29','09:25:00',1.86),('8348','2013-07-29','09:30:00',1.92),('8348','2013-07-29','09:35:00',1.96),('8348','2013-07-29','09:40:00',2.03),('8348','2013-07-29','09:45:00',2.12),('8348','2013-07-29','09:50:00',2.18),('8348','2013-07-29','09:55:00',2.22),('8348','2013-07-29','10:00:00',2.27),('8348','2013-07-29','10:05:00',2.33),('8348','2013-07-29','10:10:00',2.4),('8348','2013-07-29','10:15:00',2.43),('8348','2013-07-29','10:20:00',2.49),('8348','2013-07-29','10:25:00',2.57),('8348','2013-07-29','10:30:00',2.61),('8348','2013-07-29','10:35:00',2.63),('8348','2013-07-29','10:40:00',2.66),('8348','2013-07-29','10:45:00',2.74),('8348','2013-07-29','10:50:00',2.75),('8348','2013-07-29','10:55:00',2.8),('8348','2013-07-29','11:00:00',2.8),('8348','2013-07-29','11:05:00',2.87),('8348','2013-07-29','11:10:00',2.91),('8348','2013-07-29','11:15:00',2.91),('8348','2013-07-29','11:20:00',2.92),('8348','2013-07-29','11:25:00',2.99),('8348','2013-07-29','11:30:00',2.99),('8348','2013-07-29','11:35:00',2.97),('8348','2013-07-29','11:40:00',2.99),('8348','2013-07-29','11:45:00',3.02),('8348','2013-07-29','11:50:00',3.05),('8348','2013-07-29','11:55:00',3.08),('8348','2013-07-29','12:00:00',3.1),('8348','2013-07-29','12:05:00',3.14),('8348','2013-07-29','12:10:00',3.2),('8348','2013-07-29','12:15:00',3.23),('8348','2013-07-29','12:20:00',3.21),('8348','2013-07-29','12:25:00',3.22),('8348','2013-07-29','12:30:00',3.25),('8348','2013-07-29','12:35:00',3.29),('8348','2013-07-29','12:40:00',3.29),('8348','2013-07-29','12:45:00',3.27),('8348','2013-07-29','12:50:00',3.25),('8348','2013-07-29','12:55:00',3.25),('8348','2013-07-29','13:00:00',3.32),('8348','2013-07-29','13:05:00',3.37),('8348','2013-07-29','13:10:00',3.43),('8348','2013-07-29','13:15:00',3.45),('8348','2013-07-29','13:20:00',3.5),('8348','2013-07-29','13:25:00',3.53),('8348','2013-07-29','13:30:00',3.55),('8348','2013-07-29','13:35:00',3.54),('8348','2013-07-29','13:40:00',3.56),('8348','2013-07-29','13:45:00',3.57),('8348','2013-07-29','13:50:00',3.57),('8348','2013-07-29','13:55:00',3.57),('8348','2013-07-29','14:00:00',3.58),('8348','2013-07-29','14:05:00',3.57),('8348','2013-07-29','14:10:00',3.55),('8348','2013-07-29','14:15:00',3.53),('8348','2013-07-29','14:20:00',3.53),('8348','2013-07-29','14:25:00',3.49),('8348','2013-07-29','14:30:00',3.48),('8348','2013-07-29','14:35:00',3.47),('8348','2013-07-29','14:40:00',3.45),('8348','2013-07-29','14:45:00',3.43),('8348','2013-07-29','14:50:00',3.41),('8348','2013-07-29','14:55:00',3.39),('8348','2013-07-29','15:00:00',3.37),('8348','2013-07-29','15:05:00',3.34),('8348','2013-07-29','15:10:00',3.32),('8348','2013-07-29','15:15:00',3.29),('8348','2013-07-29','15:20:00',3.26),('8348','2013-07-29','15:25:00',3.23),('8348','2013-07-29','15:30:00',3.2),('8348','2013-07-29','15:35:00',3.21),('8348','2013-07-29','15:40:00',3.26),('8348','2013-07-29','15:45:00',3.27),('8348','2013-07-29','15:50:00',2.7),('8348','2013-07-29','15:55:00',1.83),('8348','2013-07-29','16:00:00',1.69),('8348','2013-07-29','16:05:00',2.74),('8348','2013-07-29','16:10:00',2.72),('8348','2013-07-29','16:15:00',2.57),('8348','2013-07-29','16:20:00',2.43),('8348','2013-07-29','16:25:00',2.34),('8348','2013-07-29','16:30:00',2.96),('8348','2013-07-29','16:35:00',2.61),('8348','2013-07-29','16:40:00',2.33),('8348','2013-07-29','16:45:00',2.82),('8348','2013-07-29','16:50:00',2.52),('8348','2013-07-29','16:55:00',1.61),('8348','2013-07-29','17:00:00',1.31),('8348','2013-07-29','17:05:00',1.93),('8348','2013-07-29','17:10:00',1.25),('8348','2013-07-29','17:15:00',1.18),('8348','2013-07-29','17:20:00',2.2),('8348','2013-07-29','17:25:00',2.04),('8348','2013-07-29','17:30:00',1.29),('8348','2013-07-29','17:40:00',1.12),('8348','2013-07-29','17:45:00',1.93),('8348','2013-07-29','17:50:00',1.79),('8348','2013-07-29','17:55:00',1.64),('8348','2013-07-29','18:00:00',1.16),('8348','2013-07-29','18:10:00',1.37),('8348','2013-07-29','18:15:00',1.15),('8348','2013-07-29','18:20:00',1.31),('8348','2013-07-29','18:25:00',1.27),('8348','2013-07-29','18:30:00',1.21),('8348','2013-07-29','18:35:00',1.08),('8348','2013-07-28','08:20:00',1),('8348','2013-07-28','08:25:00',1.04),('8348','2013-07-28','08:30:00',1.14),('8348','2013-07-28','08:35:00',1.24),('8348','2013-07-28','08:40:00',1.33),('8348','2013-07-28','08:45:00',1.41),('8348','2013-07-28','08:50:00',1.47),('8348','2013-07-28','08:55:00',1.54),('8348','2013-07-28','09:00:00',1.62),('8348','2013-07-28','09:05:00',1.68),('8348','2013-07-28','09:10:00',1.74),('8348','2013-07-28','09:15:00',1.8),('8348','2013-07-28','09:20:00',1.84),('8348','2013-07-28','09:25:00',1.91),('8348','2013-07-28','09:30:00',1.97),('8348','2013-07-28','09:35:00',2.03),('8348','2013-07-28','09:40:00',2.07),('8348','2013-07-28','09:45:00',2.13),('8348','2013-07-28','09:50:00',2.19),('8348','2013-07-28','09:55:00',2.23),('8348','2013-07-28','10:00:00',2.26),('8348','2013-07-28','10:05:00',2.29),('8348','2013-07-28','10:10:00',2.37),('8348','2013-07-28','10:15:00',2.44),('8348','2013-07-28','10:20:00',2.46),('8348','2013-07-28','10:25:00',2.52),('8348','2013-07-28','10:30:00',2.56),('8348','2013-07-28','10:35:00',2.6),('8348','2013-07-28','10:40:00',2.63),('8348','2013-07-28','10:45:00',2.68),('8348','2013-07-28','10:50:00',2.74),('8348','2013-07-28','10:55:00',2.8),('8348','2013-07-28','11:00:00',2.84),('8348','2013-07-28','11:05:00',2.87),('8348','2013-07-28','11:10:00',2.87),('8348','2013-07-28','11:15:00',2.89),('8348','2013-07-28','11:20:00',2.94),('8348','2013-07-28','11:25:00',2.97),('8348','2013-07-28','11:30:00',2.97),('8348','2013-07-28','11:35:00',2.94),('8348','2013-07-28','11:40:00',2.98),('8348','2013-07-28','11:45:00',3.06),('8348','2013-07-28','11:50:00',3.09),('8348','2013-07-28','11:55:00',3.11),('8348','2013-07-28','12:00:00',3.11),('8348','2013-07-28','12:05:00',3.12),('8348','2013-07-28','12:10:00',3.12),('8348','2013-07-28','12:15:00',3.07),('8348','2013-07-28','12:20:00',3.15),('8348','2013-07-28','12:25:00',3.13),('8348','2013-07-28','12:30:00',3.32),('8348','2013-07-28','12:35:00',3.26),('8348','2013-07-28','12:40:00',3.27),('8348','2013-07-28','12:45:00',3.22),('8348','2013-07-28','12:50:00',3.22),('8348','2013-07-28','12:55:00',3.25),('8348','2013-07-28','13:00:00',3.25),('8348','2013-07-28','13:05:00',3.33),('8348','2013-07-28','13:10:00',3.41),('8348','2013-07-28','13:15:00',3.38),('8348','2013-07-28','13:20:00',2.42),('8348','2013-07-28','13:25:00',3.39),('8348','2013-07-28','13:30:00',3.47),('8348','2013-07-28','13:35:00',3.47),('8348','2013-07-28','13:40:00',3.48),('8348','2013-07-28','13:45:00',3.51),('8348','2013-07-28','13:50:00',3.52),('8348','2013-07-28','13:55:00',3.49),('8348','2013-07-28','14:00:00',3.46),('8348','2013-07-28','14:05:00',3.47),('8348','2013-07-28','14:10:00',3.45),('8348','2013-07-28','14:15:00',3.46),('8348','2013-07-28','14:20:00',3.46),('8348','2013-07-28','14:25:00',3.45),('8348','2013-07-28','14:30:00',3.39),('8348','2013-07-28','14:35:00',3.39),('8348','2013-07-28','14:40:00',3.37),('8348','2013-07-28','14:45:00',3.37),('8348','2013-07-28','14:50:00',3.33),('8348','2013-07-28','14:55:00',3.33),('8348','2013-07-28','15:00:00',3.3),('8348','2013-07-28','15:05:00',3.24),('8348','2013-07-28','15:10:00',3.27),('8348','2013-07-28','15:15:00',3.23),('8348','2013-07-28','15:20:00',3.17),('8348','2013-07-28','15:25:00',3.16),('8348','2013-07-28','15:30:00',3.16),('8348','2013-07-28','15:35:00',3.1),('8348','2013-07-28','15:40:00',3.1),('8348','2013-07-28','15:45:00',3.04),('8348','2013-07-28','15:50:00',3.04),('8348','2013-07-28','15:55:00',3.01),('8348','2013-07-28','16:00:00',2.98),('8348','2013-07-28','16:05:00',2.99),('8348','2013-07-28','16:10:00',2.95),('8348','2013-07-28','16:15:00',2.91),('8348','2013-07-28','16:20:00',2.88),('8348','2013-07-28','16:25:00',2.83),('8348','2013-07-28','16:30:00',2.78),('8348','2013-07-28','16:35:00',2.73),('8348','2013-07-28','16:40:00',2.68),('8348','2013-07-28','16:45:00',2.64),('8348','2013-07-28','16:50:00',2.59),('8348','2013-07-28','16:55:00',2.52),('8348','2013-07-28','17:00:00',2.47),('8348','2013-07-28','17:05:00',2.42),('8348','2013-07-28','17:10:00',2.37),('8348','2013-07-28','17:15:00',2.31),('8348','2013-07-28','17:20:00',2.25),('8348','2013-07-28','17:25:00',2.19),('8348','2013-07-28','17:30:00',2.12),('8348','2013-07-28','17:35:00',2.06),('8348','2013-07-28','17:40:00',2),('8348','2013-07-28','17:45:00',1.93),('8348','2013-07-28','17:50:00',1.86),('8348','2013-07-28','17:55:00',1.78),('8348','2013-07-28','18:00:00',1.7),('8348','2013-07-28','18:05:00',1.63),('8348','2013-07-28','18:10:00',1.57),('8348','2013-07-28','18:15:00',1.49),('8348','2013-07-28','18:20:00',1.41),('8348','2013-07-28','18:25:00',1.35),('8348','2013-07-28','18:30:00',1.27),('8348','2013-07-28','18:35:00',1.18),('8348','2013-07-28','18:40:00',1.1),('8348','2013-07-28','18:45:00',1.02),('8348','2013-07-27','08:15:00',1),('8348','2013-07-27','08:20:00',1.05),('8348','2013-07-27','08:25:00',1.13),('8348','2013-07-27','08:30:00',1.21),('8348','2013-07-27','08:35:00',1.28),('8348','2013-07-27','08:40:00',1.37),('8348','2013-07-27','08:45:00',1.44),('8348','2013-07-27','08:50:00',1.5),('8348','2013-07-27','08:55:00',1.59),('8348','2013-07-27','09:00:00',1.66),('8348','2013-07-27','09:05:00',1.72),('8348','2013-07-27','09:10:00',1.8),('8348','2013-07-27','09:15:00',1.85),('8348','2013-07-27','09:20:00',1.91),('8348','2013-07-27','09:25:00',1.97),('8348','2013-07-27','09:30:00',2.01),('8348','2013-07-27','09:35:00',2.07),('8348','2013-07-27','09:40:00',2.13),('8348','2013-07-27','09:45:00',2.2),('8348','2013-07-27','09:50:00',2.26),('8348','2013-07-27','09:55:00',2.33),('8348','2013-07-27','10:00:00',2.38),('8348','2013-07-27','10:05:00',2.4),('8348','2013-07-27','10:10:00',2.45),('8348','2013-07-27','10:15:00',2.49),('8348','2013-07-27','10:20:00',2.55),('8348','2013-07-27','10:25:00',2.59),('8348','2013-07-27','10:30:00',2.63),('8348','2013-07-27','10:35:00',2.68),('8348','2013-07-27','10:40:00',2.71),('8348','2013-07-27','10:45:00',2.75),('8348','2013-07-27','10:50:00',2.79),('8348','2013-07-27','10:55:00',2.84),('8348','2013-07-27','11:00:00',2.89),('8348','2013-07-27','11:05:00',2.9),('8348','2013-07-27','11:10:00',2.95),('8348','2013-07-27','11:15:00',2.99),('8348','2013-07-27','11:20:00',3),('8348','2013-07-27','11:25:00',3.03),('8348','2013-07-27','11:30:00',3.05),('8348','2013-07-27','11:35:00',3.09),('8348','2013-07-27','11:40:00',3.13),('8348','2013-07-27','11:45:00',3.17),('8348','2013-07-27','11:50:00',3.17),('8348','2013-07-27','11:55:00',3.19),('8348','2013-07-27','12:00:00',3.18),('8348','2013-07-27','12:05:00',3.21),('8348','2013-07-27','12:10:00',3.21),('8348','2013-07-27','12:15:00',3.27),('8348','2013-07-27','12:20:00',3.26),('8348','2013-07-27','12:25:00',3.25),('8348','2013-07-27','12:30:00',3.28),('8348','2013-07-27','12:35:00',3.29),('8348','2013-07-27','12:40:00',3.4),('8348','2013-07-27','12:45:00',3.45),('8348','2013-07-27','12:50:00',3.41),('8348','2013-07-27','12:55:00',3.42),('8348','2013-07-27','13:00:00',3.53),('8348','2013-07-27','13:05:00',2.85),('8348','2013-07-27','13:10:00',2.8),('8348','2013-07-27','13:15:00',3.46),('8348','2013-07-27','13:20:00',3.49),('8348','2013-07-27','13:25:00',3.49),('8348','2013-07-27','13:30:00',3.44),('8348','2013-07-27','13:35:00',3.41),('8348','2013-07-27','13:40:00',3.45),('8348','2013-07-27','13:45:00',3.49),('8348','2013-07-27','13:50:00',3.54),('8348','2013-07-27','13:55:00',3.53),('8348','2013-07-27','14:00:00',3.48),('8348','2013-07-27','14:05:00',3.48),('8348','2013-07-27','14:10:00',3.48),('8348','2013-07-27','14:15:00',3.6),('8348','2013-07-27','14:20:00',3.46),('8348','2013-07-27','14:25:00',3.46),('8348','2013-07-27','14:30:00',3.46),('8348','2013-07-27','14:35:00',3.44),('8348','2013-07-27','14:40:00',3.45),('8348','2013-07-27','14:45:00',3.42),('8348','2013-07-27','14:50:00',3.44),('8348','2013-07-27','14:55:00',3.43),('8348','2013-07-27','15:00:00',3.36),('8348','2013-07-27','15:05:00',3.32),('8348','2013-07-27','15:10:00',3.31),('8348','2013-07-27','15:15:00',3.29),('8348','2013-07-27','15:20:00',3.23),('8348','2013-07-27','15:25:00',3.24),('8348','2013-07-27','15:30:00',3.22),('8348','2013-07-27','15:35:00',3.2),('8348','2013-07-27','15:40:00',3.16),('8348','2013-07-27','15:45:00',3.13),('8348','2013-07-27','15:50:00',3.09),('8348','2013-07-27','15:55:00',3.06),('8348','2013-07-27','16:00:00',3.03),('8348','2013-07-27','16:05:00',2.99),('8348','2013-07-27','16:10:00',2.94),('8348','2013-07-27','16:15:00',2.9),('8348','2013-07-27','16:20:00',2.86),('8348','2013-07-27','16:25:00',2.83),('8348','2013-07-27','16:30:00',2.78),('8348','2013-07-27','16:35:00',2.75),('8348','2013-07-27','16:40:00',2.7),('8348','2013-07-27','16:45:00',2.64),('8348','2013-07-27','16:50:00',2.59),('8348','2013-07-27','16:55:00',2.53),('8348','2013-07-27','17:00:00',2.46),('8348','2013-07-27','17:05:00',2.41),('8348','2013-07-27','17:10:00',2.36),('8348','2013-07-27','17:15:00',2.31),('8348','2013-07-27','17:20:00',2.22),('8348','2013-07-27','17:25:00',2.19),('8348','2013-07-27','17:30:00',2.09),('8348','2013-07-27','17:35:00',2.05),('8348','2013-07-27','17:40:00',1.96),('8348','2013-07-27','17:45:00',1.91),('8348','2013-07-27','17:50:00',1.85),('8348','2013-07-27','17:55:00',1.77),('8348','2013-07-27','18:00:00',1.72),('8348','2013-07-27','18:05:00',1.66),('8348','2013-07-27','18:10:00',1.6),('8348','2013-07-27','18:15:00',1.51),('8348','2013-07-27','18:20:00',1.42),('8348','2013-07-27','18:25:00',1.35),('8348','2013-07-27','18:30:00',1.3),('8348','2013-07-27','18:35:00',1.23),('8348','2013-07-27','18:40:00',1.15),('8348','2013-07-27','18:45:00',1.07),('8348','2014-04-07','07:10:00',1.2),('8348','2014-04-07','07:15:00',1.36),('8348','2014-04-07','07:20:00',1.61),('8348','2014-04-07','07:25:00',1.68),('8348','2014-04-07','07:30:00',1.89),('8348','2014-04-07','07:35:00',2.39),('8348','2014-04-07','07:40:00',2.48),('8348','2014-04-07','07:45:00',2.43),('8348','2014-04-07','07:50:00',2.27),('8348','2014-04-07','07:55:00',2.03),('8348','2014-04-07','08:00:00',1.98),('8348','2014-04-07','08:05:00',2.04),('8348','2014-04-07','08:10:00',2.3),('8348','2014-04-07','08:15:00',2.58),('8348','2014-04-07','08:20:00',2.22),('8348','2014-04-07','08:25:00',2.11),('8348','2014-04-07','08:30:00',2.1),('8348','2014-04-07','08:35:00',2),('8348','2014-04-07','08:40:00',2.07),('8348','2014-04-07','08:45:00',2.18),('8348','2014-04-07','08:50:00',2.28),('8348','2014-04-07','08:55:00',2.45),('8348','2014-04-07','09:00:00',2.41),('8348','2014-04-07','09:05:00',2.42),('8348','2014-04-07','09:10:00',2.48),('8348','2014-04-07','09:15:00',2.29),('8348','2014-04-07','09:20:00',2.29),('8348','2014-04-07','09:25:00',2.35),('8348','2014-04-07','09:30:00',2.41),('8348','2014-04-07','09:35:00',2.56),('8348','2014-04-07','09:40:00',2.63),('8348','2014-04-07','09:45:00',2.71),('8348','2014-04-07','09:50:00',2.84),('8348','2014-04-07','09:55:00',3.05),('8348','2014-04-07','10:00:00',3.22),('8348','2014-04-07','10:05:00',3.39),('8348','2014-04-07','10:10:00',3.77),('8348','2014-04-07','10:15:00',4.03),('8348','2014-04-07','10:20:00',4),('8348','2014-04-07','10:25:00',3.5),('8348','2014-04-07','10:30:00',3.55),('8348','2014-04-07','10:35:00',3.48),('8348','2014-04-07','10:40:00',3.35),('8348','2014-04-07','10:45:00',3.18),('8348','2014-04-07','10:50:00',3.06),('8348','2014-04-07','10:55:00',2.98),('8348','2014-04-07','11:00:00',3.39),('8348','2014-04-07','11:05:00',4.09),('8348','2014-04-07','11:10:00',4.53),('8348','2014-04-07','11:15:00',5.92),('8348','2014-04-07','11:20:00',6.93),('8348','2014-04-07','11:25:00',6.43),('8348','2014-04-07','11:30:00',4.06),('8348','2014-04-07','11:35:00',3.56),('8348','2014-04-07','11:40:00',4.78),('8348','2014-04-07','11:45:00',6.69),('8348','2014-04-07','11:50:00',6.79),('8348','2014-04-07','11:55:00',6.71),('8348','2014-04-07','12:00:00',6.72),('8348','2014-04-07','12:05:00',6.7),('8348','2014-04-07','12:10:00',6.67),('8348','2014-04-07','12:15:00',6.7),('8348','2014-04-07','12:20:00',6.72),('8348','2014-04-07','12:25:00',6.7),('8348','2014-04-07','12:30:00',6.67),('8348','2014-04-07','12:35:00',6.63),('8348','2014-04-07','12:40:00',6.63),('8348','2014-04-07','12:45:00',6.65),('8348','2014-04-07','12:50:00',6.66),('8348','2014-04-07','12:55:00',6.7),('8348','2014-04-07','13:00:00',6.65),('8348','2014-04-07','13:05:00',6.63),('8348','2014-04-07','13:10:00',6.64),('8348','2014-04-07','13:15:00',6.49),('8348','2014-04-07','13:20:00',6.58),('8348','2014-04-07','13:25:00',6.77),('8348','2014-04-07','13:30:00',6.7),('8348','2014-04-07','13:35:00',6.5),('8348','2014-04-07','13:40:00',6.48),('8348','2014-04-07','13:45:00',6.29),('8348','2014-04-07','13:50:00',6.5),('8348','2014-04-07','13:55:00',6.17),('8348','2014-04-07','14:00:00',5.56),('8348','2014-04-07','14:05:00',6.45),('8348','2014-04-07','14:10:00',6.22),('8348','2014-04-07','14:15:00',6.58),('8348','2014-04-07','14:20:00',6.79),('8348','2014-04-07','14:25:00',6.75),('8348','2014-04-07','14:30:00',6.24),('8348','2014-04-07','14:35:00',6.34),('8348','2014-04-07','14:40:00',6.25),('8348','2014-04-07','14:45:00',6.45),('8348','2014-04-07','14:50:00',6.73),('8348','2014-04-07','14:55:00',6.45),('8348','2014-04-07','15:00:00',4.28),('8348','2014-04-07','15:05:00',3.81),('8348','2014-04-07','15:10:00',5.81),('8348','2014-04-07','15:15:00',5.41),('8348','2014-04-07','15:20:00',5.02),('8348','2014-04-07','15:25:00',4.92),('8348','2014-04-07','15:30:00',4.69),('8348','2014-04-07','15:35:00',3.02),('8348','2014-04-07','15:40:00',2),('8348','2014-04-07','15:45:00',3.46),('8348','2014-04-07','15:50:00',4.69),('8348','2014-04-07','15:55:00',4.74),('8348','2014-04-07','16:00:00',4.92),('8348','2014-04-07','16:05:00',4.59),('8348','2014-04-07','16:10:00',3.32),('8348','2014-04-07','16:15:00',3.5),('8348','2014-04-07','16:20:00',1.98),('8348','2014-04-07','16:25:00',1.6),('8348','2014-04-07','16:30:00',1.34),('8348','2014-04-07','16:35:00',1.03),('8348','2014-04-07','16:45:00',1.71),('8348','2014-04-07','16:50:00',1.45),('8348','2014-04-07','16:55:00',2.34),('8348','2014-04-07','17:00:00',2.11),('8348','2014-04-07','17:05:00',1.99),('8348','2014-04-07','17:10:00',2),('8348','2014-04-07','17:15:00',1.91),('8348','2014-04-07','17:20:00',1.64),('8348','2014-04-07','17:25:00',1.49),('8348','2014-04-07','17:30:00',1.29),('8348','2014-04-07','17:35:00',1.08),('8348','2014-05-03','06:35:00',1.01),('8348','2014-05-03','06:40:00',1.1),('8348','2014-05-03','06:45:00',1.2),('8348','2014-05-03','06:50:00',1.42),('8348','2014-05-03','06:55:00',1.58),('8348','2014-05-03','07:00:00',1.77),('8348','2014-05-03','07:05:00',2.06),('8348','2014-05-03','07:10:00',2.5),('8348','2014-05-03','07:15:00',2.92),('8348','2014-05-03','07:20:00',1.93),('8348','2014-05-03','07:25:00',1.77),('8348','2014-05-03','07:30:00',2.43),('8348','2014-05-03','07:35:00',1.45),('8348','2014-05-03','07:40:00',1.42),('8348','2014-05-03','07:45:00',1.84),('8348','2014-05-03','07:50:00',3.79),('8348','2014-05-03','07:55:00',4.45),('8348','2014-05-03','08:00:00',5.09),('8348','2014-05-03','08:05:00',2.79),('8348','2014-05-03','08:10:00',2.11),('8348','2014-05-03','08:15:00',5.37),('8348','2014-05-03','08:20:00',3.89),('8348','2014-05-03','08:25:00',4.96),('8348','2014-05-03','08:30:00',3.38),('8348','2014-05-03','08:35:00',5.73),('8348','2014-05-03','08:40:00',4.72),('8348','2014-05-03','08:45:00',5.18),('8348','2014-05-03','08:50:00',3.14),('8348','2014-05-03','08:55:00',4.8),('8348','2014-05-03','09:00:00',5.92),('8348','2014-05-03','09:05:00',5.95),('8348','2014-05-03','09:10:00',6.2),('8348','2014-05-03','09:15:00',6.85),('8348','2014-05-03','09:20:00',6.18),('8348','2014-05-03','09:25:00',6.35),('8348','2014-05-03','09:30:00',3.81),('8348','2014-05-03','09:35:00',2.1),('8348','2014-05-03','09:40:00',1.85),('8348','2014-05-03','09:45:00',2.16),('8348','2014-05-03','09:50:00',1.96),('8348','2014-05-03','09:55:00',2.3),('8348','2014-05-03','10:00:00',2.08),('8348','2014-05-03','10:05:00',5.11),('8348','2014-05-03','10:10:00',5.91),('8348','2014-05-03','10:15:00',8.68),('8348','2014-05-03','10:20:00',6.99),('8348','2014-05-03','10:25:00',7.25),('8348','2014-05-03','10:30:00',8.11),('8348','2014-05-03','10:35:00',5.54),('8348','2014-05-03','10:40:00',5.01),('8348','2014-05-03','10:45:00',5.07),('8348','2014-05-03','10:50:00',4.23),('8348','2014-05-03','10:55:00',4.64),('8348','2014-05-03','11:00:00',3.67),('8348','2014-05-03','11:05:00',2.93),('8348','2014-05-03','11:10:00',2.61),('8348','2014-05-03','11:15:00',2.43),('8348','2014-05-03','11:20:00',2.24),('8348','2014-05-03','11:25:00',2.31),('8348','2014-05-03','11:30:00',2.94),('8348','2014-05-03','11:35:00',3.71),('8348','2014-05-03','11:40:00',3.55),('8348','2014-05-03','11:45:00',3.64),('8348','2014-05-03','11:50:00',3.37),('8348','2014-05-03','11:55:00',3.31),('8348','2014-05-03','12:00:00',3.58),('8348','2014-05-03','12:05:00',4.06),('8348','2014-05-03','12:10:00',6.05),('8348','2014-05-03','12:15:00',5.62),('8348','2014-05-03','12:20:00',3.96),('8348','2014-05-03','12:25:00',5.27),('8348','2014-05-03','12:30:00',5.98),('8348','2014-05-03','12:35:00',5.04),('8348','2014-05-03','12:40:00',3.75),('8348','2014-05-03','12:45:00',3.46),('8348','2014-05-03','12:50:00',3.41),('8348','2014-05-03','12:55:00',3.42),('8348','2014-05-03','13:00:00',3.35),('8348','2014-05-03','13:05:00',3.38),('8348','2014-05-03','13:10:00',3.64),('8348','2014-05-03','13:15:00',4.12),('8348','2014-05-03','13:20:00',4.79),('8348','2014-05-03','13:25:00',5.89),('8348','2014-05-03','13:30:00',5.27),('8348','2014-05-03','13:35:00',2.98),('8348','2014-05-03','13:40:00',2.32),('8348','2014-05-03','13:45:00',1.48),('8348','2014-05-03','13:50:00',1.04),('8348','2014-05-03','13:55:00',1.55),('8348','2014-05-03','14:00:00',1.93),('8348','2014-05-03','14:05:00',1.76),('8348','2014-05-03','14:10:00',1.46),('8348','2014-05-03','14:15:00',1.07),('8348','2014-05-03','15:25:00',1.02),('8348','2014-05-03','15:30:00',1.19),('8348','2014-05-03','15:35:00',1.34),('8348','2014-05-03','15:40:00',1.47),('8348','2014-05-03','15:45:00',1.59),('8348','2014-05-03','15:50:00',1.67),('8348','2014-05-03','15:55:00',1.71),('8348','2014-05-03','16:00:00',1.72),('8348','2014-05-03','16:05:00',1.73),('8348','2014-05-03','16:10:00',1.74),('8348','2014-05-03','16:15:00',1.73),('8348','2014-05-03','16:20:00',1.72),('8348','2014-05-03','16:25:00',1.73),('8348','2014-05-03','16:30:00',1.7),('8348','2014-05-03','16:35:00',1.64),('8348','2014-05-03','16:40:00',1.7),('8348','2014-05-03','16:45:00',1.86),('8348','2014-05-03','16:50:00',2.24),('8348','2014-05-03','16:55:00',2.23),('8348','2014-05-03','17:00:00',1.76),('8348','2014-05-03','17:05:00',1.51),('8348','2014-05-03','17:10:00',1.61),('8348','2014-05-03','17:15:00',1.39),('8348','2014-05-03','17:20:00',1.07),('8348','2014-05-03','17:25:00',1.3),('8348','2014-05-03','17:45:00',1.35),('8348','2014-05-03','17:50:00',1.12),('8348','2014-04-06','07:15:00',1.17),('8348','2014-04-06','07:20:00',1.25),('8348','2014-04-06','07:25:00',1.37),('8348','2014-04-06','07:30:00',1.58),('8348','2014-04-06','07:35:00',1.72),('8348','2014-04-06','07:40:00',1.84),('8348','2014-04-06','07:45:00',1.94),('8348','2014-04-06','07:50:00',1.49),('8348','2014-04-06','07:55:00',1.07),('8348','2014-04-06','08:05:00',1.57),('8348','2014-04-06','08:10:00',3.02),('8348','2014-04-06','08:15:00',3.24),('8348','2014-04-06','08:20:00',3.1),('8348','2014-04-06','08:25:00',2.83),('8348','2014-04-06','08:30:00',2.61),('8348','2014-04-06','08:35:00',3.58),('8348','2014-04-06','08:40:00',3.9),('8348','2014-04-06','08:45:00',4.91),('8348','2014-04-06','08:50:00',5.64),('8348','2014-04-06','08:55:00',5.7),('8348','2014-04-06','09:00:00',4.66),('8348','2014-04-06','09:05:00',4.92),('8348','2014-04-06','09:10:00',4.41),('8348','2014-04-06','09:15:00',5.32),('8348','2014-04-06','09:20:00',3.91),('8348','2014-04-06','09:25:00',2.23),('8348','2014-04-06','09:30:00',2.35),('8348','2014-04-06','09:35:00',2.59),('8348','2014-04-06','09:40:00',2.75),('8348','2014-04-06','09:45:00',4.07),('8348','2014-04-06','09:50:00',3.38),('8348','2014-04-06','09:55:00',2.66),('8348','2014-04-06','10:00:00',2.82),('8348','2014-04-06','10:05:00',3.96),('8348','2014-04-06','10:10:00',6.34),('8348','2014-04-06','10:15:00',5.83),('8348','2014-04-06','10:20:00',6.72),('8348','2014-04-06','10:25:00',6.61),('8348','2014-04-06','10:30:00',7.03),('8348','2014-04-06','10:35:00',7.38),('8348','2014-04-06','10:40:00',7.25),('8348','2014-04-06','10:45:00',7.16),('8348','2014-04-06','10:50:00',5.38),('8348','2014-04-06','10:55:00',7.05),('8348','2014-04-06','11:00:00',7.23),('8348','2014-04-06','11:05:00',6.81),('8348','2014-04-06','11:10:00',7.04),('8348','2014-04-06','11:15:00',7.13),('8348','2014-04-06','11:20:00',6.33),('8348','2014-04-06','11:25:00',3.66),('8348','2014-04-06','11:30:00',3.94),('8348','2014-04-06','11:35:00',3.01),('8348','2014-04-06','11:40:00',3.68),('8348','2014-04-06','11:45:00',1.99),('8348','2014-04-06','11:50:00',1.94),('8348','2014-04-06','11:55:00',6.2),('8348','2014-04-06','12:00:00',7.36),('8348','2014-04-06','12:05:00',6.5),('8348','2014-04-06','12:10:00',6.94),('8348','2014-04-06','12:15:00',8.12),('8348','2014-04-06','12:20:00',3.59),('8348','2014-04-06','12:25:00',1.9),('8348','2014-04-06','12:30:00',7.83),('8348','2014-04-06','12:35:00',5.91),('8348','2014-04-06','12:40:00',2.47),('8348','2014-04-06','12:45:00',8),('8348','2014-04-06','12:50:00',7.71),('8348','2014-04-06','12:55:00',7.59),('8348','2014-04-06','13:00:00',7.34),('8348','2014-04-06','13:05:00',7.22),('8348','2014-04-06','13:10:00',7.45),('8348','2014-04-06','13:15:00',6.88),('8348','2014-04-06','13:20:00',3.61),('8348','2014-04-06','13:25:00',3.3),('8348','2014-04-06','13:30:00',1.95),('8348','2014-04-06','13:35:00',2.24),('8348','2014-04-06','13:40:00',4.15),('8348','2014-04-06','13:45:00',8.63),('8348','2014-04-06','13:50:00',6.35),('8348','2014-04-06','13:55:00',4.93),('8348','2014-04-06','14:00:00',3.15),('8348','2014-04-06','14:05:00',2.34),('8348','2014-04-06','14:10:00',5.87),('8348','2014-04-06','14:15:00',5.33),('8348','2014-04-06','14:20:00',4.44),('8348','2014-04-06','14:25:00',2.26),('8348','2014-04-06','14:30:00',2.07),('8348','2014-04-06','14:35:00',1.15),('8348','2014-04-06','14:40:00',1.28),('8348','2014-04-06','14:45:00',1.73),('8348','2014-04-06','14:50:00',2.85),('8348','2014-04-06','14:55:00',6.6),('8348','2014-04-06','15:00:00',5.68),('8348','2014-04-06','15:05:00',2.78),('8348','2014-04-06','15:10:00',4.01),('8348','2014-04-06','15:15:00',1.93),('8348','2014-04-06','15:20:00',1.22),('8348','2014-04-06','15:25:00',1.69),('8348','2014-04-06','15:30:00',1.76),('8348','2014-04-06','15:35:00',2.52),('8348','2014-04-06','15:40:00',5.08),('8348','2014-04-06','15:45:00',5.84),('8348','2014-04-06','15:50:00',5.5),('8348','2014-04-06','15:55:00',4.71),('8348','2014-04-06','16:00:00',1.9),('8348','2014-04-06','16:05:00',1.44),('8348','2014-04-06','16:10:00',1.17),('8348','2014-04-06','16:15:00',1.07),('8348','2014-04-06','16:20:00',1.51),('8348','2014-04-06','16:25:00',3.99),('8348','2014-04-06','16:30:00',3.81),('8348','2014-04-06','16:35:00',2.32),('8348','2014-04-06','16:40:00',1.28),('8348','2014-04-06','16:45:00',2.5),('8348','2014-04-06','16:50:00',3.12),('8348','2014-04-06','16:55:00',2.85),('8348','2014-04-06','17:00:00',2.62),('8348','2014-04-06','17:05:00',2.41),('8348','2014-04-06','17:10:00',2.27),('8348','2014-04-06','17:15:00',2.21),('8348','2014-04-06','17:20:00',2.18),('8348','2014-04-06','17:25:00',1.95),('8348','2014-04-06','17:30:00',1.15),('8348','2014-04-06','17:35:00',1.2),('8348','2014-04-05','07:35:00',1.14),('8348','2014-04-05','07:40:00',1.14),('8348','2014-04-05','07:45:00',1.04),('8348','2014-04-05','08:00:00',1.02),('8348','2014-04-05','08:05:00',1.28),('8348','2014-04-05','08:10:00',1.39),('8348','2014-04-05','08:15:00',1.9),('8348','2014-04-05','08:20:00',2.6),('8348','2014-04-05','08:25:00',3.52),('8348','2014-04-05','08:30:00',5.51),('8348','2014-04-05','08:35:00',5.44),('8348','2014-04-05','08:40:00',5.6),('8348','2014-04-05','08:45:00',4.93),('8348','2014-04-05','08:50:00',2.65),('8348','2014-04-05','08:55:00',4.28),('8348','2014-04-05','09:00:00',3.57),('8348','2014-04-05','09:05:00',3.36),('8348','2014-04-05','09:10:00',3.8),('8348','2014-04-05','09:15:00',2.7),('8348','2014-04-05','09:20:00',3.92),('8348','2014-04-05','09:25:00',4.75),('8348','2014-04-05','09:30:00',4.06),('8348','2014-04-05','09:35:00',4.51),('8348','2014-04-05','09:40:00',4.37),('8348','2014-04-05','09:45:00',5.13),('8348','2014-04-05','09:50:00',4.18),('8348','2014-04-05','09:55:00',4.68),('8348','2014-04-05','10:00:00',5.28),('8348','2014-04-05','10:05:00',5.55),('8348','2014-04-05','10:10:00',6.34),('8348','2014-04-05','10:15:00',6.51),('8348','2014-04-05','10:20:00',6.83),('8348','2014-04-05','10:25:00',5.72),('8348','2014-04-05','10:30:00',4.1),('8348','2014-04-05','10:35:00',3.78),('8348','2014-04-05','10:40:00',5.21),('8348','2014-04-05','10:45:00',6.45),('8348','2014-04-05','10:50:00',6.88),('8348','2014-04-05','10:55:00',6.66),('8348','2014-04-05','11:00:00',6.42),('8348','2014-04-05','11:05:00',5.09),('8348','2014-04-05','11:10:00',5.12),('8348','2014-04-05','11:15:00',5.7),('8348','2014-04-05','11:20:00',5.26),('8348','2014-04-05','11:25:00',5.92),('8348','2014-04-05','11:30:00',4.51),('8348','2014-04-05','11:35:00',3.5),('8348','2014-04-05','11:40:00',5.51),('8348','2014-04-05','11:45:00',7.1),('8348','2014-04-05','11:50:00',7.71),('8348','2014-04-05','11:55:00',7.26),('8348','2014-04-05','12:00:00',5.7),('8348','2014-04-05','12:05:00',5.15),('8348','2014-04-05','12:10:00',5.58),('8348','2014-04-05','12:15:00',4.22),('8348','2014-04-05','12:20:00',7.05),('8348','2014-04-05','12:25:00',6.86),('8348','2014-04-05','12:30:00',6.27),('8348','2014-04-05','12:35:00',7.86),('8348','2014-04-05','12:40:00',7.78),('8348','2014-04-05','12:45:00',8.02),('8348','2014-04-05','12:50:00',8.03),('8348','2014-04-05','12:55:00',6.51),('8348','2014-04-05','13:00:00',5.75),('8348','2014-04-05','13:05:00',8.31),('8348','2014-04-05','13:10:00',4.77),('8348','2014-04-05','13:15:00',1.27),('8348','2014-04-05','13:20:00',1.52),('8348','2014-04-05','13:25:00',1.92),('8348','2014-04-05','13:30:00',2.31),('8348','2014-04-05','13:35:00',1.74),('8348','2014-04-05','13:40:00',1.45),('8348','2014-04-05','13:45:00',1.35),('8348','2014-04-05','13:50:00',3.67),('8348','2014-04-05','13:55:00',7.41),('8348','2014-04-05','14:00:00',7.31),('8348','2014-04-05','14:05:00',6.97),('8348','2014-04-05','14:10:00',3.36),('8348','2014-04-05','14:15:00',4.41),('8348','2014-04-05','14:20:00',7.73),('8348','2014-04-05','14:25:00',5.02),('8348','2014-04-05','14:30:00',2.68),('8348','2014-04-05','14:35:00',2.83),('8348','2014-04-05','14:40:00',3.95),('8348','2014-04-05','14:45:00',3.93),('8348','2014-04-05','14:50:00',3.99),('8348','2014-04-05','14:55:00',2.2),('8348','2014-04-05','15:00:00',2.31),('8348','2014-04-05','15:05:00',2.45),('8348','2014-04-05','15:10:00',2.31),('8348','2014-04-05','15:15:00',3.19),('8348','2014-04-05','15:20:00',6.67),('8348','2014-04-05','15:25:00',6.1),('8348','2014-04-05','15:30:00',4.19),('8348','2014-04-05','15:35:00',4.88),('8348','2014-04-05','15:40:00',2.82),('8348','2014-04-05','15:45:00',3.64),('8348','2014-04-05','15:50:00',3.12),('8348','2014-04-05','15:55:00',4.59),('8348','2014-04-05','16:00:00',3.32),('8348','2014-04-05','16:05:00',4.2),('8348','2014-04-05','16:10:00',3.58),('8348','2014-04-05','16:15:00',1.95),('8348','2014-04-05','16:20:00',2.6),('8348','2014-04-05','16:25:00',2.55),('8348','2014-04-05','16:30:00',2.5),('8348','2014-04-05','16:35:00',2.11),('8348','2014-04-05','16:40:00',1.91),('8348','2014-04-05','16:45:00',1.87),('8348','2014-04-05','16:50:00',2.3),('8348','2014-04-05','16:55:00',2.37),('8348','2014-04-05','17:00:00',2.31),('8348','2014-04-05','17:05:00',2.08),('8348','2014-04-05','17:10:00',2.07),('8348','2014-04-05','17:15:00',2.18),('8348','2014-04-05','17:20:00',2.04),('8348','2014-04-05','17:25:00',1.51),('8348','2014-04-04','07:40:00',1.26),('8348','2014-04-04','07:45:00',1.38),('8348','2014-04-04','07:50:00',1.55),('8348','2014-04-04','07:55:00',1.6),('8348','2014-04-04','08:00:00',1.6),('8348','2014-04-04','08:05:00',2.15),('8348','2014-04-04','08:10:00',2.85),('8348','2014-04-04','08:15:00',2.53),('8348','2014-04-04','08:20:00',1.79),('8348','2014-04-04','08:25:00',1.46),('8348','2014-04-04','08:30:00',1.42),('8348','2014-04-04','08:35:00',1.43),('8348','2014-04-04','08:40:00',1.37),('8348','2014-04-04','08:45:00',1.33),('8348','2014-04-04','08:50:00',1.21),('8348','2014-04-04','10:20:00',1.29),('8348','2014-04-04','11:45:00',1.13),('8348','2014-04-04','11:50:00',1.07),('8348','2014-04-04','11:55:00',1.16),('8348','2014-04-04','12:05:00',1.21),('8348','2014-04-04','12:10:00',2.17),('8348','2014-04-04','12:15:00',1.68),('8348','2014-04-04','12:20:00',3.57),('8348','2014-04-04','12:25:00',4.22),('8348','2014-04-04','12:30:00',3.67),('8348','2014-04-04','12:35:00',4.52),('8348','2014-04-04','12:40:00',7.66),('8348','2014-04-04','12:45:00',5.42),('8348','2014-04-04','12:50:00',6.93),('8348','2014-04-04','12:55:00',4.36),('8348','2014-04-04','13:00:00',4.74),('8348','2014-04-04','13:05:00',8.6),('8348','2014-04-04','13:10:00',7.45),('8348','2014-04-04','13:15:00',6.32),('8348','2014-04-04','13:20:00',5.56),('8348','2014-04-04','13:25:00',5.6),('8348','2014-04-04','13:30:00',2.39),('8348','2014-04-04','13:35:00',3.83),('8348','2014-04-04','13:40:00',3.07),('8348','2014-04-04','13:45:00',2.56),('8348','2014-04-04','13:50:00',5.13),('8348','2014-04-04','13:55:00',7.26),('8348','2014-04-04','14:00:00',7.38),('8348','2014-04-04','14:05:00',7.58),('8348','2014-04-04','14:10:00',5.58),('8348','2014-04-04','14:15:00',5.99),('8348','2014-04-04','14:20:00',4.29),('8348','2014-04-04','14:25:00',3.72),('8348','2014-04-04','14:30:00',2.71),('8348','2014-04-04','14:35:00',2.84),('8348','2014-04-04','14:40:00',4.22),('8348','2014-04-04','14:45:00',3.95),('8348','2014-04-04','14:50:00',3.17),('8348','2014-04-04','14:55:00',5.39),('8348','2014-04-04','15:00:00',6.42),('8348','2014-04-04','15:05:00',4.45),('8348','2014-04-04','15:10:00',6.95),('8348','2014-04-04','15:15:00',2.92),('8348','2014-04-04','15:20:00',2.21),('8348','2014-04-04','15:25:00',1.97),('8348','2014-04-04','15:30:00',3.79),('8348','2014-04-04','15:35:00',2.77),('8348','2014-04-04','15:40:00',2.89),('8348','2014-04-04','15:45:00',4.98),('8348','2014-04-04','15:50:00',5.32),('8348','2014-04-04','15:55:00',3.9),('8348','2014-04-04','16:00:00',3.84),('8348','2014-04-04','16:05:00',3.92),('8348','2014-04-04','16:10:00',4.26),('8348','2014-04-04','16:15:00',3.67),('8348','2014-04-04','16:20:00',4.21),('8348','2014-04-04','16:25:00',3.86),('8348','2014-04-04','16:30:00',4.38),('8348','2014-04-04','16:35:00',4.1),('8348','2014-04-04','16:40:00',2.46),('8348','2014-04-04','16:45:00',3.33),('8348','2014-04-04','16:50:00',3.22),('8348','2014-04-04','16:55:00',2.87),('8348','2014-04-04','17:00:00',2.61),('8348','2014-04-04','17:05:00',2.39),('8348','2014-04-04','17:10:00',2.15),('8348','2014-04-04','17:15:00',1.96),('8348','2014-04-04','17:20:00',1.77),('8348','2014-04-04','17:25:00',1.24),('8348','2014-04-04','17:30:00',1.51),('8348','2014-04-04','17:35:00',1.39),('8348','2014-04-04','17:40:00',1.01),('8348','2014-04-03','07:20:00',1.05),('8348','2014-04-03','07:25:00',1.12),('8348','2014-04-03','07:30:00',1.21),('8348','2014-04-03','07:35:00',1.28),('8348','2014-04-03','07:40:00',1.41),('8348','2014-04-03','07:45:00',1.6),('8348','2014-04-03','07:50:00',1.65),('8348','2014-04-03','07:55:00',1.86),('8348','2014-04-03','08:00:00',2.04),('8348','2014-04-03','08:05:00',2.23),('8348','2014-04-03','08:10:00',2.18),('8348','2014-04-03','08:15:00',2.03),('8348','2014-04-03','08:20:00',2.06),('8348','2014-04-03','08:25:00',2.2),('8348','2014-04-03','08:30:00',2.53),('8348','2014-04-03','08:35:00',2.99),('8348','2014-04-03','08:40:00',3.16),('8348','2014-04-03','08:45:00',3.09),('8348','2014-04-03','08:50:00',2.94),('8348','2014-04-03','08:55:00',3.05),('8348','2014-04-03','09:00:00',3.62),('8348','2014-04-03','09:05:00',4.17),('8348','2014-04-03','09:10:00',4.41),('8348','2014-04-03','09:15:00',5.06),('8348','2014-04-03','09:20:00',5.16),('8348','2014-04-03','09:25:00',4.8),('8348','2014-04-03','09:30:00',4.48),('8348','2014-04-03','09:35:00',4.85),('8348','2014-04-03','09:40:00',3.83),('8348','2014-04-03','09:45:00',4.19),('8348','2014-04-03','09:50:00',3.66),('8348','2014-04-03','09:55:00',3.81),('8348','2014-04-03','10:00:00',3.58),('8348','2014-04-03','10:05:00',3.02),('8348','2014-04-03','10:10:00',2.89),('8348','2014-04-03','10:15:00',2.7),('8348','2014-04-03','10:20:00',2.57),('8348','2014-04-03','10:25:00',2.39),('8348','2014-04-03','10:30:00',2.36),('8348','2014-04-03','10:35:00',2.52),('8348','2014-04-03','10:40:00',2.77),('8348','2014-04-03','10:45:00',3.12),('8348','2014-04-03','10:50:00',3.76),('8348','2014-04-03','10:55:00',4.2),('8348','2014-04-03','11:00:00',4.02),('8348','2014-04-03','11:05:00',4.06),('8348','2014-04-03','11:10:00',3.91),('8348','2014-04-03','11:15:00',3.85),('8348','2014-04-03','11:20:00',4.25),('8348','2014-04-03','11:25:00',5.18),('8348','2014-04-03','11:30:00',6.58),('8348','2014-04-03','11:35:00',6.3),('8348','2014-04-03','11:40:00',7.01),('8348','2014-04-03','11:45:00',4.19),('8348','2014-04-03','11:50:00',4.85),('8348','2014-04-03','11:55:00',4.86),('8348','2014-04-03','12:00:00',4.51),('8348','2014-04-03','12:05:00',5.73),('8348','2014-04-03','12:10:00',4.34),('8348','2014-04-03','12:15:00',7.62),('8348','2014-04-03','12:20:00',5),('8348','2014-04-03','12:25:00',4.81),('8348','2014-04-03','12:30:00',4.88),('8348','2014-04-03','12:35:00',7.74),('8348','2014-04-03','12:40:00',6.94),('8348','2014-04-03','12:45:00',3.75),('8348','2014-04-03','12:50:00',3.77),('8348','2014-04-03','12:55:00',4.36),('8348','2014-04-03','13:00:00',6.31),('8348','2014-04-03','13:05:00',6.23),('8348','2014-04-03','13:10:00',4.85),('8348','2014-04-03','13:15:00',6.1),('8348','2014-04-03','13:20:00',6.54),('8348','2014-04-03','13:25:00',6.77),('8348','2014-04-03','13:30:00',6.86),('8348','2014-04-03','13:35:00',7.04),('8348','2014-04-03','13:40:00',6.79),('8348','2014-04-03','13:45:00',6.59),('8348','2014-04-03','13:50:00',6.51),('8348','2014-04-03','13:55:00',6.41),('8348','2014-04-03','14:00:00',6.31),('8348','2014-04-03','14:05:00',6.27),('8348','2014-04-03','14:10:00',6.15),('8348','2014-04-03','14:15:00',6.11),('8348','2014-04-03','14:20:00',6.2),('8348','2014-04-03','14:25:00',6.19),('8348','2014-04-03','14:30:00',6.17),('8348','2014-04-03','14:35:00',6.09),('8348','2014-04-03','14:40:00',6.03),('8348','2014-04-03','14:45:00',5.97),('8348','2014-04-03','14:50:00',5.93),('8348','2014-04-03','14:55:00',5.89),('8348','2014-04-03','15:00:00',5.87),('8348','2014-04-03','15:05:00',5.66),('8348','2014-04-03','15:10:00',5.69),('8348','2014-04-03','15:15:00',5.49),('8348','2014-04-03','15:20:00',5.43),('8348','2014-04-03','15:25:00',5.25),('8348','2014-04-03','15:30:00',5.09),('8348','2014-04-03','15:35:00',4.99),('8348','2014-04-03','15:40:00',4.88),('8348','2014-04-03','15:45:00',4.48),('8348','2014-04-03','15:50:00',3.49),('8348','2014-04-03','15:55:00',2.96),('8348','2014-04-03','16:00:00',2.15),('8348','2014-04-03','16:05:00',1.94),('8348','2014-04-03','16:10:00',1.77),('8348','2014-04-03','16:15:00',1.7),('8348','2014-04-03','16:20:00',1.85),('8348','2014-04-03','16:25:00',2.02),('8348','2014-04-03','16:30:00',2.06),('8348','2014-04-03','16:35:00',1.35),('8348','2014-04-03','16:40:00',1.11),('8348','2014-04-03','16:45:00',1.97),('8348','2014-04-03','16:50:00',2.92),('8348','2014-04-03','16:55:00',2.61),('8348','2014-04-03','17:00:00',2.4),('8348','2014-04-03','17:05:00',2.2),('8348','2014-04-03','17:10:00',2.03),('8348','2014-04-03','17:15:00',1.86),('8348','2014-04-03','17:20:00',1.65),('8348','2014-04-03','17:25:00',1.28),('8348','2014-04-02','07:00:00',1.22),('8348','2014-04-02','07:05:00',1.13),('8348','2014-04-02','07:20:00',1.06),('8348','2014-04-02','07:35:00',1.23),('8348','2014-04-02','07:40:00',1.31),('8348','2014-04-02','07:45:00',1.34),('8348','2014-04-02','07:50:00',1.98),('8348','2014-04-02','07:55:00',2.56),('8348','2014-04-02','08:00:00',1.49),('8348','2014-04-02','08:05:00',1.14),('8348','2014-04-02','08:10:00',1.15),('8348','2014-04-02','08:15:00',1.35),('8348','2014-04-02','08:20:00',1.35),('8348','2014-04-02','08:25:00',1.16),('8348','2014-04-02','08:30:00',1.03),('8348','2014-04-02','08:35:00',1.33),('8348','2014-04-02','08:40:00',1.64),('8348','2014-04-02','08:45:00',1.36),('8348','2014-04-02','08:50:00',1.87),('8348','2014-04-02','08:55:00',4.88),('8348','2014-04-02','09:00:00',4.02),('8348','2014-04-02','09:05:00',4.93),('8348','2014-04-02','09:10:00',5.27),('8348','2014-04-02','09:15:00',5.78),('8348','2014-04-02','09:20:00',5.82),('8348','2014-04-02','09:25:00',5.66),('8348','2014-04-02','09:30:00',2.28),('8348','2014-04-02','09:35:00',1.9),('8348','2014-04-02','09:40:00',2.18),('8348','2014-04-02','09:45:00',2.42),('8348','2014-04-02','09:50:00',5.87),('8348','2014-04-02','09:55:00',5.96),('8348','2014-04-02','10:00:00',6.13),('8348','2014-04-02','10:05:00',4.86),('8348','2014-04-02','10:10:00',2),('8348','2014-04-02','10:15:00',5.37),('8348','2014-04-02','10:20:00',6.39),('8348','2014-04-02','10:25:00',7.13),('8348','2014-04-02','10:30:00',5.66),('8348','2014-04-02','10:35:00',3.89),('8348','2014-04-02','10:40:00',2.42),('8348','2014-04-02','10:45:00',4.76),('8348','2014-04-02','10:50:00',7.19),('8348','2014-04-02','10:55:00',7.23),('8348','2014-04-02','11:00:00',7.12),('8348','2014-04-02','11:05:00',3.59),('8348','2014-04-02','11:10:00',2.79),('8348','2014-04-02','11:15:00',6.67),('8348','2014-04-02','11:20:00',7.55),('8348','2014-04-02','11:25:00',7.19),('8348','2014-04-02','11:30:00',6.43),('8348','2014-04-02','11:35:00',7.71),('8348','2014-04-02','11:40:00',6.12),('8348','2014-04-02','11:45:00',5.51),('8348','2014-04-02','11:50:00',6.28),('8348','2014-04-02','11:55:00',4.54),('8348','2014-04-02','12:00:00',4.59),('8348','2014-04-02','12:05:00',4.98),('8348','2014-04-02','12:10:00',6.5),('8348','2014-04-02','12:15:00',5.73),('8348','2014-04-02','12:20:00',6.33),('8348','2014-04-02','12:25:00',6.21),('8348','2014-04-02','12:30:00',7.57),('8348','2014-04-02','12:35:00',7.62),('8348','2014-04-02','12:40:00',7.83),('8348','2014-04-02','12:45:00',7.5),('8348','2014-04-02','12:50:00',7.43),('8348','2014-04-02','12:55:00',7.62),('8348','2014-04-02','13:00:00',7.44),('8348','2014-04-02','13:05:00',7.29),('8348','2014-04-02','13:10:00',7.49),('8348','2014-04-02','13:15:00',7.23),('8348','2014-04-02','13:20:00',7.3),('8348','2014-04-02','13:25:00',7.29),('8348','2014-04-02','13:30:00',7.12),('8348','2014-04-02','13:35:00',7.05),('8348','2014-04-02','13:40:00',6.68),('8348','2014-04-02','13:45:00',7.1),('8348','2014-04-02','13:50:00',6.07),('8348','2014-04-02','13:55:00',6.39),('8348','2014-04-02','14:00:00',6.55),('8348','2014-04-02','14:05:00',6.63),('8348','2014-04-02','14:10:00',6.25),('8348','2014-04-02','14:15:00',6.28),('8348','2014-04-02','14:20:00',6.32),('8348','2014-04-02','14:25:00',6.19),('8348','2014-04-02','14:30:00',5.86),('8348','2014-04-02','14:35:00',5.67),('8348','2014-04-02','14:40:00',6),('8348','2014-04-02','14:45:00',6.04),('8348','2014-04-02','14:50:00',5.97),('8348','2014-04-02','14:55:00',5.18),('8348','2014-04-02','15:00:00',5.46),('8348','2014-04-02','15:05:00',5.48),('8348','2014-04-02','15:10:00',5.37),('8348','2014-04-02','15:15:00',5.32),('8348','2014-04-02','15:20:00',5.11),('8348','2014-04-02','15:25:00',5.09),('8348','2014-04-02','15:30:00',5.05),('8348','2014-04-02','15:35:00',4.85),('8348','2014-04-02','15:40:00',4.78),('8348','2014-04-02','15:45:00',4.59),('8348','2014-04-02','15:50:00',4.2),('8348','2014-04-02','15:55:00',4.2),('8348','2014-04-02','16:00:00',4.31),('8348','2014-04-02','16:05:00',3.92),('8348','2014-04-02','16:10:00',3.79),('8348','2014-04-02','16:15:00',3.37),('8348','2014-04-02','16:20:00',3.35),('8348','2014-04-02','16:25:00',3.23),('8348','2014-04-02','16:30:00',2.93),('8348','2014-04-02','16:35:00',2.87),('8348','2014-04-02','16:40:00',2.13),('8348','2014-04-02','16:45:00',2.25),('8348','2014-04-02','16:50:00',2.69),('8348','2014-04-02','16:55:00',2.31),('8348','2014-04-02','17:00:00',2.12),('8348','2014-04-02','17:05:00',1.39),('8348','2014-04-02','17:10:00',1.24),('8348','2014-04-02','17:15:00',1.2),('8348','2014-04-02','17:20:00',1.28),('8348','2014-04-02','17:25:00',1.16),('8348','2013-05-30','08:25:00',1.02),('8348','2013-05-30','08:40:00',2.01),('8348','2013-05-30','08:45:00',2.03),('8348','2013-05-30','08:50:00',2.09),('8348','2013-05-30','08:55:00',2.16),('8348','2013-05-30','09:00:00',2.23),('8348','2013-05-30','09:05:00',2.3),('8348','2013-05-30','09:10:00',2.35),('8348','2013-05-30','09:15:00',2.44),('8348','2013-05-30','09:20:00',2.44),('8348','2013-05-30','09:25:00',2.66),('8348','2013-05-30','09:30:00',2.77),('8348','2013-05-30','09:35:00',2.77),('8348','2013-05-30','09:40:00',2.96),('8348','2013-05-30','09:45:00',2.63),('8348','2013-05-30','09:50:00',3.21),('8348','2013-05-30','09:55:00',1.57),('8348','2013-05-30','10:05:00',1.76),('8348','2013-05-30','10:10:00',3.09),('8348','2013-05-30','10:15:00',1.4),('8348','2013-05-30','10:20:00',3.29),('8348','2013-05-30','10:30:00',1.06),('8348','2013-05-30','10:35:00',1.21),('8348','2013-05-30','10:40:00',2.05),('8348','2013-05-30','10:45:00',3.81),('8348','2013-05-30','10:50:00',3.94),('8348','2013-05-30','10:55:00',3.67),('8348','2013-05-30','11:00:00',4.28),('8348','2013-05-30','11:05:00',3.44),('8348','2013-05-30','11:10:00',1.29),('8348','2013-05-30','11:15:00',2.05),('8348','2013-05-30','11:20:00',3.85),('8348','2013-05-30','11:25:00',1.79),('8348','2013-05-30','11:30:00',3.75),('8348','2013-05-30','11:35:00',4),('8348','2013-05-30','11:40:00',3.85),('8348','2013-05-30','11:45:00',3.4),('8348','2013-05-30','11:50:00',4.18),('8348','2013-05-30','11:55:00',1.05),('8348','2013-05-30','12:00:00',4.04),('8348','2013-05-30','12:05:00',4.68),('8348','2013-05-30','12:10:00',2.61),('8348','2013-05-30','12:15:00',4.53),('8348','2013-05-30','12:20:00',3.89),('8348','2013-05-30','12:25:00',4.09),('8348','2013-05-30','12:30:00',2.31),('8348','2013-05-29','07:50:00',1.01),('8348','2013-05-29','07:55:00',1.07),('8348','2013-05-29','08:00:00',1.13),('8348','2013-05-29','08:05:00',1.23),('8348','2013-05-29','08:10:00',1.34),('8348','2013-05-29','08:15:00',1.43),('8348','2013-05-29','08:20:00',1.49),('8348','2013-05-29','08:25:00',1.61),('8348','2013-05-29','08:30:00',1.71),('8348','2013-05-29','08:35:00',1.79),('8348','2013-05-29','08:40:00',1.86),('8348','2013-05-29','08:45:00',1.93),('8348','2013-05-29','08:50:00',2.01),('8348','2013-05-29','08:55:00',2.1),('8348','2013-05-29','09:00:00',2.17),('8348','2013-05-29','09:05:00',2.23),('8348','2013-05-29','09:10:00',2.3),('8348','2013-05-29','09:15:00',2.37),('8348','2013-05-29','09:20:00',2.43),('8348','2013-05-29','09:25:00',2.49),('8348','2013-05-29','09:30:00',2.55),('8348','2013-05-29','09:35:00',2.63),('8348','2013-05-29','09:40:00',2.7),('8348','2013-05-29','09:45:00',2.78),('8348','2013-05-29','09:50:00',2.85),('8348','2013-05-29','09:55:00',2.9),('8348','2013-05-29','10:00:00',2.95),('8348','2013-05-29','10:05:00',3.01),('8348','2013-05-29','10:10:00',3.06),('8348','2013-05-29','10:15:00',3.12),('8348','2013-05-29','10:20:00',3.2),('8348','2013-05-29','10:25:00',3.24),('8348','2013-05-29','10:30:00',3.3),('8348','2013-05-29','10:35:00',3.37),('8348','2013-05-29','10:40:00',3.41),('8348','2013-05-29','10:45:00',3.47),('8348','2013-05-29','10:50:00',3.49),('8348','2013-05-29','10:55:00',3.57),('8348','2013-05-29','11:00:00',3.61),('8348','2013-05-29','11:05:00',3.63),('8348','2013-05-29','11:10:00',3.79),('8348','2013-05-29','11:15:00',2.53),('8348','2013-05-29','11:20:00',3.59),('8348','2013-05-29','11:25:00',2.89),('8348','2013-05-29','11:30:00',4.28),('8348','2013-05-29','11:35:00',3.96),('8348','2013-05-29','11:40:00',3.04),('8348','2013-05-29','11:45:00',3.43),('8348','2013-05-29','11:50:00',3.14),('8348','2013-05-29','11:55:00',4.27),('8348','2013-05-29','12:00:00',4.17),('8348','2013-05-29','12:05:00',2.79),('8348','2013-05-29','12:10:00',3.86),('8348','2013-05-29','12:15:00',4.06),('8348','2013-05-29','12:20:00',4.23),('8348','2013-05-29','12:25:00',4.18),('8348','2013-05-29','12:30:00',4.14),('8348','2013-05-29','12:35:00',4.14),('8348','2013-05-29','12:40:00',4.18),('8348','2013-05-29','12:45:00',4.21),('8348','2013-05-29','12:50:00',4),('8348','2013-05-29','12:55:00',4.17),('8348','2013-05-29','13:00:00',4.2),('8348','2013-05-29','13:05:00',4.35),('8348','2013-05-29','13:10:00',3.96),('8348','2013-05-29','13:15:00',4.21),('8348','2013-05-29','13:20:00',4.75),('8348','2013-05-29','13:25:00',4.69),('8348','2013-05-29','13:30:00',4.49),('8348','2013-05-29','13:35:00',3.49),('8348','2013-05-29','13:40:00',4.2),('8348','2013-05-29','13:45:00',4.09),('8348','2013-05-29','13:50:00',3.83),('8348','2013-05-29','13:55:00',3.65),('8348','2013-05-29','14:00:00',4.27),('8348','2013-05-29','14:05:00',4.11),('8348','2013-05-29','14:10:00',4.08),('8348','2013-05-29','14:15:00',4.2),('8348','2013-05-29','14:20:00',4.19),('8348','2013-05-29','14:25:00',3.41),('8348','2013-05-29','14:30:00',4.19),('8348','2013-05-29','14:35:00',3.61),('8348','2013-05-29','14:40:00',4.3),('8348','2013-05-29','14:45:00',4.23),('8348','2013-05-29','14:50:00',3.71),('8348','2013-05-29','14:55:00',3.9),('8348','2013-05-29','15:00:00',4.22),('8348','2013-05-29','15:05:00',4.19),('8348','2013-05-29','15:10:00',3.58),('8348','2013-05-29','15:15:00',2.8),('8348','2013-05-29','15:20:00',3.09),('8348','2013-05-29','15:25:00',2.57),('8348','2013-05-29','15:30:00',2.9),('8348','2013-05-29','15:35:00',3.09),('8348','2013-05-29','15:40:00',2.65),('8348','2013-05-29','15:45:00',2.87),('8348','2013-05-29','15:50:00',2.77),('8348','2013-05-29','15:55:00',2.79),('8348','2013-05-29','16:00:00',2.61),('8348','2013-05-29','16:05:00',2.59),('8348','2013-05-29','16:10:00',2.22),('8348','2013-05-29','16:15:00',2.12),('8348','2013-05-29','16:20:00',2.06),('8348','2013-05-29','16:25:00',2.2),('8348','2013-05-29','16:30:00',1.87),('8348','2013-05-29','16:35:00',1.86),('8348','2013-05-29','16:40:00',2.2),('8348','2013-05-29','16:45:00',1.9),('8348','2013-05-29','16:50:00',1.52),('8348','2013-05-29','16:55:00',1.4),('8348','2013-05-29','17:00:00',1.28),('8348','2013-05-29','17:35:00',1.11),('8348','2013-05-29','17:40:00',1.66),('8348','2013-05-29','17:45:00',1.08),('8348','2013-05-29','18:05:00',1.36),('8348','2013-05-29','18:10:00',1.4),('8348','2013-05-29','18:15:00',2.22),('8348','2013-05-29','18:20:00',1.45),('8348','2013-05-28','07:50:00',1.01),('8348','2013-05-28','08:00:00',1.04),('8348','2013-05-28','08:05:00',1.09),('8348','2013-05-28','08:10:00',1.21),('8348','2013-05-28','08:15:00',1.4),('8348','2013-05-28','08:20:00',1.5),('8348','2013-05-28','08:25:00',1.37),('8348','2013-05-28','08:30:00',1.58),('8348','2013-05-28','08:35:00',1.45),('8348','2013-05-28','08:40:00',1.32),('8348','2013-05-28','08:45:00',1.28),('8348','2013-05-28','08:50:00',1.52),('8348','2013-05-28','08:55:00',1.36),('8348','2013-05-28','09:00:00',1.43),('8348','2013-05-28','09:05:00',1.62),('8348','2013-05-28','09:10:00',1.49),('8348','2013-05-28','09:15:00',1.42),('8348','2013-05-28','09:20:00',1.62),('8348','2013-05-28','09:25:00',1.81),('8348','2013-05-28','09:30:00',1.95),('8348','2013-05-28','09:35:00',2.03),('8348','2013-05-28','09:40:00',1.96),('8348','2013-05-28','09:45:00',1.83),('8348','2013-05-28','09:50:00',1.89),('8348','2013-05-28','09:55:00',2.02),('8348','2013-05-28','10:00:00',1.89),('8348','2013-05-28','10:05:00',2),('8348','2013-05-28','10:10:00',2.24),('8348','2013-05-28','10:15:00',2.32),('8348','2013-05-28','10:20:00',2.44),('8348','2013-05-28','10:25:00',2.44),('8348','2013-05-28','10:30:00',2.6),('8348','2013-05-28','10:35:00',2.67),('8348','2013-05-28','10:40:00',2.49),('8348','2013-05-28','10:45:00',2.31),('8348','2013-05-28','10:50:00',2.47),('8348','2013-05-28','10:55:00',2.18),('8348','2013-05-28','11:00:00',2.21),('8348','2013-05-28','11:05:00',2.13),('8348','2013-05-28','11:10:00',2.24),('8348','2013-05-28','11:15:00',2.1),('8348','2013-05-28','11:20:00',2.04),('8348','2013-05-28','11:25:00',2),('8348','2013-05-28','11:30:00',3.7),('8348','2013-05-28','11:35:00',2.68),('8348','2013-05-28','11:40:00',3.44),('8348','2013-05-28','11:45:00',3.09),('8348','2013-05-28','11:50:00',1.05),('8348','2013-05-28','11:55:00',1.54),('8348','2013-05-28','12:00:00',1.39),('8348','2013-05-28','12:05:00',1.77),('8348','2013-05-28','12:10:00',2.35),('8348','2013-05-28','12:15:00',2.44),('8348','2013-05-28','12:20:00',2.14),('8348','2013-05-28','12:25:00',2.18),('8348','2013-05-28','12:30:00',2.44),('8348','2013-05-28','12:35:00',2.38),('8348','2013-05-28','12:40:00',2.41),('8348','2013-05-28','12:45:00',2.67),('8348','2013-05-28','12:50:00',2.41),('8348','2013-05-28','12:55:00',2.47),('8348','2013-05-28','13:00:00',2.52),('8348','2013-05-28','13:05:00',2.7),('8348','2013-05-28','13:10:00',2.84),('8348','2013-05-28','13:15:00',2.38),('8348','2013-05-28','13:20:00',2.95),('8348','2013-05-28','13:25:00',1.64),('8348','2013-05-28','13:30:00',1.97),('8348','2013-05-28','13:35:00',1.66),('8348','2013-05-28','13:40:00',1.86),('8348','2013-05-28','13:45:00',1.76),('8348','2013-05-28','13:50:00',2.4),('8348','2013-05-28','13:55:00',2.28),('8348','2013-05-28','14:00:00',2.4),('8348','2013-05-28','14:05:00',2.53),('8348','2013-05-28','14:10:00',3.55),('8348','2013-05-28','14:15:00',3.65),('8348','2013-05-28','14:20:00',2.28),('8348','2013-05-28','14:25:00',2.55),('8348','2013-05-28','14:30:00',3.06),('8348','2013-05-28','14:35:00',2.64),('8348','2013-05-28','14:40:00',2.9),('8348','2013-05-28','14:45:00',3.51),('8348','2013-05-28','14:50:00',2.81),('8348','2013-05-28','14:55:00',2.45),('8348','2013-05-28','15:00:00',2.27),('8348','2013-05-28','15:05:00',3.32),('8348','2013-05-28','15:10:00',1.6),('8348','2013-05-28','15:15:00',2.39),('8348','2013-05-28','15:20:00',2.92),('8348','2013-05-28','15:25:00',2.13),('8348','2013-05-28','15:30:00',1.39),('8348','2013-05-28','15:35:00',1.43),('8348','2013-05-28','15:40:00',2.21),('8348','2013-05-28','15:45:00',3.51),('8348','2013-05-28','15:50:00',2.95),('8348','2013-05-28','15:55:00',2.14),('8348','2013-05-28','16:00:00',1.56),('8348','2013-05-28','16:05:00',1.26),('8348','2013-05-28','16:10:00',1.37),('8348','2013-05-28','16:15:00',1.51),('8348','2013-05-28','16:20:00',2.31),('8348','2013-05-28','16:25:00',2.12),('8348','2013-05-28','16:30:00',2.44),('8348','2013-05-28','16:35:00',3.06),('8348','2013-05-28','16:40:00',2.82),('8348','2013-05-28','16:45:00',2.72),('8348','2013-05-28','16:50:00',2.65),('8348','2013-05-28','16:55:00',2.59),('8348','2013-05-28','17:00:00',2.54),('8348','2013-05-28','17:05:00',2.49),('8348','2013-05-28','17:10:00',2.4),('8348','2013-05-28','17:15:00',2.35),('8348','2013-05-28','17:20:00',2.3),('8348','2013-05-28','17:25:00',2.21),('8348','2013-05-28','17:30:00',2.12),('8348','2013-05-28','17:35:00',2.05),('8348','2013-05-28','17:40:00',1.98),('8348','2013-05-28','17:45:00',1.9),('8348','2013-05-28','17:50:00',1.85),('8348','2013-05-28','17:55:00',1.8),('8348','2013-05-28','18:00:00',1.78),('8348','2013-05-28','18:05:00',1.71),('8348','2013-05-28','18:35:00',1.25),('8348','2013-05-28','18:40:00',1.18),('8348','2013-05-28','18:45:00',1.09),('8348','2013-05-28','18:50:00',1.02),('8348','2013-05-27','07:45:00',1),('8348','2013-05-27','08:00:00',1.06),('8348','2013-05-27','08:05:00',1.35),('8348','2013-05-27','08:10:00',1.53),('8348','2013-05-27','08:15:00',1.47),('8348','2013-05-27','08:20:00',1.33),('8348','2013-05-27','08:25:00',1.62),('8348','2013-05-27','08:30:00',1.73),('8348','2013-05-27','08:35:00',1.83),('8348','2013-05-27','08:40:00',1.91),('8348','2013-05-27','08:45:00',2.17),('8348','2013-05-27','08:50:00',2.21),('8348','2013-05-27','08:55:00',1.59),('8348','2013-05-27','09:00:00',2.48),('8348','2013-05-27','09:05:00',2.65),('8348','2013-05-27','09:10:00',2.42),('8348','2013-05-27','09:15:00',2.4),('8348','2013-05-27','09:20:00',1.72),('8348','2013-05-27','09:25:00',2.9),('8348','2013-05-27','09:30:00',2.72),('8348','2013-05-27','09:35:00',2.75),('8348','2013-05-27','09:40:00',2.79),('8348','2013-05-27','09:45:00',2.88),('8348','2013-05-27','09:50:00',2.89),('8348','2013-05-27','09:55:00',2.96),('8348','2013-05-27','10:00:00',3.16),('8348','2013-05-27','10:05:00',3.16),('8348','2013-05-27','10:10:00',3.23),('8348','2013-05-27','10:15:00',3.07),('8348','2013-05-27','10:20:00',2.44),('8348','2013-05-27','10:25:00',2.03),('8348','2013-05-27','10:30:00',1.83),('8348','2013-05-27','10:40:00',2.48),('8348','2013-05-27','10:45:00',2.43),('8348','2013-05-27','10:50:00',2.25),('8348','2013-05-27','10:55:00',2.46),('8348','2013-05-27','11:00:00',3.42),('8348','2013-05-27','11:05:00',2),('8348','2013-05-27','11:10:00',1.78),('8348','2013-05-27','11:15:00',1.89),('8348','2013-05-27','11:20:00',2.72),('8348','2013-05-27','11:25:00',2.74),('8348','2013-05-27','11:30:00',3.16),('8348','2013-05-27','11:35:00',1.52),('8348','2013-05-27','11:40:00',3.87),('8348','2013-05-27','11:45:00',2.63),('8348','2013-05-27','11:50:00',1.5),('8348','2013-05-27','11:55:00',1.84),('8348','2013-05-27','12:00:00',4.59),('8348','2013-05-27','12:05:00',2.82),('8348','2013-05-27','12:10:00',3.16),('8348','2013-05-27','12:15:00',2.09),('8348','2013-05-27','12:20:00',4.19),('8348','2013-05-27','12:25:00',3.37),('8348','2013-05-27','12:30:00',3.99),('8348','2013-05-27','12:35:00',1.99),('8348','2013-05-27','12:40:00',4.42),('8348','2013-05-27','12:45:00',3.16),('8348','2013-05-27','12:50:00',3.69),('8348','2013-05-27','12:55:00',4.08),('8348','2013-05-27','13:00:00',3.24),('8348','2013-05-27','13:05:00',2.04),('8348','2013-05-27','13:10:00',4.47),('8348','2013-05-27','13:15:00',2.52),('8348','2013-05-27','13:20:00',3.84),('8348','2013-05-27','13:25:00',4.38),('8348','2013-05-27','13:30:00',4.38),('8348','2013-05-27','13:35:00',2.21),('8348','2013-05-27','13:40:00',4.66),('8348','2013-05-27','13:45:00',3.07),('8348','2013-05-27','13:50:00',1.74),('8348','2013-05-27','13:55:00',4.39),('8348','2013-05-27','14:00:00',4.15),('8348','2013-05-27','14:05:00',4.24),('8348','2013-05-27','14:10:00',3.82),('8348','2013-05-27','14:15:00',3.69),('8348','2013-05-27','14:20:00',2.53),('8348','2013-05-27','14:25:00',4.09),('8348','2013-05-27','14:30:00',3.21),('8348','2013-05-27','14:35:00',3.33),('8348','2013-05-27','14:40:00',2.15),('8348','2013-05-27','14:45:00',4.44),('8348','2013-05-27','14:50:00',3.93),('8348','2013-05-27','14:55:00',3.55),('8348','2013-05-27','15:00:00',2.65),('8348','2013-05-27','15:05:00',2.56),('8348','2013-05-27','15:10:00',4.07),('8348','2013-05-27','15:15:00',2.77),('8348','2013-05-27','15:20:00',3.34),('8348','2013-05-27','15:25:00',3.24),('8348','2013-05-27','15:30:00',3.5),('8348','2013-05-27','15:35:00',3.99),('8348','2013-05-27','15:40:00',3.29),('8348','2013-05-27','15:45:00',2.57),('8348','2013-05-27','15:50:00',3.51),('8348','2013-05-27','15:55:00',2.44),('8348','2013-05-27','16:00:00',3.05),('8348','2013-05-27','16:05:00',2.14),('8348','2013-05-27','16:10:00',2.52),('8348','2013-05-27','16:15:00',2.22),('8348','2013-05-27','16:20:00',3.65),('8348','2013-05-27','16:25:00',3.52),('8348','2013-05-27','16:30:00',3.24),('8348','2013-05-27','16:35:00',2.94),('8348','2013-05-27','16:40:00',1.38),('8348','2013-05-27','16:45:00',1.23),('8348','2013-05-27','16:50:00',1.22),('8348','2013-05-27','16:55:00',1.29),('8348','2013-05-27','17:00:00',1.37),('8348','2013-05-27','17:05:00',1.42),('8348','2013-05-27','17:10:00',1.82),('8348','2013-05-27','17:15:00',1.42),('8348','2013-05-27','17:20:00',1.21),('8348','2013-05-27','17:25:00',1.11),('8348','2013-05-27','17:30:00',1.08),('8348','2013-05-27','17:35:00',1),('8348','2013-05-27','18:20:00',1.36),('8348','2013-05-27','18:25:00',2.02),('8348','2013-05-27','18:30:00',1.58),('8348','2013-05-27','18:35:00',1.21),('8348','2013-05-27','18:45:00',1.2),('8348','2013-05-27','18:55:00',1.2),('8348','2013-05-27','19:00:00',1.28),('8348','2013-05-27','19:05:00',1.24),('8348','2013-05-27','19:10:00',1.11),('8348','2013-05-26','07:45:00',1.09),('8348','2013-05-26','07:50:00',1.69),('8348','2013-05-26','08:05:00',1.75),('8348','2013-05-26','08:10:00',1.51),('8348','2013-05-26','08:20:00',1.12),('8348','2013-05-26','08:25:00',1.43),('8348','2013-05-26','08:30:00',1.71),('8348','2013-05-26','08:35:00',1.82),('8348','2013-05-26','08:40:00',2.07),('8348','2013-05-26','08:45:00',2.08),('8348','2013-05-26','08:50:00',1.89),('8348','2013-05-26','08:55:00',1.01),('8348','2013-05-26','09:00:00',2.01),('8348','2013-05-26','09:10:00',1.92),('8348','2013-05-26','09:15:00',2),('8348','2013-05-26','09:25:00',1.37),('8348','2013-05-26','09:40:00',1.12),('8348','2013-05-26','09:45:00',1.84),('8348','2013-05-26','09:55:00',1.09),('8348','2013-05-26','10:05:00',2.85),('8348','2013-05-26','10:10:00',3.37),('8348','2013-05-26','10:15:00',2.29),('8348','2013-05-26','10:20:00',2.65),('8348','2013-05-26','10:25:00',2.86),('8348','2013-05-26','10:30:00',3.18),('8348','2013-05-26','10:35:00',2.82),('8348','2013-05-26','10:40:00',3.59),('8348','2013-05-26','10:45:00',3.61),('8348','2013-05-26','10:50:00',3.67),('8348','2013-05-26','10:55:00',3.71),('8348','2013-05-26','11:00:00',3.69),('8348','2013-05-26','11:05:00',3.79),('8348','2013-05-26','11:10:00',3.82),('8348','2013-05-26','11:15:00',3.86),('8348','2013-05-26','11:20:00',3.91),('8348','2013-05-26','11:25:00',3.94),('8348','2013-05-26','11:30:00',3.99),('8348','2013-05-26','11:35:00',3.69),('8348','2013-05-26','11:40:00',4.11),('8348','2013-05-26','11:45:00',4.14),('8348','2013-05-26','11:50:00',4.13),('8348','2013-05-26','11:55:00',4.05),('8348','2013-05-26','12:00:00',4.19),('8348','2013-05-26','12:05:00',4.22),('8348','2013-05-26','12:10:00',3.89),('8348','2013-05-26','12:15:00',3.32),('8348','2013-05-26','12:20:00',3.71),('8348','2013-05-26','12:25:00',3.78),('8348','2013-05-26','12:30:00',4.3),('8348','2013-05-26','12:35:00',4.37),('8348','2013-05-26','12:40:00',3.94),('8348','2013-05-26','12:45:00',3.3),('8348','2013-05-26','12:50:00',4.43),('8348','2013-05-26','12:55:00',4.41),('8348','2013-05-26','13:00:00',4.43),('8348','2013-05-26','13:05:00',4.1),('8348','2013-05-26','13:10:00',4.47),('8348','2013-05-26','13:15:00',4.12),('8348','2013-05-26','13:20:00',4.41),('8348','2013-05-26','13:25:00',4.4),('8348','2013-05-26','13:30:00',4.41),('8348','2013-05-26','13:35:00',4.39),('8348','2013-05-26','13:40:00',4.36),('8348','2013-05-26','13:45:00',4.39),('8348','2013-05-26','13:50:00',4.04),('8348','2013-05-26','13:55:00',4.31),('8348','2013-05-26','14:00:00',4.29),('8348','2013-05-26','14:05:00',4.28),('8348','2013-05-26','14:10:00',4.22),('8348','2013-05-26','14:15:00',4.21),('8348','2013-05-26','14:20:00',4.23),('8348','2013-05-26','14:25:00',4.21),('8348','2013-05-26','14:30:00',4.19),('8348','2013-05-26','14:35:00',4.15),('8348','2013-05-26','14:40:00',4.16),('8348','2013-05-26','14:45:00',4.13),('8348','2013-05-26','14:50:00',4.12),('8348','2013-05-26','14:55:00',4.09),('8348','2013-05-26','15:00:00',4.04),('8348','2013-05-26','15:05:00',4.02),('8348','2013-05-26','15:10:00',4),('8348','2013-05-26','15:15:00',3.98),('8348','2013-05-26','15:20:00',3.94),('8348','2013-05-26','15:25:00',3.9),('8348','2013-05-26','15:30:00',3.86),('8348','2013-05-26','15:35:00',3.82),('8348','2013-05-26','15:40:00',3.8),('8348','2013-05-26','15:45:00',3.75),('8348','2013-05-26','15:50:00',3.69),('8348','2013-05-26','15:55:00',3.65),('8348','2013-05-26','16:00:00',3.62),('8348','2013-05-26','16:05:00',3.57),('8348','2013-05-26','16:10:00',3.51),('8348','2013-05-26','16:15:00',3.46),('8348','2013-05-26','16:20:00',3.41),('8348','2013-05-26','16:25:00',3.36),('8348','2013-05-26','16:30:00',3.3),('8348','2013-05-26','16:35:00',3.22),('8348','2013-05-26','16:40:00',3.18),('8348','2013-05-26','16:45:00',3.12),('8348','2013-05-26','16:50:00',3.06),('8348','2013-05-26','16:55:00',2.99),('8348','2013-05-26','17:00:00',2.92),('8348','2013-05-26','17:05:00',2.87),('8348','2013-05-26','17:10:00',2.79),('8348','2013-05-26','17:15:00',2.73),('8348','2013-05-26','17:20:00',2.64),('8348','2013-05-26','17:25:00',2.57),('8348','2013-05-26','17:30:00',2.48),('8348','2013-05-26','17:35:00',2.4),('8348','2013-05-26','17:40:00',2.34),('8348','2013-05-26','17:45:00',2.26),('8348','2013-05-26','17:50:00',2.2),('8348','2013-05-26','17:55:00',2.11),('8348','2013-05-26','18:00:00',2.03),('8348','2013-05-26','18:05:00',1.95),('8348','2013-05-26','18:10:00',1.87),('8348','2013-05-26','18:15:00',1.79),('8348','2013-05-26','18:20:00',1.7),('8348','2013-05-26','18:25:00',1.62),('8348','2013-05-26','18:30:00',1.53),('8348','2013-05-26','18:35:00',1.44),('8348','2013-05-26','18:40:00',1.34),('8348','2013-05-26','18:45:00',1.26),('8348','2013-05-26','18:50:00',1.19),('8348','2013-05-26','18:55:00',1.11),('8348','2013-05-26','19:00:00',1.02),('8348','2013-05-25','07:35:00',1.27),('8348','2013-05-25','07:55:00',1.29),('8348','2013-05-25','08:00:00',1.66),('8348','2013-05-25','08:05:00',1.55),('8348','2013-05-25','08:10:00',1.31),('8348','2013-05-25','08:20:00',1.13),('8348','2013-05-25','08:25:00',2.04),('8348','2013-05-25','08:30:00',2.18),('8348','2013-05-25','08:35:00',1.2),('8348','2013-05-25','08:40:00',1.24),('8348','2013-05-25','08:45:00',1.22),('8348','2013-05-25','08:50:00',1.52),('8348','2013-05-25','08:55:00',2.18),('8348','2013-05-25','09:00:00',2.01),('8348','2013-05-25','09:05:00',2.4),('8348','2013-05-25','09:10:00',1.84),('8348','2013-05-25','09:15:00',2.98),('8348','2013-05-25','09:20:00',1.33),('8348','2013-05-25','09:25:00',1.44),('8348','2013-05-25','09:30:00',1.08),('8348','2013-05-25','09:35:00',2.13),('8348','2013-05-25','09:40:00',3.18),('8348','2013-05-25','09:45:00',2.57),('8348','2013-05-25','09:50:00',3.15),('8348','2013-05-25','09:55:00',1.98),('8348','2013-05-25','10:10:00',1.09),('8348','2013-05-25','10:15:00',1.26),('8348','2013-05-25','10:40:00',1.37),('8348','2013-05-25','10:45:00',1.27),('8348','2013-05-25','10:50:00',1.27),('8348','2013-05-25','11:05:00',1.8),('8348','2013-05-25','11:10:00',3.75),('8348','2013-05-25','11:15:00',3.4),('8348','2013-05-25','11:20:00',2.77),('8348','2013-05-25','11:35:00',1.91),('8348','2013-05-25','11:40:00',2.28),('8348','2013-05-25','11:45:00',2.35),('8348','2013-05-25','11:50:00',1.65),('8348','2013-05-25','11:55:00',1.81),('8348','2013-05-25','12:00:00',1.75),('8348','2013-05-25','12:05:00',1.33),('8348','2013-05-25','12:10:00',1.71),('8348','2013-05-25','12:15:00',1.19),('8348','2013-05-25','12:20:00',1.47),('8348','2013-05-25','12:25:00',1.99),('8348','2013-05-25','12:30:00',1.32),('8348','2013-05-25','12:35:00',1.6),('8348','2013-05-25','12:40:00',1.77),('8348','2013-05-25','12:45:00',1.71),('8348','2013-05-25','12:50:00',1.21),('8348','2013-05-25','12:55:00',1.77),('8348','2013-05-25','13:05:00',2.12),('8348','2013-05-25','13:10:00',1.35),('8348','2013-05-25','13:15:00',1.78),('8348','2013-05-25','13:20:00',2.44),('8348','2013-05-25','13:25:00',2.82),('8348','2013-05-25','13:30:00',1.79),('8348','2013-05-25','13:35:00',1.4),('8348','2013-05-25','13:40:00',1.99),('8348','2013-05-25','13:45:00',1.98),('8348','2013-05-25','13:50:00',2.18),('8348','2013-05-25','13:55:00',3.51),('8348','2013-05-25','14:00:00',3.89),('8348','2013-05-25','14:05:00',3.6),('8348','2013-05-25','14:10:00',4.41),('8348','2013-05-25','14:15:00',4.02),('8348','2013-05-25','14:20:00',3.16),('8348','2013-05-25','14:25:00',2.08),('8348','2013-05-25','14:30:00',1.99),('8348','2013-05-25','14:35:00',2.57),('8348','2013-05-25','14:40:00',1.37),('8348','2013-05-25','14:45:00',2.16),('8348','2013-05-25','14:50:00',2.26),('8348','2013-05-25','14:55:00',1.93),('8348','2013-05-25','15:00:00',3.64),('8348','2013-05-25','15:05:00',3.27),('8348','2013-05-25','15:10:00',1.97),('8348','2013-05-25','15:15:00',2.57),('8348','2013-05-25','15:20:00',1.89),('8348','2013-05-25','15:25:00',1.98),('8348','2013-05-25','15:30:00',3.48),('8348','2013-05-25','15:35:00',4.17),('8348','2013-05-25','15:40:00',4.14),('8348','2013-05-25','15:45:00',3.69),('8348','2013-05-25','15:50:00',3.87),('8348','2013-05-25','15:55:00',3.85),('8348','2013-05-25','16:00:00',2.75),('8348','2013-05-25','16:05:00',2.32),('8348','2013-05-25','16:10:00',1.61),('8348','2013-05-25','16:15:00',1.32),('8348','2013-05-25','16:20:00',1.95),('8348','2013-05-25','16:25:00',1.73),('8348','2013-05-25','16:30:00',3.07),('8348','2013-05-25','16:35:00',3.37),('8348','2013-05-25','16:40:00',3.42),('8348','2013-05-25','16:45:00',1.89),('8348','2013-05-25','16:50:00',1.51),('8348','2013-05-25','17:05:00',1.55),('8348','2013-05-25','17:10:00',3.02),('8348','2013-05-25','17:15:00',2.8),('8348','2013-05-25','17:20:00',2.02),('8348','2013-05-25','17:35:00',1.88),('8348','2013-05-25','17:40:00',1.66),('8348','2013-05-25','17:50:00',1.43),('8348','2013-05-25','18:00:00',1.11),('8348','2013-05-24','08:05:00',1.42),('8348','2013-05-24','08:10:00',1.54),('8348','2013-05-24','08:15:00',1.47),('8348','2013-05-24','08:25:00',1.24),('8348','2013-05-24','08:30:00',1.81),('8348','2013-05-24','08:35:00',1.38),('8348','2013-05-24','08:45:00',2.02),('8348','2013-05-24','08:50:00',2.06),('8348','2013-05-24','08:55:00',2.16),('8348','2013-05-24','09:00:00',2.31),('8348','2013-05-24','09:05:00',2.49),('8348','2013-05-24','09:20:00',1.89),('8348','2013-05-24','09:25:00',1.72),('8348','2013-05-24','09:30:00',2.03),('8348','2013-05-24','09:40:00',1.42),('8348','2013-05-24','09:50:00',1.21),('8348','2013-05-24','09:55:00',2.36),('8348','2013-05-24','10:00:00',2.23),('8348','2013-05-24','10:20:00',1),('8348','2013-05-24','10:25:00',2.41),('8348','2013-05-24','10:30:00',3.38),('8348','2013-05-24','10:35:00',3.55),('8348','2013-05-24','10:40:00',3.62),('8348','2013-05-24','10:45:00',3.34),('8348','2013-05-24','10:50:00',3.56),('8348','2013-05-24','10:55:00',4.07),('8348','2013-05-24','11:00:00',3.57),('8348','2013-05-24','11:05:00',3.48),('8348','2013-05-24','11:10:00',3.68),('8348','2013-05-24','11:15:00',2.98),('8348','2013-05-24','11:20:00',4.11),('8348','2013-05-24','11:25:00',4.12),('8348','2013-05-24','11:30:00',2.92),('8348','2013-05-24','11:35:00',1.5),('8348','2013-05-24','11:45:00',2.97),('8348','2013-05-24','11:50:00',4.69),('8348','2013-05-24','11:55:00',3.23),('8348','2013-05-24','12:00:00',2.23),('8348','2013-05-24','12:05:00',2.4),('8348','2013-05-24','12:10:00',4.24),('8348','2013-05-24','12:15:00',3.09),('8348','2013-05-24','12:20:00',2.09),('8348','2013-05-24','12:25:00',3.26),('8348','2013-05-24','12:30:00',4.31),('8348','2013-05-24','12:35:00',2.2),('8348','2013-05-24','12:40:00',2.56),('8348','2013-05-24','12:45:00',2.55),('8348','2013-05-24','12:50:00',3.03),('8348','2013-05-24','12:55:00',2.54),('8348','2013-05-24','13:00:00',2.51),('8348','2013-05-24','13:05:00',2.02),('8348','2013-05-24','13:10:00',2.32),('8348','2013-05-24','13:15:00',2.87),('8348','2013-05-24','13:20:00',3.09),('8348','2013-05-24','13:25:00',2.22),('8348','2013-05-24','13:30:00',1.77),('8348','2013-05-24','13:35:00',2.84),('8348','2013-05-24','13:40:00',2.12),('8348','2013-05-24','13:45:00',1.1),('8348','2013-05-24','13:50:00',1.1),('8348','2013-05-24','13:55:00',2.19),('8348','2013-05-24','14:00:00',2.03),('8348','2013-05-24','14:05:00',1.93),('8348','2013-05-24','14:10:00',1.43),('8348','2013-05-24','14:15:00',3.92),('8348','2013-05-24','14:20:00',3.17),('8348','2013-05-24','14:25:00',2.63),('8348','2013-05-24','14:30:00',2.6),('8348','2013-05-24','14:35:00',3.24),('8348','2013-05-24','14:40:00',3.11),('8348','2013-05-24','14:45:00',2.58),('8348','2013-05-24','14:50:00',1.41),('8348','2013-05-24','14:55:00',1.74),('8348','2013-05-24','15:00:00',2.38),('8348','2013-05-24','15:05:00',3.11),('8348','2013-05-24','15:10:00',2.37),('8348','2013-05-24','15:15:00',2.72),('8348','2013-05-24','15:20:00',4.54),('8348','2013-05-24','15:25:00',3.68),('8348','2013-05-24','15:30:00',4.22),('8348','2013-05-24','15:35:00',3.5),('8348','2013-05-24','15:40:00',3.25),('8348','2013-05-24','15:45:00',3.96),('8348','2013-05-24','15:50:00',4.71),('8348','2013-05-24','15:55:00',4.14),('8348','2013-05-24','16:00:00',2.37),('8348','2013-05-24','16:05:00',2.07),('8348','2013-05-24','16:10:00',2.21),('8348','2013-05-24','16:15:00',2.72),('8348','2013-05-24','16:20:00',2.28),('8348','2013-05-24','16:25:00',3.18),('8348','2013-05-24','16:30:00',2.97),('8348','2013-05-24','16:35:00',1.74),('8348','2013-05-24','16:50:00',1.49),('8348','2013-05-24','16:55:00',1.69),('8348','2013-05-24','17:00:00',1.34),('8348','2013-05-24','17:20:00',1.01),('8348','2013-05-24','17:25:00',1.05),('8348','2013-05-24','17:30:00',1.06),('8348','2013-05-24','17:35:00',1.05),('8348','2013-05-23','08:05:00',1.42),('8348','2013-05-23','08:10:00',1.23),('8348','2013-05-23','08:30:00',1.22),('8348','2013-05-23','08:35:00',1.48),('8348','2013-05-23','08:40:00',2.13),('8348','2013-05-23','08:45:00',2.06),('8348','2013-05-23','08:50:00',1.2),('8348','2013-05-23','09:00:00',2.55),('8348','2013-05-23','09:20:00',2.07),('8348','2013-05-23','09:25:00',2.79),('8348','2013-05-23','09:30:00',2.96),('8348','2013-05-23','09:35:00',1.74),('8348','2013-05-23','09:40:00',2.18),('8348','2013-05-23','09:45:00',1.72),('8348','2013-05-23','09:50:00',3),('8348','2013-05-23','09:55:00',1.5),('8348','2013-05-23','10:00:00',1.35),('8348','2013-05-23','10:05:00',3.49),('8348','2013-05-23','10:10:00',2.05),('8348','2013-05-23','10:15:00',3.57),('8348','2013-05-23','10:20:00',1.69),('8348','2013-05-23','10:25:00',3.46),('8348','2013-05-23','10:30:00',3.05),('8348','2013-05-23','10:35:00',3.55),('8348','2013-05-23','10:40:00',3.36),('8348','2013-05-23','10:45:00',3.78),('8348','2013-05-23','10:50:00',2.5),('8348','2013-05-23','10:55:00',3.25),('8348','2013-05-23','11:00:00',2.13),('8348','2013-05-23','11:05:00',3.41),('8348','2013-05-23','11:10:00',2.84),('8348','2013-05-23','11:15:00',2.26),('8348','2013-05-23','11:20:00',1.89),('8348','2013-05-23','11:25:00',2.65),('8348','2013-05-23','11:30:00',2.58),('8348','2013-05-23','11:35:00',3.51),('8348','2013-05-23','11:40:00',4.3),('8348','2013-05-23','11:45:00',2.9),('8348','2013-05-23','11:50:00',2.13),('8348','2013-05-23','11:55:00',3.95),('8348','2013-05-23','12:00:00',3.83),('8348','2013-05-23','12:05:00',4.28),('8348','2013-05-23','12:10:00',4.36),('8348','2013-05-23','12:15:00',3.69),('8348','2013-05-23','12:20:00',3.27),('8348','2013-05-23','12:25:00',2.8),('8348','2013-05-23','12:30:00',3.64),('8348','2013-05-23','12:35:00',1.75),('8348','2013-05-23','12:40:00',4.46),('8348','2013-05-23','12:45:00',3.35),('8348','2013-05-23','12:50:00',3.83),('8348','2013-05-23','12:55:00',3.45),('8348','2013-05-23','13:00:00',4.44),('8348','2013-05-23','13:05:00',3.49),('8348','2013-05-23','13:10:00',4.51),('8348','2013-05-23','13:15:00',3.98),('8348','2013-05-23','13:20:00',3.41),('8348','2013-05-23','13:25:00',4.73),('8348','2013-05-23','13:30:00',4.01),('8348','2013-05-23','13:35:00',2.4),('8348','2013-05-23','13:40:00',2.37),('8348','2013-05-23','13:45:00',2.76),('8348','2013-05-23','13:50:00',3.8),('8348','2013-05-23','13:55:00',3.66),('8348','2013-05-23','14:00:00',4.47),('8348','2013-05-23','14:05:00',3.96),('8348','2013-05-23','14:10:00',3.44),('8348','2013-05-23','14:15:00',3.6),('8348','2013-05-23','14:20:00',3.93),('8348','2013-05-23','14:25:00',2.27),('8348','2013-05-23','14:30:00',2.24),('8348','2013-05-23','14:35:00',4.71),('8348','2013-05-23','14:40:00',2.76),('8348','2013-05-23','14:45:00',2.33),('8348','2013-05-23','14:50:00',2.65),('8348','2013-05-23','14:55:00',3.92),('8348','2013-05-23','15:00:00',4.26),('8348','2013-05-23','15:05:00',3.3),('8348','2013-05-23','15:10:00',1.37),('8348','2013-05-23','15:15:00',1.63),('8348','2013-05-23','15:20:00',3.37),('8348','2013-05-23','15:25:00',1.79),('8348','2013-05-23','15:30:00',3.36),('8348','2013-05-23','15:35:00',3.55),('8348','2013-05-23','15:40:00',1.45),('8348','2013-05-23','15:45:00',3.14),('8348','2013-05-23','15:50:00',1.11),('8348','2013-05-23','15:55:00',1.78),('8348','2013-05-23','16:00:00',2.9),('8348','2013-05-23','16:05:00',4.03),('8348','2013-05-23','16:10:00',2.44),('8348','2013-05-23','16:15:00',2.22),('8348','2013-05-23','16:20:00',3.38),('8348','2013-05-23','16:25:00',2.17),('8348','2013-05-23','16:30:00',3.08),('8348','2013-05-23','16:35:00',1.45),('8348','2013-05-23','16:40:00',1.64),('8348','2013-05-23','16:45:00',2.39),('8348','2013-05-23','17:05:00',1.14),('8348','2013-05-23','17:10:00',2.85),('8348','2013-05-23','17:15:00',1.44),('8348','2013-05-23','17:25:00',1.01),('8348','2013-05-23','17:30:00',1.05),('8348','2013-05-23','17:35:00',1.61),('8348','2013-05-23','17:40:00',1.12),('8348','2013-05-23','17:50:00',1.2),('8348','2013-05-23','17:55:00',1.28),('8348','2013-05-23','18:00:00',1.91),('8348','2013-05-23','18:05:00',2.38),('8348','2013-05-23','18:45:00',1.24),('8348','2013-05-23','18:50:00',1.29),('8348','2013-05-22','08:05:00',1.18),('8348','2013-05-22','08:15:00',1.66),('8348','2013-05-22','08:20:00',1.59),('8348','2013-05-22','08:25:00',1.43),('8348','2013-05-22','08:30:00',1.9),('8348','2013-05-22','08:35:00',2.22),('8348','2013-05-22','08:40:00',1.37),('8348','2013-05-22','08:45:00',1.31),('8348','2013-05-22','09:25:00',1.03),('8348','2013-05-22','09:30:00',2.48),('8348','2013-05-22','09:35:00',2.51),('8348','2013-05-22','09:40:00',2.49),('8348','2013-05-22','09:45:00',2.51),('8348','2013-05-22','09:50:00',2.56),('8348','2013-05-22','09:55:00',2.61),('8348','2013-05-22','10:00:00',2.68),('8348','2013-05-22','10:05:00',2.74),('8348','2013-05-22','10:10:00',2.8),('8348','2013-05-22','10:15:00',2.86),('8348','2013-05-22','10:20:00',2.77),('8348','2013-05-22','10:25:00',2.91),('8348','2013-05-22','10:30:00',3.02),('8348','2013-05-22','10:35:00',3.05),('8348','2013-05-22','10:40:00',3.24),('8348','2013-05-22','10:45:00',3.22),('8348','2013-05-22','10:50:00',3.15),('8348','2013-05-22','10:55:00',3.18),('8348','2013-05-22','11:00:00',3.24),('8348','2013-05-22','11:05:00',3.33),('8348','2013-05-22','11:10:00',2.66),('8348','2013-05-22','11:15:00',3.25),('8348','2013-05-22','11:20:00',3.47),('8348','2013-05-22','11:25:00',3.62),('8348','2013-05-22','11:30:00',2.65),('8348','2013-05-22','11:35:00',3.07),('8348','2013-05-22','11:40:00',2.65),('8348','2013-05-22','11:45:00',3.68),('8348','2013-05-22','11:50:00',2.18),('8348','2013-05-22','11:55:00',1.79),('8348','2013-05-22','12:00:00',2.67),('8348','2013-05-22','12:05:00',2.16),('8348','2013-05-22','12:10:00',2.12),('8348','2013-05-22','12:15:00',2.76),('8348','2013-05-22','12:20:00',3.09),('8348','2013-05-22','12:25:00',2.92),('8348','2013-05-22','12:30:00',1.99),('8348','2013-05-22','12:35:00',2.09),('8348','2013-05-22','12:40:00',1.56),('8348','2013-05-22','13:05:00',3.67),('8348','2013-05-22','13:10:00',2.55),('8348','2013-05-22','13:15:00',2.48),('8348','2013-05-22','13:20:00',3.01),('8348','2013-05-22','13:25:00',1.02),('8348','2013-05-22','13:30:00',1.54),('8348','2013-05-22','13:35:00',3.49),('8348','2013-05-22','13:40:00',2.58),('8348','2013-05-22','13:45:00',2.6),('8348','2013-05-22','13:50:00',1.83),('8348','2013-05-22','13:55:00',1.76),('8348','2013-05-22','14:00:00',2.6),('8348','2013-05-22','14:05:00',3.2),('8348','2013-05-22','14:10:00',3.77),('8348','2013-05-22','14:15:00',3.93),('8348','2013-05-22','14:20:00',3.81),('8348','2013-05-22','14:25:00',3.75),('8348','2013-05-22','14:30:00',3.71),('8348','2013-05-22','14:35:00',3.7),('8348','2013-05-22','14:40:00',3.7),('8348','2013-05-22','14:45:00',3.67),('8348','2013-05-22','14:50:00',3.65),('8348','2013-05-22','14:55:00',3.61),('8348','2013-05-22','15:00:00',3.59),('8348','2013-05-22','15:05:00',3.54),('8348','2013-05-22','15:10:00',3.52),('8348','2013-05-22','15:15:00',3.5),('8348','2013-05-22','15:20:00',3.15),('8348','2013-05-22','15:25:00',2.1),('8348','2013-05-22','15:30:00',1.69),('8348','2013-05-22','15:35:00',2.05),('8348','2013-05-22','15:40:00',2.73),('8348','2013-05-22','15:45:00',2.64),('8348','2013-05-22','15:50:00',3.29),('8348','2013-05-22','15:55:00',3.07),('8348','2013-05-22','16:00:00',3.17),('8348','2013-05-22','16:05:00',3.08),('8348','2013-05-22','16:10:00',3.01),('8348','2013-05-22','16:15:00',2.99),('8348','2013-05-22','16:20:00',2.93),('8348','2013-05-22','16:25:00',2.88),('8348','2013-05-22','16:30:00',2.81),('8348','2013-05-22','16:35:00',2.74),('8348','2013-05-22','16:40:00',2.7),('8348','2013-05-22','16:45:00',2.15),('8348','2013-05-22','16:50:00',1.17),('8348','2013-05-22','17:15:00',1.12),('8348','2013-05-22','17:20:00',1.35),('8348','2013-05-22','17:25:00',1.68),('8348','2013-05-22','17:30:00',1.3),('8348','2013-05-22','17:35:00',1.55),('8348','2013-05-22','17:55:00',1.25),('8348','2013-05-22','18:00:00',1.69),('8348','2013-05-22','18:05:00',1.09),('8348','2014-04-01','07:15:00',1.05),('8348','2014-04-01','07:20:00',1.15),('8348','2014-04-01','07:25:00',1.25),('8348','2014-04-01','07:30:00',1.34),('8348','2014-04-01','07:35:00',1.47),('8348','2014-04-01','07:40:00',1.67),('8348','2014-04-01','07:45:00',1.78),('8348','2014-04-01','07:50:00',1.89),('8348','2014-04-01','07:55:00',2),('8348','2014-04-01','08:00:00',2.12),('8348','2014-04-01','08:05:00',2.26),('8348','2014-04-01','08:10:00',2.38),('8348','2014-04-01','08:15:00',2.5),('8348','2014-04-01','08:20:00',2.71),('8348','2014-04-01','08:25:00',3.1),('8348','2014-04-01','08:30:00',3.31),('8348','2014-04-01','08:35:00',3.45),('8348','2014-04-01','08:40:00',3.66),('8348','2014-04-01','08:45:00',3.86),('8348','2014-04-01','08:50:00',3.91),('8348','2014-04-01','08:55:00',4.19),('8348','2014-04-01','09:00:00',4.3),('8348','2014-04-01','09:05:00',4.25),('8348','2014-04-01','09:10:00',4.58),('8348','2014-04-01','09:15:00',4.77),('8348','2014-04-01','09:20:00',5.1),('8348','2014-04-01','09:25:00',4.76),('8348','2014-04-01','09:30:00',4.5),('8348','2014-04-01','09:35:00',4.53),('8348','2014-04-01','09:40:00',4.56),('8348','2014-04-01','09:45:00',3),('8348','2014-04-01','09:50:00',5.72),('8348','2014-04-01','09:55:00',5.66),('8348','2014-04-01','10:00:00',5.73),('8348','2014-04-01','10:05:00',5.82),('8348','2014-04-01','10:10:00',5.85),('8348','2014-04-01','10:15:00',5.92),('8348','2014-04-01','10:20:00',5.85),('8348','2014-04-01','10:25:00',6),('8348','2014-04-01','10:30:00',6.24),('8348','2014-04-01','10:35:00',6.39),('8348','2014-04-01','10:40:00',6.4),('8348','2014-04-01','10:45:00',6.61),('8348','2014-04-01','10:50:00',6.56),('8348','2014-04-01','10:55:00',6.62),('8348','2014-04-01','11:00:00',6.69),('8348','2014-04-01','11:05:00',6.75),('8348','2014-04-01','11:10:00',6.85),('8348','2014-04-01','11:15:00',6.91),('8348','2014-04-01','11:20:00',7.04),('8348','2014-04-01','11:25:00',7.14),('8348','2014-04-01','11:30:00',7.2),('8348','2014-04-01','11:35:00',7.22),('8348','2014-04-01','11:40:00',7.24),('8348','2014-04-01','11:45:00',7.26),('8348','2014-04-01','11:50:00',7.34),('8348','2014-04-01','11:55:00',7.28),('8348','2014-04-01','12:00:00',7.26),('8348','2014-04-01','12:05:00',7.39),('8348','2014-04-01','12:10:00',7.46),('8348','2014-04-01','12:15:00',7.19),('8348','2014-04-01','12:20:00',7.26),('8348','2014-04-01','12:25:00',7.33),('8348','2014-04-01','12:30:00',7.38),('8348','2014-04-01','12:35:00',7.41),('8348','2014-04-01','12:40:00',7.41),('8348','2014-04-01','12:45:00',6.95),('8348','2014-04-01','12:50:00',7.17),('8348','2014-04-01','12:55:00',7.43),('8348','2014-04-01','13:00:00',7.38),('8348','2014-04-01','13:05:00',7.39),('8348','2014-04-01','13:10:00',7.37),('8348','2014-04-01','13:15:00',7.37),('8348','2014-04-01','13:20:00',7.19),('8348','2014-04-01','13:25:00',7.28),('8348','2014-04-01','13:30:00',5.82),('8348','2014-04-01','13:35:00',7.01),('8348','2014-04-01','13:40:00',7.48),('8348','2014-04-01','13:45:00',7.71),('8348','2014-04-01','13:50:00',6.54),('8348','2014-04-01','13:55:00',6.99),('8348','2014-04-01','14:00:00',6.18),('8348','2014-04-01','14:05:00',7.06),('8348','2014-04-01','14:10:00',6.49),('8348','2014-04-01','14:15:00',5.8),('8348','2014-04-01','14:20:00',6.05),('8348','2014-04-01','14:25:00',6.37),('8348','2014-04-01','14:30:00',6.92),('8348','2014-04-01','14:35:00',4.88),('8348','2014-04-01','14:40:00',6.16),('8348','2014-04-01','14:45:00',6.15),('8348','2014-04-01','14:50:00',5.81),('8348','2014-04-01','14:55:00',4.35),('8348','2014-04-01','15:00:00',4.33),('8348','2014-04-01','15:05:00',5.69),('8348','2014-04-01','15:10:00',5.14),('8348','2014-04-01','15:15:00',4.16),('8348','2014-04-01','15:20:00',5.16),('8348','2014-04-01','15:25:00',3.73),('8348','2014-04-01','15:30:00',4.63),('8348','2014-04-01','15:35:00',4.63),('8348','2014-04-01','15:40:00',3.45),('8348','2014-04-01','15:45:00',4.12),('8348','2014-04-01','15:50:00',3.79),('8348','2014-04-01','15:55:00',3.62),('8348','2014-04-01','16:00:00',4.68),('8348','2014-04-01','16:05:00',4.13),('8348','2014-04-01','16:10:00',4.23),('8348','2014-04-01','16:15:00',3.71),('8348','2014-04-01','16:20:00',3.74),('8348','2014-04-01','16:25:00',3.36),('8348','2014-04-01','16:30:00',3.5),('8348','2014-04-01','16:35:00',3.25),('8348','2014-04-01','16:40:00',3.07),('8348','2014-04-01','16:45:00',2.69),('8348','2014-04-01','16:50:00',2.76),('8348','2014-04-01','16:55:00',2.56),('8348','2014-04-01','17:00:00',2.34),('8348','2014-04-01','17:05:00',2.15),('8348','2014-04-01','17:10:00',2),('8348','2014-04-01','17:15:00',1.81),('8348','2014-04-01','17:20:00',1.51),('8348','2014-04-01','17:25:00',1.26),('8348','2013-05-21','07:35:00',1.04),('8348','2013-05-21','07:40:00',1.2),('8348','2013-05-21','07:45:00',1.01),('8348','2013-05-21','08:10:00',1.27),('8348','2013-05-21','08:15:00',1.58),('8348','2013-05-21','08:20:00',1.39),('8348','2013-05-21','08:25:00',1.66),('8348','2013-05-21','08:30:00',1.19),('8348','2013-05-21','08:35:00',1.16),('8348','2013-05-21','08:40:00',1.33),('8348','2013-05-21','08:45:00',1.15),('8348','2013-05-21','08:50:00',1.27),('8348','2013-05-21','08:55:00',1.57),('8348','2013-05-21','09:00:00',1.36),('8348','2013-05-21','09:05:00',1.22),('8348','2013-05-21','09:10:00',1.34),('8348','2013-05-21','09:15:00',1.48),('8348','2013-05-21','09:20:00',1.96),('8348','2013-05-21','09:25:00',2.14),('8348','2013-05-21','09:30:00',1.74),('8348','2013-05-21','09:35:00',1.7),('8348','2013-05-21','09:40:00',1.86),('8348','2013-05-21','09:45:00',1.55),('8348','2013-05-21','09:50:00',1.55),('8348','2013-05-21','09:55:00',1.71),('8348','2013-05-21','10:00:00',1.89),('8348','2013-05-21','10:05:00',1.89),('8348','2013-05-21','10:10:00',2.1),('8348','2013-05-21','10:15:00',2.14),('8348','2013-05-21','10:20:00',1.84),('8348','2013-05-21','10:25:00',1.78),('8348','2013-05-21','10:30:00',1.68),('8348','2013-05-21','10:35:00',1.69),('8348','2013-05-21','10:40:00',1.86),('8348','2013-05-21','10:45:00',2.65),('8348','2013-05-21','10:50:00',1.9),('8348','2013-05-21','10:55:00',1.52),('8348','2013-05-21','11:00:00',1.74),('8348','2013-05-21','11:05:00',1.62),('8348','2013-05-21','11:10:00',2.45),('8348','2013-05-21','11:15:00',3.32),('8348','2013-05-21','11:20:00',2.95),('8348','2013-05-21','11:25:00',3.61),('8348','2013-05-21','11:30:00',2.78),('8348','2013-05-21','11:35:00',2.34),('8348','2013-05-21','11:40:00',2.3),('8348','2013-05-21','11:45:00',2.94),('8348','2013-05-21','11:50:00',2.55),('8348','2013-05-21','11:55:00',3.19),('8348','2013-05-21','12:00:00',2.72),('8348','2013-05-21','12:05:00',3.5),('8348','2013-05-21','12:10:00',2.59),('8348','2013-05-21','12:15:00',2.89),('8348','2013-05-21','12:20:00',2.11),('8348','2013-05-21','12:25:00',2.78),('8348','2013-05-21','12:30:00',3.81),('8348','2013-05-21','12:35:00',2.38),('8348','2013-05-21','12:40:00',3.8),('8348','2013-05-21','12:45:00',3.52),('8348','2013-05-21','12:50:00',2.48),('8348','2013-05-21','12:55:00',4.11),('8348','2013-05-21','13:00:00',3.48),('8348','2013-05-21','13:05:00',3.77),('8348','2013-05-21','13:10:00',2.3),('8348','2013-05-21','13:15:00',3.27),('8348','2013-05-21','13:20:00',2.7),('8348','2013-05-21','13:25:00',2.61),('8348','2013-05-21','13:30:00',2.65),('8348','2013-05-21','13:35:00',1.38),('8348','2013-05-21','14:05:00',1.01),('8348','2013-05-21','14:10:00',1.6),('8348','2013-05-21','14:15:00',1.92),('8348','2013-05-21','14:20:00',1.64),('8348','2013-05-21','14:25:00',2.39),('8348','2013-05-21','14:30:00',2.52),('8348','2013-05-21','14:35:00',1.86),('8348','2013-05-21','14:40:00',1.73),('8348','2013-05-21','14:45:00',1.52),('8348','2013-05-21','15:15:00',1.04),('8348','2013-05-21','15:20:00',1.44),('8348','2013-05-21','15:25:00',1.47),('8348','2013-05-21','15:30:00',2.27),('8348','2013-05-21','15:35:00',1.56),('8348','2013-05-21','15:40:00',1.26),('8348','2013-05-21','15:45:00',1.31),('8348','2013-05-21','15:50:00',1.17),('8348','2013-05-21','15:55:00',1.12),('8348','2013-05-21','16:00:00',1.08),('8348','2013-05-21','16:05:00',1.08),('8348','2013-05-21','16:10:00',1.23),('8348','2013-05-21','16:15:00',1.02),('8348','2013-05-21','16:25:00',1.15),('8348','2013-05-21','16:30:00',1.77),('8348','2013-05-21','16:35:00',2.02),('8348','2013-05-21','16:40:00',1.82),('8348','2013-05-21','16:45:00',1.8),('8348','2013-05-21','16:50:00',1.02),('8348','2013-05-17','08:00:00',1.03),('8348','2013-05-17','08:10:00',1.02),('8348','2013-05-17','08:15:00',1.45),('8348','2013-05-17','08:20:00',1.89),('8348','2013-05-17','08:25:00',1.45),('8348','2013-05-17','09:25:00',1.09),('8348','2013-05-17','10:25:00',1.22),('8348','2013-05-17','10:30:00',1.52),('8348','2013-05-17','10:35:00',1.17),('8348','2013-05-17','10:40:00',1.28),('8348','2013-05-17','10:45:00',1.43),('8348','2013-05-17','10:50:00',2.4),('8348','2013-05-17','10:55:00',2.61),('8348','2013-05-17','11:00:00',2.16),('8348','2013-05-17','11:05:00',1.82),('8348','2013-05-17','11:10:00',1.35),('8348','2013-05-17','11:15:00',2.03),('8348','2013-05-17','11:20:00',1.89),('8348','2013-05-17','11:25:00',1.62),('8348','2013-05-17','11:30:00',1.46),('8348','2013-05-17','11:35:00',2.07),('8348','2013-05-17','11:40:00',1.38),('8348','2013-05-17','11:45:00',2.67),('8348','2013-05-17','11:50:00',4.35),('8348','2013-05-17','11:55:00',3.26),('8348','2013-05-17','12:00:00',3.66),('8348','2013-05-17','12:05:00',2.82),('8348','2013-05-17','12:10:00',3.22),('8348','2013-05-17','12:15:00',1.98),('8348','2013-05-17','12:20:00',3.06),('8348','2013-05-17','12:25:00',3.37),('8348','2013-05-17','12:30:00',2.25),('8348','2013-05-17','12:35:00',2.66),('8348','2013-05-17','12:40:00',3.94),('8348','2013-05-17','12:45:00',4.44),('8348','2013-05-17','12:50:00',4.43),('8348','2013-05-17','12:55:00',3.97),('8348','2013-05-17','13:00:00',3.23),('8348','2013-05-17','13:05:00',3.46),('8348','2013-05-17','13:10:00',3.63),('8348','2013-05-17','13:15:00',4.16),('8348','2013-05-17','13:20:00',4.23),('8348','2013-05-17','13:25:00',4.17),('8348','2013-05-17','13:30:00',3.24),('8348','2013-05-17','13:35:00',4.22),('8348','2013-05-17','13:40:00',3.64),('8348','2013-05-17','13:45:00',3.61),('8348','2013-05-17','13:50:00',3.96),('8348','2013-05-17','13:55:00',4.48),('8348','2013-05-17','14:00:00',3.06),('8348','2013-05-17','14:05:00',3.1),('8348','2013-05-17','14:10:00',3.75),('8348','2013-05-17','14:15:00',3.91),('8348','2013-05-17','14:20:00',4.19),('8348','2013-05-17','14:25:00',3.67),('8348','2013-05-17','14:30:00',3.64),('8348','2013-05-17','14:35:00',3.74),('8348','2013-05-16','09:20:00',1.01),('8348','2013-05-16','09:25:00',1.39),('8348','2013-05-16','09:30:00',1.39),('8348','2013-05-16','09:35:00',1.6),('8348','2013-05-16','09:40:00',1.81),('8348','2013-05-16','09:45:00',2.17),('8348','2013-05-16','09:50:00',1.19),('8348','2013-05-16','09:55:00',1.09),('8348','2013-05-16','10:00:00',1.37),('8348','2013-05-16','10:05:00',1.18),('8348','2013-05-16','10:10:00',1.07),('8348','2013-05-16','10:15:00',1.38),('8348','2013-05-16','10:20:00',1.85),('8348','2013-05-16','10:25:00',1.64),('8348','2013-05-16','10:30:00',1.7),('8348','2013-05-16','10:35:00',1.25),('8348','2013-05-16','10:40:00',1.28),('8348','2013-05-16','10:45:00',1.18),('8348','2013-05-16','10:50:00',1.35),('8348','2013-05-16','10:55:00',1.48),('8348','2013-05-16','11:00:00',3.45),('8348','2013-05-16','11:05:00',3.04),('8348','2013-05-16','11:10:00',2.82),('8348','2013-05-16','11:15:00',2.34),('8348','2013-05-16','11:20:00',1.11),('8348','2013-05-16','11:25:00',1.2),('8348','2013-05-16','11:30:00',1.43),('8348','2013-05-16','11:35:00',2.38),('8348','2013-05-16','11:40:00',3.63),('8348','2013-05-16','11:45:00',3.22),('8348','2013-05-16','11:50:00',3.33),('8348','2013-05-16','11:55:00',2.43),('8348','2013-05-16','12:00:00',1.68),('8348','2013-05-16','12:05:00',1.47),('8348','2013-05-16','12:10:00',1.51),('8348','2013-05-16','12:15:00',2.25),('8348','2013-05-16','12:20:00',1.8),('8348','2013-05-16','12:25:00',1.92),('8348','2013-05-16','12:30:00',2.82),('8348','2013-05-16','12:35:00',2.97),('8348','2013-05-16','12:40:00',3.92),('8348','2013-05-16','12:45:00',2.97),('8348','2013-05-16','12:50:00',2.28),('8348','2013-05-16','12:55:00',3.5),('8348','2013-05-16','13:00:00',3.71),('8348','2013-05-16','13:05:00',3.64),('8348','2013-05-16','13:10:00',3.59),('8348','2013-05-16','13:15:00',3.26),('8348','2013-05-16','13:20:00',2.99),('8348','2013-05-16','13:25:00',3.66),('8348','2013-05-16','13:30:00',3.57),('8348','2013-05-16','13:35:00',3.55),('8348','2013-05-16','13:40:00',3.51),('8348','2013-05-16','13:45:00',3.5),('8348','2013-05-16','13:50:00',3.5),('8348','2013-05-16','13:55:00',3.53),('8348','2013-05-16','14:00:00',3.49),('8348','2013-05-16','14:05:00',3.49),('8348','2013-05-16','14:10:00',3.49),('8348','2013-05-16','14:15:00',3.44),('8348','2013-05-16','14:20:00',3.43),('8348','2013-05-16','14:25:00',3.38),('8348','2013-05-16','14:30:00',3.39),('8348','2013-05-16','14:35:00',3.33),('8348','2013-05-16','14:40:00',3.31),('8348','2013-05-16','14:45:00',3.32),('8348','2013-05-16','14:50:00',3.08),('8348','2013-05-16','14:55:00',2.83),('8348','2013-05-16','15:00:00',3.27),('8348','2013-05-16','15:05:00',3.23),('8348','2013-05-16','15:10:00',3.24),('8348','2013-05-16','15:15:00',2.96),('8348','2013-05-16','15:20:00',3.14),('8348','2013-05-16','15:25:00',3.12),('8348','2013-05-16','15:30:00',3.03),('8348','2013-05-16','15:35:00',2.94),('8348','2013-05-16','15:40:00',3.02),('8348','2013-05-16','15:45:00',2.92),('8348','2013-05-16','15:50:00',2.9),('8348','2013-05-16','15:55:00',2.86),('8348','2013-05-16','16:00:00',2.85),('8348','2013-05-16','16:05:00',2.68),('8348','2013-05-16','16:10:00',2.71),('8348','2013-05-16','16:15:00',2.52),('8348','2013-05-16','16:20:00',2.71),('8348','2013-05-16','16:25:00',2.56),('8348','2013-05-16','16:30:00',2.57),('8348','2013-05-16','16:35:00',2.5),('8348','2013-05-16','16:40:00',1.49),('8348','2013-05-16','16:45:00',1.3),('8348','2013-05-16','16:50:00',1.72),('8348','2013-05-16','16:55:00',1.57),('8348','2013-05-16','17:00:00',1.56),('8348','2013-05-16','17:15:00',1.23),('8348','2013-05-16','17:20:00',1.39),('8348','2013-05-16','17:25:00',1.42),('8348','2013-05-16','17:30:00',1.69),('8348','2013-05-16','17:35:00',1.7),('8348','2013-05-16','17:40:00',1.41),('8348','2013-05-16','19:00:00',1.01),('8348','2013-05-15','07:45:00',1.01),('8348','2013-05-15','07:50:00',1.03),('8348','2013-05-15','08:10:00',1.15),('8348','2013-05-15','08:15:00',1.27),('8348','2013-05-15','08:20:00',1.33),('8348','2013-05-15','08:25:00',1.41),('8348','2013-05-15','08:30:00',1.45),('8348','2013-05-15','08:35:00',1.6),('8348','2013-05-15','08:40:00',1.69),('8348','2013-05-15','08:45:00',1.77),('8348','2013-05-15','08:50:00',1.84),('8348','2013-05-15','08:55:00',1.93),('8348','2013-05-15','09:00:00',1.88),('8348','2013-05-15','09:05:00',2.02),('8348','2013-05-15','09:10:00',2.01),('8348','2013-05-15','09:15:00',2.09),('8348','2013-05-15','09:20:00',2.09),('8348','2013-05-15','09:25:00',2.17),('8348','2013-05-15','09:30:00',2.3),('8348','2013-05-15','09:35:00',2.35),('8348','2013-05-15','09:40:00',2.36),('8348','2013-05-15','09:45:00',2.46),('8348','2013-05-15','09:50:00',2.54),('8348','2013-05-15','09:55:00',2.58),('8348','2013-05-15','10:00:00',2.66),('8348','2013-05-15','10:05:00',2.69),('8348','2013-05-15','10:10:00',2.73),('8348','2013-05-15','10:15:00',2.73),('8348','2013-05-15','10:20:00',2.86),('8348','2013-05-15','10:25:00',2.93),('8348','2013-05-15','10:30:00',2.87),('8348','2013-05-15','10:35:00',2.97),('8348','2013-05-15','10:40:00',3.04),('8348','2013-05-15','10:45:00',3.1),('8348','2013-05-15','10:50:00',3.1),('8348','2013-05-15','10:55:00',3.01),('8348','2013-05-15','11:00:00',2.98),('8348','2013-05-15','11:05:00',3.15),('8348','2013-05-15','11:10:00',3.21),('8348','2013-05-15','11:15:00',3.26),('8348','2013-05-15','11:20:00',3.13),('8348','2013-05-15','11:25:00',3.28),('8348','2013-05-15','11:30:00',3.23),('8348','2013-05-15','11:35:00',3.08),('8348','2013-05-15','11:40:00',2.7),('8348','2013-05-15','11:45:00',2.55),('8348','2013-05-15','11:50:00',2.2),('8348','2013-05-15','11:55:00',1.66),('8348','2013-05-15','12:00:00',1.88),('8348','2013-05-15','12:05:00',2.7),('8348','2013-05-15','12:10:00',3.9),('8348','2013-05-15','12:15:00',4),('8348','2013-05-15','12:20:00',3),('8348','2013-05-15','12:25:00',3.44),('8348','2013-05-15','12:30:00',2.52),('8348','2013-05-15','12:35:00',2.81),('8348','2013-05-15','12:40:00',4.12),('8348','2013-05-15','12:45:00',2.27),('8348','2013-05-15','12:50:00',2.25),('8348','2013-05-15','12:55:00',2.46),('8348','2013-05-15','13:00:00',2.49),('8348','2013-05-15','13:05:00',3.19),('8348','2013-05-15','13:10:00',2.64),('8348','2013-05-15','13:15:00',2.29),('8348','2013-05-15','13:20:00',2.5),('8348','2013-05-15','13:25:00',2.49),('8348','2013-05-15','13:30:00',2.49),('8348','2013-05-15','13:35:00',2.2),('8348','2013-05-15','13:40:00',2.4),('8348','2013-05-15','13:45:00',2.31),('8348','2013-05-15','13:50:00',1.94),('8348','2013-05-15','13:55:00',1.96),('8348','2013-05-15','14:00:00',1.73),('8348','2013-05-15','14:05:00',1.54),('8348','2013-05-15','14:10:00',1.6),('8348','2013-05-15','14:15:00',1.58),('8348','2013-05-15','14:20:00',1.64),('8348','2013-05-15','14:25:00',1.55),('8348','2013-05-15','14:30:00',1.36),('8348','2013-05-15','14:35:00',1.33),('8348','2013-05-15','14:40:00',1.48),('8348','2013-05-15','14:45:00',1.35),('8348','2013-05-15','14:50:00',1.34),('8348','2013-05-15','14:55:00',1.34),('8348','2013-05-15','15:00:00',1.34),('8348','2013-05-15','15:05:00',1.04),('8348','2013-05-15','15:50:00',1.37),('8348','2013-05-15','15:55:00',1.81),('8348','2013-05-15','16:00:00',1.77),('8348','2013-05-15','16:05:00',1.67),('8348','2013-05-15','16:10:00',1.52),('8348','2013-05-15','16:15:00',1.36),('8348','2013-05-15','16:20:00',1.47),('8348','2013-05-15','16:25:00',1.5),('8348','2013-05-15','16:30:00',1.32),('8348','2013-05-15','16:35:00',1.23),('8348','2013-05-15','16:40:00',1.15),('8348','2013-05-15','16:45:00',1.09),('8348','2013-05-15','16:50:00',1.11),('8348','2013-05-15','16:55:00',1.29),('8348','2013-05-15','17:00:00',1.58),('8348','2013-05-15','17:05:00',1.87),('8348','2013-05-15','17:10:00',2.49),('8348','2013-05-15','17:15:00',2.76),('8348','2013-05-15','17:20:00',1.5),('8348','2013-05-14','07:55:00',1),('8348','2013-05-14','08:00:00',1.08),('8348','2013-05-14','08:05:00',1.13),('8348','2013-05-14','08:10:00',1.18),('8348','2013-05-14','08:15:00',1.32),('8348','2013-05-14','08:20:00',1.39),('8348','2013-05-14','08:25:00',1.51),('8348','2013-05-14','08:30:00',1.61),('8348','2013-05-14','08:35:00',1.7),('8348','2013-05-14','08:40:00',1.78),('8348','2013-05-14','08:45:00',1.85),('8348','2013-05-14','08:50:00',1.92),('8348','2013-05-14','08:55:00',1.99),('8348','2013-05-14','09:00:00',2.07),('8348','2013-05-14','09:05:00',2.14),('8348','2013-05-14','09:10:00',2.21),('8348','2013-05-14','09:15:00',2.27),('8348','2013-05-14','09:20:00',2.33),('8348','2013-05-14','09:25:00',2.39),('8348','2013-05-14','09:30:00',2.45),('8348','2013-05-14','09:35:00',2.51),('8348','2013-05-14','09:40:00',2.56),('8348','2013-05-14','09:45:00',2.61),('8348','2013-05-14','09:50:00',2.66),('8348','2013-05-14','09:55:00',2.74),('8348','2013-05-14','10:00:00',2.8),('8348','2013-05-14','10:05:00',2.86),('8348','2013-05-14','10:10:00',2.9),('8348','2013-05-14','10:15:00',2.97),('8348','2013-05-14','10:20:00',3),('8348','2013-05-14','10:25:00',3.01),('8348','2013-05-14','10:30:00',3.08),('8348','2013-05-14','10:35:00',3.12),('8348','2013-05-14','10:40:00',3.18),('8348','2013-05-14','10:45:00',3.22),('8348','2013-05-14','10:50:00',3.25),('8348','2013-05-14','10:55:00',3.28),('8348','2013-05-14','11:00:00',3.29),('8348','2013-05-14','11:05:00',3.34),('8348','2013-05-14','11:10:00',3.38),('8348','2013-05-14','11:15:00',3.4),('8348','2013-05-14','11:20:00',3.42),('8348','2013-05-14','11:25:00',3.43),('8348','2013-05-14','11:30:00',3.45),('8348','2013-05-14','11:35:00',3.47),('8348','2013-05-14','11:40:00',3.5),('8348','2013-05-14','11:45:00',3.51),('8348','2013-05-14','11:50:00',3.54),('8348','2013-05-14','11:55:00',3.56),('8348','2013-05-14','12:00:00',3.58),('8348','2013-05-14','12:05:00',3.58),('8348','2013-05-14','12:10:00',3.6),('8348','2013-05-14','12:15:00',3.66),('8348','2013-05-14','12:20:00',3.7),('8348','2013-05-14','12:25:00',3.7),('8348','2013-05-14','12:30:00',3.71),('8348','2013-05-14','12:35:00',3.74),('8348','2013-05-14','12:40:00',3.76),('8348','2013-05-14','12:45:00',3.74),('8348','2013-05-14','12:50:00',3.76),('8348','2013-05-14','12:55:00',3.78),('8348','2013-05-14','13:00:00',3.77),('8348','2013-05-14','13:05:00',3.74),('8348','2013-05-14','13:10:00',3.79),('8348','2013-05-14','13:15:00',3.76),('8348','2013-05-14','13:20:00',3.75),('8348','2013-05-14','13:25:00',3.74),('8348','2013-05-14','13:30:00',3.73),('8348','2013-05-14','13:35:00',3.73),('8348','2013-05-14','13:40:00',3.73),('8348','2013-05-14','13:45:00',3.75),('8348','2013-05-14','13:50:00',3.75),('8348','2013-05-14','13:55:00',3.72),('8348','2013-05-14','14:00:00',3.7),('8348','2013-05-14','14:05:00',3.68),('8348','2013-05-14','14:10:00',3.64),('8348','2013-05-14','14:15:00',3.63),('8348','2013-05-14','14:20:00',3.64),('8348','2013-05-14','14:25:00',3.62),('8348','2013-05-14','14:30:00',3.6),('8348','2013-05-14','14:35:00',3.63),('8348','2013-05-14','14:40:00',3.7),('8348','2013-05-14','14:45:00',3.75),('8348','2013-05-14','14:50:00',3.77),('8348','2013-05-14','14:55:00',3.78),('8348','2013-05-14','15:00:00',3.77),('8348','2013-05-14','15:05:00',3.76),('8348','2013-05-14','15:10:00',3.74),('8348','2013-05-14','15:15:00',3.7),('8348','2013-05-14','15:20:00',3.67),('8348','2013-05-14','15:25:00',3.62),('8348','2013-05-14','15:30:00',3.6),('8348','2013-05-14','15:35:00',3.55),('8348','2013-05-14','15:40:00',3.51),('8348','2013-05-14','15:45:00',3.47),('8348','2013-05-14','15:50:00',3.44),('8348','2013-05-14','15:55:00',3.38),('8348','2013-05-14','16:00:00',3.34),('8348','2013-05-14','16:05:00',3.28),('8348','2013-05-14','16:10:00',3.24),('8348','2013-05-14','16:15:00',3.19),('8348','2013-05-14','16:20:00',3.13),('8348','2013-05-14','16:25:00',3.09),('8348','2013-05-14','16:30:00',3.02),('8348','2013-05-14','16:35:00',2.97),('8348','2013-05-14','16:40:00',2.91),('8348','2013-05-14','16:45:00',2.85),('8348','2013-05-14','16:50:00',2.8),('8348','2013-05-14','16:55:00',2.73),('8348','2013-05-14','17:00:00',2.66),('8348','2013-05-14','17:05:00',2.59),('8348','2013-05-14','17:10:00',2.52),('8348','2013-05-14','17:15:00',2.45),('8348','2013-05-14','17:20:00',2.38),('8348','2013-05-14','17:25:00',2.31),('8348','2013-05-14','17:30:00',2.24),('8348','2013-05-14','17:35:00',2.16),('8348','2013-05-14','17:40:00',2.09),('8348','2013-05-14','17:45:00',2.01),('8348','2013-05-14','17:50:00',1.93),('8348','2013-05-14','17:55:00',1.85),('8348','2013-05-14','18:00:00',1.77),('8348','2013-05-14','18:05:00',1.69),('8348','2013-05-14','18:10:00',1.61),('8348','2013-05-14','18:15:00',1.53),('8348','2013-05-14','18:20:00',1.45),('8348','2013-05-14','18:25:00',1.36),('8348','2013-05-14','18:30:00',1.29),('8348','2013-05-14','18:35:00',1.21),('8348','2013-05-14','18:40:00',1.13),('8348','2013-05-14','18:45:00',1.04),('8348','2013-05-13','08:00:00',1.03),('8348','2013-05-13','08:05:00',1.09),('8348','2013-05-13','08:10:00',1.16),('8348','2013-05-13','08:15:00',1.26),('8348','2013-05-13','08:20:00',1.34),('8348','2013-05-13','08:25:00',1.42),('8348','2013-05-13','08:30:00',1.49),('8348','2013-05-13','08:35:00',1.59),('8348','2013-05-13','08:40:00',1.66),('8348','2013-05-13','08:45:00',1.73),('8348','2013-05-13','08:50:00',1.78),('8348','2013-05-13','08:55:00',1.87),('8348','2013-05-13','09:00:00',1.93),('8348','2013-05-13','09:05:00',2),('8348','2013-05-13','09:10:00',2.07),('8348','2013-05-13','09:15:00',2.12),('8348','2013-05-13','09:20:00',2.18),('8348','2013-05-13','09:25:00',2.24),('8348','2013-05-13','09:30:00',2.34),('8348','2013-05-13','09:35:00',2.39),('8348','2013-05-13','09:40:00',2.51),('8348','2013-05-13','09:45:00',2.55),('8348','2013-05-13','09:50:00',2.54),('8348','2013-05-13','09:55:00',2.01),('8348','2013-05-13','10:00:00',2.91),('8348','2013-05-13','10:05:00',2.92),('8348','2013-05-13','10:10:00',2.81),('8348','2013-05-13','10:15:00',2.87),('8348','2013-05-13','10:20:00',3.09),('8348','2013-05-13','10:25:00',2.89),('8348','2013-05-13','10:30:00',2.5),('8348','2013-05-13','10:40:00',1.18),('8348','2013-05-13','10:45:00',1.05),('8348','2013-05-13','10:50:00',3.19),('8348','2013-05-13','10:55:00',2.42),('8348','2013-05-13','11:00:00',2.69),('8348','2013-05-13','11:05:00',2.92),('8348','2013-05-13','11:10:00',2.64),('8348','2013-05-13','11:15:00',1.45),('8348','2013-05-13','11:20:00',1.36),('8348','2013-05-13','11:25:00',1.57),('8348','2013-05-13','11:30:00',1.53),('8348','2013-05-13','11:35:00',2.3),('8348','2013-05-13','11:40:00',3.04),('8348','2013-05-13','11:45:00',2.69),('8348','2013-05-13','11:50:00',1.87),('8348','2013-05-13','11:55:00',1.72),('8348','2013-05-13','12:00:00',1.66),('8348','2013-05-13','12:05:00',1.63),('8348','2013-05-13','12:10:00',3.68),('8348','2013-05-13','12:15:00',1.52),('8348','2013-05-13','12:20:00',1.08),('8348','2013-05-13','12:25:00',1.08),('8348','2013-05-13','12:30:00',2.02),('8348','2013-05-13','12:35:00',4.54),('8348','2013-05-13','12:40:00',4.22),('8348','2013-05-13','12:45:00',2.81),('8348','2013-05-13','12:50:00',2.93),('8348','2013-05-13','12:55:00',3.3),('8348','2013-05-13','13:00:00',3.82),('8348','2013-05-13','13:05:00',4.01),('8348','2013-05-13','13:10:00',3.56),('8348','2013-05-13','13:15:00',3.55),('8348','2013-05-13','13:20:00',4.21),('8348','2013-05-13','13:25:00',4.11),('8348','2013-05-13','13:30:00',3.98),('8348','2013-05-13','13:35:00',4.25),('8348','2013-05-13','13:40:00',3.83),('8348','2013-05-13','13:45:00',3.23),('8348','2013-05-13','13:50:00',1.21),('8348','2013-05-13','13:55:00',1.76),('8348','2013-05-13','14:00:00',1.11),('8348','2013-05-13','14:05:00',4.2),('8348','2013-05-13','14:10:00',4.33),('8348','2013-05-13','14:15:00',4.19),('8348','2013-05-13','14:20:00',3.79),('8348','2013-05-13','14:25:00',3.75),('8348','2013-05-13','14:30:00',3.76),('8348','2013-05-13','14:35:00',3.71),('8348','2013-05-13','14:40:00',3.91),('8348','2013-05-13','14:45:00',3.22),('8348','2013-05-13','14:50:00',3.99),('8348','2013-05-13','14:55:00',3.99),('8348','2013-05-13','15:00:00',2.12),('8348','2013-05-13','15:05:00',2.33),('8348','2013-05-13','15:10:00',1.24),('8348','2013-05-13','15:20:00',1.08),('8348','2013-05-13','15:40:00',1.49),('8348','2013-05-13','16:00:00',1.04),('8348','2013-05-13','16:05:00',1.8),('8348','2013-05-13','16:10:00',1.85),('8348','2013-05-13','16:15:00',1.17),('8348','2013-05-13','16:20:00',1.23),('8348','2013-05-13','16:25:00',1.27),('8348','2013-05-13','16:30:00',2.11),('8348','2013-05-13','16:35:00',1.27),('8348','2013-05-13','16:40:00',1.5),('8348','2013-05-13','16:45:00',2.23),('8348','2013-05-13','16:50:00',3.14),('8348','2013-05-13','16:55:00',2.98),('8348','2013-05-13','17:00:00',2.88),('8348','2013-05-13','17:05:00',2.71),('8348','2013-05-13','17:10:00',1.37),('8348','2013-05-13','17:15:00',2.84),('8348','2013-05-13','17:20:00',3.14),('8348','2013-05-13','17:25:00',2.97),('8348','2013-05-13','17:30:00',2.81),('8348','2013-05-13','17:35:00',2.63),('8348','2013-05-13','17:40:00',2.44),('8348','2013-05-13','17:45:00',2.37),('8348','2013-05-13','17:50:00',1.87),('8348','2013-05-13','17:55:00',1.64),('8348','2013-05-13','18:00:00',1.27),('8348','2013-05-13','18:10:00',1.34),('8348','2013-05-13','18:15:00',1.15),('8348','2013-05-12','08:15:00',1.22),('8348','2013-05-12','08:20:00',1.35),('8348','2013-05-12','08:25:00',1.66),('8348','2013-05-12','08:30:00',1.21),('8348','2013-05-12','08:40:00',1.35),('8348','2013-05-12','08:45:00',1.6),('8348','2013-05-12','08:50:00',1.25),('8348','2013-05-12','08:55:00',1.16),('8348','2013-05-12','09:00:00',1.1),('8348','2013-05-12','09:05:00',1.32),('8348','2013-05-12','09:15:00',1.22),('8348','2013-05-12','09:20:00',1.23),('8348','2013-05-12','09:25:00',1.1),('8348','2013-05-12','09:30:00',1.1),('8348','2013-05-12','09:35:00',1.15),('8348','2013-05-12','09:40:00',1.16),('8348','2013-05-12','09:45:00',2.41),('8348','2013-05-12','09:50:00',3.09),('8348','2013-05-12','09:55:00',2.61),('8348','2013-05-12','10:00:00',3.06),('8348','2013-05-12','10:05:00',2.63),('8348','2013-05-12','10:10:00',2.35),('8348','2013-05-12','10:25:00',2.49),('8348','2013-05-12','10:30:00',2.71),('8348','2013-05-12','10:35:00',1.06),('8348','2013-05-12','10:40:00',1.99),('8348','2013-05-12','10:45:00',1.78),('8348','2013-05-12','10:50:00',2.61),('8348','2013-05-12','10:55:00',3.41),('8348','2013-05-12','11:00:00',3.73),('8348','2013-05-12','11:05:00',3.66),('8348','2013-05-12','11:10:00',3.73),('8348','2013-05-12','11:15:00',3.75),('8348','2013-05-12','11:20:00',3.8),('8348','2013-05-12','11:25:00',3.9),('8348','2013-05-12','11:30:00',3.98),('8348','2013-05-12','11:35:00',3.43),('8348','2013-05-12','11:40:00',2.83),('8348','2013-05-12','11:45:00',2.88),('8348','2013-05-12','11:50:00',1.98),('8348','2013-05-12','11:55:00',1.44),('8348','2013-05-12','12:00:00',2.16),('8348','2013-05-12','12:05:00',4.08),('8348','2013-05-12','12:10:00',2.72),('8348','2013-05-12','12:15:00',1.2),('8348','2013-05-12','12:20:00',1.02),('8348','2013-05-12','12:25:00',1.07),('8348','2013-05-12','12:30:00',3.17),('8348','2013-05-12','12:35:00',3.57),('8348','2013-05-12','12:40:00',3.83),('8348','2013-05-12','12:45:00',3.9),('8348','2013-05-12','12:50:00',4.06),('8348','2013-05-12','12:55:00',3.98),('8348','2013-05-12','13:00:00',1.48),('8348','2013-05-12','13:05:00',1.41),('8348','2013-05-12','13:10:00',4.37),('8348','2013-05-12','13:15:00',2.08),('8348','2013-05-12','13:20:00',3.59),('8348','2013-05-12','13:25:00',3.28),('8348','2013-05-12','13:30:00',4.19),('8348','2013-05-12','13:35:00',3.93),('8348','2013-05-12','13:40:00',3.66),('8348','2013-05-12','13:45:00',4.48),('8348','2013-05-12','13:50:00',3.38),('8348','2013-05-12','13:55:00',2.62),('8348','2013-05-12','14:00:00',3.08),('8348','2013-05-12','14:05:00',3.34),('8348','2013-05-12','14:10:00',4.12),('8348','2013-05-12','14:15:00',4.35),('8348','2013-05-12','14:20:00',3.17),('8348','2013-05-12','14:25:00',3.69),('8348','2013-05-12','14:30:00',4.16),('8348','2013-05-12','14:35:00',4.15),('8348','2013-05-12','14:40:00',4.06),('8348','2013-05-12','14:45:00',3.82),('8348','2013-05-12','14:50:00',3.97),('8348','2013-05-12','14:55:00',3.89),('8348','2013-05-12','15:00:00',3.46),('8348','2013-05-12','15:05:00',3.97),('8348','2013-05-12','15:10:00',3.11),('8348','2013-05-12','15:15:00',3.54),('8348','2013-05-12','15:20:00',2.48),('8348','2013-05-12','15:25:00',3.81),('8348','2013-05-12','15:30:00',3.65),('8348','2013-05-12','15:35:00',3.58),('8348','2013-05-12','15:40:00',3.55),('8348','2013-05-12','15:45:00',3.49),('8348','2013-05-12','15:50:00',3.43),('8348','2013-05-12','15:55:00',3.34),('8348','2013-05-12','16:00:00',3.23),('8348','2013-05-12','16:05:00',3.14),('8348','2013-05-12','16:10:00',3.19),('8348','2013-05-12','16:15:00',3.16),('8348','2013-05-12','16:20:00',3.11),('8348','2013-05-12','16:25:00',3.04),('8348','2013-05-12','16:30:00',2.99),('8348','2013-05-12','16:35:00',2.99),('8348','2013-05-12','16:40:00',3.09),('8348','2013-05-12','16:45:00',3.25),('8348','2013-05-12','16:50:00',2.74),('8348','2013-05-12','16:55:00',3.28),('8348','2013-05-12','17:00:00',2.81),('8348','2013-05-12','17:05:00',2.85),('8348','2013-05-12','17:10:00',3.26),('8348','2013-05-12','17:15:00',3.1),('8348','2013-05-12','17:20:00',2.92),('8348','2013-05-12','17:25:00',2.38),('8348','2013-05-12','17:30:00',2.36),('8348','2013-05-12','17:35:00',2.32),('8348','2013-05-12','17:40:00',1.62),('8348','2013-05-12','17:45:00',1.59),('8348','2013-05-12','17:50:00',1.16),('8348','2013-05-12','18:00:00',1.72),('8348','2013-05-12','18:05:00',1.83),('8348','2013-05-12','18:10:00',2.03),('8348','2013-05-12','18:15:00',1.33),('8348','2013-05-12','18:20:00',1.02),('8348','2013-05-12','18:25:00',1.49),('8348','2013-05-12','18:30:00',1.35),('8348','2013-05-12','18:35:00',1.4),('8348','2014-03-31','07:15:00',1.07),('8348','2014-03-31','07:20:00',1.15),('8348','2014-03-31','07:25:00',1.24),('8348','2014-03-31','07:30:00',1.32),('8348','2014-03-31','07:35:00',1.41),('8348','2014-03-31','07:40:00',1.66),('8348','2014-03-31','07:45:00',1.78),('8348','2014-03-31','07:50:00',1.9),('8348','2014-03-31','07:55:00',2),('8348','2014-03-31','08:00:00',2.11),('8348','2014-03-31','08:05:00',2.24),('8348','2014-03-31','08:10:00',2.35),('8348','2014-03-31','08:15:00',2.47),('8348','2014-03-31','08:20:00',2.63),('8348','2014-03-31','08:25:00',3.01),('8348','2014-03-31','08:30:00',3.3),('8348','2014-03-31','08:35:00',3.45),('8348','2014-03-31','08:40:00',3.6),('8348','2014-03-31','08:45:00',3.75),('8348','2014-03-31','08:50:00',3.89),('8348','2014-03-31','08:55:00',4.05),('8348','2014-03-31','09:00:00',4.15),('8348','2014-03-31','09:05:00',4.28),('8348','2014-03-31','09:10:00',4.42),('8348','2014-03-31','09:15:00',4.5),('8348','2014-03-31','09:20:00',4.58),('8348','2014-03-31','09:25:00',4.69),('8348','2014-03-31','09:30:00',4.86),('8348','2014-03-31','09:35:00',4.91),('8348','2014-03-31','09:40:00',5.05),('8348','2014-03-31','09:45:00',5.16),('8348','2014-03-31','09:50:00',5.26),('8348','2014-03-31','09:55:00',5.36),('8348','2014-03-31','10:00:00',5.42),('8348','2014-03-31','10:05:00',5.48),('8348','2014-03-31','10:10:00',5.62),('8348','2014-03-31','10:15:00',5.69),('8348','2014-03-31','10:20:00',5.74),('8348','2014-03-31','10:25:00',5.85),('8348','2014-03-31','10:30:00',5.91),('8348','2014-03-31','10:35:00',5.96),('8348','2014-03-31','10:40:00',5.95),('8348','2014-03-31','10:45:00',6.05),('8348','2014-03-31','10:50:00',6.23),('8348','2014-03-31','10:55:00',6.36),('8348','2014-03-31','11:00:00',6.38),('8348','2014-03-31','11:05:00',6.34),('8348','2014-03-31','11:10:00',6.34),('8348','2014-03-31','11:15:00',6.44),('8348','2014-03-31','11:20:00',6.52),('8348','2014-03-31','11:25:00',6.57),('8348','2014-03-31','11:30:00',6.62),('8348','2014-03-31','11:35:00',6.67),('8348','2014-03-31','11:40:00',6.72),('8348','2014-03-31','11:45:00',6.61),('8348','2014-03-31','11:50:00',6.61),('8348','2014-03-31','11:55:00',6.65),('8348','2014-03-31','12:00:00',6.78),('8348','2014-03-31','12:05:00',6.83),('8348','2014-03-31','12:10:00',6.88),('8348','2014-03-31','12:15:00',6.87),('8348','2014-03-31','12:20:00',6.87),('8348','2014-03-31','12:25:00',6.85),('8348','2014-03-31','12:30:00',6.91),('8348','2014-03-31','12:35:00',6.96),('8348','2014-03-31','12:40:00',6.99),('8348','2014-03-31','12:45:00',7),('8348','2014-03-31','12:50:00',7.02),('8348','2014-03-31','12:55:00',6.98),('8348','2014-03-31','13:00:00',6.95),('8348','2014-03-31','13:05:00',6.94),('8348','2014-03-31','13:10:00',6.88),('8348','2014-03-31','13:15:00',6.9),('8348','2014-03-31','13:20:00',6.89),('8348','2014-03-31','13:25:00',6.87),('8348','2014-03-31','13:30:00',6.84),('8348','2014-03-31','13:35:00',6.8),('8348','2014-03-31','13:40:00',6.78),('8348','2014-03-31','13:45:00',6.77),('8348','2014-03-31','13:50:00',6.7),('8348','2014-03-31','13:55:00',6.67),('8348','2014-03-31','14:00:00',6.61),('8348','2014-03-31','14:05:00',6.53),('8348','2014-03-31','14:10:00',6.48),('8348','2014-03-31','14:15:00',6.45),('8348','2014-03-31','14:20:00',6.38),('8348','2014-03-31','14:25:00',6.3),('8348','2014-03-31','14:30:00',6.19),('8348','2014-03-31','14:35:00',6.09),('8348','2014-03-31','14:40:00',6.04),('8348','2014-03-31','14:45:00',5.98),('8348','2014-03-31','14:50:00',5.83),('8348','2014-03-31','14:55:00',5.73),('8348','2014-03-31','15:00:00',5.6),('8348','2014-03-31','15:05:00',5.48),('8348','2014-03-31','15:10:00',5.37),('8348','2014-03-31','15:15:00',5.27),('8348','2014-03-31','15:20:00',5.13),('8348','2014-03-31','15:25:00',5.01),('8348','2014-03-31','15:30:00',4.88),('8348','2014-03-31','15:35:00',4.78),('8348','2014-03-31','15:40:00',4.62),('8348','2014-03-31','15:45:00',4.49),('8348','2014-03-31','15:50:00',4.36),('8348','2014-03-31','15:55:00',4.23),('8348','2014-03-31','16:00:00',4.09),('8348','2014-03-31','16:05:00',3.95),('8348','2014-03-31','16:10:00',3.8),('8348','2014-03-31','16:15:00',3.64),('8348','2014-03-31','16:20:00',3.43),('8348','2014-03-31','16:25:00',3.28),('8348','2014-03-31','16:30:00',3.13),('8348','2014-03-31','16:35:00',3.01),('8348','2014-03-31','16:40:00',2.85),('8348','2014-03-31','16:45:00',2.71),('8348','2014-03-31','16:50:00',2.53),('8348','2014-03-31','16:55:00',2.35),('8348','2014-03-31','17:00:00',2.18),('8348','2014-03-31','17:05:00',2.02),('8348','2014-03-31','17:10:00',1.86),('8348','2014-03-31','17:15:00',1.74),('8348','2014-03-31','17:20:00',1.57),('8348','2014-03-31','17:25:00',1.39),('8348','2014-03-31','17:30:00',1.24),('8348','2014-03-31','17:35:00',1.16),('8348','2014-03-31','17:40:00',1.1),('8348','2013-05-11','07:50:00',1),('8348','2013-05-11','07:55:00',1.14),('8348','2013-05-11','08:00:00',1.08),('8348','2013-05-11','08:05:00',1.12),('8348','2013-05-11','08:15:00',1.26),('8348','2013-05-11','08:20:00',1.08),('8348','2013-05-11','09:05:00',1.19),('8348','2013-05-11','09:10:00',1.34),('8348','2013-05-11','09:15:00',1.23),('8348','2013-05-11','09:20:00',1.74),('8348','2013-05-11','09:25:00',1.36),('8348','2013-05-11','09:30:00',2.22),('8348','2013-05-11','09:35:00',2.06),('8348','2013-05-11','09:40:00',1.21),('8348','2013-05-11','09:45:00',1.79),('8348','2013-05-11','09:50:00',1.7),('8348','2013-05-11','09:55:00',2.79),('8348','2013-05-11','10:00:00',1.89),('8348','2013-05-11','10:05:00',1.2),('8348','2013-05-11','10:20:00',1.08),('8348','2013-05-11','10:25:00',1),('8348','2013-05-11','10:30:00',1.16),('8348','2013-05-11','10:35:00',1.13),('8348','2013-05-11','10:50:00',1.22),('8348','2013-05-11','10:55:00',2.74),('8348','2013-05-11','11:00:00',3.86),('8348','2013-05-11','11:05:00',1.75),('8348','2013-05-11','11:10:00',1.17),('8348','2013-05-11','11:30:00',1.61),('8348','2013-05-11','11:35:00',3.01),('8348','2013-05-11','11:40:00',1.77),('8348','2013-05-11','11:45:00',4.16),('8348','2013-05-11','11:50:00',1.82),('8348','2013-05-11','12:00:00',1.45),('8348','2013-05-11','12:05:00',1.82),('8348','2013-05-11','12:10:00',1.39),('8348','2013-05-11','12:15:00',1.31),('8348','2013-05-11','12:20:00',2.48),('8348','2013-05-11','12:25:00',4.49),('8348','2013-05-11','12:30:00',2.47),('8348','2013-05-11','12:35:00',2.03),('8348','2013-05-11','12:40:00',1.86),('8348','2013-05-11','12:45:00',1.59),('8348','2013-05-11','12:50:00',1.58),('8348','2013-05-11','12:55:00',1.45),('8348','2013-05-11','13:00:00',1.61),('8348','2013-05-11','13:05:00',1.34),('8348','2013-05-11','13:10:00',1.01),('8348','2013-05-11','13:30:00',1.01),('8348','2013-05-11','13:35:00',1.17),('8348','2013-05-11','14:00:00',2.35),('8348','2013-05-11','14:05:00',3.42),('8348','2013-05-11','14:10:00',2.37),('8348','2013-05-11','14:15:00',3.11),('8348','2013-05-11','14:20:00',3.73),('8348','2013-05-11','14:25:00',3.47),('8348','2013-05-11','14:30:00',1.89),('8348','2013-05-11','14:35:00',2.81),('8348','2013-05-11','14:40:00',2.65),('8348','2013-05-11','14:45:00',4.39),('8348','2013-05-11','14:50:00',4.26),('8348','2013-05-11','14:55:00',4.08),('8348','2013-05-11','15:00:00',3.66),('8348','2013-05-11','15:05:00',3.92),('8348','2013-05-11','15:10:00',4),('8348','2013-05-11','15:15:00',3.88),('8348','2013-05-11','15:20:00',3.84),('8348','2013-05-11','15:25:00',3.46),('8348','2013-05-11','15:30:00',3.75),('8348','2013-05-11','15:35:00',3.31),('8348','2013-05-11','15:40:00',3.71),('8348','2013-05-11','15:45:00',3.39),('8348','2013-05-11','15:50:00',3.22),('8348','2013-05-11','15:55:00',3.57),('8348','2013-05-11','16:00:00',3.54),('8348','2013-05-11','16:05:00',3.34),('8348','2013-05-11','16:10:00',3.47),('8348','2013-05-11','16:15:00',2.86),('8348','2013-05-11','16:20:00',3.34),('8348','2013-05-11','16:25:00',3.2),('8348','2013-05-11','16:30:00',2.87),('8348','2013-05-11','16:35:00',2.46),('8348','2013-05-11','16:40:00',3.02),('8348','2013-05-11','16:45:00',2.91),('8348','2013-05-11','16:50:00',2.32),('8348','2013-05-11','16:55:00',2.89),('8348','2013-05-11','17:00:00',2.82),('8348','2013-05-11','17:05:00',2.18),('8348','2013-05-11','17:10:00',2.62),('8348','2013-05-11','17:15:00',1.68),('8348','2013-05-11','17:20:00',2.48),('8348','2013-05-11','17:25:00',2.47),('8348','2013-05-11','17:30:00',1.9),('8348','2013-05-11','17:35:00',2.26),('8348','2013-05-11','17:40:00',1.93),('8348','2013-05-11','17:45:00',2.19),('8348','2013-05-11','17:50:00',1.27),('8348','2013-05-11','17:55:00',1.68),('8348','2013-05-11','18:05:00',1.58),('8348','2013-05-11','18:10:00',1.76),('8348','2013-05-11','18:15:00',1.19),('8348','2013-05-11','18:20:00',1.14),('8348','2013-05-11','18:25:00',1.34),('8348','2013-05-11','18:30:00',1.14),('8348','2013-05-11','18:35:00',1.11),('8348','2013-05-11','18:40:00',1.05),('8348','2013-05-11','18:55:00',1.06),('8348','2013-05-10','07:55:00',1.04),('8348','2013-05-10','08:00:00',1.31),('8348','2013-05-10','08:05:00',1.58),('8348','2013-05-10','08:10:00',1.67),('8348','2013-05-10','08:15:00',1.69),('8348','2013-05-10','08:20:00',1.55),('8348','2013-05-10','08:25:00',1.46),('8348','2013-05-10','08:30:00',1.51),('8348','2013-05-10','08:35:00',1.53),('8348','2013-05-10','09:00:00',1.32),('8348','2013-05-10','09:05:00',1.95),('8348','2013-05-10','09:10:00',2.14),('8348','2013-05-10','09:15:00',2.24),('8348','2013-05-10','09:20:00',2.12),('8348','2013-05-10','09:25:00',1.94),('8348','2013-05-10','09:30:00',1.99),('8348','2013-05-10','09:35:00',2.48),('8348','2013-05-10','09:40:00',2.1),('8348','2013-05-10','09:45:00',2.39),('8348','2013-05-10','09:50:00',1.96),('8348','2013-05-10','09:55:00',2.09),('8348','2013-05-10','10:00:00',1.24),('8348','2013-05-10','10:05:00',1.27),('8348','2013-05-10','10:10:00',1.1),('8348','2013-05-10','10:20:00',2.08),('8348','2013-05-10','10:25:00',2.08),('8348','2013-05-10','10:30:00',2.81),('8348','2013-05-10','10:35:00',3.09),('8348','2013-05-10','10:40:00',3.25),('8348','2013-05-10','10:45:00',3.41),('8348','2013-05-10','10:50:00',3.47),('8348','2013-05-10','10:55:00',3.46),('8348','2013-05-10','11:00:00',3.35),('8348','2013-05-10','11:05:00',3.41),('8348','2013-05-10','11:10:00',3.4),('8348','2013-05-10','11:15:00',3.28),('8348','2013-05-10','11:20:00',3.76),('8348','2013-05-10','11:25:00',3.07),('8348','2013-05-10','11:30:00',3.41),('8348','2013-05-10','11:35:00',2.91),('8348','2013-05-10','11:40:00',1.64),('8348','2013-05-10','11:45:00',3.41),('8348','2013-05-10','11:50:00',3.1),('8348','2013-05-10','11:55:00',4.14),('8348','2013-05-10','12:00:00',2.5),('8348','2013-05-10','12:05:00',1.85),('8348','2013-05-10','12:10:00',1.78),('8348','2013-05-10','12:15:00',2.2),('8348','2013-05-10','12:20:00',2.47),('8348','2013-05-10','12:25:00',2.04),('8348','2013-05-10','12:30:00',2.23),('8348','2013-05-10','12:35:00',2.08),('8348','2013-05-10','12:40:00',3.19),('8348','2013-05-10','12:45:00',4.15),('8348','2013-05-10','12:50:00',3.42),('8348','2013-05-10','12:55:00',2.43),('8348','2013-05-10','13:00:00',3.88),('8348','2013-05-10','13:05:00',3.55),('8348','2013-05-10','13:10:00',4.63),('8348','2013-05-10','13:15:00',4.26),('8348','2013-05-10','13:20:00',2.87),('8348','2013-05-10','13:25:00',2.77),('8348','2013-05-10','13:30:00',3.14),('8348','2013-05-10','13:35:00',3.66),('8348','2013-05-10','13:40:00',4.01),('8348','2013-05-10','13:45:00',3.56),('8348','2013-05-10','13:50:00',2.18),('8348','2013-05-10','13:55:00',1.99),('8348','2013-05-10','14:00:00',1.83),('8348','2013-05-10','14:05:00',1.94),('8348','2013-05-10','14:10:00',2.31),('8348','2013-05-10','14:15:00',2.44),('8348','2013-05-10','14:20:00',2.4),('8348','2013-05-10','14:25:00',2.39),('8348','2013-05-10','14:30:00',2.47),('8348','2013-05-10','14:35:00',3.05),('8348','2013-05-10','14:40:00',2.5),('8348','2013-05-10','14:45:00',1.81),('8348','2013-05-10','14:50:00',1.39),('8348','2013-05-10','14:55:00',1.22),('8348','2013-05-10','15:00:00',1.18),('8348','2013-05-10','15:05:00',1.35),('8348','2013-05-10','15:10:00',1.94),('8348','2013-05-10','15:15:00',3.3),('8348','2013-05-10','15:20:00',2.47),('8348','2013-05-10','15:25:00',1.88),('8348','2013-05-10','15:30:00',1.83),('8348','2013-05-10','15:35:00',1.87),('8348','2013-05-10','15:40:00',1.94),('8348','2013-05-10','15:45:00',1.83),('8348','2013-05-10','15:50:00',1.68),('8348','2013-05-10','15:55:00',1.58),('8348','2013-05-10','16:00:00',1.54),('8348','2013-05-10','16:05:00',1.51),('8348','2013-05-10','16:10:00',1.48),('8348','2013-05-10','16:15:00',1.35),('8348','2013-05-10','16:20:00',1.23),('8348','2013-05-10','16:25:00',1.26),('8348','2013-05-10','16:30:00',1.34),('8348','2013-05-10','16:35:00',1.42),('8348','2013-05-10','16:40:00',1.33),('8348','2013-05-10','16:45:00',1.38),('8348','2013-05-10','16:50:00',1.29),('8348','2013-05-10','16:55:00',1.07),('8348','2013-05-10','17:10:00',1.28),('8348','2013-05-10','17:15:00',1.61),('8348','2013-05-10','17:20:00',2.15),('8348','2013-05-10','17:25:00',1.91),('8348','2013-05-10','17:30:00',1.84),('8348','2013-05-10','17:35:00',2.31),('8348','2013-05-10','17:40:00',1.34),('8348','2013-05-10','17:45:00',1.27),('8348','2013-05-10','17:50:00',1.05),('8348','2013-05-09','08:00:00',1.01),('8348','2013-05-09','08:05:00',1.08),('8348','2013-05-09','08:10:00',1.15),('8348','2013-05-09','08:15:00',1.19),('8348','2013-05-09','08:20:00',1.32),('8348','2013-05-09','08:25:00',1.38),('8348','2013-05-09','08:30:00',1.49),('8348','2013-05-09','08:35:00',1.57),('8348','2013-05-09','08:40:00',1.67),('8348','2013-05-09','08:45:00',1.74),('8348','2013-05-09','08:50:00',1.8),('8348','2013-05-09','08:55:00',1.86),('8348','2013-05-09','09:00:00',1.93),('8348','2013-05-09','09:05:00',2.01),('8348','2013-05-09','09:10:00',2.08),('8348','2013-05-09','09:15:00',2.15),('8348','2013-05-09','09:20:00',2.21),('8348','2013-05-09','09:25:00',2.29),('8348','2013-05-09','09:30:00',2.36),('8348','2013-05-09','09:35:00',2.42),('8348','2013-05-09','09:40:00',2.47),('8348','2013-05-09','09:45:00',2.53),('8348','2013-05-09','09:50:00',2.6),('8348','2013-05-09','09:55:00',2.66),('8348','2013-05-09','10:00:00',2.72),('8348','2013-05-09','10:05:00',2.77),('8348','2013-05-09','10:10:00',2.82),('8348','2013-05-09','10:15:00',2.86),('8348','2013-05-09','10:20:00',2.89),('8348','2013-05-09','10:25:00',2.94),('8348','2013-05-09','10:30:00',2.99),('8348','2013-05-09','10:35:00',3.03),('8348','2013-05-09','10:40:00',3.07),('8348','2013-05-09','10:45:00',3.1),('8348','2013-05-09','10:50:00',3.15),('8348','2013-05-09','10:55:00',3.18),('8348','2013-05-09','11:00:00',3.21),('8348','2013-05-09','11:05:00',3.26),('8348','2013-05-09','11:10:00',3.3),('8348','2013-05-09','11:15:00',3.32),('8348','2013-05-09','11:20:00',3.35),('8348','2013-05-09','11:25:00',3.37),('8348','2013-05-09','11:30:00',3.38),('8348','2013-05-09','11:35:00',3.41),('8348','2013-05-09','11:40:00',3.48),('8348','2013-05-09','11:45:00',3.5),('8348','2013-05-09','11:50:00',3.5),('8348','2013-05-09','11:55:00',3.53),('8348','2013-05-09','12:00:00',3.52),('8348','2013-05-09','12:05:00',3.57),('8348','2013-05-09','12:10:00',3.6),('8348','2013-05-09','12:15:00',3.62),('8348','2013-05-09','12:20:00',3.63),('8348','2013-05-09','12:25:00',3.62),('8348','2013-05-09','12:30:00',3.66),('8348','2013-05-09','12:35:00',3.69),('8348','2013-05-09','12:40:00',3.7),('8348','2013-05-09','12:45:00',3.71),('8348','2013-05-09','12:50:00',3.75),('8348','2013-05-09','12:55:00',3.72),('8348','2013-05-09','13:00:00',3.69),('8348','2013-05-09','13:05:00',3.66),('8348','2013-05-09','13:10:00',3.7),('8348','2013-05-09','13:15:00',3.71),('8348','2013-05-09','13:20:00',3.74),('8348','2013-05-09','13:25:00',3.75),('8348','2013-05-09','13:30:00',3.78),('8348','2013-05-09','13:35:00',3.76),('8348','2013-05-09','13:40:00',3.78),('8348','2013-05-09','13:45:00',3.85),('8348','2013-05-09','13:50:00',3.84),('8348','2013-05-09','13:55:00',3.92),('8348','2013-05-09','14:00:00',2.73),('8348','2013-05-09','14:05:00',2.79),('8348','2013-05-09','14:10:00',3.44),('8348','2013-05-09','14:15:00',2.87),('8348','2013-05-09','14:20:00',1.82),('8348','2013-05-09','14:25:00',3.97),('8348','2013-05-09','14:30:00',3.84),('8348','2013-05-09','14:35:00',3.78),('8348','2013-05-09','14:40:00',3.75),('8348','2013-05-09','14:45:00',3.71),('8348','2013-05-09','14:50:00',3.71),('8348','2013-05-09','14:55:00',3.76),('8348','2013-05-09','15:00:00',3.75),('8348','2013-05-09','15:05:00',3.69),('8348','2013-05-09','15:10:00',3.63),('8348','2013-05-09','15:15:00',3.57),('8348','2013-05-09','15:20:00',3.52),('8348','2013-05-09','15:25:00',3.46),('8348','2013-05-09','15:30:00',3.47),('8348','2013-05-09','15:35:00',3.46),('8348','2013-05-09','15:40:00',3.43),('8348','2013-05-09','15:45:00',3.4),('8348','2013-05-09','15:50:00',3.36),('8348','2013-05-09','15:55:00',3.32),('8348','2013-05-09','16:00:00',3.27),('8348','2013-05-09','16:05:00',3.23),('8348','2013-05-09','16:10:00',3.18),('8348','2013-05-09','16:15:00',3.11),('8348','2013-05-09','16:20:00',3.04),('8348','2013-05-09','16:25:00',2.97),('8348','2013-05-09','16:30:00',2.93),('8348','2013-05-09','16:35:00',2.87),('8348','2013-05-09','16:40:00',2.81),('8348','2013-05-09','16:45:00',2.74),('8348','2013-05-09','16:50:00',2.65),('8348','2013-05-09','16:55:00',2.59),('8348','2013-05-09','17:00:00',2.53),('8348','2013-05-09','17:05:00',2.46),('8348','2013-05-09','17:10:00',2.41),('8348','2013-05-09','17:15:00',2.34),('8348','2013-05-09','17:20:00',2.29),('8348','2013-05-09','17:25:00',2.23),('8348','2013-05-09','17:30:00',2.14),('8348','2013-05-09','17:35:00',2.06),('8348','2013-05-09','17:40:00',1.98),('8348','2013-05-09','17:45:00',1.9),('8348','2013-05-09','17:50:00',1.82),('8348','2013-05-09','17:55:00',1.75),('8348','2013-05-09','18:00:00',1.67),('8348','2013-05-09','18:05:00',1.59),('8348','2013-05-09','18:10:00',1.5),('8348','2013-05-09','18:15:00',1.42),('8348','2013-05-09','18:20:00',1.34),('8348','2013-05-09','18:25:00',1.26),('8348','2013-05-09','18:30:00',1.18),('8348','2013-05-09','18:35:00',1.1),('8348','2013-05-09','18:40:00',1.02),('8348','2013-05-08','08:05:00',1.16),('8348','2013-05-08','08:10:00',1.21),('8348','2013-05-08','08:15:00',1.22),('8348','2013-05-08','08:20:00',1.29),('8348','2013-05-08','08:25:00',1.36),('8348','2013-05-08','08:30:00',1.44),('8348','2013-05-08','08:35:00',1.52),('8348','2013-05-08','08:40:00',1.49),('8348','2013-05-08','08:45:00',1.05),('8348','2013-05-08','08:50:00',1.1),('8348','2013-05-08','09:05:00',1.22),('8348','2013-05-08','09:10:00',1.35),('8348','2013-05-08','09:35:00',1.24),('8348','2013-05-08','09:40:00',3),('8348','2013-05-08','09:45:00',2.47),('8348','2013-05-08','09:50:00',1.73),('8348','2013-05-08','09:55:00',2.67),('8348','2013-05-08','10:05:00',2.02),('8348','2013-05-08','10:10:00',2.59),('8348','2013-05-08','10:15:00',1.48),('8348','2013-05-08','10:55:00',1.33),('8348','2013-05-08','11:00:00',2.19),('8348','2013-05-08','11:05:00',3.76),('8348','2013-05-08','11:10:00',3.48),('8348','2013-05-08','11:15:00',2.8),('8348','2013-05-08','11:20:00',3.44),('8348','2013-05-08','11:25:00',3.68),('8348','2013-05-08','11:30:00',3.79),('8348','2013-05-08','11:35:00',3.88),('8348','2013-05-08','11:40:00',3.09),('8348','2013-05-08','11:45:00',1.49),('8348','2013-05-08','11:50:00',1.55),('8348','2013-05-08','11:55:00',1.56),('8348','2013-05-08','12:00:00',3.58),('8348','2013-05-08','12:05:00',1.13),('8348','2013-05-08','12:15:00',1.05),('8348','2013-05-08','12:20:00',3.09),('8348','2013-05-08','12:25:00',2.64),('8348','2013-05-08','12:30:00',2.14),('8348','2013-05-08','12:35:00',1.05),('8348','2013-05-08','12:40:00',1.05),('8348','2013-05-08','12:45:00',1.26),('8348','2013-05-08','12:50:00',1.55),('8348','2013-05-08','12:55:00',3.02),('8348','2013-05-08','13:00:00',4.07),('8348','2013-05-08','13:05:00',2.82),('8348','2013-05-08','13:10:00',4.67),('8348','2013-05-08','13:15:00',2.29),('8348','2013-05-08','13:20:00',1.02),('8348','2013-05-08','13:25:00',1.94),('8348','2013-05-08','13:40:00',2.79),('8348','2013-05-08','13:45:00',4.52),('8348','2013-05-08','13:50:00',4.33),('8348','2013-05-08','13:55:00',4.26),('8348','2013-05-08','14:00:00',3.56),('8348','2013-05-08','14:05:00',3.93),('8348','2013-05-08','14:10:00',2.43),('8348','2013-05-08','14:15:00',1.42),('8348','2013-05-08','14:20:00',2.36),('8348','2013-05-08','14:25:00',1.4),('8348','2013-05-08','14:30:00',1.94),('8348','2013-05-08','14:35:00',3.08),('8348','2013-05-08','14:40:00',4.46),('8348','2013-05-08','14:45:00',4),('8348','2013-05-08','14:50:00',3.91),('8348','2013-05-08','14:55:00',3.56),('8348','2013-05-08','15:00:00',3.37),('8348','2013-05-08','15:05:00',3.63),('8348','2013-05-08','15:10:00',3.28),('8348','2013-05-08','15:15:00',3.71),('8348','2013-05-08','15:20:00',3.67),('8348','2013-05-08','15:25:00',3.67),('8348','2013-05-08','15:30:00',3.61),('8348','2013-05-08','15:35:00',3.49),('8348','2013-05-08','15:40:00',3.44),('8348','2013-05-08','15:45:00',3.42),('8348','2013-05-08','15:50:00',3.38),('8348','2013-05-08','15:55:00',3.35),('8348','2013-05-08','16:00:00',3.34),('8348','2013-05-08','16:05:00',3.26),('8348','2013-05-08','16:10:00',3.22),('8348','2013-05-08','16:15:00',3.17),('8348','2013-05-08','16:20:00',3.09),('8348','2013-05-08','16:25:00',3.06),('8348','2013-05-08','16:30:00',3.09),('8348','2013-05-08','16:35:00',2.89),('8348','2013-05-08','16:40:00',2.31),('8348','2013-05-08','16:45:00',2.31),('8348','2013-05-08','16:50:00',2.66),('8348','2013-05-08','16:55:00',2.71),('8348','2013-05-08','17:00:00',2.62),('8348','2013-05-08','17:05:00',2.76),('8348','2013-05-08','17:10:00',2.68),('8348','2013-05-08','17:15:00',2.53),('8348','2013-05-08','17:20:00',2.14),('8348','2013-05-08','17:25:00',2.23),('8348','2013-05-08','17:30:00',2.48),('8348','2013-05-08','17:35:00',2.42),('8348','2013-05-08','17:40:00',2.42),('8348','2013-05-08','17:45:00',2.43),('8348','2013-05-08','17:50:00',2.41),('8348','2013-05-08','17:55:00',2.21),('8348','2013-05-08','18:00:00',1.01),('8348','2013-05-08','18:10:00',1.14),('8348','2013-05-08','18:15:00',1.8),('8348','2013-05-08','18:20:00',1.71),('8348','2013-05-08','18:25:00',1.55),('8348','2013-05-08','18:30:00',1.24),('8348','2013-05-08','18:35:00',1.22),('8348','2013-05-07','08:05:00',1.05),('8348','2013-05-07','08:10:00',1.11),('8348','2013-05-07','08:15:00',1.18),('8348','2013-05-07','08:20:00',1.27),('8348','2013-05-07','08:25:00',1.35),('8348','2013-05-07','08:30:00',1.45),('8348','2013-05-07','08:35:00',1.51),('8348','2013-05-07','08:40:00',1.64),('8348','2013-05-07','08:45:00',1.74),('8348','2013-05-07','08:50:00',1.88),('8348','2013-05-07','08:55:00',2.06),('8348','2013-05-07','09:00:00',2.18),('8348','2013-05-07','09:35:00',1.01),('8348','2013-05-07','09:40:00',1.73),('8348','2013-05-07','09:45:00',1.92),('8348','2013-05-07','09:50:00',1.91),('8348','2013-05-07','10:55:00',1.06),('8348','2013-05-07','11:00:00',1.23),('8348','2013-05-07','11:05:00',1.3),('8348','2013-05-07','11:10:00',1.26),('8348','2013-05-07','11:15:00',1.22),('8348','2013-05-07','11:20:00',1.38),('8348','2013-05-07','11:25:00',1.55),('8348','2013-05-07','11:55:00',1.51),('8348','2013-05-07','12:00:00',4.38),('8348','2013-05-07','12:05:00',4.3),('8348','2013-05-07','12:10:00',4.32),('8348','2013-05-07','12:15:00',4.36),('8348','2013-05-07','12:20:00',4.33),('8348','2013-05-07','12:25:00',3.49),('8348','2013-05-07','12:30:00',1.19),('8348','2013-05-07','13:15:00',1.07),('8348','2013-05-07','13:20:00',1.06),('8348','2013-05-07','13:25:00',1.27),('8348','2013-05-07','13:30:00',2.3),('8348','2013-05-07','13:35:00',3.32),('8348','2013-05-07','13:40:00',4.15),('8348','2013-05-07','13:45:00',4.62),('8348','2013-05-07','13:50:00',4.26),('8348','2013-05-07','13:55:00',2.01),('8348','2013-05-07','14:00:00',4.33),('8348','2013-05-07','14:05:00',3.49),('8348','2013-05-07','14:10:00',3.74),('8348','2013-05-07','14:15:00',3.91),('8348','2013-05-07','14:20:00',2.32),('8348','2013-05-07','14:25:00',1.53),('8348','2013-05-07','14:30:00',2.81),('8348','2013-05-07','14:35:00',2.31),('8348','2013-05-07','14:40:00',4.14),('8348','2013-05-07','14:45:00',2.61),('8348','2013-05-07','14:50:00',3.62),('8348','2013-05-07','14:55:00',2.76),('8348','2013-05-07','15:00:00',3.76),('8348','2013-05-07','15:05:00',3.92),('8348','2013-05-07','15:10:00',3.3),('8348','2013-05-07','15:15:00',3.78),('8348','2013-05-07','15:20:00',3.59),('8348','2013-05-07','15:25:00',2.33),('8348','2013-05-07','15:30:00',2.22),('8348','2013-05-07','15:35:00',2.84),('8348','2013-05-07','15:40:00',2.83),('8348','2013-05-07','15:45:00',2.2),('8348','2013-05-07','15:50:00',1.92),('8348','2013-05-07','15:55:00',2.13),('8348','2013-05-07','16:00:00',3.45),('8348','2013-05-07','16:05:00',1.79),('8348','2013-05-07','16:10:00',1.24),('8348','2013-05-07','16:15:00',2.81),('8348','2013-05-07','16:20:00',4.05),('8348','2013-05-07','16:25:00',3.83),('8348','2013-05-07','16:30:00',3.64),('8348','2013-05-07','16:35:00',3.61),('8348','2013-05-07','16:40:00',3.64),('8348','2013-05-07','16:45:00',2.74),('8348','2013-05-07','16:50:00',2.95),('8348','2013-05-07','16:55:00',2.23),('8348','2013-05-07','17:00:00',2.76),('8348','2013-05-07','17:05:00',2.88),('8348','2013-05-07','17:10:00',1.59),('8348','2013-05-07','17:15:00',1.18),('8348','2013-05-07','17:20:00',1.16),('8348','2013-05-07','17:25:00',1.14),('8348','2013-05-06','08:25:00',1.03),('8348','2013-05-06','08:30:00',1.13),('8348','2013-05-06','08:35:00',1.04),('8348','2013-05-06','08:50:00',1.09),('8348','2013-05-06','08:55:00',1.77),('8348','2013-05-06','09:00:00',2.02),('8348','2013-05-06','09:05:00',1.41),('8348','2013-05-06','09:10:00',1.25),('8348','2013-05-06','09:15:00',1.24),('8348','2013-05-06','09:20:00',1.2),('8348','2013-05-06','09:25:00',1.12),('8348','2013-05-06','10:00:00',1.59),('8348','2013-05-06','10:05:00',1.09),('8348','2013-05-06','10:10:00',1.01),('8348','2013-05-06','10:15:00',1.29),('8348','2013-05-06','10:20:00',2.02),('8348','2013-05-06','10:25:00',1.73),('8348','2013-05-06','10:30:00',1.71),('8348','2013-05-06','10:35:00',1.73),('8348','2013-05-06','10:40:00',1.64),('8348','2013-05-06','10:45:00',2.31),('8348','2013-05-06','10:50:00',2.37),('8348','2013-05-06','10:55:00',1.79),('8348','2013-05-06','11:00:00',1.64),('8348','2013-05-06','11:05:00',1.85),('8348','2013-05-06','11:10:00',1.81),('8348','2013-05-06','11:15:00',1.6),('8348','2013-05-06','11:20:00',1.92),('8348','2013-05-06','11:25:00',2),('8348','2013-05-06','11:30:00',1.32),('8348','2013-05-06','11:35:00',1.57),('8348','2013-05-06','11:40:00',2.18),('8348','2013-05-06','11:45:00',3.66),('8348','2013-05-06','11:50:00',2.03),('8348','2013-05-06','11:55:00',1.69),('8348','2013-05-06','12:00:00',1.95),('8348','2013-05-06','12:05:00',1.89),('8348','2013-05-06','12:10:00',3.18),('8348','2013-05-06','12:15:00',2.28),('8348','2013-05-06','12:20:00',2.19),('8348','2013-05-06','12:25:00',2.74),('8348','2013-05-06','12:30:00',3.83),('8348','2013-05-06','12:35:00',4.28),('8348','2013-05-06','12:40:00',2.52),('8348','2013-05-06','12:45:00',1.97),('8348','2013-05-06','12:50:00',3.54),('8348','2013-05-06','12:55:00',2.85),('8348','2013-05-06','13:00:00',2.16),('8348','2013-05-06','13:05:00',3.4),('8348','2013-05-06','13:10:00',3.43),('8348','2013-05-06','13:15:00',3.7),('8348','2013-05-06','13:20:00',2.8),('8348','2013-05-06','13:25:00',2.75),('8348','2013-05-06','13:30:00',2.77),('8348','2013-05-06','13:35:00',3.04),('8348','2013-05-06','13:40:00',3.33),('8348','2013-05-06','13:45:00',4.37),('8348','2013-05-06','13:50:00',3.55),('8348','2013-05-06','13:55:00',4.43),('8348','2013-05-06','14:00:00',3.08),('8348','2013-05-06','14:05:00',3.95),('8348','2013-05-06','14:10:00',2.37),('8348','2013-05-06','14:15:00',3.17),('8348','2013-05-06','14:20:00',4.67),('8348','2013-05-06','14:25:00',2.25),('8348','2013-05-06','14:30:00',3.7),('8348','2013-05-06','14:35:00',3.82),('8348','2013-05-06','14:40:00',2.06),('8348','2013-05-06','14:45:00',2.84),('8348','2013-05-06','14:50:00',1.95),('8348','2013-05-06','14:55:00',3.91),('8348','2013-05-06','15:00:00',3.58),('8348','2013-05-06','15:05:00',3.15),('8348','2013-05-06','15:10:00',3.51),('8348','2013-05-06','15:15:00',1.92),('8348','2013-05-06','15:20:00',2),('8348','2013-05-06','15:25:00',2.97),('8348','2013-05-06','15:30:00',1.45),('8348','2013-05-06','15:35:00',1.88),('8348','2013-05-06','15:40:00',1.28),('8348','2013-05-06','15:45:00',1.75),('8348','2013-05-06','15:50:00',2),('8348','2013-05-06','15:55:00',1.4),('8348','2013-05-06','16:00:00',2.18),('8348','2013-05-06','16:05:00',1.41),('8348','2013-05-06','16:10:00',1.31),('8348','2013-05-06','16:15:00',1.77),('8348','2013-05-06','16:20:00',2.09),('8348','2013-05-06','16:25:00',1.68),('8348','2013-05-06','16:30:00',1.84),('8348','2013-05-06','16:35:00',1.86),('8348','2013-05-06','16:40:00',2.56),('8348','2013-05-06','16:45:00',2.79),('8348','2013-05-06','16:50:00',2.54),('8348','2013-05-06','16:55:00',2.86),('8348','2013-05-06','17:15:00',1.11),('8348','2013-05-06','17:35:00',1.42),('8348','2013-05-06','17:40:00',1.69),('8348','2013-05-06','17:50:00',1.21),('8348','2013-05-06','17:55:00',1.25),('8348','2013-05-06','18:00:00',1.67),('8348','2013-05-06','18:05:00',1.86),('8348','2013-05-06','18:15:00',1.26),('8348','2013-05-06','18:20:00',1.69),('8348','2013-05-06','18:25:00',1.47),('8348','2013-05-06','18:30:00',1.27),('8348','2013-05-05','08:10:00',1.05),('8348','2013-05-05','08:15:00',1.15),('8348','2013-05-05','08:20:00',1.35),('8348','2013-05-05','08:25:00',1.7),('8348','2013-05-05','08:30:00',1.83),('8348','2013-05-05','08:35:00',1.69),('8348','2013-05-05','08:40:00',1.75),('8348','2013-05-05','08:45:00',1.44),('8348','2013-05-05','08:50:00',1.16),('8348','2013-05-05','08:55:00',1.15),('8348','2013-05-05','09:00:00',1.21),('8348','2013-05-05','09:05:00',1.24),('8348','2013-05-05','09:10:00',1.24),('8348','2013-05-05','09:15:00',1.28),('8348','2013-05-05','09:20:00',1.1),('8348','2013-05-05','09:25:00',1.28),('8348','2013-05-05','09:30:00',1.61),('8348','2013-05-05','09:35:00',1.28),('8348','2013-05-05','09:40:00',2.04),('8348','2013-05-05','09:45:00',2.59),('8348','2013-05-05','09:50:00',2.75),('8348','2013-05-05','09:55:00',2.61),('8348','2013-05-05','10:00:00',2.59),('8348','2013-05-05','10:05:00',2.36),('8348','2013-05-05','10:10:00',1.91),('8348','2013-05-05','10:15:00',2.43),('8348','2013-05-05','10:20:00',3.07),('8348','2013-05-05','10:25:00',1.95),('8348','2013-05-05','10:30:00',2.21),('8348','2013-05-05','10:35:00',2.42),('8348','2013-05-05','10:40:00',2.22),('8348','2013-05-05','10:45:00',2.28),('8348','2013-05-05','10:50:00',1.53),('8348','2013-05-05','10:55:00',1.34),('8348','2013-05-05','11:00:00',1.31),('8348','2013-05-05','11:05:00',1.53),('8348','2013-05-05','11:10:00',1.4),('8348','2013-05-05','11:15:00',1.5),('8348','2013-05-05','11:20:00',2.31),('8348','2013-05-05','11:25:00',3.09),('8348','2013-05-05','11:30:00',2.27),('8348','2013-05-05','11:35:00',3.07),('8348','2013-05-05','11:40:00',2.37),('8348','2013-05-05','11:45:00',2.38),('8348','2013-05-05','11:50:00',2.5),('8348','2013-05-05','11:55:00',3.33),('8348','2013-05-05','12:00:00',2.84),('8348','2013-05-05','12:05:00',2.6),('8348','2013-05-05','12:10:00',2.4),('8348','2013-05-05','12:15:00',2.84),('8348','2013-05-05','12:20:00',2.86),('8348','2013-05-05','12:25:00',3.6),('8348','2013-05-05','12:30:00',2.36),('8348','2013-05-05','12:35:00',3.17),('8348','2013-05-05','12:40:00',3.73),('8348','2013-05-05','12:45:00',3.89),('8348','2013-05-05','12:50:00',3.77),('8348','2013-05-05','12:55:00',3.93),('8348','2013-05-05','13:00:00',3.95),('8348','2013-05-05','13:05:00',3.96),('8348','2013-05-05','13:10:00',4.1),('8348','2013-05-05','13:15:00',3.49),('8348','2013-05-05','13:20:00',2.99),('8348','2013-05-05','13:25:00',1.71),('8348','2013-05-05','13:30:00',1.56),('8348','2013-05-05','13:35:00',3.98),('8348','2013-05-05','13:40:00',4.11),('8348','2013-05-05','13:45:00',3.94),('8348','2013-05-05','13:50:00',4.02),('8348','2013-05-05','13:55:00',4.06),('8348','2013-05-05','14:00:00',4.09),('8348','2013-05-05','14:05:00',3.86),('8348','2013-05-05','14:10:00',2.98),('8348','2013-05-05','14:15:00',3.26),('8348','2013-05-05','14:20:00',3.72),('8348','2013-05-05','14:25:00',3.59),('8348','2013-05-05','14:30:00',3.52),('8348','2013-05-05','14:35:00',3.48),('8348','2013-05-05','14:40:00',3.46),('8348','2013-05-05','14:45:00',3.44),('8348','2013-05-05','14:50:00',3.41),('8348','2013-05-05','14:55:00',3.36),('8348','2013-05-05','15:00:00',3.35),('8348','2013-05-05','15:05:00',3.32),('8348','2013-05-05','15:10:00',3.31),('8348','2013-05-05','15:15:00',3.28),('8348','2013-05-05','15:20:00',3.21),('8348','2013-05-05','15:25:00',3.21),('8348','2013-05-05','15:30:00',3.19),('8348','2013-05-05','15:35:00',3.19),('8348','2013-05-05','15:40:00',3.16),('8348','2013-05-05','15:45:00',3.11),('8348','2013-05-05','15:50:00',3.07),('8348','2013-05-05','15:55:00',3.04),('8348','2013-05-05','16:00:00',2.99),('8348','2013-05-05','16:05:00',2.95),('8348','2013-05-05','16:10:00',2.9),('8348','2013-05-05','16:15:00',2.84),('8348','2013-05-05','16:20:00',2.79),('8348','2013-05-05','16:25:00',2.75),('8348','2013-05-05','16:30:00',2.71),('8348','2013-05-05','16:35:00',2.65),('8348','2013-05-05','16:40:00',2.6),('8348','2013-05-05','16:45:00',2.53),('8348','2013-05-05','16:50:00',2.47),('8348','2013-05-05','16:55:00',2.4),('8348','2013-05-05','17:00:00',2.34),('8348','2013-05-05','17:05:00',2.28),('8348','2013-05-05','17:10:00',2.21),('8348','2013-05-05','17:15:00',2.15),('8348','2013-05-05','17:20:00',2.08),('8348','2013-05-05','17:25:00',1.99),('8348','2013-05-05','17:30:00',1.92),('8348','2013-05-05','17:35:00',1.84),('8348','2013-05-05','17:40:00',1.78),('8348','2013-05-05','17:45:00',1.71),('8348','2013-05-05','17:50:00',1.63),('8348','2013-05-05','17:55:00',1.55),('8348','2013-05-05','18:00:00',1.46),('8348','2013-05-05','18:05:00',1.39),('8348','2013-05-05','18:10:00',1.31),('8348','2013-05-05','18:15:00',1.24),('8348','2013-05-05','18:20:00',1.17),('8348','2013-05-05','18:25:00',1.09),('8348','2013-05-05','18:30:00',1.01),('8348','2013-05-04','08:10:00',1.02),('8348','2013-05-04','08:15:00',1.08),('8348','2013-05-04','08:20:00',1.13),('8348','2013-05-04','08:25:00',1.18),('8348','2013-05-04','08:30:00',1.3),('8348','2013-05-04','08:35:00',1.35),('8348','2013-05-04','08:40:00',1.43),('8348','2013-05-04','08:45:00',1.53),('8348','2013-05-04','08:50:00',1.59),('8348','2013-05-04','08:55:00',1.66),('8348','2013-05-04','09:00:00',1.72),('8348','2013-05-04','09:05:00',1.8),('8348','2013-05-04','09:10:00',1.88),('8348','2013-05-04','09:15:00',1.91),('8348','2013-05-04','09:20:00',2),('8348','2013-05-04','09:25:00',2.04),('8348','2013-05-04','09:30:00',2.08),('8348','2013-05-04','09:35:00',2.16),('8348','2013-05-04','09:40:00',2.24),('8348','2013-05-04','09:45:00',2.3),('8348','2013-05-04','09:50:00',2.35),('8348','2013-05-04','09:55:00',2.41),('8348','2013-05-04','10:00:00',2.49),('8348','2013-05-04','10:05:00',2.52),('8348','2013-05-04','10:10:00',2.57),('8348','2013-05-04','10:15:00',2.63),('8348','2013-05-04','10:20:00',2.69),('8348','2013-05-04','10:25:00',2.74),('8348','2013-05-04','10:30:00',2.76),('8348','2013-05-04','10:35:00',2.8),('8348','2013-05-04','10:40:00',2.81),('8348','2013-05-04','10:45:00',2.82),('8348','2013-05-04','10:50:00',2.77),('8348','2013-05-04','10:55:00',2.81),('8348','2013-05-04','11:00:00',2.82),('8348','2013-05-04','11:05:00',2.83),('8348','2013-05-04','11:10:00',2.7),('8348','2013-05-04','11:15:00',2.65),('8348','2013-05-04','11:20:00',2.85),('8348','2013-05-04','11:25:00',2.9),('8348','2013-05-04','11:30:00',2.81),('8348','2013-05-04','11:35:00',2.9),('8348','2013-05-04','11:40:00',2.82),('8348','2013-05-04','11:45:00',2.89),('8348','2013-05-04','11:50:00',2.93),('8348','2013-05-04','11:55:00',2.93),('8348','2013-05-04','12:00:00',2.89),('8348','2013-05-04','12:05:00',3.02),('8348','2013-05-04','12:10:00',3.03),('8348','2013-05-04','12:15:00',3.12),('8348','2013-05-04','12:20:00',3.15),('8348','2013-05-04','12:25:00',3.22),('8348','2013-05-04','12:30:00',3.26),('8348','2013-05-04','12:35:00',3.28),('8348','2013-05-04','12:40:00',3.27),('8348','2013-05-04','12:45:00',3.32),('8348','2013-05-04','12:50:00',3.21),('8348','2013-05-04','12:55:00',3.2),('8348','2013-05-04','13:00:00',3.17),('8348','2013-05-04','13:05:00',2.84),('8348','2013-05-04','13:10:00',3.04),('8348','2013-05-04','13:15:00',3.44),('8348','2013-05-04','13:20:00',3.47),('8348','2013-05-04','13:25:00',3.34),('8348','2013-05-04','13:30:00',3.38),('8348','2013-05-04','13:35:00',3.2),('8348','2013-05-04','13:40:00',3.29),('8348','2013-05-04','13:45:00',3.3),('8348','2013-05-04','13:50:00',2.91),('8348','2013-05-04','13:55:00',3.01),('8348','2013-05-04','14:00:00',3.26),('8348','2013-05-04','14:05:00',3.19),('8348','2013-05-04','14:10:00',3.08),('8348','2013-05-04','14:15:00',3.13),('8348','2013-05-04','14:20:00',3.16),('8348','2013-05-04','14:25:00',2.92),('8348','2013-05-04','14:30:00',3.11),('8348','2013-05-04','14:35:00',2.89),('8348','2013-05-04','14:40:00',3.03),('8348','2013-05-04','14:45:00',2.97),('8348','2013-05-04','14:50:00',2.9),('8348','2013-05-04','14:55:00',3.02),('8348','2013-05-04','15:00:00',3.03),('8348','2013-05-04','15:05:00',3.12),('8348','2013-05-04','15:10:00',2.95),('8348','2013-05-04','15:15:00',3.04),('8348','2013-05-04','15:20:00',3.02),('8348','2013-05-04','15:25:00',3.03),('8348','2013-05-04','15:30:00',2.98),('8348','2013-05-04','15:35:00',2.89),('8348','2013-05-04','15:40:00',2.94),('8348','2013-05-04','15:45:00',2.97),('8348','2013-05-04','15:50:00',2.92),('8348','2013-05-04','15:55:00',2.88),('8348','2013-05-04','16:00:00',2.84),('8348','2013-05-04','16:05:00',2.77),('8348','2013-05-04','16:10:00',2.72),('8348','2013-05-04','16:15:00',2.69),('8348','2013-05-04','16:20:00',2.64),('8348','2013-05-04','16:25:00',2.58),('8348','2013-05-04','16:30:00',2.52),('8348','2013-05-04','16:35:00',2.47),('8348','2013-05-04','16:40:00',2.39),('8348','2013-05-04','16:45:00',2.34),('8348','2013-05-04','16:50:00',2.28),('8348','2013-05-04','16:55:00',2.24),('8348','2013-05-04','17:00:00',2.2),('8348','2013-05-04','17:05:00',2.12),('8348','2013-05-04','17:10:00',1.66),('8348','2013-05-04','17:15:00',1.9),('8348','2013-05-04','17:20:00',1.99),('8348','2013-05-04','17:25:00',1.92),('8348','2013-05-04','17:30:00',1.83),('8348','2013-05-04','17:35:00',1.7),('8348','2013-05-04','17:40:00',1.59),('8348','2013-05-04','17:45:00',1.56),('8348','2013-05-04','17:50:00',1.58),('8348','2013-05-04','17:55:00',1.51),('8348','2013-05-04','18:00:00',1.44),('8348','2013-05-04','18:05:00',1.37),('8348','2013-05-04','18:10:00',1.16),('8348','2013-05-03','08:05:00',1.02),('8348','2013-05-03','08:10:00',1.13),('8348','2013-05-03','08:15:00',1.3),('8348','2013-05-03','08:20:00',1.29),('8348','2013-05-03','08:25:00',1.37),('8348','2013-05-03','08:30:00',1.4),('8348','2013-05-03','08:35:00',1.44),('8348','2013-05-03','08:40:00',1.53),('8348','2013-05-03','08:45:00',1.64),('8348','2013-05-03','08:50:00',1.62),('8348','2013-05-03','08:55:00',1.65),('8348','2013-05-03','09:00:00',1.77),('8348','2013-05-03','09:05:00',1.87),('8348','2013-05-03','09:10:00',1.91),('8348','2013-05-03','09:15:00',1.97),('8348','2013-05-03','09:20:00',2.02),('8348','2013-05-03','09:25:00',2.1),('8348','2013-05-03','09:30:00',2.14),('8348','2013-05-03','09:35:00',2.22),('8348','2013-05-03','09:40:00',2.28),('8348','2013-05-03','09:45:00',2.35),('8348','2013-05-03','09:50:00',2.4),('8348','2013-05-03','09:55:00',2.46),('8348','2013-05-03','10:00:00',2.53),('8348','2013-05-03','10:05:00',2.57),('8348','2013-05-03','10:10:00',2.62),('8348','2013-05-03','10:15:00',2.66),('8348','2013-05-03','10:20:00',2.7),('8348','2013-05-03','10:25:00',2.74),('8348','2013-05-03','10:30:00',2.78),('8348','2013-05-03','10:35:00',2.85),('8348','2013-05-03','10:40:00',2.9),('8348','2013-05-03','10:45:00',2.93),('8348','2013-05-03','10:50:00',2.94),('8348','2013-05-03','10:55:00',2.99),('8348','2013-05-03','11:00:00',3.04),('8348','2013-05-03','11:05:00',3.08),('8348','2013-05-03','11:10:00',3.09),('8348','2013-05-03','11:15:00',3.11),('8348','2013-05-03','11:20:00',3.16),('8348','2013-05-03','11:25:00',3.2),('8348','2013-05-03','11:30:00',3.23),('8348','2013-05-03','11:35:00',3.28),('8348','2013-05-03','11:40:00',3.31),('8348','2013-05-03','11:45:00',3.3),('8348','2013-05-03','11:50:00',3.31),('8348','2013-05-03','11:55:00',3.34),('8348','2013-05-03','12:00:00',3.36),('8348','2013-05-03','12:05:00',3.36),('8348','2013-05-03','12:10:00',3.38),('8348','2013-05-03','12:15:00',3.4),('8348','2013-05-03','12:20:00',3.43),('8348','2013-05-03','12:25:00',3.45),('8348','2013-05-03','12:30:00',3.45),('8348','2013-05-03','12:35:00',3.45),('8348','2013-05-03','12:40:00',3.46),('8348','2013-05-03','12:45:00',3.42),('8348','2013-05-03','12:50:00',3.48),('8348','2013-05-03','12:55:00',3.52),('8348','2013-05-03','13:00:00',3.54),('8348','2013-05-03','13:05:00',3.52),('8348','2013-05-03','13:10:00',3.52),('8348','2013-05-03','13:15:00',3.52),('8348','2013-05-03','13:20:00',3.54),('8348','2013-05-03','13:25:00',3.56),('8348','2013-05-03','13:30:00',3.56),('8348','2013-05-03','13:35:00',3.47),('8348','2013-05-03','13:40:00',3.35),('8348','2013-05-03','13:45:00',3.4),('8348','2013-05-03','13:50:00',3.36),('8348','2013-05-03','13:55:00',3.37),('8348','2013-05-03','14:00:00',3.37),('8348','2013-05-03','14:05:00',3.2),('8348','2013-05-03','14:10:00',3.27),('8348','2013-05-03','14:15:00',3.25),('8348','2013-05-03','14:20:00',3.35),('8348','2013-05-03','14:25:00',3.3),('8348','2013-05-03','14:30:00',3.35),('8348','2013-05-03','14:35:00',3.4),('8348','2013-05-03','14:40:00',3.36),('8348','2013-05-03','14:45:00',3.37),('8348','2013-05-03','14:50:00',3.33),('8348','2013-05-03','14:55:00',3.34),('8348','2013-05-03','15:00:00',3.34),('8348','2013-05-03','15:05:00',3.33),('8348','2013-05-03','15:10:00',3.33),('8348','2013-05-03','15:15:00',3.31),('8348','2013-05-03','15:20:00',3.27),('8348','2013-05-03','15:25:00',3.26),('8348','2013-05-03','15:30:00',3.23),('8348','2013-05-03','15:35:00',3.19),('8348','2013-05-03','15:40:00',3.14),('8348','2013-05-03','15:45:00',3.1),('8348','2013-05-03','15:50:00',3.04),('8348','2013-05-03','15:55:00',2.99),('8348','2013-05-03','16:00:00',2.98),('8348','2013-05-03','16:05:00',2.96),('8348','2013-05-03','16:10:00',2.91),('8348','2013-05-03','16:15:00',2.81),('8348','2013-05-03','16:20:00',2.7),('8348','2013-05-03','16:25:00',2.67),('8348','2013-05-03','16:30:00',2.67),('8348','2013-05-03','16:35:00',2.6),('8348','2013-05-03','16:40:00',2.55),('8348','2013-05-03','16:45:00',2.49),('8348','2013-05-03','16:50:00',2.42),('8348','2013-05-03','16:55:00',2.34),('8348','2013-05-03','17:00:00',2.29),('8348','2013-05-03','17:05:00',2.22),('8348','2013-05-03','17:10:00',2.14),('8348','2013-05-03','17:15:00',2.07),('8348','2013-05-03','17:20:00',1.97),('8348','2013-05-03','17:25:00',1.87),('8348','2013-05-03','17:30:00',1.8),('8348','2013-05-03','17:35:00',1.72),('8348','2013-05-03','17:40:00',1.64),('8348','2013-05-03','17:45:00',1.55),('8348','2013-05-03','17:50:00',1.46),('8348','2013-05-03','17:55:00',1.4),('8348','2013-05-03','18:00:00',1.36),('8348','2013-05-03','18:05:00',1.31),('8348','2013-05-03','18:10:00',1.22),('8348','2013-05-03','18:15:00',1.15),('8348','2013-05-03','18:20:00',1.08),('8348','2013-05-03','18:25:00',1.01),('8348','2013-05-02','08:55:00',1.03),('8348','2013-05-02','09:00:00',1.52),('8348','2013-05-02','09:05:00',1.25),('8348','2013-05-02','09:25:00',1.55),('8348','2013-05-02','09:30:00',1.87),('8348','2013-05-02','09:35:00',1.75),('8348','2013-05-02','09:40:00',1.34),('8348','2013-05-02','09:45:00',2.24),('8348','2013-05-02','09:50:00',1.23),('8348','2013-05-02','10:05:00',1.31),('8348','2013-05-02','10:10:00',1.28),('8348','2013-05-02','10:15:00',1.3),('8348','2013-05-02','10:20:00',1.33),('8348','2013-05-02','10:25:00',1.54),('8348','2013-05-02','10:30:00',2.41),('8348','2013-05-02','10:35:00',2.29),('8348','2013-05-02','10:40:00',2.87),('8348','2013-05-02','10:45:00',2.84),('8348','2013-05-02','10:50:00',3.1),('8348','2013-05-02','10:55:00',3.32),('8348','2013-05-02','11:00:00',3.25),('8348','2013-05-02','11:05:00',3.02),('8348','2013-05-02','11:10:00',2.66),('8348','2013-05-02','11:15:00',2.51),('8348','2013-05-02','11:20:00',2.35),('8348','2013-05-02','11:25:00',3.24),('8348','2013-05-02','11:30:00',3.4),('8348','2013-05-02','11:35:00',3.28),('8348','2013-05-02','11:40:00',3.28),('8348','2013-05-02','11:45:00',3.29),('8348','2013-05-02','11:50:00',3.28),('8348','2013-05-02','11:55:00',3.29),('8348','2013-05-02','12:00:00',3.29),('8348','2013-05-02','12:05:00',3.29),('8348','2013-05-02','12:10:00',3.27),('8348','2013-05-02','12:15:00',3.33),('8348','2013-05-02','12:20:00',3.35),('8348','2013-05-02','12:25:00',3.38),('8348','2013-05-02','12:30:00',3.41),('8348','2013-05-02','12:35:00',3.48),('8348','2013-05-02','12:40:00',3.52),('8348','2013-05-02','12:45:00',3.54),('8348','2013-05-02','12:50:00',3.57),('8348','2013-05-02','12:55:00',3.6),('8348','2013-05-02','13:00:00',3.62),('8348','2013-05-02','13:05:00',3.66),('8348','2013-05-02','13:10:00',3.71),('8348','2013-05-02','13:15:00',3.75),('8348','2013-05-02','13:20:00',3.76),('8348','2013-05-02','13:25:00',3.77),('8348','2013-05-02','13:30:00',3.77),('8348','2013-05-02','13:35:00',3.76),('8348','2013-05-02','13:40:00',3.74),('8348','2013-05-02','13:45:00',3.7),('8348','2013-05-02','13:50:00',3.67),('8348','2013-05-02','13:55:00',3.67),('8348','2013-05-02','14:00:00',3.66),('8348','2013-05-02','14:05:00',3.61),('8348','2013-05-02','14:10:00',3.58),('8348','2013-05-02','14:15:00',3.57),('8348','2013-05-02','14:20:00',3.55),('8348','2013-05-02','14:25:00',3.53),('8348','2013-05-02','14:30:00',3.5),('8348','2013-05-02','14:35:00',3.47),('8348','2013-05-02','14:40:00',3.46),('8348','2013-05-02','14:45:00',3.46),('8348','2013-05-02','14:50:00',3.42),('8348','2013-05-02','14:55:00',3.38),('8348','2013-05-02','15:00:00',3.38),('8348','2013-05-02','15:05:00',3.35),('8348','2013-05-02','15:10:00',3.31),('8348','2013-05-02','15:15:00',3.25),('8348','2013-05-02','15:20:00',3.21),('8348','2013-05-02','15:25:00',3.17),('8348','2013-05-02','15:30:00',3.13),('8348','2013-05-02','15:35:00',3.13),('8348','2013-05-02','15:40:00',3.1),('8348','2013-05-02','15:45:00',3.06),('8348','2013-05-02','15:50:00',3.05),('8348','2013-05-02','15:55:00',3.01),('8348','2013-05-02','16:00:00',2.97),('8348','2013-05-02','16:05:00',2.93),('8348','2013-05-02','16:10:00',2.89),('8348','2013-05-02','16:15:00',2.84),('8348','2013-05-02','16:20:00',2.77),('8348','2013-05-02','16:25:00',2.73),('8348','2013-05-02','16:30:00',2.65),('8348','2013-05-02','16:35:00',2.59),('8348','2013-05-02','16:40:00',2.55),('8348','2013-05-02','16:45:00',2.48),('8348','2013-05-02','16:50:00',2.42),('8348','2013-05-02','16:55:00',2.36),('8348','2013-05-02','17:00:00',2.31),('8348','2013-05-02','17:05:00',2.25),('8348','2013-05-02','17:10:00',2.19),('8348','2013-05-02','17:15:00',2.13),('8348','2013-05-02','17:20:00',2.06),('8348','2013-05-02','17:25:00',2),('8348','2013-05-02','17:30:00',1.92),('8348','2013-05-02','17:35:00',1.84),('8348','2013-05-02','17:40:00',1.77),('8348','2013-05-02','17:45:00',1.7),('8348','2013-05-02','17:50:00',1.62),('8348','2013-05-02','17:55:00',1.54),('8348','2013-05-02','18:00:00',1.47),('8348','2013-05-02','18:05:00',1.4),('8348','2013-05-02','18:10:00',1.32),('8348','2013-05-02','18:15:00',1.24),('8348','2013-05-02','18:20:00',1.16),('8348','2013-05-02','18:25:00',1.08),('8348','2013-05-02','18:30:00',1.01),('8348','2014-03-30','07:05:00',1.05),('8348','2014-03-30','07:10:00',1.14),('8348','2014-03-30','07:15:00',1.27),('8348','2014-03-30','07:20:00',1.44),('8348','2014-03-30','07:25:00',1.59),('8348','2014-03-30','07:30:00',1.71),('8348','2014-03-30','07:35:00',1.79),('8348','2014-03-30','07:40:00',1.89),('8348','2014-03-30','07:45:00',1.92),('8348','2014-03-30','07:50:00',1.95),('8348','2014-03-30','07:55:00',2.05),('8348','2014-03-30','08:00:00',2.16),('8348','2014-03-30','08:05:00',2.13),('8348','2014-03-30','08:10:00',2.13),('8348','2014-03-30','08:15:00',2.12),('8348','2014-03-30','08:20:00',2.45),('8348','2014-03-30','08:25:00',2.67),('8348','2014-03-30','08:30:00',3.04),('8348','2014-03-30','08:35:00',3.24),('8348','2014-03-30','08:40:00',3.33),('8348','2014-03-30','08:45:00',3.51),('8348','2014-03-30','08:50:00',3.66),('8348','2014-03-30','08:55:00',3.66),('8348','2014-03-30','09:00:00',3.68),('8348','2014-03-30','09:05:00',4.13),('8348','2014-03-30','09:10:00',4.27),('8348','2014-03-30','09:15:00',4.33),('8348','2014-03-30','09:20:00',4.12),('8348','2014-03-30','09:25:00',4.54),('8348','2014-03-30','09:30:00',4.71),('8348','2014-03-30','09:35:00',4.84),('8348','2014-03-30','09:40:00',4.95),('8348','2014-03-30','09:45:00',4.98),('8348','2014-03-30','09:50:00',5.02),('8348','2014-03-30','09:55:00',5.06),('8348','2014-03-30','10:00:00',5.06),('8348','2014-03-30','10:05:00',5.13),('8348','2014-03-30','10:10:00',5.1),('8348','2014-03-30','10:15:00',4.97),('8348','2014-03-30','10:20:00',4.84),('8348','2014-03-30','10:25:00',5.06),('8348','2014-03-30','10:30:00',5.42),('8348','2014-03-30','10:35:00',5.6),('8348','2014-03-30','10:40:00',5.87),('8348','2014-03-30','10:45:00',6.01),('8348','2014-03-30','10:50:00',6.08),('8348','2014-03-30','10:55:00',6.29),('8348','2014-03-30','11:00:00',6.37),('8348','2014-03-30','11:05:00',6.62),('8348','2014-03-30','11:10:00',6.69),('8348','2014-03-30','11:15:00',6.9),('8348','2014-03-30','11:20:00',6.72),('8348','2014-03-30','11:25:00',6.72),('8348','2014-03-30','11:30:00',6.57),('8348','2014-03-30','11:35:00',6.28),('8348','2014-03-30','11:40:00',6.6),('8348','2014-03-30','11:45:00',6.51),('8348','2014-03-30','11:50:00',6.61),('8348','2014-03-30','11:55:00',6.7),('8348','2014-03-30','12:00:00',6.82),('8348','2014-03-30','12:05:00',6.99),('8348','2014-03-30','12:10:00',6.94),('8348','2014-03-30','12:15:00',6.84),('8348','2014-03-30','12:20:00',6.92),('8348','2014-03-30','12:25:00',6.96),('8348','2014-03-30','12:30:00',7.03),('8348','2014-03-30','12:35:00',6.99),('8348','2014-03-30','12:40:00',7.02),('8348','2014-03-30','12:45:00',7.17),('8348','2014-03-30','12:50:00',7.19),('8348','2014-03-30','12:55:00',7.02),('8348','2014-03-30','13:00:00',6.95),('8348','2014-03-30','13:05:00',7.01),('8348','2014-03-30','13:10:00',6.9),('8348','2014-03-30','13:15:00',6.7),('8348','2014-03-30','13:20:00',6.9),('8348','2014-03-30','13:25:00',7.08),('8348','2014-03-30','13:30:00',7.14),('8348','2014-03-30','13:35:00',6.48),('8348','2014-03-30','13:40:00',5.81),('8348','2014-03-30','13:45:00',5.76),('8348','2014-03-30','13:50:00',5.3),('8348','2014-03-30','13:55:00',3.67),('8348','2014-03-30','14:00:00',2.77),('8348','2014-03-30','14:05:00',3.27),('8348','2014-03-30','14:10:00',3.87),('8348','2014-03-30','14:15:00',3.33),('8348','2014-03-30','14:20:00',5.02),('8348','2014-03-30','14:25:00',5.51),('8348','2014-03-30','14:30:00',5.86),('8348','2014-03-30','14:35:00',5.89),('8348','2014-03-30','14:40:00',5.76),('8348','2014-03-30','14:45:00',5.91),('8348','2014-03-30','14:50:00',5.83),('8348','2014-03-30','14:55:00',5.57),('8348','2014-03-30','15:00:00',4.93),('8348','2014-03-30','15:05:00',4.56),('8348','2014-03-30','15:10:00',4.72),('8348','2014-03-30','15:15:00',4.75),('8348','2014-03-30','15:20:00',5.09),('8348','2014-03-30','15:25:00',5.21),('8348','2014-03-30','15:30:00',4.95),('8348','2014-03-30','15:35:00',5.12),('8348','2014-03-30','15:40:00',4.68),('8348','2014-03-30','15:45:00',4.45),('8348','2014-03-30','15:50:00',3.94),('8348','2014-03-30','15:55:00',3.58),('8348','2014-03-30','16:00:00',3.7),('8348','2014-03-30','16:05:00',4.07),('8348','2014-03-30','16:10:00',4.12),('8348','2014-03-30','16:15:00',4.06),('8348','2014-03-30','16:20:00',3.81),('8348','2014-03-30','16:25:00',3.43),('8348','2014-03-30','16:30:00',3.39),('8348','2014-03-30','16:35:00',3.28),('8348','2014-03-30','16:40:00',2.93),('8348','2014-03-30','16:45:00',2.93),('8348','2014-03-30','16:50:00',2.64),('8348','2014-03-30','16:55:00',2.04),('8348','2014-03-30','17:00:00',1.56),('8348','2014-03-30','17:05:00',1.67),('8348','2014-03-30','17:10:00',1.55),('8348','2014-03-30','17:15:00',1.57),('8348','2014-03-30','17:20:00',1.17),('8348','2013-05-01','08:20:00',1.07),('8348','2013-05-01','08:25:00',1.12),('8348','2013-05-01','08:30:00',1.19),('8348','2013-05-01','08:35:00',1.25),('8348','2013-05-01','08:40:00',1.33),('8348','2013-05-01','08:45:00',1.44),('8348','2013-05-01','08:50:00',1.53),('8348','2013-05-01','08:55:00',1.6),('8348','2013-05-01','09:00:00',1.68),('8348','2013-05-01','09:05:00',1.75),('8348','2013-05-01','09:10:00',1.81),('8348','2013-05-01','09:15:00',1.86),('8348','2013-05-01','09:20:00',1.9),('8348','2013-05-01','09:25:00',1.95),('8348','2013-05-01','09:30:00',1.98),('8348','2013-05-01','09:35:00',2.05),('8348','2013-05-01','09:40:00',2.11),('8348','2013-05-01','09:45:00',2.18),('8348','2013-05-01','09:50:00',2.23),('8348','2013-05-01','09:55:00',2.28),('8348','2013-05-01','10:00:00',2.32),('8348','2013-05-01','10:05:00',2.34),('8348','2013-05-01','10:10:00',2.43),('8348','2013-05-01','10:15:00',2.49),('8348','2013-05-01','10:20:00',2.54),('8348','2013-05-01','10:25:00',2.59),('8348','2013-05-01','10:30:00',2.65),('8348','2013-05-01','10:35:00',2.68),('8348','2013-05-01','10:40:00',2.85),('8348','2013-05-01','10:45:00',2.92),('8348','2013-05-01','10:50:00',2.96),('8348','2013-05-01','10:55:00',2.95),('8348','2013-05-01','11:00:00',3.01),('8348','2013-05-01','11:05:00',3.06),('8348','2013-05-01','11:10:00',3.09),('8348','2013-05-01','11:15:00',2.88),('8348','2013-05-01','11:20:00',2.95),('8348','2013-05-01','11:25:00',2.94),('8348','2013-05-01','11:30:00',2.86),('8348','2013-05-01','11:35:00',2.93),('8348','2013-05-01','11:40:00',2.3),('8348','2013-05-01','11:45:00',2.18),('8348','2013-05-01','11:50:00',2.79),('8348','2013-05-01','11:55:00',3.35),('8348','2013-05-01','12:00:00',3.32),('8348','2013-05-01','12:05:00',3.28),('8348','2013-05-01','12:10:00',3.29),('8348','2013-05-01','12:15:00',3.26),('8348','2013-05-01','12:20:00',3.28),('8348','2013-05-01','12:25:00',3.36),('8348','2013-05-01','12:30:00',3.39),('8348','2013-05-01','12:35:00',3.45),('8348','2013-05-01','12:40:00',3.58),('8348','2013-05-01','12:45:00',3.24),('8348','2013-05-01','12:50:00',2.49),('8348','2013-05-01','12:55:00',1.38),('8348','2013-05-01','13:00:00',1.38),('8348','2013-05-01','13:05:00',1.65),('8348','2013-05-01','13:10:00',1.94),('8348','2013-05-01','13:15:00',3.28),('8348','2013-05-01','13:20:00',4.15),('8348','2013-05-01','13:25:00',3.39),('8348','2013-05-01','13:30:00',2.77),('8348','2013-05-01','13:35:00',3.14),('8348','2013-05-01','13:40:00',3.82),('8348','2013-05-01','13:45:00',3.9),('8348','2013-05-01','13:50:00',3.69),('8348','2013-05-01','13:55:00',3.56),('8348','2013-05-01','14:00:00',3.47),('8348','2013-05-01','14:05:00',3.45),('8348','2013-05-01','14:10:00',3.48),('8348','2013-05-01','14:15:00',3.08),('8348','2013-05-01','14:20:00',3.66),('8348','2013-05-01','14:25:00',3.66),('8348','2013-05-01','14:30:00',3.69),('8348','2013-05-01','14:35:00',3.55),('8348','2013-05-01','14:40:00',3.21),('8348','2013-05-01','14:45:00',3.29),('8348','2013-05-01','14:50:00',2.96),('8348','2013-05-01','14:55:00',2.68),('8348','2013-05-01','15:00:00',2.75),('8348','2013-05-01','15:05:00',3.24),('8348','2013-05-01','15:10:00',3.27),('8348','2013-05-01','15:15:00',3.11),('8348','2013-05-01','15:20:00',3.02),('8348','2013-05-01','15:25:00',2.98),('8348','2013-05-01','15:30:00',2.5),('8348','2013-05-01','15:35:00',2.2),('8348','2013-05-01','15:40:00',2.2),('8348','2013-05-01','15:45:00',2.15),('8348','2013-05-01','15:50:00',1.63),('8348','2013-05-01','15:55:00',1.59),('8348','2013-05-01','16:00:00',1.9),('8348','2013-05-01','16:05:00',1.84),('8348','2013-05-01','16:10:00',1.67),('8348','2013-05-01','16:15:00',1.54),('8348','2013-05-01','16:20:00',1.37),('8348','2013-05-01','16:25:00',1.06),('8348','2013-05-01','16:35:00',1.02),('8348','2013-05-01','16:40:00',1.1),('8348','2013-05-01','16:45:00',1.03),('8348','2013-04-30','08:55:00',1.39),('8348','2013-04-30','09:00:00',1.48),('8348','2013-04-30','09:05:00',1.29),('8348','2013-04-30','09:10:00',1.77),('8348','2013-04-30','09:15:00',2.12),('8348','2013-04-30','09:20:00',2.17),('8348','2013-04-30','09:25:00',2.33),('8348','2013-04-30','09:30:00',2.26),('8348','2013-04-30','09:35:00',1.88),('8348','2013-04-30','09:40:00',1.33),('8348','2013-04-30','09:45:00',1.75),('8348','2013-04-30','09:50:00',2.16),('8348','2013-04-30','09:55:00',2.42),('8348','2013-04-30','10:00:00',2.76),('8348','2013-04-30','10:05:00',2.77),('8348','2013-04-30','10:10:00',2.24),('8348','2013-04-30','10:15:00',1.93),('8348','2013-04-30','10:20:00',1.82),('8348','2013-04-30','10:25:00',2.6),('8348','2013-04-30','10:30:00',1.92),('8348','2013-04-30','10:35:00',1.68),('8348','2013-04-30','10:40:00',1.52),('8348','2013-04-30','10:45:00',1.22),('8348','2013-04-30','10:50:00',1.31),('8348','2013-04-30','10:55:00',1.42),('8348','2013-04-30','11:00:00',1.47),('8348','2013-04-30','11:05:00',1.65),('8348','2013-04-30','11:10:00',1.67),('8348','2013-04-30','11:15:00',1.74),('8348','2013-04-30','11:20:00',2.02),('8348','2013-04-30','11:25:00',1.83),('8348','2013-04-30','11:30:00',1.83),('8348','2013-04-30','11:35:00',1.95),('8348','2013-04-30','11:40:00',1.83),('8348','2013-04-30','11:45:00',1.5),('8348','2013-04-30','11:50:00',1.51),('8348','2013-04-30','11:55:00',1.56),('8348','2013-04-30','12:00:00',1.59),('8348','2013-04-30','12:05:00',1.64),('8348','2013-04-30','12:10:00',1.58),('8348','2013-04-30','12:15:00',1.45),('8348','2013-04-30','12:20:00',1.33),('8348','2013-04-30','12:25:00',1.24),('8348','2013-04-30','12:30:00',1.26),('8348','2013-04-30','12:35:00',2.2),('8348','2013-04-30','12:40:00',3.8),('8348','2013-04-30','12:45:00',3.94),('8348','2013-04-30','12:50:00',3.75),('8348','2013-04-30','12:55:00',3.34),('8348','2013-04-30','13:00:00',3.59),('8348','2013-04-30','13:05:00',3.52),('8348','2013-04-30','13:10:00',3.53),('8348','2013-04-30','13:15:00',3.5),('8348','2013-04-30','13:20:00',3.47),('8348','2013-04-30','13:25:00',3.45),('8348','2013-04-30','13:30:00',3.47),('8348','2013-04-30','13:35:00',3.45),('8348','2013-04-30','13:40:00',3.43),('8348','2013-04-30','13:45:00',3.39),('8348','2013-04-30','13:50:00',3.36),('8348','2013-04-30','13:55:00',3.35),('8348','2013-04-30','14:00:00',3.32),('8348','2013-04-30','14:05:00',3.32),('8348','2013-04-30','14:10:00',3.3),('8348','2013-04-30','14:15:00',3.28),('8348','2013-04-30','14:20:00',3.25),('8348','2013-04-30','14:25:00',3.27),('8348','2013-04-30','14:30:00',3.25),('8348','2013-04-30','14:35:00',3.23),('8348','2013-04-30','14:40:00',3.21),('8348','2013-04-30','14:45:00',3.18),('8348','2013-04-30','14:50:00',3.14),('8348','2013-04-30','14:55:00',3.1),('8348','2013-04-30','15:00:00',3.07),('8348','2013-04-30','15:05:00',3.01),('8348','2013-04-30','15:10:00',2.97),('8348','2013-04-30','15:15:00',2.95),('8348','2013-04-30','15:20:00',2.94),('8348','2013-04-30','15:25:00',2.9),('8348','2013-04-30','15:30:00',2.92),('8348','2013-04-30','15:35:00',2.91),('8348','2013-04-30','15:40:00',2.87),('8348','2013-04-30','15:45:00',2.83),('8348','2013-04-30','15:50:00',2.78),('8348','2013-04-30','15:55:00',2.73),('8348','2013-04-30','16:00:00',2.69),('8348','2013-04-30','16:05:00',2.65),('8348','2013-04-30','16:10:00',2.59),('8348','2013-04-30','16:15:00',2.54),('8348','2013-04-30','16:20:00',2.49),('8348','2013-04-30','16:25:00',2.44),('8348','2013-04-30','16:30:00',2.39),('8348','2013-04-30','16:35:00',2.29),('8348','2013-04-30','16:40:00',1.91),('8348','2013-04-30','16:45:00',2.14),('8348','2013-04-30','16:50:00',1.72),('8348','2013-04-30','16:55:00',1.89),('8348','2013-04-30','17:00:00',1.96),('8348','2013-04-30','17:05:00',1.91),('8348','2013-04-30','17:10:00',1.66),('8348','2013-04-30','17:20:00',1.44),('8348','2013-04-30','17:25:00',1.62),('8348','2013-04-30','17:30:00',1.56),('8348','2013-04-30','17:35:00',1.52),('8348','2013-04-30','17:40:00',1.45),('8348','2013-04-30','17:45:00',1.38),('8348','2013-04-30','17:50:00',1.29),('8348','2013-04-30','17:55:00',1.21),('8348','2013-04-30','18:00:00',1.15),('8348','2013-04-30','18:05:00',1.07),('8348','2013-04-30','18:10:00',1.01),('8348','2013-04-29','08:05:00',1.01),('8348','2013-04-29','08:15:00',1.01),('8348','2013-04-29','08:20:00',1.1),('8348','2013-04-29','08:25:00',1.24),('8348','2013-04-29','08:30:00',1.4),('8348','2013-04-29','08:35:00',1.54),('8348','2013-04-29','08:40:00',1.59),('8348','2013-04-29','08:45:00',1.59),('8348','2013-04-29','08:50:00',1.71),('8348','2013-04-29','08:55:00',1.69),('8348','2013-04-29','09:00:00',1.38),('8348','2013-04-29','09:05:00',1.83),('8348','2013-04-29','09:10:00',2.02),('8348','2013-04-29','09:15:00',2.12),('8348','2013-04-29','09:20:00',2.01),('8348','2013-04-29','09:25:00',1.96),('8348','2013-04-29','09:30:00',1.98),('8348','2013-04-29','09:35:00',2.11),('8348','2013-04-29','09:40:00',2.13),('8348','2013-04-29','09:45:00',2.19),('8348','2013-04-29','09:50:00',2.34),('8348','2013-04-29','09:55:00',2.2),('8348','2013-04-29','10:00:00',2.29),('8348','2013-04-29','10:05:00',2.32),('8348','2013-04-29','10:10:00',2.28),('8348','2013-04-29','10:15:00',1.86),('8348','2013-04-29','10:20:00',1.93),('8348','2013-04-29','10:25:00',2.29),('8348','2013-04-29','10:30:00',2.41),('8348','2013-04-29','10:35:00',2.72),('8348','2013-04-29','10:40:00',2.73),('8348','2013-04-29','10:45:00',2.78),('8348','2013-04-29','10:50:00',2.69),('8348','2013-04-29','10:55:00',2.51),('8348','2013-04-29','11:00:00',2.84),('8348','2013-04-29','11:05:00',2.67),('8348','2013-04-29','11:10:00',2.61),('8348','2013-04-29','11:15:00',2.48),('8348','2013-04-29','11:20:00',2.94),('8348','2013-04-29','11:25:00',3),('8348','2013-04-29','11:30:00',3.13),('8348','2013-04-29','11:35:00',2.96),('8348','2013-04-29','11:40:00',3.07),('8348','2013-04-29','11:45:00',2.89),('8348','2013-04-29','11:50:00',3.29),('8348','2013-04-29','11:55:00',3.23),('8348','2013-04-29','12:00:00',3.32),('8348','2013-04-29','12:05:00',3.29),('8348','2013-04-29','12:10:00',3.21),('8348','2013-04-29','12:15:00',3.28),('8348','2013-04-29','12:20:00',3.29),('8348','2013-04-29','12:25:00',3.2),('8348','2013-04-29','12:30:00',3.3),('8348','2013-04-29','12:35:00',3.37),('8348','2013-04-29','12:40:00',3.43),('8348','2013-04-29','12:45:00',3.45),('8348','2013-04-29','12:50:00',3.41),('8348','2013-04-29','12:55:00',3.39),('8348','2013-04-29','13:00:00',3.49),('8348','2013-04-29','13:05:00',3.42),('8348','2013-04-29','13:10:00',3.35),('8348','2013-04-29','13:15:00',3),('8348','2013-04-29','13:20:00',3.42),('8348','2013-04-29','13:25:00',3.6),('8348','2013-04-29','13:30:00',3.51),('8348','2013-04-29','13:35:00',3.37),('8348','2013-04-29','13:40:00',3.5),('8348','2013-04-29','13:45:00',3.43),('8348','2013-04-29','13:50:00',3.29),('8348','2013-04-29','13:55:00',3.74),('8348','2013-04-29','14:00:00',3.45),('8348','2013-04-29','14:05:00',3.35),('8348','2013-04-29','14:10:00',3.47),('8348','2013-04-29','14:15:00',3.56),('8348','2013-04-29','14:20:00',3.59),('8348','2013-04-29','14:25:00',3.43),('8348','2013-04-29','14:30:00',3.28),('8348','2013-04-29','14:35:00',3.25),('8348','2013-04-29','14:40:00',3.07),('8348','2013-04-29','14:45:00',3.28),('8348','2013-04-29','14:50:00',3.27),('8348','2013-04-29','14:55:00',3.28),('8348','2013-04-29','15:00:00',3.19),('8348','2013-04-29','15:05:00',3.29),('8348','2013-04-29','15:10:00',2.92),('8348','2013-04-29','15:15:00',2.94),('8348','2013-04-29','15:20:00',3.11),('8348','2013-04-29','15:25:00',3.24),('8348','2013-04-29','15:30:00',3.15),('8348','2013-04-29','15:35:00',2.78),('8348','2013-04-29','15:40:00',2.55),('8348','2013-04-29','15:45:00',2.49),('8348','2013-04-29','15:50:00',2.57),('8348','2013-04-29','15:55:00',2.71),('8348','2013-04-29','16:00:00',2.66),('8348','2013-04-29','16:05:00',2.86),('8348','2013-04-29','16:10:00',2.74),('8348','2013-04-29','16:15:00',3.18),('8348','2013-04-29','16:20:00',3.02),('8348','2013-04-29','16:25:00',2.36),('8348','2013-04-29','16:30:00',2.46),('8348','2013-04-29','16:35:00',2.47),('8348','2013-04-29','16:40:00',2.64),('8348','2013-04-29','16:45:00',2.66),('8348','2013-04-29','16:50:00',2.69),('8348','2013-04-29','16:55:00',2.8),('8348','2013-04-29','17:00:00',2.59),('8348','2013-04-29','17:05:00',2.24),('8348','2013-04-29','17:10:00',2.32),('8348','2013-04-29','17:15:00',1.99),('8348','2013-04-29','17:20:00',1.61),('8348','2013-04-29','17:25:00',1.59),('8348','2013-04-29','17:30:00',1.51),('8348','2013-04-29','17:35:00',1.42),('8348','2013-04-29','17:40:00',1.2),('8348','2013-04-29','17:45:00',1.08),('8348','2013-04-29','17:50:00',1.37),('8348','2013-04-29','17:55:00',1.58),('8348','2013-04-29','18:00:00',1.55),('8348','2013-04-29','18:05:00',1.74),('8348','2013-04-29','18:10:00',1.58),('8348','2013-04-29','18:15:00',1.51),('8348','2013-04-29','18:20:00',1.28),('8348','2013-04-29','18:25:00',1.28),('8348','2013-04-29','18:30:00',1.18),('8348','2013-04-28','08:15:00',1.04),('8348','2013-04-28','08:20:00',1.13),('8348','2013-04-28','08:25:00',1.2),('8348','2013-04-28','08:30:00',1.26),('8348','2013-04-28','08:35:00',1.37),('8348','2013-04-28','08:40:00',1.42),('8348','2013-04-28','08:45:00',1.51),('8348','2013-04-28','08:50:00',1.62),('8348','2013-04-28','08:55:00',1.69),('8348','2013-04-28','09:00:00',1.76),('8348','2013-04-28','09:05:00',1.83),('8348','2013-04-28','09:10:00',1.9),('8348','2013-04-28','09:15:00',1.98),('8348','2013-04-28','09:20:00',2.04),('8348','2013-04-28','09:25:00',2.11),('8348','2013-04-28','09:30:00',2.17),('8348','2013-04-28','09:35:00',2.22),('8348','2013-04-28','09:40:00',2.29),('8348','2013-04-28','09:45:00',2.36),('8348','2013-04-28','09:50:00',2.42),('8348','2013-04-28','09:55:00',2.48),('8348','2013-04-28','10:00:00',2.52),('8348','2013-04-28','10:05:00',2.56),('8348','2013-04-28','10:10:00',2.63),('8348','2013-04-28','10:15:00',2.63),('8348','2013-04-28','10:20:00',2.71),('8348','2013-04-28','10:25:00',2.81),('8348','2013-04-28','10:30:00',2.76),('8348','2013-04-28','10:35:00',2.86),('8348','2013-04-28','10:40:00',2.66),('8348','2013-04-28','10:45:00',2.99),('8348','2013-04-28','10:50:00',3.01),('8348','2013-04-28','10:55:00',3.03),('8348','2013-04-28','11:00:00',3.06),('8348','2013-04-28','11:05:00',3.09),('8348','2013-04-28','11:10:00',3.13),('8348','2013-04-28','11:15:00',3.21),('8348','2013-04-28','11:20:00',3.22),('8348','2013-04-28','11:25:00',3.28),('8348','2013-04-28','11:30:00',3.28),('8348','2013-04-28','11:35:00',3.21),('8348','2013-04-28','11:40:00',3.25),('8348','2013-04-28','11:45:00',3.19),('8348','2013-04-28','11:50:00',3.18),('8348','2013-04-28','11:55:00',3.34),('8348','2013-04-28','12:00:00',2.95),('8348','2013-04-28','12:05:00',2.9),('8348','2013-04-28','12:10:00',3.19),('8348','2013-04-28','12:15:00',3.32),('8348','2013-04-28','12:20:00',3.29),('8348','2013-04-28','12:25:00',3),('8348','2013-04-28','12:30:00',2.86),('8348','2013-04-28','12:35:00',2.7),('8348','2013-04-28','12:40:00',2.68),('8348','2013-04-28','12:45:00',3.58),('8348','2013-04-28','12:50:00',3.5),('8348','2013-04-28','12:55:00',3.3),('8348','2013-04-28','13:00:00',3.37),('8348','2013-04-28','13:05:00',3.6),('8348','2013-04-28','13:10:00',3.55),('8348','2013-04-28','13:15:00',3.29),('8348','2013-04-28','13:20:00',3.39),('8348','2013-04-28','13:25:00',3.31),('8348','2013-04-28','13:30:00',3.56),('8348','2013-04-28','13:35:00',3.57),('8348','2013-04-28','13:40:00',3.7),('8348','2013-04-28','13:45:00',2.6),('8348','2013-04-28','13:50:00',1.55),('8348','2013-04-28','13:55:00',1.62),('8348','2013-04-28','14:00:00',2.77),('8348','2013-04-28','14:05:00',3.69),('8348','2013-04-28','14:10:00',3.52),('8348','2013-04-28','14:15:00',3.57),('8348','2013-04-28','14:20:00',3.05),('8348','2013-04-28','14:25:00',3.52),('8348','2013-04-28','14:30:00',3.44),('8348','2013-04-28','14:35:00',3.42),('8348','2013-04-28','14:40:00',3.39),('8348','2013-04-28','14:45:00',3.37),('8348','2013-04-28','14:50:00',3.33),('8348','2013-04-28','14:55:00',3.32),('8348','2013-04-28','15:00:00',3.28),('8348','2013-04-28','15:05:00',3.26),('8348','2013-04-28','15:10:00',3.26),('8348','2013-04-28','15:15:00',3.22),('8348','2013-04-28','15:20:00',3.19),('8348','2013-04-28','15:25:00',3.14),('8348','2013-04-28','15:30:00',3.11),('8348','2013-04-28','15:35:00',3.07),('8348','2013-04-28','15:40:00',3.03),('8348','2013-04-28','15:45:00',3),('8348','2013-04-28','15:50:00',2.96),('8348','2013-04-28','15:55:00',2.93),('8348','2013-04-28','16:00:00',2.88),('8348','2013-04-28','16:05:00',2.84),('8348','2013-04-28','16:10:00',2.81),('8348','2013-04-28','16:15:00',2.75),('8348','2013-04-28','16:20:00',2.69),('8348','2013-04-28','16:25:00',2.63),('8348','2013-04-28','16:30:00',2.59),('8348','2013-04-28','16:35:00',2.54),('8348','2013-04-28','16:40:00',2.48),('8348','2013-04-28','16:45:00',2.42),('8348','2013-04-28','16:50:00',2.38),('8348','2013-04-28','16:55:00',2.31),('8348','2013-04-28','17:00:00',2.25),('8348','2013-04-28','17:05:00',2.1),('8348','2013-04-28','17:10:00',2.01),('8348','2013-04-28','17:15:00',2.08),('8348','2013-04-28','17:20:00',1.99),('8348','2013-04-28','17:25:00',1.95),('8348','2013-04-28','17:30:00',1.67),('8348','2013-04-28','17:35:00',1.67),('8348','2013-04-28','17:40:00',1.57),('8348','2013-04-28','17:45:00',1.62),('8348','2013-04-28','17:50:00',1.54),('8348','2013-04-28','17:55:00',1.35),('8348','2013-04-28','18:00:00',1.34),('8348','2013-04-28','18:05:00',1.28),('8348','2013-04-28','18:20:00',1.11),('8348','2013-04-28','18:25:00',1.05),('8348','2013-04-27','12:55:00',1.22),('8348','2013-04-27','13:00:00',1.35),('8348','2013-04-27','13:05:00',1.03),('8348','2013-04-27','13:10:00',1.11),('8348','2013-04-27','13:15:00',1.4),('8348','2013-04-27','13:20:00',1.48),('8348','2013-04-27','13:25:00',1.09),('8348','2013-04-27','13:30:00',1.11),('8348','2013-04-27','13:35:00',1.37),('8348','2013-04-27','13:40:00',1.57),('8348','2013-04-27','13:45:00',1.05),('8348','2013-04-27','13:50:00',1.01),('8348','2013-04-27','14:25:00',1.09),('8348','2013-04-27','14:30:00',1.97),('8348','2013-04-27','14:35:00',1.9),('8348','2013-04-27','14:40:00',1.2),('8348','2013-04-27','14:45:00',1.11),('8348','2013-04-27','15:05:00',1.35),('8348','2013-04-27','15:10:00',1.15),('8348','2013-04-27','16:45:00',1.15),('8348','2013-04-27','16:50:00',2),('8348','2013-04-27','16:55:00',1.8),('8348','2013-04-27','17:00:00',2.32),('8348','2013-04-27','17:05:00',1.67),('8348','2013-04-27','17:40:00',1.02),('8348','2013-04-26','08:20:00',1.04),('8348','2013-04-26','08:25:00',1.1),('8348','2013-04-26','08:30:00',1.16),('8348','2013-04-26','08:35:00',1.25),('8348','2013-04-26','08:40:00',1.28),('8348','2013-04-26','08:45:00',1.37),('8348','2013-04-26','08:50:00',1.28),('8348','2013-04-26','08:55:00',1.18),('8348','2013-04-26','09:00:00',1.01),('8348','2013-04-26','09:05:00',1.46),('8348','2013-04-26','09:10:00',1.62),('8348','2013-04-26','09:15:00',1.03),('8348','2013-04-26','09:20:00',1.01),('8348','2013-04-26','09:25:00',1.24),('8348','2013-04-26','09:30:00',1.79),('8348','2013-04-26','09:35:00',1.54),('8348','2013-04-26','09:40:00',1.58),('8348','2013-04-26','09:45:00',2.18),('8348','2013-04-26','09:50:00',1.98),('8348','2013-04-26','09:55:00',1.49),('8348','2013-04-26','10:00:00',1.89),('8348','2013-04-26','10:05:00',2.31),('8348','2013-04-26','10:10:00',2.41),('8348','2013-04-26','10:15:00',2.65),('8348','2013-04-26','10:20:00',2.62),('8348','2013-04-26','10:25:00',2.45),('8348','2013-04-26','10:30:00',2.72),('8348','2013-04-26','10:35:00',2.87),('8348','2013-04-26','10:40:00',2.83),('8348','2013-04-26','10:45:00',2.74),('8348','2013-04-26','10:50:00',2.17),('8348','2013-04-26','10:55:00',1.58),('8348','2013-04-26','11:00:00',2.78),('8348','2013-04-26','11:05:00',2.83),('8348','2013-04-26','11:10:00',2.69),('8348','2013-04-26','11:15:00',2.83),('8348','2013-04-26','11:20:00',2.08),('8348','2013-04-26','11:25:00',2.49),('8348','2013-04-26','11:30:00',2.66),('8348','2013-04-26','11:35:00',2.96),('8348','2013-04-26','11:40:00',2.8),('8348','2013-04-26','11:45:00',2.58),('8348','2013-04-26','11:50:00',2.36),('8348','2013-04-26','11:55:00',2.2),('8348','2013-04-26','12:00:00',2.51),('8348','2013-04-26','12:05:00',2.44),('8348','2013-04-26','12:10:00',2.11),('8348','2013-04-26','12:15:00',2.39),('8348','2013-04-26','12:20:00',2.38),('8348','2013-04-26','12:25:00',1.67),('8348','2013-04-26','12:30:00',1.61),('8348','2013-04-26','12:35:00',2.07),('8348','2013-04-26','12:40:00',2.89),('8348','2013-04-26','12:45:00',2.96),('8348','2013-04-26','12:50:00',1.96),('8348','2013-04-26','12:55:00',1.8),('8348','2013-04-26','13:00:00',1.26),('8348','2013-04-26','13:05:00',1.2),('8348','2013-04-26','13:10:00',1.46),('8348','2013-04-26','13:15:00',2.29),('8348','2013-04-26','13:20:00',1.63),('8348','2013-04-26','13:25:00',1.9),('8348','2013-04-26','13:30:00',2.62),('8348','2013-04-26','13:35:00',2.16),('8348','2013-04-26','13:40:00',2.43),('8348','2013-04-26','13:45:00',1.96),('8348','2013-04-26','13:50:00',3.17),('8348','2013-04-26','13:55:00',2.32),('8348','2013-04-26','14:00:00',2.67),('8348','2013-04-26','14:05:00',3.51),('8348','2013-04-26','14:10:00',2.83),('8348','2013-04-26','14:15:00',2.91),('8348','2013-04-26','14:20:00',3.2),('8348','2013-04-26','14:25:00',3.62),('8348','2013-04-26','14:30:00',3.53),('8348','2013-04-26','14:35:00',2.48),('8348','2013-04-26','14:40:00',1.64),('8348','2013-04-26','14:45:00',1.41),('8348','2013-04-26','14:50:00',3.46),('8348','2013-04-26','14:55:00',3.7),('8348','2013-04-26','15:00:00',3.46),('8348','2013-04-26','15:05:00',2.4),('8348','2013-04-26','15:10:00',1.35),('8348','2013-04-26','15:15:00',2.01),('8348','2013-04-26','15:20:00',1.36),('8348','2013-04-26','15:25:00',1.44),('8348','2013-04-26','15:30:00',1.96),('8348','2013-04-26','15:35:00',1.74),('8348','2013-04-26','15:40:00',1.77),('8348','2013-04-26','15:45:00',2.22),('8348','2013-04-26','15:50:00',1.67),('8348','2013-04-26','15:55:00',1),('8348','2013-04-25','08:15:00',1.1),('8348','2013-04-25','08:45:00',1.15),('8348','2013-04-25','08:50:00',1.68),('8348','2013-04-25','08:55:00',1.93),('8348','2013-04-25','09:00:00',1.59),('8348','2013-04-25','09:05:00',1.19),('8348','2013-04-25','09:10:00',1.13),('8348','2013-04-25','09:15:00',1.05),('8348','2013-04-25','09:20:00',1.12),('8348','2013-04-25','09:25:00',1.25),('8348','2013-04-25','09:30:00',1.18),('8348','2013-04-25','09:35:00',1.34),('8348','2013-04-25','09:40:00',1.85),('8348','2013-04-25','09:45:00',2.23),('8348','2013-04-25','09:50:00',2.5),('8348','2013-04-25','09:55:00',2.54),('8348','2013-04-25','10:00:00',2.54),('8348','2013-04-25','10:05:00',2.37),('8348','2013-04-25','10:10:00',2.18),('8348','2013-04-25','10:15:00',2.36),('8348','2013-04-25','10:20:00',2.66),('8348','2013-04-25','10:25:00',2.76),('8348','2013-04-25','10:30:00',2.85),('8348','2013-04-25','10:35:00',2.88),('8348','2013-04-25','10:40:00',2.89),('8348','2013-04-25','10:45:00',2.79),('8348','2013-04-25','10:50:00',3),('8348','2013-04-25','10:55:00',3),('8348','2013-04-25','11:00:00',3.1),('8348','2013-04-25','11:05:00',3.14),('8348','2013-04-25','11:10:00',3.16),('8348','2013-04-25','11:15:00',3.18),('8348','2013-04-25','11:20:00',3.22),('8348','2013-04-25','11:25:00',3.25),('8348','2013-04-25','11:30:00',3.27),('8348','2013-04-25','11:35:00',3.32),('8348','2013-04-25','11:40:00',3.35),('8348','2013-04-25','11:45:00',3.4),('8348','2013-04-25','11:50:00',3.44),('8348','2013-04-25','11:55:00',3.41),('8348','2013-04-25','12:00:00',3.35),('8348','2013-04-25','12:05:00',3.36),('8348','2013-04-25','12:10:00',3.43),('8348','2013-04-25','12:15:00',3.46),('8348','2013-04-25','12:20:00',3.48),('8348','2013-04-25','12:25:00',3.47),('8348','2013-04-25','12:30:00',3.48),('8348','2013-04-25','12:35:00',3.49),('8348','2013-04-25','12:40:00',3.49),('8348','2013-04-25','12:45:00',3.5),('8348','2013-04-25','12:50:00',3.49),('8348','2013-04-25','12:55:00',3.53),('8348','2013-04-25','13:00:00',3.56),('8348','2013-04-25','13:05:00',3.64),('8348','2013-04-25','13:10:00',3.28),('8348','2013-04-25','13:15:00',3.52),('8348','2013-04-25','13:20:00',3.45),('8348','2013-04-25','13:25:00',3.33),('8348','2013-04-25','13:30:00',2.51),('8348','2013-04-25','13:35:00',2.35),('8348','2013-04-25','13:40:00',2.1),('8348','2013-04-25','13:45:00',1.97),('8348','2013-04-25','13:50:00',1.86),('8348','2013-04-25','13:55:00',1.98),('8348','2013-04-25','14:00:00',2.05),('8348','2013-04-25','14:05:00',1.93),('8348','2013-04-25','14:10:00',2.08),('8348','2013-04-25','14:15:00',2.26),('8348','2013-04-25','14:20:00',2.32),('8348','2013-04-25','14:25:00',2.41),('8348','2013-04-25','14:30:00',2.83),('8348','2013-04-25','14:35:00',3.25),('8348','2013-04-25','14:40:00',3.03),('8348','2013-04-25','14:45:00',3.08),('8348','2013-04-25','14:50:00',2.84),('8348','2013-04-25','14:55:00',2.97),('8348','2013-04-25','15:00:00',2.83),('8348','2013-04-25','15:05:00',2.6),('8348','2013-04-25','15:10:00',2.56),('8348','2013-04-25','15:15:00',2.93),('8348','2013-04-25','15:20:00',3.13),('8348','2013-04-25','15:25:00',3.16),('8348','2013-04-25','15:30:00',3.09),('8348','2013-04-25','15:35:00',2.95),('8348','2013-04-25','15:40:00',2.73),('8348','2013-04-25','15:45:00',2.65),('8348','2013-04-25','15:50:00',2.51),('8348','2013-04-25','15:55:00',2.42),('8348','2013-04-25','16:00:00',2.45),('8348','2013-04-25','16:05:00',2.11),('8348','2013-04-25','16:10:00',2.09),('8348','2013-04-25','16:15:00',2.06),('8348','2013-04-25','16:20:00',2.19),('8348','2013-04-25','16:25:00',1.95),('8348','2013-04-25','16:30:00',1.85),('8348','2013-04-25','16:35:00',2.3),('8348','2013-04-25','16:40:00',1.95),('8348','2013-04-25','16:45:00',2.08),('8348','2013-04-25','16:50:00',1.75),('8348','2013-04-25','16:55:00',1.77),('8348','2013-04-25','17:00:00',1.76),('8348','2013-04-25','17:05:00',2.06),('8348','2013-04-25','17:10:00',2.22),('8348','2013-04-25','17:15:00',2.07),('8348','2013-04-25','17:20:00',2.07),('8348','2013-04-25','17:25:00',1.72),('8348','2013-04-25','17:30:00',1.44),('8348','2013-04-25','17:35:00',1.33),('8348','2013-04-25','17:40:00',1.37),('8348','2013-04-25','17:45:00',1.18),('8348','2013-04-24','08:15:00',1.04),('8348','2013-04-24','08:20:00',1.09),('8348','2013-04-24','08:25:00',1.18),('8348','2013-04-24','08:30:00',1.2),('8348','2013-04-24','08:35:00',1.18),('8348','2013-04-24','08:40:00',1.22),('8348','2013-04-24','08:45:00',1.32),('8348','2013-04-24','08:50:00',1.38),('8348','2013-04-24','08:55:00',1.52),('8348','2013-04-24','09:00:00',1.69),('8348','2013-04-24','09:05:00',1.88),('8348','2013-04-24','09:10:00',2.01),('8348','2013-04-24','09:15:00',1.81),('8348','2013-04-24','09:20:00',1.61),('8348','2013-04-24','09:25:00',1.96),('8348','2013-04-24','09:30:00',2.18),('8348','2013-04-24','09:35:00',2.4),('8348','2013-04-24','09:40:00',2.26),('8348','2013-04-24','09:45:00',2.2),('8348','2013-04-24','09:50:00',2.34),('8348','2013-04-24','09:55:00',2.65),('8348','2013-04-24','10:00:00',2.67),('8348','2013-04-24','10:05:00',2.73),('8348','2013-04-24','10:10:00',2.77),('8348','2013-04-24','10:15:00',2.75),('8348','2013-04-24','10:20:00',2.74),('8348','2013-04-24','10:25:00',2.72),('8348','2013-04-24','10:30:00',2.69),('8348','2013-04-24','10:35:00',2.67),('8348','2013-04-24','10:40:00',2.98),('8348','2013-04-24','10:45:00',3.05),('8348','2013-04-24','10:50:00',3.09),('8348','2013-04-24','10:55:00',3.16),('8348','2013-04-24','11:00:00',3.19),('8348','2013-04-24','11:05:00',3.13),('8348','2013-04-24','11:10:00',3.36),('8348','2013-04-24','11:15:00',3.43),('8348','2013-04-24','11:20:00',3.51),('8348','2013-04-24','11:25:00',3.59),('8348','2013-04-24','11:30:00',3.35),('8348','2013-04-24','11:35:00',2.96),('8348','2013-04-24','11:40:00',2.4),('8348','2013-04-24','11:45:00',2.32),('8348','2013-04-24','11:50:00',1.77),('8348','2013-04-24','11:55:00',2.39),('8348','2013-04-24','12:00:00',2.98),('8348','2013-04-24','12:05:00',2.14),('8348','2013-04-24','12:10:00',2.56),('8348','2013-04-24','12:15:00',3.36),('8348','2013-04-24','12:20:00',4),('8348','2013-04-24','12:25:00',3.37),('8348','2013-04-24','12:30:00',3.37),('8348','2013-04-24','12:35:00',3.45),('8348','2013-04-24','12:40:00',3.21),('8348','2013-04-24','12:45:00',3.45),('8348','2013-04-24','12:50:00',3.65),('8348','2013-04-24','12:55:00',3.51),('8348','2013-04-24','13:00:00',3.37),('8348','2013-04-24','13:05:00',3.06),('8348','2013-04-24','13:10:00',3.92),('8348','2013-04-24','13:15:00',3.48),('8348','2013-04-24','13:20:00',3.41),('8348','2013-04-24','13:25:00',3.49),('8348','2013-04-24','13:30:00',3.22),('8348','2013-04-24','13:35:00',3.3),('8348','2013-04-24','13:40:00',3.93),('8348','2013-04-24','13:45:00',3.15),('8348','2013-04-24','13:50:00',2.47),('8348','2013-04-24','13:55:00',3.66),('8348','2013-04-24','14:00:00',3.52),('8348','2013-04-24','14:05:00',2.59),('8348','2013-04-24','14:10:00',2.62),('8348','2013-04-24','14:15:00',3.69),('8348','2013-04-24','14:20:00',3.33),('8348','2013-04-24','14:25:00',3.42),('8348','2013-04-24','14:30:00',3.23),('8348','2013-04-24','14:35:00',2.9),('8348','2013-04-24','14:40:00',2.72),('8348','2013-04-24','14:45:00',2.67),('8348','2013-04-24','14:50:00',2.35),('8348','2013-04-24','14:55:00',2.11),('8348','2013-04-24','15:00:00',2.35),('8348','2013-04-24','15:05:00',2.17),('8348','2013-04-24','15:10:00',2.02),('8348','2013-04-24','15:15:00',2.14),('8348','2013-04-24','15:20:00',2.28),('8348','2013-04-24','15:25:00',1.87),('8348','2013-04-24','15:30:00',1.64),('8348','2013-04-24','15:35:00',1.58),('8348','2013-04-24','15:40:00',1.57),('8348','2013-04-24','15:45:00',1.57),('8348','2013-04-24','15:50:00',1.61),('8348','2013-04-24','15:55:00',2.02),('8348','2013-04-24','16:00:00',2.47),('8348','2013-04-24','16:05:00',2.6),('8348','2013-04-24','16:10:00',2.56),('8348','2013-04-24','16:15:00',2.51),('8348','2013-04-24','16:20:00',3.29),('8348','2013-04-24','16:25:00',2.38),('8348','2013-04-24','16:30:00',2.01),('8348','2013-04-24','16:35:00',1.77),('8348','2013-04-24','16:40:00',2.44),('8348','2013-04-24','16:45:00',2.46),('8348','2013-04-24','16:50:00',2.25),('8348','2013-04-24','16:55:00',2.69),('8348','2013-04-24','17:00:00',2.67),('8348','2013-04-24','17:05:00',2.52),('8348','2013-04-24','17:10:00',2.44),('8348','2013-04-24','17:15:00',1.74),('8348','2013-04-24','17:20:00',1.75),('8348','2013-04-24','17:25:00',1.59),('8348','2013-04-24','17:50:00',1.13),('8348','2013-04-24','17:55:00',1.49),('8348','2013-04-24','18:00:00',1.13),('8348','2013-04-24','18:05:00',1.25),('8348','2013-04-23','08:15:00',1.04),('8348','2013-04-23','08:20:00',1.11),('8348','2013-04-23','08:25:00',1.19),('8348','2013-04-23','08:30:00',1.26),('8348','2013-04-23','08:35:00',1.33),('8348','2013-04-23','08:40:00',1.44),('8348','2013-04-23','08:45:00',1.53),('8348','2013-04-23','08:50:00',1.62),('8348','2013-04-23','08:55:00',1.73),('8348','2013-04-23','09:00:00',1.82),('8348','2013-04-23','09:05:00',1.89),('8348','2013-04-23','09:10:00',1.96),('8348','2013-04-23','09:15:00',2.05),('8348','2013-04-23','09:20:00',2.12),('8348','2013-04-23','09:25:00',2.2),('8348','2013-04-23','09:30:00',2.25),('8348','2013-04-23','09:35:00',2.32),('8348','2013-04-23','09:40:00',2.15),('8348','2013-04-23','09:45:00',2.16),('8348','2013-04-23','09:50:00',2.56),('8348','2013-04-23','09:55:00',2.63),('8348','2013-04-23','10:00:00',2.65),('8348','2013-04-23','10:05:00',2.69),('8348','2013-04-23','10:10:00',2.73),('8348','2013-04-23','10:15:00',2.78),('8348','2013-04-23','10:20:00',2.82),('8348','2013-04-23','10:25:00',2.89),('8348','2013-04-23','10:30:00',2.94),('8348','2013-04-23','10:35:00',2.98),('8348','2013-04-23','10:40:00',3.04),('8348','2013-04-23','10:45:00',3.01),('8348','2013-04-23','10:50:00',3.1),('8348','2013-04-23','10:55:00',3.15),('8348','2013-04-23','11:00:00',3.18),('8348','2013-04-23','11:05:00',3.2),('8348','2013-04-23','11:10:00',3.23),('8348','2013-04-23','11:15:00',3.27),('8348','2013-04-23','11:20:00',3.31),('8348','2013-04-23','11:25:00',3.36),('8348','2013-04-23','11:30:00',3.39),('8348','2013-04-23','11:35:00',3.42),('8348','2013-04-23','11:40:00',3.44),('8348','2013-04-23','11:45:00',3.46),('8348','2013-04-23','11:50:00',3.48),('8348','2013-04-23','11:55:00',3.48),('8348','2013-04-23','12:00:00',3.49),('8348','2013-04-23','12:05:00',3.49),('8348','2013-04-23','12:10:00',3.51),('8348','2013-04-23','12:15:00',3.5),('8348','2013-04-23','12:20:00',3.51),('8348','2013-04-23','12:25:00',3.58),('8348','2013-04-23','12:30:00',3.17),('8348','2013-04-23','12:35:00',3.8),('8348','2013-04-23','12:40:00',4.13),('8348','2013-04-23','12:45:00',3.86),('8348','2013-04-23','12:50:00',1.66),('8348','2013-04-23','12:55:00',4.24),('8348','2013-04-23','13:00:00',4.2),('8348','2013-04-23','13:05:00',3.59),('8348','2013-04-23','13:10:00',1.23),('8348','2013-04-23','13:15:00',2.17),('8348','2013-04-23','13:20:00',4.05),('8348','2013-04-23','13:25:00',3.91),('8348','2013-04-23','13:30:00',3.84),('8348','2013-04-23','13:35:00',3.96),('8348','2013-04-23','13:40:00',4),('8348','2013-04-23','13:45:00',2.85),('8348','2013-04-23','13:50:00',3.51),('8348','2013-04-23','13:55:00',3.94),('8348','2013-04-23','14:00:00',2.54),('8348','2013-04-23','14:05:00',4.09),('8348','2013-04-23','14:10:00',3.5),('8348','2013-04-23','14:15:00',3.51),('8348','2013-04-23','14:20:00',3.5),('8348','2013-04-23','14:25:00',3.22),('8348','2013-04-23','14:30:00',3.77),('8348','2013-04-23','14:35:00',3.6),('8348','2013-04-23','14:40:00',3.58),('8348','2013-04-23','14:45:00',3.13),('8348','2013-04-23','14:50:00',2),('8348','2013-04-23','14:55:00',2.07),('8348','2013-04-23','15:00:00',2.16),('8348','2013-04-23','15:05:00',2.29),('8348','2013-04-23','15:10:00',2.79),('8348','2013-04-23','15:15:00',2.77),('8348','2013-04-23','15:20:00',2.57),('8348','2013-04-23','15:25:00',2.33),('8348','2013-04-23','15:30:00',2.32),('8348','2013-04-23','15:35:00',2.29),('8348','2013-04-23','15:40:00',2.41),('8348','2013-04-23','15:45:00',2.41),('8348','2013-04-23','15:50:00',1.95),('8348','2013-04-23','15:55:00',1.57),('8348','2013-04-23','16:00:00',1.67),('8348','2013-04-23','16:05:00',2.01),('8348','2013-04-23','16:10:00',2.01),('8348','2013-04-23','16:15:00',2.09),('8348','2013-04-23','16:20:00',1.31),('8348','2013-04-23','16:25:00',1.32),('8348','2013-04-23','16:30:00',1.11),('8348','2013-04-23','16:35:00',1.05),('8348','2013-04-23','16:40:00',1),('8348','2013-04-23','16:45:00',1.15),('8348','2013-04-23','16:55:00',1.01),('8348','2013-04-23','17:00:00',1.06),('8348','2013-04-23','17:05:00',1.08),('8348','2013-04-23','17:10:00',1.66),('8348','2013-04-23','17:15:00',1.41),('8348','2013-04-23','17:25:00',1.5),('8348','2013-04-23','17:30:00',1.5),('8348','2013-04-23','17:35:00',1.2),('8348','2013-04-22','09:30:00',1.08),('8348','2013-04-22','10:35:00',1.91),('8348','2013-04-22','10:40:00',2.65),('8348','2013-04-22','10:45:00',4.24),('8348','2013-04-22','10:50:00',2.05),('8348','2013-04-22','10:55:00',2.1),('8348','2013-04-22','11:00:00',1.85),('8348','2013-04-22','11:05:00',1.61),('8348','2013-04-22','11:10:00',2.16),('8348','2013-04-22','11:15:00',1.32),('8348','2013-04-22','11:20:00',1.32),('8348','2013-04-22','11:25:00',1.66),('8348','2013-04-22','11:30:00',2.46),('8348','2013-04-22','11:35:00',3.51),('8348','2013-04-22','11:40:00',3.42),('8348','2013-04-22','11:45:00',2.07),('8348','2013-04-22','11:50:00',1.51),('8348','2013-04-22','11:55:00',2.76),('8348','2013-04-22','12:00:00',3.31),('8348','2013-04-22','12:05:00',3.79),('8348','2013-04-22','12:10:00',2.15),('8348','2013-04-22','12:15:00',2.34),('8348','2013-04-22','12:20:00',1.98),('8348','2013-04-22','12:25:00',2.19),('8348','2013-04-22','12:30:00',2.54),('8348','2013-04-22','12:35:00',1.67),('8348','2013-04-22','12:40:00',2.93),('8348','2013-04-22','12:45:00',2.97),('8348','2013-04-22','12:50:00',4.08),('8348','2013-04-22','12:55:00',4.04),('8348','2013-04-22','13:00:00',4.05),('8348','2013-04-22','13:05:00',3.39),('8348','2013-04-22','13:10:00',3),('8348','2013-04-22','13:15:00',4.14),('8348','2013-04-22','13:20:00',4.38),('8348','2013-04-22','13:25:00',2.62),('8348','2013-04-22','13:30:00',1.47),('8348','2013-04-22','13:35:00',1.85),('8348','2013-04-22','13:40:00',2.26),('8348','2013-04-22','13:45:00',1.68),('8348','2013-04-22','13:50:00',1.03),('8348','2013-04-22','13:55:00',2.05),('8348','2013-04-22','14:00:00',1.31),('8348','2013-04-22','14:05:00',1.76),('8348','2013-04-22','14:10:00',2.91),('8348','2013-04-22','14:15:00',3.71),('8348','2013-04-22','14:20:00',3.57),('8348','2013-04-22','14:25:00',2.63),('8348','2013-04-22','14:30:00',4.04),('8348','2013-04-22','14:35:00',2.47),('8348','2013-04-22','14:40:00',4.25),('8348','2013-04-22','14:45:00',3.89),('8348','2013-04-22','14:50:00',4.04),('8348','2013-04-22','14:55:00',3.94),('8348','2013-04-22','15:00:00',1.18),('8348','2013-04-22','15:05:00',1.4),('8348','2013-04-22','15:10:00',1.52),('8348','2013-04-22','15:15:00',1.07),('8348','2013-04-22','15:20:00',1.53),('8348','2013-04-22','15:25:00',4.03),('8348','2013-04-22','15:30:00',1.59),('8348','2013-04-22','15:35:00',1.59),('8348','2013-04-22','15:40:00',2.22),('8348','2013-04-22','15:45:00',3.54),('8348','2013-04-22','15:50:00',2.81),('8348','2013-04-22','15:55:00',1.47),('8348','2013-04-22','16:45:00',1.03),('8348','2014-03-29','07:20:00',1.09),('8348','2014-03-29','07:25:00',1.18),('8348','2014-03-29','07:30:00',1.29),('8348','2014-03-29','07:35:00',1.37),('8348','2014-03-29','07:40:00',1.53),('8348','2014-03-29','07:45:00',1.72),('8348','2014-03-29','07:50:00',1.83),('8348','2014-03-29','07:55:00',1.93),('8348','2014-03-29','08:00:00',2.06),('8348','2014-03-29','08:05:00',2.19),('8348','2014-03-29','08:10:00',2.31),('8348','2014-03-29','08:15:00',2.4),('8348','2014-03-29','08:20:00',2.52),('8348','2014-03-29','08:25:00',2.76),('8348','2014-03-29','08:30:00',3.01),('8348','2014-03-29','08:35:00',3.19),('8348','2014-03-29','08:40:00',3.34),('8348','2014-03-29','08:45:00',3.57),('8348','2014-03-29','08:50:00',3.75),('8348','2014-03-29','08:55:00',3.84),('8348','2014-03-29','09:00:00',3.96),('8348','2014-03-29','09:05:00',4.07),('8348','2014-03-29','09:10:00',4.21),('8348','2014-03-29','09:15:00',4.38),('8348','2014-03-29','09:20:00',4.54),('8348','2014-03-29','09:25:00',4.67),('8348','2014-03-29','09:30:00',4.78),('8348','2014-03-29','09:35:00',4.87),('8348','2014-03-29','09:40:00',5.01),('8348','2014-03-29','09:45:00',5.08),('8348','2014-03-29','09:50:00',5.21),('8348','2014-03-29','09:55:00',5.34),('8348','2014-03-29','10:00:00',5.46),('8348','2014-03-29','10:05:00',5.52),('8348','2014-03-29','10:10:00',5.66),('8348','2014-03-29','10:15:00',5.8),('8348','2014-03-29','10:20:00',5.86),('8348','2014-03-29','10:25:00',5.95),('8348','2014-03-29','10:30:00',6.01),('8348','2014-03-29','10:35:00',6.08),('8348','2014-03-29','10:40:00',6.14),('8348','2014-03-29','10:45:00',6.23),('8348','2014-03-29','10:50:00',6.29),('8348','2014-03-29','10:55:00',6.33),('8348','2014-03-29','11:00:00',6.37),('8348','2014-03-29','11:05:00',6.38),('8348','2014-03-29','11:10:00',6.43),('8348','2014-03-29','11:15:00',6.51),('8348','2014-03-29','11:20:00',6.55),('8348','2014-03-29','11:25:00',6.62),('8348','2014-03-29','11:30:00',6.67),('8348','2014-03-29','11:35:00',6.61),('8348','2014-03-29','11:40:00',6.43),('8348','2014-03-29','11:45:00',6.74),('8348','2014-03-29','11:50:00',6.78),('8348','2014-03-29','11:55:00',6.75),('8348','2014-03-29','12:00:00',6.77),('8348','2014-03-29','12:05:00',6.81),('8348','2014-03-29','12:10:00',6.82),('8348','2014-03-29','12:15:00',6.83),('8348','2014-03-29','12:20:00',6.96),('8348','2014-03-29','12:25:00',6.95),('8348','2014-03-29','12:30:00',6.9),('8348','2014-03-29','12:35:00',6.9),('8348','2014-03-29','12:40:00',6.89),('8348','2014-03-29','12:45:00',6.92),('8348','2014-03-29','12:50:00',6.91),('8348','2014-03-29','12:55:00',6.86),('8348','2014-03-29','13:00:00',6.79),('8348','2014-03-29','13:05:00',6.87),('8348','2014-03-29','13:10:00',6.78),('8348','2014-03-29','13:15:00',6.77),('8348','2014-03-29','13:20:00',6.73),('8348','2014-03-29','13:25:00',6.61),('8348','2014-03-29','13:30:00',6.62),('8348','2014-03-29','13:35:00',6.51),('8348','2014-03-29','13:40:00',6.47),('8348','2014-03-29','13:45:00',6.32),('8348','2014-03-29','13:50:00',6.23),('8348','2014-03-29','13:55:00',6.18),('8348','2014-03-29','14:00:00',6.17),('8348','2014-03-29','14:05:00',6.15),('8348','2014-03-29','14:10:00',6.09),('8348','2014-03-29','14:15:00',6.02),('8348','2014-03-29','14:20:00',5.95),('8348','2014-03-29','14:25:00',5.89),('8348','2014-03-29','14:30:00',5.78),('8348','2014-03-29','14:35:00',5.14),('8348','2014-03-29','14:40:00',4.08),('8348','2014-03-29','14:45:00',5.23),('8348','2014-03-29','14:50:00',5.59),('8348','2014-03-29','14:55:00',5.62),('8348','2014-03-29','15:00:00',5.52),('8348','2014-03-29','15:05:00',5.35),('8348','2014-03-29','15:10:00',5.2),('8348','2014-03-29','15:15:00',5.12),('8348','2014-03-29','15:20:00',5.02),('8348','2014-03-29','15:25:00',4.83),('8348','2014-03-29','15:30:00',4.63),('8348','2014-03-29','15:35:00',4.45),('8348','2014-03-29','15:40:00',4.42),('8348','2014-03-29','15:45:00',4.31),('8348','2014-03-29','15:50:00',4.15),('8348','2014-03-29','15:55:00',4.04),('8348','2014-03-29','16:00:00',3.92),('8348','2014-03-29','16:05:00',3.76),('8348','2014-03-29','16:10:00',3.55),('8348','2014-03-29','16:15:00',3.38),('8348','2014-03-29','16:20:00',3.07),('8348','2014-03-29','16:25:00',3.1),('8348','2014-03-29','16:30:00',2.96),('8348','2014-03-29','16:35:00',2.69),('8348','2014-03-29','16:40:00',2.33),('8348','2014-03-29','16:45:00',1.9),('8348','2014-03-29','16:50:00',2.1),('8348','2014-03-29','16:55:00',2.17),('8348','2014-03-29','17:00:00',2.05),('8348','2014-03-29','17:05:00',1.86),('8348','2014-03-29','17:10:00',1.72),('8348','2014-03-29','17:15:00',1.56),('8348','2014-03-29','17:20:00',1.38),('8348','2014-03-29','17:25:00',1.2),('8348','2014-03-29','17:30:00',1.04),('8348','2013-04-21','08:25:00',1.02),('8348','2013-04-21','08:30:00',1.1),('8348','2013-04-21','08:35:00',1.23),('8348','2013-04-21','08:40:00',1.19),('8348','2013-04-21','08:45:00',1.11),('8348','2013-04-21','08:50:00',1.24),('8348','2013-04-21','08:55:00',1.63),('8348','2013-04-21','09:00:00',1.51),('8348','2013-04-21','09:05:00',1.91),('8348','2013-04-21','09:10:00',1.64),('8348','2013-04-21','09:15:00',1.39),('8348','2013-04-21','09:20:00',1.35),('8348','2013-04-21','09:25:00',1.96),('8348','2013-04-21','09:30:00',2.33),('8348','2013-04-21','09:35:00',2.39),('8348','2013-04-21','09:40:00',2.48),('8348','2013-04-21','09:45:00',2.65),('8348','2013-04-21','09:50:00',2.95),('8348','2013-04-21','09:55:00',3.27),('8348','2013-04-21','10:00:00',2.68),('8348','2013-04-21','10:05:00',1.75),('8348','2013-04-21','10:10:00',1.73),('8348','2013-04-21','10:15:00',1.57),('8348','2013-04-21','10:20:00',3.21),('8348','2013-04-21','10:25:00',2.27),('8348','2013-04-21','10:30:00',2.14),('8348','2013-04-21','10:35:00',1.55),('8348','2013-04-21','10:40:00',1.85),('8348','2013-04-21','10:45:00',2.16),('8348','2013-04-21','10:50:00',2.28),('8348','2013-04-21','10:55:00',2.22),('8348','2013-04-21','11:00:00',3.1),('8348','2013-04-21','11:05:00',2.95),('8348','2013-04-21','11:10:00',3.49),('8348','2013-04-21','11:15:00',2.96),('8348','2013-04-21','11:20:00',2.56),('8348','2013-04-21','11:25:00',2.71),('8348','2013-04-21','11:30:00',2.46),('8348','2013-04-21','11:35:00',2.35),('8348','2013-04-21','11:40:00',2.49),('8348','2013-04-21','11:45:00',2.71),('8348','2013-04-21','11:50:00',2.99),('8348','2013-04-21','11:55:00',2.81),('8348','2013-04-21','12:00:00',2.21),('8348','2013-04-21','12:05:00',2.25),('8348','2013-04-21','12:10:00',2.16),('8348','2013-04-21','12:15:00',2.01),('8348','2013-04-21','12:20:00',1.83),('8348','2013-04-21','12:25:00',1.78),('8348','2013-04-21','12:30:00',1.91),('8348','2013-04-21','12:35:00',1.98),('8348','2013-04-21','12:40:00',2),('8348','2013-04-21','12:45:00',2.02),('8348','2013-04-21','12:50:00',1.91),('8348','2013-04-21','12:55:00',1.84),('8348','2013-04-21','13:00:00',2.08),('8348','2013-04-21','13:05:00',2.43),('8348','2013-04-21','13:10:00',2.44),('8348','2013-04-21','13:15:00',2.24),('8348','2013-04-21','13:20:00',2.11),('8348','2013-04-21','13:25:00',2.06),('8348','2013-04-21','13:30:00',3),('8348','2013-04-21','13:35:00',3.5),('8348','2013-04-21','13:40:00',2.59),('8348','2013-04-21','13:45:00',3),('8348','2013-04-21','13:50:00',2.96),('8348','2013-04-21','13:55:00',3.53),('8348','2013-04-21','14:00:00',3.64),('8348','2013-04-21','14:05:00',4.03),('8348','2013-04-21','14:10:00',3.81),('8348','2013-04-21','14:15:00',4.08),('8348','2013-04-21','14:20:00',4.27),('8348','2013-04-21','14:25:00',4.02),('8348','2013-04-21','14:30:00',3.64),('8348','2013-04-21','14:35:00',4.13),('8348','2013-04-21','14:40:00',4.29),('8348','2013-04-21','14:45:00',3.25),('8348','2013-04-21','14:50:00',2.01),('8348','2013-04-21','14:55:00',2.06),('8348','2013-04-21','15:00:00',1.84),('8348','2013-04-21','15:05:00',3.46),('8348','2013-04-21','15:10:00',3.76),('8348','2013-04-21','15:15:00',2.87),('8348','2013-04-21','15:20:00',1.67),('8348','2013-04-21','15:25:00',1.8),('8348','2013-04-21','15:30:00',1.6),('8348','2013-04-21','15:35:00',1.37),('8348','2013-04-21','15:40:00',1.44),('8348','2013-04-21','15:45:00',1.18),('8348','2013-04-20','08:30:00',1.11),('8348','2013-04-20','08:35:00',1.2),('8348','2013-04-20','08:40:00',1.33),('8348','2013-04-20','08:45:00',1.41),('8348','2013-04-20','08:50:00',1.45),('8348','2013-04-20','08:55:00',1.46),('8348','2013-04-20','09:00:00',1.71),('8348','2013-04-20','09:05:00',1.81),('8348','2013-04-20','09:10:00',1.73),('8348','2013-04-20','09:15:00',1.73),('8348','2013-04-20','09:20:00',2.13),('8348','2013-04-20','09:25:00',2.01),('8348','2013-04-20','09:30:00',1.9),('8348','2013-04-20','09:35:00',1.33),('8348','2013-04-20','09:50:00',1.02),('8348','2013-04-20','10:40:00',1.11),('8348','2013-04-20','10:45:00',2),('8348','2013-04-20','10:50:00',2.43),('8348','2013-04-20','10:55:00',2.3),('8348','2013-04-20','11:00:00',3.22),('8348','2013-04-20','11:05:00',3.25),('8348','2013-04-20','11:10:00',3.51),('8348','2013-04-20','11:15:00',3.62),('8348','2013-04-20','11:20:00',2.69),('8348','2013-04-20','11:25:00',2.73),('8348','2013-04-20','11:30:00',3.69),('8348','2013-04-20','11:35:00',2.14),('8348','2013-04-20','11:40:00',1.16),('8348','2013-04-20','11:45:00',1.91),('8348','2013-04-20','11:50:00',3.08),('8348','2013-04-20','11:55:00',3.98),('8348','2013-04-20','12:00:00',3.95),('8348','2013-04-20','12:05:00',3.87),('8348','2013-04-20','12:10:00',3.8),('8348','2013-04-20','12:15:00',3.82),('8348','2013-04-20','12:20:00',3.74),('8348','2013-04-20','12:25:00',3.78),('8348','2013-04-20','12:30:00',3.49),('8348','2013-04-20','12:35:00',1.29),('8348','2013-04-20','12:40:00',1.57),('8348','2013-04-20','12:45:00',4.08),('8348','2013-04-20','12:50:00',2.93),('8348','2013-04-20','12:55:00',2.34),('8348','2013-04-20','13:00:00',3.34),('8348','2013-04-20','13:05:00',2.64),('8348','2013-04-20','13:10:00',2.3),('8348','2013-04-20','13:15:00',3.9),('8348','2013-04-20','13:20:00',3.14),('8348','2013-04-20','13:25:00',3.07),('8348','2013-04-20','13:30:00',1.29),('8348','2013-04-20','13:35:00',1.92),('8348','2013-04-20','13:40:00',3.22),('8348','2013-04-20','13:45:00',2.02),('8348','2013-04-20','13:50:00',1.54),('8348','2013-04-20','13:55:00',2.12),('8348','2013-04-20','14:00:00',2.58),('8348','2013-04-20','14:05:00',3.02),('8348','2013-04-20','14:10:00',3.41),('8348','2013-04-20','14:15:00',3.84),('8348','2013-04-20','14:20:00',3.67),('8348','2013-04-20','14:25:00',3.62),('8348','2013-04-20','14:30:00',3.53),('8348','2013-04-20','14:35:00',3.47),('8348','2013-04-20','14:40:00',3.47),('8348','2013-04-20','14:45:00',3.5),('8348','2013-04-20','14:50:00',3.46),('8348','2013-04-20','14:55:00',3.47),('8348','2013-04-20','15:00:00',3.47),('8348','2013-04-20','15:05:00',3.44),('8348','2013-04-20','15:10:00',2.1),('8348','2013-04-20','15:15:00',2.17),('8348','2013-04-20','15:20:00',2.37),('8348','2013-04-20','15:25:00',3.07),('8348','2013-04-20','15:30:00',1.49),('8348','2013-04-20','16:05:00',1.01),('8348','2013-04-20','16:10:00',1.58),('8348','2013-04-20','16:15:00',2.36),('8348','2013-04-20','16:20:00',2),('8348','2013-04-20','16:25:00',2.52),('8348','2013-04-20','16:30:00',2.6),('8348','2013-04-20','16:35:00',2.62),('8348','2013-04-20','16:40:00',2.68),('8348','2013-04-20','16:45:00',2.84),('8348','2013-04-20','16:50:00',2.57),('8348','2013-04-20','16:55:00',2.46),('8348','2013-04-20','17:00:00',2.34),('8348','2013-04-20','17:05:00',2.28),('8348','2013-04-20','17:10:00',2.22),('8348','2013-04-20','17:15:00',1.95),('8348','2013-04-20','17:20:00',1.99),('8348','2013-04-20','17:25:00',2.01),('8348','2013-04-20','17:30:00',2.09),('8348','2013-04-20','17:35:00',2.07),('8348','2013-04-20','17:40:00',1.86),('8348','2013-04-20','17:50:00',1.01),('8348','2013-04-20','17:55:00',1.75),('8348','2013-04-20','18:00:00',1.27),('8348','2013-04-20','18:05:00',1.37),('8348','2013-04-20','18:10:00',1.48),('8348','2013-04-20','18:15:00',1.25),('8348','2013-04-19','08:35:00',1.16),('8348','2013-04-19','08:40:00',1.24),('8348','2013-04-19','08:45:00',1.32),('8348','2013-04-19','08:50:00',1.39),('8348','2013-04-19','08:55:00',1.48),('8348','2013-04-19','09:00:00',1.56),('8348','2013-04-19','09:05:00',1.62),('8348','2013-04-19','09:10:00',1.68),('8348','2013-04-19','09:15:00',1.73),('8348','2013-04-19','09:20:00',1.82),('8348','2013-04-19','09:25:00',1.88),('8348','2013-04-19','09:30:00',1.93),('8348','2013-04-19','09:35:00',2),('8348','2013-04-19','09:40:00',2.05),('8348','2013-04-19','09:45:00',2.1),('8348','2013-04-19','09:50:00',2.14),('8348','2013-04-19','09:55:00',2.22),('8348','2013-04-19','10:00:00',2.26),('8348','2013-04-19','10:05:00',2.31),('8348','2013-04-19','10:10:00',2.36),('8348','2013-04-19','10:15:00',2.46),('8348','2013-04-19','10:20:00',2.4),('8348','2013-04-19','10:25:00',2.58),('8348','2013-04-19','10:30:00',2.57),('8348','2013-04-19','10:35:00',2.13),('8348','2013-04-19','10:40:00',2.75),('8348','2013-04-19','10:45:00',2.7),('8348','2013-04-19','10:50:00',2.73),('8348','2013-04-19','10:55:00',2.75),('8348','2013-04-19','11:00:00',2.79),('8348','2013-04-19','11:05:00',2.83),('8348','2013-04-19','11:10:00',2.88),('8348','2013-04-19','11:15:00',2.89),('8348','2013-04-19','11:20:00',2.94),('8348','2013-04-19','11:25:00',2.99),('8348','2013-04-19','11:30:00',3),('8348','2013-04-19','11:35:00',2.98),('8348','2013-04-19','11:40:00',3.09),('8348','2013-04-19','11:45:00',3.17),('8348','2013-04-19','11:50:00',3.22),('8348','2013-04-19','11:55:00',3.22),('8348','2013-04-19','12:00:00',3.18),('8348','2013-04-19','12:05:00',3.24),('8348','2013-04-19','12:10:00',3.29),('8348','2013-04-19','12:15:00',3.27),('8348','2013-04-19','12:20:00',3.27),('8348','2013-04-19','12:25:00',3.3),('8348','2013-04-19','12:30:00',3.35),('8348','2013-04-19','12:35:00',3.34),('8348','2013-04-19','12:40:00',3.35),('8348','2013-04-19','12:45:00',3.36),('8348','2013-04-19','12:50:00',3.35),('8348','2013-04-19','12:55:00',3.39),('8348','2013-04-19','13:00:00',3.38),('8348','2013-04-19','13:05:00',3.43),('8348','2013-04-19','13:10:00',3.47),('8348','2013-04-19','13:15:00',3.48),('8348','2013-04-19','13:20:00',3.45),('8348','2013-04-19','13:25:00',3.53),('8348','2013-04-19','13:30:00',3.5),('8348','2013-04-19','13:35:00',3.44),('8348','2013-04-19','13:40:00',3.49),('8348','2013-04-19','13:45:00',3.45),('8348','2013-04-19','13:50:00',3.43),('8348','2013-04-19','13:55:00',3.44),('8348','2013-04-19','14:00:00',3.39),('8348','2013-04-19','14:05:00',3.41),('8348','2013-04-19','14:10:00',3.4),('8348','2013-04-19','14:15:00',3.37),('8348','2013-04-19','14:20:00',3.33),('8348','2013-04-19','14:25:00',3.35),('8348','2013-04-19','14:30:00',3.27),('8348','2013-04-19','14:35:00',3.26),('8348','2013-04-19','14:40:00',3.25),('8348','2013-04-19','14:45:00',3.22),('8348','2013-04-19','14:50:00',3.24),('8348','2013-04-19','14:55:00',3.21),('8348','2013-04-19','15:00:00',3.19),('8348','2013-04-19','15:05:00',3.15),('8348','2013-04-19','15:10:00',3.11),('8348','2013-04-19','15:15:00',3.08),('8348','2013-04-19','15:20:00',3.05),('8348','2013-04-19','15:25:00',3.05),('8348','2013-04-19','15:30:00',3.02),('8348','2013-04-19','15:35:00',2.97),('8348','2013-04-19','15:40:00',2.96),('8348','2013-04-19','15:45:00',2.92),('8348','2013-04-19','15:50:00',2.89),('8348','2013-04-19','15:55:00',2.85),('8348','2013-04-19','16:00:00',2.8),('8348','2013-04-19','16:05:00',2.75),('8348','2013-04-19','16:10:00',2.68),('8348','2013-04-19','16:15:00',2.63),('8348','2013-04-19','16:20:00',2.58),('8348','2013-04-19','16:25:00',2.53),('8348','2013-04-19','16:30:00',2.47),('8348','2013-04-19','16:35:00',2.39),('8348','2013-04-19','16:40:00',2.33),('8348','2013-04-19','16:45:00',2.28),('8348','2013-04-19','16:50:00',2.2),('8348','2013-04-19','16:55:00',2.11),('8348','2013-04-19','17:00:00',2.06),('8348','2013-04-19','17:05:00',1.98),('8348','2013-04-19','17:10:00',1.89),('8348','2013-04-19','17:15:00',1.82),('8348','2013-04-19','17:20:00',1.75),('8348','2013-04-19','17:25:00',1.68),('8348','2013-04-19','17:30:00',1.61),('8348','2013-04-19','17:35:00',1.54),('8348','2013-04-19','17:40:00',1.47),('8348','2013-04-19','17:45:00',1.39),('8348','2013-04-19','17:50:00',1.26),('8348','2013-04-19','17:55:00',1.2),('8348','2013-04-19','18:00:00',1.14),('8348','2013-04-19','18:05:00',1.08),('8348','2013-04-19','18:10:00',1.01),('8348','2013-04-18','08:30:00',1.01),('8348','2013-04-18','08:35:00',1.06),('8348','2013-04-18','08:40:00',1.03),('8348','2013-04-18','08:45:00',1.03),('8348','2013-04-18','08:50:00',1.15),('8348','2013-04-18','08:55:00',1.31),('8348','2013-04-18','09:00:00',1.4),('8348','2013-04-18','09:05:00',1.51),('8348','2013-04-18','09:10:00',1.56),('8348','2013-04-18','09:15:00',1.58),('8348','2013-04-18','09:20:00',1.62),('8348','2013-04-18','09:25:00',1.67),('8348','2013-04-18','09:30:00',1.81),('8348','2013-04-18','09:35:00',2.01),('8348','2013-04-18','09:40:00',2.21),('8348','2013-04-18','09:45:00',2.13),('8348','2013-04-18','09:50:00',1.83),('8348','2013-04-18','09:55:00',1.79),('8348','2013-04-18','10:00:00',2.1),('8348','2013-04-18','10:05:00',2.34),('8348','2013-04-18','10:10:00',2.47),('8348','2013-04-18','10:15:00',2.62),('8348','2013-04-18','10:20:00',2.66),('8348','2013-04-18','10:25:00',2.64),('8348','2013-04-18','10:30:00',2.68),('8348','2013-04-18','10:35:00',2.7),('8348','2013-04-18','10:40:00',2.77),('8348','2013-04-18','10:45:00',2.82),('8348','2013-04-18','10:50:00',2.85),('8348','2013-04-18','10:55:00',2.89),('8348','2013-04-18','11:00:00',2.93),('8348','2013-04-18','11:05:00',2.97),('8348','2013-04-18','11:10:00',3.02),('8348','2013-04-18','11:15:00',3.07),('8348','2013-04-18','11:20:00',3.11),('8348','2013-04-18','11:25:00',3.15),('8348','2013-04-18','11:30:00',3.17),('8348','2013-04-18','11:35:00',3.2),('8348','2013-04-18','11:40:00',3.22),('8348','2013-04-18','11:45:00',3.22),('8348','2013-04-18','11:50:00',3.32),('8348','2013-04-18','11:55:00',3.38),('8348','2013-04-18','12:00:00',3.34),('8348','2013-04-18','12:05:00',3.4),('8348','2013-04-18','12:10:00',3.46),('8348','2013-04-18','12:15:00',3.47),('8348','2013-04-18','12:20:00',3.54),('8348','2013-04-18','12:25:00',3.5),('8348','2013-04-18','12:30:00',3.54),('8348','2013-04-18','12:35:00',3.56),('8348','2013-04-18','12:40:00',3.54),('8348','2013-04-18','12:45:00',3.58),('8348','2013-04-18','12:50:00',3.59),('8348','2013-04-18','12:55:00',3.62),('8348','2013-04-18','13:00:00',3.64),('8348','2013-04-18','13:05:00',3.63),('8348','2013-04-18','13:10:00',3.61),('8348','2013-04-18','13:15:00',3.6),('8348','2013-04-18','13:20:00',3.59),('8348','2013-04-18','13:25:00',3.63),('8348','2013-04-18','13:30:00',3.63),('8348','2013-04-18','13:35:00',3.65),('8348','2013-04-18','13:40:00',3.63),('8348','2013-04-18','13:45:00',3.65),('8348','2013-04-18','13:50:00',3.67),('8348','2013-04-18','13:55:00',3.67),('8348','2013-04-18','14:00:00',3.66),('8348','2013-04-18','14:05:00',3.65),('8348','2013-04-18','14:10:00',3.63),('8348','2013-04-18','14:15:00',3.64),('8348','2013-04-18','14:20:00',3.62),('8348','2013-04-18','14:25:00',3.59),('8348','2013-04-18','14:30:00',3.58),('8348','2013-04-18','14:35:00',3.56),('8348','2013-04-18','14:40:00',3.53),('8348','2013-04-18','14:45:00',3.51),('8348','2013-04-18','14:50:00',3.48),('8348','2013-04-18','14:55:00',3.44),('8348','2013-04-18','15:00:00',3.41),('8348','2013-04-18','15:05:00',3.39),('8348','2013-04-18','15:10:00',3.34),('8348','2013-04-18','15:15:00',3.31),('8348','2013-04-18','15:20:00',3.26),('8348','2013-04-18','15:25:00',3.24),('8348','2013-04-18','15:30:00',3.19),('8348','2013-04-18','15:35:00',3.15),('8348','2013-04-18','15:40:00',3.1),('8348','2013-04-18','15:45:00',3.06),('8348','2013-04-18','15:50:00',3.04),('8348','2013-04-18','15:55:00',2.96),('8348','2013-04-18','16:00:00',2.91),('8348','2013-04-18','16:05:00',2.85),('8348','2013-04-18','16:10:00',2.81),('8348','2013-04-18','16:15:00',2.75),('8348','2013-04-18','16:20:00',2.66),('8348','2013-04-18','16:25:00',2.61),('8348','2013-04-18','16:30:00',2.56),('8348','2013-04-18','16:35:00',2.49),('8348','2013-04-18','16:40:00',2.44),('8348','2013-04-18','16:45:00',2.39),('8348','2013-04-18','16:50:00',2.34),('8348','2013-04-18','16:55:00',2.25),('8348','2013-04-18','17:00:00',2.17),('8348','2013-04-18','17:05:00',2.08),('8348','2013-04-18','17:10:00',2.03),('8348','2013-04-18','17:15:00',1.99),('8348','2013-04-18','17:20:00',1.9),('8348','2013-04-18','17:25:00',1.82),('8348','2013-04-18','17:30:00',1.75),('8348','2013-04-18','17:35:00',1.69),('8348','2013-04-18','17:40:00',1.6),('8348','2013-04-18','17:45:00',1.54),('8348','2013-04-18','17:50:00',1.47),('8348','2013-04-18','17:55:00',1.39),('8348','2013-04-18','18:00:00',1.3),('8348','2013-04-18','18:05:00',1.21),('8348','2013-04-18','18:10:00',1.12),('8348','2013-04-18','18:15:00',1.04),('8348','2013-04-17','08:30:00',1.03),('8348','2013-04-17','08:35:00',1.14),('8348','2013-04-17','08:40:00',1.2),('8348','2013-04-17','08:45:00',1.28),('8348','2013-04-17','08:50:00',1.37),('8348','2013-04-17','08:55:00',1.44),('8348','2013-04-17','09:00:00',1.52),('8348','2013-04-17','09:05:00',1.63),('8348','2013-04-17','09:10:00',1.7),('8348','2013-04-17','09:15:00',1.77),('8348','2013-04-17','09:20:00',1.84),('8348','2013-04-17','09:25:00',1.91),('8348','2013-04-17','09:30:00',1.98),('8348','2013-04-17','09:35:00',2.06),('8348','2013-04-17','09:40:00',2.12),('8348','2013-04-17','09:45:00',2.18),('8348','2013-04-17','09:50:00',2.25),('8348','2013-04-17','09:55:00',2.31),('8348','2013-04-17','10:00:00',2.36),('8348','2013-04-17','10:05:00',2.42),('8348','2013-04-17','10:10:00',2.48),('8348','2013-04-17','10:15:00',2.53),('8348','2013-04-17','10:20:00',2.59),('8348','2013-04-17','10:25:00',2.65),('8348','2013-04-17','10:30:00',2.7),('8348','2013-04-17','10:35:00',2.75),('8348','2013-04-17','10:40:00',2.79),('8348','2013-04-17','10:45:00',2.83),('8348','2013-04-17','10:50:00',2.89),('8348','2013-04-17','10:55:00',2.93),('8348','2013-04-17','11:00:00',2.97),('8348','2013-04-17','11:05:00',3.02),('8348','2013-04-17','11:10:00',3.06),('8348','2013-04-17','11:15:00',3.1),('8348','2013-04-17','11:20:00',3.13),('8348','2013-04-17','11:25:00',3.14),('8348','2013-04-17','11:30:00',3.17),('8348','2013-04-17','11:35:00',3.21),('8348','2013-04-17','11:40:00',3.23),('8348','2013-04-17','11:45:00',3.25),('8348','2013-04-17','11:50:00',3.3),('8348','2013-04-17','11:55:00',3.33),('8348','2013-04-17','12:00:00',3.34),('8348','2013-04-17','12:05:00',3.36),('8348','2013-04-17','12:10:00',3.38),('8348','2013-04-17','12:15:00',3.42),('8348','2013-04-17','12:20:00',3.42),('8348','2013-04-17','12:25:00',3.44),('8348','2013-04-17','12:30:00',3.49),('8348','2013-04-17','12:35:00',3.51),('8348','2013-04-17','12:40:00',3.51),('8348','2013-04-17','12:45:00',3.52),('8348','2013-04-17','12:50:00',3.52),('8348','2013-04-17','12:55:00',3.55),('8348','2013-04-17','13:00:00',3.54),('8348','2013-04-17','13:05:00',3.56),('8348','2013-04-17','13:10:00',3.56),('8348','2013-04-17','13:15:00',3.59),('8348','2013-04-17','13:20:00',3.58),('8348','2013-04-17','13:25:00',3.59),('8348','2013-04-17','13:30:00',3.6),('8348','2013-04-17','13:35:00',3.61),('8348','2013-04-17','13:40:00',3.68),('8348','2013-04-17','13:45:00',3.56),('8348','2013-04-17','13:50:00',3.52),('8348','2013-04-17','13:55:00',3.78),('8348','2013-04-17','14:00:00',3.59),('8348','2013-04-17','14:05:00',3.95),('8348','2013-04-17','14:10:00',3.92),('8348','2013-04-17','14:15:00',3.48),('8348','2013-04-17','14:20:00',3.45),('8348','2013-04-17','14:25:00',3.31),('8348','2013-04-17','14:30:00',3.59),('8348','2013-04-17','14:35:00',3.85),('8348','2013-04-17','14:40:00',3.59),('8348','2013-04-17','14:45:00',3.36),('8348','2013-04-17','14:50:00',3.75),('8348','2013-04-17','14:55:00',3.76),('8348','2013-04-17','15:00:00',3.72),('8348','2013-04-17','15:05:00',3.79),('8348','2013-04-17','15:10:00',3.92),('8348','2013-04-17','15:15:00',3.62),('8348','2013-04-17','15:20:00',2.1),('8348','2013-04-17','15:25:00',1.8),('8348','2013-04-17','15:30:00',3.12),('8348','2013-04-17','15:35:00',3.33),('8348','2013-04-17','15:40:00',3.37),('8348','2013-04-17','15:45:00',3.36),('8348','2013-04-17','15:50:00',3.34),('8348','2013-04-17','15:55:00',3.25),('8348','2013-04-17','16:00:00',3.11),('8348','2013-04-17','16:05:00',2.28),('8348','2013-04-17','16:10:00',3.05),('8348','2013-04-17','16:15:00',2.95),('8348','2013-04-17','16:20:00',2.85),('8348','2013-04-17','16:25:00',2.79),('8348','2013-04-17','16:30:00',2.73),('8348','2013-04-17','16:35:00',2.71),('8348','2013-04-17','16:40:00',2.36),('8348','2013-04-17','16:45:00',2.59),('8348','2013-04-17','16:50:00',2.44),('8348','2013-04-17','16:55:00',2.34),('8348','2013-04-17','17:00:00',2.26),('8348','2013-04-17','17:05:00',2.17),('8348','2013-04-17','17:10:00',2.09),('8348','2013-04-17','17:15:00',2.02),('8348','2013-04-17','17:20:00',1.94),('8348','2013-04-17','17:25:00',1.87),('8348','2013-04-17','17:30:00',1.78),('8348','2013-04-17','17:35:00',1.71),('8348','2013-04-17','17:40:00',1.63),('8348','2013-04-17','17:45:00',1.54),('8348','2013-04-17','17:50:00',1.47),('8348','2013-04-17','17:55:00',1.4),('8348','2013-04-17','18:00:00',1.32),('8348','2013-04-17','18:05:00',1.24),('8348','2013-04-17','18:10:00',1.16),('8348','2013-04-17','18:15:00',1.07),('8348','2013-04-16','09:10:00',1.2),('8348','2013-04-16','09:15:00',1.17),('8348','2013-04-16','09:25:00',1.22),('8348','2013-04-16','09:30:00',1.46),('8348','2013-04-16','09:35:00',1.35),('8348','2013-04-16','09:40:00',1.26),('8348','2013-04-16','09:45:00',1.31),('8348','2013-04-16','09:50:00',1.24),('8348','2013-04-16','09:55:00',1.2),('8348','2013-04-16','10:00:00',1.15),('8348','2013-04-16','10:05:00',1.15),('8348','2013-04-16','10:10:00',1.23),('8348','2013-04-16','10:15:00',1.31),('8348','2013-04-16','10:20:00',1.36),('8348','2013-04-16','10:25:00',1.4),('8348','2013-04-16','10:30:00',1.4),('8348','2013-04-16','10:35:00',1.43),('8348','2013-04-16','10:40:00',1.41),('8348','2013-04-16','10:45:00',1.35),('8348','2013-04-16','10:50:00',1.37),('8348','2013-04-16','10:55:00',1.46),('8348','2013-04-16','11:00:00',1.58),('8348','2013-04-16','11:05:00',1.63),('8348','2013-04-16','11:10:00',1.61),('8348','2013-04-16','11:15:00',1.66),('8348','2013-04-16','11:20:00',1.7),('8348','2013-04-16','11:25:00',1.67),('8348','2013-04-16','11:30:00',1.62),('8348','2013-04-16','11:35:00',1.57),('8348','2013-04-16','11:40:00',1.73),('8348','2013-04-16','11:45:00',1.98),('8348','2013-04-16','11:50:00',2.11),('8348','2013-04-16','11:55:00',2.18),('8348','2013-04-16','12:00:00',2.21),('8348','2013-04-16','12:05:00',2.48),('8348','2013-04-16','12:10:00',2.38),('8348','2013-04-16','12:15:00',2.52),('8348','2013-04-16','12:20:00',2.65),('8348','2013-04-16','12:25:00',2.56),('8348','2013-04-16','12:30:00',2.16),('8348','2013-04-16','12:35:00',3.63),('8348','2013-04-16','12:40:00',3.48),('8348','2013-04-16','12:45:00',2.99),('8348','2013-04-16','12:50:00',2.47),('8348','2013-04-16','12:55:00',3.42),('8348','2013-04-16','13:00:00',3.62),('8348','2013-04-16','13:05:00',3.46),('8348','2013-04-16','13:10:00',3.45),('8348','2013-04-16','13:15:00',3.49),('8348','2013-04-16','13:20:00',3.56),('8348','2013-04-16','13:25:00',3.58),('8348','2013-04-16','13:30:00',3.57),('8348','2013-04-16','13:35:00',3.53),('8348','2013-04-16','13:40:00',3.51),('8348','2013-04-16','13:45:00',3.44),('8348','2013-04-16','13:50:00',3.43),('8348','2013-04-16','13:55:00',3.35),('8348','2013-04-16','14:00:00',3.45),('8348','2013-04-16','14:05:00',3.52),('8348','2013-04-16','14:10:00',3.53),('8348','2013-04-16','14:15:00',3.57),('8348','2013-04-16','14:20:00',3.51),('8348','2013-04-16','14:25:00',3),('8348','2013-04-16','14:30:00',3.1),('8348','2013-04-16','14:35:00',2.74),('8348','2013-04-16','14:40:00',3.25),('8348','2013-04-16','14:45:00',3.4),('8348','2013-04-16','14:50:00',3.31),('8348','2013-04-16','14:55:00',3.25),('8348','2013-04-16','15:00:00',3.35),('8348','2013-04-16','15:05:00',3.32),('8348','2013-04-16','15:10:00',3.33),('8348','2013-04-16','15:15:00',3.26),('8348','2013-04-16','15:20:00',3.2),('8348','2013-04-16','15:25:00',3.1),('8348','2013-04-16','15:30:00',2.99),('8348','2013-04-16','15:35:00',3.07),('8348','2013-04-16','15:40:00',3.04),('8348','2013-04-16','15:45:00',3.01),('8348','2013-04-16','15:50:00',2.96),('8348','2013-04-16','15:55:00',2.93),('8348','2013-04-16','16:00:00',2.8),('8348','2013-04-16','16:05:00',2.8),('8348','2013-04-16','16:10:00',2.72),('8348','2013-04-16','16:15:00',2.65),('8348','2013-04-16','16:20:00',2.67),('8348','2013-04-16','16:25:00',2.61),('8348','2013-04-16','16:30:00',2.57),('8348','2013-04-16','16:35:00',2.54),('8348','2013-04-16','16:40:00',2.64),('8348','2013-04-16','16:45:00',2.69),('8348','2013-04-16','16:50:00',2.45),('8348','2013-04-16','16:55:00',2.09),('8348','2013-04-16','17:00:00',2.14),('8348','2013-04-16','17:05:00',2.21),('8348','2013-04-16','17:10:00',2.21),('8348','2013-04-16','17:15:00',2.15),('8348','2013-04-16','17:20:00',2.09),('8348','2013-04-16','17:25:00',2.08),('8348','2013-04-16','17:30:00',1.95),('8348','2013-04-16','17:35:00',1.96),('8348','2013-04-16','17:40:00',1.83),('8348','2013-04-16','17:45:00',1.7),('8348','2013-04-16','17:50:00',1.55),('8348','2013-04-16','17:55:00',1.37),('8348','2013-04-15','08:30:00',1.02),('8348','2013-04-15','08:35:00',1.1),('8348','2013-04-15','08:40:00',1.15),('8348','2013-04-15','08:45:00',1.24),('8348','2013-04-15','08:50:00',1.3),('8348','2013-04-15','08:55:00',1.42),('8348','2013-04-15','09:00:00',1.51),('8348','2013-04-15','09:05:00',1.61),('8348','2013-04-15','09:10:00',1.7),('8348','2013-04-15','09:15:00',1.76),('8348','2013-04-15','09:20:00',1.83),('8348','2013-04-15','09:25:00',1.91),('8348','2013-04-15','09:30:00',1.97),('8348','2013-04-15','09:35:00',2.04),('8348','2013-04-15','09:40:00',2.09),('8348','2013-04-15','09:45:00',2.16),('8348','2013-04-15','09:50:00',2.23),('8348','2013-04-15','09:55:00',2.28),('8348','2013-04-15','10:00:00',2.34),('8348','2013-04-15','10:05:00',2.4),('8348','2013-04-15','10:10:00',2.46),('8348','2013-04-15','10:15:00',2.53),('8348','2013-04-15','10:20:00',2.58),('8348','2013-04-15','10:25:00',2.62),('8348','2013-04-15','10:30:00',2.68),('8348','2013-04-15','10:35:00',2.73),('8348','2013-04-15','10:40:00',2.78),('8348','2013-04-15','10:45:00',2.82),('8348','2013-04-15','10:50:00',2.86),('8348','2013-04-15','10:55:00',2.9),('8348','2013-04-15','11:00:00',2.95),('8348','2013-04-15','11:05:00',3),('8348','2013-04-15','11:10:00',3.03),('8348','2013-04-15','11:15:00',3.07),('8348','2013-04-15','11:20:00',3.1),('8348','2013-04-15','11:25:00',3.13),('8348','2013-04-15','11:30:00',3.17),('8348','2013-04-15','11:35:00',3.19),('8348','2013-04-15','11:40:00',3.23),('8348','2013-04-15','11:45:00',3.25),('8348','2013-04-15','11:50:00',3.27),('8348','2013-04-15','11:55:00',3.29),('8348','2013-04-15','12:00:00',3.32),('8348','2013-04-15','12:05:00',3.34),('8348','2013-04-15','12:10:00',3.35),('8348','2013-04-15','12:15:00',3.38),('8348','2013-04-15','12:20:00',3.4),('8348','2013-04-15','12:25:00',3.41),('8348','2013-04-15','12:30:00',3.43),('8348','2013-04-15','12:35:00',3.46),('8348','2013-04-15','12:40:00',3.46),('8348','2013-04-15','12:45:00',3.45),('8348','2013-04-15','12:50:00',3.42),('8348','2013-04-15','12:55:00',3.46),('8348','2013-04-15','13:00:00',3.48),('8348','2013-04-15','13:05:00',3.51),('8348','2013-04-15','13:10:00',3.5),('8348','2013-04-15','13:15:00',3.5),('8348','2013-04-15','13:20:00',3.52),('8348','2013-04-15','13:25:00',3.53),('8348','2013-04-15','13:30:00',3.52),('8348','2013-04-15','13:35:00',3.52),('8348','2013-04-15','13:40:00',3.49),('8348','2013-04-15','13:45:00',3.48),('8348','2013-04-15','13:50:00',3.58),('8348','2013-04-15','13:55:00',3.63),('8348','2013-04-15','14:00:00',3.65),('8348','2013-04-15','14:05:00',3.66),('8348','2013-04-15','14:10:00',3.67),('8348','2013-04-15','14:15:00',3.67),('8348','2013-04-15','14:20:00',3.67),('8348','2013-04-15','14:25:00',3.64),('8348','2013-04-15','14:30:00',3.61),('8348','2013-04-15','14:35:00',3.59),('8348','2013-04-15','14:40:00',3.54),('8348','2013-04-15','14:45:00',3.53),('8348','2013-04-15','14:50:00',3.5),('8348','2013-04-15','14:55:00',3.48),('8348','2013-04-15','15:00:00',3.45),('8348','2013-04-15','15:05:00',3.42),('8348','2013-04-15','15:10:00',3.4),('8348','2013-04-15','15:15:00',3.36),('8348','2013-04-15','15:20:00',3.32),('8348','2013-04-15','15:25:00',3.27),('8348','2013-04-15','15:30:00',3.25),('8348','2013-04-15','15:35:00',3.21),('8348','2013-04-15','15:40:00',3.17),('8348','2013-04-15','15:45:00',3.12),('8348','2013-04-15','15:50:00',3.07),('8348','2013-04-15','15:55:00',3.03),('8348','2013-04-15','16:00:00',2.97),('8348','2013-04-15','16:05:00',2.91),('8348','2013-04-15','16:10:00',2.85),('8348','2013-04-15','16:15:00',2.8),('8348','2013-04-15','16:20:00',2.75),('8348','2013-04-15','16:25:00',2.69),('8348','2013-04-15','16:30:00',2.62),('8348','2013-04-15','16:35:00',2.56),('8348','2013-04-15','16:40:00',2.5),('8348','2013-04-15','16:45:00',2.43),('8348','2013-04-15','16:50:00',2.37),('8348','2013-04-15','16:55:00',2.3),('8348','2013-04-15','17:00:00',2.22),('8348','2013-04-15','17:05:00',2.15),('8348','2013-04-15','17:10:00',2.08),('8348','2013-04-15','17:15:00',2.01),('8348','2013-04-15','17:20:00',1.93),('8348','2013-04-15','17:25:00',1.86),('8348','2013-04-15','17:30:00',1.78),('8348','2013-04-15','17:35:00',1.7),('8348','2013-04-15','17:40:00',1.63),('8348','2013-04-15','17:45:00',1.55),('8348','2013-04-15','17:50:00',1.47),('8348','2013-04-15','17:55:00',1.4),('8348','2013-04-15','18:00:00',1.32),('8348','2013-04-15','18:05:00',1.24),('8348','2013-04-15','18:10:00',1.16),('8348','2013-04-15','18:15:00',1.08),('8348','2013-04-15','18:20:00',1),('8348','2013-04-14','08:30:00',1.02),('8348','2013-04-14','08:35:00',1.09),('8348','2013-04-14','08:40:00',1.13),('8348','2013-04-14','08:45:00',1.19),('8348','2013-04-14','08:50:00',1.28),('8348','2013-04-14','08:55:00',1.39),('8348','2013-04-14','09:00:00',1.47),('8348','2013-04-14','09:05:00',1.55),('8348','2013-04-14','09:10:00',1.64),('8348','2013-04-14','09:15:00',1.71),('8348','2013-04-14','09:20:00',1.78),('8348','2013-04-14','09:25:00',1.86),('8348','2013-04-14','09:30:00',1.92),('8348','2013-04-14','09:35:00',1.98),('8348','2013-04-14','09:40:00',2.06),('8348','2013-04-14','09:45:00',2.12),('8348','2013-04-14','09:50:00',2.18),('8348','2013-04-14','09:55:00',2.25),('8348','2013-04-14','10:00:00',2.3),('8348','2013-04-14','10:05:00',2.35),('8348','2013-04-14','10:10:00',2.41),('8348','2013-04-14','10:15:00',2.46),('8348','2013-04-14','10:20:00',2.51),('8348','2013-04-14','10:25:00',2.56),('8348','2013-04-14','10:30:00',2.6),('8348','2013-04-14','10:35:00',2.66),('8348','2013-04-14','10:40:00',2.7),('8348','2013-04-14','10:45:00',2.74),('8348','2013-04-14','10:50:00',2.79),('8348','2013-04-14','10:55:00',2.85),('8348','2013-04-14','11:00:00',2.89),('8348','2013-04-14','11:05:00',2.95),('8348','2013-04-14','11:10:00',2.97),('8348','2013-04-14','11:15:00',3.01),('8348','2013-04-14','11:20:00',3.05),('8348','2013-04-14','11:25:00',3.06),('8348','2013-04-14','11:30:00',3.09),('8348','2013-04-14','11:35:00',3.09),('8348','2013-04-14','11:40:00',3.18),('8348','2013-04-14','11:45:00',3.2),('8348','2013-04-14','11:50:00',3.22),('8348','2013-04-14','11:55:00',3.24),('8348','2013-04-14','12:00:00',3.25),('8348','2013-04-14','12:05:00',3.24),('8348','2013-04-14','12:10:00',3.28),('8348','2013-04-14','12:15:00',3.34),('8348','2013-04-14','12:20:00',3.35),('8348','2013-04-14','12:25:00',3.38),('8348','2013-04-14','12:30:00',3.38),('8348','2013-04-14','12:35:00',3.38),('8348','2013-04-14','12:40:00',3.39),('8348','2013-04-14','12:45:00',3.5),('8348','2013-04-14','12:50:00',3.53),('8348','2013-04-14','12:55:00',3.49),('8348','2013-04-14','13:00:00',3.21),('8348','2013-04-14','13:05:00',3.55),('8348','2013-04-14','13:10:00',3.54),('8348','2013-04-14','13:15:00',3.57),('8348','2013-04-14','13:20:00',3.61),('8348','2013-04-14','13:25:00',3.56),('8348','2013-04-14','13:30:00',3.54),('8348','2013-04-14','13:35:00',3.51),('8348','2013-04-14','13:40:00',3.5),('8348','2013-04-14','13:45:00',3.41),('8348','2013-04-14','13:50:00',3.46),('8348','2013-04-14','13:55:00',3.46),('8348','2013-04-14','14:00:00',3.45),('8348','2013-04-14','14:05:00',3.47),('8348','2013-04-14','14:10:00',3.46),('8348','2013-04-14','14:15:00',3.42),('8348','2013-04-14','14:20:00',3.38),('8348','2013-04-14','14:25:00',3.4),('8348','2013-04-14','14:30:00',3.41),('8348','2013-04-14','14:35:00',3.47),('8348','2013-04-14','14:40:00',3.49),('8348','2013-04-14','14:45:00',3.57),('8348','2013-04-14','14:50:00',3.52),('8348','2013-04-14','14:55:00',3.47),('8348','2013-04-14','15:00:00',3.39),('8348','2013-04-14','15:05:00',3.39),('8348','2013-04-14','15:10:00',3.43),('8348','2013-04-14','15:15:00',3.32),('8348','2013-04-14','15:20:00',3.23),('8348','2013-04-14','15:25:00',2.65),('8348','2013-04-14','15:30:00',2.95),('8348','2013-04-14','15:35:00',3.25),('8348','2013-04-14','15:40:00',3.26),('8348','2013-04-14','15:45:00',3.31),('8348','2013-04-14','15:50:00',3.17),('8348','2013-04-14','15:55:00',3.01),('8348','2013-04-14','16:00:00',2.62),('8348','2013-04-14','16:05:00',2.79),('8348','2013-04-14','16:10:00',2.82),('8348','2013-04-14','16:15:00',2.69),('8348','2013-04-14','16:20:00',2.62),('8348','2013-04-14','16:25:00',2.63),('8348','2013-04-14','16:30:00',2.56),('8348','2013-04-14','16:35:00',2.47),('8348','2013-04-14','16:40:00',2.4),('8348','2013-04-14','16:45:00',2.32),('8348','2013-04-14','16:50:00',2.27),('8348','2013-04-14','16:55:00',2.2),('8348','2013-04-14','17:00:00',2.11),('8348','2013-04-14','17:05:00',2.07),('8348','2013-04-14','17:10:00',2.01),('8348','2013-04-14','17:15:00',1.92),('8348','2013-04-14','17:20:00',1.85),('8348','2013-04-14','17:25:00',1.78),('8348','2013-04-14','17:30:00',1.71),('8348','2013-04-14','17:35:00',1.63),('8348','2013-04-14','17:40:00',1.55),('8348','2013-04-14','17:45:00',1.49),('8348','2013-04-14','17:50:00',1.41),('8348','2013-04-14','17:55:00',1.31),('8348','2013-04-14','18:00:00',1.23),('8348','2013-04-14','18:05:00',1.17),('8348','2013-04-14','18:10:00',1.09),('8348','2013-04-14','18:15:00',1.02),('8348','2013-04-13','08:55:00',1.19),('8348','2013-04-13','09:05:00',1.04),('8348','2013-04-13','09:10:00',1.01),('8348','2013-04-13','09:25:00',1.58),('8348','2013-04-13','09:30:00',1.94),('8348','2013-04-13','09:35:00',1.92),('8348','2013-04-13','09:40:00',1.83),('8348','2013-04-13','09:45:00',2.12),('8348','2013-04-13','09:50:00',2.16),('8348','2013-04-13','09:55:00',2.19),('8348','2013-04-13','10:00:00',2.29),('8348','2013-04-13','10:05:00',2.43),('8348','2013-04-13','10:10:00',2.56),('8348','2013-04-13','10:15:00',1.94),('8348','2013-04-13','10:20:00',2.08),('8348','2013-04-13','10:25:00',2.36),('8348','2013-04-13','10:30:00',2.87),('8348','2013-04-13','10:35:00',2.79),('8348','2013-04-13','10:40:00',2.95),('8348','2013-04-13','10:45:00',2.62),('8348','2013-04-13','10:50:00',2.45),('8348','2013-04-13','10:55:00',3.19),('8348','2013-04-13','11:00:00',1.76),('8348','2013-04-13','11:05:00',2.96),('8348','2013-04-13','11:10:00',2.08),('8348','2013-04-13','11:15:00',2.76),('8348','2013-04-13','11:20:00',2.64),('8348','2013-04-13','11:30:00',2.73),('8348','2013-04-13','11:35:00',3.53),('8348','2013-04-13','11:40:00',3.55),('8348','2013-04-13','11:45:00',3.67),('8348','2013-04-13','11:50:00',1.67),('8348','2013-04-13','11:55:00',3.72),('8348','2013-04-13','12:00:00',3.79),('8348','2013-04-13','12:05:00',3.69),('8348','2013-04-13','12:10:00',3.73),('8348','2013-04-13','12:15:00',3.63),('8348','2013-04-13','12:20:00',2.54),('8348','2013-04-13','12:25:00',3.51),('8348','2013-04-13','12:30:00',3.13),('8348','2013-04-13','12:35:00',3.76),('8348','2013-04-13','12:40:00',3.66),('8348','2013-04-13','12:45:00',3.65),('8348','2013-04-13','12:50:00',3.56),('8348','2013-04-13','12:55:00',3.57),('8348','2013-04-13','13:00:00',3.49),('8348','2013-04-13','13:05:00',3.68),('8348','2013-04-13','13:10:00',3.76),('8348','2013-04-13','13:15:00',3.67),('8348','2013-04-13','13:20:00',3.68),('8348','2013-04-13','13:25:00',3.72),('8348','2013-04-13','13:30:00',3.52),('8348','2013-04-13','13:35:00',3.09),('8348','2013-04-13','13:40:00',2.88),('8348','2013-04-13','13:45:00',3.12),('8348','2013-04-13','13:50:00',2.26),('8348','2013-04-13','13:55:00',1.86),('8348','2013-04-13','14:00:00',1.9),('8348','2013-04-13','14:05:00',2.14),('8348','2013-04-13','14:10:00',1.69),('8348','2013-04-13','14:15:00',2.39),('8348','2013-04-13','14:20:00',3.2),('8348','2013-04-13','14:25:00',3.31),('8348','2013-04-13','14:30:00',3.35),('8348','2013-04-13','14:35:00',3.41),('8348','2013-04-13','14:40:00',3.34),('8348','2013-04-13','14:45:00',3.37),('8348','2013-04-13','14:50:00',3.2),('8348','2013-04-13','14:55:00',3.28),('8348','2013-04-13','15:00:00',3.02),('8348','2013-04-13','15:05:00',2.76),('8348','2013-04-13','15:10:00',2.89),('8348','2013-04-13','15:15:00',2.47),('8348','2013-04-13','15:20:00',2.56),('8348','2013-04-13','15:25:00',2.45),('8348','2013-04-13','15:30:00',2.52),('8348','2013-04-13','15:35:00',2.45),('8348','2013-04-13','15:40:00',2.56),('8348','2013-04-13','15:45:00',2.61),('8348','2013-04-13','15:50:00',2.54),('8348','2013-04-13','15:55:00',2.52),('8348','2013-04-13','16:00:00',2.51),('8348','2013-04-13','16:05:00',2.36),('8348','2013-04-13','16:10:00',2.23),('8348','2013-04-13','16:15:00',2.3),('8348','2013-04-13','16:20:00',2.21),('8348','2013-04-13','16:25:00',2.05),('8348','2013-04-13','16:30:00',1.96),('8348','2013-04-13','16:35:00',1.82),('8348','2013-04-13','16:40:00',1.73),('8348','2013-04-13','16:45:00',1.66),('8348','2013-04-13','16:50:00',1.71),('8348','2013-04-13','16:55:00',1.4),('8348','2013-04-13','17:00:00',1.17),('8348','2013-04-13','17:05:00',1.15),('8348','2013-04-13','17:10:00',1.71),('8348','2013-04-13','17:15:00',1.91),('8348','2013-04-13','17:20:00',1.61),('8348','2013-04-13','17:25:00',1.85),('8348','2013-04-13','17:30:00',1.61),('8348','2013-04-13','17:35:00',1.64),('8348','2013-04-13','17:40:00',1.57),('8348','2013-04-13','17:45:00',1.42),('8348','2013-04-13','17:50:00',1.27),('8348','2013-04-13','17:55:00',1.38),('8348','2013-04-13','18:00:00',1.08),('8348','2013-04-13','18:05:00',1.07),('8348','2013-04-12','08:35:00',1.03),('8348','2013-04-12','08:55:00',1.4),('8348','2013-04-12','09:00:00',1.62),('8348','2013-04-12','09:05:00',1.3),('8348','2013-04-12','09:10:00',1.11),('8348','2013-04-12','09:15:00',1.72),('8348','2013-04-12','09:20:00',2.21),('8348','2013-04-12','09:25:00',1.98),('8348','2013-04-12','09:30:00',1.43),('8348','2013-04-12','09:35:00',1.16),('8348','2013-04-12','09:40:00',1.24),('8348','2013-04-12','09:45:00',1.68),('8348','2013-04-12','10:20:00',2.23),('8348','2013-04-12','10:25:00',2.5),('8348','2013-04-12','10:30:00',1.6),('8348','2013-04-12','10:35:00',2.5),('8348','2013-04-12','10:40:00',3.39),('8348','2013-04-12','10:45:00',3.44),('8348','2013-04-12','10:50:00',3.17),('8348','2013-04-12','10:55:00',1.32),('8348','2013-04-12','11:00:00',1.11),('8348','2013-04-12','11:05:00',1.6),('8348','2013-04-12','11:10:00',1.32),('8348','2013-04-12','11:15:00',3.49),('8348','2013-04-12','11:20:00',3.93),('8348','2013-04-12','11:25:00',3.76),('8348','2013-04-12','11:30:00',3.94),('8348','2013-04-12','11:35:00',3.34),('8348','2013-04-12','11:40:00',1.47),('8348','2013-04-12','11:45:00',1.99),('8348','2013-04-12','11:50:00',1.88),('8348','2013-04-12','11:55:00',3.04),('8348','2013-04-12','12:00:00',3.82),('8348','2013-04-12','12:05:00',3.65),('8348','2013-04-12','12:10:00',3.55),('8348','2013-04-12','12:15:00',3.62),('8348','2013-04-12','12:20:00',3.72),('8348','2013-04-12','12:25:00',3.73),('8348','2013-04-12','12:30:00',3.21),('8348','2013-04-12','12:35:00',3.65),('8348','2013-04-12','12:40:00',3.53),('8348','2013-04-12','12:45:00',3.56),('8348','2013-04-12','12:50:00',3.15),('8348','2013-04-12','12:55:00',2.64),('8348','2013-04-12','13:00:00',3.68),('8348','2013-04-12','13:05:00',3.73),('8348','2013-04-12','13:10:00',3.71),('8348','2013-04-12','13:15:00',3.73),('8348','2013-04-12','13:20:00',3.74),('8348','2013-04-12','13:25:00',3.72),('8348','2013-04-12','13:30:00',3.7),('8348','2013-04-12','13:35:00',3.72),('8348','2013-04-12','13:40:00',3.65),('8348','2013-04-12','13:45:00',3.68),('8348','2013-04-12','13:50:00',3.66),('8348','2013-04-12','13:55:00',3.67),('8348','2013-04-12','14:00:00',3.69),('8348','2013-04-12','14:05:00',3.68),('8348','2013-04-12','14:10:00',3.65),('8348','2013-04-12','14:15:00',3.62),('8348','2013-04-12','14:20:00',3.58),('8348','2013-04-12','14:25:00',3.56),('8348','2013-04-12','14:30:00',3.55),('8348','2013-04-12','14:35:00',3.53),('8348','2013-04-12','14:40:00',3.49),('8348','2013-04-12','14:45:00',3.47),('8348','2013-04-12','14:50:00',3.45),('8348','2013-04-12','14:55:00',3.41),('8348','2013-04-12','15:00:00',3.38),('8348','2013-04-12','15:05:00',3.34),('8348','2013-04-12','15:10:00',3.3),('8348','2013-04-12','15:15:00',3.24),('8348','2013-04-12','15:20:00',3.22),('8348','2013-04-12','15:25:00',3.19),('8348','2013-04-12','15:30:00',3.15),('8348','2013-04-12','15:35:00',3.1),('8348','2013-04-12','15:40:00',3.07),('8348','2013-04-12','15:45:00',3.06),('8348','2013-04-12','15:50:00',3.03),('8348','2013-04-12','15:55:00',2.97),('8348','2013-04-12','16:00:00',2.94),('8348','2013-04-12','16:05:00',2.89),('8348','2013-04-12','16:10:00',2.88),('8348','2013-04-12','16:15:00',2.51),('8348','2013-04-12','16:20:00',2.7),('8348','2013-04-12','16:25:00',2.68),('8348','2013-04-12','16:30:00',1.59),('8348','2013-04-12','16:35:00',1.29),('8348','2013-04-12','16:40:00',1.6),('8348','2013-04-12','16:45:00',2.5),('8348','2013-04-12','16:50:00',2.34),('8348','2013-04-12','16:55:00',2.28),('8348','2013-04-12','17:00:00',2.2),('8348','2013-04-12','17:05:00',2.12),('8348','2013-04-12','17:10:00',2.03),('8348','2013-04-12','17:15:00',1.96),('8348','2013-04-12','17:20:00',1.88),('8348','2013-04-12','17:25:00',1.81),('8348','2013-04-12','17:30:00',1.78),('8348','2013-04-12','17:35:00',1.68),('8348','2013-04-12','17:40:00',1.59),('8348','2013-04-12','17:45:00',1.47),('8348','2013-04-12','17:50:00',1.41),('8348','2013-04-12','17:55:00',1.34),('8348','2013-04-12','18:00:00',1.26),('8348','2013-04-12','18:05:00',1.18),('8348','2013-04-12','18:10:00',1.07),('8348','2014-03-28','07:15:00',1.02),('8348','2014-03-28','07:20:00',1.07),('8348','2014-03-28','07:25:00',1.11),('8348','2014-03-28','07:30:00',1.19),('8348','2014-03-28','07:35:00',1.31),('8348','2014-03-28','07:40:00',1.4),('8348','2014-03-28','07:45:00',1.72),('8348','2014-03-28','07:50:00',1.82),('8348','2014-03-28','07:55:00',1.91),('8348','2014-03-28','08:00:00',2),('8348','2014-03-28','08:05:00',2.14),('8348','2014-03-28','08:10:00',2.27),('8348','2014-03-28','08:15:00',2.41),('8348','2014-03-28','08:20:00',2.55),('8348','2014-03-28','08:25:00',2.7),('8348','2014-03-28','08:30:00',3.1),('8348','2014-03-28','08:35:00',3.32),('8348','2014-03-28','08:40:00',3.5),('8348','2014-03-28','08:45:00',3.65),('8348','2014-03-28','08:50:00',3.87),('8348','2014-03-28','08:55:00',4.05),('8348','2014-03-28','09:00:00',4.17),('8348','2014-03-28','09:05:00',4.51),('8348','2014-03-28','09:10:00',4.77),('8348','2014-03-28','09:15:00',4.71),('8348','2014-03-28','09:20:00',4.33),('8348','2014-03-28','09:25:00',5.29),('8348','2014-03-28','09:30:00',5.48),('8348','2014-03-28','09:35:00',4.7),('8348','2014-03-28','09:40:00',3.05),('8348','2014-03-28','09:45:00',2.7),('8348','2014-03-28','09:50:00',3.91),('8348','2014-03-28','09:55:00',5.63),('8348','2014-03-28','10:00:00',5.8),('8348','2014-03-28','10:05:00',5.84),('8348','2014-03-28','10:10:00',4.87),('8348','2014-03-28','10:15:00',4.33),('8348','2014-03-28','10:20:00',4.03),('8348','2014-03-28','10:25:00',5.93),('8348','2014-03-28','10:30:00',6.01),('8348','2014-03-28','10:35:00',5.86),('8348','2014-03-28','10:40:00',5.55),('8348','2014-03-28','10:45:00',4.39),('8348','2014-03-28','10:50:00',6.51),('8348','2014-03-28','10:55:00',6.53),('8348','2014-03-28','11:00:00',6.06),('8348','2014-03-28','11:05:00',5.62),('8348','2014-03-28','11:10:00',5.04),('8348','2014-03-28','11:15:00',4.71),('8348','2014-03-28','11:20:00',3.43),('8348','2014-03-28','11:25:00',4.21),('8348','2014-03-28','11:30:00',4.73),('8348','2014-03-28','11:35:00',2.84),('8348','2014-03-28','11:40:00',2.56),('8348','2014-03-28','11:45:00',5.87),('8348','2014-03-28','11:50:00',2.78),('8348','2014-03-28','11:55:00',2.19),('8348','2014-03-28','12:00:00',3.31),('8348','2014-03-28','12:05:00',7.66),('8348','2014-03-28','12:10:00',7.66),('8348','2014-03-28','12:15:00',8.05),('8348','2014-03-28','12:20:00',6.02),('8348','2014-03-28','12:25:00',2.19),('8348','2014-03-28','12:30:00',1.71),('8348','2014-03-28','12:35:00',7.03),('8348','2014-03-28','12:40:00',6.87),('8348','2014-03-28','12:45:00',7.41),('8348','2014-03-28','12:50:00',7.54),('8348','2014-03-28','12:55:00',8.1),('8348','2014-03-28','13:00:00',8.42),('8348','2014-03-28','13:05:00',2.69),('8348','2014-03-28','13:10:00',2.57),('8348','2014-03-28','13:15:00',4.32),('8348','2014-03-28','13:20:00',4.55),('8348','2014-03-28','13:25:00',2.59),('8348','2014-03-28','13:30:00',2.94),('8348','2014-03-28','13:35:00',5.6),('8348','2014-03-28','13:40:00',7.75),('8348','2014-03-28','13:45:00',7.21),('8348','2014-03-28','13:50:00',6.9),('8348','2014-03-28','13:55:00',6.71),('8348','2014-03-28','14:00:00',6.82),('8348','2014-03-28','14:05:00',6.73),('8348','2014-03-28','14:10:00',6.53),('8348','2014-03-28','14:15:00',6.55),('8348','2014-03-28','14:20:00',6.48),('8348','2014-03-28','14:25:00',6.41),('8348','2014-03-28','14:30:00',6.34),('8348','2014-03-28','14:35:00',6.27),('8348','2014-03-28','14:40:00',6.21),('8348','2014-03-28','14:45:00',6.12),('8348','2014-03-28','14:50:00',6.07),('8348','2014-03-28','14:55:00',5.97),('8348','2014-03-28','15:00:00',5.91),('8348','2014-03-28','15:05:00',5.79),('8348','2014-03-28','15:10:00',5.64),('8348','2014-03-28','15:15:00',5.51),('8348','2014-03-28','15:20:00',5.37),('8348','2014-03-28','15:25:00',5.25),('8348','2014-03-28','15:30:00',5.16),('8348','2014-03-28','15:35:00',5.06),('8348','2014-03-28','15:40:00',4.95),('8348','2014-03-28','15:45:00',4.97),('8348','2014-03-28','15:50:00',4.88),('8348','2014-03-28','15:55:00',4.79),('8348','2014-03-28','16:00:00',4.9),('8348','2014-03-28','16:05:00',5),('8348','2014-03-28','16:10:00',4.82),('8348','2014-03-28','16:15:00',4.57),('8348','2014-03-28','16:20:00',3.91),('8348','2014-03-28','16:25:00',3.56),('8348','2014-03-28','16:30:00',3.31),('8348','2014-03-28','16:35:00',2.06),('8348','2014-03-28','16:40:00',1.37),('8348','2014-03-28','16:45:00',2.27),('8348','2014-03-28','16:50:00',2.15),('8348','2014-03-28','17:00:00',1.6),('8348','2014-03-28','17:05:00',1.87),('8348','2014-03-28','17:10:00',1.94),('8348','2014-03-28','17:15:00',1.96),('8348','2014-03-28','17:20:00',1.96),('8348','2014-03-28','17:35:00',1.06),('8348','2014-03-28','17:40:00',1.02),('8348','2014-03-28','17:45:00',1.06),('8348','2013-04-11','08:35:00',1.05),('8348','2013-04-11','08:40:00',1.12),('8348','2013-04-11','08:45:00',1.19),('8348','2013-04-11','08:50:00',1.24),('8348','2013-04-11','08:55:00',1.35),('8348','2013-04-11','09:00:00',1.41),('8348','2013-04-11','09:05:00',1.5),('8348','2013-04-11','09:10:00',1.59),('8348','2013-04-11','09:15:00',1.68),('8348','2013-04-11','09:20:00',1.75),('8348','2013-04-11','09:25:00',1.8),('8348','2013-04-11','09:30:00',1.85),('8348','2013-04-11','09:35:00',1.93),('8348','2013-04-11','09:40:00',1.94),('8348','2013-04-11','09:45:00',2.15),('8348','2013-04-11','09:50:00',1.68),('8348','2013-04-11','09:55:00',1.38),('8348','2013-04-11','10:00:00',1.84),('8348','2013-04-11','10:05:00',2.28),('8348','2013-04-11','10:10:00',1.64),('8348','2013-04-11','10:15:00',2.51),('8348','2013-04-11','10:20:00',2.58),('8348','2013-04-11','10:25:00',2.77),('8348','2013-04-11','10:30:00',2.92),('8348','2013-04-11','10:35:00',2.78),('8348','2013-04-11','10:40:00',2.8),('8348','2013-04-11','10:45:00',1.94),('8348','2013-04-11','10:50:00',1.11),('8348','2013-04-11','11:05:00',3.13),('8348','2013-04-11','11:10:00',3.37),('8348','2013-04-11','11:15:00',3.23),('8348','2013-04-11','11:20:00',1.63),('8348','2013-04-11','11:25:00',3.05),('8348','2013-04-11','11:30:00',3.53),('8348','2013-04-11','11:35:00',1.62),('8348','2013-04-11','11:40:00',1.08),('8348','2013-04-11','11:45:00',1),('8348','2013-04-11','11:50:00',1.1),('8348','2013-04-11','11:55:00',3.68),('8348','2013-04-11','12:00:00',3.64),('8348','2013-04-11','12:05:00',3.85),('8348','2013-04-11','12:10:00',2.73),('8348','2013-04-11','12:15:00',1.68),('8348','2013-04-11','12:20:00',2.2),('8348','2013-04-11','12:25:00',3.9),('8348','2013-04-11','12:30:00',3.35),('8348','2013-04-11','12:35:00',1.39),('8348','2013-04-11','12:40:00',4.02),('8348','2013-04-11','12:45:00',3.89),('8348','2013-04-11','12:50:00',3.47),('8348','2013-04-11','12:55:00',3.03),('8348','2013-04-11','13:00:00',3.77),('8348','2013-04-11','13:05:00',3.05),('8348','2013-04-11','13:10:00',3.86),('8348','2013-04-11','13:15:00',3.69),('8348','2013-04-11','13:20:00',3.27),('8348','2013-04-11','13:25:00',3.83),('8348','2013-04-11','13:30:00',3.76),('8348','2013-04-11','13:35:00',3.49),('8348','2013-04-11','13:40:00',3.76),('8348','2013-04-11','13:45:00',3.68),('8348','2013-04-11','13:50:00',3.67),('8348','2013-04-11','13:55:00',3.75),('8348','2013-04-11','14:00:00',3.71),('8348','2013-04-11','14:05:00',3.75),('8348','2013-04-11','14:10:00',3.77),('8348','2013-04-11','14:15:00',3.74),('8348','2013-04-11','14:20:00',3.72),('8348','2013-04-11','14:25:00',3.64),('8348','2013-04-11','14:30:00',3.62),('8348','2013-04-11','14:35:00',3.38),('8348','2013-04-11','14:40:00',3.71),('8348','2013-04-11','14:45:00',3.62),('8348','2013-04-11','14:50:00',3.57),('8348','2013-04-11','14:55:00',3.55),('8348','2013-04-11','15:00:00',3.48),('8348','2013-04-11','15:05:00',3.41),('8348','2013-04-11','15:10:00',3.39),('8348','2013-04-11','15:15:00',3.37),('8348','2013-04-11','15:20:00',3.34),('8348','2013-04-11','15:25:00',3.3),('8348','2013-04-11','15:30:00',3.24),('8348','2013-04-11','15:35:00',3.21),('8348','2013-04-11','15:40:00',3.16),('8348','2013-04-11','15:45:00',3.11),('8348','2013-04-11','15:50:00',3.07),('8348','2013-04-11','15:55:00',3.03),('8348','2013-04-11','16:00:00',2.98),('8348','2013-04-11','16:05:00',2.93),('8348','2013-04-11','16:10:00',2.88),('8348','2013-04-11','16:15:00',2.82),('8348','2013-04-11','16:20:00',2.77),('8348','2013-04-11','16:25:00',2.71),('8348','2013-04-11','16:30:00',2.66),('8348','2013-04-11','16:35:00',2.59),('8348','2013-04-11','16:40:00',2.52),('8348','2013-04-11','16:45:00',2.47),('8348','2013-04-11','16:50:00',2.39),('8348','2013-04-11','16:55:00',2.34),('8348','2013-04-11','17:00:00',2.24),('8348','2013-04-11','17:05:00',2.17),('8348','2013-04-11','17:10:00',2.09),('8348','2013-04-11','17:15:00',2.03),('8348','2013-04-11','17:20:00',1.94),('8348','2013-04-11','17:25:00',1.86),('8348','2013-04-11','17:30:00',1.8),('8348','2013-04-11','17:35:00',1.73),('8348','2013-04-11','17:40:00',1.66),('8348','2013-04-11','17:45:00',1.57),('8348','2013-04-11','17:50:00',1.49),('8348','2013-04-11','17:55:00',1.39),('8348','2013-04-11','18:00:00',1.26),('8348','2013-04-11','18:05:00',1.17),('8348','2013-04-11','18:10:00',1.03),('8348','2013-04-11','18:15:00',1.05),('8348','2013-04-11','18:20:00',1.03),('8348','2013-04-10','08:55:00',1.28),('8348','2013-04-10','09:00:00',1.42),('8348','2013-04-10','09:05:00',1.54),('8348','2013-04-10','09:10:00',1.66),('8348','2013-04-10','09:15:00',1.75),('8348','2013-04-10','09:20:00',1.77),('8348','2013-04-10','09:25:00',1.77),('8348','2013-04-10','09:30:00',1.86),('8348','2013-04-10','09:35:00',1.99),('8348','2013-04-10','09:40:00',2.08),('8348','2013-04-10','09:45:00',2.11),('8348','2013-04-10','09:50:00',2.24),('8348','2013-04-10','09:55:00',2.33),('8348','2013-04-10','10:00:00',2.38),('8348','2013-04-10','10:05:00',2.52),('8348','2013-04-10','10:10:00',2.67),('8348','2013-04-10','10:15:00',2.74),('8348','2013-04-10','10:20:00',2.79),('8348','2013-04-10','10:25:00',2.83),('8348','2013-04-10','10:30:00',2.86),('8348','2013-04-10','10:35:00',2.9),('8348','2013-04-10','10:40:00',2.83),('8348','2013-04-10','10:45:00',3.04),('8348','2013-04-10','10:50:00',2.86),('8348','2013-04-10','10:55:00',2.87),('8348','2013-04-10','11:00:00',2.83),('8348','2013-04-10','11:05:00',2.92),('8348','2013-04-10','11:10:00',3.03),('8348','2013-04-10','11:15:00',3.02),('8348','2013-04-10','11:20:00',3.15),('8348','2013-04-10','11:25:00',3.29),('8348','2013-04-10','11:30:00',3.29),('8348','2013-04-10','11:35:00',3.36),('8348','2013-04-10','11:40:00',3.4),('8348','2013-04-10','11:45:00',3.4),('8348','2013-04-10','11:50:00',3.47),('8348','2013-04-10','11:55:00',3.52),('8348','2013-04-10','12:00:00',3.57),('8348','2013-04-10','12:05:00',3.64),('8348','2013-04-10','12:10:00',3.66),('8348','2013-04-10','12:15:00',3.73),('8348','2013-04-10','12:20:00',3.75),('8348','2013-04-10','12:25:00',3.79),('8348','2013-04-10','12:30:00',3.84),('8348','2013-04-10','12:35:00',3.73),('8348','2013-04-10','12:40:00',3.81),('8348','2013-04-10','12:45:00',3.8),('8348','2013-04-10','12:50:00',3.57),('8348','2013-04-10','12:55:00',3.27),('8348','2013-04-10','13:00:00',3.71),('8348','2013-04-10','13:05:00',2.11),('8348','2013-04-10','13:10:00',1.53),('8348','2013-04-10','13:15:00',2.19),('8348','2013-04-10','13:20:00',3.37),('8348','2013-04-10','13:25:00',3.96),('8348','2013-04-10','13:30:00',3.26),('8348','2013-04-10','13:35:00',4.3),('8348','2013-04-10','13:40:00',2.5),('8348','2013-04-10','13:45:00',2.43),('8348','2013-04-10','13:50:00',3.86),('8348','2013-04-10','13:55:00',3.66),('8348','2013-04-10','14:00:00',3.87),('8348','2013-04-10','14:05:00',3.83),('8348','2013-04-10','14:10:00',3.84),('8348','2013-04-10','14:15:00',3.77),('8348','2013-04-10','14:20:00',3.77),('8348','2013-04-10','14:25:00',3.82),('8348','2013-04-10','14:30:00',3.83),('8348','2013-04-10','14:35:00',3.75),('8348','2013-04-10','14:40:00',3.74),('8348','2013-04-10','14:45:00',3.8),('8348','2013-04-10','14:50:00',3.79),('8348','2013-04-10','14:55:00',3.67),('8348','2013-04-10','15:00:00',2.99),('8348','2013-04-10','15:05:00',3.74),('8348','2013-04-10','15:10:00',3.32),('8348','2013-04-10','15:15:00',3.45),('8348','2013-04-10','15:20:00',3.63),('8348','2013-04-10','15:25:00',3.4),('8348','2013-04-10','15:30:00',3.29),('8348','2013-04-10','15:35:00',3.26),('8348','2013-04-10','15:40:00',2.53),('8348','2013-04-10','15:45:00',3.2),('8348','2013-04-10','15:50:00',3.2),('8348','2013-04-10','15:55:00',2.92),('8348','2013-04-10','16:00:00',2.62),('8348','2013-04-10','16:05:00',3),('8348','2013-04-10','16:10:00',2.98),('8348','2013-04-10','16:15:00',2.24),('8348','2013-04-10','16:20:00',2.37),('8348','2013-04-10','16:25:00',2.85),('8348','2013-04-10','16:30:00',1.7),('8348','2013-04-10','16:35:00',1.62),('8348','2013-04-10','16:40:00',2.56),('8348','2013-04-10','16:45:00',2.42),('8348','2013-04-10','16:50:00',2.04),('8348','2013-04-10','16:55:00',2.09),('8348','2013-04-10','17:00:00',2.26),('8348','2013-04-10','17:05:00',1.48),('8348','2013-04-10','17:10:00',1.79),('8348','2013-04-10','17:15:00',2.24),('8348','2013-04-10','17:20:00',2.07),('8348','2013-04-10','17:25:00',1.95),('8348','2013-04-10','17:30:00',1.8),('8348','2013-04-10','17:35:00',1.73),('8348','2013-04-10','17:45:00',1.6),('8348','2013-04-10','17:55:00',1.36),('8348','2013-04-10','18:05:00',1.06),('8348','2013-04-10','18:10:00',1.01),('8348','2013-04-09','09:45:00',1.07),('8348','2013-04-09','09:50:00',2.25),('8348','2013-04-09','09:55:00',2.36),('8348','2013-04-09','10:00:00',1.46),('8348','2013-04-09','10:10:00',1.24),('8348','2013-04-09','10:15:00',2.14),('8348','2013-04-09','10:20:00',1.18),('8348','2013-04-09','10:30:00',1.1),('8348','2013-04-09','10:35:00',2.42),('8348','2013-04-09','10:40:00',2.16),('8348','2013-04-09','10:45:00',2.74),('8348','2013-04-09','10:50:00',3.52),('8348','2013-04-09','10:55:00',2.72),('8348','2013-04-09','11:00:00',3.15),('8348','2013-04-09','11:05:00',3.44),('8348','2013-04-09','11:10:00',3.25),('8348','2013-04-09','11:15:00',1.25),('8348','2013-04-09','11:20:00',1.37),('8348','2013-04-09','11:25:00',3.61),('8348','2013-04-09','11:30:00',3.55),('8348','2013-04-09','11:35:00',1.8),('8348','2013-04-09','11:45:00',3),('8348','2013-04-09','11:50:00',3.92),('8348','2013-04-09','11:55:00',2.97),('8348','2013-04-09','12:00:00',3.97),('8348','2013-04-09','12:05:00',3.9),('8348','2013-04-09','12:10:00',3.95),('8348','2013-04-09','12:15:00',3.97),('8348','2013-04-09','12:20:00',2.44),('8348','2013-04-09','12:25:00',3.78),('8348','2013-04-09','12:30:00',3.73),('8348','2013-04-09','12:35:00',3.55),('8348','2013-04-09','12:40:00',3.94),('8348','2013-04-09','12:45:00',3.57),('8348','2013-04-09','12:50:00',4.09),('8348','2013-04-09','12:55:00',3.97),('8348','2013-04-09','13:00:00',4),('8348','2013-04-09','13:05:00',4.23),('8348','2013-04-09','13:10:00',4.33),('8348','2013-04-09','13:15:00',3.89),('8348','2013-04-09','13:20:00',3.26),('8348','2013-04-09','13:25:00',4.07),('8348','2013-04-09','13:30:00',2.62),('8348','2013-04-09','13:35:00',1.81),('8348','2013-04-09','13:40:00',1.57),('8348','2013-04-09','13:45:00',1.44),('8348','2013-04-09','13:50:00',3.76),('8348','2013-04-09','13:55:00',3.84),('8348','2013-04-09','14:00:00',3.59),('8348','2013-04-09','14:05:00',2.81),('8348','2013-04-09','14:10:00',3.2),('8348','2013-04-09','14:15:00',3.6),('8348','2013-04-09','14:20:00',1.62),('8348','2013-04-09','14:25:00',3.25),('8348','2013-04-09','14:30:00',3.61),('8348','2013-04-09','14:35:00',3.44),('8348','2013-04-09','14:40:00',3.53),('8348','2013-04-09','14:45:00',3.28),('8348','2013-04-09','14:50:00',3.19),('8348','2013-04-09','14:55:00',2.79),('8348','2013-04-09','15:00:00',2.68),('8348','2013-04-09','15:05:00',3.53),('8348','2013-04-09','15:10:00',3.58),('8348','2013-04-09','15:15:00',2.84),('8348','2013-04-09','15:20:00',3.57),('8348','2013-04-09','15:25:00',3.57),('8348','2013-04-09','15:30:00',2.67),('8348','2013-04-09','15:35:00',3.13),('8348','2013-04-09','15:40:00',3.43),('8348','2013-04-09','15:45:00',2.99),('8348','2013-04-09','15:50:00',3.23),('8348','2013-04-09','15:55:00',2.71),('8348','2013-04-09','16:00:00',2.57),('8348','2013-04-09','16:05:00',2.6),('8348','2013-04-09','16:10:00',2.56),('8348','2013-04-09','16:15:00',2.72),('8348','2013-04-09','16:20:00',1.18),('8348','2013-04-09','16:35:00',1.26),('8348','2013-04-09','16:40:00',1.25),('8348','2013-04-09','16:50:00',2.37),('8348','2013-04-09','16:55:00',1.94),('8348','2013-04-09','17:30:00',1.11),('8348','2013-04-08','08:45:00',1),('8348','2013-04-08','08:50:00',1.09),('8348','2013-04-08','09:00:00',1.1),('8348','2013-04-08','09:05:00',1.1),('8348','2013-04-08','09:10:00',1.47),('8348','2013-04-08','09:15:00',1.89),('8348','2013-04-08','09:20:00',1.97),('8348','2013-04-08','09:25:00',1.91),('8348','2013-04-08','09:30:00',1.96),('8348','2013-04-08','09:35:00',2.13),('8348','2013-04-08','09:40:00',2.19),('8348','2013-04-08','09:45:00',2.26),('8348','2013-04-08','09:50:00',1.39),('8348','2013-04-08','09:55:00',1.42),('8348','2013-04-08','10:00:00',2.4),('8348','2013-04-08','10:05:00',2.55),('8348','2013-04-08','10:10:00',2.4),('8348','2013-04-08','10:15:00',2.55),('8348','2013-04-08','10:20:00',2.56),('8348','2013-04-08','10:25:00',2.58),('8348','2013-04-08','10:30:00',2.62),('8348','2013-04-08','10:35:00',2.51),('8348','2013-04-08','10:40:00',2.77),('8348','2013-04-08','10:45:00',2.95),('8348','2013-04-08','10:50:00',3),('8348','2013-04-08','10:55:00',2.87),('8348','2013-04-08','11:00:00',3.06),('8348','2013-04-08','11:05:00',2.66),('8348','2013-04-08','11:10:00',2.51),('8348','2013-04-08','11:15:00',2.4),('8348','2013-04-08','11:20:00',2.01),('8348','2013-04-08','11:25:00',1.76),('8348','2013-04-08','11:30:00',2),('8348','2013-04-08','11:35:00',2.57),('8348','2013-04-08','11:40:00',2.73),('8348','2013-04-08','11:45:00',2.48),('8348','2013-04-08','11:50:00',2.31),('8348','2013-04-08','11:55:00',2.06),('8348','2013-04-08','12:00:00',1.97),('8348','2013-04-08','12:05:00',1.89),('8348','2013-04-08','12:10:00',2.03),('8348','2013-04-08','12:15:00',2.38),('8348','2013-04-08','12:20:00',2.38),('8348','2013-04-08','12:25:00',2.4),('8348','2013-04-08','12:30:00',2.65),('8348','2013-04-08','12:35:00',2.53),('8348','2013-04-08','12:40:00',2.18),('8348','2013-04-08','12:45:00',2.96),('8348','2013-04-08','12:50:00',2.84),('8348','2013-04-08','12:55:00',2.6),('8348','2013-04-08','13:00:00',1.67),('8348','2013-04-08','13:05:00',2.33),('8348','2013-04-08','13:10:00',2.52),('8348','2013-04-08','13:15:00',2.63),('8348','2013-04-08','13:20:00',3.34),('8348','2013-04-08','13:25:00',2.87),('8348','2013-04-08','13:30:00',2.53),('8348','2013-04-08','13:35:00',2.38),('8348','2013-04-08','13:40:00',2.21),('8348','2013-04-08','13:45:00',2.8),('8348','2013-04-08','13:50:00',2.81),('8348','2013-04-08','13:55:00',3.54),('8348','2013-04-08','14:00:00',3.34),('8348','2013-04-08','14:05:00',2.91),('8348','2013-04-08','14:10:00',3.02),('8348','2013-04-08','14:15:00',3.45),('8348','2013-04-08','14:20:00',3.06),('8348','2013-04-08','14:25:00',3.61),('8348','2013-04-08','14:30:00',3.51),('8348','2013-04-08','14:35:00',3.29),('8348','2013-04-08','14:40:00',3.27),('8348','2013-04-08','14:45:00',3.32),('8348','2013-04-08','14:50:00',3.32),('8348','2013-04-08','14:55:00',3.45),('8348','2013-04-08','15:00:00',2.66),('8348','2013-04-08','15:05:00',2.67),('8348','2013-04-08','15:10:00',2.66),('8348','2013-04-08','15:15:00',2.75),('8348','2013-04-08','15:20:00',2.52),('8348','2013-04-08','15:25:00',3.26),('8348','2013-04-08','15:30:00',3.35),('8348','2013-04-08','15:35:00',3.22),('8348','2013-04-08','15:40:00',3.15),('8348','2013-04-08','15:45:00',3.09),('8348','2013-04-08','15:50:00',3.09),('8348','2013-04-08','15:55:00',3.01),('8348','2013-04-08','16:00:00',2.96),('8348','2013-04-08','16:05:00',2.81),('8348','2013-04-08','16:10:00',2.65),('8348','2013-04-08','16:15:00',2.79),('8348','2013-04-08','16:20:00',2.81),('8348','2013-04-08','16:25:00',2.69),('8348','2013-04-08','16:30:00',2.63),('8348','2013-04-08','16:35:00',2.55),('8348','2013-04-08','16:40:00',2.51),('8348','2013-04-08','16:45:00',2.46),('8348','2013-04-08','16:50:00',2.41),('8348','2013-04-08','16:55:00',2.33),('8348','2013-04-08','17:00:00',2.27),('8348','2013-04-08','17:05:00',2.21),('8348','2013-04-08','17:10:00',2.08),('8348','2013-04-08','17:15:00',2.02),('8348','2013-04-08','17:20:00',1.9),('8348','2013-04-08','17:25:00',1.95),('8348','2013-04-08','17:30:00',1.81),('8348','2013-04-08','17:35:00',1.7),('8348','2013-04-08','17:40:00',1.54),('8348','2013-04-08','17:45:00',1.47),('8348','2013-04-08','17:50:00',1.2),('8348','2013-04-08','17:55:00',1.04),('8348','2013-04-08','18:00:00',1.12),('8348','2013-04-08','18:20:00',1.28),('8348','2013-04-08','18:25:00',1.15),('8348','2013-04-07','09:05:00',1.03),('8348','2013-04-07','09:10:00',1.11),('8348','2013-04-07','09:15:00',1.16),('8348','2013-04-07','09:20:00',1.23),('8348','2013-04-07','09:25:00',1.25),('8348','2013-04-07','09:30:00',1.18),('8348','2013-04-07','09:35:00',1.13),('8348','2013-04-07','09:40:00',1.13),('8348','2013-04-07','09:45:00',1.32),('8348','2013-04-07','09:50:00',1.61),('8348','2013-04-07','09:55:00',1.73),('8348','2013-04-07','10:00:00',2.02),('8348','2013-04-07','10:05:00',2.17),('8348','2013-04-07','10:10:00',2.15),('8348','2013-04-07','10:15:00',2.23),('8348','2013-04-07','10:20:00',2.28),('8348','2013-04-07','10:25:00',2.37),('8348','2013-04-07','10:30:00',2.07),('8348','2013-04-07','10:35:00',2.18),('8348','2013-04-07','10:40:00',2.25),('8348','2013-04-07','10:45:00',2.19),('8348','2013-04-07','10:50:00',2.19),('8348','2013-04-07','10:55:00',1.97),('8348','2013-04-07','11:00:00',1.79),('8348','2013-04-07','11:05:00',1.6),('8348','2013-04-07','11:10:00',1.75),('8348','2013-04-07','11:15:00',2.34),('8348','2013-04-07','11:20:00',2.89),('8348','2013-04-07','11:25:00',3.16),('8348','2013-04-07','11:30:00',3.15),('8348','2013-04-07','11:35:00',2.96),('8348','2013-04-07','11:40:00',2.73),('8348','2013-04-07','11:45:00',2.21),('8348','2013-04-07','11:50:00',1.98),('8348','2013-04-07','11:55:00',2.11),('8348','2013-04-07','12:00:00',2.13),('8348','2013-04-07','12:05:00',2.15),('8348','2013-04-07','12:10:00',2.32),('8348','2013-04-07','12:15:00',2.29),('8348','2013-04-07','12:20:00',2.39),('8348','2013-04-07','12:25:00',2.69),('8348','2013-04-07','12:30:00',2.5),('8348','2013-04-07','12:35:00',2.52),('8348','2013-04-07','12:40:00',2.54),('8348','2013-04-07','12:45:00',2.16),('8348','2013-04-07','12:50:00',2.33),('8348','2013-04-07','12:55:00',2.32),('8348','2013-04-07','13:00:00',2.76),('8348','2013-04-07','13:05:00',3.1),('8348','2013-04-07','13:10:00',2.95),('8348','2013-04-07','13:15:00',2.68),('8348','2013-04-07','13:20:00',2.53),('8348','2013-04-07','13:25:00',2.85),('8348','2013-04-07','13:30:00',2.67),('8348','2013-04-07','13:35:00',2.66),('8348','2013-04-07','13:40:00',2.95),('8348','2013-04-07','13:45:00',2.94),('8348','2013-04-07','13:50:00',2.62),('8348','2013-04-07','13:55:00',2.49),('8348','2013-04-07','14:00:00',3.24),('8348','2013-04-07','14:05:00',3.03),('8348','2013-04-07','14:10:00',1.63),('8348','2013-04-07','14:15:00',2.32),('8348','2013-04-07','14:20:00',2.14),('8348','2013-04-07','14:25:00',1.81),('8348','2013-04-07','14:30:00',1.52),('8348','2013-04-07','14:35:00',1.96),('8348','2013-04-07','14:40:00',1.84),('8348','2013-04-07','14:45:00',1.91),('8348','2013-04-07','14:50:00',2.07),('8348','2013-04-07','14:55:00',1.98),('8348','2013-04-07','15:00:00',1.81),('8348','2013-04-07','15:05:00',2.59),('8348','2013-04-07','15:10:00',2.48),('8348','2013-04-07','15:15:00',2.63),('8348','2013-04-07','15:20:00',2.65),('8348','2013-04-07','15:25:00',2.75),('8348','2013-04-07','15:30:00',2.6),('8348','2013-04-07','15:35:00',2.66),('8348','2013-04-07','15:40:00',2.27),('8348','2013-04-07','15:45:00',2.41),('8348','2013-04-07','15:50:00',2.39),('8348','2013-04-07','15:55:00',1.88),('8348','2013-04-07','16:00:00',2.2),('8348','2013-04-07','16:05:00',1.92),('8348','2013-04-07','16:10:00',1.66),('8348','2013-04-07','16:15:00',1.45),('8348','2013-04-07','16:20:00',1.36),('8348','2013-04-07','16:25:00',1.27),('8348','2013-04-07','16:30:00',1.35),('8348','2013-04-07','16:35:00',1.69),('8348','2013-04-07','16:40:00',1.68);
INSERT INTO `solarlog` VALUES ('8348','2013-04-07','16:45:00',2.13),('8348','2013-04-07','16:50:00',2.21),('8348','2013-04-07','16:55:00',2.15),('8348','2013-04-07','17:00:00',2.01),('8348','2013-04-07','17:05:00',1.85),('8348','2013-04-07','17:10:00',1.19),('8348','2013-04-07','17:20:00',1.61),('8348','2013-04-07','17:25:00',1.95),('8348','2013-04-07','17:30:00',1.8),('8348','2013-04-07','17:35:00',1.73),('8348','2013-04-07','17:40:00',1.74),('8348','2013-04-07','17:45:00',1.65),('8348','2013-04-07','17:50:00',1.52),('8348','2013-04-07','17:55:00',1.26),('8348','2013-04-06','08:40:00',1.04),('8348','2013-04-06','08:45:00',1.11),('8348','2013-04-06','08:50:00',1.18),('8348','2013-04-06','08:55:00',1.23),('8348','2013-04-06','09:00:00',1.33),('8348','2013-04-06','09:05:00',1.42),('8348','2013-04-06','09:10:00',1.5),('8348','2013-04-06','09:15:00',1.58),('8348','2013-04-06','09:20:00',1.7),('8348','2013-04-06','09:25:00',1.79),('8348','2013-04-06','09:30:00',1.85),('8348','2013-04-06','09:35:00',1.88),('8348','2013-04-06','09:40:00',1.98),('8348','2013-04-06','09:45:00',2.04),('8348','2013-04-06','09:50:00',2.1),('8348','2013-04-06','09:55:00',2.16),('8348','2013-04-06','10:00:00',2.23),('8348','2013-04-06','10:05:00',2.29),('8348','2013-04-06','10:10:00',2.36),('8348','2013-04-06','10:15:00',1.73),('8348','2013-04-06','10:20:00',1.54),('8348','2013-04-06','10:25:00',2.46),('8348','2013-04-06','10:30:00',2.4),('8348','2013-04-06','10:35:00',2.52),('8348','2013-04-06','10:40:00',2.64),('8348','2013-04-06','10:45:00',2.73),('8348','2013-04-06','10:50:00',2.77),('8348','2013-04-06','10:55:00',2.81),('8348','2013-04-06','11:00:00',2.87),('8348','2013-04-06','11:05:00',2.92),('8348','2013-04-06','11:10:00',2.95),('8348','2013-04-06','11:15:00',2.99),('8348','2013-04-06','11:20:00',3.05),('8348','2013-04-06','11:25:00',3.13),('8348','2013-04-06','11:30:00',3.16),('8348','2013-04-06','11:35:00',3.18),('8348','2013-04-06','11:40:00',3.2),('8348','2013-04-06','11:45:00',3.23),('8348','2013-04-06','11:50:00',3.23),('8348','2013-04-06','11:55:00',3.23),('8348','2013-04-06','12:00:00',3.22),('8348','2013-04-06','12:05:00',3.28),('8348','2013-04-06','12:10:00',3.3),('8348','2013-04-06','12:15:00',3.33),('8348','2013-04-06','12:20:00',3.4),('8348','2013-04-06','12:25:00',3.47),('8348','2013-04-06','12:30:00',3.46),('8348','2013-04-06','12:35:00',3.51),('8348','2013-04-06','12:40:00',3.49),('8348','2013-04-06','12:45:00',3.51),('8348','2013-04-06','12:50:00',3.54),('8348','2013-04-06','12:55:00',3.49),('8348','2013-04-06','13:00:00',3.37),('8348','2013-04-06','13:05:00',3.33),('8348','2013-04-06','13:10:00',3.62),('8348','2013-04-06','13:15:00',4.04),('8348','2013-04-06','13:20:00',3.3),('8348','2013-04-06','13:25:00',1.95),('8348','2013-04-06','13:30:00',3.29),('8348','2013-04-06','13:35:00',4.09),('8348','2013-04-06','13:40:00',3.76),('8348','2013-04-06','13:45:00',2.7),('8348','2013-04-06','13:50:00',3.99),('8348','2013-04-06','13:55:00',2.4),('8348','2013-04-06','14:00:00',2.95),('8348','2013-04-06','14:05:00',1.93),('8348','2013-04-06','14:10:00',2.34),('8348','2013-04-06','14:15:00',3.95),('8348','2013-04-06','14:20:00',2.89),('8348','2013-04-06','14:30:00',3.01),('8348','2013-04-06','14:35:00',3.69),('8348','2013-04-06','14:40:00',3.01),('8348','2013-04-06','14:45:00',3.54),('8348','2013-04-06','14:50:00',3.37),('8348','2013-04-06','14:55:00',3.45),('8348','2013-04-06','15:00:00',3),('8348','2013-04-06','15:05:00',3.39),('8348','2013-04-06','15:10:00',3.24),('8348','2013-04-06','15:15:00',3.22),('8348','2013-04-06','15:20:00',3.2),('8348','2013-04-06','15:25:00',3.17),('8348','2013-04-06','15:30:00',3.03),('8348','2013-04-06','15:35:00',3),('8348','2013-04-06','15:40:00',3),('8348','2013-04-06','15:45:00',2.71),('8348','2013-04-06','15:50:00',2.77),('8348','2013-04-06','15:55:00',2.89),('8348','2013-04-06','16:00:00',2.68),('8348','2013-04-06','16:05:00',2.86),('8348','2013-04-06','16:10:00',2.75),('8348','2013-04-06','16:15:00',2.64),('8348','2013-04-06','16:20:00',2.13),('8348','2013-04-06','16:25:00',1.79),('8348','2013-04-06','16:30:00',2.21),('8348','2013-04-06','16:35:00',2.08),('8348','2013-04-06','16:40:00',1.72),('8348','2013-04-06','16:45:00',2.27),('8348','2013-04-06','16:50:00',2.2),('8348','2013-04-06','16:55:00',1.94),('8348','2013-04-06','17:00:00',1.99),('8348','2013-04-06','17:05:00',1.71),('8348','2013-04-06','17:10:00',1.46),('8348','2013-04-06','17:15:00',1.14),('8348','2013-04-05','08:20:00',1.01),('8348','2013-04-05','09:05:00',1.76),('8348','2013-04-05','09:15:00',1.78),('8348','2013-04-05','09:20:00',1.63),('8348','2013-04-05','09:25:00',1),('8348','2013-04-05','09:35:00',1.02),('8348','2013-04-05','09:40:00',1.99),('8348','2013-04-05','09:45:00',1.87),('8348','2013-04-05','09:50:00',1.08),('8348','2013-04-05','10:00:00',1.23),('8348','2013-04-05','10:10:00',2.03),('8348','2013-04-05','10:15:00',2.75),('8348','2013-04-05','10:20:00',1.22),('8348','2013-04-05','10:25:00',2.15),('8348','2013-04-05','10:30:00',2.25),('8348','2013-04-05','10:35:00',2.29),('8348','2013-04-05','10:40:00',3.13),('8348','2013-04-05','10:45:00',1.64),('8348','2013-04-05','10:50:00',1.43),('8348','2013-04-05','10:55:00',2.72),('8348','2013-04-05','11:00:00',2.56),('8348','2013-04-05','11:05:00',2.35),('8348','2013-04-05','11:10:00',2.98),('8348','2013-04-05','11:15:00',2.87),('8348','2013-04-05','11:20:00',2.77),('8348','2013-04-05','11:25:00',2.65),('8348','2013-04-05','11:30:00',2.88),('8348','2013-04-05','11:35:00',2.33),('8348','2013-04-05','11:40:00',3.6),('8348','2013-04-05','11:45:00',2.53),('8348','2013-04-05','11:50:00',3.46),('8348','2013-04-05','11:55:00',3.33),('8348','2013-04-05','12:00:00',3.63),('8348','2013-04-05','12:05:00',2.57),('8348','2013-04-05','12:10:00',1.93),('8348','2013-04-05','12:15:00',1.99),('8348','2013-04-05','12:20:00',1.4),('8348','2013-04-05','12:25:00',2.06),('8348','2013-04-05','12:30:00',1.18),('8348','2013-04-05','12:35:00',1.27),('8348','2013-04-05','12:40:00',1.71),('8348','2013-04-05','12:45:00',3.45),('8348','2013-04-05','12:50:00',4.04),('8348','2013-04-05','12:55:00',3.88),('8348','2013-04-05','13:00:00',2.86),('8348','2013-04-05','13:05:00',2.81),('8348','2013-04-05','13:10:00',2.49),('8348','2013-04-05','13:15:00',2.51),('8348','2013-04-05','13:20:00',2.59),('8348','2013-04-05','13:25:00',2.28),('8348','2013-04-05','13:30:00',2.45),('8348','2013-04-05','13:35:00',2.86),('8348','2013-04-05','13:40:00',3.23),('8348','2013-04-05','13:45:00',3.12),('8348','2013-04-05','13:50:00',4.17),('8348','2013-04-05','13:55:00',3.34),('8348','2013-04-05','14:00:00',2.66),('8348','2013-04-05','14:05:00',4.1),('8348','2013-04-05','14:10:00',3.59),('8348','2013-04-05','14:15:00',3.57),('8348','2013-04-05','14:20:00',3.59),('8348','2013-04-05','14:25:00',3.63),('8348','2013-04-05','14:30:00',3.57),('8348','2013-04-05','14:35:00',3.66),('8348','2013-04-05','14:40:00',3.84),('8348','2013-04-05','14:45:00',2.83),('8348','2013-04-05','14:50:00',2.57),('8348','2013-04-05','14:55:00',3.53),('8348','2013-04-05','15:00:00',3.07),('8348','2013-04-05','15:05:00',3.07),('8348','2013-04-05','15:10:00',1.95),('8348','2013-04-05','15:15:00',1.5),('8348','2013-04-05','15:20:00',1.57),('8348','2013-04-05','15:25:00',1.63),('8348','2013-04-05','15:30:00',1.43),('8348','2013-04-05','15:35:00',1.17),('8348','2013-04-05','15:40:00',1),('8348','2013-04-05','15:45:00',1.25),('8348','2013-04-05','15:50:00',1.56),('8348','2013-04-05','15:55:00',1.5),('8348','2013-04-05','16:00:00',1.59),('8348','2013-04-05','16:05:00',1.47),('8348','2013-04-05','16:10:00',1.47),('8348','2013-04-05','16:15:00',2.05),('8348','2013-04-05','16:20:00',1.73),('8348','2013-04-05','16:25:00',1.41),('8348','2013-04-05','16:30:00',1.49),('8348','2013-04-05','16:35:00',1.47),('8348','2013-04-05','16:40:00',1.41),('8348','2013-04-05','16:45:00',2.02),('8348','2013-04-05','16:50:00',2.79),('8348','2013-04-05','16:55:00',1.39),('8348','2013-04-05','17:00:00',1.51),('8348','2013-04-05','17:05:00',1),('8348','2013-04-05','17:10:00',2.38),('8348','2013-04-05','17:15:00',1.95),('8348','2013-04-05','17:20:00',1.6),('8348','2013-04-05','17:25:00',1.7),('8348','2013-04-05','17:30:00',2.16),('8348','2013-04-05','17:35:00',1.27),('8348','2013-04-05','17:40:00',1.37),('8348','2013-04-05','17:50:00',1.17),('8348','2013-04-05','17:55:00',1.75),('8348','2013-04-05','18:00:00',1.25),('8348','2013-04-04','08:55:00',1.14),('8348','2013-04-04','09:00:00',1.59),('8348','2013-04-04','09:05:00',1.18),('8348','2013-04-04','09:10:00',1.1),('8348','2013-04-04','09:15:00',1.12),('8348','2013-04-04','09:20:00',1.13),('8348','2013-04-04','09:30:00',1.32),('8348','2013-04-04','09:35:00',2.08),('8348','2013-04-04','09:40:00',1.97),('8348','2013-04-04','09:45:00',1.7),('8348','2013-04-04','09:55:00',1.11),('8348','2013-04-04','10:00:00',1.58),('8348','2013-04-04','10:05:00',2.06),('8348','2013-04-04','10:10:00',1.84),('8348','2013-04-04','10:15:00',1.4),('8348','2013-04-04','10:20:00',1.52),('8348','2013-04-04','10:25:00',2.81),('8348','2013-04-04','10:30:00',2.58),('8348','2013-04-04','10:35:00',1.73),('8348','2013-04-04','10:40:00',3.19),('8348','2013-04-04','10:45:00',1.81),('8348','2013-04-04','10:50:00',2.1),('8348','2013-04-04','10:55:00',3.1),('8348','2013-04-04','11:00:00',1.86),('8348','2013-04-04','11:05:00',1.07),('8348','2013-04-04','11:15:00',1.34),('8348','2013-04-04','11:20:00',1.23),('8348','2013-04-04','11:30:00',1.05),('8348','2013-04-04','11:35:00',1.5),('8348','2013-04-04','11:40:00',2.48),('8348','2013-04-04','11:45:00',2.93),('8348','2013-04-04','11:50:00',3.26),('8348','2013-04-04','11:55:00',3.53),('8348','2013-04-04','12:00:00',3.38),('8348','2013-04-04','12:05:00',3.41),('8348','2013-04-04','12:10:00',3.44),('8348','2013-04-04','12:15:00',3.35),('8348','2013-04-04','12:20:00',2.87),('8348','2013-04-04','12:25:00',2.05),('8348','2013-04-04','12:30:00',2.15),('8348','2013-04-04','12:35:00',1.64),('8348','2013-04-04','12:40:00',2.83),('8348','2013-04-04','12:45:00',2.47),('8348','2013-04-04','12:50:00',3.54),('8348','2013-04-04','12:55:00',3.31),('8348','2013-04-04','13:00:00',3.32),('8348','2013-04-04','13:05:00',3.35),('8348','2013-04-04','13:10:00',3.45),('8348','2013-04-04','13:15:00',3.54),('8348','2013-04-04','13:20:00',3.46),('8348','2013-04-04','13:25:00',3.6),('8348','2013-04-04','13:30:00',3.49),('8348','2013-04-04','13:35:00',3.2),('8348','2013-04-04','13:40:00',2.75),('8348','2013-04-04','13:45:00',2.86),('8348','2013-04-04','13:50:00',2.78),('8348','2013-04-04','13:55:00',2.2),('8348','2013-04-04','14:00:00',2.37),('8348','2013-04-04','14:05:00',3.08),('8348','2013-04-04','14:10:00',3.45),('8348','2013-04-04','14:15:00',3.4),('8348','2013-04-04','14:20:00',3.4),('8348','2013-04-04','14:25:00',3.34),('8348','2013-04-04','14:30:00',3.32),('8348','2013-04-04','14:35:00',3.29),('8348','2013-04-04','14:40:00',3.27),('8348','2013-04-04','14:45:00',3.23),('8348','2013-04-04','14:50:00',3.21),('8348','2013-04-04','14:55:00',3.22),('8348','2013-04-04','15:00:00',3.18),('8348','2013-04-04','15:05:00',3.06),('8348','2013-04-04','15:10:00',2.92),('8348','2013-04-04','15:15:00',2.88),('8348','2013-04-04','15:20:00',2.94),('8348','2013-04-04','15:25:00',2.97),('8348','2013-04-04','15:30:00',2.96),('8348','2013-04-04','15:35:00',2.9),('8348','2013-04-04','15:40:00',2.83),('8348','2013-04-04','15:45:00',2.79),('8348','2013-04-04','15:50:00',2.69),('8348','2013-04-04','15:55:00',2.67),('8348','2013-04-04','16:00:00',2.62),('8348','2013-04-04','16:05:00',2.54),('8348','2013-04-04','16:10:00',2.43),('8348','2013-04-04','16:15:00',2.33),('8348','2013-04-04','16:20:00',2.2),('8348','2013-04-04','16:25:00',2.17),('8348','2013-04-04','16:30:00',1.67),('8348','2013-04-04','16:35:00',1.8),('8348','2013-04-04','16:40:00',1.81),('8348','2013-04-04','16:45:00',1.64),('8348','2013-04-04','16:50:00',1.57),('8348','2013-04-04','16:55:00',1.81),('8348','2013-04-04','17:00:00',1.63),('8348','2013-04-04','17:05:00',1.61),('8348','2013-04-04','17:10:00',1.55),('8348','2013-04-04','17:15:00',1.34),('8348','2013-04-04','17:55:00',1.12),('8348','2013-04-03','08:50:00',1.09),('8348','2013-04-03','08:55:00',1.2),('8348','2013-04-03','09:00:00',1.35),('8348','2013-04-03','09:05:00',1.36),('8348','2013-04-03','09:10:00',1.61),('8348','2013-04-03','09:15:00',1.62),('8348','2013-04-03','09:20:00',1.09),('8348','2013-04-03','09:25:00',1.18),('8348','2013-04-03','09:30:00',2.11),('8348','2013-04-03','09:35:00',2.34),('8348','2013-04-03','09:40:00',2.01),('8348','2013-04-03','09:45:00',2.18),('8348','2013-04-03','09:50:00',2.35),('8348','2013-04-03','09:55:00',2.62),('8348','2013-04-03','10:00:00',2.14),('8348','2013-04-03','10:05:00',1.04),('8348','2013-04-03','10:10:00',1.06),('8348','2013-04-03','10:15:00',1.44),('8348','2013-04-03','10:20:00',2.69),('8348','2013-04-03','10:25:00',2.63),('8348','2013-04-03','10:30:00',2.3),('8348','2013-04-03','10:35:00',1.91),('8348','2013-04-03','10:40:00',1.48),('8348','2013-04-03','10:45:00',1.28),('8348','2013-04-03','10:50:00',1.93),('8348','2013-04-03','10:55:00',2.14),('8348','2013-04-03','11:00:00',2.91),('8348','2013-04-03','11:05:00',3.22),('8348','2013-04-03','11:10:00',1.8),('8348','2013-04-03','11:15:00',3.3),('8348','2013-04-03','11:20:00',3.65),('8348','2013-04-03','11:25:00',1.96),('8348','2013-04-03','11:30:00',1.5),('8348','2013-04-03','11:35:00',1.87),('8348','2013-04-03','11:40:00',1.43),('8348','2013-04-03','11:45:00',1.59),('8348','2013-04-03','11:50:00',3.43),('8348','2013-04-03','11:55:00',1.86),('8348','2013-04-03','12:00:00',3.28),('8348','2013-04-03','12:05:00',3.44),('8348','2013-04-03','12:10:00',2.34),('8348','2013-04-03','12:15:00',1.95),('8348','2013-04-03','12:20:00',3.69),('8348','2013-04-03','12:25:00',3.41),('8348','2013-04-03','12:30:00',2.77),('8348','2013-04-03','12:35:00',3.67),('8348','2013-04-03','12:40:00',4.06),('8348','2013-04-03','12:45:00',3.18),('8348','2013-04-03','12:50:00',4.03),('8348','2013-04-03','12:55:00',4.03),('8348','2013-04-03','13:00:00',3.33),('8348','2013-04-03','13:05:00',3.3),('8348','2013-04-03','13:10:00',2.61),('8348','2013-04-03','13:15:00',4.36),('8348','2013-04-03','13:20:00',2.86),('8348','2013-04-03','13:25:00',2.58),('8348','2013-04-03','13:30:00',2.51),('8348','2013-04-03','13:35:00',4.27),('8348','2013-04-03','13:40:00',3.45),('8348','2013-04-03','13:45:00',3.03),('8348','2013-04-03','13:50:00',3.28),('8348','2013-04-03','13:55:00',2.64),('8348','2013-04-03','14:00:00',4.52),('8348','2013-04-03','14:05:00',3.9),('8348','2013-04-03','14:10:00',3.07),('8348','2013-04-03','14:15:00',1.92),('8348','2013-04-03','14:20:00',1.8),('8348','2013-04-03','14:25:00',3.45),('8348','2013-04-03','14:30:00',3.73),('8348','2013-04-03','14:35:00',3.47),('8348','2013-04-03','14:40:00',3.21),('8348','2013-04-03','14:45:00',2.84),('8348','2013-04-03','14:50:00',1.79),('8348','2013-04-03','14:55:00',2.98),('8348','2013-04-03','15:00:00',3.43),('8348','2013-04-03','15:05:00',3.68),('8348','2013-04-03','15:10:00',3.3),('8348','2013-04-03','15:15:00',3.95),('8348','2013-04-03','15:20:00',3.74),('8348','2013-04-03','15:25:00',3.64),('8348','2013-04-03','15:30:00',2.75),('8348','2013-04-03','15:35:00',3.08),('8348','2013-04-03','15:40:00',3.46),('8348','2013-04-03','15:45:00',2.79),('8348','2013-04-03','15:50:00',3.2),('8348','2013-04-03','15:55:00',3.34),('8348','2013-04-03','16:00:00',3.26),('8348','2013-04-03','16:05:00',3.13),('8348','2013-04-03','16:10:00',3.1),('8348','2013-04-03','16:15:00',3),('8348','2013-04-03','16:20:00',2.93),('8348','2013-04-03','16:25:00',2.87),('8348','2013-04-03','16:30:00',2.71),('8348','2013-04-03','16:35:00',2.57),('8348','2013-04-03','16:40:00',2.67),('8348','2013-04-03','16:45:00',2.57),('8348','2013-04-03','16:50:00',2.51),('8348','2013-04-03','16:55:00',2.44),('8348','2013-04-03','17:00:00',2.36),('8348','2013-04-03','17:05:00',2.27),('8348','2013-04-03','17:10:00',2.2),('8348','2013-04-03','17:15:00',2.13),('8348','2013-04-03','17:20:00',1.93),('8348','2013-04-03','17:25:00',1.96),('8348','2013-04-03','17:30:00',1.87),('8348','2013-04-03','17:35:00',1.77),('8348','2013-04-03','17:40:00',1.69),('8348','2013-04-03','17:45:00',1.6),('8348','2013-04-03','17:50:00',1.52),('8348','2013-04-03','17:55:00',1.42),('8348','2013-04-03','18:00:00',1.32),('8348','2013-04-03','18:05:00',1.24),('8348','2013-04-03','18:10:00',1.13),('8348','2013-04-03','18:15:00',1.03),('8348','2013-04-02','08:40:00',1.21),('8348','2013-04-02','08:45:00',1.26),('8348','2013-04-02','08:50:00',1.14),('8348','2013-04-02','09:00:00',1.31),('8348','2013-04-02','09:05:00',1.34),('8348','2013-04-02','09:10:00',1.37),('8348','2013-04-02','09:15:00',1.1),('8348','2013-04-02','09:20:00',1.42),('8348','2013-04-02','09:25:00',1.1),('8348','2013-04-02','09:30:00',1.04),('8348','2013-04-02','09:35:00',2.07),('8348','2013-04-02','09:40:00',2.09),('8348','2013-04-02','09:45:00',1.84),('8348','2013-04-02','09:50:00',1.77),('8348','2013-04-02','09:55:00',1.65),('8348','2013-04-02','10:00:00',1.76),('8348','2013-04-02','10:05:00',1.1),('8348','2013-04-02','10:10:00',1.22),('8348','2013-04-02','10:15:00',1.3),('8348','2013-04-02','10:20:00',1.46),('8348','2013-04-02','10:25:00',1.43),('8348','2013-04-02','10:35:00',2.13),('8348','2013-04-02','10:40:00',1.79),('8348','2013-04-02','10:45:00',2.17),('8348','2013-04-02','10:50:00',3.29),('8348','2013-04-02','10:55:00',1.47),('8348','2013-04-02','11:05:00',2.64),('8348','2013-04-02','11:10:00',1.63),('8348','2013-04-02','11:15:00',1.04),('8348','2013-04-02','11:25:00',1.04),('8348','2013-04-02','11:30:00',1.1),('8348','2013-04-02','11:35:00',1.02),('8348','2013-04-02','11:45:00',2.25),('8348','2013-04-02','11:50:00',2.11),('8348','2013-04-02','11:55:00',1.13),('8348','2013-04-02','12:05:00',3.06),('8348','2013-04-02','12:10:00',1.68),('8348','2013-04-02','12:15:00',2.19),('8348','2013-04-02','12:35:00',1.58),('8348','2013-04-02','12:40:00',1.86),('8348','2013-04-02','12:45:00',2.1),('8348','2013-04-02','12:50:00',2),('8348','2013-04-02','12:55:00',2.03),('8348','2013-04-02','13:00:00',2.16),('8348','2013-04-02','13:05:00',2.35),('8348','2013-04-02','13:10:00',2.89),('8348','2013-04-02','13:15:00',2.41),('8348','2013-04-02','13:20:00',1.86),('8348','2013-04-02','13:25:00',2.95),('8348','2013-04-02','13:30:00',2.36),('8348','2013-04-02','13:35:00',1.77),('8348','2013-04-02','13:40:00',2.66),('8348','2013-04-02','13:45:00',2.43),('8348','2013-04-02','13:50:00',2.12),('8348','2013-04-02','13:55:00',1.61),('8348','2013-04-02','14:00:00',2.2),('8348','2013-04-02','14:05:00',1.75),('8348','2013-04-02','14:10:00',2.23),('8348','2013-04-02','14:15:00',2.08),('8348','2013-04-02','14:20:00',3.27),('8348','2013-04-02','14:25:00',3.4),('8348','2013-04-02','14:30:00',2.45),('8348','2013-04-02','14:35:00',1.71),('8348','2013-04-02','14:40:00',2.3),('8348','2013-04-02','14:45:00',2.47),('8348','2013-04-02','14:50:00',1.91),('8348','2013-04-02','14:55:00',1.61),('8348','2013-04-02','15:00:00',1.43),('8348','2013-04-02','15:45:00',1.1),('8348','2013-04-02','16:05:00',1.07),('8348','2014-05-02','06:15:00',1.06),('8348','2014-05-02','06:35:00',1.03),('8348','2014-05-02','06:40:00',1.15),('8348','2014-05-02','06:45:00',1.26),('8348','2014-05-02','06:50:00',1.47),('8348','2014-05-02','06:55:00',1.81),('8348','2014-05-02','07:00:00',2.16),('8348','2014-05-02','07:05:00',2.17),('8348','2014-05-02','07:10:00',1.54),('8348','2014-05-02','07:15:00',2.66),('8348','2014-05-02','07:20:00',3.64),('8348','2014-05-02','07:25:00',1.97),('8348','2014-05-02','07:30:00',1.31),('8348','2014-05-02','07:40:00',1.38),('8348','2014-05-02','07:45:00',2.12),('8348','2014-05-02','07:50:00',2.1),('8348','2014-05-02','07:55:00',1.24),('8348','2014-05-02','08:05:00',1.24),('8348','2014-05-02','08:10:00',1.6),('8348','2014-05-02','08:15:00',2.24),('8348','2014-05-02','08:20:00',2.63),('8348','2014-05-02','08:25:00',3.01),('8348','2014-05-02','08:30:00',3.65),('8348','2014-05-02','08:35:00',3.22),('8348','2014-05-02','08:40:00',2.94),('8348','2014-05-02','08:45:00',3.17),('8348','2014-05-02','08:50:00',2.95),('8348','2014-05-02','08:55:00',2.69),('8348','2014-05-02','09:00:00',3.52),('8348','2014-05-02','09:05:00',3.6),('8348','2014-05-02','09:10:00',3.42),('8348','2014-05-02','09:15:00',2.84),('8348','2014-05-02','09:20:00',2.78),('8348','2014-05-02','09:25:00',2.23),('8348','2014-05-02','09:30:00',1.71),('8348','2014-05-02','09:35:00',1.68),('8348','2014-05-02','09:40:00',1.83),('8348','2014-05-02','09:45:00',2.26),('8348','2014-05-02','09:50:00',2.19),('8348','2014-05-02','09:55:00',1.57),('8348','2014-05-02','11:25:00',1.62),('8348','2014-05-02','11:30:00',2.02),('8348','2014-05-02','11:35:00',2.27),('8348','2014-05-02','11:40:00',2.23),('8348','2014-05-02','11:45:00',2.68),('8348','2014-05-02','11:50:00',3.49),('8348','2014-05-02','11:55:00',2.82),('8348','2014-05-02','12:00:00',2.88),('8348','2014-05-02','12:05:00',3.11),('8348','2014-05-02','12:10:00',3.49),('8348','2014-05-02','12:15:00',4.19),('8348','2014-05-02','12:20:00',6.02),('8348','2014-05-02','12:25:00',6.02),('8348','2014-05-02','12:30:00',5.03),('8348','2014-05-02','12:35:00',5.82),('8348','2014-05-02','12:40:00',4.74),('8348','2014-05-02','12:45:00',3.92),('8348','2014-05-02','12:50:00',3.23),('8348','2014-05-02','12:55:00',2.63),('8348','2014-05-02','13:00:00',2.71),('8348','2014-05-02','13:05:00',3.34),('8348','2014-05-02','13:10:00',1.99),('8348','2014-05-02','13:25:00',1.22),('8348','2014-05-02','13:30:00',1.87),('8348','2014-05-02','13:35:00',2.49),('8348','2014-05-02','13:40:00',5.69),('8348','2014-05-02','13:45:00',3.2),('8348','2014-05-02','13:50:00',2.55),('8348','2014-05-02','13:55:00',3.46),('8348','2014-05-02','14:00:00',4.22),('8348','2014-05-02','14:05:00',3.63),('8348','2014-05-02','14:10:00',7.47),('8348','2014-05-02','14:15:00',6.53),('8348','2014-05-02','14:20:00',4.89),('8348','2014-05-02','14:25:00',4.25),('8348','2014-05-02','14:30:00',2.32),('8348','2014-05-02','14:35:00',4.08),('8348','2014-05-02','14:40:00',6.6),('8348','2014-05-02','14:45:00',2.26),('8348','2014-05-02','14:50:00',1.51),('8348','2014-05-02','14:55:00',1.58),('8348','2014-05-02','15:00:00',2.67),('8348','2014-05-02','15:05:00',3.61),('8348','2014-05-02','15:10:00',2.15),('8348','2014-05-02','15:15:00',1.77),('8348','2014-05-02','15:20:00',5.14),('8348','2014-05-02','15:25:00',1.26),('8348','2014-05-02','15:55:00',1.63),('8348','2014-05-02','16:05:00',1.24),('8348','2014-05-02','16:10:00',1.08),('8348','2014-05-02','16:15:00',1.56),('8348','2014-05-02','16:20:00',1.81),('8348','2014-05-02','16:25:00',2.23),('8348','2014-05-02','16:30:00',1.67),('8348','2014-05-02','16:35:00',1.36),('8348','2014-05-02','16:40:00',1.11),('8348','2014-03-27','07:45:00',1.27),('8348','2014-03-27','07:50:00',1.39),('8348','2014-03-27','07:55:00',1.9),('8348','2014-03-27','08:00:00',2.33),('8348','2014-03-27','08:05:00',2.56),('8348','2014-03-27','08:10:00',1.46),('8348','2014-03-27','09:10:00',1.35),('8348','2014-03-27','09:15:00',1.68),('8348','2014-03-27','09:20:00',1.59),('8348','2014-03-27','09:25:00',1.46),('8348','2014-03-27','09:30:00',1.3),('8348','2014-03-27','09:55:00',1.27),('8348','2014-03-27','10:00:00',1.55),('8348','2014-03-27','10:05:00',2.02),('8348','2014-03-27','10:10:00',2.39),('8348','2014-03-27','10:15:00',2.22),('8348','2014-03-27','10:20:00',3.04),('8348','2014-03-27','10:25:00',3.86),('8348','2014-03-27','10:30:00',3.76),('8348','2014-03-27','10:35:00',3.14),('8348','2014-03-27','10:40:00',3.5),('8348','2014-03-27','10:45:00',2.09),('8348','2014-03-27','10:50:00',1.44),('8348','2014-03-27','10:55:00',1.35),('8348','2014-03-27','11:00:00',1.31),('8348','2014-03-27','11:05:00',1.12),('8348','2014-03-27','11:10:00',4.54),('8348','2014-03-27','11:15:00',4.35),('8348','2014-03-27','11:20:00',2.52),('8348','2014-03-27','11:25:00',1.33),('8348','2014-03-27','11:50:00',1.95),('8348','2014-03-27','11:55:00',2.51),('8348','2014-03-27','12:00:00',2.16),('8348','2014-03-27','12:05:00',1.93),('8348','2014-03-27','12:10:00',2.24),('8348','2014-03-27','12:15:00',1.73),('8348','2014-03-27','12:20:00',1.78),('8348','2014-03-27','12:25:00',1.17),('8348','2014-03-27','12:55:00',1.34),('8348','2014-03-27','13:00:00',1.69),('8348','2014-03-27','13:05:00',2.01),('8348','2014-03-27','13:10:00',2.81),('8348','2014-03-27','13:15:00',3.97),('8348','2014-03-27','13:20:00',4.25),('8348','2014-03-27','13:25:00',4.47),('8348','2014-03-27','13:30:00',3.92),('8348','2014-03-27','13:35:00',3.43),('8348','2014-03-27','13:40:00',3.25),('8348','2014-03-27','13:45:00',2.93),('8348','2014-03-27','13:50:00',3.68),('8348','2014-03-27','13:55:00',4.92),('8348','2014-03-27','14:00:00',3.84),('8348','2014-03-27','14:05:00',2.15),('8348','2014-03-27','14:10:00',1.17),('8348','2014-03-27','14:15:00',4.34),('8348','2014-03-27','14:20:00',6.95),('8348','2014-03-27','14:25:00',6.55),('8348','2014-03-27','14:30:00',7.19),('8348','2014-03-27','14:35:00',3.85),('8348','2014-03-27','14:40:00',3.5),('8348','2014-03-27','14:45:00',3.16),('8348','2014-03-27','14:50:00',3.79),('8348','2014-03-27','14:55:00',3.12),('8348','2014-03-27','15:00:00',7.08),('8348','2014-03-27','15:05:00',2.69),('8348','2014-03-27','15:20:00',1.53),('8348','2014-03-27','15:25:00',4.56),('8348','2014-03-27','15:30:00',5.66),('8348','2014-03-27','15:35:00',4.4),('8348','2014-03-27','15:40:00',2.4),('8348','2014-03-27','15:45:00',1.09),('8348','2014-03-27','15:50:00',1.54),('8348','2014-03-27','15:55:00',1.62),('8348','2014-03-27','16:00:00',1.53),('8348','2014-03-27','16:05:00',1.78),('8348','2014-03-27','16:10:00',1.99),('8348','2014-03-27','16:15:00',1.89),('8348','2014-03-27','16:20:00',1.55),('8348','2014-03-27','16:25:00',1.87),('8348','2014-03-27','16:30:00',2.41),('8348','2014-03-27','16:35:00',1.65),('8348','2014-03-27','16:40:00',1.66),('8348','2014-03-27','16:45:00',1.66),('8348','2014-03-27','16:50:00',1.11),('8348','2014-03-27','16:55:00',1.77),('8348','2014-03-27','17:00:00',1.78),('8348','2014-03-27','17:05:00',1.54),('8348','2014-03-27','17:10:00',1.11),('8348','2013-04-01','08:40:00',1.12),('8348','2013-04-01','08:55:00',1.05),('8348','2013-04-01','09:00:00',1.3),('8348','2013-04-01','09:05:00',1.38),('8348','2013-04-01','09:10:00',1.52),('8348','2013-04-01','09:15:00',1.48),('8348','2013-04-01','09:20:00',1.1),('8348','2013-04-01','09:25:00',1.35),('8348','2013-04-01','09:30:00',1.83),('8348','2013-04-01','09:35:00',1.49),('8348','2013-04-01','09:40:00',1.43),('8348','2013-04-01','09:45:00',1.6),('8348','2013-04-01','09:50:00',2.2),('8348','2013-04-01','09:55:00',2.14),('8348','2013-04-01','10:00:00',2.33),('8348','2013-04-01','10:05:00',2.44),('8348','2013-04-01','10:10:00',1.82),('8348','2013-04-01','10:15:00',2.23),('8348','2013-04-01','10:20:00',1.64),('8348','2013-04-01','10:25:00',2.39),('8348','2013-04-01','10:30:00',1.81),('8348','2013-04-01','10:35:00',1.39),('8348','2013-04-01','10:40:00',1.35),('8348','2013-04-01','10:45:00',2.64),('8348','2013-04-01','10:50:00',2.12),('8348','2013-04-01','10:55:00',1.55),('8348','2013-04-01','11:00:00',1.22),('8348','2013-04-01','11:05:00',1.47),('8348','2013-04-01','11:10:00',2.07),('8348','2013-04-01','11:15:00',2.89),('8348','2013-04-01','11:20:00',2.55),('8348','2013-04-01','11:25:00',1.88),('8348','2013-04-01','11:30:00',1.35),('8348','2013-04-01','11:35:00',1.6),('8348','2013-04-01','11:40:00',2.34),('8348','2013-04-01','11:45:00',2.76),('8348','2013-04-01','11:50:00',2.25),('8348','2013-04-01','11:55:00',1.97),('8348','2013-04-01','12:00:00',2.57),('8348','2013-04-01','12:05:00',1.62),('8348','2013-04-01','12:10:00',2.08),('8348','2013-04-01','12:15:00',1.75),('8348','2013-04-01','12:20:00',1.47),('8348','2013-04-01','12:25:00',1.63),('8348','2013-04-01','12:30:00',2.29),('8348','2013-04-01','12:35:00',2.13),('8348','2013-04-01','12:40:00',2.16),('8348','2013-04-01','12:45:00',2.4),('8348','2013-04-01','12:50:00',2.55),('8348','2013-04-01','12:55:00',2.75),('8348','2013-04-01','13:00:00',2.68),('8348','2013-04-01','13:05:00',2.92),('8348','2013-04-01','13:10:00',2.68),('8348','2013-04-01','13:15:00',2.66),('8348','2013-04-01','13:20:00',2.56),('8348','2013-04-01','13:25:00',2.42),('8348','2013-04-01','13:30:00',2.75),('8348','2013-04-01','13:35:00',2.39),('8348','2013-04-01','13:40:00',2.98),('8348','2013-04-01','13:45:00',3.31),('8348','2013-04-01','13:50:00',3.64),('8348','2013-04-01','13:55:00',3.81),('8348','2013-04-01','14:00:00',2.13),('8348','2013-04-01','14:05:00',1.66),('8348','2013-04-01','14:10:00',2.12),('8348','2013-04-01','14:15:00',2.35),('8348','2013-04-01','14:20:00',2.43),('8348','2013-04-01','14:25:00',3.8),('8348','2013-04-01','14:30:00',2.6),('8348','2013-04-01','14:35:00',2.05),('8348','2013-04-01','14:40:00',1.8),('8348','2013-04-01','14:45:00',1.8),('8348','2013-04-01','14:50:00',1.94),('8348','2013-04-01','14:55:00',2.07),('8348','2013-04-01','15:00:00',1.84),('8348','2013-04-01','15:05:00',1.83),('8348','2013-04-01','15:10:00',1.87),('8348','2013-04-01','15:15:00',2.02),('8348','2013-04-01','15:20:00',2.07),('8348','2013-04-01','15:25:00',2.14),('8348','2013-04-01','15:30:00',1.86),('8348','2013-04-01','15:35:00',2.33),('8348','2013-04-01','15:40:00',2.17),('8348','2013-04-01','15:45:00',2.21),('8348','2013-04-01','15:50:00',2.58),('8348','2013-04-01','15:55:00',1.99),('8348','2013-04-01','16:00:00',1.8),('8348','2013-04-01','16:05:00',1.48),('8348','2013-04-01','16:10:00',1.24),('8348','2013-03-31','08:45:00',1.06),('8348','2013-03-31','08:55:00',1.05),('8348','2013-03-31','09:15:00',1.03),('8348','2013-03-31','09:20:00',2.02),('8348','2013-03-31','09:25:00',2.24),('8348','2013-03-31','09:30:00',1.91),('8348','2013-03-31','09:35:00',2),('8348','2013-03-31','09:40:00',1.31),('8348','2013-03-31','09:45:00',2.13),('8348','2013-03-31','09:50:00',1.35),('8348','2013-03-31','09:55:00',1.67),('8348','2013-03-31','10:00:00',1.91),('8348','2013-03-31','10:20:00',1.86),('8348','2013-03-31','10:25:00',2.4),('8348','2013-03-31','10:30:00',2.15),('8348','2013-03-31','10:35:00',2.38),('8348','2013-03-31','10:45:00',1.07),('8348','2013-03-31','10:50:00',1.9),('8348','2013-03-31','11:10:00',1.25),('8348','2013-03-31','11:15:00',1.14),('8348','2013-03-31','11:20:00',1),('8348','2013-03-31','11:25:00',1.52),('8348','2013-03-31','11:30:00',1.21),('8348','2013-03-31','11:35:00',1.47),('8348','2013-03-31','11:40:00',1.53),('8348','2013-03-31','11:45:00',1.41),('8348','2013-03-31','11:50:00',1.45),('8348','2013-03-31','11:55:00',1.53),('8348','2013-03-31','12:00:00',1.41),('8348','2013-03-31','12:05:00',1.29),('8348','2013-03-31','12:10:00',1.15),('8348','2013-03-31','12:15:00',1.21),('8348','2013-03-31','12:20:00',1.13),('8348','2013-03-31','12:25:00',1.34),('8348','2013-03-31','12:30:00',1.66),('8348','2013-03-31','12:35:00',2.54),('8348','2013-03-31','12:40:00',3.49),('8348','2013-03-31','12:45:00',1.72),('8348','2013-03-31','12:50:00',1.61),('8348','2013-03-31','12:55:00',1.82),('8348','2013-03-31','13:00:00',2.21),('8348','2013-03-31','13:05:00',1.66),('8348','2013-03-31','13:10:00',2.36),('8348','2013-03-31','13:15:00',3.04),('8348','2013-03-31','13:20:00',3.67),('8348','2013-03-31','13:25:00',2.58),('8348','2013-03-31','13:40:00',1.43),('8348','2013-03-31','13:45:00',1.7),('8348','2013-03-31','13:50:00',1.79),('8348','2013-03-31','13:55:00',1.34),('8348','2013-03-31','14:00:00',2.12),('8348','2013-03-31','14:05:00',2.99),('8348','2013-03-31','14:10:00',2.36),('8348','2013-03-31','14:15:00',2.46),('8348','2013-03-31','14:20:00',2.09),('8348','2013-03-31','14:25:00',1.69),('8348','2013-03-31','14:30:00',2.1),('8348','2013-03-31','14:35:00',3.87),('8348','2013-03-31','14:40:00',4.11),('8348','2013-03-31','14:45:00',3.59),('8348','2013-03-31','14:50:00',3.33),('8348','2013-03-31','14:55:00',2.67),('8348','2013-03-31','15:00:00',3.17),('8348','2013-03-31','15:05:00',2.11),('8348','2013-03-31','15:10:00',3.07),('8348','2013-03-31','15:15:00',2.9),('8348','2013-03-31','15:20:00',3.77),('8348','2013-03-31','15:25:00',3.13),('8348','2013-03-31','15:30:00',2.67),('8348','2013-03-31','15:35:00',2.64),('8348','2013-03-31','15:40:00',3.73),('8348','2013-03-31','15:45:00',2.35),('8348','2013-03-31','16:00:00',2.37),('8348','2013-03-31','16:05:00',1.13),('8348','2013-03-31','16:10:00',1.3),('8348','2013-03-31','16:15:00',2.3),('8348','2013-03-31','16:20:00',1.67),('8348','2013-03-31','16:25:00',1.24),('8348','2013-03-31','16:35:00',1.08),('8348','2013-03-31','16:40:00',1.12),('8348','2013-03-31','17:00:00',1.25),('8348','2013-03-31','17:05:00',1.7),('8348','2013-03-31','17:10:00',1.21),('8348','2013-03-31','17:20:00',1),('8348','2013-03-31','17:25:00',1.06),('8348','2013-03-31','17:30:00',1.19),('8348','2013-03-31','17:35:00',1.14),('8348','2013-03-31','17:50:00',1.19),('8348','2013-03-31','17:55:00',1.63),('8348','2013-03-31','18:15:00',1.4),('8348','2013-03-30','08:35:00',1.02),('8348','2013-03-30','09:05:00',1.51),('8348','2013-03-30','09:10:00',1.62),('8348','2013-03-30','09:15:00',1.58),('8348','2013-03-30','09:20:00',2.78),('8348','2013-03-30','09:25:00',1.86),('8348','2013-03-30','09:30:00',1.22),('8348','2013-03-30','09:35:00',1.42),('8348','2013-03-30','09:40:00',1.35),('8348','2013-03-30','09:45:00',1.17),('8348','2013-03-30','09:55:00',1.03),('8348','2013-03-30','10:00:00',1.58),('8348','2013-03-30','10:05:00',1.53),('8348','2013-03-30','10:10:00',1.71),('8348','2013-03-30','10:15:00',1.57),('8348','2013-03-30','10:20:00',1.37),('8348','2013-03-30','10:25:00',1.35),('8348','2013-03-30','10:30:00',1.54),('8348','2013-03-30','10:35:00',1.83),('8348','2013-03-30','10:40:00',2.19),('8348','2013-03-30','10:45:00',2.93),('8348','2013-03-30','10:50:00',2.76),('8348','2013-03-30','10:55:00',2.08),('8348','2013-03-30','11:00:00',3.31),('8348','2013-03-30','11:05:00',3.53),('8348','2013-03-30','11:10:00',4.22),('8348','2013-03-30','11:15:00',3.86),('8348','2013-03-30','11:20:00',4.44),('8348','2013-03-30','11:25:00',3.96),('8348','2013-03-30','11:30:00',2.08),('8348','2013-03-30','11:35:00',2.9),('8348','2013-03-30','11:40:00',2.36),('8348','2013-03-30','11:45:00',2.85),('8348','2013-03-30','11:50:00',3.44),('8348','2013-03-30','11:55:00',4.2),('8348','2013-03-30','12:00:00',3.92),('8348','2013-03-30','12:05:00',2.52),('8348','2013-03-30','12:10:00',1.93),('8348','2013-03-30','12:15:00',1.82),('8348','2013-03-30','12:20:00',1.75),('8348','2013-03-30','12:25:00',1.1),('8348','2013-03-30','13:10:00',1.54),('8348','2013-03-30','13:15:00',3.24),('8348','2013-03-30','13:20:00',2.45),('8348','2013-03-30','13:25:00',1.64),('8348','2013-03-30','13:30:00',1.06),('8348','2013-03-30','13:45:00',2.19),('8348','2013-03-30','13:50:00',4.08),('8348','2013-03-30','13:55:00',1.85),('8348','2013-03-30','14:00:00',2.08),('8348','2013-03-30','14:05:00',2.12),('8348','2013-03-30','14:10:00',1.07),('8348','2013-03-30','14:20:00',1.8),('8348','2013-03-30','14:25:00',1.25),('8348','2013-03-30','14:30:00',1.87),('8348','2013-03-30','14:35:00',2.14),('8348','2013-03-30','14:40:00',1.17),('8348','2013-03-30','14:50:00',1.34),('8348','2013-03-29','07:45:00',1.01),('8348','2013-03-29','08:00:00',1.06),('8348','2013-03-29','08:05:00',1.24),('8348','2013-03-29','08:10:00',1.41),('8348','2013-03-29','08:15:00',1.43),('8348','2013-03-29','08:20:00',1.5),('8348','2013-03-29','08:25:00',1.58),('8348','2013-03-29','08:30:00',1.69),('8348','2013-03-29','08:35:00',1.81),('8348','2013-03-29','08:40:00',1.88),('8348','2013-03-29','08:45:00',1.82),('8348','2013-03-29','08:50:00',1.86),('8348','2013-03-29','08:55:00',1.77),('8348','2013-03-29','09:00:00',1.95),('8348','2013-03-29','09:05:00',2.04),('8348','2013-03-29','09:10:00',2.14),('8348','2013-03-29','09:15:00',2.39),('8348','2013-03-29','09:20:00',2.53),('8348','2013-03-29','09:25:00',2.34),('8348','2013-03-29','09:30:00',2.82),('8348','2013-03-29','09:35:00',2.89),('8348','2013-03-29','09:40:00',2.94),('8348','2013-03-29','09:45:00',2.58),('8348','2013-03-29','09:50:00',2.79),('8348','2013-03-29','09:55:00',2.81),('8348','2013-03-29','10:00:00',2.82),('8348','2013-03-29','10:05:00',2.69),('8348','2013-03-29','10:10:00',2.3),('8348','2013-03-29','10:15:00',2.87),('8348','2013-03-29','10:20:00',2.68),('8348','2013-03-29','10:25:00',2.58),('8348','2013-03-29','10:30:00',2.79),('8348','2013-03-29','10:35:00',2.25),('8348','2013-03-29','10:40:00',3.18),('8348','2013-03-29','10:45:00',2.44),('8348','2013-03-29','10:50:00',2.08),('8348','2013-03-29','10:55:00',2.82),('8348','2013-03-29','11:00:00',2.89),('8348','2013-03-29','11:05:00',3.37),('8348','2013-03-29','11:10:00',3.77),('8348','2013-03-29','11:15:00',1.53),('8348','2013-03-29','11:20:00',3.27),('8348','2013-03-29','11:25:00',3.93),('8348','2013-03-29','11:30:00',3.74),('8348','2013-03-29','11:35:00',3.59),('8348','2013-03-29','11:40:00',3.64),('8348','2013-03-29','11:45:00',3.63),('8348','2013-03-29','11:50:00',3.68),('8348','2013-03-29','11:55:00',3.71),('8348','2013-03-29','12:00:00',3.72),('8348','2013-03-29','12:05:00',3.82),('8348','2013-03-29','12:10:00',3.75),('8348','2013-03-29','12:15:00',3.49),('8348','2013-03-29','12:20:00',3.78),('8348','2013-03-29','12:25:00',3.61),('8348','2013-03-29','12:30:00',3.48),('8348','2013-03-29','12:35:00',3.6),('8348','2013-03-29','12:40:00',3.71),('8348','2013-03-29','12:45:00',3.36),('8348','2013-03-29','12:50:00',3.84),('8348','2013-03-29','12:55:00',3.54),('8348','2013-03-29','13:00:00',3.65),('8348','2013-03-29','13:05:00',3.14),('8348','2013-03-29','13:10:00',3.51),('8348','2013-03-29','13:15:00',3.05),('8348','2013-03-29','13:20:00',3.09),('8348','2013-03-29','13:25:00',3.93),('8348','2013-03-29','13:30:00',3.34),('8348','2013-03-29','13:35:00',3.11),('8348','2013-03-29','13:40:00',3.07),('8348','2013-03-29','13:45:00',3.21),('8348','2013-03-29','13:50:00',3.05),('8348','2013-03-29','13:55:00',3.17),('8348','2013-03-29','14:00:00',3.3),('8348','2013-03-29','14:05:00',2.75),('8348','2013-03-29','14:10:00',2.28),('8348','2013-03-29','14:15:00',2.25),('8348','2013-03-29','14:20:00',2.26),('8348','2013-03-29','14:25:00',2.29),('8348','2013-03-29','14:30:00',1.95),('8348','2013-03-29','14:35:00',1.94),('8348','2013-03-29','14:40:00',1.87),('8348','2013-03-29','14:45:00',1.72),('8348','2013-03-29','14:50:00',1.66),('8348','2013-03-29','14:55:00',1.6),('8348','2013-03-29','15:00:00',1.45),('8348','2013-03-29','15:05:00',1.49),('8348','2013-03-29','15:10:00',1.39),('8348','2013-03-29','15:15:00',1.37),('8348','2013-03-29','15:20:00',1.28),('8348','2013-03-29','15:25:00',1.15),('8348','2013-03-29','15:30:00',1.06),('8348','2013-03-29','15:35:00',1.01),('8348','2013-03-29','15:50:00',1.03),('8348','2013-03-29','15:55:00',1.21),('8348','2013-03-29','16:00:00',1.49),('8348','2013-03-29','16:05:00',1.41),('8348','2013-03-29','16:10:00',1.06),('8348','2013-03-29','16:30:00',1.09),('8348','2013-03-29','16:35:00',1.06),('8348','2013-03-29','16:40:00',2),('8348','2013-03-29','16:45:00',1.62),('8348','2013-03-29','16:50:00',1.16),('8348','2013-03-29','17:00:00',1.19),('8348','2013-03-29','17:20:00',1),('8348','2013-03-29','17:25:00',1.01),('8348','2013-03-28','09:10:00',1.28),('8348','2013-03-28','09:15:00',2.46),('8348','2013-03-28','09:20:00',1.44),('8348','2013-03-28','09:25:00',1.37),('8348','2013-03-28','09:30:00',1.09),('8348','2013-03-28','09:50:00',1.05),('8348','2013-03-28','10:00:00',1.04),('8348','2013-03-28','11:40:00',1.47),('8348','2013-03-28','11:45:00',1.14),('8348','2013-03-28','11:55:00',1.93),('8348','2013-03-28','12:00:00',1.41),('8348','2013-03-28','12:15:00',1.07),('8348','2013-03-28','12:30:00',1.03),('8348','2013-03-28','12:40:00',1.26),('8348','2013-03-28','12:45:00',1.57),('8348','2013-03-28','12:50:00',2.86),('8348','2013-03-28','12:55:00',3.09),('8348','2013-03-28','13:00:00',3.26),('8348','2013-03-28','13:05:00',4.39),('8348','2013-03-28','13:10:00',3.15),('8348','2013-03-28','13:15:00',3.66),('8348','2013-03-28','13:20:00',2.93),('8348','2013-03-28','13:25:00',2.38),('8348','2013-03-28','13:30:00',2.66),('8348','2013-03-28','13:35:00',2.67),('8348','2013-03-28','13:40:00',2.73),('8348','2013-03-28','13:45:00',2.43),('8348','2013-03-28','13:50:00',2.88),('8348','2013-03-28','13:55:00',1.52),('8348','2013-03-28','14:00:00',1.72),('8348','2013-03-28','14:05:00',1.83),('8348','2013-03-28','14:10:00',1.29),('8348','2013-03-28','14:15:00',1.28),('8348','2013-03-28','14:20:00',1.56),('8348','2013-03-28','14:25:00',1.34),('8348','2013-03-28','14:30:00',2),('8348','2013-03-28','14:35:00',1.52),('8348','2013-03-28','14:40:00',1.01),('8348','2013-03-28','15:00:00',1.1),('8348','2013-03-28','15:05:00',1.22),('8348','2013-03-28','15:10:00',2.5),('8348','2013-03-28','15:15:00',1.97),('8348','2013-03-28','15:20:00',1.59),('8348','2013-03-28','15:25:00',1.06),('8348','2013-03-28','15:30:00',1.55),('8348','2013-03-28','15:35:00',2.06),('8348','2013-03-28','15:40:00',1.59),('8348','2013-03-28','15:45:00',2.15),('8348','2013-03-28','15:50:00',1.32),('8348','2013-03-28','15:55:00',2.74),('8348','2013-03-28','16:00:00',1.26),('8348','2013-03-28','16:10:00',1.84),('8348','2013-03-28','16:35:00',1.63),('8348','2013-03-28','16:40:00',1.06),('8348','2013-03-28','16:45:00',1.11),('8348','2013-03-28','17:00:00',1.5),('8348','2013-03-28','17:05:00',1.34),('8348','2013-03-28','17:10:00',1.13),('8348','2013-03-27','07:55:00',1.17),('8348','2013-03-27','08:00:00',1.2),('8348','2013-03-27','08:05:00',1.18),('8348','2013-03-27','08:10:00',1.11),('8348','2013-03-27','08:15:00',1.25),('8348','2013-03-27','08:20:00',1.09),('8348','2013-03-27','08:25:00',1.25),('8348','2013-03-27','08:30:00',1.5),('8348','2013-03-27','08:35:00',1.45),('8348','2013-03-27','08:40:00',1.15),('8348','2013-03-27','08:45:00',1.09),('8348','2013-03-27','08:50:00',1.5),('8348','2013-03-27','08:55:00',1.14),('8348','2013-03-27','09:00:00',1.24),('8348','2013-03-27','09:15:00',1.14),('8348','2013-03-27','09:20:00',1.22),('8348','2013-03-27','09:45:00',1.39),('8348','2013-03-27','09:50:00',1.67),('8348','2013-03-27','09:55:00',1.31),('8348','2013-03-27','10:00:00',1.19),('8348','2013-03-27','10:10:00',1.09),('8348','2013-03-27','10:15:00',1.61),('8348','2013-03-27','10:20:00',1.28),('8348','2013-03-27','10:25:00',1.6),('8348','2013-03-27','10:30:00',2.05),('8348','2013-03-27','10:35:00',1.83),('8348','2013-03-27','10:40:00',2.03),('8348','2013-03-27','10:45:00',1.92),('8348','2013-03-27','10:50:00',2.04),('8348','2013-03-27','10:55:00',1.88),('8348','2013-03-27','11:00:00',1.62),('8348','2013-03-27','11:05:00',1.41),('8348','2013-03-27','11:10:00',1.52),('8348','2013-03-27','11:15:00',1.6),('8348','2013-03-27','11:20:00',1.68),('8348','2013-03-27','11:25:00',1.58),('8348','2013-03-27','11:30:00',1.75),('8348','2013-03-27','11:35:00',1.69),('8348','2013-03-27','11:40:00',1.54),('8348','2013-03-27','11:45:00',1.58),('8348','2013-03-27','11:50:00',1.55),('8348','2013-03-27','11:55:00',2.32),('8348','2013-03-27','12:00:00',2.41),('8348','2013-03-27','12:05:00',2.28),('8348','2013-03-27','12:10:00',1.92),('8348','2013-03-27','12:15:00',1.55),('8348','2013-03-27','12:20:00',1.56),('8348','2013-03-27','12:25:00',1.54),('8348','2013-03-27','12:30:00',3.22),('8348','2013-03-27','12:35:00',4.13),('8348','2013-03-27','12:40:00',2.84),('8348','2013-03-27','12:45:00',3.61),('8348','2013-03-27','12:50:00',2.67),('8348','2013-03-27','12:55:00',1.68),('8348','2013-03-27','13:00:00',1.47),('8348','2013-03-27','13:05:00',1.46),('8348','2013-03-27','13:10:00',1.91),('8348','2013-03-27','13:15:00',1.53),('8348','2013-03-27','13:20:00',1.21),('8348','2013-03-27','13:25:00',1.23),('8348','2013-03-27','13:30:00',1.48),('8348','2013-03-27','13:35:00',1.95),('8348','2013-03-27','13:40:00',1.59),('8348','2013-03-27','13:45:00',1.81),('8348','2013-03-27','13:50:00',2.01),('8348','2013-03-27','13:55:00',1.95),('8348','2013-03-27','14:00:00',1.53),('8348','2013-03-27','14:05:00',1.4),('8348','2013-03-27','14:10:00',1.45),('8348','2013-03-27','14:15:00',1.65),('8348','2013-03-27','14:20:00',2.06),('8348','2013-03-27','14:25:00',1.62),('8348','2013-03-27','14:30:00',1.37),('8348','2013-03-27','14:35:00',1.64),('8348','2013-03-27','14:40:00',2.12),('8348','2013-03-27','14:45:00',2.04),('8348','2013-03-27','14:50:00',1.61),('8348','2013-03-27','14:55:00',1.16),('8348','2013-03-27','15:00:00',1.01),('8348','2013-03-27','15:05:00',1.33),('8348','2013-03-27','15:10:00',1.34),('8348','2013-03-27','15:25:00',1.03),('8348','2013-03-27','16:45:00',1.15),('8348','2013-03-27','16:55:00',1.16),('8348','2013-03-27','17:00:00',1.27),('8348','2013-03-27','17:05:00',1.49),('8348','2013-03-27','17:10:00',1.2),('8348','2013-03-26','07:50:00',1.31),('8348','2013-03-26','07:55:00',1.37),('8348','2013-03-26','08:35:00',1.26),('8348','2013-03-26','08:40:00',1.33),('8348','2013-03-26','09:15:00',1.39),('8348','2013-03-26','09:50:00',1.1),('8348','2013-03-26','09:55:00',2.42),('8348','2013-03-26','10:00:00',1.15),('8348','2013-03-26','11:00:00',1.08),('8348','2013-03-26','11:05:00',1.01),('8348','2013-03-26','11:10:00',2.19),('8348','2013-03-26','11:15:00',1.32),('8348','2013-03-26','11:20:00',1.42),('8348','2013-03-26','11:50:00',1.13),('8348','2013-03-26','12:00:00',1.33),('8348','2013-03-26','12:05:00',1.22),('8348','2013-03-26','12:10:00',1.25),('8348','2013-03-26','12:15:00',1.33),('8348','2013-03-26','12:20:00',1.47),('8348','2013-03-26','12:25:00',2.31),('8348','2013-03-26','12:30:00',1.94),('8348','2013-03-26','12:35:00',2.65),('8348','2013-03-26','12:40:00',1.46),('8348','2013-03-26','12:45:00',2.47),('8348','2013-03-26','12:50:00',1.72),('8348','2013-03-26','13:00:00',1.48),('8348','2013-03-26','13:05:00',2.19),('8348','2013-03-26','13:10:00',2.05),('8348','2013-03-26','13:15:00',1.7),('8348','2013-03-26','13:20:00',1.82),('8348','2013-03-26','13:25:00',2.05),('8348','2013-03-26','13:30:00',1.62),('8348','2013-03-26','13:35:00',1.92),('8348','2013-03-26','13:40:00',2.2),('8348','2013-03-26','13:45:00',1.92),('8348','2013-03-26','13:50:00',1.63),('8348','2013-03-26','13:55:00',1.44),('8348','2013-03-26','14:00:00',1.43),('8348','2013-03-26','14:05:00',1.4),('8348','2013-03-26','14:10:00',1.49),('8348','2013-03-26','14:15:00',1.37),('8348','2013-03-26','14:20:00',1.14),('8348','2013-03-26','14:25:00',1.06),('8348','2013-03-25','08:25:00',1.55),('8348','2013-03-25','08:30:00',1.19),('8348','2013-03-25','08:55:00',1.08),('8348','2013-03-25','09:00:00',1.02),('8348','2013-03-25','09:10:00',1.13),('8348','2013-03-25','09:15:00',1),('8348','2013-03-25','09:20:00',1.95),('8348','2013-03-25','09:25:00',2.25),('8348','2013-03-25','09:30:00',1.45),('8348','2013-03-25','09:50:00',3.6),('8348','2013-03-25','09:55:00',3.76),('8348','2013-03-25','10:00:00',1.42),('8348','2013-03-25','10:10:00',1.05),('8348','2013-03-25','10:20:00',1.29),('8348','2013-03-25','10:25:00',2.18),('8348','2013-03-25','10:30:00',2.15),('8348','2013-03-25','10:35:00',1.34),('8348','2013-03-25','10:40:00',1.5),('8348','2013-03-25','10:45:00',2.38),('8348','2013-03-25','10:50:00',2.04),('8348','2013-03-25','10:55:00',2.61),('8348','2013-03-25','11:00:00',2.16),('8348','2013-03-25','11:05:00',1.95),('8348','2013-03-25','11:10:00',1.7),('8348','2013-03-25','11:15:00',1.94),('8348','2013-03-25','11:20:00',3.25),('8348','2013-03-25','11:25:00',3.12),('8348','2013-03-25','11:30:00',4.11),('8348','2013-03-25','11:35:00',2.97),('8348','2013-03-25','11:40:00',1.18),('8348','2013-03-25','11:45:00',1.45),('8348','2013-03-25','11:50:00',1.71),('8348','2013-03-25','11:55:00',2.59),('8348','2013-03-25','12:00:00',3.64),('8348','2013-03-25','12:05:00',3.62),('8348','2013-03-25','12:10:00',3.75),('8348','2013-03-25','12:15:00',2.49),('8348','2013-03-25','12:20:00',2.49),('8348','2013-03-25','12:25:00',4.13),('8348','2013-03-25','12:30:00',3.17),('8348','2013-03-25','12:35:00',2.66),('8348','2013-03-25','12:40:00',2.24),('8348','2013-03-25','12:45:00',2.19),('8348','2013-03-25','12:50:00',2.63),('8348','2013-03-25','12:55:00',3.1),('8348','2013-03-25','13:00:00',2.61),('8348','2013-03-25','13:05:00',4.22),('8348','2013-03-25','13:10:00',4.21),('8348','2013-03-25','13:15:00',3.93),('8348','2013-03-25','13:20:00',3.95),('8348','2013-03-25','13:25:00',1.54),('8348','2013-03-25','13:30:00',1.99),('8348','2013-03-25','13:35:00',1.06),('8348','2013-03-25','13:40:00',1.1),('8348','2013-03-25','13:45:00',2.51),('8348','2013-03-25','13:50:00',1.73),('8348','2013-03-25','13:55:00',1.63),('8348','2013-03-25','14:05:00',1.04),('8348','2013-03-25','14:10:00',2.9),('8348','2013-03-25','14:15:00',2.45),('8348','2013-03-25','14:20:00',2.43),('8348','2013-03-25','14:25:00',3.59),('8348','2013-03-25','14:30:00',1.97),('8348','2013-03-25','14:35:00',1.68),('8348','2013-03-25','14:40:00',1.32),('8348','2013-03-25','14:45:00',2.34),('8348','2013-03-25','14:50:00',1.88),('8348','2013-03-25','14:55:00',2.73),('8348','2013-03-25','15:00:00',2.48),('8348','2013-03-25','15:05:00',2.45),('8348','2013-03-25','15:10:00',2.02),('8348','2013-03-25','15:15:00',2.26),('8348','2013-03-25','15:20:00',2.51),('8348','2013-03-25','15:25:00',2.78),('8348','2013-03-25','15:30:00',2.61),('8348','2013-03-25','15:35:00',1.96),('8348','2013-03-25','15:40:00',2.67),('8348','2013-03-25','15:45:00',1.42),('8348','2013-03-25','15:55:00',1.38),('8348','2013-03-25','16:00:00',1.83),('8348','2013-03-25','16:05:00',1.05),('8348','2013-03-25','16:10:00',1.42),('8348','2013-03-25','16:15:00',1.06),('8348','2013-03-25','16:30:00',1.43),('8348','2013-03-25','16:35:00',1.92),('8348','2013-03-25','16:40:00',2.05),('8348','2013-03-24','08:00:00',1.09),('8348','2013-03-24','08:05:00',1.19),('8348','2013-03-24','08:10:00',1.23),('8348','2013-03-24','08:15:00',1.31),('8348','2013-03-24','08:20:00',1.4),('8348','2013-03-24','08:25:00',1.49),('8348','2013-03-24','08:30:00',1.56),('8348','2013-03-24','08:35:00',1.63),('8348','2013-03-24','08:40:00',1.72),('8348','2013-03-24','08:45:00',1.78),('8348','2013-03-24','08:50:00',1.84),('8348','2013-03-24','08:55:00',1.9),('8348','2013-03-24','09:00:00',1.97),('8348','2013-03-24','09:05:00',2.04),('8348','2013-03-24','09:10:00',2.11),('8348','2013-03-24','09:15:00',2.17),('8348','2013-03-24','09:20:00',2.22),('8348','2013-03-24','09:25:00',2.27),('8348','2013-03-24','09:30:00',2.33),('8348','2013-03-24','09:35:00',2.39),('8348','2013-03-24','09:40:00',2.43),('8348','2013-03-24','09:45:00',2.48),('8348','2013-03-24','09:50:00',2.51),('8348','2013-03-24','09:55:00',2.59),('8348','2013-03-24','10:00:00',2.64),('8348','2013-03-24','10:05:00',2.69),('8348','2013-03-24','10:10:00',2.74),('8348','2013-03-24','10:15:00',2.79),('8348','2013-03-24','10:20:00',2.84),('8348','2013-03-24','10:25:00',2.87),('8348','2013-03-24','10:30:00',2.92),('8348','2013-03-24','10:35:00',2.95),('8348','2013-03-24','10:40:00',2.96),('8348','2013-03-24','10:45:00',2.98),('8348','2013-03-24','10:50:00',3),('8348','2013-03-24','10:55:00',3.04),('8348','2013-03-24','11:00:00',3.05),('8348','2013-03-24','11:05:00',3.08),('8348','2013-03-24','11:10:00',3.09),('8348','2013-03-24','11:15:00',3.11),('8348','2013-03-24','11:20:00',3.12),('8348','2013-03-24','11:25:00',3.15),('8348','2013-03-24','11:30:00',3.16),('8348','2013-03-24','11:35:00',3.21),('8348','2013-03-24','11:40:00',3.23),('8348','2013-03-24','11:45:00',3.23),('8348','2013-03-24','11:50:00',3.26),('8348','2013-03-24','11:55:00',3.27),('8348','2013-03-24','12:00:00',3.29),('8348','2013-03-24','12:05:00',3.33),('8348','2013-03-24','12:10:00',3.37),('8348','2013-03-24','12:15:00',3.4),('8348','2013-03-24','12:20:00',3.48),('8348','2013-03-24','12:25:00',3.53),('8348','2013-03-24','12:30:00',3.52),('8348','2013-03-24','12:35:00',3.55),('8348','2013-03-24','12:40:00',3.55),('8348','2013-03-24','12:45:00',3.56),('8348','2013-03-24','12:50:00',3.52),('8348','2013-03-24','12:55:00',3.52),('8348','2013-03-24','13:00:00',3.5),('8348','2013-03-24','13:05:00',3.51),('8348','2013-03-24','13:10:00',3.51),('8348','2013-03-24','13:15:00',3.51),('8348','2013-03-24','13:20:00',3.51),('8348','2013-03-24','13:25:00',3.44),('8348','2013-03-24','13:30:00',3.41),('8348','2013-03-24','13:35:00',3.4),('8348','2013-03-24','13:40:00',3.39),('8348','2013-03-24','13:45:00',3.37),('8348','2013-03-24','13:50:00',3.35),('8348','2013-03-24','13:55:00',3.31),('8348','2013-03-24','14:00:00',3.27),('8348','2013-03-24','14:05:00',3.23),('8348','2013-03-24','14:10:00',3.19),('8348','2013-03-24','14:15:00',3.16),('8348','2013-03-24','14:20:00',3.12),('8348','2013-03-24','14:25:00',3.08),('8348','2013-03-24','14:30:00',2.99),('8348','2013-03-24','14:35:00',2.89),('8348','2013-03-24','14:40:00',2.86),('8348','2013-03-24','14:45:00',2.83),('8348','2013-03-24','14:50:00',2.68),('8348','2013-03-24','14:55:00',2.7),('8348','2013-03-24','15:00:00',2.61),('8348','2013-03-24','15:05:00',2.56),('8348','2013-03-24','15:10:00',2.39),('8348','2013-03-24','15:15:00',2.63),('8348','2013-03-24','15:20:00',2.53),('8348','2013-03-24','15:25:00',2.38),('8348','2013-03-24','15:30:00',2.18),('8348','2013-03-24','15:35:00',2.11),('8348','2013-03-24','15:40:00',2.12),('8348','2013-03-24','15:45:00',1.7),('8348','2013-03-24','15:50:00',1.22),('8348','2013-03-24','15:55:00',1.17),('8348','2013-03-24','16:00:00',1.13),('8348','2013-03-24','16:05:00',1.38),('8348','2013-03-24','16:15:00',1.48),('8348','2013-03-24','16:20:00',1.22),('8348','2013-03-24','16:25:00',1.02),('8348','2013-03-24','16:30:00',1.15),('8348','2013-03-24','16:35:00',1.01),('8348','2013-03-23','08:00:00',1.07),('8348','2013-03-23','08:05:00',1.16),('8348','2013-03-23','08:10:00',1.21),('8348','2013-03-23','08:15:00',1.29),('8348','2013-03-23','08:20:00',1.36),('8348','2013-03-23','08:25:00',1.45),('8348','2013-03-23','08:30:00',1.49),('8348','2013-03-23','08:35:00',1.58),('8348','2013-03-23','08:40:00',1.69),('8348','2013-03-23','08:45:00',1.8),('8348','2013-03-23','08:50:00',1.88),('8348','2013-03-23','08:55:00',1.99),('8348','2013-03-23','09:00:00',2.05),('8348','2013-03-23','09:05:00',2.13),('8348','2013-03-23','09:10:00',2.16),('8348','2013-03-23','09:15:00',2.2),('8348','2013-03-23','09:20:00',2.27),('8348','2013-03-23','09:25:00',2.4),('8348','2013-03-23','09:30:00',2.44),('8348','2013-03-23','09:35:00',2.46),('8348','2013-03-23','09:40:00',2.42),('8348','2013-03-23','09:45:00',2.57),('8348','2013-03-23','09:50:00',2.6),('8348','2013-03-23','09:55:00',2.63),('8348','2013-03-23','10:00:00',2.65),('8348','2013-03-23','10:05:00',2.76),('8348','2013-03-23','10:10:00',2.76),('8348','2013-03-23','10:15:00',2.85),('8348','2013-03-23','10:20:00',2.83),('8348','2013-03-23','10:25:00',2.84),('8348','2013-03-23','10:30:00',2.97),('8348','2013-03-23','10:35:00',3.04),('8348','2013-03-23','10:40:00',3.03),('8348','2013-03-23','10:45:00',3.04),('8348','2013-03-23','10:50:00',3.05),('8348','2013-03-23','10:55:00',2.96),('8348','2013-03-23','11:00:00',2.88),('8348','2013-03-23','11:05:00',2.68),('8348','2013-03-23','11:10:00',2.3),('8348','2013-03-23','11:15:00',2.58),('8348','2013-03-23','11:20:00',3.05),('8348','2013-03-23','11:25:00',3.03),('8348','2013-03-23','11:30:00',3.06),('8348','2013-03-23','11:35:00',3.23),('8348','2013-03-23','11:40:00',3.22),('8348','2013-03-23','11:45:00',3.26),('8348','2013-03-23','11:50:00',3.12),('8348','2013-03-23','11:55:00',3.27),('8348','2013-03-23','12:00:00',3.32),('8348','2013-03-23','12:05:00',3.27),('8348','2013-03-23','12:10:00',3.28),('8348','2013-03-23','12:15:00',3.37),('8348','2013-03-23','12:20:00',3.42),('8348','2013-03-23','12:25:00',3.39),('8348','2013-03-23','12:30:00',3.43),('8348','2013-03-23','12:35:00',3.34),('8348','2013-03-23','12:40:00',3.29),('8348','2013-03-23','12:45:00',3.38),('8348','2013-03-23','12:50:00',3.44),('8348','2013-03-23','12:55:00',3.39),('8348','2013-03-23','13:00:00',2.62),('8348','2013-03-23','13:05:00',3.38),('8348','2013-03-23','13:10:00',3.43),('8348','2013-03-23','13:15:00',3.29),('8348','2013-03-23','13:20:00',3.35),('8348','2013-03-23','13:25:00',3.25),('8348','2013-03-23','13:30:00',3.06),('8348','2013-03-23','13:35:00',3.04),('8348','2013-03-23','13:40:00',3.3),('8348','2013-03-23','13:45:00',3.04),('8348','2013-03-23','13:50:00',3.32),('8348','2013-03-23','13:55:00',3.2),('8348','2013-03-23','14:00:00',3.18),('8348','2013-03-23','14:05:00',3.21),('8348','2013-03-23','14:10:00',3.11),('8348','2013-03-23','14:15:00',3.02),('8348','2013-03-23','14:20:00',3.14),('8348','2013-03-23','14:25:00',3.06),('8348','2013-03-23','14:30:00',3.05),('8348','2013-03-23','14:35:00',2.99),('8348','2013-03-23','14:40:00',2.91),('8348','2013-03-23','14:45:00',2.75),('8348','2013-03-23','14:50:00',2.69),('8348','2013-03-23','14:55:00',2.74),('8348','2013-03-23','15:00:00',2.64),('8348','2013-03-23','15:05:00',2.5),('8348','2013-03-23','15:10:00',2.59),('8348','2013-03-23','15:15:00',2.42),('8348','2013-03-23','15:20:00',2.48),('8348','2013-03-23','15:25:00',2.45),('8348','2013-03-23','15:30:00',2.21),('8348','2013-03-23','15:35:00',2.23),('8348','2013-03-23','15:40:00',2.07),('8348','2013-03-23','15:45:00',1.96),('8348','2013-03-23','15:50:00',1.86),('8348','2013-03-23','15:55:00',1.78),('8348','2013-03-23','16:00:00',1.69),('8348','2013-03-23','16:05:00',1.55),('8348','2013-03-23','16:10:00',1.96),('8348','2013-03-23','16:15:00',1.78),('8348','2013-03-23','16:20:00',1.5),('8348','2013-03-23','16:25:00',1.53),('8348','2013-03-23','16:30:00',1.2),('8348','2013-03-23','16:35:00',1.3),('8348','2013-03-23','16:40:00',1.12),('8348','2013-03-23','16:45:00',1.13),('8348','2013-03-23','17:00:00',1.12),('8348','2013-03-23','17:05:00',1.17),('8348','2013-03-23','17:10:00',1),('8348','2014-03-26','07:25:00',1.09),('8348','2014-03-26','07:30:00',1.19),('8348','2014-03-26','07:35:00',1.28),('8348','2014-03-26','07:40:00',1.37),('8348','2014-03-26','07:45:00',1.53),('8348','2014-03-26','07:50:00',1.75),('8348','2014-03-26','07:55:00',1.84),('8348','2014-03-26','08:00:00',1.96),('8348','2014-03-26','08:05:00',2.08),('8348','2014-03-26','08:10:00',2.28),('8348','2014-03-26','08:15:00',2.55),('8348','2014-03-26','08:20:00',3.25),('8348','2014-03-26','08:25:00',2.47),('8348','2014-03-26','08:30:00',1.92),('8348','2014-03-26','08:35:00',1.59),('8348','2014-03-26','08:40:00',1.8),('8348','2014-03-26','08:45:00',2),('8348','2014-03-26','08:50:00',2.33),('8348','2014-03-26','08:55:00',2.08),('8348','2014-03-26','09:00:00',2.32),('8348','2014-03-26','09:05:00',2.19),('8348','2014-03-26','09:10:00',2.54),('8348','2014-03-26','09:15:00',2.06),('8348','2014-03-26','09:20:00',1.66),('8348','2014-03-26','09:25:00',2.1),('8348','2014-03-26','09:30:00',5),('8348','2014-03-26','09:35:00',5.09),('8348','2014-03-26','09:40:00',5.16),('8348','2014-03-26','09:45:00',5.24),('8348','2014-03-26','09:50:00',5.31),('8348','2014-03-26','09:55:00',5.4),('8348','2014-03-26','10:00:00',5.75),('8348','2014-03-26','10:05:00',4.76),('8348','2014-03-26','10:10:00',5.73),('8348','2014-03-26','10:15:00',6.9),('8348','2014-03-26','10:20:00',6.23),('8348','2014-03-26','10:25:00',5.82),('8348','2014-03-26','10:30:00',5.73),('8348','2014-03-26','10:35:00',2.61),('8348','2014-03-26','10:40:00',1.62),('8348','2014-03-26','10:45:00',2.55),('8348','2014-03-26','10:50:00',3.53),('8348','2014-03-26','10:55:00',8.37),('8348','2014-03-26','11:00:00',6.43),('8348','2014-03-26','11:05:00',1.95),('8348','2014-03-26','11:10:00',2.8),('8348','2014-03-26','11:15:00',6.29),('8348','2014-03-26','11:20:00',5.01),('8348','2014-03-26','11:25:00',2.34),('8348','2014-03-26','11:30:00',3.02),('8348','2014-03-26','11:35:00',3.17),('8348','2014-03-26','11:40:00',3.91),('8348','2014-03-26','11:45:00',5.44),('8348','2014-03-26','11:50:00',7.97),('8348','2014-03-26','11:55:00',8.07),('8348','2014-03-26','12:00:00',7.49),('8348','2014-03-26','12:05:00',7.19),('8348','2014-03-26','12:10:00',7.78),('8348','2014-03-26','12:15:00',3.01),('8348','2014-03-26','12:20:00',3.31),('8348','2014-03-26','12:25:00',3.17),('8348','2014-03-26','12:30:00',3.07),('8348','2014-03-26','12:35:00',2.96),('8348','2014-03-26','12:40:00',3.74),('8348','2014-03-26','12:45:00',4.06),('8348','2014-03-26','12:50:00',3.04),('8348','2014-03-26','12:55:00',2.34),('8348','2014-03-26','13:00:00',2.33),('8348','2014-03-26','13:05:00',2.29),('8348','2014-03-26','13:10:00',2.19),('8348','2014-03-26','13:15:00',1.47),('8348','2014-03-26','13:20:00',2.94),('8348','2014-03-26','13:25:00',7.97),('8348','2014-03-26','13:30:00',4.36),('8348','2014-03-26','13:35:00',2.84),('8348','2014-03-26','13:40:00',2.34),('8348','2014-03-26','13:45:00',1.8),('8348','2014-03-26','13:50:00',1.74),('8348','2014-03-26','13:55:00',2.26),('8348','2014-03-26','14:00:00',3.08),('8348','2014-03-26','14:05:00',6.04),('8348','2014-03-26','14:10:00',7.41),('8348','2014-03-26','14:15:00',3.33),('8348','2014-03-26','14:20:00',1.68),('8348','2014-03-26','14:25:00',1.39),('8348','2014-03-26','14:30:00',1.27),('8348','2014-03-26','14:35:00',1.15),('8348','2014-03-26','14:40:00',1.21),('8348','2014-03-26','14:45:00',4.12),('8348','2014-03-26','14:50:00',5.86),('8348','2014-03-26','14:55:00',6.13),('8348','2014-03-26','15:00:00',5.77),('8348','2014-03-26','15:05:00',5.66),('8348','2014-03-26','15:10:00',5.8),('8348','2014-03-26','15:15:00',5.99),('8348','2014-03-26','15:20:00',5.57),('8348','2014-03-26','15:25:00',5.64),('8348','2014-03-26','15:30:00',5.79),('8348','2014-03-26','15:35:00',5.58),('8348','2014-03-26','15:40:00',4.57),('8348','2014-03-26','15:45:00',4.76),('8348','2014-03-26','15:50:00',4.14),('8348','2014-03-26','15:55:00',3.1),('8348','2014-03-26','16:00:00',2.5),('8348','2014-03-26','16:05:00',2.99),('8348','2014-03-26','16:10:00',2.9),('8348','2014-03-26','16:15:00',3.2),('8348','2014-03-26','16:20:00',1.98),('8348','2014-03-26','16:25:00',1.54),('8348','2014-03-26','16:30:00',1.21),('8348','2014-03-26','16:35:00',1.2),('8348','2013-03-22','08:00:00',1.04),('8348','2013-03-22','08:05:00',1.1),('8348','2013-03-22','08:10:00',1.17),('8348','2013-03-22','08:15:00',1.24),('8348','2013-03-22','08:20:00',1.32),('8348','2013-03-22','08:25:00',1.42),('8348','2013-03-22','08:30:00',1.51),('8348','2013-03-22','08:35:00',1.59),('8348','2013-03-22','08:40:00',1.68),('8348','2013-03-22','08:45:00',1.79),('8348','2013-03-22','08:50:00',1.87),('8348','2013-03-22','08:55:00',1.94),('8348','2013-03-22','09:00:00',1.99),('8348','2013-03-22','09:05:00',2.05),('8348','2013-03-22','09:10:00',2.13),('8348','2013-03-22','09:15:00',2.18),('8348','2013-03-22','09:20:00',2.25),('8348','2013-03-22','09:25:00',2.29),('8348','2013-03-22','09:30:00',2.36),('8348','2013-03-22','09:35:00',2.42),('8348','2013-03-22','09:40:00',2.47),('8348','2013-03-22','09:45:00',2.56),('8348','2013-03-22','09:50:00',2.59),('8348','2013-03-22','09:55:00',2.65),('8348','2013-03-22','10:00:00',2.7),('8348','2013-03-22','10:05:00',2.75),('8348','2013-03-22','10:10:00',2.8),('8348','2013-03-22','10:15:00',2.8),('8348','2013-03-22','10:20:00',2.86),('8348','2013-03-22','10:25:00',2.97),('8348','2013-03-22','10:30:00',3.03),('8348','2013-03-22','10:35:00',3.09),('8348','2013-03-22','10:40:00',3.13),('8348','2013-03-22','10:45:00',3.18),('8348','2013-03-22','10:50:00',3.23),('8348','2013-03-22','10:55:00',3.25),('8348','2013-03-22','11:00:00',3.26),('8348','2013-03-22','11:05:00',3.29),('8348','2013-03-22','11:10:00',3.34),('8348','2013-03-22','11:15:00',3.39),('8348','2013-03-22','11:20:00',3.4),('8348','2013-03-22','11:25:00',3.36),('8348','2013-03-22','11:30:00',3.45),('8348','2013-03-22','11:35:00',3.47),('8348','2013-03-22','11:40:00',3.51),('8348','2013-03-22','11:45:00',3.55),('8348','2013-03-22','11:50:00',3.54),('8348','2013-03-22','11:55:00',3.57),('8348','2013-03-22','12:00:00',3.57),('8348','2013-03-22','12:05:00',3.61),('8348','2013-03-22','12:10:00',3.6),('8348','2013-03-22','12:15:00',3.61),('8348','2013-03-22','12:20:00',3.61),('8348','2013-03-22','12:25:00',3.63),('8348','2013-03-22','12:30:00',3.66),('8348','2013-03-22','12:35:00',3.65),('8348','2013-03-22','12:40:00',3.67),('8348','2013-03-22','12:45:00',3.65),('8348','2013-03-22','12:50:00',3.59),('8348','2013-03-22','12:55:00',3.47),('8348','2013-03-22','13:00:00',3.67),('8348','2013-03-22','13:05:00',3.56),('8348','2013-03-22','13:10:00',3.68),('8348','2013-03-22','13:15:00',3.65),('8348','2013-03-22','13:20:00',3.61),('8348','2013-03-22','13:25:00',3.42),('8348','2013-03-22','13:30:00',3.39),('8348','2013-03-22','13:35:00',3.49),('8348','2013-03-22','13:40:00',2.98),('8348','2013-03-22','13:45:00',3.12),('8348','2013-03-22','13:50:00',3.54),('8348','2013-03-22','13:55:00',3.48),('8348','2013-03-22','14:00:00',3.41),('8348','2013-03-22','14:05:00',3.37),('8348','2013-03-22','14:10:00',3.34),('8348','2013-03-22','14:15:00',3.3),('8348','2013-03-22','14:20:00',3.27),('8348','2013-03-22','14:25:00',3.23),('8348','2013-03-22','14:30:00',3.19),('8348','2013-03-22','14:35:00',3.14),('8348','2013-03-22','14:40:00',3.08),('8348','2013-03-22','14:45:00',3.03),('8348','2013-03-22','14:50:00',2.99),('8348','2013-03-22','14:55:00',2.95),('8348','2013-03-22','15:00:00',2.92),('8348','2013-03-22','15:05:00',2.83),('8348','2013-03-22','15:10:00',2.52),('8348','2013-03-22','15:15:00',2.11),('8348','2013-03-22','15:20:00',2.08),('8348','2013-03-22','15:25:00',2.23),('8348','2013-03-22','15:30:00',2.05),('8348','2013-03-22','15:35:00',2.3),('8348','2013-03-22','15:40:00',2.2),('8348','2013-03-22','15:45:00',1.96),('8348','2013-03-22','15:50:00',2.13),('8348','2013-03-22','15:55:00',1.86),('8348','2013-03-22','16:00:00',1.36),('8348','2013-03-22','16:05:00',1.41),('8348','2013-03-22','16:10:00',1.65),('8348','2013-03-22','16:15:00',1.94),('8348','2013-03-22','16:20:00',1.53),('8348','2013-03-22','16:25:00',1.58),('8348','2013-03-22','16:30:00',1.72),('8348','2013-03-22','16:35:00',1.71),('8348','2013-03-22','16:40:00',1.67),('8348','2013-03-22','16:45:00',1.55),('8348','2013-03-22','16:50:00',1.44),('8348','2013-03-22','16:55:00',1.39),('8348','2013-03-22','17:00:00',1.27),('8348','2013-03-22','17:05:00',1.13),('8348','2013-03-22','17:10:00',1.03),('8348','2013-03-21','08:15:00',1.21),('8348','2013-03-21','08:20:00',1.35),('8348','2013-03-21','08:25:00',1.69),('8348','2013-03-21','08:30:00',1.51),('8348','2013-03-21','08:35:00',1.69),('8348','2013-03-21','08:40:00',1.73),('8348','2013-03-21','08:45:00',1.93),('8348','2013-03-21','08:50:00',1.81),('8348','2013-03-21','08:55:00',1.98),('8348','2013-03-21','09:00:00',2.13),('8348','2013-03-21','09:05:00',2.4),('8348','2013-03-21','09:10:00',2.68),('8348','2013-03-21','09:15:00',1.81),('8348','2013-03-21','09:20:00',2.03),('8348','2013-03-21','09:25:00',2.44),('8348','2013-03-21','09:30:00',2.56),('8348','2013-03-21','09:35:00',2.59),('8348','2013-03-21','09:40:00',2.54),('8348','2013-03-21','09:45:00',2.71),('8348','2013-03-21','09:50:00',2.78),('8348','2013-03-21','09:55:00',2.84),('8348','2013-03-21','10:00:00',2.91),('8348','2013-03-21','10:05:00',2.93),('8348','2013-03-21','10:10:00',2.99),('8348','2013-03-21','10:15:00',3.03),('8348','2013-03-21','10:20:00',3.08),('8348','2013-03-21','10:25:00',3.11),('8348','2013-03-21','10:30:00',3.17),('8348','2013-03-21','10:35:00',3.21),('8348','2013-03-21','10:40:00',3.24),('8348','2013-03-21','10:45:00',3.24),('8348','2013-03-21','10:50:00',3.26),('8348','2013-03-21','10:55:00',2.55),('8348','2013-03-21','11:00:00',3.39),('8348','2013-03-21','11:05:00',3.43),('8348','2013-03-21','11:10:00',3.47),('8348','2013-03-21','11:15:00',3.52),('8348','2013-03-21','11:20:00',3.54),('8348','2013-03-21','11:25:00',3.59),('8348','2013-03-21','11:30:00',3.63),('8348','2013-03-21','11:35:00',3.66),('8348','2013-03-21','11:40:00',3.66),('8348','2013-03-21','11:45:00',3.69),('8348','2013-03-21','11:50:00',3.72),('8348','2013-03-21','11:55:00',3.73),('8348','2013-03-21','12:00:00',3.74),('8348','2013-03-21','12:05:00',3.76),('8348','2013-03-21','12:10:00',3.77),('8348','2013-03-21','12:15:00',3.78),('8348','2013-03-21','12:20:00',3.78),('8348','2013-03-21','12:25:00',3.79),('8348','2013-03-21','12:30:00',3.81),('8348','2013-03-21','12:35:00',3.81),('8348','2013-03-21','12:40:00',3.8),('8348','2013-03-21','12:45:00',3.79),('8348','2013-03-21','12:50:00',3.78),('8348','2013-03-21','12:55:00',3.78),('8348','2013-03-21','13:00:00',3.77),('8348','2013-03-21','13:05:00',3.73),('8348','2013-03-21','13:10:00',3.7),('8348','2013-03-21','13:15:00',3.69),('8348','2013-03-21','13:20:00',3.68),('8348','2013-03-21','13:25:00',3.66),('8348','2013-03-21','13:30:00',3.66),('8348','2013-03-21','13:35:00',3.63),('8348','2013-03-21','13:40:00',3.61),('8348','2013-03-21','13:45:00',3.58),('8348','2013-03-21','13:50:00',3.54),('8348','2013-03-21','13:55:00',3.5),('8348','2013-03-21','14:00:00',3.47),('8348','2013-03-21','14:05:00',3.42),('8348','2013-03-21','14:10:00',3.38),('8348','2013-03-21','14:15:00',3.35),('8348','2013-03-21','14:20:00',3.31),('8348','2013-03-21','14:25:00',3.27),('8348','2013-03-21','14:30:00',3.2),('8348','2013-03-21','14:35:00',3.13),('8348','2013-03-21','14:40:00',3.1),('8348','2013-03-21','14:45:00',3.07),('8348','2013-03-21','14:50:00',3.04),('8348','2013-03-21','14:55:00',2.98),('8348','2013-03-21','15:00:00',2.92),('8348','2013-03-21','15:05:00',2.87),('8348','2013-03-21','15:10:00',2.81),('8348','2013-03-21','15:15:00',2.76),('8348','2013-03-21','15:20:00',2.69),('8348','2013-03-21','15:25:00',2.64),('8348','2013-03-21','15:30:00',2.57),('8348','2013-03-21','15:35:00',2.5),('8348','2013-03-21','15:40:00',2.43),('8348','2013-03-21','15:45:00',2.35),('8348','2013-03-21','15:50:00',2.28),('8348','2013-03-21','15:55:00',2.21),('8348','2013-03-21','16:00:00',2.14),('8348','2013-03-21','16:05:00',2.07),('8348','2013-03-21','16:10:00',1.98),('8348','2013-03-21','16:15:00',1.91),('8348','2013-03-21','16:20:00',1.83),('8348','2013-03-21','16:25:00',1.73),('8348','2013-03-21','16:30:00',1.63),('8348','2013-03-21','16:35:00',1.54),('8348','2013-03-21','16:40:00',1.44),('8348','2013-03-21','16:45:00',1.38),('8348','2013-03-21','16:50:00',1.29),('8348','2013-03-21','16:55:00',1.19),('8348','2013-03-21','17:00:00',1.1),('8348','2013-03-21','17:05:00',1.02),('8348','2013-03-20','07:55:00',1.08),('8348','2013-03-20','08:00:00',1.03),('8348','2013-03-20','08:05:00',1.07),('8348','2013-03-20','08:10:00',1.16),('8348','2013-03-20','08:15:00',1.22),('8348','2013-03-20','08:20:00',1.29),('8348','2013-03-20','08:25:00',1.4),('8348','2013-03-20','08:30:00',1.52),('8348','2013-03-20','08:35:00',1.62),('8348','2013-03-20','08:40:00',1.49),('8348','2013-03-20','08:45:00',1.68),('8348','2013-03-20','08:50:00',1.78),('8348','2013-03-20','08:55:00',1.77),('8348','2013-03-20','09:00:00',1.79),('8348','2013-03-20','09:05:00',2.4),('8348','2013-03-20','09:10:00',1.95),('8348','2013-03-20','09:15:00',2.17),('8348','2013-03-20','09:20:00',2.24),('8348','2013-03-20','09:25:00',2.09),('8348','2013-03-20','09:30:00',2.38),('8348','2013-03-20','09:35:00',2.29),('8348','2013-03-20','09:40:00',2.42),('8348','2013-03-20','09:45:00',2.49),('8348','2013-03-20','09:50:00',2.53),('8348','2013-03-20','09:55:00',2.54),('8348','2013-03-20','10:00:00',2.63),('8348','2013-03-20','10:05:00',2.66),('8348','2013-03-20','10:10:00',2.64),('8348','2013-03-20','10:15:00',2.07),('8348','2013-03-20','10:20:00',2.07),('8348','2013-03-20','10:25:00',1.96),('8348','2013-03-20','10:30:00',2.56),('8348','2013-03-20','10:35:00',3.16),('8348','2013-03-20','10:40:00',2.53),('8348','2013-03-20','10:45:00',2.11),('8348','2013-03-20','10:50:00',2.85),('8348','2013-03-20','10:55:00',2.47),('8348','2013-03-20','11:00:00',2.38),('8348','2013-03-20','11:05:00',2.88),('8348','2013-03-20','11:10:00',2.2),('8348','2013-03-20','11:15:00',2.12),('8348','2013-03-20','11:20:00',2.29),('8348','2013-03-20','11:25:00',2.26),('8348','2013-03-20','11:30:00',2.1),('8348','2013-03-20','11:35:00',2.33),('8348','2013-03-20','11:40:00',1.91),('8348','2013-03-20','11:45:00',1.82),('8348','2013-03-20','11:50:00',1.77),('8348','2013-03-20','11:55:00',1.96),('8348','2013-03-20','12:00:00',1.91),('8348','2013-03-20','12:05:00',2.13),('8348','2013-03-20','12:10:00',1.77),('8348','2013-03-20','12:15:00',1.52),('8348','2013-03-20','12:20:00',1.41),('8348','2013-03-20','12:25:00',1.19),('8348','2013-03-20','12:35:00',1.23),('8348','2013-03-20','12:50:00',1.32),('8348','2013-03-20','12:55:00',1.57),('8348','2013-03-20','13:00:00',1.69),('8348','2013-03-20','13:05:00',1.26),('8348','2013-03-20','13:10:00',1.29),('8348','2013-03-20','13:15:00',1.04),('8348','2013-03-20','13:20:00',1.13),('8348','2013-03-20','13:25:00',1.23),('8348','2013-03-20','13:30:00',1.34),('8348','2013-03-20','13:35:00',1.28),('8348','2013-03-20','13:40:00',1.59),('8348','2013-03-20','13:45:00',1.84),('8348','2013-03-20','13:50:00',1.56),('8348','2013-03-20','13:55:00',1.45),('8348','2013-03-20','14:00:00',1.45),('8348','2013-03-20','14:05:00',1.24),('8348','2013-03-20','14:10:00',1.16),('8348','2013-03-20','14:15:00',1.56),('8348','2013-03-20','14:20:00',1.93),('8348','2013-03-20','14:25:00',1.8),('8348','2013-03-20','14:30:00',1.56),('8348','2013-03-20','14:35:00',1.27),('8348','2013-03-20','14:40:00',1),('8348','2013-03-19','08:10:00',1.09),('8348','2013-03-19','08:15:00',1.19),('8348','2013-03-19','08:20:00',1.24),('8348','2013-03-19','08:25:00',1.32),('8348','2013-03-19','08:30:00',1.35),('8348','2013-03-19','08:35:00',1.48),('8348','2013-03-19','08:40:00',1.59),('8348','2013-03-19','08:45:00',1.72),('8348','2013-03-19','08:50:00',1.81),('8348','2013-03-19','08:55:00',1.85),('8348','2013-03-19','09:00:00',1.93),('8348','2013-03-19','09:05:00',1.85),('8348','2013-03-19','09:10:00',2.09),('8348','2013-03-19','09:15:00',1.71),('8348','2013-03-19','09:20:00',1.73),('8348','2013-03-19','09:25:00',2.24),('8348','2013-03-19','09:30:00',2.38),('8348','2013-03-19','09:35:00',2.44),('8348','2013-03-19','09:40:00',2.56),('8348','2013-03-19','09:45:00',2.48),('8348','2013-03-19','09:50:00',2.64),('8348','2013-03-19','09:55:00',2.27),('8348','2013-03-19','10:00:00',2.96),('8348','2013-03-19','10:05:00',2.25),('8348','2013-03-19','10:10:00',2.59),('8348','2013-03-19','10:15:00',2.92),('8348','2013-03-19','10:20:00',2.98),('8348','2013-03-19','10:25:00',3.08),('8348','2013-03-19','10:30:00',3.09),('8348','2013-03-19','10:35:00',3.13),('8348','2013-03-19','10:40:00',3.16),('8348','2013-03-19','10:45:00',3.22),('8348','2013-03-19','10:50:00',3.24),('8348','2013-03-19','10:55:00',3.35),('8348','2013-03-19','11:00:00',3.36),('8348','2013-03-19','11:05:00',3.38),('8348','2013-03-19','11:10:00',3.32),('8348','2013-03-19','11:15:00',3.45),('8348','2013-03-19','11:20:00',3.45),('8348','2013-03-19','11:25:00',3.47),('8348','2013-03-19','11:30:00',3.46),('8348','2013-03-19','11:35:00',2.17),('8348','2013-03-19','11:40:00',3.14),('8348','2013-03-19','11:45:00',3.27),('8348','2013-03-19','11:50:00',3.64),('8348','2013-03-19','11:55:00',3.69),('8348','2013-03-19','12:00:00',3.64),('8348','2013-03-19','12:05:00',3.61),('8348','2013-03-19','12:10:00',3.65),('8348','2013-03-19','12:15:00',3.45),('8348','2013-03-19','12:20:00',3.67),('8348','2013-03-19','12:25:00',3.61),('8348','2013-03-19','12:30:00',3.62),('8348','2013-03-19','12:35:00',3.63),('8348','2013-03-19','12:40:00',3.67),('8348','2013-03-19','12:45:00',3.69),('8348','2013-03-19','12:50:00',3.57),('8348','2013-03-19','12:55:00',3.59),('8348','2013-03-19','13:00:00',3.65),('8348','2013-03-19','13:05:00',3.63),('8348','2013-03-19','13:10:00',3.58),('8348','2013-03-19','13:15:00',3.59),('8348','2013-03-19','13:20:00',3.54),('8348','2013-03-19','13:25:00',3.52),('8348','2013-03-19','13:30:00',3.51),('8348','2013-03-19','13:35:00',3.46),('8348','2013-03-19','13:40:00',3.41),('8348','2013-03-19','13:45:00',3.43),('8348','2013-03-19','13:50:00',3.41),('8348','2013-03-19','13:55:00',3.37),('8348','2013-03-19','14:00:00',3.36),('8348','2013-03-19','14:05:00',3.32),('8348','2013-03-19','14:10:00',3.29),('8348','2013-03-19','14:15:00',3.25),('8348','2013-03-19','14:20:00',3.21),('8348','2013-03-19','14:25:00',3.17),('8348','2013-03-19','14:30:00',3.14),('8348','2013-03-19','14:35:00',3.08),('8348','2013-03-19','14:40:00',3.04),('8348','2013-03-19','14:45:00',2.99),('8348','2013-03-19','14:50:00',2.92),('8348','2013-03-19','14:55:00',2.86),('8348','2013-03-19','15:00:00',2.81),('8348','2013-03-19','15:05:00',2.77),('8348','2013-03-19','15:10:00',2.71),('8348','2013-03-19','15:15:00',2.63),('8348','2013-03-19','15:20:00',2.59),('8348','2013-03-19','15:25:00',2.53),('8348','2013-03-19','15:30:00',2.47),('8348','2013-03-19','15:35:00',2.42),('8348','2013-03-19','15:40:00',2.34),('8348','2013-03-19','15:45:00',2.27),('8348','2013-03-19','15:50:00',2.2),('8348','2013-03-19','15:55:00',2.13),('8348','2013-03-19','16:00:00',2.05),('8348','2013-03-19','16:05:00',1.96),('8348','2013-03-19','16:10:00',1.88),('8348','2013-03-19','16:15:00',1.81),('8348','2013-03-19','16:20:00',1.73),('8348','2013-03-19','16:25:00',1.67),('8348','2013-03-19','16:30:00',1.59),('8348','2013-03-19','16:35:00',1.49),('8348','2013-03-19','16:40:00',1.42),('8348','2013-03-19','16:45:00',1.15),('8348','2013-03-18','10:00:00',1.13),('8348','2013-03-18','10:05:00',1.34),('8348','2013-03-18','10:10:00',1.35),('8348','2013-03-18','10:15:00',1.19),('8348','2013-03-18','10:20:00',1.39),('8348','2013-03-18','10:25:00',1.66),('8348','2013-03-18','10:30:00',1.63),('8348','2013-03-18','10:35:00',1.38),('8348','2013-03-18','10:40:00',1.3),('8348','2013-03-18','10:45:00',1.37),('8348','2013-03-18','10:50:00',1.29),('8348','2013-03-18','10:55:00',1.07),('8348','2013-03-18','11:00:00',1.18),('8348','2013-03-18','11:05:00',1.31),('8348','2013-03-18','11:10:00',1.47),('8348','2013-03-18','11:15:00',1.61),('8348','2013-03-18','11:20:00',1.65),('8348','2013-03-18','11:25:00',1.71),('8348','2013-03-18','11:30:00',2.16),('8348','2013-03-18','11:35:00',1.81),('8348','2013-03-18','11:40:00',1.62),('8348','2013-03-18','11:45:00',1.39),('8348','2013-03-18','11:50:00',1.14),('8348','2013-03-18','11:55:00',1.36),('8348','2013-03-18','12:00:00',1.43),('8348','2013-03-18','12:05:00',2.4),('8348','2013-03-18','12:10:00',2.25),('8348','2013-03-18','12:15:00',2.72),('8348','2013-03-18','12:20:00',2.54),('8348','2013-03-18','12:25:00',1.82),('8348','2013-03-18','12:30:00',3.01),('8348','2013-03-18','12:35:00',3.39),('8348','2013-03-18','12:40:00',2.61),('8348','2013-03-18','12:45:00',2.4),('8348','2013-03-18','12:50:00',3.27),('8348','2013-03-18','12:55:00',3.49),('8348','2013-03-18','13:00:00',2.76),('8348','2013-03-18','13:05:00',1.4),('8348','2013-03-18','13:10:00',1.06),('8348','2013-03-18','13:20:00',1.01),('8348','2013-03-18','13:25:00',1.74),('8348','2013-03-18','13:30:00',1.26),('8348','2013-03-18','13:35:00',1.07),('8348','2013-03-18','13:40:00',1.85),('8348','2013-03-18','13:45:00',1.66),('8348','2013-03-18','13:50:00',1.56),('8348','2013-03-18','13:55:00',1.38),('8348','2013-03-18','14:00:00',1.52),('8348','2013-03-18','14:05:00',2.34),('8348','2013-03-18','14:10:00',2.16),('8348','2013-03-18','14:15:00',1.13),('8348','2013-03-18','14:20:00',1.07),('8348','2013-03-18','14:25:00',1.52),('8348','2013-03-18','14:35:00',1.03),('8348','2013-03-18','14:40:00',1.07),('8348','2013-03-17','08:20:00',1.06),('8348','2013-03-17','08:25:00',1.29),('8348','2013-03-17','08:30:00',1.15),('8348','2013-03-17','08:35:00',1.01),('8348','2013-03-17','08:40:00',1.04),('8348','2013-03-17','08:45:00',1.22),('8348','2013-03-17','08:50:00',1.21),('8348','2013-03-17','08:55:00',1.15),('8348','2013-03-17','09:00:00',1.13),('8348','2013-03-17','09:05:00',1.31),('8348','2013-03-17','09:10:00',1.5),('8348','2013-03-17','09:15:00',1.6),('8348','2013-03-17','09:20:00',1.38),('8348','2013-03-17','09:25:00',1.18),('8348','2013-03-17','09:30:00',1.29),('8348','2013-03-17','09:35:00',1.45),('8348','2013-03-17','09:40:00',1.37),('8348','2013-03-17','09:45:00',1.41),('8348','2013-03-17','09:50:00',1.58),('8348','2013-03-17','09:55:00',1.68),('8348','2013-03-17','10:00:00',1.85),('8348','2013-03-17','10:05:00',1.56),('8348','2013-03-17','10:10:00',1.54),('8348','2013-03-17','10:15:00',1.67),('8348','2013-03-17','10:20:00',1.69),('8348','2013-03-17','10:25:00',1.77),('8348','2013-03-17','10:30:00',1.73),('8348','2013-03-17','10:35:00',1.66),('8348','2013-03-17','10:40:00',1.58),('8348','2013-03-17','10:45:00',1.66),('8348','2013-03-17','10:50:00',1.57),('8348','2013-03-17','10:55:00',1.42),('8348','2013-03-17','11:00:00',1.45),('8348','2013-03-17','11:05:00',1.24),('8348','2013-03-17','11:10:00',1.21),('8348','2013-03-17','11:15:00',1.34),('8348','2013-03-17','11:20:00',1.55),('8348','2013-03-17','11:25:00',1.58),('8348','2013-03-17','11:30:00',1.41),('8348','2013-03-17','11:35:00',1.4),('8348','2013-03-17','11:40:00',1.33),('8348','2013-03-17','11:45:00',1.23),('8348','2013-03-17','11:50:00',1.14),('8348','2013-03-17','11:55:00',1.02),('8348','2013-03-17','12:10:00',1.29),('8348','2013-03-17','12:15:00',1.76),('8348','2013-03-17','12:20:00',2.12),('8348','2013-03-17','12:25:00',3.05),('8348','2013-03-17','12:30:00',3.28),('8348','2013-03-17','12:35:00',2.2),('8348','2013-03-17','12:40:00',2.38),('8348','2013-03-17','12:45:00',2.23),('8348','2013-03-17','12:50:00',1.97),('8348','2013-03-17','12:55:00',1.6),('8348','2013-03-17','13:00:00',1.86),('8348','2013-03-17','13:05:00',2.02),('8348','2013-03-17','13:10:00',2.23),('8348','2013-03-17','13:15:00',2.16),('8348','2013-03-17','13:20:00',1.82),('8348','2013-03-17','13:25:00',1.64),('8348','2013-03-17','13:30:00',2.5),('8348','2013-03-17','13:35:00',2.65),('8348','2013-03-17','13:40:00',1.84),('8348','2013-03-17','13:45:00',1.66),('8348','2013-03-17','13:50:00',1.31),('8348','2013-03-17','13:55:00',1.98),('8348','2013-03-17','14:00:00',1.92),('8348','2013-03-17','14:05:00',1.96),('8348','2013-03-17','14:10:00',2.31),('8348','2013-03-17','14:15:00',2.49),('8348','2013-03-17','14:20:00',2.49),('8348','2013-03-17','14:25:00',2.27),('8348','2013-03-17','14:30:00',2.1),('8348','2013-03-17','14:35:00',1.77),('8348','2013-03-17','14:40:00',1.35),('8348','2013-03-17','14:45:00',1.22),('8348','2013-03-17','14:50:00',1.05),('8348','2013-03-17','14:55:00',1.13),('8348','2013-03-17','15:00:00',1.46),('8348','2013-03-17','15:05:00',1.57),('8348','2013-03-17','15:10:00',2.03),('8348','2013-03-17','15:15:00',1.93),('8348','2013-03-17','15:20:00',2.26),('8348','2013-03-17','15:25:00',1.99),('8348','2013-03-17','15:30:00',1.24),('8348','2013-03-17','15:35:00',1.53),('8348','2013-03-17','15:40:00',1.49),('8348','2013-03-17','15:45:00',1.4),('8348','2013-03-17','16:45:00',1.13),('8348','2013-03-16','08:15:00',1.3),('8348','2013-03-16','08:20:00',1.46),('8348','2013-03-16','08:25:00',1.46),('8348','2013-03-16','08:30:00',1.46),('8348','2013-03-16','08:35:00',1.57),('8348','2013-03-16','08:40:00',1.67),('8348','2013-03-16','08:45:00',1.66),('8348','2013-03-16','08:50:00',1.88),('8348','2013-03-16','08:55:00',2.04),('8348','2013-03-16','09:00:00',2.03),('8348','2013-03-16','09:05:00',1.68),('8348','2013-03-16','09:10:00',2.06),('8348','2013-03-16','09:15:00',2.23),('8348','2013-03-16','09:20:00',2.27),('8348','2013-03-16','09:25:00',1.69),('8348','2013-03-16','09:30:00',2.45),('8348','2013-03-16','09:35:00',2.61),('8348','2013-03-16','09:40:00',2.45),('8348','2013-03-16','09:45:00',2.77),('8348','2013-03-16','09:50:00',2.73),('8348','2013-03-16','09:55:00',2.85),('8348','2013-03-16','10:00:00',2.41),('8348','2013-03-16','10:05:00',1.54),('8348','2013-03-16','10:10:00',2.17),('8348','2013-03-16','10:18:00',1.96),('8348','2013-03-16','10:20:00',1.48),('8348','2013-03-16','10:25:00',1.95),('8348','2013-03-16','10:30:00',1.72),('8348','2013-03-16','10:35:00',1.79),('8348','2013-03-16','10:40:00',2.6),('8348','2013-03-16','10:45:00',3.25),('8348','2013-03-16','10:50:00',3.25),('8348','2013-03-16','10:55:00',3.22),('8348','2013-03-16','11:00:00',3.31),('8348','2013-03-16','11:05:00',3.32),('8348','2013-03-16','11:10:00',3.35),('8348','2013-03-16','11:18:00',3.37),('8348','2013-03-16','11:20:00',3.41),('8348','2013-03-16','11:25:00',3.41),('8348','2013-03-16','11:30:00',3.44),('8348','2013-03-16','11:35:00',3.44),('8348','2013-03-16','11:40:00',3.48),('8348','2013-03-16','11:45:00',3.49),('8348','2013-03-16','11:50:00',3.51),('8348','2013-03-16','11:55:00',3.51),('8348','2013-03-16','12:00:00',3.52),('8348','2013-03-16','12:05:00',3.52),('8348','2013-03-16','12:10:00',3.51),('8348','2013-03-16','12:15:00',3.52),('8348','2013-03-16','12:20:00',3.52),('8348','2013-03-16','12:25:00',3.52),('8348','2013-03-16','12:30:00',3.53),('8348','2013-03-16','12:35:00',3.53),('8348','2013-03-16','12:40:00',3.52),('8348','2013-03-16','12:45:00',3.53),('8348','2013-03-16','12:50:00',3.52),('8348','2013-03-16','12:55:00',3.49),('8348','2013-03-16','13:00:00',3.46),('8348','2013-03-16','13:05:00',3.44),('8348','2013-03-16','13:10:00',3.43),('8348','2013-03-16','13:15:00',3.42),('8348','2013-03-16','13:20:00',3.11),('8348','2013-03-16','13:30:00',2.25),('8348','2013-03-16','13:35:00',3.41),('8348','2013-03-16','13:40:00',3.44),('8348','2013-03-16','13:45:00',3.45),('8348','2013-03-16','13:50:00',3.07),('8348','2013-03-16','13:55:00',2.99),('8348','2013-03-16','14:00:00',3.5),('8348','2013-03-16','14:05:00',3.37),('8348','2013-03-16','14:15:00',3.18),('8348','2013-03-16','14:20:00',1.52),('8348','2013-03-16','14:25:00',1.82),('8348','2013-03-16','14:30:00',3.36),('8348','2013-03-16','14:35:00',2.8),('8348','2013-03-16','14:40:00',1.12),('8348','2013-03-16','15:40:00',1.01),('8348','2013-03-16','16:00:00',1.85),('8348','2013-03-16','16:05:00',1.92),('8348','2013-03-16','16:10:00',1.92),('8348','2013-03-16','16:15:00',1.56),('8348','2013-03-16','16:55:00',1.17),('8348','2013-03-16','17:00:00',1.06),('8348','2013-03-16','17:05:00',1.05),('8348','2013-03-15','10:40:00',1.13),('8348','2013-03-15','10:45:00',1.3),('8348','2013-03-15','10:50:00',1.33),('8348','2013-03-15','10:55:00',1.42),('8348','2013-03-15','11:00:00',1.38),('8348','2013-03-15','11:05:00',1.21),('8348','2013-03-15','11:10:00',1.17),('8348','2013-03-15','11:20:00',1.14),('8348','2013-03-15','11:25:00',1.39),('8348','2013-03-15','11:30:00',1.56),('8348','2013-03-15','11:35:00',1.92),('8348','2013-03-15','11:40:00',2.27),('8348','2013-03-15','11:45:00',2.01),('8348','2013-03-15','11:50:00',1.86),('8348','2013-03-15','11:55:00',1.94),('8348','2013-03-15','12:00:00',1.74),('8348','2013-03-15','12:05:00',1.71),('8348','2013-03-15','12:10:00',1.86),('8348','2013-03-15','12:15:00',1.65),('8348','2013-03-15','12:20:00',1.61),('8348','2013-03-15','12:25:00',1.7),('8348','2013-03-15','12:30:00',1.74),('8348','2013-03-15','12:35:00',1.95),('8348','2013-03-15','12:40:00',1.67),('8348','2013-03-15','12:45:00',1.38),('8348','2013-03-15','12:50:00',1.3),('8348','2013-03-15','12:55:00',1.27),('8348','2013-03-15','13:00:00',1.2),('8348','2013-03-15','13:05:00',1.1),('8348','2013-03-15','13:10:00',1.17),('8348','2013-03-15','13:15:00',1.3),('8348','2013-03-15','13:20:00',1.4),('8348','2013-03-15','13:25:00',1.55),('8348','2013-03-15','13:30:00',1.47),('8348','2013-03-15','13:35:00',1.35),('8348','2013-03-15','13:40:00',1.39),('8348','2013-03-15','13:45:00',1.47),('8348','2013-03-15','13:50:00',1.2),('8348','2013-03-15','13:55:00',1.04),('8348','2013-03-15','14:55:00',1.08),('8348','2013-03-15','15:00:00',1.13),('8348','2013-03-15','15:05:00',1.07),('8348','2013-03-15','15:10:00',1.07),('8348','2013-03-15','15:15:00',1.16),('8348','2013-03-15','15:20:00',1.2),('8348','2013-03-15','15:25:00',1.29),('8348','2013-03-15','15:30:00',1.11),('8348','2013-03-14','13:05:00',1.01),('8348','2013-03-14','13:10:00',1.07),('8348','2013-03-14','13:15:00',1.04),('8348','2013-03-14','13:20:00',1.08),('8348','2013-03-14','13:25:00',1.09),('8348','2013-03-14','13:30:00',1.07),('8348','2013-03-14','13:35:00',1.1),('8348','2013-03-14','13:40:00',1.05),('8348','2013-03-14','13:45:00',1.34),('8348','2013-03-14','13:50:00',1.72),('8348','2013-03-14','13:55:00',1.89),('8348','2013-03-14','14:00:00',1.73),('8348','2013-03-14','14:05:00',1.83),('8348','2013-03-14','14:10:00',1.37),('8348','2013-03-14','14:15:00',1.18),('8348','2013-03-14','14:20:00',1.08),('8348','2013-03-14','14:25:00',1.07),('8348','2013-03-14','15:10:00',1.2),('8348','2013-03-14','15:15:00',1.18),('8348','2013-03-14','15:20:00',1.1),('8348','2013-03-14','15:25:00',1.15),('8348','2013-03-14','15:30:00',1.11),('8348','2013-03-13','08:50:00',1.01),('8348','2013-03-13','09:10:00',1.04),('8348','2013-03-13','10:10:00',1.13),('8348','2013-03-13','10:15:00',1.78),('8348','2013-03-13','10:20:00',1.4),('8348','2013-03-13','10:25:00',1.86),('8348','2013-03-13','10:30:00',3.07),('8348','2013-03-13','10:35:00',2.6),('8348','2013-03-13','10:40:00',2.44),('8348','2013-03-13','10:45:00',1.4),('8348','2013-03-13','10:50:00',1.12),('8348','2013-03-13','11:00:00',1.08),('8348','2013-03-13','11:10:00',1.13),('8348','2013-03-13','11:30:00',1.06),('8348','2013-03-13','11:35:00',1.11),('8348','2013-03-13','11:40:00',1.12),('8348','2013-03-13','11:45:00',1.27),('8348','2013-03-13','11:50:00',1.14),('8348','2013-03-13','12:45:00',1.03),('8348','2013-03-13','12:50:00',1.2),('8348','2013-03-13','12:55:00',1.08),('8348','2013-03-13','13:00:00',1.05),('8348','2013-03-13','13:05:00',1.03),('8348','2014-03-25','07:10:00',1.1),('8348','2014-03-25','07:15:00',1.36),('8348','2014-03-25','07:20:00',1.59),('8348','2014-03-25','07:25:00',1.8),('8348','2014-03-25','07:30:00',1.94),('8348','2014-03-25','07:35:00',1.67),('8348','2014-03-25','07:40:00',1.63),('8348','2014-03-25','07:45:00',1.82),('8348','2014-03-25','07:50:00',1.97),('8348','2014-03-25','07:55:00',2.03),('8348','2014-03-25','08:00:00',1.99),('8348','2014-03-25','08:05:00',2.07),('8348','2014-03-25','08:10:00',2.21),('8348','2014-03-25','08:15:00',2.3),('8348','2014-03-25','08:20:00',2.16),('8348','2014-03-25','08:25:00',2.01),('8348','2014-03-25','08:30:00',1.87),('8348','2014-03-25','08:35:00',1.92),('8348','2014-03-25','08:40:00',2.26),('8348','2014-03-25','08:45:00',3.03),('8348','2014-03-25','08:50:00',3.1),('8348','2014-03-25','08:55:00',3.24),('8348','2014-03-25','09:00:00',2.97),('8348','2014-03-25','09:05:00',2.94),('8348','2014-03-25','09:10:00',2.97),('8348','2014-03-25','09:15:00',3.83),('8348','2014-03-25','09:20:00',4.11),('8348','2014-03-25','09:25:00',3.68),('8348','2014-03-25','09:30:00',3.36),('8348','2014-03-25','09:35:00',3.14),('8348','2014-03-25','09:40:00',3.17),('8348','2014-03-25','09:45:00',3.01),('8348','2014-03-25','09:50:00',3.13),('8348','2014-03-25','09:55:00',3.45),('8348','2014-03-25','10:00:00',3.94),('8348','2014-03-25','10:05:00',4.18),('8348','2014-03-25','10:10:00',4.41),('8348','2014-03-25','10:15:00',4.44),('8348','2014-03-25','10:20:00',4.43),('8348','2014-03-25','10:25:00',4.63),('8348','2014-03-25','10:30:00',5.01),('8348','2014-03-25','10:35:00',4.23),('8348','2014-03-25','10:40:00',3.58),('8348','2014-03-25','10:45:00',3.35),('8348','2014-03-25','10:50:00',3.25),('8348','2014-03-25','10:55:00',3.28),('8348','2014-03-25','11:00:00',3.58),('8348','2014-03-25','11:05:00',4.02),('8348','2014-03-25','11:10:00',4.5),('8348','2014-03-25','11:15:00',5.07),('8348','2014-03-25','11:20:00',4.41),('8348','2014-03-25','11:25:00',5.01),('8348','2014-03-25','11:30:00',5.07),('8348','2014-03-25','11:35:00',4.11),('8348','2014-03-25','11:40:00',4.66),('8348','2014-03-25','11:45:00',3.54),('8348','2014-03-25','11:50:00',4.41),('8348','2014-03-25','11:55:00',3.22),('8348','2014-03-25','12:00:00',2.23),('8348','2014-03-25','12:05:00',1.43),('8348','2014-03-25','12:10:00',1.36),('8348','2014-03-25','12:15:00',1.57),('8348','2014-03-25','12:20:00',2.03),('8348','2014-03-25','12:25:00',2.32),('8348','2014-03-25','12:30:00',1.88),('8348','2014-03-25','12:35:00',1.5),('8348','2014-03-25','12:40:00',1.54),('8348','2014-03-25','12:45:00',1.52),('8348','2014-03-25','12:50:00',1.04),('8348','2014-03-25','13:30:00',1.16),('8348','2014-03-25','13:35:00',1.52),('8348','2014-03-25','13:40:00',1.52),('8348','2014-03-25','13:45:00',1.33),('8348','2014-03-25','13:50:00',1.34),('8348','2014-03-25','13:55:00',1.34),('8348','2014-03-25','14:00:00',1.26),('8348','2014-03-25','14:05:00',1.32),('8348','2014-03-25','14:10:00',1.45),('8348','2014-03-25','14:15:00',1.58),('8348','2014-03-25','14:20:00',1.21),('8348','2014-03-25','14:35:00',1.16),('8348','2014-03-25','14:40:00',1.17),('8348','2014-03-25','14:45:00',1.23),('8348','2014-03-25','14:50:00',1.06),('8348','2014-03-25','15:15:00',1.14),('8348','2014-03-25','15:20:00',1.17),('8348','2013-03-12','08:20:00',1.23),('8348','2013-03-12','08:25:00',1.22),('8348','2013-03-12','08:30:00',1.28),('8348','2013-03-12','08:35:00',1.22),('8348','2013-03-12','08:40:00',1.24),('8348','2013-03-12','08:45:00',1.69),('8348','2013-03-12','08:50:00',1.01),('8348','2013-03-12','09:00:00',1.27),('8348','2013-03-12','09:05:00',1.85),('8348','2013-03-12','09:10:00',1.91),('8348','2013-03-12','09:15:00',1.97),('8348','2013-03-12','09:20:00',2.03),('8348','2013-03-12','09:25:00',2.09),('8348','2013-03-12','09:30:00',2.11),('8348','2013-03-12','09:35:00',2.25),('8348','2013-03-12','09:40:00',2.38),('8348','2013-03-12','09:45:00',1.98),('8348','2013-03-12','09:50:00',2.42),('8348','2013-03-12','09:55:00',2.55),('8348','2013-03-12','10:00:00',2.71),('8348','2013-03-12','10:05:00',2.41),('8348','2013-03-12','10:10:00',2.1),('8348','2013-03-12','10:15:00',2.62),('8348','2013-03-12','10:20:00',2.66),('8348','2013-03-12','10:25:00',3.15),('8348','2013-03-12','10:30:00',2.63),('8348','2013-03-12','10:35:00',2.01),('8348','2013-03-12','10:40:00',2.98),('8348','2013-03-12','10:45:00',1.64),('8348','2013-03-12','10:50:00',3.16),('8348','2013-03-12','10:55:00',3.15),('8348','2013-03-12','11:00:00',3.07),('8348','2013-03-12','11:05:00',3.35),('8348','2013-03-12','11:10:00',3.04),('8348','2013-03-12','11:15:00',2.9),('8348','2013-03-12','11:20:00',3.82),('8348','2013-03-12','11:25:00',1.37),('8348','2013-03-12','11:30:00',1.55),('8348','2013-03-12','11:35:00',1.81),('8348','2013-03-12','11:40:00',1.98),('8348','2013-03-12','11:45:00',2.21),('8348','2013-03-12','11:50:00',2.53),('8348','2013-03-12','11:55:00',3.31),('8348','2013-03-12','12:05:00',1.36),('8348','2013-03-12','12:10:00',3.95),('8348','2013-03-12','12:15:00',2.49),('8348','2013-03-12','12:20:00',2.25),('8348','2013-03-12','12:25:00',3.9),('8348','2013-03-12','12:30:00',4.63),('8348','2013-03-12','12:35:00',2.51),('8348','2013-03-12','12:40:00',3.21),('8348','2013-03-12','12:45:00',1.05),('8348','2013-03-12','12:50:00',1.63),('8348','2013-03-12','12:55:00',2.35),('8348','2013-03-12','13:00:00',3.92),('8348','2013-03-12','13:05:00',1.91),('8348','2013-03-12','13:10:00',2.35),('8348','2013-03-12','13:15:00',2.17),('8348','2013-03-12','13:20:00',2.57),('8348','2013-03-12','13:25:00',1.8),('8348','2013-03-12','13:30:00',1.46),('8348','2013-03-12','13:35:00',2.17),('8348','2013-03-12','13:40:00',1.64),('8348','2013-03-12','13:45:00',1.23),('8348','2013-03-12','13:50:00',1.13),('8348','2013-03-12','13:55:00',2.11),('8348','2013-03-12','14:00:00',2.63),('8348','2013-03-12','14:05:00',2),('8348','2013-03-12','14:10:00',2.02),('8348','2013-03-12','15:15:00',1.02),('8348','2013-03-12','15:20:00',1.03),('8348','2013-03-11','08:20:00',1.04),('8348','2013-03-11','08:25:00',1.11),('8348','2013-03-11','08:30:00',1.18),('8348','2013-03-11','08:35:00',1.26),('8348','2013-03-11','08:40:00',1.34),('8348','2013-03-11','08:45:00',1.44),('8348','2013-03-11','08:50:00',1.54),('8348','2013-03-11','08:55:00',1.62),('8348','2013-03-11','09:00:00',1.72),('8348','2013-03-11','09:05:00',1.79),('8348','2013-03-11','09:10:00',1.86),('8348','2013-03-11','09:15:00',1.95),('8348','2013-03-11','09:20:00',1.72),('8348','2013-03-11','09:25:00',1.58),('8348','2013-03-11','09:35:00',2.33),('8348','2013-03-11','09:40:00',2.21),('8348','2013-03-11','09:45:00',2.02),('8348','2013-03-11','10:10:00',1.09),('8348','2013-03-11','10:15:00',1.11),('8348','2013-03-11','10:20:00',1.22),('8348','2013-03-11','10:25:00',1.34),('8348','2013-03-11','10:30:00',1.22),('8348','2013-03-11','10:35:00',1.4),('8348','2013-03-11','10:40:00',1.94),('8348','2013-03-11','10:45:00',2.04),('8348','2013-03-11','10:50:00',2.62),('8348','2013-03-11','10:55:00',1.65),('8348','2013-03-11','11:00:00',1.42),('8348','2013-03-11','11:05:00',1.16),('8348','2013-03-11','11:10:00',1.31),('8348','2013-03-11','11:15:00',1.4),('8348','2013-03-11','11:20:00',1.25),('8348','2013-03-11','11:25:00',1.13),('8348','2013-03-11','11:30:00',1.98),('8348','2013-03-11','11:35:00',1.76),('8348','2013-03-11','11:40:00',1.77),('8348','2013-03-11','11:45:00',2.36),('8348','2013-03-11','11:50:00',2.05),('8348','2013-03-11','11:55:00',1.83),('8348','2013-03-11','12:00:00',1.65),('8348','2013-03-11','12:05:00',1.61),('8348','2013-03-11','12:10:00',3),('8348','2013-03-11','12:35:00',1.44),('8348','2013-03-11','12:40:00',1.13),('8348','2013-03-11','12:45:00',1.21),('8348','2013-03-11','12:50:00',2.04),('8348','2013-03-11','12:55:00',3.14),('8348','2013-03-11','13:00:00',2.1),('8348','2013-03-11','13:05:00',1.72),('8348','2013-03-11','13:10:00',2.4),('8348','2013-03-11','13:15:00',3.33),('8348','2013-03-11','13:20:00',3.39),('8348','2013-03-11','13:25:00',3.43),('8348','2013-03-11','13:30:00',3.24),('8348','2013-03-11','13:35:00',3.6),('8348','2013-03-11','13:40:00',2.97),('8348','2013-03-11','13:45:00',2.27),('8348','2013-03-11','13:50:00',1.35),('8348','2013-03-11','13:55:00',1.96),('8348','2013-03-11','14:20:00',1.29),('8348','2013-03-11','14:25:00',1.55),('8348','2013-03-11','14:30:00',1.13),('8348','2013-03-11','14:40:00',1.47),('8348','2013-03-11','15:25:00',1.59),('8348','2013-03-11','15:30:00',2.47),('8348','2013-03-11','15:35:00',1.41),('8348','2013-03-11','15:40:00',1.5),('8348','2013-03-11','15:45:00',2.71),('8348','2013-03-11','15:50:00',2.27),('8348','2013-03-11','15:55:00',1.87),('8348','2013-03-11','16:00:00',1.84),('8348','2013-03-11','16:05:00',1.49),('8348','2013-03-11','16:10:00',1.75),('8348','2013-03-11','16:15:00',1.14),('8348','2013-03-11','16:20:00',1.29),('8348','2013-03-11','16:25:00',1.43),('8348','2013-03-11','16:30:00',1.43),('8348','2013-03-11','16:35:00',1.22),('8348','2013-03-11','16:40:00',1.07),('8348','2013-03-11','16:45:00',1.44),('8348','2013-03-10','08:20:00',1.07),('8348','2013-03-10','08:25:00',1.12),('8348','2013-03-10','08:30:00',1.2),('8348','2013-03-10','08:35:00',1.25),('8348','2013-03-10','08:40:00',1.32),('8348','2013-03-10','08:45:00',1.43),('8348','2013-03-10','08:50:00',1.51),('8348','2013-03-10','08:55:00',1.59),('8348','2013-03-10','09:00:00',1.68),('8348','2013-03-10','09:05:00',1.78),('8348','2013-03-10','09:10:00',1.85),('8348','2013-03-10','09:15:00',1.91),('8348','2013-03-10','09:20:00',1.97),('8348','2013-03-10','09:25:00',2.04),('8348','2013-03-10','09:30:00',2.13),('8348','2013-03-10','09:35:00',2.21),('8348','2013-03-10','09:40:00',2.14),('8348','2013-03-10','09:45:00',2.03),('8348','2013-03-10','09:50:00',1.85),('8348','2013-03-10','09:55:00',1.99),('8348','2013-03-10','10:00:00',1.76),('8348','2013-03-10','10:05:00',2.12),('8348','2013-03-10','10:10:00',2.7),('8348','2013-03-10','10:15:00',2.33),('8348','2013-03-10','10:20:00',1.96),('8348','2013-03-10','10:25:00',2.88),('8348','2013-03-10','10:30:00',2.38),('8348','2013-03-10','10:35:00',2.48),('8348','2013-03-10','10:40:00',2.76),('8348','2013-03-10','10:45:00',2.99),('8348','2013-03-10','10:50:00',2.36),('8348','2013-03-10','10:55:00',2),('8348','2013-03-10','11:00:00',2.17),('8348','2013-03-10','11:05:00',1.49),('8348','2013-03-10','11:10:00',2.12),('8348','2013-03-10','11:15:00',2.1),('8348','2013-03-10','11:20:00',1.05),('8348','2013-03-10','11:25:00',2.6),('8348','2013-03-10','11:30:00',1.84),('8348','2013-03-10','11:35:00',1.44),('8348','2013-03-10','11:40:00',1.18),('8348','2013-03-10','11:45:00',1.27),('8348','2013-03-10','11:50:00',2.16),('8348','2013-03-10','11:55:00',3.53),('8348','2013-03-10','12:00:00',3.31),('8348','2013-03-10','12:05:00',3.35),('8348','2013-03-10','12:10:00',3.45),('8348','2013-03-10','12:15:00',1.98),('8348','2013-03-10','12:20:00',2.6),('8348','2013-03-10','12:25:00',2.61),('8348','2013-03-10','12:30:00',2.68),('8348','2013-03-10','12:35:00',2.24),('8348','2013-03-10','12:40:00',2.76),('8348','2013-03-10','12:45:00',3.74),('8348','2013-03-10','12:50:00',3.48),('8348','2013-03-10','12:55:00',3.51),('8348','2013-03-10','13:00:00',3.4),('8348','2013-03-10','13:05:00',3.32),('8348','2013-03-10','13:10:00',3.18),('8348','2013-03-10','13:15:00',3.39),('8348','2013-03-10','13:20:00',3.51),('8348','2013-03-10','13:25:00',3.19),('8348','2013-03-10','13:30:00',3.07),('8348','2013-03-10','13:35:00',3.03),('8348','2013-03-10','13:40:00',2.01),('8348','2013-03-10','13:45:00',1.93),('8348','2013-03-10','13:50:00',1.7),('8348','2013-03-10','13:55:00',1.61),('8348','2013-03-10','14:00:00',1.37),('8348','2013-03-10','14:05:00',1.7),('8348','2013-03-10','14:10:00',2.07),('8348','2013-03-10','14:15:00',2.52),('8348','2013-03-10','14:20:00',2.5),('8348','2013-03-10','14:25:00',1.66),('8348','2013-03-10','14:30:00',2.02),('8348','2013-03-10','14:35:00',2.75),('8348','2013-03-10','14:40:00',2.02),('8348','2013-03-10','14:45:00',1.53),('8348','2013-03-10','14:50:00',1.5),('8348','2013-03-10','14:55:00',1.35),('8348','2013-03-10','15:00:00',1.04),('8348','2013-03-10','15:05:00',1.23),('8348','2013-03-10','15:10:00',1.19),('8348','2013-03-09','08:25:00',1.07),('8348','2013-03-09','08:30:00',1.15),('8348','2013-03-09','08:35:00',1.21),('8348','2013-03-09','08:40:00',1.31),('8348','2013-03-09','08:50:00',1.06),('8348','2013-03-09','08:55:00',1.48),('8348','2013-03-09','09:00:00',1.17),('8348','2013-03-09','09:05:00',1.18),('8348','2013-03-09','09:30:00',1.64),('8348','2013-03-09','09:35:00',1.71),('8348','2013-03-09','09:40:00',2.28),('8348','2013-03-09','09:45:00',2.87),('8348','2013-03-09','09:50:00',1.59),('8348','2013-03-09','09:55:00',2.35),('8348','2013-03-09','10:05:00',1.18),('8348','2013-03-09','10:10:00',1.17),('8348','2013-03-09','10:15:00',1.28),('8348','2013-03-09','10:20:00',1.23),('8348','2013-03-09','10:35:00',1.89),('8348','2013-03-09','10:40:00',2.09),('8348','2013-03-09','10:45:00',3.32),('8348','2013-03-09','10:50:00',3.3),('8348','2013-03-09','10:55:00',2.55),('8348','2013-03-09','11:00:00',3.33),('8348','2013-03-09','11:05:00',3.23),('8348','2013-03-09','11:10:00',2.88),('8348','2013-03-09','11:15:00',3.36),('8348','2013-03-09','11:20:00',3.44),('8348','2013-03-09','11:25:00',3.32),('8348','2013-03-09','11:30:00',3.34),('8348','2013-03-09','11:35:00',3.3),('8348','2013-03-09','11:40:00',3.33),('8348','2013-03-09','11:45:00',3.36),('8348','2013-03-09','11:50:00',3.31),('8348','2013-03-09','11:55:00',3.33),('8348','2013-03-09','12:00:00',3.09),('8348','2013-03-09','12:05:00',1.59),('8348','2013-03-09','12:10:00',1.71),('8348','2013-03-09','12:15:00',1.3),('8348','2013-03-09','12:20:00',1.33),('8348','2013-03-09','12:25:00',1.67),('8348','2013-03-09','12:30:00',1.33),('8348','2013-03-09','12:35:00',1.6),('8348','2013-03-09','12:40:00',1.47),('8348','2013-03-09','12:45:00',1.89),('8348','2013-03-09','12:50:00',1.68),('8348','2013-03-09','12:55:00',3),('8348','2013-03-09','13:00:00',3.44),('8348','2013-03-09','13:05:00',3.37),('8348','2013-03-09','13:10:00',3.35),('8348','2013-03-09','13:15:00',3.55),('8348','2013-03-09','13:20:00',2.94),('8348','2013-03-09','13:25:00',3.07),('8348','2013-03-09','13:30:00',3.51),('8348','2013-03-09','13:35:00',3.53),('8348','2013-03-09','13:40:00',3.4),('8348','2013-03-09','13:45:00',3.3),('8348','2013-03-09','13:50:00',3.3),('8348','2013-03-09','13:55:00',1.58),('8348','2013-03-09','14:05:00',1),('8348','2013-03-09','14:10:00',3.28),('8348','2013-03-09','14:15:00',2.39),('8348','2013-03-09','14:20:00',3.03),('8348','2013-03-09','14:25:00',2.95),('8348','2013-03-09','14:30:00',2.87),('8348','2013-03-09','14:35:00',2.8),('8348','2013-03-09','14:40:00',2.77),('8348','2013-03-09','14:45:00',2.73),('8348','2013-03-09','14:50:00',2.68),('8348','2013-03-09','14:55:00',2.64),('8348','2013-03-09','15:00:00',2.59),('8348','2013-03-09','15:05:00',2.53),('8348','2013-03-09','15:10:00',2.47),('8348','2013-03-09','15:15:00',2.42),('8348','2013-03-09','15:20:00',2.35),('8348','2013-03-09','15:25:00',2.28),('8348','2013-03-09','15:30:00',2.2),('8348','2013-03-09','15:35:00',2.13),('8348','2013-03-09','15:40:00',2.1),('8348','2013-03-09','15:45:00',2.05),('8348','2013-03-09','15:50:00',1.98),('8348','2013-03-09','15:55:00',1.81),('8348','2013-03-09','16:00:00',1.66),('8348','2013-03-09','16:05:00',1.69),('8348','2013-03-09','16:10:00',1.34),('8348','2013-03-09','16:15:00',1.55),('8348','2013-03-09','16:20:00',1.21),('8348','2013-03-09','16:25:00',1.5),('8348','2013-03-09','16:30:00',1.28),('8348','2013-03-09','16:35:00',1.11),('8348','2013-03-09','16:40:00',1.03),('8348','2013-03-08','08:30:00',1.33),('8348','2013-03-08','08:35:00',1.5),('8348','2013-03-08','09:30:00',1.39),('8348','2013-03-08','09:35:00',1.85),('8348','2013-03-08','09:40:00',1.1),('8348','2013-03-08','09:45:00',1.18),('8348','2013-03-08','09:50:00',1.68),('8348','2013-03-08','09:55:00',1.57),('8348','2013-03-08','10:05:00',1.16),('8348','2013-03-08','10:10:00',1.4),('8348','2013-03-08','10:15:00',1.83),('8348','2013-03-08','10:20:00',1.43),('8348','2013-03-08','10:25:00',1.27),('8348','2013-03-08','10:30:00',1.62),('8348','2013-03-08','10:35:00',1.89),('8348','2013-03-08','10:40:00',1.27),('8348','2013-03-08','10:50:00',1.17),('8348','2013-03-08','10:55:00',1.12),('8348','2013-03-08','11:00:00',1.1),('8348','2013-03-08','11:35:00',1.31),('8348','2013-03-08','11:40:00',1.72),('8348','2013-03-08','11:45:00',1.42),('8348','2013-03-08','11:50:00',1.27),('8348','2013-03-08','11:55:00',1.44),('8348','2013-03-08','12:00:00',2.07),('8348','2013-03-08','12:05:00',1.37),('8348','2013-03-08','12:10:00',1.09),('8348','2013-03-08','12:20:00',1.23),('8348','2013-03-08','12:25:00',1.04),('8348','2013-03-08','12:35:00',1.52),('8348','2013-03-08','12:40:00',1.77),('8348','2013-03-08','12:45:00',1.88),('8348','2013-03-08','12:50:00',2.16),('8348','2013-03-08','12:55:00',1.85),('8348','2013-03-08','13:00:00',1.89),('8348','2013-03-08','13:05:00',1.99),('8348','2013-03-08','13:10:00',1.34),('8348','2013-03-08','13:15:00',1.07),('8348','2013-03-08','13:20:00',1),('8348','2013-03-08','13:25:00',1.37),('8348','2013-03-08','13:30:00',1.87),('8348','2013-03-08','13:35:00',1.28),('8348','2013-03-08','13:40:00',1.16),('8348','2013-03-08','17:10:00',1.2),('8348','2013-03-07','10:55:00',1.13),('8348','2013-03-07','11:00:00',1.03),('8348','2013-03-07','11:05:00',1.41),('8348','2013-03-07','11:30:00',1.43),('8348','2013-03-07','11:35:00',2.1),('8348','2013-03-07','11:40:00',1.92),('8348','2013-03-07','11:45:00',2.14),('8348','2013-03-07','11:50:00',2.19),('8348','2013-03-07','11:55:00',1.51),('8348','2013-03-07','12:00:00',1.2),('8348','2013-03-07','12:40:00',1.2),('8348','2013-03-07','12:45:00',1.74),('8348','2013-03-07','12:50:00',1.64),('8348','2013-03-07','12:55:00',1.43),('8348','2013-03-07','13:00:00',1.57),('8348','2013-03-07','13:05:00',1.72),('8348','2013-03-07','13:10:00',1.52),('8348','2013-03-07','13:15:00',1.64),('8348','2013-03-07','13:20:00',1.98),('8348','2013-03-07','13:25:00',1.74),('8348','2013-03-07','13:30:00',1.45),('8348','2013-03-07','13:35:00',1.35),('8348','2013-03-05','08:25:00',1),('8348','2013-03-05','08:30:00',1.38),('8348','2013-03-05','08:35:00',1.3),('8348','2013-03-05','08:40:00',1.37),('8348','2013-03-05','08:45:00',1.19),('8348','2013-03-05','08:50:00',1.28),('8348','2013-03-05','08:55:00',1.27),('8348','2013-03-05','09:00:00',1.37),('8348','2013-03-05','09:05:00',1.39),('8348','2013-03-05','09:10:00',1.32),('8348','2013-03-05','09:15:00',1.29),('8348','2013-03-05','09:20:00',1.3),('8348','2013-03-05','09:25:00',1.29),('8348','2013-03-05','09:30:00',1.35),('8348','2013-03-05','09:35:00',1.47),('8348','2013-03-05','09:40:00',1.54),('8348','2013-03-05','09:45:00',1.56),('8348','2013-03-05','09:50:00',1.55),('8348','2013-03-05','09:55:00',1.47),('8348','2013-03-05','10:00:00',1.42),('8348','2013-03-05','10:05:00',1.54),('8348','2013-03-05','10:10:00',1.6),('8348','2013-03-05','10:15:00',1.63),('8348','2013-03-05','10:20:00',1.79),('8348','2013-03-05','10:25:00',1.66),('8348','2013-03-05','10:30:00',1.59),('8348','2013-03-05','10:35:00',1.84),('8348','2013-03-05','10:40:00',1.9),('8348','2013-03-05','10:45:00',2.01),('8348','2013-03-05','10:50:00',2.17),('8348','2013-03-05','10:55:00',2.2),('8348','2013-03-05','11:00:00',2.1),('8348','2013-03-05','11:05:00',2.22),('8348','2013-03-05','11:10:00',2.28),('8348','2013-03-05','11:15:00',2.24),('8348','2013-03-05','11:20:00',2.19),('8348','2013-03-05','11:25:00',2.14),('8348','2013-03-05','11:30:00',2.2),('8348','2013-03-05','11:35:00',2.41),('8348','2013-03-05','11:40:00',2.61),('8348','2013-03-05','11:45:00',2.52),('8348','2013-03-05','11:50:00',2.57),('8348','2013-03-05','11:55:00',2.6),('8348','2013-03-05','12:00:00',2.67),('8348','2013-03-05','12:05:00',2.77),('8348','2013-03-05','12:10:00',2.85),('8348','2013-03-05','12:15:00',2.32),('8348','2013-03-05','12:20:00',2.62),('8348','2013-03-05','12:25:00',2.67),('8348','2013-03-05','12:30:00',2.22),('8348','2013-03-05','12:35:00',2.3),('8348','2013-03-05','12:40:00',2.24),('8348','2013-03-05','12:45:00',2.3),('8348','2013-03-05','12:50:00',2.01),('8348','2013-03-05','12:55:00',1.83),('8348','2013-03-05','13:00:00',1.54),('8348','2013-03-05','13:05:00',1.48),('8348','2013-03-05','13:10:00',1.58),('8348','2013-03-05','13:15:00',1.69),('8348','2013-03-05','13:20:00',1.61),('8348','2013-03-05','13:25:00',1.46),('8348','2013-03-05','13:30:00',1.34),('8348','2013-03-05','13:35:00',1.26),('8348','2013-03-05','13:40:00',1.2),('8348','2013-03-05','13:45:00',1.09),('8348','2013-03-05','15:45:00',1.06),('8348','2013-03-05','15:50:00',1.04),('8348','2013-03-04','08:25:00',1),('8348','2013-03-04','08:30:00',1.06),('8348','2013-03-04','08:35:00',1.11),('8348','2013-03-04','08:40:00',1.16),('8348','2013-03-04','08:45:00',1.25),('8348','2013-03-04','08:50:00',1.34),('8348','2013-03-04','08:55:00',1.41),('8348','2013-03-04','09:00:00',1.47),('8348','2013-03-04','09:05:00',1.57),('8348','2013-03-04','09:10:00',1.66),('8348','2013-03-04','09:15:00',1.75),('8348','2013-03-04','09:20:00',1.82),('8348','2013-03-04','09:25:00',1.88),('8348','2013-03-04','09:30:00',1.94),('8348','2013-03-04','09:35:00',2.02),('8348','2013-03-04','09:40:00',2.08),('8348','2013-03-04','09:45:00',2.13),('8348','2013-03-04','09:50:00',2.19),('8348','2013-03-04','09:55:00',2.25),('8348','2013-03-04','10:00:00',2.3),('8348','2013-03-04','10:05:00',2.33),('8348','2013-03-04','10:10:00',2.4),('8348','2013-03-04','10:15:00',2.44),('8348','2013-03-04','10:20:00',2.47),('8348','2013-03-04','10:25:00',2.47),('8348','2013-03-04','10:30:00',2.54),('8348','2013-03-04','10:35:00',2.6),('8348','2013-03-04','10:40:00',2.64),('8348','2013-03-04','10:45:00',2.68),('8348','2013-03-04','10:50:00',2.7),('8348','2013-03-04','10:55:00',2.72),('8348','2013-03-04','11:00:00',2.78),('8348','2013-03-04','11:05:00',2.84),('8348','2013-03-04','11:10:00',2.86),('8348','2013-03-04','11:15:00',2.86),('8348','2013-03-04','11:20:00',2.88),('8348','2013-03-04','11:25:00',2.89),('8348','2013-03-04','11:30:00',2.96),('8348','2013-03-04','11:35:00',2.98),('8348','2013-03-04','11:40:00',2.99),('8348','2013-03-04','11:45:00',2.99),('8348','2013-03-04','11:50:00',2.95),('8348','2013-03-04','11:55:00',2.95),('8348','2013-03-04','12:00:00',2.97),('8348','2013-03-04','12:05:00',3),('8348','2013-03-04','12:10:00',3.06),('8348','2013-03-04','12:15:00',3.09),('8348','2013-03-04','12:20:00',3.1),('8348','2013-03-04','12:25:00',3.06),('8348','2013-03-04','12:30:00',3.07),('8348','2013-03-04','12:35:00',3.09),('8348','2013-03-04','12:40:00',3.09),('8348','2013-03-04','12:45:00',3.09),('8348','2013-03-04','12:50:00',3.07),('8348','2013-03-04','12:55:00',3.06),('8348','2013-03-04','13:00:00',3.04),('8348','2013-03-04','13:05:00',3),('8348','2013-03-04','13:10:00',3),('8348','2013-03-04','13:15:00',3.02),('8348','2013-03-04','13:20:00',3.01),('8348','2013-03-04','13:25:00',2.93),('8348','2013-03-04','13:30:00',1.97),('8348','2013-03-04','13:35:00',3.07),('8348','2013-03-04','13:40:00',2.81),('8348','2013-03-04','13:45:00',2.71),('8348','2013-03-04','13:50:00',2.81),('8348','2013-03-04','13:55:00',2.83),('8348','2013-03-04','14:00:00',2.84),('8348','2013-03-04','14:05:00',2.83),('8348','2013-03-04','14:10:00',2.72),('8348','2013-03-04','14:15:00',2.65),('8348','2013-03-04','14:20:00',2.63),('8348','2013-03-04','14:25:00',2.55),('8348','2013-03-04','14:30:00',2.5),('8348','2013-03-04','14:35:00',2.55),('8348','2013-03-04','14:40:00',2.47),('8348','2013-03-04','14:45:00',2.41),('8348','2013-03-04','14:50:00',2.34),('8348','2013-03-04','14:55:00',2.28),('8348','2013-03-04','15:00:00',2.25),('8348','2013-03-04','15:05:00',2.24),('8348','2013-03-04','15:10:00',2.15),('8348','2013-03-04','15:15:00',2.07),('8348','2013-03-04','15:20:00',2.04),('8348','2013-03-04','15:25:00',1.98),('8348','2013-03-04','15:30:00',1.94),('8348','2013-03-04','15:35:00',1.85),('8348','2013-03-04','15:40:00',1.82),('8348','2013-03-04','15:45:00',1.75),('8348','2013-03-04','15:50:00',1.68),('8348','2013-03-04','15:55:00',1.63),('8348','2013-03-04','16:00:00',1.56),('8348','2013-03-04','16:05:00',1.49),('8348','2013-03-04','16:10:00',1.41),('8348','2013-03-04','16:15:00',1.35),('8348','2013-03-04','16:20:00',1.28),('8348','2013-03-04','16:25:00',1.23),('8348','2013-03-04','16:30:00',1.15),('8348','2013-03-04','16:35:00',1.07),('8348','2013-03-03','08:30:00',1.03),('8348','2013-03-03','08:35:00',1.07),('8348','2013-03-03','08:40:00',1.17),('8348','2013-03-03','08:45:00',1.24),('8348','2013-03-03','08:50:00',1.32),('8348','2013-03-03','08:55:00',1.4),('8348','2013-03-03','09:00:00',1.48),('8348','2013-03-03','09:05:00',1.57),('8348','2013-03-03','09:10:00',1.66),('8348','2013-03-03','09:15:00',1.75),('8348','2013-03-03','09:20:00',1.83),('8348','2013-03-03','09:25:00',1.89),('8348','2013-03-03','09:30:00',1.96),('8348','2013-03-03','09:35:00',2.02),('8348','2013-03-03','09:40:00',2.08),('8348','2013-03-03','09:45:00',2.15),('8348','2013-03-03','09:50:00',2.22),('8348','2013-03-03','09:55:00',2.3),('8348','2013-03-03','10:00:00',2.37),('8348','2013-03-03','10:05:00',2.42),('8348','2013-03-03','10:10:00',2.48),('8348','2013-03-03','10:15:00',2.55),('8348','2013-03-03','10:20:00',2.6),('8348','2013-03-03','10:25:00',2.65),('8348','2013-03-03','10:30:00',2.69),('8348','2013-03-03','10:35:00',2.73),('8348','2013-03-03','10:40:00',2.77),('8348','2013-03-03','10:45:00',2.8),('8348','2013-03-03','10:50:00',2.83),('8348','2013-03-03','10:55:00',2.86),('8348','2013-03-03','11:00:00',2.89),('8348','2013-03-03','11:05:00',2.92),('8348','2013-03-03','11:10:00',2.94),('8348','2013-03-03','11:15:00',2.97),('8348','2013-03-03','11:20:00',2.99),('8348','2013-03-03','11:25:00',3.01),('8348','2013-03-03','11:30:00',3.03),('8348','2013-03-03','11:35:00',3.06),('8348','2013-03-03','11:40:00',3.07),('8348','2013-03-03','11:45:00',3.09),('8348','2013-03-03','11:50:00',3.1),('8348','2013-03-03','11:55:00',3.12),('8348','2013-03-03','12:00:00',3.12),('8348','2013-03-03','12:05:00',3.13),('8348','2013-03-03','12:10:00',3.13),('8348','2013-03-03','12:15:00',3.14),('8348','2013-03-03','12:20:00',3.14),('8348','2013-03-03','12:25:00',3.17),('8348','2013-03-03','12:30:00',3.17),('8348','2013-03-03','12:35:00',3.17),('8348','2013-03-03','12:40:00',3.18),('8348','2013-03-03','12:45:00',3.2),('8348','2013-03-03','12:50:00',3.19),('8348','2013-03-03','12:55:00',3.19),('8348','2013-03-03','13:00:00',3.17),('8348','2013-03-03','13:05:00',3.17),('8348','2013-03-03','13:10:00',3.16),('8348','2013-03-03','13:15:00',3.12),('8348','2013-03-03','13:20:00',3.12),('8348','2013-03-03','13:25:00',3.11),('8348','2013-03-03','13:30:00',3.09),('8348','2013-03-03','13:35:00',3.06),('8348','2013-03-03','13:40:00',3.04),('8348','2013-03-03','13:45:00',3),('8348','2013-03-03','13:50:00',2.99),('8348','2013-03-03','13:55:00',2.95),('8348','2013-03-03','14:00:00',2.93),('8348','2013-03-03','14:05:00',2.91),('8348','2013-03-03','14:10:00',2.89),('8348','2013-03-03','14:15:00',2.88),('8348','2013-03-03','14:20:00',2.83),('8348','2013-03-03','14:25:00',2.8),('8348','2013-03-03','14:30:00',2.74),('8348','2013-03-03','14:35:00',2.71),('8348','2013-03-03','14:40:00',2.67),('8348','2013-03-03','14:45:00',2.62),('8348','2013-03-03','14:50:00',2.58),('8348','2013-03-03','14:55:00',2.51),('8348','2013-03-03','15:00:00',2.47),('8348','2013-03-03','15:05:00',2.41),('8348','2013-03-03','15:10:00',2.35),('8348','2013-03-03','15:15:00',2.32),('8348','2013-03-03','15:20:00',2.27),('8348','2013-03-03','15:25:00',2.21),('8348','2013-03-03','15:30:00',2.16),('8348','2013-03-03','15:35:00',2.08),('8348','2013-03-03','15:40:00',2.01),('8348','2013-03-03','15:45:00',1.94),('8348','2013-03-03','15:50:00',1.87),('8348','2013-03-03','15:55:00',1.8),('8348','2013-03-03','16:00:00',1.71),('8348','2013-03-03','16:05:00',1.65),('8348','2013-03-03','16:10:00',1.57),('8348','2013-03-03','16:15:00',1.49),('8348','2013-03-03','16:20:00',1.41),('8348','2013-03-03','16:25:00',1.33),('8348','2013-03-03','16:30:00',1.25),('8348','2013-03-03','16:35:00',1.17),('8348','2013-03-03','16:40:00',1.09),('8348','2014-03-24','07:35:00',1.02),('8348','2014-03-24','07:45:00',2.02),('8348','2014-03-24','07:50:00',1.45),('8348','2014-03-24','07:55:00',1.47),('8348','2014-03-24','08:35:00',1.5),('8348','2014-03-24','08:40:00',1.59),('8348','2014-03-24','08:45:00',1.13),('8348','2014-03-24','08:50:00',1.35),('8348','2014-03-24','08:55:00',2.7),('8348','2014-03-24','09:00:00',2.97),('8348','2014-03-24','09:05:00',1.59),('8348','2014-03-24','09:10:00',1.12),('8348','2014-03-24','09:15:00',1.07),('8348','2014-03-24','09:20:00',2.59),('8348','2014-03-24','09:25:00',1.51),('8348','2014-03-24','09:30:00',2.28),('8348','2014-03-24','09:35:00',1.72),('8348','2014-03-24','09:40:00',2.77),('8348','2014-03-24','09:45:00',2.08),('8348','2014-03-24','09:50:00',1.92),('8348','2014-03-24','09:55:00',1.19),('8348','2014-03-24','10:00:00',3.77),('8348','2014-03-24','10:05:00',4.98),('8348','2014-03-24','10:10:00',5.56),('8348','2014-03-24','10:15:00',4.41),('8348','2014-03-24','10:20:00',1.65),('8348','2014-03-24','10:25:00',1.47),('8348','2014-03-24','10:30:00',1.38),('8348','2014-03-24','10:35:00',2.33),('8348','2014-03-24','10:40:00',1.94),('8348','2014-03-24','10:45:00',2.91),('8348','2014-03-24','10:50:00',7.79),('8348','2014-03-24','10:55:00',6.59),('8348','2014-03-24','11:00:00',3.21),('8348','2014-03-24','11:05:00',4.24),('8348','2014-03-24','11:10:00',4.88),('8348','2014-03-24','11:15:00',5.59),('8348','2014-03-24','11:20:00',5.33),('8348','2014-03-24','11:25:00',5.5),('8348','2014-03-24','11:30:00',7.05),('8348','2014-03-24','11:35:00',2.87),('8348','2014-03-24','11:40:00',1.44),('8348','2014-03-24','11:45:00',1.1),('8348','2014-03-24','11:50:00',1.13),('8348','2014-03-24','11:55:00',1.29),('8348','2014-03-24','12:00:00',1.14),('8348','2014-03-24','12:20:00',1.02),('8348','2014-03-24','12:25:00',1.23),('8348','2014-03-24','12:30:00',2.07),('8348','2014-03-24','12:35:00',3.52),('8348','2014-03-24','12:40:00',3.68),('8348','2014-03-24','12:45:00',3.18),('8348','2014-03-24','12:50:00',2.72),('8348','2014-03-24','12:55:00',2.62),('8348','2014-03-24','13:00:00',2.64),('8348','2014-03-24','13:05:00',2.62),('8348','2014-03-24','13:10:00',2.26),('8348','2014-03-24','13:15:00',1.98),('8348','2014-03-24','13:20:00',2.03),('8348','2014-03-24','13:25:00',2.32),('8348','2014-03-24','13:30:00',2.61),('8348','2014-03-24','13:35:00',2.17),('8348','2014-03-24','13:40:00',1.51),('8348','2014-03-24','13:45:00',2.13),('8348','2014-03-24','13:50:00',2.44),('8348','2014-03-24','13:55:00',2.42),('8348','2014-03-24','14:00:00',2.14),('8348','2014-03-24','14:05:00',1.97),('8348','2014-03-24','14:10:00',2.31),('8348','2014-03-24','14:15:00',2.95),('8348','2014-03-24','14:20:00',3.85),('8348','2014-03-24','14:25:00',3.67),('8348','2014-03-24','14:30:00',3.3),('8348','2014-03-24','14:35:00',4.03),('8348','2014-03-24','14:40:00',5.63),('8348','2014-03-24','14:45:00',6.18),('8348','2014-03-24','14:50:00',6.47),('8348','2014-03-24','14:55:00',5.62),('8348','2014-03-24','15:00:00',4.9),('8348','2014-03-24','15:05:00',4.4),('8348','2014-03-24','15:10:00',3.9),('8348','2014-03-24','15:15:00',2.62),('8348','2014-03-24','15:20:00',3.03),('8348','2014-03-24','15:25:00',2.63),('8348','2014-03-24','15:30:00',3.18),('8348','2014-03-24','15:35:00',2.71),('8348','2014-03-24','15:40:00',2.3),('8348','2014-03-24','15:45:00',2.36),('8348','2014-03-24','15:50:00',2.7),('8348','2014-03-24','15:55:00',2.88),('8348','2014-03-24','16:00:00',4.71),('8348','2014-03-24','16:05:00',2.36),('8348','2014-03-24','16:10:00',2.03),('8348','2014-03-24','16:15:00',1.43),('8348','2013-03-02','10:50:00',1.01),('8348','2013-03-02','10:55:00',1.05),('8348','2013-03-02','11:00:00',1.13),('8348','2013-03-02','11:05:00',1.2),('8348','2013-03-02','11:10:00',1.22),('8348','2013-03-02','11:15:00',1.42),('8348','2013-03-02','11:20:00',1.25),('8348','2013-03-02','11:25:00',1.11),('8348','2013-03-02','11:30:00',1.05),('8348','2013-03-02','11:35:00',1.07),('8348','2013-03-02','11:40:00',1.22),('8348','2013-03-02','11:45:00',1.1),('8348','2013-03-02','11:50:00',1.12),('8348','2013-03-02','11:55:00',1.04),('8348','2013-03-02','12:00:00',1.02),('8348','2013-03-02','12:05:00',1.16),('8348','2013-03-02','12:10:00',1.14),('8348','2013-03-02','12:15:00',1.17),('8348','2013-03-02','12:20:00',1.1),('8348','2013-03-02','12:25:00',1.15),('8348','2013-03-02','12:30:00',1.23),('8348','2013-03-02','12:35:00',1.34),('8348','2013-03-02','12:40:00',1.6),('8348','2013-03-02','12:45:00',1.45),('8348','2013-03-02','12:50:00',1.28),('8348','2013-03-02','12:55:00',1.4),('8348','2013-03-02','13:00:00',1.35),('8348','2013-03-02','13:05:00',1.15),('8348','2013-03-02','13:45:00',1.08),('8348','2013-03-02','13:50:00',1.04),('8348','2013-03-02','13:55:00',1.1),('8348','2013-03-02','14:00:00',1.21),('8348','2013-03-02','14:05:00',1.18),('8348','2013-03-02','14:10:00',1.01),('8348','2013-03-01','08:35:00',1.01),('8348','2013-03-01','08:40:00',1.08),('8348','2013-03-01','08:45:00',1.14),('8348','2013-03-01','08:50:00',1.2),('8348','2013-03-01','08:55:00',1.28),('8348','2013-03-01','09:00:00',1.35),('8348','2013-03-01','09:05:00',1.46),('8348','2013-03-01','09:10:00',1.47),('8348','2013-03-01','09:15:00',1.54),('8348','2013-03-01','09:20:00',1.58),('8348','2013-03-01','09:25:00',1.63),('8348','2013-03-01','09:30:00',1.79),('8348','2013-03-01','09:35:00',1.73),('8348','2013-03-01','09:40:00',1.83),('8348','2013-03-01','09:45:00',1.95),('8348','2013-03-01','09:50:00',1.98),('8348','2013-03-01','09:55:00',1.95),('8348','2013-03-01','10:00:00',2),('8348','2013-03-01','10:05:00',2),('8348','2013-03-01','10:10:00',2),('8348','2013-03-01','10:15:00',1.81),('8348','2013-03-01','10:20:00',1.73),('8348','2013-03-01','10:25:00',1.85),('8348','2013-03-01','10:30:00',2.07),('8348','2013-03-01','10:35:00',2.26),('8348','2013-03-01','10:40:00',2.03),('8348','2013-03-01','10:45:00',1.94),('8348','2013-03-01','10:50:00',1.86),('8348','2013-03-01','10:55:00',1.77),('8348','2013-03-01','11:00:00',1.58),('8348','2013-03-01','11:05:00',1.41),('8348','2013-03-01','11:10:00',1.37),('8348','2013-03-01','11:15:00',1.5),('8348','2013-03-01','11:20:00',1.58),('8348','2013-03-01','11:25:00',1.58),('8348','2013-03-01','11:30:00',1.59),('8348','2013-03-01','11:35:00',1.62),('8348','2013-03-01','11:40:00',1.55),('8348','2013-03-01','11:45:00',1.48),('8348','2013-03-01','11:50:00',1.46),('8348','2013-03-01','11:55:00',1.4),('8348','2013-03-01','12:00:00',1.34),('8348','2013-03-01','12:05:00',1.28),('8348','2013-03-01','12:10:00',1.19),('8348','2013-03-01','12:15:00',1.09),('8348','2013-03-01','12:20:00',1.03),('8348','2013-03-01','12:25:00',1.03),('8348','2013-03-01','12:30:00',1.07),('8348','2013-03-01','12:35:00',1.06),('8348','2013-03-01','12:40:00',1.02),('8348','2013-03-01','12:45:00',1.02),('8348','2013-03-01','12:50:00',1.05),('8348','2013-03-01','12:55:00',1.11),('8348','2013-03-01','13:00:00',1.17),('8348','2013-03-01','13:05:00',1.18),('8348','2013-03-01','13:10:00',1.22),('8348','2013-03-01','13:15:00',1.3),('8348','2013-03-01','13:20:00',1.41),('8348','2013-03-01','13:25:00',1.54),('8348','2013-03-01','13:30:00',1.49),('8348','2013-03-01','13:35:00',1.39),('8348','2013-03-01','13:40:00',1.32),('8348','2013-03-01','13:45:00',1.3),('8348','2013-03-01','13:50:00',1.29),('8348','2013-03-01','13:55:00',1.24),('8348','2013-03-01','14:00:00',1.21),('8348','2013-03-01','14:05:00',1.16),('8348','2013-03-01','14:10:00',1.09),('8348','2013-03-01','14:15:00',1.03),('8348','2013-03-01','14:30:00',1.03),('8348','2013-03-01','14:35:00',1.02),('8348','2013-02-28','08:35:00',1.01),('8348','2013-02-28','08:40:00',1.07),('8348','2013-02-28','08:45:00',1.13),('8348','2013-02-28','08:50:00',1.21),('8348','2013-02-28','08:55:00',1.29),('8348','2013-02-28','09:00:00',1.36),('8348','2013-02-28','09:05:00',1.41),('8348','2013-02-28','09:10:00',1.48),('8348','2013-02-28','09:15:00',1.57),('8348','2013-02-28','09:20:00',1.66),('8348','2013-02-28','09:25:00',1.71),('8348','2013-02-28','09:30:00',1.78),('8348','2013-02-28','09:35:00',1.85),('8348','2013-02-28','09:40:00',1.92),('8348','2013-02-28','09:45:00',1.99),('8348','2013-02-28','09:50:00',1.89),('8348','2013-02-28','09:55:00',2.06),('8348','2013-02-28','10:00:00',2.13),('8348','2013-02-28','10:05:00',2.19),('8348','2013-02-28','10:10:00',2.21),('8348','2013-02-28','10:15:00',2.26),('8348','2013-02-28','10:20:00',2.32),('8348','2013-02-28','10:25:00',2.35),('8348','2013-02-28','10:30:00',2.34),('8348','2013-02-28','10:35:00',2.41),('8348','2013-02-28','10:40:00',2.45),('8348','2013-02-28','10:45:00',2.49),('8348','2013-02-28','10:50:00',2.51),('8348','2013-02-28','10:55:00',2.52),('8348','2013-02-28','11:00:00',2.62),('8348','2013-02-28','11:05:00',2.67),('8348','2013-02-28','11:10:00',2.74),('8348','2013-02-28','11:15:00',2.77),('8348','2013-02-28','11:20:00',2.79),('8348','2013-02-28','11:25:00',2.86),('8348','2013-02-28','11:30:00',2.84),('8348','2013-02-28','11:35:00',2.86),('8348','2013-02-28','11:40:00',2.86),('8348','2013-02-28','11:45:00',2.85),('8348','2013-02-28','11:50:00',2.85),('8348','2013-02-28','11:55:00',2.87),('8348','2013-02-28','12:00:00',2.85),('8348','2013-02-28','12:05:00',2.8),('8348','2013-02-28','12:10:00',2.54),('8348','2013-02-28','12:15:00',2.93),('8348','2013-02-28','12:20:00',2.98),('8348','2013-02-28','12:25:00',2.9),('8348','2013-02-28','12:30:00',2.95),('8348','2013-02-28','12:35:00',3),('8348','2013-02-28','12:40:00',3.02),('8348','2013-02-28','12:45:00',2.96),('8348','2013-02-28','12:50:00',2.89),('8348','2013-02-28','12:55:00',2.94),('8348','2013-02-28','13:00:00',2.81),('8348','2013-02-28','13:05:00',2.96),('8348','2013-02-28','13:10:00',2.95),('8348','2013-02-28','13:15:00',2.92),('8348','2013-02-28','13:20:00',2.35),('8348','2013-02-28','13:25:00',1.17),('8348','2013-02-28','13:30:00',2.9),('8348','2013-02-28','13:35:00',2.92),('8348','2013-02-28','13:40:00',2.89),('8348','2013-02-28','13:45:00',2.83),('8348','2013-02-28','13:50:00',2.91),('8348','2013-02-28','13:55:00',2.99),('8348','2013-02-28','14:00:00',3.04),('8348','2013-02-28','14:05:00',2.96),('8348','2013-02-28','14:10:00',2.83),('8348','2013-02-28','14:15:00',2.7),('8348','2013-02-28','14:20:00',2.63),('8348','2013-02-28','14:25:00',2.55),('8348','2013-02-28','14:30:00',2.47),('8348','2013-02-28','14:35:00',2.34),('8348','2013-02-28','14:40:00',2.41),('8348','2013-02-28','14:45:00',2.38),('8348','2013-02-28','14:50:00',2.36),('8348','2013-02-28','14:55:00',2.29),('8348','2013-02-28','15:00:00',2.23),('8348','2013-02-28','15:05:00',2.13),('8348','2013-02-28','15:10:00',2.09),('8348','2013-02-28','15:15:00',2.03),('8348','2013-02-28','15:20:00',1.98),('8348','2013-02-28','15:25:00',1.84),('8348','2013-02-28','15:30:00',1.72),('8348','2013-02-28','15:35:00',1.69),('8348','2013-02-28','15:40:00',1.65),('8348','2013-02-28','15:45:00',1.63),('8348','2013-02-28','15:50:00',1.56),('8348','2013-02-28','15:55:00',1.49),('8348','2013-02-28','16:00:00',1.43),('8348','2013-02-28','16:05:00',1.33),('8348','2013-02-28','16:10:00',1.26),('8348','2013-02-28','16:15:00',1.19),('8348','2013-02-28','16:20:00',1.13),('8348','2013-02-28','16:25:00',1.05),('8348','2013-02-27','08:40:00',1.02),('8348','2013-02-27','08:45:00',1.08),('8348','2013-02-27','08:50:00',1.14),('8348','2013-02-27','08:55:00',1.21),('8348','2013-02-27','09:00:00',1.29),('8348','2013-02-27','09:05:00',1.36),('8348','2013-02-27','09:10:00',1.44),('8348','2013-02-27','09:15:00',1.52),('8348','2013-02-27','09:20:00',1.62),('8348','2013-02-27','09:25:00',1.68),('8348','2013-02-27','09:30:00',1.74),('8348','2013-02-27','09:35:00',1.8),('8348','2013-02-27','09:40:00',1.86),('8348','2013-02-27','09:45:00',1.92),('8348','2013-02-27','09:50:00',1.98),('8348','2013-02-27','09:55:00',2.04),('8348','2013-02-27','10:00:00',2.1),('8348','2013-02-27','10:05:00',2.15),('8348','2013-02-27','10:10:00',2.19),('8348','2013-02-27','10:15:00',2.27),('8348','2013-02-27','10:20:00',2.28),('8348','2013-02-27','10:25:00',2.31),('8348','2013-02-27','10:30:00',2.36),('8348','2013-02-27','10:35:00',2.4),('8348','2013-02-27','10:40:00',2.36),('8348','2013-02-27','10:45:00',2.52),('8348','2013-02-27','10:50:00',2.58),('8348','2013-02-27','10:55:00',2.57),('8348','2013-02-27','11:00:00',2.63),('8348','2013-02-27','11:05:00',2.67),('8348','2013-02-27','11:10:00',2.73),('8348','2013-02-27','11:15:00',2.76),('8348','2013-02-27','11:20:00',2.8),('8348','2013-02-27','11:25:00',2.06),('8348','2013-02-27','11:30:00',1.08),('8348','2013-02-27','11:35:00',1.04),('8348','2013-02-27','11:45:00',1.12),('8348','2013-02-27','11:50:00',2.99),('8348','2013-02-27','11:55:00',3.15),('8348','2013-02-27','12:00:00',3.04),('8348','2013-02-27','12:05:00',3.06),('8348','2013-02-27','12:10:00',3.12),('8348','2013-02-27','12:15:00',3.25),('8348','2013-02-27','12:20:00',3.13),('8348','2013-02-27','12:25:00',3.05),('8348','2013-02-27','12:30:00',3),('8348','2013-02-27','12:35:00',3.07),('8348','2013-02-27','12:40:00',3.06),('8348','2013-02-27','12:45:00',3.02),('8348','2013-02-27','12:50:00',3.02),('8348','2013-02-27','12:55:00',3.04),('8348','2013-02-27','13:00:00',3.04),('8348','2013-02-27','13:05:00',3.09),('8348','2013-02-27','13:10:00',2.62),('8348','2013-02-27','13:15:00',2.82),('8348','2013-02-27','13:20:00',2.73),('8348','2013-02-27','13:25:00',3.05),('8348','2013-02-27','13:30:00',3.03),('8348','2013-02-27','13:35:00',2.99),('8348','2013-02-27','13:40:00',2.97),('8348','2013-02-27','13:45:00',2.83),('8348','2013-02-27','13:50:00',2.59),('8348','2013-02-27','13:55:00',2.67),('8348','2013-02-27','14:00:00',2.25),('8348','2013-02-27','14:05:00',2.42),('8348','2013-02-27','14:10:00',1.46),('8348','2013-02-27','14:15:00',1.86),('8348','2013-02-27','14:20:00',2.53),('8348','2013-02-27','14:25:00',2.07),('8348','2013-02-27','14:30:00',2.6),('8348','2013-02-27','14:35:00',2.62),('8348','2013-02-27','14:40:00',2.53),('8348','2013-02-27','14:45:00',2.31),('8348','2013-02-27','14:50:00',1.83),('8348','2013-02-27','14:55:00',1.94),('8348','2013-02-27','15:00:00',2.34),('8348','2013-02-27','15:05:00',2.33),('8348','2013-02-27','15:10:00',2.09),('8348','2013-02-27','15:15:00',1.8),('8348','2013-02-27','15:20:00',1.82),('8348','2013-02-27','15:25:00',1.99),('8348','2013-02-27','15:30:00',1.92),('8348','2013-02-27','15:35:00',1.85),('8348','2013-02-27','15:40:00',1.77),('8348','2013-02-27','15:45:00',1.73),('8348','2013-02-27','15:50:00',1.67),('8348','2013-02-27','15:55:00',1.62),('8348','2013-02-27','16:00:00',1.54),('8348','2013-02-27','16:05:00',1.47),('8348','2013-02-27','16:10:00',1.4),('8348','2013-02-27','16:15:00',1.32),('8348','2013-02-27','16:20:00',1.24),('8348','2013-02-27','16:25:00',1.17),('8348','2013-02-27','16:30:00',1.07),('8348','2013-02-26','09:30:00',1.1),('8348','2013-02-26','09:35:00',1.36),('8348','2013-02-26','09:40:00',1.52),('8348','2013-02-26','09:45:00',1.54),('8348','2013-02-26','09:50:00',1.55),('8348','2013-02-26','09:55:00',1.69),('8348','2013-02-26','10:00:00',1.62),('8348','2013-02-26','10:05:00',1.57),('8348','2013-02-26','10:10:00',1.78),('8348','2013-02-26','10:15:00',2.03),('8348','2013-02-26','10:20:00',2.45),('8348','2013-02-26','10:25:00',2.72),('8348','2013-02-26','10:30:00',2.66),('8348','2013-02-26','10:35:00',1.95),('8348','2013-02-26','10:40:00',2.25),('8348','2013-02-26','10:45:00',1.3),('8348','2013-02-26','10:50:00',1.51),('8348','2013-02-26','10:55:00',1.61),('8348','2013-02-26','11:00:00',1.97),('8348','2013-02-26','11:05:00',1.7),('8348','2013-02-26','11:10:00',1.7),('8348','2013-02-26','11:15:00',1.54),('8348','2013-02-26','11:20:00',1.53),('8348','2013-02-26','11:25:00',1.43),('8348','2013-02-26','11:30:00',1.4),('8348','2013-02-26','11:35:00',1.33),('8348','2013-02-26','11:40:00',1.38),('8348','2013-02-26','11:45:00',1.35),('8348','2013-02-26','11:50:00',1.48),('8348','2013-02-26','11:55:00',1.53),('8348','2013-02-26','12:00:00',1.49),('8348','2013-02-26','12:05:00',1.47),('8348','2013-02-26','12:10:00',1.51),('8348','2013-02-26','12:15:00',1.34),('8348','2013-02-26','12:20:00',1.38),('8348','2013-02-26','12:25:00',1.27),('8348','2013-02-26','12:30:00',1.27),('8348','2013-02-26','12:35:00',1.16),('8348','2013-02-26','12:40:00',1.07),('8348','2013-02-25','09:25:00',1.22),('8348','2013-02-25','09:30:00',1.36),('8348','2013-02-25','09:35:00',1.35),('8348','2013-02-25','09:40:00',1.03),('8348','2013-02-25','10:45:00',1.48),('8348','2013-02-25','10:50:00',2.62),('8348','2013-02-25','10:55:00',3.69),('8348','2013-02-25','11:00:00',3.42),('8348','2013-02-25','11:05:00',1.79),('8348','2013-02-25','11:10:00',1.64),('8348','2013-02-25','11:15:00',1.47),('8348','2013-02-25','11:20:00',1.12),('8348','2013-02-25','11:25:00',1.05),('8348','2013-02-25','11:30:00',1.5),('8348','2013-02-25','11:35:00',1.25),('8348','2013-02-25','11:40:00',1.47),('8348','2013-02-25','11:45:00',1.58),('8348','2013-02-25','11:50:00',1.96),('8348','2013-02-25','11:55:00',3.92),('8348','2013-02-25','12:00:00',2.73),('8348','2013-02-25','12:05:00',2.13),('8348','2013-02-25','12:10:00',1.65),('8348','2013-02-25','12:15:00',1.74),('8348','2013-02-25','12:20:00',3.29),('8348','2013-02-25','12:25:00',3.63),('8348','2013-02-25','12:30:00',2.77),('8348','2013-02-25','12:35:00',2.1),('8348','2013-02-25','12:40:00',2.93),('8348','2013-02-25','12:45:00',3.33),('8348','2013-02-25','12:50:00',3.14),('8348','2013-02-25','12:55:00',3.14),('8348','2013-02-25','13:00:00',2.29),('8348','2013-02-25','13:05:00',2.21),('8348','2013-02-25','13:10:00',1.35),('8348','2013-02-25','13:15:00',2.23),('8348','2013-02-25','13:20:00',1.78),('8348','2013-02-25','13:25:00',1.31),('8348','2013-02-25','13:30:00',1.59),('8348','2013-02-25','13:35:00',1.61),('8348','2013-02-25','13:40:00',1.08),('8348','2013-02-24','10:50:00',1.25),('8348','2013-02-24','10:55:00',1.18),('8348','2013-02-24','12:40:00',1.08),('8348','2013-02-24','12:45:00',1.15),('8348','2013-02-24','13:00:00',1.06),('8348','2013-02-24','13:05:00',1.36),('8348','2013-02-24','13:10:00',1.33),('8348','2013-02-24','13:15:00',1.2),('8348','2013-02-24','13:20:00',1.39),('8348','2013-02-24','13:35:00',1.29),('8348','2013-02-24','13:40:00',1.04),('8348','2013-02-24','13:45:00',1.14),('8348','2013-02-24','13:50:00',1),('8348','2013-02-24','14:00:00',1.04),('8348','2013-02-24','14:05:00',1.75),('8348','2013-02-24','14:10:00',1.51),('8348','2013-02-24','14:15:00',1.06),('8348','2013-02-24','14:30:00',1.09),('8348','2013-02-24','14:35:00',1.12),('8348','2013-02-24','15:10:00',2.06),('8348','2013-02-24','15:15:00',1.05),('8348','2013-02-24','15:20:00',1.42),('8348','2013-02-24','15:25:00',1.48),('8348','2013-02-24','15:30:00',1.03),('8348','2013-02-24','15:35:00',1.49),('8348','2013-02-24','15:40:00',1.13),('8348','2013-02-24','15:45:00',1.45),('8348','2013-02-24','15:50:00',1.01),('8348','2013-02-24','15:55:00',1.51),('8348','2013-02-24','16:00:00',1.66),('8348','2013-02-24','16:05:00',1.06),('8348','2013-02-24','16:40:00',1.03),('8348','2013-02-23','08:15:00',1.11),('8348','2013-02-23','09:00:00',1.16),('8348','2013-02-23','09:05:00',1.12),('8348','2013-02-23','09:45:00',1.18),('8348','2013-02-23','09:50:00',1.24),('8348','2013-02-23','09:55:00',1.22),('8348','2013-02-23','14:05:00',1.5),('8348','2013-02-23','14:10:00',1.16),('8348','2013-02-22','14:35:00',1.34),('8348','2013-02-22','14:40:00',1.33),('8348','2013-02-22','14:55:00',1.21),('8348','2013-02-22','16:20:00',1.09),('8348','2013-02-22','16:25:00',1.25),('8348','2013-02-22','16:30:00',1.04),('8348','2013-02-21','11:50:00',1.06),('8348','2013-02-21','11:55:00',1.08),('8348','2013-02-21','12:00:00',1.05),('8348','2013-02-21','12:05:00',1.07),('8348','2013-02-21','12:10:00',1.1),('8348','2013-02-21','12:15:00',1.17),('8348','2013-02-21','12:20:00',1.24),('8348','2013-02-21','12:25:00',1.21),('8348','2013-02-21','12:30:00',1.14),('8348','2013-02-21','12:35:00',1.09),('8348','2013-02-21','12:40:00',1.06),('8348','2013-02-21','12:45:00',1.08),('8348','2013-02-21','12:50:00',1.08),('8348','2013-02-21','12:55:00',1.15),('8348','2013-02-21','13:00:00',1.15),('8348','2013-02-21','13:05:00',1.07),('8348','2013-02-21','13:10:00',1.03),('8348','2013-02-21','13:15:00',1.08),('8348','2013-02-21','13:20:00',1.13),('8348','2013-02-21','13:25:00',1.16),('8348','2013-02-21','13:30:00',1.16),('8348','2013-02-21','13:35:00',1.16),('8348','2013-02-21','13:40:00',1.11),('8348','2013-02-21','13:45:00',1.05),('8348','2013-02-21','13:50:00',1.07),('8348','2013-02-21','13:55:00',1.05),('8348','2013-02-21','14:00:00',1.07),('8348','2013-02-21','14:05:00',1.03),('8348','2013-02-21','16:20:00',1.3),('8348','2013-02-21','16:25:00',1.4),('8348','2013-02-21','16:30:00',1.29),('8348','2013-02-21','16:35:00',1.13),('8348','2014-03-23','08:05:00',1.18),('8348','2014-03-23','08:10:00',1.26),('8348','2014-03-23','08:15:00',1.25),('8348','2014-03-23','08:20:00',1.36),('8348','2014-03-23','08:25:00',1.53),('8348','2014-03-23','08:30:00',1.7),('8348','2014-03-23','08:35:00',1.84),('8348','2014-03-23','08:40:00',1.4),('8348','2014-03-23','08:45:00',1.48),('8348','2014-03-23','08:50:00',2),('8348','2014-03-23','08:55:00',2.49),('8348','2014-03-23','09:00:00',1.63),('8348','2014-03-23','09:05:00',2.68),('8348','2014-03-23','09:10:00',4.23),('8348','2014-03-23','09:15:00',4.14),('8348','2014-03-23','09:20:00',3.05),('8348','2014-03-23','09:25:00',1.87),('8348','2014-03-23','09:30:00',2.47),('8348','2014-03-23','09:35:00',2.55),('8348','2014-03-23','09:40:00',2.15),('8348','2014-03-23','09:45:00',1.72),('8348','2014-03-23','09:50:00',1.49),('8348','2014-03-23','09:55:00',1.39),('8348','2014-03-23','10:00:00',1.28),('8348','2014-03-23','10:05:00',1.23),('8348','2014-03-23','10:10:00',1.37),('8348','2014-03-23','10:15:00',1.05),('8348','2014-03-23','10:20:00',1.29),('8348','2014-03-23','10:25:00',2.08),('8348','2014-03-23','10:30:00',1.57),('8348','2014-03-23','10:35:00',1.2),('8348','2014-03-23','10:40:00',2.04),('8348','2014-03-23','10:45:00',1.83),('8348','2014-03-23','10:50:00',2.06),('8348','2014-03-23','10:55:00',2.91),('8348','2014-03-23','11:00:00',2.17),('8348','2014-03-23','11:05:00',1.8),('8348','2014-03-23','11:10:00',2.18),('8348','2014-03-23','11:15:00',1.37),('8348','2014-03-23','11:20:00',1.46),('8348','2014-03-23','11:25:00',1.9),('8348','2014-03-23','11:30:00',1.52),('8348','2014-03-23','11:35:00',2.84),('8348','2014-03-23','11:40:00',6.61),('8348','2014-03-23','11:45:00',1.78),('8348','2014-03-23','11:55:00',1.46),('8348','2014-03-23','12:00:00',1.63),('8348','2014-03-23','12:05:00',1.06),('8348','2014-03-23','12:25:00',1.02),('8348','2014-03-23','12:30:00',1.12),('8348','2014-03-23','12:35:00',1.21),('8348','2014-03-23','13:15:00',1.02),('8348','2014-03-23','13:40:00',1.86),('8348','2014-03-23','13:45:00',4.51),('8348','2014-03-23','13:50:00',2.87),('8348','2014-03-23','13:55:00',2.29),('8348','2014-03-23','14:00:00',1.82),('8348','2014-03-23','14:05:00',1.08),('8348','2014-03-23','14:15:00',1.06),('8348','2014-03-23','14:50:00',1.3),('8348','2014-03-23','14:55:00',1.61),('8348','2014-03-23','15:00:00',1.3),('8348','2014-03-23','15:05:00',1.82),('8348','2014-03-23','15:10:00',2.27),('8348','2014-03-23','15:15:00',3.43),('8348','2014-03-23','15:20:00',3.02),('8348','2014-03-23','15:25:00',3.41),('8348','2014-03-23','15:30:00',2.27),('8348','2014-03-23','15:35:00',1.6),('8348','2014-03-23','15:40:00',1.7),('8348','2013-02-20','08:45:00',1.04),('8348','2013-02-20','08:50:00',1.11),('8348','2013-02-20','08:55:00',1.17),('8348','2013-02-20','09:00:00',1.28),('8348','2013-02-20','09:10:00',1.03),('8348','2013-02-20','09:15:00',1.2),('8348','2013-02-20','09:20:00',1.44),('8348','2013-02-20','09:25:00',1.43),('8348','2013-02-20','09:30:00',1.47),('8348','2013-02-20','09:35:00',1.12),('8348','2013-02-20','09:40:00',1.05),('8348','2013-02-20','09:45:00',1.05),('8348','2013-02-20','09:50:00',1.31),('8348','2013-02-20','09:55:00',1.59),('8348','2013-02-20','10:00:00',1.14),('8348','2013-02-20','10:05:00',1.5),('8348','2013-02-20','10:10:00',1.74),('8348','2013-02-20','10:45:00',1.19),('8348','2013-02-20','10:50:00',3.2),('8348','2013-02-20','10:55:00',1.62),('8348','2013-02-20','11:05:00',1.46),('8348','2013-02-20','11:10:00',3.32),('8348','2013-02-20','11:15:00',3.02),('8348','2013-02-20','11:20:00',2.87),('8348','2013-02-20','11:25:00',1.54),('8348','2013-02-20','11:30:00',1.07),('8348','2013-02-20','11:35:00',2.45),('8348','2013-02-20','11:40:00',3.66),('8348','2013-02-20','11:45:00',3.17),('8348','2013-02-20','11:50:00',3.58),('8348','2013-02-20','11:55:00',2.66),('8348','2013-02-20','12:00:00',2.07),('8348','2013-02-20','12:10:00',1.79),('8348','2013-02-20','12:15:00',3.3),('8348','2013-02-20','12:20:00',1.55),('8348','2013-02-20','12:25:00',2.66),('8348','2013-02-20','12:30:00',3.83),('8348','2013-02-20','12:35:00',2.65),('8348','2013-02-20','12:50:00',1.04),('8348','2013-02-20','12:55:00',1.22),('8348','2013-02-20','13:00:00',2.88),('8348','2013-02-20','13:05:00',1.61),('8348','2013-02-20','13:10:00',2.86),('8348','2013-02-20','13:15:00',3.55),('8348','2013-02-20','13:20:00',2.63),('8348','2013-02-20','13:25:00',1.5),('8348','2013-02-20','13:30:00',1.73),('8348','2013-02-20','13:35:00',1.26),('8348','2013-02-20','13:40:00',1.37),('8348','2013-02-20','13:45:00',1.12),('8348','2013-02-20','13:50:00',1.05),('8348','2013-02-20','13:55:00',1.08),('8348','2013-02-20','14:00:00',1.02),('8348','2013-02-20','14:40:00',1.09),('8348','2013-02-20','14:45:00',1.11),('8348','2013-02-20','15:10:00',1.85),('8348','2013-02-20','15:15:00',2.41),('8348','2013-02-20','15:20:00',1.87),('8348','2013-02-20','15:25:00',2.3),('8348','2013-02-20','15:30:00',1.74),('8348','2013-02-20','15:35:00',1.16),('8348','2013-02-20','16:05:00',1.18),('8348','2013-02-20','16:10:00',1.62),('8348','2013-02-20','16:15:00',1.59),('8348','2013-02-20','16:20:00',1.46),('8348','2013-02-20','16:25:00',1.21),('8348','2013-02-20','16:30:00',1.01),('8348','2013-02-19','08:50:00',1.04),('8348','2013-02-19','08:55:00',1.1),('8348','2013-02-19','09:00:00',1.14),('8348','2013-02-19','09:05:00',1.23),('8348','2013-02-19','09:10:00',1.31),('8348','2013-02-19','09:15:00',1.37),('8348','2013-02-19','09:20:00',1.45),('8348','2013-02-19','09:25:00',1.54),('8348','2013-02-19','09:30:00',1.63),('8348','2013-02-19','09:35:00',1.7),('8348','2013-02-19','09:40:00',1.75),('8348','2013-02-19','09:45:00',1.82),('8348','2013-02-19','09:50:00',1.88),('8348','2013-02-19','09:55:00',1.94),('8348','2013-02-19','10:00:00',1.99),('8348','2013-02-19','10:05:00',2.03),('8348','2013-02-19','10:10:00',2.1),('8348','2013-02-19','10:15:00',2.16),('8348','2013-02-19','10:20:00',2.22),('8348','2013-02-19','10:25:00',2.23),('8348','2013-02-19','10:30:00',2.31),('8348','2013-02-19','10:35:00',2.35),('8348','2013-02-19','10:40:00',2.38),('8348','2013-02-19','10:45:00',2.42),('8348','2013-02-19','10:50:00',2.47),('8348','2013-02-19','10:55:00',2.51),('8348','2013-02-19','11:00:00',2.52),('8348','2013-02-19','11:05:00',2.56),('8348','2013-02-19','11:10:00',2.63),('8348','2013-02-19','11:15:00',2.64),('8348','2013-02-19','11:20:00',2.66),('8348','2013-02-19','11:25:00',2.68),('8348','2013-02-19','11:30:00',2.68),('8348','2013-02-19','11:35:00',2.72),('8348','2013-02-19','11:40:00',2.77),('8348','2013-02-19','11:45:00',2.76),('8348','2013-02-19','11:50:00',2.81),('8348','2013-02-19','11:55:00',2.82),('8348','2013-02-19','12:00:00',2.82),('8348','2013-02-19','12:05:00',2.82),('8348','2013-02-19','12:10:00',2.81),('8348','2013-02-19','12:15:00',2.81),('8348','2013-02-19','12:20:00',2.84),('8348','2013-02-19','12:25:00',2.86),('8348','2013-02-19','12:30:00',2.87),('8348','2013-02-19','12:35:00',2.82),('8348','2013-02-19','12:40:00',2.86),('8348','2013-02-19','12:45:00',2.86),('8348','2013-02-19','12:50:00',2.87),('8348','2013-02-19','12:55:00',2.87),('8348','2013-02-19','13:00:00',2.9),('8348','2013-02-19','13:05:00',2.9),('8348','2013-02-19','13:10:00',2.91),('8348','2013-02-19','13:15:00',2.94),('8348','2013-02-19','13:20:00',2.91),('8348','2013-02-19','13:25:00',2.86),('8348','2013-02-19','13:30:00',2.83),('8348','2013-02-19','13:35:00',2.79),('8348','2013-02-19','13:40:00',2.76),('8348','2013-02-19','13:45:00',2.72),('8348','2013-02-19','13:50:00',2.69),('8348','2013-02-19','13:55:00',2.68),('8348','2013-02-19','14:00:00',2.62),('8348','2013-02-19','14:05:00',2.57),('8348','2013-02-19','14:10:00',2.57),('8348','2013-02-19','14:15:00',2.5),('8348','2013-02-19','14:20:00',2.28),('8348','2013-02-19','14:25:00',2.38),('8348','2013-02-19','14:30:00',2.37),('8348','2013-02-19','14:35:00',2.34),('8348','2013-02-19','14:40:00',2.27),('8348','2013-02-19','14:45:00',2.26),('8348','2013-02-19','14:50:00',2.25),('8348','2013-02-19','14:55:00',2.19),('8348','2013-02-19','15:00:00',2.14),('8348','2013-02-19','15:05:00',2.08),('8348','2013-02-19','15:10:00',2.07),('8348','2013-02-19','15:15:00',1.97),('8348','2013-02-19','15:20:00',1.92),('8348','2013-02-19','15:25:00',1.86),('8348','2013-02-19','15:30:00',1.73),('8348','2013-02-19','15:35:00',1.67),('8348','2013-02-19','15:40:00',1.66),('8348','2013-02-19','15:45:00',1.58),('8348','2013-02-19','15:50:00',1.51),('8348','2013-02-19','15:55:00',1.47),('8348','2013-02-19','16:00:00',1.39),('8348','2013-02-19','16:05:00',1.32),('8348','2013-02-19','16:10:00',1.23),('8348','2013-02-19','16:15:00',1.16),('8348','2013-02-19','16:20:00',1.08),('8348','2013-02-18','08:55:00',1.04),('8348','2013-02-18','09:00:00',1.1),('8348','2013-02-18','09:05:00',1.17),('8348','2013-02-18','09:10:00',1.25),('8348','2013-02-18','09:15:00',1.37),('8348','2013-02-18','09:20:00',1.56),('8348','2013-02-18','09:25:00',1.75),('8348','2013-02-18','09:30:00',1.39),('8348','2013-02-18','09:35:00',1.09),('8348','2013-02-18','09:50:00',1.48),('8348','2013-02-18','11:00:00',1.06),('8348','2013-02-18','11:05:00',1.1),('8348','2013-02-18','11:10:00',1.23),('8348','2013-02-18','11:15:00',1.09),('8348','2013-02-18','11:20:00',1.33),('8348','2013-02-18','11:25:00',1.36),('8348','2013-02-18','11:30:00',1.28),('8348','2013-02-18','11:35:00',1.32),('8348','2013-02-18','11:40:00',1.3),('8348','2013-02-18','11:45:00',1.21),('8348','2013-02-18','11:50:00',1.28),('8348','2013-02-18','11:55:00',1.49),('8348','2013-02-18','12:00:00',1.57),('8348','2013-02-18','12:05:00',1.48),('8348','2013-02-18','12:10:00',1.33),('8348','2013-02-18','12:15:00',1.31),('8348','2013-02-18','12:20:00',1.27),('8348','2013-02-18','12:25:00',1.28),('8348','2013-02-18','12:30:00',1.19),('8348','2013-02-18','12:35:00',1.13),('8348','2013-02-18','12:40:00',1.18),('8348','2013-02-18','12:45:00',1.41),('8348','2013-02-18','12:50:00',1.42),('8348','2013-02-18','12:55:00',1.31),('8348','2013-02-18','13:00:00',1.34),('8348','2013-02-18','13:05:00',1.37),('8348','2013-02-18','13:10:00',1.34),('8348','2013-02-18','13:15:00',1.71),('8348','2013-02-18','13:20:00',1.36),('8348','2013-02-18','13:25:00',1.76),('8348','2013-02-18','13:30:00',1.43),('8348','2013-02-18','13:35:00',1.18),('8348','2013-02-18','13:40:00',1.14),('8348','2013-02-18','13:45:00',1.09),('8348','2013-02-18','13:50:00',1.1),('8348','2013-02-18','13:55:00',1.41),('8348','2013-02-18','14:00:00',1.39),('8348','2013-02-18','14:05:00',1.39),('8348','2013-02-18','14:10:00',1.16),('8348','2013-02-18','14:20:00',1.07),('8348','2013-02-17','08:55:00',1.01),('8348','2013-02-17','09:00:00',1.06),('8348','2013-02-17','09:05:00',1.1),('8348','2013-02-17','09:10:00',1.16),('8348','2013-02-17','09:15:00',1.29),('8348','2013-02-17','09:20:00',1.35),('8348','2013-02-17','09:25:00',1.43),('8348','2013-02-17','09:30:00',1.5),('8348','2013-02-17','09:35:00',1.57),('8348','2013-02-17','09:40:00',1.63),('8348','2013-02-17','09:45:00',1.69),('8348','2013-02-17','09:50:00',1.76),('8348','2013-02-17','09:55:00',1.83),('8348','2013-02-17','10:00:00',1.87),('8348','2013-02-17','10:05:00',1.93),('8348','2013-02-17','10:10:00',1.98),('8348','2013-02-17','10:15:00',2.03),('8348','2013-02-17','10:20:00',2.07),('8348','2013-02-17','10:25:00',2.13),('8348','2013-02-17','10:30:00',2.18),('8348','2013-02-17','10:35:00',2.24),('8348','2013-02-17','10:40:00',2.29),('8348','2013-02-17','10:45:00',2.31),('8348','2013-02-17','10:50:00',2.34),('8348','2013-02-17','10:55:00',2.37),('8348','2013-02-17','11:00:00',2.42),('8348','2013-02-17','11:05:00',2.46),('8348','2013-02-17','11:10:00',2.5),('8348','2013-02-17','11:15:00',2.51),('8348','2013-02-17','11:20:00',2.53),('8348','2013-02-17','11:25:00',2.59),('8348','2013-02-17','11:30:00',2.59),('8348','2013-02-17','11:35:00',2.6),('8348','2013-02-17','11:40:00',2.61),('8348','2013-02-17','11:45:00',2.67),('8348','2013-02-17','11:50:00',2.69),('8348','2013-02-17','11:55:00',2.71),('8348','2013-02-17','12:00:00',2.74),('8348','2013-02-17','12:05:00',2.75),('8348','2013-02-17','12:10:00',2.79),('8348','2013-02-17','12:15:00',2.78),('8348','2013-02-17','12:20:00',2.76),('8348','2013-02-17','12:25:00',2.77),('8348','2013-02-17','12:30:00',2.8),('8348','2013-02-17','12:35:00',2.79),('8348','2013-02-17','12:40:00',2.76),('8348','2013-02-17','12:45:00',2.71),('8348','2013-02-17','12:50:00',2.71),('8348','2013-02-17','12:55:00',2.75),('8348','2013-02-17','13:00:00',2.76),('8348','2013-02-17','13:05:00',2.76),('8348','2013-02-17','13:10:00',2.72),('8348','2013-02-17','13:15:00',2.71),('8348','2013-02-17','13:20:00',2.33),('8348','2013-02-17','13:30:00',2.69),('8348','2013-02-17','13:35:00',2.58),('8348','2013-02-17','13:40:00',2.55),('8348','2013-02-17','13:45:00',2.53),('8348','2013-02-17','13:50:00',2.18),('8348','2013-02-17','13:55:00',1.86),('8348','2013-02-17','14:05:00',1.18),('8348','2013-02-17','14:10:00',2.55),('8348','2013-02-17','14:15:00',1.9),('8348','2013-02-17','14:25:00',1.27),('8348','2013-02-17','14:30:00',2.17),('8348','2013-02-17','14:35:00',2.4),('8348','2013-02-17','14:40:00',2.07),('8348','2013-02-17','15:00:00',1.42),('8348','2013-02-17','15:05:00',1.49),('8348','2013-02-17','15:10:00',2.29),('8348','2013-02-17','15:15:00',2.22),('8348','2013-02-17','15:20:00',2.14),('8348','2013-02-17','15:25:00',2.03),('8348','2013-02-17','15:30:00',1.87),('8348','2013-02-17','15:35:00',1.82),('8348','2013-02-17','15:40:00',1.82),('8348','2013-02-17','15:45:00',1.7),('8348','2013-02-17','15:50:00',1.63),('8348','2013-02-17','15:55:00',1.55),('8348','2013-02-17','16:00:00',1.45),('8348','2013-02-17','16:05:00',1.34),('8348','2013-02-17','16:25:00',1.16),('8348','2013-02-17','16:30:00',1.14),('8348','2013-02-16','09:15:00',1.31),('8348','2013-02-16','09:20:00',1.42),('8348','2013-02-16','09:25:00',1.47),('8348','2013-02-16','09:30:00',1.54),('8348','2013-02-16','09:35:00',1.63),('8348','2013-02-16','09:40:00',1.68),('8348','2013-02-16','09:45:00',1.73),('8348','2013-02-16','09:50:00',1.81),('8348','2013-02-16','09:55:00',1.85),('8348','2013-02-16','10:00:00',1.88),('8348','2013-02-16','10:05:00',1.94),('8348','2013-02-16','10:10:00',2.03),('8348','2013-02-16','10:15:00',2.06),('8348','2013-02-16','10:20:00',2.13),('8348','2013-02-16','10:25:00',2.17),('8348','2013-02-16','10:30:00',2.2),('8348','2013-02-16','10:35:00',2.3),('8348','2013-02-16','10:40:00',2.33),('8348','2013-02-16','10:45:00',2.45),('8348','2013-02-16','10:50:00',2.47),('8348','2013-02-16','10:55:00',2.45),('8348','2013-02-16','11:00:00',2.51),('8348','2013-02-16','11:05:00',2.49),('8348','2013-02-16','11:10:00',2.52),('8348','2013-02-16','11:15:00',2.57),('8348','2013-02-16','11:20:00',2.59),('8348','2013-02-16','11:25:00',2.67),('8348','2013-02-16','11:30:00',2.67),('8348','2013-02-16','11:35:00',2.7),('8348','2013-02-16','11:40:00',2.73),('8348','2013-02-16','11:45:00',2.77),('8348','2013-02-16','11:50:00',2.8),('8348','2013-02-16','11:55:00',2.81),('8348','2013-02-16','12:00:00',2.81),('8348','2013-02-16','12:05:00',2.81),('8348','2013-02-16','12:10:00',2.82),('8348','2013-02-16','12:15:00',2.84),('8348','2013-02-16','12:20:00',2.84),('8348','2013-02-16','12:25:00',2.84),('8348','2013-02-16','12:30:00',2.85),('8348','2013-02-16','12:35:00',2.86),('8348','2013-02-16','12:40:00',2.87),('8348','2013-02-16','12:45:00',2.87),('8348','2013-02-16','12:50:00',2.91),('8348','2013-02-16','12:55:00',2.88),('8348','2013-02-16','13:00:00',2.88),('8348','2013-02-16','13:05:00',2.86),('8348','2013-02-16','13:10:00',2.83),('8348','2013-02-16','13:15:00',2.82),('8348','2013-02-16','13:20:00',2.8),('8348','2013-02-16','13:25:00',2.77),('8348','2013-02-16','13:30:00',2.75),('8348','2013-02-16','13:35:00',2.74),('8348','2013-02-16','13:40:00',2.74),('8348','2013-02-16','13:45:00',2.75),('8348','2013-02-16','13:50:00',2.73),('8348','2013-02-16','13:55:00',2.69),('8348','2013-02-16','14:00:00',2.63),('8348','2013-02-16','14:05:00',2.63),('8348','2013-02-16','14:10:00',2.6),('8348','2013-02-16','14:15:00',2.58),('8348','2013-02-16','14:20:00',2.62),('8348','2013-02-16','14:25:00',1.77),('8348','2013-02-16','15:20:00',1.05),('8348','2013-02-16','15:25:00',1.21),('8348','2013-02-16','15:30:00',2.12),('8348','2013-02-16','15:35:00',2.07),('8348','2013-02-16','15:40:00',1.97),('8348','2013-02-16','15:45:00',1.9),('8348','2013-02-16','15:50:00',1.95),('8348','2013-02-16','15:55:00',1.27),('8348','2013-02-16','16:00:00',1.12),('8348','2013-02-16','16:05:00',1.3),('8348','2013-02-15','09:20:00',1.17),('8348','2013-02-15','09:25:00',1.45),('8348','2013-02-15','09:30:00',1.06),('8348','2013-02-15','09:55:00',1.11),('8348','2013-02-15','10:00:00',1.42),('8348','2013-02-15','10:05:00',1.24),('8348','2013-02-15','10:10:00',1.03),('8348','2013-02-15','10:15:00',1),('8348','2013-02-15','10:20:00',1.35),('8348','2013-02-15','10:25:00',1.76),('8348','2013-02-15','10:30:00',1.5),('8348','2013-02-15','10:35:00',2.27),('8348','2013-02-15','10:40:00',2.2),('8348','2013-02-15','10:48:00',2.26),('8348','2013-02-15','10:50:00',1.42),('8348','2013-02-15','10:55:00',1.53),('8348','2013-02-15','11:00:00',1.46),('8348','2013-02-15','11:05:00',1.57),('8348','2013-02-15','11:10:00',1.64),('8348','2013-02-15','11:15:00',2.15),('8348','2013-02-15','11:20:00',2.71),('8348','2013-02-15','11:25:00',2.65),('8348','2013-02-15','11:30:00',2.65),('8348','2013-02-15','11:35:00',2.29),('8348','2013-02-15','11:40:00',1.53),('8348','2013-02-15','11:45:00',1.95),('8348','2013-02-15','11:50:00',3.08),('8348','2013-02-15','11:55:00',2.63),('8348','2013-02-15','12:00:00',2.34),('8348','2013-02-15','12:05:00',2.23),('8348','2013-02-15','12:10:00',2.29),('8348','2013-02-15','12:15:00',2.57),('8348','2013-02-15','12:20:00',3.16),('8348','2013-02-15','12:25:00',2.81),('8348','2013-02-15','12:30:00',2.91),('8348','2013-02-15','12:35:00',2.86),('8348','2013-02-15','12:40:00',2.87),('8348','2013-02-15','12:45:00',2.87),('8348','2013-02-15','12:50:00',2.87),('8348','2013-02-15','12:55:00',2.9),('8348','2013-02-15','13:00:00',2.88),('8348','2013-02-15','13:05:00',2.88),('8348','2013-02-15','13:10:00',2.8),('8348','2013-02-15','13:15:00',2.9),('8348','2013-02-15','13:20:00',2.66),('8348','2013-02-15','13:25:00',2.37),('8348','2013-02-15','13:30:00',1.68),('8348','2013-02-15','13:35:00',2.06),('8348','2013-02-15','13:40:00',2.84),('8348','2013-02-15','13:45:00',2.18),('8348','2013-02-15','13:50:00',2.2),('8348','2013-02-15','13:55:00',2.45),('8348','2013-02-15','14:00:00',1.83),('8348','2013-02-15','14:05:00',2.6),('8348','2013-02-15','14:10:00',3.05),('8348','2013-02-15','14:15:00',2.04),('8348','2013-02-15','14:20:00',2.1),('8348','2013-02-15','14:25:00',1.49),('8348','2013-02-15','14:30:00',1.42),('8348','2013-02-15','14:35:00',2.34),('8348','2013-02-15','14:40:00',2.45),('8348','2013-02-15','14:45:00',1.85),('8348','2013-02-15','14:50:00',1.15),('8348','2013-02-15','14:55:00',1.13),('8348','2013-02-15','15:00:00',1.66),('8348','2013-02-15','15:05:00',1.08),('8348','2013-02-15','15:10:00',1.3),('8348','2013-02-15','15:15:00',1.46),('8348','2013-02-15','15:20:00',1.21),('8348','2013-02-15','15:25:00',1.47),('8348','2013-02-15','15:30:00',1.62),('8348','2013-02-15','15:35:00',1.27),('8348','2013-02-15','15:40:00',1.14),('8348','2013-02-15','15:45:00',1.1),('8348','2013-02-14','09:00:00',1.07),('8348','2013-02-14','09:05:00',1.12),('8348','2013-02-14','09:10:00',1.2),('8348','2013-02-14','09:15:00',1.27),('8348','2013-02-14','09:20:00',1.35),('8348','2013-02-14','09:25:00',1.42),('8348','2013-02-14','09:30:00',1.51),('8348','2013-02-14','09:35:00',1.62),('8348','2013-02-14','09:40:00',1.69),('8348','2013-02-14','09:45:00',1.76),('8348','2013-02-14','09:50:00',1.82),('8348','2013-02-14','09:55:00',1.89),('8348','2013-02-14','10:00:00',1.95),('8348','2013-02-14','10:05:00',2.01),('8348','2013-02-14','10:10:00',2.07),('8348','2013-02-14','10:15:00',2.13),('8348','2013-02-14','10:20:00',2.18),('8348','2013-02-14','10:25:00',2.23),('8348','2013-02-14','10:30:00',2.28),('8348','2013-02-14','10:35:00',2.33),('8348','2013-02-14','10:40:00',2.38),('8348','2013-02-14','10:45:00',2.42),('8348','2013-02-14','10:50:00',2.47),('8348','2013-02-14','10:55:00',2.52),('8348','2013-02-14','11:00:00',2.55),('8348','2013-02-14','11:05:00',2.59),('8348','2013-02-14','11:10:00',2.63),('8348','2013-02-14','11:15:00',2.66),('8348','2013-02-14','11:20:00',2.69),('8348','2013-02-14','11:25:00',2.71),('8348','2013-02-14','11:30:00',2.73),('8348','2013-02-14','11:35:00',2.76),('8348','2013-02-14','11:40:00',2.76),('8348','2013-02-14','11:45:00',2.79),('8348','2013-02-14','11:50:00',2.81),('8348','2013-02-14','11:55:00',2.83),('8348','2013-02-14','12:00:00',2.86),('8348','2013-02-14','12:05:00',2.87),('8348','2013-02-14','12:10:00',2.87),('8348','2013-02-14','12:15:00',2.88),('8348','2013-02-14','12:20:00',2.88),('8348','2013-02-14','12:25:00',2.89),('8348','2013-02-14','12:30:00',2.89),('8348','2013-02-14','12:35:00',2.89),('8348','2013-02-14','12:40:00',2.9),('8348','2013-02-14','12:45:00',2.88),('8348','2013-02-14','12:50:00',2.87),('8348','2013-02-14','12:55:00',2.87),('8348','2013-02-14','13:00:00',2.87),('8348','2013-02-14','13:05:00',2.87),('8348','2013-02-14','13:10:00',2.87),('8348','2013-02-14','13:15:00',2.86),('8348','2013-02-14','13:20:00',2.84),('8348','2013-02-14','13:25:00',2.81),('8348','2013-02-14','13:30:00',2.79),('8348','2013-02-14','13:35:00',2.77),('8348','2013-02-14','13:40:00',2.76),('8348','2013-02-14','13:45:00',2.74),('8348','2013-02-14','13:50:00',2.7),('8348','2013-02-14','13:55:00',2.67),('8348','2013-02-14','14:00:00',2.64),('8348','2013-02-14','14:05:00',2.6),('8348','2013-02-14','14:10:00',2.57),('8348','2013-02-14','14:15:00',2.53),('8348','2013-02-14','14:20:00',2.49),('8348','2013-02-14','14:25:00',2.45),('8348','2013-02-14','14:30:00',2.39),('8348','2013-02-14','14:35:00',2.34),('8348','2013-02-14','14:40:00',2.3),('8348','2013-02-14','14:45:00',2.26),('8348','2013-02-14','14:50:00',2.21),('8348','2013-02-14','14:55:00',2.16),('8348','2013-02-14','15:00:00',2.1),('8348','2013-02-14','15:05:00',2.04),('8348','2013-02-14','15:10:00',1.99),('8348','2013-02-14','15:15:00',1.92),('8348','2013-02-14','15:20:00',1.86),('8348','2013-02-14','15:25:00',1.79),('8348','2013-02-14','15:30:00',1.74),('8348','2013-02-14','15:35:00',1.66),('8348','2013-02-14','15:40:00',1.58),('8348','2013-02-14','15:45:00',1.53),('8348','2013-02-14','15:50:00',1.46),('8348','2013-02-14','15:55:00',1.39),('8348','2013-02-14','16:00:00',1.31),('8348','2013-02-14','16:05:00',1.22),('8348','2013-02-14','16:10:00',1.14),('8348','2013-02-14','16:15:00',1.07),('8348','2013-02-13','09:10:00',1),('8348','2013-02-13','09:25:00',1.01),('8348','2013-02-13','09:30:00',1.02),('8348','2013-02-13','09:35:00',1.34),('8348','2013-02-13','09:40:00',1.53),('8348','2013-02-13','09:45:00',1.79),('8348','2013-02-13','09:50:00',1.8),('8348','2013-02-13','09:55:00',1.7),('8348','2013-02-13','10:00:00',1.76),('8348','2013-02-13','10:05:00',1.89),('8348','2013-02-13','10:10:00',2),('8348','2013-02-13','10:15:00',2.11),('8348','2013-02-13','10:20:00',2.18),('8348','2013-02-13','10:25:00',2.26),('8348','2013-02-13','10:30:00',2.4),('8348','2013-02-13','10:35:00',2.37),('8348','2013-02-13','10:40:00',2.39),('8348','2013-02-13','10:45:00',2.56),('8348','2013-02-13','10:50:00',2.61),('8348','2013-02-13','10:55:00',2.6),('8348','2013-02-13','11:00:00',2.55),('8348','2013-02-13','11:05:00',2.69),('8348','2013-02-13','11:10:00',2.44),('8348','2013-02-13','11:15:00',2.57),('8348','2013-02-13','11:20:00',2.59),('8348','2013-02-13','11:25:00',1.93),('8348','2013-02-13','11:30:00',2.52),('8348','2013-02-13','11:35:00',1.37),('8348','2013-02-13','11:40:00',1.31),('8348','2013-02-13','11:45:00',1.09),('8348','2013-02-13','11:50:00',1.02),('8348','2013-02-13','12:10:00',1.51),('8348','2013-02-13','12:15:00',1.77),('8348','2013-02-13','12:20:00',1.8),('8348','2013-02-13','12:25:00',2.07),('8348','2013-02-13','12:35:00',1.25),('8348','2013-02-13','12:45:00',1.65),('8348','2013-02-13','12:50:00',2.17),('8348','2013-02-13','12:55:00',2.11),('8348','2013-02-13','13:00:00',2.05),('8348','2013-02-13','13:05:00',1.89),('8348','2013-02-13','13:10:00',2.25),('8348','2013-02-13','13:15:00',2.12),('8348','2013-02-13','13:20:00',2.9),('8348','2013-02-13','13:25:00',2.94),('8348','2013-02-13','13:30:00',2.99),('8348','2013-02-13','13:35:00',3),('8348','2013-02-13','13:40:00',2.81),('8348','2013-02-13','13:45:00',2.64),('8348','2013-02-13','13:50:00',2.28),('8348','2013-02-13','13:55:00',2.3),('8348','2013-02-13','14:00:00',2.64),('8348','2013-02-13','14:05:00',2.8),('8348','2013-02-13','14:10:00',2.41),('8348','2013-02-13','14:15:00',2.37),('8348','2013-02-13','14:20:00',2.3),('8348','2013-02-13','14:25:00',2.12),('8348','2013-02-13','14:30:00',2.34),('8348','2013-02-13','14:35:00',2.43),('8348','2013-02-13','14:40:00',2.39),('8348','2013-02-13','14:45:00',2.22),('8348','2013-02-13','14:50:00',2.25),('8348','2013-02-13','14:55:00',2.19),('8348','2013-02-13','15:00:00',2.12),('8348','2013-02-13','15:05:00',2.06),('8348','2013-02-13','15:10:00',1.98),('8348','2013-02-13','15:15:00',1.91),('8348','2013-02-13','15:20:00',1.85),('8348','2013-02-13','15:25:00',1.83),('8348','2013-02-13','15:30:00',1.77),('8348','2013-02-13','15:35:00',1.71),('8348','2013-02-13','15:40:00',1.65),('8348','2013-02-13','15:45:00',1.58),('8348','2013-02-13','15:50:00',1.49),('8348','2013-02-13','15:55:00',1.43),('8348','2013-02-13','16:00:00',1.34),('8348','2013-02-13','16:05:00',1.25),('8348','2013-02-13','16:10:00',1.18),('8348','2013-02-13','16:15:00',1.11),('8348','2013-02-13','16:20:00',1.01),('8348','2013-02-11','10:35:00',1.14),('8348','2013-02-11','10:40:00',1.02),('8348','2013-02-11','11:10:00',1.17),('8348','2013-02-11','11:15:00',1.29),('8348','2013-02-11','11:20:00',1.02),('8348','2013-02-11','11:45:00',1.08),('8348','2013-02-11','12:45:00',1.14),('8348','2013-02-11','14:10:00',1.1),('8348','2013-02-11','14:25:00',1.36),('8348','2013-02-11','14:30:00',1.93),('8348','2013-02-11','14:35:00',1.01),('8348','2013-02-11','14:40:00',1.48),('8348','2013-02-11','14:45:00',1.22),('8348','2014-03-22','07:35:00',1.45),('8348','2014-03-22','07:40:00',1.94),('8348','2014-03-22','07:45:00',1.85),('8348','2014-03-22','07:50:00',1.74),('8348','2014-03-22','07:55:00',1.05),('8348','2014-03-22','08:10:00',1.65),('8348','2014-03-22','08:15:00',1.95),('8348','2014-03-22','08:20:00',2.27),('8348','2014-03-22','08:25:00',2.29),('8348','2014-03-22','08:30:00',2.39),('8348','2014-03-22','08:35:00',1.68),('8348','2014-03-22','08:40:00',3.42),('8348','2014-03-22','08:45:00',3.34),('8348','2014-03-22','08:50:00',2.76),('8348','2014-03-22','08:55:00',2.56),('8348','2014-03-22','09:00:00',3.29),('8348','2014-03-22','09:05:00',2.34),('8348','2014-03-22','09:10:00',2.47),('8348','2014-03-22','09:15:00',2.18),('8348','2014-03-22','09:20:00',2.36),('8348','2014-03-22','09:25:00',2.9),('8348','2014-03-22','09:30:00',4.17),('8348','2014-03-22','09:35:00',3),('8348','2014-03-22','09:40:00',4.01),('8348','2014-03-22','09:45:00',4.65),('8348','2014-03-22','09:50:00',4.76),('8348','2014-03-22','09:55:00',4.89),('8348','2014-03-22','10:00:00',5.12),('8348','2014-03-22','10:05:00',3.8),('8348','2014-03-22','10:10:00',4.34),('8348','2014-03-22','10:15:00',2.97),('8348','2014-03-22','10:20:00',2.02),('8348','2014-03-22','10:25:00',1.69),('8348','2014-03-22','10:30:00',1.74),('8348','2014-03-22','10:35:00',2.55),('8348','2014-03-22','10:40:00',3.53),('8348','2014-03-22','10:45:00',4.35),('8348','2014-03-22','10:50:00',5.06),('8348','2014-03-22','10:55:00',2.38),('8348','2014-03-22','11:00:00',2),('8348','2014-03-22','11:05:00',1.77),('8348','2014-03-22','11:10:00',2.31),('8348','2014-03-22','11:15:00',3.17),('8348','2014-03-22','11:20:00',6.37),('8348','2014-03-22','11:25:00',6.73),('8348','2014-03-22','11:30:00',5.86),('8348','2014-03-22','11:35:00',2.93),('8348','2014-03-22','11:40:00',5.44),('8348','2014-03-22','11:45:00',2.85),('8348','2014-03-22','11:50:00',3.79),('8348','2014-03-22','11:55:00',7.38),('8348','2014-03-22','12:00:00',4.85),('8348','2014-03-22','12:05:00',3.27),('8348','2014-03-22','12:10:00',2.29),('8348','2014-03-22','12:15:00',3.4),('8348','2014-03-22','12:20:00',6.66),('8348','2014-03-22','12:25:00',4.98),('8348','2014-03-22','12:30:00',3),('8348','2014-03-22','12:35:00',5.3),('8348','2014-03-22','12:40:00',6.4),('8348','2014-03-22','12:45:00',6.99),('8348','2014-03-22','12:50:00',4.1),('8348','2014-03-22','12:55:00',6.21),('8348','2014-03-22','13:00:00',2.58),('8348','2014-03-22','13:05:00',4.9),('8348','2014-03-22','13:10:00',7.36),('8348','2014-03-22','13:15:00',5.16),('8348','2014-03-22','13:20:00',6.28),('8348','2014-03-22','13:25:00',6.25),('8348','2014-03-22','13:30:00',3.89),('8348','2014-03-22','13:35:00',6.39),('8348','2014-03-22','13:40:00',5.96),('8348','2014-03-22','13:45:00',6.41),('8348','2014-03-22','13:50:00',6.09),('8348','2014-03-22','13:55:00',3.94),('8348','2014-03-22','14:00:00',5.52),('8348','2014-03-22','14:05:00',3.78),('8348','2014-03-22','14:10:00',6.18),('8348','2014-03-22','14:15:00',4.19),('8348','2014-03-22','14:20:00',5.08),('8348','2014-03-22','14:25:00',5.9),('8348','2014-03-22','14:30:00',5.73),('8348','2014-03-22','14:35:00',5.65),('8348','2014-03-22','14:40:00',5.53),('8348','2014-03-22','14:45:00',5.36),('8348','2014-03-22','14:50:00',5.31),('8348','2014-03-22','14:55:00',5.23),('8348','2014-03-22','15:00:00',5.08),('8348','2014-03-22','15:05:00',5.01),('8348','2014-03-22','15:10:00',4.77),('8348','2014-03-22','15:15:00',4.69),('8348','2014-03-22','15:20:00',4.7),('8348','2014-03-22','15:25:00',3.79),('8348','2014-03-22','15:30:00',2.54),('8348','2014-03-22','15:35:00',4.65),('8348','2014-03-22','15:40:00',5.32),('8348','2014-03-22','15:45:00',5.14),('8348','2014-03-22','15:50:00',5.07),('8348','2014-03-22','15:55:00',4.59),('8348','2014-03-22','16:00:00',4.23),('8348','2014-03-22','16:05:00',3.75),('8348','2014-03-22','16:10:00',3.43),('8348','2014-03-22','16:15:00',3.24),('8348','2014-03-22','16:20:00',3.19),('8348','2014-03-22','16:25:00',2.64),('8348','2014-03-22','16:30:00',1.48),('8348','2014-03-22','16:35:00',1.25),('8348','2014-03-22','16:45:00',1.16),('8348','2014-03-22','16:50:00',1.65),('8348','2014-03-22','16:55:00',1.5),('8348','2014-03-22','17:00:00',1.73),('8348','2014-03-22','17:05:00',1.22),('8348','2013-02-10','10:00:00',1.91),('8348','2013-02-10','10:05:00',1.98),('8348','2013-02-10','10:10:00',1.98),('8348','2013-02-10','10:15:00',2.07),('8348','2013-02-10','10:20:00',2.11),('8348','2013-02-10','10:25:00',2.16),('8348','2013-02-10','10:30:00',2.21),('8348','2013-02-10','10:35:00',2.26),('8348','2013-02-10','10:40:00',2.29),('8348','2013-02-10','10:45:00',2.33),('8348','2013-02-10','10:50:00',2.38),('8348','2013-02-10','10:55:00',2.42),('8348','2013-02-10','11:00:00',2.47),('8348','2013-02-10','11:05:00',2.49),('8348','2013-02-10','11:10:00',2.52),('8348','2013-02-10','11:15:00',2.55),('8348','2013-02-10','11:20:00',2.57),('8348','2013-02-10','11:25:00',2.6),('8348','2013-02-10','11:30:00',2.64),('8348','2013-02-10','11:35:00',2.66),('8348','2013-02-10','11:40:00',2.68),('8348','2013-02-10','11:45:00',2.7),('8348','2013-02-10','11:50:00',2.72),('8348','2013-02-10','11:55:00',2.75),('8348','2013-02-10','12:00:00',2.79),('8348','2013-02-10','12:05:00',2.8),('8348','2013-02-10','12:10:00',2.81),('8348','2013-02-10','12:15:00',2.85),('8348','2013-02-10','12:20:00',2.85),('8348','2013-02-10','12:25:00',2.86),('8348','2013-02-10','12:30:00',2.84),('8348','2013-02-10','12:35:00',2.85),('8348','2013-02-10','12:40:00',2.84),('8348','2013-02-10','12:45:00',2.84),('8348','2013-02-10','12:50:00',2.86),('8348','2013-02-10','12:55:00',2.86),('8348','2013-02-10','13:00:00',2.83),('8348','2013-02-10','13:05:00',2.79),('8348','2013-02-10','13:10:00',2.78),('8348','2013-02-10','13:15:00',2.75),('8348','2013-02-10','13:20:00',2.75),('8348','2013-02-10','13:25:00',2.75),('8348','2013-02-10','13:30:00',2.69),('8348','2013-02-10','13:35:00',2.63),('8348','2013-02-10','13:40:00',2.6),('8348','2013-02-10','13:45:00',2.58),('8348','2013-02-10','13:50:00',2.59),('8348','2013-02-10','13:55:00',2.55),('8348','2013-02-10','14:00:00',2.48),('8348','2013-02-10','14:05:00',2.46),('8348','2013-02-10','14:10:00',2.43),('8348','2013-02-10','14:15:00',2.4),('8348','2013-02-10','14:20:00',2.39),('8348','2013-02-10','14:25:00',2.32),('8348','2013-02-10','14:30:00',2.31),('8348','2013-02-10','14:35:00',1.81),('8348','2013-02-10','14:40:00',2.23),('8348','2013-02-10','14:45:00',2.13),('8348','2013-02-10','14:50:00',2.09),('8348','2013-02-10','14:55:00',1.23),('8348','2013-02-10','15:00:00',1.29),('8348','2013-02-10','15:05:00',1.45),('8348','2013-02-10','15:10:00',1.91),('8348','2013-02-10','15:15:00',1.27),('8348','2013-02-10','15:20:00',1.89),('8348','2013-02-10','15:25:00',1.98),('8348','2013-02-10','15:30:00',1.29),('8348','2013-02-10','15:35:00',1.47),('8348','2013-02-10','15:40:00',1.1),('8348','2013-02-09','11:05:00',1),('8348','2013-02-09','11:10:00',1.03),('8348','2013-02-09','11:15:00',1.07),('8348','2013-02-09','11:20:00',1.1),('8348','2013-02-09','11:25:00',1.11),('8348','2013-02-09','11:30:00',1.12),('8348','2013-02-09','11:35:00',1.09),('8348','2013-02-09','11:40:00',1.06),('8348','2013-02-09','11:45:00',1.07),('8348','2013-02-09','11:50:00',1.07),('8348','2013-02-09','11:55:00',1.04),('8348','2013-02-09','12:00:00',1.05),('8348','2013-02-09','12:05:00',1.05),('8348','2013-02-09','12:10:00',1.03),('8348','2013-02-09','12:15:00',1.02),('8348','2013-02-09','12:20:00',1.04),('8348','2013-02-09','12:25:00',1.05),('8348','2013-02-09','12:30:00',1.07),('8348','2013-02-09','12:35:00',1.13),('8348','2013-02-09','12:40:00',1.15),('8348','2013-02-09','12:45:00',1.15),('8348','2013-02-09','12:50:00',1.17),('8348','2013-02-09','12:55:00',1.16),('8348','2013-02-09','13:00:00',1.24),('8348','2013-02-09','13:05:00',1.4),('8348','2013-02-09','13:10:00',1.56),('8348','2013-02-09','13:15:00',1.69),('8348','2013-02-09','13:20:00',1.88),('8348','2013-02-09','13:25:00',1.98),('8348','2013-02-09','13:30:00',2.25),('8348','2013-02-09','13:35:00',2.33),('8348','2013-02-09','13:40:00',2.35),('8348','2013-02-09','13:45:00',2.55),('8348','2013-02-09','13:50:00',2.66),('8348','2013-02-09','13:55:00',2.75),('8348','2013-02-09','14:00:00',2.65),('8348','2013-02-09','14:05:00',2.38),('8348','2013-02-09','14:10:00',2.01),('8348','2013-02-09','14:15:00',2.51),('8348','2013-02-09','14:20:00',2.85),('8348','2013-02-09','14:25:00',2.9),('8348','2013-02-09','14:30:00',2.61),('8348','2013-02-09','14:35:00',2.41),('8348','2013-02-09','14:40:00',2.18),('8348','2013-02-09','14:45:00',2.11),('8348','2013-02-09','14:50:00',2.06),('8348','2013-02-09','14:55:00',2.04),('8348','2013-02-09','15:00:00',1.97),('8348','2013-02-09','15:05:00',1.91),('8348','2013-02-09','15:10:00',1.85),('8348','2013-02-09','15:15:00',1.74),('8348','2013-02-09','15:20:00',1.72),('8348','2013-02-09','15:25:00',1.52),('8348','2013-02-09','15:30:00',1.55),('8348','2013-02-09','15:35:00',1.48),('8348','2013-02-09','15:40:00',1.41),('8348','2013-02-09','15:45:00',1.3),('8348','2013-02-09','15:50:00',1.28),('8348','2013-02-08','09:35:00',1.86),('8348','2013-02-08','09:40:00',1.94),('8348','2013-02-08','09:45:00',1.47),('8348','2013-02-08','09:50:00',2.01),('8348','2013-02-08','09:55:00',2.06),('8348','2013-02-08','10:00:00',2.19),('8348','2013-02-08','10:05:00',2.34),('8348','2013-02-08','10:10:00',2.36),('8348','2013-02-08','10:15:00',2.46),('8348','2013-02-08','10:20:00',2.61),('8348','2013-02-08','10:25:00',2.43),('8348','2013-02-08','10:30:00',2.59),('8348','2013-02-08','10:35:00',1.21),('8348','2013-02-08','10:40:00',2.16),('8348','2013-02-08','10:45:00',2.47),('8348','2013-02-08','10:50:00',2.66),('8348','2013-02-08','10:55:00',2.62),('8348','2013-02-08','11:00:00',2.56),('8348','2013-02-08','11:05:00',2.54),('8348','2013-02-08','11:10:00',2.56),('8348','2013-02-08','11:15:00',2.56),('8348','2013-02-08','11:20:00',2.59),('8348','2013-02-08','11:25:00',2.61),('8348','2013-02-08','11:30:00',2.63),('8348','2013-02-08','11:35:00',2.64),('8348','2013-02-08','11:40:00',2.67),('8348','2013-02-08','11:45:00',2.69),('8348','2013-02-08','11:50:00',2.7),('8348','2013-02-08','11:55:00',2.71),('8348','2013-02-08','12:00:00',2.73),('8348','2013-02-08','12:05:00',2.74),('8348','2013-02-08','12:10:00',2.75),('8348','2013-02-08','12:15:00',2.76),('8348','2013-02-08','12:20:00',2.79),('8348','2013-02-08','12:25:00',2.82),('8348','2013-02-08','12:30:00',2.81),('8348','2013-02-08','12:35:00',2.82),('8348','2013-02-08','12:40:00',2.87),('8348','2013-02-08','12:45:00',3.18),('8348','2013-02-08','12:50:00',1.95),('8348','2013-02-08','12:55:00',1.89),('8348','2013-02-08','13:00:00',1.74),('8348','2013-02-08','13:05:00',1.52),('8348','2013-02-08','13:10:00',1.68),('8348','2013-02-08','13:15:00',1.62),('8348','2013-02-08','13:20:00',1.71),('8348','2013-02-08','13:25:00',1.58),('8348','2013-02-08','13:30:00',1.58),('8348','2013-02-08','13:35:00',2.3),('8348','2013-02-08','13:40:00',1.68),('8348','2013-02-08','13:45:00',1.32),('8348','2013-02-08','13:50:00',1.38),('8348','2013-02-08','13:55:00',1.41),('8348','2013-02-08','14:00:00',1.31),('8348','2013-02-08','14:05:00',1.29),('8348','2013-02-08','14:10:00',1.2),('8348','2013-02-08','14:15:00',1.11),('8348','2013-02-08','14:20:00',1.15),('8348','2013-02-08','14:25:00',1.44),('8348','2013-02-08','14:30:00',1.84),('8348','2013-02-08','14:35:00',2.12),('8348','2013-02-08','14:40:00',3.21),('8348','2013-02-08','14:45:00',2.62),('8348','2013-02-08','14:50:00',1.77),('8348','2013-02-08','14:55:00',2.28),('8348','2013-02-08','15:00:00',2.43),('8348','2013-02-08','15:05:00',2.68),('8348','2013-02-08','15:10:00',2.51),('8348','2013-02-08','15:15:00',1.95),('8348','2013-02-08','15:20:00',1.19),('8348','2013-02-08','15:25:00',1.81),('8348','2013-02-08','15:30:00',1.72),('8348','2013-02-08','15:35:00',1.62),('8348','2013-02-08','15:40:00',1.55),('8348','2013-02-08','15:45:00',1.49),('8348','2013-02-08','15:50:00',1.4),('8348','2013-02-08','15:55:00',1.31),('8348','2013-02-08','16:00:00',1.22),('8348','2013-02-08','16:05:00',1.14),('8348','2013-02-08','16:10:00',1.08),('8348','2013-02-07','10:40:00',1.16),('8348','2013-02-07','10:45:00',1.22),('8348','2013-02-07','10:55:00',1.22),('8348','2013-02-07','11:00:00',1.67),('8348','2013-02-07','12:25:00',2.16),('8348','2013-02-07','12:30:00',1.6),('8348','2013-02-07','13:15:00',1.77),('8348','2013-02-07','13:20:00',1.38),('8348','2013-02-07','13:25:00',1.19),('8348','2013-02-07','13:55:00',1.01),('8348','2013-02-07','14:00:00',1.23),('8348','2013-02-07','14:05:00',1.74),('8348','2013-02-07','14:10:00',2.71),('8348','2013-02-07','14:15:00',2.54),('8348','2013-02-07','14:20:00',2.38),('8348','2013-02-07','14:25:00',1.13),('8348','2013-02-07','14:30:00',1.05),('8348','2013-02-07','14:35:00',1.85),('8348','2013-02-07','14:40:00',1.5),('8348','2013-02-07','14:45:00',1.83),('8348','2013-02-07','14:50:00',1.17),('8348','2013-02-07','15:00:00',1.64),('8348','2013-02-07','15:05:00',2.22),('8348','2013-02-07','15:10:00',2.26),('8348','2013-02-07','15:15:00',1.36),('8348','2013-02-06','09:10:00',1.12),('8348','2013-02-06','09:30:00',1.23),('8348','2013-02-06','09:40:00',1.32),('8348','2013-02-06','09:45:00',1.08),('8348','2013-02-06','09:50:00',1.09),('8348','2013-02-06','09:55:00',1.32),('8348','2013-02-06','10:06:00',1.25),('8348','2013-02-06','10:10:00',1.07),('8348','2013-02-06','10:15:00',1.16),('8348','2013-02-06','10:20:00',1.04),('8348','2013-02-06','10:25:00',1.39),('8348','2013-02-06','10:30:00',1.23),('8348','2013-02-06','10:35:00',1.64),('8348','2013-02-06','10:40:00',1.14),('8348','2013-02-06','10:50:00',1.47),('8348','2013-02-06','10:55:00',1.85),('8348','2013-02-06','11:00:00',1.56),('8348','2013-02-06','11:05:00',1.25),('8348','2013-02-06','11:10:00',1.4),('8348','2013-02-06','11:15:00',1.3),('8348','2013-02-06','11:20:00',1.61),('8348','2013-02-06','11:25:00',2.37),('8348','2013-02-06','11:30:00',1.35),('8348','2013-02-06','11:35:00',1.29),('8348','2013-02-06','11:40:00',1.45),('8348','2013-02-06','11:45:00',1.47),('8348','2013-02-06','11:50:00',1.52),('8348','2013-02-06','11:55:00',1.43),('8348','2013-02-06','12:00:00',1.22),('8348','2013-02-06','12:15:00',1.04),('8348','2013-02-06','12:20:00',1),('8348','2013-02-06','13:30:00',1.16),('8348','2013-02-06','13:35:00',1.28),('8348','2013-02-06','13:40:00',1.02),('8348','2013-02-06','13:45:00',1.05),('8348','2013-02-06','13:50:00',1.65),('8348','2013-02-06','13:55:00',1.18),('8348','2013-02-06','14:00:00',1.27),('8348','2013-02-06','14:05:00',1.2),('8348','2013-02-06','14:30:00',1.49),('8348','2013-02-06','14:35:00',2.03),('8348','2013-02-06','14:40:00',1.19),('8348','2013-02-05','09:10:00',1.01),('8348','2013-02-05','09:15:00',1.04),('8348','2013-02-05','09:20:00',1.1),('8348','2013-02-05','09:25:00',1.19),('8348','2013-02-05','09:30:00',1.25),('8348','2013-02-05','09:35:00',1.32),('8348','2013-02-05','09:40:00',1.42),('8348','2013-02-05','09:45:00',1.52),('8348','2013-02-05','09:50:00',1.6),('8348','2013-02-05','09:55:00',1.66),('8348','2013-02-05','10:00:00',1.68),('8348','2013-02-05','10:05:00',1.72),('8348','2013-02-05','10:10:00',1.65),('8348','2013-02-05','10:15:00',1.67),('8348','2013-02-05','10:20:00',1.89),('8348','2013-02-05','10:25:00',1.94),('8348','2013-02-05','10:30:00',1.99),('8348','2013-02-05','10:35:00',2.02),('8348','2013-02-05','10:40:00',2.06),('8348','2013-02-05','10:45:00',2.08),('8348','2013-02-05','10:50:00',2.1),('8348','2013-02-05','10:55:00',2.14),('8348','2013-02-05','11:00:00',2.17),('8348','2013-02-05','11:05:00',2.18),('8348','2013-02-05','11:10:00',2.26),('8348','2013-02-05','11:15:00',2.26),('8348','2013-02-05','11:20:00',2.29),('8348','2013-02-05','11:25:00',2.33),('8348','2013-02-05','11:30:00',2.32),('8348','2013-02-05','11:35:00',2.2),('8348','2013-02-05','11:40:00',1.92),('8348','2013-02-05','11:45:00',2.02),('8348','2013-02-05','11:50:00',1.48),('8348','2013-02-05','11:55:00',1.26),('8348','2013-02-05','12:05:00',1.43),('8348','2013-02-05','12:10:00',1.31),('8348','2013-02-05','12:15:00',1.25),('8348','2013-02-05','12:20:00',1.1),('8348','2013-02-05','12:25:00',1.07),('8348','2013-02-05','12:30:00',1.04),('8348','2013-02-05','12:35:00',1.37),('8348','2013-02-05','12:40:00',1.73),('8348','2013-02-05','12:45:00',1.85),('8348','2013-02-05','12:50:00',1.74),('8348','2013-02-05','13:15:00',1.23),('8348','2013-02-05','13:20:00',1.25),('8348','2013-02-05','13:25:00',1.24),('8348','2013-02-05','13:30:00',1.18),('8348','2013-02-05','13:45:00',1.26),('8348','2013-02-05','13:50:00',1.28),('8348','2013-02-05','13:55:00',1.13),('8348','2013-02-05','14:00:00',1.16),('8348','2013-02-05','14:05:00',1.14),('8348','2013-02-05','14:15:00',1.05),('8348','2013-02-05','14:20:00',1.12),('8348','2013-02-05','14:25:00',1.58),('8348','2013-02-05','14:30:00',1.59),('8348','2013-02-05','14:35:00',1.36),('8348','2013-02-05','14:40:00',1.32),('8348','2013-02-04','09:05:00',1.01),('8348','2013-02-04','09:10:00',1.09),('8348','2013-02-04','09:15:00',1.14),('8348','2013-02-04','09:20:00',1.13),('8348','2013-02-04','09:25:00',1.2),('8348','2013-02-04','09:30:00',1.3),('8348','2013-02-04','09:35:00',1.33),('8348','2013-02-04','09:40:00',1.39),('8348','2013-02-04','09:45:00',1.28),('8348','2013-02-04','09:50:00',1.62),('8348','2013-02-04','09:55:00',1.74),('8348','2013-02-04','10:00:00',1.77),('8348','2013-02-04','10:05:00',1.86),('8348','2013-02-04','10:10:00',1.95),('8348','2013-02-04','10:15:00',2.03),('8348','2013-02-04','10:20:00',1.92),('8348','2013-02-04','10:25:00',2.03),('8348','2013-02-04','10:30:00',1.94),('8348','2013-02-04','10:35:00',1.85),('8348','2013-02-04','10:40:00',1.98),('8348','2013-02-04','10:45:00',2.18),('8348','2013-02-04','10:50:00',2.25),('8348','2013-02-04','10:55:00',2.26),('8348','2013-02-04','11:00:00',2.28),('8348','2013-02-04','11:05:00',2.35),('8348','2013-02-04','11:10:00',2.38),('8348','2013-02-04','11:15:00',2.41),('8348','2013-02-04','11:20:00',2.44),('8348','2013-02-04','11:25:00',2.46),('8348','2013-02-04','11:30:00',2.48),('8348','2013-02-04','11:35:00',2.51),('8348','2013-02-04','11:40:00',2.54),('8348','2013-02-04','11:45:00',2.56),('8348','2013-02-04','11:50:00',2.57),('8348','2013-02-04','11:55:00',2.58),('8348','2013-02-04','12:00:00',2.59),('8348','2013-02-04','12:05:00',2.62),('8348','2013-02-04','12:10:00',2.63),('8348','2013-02-04','12:15:00',2.63),('8348','2013-02-04','12:20:00',2.63),('8348','2013-02-04','12:25:00',2.63),('8348','2013-02-04','12:30:00',2.63),('8348','2013-02-04','12:35:00',2.63),('8348','2013-02-04','12:40:00',2.63),('8348','2013-02-04','12:45:00',2.64),('8348','2013-02-04','12:50:00',2.65),('8348','2013-02-04','12:55:00',2.65),('8348','2013-02-04','13:00:00',2.65),('8348','2013-02-04','13:05:00',2.64),('8348','2013-02-04','13:10:00',2.61),('8348','2013-02-04','13:15:00',2.61),('8348','2013-02-04','13:20:00',2.6),('8348','2013-02-04','13:25:00',2.59),('8348','2013-02-04','13:30:00',2.56),('8348','2013-02-04','13:35:00',2.54),('8348','2013-02-04','13:40:00',2.52),('8348','2013-02-04','13:45:00',2.49),('8348','2013-02-04','13:50:00',2.48),('8348','2013-02-04','13:55:00',2.45),('8348','2013-02-04','14:00:00',2.41),('8348','2013-02-04','14:05:00',2.38),('8348','2013-02-04','14:10:00',2.35),('8348','2013-02-04','14:15:00',2.31),('8348','2013-02-04','14:20:00',2.28),('8348','2013-02-04','14:25:00',2.24),('8348','2013-02-04','14:30:00',2.2),('8348','2013-02-04','14:35:00',2.15),('8348','2013-02-04','14:40:00',2.09),('8348','2013-02-04','14:45:00',2.05),('8348','2013-02-04','14:50:00',2.01),('8348','2013-02-04','14:55:00',1.95),('8348','2013-02-04','15:00:00',1.9),('8348','2013-02-04','15:05:00',1.85),('8348','2013-02-04','15:10:00',1.8),('8348','2013-02-04','15:15:00',1.74),('8348','2013-02-04','15:20:00',1.68),('8348','2013-02-04','15:25:00',1.61),('8348','2013-02-04','15:30:00',1.54),('8348','2013-02-04','15:35:00',1.48),('8348','2013-02-04','15:40:00',1.41),('8348','2013-02-04','15:45:00',1.34),('8348','2013-02-04','15:50:00',1.27),('8348','2013-02-04','15:55:00',1.2),('8348','2013-02-04','16:00:00',1.13),('8348','2013-02-04','16:05:00',1.06),('8348','2013-02-03','09:25:00',1.12),('8348','2013-02-03','09:40:00',1.08),('8348','2013-02-03','09:45:00',1.2),('8348','2013-02-03','09:50:00',1.34),('8348','2013-02-03','09:55:00',1.21),('8348','2013-02-03','10:00:00',1.51),('8348','2013-02-03','11:20:00',1.24),('8348','2013-02-03','11:55:00',1.3),('8348','2013-02-03','12:00:00',1.23),('8348','2013-02-03','12:05:00',1.18),('8348','2013-02-03','12:10:00',1.17),('8348','2013-02-02','10:30:00',1.03),('8348','2013-02-02','10:35:00',1.12),('8348','2013-02-02','10:40:00',1.23),('8348','2013-02-02','10:45:00',1.37),('8348','2013-02-02','10:50:00',1.09),('8348','2013-02-02','10:55:00',1.61),('8348','2013-02-02','11:00:00',1.64),('8348','2013-02-02','11:05:00',1.51),('8348','2013-02-02','11:10:00',1.61),('8348','2013-02-02','11:15:00',1.55),('8348','2013-02-02','11:20:00',1.57),('8348','2013-02-02','11:25:00',1.81),('8348','2013-02-02','11:30:00',1.68),('8348','2013-02-02','11:35:00',1.6),('8348','2013-02-02','11:40:00',1.53),('8348','2013-02-02','11:45:00',1.1),('8348','2013-02-02','11:55:00',1.04),('8348','2013-02-02','12:55:00',1.9),('8348','2013-02-02','13:00:00',1.68),('8348','2013-02-02','13:05:00',1.6),('8348','2013-02-02','13:10:00',1.87),('8348','2013-02-02','13:15:00',1.88),('8348','2013-02-02','13:20:00',1.68),('8348','2013-02-02','13:25:00',1.65),('8348','2013-02-02','13:30:00',1.26),('8348','2013-02-02','13:35:00',1.74),('8348','2013-02-02','13:40:00',2.2),('8348','2013-02-02','13:45:00',1.79),('8348','2013-02-02','13:50:00',1.71),('8348','2013-02-01','09:05:00',1.05),('8348','2013-02-01','09:10:00',1.13),('8348','2013-02-01','09:25:00',1.22),('8348','2013-02-01','09:30:00',1.29),('8348','2013-02-01','09:35:00',1.46),('8348','2013-02-01','09:40:00',1.67),('8348','2013-02-01','09:45:00',1.26),('8348','2013-02-01','09:50:00',1.02),('8348','2013-02-01','09:55:00',1.48),('8348','2013-02-01','10:00:00',1.16),('8348','2013-02-01','10:05:00',1.66),('8348','2013-02-01','10:15:00',1.14),('8348','2013-02-01','10:20:00',1.09),('8348','2013-02-01','10:50:00',2.22),('8348','2013-02-01','10:55:00',2.61),('8348','2013-02-01','11:00:00',2.47),('8348','2013-02-01','11:05:00',2.29),('8348','2013-02-01','11:10:00',1.67),('8348','2013-02-01','11:15:00',1.1),('8348','2013-02-01','11:20:00',1.71),('8348','2013-02-01','11:30:00',1.04),('8348','2013-02-01','11:35:00',1.64),('8348','2013-02-01','11:40:00',1.18),('8348','2013-02-01','11:45:00',1.57),('8348','2013-02-01','11:50:00',1.15),('8348','2013-02-01','12:00:00',1.1),('8348','2013-02-01','12:05:00',1.57),('8348','2013-02-01','12:10:00',1.43),('8348','2013-02-01','12:15:00',1.89),('8348','2013-02-01','12:20:00',2.83),('8348','2013-02-01','12:25:00',2.33),('8348','2013-02-01','12:30:00',2.11),('8348','2013-02-01','12:35:00',2.45),('8348','2013-02-01','12:40:00',2.84),('8348','2013-02-01','12:45:00',2.61),('8348','2013-02-01','12:50:00',2.81),('8348','2013-02-01','12:55:00',1.34),('8348','2013-02-01','13:00:00',1.7),('8348','2013-02-01','13:05:00',1.81),('8348','2013-02-01','13:10:00',2.69),('8348','2013-02-01','13:15:00',2.47),('8348','2013-02-01','13:20:00',2.57),('8348','2013-02-01','13:25:00',1.8),('8348','2013-02-01','13:30:00',2.21),('8348','2013-02-01','13:35:00',1.72),('8348','2013-02-01','13:40:00',2.1),('8348','2013-02-01','13:45:00',1.58),('8348','2013-02-01','13:50:00',1.06),('8348','2013-02-01','14:10:00',1.53),('8348','2013-02-01','14:15:00',2.35),('8348','2013-02-01','14:20:00',2.34),('8348','2013-02-01','14:25:00',2.1),('8348','2013-02-01','14:30:00',2.09),('8348','2013-02-01','14:35:00',2.06),('8348','2013-02-01','14:40:00',1.03),('8348','2013-02-01','15:10:00',1.4),('8348','2013-02-01','15:15:00',1.82),('8348','2013-02-01','15:20:00',1.7),('8348','2013-02-01','15:25:00',1.55),('8348','2013-02-01','15:50:00',1),('8348','2013-02-01','15:55:00',1.09),('8348','2014-03-21','07:35:00',1.1),('8348','2014-03-21','07:40:00',1.19),('8348','2014-03-21','07:45:00',1.32),('8348','2014-03-21','07:50:00',1.43),('8348','2014-03-21','07:55:00',1.59),('8348','2014-03-21','08:00:00',1.72),('8348','2014-03-21','08:05:00',1.79),('8348','2014-03-21','08:10:00',1.87),('8348','2014-03-21','08:15:00',1.98),('8348','2014-03-21','08:20:00',2.09),('8348','2014-03-21','08:25:00',2.23),('8348','2014-03-21','08:30:00',2.36),('8348','2014-03-21','08:35:00',2.48),('8348','2014-03-21','08:40:00',2.79),('8348','2014-03-21','08:45:00',3.01),('8348','2014-03-21','08:50:00',3.19),('8348','2014-03-21','08:55:00',3.35),('8348','2014-03-21','09:00:00',3.49),('8348','2014-03-21','09:05:00',3.61),('8348','2014-03-21','09:10:00',3.83),('8348','2014-03-21','09:15:00',3.92),('8348','2014-03-21','09:20:00',4.09),('8348','2014-03-21','09:25:00',3.99),('8348','2014-03-21','09:30:00',4.29),('8348','2014-03-21','09:35:00',4.31),('8348','2014-03-21','09:40:00',4.48),('8348','2014-03-21','09:45:00',4.58),('8348','2014-03-21','09:50:00',4.65),('8348','2014-03-21','09:55:00',4.72),('8348','2014-03-21','10:00:00',4.82),('8348','2014-03-21','10:05:00',4.87),('8348','2014-03-21','10:10:00',4.95),('8348','2014-03-21','10:15:00',5.06),('8348','2014-03-21','10:20:00',5.12),('8348','2014-03-21','10:25:00',5.27),('8348','2014-03-21','10:30:00',5.32),('8348','2014-03-21','10:35:00',5.39),('8348','2014-03-21','10:40:00',5.52),('8348','2014-03-21','10:45:00',5.47),('8348','2014-03-21','10:50:00',5.47),('8348','2014-03-21','10:55:00',5.54),('8348','2014-03-21','11:00:00',5.66),('8348','2014-03-21','11:05:00',5.67),('8348','2014-03-21','11:10:00',5.73),('8348','2014-03-21','11:15:00',5.74),('8348','2014-03-21','11:20:00',5.94),('8348','2014-03-21','11:25:00',6.12),('8348','2014-03-21','11:30:00',4.61),('8348','2014-03-21','11:35:00',3.51),('8348','2014-03-21','11:40:00',4.4),('8348','2014-03-21','11:45:00',5.19),('8348','2014-03-21','11:50:00',6.94),('8348','2014-03-21','11:55:00',6.94),('8348','2014-03-21','12:00:00',5.6),('8348','2014-03-21','12:05:00',4.02),('8348','2014-03-21','12:10:00',6.17),('8348','2014-03-21','12:15:00',6.51),('8348','2014-03-21','12:20:00',6.5),('8348','2014-03-21','12:25:00',6.56),('8348','2014-03-21','12:30:00',6.44),('8348','2014-03-21','12:35:00',6.45),('8348','2014-03-21','12:40:00',6.44),('8348','2014-03-21','12:45:00',6.5),('8348','2014-03-21','12:50:00',6.42),('8348','2014-03-21','12:55:00',6.36),('8348','2014-03-21','13:00:00',6.41),('8348','2014-03-21','13:05:00',6.48),('8348','2014-03-21','13:10:00',6.42),('8348','2014-03-21','13:15:00',6.46),('8348','2014-03-21','13:20:00',6.38),('8348','2014-03-21','13:25:00',6.34),('8348','2014-03-21','13:30:00',6.26),('8348','2014-03-21','13:35:00',6.31),('8348','2014-03-21','13:40:00',6.28),('8348','2014-03-21','13:45:00',6.22),('8348','2014-03-21','13:50:00',6.25),('8348','2014-03-21','13:55:00',6.18),('8348','2014-03-21','14:00:00',6.2),('8348','2014-03-21','14:05:00',6.17),('8348','2014-03-21','14:10:00',6.1),('8348','2014-03-21','14:15:00',6.02),('8348','2014-03-21','14:20:00',5.96),('8348','2014-03-21','14:25:00',5.88),('8348','2014-03-21','14:30:00',5.56),('8348','2014-03-21','14:35:00',5.47),('8348','2014-03-21','14:40:00',5.5),('8348','2014-03-21','14:45:00',5.41),('8348','2014-03-21','14:50:00',4.48),('8348','2014-03-21','14:55:00',2.39),('8348','2014-03-21','15:00:00',1.52),('8348','2014-03-21','15:05:00',3.03),('8348','2014-03-21','15:10:00',5.61),('8348','2014-03-21','15:15:00',5.79),('8348','2014-03-21','15:20:00',5.24),('8348','2014-03-21','15:25:00',5.31),('8348','2014-03-21','15:30:00',5.44),('8348','2014-03-21','15:35:00',4.99),('8348','2014-03-21','15:40:00',5.07),('8348','2014-03-21','15:45:00',4.93),('8348','2014-03-21','15:50:00',4.87),('8348','2014-03-21','15:55:00',4.76),('8348','2014-03-21','16:00:00',4.52),('8348','2014-03-21','16:05:00',4.15),('8348','2014-03-21','16:10:00',3.85),('8348','2014-03-21','16:15:00',3.61),('8348','2014-03-21','16:20:00',3.36),('8348','2014-03-21','16:25:00',3.08),('8348','2014-03-21','16:30:00',2.9),('8348','2014-03-21','16:35:00',2.7),('8348','2014-03-21','16:40:00',2.52),('8348','2014-03-21','16:45:00',2.38),('8348','2014-03-21','16:50:00',2.21),('8348','2014-03-21','16:55:00',2.04),('8348','2014-03-21','17:00:00',1.72),('8348','2014-03-21','17:05:00',1.61),('8348','2014-03-21','17:10:00',1.45),('8348','2014-03-21','17:15:00',1.23),('8348','2014-03-21','17:20:00',1.08),('8348','2013-01-31','09:25:00',1.01),('8348','2013-01-31','09:30:00',1.29),('8348','2013-01-31','09:35:00',1.24),('8348','2013-01-31','09:40:00',1.2),('8348','2013-01-31','09:45:00',1.36),('8348','2013-01-31','09:50:00',1.42),('8348','2013-01-31','09:55:00',1.54),('8348','2013-01-31','10:00:00',1.54),('8348','2013-01-31','10:05:00',1.59),('8348','2013-01-31','10:10:00',1.61),('8348','2013-01-31','10:15:00',1.66),('8348','2013-01-31','10:20:00',1.76),('8348','2013-01-31','10:25:00',1.76),('8348','2013-01-31','10:30:00',1.92),('8348','2013-01-31','10:35:00',2.06),('8348','2013-01-31','10:40:00',2.13),('8348','2013-01-31','10:45:00',2.22),('8348','2013-01-31','10:50:00',2.21),('8348','2013-01-31','10:55:00',1.54),('8348','2013-01-31','11:10:00',2.33),('8348','2013-01-31','11:15:00',2.65),('8348','2013-01-31','11:20:00',2.71),('8348','2013-01-31','11:25:00',2.46),('8348','2013-01-31','11:30:00',2.34),('8348','2013-01-31','11:35:00',2.35),('8348','2013-01-31','11:40:00',2.33),('8348','2013-01-31','11:45:00',2.34),('8348','2013-01-31','11:50:00',2.37),('8348','2013-01-31','11:55:00',2.37),('8348','2013-01-31','12:00:00',2.36),('8348','2013-01-31','12:05:00',2.43),('8348','2013-01-31','12:10:00',2.42),('8348','2013-01-31','12:15:00',2.29),('8348','2013-01-31','12:20:00',2.43),('8348','2013-01-31','12:25:00',2.42),('8348','2013-01-31','12:30:00',2.41),('8348','2013-01-31','12:35:00',2.42),('8348','2013-01-31','12:40:00',2.42),('8348','2013-01-31','12:45:00',2.4),('8348','2013-01-31','12:50:00',2.42),('8348','2013-01-31','12:55:00',2.42),('8348','2013-01-31','13:00:00',2.39),('8348','2013-01-31','13:05:00',2.4),('8348','2013-01-31','13:10:00',2.39),('8348','2013-01-31','13:15:00',2.32),('8348','2013-01-31','13:20:00',2.29),('8348','2013-01-31','13:25:00',2.3),('8348','2013-01-31','13:30:00',2.29),('8348','2013-01-31','13:35:00',2.24),('8348','2013-01-31','13:40:00',2.23),('8348','2013-01-31','13:45:00',2.21),('8348','2013-01-31','13:50:00',2.25),('8348','2013-01-31','13:55:00',2.22),('8348','2013-01-31','14:00:00',2.11),('8348','2013-01-31','14:05:00',2.07),('8348','2013-01-31','14:10:00',2.02),('8348','2013-01-31','14:15:00',2.03),('8348','2013-01-31','14:20:00',1.98),('8348','2013-01-31','14:25:00',1.97),('8348','2013-01-31','14:30:00',1.88),('8348','2013-01-31','14:35:00',1.84),('8348','2013-01-31','14:40:00',1.82),('8348','2013-01-31','14:45:00',1.76),('8348','2013-01-31','14:50:00',1.71),('8348','2013-01-31','14:55:00',1.61),('8348','2013-01-31','15:00:00',1.59),('8348','2013-01-31','15:05:00',1.58),('8348','2013-01-31','15:10:00',1.53),('8348','2013-01-31','15:15:00',1.51),('8348','2013-01-31','15:20:00',1.47),('8348','2013-01-31','15:25:00',1.36),('8348','2013-01-31','15:30:00',1.33),('8348','2013-01-31','15:35:00',1.31),('8348','2013-01-31','15:40:00',1.22),('8348','2013-01-31','15:45:00',1.12),('8348','2013-01-31','15:50:00',1.06),('8348','2013-01-30','10:05:00',1.05),('8348','2013-01-30','10:10:00',1.3),('8348','2013-01-30','10:15:00',1.05),('8348','2013-01-30','10:20:00',1.4),('8348','2013-01-30','10:25:00',1.51),('8348','2013-01-30','10:30:00',1.22),('8348','2013-01-30','10:35:00',1.17),('8348','2013-01-30','10:40:00',1.12),('8348','2013-01-30','10:45:00',1.63),('8348','2013-01-30','10:50:00',1.92),('8348','2013-01-30','10:55:00',1.94),('8348','2013-01-30','11:00:00',2.08),('8348','2013-01-30','11:05:00',2),('8348','2013-01-30','11:10:00',2.05),('8348','2013-01-30','11:15:00',2.07),('8348','2013-01-30','11:20:00',2.13),('8348','2013-01-30','11:25:00',2.21),('8348','2013-01-30','11:30:00',2.23),('8348','2013-01-30','11:35:00',2.15),('8348','2013-01-30','11:40:00',2.08),('8348','2013-01-30','11:45:00',2.49),('8348','2013-01-30','11:50:00',1.75),('8348','2013-01-30','11:55:00',1.87),('8348','2013-01-30','12:00:00',2.19),('8348','2013-01-30','12:05:00',1.65),('8348','2013-01-30','12:10:00',1.04),('8348','2013-01-30','12:15:00',1.7),('8348','2013-01-30','12:20:00',1.39),('8348','2013-01-30','12:40:00',1.04),('8348','2013-01-30','12:45:00',1.02),('8348','2013-01-30','12:50:00',2.43),('8348','2013-01-30','12:55:00',2.93),('8348','2013-01-30','13:00:00',2.75),('8348','2013-01-30','13:05:00',2.59),('8348','2013-01-30','13:10:00',2.68),('8348','2013-01-30','13:15:00',2.71),('8348','2013-01-30','13:20:00',2.65),('8348','2013-01-30','13:25:00',2.7),('8348','2013-01-30','13:30:00',2.59),('8348','2013-01-30','13:35:00',2.78),('8348','2013-01-30','13:40:00',2.19),('8348','2013-01-30','13:45:00',1.21),('8348','2013-01-30','13:50:00',2.59),('8348','2013-01-30','13:55:00',2.47),('8348','2013-01-30','14:00:00',2.23),('8348','2013-01-30','14:05:00',2.54),('8348','2013-01-30','14:10:00',2.48),('8348','2013-01-30','14:15:00',2.02),('8348','2013-01-30','14:20:00',1.67),('8348','2013-01-30','14:25:00',2.14),('8348','2013-01-30','14:30:00',2.07),('8348','2013-01-30','14:35:00',1.97),('8348','2013-01-30','14:40:00',1.43),('8348','2013-01-30','14:45:00',1.61),('8348','2013-01-29','09:25:00',1.05),('8348','2013-01-29','09:30:00',1.13),('8348','2013-01-29','09:35:00',1.19),('8348','2013-01-29','09:40:00',1.25),('8348','2013-01-29','09:45:00',1.35),('8348','2013-01-29','09:50:00',1.41),('8348','2013-01-29','09:55:00',1.48),('8348','2013-01-29','10:00:00',1.53),('8348','2013-01-29','10:05:00',1.6),('8348','2013-01-29','10:10:00',1.66),('8348','2013-01-29','10:15:00',1.72),('8348','2013-01-29','10:20:00',1.77),('8348','2013-01-29','10:25:00',1.83),('8348','2013-01-29','10:30:00',1.89),('8348','2013-01-29','10:35:00',1.93),('8348','2013-01-29','10:40:00',1.99),('8348','2013-01-29','10:45:00',2.02),('8348','2013-01-29','10:50:00',2.06),('8348','2013-01-29','10:55:00',2.09),('8348','2013-01-29','11:00:00',2.11),('8348','2013-01-29','11:05:00',2.14),('8348','2013-01-29','11:10:00',2.16),('8348','2013-01-29','11:15:00',2.21),('8348','2013-01-29','11:20:00',2.25),('8348','2013-01-29','11:25:00',2.23),('8348','2013-01-29','11:30:00',2.22),('8348','2013-01-29','11:35:00',2.34),('8348','2013-01-29','11:40:00',2.37),('8348','2013-01-29','11:45:00',2.38),('8348','2013-01-29','11:50:00',2.38),('8348','2013-01-29','11:55:00',2.39),('8348','2013-01-29','12:00:00',2.38),('8348','2013-01-29','12:05:00',2.39),('8348','2013-01-29','12:10:00',2.46),('8348','2013-01-29','12:15:00',2.43),('8348','2013-01-29','12:20:00',2.45),('8348','2013-01-29','12:25:00',2.46),('8348','2013-01-29','12:30:00',2.47),('8348','2013-01-29','12:35:00',2.42),('8348','2013-01-29','12:40:00',2.45),('8348','2013-01-29','12:45:00',2.39),('8348','2013-01-29','12:50:00',2.4),('8348','2013-01-29','12:55:00',2.45),('8348','2013-01-29','13:00:00',2.44),('8348','2013-01-29','13:05:00',2.42),('8348','2013-01-29','13:10:00',2.4),('8348','2013-01-29','13:15:00',2.37),('8348','2013-01-29','13:20:00',2.33),('8348','2013-01-29','13:25:00',2.37),('8348','2013-01-29','13:30:00',2.34),('8348','2013-01-29','13:35:00',2.3),('8348','2013-01-29','13:40:00',2.27),('8348','2013-01-29','13:45:00',2.27),('8348','2013-01-29','13:50:00',2.24),('8348','2013-01-29','13:55:00',2.21),('8348','2013-01-29','14:00:00',2.16),('8348','2013-01-29','14:05:00',2.09),('8348','2013-01-29','14:10:00',2.07),('8348','2013-01-29','14:15:00',1.76),('8348','2013-01-29','14:20:00',2.07),('8348','2013-01-29','14:25:00',2.02),('8348','2013-01-29','14:30:00',1.99),('8348','2013-01-29','14:35:00',1.93),('8348','2013-01-29','14:40:00',1.89),('8348','2013-01-29','14:45:00',1.85),('8348','2013-01-29','14:50:00',1.8),('8348','2013-01-29','14:55:00',1.74),('8348','2013-01-29','15:00:00',1.67),('8348','2013-01-29','15:05:00',1.63),('8348','2013-01-29','15:10:00',1.57),('8348','2013-01-29','15:15:00',1.51),('8348','2013-01-29','15:20:00',1.43),('8348','2013-01-29','15:25:00',1.36),('8348','2013-01-29','15:30:00',1.3),('8348','2013-01-29','15:35:00',1.23),('8348','2013-01-29','15:40:00',1.19),('8348','2013-01-29','15:45:00',1.13),('8348','2013-01-29','15:50:00',1.04),('8348','2013-01-29','15:55:00',1),('8348','2013-01-28','12:50:00',1.14),('8348','2013-01-28','12:55:00',1.08),('8348','2013-01-27','09:25:00',1.04),('8348','2013-01-27','09:30:00',1.11),('8348','2013-01-27','09:35:00',1.19),('8348','2013-01-27','09:40:00',1.25),('8348','2013-01-27','09:45:00',1.32),('8348','2013-01-27','09:50:00',1.38),('8348','2013-01-27','09:55:00',1.45),('8348','2013-01-27','10:00:00',1.5),('8348','2013-01-27','10:05:00',1.56),('8348','2013-01-27','10:10:00',1.6),('8348','2013-01-27','10:15:00',1.66),('8348','2013-01-27','10:20:00',1.7),('8348','2013-01-27','10:25:00',1.76),('8348','2013-01-27','10:30:00',1.8),('8348','2013-01-27','10:35:00',1.84),('8348','2013-01-27','10:40:00',1.88),('8348','2013-01-27','10:45:00',1.93),('8348','2013-01-27','10:50:00',1.97),('8348','2013-01-27','10:55:00',2.02),('8348','2013-01-27','11:00:00',2.05),('8348','2013-01-27','11:05:00',2.09),('8348','2013-01-27','11:10:00',2.12),('8348','2013-01-27','11:15:00',2.14),('8348','2013-01-27','11:20:00',2.18),('8348','2013-01-27','11:25:00',2.2),('8348','2013-01-27','11:30:00',2.22),('8348','2013-01-27','11:35:00',2.22),('8348','2013-01-27','11:40:00',2.26),('8348','2013-01-27','11:45:00',2.28),('8348','2013-01-27','11:50:00',2.29),('8348','2013-01-27','11:55:00',2.32),('8348','2013-01-27','12:00:00',2.33),('8348','2013-01-27','12:05:00',2.36),('8348','2013-01-27','12:10:00',2.38),('8348','2013-01-27','12:15:00',2.38),('8348','2013-01-27','12:20:00',2.38),('8348','2013-01-27','12:25:00',2.4),('8348','2013-01-27','12:30:00',2.39),('8348','2013-01-27','12:35:00',2.4),('8348','2013-01-27','12:40:00',2.4),('8348','2013-01-27','12:45:00',2.39),('8348','2013-01-27','12:50:00',2.37),('8348','2013-01-27','12:55:00',2.41),('8348','2013-01-27','13:00:00',2.41),('8348','2013-01-27','13:05:00',2.41),('8348','2013-01-27','13:10:00',2.39),('8348','2013-01-27','13:15:00',2.36),('8348','2013-01-27','13:20:00',2.32),('8348','2013-01-27','13:25:00',2.28),('8348','2013-01-27','13:30:00',2.24),('8348','2013-01-27','13:35:00',2.22),('8348','2013-01-27','13:40:00',2.16),('8348','2013-01-27','13:45:00',2.09),('8348','2013-01-27','13:50:00',2.09),('8348','2013-01-27','13:55:00',2.08),('8348','2013-01-27','14:00:00',2.06),('8348','2013-01-27','14:05:00',2.03),('8348','2013-01-27','14:10:00',2.02),('8348','2013-01-27','14:15:00',1.98),('8348','2013-01-27','14:20:00',1.92),('8348','2013-01-27','14:25:00',1.86),('8348','2013-01-27','14:30:00',1.81),('8348','2013-01-27','14:35:00',1.77),('8348','2013-01-27','14:40:00',1.73),('8348','2013-01-27','14:45:00',1.74),('8348','2013-01-27','14:50:00',1.7),('8348','2013-01-27','14:55:00',1.65),('8348','2013-01-27','15:00:00',1.59),('8348','2013-01-27','15:05:00',1.52),('8348','2013-01-27','15:10:00',1.43),('8348','2013-01-27','15:15:00',1.37),('8348','2013-01-27','15:20:00',1.32),('8348','2013-01-27','15:25:00',1.27),('8348','2013-01-27','15:30:00',1.22),('8348','2013-01-27','15:35:00',1.14),('8348','2013-01-27','15:40:00',1.09),('8348','2013-01-27','15:45:00',1.03),('8348','2013-01-26','10:20:00',1.11),('8348','2013-01-26','10:25:00',1.01),('8348','2013-01-25','09:20:00',1.06),('8348','2013-01-25','09:25:00',1.12),('8348','2013-01-25','09:30:00',1.23),('8348','2013-01-25','09:35:00',1.23),('8348','2013-01-25','09:40:00',1.16),('8348','2013-01-25','09:45:00',1.29),('8348','2013-01-25','09:50:00',1.6),('8348','2013-01-25','09:55:00',1.64),('8348','2013-01-25','10:00:00',1.66),('8348','2013-01-25','10:05:00',1.72),('8348','2013-01-25','10:10:00',1.76),('8348','2013-01-25','10:15:00',1.74),('8348','2013-01-25','10:20:00',1.77),('8348','2013-01-25','10:25:00',1.86),('8348','2013-01-25','10:30:00',1.84),('8348','2013-01-25','10:35:00',1.22),('8348','2013-01-25','10:40:00',2.09),('8348','2013-01-25','10:45:00',1.76),('8348','2013-01-25','10:50:00',1.44),('8348','2013-01-25','10:55:00',2.22),('8348','2013-01-25','11:00:00',1.28),('8348','2013-01-25','11:05:00',1.49),('8348','2013-01-25','11:10:00',2.18),('8348','2013-01-25','11:15:00',2.24),('8348','2013-01-25','11:20:00',2.25),('8348','2013-01-25','11:25:00',2.27),('8348','2013-01-25','11:30:00',2.3),('8348','2013-01-25','11:35:00',2.36),('8348','2013-01-25','11:40:00',2.36),('8348','2013-01-25','11:45:00',2.39),('8348','2013-01-25','11:50:00',2.43),('8348','2013-01-25','11:55:00',2.42),('8348','2013-01-25','12:00:00',2.41),('8348','2013-01-25','12:05:00',2.4),('8348','2013-01-25','12:10:00',2.44),('8348','2013-01-25','12:15:00',2.46),('8348','2013-01-25','12:20:00',2.48),('8348','2013-01-25','12:25:00',2.46),('8348','2013-01-25','12:30:00',2.44),('8348','2013-01-25','12:35:00',2.07),('8348','2013-01-25','12:40:00',2.26),('8348','2013-01-25','12:45:00',2.41),('8348','2013-01-25','12:50:00',2.37),('8348','2013-01-25','12:55:00',2.39),('8348','2013-01-25','13:00:00',2.38),('8348','2013-01-25','13:05:00',2.34),('8348','2013-01-25','13:10:00',2.33),('8348','2013-01-25','13:15:00',2.33),('8348','2013-01-25','13:20:00',2.36),('8348','2013-01-25','13:25:00',2.39),('8348','2013-01-25','13:30:00',2.46),('8348','2013-01-25','13:35:00',2.43),('8348','2013-01-25','13:40:00',2.39),('8348','2013-01-25','13:45:00',2.34),('8348','2013-01-25','13:50:00',2.26),('8348','2013-01-25','13:55:00',2.21),('8348','2013-01-25','14:00:00',2.15),('8348','2013-01-25','14:05:00',2.03),('8348','2013-01-25','14:10:00',1.94),('8348','2013-01-25','14:15:00',1.8),('8348','2013-01-25','14:20:00',1.73),('8348','2013-01-25','14:25:00',1.77),('8348','2013-01-25','14:30:00',1.69),('8348','2013-01-25','14:35:00',1.59),('8348','2013-01-25','14:40:00',1.58),('8348','2013-01-25','14:45:00',1.51),('8348','2013-01-25','14:50:00',1.48),('8348','2013-01-25','14:55:00',1.44),('8348','2013-01-25','15:00:00',1.32),('8348','2013-01-25','15:05:00',1.26),('8348','2013-01-25','15:10:00',1.23),('8348','2013-01-25','15:15:00',1.19),('8348','2013-01-25','15:20:00',1.19),('8348','2013-01-25','15:25:00',1.17),('8348','2013-01-25','15:30:00',1.18),('8348','2013-01-25','15:35:00',1.21),('8348','2013-01-25','15:40:00',1.17),('8348','2013-01-25','15:45:00',1.15),('8348','2013-01-25','15:50:00',1.14),('8348','2013-01-25','15:55:00',1.02),('8348','2013-01-24','09:45:00',1.09),('8348','2013-01-24','09:50:00',1.37),('8348','2013-01-24','09:55:00',1.5),('8348','2013-01-24','10:00:00',1.55),('8348','2013-01-24','10:05:00',1.57),('8348','2013-01-24','10:10:00',1.76),('8348','2013-01-24','10:15:00',1.76),('8348','2013-01-24','10:20:00',1.8),('8348','2013-01-24','10:25:00',1.85),('8348','2013-01-24','10:30:00',1.89),('8348','2013-01-24','10:35:00',1.92),('8348','2013-01-24','10:40:00',1.97),('8348','2013-01-24','10:45:00',2.02),('8348','2013-01-24','10:50:00',2.1),('8348','2013-01-24','10:55:00',1.88),('8348','2013-01-24','11:00:00',1.42),('8348','2013-01-24','14:00:00',1.06),('8348','2013-01-24','14:05:00',1.05),('8348','2013-01-24','14:10:00',1.02),('8348','2013-01-24','14:15:00',1.16),('8348','2013-01-24','14:20:00',1.74),('8348','2013-01-24','14:25:00',2.8),('8348','2013-01-24','14:30:00',2.43),('8348','2013-01-24','14:35:00',1.68),('8348','2013-01-24','14:40:00',1.28),('8348','2013-01-24','14:45:00',1.68),('8348','2013-01-24','14:50:00',1.79),('8348','2013-01-24','14:55:00',1.79),('8348','2013-01-24','15:00:00',1.28),('8348','2013-01-24','15:20:00',1.19),('8348','2013-01-24','15:25:00',1.18),('8348','2013-01-24','15:30:00',1.29),('8348','2013-01-24','15:35:00',1.06),('8348','2013-01-24','15:45:00',1.05),('8348','2013-01-24','15:50:00',1.04),('8348','2013-01-23','09:55:00',1.29),('8348','2013-01-23','10:30:00',2.03),('8348','2013-01-23','10:35:00',2.04),('8348','2013-01-23','10:40:00',1.28),('8348','2013-01-23','10:45:00',1.21),('8348','2013-01-23','10:50:00',1.72),('8348','2013-01-23','10:55:00',1.31),('8348','2013-01-22','09:00:00',1.1),('8348','2013-01-22','09:30:00',1.15),('8348','2013-01-22','09:35:00',1.38),('8348','2013-01-22','09:40:00',1.2),('8348','2013-01-22','09:45:00',1.85),('8348','2013-01-22','09:50:00',1.05),('8348','2013-01-22','09:55:00',1.25),('8348','2013-01-22','10:05:00',1.57),('8348','2013-01-22','10:10:00',1.86),('8348','2013-01-22','10:15:00',1.49),('8348','2013-01-22','10:20:00',1.78),('8348','2013-01-22','10:25:00',1.9),('8348','2013-01-22','10:30:00',1.98),('8348','2013-01-22','10:35:00',2.18),('8348','2013-01-22','10:40:00',2.48),('8348','2013-01-22','10:45:00',2.01),('8348','2013-01-22','10:50:00',1.65),('8348','2013-01-22','10:55:00',1.07),('8348','2013-01-22','11:15:00',1.4),('8348','2013-01-22','11:20:00',1.46),('8348','2013-01-22','11:45:00',1.44),('8348','2013-01-22','11:50:00',1.65),('8348','2013-01-22','12:10:00',2.4),('8348','2013-01-22','12:15:00',2.09),('8348','2013-01-22','12:20:00',1.42),('8348','2013-01-22','12:25:00',2.19),('8348','2013-01-22','12:35:00',1.14),('8348','2013-01-22','12:40:00',2.69),('8348','2013-01-22','12:50:00',1.15),('8348','2013-01-22','13:00:00',2.42),('8348','2013-01-22','13:05:00',2.13),('8348','2013-01-22','13:10:00',1.81),('8348','2013-01-22','13:15:00',1.27),('8348','2013-01-22','13:20:00',1.91),('8348','2013-01-22','13:40:00',1.15),('8348','2013-01-22','13:50:00',1.19),('8348','2013-01-22','14:10:00',1.25),('8348','2013-01-22','14:15:00',1.31),('8348','2013-01-22','14:20:00',1.01),('8348','2013-01-22','14:25:00',1.68),('8348','2013-01-22','14:35:00',1.19),('8348','2013-01-22','14:40:00',1.14),('8348','2013-01-22','14:45:00',1.45),('8348','2014-03-20','07:25:00',1.07),('8348','2014-03-20','07:30:00',1.09),('8348','2014-03-20','07:35:00',1.25),('8348','2014-03-20','07:40:00',1.37),('8348','2014-03-20','07:45:00',1.48),('8348','2014-03-20','07:50:00',1.56),('8348','2014-03-20','07:55:00',1.69),('8348','2014-03-20','08:00:00',1.86),('8348','2014-03-20','08:05:00',1.94),('8348','2014-03-20','08:10:00',2.02),('8348','2014-03-20','08:15:00',2.07),('8348','2014-03-20','08:20:00',2.14),('8348','2014-03-20','08:25:00',2.26),('8348','2014-03-20','08:30:00',2.38),('8348','2014-03-20','08:35:00',2.5),('8348','2014-03-20','08:40:00',2.78),('8348','2014-03-20','08:45:00',3.14),('8348','2014-03-20','08:50:00',3.26),('8348','2014-03-20','08:55:00',3.38),('8348','2014-03-20','09:00:00',3.45),('8348','2014-03-20','09:05:00',3.64),('8348','2014-03-20','09:10:00',3.83),('8348','2014-03-20','09:15:00',3.92),('8348','2014-03-20','09:20:00',4.06),('8348','2014-03-20','09:25:00',4.12),('8348','2014-03-20','09:30:00',4.24),('8348','2014-03-20','09:35:00',4.36),('8348','2014-03-20','09:40:00',4.44),('8348','2014-03-20','09:45:00',4.49),('8348','2014-03-20','09:50:00',4.49),('8348','2014-03-20','09:55:00',4.65),('8348','2014-03-20','10:00:00',4.86),('8348','2014-03-20','10:05:00',5.04),('8348','2014-03-20','10:10:00',5.11),('8348','2014-03-20','10:15:00',5.09),('8348','2014-03-20','10:20:00',5.12),('8348','2014-03-20','10:25:00',5.2),('8348','2014-03-20','10:30:00',5.3),('8348','2014-03-20','10:35:00',5.16),('8348','2014-03-20','10:40:00',5.1),('8348','2014-03-20','10:45:00',5.15),('8348','2014-03-20','10:50:00',5.55),('8348','2014-03-20','10:55:00',5.85),('8348','2014-03-20','11:00:00',5.89),('8348','2014-03-20','11:05:00',5.89),('8348','2014-03-20','11:10:00',5.85),('8348','2014-03-20','11:15:00',5.58),('8348','2014-03-20','11:20:00',5.81),('8348','2014-03-20','11:25:00',5.9),('8348','2014-03-20','11:30:00',6.04),('8348','2014-03-20','11:35:00',6.24),('8348','2014-03-20','11:40:00',6.15),('8348','2014-03-20','11:45:00',6.2),('8348','2014-03-20','11:50:00',6.12),('8348','2014-03-20','11:55:00',5.96),('8348','2014-03-20','12:00:00',5.5),('8348','2014-03-20','12:05:00',5.99),('8348','2014-03-20','12:10:00',6.33),('8348','2014-03-20','12:15:00',6.45),('8348','2014-03-20','12:20:00',6.25),('8348','2014-03-20','12:25:00',5.94),('8348','2014-03-20','12:30:00',6.18),('8348','2014-03-20','12:35:00',6.28),('8348','2014-03-20','12:40:00',6.25),('8348','2014-03-20','12:45:00',6.38),('8348','2014-03-20','12:50:00',6.35),('8348','2014-03-20','12:55:00',6.34),('8348','2014-03-20','13:00:00',6.33),('8348','2014-03-20','13:05:00',6.28),('8348','2014-03-20','13:10:00',6.1),('8348','2014-03-20','13:15:00',6.15),('8348','2014-03-20','13:20:00',6.17),('8348','2014-03-20','13:25:00',5.94),('8348','2014-03-20','13:30:00',6.05),('8348','2014-03-20','13:35:00',5.93),('8348','2014-03-20','13:40:00',5.69),('8348','2014-03-20','13:45:00',5.46),('8348','2014-03-20','13:50:00',5.25),('8348','2014-03-20','13:55:00',4.97),('8348','2014-03-20','14:00:00',5.02),('8348','2014-03-20','14:05:00',5.39),('8348','2014-03-20','14:10:00',5.26),('8348','2014-03-20','14:15:00',5.06),('8348','2014-03-20','14:20:00',4.97),('8348','2014-03-20','14:25:00',5.08),('8348','2014-03-20','14:30:00',4.36),('8348','2014-03-20','14:35:00',3.93),('8348','2014-03-20','14:40:00',4.53),('8348','2014-03-20','14:45:00',4.44),('8348','2014-03-20','14:50:00',4.13),('8348','2014-03-20','14:55:00',4.1),('8348','2014-03-20','15:00:00',3.77),('8348','2014-03-20','15:05:00',3.64),('8348','2014-03-20','15:10:00',3.83),('8348','2014-03-20','15:15:00',3.67),('8348','2014-03-20','15:20:00',3.91),('8348','2014-03-20','15:25:00',3.58),('8348','2014-03-20','15:30:00',3.48),('8348','2014-03-20','15:35:00',3.35),('8348','2014-03-20','15:40:00',3.05),('8348','2014-03-20','15:45:00',3.1),('8348','2014-03-20','15:50:00',2.74),('8348','2014-03-20','15:55:00',2.48),('8348','2014-03-20','16:00:00',2.16),('8348','2014-03-20','16:05:00',1.91),('8348','2014-03-20','16:10:00',1.93),('8348','2014-03-20','16:15:00',1.9),('8348','2014-03-20','16:20:00',1.97),('8348','2014-03-20','16:25:00',2.05),('8348','2014-03-20','16:30:00',1.92),('8348','2014-03-20','16:35:00',1.78),('8348','2014-03-20','16:40:00',1.65),('8348','2014-03-20','16:45:00',1.22),('8348','2013-01-21','11:15:00',1.07),('8348','2013-01-21','11:50:00',1.3),('8348','2013-01-21','11:55:00',2.63),('8348','2013-01-21','12:00:00',2.29),('8348','2013-01-21','12:05:00',2.29),('8348','2013-01-21','12:10:00',2.49),('8348','2013-01-21','12:15:00',1.51),('8348','2013-01-21','12:25:00',1.17),('8348','2013-01-21','12:50:00',1),('8348','2013-01-21','13:05:00',1.81),('8348','2013-01-21','13:10:00',1.34),('8348','2013-01-21','13:30:00',2.35),('8348','2013-01-21','13:35:00',2.67),('8348','2013-01-21','13:40:00',2.09),('8348','2013-01-21','13:50:00',1.39),('8348','2013-01-21','13:55:00',2.34),('8348','2013-01-21','14:00:00',2.41),('8348','2013-01-21','14:05:00',2.54),('8348','2013-01-21','14:10:00',2.08),('8348','2013-01-21','14:15:00',1.51),('8348','2013-01-21','14:20:00',2.05),('8348','2013-01-21','14:25:00',2.23),('8348','2013-01-21','14:30:00',1.12),('8348','2013-01-20','11:05:00',1.03),('8348','2013-01-20','11:10:00',1.09),('8348','2013-01-20','11:15:00',1.46),('8348','2013-01-20','11:20:00',1.17),('8348','2013-01-20','11:25:00',1.52),('8348','2013-01-20','11:30:00',1.98),('8348','2013-01-20','11:35:00',1.58),('8348','2013-01-19','09:55:00',1.25),('8348','2013-01-19','10:00:00',1.16),('8348','2013-01-19','10:45:00',1.15),('8348','2013-01-19','10:50:00',1.16),('8348','2013-01-19','11:20:00',1.03),('8348','2013-01-19','11:25:00',1.03),('8348','2013-01-18','10:15:00',1.85),('8348','2013-01-18','10:20:00',1.76),('8348','2013-01-18','10:25:00',1.25),('8348','2013-01-18','10:30:00',1.09),('8348','2013-01-18','11:35:00',1.08),('8348','2013-01-18','11:40:00',1.01),('8348','2013-01-18','12:35:00',1.14),('8348','2013-01-18','12:40:00',1.24),('8348','2013-01-18','12:45:00',1.34),('8348','2013-01-18','12:50:00',1.8),('8348','2013-01-18','12:55:00',1.82),('8348','2013-01-18','13:00:00',2.19),('8348','2013-01-18','13:05:00',1.97),('8348','2013-01-18','13:10:00',1.84),('8348','2013-01-18','13:15:00',2.13),('8348','2013-01-18','13:20:00',1.65),('8348','2013-01-18','13:25:00',1.38),('8348','2013-01-18','13:30:00',1.27),('8348','2013-01-18','13:35:00',1.25),('8348','2013-01-18','13:40:00',1.29),('8348','2013-01-18','13:45:00',2.63),('8348','2013-01-18','13:50:00',2.61),('8348','2013-01-18','13:55:00',2.39),('8348','2013-01-18','14:00:00',1.6),('8348','2013-01-18','14:05:00',1.92),('8348','2013-01-18','14:10:00',1.74),('8348','2013-01-18','14:15:00',1.87),('8348','2013-01-18','14:20:00',1.63),('8348','2013-01-18','14:25:00',1.32),('8348','2013-01-18','14:30:00',1.03),('8348','2013-01-17','09:50:00',1.05),('8348','2013-01-17','10:15:00',1.12),('8348','2013-01-17','10:20:00',1.07),('8348','2013-01-17','10:25:00',1.34),('8348','2013-01-17','10:30:00',1.39),('8348','2013-01-17','10:35:00',1.3),('8348','2013-01-17','10:40:00',1.28),('8348','2013-01-17','10:45:00',1.35),('8348','2013-01-17','10:50:00',1.28),('8348','2013-01-17','10:55:00',1.46),('8348','2013-01-17','11:00:00',1.32),('8348','2013-01-17','11:05:00',1.35),('8348','2013-01-17','11:10:00',1.56),('8348','2013-01-17','11:15:00',1.5),('8348','2013-01-17','11:20:00',1.42),('8348','2013-01-17','11:25:00',1.22),('8348','2013-01-17','11:30:00',1.09),('8348','2013-01-17','11:35:00',1.21),('8348','2013-01-17','11:40:00',1.31),('8348','2013-01-17','11:45:00',1.18),('8348','2013-01-17','11:50:00',1.27),('8348','2013-01-17','11:55:00',1.35),('8348','2013-01-17','12:00:00',1.5),('8348','2013-01-17','12:05:00',1.45),('8348','2013-01-17','12:10:00',1.47),('8348','2013-01-17','12:15:00',1.61),('8348','2013-01-17','12:20:00',1.55),('8348','2013-01-17','12:25:00',1.44),('8348','2013-01-17','12:30:00',1.21),('8348','2013-01-17','12:35:00',1.42),('8348','2013-01-17','12:40:00',1.58),('8348','2013-01-17','12:45:00',1.24),('8348','2013-01-17','13:00:00',1.31),('8348','2013-01-17','13:05:00',1.3),('8348','2013-01-17','13:15:00',1.27),('8348','2013-01-17','13:20:00',1.26),('8348','2013-01-17','13:25:00',1.1),('8348','2013-01-17','13:30:00',1.06),('8348','2013-01-17','13:35:00',1.48),('8348','2013-01-17','13:40:00',1.54),('8348','2013-01-17','13:45:00',1.95),('8348','2013-01-17','13:50:00',1.66),('8348','2013-01-17','14:00:00',1.32),('8348','2013-01-17','14:30:00',1.14),('8348','2013-01-17','14:35:00',1.55),('8348','2013-01-16','09:30:00',1.03),('8348','2013-01-16','09:35:00',1.13),('8348','2013-01-16','09:40:00',1.2),('8348','2013-01-16','10:35:00',1.33),('8348','2013-01-16','10:40:00',1.67),('8348','2013-01-16','10:45:00',1.58),('8348','2013-01-16','10:55:00',1.61),('8348','2013-01-16','11:25:00',1.29),('8348','2013-01-16','12:00:00',1.47),('8348','2013-01-16','12:05:00',1.17),('8348','2013-01-16','12:10:00',1.57),('8348','2013-01-16','12:15:00',2.92),('8348','2013-01-16','12:20:00',2.58),('8348','2013-01-16','13:05:00',1.67),('8348','2013-01-16','13:10:00',2.89),('8348','2013-01-16','13:15:00',3.22),('8348','2013-01-16','13:20:00',2.42),('8348','2013-01-16','13:25:00',1.38),('8348','2013-01-16','13:55:00',2.4),('8348','2013-01-16','14:00:00',1.51),('8348','2013-01-16','14:05:00',1.12),('8348','2013-01-15','10:50:00',1.12),('8348','2013-01-15','10:55:00',1.25),('8348','2013-01-15','11:00:00',1.25),('8348','2013-01-15','11:05:00',1.3),('8348','2013-01-15','11:10:00',1.34),('8348','2013-01-15','11:15:00',1.26),('8348','2013-01-15','11:20:00',1.29),('8348','2013-01-15','11:25:00',1.29),('8348','2013-01-15','11:30:00',1.23),('8348','2013-01-15','11:35:00',1.16),('8348','2013-01-15','11:40:00',1.04),('8348','2013-01-15','11:55:00',1.01),('8348','2013-01-15','12:20:00',1.12),('8348','2013-01-15','12:25:00',1.1),('8348','2013-01-15','12:30:00',1.06),('8348','2013-01-15','12:35:00',1.07),('8348','2013-01-15','12:40:00',1.18),('8348','2013-01-15','12:45:00',1.2),('8348','2013-01-15','12:50:00',1.24),('8348','2013-01-15','12:55:00',1.04),('8348','2013-01-15','13:30:00',1.01),('8348','2013-01-15','13:35:00',1.05),('8348','2013-01-15','13:40:00',1.19),('8348','2013-01-15','13:45:00',1.07),('8348','2013-01-15','13:50:00',1.03),('8348','2013-01-15','13:55:00',1.16),('8348','2013-01-15','14:00:00',1.91),('8348','2013-01-15','14:05:00',1.63),('8348','2013-01-15','14:10:00',1.72),('8348','2013-01-15','14:15:00',2.35),('8348','2013-01-15','14:20:00',2.22),('8348','2013-01-15','14:25:00',1.67),('8348','2013-01-15','14:30:00',1.9),('8348','2013-01-15','14:35:00',1.62),('8348','2013-01-15','14:40:00',1.11),('8348','2013-01-15','14:45:00',1.58),('8348','2013-01-15','14:50:00',1.51),('8348','2013-01-15','14:55:00',1.61),('8348','2013-01-15','15:00:00',1.5),('8348','2013-01-15','15:05:00',1.4),('8348','2013-01-15','15:10:00',1.35),('8348','2013-01-15','15:15:00',1.17),('8348','2013-01-15','15:20:00',1.02),('8348','2013-01-14','12:50:00',1.03),('8348','2013-01-14','12:55:00',1.02),('8348','2013-01-14','13:00:00',1.07),('8348','2013-01-14','13:05:00',1.04),('8348','2013-01-14','15:15:00',1.2),('8348','2013-01-13','09:15:00',1.13),('8348','2013-01-13','09:20:00',1.22),('8348','2013-01-13','09:25:00',1.18),('8348','2013-01-13','09:30:00',1.24),('8348','2013-01-13','09:35:00',1.28),('8348','2013-01-13','09:50:00',1.1),('8348','2013-01-13','09:55:00',1.23),('8348','2013-01-13','10:00:00',1.28),('8348','2013-01-13','10:05:00',1.44),('8348','2013-01-13','10:10:00',1.04),('8348','2013-01-13','10:20:00',1.15),('8348','2013-01-13','10:25:00',1.1),('8348','2013-01-13','10:30:00',1.57),('8348','2013-01-12','09:35:00',1.01),('8348','2013-01-12','09:40:00',1.07),('8348','2013-01-12','09:45:00',1.13),('8348','2013-01-12','09:50:00',1.18),('8348','2013-01-12','09:55:00',1.24),('8348','2013-01-12','10:00:00',1.28),('8348','2013-01-12','10:05:00',1.34),('8348','2013-01-12','10:10:00',1.39),('8348','2013-01-12','10:15:00',1.45),('8348','2013-01-12','10:20:00',1.47),('8348','2013-01-12','10:25:00',1.51),('8348','2013-01-12','10:30:00',1.55),('8348','2013-01-12','10:35:00',1.59),('8348','2013-01-12','10:40:00',1.64),('8348','2013-01-12','10:45:00',1.69),('8348','2013-01-12','10:50:00',1.71),('8348','2013-01-12','10:55:00',1.77),('8348','2013-01-12','11:00:00',1.81),('8348','2013-01-12','11:05:00',1.81),('8348','2013-01-12','11:10:00',1.84),('8348','2013-01-12','11:15:00',1.87),('8348','2013-01-12','11:20:00',1.9),('8348','2013-01-12','11:25:00',1.92),('8348','2013-01-12','11:30:00',1.92),('8348','2013-01-12','11:35:00',1.95),('8348','2013-01-12','11:40:00',1.97),('8348','2013-01-12','11:45:00',1.99),('8348','2013-01-12','11:50:00',2.01),('8348','2013-01-12','11:55:00',2.03),('8348','2013-01-12','12:00:00',2.03),('8348','2013-01-12','12:05:00',2.03),('8348','2013-01-12','12:10:00',2),('8348','2013-01-12','12:15:00',2.01),('8348','2013-01-12','12:20:00',2.02),('8348','2013-01-12','12:25:00',2.02),('8348','2013-01-12','12:30:00',1.99),('8348','2013-01-12','12:35:00',2.01),('8348','2013-01-12','12:40:00',1.71),('8348','2013-01-12','12:45:00',1.27),('8348','2013-01-12','12:50:00',1.96),('8348','2013-01-12','13:00:00',1.73),('8348','2013-01-12','13:05:00',2.03),('8348','2013-01-12','13:10:00',1.6),('8348','2013-01-12','13:15:00',1.16),('8348','2013-01-12','13:25:00',1.32),('8348','2013-01-12','13:30:00',1.6),('8348','2013-01-12','13:35:00',1.52),('8348','2013-01-12','13:50:00',1.45),('8348','2013-01-12','13:55:00',2.2),('8348','2013-01-12','14:00:00',1.49),('8348','2013-01-12','14:05:00',1.44),('8348','2013-01-12','14:10:00',2.03),('8348','2013-01-12','14:15:00',1.63),('8348','2013-01-12','14:20:00',1.59),('8348','2013-01-12','14:25:00',1.59),('8348','2013-01-12','14:30:00',1.55),('8348','2013-01-12','14:35:00',1.52),('8348','2013-01-12','14:40:00',1.47),('8348','2013-01-12','14:45:00',1.41),('8348','2013-01-12','14:50:00',1.35),('8348','2013-01-12','14:55:00',1.28),('8348','2013-01-12','15:00:00',1.22),('8348','2013-01-12','15:05:00',1.11),('8348','2013-01-12','15:15:00',1),('8348','2014-03-19','08:25:00',1.04),('8348','2014-03-19','08:30:00',1.14),('8348','2014-03-19','08:35:00',1.27),('8348','2014-03-19','08:40:00',1.44),('8348','2014-03-19','08:45:00',1.59),('8348','2014-03-19','08:50:00',1.68),('8348','2014-03-19','08:55:00',1.76),('8348','2014-03-19','09:00:00',1.82),('8348','2014-03-19','09:05:00',2.09),('8348','2014-03-19','09:10:00',2.39),('8348','2014-03-19','09:15:00',2.64),('8348','2014-03-19','09:20:00',2.84),('8348','2014-03-19','09:25:00',3.61),('8348','2014-03-19','09:30:00',5.51),('8348','2014-03-19','09:35:00',5.24),('8348','2014-03-19','09:40:00',5.21),('8348','2014-03-19','09:45:00',4.26),('8348','2014-03-19','09:50:00',4.31),('8348','2014-03-19','09:55:00',3.91),('8348','2014-03-19','10:00:00',2.52),('8348','2014-03-19','10:05:00',1.91),('8348','2014-03-19','10:10:00',1.67),('8348','2014-03-19','10:15:00',1.53),('8348','2014-03-19','10:20:00',1.7),('8348','2014-03-19','10:25:00',1.82),('8348','2014-03-19','10:30:00',2.2),('8348','2014-03-19','10:35:00',3.38),('8348','2014-03-19','10:40:00',3.95),('8348','2014-03-19','10:45:00',2.98),('8348','2014-03-19','10:50:00',3.57),('8348','2014-03-19','10:55:00',3.78),('8348','2014-03-19','11:00:00',5.53),('8348','2014-03-19','11:05:00',4.9),('8348','2014-03-19','11:10:00',3),('8348','2014-03-19','11:15:00',2.86),('8348','2014-03-19','11:20:00',2.93),('8348','2014-03-19','11:25:00',2.95),('8348','2014-03-19','11:30:00',3.02),('8348','2014-03-19','11:35:00',3.65),('8348','2014-03-19','11:40:00',2.94),('8348','2014-03-19','11:45:00',2.84),('8348','2014-03-19','11:50:00',4.46),('8348','2014-03-19','11:55:00',5.13),('8348','2014-03-19','12:00:00',7.22),('8348','2014-03-19','12:05:00',7.28),('8348','2014-03-19','12:10:00',7.15),('8348','2014-03-19','12:15:00',7.35),('8348','2014-03-19','12:20:00',7.24),('8348','2014-03-19','12:25:00',4.1),('8348','2014-03-19','12:30:00',3.44),('8348','2014-03-19','12:35:00',5.95),('8348','2014-03-19','12:40:00',6.91),('8348','2014-03-19','12:45:00',4.52),('8348','2014-03-19','12:50:00',4.14),('8348','2014-03-19','12:55:00',7.08),('8348','2014-03-19','13:00:00',6.6),('8348','2014-03-19','13:05:00',6.22),('8348','2014-03-19','13:10:00',6.53),('8348','2014-03-19','13:15:00',6.37),('8348','2014-03-19','13:20:00',4.79),('8348','2014-03-19','13:25:00',5.47),('8348','2014-03-19','13:30:00',6.28),('8348','2014-03-19','13:35:00',6.31),('8348','2014-03-19','13:40:00',6.2),('8348','2014-03-19','13:45:00',6.2),('8348','2014-03-19','13:50:00',5.99),('8348','2014-03-19','13:55:00',6.11),('8348','2014-03-19','14:00:00',6.1),('8348','2014-03-19','14:05:00',6.04),('8348','2014-03-19','14:10:00',5.8),('8348','2014-03-19','14:15:00',5.7),('8348','2014-03-19','14:20:00',5.7),('8348','2014-03-19','14:25:00',5.7),('8348','2014-03-19','14:30:00',5.5),('8348','2014-03-19','14:35:00',5.6),('8348','2014-03-19','14:40:00',5.46),('8348','2014-03-19','14:45:00',5.4),('8348','2014-03-19','14:50:00',5.33),('8348','2014-03-19','14:55:00',5.16),('8348','2014-03-19','15:00:00',5.04),('8348','2014-03-19','15:05:00',4.94),('8348','2014-03-19','15:10:00',4.87),('8348','2014-03-19','15:15:00',4.9),('8348','2014-03-19','15:20:00',4.69),('8348','2014-03-19','15:25:00',4.63),('8348','2014-03-19','15:30:00',4.48),('8348','2014-03-19','15:35:00',4.23),('8348','2014-03-19','15:40:00',4.24),('8348','2014-03-19','15:45:00',4.12),('8348','2014-03-19','15:50:00',3.96),('8348','2014-03-19','15:55:00',3.84),('8348','2014-03-19','16:00:00',3.66),('8348','2014-03-19','16:05:00',3.52),('8348','2014-03-19','16:10:00',3.42),('8348','2014-03-19','16:15:00',3.24),('8348','2014-03-19','16:20:00',3.05),('8348','2014-03-19','16:25:00',2.83),('8348','2014-03-19','16:30:00',2.7),('8348','2014-03-19','16:35:00',2.41),('8348','2014-03-19','16:40:00',2.26),('8348','2014-03-19','16:45:00',2.16),('8348','2014-03-19','16:50:00',1.82),('8348','2014-03-19','16:55:00',1.71),('8348','2014-03-19','17:00:00',1.34),('8348','2014-03-19','17:05:00',1.14),('8348','2014-03-19','17:10:00',1),('8348','2014-03-19','17:15:00',1.09),('8348','2013-01-11','10:05:00',1.25),('8348','2013-01-11','10:10:00',1.06),('8348','2013-01-11','10:15:00',1.55),('8348','2013-01-11','10:20:00',1.16),('8348','2013-01-11','10:25:00',1.58),('8348','2013-01-11','10:30:00',1.51),('8348','2013-01-11','10:35:00',1.57),('8348','2013-01-11','10:40:00',1.61),('8348','2013-01-11','10:45:00',1.66),('8348','2013-01-11','10:50:00',1.69),('8348','2013-01-11','10:55:00',1.73),('8348','2013-01-11','11:00:00',1.75),('8348','2013-01-11','11:05:00',1.78),('8348','2013-01-11','11:10:00',1.82),('8348','2013-01-11','11:15:00',1.83),('8348','2013-01-11','11:20:00',1.82),('8348','2013-01-11','11:25:00',1.23),('8348','2013-01-11','11:30:00',1.02),('8348','2013-01-11','11:35:00',1.2),('8348','2013-01-11','11:40:00',1.14),('8348','2013-01-11','11:45:00',1.25),('8348','2013-01-11','11:50:00',1.21),('8348','2013-01-11','11:55:00',1.09),('8348','2013-01-11','12:55:00',1.32),('8348','2013-01-11','13:00:00',1.17),('8348','2013-01-11','13:10:00',1.61),('8348','2013-01-11','13:35:00',1.98),('8348','2013-01-11','13:40:00',1.32),('8348','2013-01-11','13:45:00',1.82),('8348','2013-01-11','14:20:00',1.17),('8348','2013-01-11','14:25:00',1.02),('8348','2013-01-11','14:45:00',1.24),('8348','2013-01-11','14:50:00',1.47),('8348','2013-01-11','14:55:00',1.31),('8348','2013-01-11','15:00:00',1.4),('8348','2013-01-11','15:05:00',1.25),('8348','2013-01-10','11:55:00',1.05),('8348','2013-01-10','12:00:00',1.09),('8348','2013-01-10','12:05:00',1.06),('8348','2013-01-09','10:50:00',1.04),('8348','2013-01-09','10:55:00',1.1),('8348','2013-01-09','11:10:00',1.44),('8348','2013-01-09','11:15:00',1.71),('8348','2013-01-09','11:20:00',1.19),('8348','2013-01-09','11:25:00',1.04),('8348','2013-01-09','11:30:00',1.01),('8348','2013-01-09','11:35:00',1.08),('8348','2013-01-09','11:40:00',1.01),('8348','2013-01-09','11:50:00',1.05),('8348','2013-01-09','11:55:00',1.25),('8348','2013-01-09','12:00:00',1.01),('8348','2013-01-09','12:05:00',1.02),('8348','2013-01-09','12:10:00',1.02),('8348','2013-01-09','12:15:00',1.01),('8348','2013-01-09','12:20:00',1.02),('8348','2013-01-09','12:55:00',1.05),('8348','2013-01-09','13:00:00',1.07),('8348','2013-01-09','13:05:00',1.08),('8348','2013-01-09','13:10:00',1.16),('8348','2013-01-09','13:15:00',1.19),('8348','2013-01-08','09:25:00',1.03),('8348','2013-01-08','09:40:00',1.16),('8348','2013-01-08','09:45:00',1.37),('8348','2013-01-08','09:50:00',1.47),('8348','2013-01-08','09:55:00',1.47),('8348','2013-01-08','10:00:00',1.4),('8348','2013-01-08','10:05:00',1.3),('8348','2013-01-08','10:10:00',1.33),('8348','2013-01-08','10:15:00',1.33),('8348','2013-01-08','10:20:00',1.27),('8348','2013-01-08','10:25:00',1.4),('8348','2013-01-08','10:30:00',1.41),('8348','2013-01-08','10:35:00',1.52),('8348','2013-01-08','10:40:00',1.66),('8348','2013-01-08','10:45:00',1.63),('8348','2013-01-08','10:50:00',1.62),('8348','2013-01-08','10:55:00',1.68),('8348','2013-01-08','11:00:00',1.69),('8348','2013-01-08','11:05:00',1.77),('8348','2013-01-08','11:10:00',1.8),('8348','2013-01-08','11:15:00',1.83),('8348','2013-01-08','11:20:00',1.86),('8348','2013-01-08','11:25:00',1.88),('8348','2013-01-08','11:30:00',1.93),('8348','2013-01-08','11:35:00',1.95),('8348','2013-01-08','11:40:00',1.98),('8348','2013-01-08','11:45:00',2.37),('8348','2013-01-08','11:50:00',1.7),('8348','2013-01-08','11:55:00',1.44),('8348','2013-01-08','12:00:00',1.36),('8348','2013-01-08','12:05:00',1.3),('8348','2013-01-08','12:10:00',1.4),('8348','2013-01-08','12:15:00',1.29),('8348','2013-01-08','12:20:00',1.14),('8348','2013-01-08','12:25:00',1.1),('8348','2013-01-08','12:30:00',1.06),('8348','2013-01-08','12:35:00',1.03),('8348','2013-01-08','12:40:00',1.31),('8348','2013-01-08','12:45:00',1.59),('8348','2013-01-08','12:50:00',1.79),('8348','2013-01-08','12:55:00',1.23),('8348','2013-01-08','13:20:00',1.09),('8348','2013-01-08','13:45:00',1.31),('8348','2013-01-08','13:50:00',1.19),('8348','2013-01-08','13:55:00',1.28),('8348','2013-01-08','14:05:00',1.21),('8348','2013-01-07','09:35:00',1),('8348','2013-01-07','09:40:00',1.04),('8348','2013-01-07','09:45:00',1.1),('8348','2013-01-07','09:50:00',1.15),('8348','2013-01-07','09:55:00',1.22),('8348','2013-01-07','10:00:00',1.29),('8348','2013-01-07','10:05:00',1.36),('8348','2013-01-07','10:10:00',1.43),('8348','2013-01-07','10:15:00',1.49),('8348','2013-01-07','10:20:00',1.53),('8348','2013-01-07','10:25:00',1.55),('8348','2013-01-07','10:30:00',1.58),('8348','2013-01-07','10:35:00',1.61),('8348','2013-01-07','10:40:00',1.66),('8348','2013-01-07','10:45:00',1.7),('8348','2013-01-07','10:50:00',1.71),('8348','2013-01-07','10:55:00',1.72),('8348','2013-01-07','11:00:00',1.75),('8348','2013-01-07','11:05:00',1.77),('8348','2013-01-07','11:10:00',1.81),('8348','2013-01-07','11:15:00',1.83),('8348','2013-01-07','11:20:00',1.86),('8348','2013-01-07','11:25:00',1.88),('8348','2013-01-07','11:30:00',1.84),('8348','2013-01-07','11:35:00',1.91),('8348','2013-01-07','11:40:00',1.93),('8348','2013-01-07','11:45:00',1.93),('8348','2013-01-07','11:50:00',1.96),('8348','2013-01-07','11:55:00',1.96),('8348','2013-01-07','12:00:00',1.97),('8348','2013-01-07','12:05:00',1.99),('8348','2013-01-07','12:10:00',1.99),('8348','2013-01-07','12:15:00',2),('8348','2013-01-07','12:20:00',2),('8348','2013-01-07','12:25:00',2),('8348','2013-01-07','12:30:00',2.02),('8348','2013-01-07','12:35:00',2.02),('8348','2013-01-07','12:40:00',2),('8348','2013-01-07','12:45:00',2),('8348','2013-01-07','12:50:00',1.97),('8348','2013-01-07','12:55:00',1.95),('8348','2013-01-07','13:00:00',1.96),('8348','2013-01-07','13:05:00',1.95),('8348','2013-01-07','13:10:00',1.92),('8348','2013-01-07','13:15:00',1.9),('8348','2013-01-07','13:20:00',1.87),('8348','2013-01-07','13:25:00',1.88),('8348','2013-01-07','13:30:00',1.85),('8348','2013-01-07','13:35:00',1.81),('8348','2013-01-07','13:40:00',1.81),('8348','2013-01-07','13:45:00',1.77),('8348','2013-01-07','13:50:00',1.73),('8348','2013-01-07','13:55:00',1.7),('8348','2013-01-07','14:00:00',1.71),('8348','2013-01-07','14:05:00',1.67),('8348','2013-01-07','14:10:00',1.62),('8348','2013-01-07','14:15:00',1.59),('8348','2013-01-07','14:20:00',1.57),('8348','2013-01-07','14:25:00',1.53),('8348','2013-01-07','14:30:00',1.48),('8348','2013-01-07','14:35:00',1.43),('8348','2013-01-07','14:40:00',1.4),('8348','2013-01-07','14:45:00',1.34),('8348','2013-01-07','14:50:00',1.31),('8348','2013-01-07','14:55:00',1.23),('8348','2013-01-07','15:00:00',1.19),('8348','2013-01-07','15:05:00',1.13),('8348','2013-01-07','15:10:00',1.05),('8348','2013-01-06','09:35:00',1.01),('8348','2013-01-06','09:40:00',1.07),('8348','2013-01-06','09:45:00',1.12),('8348','2013-01-06','09:50:00',1.18),('8348','2013-01-06','09:55:00',1.21),('8348','2013-01-06','10:00:00',1.28),('8348','2013-01-06','10:05:00',1.32),('8348','2013-01-06','10:10:00',1.37),('8348','2013-01-06','10:15:00',1.41),('8348','2013-01-06','10:20:00',1.45),('8348','2013-01-06','10:25:00',1.5),('8348','2013-01-06','10:30:00',1.55),('8348','2013-01-06','10:35:00',1.6),('8348','2013-01-06','10:40:00',1.64),('8348','2013-01-06','10:45:00',1.67),('8348','2013-01-06','10:50:00',1.7),('8348','2013-01-06','10:55:00',1.73),('8348','2013-01-06','11:00:00',1.67),('8348','2013-01-06','11:05:00',1.79),('8348','2013-01-06','11:10:00',1.8),('8348','2013-01-06','11:15:00',1.83),('8348','2013-01-06','11:20:00',1.86),('8348','2013-01-06','11:25:00',1.89),('8348','2013-01-06','11:30:00',1.91),('8348','2013-01-06','11:35:00',1.93),('8348','2013-01-06','11:40:00',1.94),('8348','2013-01-06','11:45:00',1.95),('8348','2013-01-06','11:50:00',1.98),('8348','2013-01-06','11:55:00',1.99),('8348','2013-01-06','12:00:00',2),('8348','2013-01-06','12:05:00',2),('8348','2013-01-06','12:10:00',2),('8348','2013-01-06','12:15:00',2),('8348','2013-01-06','12:20:00',1.99),('8348','2013-01-06','12:25:00',1.98),('8348','2013-01-06','12:30:00',1.98),('8348','2013-01-06','12:35:00',1.95),('8348','2013-01-06','12:40:00',1.97),('8348','2013-01-06','12:45:00',2),('8348','2013-01-06','12:50:00',2.03),('8348','2013-01-06','12:55:00',2.04),('8348','2013-01-06','13:00:00',2.03),('8348','2013-01-06','13:05:00',2.01),('8348','2013-01-06','13:10:00',2),('8348','2013-01-06','13:15:00',1.98),('8348','2013-01-06','13:20:00',1.97),('8348','2013-01-06','13:25:00',1.95),('8348','2013-01-06','13:30:00',1.94),('8348','2013-01-06','13:35:00',1.92),('8348','2013-01-06','13:40:00',1.88),('8348','2013-01-06','13:45:00',1.87),('8348','2013-01-06','13:50:00',1.81),('8348','2013-01-06','13:55:00',1.77),('8348','2013-01-06','14:00:00',1.78),('8348','2013-01-06','14:05:00',1.77),('8348','2013-01-06','14:10:00',1.63),('8348','2013-01-06','14:15:00',1.64),('8348','2013-01-06','14:20:00',1.62),('8348','2013-01-06','14:25:00',1.48),('8348','2013-01-06','14:30:00',1.48),('8348','2013-01-06','14:35:00',1.41),('8348','2013-01-06','14:40:00',1.35),('8348','2013-01-06','14:45:00',1.31),('8348','2013-01-06','14:50:00',1.26),('8348','2013-01-06','14:55:00',1.2),('8348','2013-01-06','15:00:00',1.14),('8348','2013-01-06','15:05:00',1.07),('8348','2013-01-06','15:10:00',1.01),('8348','2013-01-05','10:50:00',1.04),('8348','2013-01-05','10:55:00',1.63),('8348','2013-01-05','11:00:00',1.38),('8348','2013-01-05','11:05:00',1.65),('8348','2013-01-05','11:10:00',1.54),('8348','2013-01-05','11:15:00',1.32),('8348','2013-01-05','11:20:00',1.75),('8348','2013-01-05','11:25:00',1.86),('8348','2013-01-05','11:30:00',1.88),('8348','2013-01-05','11:35:00',1.79),('8348','2013-01-05','11:40:00',1.69),('8348','2013-01-05','11:45:00',1.71),('8348','2013-01-05','11:50:00',1.52),('8348','2013-01-05','11:55:00',1.4),('8348','2013-01-05','12:00:00',1.3),('8348','2013-01-05','12:05:00',1.29),('8348','2013-01-05','12:10:00',1.29),('8348','2013-01-05','12:15:00',1.31),('8348','2013-01-05','12:20:00',1.19),('8348','2013-01-05','12:25:00',1.02),('8348','2013-01-05','12:30:00',1.01),('8348','2013-01-05','12:35:00',1.36),('8348','2013-01-05','12:40:00',1.71),('8348','2013-01-05','12:45:00',1.88),('8348','2013-01-05','12:50:00',1.24),('8348','2013-01-05','12:55:00',1.05),('8348','2013-01-05','13:00:00',1.1),('8348','2013-01-05','13:05:00',1.05),('8348','2013-01-05','13:10:00',1),('8348','2013-01-05','13:30:00',1.57),('8348','2013-01-05','13:35:00',1.3),('8348','2013-01-05','13:55:00',1.05),('8348','2013-01-05','14:05:00',1.46),('8348','2013-01-05','14:10:00',1.26),('8348','2013-01-05','14:15:00',1.07),('8348','2013-01-05','14:30:00',1.04),('8348','2013-01-05','14:40:00',1.05),('8348','2013-01-05','14:45:00',1.14),('8348','2013-01-05','15:00:00',1.07),('8348','2013-01-04','09:55:00',1.11),('8348','2013-01-04','10:00:00',1.42),('8348','2013-01-04','10:05:00',1.49),('8348','2013-01-04','10:10:00',1.31),('8348','2013-01-04','10:15:00',1.48),('8348','2013-01-04','10:20:00',1.29),('8348','2013-01-04','10:25:00',1.5),('8348','2013-01-04','10:30:00',1.61),('8348','2013-01-04','10:35:00',1.66),('8348','2013-01-04','10:40:00',1.73),('8348','2013-01-04','10:45:00',1.83),('8348','2013-01-04','10:50:00',1.96),('8348','2013-01-04','10:55:00',2.06),('8348','2013-01-04','11:00:00',1.84),('8348','2013-01-04','11:05:00',1.18),('8348','2013-01-04','11:45:00',1.12),('8348','2013-01-04','11:50:00',1.89),('8348','2013-01-04','11:55:00',2.33),('8348','2013-01-04','12:00:00',2.43),('8348','2013-01-04','12:05:00',2.03),('8348','2013-01-04','12:10:00',1.6),('8348','2013-01-04','12:15:00',1.09),('8348','2013-01-04','12:30:00',1.63),('8348','2013-01-04','12:35:00',1.4),('8348','2013-01-04','12:40:00',2.05),('8348','2013-01-04','12:45:00',2.07),('8348','2013-01-04','12:50:00',2.05),('8348','2013-01-04','12:55:00',2.06),('8348','2013-01-04','13:00:00',2.01),('8348','2013-01-04','13:05:00',1.91),('8348','2013-01-04','13:10:00',1.51),('8348','2013-01-04','13:15:00',1.75),('8348','2013-01-04','13:20:00',1.83),('8348','2013-01-04','13:25:00',1.78),('8348','2013-01-04','13:30:00',1.73),('8348','2013-01-04','13:35:00',1.74),('8348','2013-01-04','13:40:00',1.69),('8348','2013-01-04','13:45:00',1.71),('8348','2013-01-04','13:50:00',1.65),('8348','2013-01-04','13:55:00',1.61),('8348','2013-01-04','14:00:00',1.58),('8348','2013-01-04','14:05:00',1.57),('8348','2013-01-04','14:10:00',1.53),('8348','2013-01-04','14:15:00',1.47),('8348','2013-01-04','14:20:00',1.43),('8348','2013-01-04','14:25:00',1.36),('8348','2013-01-04','14:30:00',1.38),('8348','2013-01-04','14:35:00',1.35),('8348','2013-01-04','14:40:00',1.25),('8348','2013-01-04','14:45:00',1.21),('8348','2013-01-04','14:50:00',1.2),('8348','2013-01-04','14:55:00',1.15),('8348','2013-01-04','15:00:00',1.09),('8348','2013-01-03','09:35:00',1.05),('8348','2013-01-03','09:40:00',1.16),('8348','2013-01-03','09:45:00',1.29),('8348','2013-01-03','09:50:00',1.44),('8348','2013-01-03','09:55:00',1.55),('8348','2013-01-03','10:00:00',1.64),('8348','2013-01-03','10:05:00',1.72),('8348','2013-01-03','10:10:00',1.6),('8348','2013-01-03','10:15:00',1.96),('8348','2013-01-03','10:20:00',1.63),('8348','2013-01-03','10:25:00',1.7),('8348','2013-01-03','10:30:00',1.51),('8348','2013-01-03','10:35:00',1.55),('8348','2013-01-03','10:40:00',1.41),('8348','2013-01-03','10:45:00',1.31),('8348','2013-01-03','10:50:00',1.29),('8348','2013-01-03','10:55:00',1.23),('8348','2013-01-03','11:00:00',1.35),('8348','2013-01-03','11:05:00',1.26),('8348','2013-01-03','11:10:00',1.23),('8348','2013-01-03','11:15:00',1.16),('8348','2013-01-03','11:20:00',1.03),('8348','2013-01-03','11:35:00',1.09),('8348','2013-01-03','11:40:00',1.97),('8348','2013-01-03','11:45:00',2.05),('8348','2013-01-03','11:50:00',2.02),('8348','2013-01-03','11:55:00',2),('8348','2013-01-03','12:00:00',2),('8348','2013-01-03','12:05:00',2.01),('8348','2013-01-03','12:10:00',2.01),('8348','2013-01-03','12:15:00',2.01),('8348','2013-01-03','12:20:00',2.02),('8348','2013-01-03','12:25:00',2.02),('8348','2013-01-03','12:30:00',2.03),('8348','2013-01-03','12:35:00',2.03),('8348','2013-01-03','12:40:00',2.02),('8348','2013-01-03','12:45:00',2.02),('8348','2013-01-03','12:50:00',2),('8348','2013-01-03','12:55:00',2),('8348','2013-01-03','13:00:00',1.98),('8348','2013-01-03','13:05:00',1.96),('8348','2013-01-03','13:10:00',1.95),('8348','2013-01-03','13:15:00',1.93),('8348','2013-01-03','13:20:00',1.9),('8348','2013-01-03','13:25:00',1.89),('8348','2013-01-03','13:30:00',1.86),('8348','2013-01-03','13:35:00',1.84),('8348','2013-01-03','13:40:00',1.82),('8348','2013-01-03','13:45:00',1.79),('8348','2013-01-03','13:50:00',1.76),('8348','2013-01-03','13:55:00',1.73),('8348','2013-01-03','14:00:00',1.7),('8348','2013-01-03','14:05:00',1.67),('8348','2013-01-03','14:10:00',1.63),('8348','2013-01-03','14:15:00',1.61),('8348','2013-01-03','14:20:00',1.57),('8348','2013-01-03','14:25:00',1.52),('8348','2013-01-03','14:30:00',1.48),('8348','2013-01-03','14:35:00',1.43),('8348','2013-01-03','14:40:00',1.37),('8348','2013-01-03','14:45:00',1.33),('8348','2013-01-03','14:50:00',1.28),('8348','2013-01-03','14:55:00',1.23),('8348','2013-01-03','15:00:00',1.17),('8348','2013-01-03','15:05:00',1.11),('8348','2013-01-03','15:10:00',1.05),('8348','2014-03-18','07:45:00',1.04),('8348','2014-03-18','07:50:00',1.24),('8348','2014-03-18','07:55:00',1.73),('8348','2014-03-18','08:00:00',1.6),('8348','2014-03-18','08:05:00',1.35),('8348','2014-03-18','08:10:00',1.4),('8348','2014-03-18','08:15:00',1.42),('8348','2014-03-18','08:20:00',2.13),('8348','2014-03-18','08:25:00',1.95),('8348','2014-03-18','08:30:00',1.79),('8348','2014-03-18','08:35:00',1.63),('8348','2014-03-18','08:40:00',1.46),('8348','2014-03-18','08:45:00',1.4),('8348','2014-03-18','08:50:00',1.85),('8348','2014-03-18','08:55:00',4.02),('8348','2014-03-18','09:00:00',3.82),('8348','2014-03-18','09:05:00',3.38),('8348','2014-03-18','09:10:00',2.59),('8348','2014-03-18','09:15:00',3.26),('8348','2014-03-18','09:20:00',4.51),('8348','2014-03-18','09:25:00',3.88),('8348','2014-03-18','09:30:00',2.39),('8348','2014-03-18','09:35:00',2.93),('8348','2014-03-18','09:40:00',2.66),('8348','2014-03-18','09:45:00',2.36),('8348','2014-03-18','09:50:00',3.57),('8348','2014-03-18','09:55:00',3.71),('8348','2014-03-18','10:00:00',3.55),('8348','2014-03-18','10:05:00',5.33),('8348','2014-03-18','10:10:00',5.85),('8348','2014-03-18','10:15:00',5.96),('8348','2014-03-18','10:20:00',4.24),('8348','2014-03-18','10:25:00',3.05),('8348','2014-03-18','10:30:00',4.04),('8348','2014-03-18','10:35:00',5.56),('8348','2014-03-18','10:40:00',4.48),('8348','2014-03-18','10:45:00',4.75),('8348','2014-03-18','10:50:00',3.44),('8348','2014-03-18','10:55:00',6.23),('8348','2014-03-18','11:00:00',4.77),('8348','2014-03-18','11:05:00',4.17),('8348','2014-03-18','11:10:00',3.22),('8348','2014-03-18','11:15:00',2.3),('8348','2014-03-18','11:20:00',2.94),('8348','2014-03-18','11:25:00',3.42),('8348','2014-03-18','11:30:00',7.48),('8348','2014-03-18','11:35:00',7.57),('8348','2014-03-18','11:40:00',6.23),('8348','2014-03-18','11:45:00',4.31),('8348','2014-03-18','11:50:00',4.25),('8348','2014-03-18','11:55:00',2.82),('8348','2014-03-18','12:00:00',3.11),('8348','2014-03-18','12:05:00',3.28),('8348','2014-03-18','12:10:00',6.09),('8348','2014-03-18','12:15:00',6.47),('8348','2014-03-18','12:20:00',3.74),('8348','2014-03-18','12:25:00',2.81),('8348','2014-03-18','12:30:00',5.1),('8348','2014-03-18','12:35:00',5.92),('8348','2014-03-18','12:40:00',4.96),('8348','2014-03-18','12:45:00',5.62),('8348','2014-03-18','12:50:00',6.45),('8348','2014-03-18','12:55:00',5.97),('8348','2014-03-18','13:00:00',6.7),('8348','2014-03-18','13:05:00',6.68),('8348','2014-03-18','13:10:00',6.65),('8348','2014-03-18','13:15:00',6.57),('8348','2014-03-18','13:20:00',6.34),('8348','2014-03-18','13:25:00',5.78),('8348','2014-03-18','13:30:00',6.18),('8348','2014-03-18','13:35:00',6.38),('8348','2014-03-18','13:40:00',6.23),('8348','2014-03-18','13:45:00',6.22),('8348','2014-03-18','13:50:00',6.19),('8348','2014-03-18','13:55:00',6.2),('8348','2014-03-18','14:00:00',6.13),('8348','2014-03-18','14:05:00',6.09),('8348','2014-03-18','14:10:00',5.99),('8348','2014-03-18','14:15:00',5.91),('8348','2014-03-18','14:20:00',5.89),('8348','2014-03-18','14:25:00',5.8),('8348','2014-03-18','14:30:00',5.7),('8348','2014-03-18','14:35:00',5.63),('8348','2014-03-18','14:40:00',5.52),('8348','2014-03-18','14:45:00',5.42),('8348','2014-03-18','14:50:00',5.37),('8348','2014-03-18','14:55:00',5.25),('8348','2014-03-18','15:00:00',5.11),('8348','2014-03-18','15:05:00',5.06),('8348','2014-03-18','15:10:00',4.98),('8348','2014-03-18','15:15:00',4.86),('8348','2014-03-18','15:20:00',4.71),('8348','2014-03-18','15:25:00',4.61),('8348','2014-03-18','15:30:00',4.53),('8348','2014-03-18','15:35:00',4.37),('8348','2014-03-18','15:40:00',4.23),('8348','2014-03-18','15:45:00',4.08),('8348','2014-03-18','15:50:00',3.88),('8348','2014-03-18','15:55:00',3.8),('8348','2014-03-18','16:00:00',3.66),('8348','2014-03-18','16:05:00',3.42),('8348','2014-03-18','16:10:00',3.34),('8348','2014-03-18','16:15:00',3.24),('8348','2014-03-18','16:20:00',3.04),('8348','2014-03-18','16:25:00',2.89),('8348','2014-03-18','16:30:00',2.75),('8348','2014-03-18','16:35:00',2.55),('8348','2014-03-18','16:40:00',2.4),('8348','2014-03-18','16:45:00',2.16),('8348','2014-03-18','16:50:00',2.02),('8348','2014-03-18','16:55:00',1.84),('8348','2014-03-18','17:00:00',1.81),('8348','2014-03-18','17:05:00',1.59),('8348','2014-03-18','17:10:00',1.42),('8348','2014-03-18','17:15:00',1.22),('8348','2014-03-18','17:20:00',1.04),('8348','2013-01-01','09:40:00',1.02),('8348','2013-01-01','09:45:00',1.08),('8348','2013-01-01','09:50:00',1.14),('8348','2013-01-01','09:55:00',1.19),('8348','2013-01-01','10:00:00',1.23),('8348','2013-01-01','10:05:00',1.26),('8348','2013-01-01','10:10:00',1.3),('8348','2013-01-01','10:15:00',1.36),('8348','2013-01-01','10:20:00',1.39),('8348','2013-01-01','10:25:00',1.44),('8348','2013-01-01','10:30:00',1.49),('8348','2013-01-01','10:35:00',1.53),('8348','2013-01-01','10:40:00',1.63),('8348','2013-01-01','10:45:00',1.54),('8348','2013-01-01','10:50:00',1.57),('8348','2013-01-01','11:05:00',1.87),('8348','2013-01-01','11:10:00',1.81),('8348','2013-01-01','11:15:00',1.58),('8348','2013-01-01','11:20:00',1.32),('8348','2013-01-01','11:25:00',1.61),('8348','2013-01-01','11:30:00',1.83),('8348','2013-01-01','11:35:00',1.1),('8348','2013-01-01','11:40:00',1.39),('8348','2013-01-01','11:45:00',1.92),('8348','2013-01-01','11:50:00',1.77),('8348','2013-01-01','11:55:00',1.58),('8348','2013-01-01','12:00:00',1.06),('8348','2013-01-01','12:10:00',1.13),('8348','2013-01-01','12:15:00',1.03),('8348','2013-01-01','12:20:00',1.17),('8348','2013-01-01','12:25:00',1.04),('8348','2013-01-01','12:45:00',1.09),('8348','2013-01-01','12:50:00',1.01),('8348','2012-12-31','10:10:00',1.17),('8348','2012-12-31','10:15:00',1.54),('8348','2012-12-31','10:20:00',1.57),('8348','2012-12-31','10:25:00',1.59),('8348','2012-12-31','10:30:00',1.62),('8348','2012-12-31','10:35:00',1.65),('8348','2012-12-31','10:40:00',1.68),('8348','2012-12-31','10:45:00',1.67),('8348','2012-12-31','10:50:00',1.69),('8348','2012-12-31','10:55:00',1.75),('8348','2012-12-31','11:00:00',1.79),('8348','2012-12-31','11:05:00',1.78),('8348','2012-12-31','11:10:00',1.74),('8348','2012-12-31','11:15:00',1.82),('8348','2012-12-31','11:20:00',1.89),('8348','2012-12-31','11:25:00',1.91),('8348','2012-12-31','11:30:00',1.94),('8348','2012-12-31','11:35:00',1.97),('8348','2012-12-31','11:40:00',1.98),('8348','2012-12-31','11:45:00',2),('8348','2012-12-31','11:50:00',2.01),('8348','2012-12-31','11:55:00',2.02),('8348','2012-12-31','12:00:00',2.04),('8348','2012-12-31','12:05:00',2.07),('8348','2012-12-31','12:10:00',2.07),('8348','2012-12-31','12:15:00',2.08),('8348','2012-12-31','12:20:00',2.08),('8348','2012-12-31','12:25:00',2.08),('8348','2012-12-31','12:30:00',2.08),('8348','2012-12-31','12:35:00',2.07),('8348','2012-12-31','12:40:00',2.07),('8348','2012-12-31','12:45:00',2.07),('8348','2012-12-31','12:50:00',2.06),('8348','2012-12-31','12:55:00',2.04),('8348','2012-12-31','13:00:00',2.02),('8348','2012-12-31','13:05:00',2),('8348','2012-12-31','13:10:00',1.99),('8348','2012-12-31','13:15:00',1.97),('8348','2012-12-31','13:20:00',1.95),('8348','2012-12-31','13:25:00',1.92),('8348','2012-12-31','13:30:00',1.91),('8348','2012-12-31','13:35:00',1.88),('8348','2012-12-31','13:40:00',1.85),('8348','2012-12-31','13:45:00',1.82),('8348','2012-12-31','13:50:00',1.78),('8348','2012-12-31','13:55:00',1.74),('8348','2012-12-31','14:00:00',1.71),('8348','2012-12-31','14:05:00',1.69),('8348','2012-12-31','14:10:00',1.64),('8348','2012-12-31','14:15:00',1.6),('8348','2012-12-31','14:20:00',1.55),('8348','2012-12-31','14:25:00',1.51),('8348','2012-12-31','14:30:00',1.48),('8348','2012-12-31','14:35:00',1.43),('8348','2012-12-31','14:40:00',1.39),('8348','2012-12-31','14:45:00',1.34),('8348','2012-12-31','14:50:00',1.29),('8348','2012-12-31','14:55:00',1.23),('8348','2012-12-31','15:00:00',1.16),('8348','2012-12-31','15:05:00',1.11),('8348','2012-12-31','15:10:00',1.05),('8348','2012-12-30','09:35:00',1.02),('8348','2012-12-30','09:40:00',1.07),('8348','2012-12-30','09:45:00',1.11),('8348','2012-12-30','09:50:00',1.17),('8348','2012-12-30','09:55:00',1.22),('8348','2012-12-30','10:00:00',1.26),('8348','2012-12-30','10:05:00',1.31),('8348','2012-12-30','10:10:00',1.36),('8348','2012-12-30','10:15:00',1.41),('8348','2012-12-30','10:20:00',1.45),('8348','2012-12-30','10:25:00',1.49),('8348','2012-12-30','10:30:00',1.54),('8348','2012-12-30','10:35:00',1.58),('8348','2012-12-30','10:40:00',1.62),('8348','2012-12-30','10:45:00',1.66),('8348','2012-12-30','10:50:00',1.69),('8348','2012-12-30','10:55:00',1.73),('8348','2012-12-30','11:00:00',1.75),('8348','2012-12-30','11:05:00',1.79),('8348','2012-12-30','11:10:00',1.81),('8348','2012-12-30','11:15:00',1.84),('8348','2012-12-30','11:20:00',1.86),('8348','2012-12-30','11:25:00',1.88),('8348','2012-12-30','11:30:00',1.89),('8348','2012-12-30','11:35:00',1.92),('8348','2012-12-30','11:40:00',1.93),('8348','2012-12-30','11:45:00',1.96),('8348','2012-12-30','11:50:00',1.98),('8348','2012-12-30','11:55:00',1.99),('8348','2012-12-30','12:00:00',1.99),('8348','2012-12-30','12:05:00',2),('8348','2012-12-30','12:10:00',2.02),('8348','2012-12-30','12:15:00',2.03),('8348','2012-12-30','12:20:00',2.02),('8348','2012-12-30','12:25:00',2),('8348','2012-12-30','12:30:00',1.98),('8348','2012-12-30','12:35:00',1.98),('8348','2012-12-30','12:40:00',1.98),('8348','2012-12-30','12:45:00',1.97),('8348','2012-12-30','12:50:00',1.96),('8348','2012-12-30','12:55:00',1.97),('8348','2012-12-30','13:00:00',2),('8348','2012-12-30','13:05:00',1.99),('8348','2012-12-30','13:10:00',1.98),('8348','2012-12-30','13:15:00',1.97),('8348','2012-12-30','13:20:00',1.95),('8348','2012-12-30','13:25:00',1.94),('8348','2012-12-30','13:30:00',1.92),('8348','2012-12-30','13:35:00',1.89),('8348','2012-12-30','13:40:00',1.86),('8348','2012-12-30','13:45:00',1.83),('8348','2012-12-30','13:50:00',1.8),('8348','2012-12-30','13:55:00',1.77),('8348','2012-12-30','14:00:00',1.75),('8348','2012-12-30','14:05:00',1.7),('8348','2012-12-30','14:10:00',1.66),('8348','2012-12-30','14:15:00',1.63),('8348','2012-12-30','14:20:00',1.58),('8348','2012-12-30','14:25:00',1.54),('8348','2012-12-30','14:30:00',1.48),('8348','2012-12-30','14:35:00',1.44),('8348','2012-12-30','14:40:00',1.39),('8348','2012-12-30','14:45:00',1.33),('8348','2012-12-30','14:50:00',1.27),('8348','2012-12-30','14:55:00',1.22),('8348','2012-12-30','15:00:00',1.16),('8348','2012-12-30','15:05:00',1.09),('8348','2012-12-30','15:10:00',1.04),('8348','2012-12-29','09:40:00',1.05),('8348','2012-12-29','09:45:00',1.11),('8348','2012-12-29','09:50:00',1.17),('8348','2012-12-29','09:55:00',1.23),('8348','2012-12-29','10:00:00',1.28),('8348','2012-12-29','10:05:00',1.34),('8348','2012-12-29','10:10:00',1.38),('8348','2012-12-29','10:15:00',1.44),('8348','2012-12-29','10:20:00',1.48),('8348','2012-12-29','10:25:00',1.52),('8348','2012-12-29','10:30:00',1.56),('8348','2012-12-29','10:35:00',1.6),('8348','2012-12-29','10:40:00',1.64),('8348','2012-12-29','10:45:00',1.68),('8348','2012-12-29','10:50:00',1.73),('8348','2012-12-29','10:55:00',1.77),('8348','2012-12-29','11:00:00',1.79),('8348','2012-12-29','11:05:00',1.82),('8348','2012-12-29','11:10:00',1.84),('8348','2012-12-29','11:15:00',1.88),('8348','2012-12-29','11:20:00',1.91),('8348','2012-12-29','11:25:00',1.93),('8348','2012-12-29','11:30:00',1.94),('8348','2012-12-29','11:35:00',1.98),('8348','2012-12-29','11:40:00',1.97),('8348','2012-12-29','11:45:00',2),('8348','2012-12-29','11:50:00',2.01),('8348','2012-12-29','11:55:00',2.02),('8348','2012-12-29','12:00:00',2.05),('8348','2012-12-29','12:05:00',2.07),('8348','2012-12-29','12:10:00',2.09),('8348','2012-12-29','12:15:00',2.07),('8348','2012-12-29','12:20:00',2.05),('8348','2012-12-29','12:25:00',2.03),('8348','2012-12-29','12:30:00',2.04),('8348','2012-12-29','12:35:00',2.04),('8348','2012-12-29','12:40:00',2.06),('8348','2012-12-29','12:45:00',2.04),('8348','2012-12-29','12:50:00',2.02),('8348','2012-12-29','12:55:00',2.01),('8348','2012-12-29','13:00:00',2.03),('8348','2012-12-29','13:05:00',2.03),('8348','2012-12-29','13:10:00',2),('8348','2012-12-29','13:15:00',2),('8348','2012-12-29','13:20:00',1.98),('8348','2012-12-29','13:25:00',1.95),('8348','2012-12-29','13:30:00',1.92),('8348','2012-12-29','13:35:00',1.9),('8348','2012-12-29','13:40:00',1.88),('8348','2012-12-29','13:45:00',1.85),('8348','2012-12-29','13:50:00',1.82),('8348','2012-12-29','13:55:00',1.78),('8348','2012-12-29','14:00:00',1.75),('8348','2012-12-29','14:05:00',1.71),('8348','2012-12-29','14:10:00',1.67),('8348','2012-12-29','14:15:00',1.64),('8348','2012-12-29','14:20:00',1.6),('8348','2012-12-29','14:25:00',1.55),('8348','2012-12-29','14:30:00',1.5),('8348','2012-12-29','14:35:00',1.44),('8348','2012-12-29','14:40:00',1.4),('8348','2012-12-29','14:45:00',1.36),('8348','2012-12-29','14:50:00',1.31),('8348','2012-12-29','14:55:00',1.25),('8348','2012-12-29','15:00:00',1.19),('8348','2012-12-29','15:05:00',1.14),('8348','2012-12-29','15:10:00',1.08),('8348','2012-12-29','15:15:00',1.01),('8348','2012-12-28','09:45:00',1.05),('8348','2012-12-28','09:50:00',1.06),('8348','2012-12-28','09:55:00',1.12),('8348','2012-12-28','10:00:00',1.18),('8348','2012-12-28','10:05:00',1.24),('8348','2012-12-28','10:10:00',1.3),('8348','2012-12-28','10:15:00',1.35),('8348','2012-12-28','10:20:00',1.39),('8348','2012-12-28','10:25:00',1.44),('8348','2012-12-28','10:30:00',1.46),('8348','2012-12-28','10:35:00',1.53),('8348','2012-12-28','10:40:00',1.56),('8348','2012-12-28','10:45:00',1.59),('8348','2012-12-28','10:50:00',1.63),('8348','2012-12-28','10:55:00',1.68),('8348','2012-12-28','11:00:00',1.69),('8348','2012-12-28','11:05:00',1.75),('8348','2012-12-28','11:10:00',1.8),('8348','2012-12-28','11:15:00',1.81),('8348','2012-12-28','11:20:00',1.81),('8348','2012-12-28','11:25:00',1.86),('8348','2012-12-28','11:30:00',1.8),('8348','2012-12-28','11:35:00',1.92),('8348','2012-12-28','11:40:00',1.93),('8348','2012-12-28','11:45:00',1.89),('8348','2012-12-28','11:50:00',1.97),('8348','2012-12-28','11:55:00',1.97),('8348','2012-12-28','12:00:00',1.52),('8348','2012-12-28','12:05:00',1.83),('8348','2012-12-28','12:10:00',1.99),('8348','2012-12-28','12:15:00',1.99),('8348','2012-12-28','12:20:00',2.01),('8348','2012-12-28','12:25:00',1.98),('8348','2012-12-28','12:30:00',1.98),('8348','2012-12-28','12:35:00',1.97),('8348','2012-12-28','12:40:00',1.98),('8348','2012-12-28','12:45:00',1.97),('8348','2012-12-28','12:50:00',1.92),('8348','2012-12-28','12:55:00',1.77),('8348','2012-12-28','13:00:00',1.94),('8348','2012-12-28','13:05:00',1.92),('8348','2012-12-28','13:10:00',1.88),('8348','2012-12-28','13:15:00',1.86),('8348','2012-12-28','13:20:00',1.84),('8348','2012-12-28','13:25:00',1.83),('8348','2012-12-28','13:30:00',1.8),('8348','2012-12-28','13:35:00',1.77),('8348','2012-12-28','13:40:00',1.74),('8348','2012-12-28','13:45:00',1.7),('8348','2012-12-28','13:50:00',1.68),('8348','2012-12-28','13:55:00',1.6),('8348','2012-12-28','14:00:00',1.51),('8348','2012-12-28','14:05:00',1.48),('8348','2012-12-28','14:10:00',1.47),('8348','2012-12-28','14:15:00',1.45),('8348','2012-12-28','14:20:00',1.39),('8348','2012-12-28','14:25:00',1.35),('8348','2012-12-28','14:35:00',1.09),('8348','2012-12-28','14:40:00',1.19),('8348','2012-12-28','14:45:00',1.2),('8348','2012-12-28','14:50:00',1.15),('8348','2012-12-28','14:55:00',1.1),('8348','2012-12-28','15:00:00',1.07),('8348','2012-12-28','15:05:00',1.01),('8348','2012-12-27','09:35:00',1.13),('8348','2012-12-27','09:40:00',1.03),('8348','2012-12-27','09:45:00',1.19),('8348','2012-12-27','09:50:00',1.32),('8348','2012-12-27','10:15:00',1.23),('8348','2012-12-27','10:20:00',1.3),('8348','2012-12-27','10:25:00',1.37),('8348','2012-12-27','10:30:00',1.39),('8348','2012-12-27','10:35:00',1.45),('8348','2012-12-27','10:40:00',1.51),('8348','2012-12-27','10:45:00',1.56),('8348','2012-12-27','10:50:00',1.53),('8348','2012-12-27','10:55:00',1.6),('8348','2012-12-27','11:00:00',1.2),('8348','2012-12-27','11:05:00',1.61),('8348','2012-12-27','11:10:00',1.24),('8348','2012-12-27','11:50:00',1.7),('8348','2012-12-27','11:55:00',1.9),('8348','2012-12-27','12:00:00',1.99),('8348','2012-12-27','12:05:00',2.21),('8348','2012-12-27','12:10:00',2.26),('8348','2012-12-27','12:15:00',1.06),('8348','2012-12-27','12:20:00',1.62),('8348','2012-12-27','12:25:00',1.73),('8348','2012-12-27','12:30:00',1.93),('8348','2012-12-27','12:35:00',1.92),('8348','2012-12-27','12:40:00',2),('8348','2012-12-27','12:45:00',1.77),('8348','2012-12-27','12:50:00',1.68),('8348','2012-12-27','12:55:00',2.02),('8348','2012-12-27','13:00:00',1.98),('8348','2012-12-27','13:05:00',1.39),('8348','2012-12-27','13:10:00',1.26),('8348','2012-12-27','13:15:00',1.85),('8348','2012-12-27','13:20:00',1.14),('8348','2012-12-27','13:25:00',1.81),('8348','2012-12-27','13:30:00',1.75),('8348','2012-12-27','14:00:00',1.27),('8348','2012-12-27','14:05:00',1.46),('8348','2012-12-27','14:10:00',1.57),('8348','2012-12-27','14:15:00',1.55),('8348','2012-12-27','14:20:00',1.46),('8348','2012-12-27','14:25:00',1.42),('8348','2012-12-27','14:30:00',1.39),('8348','2012-12-27','14:35:00',1.36),('8348','2012-12-27','14:40:00',1.25),('8348','2012-12-27','15:00:00',1.15),('8348','2012-12-27','15:05:00',1.04),('8348','2012-12-26','09:40:00',1.02),('8348','2012-12-26','09:45:00',1.06),('8348','2012-12-26','09:50:00',1.11),('8348','2012-12-26','09:55:00',1.17),('8348','2012-12-26','10:00:00',1.22),('8348','2012-12-26','10:05:00',1.26),('8348','2012-12-26','10:10:00',1.3),('8348','2012-12-26','10:15:00',1.34),('8348','2012-12-26','10:20:00',1.37),('8348','2012-12-26','10:25:00',1.4),('8348','2012-12-26','10:30:00',1.44),('8348','2012-12-26','10:35:00',1.49),('8348','2012-12-26','10:40:00',1.52),('8348','2012-12-26','10:45:00',1.54),('8348','2012-12-26','10:50:00',1.57),('8348','2012-12-26','10:55:00',1.6),('8348','2012-12-26','11:00:00',1.63),('8348','2012-12-26','11:05:00',1.66),('8348','2012-12-26','11:10:00',1.68),('8348','2012-12-26','11:15:00',1.7),('8348','2012-12-26','11:20:00',1.74),('8348','2012-12-26','11:25:00',1.76),('8348','2012-12-26','11:30:00',1.77),('8348','2012-12-26','11:35:00',1.78),('8348','2012-12-26','11:40:00',1.82),('8348','2012-12-26','11:45:00',1.83),('8348','2012-12-26','11:50:00',1.88),('8348','2012-12-26','11:55:00',1.93),('8348','2012-12-26','12:00:00',1.97),('8348','2012-12-26','12:05:00',2.01),('8348','2012-12-26','12:10:00',2.01),('8348','2012-12-26','12:15:00',2.01),('8348','2012-12-26','12:20:00',2.02),('8348','2012-12-26','12:25:00',2.04),('8348','2012-12-26','12:30:00',2.03),('8348','2012-12-26','12:35:00',2.03),('8348','2012-12-26','12:40:00',2.05),('8348','2012-12-26','12:45:00',2.02),('8348','2012-12-26','12:50:00',1.97),('8348','2012-12-26','12:55:00',1.84),('8348','2012-12-26','13:00:00',2.05),('8348','2012-12-26','13:05:00',1.61),('8348','2012-12-26','13:10:00',2.07),('8348','2012-12-26','13:15:00',2.06),('8348','2012-12-26','13:20:00',2.16),('8348','2012-12-26','13:25:00',2.1),('8348','2012-12-26','13:30:00',2.36),('8348','2012-12-26','13:35:00',2.34),('8348','2012-12-26','13:40:00',2.29),('8348','2012-12-26','13:45:00',2.19),('8348','2012-12-26','13:50:00',1.95),('8348','2012-12-26','13:55:00',1.84),('8348','2012-12-26','14:00:00',1.65),('8348','2012-12-26','14:05:00',1.92),('8348','2012-12-26','14:10:00',1.09),('8348','2012-12-23','09:35:00',1.03),('8348','2012-12-23','09:40:00',1.08),('8348','2012-12-23','09:45:00',1.13),('8348','2012-12-23','09:50:00',1.18),('8348','2012-12-23','09:55:00',1.22),('8348','2012-12-23','10:00:00',1.26),('8348','2012-12-23','10:05:00',1.31),('8348','2012-12-23','10:10:00',1.35),('8348','2012-12-23','10:15:00',1.38),('8348','2012-12-23','10:20:00',1.42),('8348','2012-12-23','10:25:00',1.43),('8348','2012-12-23','10:30:00',1.44),('8348','2012-12-23','10:35:00',1.48),('8348','2012-12-23','10:40:00',1.55),('8348','2012-12-23','10:45:00',1.61),('8348','2012-12-23','10:50:00',1.62),('8348','2012-12-23','10:55:00',1.56),('8348','2012-12-23','11:00:00',1.68),('8348','2012-12-23','11:05:00',1.7),('8348','2012-12-23','11:10:00',1.72),('8348','2012-12-23','11:15:00',1.76),('8348','2012-12-23','11:20:00',1.82),('8348','2012-12-23','11:25:00',1.64),('8348','2012-12-23','11:30:00',1.77),('8348','2012-12-23','11:35:00',1.88),('8348','2012-12-23','11:40:00',1.89),('8348','2012-12-23','11:45:00',1.89),('8348','2012-12-23','11:50:00',1.94),('8348','2012-12-23','11:55:00',1.81),('8348','2012-12-23','12:00:00',1.7),('8348','2012-12-23','12:05:00',1.76),('8348','2012-12-23','12:10:00',1.77),('8348','2012-12-23','12:15:00',1.41),('8348','2012-12-23','12:20:00',1.04),('8348','2012-12-23','12:30:00',1.42),('8348','2012-12-23','12:35:00',1.12),('8348','2012-12-23','12:40:00',1.25),('8348','2012-12-23','12:50:00',1.31),('8348','2012-12-23','12:55:00',1.83),('8348','2012-12-23','13:00:00',1.89),('8348','2012-12-23','13:05:00',1.53),('8348','2012-12-23','13:10:00',1.68),('8348','2012-12-23','13:15:00',1.18),('8348','2012-12-23','13:20:00',1.03),('8348','2012-12-23','13:35:00',1.06),('8348','2012-12-23','13:40:00',1.31),('8348','2012-12-23','13:45:00',1.39),('8348','2012-12-23','13:50:00',1.22),('8348','2012-12-23','13:55:00',1.15),('8348','2012-12-23','14:00:00',1.67),('8348','2012-12-23','14:05:00',1.41),('8348','2012-12-23','14:10:00',1.33),('8348','2012-12-23','14:15:00',1.38),('8348','2012-12-23','14:20:00',1.08),('8348','2012-12-23','14:35:00',1.03),('8348','2012-12-23','14:40:00',1.18),('8348','2012-12-23','14:45:00',1.19),('8348','2014-05-01','06:40:00',1.14),('8348','2014-05-01','06:50:00',1.34),('8348','2014-05-01','06:55:00',1.58),('8348','2014-05-01','07:00:00',1.73),('8348','2014-05-01','07:05:00',1.79),('8348','2014-05-01','07:10:00',1.8),('8348','2014-05-01','07:15:00',1.95),('8348','2014-05-01','07:20:00',2.07),('8348','2014-05-01','07:25:00',2.2),('8348','2014-05-01','07:30:00',2.33),('8348','2014-05-01','07:35:00',2.47),('8348','2014-05-01','07:40:00',2.82),('8348','2014-05-01','07:45:00',3.19),('8348','2014-05-01','07:50:00',3.58),('8348','2014-05-01','07:55:00',4.2),('8348','2014-05-01','08:00:00',2.99),('8348','2014-05-01','08:05:00',1.83),('8348','2014-05-01','08:10:00',2.53),('8348','2014-05-01','08:15:00',2.88),('8348','2014-05-01','08:20:00',3.05),('8348','2014-05-01','08:25:00',4.51),('8348','2014-05-01','08:30:00',4.78),('8348','2014-05-01','08:35:00',4.93),('8348','2014-05-01','08:40:00',5.41),('8348','2014-05-01','08:45:00',2.98),('8348','2014-05-01','08:50:00',4.16),('8348','2014-05-01','08:55:00',3.06),('8348','2014-05-01','09:00:00',3.54),('8348','2014-05-01','09:05:00',4.21),('8348','2014-05-01','09:10:00',5.04),('8348','2014-05-01','09:15:00',4.04),('8348','2014-05-01','09:20:00',3.26),('8348','2014-05-01','09:25:00',4.91),('8348','2014-05-01','09:30:00',6.6),('8348','2014-05-01','09:35:00',5.39),('8348','2014-05-01','09:40:00',5.55),('8348','2014-05-01','09:45:00',6.63),('8348','2014-05-01','09:50:00',6.84),('8348','2014-05-01','09:55:00',7.6),('8348','2014-05-01','10:00:00',3.41),('8348','2014-05-01','10:05:00',5.05),('8348','2014-05-01','10:10:00',5.05),('8348','2014-05-01','10:15:00',6.76),('8348','2014-05-01','10:20:00',7.62),('8348','2014-05-01','10:25:00',7.62),('8348','2014-05-01','10:30:00',6.41),('8348','2014-05-01','10:35:00',7.72),('8348','2014-05-01','10:40:00',7.65),('8348','2014-05-01','10:45:00',7.13),('8348','2014-05-01','10:50:00',7.87),('8348','2014-05-01','10:55:00',6.44),('8348','2014-05-01','11:00:00',6.91),('8348','2014-05-01','11:05:00',5.52),('8348','2014-05-01','11:10:00',2.83),('8348','2014-05-01','11:15:00',4.48),('8348','2014-05-01','11:20:00',5.84),('8348','2014-05-01','11:25:00',6),('8348','2014-05-01','11:30:00',8.12),('8348','2014-05-01','11:35:00',8.11),('8348','2014-05-01','11:40:00',8.09),('8348','2014-05-01','11:45:00',5.21),('8348','2014-05-01','11:50:00',4.34),('8348','2014-05-01','11:55:00',8.62),('8348','2014-05-01','12:00:00',7.83),('8348','2014-05-01','12:05:00',8.25),('8348','2014-05-01','12:10:00',8.04),('8348','2014-05-01','12:15:00',6.01),('8348','2014-05-01','12:20:00',8.35),('8348','2014-05-01','12:25:00',4.8),('8348','2014-05-01','12:30:00',5.01),('8348','2014-05-01','12:35:00',7.86),('8348','2014-05-01','12:40:00',8.41),('8348','2014-05-01','12:45:00',8.51),('8348','2014-05-01','12:50:00',8.27),('8348','2014-05-01','12:55:00',6.61),('8348','2014-05-01','13:00:00',4.72),('8348','2014-05-01','13:05:00',6.91),('8348','2014-05-01','13:10:00',7.51),('8348','2014-05-01','13:15:00',8.03),('8348','2014-05-01','13:20:00',7.74),('8348','2014-05-01','13:25:00',7.86),('8348','2014-05-01','13:30:00',7.55),('8348','2014-05-01','13:35:00',6.87),('8348','2014-05-01','13:40:00',6.04),('8348','2014-05-01','13:45:00',7.38),('8348','2014-05-01','13:50:00',7.88),('8348','2014-05-01','13:55:00',5.76),('8348','2014-05-01','14:00:00',8.04),('8348','2014-05-01','14:05:00',7.97),('8348','2014-05-01','14:10:00',7.48),('8348','2014-05-01','14:15:00',7.49),('8348','2014-05-01','14:20:00',7.37),('8348','2014-05-01','14:25:00',7.19),('8348','2014-05-01','14:30:00',6.97),('8348','2014-05-01','14:35:00',6.9),('8348','2014-05-01','14:40:00',6.89),('8348','2014-05-01','14:45:00',6.78),('8348','2014-05-01','14:50:00',6.63),('8348','2014-05-01','14:55:00',6.37),('8348','2014-05-01','15:00:00',6.39),('8348','2014-05-01','15:05:00',6.45),('8348','2014-05-01','15:10:00',6.15),('8348','2014-05-01','15:15:00',6.15),('8348','2014-05-01','15:20:00',5.92),('8348','2014-05-01','15:25:00',5.4),('8348','2014-05-01','15:30:00',5.68),('8348','2014-05-01','15:35:00',5.66),('8348','2014-05-01','15:40:00',5.38),('8348','2014-05-01','15:45:00',4.56),('8348','2014-05-01','15:50:00',4.47),('8348','2014-05-01','15:55:00',4.54),('8348','2014-05-01','16:00:00',4.43),('8348','2014-05-01','16:05:00',4.65),('8348','2014-05-01','16:10:00',4.9),('8348','2014-05-01','16:15:00',4.63),('8348','2014-05-01','16:20:00',4.52),('8348','2014-05-01','16:25:00',4.35),('8348','2014-05-01','16:30:00',4.19),('8348','2014-05-01','16:35:00',4.06),('8348','2014-05-01','16:40:00',3.88),('8348','2014-05-01','16:45:00',3.74),('8348','2014-05-01','16:50:00',3.61),('8348','2014-05-01','16:55:00',3.46),('8348','2014-05-01','17:00:00',3.45),('8348','2014-05-01','17:05:00',3.15),('8348','2014-05-01','17:10:00',2.9),('8348','2014-05-01','17:15:00',2.7),('8348','2014-05-01','17:20:00',2.55),('8348','2014-05-01','17:25:00',2.23),('8348','2014-05-01','17:30:00',2.27),('8348','2014-05-01','17:35:00',1.63),('8348','2014-05-01','17:40:00',1.91),('8348','2014-05-01','17:45:00',1.76),('8348','2014-05-01','17:50:00',1.58),('8348','2014-05-01','17:55:00',1.41),('8348','2014-05-01','18:00:00',1.26),('8348','2014-05-01','18:05:00',1.06),('8348','2014-03-17','08:30:00',1.02),('8348','2014-03-17','08:35:00',1.08),('8348','2014-03-17','08:40:00',1.26),('8348','2014-03-17','08:45:00',1.38),('8348','2014-03-17','08:50:00',1.31),('8348','2014-03-17','08:55:00',1.44),('8348','2014-03-17','09:00:00',1.43),('8348','2014-03-17','09:05:00',1.52),('8348','2014-03-17','09:10:00',1.67),('8348','2014-03-17','09:15:00',1.85),('8348','2014-03-17','09:20:00',2.01),('8348','2014-03-17','09:25:00',2.45),('8348','2014-03-17','09:30:00',2.8),('8348','2014-03-17','09:35:00',2.61),('8348','2014-03-17','09:40:00',2.18),('8348','2014-03-17','09:45:00',2.24),('8348','2014-03-17','09:50:00',3.13),('8348','2014-03-17','09:55:00',3.05),('8348','2014-03-17','10:00:00',3.26),('8348','2014-03-17','10:05:00',3.04),('8348','2014-03-17','10:10:00',2.89),('8348','2014-03-17','10:15:00',3),('8348','2014-03-17','10:20:00',3.52),('8348','2014-03-17','10:25:00',3.21),('8348','2014-03-17','10:30:00',2.54),('8348','2014-03-17','10:35:00',2.49),('8348','2014-03-17','10:40:00',2.49),('8348','2014-03-17','10:45:00',3.19),('8348','2014-03-17','10:50:00',2.66),('8348','2014-03-17','10:55:00',2.44),('8348','2014-03-17','11:00:00',2.63),('8348','2014-03-17','11:05:00',2.53),('8348','2014-03-17','11:10:00',2.89),('8348','2014-03-17','11:15:00',3.54),('8348','2014-03-17','11:20:00',2.62),('8348','2014-03-17','11:25:00',2.66),('8348','2014-03-17','11:30:00',2.51),('8348','2014-03-17','11:35:00',2.37),('8348','2014-03-17','11:40:00',2.25),('8348','2014-03-17','11:45:00',2.54),('8348','2014-03-17','11:50:00',2.72),('8348','2014-03-17','11:55:00',2.95),('8348','2014-03-17','12:00:00',4.08),('8348','2014-03-17','12:05:00',3),('8348','2014-03-17','12:10:00',3.03),('8348','2014-03-17','12:15:00',2.92),('8348','2014-03-17','12:20:00',5.55),('8348','2014-03-17','12:25:00',3.4),('8348','2014-03-17','12:30:00',2.79),('8348','2014-03-17','12:35:00',4.74),('8348','2014-03-17','12:40:00',5.34),('8348','2014-03-17','12:45:00',7.09),('8348','2014-03-17','12:50:00',6.87),('8348','2014-03-17','12:55:00',6.82),('8348','2014-03-17','13:00:00',4.78),('8348','2014-03-17','13:05:00',2.67),('8348','2014-03-17','13:10:00',5.8),('8348','2014-03-17','13:15:00',6.64),('8348','2014-03-17','13:20:00',6.43),('8348','2014-03-17','13:25:00',6.28),('8348','2014-03-17','13:30:00',6.43),('8348','2014-03-17','13:35:00',6.42),('8348','2014-03-17','13:40:00',6.66),('8348','2014-03-17','13:45:00',4.14),('8348','2014-03-17','13:50:00',5.86),('8348','2014-03-17','13:55:00',5.25),('8348','2014-03-17','14:00:00',6.56),('8348','2014-03-17','14:05:00',5.79),('8348','2014-03-17','14:10:00',3.52),('8348','2014-03-17','14:15:00',4.25),('8348','2014-03-17','14:20:00',4.79),('8348','2014-03-17','14:25:00',3.89),('8348','2014-03-17','14:30:00',2.66),('8348','2014-03-17','14:35:00',3.17),('8348','2014-03-17','14:40:00',5.38),('8348','2014-03-17','14:45:00',3.52),('8348','2014-03-17','14:50:00',3.95),('8348','2014-03-17','14:55:00',4.73),('8348','2014-03-17','15:00:00',5.09),('8348','2014-03-17','15:05:00',3.77),('8348','2014-03-17','15:10:00',4.63),('8348','2014-03-17','15:15:00',4.78),('8348','2014-03-17','15:20:00',4.27),('8348','2014-03-17','15:25:00',4.35),('8348','2014-03-17','15:30:00',4.42),('8348','2014-03-17','15:35:00',4.22),('8348','2014-03-17','15:40:00',3.58),('8348','2014-03-17','15:45:00',3.88),('8348','2014-03-17','15:50:00',3.61),('8348','2014-03-17','15:55:00',3.49),('8348','2014-03-17','16:00:00',3.36),('8348','2014-03-17','16:05:00',3.24),('8348','2014-03-17','16:10:00',1.23),('8348','2014-03-17','16:15:00',2.33),('8348','2014-03-17','16:20:00',3.19),('8348','2014-03-17','16:25:00',3.17),('8348','2014-03-17','16:30:00',2.52),('8348','2014-03-17','16:35:00',2.66),('8348','2014-03-17','16:40:00',2.4),('8348','2014-03-17','16:45:00',1.99),('8348','2014-03-17','16:50:00',1.95),('8348','2014-03-17','16:55:00',1.53),('8348','2014-03-17','17:00:00',1.13),('8348','2014-03-17','17:05:00',1.24),('8348','2012-12-22','10:25:00',1.25),('8348','2012-12-22','10:30:00',1.79),('8348','2012-12-22','10:35:00',2.04),('8348','2012-12-22','10:40:00',1.98),('8348','2012-12-22','10:45:00',1.95),('8348','2012-12-22','10:50:00',1.88),('8348','2012-12-22','10:55:00',1.79),('8348','2012-12-22','11:35:00',1.03),('8348','2012-12-22','11:40:00',1.54),('8348','2012-12-22','11:45:00',1.64),('8348','2012-12-22','11:50:00',1.67),('8348','2012-12-22','11:55:00',1.18),('8348','2012-12-22','12:00:00',1.18),('8348','2012-12-22','12:45:00',1.85),('8348','2012-12-22','12:50:00',1.92),('8348','2012-12-22','12:55:00',1.74),('8348','2012-12-22','13:00:00',2.1),('8348','2012-12-22','13:05:00',1.8),('8348','2012-12-22','13:10:00',2.51),('8348','2012-12-22','13:15:00',2.56),('8348','2012-12-22','13:20:00',2.48),('8348','2012-12-22','13:25:00',2.4),('8348','2012-12-22','13:30:00',2.19),('8348','2012-12-22','13:35:00',2.27),('8348','2012-12-22','13:40:00',1.38),('8348','2012-12-22','14:00:00',1.07),('8348','2012-12-22','14:10:00',1.44),('8348','2012-12-22','14:15:00',1.08),('8348','2012-12-22','15:00:00',1.08),('8348','2014-03-16','07:35:00',1.02),('8348','2014-03-16','07:40:00',1.08),('8348','2014-03-16','07:45:00',1.17),('8348','2014-03-16','07:50:00',1.27),('8348','2014-03-16','07:55:00',1.47),('8348','2014-03-16','08:00:00',1.64),('8348','2014-03-16','08:05:00',1.78),('8348','2014-03-16','08:10:00',1.81),('8348','2014-03-16','08:15:00',1.86),('8348','2014-03-16','08:20:00',1.96),('8348','2014-03-16','08:25:00',2.07),('8348','2014-03-16','08:30:00',2.17),('8348','2014-03-16','08:35:00',2.24),('8348','2014-03-16','08:40:00',2.34),('8348','2014-03-16','08:45:00',2.54),('8348','2014-03-16','08:50:00',2.76),('8348','2014-03-16','08:55:00',2.83),('8348','2014-03-16','09:00:00',2.82),('8348','2014-03-16','09:05:00',2.94),('8348','2014-03-16','09:10:00',3.16),('8348','2014-03-16','09:15:00',3.53),('8348','2014-03-16','09:20:00',3.63),('8348','2014-03-16','09:25:00',3.64),('8348','2014-03-16','09:30:00',3.74),('8348','2014-03-16','09:35:00',3.77),('8348','2014-03-16','09:40:00',3.84),('8348','2014-03-16','09:45:00',4.14),('8348','2014-03-16','09:50:00',4.35),('8348','2014-03-16','09:55:00',4.31),('8348','2014-03-16','10:00:00',4.47),('8348','2014-03-16','10:05:00',4.49),('8348','2014-03-16','10:10:00',4.6),('8348','2014-03-16','10:15:00',4.76),('8348','2014-03-16','10:20:00',4.69),('8348','2014-03-16','10:25:00',4.81),('8348','2014-03-16','10:30:00',4.93),('8348','2014-03-16','10:35:00',5.01),('8348','2014-03-16','10:40:00',5.15),('8348','2014-03-16','10:45:00',5.26),('8348','2014-03-16','10:50:00',4.74),('8348','2014-03-16','10:55:00',5.11),('8348','2014-03-16','11:00:00',5.24),('8348','2014-03-16','11:05:00',5.42),('8348','2014-03-16','11:10:00',5.44),('8348','2014-03-16','11:15:00',5.58),('8348','2014-03-16','11:20:00',5.61),('8348','2014-03-16','11:25:00',5.76),('8348','2014-03-16','11:30:00',5.85),('8348','2014-03-16','11:35:00',5.85),('8348','2014-03-16','11:40:00',5.94),('8348','2014-03-16','11:45:00',5.88),('8348','2014-03-16','11:50:00',5.84),('8348','2014-03-16','11:55:00',5.86),('8348','2014-03-16','12:00:00',5.82),('8348','2014-03-16','12:05:00',5.96),('8348','2014-03-16','12:10:00',5.95),('8348','2014-03-16','12:15:00',5.76),('8348','2014-03-16','12:20:00',5.43),('8348','2014-03-16','12:25:00',5.61),('8348','2014-03-16','12:30:00',5.89),('8348','2014-03-16','12:35:00',5.95),('8348','2014-03-16','12:40:00',6.07),('8348','2014-03-16','12:45:00',6.02),('8348','2014-03-16','12:50:00',5.97),('8348','2014-03-16','12:55:00',5.82),('8348','2014-03-16','13:00:00',5.82),('8348','2014-03-16','13:05:00',5.98),('8348','2014-03-16','13:10:00',5.97),('8348','2014-03-16','13:15:00',6.02),('8348','2014-03-16','13:20:00',5.79),('8348','2014-03-16','13:25:00',5.83),('8348','2014-03-16','13:30:00',5.86),('8348','2014-03-16','13:35:00',5.79),('8348','2014-03-16','13:40:00',5.86),('8348','2014-03-16','13:45:00',5.73),('8348','2014-03-16','13:50:00',5.8),('8348','2014-03-16','13:55:00',5.82),('8348','2014-03-16','14:00:00',5.54),('8348','2014-03-16','14:05:00',5.59),('8348','2014-03-16','14:10:00',5.45),('8348','2014-03-16','14:15:00',5.35),('8348','2014-03-16','14:20:00',5.37),('8348','2014-03-16','14:25:00',5.31),('8348','2014-03-16','14:30:00',5.25),('8348','2014-03-16','14:35:00',5.18),('8348','2014-03-16','14:40:00',5.05),('8348','2014-03-16','14:45:00',4.91),('8348','2014-03-16','14:50:00',4.7),('8348','2014-03-16','14:55:00',4.64),('8348','2014-03-16','15:00:00',4.83),('8348','2014-03-16','15:05:00',4.6),('8348','2014-03-16','15:10:00',4.2),('8348','2014-03-16','15:15:00',4.06),('8348','2014-03-16','15:20:00',3.42),('8348','2014-03-16','15:25:00',3.88),('8348','2014-03-16','15:30:00',3.63),('8348','2014-03-16','15:35:00',3.32),('8348','2014-03-16','15:40:00',2.63),('8348','2014-03-16','15:45:00',2.58),('8348','2014-03-16','15:50:00',2.9),('8348','2014-03-16','15:55:00',2.69),('8348','2014-03-16','16:00:00',2.38),('8348','2014-03-16','16:05:00',2.82),('8348','2014-03-16','16:10:00',2.96),('8348','2014-03-16','16:15:00',2.91),('8348','2014-03-16','16:20:00',2.65),('8348','2014-03-16','16:25:00',2.64),('8348','2014-03-16','16:30:00',2.61),('8348','2014-03-16','16:35:00',2.4),('8348','2014-03-16','16:40:00',2.1),('8348','2014-03-16','16:45:00',1.84),('8348','2014-03-16','16:50:00',1.7),('8348','2014-03-16','16:55:00',1.42),('8348','2014-03-16','17:00:00',1.17),('8348','2014-03-16','17:05:00',1.13),('8348','2014-03-15','07:40:00',1.06),('8348','2014-03-15','07:45:00',1.15),('8348','2014-03-15','07:50:00',1.26),('8348','2014-03-15','07:55:00',1.37),('8348','2014-03-15','08:00:00',1.48),('8348','2014-03-15','08:05:00',1.61),('8348','2014-03-15','08:10:00',1.71),('8348','2014-03-15','08:15:00',1.82),('8348','2014-03-15','08:20:00',1.93),('8348','2014-03-15','08:25:00',2.02),('8348','2014-03-15','08:30:00',2.13),('8348','2014-03-15','08:35:00',2.22),('8348','2014-03-15','08:40:00',2.33),('8348','2014-03-15','08:45:00',2.46),('8348','2014-03-15','08:50:00',2.69),('8348','2014-03-15','08:55:00',2.84),('8348','2014-03-15','09:00:00',2.96),('8348','2014-03-15','09:05:00',3.08),('8348','2014-03-15','09:10:00',3.19),('8348','2014-03-15','09:15:00',3.4),('8348','2014-03-15','09:20:00',3.59),('8348','2014-03-15','09:25:00',3.71),('8348','2014-03-15','09:30:00',3.8),('8348','2014-03-15','09:35:00',3.89),('8348','2014-03-15','09:40:00',3.99),('8348','2014-03-15','09:45:00',4.08),('8348','2014-03-15','09:50:00',4.14),('8348','2014-03-15','09:55:00',4.22),('8348','2014-03-15','10:00:00',4.3),('8348','2014-03-15','10:05:00',4.4),('8348','2014-03-15','10:10:00',4.47),('8348','2014-03-15','10:15:00',4.6),('8348','2014-03-15','10:20:00',4.72),('8348','2014-03-15','10:25:00',4.77),('8348','2014-03-15','10:30:00',4.85),('8348','2014-03-15','10:35:00',4.88),('8348','2014-03-15','10:40:00',4.94),('8348','2014-03-15','10:45:00',5),('8348','2014-03-15','10:50:00',4.96),('8348','2014-03-15','10:55:00',5.04),('8348','2014-03-15','11:00:00',5.17),('8348','2014-03-15','11:05:00',5.18),('8348','2014-03-15','11:10:00',5.31),('8348','2014-03-15','11:15:00',5.53),('8348','2014-03-15','11:20:00',5.59),('8348','2014-03-15','11:25:00',5.72),('8348','2014-03-15','11:30:00',5.7),('8348','2014-03-15','11:35:00',5.83),('8348','2014-03-15','11:40:00',5.82),('8348','2014-03-15','11:45:00',5.85),('8348','2014-03-15','11:50:00',5.76),('8348','2014-03-15','11:55:00',5.93),('8348','2014-03-15','12:00:00',5.89),('8348','2014-03-15','12:05:00',5.88),('8348','2014-03-15','12:10:00',5.98),('8348','2014-03-15','12:15:00',6.08),('8348','2014-03-15','12:20:00',5.94),('8348','2014-03-15','12:25:00',6.03),('8348','2014-03-15','12:30:00',6.13),('8348','2014-03-15','12:35:00',6.35),('8348','2014-03-15','12:40:00',6.29),('8348','2014-03-15','12:45:00',6.22),('8348','2014-03-15','12:50:00',6.27),('8348','2014-03-15','12:55:00',6.14),('8348','2014-03-15','13:00:00',6.16),('8348','2014-03-15','13:05:00',6.18),('8348','2014-03-15','13:10:00',6.17),('8348','2014-03-15','13:15:00',6.16),('8348','2014-03-15','13:20:00',6.12),('8348','2014-03-15','13:25:00',6.12),('8348','2014-03-15','13:30:00',6.12),('8348','2014-03-15','13:35:00',6.09),('8348','2014-03-15','13:40:00',6.11),('8348','2014-03-15','13:45:00',6.03),('8348','2014-03-15','13:50:00',5.99),('8348','2014-03-15','13:55:00',5.96),('8348','2014-03-15','14:00:00',5.94),('8348','2014-03-15','14:05:00',5.92),('8348','2014-03-15','14:10:00',5.8),('8348','2014-03-15','14:15:00',5.72),('8348','2014-03-15','14:20:00',5.63),('8348','2014-03-15','14:25:00',5.56),('8348','2014-03-15','14:30:00',5.47),('8348','2014-03-15','14:35:00',5.36),('8348','2014-03-15','14:40:00',5.25),('8348','2014-03-15','14:45:00',5.16),('8348','2014-03-15','14:50:00',5.05),('8348','2014-03-15','14:55:00',5),('8348','2014-03-15','15:00:00',4.9),('8348','2014-03-15','15:05:00',4.78),('8348','2014-03-15','15:10:00',4.65),('8348','2014-03-15','15:15:00',4.52),('8348','2014-03-15','15:20:00',4.36),('8348','2014-03-15','15:25:00',4.24),('8348','2014-03-15','15:30:00',4.15),('8348','2014-03-15','15:35:00',3.99),('8348','2014-03-15','15:40:00',3.86),('8348','2014-03-15','15:45:00',3.75),('8348','2014-03-15','15:50:00',3.63),('8348','2014-03-15','15:55:00',3.47),('8348','2014-03-15','16:00:00',3.24),('8348','2014-03-15','16:05:00',3.02),('8348','2014-03-15','16:10:00',2.85),('8348','2014-03-15','16:15:00',2.64),('8348','2014-03-15','16:20:00',2.53),('8348','2014-03-15','16:25:00',2.37),('8348','2014-03-15','16:30:00',2.21),('8348','2014-03-15','16:35:00',2.09),('8348','2014-03-15','16:40:00',1.93),('8348','2014-03-15','16:45:00',1.79),('8348','2014-03-15','16:50:00',1.61),('8348','2014-03-15','16:55:00',1.48),('8348','2014-03-15','17:00:00',1.33),('8348','2014-03-15','17:05:00',1.2),('8348','2014-03-15','17:10:00',1.06),('8348','2014-03-14','07:45:00',1.07),('8348','2014-03-14','07:50:00',1.17),('8348','2014-03-14','07:55:00',1.27),('8348','2014-03-14','08:00:00',1.35),('8348','2014-03-14','08:05:00',1.43),('8348','2014-03-14','08:10:00',1.55),('8348','2014-03-14','08:15:00',1.7),('8348','2014-03-14','08:20:00',1.87),('8348','2014-03-14','08:25:00',1.95),('8348','2014-03-14','08:30:00',2.09),('8348','2014-03-14','08:35:00',2.08),('8348','2014-03-14','08:40:00',2.07),('8348','2014-03-14','08:45:00',1.86),('8348','2014-03-14','08:50:00',1.78),('8348','2014-03-14','08:55:00',1.83),('8348','2014-03-14','09:00:00',1.97),('8348','2014-03-14','09:05:00',2.22),('8348','2014-03-14','09:10:00',2.48),('8348','2014-03-14','09:15:00',2.59),('8348','2014-03-14','09:20:00',2.52),('8348','2014-03-14','09:25:00',2.62),('8348','2014-03-14','09:30:00',2.61),('8348','2014-03-14','09:35:00',2.98),('8348','2014-03-14','09:40:00',3.68),('8348','2014-03-14','09:45:00',4.2),('8348','2014-03-14','09:50:00',4.91),('8348','2014-03-14','09:55:00',5.26),('8348','2014-03-14','10:00:00',5.42),('8348','2014-03-14','10:05:00',5.47),('8348','2014-03-14','10:10:00',5.35),('8348','2014-03-14','10:15:00',5.25),('8348','2014-03-14','10:20:00',5.23),('8348','2014-03-14','10:25:00',4.98),('8348','2014-03-14','10:30:00',4.94),('8348','2014-03-14','10:35:00',5.07),('8348','2014-03-14','10:40:00',5.36),('8348','2014-03-14','10:45:00',4.84),('8348','2014-03-14','10:50:00',3.25),('8348','2014-03-14','10:55:00',3.94),('8348','2014-03-14','11:00:00',5.23),('8348','2014-03-14','11:05:00',5.42),('8348','2014-03-14','11:10:00',5.92),('8348','2014-03-14','11:15:00',6.15),('8348','2014-03-14','11:20:00',5.93),('8348','2014-03-14','11:25:00',5.85),('8348','2014-03-14','11:30:00',5.75),('8348','2014-03-14','11:35:00',5.9),('8348','2014-03-14','11:40:00',5.8),('8348','2014-03-14','11:45:00',5.86),('8348','2014-03-14','11:50:00',6.01),('8348','2014-03-14','11:55:00',6.07),('8348','2014-03-14','12:00:00',6.09),('8348','2014-03-14','12:05:00',5.98),('8348','2014-03-14','12:10:00',5.75),('8348','2014-03-14','12:15:00',5.65),('8348','2014-03-14','12:20:00',5.03),('8348','2014-03-14','12:25:00',4.06),('8348','2014-03-14','12:30:00',3.93),('8348','2014-03-14','12:35:00',3.16),('8348','2014-03-14','12:40:00',3.73),('8348','2014-03-14','12:45:00',3.92),('8348','2014-03-14','12:50:00',4.87),('8348','2014-03-14','12:55:00',5.08),('8348','2014-03-14','13:00:00',3.53),('8348','2014-03-14','13:05:00',3.12),('8348','2014-03-14','13:10:00',3.88),('8348','2014-03-14','13:15:00',4.31),('8348','2014-03-14','13:20:00',4.88),('8348','2014-03-14','13:25:00',4.52),('8348','2014-03-14','13:30:00',4.1),('8348','2014-03-14','13:35:00',3.67),('8348','2014-03-14','13:40:00',3.43),('8348','2014-03-14','13:45:00',3.6),('8348','2014-03-14','13:50:00',3.52),('8348','2014-03-14','13:55:00',3.47),('8348','2014-03-14','14:00:00',3.97),('8348','2014-03-14','14:05:00',4.45),('8348','2014-03-14','14:10:00',4.51),('8348','2014-03-14','14:15:00',4.85),('8348','2014-03-14','14:20:00',4.89),('8348','2014-03-14','14:25:00',4.95),('8348','2014-03-14','14:30:00',4.56),('8348','2014-03-14','14:35:00',4.31),('8348','2014-03-14','14:40:00',3.69),('8348','2014-03-14','14:45:00',2.96),('8348','2014-03-14','14:50:00',2.63),('8348','2014-03-14','14:55:00',2.44),('8348','2014-03-14','15:00:00',2.21),('8348','2014-03-14','15:05:00',2.18),('8348','2014-03-14','15:10:00',2.1),('8348','2014-03-14','15:15:00',2.07),('8348','2014-03-14','15:20:00',2.21),('8348','2014-03-14','15:25:00',2.47),('8348','2014-03-14','15:30:00',2.61),('8348','2014-03-14','15:35:00',2.92),('8348','2014-03-14','15:40:00',2.64),('8348','2014-03-14','15:45:00',2.36),('8348','2014-03-14','15:50:00',2.05),('8348','2014-03-14','15:55:00',2.07),('8348','2014-03-14','16:00:00',1.95),('8348','2014-03-14','16:05:00',1.92),('8348','2014-03-14','16:10:00',1.65),('8348','2014-03-14','16:15:00',1.4),('8348','2014-03-14','16:20:00',1.23),('8348','2014-03-14','16:25:00',1.14),('8348','2014-03-14','16:30:00',1.09),('8348','2014-03-14','16:35:00',1.02),('8348','2014-03-13','07:40:00',1.02),('8348','2014-03-13','07:45:00',1.12),('8348','2014-03-13','07:50:00',1.2),('8348','2014-03-13','07:55:00',1.3),('8348','2014-03-13','08:00:00',1.38),('8348','2014-03-13','08:05:00',1.49),('8348','2014-03-13','08:10:00',1.74),('8348','2014-03-13','08:15:00',1.85),('8348','2014-03-13','08:20:00',1.94),('8348','2014-03-13','08:25:00',2.02),('8348','2014-03-13','08:30:00',2.14),('8348','2014-03-13','08:35:00',2.26),('8348','2014-03-13','08:40:00',2.41),('8348','2014-03-13','08:45:00',2.5),('8348','2014-03-13','08:50:00',2.72),('8348','2014-03-13','08:55:00',3.08),('8348','2014-03-13','09:00:00',3.3),('8348','2014-03-13','09:05:00',3.44),('8348','2014-03-13','09:10:00',3.59),('8348','2014-03-13','09:15:00',3.71),('8348','2014-03-13','09:20:00',3.87),('8348','2014-03-13','09:25:00',4),('8348','2014-03-13','09:30:00',4.13),('8348','2014-03-13','09:35:00',4.25),('8348','2014-03-13','09:40:00',4.35),('8348','2014-03-13','09:45:00',4.49),('8348','2014-03-13','09:50:00',4.61),('8348','2014-03-13','09:55:00',4.72),('8348','2014-03-13','10:00:00',4.83),('8348','2014-03-13','10:05:00',4.94),('8348','2014-03-13','10:10:00',5.03),('8348','2014-03-13','10:15:00',5.12),('8348','2014-03-13','10:20:00',5.19),('8348','2014-03-13','10:25:00',5.26),('8348','2014-03-13','10:30:00',5.36),('8348','2014-03-13','10:35:00',5.44),('8348','2014-03-13','10:40:00',5.49),('8348','2014-03-13','10:45:00',5.55),('8348','2014-03-13','10:50:00',5.65),('8348','2014-03-13','10:55:00',5.7),('8348','2014-03-13','11:00:00',5.73),('8348','2014-03-13','11:05:00',5.8),('8348','2014-03-13','11:10:00',5.88),('8348','2014-03-13','11:15:00',5.92),('8348','2014-03-13','11:20:00',5.95),('8348','2014-03-13','11:25:00',5.99),('8348','2014-03-13','11:30:00',5.98),('8348','2014-03-13','11:35:00',6.02),('8348','2014-03-13','11:40:00',6.06),('8348','2014-03-13','11:45:00',6.1),('8348','2014-03-13','11:50:00',6.17),('8348','2014-03-13','11:55:00',6.23),('8348','2014-03-13','12:00:00',6.24),('8348','2014-03-13','12:05:00',6.22),('8348','2014-03-13','12:10:00',6.25),('8348','2014-03-13','12:15:00',6.27),('8348','2014-03-13','12:20:00',6.23),('8348','2014-03-13','12:25:00',6.18),('8348','2014-03-13','12:30:00',6.21),('8348','2014-03-13','12:35:00',6.21),('8348','2014-03-13','12:40:00',6.2),('8348','2014-03-13','12:45:00',6.14),('8348','2014-03-13','12:50:00',6.12),('8348','2014-03-13','12:55:00',6.09),('8348','2014-03-13','13:00:00',6.04),('8348','2014-03-13','13:05:00',6.06),('8348','2014-03-13','13:10:00',5.98),('8348','2014-03-13','13:15:00',6.1),('8348','2014-03-13','13:20:00',6.11),('8348','2014-03-13','13:25:00',6.14),('8348','2014-03-13','13:30:00',6.19),('8348','2014-03-13','13:35:00',6.16),('8348','2014-03-13','13:40:00',6.08),('8348','2014-03-13','13:45:00',6.04),('8348','2014-03-13','13:50:00',5.97),('8348','2014-03-13','13:55:00',5.9),('8348','2014-03-13','14:00:00',5.81),('8348','2014-03-13','14:05:00',5.73),('8348','2014-03-13','14:10:00',5.68),('8348','2014-03-13','14:15:00',5.66),('8348','2014-03-13','14:20:00',5.57),('8348','2014-03-13','14:25:00',5.48),('8348','2014-03-13','14:30:00',5.39),('8348','2014-03-13','14:35:00',5.32),('8348','2014-03-13','14:40:00',5.23),('8348','2014-03-13','14:45:00',5.12),('8348','2014-03-13','14:50:00',5.03),('8348','2014-03-13','14:55:00',4.91),('8348','2014-03-13','15:00:00',4.81),('8348','2014-03-13','15:05:00',4.69),('8348','2014-03-13','15:10:00',4.61),('8348','2014-03-13','15:15:00',4.51),('8348','2014-03-13','15:20:00',4.4),('8348','2014-03-13','15:25:00',4.28),('8348','2014-03-13','15:30:00',4.13),('8348','2014-03-13','15:35:00',3.99),('8348','2014-03-13','15:40:00',3.86),('8348','2014-03-13','15:45:00',3.75),('8348','2014-03-13','15:50:00',3.64),('8348','2014-03-13','15:55:00',3.49),('8348','2014-03-13','16:00:00',3.28),('8348','2014-03-13','16:05:00',3.11),('8348','2014-03-13','16:10:00',2.97),('8348','2014-03-13','16:15:00',2.81),('8348','2014-03-13','16:20:00',2.69),('8348','2014-03-13','16:25:00',2.54),('8348','2014-03-13','16:30:00',2.38),('8348','2014-03-13','16:35:00',2.24),('8348','2014-03-13','16:40:00',2.06),('8348','2014-03-13','16:45:00',1.91),('8348','2014-03-13','16:50:00',1.78),('8348','2014-03-13','16:55:00',1.64),('8348','2014-03-13','17:00:00',1.48),('8348','2014-03-13','17:05:00',1.33),('8348','2014-03-13','17:10:00',1.15),('8348','2014-03-13','17:15:00',1.01),('8348','2014-03-12','07:50:00',1.09),('8348','2014-03-12','07:55:00',1.18),('8348','2014-03-12','08:00:00',1.27),('8348','2014-03-12','08:05:00',1.37),('8348','2014-03-12','08:10:00',1.58),('8348','2014-03-12','08:15:00',1.73),('8348','2014-03-12','08:20:00',1.83),('8348','2014-03-12','08:25:00',1.93),('8348','2014-03-12','08:30:00',2.04),('8348','2014-03-12','08:35:00',2.19),('8348','2014-03-12','08:40:00',2.31),('8348','2014-03-12','08:45:00',2.42),('8348','2014-03-12','08:50:00',2.59),('8348','2014-03-12','08:55:00',2.91),('8348','2014-03-12','09:00:00',3.21),('8348','2014-03-12','09:05:00',3.37),('8348','2014-03-12','09:10:00',3.51),('8348','2014-03-12','09:15:00',3.65),('8348','2014-03-12','09:20:00',3.82),('8348','2014-03-12','09:25:00',3.98),('8348','2014-03-12','09:30:00',4.08),('8348','2014-03-12','09:35:00',4.21),('8348','2014-03-12','09:40:00',4.31),('8348','2014-03-12','09:45:00',4.42),('8348','2014-03-12','09:50:00',4.53),('8348','2014-03-12','09:55:00',4.65),('8348','2014-03-12','10:00:00',4.77),('8348','2014-03-12','10:05:00',4.88),('8348','2014-03-12','10:10:00',4.97),('8348','2014-03-12','10:15:00',5.07),('8348','2014-03-12','10:20:00',5.17),('8348','2014-03-12','10:25:00',5.24),('8348','2014-03-12','10:30:00',5.32),('8348','2014-03-12','10:35:00',5.43),('8348','2014-03-12','10:40:00',5.55),('8348','2014-03-12','10:45:00',5.64),('8348','2014-03-12','10:50:00',5.72),('8348','2014-03-12','10:55:00',5.8),('8348','2014-03-12','11:00:00',5.9),('8348','2014-03-12','11:05:00',5.96),('8348','2014-03-12','11:10:00',6.03),('8348','2014-03-12','11:15:00',6.09),('8348','2014-03-12','11:20:00',6.15),('8348','2014-03-12','11:25:00',6.19),('8348','2014-03-12','11:30:00',6.24),('8348','2014-03-12','11:35:00',6.26),('8348','2014-03-12','11:40:00',6.3),('8348','2014-03-12','11:45:00',6.31),('8348','2014-03-12','11:50:00',6.35),('8348','2014-03-12','11:55:00',6.37),('8348','2014-03-12','12:00:00',6.39),('8348','2014-03-12','12:05:00',6.38),('8348','2014-03-12','12:10:00',6.39),('8348','2014-03-12','12:15:00',6.39),('8348','2014-03-12','12:20:00',6.38),('8348','2014-03-12','12:25:00',6.37),('8348','2014-03-12','12:30:00',6.36),('8348','2014-03-12','12:35:00',6.35),('8348','2014-03-12','12:40:00',6.35),('8348','2014-03-12','12:45:00',6.39),('8348','2014-03-12','12:50:00',6.38),('8348','2014-03-12','12:55:00',6.33),('8348','2014-03-12','13:00:00',6.36),('8348','2014-03-12','13:05:00',6.28),('8348','2014-03-12','13:10:00',6.28),('8348','2014-03-12','13:15:00',6.25),('8348','2014-03-12','13:20:00',6.26),('8348','2014-03-12','13:25:00',6.18),('8348','2014-03-12','13:30:00',6.17),('8348','2014-03-12','13:35:00',6.05),('8348','2014-03-12','13:40:00',6.06),('8348','2014-03-12','13:45:00',6.02),('8348','2014-03-12','13:50:00',5.93),('8348','2014-03-12','13:55:00',5.88),('8348','2014-03-12','14:00:00',5.88),('8348','2014-03-12','14:05:00',5.85),('8348','2014-03-12','14:10:00',5.79),('8348','2014-03-12','14:15:00',5.69),('8348','2014-03-12','14:20:00',5.6),('8348','2014-03-12','14:25:00',5.51),('8348','2014-03-12','14:30:00',5.49),('8348','2014-03-12','14:35:00',5.25),('8348','2014-03-12','14:40:00',5.18),('8348','2014-03-12','14:45:00',4.99),('8348','2014-03-12','14:50:00',5.03),('8348','2014-03-12','14:55:00',4.79),('8348','2014-03-12','15:00:00',4.54),('8348','2014-03-12','15:05:00',4.59),('8348','2014-03-12','15:10:00',4.49),('8348','2014-03-12','15:15:00',4.3),('8348','2014-03-12','15:20:00',4.29),('8348','2014-03-12','15:25:00',4.1),('8348','2014-03-12','15:30:00',3.92),('8348','2014-03-12','15:35:00',3.87),('8348','2014-03-12','15:40:00',3.82),('8348','2014-03-12','15:45:00',3.72),('8348','2014-03-12','15:50:00',3.64),('8348','2014-03-12','15:55:00',3.49),('8348','2014-03-12','16:00:00',3.35),('8348','2014-03-12','16:05:00',3.2),('8348','2014-03-12','16:10:00',2.98),('8348','2014-03-12','16:15:00',2.86),('8348','2014-03-12','16:20:00',2.71),('8348','2014-03-12','16:25:00',2.52),('8348','2014-03-12','16:30:00',2.34),('8348','2014-03-12','16:35:00',2.26),('8348','2014-03-12','16:40:00',2.09),('8348','2014-03-12','16:45:00',1.91),('8348','2014-03-12','16:50:00',1.74),('8348','2014-03-12','16:55:00',1.57),('8348','2014-03-12','17:00:00',1.41),('8348','2014-03-12','17:05:00',1.24),('8348','2014-03-12','17:10:00',1.1),('8348','2014-03-11','07:55:00',1.04),('8348','2014-03-11','08:00:00',1.04),('8348','2014-03-11','10:10:00',1.04),('8348','2014-03-11','10:15:00',1.28),('8348','2014-03-11','10:20:00',1.6),('8348','2014-03-11','10:25:00',1.66),('8348','2014-03-11','10:30:00',1.71),('8348','2014-03-11','10:35:00',1.73),('8348','2014-03-11','10:40:00',1.68),('8348','2014-03-11','10:45:00',1.59),('8348','2014-03-11','10:50:00',1.47),('8348','2014-03-11','10:55:00',1.54),('8348','2014-03-11','11:00:00',1.77),('8348','2014-03-11','11:05:00',1.84),('8348','2014-03-11','11:10:00',1.86),('8348','2014-03-11','11:15:00',1.89),('8348','2014-03-11','11:20:00',1.67),('8348','2014-03-11','11:25:00',1.6),('8348','2014-03-11','11:30:00',1.52),('8348','2014-03-11','11:35:00',1.62),('8348','2014-03-11','11:40:00',1.77),('8348','2014-03-11','11:45:00',1.89),('8348','2014-03-11','11:50:00',1.67),('8348','2014-03-11','11:55:00',1.82),('8348','2014-03-11','12:00:00',1.91),('8348','2014-03-11','12:05:00',1.92),('8348','2014-03-11','12:10:00',1.97),('8348','2014-03-11','12:15:00',2.23),('8348','2014-03-11','12:20:00',2.37),('8348','2014-03-11','12:25:00',2.15),('8348','2014-03-11','12:30:00',2.09),('8348','2014-03-11','12:35:00',2.26),('8348','2014-03-11','12:40:00',2.49),('8348','2014-03-11','12:45:00',2.46),('8348','2014-03-11','12:50:00',2.35),('8348','2014-03-11','12:55:00',2.14),('8348','2014-03-11','13:00:00',2.07),('8348','2014-03-11','13:05:00',2.34),('8348','2014-03-11','13:10:00',2.35),('8348','2014-03-11','13:15:00',2.29),('8348','2014-03-11','13:20:00',2.4),('8348','2014-03-11','13:25:00',2.07),('8348','2014-03-11','13:30:00',1.98),('8348','2014-03-11','13:35:00',1.9),('8348','2014-03-11','13:40:00',1.98),('8348','2014-03-11','13:45:00',2.45),('8348','2014-03-11','13:50:00',2.84),('8348','2014-03-11','13:55:00',3.43),('8348','2014-03-11','14:00:00',3.46),('8348','2014-03-11','14:05:00',3.61),('8348','2014-03-11','14:10:00',4.25),('8348','2014-03-11','14:15:00',4.03),('8348','2014-03-11','14:20:00',3.76),('8348','2014-03-11','14:25:00',3.3),('8348','2014-03-11','14:30:00',2.57),('8348','2014-03-11','14:35:00',2.7),('8348','2014-03-11','14:40:00',2.63),('8348','2014-03-11','14:45:00',2.85),('8348','2014-03-11','14:50:00',2.54),('8348','2014-03-11','14:55:00',2.5),('8348','2014-03-11','15:00:00',2.86),('8348','2014-03-11','15:05:00',3.06),('8348','2014-03-11','15:10:00',3.24),('8348','2014-03-11','15:15:00',2.95),('8348','2014-03-11','15:20:00',3.03),('8348','2014-03-11','15:25:00',2.61),('8348','2014-03-11','15:30:00',2.38),('8348','2014-03-11','15:35:00',2.09),('8348','2014-03-11','15:40:00',2.02),('8348','2014-03-11','15:45:00',1.91),('8348','2014-03-11','15:50:00',1.87),('8348','2014-03-11','15:55:00',1.51),('8348','2014-03-11','16:00:00',1.38),('8348','2014-03-11','16:05:00',1.34),('8348','2014-03-11','16:10:00',1.39),('8348','2014-03-11','16:15:00',1.33),('8348','2014-03-11','16:20:00',1.32),('8348','2014-03-11','16:25:00',1.16),('8348','2014-03-11','16:30:00',1.07),('8348','2014-03-10','08:15:00',1),('8348','2014-03-10','08:20:00',1.08),('8348','2014-03-10','08:25:00',1.18),('8348','2014-03-10','08:30:00',1.28),('8348','2014-03-10','08:35:00',1.46),('8348','2014-03-10','08:40:00',1.58),('8348','2014-03-10','08:45:00',1.57),('8348','2014-03-10','08:50:00',1.63),('8348','2014-03-10','08:55:00',1.65),('8348','2014-03-10','09:00:00',1.69),('8348','2014-03-10','09:05:00',1.8),('8348','2014-03-10','09:10:00',1.85),('8348','2014-03-10','09:15:00',1.85),('8348','2014-03-10','09:20:00',1.78),('8348','2014-03-10','09:25:00',1.78),('8348','2014-03-10','09:30:00',1.84),('8348','2014-03-10','09:35:00',1.87),('8348','2014-03-10','09:40:00',1.92),('8348','2014-03-10','09:45:00',1.73),('8348','2014-03-10','09:50:00',1.49),('8348','2014-03-10','09:55:00',1.38),('8348','2014-03-10','10:00:00',1.25),('8348','2014-03-10','10:05:00',1.44),('8348','2014-03-10','10:10:00',1.81),('8348','2014-03-10','10:15:00',2.11),('8348','2014-03-10','10:20:00',1.68),('8348','2014-03-10','10:25:00',1.61),('8348','2014-03-10','10:30:00',1.97),('8348','2014-03-10','10:35:00',2.15),('8348','2014-03-10','10:40:00',1.46),('8348','2014-03-10','11:10:00',1.27),('8348','2014-03-10','11:15:00',1.61),('8348','2014-03-10','11:20:00',1.76),('8348','2014-03-10','11:25:00',1.64),('8348','2014-03-10','11:30:00',1.46),('8348','2014-03-10','12:20:00',1.04),('8348','2014-03-10','12:25:00',1.1),('8348','2014-03-10','12:30:00',1.23),('8348','2014-03-10','12:35:00',1.42),('8348','2014-03-10','12:40:00',1.59),('8348','2014-03-10','12:45:00',1.81),('8348','2014-03-10','12:50:00',1.99),('8348','2014-03-10','12:55:00',2.12),('8348','2014-03-10','13:00:00',2.22),('8348','2014-03-10','13:05:00',2.27),('8348','2014-03-10','13:10:00',2.42),('8348','2014-03-10','13:15:00',2.63),('8348','2014-03-10','13:20:00',2.61),('8348','2014-03-10','13:25:00',2.28),('8348','2014-03-10','13:30:00',1.91),('8348','2014-03-10','13:35:00',1.59),('8348','2014-03-10','13:40:00',1.44),('8348','2014-03-10','13:45:00',1.37),('8348','2014-03-10','13:50:00',2.05),('8348','2014-03-10','13:55:00',2.16),('8348','2014-03-10','14:00:00',2.12),('8348','2014-03-10','14:05:00',3.14),('8348','2014-03-10','14:10:00',4.11),('8348','2014-03-10','14:15:00',5.74),('8348','2014-03-10','14:20:00',4.05),('8348','2014-03-10','14:25:00',3.01),('8348','2014-03-10','14:30:00',2.32),('8348','2014-03-10','14:35:00',3.53),('8348','2014-03-10','14:40:00',4.75),('8348','2014-03-10','14:45:00',4.37),('8348','2014-03-10','14:50:00',4.52),('8348','2014-03-10','14:55:00',2.38),('8348','2014-03-10','15:00:00',2.88),('8348','2014-03-10','15:05:00',2.29),('8348','2014-03-10','15:10:00',1.81),('8348','2014-03-10','15:15:00',2.78),('8348','2014-03-10','15:20:00',3.58),('8348','2014-03-10','15:25:00',3.8),('8348','2014-03-10','15:30:00',3.56),('8348','2014-03-10','15:35:00',2.07),('8348','2014-03-10','15:40:00',1.77),('8348','2014-03-10','15:45:00',1.27),('8348','2014-03-10','15:50:00',1.57),('8348','2014-03-10','15:55:00',1.54),('8348','2014-03-10','16:00:00',1.53),('8348','2014-03-10','16:05:00',1.78),('8348','2014-03-10','16:10:00',1.52),('8348','2014-03-10','16:15:00',1.29),('8348','2014-03-10','16:20:00',1.39),('8348','2014-03-10','16:25:00',1.88),('8348','2014-03-10','16:30:00',2.24),('8348','2014-03-10','16:35:00',1.52),('8348','2014-03-10','16:40:00',1.02),('8348','2014-03-10','16:55:00',1.54),('8348','2014-03-10','17:00:00',1.28),('8348','2014-03-10','17:05:00',1.03),('8348','2014-03-09','07:50:00',1.04),('8348','2014-03-09','07:55:00',1.13),('8348','2014-03-09','08:00:00',1.23),('8348','2014-03-09','08:05:00',1.3),('8348','2014-03-09','08:10:00',1.4),('8348','2014-03-09','08:15:00',1.61),('8348','2014-03-09','08:20:00',1.69),('8348','2014-03-09','08:25:00',1.7),('8348','2014-03-09','08:30:00',1.6),('8348','2014-03-09','08:35:00',1.42),('8348','2014-03-09','08:40:00',1.54),('8348','2014-03-09','08:45:00',1.52),('8348','2014-03-09','08:50:00',1.25),('8348','2014-03-09','08:55:00',2.1),('8348','2014-03-09','09:00:00',2.69),('8348','2014-03-09','09:05:00',2.1),('8348','2014-03-09','09:10:00',1.25),('8348','2014-03-09','09:15:00',3.53),('8348','2014-03-09','09:20:00',3.72),('8348','2014-03-09','09:25:00',3.82),('8348','2014-03-09','09:30:00',4.29),('8348','2014-03-09','09:35:00',4.57),('8348','2014-03-09','09:40:00',4.73),('8348','2014-03-09','09:45:00',4.85),('8348','2014-03-09','09:50:00',4.89),('8348','2014-03-09','09:55:00',4.9),('8348','2014-03-09','10:00:00',4.95),('8348','2014-03-09','10:05:00',5.03),('8348','2014-03-09','10:10:00',5.2),('8348','2014-03-09','10:15:00',5.24),('8348','2014-03-09','10:20:00',5.24),('8348','2014-03-09','10:25:00',4.51),('8348','2014-03-09','10:30:00',5.49),('8348','2014-03-09','10:35:00',5.55),('8348','2014-03-09','10:40:00',5.63),('8348','2014-03-09','10:45:00',5.71),('8348','2014-03-09','10:50:00',5.86),('8348','2014-03-09','10:55:00',6.08),('8348','2014-03-09','11:00:00',6.5),('8348','2014-03-09','11:05:00',6.6),('8348','2014-03-09','11:10:00',6.79),('8348','2014-03-09','11:15:00',6.8),('8348','2014-03-09','11:20:00',4.16),('8348','2014-03-09','11:25:00',4.86),('8348','2014-03-09','11:30:00',2.6),('8348','2014-03-09','11:35:00',3.76),('8348','2014-03-09','11:40:00',3.6),('8348','2014-03-09','11:45:00',3.56),('8348','2014-03-09','11:50:00',5.39),('8348','2014-03-09','11:55:00',5.77),('8348','2014-03-09','12:00:00',7.37),('8348','2014-03-09','12:05:00',7.53),('8348','2014-03-09','12:10:00',7.44),('8348','2014-03-09','12:15:00',7.39),('8348','2014-03-09','12:20:00',7.32),('8348','2014-03-09','12:25:00',7.17),('8348','2014-03-09','12:30:00',7.24),('8348','2014-03-09','12:35:00',7.41),('8348','2014-03-09','12:40:00',7.01),('8348','2014-03-09','12:45:00',6.84),('8348','2014-03-09','12:50:00',6.95),('8348','2014-03-09','12:55:00',7.04),('8348','2014-03-09','13:00:00',7.18),('8348','2014-03-09','13:05:00',7.24),('8348','2014-03-09','13:10:00',7.25),('8348','2014-03-09','13:15:00',6.77),('8348','2014-03-09','13:20:00',6.62),('8348','2014-03-09','13:25:00',6.52),('8348','2014-03-09','13:30:00',5.84),('8348','2014-03-09','13:35:00',5.76),('8348','2014-03-09','13:40:00',1.61),('8348','2014-03-09','13:45:00',2.48),('8348','2014-03-09','13:50:00',5.74),('8348','2014-03-09','13:55:00',1.68),('8348','2014-03-09','14:00:00',5.56),('8348','2014-03-09','14:05:00',6.26),('8348','2014-03-09','14:10:00',6.11),('8348','2014-03-09','14:15:00',5.97),('8348','2014-03-09','14:20:00',3.77),('8348','2014-03-09','14:25:00',4.44),('8348','2014-03-09','14:30:00',1.67),('8348','2014-03-09','14:35:00',1.72),('8348','2014-03-09','14:40:00',1.79),('8348','2014-03-09','14:45:00',4.6),('8348','2014-03-09','14:50:00',3.25),('8348','2014-03-09','14:55:00',5.33),('8348','2014-03-09','15:00:00',5.16),('8348','2014-03-09','15:05:00',3.8),('8348','2014-03-09','15:10:00',4.93),('8348','2014-03-09','15:15:00',4.73),('8348','2014-03-09','15:20:00',4.67),('8348','2014-03-09','15:25:00',4.63),('8348','2014-03-09','15:30:00',4.52),('8348','2014-03-09','15:35:00',4.33),('8348','2014-03-09','15:40:00',4.07),('8348','2014-03-09','15:45:00',3.58),('8348','2014-03-09','15:50:00',1.17),('8348','2014-03-09','15:55:00',2.74),('8348','2014-03-09','16:00:00',3.51),('8348','2014-03-09','16:05:00',3.25),('8348','2014-03-09','16:10:00',2.58),('8348','2014-03-09','16:15:00',2.42),('8348','2014-03-09','16:20:00',2.23),('8348','2014-03-09','16:25:00',2.54),('8348','2014-03-09','16:30:00',2.41),('8348','2014-03-09','16:35:00',2.35),('8348','2014-03-09','16:40:00',2.3),('8348','2014-03-09','16:45:00',1.97),('8348','2014-03-09','16:50:00',1.77),('8348','2014-03-09','16:55:00',1.6),('8348','2014-03-09','17:00:00',1.39),('8348','2014-03-09','17:05:00',1.21),('8348','2014-03-09','17:10:00',1.07),('8348','2014-03-08','07:50:00',1.01),('8348','2014-03-08','07:55:00',1.09),('8348','2014-03-08','08:00:00',1.19),('8348','2014-03-08','08:05:00',1.28),('8348','2014-03-08','08:10:00',1.37),('8348','2014-03-08','08:15:00',1.53),('8348','2014-03-08','08:20:00',1.73),('8348','2014-03-08','08:25:00',1.84),('8348','2014-03-08','08:30:00',1.95),('8348','2014-03-08','08:35:00',2.05),('8348','2014-03-08','08:40:00',2.19),('8348','2014-03-08','08:45:00',2.32),('8348','2014-03-08','08:50:00',2.43),('8348','2014-03-08','08:55:00',2.56),('8348','2014-03-08','09:00:00',2.92),('8348','2014-03-08','09:05:00',3.2),('8348','2014-03-08','09:10:00',3.36),('8348','2014-03-08','09:15:00',3.47),('8348','2014-03-08','09:20:00',3.63),('8348','2014-03-08','09:25:00',3.81),('8348','2014-03-08','09:30:00',3.98),('8348','2014-03-08','09:35:00',4.09),('8348','2014-03-08','09:40:00',4.21),('8348','2014-03-08','09:45:00',4.33),('8348','2014-03-08','09:50:00',4.46),('8348','2014-03-08','09:55:00',4.58),('8348','2014-03-08','10:00:00',4.68),('8348','2014-03-08','10:05:00',4.78),('8348','2014-03-08','10:10:00',4.88),('8348','2014-03-08','10:15:00',4.98),('8348','2014-03-08','10:20:00',5.08),('8348','2014-03-08','10:25:00',5.18),('8348','2014-03-08','10:30:00',5.33),('8348','2014-03-08','10:35:00',5.42),('8348','2014-03-08','10:40:00',5.5),('8348','2014-03-08','10:45:00',5.57),('8348','2014-03-08','10:50:00',5.65),('8348','2014-03-08','10:55:00',5.71),('8348','2014-03-08','11:00:00',5.78),('8348','2014-03-08','11:05:00',5.84),('8348','2014-03-08','11:10:00',5.92),('8348','2014-03-08','11:15:00',6.01),('8348','2014-03-08','11:20:00',6.16),('8348','2014-03-08','11:25:00',6.34),('8348','2014-03-08','11:30:00',6.59),('8348','2014-03-08','11:35:00',5.43),('8348','2014-03-08','11:40:00',3.72),('8348','2014-03-08','11:45:00',2.3),('8348','2014-03-08','11:50:00',2.55),('8348','2014-03-08','11:55:00',5.26),('8348','2014-03-08','12:00:00',3.99),('8348','2014-03-08','12:05:00',1.91),('8348','2014-03-08','12:10:00',2.03),('8348','2014-03-08','12:15:00',2.14),('8348','2014-03-08','12:20:00',2.39),('8348','2014-03-08','12:25:00',2.63),('8348','2014-03-08','12:30:00',2.8),('8348','2014-03-08','12:35:00',6.05),('8348','2014-03-08','12:40:00',3.39),('8348','2014-03-08','12:45:00',3.81),('8348','2014-03-08','12:50:00',3.68),('8348','2014-03-08','12:55:00',5.05),('8348','2014-03-08','13:00:00',3.61),('8348','2014-03-08','13:05:00',3.02),('8348','2014-03-08','13:10:00',2.66),('8348','2014-03-08','13:15:00',2.12),('8348','2014-03-08','13:20:00',1.8),('8348','2014-03-08','13:25:00',1.82),('8348','2014-03-08','13:30:00',2.87),('8348','2014-03-08','13:35:00',2.97),('8348','2014-03-08','13:40:00',3.77),('8348','2014-03-08','13:45:00',4.66),('8348','2014-03-08','13:50:00',3.67),('8348','2014-03-08','13:55:00',2.55),('8348','2014-03-08','14:00:00',2.02),('8348','2014-03-08','14:05:00',1.86),('8348','2014-03-08','14:10:00',1.71),('8348','2014-03-08','14:15:00',1.42),('8348','2014-03-08','14:20:00',1.36),('8348','2014-03-08','14:25:00',1.32),('8348','2014-03-08','14:30:00',1.45),('8348','2014-03-08','14:35:00',1.72),('8348','2014-03-08','14:40:00',1.82),('8348','2014-03-08','14:45:00',1.71),('8348','2014-03-08','14:50:00',1.76),('8348','2014-03-08','14:55:00',1.88),('8348','2014-03-08','15:00:00',1.65),('8348','2014-03-08','15:05:00',1.47),('8348','2014-03-08','15:10:00',1.59),('8348','2014-03-08','15:15:00',2.09),('8348','2014-03-08','15:20:00',2.91),('8348','2014-03-08','15:25:00',2.9),('8348','2014-03-08','15:30:00',2.34),('8348','2014-03-08','15:35:00',1.28),('8348','2014-03-08','15:40:00',1.14),('8348','2014-03-08','15:45:00',1.19),('8348','2014-03-08','15:50:00',1.43),('8348','2014-03-08','15:55:00',1.57),('8348','2014-03-08','16:00:00',1.79),('8348','2014-03-08','16:05:00',2.19),('8348','2014-03-08','16:10:00',1.25),('8348','2014-03-08','16:15:00',1.2),('8348','2014-03-08','16:20:00',1.3),('8348','2014-03-08','16:25:00',1.22),('8348','2014-03-08','16:30:00',1.97),('8348','2014-03-08','16:35:00',2.56),('8348','2014-03-08','16:40:00',2.21),('8348','2014-03-08','16:45:00',2.04),('8348','2014-03-08','16:50:00',1.88),('8348','2014-03-08','16:55:00',1.65),('8348','2014-03-08','17:00:00',1.5),('8348','2014-03-08','17:05:00',1.35),('8348','2014-03-08','17:10:00',1.2),('8348','2014-03-08','17:15:00',1.07),('8348','2014-04-30','06:40:00',1.07),('8348','2014-04-30','06:45:00',1.16),('8348','2014-04-30','06:50:00',1.25),('8348','2014-04-30','06:55:00',1.47),('8348','2014-04-30','07:00:00',1.59),('8348','2014-04-30','07:05:00',1.64),('8348','2014-04-30','07:10:00',1.81),('8348','2014-04-30','07:15:00',1.93),('8348','2014-04-30','07:20:00',2.03),('8348','2014-04-30','07:25:00',2.12),('8348','2014-04-30','07:30:00',2.24),('8348','2014-04-30','07:35:00',2.41),('8348','2014-04-30','07:40:00',2.66),('8348','2014-04-30','07:45:00',2.97),('8348','2014-04-30','07:50:00',3.17),('8348','2014-04-30','07:55:00',3.47),('8348','2014-04-30','08:00:00',3.78),('8348','2014-04-30','08:05:00',4.09),('8348','2014-04-30','08:10:00',4.4),('8348','2014-04-30','08:15:00',2.85),('8348','2014-04-30','08:20:00',1.7),('8348','2014-04-30','08:25:00',2.37),('8348','2014-04-30','08:30:00',3.45),('8348','2014-04-30','08:35:00',4.24),('8348','2014-04-30','08:40:00',5.16),('8348','2014-04-30','08:45:00',5.08),('8348','2014-04-30','08:50:00',2.84),('8348','2014-04-30','08:55:00',4.72),('8348','2014-04-30','09:00:00',6.12),('8348','2014-04-30','09:05:00',5.68),('8348','2014-04-30','09:10:00',3.95),('8348','2014-04-30','09:15:00',6.31),('8348','2014-04-30','09:20:00',3.37),('8348','2014-04-30','09:25:00',2.86),('8348','2014-04-30','09:30:00',3.16),('8348','2014-04-30','09:35:00',4.18),('8348','2014-04-30','09:40:00',3.85),('8348','2014-04-30','09:45:00',3.07),('8348','2014-04-30','09:50:00',2.95),('8348','2014-04-30','09:55:00',6.9),('8348','2014-04-30','10:00:00',6.92),('8348','2014-04-30','10:05:00',7.09),('8348','2014-04-30','10:10:00',6.16),('8348','2014-04-30','10:15:00',4.77),('8348','2014-04-30','10:20:00',3.69),('8348','2014-04-30','10:25:00',4.92),('8348','2014-04-30','10:30:00',3.88),('8348','2014-04-30','10:35:00',4.54),('8348','2014-04-30','10:40:00',4.22),('8348','2014-04-30','10:45:00',5.26),('8348','2014-04-30','10:50:00',6.5),('8348','2014-04-30','10:55:00',4.75),('8348','2014-04-30','11:00:00',4.62),('8348','2014-04-30','11:05:00',2.68),('8348','2014-04-30','11:10:00',2.53),('8348','2014-04-30','11:15:00',3.55),('8348','2014-04-30','11:20:00',3.41),('8348','2014-04-30','11:25:00',2.59),('8348','2014-04-30','11:30:00',2.54),('8348','2014-04-30','11:35:00',2.65),('8348','2014-04-30','11:40:00',2.26),('8348','2014-04-30','11:45:00',2.73),('8348','2014-04-30','11:50:00',2.97),('8348','2014-04-30','11:55:00',8.51),('8348','2014-04-30','12:00:00',7.11),('8348','2014-04-30','12:05:00',7.86),('8348','2014-04-30','12:10:00',7.92),('8348','2014-04-30','12:15:00',3.62),('8348','2014-04-30','12:20:00',3.7),('8348','2014-04-30','12:25:00',5.01),('8348','2014-04-30','12:30:00',3.1),('8348','2014-04-30','12:35:00',3.98),('8348','2014-04-30','12:40:00',6.92),('8348','2014-04-30','12:45:00',6.2),('8348','2014-04-30','12:50:00',7.02),('8348','2014-04-30','12:55:00',7.78),('8348','2014-04-30','13:00:00',3.66),('8348','2014-04-30','13:05:00',3.35),('8348','2014-04-30','13:10:00',3.03),('8348','2014-04-30','13:15:00',3.6),('8348','2014-04-30','13:20:00',6.26),('8348','2014-04-30','13:25:00',6.56),('8348','2014-04-30','13:30:00',8.32),('8348','2014-04-30','13:35:00',7.76),('8348','2014-04-30','13:40:00',3.95),('8348','2014-04-30','13:45:00',2.59),('8348','2014-04-30','13:50:00',3.17),('8348','2014-04-30','13:55:00',3.44),('8348','2014-04-30','14:00:00',2.81),('8348','2014-04-30','14:05:00',2.8),('8348','2014-04-30','14:10:00',2.77),('8348','2014-04-30','14:15:00',2.42),('8348','2014-04-30','14:20:00',2.39),('8348','2014-04-30','14:25:00',2.76),('8348','2014-04-30','14:30:00',3.38),('8348','2014-04-30','14:35:00',5.68),('8348','2014-04-30','14:40:00',7.81),('8348','2014-04-30','14:45:00',7.33),('8348','2014-04-30','14:50:00',5.63),('8348','2014-04-30','14:55:00',4.44),('8348','2014-04-30','15:00:00',2.61),('8348','2014-04-30','15:05:00',3.66),('8348','2014-04-30','15:10:00',3.32),('8348','2014-04-30','15:15:00',3.8),('8348','2014-04-30','15:20:00',2.98),('8348','2014-04-30','15:25:00',3.36),('8348','2014-04-30','15:30:00',4.41),('8348','2014-04-30','15:35:00',2.51),('8348','2014-04-30','15:40:00',4.08),('8348','2014-04-30','15:45:00',5.4),('8348','2014-04-30','15:50:00',6.17),('8348','2014-04-30','15:55:00',4.67),('8348','2014-04-30','16:00:00',3.22),('8348','2014-04-30','16:05:00',4.38),('8348','2014-04-30','16:10:00',2.23),('8348','2014-04-30','16:15:00',1.63),('8348','2014-04-30','16:20:00',2.52),('8348','2014-04-30','16:25:00',1.44),('8348','2014-04-30','16:30:00',1.38),('8348','2014-04-30','16:35:00',1.87),('8348','2014-04-30','16:40:00',2.05),('8348','2014-04-30','16:45:00',1.47),('8348','2014-04-30','16:50:00',1.46),('8348','2014-04-30','16:55:00',1.38),('8348','2014-04-30','17:00:00',1.01),('8348','2014-04-30','17:35:00',1.07),('8348','2014-04-30','17:40:00',1.01),('8348','2014-04-30','17:45:00',1.07),('8348','2014-03-07','09:35:00',1.18),('8348','2014-03-07','09:40:00',1.08),('8348','2014-03-07','09:55:00',1.25),('8348','2014-03-07','10:00:00',1.2),('8348','2014-03-07','10:05:00',1.12),('8348','2014-03-07','10:10:00',1.15),('8348','2014-03-07','10:15:00',1.06),('8348','2014-03-07','10:20:00',1.28),('8348','2014-03-07','10:25:00',1.16),('8348','2014-03-07','10:30:00',1.3),('8348','2014-03-07','10:35:00',1.37),('8348','2014-03-07','10:40:00',1.23),('8348','2014-03-07','10:45:00',1.21),('8348','2014-03-07','10:50:00',1.33),('8348','2014-03-07','10:55:00',1.45),('8348','2014-03-07','11:00:00',1.64),('8348','2014-03-07','11:05:00',1.32),('8348','2014-03-07','11:10:00',1.09),('8348','2014-03-07','11:15:00',1.26),('8348','2014-03-07','11:20:00',1.65),('8348','2014-03-07','11:25:00',1.66),('8348','2014-03-07','11:30:00',1.75),('8348','2014-03-07','11:35:00',1.68),('8348','2014-03-07','11:40:00',1.54),('8348','2014-03-07','11:45:00',3.06),('8348','2014-03-07','11:50:00',4.39),('8348','2014-03-07','11:55:00',6.82),('8348','2014-03-07','12:00:00',7.84),('8348','2014-03-07','12:05:00',5.32),('8348','2014-03-07','12:10:00',7.28),('8348','2014-03-07','12:15:00',6.95),('8348','2014-03-07','12:20:00',7.02),('8348','2014-03-07','12:25:00',6.97),('8348','2014-03-07','12:30:00',6.97),('8348','2014-03-07','12:35:00',6.79),('8348','2014-03-07','12:40:00',4.54),('8348','2014-03-07','12:45:00',2.04),('8348','2014-03-07','12:50:00',2.56),('8348','2014-03-07','12:55:00',1.27),('8348','2014-03-07','13:00:00',2.02),('8348','2014-03-07','13:05:00',4.39),('8348','2014-03-07','13:10:00',1.88),('8348','2014-03-07','13:15:00',1.92),('8348','2014-03-07','13:20:00',3.81),('8348','2014-03-07','13:25:00',5.07),('8348','2014-03-07','13:30:00',4.41),('8348','2014-03-07','13:35:00',4.52),('8348','2014-03-07','13:40:00',4.65),('8348','2014-03-07','13:45:00',3.86),('8348','2014-03-07','13:50:00',2.71),('8348','2014-03-07','13:55:00',2.19),('8348','2014-03-07','14:00:00',2.08),('8348','2014-03-07','14:05:00',1.99),('8348','2014-03-07','14:10:00',2.02),('8348','2014-03-07','14:15:00',2.01),('8348','2014-03-07','14:20:00',1.97),('8348','2014-03-07','14:25:00',1.91),('8348','2014-03-07','14:30:00',2.03),('8348','2014-03-07','14:35:00',2.1),('8348','2014-03-07','14:40:00',2.21),('8348','2014-03-07','14:45:00',2.23),('8348','2014-03-07','14:50:00',2.82),('8348','2014-03-07','14:55:00',4.11),('8348','2014-03-07','15:00:00',4.98),('8348','2014-03-07','15:05:00',5.49),('8348','2014-03-07','15:10:00',5.6),('8348','2014-03-07','15:15:00',5.66),('8348','2014-03-07','15:20:00',5.76),('8348','2014-03-07','15:25:00',5.61),('8348','2014-03-07','15:30:00',5.49),('8348','2014-03-07','15:35:00',5.16),('8348','2014-03-07','15:40:00',4.77),('8348','2014-03-07','15:45:00',4.42),('8348','2014-03-07','15:50:00',3.16),('8348','2014-03-07','15:55:00',1.74),('8348','2014-03-07','16:00:00',3.34),('8348','2014-03-07','16:05:00',3.38),('8348','2014-03-07','16:10:00',3.33),('8348','2014-03-07','16:15:00',3.31),('8348','2014-03-07','16:20:00',3.02),('8348','2014-03-07','16:25:00',2.88),('8348','2014-03-07','16:30:00',2.68),('8348','2014-03-07','16:35:00',2.56),('8348','2014-03-07','16:40:00',2.6),('8348','2014-03-07','16:45:00',2.47),('8348','2014-03-07','16:50:00',2.3),('8348','2014-03-07','16:55:00',2.16),('8348','2014-03-07','17:00:00',2.02),('8348','2014-03-07','17:05:00',1.81),('8348','2014-03-07','17:10:00',1.6),('8348','2014-03-07','17:15:00',1.37),('8348','2014-03-07','17:20:00',1.15),('8348','2014-03-06','08:00:00',1.62),('8348','2014-03-06','08:05:00',1.53),('8348','2014-03-06','08:10:00',1.99),('8348','2014-03-06','08:15:00',2.41),('8348','2014-03-06','08:20:00',2.19),('8348','2014-03-06','08:25:00',1.96),('8348','2014-03-06','08:30:00',1.34),('8348','2014-03-06','08:35:00',1.15),('8348','2014-03-06','08:40:00',1.09),('8348','2014-03-06','08:45:00',1.41),('8348','2014-03-06','08:50:00',1.5),('8348','2014-03-06','08:55:00',1.49),('8348','2014-03-06','09:00:00',1.57),('8348','2014-03-06','09:05:00',1.43),('8348','2014-03-06','09:10:00',1.43),('8348','2014-03-06','09:15:00',1.69),('8348','2014-03-06','09:20:00',1.87),('8348','2014-03-06','09:25:00',1.63),('8348','2014-03-06','09:30:00',1.65),('8348','2014-03-06','09:35:00',1.92),('8348','2014-03-06','09:50:00',3.04),('8348','2014-03-06','09:55:00',3.24),('8348','2014-03-06','10:00:00',3.39),('8348','2014-03-06','10:05:00',3.8),('8348','2014-03-06','10:10:00',4.25),('8348','2014-03-06','10:15:00',4.79),('8348','2014-03-06','10:20:00',4.99),('8348','2014-03-06','10:25:00',3.54),('8348','2014-03-06','10:30:00',1.72),('8348','2014-03-06','10:35:00',2.57),('8348','2014-03-06','10:40:00',3.29),('8348','2014-03-06','10:45:00',2.01),('8348','2014-03-06','10:50:00',2.46),('8348','2014-03-06','10:55:00',2.62),('8348','2014-03-06','11:00:00',4.69),('8348','2014-03-06','11:05:00',5.74),('8348','2014-03-06','11:10:00',4.34),('8348','2014-03-06','11:15:00',4.43),('8348','2014-03-06','11:20:00',3.6),('8348','2014-03-06','11:25:00',3.5),('8348','2014-03-06','11:30:00',2.69),('8348','2014-03-06','11:35:00',2.28),('8348','2014-03-06','11:40:00',2.99),('8348','2014-03-06','11:45:00',6.69),('8348','2014-03-06','11:50:00',4.11),('8348','2014-03-06','11:55:00',5.19),('8348','2014-03-06','12:00:00',2.57),('8348','2014-03-06','12:05:00',5.08),('8348','2014-03-06','12:10:00',7.95),('8348','2014-03-06','12:15:00',6.46),('8348','2014-03-06','12:20:00',2.83),('8348','2014-03-06','12:25:00',5.66),('8348','2014-03-06','12:30:00',7.56),('8348','2014-03-06','12:35:00',3.19),('8348','2014-03-06','12:40:00',1.3),('8348','2014-03-06','12:55:00',2.26),('8348','2014-03-06','13:00:00',2.6),('8348','2014-03-06','13:05:00',2.46),('8348','2014-03-06','13:10:00',2.29),('8348','2014-03-06','13:15:00',2.59),('8348','2014-03-06','13:20:00',2),('8348','2014-03-06','13:25:00',1.84),('8348','2014-03-06','13:30:00',2),('8348','2014-03-06','13:35:00',1.95),('8348','2014-03-06','13:40:00',2.16),('8348','2014-03-06','13:45:00',1.89),('8348','2014-03-06','13:50:00',1.76),('8348','2014-03-06','13:55:00',1.61),('8348','2014-03-06','14:00:00',1.65),('8348','2014-03-06','14:05:00',1.96),('8348','2014-03-06','14:10:00',1.96),('8348','2014-03-06','14:15:00',1.87),('8348','2014-03-06','14:20:00',2.14),('8348','2014-03-06','14:25:00',1.98),('8348','2014-03-06','14:30:00',1.88),('8348','2014-03-06','14:35:00',3.59),('8348','2014-03-06','14:40:00',2.09),('8348','2014-03-06','14:45:00',1.41),('8348','2014-03-06','14:50:00',1.56),('8348','2014-03-06','14:55:00',1.55),('8348','2014-03-06','15:00:00',1.73),('8348','2014-03-06','15:05:00',2.23),('8348','2014-03-06','15:10:00',2.54),('8348','2014-03-06','15:15:00',1.49),('8348','2014-03-06','15:20:00',1.17),('8348','2014-03-06','15:25:00',1.13),('8348','2014-03-06','15:30:00',1.16),('8348','2014-03-06','15:35:00',1.22),('8348','2014-03-06','15:40:00',1.06),('8348','2014-03-06','16:00:00',1.19),('8348','2014-03-06','16:05:00',1.18),('8348','2014-03-06','16:10:00',1.08),('8348','2014-03-06','16:15:00',1.08),('8348','2014-03-06','16:20:00',1.2),('8348','2014-03-06','16:25:00',1.2),('8348','2014-03-06','16:30:00',1.77),('8348','2014-03-06','16:45:00',1.76),('8348','2014-03-06','16:50:00',1.94),('8348','2014-03-06','16:55:00',1.84),('8348','2014-03-06','17:00:00',1.48),('8348','2014-03-06','17:10:00',1.47),('8348','2014-03-06','17:15:00',1.21),('8348','2014-03-05','07:35:00',1.1),('8348','2014-03-05','07:40:00',1.22),('8348','2014-03-05','07:45:00',1.33),('8348','2014-03-05','07:50:00',1.43),('8348','2014-03-05','07:55:00',1.51),('8348','2014-03-05','08:00:00',1.53),('8348','2014-03-05','08:05:00',1.5),('8348','2014-03-05','08:10:00',1.6),('8348','2014-03-05','08:15:00',1.69),('8348','2014-03-05','08:20:00',1.02),('8348','2014-03-05','08:30:00',1.84),('8348','2014-03-05','08:35:00',2.83),('8348','2014-03-05','08:40:00',2.69),('8348','2014-03-05','08:45:00',2.73),('8348','2014-03-05','08:50:00',1.31),('8348','2014-03-05','08:55:00',1.1),('8348','2014-03-05','09:00:00',3.21),('8348','2014-03-05','09:05:00',2.06),('8348','2014-03-05','09:10:00',1.86),('8348','2014-03-05','09:15:00',3.49),('8348','2014-03-05','09:20:00',3.77),('8348','2014-03-05','09:25:00',3.83),('8348','2014-03-05','09:30:00',3.97),('8348','2014-03-05','09:35:00',3.79),('8348','2014-03-05','09:40:00',4.29),('8348','2014-03-05','09:45:00',4.4),('8348','2014-03-05','09:50:00',4.47),('8348','2014-03-05','09:55:00',4.58),('8348','2014-03-05','10:00:00',4.66),('8348','2014-03-05','10:05:00',4.76),('8348','2014-03-05','10:10:00',4.9),('8348','2014-03-05','10:15:00',4.98),('8348','2014-03-05','10:20:00',5.04),('8348','2014-03-05','10:25:00',5.14),('8348','2014-03-05','10:30:00',5.21),('8348','2014-03-05','10:35:00',5.3),('8348','2014-03-05','10:40:00',5.36),('8348','2014-03-05','10:45:00',5.43),('8348','2014-03-05','10:50:00',5.53),('8348','2014-03-05','10:55:00',5.6),('8348','2014-03-05','11:00:00',5.71),('8348','2014-03-05','11:05:00',5.85),('8348','2014-03-05','11:10:00',5.91),('8348','2014-03-05','11:15:00',6.03),('8348','2014-03-05','11:20:00',6.11),('8348','2014-03-05','11:25:00',6.17),('8348','2014-03-05','11:30:00',6.32),('8348','2014-03-05','11:35:00',6.73),('8348','2014-03-05','11:40:00',6.32),('8348','2014-03-05','11:45:00',6.53),('8348','2014-03-05','11:50:00',6.46),('8348','2014-03-05','11:55:00',5.61),('8348','2014-03-05','12:00:00',5.89),('8348','2014-03-05','12:05:00',4.75),('8348','2014-03-05','12:10:00',3.52),('8348','2014-03-05','12:15:00',1.62),('8348','2014-03-05','12:20:00',1.42),('8348','2014-03-05','12:25:00',1.44),('8348','2014-03-05','12:30:00',2.39),('8348','2014-03-05','12:35:00',2.71),('8348','2014-03-05','12:40:00',2.48),('8348','2014-03-05','12:45:00',1.95),('8348','2014-03-05','12:50:00',2.59),('8348','2014-03-05','12:55:00',3.01),('8348','2014-03-05','13:00:00',3.48),('8348','2014-03-05','13:05:00',4.85),('8348','2014-03-05','13:10:00',6.47),('8348','2014-03-05','13:15:00',3.98),('8348','2014-03-05','13:20:00',4.17),('8348','2014-03-05','13:25:00',3.73),('8348','2014-03-05','13:30:00',2.15),('8348','2014-03-05','13:35:00',2.36),('8348','2014-03-05','13:40:00',2.78),('8348','2014-03-05','13:45:00',2.58),('8348','2014-03-05','13:50:00',2.23),('8348','2014-03-05','13:55:00',2.07),('8348','2014-03-05','14:00:00',1.96),('8348','2014-03-05','14:05:00',2.02),('8348','2014-03-05','14:10:00',1.99),('8348','2014-03-05','14:15:00',2.17),('8348','2014-03-05','14:20:00',2.27),('8348','2014-03-05','14:25:00',2.51),('8348','2014-03-05','14:30:00',2.62),('8348','2014-03-05','14:35:00',2.2),('8348','2014-03-05','14:40:00',2.83),('8348','2014-03-05','14:45:00',3.53),('8348','2014-03-05','14:50:00',3.27),('8348','2014-03-05','14:55:00',2.43),('8348','2014-03-05','15:00:00',1.67),('8348','2014-03-05','15:05:00',1.41),('8348','2014-03-05','15:10:00',1.39),('8348','2014-03-05','15:15:00',1.36),('8348','2014-03-05','15:20:00',1.29),('8348','2014-03-05','15:25:00',1.42),('8348','2014-03-05','15:30:00',1.83),('8348','2014-03-05','15:35:00',2.13),('8348','2014-03-05','15:40:00',3.13),('8348','2014-03-05','15:45:00',3.86),('8348','2014-03-05','15:50:00',2.28),('8348','2014-03-05','15:55:00',3.93),('8348','2014-03-05','16:00:00',5.13),('8348','2014-03-05','16:05:00',4.55),('8348','2014-03-05','16:10:00',3.59),('8348','2014-03-05','16:15:00',2.29),('8348','2014-03-04','08:50:00',1.09),('8348','2014-03-04','09:00:00',1.09),('8348','2014-03-04','09:05:00',1.61),('8348','2014-03-04','09:10:00',2.66),('8348','2014-03-04','09:15:00',3.3),('8348','2014-03-04','09:20:00',3.77),('8348','2014-03-04','09:25:00',1.47),('8348','2014-03-04','09:30:00',1.72),('8348','2014-03-04','09:35:00',1.68),('8348','2014-03-04','09:40:00',1.82),('8348','2014-03-04','09:45:00',1.75),('8348','2014-03-04','09:50:00',1.24),('8348','2014-03-04','09:55:00',3.06),('8348','2014-03-04','10:00:00',2.53),('8348','2014-03-04','10:05:00',1.79),('8348','2014-03-04','10:10:00',1.2),('8348','2014-03-04','10:20:00',1.65),('8348','2014-03-04','10:25:00',4.69),('8348','2014-03-04','10:30:00',3.82),('8348','2014-03-04','10:35:00',5.82),('8348','2014-03-04','10:40:00',6.89),('8348','2014-03-04','10:45:00',6.66),('8348','2014-03-04','10:50:00',2.87),('8348','2014-03-04','10:55:00',5),('8348','2014-03-04','11:00:00',4.68),('8348','2014-03-04','11:05:00',4.56),('8348','2014-03-04','11:10:00',6.73),('8348','2014-03-04','11:15:00',7.97),('8348','2014-03-04','11:20:00',4.98),('8348','2014-03-04','11:25:00',1.52),('8348','2014-03-04','11:30:00',1.9),('8348','2014-03-04','11:35:00',1.39),('8348','2014-03-04','11:40:00',1.62),('8348','2014-03-04','11:45:00',3.4),('8348','2014-03-04','11:50:00',7.51),('8348','2014-03-04','11:55:00',6.94),('8348','2014-03-04','12:00:00',6.71),('8348','2014-03-04','12:05:00',6.58),('8348','2014-03-04','12:10:00',6.55),('8348','2014-03-04','12:15:00',6.54),('8348','2014-03-04','12:20:00',6.56),('8348','2014-03-04','12:25:00',6.6),('8348','2014-03-04','12:30:00',6.48),('8348','2014-03-04','12:35:00',6.44),('8348','2014-03-04','12:40:00',6.51),('8348','2014-03-04','12:45:00',4.34),('8348','2014-03-04','12:50:00',5.78),('8348','2014-03-04','12:55:00',4.73),('8348','2014-03-04','13:00:00',6.71),('8348','2014-03-04','13:05:00',4.53),('8348','2014-03-04','13:10:00',7.04),('8348','2014-03-04','13:15:00',4.44),('8348','2014-03-04','13:20:00',3.31),('8348','2014-03-04','13:25:00',1.85),('8348','2014-03-04','13:30:00',1.89),('8348','2014-03-04','13:35:00',1.41),('8348','2014-03-04','13:40:00',1.18),('8348','2014-03-04','13:45:00',2.1),('8348','2014-03-04','13:50:00',2.42),('8348','2014-03-04','13:55:00',2.25),('8348','2014-03-04','14:00:00',1.34),('8348','2014-03-04','14:05:00',3.46),('8348','2014-03-04','14:10:00',4.71),('8348','2014-03-04','14:15:00',6.38),('8348','2014-03-04','14:20:00',3.86),('8348','2014-03-04','14:25:00',6.47),('8348','2014-03-04','14:30:00',5.83),('8348','2014-03-04','14:35:00',5.57),('8348','2014-03-04','14:40:00',5.51),('8348','2014-03-04','14:45:00',5.21),('8348','2014-03-04','14:50:00',5.81),('8348','2014-03-04','14:55:00',4.18),('8348','2014-03-04','15:00:00',5.61),('8348','2014-03-04','15:05:00',5.14),('8348','2014-03-04','15:10:00',4.88),('8348','2014-03-04','15:15:00',4.67),('8348','2014-03-04','15:20:00',2.95),('8348','2014-03-04','15:25:00',3.71),('8348','2014-03-04','15:30:00',1.56),('8348','2014-03-04','15:35:00',5.09),('8348','2014-03-04','15:40:00',4.53),('8348','2014-03-04','15:45:00',4.3),('8348','2014-03-04','15:50:00',3),('8348','2014-03-04','15:55:00',1.25),('8348','2014-03-04','16:00:00',1.19),('8348','2014-03-04','16:05:00',1.73),('8348','2014-03-04','16:10:00',1.93),('8348','2014-03-04','16:15:00',1.46),('8348','2014-03-04','16:20:00',1.76),('8348','2014-03-04','16:25:00',2.57),('8348','2014-03-04','16:30:00',1.83),('8348','2014-03-04','16:35:00',1.76),('8348','2014-03-04','16:40:00',2.01),('8348','2014-03-04','16:45:00',2.13),('8348','2014-03-04','16:50:00',1.95),('8348','2014-03-04','16:55:00',1.6),('8348','2014-03-04','17:00:00',1.27),('8348','2014-03-03','08:30:00',1.04),('8348','2014-03-03','08:35:00',1.1),('8348','2014-03-03','08:40:00',1.18),('8348','2014-03-03','08:45:00',1.26),('8348','2014-03-03','08:50:00',1.27),('8348','2014-03-03','08:55:00',1.49),('8348','2014-03-03','09:00:00',1.53),('8348','2014-03-03','09:05:00',1.59),('8348','2014-03-03','09:10:00',1.49),('8348','2014-03-03','09:15:00',1.6),('8348','2014-03-03','09:20:00',1.78),('8348','2014-03-03','09:25:00',1.89),('8348','2014-03-03','09:30:00',1.91),('8348','2014-03-03','09:35:00',1.68),('8348','2014-03-03','09:40:00',1.61),('8348','2014-03-03','09:45:00',1.71),('8348','2014-03-03','09:50:00',1.73),('8348','2014-03-03','09:55:00',2),('8348','2014-03-03','10:00:00',2.22),('8348','2014-03-03','10:05:00',2.36),('8348','2014-03-03','10:10:00',2.39),('8348','2014-03-03','10:15:00',2.43),('8348','2014-03-03','10:20:00',2.47),('8348','2014-03-03','10:25:00',2.52),('8348','2014-03-03','10:30:00',2.56),('8348','2014-03-03','10:35:00',2.57),('8348','2014-03-03','10:40:00',2.6),('8348','2014-03-03','10:45:00',2.65),('8348','2014-03-03','10:50:00',2.72),('8348','2014-03-03','10:55:00',2.74),('8348','2014-03-03','11:00:00',2.76),('8348','2014-03-03','11:05:00',2.84),('8348','2014-03-03','11:10:00',2.85),('8348','2014-03-03','11:15:00',2.87),('8348','2014-03-03','11:20:00',2.94),('8348','2014-03-03','11:25:00',2.95),('8348','2014-03-03','11:30:00',3.01),('8348','2014-03-03','11:35:00',2.51),('8348','2014-03-03','11:40:00',3.14),('8348','2014-03-03','11:45:00',3.12),('8348','2014-03-03','11:50:00',3.2),('8348','2014-03-03','11:55:00',3.21),('8348','2014-03-03','12:00:00',3.24),('8348','2014-03-03','12:05:00',3.25),('8348','2014-03-03','12:10:00',3.25),('8348','2014-03-03','12:15:00',3.27),('8348','2014-03-03','12:20:00',3.29),('8348','2014-03-03','12:25:00',3.28),('8348','2014-03-03','12:30:00',3.29),('8348','2014-03-03','12:35:00',3.27),('8348','2014-03-03','12:40:00',3.26),('8348','2014-03-03','12:45:00',3.25),('8348','2014-03-03','12:50:00',3.24),('8348','2014-03-03','12:55:00',3.24),('8348','2014-03-03','13:00:00',3.24),('8348','2014-03-03','13:05:00',3.23),('8348','2014-03-03','13:10:00',3.22),('8348','2014-03-03','13:15:00',3.21),('8348','2014-03-03','13:20:00',3.2),('8348','2014-03-03','13:25:00',3.19),('8348','2014-03-03','13:30:00',3.19),('8348','2014-03-03','13:35:00',3.16),('8348','2014-03-03','13:40:00',3.12),('8348','2014-03-03','13:45:00',3.11),('8348','2014-03-03','13:50:00',3.09),('8348','2014-03-03','13:55:00',3.06),('8348','2014-03-03','14:00:00',3.05),('8348','2014-03-03','14:05:00',3.07),('8348','2014-03-03','14:10:00',3.08),('8348','2014-03-03','14:15:00',3.05),('8348','2014-03-03','14:20:00',2.95),('8348','2014-03-03','14:25:00',2.56),('8348','2014-03-03','14:30:00',2.88),('8348','2014-03-03','14:35:00',2.84),('8348','2014-03-03','14:40:00',2.79),('8348','2014-03-03','14:45:00',2.72),('8348','2014-03-03','14:50:00',2.65),('8348','2014-03-03','14:55:00',2.6),('8348','2014-03-03','15:00:00',2.54),('8348','2014-03-03','15:05:00',2.43),('8348','2014-03-03','15:10:00',2.44),('8348','2014-03-03','15:15:00',2.36),('8348','2014-03-03','15:20:00',2.32),('8348','2014-03-03','15:25:00',2.26),('8348','2014-03-03','15:30:00',2.19),('8348','2014-03-03','15:35:00',2.12),('8348','2014-03-03','15:40:00',2.04),('8348','2014-03-03','15:45:00',1.98),('8348','2014-03-03','15:50:00',1.9),('8348','2014-03-03','15:55:00',1.83),('8348','2014-03-03','16:00:00',1.74),('8348','2014-03-03','16:05:00',1.66),('8348','2014-03-03','16:10:00',1.58),('8348','2014-03-03','16:15:00',1.5),('8348','2014-03-03','16:20:00',1.43),('8348','2014-03-03','16:25:00',1.35),('8348','2014-03-03','16:30:00',1.26),('8348','2014-03-03','16:35:00',1.18),('8348','2014-03-03','16:40:00',1.08),('8348','2014-03-02','08:10:00',1.12),('8348','2014-03-02','08:15:00',1.04),('8348','2014-03-02','08:20:00',1.02),('8348','2014-03-02','08:30:00',1.02),('8348','2014-03-02','08:35:00',1.07),('8348','2014-03-02','08:40:00',1.15),('8348','2014-03-02','08:45:00',1.2),('8348','2014-03-02','08:50:00',1.32),('8348','2014-03-02','08:55:00',1.42),('8348','2014-03-02','09:00:00',1.49),('8348','2014-03-02','09:05:00',1.6),('8348','2014-03-02','09:10:00',1.74),('8348','2014-03-02','09:15:00',1.87),('8348','2014-03-02','09:20:00',1.41),('8348','2014-03-02','09:25:00',1.99),('8348','2014-03-02','09:30:00',2.19),('8348','2014-03-02','09:35:00',2.19),('8348','2014-03-02','09:40:00',2.1),('8348','2014-03-02','10:00:00',1.31),('8348','2014-03-02','10:05:00',1.38),('8348','2014-03-02','10:10:00',1.26),('8348','2014-03-02','10:15:00',1.14),('8348','2014-03-02','10:20:00',1.14),('8348','2014-03-02','10:25:00',1.29),('8348','2014-03-02','10:30:00',1.41),('8348','2014-03-02','10:35:00',2.12),('8348','2014-03-02','10:40:00',2.81),('8348','2014-03-02','10:50:00',1.26),('8348','2014-03-02','10:55:00',1.21),('8348','2014-03-02','11:00:00',2.14),('8348','2014-03-02','11:05:00',2.98),('8348','2014-03-02','11:10:00',1.54),('8348','2014-03-02','11:15:00',1.12),('8348','2014-03-02','11:20:00',1.48),('8348','2014-03-02','11:25:00',1.77),('8348','2014-03-02','11:30:00',1.85),('8348','2014-03-02','11:35:00',2.98),('8348','2014-03-02','11:40:00',2.35),('8348','2014-03-02','11:45:00',3.48),('8348','2014-03-02','11:50:00',3.89),('8348','2014-03-02','11:55:00',3.74),('8348','2014-03-02','12:00:00',2.67),('8348','2014-03-02','12:05:00',1.81),('8348','2014-03-02','12:10:00',1.4),('8348','2014-03-02','12:15:00',2.46),('8348','2014-03-02','12:20:00',2.03),('8348','2014-03-02','12:25:00',1.71),('8348','2014-03-02','12:30:00',1.34),('8348','2014-03-02','12:35:00',1.05),('8348','2014-03-02','12:55:00',1.11),('8348','2014-03-02','13:00:00',1.33),('8348','2014-03-02','13:05:00',1.43),('8348','2014-03-02','13:10:00',1.43),('8348','2014-03-02','13:15:00',1.33),('8348','2014-03-02','13:20:00',1.24),('8348','2014-03-02','13:25:00',1.15),('8348','2014-03-02','13:30:00',1.04),('8348','2014-03-02','14:00:00',1.1),('8348','2014-03-02','14:05:00',1.23),('8348','2014-03-02','14:10:00',1.2),('8348','2014-03-02','14:15:00',1.17),('8348','2014-03-02','14:20:00',1.09),('8348','2014-03-02','14:25:00',1.08),('8348','2014-03-02','14:30:00',1.12),('8348','2014-03-02','14:35:00',1.12),('8348','2014-03-02','14:40:00',1.11),('8348','2014-03-02','14:45:00',1.16),('8348','2014-03-02','14:50:00',1.17),('8348','2014-03-02','14:55:00',1.14),('8348','2014-03-02','15:00:00',1.2),('8348','2014-03-02','15:05:00',1.28),('8348','2014-03-02','15:10:00',1.33),('8348','2014-03-02','15:15:00',1.28),('8348','2014-03-02','15:20:00',1.25),('8348','2014-03-02','15:25:00',1.22),('8348','2014-03-02','15:30:00',1.29),('8348','2014-03-02','15:35:00',1.23),('8348','2014-03-02','15:40:00',1.32),('8348','2014-03-02','15:45:00',1.16),('8348','2014-03-02','15:50:00',1.04),('8348','2014-02-28','08:20:00',1.2),('8348','2014-02-28','08:35:00',1.23),('8348','2014-02-28','09:25:00',1.04),('8348','2014-02-28','09:30:00',1.48),('8348','2014-02-28','09:40:00',1.78),('8348','2014-02-28','09:45:00',2.25),('8348','2014-02-28','09:50:00',2.7),('8348','2014-02-28','09:55:00',1.96),('8348','2014-02-28','10:00:00',1.02),('8348','2014-02-28','10:10:00',1.33),('8348','2014-02-28','10:15:00',1.03),('8348','2014-02-28','10:20:00',1.6),('8348','2014-02-28','10:25:00',2.33),('8348','2014-02-28','10:30:00',2.9),('8348','2014-02-28','10:35:00',2.04),('8348','2014-02-28','10:40:00',1.08),('8348','2014-02-28','11:20:00',1.27),('8348','2014-02-28','11:25:00',1.3),('8348','2014-02-28','11:30:00',1.14),('8348','2014-02-28','11:55:00',1.02),('8348','2014-02-28','12:00:00',1.3),('8348','2014-02-28','12:05:00',1.98),('8348','2014-02-28','12:10:00',1.81),('8348','2014-02-28','12:25:00',1.8),('8348','2014-02-28','12:30:00',1.9),('8348','2014-02-28','12:35:00',3.25),('8348','2014-02-28','12:40:00',2.81),('8348','2014-02-28','12:45:00',1.15),('8348','2014-02-28','12:50:00',3.13),('8348','2014-02-28','12:55:00',1.86),('8348','2014-02-28','13:00:00',2.45),('8348','2014-02-28','13:05:00',1.55),('8348','2014-02-28','13:10:00',1.43),('8348','2014-02-28','13:15:00',1.03),('8348','2014-02-28','13:50:00',3.75),('8348','2014-02-28','13:55:00',2.56),('8348','2014-02-28','14:00:00',1.24),('8348','2014-02-28','14:20:00',1.25),('8348','2014-02-28','14:25:00',1.78),('8348','2014-02-28','14:30:00',1.65),('8348','2014-02-28','14:35:00',1.35),('8348','2014-02-28','14:40:00',1.21),('8348','2014-02-28','14:45:00',1.19),('8348','2014-02-28','14:50:00',1.27),('8348','2014-02-28','14:55:00',1.37),('8348','2014-02-28','15:00:00',1.98),('8348','2014-02-28','15:05:00',1.58),('8348','2014-02-28','15:25:00',2.27),('8348','2014-02-28','15:30:00',1.73),('8348','2014-02-28','15:35:00',1.8),('8348','2014-02-28','15:40:00',1.77),('8348','2014-02-28','16:15:00',1.86),('8348','2014-02-28','16:20:00',1.54),('8348','2014-02-28','16:35:00',1),('8348','2014-02-28','16:40:00',1.34),('8348','2014-02-28','16:45:00',1.47),('8348','2014-02-28','16:50:00',1.24),('8348','2014-02-27','10:40:00',1.08),('8348','2014-02-27','10:45:00',1.17),('8348','2014-02-27','10:50:00',1.2),('8348','2014-02-27','10:55:00',1.27),('8348','2014-02-27','11:00:00',1.43),('8348','2014-02-27','11:05:00',1.57),('8348','2014-02-27','11:10:00',1.45),('8348','2014-02-27','11:15:00',1.4),('8348','2014-02-27','11:20:00',1.3),('8348','2014-02-27','11:25:00',1.43),('8348','2014-02-27','11:30:00',1.75),('8348','2014-02-27','11:35:00',1.62),('8348','2014-02-27','11:40:00',1.36),('8348','2014-02-27','11:45:00',1.17),('8348','2014-02-27','11:50:00',1.13),('8348','2014-02-27','11:55:00',1.19),('8348','2014-02-27','12:00:00',1.17),('8348','2014-02-27','12:05:00',1.15),('8348','2014-02-27','12:10:00',1.09),('8348','2014-02-27','12:15:00',1.16),('8348','2014-02-27','12:20:00',1.2),('8348','2014-02-27','12:25:00',1.22),('8348','2014-02-27','12:30:00',1.15),('8348','2014-02-27','12:35:00',1.12),('8348','2014-02-27','12:40:00',1.1),('8348','2014-02-27','12:45:00',1.08),('8348','2014-02-27','12:50:00',1.06),('8348','2014-02-27','12:55:00',1.08),('8348','2014-02-27','13:00:00',1.14),('8348','2014-02-27','13:10:00',1.03),('8348','2014-02-27','13:15:00',1.15),('8348','2014-02-27','13:20:00',1.17),('8348','2014-02-27','13:25:00',1.25),('8348','2014-02-27','13:30:00',1.43),('8348','2014-02-27','13:35:00',1.53),('8348','2014-02-27','13:40:00',1.58),('8348','2014-02-27','13:45:00',1.57),('8348','2014-02-27','13:50:00',1.61),('8348','2014-02-27','13:55:00',1.82),('8348','2014-02-27','14:00:00',1.85),('8348','2014-02-27','14:05:00',1.57),('8348','2014-02-27','14:10:00',1.46),('8348','2014-02-27','14:15:00',1.33),('8348','2014-02-27','14:20:00',1.33),('8348','2014-02-27','14:25:00',1.31),('8348','2014-02-27','14:30:00',1.4),('8348','2014-02-27','14:35:00',1.32),('8348','2014-02-27','14:40:00',1.13),('8348','2014-02-27','14:45:00',1.19),('8348','2014-02-27','14:50:00',1.14),('8348','2014-02-27','14:55:00',1.03),('8348','2014-02-27','15:00:00',1.1),('8348','2014-02-27','15:05:00',1.09),('8348','2014-02-27','15:10:00',1.12),('8348','2014-02-27','15:15:00',1.28),('8348','2014-02-27','15:20:00',1.4),('8348','2014-02-27','15:25:00',1.25),('8348','2014-02-27','15:30:00',1.23),('8348','2014-02-27','15:35:00',1.19),('8348','2014-02-27','16:50:00',1.02),('8348','2014-02-27','16:55:00',1.08),('8348','2014-02-26','08:35:00',1.06),('8348','2014-02-26','08:40:00',1.15),('8348','2014-02-26','08:45:00',1.31),('8348','2014-02-26','08:50:00',1.2),('8348','2014-02-26','08:55:00',1.26),('8348','2014-02-26','09:00:00',1.36),('8348','2014-02-26','09:05:00',1.38),('8348','2014-02-26','09:10:00',1.47),('8348','2014-02-26','09:15:00',1.58),('8348','2014-02-26','09:20:00',1.71),('8348','2014-02-26','09:25:00',1.88),('8348','2014-02-26','09:30:00',1.74),('8348','2014-02-26','09:35:00',1.57),('8348','2014-02-26','09:40:00',1.47),('8348','2014-02-26','09:45:00',1.37),('8348','2014-02-26','09:50:00',1.25),('8348','2014-02-26','09:55:00',1.29),('8348','2014-02-26','10:00:00',1.12),('8348','2014-02-26','11:55:00',1.04),('8348','2014-02-26','12:00:00',1.11),('8348','2014-02-26','12:05:00',1.16),('8348','2014-02-26','12:10:00',1.21),('8348','2014-02-26','12:15:00',1.12),('8348','2014-02-26','12:20:00',1.08),('8348','2014-02-26','12:25:00',1.82),('8348','2014-02-26','12:30:00',1.82),('8348','2014-02-26','12:35:00',2.22),('8348','2014-02-26','12:40:00',2.86),('8348','2014-02-26','12:45:00',3.4),('8348','2014-02-26','12:50:00',3.33),('8348','2014-02-26','12:55:00',3.22),('8348','2014-02-26','13:00:00',2.77),('8348','2014-02-26','13:05:00',2.32),('8348','2014-02-26','13:10:00',2.73),('8348','2014-02-26','13:15:00',2.52),('8348','2014-02-26','13:20:00',1.97),('8348','2014-02-26','13:25:00',1.92),('8348','2014-02-26','13:30:00',1.93),('8348','2014-02-26','13:35:00',1.9),('8348','2014-02-26','13:40:00',1.94),('8348','2014-02-26','13:45:00',1.44),('8348','2014-02-26','13:50:00',1.28),('8348','2014-02-26','13:55:00',1.78),('8348','2014-02-26','14:00:00',3.03),('8348','2014-02-26','14:05:00',2.34),('8348','2014-02-26','14:10:00',1.04),('8348','2014-02-26','14:15:00',1.53),('8348','2014-02-26','14:20:00',2.72),('8348','2014-02-26','14:25:00',2.26),('8348','2014-02-26','14:30:00',1.06),('8348','2014-02-26','14:35:00',1.78),('8348','2014-02-26','14:40:00',2.81),('8348','2014-02-26','14:45:00',2.65),('8348','2014-02-26','14:50:00',2.74),('8348','2014-02-26','14:55:00',2.73),('8348','2014-02-26','15:00:00',2.51),('8348','2014-02-26','15:05:00',2.3),('8348','2014-02-26','15:10:00',2.41),('8348','2014-02-26','15:15:00',2.06),('8348','2014-02-26','15:20:00',1.38),('8348','2014-02-26','15:30:00',1.11),('8348','2014-02-26','15:35:00',1.62),('8348','2014-02-26','15:40:00',1.65),('8348','2014-02-26','15:45:00',1.31),('8348','2014-02-26','15:50:00',1.26),('8348','2014-02-26','15:55:00',1.44),('8348','2014-02-26','16:00:00',1.63),('8348','2014-02-26','16:05:00',1.4),('8348','2014-02-26','16:10:00',1.06),('8348','2014-04-29','08:40:00',1.04),('8348','2014-04-29','08:45:00',1.44),('8348','2014-04-29','08:50:00',1.86),('8348','2014-04-29','08:55:00',2.02),('8348','2014-04-29','09:00:00',2.04),('8348','2014-04-29','09:05:00',3.03),('8348','2014-04-29','09:10:00',5.57),('8348','2014-04-29','09:15:00',5.8),('8348','2014-04-29','09:20:00',5.12),('8348','2014-04-29','09:25:00',6.4),('8348','2014-04-29','09:30:00',6.47),('8348','2014-04-29','09:35:00',6.4),('8348','2014-04-29','09:40:00',6.49),('8348','2014-04-29','09:45:00',6.59),('8348','2014-04-29','09:50:00',6.66),('8348','2014-04-29','09:55:00',6.18),('8348','2014-04-29','10:00:00',6.63),('8348','2014-04-29','10:05:00',6.57),('8348','2014-04-29','10:10:00',6.99),('8348','2014-04-29','10:15:00',7.27),('8348','2014-04-29','10:20:00',6.9),('8348','2014-04-29','10:25:00',6.92),('8348','2014-04-29','10:30:00',5.37),('8348','2014-04-29','10:35:00',4.56),('8348','2014-04-29','10:40:00',5.64),('8348','2014-04-29','10:45:00',5.43),('8348','2014-04-29','10:50:00',2.03),('8348','2014-04-29','10:55:00',2.08),('8348','2014-04-29','11:00:00',2.67),('8348','2014-04-29','11:05:00',3.04),('8348','2014-04-29','11:10:00',3.06),('8348','2014-04-29','11:15:00',2.9),('8348','2014-04-29','11:20:00',5.04),('8348','2014-04-29','11:25:00',4.18),('8348','2014-04-29','11:30:00',3.21),('8348','2014-04-29','11:35:00',2.86),('8348','2014-04-29','11:40:00',3.96),('8348','2014-04-29','11:45:00',4.82),('8348','2014-04-29','11:50:00',4.26),('8348','2014-04-29','11:55:00',2.92),('8348','2014-04-29','12:00:00',4.55),('8348','2014-04-29','12:05:00',3.47),('8348','2014-04-29','12:10:00',3.6),('8348','2014-04-29','12:15:00',4.01),('8348','2014-04-29','12:20:00',5.71),('8348','2014-04-29','12:25:00',5.05),('8348','2014-04-29','12:30:00',5.31),('8348','2014-04-29','12:35:00',3.37),('8348','2014-04-29','12:40:00',3.05),('8348','2014-04-29','12:45:00',7),('8348','2014-04-29','12:50:00',2.78),('8348','2014-04-29','12:55:00',1.56),('8348','2014-04-29','13:35:00',1.02),('8348','2014-04-29','13:40:00',1.12),('8348','2014-04-29','14:00:00',1.29),('8348','2014-04-29','14:05:00',1.71),('8348','2014-04-29','14:10:00',1.37),('8348','2014-04-29','14:25:00',1.22),('8348','2014-04-29','14:30:00',1.38),('8348','2014-04-29','14:35:00',1.41),('8348','2014-04-29','15:05:00',1.14),('8348','2014-04-29','15:10:00',1.33),('8348','2014-04-29','15:15:00',1.62),('8348','2014-04-29','15:20:00',1.79),('8348','2014-04-29','15:25:00',1.87),('8348','2014-04-29','15:30:00',1.53),('8348','2014-04-29','15:35:00',1.32),('8348','2014-04-29','15:40:00',1.18),('8348','2014-04-29','15:45:00',1.17),('8348','2014-04-29','15:50:00',1.24),('8348','2014-04-29','15:55:00',1.47),('8348','2014-04-29','16:00:00',1.78),('8348','2014-04-29','16:05:00',2.22),('8348','2014-04-29','16:10:00',2.04),('8348','2014-04-29','16:15:00',1.62),('8348','2014-04-29','16:20:00',2.23),('8348','2014-04-29','16:25:00',2.77),('8348','2014-04-29','16:30:00',4.21),('8348','2014-04-29','16:35:00',3.28),('8348','2014-04-29','16:40:00',3.93),('8348','2014-04-29','16:45:00',3.25),('8348','2014-04-29','16:55:00',1),('8348','2014-04-29','17:00:00',1.18),('8348','2014-04-29','17:05:00',1.24),('8348','2014-02-25','08:40:00',1.02),('8348','2014-02-25','08:45:00',1.09),('8348','2014-02-25','08:50:00',1.13),('8348','2014-02-25','08:55:00',1.22),('8348','2014-02-25','09:00:00',1.3),('8348','2014-02-25','09:05:00',1.36),('8348','2014-02-25','09:10:00',1.42),('8348','2014-02-25','09:15:00',1.51),('8348','2014-02-25','09:20:00',1.61),('8348','2014-02-25','09:25:00',1.68),('8348','2014-02-25','09:30:00',1.74),('8348','2014-02-25','09:35:00',1.79),('8348','2014-02-25','09:40:00',1.84),('8348','2014-02-25','09:45:00',1.9),('8348','2014-02-25','09:50:00',1.97),('8348','2014-02-25','09:55:00',2.02),('8348','2014-02-25','10:00:00',2.09),('8348','2014-02-25','10:05:00',2.14),('8348','2014-02-25','10:10:00',2.19),('8348','2014-02-25','10:15:00',2.24),('8348','2014-02-25','10:20:00',2.28),('8348','2014-02-25','10:25:00',2.32),('8348','2014-02-25','10:30:00',2.36),('8348','2014-02-25','10:35:00',2.39),('8348','2014-02-25','10:40:00',2.42),('8348','2014-02-25','10:45:00',2.45),('8348','2014-02-25','10:50:00',2.52),('8348','2014-02-25','10:55:00',2.56),('8348','2014-02-25','11:00:00',2.57),('8348','2014-02-25','11:05:00',2.59),('8348','2014-02-25','11:10:00',2.6),('8348','2014-02-25','11:15:00',2.63),('8348','2014-02-25','11:20:00',2.68),('8348','2014-02-25','11:25:00',2.7),('8348','2014-02-25','11:30:00',2.69),('8348','2014-02-25','11:35:00',2.7),('8348','2014-02-25','11:40:00',2.72),('8348','2014-02-25','11:45:00',2.75),('8348','2014-02-25','11:50:00',2.76),('8348','2014-02-25','11:55:00',2.75),('8348','2014-02-25','12:00:00',2.79),('8348','2014-02-25','12:05:00',2.84),('8348','2014-02-25','12:10:00',2.86),('8348','2014-02-25','12:15:00',2.82),('8348','2014-02-25','12:20:00',2.85),('8348','2014-02-25','12:25:00',2.91),('8348','2014-02-25','12:30:00',2.88),('8348','2014-02-25','12:35:00',2.89),('8348','2014-02-25','12:40:00',2.89),('8348','2014-02-25','12:45:00',2.91),('8348','2014-02-25','12:50:00',2.92),('8348','2014-02-25','12:55:00',2.96),('8348','2014-02-25','13:00:00',2.91),('8348','2014-02-25','13:05:00',2.82),('8348','2014-02-25','13:10:00',2.73),('8348','2014-02-25','13:15:00',2.38),('8348','2014-02-25','13:20:00',1.59),('8348','2014-02-25','13:25:00',1.35),('8348','2014-02-25','13:40:00',1.19),('8348','2014-02-25','13:45:00',1.21),('8348','2014-02-25','13:55:00',1.05),('8348','2014-02-25','14:00:00',1.24),('8348','2014-02-25','14:05:00',1.07),('8348','2014-02-25','14:10:00',1),('8348','2014-02-25','14:15:00',1.07),('8348','2014-02-25','14:20:00',1.09),('8348','2014-02-25','14:25:00',1.91),('8348','2014-02-25','14:30:00',2.36),('8348','2014-02-25','14:35:00',2.26),('8348','2014-02-25','14:40:00',2.68),('8348','2014-02-25','14:45:00',2.69),('8348','2014-02-25','14:50:00',2.5),('8348','2014-02-25','14:55:00',2.27),('8348','2014-02-25','15:00:00',1.96),('8348','2014-02-25','15:05:00',2.22),('8348','2014-02-25','15:10:00',2.12),('8348','2014-02-25','15:15:00',2.1),('8348','2014-02-25','15:20:00',2),('8348','2014-02-25','15:25:00',1.73),('8348','2014-02-25','15:30:00',1.62),('8348','2014-02-25','15:35:00',1.5),('8348','2014-02-25','15:40:00',1.54),('8348','2014-02-25','15:45:00',1.02),('8348','2014-02-25','15:55:00',1.04),('8348','2014-02-25','16:15:00',1.04),('8348','2014-02-25','16:20:00',1.06),('8348','2014-02-24','08:30:00',1.01),('8348','2014-02-24','08:35:00',1.16),('8348','2014-02-24','08:45:00',1.16),('8348','2014-02-24','08:50:00',1.17),('8348','2014-02-24','08:55:00',1.21),('8348','2014-02-24','09:00:00',1.25),('8348','2014-02-24','09:05:00',1.32),('8348','2014-02-24','09:10:00',1.37),('8348','2014-02-24','09:15:00',1.46),('8348','2014-02-24','09:20:00',1.57),('8348','2014-02-24','09:25:00',1.65),('8348','2014-02-24','09:30:00',1.72),('8348','2014-02-24','09:35:00',1.78),('8348','2014-02-24','09:40:00',1.83),('8348','2014-02-24','09:45:00',1.89),('8348','2014-02-24','09:50:00',1.95),('8348','2014-02-24','09:55:00',2.01),('8348','2014-02-24','10:00:00',2.08),('8348','2014-02-24','10:05:00',2.13),('8348','2014-02-24','10:10:00',2.19),('8348','2014-02-24','10:15:00',2.24),('8348','2014-02-24','10:20:00',2.31),('8348','2014-02-24','10:25:00',2.36),('8348','2014-02-24','10:30:00',2.4),('8348','2014-02-24','10:35:00',2.45),('8348','2014-02-24','10:40:00',2.49),('8348','2014-02-24','10:45:00',2.53),('8348','2014-02-24','10:50:00',2.58),('8348','2014-02-24','10:55:00',2.61),('8348','2014-02-24','11:00:00',2.64),('8348','2014-02-24','11:05:00',2.67),('8348','2014-02-24','11:10:00',2.7),('8348','2014-02-24','11:15:00',2.69),('8348','2014-02-24','11:20:00',2.78),('8348','2014-02-24','11:25:00',2.89),('8348','2014-02-24','11:30:00',3.2),('8348','2014-02-24','11:35:00',2.1),('8348','2014-02-24','11:40:00',2.33),('8348','2014-02-24','11:45:00',2.21),('8348','2014-02-24','11:50:00',2.89),('8348','2014-02-24','11:55:00',2.39),('8348','2014-02-24','12:00:00',2.39),('8348','2014-02-24','12:05:00',3.09),('8348','2014-02-24','12:10:00',2.92),('8348','2014-02-24','12:15:00',2.87),('8348','2014-02-24','12:20:00',2.43),('8348','2014-02-24','12:25:00',2.35),('8348','2014-02-24','12:30:00',1.45),('8348','2014-02-24','12:35:00',3.02),('8348','2014-02-24','12:40:00',3.32),('8348','2014-02-24','12:45:00',3.23),('8348','2014-02-24','12:50:00',3.17),('8348','2014-02-24','12:55:00',3.18),('8348','2014-02-24','13:00:00',3),('8348','2014-02-24','13:05:00',2.61),('8348','2014-02-24','13:10:00',3.63),('8348','2014-02-24','13:15:00',1.51),('8348','2014-02-24','15:20:00',1.05),('8348','2014-02-24','15:25:00',1.14),('8348','2014-02-24','15:30:00',1.19),('8348','2014-02-24','15:35:00',1.91),('8348','2014-02-24','15:40:00',2.34),('8348','2014-02-24','15:45:00',2.23),('8348','2014-02-24','15:50:00',1.78),('8348','2014-02-24','15:55:00',1.74),('8348','2014-02-24','16:00:00',2.06),('8348','2014-02-24','16:05:00',1.94),('8348','2014-02-24','16:10:00',1.83),('8348','2014-02-24','16:15:00',1.67),('8348','2014-02-24','16:20:00',1.42),('8348','2014-02-24','16:25:00',1.19),('8348','2014-02-23','08:45:00',1.03),('8348','2014-02-23','08:50:00',1.09),('8348','2014-02-23','08:55:00',1.15),('8348','2014-02-23','09:00:00',1.22),('8348','2014-02-23','09:05:00',1.3),('8348','2014-02-23','09:10:00',1.37),('8348','2014-02-23','09:15:00',1.49),('8348','2014-02-23','09:20:00',1.58),('8348','2014-02-23','09:25:00',1.61),('8348','2014-02-23','09:30:00',1.53),('8348','2014-02-23','09:35:00',1.77),('8348','2014-02-23','09:40:00',1.84),('8348','2014-02-23','09:45:00',1.87),('8348','2014-02-23','09:50:00',1.91),('8348','2014-02-23','09:55:00',1.96),('8348','2014-02-23','10:00:00',2.02),('8348','2014-02-23','10:05:00',2.07),('8348','2014-02-23','10:10:00',2.1),('8348','2014-02-23','10:15:00',2.17),('8348','2014-02-23','10:20:00',2.22),('8348','2014-02-23','10:25:00',2.28),('8348','2014-02-23','10:30:00',2.34),('8348','2014-02-23','10:35:00',2.37),('8348','2014-02-23','10:40:00',2.42),('8348','2014-02-23','10:45:00',2.47),('8348','2014-02-23','10:50:00',2.52),('8348','2014-02-23','10:55:00',2.56),('8348','2014-02-23','11:00:00',2.61),('8348','2014-02-23','11:05:00',2.6),('8348','2014-02-23','11:10:00',2.69),('8348','2014-02-23','11:15:00',2.69),('8348','2014-02-23','11:20:00',2.76),('8348','2014-02-23','11:25:00',2.79),('8348','2014-02-23','11:30:00',2.32),('8348','2014-02-23','11:35:00',2.85),('8348','2014-02-23','11:40:00',2.8),('8348','2014-02-23','11:45:00',1.99),('8348','2014-02-23','11:50:00',1.97),('8348','2014-02-23','11:55:00',2.2),('8348','2014-02-23','12:00:00',3.11),('8348','2014-02-23','12:05:00',3.19),('8348','2014-02-23','12:10:00',3.26),('8348','2014-02-23','12:15:00',3.29),('8348','2014-02-23','12:20:00',2.33),('8348','2014-02-23','12:25:00',1.79),('8348','2014-02-23','12:30:00',2.43),('8348','2014-02-23','12:35:00',3.38),('8348','2014-02-23','12:40:00',1.78),('8348','2014-02-23','12:45:00',1.92),('8348','2014-02-23','12:50:00',1.55),('8348','2014-02-23','12:55:00',1.78),('8348','2014-02-23','13:00:00',2.1),('8348','2014-02-23','13:05:00',3.14),('8348','2014-02-23','13:10:00',3.09),('8348','2014-02-23','13:15:00',3.04),('8348','2014-02-23','13:20:00',3.03),('8348','2014-02-23','13:25:00',3.02),('8348','2014-02-23','13:30:00',2.98),('8348','2014-02-23','13:35:00',2.85),('8348','2014-02-23','13:40:00',2.67),('8348','2014-02-23','13:45:00',1.88),('8348','2014-02-23','14:00:00',2.19),('8348','2014-02-23','14:05:00',2.69),('8348','2014-02-23','14:10:00',3.04),('8348','2014-02-23','14:15:00',2.03),('8348','2014-02-23','14:20:00',1.98),('8348','2014-02-23','14:25:00',2.78),('8348','2014-02-23','14:30:00',2.85),('8348','2014-02-23','14:35:00',2.1),('8348','2014-02-23','14:40:00',1.1),('8348','2014-02-23','14:45:00',1.11),('8348','2014-02-23','14:50:00',1.08),('8348','2014-02-22','10:00:00',1.25),('8348','2014-02-22','10:05:00',1.59),('8348','2014-02-22','10:10:00',1.79),('8348','2014-02-22','10:15:00',1.74),('8348','2014-02-22','10:20:00',1.21),('8348','2014-02-22','10:25:00',1.76),('8348','2014-02-22','10:30:00',2.01),('8348','2014-02-22','10:35:00',1.52),('8348','2014-02-22','10:40:00',1.68),('8348','2014-02-22','10:45:00',3.03),('8348','2014-02-22','10:50:00',2.97),('8348','2014-02-22','10:55:00',1.03),('8348','2014-02-22','12:05:00',1.18),('8348','2014-02-22','12:10:00',1.48),('8348','2014-02-22','12:15:00',1.65),('8348','2014-02-22','12:20:00',1.48),('8348','2014-02-22','12:25:00',1.51),('8348','2014-02-22','12:35:00',1.09),('8348','2014-02-22','12:40:00',1.25),('8348','2014-02-22','12:45:00',2.98),('8348','2014-02-22','12:50:00',2.78),('8348','2014-02-22','12:55:00',1.35),('8348','2014-02-22','13:00:00',1.3),('8348','2014-02-22','13:05:00',2.01),('8348','2014-02-22','13:10:00',4.1),('8348','2014-02-22','13:15:00',2.28),('8348','2014-02-22','13:20:00',1.5),('8348','2014-02-22','13:30:00',1.18),('8348','2014-02-22','13:35:00',1.98),('8348','2014-02-22','13:40:00',1.86),('8348','2014-02-22','13:45:00',1.65),('8348','2014-02-22','13:50:00',1.86),('8348','2014-02-22','13:55:00',2.98),('8348','2014-02-22','14:00:00',3.16),('8348','2014-02-22','14:05:00',3.16),('8348','2014-02-22','14:10:00',2.96),('8348','2014-02-22','14:15:00',2.91),('8348','2014-02-22','14:20:00',2.81),('8348','2014-02-22','14:25:00',2.14),('8348','2014-02-22','14:30:00',2.79),('8348','2014-02-22','14:35:00',2.57),('8348','2014-02-22','14:40:00',2.39),('8348','2014-02-22','14:45:00',2.75),('8348','2014-02-22','14:50:00',2.28),('8348','2014-02-22','15:00:00',1.77),('8348','2014-02-22','15:05:00',2.21),('8348','2014-02-22','15:10:00',1.65),('8348','2014-02-22','15:15:00',1.98),('8348','2014-02-22','15:20:00',1.25),('8348','2014-02-22','15:25:00',2.03),('8348','2014-02-22','15:30:00',1.4),('8348','2014-02-22','15:45:00',1.63),('8348','2014-02-22','15:50:00',1.8),('8348','2014-02-22','16:00:00',1.35),('8348','2014-02-22','16:10:00',1.04),('8348','2014-02-22','16:15:00',1.3),('8348','2014-02-22','16:20:00',1.23),('8348','2014-02-22','16:25:00',1.13),('8348','2014-02-21','09:50:00',1.05),('8348','2014-02-21','09:55:00',1.03),('8348','2014-02-21','10:00:00',1.06),('8348','2014-02-21','10:05:00',1.26),('8348','2014-02-21','10:10:00',1.17),('8348','2014-02-21','10:15:00',1.29),('8348','2014-02-21','10:20:00',1.72),('8348','2014-02-21','10:25:00',1.97),('8348','2014-02-21','10:30:00',2.31),('8348','2014-02-21','10:35:00',1.69),('8348','2014-02-21','10:40:00',1.53),('8348','2014-02-21','10:45:00',1.47),('8348','2014-02-21','10:50:00',1.34),('8348','2014-02-21','10:55:00',1.88),('8348','2014-02-21','11:00:00',1.49),('8348','2014-02-21','11:05:00',1.32),('8348','2014-02-21','11:10:00',1.31),('8348','2014-02-21','11:15:00',1.46),('8348','2014-02-21','11:20:00',1.37),('8348','2014-02-21','11:25:00',1.44),('8348','2014-02-21','11:30:00',2.05),('8348','2014-02-21','11:35:00',1.6),('8348','2014-02-21','11:40:00',1.68),('8348','2014-02-21','11:45:00',1.4),('8348','2014-02-21','11:50:00',1.94),('8348','2014-02-21','11:55:00',1.88),('8348','2014-02-21','12:00:00',3.03),('8348','2014-02-21','12:05:00',3.53),('8348','2014-02-21','12:10:00',3.27),('8348','2014-02-21','12:15:00',2.78),('8348','2014-02-21','12:20:00',1.61),('8348','2014-02-21','12:25:00',1.42),('8348','2014-02-21','12:30:00',1.59),('8348','2014-02-21','12:35:00',1.27),('8348','2014-02-21','12:40:00',1.02),('8348','2014-02-21','15:25:00',1.16),('8348','2014-02-21','15:30:00',1.59),('8348','2014-02-21','15:35:00',1.79),('8348','2014-02-21','15:40:00',1.69),('8348','2014-02-21','15:45:00',1.63),('8348','2014-02-21','15:50:00',1.52),('8348','2014-02-21','15:55:00',1.44),('8348','2014-02-21','16:00:00',1.37),('8348','2014-02-21','16:05:00',1.29),('8348','2014-02-21','16:10:00',1.21),('8348','2014-02-21','16:15:00',1.13),('8348','2014-02-21','16:20:00',1.05),('8348','2014-02-20','11:25:00',1.09),('8348','2014-02-20','11:30:00',1.08),('8348','2014-02-20','12:40:00',1.05),('8348','2014-02-20','12:55:00',1.08),('8348','2014-02-20','13:00:00',1.32),('8348','2014-02-20','13:15:00',1.09),('8348','2014-02-20','13:30:00',1.09),('8348','2014-02-19','09:35:00',1.02),('8348','2014-02-19','09:40:00',1.1),('8348','2014-02-19','09:45:00',1.31),('8348','2014-02-19','09:50:00',1.23),('8348','2014-02-19','09:55:00',1.15),('8348','2014-02-19','10:00:00',1.12),('8348','2014-02-19','10:05:00',1.12),('8348','2014-02-19','10:10:00',1.21),('8348','2014-02-19','10:15:00',1.28),('8348','2014-02-19','10:20:00',1.17),('8348','2014-02-19','10:25:00',1.2),('8348','2014-02-19','10:30:00',1.27),('8348','2014-02-19','10:35:00',1.33),('8348','2014-02-19','10:40:00',1.52),('8348','2014-02-19','10:45:00',1.65),('8348','2014-02-19','10:50:00',1.57),('8348','2014-02-19','10:55:00',1.41),('8348','2014-02-19','11:00:00',1.28),('8348','2014-02-19','11:05:00',1.28),('8348','2014-02-19','11:10:00',1.42),('8348','2014-02-19','11:15:00',1.44),('8348','2014-02-19','11:20:00',1.56),('8348','2014-02-19','11:25:00',1.46),('8348','2014-02-19','11:30:00',1.33),('8348','2014-02-19','11:35:00',1.31),('8348','2014-02-19','11:40:00',1.28),('8348','2014-02-19','11:45:00',1.18),('8348','2014-02-19','11:50:00',1.24),('8348','2014-02-19','11:55:00',1.12),('8348','2014-02-19','12:00:00',1.19),('8348','2014-02-19','12:05:00',1.3),('8348','2014-02-19','12:10:00',1.28),('8348','2014-02-19','12:15:00',1.25),('8348','2014-02-19','12:20:00',1.08),('8348','2014-02-19','12:25:00',1.26),('8348','2014-02-19','12:30:00',1.42),('8348','2014-02-19','12:35:00',1.2),('8348','2014-02-19','12:40:00',1.1),('8348','2014-02-19','12:45:00',1.12),('8348','2014-02-19','13:05:00',1.04),('8348','2014-02-19','13:15:00',1.12),('8348','2014-02-19','13:20:00',1.11),('8348','2014-02-19','13:25:00',1.35),('8348','2014-02-19','13:30:00',1.36),('8348','2014-02-19','13:35:00',1.57),('8348','2014-02-19','13:40:00',1.46),('8348','2014-02-19','13:45:00',1.76),('8348','2014-02-19','13:50:00',1.9),('8348','2014-02-19','13:55:00',1.68),('8348','2014-02-19','14:00:00',1.57),('8348','2014-02-19','14:05:00',1.64),('8348','2014-02-19','14:10:00',1.31),('8348','2014-02-19','14:15:00',1.16),('8348','2014-02-19','14:20:00',1.86),('8348','2014-02-19','14:25:00',1.45),('8348','2014-02-19','14:30:00',1.41),('8348','2014-02-19','14:35:00',1.48),('8348','2014-02-19','14:40:00',1.25),('8348','2014-02-19','14:45:00',1.14),('8348','2014-02-19','14:50:00',1.53),('8348','2014-02-19','14:55:00',1.31),('8348','2014-02-19','15:05:00',1),('8348','2014-02-19','15:10:00',1.04),('8348','2014-02-19','15:15:00',1.16),('8348','2014-02-19','15:25:00',1.04),('8348','2014-02-19','15:50:00',1.06),('8348','2014-02-18','08:55:00',1.03),('8348','2014-02-18','09:00:00',1.09),('8348','2014-02-18','09:05:00',1.16),('8348','2014-02-18','09:10:00',1.22),('8348','2014-02-18','09:15:00',1.3),('8348','2014-02-18','09:20:00',1.37),('8348','2014-02-18','09:25:00',1.44),('8348','2014-02-18','09:30:00',1.54),('8348','2014-02-18','09:35:00',1.59),('8348','2014-02-18','09:40:00',1.65),('8348','2014-02-18','09:45:00',1.71),('8348','2014-02-18','09:50:00',1.77),('8348','2014-02-18','09:55:00',1.83),('8348','2014-02-18','10:00:00',1.89),('8348','2014-02-18','10:05:00',1.94),('8348','2014-02-18','10:10:00',1.98),('8348','2014-02-18','10:15:00',2.02),('8348','2014-02-18','10:20:00',2.06),('8348','2014-02-18','10:25:00',2.11),('8348','2014-02-18','10:30:00',2.15),('8348','2014-02-18','10:35:00',2.18),('8348','2014-02-18','10:40:00',2.23),('8348','2014-02-18','10:45:00',2.26),('8348','2014-02-18','10:50:00',2.3),('8348','2014-02-18','10:55:00',2.35),('8348','2014-02-18','11:00:00',2.4),('8348','2014-02-18','11:05:00',2.1),('8348','2014-02-18','11:10:00',2.03),('8348','2014-02-18','11:15:00',1.97),('8348','2014-02-18','11:20:00',2.17),('8348','2014-02-18','11:25:00',2.49),('8348','2014-02-18','11:30:00',2.28),('8348','2014-02-18','11:35:00',2.22),('8348','2014-02-18','11:40:00',1.75),('8348','2014-02-18','11:45:00',1.71),('8348','2014-02-18','11:50:00',1.52),('8348','2014-02-18','11:55:00',1.35),('8348','2014-02-18','12:00:00',1.33),('8348','2014-02-18','12:05:00',1.34),('8348','2014-02-18','12:10:00',1.51),('8348','2014-02-18','12:15:00',1.64),('8348','2014-02-18','12:20:00',1.64),('8348','2014-02-18','12:25:00',1.86),('8348','2014-02-18','12:30:00',2),('8348','2014-02-18','12:35:00',1.57),('8348','2014-02-18','12:40:00',1.42),('8348','2014-02-18','12:45:00',1.37),('8348','2014-02-18','12:50:00',1.46),('8348','2014-02-18','12:55:00',1.61),('8348','2014-02-18','13:00:00',1.27),('8348','2014-02-18','13:05:00',1.19),('8348','2014-02-18','13:10:00',1.25),('8348','2014-02-18','13:15:00',1.64),('8348','2014-02-18','13:20:00',1.82),('8348','2014-02-18','13:25:00',2.24),('8348','2014-02-18','13:30:00',1.65),('8348','2014-02-18','13:35:00',1.33),('8348','2014-02-18','13:40:00',1.67),('8348','2014-02-18','13:45:00',1.93),('8348','2014-02-18','13:50:00',1.52),('8348','2014-02-18','13:55:00',1.5),('8348','2014-02-18','14:00:00',1.65),('8348','2014-02-18','14:05:00',2.38),('8348','2014-02-18','14:10:00',1.48),('8348','2014-02-18','14:15:00',1.15),('8348','2014-02-18','14:20:00',1.02),('8348','2014-02-18','14:25:00',1.04),('8348','2014-02-18','14:30:00',1.29),('8348','2014-02-18','14:35:00',1.24),('8348','2014-02-18','14:40:00',1.06),('8348','2014-02-18','15:40:00',1.18),('8348','2014-02-18','15:45:00',1.26),('8348','2014-02-18','16:05:00',1.04),('8348','2014-02-17','09:00:00',1.01),('8348','2014-02-17','09:05:00',1.08),('8348','2014-02-17','09:10:00',1.14),('8348','2014-02-17','09:15:00',1.22),('8348','2014-02-17','09:20:00',1.28),('8348','2014-02-17','09:25:00',1.36),('8348','2014-02-17','09:30:00',1.46),('8348','2014-02-17','09:35:00',1.53),('8348','2014-02-17','09:40:00',1.57),('8348','2014-02-17','09:45:00',1.62),('8348','2014-02-17','09:50:00',1.65),('8348','2014-02-17','09:55:00',1.71),('8348','2014-02-17','10:00:00',1.77),('8348','2014-02-17','10:05:00',1.82),('8348','2014-02-17','10:10:00',1.86),('8348','2014-02-17','10:15:00',1.89),('8348','2014-02-17','10:20:00',1.92),('8348','2014-02-17','10:25:00',1.96),('8348','2014-02-17','10:30:00',2),('8348','2014-02-17','10:35:00',2.02),('8348','2014-02-17','10:40:00',2.03),('8348','2014-02-17','10:45:00',2.06),('8348','2014-02-17','10:50:00',2.09),('8348','2014-02-17','10:55:00',2.14),('8348','2014-02-17','11:00:00',2.14),('8348','2014-02-17','11:05:00',2.17),('8348','2014-02-17','11:10:00',2.2),('8348','2014-02-17','11:15:00',2.25),('8348','2014-02-17','11:20:00',2.27),('8348','2014-02-17','11:25:00',2.36),('8348','2014-02-17','11:30:00',2.43),('8348','2014-02-17','11:35:00',2.49),('8348','2014-02-17','11:40:00',2.53),('8348','2014-02-17','11:45:00',2.56),('8348','2014-02-17','11:50:00',2.58),('8348','2014-02-17','11:55:00',2.59),('8348','2014-02-17','12:00:00',2.6),('8348','2014-02-17','12:05:00',2.61),('8348','2014-02-17','12:10:00',2.62),('8348','2014-02-17','12:15:00',2.61),('8348','2014-02-17','12:20:00',2.61),('8348','2014-02-17','12:25:00',2.62),('8348','2014-02-17','12:30:00',2.64),('8348','2014-02-17','12:35:00',2.64),('8348','2014-02-17','12:40:00',2.63),('8348','2014-02-17','12:45:00',2.62),('8348','2014-02-17','12:50:00',2.61),('8348','2014-02-17','12:55:00',2.6),('8348','2014-02-17','13:00:00',2.6),('8348','2014-02-17','13:05:00',2.58),('8348','2014-02-17','13:10:00',2.57),('8348','2014-02-17','13:15:00',2.55),('8348','2014-02-17','13:20:00',2.54),('8348','2014-02-17','13:25:00',2.55),('8348','2014-02-17','13:30:00',2.54),('8348','2014-02-17','13:35:00',2.52),('8348','2014-02-17','13:40:00',2.51),('8348','2014-02-17','13:45:00',2.44),('8348','2014-02-17','13:50:00',2.45),('8348','2014-02-17','13:55:00',2.41),('8348','2014-02-17','14:00:00',2.36),('8348','2014-02-17','14:05:00',2.35),('8348','2014-02-17','14:10:00',2.27),('8348','2014-02-17','14:15:00',2.19),('8348','2014-02-17','14:20:00',2.28),('8348','2014-02-17','14:25:00',2.2),('8348','2014-02-17','14:30:00',2.12),('8348','2014-02-17','14:35:00',2.07),('8348','2014-02-17','14:40:00',1.96),('8348','2014-02-17','14:45:00',2.07),('8348','2014-02-17','14:50:00',1.99),('8348','2014-02-17','14:55:00',1.94),('8348','2014-02-17','15:00:00',1.82),('8348','2014-02-17','15:05:00',1.81),('8348','2014-02-17','15:10:00',1.76),('8348','2014-02-17','15:15:00',1.78),('8348','2014-02-17','15:20:00',1.75),('8348','2014-02-17','15:25:00',1.62),('8348','2014-02-17','15:30:00',1.6),('8348','2014-02-17','15:35:00',1.53),('8348','2014-02-17','15:40:00',1.42),('8348','2014-02-17','15:45:00',1.42),('8348','2014-02-17','15:50:00',1.34),('8348','2014-02-17','15:55:00',1.27),('8348','2014-02-17','16:00:00',1.17),('8348','2014-02-17','16:05:00',1.12),('8348','2014-02-17','16:10:00',1.04),('8348','2014-02-16','08:55:00',1.06),('8348','2014-02-16','09:00:00',1.13),('8348','2014-02-16','09:05:00',1.18),('8348','2014-02-16','09:10:00',1.18),('8348','2014-02-16','09:20:00',1.3),('8348','2014-02-16','09:25:00',1.34),('8348','2014-02-16','09:30:00',1.41),('8348','2014-02-16','09:35:00',1.27),('8348','2014-02-16','09:40:00',1.58),('8348','2014-02-16','09:45:00',1.71),('8348','2014-02-16','09:50:00',1.78),('8348','2014-02-16','09:55:00',1.75),('8348','2014-02-16','10:00:00',1.73),('8348','2014-02-16','10:05:00',1.93),('8348','2014-02-16','10:10:00',1.99),('8348','2014-02-16','10:15:00',2.04),('8348','2014-02-16','10:20:00',2.1),('8348','2014-02-16','10:25:00',2.14),('8348','2014-02-16','10:30:00',2.2),('8348','2014-02-16','10:35:00',2.29),('8348','2014-02-16','10:40:00',2.36),('8348','2014-02-16','10:45:00',2.36),('8348','2014-02-16','10:50:00',2.12),('8348','2014-02-16','10:55:00',2.06),('8348','2014-02-16','11:00:00',2.39),('8348','2014-02-16','11:05:00',2.46),('8348','2014-02-16','11:10:00',2.4),('8348','2014-02-16','11:15:00',2.47),('8348','2014-02-16','11:20:00',2.42),('8348','2014-02-16','11:25:00',2.33),('8348','2014-02-16','11:30:00',2.4),('8348','2014-02-16','11:35:00',2.55),('8348','2014-02-16','11:40:00',2.56),('8348','2014-02-16','11:45:00',2.3),('8348','2014-02-16','11:50:00',2.56),('8348','2014-02-16','11:55:00',2.3),('8348','2014-02-16','12:00:00',2.66),('8348','2014-02-16','12:05:00',2.64),('8348','2014-02-16','12:10:00',2.65),('8348','2014-02-16','12:15:00',2.65),('8348','2014-02-16','12:20:00',2.67),('8348','2014-02-16','12:25:00',2.57),('8348','2014-02-16','12:30:00',2.65),('8348','2014-02-16','12:35:00',2.66),('8348','2014-02-16','12:40:00',2.65),('8348','2014-02-16','12:45:00',2.64),('8348','2014-02-16','12:50:00',2.63),('8348','2014-02-16','12:55:00',2.64),('8348','2014-02-16','13:00:00',2.63),('8348','2014-02-16','13:05:00',2.68),('8348','2014-02-16','13:10:00',2.58),('8348','2014-02-16','13:15:00',2.63),('8348','2014-02-16','13:20:00',2.62),('8348','2014-02-16','13:25:00',2.59),('8348','2014-02-16','13:30:00',2.57),('8348','2014-02-16','13:35:00',2.56),('8348','2014-02-16','13:40:00',2.52),('8348','2014-02-16','13:45:00',2.58),('8348','2014-02-16','13:50:00',2.52),('8348','2014-02-16','13:55:00',2.56),('8348','2014-02-16','14:00:00',2.56),('8348','2014-02-16','14:05:00',2.55),('8348','2014-02-16','14:10:00',2.51),('8348','2014-02-16','14:15:00',2.47),('8348','2014-02-16','14:20:00',2.46),('8348','2014-02-16','14:25:00',2.44),('8348','2014-02-16','14:30:00',2.39),('8348','2014-02-16','14:35:00',2.33),('8348','2014-02-16','14:40:00',2.25),('8348','2014-02-16','14:45:00',2.23),('8348','2014-02-16','14:50:00',2.19),('8348','2014-02-16','14:55:00',2.1),('8348','2014-02-16','15:00:00',2.04),('8348','2014-02-16','15:05:00',2.04),('8348','2014-02-16','15:10:00',1.99),('8348','2014-02-16','15:15:00',1.92),('8348','2014-02-16','15:20:00',1.84),('8348','2014-02-16','15:25:00',1.77),('8348','2014-02-16','15:30:00',1.71),('8348','2014-02-16','15:35:00',1.54),('8348','2014-02-16','15:40:00',1.3),('8348','2014-02-16','15:45:00',1.53),('8348','2014-02-16','15:50:00',1.24),('8348','2014-02-16','16:20:00',1.08),('8348','2014-02-16','16:25:00',1.2),('8348','2014-02-16','16:30:00',1.17),('8348','2014-04-28','06:45:00',1.07),('8348','2014-04-28','06:50:00',1.08),('8348','2014-04-28','06:55:00',1.2),('8348','2014-04-28','07:00:00',1.32),('8348','2014-04-28','07:15:00',2.02),('8348','2014-04-28','07:20:00',2.33),('8348','2014-04-28','07:25:00',2.79),('8348','2014-04-28','07:30:00',2.04),('8348','2014-04-28','07:35:00',2.03),('8348','2014-04-28','07:40:00',2.16),('8348','2014-04-28','07:45:00',2.25),('8348','2014-04-28','07:50:00',1.98),('8348','2014-04-28','07:55:00',2.1),('8348','2014-04-28','08:00:00',1.71),('8348','2014-04-28','08:05:00',1.7),('8348','2014-04-28','08:10:00',2.16),('8348','2014-04-28','08:15:00',3.56),('8348','2014-04-28','08:20:00',1.94),('8348','2014-04-28','08:25:00',2.62),('8348','2014-04-28','08:30:00',5.22),('8348','2014-04-28','08:35:00',3.45),('8348','2014-04-28','08:40:00',3.09),('8348','2014-04-28','08:45:00',4.59),('8348','2014-04-28','08:50:00',4.67),('8348','2014-04-28','08:55:00',2.32),('8348','2014-04-28','09:00:00',3.12),('8348','2014-04-28','09:05:00',3.97),('8348','2014-04-28','09:10:00',4.05),('8348','2014-04-28','09:15:00',3.64),('8348','2014-04-28','09:20:00',3.07),('8348','2014-04-28','09:25:00',1.82),('8348','2014-04-28','09:35:00',1.08),('8348','2014-04-28','09:40:00',1.91),('8348','2014-04-28','09:45:00',2.91),('8348','2014-04-28','09:50:00',3.6),('8348','2014-04-28','09:55:00',3.18),('8348','2014-04-28','10:00:00',3.43),('8348','2014-04-28','10:05:00',4.41),('8348','2014-04-28','10:10:00',4.57),('8348','2014-04-28','10:15:00',4.55),('8348','2014-04-28','10:20:00',4.29),('8348','2014-04-28','10:25:00',3.14),('8348','2014-04-28','10:30:00',3.32),('8348','2014-04-28','10:35:00',2.95),('8348','2014-04-28','10:40:00',2.82),('8348','2014-04-28','10:45:00',3.12),('8348','2014-04-28','10:50:00',3.51),('8348','2014-04-28','10:55:00',3.54),('8348','2014-04-28','11:00:00',3.28),('8348','2014-04-28','11:05:00',2.71),('8348','2014-04-28','11:10:00',3.71),('8348','2014-04-28','11:15:00',5.33),('8348','2014-04-28','11:20:00',5.25),('8348','2014-04-28','11:25:00',5.09),('8348','2014-04-28','11:30:00',5.02),('8348','2014-04-28','11:35:00',4.44),('8348','2014-04-28','11:40:00',3.85),('8348','2014-04-28','11:45:00',3.54),('8348','2014-04-28','11:50:00',4.1),('8348','2014-04-28','11:55:00',4.18),('8348','2014-04-28','12:00:00',4.35),('8348','2014-04-28','12:05:00',5.94),('8348','2014-04-28','12:10:00',5.92),('8348','2014-04-28','12:15:00',4.15),('8348','2014-04-28','12:20:00',4.65),('8348','2014-04-28','12:25:00',5.62),('8348','2014-04-28','12:30:00',7.78),('8348','2014-04-28','12:35:00',6.9),('8348','2014-04-28','12:40:00',7.84),('8348','2014-04-28','12:45:00',7.16),('8348','2014-04-28','12:50:00',7.69),('8348','2014-04-28','12:55:00',5.7),('8348','2014-04-28','13:00:00',5.25),('8348','2014-04-28','13:05:00',7.1),('8348','2014-04-28','13:10:00',7.84),('8348','2014-04-28','13:15:00',4.84),('8348','2014-04-28','13:20:00',7.75),('8348','2014-04-28','13:25:00',6),('8348','2014-04-28','13:30:00',7.44),('8348','2014-04-28','13:35:00',6.01),('8348','2014-04-28','13:40:00',6.63),('8348','2014-04-28','13:45:00',5.27),('8348','2014-04-28','13:50:00',4.34),('8348','2014-04-28','13:55:00',6.89),('8348','2014-04-28','14:00:00',3.92),('8348','2014-04-28','14:05:00',6.02),('8348','2014-04-28','14:10:00',3.63),('8348','2014-04-28','14:15:00',5.48),('8348','2014-04-28','14:20:00',5.35),('8348','2014-04-28','14:25:00',2.73),('8348','2014-04-28','14:30:00',3.47),('8348','2014-04-28','14:35:00',4.75),('8348','2014-04-28','14:40:00',3.95),('8348','2014-04-28','14:45:00',4.1),('8348','2014-04-28','14:50:00',5.36),('8348','2014-04-28','14:55:00',2.94),('8348','2014-04-28','15:00:00',7.43),('8348','2014-04-28','15:05:00',7.31),('8348','2014-04-28','15:10:00',5.71),('8348','2014-04-28','15:15:00',3.01),('8348','2014-04-28','15:20:00',5.35),('8348','2014-04-28','15:25:00',4.05),('8348','2014-04-28','15:30:00',4.78),('8348','2014-04-28','15:35:00',4.39),('8348','2014-04-28','15:40:00',1.45),('8348','2014-04-28','15:45:00',1.25),('8348','2014-04-28','15:50:00',1.45),('8348','2014-04-28','15:55:00',5.48),('8348','2014-04-28','16:00:00',1.76),('8348','2014-04-28','16:05:00',1.09),('8348','2014-04-28','16:15:00',1.04),('8348','2014-04-28','16:20:00',2.18),('8348','2014-04-28','16:25:00',1.85),('8348','2014-04-28','16:30:00',1.57),('8348','2014-04-28','16:35:00',2.14),('8348','2014-04-28','16:40:00',2.73),('8348','2014-04-28','16:45:00',1.51),('8348','2014-04-28','16:50:00',1.32),('8348','2014-04-28','16:55:00',1.25),('8348','2014-04-28','17:10:00',1.16),('8348','2014-04-28','17:15:00',1.21),('8348','2014-04-28','17:25:00',1.03),('8348','2014-04-28','17:35:00',1.13),('8348','2014-02-15','09:00:00',1.01),('8348','2014-02-15','09:05:00',1.06),('8348','2014-02-15','09:10:00',1.13),('8348','2014-02-15','09:15:00',1.17),('8348','2014-02-15','09:20:00',1.24),('8348','2014-02-15','09:25:00',1.32),('8348','2014-02-15','09:30:00',1.41),('8348','2014-02-15','09:35:00',1.5),('8348','2014-02-15','09:40:00',1.57),('8348','2014-02-15','09:45:00',1.64),('8348','2014-02-15','09:50:00',1.69),('8348','2014-02-15','09:55:00',1.74),('8348','2014-02-15','10:00:00',1.79),('8348','2014-02-15','10:05:00',1.84),('8348','2014-02-15','10:10:00',1.89),('8348','2014-02-15','10:15:00',1.94),('8348','2014-02-15','10:20:00',1.99),('8348','2014-02-15','10:25:00',2.02),('8348','2014-02-15','10:30:00',2.04),('8348','2014-02-15','10:35:00',2.08),('8348','2014-02-15','10:40:00',2.11),('8348','2014-02-15','10:45:00',2.16),('8348','2014-02-15','10:50:00',2.16),('8348','2014-02-15','10:55:00',2.23),('8348','2014-02-15','11:00:00',2.17),('8348','2014-02-15','11:05:00',1.95),('8348','2014-02-15','11:10:00',2.42),('8348','2014-02-15','11:15:00',1.97),('8348','2014-02-15','11:20:00',1.76),('8348','2014-02-15','11:25:00',2.1),('8348','2014-02-15','11:30:00',2.67),('8348','2014-02-15','11:35:00',1.31),('8348','2014-02-15','11:40:00',1.82),('8348','2014-02-15','11:45:00',3.05),('8348','2014-02-15','11:50:00',2.78),('8348','2014-02-15','11:55:00',2.76),('8348','2014-02-15','12:00:00',1.08),('8348','2014-02-15','12:05:00',1.23),('8348','2014-02-15','12:10:00',1.09),('8348','2014-02-15','12:15:00',3.1),('8348','2014-02-15','12:20:00',2.99),('8348','2014-02-15','12:25:00',2.16),('8348','2014-02-15','12:30:00',1.41),('8348','2014-02-15','12:35:00',2.23),('8348','2014-02-15','12:40:00',1.8),('8348','2014-02-15','12:45:00',3.23),('8348','2014-02-15','12:50:00',3.26),('8348','2014-02-15','12:55:00',2.85),('8348','2014-02-15','13:00:00',3.16),('8348','2014-02-15','13:05:00',3.09),('8348','2014-02-15','13:10:00',3.16),('8348','2014-02-15','13:15:00',2.64),('8348','2014-02-15','13:20:00',2.83),('8348','2014-02-15','13:25:00',2.74),('8348','2014-02-15','13:30:00',2.73),('8348','2014-02-15','13:35:00',2.68),('8348','2014-02-15','13:40:00',2.62),('8348','2014-02-15','13:45:00',2.59),('8348','2014-02-15','13:50:00',2.62),('8348','2014-02-15','13:55:00',2.57),('8348','2014-02-15','14:00:00',2.5),('8348','2014-02-15','14:05:00',2.46),('8348','2014-02-15','14:10:00',2.44),('8348','2014-02-15','14:15:00',2.38),('8348','2014-02-15','14:20:00',2.35),('8348','2014-02-15','14:25:00',2.33),('8348','2014-02-15','14:30:00',2.23),('8348','2014-02-15','14:35:00',2.2),('8348','2014-02-15','14:40:00',2.18),('8348','2014-02-15','14:45:00',2.12),('8348','2014-02-15','14:50:00',2.02),('8348','2014-02-15','14:55:00',2),('8348','2014-02-15','15:00:00',1.99),('8348','2014-02-15','15:05:00',1.96),('8348','2014-02-15','15:10:00',1.91),('8348','2014-02-15','15:15:00',1.84),('8348','2014-02-15','15:20:00',1.79),('8348','2014-02-15','15:25:00',1.73),('8348','2014-02-15','15:30:00',1.68),('8348','2014-02-15','15:35:00',1.62),('8348','2014-02-15','15:40:00',1.55),('8348','2014-02-15','15:45:00',1.48),('8348','2014-02-15','15:50:00',1.41),('8348','2014-02-15','15:55:00',1.35),('8348','2014-02-15','16:00:00',1.28),('8348','2014-02-15','16:05:00',1.21),('8348','2014-02-15','16:10:00',1.14),('8348','2014-02-15','16:15:00',1.06),('8348','2014-04-27','07:30:00',1.04),('8348','2014-04-27','07:50:00',1.39),('8348','2014-04-27','07:55:00',1.78),('8348','2014-04-27','08:00:00',1.25),('8348','2014-04-27','08:10:00',1.16),('8348','2014-04-27','08:15:00',1.63),('8348','2014-04-27','08:20:00',1.81),('8348','2014-04-27','08:25:00',1.53),('8348','2014-04-27','08:30:00',1.26),('8348','2014-04-27','08:40:00',1.09),('8348','2014-04-27','08:45:00',1.32),('8348','2014-04-27','08:50:00',1.09),('8348','2014-04-27','08:55:00',1.33),('8348','2014-04-27','09:00:00',1.95),('8348','2014-04-27','09:05:00',2.1),('8348','2014-04-27','09:10:00',2.18),('8348','2014-04-27','09:15:00',2.03),('8348','2014-04-27','09:20:00',2.22),('8348','2014-04-27','09:25:00',2.04),('8348','2014-04-27','09:30:00',1.15),('8348','2014-04-27','09:55:00',1.22),('8348','2014-04-27','10:00:00',1.94),('8348','2014-04-27','10:05:00',2.22),('8348','2014-04-27','10:10:00',2.12),('8348','2014-04-27','10:15:00',2.02),('8348','2014-04-27','10:20:00',1.64),('8348','2014-04-27','10:25:00',1.15),('8348','2014-04-27','10:30:00',1.46),('8348','2014-04-27','10:35:00',2.4),('8348','2014-04-27','10:40:00',2.74),('8348','2014-04-27','10:45:00',6.07),('8348','2014-04-27','10:50:00',5.67),('8348','2014-04-27','10:55:00',4.57),('8348','2014-04-27','11:00:00',4.47),('8348','2014-04-27','11:05:00',4.94),('8348','2014-04-27','11:10:00',5.29),('8348','2014-04-27','11:15:00',5.5),('8348','2014-04-27','11:20:00',5.2),('8348','2014-04-27','11:25:00',5.15),('8348','2014-04-27','11:30:00',4.52),('8348','2014-04-27','11:35:00',4.83),('8348','2014-04-27','11:40:00',4.27),('8348','2014-04-27','11:45:00',4.58),('8348','2014-04-27','11:50:00',3.97),('8348','2014-04-27','11:55:00',3.2),('8348','2014-04-27','12:00:00',4.15),('8348','2014-04-27','12:05:00',3.99),('8348','2014-04-27','12:10:00',3.4),('8348','2014-04-27','12:15:00',3.48),('8348','2014-04-27','12:20:00',4.35),('8348','2014-04-27','12:25:00',4),('8348','2014-04-27','12:30:00',3.69),('8348','2014-04-27','12:35:00',3.31),('8348','2014-04-27','12:40:00',2.94),('8348','2014-04-27','12:45:00',3.05),('8348','2014-04-27','12:50:00',3.02),('8348','2014-04-27','12:55:00',2.89),('8348','2014-04-27','13:00:00',3.65),('8348','2014-04-27','13:05:00',4.13),('8348','2014-04-27','13:10:00',3.03),('8348','2014-04-27','13:15:00',2.65),('8348','2014-04-27','13:20:00',3.23),('8348','2014-04-27','13:25:00',3.97),('8348','2014-04-27','13:30:00',4.16),('8348','2014-04-27','13:35:00',4.11),('8348','2014-04-27','13:40:00',4.36),('8348','2014-04-27','13:45:00',3.74),('8348','2014-04-27','13:50:00',3.5),('8348','2014-04-27','13:55:00',3.73),('8348','2014-04-27','14:00:00',3.99),('8348','2014-04-27','14:05:00',5.78),('8348','2014-04-27','14:10:00',7.08),('8348','2014-04-27','14:15:00',5.67),('8348','2014-04-27','14:20:00',3.42),('8348','2014-04-27','14:25:00',2.09),('8348','2014-04-27','14:30:00',1.66),('8348','2014-04-27','14:35:00',1.89),('8348','2014-04-27','14:40:00',2.01),('8348','2014-04-27','14:45:00',1.65),('8348','2014-04-27','14:50:00',1.63),('8348','2014-04-27','14:55:00',1.18),('8537','2014-05-05','07:45:00',1.29),('8537','2014-05-05','07:50:00',1.39),('8537','2014-05-05','07:55:00',1.49),('8537','2014-05-05','08:00:00',1.61),('8537','2014-05-05','08:05:00',1.73),('8537','2014-05-05','08:10:00',1.84),('8537','2014-05-05','08:15:00',1.96),('8537','2014-05-05','08:20:00',2.09),('8537','2014-05-05','08:25:00',2.21),('8537','2014-05-05','08:30:00',2.33),('8537','2014-05-05','08:35:00',2.45),('8537','2014-05-05','08:40:00',2.56),('8537','2014-05-05','08:45:00',2.67),('8537','2014-05-05','08:50:00',2.76),('8537','2014-05-05','08:55:00',2.86),('8537','2014-05-05','09:00:00',2.94),('8537','2014-05-05','09:05:00',3.02),('8537','2014-05-05','09:10:00',3.13),('8537','2014-05-05','09:15:00',3.22),('8537','2014-05-05','09:20:00',3.3),('8537','2014-05-05','09:25:00',3.41),('8537','2014-05-05','09:30:00',3.5),('8537','2014-05-05','09:35:00',3.6),('8537','2014-05-05','09:40:00',3.71),('8537','2014-05-05','09:45:00',3.8),('8537','2014-05-05','09:50:00',3.9),('8537','2014-05-05','09:55:00',3.99),('8537','2014-05-05','10:00:00',3.98),('8537','2014-05-05','10:05:00',4.16),('8537','2014-05-05','10:10:00',4.23),('8537','2014-05-05','10:15:00',4.26),('8537','2014-05-05','10:20:00',4.28),('8537','2014-05-05','10:25:00',4.36),('8537','2014-05-05','10:30:00',4.43),('8537','2014-05-05','10:35:00',4.51),('8537','2014-05-05','10:40:00',4.51),('8537','2014-05-05','10:45:00',4.56),('8537','2014-05-05','10:50:00',4.64),('8537','2014-05-05','10:55:00',4.67),('8537','2014-05-05','11:00:00',4.74),('8537','2014-05-05','11:05:00',4.73),('8537','2014-05-05','11:10:00',4.8),('8537','2014-05-05','11:15:00',4.87),('8537','2014-05-05','11:20:00',4.89),('8537','2014-05-05','11:25:00',4.86),('8537','2014-05-05','11:30:00',4.9),('8537','2014-05-05','11:35:00',4.91),('8537','2014-05-05','11:40:00',5.01),('8537','2014-05-05','11:45:00',5.06),('8537','2014-05-05','11:50:00',5.12),('8537','2014-05-05','11:55:00',4.84),('8537','2014-05-05','12:00:00',3.46),('8537','2014-05-05','12:05:00',2.65),('8537','2014-05-05','12:10:00',2.54),('8537','2014-05-05','12:15:00',3.49),('8537','2014-05-05','12:20:00',2.23),('8537','2014-05-05','12:25:00',4.48),('8537','2014-05-05','12:30:00',3.96),('8537','2014-05-05','12:35:00',2.75),('8537','2014-05-05','12:40:00',2.57),('8537','2014-05-05','12:45:00',5.35),('8537','2014-05-05','12:50:00',4.07),('8537','2014-05-05','12:55:00',1.86),('8537','2014-05-05','13:00:00',3.5),('8537','2014-05-05','13:05:00',4.13),('8537','2014-05-05','13:10:00',5.65),('8537','2014-05-05','13:15:00',5.39),('8537','2014-05-05','13:20:00',5.24),('8537','2014-05-05','13:25:00',5.21),('8537','2014-05-05','13:30:00',5.28),('8537','2014-05-05','13:35:00',5.32),('8537','2014-05-05','13:40:00',5.23),('8537','2014-05-05','13:45:00',5.22),('8537','2014-05-05','13:50:00',5.25),('8537','2014-05-05','13:55:00',5.25),('8537','2014-05-05','14:00:00',5.27),('8537','2014-05-05','14:05:00',5.46),('8537','2014-05-05','14:10:00',5.5),('8537','2014-05-05','14:15:00',5.26),('8537','2014-05-05','14:20:00',5.83),('8537','2014-05-05','14:25:00',4.85),('8537','2014-05-05','14:30:00',3.98),('8537','2014-05-05','14:35:00',2.08),('8537','2014-05-05','14:40:00',2.13),('8537','2014-05-05','14:45:00',1.5),('8537','2014-05-05','14:50:00',1.5),('8537','2014-05-05','14:55:00',1.88),('8537','2014-05-05','15:00:00',1.84),('8537','2014-05-05','15:05:00',4.02),('8537','2014-05-05','15:10:00',2.22),('8537','2014-05-05','15:15:00',1.59),('8537','2014-05-05','15:20:00',1.84),('8537','2014-05-05','15:25:00',2.43),('8537','2014-05-05','15:30:00',4.86),('8537','2014-05-05','15:35:00',4.67),('8537','2014-05-05','15:40:00',4.39),('8537','2014-05-05','15:45:00',2.31),('8537','2014-05-05','15:50:00',1.64),('8537','2014-05-05','15:55:00',1.58),('8537','2014-05-05','16:00:00',1.35),('8537','2014-05-05','16:05:00',2.56),('8537','2014-05-05','16:10:00',1.52),('8537','2014-05-05','16:15:00',1.54),('8537','2014-05-05','16:20:00',1.54),('8537','2014-05-05','16:25:00',1.33),('8537','2014-05-05','16:30:00',1.1),('8537','2014-05-05','16:40:00',2.25),('8537','2014-05-05','16:45:00',3.06),('8537','2014-05-05','16:50:00',2.77),('8537','2014-05-05','16:55:00',2.33),('8537','2014-05-05','17:00:00',2.8),('8537','2014-05-05','17:05:00',2.61),('8537','2014-05-05','17:10:00',1.81),('8537','2014-05-05','17:15:00',2.04),('8537','2014-05-05','17:20:00',2.41),('8537','2014-05-05','17:25:00',2.25),('8537','2014-05-05','17:30:00',2.06),('8537','2014-05-05','17:35:00',1.94),('8537','2014-05-05','17:40:00',1.82),('8537','2014-05-05','17:45:00',1.69),('8537','2014-05-05','17:50:00',1.58),('8537','2014-05-05','17:55:00',1.5),('8537','2014-05-05','18:00:00',1.37),('8537','2014-05-05','18:05:00',1.25),('8537','2014-05-05','18:10:00',1.17),('8537','2014-05-05','18:15:00',1.07),('8537','2014-04-26','08:45:00',1.05),('8537','2014-04-26','08:50:00',1.09),('8537','2014-04-26','08:55:00',1.02),('8537','2014-04-26','09:00:00',1.06),('8537','2014-04-26','09:05:00',1.16),('8537','2014-04-26','09:35:00',1.08),('8537','2014-04-26','09:40:00',1.13),('8537','2014-04-26','09:50:00',1.26),('8537','2014-04-26','09:55:00',1.66),('8537','2014-04-26','10:00:00',1.7),('8537','2014-04-26','10:05:00',1.55),('8537','2014-04-26','10:10:00',1.51),('8537','2014-04-26','10:15:00',1.56),('8537','2014-04-26','10:20:00',1.71),('8537','2014-04-26','10:25:00',1.91),('8537','2014-04-26','10:30:00',2.21),('8537','2014-04-26','10:35:00',2.34),('8537','2014-04-26','10:40:00',2.64),('8537','2014-04-26','10:45:00',2.48),('8537','2014-04-26','10:50:00',3.24),('8537','2014-04-26','10:55:00',4.3),('8537','2014-04-26','11:00:00',4.37),('8537','2014-04-26','11:05:00',4.11),('8537','2014-04-26','11:10:00',3.37),('8537','2014-04-26','11:15:00',4.01),('8537','2014-04-26','11:20:00',3.75),('8537','2014-04-26','11:25:00',3.7),('8537','2014-04-26','11:30:00',3.81),('8537','2014-04-26','11:35:00',3.69),('8537','2014-04-26','11:40:00',3.5),('8537','2014-04-26','11:45:00',3.85),('8537','2014-04-26','11:50:00',3.77),('8537','2014-04-26','11:55:00',3.47),('8537','2014-04-26','12:00:00',3.8),('8537','2014-04-26','12:05:00',3.97),('8537','2014-04-26','12:10:00',3.72),('8537','2014-04-26','12:15:00',3.54),('8537','2014-04-26','12:20:00',3.49),('8537','2014-04-26','12:25:00',2.5),('8537','2014-04-26','12:30:00',3.35),('8537','2014-04-26','12:35:00',3.98),('8537','2014-04-26','12:40:00',4.32),('8537','2014-04-26','12:45:00',4.79),('8537','2014-04-26','12:50:00',4.93),('8537','2014-04-26','12:55:00',5.22),('8537','2014-04-26','13:00:00',4.88),('8537','2014-04-26','13:05:00',3.38),('8537','2014-04-26','13:10:00',3.63),('8537','2014-04-26','13:15:00',5.2),('8537','2014-04-26','13:20:00',5.38),('8537','2014-04-26','13:25:00',3.2),('8537','2014-04-26','13:30:00',1.68),('8537','2014-04-26','13:35:00',3.47),('8537','2014-04-26','13:40:00',3.49),('8537','2014-04-26','13:45:00',5.12),('8537','2014-04-26','13:50:00',5.16),('8537','2014-04-26','13:55:00',5.37),('8537','2014-04-26','14:00:00',4.05),('8537','2014-04-26','14:05:00',1.26),('8537','2014-04-26','14:10:00',3.85),('8537','2014-04-26','14:15:00',1.86),('8537','2014-04-26','14:25:00',1.01),('8537','2014-04-26','14:30:00',1.05),('8537','2014-04-26','14:35:00',2.12),('8537','2014-04-26','14:40:00',3.06),('8537','2014-04-26','14:45:00',1.29),('8537','2014-04-26','15:15:00',1.02),('8537','2014-04-26','17:45:00',1.05),('8537','2014-04-26','17:50:00',1.07),('8537','2014-04-25','07:55:00',1.41),('8537','2014-04-25','08:00:00',1.43),('8537','2014-04-25','08:05:00',1.43),('8537','2014-04-25','08:10:00',1.54),('8537','2014-04-25','08:15:00',1.6),('8537','2014-04-25','08:20:00',1.72),('8537','2014-04-25','08:25:00',1.82),('8537','2014-04-25','08:30:00',1.92),('8537','2014-04-25','08:35:00',1.98),('8537','2014-04-25','08:40:00',2.06),('8537','2014-04-25','08:45:00',2.11),('8537','2014-04-25','08:50:00',2.34),('8537','2014-04-25','08:55:00',2.57),('8537','2014-04-25','09:00:00',2.88),('8537','2014-04-25','09:05:00',2.91),('8537','2014-04-25','09:10:00',3.08),('8537','2014-04-25','09:15:00',3.07),('8537','2014-04-25','09:20:00',1.94),('8537','2014-04-25','09:25:00',2),('8537','2014-04-25','09:30:00',3.07),('8537','2014-04-25','09:35:00',1.61),('8537','2014-04-25','09:40:00',1.21),('8537','2014-04-25','09:45:00',1.25),('8537','2014-04-25','09:50:00',1.16),('8537','2014-04-25','09:55:00',1.33),('8537','2014-04-25','10:00:00',1.65),('8537','2014-04-25','10:05:00',1.43),('8537','2014-04-25','10:10:00',1.3),('8537','2014-04-25','10:15:00',1.38),('8537','2014-04-25','10:20:00',1.43),('8537','2014-04-25','10:25:00',1.5),('8537','2014-04-25','10:30:00',1.57),('8537','2014-04-25','10:35:00',3.15),('8537','2014-04-25','10:40:00',3.44),('8537','2014-04-25','10:45:00',3.05),('8537','2014-04-25','10:50:00',4.22),('8537','2014-04-25','10:55:00',4.15),('8537','2014-04-25','11:00:00',3.84),('8537','2014-04-25','11:05:00',2.14),('8537','2014-04-25','11:10:00',2.33),('8537','2014-04-25','11:15:00',3.26),('8537','2014-04-25','11:20:00',5),('8537','2014-04-25','11:25:00',4.51),('8537','2014-04-25','11:30:00',3.86),('8537','2014-04-25','11:35:00',5.06),('8537','2014-04-25','11:40:00',1.82),('8537','2014-04-25','11:45:00',1.82),('8537','2014-04-25','11:50:00',1.49),('8537','2014-04-25','11:55:00',1.71),('8537','2014-04-25','12:00:00',2.59),('8537','2014-04-25','12:05:00',2.57),('8537','2014-04-25','12:10:00',2.02),('8537','2014-04-25','12:15:00',2.7),('8537','2014-04-25','12:20:00',4.83),('8537','2014-04-25','12:25:00',4.68),('8537','2014-04-25','12:30:00',5.05),('8537','2014-04-25','12:35:00',5.22),('8537','2014-04-25','12:40:00',5.4),('8537','2014-04-25','12:45:00',5.48),('8537','2014-04-25','12:50:00',3.64),('8537','2014-04-25','12:55:00',1.75),('8537','2014-04-25','13:00:00',2.81),('8537','2014-04-25','13:05:00',3.83),('8537','2014-04-25','13:10:00',1.98),('8537','2014-04-25','13:15:00',4.33),('8537','2014-04-25','13:20:00',1.65),('8537','2014-04-25','13:25:00',2.27),('8537','2014-04-25','13:30:00',1.6),('8537','2014-04-25','13:35:00',1.32),('8537','2014-04-25','13:40:00',1.85),('8537','2014-04-25','13:45:00',1.87),('8537','2014-04-25','13:50:00',1.35),('8537','2014-04-25','13:55:00',1.98),('8537','2014-04-25','14:00:00',1.52),('8537','2014-04-25','14:05:00',1.77),('8537','2014-04-25','14:10:00',1.52),('8537','2014-04-25','14:15:00',1.44),('8537','2014-04-25','14:20:00',5.19),('8537','2014-04-25','14:25:00',5.49),('8537','2014-04-25','14:30:00',4.68),('8537','2014-04-25','14:35:00',3.99),('8537','2014-04-25','14:40:00',4.6),('8537','2014-04-25','14:45:00',4.62),('8537','2014-04-25','14:50:00',4.59),('8537','2014-04-25','14:55:00',4.58),('8537','2014-04-25','15:00:00',4.49),('8537','2014-04-25','15:05:00',4.39),('8537','2014-04-25','15:10:00',4.33),('8537','2014-04-25','15:15:00',4.29),('8537','2014-04-25','15:20:00',4.1),('8537','2014-04-25','15:25:00',4.02),('8537','2014-04-25','15:30:00',3.78),('8537','2014-04-25','15:35:00',4),('8537','2014-04-25','15:40:00',3.92),('8537','2014-04-25','15:45:00',3.74),('8537','2014-04-25','15:50:00',3.75),('8537','2014-04-25','15:55:00',3.71),('8537','2014-04-25','16:00:00',3.68),('8537','2014-04-25','16:05:00',3.5),('8537','2014-04-25','16:10:00',3.13),('8537','2014-04-25','16:15:00',2.92),('8537','2014-04-25','16:20:00',2.97),('8537','2014-04-25','16:25:00',2.99),('8537','2014-04-25','16:30:00',3.09),('8537','2014-04-25','16:35:00',3.05),('8537','2014-04-25','16:40:00',3.07),('8537','2014-04-25','16:45:00',2.9),('8537','2014-04-25','16:50:00',2.68),('8537','2014-04-25','16:55:00',2.28),('8537','2014-04-25','17:00:00',2.11),('8537','2014-04-25','17:05:00',2.28),('8537','2014-04-25','17:10:00',2),('8537','2014-04-25','17:15:00',2.04),('8537','2014-04-25','17:20:00',1.52),('8537','2014-04-25','17:25:00',1.1),('8537','2014-04-25','17:30:00',1.06),('8537','2014-04-25','17:35:00',1.08),('8537','2014-04-25','17:40:00',1.07),('8537','2014-04-24','07:45:00',1.03),('8537','2014-04-24','07:50:00',1.13),('8537','2014-04-24','07:55:00',1.24),('8537','2014-04-24','08:05:00',1.44),('8537','2014-04-24','08:10:00',1.55),('8537','2014-04-24','08:15:00',1.66),('8537','2014-04-24','08:20:00',1.79),('8537','2014-04-24','08:25:00',1.9),('8537','2014-04-24','08:30:00',2.01),('8537','2014-04-24','08:35:00',2.11),('8537','2014-04-24','08:40:00',2.22),('8537','2014-04-24','08:45:00',2.31),('8537','2014-04-24','08:50:00',2.41),('8537','2014-04-24','08:55:00',2.52),('8537','2014-04-24','09:00:00',2.62),('8537','2014-04-24','09:05:00',2.7),('8537','2014-04-24','09:10:00',2.8),('8537','2014-04-24','09:15:00',2.91),('8537','2014-04-24','09:20:00',2.97),('8537','2014-04-24','09:25:00',3.07),('8537','2014-04-24','09:30:00',3.15),('8537','2014-04-24','09:35:00',3.25),('8537','2014-04-24','09:40:00',3.35),('8537','2014-04-24','09:45:00',3.44),('8537','2014-04-24','09:50:00',3.49),('8537','2014-04-24','09:55:00',3.57),('8537','2014-04-24','10:00:00',3.65),('8537','2014-04-24','10:05:00',3.72),('8537','2014-04-24','10:10:00',3.76),('8537','2014-04-24','10:15:00',3.8),('8537','2014-04-24','10:20:00',3.85),('8537','2014-04-24','10:25:00',3.89),('8537','2014-04-24','10:30:00',3.97),('8537','2014-04-24','10:35:00',4.03),('8537','2014-04-24','10:40:00',4.13),('8537','2014-04-24','10:45:00',4.15),('8537','2014-04-24','10:50:00',4.26),('8537','2014-04-24','10:55:00',4.31),('8537','2014-04-24','11:00:00',4.34),('8537','2014-04-24','11:05:00',4.33),('8537','2014-04-24','11:10:00',4.35),('8537','2014-04-24','11:15:00',4.46),('8537','2014-04-24','11:20:00',4.49),('8537','2014-04-24','11:25:00',4.52),('8537','2014-04-24','11:30:00',4.54),('8537','2014-04-24','11:35:00',4.6),('8537','2014-04-24','11:40:00',4.64),('8537','2014-04-24','11:45:00',4.61),('8537','2014-04-24','11:50:00',4.65),('8537','2014-04-24','11:55:00',4.68),('8537','2014-04-24','12:00:00',4.6),('8537','2014-04-24','12:05:00',4.82),('8537','2014-04-24','12:10:00',4.94),('8537','2014-04-24','12:15:00',2.36),('8537','2014-04-24','12:20:00',3.71),('8537','2014-04-24','12:25:00',5.08),('8537','2014-04-24','12:30:00',5.05),('8537','2014-04-24','12:35:00',5.09),('8537','2014-04-24','12:40:00',5.15),('8537','2014-04-24','12:45:00',5.13),('8537','2014-04-24','12:50:00',5.17),('8537','2014-04-24','12:55:00',5.09),('8537','2014-04-24','13:00:00',4.99),('8537','2014-04-24','13:05:00',5),('8537','2014-04-24','13:10:00',4.98),('8537','2014-04-24','13:15:00',5.07),('8537','2014-04-24','13:20:00',5.25),('8537','2014-04-24','13:25:00',5.14),('8537','2014-04-24','13:30:00',5.14),('8537','2014-04-24','13:35:00',5.1),('8537','2014-04-24','13:40:00',1.54),('8537','2014-04-24','13:45:00',3.89),('8537','2014-04-24','13:50:00',5.59),('8537','2014-04-24','13:55:00',5.69),('8537','2014-04-24','14:00:00',3.32),('8537','2014-04-24','14:05:00',4.99),('8537','2014-04-24','14:10:00',4.9),('8537','2014-04-24','14:15:00',4.1),('8537','2014-04-24','14:20:00',3.93),('8537','2014-04-24','14:25:00',4.86),('8537','2014-04-24','14:30:00',5.24),('8537','2014-04-24','14:35:00',4.85),('8537','2014-04-24','14:40:00',3.64),('8537','2014-04-24','14:45:00',2.95),('8537','2014-04-24','14:50:00',1.85),('8537','2014-04-24','14:55:00',4.48),('8537','2014-04-24','15:00:00',5.37),('8537','2014-04-24','15:05:00',5.18),('8537','2014-04-24','15:10:00',4.9),('8537','2014-04-24','15:15:00',4.44),('8537','2014-04-24','15:20:00',2.9),('8537','2014-04-24','15:25:00',2.55),('8537','2014-04-24','15:30:00',3.18),('8537','2014-04-24','15:35:00',3.05),('8537','2014-04-24','15:40:00',2.56),('8537','2014-04-24','15:45:00',2.34),('8537','2014-04-24','15:50:00',2.61),('8537','2014-04-24','15:55:00',2.98),('8537','2014-04-24','16:00:00',4.25),('8537','2014-04-24','16:05:00',4.13),('8537','2014-04-24','16:10:00',3.44),('8537','2014-04-24','16:15:00',3.8),('8537','2014-04-24','16:20:00',3.4),('8537','2014-04-24','16:25:00',2.85),('8537','2014-04-24','16:30:00',3.25),('8537','2014-04-24','16:35:00',2.07),('8537','2014-04-24','16:40:00',2.26),('8537','2014-04-24','16:45:00',2.21),('8537','2014-04-24','16:50:00',1.64),('8537','2014-04-24','16:55:00',1.75),('8537','2014-04-24','17:00:00',1.59),('8537','2014-04-24','17:05:00',1.44),('8537','2014-04-24','17:10:00',1.35),('8537','2014-04-24','17:15:00',1.23),('8537','2014-04-24','17:20:00',1.24),('8537','2014-04-24','17:25:00',1.22),('8537','2014-04-24','17:30:00',1.19),('8537','2014-04-24','17:35:00',1.14),('8537','2014-04-24','17:40:00',1),('8537','2014-04-23','13:05:00',1.02),('8537','2014-04-23','13:10:00',1.26),('8537','2014-04-23','13:15:00',1.39),('8537','2014-04-23','13:20:00',1.47),('8537','2014-04-23','13:25:00',1.54),('8537','2014-04-23','13:30:00',1.65),('8537','2014-04-23','13:35:00',1.73),('8537','2014-04-23','13:40:00',1.82),('8537','2014-04-23','13:45:00',1.85),('8537','2014-04-23','13:50:00',1.82),('8537','2014-04-23','13:55:00',1.79),('8537','2014-04-23','14:00:00',1.68),('8537','2014-04-23','14:05:00',1.72),('8537','2014-04-23','14:10:00',1.6),('8537','2014-04-23','14:15:00',1.34),('8537','2014-04-23','14:20:00',1.19),('8537','2014-04-23','14:25:00',1.1),('8537','2014-04-23','14:30:00',1.05),('8537','2014-04-23','14:35:00',1.04),('8537','2014-04-23','14:40:00',1.14),('8537','2014-04-23','14:45:00',1.37),('8537','2014-04-23','14:50:00',1.66),('8537','2014-04-23','14:55:00',1.9),('8537','2014-04-23','15:00:00',2.06),('8537','2014-04-23','15:05:00',2.08),('8537','2014-04-23','15:10:00',2.09),('8537','2014-04-23','15:15:00',2.09),('8537','2014-04-23','15:20:00',1.73),('8537','2014-04-23','15:25:00',1.64),('8537','2014-04-23','15:30:00',1.59),('8537','2014-04-23','15:35:00',1.51),('8537','2014-04-23','15:40:00',1.48),('8537','2014-04-23','15:45:00',1.43),('8537','2014-04-23','15:50:00',1.22),('8537','2014-04-23','15:55:00',1.17),('8537','2014-04-23','16:00:00',1.02),('8537','2014-04-22','07:50:00',1.08),('8537','2014-04-22','07:55:00',1.18),('8537','2014-04-22','08:00:00',1.27),('8537','2014-04-22','08:05:00',1.38),('8537','2014-04-22','08:10:00',1.5),('8537','2014-04-22','08:15:00',1.6),('8537','2014-04-22','08:20:00',1.73),('8537','2014-04-22','08:25:00',1.83),('8537','2014-04-22','08:30:00',1.94),('8537','2014-04-22','08:35:00',2.06),('8537','2014-04-22','08:40:00',2.17),('8537','2014-04-22','08:45:00',2.25),('8537','2014-04-22','08:50:00',2.35),('8537','2014-04-22','08:55:00',2.39),('8537','2014-04-22','09:00:00',2.49),('8537','2014-04-22','09:05:00',2.77),('8537','2014-04-22','09:10:00',2.65),('8537','2014-04-22','09:15:00',2.63),('8537','2014-04-22','09:20:00',2.93),('8537','2014-04-22','09:25:00',3.1),('8537','2014-04-22','09:30:00',3.15),('8537','2014-04-22','09:35:00',3.31),('8537','2014-04-22','09:40:00',3.27),('8537','2014-04-22','09:45:00',3.49),('8537','2014-04-22','09:50:00',2.83),('8537','2014-04-22','09:55:00',1.73),('8537','2014-04-22','10:00:00',1.6),('8537','2014-04-22','10:05:00',1.69),('8537','2014-04-22','10:10:00',2.23),('8537','2014-04-22','10:15:00',2.43),('8537','2014-04-22','10:20:00',3.7),('8537','2014-04-22','10:25:00',2.61),('8537','2014-04-22','10:30:00',4.08),('8537','2014-04-22','10:35:00',4.25),('8537','2014-04-22','10:40:00',4.03),('8537','2014-04-22','10:45:00',4.35),('8537','2014-04-22','10:50:00',4.79),('8537','2014-04-22','10:55:00',3.57),('8537','2014-04-22','11:00:00',2.4),('8537','2014-04-22','11:05:00',2.95),('8537','2014-04-22','11:10:00',1.97),('8537','2014-04-22','11:15:00',1.63),('8537','2014-04-22','11:20:00',1.42),('8537','2014-04-22','11:25:00',1.45),('8537','2014-04-22','11:30:00',1.29),('8537','2014-04-22','11:35:00',1.36),('8537','2014-04-22','11:40:00',1.25),('8537','2014-04-22','11:45:00',1.06),('8537','2014-04-22','11:50:00',1.05),('8537','2014-04-22','12:00:00',1.09),('8537','2014-04-22','12:05:00',1.34),('8537','2014-04-22','12:10:00',1.39),('8537','2014-04-22','12:15:00',1.42),('8537','2014-04-22','12:20:00',1.49),('8537','2014-04-22','12:25:00',1.6),('8537','2014-04-22','12:30:00',1.86),('8537','2014-04-22','12:35:00',1.64),('8537','2014-04-22','12:40:00',1.22),('8537','2014-04-22','12:45:00',1.01),('8537','2014-04-22','13:10:00',1.04),('8537','2014-04-22','13:15:00',1.6),('8537','2014-04-22','13:20:00',2.71),('8537','2014-04-22','13:25:00',3.03),('8537','2014-04-22','13:30:00',3.38),('8537','2014-04-22','13:35:00',3.1),('8537','2014-04-22','13:40:00',3.82),('8537','2014-04-22','13:45:00',3.86),('8537','2014-04-22','13:50:00',3.35),('8537','2014-04-22','13:55:00',1.84),('8537','2014-04-22','14:00:00',1.6),('8537','2014-04-22','14:05:00',1.92),('8537','2014-04-22','14:10:00',4.15),('8537','2014-04-22','14:15:00',3.85),('8537','2014-04-22','14:20:00',4.22),('8537','2014-04-22','14:25:00',3.17),('8537','2014-04-22','14:30:00',2.42),('8537','2014-04-22','14:35:00',2.83),('8537','2014-04-22','14:40:00',3.7),('8537','2014-04-22','14:45:00',4.4),('8537','2014-04-22','14:50:00',4.28),('8537','2014-04-22','14:55:00',3.35),('8537','2014-04-22','15:00:00',1.55),('8537','2014-04-22','15:05:00',1.5),('8537','2014-04-22','15:10:00',1.36),('8537','2014-04-22','15:15:00',1.33),('8537','2014-04-22','15:20:00',1.47),('8537','2014-04-22','15:25:00',1.68),('8537','2014-04-22','15:30:00',2.05),('8537','2014-04-22','15:35:00',2.89),('8537','2014-04-22','15:40:00',2.56),('8537','2014-04-22','15:45:00',2.09),('8537','2014-04-22','15:50:00',2.46),('8537','2014-04-22','15:55:00',2.07),('8537','2014-04-22','16:00:00',2.34),('8537','2014-04-22','16:05:00',1.73),('8537','2014-04-22','16:10:00',1.63),('8537','2014-04-22','16:15:00',1.55),('8537','2014-04-22','16:20:00',1.85),('8537','2014-04-22','16:25:00',1.75),('8537','2014-04-22','16:30:00',1.47),('8537','2014-04-22','16:35:00',1.47),('8537','2014-04-22','16:40:00',1.87),('8537','2014-04-22','16:45:00',1.88),('8537','2014-04-22','16:50:00',1.51),('8537','2014-04-22','16:55:00',1.31),('8537','2014-04-22','17:00:00',1.41),('8537','2014-04-22','17:05:00',1.61),('8537','2014-04-22','17:10:00',1.29),('8537','2014-04-22','17:15:00',1.16),('8537','2014-04-21','08:40:00',1.01),('8537','2014-04-21','09:00:00',1.04),('8537','2014-04-21','09:05:00',1.04),('8537','2014-04-21','09:10:00',1.06),('8537','2014-04-21','09:15:00',1.14),('8537','2014-04-21','09:20:00',1.76),('8537','2014-04-21','09:25:00',1.39),('8537','2014-04-21','09:45:00',1.02),('8537','2014-04-21','09:50:00',1.1),('8537','2014-04-21','09:55:00',1.27),('8537','2014-04-21','10:00:00',1.72),('8537','2014-04-21','10:05:00',3.57),('8537','2014-04-21','10:10:00',3.88),('8537','2014-04-21','10:15:00',3.99),('8537','2014-04-21','10:20:00',3.9),('8537','2014-04-21','10:25:00',3.88),('8537','2014-04-21','10:30:00',3.97),('8537','2014-04-21','10:35:00',4.01),('8537','2014-04-21','10:40:00',4.06),('8537','2014-04-21','10:45:00',4.09),('8537','2014-04-21','10:50:00',4.12),('8537','2014-04-21','10:55:00',4.16),('8537','2014-04-21','11:00:00',4.21),('8537','2014-04-21','11:05:00',4.25),('8537','2014-04-21','11:10:00',4.31),('8537','2014-04-21','11:15:00',4.34),('8537','2014-04-21','11:20:00',4.38),('8537','2014-04-21','11:25:00',4.42),('8537','2014-04-21','11:30:00',4.5),('8537','2014-04-21','11:35:00',4.56),('8537','2014-04-21','11:40:00',4.59),('8537','2014-04-21','11:45:00',4.64),('8537','2014-04-21','11:50:00',4.66),('8537','2014-04-21','11:55:00',4.65),('8537','2014-04-21','12:00:00',4.7),('8537','2014-04-21','12:05:00',4.75),('8537','2014-04-21','12:10:00',4.77),('8537','2014-04-21','12:15:00',4.84),('8537','2014-04-21','12:20:00',4.88),('8537','2014-04-21','12:25:00',4.92),('8537','2014-04-21','12:30:00',4.93),('8537','2014-04-21','12:35:00',4.93),('8537','2014-04-21','12:40:00',4.93),('8537','2014-04-21','12:45:00',4.99),('8537','2014-04-21','12:50:00',4.99),('8537','2014-04-21','12:55:00',4.99),('8537','2014-04-21','13:00:00',4.95),('8537','2014-04-21','13:05:00',4.98),('8537','2014-04-21','13:10:00',5.01),('8537','2014-04-21','13:15:00',4.99),('8537','2014-04-21','13:20:00',4.96),('8537','2014-04-21','13:25:00',4.93),('8537','2014-04-21','13:30:00',4.88),('8537','2014-04-21','13:35:00',4.93),('8537','2014-04-21','13:40:00',4.93),('8537','2014-04-21','13:45:00',4.95),('8537','2014-04-21','13:50:00',4.95),('8537','2014-04-21','13:55:00',4.93),('8537','2014-04-21','14:00:00',4.91),('8537','2014-04-21','14:05:00',4.9),('8537','2014-04-21','14:10:00',4.88),('8537','2014-04-21','14:15:00',4.85),('8537','2014-04-21','14:20:00',4.83),('8537','2014-04-21','14:25:00',4.77),('8537','2014-04-21','14:30:00',4.73),('8537','2014-04-21','14:35:00',4.46),('8537','2014-04-21','14:40:00',4.05),('8537','2014-04-21','14:45:00',4.38),('8537','2014-04-21','14:50:00',4.51),('8537','2014-04-21','14:55:00',4.48),('8537','2014-04-21','15:00:00',4.42),('8537','2014-04-21','15:05:00',4.39),('8537','2014-04-21','15:10:00',4.31),('8537','2014-04-21','15:15:00',4.24),('8537','2014-04-21','15:20:00',4.21),('8537','2014-04-21','15:25:00',4.08),('8537','2014-04-21','15:30:00',4),('8537','2014-04-21','15:35:00',3.98),('8537','2014-04-21','15:40:00',3.9),('8537','2014-04-21','15:45:00',3.83),('8537','2014-04-21','15:50:00',3.77),('8537','2014-04-21','15:55:00',3.71),('8537','2014-04-21','16:00:00',3.66),('8537','2014-04-21','16:05:00',3.51),('8537','2014-04-21','16:10:00',3.09),('8537','2014-04-21','16:15:00',2.95),('8537','2014-04-21','16:20:00',3.33),('8537','2014-04-21','16:25:00',3.18),('8537','2014-04-21','16:30:00',3.07),('8537','2014-04-21','16:35:00',3.08),('8537','2014-04-21','16:40:00',2.99),('8537','2014-04-21','16:45:00',2.85),('8537','2014-04-21','16:50:00',2.78),('8537','2014-04-21','16:55:00',2.68),('8537','2014-04-21','17:00:00',2.57),('8537','2014-04-21','17:05:00',2.38),('8537','2014-04-21','17:10:00',2.34),('8537','2014-04-21','17:15:00',2.24),('8537','2014-04-21','17:20:00',2.15),('8537','2014-04-21','17:25:00',2.04),('8537','2014-04-21','17:30:00',1.94),('8537','2014-04-21','17:35:00',1.79),('8537','2014-04-21','17:40:00',1.62),('8537','2014-04-21','17:45:00',1.6),('8537','2014-04-21','17:50:00',1.51),('8537','2014-04-21','17:55:00',1.38),('8537','2014-04-21','18:00:00',1.27),('8537','2014-04-21','18:05:00',1.17),('8537','2014-04-21','18:10:00',1.06),('8537','2014-04-20','07:50:00',1.1),('8537','2014-04-20','07:55:00',1.27),('8537','2014-04-20','08:00:00',1.29),('8537','2014-04-20','08:05:00',1.34),('8537','2014-04-20','08:10:00',1.42),('8537','2014-04-20','08:15:00',1.61),('8537','2014-04-20','08:20:00',1.9),('8537','2014-04-20','08:25:00',2.53),('8537','2014-04-20','08:30:00',2.85),('8537','2014-04-20','08:35:00',2.79),('8537','2014-04-20','08:40:00',2.19),('8537','2014-04-20','08:45:00',2.07),('8537','2014-04-20','08:50:00',2.09),('8537','2014-04-20','08:55:00',1.14),('8537','2014-04-20','09:00:00',2.04),('8537','2014-04-20','09:10:00',1.81),('8537','2014-04-20','09:15:00',3.15),('8537','2014-04-20','09:20:00',3.18),('8537','2014-04-20','09:25:00',3.5),('8537','2014-04-20','09:30:00',4.02),('8537','2014-04-20','09:35:00',3.08),('8537','2014-04-20','09:40:00',2.4),('8537','2014-04-20','09:45:00',1.65),('8537','2014-04-20','09:50:00',1.84),('8537','2014-04-20','09:55:00',2.15),('8537','2014-04-20','10:00:00',2.74),('8537','2014-04-20','10:05:00',3.32),('8537','2014-04-20','10:10:00',3.08),('8537','2014-04-20','10:15:00',3.61),('8537','2014-04-20','10:20:00',3.72),('8537','2014-04-20','10:25:00',3.16),('8537','2014-04-20','10:30:00',2.99),('8537','2014-04-20','10:35:00',3.22),('8537','2014-04-20','10:40:00',3.13),('8537','2014-04-20','10:45:00',3.23),('8537','2014-04-20','10:50:00',3.48),('8537','2014-04-20','10:55:00',3.53),('8537','2014-04-20','11:00:00',4.1),('8537','2014-04-20','11:05:00',4.14),('8537','2014-04-20','11:10:00',3.95),('8537','2014-04-20','11:15:00',4.68),('8537','2014-04-20','11:20:00',3.75),('8537','2014-04-20','11:25:00',2.86),('8537','2014-04-20','11:30:00',4.99),('8537','2014-04-20','11:35:00',4.85),('8537','2014-04-20','11:40:00',3.77),('8537','2014-04-20','11:45:00',4.67),('8537','2014-04-20','11:50:00',3.8),('8537','2014-04-20','11:55:00',1.66),('8537','2014-04-20','12:00:00',3.8),('8537','2014-04-20','12:05:00',5.35),('8537','2014-04-20','12:10:00',3.54),('8537','2014-04-20','12:15:00',1.89),('8537','2014-04-20','12:20:00',2.72),('8537','2014-04-20','12:25:00',5.73),('8537','2014-04-20','12:30:00',5.32),('8537','2014-04-20','12:35:00',5.07),('8537','2014-04-20','12:40:00',5.1),('8537','2014-04-20','12:45:00',5.14),('8537','2014-04-20','12:50:00',5.2),('8537','2014-04-20','12:55:00',5.2),('8537','2014-04-20','13:00:00',5.26),('8537','2014-04-20','13:05:00',5.28),('8537','2014-04-20','13:10:00',5.29),('8537','2014-04-20','13:15:00',5.37),('8537','2014-04-20','13:20:00',5.11),('8537','2014-04-20','13:25:00',5.11),('8537','2014-04-20','13:30:00',5.13),('8537','2014-04-20','13:35:00',5.1),('8537','2014-04-20','13:40:00',5.11),('8537','2014-04-20','13:45:00',5.08),('8537','2014-04-20','13:50:00',5.05),('8537','2014-04-20','13:55:00',5.04),('8537','2014-04-20','14:00:00',5.01),('8537','2014-04-20','14:05:00',5.04),('8537','2014-04-20','14:10:00',5.01),('8537','2014-04-20','14:15:00',5.16),('8537','2014-04-20','14:20:00',4.09),('8537','2014-04-20','14:25:00',3.68),('8537','2014-04-20','14:30:00',3.58),('8537','2014-04-20','14:35:00',2.92),('8537','2014-04-20','14:40:00',2.87),('8537','2014-04-20','14:45:00',3.1),('8537','2014-04-20','14:50:00',3),('8537','2014-04-20','14:55:00',3.32),('8537','2014-04-20','15:00:00',3.73),('8537','2014-04-20','15:05:00',3.68),('8537','2014-04-20','15:10:00',4.37),('8537','2014-04-20','15:15:00',4.46),('8537','2014-04-20','15:20:00',4.24),('8537','2014-04-20','15:25:00',4.2),('8537','2014-04-20','15:30:00',3.87),('8537','2014-04-20','15:35:00',3.76),('8537','2014-04-20','15:40:00',4.13),('8537','2014-04-20','15:45:00',3.46),('8537','2014-04-20','15:50:00',2.77),('8537','2014-04-20','15:55:00',3.96),('8537','2014-04-20','16:00:00',3.8),('8537','2014-04-20','16:05:00',3.69),('8537','2014-04-20','16:10:00',3.61),('8537','2014-04-20','16:15:00',3.56),('8537','2014-04-20','16:20:00',3.55),('8537','2014-04-20','16:25:00',2.92),('8537','2014-04-20','16:30:00',3.5),('8537','2014-04-20','16:35:00',3.23),('8537','2014-04-20','16:40:00',3.27),('8537','2014-04-20','16:45:00',2.51),('8537','2014-04-20','16:50:00',2.93),('8537','2014-04-20','16:55:00',2.87),('8537','2014-04-20','17:00:00',2.73),('8537','2014-04-20','17:05:00',2.48),('8537','2014-04-20','17:10:00',2.39),('8537','2014-04-20','17:15:00',2.27),('8537','2014-04-20','17:20:00',2.17),('8537','2014-04-20','17:25:00',2.04),('8537','2014-04-20','17:30:00',1.94),('8537','2014-04-20','17:35:00',1.78),('8537','2014-04-20','17:40:00',1.7),('8537','2014-04-20','17:45:00',1.59),('8537','2014-04-20','17:50:00',1.48),('8537','2014-04-20','17:55:00',1.37),('8537','2014-04-20','18:00:00',1.27),('8537','2014-04-20','18:05:00',1.17),('8537','2014-04-20','18:10:00',1.06),('8537','2014-04-19','07:35:00',1.01),('8537','2014-04-19','07:40:00',1.19),('8537','2014-04-19','07:55:00',1.91),('8537','2014-04-19','08:00:00',1.74),('8537','2014-04-19','08:05:00',1.26),('8537','2014-04-19','08:10:00',1.71),('8537','2014-04-19','08:15:00',1.24),('8537','2014-04-19','08:20:00',1.32),('8537','2014-04-19','08:25:00',1.72),('8537','2014-04-19','08:30:00',2.26),('8537','2014-04-19','08:35:00',2.91),('8537','2014-04-19','08:40:00',2.42),('8537','2014-04-19','08:45:00',2.26),('8537','2014-04-19','08:50:00',1.77),('8537','2014-04-19','08:55:00',1.24),('8537','2014-04-19','09:20:00',1.17),('8537','2014-04-19','09:25:00',1.59),('8537','2014-04-19','09:30:00',2.44),('8537','2014-04-19','09:35:00',2.49),('8537','2014-04-19','09:40:00',1.46),('8537','2014-04-19','09:45:00',1.08),('8537','2014-04-19','10:35:00',1.04),('8537','2014-04-19','10:40:00',1.41),('8537','2014-04-19','10:45:00',1.35),('8537','2014-04-19','10:50:00',1.37),('8537','2014-04-19','10:55:00',1.74),('8537','2014-04-19','11:00:00',1.86),('8537','2014-04-19','11:05:00',1.5),('8537','2014-04-19','11:10:00',1.4),('8537','2014-04-19','11:15:00',2.06),('8537','2014-04-19','11:20:00',3.6),('8537','2014-04-19','11:25:00',3.09),('8537','2014-04-19','11:30:00',3.17),('8537','2014-04-19','11:35:00',2.81),('8537','2014-04-19','11:40:00',2.94),('8537','2014-04-19','11:45:00',2.51),('8537','2014-04-19','11:50:00',2.09),('8537','2014-04-19','11:55:00',1.26),('8537','2014-04-19','13:15:00',1.72),('8537','2014-04-19','13:20:00',1.42),('8537','2014-04-19','13:50:00',1.02),('8537','2014-04-19','14:30:00',1.54),('8537','2014-04-19','14:35:00',1.78),('8537','2014-04-19','14:40:00',2.1),('8537','2014-04-19','14:45:00',2.2),('8537','2014-04-19','14:50:00',1.51),('8537','2014-04-19','14:55:00',1.27),('8537','2014-04-19','15:00:00',1.64),('8537','2014-04-19','15:05:00',1.45),('8537','2014-04-19','15:25:00',1.27),('8537','2014-04-19','15:30:00',1.33),('8537','2014-04-19','15:45:00',1.08),('8537','2014-04-19','15:50:00',3.4),('8537','2014-04-19','15:55:00',3.49),('8537','2014-04-19','16:00:00',2.1),('8537','2014-04-19','16:05:00',1.9),('8537','2014-04-19','16:10:00',1.9),('8537','2014-04-19','16:15:00',1.93),('8537','2014-04-19','16:20:00',2.28),('8537','2014-04-19','16:25:00',2.22),('8537','2014-04-19','16:30:00',3.02),('8537','2014-04-19','16:35:00',1.85),('8537','2014-04-19','16:40:00',1.28),('8537','2014-04-19','16:45:00',1.1),('8537','2014-04-19','17:10:00',1.08),('8537','2014-04-19','17:15:00',1.06),('8537','2014-04-19','17:20:00',1.75),('8537','2014-04-19','17:25:00',1.47),('8537','2014-04-19','17:30:00',1.28),('8537','2014-04-19','17:35:00',1.04),('8537','2014-04-18','08:00:00',1.01),('8537','2014-04-18','08:05:00',1.91),('8537','2014-04-18','08:10:00',1.74),('8537','2014-04-18','08:35:00',1.17),('8537','2014-04-18','08:40:00',1.72),('8537','2014-04-18','08:45:00',1.73),('8537','2014-04-18','08:50:00',1.29),('8537','2014-04-18','08:55:00',1.18),('8537','2014-04-18','09:00:00',1.42),('8537','2014-04-18','09:05:00',2.98),('8537','2014-04-18','09:10:00',3.79),('8537','2014-04-18','09:15:00',3.49),('8537','2014-04-18','09:20:00',3.26),('8537','2014-04-18','09:25:00',2.26),('8537','2014-04-18','09:30:00',3.69),('8537','2014-04-18','09:35:00',2.14),('8537','2014-04-18','09:40:00',1.45),('8537','2014-04-18','09:45:00',2.08),('8537','2014-04-18','09:50:00',3.5),('8537','2014-04-18','09:55:00',3.37),('8537','2014-04-18','10:00:00',3.07),('8537','2014-04-18','10:05:00',2.05),('8537','2014-04-18','10:10:00',1.84),('8537','2014-04-18','10:15:00',2.12),('8537','2014-04-18','10:20:00',1.75),('8537','2014-04-18','10:25:00',1.81),('8537','2014-04-18','10:30:00',1.52),('8537','2014-04-18','10:35:00',1.37),('8537','2014-04-18','10:40:00',1.64),('8537','2014-04-18','10:45:00',3.12),('8537','2014-04-18','10:50:00',3.43),('8537','2014-04-18','10:55:00',3.58),('8537','2014-04-18','11:00:00',2.16),('8537','2014-04-18','11:05:00',1.92),('8537','2014-04-18','11:10:00',2.54),('8537','2014-04-18','11:15:00',3.44),('8537','2014-04-18','11:20:00',2.22),('8537','2014-04-18','11:25:00',1.61),('8537','2014-04-18','11:30:00',1.95),('8537','2014-04-18','11:35:00',1.89),('8537','2014-04-18','11:40:00',1.97),('8537','2014-04-18','11:45:00',1.85),('8537','2014-04-18','11:50:00',2.23),('8537','2014-04-18','11:55:00',2.06),('8537','2014-04-18','12:00:00',2.09),('8537','2014-04-18','12:05:00',3.55),('8537','2014-04-18','12:10:00',3.95),('8537','2014-04-18','12:15:00',3.96),('8537','2014-04-18','12:20:00',4.69),('8537','2014-04-18','12:25:00',3.72),('8537','2014-04-18','12:30:00',5.39),('8537','2014-04-18','12:35:00',5.05),('8537','2014-04-18','12:40:00',5.31),('8537','2014-04-18','12:45:00',4.3),('8537','2014-04-18','12:50:00',3.71),('8537','2014-04-18','12:55:00',2.46),('8537','2014-04-18','13:00:00',5.43),('8537','2014-04-18','13:05:00',3.67),('8537','2014-04-18','13:10:00',2.93),('8537','2014-04-18','13:15:00',2.85),('8537','2014-04-18','13:20:00',2.59),('8537','2014-04-18','13:25:00',1.93),('8537','2014-04-18','13:30:00',1.65),('8537','2014-04-18','13:35:00',1.64),('8537','2014-04-18','13:40:00',1.45),('8537','2014-04-18','13:45:00',1.27),('8537','2014-04-18','13:50:00',1.58),('8537','2014-04-18','13:55:00',2.51),('8537','2014-04-18','14:00:00',2.26),('8537','2014-04-18','14:05:00',1.92),('8537','2014-04-18','14:10:00',1.69),('8537','2014-04-18','14:15:00',1.51),('8537','2014-04-18','14:20:00',1.79),('8537','2014-04-18','14:25:00',2.34),('8537','2014-04-18','14:30:00',2.6),('8537','2014-04-18','14:35:00',2.98),('8537','2014-04-18','14:40:00',2.65),('8537','2014-04-18','14:45:00',3.26),('8537','2014-04-18','14:50:00',3.69),('8537','2014-04-18','14:55:00',2.52),('8537','2014-04-18','15:00:00',4.78),('8537','2014-04-18','15:05:00',2.9),('8537','2014-04-18','15:10:00',2.37),('8537','2014-04-18','15:15:00',2.6),('8537','2014-04-18','15:20:00',2.26),('8537','2014-04-18','15:25:00',2.48),('8537','2014-04-18','15:30:00',3.6),('8537','2014-04-18','15:35:00',4.48),('8537','2014-04-18','15:40:00',2.46),('8537','2014-04-18','15:45:00',2.71),('8537','2014-04-18','15:50:00',3.35),('8537','2014-04-18','15:55:00',2.87),('8537','2014-04-18','16:00:00',2.56),('8537','2014-04-18','16:05:00',2.02),('8537','2014-04-18','16:10:00',1.66),('8537','2014-04-18','16:15:00',1.44),('8537','2014-04-18','16:20:00',1.49),('8537','2014-04-18','16:25:00',2.12),('8537','2014-04-18','16:30:00',2.19),('8537','2014-04-18','16:35:00',2.48),('8537','2014-04-18','16:40:00',3.27),('8537','2014-04-18','16:45:00',3.07),('8537','2014-04-18','16:50:00',2.82),('8537','2014-04-18','16:55:00',2.16),('8537','2014-04-18','17:00:00',2.25),('8537','2014-04-18','17:05:00',2.87),('8537','2014-04-18','17:10:00',2.09),('8537','2014-04-18','17:15:00',2.3),('8537','2014-04-18','17:20:00',1.97),('8537','2014-04-18','17:25:00',2.14),('8537','2014-04-18','17:30:00',1.94),('8537','2014-04-18','17:35:00',1.77),('8537','2014-04-18','17:40:00',1.7),('8537','2014-04-18','17:45:00',1.58),('8537','2014-04-18','17:50:00',1.5),('8537','2014-04-18','17:55:00',1.39),('8537','2014-04-18','18:00:00',1.29),('8537','2014-04-18','18:05:00',1.16),('8537','2014-04-18','18:10:00',1.03),('8537','2014-04-17','08:00:00',1.33),('8537','2014-04-17','08:05:00',1.48),('8537','2014-04-17','08:10:00',1.61),('8537','2014-04-17','08:15:00',1.73),('8537','2014-04-17','08:20:00',1.77),('8537','2014-04-17','08:25:00',1.95),('8537','2014-04-17','08:30:00',2.07),('8537','2014-04-17','08:35:00',2.17),('8537','2014-04-17','08:40:00',2.29),('8537','2014-04-17','08:45:00',2.4),('8537','2014-04-17','08:50:00',2.51),('8537','2014-04-17','08:55:00',2.28),('8537','2014-04-17','09:00:00',2.26),('8537','2014-04-17','09:05:00',2.64),('8537','2014-04-17','09:10:00',2.91),('8537','2014-04-17','09:15:00',2.91),('8537','2014-04-17','09:20:00',3.19),('8537','2014-04-17','09:25:00',3.29),('8537','2014-04-17','09:30:00',3.39),('8537','2014-04-17','09:35:00',3.5),('8537','2014-04-17','09:40:00',3.6),('8537','2014-04-17','09:45:00',3.71),('8537','2014-04-17','09:50:00',3.79),('8537','2014-04-17','09:55:00',3.92),('8537','2014-04-17','10:00:00',4.07),('8537','2014-04-17','10:05:00',4.37),('8537','2014-04-17','10:10:00',4.12),('8537','2014-04-17','10:15:00',3.63),('8537','2014-04-17','10:20:00',4.32),('8537','2014-04-17','10:25:00',4.7),('8537','2014-04-17','10:30:00',4.99),('8537','2014-04-17','10:35:00',5.23),('8537','2014-04-17','10:40:00',4.93),('8537','2014-04-17','10:45:00',4.07),('8537','2014-04-17','10:50:00',3.07),('8537','2014-04-17','10:55:00',3.1),('8537','2014-04-17','11:00:00',3.08),('8537','2014-04-17','11:05:00',4.17),('8537','2014-04-17','11:10:00',3.97),('8537','2014-04-17','11:15:00',3.5),('8537','2014-04-17','11:20:00',4.05),('8537','2014-04-17','11:25:00',4.46),('8537','2014-04-17','11:30:00',2.98),('8537','2014-04-17','11:35:00',3.31),('8537','2014-04-17','11:40:00',3.17),('8537','2014-04-17','11:45:00',4.46),('8537','2014-04-17','11:50:00',3.15),('8537','2014-04-17','11:55:00',2.37),('8537','2014-04-17','12:00:00',2.78),('8537','2014-04-17','12:05:00',3.51),('8537','2014-04-17','12:10:00',3.27),('8537','2014-04-17','12:15:00',2.93),('8537','2014-04-17','12:20:00',2.77),('8537','2014-04-17','12:25:00',3),('8537','2014-04-17','12:30:00',3.83),('8537','2014-04-17','12:35:00',4.7),('8537','2014-04-17','12:40:00',5.41),('8537','2014-04-17','12:45:00',5.08),('8537','2014-04-17','12:50:00',5.32),('8537','2014-04-17','12:55:00',5.49),('8537','2014-04-17','13:00:00',5.48),('8537','2014-04-17','13:05:00',1.15),('8537','2014-04-17','13:15:00',1.52),('8537','2014-04-17','13:20:00',1.54),('8537','2014-04-17','13:25:00',6),('8537','2014-04-17','13:30:00',5.31),('8537','2014-04-17','13:35:00',1.27),('8537','2014-04-17','13:40:00',1.13),('8537','2014-04-17','13:45:00',1.1),('8537','2014-04-17','13:50:00',1.25),('8537','2014-04-17','13:55:00',1.39),('8537','2014-04-17','14:00:00',1.3),('8537','2014-04-17','14:05:00',1.36),('8537','2014-04-17','14:10:00',3.15),('8537','2014-04-17','14:15:00',2.01),('8537','2014-04-17','14:20:00',1.57),('8537','2014-04-17','14:25:00',2.21),('8537','2014-04-17','14:30:00',1.86),('8537','2014-04-17','14:35:00',2.17),('8537','2014-04-17','14:40:00',4.11),('8537','2014-04-17','14:45:00',1.66),('8537','2014-04-17','14:50:00',1.05),('8537','2014-04-17','15:05:00',1.11),('8537','2014-04-17','15:10:00',1.08),('8537','2014-04-17','15:20:00',1.03),('8537','2014-04-17','15:25:00',1.31),('8537','2014-04-17','15:30:00',1.99),('8537','2014-04-17','15:35:00',2.48),('8537','2014-04-17','15:40:00',1.97),('8537','2014-04-17','15:45:00',1.46),('8537','2014-04-17','15:50:00',1.37),('8537','2014-04-17','15:55:00',1.55),('8537','2014-04-17','16:00:00',1.36),('8537','2014-04-17','16:05:00',1.09),('8537','2014-04-17','16:10:00',1.22),('8537','2014-04-17','16:15:00',1.28),('8537','2014-04-17','16:20:00',1.24),('8537','2014-04-17','16:25:00',1.34),('8537','2014-04-17','16:30:00',1.41),('8537','2014-04-17','16:35:00',1.27),('8537','2014-04-17','16:40:00',1.43),('8537','2014-04-17','16:45:00',1.76),('8537','2014-04-17','16:50:00',1.78),('8537','2014-04-17','16:55:00',1.4),('8537','2014-04-17','17:00:00',1.17),('8537','2014-04-17','17:15:00',1.07),('8537','2014-04-17','17:20:00',1.21),('8537','2014-04-17','17:25:00',1.09),('8537','2014-04-17','17:30:00',1.12),('8537','2014-04-17','17:35:00',1.12),('8537','2014-04-17','17:40:00',1.09),('8537','2014-05-04','07:45:00',1.19),('8537','2014-05-04','07:50:00',1.45),('8537','2014-05-04','07:55:00',1.56),('8537','2014-05-04','08:00:00',1.67),('8537','2014-05-04','08:05:00',1.81),('8537','2014-05-04','08:10:00',1.91),('8537','2014-05-04','08:15:00',2.03),('8537','2014-05-04','08:20:00',2.17),('8537','2014-05-04','08:25:00',2.28),('8537','2014-05-04','08:30:00',2.51),('8537','2014-05-04','08:35:00',2.32),('8537','2014-05-04','08:40:00',2.11),('8537','2014-05-04','08:45:00',1.2),('8537','2014-05-04','08:50:00',2.46),('8537','2014-05-04','08:55:00',1.51),('8537','2014-05-04','09:00:00',1.67),('8537','2014-05-04','09:05:00',2.48),('8537','2014-05-04','09:10:00',2.67),('8537','2014-05-04','09:15:00',2.54),('8537','2014-05-04','09:20:00',4.38),('8537','2014-05-04','09:25:00',3.89),('8537','2014-05-04','09:30:00',1.66),('8537','2014-05-04','09:35:00',1.51),('8537','2014-05-04','09:40:00',2.05),('8537','2014-05-04','09:45:00',3.01),('8537','2014-05-04','09:50:00',2.72),('8537','2014-05-04','09:55:00',2.73),('8537','2014-05-04','10:00:00',4.57),('8537','2014-05-04','10:05:00',4.7),('8537','2014-05-04','10:10:00',4.12),('8537','2014-05-04','10:15:00',3.29),('8537','2014-05-04','10:20:00',2.33),('8537','2014-05-04','10:25:00',2.32),('8537','2014-05-04','10:30:00',2.41),('8537','2014-05-04','10:35:00',2.49),('8537','2014-05-04','10:40:00',2.64),('8537','2014-05-04','10:45:00',3.78),('8537','2014-05-04','10:50:00',4.05),('8537','2014-05-04','10:55:00',3.14),('8537','2014-05-04','11:00:00',3.29),('8537','2014-05-04','11:05:00',4.02),('8537','2014-05-04','11:10:00',5.79),('8537','2014-05-04','11:15:00',4.81),('8537','2014-05-04','11:20:00',5.46),('8537','2014-05-04','11:25:00',3.91),('8537','2014-05-04','11:30:00',4.55),('8537','2014-05-04','11:35:00',4.76),('8537','2014-05-04','11:40:00',3.57),('8537','2014-05-04','11:45:00',5.3),('8537','2014-05-04','11:50:00',3.44),('8537','2014-05-04','11:55:00',4.03),('8537','2014-05-04','12:00:00',4.01),('8537','2014-05-04','12:05:00',4.74),('8537','2014-05-04','12:10:00',3.69),('8537','2014-05-04','12:15:00',1.88),('8537','2014-05-04','12:20:00',2.05),('8537','2014-05-04','12:25:00',2.22),('8537','2014-05-04','12:30:00',5.84),('8537','2014-05-04','12:35:00',5.07),('8537','2014-05-04','12:40:00',3.66),('8537','2014-05-04','12:45:00',4.75),('8537','2014-05-04','12:50:00',4.34),('8537','2014-05-04','12:55:00',3.49),('8537','2014-05-04','13:00:00',2.58),('8537','2014-05-04','13:05:00',2.43),('8537','2014-05-04','13:10:00',2.7),('8537','2014-05-04','13:15:00',2.43),('8537','2014-05-04','13:20:00',2.1),('8537','2014-05-04','13:25:00',1.82),('8537','2014-05-04','13:30:00',1.88),('8537','2014-05-04','13:35:00',1.99),('8537','2014-05-04','13:40:00',1.9),('8537','2014-05-04','13:45:00',1.67),('8537','2014-05-04','13:50:00',1.59),('8537','2014-05-04','13:55:00',1.63),('8537','2014-05-04','14:00:00',1.61),('8537','2014-05-04','14:05:00',1.64),('8537','2014-05-04','14:10:00',1.65),('8537','2014-05-04','14:15:00',1.55),('8537','2014-05-04','14:20:00',1.25),('8537','2014-05-04','14:45:00',1.01),('8537','2014-05-04','14:50:00',1.33),('8537','2014-05-04','14:55:00',1.91),('8537','2014-05-04','15:00:00',2.19),('8537','2014-05-04','15:05:00',3.22),('8537','2014-05-04','15:10:00',3.95),('8537','2014-05-04','15:15:00',3.19),('8537','2014-05-04','15:20:00',1.9),('8537','2014-05-04','15:25:00',1.65),('8537','2014-05-04','15:30:00',1.26),('8537','2014-05-04','15:45:00',1.11),('8537','2014-05-04','15:50:00',1.41),('8537','2014-05-04','15:55:00',1.45),('8537','2014-05-04','16:00:00',1.19),('8537','2014-05-04','16:05:00',1.27),('8537','2014-05-04','16:10:00',1.56),('8537','2014-05-04','16:15:00',1.52),('8537','2014-05-04','16:20:00',1.28),('8537','2014-05-04','16:25:00',1.02),('8537','2014-05-04','17:25:00',1.13),('8537','2014-05-04','17:30:00',1.1),('8537','2014-05-04','17:35:00',1.09),('8537','2014-05-04','17:40:00',1.08),('8537','2014-04-16','07:50:00',1.08),('8537','2014-04-16','07:55:00',1.18),('8537','2014-04-16','08:00:00',1.3),('8537','2014-04-16','08:05:00',1.41),('8537','2014-04-16','08:10:00',1.58),('8537','2014-04-16','08:15:00',1.68),('8537','2014-04-16','08:20:00',1.82),('8537','2014-04-16','08:25:00',1.95),('8537','2014-04-16','08:30:00',1.44),('8537','2014-04-16','08:35:00',1.18),('8537','2014-04-16','08:40:00',1.48),('8537','2014-04-16','08:45:00',2.21),('8537','2014-04-16','08:50:00',2.5),('8537','2014-04-16','08:55:00',2.64),('8537','2014-04-16','09:00:00',2.75),('8537','2014-04-16','09:05:00',2.86),('8537','2014-04-16','09:10:00',2.97),('8537','2014-04-16','09:15:00',3.04),('8537','2014-04-16','09:20:00',3.15),('8537','2014-04-16','09:25:00',3.28),('8537','2014-04-16','09:30:00',2.31),('8537','2014-04-16','09:35:00',1.04),('8537','2014-04-16','09:45:00',1.15),('8537','2014-04-16','09:50:00',2.09),('8537','2014-04-16','09:55:00',4.17),('8537','2014-04-16','10:00:00',4.05),('8537','2014-04-16','10:05:00',4.11),('8537','2014-04-16','10:10:00',4.19),('8537','2014-04-16','10:15:00',4.3),('8537','2014-04-16','10:20:00',4.39),('8537','2014-04-16','10:25:00',4.47),('8537','2014-04-16','10:30:00',4.55),('8537','2014-04-16','10:35:00',4.62),('8537','2014-04-16','10:40:00',4.68),('8537','2014-04-16','10:45:00',4.76),('8537','2014-04-16','10:50:00',4.91),('8537','2014-04-16','10:55:00',4.58),('8537','2014-04-16','11:00:00',4.92),('8537','2014-04-16','11:05:00',3.65),('8537','2014-04-16','11:10:00',1.81),('8537','2014-04-16','11:15:00',2.69),('8537','2014-04-16','11:20:00',4.93),('8537','2014-04-16','11:25:00',3.38),('8537','2014-04-16','11:30:00',4.57),('8537','2014-04-16','11:35:00',3.33),('8537','2014-04-16','11:40:00',4.71),('8537','2014-04-16','11:45:00',5.05),('8537','2014-04-16','11:50:00',5.94),('8537','2014-04-16','11:55:00',5.76),('8537','2014-04-16','12:00:00',5.87),('8537','2014-04-16','12:05:00',2.94),('8537','2014-04-16','12:10:00',4.75),('8537','2014-04-16','12:15:00',4.71),('8537','2014-04-16','12:20:00',4.33),('8537','2014-04-16','12:25:00',1.77),('8537','2014-04-16','12:30:00',2.66),('8537','2014-04-16','12:35:00',5.3),('8537','2014-04-16','12:40:00',5.89),('8537','2014-04-16','12:45:00',5.77),('8537','2014-04-16','12:50:00',5.86),('8537','2014-04-16','12:55:00',2.97),('8537','2014-04-16','13:00:00',3.2),('8537','2014-04-16','13:05:00',1.44),('8537','2014-04-16','13:20:00',1.72),('8537','2014-04-16','13:25:00',1.3),('8537','2014-04-16','13:30:00',1.05),('8537','2014-04-16','13:35:00',1.81),('8537','2014-04-16','13:40:00',2.73),('8537','2014-04-16','13:45:00',5.72),('8537','2014-04-16','13:50:00',4.68),('8537','2014-04-16','13:55:00',3.43),('8537','2014-04-16','14:00:00',2.13),('8537','2014-04-16','14:05:00',3.79),('8537','2014-04-16','14:10:00',5.59),('8537','2014-04-16','14:15:00',5.99),('8537','2014-04-16','14:20:00',5.34),('8537','2014-04-16','14:25:00',4.48),('8537','2014-04-16','14:30:00',5.11),('8537','2014-04-16','14:35:00',5.03),('8537','2014-04-16','14:40:00',5.05),('8537','2014-04-16','14:45:00',4.72),('8537','2014-04-16','14:50:00',4.86),('8537','2014-04-16','14:55:00',1.72),('8537','2014-04-16','15:00:00',2.12),('8537','2014-04-16','15:05:00',3.32),('8537','2014-04-16','15:10:00',5.73),('8537','2014-04-16','15:15:00',3.49),('8537','2014-04-16','15:25:00',1.46),('8537','2014-04-16','15:30:00',3.94),('8537','2014-04-16','15:35:00',4.88),('8537','2014-04-16','15:40:00',4.72),('8537','2014-04-16','15:45:00',4.51),('8537','2014-04-16','15:50:00',4.41),('8537','2014-04-16','15:55:00',4.27),('8537','2014-04-16','16:00:00',4.11),('8537','2014-04-16','16:05:00',3.86),('8537','2014-04-16','16:10:00',3.34),('8537','2014-04-16','16:15:00',3.72),('8537','2014-04-16','16:20:00',3.73),('8537','2014-04-16','16:25:00',3.58),('8537','2014-04-16','16:30:00',3.5),('8537','2014-04-16','16:35:00',3.42),('8537','2014-04-16','16:40:00',3.21),('8537','2014-04-16','16:45:00',3.1),('8537','2014-04-16','16:50:00',3.06),('8537','2014-04-16','16:55:00',2.95),('8537','2014-04-16','17:00:00',2.82),('8537','2014-04-16','17:05:00',2.59),('8537','2014-04-16','17:10:00',2.55),('8537','2014-04-16','17:15:00',2.45),('8537','2014-04-16','17:20:00',2.33),('8537','2014-04-16','17:25:00',2.17),('8537','2014-04-16','17:30:00',2.06),('8537','2014-04-16','17:35:00',1.94),('8537','2014-04-16','17:40:00',1.82),('8537','2014-04-16','17:45:00',1.75),('8537','2014-04-16','17:50:00',1.73),('8537','2014-04-16','17:55:00',1.69),('8537','2014-04-16','18:00:00',1.52),('8537','2014-04-16','18:05:00',1.41),('8537','2014-04-16','18:10:00',1.26),('8537','2014-04-16','18:15:00',1.08),('8537','2014-04-16','18:20:00',1.01),('8537','2014-04-15','09:00:00',1.7),('8537','2014-04-15','09:05:00',1.98),('8537','2014-04-15','09:10:00',1.89),('8537','2014-04-15','09:15:00',2.49),('8537','2014-04-15','09:20:00',2.2),('8537','2014-04-15','09:25:00',3.09),('8537','2014-04-15','09:30:00',2.44),('8537','2014-04-15','09:35:00',1.08),('8537','2014-04-15','09:45:00',1.28),('8537','2014-04-15','09:50:00',3.41),('8537','2014-04-15','09:55:00',1.03),('8537','2014-04-15','10:00:00',1.65),('8537','2014-04-15','10:05:00',1.68),('8537','2014-04-15','10:10:00',1.99),('8537','2014-04-15','10:15:00',2.27),('8537','2014-04-15','10:20:00',1.8),('8537','2014-04-15','10:25:00',1.65),('8537','2014-04-15','10:30:00',3.7),('8537','2014-04-15','10:35:00',2.85),('8537','2014-04-15','10:40:00',2.32),('8537','2014-04-15','10:45:00',3.27),('8537','2014-04-15','10:50:00',2.93),('8537','2014-04-15','10:55:00',1.77),('8537','2014-04-15','11:00:00',2.01),('8537','2014-04-15','11:05:00',4.53),('8537','2014-04-15','11:10:00',3.22),('8537','2014-04-15','11:15:00',1.98),('8537','2014-04-15','11:20:00',1.36),('8537','2014-04-15','11:25:00',1.71),('8537','2014-04-15','11:30:00',1.29),('8537','2014-04-15','11:35:00',1.11),('8537','2014-04-15','11:45:00',1.26),('8537','2014-04-15','11:50:00',1.71),('8537','2014-04-15','11:55:00',1.23),('8537','2014-04-15','12:10:00',1.2),('8537','2014-04-15','12:15:00',1.75),('8537','2014-04-15','12:20:00',2.22),('8537','2014-04-15','12:25:00',1.05),('8537','2014-04-15','13:05:00',1.15),('8537','2014-04-15','13:10:00',1.92),('8537','2014-04-15','13:15:00',2.09),('8537','2014-04-15','13:20:00',3.41),('8537','2014-04-15','13:25:00',2.27),('8537','2014-04-15','13:30:00',3.07),('8537','2014-04-15','13:35:00',3.74),('8537','2014-04-15','13:40:00',3.31),('8537','2014-04-15','13:45:00',1.22),('8537','2014-04-15','13:50:00',1.09),('8537','2014-04-15','13:55:00',1.06),('8537','2014-04-15','14:00:00',2.37),('8537','2014-04-15','14:05:00',3.09),('8537','2014-04-15','14:10:00',3.16),('8537','2014-04-15','14:15:00',4.25),('8537','2014-04-15','14:20:00',2.84),('8537','2014-04-15','14:25:00',4.32),('8537','2014-04-15','14:30:00',3.3),('8537','2014-04-15','14:35:00',2.51),('8537','2014-04-15','14:40:00',1.74),('8537','2014-04-15','14:45:00',1.44),('8537','2014-04-15','14:50:00',1.42),('8537','2014-04-15','14:55:00',1.17),('8537','2014-04-15','15:10:00',1.14),('8537','2014-04-15','15:15:00',1.6),('8537','2014-04-15','15:20:00',2.04),('8537','2014-04-15','15:25:00',2.25),('8537','2014-04-15','15:30:00',1.71),('8537','2014-04-15','15:35:00',1.61),('8537','2014-04-15','15:40:00',1.68),('8537','2014-04-15','15:45:00',1.54),('8537','2014-04-15','15:50:00',1.54),('8537','2014-04-15','15:55:00',1.65),('8537','2014-04-15','16:00:00',1.72),('8537','2014-04-15','16:05:00',1.67),('8537','2014-04-15','16:10:00',1.01),('8537','2013-10-08','08:10:00',1.11),('8537','2013-10-08','08:15:00',1.42),('8537','2013-10-08','08:20:00',1.42),('8537','2013-10-08','10:00:00',1.31),('8537','2013-10-08','10:05:00',1.11),('8537','2013-10-08','10:10:00',1.12),('8537','2013-10-08','11:00:00',2.11),('8537','2013-10-08','11:05:00',1.57),('8537','2013-10-08','11:10:00',3.59),('8537','2013-10-08','11:15:00',4.87),('8537','2013-10-08','11:20:00',4.28),('8537','2013-10-08','11:25:00',2.21),('8537','2013-10-08','11:30:00',3.78),('8537','2013-10-08','11:35:00',2.68),('8537','2013-10-08','11:40:00',1.93),('8537','2013-10-08','11:45:00',1.78),('8537','2013-10-08','11:50:00',1.28),('8537','2013-10-08','11:55:00',1.04),('8537','2013-10-08','12:10:00',1.18),('8537','2013-10-08','12:15:00',1.18),('8537','2013-10-08','12:20:00',1.33),('8537','2013-10-08','12:25:00',1.76),('8537','2013-10-08','12:30:00',3.65),('8537','2013-10-08','12:35:00',2.46),('8537','2013-10-08','12:40:00',4.89),('8537','2013-10-08','12:45:00',4.75),('8537','2013-10-08','12:50:00',4.98),('8537','2013-10-08','12:55:00',4.91),('8537','2013-10-08','13:00:00',4.17),('8537','2013-10-08','13:05:00',4.18),('8537','2013-10-08','13:10:00',2.67),('8537','2013-10-08','13:15:00',4.47),('8537','2013-10-08','13:20:00',1.77),('8537','2013-10-08','13:25:00',4.1),('8537','2013-10-08','13:30:00',2.15),('8537','2013-10-08','13:35:00',1.41),('8537','2013-10-08','13:40:00',1.38),('8537','2013-10-08','13:45:00',1.01),('8537','2013-10-08','13:55:00',1.1),('8537','2013-10-08','14:05:00',1.79),('8537','2013-10-08','14:10:00',2.62),('8537','2013-10-08','14:15:00',2.9),('8537','2013-10-08','14:20:00',3.31),('8537','2013-10-08','14:25:00',3.41),('8537','2013-10-08','14:30:00',3.16),('8537','2013-10-08','14:35:00',1.36),('8537','2013-10-08','14:40:00',1.58),('8537','2013-10-08','14:45:00',3.65),('8537','2013-10-08','14:50:00',4),('8537','2013-10-08','14:55:00',3.78),('8537','2013-10-08','15:00:00',3.7),('8537','2013-10-08','15:05:00',3.67),('8537','2013-10-08','15:10:00',3.42),('8537','2013-10-08','15:15:00',3.6),('8537','2013-10-08','15:20:00',2.09),('8537','2013-10-08','15:25:00',3.88),('8537','2013-10-08','15:30:00',4.01),('8537','2013-10-08','15:35:00',3.46),('8537','2013-10-08','15:40:00',2.59),('8537','2013-10-08','15:45:00',1.98),('8537','2013-10-08','15:50:00',2.73),('8537','2013-10-08','15:55:00',1.8),('8537','2013-10-08','16:00:00',1.52),('8537','2013-10-08','16:05:00',1.94),('8537','2013-10-07','08:20:00',1.07),('8537','2013-10-07','08:25:00',1.18),('8537','2013-10-07','08:30:00',1.29),('8537','2013-10-07','08:35:00',1.6),('8537','2013-10-07','08:40:00',1.91),('8537','2013-10-07','08:45:00',1.05),('8537','2013-10-07','08:55:00',1.43),('8537','2013-10-07','09:00:00',1.98),('8537','2013-10-07','09:05:00',2.22),('8537','2013-10-07','09:10:00',2.18),('8537','2013-10-07','09:15:00',2.27),('8537','2013-10-07','09:20:00',2.35),('8537','2013-10-07','09:25:00',2.44),('8537','2013-10-07','09:30:00',2.55),('8537','2013-10-07','09:35:00',2.64),('8537','2013-10-07','09:40:00',2.73),('8537','2013-10-07','09:45:00',2.81),('8537','2013-10-07','09:50:00',2.91),('8537','2013-10-07','09:55:00',2.97),('8537','2013-10-07','10:00:00',3.05),('8537','2013-10-07','10:05:00',3.13),('8537','2013-10-07','10:10:00',3.13),('8537','2013-10-07','10:15:00',3.27),('8537','2013-10-07','10:20:00',3.34),('8537','2013-10-07','10:25:00',3.39),('8537','2013-10-07','10:30:00',3.52),('8537','2013-10-07','10:35:00',3.67),('8537','2013-10-07','10:40:00',3.67),('8537','2013-10-07','10:45:00',3.73),('8537','2013-10-07','10:50:00',3.81),('8537','2013-10-07','10:55:00',3.27),('8537','2013-10-07','11:00:00',3.39),('8537','2013-10-07','11:05:00',3.94),('8537','2013-10-07','11:10:00',2.84),('8537','2013-10-07','11:15:00',3.64),('8537','2013-10-07','11:20:00',3.74),('8537','2013-10-07','11:25:00',4.08),('8537','2013-10-07','11:30:00',4.1),('8537','2013-10-07','11:35:00',4.12),('8537','2013-10-07','11:40:00',4.17),('8537','2013-10-07','11:45:00',4.22),('8537','2013-10-07','11:50:00',4.21),('8537','2013-10-07','11:55:00',4.32),('8537','2013-10-07','12:00:00',4.3),('8537','2013-10-07','12:05:00',4.4),('8537','2013-10-07','12:10:00',4.24),('8537','2013-10-07','12:15:00',2.75),('8537','2013-10-07','12:20:00',3.85),('8537','2013-10-07','12:25:00',4.92),('8537','2013-10-07','12:30:00',4.69),('8537','2013-10-07','12:35:00',4.6),('8537','2013-10-07','12:40:00',4.61),('8537','2013-10-07','12:45:00',4.58),('8537','2013-10-07','12:50:00',4.57),('8537','2013-10-07','12:55:00',4.68),('8537','2013-10-07','13:00:00',3.97),('8537','2013-10-07','13:05:00',4.56),('8537','2013-10-07','13:10:00',4.57),('8537','2013-10-07','13:15:00',3.13),('8537','2013-10-07','13:20:00',4.94),('8537','2013-10-07','13:25:00',3.28),('8537','2013-10-07','13:30:00',3.15),('8537','2013-10-07','13:35:00',2.44),('8537','2013-10-07','13:40:00',2.12),('8537','2013-10-07','13:45:00',1.67),('8537','2013-10-07','13:50:00',2.71),('8537','2013-10-07','13:55:00',5.24),('8537','2013-10-07','14:00:00',4.97),('8537','2013-10-07','14:05:00',1.71),('8537','2013-10-07','14:10:00',2.36),('8537','2013-10-07','14:15:00',1.04),('8537','2013-10-07','14:20:00',1.73),('8537','2013-10-07','14:25:00',1.96),('8537','2013-10-07','14:30:00',1.81),('8537','2013-10-07','14:35:00',1.48),('8537','2013-10-07','14:40:00',2.81),('8537','2013-10-07','14:45:00',4.43),('8537','2013-10-07','14:50:00',4.35),('8537','2013-10-07','14:55:00',4.16),('8537','2013-10-07','15:00:00',2.85),('8537','2013-10-07','15:05:00',2.03),('8537','2013-10-07','15:10:00',2.36),('8537','2013-10-07','15:20:00',1.04),('8537','2013-10-07','15:25:00',2.04),('8537','2013-10-07','15:30:00',2.02),('8537','2013-10-07','15:35:00',1.71),('8537','2013-10-07','15:40:00',1.68),('8537','2013-10-07','15:45:00',1.85),('8537','2013-10-07','15:50:00',2.59),('8537','2013-10-07','15:55:00',2.39),('8537','2013-10-07','16:10:00',2.74),('8537','2013-10-07','16:15:00',2.69),('8537','2013-10-07','16:20:00',2.58),('8537','2013-10-07','16:25:00',2.24),('8537','2013-10-07','16:30:00',2.16),('8537','2013-10-07','16:35:00',2.12),('8537','2013-10-07','16:40:00',2.11),('8537','2013-10-07','16:45:00',1.97),('8537','2013-10-07','16:50:00',1.81),('8537','2013-10-07','16:55:00',1.64),('8537','2013-10-07','17:00:00',1.48),('8537','2013-10-07','17:05:00',1.34),('8537','2013-10-07','17:10:00',1.17),('8537','2013-10-07','17:15:00',1.09),('8537','2013-10-06','09:05:00',1.29),('8537','2013-10-06','09:10:00',1.13),('8537','2013-10-06','09:30:00',1.4),('8537','2013-10-06','09:35:00',1.88),('8537','2013-10-06','09:40:00',1.69),('8537','2013-10-06','09:45:00',1.37),('8537','2013-10-06','09:50:00',2.59),('8537','2013-10-06','09:55:00',3.05),('8537','2013-10-06','10:00:00',3.53),('8537','2013-10-06','10:05:00',3.6),('8537','2013-10-06','10:10:00',3.52),('8537','2013-10-06','10:15:00',3.26),('8537','2013-10-06','10:20:00',3.26),('8537','2013-10-06','10:25:00',3.69),('8537','2013-10-06','10:30:00',3.62),('8537','2013-10-06','10:35:00',3.49),('8537','2013-10-06','10:40:00',3.04),('8537','2013-10-06','10:45:00',2.49),('8537','2013-10-06','10:50:00',2.81),('8537','2013-10-06','10:55:00',3.01),('8537','2013-10-06','11:00:00',3.16),('8537','2013-10-06','11:05:00',3.46),('8537','2013-10-06','11:10:00',3.56),('8537','2013-10-06','11:15:00',3.4),('8537','2013-10-06','11:20:00',3.49),('8537','2013-10-06','11:25:00',3.69),('8537','2013-10-06','11:30:00',3.59),('8537','2013-10-06','11:35:00',3.53),('8537','2013-10-06','11:40:00',3.45),('8537','2013-10-06','11:45:00',2.84),('8537','2013-10-06','11:50:00',2.75),('8537','2013-10-06','11:55:00',3.2),('8537','2013-10-06','12:00:00',3.26),('8537','2013-10-06','12:05:00',3.36),('8537','2013-10-06','12:10:00',4.06),('8537','2013-10-06','12:15:00',3.98),('8537','2013-10-06','12:20:00',3.31),('8537','2013-10-06','12:25:00',3.45),('8537','2013-10-06','12:30:00',3.27),('8537','2013-10-06','12:35:00',3.42),('8537','2013-10-06','12:40:00',2.93),('8537','2013-10-06','12:45:00',3.19),('8537','2013-10-06','12:50:00',3.55),('8537','2013-10-06','12:55:00',4.03),('8537','2013-10-06','13:00:00',4.13),('8537','2013-10-06','13:05:00',3.98),('8537','2013-10-06','13:10:00',3.11),('8537','2013-10-06','13:15:00',2.96),('8537','2013-10-06','13:20:00',3.55),('8537','2013-10-06','13:25:00',1.29),('8537','2013-10-06','13:45:00',1.74),('8537','2013-10-06','13:50:00',4.75),('8537','2013-10-06','13:55:00',3.66),('8537','2013-10-06','14:00:00',2.17),('8537','2013-10-06','14:05:00',2.24),('8537','2013-10-06','14:10:00',3.29),('8537','2013-10-06','14:15:00',2.1),('8537','2013-10-06','14:20:00',2.02),('8537','2013-10-06','14:25:00',1.95),('8537','2013-10-06','14:30:00',2.48),('8537','2013-10-06','14:35:00',2.44),('8537','2013-10-06','14:40:00',1.93),('8537','2013-10-06','14:45:00',2.06),('8537','2013-10-06','14:50:00',2.1),('8537','2013-10-06','14:55:00',2.72),('8537','2013-10-06','15:00:00',2.37),('8537','2013-10-06','15:05:00',1.75),('8537','2013-10-06','15:10:00',1.42),('8537','2013-10-06','15:15:00',1.3),('8537','2013-10-06','15:20:00',1.14),('8537','2013-10-06','15:40:00',1.01),('8537','2013-10-06','15:45:00',1.01),('8537','2013-10-06','15:50:00',1.1),('8537','2013-10-06','15:55:00',1.34),('8537','2013-10-06','16:00:00',1.35),('8537','2013-10-06','17:15:00',1.04),('8537','2013-10-05','15:55:00',1.02),('8537','2013-10-05','16:00:00',1.14),('8537','2013-10-05','16:05:00',1.37),('8537','2013-10-05','16:10:00',1.37),('8537','2013-10-05','16:15:00',1.23),('8537','2013-10-05','16:20:00',1.26),('8537','2013-10-05','16:25:00',1.27),('8537','2013-10-05','16:30:00',1.1),('8537','2013-10-05','16:35:00',1.03),('8537','2013-10-05','16:40:00',1.08),('8537','2013-10-05','16:45:00',1.01),('8537','2013-10-04','09:25:00',1.17),('8537','2013-10-04','09:30:00',1.33),('8537','2013-10-04','09:35:00',1.33),('8537','2013-10-04','09:40:00',1.31),('8537','2013-10-04','09:45:00',1.35),('8537','2013-10-04','09:50:00',1.64),('8537','2013-10-04','09:55:00',3.38),('8537','2013-10-04','10:00:00',2.48),('8537','2013-10-04','10:05:00',1.82),('8537','2013-10-04','10:10:00',1.82),('8537','2013-10-04','10:15:00',2.24),('8537','2013-10-04','10:20:00',1.79),('8537','2013-10-04','10:25:00',2.28),('8537','2013-10-04','10:30:00',2.86),('8537','2013-10-04','10:35:00',2.29),('8537','2013-10-04','10:40:00',3.1),('8537','2013-10-04','10:45:00',2.44),('8537','2013-10-04','10:50:00',2.27),('8537','2013-10-04','10:55:00',3.42),('8537','2013-10-04','11:00:00',2.67),('8537','2013-10-04','11:05:00',2.1),('8537','2013-10-04','11:10:00',1.95),('8537','2013-10-04','11:15:00',3.61),('8537','2013-10-04','11:20:00',3.8),('8537','2013-10-04','11:25:00',3.59),('8537','2013-10-04','11:30:00',4.45),('8537','2013-10-04','11:35:00',4.54),('8537','2013-10-04','11:40:00',4.61),('8537','2013-10-04','11:45:00',4.5),('8537','2013-10-04','11:50:00',4.43),('8537','2013-10-04','11:55:00',4.44),('8537','2013-10-04','12:00:00',4.44),('8537','2013-10-04','12:05:00',4.51),('8537','2013-10-04','12:10:00',4.54),('8537','2013-10-04','12:15:00',4.28),('8537','2013-10-04','12:20:00',4.33),('8537','2013-10-04','12:25:00',4.6),('8537','2013-10-04','12:30:00',4.54),('8537','2013-10-04','12:35:00',4.13),('8537','2013-10-04','12:40:00',4.48),('8537','2013-10-04','12:45:00',4.53),('8537','2013-10-04','12:50:00',4.36),('8537','2013-10-04','12:55:00',4.39),('8537','2013-10-04','13:00:00',4.43),('8537','2013-10-04','13:05:00',4.48),('8537','2013-10-04','13:10:00',4.49),('8537','2013-10-04','13:15:00',4.71),('8537','2013-10-04','13:20:00',4.6),('8537','2013-10-04','13:25:00',4.35),('8537','2013-10-04','13:30:00',4.56),('8537','2013-10-04','13:35:00',3.99),('8537','2013-10-04','13:40:00',4.38),('8537','2013-10-04','13:45:00',4.25),('8537','2013-10-04','13:50:00',4.26),('8537','2013-10-04','13:55:00',4.27),('8537','2013-10-04','14:00:00',4.25),('8537','2013-10-04','14:05:00',4.21),('8537','2013-10-04','14:10:00',3.85),('8537','2013-10-04','14:15:00',3.47),('8537','2013-10-04','14:20:00',3.79),('8537','2013-10-04','14:25:00',4.03),('8537','2013-10-04','14:30:00',3.53),('8537','2013-10-04','14:35:00',2.5),('8537','2013-10-04','14:40:00',1.99),('8537','2013-10-04','14:45:00',2.25),('8537','2013-10-04','14:50:00',2.99),('8537','2013-10-04','14:55:00',3.06),('8537','2013-10-04','15:00:00',2.64),('8537','2013-10-04','15:05:00',2.98),('8537','2013-10-04','15:10:00',2.59),('8537','2013-10-04','15:15:00',2),('8537','2013-10-04','15:20:00',1.76),('8537','2013-10-04','15:25:00',2.66),('8537','2013-10-04','15:30:00',3.18),('8537','2013-10-04','15:35:00',1.7),('8537','2013-10-04','15:40:00',1.04),('8537','2013-10-04','16:00:00',1.14),('8537','2013-10-04','16:05:00',1.27),('8537','2013-10-04','16:10:00',1.2),('8537','2013-10-04','16:15:00',1.08),('8537','2013-10-03','08:15:00',1.08),('8537','2013-10-03','08:20:00',1.19),('8537','2013-10-03','08:25:00',1.31),('8537','2013-10-03','08:30:00',1.43),('8537','2013-10-03','08:35:00',1.55),('8537','2013-10-03','08:40:00',1.66),('8537','2013-10-03','08:45:00',1.79),('8537','2013-10-03','08:50:00',1.91),('8537','2013-10-03','08:55:00',2.03),('8537','2013-10-03','09:00:00',2.15),('8537','2013-10-03','09:05:00',2.25),('8537','2013-10-03','09:10:00',2.37),('8537','2013-10-03','09:15:00',2.47),('8537','2013-10-03','09:20:00',2.59),('8537','2013-10-03','09:25:00',2.7),('8537','2013-10-03','09:30:00',2.81),('8537','2013-10-03','09:35:00',2.91),('8537','2013-10-03','09:40:00',3.01),('8537','2013-10-03','09:45:00',3.11),('8537','2013-10-03','09:50:00',3.2),('8537','2013-10-03','09:55:00',3.3),('8537','2013-10-03','10:00:00',3.39),('8537','2013-10-03','10:05:00',3.48),('8537','2013-10-03','10:10:00',3.56),('8537','2013-10-03','10:15:00',3.63),('8537','2013-10-03','10:20:00',3.71),('8537','2013-10-03','10:25:00',3.8),('8537','2013-10-03','10:30:00',3.86),('8537','2013-10-03','10:35:00',3.95),('8537','2013-10-03','10:40:00',4.02),('8537','2013-10-03','10:45:00',4.07),('8537','2013-10-03','10:50:00',4.12),('8537','2013-10-03','10:55:00',4.18),('8537','2013-10-03','11:00:00',4.21),('8537','2013-10-03','11:05:00',4.28),('8537','2013-10-03','11:10:00',4.34),('8537','2013-10-03','11:15:00',4.36),('8537','2013-10-03','11:20:00',4.43),('8537','2013-10-03','11:25:00',4.47),('8537','2013-10-03','11:30:00',4.49),('8537','2013-10-03','11:35:00',4.56),('8537','2013-10-03','11:40:00',4.6),('8537','2013-10-03','11:45:00',4.62),('8537','2013-10-03','11:50:00',4.68),('8537','2013-10-03','11:55:00',4.7),('8537','2013-10-03','12:00:00',4.71),('8537','2013-10-03','12:05:00',4.74),('8537','2013-10-03','12:10:00',4.76),('8537','2013-10-03','12:15:00',4.73),('8537','2013-10-03','12:20:00',4.76),('8537','2013-10-03','12:25:00',4.77),('8537','2013-10-03','12:30:00',4.78),('8537','2013-10-03','12:35:00',4.79),('8537','2013-10-03','12:40:00',4.8),('8537','2013-10-03','12:45:00',4.81),('8537','2013-10-03','12:50:00',4.78),('8537','2013-10-03','12:55:00',4.78),('8537','2013-10-03','13:00:00',4.74),('8537','2013-10-03','13:05:00',4.68),('8537','2013-10-03','13:10:00',4.77),('8537','2013-10-03','13:15:00',4.74),('8537','2013-10-03','13:20:00',4.73),('8537','2013-10-03','13:25:00',4.71),('8537','2013-10-03','13:30:00',4.7),('8537','2013-10-03','13:35:00',4.65),('8537','2013-10-03','13:40:00',4.64),('8537','2013-10-03','13:45:00',4.61),('8537','2013-10-03','13:50:00',4.6),('8537','2013-10-03','13:55:00',4.62),('8537','2013-10-03','14:00:00',4.59),('8537','2013-10-03','14:05:00',4.55),('8537','2013-10-03','14:10:00',4.52),('8537','2013-10-03','14:15:00',4.45),('8537','2013-10-03','14:20:00',4.4),('8537','2013-10-03','14:25:00',4.35),('8537','2013-10-03','14:30:00',4.31),('8537','2013-10-03','14:35:00',4.22),('8537','2013-10-03','14:40:00',4.04),('8537','2013-10-03','14:45:00',3.78),('8537','2013-10-03','14:50:00',3.96),('8537','2013-10-03','14:55:00',4),('8537','2013-10-03','15:00:00',3.94),('8537','2013-10-03','15:05:00',3.86),('8537','2013-10-03','15:10:00',3.79),('8537','2013-10-03','15:15:00',3.72),('8537','2013-10-03','15:20:00',3.65),('8537','2013-10-03','15:25:00',3.55),('8537','2013-10-03','15:30:00',3.33),('8537','2013-10-03','15:35:00',3.31),('8537','2013-10-03','15:40:00',3.29),('8537','2013-10-03','15:45:00',3.2),('8537','2013-10-03','15:50:00',3.12),('8537','2013-10-03','15:55:00',3.04),('8537','2013-10-03','16:00:00',2.93),('8537','2013-10-03','16:05:00',2.8),('8537','2013-10-03','16:10:00',2.71),('8537','2013-10-03','16:15:00',2.6),('8537','2013-10-03','16:20:00',2.52),('8537','2013-10-03','16:25:00',2.35),('8537','2013-10-03','16:30:00',2.3),('8537','2013-10-03','16:35:00',2.14),('8537','2013-10-03','16:40:00',1.94),('8537','2013-10-03','16:45:00',1.79),('8537','2013-10-03','16:50:00',1.83),('8537','2013-10-03','16:55:00',1.69),('8537','2013-10-03','17:00:00',1.56),('8537','2013-10-03','17:05:00',1.45),('8537','2013-10-03','17:10:00',1.35),('8537','2013-10-03','17:15:00',1.17),('8537','2013-10-03','17:20:00',1.1),('8537','2013-10-02','08:15:00',1.08),('8537','2013-10-02','08:20:00',1.31),('8537','2013-10-02','08:25:00',1.29),('8537','2013-10-02','08:30:00',1.37),('8537','2013-10-02','08:35:00',1.44),('8537','2013-10-02','08:40:00',1.54),('8537','2013-10-02','08:45:00',1.67),('8537','2013-10-02','08:50:00',1.79),('8537','2013-10-02','08:55:00',1.9),('8537','2013-10-02','09:00:00',2.03),('8537','2013-10-02','09:05:00',2.13),('8537','2013-10-02','09:10:00',2.24),('8537','2013-10-02','09:15:00',2.36),('8537','2013-10-02','09:20:00',2.47),('8537','2013-10-02','09:25:00',2.57),('8537','2013-10-02','09:30:00',2.64),('8537','2013-10-02','09:35:00',2.77),('8537','2013-10-02','09:40:00',2.86),('8537','2013-10-02','09:45:00',2.93),('8537','2013-10-02','09:50:00',3.02),('8537','2013-10-02','09:55:00',3.09),('8537','2013-10-02','10:00:00',2.36),('8537','2013-10-02','10:05:00',3.23),('8537','2013-10-02','10:10:00',3.29),('8537','2013-10-02','10:15:00',3.39),('8537','2013-10-02','10:20:00',3.49),('8537','2013-10-02','10:25:00',3.57),('8537','2013-10-02','10:30:00',3.66),('8537','2013-10-02','10:35:00',3.73),('8537','2013-10-02','10:40:00',3.82),('8537','2013-10-02','10:45:00',3.9),('8537','2013-10-02','10:50:00',3.95),('8537','2013-10-02','10:55:00',4.02),('8537','2013-10-02','11:00:00',4.08),('8537','2013-10-02','11:05:00',4.14),('8537','2013-10-02','11:10:00',4.19),('8537','2013-10-02','11:15:00',4.24),('8537','2013-10-02','11:20:00',4.27),('8537','2013-10-02','11:25:00',4.31),('8537','2013-10-02','11:30:00',4.34),('8537','2013-10-02','11:35:00',4.35),('8537','2013-10-02','11:40:00',4.39),('8537','2013-10-02','11:45:00',4.41),('8537','2013-10-02','11:50:00',4.45),('8537','2013-10-02','11:55:00',4.49),('8537','2013-10-02','12:00:00',4.52),('8537','2013-10-02','12:05:00',4.55),('8537','2013-10-02','12:10:00',4.53),('8537','2013-10-02','12:15:00',4.58),('8537','2013-10-02','12:20:00',4.59),('8537','2013-10-02','12:25:00',4.58),('8537','2013-10-02','12:30:00',4.58),('8537','2013-10-02','12:35:00',4.61),('8537','2013-10-02','12:40:00',4.64),('8537','2013-10-02','12:45:00',4.64),('8537','2013-10-02','12:50:00',4.62),('8537','2013-10-02','12:55:00',4.62),('8537','2013-10-02','13:00:00',4.64),('8537','2013-10-02','13:05:00',4.63),('8537','2013-10-02','13:10:00',4.61),('8537','2013-10-02','13:15:00',4.6),('8537','2013-10-02','13:20:00',4.62),('8537','2013-10-02','13:25:00',4.61),('8537','2013-10-02','13:30:00',4.59),('8537','2013-10-02','13:35:00',4.57),('8537','2013-10-02','13:40:00',4.55),('8537','2013-10-02','13:45:00',4.52),('8537','2013-10-02','13:50:00',4.49),('8537','2013-10-02','13:55:00',4.47),('8537','2013-10-02','14:00:00',4.44),('8537','2013-10-02','14:05:00',4.41),('8537','2013-10-02','14:10:00',4.39),('8537','2013-10-02','14:15:00',4.34),('8537','2013-10-02','14:20:00',4.21),('8537','2013-10-02','14:25:00',4.24),('8537','2013-10-02','14:30:00',4.17),('8537','2013-10-02','14:35:00',4.1),('8537','2013-10-02','14:40:00',4.06),('8537','2013-10-02','14:45:00',4.01),('8537','2013-10-02','14:50:00',3.95),('8537','2013-10-02','14:55:00',3.91),('8537','2013-10-02','15:00:00',3.85),('8537','2013-10-02','15:05:00',3.78),('8537','2013-10-02','15:10:00',3.71),('8537','2013-10-02','15:15:00',3.65),('8537','2013-10-02','15:20:00',3.56),('8537','2013-10-02','15:25:00',3.42),('8537','2013-10-02','15:30:00',3.19),('8537','2013-10-02','15:35:00',3.17),('8537','2013-10-02','15:40:00',3.22),('8537','2013-10-02','15:45:00',3.15),('8537','2013-10-02','15:50:00',3.06),('8537','2013-10-02','15:55:00',2.96),('8537','2013-10-02','16:00:00',2.85),('8537','2013-10-02','16:05:00',2.7),('8537','2013-10-02','16:10:00',2.65),('8537','2013-10-02','16:15:00',2.56),('8537','2013-10-02','16:20:00',2.46),('8537','2013-10-02','16:25:00',2.31),('8537','2013-10-02','16:30:00',2.22),('8537','2013-10-02','16:35:00',2.12),('8537','2013-10-02','16:40:00',2.01),('8537','2013-10-02','16:45:00',1.9),('8537','2013-10-02','16:50:00',1.79),('8537','2013-10-02','16:55:00',1.64),('8537','2013-10-02','17:00:00',1.53),('8537','2013-10-02','17:05:00',1.42),('8537','2013-10-02','17:10:00',1.31),('8537','2013-10-02','17:15:00',1.17),('8537','2013-10-02','17:20:00',1.06),('8537','2013-10-01','08:25:00',1.31),('8537','2013-10-01','08:30:00',1.26),('8537','2013-10-01','08:35:00',1.02),('8537','2013-10-01','08:40:00',1.59),('8537','2013-10-01','08:45:00',1.72),('8537','2013-10-01','08:50:00',1.83),('8537','2013-10-01','08:55:00',1.94),('8537','2013-10-01','09:00:00',2.04),('8537','2013-10-01','09:05:00',2.14),('8537','2013-10-01','09:10:00',2.22),('8537','2013-10-01','09:15:00',2.32),('8537','2013-10-01','09:20:00',2.41),('8537','2013-10-01','09:25:00',2.51),('8537','2013-10-01','09:30:00',2.59),('8537','2013-10-01','09:35:00',2.67),('8537','2013-10-01','09:40:00',2.77),('8537','2013-10-01','09:45:00',2.86),('8537','2013-10-01','09:50:00',2.92),('8537','2013-10-01','09:55:00',3.02),('8537','2013-10-01','10:00:00',3.1),('8537','2013-10-01','10:05:00',3.18),('8537','2013-10-01','10:10:00',3.27),('8537','2013-10-01','10:15:00',3.32),('8537','2013-10-01','10:20:00',3.34),('8537','2013-10-01','10:25:00',3.51),('8537','2013-10-01','10:30:00',3.59),('8537','2013-10-01','10:35:00',3.64),('8537','2013-10-01','10:40:00',3.72),('8537','2013-10-01','10:45:00',3.8),('8537','2013-10-01','10:50:00',3.8),('8537','2013-10-01','10:55:00',3.88),('8537','2013-10-01','11:00:00',3.88),('8537','2013-10-01','11:05:00',4.12),('8537','2013-10-01','11:10:00',4.37),('8537','2013-10-01','11:15:00',1.59),('8537','2013-10-01','11:20:00',2.35),('8537','2013-10-01','11:25:00',4.13),('8537','2013-10-01','11:30:00',3.49),('8537','2013-10-01','11:35:00',1.39),('8537','2013-10-01','11:40:00',3.35),('8537','2013-10-01','11:45:00',4.5),('8537','2013-10-01','11:50:00',4.49),('8537','2013-10-01','11:55:00',4.51),('8537','2013-10-01','12:00:00',4.42),('8537','2013-10-01','12:05:00',4.32),('8537','2013-10-01','12:10:00',4.26),('8537','2013-10-01','12:15:00',4.47),('8537','2013-10-01','12:20:00',4.65),('8537','2013-10-01','12:25:00',4.64),('8537','2013-10-01','12:30:00',4.71),('8537','2013-10-01','12:35:00',4.61),('8537','2013-10-01','12:40:00',1.2),('8537','2013-10-01','12:45:00',4.66),('8537','2013-10-01','12:50:00',4.71),('8537','2013-10-01','12:55:00',4.68),('8537','2013-10-01','13:00:00',4.63),('8537','2013-10-01','13:05:00',4.24),('8537','2013-10-01','13:20:00',4.4),('8537','2013-10-01','13:25:00',4.99),('8537','2013-10-01','13:30:00',4.4),('8537','2013-10-01','13:35:00',4.76),('8537','2013-10-01','13:40:00',4),('8537','2013-10-01','13:45:00',4.71),('8537','2013-10-01','13:50:00',2.82),('8537','2013-10-01','13:55:00',4.49),('8537','2013-10-01','14:00:00',4.33),('8537','2013-10-01','14:05:00',4.25),('8537','2013-10-01','14:10:00',4.22),('8537','2013-10-01','14:15:00',4.14),('8537','2013-10-01','14:20:00',4.11),('8537','2013-10-01','14:25:00',4.06),('8537','2013-10-01','14:30:00',3.95),('8537','2013-10-01','14:35:00',3.85),('8537','2013-10-01','14:40:00',3.98),('8537','2013-10-01','14:45:00',3.95),('8537','2013-10-01','14:50:00',3.83),('8537','2013-10-01','14:55:00',3.86),('8537','2013-10-01','15:00:00',3.82),('8537','2013-10-01','15:05:00',3.69),('8537','2013-10-01','15:10:00',3.59),('8537','2013-10-01','15:15:00',3.5),('8537','2013-10-01','15:20:00',3.43),('8537','2013-10-01','15:25:00',3.39),('8537','2013-10-01','15:30:00',3.33),('8537','2013-10-01','15:35:00',3.2),('8537','2013-10-01','15:40:00',3.17),('8537','2013-10-01','15:45:00',3.08),('8537','2013-10-01','15:50:00',3),('8537','2013-10-01','15:55:00',2.92),('8537','2013-10-01','16:00:00',2.79),('8537','2013-10-01','16:05:00',2.73),('8537','2013-10-01','16:10:00',2.62),('8537','2013-10-01','16:15:00',2.55),('8537','2013-10-01','16:20:00',2.46),('8537','2013-10-01','16:25:00',2.33),('8537','2013-10-01','16:30:00',2.18),('8537','2013-10-01','16:35:00',2.02),('8537','2013-10-01','16:40:00',1.99),('8537','2013-10-01','16:45:00',1.89),('8537','2013-10-01','16:50:00',1.79),('8537','2013-10-01','16:55:00',1.66),('8537','2013-10-01','17:00:00',1.55),('8537','2013-10-01','17:05:00',1.43),('8537','2013-10-01','17:10:00',1.33),('8537','2013-10-01','17:15:00',1.18),('8537','2013-10-01','17:20:00',1.1),('8537','2013-10-01','17:25:00',1.01),('8537','2013-09-30','09:45:00',1.14),('8537','2013-09-30','09:50:00',1.5),('8537','2013-09-30','09:55:00',1.27),('8537','2013-09-30','10:00:00',1.19),('8537','2013-09-30','10:05:00',1.15),('8537','2013-09-30','10:10:00',1.25),('8537','2013-09-30','10:15:00',1.27),('8537','2013-09-30','10:20:00',1.28),('8537','2013-09-30','10:25:00',1.53),('8537','2013-09-30','10:30:00',1.75),('8537','2013-09-30','10:35:00',2.01),('8537','2013-09-30','10:40:00',2.63),('8537','2013-09-30','10:45:00',3.95),('8537','2013-09-30','10:50:00',4.08),('8537','2013-09-30','10:55:00',3.76),('8537','2013-09-30','11:00:00',2.77),('8537','2013-09-30','11:05:00',2.83),('8537','2013-09-30','11:10:00',3.21),('8537','2013-09-30','11:15:00',3.54),('8537','2013-09-30','11:20:00',3.89),('8537','2013-09-30','11:25:00',2.87),('8537','2013-09-30','11:30:00',2.07),('8537','2013-09-30','11:35:00',1.78),('8537','2013-09-30','11:40:00',3.7),('8537','2013-09-30','11:45:00',2.39),('8537','2013-09-30','11:50:00',2.1),('8537','2013-09-30','11:55:00',1.71),('8537','2013-09-30','12:00:00',1.76),('8537','2013-09-30','12:05:00',1.95),('8537','2013-09-30','12:10:00',2.11),('8537','2013-09-30','12:15:00',4.78),('8537','2013-09-30','12:20:00',4.79),('8537','2013-09-30','12:25:00',4.77),('8537','2013-09-30','12:30:00',4.54),('8537','2013-09-30','12:35:00',4.62),('8537','2013-09-30','12:40:00',4.52),('8537','2013-09-30','12:45:00',3.99),('8537','2013-09-30','12:50:00',4.84),('8537','2013-09-30','12:55:00',4.73),('8537','2013-09-30','13:00:00',4.78),('8537','2013-09-30','13:05:00',4.7),('8537','2013-09-30','13:10:00',4.89),('8537','2013-09-30','13:15:00',4.68),('8537','2013-09-30','13:20:00',5.02),('8537','2013-09-30','13:25:00',5.25),('8537','2013-09-30','13:30:00',5.16),('8537','2013-09-30','13:35:00',4.23),('8537','2013-09-30','13:40:00',4.55),('8537','2013-09-30','13:45:00',3.02),('8537','2013-09-30','13:50:00',3.81),('8537','2013-09-30','13:55:00',2.78),('8537','2013-09-30','14:00:00',2.21),('8537','2013-09-30','14:05:00',1.62),('8537','2013-09-30','14:10:00',1.54),('8537','2013-09-30','14:15:00',1.46),('8537','2013-09-30','14:20:00',1.24),('8537','2013-09-30','14:25:00',1.39),('8537','2013-09-30','14:30:00',2.98),('8537','2013-09-30','14:35:00',3.17),('8537','2013-09-30','14:40:00',4.57),('8537','2013-09-30','14:45:00',4.16),('8537','2013-09-30','14:50:00',3.23),('8537','2013-09-30','14:55:00',3.38),('8537','2013-09-30','15:00:00',2.13),('8537','2013-09-30','15:05:00',2.61),('8537','2013-09-30','15:10:00',4.36),('8537','2013-09-30','15:15:00',2.55),('8537','2013-09-30','15:20:00',1.35),('8537','2013-09-30','15:25:00',3.02),('8537','2013-09-30','15:30:00',2.53),('8537','2013-09-30','15:35:00',3.02),('8537','2013-09-30','15:40:00',3.78),('8537','2013-09-30','15:45:00',2.55),('8537','2013-09-30','16:10:00',1.08),('8537','2013-09-30','16:15:00',1.68),('8537','2013-09-30','16:20:00',2.13),('8537','2013-09-30','16:25:00',1.01),('8537','2013-09-30','16:40:00',1.07),('8537','2013-09-30','16:45:00',1.69),('8537','2013-09-29','08:45:00',1.13),('8537','2013-09-29','08:50:00',1.45),('8537','2013-09-29','08:55:00',1.28),('8537','2013-09-29','09:00:00',1.18),('8537','2013-09-29','09:05:00',1.04),('8537','2013-09-29','09:10:00',1.16),('8537','2013-09-29','09:15:00',1.53),('8537','2013-09-29','09:20:00',1.03),('8537','2013-09-29','09:25:00',1.05),('8537','2013-09-29','09:30:00',1.02),('8537','2013-09-29','09:45:00',1.11),('8537','2013-09-29','09:50:00',1.2),('8537','2013-09-29','09:55:00',1.24),('8537','2013-09-29','10:00:00',1.46),('8537','2013-09-29','10:05:00',2.03),('8537','2013-09-29','10:10:00',2.38),('8537','2013-09-29','10:15:00',3.02),('8537','2013-09-29','10:20:00',2.65),('8537','2013-09-29','10:25:00',2.47),('8537','2013-09-29','10:30:00',2.83),('8537','2013-09-29','10:35:00',3.01),('8537','2013-09-29','10:40:00',3.26),('8537','2013-09-29','10:45:00',3.36),('8537','2013-09-29','10:50:00',3.47),('8537','2013-09-29','10:55:00',3.43),('8537','2013-09-29','11:00:00',3.5),('8537','2013-09-29','11:05:00',3.36),('8537','2013-09-29','11:10:00',3.4),('8537','2013-09-29','11:15:00',3.67),('8537','2013-09-29','11:20:00',3.67),('8537','2013-09-29','11:25:00',3.37),('8537','2013-09-29','11:30:00',3.65),('8537','2013-09-29','11:35:00',3.62),('8537','2013-09-29','11:40:00',3.76),('8537','2013-09-29','11:45:00',3.86),('8537','2013-09-29','11:50:00',4.03),('8537','2013-09-29','11:55:00',3.99),('8537','2013-09-29','12:00:00',3.83),('8537','2013-09-29','12:05:00',4.02),('8537','2013-09-29','12:10:00',3.79),('8537','2013-09-29','12:15:00',4.51),('8537','2013-09-29','12:20:00',3.48),('8537','2013-09-29','12:25:00',2.24),('8537','2013-09-29','12:30:00',2.28),('8537','2013-09-29','12:35:00',2.23),('8537','2013-09-29','12:40:00',1.93),('8537','2013-09-29','12:45:00',1.71),('8537','2013-09-29','12:50:00',1.74),('8537','2013-09-29','12:55:00',1.49),('8537','2013-09-29','13:00:00',1.56),('8537','2013-09-29','13:05:00',1.26),('8537','2013-09-29','13:10:00',1.35),('8537','2013-09-29','13:15:00',1.03),('8537','2013-09-29','13:20:00',1.1),('8537','2013-09-29','13:25:00',1.6),('8537','2013-09-29','13:30:00',2.83),('8537','2013-09-29','13:35:00',1.95),('8537','2013-09-29','13:40:00',1.91),('8537','2013-09-29','13:45:00',1.77),('8537','2013-09-29','13:50:00',1.89),('8537','2013-09-29','13:55:00',2.79),('8537','2013-09-29','14:00:00',2.18),('8537','2013-09-29','14:05:00',2.99),('8537','2013-09-29','14:10:00',1.68),('8537','2013-09-29','14:15:00',1.96),('8537','2013-09-29','14:20:00',2.4),('8537','2013-09-29','14:25:00',1.72),('8537','2013-09-29','14:30:00',1.52),('8537','2013-09-29','14:35:00',1.46),('8537','2013-09-29','14:40:00',1.31),('8537','2013-09-29','14:50:00',1.11),('8537','2013-09-29','14:55:00',1.23),('8537','2013-09-29','15:00:00',1.56),('8537','2013-09-29','15:20:00',1.14),('8537','2013-09-29','15:25:00',1),('8537','2013-09-29','15:55:00',1.07),('8537','2013-09-29','16:00:00',1.35),('8537','2013-09-29','16:05:00',1.1),('8537','2013-09-29','16:30:00',1.3),('8537','2013-09-29','16:35:00',1.14),('8537','2014-04-14','07:55:00',1.09),('8537','2014-04-14','08:00:00',1.2),('8537','2014-04-14','08:05:00',1.32),('8537','2014-04-14','08:10:00',1.43),('8537','2014-04-14','08:15:00',1.55),('8537','2014-04-14','08:20:00',1.67),('8537','2014-04-14','08:25:00',1.79),('8537','2014-04-14','08:30:00',1.9),('8537','2014-04-14','08:35:00',2.02),('8537','2014-04-14','08:40:00',2.13),('8537','2014-04-14','08:45:00',2.25),('8537','2014-04-14','08:50:00',2.36),('8537','2014-04-14','08:55:00',2.46),('8537','2014-04-14','09:00:00',2.57),('8537','2014-04-14','09:05:00',2.66),('8537','2014-04-14','09:10:00',2.78),('8537','2014-04-14','09:15:00',2.87),('8537','2014-04-14','09:20:00',2.96),('8537','2014-04-14','09:25:00',2.99),('8537','2014-04-14','09:30:00',3.13),('8537','2014-04-14','09:35:00',3.22),('8537','2014-04-14','09:40:00',3.3),('8537','2014-04-14','09:45:00',3.4),('8537','2014-04-14','09:50:00',3.49),('8537','2014-04-14','09:55:00',3.6),('8537','2014-04-14','10:00:00',3.67),('8537','2014-04-14','10:05:00',3.78),('8537','2014-04-14','10:10:00',3.83),('8537','2014-04-14','10:15:00',3.93),('8537','2014-04-14','10:20:00',4.02),('8537','2014-04-14','10:25:00',4.09),('8537','2014-04-14','10:30:00',4.15),('8537','2014-04-14','10:35:00',4.22),('8537','2014-04-14','10:40:00',4.23),('8537','2014-04-14','10:45:00',4.34),('8537','2014-04-14','10:50:00',4.4),('8537','2014-04-14','10:55:00',4.45),('8537','2014-04-14','11:00:00',4.49),('8537','2014-04-14','11:05:00',4.54),('8537','2014-04-14','11:10:00',4.58),('8537','2014-04-14','11:15:00',4.63),('8537','2014-04-14','11:20:00',4.69),('8537','2014-04-14','11:25:00',4.72),('8537','2014-04-14','11:30:00',4.75),('8537','2014-04-14','11:35:00',4.81),('8537','2014-04-14','11:40:00',4.83),('8537','2014-04-14','11:45:00',4.86),('8537','2014-04-14','11:50:00',4.89),('8537','2014-04-14','11:55:00',4.88),('8537','2014-04-14','12:00:00',4.91),('8537','2014-04-14','12:05:00',4.93),('8537','2014-04-14','12:10:00',4.98),('8537','2014-04-14','12:15:00',4.99),('8537','2014-04-14','12:20:00',4.98),('8537','2014-04-14','12:25:00',4.93),('8537','2014-04-14','12:30:00',5.07),('8537','2014-04-14','12:35:00',5.03),('8537','2014-04-14','12:40:00',5.11),('8537','2014-04-14','12:45:00',5.13),('8537','2014-04-14','12:50:00',5.13),('8537','2014-04-14','12:55:00',5.11),('8537','2014-04-14','13:00:00',5.15),('8537','2014-04-14','13:05:00',5.13),('8537','2014-04-14','13:10:00',5.11),('8537','2014-04-14','13:15:00',5.06),('8537','2014-04-14','13:20:00',5.13),('8537','2014-04-14','13:25:00',5.09),('8537','2014-04-14','13:30:00',5.09),('8537','2014-04-14','13:35:00',5.14),('8537','2014-04-14','13:40:00',5.11),('8537','2014-04-14','13:45:00',5.08),('8537','2014-04-14','13:50:00',5.05),('8537','2014-04-14','13:55:00',5.04),('8537','2014-04-14','14:00:00',5.03),('8537','2014-04-14','14:05:00',5),('8537','2014-04-14','14:10:00',4.98),('8537','2014-04-14','14:15:00',4.96),('8537','2014-04-14','14:20:00',4.96),('8537','2014-04-14','14:25:00',4.95),('8537','2014-04-14','14:30:00',4.83),('8537','2014-04-14','14:35:00',4.48),('8537','2014-04-14','14:40:00',4.04),('8537','2014-04-14','14:45:00',4.53),('8537','2014-04-14','14:50:00',4.67),('8537','2014-04-14','14:55:00',4.62),('8537','2014-04-14','15:00:00',4.56),('8537','2014-04-14','15:05:00',4.51),('8537','2014-04-14','15:10:00',4.47),('8537','2014-04-14','15:15:00',4.41),('8537','2014-04-14','15:20:00',4.35),('8537','2014-04-14','15:25:00',4.08),('8537','2014-04-14','15:30:00',4.05),('8537','2014-04-14','15:35:00',4.1),('8537','2014-04-14','15:40:00',4.05),('8537','2014-04-14','15:45:00',3.98),('8537','2014-04-14','15:50:00',3.91),('8537','2014-04-14','15:55:00',3.86),('8537','2014-04-14','16:00:00',3.76),('8537','2014-04-14','16:05:00',3.57),('8537','2014-04-14','16:10:00',3.21),('8537','2014-04-14','16:15:00',3.46),('8537','2014-04-14','16:20:00',3.38),('8537','2014-04-14','16:25:00',3.31),('8537','2014-04-14','16:30:00',3.21),('8537','2014-04-14','16:35:00',3.13),('8537','2014-04-14','16:40:00',2.87),('8537','2014-04-14','16:45:00',2.7),('8537','2014-04-14','16:50:00',2.8),('8537','2014-04-14','16:55:00',2.71),('8537','2014-04-14','17:00:00',2.55),('8537','2014-04-14','17:05:00',2.4),('8537','2014-04-14','17:10:00',2.32),('8537','2014-04-14','17:15:00',2.19),('8537','2014-04-14','17:20:00',2.13),('8537','2014-04-14','17:25:00',2.02),('8537','2014-04-14','17:30:00',1.86),('8537','2014-04-14','17:35:00',1.74),('8537','2014-04-14','17:40:00',1.63),('8537','2014-04-14','17:45:00',1.53),('8537','2014-04-14','17:50:00',1.42),('8537','2014-04-14','17:55:00',1.3),('8537','2014-04-14','18:00:00',1.2),('8537','2014-04-14','18:05:00',1.09),('8537','2013-09-28','08:15:00',1.01),('8537','2013-09-28','08:20:00',1.16),('8537','2013-09-28','08:30:00',1.27),('8537','2013-09-28','08:35:00',1.35),('8537','2013-09-28','08:40:00',1.47),('8537','2013-09-28','08:45:00',1.56),('8537','2013-09-28','08:50:00',1.67),('8537','2013-09-28','08:55:00',1.74),('8537','2013-09-28','09:00:00',1.85),('8537','2013-09-28','09:05:00',1.95),('8537','2013-09-28','09:10:00',2.09),('8537','2013-09-28','09:15:00',2.19),('8537','2013-09-28','09:20:00',2.27),('8537','2013-09-28','09:25:00',2.39),('8537','2013-09-28','09:30:00',2.49),('8537','2013-09-28','09:35:00',2.57),('8537','2013-09-28','09:40:00',2.72),('8537','2013-09-28','09:45:00',2.53),('8537','2013-09-28','09:50:00',2.52),('8537','2013-09-28','09:55:00',2.61),('8537','2013-09-28','10:00:00',1.88),('8537','2013-09-28','10:05:00',2.77),('8537','2013-09-28','10:10:00',1.41),('8537','2013-09-28','10:15:00',1.09),('8537','2013-09-28','10:20:00',1.25),('8537','2013-09-28','10:25:00',1.82),('8537','2013-09-28','10:30:00',2.48),('8537','2013-09-28','10:35:00',2.67),('8537','2013-09-28','10:40:00',2.49),('8537','2013-09-28','10:45:00',3.27),('8537','2013-09-28','10:50:00',4.22),('8537','2013-09-28','10:55:00',4.3),('8537','2013-09-28','11:00:00',3.94),('8537','2013-09-28','11:05:00',1.5),('8537','2013-09-28','11:10:00',2.03),('8537','2013-09-28','11:15:00',3.9),('8537','2013-09-28','11:20:00',4.23),('8537','2013-09-28','11:25:00',4.14),('8537','2013-09-28','11:30:00',4.42),('8537','2013-09-28','11:35:00',3.66),('8537','2013-09-28','11:40:00',3.62),('8537','2013-09-28','11:45:00',1.11),('8537','2013-09-28','11:50:00',2.52),('8537','2013-09-28','11:55:00',1.6),('8537','2013-09-28','12:00:00',4.74),('8537','2013-09-28','12:05:00',4.66),('8537','2013-09-28','12:10:00',4.5),('8537','2013-09-28','12:15:00',2.98),('8537','2013-09-28','12:20:00',4.07),('8537','2013-09-28','12:25:00',3.02),('8537','2013-09-28','12:30:00',2.21),('8537','2013-09-28','12:35:00',2.8),('8537','2013-09-28','12:40:00',2.61),('8537','2013-09-28','12:45:00',1.76),('8537','2013-09-28','12:50:00',5.06),('8537','2013-09-28','12:55:00',4.49),('8537','2013-09-28','13:00:00',4.52),('8537','2013-09-28','13:05:00',3.67),('8537','2013-09-28','13:10:00',1.36),('8537','2013-09-28','13:15:00',1.59),('8537','2013-09-28','13:20:00',2.31),('8537','2013-09-28','13:25:00',3.81),('8537','2013-09-28','13:30:00',3.51),('8537','2013-09-28','13:35:00',1.87),('8537','2013-09-28','13:40:00',1.79),('8537','2013-09-28','13:45:00',2.4),('8537','2013-09-28','13:50:00',2.79),('8537','2013-09-28','13:55:00',1.74),('8537','2013-09-28','14:00:00',1.98),('8537','2013-09-28','14:05:00',2.16),('8537','2013-09-28','14:10:00',1.85),('8537','2013-09-28','14:15:00',2.31),('8537','2013-09-28','14:20:00',4.21),('8537','2013-09-28','14:25:00',4.62),('8537','2013-09-28','14:30:00',4.2),('8537','2013-09-28','14:35:00',4.35),('8537','2013-09-28','14:40:00',4.33),('8537','2013-09-28','14:45:00',4.27),('8537','2013-09-28','14:50:00',3.13),('8537','2013-09-28','14:55:00',3.22),('8537','2013-09-28','15:00:00',4.17),('8537','2013-09-28','15:05:00',2.67),('8537','2013-09-28','15:10:00',2.79),('8537','2013-09-28','15:15:00',3.39),('8537','2013-09-28','15:20:00',3.82),('8537','2013-09-28','15:25:00',3.8),('8537','2013-09-28','15:30:00',3.62),('8537','2013-09-28','15:35:00',3.35),('8537','2013-09-28','15:40:00',3.27),('8537','2013-09-28','15:45:00',2.47),('8537','2013-09-28','15:50:00',2.18),('8537','2013-09-28','15:55:00',2.67),('8537','2013-09-28','16:00:00',2.95),('8537','2013-09-28','16:05:00',3.01),('8537','2013-09-28','16:10:00',2.94),('8537','2013-09-28','16:15:00',2.76),('8537','2013-09-28','16:20:00',2.54),('8537','2013-09-28','16:25:00',2.19),('8537','2013-09-28','16:30:00',2.06),('8537','2013-09-28','16:35:00',2.05),('8537','2013-09-28','16:40:00',1.95),('8537','2013-09-28','16:45:00',1.82),('8537','2013-09-28','16:50:00',1.74),('8537','2013-09-28','16:55:00',1.63),('8537','2013-09-28','17:00:00',1.49),('8537','2013-09-28','17:05:00',1.41),('8537','2013-09-28','17:10:00',1.28),('8537','2013-09-28','17:15:00',1.19),('8537','2013-09-28','17:20:00',1.09),('8537','2013-09-28','17:25:00',1),('8537','2013-09-27','08:25:00',1.32),('8537','2013-09-27','08:30:00',1.28),('8537','2013-09-27','08:35:00',1.47),('8537','2013-09-27','08:40:00',1.57),('8537','2013-09-27','08:45:00',1.37),('8537','2013-09-27','08:50:00',1.54),('8537','2013-09-27','08:55:00',1.93),('8537','2013-09-27','09:00:00',1.78),('8537','2013-09-27','09:05:00',1.42),('8537','2013-09-27','09:10:00',1.2),('8537','2013-09-27','09:15:00',1.27),('8537','2013-09-27','09:25:00',1.15),('8537','2013-09-27','09:50:00',1.61),('8537','2013-09-27','09:55:00',2.82),('8537','2013-09-27','10:00:00',2.04),('8537','2013-09-27','10:05:00',2.62),('8537','2013-09-27','10:10:00',2.1),('8537','2013-09-27','10:15:00',2.16),('8537','2013-09-27','10:20:00',3.19),('8537','2013-09-27','10:25:00',2.37),('8537','2013-09-27','10:30:00',1.98),('8537','2013-09-27','10:35:00',1.9),('8537','2013-09-27','10:40:00',1.52),('8537','2013-09-27','10:45:00',1.78),('8537','2013-09-27','10:50:00',1.62),('8537','2013-09-27','10:55:00',3.28),('8537','2013-09-27','11:00:00',3.67),('8537','2013-09-27','11:05:00',3.43),('8537','2013-09-27','11:10:00',3.2),('8537','2013-09-27','11:15:00',3.49),('8537','2013-09-27','11:20:00',3.03),('8537','2013-09-27','11:25:00',2.62),('8537','2013-09-27','11:30:00',2.18),('8537','2013-09-27','11:35:00',1.23),('8537','2013-09-27','11:40:00',1.24),('8537','2013-09-27','11:45:00',2.78),('8537','2013-09-27','11:50:00',1.3),('8537','2013-09-27','11:55:00',1.38),('8537','2013-09-27','12:00:00',4.32),('8537','2013-09-27','12:05:00',2.44),('8537','2013-09-27','12:10:00',4.69),('8537','2013-09-27','12:15:00',3.36),('8537','2013-09-27','12:20:00',1.15),('8537','2013-09-27','12:25:00',1.24),('8537','2013-09-27','12:30:00',1.43),('8537','2013-09-27','12:35:00',1.23),('8537','2013-09-27','12:40:00',1.07),('8537','2013-09-27','12:45:00',1.53),('8537','2013-09-27','12:50:00',3.57),('8537','2013-09-27','12:55:00',4.36),('8537','2013-09-27','13:00:00',4.36),('8537','2013-09-27','13:05:00',4.35),('8537','2013-09-27','13:10:00',4.51),('8537','2013-09-27','13:15:00',3.36),('8537','2013-09-27','13:20:00',2.62),('8537','2013-09-27','13:25:00',2.55),('8537','2013-09-27','13:30:00',1.01),('8537','2013-09-27','13:35:00',1.06),('8537','2013-09-27','13:40:00',1.13),('8537','2013-09-27','13:45:00',1.66),('8537','2013-09-27','13:50:00',1.31),('8537','2013-09-27','13:55:00',1.57),('8537','2013-09-27','14:00:00',1.96),('8537','2013-09-27','14:05:00',3.96),('8537','2013-09-27','14:10:00',2.62),('8537','2013-09-27','14:15:00',4.2),('8537','2013-09-27','14:20:00',3.51),('8537','2013-09-27','14:25:00',4.21),('8537','2013-09-27','14:30:00',3.18),('8537','2013-09-27','14:35:00',4.05),('8537','2013-09-27','14:40:00',3.94),('8537','2013-09-27','14:45:00',3.9),('8537','2013-09-27','14:50:00',3.84),('8537','2013-09-27','14:55:00',3.74),('8537','2013-09-27','15:00:00',3.78),('8537','2013-09-27','15:05:00',2.62),('8537','2013-09-27','15:10:00',2.67),('8537','2013-09-27','15:15:00',3.53),('8537','2013-09-27','15:20:00',2.75),('8537','2013-09-27','15:25:00',3.39),('8537','2013-09-27','15:30:00',3.34),('8537','2013-09-27','15:35:00',3.21),('8537','2013-09-27','15:40:00',3.15),('8537','2013-09-27','15:45:00',2.6),('8537','2013-09-27','15:50:00',3.14),('8537','2013-09-27','15:55:00',2.95),('8537','2013-09-27','16:00:00',2.27),('8537','2013-09-27','16:05:00',2.22),('8537','2013-09-27','16:10:00',1.26),('8537','2013-09-27','16:15:00',1.9),('8537','2013-09-27','16:20:00',2.18),('8537','2013-09-27','16:25:00',2.21),('8537','2013-09-27','16:30:00',2.09),('8537','2013-09-27','16:35:00',2.09),('8537','2013-09-27','16:40:00',1.84),('8537','2013-09-27','16:45:00',1.93),('8537','2013-09-27','16:50:00',1.64),('8537','2013-09-27','16:55:00',1.06),('8537','2013-09-27','17:10:00',1.2),('8537','2013-09-27','17:15:00',1.4),('8537','2013-09-27','17:20:00',1.21),('8537','2013-09-27','17:25:00',1.1),('8537','2013-09-27','17:30:00',1.01),('8537','2013-09-26','08:15:00',1.06),('8537','2013-09-26','08:25:00',1.23),('8537','2013-09-26','08:30:00',1.21),('8537','2013-09-26','08:35:00',1.27),('8537','2013-09-26','08:40:00',1.55),('8537','2013-09-26','08:45:00',1.68),('8537','2013-09-26','08:50:00',1.82),('8537','2013-09-26','08:55:00',1.94),('8537','2013-09-26','09:00:00',2.04),('8537','2013-09-26','09:05:00',2.13),('8537','2013-09-26','09:10:00',2.24),('8537','2013-09-26','09:15:00',2.36),('8537','2013-09-26','09:20:00',2.47),('8537','2013-09-26','09:25:00',2.55),('8537','2013-09-26','09:30:00',2.63),('8537','2013-09-26','09:35:00',2.74),('8537','2013-09-26','09:40:00',2.81),('8537','2013-09-26','09:45:00',2.91),('8537','2013-09-26','09:50:00',3),('8537','2013-09-26','09:55:00',3.04),('8537','2013-09-26','10:00:00',3.13),('8537','2013-09-26','10:05:00',3.21),('8537','2013-09-26','10:10:00',3.3),('8537','2013-09-26','10:15:00',3.29),('8537','2013-09-26','10:20:00',3.35),('8537','2013-09-26','10:25:00',3.33),('8537','2013-09-26','10:30:00',3.49),('8537','2013-09-26','10:35:00',3.57),('8537','2013-09-26','10:40:00',3.58),('8537','2013-09-26','10:45:00',3.67),('8537','2013-09-26','10:50:00',3.68),('8537','2013-09-26','10:55:00',3.75),('8537','2013-09-26','11:00:00',3.64),('8537','2013-09-26','11:05:00',3.78),('8537','2013-09-26','11:10:00',3.88),('8537','2013-09-26','11:15:00',3.89),('8537','2013-09-26','11:20:00',3.99),('8537','2013-09-26','11:25:00',4.03),('8537','2013-09-26','11:30:00',4.05),('8537','2013-09-26','11:35:00',3.71),('8537','2013-09-26','11:40:00',3.35),('8537','2013-09-26','11:45:00',4.1),('8537','2013-09-26','11:50:00',4.17),('8537','2013-09-26','11:55:00',2.41),('8537','2013-09-26','12:00:00',4.02),('8537','2013-09-26','12:05:00',3.13),('8537','2013-09-26','12:10:00',1.87),('8537','2013-09-26','12:15:00',1.62),('8537','2013-09-26','12:20:00',2.03),('8537','2013-09-26','12:25:00',1.53),('8537','2013-09-26','12:30:00',1.59),('8537','2013-09-26','12:35:00',1.64),('8537','2013-09-26','12:40:00',1.79),('8537','2013-09-26','12:45:00',1.97),('8537','2013-09-26','12:50:00',1.88),('8537','2013-09-26','12:55:00',2.78),('8537','2013-09-26','13:00:00',3.76),('8537','2013-09-26','13:05:00',3.05),('8537','2013-09-26','13:10:00',2.14),('8537','2013-09-26','13:15:00',3.41),('8537','2013-09-26','13:20:00',4.89),('8537','2013-09-26','13:25:00',4.66),('8537','2013-09-26','13:30:00',2.21),('8537','2013-09-26','13:35:00',2.34),('8537','2013-09-26','13:40:00',2.01),('8537','2013-09-26','13:45:00',1.65),('8537','2013-09-26','13:50:00',1.95),('8537','2013-09-26','13:55:00',2.58),('8537','2013-09-26','14:00:00',2.95),('8537','2013-09-26','14:05:00',3.69),('8537','2013-09-26','14:10:00',4.26),('8537','2013-09-26','14:15:00',3.94),('8537','2013-09-26','14:20:00',3.37),('8537','2013-09-26','14:25:00',1.08),('8537','2013-09-26','14:30:00',1.22),('8537','2013-09-26','14:35:00',3.14),('8537','2013-09-26','14:40:00',2.04),('8537','2013-09-26','14:45:00',3.93),('8537','2013-09-26','14:50:00',4.55),('8537','2013-09-26','14:55:00',2.92),('8537','2013-09-26','15:00:00',1.6),('8537','2013-09-26','15:05:00',2.52),('8537','2013-09-26','15:10:00',1.71),('8537','2013-09-26','15:15:00',1.61),('8537','2013-09-26','15:20:00',2.15),('8537','2013-09-26','15:25:00',3.1),('8537','2013-09-26','15:35:00',2.33),('8537','2013-09-26','15:40:00',1.57),('8537','2013-09-26','15:45:00',1.93),('8537','2013-09-26','15:50:00',2.85),('8537','2013-09-26','15:55:00',3.04),('8537','2013-09-26','16:00:00',2.87),('8537','2013-09-26','16:05:00',2.74),('8537','2013-09-26','16:10:00',2.7),('8537','2013-09-26','16:15:00',2.48),('8537','2013-09-26','16:20:00',2.28),('8537','2013-09-26','16:25:00',2.15),('8537','2013-09-26','16:30:00',2.2),('8537','2013-09-26','16:35:00',2.09),('8537','2013-09-26','16:40:00',2.02),('8537','2013-09-26','16:45:00',1.91),('8537','2013-09-26','16:50:00',1.8),('8537','2013-09-26','16:55:00',1.7),('8537','2013-09-26','17:00:00',1.56),('8537','2013-09-26','17:05:00',1.52),('8537','2013-09-26','17:10:00',1.45),('8537','2013-09-26','17:15:00',1.32),('8537','2013-09-26','17:20:00',1.24),('8537','2013-09-26','17:25:00',1.05),('8537','2013-09-25','08:25:00',1.15),('8537','2013-09-25','08:30:00',1.26),('8537','2013-09-25','08:45:00',1.74),('8537','2013-09-25','08:50:00',1.51),('8537','2013-09-25','09:05:00',1.16),('8537','2013-09-25','09:10:00',1.69),('8537','2013-09-25','09:15:00',1.56),('8537','2013-09-25','09:20:00',1.12),('8537','2013-09-25','09:25:00',1.72),('8537','2013-09-25','09:30:00',1.95),('8537','2013-09-25','09:35:00',2.72),('8537','2013-09-25','09:40:00',2.56),('8537','2013-09-25','09:50:00',2.61),('8537','2013-09-25','09:55:00',1.44),('8537','2013-09-25','10:00:00',2.23),('8537','2013-09-25','10:05:00',1.41),('8537','2013-09-25','10:10:00',1.09),('8537','2013-09-25','10:20:00',1.47),('8537','2013-09-25','10:25:00',1.41),('8537','2013-09-25','10:30:00',1.86),('8537','2013-09-25','10:40:00',1.69),('8537','2013-09-25','10:45:00',2.54),('8537','2013-09-25','10:50:00',4.46),('8537','2013-09-25','10:55:00',4.42),('8537','2013-09-25','11:00:00',4.09),('8537','2013-09-25','11:05:00',1.66),('8537','2013-09-25','11:10:00',3.4),('8537','2013-09-25','11:15:00',1.71),('8537','2013-09-25','11:20:00',1.25),('8537','2013-09-25','11:25:00',4.33),('8537','2013-09-25','11:30:00',4.35),('8537','2013-09-25','11:35:00',4.16),('8537','2013-09-25','11:40:00',3.39),('8537','2013-09-25','11:45:00',4.46),('8537','2013-09-25','11:50:00',2.88),('8537','2013-09-25','11:55:00',2.02),('8537','2013-09-25','12:00:00',1.21),('8537','2013-09-25','12:10:00',1.25),('8537','2013-09-25','12:15:00',3.22),('8537','2013-09-25','12:20:00',4.35),('8537','2013-09-25','12:25:00',1.44),('8537','2013-09-25','12:30:00',3.06),('8537','2013-09-25','12:35:00',3.76),('8537','2013-09-25','12:40:00',4.29),('8537','2013-09-25','12:45:00',1.28),('8537','2013-09-25','12:50:00',1.21),('8537','2013-09-25','13:00:00',1.52),('8537','2013-09-25','13:05:00',1.18),('8537','2013-09-25','13:10:00',1.11),('8537','2013-09-25','13:15:00',1.11),('8537','2013-09-25','13:20:00',1.25),('8537','2013-09-25','13:25:00',1.31),('8537','2013-09-25','13:30:00',1.51),('8537','2013-09-25','13:35:00',5.03),('8537','2013-09-25','13:40:00',5.05),('8537','2013-09-25','13:45:00',5.07),('8537','2013-09-25','13:50:00',4.99),('8537','2013-09-25','13:55:00',4.02),('8537','2013-09-25','14:00:00',1.18),('8537','2013-09-25','14:05:00',1.12),('8537','2013-09-25','14:10:00',1.28),('8537','2013-09-25','14:15:00',1.14),('8537','2013-09-25','14:20:00',1.11),('8537','2013-09-25','14:25:00',1.32),('8537','2013-09-25','14:30:00',3.19),('8537','2013-09-25','14:35:00',4.07),('8537','2013-09-25','14:40:00',3.82),('8537','2013-09-25','14:45:00',3.05),('8537','2013-09-25','14:50:00',2.74),('8537','2013-09-25','14:55:00',2.92),('8537','2013-09-25','15:00:00',3.59),('8537','2013-09-25','15:05:00',3.97),('8537','2013-09-25','15:10:00',3.74),('8537','2013-09-25','15:15:00',3.71),('8537','2013-09-25','15:20:00',3.72),('8537','2013-09-25','15:25:00',3.3),('8537','2013-09-25','15:30:00',3.61),('8537','2013-09-25','15:35:00',3.16),('8537','2013-09-25','15:40:00',3.65),('8537','2013-09-25','15:45:00',3.19),('8537','2013-09-25','15:50:00',3.25),('8537','2013-09-25','15:55:00',3.14),('8537','2013-09-25','16:00:00',3.04),('8537','2013-09-25','16:05:00',2.95),('8537','2013-09-25','16:10:00',2.84),('8537','2013-09-25','16:15:00',2.75),('8537','2013-09-25','16:20:00',2.62),('8537','2013-09-25','16:25:00',1.16),('8537','2013-09-25','16:30:00',2.46),('8537','2013-09-25','16:35:00',2.27),('8537','2013-09-25','16:40:00',2.18),('8537','2013-09-25','16:45:00',2.08),('8537','2013-09-25','16:50:00',1.97),('8537','2013-09-25','16:55:00',1.83),('8537','2013-09-25','17:00:00',1.71),('8537','2013-09-25','17:05:00',1.62),('8537','2013-09-25','17:10:00',1.52),('8537','2013-09-25','17:15:00',1.41),('8537','2013-09-25','17:20:00',1.29),('8537','2013-09-25','17:25:00',1.17),('8537','2013-09-25','17:30:00',1.09),('8537','2013-09-24','08:10:00',1.03),('8537','2013-09-24','08:15:00',1.14),('8537','2013-09-24','08:20:00',1.27),('8537','2013-09-24','08:25:00',1.38),('8537','2013-09-24','08:30:00',1.49),('8537','2013-09-24','08:35:00',1.61),('8537','2013-09-24','08:40:00',1.73),('8537','2013-09-24','08:45:00',1.84),('8537','2013-09-24','08:50:00',1.93),('8537','2013-09-24','08:55:00',2.05),('8537','2013-09-24','09:00:00',2.15),('8537','2013-09-24','09:05:00',2.26),('8537','2013-09-24','09:10:00',2.37),('8537','2013-09-24','09:15:00',2.46),('8537','2013-09-24','09:20:00',2.56),('8537','2013-09-24','09:25:00',2.67),('8537','2013-09-24','09:30:00',2.78),('8537','2013-09-24','09:35:00',2.87),('8537','2013-09-24','09:40:00',2.96),('8537','2013-09-24','09:45:00',3.02),('8537','2013-09-24','09:50:00',3.09),('8537','2013-09-24','09:55:00',3.19),('8537','2013-09-24','10:00:00',3.24),('8537','2013-09-24','10:05:00',3.33),('8537','2013-09-24','10:10:00',3.43),('8537','2013-09-24','10:15:00',3.5),('8537','2013-09-24','10:20:00',3.58),('8537','2013-09-24','10:25:00',3.67),('8537','2013-09-24','10:30:00',3.73),('8537','2013-09-24','10:35:00',3.77),('8537','2013-09-24','10:40:00',3.85),('8537','2013-09-24','10:45:00',3.89),('8537','2013-09-24','10:50:00',3.95),('8537','2013-09-24','10:55:00',4.03),('8537','2013-09-24','11:00:00',4.06),('8537','2013-09-24','11:05:00',4.07),('8537','2013-09-24','11:10:00',4.1),('8537','2013-09-24','11:15:00',4.12),('8537','2013-09-24','11:20:00',4.15),('8537','2013-09-24','11:25:00',4.23),('8537','2013-09-24','11:30:00',4.25),('8537','2013-09-24','11:35:00',4.28),('8537','2013-09-24','11:40:00',4.32),('8537','2013-09-24','11:45:00',4.34),('8537','2013-09-24','11:50:00',4.34),('8537','2013-09-24','11:55:00',4.33),('8537','2013-09-24','12:00:00',4.38),('8537','2013-09-24','12:05:00',4.38),('8537','2013-09-24','12:10:00',4.4),('8537','2013-09-24','12:15:00',4.42),('8537','2013-09-24','12:20:00',4.44),('8537','2013-09-24','12:25:00',4.45),('8537','2013-09-24','12:30:00',4.47),('8537','2013-09-24','12:35:00',4.48),('8537','2013-09-24','12:40:00',4.51),('8537','2013-09-24','12:45:00',4.53),('8537','2013-09-24','12:50:00',4.51),('8537','2013-09-24','12:55:00',4.52),('8537','2013-09-24','13:00:00',4.51),('8537','2013-09-24','13:05:00',4.52),('8537','2013-09-24','13:10:00',4.48),('8537','2013-09-24','13:15:00',4.55),('8537','2013-09-24','13:20:00',4.53),('8537','2013-09-24','13:25:00',4.5),('8537','2013-09-24','13:30:00',4.43),('8537','2013-09-24','13:35:00',4.45),('8537','2013-09-24','13:40:00',4.46),('8537','2013-09-24','13:45:00',4.45),('8537','2013-09-24','13:50:00',4.38),('8537','2013-09-24','13:55:00',4.38),('8537','2013-09-24','14:00:00',4.35),('8537','2013-09-24','14:05:00',4.34),('8537','2013-09-24','14:10:00',4.29),('8537','2013-09-24','14:15:00',4.25),('8537','2013-09-24','14:20:00',4.09),('8537','2013-09-24','14:25:00',4.08),('8537','2013-09-24','14:30:00',4.1),('8537','2013-09-24','14:35:00',4.06),('8537','2013-09-24','14:40:00',4.03),('8537','2013-09-24','14:45:00',3.98),('8537','2013-09-24','14:50:00',3.88),('8537','2013-09-24','14:55:00',3.82),('8537','2013-09-24','15:00:00',3.76),('8537','2013-09-24','15:05:00',3.68),('8537','2013-09-24','15:10:00',3.58),('8537','2013-09-24','15:15:00',3.59),('8537','2013-09-24','15:20:00',3.55),('8537','2013-09-24','15:25:00',3.52),('8537','2013-09-24','15:30:00',3.47),('8537','2013-09-24','15:35:00',3.39),('8537','2013-09-24','15:40:00',3.3),('8537','2013-09-24','15:45:00',3.22),('8537','2013-09-24','15:50:00',3.15),('8537','2013-09-24','15:55:00',3.07),('8537','2013-09-24','16:00:00',2.99),('8537','2013-09-24','16:05:00',2.91),('8537','2013-09-24','16:10:00',2.79),('8537','2013-09-24','16:15:00',2.63),('8537','2013-09-24','16:20:00',2.28),('8537','2013-09-24','16:25:00',2.46),('8537','2013-09-24','16:30:00',2.44),('8537','2013-09-24','16:35:00',2.24),('8537','2013-09-24','16:40:00',2.14),('8537','2013-09-24','16:45:00',2.07),('8537','2013-09-24','16:50:00',2.01),('8537','2013-09-24','16:55:00',1.89),('8537','2013-09-24','17:00:00',1.78),('8537','2013-09-24','17:05:00',1.63),('8537','2013-09-24','17:10:00',1.56),('8537','2013-09-24','17:15:00',1.45),('8537','2013-09-24','17:20:00',1.34),('8537','2013-09-24','17:25:00',1.21),('8537','2013-09-24','17:30:00',1.09),('8537','2013-09-23','08:10:00',1.08),('8537','2013-09-23','08:15:00',1.19),('8537','2013-09-23','08:20:00',1.31),('8537','2013-09-23','08:25:00',1.44),('8537','2013-09-23','08:30:00',1.55),('8537','2013-09-23','08:35:00',1.67),('8537','2013-09-23','08:40:00',1.79),('8537','2013-09-23','08:45:00',1.91),('8537','2013-09-23','08:50:00',2.02),('8537','2013-09-23','08:55:00',2.13),('8537','2013-09-23','09:00:00',2.22),('8537','2013-09-23','09:05:00',2.34),('8537','2013-09-23','09:10:00',2.45),('8537','2013-09-23','09:15:00',2.55),('8537','2013-09-23','09:20:00',2.65),('8537','2013-09-23','09:25:00',2.74),('8537','2013-09-23','09:30:00',2.84),('8537','2013-09-23','09:35:00',2.92),('8537','2013-09-23','09:40:00',3.02),('8537','2013-09-23','09:45:00',3.1),('8537','2013-09-23','09:50:00',3.19),('8537','2013-09-23','09:55:00',3.27),('8537','2013-09-23','10:00:00',3.36),('8537','2013-09-23','10:05:00',3.45),('8537','2013-09-23','10:10:00',3.52),('8537','2013-09-23','10:15:00',3.58),('8537','2013-09-23','10:20:00',3.65),('8537','2013-09-23','10:25:00',3.71),('8537','2013-09-23','10:30:00',3.78),('8537','2013-09-23','10:35:00',3.85),('8537','2013-09-23','10:40:00',3.91),('8537','2013-09-23','10:45:00',3.96),('8537','2013-09-23','10:50:00',3.98),('8537','2013-09-23','10:55:00',4.08),('8537','2013-09-23','11:00:00',4.12),('8537','2013-09-23','11:05:00',4.2),('8537','2013-09-23','11:10:00',4.26),('8537','2013-09-23','11:15:00',4.33),('8537','2013-09-23','11:20:00',4.36),('8537','2013-09-23','11:25:00',4.39),('8537','2013-09-23','11:30:00',4.45),('8537','2013-09-23','11:35:00',4.48),('8537','2013-09-23','11:40:00',4.5),('8537','2013-09-23','11:45:00',4.52),('8537','2013-09-23','11:50:00',4.58),('8537','2013-09-23','11:55:00',4.6),('8537','2013-09-23','12:00:00',4.64),('8537','2013-09-23','12:05:00',4.69),('8537','2013-09-23','12:10:00',4.72),('8537','2013-09-23','12:15:00',4.73),('8537','2013-09-23','12:20:00',4.75),('8537','2013-09-23','12:25:00',4.73),('8537','2013-09-23','12:30:00',4.69),('8537','2013-09-23','12:35:00',4.65),('8537','2013-09-23','12:40:00',4.64),('8537','2013-09-23','12:45:00',4.68),('8537','2013-09-23','12:50:00',4.66),('8537','2013-09-23','12:55:00',4.69),('8537','2013-09-23','13:00:00',4.71),('8537','2013-09-23','13:05:00',4.65),('8537','2013-09-23','13:10:00',4.64),('8537','2013-09-23','13:15:00',4.62),('8537','2013-09-23','13:20:00',4.57),('8537','2013-09-23','13:25:00',4.6),('8537','2013-09-23','13:30:00',4.59),('8537','2013-09-23','13:35:00',4.58),('8537','2013-09-23','13:40:00',4.57),('8537','2013-09-23','13:45:00',4.57),('8537','2013-09-23','13:50:00',4.55),('8537','2013-09-23','13:55:00',4.46),('8537','2013-09-23','14:00:00',4.41),('8537','2013-09-23','14:05:00',4.33),('8537','2013-09-23','14:10:00',4.36),('8537','2013-09-23','14:15:00',4.39),('8537','2013-09-23','14:20:00',4.15),('8537','2013-09-23','14:25:00',4.16),('8537','2013-09-23','14:30:00',4.28),('8537','2013-09-23','14:35:00',4.19),('8537','2013-09-23','14:40:00',4.13),('8537','2013-09-23','14:45:00',4.08),('8537','2013-09-23','14:50:00',3.49),('8537','2013-09-23','14:55:00',4.01),('8537','2013-09-23','15:00:00',3.94),('8537','2013-09-23','15:05:00',3.75),('8537','2013-09-23','15:10:00',2.61),('8537','2013-09-23','15:15:00',3.75),('8537','2013-09-23','15:20:00',3.6),('8537','2013-09-23','15:25:00',3.52),('8537','2013-09-23','15:30:00',3.47),('8537','2013-09-23','15:35:00',3.41),('8537','2013-09-23','15:40:00',3.36),('8537','2013-09-23','15:45:00',3.2),('8537','2013-09-23','15:50:00',3.15),('8537','2013-09-23','15:55:00',3.05),('8537','2013-09-23','16:00:00',2.89),('8537','2013-09-23','16:05:00',2.9),('8537','2013-09-23','16:10:00',1.86),('8537','2013-09-23','16:15:00',2.72),('8537','2013-09-23','16:20:00',1.82),('8537','2013-09-23','16:25:00',2.33),('8537','2013-09-23','16:30:00',1.56),('8537','2013-09-23','16:35:00',2.14),('8537','2013-09-23','16:40:00',2.12),('8537','2013-09-23','16:45:00',2.05),('8537','2013-09-23','16:50:00',1.92),('8537','2013-09-23','16:55:00',1.8),('8537','2013-09-23','17:00:00',1.73),('8537','2013-09-23','17:05:00',1.59),('8537','2013-09-23','17:10:00',1.52),('8537','2013-09-23','17:15:00',1.42),('8537','2013-09-23','17:20:00',1.32),('8537','2013-09-23','17:25:00',1.19),('8537','2013-09-23','17:30:00',1.11),('8537','2013-09-23','17:35:00',1.02),('8537','2013-09-22','08:05:00',1.02),('8537','2013-09-22','08:10:00',1.16),('8537','2013-09-22','08:20:00',1.09),('8537','2013-09-22','08:25:00',1.44),('8537','2013-09-22','08:30:00',1.53),('8537','2013-09-22','08:35:00',1.63),('8537','2013-09-22','08:40:00',1.73),('8537','2013-09-22','08:45:00',1.85),('8537','2013-09-22','08:50:00',1.96),('8537','2013-09-22','08:55:00',2.09),('8537','2013-09-22','09:00:00',2.19),('8537','2013-09-22','09:05:00',2.3),('8537','2013-09-22','09:10:00',2.42),('8537','2013-09-22','09:15:00',2.54),('8537','2013-09-22','09:20:00',2.63),('8537','2013-09-22','09:25:00',2.73),('8537','2013-09-22','09:30:00',2.84),('8537','2013-09-22','09:35:00',2.93),('8537','2013-09-22','09:40:00',2.99),('8537','2013-09-22','09:45:00',3.09),('8537','2013-09-22','09:50:00',3.17),('8537','2013-09-22','09:55:00',3.27),('8537','2013-09-22','10:00:00',3.37),('8537','2013-09-22','10:05:00',3.48),('8537','2013-09-22','10:10:00',3.55),('8537','2013-09-22','10:15:00',3.62),('8537','2013-09-22','10:20:00',3.71),('8537','2013-09-22','10:25:00',3.77),('8537','2013-09-22','10:30:00',3.85),('8537','2013-09-22','10:35:00',3.93),('8537','2013-09-22','10:40:00',3.91),('8537','2013-09-22','10:45:00',4.02),('8537','2013-09-22','10:50:00',4.09),('8537','2013-09-22','10:55:00',4.13),('8537','2013-09-22','11:00:00',4.17),('8537','2013-09-22','11:05:00',4.21),('8537','2013-09-22','11:10:00',4.26),('8537','2013-09-22','11:15:00',4.31),('8537','2013-09-22','11:20:00',4.34),('8537','2013-09-22','11:25:00',4.37),('8537','2013-09-22','11:30:00',4.42),('8537','2013-09-22','11:35:00',4.5),('8537','2013-09-22','11:40:00',4.56),('8537','2013-09-22','11:45:00',4.61),('8537','2013-09-22','11:50:00',4.62),('8537','2013-09-22','11:55:00',4.66),('8537','2013-09-22','12:00:00',4.71),('8537','2013-09-22','12:05:00',4.73),('8537','2013-09-22','12:10:00',4.77),('8537','2013-09-22','12:15:00',4.78),('8537','2013-09-22','12:20:00',4.79),('8537','2013-09-22','12:25:00',4.8),('8537','2013-09-22','12:30:00',4.8),('8537','2013-09-22','12:35:00',4.8),('8537','2013-09-22','12:40:00',4.85),('8537','2013-09-22','12:45:00',4.82),('8537','2013-09-22','12:50:00',4.86),('8537','2013-09-22','12:55:00',4.91),('8537','2013-09-22','13:00:00',4.86),('8537','2013-09-22','13:05:00',4.83),('8537','2013-09-22','13:10:00',4.18),('8537','2013-09-22','13:15:00',4.88),('8537','2013-09-22','13:20:00',4.79),('8537','2013-09-22','13:25:00',4.77),('8537','2013-09-22','13:30:00',4.72),('8537','2013-09-22','13:35:00',4.71),('8537','2013-09-22','13:40:00',4.68),('8537','2013-09-22','13:45:00',4.69),('8537','2013-09-22','13:50:00',4.7),('8537','2013-09-22','13:55:00',4.1),('8537','2013-09-22','14:00:00',4.59),('8537','2013-09-22','14:05:00',4.62),('8537','2013-09-22','14:10:00',4.65),('8537','2013-09-22','14:15:00',4.42),('8537','2013-09-22','14:20:00',2.73),('8537','2013-09-22','14:25:00',4.57),('8537','2013-09-22','14:30:00',3.19),('8537','2013-09-22','14:35:00',4.43),('8537','2013-09-22','14:40:00',3.32),('8537','2013-09-22','14:45:00',3.72),('8537','2013-09-22','14:50:00',4.24),('8537','2013-09-22','14:55:00',4.18),('8537','2013-09-22','15:00:00',4.2),('8537','2013-09-22','15:05:00',4.21),('8537','2013-09-22','15:10:00',4.01),('8537','2013-09-22','15:15:00',4.23),('8537','2013-09-22','15:20:00',4.41),('8537','2013-09-22','15:25:00',2.2),('8537','2013-09-22','15:30:00',1.2),('8537','2013-09-22','15:35:00',1.2),('8537','2013-09-22','15:40:00',3.05),('8537','2013-09-22','15:45:00',3.56),('8537','2013-09-22','15:50:00',3.38),('8537','2013-09-22','15:55:00',3.34),('8537','2013-09-22','16:00:00',3.56),('8537','2013-09-22','16:05:00',3.36),('8537','2013-09-22','16:10:00',3.73),('8537','2013-09-22','16:15:00',3.49),('8537','2013-09-22','16:20:00',2.35),('8537','2013-09-22','16:25:00',1.78),('8537','2013-09-22','16:30:00',1.4),('8537','2013-09-22','16:35:00',1.14),('8537','2013-09-22','16:40:00',1.22),('8537','2013-09-22','16:45:00',2.05),('8537','2013-09-22','16:50:00',1.93),('8537','2013-09-22','16:55:00',1.51),('8537','2013-09-22','17:00:00',1.11),('8537','2013-09-22','17:05:00',1.54),('8537','2013-09-22','17:10:00',1.27),('8537','2013-09-22','17:15:00',1.07),('8537','2013-09-21','08:10:00',1.04),('8537','2013-09-21','08:15:00',1.16),('8537','2013-09-21','08:20:00',1.27),('8537','2013-09-21','08:25:00',1.38),('8537','2013-09-21','08:30:00',1.5),('8537','2013-09-21','08:35:00',1.61),('8537','2013-09-21','08:40:00',1.73),('8537','2013-09-21','08:45:00',1.83),('8537','2013-09-21','08:50:00',1.96),('8537','2013-09-21','08:55:00',2.07),('8537','2013-09-21','09:00:00',2.18),('8537','2013-09-21','09:05:00',2.27),('8537','2013-09-21','09:10:00',2.36),('8537','2013-09-21','09:15:00',2.46),('8537','2013-09-21','09:20:00',2.56),('8537','2013-09-21','09:25:00',2.66),('8537','2013-09-21','09:30:00',2.74),('8537','2013-09-21','09:35:00',2.84),('8537','2013-09-21','09:40:00',2.91),('8537','2013-09-21','09:45:00',3.02),('8537','2013-09-21','09:50:00',3.11),('8537','2013-09-21','09:55:00',3.18),('8537','2013-09-21','10:00:00',3.28),('8537','2013-09-21','10:05:00',3.38),('8537','2013-09-21','10:10:00',3.43),('8537','2013-09-21','10:15:00',3.49),('8537','2013-09-21','10:20:00',3.54),('8537','2013-09-21','10:25:00',3.65),('8537','2013-09-21','10:30:00',3.72),('8537','2013-09-21','10:35:00',3.77),('8537','2013-09-21','10:40:00',3.84),('8537','2013-09-21','10:45:00',3.91),('8537','2013-09-21','10:50:00',3.96),('8537','2013-09-21','10:55:00',4.02),('8537','2013-09-21','11:00:00',4.08),('8537','2013-09-21','11:05:00',4.12),('8537','2013-09-21','11:10:00',4.15),('8537','2013-09-21','11:15:00',4.21),('8537','2013-09-21','11:20:00',4.26),('8537','2013-09-21','11:25:00',4.32),('8537','2013-09-21','11:30:00',4.4),('8537','2013-09-21','11:35:00',4.35),('8537','2013-09-21','11:40:00',4.44),('8537','2013-09-21','11:45:00',4.49),('8537','2013-09-21','11:50:00',4.5),('8537','2013-09-21','11:55:00',4.44),('8537','2013-09-21','12:00:00',4.53),('8537','2013-09-21','12:05:00',4.59),('8537','2013-09-21','12:10:00',4.59),('8537','2013-09-21','12:15:00',4.59),('8537','2013-09-21','12:20:00',4.55),('8537','2013-09-21','12:25:00',4.16),('8537','2013-09-21','12:30:00',4.71),('8537','2013-09-21','12:35:00',4.61),('8537','2013-09-21','12:40:00',4.33),('8537','2013-09-21','12:45:00',4.56),('8537','2013-09-21','12:50:00',4.65),('8537','2013-09-21','12:55:00',4.71),('8537','2013-09-21','13:00:00',4.67),('8537','2013-09-21','13:05:00',4.54),('8537','2013-09-21','13:10:00',4.67),('8537','2013-09-21','13:15:00',4.77),('8537','2013-09-21','13:20:00',3.9),('8537','2013-09-21','13:25:00',4.48),('8537','2013-09-21','13:30:00',4.44),('8537','2013-09-21','13:35:00',4.53),('8537','2013-09-21','13:40:00',3.99),('8537','2013-09-21','13:45:00',3.96),('8537','2013-09-21','13:50:00',4.16),('8537','2013-09-21','13:55:00',4.14),('8537','2013-09-21','14:00:00',4.22),('8537','2013-09-21','14:05:00',4.43),('8537','2013-09-21','14:10:00',4.24),('8537','2013-09-21','14:15:00',4.43),('8537','2013-09-21','14:20:00',4.31),('8537','2013-09-21','14:25:00',4.3),('8537','2013-09-21','14:30:00',4.24),('8537','2013-09-21','14:35:00',4.18),('8537','2013-09-21','14:40:00',4.13),('8537','2013-09-21','14:45:00',4.06),('8537','2013-09-21','14:50:00',4.02),('8537','2013-09-21','14:55:00',3.99),('8537','2013-09-21','15:00:00',3.92),('8537','2013-09-21','15:05:00',3.81),('8537','2013-09-21','15:10:00',3.69),('8537','2013-09-21','15:15:00',3.64),('8537','2013-09-21','15:20:00',3.64),('8537','2013-09-21','15:25:00',3.56),('8537','2013-09-21','15:30:00',3.51),('8537','2013-09-21','15:35:00',3.45),('8537','2013-09-21','15:40:00',3.13),('8537','2013-09-21','15:45:00',2.35),('8537','2013-09-21','15:50:00',3.05),('8537','2013-09-21','15:55:00',3.12),('8537','2013-09-21','16:00:00',2.41),('8537','2013-09-21','16:05:00',1.57),('8537','2013-09-21','16:10:00',1.91),('8537','2013-09-21','16:15:00',1.6),('8537','2013-09-21','16:20:00',1.85),('8537','2013-09-21','16:30:00',1.33),('8537','2013-09-21','16:35:00',1.61),('8537','2013-09-21','16:40:00',1.14),('8537','2013-09-21','16:55:00',1.14),('8537','2013-09-21','17:15:00',1.18),('8537','2013-09-20','08:35:00',1.74),('8537','2013-09-20','08:40:00',1.9),('8537','2013-09-20','08:45:00',1.72),('8537','2013-09-20','08:50:00',1.21),('8537','2013-09-20','08:55:00',1.2),('8537','2013-09-20','09:00:00',1.33),('8537','2013-09-20','09:05:00',1.43),('8537','2013-09-20','09:10:00',1.32),('8537','2013-09-20','09:15:00',1.67),('8537','2013-09-20','09:20:00',1.78),('8537','2013-09-20','09:25:00',1.71),('8537','2013-09-20','09:30:00',1.48),('8537','2013-09-20','09:35:00',1.53),('8537','2013-09-20','09:40:00',1.51),('8537','2013-09-20','09:45:00',1.5),('8537','2013-09-20','09:50:00',1.56),('8537','2013-09-20','09:55:00',1.73),('8537','2013-09-20','10:00:00',1.92),('8537','2013-09-20','10:05:00',3.26),('8537','2013-09-20','10:10:00',2.66),('8537','2013-09-20','10:15:00',3.38),('8537','2013-09-20','10:20:00',4),('8537','2013-09-20','10:25:00',3.19),('8537','2013-09-20','10:30:00',2.8),('8537','2013-09-20','10:35:00',2.98),('8537','2013-09-20','10:40:00',4.51),('8537','2013-09-20','10:45:00',3.64),('8537','2013-09-20','10:50:00',3.91),('8537','2013-09-20','10:55:00',3.28),('8537','2013-09-20','11:00:00',2.33),('8537','2013-09-20','11:05:00',2.29),('8537','2013-09-20','11:10:00',2.46),('8537','2013-09-20','11:15:00',3.35),('8537','2013-09-20','11:20:00',2.78),('8537','2013-09-20','11:25:00',3.19),('8537','2013-09-20','11:30:00',2.67),('8537','2013-09-20','11:35:00',3.78),('8537','2013-09-20','11:40:00',3.14),('8537','2013-09-20','11:45:00',4.8),('8537','2013-09-20','11:50:00',4.82),('8537','2013-09-20','11:55:00',4.67),('8537','2013-09-20','12:00:00',4.57),('8537','2013-09-20','12:05:00',4.61),('8537','2013-09-20','12:10:00',4.67),('8537','2013-09-20','12:15:00',4.78),('8537','2013-09-20','12:20:00',4.87),('8537','2013-09-20','12:25:00',4.56),('8537','2013-09-20','12:30:00',4.38),('8537','2013-09-20','12:35:00',3.87),('8537','2013-09-20','12:40:00',4.34),('8537','2013-09-20','12:45:00',2.83),('8537','2013-09-20','12:50:00',3.92),('8537','2013-09-20','12:55:00',4.89),('8537','2013-09-20','13:00:00',4.09),('8537','2013-09-20','13:05:00',4.67),('8537','2013-09-20','13:10:00',4.73),('8537','2013-09-20','13:15:00',2.78),('8537','2013-09-20','13:20:00',3.79),('8537','2013-09-20','13:25:00',5.01),('8537','2013-09-20','13:30:00',4.83),('8537','2013-09-20','13:35:00',2.95),('8537','2013-09-20','13:40:00',4.42),('8537','2013-09-20','13:45:00',4.69),('8537','2013-09-20','13:50:00',4.49),('8537','2013-09-20','13:55:00',4.09),('8537','2013-09-20','14:00:00',4.57),('8537','2013-09-20','14:05:00',4.67),('8537','2013-09-20','14:10:00',1.38),('8537','2013-09-20','14:15:00',2.79),('8537','2013-09-20','14:20:00',1.65),('8537','2013-09-20','14:25:00',3.18),('8537','2013-09-20','14:30:00',4.72),('8537','2013-09-20','14:35:00',4.55),('8537','2013-09-20','14:40:00',4.35),('8537','2013-09-20','14:45:00',4.45),('8537','2013-09-20','14:50:00',4.43),('8537','2013-09-20','14:55:00',4.34),('8537','2013-09-20','15:00:00',3.27),('8537','2013-09-20','15:05:00',2.31),('8537','2013-09-20','15:10:00',3.78),('8537','2013-09-20','15:15:00',3.02),('8537','2013-09-20','15:20:00',3.1),('8537','2013-09-20','15:25:00',2.84),('8537','2013-09-20','15:30:00',2.44),('8537','2013-09-20','15:35:00',3.24),('8537','2013-09-20','15:40:00',2.49),('8537','2013-09-20','15:45:00',3.51),('8537','2013-09-20','15:50:00',3.41),('8537','2013-09-20','15:55:00',3.48),('8537','2013-09-20','16:00:00',2.24),('8537','2013-09-20','16:05:00',1.83),('8537','2013-09-20','16:10:00',1.97),('8537','2013-09-20','16:15:00',2.44),('8537','2013-09-20','16:20:00',1.4),('8537','2013-09-20','16:25:00',1.32),('8537','2013-09-20','16:35:00',1.01),('8537','2013-09-20','16:40:00',1.13),('8537','2013-09-20','16:45:00',1.54),('8537','2013-09-20','16:50:00',2.05),('8537','2013-09-20','16:55:00',2.35),('8537','2013-09-20','17:00:00',2.02),('8537','2013-09-20','17:05:00',2.37),('8537','2013-09-20','17:10:00',2.31),('8537','2013-09-20','17:15:00',2.17),('8537','2013-09-20','17:20:00',2.08),('8537','2013-09-20','17:25:00',1.72),('8537','2013-09-20','17:30:00',1.47),('8537','2013-09-20','17:35:00',1.26),('8537','2013-09-20','17:40:00',1.04),('8537','2013-09-20','17:45:00',1.02),('8537','2013-09-19','08:15:00',1.01),('8537','2013-09-19','08:20:00',1.28),('8537','2013-09-19','08:25:00',1.24),('8537','2013-09-19','08:30:00',1.54),('8537','2013-09-19','08:35:00',1.69),('8537','2013-09-19','08:40:00',1.38),('8537','2013-09-19','08:45:00',1.56),('8537','2013-09-19','08:50:00',1.37),('8537','2013-09-19','08:55:00',1.56),('8537','2013-09-19','09:00:00',1.68),('8537','2013-09-19','09:05:00',1.11),('8537','2013-09-19','09:10:00',1.82),('8537','2013-09-19','09:15:00',2.01),('8537','2013-09-19','09:20:00',1.55),('8537','2013-09-19','09:25:00',1.24),('8537','2013-09-19','09:35:00',1.06),('8537','2013-09-19','09:40:00',1.11),('8537','2013-09-19','10:05:00',2.48),('8537','2013-09-19','10:10:00',2.78),('8537','2013-09-19','10:15:00',2.61),('8537','2013-09-19','10:20:00',1.08),('8537','2013-09-19','10:25:00',1.35),('8537','2013-09-19','10:30:00',1.15),('8537','2013-09-19','10:35:00',4.1),('8537','2013-09-19','10:40:00',3.51),('8537','2013-09-19','10:45:00',3.44),('8537','2013-09-19','10:50:00',1.84),('8537','2013-09-19','10:55:00',3.11),('8537','2013-09-19','11:00:00',4.98),('8537','2013-09-19','11:05:00',4.26),('8537','2013-09-19','11:10:00',2.63),('8537','2013-09-19','11:15:00',2.01),('8537','2013-09-19','11:20:00',3.07),('8537','2013-09-19','11:25:00',2.33),('8537','2013-09-19','11:30:00',4.25),('8537','2013-09-19','11:35:00',3.57),('8537','2013-09-19','11:40:00',3.47),('8537','2013-09-19','11:45:00',4.3),('8537','2013-09-19','11:50:00',4.28),('8537','2013-09-19','11:55:00',4.3),('8537','2013-09-19','12:00:00',2.71),('8537','2013-09-19','12:05:00',2.09),('8537','2013-09-19','12:10:00',4.13),('8537','2013-09-19','12:15:00',3.84),('8537','2013-09-19','12:20:00',4.4),('8537','2013-09-19','12:25:00',5.06),('8537','2013-09-19','12:30:00',5.1),('8537','2013-09-19','12:35:00',4.77),('8537','2013-09-19','12:40:00',4.88),('8537','2013-09-19','12:45:00',3.53),('8537','2013-09-19','12:50:00',5.09),('8537','2013-09-19','12:55:00',4.97),('8537','2013-09-19','13:00:00',4.96),('8537','2013-09-19','13:05:00',4.96),('8537','2013-09-19','13:10:00',5.22),('8537','2013-09-19','13:15:00',5.21),('8537','2013-09-19','13:20:00',4.78),('8537','2013-09-19','13:25:00',3.11),('8537','2013-09-19','13:30:00',5),('8537','2013-09-19','13:35:00',4.95),('8537','2013-09-19','13:40:00',5.19),('8537','2013-09-19','13:45:00',5.09),('8537','2013-09-19','13:50:00',4.38),('8537','2013-09-19','13:55:00',2.02),('8537','2013-09-19','14:00:00',1.12),('8537','2013-09-19','14:05:00',3.94),('8537','2013-09-19','14:10:00',4.85),('8537','2013-09-19','14:15:00',4.64),('8537','2013-09-19','14:20:00',4.42),('8537','2013-09-19','14:25:00',4.33),('8537','2013-09-19','14:30:00',4.36),('8537','2013-09-19','14:35:00',4.29),('8537','2013-09-19','14:40:00',4.23),('8537','2013-09-19','14:45:00',4.16),('8537','2013-09-19','14:50:00',4.15),('8537','2013-09-19','14:55:00',4.15),('8537','2013-09-19','15:00:00',4.13),('8537','2013-09-19','15:05:00',3.77),('8537','2013-09-19','15:10:00',2.86),('8537','2013-09-19','15:15:00',3.64),('8537','2013-09-19','15:20:00',3.75),('8537','2013-09-19','15:25:00',3.35),('8537','2013-09-19','15:30:00',3.23),('8537','2013-09-19','15:35:00',2.23),('8537','2013-09-19','15:40:00',3.34),('8537','2013-09-19','15:45:00',3.58),('8537','2013-09-19','15:50:00',3.35),('8537','2013-09-19','15:55:00',3.04),('8537','2013-09-19','16:00:00',3.12),('8537','2013-09-19','16:05:00',3.07),('8537','2013-09-19','16:10:00',2.27),('8537','2013-09-19','16:15:00',2.81),('8537','2013-09-19','16:20:00',2.77),('8537','2013-09-19','16:25:00',2.74),('8537','2013-09-19','16:30:00',2.24),('8537','2013-09-19','16:35:00',2.03),('8537','2013-09-19','16:40:00',1.26),('8537','2013-09-19','16:45:00',1.16),('8537','2013-09-19','16:50:00',1.92),('8537','2013-09-19','16:55:00',2.2),('8537','2013-09-19','17:00:00',1.83),('8537','2013-09-19','17:05:00',1.75),('8537','2013-09-19','17:10:00',1.66),('8537','2013-09-19','17:15:00',1.57),('8537','2013-09-19','17:20:00',1.48),('8537','2013-09-19','17:25:00',1.26),('8537','2013-09-19','17:30:00',1.16),('8537','2013-09-19','17:35:00',1.01),('8537','2014-04-13','09:00:00',1.07),('8537','2014-04-13','09:05:00',1.41),('8537','2014-04-13','09:10:00',1.71),('8537','2014-04-13','09:15:00',1.51),('8537','2014-04-13','09:20:00',1.73),('8537','2014-04-13','09:25:00',2.35),('8537','2014-04-13','09:30:00',2.17),('8537','2014-04-13','09:35:00',1.72),('8537','2014-04-13','09:40:00',2.65),('8537','2014-04-13','09:45:00',2.25),('8537','2014-04-13','09:50:00',1.8),('8537','2014-04-13','09:55:00',1.86),('8537','2014-04-13','10:00:00',3.21),('8537','2014-04-13','10:05:00',4.48),('8537','2014-04-13','10:10:00',2.61),('8537','2014-04-13','10:15:00',2.97),('8537','2014-04-13','10:20:00',3.87),('8537','2014-04-13','10:25:00',2.19),('8537','2014-04-13','10:30:00',4.18),('8537','2014-04-13','10:35:00',4.21),('8537','2014-04-13','10:40:00',4.12),('8537','2014-04-13','10:45:00',4.38),('8537','2014-04-13','10:50:00',4.4),('8537','2014-04-13','10:55:00',4.4),('8537','2014-04-13','11:00:00',4.47),('8537','2014-04-13','11:05:00',4.51),('8537','2014-04-13','11:10:00',4.4),('8537','2014-04-13','11:15:00',3.68),('8537','2014-04-13','11:20:00',5.37),('8537','2014-04-13','11:25:00',3.81),('8537','2014-04-13','11:30:00',2.28),('8537','2014-04-13','11:35:00',3.08),('8537','2014-04-13','11:40:00',5.04),('8537','2014-04-13','11:45:00',4.61),('8537','2014-04-13','11:50:00',4.63),('8537','2014-04-13','11:55:00',3.53),('8537','2014-04-13','12:00:00',2.99),('8537','2014-04-13','12:05:00',2.02),('8537','2014-04-13','12:10:00',1.79),('8537','2014-04-13','12:15:00',1.65),('8537','2014-04-13','12:20:00',1.45),('8537','2014-04-13','12:25:00',1.07),('8537','2014-04-13','13:05:00',1.51),('8537','2014-04-13','13:10:00',2.31),('8537','2014-04-13','13:15:00',2.24),('8537','2014-04-13','13:20:00',2.79),('8537','2014-04-13','13:25:00',3.33),('8537','2014-04-13','13:30:00',4.94),('8537','2014-04-13','13:35:00',4.74),('8537','2014-04-13','13:40:00',4.74),('8537','2014-04-13','13:45:00',2.43),('8537','2014-04-13','13:50:00',3.57),('8537','2014-04-13','13:55:00',3.78),('8537','2014-04-13','14:00:00',4.77),('8537','2014-04-13','14:05:00',4.04),('8537','2014-04-13','14:10:00',4.46),('8537','2014-04-13','14:15:00',4.52),('8537','2014-04-13','14:20:00',2.17),('8537','2014-04-13','14:25:00',1.9),('8537','2014-04-13','14:30:00',1.9),('8537','2014-04-13','14:35:00',1.79),('8537','2014-04-13','14:40:00',1.49),('8537','2014-04-13','14:45:00',2.09),('8537','2014-04-13','14:50:00',3.98),('8537','2014-04-13','14:55:00',2.21),('8537','2014-04-13','15:00:00',3.69),('8537','2014-04-13','15:05:00',4.3),('8537','2014-04-13','15:10:00',4.44),('8537','2014-04-13','15:15:00',3.95),('8537','2014-04-13','15:20:00',3.88),('8537','2014-04-13','15:25:00',4.02),('8537','2014-04-13','15:30:00',3.88),('8537','2014-04-13','15:35:00',2.62),('8537','2014-04-13','15:40:00',1.5),('8537','2014-04-13','15:45:00',1.61),('8537','2014-04-13','15:50:00',2.15),('8537','2014-04-13','15:55:00',2.43),('8537','2014-04-13','16:00:00',4),('8537','2014-04-13','16:05:00',3.19),('8537','2014-04-13','16:10:00',1.62),('8537','2014-04-13','16:15:00',1.61),('8537','2014-04-13','16:20:00',1.67),('8537','2014-04-13','16:25:00',1.65),('8537','2014-04-13','16:30:00',1.45),('8537','2014-04-13','16:35:00',1.99),('8537','2014-04-13','16:40:00',2.68),('8537','2014-04-13','16:45:00',3.43),('8537','2014-04-13','16:50:00',2.17),('8537','2014-04-13','16:55:00',2.58),('8537','2014-04-13','17:00:00',2.56),('8537','2014-04-13','17:05:00',1.76),('8537','2014-04-13','17:10:00',1.1),('8537','2014-04-13','17:15:00',1.17),('8537','2014-04-13','17:20:00',1.45),('8537','2014-04-13','17:25:00',1.31),('8537','2014-04-13','17:50:00',1.08),('8537','2014-04-13','17:55:00',1.14),('8537','2014-04-13','18:00:00',1.08),('8537','2013-09-18','08:10:00',1.06),('8537','2013-09-18','08:15:00',1.08),('8537','2013-09-18','08:25:00',1.27),('8537','2013-09-18','08:30:00',1.06),('8537','2013-09-18','08:35:00',1.04),('8537','2013-09-18','08:45:00',1.94),('8537','2013-09-18','08:55:00',1.3),('8537','2013-09-18','09:00:00',1.2),('8537','2013-09-18','09:05:00',2.09),('8537','2013-09-18','09:10:00',1.06),('8537','2013-09-18','09:15:00',1.56),('8537','2013-09-18','09:20:00',2.84),('8537','2013-09-18','09:25:00',1.91),('8537','2013-09-18','09:30:00',1.55),('8537','2013-09-18','09:35:00',3.14),('8537','2013-09-18','09:40:00',2.32),('8537','2013-09-18','09:45:00',1.49),('8537','2013-09-18','09:50:00',1),('8537','2013-09-18','09:55:00',1.69),('8537','2013-09-18','10:00:00',3.39),('8537','2013-09-18','10:05:00',3.81),('8537','2013-09-18','10:10:00',3.71),('8537','2013-09-18','10:15:00',3.55),('8537','2013-09-18','10:20:00',3.54),('8537','2013-09-18','10:25:00',3.56),('8537','2013-09-18','10:30:00',3.6),('8537','2013-09-18','10:35:00',3.67),('8537','2013-09-18','10:40:00',3.75),('8537','2013-09-18','10:45:00',3.68),('8537','2013-09-18','10:50:00',3.46),('8537','2013-09-18','10:55:00',3.02),('8537','2013-09-18','11:00:00',3.83),('8537','2013-09-18','11:05:00',3.7),('8537','2013-09-18','11:10:00',3.93),('8537','2013-09-18','11:15:00',2.18),('8537','2013-09-18','11:25:00',3.65),('8537','2013-09-18','11:30:00',4.88),('8537','2013-09-18','11:35:00',4.76),('8537','2013-09-18','11:40:00',3.6),('8537','2013-09-18','11:45:00',3.24),('8537','2013-09-18','11:50:00',4.65),('8537','2013-09-18','11:55:00',4.61),('8537','2013-09-18','12:00:00',4.71),('8537','2013-09-18','12:05:00',4.15),('8537','2013-09-18','12:10:00',4.94),('8537','2013-09-18','12:15:00',4.92),('8537','2013-09-18','12:20:00',4.88),('8537','2013-09-18','12:25:00',4.58),('8537','2013-09-18','12:30:00',2.61),('8537','2013-09-18','12:35:00',4.58),('8537','2013-09-18','12:40:00',5.15),('8537','2013-09-18','12:45:00',2.1),('8537','2013-09-18','12:50:00',4.8),('8537','2013-09-18','12:55:00',4.54),('8537','2013-09-18','13:00:00',3.75),('8537','2013-09-18','13:05:00',2.99),('8537','2013-09-18','13:10:00',5.03),('8537','2013-09-18','13:15:00',4.95),('8537','2013-09-18','13:20:00',4.9),('8537','2013-09-18','13:25:00',4.84),('8537','2013-09-18','13:30:00',4.89),('8537','2013-09-18','13:35:00',4.8),('8537','2013-09-18','13:40:00',4.76),('8537','2013-09-18','13:45:00',4.75),('8537','2013-09-18','13:50:00',4.9),('8537','2013-09-18','13:55:00',4.14),('8537','2013-09-18','14:00:00',4.83),('8537','2013-09-18','14:05:00',3.7),('8537','2013-09-18','14:10:00',4.1),('8537','2013-09-18','14:15:00',4.58),('8537','2013-09-18','14:20:00',4.54),('8537','2013-09-18','14:25:00',4.44),('8537','2013-09-18','14:30:00',4.36),('8537','2013-09-18','14:35:00',4.34),('8537','2013-09-18','14:40:00',4.33),('8537','2013-09-18','14:45:00',4.22),('8537','2013-09-18','14:50:00',2.88),('8537','2013-09-18','14:55:00',3.59),('8537','2013-09-18','15:00:00',4.14),('8537','2013-09-18','15:05:00',3.99),('8537','2013-09-18','15:10:00',1.43),('8537','2013-09-18','15:15:00',2.42),('8537','2013-09-18','15:20:00',2.85),('8537','2013-09-18','15:25:00',3.97),('8537','2013-09-18','15:30:00',3.89),('8537','2013-09-18','15:35:00',3.57),('8537','2013-09-18','15:40:00',3.69),('8537','2013-09-18','15:45:00',3.42),('8537','2013-09-18','15:50:00',2.66),('8537','2013-09-18','15:55:00',2.13),('8537','2013-09-18','16:00:00',3.43),('8537','2013-09-18','16:05:00',3.4),('8537','2013-09-18','16:10:00',3.25),('8537','2013-09-18','16:15:00',3.04),('8537','2013-09-18','16:20:00',2.85),('8537','2013-09-18','16:25:00',2.5),('8537','2013-09-18','16:30:00',2.41),('8537','2013-09-18','16:35:00',2.25),('8537','2013-09-18','16:40:00',2.2),('8537','2013-09-18','16:45:00',2.18),('8537','2013-09-18','16:50:00',1.95),('8537','2013-09-18','16:55:00',1.87),('8537','2013-09-18','17:00:00',1.95),('8537','2013-09-18','17:05:00',1.7),('8537','2013-09-18','17:10:00',1.67),('8537','2013-09-18','17:15:00',1.6),('8537','2013-09-18','17:20:00',1.53),('8537','2013-09-18','17:25:00',1.18),('8537','2013-09-18','17:30:00',1.33),('8537','2013-09-18','17:35:00',1.2),('8537','2013-09-18','17:40:00',1.09),('8537','2013-09-17','09:20:00',1.47),('8537','2013-09-17','09:25:00',1.04),('8537','2013-09-17','09:30:00',1.31),('8537','2013-09-17','09:40:00',1.63),('8537','2013-09-17','09:45:00',2.78),('8537','2013-09-17','09:50:00',1.78),('8537','2013-09-17','09:55:00',1.73),('8537','2013-09-17','10:00:00',2.64),('8537','2013-09-17','10:05:00',1.85),('8537','2013-09-17','10:10:00',2.27),('8537','2013-09-17','10:20:00',1.15),('8537','2013-09-17','10:25:00',2.98),('8537','2013-09-17','10:30:00',4.06),('8537','2013-09-17','10:35:00',2.14),('8537','2013-09-17','10:40:00',2.4),('8537','2013-09-17','10:45:00',2.39),('8537','2013-09-17','10:50:00',4.51),('8537','2013-09-17','10:55:00',3.44),('8537','2013-09-17','11:00:00',2.72),('8537','2013-09-17','11:05:00',2.4),('8537','2013-09-17','11:10:00',4.06),('8537','2013-09-17','11:15:00',3.27),('8537','2013-09-17','11:20:00',2.88),('8537','2013-09-17','11:25:00',2.17),('8537','2013-09-17','11:30:00',2.21),('8537','2013-09-17','11:35:00',3.89),('8537','2013-09-17','11:40:00',4.1),('8537','2013-09-17','11:45:00',3.86),('8537','2013-09-17','11:50:00',3.71),('8537','2013-09-17','11:55:00',3.26),('8537','2013-09-17','12:00:00',4.48),('8537','2013-09-17','12:05:00',3.39),('8537','2013-09-17','12:10:00',2.23),('8537','2013-09-17','12:15:00',2.68),('8537','2013-09-17','12:20:00',2.42),('8537','2013-09-17','12:25:00',4.65),('8537','2013-09-17','12:30:00',3.8),('8537','2013-09-17','12:35:00',2.7),('8537','2013-09-17','12:40:00',3.98),('8537','2013-09-17','12:45:00',3.94),('8537','2013-09-17','12:50:00',3.6),('8537','2013-09-17','12:55:00',3.05),('8537','2013-09-17','13:00:00',2.8),('8537','2013-09-17','13:05:00',1.77),('8537','2013-09-17','13:10:00',3.1),('8537','2013-09-17','13:15:00',3.81),('8537','2013-09-17','13:20:00',2.82),('8537','2013-09-17','13:25:00',1.66),('8537','2013-09-17','13:30:00',2.1),('8537','2013-09-17','13:35:00',2.12),('8537','2013-09-17','13:40:00',2.79),('8537','2013-09-17','13:45:00',1.96),('8537','2013-09-17','13:50:00',1.11),('8537','2013-09-17','13:55:00',1.49),('8537','2013-09-17','14:00:00',2.27),('8537','2013-09-17','14:05:00',1.56),('8537','2013-09-17','14:10:00',1.14),('8537','2013-09-17','14:15:00',1.54),('8537','2013-09-17','14:20:00',1.12),('8537','2013-09-17','14:25:00',2.16),('8537','2013-09-17','14:30:00',1.29),('8537','2013-09-17','14:35:00',1.33),('8537','2013-09-17','14:40:00',1.04),('8537','2013-09-17','14:50:00',1.54),('8537','2013-09-17','14:55:00',3.1),('8537','2013-09-17','15:00:00',3.81),('8537','2013-09-17','15:05:00',3.07),('8537','2013-09-17','15:10:00',3.05),('8537','2013-09-17','15:15:00',3.09),('8537','2013-09-17','15:20:00',3.48),('8537','2013-09-17','15:25:00',3.26),('8537','2013-09-17','15:30:00',2.77),('8537','2013-09-17','15:35:00',1.33),('8537','2013-09-17','15:45:00',1.38),('8537','2013-09-17','15:50:00',2.11),('8537','2013-09-17','15:55:00',2.23),('8537','2013-09-17','16:00:00',1.48),('8537','2013-09-17','16:05:00',2.12),('8537','2013-09-17','16:10:00',1.84),('8537','2013-09-17','16:15:00',1.88),('8537','2013-09-17','16:20:00',1.23),('8537','2013-09-17','16:40:00',1.33),('8537','2013-09-17','16:45:00',1.53),('8537','2013-09-17','16:50:00',1.38),('8537','2013-09-17','16:55:00',1.08),('8537','2013-09-17','17:00:00',1.63),('8537','2013-09-17','17:05:00',1.78),('8537','2013-09-17','17:10:00',1.63),('8537','2013-09-17','17:15:00',1.65),('8537','2013-09-17','17:20:00',1.37),('8537','2013-09-17','17:25:00',1.28),('8537','2013-09-17','17:30:00',1.34),('8537','2013-09-16','08:10:00',1.17),('8537','2013-09-16','08:15:00',1.28),('8537','2013-09-16','08:20:00',1.34),('8537','2013-09-16','08:25:00',1.44),('8537','2013-09-16','08:30:00',1.54),('8537','2013-09-16','08:35:00',1.68),('8537','2013-09-16','08:40:00',1.88),('8537','2013-09-16','08:45:00',1.46),('8537','2013-09-16','08:50:00',1.83),('8537','2013-09-16','08:55:00',1.05),('8537','2013-09-16','09:05:00',1.74),('8537','2013-09-16','09:10:00',2.24),('8537','2013-09-16','09:15:00',2.71),('8537','2013-09-16','09:20:00',2.08),('8537','2013-09-16','09:25:00',2.55),('8537','2013-09-16','09:30:00',2.44),('8537','2013-09-16','09:35:00',2.56),('8537','2013-09-16','09:40:00',3.02),('8537','2013-09-16','09:45:00',3.08),('8537','2013-09-16','09:50:00',3.15),('8537','2013-09-16','09:55:00',3.32),('8537','2013-09-16','10:00:00',3.4),('8537','2013-09-16','10:05:00',3.48),('8537','2013-09-16','10:10:00',3.31),('8537','2013-09-16','10:15:00',1.17),('8537','2013-09-16','10:20:00',1.88),('8537','2013-09-16','10:25:00',2.22),('8537','2013-09-16','10:30:00',3.97),('8537','2013-09-16','10:35:00',4.21),('8537','2013-09-16','10:40:00',4.45),('8537','2013-09-16','10:45:00',4.68),('8537','2013-09-16','10:50:00',3.25),('8537','2013-09-16','11:05:00',3.01),('8537','2013-09-16','11:10:00',1.18),('8537','2013-09-16','11:15:00',1.01),('8537','2013-09-16','11:20:00',2.57),('8537','2013-09-16','11:25:00',2.66),('8537','2013-09-16','11:30:00',4.75),('8537','2013-09-16','11:35:00',4.64),('8537','2013-09-16','11:40:00',4.69),('8537','2013-09-16','11:45:00',4.13),('8537','2013-09-16','11:50:00',3.16),('8537','2013-09-16','11:55:00',4.83),('8537','2013-09-16','12:00:00',4.98),('8537','2013-09-16','12:05:00',5.06),('8537','2013-09-16','12:10:00',5.13),('8537','2013-09-16','12:15:00',4.3),('8537','2013-09-16','12:20:00',4.84),('8537','2013-09-16','12:25:00',4.81),('8537','2013-09-16','12:30:00',4.79),('8537','2013-09-16','12:35:00',4.86),('8537','2013-09-16','12:40:00',4.99),('8537','2013-09-16','12:45:00',5.08),('8537','2013-09-16','12:50:00',2.91),('8537','2013-09-16','12:55:00',2.91),('8537','2013-09-16','13:00:00',3.8),('8537','2013-09-16','13:05:00',4.41),('8537','2013-09-16','13:10:00',4.66),('8537','2013-09-16','13:15:00',4.86),('8537','2013-09-16','13:20:00',4.71),('8537','2013-09-16','13:25:00',4.84),('8537','2013-09-16','13:30:00',4.78),('8537','2013-09-16','13:35:00',4.77),('8537','2013-09-16','13:40:00',4.76),('8537','2013-09-16','13:45:00',4.73),('8537','2013-09-16','13:50:00',4.76),('8537','2013-09-16','13:55:00',4.87),('8537','2013-09-16','14:00:00',4.39),('8537','2013-09-16','14:05:00',3.77),('8537','2013-09-16','14:10:00',4.64),('8537','2013-09-16','14:15:00',4.54),('8537','2013-09-16','14:20:00',4.44),('8537','2013-09-16','14:25:00',4.4),('8537','2013-09-16','14:30:00',4.38),('8537','2013-09-16','14:35:00',4.3),('8537','2013-09-16','14:40:00',4.22),('8537','2013-09-16','14:45:00',4.21),('8537','2013-09-16','14:50:00',4.06),('8537','2013-09-16','14:55:00',4.15),('8537','2013-09-16','15:00:00',4.11),('8537','2013-09-16','15:05:00',4.08),('8537','2013-09-16','15:10:00',3.84),('8537','2013-09-16','15:15:00',3.37),('8537','2013-09-16','15:20:00',3.2),('8537','2013-09-16','15:25:00',3.75),('8537','2013-09-16','15:30:00',3.7),('8537','2013-09-16','15:35:00',3.63),('8537','2013-09-16','15:40:00',3.58),('8537','2013-09-16','15:45:00',3.51),('8537','2013-09-16','15:50:00',3.38),('8537','2013-09-16','15:55:00',3.3),('8537','2013-09-16','16:00:00',3.28),('8537','2013-09-16','16:05:00',2.36),('8537','2013-09-16','16:10:00',3.21),('8537','2013-09-16','16:15:00',3.01),('8537','2013-09-16','16:20:00',2.9),('8537','2013-09-16','16:25:00',2.78),('8537','2013-09-16','16:30:00',2.71),('8537','2013-09-16','16:35:00',2.58),('8537','2013-09-16','16:40:00',2.51),('8537','2013-09-16','16:45:00',2.34),('8537','2013-09-16','16:50:00',2.27),('8537','2013-09-16','16:55:00',2.17),('8537','2013-09-16','17:00:00',2.06),('8537','2013-09-16','17:05:00',1.93),('8537','2013-09-16','17:10:00',1.81),('8537','2013-09-16','17:15:00',1.69),('8537','2013-09-16','17:20:00',1.58),('8537','2013-09-16','17:25:00',1.48),('8537','2013-09-16','17:30:00',1.37),('8537','2013-09-16','17:35:00',1.15),('8537','2013-09-16','17:40:00',1.03),('8537','2013-09-16','17:45:00',1.03),('8537','2013-09-15','08:05:00',1.06),('8537','2013-09-15','08:10:00',1.17),('8537','2013-09-15','08:15:00',1.29),('8537','2013-09-15','08:20:00',1.4),('8537','2013-09-15','08:25:00',1.52),('8537','2013-09-15','08:30:00',1.63),('8537','2013-09-15','08:35:00',1.76),('8537','2013-09-15','08:40:00',1.9),('8537','2013-09-15','08:45:00',2.03),('8537','2013-09-15','08:50:00',2.06),('8537','2013-09-15','08:55:00',1.99),('8537','2013-09-15','09:00:00',2.17),('8537','2013-09-15','09:05:00',2.23),('8537','2013-09-15','09:10:00',2.42),('8537','2013-09-15','09:15:00',2.64),('8537','2013-09-15','09:20:00',2.58),('8537','2013-09-15','09:25:00',2.71),('8537','2013-09-15','09:30:00',2.75),('8537','2013-09-15','09:35:00',2.94),('8537','2013-09-15','09:40:00',3),('8537','2013-09-15','09:45:00',3.04),('8537','2013-09-15','09:50:00',3.16),('8537','2013-09-15','09:55:00',3.21),('8537','2013-09-15','10:00:00',3.34),('8537','2013-09-15','10:05:00',3.41),('8537','2013-09-15','10:10:00',3.43),('8537','2013-09-15','10:15:00',3.38),('8537','2013-09-15','10:20:00',3.49),('8537','2013-09-15','10:25:00',3.6),('8537','2013-09-15','10:30:00',3.43),('8537','2013-09-15','10:35:00',2.84),('8537','2013-09-15','10:40:00',1.98),('8537','2013-09-15','10:45:00',1.64),('8537','2013-09-15','10:50:00',1.2),('8537','2013-09-15','10:55:00',1.74),('8537','2013-09-15','11:00:00',3.62),('8537','2013-09-15','11:05:00',4.54),('8537','2013-09-15','11:10:00',3.35),('8537','2013-09-15','11:15:00',1.6),('8537','2013-09-15','11:20:00',1.25),('8537','2013-09-15','11:25:00',1.23),('8537','2013-09-15','11:30:00',1.43),('8537','2013-09-15','11:35:00',3.66),('8537','2013-09-15','11:40:00',1.87),('8537','2013-09-15','11:45:00',1.5),('8537','2013-09-15','11:50:00',3.08),('8537','2013-09-15','11:55:00',1.62),('8537','2013-09-15','12:00:00',1.48),('8537','2013-09-15','12:05:00',1.41),('8537','2013-09-15','12:10:00',1.32),('8537','2013-09-15','12:15:00',1.34),('8537','2013-09-15','12:20:00',1.61),('8537','2013-09-15','12:25:00',1.9),('8537','2013-09-15','12:30:00',1.93),('8537','2013-09-15','12:35:00',1.87),('8537','2013-09-15','12:40:00',1.83),('8537','2013-09-15','12:45:00',1.43),('8537','2013-09-15','12:50:00',1.53),('8537','2013-09-15','12:55:00',1.59),('8537','2013-09-15','13:00:00',1.48),('8537','2013-09-15','13:05:00',1.33),('8537','2013-09-15','13:25:00',1.08),('8537','2013-09-15','13:30:00',1.17),('8537','2013-09-15','13:35:00',1.44),('8537','2013-09-15','13:40:00',1.64),('8537','2013-09-15','13:45:00',2.35),('8537','2013-09-15','13:50:00',2.33),('8537','2013-09-15','13:55:00',1.51),('8537','2013-09-15','14:00:00',2.14),('8537','2013-09-15','14:05:00',1.98),('8537','2013-09-15','14:10:00',1.74),('8537','2013-09-15','14:15:00',1.58),('8537','2013-09-15','14:20:00',1.5),('8537','2013-09-15','14:25:00',1.49),('8537','2013-09-15','14:30:00',1.47),('8537','2013-09-15','14:35:00',1.26),('8537','2013-09-15','14:40:00',1.28),('8537','2013-09-15','14:45:00',1.11),('8537','2013-09-15','14:50:00',1.17),('8537','2013-09-15','14:55:00',1.24),('8537','2013-09-15','15:00:00',1.26),('8537','2013-09-15','15:05:00',1.35),('8537','2013-09-15','15:10:00',1.54),('8537','2013-09-15','15:15:00',3.02),('8537','2013-09-15','15:20:00',2.46),('8537','2013-09-15','15:25:00',1.77),('8537','2013-09-15','15:30:00',1.32),('8537','2013-09-15','15:35:00',1.26),('8537','2013-09-15','15:40:00',1.17),('8537','2013-09-15','15:45:00',1.13),('8537','2013-09-15','15:50:00',1.13),('8537','2013-09-15','15:55:00',1.13),('8537','2013-09-15','16:05:00',1.11),('8537','2013-09-14','08:05:00',1.01),('8537','2013-09-14','08:10:00',1.12),('8537','2013-09-14','08:15:00',1.23),('8537','2013-09-14','08:20:00',1.34),('8537','2013-09-14','08:25:00',1.45),('8537','2013-09-14','08:30:00',1.58),('8537','2013-09-14','08:35:00',1.7),('8537','2013-09-14','08:40:00',1.81),('8537','2013-09-14','08:45:00',1.92),('8537','2013-09-14','08:50:00',2.02),('8537','2013-09-14','08:55:00',2.14),('8537','2013-09-14','09:00:00',2.25),('8537','2013-09-14','09:05:00',2.35),('8537','2013-09-14','09:10:00',2.46),('8537','2013-09-14','09:15:00',2.56),('8537','2013-09-14','09:20:00',2.65),('8537','2013-09-14','09:25:00',2.72),('8537','2013-09-14','09:30:00',2.84),('8537','2013-09-14','09:35:00',2.91),('8537','2013-09-14','09:40:00',3),('8537','2013-09-14','09:45:00',3.1),('8537','2013-09-14','09:50:00',3.1),('8537','2013-09-14','09:55:00',3.2),('8537','2013-09-14','10:00:00',2.69),('8537','2013-09-14','10:05:00',3.19),('8537','2013-09-14','10:10:00',3.16),('8537','2013-09-14','10:15:00',3.27),('8537','2013-09-14','10:20:00',3.5),('8537','2013-09-14','10:25:00',3.67),('8537','2013-09-14','10:30:00',3.65),('8537','2013-09-14','10:35:00',3.78),('8537','2013-09-14','10:40:00',3.92),('8537','2013-09-14','10:45:00',4.26),('8537','2013-09-14','10:50:00',4.54),('8537','2013-09-14','10:55:00',4.57),('8537','2013-09-14','11:00:00',4.4),('8537','2013-09-14','11:05:00',2.01),('8537','2013-09-14','11:10:00',1.12),('8537','2013-09-14','11:15:00',1.12),('8537','2013-09-14','11:25:00',2.74),('8537','2013-09-14','11:30:00',4.55),('8537','2013-09-14','11:35:00',4.45),('8537','2013-09-14','11:40:00',3.98),('8537','2013-09-14','11:45:00',4.47),('8537','2013-09-14','11:50:00',3.96),('8537','2013-09-14','11:55:00',2.32),('8537','2013-09-14','12:00:00',2.1),('8537','2013-09-14','12:05:00',2.91),('8537','2013-09-14','12:10:00',1.75),('8537','2013-09-14','12:15:00',2.66),('8537','2013-09-14','12:20:00',1.18),('8537','2013-09-14','12:35:00',2.26),('8537','2013-09-14','12:40:00',3.99),('8537','2013-09-14','12:45:00',1.21),('8537','2013-09-14','12:50:00',1.05),('8537','2013-09-14','12:55:00',1.11),('8537','2013-09-14','13:00:00',1.11),('8537','2013-09-14','13:10:00',1.42),('8537','2013-09-14','13:15:00',4.4),('8537','2013-09-14','13:20:00',5.04),('8537','2013-09-14','13:25:00',4.77),('8537','2013-09-14','13:30:00',5.12),('8537','2013-09-14','13:35:00',2.72),('8537','2013-09-14','13:40:00',2.54),('8537','2013-09-14','13:45:00',3.37),('8537','2013-09-14','13:50:00',3.16),('8537','2013-09-14','13:55:00',5.49),('8537','2013-09-14','14:00:00',5.05),('8537','2013-09-14','14:05:00',4.7),('8537','2013-09-14','14:10:00',4.61),('8537','2013-09-14','14:15:00',4.58),('8537','2013-09-14','14:20:00',3.9),('8537','2013-09-14','14:25:00',4.27),('8537','2013-09-14','14:30:00',4.41),('8537','2013-09-14','14:35:00',4.37),('8537','2013-09-14','14:40:00',4.31),('8537','2013-09-14','14:45:00',4.16),('8537','2013-09-14','14:50:00',4.23),('8537','2013-09-14','14:55:00',4.18),('8537','2013-09-14','15:00:00',4.1),('8537','2013-09-14','15:05:00',4.02),('8537','2013-09-14','15:10:00',3.91),('8537','2013-09-14','15:15:00',3.83),('8537','2013-09-14','15:20:00',3.82),('8537','2013-09-14','15:25:00',3.79),('8537','2013-09-14','15:30:00',3.56),('8537','2013-09-14','15:35:00',3.65),('8537','2013-09-14','15:40:00',3.58),('8537','2013-09-14','15:45:00',3.49),('8537','2013-09-14','15:50:00',3.37),('8537','2013-09-14','15:55:00',3.29),('8537','2013-09-14','16:00:00',3.2),('8537','2013-09-14','16:05:00',3.12),('8537','2013-09-14','16:10:00',3.05),('8537','2013-09-14','16:15:00',2.96),('8537','2013-09-14','16:20:00',2.89),('8537','2013-09-14','16:25:00',2.66),('8537','2013-09-14','16:30:00',2.55),('8537','2013-09-14','16:35:00',2.6),('8537','2013-09-14','16:40:00',2.5),('8537','2013-09-14','16:45:00',2.33),('8537','2013-09-14','16:50:00',2.24),('8537','2013-09-14','16:55:00',2.17),('8537','2013-09-14','17:00:00',1.86),('8537','2013-09-14','17:05:00',1.96),('8537','2013-09-14','17:10:00',1.85),('8537','2013-09-14','17:15:00',1.73),('8537','2013-09-14','17:20:00',1.62),('8537','2013-09-14','17:25:00',1.5),('8537','2013-09-14','17:30:00',1.38),('8537','2013-09-14','17:35:00',1.17),('8537','2013-09-14','17:40:00',1.11),('8537','2013-09-14','17:45:00',1.1),('8537','2013-09-14','17:50:00',1),('8537','2013-09-13','08:30:00',1.08),('8537','2013-09-13','08:50:00',1.12),('8537','2013-09-13','08:55:00',1.25),('8537','2013-09-13','09:00:00',1.19),('8537','2013-09-13','09:05:00',1.14),('8537','2013-09-13','09:10:00',1.12),('8537','2013-09-13','09:15:00',1.17),('8537','2013-09-13','09:20:00',1.2),('8537','2013-09-13','09:25:00',1.32),('8537','2013-09-13','09:30:00',1.43),('8537','2013-09-13','09:35:00',1.56),('8537','2013-09-13','09:40:00',1.7),('8537','2013-09-13','09:45:00',1.61),('8537','2013-09-13','09:50:00',1.84),('8537','2013-09-13','09:55:00',3.29),('8537','2013-09-13','10:00:00',3.4),('8537','2013-09-13','10:05:00',1.52),('8537','2013-09-13','10:10:00',2.12),('8537','2013-09-13','10:15:00',4.27),('8537','2013-09-13','10:20:00',4.13),('8537','2013-09-13','10:25:00',2.35),('8537','2013-09-13','10:30:00',2.7),('8537','2013-09-13','10:35:00',4.06),('8537','2013-09-13','10:40:00',4.01),('8537','2013-09-13','10:45:00',3.99),('8537','2013-09-13','10:50:00',4.07),('8537','2013-09-13','10:55:00',4.12),('8537','2013-09-13','11:00:00',4.14),('8537','2013-09-13','11:05:00',4.22),('8537','2013-09-13','11:10:00',4.24),('8537','2013-09-13','11:15:00',4.29),('8537','2013-09-13','11:20:00',4.36),('8537','2013-09-13','11:25:00',4.35),('8537','2013-09-13','11:30:00',4.34),('8537','2013-09-13','11:35:00',4.47),('8537','2013-09-13','11:40:00',4.48),('8537','2013-09-13','11:45:00',4.48),('8537','2013-09-13','11:50:00',4.5),('8537','2013-09-13','11:55:00',4.56),('8537','2013-09-13','12:00:00',4.6),('8537','2013-09-13','12:05:00',4.68),('8537','2013-09-13','12:10:00',4.68),('8537','2013-09-13','12:15:00',4.69),('8537','2013-09-13','12:20:00',4.7),('8537','2013-09-13','12:25:00',4.79),('8537','2013-09-13','12:30:00',4.95),('8537','2013-09-13','12:35:00',4.85),('8537','2013-09-13','12:40:00',4.86),('8537','2013-09-13','12:45:00',4.85),('8537','2013-09-13','12:50:00',4.94),('8537','2013-09-13','12:55:00',4.87),('8537','2013-09-13','13:00:00',4.79),('8537','2013-09-13','13:05:00',4.76),('8537','2013-09-13','13:10:00',4.73),('8537','2013-09-13','13:15:00',4.74),('8537','2013-09-13','13:20:00',4.73),('8537','2013-09-13','13:25:00',4.74),('8537','2013-09-13','13:30:00',4.69),('8537','2013-09-13','13:35:00',4.65),('8537','2013-09-13','13:40:00',4.63),('8537','2013-09-13','13:45:00',4.6),('8537','2013-09-13','13:50:00',4.56),('8537','2013-09-13','13:55:00',4.55),('8537','2013-09-13','14:00:00',4.57),('8537','2013-09-13','14:05:00',4.53),('8537','2013-09-13','14:10:00',4.47),('8537','2013-09-13','14:15:00',4.46),('8537','2013-09-13','14:20:00',4.45),('8537','2013-09-13','14:25:00',4.2),('8537','2013-09-13','14:30:00',3.81),('8537','2013-09-13','14:35:00',4.29),('8537','2013-09-13','14:40:00',4.19),('8537','2013-09-13','14:45:00',4.18),('8537','2013-09-13','14:50:00',4.26),('8537','2013-09-13','14:55:00',4.15),('8537','2013-09-13','15:00:00',4.03),('8537','2013-09-13','15:05:00',4.04),('8537','2013-09-13','15:10:00',4),('8537','2013-09-13','15:15:00',3.72),('8537','2013-09-13','15:20:00',3.82),('8537','2013-09-13','15:25:00',3.79),('8537','2013-09-13','15:30:00',3.73),('8537','2013-09-13','15:35:00',3.68),('8537','2013-09-13','15:40:00',3.62),('8537','2013-09-13','15:45:00',3.56),('8537','2013-09-13','15:50:00',3.41),('8537','2013-09-13','15:55:00',3.35),('8537','2013-09-13','16:00:00',3.26),('8537','2013-09-13','16:05:00',3.19),('8537','2013-09-13','16:10:00',3.11),('8537','2013-09-13','16:15:00',3.03),('8537','2013-09-13','16:20:00',2.93),('8537','2013-09-13','16:25:00',2.79),('8537','2013-09-13','16:30:00',2.33),('8537','2013-09-13','16:35:00',2.62),('8537','2013-09-13','16:40:00',2.54),('8537','2013-09-13','16:45:00',2.36),('8537','2013-09-13','16:50:00',2.26),('8537','2013-09-13','16:55:00',2.18),('8537','2013-09-13','17:00:00',2.07),('8537','2013-09-13','17:05:00',1.96),('8537','2013-09-13','17:10:00',1.84),('8537','2013-09-13','17:15:00',1.7),('8537','2013-09-13','17:20:00',1.61),('8537','2013-09-13','17:25:00',1.51),('8537','2013-09-13','17:30:00',1.4),('8537','2013-09-13','17:35:00',1.27),('8537','2013-09-13','17:40:00',1.19),('8537','2013-09-13','17:45:00',1.1),('8537','2013-09-12','08:00:00',1.13),('8537','2013-09-12','08:15:00',1.46),('8537','2013-09-12','08:20:00',1.49),('8537','2013-09-12','08:25:00',1.74),('8537','2013-09-12','08:30:00',1.95),('8537','2013-09-12','08:35:00',1.89),('8537','2013-09-12','08:40:00',1.38),('8537','2013-09-12','08:55:00',2),('8537','2013-09-12','09:00:00',2.2),('8537','2013-09-12','09:05:00',2.15),('8537','2013-09-12','09:10:00',1.66),('8537','2013-09-12','09:15:00',2.45),('8537','2013-09-12','09:20:00',2.47),('8537','2013-09-12','09:25:00',2.71),('8537','2013-09-12','09:30:00',2.91),('8537','2013-09-12','09:35:00',2.65),('8537','2013-09-12','09:40:00',2.18),('8537','2013-09-12','09:45:00',2.67),('8537','2013-09-12','09:50:00',2.65),('8537','2013-09-12','09:55:00',1.79),('8537','2013-09-12','10:00:00',1.27),('8537','2013-09-12','10:05:00',1.62),('8537','2013-09-12','10:10:00',2.03),('8537','2013-09-12','10:15:00',2),('8537','2013-09-12','10:20:00',1.56),('8537','2013-09-12','10:25:00',1.09),('8537','2013-09-12','10:30:00',1.86),('8537','2013-09-12','10:35:00',2.06),('8537','2013-09-12','10:55:00',2.21),('8537','2013-09-12','11:00:00',2.7),('8537','2013-09-12','11:05:00',4),('8537','2013-09-12','11:10:00',2.87),('8537','2013-09-12','11:15:00',3.08),('8537','2013-09-12','11:20:00',1.46),('8537','2013-09-12','11:40:00',1.27),('8537','2013-09-12','11:45:00',2.82),('8537','2013-09-12','11:50:00',1.88),('8537','2013-09-12','11:55:00',3.48),('8537','2013-09-12','12:00:00',3.89),('8537','2013-09-12','12:05:00',4.54),('8537','2013-09-12','12:10:00',4.01),('8537','2013-09-12','12:15:00',3.7),('8537','2013-09-12','12:20:00',1.66),('8537','2013-09-12','12:25:00',2.29),('8537','2013-09-12','12:30:00',1.81),('8537','2013-09-12','12:35:00',3.45),('8537','2013-09-12','12:40:00',4.59),('8537','2013-09-12','12:45:00',1.33),('8537','2013-09-12','12:50:00',2.71),('8537','2013-09-12','12:55:00',2.29),('8537','2013-09-12','13:00:00',5.05),('8537','2013-09-12','13:05:00',2.77),('8537','2013-09-12','13:10:00',3.97),('8537','2013-09-12','13:15:00',4.64),('8537','2013-09-12','13:20:00',5.45),('8537','2013-09-12','13:25:00',5.54),('8537','2013-09-12','13:30:00',4.28),('8537','2013-09-12','13:35:00',3.6),('8537','2013-09-12','13:40:00',3.65),('8537','2013-09-12','13:45:00',4.08),('8537','2013-09-12','13:50:00',4.9),('8537','2013-09-12','13:55:00',4.81),('8537','2013-09-12','14:00:00',4.88),('8537','2013-09-12','14:05:00',4.55),('8537','2013-09-12','14:10:00',3.85),('8537','2013-09-12','14:15:00',4.79),('8537','2013-09-12','14:20:00',4.54),('8537','2013-09-12','14:25:00',4.66),('8537','2013-09-12','14:30:00',4.33),('8537','2013-09-12','14:35:00',3.32),('8537','2013-09-12','14:40:00',3.45),('8537','2013-09-12','14:45:00',4.48),('8537','2013-09-12','14:50:00',4.35),('8537','2013-09-12','14:55:00',4.27),('8537','2013-09-12','15:00:00',4.06),('8537','2013-09-12','15:05:00',3.53),('8537','2013-09-12','15:10:00',3),('8537','2013-09-12','15:15:00',4.01),('8537','2013-09-12','15:20:00',3.94),('8537','2013-09-12','15:25:00',3.5),('8537','2013-09-12','15:30:00',3.83),('8537','2013-09-12','15:35:00',3.72),('8537','2013-09-12','15:40:00',3.66),('8537','2013-09-12','15:45:00',3.66),('8537','2013-09-12','15:50:00',3.53),('8537','2013-09-12','15:55:00',3.4),('8537','2013-09-12','16:00:00',3.43),('8537','2013-09-12','16:05:00',2.48),('8537','2013-09-12','16:10:00',2.94),('8537','2013-09-12','16:15:00',2.32),('8537','2013-09-12','16:20:00',2.07),('8537','2013-09-12','16:25:00',2.12),('8537','2013-09-12','16:30:00',1.88),('8537','2013-09-12','16:35:00',1.19),('8537','2013-09-12','16:40:00',2.12),('8537','2013-09-12','16:45:00',2.77),('8537','2013-09-12','16:50:00',1.06),('8537','2013-09-12','16:55:00',1.4),('8537','2013-09-12','17:00:00',1.42),('8537','2013-09-12','17:05:00',1.57),('8537','2013-09-12','17:10:00',1.3),('8537','2013-09-12','17:15:00',1.93),('8537','2013-09-12','17:20:00',1.21),('8537','2013-09-12','17:30:00',1.28),('8537','2013-09-12','17:35:00',1.48),('8537','2013-09-12','17:40:00',1.31),('8537','2013-09-12','17:45:00',1.26),('8537','2013-09-12','17:50:00',1.07),('8537','2013-09-11','08:05:00',1.33),('8537','2013-09-11','08:10:00',1.26),('8537','2013-09-11','08:15:00',1.22),('8537','2013-09-11','08:30:00',1.01),('8537','2013-09-11','08:50:00',1.06),('8537','2013-09-11','08:55:00',1.16),('8537','2013-09-11','09:00:00',2.46),('8537','2013-09-11','09:05:00',2.35),('8537','2013-09-11','09:10:00',2.44),('8537','2013-09-11','09:15:00',2.68),('8537','2013-09-11','09:20:00',2.52),('8537','2013-09-11','09:25:00',2.46),('8537','2013-09-11','09:30:00',1.65),('8537','2013-09-11','09:35:00',2.38),('8537','2013-09-11','09:40:00',1.79),('8537','2013-09-11','09:50:00',1.02),('8537','2013-09-11','10:00:00',1.22),('8537','2013-09-11','10:05:00',2.91),('8537','2013-09-11','10:15:00',2.17),('8537','2013-09-11','10:20:00',3.58),('8537','2013-09-11','10:25:00',2.69),('8537','2013-09-11','10:30:00',4.05),('8537','2013-09-11','10:35:00',3.2),('8537','2013-09-11','10:40:00',3.86),('8537','2013-09-11','10:45:00',3.02),('8537','2013-09-11','10:50:00',3.67),('8537','2013-09-11','10:55:00',1.91),('8537','2013-09-11','11:00:00',1.67),('8537','2013-09-11','11:05:00',3.63),('8537','2013-09-11','11:10:00',4.26),('8537','2013-09-11','11:15:00',3.39),('8537','2013-09-11','11:20:00',4.71),('8537','2013-09-11','11:25:00',3.35),('8537','2013-09-11','11:35:00',3.48),('8537','2013-09-11','11:40:00',3.6),('8537','2013-09-11','11:45:00',4.75),('8537','2013-09-11','11:50:00',4.79),('8537','2013-09-11','11:55:00',3.8),('8537','2013-09-11','12:00:00',3.58),('8537','2013-09-11','12:05:00',4.29),('8537','2013-09-11','12:10:00',2.52),('8537','2013-09-11','12:15:00',2.54),('8537','2013-09-11','12:20:00',3.38),('8537','2013-09-11','12:25:00',2.46),('8537','2013-09-11','12:30:00',4.89),('8537','2013-09-11','12:35:00',3.15),('8537','2013-09-11','12:40:00',1.42),('8537','2013-09-11','12:45:00',3.66),('8537','2013-09-11','12:50:00',4.47),('8537','2013-09-11','12:55:00',1.21),('8537','2013-09-11','13:00:00',4.44),('8537','2013-09-11','13:05:00',3.74),('8537','2013-09-11','13:10:00',4.91),('8537','2013-09-11','13:15:00',5.13),('8537','2013-09-11','13:20:00',5.2),('8537','2013-09-11','13:25:00',4.37),('8537','2013-09-11','13:30:00',4.5),('8537','2013-09-11','13:35:00',2.4),('8537','2013-09-11','13:40:00',4.07),('8537','2013-09-11','13:45:00',3.14),('8537','2013-09-11','13:50:00',4.53),('8537','2013-09-11','13:55:00',2.95),('8537','2013-09-11','14:00:00',3.71),('8537','2013-09-11','14:05:00',4.89),('8537','2013-09-11','14:10:00',2.82),('8537','2013-09-11','14:15:00',4.39),('8537','2013-09-11','14:20:00',3.51),('8537','2013-09-11','14:25:00',4.47),('8537','2013-09-11','14:30:00',3.47),('8537','2013-09-11','14:35:00',3.72),('8537','2013-09-11','14:40:00',2.19),('8537','2013-09-11','14:45:00',3.95),('8537','2013-09-11','14:50:00',4.45),('8537','2013-09-11','14:55:00',2.88),('8537','2013-09-11','15:00:00',3.2),('8537','2013-09-11','15:05:00',4.15),('8537','2013-09-11','15:10:00',3.1),('8537','2013-09-11','15:15:00',4),('8537','2013-09-11','15:20:00',4.34),('8537','2013-09-11','15:25:00',2.58),('8537','2013-09-11','15:30:00',2.03),('8537','2013-09-11','15:35:00',1.14),('8537','2013-09-11','15:40:00',1.38),('8537','2013-09-11','15:45:00',3.03),('8537','2013-09-11','15:50:00',3.71),('8537','2013-09-11','15:55:00',3.19),('8537','2013-09-11','16:00:00',3.22),('8537','2013-09-11','16:05:00',2.99),('8537','2013-09-11','16:10:00',3.31),('8537','2013-09-11','16:15:00',3.21),('8537','2013-09-11','16:20:00',3.01),('8537','2013-09-11','16:25:00',2.06),('8537','2013-09-11','16:30:00',2.16),('8537','2013-09-11','16:35:00',1.59),('8537','2013-09-11','16:40:00',1.33),('8537','2013-09-11','16:45:00',2.67),('8537','2013-09-11','16:50:00',2.09),('8537','2013-09-11','16:55:00',1.69),('8537','2013-09-11','17:00:00',1.65),('8537','2013-09-11','17:05:00',2.07),('8537','2013-09-11','17:10:00',1.94),('8537','2013-09-11','17:15:00',1.79),('8537','2013-09-11','17:20:00',1.66),('8537','2013-09-11','17:25:00',1.56),('8537','2013-09-11','17:30:00',1.45),('8537','2013-09-11','17:35:00',1.36),('8537','2013-09-11','17:40:00',1.26),('8537','2013-09-11','17:45:00',1.01),('8537','2013-09-11','17:50:00',1.03),('8537','2013-09-10','08:15:00',1.04),('8537','2013-09-10','08:55:00',1.99),('8537','2013-09-10','09:00:00',2.17),('8537','2013-09-10','09:05:00',2.35),('8537','2013-09-10','09:10:00',2.8),('8537','2013-09-10','09:15:00',2.34),('8537','2013-09-10','09:20:00',1.86),('8537','2013-09-10','09:25:00',1.85),('8537','2013-09-10','09:30:00',3.05),('8537','2013-09-10','09:35:00',3.44),('8537','2013-09-10','09:40:00',1.92),('8537','2013-09-10','09:45:00',1.63),('8537','2013-09-10','09:50:00',1.47),('8537','2013-09-10','09:55:00',1.33),('8537','2013-09-10','10:20:00',1.07),('8537','2013-09-10','10:25:00',1.17),('8537','2013-09-10','10:30:00',1.19),('8537','2013-09-10','10:35:00',1.36),('8537','2013-09-10','10:40:00',1.77),('8537','2013-09-10','10:45:00',2.34),('8537','2013-09-10','10:50:00',1.5),('8537','2013-09-10','10:55:00',1.54),('8537','2013-09-10','11:00:00',1.83),('8537','2013-09-10','11:05:00',1.55),('8537','2013-09-10','11:10:00',1.65),('8537','2013-09-10','11:15:00',1.41),('8537','2013-09-10','11:20:00',1.54),('8537','2013-09-10','11:25:00',1.76),('8537','2013-09-10','11:30:00',1.3),('8537','2013-09-10','11:45:00',1.5),('8537','2013-09-10','11:50:00',1.5),('8537','2013-09-10','11:55:00',1.91),('8537','2013-09-10','12:00:00',1.56),('8537','2013-09-10','12:05:00',1.24),('8537','2013-09-10','12:10:00',1.17),('8537','2013-09-10','12:15:00',1.15),('8537','2013-09-10','12:20:00',1.21),('8537','2013-09-10','12:25:00',1.16),('8537','2013-09-10','12:30:00',1.03),('8537','2013-09-10','13:20:00',1.05),('8537','2013-09-10','13:25:00',1.24),('8537','2013-09-10','13:30:00',1.15),('8537','2013-09-10','13:35:00',1.23),('8537','2013-09-10','13:40:00',2.07),('8537','2013-09-10','13:45:00',3.3),('8537','2013-09-10','13:50:00',2.14),('8537','2013-09-10','13:55:00',1.83),('8537','2013-09-10','14:00:00',1.28),('8537','2013-09-10','14:05:00',1.52),('8537','2013-09-10','14:10:00',1.55),('8537','2013-09-10','14:15:00',1.88),('8537','2013-09-10','14:20:00',1.88),('8537','2013-09-10','14:25:00',2.57),('8537','2013-09-10','14:30:00',2.32),('8537','2013-09-10','14:35:00',1.74),('8537','2013-09-10','14:40:00',2.12),('8537','2013-09-10','14:45:00',2.18),('8537','2013-09-10','14:50:00',2.44),('8537','2013-09-10','14:55:00',2.21),('8537','2013-09-10','15:00:00',2.66),('8537','2013-09-10','15:05:00',2.68),('8537','2013-09-10','15:10:00',1.96),('8537','2013-09-10','15:15:00',1.87),('8537','2013-09-10','15:20:00',2.32),('8537','2013-09-10','15:25:00',2.06),('8537','2013-09-10','15:30:00',2.31),('8537','2013-09-10','15:35:00',2.08),('8537','2013-09-10','15:40:00',1.37),('8537','2013-09-10','15:45:00',1.21),('8537','2013-09-10','15:50:00',1.2),('8537','2013-09-10','15:55:00',1.18),('8537','2013-09-10','16:00:00',1.21),('8537','2013-09-10','16:05:00',1.35),('8537','2013-09-10','16:10:00',1.45),('8537','2013-09-10','16:15:00',1.66),('8537','2013-09-10','16:20:00',1.23),('8537','2013-09-10','16:25:00',1.13),('8537','2013-09-09','07:45:00',1.1),('8537','2013-09-09','07:50:00',1.16),('8537','2013-09-09','07:55:00',1.06),('8537','2013-09-09','08:45:00',1),('8537','2013-09-09','08:50:00',1.15),('8537','2013-09-09','08:55:00',1.37),('8537','2013-09-09','09:00:00',1.42),('8537','2013-09-09','09:05:00',1.27),('8537','2013-09-09','09:10:00',1.09),('8537','2013-09-09','09:35:00',1.28),('8537','2013-09-09','09:40:00',1.21),('8537','2013-09-09','10:00:00',1.6),('8537','2013-09-09','10:05:00',2.09),('8537','2013-09-09','10:10:00',2.09),('8537','2013-09-09','10:15:00',2.02),('8537','2013-09-09','10:20:00',1.64),('8537','2013-09-09','10:25:00',1.51),('8537','2013-09-09','10:30:00',1.81),('8537','2013-09-09','10:35:00',2.04),('8537','2013-09-09','10:40:00',2.04),('8537','2013-09-09','10:45:00',2.28),('8537','2013-09-09','10:50:00',3.02),('8537','2013-09-09','10:55:00',2.91),('8537','2013-09-09','11:00:00',3.09),('8537','2013-09-09','11:05:00',2.44),('8537','2013-09-09','11:10:00',2.12),('8537','2013-09-09','11:15:00',2.59),('8537','2013-09-09','11:20:00',2.98),('8537','2013-09-09','11:25:00',3.25),('8537','2013-09-09','11:30:00',2.58),('8537','2013-09-09','11:35:00',2.55),('8537','2013-09-09','11:40:00',3.84),('8537','2013-09-09','11:45:00',3.97),('8537','2013-09-09','11:50:00',3.83),('8537','2013-09-09','11:55:00',3.93),('8537','2013-09-09','12:00:00',3.17),('8537','2013-09-09','12:05:00',3.83),('8537','2013-09-09','12:10:00',2.95),('8537','2013-09-09','12:15:00',2.4),('8537','2013-09-09','12:20:00',2.18),('8537','2013-09-09','12:25:00',1.57),('8537','2013-09-09','12:30:00',1.34),('8537','2013-09-09','12:35:00',1.22),('8537','2013-09-09','12:40:00',1.62),('8537','2013-09-09','12:45:00',1.94),('8537','2013-09-09','12:50:00',1.49),('8537','2013-09-09','12:55:00',1.81),('8537','2013-09-09','13:00:00',1.87),('8537','2013-09-09','13:05:00',2.9),('8537','2013-09-09','13:10:00',3.25),('8537','2013-09-09','13:15:00',3.63),('8537','2013-09-09','13:20:00',2.35),('8537','2013-09-09','13:25:00',2.8),('8537','2013-09-09','13:30:00',3.32),('8537','2013-09-09','13:35:00',4.66),('8537','2013-09-09','13:40:00',3.88),('8537','2013-09-09','13:45:00',4.57),('8537','2013-09-09','13:50:00',4.71),('8537','2013-09-09','13:55:00',4.71),('8537','2013-09-09','14:00:00',4.33),('8537','2013-09-09','14:05:00',4.11),('8537','2013-09-09','14:10:00',4.07),('8537','2013-09-09','14:15:00',3.1),('8537','2013-09-09','14:20:00',2.4),('8537','2013-09-09','14:25:00',1.97),('8537','2013-09-09','14:30:00',2.11),('8537','2013-09-09','14:35:00',4.14),('8537','2013-09-09','14:40:00',3.73),('8537','2013-09-09','14:45:00',2.34),('8537','2013-09-09','14:50:00',3.07),('8537','2013-09-09','14:55:00',3.47),('8537','2013-09-09','15:00:00',3.01),('8537','2013-09-09','15:05:00',2.69),('8537','2013-09-09','15:10:00',3.35),('8537','2013-09-09','15:15:00',1.77),('8537','2013-09-09','15:20:00',2.36),('8537','2013-09-09','15:25:00',1.33),('8537','2013-09-09','15:30:00',3.35),('8537','2013-09-09','15:35:00',2.66),('8537','2013-09-09','15:40:00',2.39),('8537','2013-09-09','15:45:00',1.33),('8537','2013-09-09','15:50:00',1.38),('8537','2013-09-09','15:55:00',1.56),('8537','2013-09-09','16:00:00',1.77),('8537','2013-09-09','16:05:00',1.5),('8537','2013-09-09','16:10:00',1.84),('8537','2013-09-09','16:15:00',2.41),('8537','2013-09-09','16:20:00',2.04),('8537','2013-09-09','16:25:00',1.21),('8537','2013-09-09','16:30:00',1.22),('8537','2013-09-09','16:35:00',1.36),('8537','2013-09-09','16:40:00',1.51),('8537','2013-09-09','16:45:00',2.14),('8537','2013-09-09','17:00:00',1.08),('8537','2013-09-09','18:15:00',1.01),('8537','2014-04-12','08:15:00',1.04),('8537','2014-04-12','09:10:00',1.15),('8537','2014-04-12','09:15:00',1.58),('8537','2014-04-12','09:20:00',2.38),('8537','2014-04-12','09:25:00',2.8),('8537','2014-04-12','09:30:00',2.06),('8537','2014-04-12','09:35:00',1.71),('8537','2014-04-12','09:40:00',1.4),('8537','2014-04-12','09:45:00',1.34),('8537','2014-04-12','09:50:00',1.4),('8537','2014-04-12','09:55:00',1.39),('8537','2014-04-12','10:00:00',1.41),('8537','2014-04-12','10:05:00',1.46),('8537','2014-04-12','10:10:00',1.57),('8537','2014-04-12','10:15:00',1.75),('8537','2014-04-12','10:20:00',1.9),('8537','2014-04-12','10:25:00',2.21),('8537','2014-04-12','10:30:00',2.35),('8537','2014-04-12','10:35:00',2.83),('8537','2014-04-12','10:40:00',2.71),('8537','2014-04-12','10:45:00',2.91),('8537','2014-04-12','10:50:00',2.87),('8537','2014-04-12','10:55:00',2.13),('8537','2014-04-12','11:00:00',2.3),('8537','2014-04-12','11:05:00',3.48),('8537','2014-04-12','11:10:00',3.67),('8537','2014-04-12','11:15:00',4.96),('8537','2014-04-12','11:20:00',4.69),('8537','2014-04-12','11:25:00',4.3),('8537','2014-04-12','11:30:00',4.24),('8537','2014-04-12','11:35:00',4.64),('8537','2014-04-12','11:40:00',4.54),('8537','2014-04-12','11:45:00',4.65),('8537','2014-04-12','11:50:00',3.36),('8537','2014-04-12','11:55:00',2.47),('8537','2014-04-12','12:00:00',2.21),('8537','2014-04-12','12:05:00',2),('8537','2014-04-12','12:10:00',2.56),('8537','2014-04-12','12:15:00',2.01),('8537','2014-04-12','12:20:00',2.13),('8537','2014-04-12','12:25:00',3.75),('8537','2014-04-12','12:30:00',3.13),('8537','2014-04-12','12:35:00',2.94),('8537','2014-04-12','12:40:00',3.46),('8537','2014-04-12','12:45:00',3.58),('8537','2014-04-12','12:50:00',2.62),('8537','2014-04-12','12:55:00',2.21),('8537','2014-04-12','13:00:00',1.67),('8537','2014-04-12','13:05:00',2.03),('8537','2014-04-12','13:10:00',3.16),('8537','2014-04-12','13:15:00',4.28),('8537','2014-04-12','13:20:00',5.01),('8537','2014-04-12','13:25:00',5.07),('8537','2014-04-12','13:30:00',2.66),('8537','2014-04-12','13:35:00',3.23),('8537','2014-04-12','13:40:00',1.97),('8537','2014-04-12','13:45:00',1.92),('8537','2014-04-12','13:50:00',3.68),('8537','2014-04-12','13:55:00',1.73),('8537','2014-04-12','14:00:00',1.91),('8537','2014-04-12','14:05:00',4.09),('8537','2014-04-12','14:10:00',4.61),('8537','2014-04-12','14:15:00',4.51),('8537','2014-04-12','14:20:00',3.62),('8537','2014-04-12','14:25:00',4.64),('8537','2014-04-12','14:30:00',3.88),('8537','2014-04-12','14:35:00',2.75),('8537','2014-04-12','14:40:00',2.46),('8537','2014-04-12','14:45:00',3.11),('8537','2014-04-12','14:50:00',4.9),('8537','2014-04-12','14:55:00',4.18),('8537','2014-04-12','15:00:00',4.05),('8537','2014-04-12','15:05:00',4.13),('8537','2014-04-12','15:10:00',4.17),('8537','2014-04-12','15:15:00',4.18),('8537','2014-04-12','15:20:00',3.52),('8537','2014-04-12','15:25:00',3.11),('8537','2014-04-12','15:30:00',2.4),('8537','2014-04-12','15:35:00',2.92),('8537','2014-04-12','15:40:00',3.39),('8537','2014-04-12','15:45:00',3.55),('8537','2014-04-12','15:50:00',3.98),('8537','2014-04-12','15:55:00',3.86),('8537','2014-04-12','16:00:00',3.83),('8537','2014-04-12','16:05:00',3.64),('8537','2014-04-12','16:10:00',3.23),('8537','2014-04-12','16:15:00',3.46),('8537','2014-04-12','16:20:00',3.64),('8537','2014-04-12','16:25:00',3.28),('8537','2014-04-12','16:30:00',3.18),('8537','2014-04-12','16:35:00',2.93),('8537','2014-04-12','16:40:00',2.13),('8537','2014-04-12','16:45:00',2.21),('8537','2014-04-12','16:50:00',1.64),('8537','2014-04-12','16:55:00',2.26),('8537','2014-04-12','17:00:00',2.54),('8537','2014-04-12','17:05:00',2.18),('8537','2014-04-12','17:10:00',2.25),('8537','2014-04-12','17:15:00',2.13),('8537','2014-04-12','17:20:00',1.72),('8537','2014-04-12','17:25:00',1.79),('8537','2014-04-12','17:30:00',1.5),('8537','2014-04-12','17:35:00',1.27),('8537','2014-04-12','17:40:00',1.3),('8537','2014-04-12','17:45:00',1.65),('8537','2014-04-12','17:50:00',1.56),('8537','2014-04-12','17:55:00',1.32),('8537','2014-04-12','18:00:00',1.26),('8537','2013-09-08','08:50:00',1.04),('8537','2013-09-08','08:55:00',1),('8537','2013-09-08','09:00:00',1.36),('8537','2013-09-08','09:05:00',1.26),('8537','2013-09-08','09:10:00',1.24),('8537','2013-09-08','09:15:00',1.44),('8537','2013-09-08','09:20:00',1.44),('8537','2013-09-08','09:25:00',1.86),('8537','2013-09-08','09:30:00',2.44),('8537','2013-09-08','09:35:00',2.84),('8537','2013-09-08','09:40:00',2.83),('8537','2013-09-08','09:45:00',2.81),('8537','2013-09-08','09:50:00',2.87),('8537','2013-09-08','09:55:00',2.99),('8537','2013-09-08','10:00:00',3.1),('8537','2013-09-08','10:05:00',3.2),('8537','2013-09-08','10:10:00',3.23),('8537','2013-09-08','10:15:00',3.3),('8537','2013-09-08','10:20:00',3.16),('8537','2013-09-08','10:25:00',3.38),('8537','2013-09-08','10:30:00',3.45),('8537','2013-09-08','10:35:00',3.58),('8537','2013-09-08','10:40:00',3.63),('8537','2013-09-08','10:45:00',3.7),('8537','2013-09-08','10:50:00',3.73),('8537','2013-09-08','10:55:00',3.77),('8537','2013-09-08','11:00:00',3.83),('8537','2013-09-08','11:05:00',3.83),('8537','2013-09-08','11:10:00',3.85),('8537','2013-09-08','11:15:00',3.93),('8537','2013-09-08','11:20:00',4.01),('8537','2013-09-08','11:25:00',3.92),('8537','2013-09-08','11:30:00',4.01),('8537','2013-09-08','11:35:00',3.98),('8537','2013-09-08','11:40:00',4.07),('8537','2013-09-08','11:45:00',4.04),('8537','2013-09-08','11:50:00',4.05),('8537','2013-09-08','11:55:00',4.15),('8537','2013-09-08','12:00:00',4.04),('8537','2013-09-08','12:05:00',4.01),('8537','2013-09-08','12:10:00',4.04),('8537','2013-09-08','12:15:00',4.2),('8537','2013-09-08','12:20:00',4.26),('8537','2013-09-08','12:25:00',4.17),('8537','2013-09-08','12:30:00',4.25),('8537','2013-09-08','12:35:00',4.31),('8537','2013-09-08','12:40:00',4.14),('8537','2013-09-08','12:45:00',4.31),('8537','2013-09-08','12:50:00',4.26),('8537','2013-09-08','12:55:00',4.34),('8537','2013-09-08','13:00:00',4.33),('8537','2013-09-08','13:05:00',4.31),('8537','2013-09-08','13:10:00',4.3),('8537','2013-09-08','13:15:00',4.17),('8537','2013-09-08','13:20:00',4.18),('8537','2013-09-08','13:25:00',4.02),('8537','2013-09-08','13:30:00',3.83),('8537','2013-09-08','13:35:00',3.74),('8537','2013-09-08','13:40:00',2.91),('8537','2013-09-08','13:45:00',2.48),('8537','2013-09-08','13:50:00',3.12),('8537','2013-09-08','13:55:00',3.26),('8537','2013-09-08','14:00:00',3.88),('8537','2013-09-08','14:05:00',3.96),('8537','2013-09-08','14:10:00',4.29),('8537','2013-09-08','14:15:00',3.81),('8537','2013-09-08','14:20:00',4),('8537','2013-09-08','14:25:00',4.53),('8537','2013-09-08','14:30:00',3.83),('8537','2013-09-08','14:35:00',3.78),('8537','2013-09-08','14:40:00',4.04),('8537','2013-09-08','14:45:00',4.07),('8537','2013-09-08','14:50:00',4.03),('8537','2013-09-08','14:55:00',3.93),('8537','2013-09-08','15:00:00',3.93),('8537','2013-09-08','15:05:00',3.29),('8537','2013-09-08','15:10:00',2.16),('8537','2013-09-08','15:15:00',2.88),('8537','2013-09-08','15:20:00',3.56),('8537','2013-09-08','15:25:00',3.62),('8537','2013-09-08','15:30:00',3.71),('8537','2013-09-08','15:35:00',3.58),('8537','2013-09-08','15:40:00',3.34),('8537','2013-09-08','15:45:00',3.37),('8537','2013-09-08','15:50:00',3.38),('8537','2013-09-08','15:55:00',2.67),('8537','2013-09-08','16:00:00',2.68),('8537','2013-09-08','16:05:00',2.78),('8537','2013-09-08','16:10:00',2.59),('8537','2013-09-08','16:15:00',2.73),('8537','2013-09-08','16:20:00',2.62),('8537','2013-09-08','16:25:00',2.52),('8537','2013-09-08','16:30:00',2.45),('8537','2013-09-08','16:35:00',2.22),('8537','2013-09-08','16:40:00',2.05),('8537','2013-09-08','16:45:00',1.34),('8537','2013-09-08','16:50:00',1.38),('8537','2013-09-08','16:55:00',1.23),('8537','2013-09-08','17:00:00',1.38),('8537','2013-09-08','17:05:00',2.09),('8537','2013-09-08','17:10:00',1.99),('8537','2013-09-08','17:15:00',1.79),('8537','2013-09-08','17:20:00',1.53),('8537','2013-09-08','17:25:00',1.49),('8537','2013-09-08','17:30:00',1.36),('8537','2013-09-08','17:45:00',1.01),('8537','2013-09-08','17:50:00',1.01),('8537','2013-09-07','08:05:00',1.03),('8537','2013-09-07','08:10:00',1.14),('8537','2013-09-07','08:15:00',1.24),('8537','2013-09-07','08:20:00',1.34),('8537','2013-09-07','08:25:00',1.44),('8537','2013-09-07','08:30:00',1.55),('8537','2013-09-07','08:35:00',1.66),('8537','2013-09-07','08:40:00',1.76),('8537','2013-09-07','08:45:00',1.85),('8537','2013-09-07','08:50:00',1.95),('8537','2013-09-07','08:55:00',2.05),('8537','2013-09-07','09:00:00',2.12),('8537','2013-09-07','09:05:00',2.22),('8537','2013-09-07','09:10:00',2.35),('8537','2013-09-07','09:15:00',2.47),('8537','2013-09-07','09:20:00',2.54),('8537','2013-09-07','09:25:00',2.64),('8537','2013-09-07','09:30:00',2.73),('8537','2013-09-07','09:35:00',2.79),('8537','2013-09-07','09:40:00',2.87),('8537','2013-09-07','09:45:00',2.94),('8537','2013-09-07','09:50:00',3.03),('8537','2013-09-07','09:55:00',3.12),('8537','2013-09-07','10:00:00',3.19),('8537','2013-09-07','10:05:00',3.27),('8537','2013-09-07','10:10:00',3.33),('8537','2013-09-07','10:15:00',3.39),('8537','2013-09-07','10:20:00',3.45),('8537','2013-09-07','10:25:00',3.5),('8537','2013-09-07','10:30:00',3.55),('8537','2013-09-07','10:35:00',3.66),('8537','2013-09-07','10:40:00',3.69),('8537','2013-09-07','10:45:00',3.71),('8537','2013-09-07','10:50:00',3.78),('8537','2013-09-07','10:55:00',3.81),('8537','2013-09-07','11:00:00',3.85),('8537','2013-09-07','11:05:00',3.9),('8537','2013-09-07','11:10:00',3.96),('8537','2013-09-07','11:15:00',4.02),('8537','2013-09-07','11:20:00',4.09),('8537','2013-09-07','11:25:00',4.14),('8537','2013-09-07','11:30:00',4.19),('8537','2013-09-07','11:35:00',4.24),('8537','2013-09-07','11:40:00',4.25),('8537','2013-09-07','11:45:00',4.3),('8537','2013-09-07','11:50:00',4.33),('8537','2013-09-07','11:55:00',4.35),('8537','2013-09-07','12:00:00',4.33),('8537','2013-09-07','12:05:00',4.3),('8537','2013-09-07','12:10:00',4.42),('8537','2013-09-07','12:15:00',4.41),('8537','2013-09-07','12:20:00',4.43),('8537','2013-09-07','12:25:00',4.48),('8537','2013-09-07','12:30:00',4.48),('8537','2013-09-07','12:35:00',4.49),('8537','2013-09-07','12:40:00',4.45),('8537','2013-09-07','12:45:00',4.46),('8537','2013-09-07','12:50:00',4.47),('8537','2013-09-07','12:55:00',4.52),('8537','2013-09-07','13:00:00',4.49),('8537','2013-09-07','13:05:00',4.41),('8537','2013-09-07','13:10:00',4.4),('8537','2013-09-07','13:15:00',4.42),('8537','2013-09-07','13:20:00',4.48),('8537','2013-09-07','13:25:00',4.37),('8537','2013-09-07','13:30:00',4.47),('8537','2013-09-07','13:35:00',4.65),('8537','2013-09-07','13:40:00',4.58),('8537','2013-09-07','13:45:00',4.38),('8537','2013-09-07','13:50:00',4.46),('8537','2013-09-07','13:55:00',4.39),('8537','2013-09-07','14:00:00',3.17),('8537','2013-09-07','14:05:00',4.31),('8537','2013-09-07','14:10:00',4.43),('8537','2013-09-07','14:15:00',4.39),('8537','2013-09-07','14:20:00',4.28),('8537','2013-09-07','14:25:00',4.18),('8537','2013-09-07','14:30:00',3.92),('8537','2013-09-07','14:35:00',3.69),('8537','2013-09-07','14:40:00',4.01),('8537','2013-09-07','14:45:00',4.12),('8537','2013-09-07','14:50:00',4.06),('8537','2013-09-07','14:55:00',4.03),('8537','2013-09-07','15:00:00',4.01),('8537','2013-09-07','15:05:00',3.92),('8537','2013-09-07','15:10:00',3.81),('8537','2013-09-07','15:15:00',3.82),('8537','2013-09-07','15:20:00',3.54),('8537','2013-09-07','15:25:00',3.6),('8537','2013-09-07','15:30:00',3.61),('8537','2013-09-07','15:35:00',3.55),('8537','2013-09-07','15:40:00',3.44),('8537','2013-09-07','15:45:00',3.38),('8537','2013-09-07','15:50:00',3.33),('8537','2013-09-07','15:55:00',3.2),('8537','2013-09-07','16:00:00',2.88),('8537','2013-09-07','16:05:00',3.05),('8537','2013-09-07','16:10:00',2.98),('8537','2013-09-07','16:15:00',2.9),('8537','2013-09-07','16:20:00',2.81),('8537','2013-09-07','16:25:00',2.72),('8537','2013-09-07','16:30:00',2.56),('8537','2013-09-07','16:35:00',2.38),('8537','2013-09-07','16:40:00',2.45),('8537','2013-09-07','16:45:00',2.36),('8537','2013-09-07','16:50:00',2.22),('8537','2013-09-07','16:55:00',2.06),('8537','2013-09-07','17:00:00',2.03),('8537','2013-09-07','17:05:00',1.93),('8537','2013-09-07','17:10:00',1.83),('8537','2013-09-07','17:15:00',1.71),('8537','2013-09-07','17:20:00',1.6),('8537','2013-09-07','17:25:00',1.49),('8537','2013-09-07','17:30:00',1.39),('8537','2013-09-07','17:35:00',1.31),('8537','2013-09-07','17:40:00',1.22),('8537','2013-09-07','17:45:00',1.12),('8537','2013-09-07','17:50:00',1.03),('8537','2013-09-06','08:05:00',1.05),('8537','2013-09-06','08:10:00',1.15),('8537','2013-09-06','08:15:00',1.26),('8537','2013-09-06','08:20:00',1.37),('8537','2013-09-06','08:25:00',1.47),('8537','2013-09-06','08:30:00',1.57),('8537','2013-09-06','08:35:00',1.68),('8537','2013-09-06','08:40:00',1.8),('8537','2013-09-06','08:45:00',1.91),('8537','2013-09-06','08:50:00',1.99),('8537','2013-09-06','08:55:00',2.12),('8537','2013-09-06','09:00:00',2.21),('8537','2013-09-06','09:05:00',2.3),('8537','2013-09-06','09:10:00',2.4),('8537','2013-09-06','09:15:00',2.48),('8537','2013-09-06','09:20:00',2.57),('8537','2013-09-06','09:25:00',2.64),('8537','2013-09-06','09:30:00',2.72),('8537','2013-09-06','09:35:00',2.81),('8537','2013-09-06','09:40:00',2.89),('8537','2013-09-06','09:45:00',2.97),('8537','2013-09-06','09:50:00',3.06),('8537','2013-09-06','09:55:00',3.13),('8537','2013-09-06','10:00:00',3.23),('8537','2013-09-06','10:05:00',3.29),('8537','2013-09-06','10:10:00',3.35),('8537','2013-09-06','10:15:00',3.45),('8537','2013-09-06','10:20:00',3.5),('8537','2013-09-06','10:25:00',3.53),('8537','2013-09-06','10:30:00',3.63),('8537','2013-09-06','10:35:00',3.72),('8537','2013-09-06','10:40:00',3.77),('8537','2013-09-06','10:45:00',3.83),('8537','2013-09-06','10:50:00',3.84),('8537','2013-09-06','10:55:00',3.9),('8537','2013-09-06','11:00:00',3.98),('8537','2013-09-06','11:05:00',4.07),('8537','2013-09-06','11:10:00',4.06),('8537','2013-09-06','11:15:00',4.05),('8537','2013-09-06','11:20:00',4.11),('8537','2013-09-06','11:25:00',4.15),('8537','2013-09-06','11:30:00',4.17),('8537','2013-09-06','11:35:00',4.23),('8537','2013-09-06','11:40:00',4.25),('8537','2013-09-06','11:45:00',4.28),('8537','2013-09-06','11:50:00',4.29),('8537','2013-09-06','11:55:00',4.34),('8537','2013-09-06','12:00:00',4.36),('8537','2013-09-06','12:05:00',4.38),('8537','2013-09-06','12:10:00',4.42),('8537','2013-09-06','12:15:00',4.48),('8537','2013-09-06','12:20:00',4.5),('8537','2013-09-06','12:25:00',4.53),('8537','2013-09-06','12:30:00',4.57),('8537','2013-09-06','12:35:00',4.6),('8537','2013-09-06','12:40:00',4.53),('8537','2013-09-06','12:45:00',4.45),('8537','2013-09-06','12:50:00',4.44),('8537','2013-09-06','12:55:00',4.49),('8537','2013-09-06','13:00:00',4.59),('8537','2013-09-06','13:05:00',4.61),('8537','2013-09-06','13:10:00',4.57),('8537','2013-09-06','13:15:00',4.51),('8537','2013-09-06','13:20:00',4.51),('8537','2013-09-06','13:25:00',4.55),('8537','2013-09-06','13:30:00',4.46),('8537','2013-09-06','13:35:00',4.4),('8537','2013-09-06','13:40:00',4.38),('8537','2013-09-06','13:45:00',4.36),('8537','2013-09-06','13:50:00',4.34),('8537','2013-09-06','13:55:00',4.35),('8537','2013-09-06','14:00:00',4.28),('8537','2013-09-06','14:05:00',4.19),('8537','2013-09-06','14:10:00',4.21),('8537','2013-09-06','14:15:00',4.24),('8537','2013-09-06','14:20:00',4.21),('8537','2013-09-06','14:25:00',4.18),('8537','2013-09-06','14:30:00',3.96),('8537','2013-09-06','14:35:00',3.58),('8537','2013-09-06','14:40:00',3.89),('8537','2013-09-06','14:45:00',4.03),('8537','2013-09-06','14:50:00',4.07),('8537','2013-09-06','14:55:00',4.03),('8537','2013-09-06','15:00:00',3.93),('8537','2013-09-06','15:05:00',3.83),('8537','2013-09-06','15:10:00',3.82),('8537','2013-09-06','15:15:00',3.74),('8537','2013-09-06','15:20:00',3.53),('8537','2013-09-06','15:25:00',3.52),('8537','2013-09-06','15:30:00',3.51),('8537','2013-09-06','15:35:00',3.46),('8537','2013-09-06','15:40:00',3.4),('8537','2013-09-06','15:45:00',3.36),('8537','2013-09-06','15:50:00',3.29),('8537','2013-09-06','15:55:00',3.18),('8537','2013-09-06','16:00:00',2.86),('8537','2013-09-06','16:05:00',2.99),('8537','2013-09-06','16:10:00',2.9),('8537','2013-09-06','16:15:00',2.86),('8537','2013-09-06','16:20:00',2.8),('8537','2013-09-06','16:25:00',2.75),('8537','2013-09-06','16:30:00',2.67),('8537','2013-09-06','16:35:00',2.39),('8537','2013-09-06','16:40:00',2.47),('8537','2013-09-06','16:45:00',2.38),('8537','2013-09-06','16:50:00',2.26),('8537','2013-09-06','16:55:00',2.11),('8537','2013-09-06','17:00:00',2.05),('8537','2013-09-06','17:05:00',1.92),('8537','2013-09-06','17:10:00',1.86),('8537','2013-09-06','17:15:00',1.75),('8537','2013-09-06','17:20:00',1.64),('8537','2013-09-06','17:25:00',1.48),('8537','2013-09-06','17:30:00',1.39),('8537','2013-09-06','17:35:00',1.31),('8537','2013-09-06','17:40:00',1.23),('8537','2013-09-06','17:45:00',1.1),('8537','2013-09-05','08:00:00',1.05),('8537','2013-09-05','08:05:00',1.16),('8537','2013-09-05','08:10:00',1.27),('8537','2013-09-05','08:15:00',1.39),('8537','2013-09-05','08:20:00',1.51),('8537','2013-09-05','08:25:00',1.62),('8537','2013-09-05','08:30:00',1.73),('8537','2013-09-05','08:35:00',1.85),('8537','2013-09-05','08:40:00',1.96),('8537','2013-09-05','08:45:00',2.05),('8537','2013-09-05','08:50:00',2.17),('8537','2013-09-05','08:55:00',2.26),('8537','2013-09-05','09:00:00',2.35),('8537','2013-09-05','09:05:00',2.46),('8537','2013-09-05','09:10:00',2.56),('8537','2013-09-05','09:15:00',2.65),('8537','2013-09-05','09:20:00',2.75),('8537','2013-09-05','09:25:00',2.85),('8537','2013-09-05','09:30:00',2.93),('8537','2013-09-05','09:35:00',3.01),('8537','2013-09-05','09:40:00',3.08),('8537','2013-09-05','09:45:00',3.16),('8537','2013-09-05','09:50:00',3.25),('8537','2013-09-05','09:55:00',3.33),('8537','2013-09-05','10:00:00',3.4),('8537','2013-09-05','10:05:00',3.46),('8537','2013-09-05','10:10:00',3.54),('8537','2013-09-05','10:15:00',3.6),('8537','2013-09-05','10:20:00',3.64),('8537','2013-09-05','10:25:00',3.69),('8537','2013-09-05','10:30:00',3.75),('8537','2013-09-05','10:35:00',3.79),('8537','2013-09-05','10:40:00',3.84),('8537','2013-09-05','10:45:00',3.89),('8537','2013-09-05','10:50:00',3.94),('8537','2013-09-05','10:55:00',3.99),('8537','2013-09-05','11:00:00',4.03),('8537','2013-09-05','11:05:00',4.1),('8537','2013-09-05','11:10:00',4.17),('8537','2013-09-05','11:15:00',4.18),('8537','2013-09-05','11:20:00',4.24),('8537','2013-09-05','11:25:00',4.32),('8537','2013-09-05','11:30:00',4.26),('8537','2013-09-05','11:35:00',4.37),('8537','2013-09-05','11:40:00',4.31),('8537','2013-09-05','11:45:00',4.3),('8537','2013-09-05','11:50:00',4.46),('8537','2013-09-05','11:55:00',4.48),('8537','2013-09-05','12:00:00',4.49),('8537','2013-09-05','12:05:00',4.49),('8537','2013-09-05','12:10:00',4.55),('8537','2013-09-05','12:15:00',4.59),('8537','2013-09-05','12:20:00',4.63),('8537','2013-09-05','12:25:00',4.62),('8537','2013-09-05','12:30:00',4.61),('8537','2013-09-05','12:35:00',4.59),('8537','2013-09-05','12:40:00',4.58),('8537','2013-09-05','12:45:00',4.57),('8537','2013-09-05','12:50:00',4.59),('8537','2013-09-05','12:55:00',4.6),('8537','2013-09-05','13:00:00',4.6),('8537','2013-09-05','13:05:00',4.6),('8537','2013-09-05','13:10:00',4.57),('8537','2013-09-05','13:15:00',4.56),('8537','2013-09-05','13:20:00',4.58),('8537','2013-09-05','13:25:00',4.58),('8537','2013-09-05','13:30:00',4.57),('8537','2013-09-05','13:35:00',4.59),('8537','2013-09-05','13:40:00',4.61),('8537','2013-09-05','13:45:00',4.56),('8537','2013-09-05','13:50:00',4.5),('8537','2013-09-05','13:55:00',4.45),('8537','2013-09-05','14:00:00',4.44),('8537','2013-09-05','14:05:00',4.4),('8537','2013-09-05','14:10:00',4.42),('8537','2013-09-05','14:15:00',4.41),('8537','2013-09-05','14:20:00',4.35),('8537','2013-09-05','14:25:00',4.31),('8537','2013-09-05','14:30:00',4.17),('8537','2013-09-05','14:35:00',4),('8537','2013-09-05','14:40:00',4.11),('8537','2013-09-05','14:45:00',4.09),('8537','2013-09-05','14:50:00',3.98),('8537','2013-09-05','14:55:00',4.03),('8537','2013-09-05','15:00:00',4.03),('8537','2013-09-05','15:05:00',3.99),('8537','2013-09-05','15:10:00',3.93),('8537','2013-09-05','15:15:00',3.84),('8537','2013-09-05','15:20:00',3.71),('8537','2013-09-05','15:25:00',3.7),('8537','2013-09-05','15:30:00',3.62),('8537','2013-09-05','15:35:00',3.59),('8537','2013-09-05','15:40:00',3.52),('8537','2013-09-05','15:45:00',3.46),('8537','2013-09-05','15:50:00',3.39),('8537','2013-09-05','15:55:00',3.33),('8537','2013-09-05','16:00:00',3.02),('8537','2013-09-05','16:05:00',3.15),('8537','2013-09-05','16:10:00',3.12),('8537','2013-09-05','16:15:00',3.06),('8537','2013-09-05','16:20:00',2.99),('8537','2013-09-05','16:25:00',2.9),('8537','2013-09-05','16:30:00',2.82),('8537','2013-09-05','16:35:00',2.58),('8537','2013-09-05','16:40:00',2.7),('8537','2013-09-05','16:45:00',2.65),('8537','2013-09-05','16:50:00',2.29),('8537','2013-09-05','16:55:00',1.77),('8537','2013-09-05','17:00:00',1.4),('8537','2013-09-05','17:05:00',1.5),('8537','2013-09-05','17:10:00',1.51),('8537','2013-09-05','17:15:00',1.33),('8537','2013-09-05','17:20:00',1.48),('8537','2013-09-05','17:25:00',1.44),('8537','2013-09-05','17:30:00',1.43),('8537','2013-09-05','17:35:00',1.45),('8537','2013-09-05','17:40:00',1.54),('8537','2013-09-05','17:45:00',1.37),('8537','2013-09-05','17:50:00',1.2),('8537','2013-09-05','17:55:00',1.04),('8537','2013-09-04','08:00:00',1.03),('8537','2013-09-04','08:05:00',1.16),('8537','2013-09-04','08:10:00',1.27),('8537','2013-09-04','08:15:00',1.39),('8537','2013-09-04','08:20:00',1.5),('8537','2013-09-04','08:25:00',1.61),('8537','2013-09-04','08:30:00',1.72),('8537','2013-09-04','08:35:00',1.83),('8537','2013-09-04','08:40:00',1.94),('8537','2013-09-04','08:45:00',2.04),('8537','2013-09-04','08:50:00',2.16),('8537','2013-09-04','08:55:00',2.27),('8537','2013-09-04','09:00:00',2.37),('8537','2013-09-04','09:05:00',2.47),('8537','2013-09-04','09:10:00',2.59),('8537','2013-09-04','09:15:00',2.68),('8537','2013-09-04','09:20:00',2.8),('8537','2013-09-04','09:25:00',2.88),('8537','2013-09-04','09:30:00',2.99),('8537','2013-09-04','09:35:00',3.1),('8537','2013-09-04','09:40:00',3.19),('8537','2013-09-04','09:45:00',3.27),('8537','2013-09-04','09:50:00',3.34),('8537','2013-09-04','09:55:00',3.44),('8537','2013-09-04','10:00:00',3.54),('8537','2013-09-04','10:05:00',3.61),('8537','2013-09-04','10:10:00',3.68),('8537','2013-09-04','10:15:00',3.73),('8537','2013-09-04','10:20:00',3.8),('8537','2013-09-04','10:25:00',3.85),('8537','2013-09-04','10:30:00',3.91),('8537','2013-09-04','10:35:00',3.99),('8537','2013-09-04','10:40:00',4.03),('8537','2013-09-04','10:45:00',4.07),('8537','2013-09-04','10:50:00',4.13),('8537','2013-09-04','10:55:00',4.21),('8537','2013-09-04','11:00:00',4.26),('8537','2013-09-04','11:05:00',4.28),('8537','2013-09-04','11:10:00',4.37),('8537','2013-09-04','11:15:00',4.4),('8537','2013-09-04','11:20:00',4.44),('8537','2013-09-04','11:25:00',4.49),('8537','2013-09-04','11:30:00',4.51),('8537','2013-09-04','11:35:00',4.58),('8537','2013-09-04','11:40:00',4.61),('8537','2013-09-04','11:45:00',4.66),('8537','2013-09-04','11:50:00',4.7),('8537','2013-09-04','11:55:00',4.72),('8537','2013-09-04','12:00:00',4.75),('8537','2013-09-04','12:05:00',4.75),('8537','2013-09-04','12:10:00',4.77),('8537','2013-09-04','12:15:00',4.79),('8537','2013-09-04','12:20:00',4.8),('8537','2013-09-04','12:25:00',4.84),('8537','2013-09-04','12:30:00',4.86),('8537','2013-09-04','12:35:00',4.88),('8537','2013-09-04','12:40:00',4.89),('8537','2013-09-04','12:45:00',4.86),('8537','2013-09-04','12:50:00',4.84),('8537','2013-09-04','12:55:00',4.86),('8537','2013-09-04','13:00:00',4.86),('8537','2013-09-04','13:05:00',4.87),('8537','2013-09-04','13:10:00',4.86),('8537','2013-09-04','13:15:00',4.86),('8537','2013-09-04','13:20:00',4.86),('8537','2013-09-04','13:25:00',4.86),('8537','2013-09-04','13:30:00',4.84),('8537','2013-09-04','13:35:00',4.83),('8537','2013-09-04','13:40:00',4.8),('8537','2013-09-04','13:45:00',4.77),('8537','2013-09-04','13:50:00',4.76),('8537','2013-09-04','13:55:00',4.71),('8537','2013-09-04','14:00:00',4.68),('8537','2013-09-04','14:05:00',4.59),('8537','2013-09-04','14:10:00',4.66),('8537','2013-09-04','14:15:00',4.62),('8537','2013-09-04','14:20:00',4.54),('8537','2013-09-04','14:25:00',4.56),('8537','2013-09-04','14:30:00',4.4),('8537','2013-09-04','14:35:00',4.3),('8537','2013-09-04','14:40:00',4.4),('8537','2013-09-04','14:45:00',4.36),('8537','2013-09-04','14:50:00',4.31),('8537','2013-09-04','14:55:00',4.25),('8537','2013-09-04','15:00:00',4.21),('8537','2013-09-04','15:05:00',4.17),('8537','2013-09-04','15:10:00',4.11),('8537','2013-09-04','15:15:00',4.07),('8537','2013-09-04','15:20:00',3.96),('8537','2013-09-04','15:25:00',3.89),('8537','2013-09-04','15:30:00',3.82),('8537','2013-09-04','15:35:00',3.75),('8537','2013-09-04','15:40:00',3.69),('8537','2013-09-04','15:45:00',3.63),('8537','2013-09-04','15:50:00',3.54),('8537','2013-09-04','15:55:00',3.47),('8537','2013-09-04','16:00:00',3.18),('8537','2013-09-04','16:05:00',3.19),('8537','2013-09-04','16:10:00',3.18),('8537','2013-09-04','16:15:00',3.12),('8537','2013-09-04','16:20:00',3.03),('8537','2013-09-04','16:25:00',2.95),('8537','2013-09-04','16:30:00',2.89),('8537','2013-09-04','16:35:00',2.72),('8537','2013-09-04','16:40:00',2.66),('8537','2013-09-04','16:45:00',2.58),('8537','2013-09-04','16:50:00',2.48),('8537','2013-09-04','16:55:00',2.3),('8537','2013-09-04','17:00:00',2.2),('8537','2013-09-04','17:05:00',2.11),('8537','2013-09-04','17:10:00',2.03),('8537','2013-09-04','17:15:00',1.91),('8537','2013-09-04','17:20:00',1.81),('8537','2013-09-04','17:25:00',1.67),('8537','2013-09-04','17:30:00',1.58),('8537','2013-09-04','17:35:00',1.47),('8537','2013-09-04','17:40:00',1.37),('8537','2013-09-04','17:45:00',1.25),('8537','2013-09-04','17:50:00',1.16),('8537','2013-09-04','17:55:00',1.06),('8537','2013-09-03','08:05:00',1.05),('8537','2013-09-03','08:10:00',1.14),('8537','2013-09-03','08:15:00',1.25),('8537','2013-09-03','08:20:00',1.34),('8537','2013-09-03','08:25:00',1.44),('8537','2013-09-03','08:30:00',1.55),('8537','2013-09-03','08:35:00',1.65),('8537','2013-09-03','08:40:00',1.75),('8537','2013-09-03','08:45:00',1.86),('8537','2013-09-03','08:50:00',1.97),('8537','2013-09-03','08:55:00',2.09),('8537','2013-09-03','09:00:00',2.18),('8537','2013-09-03','09:05:00',2.28),('8537','2013-09-03','09:10:00',2.39),('8537','2013-09-03','09:15:00',2.47),('8537','2013-09-03','09:20:00',2.6),('8537','2013-09-03','09:25:00',2.7),('8537','2013-09-03','09:30:00',2.79),('8537','2013-09-03','09:35:00',2.87),('8537','2013-09-03','09:40:00',2.95),('8537','2013-09-03','09:45:00',3.03),('8537','2013-09-03','09:50:00',3.1),('8537','2013-09-03','09:55:00',3.17),('8537','2013-09-03','10:00:00',3.24),('8537','2013-09-03','10:05:00',3.31),('8537','2013-09-03','10:10:00',3.38),('8537','2013-09-03','10:15:00',3.48),('8537','2013-09-03','10:20:00',3.56),('8537','2013-09-03','10:25:00',3.63),('8537','2013-09-03','10:30:00',3.71),('8537','2013-09-03','10:35:00',3.82),('8537','2013-09-03','10:40:00',3.92),('8537','2013-09-03','10:45:00',3.98),('8537','2013-09-03','10:50:00',4.01),('8537','2013-09-03','10:55:00',4.04),('8537','2013-09-03','11:00:00',4.09),('8537','2013-09-03','11:05:00',4.08),('8537','2013-09-03','11:10:00',4.18),('8537','2013-09-03','11:15:00',4.22),('8537','2013-09-03','11:20:00',4.25),('8537','2013-09-03','11:25:00',4.32),('8537','2013-09-03','11:30:00',4.34),('8537','2013-09-03','11:35:00',4.37),('8537','2013-09-03','11:40:00',4.39),('8537','2013-09-03','11:45:00',4.43),('8537','2013-09-03','11:50:00',4.45),('8537','2013-09-03','11:55:00',4.51),('8537','2013-09-03','12:00:00',4.52),('8537','2013-09-03','12:05:00',4.56),('8537','2013-09-03','12:10:00',4.61),('8537','2013-09-03','12:15:00',4.64),('8537','2013-09-03','12:20:00',4.65),('8537','2013-09-03','12:25:00',4.71),('8537','2013-09-03','12:30:00',4.74),('8537','2013-09-03','12:35:00',4.74),('8537','2013-09-03','12:40:00',4.75),('8537','2013-09-03','12:45:00',4.78),('8537','2013-09-03','12:50:00',4.72),('8537','2013-09-03','12:55:00',4.73),('8537','2013-09-03','13:00:00',4.75),('8537','2013-09-03','13:05:00',4.79),('8537','2013-09-03','13:10:00',4.77),('8537','2013-09-03','13:15:00',4.75),('8537','2013-09-03','13:20:00',4.74),('8537','2013-09-03','13:25:00',4.67),('8537','2013-09-03','13:30:00',4.69),('8537','2013-09-03','13:35:00',4.7),('8537','2013-09-03','13:40:00',4.66),('8537','2013-09-03','13:45:00',4.7),('8537','2013-09-03','13:50:00',4.67),('8537','2013-09-03','13:55:00',4.63),('8537','2013-09-03','14:00:00',4.51),('8537','2013-09-03','14:05:00',4.41),('8537','2013-09-03','14:10:00',4.47),('8537','2013-09-03','14:15:00',4.48),('8537','2013-09-03','14:20:00',4.47),('8537','2013-09-03','14:25:00',4.44),('8537','2013-09-03','14:30:00',4.3),('8537','2013-09-03','14:35:00',4.16),('8537','2013-09-03','14:40:00',4.31),('8537','2013-09-03','14:45:00',4.29),('8537','2013-09-03','14:50:00',4.28),('8537','2013-09-03','14:55:00',4.23),('8537','2013-09-03','15:00:00',4.15),('8537','2013-09-03','15:05:00',4.02),('8537','2013-09-03','15:10:00',4.03),('8537','2013-09-03','15:15:00',4),('8537','2013-09-03','15:20:00',3.86),('8537','2013-09-03','15:25:00',3.81),('8537','2013-09-03','15:30:00',3.7),('8537','2013-09-03','15:35:00',3.63),('8537','2013-09-03','15:40:00',3.56),('8537','2013-09-03','15:45:00',3.52),('8537','2013-09-03','15:50:00',3.47),('8537','2013-09-03','15:55:00',3.42),('8537','2013-09-03','16:00:00',3.24),('8537','2013-09-03','16:05:00',3.08),('8537','2013-09-03','16:10:00',3.15),('8537','2013-09-03','16:15:00',3.08),('8537','2013-09-03','16:20:00',3.02),('8537','2013-09-03','16:25:00',2.93),('8537','2013-09-03','16:30:00',2.85),('8537','2013-09-03','16:35:00',2.72),('8537','2013-09-03','16:40:00',2.62),('8537','2013-09-03','16:45:00',2.54),('8537','2013-09-03','16:50:00',2.46),('8537','2013-09-03','16:55:00',2.35),('8537','2013-09-03','17:00:00',2.19),('8537','2013-09-03','17:05:00',2.12),('8537','2013-09-03','17:10:00',2.03),('8537','2013-09-03','17:15:00',1.92),('8537','2013-09-03','17:20:00',1.82),('8537','2013-09-03','17:25:00',1.69),('8537','2013-09-03','17:30:00',1.59),('8537','2013-09-03','17:35:00',1.49),('8537','2013-09-03','17:40:00',1.39),('8537','2013-09-03','17:45:00',1.28),('8537','2013-09-03','17:50:00',1.19),('8537','2013-09-03','17:55:00',1.1),('8537','2013-09-02','08:05:00',1.09),('8537','2013-09-02','08:10:00',1.19),('8537','2013-09-02','08:15:00',1.29),('8537','2013-09-02','08:20:00',1.4),('8537','2013-09-02','08:25:00',1.5),('8537','2013-09-02','08:30:00',1.6),('8537','2013-09-02','08:35:00',1.71),('8537','2013-09-02','08:40:00',1.82),('8537','2013-09-02','08:45:00',1.94),('8537','2013-09-02','08:50:00',2.04),('8537','2013-09-02','08:55:00',2.15),('8537','2013-09-02','09:00:00',2.25),('8537','2013-09-02','09:05:00',2.36),('8537','2013-09-02','09:10:00',2.45),('8537','2013-09-02','09:15:00',2.55),('8537','2013-09-02','09:20:00',2.65),('8537','2013-09-02','09:25:00',2.74),('8537','2013-09-02','09:30:00',2.83),('8537','2013-09-02','09:35:00',2.95),('8537','2013-09-02','09:40:00',3.02),('8537','2013-09-02','09:45:00',3.11),('8537','2013-09-02','09:50:00',3.2),('8537','2013-09-02','09:55:00',3.27),('8537','2013-09-02','10:00:00',3.35),('8537','2013-09-02','10:05:00',3.44),('8537','2013-09-02','10:10:00',3.52),('8537','2013-09-02','10:15:00',3.61),('8537','2013-09-02','10:20:00',3.66),('8537','2013-09-02','10:25:00',3.74),('8537','2013-09-02','10:30:00',3.8),('8537','2013-09-02','10:35:00',3.85),('8537','2013-09-02','10:40:00',3.89),('8537','2013-09-02','10:45:00',3.89),('8537','2013-09-02','10:50:00',3.98),('8537','2013-09-02','10:55:00',4.04),('8537','2013-09-02','11:00:00',4.07),('8537','2013-09-02','11:05:00',4.14),('8537','2013-09-02','11:10:00',4.15),('8537','2013-09-02','11:15:00',4.2),('8537','2013-09-02','11:20:00',4.26),('8537','2013-09-02','11:25:00',4.31),('8537','2013-09-02','11:30:00',4.33),('8537','2013-09-02','11:35:00',4.34),('8537','2013-09-02','11:40:00',4.38),('8537','2013-09-02','11:45:00',4.43),('8537','2013-09-02','11:50:00',4.44),('8537','2013-09-02','11:55:00',4.48),('8537','2013-09-02','12:00:00',4.47),('8537','2013-09-02','12:05:00',4.56),('8537','2013-09-02','12:10:00',4.64),('8537','2013-09-02','12:15:00',4.64),('8537','2013-09-02','12:20:00',4.62),('8537','2013-09-02','12:25:00',4.6),('8537','2013-09-02','12:30:00',4.53),('8537','2013-09-02','12:35:00',4.53),('8537','2013-09-02','12:40:00',4.63),('8537','2013-09-02','12:45:00',4.62),('8537','2013-09-02','12:50:00',4.6),('8537','2013-09-02','12:55:00',4.61),('8537','2013-09-02','13:00:00',4.64),('8537','2013-09-02','13:05:00',4.64),('8537','2013-09-02','13:10:00',4.63),('8537','2013-09-02','13:15:00',4.64),('8537','2013-09-02','13:20:00',4.63),('8537','2013-09-02','13:25:00',4.65),('8537','2013-09-02','13:30:00',4.59),('8537','2013-09-02','13:35:00',4.61),('8537','2013-09-02','13:40:00',4.61),('8537','2013-09-02','13:45:00',2.11),('8537','2013-09-02','13:55:00',2.51),('8537','2013-09-02','14:00:00',4.44),('8537','2013-09-02','14:05:00',4.61),('8537','2013-09-02','14:10:00',4.4),('8537','2013-09-02','14:15:00',4.58),('8537','2013-09-02','14:20:00',4.51),('8537','2013-09-02','14:25:00',4.48),('8537','2013-09-02','14:30:00',4.4),('8537','2013-09-02','14:35:00',4.23),('8537','2013-09-02','14:40:00',4.42),('8537','2013-09-02','14:45:00',4.4),('8537','2013-09-02','14:50:00',4.37),('8537','2013-09-02','14:55:00',2.42),('8537','2013-09-02','15:05:00',3.91),('8537','2013-09-02','15:10:00',4.07),('8537','2013-09-02','15:15:00',4.03),('8537','2013-09-02','15:20:00',2.33),('8537','2013-09-02','15:25:00',3.82),('8537','2013-09-02','15:30:00',2.03),('8537','2013-09-02','15:35:00',2.69),('8537','2013-09-02','15:40:00',3.62),('8537','2013-09-02','15:45:00',3.64),('8537','2013-09-02','15:50:00',3.56),('8537','2013-09-02','15:55:00',3.48),('8537','2013-09-02','16:00:00',3.31),('8537','2013-09-02','16:05:00',3.1),('8537','2013-09-02','16:10:00',3.13),('8537','2013-09-02','16:15:00',3.14),('8537','2013-09-02','16:20:00',3.09),('8537','2013-09-02','16:25:00',2.96),('8537','2013-09-02','16:30:00',2.87),('8537','2013-09-02','16:35:00',2.74),('8537','2013-09-02','16:40:00',2.37),('8537','2013-09-02','16:45:00',2.48),('8537','2013-09-02','16:50:00',2.36),('8537','2013-09-02','16:55:00',2.25),('8537','2013-09-02','17:00:00',2.06),('8537','2013-09-02','17:05:00',2.03),('8537','2013-09-02','17:10:00',1.93),('8537','2013-09-02','17:15:00',1.85),('8537','2013-09-02','17:20:00',1.73),('8537','2013-09-02','17:25:00',1.64),('8537','2013-09-02','17:30:00',1.51),('8537','2013-09-02','17:35:00',1.43),('8537','2013-09-02','17:40:00',1.33),('8537','2013-09-02','17:45:00',1.24),('8537','2013-09-02','17:50:00',1.13),('8537','2013-09-02','17:55:00',1.06),('8537','2013-09-01','08:00:00',1.06),('8537','2013-09-01','08:05:00',1.17),('8537','2013-09-01','08:10:00',1.28),('8537','2013-09-01','08:15:00',1.39),('8537','2013-09-01','08:20:00',1.49),('8537','2013-09-01','08:25:00',1.59),('8537','2013-09-01','08:30:00',1.59),('8537','2013-09-01','08:35:00',1.79),('8537','2013-09-01','08:40:00',1.92),('8537','2013-09-01','08:45:00',2.02),('8537','2013-09-01','08:50:00',2.12),('8537','2013-09-01','08:55:00',2.23),('8537','2013-09-01','09:00:00',2.31),('8537','2013-09-01','09:05:00',2.4),('8537','2013-09-01','09:10:00',2.51),('8537','2013-09-01','09:15:00',2.61),('8537','2013-09-01','09:20:00',2.71),('8537','2013-09-01','09:25:00',2.8),('8537','2013-09-01','09:30:00',2.9),('8537','2013-09-01','09:35:00',3),('8537','2013-09-01','09:40:00',3.08),('8537','2013-09-01','09:45:00',3.16),('8537','2013-09-01','09:50:00',3.26),('8537','2013-09-01','09:55:00',3.33),('8537','2013-09-01','10:00:00',3.41),('8537','2013-09-01','10:05:00',3.48),('8537','2013-09-01','10:10:00',3.56),('8537','2013-09-01','10:15:00',3.59),('8537','2013-09-01','10:20:00',3.65),('8537','2013-09-01','10:25:00',3.71),('8537','2013-09-01','10:30:00',3.79),('8537','2013-09-01','10:35:00',3.84),('8537','2013-09-01','10:40:00',3.9),('8537','2013-09-01','10:45:00',3.95),('8537','2013-09-01','10:50:00',3.96),('8537','2013-09-01','10:55:00',4.03),('8537','2013-09-01','11:00:00',4.14),('8537','2013-09-01','11:05:00',4.2),('8537','2013-09-01','11:10:00',4.22),('8537','2013-09-01','11:15:00',4.21),('8537','2013-09-01','11:20:00',4.24),('8537','2013-09-01','11:25:00',4.26),('8537','2013-09-01','11:30:00',4.25),('8537','2013-09-01','11:35:00',4.42),('8537','2013-09-01','11:40:00',4.52),('8537','2013-09-01','11:45:00',4.55),('8537','2013-09-01','11:50:00',4.55),('8537','2013-09-01','11:55:00',4.54),('8537','2013-09-01','12:00:00',4.56),('8537','2013-09-01','12:05:00',4.48),('8537','2013-09-01','12:10:00',4.61),('8537','2013-09-01','12:15:00',4.63),('8537','2013-09-01','12:20:00',4.65),('8537','2013-09-01','12:25:00',4.52),('8537','2013-09-01','12:30:00',4.64),('8537','2013-09-01','12:35:00',4.67),('8537','2013-09-01','12:40:00',4.69),('8537','2013-09-01','12:45:00',4.67),('8537','2013-09-01','12:50:00',4.69),('8537','2013-09-01','12:55:00',4.66),('8537','2013-09-01','13:00:00',4.76),('8537','2013-09-01','13:05:00',4.75),('8537','2013-09-01','13:10:00',4.73),('8537','2013-09-01','13:15:00',4.27),('8537','2013-09-01','13:20:00',4.8),('8537','2013-09-01','13:25:00',4.78),('8537','2013-09-01','13:30:00',4.79),('8537','2013-09-01','13:35:00',4.66),('8537','2013-09-01','13:40:00',4.66),('8537','2013-09-01','13:45:00',4.5),('8537','2013-09-01','13:50:00',4.05),('8537','2013-09-01','13:55:00',4.23),('8537','2013-09-01','14:00:00',3.72),('8537','2013-09-01','14:05:00',3.64),('8537','2013-09-01','14:10:00',4.24),('8537','2013-09-01','14:15:00',4.25),('8537','2013-09-01','14:20:00',3.9),('8537','2013-09-01','14:25:00',3.86),('8537','2013-09-01','14:30:00',3.98),('8537','2013-09-01','14:35:00',3.88),('8537','2013-09-01','14:40:00',3.89),('8537','2013-09-01','14:45:00',3.93),('8537','2013-09-01','14:50:00',3.94),('8537','2013-09-01','14:55:00',3.81),('8537','2013-09-01','15:00:00',3.78),('8537','2013-09-01','15:05:00',3.75),('8537','2013-09-01','15:10:00',3.7),('8537','2013-09-01','15:15:00',3.58),('8537','2013-09-01','15:20:00',3.4),('8537','2013-09-01','15:25:00',2.98),('8537','2013-09-01','15:30:00',2.5),('8537','2013-09-01','15:35:00',2.82),('8537','2013-09-01','15:40:00',3.21),('8537','2013-09-01','15:45:00',2.86),('8537','2013-09-01','15:50:00',2.18),('8537','2013-09-01','15:55:00',2.53),('8537','2013-09-01','16:00:00',3.01),('8537','2013-09-01','16:05:00',3.05),('8537','2013-09-01','16:10:00',3.18),('8537','2013-09-01','16:15:00',3.03),('8537','2013-09-01','16:20:00',2.78),('8537','2013-09-01','16:25:00',2.76),('8537','2013-09-01','16:30:00',3.02),('8537','2013-09-01','16:35:00',2.81),('8537','2013-09-01','16:40:00',2.63),('8537','2013-09-01','16:45:00',2.3),('8537','2013-09-01','16:50:00',2.41),('8537','2013-09-01','16:55:00',2.19),('8537','2013-09-01','17:00:00',1.74),('8537','2013-09-01','17:05:00',1.76),('8537','2013-09-01','17:10:00',1.53),('8537','2013-09-01','17:15:00',1.45),('8537','2013-09-01','17:20:00',1.58),('8537','2013-09-01','17:25:00',1.48),('8537','2013-09-01','17:30:00',1.34),('8537','2013-09-01','17:35:00',1.29),('8537','2013-09-01','17:40:00',1.34),('8537','2013-09-01','17:45:00',1.15),('8537','2013-09-01','17:50:00',1.04),('8537','2013-08-31','08:20:00',1.22),('8537','2013-08-31','08:25:00',1.44),('8537','2013-08-31','08:30:00',1.72),('8537','2013-08-31','08:35:00',1.82),('8537','2013-08-31','08:40:00',1.96),('8537','2013-08-31','08:45:00',2.11),('8537','2013-08-31','08:50:00',2.3),('8537','2013-08-31','08:55:00',2.49),('8537','2013-08-31','09:00:00',2.62),('8537','2013-08-31','09:05:00',2.4),('8537','2013-08-31','09:10:00',1.97),('8537','2013-08-31','09:15:00',2.4),('8537','2013-08-31','09:20:00',2.72),('8537','2013-08-31','09:25:00',2.98),('8537','2013-08-31','09:30:00',3.03),('8537','2013-08-31','09:35:00',3.16),('8537','2013-08-31','09:40:00',3.21),('8537','2013-08-31','09:45:00',3.05),('8537','2013-08-31','09:50:00',3.08),('8537','2013-08-31','09:55:00',3.32),('8537','2013-08-31','10:00:00',3.54),('8537','2013-08-31','10:05:00',3.56),('8537','2013-08-31','10:10:00',3.71),('8537','2013-08-31','10:15:00',3.72),('8537','2013-08-31','10:20:00',3.77),('8537','2013-08-31','10:25:00',3.83),('8537','2013-08-31','10:30:00',3.91),('8537','2013-08-31','10:35:00',4.01),('8537','2013-08-31','10:40:00',4.02),('8537','2013-08-31','10:45:00',4.11),('8537','2013-08-31','10:50:00',4.2),('8537','2013-08-31','10:55:00',4.24),('8537','2013-08-31','11:00:00',4.35),('8537','2013-08-31','11:05:00',4.39),('8537','2013-08-31','11:10:00',4.44),('8537','2013-08-31','11:15:00',4.48),('8537','2013-08-31','11:20:00',4.53),('8537','2013-08-31','11:25:00',4.57),('8537','2013-08-31','11:30:00',4.61),('8537','2013-08-31','11:35:00',4.67),('8537','2013-08-31','11:40:00',4.71),('8537','2013-08-31','11:45:00',4.74),('8537','2013-08-31','11:50:00',4.78),('8537','2013-08-31','11:55:00',4.8),('8537','2013-08-31','12:00:00',4.3),('8537','2013-08-31','12:05:00',3.31),('8537','2013-08-31','12:10:00',4.38),('8537','2013-08-31','12:15:00',4.62),('8537','2013-08-31','12:20:00',4.77),('8537','2013-08-31','12:25:00',4.78),('8537','2013-08-31','12:30:00',4.78),('8537','2013-08-31','12:35:00',4.79),('8537','2013-08-31','12:40:00',4.8),('8537','2013-08-31','12:45:00',4.81),('8537','2013-08-31','12:50:00',4.78),('8537','2013-08-31','12:55:00',4.83),('8537','2013-08-31','13:00:00',4.82),('8537','2013-08-31','13:05:00',4.85),('8537','2013-08-31','13:10:00',4.82),('8537','2013-08-31','13:15:00',4.8),('8537','2013-08-31','13:20:00',4.83),('8537','2013-08-31','13:25:00',4.8),('8537','2013-08-31','13:30:00',4.77),('8537','2013-08-31','13:35:00',4.76),('8537','2013-08-31','13:40:00',4.73),('8537','2013-08-31','13:45:00',4.71),('8537','2013-08-31','13:50:00',4.72),('8537','2013-08-31','13:55:00',4.66),('8537','2013-08-31','14:00:00',4.65),('8537','2013-08-31','14:05:00',4.63),('8537','2013-08-31','14:10:00',4.58),('8537','2013-08-31','14:15:00',4.55),('8537','2013-08-31','14:20:00',4.45),('8537','2013-08-31','14:25:00',4.42),('8537','2013-08-31','14:30:00',4.39),('8537','2013-08-31','14:35:00',3.91),('8537','2013-08-31','14:40:00',3.86),('8537','2013-08-31','14:45:00',4.18),('8537','2013-08-31','14:50:00',4.14),('8537','2013-08-31','14:55:00',4.02),('8537','2013-08-31','15:00:00',4.01),('8537','2013-08-31','15:05:00',4.03),('8537','2013-08-31','15:10:00',3.99),('8537','2013-08-31','15:15:00',3.92),('8537','2013-08-31','15:20:00',3.82),('8537','2013-08-31','15:25:00',3.61),('8537','2013-08-31','15:30:00',3.68),('8537','2013-08-31','15:35:00',3.56),('8537','2013-08-31','15:40:00',3.55),('8537','2013-08-31','15:45:00',3.52),('8537','2013-08-31','15:50:00',3.44),('8537','2013-08-31','15:55:00',3.36),('8537','2013-08-31','16:00:00',3.28),('8537','2013-08-31','16:05:00',3.17),('8537','2013-08-31','16:10:00',3.15),('8537','2013-08-31','16:15:00',3.08),('8537','2013-08-31','16:20:00',3.01),('8537','2013-08-31','16:25:00',2.91),('8537','2013-08-31','16:30:00',2.8),('8537','2013-08-31','16:35:00',2.8),('8537','2013-08-31','16:40:00',2.54),('8537','2013-08-31','16:45:00',2.5),('8537','2013-08-31','16:50:00',2.4),('8537','2013-08-31','16:55:00',2.33),('8537','2013-08-31','17:00:00',2.12),('8537','2013-08-31','17:05:00',2.12),('8537','2013-08-31','17:10:00',2.08),('8537','2013-08-31','17:15:00',1.95),('8537','2013-08-31','17:20:00',1.81),('8537','2013-08-31','17:25:00',1.71),('8537','2013-08-31','17:30:00',1.56),('8537','2013-08-31','17:35:00',1.43),('8537','2013-08-31','17:40:00',1.38),('8537','2013-08-31','17:45:00',1.25),('8537','2013-08-31','17:50:00',1.14),('8537','2013-08-31','17:55:00',1),('8537','2013-08-30','08:00:00',1.09),('8537','2013-08-30','08:05:00',1.33),('8537','2013-08-30','08:10:00',1.49),('8537','2013-08-30','08:15:00',1.44),('8537','2013-08-30','08:20:00',1.54),('8537','2013-08-30','08:25:00',1.6),('8537','2013-08-30','08:30:00',1.67),('8537','2013-08-30','08:35:00',1.76),('8537','2013-08-30','08:40:00',1.81),('8537','2013-08-30','08:45:00',1.63),('8537','2013-08-30','08:50:00',1.48),('8537','2013-08-30','08:55:00',1.48),('8537','2013-08-30','09:00:00',1.71),('8537','2013-08-30','09:05:00',1.88),('8537','2013-08-30','09:10:00',1.67),('8537','2013-08-30','09:15:00',1.56),('8537','2013-08-30','09:20:00',1.41),('8537','2013-08-30','09:25:00',1.5),('8537','2013-08-30','09:30:00',1.93),('8537','2013-08-30','09:35:00',2.16),('8537','2013-08-30','09:40:00',2.1),('8537','2013-08-30','09:45:00',2.15),('8537','2013-08-30','09:50:00',2.16),('8537','2013-08-30','09:55:00',2.26),('8537','2013-08-30','10:00:00',2.29),('8537','2013-08-30','10:05:00',2.27),('8537','2013-08-30','10:10:00',2.27),('8537','2013-08-30','10:15:00',2.42),('8537','2013-08-30','10:20:00',2.56),('8537','2013-08-30','10:25:00',2.35),('8537','2013-08-30','10:30:00',2.61),('8537','2013-08-30','10:35:00',2.5),('8537','2013-08-30','10:40:00',2.37),('8537','2013-08-30','10:45:00',2.3),('8537','2013-08-30','10:50:00',2.44),('8537','2013-08-30','10:55:00',2.33),('8537','2013-08-30','11:00:00',2.44),('8537','2013-08-30','11:05:00',2.59),('8537','2013-08-30','11:10:00',2.73),('8537','2013-08-30','11:15:00',2.76),('8537','2013-08-30','11:20:00',2.74),('8537','2013-08-30','11:25:00',2.87),('8537','2013-08-30','11:30:00',3.05),('8537','2013-08-30','11:35:00',2.9),('8537','2013-08-30','11:40:00',3.16),('8537','2013-08-30','11:45:00',3.09),('8537','2013-08-30','11:50:00',3.57),('8537','2013-08-30','11:55:00',3.14),('8537','2013-08-30','12:00:00',2.82),('8537','2013-08-30','12:05:00',2.4),('8537','2013-08-30','12:10:00',2.61),('8537','2013-08-30','12:15:00',2.87),('8537','2013-08-30','12:20:00',3.1),('8537','2013-08-30','12:25:00',3.53),('8537','2013-08-30','12:30:00',3.86),('8537','2013-08-30','12:35:00',3.72),('8537','2013-08-30','12:40:00',3.62),('8537','2013-08-30','12:45:00',3.74),('8537','2013-08-30','12:50:00',3.69),('8537','2013-08-30','12:55:00',3.43),('8537','2013-08-30','13:00:00',3.34),('8537','2013-08-30','13:05:00',3.25),('8537','2013-08-30','13:10:00',3.36),('8537','2013-08-30','13:15:00',3.22),('8537','2013-08-30','13:20:00',3.74),('8537','2013-08-30','13:25:00',4.43),('8537','2013-08-30','13:30:00',4.73),('8537','2013-08-30','13:35:00',4.41),('8537','2013-08-30','13:40:00',4.68),('8537','2013-08-30','13:45:00',4.21),('8537','2013-08-30','13:50:00',4.21),('8537','2013-08-30','13:55:00',4.6),('8537','2013-08-30','14:00:00',4.75),('8537','2013-08-30','14:05:00',4.58),('8537','2013-08-30','14:10:00',4.62),('8537','2013-08-30','14:15:00',4.54),('8537','2013-08-30','14:20:00',4.59),('8537','2013-08-30','14:25:00',4.51),('8537','2013-08-30','14:30:00',4.49),('8537','2013-08-30','14:35:00',4.33),('8537','2013-08-30','14:40:00',4.33),('8537','2013-08-30','14:45:00',3.57),('8537','2013-08-30','14:50:00',2.98),('8537','2013-08-30','14:55:00',3.41),('8537','2013-08-30','15:00:00',2.95),('8537','2013-08-30','15:05:00',2.7),('8537','2013-08-30','15:10:00',2.7),('8537','2013-08-30','15:15:00',3.31),('8537','2013-08-30','15:20:00',2.87),('8537','2013-08-30','15:25:00',2.56),('8537','2013-08-30','15:30:00',2.39),('8537','2013-08-30','15:35:00',1.99),('8537','2013-08-30','15:40:00',2.13),('8537','2013-08-30','15:45:00',2.49),('8537','2013-08-30','15:50:00',2.7),('8537','2013-08-30','15:55:00',2.67),('8537','2013-08-30','16:00:00',2.52),('8537','2013-08-30','16:05:00',2.2),('8537','2013-08-30','16:10:00',1.79),('8537','2013-08-30','16:15:00',1.64),('8537','2013-08-30','16:20:00',1.79),('8537','2013-08-30','16:25:00',1.82),('8537','2013-08-30','16:30:00',1.8),('8537','2013-08-30','16:35:00',1.66),('8537','2013-08-30','16:40:00',2.5),('8537','2013-08-30','16:45:00',2.43),('8537','2013-08-30','16:50:00',2.05),('8537','2013-08-30','16:55:00',1.53),('8537','2013-08-30','17:00:00',1.8),('8537','2013-08-30','17:05:00',1.44),('8537','2013-08-30','17:10:00',1.63),('8537','2013-08-30','17:15:00',1.5),('8537','2013-08-30','17:20:00',1.3),('8537','2013-08-30','17:25:00',1.26),('8537','2013-08-30','17:30:00',1.34),('8537','2013-08-30','17:35:00',1.31),('8537','2013-08-30','17:40:00',1.46),('8537','2013-08-30','17:45:00',1.43),('8537','2013-08-30','17:50:00',1.18),('8537','2013-08-30','17:55:00',1.32),('8537','2013-08-30','18:00:00',1.03),('8537','2014-04-11','07:50:00',1.02),('8537','2014-04-11','07:55:00',1.11),('8537','2014-04-11','08:30:00',1.27),('8537','2014-04-11','08:35:00',1.72),('8537','2014-04-11','08:40:00',2.14),('8537','2014-04-11','08:45:00',2.27),('8537','2014-04-11','08:50:00',2.34),('8537','2014-04-11','08:55:00',2.43),('8537','2014-04-11','09:00:00',2.49),('8537','2014-04-11','09:05:00',2.56),('8537','2014-04-11','09:10:00',2.61),('8537','2014-04-11','09:15:00',2.7),('8537','2014-04-11','09:20:00',2.84),('8537','2014-04-11','09:25:00',2.95),('8537','2014-04-11','09:30:00',3.03),('8537','2014-04-11','09:35:00',3.13),('8537','2014-04-11','09:40:00',3.2),('8537','2014-04-11','09:45:00',3.27),('8537','2014-04-11','09:50:00',3.36),('8537','2014-04-11','09:55:00',3.44),('8537','2014-04-11','10:00:00',3.54),('8537','2014-04-11','10:05:00',3.63),('8537','2014-04-11','10:10:00',3.78),('8537','2014-04-11','10:15:00',3.83),('8537','2014-04-11','10:20:00',3.9),('8537','2014-04-11','10:25:00',3.98),('8537','2014-04-11','10:30:00',4.04),('8537','2014-04-11','10:35:00',4.09),('8537','2014-04-11','10:40:00',4.13),('8537','2014-04-11','10:45:00',4.2),('8537','2014-04-11','10:50:00',4.31),('8537','2014-04-11','10:55:00',4.38),('8537','2014-04-11','11:00:00',4.45),('8537','2014-04-11','11:05:00',4.48),('8537','2014-04-11','11:10:00',4.51),('8537','2014-04-11','11:15:00',4.31),('8537','2014-04-11','11:20:00',4.66),('8537','2014-04-11','11:25:00',4.75),('8537','2014-04-11','11:30:00',4.75),('8537','2014-04-11','11:35:00',4.8),('8537','2014-04-11','11:40:00',4.7),('8537','2014-04-11','11:45:00',4.86),('8537','2014-04-11','11:50:00',4.86),('8537','2014-04-11','11:55:00',5),('8537','2014-04-11','12:00:00',5.18),('8537','2014-04-11','12:05:00',4.52),('8537','2014-04-11','12:10:00',5.29),('8537','2014-04-11','12:15:00',4.93),('8537','2014-04-11','12:20:00',5.06),('8537','2014-04-11','12:25:00',3.32),('8537','2014-04-11','12:30:00',5.21),('8537','2014-04-11','12:35:00',5.27),('8537','2014-04-11','12:40:00',5.41),('8537','2014-04-11','12:45:00',5.14),('8537','2014-04-11','12:50:00',4.96),('8537','2014-04-11','12:55:00',5.27),('8537','2014-04-11','13:00:00',4.93),('8537','2014-04-11','13:05:00',3.31),('8537','2014-04-11','13:10:00',3.63),('8537','2014-04-11','13:15:00',4.84),('8537','2014-04-11','13:20:00',2.9),('8537','2014-04-11','13:25:00',5.08),('8537','2014-04-11','13:30:00',3.79),('8537','2014-04-11','13:35:00',3.65),('8537','2014-04-11','13:40:00',3.8),('8537','2014-04-11','13:45:00',4.52),('8537','2014-04-11','13:50:00',4.37),('8537','2014-04-11','13:55:00',4.79),('8537','2014-04-11','14:00:00',4.43),('8537','2014-04-11','14:05:00',3.76),('8537','2014-04-11','14:10:00',3.8),('8537','2014-04-11','14:15:00',4),('8537','2014-04-11','14:20:00',3.29),('8537','2014-04-11','14:25:00',3.13),('8537','2014-04-11','14:30:00',5.16),('8537','2014-04-11','14:35:00',5.27),('8537','2014-04-11','14:40:00',4.69),('8537','2014-04-11','14:45:00',4.26),('8537','2014-04-11','14:50:00',4.68),('8537','2014-04-11','14:55:00',3.97),('8537','2014-04-11','15:00:00',3.91),('8537','2014-04-11','15:05:00',4.37),('8537','2014-04-11','15:10:00',4.18),('8537','2014-04-11','15:15:00',4.5),('8537','2014-04-11','15:20:00',3.72),('8537','2014-04-11','15:25:00',4.11),('8537','2014-04-11','15:30:00',4.19),('8537','2014-04-11','15:35:00',4.08),('8537','2014-04-11','15:40:00',4.03),('8537','2014-04-11','15:45:00',3.88),('8537','2014-04-11','15:50:00',3.84),('8537','2014-04-11','15:55:00',3.84),('8537','2014-04-11','16:00:00',3.69),('8537','2014-04-11','16:05:00',3.55),('8537','2014-04-11','16:10:00',3.49),('8537','2014-04-11','16:15:00',3.37),('8537','2014-04-11','16:20:00',3.27),('8537','2014-04-11','16:25:00',3.22),('8537','2014-04-11','16:30:00',3.15),('8537','2014-04-11','16:35:00',2.8),('8537','2014-04-11','16:40:00',2.53),('8537','2014-04-11','16:45:00',2.31),('8537','2014-04-11','16:50:00',2.19),('8537','2014-04-11','16:55:00',1.2),('8537','2014-04-11','17:00:00',1.92),('8537','2014-04-11','17:05:00',1.47),('8537','2014-04-11','17:10:00',1.71),('8537','2014-04-11','17:15:00',1.42),('8537','2014-04-11','17:20:00',1.58),('8537','2014-04-11','17:25:00',1.97),('8537','2014-04-11','17:30:00',1.91),('8537','2014-04-11','17:35:00',1.87),('8537','2014-04-11','17:40:00',1.77),('8537','2014-04-11','17:45:00',1.58),('8537','2014-04-11','17:50:00',1.41),('8537','2014-04-11','17:55:00',1.29),('8537','2014-04-11','18:00:00',1.17),('8537','2014-04-11','18:05:00',1.03),('8537','2013-08-29','07:55:00',1.02),('8537','2013-08-29','08:00:00',1.15),('8537','2013-08-29','08:05:00',1.25),('8537','2013-08-29','08:10:00',1.39),('8537','2013-08-29','08:15:00',1.54),('8537','2013-08-29','08:20:00',1.73),('8537','2013-08-29','08:25:00',1.96),('8537','2013-08-29','08:30:00',2.21),('8537','2013-08-29','08:35:00',2.15),('8537','2013-08-29','08:40:00',1.65),('8537','2013-08-29','08:45:00',1.27),('8537','2013-08-29','08:50:00',1.47),('8537','2013-08-29','08:55:00',1.95),('8537','2013-08-29','09:00:00',1.91),('8537','2013-08-29','09:05:00',1.86),('8537','2013-08-29','09:10:00',1.79),('8537','2013-08-29','09:15:00',1.96),('8537','2013-08-29','09:20:00',1.94),('8537','2013-08-29','09:25:00',1.77),('8537','2013-08-29','09:30:00',1.83),('8537','2013-08-29','09:35:00',2),('8537','2013-08-29','09:40:00',2.04),('8537','2013-08-29','09:45:00',1.78),('8537','2013-08-29','09:50:00',1.72),('8537','2013-08-29','09:55:00',1.79),('8537','2013-08-29','10:00:00',1.91),('8537','2013-08-29','10:05:00',1.81),('8537','2013-08-29','10:10:00',1.77),('8537','2013-08-29','10:15:00',1.76),('8537','2013-08-29','10:20:00',1.78),('8537','2013-08-29','10:25:00',1.77),('8537','2013-08-29','10:30:00',1.83),('8537','2013-08-29','10:35:00',1.72),('8537','2013-08-29','10:40:00',1.59),('8537','2013-08-29','10:45:00',1.47),('8537','2013-08-29','10:50:00',1.45),('8537','2013-08-29','10:55:00',1.6),('8537','2013-08-29','11:00:00',1.71),('8537','2013-08-29','11:05:00',1.72),('8537','2013-08-29','11:10:00',2.55),('8537','2013-08-29','11:15:00',3.12),('8537','2013-08-29','11:20:00',2.91),('8537','2013-08-29','11:25:00',2.15),('8537','2013-08-29','11:30:00',1.85),('8537','2013-08-29','11:35:00',1.62),('8537','2013-08-29','11:40:00',1.8),('8537','2013-08-29','11:45:00',2.12),('8537','2013-08-29','11:50:00',2.22),('8537','2013-08-29','11:55:00',2.13),('8537','2013-08-29','12:00:00',2.13),('8537','2013-08-29','12:05:00',2.47),('8537','2013-08-29','12:10:00',2.98),('8537','2013-08-29','12:15:00',3.64),('8537','2013-08-29','12:20:00',3.12),('8537','2013-08-29','12:25:00',3.18),('8537','2013-08-29','12:30:00',3.19),('8537','2013-08-29','12:35:00',3.78),('8537','2013-08-29','12:40:00',5.22),('8537','2013-08-29','12:45:00',5.27),('8537','2013-08-29','12:50:00',3.14),('8537','2013-08-29','12:55:00',4.36),('8537','2013-08-29','13:00:00',3.43),('8537','2013-08-29','13:05:00',2.99),('8537','2013-08-29','13:10:00',2.95),('8537','2013-08-29','13:15:00',2.83),('8537','2013-08-29','13:20:00',2.77),('8537','2013-08-29','13:25:00',2.4),('8537','2013-08-29','13:30:00',2.18),('8537','2013-08-29','13:35:00',2.03),('8537','2013-08-29','13:40:00',1.92),('8537','2013-08-29','13:45:00',1.8),('8537','2013-08-29','13:50:00',1.76),('8537','2013-08-29','13:55:00',2.02),('8537','2013-08-29','14:00:00',2.78),('8537','2013-08-29','14:05:00',2.01),('8537','2013-08-29','14:10:00',1.81),('8537','2013-08-29','14:15:00',1.54),('8537','2013-08-29','14:20:00',1.23),('8537','2013-08-29','14:25:00',1.09),('8537','2013-08-29','14:30:00',1.01),('8537','2013-08-29','14:35:00',1.01),('8537','2013-08-29','14:40:00',1.03),('8537','2013-08-29','14:45:00',1.13),('8537','2013-08-29','14:50:00',1.31),('8537','2013-08-29','14:55:00',1.55),('8537','2013-08-29','15:00:00',1.73),('8537','2013-08-29','15:05:00',1.91),('8537','2013-08-29','15:10:00',1.56),('8537','2013-08-29','15:15:00',1.36),('8537','2013-08-29','15:20:00',1.45),('8537','2013-08-29','15:25:00',1.66),('8537','2013-08-29','15:30:00',2.34),('8537','2013-08-29','15:35:00',2.45),('8537','2013-08-29','15:40:00',2.26),('8537','2013-08-29','15:45:00',2.74),('8537','2013-08-29','15:50:00',3.33),('8537','2013-08-29','15:55:00',3.54),('8537','2013-08-29','16:00:00',3.59),('8537','2013-08-29','16:05:00',3.76),('8537','2013-08-29','16:10:00',3.31),('8537','2013-08-29','16:15:00',3.34),('8537','2013-08-29','16:20:00',3.21),('8537','2013-08-29','16:25:00',3.06),('8537','2013-08-29','16:30:00',2.91),('8537','2013-08-29','16:35:00',2.89),('8537','2013-08-29','16:40:00',2.67),('8537','2013-08-29','16:45:00',2.64),('8537','2013-08-29','16:50:00',2.58),('8537','2013-08-29','16:55:00',2.49),('8537','2013-08-29','17:00:00',2.35),('8537','2013-08-29','17:05:00',2.18),('8537','2013-08-29','17:10:00',2.16),('8537','2013-08-29','17:15:00',2.06),('8537','2013-08-29','17:20:00',1.94),('8537','2013-08-29','17:25:00',1.83),('8537','2013-08-29','17:30:00',1.7),('8537','2013-08-29','17:35:00',1.6),('8537','2013-08-29','17:40:00',1.49),('8537','2013-08-29','17:45:00',1.37),('8537','2013-08-29','17:50:00',1.27),('8537','2013-08-29','17:55:00',1.17),('8537','2013-08-29','18:00:00',1.09),('8537','2013-08-28','07:55:00',1),('8537','2013-08-28','08:00:00',1.13),('8537','2013-08-28','08:05:00',1.21),('8537','2013-08-28','08:10:00',1.3),('8537','2013-08-28','08:15:00',1.41),('8537','2013-08-28','08:20:00',1.5),('8537','2013-08-28','08:25:00',1.59),('8537','2013-08-28','08:30:00',1.68),('8537','2013-08-28','08:35:00',1.91),('8537','2013-08-28','08:40:00',1.49),('8537','2013-08-28','08:45:00',1.5),('8537','2013-08-28','08:50:00',1.62),('8537','2013-08-28','08:55:00',1.07),('8537','2013-08-28','09:00:00',2.22),('8537','2013-08-28','09:05:00',1.72),('8537','2013-08-28','09:10:00',1.49),('8537','2013-08-28','09:15:00',1.93),('8537','2013-08-28','09:20:00',1.6),('8537','2013-08-28','09:30:00',1.22),('8537','2013-08-28','09:35:00',2.83),('8537','2013-08-28','09:40:00',3.02),('8537','2013-08-28','09:45:00',3.22),('8537','2013-08-28','09:50:00',3.3),('8537','2013-08-28','09:55:00',3.33),('8537','2013-08-28','10:00:00',3.37),('8537','2013-08-28','10:05:00',3.43),('8537','2013-08-28','10:10:00',3.6),('8537','2013-08-28','10:15:00',3.66),('8537','2013-08-28','10:20:00',4.01),('8537','2013-08-28','10:25:00',2.91),('8537','2013-08-28','10:30:00',2.71),('8537','2013-08-28','10:35:00',2.24),('8537','2013-08-28','10:40:00',2.27),('8537','2013-08-28','10:45:00',3.7),('8537','2013-08-28','10:50:00',4.19),('8537','2013-08-28','10:55:00',4.11),('8537','2013-08-28','11:00:00',2.64),('8537','2013-08-28','11:05:00',2.91),('8537','2013-08-28','11:10:00',3.97),('8537','2013-08-28','11:15:00',3.03),('8537','2013-08-28','11:20:00',4.73),('8537','2013-08-28','11:25:00',4.62),('8537','2013-08-28','11:30:00',4.68),('8537','2013-08-28','11:35:00',4.73),('8537','2013-08-28','11:40:00',4.91),('8537','2013-08-28','11:45:00',3.73),('8537','2013-08-28','11:50:00',2.91),('8537','2013-08-28','11:55:00',3.75),('8537','2013-08-28','12:00:00',1.97),('8537','2013-08-28','12:05:00',4.47),('8537','2013-08-28','12:10:00',4.93),('8537','2013-08-28','12:15:00',3.38),('8537','2013-08-28','12:20:00',4.96),('8537','2013-08-28','12:25:00',4.91),('8537','2013-08-28','12:30:00',4.88),('8537','2013-08-28','12:35:00',4.85),('8537','2013-08-28','12:40:00',4.88),('8537','2013-08-28','12:45:00',5.03),('8537','2013-08-28','12:50:00',4.98),('8537','2013-08-28','12:55:00',4.92),('8537','2013-08-28','13:00:00',5.02),('8537','2013-08-28','13:05:00',4.54),('8537','2013-08-28','13:10:00',5.12),('8537','2013-08-28','13:15:00',5.06),('8537','2013-08-28','13:20:00',4.95),('8537','2013-08-28','13:25:00',4.97),('8537','2013-08-28','13:30:00',4.97),('8537','2013-08-28','13:35:00',4.93),('8537','2013-08-28','13:40:00',4.88),('8537','2013-08-28','13:45:00',4.71),('8537','2013-08-28','13:50:00',4.6),('8537','2013-08-28','13:55:00',3.53),('8537','2013-08-28','14:00:00',4.84),('8537','2013-08-28','14:05:00',4.79),('8537','2013-08-28','14:10:00',4.85),('8537','2013-08-28','14:15:00',4.85),('8537','2013-08-28','14:20:00',4.75),('8537','2013-08-28','14:25:00',4.72),('8537','2013-08-28','14:30:00',3.8),('8537','2013-08-28','14:35:00',3.81),('8537','2013-08-28','14:40:00',4.63),('8537','2013-08-28','14:45:00',4.53),('8537','2013-08-28','14:50:00',4.48),('8537','2013-08-28','14:55:00',4.42),('8537','2013-08-28','15:00:00',4.37),('8537','2013-08-28','15:05:00',4.06),('8537','2013-08-28','15:10:00',4.39),('8537','2013-08-28','15:15:00',4.31),('8537','2013-08-28','15:20:00',4.26),('8537','2013-08-28','15:25:00',3.93),('8537','2013-08-28','15:30:00',2.3),('8537','2013-08-28','15:35:00',4.08),('8537','2013-08-28','15:40:00',2.46),('8537','2013-08-28','15:45:00',1.93),('8537','2013-08-28','15:50:00',1.88),('8537','2013-08-28','15:55:00',2.48),('8537','2013-08-28','16:00:00',3.95),('8537','2013-08-28','16:05:00',2.94),('8537','2013-08-28','16:10:00',3.58),('8537','2013-08-28','16:15:00',2.78),('8537','2013-08-28','16:20:00',1.56),('8537','2013-08-28','16:25:00',3.46),('8537','2013-08-28','16:30:00',3.18),('8537','2013-08-28','16:35:00',3.07),('8537','2013-08-28','16:40:00',2.92),('8537','2013-08-28','16:45:00',2.3),('8537','2013-08-28','16:50:00',2.55),('8537','2013-08-28','16:55:00',2.25),('8537','2013-08-28','17:00:00',2.52),('8537','2013-08-28','17:05:00',2.3),('8537','2013-08-28','17:10:00',1.64),('8537','2013-08-28','17:15:00',2.09),('8537','2013-08-28','17:20:00',1.13),('8537','2013-08-28','17:25:00',1.62),('8537','2013-08-28','17:30:00',1.07),('8537','2013-08-28','17:35:00',1.4),('8537','2013-08-28','17:40:00',1.25),('8537','2013-08-28','17:45:00',1.16),('8537','2013-08-27','08:20:00',1.34),('8537','2013-08-27','08:25:00',1.77),('8537','2013-08-27','08:30:00',1.79),('8537','2013-08-27','08:35:00',1.27),('8537','2013-08-27','08:40:00',1.18),('8537','2013-08-27','08:45:00',1.46),('8537','2013-08-27','08:50:00',1.08),('8537','2013-08-27','09:00:00',1.16),('8537','2013-08-27','09:05:00',1.24),('8537','2013-08-27','09:10:00',1.25),('8537','2013-08-27','09:15:00',1.6),('8537','2013-08-27','09:20:00',1.84),('8537','2013-08-27','09:25:00',2.43),('8537','2013-08-27','09:30:00',2.66),('8537','2013-08-27','09:35:00',1.6),('8537','2013-08-27','09:40:00',1.22),('8537','2013-08-27','09:45:00',1.26),('8537','2013-08-27','09:50:00',1.32),('8537','2013-08-27','09:55:00',1.72),('8537','2013-08-27','10:00:00',2.26),('8537','2013-08-27','10:05:00',2.77),('8537','2013-08-27','10:10:00',3.39),('8537','2013-08-27','10:15:00',3.48),('8537','2013-08-27','10:20:00',3.63),('8537','2013-08-27','10:25:00',3.66),('8537','2013-08-27','10:30:00',3.73),('8537','2013-08-27','10:35:00',3.78),('8537','2013-08-27','10:40:00',3.76),('8537','2013-08-27','10:45:00',3.89),('8537','2013-08-27','10:50:00',3.95),('8537','2013-08-27','10:55:00',3.97),('8537','2013-08-27','11:00:00',4.01),('8537','2013-08-27','11:05:00',4.14),('8537','2013-08-27','11:10:00',4.12),('8537','2013-08-27','11:15:00',4.21),('8537','2013-08-27','11:20:00',4.17),('8537','2013-08-27','11:25:00',4.17),('8537','2013-08-27','11:30:00',4.17),('8537','2013-08-27','11:35:00',4.28),('8537','2013-08-27','11:40:00',4.15),('8537','2013-08-27','11:45:00',5.06),('8537','2013-08-27','11:50:00',3.94),('8537','2013-08-27','11:55:00',4.55),('8537','2013-08-27','12:00:00',4.85),('8537','2013-08-27','12:05:00',4.51),('8537','2013-08-27','12:10:00',3.75),('8537','2013-08-27','12:15:00',4.16),('8537','2013-08-27','12:20:00',4.52),('8537','2013-08-27','12:25:00',4.45),('8537','2013-08-27','12:30:00',4.52),('8537','2013-08-27','12:35:00',5.04),('8537','2013-08-27','12:40:00',4.29),('8537','2013-08-27','12:45:00',3.67),('8537','2013-08-27','12:50:00',2.91),('8537','2013-08-27','12:55:00',2.66),('8537','2013-08-27','13:00:00',1.7),('8537','2013-08-27','13:05:00',2.06),('8537','2013-08-27','13:10:00',2.92),('8537','2013-08-27','13:15:00',2.41),('8537','2013-08-27','13:20:00',2.25),('8537','2013-08-27','13:25:00',2.26),('8537','2013-08-27','13:30:00',2.81),('8537','2013-08-27','13:35:00',2.24),('8537','2013-08-27','13:40:00',2.48),('8537','2013-08-27','13:45:00',3.19),('8537','2013-08-27','13:50:00',4.7),('8537','2013-08-27','13:55:00',3.78),('8537','2013-08-27','14:00:00',4.99),('8537','2013-08-27','14:05:00',2.98),('8537','2013-08-27','14:10:00',2.28),('8537','2013-08-27','14:15:00',3.7),('8537','2013-08-27','14:20:00',2.8),('8537','2013-08-27','14:25:00',1.59),('8537','2013-08-27','14:30:00',1.28),('8537','2013-08-27','14:35:00',1.31),('8537','2013-08-27','14:40:00',1.4),('8537','2013-08-27','14:45:00',1.48),('8537','2013-08-27','14:50:00',1.16),('8537','2013-08-27','15:55:00',1.26),('8537','2013-08-27','16:00:00',1.6),('8537','2013-08-27','16:05:00',1.66),('8537','2013-08-27','16:10:00',3.51),('8537','2013-08-27','16:15:00',3.07),('8537','2013-08-27','16:20:00',2.04),('8537','2013-08-27','16:25:00',1.95),('8537','2013-08-27','16:30:00',1.2),('8537','2013-08-27','16:35:00',1.32),('8537','2013-08-27','16:40:00',1.41),('8537','2013-08-27','16:45:00',1.12),('8537','2013-08-27','16:50:00',1.52),('8537','2013-08-27','16:55:00',1.17),('8537','2013-08-27','17:05:00',1.06),('8537','2013-08-27','17:10:00',2.62),('8537','2013-08-27','17:15:00',1.5),('8537','2013-08-27','17:20:00',1.03),('8537','2013-08-27','17:45:00',1.23),('8537','2013-08-27','17:50:00',1.27),('8537','2013-08-27','17:55:00',1.36),('8537','2013-08-27','18:00:00',1.07),('8537','2013-08-26','08:05:00',1.54),('8537','2013-08-26','08:10:00',1.53),('8537','2013-08-26','08:20:00',1.78),('8537','2013-08-26','08:25:00',1.55),('8537','2013-08-26','08:30:00',1.84),('8537','2013-08-26','08:35:00',1.4),('8537','2013-08-26','08:40:00',1.91),('8537','2013-08-26','08:45:00',2.03),('8537','2013-08-26','08:50:00',2.13),('8537','2013-08-26','08:55:00',2.24),('8537','2013-08-26','09:00:00',2.33),('8537','2013-08-26','09:05:00',2.41),('8537','2013-08-26','09:10:00',2.48),('8537','2013-08-26','09:15:00',2.6),('8537','2013-08-26','09:20:00',2.7),('8537','2013-08-26','09:25:00',2.78),('8537','2013-08-26','09:30:00',2.88),('8537','2013-08-26','09:35:00',2.93),('8537','2013-08-26','09:40:00',3.02),('8537','2013-08-26','09:45:00',3.1),('8537','2013-08-26','09:50:00',3.18),('8537','2013-08-26','09:55:00',3.22),('8537','2013-08-26','10:00:00',3.31),('8537','2013-08-26','10:05:00',3.4),('8537','2013-08-26','10:10:00',3.44),('8537','2013-08-26','10:15:00',3.52),('8537','2013-08-26','10:20:00',3.57),('8537','2013-08-26','10:25:00',3.68),('8537','2013-08-26','10:30:00',3.74),('8537','2013-08-26','10:35:00',3.76),('8537','2013-08-26','10:40:00',3.86),('8537','2013-08-26','10:45:00',3.94),('8537','2013-08-26','10:50:00',3.97),('8537','2013-08-26','10:55:00',4.03),('8537','2013-08-26','11:00:00',4.07),('8537','2013-08-26','11:05:00',4.09),('8537','2013-08-26','11:10:00',4.07),('8537','2013-08-26','11:15:00',4.16),('8537','2013-08-26','11:20:00',4.23),('8537','2013-08-26','11:25:00',4.25),('8537','2013-08-26','11:30:00',4.32),('8537','2013-08-26','11:35:00',4.39),('8537','2013-08-26','11:40:00',4.39),('8537','2013-08-26','11:45:00',4.39),('8537','2013-08-26','11:50:00',3.35),('8537','2013-08-26','11:55:00',4.48),('8537','2013-08-26','12:00:00',4.51),('8537','2013-08-26','12:05:00',4.59),('8537','2013-08-26','12:10:00',4.62),('8537','2013-08-26','12:15:00',4.61),('8537','2013-08-26','12:20:00',4.58),('8537','2013-08-26','12:25:00',4.55),('8537','2013-08-26','12:30:00',4.55),('8537','2013-08-26','12:35:00',4.56),('8537','2013-08-26','12:40:00',4.57),('8537','2013-08-26','12:45:00',4.61),('8537','2013-08-26','12:50:00',4.63),('8537','2013-08-26','12:55:00',4.63),('8537','2013-08-26','13:00:00',4.82),('8537','2013-08-26','13:05:00',5.28),('8537','2013-08-26','13:10:00',5.07),('8537','2013-08-26','13:15:00',3.22),('8537','2013-08-26','13:20:00',3.1),('8537','2013-08-26','13:25:00',3.19),('8537','2013-08-26','13:30:00',3.28),('8537','2013-08-26','13:35:00',4.49),('8537','2013-08-26','13:40:00',4.6),('8537','2013-08-26','13:45:00',4.65),('8537','2013-08-26','13:50:00',4.71),('8537','2013-08-26','13:55:00',3.74),('8537','2013-08-26','14:00:00',3.15),('8537','2013-08-26','14:05:00',4.2),('8537','2013-08-26','14:10:00',2.86),('8537','2013-08-26','14:15:00',4.53),('8537','2013-08-26','14:20:00',4.46),('8537','2013-08-26','14:25:00',4.39),('8537','2013-08-26','14:30:00',4.39),('8537','2013-08-26','14:35:00',4.05),('8537','2013-08-26','14:40:00',3.73),('8537','2013-08-26','14:45:00',2.91),('8537','2013-08-26','14:50:00',2.51),('8537','2013-08-26','14:55:00',2.31),('8537','2013-08-26','15:00:00',2.19),('8537','2013-08-26','15:05:00',1.62),('8537','2013-08-26','15:10:00',1.26),('8537','2013-08-26','15:15:00',1.1),('8537','2013-08-26','15:35:00',1.15),('8537','2013-08-26','15:40:00',1.78),('8537','2013-08-26','15:45:00',1.92),('8537','2013-08-26','15:50:00',1.82),('8537','2013-08-26','15:55:00',1.71),('8537','2013-08-26','16:00:00',2.64),('8537','2013-08-26','16:05:00',3.69),('8537','2013-08-26','16:10:00',3.09),('8537','2013-08-26','16:15:00',3.05),('8537','2013-08-26','16:20:00',2.98),('8537','2013-08-26','16:25:00',2.88),('8537','2013-08-26','16:30:00',2.81),('8537','2013-08-26','16:35:00',2.74),('8537','2013-08-26','16:40:00',2.66),('8537','2013-08-26','16:45:00',2.58),('8537','2013-08-26','16:50:00',2.39),('8537','2013-08-26','16:55:00',2.32),('8537','2013-08-26','17:00:00',2.28),('8537','2013-08-26','17:05:00',1.99),('8537','2013-08-26','17:10:00',2.02),('8537','2013-08-26','17:15:00',1.92),('8537','2013-08-26','17:20:00',1.44),('8537','2013-08-26','17:30:00',1.28),('8537','2013-08-26','17:35:00',1.05),('8537','2013-08-26','17:40:00',1.06),('8537','2013-08-26','17:45:00',1.17),('8537','2013-08-26','17:50:00',1.3),('8537','2013-08-26','17:55:00',1.27),('8537','2013-08-26','18:00:00',1.14),('8537','2013-08-26','18:05:00',1),('8537','2013-08-25','08:00:00',1.06),('8537','2013-08-25','08:05:00',1.2),('8537','2013-08-25','08:10:00',1.43),('8537','2013-08-25','08:15:00',1.43),('8537','2013-08-25','08:20:00',1.32),('8537','2013-08-25','08:25:00',1.41),('8537','2013-08-25','08:30:00',1.11),('8537','2013-08-25','08:35:00',1.03),('8537','2013-08-25','08:40:00',1.46),('8537','2013-08-25','08:45:00',1.75),('8537','2013-08-25','09:10:00',1),('8537','2013-08-25','09:15:00',1.24),('8537','2013-08-25','09:20:00',2.52),('8537','2013-08-25','09:25:00',2.49),('8537','2013-08-25','09:30:00',2.2),('8537','2013-08-25','09:35:00',2.25),('8537','2013-08-25','09:40:00',3.5),('8537','2013-08-25','09:45:00',3.72),('8537','2013-08-25','09:50:00',3.51),('8537','2013-08-25','09:55:00',3.82),('8537','2013-08-25','10:00:00',2.75),('8537','2013-08-25','10:05:00',1.97),('8537','2013-08-25','10:10:00',1.16),('8537','2013-08-25','15:05:00',1.02),('8537','2013-08-25','15:10:00',1.12),('8537','2013-08-25','15:15:00',1.32),('8537','2013-08-25','15:20:00',1.6),('8537','2013-08-25','15:25:00',1.77),('8537','2013-08-25','15:30:00',2.34),('8537','2013-08-25','15:35:00',3.04),('8537','2013-08-25','15:40:00',3.15),('8537','2013-08-25','15:45:00',4.15),('8537','2013-08-25','15:50:00',3.11),('8537','2013-08-25','15:55:00',2.66),('8537','2013-08-25','16:00:00',3.84),('8537','2013-08-25','16:05:00',3.61),('8537','2013-08-25','16:10:00',3.26),('8537','2013-08-25','16:15:00',3.3),('8537','2013-08-25','16:20:00',3.19),('8537','2013-08-25','16:25:00',3.15),('8537','2013-08-25','16:30:00',3.05),('8537','2013-08-25','16:35:00',2.93),('8537','2013-08-25','16:40:00',2.26),('8537','2013-08-25','16:45:00',1.45),('8537','2013-08-25','16:50:00',1.79),('8537','2013-08-25','16:55:00',1.49),('8537','2013-08-25','17:00:00',2.57),('8537','2013-08-25','17:05:00',2.4),('8537','2013-08-25','17:10:00',2.23),('8537','2013-08-25','17:15:00',2.08),('8537','2013-08-25','17:20:00',1.98),('8537','2013-08-25','17:25:00',1.86),('8537','2013-08-25','17:30:00',1.75),('8537','2013-08-25','17:35:00',1.48),('8537','2013-08-25','17:40:00',1.25),('8537','2013-08-25','17:45:00',1.45),('8537','2013-08-25','17:50:00',1.3),('8537','2013-08-25','17:55:00',1.11),('8537','2013-08-24','08:25:00',1.5),('8537','2013-08-24','08:30:00',1.51),('8537','2013-08-24','08:35:00',1.76),('8537','2013-08-24','08:40:00',1.87),('8537','2013-08-24','08:45:00',1.93),('8537','2013-08-24','08:50:00',1.6),('8537','2013-08-24','08:55:00',2.21),('8537','2013-08-24','09:00:00',2.31),('8537','2013-08-24','09:05:00',2.46),('8537','2013-08-24','09:10:00',2.69),('8537','2013-08-24','09:15:00',2.66),('8537','2013-08-24','09:20:00',2.73),('8537','2013-08-24','09:25:00',2.25),('8537','2013-08-24','09:30:00',2.26),('8537','2013-08-24','09:35:00',3.06),('8537','2013-08-24','09:40:00',2.99),('8537','2013-08-24','09:45:00',3.02),('8537','2013-08-24','09:50:00',2.7),('8537','2013-08-24','09:55:00',1.85),('8537','2013-08-24','10:00:00',2.27),('8537','2013-08-24','10:05:00',3.08),('8537','2013-08-24','10:10:00',3.51),('8537','2013-08-24','10:15:00',3.55),('8537','2013-08-24','10:20:00',3.61),('8537','2013-08-24','10:25:00',3.64),('8537','2013-08-24','10:30:00',3.7),('8537','2013-08-24','10:35:00',3.77),('8537','2013-08-24','10:40:00',3.84),('8537','2013-08-24','10:45:00',3.86),('8537','2013-08-24','10:50:00',3.82),('8537','2013-08-24','10:55:00',4.08),('8537','2013-08-24','11:00:00',4.08),('8537','2013-08-24','11:05:00',4.13),('8537','2013-08-24','11:10:00',4.24),('8537','2013-08-24','11:15:00',4.2),('8537','2013-08-24','11:20:00',4.19),('8537','2013-08-24','11:25:00',4.24),('8537','2013-08-24','11:30:00',4.27),('8537','2013-08-24','11:35:00',4.32),('8537','2013-08-24','11:40:00',4.35),('8537','2013-08-24','11:45:00',4.38),('8537','2013-08-24','11:50:00',4.43),('8537','2013-08-24','11:55:00',4.4),('8537','2013-08-24','12:00:00',4.47),('8537','2013-08-24','12:05:00',4.51),('8537','2013-08-24','12:10:00',4.54),('8537','2013-08-24','12:15:00',4.56),('8537','2013-08-24','12:20:00',4.58),('8537','2013-08-24','12:25:00',4.59),('8537','2013-08-24','12:30:00',4.59),('8537','2013-08-24','12:35:00',4.64),('8537','2013-08-24','12:40:00',4.64),('8537','2013-08-24','12:45:00',4.63),('8537','2013-08-24','12:50:00',4.64),('8537','2013-08-24','12:55:00',4.61),('8537','2013-08-24','13:00:00',4.57),('8537','2013-08-24','13:05:00',4.57),('8537','2013-08-24','13:10:00',4.6),('8537','2013-08-24','13:15:00',4.63),('8537','2013-08-24','13:20:00',4.68),('8537','2013-08-24','13:25:00',4.58),('8537','2013-08-24','13:30:00',4.67),('8537','2013-08-24','13:35:00',4.68),('8537','2013-08-24','13:40:00',4.65),('8537','2013-08-24','13:45:00',4.62),('8537','2013-08-24','13:50:00',4.61),('8537','2013-08-24','13:55:00',4.57),('8537','2013-08-24','14:00:00',4.55),('8537','2013-08-24','14:05:00',4.54),('8537','2013-08-24','14:10:00',4.53),('8537','2013-08-24','14:15:00',4.49),('8537','2013-08-24','14:20:00',4.49),('8537','2013-08-24','14:25:00',4.45),('8537','2013-08-24','14:30:00',4.43),('8537','2013-08-24','14:35:00',4.28),('8537','2013-08-24','14:40:00',4.02),('8537','2013-08-24','14:45:00',4.22),('8537','2013-08-24','14:50:00',4.15),('8537','2013-08-24','14:55:00',4.14),('8537','2013-08-24','15:00:00',4.11),('8537','2013-08-24','15:05:00',4.07),('8537','2013-08-24','15:10:00',3.99),('8537','2013-08-24','15:15:00',3.98),('8537','2013-08-24','15:20:00',3.93),('8537','2013-08-24','15:25:00',3.87),('8537','2013-08-24','15:30:00',3.77),('8537','2013-08-24','15:35:00',3.7),('8537','2013-08-24','15:40:00',3.63),('8537','2013-08-24','15:45:00',3.55),('8537','2013-08-24','15:50:00',3.52),('8537','2013-08-24','15:55:00',3.45),('8537','2013-08-24','16:00:00',3.39),('8537','2013-08-24','16:05:00',3.33),('8537','2013-08-24','16:10:00',3.21),('8537','2013-08-24','16:15:00',3.15),('8537','2013-08-24','16:20:00',3.08),('8537','2013-08-24','16:25:00',3),('8537','2013-08-24','16:30:00',2.89),('8537','2013-08-24','16:35:00',2.82),('8537','2013-08-24','16:40:00',2.73),('8537','2013-08-24','16:45:00',2.52),('8537','2013-08-24','16:50:00',2.04),('8537','2013-08-24','16:55:00',2.09),('8537','2013-08-24','17:00:00',2.36),('8537','2013-08-24','17:05:00',2.23),('8537','2013-08-24','17:10:00',2.11),('8537','2013-08-24','17:15:00',2.06),('8537','2013-08-24','17:20:00',1.97),('8537','2013-08-24','17:25:00',1.86),('8537','2013-08-24','17:30:00',1.75),('8537','2013-08-24','17:35:00',1.63),('8537','2013-08-24','17:40:00',1.53),('8537','2013-08-24','17:45:00',1.43),('8537','2013-08-24','17:50:00',1.34),('8537','2013-08-24','17:55:00',1.24),('8537','2013-08-24','18:00:00',1.14),('8537','2013-08-24','18:05:00',1.05),('8537','2013-08-23','08:05:00',1.04),('8537','2013-08-23','08:10:00',1.13),('8537','2013-08-23','08:15:00',1.23),('8537','2013-08-23','08:20:00',1.34),('8537','2013-08-23','08:25:00',1.44),('8537','2013-08-23','08:30:00',1.55),('8537','2013-08-23','08:35:00',1.62),('8537','2013-08-23','08:40:00',1.67),('8537','2013-08-23','08:45:00',1.82),('8537','2013-08-23','08:50:00',1.89),('8537','2013-08-23','08:55:00',1.96),('8537','2013-08-23','09:00:00',2.04),('8537','2013-08-23','09:05:00',2.14),('8537','2013-08-23','09:10:00',2.19),('8537','2013-08-23','09:15:00',2.35),('8537','2013-08-23','09:20:00',2.44),('8537','2013-08-23','09:25:00',2.52),('8537','2013-08-23','09:30:00',2.61),('8537','2013-08-23','09:35:00',2.66),('8537','2013-08-23','09:40:00',2.69),('8537','2013-08-23','09:45:00',2.79),('8537','2013-08-23','09:50:00',2.9),('8537','2013-08-23','09:55:00',2.98),('8537','2013-08-23','10:00:00',3.04),('8537','2013-08-23','10:05:00',3.11),('8537','2013-08-23','10:10:00',3.15),('8537','2013-08-23','10:15:00',3.24),('8537','2013-08-23','10:20:00',3.3),('8537','2013-08-23','10:25:00',3.37),('8537','2013-08-23','10:30:00',3.41),('8537','2013-08-23','10:35:00',3.43),('8537','2013-08-23','10:40:00',3.53),('8537','2013-08-23','10:45:00',3.47),('8537','2013-08-23','10:50:00',3.62),('8537','2013-08-23','10:55:00',3.56),('8537','2013-08-23','11:00:00',3.81),('8537','2013-08-23','11:05:00',3.94),('8537','2013-08-23','11:10:00',3.48),('8537','2013-08-23','11:15:00',3.21),('8537','2013-08-23','11:20:00',3.18),('8537','2013-08-23','11:25:00',4.05),('8537','2013-08-23','11:30:00',3.49),('8537','2013-08-23','11:35:00',4.01),('8537','2013-08-23','11:40:00',4.09),('8537','2013-08-23','11:45:00',4.31),('8537','2013-08-23','11:50:00',4.21),('8537','2013-08-23','11:55:00',4.21),('8537','2013-08-23','12:00:00',3.65),('8537','2013-08-23','12:05:00',2.42),('8537','2013-08-23','12:10:00',1.77),('8537','2013-08-23','12:15:00',4.21),('8537','2013-08-23','12:20:00',1.14),('8537','2013-08-23','12:25:00',1.09),('8537','2013-08-23','12:30:00',1.03),('8537','2013-08-23','12:35:00',1.4),('8537','2013-08-23','12:40:00',1.59),('8537','2013-08-23','12:45:00',1.23),('8537','2013-08-23','12:50:00',1.14),('8537','2013-08-23','12:55:00',1.05),('8537','2013-08-23','13:00:00',1.18),('8537','2013-08-23','13:05:00',1.55),('8537','2013-08-23','13:10:00',1.84),('8537','2013-08-23','13:15:00',3.35),('8537','2013-08-23','13:20:00',2.27),('8537','2013-08-23','13:25:00',4.69),('8537','2013-08-23','13:30:00',5.04),('8537','2013-08-23','13:35:00',4.76),('8537','2013-08-23','13:40:00',4.56),('8537','2013-08-23','13:45:00',4.6),('8537','2013-08-23','13:50:00',3.89),('8537','2013-08-23','13:55:00',4.37),('8537','2013-08-23','14:00:00',4.44),('8537','2013-08-23','14:05:00',4.77),('8537','2013-08-23','14:10:00',4.69),('8537','2013-08-23','14:15:00',4.64),('8537','2013-08-23','14:20:00',3.48),('8537','2013-08-23','14:25:00',3.53),('8537','2013-08-23','14:30:00',4.56),('8537','2013-08-23','14:35:00',4.23),('8537','2013-08-23','14:40:00',4.17),('8537','2013-08-23','14:45:00',4.25),('8537','2013-08-23','14:50:00',4.13),('8537','2013-08-23','14:55:00',4.03),('8537','2013-08-23','15:00:00',3.96),('8537','2013-08-23','15:05:00',3.71),('8537','2013-08-23','15:10:00',3.92),('8537','2013-08-23','15:15:00',3.85),('8537','2013-08-23','15:20:00',3.77),('8537','2013-08-23','15:25:00',3.81),('8537','2013-08-23','15:30:00',3.82),('8537','2013-08-23','15:35:00',3.47),('8537','2013-08-23','15:40:00',3.56),('8537','2013-08-23','15:45:00',3.56),('8537','2013-08-23','15:50:00',3.29),('8537','2013-08-23','15:55:00',3.45),('8537','2013-08-23','16:00:00',3.27),('8537','2013-08-23','16:05:00',3.08),('8537','2013-08-23','16:10:00',2.75),('8537','2013-08-23','16:15:00',2.84),('8537','2013-08-23','16:20:00',3.17),('8537','2013-08-23','16:25:00',3.05),('8537','2013-08-23','16:30:00',2.97),('8537','2013-08-23','16:35:00',2.93),('8537','2013-08-23','16:40:00',2.86),('8537','2013-08-23','16:45:00',2.71),('8537','2013-08-23','16:50:00',2.28),('8537','2013-08-23','16:55:00',1.83),('8537','2013-08-23','17:00:00',2.38),('8537','2013-08-23','17:05:00',2.23),('8537','2013-08-23','17:10:00',2.07),('8537','2013-08-23','17:15:00',2),('8537','2013-08-23','17:20:00',1.9),('8537','2013-08-23','17:25:00',1.82),('8537','2013-08-23','17:30:00',1.68),('8537','2013-08-23','17:35:00',1.59),('8537','2013-08-23','17:40:00',1.46),('8537','2013-08-23','17:45:00',1.39),('8537','2013-08-23','17:50:00',1.31),('8537','2013-08-23','17:55:00',1.22),('8537','2013-08-23','18:00:00',1.11),('8537','2013-08-23','18:05:00',1.02),('8537','2013-08-22','08:00:00',1.04),('8537','2013-08-22','08:05:00',1.11),('8537','2013-08-22','08:10:00',1.23),('8537','2013-08-22','08:15:00',1.3),('8537','2013-08-22','08:20:00',1.38),('8537','2013-08-22','08:25:00',1.49),('8537','2013-08-22','08:30:00',1.6),('8537','2013-08-22','08:35:00',1.71),('8537','2013-08-22','08:40:00',1.78),('8537','2013-08-22','08:45:00',1.92),('8537','2013-08-22','08:50:00',2.02),('8537','2013-08-22','08:55:00',2.14),('8537','2013-08-22','09:00:00',2.19),('8537','2013-08-22','09:05:00',2.42),('8537','2013-08-22','09:10:00',2.58),('8537','2013-08-22','09:15:00',2.72),('8537','2013-08-22','09:20:00',2.87),('8537','2013-08-22','09:25:00',2.87),('8537','2013-08-22','09:30:00',2.4),('8537','2013-08-22','09:35:00',1.58),('8537','2013-08-22','09:40:00',1.71),('8537','2013-08-22','09:45:00',2.26),('8537','2013-08-22','09:50:00',3.09),('8537','2013-08-22','09:55:00',2.48),('8537','2013-08-22','10:00:00',3.48),('8537','2013-08-22','10:05:00',3.53),('8537','2013-08-22','10:10:00',3.55),('8537','2013-08-22','10:15:00',3.55),('8537','2013-08-22','10:20:00',3.55),('8537','2013-08-22','10:25:00',3.62),('8537','2013-08-22','10:30:00',3.72),('8537','2013-08-22','10:35:00',3.73),('8537','2013-08-22','10:40:00',3.8),('8537','2013-08-22','10:45:00',3.84),('8537','2013-08-22','10:50:00',3.89),('8537','2013-08-22','10:55:00',3.93),('8537','2013-08-22','11:00:00',4),('8537','2013-08-22','11:05:00',4.01),('8537','2013-08-22','11:10:00',4.06),('8537','2013-08-22','11:15:00',4.12),('8537','2013-08-22','11:20:00',4.09),('8537','2013-08-22','11:25:00',4.11),('8537','2013-08-22','11:30:00',4.2),('8537','2013-08-22','11:35:00',4.24),('8537','2013-08-22','11:40:00',4.29),('8537','2013-08-22','11:45:00',4.28),('8537','2013-08-22','11:50:00',4.32),('8537','2013-08-22','11:55:00',4.37),('8537','2013-08-22','12:00:00',4.44),('8537','2013-08-22','12:05:00',4.46),('8537','2013-08-22','12:10:00',4.47),('8537','2013-08-22','12:15:00',4.49),('8537','2013-08-22','12:20:00',4.5),('8537','2013-08-22','12:25:00',4.5),('8537','2013-08-22','12:30:00',4.5),('8537','2013-08-22','12:35:00',4.51),('8537','2013-08-22','12:40:00',4.52),('8537','2013-08-22','12:45:00',4.54),('8537','2013-08-22','12:50:00',4.56),('8537','2013-08-22','12:55:00',4.59),('8537','2013-08-22','13:00:00',4.55),('8537','2013-08-22','13:05:00',4.35),('8537','2013-08-22','13:10:00',4.37),('8537','2013-08-22','13:15:00',4.34),('8537','2013-08-22','13:20:00',4.4),('8537','2013-08-22','13:25:00',4.4),('8537','2013-08-22','13:30:00',4.45),('8537','2013-08-22','13:35:00',4.41),('8537','2013-08-22','13:40:00',4.44),('8537','2013-08-22','13:45:00',4.46),('8537','2013-08-22','13:50:00',4.43),('8537','2013-08-22','13:55:00',4.42),('8537','2013-08-22','14:00:00',4.4),('8537','2013-08-22','14:05:00',4.39),('8537','2013-08-22','14:10:00',4.38),('8537','2013-08-22','14:15:00',4.36),('8537','2013-08-22','14:20:00',4.36),('8537','2013-08-22','14:25:00',4.3),('8537','2013-08-22','14:30:00',4.3),('8537','2013-08-22','14:35:00',4.11),('8537','2013-08-22','14:40:00',4.07),('8537','2013-08-22','14:45:00',4.13),('8537','2013-08-22','14:50:00',4.07),('8537','2013-08-22','14:55:00',4.05),('8537','2013-08-22','15:00:00',4.01),('8537','2013-08-22','15:05:00',3.96),('8537','2013-08-22','15:10:00',3.92),('8537','2013-08-22','15:15:00',3.85),('8537','2013-08-22','15:20:00',3.78),('8537','2013-08-22','15:25:00',3.72),('8537','2013-08-22','15:30:00',3.6),('8537','2013-08-22','15:35:00',3.31),('8537','2013-08-22','15:40:00',3.16),('8537','2013-08-22','15:45:00',3.47),('8537','2013-08-22','15:50:00',3.42),('8537','2013-08-22','15:55:00',3.34),('8537','2013-08-22','16:00:00',3.25),('8537','2013-08-22','16:05:00',3.14),('8537','2013-08-22','16:10:00',3),('8537','2013-08-22','16:15:00',3),('8537','2013-08-22','16:20:00',2.93),('8537','2013-08-22','16:25:00',2.86),('8537','2013-08-22','16:30:00',2.8),('8537','2013-08-22','16:35:00',2.7),('8537','2013-08-22','16:40:00',2.62),('8537','2013-08-22','16:45:00',2.49),('8537','2013-08-22','16:50:00',2.2),('8537','2013-08-22','16:55:00',1.94),('8537','2013-08-22','17:00:00',2.22),('8537','2013-08-22','17:05:00',2.13),('8537','2013-08-22','17:10:00',1.97),('8537','2013-08-22','17:15:00',1.89),('8537','2013-08-22','17:20:00',1.82),('8537','2013-08-22','17:25:00',1.72),('8537','2013-08-22','17:30:00',1.63),('8537','2013-08-22','17:35:00',1.55),('8537','2013-08-22','17:40:00',1.42),('8537','2013-08-22','17:45:00',1.34),('8537','2013-08-22','17:50:00',1.24),('8537','2013-08-22','17:55:00',1.18),('8537','2013-08-22','18:00:00',1.1),('8537','2013-08-22','18:05:00',1.02),('8537','2013-08-21','09:00:00',1.08),('8537','2013-08-21','09:05:00',1.66),('8537','2013-08-21','09:10:00',1.56),('8537','2013-08-21','09:15:00',2.89),('8537','2013-08-21','09:20:00',2.86),('8537','2013-08-21','09:25:00',1.49),('8537','2013-08-21','09:35:00',1.16),('8537','2013-08-21','09:40:00',1.32),('8537','2013-08-21','09:45:00',1.51),('8537','2013-08-21','09:50:00',3.52),('8537','2013-08-21','09:55:00',4.12),('8537','2013-08-21','10:00:00',3.94),('8537','2013-08-21','10:05:00',3.15),('8537','2013-08-21','10:10:00',2.86),('8537','2013-08-21','10:15:00',1.72),('8537','2013-08-21','10:20:00',2.33),('8537','2013-08-21','10:25:00',2.06),('8537','2013-08-21','10:30:00',2.77),('8537','2013-08-21','10:35:00',4.03),('8537','2013-08-21','10:40:00',3.24),('8537','2013-08-21','10:45:00',2.66),('8537','2013-08-21','10:50:00',2.55),('8537','2013-08-21','10:55:00',2.08),('8537','2013-08-21','11:00:00',2.67),('8537','2013-08-21','11:05:00',2.21),('8537','2013-08-21','11:10:00',2.07),('8537','2013-08-21','11:15:00',2.66),('8537','2013-08-21','11:20:00',4.03),('8537','2013-08-21','11:25:00',2.88),('8537','2013-08-21','11:30:00',3.28),('8537','2013-08-21','11:35:00',4.85),('8537','2013-08-21','11:40:00',4.83),('8537','2013-08-21','11:45:00',4.77),('8537','2013-08-21','11:50:00',3.89),('8537','2013-08-21','11:55:00',4.46),('8537','2013-08-21','12:00:00',4.83),('8537','2013-08-21','12:05:00',4.79),('8537','2013-08-21','12:10:00',4.81),('8537','2013-08-21','12:15:00',4.86),('8537','2013-08-21','12:20:00',4.37),('8537','2013-08-21','12:25:00',3.49),('8537','2013-08-21','12:30:00',3.64),('8537','2013-08-21','12:35:00',3.05),('8537','2013-08-21','12:40:00',4.12),('8537','2013-08-21','12:45:00',4.59),('8537','2013-08-21','12:50:00',4.48),('8537','2013-08-21','12:55:00',4.31),('8537','2013-08-21','13:00:00',4.54),('8537','2013-08-21','13:05:00',4.63),('8537','2013-08-21','13:10:00',4.66),('8537','2013-08-21','13:15:00',4.76),('8537','2013-08-21','13:20:00',4.73),('8537','2013-08-21','13:25:00',4.78),('8537','2013-08-21','13:30:00',4.77),('8537','2013-08-21','13:35:00',4.65),('8537','2013-08-21','13:40:00',4.45),('8537','2013-08-21','13:45:00',4.15),('8537','2013-08-21','13:50:00',4.5),('8537','2013-08-21','13:55:00',4.51),('8537','2013-08-21','14:00:00',4.26),('8537','2013-08-21','14:05:00',4.56),('8537','2013-08-21','14:10:00',4.55),('8537','2013-08-21','14:15:00',4.4),('8537','2013-08-21','14:20:00',3.54),('8537','2013-08-21','14:25:00',3.12),('8537','2013-08-21','14:30:00',4.06),('8537','2013-08-21','14:35:00',3.95),('8537','2013-08-21','14:40:00',4),('8537','2013-08-21','14:45:00',4.02),('8537','2013-08-21','14:50:00',3.81),('8537','2013-08-21','14:55:00',3.87),('8537','2013-08-21','15:00:00',3.97),('8537','2013-08-21','15:05:00',3.96),('8537','2013-08-21','15:10:00',3.81),('8537','2013-08-21','15:15:00',3.77),('8537','2013-08-21','15:20:00',3.67),('8537','2013-08-21','15:25:00',3.6),('8537','2013-08-21','15:30:00',3.44),('8537','2013-08-21','15:35:00',3.22),('8537','2013-08-21','15:40:00',3.16),('8537','2013-08-21','15:45:00',3.19),('8537','2013-08-21','15:50:00',3.26),('8537','2013-08-21','15:55:00',3.1),('8537','2013-08-21','16:00:00',2.88),('8537','2013-08-21','16:05:00',2.76),('8537','2013-08-21','16:10:00',2.7),('8537','2013-08-21','16:15:00',2.6),('8537','2013-08-21','16:20:00',2.48),('8537','2013-08-21','16:25:00',2.81),('8537','2013-08-21','16:30:00',2.94),('8537','2013-08-21','16:35:00',2.87),('8537','2013-08-21','16:40:00',2.76),('8537','2013-08-21','16:45:00',2.67),('8537','2013-08-21','16:50:00',2.46),('8537','2013-08-21','16:55:00',2.36),('8537','2013-08-21','17:00:00',2.41),('8537','2013-08-21','17:05:00',2.35),('8537','2013-08-21','17:10:00',2.19),('8537','2013-08-21','17:15:00',2.18),('8537','2013-08-21','17:20:00',2.14),('8537','2013-08-21','17:25:00',2.05),('8537','2013-08-21','17:30:00',1.92),('8537','2013-08-21','17:35:00',1.84),('8537','2013-08-21','17:40:00',1.73),('8537','2013-08-21','17:45:00',1.66),('8537','2013-08-21','17:50:00',1.61),('8537','2013-08-21','17:55:00',1.52),('8537','2013-08-21','18:00:00',1.42),('8537','2013-08-21','18:05:00',1.32),('8537','2013-08-21','18:10:00',1.21),('8537','2013-08-21','18:15:00',1.12),('8537','2013-08-20','07:55:00',1.18),('8537','2013-08-20','08:00:00',1.13),('8537','2013-08-20','08:50:00',1.13),('8537','2013-08-20','08:55:00',1.3),('8537','2013-08-20','09:00:00',1.22),('8537','2013-08-20','09:05:00',1.28),('8537','2013-08-20','09:10:00',1.3),('8537','2013-08-20','09:15:00',1.31),('8537','2013-08-20','09:20:00',1.3),('8537','2013-08-20','09:25:00',2.14),('8537','2013-08-20','09:30:00',2.75),('8537','2013-08-20','09:35:00',2.93),('8537','2013-08-20','09:40:00',2.94),('8537','2013-08-20','09:45:00',2.88),('8537','2013-08-20','09:50:00',2.81),('8537','2013-08-20','09:55:00',2.71),('8537','2013-08-20','10:00:00',2.79),('8537','2013-08-20','10:05:00',1.31),('8537','2013-08-20','10:10:00',2.55),('8537','2013-08-20','10:15:00',3.12),('8537','2013-08-20','10:20:00',4.12),('8537','2013-08-20','10:25:00',1.6),('8537','2013-08-20','10:30:00',1.16),('8537','2013-08-20','10:35:00',1.14),('8537','2013-08-20','10:40:00',1.17),('8537','2013-08-20','10:45:00',1.21),('8537','2013-08-20','10:50:00',2.6),('8537','2013-08-20','10:55:00',2.42),('8537','2013-08-20','11:00:00',1.07),('8537','2013-08-20','11:15:00',3.26),('8537','2013-08-20','11:20:00',4.66),('8537','2013-08-20','11:25:00',4.33),('8537','2013-08-20','11:30:00',1.28),('8537','2013-08-20','11:35:00',2.29),('8537','2013-08-20','11:40:00',4.71),('8537','2013-08-20','11:45:00',4.93),('8537','2013-08-20','11:50:00',5.21),('8537','2013-08-20','11:55:00',4.19),('8537','2013-08-20','12:00:00',1.89),('8537','2013-08-20','12:05:00',1.77),('8537','2013-08-20','12:10:00',1.88),('8537','2013-08-20','12:15:00',1.02),('8537','2013-08-20','12:20:00',1.07),('8537','2013-08-20','12:25:00',1.24),('8537','2013-08-20','12:30:00',1.5),('8537','2013-08-20','12:35:00',1.67),('8537','2013-08-20','12:40:00',1.99),('8537','2013-08-20','12:45:00',2),('8537','2013-08-20','12:50:00',2.08),('8537','2013-08-20','12:55:00',2.12),('8537','2013-08-20','13:00:00',2.05),('8537','2013-08-20','13:05:00',1.91),('8537','2013-08-20','13:10:00',1.85),('8537','2013-08-20','13:15:00',1.92),('8537','2013-08-20','13:20:00',1.99),('8537','2013-08-20','13:25:00',2.09),('8537','2013-08-20','13:30:00',2.25),('8537','2013-08-20','13:35:00',2.86),('8537','2013-08-20','13:40:00',4.64),('8537','2013-08-20','13:45:00',4.26),('8537','2013-08-20','13:50:00',4.81),('8537','2013-08-20','13:55:00',4.88),('8537','2013-08-20','14:00:00',4.78),('8537','2013-08-20','14:05:00',4.76),('8537','2013-08-20','14:10:00',4.73),('8537','2013-08-20','14:15:00',4.6),('8537','2013-08-20','14:20:00',4.61),('8537','2013-08-20','14:25:00',4.38),('8537','2013-08-20','14:30:00',3.82),('8537','2013-08-20','14:35:00',4.54),('8537','2013-08-20','14:40:00',4.77),('8537','2013-08-20','14:45:00',4.13),('8537','2013-08-20','14:50:00',4.57),('8537','2013-08-20','14:55:00',3.64),('8537','2013-08-20','15:00:00',4),('8537','2013-08-20','15:05:00',4.51),('8537','2013-08-20','15:10:00',4.45),('8537','2013-08-20','15:15:00',4.31),('8537','2013-08-20','15:20:00',4.31),('8537','2013-08-20','15:25:00',4.28),('8537','2013-08-20','15:30:00',4.18),('8537','2013-08-20','15:35:00',4.01),('8537','2013-08-20','15:40:00',4.2),('8537','2013-08-20','15:45:00',4.37),('8537','2013-08-20','15:50:00',4.1),('8537','2013-08-20','15:55:00',4.54),('8537','2013-08-20','16:00:00',4.19),('8537','2013-08-20','16:05:00',4.17),('8537','2013-08-20','16:10:00',4.09),('8537','2013-08-20','16:15:00',3.99),('8537','2013-08-20','16:20:00',3.9),('8537','2013-08-20','16:25:00',3.73),('8537','2013-08-20','16:30:00',3.39),('8537','2013-08-20','16:35:00',3.5),('8537','2013-08-20','16:40:00',3.57),('8537','2013-08-20','16:45:00',3.42),('8537','2013-08-20','16:50:00',3.02),('8537','2013-08-20','16:55:00',2.93),('8537','2013-08-20','17:00:00',2.71),('8537','2013-08-20','17:05:00',2.55),('8537','2013-08-20','17:10:00',2.31),('8537','2013-08-20','17:15:00',2.14),('8537','2013-08-20','17:20:00',2.15),('8537','2013-08-20','17:25:00',2.04),('8537','2013-08-20','17:30:00',1.94),('8537','2013-08-20','17:35:00',1.84),('8537','2013-08-20','17:40:00',1.68),('8537','2013-08-20','17:45:00',1.65),('8537','2013-08-20','17:50:00',1.49),('8537','2013-08-20','17:55:00',1.34),('8537','2013-08-20','18:00:00',1.16),('8537','2013-08-20','18:05:00',1.19),('8537','2013-08-20','18:10:00',1.19),('8537','2013-08-20','18:15:00',1.18),('8537','2013-08-20','18:20:00',1.11),('8537','2013-08-20','18:25:00',1.04),('8537','2014-04-10','07:55:00',1.04),('8537','2014-04-10','08:00:00',1.15),('8537','2014-04-10','08:05:00',1.29),('8537','2014-04-10','08:10:00',1.41),('8537','2014-04-10','08:15:00',1.54),('8537','2014-04-10','08:20:00',1.66),('8537','2014-04-10','08:25:00',1.79),('8537','2014-04-10','08:30:00',1.91),('8537','2014-04-10','08:35:00',2.04),('8537','2014-04-10','08:40:00',2.17),('8537','2014-04-10','08:45:00',2.29),('8537','2014-04-10','08:50:00',2.4),('8537','2014-04-10','08:55:00',2.5),('8537','2014-04-10','09:00:00',2.58),('8537','2014-04-10','09:05:00',2.72),('8537','2014-04-10','09:10:00',2.82),('8537','2014-04-10','09:15:00',2.86),('8537','2014-04-10','09:20:00',2.89),('8537','2014-04-10','09:25:00',3.11),('8537','2014-04-10','09:30:00',3.23),('8537','2014-04-10','09:35:00',3.31),('8537','2014-04-10','09:40:00',3.39),('8537','2014-04-10','09:45:00',3.49),('8537','2014-04-10','09:50:00',3.61),('8537','2014-04-10','09:55:00',3.69),('8537','2014-04-10','10:00:00',3.75),('8537','2014-04-10','10:05:00',3.8),('8537','2014-04-10','10:10:00',3.93),('8537','2014-04-10','10:15:00',3.93),('8537','2014-04-10','10:20:00',4.02),('8537','2014-04-10','10:25:00',4.08),('8537','2014-04-10','10:30:00',4.1),('8537','2014-04-10','10:35:00',4.3),('8537','2014-04-10','10:40:00',4.34),('8537','2014-04-10','10:45:00',4.37),('8537','2014-04-10','10:50:00',4.28),('8537','2014-04-10','10:55:00',4.4),('8537','2014-04-10','11:00:00',4.48),('8537','2014-04-10','11:05:00',4.61),('8537','2014-04-10','11:10:00',4.52),('8537','2014-04-10','11:15:00',4.7),('8537','2014-04-10','11:20:00',4.82),('8537','2014-04-10','11:25:00',4.89),('8537','2014-04-10','11:30:00',4.9),('8537','2014-04-10','11:35:00',4.98),('8537','2014-04-10','11:40:00',4.85),('8537','2014-04-10','11:45:00',4.96),('8537','2014-04-10','11:50:00',4.79),('8537','2014-04-10','11:55:00',5.03),('8537','2014-04-10','12:00:00',4.98),('8537','2014-04-10','12:05:00',4.66),('8537','2014-04-10','12:10:00',4.87),('8537','2014-04-10','12:15:00',4.97),('8537','2014-04-10','12:20:00',4.97),('8537','2014-04-10','12:25:00',4.82),('8537','2014-04-10','12:30:00',4.9),('8537','2014-04-10','12:35:00',5.13),('8537','2014-04-10','12:40:00',5.07),('8537','2014-04-10','12:45:00',5.13),('8537','2014-04-10','12:50:00',4.97),('8537','2014-04-10','12:55:00',4.86),('8537','2014-04-10','13:00:00',4.83),('8537','2014-04-10','13:05:00',4.69),('8537','2014-04-10','13:10:00',4.76),('8537','2014-04-10','13:15:00',4.81),('8537','2014-04-10','13:20:00',4.76),('8537','2014-04-10','13:25:00',5.1),('8537','2014-04-10','13:30:00',5),('8537','2014-04-10','13:35:00',5.08),('8537','2014-04-10','13:40:00',4.85),('8537','2014-04-10','13:45:00',5.13),('8537','2014-04-10','13:50:00',5.08),('8537','2014-04-10','13:55:00',5),('8537','2014-04-10','14:00:00',4.97),('8537','2014-04-10','14:05:00',4.93),('8537','2014-04-10','14:10:00',4.95),('8537','2014-04-10','14:15:00',4.92),('8537','2014-04-10','14:20:00',4.94),('8537','2014-04-10','14:25:00',4.92),('8537','2014-04-10','14:30:00',4.81),('8537','2014-04-10','14:35:00',4.7),('8537','2014-04-10','14:40:00',4.71),('8537','2014-04-10','14:45:00',4.31),('8537','2014-04-10','14:50:00',4.72),('8537','2014-04-10','14:55:00',4.6),('8537','2014-04-10','15:00:00',4.53),('8537','2014-04-10','15:05:00',4.49),('8537','2014-04-10','15:10:00',4.38),('8537','2014-04-10','15:15:00',4.35),('8537','2014-04-10','15:20:00',4.22),('8537','2014-04-10','15:25:00',3.92),('8537','2014-04-10','15:30:00',3.72),('8537','2014-04-10','15:35:00',3.76),('8537','2014-04-10','15:40:00',3.85),('8537','2014-04-10','15:45:00',3.78),('8537','2014-04-10','15:50:00',3.81),('8537','2014-04-10','15:55:00',3.73),('8537','2014-04-10','16:00:00',3.56),('8537','2014-04-10','16:05:00',3.51),('8537','2014-04-10','16:10:00',3.53),('8537','2014-04-10','16:15:00',3.6),('8537','2014-04-10','16:20:00',3.38),('8537','2014-04-10','16:25:00',3.41),('8537','2014-04-10','16:30:00',3.32),('8537','2014-04-10','16:35:00',3.23),('8537','2014-04-10','16:40:00',3.02),('8537','2014-04-10','16:45:00',2.61),('8537','2014-04-10','16:50:00',2.92),('8537','2014-04-10','16:55:00',2.8),('8537','2014-04-10','17:00:00',2.57),('8537','2014-04-10','17:05:00',2.43),('8537','2014-04-10','17:10:00',2.37),('8537','2014-04-10','17:15:00',2.24),('8537','2014-04-10','17:20:00',2.15),('8537','2014-04-10','17:25:00',2.02),('8537','2014-04-10','17:30:00',1.83),('8537','2014-04-10','17:35:00',1.74),('8537','2014-04-10','17:40:00',1.63),('8537','2014-04-10','17:45:00',1.52),('8537','2014-04-10','17:50:00',1.39),('8537','2014-04-10','17:55:00',1.29),('8537','2014-04-10','18:00:00',1.18),('8537','2014-04-10','18:05:00',1.07),('8537','2013-08-19','07:55:00',1.03),('8537','2013-08-19','08:00:00',1.13),('8537','2013-08-19','08:05:00',1.23),('8537','2013-08-19','08:10:00',1.31),('8537','2013-08-19','08:15:00',1.41),('8537','2013-08-19','08:20:00',1.51),('8537','2013-08-19','08:25:00',1.62),('8537','2013-08-19','08:30:00',1.7),('8537','2013-08-19','08:35:00',1.8),('8537','2013-08-19','08:40:00',1.89),('8537','2013-08-19','08:45:00',2.01),('8537','2013-08-19','08:50:00',2.11),('8537','2013-08-19','08:55:00',2.23),('8537','2013-08-19','09:00:00',2.34),('8537','2013-08-19','09:05:00',2.43),('8537','2013-08-19','09:10:00',2.53),('8537','2013-08-19','09:15:00',2.62),('8537','2013-08-19','09:20:00',2.72),('8537','2013-08-19','09:25:00',2.8),('8537','2013-08-19','09:30:00',2.86),('8537','2013-08-19','09:35:00',2.96),('8537','2013-08-19','09:40:00',3.04),('8537','2013-08-19','09:45:00',3.12),('8537','2013-08-19','09:50:00',3.18),('8537','2013-08-19','09:55:00',3.27),('8537','2013-08-19','10:00:00',3.36),('8537','2013-08-19','10:05:00',3.39),('8537','2013-08-19','10:10:00',3.47),('8537','2013-08-19','10:15:00',3.53),('8537','2013-08-19','10:20:00',3.6),('8537','2013-08-19','10:25:00',3.65),('8537','2013-08-19','10:30:00',3.72),('8537','2013-08-19','10:35:00',3.79),('8537','2013-08-19','10:40:00',3.87),('8537','2013-08-19','10:45:00',3.91),('8537','2013-08-19','10:50:00',3.96),('8537','2013-08-19','10:55:00',3.95),('8537','2013-08-19','11:00:00',4.07),('8537','2013-08-19','11:05:00',4.09),('8537','2013-08-19','11:10:00',4.08),('8537','2013-08-19','11:15:00',4.13),('8537','2013-08-19','11:20:00',4.17),('8537','2013-08-19','11:25:00',4.12),('8537','2013-08-19','11:30:00',4.24),('8537','2013-08-19','11:35:00',4.27),('8537','2013-08-19','11:40:00',4.29),('8537','2013-08-19','11:45:00',4.3),('8537','2013-08-19','11:50:00',4.29),('8537','2013-08-19','11:55:00',4.36),('8537','2013-08-19','12:00:00',4.33),('8537','2013-08-19','12:05:00',4.43),('8537','2013-08-19','12:10:00',4.44),('8537','2013-08-19','12:15:00',4.48),('8537','2013-08-19','12:20:00',4.53),('8537','2013-08-19','12:25:00',4.5),('8537','2013-08-19','12:30:00',4.52),('8537','2013-08-19','12:35:00',4.56),('8537','2013-08-19','12:40:00',4.53),('8537','2013-08-19','12:45:00',4.61),('8537','2013-08-19','12:50:00',4.63),('8537','2013-08-19','12:55:00',4.64),('8537','2013-08-19','13:00:00',4.63),('8537','2013-08-19','13:05:00',4.65),('8537','2013-08-19','13:10:00',4.67),('8537','2013-08-19','13:15:00',4.62),('8537','2013-08-19','13:20:00',4.66),('8537','2013-08-19','13:25:00',4.61),('8537','2013-08-19','13:30:00',4.62),('8537','2013-08-19','13:35:00',4.55),('8537','2013-08-19','13:40:00',4.63),('8537','2013-08-19','13:45:00',4.61),('8537','2013-08-19','13:50:00',4.61),('8537','2013-08-19','13:55:00',4.62),('8537','2013-08-19','14:00:00',4.58),('8537','2013-08-19','14:05:00',4.57),('8537','2013-08-19','14:10:00',4.56),('8537','2013-08-19','14:15:00',4.52),('8537','2013-08-19','14:20:00',4.51),('8537','2013-08-19','14:25:00',4.48),('8537','2013-08-19','14:30:00',4.46),('8537','2013-08-19','14:35:00',4.41),('8537','2013-08-19','14:40:00',4.21),('8537','2013-08-19','14:45:00',3.91),('8537','2013-08-19','14:50:00',3.73),('8537','2013-08-19','14:55:00',4.22),('8537','2013-08-19','15:00:00',4.19),('8537','2013-08-19','15:05:00',4.16),('8537','2013-08-19','15:10:00',4.12),('8537','2013-08-19','15:15:00',4.07),('8537','2013-08-19','15:20:00',4.02),('8537','2013-08-19','15:25:00',3.98),('8537','2013-08-19','15:30:00',3.85),('8537','2013-08-19','15:35:00',3.73),('8537','2013-08-19','15:40:00',3.78),('8537','2013-08-19','15:45:00',3.7),('8537','2013-08-19','15:50:00',3.64),('8537','2013-08-19','15:55:00',3.57),('8537','2013-08-19','16:00:00',3.5),('8537','2013-08-19','16:05:00',3.43),('8537','2013-08-19','16:10:00',3.36),('8537','2013-08-19','16:15:00',2.99),('8537','2013-08-19','16:20:00',2.86),('8537','2013-08-19','16:25:00',3.05),('8537','2013-08-19','16:30:00',3.01),('8537','2013-08-19','16:35:00',2.96),('8537','2013-08-19','16:40:00',2.89),('8537','2013-08-19','16:45:00',2.81),('8537','2013-08-19','16:50:00',2.68),('8537','2013-08-19','16:55:00',2.6),('8537','2013-08-19','17:00:00',2.51),('8537','2013-08-19','17:05:00',2.42),('8537','2013-08-19','17:10:00',2.25),('8537','2013-08-19','17:15:00',2.1),('8537','2013-08-19','17:20:00',2.09),('8537','2013-08-19','17:25:00',1.98),('8537','2013-08-19','17:30:00',1.87),('8537','2013-08-19','17:35:00',1.78),('8537','2013-08-19','17:40:00',1.65),('8537','2013-08-19','17:45:00',1.56),('8537','2013-08-19','17:50:00',1.47),('8537','2013-08-19','17:55:00',1.36),('8537','2013-08-19','18:00:00',1.27),('8537','2013-08-19','18:05:00',1.18),('8537','2013-08-19','18:10:00',1.08),('8537','2013-08-18','07:55:00',1.06),('8537','2013-08-18','08:00:00',1.16),('8537','2013-08-18','08:05:00',1.26),('8537','2013-08-18','08:10:00',1.37),('8537','2013-08-18','08:15:00',1.47),('8537','2013-08-18','08:20:00',1.58),('8537','2013-08-18','08:25:00',1.68),('8537','2013-08-18','08:30:00',1.79),('8537','2013-08-18','08:35:00',1.89),('8537','2013-08-18','08:40:00',2),('8537','2013-08-18','08:45:00',2.07),('8537','2013-08-18','08:50:00',2.18),('8537','2013-08-18','08:55:00',2.27),('8537','2013-08-18','09:00:00',2.36),('8537','2013-08-18','09:05:00',2.46),('8537','2013-08-18','09:10:00',2.57),('8537','2013-08-18','09:15:00',2.67),('8537','2013-08-18','09:20:00',2.76),('8537','2013-08-18','09:25:00',2.85),('8537','2013-08-18','09:30:00',2.95),('8537','2013-08-18','09:35:00',3.03),('8537','2013-08-18','09:40:00',3.15),('8537','2013-08-18','09:45:00',2.9),('8537','2013-08-18','09:50:00',3.11),('8537','2013-08-18','09:55:00',2.5),('8537','2013-08-18','10:00:00',3.39),('8537','2013-08-18','10:05:00',2.9),('8537','2013-08-18','10:10:00',3.16),('8537','2013-08-18','10:15:00',3.57),('8537','2013-08-18','10:20:00',3.61),('8537','2013-08-18','10:25:00',3.67),('8537','2013-08-18','10:30:00',3.7),('8537','2013-08-18','10:35:00',3.77),('8537','2013-08-18','10:40:00',3.84),('8537','2013-08-18','10:45:00',3.88),('8537','2013-08-18','10:50:00',3.92),('8537','2013-08-18','10:55:00',3.95),('8537','2013-08-18','11:00:00',3.93),('8537','2013-08-18','11:05:00',4.02),('8537','2013-08-18','11:10:00',4.1),('8537','2013-08-18','11:15:00',4.1),('8537','2013-08-18','11:20:00',4.13),('8537','2013-08-18','11:25:00',4.2),('8537','2013-08-18','11:30:00',4.23),('8537','2013-08-18','11:35:00',4.28),('8537','2013-08-18','11:40:00',4.31),('8537','2013-08-18','11:45:00',4.31),('8537','2013-08-18','11:50:00',4.38),('8537','2013-08-18','11:55:00',4.36),('8537','2013-08-18','12:00:00',4.36),('8537','2013-08-18','12:05:00',4.45),('8537','2013-08-18','12:10:00',4.43),('8537','2013-08-18','12:15:00',4.11),('8537','2013-08-18','12:20:00',4.54),('8537','2013-08-18','12:25:00',4.61),('8537','2013-08-18','12:30:00',4.59),('8537','2013-08-18','12:35:00',3.67),('8537','2013-08-18','12:40:00',1.32),('8537','2013-08-18','12:45:00',2.27),('8537','2013-08-18','12:50:00',1.89),('8537','2013-08-18','12:55:00',1.29),('8537','2013-08-18','13:00:00',1.68),('8537','2013-08-18','13:05:00',5.05),('8537','2013-08-18','13:10:00',4.9),('8537','2013-08-18','13:15:00',3.65),('8537','2013-08-18','13:20:00',4.04),('8537','2013-08-18','13:25:00',4.73),('8537','2013-08-18','13:30:00',4.73),('8537','2013-08-18','13:35:00',4.6),('8537','2013-08-18','13:40:00',4.71),('8537','2013-08-18','13:45:00',4.65),('8537','2013-08-18','13:50:00',4.65),('8537','2013-08-18','13:55:00',4.56),('8537','2013-08-18','14:00:00',4.66),('8537','2013-08-18','14:05:00',4.6),('8537','2013-08-18','14:10:00',4.51),('8537','2013-08-18','14:15:00',4.51),('8537','2013-08-18','14:20:00',4.47),('8537','2013-08-18','14:25:00',4.46),('8537','2013-08-18','14:30:00',4.46),('8537','2013-08-18','14:35:00',4.43),('8537','2013-08-18','14:40:00',4.26),('8537','2013-08-18','14:45:00',3.96),('8537','2013-08-18','14:50:00',4.1),('8537','2013-08-18','14:55:00',4.23),('8537','2013-08-18','15:00:00',4.18),('8537','2013-08-18','15:05:00',4.15),('8537','2013-08-18','15:10:00',4.08),('8537','2013-08-18','15:15:00',4.04),('8537','2013-08-18','15:20:00',3.99),('8537','2013-08-18','15:25:00',3.93),('8537','2013-08-18','15:30:00',3.83),('8537','2013-08-18','15:35:00',3.71),('8537','2013-08-18','15:40:00',3.73),('8537','2013-08-18','15:45:00',3.7),('8537','2013-08-18','15:50:00',3.64),('8537','2013-08-18','15:55:00',3.55),('8537','2013-08-18','16:00:00',3.5),('8537','2013-08-18','16:05:00',3.41),('8537','2013-08-18','16:10:00',3.35),('8537','2013-08-18','16:15:00',3.05),('8537','2013-08-18','16:20:00',2.94),('8537','2013-08-18','16:25:00',3.09),('8537','2013-08-18','16:30:00',3.02),('8537','2013-08-18','16:35:00',2.95),('8537','2013-08-18','16:40:00',2.88),('8537','2013-08-18','16:45:00',2.78),('8537','2013-08-18','16:50:00',2.66),('8537','2013-08-18','16:55:00',2.58),('8537','2013-08-18','17:00:00',2.51),('8537','2013-08-18','17:05:00',2.42),('8537','2013-08-18','17:10:00',2.28),('8537','2013-08-18','17:15:00',2.07),('8537','2013-08-18','17:20:00',2.1),('8537','2013-08-18','17:25:00',2.01),('8537','2013-08-18','17:30:00',1.91),('8537','2013-08-18','17:35:00',1.79),('8537','2013-08-18','17:40:00',1.67),('8537','2013-08-18','17:45:00',1.56),('8537','2013-08-18','17:50:00',1.46),('8537','2013-08-18','17:55:00',1.37),('8537','2013-08-18','18:00:00',1.27),('8537','2013-08-18','18:05:00',1.17),('8537','2013-08-18','18:10:00',1.09),('8537','2013-08-18','18:15:00',1),('8537','2013-08-17','07:55:00',1.04),('8537','2013-08-17','08:00:00',1.12),('8537','2013-08-17','08:05:00',1.23),('8537','2013-08-17','08:10:00',1.32),('8537','2013-08-17','08:15:00',1.42),('8537','2013-08-17','08:20:00',1.53),('8537','2013-08-17','08:25:00',1.63),('8537','2013-08-17','08:30:00',1.72),('8537','2013-08-17','08:35:00',1.84),('8537','2013-08-17','08:40:00',1.96),('8537','2013-08-17','08:45:00',2.06),('8537','2013-08-17','08:50:00',2.16),('8537','2013-08-17','08:55:00',2.27),('8537','2013-08-17','09:00:00',2.36),('8537','2013-08-17','09:05:00',2.46),('8537','2013-08-17','09:10:00',2.54),('8537','2013-08-17','09:15:00',2.62),('8537','2013-08-17','09:20:00',2.72),('8537','2013-08-17','09:25:00',2.82),('8537','2013-08-17','09:30:00',2.91),('8537','2013-08-17','09:35:00',2.98),('8537','2013-08-17','09:40:00',3.07),('8537','2013-08-17','09:45:00',3.14),('8537','2013-08-17','09:50:00',3.21),('8537','2013-08-17','09:55:00',3.29),('8537','2013-08-17','10:00:00',3.38),('8537','2013-08-17','10:05:00',3.46),('8537','2013-08-17','10:10:00',3.53),('8537','2013-08-17','10:15:00',3.58),('8537','2013-08-17','10:20:00',3.62),('8537','2013-08-17','10:25:00',3.68),('8537','2013-08-17','10:30:00',3.72),('8537','2013-08-17','10:35:00',3.79),('8537','2013-08-17','10:40:00',3.81),('8537','2013-08-17','10:45:00',3.84),('8537','2013-08-17','10:50:00',3.94),('8537','2013-08-17','10:55:00',4.01),('8537','2013-08-17','11:00:00',4.05),('8537','2013-08-17','11:05:00',4.1),('8537','2013-08-17','11:10:00',4.15),('8537','2013-08-17','11:15:00',4.2),('8537','2013-08-17','11:20:00',4.22),('8537','2013-08-17','11:25:00',4.24),('8537','2013-08-17','11:30:00',4.31),('8537','2013-08-17','11:35:00',4.31),('8537','2013-08-17','11:40:00',4.28),('8537','2013-08-17','11:45:00',4.34),('8537','2013-08-17','11:50:00',4.43),('8537','2013-08-17','11:55:00',4.39),('8537','2013-08-17','12:00:00',4.4),('8537','2013-08-17','12:05:00',4.52),('8537','2013-08-17','12:10:00',4.46),('8537','2013-08-17','12:15:00',4.47),('8537','2013-08-17','12:20:00',4.56),('8537','2013-08-17','12:25:00',4.55),('8537','2013-08-17','12:30:00',4.59),('8537','2013-08-17','12:35:00',4.57),('8537','2013-08-17','12:40:00',4.5),('8537','2013-08-17','12:45:00',4.65),('8537','2013-08-17','12:50:00',4.62),('8537','2013-08-17','12:55:00',4.59),('8537','2013-08-17','13:00:00',4.65),('8537','2013-08-17','13:05:00',4.64),('8537','2013-08-17','13:10:00',4.79),('8537','2013-08-17','13:15:00',4.75),('8537','2013-08-17','13:20:00',4.8),('8537','2013-08-17','13:25:00',4.78),('8537','2013-08-17','13:30:00',4.82),('8537','2013-08-17','13:35:00',4.87),('8537','2013-08-17','13:40:00',1.74),('8537','2013-08-17','13:45:00',2.3),('8537','2013-08-17','13:50:00',4.27),('8537','2013-08-17','13:55:00',1.19),('8537','2013-08-17','14:00:00',4.32),('8537','2013-08-17','14:05:00',4.74),('8537','2013-08-17','14:10:00',4.56),('8537','2013-08-17','14:15:00',4.05),('8537','2013-08-17','14:20:00',4.63),('8537','2013-08-17','14:25:00',4.6),('8537','2013-08-17','14:30:00',4.52),('8537','2013-08-17','14:35:00',4.39),('8537','2013-08-17','14:40:00',4.34),('8537','2013-08-17','14:45:00',4.02),('8537','2013-08-17','14:50:00',4.28),('8537','2013-08-17','14:55:00',4.19),('8537','2013-08-17','15:00:00',4.21),('8537','2013-08-17','15:05:00',4.12),('8537','2013-08-17','15:10:00',4.06),('8537','2013-08-17','15:15:00',3.99),('8537','2013-08-17','15:20:00',4.03),('8537','2013-08-17','15:25:00',3.94),('8537','2013-08-17','15:30:00',3.86),('8537','2013-08-17','15:35:00',3.83),('8537','2013-08-17','15:40:00',3.77),('8537','2013-08-17','15:45:00',3.69),('8537','2013-08-17','15:50:00',3.64),('8537','2013-08-17','15:55:00',3.58),('8537','2013-08-17','16:00:00',3.51),('8537','2013-08-17','16:05:00',3.43),('8537','2013-08-17','16:10:00',3.36),('8537','2013-08-17','16:15:00',3.14),('8537','2013-08-17','16:20:00',3.11),('8537','2013-08-17','16:25:00',3.14),('8537','2013-08-17','16:30:00',3.04),('8537','2013-08-17','16:35:00',3),('8537','2013-08-17','16:40:00',2.94),('8537','2013-08-17','16:45:00',2.83),('8537','2013-08-17','16:50:00',2.68),('8537','2013-08-17','16:55:00',2.65),('8537','2013-08-17','17:00:00',2.57),('8537','2013-08-17','17:05:00',2.43),('8537','2013-08-17','17:10:00',2.31),('8537','2013-08-17','17:15:00',1.97),('8537','2013-08-17','17:20:00',2.07),('8537','2013-08-17','17:25:00',2.07),('8537','2013-08-17','17:30:00',2.03),('8537','2013-08-17','17:35:00',1.92),('8537','2013-08-17','17:40:00',1.82),('8537','2013-08-17','17:45:00',1.67),('8537','2013-08-17','17:50:00',1.57),('8537','2013-08-17','17:55:00',1.48),('8537','2013-08-17','18:00:00',1.37),('8537','2013-08-17','18:05:00',1.25),('8537','2013-08-17','18:10:00',1.15),('8537','2013-08-17','18:15:00',1.06),('8537','2013-08-16','07:55:00',1.05),('8537','2013-08-16','08:00:00',1.16),('8537','2013-08-16','08:05:00',1.26),('8537','2013-08-16','08:10:00',1.36),('8537','2013-08-16','08:15:00',1.47),('8537','2013-08-16','08:20:00',1.58),('8537','2013-08-16','08:25:00',1.69),('8537','2013-08-16','08:30:00',1.8),('8537','2013-08-16','08:35:00',1.9),('8537','2013-08-16','08:40:00',2.01),('8537','2013-08-16','08:45:00',2.11),('8537','2013-08-16','08:50:00',2.22),('8537','2013-08-16','08:55:00',2.33),('8537','2013-08-16','09:00:00',2.43),('8537','2013-08-16','09:05:00',2.53),('8537','2013-08-16','09:10:00',2.62),('8537','2013-08-16','09:15:00',2.72),('8537','2013-08-16','09:20:00',2.83),('8537','2013-08-16','09:25:00',2.92),('8537','2013-08-16','09:30:00',3.02),('8537','2013-08-16','09:35:00',3.11),('8537','2013-08-16','09:40:00',3.2),('8537','2013-08-16','09:45:00',3.29),('8537','2013-08-16','09:50:00',3.37),('8537','2013-08-16','09:55:00',3.45),('8537','2013-08-16','10:00:00',3.51),('8537','2013-08-16','10:05:00',3.6),('8537','2013-08-16','10:10:00',3.65),('8537','2013-08-16','10:15:00',3.7),('8537','2013-08-16','10:20:00',3.78),('8537','2013-08-16','10:25:00',3.85),('8537','2013-08-16','10:30:00',3.87),('8537','2013-08-16','10:35:00',3.97),('8537','2013-08-16','10:40:00',4.02),('8537','2013-08-16','10:45:00',4.08),('8537','2013-08-16','10:50:00',4.13),('8537','2013-08-16','10:55:00',4.17),('8537','2013-08-16','11:00:00',4.22),('8537','2013-08-16','11:05:00',4.27),('8537','2013-08-16','11:10:00',4.32),('8537','2013-08-16','11:15:00',4.37),('8537','2013-08-16','11:20:00',4.39),('8537','2013-08-16','11:25:00',4.39),('8537','2013-08-16','11:30:00',4.42),('8537','2013-08-16','11:35:00',4.5),('8537','2013-08-16','11:40:00',4.51),('8537','2013-08-16','11:45:00',4.51),('8537','2013-08-16','11:50:00',4.52),('8537','2013-08-16','11:55:00',4.53),('8537','2013-08-16','12:00:00',4.59),('8537','2013-08-16','12:05:00',4.62),('8537','2013-08-16','12:10:00',4.68),('8537','2013-08-16','12:15:00',4.68),('8537','2013-08-16','12:20:00',4.7),('8537','2013-08-16','12:25:00',4.71),('8537','2013-08-16','12:30:00',4.72),('8537','2013-08-16','12:35:00',4.7),('8537','2013-08-16','12:40:00',4.71),('8537','2013-08-16','12:45:00',4.77),('8537','2013-08-16','12:50:00',4.8),('8537','2013-08-16','12:55:00',4.76),('8537','2013-08-16','13:00:00',4.76),('8537','2013-08-16','13:05:00',4.77),('8537','2013-08-16','13:10:00',4.77),('8537','2013-08-16','13:15:00',4.75),('8537','2013-08-16','13:20:00',4.73),('8537','2013-08-16','13:25:00',4.66),('8537','2013-08-16','13:30:00',4.58),('8537','2013-08-16','13:35:00',4.61),('8537','2013-08-16','13:40:00',4.61),('8537','2013-08-16','13:45:00',4.61),('8537','2013-08-16','13:50:00',4.64),('8537','2013-08-16','13:55:00',4.61),('8537','2013-08-16','14:00:00',4.58),('8537','2013-08-16','14:05:00',4.6),('8537','2013-08-16','14:10:00',4.55),('8537','2013-08-16','14:15:00',4.52),('8537','2013-08-16','14:20:00',4.46),('8537','2013-08-16','14:25:00',4.44),('8537','2013-08-16','14:30:00',4.4),('8537','2013-08-16','14:35:00',4.37),('8537','2013-08-16','14:40:00',4.23),('8537','2013-08-16','14:45:00',4.04),('8537','2013-08-16','14:50:00',4.19),('8537','2013-08-16','14:55:00',4.21),('8537','2013-08-16','15:00:00',4.14),('8537','2013-08-16','15:05:00',4.08),('8537','2013-08-16','15:10:00',4.05),('8537','2013-08-16','15:15:00',3.92),('8537','2013-08-16','15:20:00',3.98),('8537','2013-08-16','15:25:00',3.95),('8537','2013-08-16','15:30:00',3.88),('8537','2013-08-16','15:35:00',3.78),('8537','2013-08-16','15:40:00',3.72),('8537','2013-08-16','15:45:00',3.66),('8537','2013-08-16','15:50:00',3.62),('8537','2013-08-16','15:55:00',3.57),('8537','2013-08-16','16:00:00',3.5),('8537','2013-08-16','16:05:00',3.45),('8537','2013-08-16','16:10:00',3.38),('8537','2013-08-16','16:15:00',3.19),('8537','2013-08-16','16:20:00',3.18),('8537','2013-08-16','16:25:00',3.11),('8537','2013-08-16','16:30:00',3.04),('8537','2013-08-16','16:35:00',2.97),('8537','2013-08-16','16:40:00',2.91),('8537','2013-08-16','16:45:00',2.82),('8537','2013-08-16','16:50:00',2.7),('8537','2013-08-16','16:55:00',2.61),('8537','2013-08-16','17:00:00',2.52),('8537','2013-08-16','17:05:00',2.43),('8537','2013-08-16','17:10:00',2.33),('8537','2013-08-16','17:15:00',2.16),('8537','2013-08-16','17:20:00',2.09),('8537','2013-08-16','17:25:00',2),('8537','2013-08-16','17:30:00',1.91),('8537','2013-08-16','17:35:00',1.79),('8537','2013-08-16','17:40:00',1.7),('8537','2013-08-16','17:45:00',1.56),('8537','2013-08-16','17:50:00',1.48),('8537','2013-08-16','17:55:00',1.38),('8537','2013-08-16','18:00:00',1.28),('8537','2013-08-16','18:05:00',1.18),('8537','2013-08-16','18:10:00',1.1),('8537','2013-08-16','18:15:00',1.01),('8537','2013-08-15','08:00:00',1.15),('8537','2013-08-15','08:05:00',1.53),('8537','2013-08-15','08:10:00',1.53),('8537','2013-08-15','08:15:00',1.28),('8537','2013-08-15','08:20:00',1.65),('8537','2013-08-15','08:25:00',1.74),('8537','2013-08-15','08:30:00',1.83),('8537','2013-08-15','08:35:00',1.93),('8537','2013-08-15','08:40:00',2.04),('8537','2013-08-15','08:45:00',2.16),('8537','2013-08-15','08:50:00',2.27),('8537','2013-08-15','08:55:00',2.34),('8537','2013-08-15','09:00:00',2.45),('8537','2013-08-15','09:05:00',2.38),('8537','2013-08-15','09:10:00',1.54),('8537','2013-08-15','09:15:00',2.23),('8537','2013-08-15','09:20:00',2.99),('8537','2013-08-15','09:25:00',2.93),('8537','2013-08-15','09:30:00',2.96),('8537','2013-08-15','09:35:00',3.07),('8537','2013-08-15','09:40:00',3.17),('8537','2013-08-15','09:45:00',3.27),('8537','2013-08-15','09:50:00',3.36),('8537','2013-08-15','09:55:00',3.43),('8537','2013-08-15','10:00:00',3.52),('8537','2013-08-15','10:05:00',3.6),('8537','2013-08-15','10:10:00',3.67),('8537','2013-08-15','10:15:00',3.75),('8537','2013-08-15','10:20:00',3.82),('8537','2013-08-15','10:25:00',3.89),('8537','2013-08-15','10:30:00',3.97),('8537','2013-08-15','10:35:00',4.01),('8537','2013-08-15','10:40:00',4.06),('8537','2013-08-15','10:45:00',4.09),('8537','2013-08-15','10:50:00',4.04),('8537','2013-08-15','10:55:00',3.91),('8537','2013-08-15','11:00:00',4.24),('8537','2013-08-15','11:05:00',3.19),('8537','2013-08-15','11:10:00',3),('8537','2013-08-15','11:15:00',3.33),('8537','2013-08-15','11:20:00',3.73),('8537','2013-08-15','11:25:00',4.15),('8537','2013-08-15','11:30:00',4.37),('8537','2013-08-15','11:35:00',4.63),('8537','2013-08-15','11:40:00',4.77),('8537','2013-08-15','11:45:00',4.91),('8537','2013-08-15','11:50:00',4.94),('8537','2013-08-15','11:55:00',4.93),('8537','2013-08-15','12:00:00',4.97),('8537','2013-08-15','12:05:00',4.94),('8537','2013-08-15','12:10:00',4.9),('8537','2013-08-15','12:15:00',4.91),('8537','2013-08-15','12:20:00',4.9),('8537','2013-08-15','12:25:00',4.94),('8537','2013-08-15','12:30:00',4.8),('8537','2013-08-15','12:35:00',4.96),('8537','2013-08-15','12:40:00',4.91),('8537','2013-08-15','12:45:00',4.92),('8537','2013-08-15','12:50:00',4.91),('8537','2013-08-15','12:55:00',4.7),('8537','2013-08-15','13:00:00',4.62),('8537','2013-08-15','13:05:00',4.72),('8537','2013-08-15','13:10:00',4.64),('8537','2013-08-15','13:15:00',4.53),('8537','2013-08-15','13:20:00',4.6),('8537','2013-08-15','13:25:00',4.72),('8537','2013-08-15','13:30:00',4.82),('8537','2013-08-15','13:35:00',4.83),('8537','2013-08-15','13:40:00',4.76),('8537','2013-08-15','13:45:00',4.71),('8537','2013-08-15','13:50:00',4.69),('8537','2013-08-15','13:55:00',4.66),('8537','2013-08-15','14:00:00',4.72),('8537','2013-08-15','14:05:00',4.71),('8537','2013-08-15','14:10:00',4.69),('8537','2013-08-15','14:15:00',4.65),('8537','2013-08-15','14:20:00',4.62),('8537','2013-08-15','14:25:00',4.47),('8537','2013-08-15','14:30:00',4.39),('8537','2013-08-15','14:35:00',4.53),('8537','2013-08-15','14:40:00',4.41),('8537','2013-08-15','14:45:00',4.09),('8537','2013-08-15','14:50:00',4.28),('8537','2013-08-15','14:55:00',4.23),('8537','2013-08-15','15:00:00',4.18),('8537','2013-08-15','15:05:00',4.15),('8537','2013-08-15','15:10:00',4.11),('8537','2013-08-15','15:15:00',4.08),('8537','2013-08-15','15:20:00',3.99),('8537','2013-08-15','15:25:00',3.92),('8537','2013-08-15','15:30:00',3.87),('8537','2013-08-15','15:35:00',3.77),('8537','2013-08-15','15:40:00',3.72),('8537','2013-08-15','15:45:00',3.64),('8537','2013-08-15','15:50:00',3.57),('8537','2013-08-15','15:55:00',3.55),('8537','2013-08-15','16:00:00',3.48),('8537','2013-08-15','16:05:00',3.4),('8537','2013-08-15','16:10:00',3.27),('8537','2013-08-15','16:15:00',3.17),('8537','2013-08-15','16:20:00',3.17),('8537','2013-08-15','16:25:00',3.07),('8537','2013-08-15','16:30:00',2.91),('8537','2013-08-15','16:35:00',2.86),('8537','2013-08-15','16:40:00',2.82),('8537','2013-08-15','16:45:00',2.75),('8537','2013-08-15','16:50:00',2.63),('8537','2013-08-15','16:55:00',2.52),('8537','2013-08-15','17:00:00',2.46),('8537','2013-08-15','17:05:00',2.37),('8537','2013-08-15','17:10:00',2.26),('8537','2013-08-15','17:15:00',2.17),('8537','2013-08-15','17:20:00',2.09),('8537','2013-08-15','17:25:00',1.97),('8537','2013-08-15','17:30:00',1.91),('8537','2013-08-15','17:35:00',1.77),('8537','2013-08-15','17:40:00',1.69),('8537','2013-08-15','17:45:00',1.57),('8537','2013-08-15','17:50:00',1.49),('8537','2013-08-15','17:55:00',1.38),('8537','2013-08-15','18:00:00',1.29),('8537','2013-08-15','18:05:00',1.19),('8537','2013-08-15','18:10:00',1.08),('8537','2013-08-15','18:15:00',1.01),('8537','2013-08-14','07:55:00',1.06),('8537','2013-08-14','08:00:00',1.15),('8537','2013-08-14','08:05:00',1.24),('8537','2013-08-14','08:10:00',1.34),('8537','2013-08-14','08:15:00',1.45),('8537','2013-08-14','08:20:00',1.49),('8537','2013-08-14','08:25:00',1.55),('8537','2013-08-14','08:30:00',1.7),('8537','2013-08-14','08:35:00',1.82),('8537','2013-08-14','08:40:00',2),('8537','2013-08-14','08:45:00',2.1),('8537','2013-08-14','08:50:00',1.98),('8537','2013-08-14','08:55:00',2.19),('8537','2013-08-14','09:00:00',2.34),('8537','2013-08-14','09:05:00',2.41),('8537','2013-08-14','09:10:00',2.63),('8537','2013-08-14','09:15:00',2.72),('8537','2013-08-14','09:20:00',2.82),('8537','2013-08-14','09:25:00',2.71),('8537','2013-08-14','09:30:00',3.05),('8537','2013-08-14','09:35:00',3.17),('8537','2013-08-14','09:40:00',2.65),('8537','2013-08-14','09:45:00',1.12),('8537','2013-08-14','09:50:00',1.21),('8537','2013-08-14','09:55:00',1.79),('8537','2013-08-14','10:00:00',2.06),('8537','2013-08-14','10:05:00',3.5),('8537','2013-08-14','10:10:00',3.4),('8537','2013-08-14','10:15:00',3.36),('8537','2013-08-14','10:20:00',2.71),('8537','2013-08-14','10:25:00',1.59),('8537','2013-08-14','10:30:00',4.14),('8537','2013-08-14','10:35:00',4.07),('8537','2013-08-14','10:40:00',3.66),('8537','2013-08-14','10:45:00',3.04),('8537','2013-08-14','10:50:00',1.71),('8537','2013-08-14','10:55:00',1.6),('8537','2013-08-14','11:00:00',4.05),('8537','2013-08-14','11:05:00',4),('8537','2013-08-14','11:10:00',3.79),('8537','2013-08-14','11:15:00',4.06),('8537','2013-08-14','11:20:00',2.83),('8537','2013-08-14','11:25:00',3.38),('8537','2013-08-14','11:30:00',4.53),('8537','2013-08-14','11:35:00',4.49),('8537','2013-08-14','11:40:00',4.47),('8537','2013-08-14','11:45:00',3.83),('8537','2013-08-14','11:50:00',3.63),('8537','2013-08-14','11:55:00',3.22),('8537','2013-08-14','12:00:00',2),('8537','2013-08-14','12:05:00',3.46),('8537','2013-08-14','12:10:00',3.19),('8537','2013-08-14','12:15:00',2.37),('8537','2013-08-14','12:20:00',1.83),('8537','2013-08-14','12:25:00',2.02),('8537','2013-08-14','12:30:00',2.75),('8537','2013-08-14','12:35:00',1.54),('8537','2013-08-14','12:40:00',1.5),('8537','2013-08-14','12:45:00',1.69),('8537','2013-08-14','12:50:00',2.12),('8537','2013-08-14','12:55:00',2.73),('8537','2013-08-14','13:00:00',2.91),('8537','2013-08-14','13:05:00',1.23),('8537','2013-08-14','13:10:00',1.18),('8537','2013-08-14','13:15:00',1.1),('8537','2013-08-14','13:20:00',1.06),('8537','2013-08-14','13:25:00',2.01),('8537','2013-08-14','13:30:00',3.56),('8537','2013-08-14','13:35:00',3.29),('8537','2013-08-14','13:40:00',2.77),('8537','2013-08-14','13:45:00',5.12),('8537','2013-08-14','13:50:00',5.15),('8537','2013-08-14','13:55:00',3.05),('8537','2013-08-14','14:00:00',3.35),('8537','2013-08-14','14:05:00',4.37),('8537','2013-08-14','14:10:00',3.16),('8537','2013-08-14','14:15:00',4.26),('8537','2013-08-14','14:20:00',4.88),('8537','2013-08-14','14:25:00',4.76),('8537','2013-08-14','14:30:00',4.02),('8537','2013-08-14','14:35:00',4.04),('8537','2013-08-14','14:40:00',4.53),('8537','2013-08-14','14:45:00',4.31),('8537','2013-08-14','14:50:00',4.25),('8537','2013-08-14','14:55:00',4.33),('8537','2013-08-14','15:00:00',4.3),('8537','2013-08-14','15:05:00',4.16),('8537','2013-08-14','15:10:00',4.16),('8537','2013-08-14','15:15:00',4.19),('8537','2013-08-14','15:20:00',4.15),('8537','2013-08-14','15:25:00',4.06),('8537','2013-08-14','15:30:00',3.93),('8537','2013-08-14','15:35:00',3.71),('8537','2013-08-14','15:40:00',3.78),('8537','2013-08-14','15:45:00',3.7),('8537','2013-08-14','15:50:00',3.69),('8537','2013-08-14','15:55:00',3.61),('8537','2013-08-14','16:00:00',3.55),('8537','2013-08-14','16:05:00',3.48),('8537','2013-08-14','16:10:00',3.46),('8537','2013-08-14','16:15:00',3.35),('8537','2013-08-14','16:20:00',3.26),('8537','2013-08-14','16:25:00',3.19),('8537','2013-08-14','16:30:00',3.1),('8537','2013-08-14','16:35:00',3.06),('8537','2013-08-14','16:40:00',2.98),('8537','2013-08-14','16:45:00',2.89),('8537','2013-08-14','16:50:00',2.8),('8537','2013-08-14','16:55:00',2.69),('8537','2013-08-14','17:00:00',2.59),('8537','2013-08-14','17:05:00',2.48),('8537','2013-08-14','17:10:00',2.4),('8537','2013-08-14','17:15:00',2.21),('8537','2013-08-14','17:20:00',2.14),('8537','2013-08-14','17:25:00',2.07),('8537','2013-08-14','17:30:00',1.98),('8537','2013-08-14','17:35:00',1.86),('8537','2013-08-14','17:40:00',1.77),('8537','2013-08-14','17:45:00',1.63),('8537','2013-08-14','17:50:00',1.54),('8537','2013-08-14','17:55:00',1.46),('8537','2013-08-14','18:00:00',1.36),('8537','2013-08-14','18:05:00',1.25),('8537','2013-08-14','18:10:00',1.15),('8537','2013-08-14','18:15:00',1.07),('8537','2013-08-14','18:20:00',1.04),('8537','2013-08-13','07:55:00',1.08),('8537','2013-08-13','08:00:00',1.19),('8537','2013-08-13','08:05:00',1.27),('8537','2013-08-13','08:10:00',1.37),('8537','2013-08-13','08:15:00',1.45),('8537','2013-08-13','08:20:00',1.55),('8537','2013-08-13','08:25:00',1.68),('8537','2013-08-13','08:30:00',1.8),('8537','2013-08-13','08:35:00',1.91),('8537','2013-08-13','08:40:00',2),('8537','2013-08-13','08:45:00',2.09),('8537','2013-08-13','08:50:00',2.2),('8537','2013-08-13','08:55:00',2.3),('8537','2013-08-13','09:00:00',2.42),('8537','2013-08-13','09:05:00',2.51),('8537','2013-08-13','09:10:00',2.6),('8537','2013-08-13','09:15:00',2.65),('8537','2013-08-13','09:20:00',2.73),('8537','2013-08-13','09:25:00',2.8),('8537','2013-08-13','09:30:00',2.94),('8537','2013-08-13','09:35:00',3.04),('8537','2013-08-13','09:40:00',3.05),('8537','2013-08-13','09:45:00',3.11),('8537','2013-08-13','09:50:00',3.13),('8537','2013-08-13','09:55:00',2.22),('8537','2013-08-13','10:00:00',3.2),('8537','2013-08-13','10:05:00',3.44),('8537','2013-08-13','10:10:00',3.52),('8537','2013-08-13','10:15:00',3.65),('8537','2013-08-13','10:20:00',3.65),('8537','2013-08-13','10:25:00',3.61),('8537','2013-08-13','10:30:00',3.62),('8537','2013-08-13','10:35:00',3.88),('8537','2013-08-13','10:40:00',3.92),('8537','2013-08-13','10:45:00',3.93),('8537','2013-08-13','10:50:00',4.05),('8537','2013-08-13','10:55:00',4.06),('8537','2013-08-13','11:00:00',4.1),('8537','2013-08-13','11:05:00',4.12),('8537','2013-08-13','11:10:00',4.17),('8537','2013-08-13','11:15:00',4.2),('8537','2013-08-13','11:20:00',4.25),('8537','2013-08-13','11:25:00',4.27),('8537','2013-08-13','11:30:00',4.33),('8537','2013-08-13','11:35:00',4.35),('8537','2013-08-13','11:40:00',4.34),('8537','2013-08-13','11:45:00',4.38),('8537','2013-08-13','11:50:00',4.44),('8537','2013-08-13','11:55:00',4.53),('8537','2013-08-13','12:00:00',4.59),('8537','2013-08-13','12:05:00',4.64),('8537','2013-08-13','12:10:00',4.68),('8537','2013-08-13','12:15:00',4.73),('8537','2013-08-13','12:20:00',4.7),('8537','2013-08-13','12:25:00',4.88),('8537','2013-08-13','12:30:00',4.88),('8537','2013-08-13','12:35:00',4.91),('8537','2013-08-13','12:40:00',4.74),('8537','2013-08-13','12:45:00',2.3),('8537','2013-08-13','12:50:00',1.95),('8537','2013-08-13','12:55:00',5.16),('8537','2013-08-13','13:00:00',2.05),('8537','2013-08-13','13:05:00',1.5),('8537','2013-08-13','13:10:00',1.4),('8537','2013-08-13','13:15:00',1.87),('8537','2013-08-13','13:20:00',4.89),('8537','2013-08-13','13:25:00',5.21),('8537','2013-08-13','13:30:00',5.14),('8537','2013-08-13','13:35:00',5.04),('8537','2013-08-13','13:40:00',4.87),('8537','2013-08-13','13:45:00',4.82),('8537','2013-08-13','13:50:00',3.29),('8537','2013-08-13','13:55:00',3.73),('8537','2013-08-13','14:00:00',5.08),('8537','2013-08-13','14:05:00',4.27),('8537','2013-08-13','14:10:00',5.11),('8537','2013-08-13','14:15:00',5.07),('8537','2013-08-13','14:20:00',4.74),('8537','2013-08-13','14:25:00',3.14),('8537','2013-08-13','14:30:00',2.98),('8537','2013-08-13','14:35:00',5.14),('8537','2013-08-13','14:40:00',2.69),('8537','2013-08-13','14:45:00',2.8),('8537','2013-08-13','14:50:00',4.86),('8537','2013-08-13','14:55:00',4.75),('8537','2013-08-13','15:00:00',4.26),('8537','2013-08-13','15:05:00',2.83),('8537','2013-08-13','15:10:00',4.13),('8537','2013-08-13','15:15:00',3.29),('8537','2013-08-13','15:20:00',4.11),('8537','2013-08-13','15:25:00',4.12),('8537','2013-08-13','15:30:00',3.84),('8537','2013-08-13','15:35:00',3.93),('8537','2013-08-13','15:40:00',3.91),('8537','2013-08-13','15:45:00',3.78),('8537','2013-08-13','15:50:00',3.67),('8537','2013-08-13','15:55:00',3.61),('8537','2013-08-13','16:00:00',3.56),('8537','2013-08-13','16:05:00',3.48),('8537','2013-08-13','16:10:00',3.41),('8537','2013-08-13','16:15:00',3.29),('8537','2013-08-13','16:20:00',3.06),('8537','2013-08-13','16:25:00',2.9),('8537','2013-08-13','16:30:00',3.1),('8537','2013-08-13','16:35:00',3.03),('8537','2013-08-13','16:40:00',2.95),('8537','2013-08-13','16:45:00',2.88),('8537','2013-08-13','16:50:00',2.78),('8537','2013-08-13','16:55:00',2.65),('8537','2013-08-13','17:00:00',2.59),('8537','2013-08-13','17:05:00',2.51),('8537','2013-08-13','17:10:00',2.42),('8537','2013-08-13','17:15:00',2.28),('8537','2013-08-13','17:20:00',2.09),('8537','2013-08-13','17:25:00',2.08),('8537','2013-08-13','17:30:00',1.98),('8537','2013-08-13','17:35:00',1.87),('8537','2013-08-13','17:40:00',1.77),('8537','2013-08-13','17:45:00',1.65),('8537','2013-08-13','17:50:00',1.55),('8537','2013-08-13','17:55:00',1.45),('8537','2013-08-13','18:00:00',1.34),('8537','2013-08-13','18:05:00',1.25),('8537','2013-08-13','18:10:00',1.15),('8537','2013-08-13','18:15:00',1.06),('8537','2013-08-12','07:55:00',1.07),('8537','2013-08-12','08:00:00',1.17),('8537','2013-08-12','08:05:00',1.27),('8537','2013-08-12','08:10:00',1.36),('8537','2013-08-12','08:15:00',1.46),('8537','2013-08-12','08:20:00',1.57),('8537','2013-08-12','08:25:00',1.67),('8537','2013-08-12','08:30:00',1.77),('8537','2013-08-12','08:35:00',1.87),('8537','2013-08-12','08:40:00',1.97),('8537','2013-08-12','08:45:00',2.07),('8537','2013-08-12','08:50:00',2.16),('8537','2013-08-12','08:55:00',2.26),('8537','2013-08-12','09:00:00',2.37),('8537','2013-08-12','09:05:00',2.46),('8537','2013-08-12','09:10:00',2.55),('8537','2013-08-12','09:15:00',2.64),('8537','2013-08-12','09:20:00',2.74),('8537','2013-08-12','09:25:00',2.82),('8537','2013-08-12','09:30:00',2.9),('8537','2013-08-12','09:35:00',2.97),('8537','2013-08-12','09:40:00',3.04),('8537','2013-08-12','09:45:00',3.13),('8537','2013-08-12','09:50:00',3.21),('8537','2013-08-12','09:55:00',3.28),('8537','2013-08-12','10:00:00',3.34),('8537','2013-08-12','10:05:00',3.39),('8537','2013-08-12','10:10:00',3.45),('8537','2013-08-12','10:15:00',3.51),('8537','2013-08-12','10:20:00',3.56),('8537','2013-08-12','10:25:00',3.64),('8537','2013-08-12','10:30:00',3.71),('8537','2013-08-12','10:35:00',3.74),('8537','2013-08-12','10:40:00',3.72),('8537','2013-08-12','10:45:00',3.89),('8537','2013-08-12','10:50:00',3.94),('8537','2013-08-12','10:55:00',3.98),('8537','2013-08-12','11:00:00',4.01),('8537','2013-08-12','11:05:00',4.04),('8537','2013-08-12','11:10:00',4.09),('8537','2013-08-12','11:15:00',4.14),('8537','2013-08-12','11:20:00',4.11),('8537','2013-08-12','11:25:00',4.16),('8537','2013-08-12','11:30:00',4.24),('8537','2013-08-12','11:35:00',4.28),('8537','2013-08-12','11:40:00',4.35),('8537','2013-08-12','11:45:00',4.37),('8537','2013-08-12','11:50:00',4.41),('8537','2013-08-12','11:55:00',4.49),('8537','2013-08-12','12:00:00',4.66),('8537','2013-08-12','12:05:00',4.68),('8537','2013-08-12','12:10:00',4.66),('8537','2013-08-12','12:15:00',3.33),('8537','2013-08-12','12:20:00',3.21),('8537','2013-08-12','12:25:00',2.63),('8537','2013-08-12','12:30:00',1.14),('8537','2013-08-12','12:35:00',1.66),('8537','2013-08-12','12:40:00',2.27),('8537','2013-08-12','12:45:00',2.2),('8537','2013-08-12','12:50:00',2.57),('8537','2013-08-12','12:55:00',1.74),('8537','2013-08-12','13:00:00',1.32),('8537','2013-08-12','13:20:00',1.14),('8537','2013-08-12','13:25:00',1.76),('8537','2013-08-12','13:30:00',1.42),('8537','2013-08-12','13:35:00',1.42),('8537','2013-08-12','13:40:00',1.25),('8537','2013-08-12','13:45:00',1.32),('8537','2013-08-12','13:50:00',3.41),('8537','2013-08-12','13:55:00',4.51),('8537','2013-08-12','14:00:00',2.52),('8537','2013-08-12','14:05:00',1.17),('8537','2013-08-12','14:10:00',3.17),('8537','2013-08-12','14:15:00',2.17),('8537','2013-08-12','14:20:00',1.24),('8537','2013-08-12','14:35:00',1.24),('8537','2013-08-12','14:40:00',1.34),('8537','2013-08-12','14:45:00',1.49),('8537','2013-08-12','14:50:00',3.18),('8537','2013-08-12','14:55:00',4.92),('8537','2013-08-12','15:00:00',4.69),('8537','2013-08-12','15:05:00',4.52),('8537','2013-08-12','15:10:00',4.41),('8537','2013-08-12','15:15:00',3.47),('8537','2013-08-12','15:20:00',3.32),('8537','2013-08-12','15:25:00',4.17),('8537','2013-08-12','15:30:00',3.99),('8537','2013-08-12','15:35:00',3.77),('8537','2013-08-12','15:40:00',3.77),('8537','2013-08-12','15:45:00',3.69),('8537','2013-08-12','15:50:00',3.69),('8537','2013-08-12','15:55:00',3.63),('8537','2013-08-12','16:00:00',3.52),('8537','2013-08-12','16:05:00',3.49),('8537','2013-08-12','16:10:00',3.4),('8537','2013-08-12','16:15:00',3.32),('8537','2013-08-12','16:20:00',3.05),('8537','2013-08-12','16:25:00',2.67),('8537','2013-08-12','16:30:00',2.77),('8537','2013-08-12','16:35:00',2.96),('8537','2013-08-12','16:40:00',2.91),('8537','2013-08-12','16:45:00',2.81),('8537','2013-08-12','16:50:00',2.76),('8537','2013-08-12','16:55:00',2.57),('8537','2013-08-12','17:00:00',2.54),('8537','2013-08-12','17:05:00',2.46),('8537','2013-08-12','17:10:00',2.37),('8537','2013-08-12','17:15:00',2.24),('8537','2013-08-12','17:20:00',2.11),('8537','2013-08-12','17:25:00',2.02),('8537','2013-08-12','17:30:00',1.96),('8537','2013-08-12','17:35:00',1.86),('8537','2013-08-12','17:40:00',1.75),('8537','2013-08-12','17:45:00',1.63),('8537','2013-08-12','17:50:00',1.52),('8537','2013-08-12','17:55:00',1.44),('8537','2013-08-12','18:00:00',1.35),('8537','2013-08-12','18:05:00',1.27),('8537','2013-08-12','18:10:00',1.15),('8537','2013-08-12','18:15:00',1.07),('8537','2013-08-11','07:50:00',1.02),('8537','2013-08-11','07:55:00',1.12),('8537','2013-08-11','08:00:00',1.22),('8537','2013-08-11','08:05:00',1.33),('8537','2013-08-11','08:10:00',1.42),('8537','2013-08-11','08:15:00',1.52),('8537','2013-08-11','08:20:00',1.63),('8537','2013-08-11','08:25:00',1.7),('8537','2013-08-11','08:30:00',1.83),('8537','2013-08-11','08:35:00',1.92),('8537','2013-08-11','08:40:00',2.02),('8537','2013-08-11','08:45:00',2.14),('8537','2013-08-11','08:50:00',2.24),('8537','2013-08-11','08:55:00',2.34),('8537','2013-08-11','09:00:00',2.44),('8537','2013-08-11','09:05:00',2.53),('8537','2013-08-11','09:10:00',2.62),('8537','2013-08-11','09:15:00',2.71),('8537','2013-08-11','09:20:00',2.8),('8537','2013-08-11','09:25:00',2.89),('8537','2013-08-11','09:30:00',2.98),('8537','2013-08-11','09:35:00',3.06),('8537','2013-08-11','09:40:00',3.13),('8537','2013-08-11','09:45:00',3.24),('8537','2013-08-11','09:50:00',3.31),('8537','2013-08-11','09:55:00',3.4),('8537','2013-08-11','10:00:00',3.48),('8537','2013-08-11','10:05:00',3.56),('8537','2013-08-11','10:10:00',3.64),('8537','2013-08-11','10:15:00',3.74),('8537','2013-08-11','10:20:00',3.79),('8537','2013-08-11','10:25:00',3.84),('8537','2013-08-11','10:30:00',3.89),('8537','2013-08-11','10:35:00',3.93),('8537','2013-08-11','10:40:00',3.97),('8537','2013-08-11','10:45:00',4.02),('8537','2013-08-11','10:50:00',4.11),('8537','2013-08-11','10:55:00',4.13),('8537','2013-08-11','11:00:00',4.21),('8537','2013-08-11','11:05:00',4.28),('8537','2013-08-11','11:10:00',4.35),('8537','2013-08-11','11:15:00',4.32),('8537','2013-08-11','11:20:00',4.36),('8537','2013-08-11','11:25:00',4.44),('8537','2013-08-11','11:30:00',4.49),('8537','2013-08-11','11:35:00',4.5),('8537','2013-08-11','11:40:00',4.53),('8537','2013-08-11','11:45:00',4.53),('8537','2013-08-11','11:50:00',4.63),('8537','2013-08-11','11:55:00',4.64),('8537','2013-08-11','12:00:00',4.62),('8537','2013-08-11','12:05:00',4.65),('8537','2013-08-11','12:10:00',4.65),('8537','2013-08-11','12:15:00',4.66),('8537','2013-08-11','12:20:00',4.72),('8537','2013-08-11','12:25:00',4.76),('8537','2013-08-11','12:30:00',4.77),('8537','2013-08-11','12:35:00',4.75),('8537','2013-08-11','12:40:00',4.72),('8537','2013-08-11','12:45:00',4.74),('8537','2013-08-11','12:50:00',4.7),('8537','2013-08-11','12:55:00',4.75),('8537','2013-08-11','13:00:00',4.77),('8537','2013-08-11','13:05:00',4.7),('8537','2013-08-11','13:10:00',4.67),('8537','2013-08-11','13:15:00',4.76),('8537','2013-08-11','13:20:00',4.74),('8537','2013-08-11','13:25:00',4.79),('8537','2013-08-11','13:30:00',4.74),('8537','2013-08-11','13:35:00',4.7),('8537','2013-08-11','13:40:00',4.7),('8537','2013-08-11','13:45:00',4.68),('8537','2013-08-11','13:50:00',4.67),('8537','2013-08-11','13:55:00',4.68),('8537','2013-08-11','14:00:00',4.68),('8537','2013-08-11','14:05:00',4.64),('8537','2013-08-11','14:10:00',4.61),('8537','2013-08-11','14:15:00',4.51),('8537','2013-08-11','14:20:00',4.44),('8537','2013-08-11','14:25:00',4.48),('8537','2013-08-11','14:30:00',4.4),('8537','2013-08-11','14:35:00',4.38),('8537','2013-08-11','14:40:00',4.42),('8537','2013-08-11','14:45:00',4.33),('8537','2013-08-11','14:50:00',4.24),('8537','2013-08-11','14:55:00',4.16),('8537','2013-08-11','15:00:00',4.22),('8537','2013-08-11','15:05:00',4.2),('8537','2013-08-11','15:10:00',4.12),('8537','2013-08-11','15:15:00',4.04),('8537','2013-08-11','15:20:00',3.96),('8537','2013-08-11','15:25:00',3.99),('8537','2013-08-11','15:30:00',3.87),('8537','2013-08-11','15:35:00',3.64),('8537','2013-08-11','15:40:00',3.58),('8537','2013-08-11','15:45:00',3.61),('8537','2013-08-11','15:50:00',3.67),('8537','2013-08-11','15:55:00',3.6),('8537','2013-08-11','16:00:00',3.55),('8537','2013-08-11','16:05:00',3.49),('8537','2013-08-11','16:10:00',3.42),('8537','2013-08-11','16:15:00',3.33),('8537','2013-08-11','16:20:00',3.14),('8537','2013-08-11','16:25:00',2.9),('8537','2013-08-11','16:30:00',3.06),('8537','2013-08-11','16:35:00',2.99),('8537','2013-08-11','16:40:00',2.92),('8537','2013-08-11','16:45:00',2.83),('8537','2013-08-11','16:50:00',2.75),('8537','2013-08-11','16:55:00',2.62),('8537','2013-08-11','17:00:00',2.55),('8537','2013-08-11','17:05:00',2.46),('8537','2013-08-11','17:10:00',2.37),('8537','2013-08-11','17:15:00',2.25),('8537','2013-08-11','17:20:00',2.1),('8537','2013-08-11','17:25:00',2.05),('8537','2013-08-11','17:30:00',1.95),('8537','2013-08-11','17:35:00',1.88),('8537','2013-08-11','17:40:00',1.76),('8537','2013-08-11','17:45:00',1.66),('8537','2013-08-11','17:50:00',1.53),('8537','2013-08-11','17:55:00',1.45),('8537','2013-08-11','18:00:00',1.35),('8537','2013-08-11','18:05:00',1.26),('8537','2013-08-11','18:10:00',1.12),('8537','2013-08-11','18:15:00',1.02),('8537','2013-08-10','07:50:00',1.01),('8537','2013-08-10','07:55:00',1.11),('8537','2013-08-10','08:00:00',1.22),('8537','2013-08-10','08:05:00',1.33),('8537','2013-08-10','08:10:00',1.43),('8537','2013-08-10','08:15:00',1.55),('8537','2013-08-10','08:20:00',1.67),('8537','2013-08-10','08:25:00',1.78),('8537','2013-08-10','08:30:00',1.89),('8537','2013-08-10','08:35:00',1.99),('8537','2013-08-10','08:40:00',2.09),('8537','2013-08-10','08:45:00',2.18),('8537','2013-08-10','08:50:00',2.28),('8537','2013-08-10','08:55:00',2.38),('8537','2013-08-10','09:00:00',2.46),('8537','2013-08-10','09:05:00',2.56),('8537','2013-08-10','09:10:00',2.66),('8537','2013-08-10','09:15:00',2.77),('8537','2013-08-10','09:20:00',2.85),('8537','2013-08-10','09:25:00',2.94),('8537','2013-08-10','09:30:00',2.99),('8537','2013-08-10','09:35:00',3.11),('8537','2013-08-10','09:40:00',3.19),('8537','2013-08-10','09:45:00',3.29),('8537','2013-08-10','09:50:00',3.34),('8537','2013-08-10','09:55:00',3.41),('8537','2013-08-10','10:00:00',3.49),('8537','2013-08-10','10:05:00',3.55),('8537','2013-08-10','10:10:00',3.24),('8537','2013-08-10','10:15:00',3.12),('8537','2013-08-10','10:20:00',3.76),('8537','2013-08-10','10:25:00',3.83),('8537','2013-08-10','10:30:00',3.87),('8537','2013-08-10','10:35:00',3.89),('8537','2013-08-10','10:40:00',3.98),('8537','2013-08-10','10:45:00',4.03),('8537','2013-08-10','10:50:00',4.08),('8537','2013-08-10','10:55:00',4.18),('8537','2013-08-10','11:00:00',4.3),('8537','2013-08-10','11:05:00',4.32),('8537','2013-08-10','11:10:00',4.37),('8537','2013-08-10','11:15:00',3.63),('8537','2013-08-10','11:20:00',3.72),('8537','2013-08-10','11:25:00',3.06),('8537','2013-08-10','11:30:00',4.01),('8537','2013-08-10','11:35:00',4.55),('8537','2013-08-10','11:40:00',4.59),('8537','2013-08-10','11:45:00',4.6),('8537','2013-08-10','11:50:00',4.62),('8537','2013-08-10','11:55:00',4.63),('8537','2013-08-10','12:00:00',4.65),('8537','2013-08-10','12:05:00',4.67),('8537','2013-08-10','12:10:00',4.68),('8537','2013-08-10','12:15:00',4.73),('8537','2013-08-10','12:20:00',4.71),('8537','2013-08-10','12:25:00',4.79),('8537','2013-08-10','12:30:00',4.76),('8537','2013-08-10','12:35:00',4.79),('8537','2013-08-10','12:40:00',4.79),('8537','2013-08-10','12:45:00',4.88),('8537','2013-08-10','12:50:00',4.97),('8537','2013-08-10','12:55:00',4.94),('8537','2013-08-10','13:00:00',4.9),('8537','2013-08-10','13:05:00',4.87),('8537','2013-08-10','13:10:00',4.92),('8537','2013-08-10','13:15:00',5),('8537','2013-08-10','13:20:00',5.09),('8537','2013-08-10','13:25:00',5.14),('8537','2013-08-10','13:30:00',4.38),('8537','2013-08-10','13:35:00',3.9),('8537','2013-08-10','13:40:00',1.17),('8537','2013-08-10','13:45:00',1.35),('8537','2013-08-10','13:50:00',5.16),('8537','2013-08-10','13:55:00',4.95),('8537','2013-08-10','14:00:00',4.79),('8537','2013-08-10','14:05:00',3.38),('8537','2013-08-10','14:10:00',5.5),('8537','2013-08-10','14:15:00',5.07),('8537','2013-08-10','14:20:00',3.19),('8537','2013-08-10','14:25:00',1.52),('8537','2013-08-10','14:30:00',1.5),('8537','2013-08-10','14:35:00',1.33),('8537','2013-08-10','14:40:00',1.22),('8537','2013-08-10','14:45:00',1.15),('8537','2013-08-10','14:50:00',1.05),('8537','2013-08-10','14:55:00',1.01),('8537','2013-08-10','15:00:00',1.13),('8537','2013-08-10','15:05:00',1.23),('8537','2013-08-10','15:10:00',1.3),('8537','2013-08-10','15:15:00',1.48),('8537','2013-08-10','15:20:00',1.5),('8537','2013-08-10','15:25:00',1.34),('8537','2013-08-10','15:30:00',1.29),('8537','2013-08-10','15:35:00',1.6),('8537','2013-08-10','15:40:00',1.54),('8537','2013-08-10','15:45:00',1.65),('8537','2013-08-10','15:50:00',1.95),('8537','2013-08-10','15:55:00',2.22),('8537','2013-08-10','16:00:00',2.44),('8537','2013-08-10','16:05:00',4.76),('8537','2013-08-10','16:10:00',2.45),('8537','2013-08-10','16:15:00',2.51),('8537','2013-08-10','16:20:00',3.39),('8537','2013-08-10','16:25:00',1.44),('8537','2013-08-10','16:30:00',1.86),('8537','2013-08-10','16:35:00',3.45),('8537','2013-08-10','16:40:00',3.29),('8537','2013-08-10','16:45:00',3.22),('8537','2013-08-10','16:50:00',3.04),('8537','2013-08-10','16:55:00',2.77),('8537','2013-08-10','17:00:00',2.64),('8537','2013-08-10','17:05:00',1.64),('8537','2013-08-10','17:10:00',1.02),('8537','2013-08-10','17:15:00',1.19),('8537','2013-08-10','17:20:00',1.23),('8537','2013-08-10','17:25:00',1.45),('8537','2014-04-09','08:05:00',1.22),('8537','2014-04-09','08:10:00',1.14),('8537','2014-04-09','08:20:00',1.39),('8537','2014-04-09','09:00:00',1.02),('8537','2014-04-09','09:25:00',1.07),('8537','2014-04-09','09:30:00',1.15),('8537','2014-04-09','09:35:00',1.05),('8537','2014-04-09','09:40:00',1.06),('8537','2014-04-09','09:45:00',1.41),('8537','2014-04-09','09:50:00',2.26),('8537','2014-04-09','09:55:00',3.55),('8537','2014-04-09','10:00:00',3.49),('8537','2014-04-09','10:05:00',3.5),('8537','2014-04-09','10:10:00',3.66),('8537','2014-04-09','10:15:00',3.87),('8537','2014-04-09','10:20:00',3.89),('8537','2014-04-09','10:25:00',3.02),('8537','2014-04-09','10:30:00',3.18),('8537','2014-04-09','10:35:00',4.46),('8537','2014-04-09','10:40:00',1.76),('8537','2014-04-09','10:45:00',1.41),('8537','2014-04-09','10:50:00',1.69),('8537','2014-04-09','10:55:00',1.59),('8537','2014-04-09','11:00:00',4.31),('8537','2014-04-09','11:05:00',4.88),('8537','2014-04-09','11:10:00',4.88),('8537','2014-04-09','11:15:00',5.07),('8537','2014-04-09','11:20:00',4.46),('8537','2014-04-09','11:25:00',1.46),('8537','2014-04-09','11:30:00',1.26),('8537','2014-04-09','11:35:00',2.05),('8537','2014-04-09','11:40:00',5.11),('8537','2014-04-09','11:45:00',5.45),('8537','2014-04-09','11:50:00',4.48),('8537','2014-04-09','11:55:00',5.25),('8537','2014-04-09','12:00:00',5.45),('8537','2014-04-09','12:05:00',4.44),('8537','2014-04-09','12:10:00',2.46),('8537','2014-04-09','12:15:00',3.16),('8537','2014-04-09','12:20:00',1.64),('8537','2014-04-09','12:25:00',1.19),('8537','2014-04-09','13:15:00',1.01),('8537','2014-04-09','13:20:00',1.55),('8537','2014-04-09','13:25:00',1.82),('8537','2014-04-09','13:30:00',1.54),('8537','2014-04-09','13:35:00',1.46),('8537','2014-04-09','13:40:00',1.35),('8537','2014-04-09','13:45:00',1.2),('8537','2014-04-09','13:50:00',1.04),('8537','2014-04-09','14:00:00',1.08),('8537','2014-04-09','14:05:00',2.19),('8537','2014-04-09','14:10:00',2.29),('8537','2014-04-09','14:15:00',2.07),('8537','2014-04-09','14:20:00',2.26),('8537','2014-04-09','14:25:00',1.83),('8537','2014-04-09','14:30:00',3.17),('8537','2014-04-09','14:35:00',4.86),('8537','2014-04-09','14:40:00',2.38),('8537','2014-04-09','14:45:00',2.03),('8537','2014-04-09','14:50:00',2.35),('8537','2014-04-09','14:55:00',2.49),('8537','2014-04-09','15:00:00',2.79),('8537','2014-04-09','15:05:00',4.49),('8537','2014-04-09','15:10:00',3.92),('8537','2014-04-09','15:15:00',3.89),('8537','2014-04-09','15:20:00',4.31),('8537','2014-04-09','15:25:00',2.33),('8537','2014-04-09','15:30:00',3.79),('8537','2014-04-09','15:35:00',2.2),('8537','2014-04-09','15:40:00',2.4),('8537','2014-04-09','15:45:00',2.54),('8537','2014-04-09','15:50:00',2.07),('8537','2014-04-09','15:55:00',1.88),('8537','2014-04-09','16:00:00',1.44),('8537','2014-04-09','16:05:00',2.45),('8537','2014-04-09','16:10:00',3.31),('8537','2014-04-09','16:15:00',3.51),('8537','2014-04-09','16:20:00',3.5),('8537','2014-04-09','16:25:00',3.32),('8537','2014-04-09','16:30:00',3.4),('8537','2014-04-09','16:35:00',1.87),('8537','2014-04-09','16:40:00',1.61),('8537','2014-04-09','16:45:00',1.7),('8537','2014-04-09','16:50:00',2.09),('8537','2014-04-09','16:55:00',1.66),('8537','2014-04-09','17:00:00',1.99),('8537','2014-04-09','17:05:00',2.57),('8537','2014-04-09','17:10:00',2.07),('8537','2014-04-09','17:15:00',1.88),('8537','2014-04-09','17:20:00',2.07),('8537','2014-04-09','17:25:00',2.06),('8537','2014-04-09','17:30:00',1.39),('8537','2014-04-09','17:45:00',1.3),('8537','2014-04-09','17:50:00',1.29),('8537','2014-04-09','17:55:00',1.3),('8537','2014-04-09','18:00:00',1.13),('8537','2013-08-09','08:05:00',1.4),('8537','2013-08-09','08:10:00',1.12),('8537','2013-08-09','08:15:00',1.02),('8537','2013-08-09','08:30:00',1.06),('8537','2013-08-09','08:35:00',1.33),('8537','2013-08-09','08:40:00',1.69),('8537','2013-08-09','08:45:00',2.01),('8537','2013-08-09','08:50:00',2.06),('8537','2013-08-09','08:55:00',2.12),('8537','2013-08-09','09:00:00',2.16),('8537','2013-08-09','09:05:00',2.33),('8537','2013-08-09','09:10:00',2.61),('8537','2013-08-09','09:15:00',2.21),('8537','2013-08-09','09:20:00',2.42),('8537','2013-08-09','09:25:00',1.84),('8537','2013-08-09','09:30:00',2.91),('8537','2013-08-09','09:35:00',2.93),('8537','2013-08-09','09:40:00',2.07),('8537','2013-08-09','09:45:00',2.75),('8537','2013-08-09','09:50:00',3.01),('8537','2013-08-09','09:55:00',2),('8537','2013-08-09','10:00:00',2.32),('8537','2013-08-09','10:05:00',2.36),('8537','2013-08-09','10:10:00',2.58),('8537','2013-08-09','10:15:00',3.29),('8537','2013-08-09','10:20:00',3.3),('8537','2013-08-09','10:25:00',3.3),('8537','2013-08-09','10:30:00',2.8),('8537','2013-08-09','10:35:00',3.6),('8537','2013-08-09','10:40:00',3.77),('8537','2013-08-09','10:45:00',3.73),('8537','2013-08-09','10:50:00',3.73),('8537','2013-08-09','10:55:00',3.86),('8537','2013-08-09','11:00:00',3.92),('8537','2013-08-09','11:05:00',3.94),('8537','2013-08-09','11:10:00',4.01),('8537','2013-08-09','11:15:00',4.08),('8537','2013-08-09','11:20:00',4.08),('8537','2013-08-09','11:25:00',4.05),('8537','2013-08-09','11:30:00',4.12),('8537','2013-08-09','11:35:00',4.16),('8537','2013-08-09','11:40:00',4.17),('8537','2013-08-09','11:45:00',4.16),('8537','2013-08-09','11:50:00',4.27),('8537','2013-08-09','11:55:00',4.35),('8537','2013-08-09','12:00:00',4.36),('8537','2013-08-09','12:05:00',4.33),('8537','2013-08-09','12:10:00',4.34),('8537','2013-08-09','12:15:00',4.44),('8537','2013-08-09','12:20:00',4.58),('8537','2013-08-09','12:25:00',3.96),('8537','2013-08-09','12:30:00',3.31),('8537','2013-08-09','12:35:00',3.84),('8537','2013-08-09','12:40:00',4.41),('8537','2013-08-09','12:45:00',3.16),('8537','2013-08-09','12:50:00',3.28),('8537','2013-08-09','12:55:00',3.27),('8537','2013-08-09','13:00:00',1.58),('8537','2013-08-09','13:05:00',1.08),('8537','2013-08-09','13:10:00',1),('8537','2013-08-09','13:15:00',1.22),('8537','2013-08-09','13:20:00',1.67),('8537','2013-08-09','13:25:00',2.95),('8537','2013-08-09','13:30:00',2.34),('8537','2013-08-09','13:35:00',1.8),('8537','2013-08-09','13:40:00',1.78),('8537','2013-08-09','13:45:00',1.68),('8537','2013-08-09','13:50:00',1.75),('8537','2013-08-09','13:55:00',1.5),('8537','2013-08-09','14:00:00',1.41),('8537','2013-08-09','14:05:00',1.58),('8537','2013-08-09','14:10:00',1.64),('8537','2013-08-09','14:15:00',1.16),('8537','2013-08-09','14:20:00',1.08),('8537','2013-08-09','14:25:00',1.27),('8537','2013-08-09','14:30:00',1.25),('8537','2013-08-09','15:05:00',1.6),('8537','2013-08-09','15:10:00',3.07),('8537','2013-08-09','15:15:00',2.88),('8537','2013-08-09','15:20:00',1.75),('8537','2013-08-09','15:25:00',1.41),('8537','2013-08-09','15:30:00',1.35),('8537','2013-08-09','15:35:00',2.39),('8537','2013-08-09','15:40:00',1.84),('8537','2013-08-09','15:45:00',2.92),('8537','2013-08-09','15:50:00',2.36),('8537','2013-08-09','15:55:00',2.28),('8537','2013-08-09','16:00:00',1.34),('8537','2013-08-09','16:45:00',1),('8537','2013-08-09','16:50:00',1.61),('8537','2013-08-09','16:55:00',2.18),('8537','2013-08-09','17:00:00',1.65),('8537','2013-08-09','17:05:00',1.83),('8537','2013-08-09','17:10:00',1.11),('8537','2013-08-09','17:30:00',1.01),('8537','2013-08-09','17:35:00',1.03),('8537','2013-08-09','19:20:00',1.14),('8537','2013-08-09','19:25:00',1.07),('8537','2013-08-08','07:55:00',1.04),('8537','2013-08-08','08:00:00',1.13),('8537','2013-08-08','08:05:00',1.22),('8537','2013-08-08','08:10:00',1.32),('8537','2013-08-08','08:15:00',1.4),('8537','2013-08-08','08:20:00',1.48),('8537','2013-08-08','08:25:00',1.59),('8537','2013-08-08','08:30:00',1.68),('8537','2013-08-08','08:35:00',1.77),('8537','2013-08-08','08:40:00',1.85),('8537','2013-08-08','08:45:00',1.94),('8537','2013-08-08','08:50:00',1.99),('8537','2013-08-08','08:55:00',2.14),('8537','2013-08-08','09:00:00',2.24),('8537','2013-08-08','09:05:00',2.36),('8537','2013-08-08','09:10:00',2.45),('8537','2013-08-08','09:15:00',2.53),('8537','2013-08-08','09:20:00',2.62),('8537','2013-08-08','09:25:00',2.71),('8537','2013-08-08','09:30:00',2.8),('8537','2013-08-08','09:35:00',2.89),('8537','2013-08-08','09:40:00',2.97),('8537','2013-08-08','09:45:00',3.05),('8537','2013-08-08','09:50:00',3.13),('8537','2013-08-08','09:55:00',3.19),('8537','2013-08-08','10:00:00',3.25),('8537','2013-08-08','10:05:00',3.32),('8537','2013-08-08','10:10:00',3.36),('8537','2013-08-08','10:15:00',3.48),('8537','2013-08-08','10:20:00',3.51),('8537','2013-08-08','10:25:00',3.57),('8537','2013-08-08','10:30:00',3.63),('8537','2013-08-08','10:35:00',3.7),('8537','2013-08-08','10:40:00',3.75),('8537','2013-08-08','10:45:00',3.79),('8537','2013-08-08','10:50:00',3.82),('8537','2013-08-08','10:55:00',3.85),('8537','2013-08-08','11:00:00',3.88),('8537','2013-08-08','11:05:00',3.93),('8537','2013-08-08','11:10:00',3.99),('8537','2013-08-08','11:15:00',4.02),('8537','2013-08-08','11:20:00',4.03),('8537','2013-08-08','11:25:00',4.02),('8537','2013-08-08','11:30:00',4.05),('8537','2013-08-08','11:35:00',4.11),('8537','2013-08-08','11:40:00',4.16),('8537','2013-08-08','11:45:00',4.18),('8537','2013-08-08','11:50:00',4.2),('8537','2013-08-08','11:55:00',4.21),('8537','2013-08-08','12:00:00',4.26),('8537','2013-08-08','12:05:00',4.27),('8537','2013-08-08','12:10:00',4.26),('8537','2013-08-08','12:15:00',4.36),('8537','2013-08-08','12:20:00',4.32),('8537','2013-08-08','12:25:00',4.36),('8537','2013-08-08','12:30:00',4.32),('8537','2013-08-08','12:35:00',4.42),('8537','2013-08-08','12:40:00',4.47),('8537','2013-08-08','12:45:00',4.5),('8537','2013-08-08','12:50:00',4.52),('8537','2013-08-08','12:55:00',4.52),('8537','2013-08-08','13:00:00',4.5),('8537','2013-08-08','13:05:00',4.53),('8537','2013-08-08','13:10:00',4.54),('8537','2013-08-08','13:15:00',4.49),('8537','2013-08-08','13:20:00',4.49),('8537','2013-08-08','13:25:00',4.55),('8537','2013-08-08','13:30:00',4.53),('8537','2013-08-08','13:35:00',4.49),('8537','2013-08-08','13:40:00',4.45),('8537','2013-08-08','13:45:00',4.46),('8537','2013-08-08','13:50:00',4.47),('8537','2013-08-08','13:55:00',4.4),('8537','2013-08-08','14:00:00',4.4),('8537','2013-08-08','14:05:00',4.41),('8537','2013-08-08','14:10:00',4.36),('8537','2013-08-08','14:15:00',4.31),('8537','2013-08-08','14:20:00',4.28),('8537','2013-08-08','14:25:00',4.28),('8537','2013-08-08','14:30:00',4.29),('8537','2013-08-08','14:35:00',4.24),('8537','2013-08-08','14:40:00',4.16),('8537','2013-08-08','14:45:00',3.95),('8537','2013-08-08','14:50:00',3.67),('8537','2013-08-08','14:55:00',3.66),('8537','2013-08-08','15:00:00',4.02),('8537','2013-08-08','15:05:00',3.97),('8537','2013-08-08','15:10:00',3.91),('8537','2013-08-08','15:15:00',3.86),('8537','2013-08-08','15:20:00',3.81),('8537','2013-08-08','15:25:00',3.74),('8537','2013-08-08','15:30:00',3.68),('8537','2013-08-08','15:35:00',3.62),('8537','2013-08-08','15:40:00',3.5),('8537','2013-08-08','15:45:00',3.5),('8537','2013-08-08','15:50:00',3.44),('8537','2013-08-08','15:55:00',3.38),('8537','2013-08-08','16:00:00',3.34),('8537','2013-08-08','16:05:00',3.3),('8537','2013-08-08','16:10:00',3.25),('8537','2013-08-08','16:15:00',3.18),('8537','2013-08-08','16:20:00',3.1),('8537','2013-08-08','16:25:00',3.04),('8537','2013-08-08','16:30:00',2.98),('8537','2013-08-08','16:35:00',2.91),('8537','2013-08-08','16:40:00',2.82),('8537','2013-08-08','16:45:00',2.75),('8537','2013-08-08','16:50:00',2.65),('8537','2013-08-08','16:55:00',2.55),('8537','2013-08-08','17:00:00',2.45),('8537','2013-08-08','17:05:00',2.36),('8537','2013-08-08','17:10:00',2.28),('8537','2013-08-08','17:15:00',2.2),('8537','2013-08-08','17:20:00',2.03),('8537','2013-08-08','17:25:00',1.97),('8537','2013-08-08','17:30:00',1.89),('8537','2013-08-08','17:35:00',1.8),('8537','2013-08-08','17:40:00',1.68),('8537','2013-08-08','17:45:00',1.6),('8537','2013-08-08','17:50:00',1.49),('8537','2013-08-08','17:55:00',1.41),('8537','2013-08-08','18:00:00',1.33),('8537','2013-08-08','18:05:00',1.24),('8537','2013-08-08','18:10:00',1.15),('8537','2013-08-08','18:15:00',1.05),('8537','2013-08-07','07:55:00',1.09),('8537','2013-08-07','08:00:00',1.19),('8537','2013-08-07','08:05:00',1.27),('8537','2013-08-07','08:10:00',1.38),('8537','2013-08-07','08:15:00',1.48),('8537','2013-08-07','08:20:00',1.58),('8537','2013-08-07','08:25:00',1.68),('8537','2013-08-07','08:30:00',1.77),('8537','2013-08-07','08:35:00',1.86),('8537','2013-08-07','08:40:00',1.98),('8537','2013-08-07','08:45:00',2.07),('8537','2013-08-07','08:50:00',2.16),('8537','2013-08-07','08:55:00',2.26),('8537','2013-08-07','09:00:00',2.36),('8537','2013-08-07','09:05:00',2.43),('8537','2013-08-07','09:10:00',2.5),('8537','2013-08-07','09:15:00',2.58),('8537','2013-08-07','09:20:00',2.66),('8537','2013-08-07','09:25:00',2.77),('8537','2013-08-07','09:30:00',2.86),('8537','2013-08-07','09:35:00',2.95),('8537','2013-08-07','09:40:00',3.04),('8537','2013-08-07','09:45:00',3.1),('8537','2013-08-07','09:50:00',3.18),('8537','2013-08-07','09:55:00',3.21),('8537','2013-08-07','10:00:00',3.28),('8537','2013-08-07','10:05:00',3.38),('8537','2013-08-07','10:10:00',3.44),('8537','2013-08-07','10:15:00',3.5),('8537','2013-08-07','10:20:00',3.55),('8537','2013-08-07','10:25:00',3.63),('8537','2013-08-07','10:30:00',3.65),('8537','2013-08-07','10:35:00',3.69),('8537','2013-08-07','10:40:00',3.75),('8537','2013-08-07','10:45:00',3.8),('8537','2013-08-07','10:50:00',3.86),('8537','2013-08-07','10:55:00',3.92),('8537','2013-08-07','11:00:00',3.94),('8537','2013-08-07','11:05:00',3.93),('8537','2013-08-07','11:10:00',4.04),('8537','2013-08-07','11:15:00',4.08),('8537','2013-08-07','11:20:00',4.13),('8537','2013-08-07','11:25:00',4.15),('8537','2013-08-07','11:30:00',4.19),('8537','2013-08-07','11:35:00',4.23),('8537','2013-08-07','11:40:00',4.22),('8537','2013-08-07','11:45:00',4.25),('8537','2013-08-07','11:50:00',4.24),('8537','2013-08-07','11:55:00',4.29),('8537','2013-08-07','12:00:00',4.34),('8537','2013-08-07','12:05:00',4.38),('8537','2013-08-07','12:10:00',4.41),('8537','2013-08-07','12:15:00',4.47),('8537','2013-08-07','12:20:00',4.44),('8537','2013-08-07','12:25:00',4.41),('8537','2013-08-07','12:30:00',4.4),('8537','2013-08-07','12:35:00',4.42),('8537','2013-08-07','12:40:00',4.37),('8537','2013-08-07','12:45:00',4.29),('8537','2013-08-07','12:50:00',4.46),('8537','2013-08-07','12:55:00',4.44),('8537','2013-08-07','13:00:00',4.48),('8537','2013-08-07','13:05:00',4.47),('8537','2013-08-07','13:10:00',4.52),('8537','2013-08-07','13:15:00',4.49),('8537','2013-08-07','13:20:00',4.52),('8537','2013-08-07','13:25:00',4.43),('8537','2013-08-07','13:30:00',4.52),('8537','2013-08-07','13:35:00',4.43),('8537','2013-08-07','13:40:00',4.49),('8537','2013-08-07','13:45:00',4.53),('8537','2013-08-07','13:50:00',4.45),('8537','2013-08-07','13:55:00',4.52),('8537','2013-08-07','14:00:00',4.44),('8537','2013-08-07','14:05:00',4.42),('8537','2013-08-07','14:10:00',4.35),('8537','2013-08-07','14:15:00',4.32),('8537','2013-08-07','14:20:00',4.29),('8537','2013-08-07','14:25:00',4.23),('8537','2013-08-07','14:30:00',4.19),('8537','2013-08-07','14:35:00',4.13),('8537','2013-08-07','14:40:00',4.07),('8537','2013-08-07','14:45:00',4.01),('8537','2013-08-07','14:50:00',3.73),('8537','2013-08-07','14:55:00',3.87),('8537','2013-08-07','15:00:00',4.01),('8537','2013-08-07','15:05:00',3.97),('8537','2013-08-07','15:10:00',3.93),('8537','2013-08-07','15:15:00',3.92),('8537','2013-08-07','15:20:00',3.89),('8537','2013-08-07','15:25:00',3.8),('8537','2013-08-07','15:30:00',3.76),('8537','2013-08-07','15:35:00',3.7),('8537','2013-08-07','15:40:00',3.6),('8537','2013-08-07','15:45:00',3.57),('8537','2013-08-07','15:50:00',3.51),('8537','2013-08-07','15:55:00',3.48),('8537','2013-08-07','16:00:00',3.37),('8537','2013-08-07','16:05:00',3.33),('8537','2013-08-07','16:10:00',3.22),('8537','2013-08-07','16:15:00',3.19),('8537','2013-08-07','16:20:00',3.09),('8537','2013-08-07','16:25:00',3.02),('8537','2013-08-07','16:30:00',2.98),('8537','2013-08-07','16:35:00',2.9),('8537','2013-08-07','16:40:00',2.84),('8537','2013-08-07','16:45:00',2.76),('8537','2013-08-07','16:50:00',2.71),('8537','2013-08-07','16:55:00',2.64),('8537','2013-08-07','17:00:00',2.52),('8537','2013-08-07','17:05:00',2.43),('8537','2013-08-07','17:10:00',2.32),('8537','2013-08-07','17:15:00',2.25),('8537','2013-08-07','17:20:00',2.09),('8537','2013-08-07','17:25:00',1.99),('8537','2013-08-07','17:30:00',1.92),('8537','2013-08-07','17:35:00',1.83),('8537','2013-08-07','17:40:00',1.71),('8537','2013-08-07','17:45:00',1.63),('8537','2013-08-07','17:50:00',1.52),('8537','2013-08-07','17:55:00',1.44),('8537','2013-08-07','18:00:00',1.35),('8537','2013-08-07','18:05:00',1.26),('8537','2013-08-07','18:10:00',1.15),('8537','2013-08-07','18:15:00',1.05),('8537','2013-08-06','07:55:00',1.06),('8537','2013-08-06','08:00:00',1.15),('8537','2013-08-06','08:05:00',1.24),('8537','2013-08-06','08:10:00',1.35),('8537','2013-08-06','08:15:00',1.45),('8537','2013-08-06','08:20:00',1.55),('8537','2013-08-06','08:25:00',1.64),('8537','2013-08-06','08:30:00',1.74),('8537','2013-08-06','08:35:00',1.83),('8537','2013-08-06','08:40:00',1.94),('8537','2013-08-06','08:45:00',2.04),('8537','2013-08-06','08:50:00',2.14),('8537','2013-08-06','08:55:00',2.21),('8537','2013-08-06','09:00:00',2.3),('8537','2013-08-06','09:05:00',2.37),('8537','2013-08-06','09:10:00',2.47),('8537','2013-08-06','09:15:00',2.58),('8537','2013-08-06','09:20:00',2.67),('8537','2013-08-06','09:25:00',2.74),('8537','2013-08-06','09:30:00',2.82),('8537','2013-08-06','09:35:00',2.93),('8537','2013-08-06','09:40:00',3),('8537','2013-08-06','09:45:00',3.05),('8537','2013-08-06','09:50:00',3.12),('8537','2013-08-06','09:55:00',3.21),('8537','2013-08-06','10:00:00',3.27),('8537','2013-08-06','10:05:00',3.33),('8537','2013-08-06','10:10:00',3.4),('8537','2013-08-06','10:15:00',3.45),('8537','2013-08-06','10:20:00',3.49),('8537','2013-08-06','10:25:00',3.57),('8537','2013-08-06','10:30:00',3.63),('8537','2013-08-06','10:35:00',3.65),('8537','2013-08-06','10:40:00',3.69),('8537','2013-08-06','10:45:00',3.73),('8537','2013-08-06','10:50:00',3.77),('8537','2013-08-06','10:55:00',3.87),('8537','2013-08-06','11:00:00',3.95),('8537','2013-08-06','11:05:00',3.86),('8537','2013-08-06','11:10:00',4),('8537','2013-08-06','11:15:00',4.06),('8537','2013-08-06','11:20:00',4.09),('8537','2013-08-06','11:25:00',4.09),('8537','2013-08-06','11:30:00',4.17),('8537','2013-08-06','11:35:00',4.22),('8537','2013-08-06','11:40:00',4.22),('8537','2013-08-06','11:45:00',4.22),('8537','2013-08-06','11:50:00',4.22),('8537','2013-08-06','11:55:00',4.32),('8537','2013-08-06','12:00:00',4.33),('8537','2013-08-06','12:05:00',4.33),('8537','2013-08-06','12:10:00',4.31),('8537','2013-08-06','12:15:00',4.31),('8537','2013-08-06','12:20:00',4.34),('8537','2013-08-06','12:25:00',4.33),('8537','2013-08-06','12:30:00',4.34),('8537','2013-08-06','12:35:00',4.39),('8537','2013-08-06','12:40:00',4.34),('8537','2013-08-06','12:45:00',4.33),('8537','2013-08-06','12:50:00',4.39),('8537','2013-08-06','12:55:00',4.34),('8537','2013-08-06','13:00:00',4.43),('8537','2013-08-06','13:05:00',4.46),('8537','2013-08-06','13:10:00',4.52),('8537','2013-08-06','13:15:00',4.51),('8537','2013-08-06','13:20:00',4.49),('8537','2013-08-06','13:25:00',4.48),('8537','2013-08-06','13:30:00',4.53),('8537','2013-08-06','13:35:00',4.54),('8537','2013-08-06','13:40:00',4.58),('8537','2013-08-06','13:45:00',4.57),('8537','2013-08-06','13:50:00',4.56),('8537','2013-08-06','13:55:00',4.56),('8537','2013-08-06','14:00:00',4.57),('8537','2013-08-06','14:05:00',4.56),('8537','2013-08-06','14:10:00',4.54),('8537','2013-08-06','14:15:00',4.55),('8537','2013-08-06','14:20:00',4.52),('8537','2013-08-06','14:25:00',4.48),('8537','2013-08-06','14:30:00',4.45),('8537','2013-08-06','14:35:00',4.39),('8537','2013-08-06','14:40:00',4.31),('8537','2013-08-06','14:45:00',4.11),('8537','2013-08-06','14:50:00',3.8),('8537','2013-08-06','14:55:00',4.03),('8537','2013-08-06','15:00:00',4.2),('8537','2013-08-06','15:05:00',4.15),('8537','2013-08-06','15:10:00',4.14),('8537','2013-08-06','15:15:00',4.09),('8537','2013-08-06','15:20:00',4.04),('8537','2013-08-06','15:25:00',3.98),('8537','2013-08-06','15:30:00',3.93),('8537','2013-08-06','15:35:00',3.88),('8537','2013-08-06','15:40:00',3.75),('8537','2013-08-06','15:45:00',3.7),('8537','2013-08-06','15:50:00',3.65),('8537','2013-08-06','15:55:00',3.57),('8537','2013-08-06','16:00:00',3.53),('8537','2013-08-06','16:05:00',3.46),('8537','2013-08-06','16:10:00',3.4),('8537','2013-08-06','16:15:00',3.34),('8537','2013-08-06','16:20:00',3.24),('8537','2013-08-06','16:25:00',3.14),('8537','2013-08-06','16:30:00',3.07),('8537','2013-08-06','16:35:00',2.99),('8537','2013-08-06','16:40:00',2.94),('8537','2013-08-06','16:45:00',2.86),('8537','2013-08-06','16:50:00',2.77),('8537','2013-08-06','16:55:00',2.69),('8537','2013-08-06','17:00:00',2.57),('8537','2013-08-06','17:05:00',2.51),('8537','2013-08-06','17:10:00',2.4),('8537','2013-08-06','17:15:00',2.31),('8537','2013-08-06','17:20:00',2.15),('8537','2013-08-06','17:25:00',1.98),('8537','2013-08-06','17:30:00',2),('8537','2013-08-06','17:35:00',1.91),('8537','2013-08-06','17:40:00',1.78),('8537','2013-08-06','17:45:00',1.68),('8537','2013-08-06','17:50:00',1.57),('8537','2013-08-06','17:55:00',1.48),('8537','2013-08-06','18:00:00',1.39),('8537','2013-08-06','18:05:00',1.3),('8537','2013-08-06','18:10:00',1.21),('8537','2013-08-06','18:15:00',1.11),('8537','2013-08-06','18:20:00',1.02),('8537','2013-08-05','07:50:00',1.04),('8537','2013-08-05','07:55:00',1.14),('8537','2013-08-05','08:00:00',1.23),('8537','2013-08-05','08:05:00',1.33),('8537','2013-08-05','08:10:00',1.43),('8537','2013-08-05','08:15:00',1.52),('8537','2013-08-05','08:20:00',1.61),('8537','2013-08-05','08:25:00',1.71),('8537','2013-08-05','08:30:00',1.8),('8537','2013-08-05','08:35:00',1.9),('8537','2013-08-05','08:40:00',2),('8537','2013-08-05','08:45:00',2.1),('8537','2013-08-05','08:50:00',2.18),('8537','2013-08-05','08:55:00',2.28),('8537','2013-08-05','09:00:00',2.37),('8537','2013-08-05','09:05:00',2.45),('8537','2013-08-05','09:10:00',2.53),('8537','2013-08-05','09:15:00',2.61),('8537','2013-08-05','09:20:00',2.69),('8537','2013-08-05','09:25:00',2.77),('8537','2013-08-05','09:30:00',2.86),('8537','2013-08-05','09:35:00',2.94),('8537','2013-08-05','09:40:00',3.01),('8537','2013-08-05','09:45:00',3.07),('8537','2013-08-05','09:50:00',3.14),('8537','2013-08-05','09:55:00',3.23),('8537','2013-08-05','10:00:00',3.32),('8537','2013-08-05','10:05:00',3.37),('8537','2013-08-05','10:10:00',3.48),('8537','2013-08-05','10:15:00',3.55),('8537','2013-08-05','10:20:00',3.58),('8537','2013-08-05','10:25:00',3.63),('8537','2013-08-05','10:30:00',3.67),('8537','2013-08-05','10:35:00',3.74),('8537','2013-08-05','10:40:00',3.81),('8537','2013-08-05','10:45:00',3.85),('8537','2013-08-05','10:50:00',3.91),('8537','2013-08-05','10:55:00',3.96),('8537','2013-08-05','11:00:00',4.02),('8537','2013-08-05','11:05:00',4.08),('8537','2013-08-05','11:10:00',4.14),('8537','2013-08-05','11:15:00',4.13),('8537','2013-08-05','11:20:00',4.23),('8537','2013-08-05','11:25:00',4.25),('8537','2013-08-05','11:30:00',4.25),('8537','2013-08-05','11:35:00',4.32),('8537','2013-08-05','11:40:00',4.31),('8537','2013-08-05','11:45:00',4.34),('8537','2013-08-05','11:50:00',4.38),('8537','2013-08-05','11:55:00',4.41),('8537','2013-08-05','12:00:00',4.43),('8537','2013-08-05','12:05:00',4.42),('8537','2013-08-05','12:10:00',4.46),('8537','2013-08-05','12:15:00',4.5),('8537','2013-08-05','12:20:00',4.51),('8537','2013-08-05','12:25:00',4.56),('8537','2013-08-05','12:30:00',4.55),('8537','2013-08-05','12:35:00',4.53),('8537','2013-08-05','12:40:00',4.53),('8537','2013-08-05','12:45:00',4.53),('8537','2013-08-05','12:50:00',4.54),('8537','2013-08-05','12:55:00',4.52),('8537','2013-08-05','13:00:00',4.57),('8537','2013-08-05','13:05:00',4.51),('8537','2013-08-05','13:10:00',4.62),('8537','2013-08-05','13:15:00',4.61),('8537','2013-08-05','13:20:00',4.6),('8537','2013-08-05','13:25:00',4.56),('8537','2013-08-05','13:30:00',4.58),('8537','2013-08-05','13:35:00',4.55),('8537','2013-08-05','13:40:00',4.51),('8537','2013-08-05','13:45:00',4.46),('8537','2013-08-05','13:50:00',4.41),('8537','2013-08-05','13:55:00',4.44),('8537','2013-08-05','14:00:00',4.47),('8537','2013-08-05','14:05:00',4.44),('8537','2013-08-05','14:10:00',4.37),('8537','2013-08-05','14:15:00',4.32),('8537','2013-08-05','14:20:00',4.31),('8537','2013-08-05','14:25:00',4.3),('8537','2013-08-05','14:30:00',4.31),('8537','2013-08-05','14:35:00',4.28),('8537','2013-08-05','14:40:00',4.28),('8537','2013-08-05','14:45:00',4.11),('8537','2013-08-05','14:50:00',3.77),('8537','2013-08-05','14:55:00',4.09),('8537','2013-08-05','15:00:00',4.06),('8537','2013-08-05','15:05:00',4.07),('8537','2013-08-05','15:10:00',4.03),('8537','2013-08-05','15:15:00',4),('8537','2013-08-05','15:20:00',3.96),('8537','2013-08-05','15:25:00',3.92),('8537','2013-08-05','15:30:00',3.87),('8537','2013-08-05','15:35:00',3.82),('8537','2013-08-05','15:40:00',3.65),('8537','2013-08-05','15:45:00',3.65),('8537','2013-08-05','15:50:00',3.61),('8537','2013-08-05','15:55:00',3.53),('8537','2013-08-05','16:00:00',3.5),('8537','2013-08-05','16:05:00',3.46),('8537','2013-08-05','16:10:00',3.39),('8537','2013-08-05','16:15:00',3.32),('8537','2013-08-05','16:20:00',3.22),('8537','2013-08-05','16:25:00',3.11),('8537','2013-08-05','16:30:00',3.05),('8537','2013-08-05','16:35:00',2.99),('8537','2013-08-05','16:40:00',2.91),('8537','2013-08-05','16:45:00',2.84),('8537','2013-08-05','16:50:00',2.76),('8537','2013-08-05','16:55:00',2.67),('8537','2013-08-05','17:00:00',2.5),('8537','2013-08-05','17:05:00',2.11),('8537','2013-08-05','17:10:00',2.26),('8537','2013-08-05','17:15:00',2.28),('8537','2013-08-05','17:20:00',2.13),('8537','2013-08-05','17:25:00',2.01),('8537','2013-08-05','17:30:00',1.96),('8537','2013-08-05','17:35:00',1.88),('8537','2013-08-05','17:40:00',1.79),('8537','2013-08-05','17:45:00',1.68),('8537','2013-08-05','17:50:00',1.57),('8537','2013-08-05','17:55:00',1.46),('8537','2013-08-05','18:00:00',1.38),('8537','2013-08-05','18:05:00',1.27),('8537','2013-08-05','18:10:00',1.18),('8537','2013-08-05','18:15:00',1.08),('8537','2013-08-04','07:50:00',1.1),('8537','2013-08-04','07:55:00',1.2),('8537','2013-08-04','08:00:00',1.31),('8537','2013-08-04','08:05:00',1.41),('8537','2013-08-04','08:10:00',1.52),('8537','2013-08-04','08:15:00',1.62),('8537','2013-08-04','08:20:00',1.73),('8537','2013-08-04','08:25:00',1.83),('8537','2013-08-04','08:30:00',1.93),('8537','2013-08-04','08:35:00',2.03),('8537','2013-08-04','08:40:00',2.14),('8537','2013-08-04','08:45:00',2.22),('8537','2013-08-04','08:50:00',2.34),('8537','2013-08-04','08:55:00',2.44),('8537','2013-08-04','09:00:00',2.53),('8537','2013-08-04','09:05:00',2.61),('8537','2013-08-04','09:10:00',2.69),('8537','2013-08-04','09:15:00',2.76),('8537','2013-08-04','09:20:00',2.84),('8537','2013-08-04','09:25:00',2.93),('8537','2013-08-04','09:30:00',3),('8537','2013-08-04','09:35:00',3.09),('8537','2013-08-04','09:40:00',3.19),('8537','2013-08-04','09:45:00',3.26),('8537','2013-08-04','09:50:00',3.32),('8537','2013-08-04','09:55:00',3.4),('8537','2013-08-04','10:00:00',3.46),('8537','2013-08-04','10:05:00',3.54),('8537','2013-08-04','10:10:00',3.61),('8537','2013-08-04','10:15:00',3.65),('8537','2013-08-04','10:20:00',3.72),('8537','2013-08-04','10:25:00',3.81),('8537','2013-08-04','10:30:00',3.87),('8537','2013-08-04','10:35:00',3.87),('8537','2013-08-04','10:40:00',3.94),('8537','2013-08-04','10:45:00',4.02),('8537','2013-08-04','10:50:00',4.07),('8537','2013-08-04','10:55:00',4.1),('8537','2013-08-04','11:00:00',4.12),('8537','2013-08-04','11:05:00',4.14),('8537','2013-08-04','11:10:00',4.17),('8537','2013-08-04','11:15:00',4.21),('8537','2013-08-04','11:20:00',4.23),('8537','2013-08-04','11:25:00',4.31),('8537','2013-08-04','11:30:00',4.37),('8537','2013-08-04','11:35:00',4.45),('8537','2013-08-04','11:40:00',4.49),('8537','2013-08-04','11:45:00',4.5),('8537','2013-08-04','11:50:00',4.51),('8537','2013-08-04','11:55:00',4.59),('8537','2013-08-04','12:00:00',4.57),('8537','2013-08-04','12:05:00',4.57),('8537','2013-08-04','12:10:00',4.57),('8537','2013-08-04','12:15:00',4.58),('8537','2013-08-04','12:20:00',4.56),('8537','2013-08-04','12:25:00',4.56),('8537','2013-08-04','12:30:00',4.6),('8537','2013-08-04','12:35:00',4.61),('8537','2013-08-04','12:40:00',4.63),('8537','2013-08-04','12:45:00',4.66),('8537','2013-08-04','12:50:00',4.65),('8537','2013-08-04','12:55:00',4.63),('8537','2013-08-04','13:00:00',4.64),('8537','2013-08-04','13:05:00',4.63),('8537','2013-08-04','13:10:00',4.63),('8537','2013-08-04','13:15:00',4.67),('8537','2013-08-04','13:20:00',4.64),('8537','2013-08-04','13:25:00',4.61),('8537','2013-08-04','13:30:00',4.63),('8537','2013-08-04','13:35:00',4.64),('8537','2013-08-04','13:40:00',4.75),('8537','2013-08-04','13:45:00',4.72),('8537','2013-08-04','13:50:00',4.71),('8537','2013-08-04','13:55:00',4.68),('8537','2013-08-04','14:00:00',4.69),('8537','2013-08-04','14:05:00',4.67),('8537','2013-08-04','14:10:00',4.63),('8537','2013-08-04','14:15:00',4.62),('8537','2013-08-04','14:20:00',4.57),('8537','2013-08-04','14:25:00',4.55),('8537','2013-08-04','14:30:00',4.52),('8537','2013-08-04','14:35:00',4.49),('8537','2013-08-04','14:40:00',4.47),('8537','2013-08-04','14:45:00',4.39),('8537','2013-08-04','14:50:00',4.32),('8537','2013-08-04','14:55:00',4.32),('8537','2013-08-04','15:00:00',4.28),('8537','2013-08-04','15:05:00',4.24),('8537','2013-08-04','15:10:00',4.2),('8537','2013-08-04','15:15:00',4.18),('8537','2013-08-04','15:20:00',4.12),('8537','2013-08-04','15:25:00',4.05),('8537','2013-08-04','15:30:00',3.93),('8537','2013-08-04','15:35:00',3.98),('8537','2013-08-04','15:40:00',3.79),('8537','2013-08-04','15:45:00',3.71),('8537','2013-08-04','15:50:00',3.7),('8537','2013-08-04','15:55:00',3.66),('8537','2013-08-04','16:00:00',3.6),('8537','2013-08-04','16:05:00',3.55),('8537','2013-08-04','16:10:00',3.49),('8537','2013-08-04','16:15:00',3.44),('8537','2013-08-04','16:20:00',3.36),('8537','2013-08-04','16:25:00',3.25),('8537','2013-08-04','16:30:00',3.16),('8537','2013-08-04','16:35:00',3.08),('8537','2013-08-04','16:40:00',3.02),('8537','2013-08-04','16:45:00',2.94),('8537','2013-08-04','16:50:00',2.84),('8537','2013-08-04','16:55:00',2.76),('8537','2013-08-04','17:00:00',2.58),('8537','2013-08-04','17:05:00',2.22),('8537','2013-08-04','17:10:00',2.5),('8537','2013-08-04','17:15:00',2.39),('8537','2013-08-04','17:20:00',2.28),('8537','2013-08-04','17:25:00',2.14),('8537','2013-08-04','17:30:00',2.05),('8537','2013-08-04','17:35:00',1.97),('8537','2013-08-04','17:40:00',1.86),('8537','2013-08-04','17:45:00',1.75),('8537','2013-08-04','17:50:00',1.66),('8537','2013-08-04','17:55:00',1.54),('8537','2013-08-04','18:00:00',1.44),('8537','2013-08-04','18:05:00',1.34),('8537','2013-08-04','18:10:00',1.24),('8537','2013-08-04','18:15:00',1.14),('8537','2013-08-04','18:20:00',1.06),('8537','2013-08-03','07:50:00',1.05),('8537','2013-08-03','07:55:00',1.15),('8537','2013-08-03','08:00:00',1.25),('8537','2013-08-03','08:05:00',1.34),('8537','2013-08-03','08:10:00',1.44),('8537','2013-08-03','08:15:00',1.54),('8537','2013-08-03','08:20:00',1.65),('8537','2013-08-03','08:25:00',1.75),('8537','2013-08-03','08:30:00',1.85),('8537','2013-08-03','08:35:00',1.93),('8537','2013-08-03','08:40:00',2.03),('8537','2013-08-03','08:45:00',2.12),('8537','2013-08-03','08:50:00',2.21),('8537','2013-08-03','08:55:00',2.31),('8537','2013-08-03','09:00:00',2.4),('8537','2013-08-03','09:05:00',2.48),('8537','2013-08-03','09:10:00',2.56),('8537','2013-08-03','09:15:00',2.65),('8537','2013-08-03','09:20:00',2.74),('8537','2013-08-03','09:25:00',2.83),('8537','2013-08-03','09:30:00',2.6),('8537','2013-08-03','09:35:00',2.63),('8537','2013-08-03','09:40:00',2.69),('8537','2013-08-03','09:45:00',2.76),('8537','2013-08-03','09:50:00',2.73),('8537','2013-08-03','09:55:00',2.84),('8537','2013-08-03','10:00:00',2.99),('8537','2013-08-03','10:05:00',3),('8537','2013-08-03','10:10:00',3.25),('8537','2013-08-03','10:15:00',3.54),('8537','2013-08-03','10:20:00',3.5),('8537','2013-08-03','10:25:00',3.59),('8537','2013-08-03','10:30:00',3.68),('8537','2013-08-03','10:35:00',3.68),('8537','2013-08-03','10:40:00',3.82),('8537','2013-08-03','10:45:00',3.87),('8537','2013-08-03','10:50:00',4.04),('8537','2013-08-03','10:55:00',4.12),('8537','2013-08-03','11:00:00',4.15),('8537','2013-08-03','11:05:00',4.17),('8537','2013-08-03','11:10:00',4.18),('8537','2013-08-03','11:15:00',4.24),('8537','2013-08-03','11:20:00',4.3),('8537','2013-08-03','11:25:00',4.35),('8537','2013-08-03','11:30:00',4.4),('8537','2013-08-03','11:35:00',4.44),('8537','2013-08-03','11:40:00',4.42),('8537','2013-08-03','11:45:00',4.42),('8537','2013-08-03','11:50:00',4.5),('8537','2013-08-03','11:55:00',4.49),('8537','2013-08-03','12:00:00',4.5),('8537','2013-08-03','12:05:00',4.53),('8537','2013-08-03','12:10:00',4.55),('8537','2013-08-03','12:15:00',4.54),('8537','2013-08-03','12:20:00',4.56),('8537','2013-08-03','12:25:00',4.62),('8537','2013-08-03','12:30:00',4.62),('8537','2013-08-03','12:35:00',4.58),('8537','2013-08-03','12:40:00',4.6),('8537','2013-08-03','12:45:00',4.63),('8537','2013-08-03','12:50:00',4.68),('8537','2013-08-03','12:55:00',4.64),('8537','2013-08-03','13:00:00',4.64),('8537','2013-08-03','13:05:00',4.58),('8537','2013-08-03','13:10:00',4.61),('8537','2013-08-03','13:15:00',4.65),('8537','2013-08-03','13:20:00',4.53),('8537','2013-08-03','13:25:00',4.5),('8537','2013-08-03','13:30:00',4.52),('8537','2013-08-03','13:35:00',4.44),('8537','2013-08-03','13:40:00',4.51),('8537','2013-08-03','13:45:00',4.58),('8537','2013-08-03','13:50:00',4.53),('8537','2013-08-03','13:55:00',4.51),('8537','2013-08-03','14:00:00',4.53),('8537','2013-08-03','14:05:00',4.51),('8537','2013-08-03','14:10:00',4.41),('8537','2013-08-03','14:15:00',4.29),('8537','2013-08-03','14:20:00',4.32),('8537','2013-08-03','14:25:00',4.3),('8537','2013-08-03','14:30:00',4.33),('8537','2013-08-03','14:35:00',4.46),('8537','2013-08-03','14:40:00',4.37),('8537','2013-08-03','14:45:00',4.31),('8537','2013-08-03','14:50:00',4.3),('8537','2013-08-03','14:55:00',4.29),('8537','2013-08-03','15:00:00',4.25),('8537','2013-08-03','15:05:00',4.15),('8537','2013-08-03','15:10:00',4.11),('8537','2013-08-03','15:15:00',4.05),('8537','2013-08-03','15:20:00',4.03),('8537','2013-08-03','15:25:00',4.02),('8537','2013-08-03','15:30:00',3.99),('8537','2013-08-03','15:35:00',3.86),('8537','2013-08-03','15:40:00',3.8),('8537','2013-08-03','15:45:00',3.71),('8537','2013-08-03','15:50:00',3.74),('8537','2013-08-03','15:55:00',3.65),('8537','2013-08-03','16:00:00',3.56),('8537','2013-08-03','16:05:00',3.48),('8537','2013-08-03','16:10:00',3.41),('8537','2013-08-03','16:15:00',3.34),('8537','2013-08-03','16:20:00',3.25),('8537','2013-08-03','16:25:00',3.16),('8537','2013-08-03','16:30:00',3.11),('8537','2013-08-03','16:35:00',3.04),('8537','2013-08-03','16:40:00',2.97),('8537','2013-08-03','16:45:00',2.89),('8537','2013-08-03','16:50:00',2.84),('8537','2013-08-03','16:55:00',2.76),('8537','2013-08-03','17:00:00',2.59),('8537','2013-08-03','17:05:00',2.36),('8537','2013-08-03','17:10:00',2.46),('8537','2013-08-03','17:15:00',2.36),('8537','2013-08-03','17:20:00',2.24),('8537','2013-08-03','17:25:00',2.13),('8537','2013-08-03','17:30:00',2.05),('8537','2013-08-03','17:35:00',1.97),('8537','2013-08-03','17:40:00',1.88),('8537','2013-08-03','17:45:00',1.75),('8537','2013-08-03','17:50:00',1.66),('8537','2013-08-03','17:55:00',1.53),('8537','2013-08-03','18:00:00',1.45),('8537','2013-08-03','18:05:00',1.35),('8537','2013-08-03','18:10:00',1.26),('8537','2013-08-03','18:15:00',1.16),('8537','2013-08-03','18:20:00',1.07),('8537','2013-08-02','07:45:00',1.01),('8537','2013-08-02','07:50:00',1.11),('8537','2013-08-02','07:55:00',1.21),('8537','2013-08-02','08:00:00',1.32),('8537','2013-08-02','08:05:00',1.42),('8537','2013-08-02','08:10:00',1.52),('8537','2013-08-02','08:15:00',1.62),('8537','2013-08-02','08:20:00',1.73),('8537','2013-08-02','08:25:00',1.83),('8537','2013-08-02','08:30:00',1.93),('8537','2013-08-02','08:35:00',2.03),('8537','2013-08-02','08:40:00',2.12),('8537','2013-08-02','08:45:00',2.22),('8537','2013-08-02','08:50:00',2.31),('8537','2013-08-02','08:55:00',2.41),('8537','2013-08-02','09:00:00',2.5),('8537','2013-08-02','09:05:00',2.59),('8537','2013-08-02','09:10:00',2.68),('8537','2013-08-02','09:15:00',2.78),('8537','2013-08-02','09:20:00',2.85),('8537','2013-08-02','09:25:00',2.94),('8537','2013-08-02','09:30:00',2.97),('8537','2013-08-02','09:35:00',3.09),('8537','2013-08-02','09:40:00',3.17),('8537','2013-08-02','09:45:00',3.24),('8537','2013-08-02','09:50:00',3.3),('8537','2013-08-02','09:55:00',3.37),('8537','2013-08-02','10:00:00',3.43),('8537','2013-08-02','10:05:00',3.46),('8537','2013-08-02','10:10:00',3.53),('8537','2013-08-02','10:15:00',3.61),('8537','2013-08-02','10:20:00',3.69),('8537','2013-08-02','10:25:00',3.73),('8537','2013-08-02','10:30:00',3.8),('8537','2013-08-02','10:35:00',3.84),('8537','2013-08-02','10:40:00',3.9),('8537','2013-08-02','10:45:00',3.93),('8537','2013-08-02','10:50:00',3.98),('8537','2013-08-02','10:55:00',4.04),('8537','2013-08-02','11:00:00',4.12),('8537','2013-08-02','11:05:00',4.14),('8537','2013-08-02','11:10:00',4.14),('8537','2013-08-02','11:15:00',4.2),('8537','2013-08-02','11:20:00',4.29),('8537','2013-08-02','11:25:00',4.35),('8537','2013-08-02','11:30:00',4.35),('8537','2013-08-02','11:35:00',4.38),('8537','2013-08-02','11:40:00',4.38),('8537','2013-08-02','11:45:00',4.4),('8537','2013-08-02','11:50:00',4.45),('8537','2013-08-02','11:55:00',4.47),('8537','2013-08-02','12:00:00',4.58),('8537','2013-08-02','12:05:00',4.6),('8537','2013-08-02','12:10:00',4.55),('8537','2013-08-02','12:15:00',4.59),('8537','2013-08-02','12:20:00',4.58),('8537','2013-08-02','12:25:00',4.55),('8537','2013-08-02','12:30:00',4.52),('8537','2013-08-02','12:35:00',4.59),('8537','2013-08-02','12:40:00',4.56),('8537','2013-08-02','12:45:00',4.55),('8537','2013-08-02','12:50:00',4.55),('8537','2013-08-02','12:55:00',4.55),('8537','2013-08-02','13:00:00',4.58),('8537','2013-08-02','13:05:00',4.66),('8537','2013-08-02','13:10:00',4.71),('8537','2013-08-02','13:15:00',4.66),('8537','2013-08-02','13:20:00',4.6),('8537','2013-08-02','13:25:00',4.61),('8537','2013-08-02','13:30:00',4.65),('8537','2013-08-02','13:35:00',4.66),('8537','2013-08-02','13:40:00',4.65),('8537','2013-08-02','13:45:00',4.61),('8537','2013-08-02','13:50:00',4.61),('8537','2013-08-02','13:55:00',4.62),('8537','2013-08-02','14:00:00',4.6),('8537','2013-08-02','14:05:00',4.56),('8537','2013-08-02','14:10:00',4.5),('8537','2013-08-02','14:15:00',4.42),('8537','2013-08-02','14:20:00',4.35),('8537','2013-08-02','14:25:00',4.35),('8537','2013-08-02','14:30:00',4.37),('8537','2013-08-02','14:35:00',4.43),('8537','2013-08-02','14:40:00',4.43),('8537','2013-08-02','14:45:00',4.25),('8537','2013-08-02','14:50:00',4.25),('8537','2013-08-02','14:55:00',4.27),('8537','2013-08-02','15:00:00',4.22),('8537','2013-08-02','15:05:00',4.17),('8537','2013-08-02','15:10:00',4.11),('8537','2013-08-02','15:15:00',4.02),('8537','2013-08-02','15:20:00',4.03),('8537','2013-08-02','15:25:00',4.01),('8537','2013-08-02','15:30:00',3.97),('8537','2013-08-02','15:35:00',3.88),('8537','2013-08-02','15:40:00',3.79),('8537','2013-08-02','15:45:00',3.63),('8537','2013-08-02','15:50:00',3.66),('8537','2013-08-02','15:55:00',3.58),('8537','2013-08-02','16:00:00',3.55),('8537','2013-08-02','16:05:00',3.48),('8537','2013-08-02','16:10:00',3.42),('8537','2013-08-02','16:15:00',3.36),('8537','2013-08-02','16:20:00',3.26),('8537','2013-08-02','16:25:00',3.13),('8537','2013-08-02','16:30:00',3.09),('8537','2013-08-02','16:35:00',3.04),('8537','2013-08-02','16:40:00',2.96),('8537','2013-08-02','16:45:00',2.88),('8537','2013-08-02','16:50:00',2.81),('8537','2013-08-02','16:55:00',2.72),('8537','2013-08-02','17:00:00',2.58),('8537','2013-08-02','17:05:00',2.39),('8537','2013-08-02','17:10:00',2.42),('8537','2013-08-02','17:15:00',2.36),('8537','2013-08-02','17:20:00',2.27),('8537','2013-08-02','17:25:00',2.1),('8537','2013-08-02','17:30:00',2.03),('8537','2013-08-02','17:35:00',1.95),('8537','2013-08-02','17:40:00',1.87),('8537','2013-08-02','17:45:00',1.74),('8537','2013-08-02','17:50:00',1.63),('8537','2013-08-02','17:55:00',1.51),('8537','2013-08-02','18:00:00',1.44),('8537','2013-08-02','18:05:00',1.35),('8537','2013-08-02','18:10:00',1.26),('8537','2013-08-02','18:15:00',1.15),('8537','2013-08-02','18:20:00',1.06),('8537','2013-08-01','07:45:00',1.02),('8537','2013-08-01','07:50:00',1.12),('8537','2013-08-01','07:55:00',1.22),('8537','2013-08-01','08:00:00',1.32),('8537','2013-08-01','08:05:00',1.42),('8537','2013-08-01','08:10:00',1.52),('8537','2013-08-01','08:15:00',1.62),('8537','2013-08-01','08:20:00',1.74),('8537','2013-08-01','08:25:00',1.85),('8537','2013-08-01','08:30:00',1.96),('8537','2013-08-01','08:35:00',2.07),('8537','2013-08-01','08:40:00',2.17),('8537','2013-08-01','08:45:00',2.28),('8537','2013-08-01','08:50:00',2.38),('8537','2013-08-01','08:55:00',2.47),('8537','2013-08-01','09:00:00',2.55),('8537','2013-08-01','09:05:00',2.65),('8537','2013-08-01','09:10:00',2.75),('8537','2013-08-01','09:15:00',2.85),('8537','2013-08-01','09:20:00',2.95),('8537','2013-08-01','09:25:00',3.03),('8537','2013-08-01','09:30:00',3.12),('8537','2013-08-01','09:35:00',3.21),('8537','2013-08-01','09:40:00',3.29),('8537','2013-08-01','09:45:00',3.37),('8537','2013-08-01','09:50:00',3.45),('8537','2013-08-01','09:55:00',3.53),('8537','2013-08-01','10:00:00',3.61),('8537','2013-08-01','10:05:00',3.66),('8537','2013-08-01','10:10:00',3.74),('8537','2013-08-01','10:15:00',3.78),('8537','2013-08-01','10:20:00',3.85),('8537','2013-08-01','10:25:00',3.91),('8537','2013-08-01','10:30:00',3.99),('8537','2013-08-01','10:35:00',4.05),('8537','2013-08-01','10:40:00',4.11),('8537','2013-08-01','10:45:00',4.16),('8537','2013-08-01','10:50:00',4.22),('8537','2013-08-01','10:55:00',4.27),('8537','2013-08-01','11:00:00',4.32),('8537','2013-08-01','11:05:00',4.38),('8537','2013-08-01','11:10:00',4.43),('8537','2013-08-01','11:15:00',4.52),('8537','2013-08-01','11:20:00',4.55),('8537','2013-08-01','11:25:00',4.59),('8537','2013-08-01','11:30:00',4.61),('8537','2013-08-01','11:35:00',4.67),('8537','2013-08-01','11:40:00',4.71),('8537','2013-08-01','11:45:00',4.74),('8537','2013-08-01','11:50:00',4.77),('8537','2013-08-01','11:55:00',4.79),('8537','2013-08-01','12:00:00',4.79),('8537','2013-08-01','12:05:00',4.83),('8537','2013-08-01','12:10:00',4.84),('8537','2013-08-01','12:15:00',4.86),('8537','2013-08-01','12:20:00',4.88),('8537','2013-08-01','12:25:00',4.9),('8537','2013-08-01','12:30:00',4.92),('8537','2013-08-01','12:35:00',4.96),('8537','2013-08-01','12:40:00',4.96),('8537','2013-08-01','12:45:00',4.93),('8537','2013-08-01','12:50:00',4.97),('8537','2013-08-01','12:55:00',4.95),('8537','2013-08-01','13:00:00',4.96),('8537','2013-08-01','13:05:00',4.94),('8537','2013-08-01','13:10:00',4.96),('8537','2013-08-01','13:15:00',4.95),('8537','2013-08-01','13:20:00',4.98),('8537','2013-08-01','13:25:00',4.97),('8537','2013-08-01','13:30:00',4.94),('8537','2013-08-01','13:35:00',4.88),('8537','2013-08-01','13:40:00',4.94),('8537','2013-08-01','13:45:00',4.91),('8537','2013-08-01','13:50:00',4.91),('8537','2013-08-01','13:55:00',4.46),('8537','2013-08-01','14:00:00',4.24),('8537','2013-08-01','14:05:00',4.88),('8537','2013-08-01','14:10:00',4.62),('8537','2013-08-01','14:15:00',4.77),('8537','2013-08-01','14:20:00',4.45),('8537','2013-08-01','14:25:00',4.62),('8537','2013-08-01','14:30:00',4.63),('8537','2013-08-01','14:35:00',3.32),('8537','2013-08-01','14:40:00',4.16),('8537','2013-08-01','14:45:00',4.54),('8537','2013-08-01','14:50:00',3.69),('8537','2013-08-01','14:55:00',4.42),('8537','2013-08-01','15:00:00',4.29),('8537','2013-08-01','15:05:00',4.36),('8537','2013-08-01','15:10:00',4.11),('8537','2013-08-01','15:15:00',3.63),('8537','2013-08-01','15:20:00',3.87),('8537','2013-08-01','15:25:00',4.15),('8537','2013-08-01','15:30:00',4.14),('8537','2013-08-01','15:35:00',3.94),('8537','2013-08-01','15:40:00',3.36),('8537','2013-08-01','15:45:00',3.88),('8537','2013-08-01','15:50:00',3.84),('8537','2013-08-01','15:55:00',3.82),('8537','2013-08-01','16:00:00',3.78),('8537','2013-08-01','16:05:00',3.67),('8537','2013-08-01','16:10:00',3.6),('8537','2013-08-01','16:15:00',3.5),('8537','2013-08-01','16:20:00',3.45),('8537','2013-08-01','16:25:00',3.32),('8537','2013-08-01','16:30:00',3.23),('8537','2013-08-01','16:35:00',3.17),('8537','2013-08-01','16:40:00',3.1),('8537','2013-08-01','16:45:00',3.01),('8537','2013-08-01','16:50:00',2.92),('8537','2013-08-01','16:55:00',2.85),('8537','2013-08-01','17:00:00',2.72),('8537','2013-08-01','17:05:00',2.64),('8537','2013-08-01','17:10:00',2.53),('8537','2013-08-01','17:15:00',2.45),('8537','2013-08-01','17:20:00',2.35),('8537','2013-08-01','17:25:00',2.15),('8537','2013-08-01','17:30:00',2.12),('8537','2013-08-01','17:35:00',2.03),('8537','2013-08-01','17:40:00',1.93),('8537','2013-08-01','17:45:00',1.81),('8537','2013-08-01','17:50:00',1.72),('8537','2013-08-01','17:55:00',1.59),('8537','2013-08-01','18:00:00',1.51),('8537','2013-08-01','18:05:00',1.39),('8537','2013-08-01','18:10:00',1.31),('8537','2013-08-01','18:15:00',1.21),('8537','2013-08-01','18:20:00',1.12),('8537','2013-08-01','18:25:00',1.03),('8537','2013-07-31','07:45:00',1.06),('8537','2013-07-31','07:50:00',1.16),('8537','2013-07-31','07:55:00',1.26),('8537','2013-07-31','08:00:00',1.36),('8537','2013-07-31','08:05:00',1.46),('8537','2013-07-31','08:10:00',1.58),('8537','2013-07-31','08:15:00',1.68),('8537','2013-07-31','08:20:00',1.79),('8537','2013-07-31','08:25:00',1.9),('8537','2013-07-31','08:30:00',2),('8537','2013-07-31','08:35:00',2.1),('8537','2013-07-31','08:40:00',2.2),('8537','2013-07-31','08:45:00',2.31),('8537','2013-07-31','08:50:00',2.41),('8537','2013-07-31','08:55:00',2.5),('8537','2013-07-31','09:00:00',2.54),('8537','2013-07-31','09:05:00',2.7),('8537','2013-07-31','09:10:00',2.8),('8537','2013-07-31','09:15:00',2.87),('8537','2013-07-31','09:20:00',2.97),('8537','2013-07-31','09:25:00',3.05),('8537','2013-07-31','09:30:00',3.15),('8537','2013-07-31','09:35:00',3.23),('8537','2013-07-31','09:40:00',3.3),('8537','2013-07-31','09:45:00',3.4),('8537','2013-07-31','09:50:00',2.07),('8537','2013-07-31','09:55:00',3.53),('8537','2013-07-31','10:00:00',3.61),('8537','2013-07-31','10:05:00',3.69),('8537','2013-07-31','10:10:00',3.72),('8537','2013-07-31','10:15:00',3.82),('8537','2013-07-31','10:20:00',3.88),('8537','2013-07-31','10:25:00',3.95),('8537','2013-07-31','10:30:00',3.03),('8537','2013-07-31','10:35:00',2.42),('8537','2013-07-31','10:40:00',4.17),('8537','2013-07-31','10:45:00',4.22),('8537','2013-07-31','10:50:00',4.3),('8537','2013-07-31','10:55:00',4.33),('8537','2013-07-31','11:00:00',4.39),('8537','2013-07-31','11:05:00',4.42),('8537','2013-07-31','11:10:00',4.47),('8537','2013-07-31','11:15:00',4.52),('8537','2013-07-31','11:20:00',4.56),('8537','2013-07-31','11:25:00',4.61),('8537','2013-07-31','11:30:00',4.66),('8537','2013-07-31','11:35:00',4.67),('8537','2013-07-31','11:40:00',4.71),('8537','2013-07-31','11:45:00',4.78),('8537','2013-07-31','11:50:00',4.8),('8537','2013-07-31','11:55:00',4.83),('8537','2013-07-31','12:00:00',4.73),('8537','2013-07-31','12:05:00',4.85),('8537','2013-07-31','12:10:00',4.87),('8537','2013-07-31','12:15:00',4.92),('8537','2013-07-31','12:20:00',4.93),('8537','2013-07-31','12:25:00',4.99),('8537','2013-07-31','12:30:00',4.97),('8537','2013-07-31','12:35:00',4.94),('8537','2013-07-31','12:40:00',4.96),('8537','2013-07-31','12:45:00',4.29),('8537','2013-07-31','12:50:00',3.12),('8537','2013-07-31','12:55:00',5.08),('8537','2013-07-31','13:00:00',2.08),('8537','2013-07-31','13:05:00',5.01),('8537','2013-07-31','13:10:00',5.05),('8537','2013-07-31','13:15:00',5.03),('8537','2013-07-31','13:20:00',4.79),('8537','2013-07-31','13:25:00',4.32),('8537','2013-07-31','13:30:00',5.04),('8537','2013-07-31','13:35:00',4.82),('8537','2013-07-31','13:40:00',5.04),('8537','2013-07-31','13:45:00',5.02),('8537','2013-07-31','13:50:00',4.35),('8537','2013-07-31','13:55:00',2.65),('8537','2013-07-31','14:00:00',4.7),('8537','2013-07-31','14:05:00',5.07),('8537','2013-07-31','14:10:00',4.57),('8537','2013-07-31','14:15:00',4.96),('8537','2013-07-31','14:20:00',5.02),('8537','2013-07-31','14:25:00',4.91),('8537','2013-07-31','14:30:00',4.81),('8537','2013-07-31','14:35:00',4.71),('8537','2013-07-31','14:40:00',4.73),('8537','2013-07-31','14:45:00',4.63),('8537','2013-07-31','14:50:00',3.79),('8537','2013-07-31','14:55:00',1.87),('8537','2013-07-31','15:00:00',1.67),('8537','2013-07-31','15:05:00',4.68),('8537','2013-07-31','15:10:00',3.2),('8537','2013-07-31','15:15:00',3.03),('8537','2013-07-31','15:20:00',4.56),('8537','2013-07-31','15:25:00',4.27),('8537','2013-07-31','15:30:00',4.26),('8537','2013-07-31','15:35:00',3.6),('8537','2013-07-31','15:40:00',4.1),('8537','2013-07-31','15:45:00',3.8),('8537','2013-07-31','15:50:00',3.9),('8537','2013-07-31','15:55:00',3.79),('8537','2013-07-31','16:00:00',3.71),('8537','2013-07-31','16:05:00',3.67),('8537','2013-07-31','16:10:00',3.67),('8537','2013-07-31','16:15:00',3.58),('8537','2013-07-31','16:20:00',3.58),('8537','2013-07-31','16:25:00',3.33),('8537','2013-07-31','16:30:00',3.23),('8537','2013-07-31','16:35:00',1.69),('8537','2013-07-31','16:40:00',3.11),('8537','2013-07-31','16:45:00',2.98),('8537','2013-07-31','16:50:00',2.95),('8537','2013-07-31','16:55:00',2.84),('8537','2013-07-31','17:00:00',2.33),('8537','2013-07-31','17:05:00',2.5),('8537','2013-07-31','17:10:00',2.51),('8537','2013-07-31','17:15:00',2.45),('8537','2013-07-31','17:20:00',2.25),('8537','2013-07-31','17:25:00',2.17),('8537','2013-07-31','17:30:00',2.09),('8537','2013-07-31','17:35:00',1.97),('8537','2013-07-31','17:40:00',1.91),('8537','2013-07-31','17:45:00',1.78),('8537','2013-07-31','17:50:00',1.71),('8537','2013-07-31','17:55:00',1.58),('8537','2013-07-31','18:00:00',1.5),('8537','2013-07-31','18:05:00',1.41),('8537','2013-07-31','18:10:00',1.31),('8537','2013-07-31','18:15:00',1.24),('8537','2013-07-31','18:20:00',1.13),('8537','2013-07-31','18:25:00',1.05),('8537','2014-04-08','08:15:00',1.45),('8537','2014-04-08','08:20:00',1.55),('8537','2014-04-08','08:25:00',1.2),('8537','2014-04-08','08:30:00',1.61),('8537','2014-04-08','08:35:00',1.64),('8537','2014-04-08','08:40:00',1.57),('8537','2014-04-08','08:45:00',1.95),('8537','2014-04-08','08:50:00',2.01),('8537','2014-04-08','08:55:00',2.17),('8537','2014-04-08','09:00:00',2.28),('8537','2014-04-08','09:05:00',2.37),('8537','2014-04-08','09:10:00',2.46),('8537','2014-04-08','09:15:00',2.58),('8537','2014-04-08','09:20:00',2.69),('8537','2014-04-08','09:25:00',2.78),('8537','2014-04-08','09:30:00',2.89),('8537','2014-04-08','09:35:00',2.96),('8537','2014-04-08','09:40:00',2.99),('8537','2014-04-08','09:45:00',3.08),('8537','2014-04-08','09:50:00',3.18),('8537','2014-04-08','09:55:00',3.21),('8537','2014-04-08','10:00:00',3.28),('8537','2014-04-08','10:05:00',3.26),('8537','2014-04-08','10:10:00',3.34),('8537','2014-04-08','10:15:00',3.57),('8537','2014-04-08','10:20:00',3.66),('8537','2014-04-08','10:25:00',3.67),('8537','2014-04-08','10:30:00',3.77),('8537','2014-04-08','10:35:00',3.71),('8537','2014-04-08','10:40:00',3.84),('8537','2014-04-08','10:45:00',3.97),('8537','2014-04-08','10:50:00',4.06),('8537','2014-04-08','10:55:00',4.07),('8537','2014-04-08','11:00:00',4.11),('8537','2014-04-08','11:05:00',4.21),('8537','2014-04-08','11:10:00',4.21),('8537','2014-04-08','11:15:00',4.17),('8537','2014-04-08','11:20:00',4.31),('8537','2014-04-08','11:25:00',4.45),('8537','2014-04-08','11:30:00',4.42),('8537','2014-04-08','11:35:00',4.17),('8537','2014-04-08','11:40:00',4.34),('8537','2014-04-08','11:45:00',4.48),('8537','2014-04-08','11:50:00',4.34),('8537','2014-04-08','11:55:00',4.51),('8537','2014-04-08','12:00:00',4.56),('8537','2014-04-08','12:05:00',4.42),('8537','2014-04-08','12:10:00',4.38),('8537','2014-04-08','12:15:00',4.29),('8537','2014-04-08','12:20:00',4.27),('8537','2014-04-08','12:25:00',4.22),('8537','2014-04-08','12:30:00',5.02),('8537','2014-04-08','12:35:00',4.75),('8537','2014-04-08','12:40:00',4.12),('8537','2014-04-08','12:45:00',3.66),('8537','2014-04-08','12:50:00',4.26),('8537','2014-04-08','12:55:00',4.75),('8537','2014-04-08','13:00:00',4.54),('8537','2014-04-08','13:05:00',4.86),('8537','2014-04-08','13:10:00',4.89),('8537','2014-04-08','13:15:00',4.97),('8537','2014-04-08','13:20:00',4.9),('8537','2014-04-08','13:25:00',4.88),('8537','2014-04-08','13:30:00',4.94),('8537','2014-04-08','13:35:00',4.93),('8537','2014-04-08','13:40:00',4.9),('8537','2014-04-08','13:45:00',4.84),('8537','2014-04-08','13:50:00',4.86),('8537','2014-04-08','13:55:00',4.88),('8537','2014-04-08','14:00:00',4.82),('8537','2014-04-08','14:05:00',4.82),('8537','2014-04-08','14:10:00',4.78),('8537','2014-04-08','14:15:00',4.73),('8537','2014-04-08','14:20:00',4.52),('8537','2014-04-08','14:25:00',4.57),('8537','2014-04-08','14:30:00',4.61),('8537','2014-04-08','14:35:00',4.19),('8537','2014-04-08','14:40:00',4.06),('8537','2014-04-08','14:45:00',3.85),('8537','2014-04-08','14:50:00',4.37),('8537','2014-04-08','14:55:00',4.4),('8537','2014-04-08','15:00:00',4.4),('8537','2014-04-08','15:05:00',4.26),('8537','2014-04-08','15:10:00',4.28),('8537','2014-04-08','15:15:00',4.21),('8537','2014-04-08','15:20:00',4.06),('8537','2014-04-08','15:25:00',3.99),('8537','2014-04-08','15:30:00',3.84),('8537','2014-04-08','15:35:00',3.86),('8537','2014-04-08','15:40:00',3.82),('8537','2014-04-08','15:45:00',3.57),('8537','2014-04-08','15:50:00',3.65),('8537','2014-04-08','15:55:00',3.57),('8537','2014-04-08','16:00:00',3.42),('8537','2014-04-08','16:05:00',3.1),('8537','2014-04-08','16:10:00',3.05),('8537','2014-04-08','16:15:00',2.98),('8537','2014-04-08','16:20:00',2.71),('8537','2014-04-08','16:25:00',2.97),('8537','2014-04-08','16:30:00',3.05),('8537','2014-04-08','16:35:00',2.99),('8537','2014-04-08','16:40:00',2.7),('8537','2014-04-08','16:45:00',2.6),('8537','2014-04-08','16:50:00',2.64),('8537','2014-04-08','16:55:00',2.41),('8537','2014-04-08','17:00:00',2.14),('8537','2014-04-08','17:05:00',2.25),('8537','2014-04-08','17:10:00',2.11),('8537','2014-04-08','17:15:00',2.04),('8537','2014-04-08','17:20:00',1.91),('8537','2014-04-08','17:25:00',1.76),('8537','2014-04-08','17:30:00',1.59),('8537','2014-04-08','17:35:00',1.41),('8537','2014-04-08','17:40:00',1.4),('8537','2014-04-08','17:45:00',1.31),('8537','2014-04-08','17:50:00',1.22),('8537','2014-04-08','17:55:00',1.05),('8537','2014-04-08','18:00:00',1.04),('8537','2013-07-30','07:55:00',1.21),('8537','2013-07-30','08:00:00',1.35),('8537','2013-07-30','08:05:00',1.46),('8537','2013-07-30','08:10:00',1.54),('8537','2013-07-30','08:15:00',1.64),('8537','2013-07-30','08:20:00',1.86),('8537','2013-07-30','08:25:00',1.98),('8537','2013-07-30','08:30:00',2),('8537','2013-07-30','08:35:00',2.07),('8537','2013-07-30','08:40:00',2.17),('8537','2013-07-30','08:45:00',2.24),('8537','2013-07-30','08:50:00',2.36),('8537','2013-07-30','08:55:00',2.49),('8537','2013-07-30','09:00:00',2.61),('8537','2013-07-30','09:05:00',2.69),('8537','2013-07-30','09:10:00',2.79),('8537','2013-07-30','09:15:00',2.89),('8537','2013-07-30','09:20:00',3.08),('8537','2013-07-30','09:25:00',3.19),('8537','2013-07-30','09:30:00',3.26),('8537','2013-07-30','09:35:00',3.33),('8537','2013-07-30','09:40:00',3.48),('8537','2013-07-30','09:45:00',3.52),('8537','2013-07-30','09:50:00',3.55),('8537','2013-07-30','09:55:00',3.7),('8537','2013-07-30','10:00:00',3.65),('8537','2013-07-30','10:05:00',3.76),('8537','2013-07-30','10:10:00',3.84),('8537','2013-07-30','10:15:00',3.86),('8537','2013-07-30','10:20:00',3.6),('8537','2013-07-30','10:25:00',4.06),('8537','2013-07-30','10:30:00',4.07),('8537','2013-07-30','10:35:00',4.11),('8537','2013-07-30','10:40:00',4.11),('8537','2013-07-30','10:45:00',4.17),('8537','2013-07-30','10:50:00',4.15),('8537','2013-07-30','10:55:00',4.2),('8537','2013-07-30','11:00:00',4.06),('8537','2013-07-30','11:05:00',4.3),('8537','2013-07-30','11:10:00',4.5),('8537','2013-07-30','11:15:00',4.53),('8537','2013-07-30','11:20:00',3.68),('8537','2013-07-30','11:30:00',1.38),('8537','2013-07-30','11:35:00',3.96),('8537','2013-07-30','11:40:00',4.65),('8537','2013-07-30','11:45:00',4.68),('8537','2013-07-30','11:50:00',4.71),('8537','2013-07-30','11:55:00',4.64),('8537','2013-07-30','12:00:00',4.64),('8537','2013-07-30','12:05:00',4.7),('8537','2013-07-30','12:10:00',4.73),('8537','2013-07-30','12:15:00',4.67),('8537','2013-07-30','12:20:00',4.66),('8537','2013-07-30','12:25:00',4.67),('8537','2013-07-30','12:30:00',4.74),('8537','2013-07-30','12:35:00',4.77),('8537','2013-07-30','12:40:00',3.39),('8537','2013-07-30','12:45:00',2.68),('8537','2013-07-30','12:50:00',5.06),('8537','2013-07-30','12:55:00',5.12),('8537','2013-07-30','13:00:00',4.88),('8537','2013-07-30','13:05:00',3.68),('8537','2013-07-30','13:10:00',3.74),('8537','2013-07-30','13:15:00',5.04),('8537','2013-07-30','13:20:00',4.96),('8537','2013-07-30','13:25:00',4.47),('8537','2013-07-30','13:30:00',4.3),('8537','2013-07-30','13:35:00',4.92),('8537','2013-07-30','13:40:00',4.88),('8537','2013-07-30','13:45:00',4.79),('8537','2013-07-30','13:50:00',4.94),('8537','2013-07-30','13:55:00',4.97),('8537','2013-07-30','14:00:00',4.87),('8537','2013-07-30','14:05:00',4.89),('8537','2013-07-30','14:10:00',4.18),('8537','2013-07-30','14:15:00',4.69),('8537','2013-07-30','14:20:00',4.61),('8537','2013-07-30','14:25:00',4.66),('8537','2013-07-30','14:30:00',4.66),('8537','2013-07-30','14:35:00',4.56),('8537','2013-07-30','14:40:00',4.48),('8537','2013-07-30','14:45:00',4.37),('8537','2013-07-30','14:50:00',4.17),('8537','2013-07-30','14:55:00',4.33),('8537','2013-07-30','15:00:00',4.26),('8537','2013-07-30','15:05:00',4.17),('8537','2013-07-30','15:10:00',4.07),('8537','2013-07-30','15:15:00',4.07),('8537','2013-07-30','15:20:00',4),('8537','2013-07-30','15:25:00',3.85),('8537','2013-07-30','15:30:00',3.89),('8537','2013-07-30','15:35:00',3.88),('8537','2013-07-30','15:40:00',3.79),('8537','2013-07-30','15:45:00',3.55),('8537','2013-07-30','15:50:00',3.68),('8537','2013-07-30','15:55:00',3.6),('8537','2013-07-30','16:00:00',3.56),('8537','2013-07-30','16:05:00',3.48),('8537','2013-07-30','16:10:00',3.41),('8537','2013-07-30','16:15:00',3.36),('8537','2013-07-30','16:20:00',3.31),('8537','2013-07-30','16:25:00',3.18),('8537','2013-07-30','16:30:00',3.08),('8537','2013-07-30','16:35:00',3.03),('8537','2013-07-30','16:40:00',2.98),('8537','2013-07-30','16:45:00',2.88),('8537','2013-07-30','16:50:00',2.8),('8537','2013-07-30','16:55:00',2.7),('8537','2013-07-30','17:00:00',2.64),('8537','2013-07-30','17:05:00',2.27),('8537','2013-07-30','17:10:00',2.33),('8537','2013-07-30','17:15:00',2.35),('8537','2013-07-30','17:20:00',2.29),('8537','2013-07-30','17:25:00',2.16),('8537','2013-07-30','17:30:00',2.02),('8537','2013-07-30','17:35:00',1.97),('8537','2013-07-30','17:40:00',1.89),('8537','2013-07-30','17:45:00',1.77),('8537','2013-07-30','17:50:00',1.66),('8537','2013-07-30','17:55:00',1.52),('8537','2013-07-30','18:00:00',1.44),('8537','2013-07-30','18:05:00',1.36),('8537','2013-07-30','18:10:00',1.28),('8537','2013-07-30','18:15:00',1.19),('8537','2013-07-30','18:20:00',1.1),('8537','2013-07-30','18:25:00',1.02),('8537','2013-07-29','07:50:00',1.05),('8537','2013-07-29','07:55:00',1.14),('8537','2013-07-29','08:00:00',1.24),('8537','2013-07-29','08:05:00',1.33),('8537','2013-07-29','08:10:00',1.42),('8537','2013-07-29','08:15:00',1.5),('8537','2013-07-29','08:20:00',1.56),('8537','2013-07-29','08:25:00',1.66),('8537','2013-07-29','08:30:00',1.76),('8537','2013-07-29','08:35:00',1.84),('8537','2013-07-29','08:40:00',1.96),('8537','2013-07-29','08:45:00',2.04),('8537','2013-07-29','08:50:00',2.1),('8537','2013-07-29','08:55:00',2.19),('8537','2013-07-29','09:00:00',2.26),('8537','2013-07-29','09:05:00',2.38),('8537','2013-07-29','09:10:00',2.47),('8537','2013-07-29','09:15:00',2.56),('8537','2013-07-29','09:20:00',2.65),('8537','2013-07-29','09:25:00',2.72),('8537','2013-07-29','09:30:00',2.78),('8537','2013-07-29','09:35:00',2.87),('8537','2013-07-29','09:40:00',2.99),('8537','2013-07-29','09:45:00',3.08),('8537','2013-07-29','09:50:00',3.13),('8537','2013-07-29','09:55:00',3.2),('8537','2013-07-29','10:00:00',3.28),('8537','2013-07-29','10:05:00',3.37),('8537','2013-07-29','10:10:00',3.44),('8537','2013-07-29','10:15:00',3.48),('8537','2013-07-29','10:20:00',3.59),('8537','2013-07-29','10:25:00',3.64),('8537','2013-07-29','10:30:00',3.66),('8537','2013-07-29','10:35:00',3.71),('8537','2013-07-29','10:40:00',3.8),('8537','2013-07-29','10:45:00',3.76),('8537','2013-07-29','10:50:00',3.83),('8537','2013-07-29','10:55:00',3.89),('8537','2013-07-29','11:00:00',3.94),('8537','2013-07-29','11:05:00',3.93),('8537','2013-07-29','11:10:00',3.94),('8537','2013-07-29','11:15:00',4.05),('8537','2013-07-29','11:20:00',4.1),('8537','2013-07-29','11:25:00',4.14),('8537','2013-07-29','11:30:00',4.16),('8537','2013-07-29','11:35:00',4.17),('8537','2013-07-29','11:40:00',4.19),('8537','2013-07-29','11:45:00',4.19),('8537','2013-07-29','11:50:00',4.25),('8537','2013-07-29','11:55:00',4.28),('8537','2013-07-29','12:00:00',4.27),('8537','2013-07-29','12:05:00',4.3),('8537','2013-07-29','12:10:00',4.33),('8537','2013-07-29','12:15:00',4.41),('8537','2013-07-29','12:20:00',4.4),('8537','2013-07-29','12:25:00',4.39),('8537','2013-07-29','12:30:00',4.45),('8537','2013-07-29','12:35:00',4.48),('8537','2013-07-29','12:40:00',4.47),('8537','2013-07-29','12:45:00',4.48),('8537','2013-07-29','12:50:00',4.46),('8537','2013-07-29','12:55:00',4.4),('8537','2013-07-29','13:00:00',4.41),('8537','2013-07-29','13:05:00',4.53),('8537','2013-07-29','13:10:00',4.56),('8537','2013-07-29','13:15:00',4.58),('8537','2013-07-29','13:20:00',4.63),('8537','2013-07-29','13:25:00',4.64),('8537','2013-07-29','13:30:00',4.68),('8537','2013-07-29','13:35:00',4.67),('8537','2013-07-29','13:40:00',4.66),('8537','2013-07-29','13:45:00',4.62),('8537','2013-07-29','13:50:00',4.63),('8537','2013-07-29','13:55:00',4.61),('8537','2013-07-29','14:00:00',4.58),('8537','2013-07-29','14:05:00',4.59),('8537','2013-07-29','14:10:00',4.54),('8537','2013-07-29','14:15:00',4.5),('8537','2013-07-29','14:20:00',4.5),('8537','2013-07-29','14:25:00',4.43),('8537','2013-07-29','14:30:00',4.42),('8537','2013-07-29','14:35:00',4.38),('8537','2013-07-29','14:40:00',4.35),('8537','2013-07-29','14:45:00',4.26),('8537','2013-07-29','14:50:00',4.22),('8537','2013-07-29','14:55:00',4.2),('8537','2013-07-29','15:00:00',4.16),('8537','2013-07-29','15:05:00',4.14),('8537','2013-07-29','15:10:00',4.11),('8537','2013-07-29','15:15:00',4.07),('8537','2013-07-29','15:20:00',4),('8537','2013-07-29','15:25:00',3.96),('8537','2013-07-29','15:30:00',3.9),('8537','2013-07-29','15:35:00',3.87),('8537','2013-07-29','15:40:00',3.86),('8537','2013-07-29','15:45:00',3.72),('8537','2013-07-29','15:50:00',3.32),('8537','2013-07-29','15:55:00',2.18),('8537','2013-07-29','16:00:00',1.9),('8537','2013-07-29','16:05:00',3.05),('8537','2013-07-29','16:10:00',3.3),('8537','2013-07-29','16:15:00',2.74),('8537','2013-07-29','16:20:00',2.81),('8537','2013-07-29','16:25:00',2.51),('8537','2013-07-29','16:30:00',3.36),('8537','2013-07-29','16:35:00',2.97),('8537','2013-07-29','16:40:00',2.46),('8537','2013-07-29','16:45:00',3.11),('8537','2013-07-29','16:50:00',2.98),('8537','2013-07-29','16:55:00',1.89),('8537','2013-07-29','17:00:00',1.51),('8537','2013-07-29','17:05:00',1.69),('8537','2013-07-29','17:10:00',1.41),('8537','2013-07-29','17:15:00',1.01),('8537','2013-07-29','17:20:00',2.17),('8537','2013-07-29','17:25:00',2.08),('8537','2013-07-29','17:30:00',1.41),('8537','2013-07-29','17:40:00',1.07),('8537','2013-07-29','17:45:00',1.89),('8537','2013-07-29','17:50:00',1.67),('8537','2013-07-29','17:55:00',1.49),('8537','2013-07-29','18:00:00',1.15),('8537','2013-07-29','18:10:00',1.14),('8537','2013-07-29','18:20:00',1.1),('8537','2013-07-29','18:25:00',1.05),('8537','2013-07-28','07:50:00',1.03),('8537','2013-07-28','07:55:00',1.11),('8537','2013-07-28','08:00:00',1.23),('8537','2013-07-28','08:05:00',1.32),('8537','2013-07-28','08:10:00',1.42),('8537','2013-07-28','08:15:00',1.51),('8537','2013-07-28','08:20:00',1.61),('8537','2013-07-28','08:25:00',1.7),('8537','2013-07-28','08:30:00',1.82),('8537','2013-07-28','08:35:00',1.91),('8537','2013-07-28','08:40:00',2),('8537','2013-07-28','08:45:00',2.1),('8537','2013-07-28','08:50:00',2.18),('8537','2013-07-28','08:55:00',2.28),('8537','2013-07-28','09:00:00',2.38),('8537','2013-07-28','09:05:00',2.48),('8537','2013-07-28','09:10:00',2.55),('8537','2013-07-28','09:15:00',2.64),('8537','2013-07-28','09:20:00',2.69),('8537','2013-07-28','09:25:00',2.75),('8537','2013-07-28','09:30:00',2.87),('8537','2013-07-28','09:35:00',2.96),('8537','2013-07-28','09:40:00',3.03),('8537','2013-07-28','09:45:00',3.09),('8537','2013-07-28','09:50:00',3.18),('8537','2013-07-28','09:55:00',3.22),('8537','2013-07-28','10:00:00',3.3),('8537','2013-07-28','10:05:00',3.36),('8537','2013-07-28','10:10:00',3.43),('8537','2013-07-28','10:15:00',3.49),('8537','2013-07-28','10:20:00',3.57),('8537','2013-07-28','10:25:00',3.6),('8537','2013-07-28','10:30:00',3.65),('8537','2013-07-28','10:35:00',3.68),('8537','2013-07-28','10:40:00',3.76),('8537','2013-07-28','10:45:00',3.84),('8537','2013-07-28','10:50:00',3.85),('8537','2013-07-28','10:55:00',3.87),('8537','2013-07-28','11:00:00',3.96),('8537','2013-07-28','11:05:00',4.02),('8537','2013-07-28','11:10:00',4.05),('8537','2013-07-28','11:15:00',4.08),('8537','2013-07-28','11:20:00',4.15),('8537','2013-07-28','11:25:00',4.2),('8537','2013-07-28','11:30:00',4.19),('8537','2013-07-28','11:35:00',4.25),('8537','2013-07-28','11:40:00',4.27),('8537','2013-07-28','11:45:00',4.25),('8537','2013-07-28','11:50:00',4.27),('8537','2013-07-28','11:55:00',4.33),('8537','2013-07-28','12:00:00',4.32),('8537','2013-07-28','12:05:00',4.35),('8537','2013-07-28','12:10:00',4.36),('8537','2013-07-28','12:15:00',4.32),('8537','2013-07-28','12:20:00',4.37),('8537','2013-07-28','12:25:00',4.36),('8537','2013-07-28','12:30:00',4.41),('8537','2013-07-28','12:35:00',4.52),('8537','2013-07-28','12:40:00',4.57),('8537','2013-07-28','12:45:00',4.47),('8537','2013-07-28','12:50:00',4.43),('8537','2013-07-28','12:55:00',4.5),('8537','2013-07-28','13:00:00',4.51),('8537','2013-07-28','13:05:00',4.52),('8537','2013-07-28','13:10:00',3.79),('8537','2013-07-28','13:15:00',4.64),('8537','2013-07-28','13:20:00',4.7),('8537','2013-07-28','13:25:00',4.62),('8537','2013-07-28','13:30:00',4.62),('8537','2013-07-28','13:35:00',4.61),('8537','2013-07-28','13:40:00',4.63),('8537','2013-07-28','13:45:00',4.64),('8537','2013-07-28','13:50:00',4.68),('8537','2013-07-28','13:55:00',4.63),('8537','2013-07-28','14:00:00',4.57),('8537','2013-07-28','14:05:00',4.54),('8537','2013-07-28','14:10:00',4.51),('8537','2013-07-28','14:15:00',4.56),('8537','2013-07-28','14:20:00',4.53),('8537','2013-07-28','14:25:00',4.48),('8537','2013-07-28','14:30:00',4.4),('8537','2013-07-28','14:35:00',4.38),('8537','2013-07-28','14:40:00',4.39),('8537','2013-07-28','14:45:00',4.3),('8537','2013-07-28','14:50:00',4.03),('8537','2013-07-28','14:55:00',3.65),('8537','2013-07-28','15:00:00',3.86),('8537','2013-07-28','15:05:00',4.11),('8537','2013-07-28','15:10:00',4.1),('8537','2013-07-28','15:15:00',4),('8537','2013-07-28','15:20:00',3.95),('8537','2013-07-28','15:25:00',3.91),('8537','2013-07-28','15:30:00',3.9),('8537','2013-07-28','15:35:00',3.84),('8537','2013-07-28','15:40:00',3.79),('8537','2013-07-28','15:45:00',3.62),('8537','2013-07-28','15:50:00',3.67),('8537','2013-07-28','15:55:00',3.6),('8537','2013-07-28','16:00:00',3.55),('8537','2013-07-28','16:05:00',3.52),('8537','2013-07-28','16:10:00',3.46),('8537','2013-07-28','16:15:00',3.39),('8537','2013-07-28','16:20:00',3.34),('8537','2013-07-28','16:25:00',3.24),('8537','2013-07-28','16:30:00',3.16),('8537','2013-07-28','16:35:00',3.09),('8537','2013-07-28','16:40:00',2.99),('8537','2013-07-28','16:45:00',2.93),('8537','2013-07-28','16:50:00',2.85),('8537','2013-07-28','16:55:00',2.78),('8537','2013-07-28','17:00:00',2.68),('8537','2013-07-28','17:05:00',2.37),('8537','2013-07-28','17:10:00',1.97),('8537','2013-07-28','17:15:00',2.42),('8537','2013-07-28','17:20:00',2.33),('8537','2013-07-28','17:25:00',2.17),('8537','2013-07-28','17:30:00',2.06),('8537','2013-07-28','17:35:00',2),('8537','2013-07-28','17:40:00',1.91),('8537','2013-07-28','17:45:00',1.82),('8537','2013-07-28','17:50:00',1.71),('8537','2013-07-28','17:55:00',1.6),('8537','2013-07-28','18:00:00',1.48),('8537','2013-07-28','18:05:00',1.4),('8537','2013-07-28','18:10:00',1.32),('8537','2013-07-28','18:15:00',1.23),('8537','2013-07-28','18:20:00',1.13),('8537','2013-07-28','18:25:00',1.04),('8537','2013-07-27','07:50:00',1.07),('8537','2013-07-27','07:55:00',1.17),('8537','2013-07-27','08:00:00',1.27),('8537','2013-07-27','08:05:00',1.36),('8537','2013-07-27','08:10:00',1.46),('8537','2013-07-27','08:15:00',1.57),('8537','2013-07-27','08:20:00',1.65),('8537','2013-07-27','08:25:00',1.72),('8537','2013-07-27','08:30:00',1.85),('8537','2013-07-27','08:35:00',1.95),('8537','2013-07-27','08:40:00',2.04),('8537','2013-07-27','08:45:00',2.12),('8537','2013-07-27','08:50:00',2.21),('8537','2013-07-27','08:55:00',2.32),('8537','2013-07-27','09:00:00',2.41),('8537','2013-07-27','09:05:00',2.53),('8537','2013-07-27','09:10:00',2.61),('8537','2013-07-27','09:15:00',2.7),('8537','2013-07-27','09:20:00',2.79),('8537','2013-07-27','09:25:00',2.85),('8537','2013-07-27','09:30:00',2.94),('8537','2013-07-27','09:35:00',3.02),('8537','2013-07-27','09:40:00',3.05),('8537','2013-07-27','09:45:00',3.18),('8537','2013-07-27','09:50:00',3.26),('8537','2013-07-27','09:55:00',3.36),('8537','2013-07-27','10:00:00',3.41),('8537','2013-07-27','10:05:00',3.47),('8537','2013-07-27','10:10:00',3.53),('8537','2013-07-27','10:15:00',3.62),('8537','2013-07-27','10:20:00',3.68),('8537','2013-07-27','10:25:00',3.71),('8537','2013-07-27','10:30:00',3.75),('8537','2013-07-27','10:35:00',3.78),('8537','2013-07-27','10:40:00',3.87),('8537','2013-07-27','10:45:00',3.92),('8537','2013-07-27','10:50:00',3.98),('8537','2013-07-27','10:55:00',4.04),('8537','2013-07-27','11:00:00',4.07),('8537','2013-07-27','11:05:00',4.09),('8537','2013-07-27','11:10:00',4.06),('8537','2013-07-27','11:15:00',4.24),('8537','2013-07-27','11:20:00',4.31),('8537','2013-07-27','11:25:00',4.31),('8537','2013-07-27','11:30:00',4.38),('8537','2013-07-27','11:35:00',4.38),('8537','2013-07-27','11:40:00',4.44),('8537','2013-07-27','11:45:00',4.44),('8537','2013-07-27','11:50:00',4.44),('8537','2013-07-27','11:55:00',4.51),('8537','2013-07-27','12:00:00',4.51),('8537','2013-07-27','12:05:00',4.55),('8537','2013-07-27','12:10:00',4.6),('8537','2013-07-27','12:15:00',4.61),('8537','2013-07-27','12:20:00',4.59),('8537','2013-07-27','12:25:00',4.53),('8537','2013-07-27','12:30:00',4.5),('8537','2013-07-27','12:35:00',4.54),('8537','2013-07-27','12:40:00',4.42),('8537','2013-07-27','12:45:00',4.58),('8537','2013-07-27','12:50:00',4.56),('8537','2013-07-27','12:55:00',4.62),('8537','2013-07-27','13:00:00',4.77),('8537','2013-07-27','13:05:00',4.8),('8537','2013-07-27','13:10:00',4.74),('8537','2013-07-27','13:15:00',4.69),('8537','2013-07-27','13:20:00',4.71),('8537','2013-07-27','13:25:00',4.74),('8537','2013-07-27','13:30:00',4.65),('8537','2013-07-27','13:35:00',4.69),('8537','2013-07-27','13:40:00',4.5),('8537','2013-07-27','13:45:00',4.74),('8537','2013-07-27','13:50:00',4.71),('8537','2013-07-27','13:55:00',4.71),('8537','2013-07-27','14:00:00',4.37),('8537','2013-07-27','14:05:00',4.4),('8537','2013-07-27','14:10:00',4.53),('8537','2013-07-27','14:15:00',4.62),('8537','2013-07-27','14:20:00',4.51),('8537','2013-07-27','14:25:00',4.41),('8537','2013-07-27','14:30:00',4.41),('8537','2013-07-27','14:35:00',4.38),('8537','2013-07-27','14:40:00',4.41),('8537','2013-07-27','14:45:00',4.27),('8537','2013-07-27','14:50:00',4.15),('8537','2013-07-27','14:55:00',4.19),('8537','2013-07-27','15:00:00',4.12),('8537','2013-07-27','15:05:00',4.09),('8537','2013-07-27','15:10:00',4.09),('8537','2013-07-27','15:15:00',4.05),('8537','2013-07-27','15:20:00',4.01),('8537','2013-07-27','15:25:00',3.97),('8537','2013-07-27','15:30:00',3.9),('8537','2013-07-27','15:35:00',3.88),('8537','2013-07-27','15:40:00',3.8),('8537','2013-07-27','15:45:00',3.7),('8537','2013-07-27','15:50:00',3.68),('8537','2013-07-27','15:55:00',3.61),('8537','2013-07-27','16:00:00',3.55),('8537','2013-07-27','16:05:00',3.49),('8537','2013-07-27','16:10:00',3.43),('8537','2013-07-27','16:15:00',3.35),('8537','2013-07-27','16:20:00',3.3),('8537','2013-07-27','16:25:00',3.19),('8537','2013-07-27','16:30:00',3.14),('8537','2013-07-27','16:35:00',3.09),('8537','2013-07-27','16:40:00',3),('8537','2013-07-27','16:45:00',2.93),('8537','2013-07-27','16:50:00',2.84),('8537','2013-07-27','16:55:00',2.76),('8537','2013-07-27','17:00:00',2.65),('8537','2013-07-27','17:05:00',2.39),('8537','2013-07-27','17:10:00',1.92),('8537','2013-07-27','17:15:00',2.4),('8537','2013-07-27','17:20:00',2.34),('8537','2013-07-27','17:25:00',2.19),('8537','2013-07-27','17:30:00',2.08),('8537','2013-07-27','17:35:00',2),('8537','2013-07-27','17:40:00',1.91),('8537','2013-07-27','17:45:00',1.81),('8537','2013-07-27','17:50:00',1.71),('8537','2013-07-27','17:55:00',1.62),('8537','2013-07-27','18:00:00',1.5),('8537','2013-07-27','18:05:00',1.43),('8537','2013-07-27','18:10:00',1.34),('8537','2013-07-27','18:15:00',1.24),('8537','2013-07-27','18:20:00',1.14),('8537','2013-07-27','18:25:00',1.05),('8537','2013-07-26','07:50:00',1.08),('8537','2013-07-26','07:55:00',1.13),('8537','2013-07-26','08:00:00',1.2),('8537','2013-07-26','08:05:00',1.32),('8537','2013-07-26','08:10:00',1.43),('8537','2013-07-26','08:15:00',1.52),('8537','2013-07-26','08:20:00',1.59),('8537','2013-07-26','08:25:00',1.69),('8537','2013-07-26','08:30:00',1.8),('8537','2013-07-26','08:35:00',1.89),('8537','2013-07-26','08:40:00',1.97),('8537','2013-07-26','08:45:00',2.07),('8537','2013-07-26','08:50:00',2.13),('8537','2013-07-26','08:55:00',2.25),('8537','2013-07-26','09:00:00',2.37),('8537','2013-07-26','09:05:00',2.46),('8537','2013-07-26','09:10:00',2.53),('8537','2013-07-26','09:15:00',2.66),('8537','2013-07-26','09:20:00',2.73),('8537','2013-07-26','09:25:00',2.82),('8537','2013-07-26','09:30:00',2.9),('8537','2013-07-26','09:35:00',2.95),('8537','2013-07-26','09:40:00',3.03),('8537','2013-07-26','09:45:00',2.92),('8537','2013-07-26','09:50:00',3.17),('8537','2013-07-26','09:55:00',3.3),('8537','2013-07-26','10:00:00',3.35),('8537','2013-07-26','10:05:00',3.4),('8537','2013-07-26','10:10:00',3.45),('8537','2013-07-26','10:15:00',3.55),('8537','2013-07-26','10:20:00',3.62),('8537','2013-07-26','10:25:00',3.68),('8537','2013-07-26','10:30:00',3.73),('8537','2013-07-26','10:35:00',3.78),('8537','2013-07-26','10:40:00',3.78),('8537','2013-07-26','10:45:00',3.92),('8537','2013-07-26','10:50:00',3.96),('8537','2013-07-26','10:55:00',3.97),('8537','2013-07-26','11:00:00',3.93),('8537','2013-07-26','11:05:00',3.7),('8537','2013-07-26','11:10:00',2.6),('8537','2013-07-26','11:15:00',4.17),('8537','2013-07-26','11:20:00',4.17),('8537','2013-07-26','11:25:00',4.28),('8537','2013-07-26','11:30:00',3.86),('8537','2013-07-26','11:35:00',4.19),('8537','2013-07-26','11:40:00',4.12),('8537','2013-07-26','11:45:00',4.43),('8537','2013-07-26','11:50:00',4.4),('8537','2013-07-26','11:55:00',4.38),('8537','2013-07-26','12:00:00',4.24),('8537','2013-07-26','12:05:00',3.06),('8537','2013-07-26','12:10:00',3.15),('8537','2013-07-26','12:15:00',4.33),('8537','2013-07-26','12:20:00',4.03),('8537','2013-07-26','12:25:00',4.77),('8537','2013-07-26','12:30:00',4.7),('8537','2013-07-26','12:35:00',4.64),('8537','2013-07-26','12:40:00',4.53),('8537','2013-07-26','12:45:00',4.88),('8537','2013-07-26','12:50:00',3.55),('8537','2013-07-26','12:55:00',4),('8537','2013-07-26','13:00:00',1.6),('8537','2013-07-26','13:05:00',1.57),('8537','2013-07-26','13:10:00',1.5),('8537','2013-07-26','13:15:00',1.54),('8537','2013-07-26','13:20:00',4.02),('8537','2013-07-26','13:25:00',5.02),('8537','2013-07-26','13:30:00',4.88),('8537','2013-07-26','13:35:00',4.79),('8537','2013-07-26','13:40:00',4.61),('8537','2013-07-26','13:45:00',4.9),('8537','2013-07-26','13:50:00',4.42),('8537','2013-07-26','13:55:00',4.07),('8537','2013-07-26','14:00:00',4.82),('8537','2013-07-26','14:05:00',4.72),('8537','2013-07-26','14:10:00',4.43),('8537','2013-07-26','14:15:00',4.74),('8537','2013-07-26','14:20:00',4.63),('8537','2013-07-26','14:25:00',4.62),('8537','2013-07-26','14:30:00',4.53),('8537','2013-07-26','14:35:00',4.52),('8537','2013-07-26','14:40:00',4.51),('8537','2013-07-26','14:45:00',4.35),('8537','2013-07-26','14:50:00',4.17),('8537','2013-07-26','14:55:00',3.8),('8537','2013-07-26','15:00:00',4.26),('8537','2013-07-26','15:05:00',4.16),('8537','2013-07-26','15:10:00',4.12),('8537','2013-07-26','15:15:00',4.1),('8537','2013-07-26','15:20:00',3.99),('8537','2013-07-26','15:25:00',3.94),('8537','2013-07-26','15:30:00',3.9),('8537','2013-07-26','15:35:00',3.92),('8537','2013-07-26','15:40:00',3.84),('8537','2013-07-26','15:45:00',3.75),('8537','2013-07-26','15:50:00',3.72),('8537','2013-07-26','15:55:00',3.63),('8537','2013-07-26','16:00:00',3.58),('8537','2013-07-26','16:05:00',3.54),('8537','2013-07-26','16:10:00',3.45),('8537','2013-07-26','16:15:00',3.36),('8537','2013-07-26','16:20:00',3.34),('8537','2013-07-26','16:25:00',3.26),('8537','2013-07-26','16:30:00',3.16),('8537','2013-07-26','16:35:00',3.08),('8537','2013-07-26','16:40:00',3.01),('8537','2013-07-26','16:45:00',2.94),('8537','2013-07-26','16:50:00',2.87),('8537','2013-07-26','16:55:00',2.77),('8537','2013-07-26','17:00:00',2.69),('8537','2013-07-26','17:05:00',2.46),('8537','2013-07-26','17:10:00',2.04),('8537','2013-07-26','17:15:00',2.24),('8537','2013-07-26','17:20:00',2.29),('8537','2013-07-26','17:25:00',2.19),('8537','2013-07-26','17:30:00',2.01),('8537','2013-07-26','17:35:00',1.97),('8537','2013-07-26','17:40:00',1.89),('8537','2013-07-26','17:45:00',1.79),('8537','2013-07-26','17:50:00',1.59),('8537','2013-07-26','17:55:00',1.55),('8537','2013-07-26','18:00:00',1.41),('8537','2013-07-26','18:05:00',1.36),('8537','2013-07-26','18:10:00',1.28),('8537','2013-07-26','18:15:00',1.2),('8537','2013-07-26','18:20:00',1.08),('8537','2013-07-26','18:25:00',1.03),('8537','2013-07-25','07:50:00',1.08),('8537','2013-07-25','07:55:00',1.18),('8537','2013-07-25','08:00:00',1.27),('8537','2013-07-25','08:05:00',1.34),('8537','2013-07-25','08:10:00',1.43),('8537','2013-07-25','08:15:00',1.54),('8537','2013-07-25','08:20:00',1.61),('8537','2013-07-25','08:25:00',1.7),('8537','2013-07-25','08:30:00',1.79),('8537','2013-07-25','08:35:00',1.89),('8537','2013-07-25','08:40:00',1.98),('8537','2013-07-25','08:45:00',2.07),('8537','2013-07-25','08:50:00',2.15),('8537','2013-07-25','08:55:00',2.31),('8537','2013-07-25','09:00:00',2.38),('8537','2013-07-25','09:05:00',2.53),('8537','2013-07-25','09:10:00',2.66),('8537','2013-07-25','09:15:00',2.78),('8537','2013-07-25','09:20:00',2.85),('8537','2013-07-25','09:25:00',1.71),('8537','2013-07-25','09:30:00',2.05),('8537','2013-07-25','09:35:00',1.64),('8537','2013-07-25','09:40:00',2.91),('8537','2013-07-25','09:45:00',2.95),('8537','2013-07-25','09:50:00',2.34),('8537','2013-07-25','09:55:00',1.07),('8537','2013-07-25','10:00:00',1.15),('8537','2013-07-25','10:05:00',2.5),('8537','2013-07-25','10:10:00',3.43),('8537','2013-07-25','10:15:00',3.7),('8537','2013-07-25','10:20:00',3.81),('8537','2013-07-25','10:25:00',3.83),('8537','2013-07-25','10:30:00',3.75),('8537','2013-07-25','10:35:00',3.93),('8537','2013-07-25','10:40:00',2.58),('8537','2013-07-25','10:45:00',3.22),('8537','2013-07-25','10:50:00',3.57),('8537','2013-07-25','10:55:00',3.18),('8537','2013-07-25','11:00:00',1.36),('8537','2013-07-25','11:05:00',4.06),('8537','2013-07-25','11:10:00',4.32),('8537','2013-07-25','11:15:00',4.22),('8537','2013-07-25','11:20:00',3.99),('8537','2013-07-25','11:25:00',4.49),('8537','2013-07-25','11:30:00',4.42),('8537','2013-07-25','11:35:00',3.94),('8537','2013-07-25','11:40:00',4.04),('8537','2013-07-25','11:45:00',4.57),('8537','2013-07-25','11:50:00',3.93),('8537','2013-07-25','11:55:00',2.57),('8537','2013-07-25','12:00:00',4.06),('8537','2013-07-25','12:05:00',4.25),('8537','2013-07-25','12:10:00',2.39),('8537','2013-07-25','12:15:00',2.96),('8537','2013-07-25','12:20:00',3.03),('8537','2013-07-25','12:25:00',1.79),('8537','2013-07-25','12:30:00',2.15),('8537','2013-07-25','12:35:00',3.02),('8537','2013-07-25','12:40:00',1.64),('8537','2013-07-25','12:45:00',1.44),('8537','2013-07-25','12:50:00',2.06),('8537','2013-07-25','12:55:00',3.37),('8537','2013-07-25','13:00:00',5.15),('8537','2013-07-25','13:05:00',4.37),('8537','2013-07-25','13:10:00',3.76),('8537','2013-07-25','13:15:00',5.03),('8537','2013-07-25','13:20:00',4.95),('8537','2013-07-25','13:25:00',4.87),('8537','2013-07-25','13:30:00',4.9),('8537','2013-07-25','13:35:00',4.74),('8537','2013-07-25','13:40:00',4.82),('8537','2013-07-25','13:45:00',4.8),('8537','2013-07-25','13:50:00',4.78),('8537','2013-07-25','13:55:00',4.72),('8537','2013-07-25','14:00:00',4.77),('8537','2013-07-25','14:05:00',4.77),('8537','2013-07-25','14:10:00',4.78),('8537','2013-07-25','14:15:00',4.8),('8537','2013-07-25','14:20:00',4.77),('8537','2013-07-25','14:25:00',4.7),('8537','2013-07-25','14:30:00',4.68),('8537','2013-07-25','14:35:00',4.66),('8537','2013-07-25','14:40:00',4.54),('8537','2013-07-25','14:45:00',4.54),('8537','2013-07-25','14:50:00',4.24),('8537','2013-07-25','14:55:00',3.97),('8537','2013-07-25','15:00:00',4.38),('8537','2013-07-25','15:05:00',4.36),('8537','2013-07-25','15:10:00',4.31),('8537','2013-07-25','15:15:00',4.25),('8537','2013-07-25','15:20:00',4.23),('8537','2013-07-25','15:25:00',4.15),('8537','2013-07-25','15:30:00',4.1),('8537','2013-07-25','15:35:00',4.06),('8537','2013-07-25','15:40:00',4),('8537','2013-07-25','15:45:00',3.94),('8537','2013-07-25','15:50:00',3.86),('8537','2013-07-25','15:55:00',3.79),('8537','2013-07-25','16:00:00',3.73),('8537','2013-07-25','16:05:00',3.68),('8537','2013-07-25','16:10:00',3.62),('8537','2013-07-25','16:15:00',3.55),('8537','2013-07-25','16:20:00',3.49),('8537','2013-07-25','16:25:00',3.38),('8537','2013-07-25','16:30:00',3.24),('8537','2013-07-25','16:35:00',3.18),('8537','2013-07-25','16:40:00',3.14),('8537','2013-07-25','16:45:00',3.06),('8537','2013-07-25','16:50:00',2.97),('8537','2013-07-25','16:55:00',2.9),('8537','2013-07-25','17:00:00',2.82),('8537','2013-07-25','17:05:00',2.61),('8537','2013-07-25','17:10:00',2.09),('8537','2013-07-25','17:15:00',2.41),('8537','2013-07-25','17:20:00',2.42),('8537','2013-07-25','17:25:00',2.3),('8537','2013-07-25','17:30:00',2.18),('8537','2013-07-25','17:35:00',2.11),('8537','2013-07-25','17:40:00',2.01),('8537','2013-07-25','17:45:00',1.92),('8537','2013-07-25','17:50:00',1.72),('8537','2013-07-25','17:55:00',1.7),('8537','2013-07-25','18:00:00',1.58),('8537','2013-07-25','18:05:00',1.49),('8537','2013-07-25','18:10:00',1.39),('8537','2013-07-25','18:15:00',1.27),('8537','2013-07-25','18:20:00',1.18),('8537','2013-07-25','18:25:00',1.07),('8537','2013-07-25','18:30:00',1),('8537','2013-07-24','07:55:00',1.1),('8537','2013-07-24','08:00:00',1.07),('8537','2013-07-24','08:05:00',1.14),('8537','2013-07-24','08:10:00',1.04),('8537','2013-07-24','08:15:00',1.09),('8537','2013-07-24','08:20:00',1.48),('8537','2013-07-24','08:25:00',1.26),('8537','2013-07-24','08:30:00',1.3),('8537','2013-07-24','08:35:00',1.31),('8537','2013-07-24','08:40:00',1.21),('8537','2013-07-24','08:45:00',1.55),('8537','2013-07-24','08:50:00',1.91),('8537','2013-07-24','08:55:00',1.83),('8537','2013-07-24','09:00:00',1.6),('8537','2013-07-24','09:05:00',1.9),('8537','2013-07-24','09:10:00',2.85),('8537','2013-07-24','09:15:00',2.6),('8537','2013-07-24','09:20:00',2.18),('8537','2013-07-24','09:25:00',1.35),('8537','2013-07-24','09:30:00',1.97),('8537','2013-07-24','09:35:00',2.52),('8537','2013-07-24','09:40:00',2.85),('8537','2013-07-24','09:45:00',2.6),('8537','2013-07-24','09:50:00',1.74),('8537','2013-07-24','09:55:00',1.5),('8537','2013-07-24','10:00:00',1.17),('8537','2013-07-24','10:05:00',1.14),('8537','2013-07-24','10:10:00',1.15),('8537','2013-07-24','10:15:00',1.21),('8537','2013-07-24','10:20:00',1.69),('8537','2013-07-24','10:25:00',3.24),('8537','2013-07-24','10:30:00',3.64),('8537','2013-07-24','10:35:00',3.97),('8537','2013-07-24','10:40:00',4.28),('8537','2013-07-24','10:45:00',3.97),('8537','2013-07-24','10:50:00',2.26),('8537','2013-07-24','10:55:00',4.23),('8537','2013-07-24','11:00:00',3.5),('8537','2013-07-24','11:05:00',4.42),('8537','2013-07-24','11:10:00',3.91),('8537','2013-07-24','11:15:00',4.42),('8537','2013-07-24','11:20:00',4.34),('8537','2013-07-24','11:25:00',4.37),('8537','2013-07-24','11:30:00',4.46),('8537','2013-07-24','11:35:00',4.64),('8537','2013-07-24','11:40:00',4.53),('8537','2013-07-24','11:45:00',4.49),('8537','2013-07-24','11:50:00',4.46),('8537','2013-07-24','11:55:00',4.62),('8537','2013-07-24','12:00:00',4.78),('8537','2013-07-24','12:05:00',3.8),('8537','2013-07-24','12:10:00',1.76),('8537','2013-07-24','12:15:00',2.3),('8537','2013-07-24','12:20:00',5.19),('8537','2013-07-24','12:25:00',3.13),('8537','2013-07-24','12:30:00',1.79),('8537','2013-07-24','12:35:00',1.29),('8537','2013-07-24','12:40:00',1.47),('8537','2013-07-24','12:45:00',3.58),('8537','2013-07-24','12:50:00',1.56),('8537','2013-07-24','12:55:00',1.52),('8537','2013-07-24','13:00:00',3.05),('8537','2013-07-24','13:05:00',5.25),('8537','2013-07-24','13:10:00',4.97),('8537','2013-07-24','13:15:00',4.07),('8537','2013-07-24','13:20:00',4.12),('8537','2013-07-24','13:25:00',1.03),('8537','2013-07-24','13:30:00',2.11),('8537','2013-07-24','13:35:00',5.21),('8537','2013-07-24','13:40:00',1.49),('8537','2013-07-24','13:45:00',2.82),('8537','2013-07-24','13:50:00',3.62),('8537','2013-07-24','13:55:00',5.28),('8537','2013-07-24','14:00:00',3.61),('8537','2013-07-24','14:05:00',5.1),('8537','2013-07-24','14:10:00',4.55),('8537','2013-07-24','14:15:00',4.88),('8537','2013-07-24','14:20:00',3.76),('8537','2013-07-24','14:25:00',4.33),('8537','2013-07-24','14:30:00',4.79),('8537','2013-07-24','14:35:00',5.06),('8537','2013-07-24','14:40:00',4.76),('8537','2013-07-24','14:45:00',4.73),('8537','2013-07-24','14:50:00',4.54),('8537','2013-07-24','14:55:00',4.38),('8537','2013-07-24','15:00:00',4.44),('8537','2013-07-24','15:05:00',4.48),('8537','2013-07-24','15:10:00',4.38),('8537','2013-07-24','15:15:00',4.38),('8537','2013-07-24','15:20:00',4.31),('8537','2013-07-24','15:25:00',4.29),('8537','2013-07-24','15:30:00',4.06),('8537','2013-07-24','15:35:00',3.96),('8537','2013-07-24','15:40:00',4.02),('8537','2013-07-24','15:45:00',3.9),('8537','2013-07-24','15:50:00',3.76),('8537','2013-07-24','15:55:00',3.86),('8537','2013-07-24','16:00:00',3.75),('8537','2013-07-24','16:05:00',3.68),('8537','2013-07-24','16:10:00',3.54),('8537','2013-07-24','16:15:00',3.52),('8537','2013-07-24','16:20:00',3.61),('8537','2013-07-24','16:25:00',3.51),('8537','2013-07-24','16:30:00',3.4),('8537','2013-07-24','16:35:00',3.29),('8537','2013-07-24','16:40:00',3.27),('8537','2013-07-24','16:45:00',3.1),('8537','2013-07-24','16:50:00',3.05),('8537','2013-07-24','16:55:00',3.09),('8537','2013-07-24','17:00:00',3.05),('8537','2013-07-24','17:05:00',2.79),('8537','2013-07-24','17:10:00',1.84),('8537','2013-07-24','17:15:00',2.52),('8537','2013-07-24','17:20:00',2.53),('8537','2013-07-24','17:25:00',2.34),('8537','2013-07-24','17:30:00',2.24),('8537','2013-07-24','17:35:00',2.12),('8537','2013-07-24','17:40:00',1.99),('8537','2013-07-24','17:45:00',1.92),('8537','2013-07-24','17:50:00',1.71),('8537','2013-07-24','17:55:00',1.68),('8537','2013-07-24','18:00:00',1.55),('8537','2013-07-24','18:05:00',1.44),('8537','2013-07-24','18:10:00',1.36),('8537','2013-07-24','18:15:00',1.23),('8537','2013-07-24','18:20:00',1.11),('8537','2013-07-24','18:25:00',1.1),('8537','2013-07-24','18:30:00',1.04),('8537','2013-07-23','07:45:00',1.09),('8537','2013-07-23','07:50:00',1.13),('8537','2013-07-23','07:55:00',1.23),('8537','2013-07-23','08:00:00',1.39),('8537','2013-07-23','08:05:00',1.52),('8537','2013-07-23','08:10:00',1.62),('8537','2013-07-23','08:15:00',1.72),('8537','2013-07-23','08:20:00',1.81),('8537','2013-07-23','08:25:00',1.9),('8537','2013-07-23','08:30:00',2),('8537','2013-07-23','08:35:00',2.1),('8537','2013-07-23','08:40:00',2.2),('8537','2013-07-23','08:45:00',2.29),('8537','2013-07-23','08:50:00',2.39),('8537','2013-07-23','08:55:00',2.5),('8537','2013-07-23','09:00:00',2.58),('8537','2013-07-23','09:05:00',2.67),('8537','2013-07-23','09:10:00',2.75),('8537','2013-07-23','09:15:00',2.82),('8537','2013-07-23','09:20:00',2.87),('8537','2013-07-23','09:25:00',2.94),('8537','2013-07-23','09:30:00',3.03),('8537','2013-07-23','09:35:00',3.11),('8537','2013-07-23','09:40:00',3.19),('8537','2013-07-23','09:45:00',3.22),('8537','2013-07-23','09:50:00',3.28),('8537','2013-07-23','09:55:00',3.3),('8537','2013-07-23','10:00:00',3.39),('8537','2013-07-23','10:05:00',3.42),('8537','2013-07-23','10:10:00',3.54),('8537','2013-07-23','10:15:00',3.61),('8537','2013-07-23','10:20:00',3.68),('8537','2013-07-23','10:25:00',3.77),('8537','2013-07-23','10:30:00',3.88),('8537','2013-07-23','10:35:00',3.96),('8537','2013-07-23','10:40:00',4.02),('8537','2013-07-23','10:45:00',4.04),('8537','2013-07-23','10:50:00',4.07),('8537','2013-07-23','10:55:00',4.12),('8537','2013-07-23','11:00:00',4.18),('8537','2013-07-23','11:05:00',4.19),('8537','2013-07-23','11:10:00',4.22),('8537','2013-07-23','11:15:00',4.27),('8537','2013-07-23','11:20:00',4.32),('8537','2013-07-23','11:25:00',4.39),('8537','2013-07-23','11:30:00',4.47),('8537','2013-07-23','11:35:00',4.51),('8537','2013-07-23','11:40:00',4.48),('8537','2013-07-23','11:45:00',4.49),('8537','2013-07-23','11:50:00',4.47),('8537','2013-07-23','11:55:00',4.57),('8537','2013-07-23','12:00:00',4.61),('8537','2013-07-23','12:05:00',4.66),('8537','2013-07-23','12:10:00',4.7),('8537','2013-07-23','12:15:00',4.7),('8537','2013-07-23','12:20:00',4.7),('8537','2013-07-23','12:25:00',4.69),('8537','2013-07-23','12:30:00',4.71),('8537','2013-07-23','12:35:00',4.74),('8537','2013-07-23','12:40:00',4.64),('8537','2013-07-23','12:45:00',4.83),('8537','2013-07-23','12:50:00',2.35),('8537','2013-07-23','12:55:00',4.31),('8537','2013-07-23','13:00:00',2.43),('8537','2013-07-23','13:05:00',1.21),('8537','2013-07-23','13:10:00',2.18),('8537','2013-07-23','13:15:00',2.49),('8537','2013-07-23','13:25:00',1.1),('8537','2013-07-23','13:30:00',3.12),('8537','2013-07-23','13:35:00',5.15),('8537','2013-07-23','13:40:00',4.03),('8537','2013-07-23','13:45:00',1.43),('8537','2013-07-23','13:50:00',3.3),('8537','2013-07-23','13:55:00',3.03),('8537','2013-07-23','14:00:00',5),('8537','2013-07-23','14:05:00',2.94),('8537','2013-07-23','14:35:00',1.52),('8537','2013-07-23','14:40:00',3.46),('8537','2013-07-23','14:45:00',4.29),('8537','2013-07-23','14:50:00',3.84),('8537','2013-07-23','14:55:00',4.11),('8537','2013-07-23','15:00:00',4.65),('8537','2013-07-23','15:05:00',4.88),('8537','2013-07-23','15:10:00',3.9),('8537','2013-07-23','15:15:00',3.97),('8537','2013-07-23','15:20:00',4.26),('8537','2013-07-23','15:25:00',4.15),('8537','2013-07-23','15:30:00',4.04),('8537','2013-07-23','15:35:00',3.99),('8537','2013-07-23','15:40:00',3.95),('8537','2013-07-23','15:45:00',3.78),('8537','2013-07-23','15:50:00',3.82),('8537','2013-07-23','15:55:00',3.79),('8537','2013-07-23','16:00:00',3.71),('8537','2013-07-23','16:05:00',3.58),('8537','2013-07-23','16:10:00',3.51),('8537','2013-07-23','16:15:00',3.43),('8537','2013-07-23','16:20:00',3.43),('8537','2013-07-23','16:25:00',3.32),('8537','2013-07-23','16:30:00',3.26),('8537','2013-07-23','16:35:00',3.12),('8537','2013-07-23','16:40:00',3.08),('8537','2013-07-23','16:45:00',2.98),('8537','2013-07-23','16:50:00',2.92),('8537','2013-07-23','16:55:00',2.85),('8537','2013-07-23','17:00:00',2.76),('8537','2013-07-23','17:05:00',2.59),('8537','2013-07-23','17:10:00',2.47),('8537','2013-07-23','17:15:00',2.51),('8537','2013-07-23','17:20:00',2.43),('8537','2013-07-23','17:25:00',2.35),('8537','2013-07-23','17:30:00',2.19),('8537','2013-07-23','17:35:00',2.13),('8537','2013-07-23','17:40:00',2.04),('8537','2013-07-23','17:45:00',1.96),('8537','2013-07-23','17:50:00',1.78),('8537','2013-07-23','17:55:00',1.73),('8537','2013-07-23','18:00:00',1.62),('8537','2013-07-23','18:05:00',1.54),('8537','2013-07-23','18:10:00',1.45),('8537','2013-07-23','18:15:00',1.37),('8537','2013-07-23','18:20:00',1.27),('8537','2013-07-23','18:25:00',1.16),('8537','2013-07-23','18:30:00',1.07),('8537','2013-07-22','07:45:00',1.08),('8537','2013-07-22','07:50:00',1.17),('8537','2013-07-22','07:55:00',1.27),('8537','2013-07-22','08:00:00',1.37),('8537','2013-07-22','08:05:00',1.46),('8537','2013-07-22','08:10:00',1.56),('8537','2013-07-22','08:15:00',1.67),('8537','2013-07-22','08:20:00',1.77),('8537','2013-07-22','08:25:00',1.87),('8537','2013-07-22','08:30:00',1.97),('8537','2013-07-22','08:35:00',2.07),('8537','2013-07-22','08:40:00',2.18),('8537','2013-07-22','08:45:00',2.28),('8537','2013-07-22','08:50:00',2.37),('8537','2013-07-22','08:55:00',2.47),('8537','2013-07-22','09:00:00',2.56),('8537','2013-07-22','09:05:00',2.65),('8537','2013-07-22','09:10:00',2.74),('8537','2013-07-22','09:15:00',2.82),('8537','2013-07-22','09:20:00',2.91),('8537','2013-07-22','09:25:00',2.99),('8537','2013-07-22','09:30:00',3.06),('8537','2013-07-22','09:35:00',3.14),('8537','2013-07-22','09:40:00',3.19),('8537','2013-07-22','09:45:00',3.3),('8537','2013-07-22','09:50:00',3.32),('8537','2013-07-22','09:55:00',3.47),('8537','2013-07-22','10:00:00',3.53),('8537','2013-07-22','10:05:00',3.6),('8537','2013-07-22','10:10:00',3.66),('8537','2013-07-22','10:15:00',3.73),('8537','2013-07-22','10:20:00',3.8),('8537','2013-07-22','10:25:00',3.85),('8537','2013-07-22','10:30:00',3.93),('8537','2013-07-22','10:35:00',3.97),('8537','2013-07-22','10:40:00',4.03),('8537','2013-07-22','10:45:00',4.08),('8537','2013-07-22','10:50:00',4.13),('8537','2013-07-22','10:55:00',4.19),('8537','2013-07-22','11:00:00',4.21),('8537','2013-07-22','11:05:00',4.25),('8537','2013-07-22','11:10:00',4.3),('8537','2013-07-22','11:15:00',4.3),('8537','2013-07-22','11:20:00',4.3),('8537','2013-07-22','11:25:00',4.37),('8537','2013-07-22','11:30:00',4.42),('8537','2013-07-22','11:35:00',4.45),('8537','2013-07-22','11:40:00',4.49),('8537','2013-07-22','11:45:00',4.48),('8537','2013-07-22','11:50:00',4.51),('8537','2013-07-22','11:55:00',4.54),('8537','2013-07-22','12:00:00',4.54),('8537','2013-07-22','12:05:00',4.6),('8537','2013-07-22','12:10:00',4.64),('8537','2013-07-22','12:15:00',4.7),('8537','2013-07-22','12:20:00',4.69),('8537','2013-07-22','12:25:00',4.68),('8537','2013-07-22','12:30:00',4.82),('8537','2013-07-22','12:35:00',4.82),('8537','2013-07-22','12:40:00',4.78),('8537','2013-07-22','12:45:00',4.74),('8537','2013-07-22','12:50:00',4.66),('8537','2013-07-22','12:55:00',4.76),('8537','2013-07-22','13:00:00',4.81),('8537','2013-07-22','13:05:00',4.89),('8537','2013-07-22','13:10:00',4.83),('8537','2013-07-22','13:15:00',4.74),('8537','2013-07-22','13:20:00',4.78),('8537','2013-07-22','13:25:00',4.81),('8537','2013-07-22','13:30:00',4.77),('8537','2013-07-22','13:35:00',4.72),('8537','2013-07-22','13:40:00',4.84),('8537','2013-07-22','13:45:00',4.78),('8537','2013-07-22','13:50:00',4.79),('8537','2013-07-22','13:55:00',4.7),('8537','2013-07-22','14:00:00',4.63),('8537','2013-07-22','14:05:00',4.68),('8537','2013-07-22','14:10:00',4.63),('8537','2013-07-22','14:15:00',4.64),('8537','2013-07-22','14:20:00',4.6),('8537','2013-07-22','14:25:00',4.55),('8537','2013-07-22','14:30:00',4.59),('8537','2013-07-22','14:35:00',4.56),('8537','2013-07-22','14:40:00',4.55),('8537','2013-07-22','14:45:00',4.47),('8537','2013-07-22','14:50:00',4.22),('8537','2013-07-22','14:55:00',4.21),('8537','2013-07-22','15:00:00',3.42),('8537','2013-07-22','15:05:00',4.37),('8537','2013-07-22','15:10:00',4.31),('8537','2013-07-22','15:15:00',4.22),('8537','2013-07-22','15:20:00',4.15),('8537','2013-07-22','15:25:00',4.18),('8537','2013-07-22','15:30:00',1.25),('8537','2013-07-22','15:40:00',1.32),('8537','2013-07-22','15:45:00',3.97),('8537','2013-07-22','15:50:00',3.75),('8537','2013-07-22','15:55:00',4.04),('8537','2013-07-22','16:00:00',3.83),('8537','2013-07-22','16:05:00',2.79),('8537','2013-07-22','16:10:00',1.92),('8537','2013-07-22','16:15:00',3.01),('8537','2013-07-22','16:20:00',3.48),('8537','2013-07-22','16:25:00',3.66),('8537','2013-07-22','16:30:00',3.35),('8537','2013-07-22','16:35:00',2.94),('8537','2013-07-22','16:40:00',2.93),('8537','2013-07-22','16:45:00',2.98),('8537','2013-07-22','16:50:00',2.88),('8537','2013-07-22','16:55:00',2.83),('8537','2013-07-22','17:00:00',2.75),('8537','2013-07-22','17:05:00',2.64),('8537','2013-07-22','17:10:00',2.48),('8537','2013-07-22','17:15:00',2.5),('8537','2013-07-22','17:20:00',2.39),('8537','2013-07-22','17:25:00',2.21),('8537','2013-07-22','17:30:00',2.08),('8537','2013-07-22','17:35:00',2.03),('8537','2013-07-22','17:40:00',1.98),('8537','2013-07-22','17:45:00',1.76),('8537','2013-07-22','17:50:00',1.67),('8537','2013-07-22','17:55:00',1.64),('8537','2013-07-22','18:00:00',1.57),('8537','2013-07-22','18:05:00',1.47),('8537','2013-07-22','18:10:00',1.35),('8537','2013-07-22','18:15:00',1.23),('8537','2013-07-22','18:20:00',1.16),('8537','2013-07-22','18:25:00',1.07),('8537','2013-07-22','18:30:00',1.01),('8537','2013-07-21','07:45:00',1.08),('8537','2013-07-21','07:50:00',1.13),('8537','2013-07-21','07:55:00',1.18),('8537','2013-07-21','08:00:00',1.28),('8537','2013-07-21','08:05:00',1.35),('8537','2013-07-21','08:10:00',1.48),('8537','2013-07-21','08:15:00',1.57),('8537','2013-07-21','08:20:00',1.62),('8537','2013-07-21','08:25:00',1.77),('8537','2013-07-21','08:30:00',1.88),('8537','2013-07-21','08:35:00',1.97),('8537','2013-07-21','08:40:00',2.04),('8537','2013-07-21','08:45:00',2.13),('8537','2013-07-21','08:50:00',2.21),('8537','2013-07-21','08:55:00',2.33),('8537','2013-07-21','09:00:00',2.43),('8537','2013-07-21','09:05:00',2.52),('8537','2013-07-21','09:10:00',2.61),('8537','2013-07-21','09:15:00',2.71),('8537','2013-07-21','09:20:00',2.79),('8537','2013-07-21','09:25:00',2.86),('8537','2013-07-21','09:30:00',2.94),('8537','2013-07-21','09:35:00',2.99),('8537','2013-07-21','09:40:00',3.11),('8537','2013-07-21','09:45:00',3.18),('8537','2013-07-21','09:50:00',3.25),('8537','2013-07-21','09:55:00',3.32),('8537','2013-07-21','10:00:00',3.41),('8537','2013-07-21','10:05:00',3.47),('8537','2013-07-21','10:10:00',3.53),('8537','2013-07-21','10:15:00',3.58),('8537','2013-07-21','10:20:00',3.66),('8537','2013-07-21','10:25:00',3.71),('8537','2013-07-21','10:30:00',3.74),('8537','2013-07-21','10:35:00',3.79),('8537','2013-07-21','10:40:00',3.86),('8537','2013-07-21','10:45:00',3.97),('8537','2013-07-21','10:50:00',4),('8537','2013-07-21','10:55:00',4.1),('8537','2013-07-21','11:00:00',4.14),('8537','2013-07-21','11:05:00',4.14),('8537','2013-07-21','11:10:00',4.16),('8537','2013-07-21','11:15:00',4.2),('8537','2013-07-21','11:20:00',4.31),('8537','2013-07-21','11:25:00',4.32),('8537','2013-07-21','11:30:00',4.36),('8537','2013-07-21','11:35:00',4.42),('8537','2013-07-21','11:40:00',4.63),('8537','2013-07-21','11:45:00',4.54),('8537','2013-07-21','11:50:00',4.59),('8537','2013-07-21','11:55:00',4.59),('8537','2013-07-21','12:00:00',4.57),('8537','2013-07-21','12:05:00',4.66),('8537','2013-07-21','12:10:00',4.57),('8537','2013-07-21','12:15:00',4.86),('8537','2013-07-21','12:20:00',5.05),('8537','2013-07-21','12:25:00',5.06),('8537','2013-07-21','12:30:00',5.18),('8537','2013-07-21','12:35:00',5.46),('8537','2013-07-21','12:40:00',5.41),('8537','2013-07-21','12:45:00',4.85),('8537','2013-07-21','12:50:00',4.69),('8537','2013-07-21','12:55:00',5.6),('8537','2013-07-21','13:00:00',5.15),('8537','2013-07-21','13:05:00',5.41),('8537','2013-07-21','13:10:00',5.23),('8537','2013-07-21','13:15:00',4.45),('8537','2013-07-21','13:20:00',4.42),('8537','2013-07-21','13:25:00',5.23),('8537','2013-07-21','13:30:00',5.01),('8537','2013-07-21','13:35:00',4.67),('8537','2013-07-21','13:40:00',4.77),('8537','2013-07-21','13:45:00',1.96),('8537','2013-07-21','13:50:00',1.18),('8537','2013-07-21','14:05:00',1.06),('8537','2013-07-21','14:20:00',1.29),('8537','2013-07-21','14:25:00',1.41),('8537','2013-07-21','14:30:00',1.32),('8537','2013-07-21','14:35:00',1.46),('8537','2013-07-21','14:40:00',1.46),('8537','2013-07-21','14:45:00',2.79),('8537','2013-07-21','14:50:00',4.77),('8537','2013-07-21','14:55:00',1.89),('8537','2013-07-21','15:00:00',2.23),('8537','2013-07-21','15:05:00',1.8),('8537','2013-07-21','15:10:00',1.76),('8537','2013-07-21','15:15:00',3.04),('8537','2013-07-21','15:20:00',4.03),('8537','2013-07-21','15:25:00',1.88),('8537','2013-07-21','15:30:00',1.64),('8537','2013-07-21','15:35:00',1.86),('8537','2013-07-21','15:40:00',3.27),('8537','2013-07-21','15:45:00',2.79),('8537','2013-07-21','15:50:00',3.13),('8537','2013-07-21','15:55:00',2.21),('8537','2013-07-21','16:00:00',1.55),('8537','2013-07-21','16:05:00',1.24),('8537','2013-07-21','16:10:00',1.05),('8537','2013-07-21','16:40:00',1.02),('8537','2013-07-21','16:45:00',1.02),('8537','2013-07-21','16:50:00',1.06),('8537','2013-07-21','16:55:00',1.18),('8537','2013-07-21','17:00:00',1.31),('8537','2013-07-21','17:05:00',1.41),('8537','2013-07-21','17:10:00',1.39),('8537','2013-07-21','17:15:00',1.23),('8537','2013-07-21','17:20:00',1.13),('8537','2013-07-21','17:25:00',1.03),('8537','2014-04-07','08:20:00',1.22),('8537','2014-04-07','08:25:00',1.21),('8537','2014-04-07','08:30:00',1.33),('8537','2014-04-07','08:35:00',1.85),('8537','2014-04-07','08:40:00',1.96),('8537','2014-04-07','08:45:00',2.03),('8537','2014-04-07','08:50:00',1.71),('8537','2014-04-07','08:55:00',1.44),('8537','2014-04-07','09:00:00',1.38),('8537','2014-04-07','09:05:00',1.44),('8537','2014-04-07','09:10:00',1.62),('8537','2014-04-07','09:15:00',1.81),('8537','2014-04-07','09:20:00',1.63),('8537','2014-04-07','09:25:00',1.5),('8537','2014-04-07','09:30:00',1.49),('8537','2014-04-07','09:35:00',1.35),('8537','2014-04-07','09:40:00',1.38),('8537','2014-04-07','09:45:00',1.45),('8537','2014-04-07','09:50:00',1.52),('8537','2014-04-07','09:55:00',1.72),('8537','2014-04-07','10:00:00',1.63),('8537','2014-04-07','10:05:00',1.61),('8537','2014-04-07','10:10:00',1.72),('8537','2014-04-07','10:15:00',1.55),('8537','2014-04-07','10:20:00',1.53),('8537','2014-04-07','10:25:00',1.57),('8537','2014-04-07','10:30:00',1.62),('8537','2014-04-07','10:35:00',1.74),('8537','2014-04-07','10:40:00',1.78),('8537','2014-04-07','10:45:00',1.84),('8537','2014-04-07','10:50:00',1.89),('8537','2014-04-07','10:55:00',2.02),('8537','2014-04-07','11:00:00',2.14),('8537','2014-04-07','11:05:00',2.27),('8537','2014-04-07','11:10:00',2.59),('8537','2014-04-07','11:15:00',2.89),('8537','2014-04-07','11:20:00',2.59),('8537','2014-04-07','11:25:00',2.42),('8537','2014-04-07','11:30:00',2.46),('8537','2014-04-07','11:35:00',2.42),('8537','2014-04-07','11:40:00',2.31),('8537','2014-04-07','11:45:00',2.18),('8537','2014-04-07','11:50:00',2.11),('8537','2014-04-07','11:55:00',2.08),('8537','2014-04-07','12:00:00',2.31),('8537','2014-04-07','12:05:00',2.87),('8537','2014-04-07','12:10:00',3.24),('8537','2014-04-07','12:15:00',4.29),('8537','2014-04-07','12:20:00',5.12),('8537','2014-04-07','12:25:00',4.86),('8537','2014-04-07','12:30:00',3.14),('8537','2014-04-07','12:35:00',2.82),('8537','2014-04-07','12:40:00',3.46),('8537','2014-04-07','12:45:00',4.82),('8537','2014-04-07','12:50:00',4.88),('8537','2014-04-07','12:55:00',4.83),('8537','2014-04-07','13:00:00',4.89),('8537','2014-04-07','13:05:00',4.84),('8537','2014-04-07','13:10:00',4.8),('8537','2014-04-07','13:15:00',4.78),('8537','2014-04-07','13:20:00',4.81),('8537','2014-04-07','13:25:00',4.86),('8537','2014-04-07','13:30:00',4.8),('8537','2014-04-07','13:35:00',4.77),('8537','2014-04-07','13:40:00',4.72),('8537','2014-04-07','13:45:00',4.75),('8537','2014-04-07','13:50:00',4.74),('8537','2014-04-07','13:55:00',4.71),('8537','2014-04-07','14:00:00',4.7),('8537','2014-04-07','14:05:00',4.64),('8537','2014-04-07','14:10:00',4.58),('8537','2014-04-07','14:15:00',4.56),('8537','2014-04-07','14:20:00',4.57),('8537','2014-04-07','14:25:00',4.74),('8537','2014-04-07','14:30:00',4.67),('8537','2014-04-07','14:35:00',4.39),('8537','2014-04-07','14:40:00',4.08),('8537','2014-04-07','14:45:00',4.3),('8537','2014-04-07','14:50:00',4.37),('8537','2014-04-07','14:55:00',3.94),('8537','2014-04-07','15:00:00',3.56),('8537','2014-04-07','15:05:00',4.44),('8537','2014-04-07','15:10:00',3.97),('8537','2014-04-07','15:15:00',3.24),('8537','2014-04-07','15:20:00',4.58),('8537','2014-04-07','15:25:00',4.33),('8537','2014-04-07','15:30:00',4.03),('8537','2014-04-07','15:35:00',4.08),('8537','2014-04-07','15:40:00',3.97),('8537','2014-04-07','15:45:00',4.06),('8537','2014-04-07','15:50:00',4.24),('8537','2014-04-07','15:55:00',4.07),('8537','2014-04-07','16:00:00',2.5),('8537','2014-04-07','16:05:00',1.99),('8537','2014-04-07','16:10:00',3.6),('8537','2014-04-07','16:15:00',3.29),('8537','2014-04-07','16:20:00',3.05),('8537','2014-04-07','16:25:00',2.98),('8537','2014-04-07','16:30:00',2.84),('8537','2014-04-07','16:35:00',2.29),('8537','2014-04-07','16:40:00',1.25),('8537','2014-04-07','16:45:00',2.36),('8537','2014-04-07','16:50:00',2.16),('8537','2014-04-07','16:55:00',2.21),('8537','2014-04-07','17:00:00',2.61),('8537','2014-04-07','17:05:00',2.27),('8537','2014-04-07','17:10:00',1.38),('8537','2014-04-07','17:15:00',1.9),('8537','2013-07-20','07:40:00',1),('8537','2013-07-20','07:45:00',1.09),('8537','2013-07-20','07:50:00',1.16),('8537','2013-07-20','07:55:00',1.27),('8537','2013-07-20','08:00:00',1.36),('8537','2013-07-20','08:05:00',1.46),('8537','2013-07-20','08:10:00',1.55),('8537','2013-07-20','08:15:00',1.66),('8537','2013-07-20','08:20:00',1.76),('8537','2013-07-20','08:25:00',1.87),('8537','2013-07-20','08:30:00',1.96),('8537','2013-07-20','08:35:00',2.06),('8537','2013-07-20','08:40:00',2.17),('8537','2013-07-20','08:45:00',2.29),('8537','2013-07-20','08:50:00',2.37),('8537','2013-07-20','08:55:00',2.49),('8537','2013-07-20','09:00:00',2.6),('8537','2013-07-20','09:05:00',2.7),('8537','2013-07-20','09:10:00',2.85),('8537','2013-07-20','09:15:00',2.96),('8537','2013-07-20','09:20:00',3.02),('8537','2013-07-20','09:25:00',2.96),('8537','2013-07-20','09:30:00',2.98),('8537','2013-07-20','09:35:00',3),('8537','2013-07-20','09:40:00',3.01),('8537','2013-07-20','09:45:00',3.3),('8537','2013-07-20','09:50:00',3.25),('8537','2013-07-20','09:55:00',3.32),('8537','2013-07-20','10:00:00',3.48),('8537','2013-07-20','10:05:00',3.49),('8537','2013-07-20','10:10:00',3.61),('8537','2013-07-20','10:15:00',3.66),('8537','2013-07-20','10:20:00',3.76),('8537','2013-07-20','10:25:00',3.81),('8537','2013-07-20','10:30:00',3.87),('8537','2013-07-20','10:35:00',3.89),('8537','2013-07-20','10:40:00',3.97),('8537','2013-07-20','10:45:00',4.07),('8537','2013-07-20','10:50:00',4.08),('8537','2013-07-20','10:55:00',4.16),('8537','2013-07-20','11:00:00',4.2),('8537','2013-07-20','11:05:00',4.19),('8537','2013-07-20','11:10:00',4.23),('8537','2013-07-20','11:15:00',4.29),('8537','2013-07-20','11:20:00',4.33),('8537','2013-07-20','11:25:00',4.36),('8537','2013-07-20','11:30:00',4.39),('8537','2013-07-20','11:35:00',4.46),('8537','2013-07-20','11:40:00',4.48),('8537','2013-07-20','11:45:00',4.5),('8537','2013-07-20','11:50:00',4.59),('8537','2013-07-20','11:55:00',4.62),('8537','2013-07-20','12:00:00',4.68),('8537','2013-07-20','12:05:00',4.73),('8537','2013-07-20','12:10:00',4.79),('8537','2013-07-20','12:15:00',4.71),('8537','2013-07-20','12:20:00',3.95),('8537','2013-07-20','12:25:00',2.59),('8537','2013-07-20','12:30:00',4.8),('8537','2013-07-20','12:35:00',4.71),('8537','2013-07-20','12:40:00',4.82),('8537','2013-07-20','12:45:00',4.86),('8537','2013-07-20','12:50:00',4.87),('8537','2013-07-20','12:55:00',4.91),('8537','2013-07-20','13:00:00',5.04),('8537','2013-07-20','13:05:00',4.99),('8537','2013-07-20','13:10:00',4.88),('8537','2013-07-20','13:15:00',3.86),('8537','2013-07-20','13:20:00',1.31),('8537','2013-07-20','13:25:00',2.89),('8537','2013-07-20','13:30:00',5.19),('8537','2013-07-20','13:35:00',5.05),('8537','2013-07-20','13:40:00',5.11),('8537','2013-07-20','13:45:00',5.03),('8537','2013-07-20','13:50:00',2.44),('8537','2013-07-20','13:55:00',1.03),('8537','2013-07-20','14:00:00',2.61),('8537','2013-07-20','14:05:00',5.17),('8537','2013-07-20','14:10:00',3.59),('8537','2013-07-20','14:15:00',2.58),('8537','2013-07-20','14:20:00',3.92),('8537','2013-07-20','14:25:00',4.97),('8537','2013-07-20','14:30:00',4.8),('8537','2013-07-20','14:35:00',4.89),('8537','2013-07-20','14:40:00',4.74),('8537','2013-07-20','14:45:00',2.11),('8537','2013-07-20','14:50:00',3.42),('8537','2013-07-20','14:55:00',1.46),('8537','2013-07-20','15:00:00',2.77),('8537','2013-07-20','15:05:00',4.65),('8537','2013-07-20','15:10:00',4.5),('8537','2013-07-20','15:15:00',4.34),('8537','2013-07-20','15:20:00',4.22),('8537','2013-07-20','15:25:00',4.14),('8537','2013-07-20','15:30:00',4.1),('8537','2013-07-20','15:35:00',4.02),('8537','2013-07-20','15:40:00',3.86),('8537','2013-07-20','15:45:00',3.72),('8537','2013-07-20','15:50:00',3.63),('8537','2013-07-20','15:55:00',3.77),('8537','2013-07-20','16:00:00',3.69),('8537','2013-07-20','16:05:00',3.61),('8537','2013-07-20','16:10:00',3.56),('8537','2013-07-20','16:15:00',3.51),('8537','2013-07-20','16:20:00',3.46),('8537','2013-07-20','16:25:00',3.38),('8537','2013-07-20','16:30:00',3.19),('8537','2013-07-20','16:35:00',2.83),('8537','2013-07-20','16:40:00',3.09),('8537','2013-07-20','16:45:00',2.98),('8537','2013-07-20','16:50:00',2.91),('8537','2013-07-20','16:55:00',2.81),('8537','2013-07-20','17:00:00',2.73),('8537','2013-07-20','17:05:00',2.65),('8537','2013-07-20','17:10:00',2.54),('8537','2013-07-20','17:15:00',2.48),('8537','2013-07-20','17:20:00',2.39),('8537','2013-07-20','17:25:00',2.29),('8537','2013-07-20','17:30:00',2.13),('8537','2013-07-20','17:35:00',2.09),('8537','2013-07-20','17:40:00',2.01),('8537','2013-07-20','17:45:00',1.92),('8537','2013-07-20','17:50:00',1.76),('8537','2013-07-20','17:55:00',1.69),('8537','2013-07-20','18:00:00',1.58),('8537','2013-07-20','18:05:00',1.49),('8537','2013-07-20','18:10:00',1.4),('8537','2013-07-20','18:15:00',1.31),('8537','2013-07-20','18:20:00',1.22),('8537','2013-07-20','18:25:00',1.13),('8537','2013-07-20','18:30:00',1.04),('8537','2013-07-19','07:45:00',1.06),('8537','2013-07-19','07:50:00',1.15),('8537','2013-07-19','07:55:00',1.24),('8537','2013-07-19','08:00:00',1.33),('8537','2013-07-19','08:05:00',1.42),('8537','2013-07-19','08:10:00',1.51),('8537','2013-07-19','08:15:00',1.6),('8537','2013-07-19','08:20:00',1.69),('8537','2013-07-19','08:25:00',1.78),('8537','2013-07-19','08:30:00',1.87),('8537','2013-07-19','08:35:00',1.98),('8537','2013-07-19','08:40:00',2.09),('8537','2013-07-19','08:45:00',2.19),('8537','2013-07-19','08:50:00',2.29),('8537','2013-07-19','08:55:00',2.38),('8537','2013-07-19','09:00:00',2.44),('8537','2013-07-19','09:05:00',2.52),('8537','2013-07-19','09:10:00',2.62),('8537','2013-07-19','09:15:00',2.7),('8537','2013-07-19','09:20:00',2.79),('8537','2013-07-19','09:25:00',2.85),('8537','2013-07-19','09:30:00',2.91),('8537','2013-07-19','09:35:00',2.99),('8537','2013-07-19','09:40:00',3.08),('8537','2013-07-19','09:45:00',3.12),('8537','2013-07-19','09:50:00',3.19),('8537','2013-07-19','09:55:00',3.25),('8537','2013-07-19','10:00:00',3.36),('8537','2013-07-19','10:05:00',3.38),('8537','2013-07-19','10:10:00',3.44),('8537','2013-07-19','10:15:00',3.5),('8537','2013-07-19','10:20:00',3.53),('8537','2013-07-19','10:25:00',3.63),('8537','2013-07-19','10:30:00',3.65),('8537','2013-07-19','10:35:00',3.75),('8537','2013-07-19','10:40:00',3.73),('8537','2013-07-19','10:45:00',3.84),('8537','2013-07-19','10:50:00',3.84),('8537','2013-07-19','10:55:00',3.99),('8537','2013-07-19','11:00:00',4),('8537','2013-07-19','11:05:00',4.03),('8537','2013-07-19','11:10:00',4.03),('8537','2013-07-19','11:15:00',4.05),('8537','2013-07-19','11:20:00',4.15),('8537','2013-07-19','11:25:00',4.2),('8537','2013-07-19','11:30:00',4.18),('8537','2013-07-19','11:35:00',4.16),('8537','2013-07-19','11:40:00',4.22),('8537','2013-07-19','11:45:00',4.37),('8537','2013-07-19','11:50:00',4.3),('8537','2013-07-19','11:55:00',4.4),('8537','2013-07-19','12:00:00',3.31),('8537','2013-07-19','12:05:00',2.35),('8537','2013-07-19','12:10:00',4.52),('8537','2013-07-19','12:15:00',4.61),('8537','2013-07-19','12:20:00',4.62),('8537','2013-07-19','12:25:00',4.61),('8537','2013-07-19','12:30:00',4.58),('8537','2013-07-19','12:35:00',4.58),('8537','2013-07-19','12:40:00',4.36),('8537','2013-07-19','12:45:00',4.5),('8537','2013-07-19','12:50:00',4.65),('8537','2013-07-19','12:55:00',4.7),('8537','2013-07-19','13:00:00',3.65),('8537','2013-07-19','13:05:00',4.38),('8537','2013-07-19','13:10:00',4.9),('8537','2013-07-19','13:15:00',2.44),('8537','2013-07-19','13:20:00',1.8),('8537','2013-07-19','13:25:00',4.24),('8537','2013-07-19','13:30:00',5.12),('8537','2013-07-19','13:35:00',4.98),('8537','2013-07-19','13:40:00',4.91),('8537','2013-07-19','13:45:00',4.94),('8537','2013-07-19','13:50:00',4.94),('8537','2013-07-19','13:55:00',4.98),('8537','2013-07-19','14:00:00',5),('8537','2013-07-19','14:05:00',4.88),('8537','2013-07-19','14:10:00',3.46),('8537','2013-07-19','14:15:00',4.21),('8537','2013-07-19','14:20:00',4.8),('8537','2013-07-19','14:25:00',4.54),('8537','2013-07-19','14:30:00',4.9),('8537','2013-07-19','14:35:00',4.92),('8537','2013-07-19','14:40:00',4.35),('8537','2013-07-19','14:45:00',4.59),('8537','2013-07-19','14:50:00',4.32),('8537','2013-07-19','14:55:00',4.58),('8537','2013-07-19','15:00:00',4.48),('8537','2013-07-19','15:05:00',4.45),('8537','2013-07-19','15:10:00',4.45),('8537','2013-07-19','15:15:00',2.5),('8537','2013-07-19','15:20:00',3.67),('8537','2013-07-19','15:25:00',3.26),('8537','2013-07-19','15:30:00',4.39),('8537','2013-07-19','15:35:00',4.26),('8537','2013-07-19','15:40:00',4.19),('8537','2013-07-19','15:45:00',4.02),('8537','2013-07-19','15:50:00',3.87),('8537','2013-07-19','15:55:00',3.88),('8537','2013-07-19','16:00:00',3.82),('8537','2013-07-19','16:05:00',3.76),('8537','2013-07-19','16:10:00',3.74),('8537','2013-07-19','16:15:00',3.66),('8537','2013-07-19','16:20:00',3.6),('8537','2013-07-19','16:25:00',3.52),('8537','2013-07-19','16:30:00',3.38),('8537','2013-07-19','16:35:00',3.03),('8537','2013-07-19','16:40:00',3.28),('8537','2013-07-19','16:45:00',3.22),('8537','2013-07-19','16:50:00',3.16),('8537','2013-07-19','16:55:00',3.18),('8537','2013-07-19','17:00:00',2.44),('8537','2013-07-19','17:05:00',2.18),('8537','2013-07-19','17:10:00',2.77),('8537','2013-07-19','17:15:00',2.35),('8537','2013-07-19','17:20:00',2.04),('8537','2013-07-19','17:25:00',1.8),('8537','2013-07-19','17:30:00',1.99),('8537','2013-07-19','17:35:00',2.08),('8537','2013-07-19','17:40:00',1.76),('8537','2013-07-19','17:45:00',1.43),('8537','2013-07-19','17:50:00',1.08),('8537','2013-07-18','07:40:00',1.03),('8537','2013-07-18','07:45:00',1.13),('8537','2013-07-18','07:50:00',1.23),('8537','2013-07-18','07:55:00',1.33),('8537','2013-07-18','08:00:00',1.42),('8537','2013-07-18','08:05:00',1.52),('8537','2013-07-18','08:10:00',1.62),('8537','2013-07-18','08:15:00',1.72),('8537','2013-07-18','08:20:00',1.81),('8537','2013-07-18','08:25:00',1.91),('8537','2013-07-18','08:30:00',2.01),('8537','2013-07-18','08:35:00',2.1),('8537','2013-07-18','08:40:00',2.2),('8537','2013-07-18','08:45:00',2.26),('8537','2013-07-18','08:50:00',2.38),('8537','2013-07-18','08:55:00',2.48),('8537','2013-07-18','09:00:00',2.58),('8537','2013-07-18','09:05:00',2.66),('8537','2013-07-18','09:10:00',2.74),('8537','2013-07-18','09:15:00',2.81),('8537','2013-07-18','09:20:00',2.9),('8537','2013-07-18','09:25:00',2.98),('8537','2013-07-18','09:30:00',3.06),('8537','2013-07-18','09:35:00',3.15),('8537','2013-07-18','09:40:00',3.21),('8537','2013-07-18','09:45:00',3.28),('8537','2013-07-18','09:50:00',3.37),('8537','2013-07-18','09:55:00',3.44),('8537','2013-07-18','10:00:00',3.51),('8537','2013-07-18','10:05:00',3.58),('8537','2013-07-18','10:10:00',3.67),('8537','2013-07-18','10:15:00',3.68),('8537','2013-07-18','10:20:00',3.74),('8537','2013-07-18','10:25:00',3.77),('8537','2013-07-18','10:30:00',3.85),('8537','2013-07-18','10:35:00',3.93),('8537','2013-07-18','10:40:00',3.99),('8537','2013-07-18','10:45:00',4.02),('8537','2013-07-18','10:50:00',4.08),('8537','2013-07-18','10:55:00',4.12),('8537','2013-07-18','11:00:00',4.15),('8537','2013-07-18','11:05:00',4.16),('8537','2013-07-18','11:10:00',4.2),('8537','2013-07-18','11:15:00',4.27),('8537','2013-07-18','11:20:00',4.39),('8537','2013-07-18','11:25:00',4.42),('8537','2013-07-18','11:30:00',4.45),('8537','2013-07-18','11:35:00',4.46),('8537','2013-07-18','11:40:00',4.45),('8537','2013-07-18','11:45:00',4.48),('8537','2013-07-18','11:50:00',4.49),('8537','2013-07-18','11:55:00',4.59),('8537','2013-07-18','12:00:00',4.62),('8537','2013-07-18','12:05:00',4.55),('8537','2013-07-18','12:10:00',4.53),('8537','2013-07-18','12:15:00',4.53),('8537','2013-07-18','12:20:00',4.65),('8537','2013-07-18','12:25:00',3.97),('8537','2013-07-18','12:30:00',2.48),('8537','2013-07-18','12:35:00',4.79),('8537','2013-07-18','12:40:00',5.04),('8537','2013-07-18','12:45:00',3.23),('8537','2013-07-18','12:50:00',4.2),('8537','2013-07-18','12:55:00',3.87),('8537','2013-07-18','13:00:00',4.86),('8537','2013-07-18','13:05:00',4.86),('8537','2013-07-18','13:10:00',4.91),('8537','2013-07-18','13:15:00',4.79),('8537','2013-07-18','13:20:00',4.45),('8537','2013-07-18','13:25:00',4.58),('8537','2013-07-18','13:30:00',4.6),('8537','2013-07-18','13:35:00',4.5),('8537','2013-07-18','13:40:00',5),('8537','2013-07-18','13:45:00',4.98),('8537','2013-07-18','13:50:00',4.82),('8537','2013-07-18','13:55:00',4.73),('8537','2013-07-18','14:00:00',4.64),('8537','2013-07-18','14:05:00',4.68),('8537','2013-07-18','14:10:00',4.64),('8537','2013-07-18','14:15:00',4.67),('8537','2013-07-18','14:20:00',4.68),('8537','2013-07-18','14:25:00',4.63),('8537','2013-07-18','14:30:00',4.54),('8537','2013-07-18','14:35:00',4.61),('8537','2013-07-18','14:40:00',4.59),('8537','2013-07-18','14:45:00',4.5),('8537','2013-07-18','14:50:00',4.28),('8537','2013-07-18','14:55:00',4.3),('8537','2013-07-18','15:00:00',4.31),('8537','2013-07-18','15:05:00',4.3),('8537','2013-07-18','15:10:00',4.27),('8537','2013-07-18','15:15:00',4.16),('8537','2013-07-18','15:20:00',4.17),('8537','2013-07-18','15:25:00',4.13),('8537','2013-07-18','15:30:00',4.07),('8537','2013-07-18','15:35:00',4.03),('8537','2013-07-18','15:40:00',3.98),('8537','2013-07-18','15:45:00',3.75),('8537','2013-07-18','15:50:00',3.7),('8537','2013-07-18','15:55:00',3.76),('8537','2013-07-18','16:00:00',3.69),('8537','2013-07-18','16:05:00',3.6),('8537','2013-07-18','16:10:00',3.55),('8537','2013-07-18','16:15:00',3.45),('8537','2013-07-18','16:20:00',3.4),('8537','2013-07-18','16:25:00',3.32),('8537','2013-07-18','16:30:00',3.11),('8537','2013-07-18','16:35:00',2.88),('8537','2013-07-18','16:40:00',3.05),('8537','2013-07-18','16:45:00',2.98),('8537','2013-07-18','16:50:00',2.89),('8537','2013-07-18','16:55:00',2.82),('8537','2013-07-18','17:00:00',2.72),('8537','2013-07-18','17:05:00',2.63),('8537','2013-07-18','17:10:00',2.36),('8537','2013-07-18','17:15:00',1.93),('8537','2013-07-18','17:20:00',1.99),('8537','2013-07-18','17:25:00',2.26),('8537','2013-07-18','17:30:00',2.07),('8537','2013-07-18','17:35:00',1.97),('8537','2013-07-18','17:40:00',1.85),('8537','2013-07-18','17:45:00',1.73),('8537','2013-07-18','17:50:00',1.64),('8537','2013-07-18','17:55:00',1.61),('8537','2013-07-18','18:00:00',1.45),('8537','2013-07-18','18:05:00',1.38),('8537','2013-07-18','18:10:00',1.28),('8537','2013-07-18','18:15:00',1.23),('8537','2013-07-18','18:20:00',1.12),('8537','2013-07-18','18:25:00',1.04),('8537','2013-07-17','07:40:00',1.04),('8537','2013-07-17','07:45:00',1.14),('8537','2013-07-17','07:50:00',1.24),('8537','2013-07-17','07:55:00',1.31),('8537','2013-07-17','08:00:00',1.41),('8537','2013-07-17','08:05:00',1.53),('8537','2013-07-17','08:10:00',1.67),('8537','2013-07-17','08:15:00',1.75),('8537','2013-07-17','08:20:00',1.9),('8537','2013-07-17','08:25:00',1.99),('8537','2013-07-17','08:30:00',2.08),('8537','2013-07-17','08:35:00',2.2),('8537','2013-07-17','08:40:00',2.31),('8537','2013-07-17','08:45:00',2.41),('8537','2013-07-17','08:50:00',2.51),('8537','2013-07-17','08:55:00',2.6),('8537','2013-07-17','09:00:00',2.7),('8537','2013-07-17','09:05:00',2.8),('8537','2013-07-17','09:10:00',2.89),('8537','2013-07-17','09:15:00',2.99),('8537','2013-07-17','09:20:00',3.09),('8537','2013-07-17','09:25:00',3.19),('8537','2013-07-17','09:30:00',3.19),('8537','2013-07-17','09:35:00',3.3),('8537','2013-07-17','09:40:00',3.41),('8537','2013-07-17','09:45:00',3.49),('8537','2013-07-17','09:50:00',3.56),('8537','2013-07-17','09:55:00',3.62),('8537','2013-07-17','10:00:00',3.68),('8537','2013-07-17','10:05:00',3.74),('8537','2013-07-17','10:10:00',3.8),('8537','2013-07-17','10:15:00',3.87),('8537','2013-07-17','10:20:00',3.91),('8537','2013-07-17','10:25:00',3.97),('8537','2013-07-17','10:30:00',4.04),('8537','2013-07-17','10:35:00',4.11),('8537','2013-07-17','10:40:00',4.12),('8537','2013-07-17','10:45:00',4.23),('8537','2013-07-17','10:50:00',4.3),('8537','2013-07-17','10:55:00',4.3),('8537','2013-07-17','11:00:00',4.39),('8537','2013-07-17','11:05:00',4.46),('8537','2013-07-17','11:10:00',4.5),('8537','2013-07-17','11:15:00',4.5),('8537','2013-07-17','11:20:00',4.54),('8537','2013-07-17','11:25:00',4.56),('8537','2013-07-17','11:30:00',4.6),('8537','2013-07-17','11:35:00',4.67),('8537','2013-07-17','11:40:00',4.68),('8537','2013-07-17','11:45:00',4.73),('8537','2013-07-17','11:50:00',4.75),('8537','2013-07-17','11:55:00',4.82),('8537','2013-07-17','12:00:00',4.85),('8537','2013-07-17','12:05:00',4.86),('8537','2013-07-17','12:10:00',4.89),('8537','2013-07-17','12:15:00',4.85),('8537','2013-07-17','12:20:00',4.87),('8537','2013-07-17','12:25:00',4.94),('8537','2013-07-17','12:30:00',4.92),('8537','2013-07-17','12:35:00',4.88),('8537','2013-07-17','12:40:00',4.91),('8537','2013-07-17','12:45:00',4.91),('8537','2013-07-17','12:50:00',4.91),('8537','2013-07-17','12:55:00',4.95),('8537','2013-07-17','13:00:00',4.92),('8537','2013-07-17','13:05:00',4.91),('8537','2013-07-17','13:10:00',4.93),('8537','2013-07-17','13:15:00',4.89),('8537','2013-07-17','13:20:00',4.84),('8537','2013-07-17','13:25:00',4.84),('8537','2013-07-17','13:30:00',4.88),('8537','2013-07-17','13:35:00',4.83),('8537','2013-07-17','13:40:00',4.82),('8537','2013-07-17','13:45:00',4.83),('8537','2013-07-17','13:50:00',4.85),('8537','2013-07-17','13:55:00',4.88),('8537','2013-07-17','14:00:00',4.86),('8537','2013-07-17','14:05:00',4.83),('8537','2013-07-17','14:10:00',4.74),('8537','2013-07-17','14:15:00',4.75),('8537','2013-07-17','14:20:00',4.66),('8537','2013-07-17','14:25:00',4.59),('8537','2013-07-17','14:30:00',4.56),('8537','2013-07-17','14:35:00',4.61),('8537','2013-07-17','14:40:00',4.79),('8537','2013-07-17','14:45:00',4.68),('8537','2013-07-17','14:50:00',4.43),('8537','2013-07-17','14:55:00',4.34),('8537','2013-07-17','15:00:00',4.4),('8537','2013-07-17','15:05:00',4.27),('8537','2013-07-17','15:10:00',2.93),('8537','2013-07-17','15:15:00',4.34),('8537','2013-07-17','15:20:00',4.35),('8537','2013-07-17','15:25:00',4.26),('8537','2013-07-17','15:30:00',4.18),('8537','2013-07-17','15:35:00',4.16),('8537','2013-07-17','15:40:00',3.32),('8537','2013-07-17','15:45:00',3.96),('8537','2013-07-17','15:50:00',3.65),('8537','2013-07-17','15:55:00',3.92),('8537','2013-07-17','16:00:00',3.81),('8537','2013-07-17','16:05:00',3.76),('8537','2013-07-17','16:10:00',3.72),('8537','2013-07-17','16:15:00',3.61),('8537','2013-07-17','16:20:00',3.51),('8537','2013-07-17','16:25:00',3.42),('8537','2013-07-17','16:30:00',3.22),('8537','2013-07-17','16:35:00',2.98),('8537','2013-07-17','16:40:00',3.16),('8537','2013-07-17','16:45:00',3.13),('8537','2013-07-17','16:50:00',2.99),('8537','2013-07-17','16:55:00',2.85),('8537','2013-07-17','17:00:00',2.81),('8537','2013-07-17','17:05:00',2.8),('8537','2013-07-17','17:10:00',2.61),('8537','2013-07-17','17:15:00',2.1),('8537','2013-07-17','17:20:00',2.43),('8537','2013-07-17','17:25:00',2.3),('8537','2013-07-17','17:30:00',2.18),('8537','2013-07-17','17:35:00',2.06),('8537','2013-07-17','17:40:00',1.99),('8537','2013-07-17','17:45:00',1.91),('8537','2013-07-17','17:50:00',1.84),('8537','2013-07-17','17:55:00',1.71),('8537','2013-07-17','18:00:00',1.61),('8537','2013-07-17','18:05:00',1.5),('8537','2013-07-17','18:10:00',1.43),('8537','2013-07-17','18:15:00',1.34),('8537','2013-07-17','18:20:00',1.24),('8537','2013-07-17','18:25:00',1.14),('8537','2013-07-17','18:30:00',1.05),('8537','2013-07-16','07:40:00',1.07),('8537','2013-07-16','07:45:00',1.16),('8537','2013-07-16','07:50:00',1.25),('8537','2013-07-16','07:55:00',1.33),('8537','2013-07-16','08:00:00',1.4),('8537','2013-07-16','08:05:00',1.51),('8537','2013-07-16','08:10:00',1.61),('8537','2013-07-16','08:15:00',1.71),('8537','2013-07-16','08:20:00',1.81),('8537','2013-07-16','08:25:00',1.92),('8537','2013-07-16','08:30:00',2.02),('8537','2013-07-16','08:35:00',2.11),('8537','2013-07-16','08:40:00',2.18),('8537','2013-07-16','08:45:00',2.27),('8537','2013-07-16','08:50:00',2.36),('8537','2013-07-16','08:55:00',2.48),('8537','2013-07-16','09:00:00',2.57),('8537','2013-07-16','09:05:00',2.63),('8537','2013-07-16','09:10:00',2.73),('8537','2013-07-16','09:15:00',2.8),('8537','2013-07-16','09:20:00',2.88),('8537','2013-07-16','09:25:00',2.98),('8537','2013-07-16','09:30:00',3.06),('8537','2013-07-16','09:35:00',3.14),('8537','2013-07-16','09:40:00',3.23),('8537','2013-07-16','09:45:00',3.3),('8537','2013-07-16','09:50:00',3.42),('8537','2013-07-16','09:55:00',3.51),('8537','2013-07-16','10:00:00',3.59),('8537','2013-07-16','10:05:00',3.68),('8537','2013-07-16','10:10:00',3.75),('8537','2013-07-16','10:15:00',3.81),('8537','2013-07-16','10:20:00',3.85),('8537','2013-07-16','10:25:00',3.91),('8537','2013-07-16','10:30:00',3.99),('8537','2013-07-16','10:35:00',4.03),('8537','2013-07-16','10:40:00',4.08),('8537','2013-07-16','10:45:00',4.12),('8537','2013-07-16','10:50:00',4.19),('8537','2013-07-16','10:55:00',4.24),('8537','2013-07-16','11:00:00',4.29),('8537','2013-07-16','11:05:00',4.34),('8537','2013-07-16','11:10:00',4.4),('8537','2013-07-16','11:15:00',4.42),('8537','2013-07-16','11:20:00',4.45),('8537','2013-07-16','11:25:00',4.52),('8537','2013-07-16','11:30:00',4.55),('8537','2013-07-16','11:35:00',4.53),('8537','2013-07-16','11:40:00',4.57),('8537','2013-07-16','11:45:00',4.63),('8537','2013-07-16','11:50:00',4.71),('8537','2013-07-16','11:55:00',4.78),('8537','2013-07-16','12:00:00',4.8),('8537','2013-07-16','12:05:00',4.81),('8537','2013-07-16','12:10:00',4.85),('8537','2013-07-16','12:15:00',4.85),('8537','2013-07-16','12:20:00',4.85),('8537','2013-07-16','12:25:00',4.84),('8537','2013-07-16','12:30:00',4.82),('8537','2013-07-16','12:35:00',4.82),('8537','2013-07-16','12:40:00',4.78),('8537','2013-07-16','12:45:00',4.77),('8537','2013-07-16','12:50:00',4.74),('8537','2013-07-16','12:55:00',4.77),('8537','2013-07-16','13:00:00',4.79),('8537','2013-07-16','13:05:00',4.9),('8537','2013-07-16','13:10:00',4.9),('8537','2013-07-16','13:15:00',4.94),('8537','2013-07-16','13:20:00',4.85),('8537','2013-07-16','13:25:00',4.82),('8537','2013-07-16','13:30:00',4.89),('8537','2013-07-16','13:35:00',4.87),('8537','2013-07-16','13:40:00',4.87),('8537','2013-07-16','13:45:00',4.9),('8537','2013-07-16','13:50:00',4.99),('8537','2013-07-16','13:55:00',4.72),('8537','2013-07-16','14:00:00',4.85),('8537','2013-07-16','14:05:00',4.7),('8537','2013-07-16','14:10:00',4.79),('8537','2013-07-16','14:15:00',4.11),('8537','2013-07-16','14:20:00',1.65),('8537','2013-07-16','14:25:00',4.42),('8537','2013-07-16','14:30:00',4.79),('8537','2013-07-16','14:35:00',4.77),('8537','2013-07-16','14:40:00',4.74),('8537','2013-07-16','14:45:00',4.65),('8537','2013-07-16','14:50:00',4.6),('8537','2013-07-16','14:55:00',4.59),('8537','2013-07-16','15:00:00',4.5),('8537','2013-07-16','15:05:00',4.4),('8537','2013-07-16','15:10:00',4.31),('8537','2013-07-16','15:15:00',4.25),('8537','2013-07-16','15:20:00',4.24),('8537','2013-07-16','15:25:00',4.22),('8537','2013-07-16','15:30:00',4.25),('8537','2013-07-16','15:35:00',4.2),('8537','2013-07-16','15:40:00',3.94),('8537','2013-07-16','15:45:00',3.05),('8537','2013-07-16','15:50:00',3.84),('8537','2013-07-16','15:55:00',3.84),('8537','2013-07-16','16:00:00',2.82),('8537','2013-07-16','16:05:00',1.01),('8537','2013-07-16','16:10:00',3.68),('8537','2013-07-16','16:15:00',3.61),('8537','2013-07-16','16:20:00',2.06),('8537','2013-07-16','16:25:00',1.48),('8537','2013-07-16','16:30:00',1.23),('8537','2013-07-16','16:45:00',1.41),('8537','2013-07-16','16:50:00',1.28),('8537','2013-07-16','16:55:00',1.37),('8537','2013-07-16','17:00:00',2.95),('8537','2013-07-16','17:05:00',2.94),('8537','2013-07-16','17:10:00',2.97),('8537','2013-07-16','17:15:00',2.8),('8537','2013-07-16','17:20:00',2.1),('8537','2013-07-16','17:25:00',1.42),('8537','2013-07-16','17:30:00',1.54),('8537','2013-07-16','17:35:00',1.55),('8537','2013-07-16','17:40:00',1.98),('8537','2013-07-16','17:45:00',2.13),('8537','2013-07-16','17:50:00',1.96),('8537','2013-07-16','17:55:00',1.39),('8537','2013-07-16','18:00:00',1.08),('8537','2013-07-16','18:10:00',1.04),('8537','2013-07-16','18:15:00',1.13),('8537','2013-07-16','18:20:00',1.09),('8537','2013-07-16','18:25:00',1.16),('8537','2013-07-16','18:30:00',1.08),('8537','2013-07-15','07:40:00',1.08),('8537','2013-07-15','07:45:00',1.18),('8537','2013-07-15','07:50:00',1.28),('8537','2013-07-15','07:55:00',1.38),('8537','2013-07-15','08:00:00',1.46),('8537','2013-07-15','08:05:00',1.58),('8537','2013-07-15','08:10:00',1.68),('8537','2013-07-15','08:15:00',1.79),('8537','2013-07-15','08:20:00',1.9),('8537','2013-07-15','08:25:00',2),('8537','2013-07-15','08:30:00',2.1),('8537','2013-07-15','08:35:00',2.21),('8537','2013-07-15','08:40:00',2.31),('8537','2013-07-15','08:45:00',2.4),('8537','2013-07-15','08:50:00',2.49),('8537','2013-07-15','08:55:00',2.59),('8537','2013-07-15','09:00:00',2.68),('8537','2013-07-15','09:05:00',2.77),('8537','2013-07-15','09:10:00',2.86),('8537','2013-07-15','09:15:00',2.94),('8537','2013-07-15','09:20:00',3.04),('8537','2013-07-15','09:25:00',3.12),('8537','2013-07-15','09:30:00',3.2),('8537','2013-07-15','09:35:00',3.28),('8537','2013-07-15','09:40:00',3.35),('8537','2013-07-15','09:45:00',3.41),('8537','2013-07-15','09:50:00',3.48),('8537','2013-07-15','09:55:00',3.54),('8537','2013-07-15','10:00:00',3.61),('8537','2013-07-15','10:05:00',3.68),('8537','2013-07-15','10:10:00',3.76),('8537','2013-07-15','10:15:00',3.83),('8537','2013-07-15','10:20:00',3.86),('8537','2013-07-15','10:25:00',3.89),('8537','2013-07-15','10:30:00',3.96),('8537','2013-07-15','10:35:00',3.99),('8537','2013-07-15','10:40:00',4.07),('8537','2013-07-15','10:45:00',4.12),('8537','2013-07-15','10:50:00',4.19),('8537','2013-07-15','10:55:00',4.25),('8537','2013-07-15','11:00:00',4.22),('8537','2013-07-15','11:05:00',4.34),('8537','2013-07-15','11:10:00',4.35),('8537','2013-07-15','11:15:00',4.36),('8537','2013-07-15','11:20:00',4.42),('8537','2013-07-15','11:25:00',4.46),('8537','2013-07-15','11:30:00',4.47),('8537','2013-07-15','11:35:00',4.53),('8537','2013-07-15','11:40:00',4.56),('8537','2013-07-15','11:45:00',4.58),('8537','2013-07-15','11:50:00',4.62),('8537','2013-07-15','11:55:00',4.67),('8537','2013-07-15','12:00:00',4.76),('8537','2013-07-15','12:05:00',4.72),('8537','2013-07-15','12:10:00',4.68),('8537','2013-07-15','12:15:00',4.77),('8537','2013-07-15','12:20:00',4.85),('8537','2013-07-15','12:25:00',4.85),('8537','2013-07-15','12:30:00',4.84),('8537','2013-07-15','12:35:00',4.82),('8537','2013-07-15','12:40:00',4.83),('8537','2013-07-15','12:45:00',4.74),('8537','2013-07-15','12:50:00',4.75),('8537','2013-07-15','12:55:00',4.84),('8537','2013-07-15','13:00:00',4.9),('8537','2013-07-15','13:05:00',4.8),('8537','2013-07-15','13:10:00',4.99),('8537','2013-07-15','13:15:00',4.94),('8537','2013-07-15','13:20:00',4.89),('8537','2013-07-15','13:25:00',5.11),('8537','2013-07-15','13:30:00',5.23),('8537','2013-07-15','13:35:00',4.3),('8537','2013-07-15','13:40:00',1.38),('8537','2013-07-15','13:45:00',3.58),('8537','2013-07-15','13:50:00',5.14),('8537','2013-07-15','13:55:00',5.22),('8537','2013-07-15','14:00:00',5.18),('8537','2013-07-15','14:05:00',4.37),('8537','2013-07-15','14:10:00',1.21),('8537','2013-07-15','14:15:00',1.2),('8537','2013-07-15','14:20:00',3.6),('8537','2013-07-15','14:25:00',5.04),('8537','2013-07-15','14:30:00',4.66),('8537','2013-07-15','14:35:00',4.44),('8537','2013-07-15','14:40:00',4.73),('8537','2013-07-15','14:45:00',4.76),('8537','2013-07-15','14:50:00',4.64),('8537','2013-07-15','14:55:00',4.43),('8537','2013-07-15','15:00:00',4.01),('8537','2013-07-15','15:05:00',4.34),('8537','2013-07-15','15:10:00',4.43),('8537','2013-07-15','15:15:00',4.3),('8537','2013-07-15','15:20:00',3.39),('8537','2013-07-15','15:25:00',3.87),('8537','2013-07-15','15:30:00',4.07),('8537','2013-07-15','15:35:00',3.78),('8537','2013-07-15','15:40:00',4.23),('8537','2013-07-15','15:45:00',3.98),('8537','2013-07-15','15:50:00',3.85),('8537','2013-07-15','15:55:00',3.8),('8537','2013-07-15','16:00:00',3.71),('8537','2013-07-15','16:05:00',3.68),('8537','2013-07-15','16:10:00',3.61),('8537','2013-07-15','16:15:00',3.55),('8537','2013-07-15','16:20:00',3.38),('8537','2013-07-15','16:25:00',3.31),('8537','2013-07-15','16:30:00',3.15),('8537','2013-07-15','16:35:00',3.06),('8537','2013-07-15','16:40:00',3.08),('8537','2013-07-15','16:45:00',3.02),('8537','2013-07-15','16:50:00',2.93),('8537','2013-07-15','16:55:00',2.88),('8537','2013-07-15','17:00:00',2.79),('8537','2013-07-15','17:05:00',2.71),('8537','2013-07-15','17:10:00',2.49),('8537','2013-07-15','17:15:00',2.13),('8537','2013-07-15','17:20:00',2.41),('8537','2013-07-15','17:25:00',2.33),('8537','2013-07-15','17:30:00',2.19),('8537','2013-07-15','17:35:00',2.06),('8537','2013-07-15','17:40:00',1.99),('8537','2013-07-15','17:45:00',1.88),('8537','2013-07-15','17:50:00',1.78),('8537','2013-07-15','17:55:00',1.62),('8537','2013-07-15','18:00:00',1.57),('8537','2013-07-15','18:05:00',1.46),('8537','2013-07-15','18:10:00',1.4),('8537','2013-07-15','18:15:00',1.32),('8537','2013-07-15','18:20:00',1.22),('8537','2013-07-15','18:25:00',1.12),('8537','2013-07-15','18:30:00',1.04),('8537','2013-07-14','07:50:00',1.15),('8537','2013-07-14','07:55:00',1.47),('8537','2013-07-14','08:00:00',1.45),('8537','2013-07-14','08:05:00',2),('8537','2013-07-14','08:10:00',1.84),('8537','2013-07-14','08:15:00',1.89),('8537','2013-07-14','08:20:00',2.22),('8537','2013-07-14','08:25:00',1.75),('8537','2013-07-14','08:30:00',1.11),('8537','2013-07-14','08:35:00',1.36),('8537','2013-07-14','08:40:00',1.31),('8537','2013-07-14','08:45:00',1.13),('8537','2013-07-14','08:50:00',1.3),('8537','2013-07-14','08:55:00',1.34),('8537','2013-07-14','09:00:00',1.26),('8537','2013-07-14','09:05:00',1.55),('8537','2013-07-14','09:10:00',1.82),('8537','2013-07-14','09:15:00',1.89),('8537','2013-07-14','09:20:00',2.33),('8537','2013-07-14','09:25:00',2.39),('8537','2013-07-14','09:30:00',2.5),('8537','2013-07-14','09:35:00',2.2),('8537','2013-07-14','09:40:00',1.97),('8537','2013-07-14','09:45:00',1.98),('8537','2013-07-14','09:50:00',1.88),('8537','2013-07-14','09:55:00',2),('8537','2013-07-14','10:00:00',1.97),('8537','2013-07-14','10:05:00',2.1),('8537','2013-07-14','10:10:00',2.06),('8537','2013-07-14','10:15:00',2.22),('8537','2013-07-14','10:20:00',2.82),('8537','2013-07-14','10:25:00',3.15),('8537','2013-07-14','10:30:00',2.99),('8537','2013-07-14','10:35:00',4.31),('8537','2013-07-14','10:40:00',4.28),('8537','2013-07-14','10:45:00',3.53),('8537','2013-07-14','10:50:00',4.52),('8537','2013-07-14','10:55:00',4.03),('8537','2013-07-14','11:00:00',4.3),('8537','2013-07-14','11:05:00',4.17),('8537','2013-07-14','11:10:00',4.04),('8537','2013-07-14','11:15:00',2.61),('8537','2013-07-14','11:20:00',4.48),('8537','2013-07-14','11:25:00',3.04),('8537','2013-07-14','11:30:00',4.74),('8537','2013-07-14','11:35:00',4.78),('8537','2013-07-14','11:40:00',4.31),('8537','2013-07-14','11:45:00',4.87),('8537','2013-07-14','11:50:00',3.99),('8537','2013-07-14','11:55:00',2.63),('8537','2013-07-14','12:00:00',2.23),('8537','2013-07-14','12:05:00',3.78),('8537','2013-07-14','12:10:00',4.83),('8537','2013-07-14','12:15:00',3.22),('8537','2013-07-14','12:20:00',3.97),('8537','2013-07-14','12:25:00',4.55),('8537','2013-07-14','12:30:00',2.46),('8537','2013-07-14','12:35:00',5.04),('8537','2013-07-14','12:40:00',4.8),('8537','2013-07-14','12:45:00',5.06),('8537','2013-07-14','12:50:00',4.81),('8537','2013-07-14','12:55:00',2.14),('8537','2013-07-14','13:00:00',4.01),('8537','2013-07-14','13:05:00',5.41),('8537','2013-07-14','13:10:00',5.12),('8537','2013-07-14','13:15:00',5.04),('8537','2013-07-14','13:20:00',5.11),('8537','2013-07-14','13:25:00',5),('8537','2013-07-14','13:30:00',4.99),('8537','2013-07-14','13:35:00',4.96),('8537','2013-07-14','13:40:00',4.93),('8537','2013-07-14','13:45:00',4.95),('8537','2013-07-14','13:50:00',4.96),('8537','2013-07-14','13:55:00',4.91),('8537','2013-07-14','14:00:00',4.92),('8537','2013-07-14','14:05:00',4.94),('8537','2013-07-14','14:10:00',4.92),('8537','2013-07-14','14:15:00',4.9),('8537','2013-07-14','14:20:00',4.86),('8537','2013-07-14','14:25:00',4.82),('8537','2013-07-14','14:30:00',4.76),('8537','2013-07-14','14:35:00',4.7),('8537','2013-07-14','14:40:00',4.62),('8537','2013-07-14','14:45:00',4.52),('8537','2013-07-14','14:50:00',4.4),('8537','2013-07-14','14:55:00',4.16),('8537','2013-07-14','15:00:00',4.21),('8537','2013-07-14','15:05:00',4.4),('8537','2013-07-14','15:10:00',4.32),('8537','2013-07-14','15:15:00',4.29),('8537','2013-07-14','15:20:00',4.22),('8537','2013-07-14','15:25:00',4.14),('8537','2013-07-14','15:30:00',4.11),('8537','2013-07-14','15:35:00',4.07),('8537','2013-07-14','15:40:00',4.01),('8537','2013-07-14','15:45:00',3.89),('8537','2013-07-14','15:50:00',3.83),('8537','2013-07-14','15:55:00',3.82),('8537','2013-07-14','16:00:00',3.55),('8537','2013-07-14','16:05:00',3.69),('8537','2013-07-14','16:10:00',3.64),('8537','2013-07-14','16:15:00',3.59),('8537','2013-07-14','16:20:00',3.62),('8537','2013-07-14','16:25:00',3),('8537','2013-07-14','16:30:00',1.96),('8537','2013-07-14','16:35:00',2.58),('8537','2013-07-14','16:40:00',2.42),('8537','2013-07-14','16:45:00',3.22),('8537','2013-07-14','16:50:00',3.05),('8537','2013-07-14','16:55:00',2.79),('8537','2013-07-14','17:00:00',2.11),('8537','2013-07-14','17:05:00',2.41),('8537','2013-07-14','17:10:00',2.18),('8537','2013-07-14','17:15:00',2.22),('8537','2013-07-14','17:20:00',1.34),('8537','2013-07-14','17:25:00',2),('8537','2013-07-14','17:30:00',2.25),('8537','2013-07-14','17:35:00',2.36),('8537','2013-07-14','17:40:00',1.21),('8537','2013-07-14','17:45:00',1.04),('8537','2013-07-14','17:50:00',1.32),('8537','2013-07-14','17:55:00',1.35),('8537','2013-07-14','18:00:00',1.18),('8537','2013-07-14','18:10:00',1.02),('8537','2013-07-13','07:35:00',1.02),('8537','2013-07-13','07:40:00',1.06),('8537','2013-07-13','07:45:00',1.12),('8537','2013-07-13','07:50:00',1.2),('8537','2013-07-13','07:55:00',1.29),('8537','2013-07-13','08:00:00',1.35),('8537','2013-07-13','08:05:00',1.48),('8537','2013-07-13','08:10:00',1.58),('8537','2013-07-13','08:15:00',1.69),('8537','2013-07-13','08:20:00',1.78),('8537','2013-07-13','08:25:00',1.87),('8537','2013-07-13','08:30:00',1.98),('8537','2013-07-13','08:35:00',2.05),('8537','2013-07-13','08:40:00',2.11),('8537','2013-07-13','08:45:00',2.2),('8537','2013-07-13','08:50:00',2.37),('8537','2013-07-13','08:55:00',2.42),('8537','2013-07-13','09:00:00',2.55),('8537','2013-07-13','09:05:00',2.64),('8537','2013-07-13','09:10:00',2.74),('8537','2013-07-13','09:15:00',2.81),('8537','2013-07-13','09:20:00',2.86),('8537','2013-07-13','09:25:00',2.95),('8537','2013-07-13','09:30:00',2.98),('8537','2013-07-13','09:35:00',3.1),('8537','2013-07-13','09:40:00',3.16),('8537','2013-07-13','09:45:00',3.29),('8537','2013-07-13','09:50:00',3.37),('8537','2013-07-13','09:55:00',3.41),('8537','2013-07-13','10:00:00',3.48),('8537','2013-07-13','10:05:00',3.53),('8537','2013-07-13','10:10:00',3.62),('8537','2013-07-13','10:15:00',3.71),('8537','2013-07-13','10:20:00',3.79),('8537','2013-07-13','10:25:00',3.87),('8537','2013-07-13','10:30:00',3.89),('8537','2013-07-13','10:35:00',3.88),('8537','2013-07-13','10:40:00',2.72),('8537','2013-07-13','10:45:00',3.09),('8537','2013-07-13','10:50:00',4.37),('8537','2013-07-13','10:55:00',4.32),('8537','2013-07-13','11:00:00',4.35),('8537','2013-07-13','11:05:00',4.56),('8537','2013-07-13','11:10:00',4.22),('8537','2013-07-13','11:15:00',4.56),('8537','2013-07-13','11:20:00',3.39),('8537','2013-07-13','11:25:00',3.9),('8537','2013-07-13','11:30:00',4.56),('8537','2013-07-13','11:35:00',4.48),('8537','2013-07-13','11:40:00',4.27),('8537','2013-07-13','11:45:00',1.46),('8537','2013-07-13','11:50:00',4.18),('8537','2013-07-13','11:55:00',5.05),('8537','2013-07-13','12:00:00',2.96),('8537','2013-07-13','12:05:00',1.48),('8537','2013-07-13','12:10:00',5.02),('8537','2013-07-13','12:15:00',3.05),('8537','2013-07-13','12:20:00',2.6),('8537','2013-07-13','12:25:00',4.47),('8537','2013-07-13','12:30:00',3.99),('8537','2013-07-13','12:35:00',5.11),('8537','2013-07-13','12:40:00',5.07),('8537','2013-07-13','12:45:00',4.95),('8537','2013-07-13','12:50:00',4.53),('8537','2013-07-13','12:55:00',3.93),('8537','2013-07-13','13:00:00',4.62),('8537','2013-07-13','13:05:00',5.05),('8537','2013-07-13','13:10:00',4.38),('8537','2013-07-13','13:15:00',4.63),('8537','2013-07-13','13:20:00',5.01),('8537','2013-07-13','13:25:00',4.96),('8537','2013-07-13','13:30:00',4.92),('8537','2013-07-13','13:35:00',4.93),('8537','2013-07-13','13:40:00',4.96),('8537','2013-07-13','13:45:00',4.91),('8537','2013-07-13','13:50:00',4.95),('8537','2013-07-13','13:55:00',4.88),('8537','2013-07-13','14:00:00',4.86),('8537','2013-07-13','14:05:00',4.84),('8537','2013-07-13','14:10:00',4.8),('8537','2013-07-13','14:15:00',4.8),('8537','2013-07-13','14:20:00',4.8),('8537','2013-07-13','14:25:00',4.75),('8537','2013-07-13','14:30:00',4.72),('8537','2013-07-13','14:35:00',4.7),('8537','2013-07-13','14:40:00',4.67),('8537','2013-07-13','14:45:00',4.63),('8537','2013-07-13','14:50:00',4.51),('8537','2013-07-13','14:55:00',4.51),('8537','2013-07-13','15:00:00',4.46),('8537','2013-07-13','15:05:00',4.49),('8537','2013-07-13','15:10:00',4.45),('8537','2013-07-13','15:15:00',4.42),('8537','2013-07-13','15:20:00',4.2),('8537','2013-07-13','15:25:00',4.35),('8537','2013-07-13','15:30:00',4.22),('8537','2013-07-13','15:35:00',4.27),('8537','2013-07-13','15:40:00',4.2),('8537','2013-07-13','15:45:00',4.04),('8537','2013-07-13','15:50:00',3.98),('8537','2013-07-13','15:55:00',3.93),('8537','2013-07-13','16:00:00',3.86),('8537','2013-07-13','16:05:00',3.8),('8537','2013-07-13','16:10:00',3.74),('8537','2013-07-13','16:15:00',3.65),('8537','2013-07-13','16:20:00',3.58),('8537','2013-07-13','16:25:00',3.55),('8537','2013-07-13','16:30:00',3.34),('8537','2013-07-13','16:35:00',3.07),('8537','2013-07-13','16:40:00',3.26),('8537','2013-07-13','16:45:00',3.16),('8537','2013-07-13','16:50:00',3.07),('8537','2013-07-13','16:55:00',3),('8537','2013-07-13','17:00:00',2.91),('8537','2013-07-13','17:05:00',2.77),('8537','2013-07-13','17:10:00',2.59),('8537','2013-07-13','17:15:00',2.22),('8537','2013-07-13','17:20:00',2.47),('8537','2013-07-13','17:25:00',2.47),('8537','2013-07-13','17:30:00',2.28),('8537','2013-07-13','17:35:00',2.15),('8537','2013-07-13','17:40:00',2.1),('8537','2013-07-13','17:45:00',2.02),('8537','2013-07-13','17:50:00',1.89),('8537','2013-07-13','17:55:00',1.79),('8537','2013-07-13','18:00:00',1.7),('8537','2013-07-13','18:05:00',1.53),('8537','2013-07-13','18:10:00',1.51),('8537','2013-07-13','18:15:00',1.43),('8537','2013-07-13','18:20:00',1.34),('8537','2013-07-13','18:25:00',1.23),('8537','2013-07-13','18:30:00',1.11),('8537','2013-07-13','18:35:00',1.02),('8537','2013-07-12','08:10:00',1.32),('8537','2013-07-12','08:15:00',1.88),('8537','2013-07-12','08:20:00',2.06),('8537','2013-07-12','08:25:00',1.03),('8537','2013-07-12','08:35:00',1.07),('8537','2013-07-12','08:40:00',1.32),('8537','2013-07-12','08:45:00',1.56),('8537','2013-07-12','08:50:00',1.15),('8537','2013-07-12','09:05:00',1.03),('8537','2013-07-12','09:10:00',1.45),('8537','2013-07-12','09:15:00',1.81),('8537','2013-07-12','09:20:00',2.52),('8537','2013-07-12','09:25:00',2.86),('8537','2013-07-12','09:30:00',1.94),('8537','2013-07-12','09:35:00',2.35),('8537','2013-07-12','09:40:00',2.21),('8537','2013-07-12','09:45:00',3.14),('8537','2013-07-12','09:50:00',3.4),('8537','2013-07-12','09:55:00',3.46),('8537','2013-07-12','10:00:00',3.52),('8537','2013-07-12','10:05:00',3.4),('8537','2013-07-12','10:10:00',2.9),('8537','2013-07-12','10:15:00',2.75),('8537','2013-07-12','10:20:00',1.34),('8537','2013-07-12','10:25:00',1.92),('8537','2013-07-12','10:30:00',2.11),('8537','2013-07-12','10:35:00',2.05),('8537','2013-07-12','10:45:00',1.08),('8537','2013-07-12','10:50:00',1.91),('8537','2013-07-12','10:55:00',3.65),('8537','2013-07-12','11:00:00',4.57),('8537','2013-07-12','11:05:00',1.6),('8537','2013-07-12','11:10:00',1.63),('8537','2013-07-12','11:15:00',3.78),('8537','2013-07-12','11:20:00',2.12),('8537','2013-07-12','11:25:00',4.18),('8537','2013-07-12','11:30:00',4.7),('8537','2013-07-12','11:35:00',4.9),('8537','2013-07-12','11:40:00',2.89),('8537','2013-07-12','11:45:00',2.55),('8537','2013-07-12','11:50:00',1.88),('8537','2013-07-12','11:55:00',5.14),('8537','2013-07-12','12:00:00',5.04),('8537','2013-07-12','12:05:00',4.4),('8537','2013-07-12','12:10:00',4.26),('8537','2013-07-12','12:15:00',3.78),('8537','2013-07-12','12:20:00',5.14),('8537','2013-07-12','12:25:00',5.17),('8537','2013-07-12','12:30:00',4.34),('8537','2013-07-12','12:35:00',5.3),('8537','2013-07-12','12:40:00',2.14),('8537','2013-07-12','12:45:00',5.22),('8537','2013-07-12','12:50:00',2.7),('8537','2013-07-12','12:55:00',4.71),('8537','2013-07-12','13:00:00',5.13),('8537','2013-07-12','13:05:00',5.11),('8537','2013-07-12','13:10:00',5.05),('8537','2013-07-12','13:15:00',5),('8537','2013-07-12','13:20:00',4.98),('8537','2013-07-12','13:25:00',4.91),('8537','2013-07-12','13:30:00',5.03),('8537','2013-07-12','13:35:00',5.01),('8537','2013-07-12','13:40:00',5),('8537','2013-07-12','13:45:00',4.56),('8537','2013-07-12','13:50:00',3.25),('8537','2013-07-12','13:55:00',5.03),('8537','2013-07-12','14:00:00',5.08),('8537','2013-07-12','14:05:00',4.81),('8537','2013-07-12','14:10:00',2.88),('8537','2013-07-12','14:15:00',4.74),('8537','2013-07-12','14:20:00',5.23),('8537','2013-07-12','14:25:00',4.99),('8537','2013-07-12','14:30:00',4.78),('8537','2013-07-12','14:35:00',4.75),('8537','2013-07-12','14:40:00',4.63),('8537','2013-07-12','14:45:00',4.52),('8537','2013-07-12','14:50:00',4.37),('8537','2013-07-12','14:55:00',4.06),('8537','2013-07-12','15:00:00',3.94),('8537','2013-07-12','15:05:00',4.35),('8537','2013-07-12','15:10:00',4.33),('8537','2013-07-12','15:15:00',4.29),('8537','2013-07-12','15:20:00',4.24),('8537','2013-07-12','15:25:00',4.21),('8537','2013-07-12','15:30:00',4.19),('8537','2013-07-12','15:35:00',4.08),('8537','2013-07-12','15:40:00',4.12),('8537','2013-07-12','15:45:00',3.93),('8537','2013-07-12','15:50:00',3.82),('8537','2013-07-12','15:55:00',3.77),('8537','2013-07-12','16:00:00',3.72),('8537','2013-07-12','16:05:00',3.62),('8537','2013-07-12','16:10:00',3.6),('8537','2013-07-12','16:15:00',3.53),('8537','2013-07-12','16:20:00',3.42),('8537','2013-07-12','16:25:00',3.39),('8537','2013-07-12','16:30:00',3.17),('8537','2013-07-12','16:35:00',3.2),('8537','2013-07-12','16:40:00',3.14),('8537','2013-07-12','16:45:00',3.09),('8537','2013-07-12','16:50:00',2.99),('8537','2013-07-12','16:55:00',2.9),('8537','2013-07-12','17:00:00',2.8),('8537','2013-07-12','17:05:00',2.72),('8537','2013-07-12','17:10:00',2.48),('8537','2013-07-12','17:15:00',2.13),('8537','2013-07-12','17:20:00',2.41),('8537','2013-07-12','17:25:00',2.3),('8537','2013-07-12','17:30:00',2.2),('8537','2013-07-12','17:35:00',2.07),('8537','2013-07-12','17:40:00',2.02),('8537','2013-07-12','17:45:00',1.9),('8537','2013-07-12','17:50:00',1.82),('8537','2013-07-12','17:55:00',1.65),('8537','2013-07-12','18:00:00',1.62),('8537','2013-07-12','18:05:00',1.5),('8537','2013-07-12','18:10:00',1.43),('8537','2013-07-12','18:15:00',1.34),('8537','2013-07-12','18:20:00',1.24),('8537','2013-07-12','18:25:00',1.16),('8537','2013-07-12','18:30:00',1.07),('8537','2013-07-11','07:40:00',1.05),('8537','2013-07-11','07:45:00',1.13),('8537','2013-07-11','07:50:00',1.22),('8537','2013-07-11','07:55:00',1.31),('8537','2013-07-11','08:00:00',1.42),('8537','2013-07-11','08:05:00',1.51),('8537','2013-07-11','08:10:00',1.59),('8537','2013-07-11','08:15:00',1.68),('8537','2013-07-11','08:20:00',1.8),('8537','2013-07-11','08:25:00',1.9),('8537','2013-07-11','08:30:00',1.99),('8537','2013-07-11','08:35:00',2.08),('8537','2013-07-11','08:40:00',2.14),('8537','2013-07-11','08:45:00',2.26),('8537','2013-07-11','08:50:00',2.41),('8537','2013-07-11','08:55:00',2.49),('8537','2013-07-11','09:00:00',2.51),('8537','2013-07-11','09:05:00',2.62),('8537','2013-07-11','09:10:00',2.77),('8537','2013-07-11','09:15:00',2.93),('8537','2013-07-11','09:20:00',3.02),('8537','2013-07-11','09:25:00',3.28),('8537','2013-07-11','09:30:00',2.87),('8537','2013-07-11','09:35:00',3.01),('8537','2013-07-11','09:40:00',2.74),('8537','2013-07-11','09:45:00',3.14),('8537','2013-07-11','09:50:00',3.79),('8537','2013-07-11','09:55:00',3.17),('8537','2013-07-11','10:00:00',2.93),('8537','2013-07-11','10:05:00',1.64),('8537','2013-07-11','10:10:00',2.95),('8537','2013-07-11','10:15:00',3.85),('8537','2013-07-11','10:20:00',3.98),('8537','2013-07-11','10:25:00',3.18),('8537','2013-07-11','10:30:00',3.7),('8537','2013-07-11','10:35:00',1.82),('8537','2013-07-11','10:40:00',1.84),('8537','2013-07-11','10:45:00',2.19),('8537','2013-07-11','10:50:00',4.36),('8537','2013-07-11','10:55:00',4.54),('8537','2013-07-11','11:00:00',3.38),('8537','2013-07-11','11:05:00',3.19),('8537','2013-07-11','11:10:00',4.77),('8537','2013-07-11','11:15:00',4.56),('8537','2013-07-11','11:20:00',4.71),('8537','2013-07-11','11:25:00',3.91),('8537','2013-07-11','11:30:00',4.85),('8537','2013-07-11','11:35:00',4.62),('8537','2013-07-11','11:40:00',3.12),('8537','2013-07-11','11:45:00',3.95),('8537','2013-07-11','11:50:00',3.29),('8537','2013-07-11','11:55:00',3.54),('8537','2013-07-11','12:00:00',3.35),('8537','2013-07-11','12:05:00',1.4),('8537','2013-07-11','12:10:00',1.41),('8537','2013-07-11','12:15:00',2.31),('8537','2013-07-11','12:20:00',5.29),('8537','2013-07-11','12:25:00',5.04),('8537','2013-07-11','12:30:00',4.96),('8537','2013-07-11','12:35:00',5.27),('8537','2013-07-11','12:40:00',5.21),('8537','2013-07-11','12:45:00',5.08),('8537','2013-07-11','12:50:00',5.09),('8537','2013-07-11','12:55:00',4.48),('8537','2013-07-11','13:00:00',5.18),('8537','2013-07-11','13:05:00',2.81),('8537','2013-07-11','13:10:00',5.26),('8537','2013-07-11','13:15:00',5.16),('8537','2013-07-11','13:20:00',5.08),('8537','2013-07-11','13:25:00',4.86),('8537','2013-07-11','13:30:00',4.21),('8537','2013-07-11','13:35:00',5.22),('8537','2013-07-11','13:40:00',4.8),('8537','2013-07-11','13:45:00',4.45),('8537','2013-07-11','13:50:00',2.38),('8537','2013-07-11','13:55:00',3.22),('8537','2013-07-11','14:00:00',4.02),('8537','2013-07-11','14:05:00',5.14),('8537','2013-07-11','14:10:00',4.76),('8537','2013-07-11','14:15:00',5),('8537','2013-07-11','14:20:00',4.35),('8537','2013-07-11','14:25:00',3.64),('8537','2013-07-11','14:30:00',3.72),('8537','2013-07-11','14:35:00',4.85),('8537','2013-07-11','14:40:00',4.78),('8537','2013-07-11','14:45:00',4.79),('8537','2013-07-11','14:50:00',4.62),('8537','2013-07-11','14:55:00',3.36),('8537','2013-07-11','15:00:00',4.18),('8537','2013-07-11','15:05:00',2.79),('8537','2013-07-11','15:10:00',2.61),('8537','2013-07-11','15:15:00',3.5),('8537','2013-07-11','15:20:00',3.4),('8537','2013-07-11','15:25:00',2.13),('8537','2013-07-11','15:30:00',3.92),('8537','2013-07-11','15:35:00',4.38),('8537','2013-07-11','15:40:00',3.21),('8537','2013-07-11','15:45:00',2.87),('8537','2013-07-11','15:50:00',2.69),('8537','2013-07-11','15:55:00',1.89),('8537','2013-07-11','16:00:00',3.5),('8537','2013-07-11','16:05:00',2.66),('8537','2013-07-11','16:10:00',4.32),('8537','2013-07-11','16:15:00',2.17),('8537','2013-07-11','16:20:00',2.52),('8537','2013-07-11','16:25:00',2.23),('8537','2013-07-11','16:30:00',2.6),('8537','2013-07-11','16:35:00',1.98),('8537','2013-07-11','16:40:00',2.65),('8537','2013-07-11','16:45:00',2.54),('8537','2013-07-11','16:50:00',3.18),('8537','2013-07-11','16:55:00',3.09),('8537','2013-07-11','17:00:00',2.34),('8537','2013-07-11','17:05:00',2.59),('8537','2013-07-11','17:10:00',2.53),('8537','2013-07-11','17:15:00',1.61),('8537','2013-07-11','17:20:00',2.06),('8537','2013-07-11','17:25:00',1.65),('8537','2013-07-11','17:30:00',2.02),('8537','2013-07-11','17:35:00',2.44),('8537','2013-07-11','17:40:00',1.71),('8537','2013-07-11','17:45:00',1.65),('8537','2013-07-11','17:50:00',1.43),('8537','2013-07-11','17:55:00',1.51),('8537','2013-07-11','18:00:00',1.48),('8537','2013-07-11','18:05:00',1.46),('8537','2013-07-11','18:10:00',1.47),('8537','2013-07-11','18:15:00',1.34),('8537','2013-07-11','18:20:00',1.09),('8537','2013-07-11','18:25:00',1.22),('8537','2013-07-11','18:30:00',1.21),('8537','2013-07-11','18:35:00',1.08),('8537','2014-05-03','07:35:00',1.07),('8537','2014-05-03','07:40:00',1.19),('8537','2014-05-03','07:45:00',1.31),('8537','2014-05-03','07:50:00',1.43),('8537','2014-05-03','07:55:00',1.54),('8537','2014-05-03','08:00:00',1.61),('8537','2014-05-03','08:05:00',1.92),('8537','2014-05-03','08:10:00',2.28),('8537','2014-05-03','08:15:00',1.74),('8537','2014-05-03','08:20:00',1.41),('8537','2014-05-03','08:25:00',1.23),('8537','2014-05-03','08:30:00',1.37),('8537','2014-05-03','08:35:00',1.11),('8537','2014-05-03','08:40:00',1.39),('8537','2014-05-03','08:45:00',2.52),('8537','2014-05-03','08:50:00',3),('8537','2014-05-03','08:55:00',3.17),('8537','2014-05-03','09:00:00',3.78),('8537','2014-05-03','09:05:00',3.56),('8537','2014-05-03','09:10:00',1.99),('8537','2014-05-03','09:15:00',2.12),('8537','2014-05-03','09:20:00',2.93),('8537','2014-05-03','09:25:00',3.92),('8537','2014-05-03','09:30:00',3.21),('8537','2014-05-03','09:35:00',2.93),('8537','2014-05-03','09:40:00',2.08),('8537','2014-05-03','09:45:00',3.66),('8537','2014-05-03','09:50:00',1.62),('8537','2014-05-03','09:55:00',3.88),('8537','2014-05-03','10:00:00',4.25),('8537','2014-05-03','10:05:00',4.19),('8537','2014-05-03','10:10:00',4.43),('8537','2014-05-03','10:15:00',4.03),('8537','2014-05-03','10:20:00',3.44),('8537','2014-05-03','10:25:00',5.4),('8537','2014-05-03','10:30:00',2.74),('8537','2014-05-03','10:35:00',1.14),('8537','2014-05-03','10:40:00',1.22),('8537','2014-05-03','10:45:00',2.17),('8537','2014-05-03','10:50:00',1.36),('8537','2014-05-03','10:55:00',2.06),('8537','2014-05-03','11:00:00',1.48),('8537','2014-05-03','11:05:00',4.43),('8537','2014-05-03','11:10:00',5.21),('8537','2014-05-03','11:15:00',4.42),('8537','2014-05-03','11:20:00',4.07),('8537','2014-05-03','11:25:00',4.72),('8537','2014-05-03','11:30:00',5.13),('8537','2014-05-03','11:35:00',3.24),('8537','2014-05-03','11:40:00',3.47),('8537','2014-05-03','11:45:00',2.86),('8537','2014-05-03','11:50:00',2.74),('8537','2014-05-03','11:55:00',2.74),('8537','2014-05-03','12:00:00',2.33),('8537','2014-05-03','12:05:00',1.91),('8537','2014-05-03','12:10:00',1.75),('8537','2014-05-03','12:15:00',1.58),('8537','2014-05-03','12:20:00',1.43),('8537','2014-05-03','12:25:00',1.53),('8537','2014-05-03','12:30:00',2.07),('8537','2014-05-03','12:35:00',2.48),('8537','2014-05-03','12:40:00',2.24),('8537','2014-05-03','12:45:00',2.29),('8537','2014-05-03','12:50:00',2.21),('8537','2014-05-03','12:55:00',2.23),('8537','2014-05-03','13:00:00',2.3),('8537','2014-05-03','13:05:00',2.35),('8537','2014-05-03','13:10:00',3.87),('8537','2014-05-03','13:15:00',3.24),('8537','2014-05-03','13:20:00',2.92),('8537','2014-05-03','13:25:00',3.5),('8537','2014-05-03','13:30:00',3.58),('8537','2014-05-03','13:35:00',2.64),('8537','2014-05-03','13:40:00',2.14),('8537','2014-05-03','13:45:00',2.1),('8537','2014-05-03','13:50:00',2.11),('8537','2014-05-03','13:55:00',2.13),('8537','2014-05-03','14:00:00',2.09),('8537','2014-05-03','14:05:00',2.11),('8537','2014-05-03','14:10:00',2.31),('8537','2014-05-03','14:15:00',2.65),('8537','2014-05-03','14:20:00',3.13),('8537','2014-05-03','14:25:00',4.35),('8537','2014-05-03','14:30:00',2.46),('8537','2014-05-03','14:35:00',1.93),('8537','2014-05-03','14:40:00',1.56),('8537','2014-05-03','14:55:00',1.3),('8537','2014-05-03','15:00:00',1.41),('8537','2014-05-03','15:05:00',1.36),('8537','2014-05-03','15:10:00',1.06),('8537','2014-05-03','16:40:00',1.01),('8537','2014-05-03','16:45:00',1.09),('8537','2014-05-03','16:50:00',1.14),('8537','2014-05-03','16:55:00',1.15),('8537','2014-05-03','17:00:00',1.15),('8537','2014-05-03','17:05:00',1.14),('8537','2014-05-03','17:10:00',1.13),('8537','2014-05-03','17:15:00',1.11),('8537','2014-05-03','17:20:00',1.1),('8537','2014-05-03','17:25:00',1.1),('8537','2014-05-03','17:30:00',1.07),('8537','2014-05-03','17:35:00',1.01),('8537','2014-05-03','17:40:00',1.02),('8537','2014-05-03','17:45:00',1.08),('8537','2014-05-03','17:50:00',1.23),('8537','2014-05-03','17:55:00',1.2),('8537','2014-05-03','18:00:00',1.05),('8537','2014-04-06','08:15:00',1.4),('8537','2014-04-06','08:20:00',1.5),('8537','2014-04-06','08:25:00',1.65),('8537','2014-04-06','08:30:00',1.73),('8537','2014-04-06','08:35:00',1.88),('8537','2014-04-06','08:40:00',2.02),('8537','2014-04-06','08:45:00',2.09),('8537','2014-04-06','08:50:00',1.56),('8537','2014-04-06','08:55:00',1.24),('8537','2014-04-06','09:00:00',1.64),('8537','2014-04-06','09:05:00',2.24),('8537','2014-04-06','09:10:00',2.67),('8537','2014-04-06','09:15:00',2.92),('8537','2014-04-06','09:20:00',2.35),('8537','2014-04-06','09:25:00',2.4),('8537','2014-04-06','09:30:00',2.08),('8537','2014-04-06','09:35:00',2.92),('8537','2014-04-06','09:40:00',3.02),('8537','2014-04-06','09:45:00',4.09),('8537','2014-04-06','09:50:00',4.31),('8537','2014-04-06','09:55:00',4.34),('8537','2014-04-06','10:00:00',3.54),('8537','2014-04-06','10:05:00',3.71),('8537','2014-04-06','10:10:00',3.4),('8537','2014-04-06','10:15:00',3.6),('8537','2014-04-06','10:20:00',2.23),('8537','2014-04-06','10:25:00',1.48),('8537','2014-04-06','10:30:00',1.62),('8537','2014-04-06','10:35:00',1.79),('8537','2014-04-06','10:40:00',1.89),('8537','2014-04-06','10:45:00',3.51),('8537','2014-04-06','10:50:00',3.86),('8537','2014-04-06','10:55:00',1.81),('8537','2014-04-06','11:00:00',2.59),('8537','2014-04-06','11:05:00',2.41),('8537','2014-04-06','11:10:00',4.64),('8537','2014-04-06','11:15:00',3.85),('8537','2014-04-06','11:20:00',4.97),('8537','2014-04-06','11:25:00',4.92),('8537','2014-04-06','11:30:00',5.13),('8537','2014-04-06','11:35:00',5.47),('8537','2014-04-06','11:40:00',5.38),('8537','2014-04-06','11:45:00',5.27),('8537','2014-04-06','11:50:00',5.35),('8537','2014-04-06','11:55:00',4.56),('8537','2014-04-06','12:00:00',5.27),('8537','2014-04-06','12:05:00',5.21),('8537','2014-04-06','12:10:00',5.13),('8537','2014-04-06','12:15:00',5.27),('8537','2014-04-06','12:20:00',3.54),('8537','2014-04-06','12:25:00',4.21),('8537','2014-04-06','12:30:00',3.93),('8537','2014-04-06','12:35:00',3.71),('8537','2014-04-06','12:40:00',3.56),('8537','2014-04-06','12:45:00',3.2),('8537','2014-04-06','12:50:00',1.99),('8537','2014-04-06','12:55:00',4.9),('8537','2014-04-06','13:00:00',5.26),('8537','2014-04-06','13:05:00',3.98),('8537','2014-04-06','13:10:00',5.12),('8537','2014-04-06','13:15:00',5.06),('8537','2014-04-06','13:20:00',3.3),('8537','2014-04-06','13:25:00',1.32),('8537','2014-04-06','13:30:00',4.92),('8537','2014-04-06','13:35:00',3.51),('8537','2014-04-06','13:40:00',3.69),('8537','2014-04-06','13:45:00',5.53),('8537','2014-04-06','13:50:00',5.36),('8537','2014-04-06','13:55:00',5.24),('8537','2014-04-06','14:00:00',5.13),('8537','2014-04-06','14:05:00',4.85),('8537','2014-04-06','14:10:00',5.2),('8537','2014-04-06','14:15:00',4.6),('8537','2014-04-06','14:20:00',3.6),('8537','2014-04-06','14:25:00',1.91),('8537','2014-04-06','14:30:00',1.31),('8537','2014-04-06','14:35:00',1.73),('8537','2014-04-06','14:40:00',3.96),('8537','2014-04-06','14:45:00',5.68),('8537','2014-04-06','14:50:00',3.91),('8537','2014-04-06','14:55:00',2.7),('8537','2014-04-06','15:00:00',2.33),('8537','2014-04-06','15:05:00',1.54),('8537','2014-04-06','15:10:00',3.86),('8537','2014-04-06','15:15:00',4.21),('8537','2014-04-06','15:20:00',2.05),('8537','2014-04-06','15:25:00',1.28),('8537','2014-04-06','15:45:00',1.14),('8537','2014-04-06','15:50:00',1.66),('8537','2014-04-06','15:55:00',3.45),('8537','2014-04-06','16:00:00',3.43),('8537','2014-04-06','16:05:00',1.54),('8537','2014-04-06','16:10:00',1.54),('8537','2014-04-06','16:25:00',1.43),('8537','2014-04-06','16:30:00',1.25),('8537','2014-04-06','16:35:00',1.85),('8537','2014-04-06','16:40:00',2.02),('8537','2014-04-06','16:45:00',2.76),('8537','2014-04-06','16:50:00',3.33),('8537','2014-04-06','16:55:00',1.81),('8537','2014-04-06','17:00:00',1),('8537','2014-04-06','17:25:00',1.45),('8537','2014-04-06','17:30:00',1.47),('8537','2014-04-06','17:35:00',1.44),('8537','2014-04-06','17:45:00',1.02),('8537','2014-04-06','17:50:00',1.46),('8537','2014-04-06','17:55:00',1.33),('8537','2014-04-06','18:00:00',1.21),('8537','2014-04-06','18:05:00',1.09),('8537','2014-04-06','18:10:00',1),('8537','2013-07-10','07:25:00',1.16),('8537','2013-07-10','07:30:00',1.33),('8537','2013-07-10','07:35:00',1.5),('8537','2013-07-10','07:40:00',1.67),('8537','2013-07-10','07:45:00',1.8),('8537','2013-07-10','07:50:00',1.96),('8537','2013-07-10','07:55:00',2.13),('8537','2013-07-10','08:00:00',2.25),('8537','2013-07-10','08:05:00',1.62),('8537','2013-07-10','08:10:00',1.95),('8537','2013-07-10','08:15:00',2.1),('8537','2013-07-10','08:20:00',2.1),('8537','2013-07-10','08:25:00',2.72),('8537','2013-07-10','08:30:00',2.94),('8537','2013-07-10','08:35:00',2.96),('8537','2013-07-10','08:40:00',2.65),('8537','2013-07-10','08:45:00',2.71),('8537','2013-07-10','08:50:00',2.72),('8537','2013-07-10','08:55:00',2.65),('8537','2013-07-10','09:00:00',2.7),('8537','2013-07-10','09:05:00',2.84),('8537','2013-07-10','09:10:00',2.95),('8537','2013-07-10','09:15:00',3.08),('8537','2013-07-10','09:20:00',3.14),('8537','2013-07-10','09:25:00',3.21),('8537','2013-07-10','09:30:00',3.2),('8537','2013-07-10','09:35:00',3.28),('8537','2013-07-10','09:40:00',3.35),('8537','2013-07-10','09:45:00',3.42),('8537','2013-07-10','09:50:00',3.46),('8537','2013-07-10','09:55:00',3.33),('8537','2013-07-10','10:00:00',3.45),('8537','2013-07-10','10:05:00',3.67),('8537','2013-07-10','10:10:00',3.74),('8537','2013-07-10','10:15:00',3.79),('8537','2013-07-10','10:20:00',3.87),('8537','2013-07-10','10:25:00',3.9),('8537','2013-07-10','10:30:00',4),('8537','2013-07-10','10:35:00',4.06),('8537','2013-07-10','10:40:00',4.08),('8537','2013-07-10','10:45:00',4.09),('8537','2013-07-10','10:50:00',4.16),('8537','2013-07-10','10:55:00',4.22),('8537','2013-07-10','11:00:00',4.24),('8537','2013-07-10','11:05:00',4.27),('8537','2013-07-10','11:10:00',4.3),('8537','2013-07-10','11:15:00',4.32),('8537','2013-07-10','11:20:00',4.4),('8537','2013-07-10','11:25:00',4.43),('8537','2013-07-10','11:30:00',4.41),('8537','2013-07-10','11:35:00',4.41),('8537','2013-07-10','11:40:00',4.43),('8537','2013-07-10','11:45:00',4.49),('8537','2013-07-10','11:50:00',4.58),('8537','2013-07-10','11:55:00',4.63),('8537','2013-07-10','12:00:00',4.62),('8537','2013-07-10','12:05:00',4.65),('8537','2013-07-10','12:10:00',4.66),('8537','2013-07-10','12:15:00',4.69),('8537','2013-07-10','12:20:00',4.73),('8537','2013-07-10','12:25:00',4.84),('8537','2013-07-10','12:30:00',4.91),('8537','2013-07-10','12:35:00',4.95),('8537','2013-07-10','12:40:00',4.82),('8537','2013-07-10','12:45:00',4.85),('8537','2013-07-10','12:50:00',4.87),('8537','2013-07-10','12:55:00',4.87),('8537','2013-07-10','13:00:00',4.79),('8537','2013-07-10','13:05:00',4.93),('8537','2013-07-10','13:10:00',4.93),('8537','2013-07-10','13:15:00',4.89),('8537','2013-07-10','13:20:00',4.85),('8537','2013-07-10','13:25:00',4.84),('8537','2013-07-10','13:30:00',4.83),('8537','2013-07-10','13:35:00',4.86),('8537','2013-07-10','13:40:00',4.88),('8537','2013-07-10','13:45:00',4.89),('8537','2013-07-10','13:50:00',4.85),('8537','2013-07-10','13:55:00',4.84),('8537','2013-07-10','14:00:00',4.84),('8537','2013-07-10','14:05:00',4.84),('8537','2013-07-10','14:10:00',4.82),('8537','2013-07-10','14:15:00',4.78),('8537','2013-07-10','14:20:00',4.75),('8537','2013-07-10','14:25:00',4.73),('8537','2013-07-10','14:30:00',4.73),('8537','2013-07-10','14:35:00',4.72),('8537','2013-07-10','14:40:00',4.69),('8537','2013-07-10','14:45:00',4.59),('8537','2013-07-10','14:50:00',4.38),('8537','2013-07-10','14:55:00',4.05),('8537','2013-07-10','15:00:00',4.27),('8537','2013-07-10','15:05:00',4.44),('8537','2013-07-10','15:10:00',4.41),('8537','2013-07-10','15:15:00',4.36),('8537','2013-07-10','15:20:00',4.3),('8537','2013-07-10','15:25:00',4.27),('8537','2013-07-10','15:30:00',4.23),('8537','2013-07-10','15:35:00',4.21),('8537','2013-07-10','15:40:00',3.27),('8537','2013-07-10','15:45:00',3.99),('8537','2013-07-10','15:50:00',3.92),('8537','2013-07-10','15:55:00',3.87),('8537','2013-07-10','16:00:00',3.74),('8537','2013-07-10','16:05:00',3.75),('8537','2013-07-10','16:10:00',3.67),('8537','2013-07-10','16:15:00',3.6),('8537','2013-07-10','16:20:00',3.52),('8537','2013-07-10','16:25:00',3.46),('8537','2013-07-10','16:30:00',3.29),('8537','2013-07-10','16:35:00',3.23),('8537','2013-07-10','16:40:00',3.15),('8537','2013-07-10','16:45:00',3.08),('8537','2013-07-10','16:50:00',3),('8537','2013-07-10','16:55:00',2.98),('8537','2013-07-10','17:00:00',2.96),('8537','2013-07-10','17:05:00',2.91),('8537','2013-07-10','17:10:00',2.56),('8537','2013-07-10','17:15:00',1.65),('8537','2013-07-10','17:20:00',1.6),('8537','2013-07-10','17:35:00',2.2),('8537','2013-07-10','17:40:00',2.13),('8537','2013-07-10','17:45:00',1.66),('8537','2013-07-10','17:50:00',1.91),('8537','2013-07-10','17:55:00',1.68),('8537','2013-07-10','18:00:00',1.68),('8537','2013-07-10','18:05:00',1.03),('8537','2013-07-09','07:35:00',1.02),('8537','2013-07-09','07:40:00',1.12),('8537','2013-07-09','07:45:00',1.2),('8537','2013-07-09','07:50:00',1.3),('8537','2013-07-09','07:55:00',1.4),('8537','2013-07-09','08:00:00',1.48),('8537','2013-07-09','08:05:00',1.57),('8537','2013-07-09','08:10:00',1.67),('8537','2013-07-09','08:15:00',1.78),('8537','2013-07-09','08:20:00',1.86),('8537','2013-07-09','08:25:00',1.96),('8537','2013-07-09','08:30:00',2.06),('8537','2013-07-09','08:35:00',2.16),('8537','2013-07-09','08:40:00',2.23),('8537','2013-07-09','08:45:00',2.33),('8537','2013-07-09','08:50:00',2.43),('8537','2013-07-09','08:55:00',2.52),('8537','2013-07-09','09:00:00',2.61),('8537','2013-07-09','09:05:00',2.7),('8537','2013-07-09','09:10:00',2.78),('8537','2013-07-09','09:15:00',2.86),('8537','2013-07-09','09:20:00',2.94),('8537','2013-07-09','09:25:00',3.03),('8537','2013-07-09','09:30:00',3.11),('8537','2013-07-09','09:35:00',3.19),('8537','2013-07-09','09:40:00',3.27),('8537','2013-07-09','09:45:00',3.35),('8537','2013-07-09','09:50:00',3.43),('8537','2013-07-09','09:55:00',3.49),('8537','2013-07-09','10:00:00',3.55),('8537','2013-07-09','10:05:00',3.61),('8537','2013-07-09','10:10:00',3.68),('8537','2013-07-09','10:15:00',3.73),('8537','2013-07-09','10:20:00',3.8),('8537','2013-07-09','10:25:00',3.85),('8537','2013-07-09','10:30:00',3.88),('8537','2013-07-09','10:35:00',3.95),('8537','2013-07-09','10:40:00',4.02),('8537','2013-07-09','10:45:00',4.09),('8537','2013-07-09','10:50:00',4.16),('8537','2013-07-09','10:55:00',4.27),('8537','2013-07-09','11:00:00',4.29),('8537','2013-07-09','11:05:00',4.25),('8537','2013-07-09','11:10:00',4.09),('8537','2013-07-09','11:15:00',3.85),('8537','2013-07-09','11:20:00',4.01),('8537','2013-07-09','11:25:00',3.88),('8537','2013-07-09','11:30:00',2.19),('8537','2013-07-09','11:35:00',2.64),('8537','2013-07-09','11:40:00',2.37),('8537','2013-07-09','11:45:00',4.57),('8537','2013-07-09','11:50:00',5.2),('8537','2013-07-09','11:55:00',5.08),('8537','2013-07-09','12:00:00',5.05),('8537','2013-07-09','12:05:00',5.02),('8537','2013-07-09','12:10:00',4.82),('8537','2013-07-09','12:15:00',4.77),('8537','2013-07-09','12:20:00',4.67),('8537','2013-07-09','12:25:00',4.6),('8537','2013-07-09','12:30:00',4.58),('8537','2013-07-09','12:35:00',4.61),('8537','2013-07-09','12:40:00',4.72),('8537','2013-07-09','12:45:00',4.71),('8537','2013-07-09','12:50:00',4.8),('8537','2013-07-09','12:55:00',4.82),('8537','2013-07-09','13:00:00',4.81),('8537','2013-07-09','13:05:00',4.83),('8537','2013-07-09','13:10:00',4.56),('8537','2013-07-09','13:15:00',4.86),('8537','2013-07-09','13:20:00',4.95),('8537','2013-07-09','13:25:00',4.83),('8537','2013-07-09','13:30:00',5.03),('8537','2013-07-09','13:35:00',4.73),('8537','2013-07-09','13:40:00',4.67),('8537','2013-07-09','13:45:00',4.02),('8537','2013-07-09','13:50:00',3.63),('8537','2013-07-09','13:55:00',3.59),('8537','2013-07-09','14:00:00',3.68),('8537','2013-07-09','14:05:00',3.55),('8537','2013-07-09','14:10:00',4),('8537','2013-07-09','14:15:00',4.05),('8537','2013-07-09','14:20:00',3.04),('8537','2013-07-09','14:25:00',2.54),('8537','2013-07-09','14:30:00',1.65),('8537','2013-07-09','14:35:00',1.23),('8537','2013-07-09','14:40:00',1.14),('8537','2013-07-08','07:40:00',1.44),('8537','2013-07-08','07:45:00',1.34),('8537','2013-07-08','07:50:00',1.12),('8537','2013-07-08','07:55:00',1.13),('8537','2013-07-08','08:00:00',1.33),('8537','2013-07-08','08:05:00',1.32),('8537','2013-07-08','08:10:00',1.53),('8537','2013-07-08','08:15:00',1.73),('8537','2013-07-08','08:20:00',1.86),('8537','2013-07-08','08:25:00',1.97),('8537','2013-07-08','08:30:00',2.08),('8537','2013-07-08','08:35:00',2.17),('8537','2013-07-08','08:40:00',2.26),('8537','2013-07-08','08:45:00',2.34),('8537','2013-07-08','08:50:00',2.44),('8537','2013-07-08','08:55:00',2.52),('8537','2013-07-08','09:00:00',2.6),('8537','2013-07-08','09:05:00',2.68),('8537','2013-07-08','09:10:00',2.74),('8537','2013-07-08','09:15:00',2.8),('8537','2013-07-08','09:20:00',2.87),('8537','2013-07-08','09:25:00',2.89),('8537','2013-07-08','09:30:00',3.04),('8537','2013-07-08','09:35:00',3.24),('8537','2013-07-08','09:40:00',3.31),('8537','2013-07-08','09:45:00',3.33),('8537','2013-07-08','09:50:00',3.39),('8537','2013-07-08','09:55:00',3.5),('8537','2013-07-08','10:00:00',3.6),('8537','2013-07-08','10:05:00',3.65),('8537','2013-07-08','10:10:00',3.66),('8537','2013-07-08','10:15:00',3.78),('8537','2013-07-08','10:20:00',3.85),('8537','2013-07-08','10:25:00',3.89),('8537','2013-07-08','10:30:00',3.99),('8537','2013-07-08','10:35:00',4.01),('8537','2013-07-08','10:40:00',4.03),('8537','2013-07-08','10:45:00',4.06),('8537','2013-07-08','10:50:00',4.1),('8537','2013-07-08','10:55:00',4.13),('8537','2013-07-08','11:00:00',4.17),('8537','2013-07-08','11:05:00',4.27),('8537','2013-07-08','11:10:00',4.35),('8537','2013-07-08','11:15:00',4.42),('8537','2013-07-08','11:20:00',4.53),('8537','2013-07-08','11:25:00',4.56),('8537','2013-07-08','11:30:00',4.61),('8537','2013-07-08','11:35:00',4.66),('8537','2013-07-08','11:40:00',4.4),('8537','2013-07-08','11:45:00',4.68),('8537','2013-07-08','11:50:00',4.71),('8537','2013-07-08','11:55:00',4.64),('8537','2013-07-08','12:00:00',4.68),('8537','2013-07-08','12:05:00',4.8),('8537','2013-07-08','12:10:00',4.9),('8537','2013-07-08','12:15:00',4.98),('8537','2013-07-08','12:20:00',5.12),('8537','2013-07-08','12:25:00',5.02),('8537','2013-07-08','12:30:00',4.65),('8537','2013-07-08','12:35:00',5.03),('8537','2013-07-08','12:40:00',4.93),('8537','2013-07-08','12:45:00',4.92),('8537','2013-07-08','12:50:00',4.93),('8537','2013-07-08','12:55:00',5),('8537','2013-07-08','13:00:00',5.11),('8537','2013-07-08','13:05:00',5.25),('8537','2013-07-08','13:10:00',5.44),('8537','2013-07-08','13:15:00',5.13),('8537','2013-07-08','13:20:00',3.44),('8537','2013-07-08','13:25:00',1.64),('8537','2013-07-08','14:30:00',1.08),('8537','2013-07-08','14:35:00',1.26),('8537','2013-07-08','14:40:00',1.29),('8537','2013-07-08','14:45:00',1.23),('8537','2013-07-08','14:50:00',1.19),('8537','2013-07-08','14:55:00',1.16),('8537','2013-07-08','15:00:00',1.07),('8537','2013-07-08','17:30:00',1.06),('8537','2013-07-08','17:35:00',1.16),('8537','2013-07-08','17:40:00',1.2),('8537','2013-07-08','17:45:00',1.2),('8537','2013-07-08','17:50:00',1.2),('8537','2013-07-08','17:55:00',1.15),('8537','2013-07-08','18:00:00',1.07),('8537','2013-07-08','18:20:00',1.01),('8537','2013-07-08','18:40:00',1.18),('8537','2013-07-08','18:45:00',1.05),('8537','2013-07-07','07:35:00',1.06),('8537','2013-07-07','07:40:00',1.16),('8537','2013-07-07','07:45:00',1.26),('8537','2013-07-07','07:50:00',1.36),('8537','2013-07-07','07:55:00',1.46),('8537','2013-07-07','08:00:00',1.58),('8537','2013-07-07','08:05:00',1.68),('8537','2013-07-07','08:10:00',1.79),('8537','2013-07-07','08:15:00',1.69),('8537','2013-07-07','08:20:00',1.51),('8537','2013-07-07','08:25:00',1.64),('8537','2013-07-07','08:30:00',2.05),('8537','2013-07-07','08:35:00',2.38),('8537','2013-07-07','08:40:00',1.54),('8537','2013-07-07','08:45:00',1),('8537','2013-07-07','08:50:00',2.2),('8537','2013-07-07','08:55:00',2.64),('8537','2013-07-07','09:00:00',2.68),('8537','2013-07-07','09:05:00',2.47),('8537','2013-07-07','09:10:00',2.63),('8537','2013-07-07','09:15:00',2.67),('8537','2013-07-07','09:20:00',1.75),('8537','2013-07-07','09:25:00',2.48),('8537','2013-07-07','09:30:00',3.26),('8537','2013-07-07','09:35:00',3.3),('8537','2013-07-07','09:40:00',3.05),('8537','2013-07-07','09:45:00',3.65),('8537','2013-07-07','09:50:00',3.64),('8537','2013-07-07','09:55:00',3.72),('8537','2013-07-07','10:00:00',3.74),('8537','2013-07-07','10:05:00',3.59),('8537','2013-07-07','10:10:00',3.76),('8537','2013-07-07','10:15:00',3.62),('8537','2013-07-07','10:20:00',3.67),('8537','2013-07-07','10:25:00',3.6),('8537','2013-07-07','10:30:00',3.6),('8537','2013-07-07','10:35:00',4.29),('8537','2013-07-07','10:40:00',3.87),('8537','2013-07-07','10:45:00',4.25),('8537','2013-07-07','10:50:00',4.36),('8537','2013-07-07','10:55:00',4.32),('8537','2013-07-07','11:00:00',4.34),('8537','2013-07-07','11:05:00',4.43),('8537','2013-07-07','11:10:00',4.5),('8537','2013-07-07','11:15:00',4.51),('8537','2013-07-07','11:20:00',4.29),('8537','2013-07-07','11:25:00',3.83),('8537','2013-07-07','11:30:00',4.02),('8537','2013-07-07','11:35:00',3.9),('8537','2013-07-07','11:40:00',4.12),('8537','2013-07-07','11:45:00',3.28),('8537','2013-07-07','11:50:00',3.36),('8537','2013-07-07','11:55:00',2.35),('8537','2013-07-07','12:00:00',3.15),('8537','2013-07-07','12:05:00',4.63),('8537','2013-07-07','12:10:00',4.71),('8537','2013-07-07','12:15:00',4.95),('8537','2013-07-07','12:20:00',4.85),('8537','2013-07-07','12:25:00',4.56),('8537','2013-07-07','12:30:00',4.65),('8537','2013-07-07','12:35:00',4.92),('8537','2013-07-07','12:40:00',5.1),('8537','2013-07-07','12:45:00',5.07),('8537','2013-07-07','12:50:00',4.9),('8537','2013-07-07','12:55:00',5.14),('8537','2013-07-07','13:00:00',4.97),('8537','2013-07-07','13:05:00',4.81),('8537','2013-07-07','13:10:00',5.06),('8537','2013-07-07','13:15:00',4.99),('8537','2013-07-07','13:20:00',4.98),('8537','2013-07-07','13:25:00',3.76),('8537','2013-07-07','13:30:00',4.74),('8537','2013-07-07','13:35:00',5.12),('8537','2013-07-07','13:40:00',4.8),('8537','2013-07-07','13:45:00',5.28),('8537','2013-07-07','13:50:00',5.42),('8537','2013-07-07','13:55:00',3.54),('8537','2013-07-07','14:00:00',3.91),('8537','2013-07-07','14:05:00',4.55),('8537','2013-07-07','14:10:00',2.44),('8537','2013-07-07','14:15:00',2.61),('8537','2013-07-07','14:20:00',1.37),('8537','2013-07-07','14:25:00',1.15),('8537','2013-07-07','14:30:00',1.05),('8537','2013-07-07','15:00:00',1.1),('8537','2013-07-07','15:05:00',1.26),('8537','2013-07-07','15:10:00',1.06),('8537','2013-07-07','17:00:00',1.05),('8537','2013-07-07','17:05:00',1.11),('8537','2013-07-07','17:10:00',1.16),('8537','2013-07-07','17:15:00',1.18),('8537','2013-07-07','17:20:00',1.19),('8537','2013-07-07','17:25:00',1.17),('8537','2013-07-07','17:30:00',1.12),('8537','2013-07-07','17:35:00',1.06),('8537','2013-07-07','17:40:00',1.01),('8537','2013-07-06','07:35:00',1.02),('8537','2013-07-06','07:40:00',1.11),('8537','2013-07-06','07:45:00',1.22),('8537','2013-07-06','07:50:00',1.32),('8537','2013-07-06','07:55:00',1.42),('8537','2013-07-06','08:00:00',1.52),('8537','2013-07-06','08:05:00',1.63),('8537','2013-07-06','08:10:00',1.73),('8537','2013-07-06','08:15:00',1.82),('8537','2013-07-06','08:20:00',1.92),('8537','2013-07-06','08:25:00',2.02),('8537','2013-07-06','08:30:00',2.12),('8537','2013-07-06','08:35:00',2.22),('8537','2013-07-06','08:40:00',2.32),('8537','2013-07-06','08:45:00',2.4),('8537','2013-07-06','08:50:00',2.49),('8537','2013-07-06','08:55:00',2.58),('8537','2013-07-06','09:00:00',2.67),('8537','2013-07-06','09:05:00',2.77),('8537','2013-07-06','09:10:00',2.87),('8537','2013-07-06','09:15:00',2.95),('8537','2013-07-06','09:20:00',3.04),('8537','2013-07-06','09:25:00',3.1),('8537','2013-07-06','09:30:00',3.16),('8537','2013-07-06','09:35:00',3.24),('8537','2013-07-06','09:40:00',3.31),('8537','2013-07-06','09:45:00',3.37),('8537','2013-07-06','09:50:00',3.48),('8537','2013-07-06','09:55:00',3.57),('8537','2013-07-06','10:00:00',3.66),('8537','2013-07-06','10:05:00',3.74),('8537','2013-07-06','10:10:00',3.81),('8537','2013-07-06','10:15:00',3.87),('8537','2013-07-06','10:20:00',3.93),('8537','2013-07-06','10:25:00',3.97),('8537','2013-07-06','10:30:00',4.02),('8537','2013-07-06','10:35:00',4.07),('8537','2013-07-06','10:40:00',4.07),('8537','2013-07-06','10:45:00',4.19),('8537','2013-07-06','10:50:00',4.28),('8537','2013-07-06','10:55:00',4.33),('8537','2013-07-06','11:00:00',4.38),('8537','2013-07-06','11:05:00',4.43),('8537','2013-07-06','11:10:00',4.46),('8537','2013-07-06','11:15:00',4.45),('8537','2013-07-06','11:20:00',4.48),('8537','2013-07-06','11:25:00',4.54),('8537','2013-07-06','11:30:00',4.56),('8537','2013-07-06','11:35:00',4.61),('8537','2013-07-06','11:40:00',4.64),('8537','2013-07-06','11:45:00',4.7),('8537','2013-07-06','11:50:00',4.74),('8537','2013-07-06','11:55:00',4.71),('8537','2013-07-06','12:00:00',4.78),('8537','2013-07-06','12:05:00',4.83),('8537','2013-07-06','12:10:00',4.89),('8537','2013-07-06','12:15:00',4.89),('8537','2013-07-06','12:20:00',4.94),('8537','2013-07-06','12:25:00',4.91),('8537','2013-07-06','12:30:00',4.96),('8537','2013-07-06','12:35:00',4.92),('8537','2013-07-06','12:40:00',4.94),('8537','2013-07-06','12:45:00',4.99),('8537','2013-07-06','12:50:00',4.99),('8537','2013-07-06','12:55:00',5.02),('8537','2013-07-06','13:00:00',5.04),('8537','2013-07-06','13:05:00',5.06),('8537','2013-07-06','13:10:00',5.1),('8537','2013-07-06','13:15:00',5.08),('8537','2013-07-06','13:20:00',5.03),('8537','2013-07-06','13:25:00',4.99),('8537','2013-07-06','13:30:00',5.06),('8537','2013-07-06','13:35:00',5.03),('8537','2013-07-06','13:40:00',4.99),('8537','2013-07-06','13:45:00',5.05),('8537','2013-07-06','13:50:00',4.96),('8537','2013-07-06','13:55:00',4.96),('8537','2013-07-06','14:00:00',4.96),('8537','2013-07-06','14:05:00',4.98),('8537','2013-07-06','14:10:00',4.9),('8537','2013-07-06','14:15:00',4.12),('8537','2013-07-06','14:20:00',2.35),('8537','2013-07-06','14:25:00',4.93),('8537','2013-07-06','14:30:00',4.84),('8537','2013-07-06','14:35:00',4.83),('8537','2013-07-06','14:40:00',4.78),('8537','2013-07-06','14:45:00',4.74),('8537','2013-07-06','14:50:00',4.48),('8537','2013-07-06','14:55:00',3.88),('8537','2013-07-06','15:00:00',4.02),('8537','2013-07-06','15:05:00',4.52),('8537','2013-07-06','15:10:00',4.63),('8537','2013-07-06','15:15:00',4.5),('8537','2013-07-06','15:20:00',4.4),('8537','2013-07-06','15:25:00',4.36),('8537','2013-07-06','15:30:00',4.46),('8537','2013-07-06','15:35:00',2.46),('8537','2013-07-06','16:50:00',1.13),('8537','2013-07-06','16:55:00',1.4),('8537','2013-07-06','17:00:00',1.12),('8537','2013-07-06','17:05:00',1.06),('8537','2013-07-06','17:10:00',1.04),('8537','2013-07-06','17:15:00',1.15),('8537','2013-07-06','17:20:00',1.08),('8537','2013-07-06','17:25:00',1.13),('8537','2013-07-06','17:30:00',1.23),('8537','2013-07-06','17:35:00',1.23),('8537','2013-07-06','17:40:00',1.07),('8537','2013-07-06','17:45:00',1),('8537','2013-07-05','07:35:00',1.07),('8537','2013-07-05','07:40:00',1.16),('8537','2013-07-05','07:45:00',1.25),('8537','2013-07-05','07:50:00',1.32),('8537','2013-07-05','07:55:00',1.42),('8537','2013-07-05','08:00:00',1.55),('8537','2013-07-05','08:05:00',1.66),('8537','2013-07-05','08:10:00',1.75),('8537','2013-07-05','08:15:00',1.85),('8537','2013-07-05','08:20:00',1.92),('8537','2013-07-05','08:25:00',2.01),('8537','2013-07-05','08:30:00',2.12),('8537','2013-07-05','08:35:00',2.22),('8537','2013-07-05','08:40:00',2.31),('8537','2013-07-05','08:45:00',2.39),('8537','2013-07-05','08:50:00',2.48),('8537','2013-07-05','08:55:00',2.57),('8537','2013-07-05','09:00:00',2.65),('8537','2013-07-05','09:05:00',2.76),('8537','2013-07-05','09:10:00',2.83),('8537','2013-07-05','09:15:00',2.92),('8537','2013-07-05','09:20:00',3.02),('8537','2013-07-05','09:25:00',3.11),('8537','2013-07-05','09:30:00',3.21),('8537','2013-07-05','09:35:00',3.28),('8537','2013-07-05','09:40:00',3.33),('8537','2013-07-05','09:45:00',3.44),('8537','2013-07-05','09:50:00',3.5),('8537','2013-07-05','09:55:00',3.58),('8537','2013-07-05','10:00:00',3.61),('8537','2013-07-05','10:05:00',3.7),('8537','2013-07-05','10:10:00',3.76),('8537','2013-07-05','10:15:00',3.84),('8537','2013-07-05','10:20:00',3.91),('8537','2013-07-05','10:25:00',3.96),('8537','2013-07-05','10:30:00',4.01),('8537','2013-07-05','10:35:00',4.05),('8537','2013-07-05','10:40:00',4.09),('8537','2013-07-05','10:45:00',4.12),('8537','2013-07-05','10:50:00',4.18),('8537','2013-07-05','10:55:00',4.24),('8537','2013-07-05','11:00:00',4.28),('8537','2013-07-05','11:05:00',4.29),('8537','2013-07-05','11:10:00',4.33),('8537','2013-07-05','11:15:00',4.37),('8537','2013-07-05','11:20:00',4.4),('8537','2013-07-05','11:25:00',4.49),('8537','2013-07-05','11:30:00',4.54),('8537','2013-07-05','11:35:00',4.58),('8537','2013-07-05','11:40:00',4.6),('8537','2013-07-05','11:45:00',4.6),('8537','2013-07-05','11:50:00',4.69),('8537','2013-07-05','11:55:00',4.69),('8537','2013-07-05','12:00:00',4.68),('8537','2013-07-05','12:05:00',4.7),('8537','2013-07-05','12:10:00',4.72),('8537','2013-07-05','12:15:00',4.78),('8537','2013-07-05','12:20:00',4.79),('8537','2013-07-05','12:25:00',3.07),('8537','2013-07-05','12:30:00',4.58),('8537','2013-07-05','12:35:00',4.71),('8537','2013-07-05','12:40:00',4.8),('8537','2013-07-05','12:45:00',4.89),('8537','2013-07-05','12:50:00',4.71),('8537','2013-07-05','12:55:00',4.71),('8537','2013-07-05','13:00:00',4.8),('8537','2013-07-05','13:05:00',3.19),('8537','2013-07-05','13:10:00',5.08),('8537','2013-07-05','13:15:00',5.04),('8537','2013-07-05','13:20:00',4.29),('8537','2013-07-05','13:25:00',4.47),('8537','2013-07-05','13:30:00',5.1),('8537','2013-07-05','13:35:00',5.08),('8537','2013-07-05','13:40:00',5.07),('8537','2013-07-05','13:45:00',5),('8537','2013-07-05','13:50:00',4.88),('8537','2013-07-05','13:55:00',4.97),('8537','2013-07-05','14:00:00',5.01),('8537','2013-07-05','14:05:00',4.53),('8537','2013-07-05','14:10:00',4.95),('8537','2013-07-05','14:15:00',4.83),('8537','2013-07-05','14:20:00',4.8),('8537','2013-07-05','14:25:00',4.86),('8537','2013-07-05','14:30:00',4.71),('8537','2013-07-05','14:35:00',4.01),('8537','2013-07-05','14:40:00',4.75),('8537','2013-07-05','14:45:00',3.07),('8537','2013-07-05','14:50:00',3.53),('8537','2013-07-05','14:55:00',4.15),('8537','2013-07-05','15:00:00',4.55),('8537','2013-07-05','15:05:00',4.43),('8537','2013-07-05','15:10:00',4.54),('8537','2013-07-05','15:15:00',4.39),('8537','2013-07-05','15:20:00',3.03),('8537','2013-07-05','15:25:00',1.92),('8537','2013-07-05','15:30:00',3.9),('8537','2013-07-05','15:35:00',4.31),('8537','2013-07-05','15:40:00',4.2),('8537','2013-07-05','15:45:00',4.12),('8537','2013-07-05','15:50:00',3.81),('8537','2013-07-05','15:55:00',3.88),('8537','2013-07-05','16:00:00',3.82),('8537','2013-07-05','16:05:00',3.81),('8537','2013-07-05','16:10:00',3.69),('8537','2013-07-05','16:15:00',3.64),('8537','2013-07-05','16:20:00',3.6),('8537','2013-07-05','16:25:00',3.51),('8537','2013-07-05','16:30:00',3.34),('8537','2013-07-05','16:35:00',2.94),('8537','2013-07-05','16:40:00',3.19),('8537','2013-07-05','16:45:00',3.19),('8537','2013-07-05','16:50:00',3.04),('8537','2013-07-05','16:55:00',2.93),('8537','2013-07-05','17:00:00',2.66),('8537','2013-07-05','17:05:00',2.79),('8537','2013-07-05','17:10:00',2.63),('8537','2013-07-05','17:15:00',2.66),('8537','2013-07-05','17:20:00',2.63),('8537','2013-07-05','17:25:00',2.5),('8537','2013-07-05','17:30:00',2.35),('8537','2013-07-05','17:35:00',2.12),('8537','2013-07-05','17:40:00',2.03),('8537','2013-07-05','17:45:00',1.91),('8537','2013-07-05','17:50:00',1.83),('8537','2013-07-05','17:55:00',1.75),('8537','2013-07-05','18:00:00',1.72),('8537','2013-07-05','18:05:00',1.6),('8537','2013-07-05','18:10:00',1.23),('8537','2013-07-04','08:55:00',1.09),('8537','2013-07-04','09:00:00',1.07),('8537','2013-07-04','11:10:00',1.18),('8537','2013-07-04','11:15:00',1.27),('8537','2013-07-04','11:20:00',1.19),('8537','2013-07-04','11:25:00',1.24),('8537','2013-07-04','11:30:00',1.34),('8537','2013-07-04','11:35:00',1.53),('8537','2013-07-04','11:40:00',1.72),('8537','2013-07-04','11:45:00',1.89),('8537','2013-07-04','11:50:00',1.96),('8537','2013-07-04','11:55:00',1.8),('8537','2013-07-04','12:00:00',1.69),('8537','2013-07-04','12:05:00',1.86),('8537','2013-07-04','12:10:00',2.47),('8537','2013-07-04','12:15:00',3.1),('8537','2013-07-04','12:20:00',2.89),('8537','2013-07-04','12:25:00',3.91),('8537','2013-07-04','12:30:00',3.28),('8537','2013-07-04','12:35:00',3.05),('8537','2013-07-04','12:40:00',2.02),('8537','2013-07-04','12:45:00',1.63),('8537','2013-07-04','12:50:00',1.29),('8537','2013-07-04','12:55:00',1.15),('8537','2013-07-04','13:00:00',1.2),('8537','2013-07-04','13:05:00',1.37),('8537','2013-07-04','13:10:00',1.74),('8537','2013-07-04','13:15:00',2.02),('8537','2013-07-04','13:20:00',2.25),('8537','2013-07-04','13:25:00',3.05),('8537','2013-07-04','13:30:00',2.41),('8537','2013-07-04','13:35:00',2.46),('8537','2013-07-04','13:40:00',3.65),('8537','2013-07-04','13:45:00',2.6),('8537','2013-07-04','13:50:00',3.28),('8537','2013-07-04','13:55:00',3.35),('8537','2013-07-04','14:00:00',2.67),('8537','2013-07-04','14:05:00',2.58),('8537','2013-07-04','14:10:00',2.54),('8537','2013-07-04','14:15:00',2.5),('8537','2013-07-04','14:20:00',3.04),('8537','2013-07-04','14:25:00',2.24),('8537','2013-07-04','14:30:00',2.2),('8537','2013-07-04','14:35:00',2.29),('8537','2013-07-04','14:40:00',3.76),('8537','2013-07-04','14:45:00',5.03),('8537','2013-07-04','14:50:00',3.18),('8537','2013-07-04','14:55:00',2.52),('8537','2013-07-04','15:00:00',3.62),('8537','2013-07-04','15:05:00',3.77),('8537','2013-07-04','15:10:00',3.03),('8537','2013-07-04','15:15:00',5.17),('8537','2013-07-04','15:20:00',4.74),('8537','2013-07-04','15:25:00',4.23),('8537','2013-07-04','15:30:00',2.72),('8537','2013-07-04','15:35:00',3.29),('8537','2013-07-04','15:40:00',3.05),('8537','2013-07-04','15:45:00',3.75),('8537','2013-07-04','15:50:00',2.55),('8537','2013-07-04','15:55:00',2.49),('8537','2013-07-04','16:00:00',2.61),('8537','2013-07-04','16:05:00',2.72),('8537','2013-07-04','16:10:00',2.28),('8537','2013-07-04','16:15:00',1.96),('8537','2013-07-04','16:20:00',2.12),('8537','2013-07-04','16:25:00',2.36),('8537','2013-07-04','16:30:00',2.31),('8537','2013-07-04','16:35:00',2.32),('8537','2013-07-04','16:40:00',1.86),('8537','2013-07-04','16:45:00',1.72),('8537','2013-07-04','16:50:00',1.76),('8537','2013-07-04','16:55:00',1.71),('8537','2013-07-04','17:00:00',1.5),('8537','2013-07-04','17:05:00',1.42),('8537','2013-07-04','17:10:00',1.75),('8537','2013-07-04','17:15:00',2.24),('8537','2013-07-04','17:20:00',2.23),('8537','2013-07-04','17:25:00',2.6),('8537','2013-07-04','17:30:00',2.26),('8537','2013-07-04','17:35:00',1.97),('8537','2013-07-04','17:40:00',2.39),('8537','2013-07-04','17:45:00',2.26),('8537','2013-07-04','17:50:00',2.18),('8537','2013-07-04','17:55:00',2.08),('8537','2013-07-04','18:00:00',2.02),('8537','2013-07-04','18:05:00',1.89),('8537','2013-07-04','18:10:00',1.81),('8537','2013-07-04','18:15:00',1.75),('8537','2013-07-04','18:20:00',1.63),('8537','2013-07-04','18:25:00',1.49),('8537','2013-07-04','18:30:00',1.04),('8537','2013-07-03','07:35:00',1.09),('8537','2013-07-03','07:40:00',1.19),('8537','2013-07-03','07:45:00',1.3),('8537','2013-07-03','07:50:00',1.4),('8537','2013-07-03','07:55:00',1.51),('8537','2013-07-03','08:00:00',1.61),('8537','2013-07-03','08:05:00',1.72),('8537','2013-07-03','08:10:00',1.83),('8537','2013-07-03','08:15:00',1.92),('8537','2013-07-03','08:20:00',2.02),('8537','2013-07-03','08:25:00',2.13),('8537','2013-07-03','08:30:00',2.22),('8537','2013-07-03','08:35:00',2.32),('8537','2013-07-03','08:40:00',2.42),('8537','2013-07-03','08:45:00',2.51),('8537','2013-07-03','08:50:00',2.59),('8537','2013-07-03','08:55:00',2.7),('8537','2013-07-03','09:00:00',2.79),('8537','2013-07-03','09:05:00',2.85),('8537','2013-07-03','09:10:00',2.92),('8537','2013-07-03','09:15:00',3.03),('8537','2013-07-03','09:20:00',3.1),('8537','2013-07-03','09:25:00',3.17),('8537','2013-07-03','09:30:00',3.26),('8537','2013-07-03','09:35:00',3.32),('8537','2013-07-03','09:40:00',3.4),('8537','2013-07-03','09:45:00',3.44),('8537','2013-07-03','09:50:00',3.51),('8537','2013-07-03','09:55:00',3.56),('8537','2013-07-03','10:00:00',3.66),('8537','2013-07-03','10:05:00',3.69),('8537','2013-07-03','10:10:00',3.7),('8537','2013-07-03','10:15:00',3.77),('8537','2013-07-03','10:20:00',3.86),('8537','2013-07-03','10:25:00',3.92),('8537','2013-07-03','10:30:00',3.99),('8537','2013-07-03','10:35:00',4.03),('8537','2013-07-03','10:40:00',4.1),('8537','2013-07-03','10:45:00',4.13),('8537','2013-07-03','10:50:00',4.15),('8537','2013-07-03','10:55:00',4.22),('8537','2013-07-03','11:00:00',4.28),('8537','2013-07-03','11:05:00',4.32),('8537','2013-07-03','11:10:00',4.33),('8537','2013-07-03','11:15:00',4.48),('8537','2013-07-03','11:20:00',4.53),('8537','2013-07-03','11:25:00',4.52),('8537','2013-07-03','11:30:00',4.52),('8537','2013-07-03','11:35:00',4.53),('8537','2013-07-03','11:40:00',4.49),('8537','2013-07-03','11:45:00',4.65),('8537','2013-07-03','11:50:00',4.79),('8537','2013-07-03','11:55:00',4.79),('8537','2013-07-03','12:00:00',4.77),('8537','2013-07-03','12:05:00',4.86),('8537','2013-07-03','12:10:00',4.85),('8537','2013-07-03','12:15:00',4.84),('8537','2013-07-03','12:20:00',4.85),('8537','2013-07-03','12:25:00',4.84),('8537','2013-07-03','12:30:00',4.85),('8537','2013-07-03','12:35:00',4.92),('8537','2013-07-03','12:40:00',4.93),('8537','2013-07-03','12:45:00',4.96),('8537','2013-07-03','12:50:00',4.98),('8537','2013-07-03','12:55:00',5.01),('8537','2013-07-03','13:00:00',5.03),('8537','2013-07-03','13:05:00',5.04),('8537','2013-07-03','13:10:00',4.94),('8537','2013-07-03','13:15:00',5.03),('8537','2013-07-03','13:20:00',5.02),('8537','2013-07-03','13:25:00',4.95),('8537','2013-07-03','13:30:00',4.93),('8537','2013-07-03','13:35:00',4.94),('8537','2013-07-03','13:40:00',4.96),('8537','2013-07-03','13:45:00',4.97),('8537','2013-07-03','13:50:00',4.97),('8537','2013-07-03','13:55:00',4.93),('8537','2013-07-03','14:00:00',4.9),('8537','2013-07-03','14:05:00',4.89),('8537','2013-07-03','14:10:00',4.89),('8537','2013-07-03','14:15:00',4.87),('8537','2013-07-03','14:20:00',4.86),('8537','2013-07-03','14:25:00',4.81),('8537','2013-07-03','14:30:00',4.81),('8537','2013-07-03','14:35:00',4.79),('8537','2013-07-03','14:40:00',4.75),('8537','2013-07-03','14:45:00',4.67),('8537','2013-07-03','14:50:00',4.42),('8537','2013-07-03','14:55:00',4.36),('8537','2013-07-03','15:00:00',4.55),('8537','2013-07-03','15:05:00',4.51),('8537','2013-07-03','15:10:00',4.46),('8537','2013-07-03','15:15:00',4.44),('8537','2013-07-03','15:20:00',4.39),('8537','2013-07-03','15:25:00',4.36),('8537','2013-07-03','15:30:00',4.32),('8537','2013-07-03','15:35:00',4.25),('8537','2013-07-03','15:40:00',4.18),('8537','2013-07-03','15:45:00',4.04),('8537','2013-07-03','15:50:00',3.86),('8537','2013-07-03','15:55:00',3.96),('8537','2013-07-03','16:00:00',3.88),('8537','2013-07-03','16:05:00',3.81),('8537','2013-07-03','16:10:00',3.71),('8537','2013-07-03','16:15:00',3.7),('8537','2013-07-03','16:20:00',3.64),('8537','2013-07-03','16:25:00',3.57),('8537','2013-07-03','16:30:00',3.37),('8537','2013-07-03','16:35:00',3.09),('8537','2013-07-03','16:40:00',3.27),('8537','2013-07-03','16:45:00',3.2),('8537','2013-07-03','16:50:00',3.12),('8537','2013-07-03','16:55:00',3.05),('8537','2013-07-03','17:00:00',2.97),('8537','2013-07-03','17:05:00',2.88),('8537','2013-07-03','17:10:00',2.7),('8537','2013-07-03','17:15:00',2.68),('8537','2013-07-03','17:20:00',2.6),('8537','2013-07-03','17:25:00',2.51),('8537','2013-07-03','17:30:00',2.39),('8537','2013-07-03','17:35:00',2.24),('8537','2013-07-03','17:40:00',2.18),('8537','2013-07-03','17:45:00',2.09),('8537','2013-07-03','17:50:00',2),('8537','2013-07-03','17:55:00',1.87),('8537','2013-07-03','18:00:00',1.79),('8537','2013-07-03','18:05:00',1.62),('8537','2013-07-03','18:10:00',1.53),('8537','2013-07-03','18:15:00',1.46),('8537','2013-07-03','18:20:00',1.37),('8537','2013-07-03','18:25:00',1.26),('8537','2013-07-03','18:30:00',1.16),('8537','2013-07-03','18:35:00',1.08),('8537','2013-07-02','07:35:00',1.07),('8537','2013-07-02','07:40:00',1.17),('8537','2013-07-02','07:45:00',1.27),('8537','2013-07-02','07:50:00',1.37),('8537','2013-07-02','07:55:00',1.47),('8537','2013-07-02','08:00:00',1.57),('8537','2013-07-02','08:05:00',1.68),('8537','2013-07-02','08:10:00',1.79),('8537','2013-07-02','08:15:00',1.9),('8537','2013-07-02','08:20:00',1.97),('8537','2013-07-02','08:25:00',2.1),('8537','2013-07-02','08:30:00',2.19),('8537','2013-07-02','08:35:00',2.27),('8537','2013-07-02','08:40:00',2.38),('8537','2013-07-02','08:45:00',2.48),('8537','2013-07-02','08:50:00',2.56),('8537','2013-07-02','08:55:00',2.64),('8537','2013-07-02','09:00:00',2.73),('8537','2013-07-02','09:05:00',2.82),('8537','2013-07-02','09:10:00',2.91),('8537','2013-07-02','09:15:00',2.97),('8537','2013-07-02','09:20:00',3.05),('8537','2013-07-02','09:25:00',3.12),('8537','2013-07-02','09:30:00',3.2),('8537','2013-07-02','09:35:00',3.23),('8537','2013-07-02','09:40:00',3.37),('8537','2013-07-02','09:45:00',3.42),('8537','2013-07-02','09:50:00',3.49),('8537','2013-07-02','09:55:00',3.58),('8537','2013-07-02','10:00:00',3.65),('8537','2013-07-02','10:05:00',3.68),('8537','2013-07-02','10:10:00',3.74),('8537','2013-07-02','10:15:00',3.78),('8537','2013-07-02','10:20:00',3.86),('8537','2013-07-02','10:25:00',3.92),('8537','2013-07-02','10:30:00',3.98),('8537','2013-07-02','10:35:00',4.02),('8537','2013-07-02','10:40:00',4.06),('8537','2013-07-02','10:45:00',4.13),('8537','2013-07-02','10:50:00',4.17),('8537','2013-07-02','10:55:00',4.18),('8537','2013-07-02','11:00:00',4.21),('8537','2013-07-02','11:05:00',4.25),('8537','2013-07-02','11:10:00',4.26),('8537','2013-07-02','11:15:00',4.31),('8537','2013-07-02','11:20:00',4.36),('8537','2013-07-02','11:25:00',4.41),('8537','2013-07-02','11:30:00',4.45),('8537','2013-07-02','11:35:00',4.48),('8537','2013-07-02','11:40:00',4.46),('8537','2013-07-02','11:45:00',4.46),('8537','2013-07-02','11:50:00',4.51),('8537','2013-07-02','11:55:00',4.55),('8537','2013-07-02','12:00:00',4.49),('8537','2013-07-02','12:05:00',4.54),('8537','2013-07-02','12:10:00',4.67),('8537','2013-07-02','12:15:00',4.66),('8537','2013-07-02','12:20:00',4.74),('8537','2013-07-02','12:25:00',4.81),('8537','2013-07-02','12:30:00',4.87),('8537','2013-07-02','12:35:00',4.89),('8537','2013-07-02','12:40:00',4.78),('8537','2013-07-02','12:45:00',4.93),('8537','2013-07-02','12:50:00',5.03),('8537','2013-07-02','12:55:00',3.58),('8537','2013-07-02','13:00:00',4.84),('8537','2013-07-02','13:05:00',3.38),('8537','2013-07-02','13:10:00',3.78),('8537','2013-07-02','13:15:00',5.05),('8537','2013-07-02','13:20:00',4.97),('8537','2013-07-02','13:25:00',5.04),('8537','2013-07-02','13:30:00',4.96),('8537','2013-07-02','13:35:00',4.86),('8537','2013-07-02','13:40:00',4.93),('8537','2013-07-02','13:45:00',4.77),('8537','2013-07-02','13:50:00',4.64),('8537','2013-07-02','13:55:00',4.72),('8537','2013-07-02','14:00:00',4.75),('8537','2013-07-02','14:05:00',4.7),('8537','2013-07-02','14:10:00',4.64),('8537','2013-07-02','14:15:00',4.69),('8537','2013-07-02','14:20:00',4.71),('8537','2013-07-02','14:25:00',4.61),('8537','2013-07-02','14:30:00',4.68),('8537','2013-07-02','14:35:00',4.66),('8537','2013-07-02','14:40:00',4.62),('8537','2013-07-02','14:45:00',4.56),('8537','2013-07-02','14:50:00',4.29),('8537','2013-07-02','14:55:00',4.28),('8537','2013-07-02','15:00:00',4.43),('8537','2013-07-02','15:05:00',4.39),('8537','2013-07-02','15:10:00',4.35),('8537','2013-07-02','15:15:00',4.3),('8537','2013-07-02','15:20:00',4.26),('8537','2013-07-02','15:25:00',4.23),('8537','2013-07-02','15:30:00',4.18),('8537','2013-07-02','15:35:00',4.15),('8537','2013-07-02','15:40:00',4.04),('8537','2013-07-02','15:45:00',3.94),('8537','2013-07-02','15:50:00',3.75),('8537','2013-07-02','15:55:00',3.87),('8537','2013-07-02','16:00:00',3.82),('8537','2013-07-02','16:05:00',3.75),('8537','2013-07-02','16:10:00',3.67),('8537','2013-07-02','16:15:00',3.59),('8537','2013-07-02','16:20:00',3.52),('8537','2013-07-02','16:25:00',3.46),('8537','2013-07-02','16:30:00',3.26),('8537','2013-07-02','16:35:00',2.93),('8537','2013-07-02','16:40:00',3.17),('8537','2013-07-02','16:45:00',3.09),('8537','2013-07-02','16:50:00',3.01),('8537','2013-07-02','16:55:00',2.94),('8537','2013-07-02','17:00:00',2.9),('8537','2013-07-02','17:05:00',2.8),('8537','2013-07-02','17:10:00',2.62),('8537','2013-07-02','17:15:00',2.59),('8537','2013-07-02','17:20:00',2.5),('8537','2013-07-02','17:25:00',2.39),('8537','2013-07-02','17:30:00',2.29),('8537','2013-07-02','17:35:00',2.15),('8537','2013-07-02','17:40:00',2.08),('8537','2013-07-02','17:45:00',1.98),('8537','2013-07-02','17:50:00',1.9),('8537','2013-07-02','17:55:00',1.77),('8537','2013-07-02','18:00:00',1.67),('8537','2013-07-02','18:05:00',1.55),('8537','2013-07-02','18:10:00',1.48),('8537','2013-07-02','18:15:00',1.4),('8537','2013-07-02','18:20:00',1.31),('8537','2013-07-02','18:25:00',1.2),('8537','2013-07-02','18:30:00',1.1),('8537','2013-07-02','18:35:00',1.02),('8537','2013-07-01','07:30:00',1.01),('8537','2013-07-01','07:35:00',1.11),('8537','2013-07-01','07:40:00',1.19),('8537','2013-07-01','07:45:00',1.29),('8537','2013-07-01','07:50:00',1.39),('8537','2013-07-01','07:55:00',1.5),('8537','2013-07-01','08:00:00',1.61),('8537','2013-07-01','08:05:00',1.69),('8537','2013-07-01','08:10:00',1.81),('8537','2013-07-01','08:15:00',1.92),('8537','2013-07-01','08:20:00',2.02),('8537','2013-07-01','08:25:00',2.13),('8537','2013-07-01','08:30:00',2.22),('8537','2013-07-01','08:35:00',2.32),('8537','2013-07-01','08:40:00',2.43),('8537','2013-07-01','08:45:00',2.53),('8537','2013-07-01','08:50:00',2.61),('8537','2013-07-01','08:55:00',2.7),('8537','2013-07-01','09:00:00',2.79),('8537','2013-07-01','09:05:00',2.87),('8537','2013-07-01','09:10:00',2.97),('8537','2013-07-01','09:15:00',3.08),('8537','2013-07-01','09:20:00',3.18),('8537','2013-07-01','09:25:00',3.27),('8537','2013-07-01','09:30:00',3.33),('8537','2013-07-01','09:35:00',3.41),('8537','2013-07-01','09:40:00',3.47),('8537','2013-07-01','09:45:00',3.5),('8537','2013-07-01','09:50:00',3.57),('8537','2013-07-01','09:55:00',3.63),('8537','2013-07-01','10:00:00',3.71),('8537','2013-07-01','10:05:00',3.79),('8537','2013-07-01','10:10:00',3.88),('8537','2013-07-01','10:15:00',3.95),('8537','2013-07-01','10:20:00',4.04),('8537','2013-07-01','10:25:00',4.1),('8537','2013-07-01','10:30:00',4.14),('8537','2013-07-01','10:35:00',4.19),('8537','2013-07-01','10:40:00',4.3),('8537','2013-07-01','10:45:00',4.35),('8537','2013-07-01','10:50:00',4.39),('8537','2013-07-01','10:55:00',4.39),('8537','2013-07-01','11:00:00',4.42),('8537','2013-07-01','11:05:00',4.53),('8537','2013-07-01','11:10:00',4.6),('8537','2013-07-01','11:15:00',4.68),('8537','2013-07-01','11:20:00',4.65),('8537','2013-07-01','11:25:00',4.66),('8537','2013-07-01','11:30:00',4.75),('8537','2013-07-01','11:35:00',4.83),('8537','2013-07-01','11:40:00',4.83),('8537','2013-07-01','11:45:00',4.83),('8537','2013-07-01','11:50:00',4.82),('8537','2013-07-01','11:55:00',4.9),('8537','2013-07-01','12:00:00',4.86),('8537','2013-07-01','12:05:00',4.83),('8537','2013-07-01','12:10:00',4.84),('8537','2013-07-01','12:15:00',4.83),('8537','2013-07-01','12:20:00',4.89),('8537','2013-07-01','12:25:00',4.94),('8537','2013-07-01','12:30:00',4.91),('8537','2013-07-01','12:35:00',4.92),('8537','2013-07-01','12:40:00',4.91),('8537','2013-07-01','12:45:00',4.9),('8537','2013-07-01','12:50:00',4.89),('8537','2013-07-01','12:55:00',4.95),('8537','2013-07-01','13:00:00',5.02),('8537','2013-07-01','13:05:00',4.99),('8537','2013-07-01','13:10:00',5.02),('8537','2013-07-01','13:15:00',5),('8537','2013-07-01','13:20:00',5.03),('8537','2013-07-01','13:25:00',5.05),('8537','2013-07-01','13:30:00',5.05),('8537','2013-07-01','13:35:00',4.98),('8537','2013-07-01','13:40:00',4.98),('8537','2013-07-01','13:45:00',4.92),('8537','2013-07-01','13:50:00',4.89),('8537','2013-07-01','13:55:00',4.92),('8537','2013-07-01','14:00:00',4.88),('8537','2013-07-01','14:05:00',4.89),('8537','2013-07-01','14:10:00',4.83),('8537','2013-07-01','14:15:00',4.86),('8537','2013-07-01','14:20:00',4.8),('8537','2013-07-01','14:25:00',4.77),('8537','2013-07-01','14:30:00',4.72),('8537','2013-07-01','14:35:00',4.7),('8537','2013-07-01','14:40:00',4.67),('8537','2013-07-01','14:45:00',4.6),('8537','2013-07-01','14:50:00',4.32),('8537','2013-07-01','14:55:00',4.25),('8537','2013-07-01','15:00:00',4.42),('8537','2013-07-01','15:05:00',4.32),('8537','2013-07-01','15:10:00',4.33),('8537','2013-07-01','15:15:00',4.31),('8537','2013-07-01','15:20:00',4.26),('8537','2013-07-01','15:25:00',4.2),('8537','2013-07-01','15:30:00',4.15),('8537','2013-07-01','15:35:00',4.06),('8537','2013-07-01','15:40:00',3.99),('8537','2013-07-01','15:45:00',3.96),('8537','2013-07-01','15:50:00',3.87),('8537','2013-07-01','15:55:00',3.8),('8537','2013-07-01','16:00:00',3.75),('8537','2013-07-01','16:05:00',3.71),('8537','2013-07-01','16:10:00',3.64),('8537','2013-07-01','16:15:00',3.54),('8537','2013-07-01','16:20:00',3.46),('8537','2013-07-01','16:25:00',3.39),('8537','2013-07-01','16:30:00',3.2),('8537','2013-07-01','16:35:00',2.9),('8537','2013-07-01','16:40:00',3.14),('8537','2013-07-01','16:45:00',3.07),('8537','2013-07-01','16:50:00',3),('8537','2013-07-01','16:55:00',2.94),('8537','2013-07-01','17:00:00',2.87),('8537','2013-07-01','17:05:00',2.78),('8537','2013-07-01','17:10:00',2.55),('8537','2013-07-01','17:15:00',2.58),('8537','2013-07-01','17:20:00',2.47),('8537','2013-07-01','17:25:00',2.38),('8537','2013-07-01','17:30:00',2.26),('8537','2013-07-01','17:35:00',2.09),('8537','2013-07-01','17:40:00',2.05),('8537','2013-07-01','17:45:00',1.98),('8537','2013-07-01','17:50:00',1.9),('8537','2013-07-01','17:55:00',1.78),('8537','2013-07-01','18:00:00',1.57),('8537','2013-07-01','18:05:00',1.53),('8537','2013-07-01','18:10:00',1.48),('8537','2013-07-01','18:15:00',1.2),('8537','2013-07-01','18:20:00',1.2),('8537','2013-07-01','18:25:00',1.26),('8537','2013-07-01','18:30:00',1.16),('8537','2013-07-01','18:35:00',1.06),('8537','2014-04-05','09:10:00',1.05),('8537','2014-04-05','09:15:00',1.42),('8537','2014-04-05','09:20:00',1.87),('8537','2014-04-05','09:25:00',2.94),('8537','2014-04-05','09:30:00',4.18),('8537','2014-04-05','09:35:00',4.05),('8537','2014-04-05','09:40:00',3.99),('8537','2014-04-05','09:45:00',2.93),('8537','2014-04-05','09:50:00',1.86),('8537','2014-04-05','09:55:00',2.93),('8537','2014-04-05','10:00:00',2.81),('8537','2014-04-05','10:05:00',2.62),('8537','2014-04-05','10:10:00',2.72),('8537','2014-04-05','10:15:00',1.97),('8537','2014-04-05','10:20:00',2.64),('8537','2014-04-05','10:25:00',3.25),('8537','2014-04-05','10:30:00',3.21),('8537','2014-04-05','10:35:00',3.69),('8537','2014-04-05','10:40:00',3.84),('8537','2014-04-05','10:45:00',3.66),('8537','2014-04-05','10:50:00',3.23),('8537','2014-04-05','10:55:00',3.6),('8537','2014-04-05','11:00:00',4.3),('8537','2014-04-05','11:05:00',4.46),('8537','2014-04-05','11:10:00',4.8),('8537','2014-04-05','11:15:00',5.04),('8537','2014-04-05','11:20:00',5.06),('8537','2014-04-05','11:25:00',3.46),('8537','2014-04-05','11:30:00',2.64),('8537','2014-04-05','11:35:00',3.24),('8537','2014-04-05','11:40:00',4.27),('8537','2014-04-05','11:45:00',4.91),('8537','2014-04-05','11:50:00',5.25),('8537','2014-04-05','11:55:00',5.08),('8537','2014-04-05','12:00:00',3.85),('8537','2014-04-05','12:05:00',3.76),('8537','2014-04-05','12:10:00',3.78),('8537','2014-04-05','12:15:00',4.02),('8537','2014-04-05','12:20:00',4.42),('8537','2014-04-05','12:25:00',3.5),('8537','2014-04-05','12:30:00',3.19),('8537','2014-04-05','12:35:00',2.79),('8537','2014-04-05','12:40:00',4.68),('8537','2014-04-05','12:45:00',5.75),('8537','2014-04-05','12:50:00',5.85),('8537','2014-04-05','12:55:00',4.6),('8537','2014-04-05','13:00:00',4.83),('8537','2014-04-05','13:05:00',3.89),('8537','2014-04-05','13:10:00',4.66),('8537','2014-04-05','13:15:00',2.48),('8537','2014-04-05','13:20:00',4.85),('8537','2014-04-05','13:25:00',4.67),('8537','2014-04-05','13:30:00',4.9),('8537','2014-04-05','13:35:00',5.84),('8537','2014-04-05','13:40:00',4.59),('8537','2014-04-05','13:45:00',3.55),('8537','2014-04-05','13:50:00',4.83),('8537','2014-04-05','13:55:00',5),('8537','2014-04-05','14:00:00',4.41),('8537','2014-04-05','14:05:00',5.96),('8537','2014-04-05','14:10:00',3.15),('8537','2014-04-05','14:15:00',1.01),('8537','2014-04-05','14:20:00',1.14),('8537','2014-04-05','14:25:00',2.04),('8537','2014-04-05','14:30:00',2.03),('8537','2014-04-05','14:35:00',1.14),('8537','2014-04-05','14:50:00',1.85),('8537','2014-04-05','14:55:00',4.11),('8537','2014-04-05','15:00:00',4.23),('8537','2014-04-05','15:05:00',3.99),('8537','2014-04-05','15:10:00',2.71),('8537','2014-04-05','15:15:00',2.78),('8537','2014-04-05','15:20:00',5.02),('8537','2014-04-05','15:25:00',3.13),('8537','2014-04-05','15:30:00',1.7),('8537','2014-04-05','15:35:00',1.8),('8537','2014-04-05','15:40:00',2.58),('8537','2014-04-05','15:45:00',1.8),('8537','2014-04-05','15:50:00',1.98),('8537','2014-04-05','15:55:00',1.46),('8537','2014-04-05','16:00:00',1.52),('8537','2014-04-05','16:05:00',1.57),('8537','2014-04-05','16:10:00',1.5),('8537','2014-04-05','16:15:00',2.87),('8537','2014-04-05','16:20:00',3.86),('8537','2014-04-05','16:25:00',3.32),('8537','2014-04-05','16:30:00',2.03),('8537','2014-04-05','16:35:00',2.46),('8537','2014-04-05','16:40:00',1.82),('8537','2014-04-05','16:45:00',2.26),('8537','2014-04-05','16:50:00',1.77),('8537','2014-04-05','16:55:00',2.05),('8537','2014-04-05','17:00:00',2.1),('8537','2014-04-05','17:05:00',2.29),('8537','2014-04-05','17:10:00',2.01),('8537','2014-04-05','17:15:00',1.48),('8537','2014-04-05','17:20:00',1.47),('8537','2014-04-05','17:25:00',1.48),('8537','2014-04-05','17:30:00',1.39),('8537','2014-04-05','17:35:00',1.18),('8537','2014-04-05','17:40:00',1.17),('8537','2014-04-05','17:50:00',1.11),('8537','2014-04-05','17:55:00',1.19),('8537','2014-04-05','18:00:00',1.17),('8537','2014-04-05','18:05:00',1.07),('8537','2014-04-05','18:10:00',1.01),('8537','2013-06-30','07:30:00',1.05),('8537','2013-06-30','07:35:00',1.16),('8537','2013-06-30','07:40:00',1.26),('8537','2013-06-30','07:45:00',1.36),('8537','2013-06-30','07:50:00',1.47),('8537','2013-06-30','07:55:00',1.58),('8537','2013-06-30','08:00:00',1.69),('8537','2013-06-30','08:05:00',1.8),('8537','2013-06-30','08:10:00',1.9),('8537','2013-06-30','08:15:00',2),('8537','2013-06-30','08:20:00',2.1),('8537','2013-06-30','08:25:00',2.21),('8537','2013-06-30','08:30:00',2.32),('8537','2013-06-30','08:35:00',2.42),('8537','2013-06-30','08:40:00',2.52),('8537','2013-06-30','08:45:00',2.62),('8537','2013-06-30','08:50:00',2.7),('8537','2013-06-30','08:55:00',2.8),('8537','2013-06-30','09:00:00',2.89),('8537','2013-06-30','09:05:00',2.98),('8537','2013-06-30','09:10:00',3.08),('8537','2013-06-30','09:15:00',3.16),('8537','2013-06-30','09:20:00',3.24),('8537','2013-06-30','09:25:00',3.32),('8537','2013-06-30','09:30:00',3.42),('8537','2013-06-30','09:35:00',3.5),('8537','2013-06-30','09:40:00',3.55),('8537','2013-06-30','09:45:00',3.63),('8537','2013-06-30','09:50:00',3.72),('8537','2013-06-30','09:55:00',3.79),('8537','2013-06-30','10:00:00',3.85),('8537','2013-06-30','10:05:00',3.91),('8537','2013-06-30','10:10:00',4),('8537','2013-06-30','10:15:00',4.07),('8537','2013-06-30','10:20:00',4.15),('8537','2013-06-30','10:25:00',4.17),('8537','2013-06-30','10:30:00',4.19),('8537','2013-06-30','10:35:00',4.27),('8537','2013-06-30','10:40:00',4.36),('8537','2013-06-30','10:45:00',4.4),('8537','2013-06-30','10:50:00',4.4),('8537','2013-06-30','10:55:00',4.46),('8537','2013-06-30','11:00:00',4.53),('8537','2013-06-30','11:05:00',4.52),('8537','2013-06-30','11:10:00',4.59),('8537','2013-06-30','11:15:00',4.62),('8537','2013-06-30','11:20:00',4.67),('8537','2013-06-30','11:25:00',4.67),('8537','2013-06-30','11:30:00',4.75),('8537','2013-06-30','11:35:00',4.76),('8537','2013-06-30','11:40:00',4.78),('8537','2013-06-30','11:45:00',4.76),('8537','2013-06-30','11:50:00',4.75),('8537','2013-06-30','11:55:00',4.77),('8537','2013-06-30','12:00:00',4.82),('8537','2013-06-30','12:05:00',4.92),('8537','2013-06-30','12:10:00',4.96),('8537','2013-06-30','12:15:00',4.97),('8537','2013-06-30','12:20:00',4.98),('8537','2013-06-30','12:25:00',4.98),('8537','2013-06-30','12:30:00',4.99),('8537','2013-06-30','12:35:00',5.03),('8537','2013-06-30','12:40:00',4.99),('8537','2013-06-30','12:45:00',5.11),('8537','2013-06-30','12:50:00',5.2),('8537','2013-06-30','12:55:00',5.16),('8537','2013-06-30','13:00:00',5.13),('8537','2013-06-30','13:05:00',5.09),('8537','2013-06-30','13:10:00',5.02),('8537','2013-06-30','13:15:00',5.09),('8537','2013-06-30','13:20:00',5.15),('8537','2013-06-30','13:25:00',5.22),('8537','2013-06-30','13:30:00',5.16),('8537','2013-06-30','13:35:00',5.1),('8537','2013-06-30','13:40:00',5.08),('8537','2013-06-30','13:45:00',5.13),('8537','2013-06-30','13:50:00',5.15),('8537','2013-06-30','13:55:00',4.37),('8537','2013-06-30','14:00:00',5.05),('8537','2013-06-30','14:05:00',5.07),('8537','2013-06-30','14:10:00',5.03),('8537','2013-06-30','14:15:00',4.9),('8537','2013-06-30','14:20:00',4.84),('8537','2013-06-30','14:25:00',4.77),('8537','2013-06-30','14:30:00',4.75),('8537','2013-06-30','14:35:00',4.77),('8537','2013-06-30','14:40:00',4.82),('8537','2013-06-30','14:45:00',4.76),('8537','2013-06-30','14:50:00',4.47),('8537','2013-06-30','14:55:00',4.52),('8537','2013-06-30','15:00:00',4.6),('8537','2013-06-30','15:05:00',4.49),('8537','2013-06-30','15:10:00',4.5),('8537','2013-06-30','15:15:00',4.46),('8537','2013-06-30','15:20:00',4.43),('8537','2013-06-30','15:25:00',4.36),('8537','2013-06-30','15:30:00',4.31),('8537','2013-06-30','15:35:00',4.28),('8537','2013-06-30','15:40:00',4.23),('8537','2013-06-30','15:45:00',4.09),('8537','2013-06-30','15:50:00',3.9),('8537','2013-06-30','15:55:00',4.01),('8537','2013-06-30','16:00:00',3.95),('8537','2013-06-30','16:05:00',3.88),('8537','2013-06-30','16:10:00',3.83),('8537','2013-06-30','16:15:00',3.8),('8537','2013-06-30','16:20:00',3.8),('8537','2013-06-30','16:25:00',3.86),('8537','2013-06-30','16:30:00',3.7),('8537','2013-06-30','16:35:00',3.21),('8537','2013-06-30','16:40:00',3.25),('8537','2013-06-30','16:45:00',3.21),('8537','2013-06-30','16:50:00',3.14),('8537','2013-06-30','16:55:00',3.01),('8537','2013-06-30','17:00:00',2.9),('8537','2013-06-30','17:05:00',2.83),('8537','2013-06-30','17:10:00',2.76),('8537','2013-06-30','17:15:00',2.65),('8537','2013-06-30','17:20:00',2.55),('8537','2013-06-30','17:25:00',2.43),('8537','2013-06-30','17:30:00',2.29),('8537','2013-06-30','17:35:00',2.11),('8537','2013-06-30','17:40:00',2.1),('8537','2013-06-30','17:45:00',1.99),('8537','2013-06-30','17:50:00',1.92),('8537','2013-06-30','17:55:00',1.78),('8537','2013-06-30','18:00:00',1.71),('8537','2013-06-30','18:05:00',1.55),('8537','2013-06-30','18:10:00',1.5),('8537','2013-06-30','18:15:00',1.43),('8537','2013-06-30','18:20:00',1.34),('8537','2013-06-30','18:25:00',1.24),('8537','2013-06-30','18:30:00',1.13),('8537','2013-06-30','18:35:00',1.04),('8537','2013-06-29','07:30:00',1.27),('8537','2013-06-29','07:35:00',1.55),('8537','2013-06-29','07:40:00',1.63),('8537','2013-06-29','07:45:00',1.63),('8537','2013-06-29','07:50:00',1.75),('8537','2013-06-29','07:55:00',1.89),('8537','2013-06-29','08:00:00',2.19),('8537','2013-06-29','08:05:00',2.39),('8537','2013-06-29','08:10:00',2.49),('8537','2013-06-29','08:15:00',2.21),('8537','2013-06-29','08:20:00',1.46),('8537','2013-06-29','08:25:00',2.31),('8537','2013-06-29','08:30:00',2.48),('8537','2013-06-29','08:35:00',2.55),('8537','2013-06-29','08:40:00',1.57),('8537','2013-06-29','08:45:00',2.39),('8537','2013-06-29','08:50:00',2.73),('8537','2013-06-29','08:55:00',2.81),('8537','2013-06-29','09:00:00',2.86),('8537','2013-06-29','09:05:00',2.95),('8537','2013-06-29','09:10:00',3.04),('8537','2013-06-29','09:15:00',3.13),('8537','2013-06-29','09:20:00',3.21),('8537','2013-06-29','09:25:00',3.27),('8537','2013-06-29','09:30:00',3.29),('8537','2013-06-29','09:35:00',3.43),('8537','2013-06-29','09:40:00',3.55),('8537','2013-06-29','09:45:00',3.61),('8537','2013-06-29','09:50:00',3.69),('8537','2013-06-29','09:55:00',3.76),('8537','2013-06-29','10:00:00',3.81),('8537','2013-06-29','10:05:00',3.89),('8537','2013-06-29','10:10:00',3.99),('8537','2013-06-29','10:15:00',4.03),('8537','2013-06-29','10:20:00',4.03),('8537','2013-06-29','10:25:00',4.14),('8537','2013-06-29','10:30:00',4.19),('8537','2013-06-29','10:35:00',4.26),('8537','2013-06-29','10:40:00',4.31),('8537','2013-06-29','10:45:00',4.33),('8537','2013-06-29','10:50:00',4.46),('8537','2013-06-29','10:55:00',4.53),('8537','2013-06-29','11:00:00',4.45),('8537','2013-06-29','11:05:00',4.65),('8537','2013-06-29','11:10:00',4.73),('8537','2013-06-29','11:15:00',4.8),('8537','2013-06-29','11:20:00',3.49),('8537','2013-06-29','11:25:00',5.16),('8537','2013-06-29','11:30:00',5.2),('8537','2013-06-29','11:35:00',3.57),('8537','2013-06-29','11:40:00',5.26),('8537','2013-06-29','11:45:00',2.05),('8537','2013-06-29','11:50:00',3.07),('8537','2013-06-29','11:55:00',5.5),('8537','2013-06-29','12:00:00',3.41),('8537','2013-06-29','12:05:00',5.22),('8537','2013-06-29','12:10:00',5.32),('8537','2013-06-29','12:15:00',4.31),('8537','2013-06-29','12:20:00',1.26),('8537','2013-06-29','12:25:00',4.43),('8537','2013-06-29','12:30:00',5.45),('8537','2013-06-29','12:35:00',5.41),('8537','2013-06-29','12:40:00',5.42),('8537','2013-06-29','12:45:00',5.72),('8537','2013-06-29','12:50:00',2.59),('8537','2013-06-29','12:55:00',4.14),('8537','2013-06-29','13:00:00',4.4),('8537','2013-06-29','13:05:00',4.05),('8537','2013-06-29','13:10:00',5.68),('8537','2013-06-29','13:15:00',4.6),('8537','2013-06-29','13:20:00',2.31),('8537','2013-06-29','13:25:00',4.79),('8537','2013-06-29','13:30:00',2.82),('8537','2013-06-29','13:35:00',1.06),('8537','2013-06-29','13:40:00',1.09),('8537','2013-06-29','13:45:00',2.12),('8537','2013-06-29','13:50:00',3.08),('8537','2013-06-29','13:55:00',3.69),('8537','2013-06-29','14:00:00',5.32),('8537','2013-06-29','14:05:00',3.9),('8537','2013-06-29','14:10:00',5.45),('8537','2013-06-29','14:15:00',5.62),('8537','2013-06-29','14:20:00',5),('8537','2013-06-29','14:25:00',3.55),('8537','2013-06-29','14:30:00',5.71),('8537','2013-06-29','14:35:00',5.38),('8537','2013-06-29','14:40:00',5.38),('8537','2013-06-29','14:45:00',5.41),('8537','2013-06-29','14:50:00',4.85),('8537','2013-06-29','14:55:00',1.54),('8537','2013-06-29','15:00:00',3.07),('8537','2013-06-29','15:05:00',3.36),('8537','2013-06-29','15:10:00',2.08),('8537','2013-06-29','15:15:00',1.88),('8537','2013-06-29','15:20:00',1.2),('8537','2013-06-29','16:40:00',1.37),('8537','2013-06-29','16:45:00',1.79),('8537','2013-06-29','16:50:00',2.56),('8537','2013-06-29','16:55:00',1.62),('8537','2013-06-29','17:00:00',1.12),('8537','2013-06-29','17:05:00',1.36),('8537','2013-06-29','17:10:00',1.23),('8537','2013-06-29','17:15:00',1.15),('8537','2013-06-29','17:20:00',1.3),('8537','2013-06-29','17:25:00',1.52),('8537','2013-06-29','17:30:00',2.29),('8537','2013-06-29','17:35:00',2.05),('8537','2013-06-29','17:45:00',1.98),('8537','2013-06-29','17:50:00',2.04),('8537','2013-06-29','17:55:00',1.89),('8537','2013-06-29','18:00:00',1.77),('8537','2013-06-29','18:05:00',1.64),('8537','2013-06-29','18:10:00',1.5),('8537','2013-06-29','18:15:00',1.47),('8537','2013-06-29','18:20:00',1.35),('8537','2013-06-29','18:25:00',1.26),('8537','2013-06-29','18:30:00',1.03),('8537','2013-06-29','18:35:00',1.12),('8537','2013-06-29','18:40:00',1.12),('8537','2013-06-28','07:25:00',1),('8537','2013-06-28','07:30:00',1.12),('8537','2013-06-28','07:35:00',1.19),('8537','2013-06-28','07:40:00',1.24),('8537','2013-06-28','07:45:00',1.44),('8537','2013-06-28','07:50:00',1.5),('8537','2013-06-28','07:55:00',1.6),('8537','2013-06-28','08:00:00',1.69),('8537','2013-06-28','08:05:00',1.7),('8537','2013-06-28','08:10:00',1.78),('8537','2013-06-28','08:15:00',1.97),('8537','2013-06-28','08:20:00',2.07),('8537','2013-06-28','08:25:00',2.04),('8537','2013-06-28','08:30:00',2.25),('8537','2013-06-28','08:35:00',2.39),('8537','2013-06-28','08:40:00',2.5),('8537','2013-06-28','08:45:00',2.57),('8537','2013-06-28','08:50:00',2.65),('8537','2013-06-28','08:55:00',2.75),('8537','2013-06-28','09:00:00',2.82),('8537','2013-06-28','09:05:00',2.94),('8537','2013-06-28','09:10:00',3.18),('8537','2013-06-28','09:15:00',2.21),('8537','2013-06-28','09:20:00',1.23),('8537','2013-06-28','09:25:00',1.28),('8537','2013-06-28','09:30:00',3.38),('8537','2013-06-28','09:35:00',3.62),('8537','2013-06-28','09:40:00',3.57),('8537','2013-06-28','09:45:00',3.55),('8537','2013-06-28','09:50:00',3),('8537','2013-06-28','09:55:00',4.25),('8537','2013-06-28','10:00:00',2.64),('8537','2013-06-28','10:05:00',3.99),('8537','2013-06-28','10:10:00',4.12),('8537','2013-06-28','10:15:00',4.41),('8537','2013-06-28','10:20:00',3.89),('8537','2013-06-28','10:25:00',1.96),('8537','2013-06-28','10:30:00',1.57),('8537','2013-06-28','10:35:00',4.55),('8537','2013-06-28','10:40:00',4.73),('8537','2013-06-28','10:45:00',4.71),('8537','2013-06-28','10:50:00',4.07),('8537','2013-06-28','10:55:00',2.67),('8537','2013-06-28','11:00:00',3.13),('8537','2013-06-28','11:05:00',4.43),('8537','2013-06-28','11:10:00',3.03),('8537','2013-06-28','11:15:00',1.79),('8537','2013-06-28','11:20:00',1.45),('8537','2013-06-28','11:25:00',4.59),('8537','2013-06-28','11:30:00',5.22),('8537','2013-06-28','11:35:00',4.2),('8537','2013-06-28','11:40:00',3.77),('8537','2013-06-28','11:45:00',4.38),('8537','2013-06-28','11:50:00',5.42),('8537','2013-06-28','11:55:00',4.99),('8537','2013-06-28','12:00:00',3.34),('8537','2013-06-28','12:05:00',4.67),('8537','2013-06-28','12:10:00',4.6),('8537','2013-06-28','12:15:00',5.47),('8537','2013-06-28','12:20:00',5.33),('8537','2013-06-28','12:25:00',5.31),('8537','2013-06-28','12:30:00',5.02),('8537','2013-06-28','12:35:00',5.2),('8537','2013-06-28','12:40:00',4.19),('8537','2013-06-28','12:45:00',5.24),('8537','2013-06-28','12:50:00',4.2),('8537','2013-06-28','12:55:00',5.32),('8537','2013-06-28','13:00:00',4.34),('8537','2013-06-28','13:05:00',5.13),('8537','2013-06-28','13:10:00',5.41),('8537','2013-06-28','13:15:00',5.34),('8537','2013-06-28','13:20:00',3.98),('8537','2013-06-28','13:25:00',5.2),('8537','2013-06-28','13:30:00',5.28),('8537','2013-06-28','13:35:00',5.31),('8537','2013-06-28','13:40:00',4.58),('8537','2013-06-28','13:45:00',4.52),('8537','2013-06-28','13:50:00',4.2),('8537','2013-06-28','13:55:00',5.27),('8537','2013-06-28','14:00:00',4.7),('8537','2013-06-28','14:05:00',5.1),('8537','2013-06-28','14:10:00',4.38),('8537','2013-06-28','14:15:00',4.1),('8537','2013-06-28','14:20:00',5.14),('8537','2013-06-28','14:25:00',5.26),('8537','2013-06-28','14:30:00',4.87),('8537','2013-06-28','14:35:00',4.59),('8537','2013-06-28','14:40:00',3.15),('8537','2013-06-28','14:45:00',4.84),('8537','2013-06-28','14:50:00',5.03),('8537','2013-06-28','14:55:00',4.58),('8537','2013-06-28','15:00:00',4.33),('8537','2013-06-28','15:05:00',4.71),('8537','2013-06-28','15:10:00',4.1),('8537','2013-06-28','15:15:00',3.61),('8537','2013-06-28','15:20:00',2.38),('8537','2013-06-28','15:25:00',3.97),('8537','2013-06-28','15:30:00',3.01),('8537','2013-06-28','15:35:00',4.69),('8537','2013-06-28','15:40:00',2.34),('8537','2013-06-28','15:45:00',4.13),('8537','2013-06-28','15:50:00',4.56),('8537','2013-06-28','15:55:00',3.47),('8537','2013-06-28','16:00:00',3.81),('8537','2013-06-28','16:05:00',4.46),('8537','2013-06-28','16:10:00',3.56),('8537','2013-06-28','16:15:00',3.83),('8537','2013-06-28','16:20:00',2.81),('8537','2013-06-28','16:25:00',2.38),('8537','2013-06-28','16:30:00',2.02),('8537','2013-06-28','16:35:00',2.18),('8537','2013-06-28','16:40:00',2.75),('8537','2013-06-28','16:50:00',1.2),('8537','2013-06-28','16:55:00',1.88),('8537','2013-06-28','17:00:00',2.52),('8537','2013-06-28','17:05:00',2.87),('8537','2013-06-28','17:10:00',2.82),('8537','2013-06-28','17:15:00',2.69),('8537','2013-06-28','17:20:00',2.56),('8537','2013-06-28','17:25:00',2.54),('8537','2013-06-28','17:30:00',1.89),('8537','2013-06-28','17:35:00',2.26),('8537','2013-06-28','17:40:00',2.14),('8537','2013-06-28','17:45:00',2.07),('8537','2013-06-28','17:50:00',2),('8537','2013-06-28','17:55:00',1.86),('8537','2013-06-28','18:00:00',1.78),('8537','2013-06-28','18:05:00',1.64),('8537','2013-06-28','18:10:00',1.55),('8537','2013-06-28','18:15:00',1.15),('8537','2013-06-28','18:20:00',1.09),('8537','2013-06-28','18:25:00',1.03),('8537','2013-06-28','18:30:00',1.19),('8537','2013-06-27','07:30:00',1.05),('8537','2013-06-27','07:35:00',1.15),('8537','2013-06-27','07:40:00',1.26),('8537','2013-06-27','07:45:00',1.37),('8537','2013-06-27','07:50:00',1.5),('8537','2013-06-27','07:55:00',1.61),('8537','2013-06-27','08:00:00',1.71),('8537','2013-06-27','08:05:00',1.81),('8537','2013-06-27','08:10:00',1.93),('8537','2013-06-27','08:15:00',2.03),('8537','2013-06-27','08:20:00',2.12),('8537','2013-06-27','08:25:00',2.22),('8537','2013-06-27','08:30:00',2.3),('8537','2013-06-27','08:35:00',2.38),('8537','2013-06-27','08:40:00',2.47),('8537','2013-06-27','08:45:00',2.58),('8537','2013-06-27','08:50:00',2.66),('8537','2013-06-27','08:55:00',2.78),('8537','2013-06-27','09:00:00',2.9),('8537','2013-06-27','09:05:00',2.96),('8537','2013-06-27','09:10:00',3.05),('8537','2013-06-27','09:15:00',3.17),('8537','2013-06-27','09:20:00',3.29),('8537','2013-06-27','09:25:00',3.3),('8537','2013-06-27','09:30:00',3.43),('8537','2013-06-27','09:35:00',3.54),('8537','2013-06-27','09:40:00',3.58),('8537','2013-06-27','09:45:00',3.62),('8537','2013-06-27','09:50:00',3.76),('8537','2013-06-27','09:55:00',3.84),('8537','2013-06-27','10:00:00',3.96),('8537','2013-06-27','10:05:00',4.17),('8537','2013-06-27','10:10:00',4.1),('8537','2013-06-27','10:15:00',3.79),('8537','2013-06-27','10:20:00',3.73),('8537','2013-06-27','10:25:00',4.26),('8537','2013-06-27','10:30:00',4.33),('8537','2013-06-27','10:35:00',4.43),('8537','2013-06-27','10:40:00',4.56),('8537','2013-06-27','10:45:00',4.67),('8537','2013-06-27','10:50:00',4.69),('8537','2013-06-27','10:55:00',4.71),('8537','2013-06-27','11:00:00',4.74),('8537','2013-06-27','11:05:00',4.84),('8537','2013-06-27','11:10:00',4.74),('8537','2013-06-27','11:15:00',4.94),('8537','2013-06-27','11:20:00',4.92),('8537','2013-06-27','11:25:00',4.9),('8537','2013-06-27','11:30:00',4.95),('8537','2013-06-27','11:35:00',5.06),('8537','2013-06-27','11:40:00',4.73),('8537','2013-06-27','11:45:00',2.12),('8537','2013-06-27','11:50:00',1.5),('8537','2013-06-27','11:55:00',1.59),('8537','2013-06-27','12:00:00',1.71),('8537','2013-06-27','12:05:00',1.59),('8537','2013-06-27','12:10:00',1.63),('8537','2013-06-27','12:15:00',1.38),('8537','2013-06-27','12:20:00',1.43),('8537','2013-06-27','12:25:00',1.76),('8537','2013-06-27','12:30:00',2.14),('8537','2013-06-27','12:35:00',5.35),('8537','2013-06-27','12:40:00',2.31),('8537','2013-06-27','12:45:00',2),('8537','2013-06-27','12:50:00',1.66),('8537','2013-06-27','12:55:00',1.61),('8537','2013-06-27','13:00:00',1.15),('8537','2013-06-27','13:05:00',1.26),('8537','2013-06-27','13:10:00',1.6),('8537','2013-06-27','13:15:00',2.35),('8537','2013-06-27','13:20:00',2.08),('8537','2013-06-27','13:25:00',1.98),('8537','2013-06-27','13:30:00',1.72),('8537','2013-06-27','13:35:00',2.2),('8537','2013-06-27','13:40:00',1.44),('8537','2013-06-27','13:45:00',1.37),('8537','2013-06-27','13:50:00',1.49),('8537','2013-06-27','13:55:00',1.49),('8537','2013-06-27','14:00:00',1.6),('8537','2013-06-27','14:05:00',1.58),('8537','2013-06-27','14:10:00',1.88),('8537','2013-06-27','14:15:00',3.67),('8537','2013-06-27','14:20:00',2.07),('8537','2013-06-27','14:25:00',3.72),('8537','2013-06-27','14:30:00',5.34),('8537','2013-06-27','14:35:00',4.7),('8537','2013-06-27','14:40:00',3.66),('8537','2013-06-27','14:45:00',1.78),('8537','2013-06-27','14:50:00',3.24),('8537','2013-06-27','14:55:00',4.11),('8537','2013-06-27','15:00:00',4.58),('8537','2013-06-27','15:05:00',4.48),('8537','2013-06-27','15:10:00',4.39),('8537','2013-06-27','15:15:00',4.33),('8537','2013-06-27','15:20:00',4.3),('8537','2013-06-27','15:25:00',4.32),('8537','2013-06-27','15:30:00',4.27),('8537','2013-06-27','15:35:00',4.22),('8537','2013-06-27','15:40:00',4.17),('8537','2013-06-27','15:45:00',4.03),('8537','2013-06-27','15:50:00',3.86),('8537','2013-06-27','15:55:00',3.9),('8537','2013-06-27','16:00:00',3.78),('8537','2013-06-27','16:05:00',3.7),('8537','2013-06-27','16:10:00',3.66),('8537','2013-06-27','16:15:00',3.61),('8537','2013-06-27','16:20:00',3.56),('8537','2013-06-27','16:25:00',3.49),('8537','2013-06-27','16:30:00',3.32),('8537','2013-06-27','16:35:00',2.88),('8537','2013-06-27','16:40:00',3.12),('8537','2013-06-27','16:45:00',3.14),('8537','2013-06-27','16:50:00',3.06),('8537','2013-06-27','16:55:00',2.96),('8537','2013-06-27','17:00:00',2.89),('8537','2013-06-27','17:05:00',2.79),('8537','2013-06-27','17:10:00',2.48),('8537','2013-06-27','17:15:00',2.46),('8537','2013-06-27','17:20:00',2.52),('8537','2013-06-27','17:25:00',2.46),('8537','2013-06-27','17:30:00',2.35),('8537','2013-06-27','17:35:00',2.2),('8537','2013-06-27','17:40:00',1.35),('8537','2013-06-27','17:50:00',1.46),('8537','2013-06-27','17:55:00',1.43),('8537','2013-06-27','18:00:00',1.65),('8537','2013-06-27','18:05:00',1.56),('8537','2013-06-27','18:10:00',1.47),('8537','2013-06-27','18:15:00',1.37),('8537','2013-06-27','18:20:00',1.3),('8537','2013-06-27','18:25:00',1.27),('8537','2013-06-27','18:30:00',1.15),('8537','2013-06-27','18:35:00',1.07),('8537','2013-06-26','07:30:00',1.08),('8537','2013-06-26','07:35:00',1.19),('8537','2013-06-26','07:40:00',1.3),('8537','2013-06-26','07:45:00',1.41),('8537','2013-06-26','07:50:00',1.52),('8537','2013-06-26','07:55:00',1.62),('8537','2013-06-26','08:00:00',1.68),('8537','2013-06-26','08:05:00',1.8),('8537','2013-06-26','08:10:00',1.92),('8537','2013-06-26','08:15:00',2.01),('8537','2013-06-26','08:20:00',2.1),('8537','2013-06-26','08:25:00',2.2),('8537','2013-06-26','08:30:00',2.29),('8537','2013-06-26','08:35:00',2.36),('8537','2013-06-26','08:40:00',2.47),('8537','2013-06-26','08:45:00',2.56),('8537','2013-06-26','08:50:00',2.64),('8537','2013-06-26','08:55:00',2.73),('8537','2013-06-26','09:00:00',2.82),('8537','2013-06-26','09:05:00',2.9),('8537','2013-06-26','09:10:00',2.97),('8537','2013-06-26','09:15:00',3.07),('8537','2013-06-26','09:20:00',3.14),('8537','2013-06-26','09:25:00',3.23),('8537','2013-06-26','09:30:00',3.3),('8537','2013-06-26','09:35:00',3.39),('8537','2013-06-26','09:40:00',3.47),('8537','2013-06-26','09:45:00',3.54),('8537','2013-06-26','09:50:00',3.59),('8537','2013-06-26','09:55:00',3.64),('8537','2013-06-26','10:00:00',3.73),('8537','2013-06-26','10:05:00',3.84),('8537','2013-06-26','10:10:00',3.9),('8537','2013-06-26','10:15:00',3.99),('8537','2013-06-26','10:20:00',3.97),('8537','2013-06-26','10:25:00',4.03),('8537','2013-06-26','10:30:00',4.06),('8537','2013-06-26','10:35:00',4.15),('8537','2013-06-26','10:40:00',4.22),('8537','2013-06-26','10:45:00',4.27),('8537','2013-06-26','10:50:00',4.31),('8537','2013-06-26','10:55:00',4.35),('8537','2013-06-26','11:00:00',4.45),('8537','2013-06-26','11:05:00',4.46),('8537','2013-06-26','11:10:00',4.49),('8537','2013-06-26','11:15:00',4.53),('8537','2013-06-26','11:20:00',4.54),('8537','2013-06-26','11:25:00',4.55),('8537','2013-06-26','11:30:00',4.57),('8537','2013-06-26','11:35:00',4.59),('8537','2013-06-26','11:40:00',4.63),('8537','2013-06-26','11:45:00',4.71),('8537','2013-06-26','11:50:00',4.79),('8537','2013-06-26','11:55:00',4.83),('8537','2013-06-26','12:00:00',4.89),('8537','2013-06-26','12:05:00',4.75),('8537','2013-06-26','12:10:00',4.84),('8537','2013-06-26','12:15:00',4.91),('8537','2013-06-26','12:20:00',4.79),('8537','2013-06-26','12:25:00',4.83),('8537','2013-06-26','12:30:00',4.82),('8537','2013-06-26','12:35:00',4.97),('8537','2013-06-26','12:40:00',5.03),('8537','2013-06-26','12:45:00',5.05),('8537','2013-06-26','12:50:00',4.89),('8537','2013-06-26','12:55:00',2.24),('8537','2013-06-26','13:00:00',1.04),('8537','2013-06-26','13:05:00',1.17),('8537','2013-06-26','13:10:00',1.6),('8537','2013-06-26','13:15:00',3.8),('8537','2013-06-26','13:20:00',5.48),('8537','2013-06-26','13:25:00',5.02),('8537','2013-06-26','13:30:00',1.49),('8537','2013-06-26','13:35:00',1.18),('8537','2013-06-26','13:40:00',1.21),('8537','2013-06-26','13:45:00',2.19),('8537','2013-06-26','13:50:00',1.47),('8537','2013-06-26','13:55:00',2.85),('8537','2013-06-26','14:00:00',4.81),('8537','2013-06-26','14:05:00',3.05),('8537','2013-06-26','14:10:00',1.38),('8537','2013-06-26','14:15:00',5.3),('8537','2013-06-26','14:20:00',5.16),('8537','2013-06-26','14:25:00',4.07),('8537','2013-06-26','14:30:00',4.71),('8537','2013-06-26','14:35:00',3.76),('8537','2013-06-26','14:40:00',1.27),('8537','2013-06-26','14:45:00',3.8),('8537','2013-06-26','14:50:00',4.63),('8537','2013-06-26','14:55:00',4.4),('8537','2013-06-26','15:00:00',4.59),('8537','2013-06-26','15:05:00',4.53),('8537','2013-06-26','15:10:00',4.43),('8537','2013-06-26','15:15:00',4.35),('8537','2013-06-26','15:20:00',4.34),('8537','2013-06-26','15:25:00',4.28),('8537','2013-06-26','15:30:00',4.25),('8537','2013-06-26','15:35:00',4.27),('8537','2013-06-26','15:40:00',4.16),('8537','2013-06-26','15:45:00',4),('8537','2013-06-26','15:50:00',3.4),('8537','2013-06-26','15:55:00',3.55),('8537','2013-06-26','16:00:00',3.91),('8537','2013-06-26','16:05:00',3.81),('8537','2013-06-26','16:10:00',3.75),('8537','2013-06-26','16:15:00',3.7),('8537','2013-06-26','16:20:00',3.63),('8537','2013-06-26','16:25:00',3.49),('8537','2013-06-26','16:30:00',3.36),('8537','2013-06-26','16:35:00',3.05),('8537','2013-06-26','16:40:00',3.22),('8537','2013-06-26','16:45:00',3.16),('8537','2013-06-26','16:50:00',3.09),('8537','2013-06-26','16:55:00',3),('8537','2013-06-26','17:00:00',2.95),('8537','2013-06-26','17:05:00',2.88),('8537','2013-06-26','17:10:00',2.76),('8537','2013-06-26','17:15:00',2.64),('8537','2013-06-26','17:20:00',2.55),('8537','2013-06-26','17:25:00',2.45),('8537','2013-06-26','17:30:00',2.33),('8537','2013-06-26','17:35:00',2.19),('8537','2013-06-26','17:40:00',2.11),('8537','2013-06-26','17:45:00',2.02),('8537','2013-06-26','17:50:00',1.93),('8537','2013-06-26','17:55:00',1.81),('8537','2013-06-26','18:00:00',1.74),('8537','2013-06-26','18:05:00',1.7),('8537','2013-06-26','18:10:00',1.85),('8537','2013-06-25','07:30:00',1.05),('8537','2013-06-25','07:35:00',1.06),('8537','2013-06-25','07:40:00',1.25),('8537','2013-06-25','07:45:00',1.29),('8537','2013-06-25','07:50:00',1.14),('8537','2013-06-25','07:55:00',1.25),('8537','2013-06-25','08:00:00',1.61),('8537','2013-06-25','08:05:00',2.05),('8537','2013-06-25','08:10:00',1.9),('8537','2013-06-25','08:15:00',1.92),('8537','2013-06-25','08:20:00',1.52),('8537','2013-06-25','08:25:00',2.25),('8537','2013-06-25','08:30:00',2.3),('8537','2013-06-25','08:35:00',2.39),('8537','2013-06-25','08:40:00',2.49),('8537','2013-06-25','08:45:00',2.58),('8537','2013-06-25','08:50:00',2.63),('8537','2013-06-25','08:55:00',2.75),('8537','2013-06-25','09:00:00',2.87),('8537','2013-06-25','09:05:00',2.89),('8537','2013-06-25','09:10:00',2.9),('8537','2013-06-25','09:15:00',3.08),('8537','2013-06-25','09:20:00',3.2),('8537','2013-06-25','09:25:00',3.1),('8537','2013-06-25','09:30:00',2.74),('8537','2013-06-25','09:35:00',1.53),('8537','2013-06-25','09:40:00',1.33),('8537','2013-06-25','09:50:00',3.54),('8537','2013-06-25','09:55:00',4.05),('8537','2013-06-25','10:00:00',3.75),('8537','2013-06-25','10:05:00',3.04),('8537','2013-06-25','10:10:00',2.96),('8537','2013-06-25','10:15:00',4.48),('8537','2013-06-25','10:20:00',4.36),('8537','2013-06-25','10:25:00',2.9),('8537','2013-06-25','10:30:00',4.65),('8537','2013-06-25','10:35:00',4.65),('8537','2013-06-25','10:40:00',4.75),('8537','2013-06-25','10:45:00',4.63),('8537','2013-06-25','10:50:00',4.58),('8537','2013-06-25','10:55:00',2),('8537','2013-06-25','11:00:00',1.18),('8537','2013-06-25','11:05:00',3.43),('8537','2013-06-25','11:10:00',2.55),('8537','2013-06-25','11:15:00',1.26),('8537','2013-06-25','11:20:00',1.56),('8537','2013-06-25','11:25:00',1.61),('8537','2013-06-25','11:30:00',1.49),('8537','2013-06-25','11:35:00',5.42),('8537','2013-06-25','11:40:00',5.62),('8537','2013-06-25','11:45:00',5.45),('8537','2013-06-25','11:50:00',3.64),('8537','2013-06-25','11:55:00',4.76),('8537','2013-06-25','12:00:00',4.72),('8537','2013-06-25','12:05:00',1.75),('8537','2013-06-25','12:10:00',1.75),('8537','2013-06-25','12:15:00',1.6),('8537','2013-06-25','12:20:00',1.48),('8537','2013-06-25','12:25:00',1.27),('8537','2013-06-25','12:30:00',1.2),('8537','2013-06-25','12:35:00',1.29),('8537','2013-06-25','12:40:00',1.7),('8537','2013-06-25','12:45:00',2.1),('8537','2013-06-25','12:50:00',1.68),('8537','2013-06-25','12:55:00',2.1),('8537','2013-06-25','13:00:00',5.48),('8537','2013-06-25','13:05:00',5.58),('8537','2013-06-25','13:10:00',5.28),('8537','2013-06-25','13:15:00',5.41),('8537','2013-06-25','13:20:00',5.24),('8537','2013-06-25','13:25:00',5.25),('8537','2013-06-25','13:30:00',4.64),('8537','2013-06-25','13:35:00',4.94),('8537','2013-06-25','13:40:00',4.92),('8537','2013-06-25','13:45:00',5.45),('8537','2013-06-25','13:50:00',3.21),('8537','2013-06-25','13:55:00',3.41),('8537','2013-06-25','14:00:00',3.9),('8537','2013-06-25','14:05:00',5.17),('8537','2013-06-25','14:10:00',4.99),('8537','2013-06-25','14:15:00',4.56),('8537','2013-06-25','14:20:00',4.94),('8537','2013-06-25','14:25:00',5.06),('8537','2013-06-25','14:30:00',4.94),('8537','2013-06-25','14:35:00',4.86),('8537','2013-06-25','14:40:00',4.9),('8537','2013-06-25','14:45:00',4.8),('8537','2013-06-25','14:50:00',4.51),('8537','2013-06-25','14:55:00',4.71),('8537','2013-06-25','15:00:00',4.64),('8537','2013-06-25','15:05:00',4.59),('8537','2013-06-25','15:10:00',4.49),('8537','2013-06-25','15:15:00',4.5),('8537','2013-06-25','15:20:00',4.42),('8537','2013-06-25','15:25:00',4.33),('8537','2013-06-25','15:30:00',4.25),('8537','2013-06-25','15:35:00',4.21),('8537','2013-06-25','15:40:00',4.16),('8537','2013-06-25','15:45:00',3.97),('8537','2013-06-25','15:50:00',3.82),('8537','2013-06-25','15:55:00',3.91),('8537','2013-06-25','16:00:00',3.85),('8537','2013-06-25','16:05:00',3.79),('8537','2013-06-25','16:10:00',3.7),('8537','2013-06-25','16:15:00',3.63),('8537','2013-06-25','16:20:00',3.58),('8537','2013-06-25','16:25:00',3.51),('8537','2013-06-25','16:30:00',3.29),('8537','2013-06-25','16:35:00',3.01),('8537','2013-06-25','16:40:00',3.21),('8537','2013-06-25','16:45:00',3.13),('8537','2013-06-25','16:50:00',3.06),('8537','2013-06-25','16:55:00',2.94),('8537','2013-06-25','17:00:00',2.89),('8537','2013-06-25','17:05:00',2.82),('8537','2013-06-25','17:10:00',2.68),('8537','2013-06-25','17:15:00',2.61),('8537','2013-06-25','17:20:00',2.54),('8537','2013-06-25','17:25:00',2.43),('8537','2013-06-25','17:30:00',2.3),('8537','2013-06-25','17:35:00',2.18),('8537','2013-06-25','17:40:00',2.1),('8537','2013-06-25','17:45:00',2),('8537','2013-06-25','17:50:00',1.9),('8537','2013-06-25','17:55:00',1.8),('8537','2013-06-25','18:00:00',1.71),('8537','2013-06-25','18:05:00',1.58),('8537','2013-06-25','18:10:00',1.47),('8537','2013-06-25','18:15:00',1.39),('8537','2013-06-25','18:20:00',1.31),('8537','2013-06-25','18:25:00',1.21),('8537','2013-06-25','18:30:00',1.11),('8537','2013-06-25','18:35:00',1.03),('8537','2013-06-24','08:45:00',2.74),('8537','2013-06-24','08:50:00',2.83),('8537','2013-06-24','08:55:00',2.95),('8537','2013-06-24','09:00:00',2.44),('8537','2013-06-24','09:05:00',2.91),('8537','2013-06-24','09:10:00',1.89),('8537','2013-06-24','09:15:00',2.78),('8537','2013-06-24','09:20:00',3.7),('8537','2013-06-24','09:25:00',2.98),('8537','2013-06-24','09:30:00',3.78),('8537','2013-06-24','09:35:00',2.47),('8537','2013-06-24','09:40:00',1.94),('8537','2013-06-24','09:45:00',2.94),('8537','2013-06-24','09:50:00',4),('8537','2013-06-24','09:55:00',3.91),('8537','2013-06-24','10:00:00',3.93),('8537','2013-06-24','10:05:00',4.04),('8537','2013-06-24','10:10:00',4.22),('8537','2013-06-24','10:15:00',3),('8537','2013-06-24','10:20:00',4.22),('8537','2013-06-24','10:25:00',4.73),('8537','2013-06-24','10:30:00',3.19),('8537','2013-06-24','10:35:00',4.74),('8537','2013-06-24','10:40:00',1.83),('8537','2013-06-24','10:45:00',2.08),('8537','2013-06-24','10:50:00',4.62),('8537','2013-06-24','10:55:00',3.79),('8537','2013-06-24','11:00:00',5),('8537','2013-06-24','11:05:00',5.11),('8537','2013-06-24','11:10:00',2.28),('8537','2013-06-24','11:15:00',1.11),('8537','2013-06-24','11:20:00',4.92),('8537','2013-06-24','11:25:00',1.68),('8537','2013-06-24','11:30:00',2.83),('8537','2013-06-24','11:35:00',1.68),('8537','2013-06-24','11:40:00',1.54),('8537','2013-06-24','11:45:00',1.93),('8537','2013-06-24','11:50:00',3.47),('8537','2013-06-24','11:55:00',4.02),('8537','2013-06-24','12:00:00',4.06),('8537','2013-06-24','12:05:00',4.45),('8537','2013-06-24','12:10:00',4.11),('8537','2013-06-24','12:15:00',3.91),('8537','2013-06-24','12:20:00',4.82),('8537','2013-06-24','12:25:00',4.91),('8537','2013-06-24','12:30:00',3.58),('8537','2013-06-24','12:35:00',5.28),('8537','2013-06-24','12:40:00',5.41),('8537','2013-06-24','12:45:00',3.24),('8537','2013-06-24','12:50:00',5.44),('8537','2013-06-24','12:55:00',5.65),('8537','2013-06-24','13:00:00',4.6),('8537','2013-06-24','13:05:00',5.04),('8537','2013-06-24','13:10:00',4.5),('8537','2013-06-24','13:15:00',4.05),('8537','2013-06-24','13:20:00',2.68),('8537','2013-06-24','13:25:00',4.32),('8537','2013-06-24','13:30:00',5.77),('8537','2013-06-24','13:35:00',3.97),('8537','2013-06-24','13:40:00',5.09),('8537','2013-06-24','13:45:00',5.39),('8537','2013-06-24','13:50:00',5.27),('8537','2013-06-24','13:55:00',5.18),('8537','2013-06-24','14:00:00',5.06),('8537','2013-06-24','14:05:00',5.18),('8537','2013-06-24','14:10:00',5.13),('8537','2013-06-24','14:15:00',5.1),('8537','2013-06-24','14:20:00',5.1),('8537','2013-06-24','14:25:00',5.1),('8537','2013-06-24','14:30:00',5.14),('8537','2013-06-24','14:35:00',5.07),('8537','2013-06-24','14:40:00',5.03),('8537','2013-06-24','14:45:00',4.91),('8537','2013-06-24','14:50:00',4.24),('8537','2013-06-24','14:55:00',4.41),('8537','2013-06-24','15:00:00',4.59),('8537','2013-06-24','15:05:00',2.98),('8537','2013-06-24','15:10:00',4.37),('8537','2013-06-24','15:15:00',5.01),('8537','2013-06-24','15:20:00',4.61),('8537','2013-06-24','15:25:00',3),('8537','2013-06-24','15:30:00',3.22),('8537','2013-06-24','15:35:00',3.41),('8537','2013-06-24','15:40:00',2.77),('8537','2013-06-24','15:45:00',3.92),('8537','2013-06-24','15:50:00',3.19),('8537','2013-06-24','15:55:00',3.96),('8537','2013-06-24','16:00:00',4.55),('8537','2013-06-24','16:05:00',4.02),('8537','2013-06-24','16:10:00',3.2),('8537','2013-06-24','16:15:00',4.33),('8537','2013-06-24','16:20:00',2.6),('8537','2013-06-24','16:25:00',2.82),('8537','2013-06-24','16:30:00',3.54),('8537','2013-06-24','16:35:00',3.41),('8537','2013-06-24','16:40:00',1.96),('8537','2013-06-24','16:45:00',2.72),('8537','2013-06-24','16:50:00',2.09),('8537','2013-06-24','16:55:00',1.37),('8537','2013-06-24','17:00:00',1.46),('8537','2013-06-24','17:05:00',2.5),('8537','2013-06-24','17:10:00',2.35),('8537','2013-06-24','17:15:00',2.7),('8537','2013-06-24','17:20:00',2.08),('8537','2013-06-24','17:25:00',1.99),('8537','2013-06-24','17:30:00',1.75),('8537','2013-06-24','17:35:00',1.14),('8537','2013-06-24','17:50:00',1.47),('8537','2013-06-24','17:55:00',1.13),('8537','2013-06-24','18:00:00',2.04),('8537','2013-06-24','18:05:00',1.82),('8537','2013-06-24','18:10:00',1.18),('8537','2013-06-24','18:15:00',1.26),('8537','2013-06-24','18:20:00',1.3),('8537','2013-06-24','18:25:00',1.31),('8537','2013-06-24','18:30:00',1.15),('8537','2013-06-24','18:35:00',1.03),('8537','2013-06-23','08:45:00',1.17),('8537','2013-06-23','08:50:00',1.73),('8537','2013-06-23','08:55:00',1.19),('8537','2013-06-23','09:00:00',2),('8537','2013-06-23','09:05:00',1.83),('8537','2013-06-23','09:20:00',2.03),('8537','2013-06-23','09:25:00',3.03),('8537','2013-06-23','09:30:00',3.35),('8537','2013-06-23','09:35:00',3.44),('8537','2013-06-23','09:40:00',3.84),('8537','2013-06-23','09:45:00',2.64),('8537','2013-06-23','09:50:00',1.59),('8537','2013-06-23','09:55:00',1.56),('8537','2013-06-23','10:00:00',2.02),('8537','2013-06-23','10:05:00',3.72),('8537','2013-06-23','10:10:00',2.76),('8537','2013-06-23','10:15:00',2.54),('8537','2013-06-23','10:20:00',1.9),('8537','2013-06-23','10:25:00',1.38),('8537','2013-06-23','10:30:00',1.22),('8537','2013-06-23','10:35:00',4),('8537','2013-06-23','10:40:00',4.05),('8537','2013-06-23','10:45:00',4.21),('8537','2013-06-23','10:50:00',4.2),('8537','2013-06-23','10:55:00',3.77),('8537','2013-06-23','11:00:00',4.29),('8537','2013-06-23','11:05:00',4.36),('8537','2013-06-23','11:10:00',4.47),('8537','2013-06-23','11:15:00',4.53),('8537','2013-06-23','11:20:00',4.62),('8537','2013-06-23','11:25:00',4.55),('8537','2013-06-23','11:30:00',4.52),('8537','2013-06-23','11:35:00',4.44),('8537','2013-06-23','11:40:00',4.48),('8537','2013-06-23','11:45:00',4.49),('8537','2013-06-23','11:50:00',4.75),('8537','2013-06-23','11:55:00',4.7),('8537','2013-06-23','12:00:00',3.98),('8537','2013-06-23','12:05:00',5),('8537','2013-06-23','12:10:00',4.88),('8537','2013-06-23','12:15:00',4.87),('8537','2013-06-23','12:20:00',4.91),('8537','2013-06-23','12:25:00',5.02),('8537','2013-06-23','12:30:00',4.95),('8537','2013-06-23','12:35:00',4.94),('8537','2013-06-23','12:40:00',4.92),('8537','2013-06-23','12:45:00',4.99),('8537','2013-06-23','12:50:00',4.99),('8537','2013-06-23','12:55:00',4.96),('8537','2013-06-23','13:00:00',4.99),('8537','2013-06-23','13:05:00',5),('8537','2013-06-23','13:10:00',5),('8537','2013-06-23','13:15:00',5),('8537','2013-06-23','13:20:00',4.98),('8537','2013-06-23','13:25:00',5),('8537','2013-06-23','13:30:00',4.97),('8537','2013-06-23','13:35:00',5.03),('8537','2013-06-23','13:40:00',5.03),('8537','2013-06-23','13:45:00',5.01),('8537','2013-06-23','13:50:00',5.01),('8537','2013-06-23','13:55:00',5),('8537','2013-06-23','14:00:00',4.96),('8537','2013-06-23','14:05:00',4.93),('8537','2013-06-23','14:10:00',4.93),('8537','2013-06-23','14:15:00',4.9),('8537','2013-06-23','14:20:00',4.84),('8537','2013-06-23','14:25:00',4.86),('8537','2013-06-23','14:30:00',4.83),('8537','2013-06-23','14:35:00',4.81),('8537','2013-06-23','14:40:00',4.8),('8537','2013-06-23','14:45:00',4.69),('8537','2013-06-23','14:50:00',4.67),('8537','2013-06-23','14:55:00',4.63),('8537','2013-06-23','15:00:00',4.58),('8537','2013-06-23','15:05:00',4.54),('8537','2013-06-23','15:10:00',4.48),('8537','2013-06-23','15:15:00',4.45),('8537','2013-06-23','15:20:00',4.4),('8537','2013-06-23','15:25:00',4.36),('8537','2013-06-23','15:30:00',4.29),('8537','2013-06-23','15:35:00',4.22),('8537','2013-06-23','15:40:00',4.16),('8537','2013-06-23','15:45:00',3.99),('8537','2013-06-23','15:50:00',4.01),('8537','2013-06-23','15:55:00',3.94),('8537','2013-06-23','16:00:00',3.88),('8537','2013-06-23','16:05:00',3.81),('8537','2013-06-23','16:10:00',3.73),('8537','2013-06-23','16:15:00',3.65),('8537','2013-06-23','16:20:00',3.58),('8537','2013-06-23','16:25:00',3.49),('8537','2013-06-23','16:30:00',3.34),('8537','2013-06-23','16:35:00',3.3),('8537','2013-06-23','16:40:00',3.25),('8537','2013-06-23','16:45:00',3.18),('8537','2013-06-23','16:50:00',3.1),('8537','2013-06-23','16:55:00',3),('8537','2013-06-23','17:00:00',2.92),('8537','2013-06-23','17:05:00',2.82),('8537','2013-06-23','17:10:00',2.47),('8537','2013-06-23','17:15:00',2.11),('8537','2013-06-23','17:20:00',2.33),('8537','2013-06-23','17:25:00',2.35),('8537','2013-06-23','17:30:00',2.32),('8537','2013-06-23','17:35:00',2.21),('8537','2013-06-23','17:40:00',2.12),('8537','2013-06-23','17:45:00',1.94),('8537','2013-06-23','17:50:00',1.98),('8537','2013-06-23','17:55:00',1.84),('8537','2013-06-23','18:00:00',1.74),('8537','2013-06-23','18:05:00',1.62),('8537','2013-06-23','18:10:00',1.54),('8537','2013-06-23','18:15:00',1.41),('8537','2013-06-23','18:20:00',1.33),('8537','2013-06-23','18:25:00',1.21),('8537','2013-06-23','18:30:00',1.13),('8537','2013-06-23','18:35:00',1.04),('8537','2013-06-22','07:35:00',1.07),('8537','2013-06-22','07:40:00',1.16),('8537','2013-06-22','07:45:00',1.23),('8537','2013-06-22','07:50:00',1.34),('8537','2013-06-22','07:55:00',1.44),('8537','2013-06-22','08:00:00',1.54),('8537','2013-06-22','08:05:00',1.6),('8537','2013-06-22','08:10:00',1.69),('8537','2013-06-22','08:15:00',1.79),('8537','2013-06-22','08:20:00',1.9),('8537','2013-06-22','08:25:00',2.01),('8537','2013-06-22','08:30:00',2.12),('8537','2013-06-22','08:35:00',2.21),('8537','2013-06-22','08:40:00',2.32),('8537','2013-06-22','08:45:00',2.42),('8537','2013-06-22','08:50:00',2.5),('8537','2013-06-22','08:55:00',2.59),('8537','2013-06-22','09:00:00',2.64),('8537','2013-06-22','09:05:00',2.72),('8537','2013-06-22','09:10:00',2.79),('8537','2013-06-22','09:15:00',2.88),('8537','2013-06-22','09:20:00',2.95),('8537','2013-06-22','09:25:00',3),('8537','2013-06-22','09:30:00',3.08),('8537','2013-06-22','09:35:00',3.16),('8537','2013-06-22','09:40:00',3.26),('8537','2013-06-22','09:45:00',3.33),('8537','2013-06-22','09:50:00',3.39),('8537','2013-06-22','09:55:00',3.48),('8537','2013-06-22','10:00:00',3.54),('8537','2013-06-22','10:05:00',3.63),('8537','2013-06-22','10:10:00',3.7),('8537','2013-06-22','10:15:00',3.76),('8537','2013-06-22','10:20:00',3.83),('8537','2013-06-22','10:25:00',3.9),('8537','2013-06-22','10:30:00',3.91),('8537','2013-06-22','10:35:00',3.98),('8537','2013-06-22','10:40:00',4.04),('8537','2013-06-22','10:45:00',4.07),('8537','2013-06-22','10:50:00',4.17),('8537','2013-06-22','10:55:00',4.22),('8537','2013-06-22','11:00:00',4.27),('8537','2013-06-22','11:05:00',4.33),('8537','2013-06-22','11:10:00',4.37),('8537','2013-06-22','11:15:00',4.39),('8537','2013-06-22','11:20:00',4.43),('8537','2013-06-22','11:25:00',4.47),('8537','2013-06-22','11:30:00',4.49),('8537','2013-06-22','11:35:00',4.51),('8537','2013-06-22','11:40:00',4.55),('8537','2013-06-22','11:45:00',4.57),('8537','2013-06-22','11:50:00',4.58),('8537','2013-06-22','11:55:00',4.59),('8537','2013-06-22','12:00:00',4.63),('8537','2013-06-22','12:05:00',4.58),('8537','2013-06-22','12:10:00',4.5),('8537','2013-06-22','12:15:00',4.71),('8537','2013-06-22','12:20:00',4.72),('8537','2013-06-22','12:25:00',4.61),('8537','2013-06-22','12:30:00',4.73),('8537','2013-06-22','12:35:00',4.77),('8537','2013-06-22','12:40:00',4.78),('8537','2013-06-22','12:45:00',4.72),('8537','2013-06-22','12:50:00',4.67),('8537','2013-06-22','12:55:00',4.63),('8537','2013-06-22','13:00:00',4.59),('8537','2013-06-22','13:05:00',4.64),('8537','2013-06-22','13:10:00',4.58),('8537','2013-06-22','13:15:00',4.51),('8537','2013-06-22','13:20:00',4.38),('8537','2013-06-22','13:25:00',4.49),('8537','2013-06-22','13:30:00',4.95),('8537','2013-06-22','13:35:00',4.99),('8537','2013-06-22','13:40:00',4.58),('8537','2013-06-22','13:45:00',4.65),('8537','2013-06-22','13:50:00',4.83),('8537','2013-06-22','13:55:00',3.93),('8537','2013-06-22','14:00:00',2.75),('8537','2013-06-22','14:05:00',5.28),('8537','2013-06-22','14:10:00',4.99),('8537','2013-06-22','14:15:00',4.98),('8537','2013-06-22','14:20:00',4.05),('8537','2013-06-22','14:25:00',4.87),('8537','2013-06-22','14:30:00',3.65),('8537','2013-06-22','14:35:00',2.68),('8537','2013-06-22','14:40:00',2.02),('8537','2013-06-22','14:45:00',2.29),('8537','2013-06-22','14:50:00',3.97),('8537','2013-06-22','14:55:00',4.57),('8537','2013-06-22','15:00:00',4.38),('8537','2013-06-22','15:05:00',3.69),('8537','2013-06-22','15:10:00',4.24),('8537','2013-06-22','15:15:00',4.61),('8537','2013-06-22','15:20:00',4.23),('8537','2013-06-22','15:25:00',3.86),('8537','2013-06-22','15:30:00',2.62),('8537','2013-06-22','15:35:00',2.29),('8537','2013-06-22','15:40:00',2.21),('8537','2013-06-22','15:45:00',2.91),('8537','2013-06-22','15:50:00',2.84),('8537','2013-06-22','15:55:00',2.68),('8537','2013-06-22','16:00:00',2.19),('8537','2013-06-22','16:05:00',1.46),('8537','2013-06-22','16:10:00',1.41),('8537','2013-06-22','16:15:00',1.71),('8537','2013-06-22','16:20:00',2.06),('8537','2013-06-22','16:25:00',1.51),('8537','2013-06-22','16:30:00',1.19),('8537','2013-06-22','16:35:00',1.01),('8537','2013-06-22','16:55:00',1.29),('8537','2013-06-22','17:00:00',1.67),('8537','2013-06-22','17:05:00',1.63),('8537','2013-06-22','17:10:00',2.08),('8537','2013-06-22','17:15:00',2.78),('8537','2013-06-22','17:20:00',2.67),('8537','2013-06-22','17:25:00',2.88),('8537','2013-06-22','17:30:00',2.28),('8537','2013-06-22','17:35:00',1.96),('8537','2013-06-22','17:40:00',2.2),('8537','2013-06-22','17:45:00',2.16),('8537','2013-06-22','17:50:00',1.98),('8537','2013-06-22','17:55:00',1.87),('8537','2013-06-22','18:00:00',1.72),('8537','2013-06-22','18:05:00',1.38),('8537','2013-06-21','07:35:00',1.08),('8537','2013-06-21','07:40:00',1.17),('8537','2013-06-21','07:45:00',1.24),('8537','2013-06-21','07:50:00',1.36),('8537','2013-06-21','07:55:00',1.45),('8537','2013-06-21','08:00:00',1.54),('8537','2013-06-21','08:05:00',1.63),('8537','2013-06-21','08:10:00',1.73),('8537','2013-06-21','08:15:00',1.81),('8537','2013-06-21','08:20:00',1.91),('8537','2013-06-21','08:25:00',2),('8537','2013-06-21','08:30:00',2.09),('8537','2013-06-21','08:35:00',2.19),('8537','2013-06-21','08:40:00',2.29),('8537','2013-06-21','08:45:00',2.35),('8537','2013-06-21','08:50:00',2.43),('8537','2013-06-21','08:55:00',2.5),('8537','2013-06-21','09:00:00',2.57),('8537','2013-06-21','09:05:00',2.64),('8537','2013-06-21','09:10:00',2.71),('8537','2013-06-21','09:15:00',2.78),('8537','2013-06-21','09:20:00',2.87),('8537','2013-06-21','09:25:00',2.96),('8537','2013-06-21','09:30:00',3.02),('8537','2013-06-21','09:35:00',3.07),('8537','2013-06-21','09:40:00',3.13),('8537','2013-06-21','09:45:00',3.19),('8537','2013-06-21','09:50:00',3.21),('8537','2013-06-21','09:55:00',3.26),('8537','2013-06-21','10:00:00',3.36),('8537','2013-06-21','10:05:00',3.44),('8537','2013-06-21','10:10:00',3.49),('8537','2013-06-21','10:15:00',3.44),('8537','2013-06-21','10:20:00',3.51),('8537','2013-06-21','10:25:00',3.61),('8537','2013-06-21','10:30:00',3.68),('8537','2013-06-21','10:35:00',3.69),('8537','2013-06-21','10:40:00',3.76),('8537','2013-06-21','10:45:00',3.83),('8537','2013-06-21','10:50:00',3.91),('8537','2013-06-21','10:55:00',3.94),('8537','2013-06-21','11:00:00',3.99),('8537','2013-06-21','11:05:00',4.02),('8537','2013-06-21','11:10:00',4.03),('8537','2013-06-21','11:15:00',4.09),('8537','2013-06-21','11:20:00',4.18),('8537','2013-06-21','11:25:00',4.26),('8537','2013-06-21','11:30:00',4.27),('8537','2013-06-21','11:35:00',4.27),('8537','2013-06-21','11:40:00',4.26),('8537','2013-06-21','11:45:00',4.25),('8537','2013-06-21','11:50:00',4.34),('8537','2013-06-21','11:55:00',4.38),('8537','2013-06-21','12:00:00',4.38),('8537','2013-06-21','12:05:00',4.38),('8537','2013-06-21','12:10:00',4.39),('8537','2013-06-21','12:15:00',4.38),('8537','2013-06-21','12:20:00',4.34),('8537','2013-06-21','12:25:00',4.4),('8537','2013-06-21','12:30:00',4.44),('8537','2013-06-21','12:35:00',4.41),('8537','2013-06-21','12:40:00',4.45),('8537','2013-06-21','12:45:00',4.43),('8537','2013-06-21','12:50:00',4.42),('8537','2013-06-21','12:55:00',4.4),('8537','2013-06-21','13:00:00',4.44),('8537','2013-06-21','13:05:00',4.44),('8537','2013-06-21','13:10:00',4.39),('8537','2013-06-21','13:15:00',4.43),('8537','2013-06-21','13:20:00',4.46),('8537','2013-06-21','13:25:00',4.52),('8537','2013-06-21','13:30:00',4.52),('8537','2013-06-21','13:35:00',4.6),('8537','2013-06-21','13:40:00',4.51),('8537','2013-06-21','13:45:00',4.53),('8537','2013-06-21','13:50:00',4.54),('8537','2013-06-21','13:55:00',4.53),('8537','2013-06-21','14:00:00',4.54),('8537','2013-06-21','14:05:00',4.54),('8537','2013-06-21','14:10:00',4.52),('8537','2013-06-21','14:15:00',4.55),('8537','2013-06-21','14:20:00',4.52),('8537','2013-06-21','14:25:00',4.54),('8537','2013-06-21','14:30:00',4.52),('8537','2013-06-21','14:35:00',4.5),('8537','2013-06-21','14:40:00',4.47),('8537','2013-06-21','14:45:00',4.36),('8537','2013-06-21','14:50:00',4.16),('8537','2013-06-21','14:55:00',4.33),('8537','2013-06-21','15:00:00',4.28),('8537','2013-06-21','15:05:00',4.22),('8537','2013-06-21','15:10:00',4.2),('8537','2013-06-21','15:15:00',4.16),('8537','2013-06-21','15:20:00',4.11),('8537','2013-06-21','15:25:00',4.07),('8537','2013-06-21','15:30:00',4.03),('8537','2013-06-21','15:35:00',3.97),('8537','2013-06-21','15:40:00',3.91),('8537','2013-06-21','15:45:00',3.74),('8537','2013-06-21','15:50:00',3.64),('8537','2013-06-21','15:55:00',3.71),('8537','2013-06-21','16:00:00',3.65),('8537','2013-06-21','16:05:00',3.57),('8537','2013-06-21','16:10:00',3.53),('8537','2013-06-21','16:15:00',3.48),('8537','2013-06-21','16:20:00',3.41),('8537','2013-06-21','16:25:00',3.33),('8537','2013-06-21','16:30:00',3.08),('8537','2013-06-21','16:35:00',2.91),('8537','2013-06-21','16:40:00',3.06),('8537','2013-06-21','16:45:00',2.99),('8537','2013-06-21','16:50:00',2.89),('8537','2013-06-21','16:55:00',2.85),('8537','2013-06-21','17:00:00',2.77),('8537','2013-06-21','17:05:00',2.68),('8537','2013-06-21','17:10:00',2.56),('8537','2013-06-21','17:15:00',2.48),('8537','2013-06-21','17:20:00',2.4),('8537','2013-06-21','17:25:00',2.31),('8537','2013-06-21','17:30:00',2.17),('8537','2013-06-21','17:35:00',2.08),('8537','2013-06-21','17:40:00',2.01),('8537','2013-06-21','17:45:00',1.92),('8537','2013-06-21','17:50:00',1.82),('8537','2013-06-21','17:55:00',1.71),('8537','2013-06-21','18:00:00',1.6),('8537','2013-06-21','18:05:00',1.5),('8537','2013-06-21','18:10:00',1.42),('8537','2013-06-21','18:15:00',1.33),('8537','2013-06-21','18:20:00',1.24),('8537','2013-06-21','18:25:00',1.14),('8537','2013-06-21','18:30:00',1.05),('8537','2014-04-04','08:50:00',1.01),('8537','2014-04-04','08:55:00',1.01),('8537','2014-04-04','09:00:00',1.01),('8537','2014-04-04','09:05:00',1.47),('8537','2014-04-04','09:10:00',2.02),('8537','2014-04-04','09:15:00',1.8),('8537','2014-04-04','09:20:00',1.27),('8537','2014-04-04','09:25:00',1.07),('8537','2014-04-04','09:30:00',1.03),('8537','2014-04-04','09:35:00',1.04),('8537','2014-04-04','13:20:00',2.34),('8537','2014-04-04','13:25:00',3.07),('8537','2014-04-04','13:30:00',2.7),('8537','2014-04-04','13:35:00',3.43),('8537','2014-04-04','13:40:00',4.3),('8537','2014-04-04','13:45:00',4.25),('8537','2014-04-04','13:50:00',4.15),('8537','2014-04-04','13:55:00',2.96),('8537','2014-04-04','14:00:00',2.48),('8537','2014-04-04','14:05:00',5.16),('8537','2014-04-04','14:10:00',3.5),('8537','2014-04-04','14:15:00',4.78),('8537','2014-04-04','14:20:00',3.71),('8537','2014-04-04','14:25:00',4.21),('8537','2014-04-04','14:30:00',1.58),('8537','2014-04-04','14:35:00',2.74),('8537','2014-04-04','14:40:00',1.87),('8537','2014-04-04','14:45:00',2.43),('8537','2014-04-04','14:50:00',3.75),('8537','2014-04-04','14:55:00',3.83),('8537','2014-04-04','15:00:00',4.74),('8537','2014-04-04','15:05:00',4.76),('8537','2014-04-04','15:10:00',4.78),('8537','2014-04-04','15:15:00',4),('8537','2014-04-04','15:20:00',2.55),('8537','2014-04-04','15:25:00',2.2),('8537','2014-04-04','15:30:00',2.01),('8537','2014-04-04','15:35:00',2),('8537','2014-04-04','15:40:00',2.82),('8537','2014-04-04','15:45:00',2.48),('8537','2014-04-04','15:50:00',2.07),('8537','2014-04-04','15:55:00',2.9),('8537','2014-04-04','16:00:00',3.12),('8537','2014-04-04','16:05:00',2.02),('8537','2014-04-04','16:10:00',2.74),('8537','2014-04-04','16:15:00',1.96),('8537','2014-04-04','16:20:00',1.23),('8537','2014-04-04','16:25:00',1.14),('8537','2014-04-04','16:30:00',2.2),('8537','2014-04-04','16:35:00',1.84),('8537','2014-04-04','16:40:00',1.51),('8537','2014-04-04','16:45:00',2.92),('8537','2014-04-04','16:50:00',2.84),('8537','2014-04-04','16:55:00',2.22),('8537','2014-04-04','17:00:00',2.13),('8537','2014-04-04','17:05:00',2.13),('8537','2014-04-04','17:10:00',2.26),('8537','2014-04-04','17:15:00',2.27),('8537','2014-04-04','17:20:00',2.17),('8537','2014-04-04','17:25:00',1.87),('8537','2014-04-04','17:30:00',1.84),('8537','2014-04-04','17:35:00',1.46),('8537','2014-04-04','17:40:00',1.27),('8537','2014-04-04','17:45:00',1.52),('8537','2014-04-04','17:50:00',1.48),('8537','2014-04-04','17:55:00',1.33),('8537','2014-04-04','18:00:00',1.16),('8537','2014-04-04','18:05:00',1.02),('8537','2013-06-20','07:40:00',1.02),('8537','2013-06-20','07:45:00',1.13),('8537','2013-06-20','07:50:00',1.26),('8537','2013-06-20','07:55:00',1.39),('8537','2013-06-20','08:00:00',1.51),('8537','2013-06-20','08:05:00',1.6),('8537','2013-06-20','08:10:00',1.73),('8537','2013-06-20','08:15:00',1.81),('8537','2013-06-20','08:20:00',1.92),('8537','2013-06-20','08:25:00',2.02),('8537','2013-06-20','08:30:00',2.12),('8537','2013-06-20','08:35:00',2.22),('8537','2013-06-20','08:40:00',2.31),('8537','2013-06-20','08:45:00',2.4),('8537','2013-06-20','08:50:00',2.48),('8537','2013-06-20','08:55:00',2.56),('8537','2013-06-20','09:00:00',2.64),('8537','2013-06-20','09:05:00',2.72),('8537','2013-06-20','09:10:00',2.8),('8537','2013-06-20','09:15:00',2.86),('8537','2013-06-20','09:20:00',2.95),('8537','2013-06-20','09:25:00',3),('8537','2013-06-20','09:30:00',3.06),('8537','2013-06-20','09:35:00',3.18),('8537','2013-06-20','09:40:00',3.25),('8537','2013-06-20','09:45:00',3.32),('8537','2013-06-20','09:50:00',3.39),('8537','2013-06-20','09:55:00',3.47),('8537','2013-06-20','10:00:00',3.5),('8537','2013-06-20','10:05:00',3.57),('8537','2013-06-20','10:10:00',3.63),('8537','2013-06-20','10:15:00',3.66),('8537','2013-06-20','10:20:00',3.73),('8537','2013-06-20','10:25:00',3.81),('8537','2013-06-20','10:30:00',3.84),('8537','2013-06-20','10:35:00',3.88),('8537','2013-06-20','10:40:00',3.92),('8537','2013-06-20','10:45:00',3.96),('8537','2013-06-20','10:50:00',3.96),('8537','2013-06-20','10:55:00',4.01),('8537','2013-06-20','11:00:00',4.06),('8537','2013-06-20','11:05:00',4.12),('8537','2013-06-20','11:10:00',4.15),('8537','2013-06-20','11:15:00',4.2),('8537','2013-06-20','11:20:00',4.13),('8537','2013-06-20','11:25:00',4.21),('8537','2013-06-20','11:30:00',4.26),('8537','2013-06-20','11:35:00',4.31),('8537','2013-06-20','11:40:00',4.33),('8537','2013-06-20','11:45:00',4.36),('8537','2013-06-20','11:50:00',4.34),('8537','2013-06-20','11:55:00',4.3),('8537','2013-06-20','12:00:00',4.34),('8537','2013-06-20','12:05:00',4.37),('8537','2013-06-20','12:10:00',4.31),('8537','2013-06-20','12:15:00',4.29),('8537','2013-06-20','12:20:00',4.27),('8537','2013-06-20','12:25:00',4.44),('8537','2013-06-20','12:30:00',4.47),('8537','2013-06-20','12:35:00',4.67),('8537','2013-06-20','12:40:00',4.69),('8537','2013-06-20','12:45:00',4.59),('8537','2013-06-20','12:50:00',4.34),('8537','2013-06-20','12:55:00',3.25),('8537','2013-06-20','13:00:00',4.17),('8537','2013-06-20','13:05:00',4.76),('8537','2013-06-20','13:10:00',4.76),('8537','2013-06-20','13:15:00',4.08),('8537','2013-06-20','13:20:00',4.33),('8537','2013-06-20','13:25:00',2.98),('8537','2013-06-20','13:30:00',4.44),('8537','2013-06-20','13:35:00',4.65),('8537','2013-06-20','13:40:00',4.64),('8537','2013-06-20','13:45:00',4.6),('8537','2013-06-20','13:50:00',4.62),('8537','2013-06-20','13:55:00',4.57),('8537','2013-06-20','14:00:00',4.64),('8537','2013-06-20','14:05:00',4.72),('8537','2013-06-20','14:10:00',4.63),('8537','2013-06-20','14:15:00',4.65),('8537','2013-06-20','14:20:00',4.63),('8537','2013-06-20','14:25:00',4.61),('8537','2013-06-20','14:30:00',4.57),('8537','2013-06-20','14:35:00',4.65),('8537','2013-06-20','14:40:00',4.63),('8537','2013-06-20','14:45:00',4.46),('8537','2013-06-20','14:50:00',4.35),('8537','2013-06-20','14:55:00',4.46),('8537','2013-06-20','15:00:00',4.39),('8537','2013-06-20','15:05:00',4.37),('8537','2013-06-20','15:10:00',4.31),('8537','2013-06-20','15:15:00',4.27),('8537','2013-06-20','15:20:00',4.22),('8537','2013-06-20','15:25:00',4.17),('8537','2013-06-20','15:30:00',4.12),('8537','2013-06-20','15:35:00',4.05),('8537','2013-06-20','15:40:00',3.99),('8537','2013-06-20','15:45:00',3.87),('8537','2013-06-20','15:50:00',3.83),('8537','2013-06-20','15:55:00',3.77),('8537','2013-06-20','16:00:00',3.7),('8537','2013-06-20','16:05:00',3.67),('8537','2013-06-20','16:10:00',3.62),('8537','2013-06-20','16:15:00',3.55),('8537','2013-06-20','16:20:00',3.46),('8537','2013-06-20','16:25:00',3.37),('8537','2013-06-20','16:30:00',3.1),('8537','2013-06-20','16:35:00',3),('8537','2013-06-20','16:40:00',3.09),('8537','2013-06-20','16:45:00',3.02),('8537','2013-06-20','16:50:00',2.94),('8537','2013-06-20','16:55:00',2.86),('8537','2013-06-20','17:00:00',2.79),('8537','2013-06-20','17:05:00',2.69),('8537','2013-06-20','17:10:00',2.58),('8537','2013-06-20','17:15:00',2.5),('8537','2013-06-20','17:20:00',2.4),('8537','2013-06-20','17:25:00',2.33),('8537','2013-06-20','17:30:00',2.21),('8537','2013-06-20','17:35:00',2.1),('8537','2013-06-20','17:40:00',2.02),('8537','2013-06-20','17:45:00',1.94),('8537','2013-06-20','17:50:00',1.85),('8537','2013-06-20','17:55:00',1.74),('8537','2013-06-20','18:00:00',1.65),('8537','2013-06-20','18:05:00',1.52),('8537','2013-06-20','18:10:00',1.44),('8537','2013-06-20','18:15:00',1.35),('8537','2013-06-20','18:20:00',1.27),('8537','2013-06-20','18:25:00',1.16),('8537','2013-06-20','18:30:00',1.06),('8537','2013-06-19','07:35:00',1.05),('8537','2013-06-19','07:40:00',1.13),('8537','2013-06-19','07:45:00',1.21),('8537','2013-06-19','07:50:00',1.3),('8537','2013-06-19','07:55:00',1.39),('8537','2013-06-19','08:00:00',1.5),('8537','2013-06-19','08:05:00',1.6),('8537','2013-06-19','08:10:00',1.7),('8537','2013-06-19','08:15:00',1.78),('8537','2013-06-19','08:20:00',1.88),('8537','2013-06-19','08:25:00',1.96),('8537','2013-06-19','08:30:00',2.03),('8537','2013-06-19','08:35:00',2.14),('8537','2013-06-19','08:40:00',2.22),('8537','2013-06-19','08:45:00',2.31),('8537','2013-06-19','08:50:00',2.42),('8537','2013-06-19','08:55:00',2.51),('8537','2013-06-19','09:00:00',2.58),('8537','2013-06-19','09:05:00',2.66),('8537','2013-06-19','09:10:00',2.74),('8537','2013-06-19','09:15:00',2.84),('8537','2013-06-19','09:20:00',2.93),('8537','2013-06-19','09:25:00',2.99),('8537','2013-06-19','09:30:00',3.04),('8537','2013-06-19','09:35:00',3.1),('8537','2013-06-19','09:40:00',3.15),('8537','2013-06-19','09:45:00',3.22),('8537','2013-06-19','09:50:00',3.28),('8537','2013-06-19','09:55:00',3.35),('8537','2013-06-19','10:00:00',3.41),('8537','2013-06-19','10:05:00',3.46),('8537','2013-06-19','10:10:00',3.53),('8537','2013-06-19','10:15:00',3.61),('8537','2013-06-19','10:20:00',3.64),('8537','2013-06-19','10:25:00',3.71),('8537','2013-06-19','10:30:00',3.74),('8537','2013-06-19','10:35:00',3.79),('8537','2013-06-19','10:40:00',3.86),('8537','2013-06-19','10:45:00',3.9),('8537','2013-06-19','10:50:00',3.93),('8537','2013-06-19','10:55:00',3.97),('8537','2013-06-19','11:00:00',3.97),('8537','2013-06-19','11:05:00',3.95),('8537','2013-06-19','11:10:00',4.01),('8537','2013-06-19','11:15:00',4.06),('8537','2013-06-19','11:20:00',4.07),('8537','2013-06-19','11:25:00',4.18),('8537','2013-06-19','11:30:00',4.21),('8537','2013-06-19','11:35:00',4.24),('8537','2013-06-19','11:40:00',4.3),('8537','2013-06-19','11:45:00',4.27),('8537','2013-06-19','11:50:00',4.28),('8537','2013-06-19','11:55:00',4.33),('8537','2013-06-19','12:00:00',4.35),('8537','2013-06-19','12:05:00',4.32),('8537','2013-06-19','12:10:00',4.4),('8537','2013-06-19','12:15:00',4.29),('8537','2013-06-19','12:20:00',4.34),('8537','2013-06-19','12:25:00',4.29),('8537','2013-06-19','12:30:00',4.41),('8537','2013-06-19','12:35:00',4.48),('8537','2013-06-19','12:40:00',4.5),('8537','2013-06-19','12:45:00',4.54),('8537','2013-06-19','12:50:00',4.53),('8537','2013-06-19','12:55:00',4.58),('8537','2013-06-19','13:00:00',4.54),('8537','2013-06-19','13:05:00',4.54),('8537','2013-06-19','13:10:00',4.57),('8537','2013-06-19','13:15:00',4.55),('8537','2013-06-19','13:20:00',4.49),('8537','2013-06-19','13:25:00',4.64),('8537','2013-06-19','13:30:00',4.63),('8537','2013-06-19','13:35:00',4.61),('8537','2013-06-19','13:40:00',4.6),('8537','2013-06-19','13:45:00',4.58),('8537','2013-06-19','13:50:00',4.57),('8537','2013-06-19','13:55:00',4.6),('8537','2013-06-19','14:00:00',4.57),('8537','2013-06-19','14:05:00',4.6),('8537','2013-06-19','14:10:00',4.57),('8537','2013-06-19','14:15:00',4.51),('8537','2013-06-19','14:20:00',4.46),('8537','2013-06-19','14:25:00',4.44),('8537','2013-06-19','14:30:00',4.39),('8537','2013-06-19','14:35:00',4.29),('8537','2013-06-19','14:40:00',4.34),('8537','2013-06-19','14:45:00',4.17),('8537','2013-06-19','14:50:00',4.06),('8537','2013-06-19','14:55:00',4.16),('8537','2013-06-19','15:00:00',4.14),('8537','2013-06-19','15:05:00',4.11),('8537','2013-06-19','15:10:00',4.09),('8537','2013-06-19','15:15:00',4.05),('8537','2013-06-19','15:20:00',4),('8537','2013-06-19','15:25:00',3.95),('8537','2013-06-19','15:30:00',3.9),('8537','2013-06-19','15:35:00',3.85),('8537','2013-06-19','15:40:00',3.79),('8537','2013-06-19','15:45:00',3.6),('8537','2013-06-19','15:50:00',3.52),('8537','2013-06-19','15:55:00',3.55),('8537','2013-06-19','16:00:00',3.49),('8537','2013-06-19','16:05:00',3.43),('8537','2013-06-19','16:10:00',3.37),('8537','2013-06-19','16:15:00',3.31),('8537','2013-06-19','16:20:00',3.23),('8537','2013-06-19','16:25:00',3.19),('8537','2013-06-19','16:30:00',2.92),('8537','2013-06-19','16:35:00',2.82),('8537','2013-06-19','16:40:00',2.93),('8537','2013-06-19','16:45:00',2.87),('8537','2013-06-19','16:50:00',2.82),('8537','2013-06-19','16:55:00',2.75),('8537','2013-06-19','17:00:00',2.68),('8537','2013-06-19','17:05:00',2.56),('8537','2013-06-19','17:10:00',2.49),('8537','2013-06-19','17:15:00',2.41),('8537','2013-06-19','17:20:00',2.37),('8537','2013-06-19','17:25:00',2.3),('8537','2013-06-19','17:30:00',2.14),('8537','2013-06-19','17:35:00',2.02),('8537','2013-06-19','17:40:00',1.97),('8537','2013-06-19','17:45:00',1.89),('8537','2013-06-19','17:50:00',1.78),('8537','2013-06-19','17:55:00',1.67),('8537','2013-06-19','18:00:00',1.59),('8537','2013-06-19','18:05:00',1.46),('8537','2013-06-19','18:10:00',1.38),('8537','2013-06-19','18:15:00',1.28),('8537','2013-06-19','18:20:00',1.2),('8537','2013-06-19','18:25:00',1.1),('8537','2013-06-19','18:30:00',1),('8537','2013-06-18','07:35:00',1.04),('8537','2013-06-18','07:40:00',1.13),('8537','2013-06-18','07:45:00',1.22),('8537','2013-06-18','07:50:00',1.31),('8537','2013-06-18','07:55:00',1.41),('8537','2013-06-18','08:00:00',1.5),('8537','2013-06-18','08:05:00',1.58),('8537','2013-06-18','08:10:00',1.67),('8537','2013-06-18','08:15:00',1.76),('8537','2013-06-18','08:20:00',1.85),('8537','2013-06-18','08:25:00',1.96),('8537','2013-06-18','08:30:00',2.04),('8537','2013-06-18','08:35:00',2.13),('8537','2013-06-18','08:40:00',2.21),('8537','2013-06-18','08:45:00',2.31),('8537','2013-06-18','08:50:00',2.38),('8537','2013-06-18','08:55:00',2.45),('8537','2013-06-18','09:00:00',2.52),('8537','2013-06-18','09:05:00',2.62),('8537','2013-06-18','09:10:00',2.69),('8537','2013-06-18','09:15:00',2.77),('8537','2013-06-18','09:20:00',2.84),('8537','2013-06-18','09:25:00',2.93),('8537','2013-06-18','09:30:00',3.02),('8537','2013-06-18','09:35:00',3.09),('8537','2013-06-18','09:40:00',3.16),('8537','2013-06-18','09:45:00',3.23),('8537','2013-06-18','09:50:00',3.3),('8537','2013-06-18','09:55:00',3.35),('8537','2013-06-18','10:00:00',3.37),('8537','2013-06-18','10:05:00',3.43),('8537','2013-06-18','10:10:00',3.51),('8537','2013-06-18','10:15:00',3.59),('8537','2013-06-18','10:20:00',3.66),('8537','2013-06-18','10:25:00',3.69),('8537','2013-06-18','10:30:00',3.73),('8537','2013-06-18','10:35:00',3.77),('8537','2013-06-18','10:40:00',3.84),('8537','2013-06-18','10:45:00',3.94),('8537','2013-06-18','10:50:00',3.98),('8537','2013-06-18','10:55:00',3.96),('8537','2013-06-18','11:00:00',3.99),('8537','2013-06-18','11:05:00',4.07),('8537','2013-06-18','11:10:00',4.13),('8537','2013-06-18','11:15:00',4.13),('8537','2013-06-18','11:20:00',4.14),('8537','2013-06-18','11:25:00',4.2),('8537','2013-06-18','11:30:00',4.21),('8537','2013-06-18','11:35:00',4.2),('8537','2013-06-18','11:40:00',4.2),('8537','2013-06-18','11:45:00',4.2),('8537','2013-06-18','11:50:00',4.25),('8537','2013-06-18','11:55:00',4.23),('8537','2013-06-18','12:00:00',4.26),('8537','2013-06-18','12:05:00',4.31),('8537','2013-06-18','12:10:00',4.29),('8537','2013-06-18','12:15:00',4.24),('8537','2013-06-18','12:20:00',4.22),('8537','2013-06-18','12:25:00',4.24),('8537','2013-06-18','12:30:00',4.31),('8537','2013-06-18','12:35:00',3.45),('8537','2013-06-18','12:40:00',3.77),('8537','2013-06-18','12:45:00',2.09),('8537','2013-06-18','12:50:00',2.32),('8537','2013-06-18','12:55:00',4.55),('8537','2013-06-18','13:00:00',4.32),('8537','2013-06-18','13:05:00',2.19),('8537','2013-06-18','13:10:00',4.75),('8537','2013-06-18','13:15:00',4.53),('8537','2013-06-18','13:20:00',4.56),('8537','2013-06-18','13:25:00',4.29),('8537','2013-06-18','13:30:00',3.74),('8537','2013-06-18','13:35:00',4.46),('8537','2013-06-18','13:40:00',4.44),('8537','2013-06-18','13:45:00',4.5),('8537','2013-06-18','13:50:00',4.56),('8537','2013-06-18','13:55:00',4.66),('8537','2013-06-18','14:00:00',4.64),('8537','2013-06-18','14:05:00',4.57),('8537','2013-06-18','14:10:00',4.5),('8537','2013-06-18','14:15:00',4.47),('8537','2013-06-18','14:20:00',4.48),('8537','2013-06-18','14:25:00',4.43),('8537','2013-06-18','14:30:00',4.43),('8537','2013-06-18','14:35:00',4.43),('8537','2013-06-18','14:40:00',4.39),('8537','2013-06-18','14:45:00',4.33),('8537','2013-06-18','14:50:00',4.13),('8537','2013-06-18','14:55:00',4.27),('8537','2013-06-18','15:00:00',4.26),('8537','2013-06-18','15:05:00',4.19),('8537','2013-06-18','15:10:00',4.16),('8537','2013-06-18','15:15:00',4.07),('8537','2013-06-18','15:20:00',4),('8537','2013-06-18','15:25:00',4),('8537','2013-06-18','15:30:00',3.92),('8537','2013-06-18','15:35:00',3.9),('8537','2013-06-18','15:40:00',3.87),('8537','2013-06-18','15:45:00',3.7),('8537','2013-06-18','15:50:00',3.55),('8537','2013-06-18','15:55:00',3.7),('8537','2013-06-18','16:00:00',3.69),('8537','2013-06-18','16:05:00',3.64),('8537','2013-06-18','16:10:00',3.56),('8537','2013-06-18','16:15:00',3.53),('8537','2013-06-18','16:20:00',3.48),('8537','2013-06-18','16:25:00',3.3),('8537','2013-06-18','16:30:00',3.13),('8537','2013-06-18','16:35:00',3),('8537','2013-06-18','16:40:00',3.04),('8537','2013-06-18','16:45:00',2.9),('8537','2013-06-18','16:50:00',2.86),('8537','2013-06-18','16:55:00',2.79),('8537','2013-06-18','17:00:00',2.71),('8537','2013-06-18','17:05:00',2.61),('8537','2013-06-18','17:10:00',2.53),('8537','2013-06-18','17:15:00',2.44),('8537','2013-06-18','17:20:00',2.38),('8537','2013-06-18','17:25:00',2.29),('8537','2013-06-18','17:30:00',2.12),('8537','2013-06-18','17:35:00',2.04),('8537','2013-06-18','17:40:00',1.95),('8537','2013-06-18','17:45:00',1.88),('8537','2013-06-18','17:50:00',1.77),('8537','2013-06-18','17:55:00',1.69),('8537','2013-06-18','18:00:00',1.57),('8537','2013-06-18','18:05:00',1.48),('8537','2013-06-18','18:10:00',1.41),('8537','2013-06-18','18:15:00',1.33),('8537','2013-06-18','18:20:00',1.25),('8537','2013-06-18','18:25:00',1.14),('8537','2013-06-18','18:30:00',1.06),('8537','2013-06-17','07:30:00',1),('8537','2013-06-17','07:35:00',1.1),('8537','2013-06-17','07:40:00',1.2),('8537','2013-06-17','07:45:00',1.29),('8537','2013-06-17','07:50:00',1.38),('8537','2013-06-17','07:55:00',1.48),('8537','2013-06-17','08:00:00',1.57),('8537','2013-06-17','08:05:00',1.67),('8537','2013-06-17','08:10:00',1.77),('8537','2013-06-17','08:15:00',1.86),('8537','2013-06-17','08:20:00',1.96),('8537','2013-06-17','08:25:00',2.05),('8537','2013-06-17','08:30:00',2.12),('8537','2013-06-17','08:35:00',2.24),('8537','2013-06-17','08:40:00',2.31),('8537','2013-06-17','08:45:00',2.41),('8537','2013-06-17','08:50:00',2.53),('8537','2013-06-17','08:55:00',2.62),('8537','2013-06-17','09:00:00',2.71),('8537','2013-06-17','09:05:00',2.8),('8537','2013-06-17','09:10:00',2.87),('8537','2013-06-17','09:15:00',2.94),('8537','2013-06-17','09:20:00',3.01),('8537','2013-06-17','09:25:00',3.07),('8537','2013-06-17','09:30:00',3.15),('8537','2013-06-17','09:35:00',3.24),('8537','2013-06-17','09:40:00',3.3),('8537','2013-06-17','09:45:00',3.34),('8537','2013-06-17','09:50:00',3.41),('8537','2013-06-17','09:55:00',3.48),('8537','2013-06-17','10:00:00',3.54),('8537','2013-06-17','10:05:00',3.59),('8537','2013-06-17','10:10:00',3.65),('8537','2013-06-17','10:15:00',3.65),('8537','2013-06-17','10:20:00',3.75),('8537','2013-06-17','10:25:00',3.83),('8537','2013-06-17','10:30:00',3.88),('8537','2013-06-17','10:35:00',3.91),('8537','2013-06-17','10:40:00',3.95),('8537','2013-06-17','10:45:00',4.03),('8537','2013-06-17','10:50:00',4.07),('8537','2013-06-17','10:55:00',4.11),('8537','2013-06-17','11:00:00',4.16),('8537','2013-06-17','11:05:00',4.17),('8537','2013-06-17','11:10:00',4.19),('8537','2013-06-17','11:15:00',4.21),('8537','2013-06-17','11:20:00',4.24),('8537','2013-06-17','11:25:00',4.28),('8537','2013-06-17','11:30:00',4.29),('8537','2013-06-17','11:35:00',4.27),('8537','2013-06-17','11:40:00',4.36),('8537','2013-06-17','11:45:00',4.42),('8537','2013-06-17','11:50:00',4.47),('8537','2013-06-17','11:55:00',4.43),('8537','2013-06-17','12:00:00',4.41),('8537','2013-06-17','12:05:00',4.39),('8537','2013-06-17','12:10:00',4.46),('8537','2013-06-17','12:15:00',4.5),('8537','2013-06-17','12:20:00',4.51),('8537','2013-06-17','12:25:00',4.48),('8537','2013-06-17','12:30:00',4.49),('8537','2013-06-17','12:35:00',4.5),('8537','2013-06-17','12:40:00',4.51),('8537','2013-06-17','12:45:00',4.52),('8537','2013-06-17','12:50:00',4.58),('8537','2013-06-17','12:55:00',4.61),('8537','2013-06-17','13:00:00',4.67),('8537','2013-06-17','13:05:00',4.72),('8537','2013-06-17','13:10:00',4.72),('8537','2013-06-17','13:15:00',4.73),('8537','2013-06-17','13:20:00',4.63),('8537','2013-06-17','13:25:00',4.69),('8537','2013-06-17','13:30:00',4.71),('8537','2013-06-17','13:35:00',4.66),('8537','2013-06-17','13:40:00',4.65),('8537','2013-06-17','13:45:00',4.68),('8537','2013-06-17','13:50:00',4.62),('8537','2013-06-17','13:55:00',4.59),('8537','2013-06-17','14:00:00',4.57),('8537','2013-06-17','14:05:00',4.58),('8537','2013-06-17','14:10:00',4.56),('8537','2013-06-17','14:15:00',4.56),('8537','2013-06-17','14:20:00',4.51),('8537','2013-06-17','14:25:00',4.51),('8537','2013-06-17','14:30:00',4.5),('8537','2013-06-17','14:35:00',4.47),('8537','2013-06-17','14:40:00',4.42),('8537','2013-06-17','14:45:00',4.27),('8537','2013-06-17','14:50:00',4.17),('8537','2013-06-17','14:55:00',4.26),('8537','2013-06-17','15:00:00',4.24),('8537','2013-06-17','15:05:00',4.17),('8537','2013-06-17','15:10:00',4.13),('8537','2013-06-17','15:15:00',4.11),('8537','2013-06-17','15:20:00',4.08),('8537','2013-06-17','15:25:00',4.02),('8537','2013-06-17','15:30:00',3.97),('8537','2013-06-17','15:35:00',3.93),('8537','2013-06-17','15:40:00',3.85),('8537','2013-06-17','15:45:00',3.61),('8537','2013-06-17','15:50:00',3.67),('8537','2013-06-17','15:55:00',3.63),('8537','2013-06-17','16:00:00',3.59),('8537','2013-06-17','16:05:00',3.53),('8537','2013-06-17','16:10:00',3.48),('8537','2013-06-17','16:15:00',3.42),('8537','2013-06-17','16:20:00',3.31),('8537','2013-06-17','16:25:00',3.26),('8537','2013-06-17','16:30:00',3.06),('8537','2013-06-17','16:35:00',3.08),('8537','2013-06-17','16:40:00',3.01),('8537','2013-06-17','16:45:00',2.94),('8537','2013-06-17','16:50:00',2.88),('8537','2013-06-17','16:55:00',2.8),('8537','2013-06-17','17:00:00',2.73),('8537','2013-06-17','17:05:00',2.64),('8537','2013-06-17','17:10:00',2.55),('8537','2013-06-17','17:15:00',2.47),('8537','2013-06-17','17:20:00',2.4),('8537','2013-06-17','17:25:00',2.33),('8537','2013-06-17','17:30:00',2.17),('8537','2013-06-17','17:35:00',2.1),('8537','2013-06-17','17:40:00',2.02),('8537','2013-06-17','17:45:00',1.94),('8537','2013-06-17','17:50:00',1.84),('8537','2013-06-17','17:55:00',1.73),('8537','2013-06-17','18:00:00',1.62),('8537','2013-06-17','18:05:00',1.52),('8537','2013-06-17','18:10:00',1.46),('8537','2013-06-17','18:15:00',1.38),('8537','2013-06-17','18:20:00',1.29),('8537','2013-06-17','18:25:00',1.14),('8537','2013-06-17','18:30:00',1.11),('8537','2013-06-16','07:30:00',1.04),('8537','2013-06-16','07:35:00',1.14),('8537','2013-06-16','07:40:00',1.23),('8537','2013-06-16','07:45:00',1.32),('8537','2013-06-16','07:50:00',1.41),('8537','2013-06-16','07:55:00',1.51),('8537','2013-06-16','08:00:00',1.6),('8537','2013-06-16','08:05:00',1.7),('8537','2013-06-16','08:10:00',1.8),('8537','2013-06-16','08:15:00',1.89),('8537','2013-06-16','08:20:00',1.99),('8537','2013-06-16','08:25:00',2.09),('8537','2013-06-16','08:30:00',2.17),('8537','2013-06-16','08:35:00',2.3),('8537','2013-06-16','08:40:00',2.39),('8537','2013-06-16','08:45:00',2.48),('8537','2013-06-16','08:50:00',2.56),('8537','2013-06-16','08:55:00',2.63),('8537','2013-06-16','09:00:00',2.72),('8537','2013-06-16','09:05:00',2.79),('8537','2013-06-16','09:10:00',2.9),('8537','2013-06-16','09:15:00',3),('8537','2013-06-16','09:20:00',3.07),('8537','2013-06-16','09:25:00',3.14),('8537','2013-06-16','09:30:00',3.22),('8537','2013-06-16','09:35:00',3.3),('8537','2013-06-16','09:40:00',3.31),('8537','2013-06-16','09:45:00',3.38),('8537','2013-06-16','09:50:00',3.44),('8537','2013-06-16','09:55:00',3.47),('8537','2013-06-16','10:00:00',3.59),('8537','2013-06-16','10:05:00',3.67),('8537','2013-06-16','10:10:00',3.72),('8537','2013-06-16','10:15:00',3.78),('8537','2013-06-16','10:20:00',3.88),('8537','2013-06-16','10:25:00',3.88),('8537','2013-06-16','10:30:00',3.94),('8537','2013-06-16','10:35:00',3.99),('8537','2013-06-16','10:40:00',4.04),('8537','2013-06-16','10:45:00',4.11),('8537','2013-06-16','10:50:00',4.1),('8537','2013-06-16','10:55:00',4.16),('8537','2013-06-16','11:00:00',4.2),('8537','2013-06-16','11:05:00',4.28),('8537','2013-06-16','11:10:00',4.27),('8537','2013-06-16','11:15:00',4.33),('8537','2013-06-16','11:20:00',4.36),('8537','2013-06-16','11:25:00',4.44),('8537','2013-06-16','11:30:00',4.44),('8537','2013-06-16','11:35:00',4.51),('8537','2013-06-16','11:40:00',4.48),('8537','2013-06-16','11:45:00',4.53),('8537','2013-06-16','11:50:00',4.53),('8537','2013-06-16','11:55:00',4.62),('8537','2013-06-16','12:00:00',4.67),('8537','2013-06-16','12:05:00',4.64),('8537','2013-06-16','12:10:00',4.68),('8537','2013-06-16','12:15:00',4.7),('8537','2013-06-16','12:20:00',4.72),('8537','2013-06-16','12:25:00',4.72),('8537','2013-06-16','12:30:00',4.71),('8537','2013-06-16','12:35:00',4.74),('8537','2013-06-16','12:40:00',4.75),('8537','2013-06-16','12:45:00',4.74),('8537','2013-06-16','12:50:00',4.72),('8537','2013-06-16','12:55:00',4.74),('8537','2013-06-16','13:00:00',4.83),('8537','2013-06-16','13:05:00',4.89),('8537','2013-06-16','13:10:00',4.86),('8537','2013-06-16','13:15:00',4.83),('8537','2013-06-16','13:20:00',4.8),('8537','2013-06-16','13:25:00',4.85),('8537','2013-06-16','13:30:00',4.8),('8537','2013-06-16','13:35:00',4.84),('8537','2013-06-16','13:40:00',4.84),('8537','2013-06-16','13:45:00',4.78),('8537','2013-06-16','13:50:00',4.77),('8537','2013-06-16','13:55:00',4.75),('8537','2013-06-16','14:00:00',4.75),('8537','2013-06-16','14:05:00',4.69),('8537','2013-06-16','14:10:00',4.73),('8537','2013-06-16','14:15:00',4.7),('8537','2013-06-16','14:20:00',4.69),('8537','2013-06-16','14:25:00',4.64),('8537','2013-06-16','14:30:00',4.61),('8537','2013-06-16','14:35:00',4.55),('8537','2013-06-16','14:40:00',4.51),('8537','2013-06-16','14:45:00',4.32),('8537','2013-06-16','14:50:00',4.28),('8537','2013-06-16','14:55:00',4.36),('8537','2013-06-16','15:00:00',4.32),('8537','2013-06-16','15:05:00',4.3),('8537','2013-06-16','15:10:00',4.25),('8537','2013-06-16','15:15:00',4.21),('8537','2013-06-16','15:20:00',4.17),('8537','2013-06-16','15:25:00',4.14),('8537','2013-06-16','15:30:00',4.07),('8537','2013-06-16','15:35:00',4.03),('8537','2013-06-16','15:40:00',3.97),('8537','2013-06-16','15:45:00',3.86),('8537','2013-06-16','15:50:00',3.8),('8537','2013-06-16','15:55:00',3.74),('8537','2013-06-16','16:00:00',3.67),('8537','2013-06-16','16:05:00',3.62),('8537','2013-06-16','16:10:00',3.56),('8537','2013-06-16','16:15:00',3.5),('8537','2013-06-16','16:20:00',3.41),('8537','2013-06-16','16:25:00',3.34),('8537','2013-06-16','16:30:00',3.14),('8537','2013-06-16','16:35:00',3.16),('8537','2013-06-16','16:40:00',3.1),('8537','2013-06-16','16:45:00',3.02),('8537','2013-06-16','16:50:00',2.93),('8537','2013-06-16','16:55:00',2.85),('8537','2013-06-16','17:00:00',2.78),('8537','2013-06-16','17:05:00',2.68),('8537','2013-06-16','17:10:00',2.56),('8537','2013-06-16','17:15:00',2.49),('8537','2013-06-16','17:20:00',2.41),('8537','2013-06-16','17:25:00',2.31),('8537','2013-06-16','17:30:00',2.15),('8537','2013-06-16','17:35:00',2.07),('8537','2013-06-16','17:40:00',1.99),('8537','2013-06-16','17:45:00',1.9),('8537','2013-06-16','17:50:00',1.8),('8537','2013-06-16','17:55:00',1.68),('8537','2013-06-16','18:00:00',1.58),('8537','2013-06-16','18:05:00',1.48),('8537','2013-06-16','18:10:00',1.4),('8537','2013-06-16','18:15:00',1.31),('8537','2013-06-16','18:20:00',1.22),('8537','2013-06-16','18:25:00',1.12),('8537','2013-06-16','18:30:00',1.04),('8537','2013-06-15','07:35:00',1.09),('8537','2013-06-15','07:40:00',1.18),('8537','2013-06-15','07:45:00',1.29),('8537','2013-06-15','07:50:00',1.38),('8537','2013-06-15','07:55:00',1.47),('8537','2013-06-15','08:00:00',1.56),('8537','2013-06-15','08:05:00',1.67),('8537','2013-06-15','08:10:00',1.76),('8537','2013-06-15','08:15:00',1.88),('8537','2013-06-15','08:20:00',2),('8537','2013-06-15','08:25:00',2.05),('8537','2013-06-15','08:30:00',1.97),('8537','2013-06-15','08:35:00',2.13),('8537','2013-06-15','08:40:00',2.36),('8537','2013-06-15','08:45:00',2.45),('8537','2013-06-15','08:50:00',2.47),('8537','2013-06-15','08:55:00',2.62),('8537','2013-06-15','09:00:00',2.7),('8537','2013-06-15','09:05:00',2.83),('8537','2013-06-15','09:10:00',2.86),('8537','2013-06-15','09:15:00',2.84),('8537','2013-06-15','09:20:00',2.2),('8537','2013-06-15','09:25:00',3),('8537','2013-06-15','09:30:00',3.16),('8537','2013-06-15','09:35:00',3.08),('8537','2013-06-15','09:40:00',3.27),('8537','2013-06-15','09:45:00',3.07),('8537','2013-06-15','09:50:00',3.16),('8537','2013-06-15','09:55:00',3.58),('8537','2013-06-15','10:00:00',3.72),('8537','2013-06-15','10:05:00',3.79),('8537','2013-06-15','10:10:00',2.57),('8537','2013-06-15','10:15:00',1.46),('8537','2013-06-15','10:20:00',2.35),('8537','2013-06-15','10:25:00',3.29),('8537','2013-06-15','10:30:00',4.06),('8537','2013-06-15','10:35:00',3.74),('8537','2013-06-15','10:40:00',4.16),('8537','2013-06-15','10:45:00',4.19),('8537','2013-06-15','10:50:00',4.52),('8537','2013-06-15','10:55:00',4.2),('8537','2013-06-15','11:00:00',2.09),('8537','2013-06-15','11:05:00',1.65),('8537','2013-06-15','11:10:00',2.65),('8537','2013-06-15','11:15:00',4.64),('8537','2013-06-15','11:20:00',3.71),('8537','2013-06-15','11:25:00',2.51),('8537','2013-06-15','11:30:00',3.09),('8537','2013-06-15','11:35:00',4.64),('8537','2013-06-15','11:40:00',4.96),('8537','2013-06-15','11:45:00',4.72),('8537','2013-06-15','11:50:00',3.94),('8537','2013-06-15','11:55:00',4.89),('8537','2013-06-15','12:00:00',4.83),('8537','2013-06-15','12:05:00',4.78),('8537','2013-06-15','12:10:00',4.79),('8537','2013-06-15','12:15:00',4.93),('8537','2013-06-15','12:20:00',4.86),('8537','2013-06-15','12:25:00',4.74),('8537','2013-06-15','12:30:00',4.79),('8537','2013-06-15','12:35:00',4.86),('8537','2013-06-15','12:40:00',4.8),('8537','2013-06-15','12:45:00',4.86),('8537','2013-06-15','12:50:00',4.78),('8537','2013-06-15','12:55:00',4.84),('8537','2013-06-15','13:00:00',4.83),('8537','2013-06-15','13:05:00',4.86),('8537','2013-06-15','13:10:00',4.86),('8537','2013-06-15','13:15:00',4.89),('8537','2013-06-15','13:20:00',4.86),('8537','2013-06-15','13:25:00',4.82),('8537','2013-06-15','13:30:00',4.81),('8537','2013-06-15','13:35:00',4.73),('8537','2013-06-15','13:40:00',4.79),('8537','2013-06-15','13:45:00',4.77),('8537','2013-06-15','13:50:00',4.76),('8537','2013-06-15','13:55:00',4.75),('8537','2013-06-15','14:00:00',4.76),('8537','2013-06-15','14:05:00',4.73),('8537','2013-06-15','14:10:00',4.72),('8537','2013-06-15','14:15:00',4.7),('8537','2013-06-15','14:20:00',4.66),('8537','2013-06-15','14:25:00',4.64),('8537','2013-06-15','14:30:00',4.55),('8537','2013-06-15','14:35:00',4.54),('8537','2013-06-15','14:40:00',4.53),('8537','2013-06-15','14:45:00',4.32),('8537','2013-06-15','14:50:00',4.25),('8537','2013-06-15','14:55:00',4.36),('8537','2013-06-15','15:00:00',4.29),('8537','2013-06-15','15:05:00',4.24),('8537','2013-06-15','15:10:00',4.2),('8537','2013-06-15','15:15:00',4.19),('8537','2013-06-15','15:20:00',4.14),('8537','2013-06-15','15:25:00',4.13),('8537','2013-06-15','15:30:00',4.11),('8537','2013-06-15','15:35:00',4.06),('8537','2013-06-15','15:40:00',3.97),('8537','2013-06-15','15:45:00',3.7),('8537','2013-06-15','15:50:00',3.75),('8537','2013-06-15','15:55:00',3.76),('8537','2013-06-15','16:00:00',3.7),('8537','2013-06-15','16:05:00',3.62),('8537','2013-06-15','16:10:00',3.54),('8537','2013-06-15','16:15:00',3.48),('8537','2013-06-15','16:20:00',3.41),('8537','2013-06-15','16:25:00',3.3),('8537','2013-06-15','16:30:00',2.98),('8537','2013-06-15','16:35:00',3.02),('8537','2013-06-15','16:40:00',3.07),('8537','2013-06-15','16:45:00',3.01),('8537','2013-06-15','16:50:00',2.92),('8537','2013-06-15','16:55:00',2.84),('8537','2013-06-15','17:00:00',2.78),('8537','2013-06-15','17:05:00',2.64),('8537','2013-06-15','17:10:00',2.56),('8537','2013-06-15','17:15:00',2.47),('8537','2013-06-15','17:20:00',2.39),('8537','2013-06-15','17:25:00',2.29),('8537','2013-06-15','17:30:00',2.1),('8537','2013-06-15','17:35:00',2.05),('8537','2013-06-15','17:40:00',1.98),('8537','2013-06-15','17:45:00',1.86),('8537','2013-06-15','17:50:00',1.75),('8537','2013-06-15','17:55:00',1.65),('8537','2013-06-15','18:00:00',1.55),('8537','2013-06-15','18:05:00',1.46),('8537','2013-06-15','18:10:00',1.38),('8537','2013-06-15','18:15:00',1.3),('8537','2013-06-15','18:20:00',1.18),('8537','2013-06-15','18:25:00',1.1),('8537','2013-06-15','18:30:00',1.01),('8537','2013-06-14','07:25:00',1),('8537','2013-06-14','07:30:00',1.1),('8537','2013-06-14','07:35:00',1.21),('8537','2013-06-14','07:40:00',1.31),('8537','2013-06-14','07:45:00',1.41),('8537','2013-06-14','07:50:00',1.51),('8537','2013-06-14','07:55:00',1.61),('8537','2013-06-14','08:00:00',1.72),('8537','2013-06-14','08:05:00',1.82),('8537','2013-06-14','08:10:00',1.93),('8537','2013-06-14','08:15:00',2.03),('8537','2013-06-14','08:20:00',2.13),('8537','2013-06-14','08:25:00',2.23),('8537','2013-06-14','08:30:00',2.28),('8537','2013-06-14','08:35:00',2.42),('8537','2013-06-14','08:40:00',2.51),('8537','2013-06-14','08:45:00',2.62),('8537','2013-06-14','08:50:00',2.68),('8537','2013-06-14','08:55:00',2.75),('8537','2013-06-14','09:00:00',2.85),('8537','2013-06-14','09:05:00',2.93),('8537','2013-06-14','09:10:00',3.02),('8537','2013-06-14','09:15:00',3.1),('8537','2013-06-14','09:20:00',3.17),('8537','2013-06-14','09:25:00',3.24),('8537','2013-06-14','09:30:00',3.32),('8537','2013-06-14','09:35:00',3.42),('8537','2013-06-14','09:40:00',3.52),('8537','2013-06-14','09:45:00',3.58),('8537','2013-06-14','09:50:00',3.66),('8537','2013-06-14','09:55:00',3.72),('8537','2013-06-14','10:00:00',3.82),('8537','2013-06-14','10:05:00',3.85),('8537','2013-06-14','10:10:00',3.87),('8537','2013-06-14','10:15:00',3.89),('8537','2013-06-14','10:20:00',3.97),('8537','2013-06-14','10:25:00',4.02),('8537','2013-06-14','10:30:00',4.07),('8537','2013-06-14','10:35:00',4.19),('8537','2013-06-14','10:40:00',4.23),('8537','2013-06-14','10:45:00',4.3),('8537','2013-06-14','10:50:00',4.3),('8537','2013-06-14','10:55:00',4.28),('8537','2013-06-14','11:00:00',4.31),('8537','2013-06-14','11:05:00',4.37),('8537','2013-06-14','11:10:00',4.42),('8537','2013-06-14','11:15:00',4.5),('8537','2013-06-14','11:20:00',4.52),('8537','2013-06-14','11:25:00',4.48),('8537','2013-06-14','11:30:00',4.62),('8537','2013-06-14','11:35:00',4.64),('8537','2013-06-14','11:40:00',4.69),('8537','2013-06-14','11:45:00',4.7),('8537','2013-06-14','11:50:00',4.74),('8537','2013-06-14','11:55:00',4.71),('8537','2013-06-14','12:00:00',4.69),('8537','2013-06-14','12:05:00',4.71),('8537','2013-06-14','12:10:00',4.73),('8537','2013-06-14','12:15:00',4.75),('8537','2013-06-14','12:20:00',4.86),('8537','2013-06-14','12:25:00',4.84),('8537','2013-06-14','12:30:00',4.8),('8537','2013-06-14','12:35:00',4.82),('8537','2013-06-14','12:40:00',4.83),('8537','2013-06-14','12:45:00',4.83),('8537','2013-06-14','12:50:00',4.78),('8537','2013-06-14','12:55:00',4.76),('8537','2013-06-14','13:00:00',4.77),('8537','2013-06-14','13:05:00',4.8),('8537','2013-06-14','13:10:00',4.73),('8537','2013-06-14','13:15:00',4.77),('8537','2013-06-14','13:20:00',4.87),('8537','2013-06-14','13:25:00',4.53),('8537','2013-06-14','13:30:00',4.88),('8537','2013-06-14','13:35:00',4.82),('8537','2013-06-14','13:40:00',4.77),('8537','2013-06-14','13:45:00',4.79),('8537','2013-06-14','13:50:00',4.87),('8537','2013-06-14','13:55:00',4.8),('8537','2013-06-14','14:00:00',4.76),('8537','2013-06-14','14:05:00',4.82),('8537','2013-06-14','14:10:00',4.82),('8537','2013-06-14','14:15:00',4.74),('8537','2013-06-14','14:20:00',4.67),('8537','2013-06-14','14:25:00',4.67),('8537','2013-06-14','14:30:00',4.66),('8537','2013-06-14','14:35:00',4.54),('8537','2013-06-14','14:40:00',4.56),('8537','2013-06-14','14:45:00',4.33),('8537','2013-06-14','14:50:00',4.31),('8537','2013-06-14','14:55:00',4.44),('8537','2013-06-14','15:00:00',4.4),('8537','2013-06-14','15:05:00',4.34),('8537','2013-06-14','15:10:00',4.35),('8537','2013-06-14','15:15:00',4.31),('8537','2013-06-14','15:20:00',4.25),('8537','2013-06-14','15:25:00',4.18),('8537','2013-06-14','15:30:00',4.16),('8537','2013-06-14','15:35:00',4.11),('8537','2013-06-14','15:40:00',4.04),('8537','2013-06-14','15:45:00',3.79),('8537','2013-06-14','15:50:00',3.87),('8537','2013-06-14','15:55:00',3.81),('8537','2013-06-14','16:00:00',3.73),('8537','2013-06-14','16:05:00',3.68),('8537','2013-06-14','16:10:00',3.62),('8537','2013-06-14','16:15:00',3.54),('8537','2013-06-14','16:20:00',3.47),('8537','2013-06-14','16:25:00',3.36),('8537','2013-06-14','16:30:00',2.98),('8537','2013-06-14','16:35:00',3.08),('8537','2013-06-14','16:40:00',3.1),('8537','2013-06-14','16:45:00',3.04),('8537','2013-06-14','16:50:00',2.97),('8537','2013-06-14','16:55:00',2.89),('8537','2013-06-14','17:00:00',2.82),('8537','2013-06-14','17:05:00',2.63),('8537','2013-06-14','17:10:00',2.59),('8537','2013-06-14','17:15:00',2.56),('8537','2013-06-14','17:20:00',2.44),('8537','2013-06-14','17:25:00',2.33),('8537','2013-06-14','17:30:00',2.13),('8537','2013-06-14','17:35:00',2.08),('8537','2013-06-14','17:40:00',2.04),('8537','2013-06-14','17:45:00',1.95),('8537','2013-06-14','17:50:00',1.85),('8537','2013-06-14','17:55:00',1.74),('8537','2013-06-14','18:00:00',1.61),('8537','2013-06-14','18:05:00',1.54),('8537','2013-06-14','18:10:00',1.44),('8537','2013-06-14','18:15:00',1.36),('8537','2013-06-14','18:20:00',1.26),('8537','2013-06-14','18:25:00',1.15),('8537','2013-06-14','18:30:00',1.06),('8537','2013-06-13','07:25:00',1.01),('8537','2013-06-13','07:30:00',1.12),('8537','2013-06-13','07:35:00',1.22),('8537','2013-06-13','07:40:00',1.33),('8537','2013-06-13','07:45:00',1.42),('8537','2013-06-13','07:50:00',1.54),('8537','2013-06-13','07:55:00',1.64),('8537','2013-06-13','08:00:00',1.75),('8537','2013-06-13','08:05:00',1.85),('8537','2013-06-13','08:10:00',1.96),('8537','2013-06-13','08:15:00',2.05),('8537','2013-06-13','08:20:00',2.14),('8537','2013-06-13','08:25:00',2.21),('8537','2013-06-13','08:30:00',2.3),('8537','2013-06-13','08:35:00',2.41),('8537','2013-06-13','08:40:00',2.51),('8537','2013-06-13','08:45:00',2.6),('8537','2013-06-13','08:50:00',2.69),('8537','2013-06-13','08:55:00',2.78),('8537','2013-06-13','09:00:00',2.86),('8537','2013-06-13','09:05:00',2.97),('8537','2013-06-13','09:10:00',3.06),('8537','2013-06-13','09:15:00',3.18),('8537','2013-06-13','09:20:00',3.3),('8537','2013-06-13','09:25:00',3.4),('8537','2013-06-13','09:30:00',3.48),('8537','2013-06-13','09:35:00',3.54),('8537','2013-06-13','09:40:00',3.62),('8537','2013-06-13','09:45:00',3.69),('8537','2013-06-13','09:50:00',3.76),('8537','2013-06-13','09:55:00',3.83),('8537','2013-06-13','10:00:00',3.9),('8537','2013-06-13','10:05:00',3.98),('8537','2013-06-13','10:10:00',4.03),('8537','2013-06-13','10:15:00',4.09),('8537','2013-06-13','10:20:00',4.13),('8537','2013-06-13','10:25:00',4.18),('8537','2013-06-13','10:30:00',4.24),('8537','2013-06-13','10:35:00',4.31),('8537','2013-06-13','10:40:00',4.35),('8537','2013-06-13','10:45:00',4.47),('8537','2013-06-13','10:50:00',4.42),('8537','2013-06-13','10:55:00',4.55),('8537','2013-06-13','11:00:00',4.56),('8537','2013-06-13','11:05:00',4.64),('8537','2013-06-13','11:10:00',4.65),('8537','2013-06-13','11:15:00',4.71),('8537','2013-06-13','11:20:00',4.73),('8537','2013-06-13','11:25:00',4.8),('8537','2013-06-13','11:30:00',4.84),('8537','2013-06-13','11:35:00',4.88),('8537','2013-06-13','11:40:00',4.9),('8537','2013-06-13','11:45:00',4.94),('8537','2013-06-13','11:50:00',4.96),('8537','2013-06-13','11:55:00',4.94),('8537','2013-06-13','12:00:00',4.97),('8537','2013-06-13','12:05:00',5.01),('8537','2013-06-13','12:10:00',5.04),('8537','2013-06-13','12:15:00',5.07),('8537','2013-06-13','12:20:00',5.08),('8537','2013-06-13','12:25:00',5.11),('8537','2013-06-13','12:30:00',5.14),('8537','2013-06-13','12:35:00',5.12),('8537','2013-06-13','12:40:00',5.14),('8537','2013-06-13','12:45:00',5.15),('8537','2013-06-13','12:50:00',5.15),('8537','2013-06-13','12:55:00',5.13),('8537','2013-06-13','13:00:00',5.15),('8537','2013-06-13','13:05:00',5.16),('8537','2013-06-13','13:10:00',5.16),('8537','2013-06-13','13:15:00',5.15),('8537','2013-06-13','13:20:00',5.1),('8537','2013-06-13','13:25:00',5.09),('8537','2013-06-13','13:30:00',5.08),('8537','2013-06-13','13:35:00',5.1),('8537','2013-06-13','13:40:00',5.1),('8537','2013-06-13','13:45:00',5.06),('8537','2013-06-13','13:50:00',4.98),('8537','2013-06-13','13:55:00',5.01),('8537','2013-06-13','14:00:00',4.99),('8537','2013-06-13','14:05:00',4.98),('8537','2013-06-13','14:10:00',4.95),('8537','2013-06-13','14:15:00',4.97),('8537','2013-06-13','14:20:00',4.95),('8537','2013-06-13','14:25:00',5.02),('8537','2013-06-13','14:30:00',3.44),('8537','2013-06-13','14:35:00',3.47),('8537','2013-06-13','14:40:00',4.83),('8537','2013-06-13','14:45:00',4.63),('8537','2013-06-13','14:50:00',4.34),('8537','2013-06-13','14:55:00',4.58),('8537','2013-06-13','15:00:00',4.55),('8537','2013-06-13','15:05:00',4.47),('8537','2013-06-13','15:10:00',4.44),('8537','2013-06-13','15:15:00',4.39),('8537','2013-06-13','15:20:00',4.35),('8537','2013-06-13','15:25:00',4.28),('8537','2013-06-13','15:30:00',4.23),('8537','2013-06-13','15:35:00',4.19),('8537','2013-06-13','15:40:00',4.1),('8537','2013-06-13','15:45:00',3.78),('8537','2013-06-13','15:50:00',3.94),('8537','2013-06-13','15:55:00',3.91),('8537','2013-06-13','16:00:00',3.82),('8537','2013-06-13','16:05:00',3.75),('8537','2013-06-13','16:10:00',3.67),('8537','2013-06-13','16:15:00',3.59),('8537','2013-06-13','16:20:00',3.51),('8537','2013-06-13','16:25:00',3.36),('8537','2013-06-13','16:30:00',3.02),('8537','2013-06-13','16:35:00',3.22),('8537','2013-06-13','16:40:00',3.15),('8537','2013-06-13','16:45:00',3.07),('8537','2013-06-13','16:50:00',2.93),('8537','2013-06-13','16:55:00',2.88),('8537','2013-06-13','17:00:00',2.79),('8537','2013-06-13','17:05:00',2.62),('8537','2013-06-13','17:10:00',2.58),('8537','2013-06-13','17:15:00',2.52),('8537','2013-06-13','17:20:00',2.43),('8537','2013-06-13','17:25:00',2.34),('8537','2013-06-13','17:30:00',2.17),('8537','2013-06-13','17:35:00',2.11),('8537','2013-06-13','17:40:00',2.02),('8537','2013-06-13','17:45:00',1.93),('8537','2013-06-13','17:50:00',1.83),('8537','2013-06-13','17:55:00',1.72),('8537','2013-06-13','18:00:00',1.58),('8537','2013-06-13','18:05:00',1.5),('8537','2013-06-13','18:10:00',1.38),('8537','2013-06-13','18:15:00',1.33),('8537','2013-06-13','18:20:00',1.24),('8537','2013-06-13','18:25:00',1.13),('8537','2013-06-13','18:30:00',1.05),('8537','2013-06-12','07:25:00',1.03),('8537','2013-06-12','07:30:00',1.13),('8537','2013-06-12','07:35:00',1.23),('8537','2013-06-12','07:40:00',1.33),('8537','2013-06-12','07:45:00',1.43),('8537','2013-06-12','07:50:00',1.53),('8537','2013-06-12','07:55:00',1.64),('8537','2013-06-12','08:00:00',1.75),('8537','2013-06-12','08:05:00',1.85),('8537','2013-06-12','08:10:00',1.97),('8537','2013-06-12','08:15:00',2.08),('8537','2013-06-12','08:20:00',2.19),('8537','2013-06-12','08:25:00',2.3),('8537','2013-06-12','08:30:00',2.4),('8537','2013-06-12','08:35:00',2.49),('8537','2013-06-12','08:40:00',2.6),('8537','2013-06-12','08:45:00',2.71),('8537','2013-06-12','08:50:00',2.81),('8537','2013-06-12','08:55:00',2.9),('8537','2013-06-12','09:00:00',2.98),('8537','2013-06-12','09:05:00',3.07),('8537','2013-06-12','09:10:00',3.18),('8537','2013-06-12','09:15:00',3.27),('8537','2013-06-12','09:20:00',3.35),('8537','2013-06-12','09:25:00',3.43),('8537','2013-06-12','09:30:00',3.5),('8537','2013-06-12','09:35:00',3.58),('8537','2013-06-12','09:40:00',3.65),('8537','2013-06-12','09:45:00',3.73),('8537','2013-06-12','09:50:00',3.81),('8537','2013-06-12','09:55:00',3.89),('8537','2013-06-12','10:00:00',3.93),('8537','2013-06-12','10:05:00',3.98),('8537','2013-06-12','10:10:00',4.02),('8537','2013-06-12','10:15:00',4.1),('8537','2013-06-12','10:20:00',4.21),('8537','2013-06-12','10:25:00',4.26),('8537','2013-06-12','10:30:00',4.31),('8537','2013-06-12','10:35:00',4.32),('8537','2013-06-12','10:40:00',4.37),('8537','2013-06-12','10:45:00',4.44),('8537','2013-06-12','10:50:00',4.55),('8537','2013-06-12','10:55:00',4.62),('8537','2013-06-12','11:00:00',4.69),('8537','2013-06-12','11:05:00',4.7),('8537','2013-06-12','11:10:00',4.76),('8537','2013-06-12','11:15:00',4.79),('8537','2013-06-12','11:20:00',4.82),('8537','2013-06-12','11:25:00',4.84),('8537','2013-06-12','11:30:00',4.87),('8537','2013-06-12','11:35:00',4.89),('8537','2013-06-12','11:40:00',4.94),('8537','2013-06-12','11:45:00',4.95),('8537','2013-06-12','11:50:00',5),('8537','2013-06-12','11:55:00',5.08),('8537','2013-06-12','12:00:00',5.04),('8537','2013-06-12','12:05:00',5.09),('8537','2013-06-12','12:10:00',5.07),('8537','2013-06-12','12:15:00',5.1),('8537','2013-06-12','12:20:00',5.08),('8537','2013-06-12','12:25:00',4.8),('8537','2013-06-12','12:30:00',3.85),('8537','2013-06-12','12:35:00',5.48),('8537','2013-06-12','12:40:00',2.73),('8537','2013-06-12','12:45:00',3.73),('8537','2013-06-12','12:50:00',5.66),('8537','2013-06-12','12:55:00',3.6),('8537','2013-06-12','13:00:00',4.64),('8537','2013-06-12','13:05:00',4.09),('8537','2013-06-12','13:10:00',5.32),('8537','2013-06-12','13:15:00',5.17),('8537','2013-06-12','13:20:00',5.11),('8537','2013-06-12','13:25:00',5.02),('8537','2013-06-12','13:30:00',5.03),('8537','2013-06-12','13:35:00',5.14),('8537','2013-06-12','13:40:00',5.13),('8537','2013-06-12','13:45:00',5.15),('8537','2013-06-12','13:50:00',5.13),('8537','2013-06-12','13:55:00',5.22),('8537','2013-06-12','14:00:00',4.93),('8537','2013-06-12','14:05:00',2.88),('8537','2013-06-12','14:10:00',3.75),('8537','2013-06-12','14:15:00',5.26),('8537','2013-06-12','14:20:00',2.63),('8537','2013-06-12','14:25:00',2.33),('8537','2013-06-12','14:30:00',5.24),('8537','2013-06-12','14:35:00',4.91),('8537','2013-06-12','14:40:00',5.02),('8537','2013-06-12','14:45:00',4.58),('8537','2013-06-12','14:50:00',4.9),('8537','2013-06-12','14:55:00',4.92),('8537','2013-06-12','15:00:00',4.8),('8537','2013-06-12','15:05:00',4.42),('8537','2013-06-12','15:10:00',4.62),('8537','2013-06-12','15:15:00',3.58),('8537','2013-06-12','15:20:00',4.57),('8537','2013-06-12','15:25:00',4.32),('8537','2013-06-12','15:30:00',4.31),('8537','2013-06-12','15:35:00',4.31),('8537','2013-06-12','15:40:00',4.18),('8537','2013-06-12','15:45:00',3.92),('8537','2013-06-12','15:50:00',3.99),('8537','2013-06-12','15:55:00',4),('8537','2013-06-12','16:00:00',3.93),('8537','2013-06-12','16:05:00',3.67),('8537','2013-06-12','16:10:00',3.81),('8537','2013-06-12','16:15:00',3.73),('8537','2013-06-12','16:20:00',3.6),('8537','2013-06-12','16:25:00',3.5),('8537','2013-06-12','16:30:00',3.12),('8537','2013-06-12','16:35:00',3.28),('8537','2013-06-12','16:40:00',3.27),('8537','2013-06-12','16:45:00',2.97),('8537','2013-06-12','16:50:00',3.12),('8537','2013-06-12','16:55:00',3),('8537','2013-06-12','17:00:00',2.87),('8537','2013-06-12','17:05:00',2.72),('8537','2013-06-12','17:10:00',2.58),('8537','2013-06-12','17:15:00',2.6),('8537','2013-06-12','17:20:00',2.49),('8537','2013-06-12','17:25:00',2.37),('8537','2013-06-12','17:30:00',2.21),('8537','2013-06-12','17:35:00',2.18),('8537','2013-06-12','17:40:00',2.12),('8537','2013-06-12','17:45:00',1.76),('8537','2013-06-12','17:50:00',1.09),('8537','2013-06-12','18:05:00',1.37),('8537','2013-06-12','18:10:00',1.49),('8537','2013-06-12','18:15:00',1.42),('8537','2013-06-12','18:20:00',1.31),('8537','2013-06-12','18:25:00',1.09),('8537','2013-06-12','18:30:00',1.06),('8537','2013-06-11','07:25:00',1.2),('8537','2013-06-11','07:30:00',1.03),('8537','2013-06-11','07:35:00',1.21),('8537','2013-06-11','07:40:00',1.29),('8537','2013-06-11','07:45:00',1.26),('8537','2013-06-11','07:50:00',1.07),('8537','2013-06-11','08:00:00',1.85),('8537','2013-06-11','08:05:00',2.04),('8537','2013-06-11','08:10:00',2.19),('8537','2013-06-11','08:15:00',1.9),('8537','2013-06-11','08:20:00',1.07),('8537','2013-06-11','08:25:00',1.56),('8537','2013-06-11','08:30:00',2.46),('8537','2013-06-11','08:35:00',2.63),('8537','2013-06-11','08:40:00',2.89),('8537','2013-06-11','08:45:00',2.88),('8537','2013-06-11','08:50:00',3.01),('8537','2013-06-11','08:55:00',2.97),('8537','2013-06-11','09:00:00',1.16),('8537','2013-06-11','09:05:00',1.25),('8537','2013-06-11','09:10:00',2.92),('8537','2013-06-11','09:15:00',3.43),('8537','2013-06-11','09:20:00',3.5),('8537','2013-06-11','09:25:00',3.48),('8537','2013-06-11','09:30:00',2.48),('8537','2013-06-11','09:35:00',2.48),('8537','2013-06-11','09:45:00',1.99),('8537','2013-06-11','09:50:00',3.82),('8537','2013-06-11','09:55:00',4.15),('8537','2013-06-11','10:00:00',4.21),('8537','2013-06-11','10:05:00',2.11),('8537','2013-06-11','10:10:00',4.18),('8537','2013-06-11','10:15:00',4.24),('8537','2013-06-11','10:20:00',4.29),('8537','2013-06-11','10:25:00',4.36),('8537','2013-06-11','10:30:00',4.04),('8537','2013-06-11','10:35:00',4.41),('8537','2013-06-11','10:40:00',3.27),('8537','2013-06-11','10:45:00',3.79),('8537','2013-06-11','10:50:00',4.29),('8537','2013-06-11','10:55:00',2.29),('8537','2013-06-11','11:00:00',4.05),('8537','2013-06-11','11:05:00',4.43),('8537','2013-06-11','11:10:00',2.18),('8537','2013-06-11','11:15:00',5.2),('8537','2013-06-11','11:20:00',4.95),('8537','2013-06-11','11:25:00',4.91),('8537','2013-06-11','11:30:00',4.91),('8537','2013-06-11','11:35:00',4.87),('8537','2013-06-11','11:40:00',4.91),('8537','2013-06-11','11:45:00',4.95),('8537','2013-06-11','11:50:00',5.03),('8537','2013-06-11','11:55:00',5.07),('8537','2013-06-11','12:00:00',5.13),('8537','2013-06-11','12:05:00',5.17),('8537','2013-06-11','12:10:00',5.08),('8537','2013-06-11','12:15:00',5.11),('8537','2013-06-11','12:20:00',5.11),('8537','2013-06-11','12:25:00',5.15),('8537','2013-06-11','12:30:00',5.18),('8537','2013-06-11','12:35:00',5.18),('8537','2013-06-11','12:40:00',5.22),('8537','2013-06-11','12:45:00',5.22),('8537','2013-06-11','12:50:00',5.23),('8537','2013-06-11','12:55:00',5.26),('8537','2013-06-11','13:00:00',5.26),('8537','2013-06-11','13:05:00',5.26),('8537','2013-06-11','13:10:00',5.26),('8537','2013-06-11','13:15:00',5.3),('8537','2013-06-11','13:20:00',5.24),('8537','2013-06-11','13:25:00',5.19),('8537','2013-06-11','13:30:00',5.25),('8537','2013-06-11','13:35:00',5.27),('8537','2013-06-11','13:40:00',5.25),('8537','2013-06-11','13:45:00',5.27),('8537','2013-06-11','13:50:00',3.86),('8537','2013-06-11','13:55:00',5.3),('8537','2013-06-11','14:00:00',5.22),('8537','2013-06-11','14:05:00',5.13),('8537','2013-06-11','14:10:00',5.07),('8537','2013-06-11','14:15:00',5.02),('8537','2013-06-11','14:20:00',4.98),('8537','2013-06-11','14:25:00',4.95),('8537','2013-06-11','14:30:00',4.94),('8537','2013-06-11','14:35:00',4.89),('8537','2013-06-11','14:40:00',4.82),('8537','2013-06-11','14:45:00',4.57),('8537','2013-06-11','14:50:00',4.16),('8537','2013-06-11','14:55:00',4.51),('8537','2013-06-11','15:00:00',4.6),('8537','2013-06-11','15:05:00',4.58),('8537','2013-06-11','15:10:00',4.5),('8537','2013-06-11','15:15:00',4.48),('8537','2013-06-11','15:20:00',4.44),('8537','2013-06-11','15:25:00',4.34),('8537','2013-06-11','15:30:00',4.3),('8537','2013-06-11','15:35:00',4.33),('8537','2013-06-11','15:40:00',4.26),('8537','2013-06-11','15:45:00',4),('8537','2013-06-11','15:50:00',4.11),('8537','2013-06-11','15:55:00',4.06),('8537','2013-06-11','16:00:00',3.97),('8537','2013-06-11','16:05:00',3.88),('8537','2013-06-11','16:10:00',3.82),('8537','2013-06-11','16:15:00',3.75),('8537','2013-06-11','16:20:00',3.67),('8537','2013-06-11','16:25:00',3.55),('8537','2013-06-11','16:30:00',3.48),('8537','2013-06-11','16:35:00',3.41),('8537','2013-06-11','16:40:00',3.44),('8537','2013-06-11','16:45:00',3.56),('8537','2013-06-11','16:50:00',3.59),('8537','2013-06-11','16:55:00',3.43),('8537','2013-06-11','17:00:00',3.17),('8537','2013-06-11','17:05:00',2.2),('8537','2013-06-11','17:10:00',1.08),('8537','2014-04-03','08:45:00',1.08),('8537','2014-04-03','08:50:00',1.13),('8537','2014-04-03','08:55:00',1.3),('8537','2014-04-03','09:00:00',1.44),('8537','2014-04-03','09:05:00',1.56),('8537','2014-04-03','09:10:00',1.51),('8537','2014-04-03','09:15:00',1.38),('8537','2014-04-03','09:20:00',1.39),('8537','2014-04-03','09:25:00',1.48),('8537','2014-04-03','09:30:00',1.73),('8537','2014-04-03','09:35:00',2.1),('8537','2014-04-03','09:40:00',2.26),('8537','2014-04-03','09:45:00',2.21),('8537','2014-04-03','09:50:00',2.1),('8537','2014-04-03','09:55:00',2.18),('8537','2014-04-03','10:00:00',2.62),('8537','2014-04-03','10:05:00',3.08),('8537','2014-04-03','10:10:00',3.29),('8537','2014-04-03','10:15:00',3.74),('8537','2014-04-03','10:20:00',3.83),('8537','2014-04-03','10:25:00',3.43),('8537','2014-04-03','10:30:00',3.16),('8537','2014-04-03','10:35:00',3.48),('8537','2014-04-03','10:40:00',2.74),('8537','2014-04-03','10:45:00',2.92),('8537','2014-04-03','10:50:00',2.46),('8537','2014-04-03','10:55:00',2.56),('8537','2014-04-03','11:00:00',2.42),('8537','2014-04-03','11:05:00',1.99),('8537','2014-04-03','11:10:00',1.87),('8537','2014-04-03','11:15:00',1.74),('8537','2014-04-03','11:20:00',1.66),('8537','2014-04-03','11:25:00',1.54),('8537','2014-04-03','11:30:00',1.52),('8537','2014-04-03','11:35:00',1.62),('8537','2014-04-03','11:40:00',1.79),('8537','2014-04-03','11:45:00',2.03),('8537','2014-04-03','11:50:00',2.55),('8537','2014-04-03','11:55:00',2.86),('8537','2014-04-03','12:00:00',2.69),('8537','2014-04-03','12:05:00',2.7),('8537','2014-04-03','12:10:00',2.6),('8537','2014-04-03','12:15:00',2.54),('8537','2014-04-03','12:20:00',2.84),('8537','2014-04-03','12:25:00',3.42),('8537','2014-04-03','12:30:00',4.57),('8537','2014-04-03','12:35:00',4.45),('8537','2014-04-03','12:40:00',4.99),('8537','2014-04-03','12:45:00',2.84),('8537','2014-04-03','12:50:00',3.22),('8537','2014-04-03','12:55:00',3.16),('8537','2014-04-03','13:00:00',3.05),('8537','2014-04-03','13:05:00',3.97),('8537','2014-04-03','13:10:00',2.8),('8537','2014-04-03','13:15:00',5.43),('8537','2014-04-03','13:20:00',3.54),('8537','2014-04-03','13:25:00',3.36),('8537','2014-04-03','13:30:00',3.38),('8537','2014-04-03','13:35:00',5.31),('8537','2014-04-03','13:40:00',4.82),('8537','2014-04-03','13:45:00',2.7),('8537','2014-04-03','13:50:00',2.51),('8537','2014-04-03','13:55:00',3.09),('8537','2014-04-03','14:00:00',4.5),('8537','2014-04-03','14:05:00',4.23),('8537','2014-04-03','14:10:00',3.28),('8537','2014-04-03','14:15:00',4.3),('8537','2014-04-03','14:20:00',4.49),('8537','2014-04-03','14:25:00',4.57),('8537','2014-04-03','14:30:00',4.58),('8537','2014-04-03','14:35:00',4.59),('8537','2014-04-03','14:40:00',4.47),('8537','2014-04-03','14:45:00',4.38),('8537','2014-04-03','14:50:00',4.27),('8537','2014-04-03','14:55:00',4.23),('8537','2014-04-03','15:00:00',4.19),('8537','2014-04-03','15:05:00',4.15),('8537','2014-04-03','15:10:00',4.08),('8537','2014-04-03','15:15:00',4.07),('8537','2014-04-03','15:20:00',4.06),('8537','2014-04-03','15:25:00',3.96),('8537','2014-04-03','15:30:00',3.91),('8537','2014-04-03','15:35:00',3.84),('8537','2014-04-03','15:40:00',3.78),('8537','2014-04-03','15:45:00',3.75),('8537','2014-04-03','15:50:00',3.71),('8537','2014-04-03','15:55:00',3.68),('8537','2014-04-03','16:00:00',3.58),('8537','2014-04-03','16:05:00',3.43),('8537','2014-04-03','16:10:00',3.45),('8537','2014-04-03','16:15:00',3.32),('8537','2014-04-03','16:20:00',3.28),('8537','2014-04-03','16:25:00',3.17),('8537','2014-04-03','16:30:00',3.1),('8537','2014-04-03','16:35:00',2.91),('8537','2014-04-03','16:40:00',2.68),('8537','2014-04-03','16:45:00',2.67),('8537','2014-04-03','16:50:00',2.1),('8537','2014-04-03','16:55:00',1.61),('8537','2014-04-03','17:00:00',1.19),('8537','2014-04-03','17:05:00',1.09),('8537','2014-04-03','17:50:00',1.35),('8537','2014-04-03','17:55:00',1.2),('8537','2014-04-03','18:00:00',1.08),('8537','2013-06-10','07:30:00',1.26),('8537','2013-06-10','07:35:00',1.75),('8537','2013-06-10','07:40:00',1.23),('8537','2013-06-10','08:00:00',1.36),('8537','2013-06-10','08:05:00',1.73),('8537','2013-06-10','08:10:00',2.27),('8537','2013-06-10','08:15:00',1.94),('8537','2013-06-10','08:20:00',2.26),('8537','2013-06-10','08:25:00',1.43),('8537','2013-06-10','08:30:00',1.43),('8537','2013-06-10','08:35:00',1.34),('8537','2013-06-10','08:40:00',1.18),('8537','2013-06-10','08:50:00',1.07),('8537','2013-06-10','08:55:00',1.2),('8537','2013-06-10','09:00:00',1.37),('8537','2013-06-10','09:05:00',1.27),('8537','2013-06-10','09:10:00',2.2),('8537','2013-06-10','09:15:00',1.16),('8537','2013-06-10','09:20:00',2.07),('8537','2013-06-10','09:25:00',1.95),('8537','2013-06-10','09:30:00',2.45),('8537','2013-06-10','09:35:00',3.82),('8537','2013-06-10','09:40:00',2.75),('8537','2013-06-10','09:45:00',4.09),('8537','2013-06-10','09:50:00',2.15),('8537','2013-06-10','09:55:00',2.03),('8537','2013-06-10','10:00:00',2.66),('8537','2013-06-10','10:05:00',2.81),('8537','2013-06-10','10:10:00',3.32),('8537','2013-06-10','10:15:00',3.03),('8537','2013-06-10','10:20:00',2.92),('8537','2013-06-10','10:25:00',2.69),('8537','2013-06-10','10:30:00',1.8),('8537','2013-06-10','10:35:00',2.21),('8537','2013-06-10','10:40:00',1.85),('8537','2013-06-10','10:45:00',1.46),('8537','2013-06-10','10:50:00',2.39),('8537','2013-06-10','10:55:00',3.13),('8537','2013-06-10','11:00:00',3.45),('8537','2013-06-10','11:05:00',2.76),('8537','2013-06-10','11:10:00',3.73),('8537','2013-06-10','11:15:00',4.83),('8537','2013-06-10','11:20:00',4.53),('8537','2013-06-10','11:25:00',5.25),('8537','2013-06-10','11:30:00',4.75),('8537','2013-06-10','11:35:00',5.54),('8537','2013-06-10','11:40:00',4.01),('8537','2013-06-10','11:45:00',4.11),('8537','2013-06-10','11:50:00',2.72),('8537','2013-06-10','11:55:00',4.15),('8537','2013-06-10','12:00:00',5.78),('8537','2013-06-10','12:05:00',2.05),('8537','2013-06-10','12:10:00',5.19),('8537','2013-06-10','12:15:00',5.27),('8537','2013-06-10','12:20:00',5.39),('8537','2013-06-10','12:25:00',5.05),('8537','2013-06-10','12:30:00',5.41),('8537','2013-06-10','12:35:00',3.77),('8537','2013-06-10','12:40:00',3.68),('8537','2013-06-10','12:45:00',4.37),('8537','2013-06-10','12:50:00',3.25),('8537','2013-06-10','12:55:00',3.01),('8537','2013-06-10','13:00:00',5.62),('8537','2013-06-10','13:05:00',4.84),('8537','2013-06-10','13:10:00',3.02),('8537','2013-06-10','13:15:00',3.81),('8537','2013-06-10','13:20:00',2.91),('8537','2013-06-10','13:25:00',3.53),('8537','2013-06-10','13:30:00',2.88),('8537','2013-06-10','13:35:00',5.29),('8537','2013-06-10','13:40:00',4.13),('8537','2013-06-10','13:45:00',3.71),('8537','2013-06-10','13:50:00',4.3),('8537','2013-06-10','13:55:00',5.23),('8537','2013-06-10','14:00:00',5.46),('8537','2013-06-10','14:05:00',5.39),('8537','2013-06-10','14:10:00',4.73),('8537','2013-06-10','14:15:00',5.09),('8537','2013-06-10','14:20:00',5.14);
INSERT INTO `solarlog` VALUES ('8537','2013-06-10','14:25:00',5.07),('8537','2013-06-10','14:30:00',4.98),('8537','2013-06-10','14:35:00',4.95),('8537','2013-06-10','14:40:00',4.24),('8537','2013-06-10','14:45:00',4.87),('8537','2013-06-10','14:50:00',4.79),('8537','2013-06-10','14:55:00',4.76),('8537','2013-06-10','15:00:00',4.7),('8537','2013-06-10','15:05:00',4.66),('8537','2013-06-10','15:10:00',4.59),('8537','2013-06-10','15:15:00',4.56),('8537','2013-06-10','15:20:00',4.52),('8537','2013-06-10','15:25:00',4.46),('8537','2013-06-10','15:30:00',4.43),('8537','2013-06-10','15:35:00',4.37),('8537','2013-06-10','15:40:00',4.23),('8537','2013-06-10','15:45:00',4.1),('8537','2013-06-10','15:50:00',4.13),('8537','2013-06-10','15:55:00',4.08),('8537','2013-06-10','16:00:00',4),('8537','2013-06-10','16:05:00',3.93),('8537','2013-06-10','16:10:00',3.85),('8537','2013-06-10','16:15:00',3.79),('8537','2013-06-10','16:20:00',3.7),('8537','2013-06-10','16:25:00',3.5),('8537','2013-06-10','16:30:00',3.35),('8537','2013-06-10','16:35:00',3.43),('8537','2013-06-10','16:40:00',3.33),('8537','2013-06-10','16:45:00',3.25),('8537','2013-06-10','16:50:00',3.18),('8537','2013-06-10','16:55:00',3.09),('8537','2013-06-10','17:00:00',3.03),('8537','2013-06-10','17:05:00',2.76),('8537','2013-06-10','17:10:00',2.76),('8537','2013-06-10','17:15:00',2.72),('8537','2013-06-10','17:20:00',2.64),('8537','2013-06-10','17:25:00',2.51),('8537','2013-06-10','17:30:00',2.33),('8537','2013-06-10','17:35:00',2.27),('8537','2013-06-10','17:40:00',2.17),('8537','2013-06-10','17:45:00',2.06),('8537','2013-06-10','17:50:00',1.93),('8537','2013-06-10','17:55:00',1.85),('8537','2013-06-10','18:00:00',1.71),('8537','2013-06-10','18:05:00',1.62),('8537','2013-06-10','18:10:00',1.52),('8537','2013-06-10','18:15:00',1.42),('8537','2013-06-10','18:20:00',1.32),('8537','2013-06-10','18:25:00',1.2),('8537','2013-06-10','18:30:00',1.11),('8537','2013-06-10','18:35:00',1.02),('8537','2013-06-09','07:35:00',1.48),('8537','2013-06-09','07:40:00',1.31),('8537','2013-06-09','07:50:00',1.06),('8537','2013-06-09','07:55:00',1.62),('8537','2013-06-09','08:00:00',1.71),('8537','2013-06-09','08:05:00',1.82),('8537','2013-06-09','08:10:00',1.92),('8537','2013-06-09','08:15:00',2.16),('8537','2013-06-09','08:20:00',2.13),('8537','2013-06-09','08:25:00',2.15),('8537','2013-06-09','08:30:00',2.22),('8537','2013-06-09','08:35:00',2.34),('8537','2013-06-09','08:40:00',2.41),('8537','2013-06-09','08:45:00',2.55),('8537','2013-06-09','08:50:00',2.63),('8537','2013-06-09','08:55:00',2.67),('8537','2013-06-09','09:00:00',2.79),('8537','2013-06-09','09:05:00',2.88),('8537','2013-06-09','09:10:00',2.94),('8537','2013-06-09','09:15:00',3.04),('8537','2013-06-09','09:20:00',3.14),('8537','2013-06-09','09:25:00',3.21),('8537','2013-06-09','09:30:00',3.32),('8537','2013-06-09','09:35:00',3.38),('8537','2013-06-09','09:40:00',3.47),('8537','2013-06-09','09:45:00',3.51),('8537','2013-06-09','09:50:00',3.55),('8537','2013-06-09','09:55:00',3.66),('8537','2013-06-09','10:00:00',3.72),('8537','2013-06-09','10:05:00',3.76),('8537','2013-06-09','10:10:00',3.81),('8537','2013-06-09','10:15:00',3.85),('8537','2013-06-09','10:20:00',3.93),('8537','2013-06-09','10:25:00',3.96),('8537','2013-06-09','10:30:00',4.04),('8537','2013-06-09','10:35:00',4.12),('8537','2013-06-09','10:40:00',4.13),('8537','2013-06-09','10:45:00',4.17),('8537','2013-06-09','10:50:00',4.22),('8537','2013-06-09','10:55:00',4.29),('8537','2013-06-09','11:00:00',4.31),('8537','2013-06-09','11:05:00',4.32),('8537','2013-06-09','11:10:00',4.34),('8537','2013-06-09','11:15:00',4.4),('8537','2013-06-09','11:20:00',4.48),('8537','2013-06-09','11:25:00',4.51),('8537','2013-06-09','11:30:00',4.55),('8537','2013-06-09','11:35:00',4.53),('8537','2013-06-09','11:40:00',4.55),('8537','2013-06-09','11:45:00',4.62),('8537','2013-06-09','11:50:00',4.66),('8537','2013-06-09','11:55:00',4.64),('8537','2013-06-09','12:00:00',4.64),('8537','2013-06-09','12:05:00',4.73),('8537','2013-06-09','12:10:00',4.03),('8537','2013-06-09','12:15:00',4.46),('8537','2013-06-09','12:20:00',4.78),('8537','2013-06-09','12:25:00',4.67),('8537','2013-06-09','12:30:00',4.8),('8537','2013-06-09','12:35:00',4.8),('8537','2013-06-09','12:40:00',4.79),('8537','2013-06-09','12:45:00',4.75),('8537','2013-06-09','12:50:00',4.5),('8537','2013-06-09','12:55:00',4.82),('8537','2013-06-09','13:00:00',4.55),('8537','2013-06-09','13:05:00',4.45),('8537','2013-06-09','13:10:00',4.52),('8537','2013-06-09','13:15:00',4.14),('8537','2013-06-09','13:20:00',5.31),('8537','2013-06-09','13:25:00',5.2),('8537','2013-06-09','13:30:00',5.03),('8537','2013-06-09','13:35:00',5.01),('8537','2013-06-09','13:40:00',5.16),('8537','2013-06-09','13:45:00',5.22),('8537','2013-06-09','13:50:00',5.4),('8537','2013-06-09','13:55:00',5.46),('8537','2013-06-09','14:00:00',3.9),('8537','2013-06-09','14:05:00',5.15),('8537','2013-06-09','14:10:00',5.16),('8537','2013-06-09','14:15:00',3.5),('8537','2013-06-09','14:20:00',2.45),('8537','2013-06-09','14:25:00',1.38),('8537','2013-06-09','14:30:00',1.71),('8537','2013-06-09','14:35:00',4.3),('8537','2013-06-09','14:40:00',3.99),('8537','2013-06-09','14:45:00',4.35),('8537','2013-06-09','14:50:00',4.54),('8537','2013-06-09','14:55:00',4.63),('8537','2013-06-09','15:00:00',4.55),('8537','2013-06-09','15:05:00',4.35),('8537','2013-06-09','15:10:00',4.36),('8537','2013-06-09','15:15:00',4.12),('8537','2013-06-09','15:20:00',4.19),('8537','2013-06-09','15:25:00',4.23),('8537','2013-06-09','15:30:00',3.93),('8537','2013-06-09','15:35:00',4.08),('8537','2013-06-09','15:40:00',3.21),('8537','2013-06-09','15:45:00',3.28),('8537','2013-06-09','15:50:00',3.66),('8537','2013-06-09','15:55:00',3.99),('8537','2013-06-09','16:00:00',2.42),('8537','2013-06-09','16:05:00',3.63),('8537','2013-06-09','16:10:00',3.44),('8537','2013-06-09','16:15:00',1.91),('8537','2013-06-09','16:20:00',1.72),('8537','2013-06-09','16:25:00',2.35),('8537','2013-06-09','16:30:00',1.55),('8537','2013-06-09','16:35:00',1.14),('8537','2013-06-09','16:40:00',1.07),('8537','2013-06-09','16:45:00',1.07),('8537','2013-06-09','16:50:00',1.04),('8537','2013-06-09','17:00:00',1.02),('8537','2013-06-09','17:05:00',1.15),('8537','2013-06-09','17:10:00',1.11),('8537','2013-06-09','17:20:00',1.01),('8537','2013-06-09','18:00:00',1.12),('8537','2013-06-09','18:10:00',1.01),('8537','2013-06-08','07:30:00',1.08),('8537','2013-06-08','07:35:00',1.17),('8537','2013-06-08','07:40:00',1.28),('8537','2013-06-08','07:45:00',1.38),('8537','2013-06-08','07:50:00',1.47),('8537','2013-06-08','07:55:00',1.57),('8537','2013-06-08','08:00:00',1.64),('8537','2013-06-08','08:05:00',1.76),('8537','2013-06-08','08:10:00',1.86),('8537','2013-06-08','08:15:00',1.98),('8537','2013-06-08','08:20:00',2.08),('8537','2013-06-08','08:25:00',2.18),('8537','2013-06-08','08:30:00',2.27),('8537','2013-06-08','08:35:00',2.36),('8537','2013-06-08','08:40:00',2.46),('8537','2013-06-08','08:45:00',2.57),('8537','2013-06-08','08:50:00',2.68),('8537','2013-06-08','08:55:00',2.76),('8537','2013-06-08','09:00:00',2.83),('8537','2013-06-08','09:05:00',2.92),('8537','2013-06-08','09:10:00',3.02),('8537','2013-06-08','09:15:00',3.08),('8537','2013-06-08','09:20:00',3.18),('8537','2013-06-08','09:25:00',3.24),('8537','2013-06-08','09:30:00',3.27),('8537','2013-06-08','09:35:00',3.35),('8537','2013-06-08','09:40:00',3.41),('8537','2013-06-08','09:45:00',3.53),('8537','2013-06-08','09:50:00',3.53),('8537','2013-06-08','09:55:00',3.62),('8537','2013-06-08','10:00:00',3.73),('8537','2013-06-08','10:05:00',3.89),('8537','2013-06-08','10:10:00',3.4),('8537','2013-06-08','10:15:00',4.06),('8537','2013-06-08','10:20:00',4.04),('8537','2013-06-08','10:25:00',4.1),('8537','2013-06-08','10:30:00',4.09),('8537','2013-06-08','10:35:00',4.18),('8537','2013-06-08','10:40:00',4.12),('8537','2013-06-08','10:45:00',4.32),('8537','2013-06-08','10:50:00',4.19),('8537','2013-06-08','10:55:00',4.59),('8537','2013-06-08','11:00:00',2.91),('8537','2013-06-08','11:05:00',4.61),('8537','2013-06-08','11:10:00',4.63),('8537','2013-06-08','11:15:00',4.62),('8537','2013-06-08','11:20:00',4.96),('8537','2013-06-08','11:25:00',4.62),('8537','2013-06-08','11:30:00',1.54),('8537','2013-06-08','11:35:00',1.74),('8537','2013-06-08','11:40:00',5.04),('8537','2013-06-08','11:45:00',5.05),('8537','2013-06-08','11:50:00',5.14),('8537','2013-06-08','11:55:00',5.16),('8537','2013-06-08','12:00:00',1.74),('8537','2013-06-08','12:05:00',2.46),('8537','2013-06-08','12:10:00',1.13),('8537','2013-06-08','12:15:00',4.3),('8537','2013-06-08','12:20:00',3.63),('8537','2013-06-08','12:25:00',1.29),('8537','2013-06-08','12:30:00',4.23),('8537','2013-06-08','12:35:00',3.89),('8537','2013-06-08','12:40:00',5.07),('8537','2013-06-08','12:45:00',4.38),('8537','2013-06-08','12:50:00',1.66),('8537','2013-06-08','12:55:00',5.45),('8537','2013-06-08','13:00:00',5.3),('8537','2013-06-08','13:05:00',3.62),('8537','2013-06-08','13:10:00',4.17),('8537','2013-06-08','13:15:00',5.49),('8537','2013-06-08','13:20:00',5.24),('8537','2013-06-08','13:25:00',5.29),('8537','2013-06-08','13:30:00',5.31),('8537','2013-06-08','13:35:00',5.17),('8537','2013-06-08','13:40:00',5.1),('8537','2013-06-08','13:45:00',5.08),('8537','2013-06-08','13:50:00',5.02),('8537','2013-06-08','13:55:00',5),('8537','2013-06-08','14:00:00',4.99),('8537','2013-06-08','14:05:00',4.98),('8537','2013-06-08','14:10:00',4.99),('8537','2013-06-08','14:15:00',4.97),('8537','2013-06-08','14:20:00',4.94),('8537','2013-06-08','14:25:00',4.89),('8537','2013-06-08','14:30:00',4.88),('8537','2013-06-08','14:35:00',4.81),('8537','2013-06-08','14:40:00',4.74),('8537','2013-06-08','14:45:00',4.47),('8537','2013-06-08','14:50:00',4.54),('8537','2013-06-08','14:55:00',4.65),('8537','2013-06-08','15:00:00',4.65),('8537','2013-06-08','15:05:00',4.46),('8537','2013-06-08','15:10:00',4.15),('8537','2013-06-08','15:15:00',4.27),('8537','2013-06-08','15:20:00',4.38),('8537','2013-06-08','15:25:00',4.18),('8537','2013-06-08','15:30:00',4.23),('8537','2013-06-08','15:35:00',4.41),('8537','2013-06-08','15:40:00',4.13),('8537','2013-06-08','15:45:00',4.07),('8537','2013-06-08','15:50:00',3.63),('8537','2013-06-08','15:55:00',3.94),('8537','2013-06-08','16:00:00',3.93),('8537','2013-06-08','16:05:00',3.9),('8537','2013-06-08','16:10:00',3.84),('8537','2013-06-08','16:15:00',3.86),('8537','2013-06-08','16:20:00',3.75),('8537','2013-06-08','16:25:00',3.49),('8537','2013-06-08','16:30:00',3.16),('8537','2013-06-08','16:35:00',3.29),('8537','2013-06-08','16:40:00',3.24),('8537','2013-06-08','16:45:00',3.16),('8537','2013-06-08','16:50:00',2.69),('8537','2013-06-08','16:55:00',2.69),('8537','2013-06-08','17:00:00',2.93),('8537','2013-06-08','17:05:00',2.41),('8537','2013-06-08','17:10:00',2.94),('8537','2013-06-08','17:15:00',2.89),('8537','2013-06-08','17:20:00',2.73),('8537','2013-06-08','17:25:00',2.48),('8537','2013-06-08','17:30:00',1.71),('8537','2013-06-08','17:35:00',1.23),('8537','2013-06-08','17:40:00',1.93),('8537','2013-06-08','17:45:00',2.13),('8537','2013-06-08','17:50:00',1.87),('8537','2013-06-08','17:55:00',1.95),('8537','2013-06-08','18:00:00',1.51),('8537','2013-06-08','18:05:00',1.39),('8537','2013-06-08','18:10:00',1.14),('8537','2013-06-08','18:15:00',1.12),('8537','2013-06-08','18:20:00',1.09),('8537','2013-06-07','07:25:00',1.03),('8537','2013-06-07','07:30:00',1.13),('8537','2013-06-07','07:35:00',1.24),('8537','2013-06-07','07:40:00',1.35),('8537','2013-06-07','07:45:00',1.45),('8537','2013-06-07','07:50:00',1.56),('8537','2013-06-07','07:55:00',1.67),('8537','2013-06-07','08:00:00',1.77),('8537','2013-06-07','08:05:00',1.88),('8537','2013-06-07','08:10:00',1.99),('8537','2013-06-07','08:15:00',2.07),('8537','2013-06-07','08:20:00',2.21),('8537','2013-06-07','08:25:00',2.32),('8537','2013-06-07','08:30:00',2.42),('8537','2013-06-07','08:35:00',2.53),('8537','2013-06-07','08:40:00',2.63),('8537','2013-06-07','08:45:00',2.74),('8537','2013-06-07','08:50:00',2.83),('8537','2013-06-07','08:55:00',2.92),('8537','2013-06-07','09:00:00',3.01),('8537','2013-06-07','09:05:00',3.11),('8537','2013-06-07','09:10:00',3.21),('8537','2013-06-07','09:15:00',3.31),('8537','2013-06-07','09:20:00',3.38),('8537','2013-06-07','09:25:00',3.48),('8537','2013-06-07','09:30:00',3.57),('8537','2013-06-07','09:35:00',3.64),('8537','2013-06-07','09:40:00',3.74),('8537','2013-06-07','09:45:00',3.83),('8537','2013-06-07','09:50:00',3.89),('8537','2013-06-07','09:55:00',3.95),('8537','2013-06-07','10:00:00',4.03),('8537','2013-06-07','10:05:00',4.09),('8537','2013-06-07','10:10:00',4.15),('8537','2013-06-07','10:15:00',4.22),('8537','2013-06-07','10:20:00',4.29),('8537','2013-06-07','10:25:00',4.37),('8537','2013-06-07','10:30:00',4.42),('8537','2013-06-07','10:35:00',4.47),('8537','2013-06-07','10:40:00',4.54),('8537','2013-06-07','10:45:00',4.59),('8537','2013-06-07','10:50:00',4.63),('8537','2013-06-07','10:55:00',4.67),('8537','2013-06-07','11:00:00',4.74),('8537','2013-06-07','11:05:00',4.8),('8537','2013-06-07','11:10:00',4.81),('8537','2013-06-07','11:15:00',4.82),('8537','2013-06-07','11:20:00',4.78),('8537','2013-06-07','11:25:00',4.9),('8537','2013-06-07','11:30:00',4.95),('8537','2013-06-07','11:35:00',4.99),('8537','2013-06-07','11:40:00',5.05),('8537','2013-06-07','11:45:00',5.03),('8537','2013-06-07','11:50:00',5.06),('8537','2013-06-07','11:55:00',5.07),('8537','2013-06-07','12:00:00',5.11),('8537','2013-06-07','12:05:00',5.16),('8537','2013-06-07','12:10:00',5.17),('8537','2013-06-07','12:15:00',5.18),('8537','2013-06-07','12:20:00',5.21),('8537','2013-06-07','12:25:00',5.18),('8537','2013-06-07','12:30:00',5.17),('8537','2013-06-07','12:35:00',5.11),('8537','2013-06-07','12:40:00',5.19),('8537','2013-06-07','12:45:00',5.19),('8537','2013-06-07','12:50:00',5.19),('8537','2013-06-07','12:55:00',5.22),('8537','2013-06-07','13:00:00',5.25),('8537','2013-06-07','13:05:00',5.22),('8537','2013-06-07','13:10:00',5.21),('8537','2013-06-07','13:15:00',5.19),('8537','2013-06-07','13:20:00',5.16),('8537','2013-06-07','13:25:00',5.17),('8537','2013-06-07','13:30:00',5.14),('8537','2013-06-07','13:35:00',5.1),('8537','2013-06-07','13:40:00',5.05),('8537','2013-06-07','13:45:00',5.06),('8537','2013-06-07','13:50:00',5.07),('8537','2013-06-07','13:55:00',5.02),('8537','2013-06-07','14:00:00',4.99),('8537','2013-06-07','14:05:00',4.95),('8537','2013-06-07','14:10:00',4.93),('8537','2013-06-07','14:15:00',4.88),('8537','2013-06-07','14:20:00',4.78),('8537','2013-06-07','14:25:00',4.74),('8537','2013-06-07','14:30:00',4.79),('8537','2013-06-07','14:35:00',4.79),('8537','2013-06-07','14:40:00',4.73),('8537','2013-06-07','14:45:00',4.45),('8537','2013-06-07','14:50:00',4.32),('8537','2013-06-07','14:55:00',4.59),('8537','2013-06-07','15:00:00',4.57),('8537','2013-06-07','15:05:00',4.54),('8537','2013-06-07','15:10:00',4.51),('8537','2013-06-07','15:15:00',4.42),('8537','2013-06-07','15:20:00',4.31),('8537','2013-06-07','15:25:00',4.36),('8537','2013-06-07','15:30:00',4.31),('8537','2013-06-07','15:35:00',4.2),('8537','2013-06-07','15:40:00',4.02),('8537','2013-06-07','15:45:00',3.9),('8537','2013-06-07','15:50:00',3.96),('8537','2013-06-07','15:55:00',3.92),('8537','2013-06-07','16:00:00',3.85),('8537','2013-06-07','16:05:00',3.72),('8537','2013-06-07','16:10:00',3.61),('8537','2013-06-07','16:15:00',3.42),('8537','2013-06-07','16:20:00',3.43),('8537','2013-06-07','16:25:00',3.28),('8537','2013-06-07','16:30:00',3.17),('8537','2013-06-07','16:35:00',3.3),('8537','2013-06-07','16:40:00',3.22),('8537','2013-06-07','16:45:00',3.14),('8537','2013-06-07','16:50:00',3.07),('8537','2013-06-07','16:55:00',2.99),('8537','2013-06-07','17:00:00',2.9),('8537','2013-06-07','17:05:00',2.62),('8537','2013-06-07','17:10:00',2.65),('8537','2013-06-07','17:15:00',2.53),('8537','2013-06-07','17:20:00',2.39),('8537','2013-06-07','17:25:00',2.31),('8537','2013-06-07','17:30:00',2.18),('8537','2013-06-07','17:35:00',2.14),('8537','2013-06-07','17:40:00',2.08),('8537','2013-06-07','17:45:00',2.04),('8537','2013-06-07','17:50:00',1.93),('8537','2013-06-07','17:55:00',1.79),('8537','2013-06-07','18:00:00',1.62),('8537','2013-06-07','18:05:00',1.58),('8537','2013-06-07','18:10:00',1.48),('8537','2013-06-07','18:15:00',1.36),('8537','2013-06-07','18:20:00',1.24),('8537','2013-06-07','18:25:00',1.1),('8537','2013-06-07','18:30:00',1.03),('8537','2013-06-06','07:05:00',1.1),('8537','2013-06-06','07:10:00',1.03),('8537','2013-06-06','07:15:00',1.15),('8537','2013-06-06','07:50:00',1.34),('8537','2013-06-06','07:55:00',1.78),('8537','2013-06-06','08:00:00',1.95),('8537','2013-06-06','08:05:00',1.48),('8537','2013-06-06','08:10:00',1.88),('8537','2013-06-06','08:15:00',1.65),('8537','2013-06-06','08:20:00',1.9),('8537','2013-06-06','08:25:00',2.3),('8537','2013-06-06','08:30:00',2.37),('8537','2013-06-06','08:35:00',2.45),('8537','2013-06-06','08:40:00',2.55),('8537','2013-06-06','08:45:00',2.61),('8537','2013-06-06','08:50:00',2.74),('8537','2013-06-06','08:55:00',2.85),('8537','2013-06-06','09:00:00',2.95),('8537','2013-06-06','09:05:00',3.05),('8537','2013-06-06','09:10:00',3.05),('8537','2013-06-06','09:15:00',3.21),('8537','2013-06-06','09:20:00',3.33),('8537','2013-06-06','09:25:00',3.39),('8537','2013-06-06','09:30:00',3.43),('8537','2013-06-06','09:35:00',3.44),('8537','2013-06-06','09:40:00',3.59),('8537','2013-06-06','09:45:00',3.71),('8537','2013-06-06','09:50:00',3.77),('8537','2013-06-06','09:55:00',3.82),('8537','2013-06-06','10:00:00',3.82),('8537','2013-06-06','10:05:00',3.83),('8537','2013-06-06','10:10:00',4),('8537','2013-06-06','10:15:00',4.07),('8537','2013-06-06','10:20:00',4.15),('8537','2013-06-06','10:25:00',4.21),('8537','2013-06-06','10:30:00',4.25),('8537','2013-06-06','10:35:00',4.31),('8537','2013-06-06','10:40:00',4.37),('8537','2013-06-06','10:45:00',4.48),('8537','2013-06-06','10:50:00',4.5),('8537','2013-06-06','10:55:00',4.54),('8537','2013-06-06','11:00:00',4.55),('8537','2013-06-06','11:05:00',4.64),('8537','2013-06-06','11:10:00',4.68),('8537','2013-06-06','11:15:00',4.67),('8537','2013-06-06','11:20:00',4.77),('8537','2013-06-06','11:25:00',4.76),('8537','2013-06-06','11:30:00',4.81),('8537','2013-06-06','11:35:00',4.82),('8537','2013-06-06','11:40:00',4.88),('8537','2013-06-06','11:45:00',4.91),('8537','2013-06-06','11:50:00',4.75),('8537','2013-06-06','11:55:00',4.75),('8537','2013-06-06','12:00:00',4.6),('8537','2013-06-06','12:05:00',4.98),('8537','2013-06-06','12:10:00',4.95),('8537','2013-06-06','12:15:00',4.98),('8537','2013-06-06','12:20:00',5),('8537','2013-06-06','12:25:00',5.12),('8537','2013-06-06','12:30:00',5.13),('8537','2013-06-06','12:35:00',5.08),('8537','2013-06-06','12:40:00',5.13),('8537','2013-06-06','12:45:00',5.1),('8537','2013-06-06','12:50:00',5.11),('8537','2013-06-06','12:55:00',5.09),('8537','2013-06-06','13:00:00',5.05),('8537','2013-06-06','13:05:00',5.01),('8537','2013-06-06','13:10:00',5.11),('8537','2013-06-06','13:15:00',5.16),('8537','2013-06-06','13:20:00',5.15),('8537','2013-06-06','13:25:00',5.14),('8537','2013-06-06','13:30:00',5.1),('8537','2013-06-06','13:35:00',5.13),('8537','2013-06-06','13:40:00',5.11),('8537','2013-06-06','13:45:00',2.04),('8537','2013-06-06','13:50:00',2.97),('8537','2013-06-06','13:55:00',5.13),('8537','2013-06-06','14:00:00',5.08),('8537','2013-06-06','14:05:00',5.12),('8537','2013-06-06','14:10:00',5.07),('8537','2013-06-06','14:15:00',5.09),('8537','2013-06-06','14:20:00',3.37),('8537','2013-06-06','14:25:00',3.25),('8537','2013-06-06','14:30:00',5.05),('8537','2013-06-06','14:35:00',4.52),('8537','2013-06-06','14:40:00',3.47),('8537','2013-06-06','14:45:00',4.76),('8537','2013-06-06','14:50:00',4.86),('8537','2013-06-06','14:55:00',4.62),('8537','2013-06-06','15:00:00',4.74),('8537','2013-06-06','15:05:00',4.72),('8537','2013-06-06','15:10:00',4.63),('8537','2013-06-06','15:15:00',4.46),('8537','2013-06-06','15:20:00',4.47),('8537','2013-06-06','15:25:00',3.89),('8537','2013-06-06','15:30:00',3.94),('8537','2013-06-06','15:35:00',4.29),('8537','2013-06-06','15:40:00',3.91),('8537','2013-06-06','15:45:00',4.06),('8537','2013-06-06','15:50:00',3.85),('8537','2013-06-06','15:55:00',3.95),('8537','2013-06-06','16:00:00',3.38),('8537','2013-06-06','16:05:00',3.84),('8537','2013-06-06','16:10:00',3.6),('8537','2013-06-06','16:15:00',3.49),('8537','2013-06-06','16:20:00',3.4),('8537','2013-06-06','16:25:00',3.26),('8537','2013-06-06','16:30:00',3.06),('8537','2013-06-06','16:35:00',3.32),('8537','2013-06-06','16:40:00',3.22),('8537','2013-06-06','16:45:00',3.06),('8537','2013-06-06','16:50:00',2.98),('8537','2013-06-06','16:55:00',2.9),('8537','2013-06-06','17:00:00',2.74),('8537','2013-06-06','17:05:00',2.61),('8537','2013-06-06','17:10:00',2.57),('8537','2013-06-06','17:15:00',2.5),('8537','2013-06-06','17:20:00',2.39),('8537','2013-06-06','17:25:00',2.26),('8537','2013-06-06','17:30:00',2.17),('8537','2013-06-06','17:35:00',2.09),('8537','2013-06-06','17:40:00',1.98),('8537','2013-06-06','17:45:00',1.89),('8537','2013-06-06','17:50:00',1.75),('8537','2013-06-06','17:55:00',1.65),('8537','2013-06-06','18:00:00',1.55),('8537','2013-06-06','18:05:00',1.48),('8537','2013-06-06','18:10:00',1.38),('8537','2013-06-06','18:15:00',1.28),('8537','2013-06-06','18:20:00',1.17),('8537','2013-06-06','18:25:00',1.08),('8537','2013-06-05','07:50:00',1.01),('8537','2013-06-05','07:55:00',1.91),('8537','2013-06-05','08:00:00',1.52),('8537','2013-06-05','08:05:00',1.48),('8537','2013-06-05','08:10:00',1.75),('8537','2013-06-05','08:15:00',1.99),('8537','2013-06-05','08:20:00',2.12),('8537','2013-06-05','08:25:00',2.27),('8537','2013-06-05','08:30:00',2.36),('8537','2013-06-05','08:35:00',2.47),('8537','2013-06-05','08:40:00',2.58),('8537','2013-06-05','08:45:00',2.66),('8537','2013-06-05','08:50:00',2.79),('8537','2013-06-05','08:55:00',2.82),('8537','2013-06-05','09:00:00',2.99),('8537','2013-06-05','09:05:00',2.52),('8537','2013-06-05','09:10:00',3.11),('8537','2013-06-05','09:15:00',3.38),('8537','2013-06-05','09:20:00',3.63),('8537','2013-06-05','09:25:00',3.67),('8537','2013-06-05','09:30:00',3.57),('8537','2013-06-05','09:35:00',3.51),('8537','2013-06-05','09:40:00',3.97),('8537','2013-06-05','09:45:00',2.84),('8537','2013-06-05','09:50:00',1.59),('8537','2013-06-05','09:55:00',1.51),('8537','2013-06-05','10:00:00',3.12),('8537','2013-06-05','10:05:00',4.2),('8537','2013-06-05','10:10:00',3.27),('8537','2013-06-05','10:15:00',3.38),('8537','2013-06-05','10:20:00',1.52),('8537','2013-06-05','10:25:00',1.55),('8537','2013-06-05','10:30:00',1.57),('8537','2013-06-05','10:35:00',1.54),('8537','2013-06-05','10:40:00',2.26),('8537','2013-06-05','10:45:00',2.96),('8537','2013-06-05','10:50:00',3.47),('8537','2013-06-05','10:55:00',5.02),('8537','2013-06-05','11:00:00',5.08),('8537','2013-06-05','11:05:00',1.99),('8537','2013-06-05','11:10:00',1.66),('8537','2013-06-05','11:15:00',1.67),('8537','2013-06-05','11:20:00',1.42),('8537','2013-06-05','11:25:00',1.26),('8537','2013-06-05','11:30:00',1.3),('8537','2013-06-05','11:35:00',2.38),('8537','2013-06-05','11:40:00',3.67),('8537','2013-06-05','11:45:00',2.8),('8537','2013-06-05','11:50:00',2.21),('8537','2013-06-05','11:55:00',5.41),('8537','2013-06-05','12:00:00',3.47),('8537','2013-06-05','12:05:00',5.48),('8537','2013-06-05','12:10:00',5.33),('8537','2013-06-05','12:15:00',5.4),('8537','2013-06-05','12:20:00',5.8),('8537','2013-06-05','12:25:00',4.74),('8537','2013-06-05','12:30:00',4.01),('8537','2013-06-05','12:35:00',5.6),('8537','2013-06-05','12:40:00',5.65),('8537','2013-06-05','12:45:00',5.72),('8537','2013-06-05','12:50:00',3.1),('8537','2013-06-05','12:55:00',2.03),('8537','2013-06-05','13:00:00',4.16),('8537','2013-06-05','13:05:00',5.88),('8537','2013-06-05','13:10:00',3.43),('8537','2013-06-05','13:15:00',2.71),('8537','2013-06-05','13:20:00',3.09),('8537','2013-06-05','13:25:00',4.01),('8537','2013-06-05','13:30:00',3.47),('8537','2013-06-05','13:35:00',5.92),('8537','2013-06-05','13:40:00',5.6),('8537','2013-06-05','13:45:00',5.44),('8537','2013-06-05','13:50:00',5.32),('8537','2013-06-05','13:55:00',5.27),('8537','2013-06-05','14:00:00',5.18),('8537','2013-06-05','14:05:00',5.12),('8537','2013-06-05','14:10:00',5.02),('8537','2013-06-05','14:15:00',5.07),('8537','2013-06-05','14:20:00',5.04),('8537','2013-06-05','14:25:00',4.99),('8537','2013-06-05','14:30:00',4.96),('8537','2013-06-05','14:35:00',4.94),('8537','2013-06-05','14:40:00',4.88),('8537','2013-06-05','14:45:00',4.84),('8537','2013-06-05','14:50:00',4.78),('8537','2013-06-05','14:55:00',4.76),('8537','2013-06-05','15:00:00',4.63),('8537','2013-06-05','15:05:00',4.59),('8537','2013-06-05','15:10:00',4.55),('8537','2013-06-05','15:15:00',4.53),('8537','2013-06-05','15:20:00',4.45),('8537','2013-06-05','15:25:00',4.44),('8537','2013-06-05','15:30:00',4.41),('8537','2013-06-05','15:35:00',4.38),('8537','2013-06-05','15:40:00',4.31),('8537','2013-06-05','15:45:00',4.2),('8537','2013-06-05','15:50:00',4.13),('8537','2013-06-05','15:55:00',4.08),('8537','2013-06-05','16:00:00',4.02),('8537','2013-06-05','16:05:00',3.92),('8537','2013-06-05','16:10:00',3.82),('8537','2013-06-05','16:15:00',3.8),('8537','2013-06-05','16:20:00',3.7),('8537','2013-06-05','16:25:00',3.39),('8537','2013-06-05','16:30:00',3.39),('8537','2013-06-05','16:35:00',3.35),('8537','2013-06-05','16:40:00',3.29),('8537','2013-06-05','16:45:00',3.21),('8537','2013-06-05','16:50:00',3.16),('8537','2013-06-05','16:55:00',3.07),('8537','2013-06-05','17:00:00',2.75),('8537','2013-06-05','17:05:00',2.25),('8537','2013-06-05','17:10:00',1.94),('8537','2013-06-05','17:15:00',1.98),('8537','2013-06-05','17:25:00',2.48),('8537','2013-06-05','17:30:00',2.33),('8537','2013-06-05','17:35:00',2.09),('8537','2013-06-05','17:40:00',1.24),('8537','2013-06-05','17:45:00',1.39),('8537','2013-06-05','17:50:00',1.79),('8537','2013-06-05','17:55:00',1.71),('8537','2013-06-05','18:00:00',1.57),('8537','2013-06-05','18:05:00',1.56),('8537','2013-06-04','07:25:00',1.06),('8537','2013-06-04','07:30:00',1.17),('8537','2013-06-04','07:35:00',1.29),('8537','2013-06-04','07:40:00',1.44),('8537','2013-06-04','07:45:00',1.65),('8537','2013-06-04','07:50:00',1.83),('8537','2013-06-04','07:55:00',1.97),('8537','2013-06-04','08:00:00',2.21),('8537','2013-06-04','08:05:00',2.4),('8537','2013-06-04','08:10:00',2.48),('8537','2013-06-04','08:15:00',2.54),('8537','2013-06-04','08:20:00',2.6),('8537','2013-06-04','08:25:00',2.63),('8537','2013-06-04','08:30:00',2.41),('8537','2013-06-04','08:35:00',2.83),('8537','2013-06-04','08:40:00',2.33),('8537','2013-06-04','08:45:00',2.26),('8537','2013-06-04','08:50:00',1.61),('8537','2013-06-04','08:55:00',1.62),('8537','2013-06-04','09:00:00',1.95),('8537','2013-06-04','09:05:00',2.12),('8537','2013-06-04','09:10:00',2.72),('8537','2013-06-04','09:15:00',3.49),('8537','2013-06-04','09:20:00',3.94),('8537','2013-06-04','09:25:00',3.72),('8537','2013-06-04','09:30:00',3.34),('8537','2013-06-04','09:35:00',2.86),('8537','2013-06-04','09:40:00',1.96),('8537','2013-06-04','09:45:00',2),('8537','2013-06-04','09:50:00',2.09),('8537','2013-06-04','09:55:00',2.07),('8537','2013-06-04','10:00:00',2.42),('8537','2013-06-04','10:05:00',2.8),('8537','2013-06-04','10:10:00',3.21),('8537','2013-06-04','10:15:00',2.82),('8537','2013-06-04','10:20:00',2.22),('8537','2013-06-04','10:25:00',2.13),('8537','2013-06-04','10:30:00',1.96),('8537','2013-06-04','10:35:00',1.97),('8537','2013-06-04','10:40:00',2.13),('8537','2013-06-04','10:45:00',2.46),('8537','2013-06-04','10:50:00',3.19),('8537','2013-06-04','10:55:00',3.89),('8537','2013-06-04','11:00:00',2.58),('8537','2013-06-04','11:05:00',3.17),('8537','2013-06-04','11:10:00',4.28),('8537','2013-06-04','11:15:00',3.8),('8537','2013-06-04','11:20:00',2.61),('8537','2013-06-04','11:25:00',3.3),('8537','2013-06-04','11:30:00',4.07),('8537','2013-06-04','11:35:00',3.63),('8537','2013-06-04','11:40:00',3.58),('8537','2013-06-04','11:45:00',4.58),('8537','2013-06-04','11:50:00',5.44),('8537','2013-06-04','11:55:00',5.25),('8537','2013-06-04','12:00:00',3.99),('8537','2013-06-04','12:05:00',3.44),('8537','2013-06-04','12:10:00',3.11),('8537','2013-06-04','12:15:00',3.26),('8537','2013-06-04','12:20:00',2.44),('8537','2013-06-04','12:25:00',2.15),('8537','2013-06-04','12:30:00',3.03),('8537','2013-06-04','12:35:00',4.66),('8537','2013-06-04','12:40:00',2.97),('8537','2013-06-04','12:45:00',3.62),('8537','2013-06-04','12:50:00',3.19),('8537','2013-06-04','12:55:00',2.32),('8537','2013-06-04','13:00:00',2.7),('8537','2013-06-04','13:05:00',1.8),('8537','2013-06-04','13:10:00',1.57),('8537','2013-06-04','13:15:00',1.55),('8537','2013-06-04','13:20:00',1.29),('8537','2013-06-04','13:25:00',1.54),('8537','2013-06-04','13:30:00',2.01),('8537','2013-06-04','13:35:00',2.94),('8537','2013-06-04','13:40:00',4.47),('8537','2013-06-04','13:45:00',5.98),('8537','2013-06-04','13:50:00',5.97),('8537','2013-06-04','13:55:00',3.53),('8537','2013-06-04','14:00:00',2.3),('8537','2013-06-04','14:05:00',4.18),('8537','2013-06-04','14:10:00',5.89),('8537','2013-06-04','14:15:00',4.76),('8537','2013-06-04','14:20:00',4.25),('8537','2013-06-04','14:25:00',2.65),('8537','2013-06-04','14:30:00',1.58),('8537','2013-06-04','14:35:00',1.89),('8537','2013-06-04','14:40:00',3.11),('8537','2013-06-04','14:45:00',1.42),('8537','2013-06-04','14:50:00',1.25),('8537','2013-06-04','14:55:00',4.22),('8537','2013-06-04','15:00:00',5.98),('8537','2013-06-04','15:05:00',5.69),('8537','2013-06-04','15:10:00',1.82),('8537','2013-06-04','15:15:00',1.38),('8537','2013-06-04','15:20:00',1.23),('8537','2013-06-04','18:10:00',1.06),('8537','2013-06-03','07:40:00',1.21),('8537','2013-06-03','07:45:00',1.46),('8537','2013-06-03','07:50:00',1.53),('8537','2013-06-03','07:55:00',1.69),('8537','2013-06-03','08:00:00',1.79),('8537','2013-06-03','08:05:00',1.85),('8537','2013-06-03','08:10:00',1.95),('8537','2013-06-03','08:15:00',2.07),('8537','2013-06-03','08:20:00',2.16),('8537','2013-06-03','08:25:00',2.29),('8537','2013-06-03','08:30:00',2.37),('8537','2013-06-03','08:35:00',2.48),('8537','2013-06-03','08:40:00',2.58),('8537','2013-06-03','08:45:00',2.65),('8537','2013-06-03','08:50:00',2.75),('8537','2013-06-03','08:55:00',2.84),('8537','2013-06-03','09:00:00',2.93),('8537','2013-06-03','09:05:00',2.79),('8537','2013-06-03','09:10:00',3.18),('8537','2013-06-03','09:15:00',3.32),('8537','2013-06-03','09:20:00',3.69),('8537','2013-06-03','09:25:00',3.08),('8537','2013-06-03','09:30:00',2.8),('8537','2013-06-03','09:35:00',2.04),('8537','2013-06-03','09:40:00',2.79),('8537','2013-06-03','09:45:00',2.89),('8537','2013-06-03','09:50:00',4.61),('8537','2013-06-03','09:55:00',4.59),('8537','2013-06-03','10:00:00',4.56),('8537','2013-06-03','10:05:00',4.5),('8537','2013-06-03','10:10:00',4.15),('8537','2013-06-03','10:15:00',1.99),('8537','2013-06-03','10:20:00',1.74),('8537','2013-06-03','10:25:00',1.59),('8537','2013-06-03','10:30:00',1.31),('8537','2013-06-03','10:35:00',1.4),('8537','2013-06-03','10:40:00',1.6),('8537','2013-06-03','10:45:00',1.8),('8537','2013-06-03','10:50:00',2),('8537','2013-06-03','10:55:00',2.88),('8537','2013-06-03','11:00:00',2.6),('8537','2013-06-03','11:05:00',2.2),('8537','2013-06-03','11:10:00',1.59),('8537','2013-06-03','11:15:00',1.56),('8537','2013-06-03','11:20:00',1.95),('8537','2013-06-03','11:25:00',1.95),('8537','2013-06-03','11:30:00',1.79),('8537','2013-06-03','11:35:00',1.63),('8537','2013-06-03','11:40:00',2.13),('8537','2013-06-03','11:45:00',2.5),('8537','2013-06-03','11:50:00',1.84),('8537','2013-06-03','11:55:00',1.96),('8537','2013-06-03','12:00:00',2.27),('8537','2013-06-03','12:05:00',2.2),('8537','2013-06-03','12:10:00',2.88),('8537','2013-06-03','12:15:00',1.77),('8537','2013-06-03','12:20:00',1.76),('8537','2013-06-03','12:25:00',1.65),('8537','2013-06-03','12:30:00',2.2),('8537','2013-06-03','12:35:00',4.59),('8537','2013-06-03','12:40:00',5.01),('8537','2013-06-03','12:45:00',2.64),('8537','2013-06-03','12:50:00',2.61),('8537','2013-06-03','12:55:00',3.65),('8537','2013-06-03','13:00:00',2.43),('8537','2013-06-03','13:05:00',2.21),('8537','2013-06-03','13:10:00',2.29),('8537','2013-06-03','13:15:00',4.46),('8537','2013-06-03','13:20:00',6),('8537','2013-06-03','13:25:00',4.83),('8537','2013-06-03','13:30:00',4.46),('8537','2013-06-03','13:35:00',5.47),('8537','2013-06-03','13:40:00',5.21),('8537','2013-06-03','13:45:00',2.03),('8537','2013-06-03','13:50:00',4.58),('8537','2013-06-03','13:55:00',3.21),('8537','2013-06-03','14:00:00',4.67),('8537','2013-06-03','14:05:00',3.44),('8537','2013-06-03','14:10:00',2.55),('8537','2013-06-03','14:15:00',3.06),('8537','2013-06-03','14:20:00',3.06),('8537','2013-06-03','14:25:00',3.51),('8537','2013-06-03','14:30:00',5.48),('8537','2013-06-03','14:35:00',5.52),('8537','2013-06-03','14:40:00',3.9),('8537','2013-06-03','14:45:00',3.67),('8537','2013-06-03','14:50:00',3.17),('8537','2013-06-03','14:55:00',4.42),('8537','2013-06-03','15:00:00',4.53),('8537','2013-06-03','15:05:00',3.17),('8537','2013-06-03','15:10:00',4.72),('8537','2013-06-03','15:15:00',4.5),('8537','2013-06-03','15:20:00',3.38),('8537','2013-06-03','15:25:00',4.57),('8537','2013-06-03','15:30:00',4.45),('8537','2013-06-03','15:35:00',4.36),('8537','2013-06-03','15:40:00',4.22),('8537','2013-06-03','15:45:00',4.17),('8537','2013-06-03','15:50:00',4.15),('8537','2013-06-03','15:55:00',4.09),('8537','2013-06-03','16:00:00',3.99),('8537','2013-06-03','16:05:00',3.94),('8537','2013-06-03','16:10:00',3.9),('8537','2013-06-03','16:15:00',3.75),('8537','2013-06-03','16:20:00',3.58),('8537','2013-06-03','16:25:00',3.53),('8537','2013-06-03','16:30:00',3.67),('8537','2013-06-03','16:35:00',3.41),('8537','2013-06-03','16:40:00',3.46),('8537','2013-06-03','16:45:00',3.01),('8537','2013-06-03','16:50:00',2.26),('8537','2013-06-03','16:55:00',1.99),('8537','2013-06-03','17:00:00',2.55),('8537','2013-06-03','17:05:00',2.85),('8537','2013-06-03','17:10:00',2.77),('8537','2013-06-03','17:15:00',2.65),('8537','2013-06-03','17:20:00',2.2),('8537','2013-06-03','17:25:00',1.67),('8537','2013-06-02','06:55:00',1.01),('8537','2013-06-02','07:00:00',1.04),('8537','2013-06-02','08:35:00',1.04),('8537','2013-06-02','08:40:00',1.04),('8537','2013-06-02','08:45:00',1.14),('8537','2013-06-02','08:50:00',1.25),('8537','2013-06-02','08:55:00',1.1),('8537','2013-06-02','09:00:00',1.08),('8537','2013-06-02','09:05:00',1.17),('8537','2013-06-02','09:10:00',1.31),('8537','2013-06-02','09:15:00',1.37),('8537','2013-06-02','09:20:00',2.85),('8537','2013-06-02','09:25:00',3.9),('8537','2013-06-02','09:30:00',3.73),('8537','2013-06-02','09:35:00',3.7),('8537','2013-06-02','09:40:00',3.65),('8537','2013-06-02','09:45:00',3.76),('8537','2013-06-02','09:50:00',3.84),('8537','2013-06-02','09:55:00',3.89),('8537','2013-06-02','10:00:00',3.97),('8537','2013-06-02','10:05:00',3.98),('8537','2013-06-02','10:10:00',4.07),('8537','2013-06-02','10:15:00',4.17),('8537','2013-06-02','10:20:00',4.31),('8537','2013-06-02','10:25:00',4.35),('8537','2013-06-02','10:30:00',4.65),('8537','2013-06-02','10:35:00',5),('8537','2013-06-02','10:40:00',4.91),('8537','2013-06-02','10:45:00',3.27),('8537','2013-06-02','10:50:00',2.79),('8537','2013-06-02','10:55:00',3.38),('8537','2013-06-02','11:00:00',4.85),('8537','2013-06-02','11:05:00',5.19),('8537','2013-06-02','11:10:00',4.32),('8537','2013-06-02','11:15:00',2.19),('8537','2013-06-02','11:20:00',3.85),('8537','2013-06-02','11:25:00',4.46),('8537','2013-06-02','11:30:00',4.96),('8537','2013-06-02','11:35:00',1.92),('8537','2013-06-02','11:40:00',1.86),('8537','2013-06-02','11:45:00',1.54),('8537','2013-06-02','11:50:00',3.13),('8537','2013-06-02','11:55:00',3.39),('8537','2013-06-02','12:00:00',3.73),('8537','2013-06-02','12:05:00',1.87),('8537','2013-06-02','12:10:00',2.41),('8537','2013-06-02','12:15:00',5.13),('8537','2013-06-02','12:20:00',2.5),('8537','2013-06-02','12:25:00',2.3),('8537','2013-06-02','12:30:00',2.48),('8537','2013-06-02','12:35:00',4.64),('8537','2013-06-02','12:40:00',4.26),('8537','2013-06-02','12:45:00',4.69),('8537','2013-06-02','12:50:00',2.31),('8537','2013-06-02','12:55:00',3.43),('8537','2013-06-02','13:00:00',2.21),('8537','2013-06-02','13:05:00',1.61),('8537','2013-06-02','13:10:00',1.78),('8537','2013-06-02','13:15:00',5.9),('8537','2013-06-02','13:20:00',5.55),('8537','2013-06-02','13:25:00',5.33),('8537','2013-06-02','13:30:00',5.28),('8537','2013-06-02','13:35:00',5.27),('8537','2013-06-02','13:40:00',5.24),('8537','2013-06-02','13:45:00',5.17),('8537','2013-06-02','13:50:00',5.15),('8537','2013-06-02','13:55:00',5.16),('8537','2013-06-02','14:00:00',5.1),('8537','2013-06-02','14:05:00',5.1),('8537','2013-06-02','14:10:00',5.18),('8537','2013-06-02','14:15:00',5.13),('8537','2013-06-02','14:20:00',5.04),('8537','2013-06-02','14:25:00',5.02),('8537','2013-06-02','14:30:00',4.99),('8537','2013-06-02','14:35:00',4.93),('8537','2013-06-02','14:40:00',4.8),('8537','2013-06-02','14:45:00',4.44),('8537','2013-06-02','14:50:00',4.31),('8537','2013-06-02','14:55:00',4.67),('8537','2013-06-02','15:00:00',4.65),('8537','2013-06-02','15:05:00',4.59),('8537','2013-06-02','15:10:00',4.53),('8537','2013-06-02','15:15:00',4.55),('8537','2013-06-02','15:20:00',4.36),('8537','2013-06-02','15:25:00',3.97),('8537','2013-06-02','15:30:00',4.51),('8537','2013-06-02','15:35:00',2.93),('8537','2013-06-02','15:40:00',2.59),('8537','2013-06-02','15:45:00',4.22),('8537','2013-06-02','15:50:00',3.97),('8537','2013-06-02','15:55:00',2.82),('8537','2013-06-02','16:00:00',4.22),('8537','2013-06-02','16:05:00',4.02),('8537','2013-06-02','16:10:00',3.77),('8537','2013-06-02','16:15:00',3.59),('8537','2013-06-02','16:20:00',3.73),('8537','2013-06-02','16:25:00',3.32),('8537','2013-06-02','16:30:00',3.49),('8537','2013-06-02','16:35:00',3.21),('8537','2013-06-02','16:40:00',3.42),('8537','2013-06-02','16:45:00',3.28),('8537','2013-06-02','16:50:00',2.88),('8537','2013-06-02','16:55:00',3.11),('8537','2013-06-02','17:00:00',3.01),('8537','2013-06-02','17:05:00',2.58),('8537','2013-06-02','17:10:00',2.75),('8537','2013-06-02','17:15:00',2.68),('8537','2013-06-02','17:20:00',2.53),('8537','2013-06-02','17:25:00',2.42),('8537','2013-06-02','17:30:00',2.17),('8537','2013-06-02','17:35:00',1.65),('8537','2013-06-02','17:40:00',1.19),('8537','2013-06-02','17:45:00',1.04),('8537','2013-06-02','17:50:00',1.28),('8537','2013-06-02','18:00:00',1.14),('8537','2013-06-01','07:25:00',1.06),('8537','2013-06-01','07:30:00',1.16),('8537','2013-06-01','07:35:00',1.26),('8537','2013-06-01','07:40:00',1.4),('8537','2013-06-01','07:45:00',1.65),('8537','2013-06-01','07:50:00',1.13),('8537','2013-06-01','07:55:00',1.56),('8537','2013-06-01','08:10:00',1),('8537','2013-06-01','08:15:00',1.55),('8537','2013-06-01','08:20:00',1.36),('8537','2013-06-01','08:30:00',1.41),('8537','2013-06-01','08:35:00',2.01),('8537','2013-06-01','09:45:00',1),('8537','2013-06-01','09:50:00',1.2),('8537','2013-06-01','10:35:00',1.36),('8537','2013-06-01','10:40:00',1.36),('8537','2013-06-01','10:50:00',2.47),('8537','2013-06-01','10:55:00',3.09),('8537','2013-06-01','11:50:00',1.64),('8537','2013-06-01','11:55:00',2.15),('8537','2013-06-01','12:00:00',2.8),('8537','2013-06-01','12:05:00',3.62),('8537','2013-06-01','12:10:00',3.93),('8537','2013-06-01','12:15:00',1.71),('8537','2013-06-01','12:20:00',1.31),('8537','2013-06-01','12:25:00',1.44),('8537','2013-06-01','12:30:00',1.41),('8537','2013-06-01','12:35:00',1.07),('8537','2013-06-01','12:40:00',1.22),('8537','2013-06-01','12:45:00',1.99),('8537','2013-06-01','12:50:00',2.17),('8537','2013-06-01','12:55:00',2.16),('8537','2013-06-01','13:00:00',2.57),('8537','2013-06-01','13:05:00',2.74),('8537','2013-06-01','13:10:00',2.84),('8537','2013-06-01','13:15:00',3.07),('8537','2013-06-01','13:20:00',2.68),('8537','2013-06-01','13:25:00',2.09),('8537','2013-06-01','13:30:00',1.82),('8537','2013-06-01','13:35:00',1.44),('8537','2013-06-01','13:40:00',1.28),('8537','2013-06-01','13:45:00',1.45),('8537','2013-06-01','13:50:00',1.57),('8537','2013-06-01','13:55:00',1.77),('8537','2013-06-01','14:00:00',2.32),('8537','2013-06-01','14:05:00',2.81),('8537','2013-06-01','14:10:00',2.75),('8537','2013-06-01','14:15:00',2.92),('8537','2013-06-01','14:20:00',3),('8537','2013-06-01','14:25:00',1.91),('8537','2013-06-01','14:30:00',1.54),('8537','2013-06-01','14:35:00',1.59),('8537','2013-06-01','14:40:00',1.53),('8537','2013-06-01','14:45:00',1.45),('8537','2013-06-01','14:50:00',1.32),('8537','2013-06-01','14:55:00',1.05),('8537','2013-06-01','15:00:00',1.03),('8537','2013-06-01','15:05:00',1.03),('8537','2013-06-01','18:30:00',1.06),('8537','2013-06-01','18:35:00',1.25),('8537','2013-06-01','19:00:00',1.12),('8537','2014-04-02','08:05:00',1.13),('8537','2014-04-02','08:20:00',1.04),('8537','2014-04-02','08:50:00',1.24),('8537','2014-04-02','08:55:00',2.48),('8537','2014-04-02','09:00:00',1.24),('8537','2014-04-02','09:05:00',1.11),('8537','2014-04-02','09:15:00',1.05),('8537','2014-04-02','09:20:00',1.06),('8537','2014-04-02','09:40:00',1.37),('8537','2014-04-02','09:55:00',1.96),('8537','2014-04-02','10:00:00',3.52),('8537','2014-04-02','10:05:00',2.36),('8537','2014-04-02','10:10:00',3.77),('8537','2014-04-02','10:15:00',3.96),('8537','2014-04-02','10:20:00',4.4),('8537','2014-04-02','10:25:00',4.44),('8537','2014-04-02','10:30:00',3.01),('8537','2014-04-02','10:35:00',1.04),('8537','2014-04-02','10:40:00',1.11),('8537','2014-04-02','10:45:00',1.18),('8537','2014-04-02','10:50:00',2.04),('8537','2014-04-02','10:55:00',4.43),('8537','2014-04-02','11:00:00',4.23),('8537','2014-04-02','11:05:00',4.03),('8537','2014-04-02','11:10:00',2.86),('8537','2014-04-02','11:15:00',2.24),('8537','2014-04-02','11:20:00',4.59),('8537','2014-04-02','11:25:00',4.98),('8537','2014-04-02','11:30:00',4.29),('8537','2014-04-02','11:35:00',3.32),('8537','2014-04-02','11:40:00',3.63),('8537','2014-04-02','11:45:00',1.56),('8537','2014-04-02','11:50:00',3.94),('8537','2014-04-02','11:55:00',4.32),('8537','2014-04-02','12:00:00',5.49),('8537','2014-04-02','12:05:00',4.65),('8537','2014-04-02','12:10:00',1.51),('8537','2014-04-02','12:15:00',1.58),('8537','2014-04-02','12:20:00',4.67),('8537','2014-04-02','12:25:00',4.5),('8537','2014-04-02','12:30:00',1.96),('8537','2014-04-02','12:35:00',5.61),('8537','2014-04-02','12:40:00',5.39),('8537','2014-04-02','12:45:00',4.91),('8537','2014-04-02','12:50:00',5.34),('8537','2014-04-02','12:55:00',5.13),('8537','2014-04-02','13:00:00',2.32),('8537','2014-04-02','13:05:00',2.46),('8537','2014-04-02','13:10:00',5.15),('8537','2014-04-02','13:15:00',4.4),('8537','2014-04-02','13:20:00',3.65),('8537','2014-04-02','13:25:00',4.94),('8537','2014-04-02','13:30:00',5.32),('8537','2014-04-02','13:35:00',5.31),('8537','2014-04-02','13:40:00',5.44),('8537','2014-04-02','13:45:00',5.15),('8537','2014-04-02','13:50:00',4.99),('8537','2014-04-02','13:55:00',5.04),('8537','2014-04-02','14:00:00',4.98),('8537','2014-04-02','14:05:00',4.83),('8537','2014-04-02','14:10:00',4.99),('8537','2014-04-02','14:15:00',4.92),('8537','2014-04-02','14:20:00',4.85),('8537','2014-04-02','14:25:00',4.85),('8537','2014-04-02','14:30:00',4.77),('8537','2014-04-02','14:35:00',4.6),('8537','2014-04-02','14:40:00',4.3),('8537','2014-04-02','14:45:00',4.38),('8537','2014-04-02','14:50:00',3.17),('8537','2014-04-02','14:55:00',4.27),('8537','2014-04-02','15:00:00',4.09),('8537','2014-04-02','15:05:00',4.39),('8537','2014-04-02','15:10:00',4.08),('8537','2014-04-02','15:15:00',4.09),('8537','2014-04-02','15:20:00',4.08),('8537','2014-04-02','15:25:00',3.96),('8537','2014-04-02','15:30:00',3.74),('8537','2014-04-02','15:35:00',3.62),('8537','2014-04-02','15:40:00',3.78),('8537','2014-04-02','15:45:00',3.82),('8537','2014-04-02','15:50:00',3.76),('8537','2014-04-02','15:55:00',3.31),('8537','2014-04-02','16:00:00',3.4),('8537','2014-04-02','16:05:00',3.12),('8537','2014-04-02','16:10:00',3.29),('8537','2014-04-02','16:15:00',3.25),('8537','2014-04-02','16:20:00',3.11),('8537','2014-04-02','16:25:00',3.07),('8537','2014-04-02','16:30:00',3.04),('8537','2014-04-02','16:35:00',2.83),('8537','2014-04-02','16:40:00',2.78),('8537','2014-04-02','16:45:00',2.7),('8537','2014-04-02','16:50:00',2.48),('8537','2014-04-02','16:55:00',2.38),('8537','2014-04-02','17:00:00',2.31),('8537','2014-04-02','17:05:00',2.18),('8537','2014-04-02','17:10:00',2.08),('8537','2014-04-02','17:15:00',1.84),('8537','2014-04-02','17:20:00',1.82),('8537','2014-04-02','17:25:00',1.69),('8537','2014-04-02','17:30:00',1.51),('8537','2014-04-02','17:35:00',1.45),('8537','2014-04-02','17:40:00',1.08),('8537','2014-04-02','17:45:00',1.1),('8537','2014-04-02','17:50:00',1.29),('8537','2014-04-02','17:55:00',1.1),('8537','2014-04-02','18:00:00',1),('8537','2013-05-31','07:25:00',1.08),('8537','2013-05-31','07:30:00',1.19),('8537','2013-05-31','07:35:00',1.28),('8537','2013-05-31','07:40:00',1.41),('8537','2013-05-31','07:45:00',1.51),('8537','2013-05-31','07:50:00',1.62),('8537','2013-05-31','07:55:00',1.76),('8537','2013-05-31','08:00:00',1.88),('8537','2013-05-31','08:05:00',1.96),('8537','2013-05-31','08:10:00',2.06),('8537','2013-05-31','08:15:00',2.16),('8537','2013-05-31','08:20:00',2.26),('8537','2013-05-31','08:25:00',2.41),('8537','2013-05-31','08:30:00',2.58),('8537','2013-05-31','08:35:00',2.31),('8537','2013-05-31','08:40:00',2.99),('8537','2013-05-31','08:45:00',1.53),('8537','2013-05-31','08:50:00',2.69),('8537','2013-05-31','08:55:00',1.81),('8537','2013-05-31','09:00:00',1.07),('8537','2013-05-31','09:10:00',1.36),('8537','2013-05-31','09:15:00',1.59),('8537','2013-05-31','09:25:00',1.05),('8537','2013-05-31','09:30:00',1.84),('8537','2013-05-31','09:35:00',2.49),('8537','2013-05-31','09:40:00',2.97),('8537','2013-05-31','09:45:00',3.57),('8537','2013-05-31','09:50:00',4.27),('8537','2013-05-31','09:55:00',4.45),('8537','2013-05-31','10:00:00',4.17),('8537','2013-05-31','10:05:00',2.82),('8537','2013-05-31','10:10:00',2),('8537','2013-05-31','10:15:00',4.07),('8537','2013-05-31','10:20:00',4.11),('8537','2013-05-31','10:25:00',1.56),('8537','2013-05-31','10:30:00',2.7),('8537','2013-05-31','10:35:00',2.58),('8537','2013-05-31','10:40:00',4.46),('8537','2013-05-31','10:45:00',5.32),('8537','2013-05-31','10:50:00',2.91),('8537','2013-05-31','10:55:00',4.52),('8537','2013-05-31','11:00:00',1.71),('8537','2013-05-31','11:05:00',2.13),('8537','2013-05-31','11:10:00',5.33),('8537','2013-05-31','11:15:00',5.81),('8537','2013-05-31','11:20:00',1.52),('8537','2013-05-31','11:25:00',2.14),('8537','2013-05-31','11:30:00',4.32),('8537','2013-05-31','11:35:00',2.86),('8537','2013-05-31','11:40:00',1.11),('8537','2013-05-31','11:45:00',4.21),('8537','2013-05-31','11:50:00',4.75),('8537','2013-05-31','11:55:00',2.97),('8537','2013-05-31','12:00:00',2.94),('8537','2013-05-31','12:05:00',5.49),('8537','2013-05-31','12:10:00',4.7),('8537','2013-05-31','12:15:00',1.86),('8537','2013-05-31','12:20:00',1.87),('8537','2013-05-31','12:25:00',4.32),('8537','2013-05-31','12:30:00',2),('8537','2013-05-31','12:35:00',2.13),('8537','2013-05-31','12:40:00',4.83),('8537','2013-05-31','12:45:00',2.86),('8537','2013-05-31','12:50:00',1.04),('8537','2013-05-31','12:55:00',1.62),('8537','2013-05-31','13:00:00',5.05),('8537','2013-05-31','13:05:00',2.54),('8537','2013-05-31','13:20:00',1.27),('8537','2013-05-31','13:25:00',2.11),('8537','2013-05-31','13:30:00',4.11),('8537','2013-05-31','13:35:00',5.52),('8537','2013-05-31','13:40:00',3.23),('8537','2013-05-31','13:45:00',1.59),('8537','2013-05-31','13:55:00',1.11),('8537','2013-05-31','14:00:00',2.69),('8537','2013-05-31','14:05:00',1.03),('8537','2013-05-31','14:25:00',1.17),('8537','2013-05-31','15:05:00',1.71),('8537','2013-05-31','15:10:00',2.06),('8537','2013-05-31','15:15:00',2.9),('8537','2013-05-31','15:20:00',5.89),('8537','2013-05-31','15:25:00',4.16),('8537','2013-05-31','15:30:00',3.01),('8537','2013-05-31','15:35:00',2.43),('8537','2013-05-31','15:40:00',2.05),('8537','2013-05-31','15:45:00',1.83),('8537','2013-05-31','15:50:00',2.67),('8537','2013-05-31','15:55:00',2.44),('8537','2013-05-31','16:00:00',1.83),('8537','2013-05-31','16:05:00',1.51),('8537','2013-05-31','16:10:00',1.16),('8537','2013-05-31','16:15:00',1.05),('8537','2013-05-31','16:20:00',1.2),('8537','2013-05-31','16:25:00',1.54),('8537','2013-05-31','16:30:00',1.44),('8537','2013-05-31','16:35:00',1.22),('8537','2013-05-31','16:40:00',1.36),('8537','2013-05-31','16:45:00',1.43),('8537','2013-05-31','16:50:00',1.01),('8537','2013-05-30','07:50:00',1.25),('8537','2013-05-30','08:25:00',1.55),('8537','2013-05-30','08:30:00',1.17),('8537','2013-05-30','08:40:00',2.76),('8537','2013-05-30','08:45:00',2.89),('8537','2013-05-30','08:50:00',2.96),('8537','2013-05-30','08:55:00',3.04),('8537','2013-05-30','09:00:00',3.15),('8537','2013-05-30','09:05:00',3.22),('8537','2013-05-30','09:10:00',3.34),('8537','2013-05-30','09:15:00',3.44),('8537','2013-05-30','09:20:00',3.59),('8537','2013-05-30','09:25:00',3.69),('8537','2013-05-30','09:30:00',3.76),('8537','2013-05-30','09:35:00',3.77),('8537','2013-05-30','09:40:00',3.93),('8537','2013-05-30','09:45:00',3.71),('8537','2013-05-30','09:50:00',3.76),('8537','2013-05-30','09:55:00',2.98),('8537','2013-05-30','10:00:00',1.32),('8537','2013-05-30','10:05:00',1.88),('8537','2013-05-30','10:10:00',4.33),('8537','2013-05-30','10:15:00',1.71),('8537','2013-05-30','10:20:00',5.21),('8537','2013-05-30','10:25:00',1.4),('8537','2013-05-30','10:30:00',1.41),('8537','2013-05-30','10:35:00',1.5),('8537','2013-05-30','10:40:00',3.59),('8537','2013-05-30','10:45:00',4.4),('8537','2013-05-30','10:50:00',5.04),('8537','2013-05-30','10:55:00',4.1),('8537','2013-05-30','11:00:00',5.22),('8537','2013-05-30','11:05:00',5.54),('8537','2013-05-30','11:10:00',2.25),('8537','2013-05-30','11:15:00',2.1),('8537','2013-05-30','11:20:00',5.21),('8537','2013-05-30','11:25:00',2.13),('8537','2013-05-30','11:30:00',4.5),('8537','2013-05-30','11:35:00',5.96),('8537','2013-05-30','11:40:00',5.85),('8537','2013-05-30','11:45:00',4.44),('8537','2013-05-30','11:50:00',5.89),('8537','2013-05-30','11:55:00',1.29),('8537','2013-05-30','12:00:00',4.72),('8537','2013-05-30','12:05:00',5.98),('8537','2013-05-30','12:10:00',2.87),('8537','2013-05-30','12:15:00',5.42),('8537','2013-05-30','12:20:00',4.9),('8537','2013-05-30','12:25:00',3.87),('8537','2013-05-30','12:30:00',4.18),('8537','2013-05-30','12:35:00',3.99),('8537','2013-05-30','12:40:00',4.74),('8537','2013-05-30','12:45:00',2.19),('8537','2013-05-30','12:50:00',5.1),('8537','2013-05-30','12:55:00',5.24),('8537','2013-05-30','13:00:00',4.71),('8537','2013-05-30','13:05:00',4.12),('8537','2013-05-30','13:10:00',2.56),('8537','2013-05-30','13:15:00',3.15),('8537','2013-05-30','13:20:00',2.1),('8537','2013-05-30','13:25:00',2.14),('8537','2013-05-30','13:30:00',2.98),('8537','2013-05-30','13:35:00',2.04),('8537','2013-05-30','13:40:00',5.15),('8537','2013-05-30','13:45:00',4.85),('8537','2013-05-30','13:50:00',2.12),('8537','2013-05-30','13:55:00',2.19),('8537','2013-05-30','14:00:00',5.06),('8537','2013-05-30','14:05:00',5.67),('8537','2013-05-30','14:10:00',3.83),('8537','2013-05-30','14:15:00',4.77),('8537','2013-05-30','14:20:00',4.46),('8537','2013-05-30','14:25:00',4.5),('8537','2013-05-30','14:30:00',5.24),('8537','2013-05-30','14:35:00',4.42),('8537','2013-05-30','14:40:00',5.29),('8537','2013-05-30','14:45:00',4.95),('8537','2013-05-30','14:50:00',4.49),('8537','2013-05-30','14:55:00',5.12),('8537','2013-05-30','15:00:00',4.73),('8537','2013-05-30','15:05:00',4.62),('8537','2013-05-30','15:10:00',1.99),('8537','2013-05-30','15:15:00',4.87),('8537','2013-05-30','15:20:00',5.06),('8537','2013-05-30','15:25:00',4.79),('8537','2013-05-30','15:30:00',4.67),('8537','2013-05-30','15:35:00',4.58),('8537','2013-05-30','15:40:00',4.96),('8537','2013-05-30','15:45:00',4.98),('8537','2013-05-30','15:50:00',3.15),('8537','2013-05-30','15:55:00',3.73),('8537','2013-05-30','16:00:00',4.65),('8537','2013-05-30','16:05:00',4.45),('8537','2013-05-30','16:10:00',4.39),('8537','2013-05-30','16:15:00',4.14),('8537','2013-05-30','16:20:00',3.79),('8537','2013-05-30','16:25:00',2.84),('8537','2013-05-30','16:30:00',1.69),('8537','2013-05-30','16:35:00',2.25),('8537','2013-05-30','16:40:00',1.47),('8537','2013-05-30','16:45:00',2.75),('8537','2013-05-30','16:50:00',2.91),('8537','2013-05-30','16:55:00',2.58),('8537','2013-05-30','17:00:00',1.93),('8537','2013-05-30','17:05:00',1.75),('8537','2013-05-30','17:15:00',1.14),('8537','2013-05-30','17:20:00',1.22),('8537','2013-05-30','17:25:00',1.13),('8537','2013-05-30','17:30:00',1.11),('8537','2013-05-30','18:00:00',1.03),('8537','2013-05-30','18:05:00',1.16),('8537','2013-05-30','18:10:00',1.1),('8537','2013-05-30','18:35:00',1.21),('8537','2013-05-30','18:40:00',1.24),('8537','2013-05-30','18:45:00',1.35),('8537','2013-05-30','18:50:00',1.27),('8537','2013-05-29','07:25:00',1.02),('8537','2013-05-29','07:30:00',1.13),('8537','2013-05-29','07:35:00',1.25),('8537','2013-05-29','07:40:00',1.36),('8537','2013-05-29','07:45:00',1.46),('8537','2013-05-29','07:50:00',1.57),('8537','2013-05-29','07:55:00',1.67),('8537','2013-05-29','08:00:00',1.79),('8537','2013-05-29','08:05:00',1.9),('8537','2013-05-29','08:10:00',2.02),('8537','2013-05-29','08:15:00',2.12),('8537','2013-05-29','08:20:00',2.17),('8537','2013-05-29','08:25:00',2.31),('8537','2013-05-29','08:30:00',2.44),('8537','2013-05-29','08:35:00',2.55),('8537','2013-05-29','08:40:00',2.65),('8537','2013-05-29','08:45:00',2.74),('8537','2013-05-29','08:50:00',2.84),('8537','2013-05-29','08:55:00',2.95),('8537','2013-05-29','09:00:00',3.05),('8537','2013-05-29','09:05:00',3.14),('8537','2013-05-29','09:10:00',3.23),('8537','2013-05-29','09:15:00',3.32),('8537','2013-05-29','09:20:00',3.4),('8537','2013-05-29','09:25:00',3.49),('8537','2013-05-29','09:30:00',3.56),('8537','2013-05-29','09:35:00',3.61),('8537','2013-05-29','09:40:00',3.75),('8537','2013-05-29','09:45:00',3.82),('8537','2013-05-29','09:50:00',3.93),('8537','2013-05-29','09:55:00',4.01),('8537','2013-05-29','10:00:00',4.04),('8537','2013-05-29','10:05:00',4.14),('8537','2013-05-29','10:10:00',4.2),('8537','2013-05-29','10:15:00',4.26),('8537','2013-05-29','10:20:00',4.36),('8537','2013-05-29','10:25:00',4.43),('8537','2013-05-29','10:30:00',4.5),('8537','2013-05-29','10:35:00',4.58),('8537','2013-05-29','10:40:00',4.61),('8537','2013-05-29','10:45:00',4.7),('8537','2013-05-29','10:50:00',4.75),('8537','2013-05-29','10:55:00',4.8),('8537','2013-05-29','11:00:00',4.87),('8537','2013-05-29','11:05:00',4.35),('8537','2013-05-29','11:10:00',4.98),('8537','2013-05-29','11:15:00',3.22),('8537','2013-05-29','11:20:00',5.27),('8537','2013-05-29','11:25:00',5.35),('8537','2013-05-29','11:30:00',5.03),('8537','2013-05-29','11:35:00',5.46),('8537','2013-05-29','11:40:00',4.79),('8537','2013-05-29','11:45:00',4.48),('8537','2013-05-29','11:50:00',4.49),('8537','2013-05-29','11:55:00',4.93),('8537','2013-05-29','12:00:00',4.65),('8537','2013-05-29','12:05:00',2.94),('8537','2013-05-29','12:10:00',4.9),('8537','2013-05-29','12:15:00',4.46),('8537','2013-05-29','12:20:00',5.18),('8537','2013-05-29','12:25:00',5.6),('8537','2013-05-29','12:30:00',5.46),('8537','2013-05-29','12:35:00',5.37),('8537','2013-05-29','12:40:00',5.15),('8537','2013-05-29','12:45:00',4.95),('8537','2013-05-29','12:50:00',5.22),('8537','2013-05-29','12:55:00',5.35),('8537','2013-05-29','13:00:00',5.51),('8537','2013-05-29','13:05:00',5.2),('8537','2013-05-29','13:10:00',4.57),('8537','2013-05-29','13:15:00',4.61),('8537','2013-05-29','13:20:00',4.95),('8537','2013-05-29','13:25:00',5.67),('8537','2013-05-29','13:30:00',5.73),('8537','2013-05-29','13:35:00',5),('8537','2013-05-29','13:40:00',5.68),('8537','2013-05-29','13:45:00',5.07),('8537','2013-05-29','13:50:00',4.66),('8537','2013-05-29','13:55:00',4.51),('8537','2013-05-29','14:00:00',5.39),('8537','2013-05-29','14:05:00',5.25),('8537','2013-05-29','14:10:00',5.12),('8537','2013-05-29','14:15:00',5.27),('8537','2013-05-29','14:20:00',5.27),('8537','2013-05-29','14:25:00',4.92),('8537','2013-05-29','14:30:00',5.24),('8537','2013-05-29','14:35:00',3.25),('8537','2013-05-29','14:40:00',5.3),('8537','2013-05-29','14:45:00',5.19),('8537','2013-05-29','14:50:00',5.05),('8537','2013-05-29','14:55:00',4.77),('8537','2013-05-29','15:00:00',4.67),('8537','2013-05-29','15:05:00',5.27),('8537','2013-05-29','15:10:00',4.7),('8537','2013-05-29','15:15:00',2.56),('8537','2013-05-29','15:20:00',3.8),('8537','2013-05-29','15:25:00',3.45),('8537','2013-05-29','15:30:00',3.39),('8537','2013-05-29','15:35:00',3.6),('8537','2013-05-29','15:40:00',2.96),('8537','2013-05-29','15:45:00',3.59),('8537','2013-05-29','15:50:00',3.46),('8537','2013-05-29','15:55:00',3.35),('8537','2013-05-29','16:00:00',3),('8537','2013-05-29','16:05:00',2.99),('8537','2013-05-29','16:10:00',2.56),('8537','2013-05-29','16:15:00',2.41),('8537','2013-05-29','16:20:00',2.35),('8537','2013-05-29','16:25:00',2.32),('8537','2013-05-29','16:30:00',2.13),('8537','2013-05-29','16:35:00',2.07),('8537','2013-05-29','16:40:00',2.37),('8537','2013-05-29','16:45:00',2.18),('8537','2013-05-29','16:50:00',1.73),('8537','2013-05-29','16:55:00',1.68),('8537','2013-05-29','17:00:00',1.59),('8537','2013-05-29','17:35:00',1.22),('8537','2013-05-29','17:40:00',1.69),('8537','2013-05-29','17:45:00',1.28),('8537','2013-05-29','18:05:00',1.11),('8537','2013-05-29','18:10:00',1.16),('8537','2013-05-29','18:15:00',1.84),('8537','2013-05-29','18:20:00',1.63),('8537','2013-05-28','07:15:00',1.02),('8537','2013-05-28','07:20:00',1.2),('8537','2013-05-28','07:25:00',1.26),('8537','2013-05-28','07:30:00',1.02),('8537','2013-05-28','07:40:00',1.23),('8537','2013-05-28','07:45:00',1.33),('8537','2013-05-28','07:50:00',1.32),('8537','2013-05-28','07:55:00',1.34),('8537','2013-05-28','08:00:00',1.38),('8537','2013-05-28','08:05:00',1.47),('8537','2013-05-28','08:10:00',1.68),('8537','2013-05-28','08:15:00',1.95),('8537','2013-05-28','08:20:00',2.14),('8537','2013-05-28','08:25:00',1.94),('8537','2013-05-28','08:30:00',2.11),('8537','2013-05-28','08:35:00',1.97),('8537','2013-05-28','08:40:00',1.71),('8537','2013-05-28','08:45:00',1.64),('8537','2013-05-28','08:50:00',1.89),('8537','2013-05-28','08:55:00',1.79),('8537','2013-05-28','09:00:00',1.96),('8537','2013-05-28','09:05:00',2.13),('8537','2013-05-28','09:10:00',1.96),('8537','2013-05-28','09:15:00',1.85),('8537','2013-05-28','09:20:00',2.16),('8537','2013-05-28','09:25:00',2.51),('8537','2013-05-28','09:30:00',2.7),('8537','2013-05-28','09:35:00',2.78),('8537','2013-05-28','09:40:00',2.66),('8537','2013-05-28','09:45:00',2.45),('8537','2013-05-28','09:50:00',2.52),('8537','2013-05-28','09:55:00',2.65),('8537','2013-05-28','10:00:00',2.5),('8537','2013-05-28','10:05:00',2.66),('8537','2013-05-28','10:10:00',2.95),('8537','2013-05-28','10:15:00',3.08),('8537','2013-05-28','10:20:00',3.25),('8537','2013-05-28','10:25:00',3.18),('8537','2013-05-28','10:30:00',3.56),('8537','2013-05-28','10:35:00',3.69),('8537','2013-05-28','10:40:00',3.19),('8537','2013-05-28','10:45:00',3.02),('8537','2013-05-28','10:50:00',3.35),('8537','2013-05-28','10:55:00',2.85),('8537','2013-05-28','11:00:00',2.87),('8537','2013-05-28','11:05:00',2.85),('8537','2013-05-28','11:10:00',3.09),('8537','2013-05-28','11:15:00',2.42),('8537','2013-05-28','11:20:00',2.61),('8537','2013-05-28','11:25:00',2.33),('8537','2013-05-28','11:30:00',4.5),('8537','2013-05-28','11:35:00',3.52),('8537','2013-05-28','11:40:00',4.36),('8537','2013-05-28','11:45:00',4.32),('8537','2013-05-28','11:50:00',1.39),('8537','2013-05-28','11:55:00',1.94),('8537','2013-05-28','12:00:00',1.94),('8537','2013-05-28','12:05:00',2.19),('8537','2013-05-28','12:10:00',3.57),('8537','2013-05-28','12:15:00',3.23),('8537','2013-05-28','12:20:00',2.74),('8537','2013-05-28','12:25:00',2.83),('8537','2013-05-28','12:30:00',3.18),('8537','2013-05-28','12:35:00',3.06),('8537','2013-05-28','12:40:00',3.12),('8537','2013-05-28','12:45:00',3.58),('8537','2013-05-28','12:50:00',3.16),('8537','2013-05-28','12:55:00',3.16),('8537','2013-05-28','13:00:00',3.22),('8537','2013-05-28','13:05:00',3.48),('8537','2013-05-28','13:10:00',3.63),('8537','2013-05-28','13:15:00',3.2),('8537','2013-05-28','13:20:00',4.27),('8537','2013-05-28','13:25:00',2.19),('8537','2013-05-28','13:30:00',2.6),('8537','2013-05-28','13:35:00',2.13),('8537','2013-05-28','13:40:00',2.34),('8537','2013-05-28','13:45:00',2.25),('8537','2013-05-28','13:50:00',3.33),('8537','2013-05-28','13:55:00',3.16),('8537','2013-05-28','14:00:00',3.09),('8537','2013-05-28','14:05:00',3.25),('8537','2013-05-28','14:10:00',4.67),('8537','2013-05-28','14:15:00',4.58),('8537','2013-05-28','14:20:00',3),('8537','2013-05-28','14:25:00',3.33),('8537','2013-05-28','14:30:00',4.04),('8537','2013-05-28','14:35:00',3.64),('8537','2013-05-28','14:40:00',3.89),('8537','2013-05-28','14:45:00',4.6),('8537','2013-05-28','14:50:00',3.35),('8537','2013-05-28','14:55:00',3.04),('8537','2013-05-28','15:00:00',2.68),('8537','2013-05-28','15:05:00',4.31),('8537','2013-05-28','15:10:00',1.98),('8537','2013-05-28','15:15:00',2.97),('8537','2013-05-28','15:20:00',3.68),('8537','2013-05-28','15:25:00',2.42),('8537','2013-05-28','15:30:00',1.78),('8537','2013-05-28','15:35:00',1.82),('8537','2013-05-28','15:40:00',2.8),('8537','2013-05-28','15:45:00',4.27),('8537','2013-05-28','15:50:00',3.51),('8537','2013-05-28','15:55:00',2.72),('8537','2013-05-28','16:00:00',1.91),('8537','2013-05-28','16:05:00',1.54),('8537','2013-05-28','16:10:00',1.64),('8537','2013-05-28','16:15:00',1.74),('8537','2013-05-28','16:20:00',2.46),('8537','2013-05-28','16:25:00',2.3),('8537','2013-05-28','16:30:00',2.4),('8537','2013-05-28','16:35:00',3.36),('8537','2013-05-28','16:40:00',3.15),('8537','2013-05-28','16:45:00',3.03),('8537','2013-05-28','16:50:00',2.95),('8537','2013-05-28','16:55:00',2.87),('8537','2013-05-28','17:00:00',2.77),('8537','2013-05-28','17:05:00',2.68),('8537','2013-05-28','17:10:00',2.56),('8537','2013-05-28','17:15:00',2.49),('8537','2013-05-28','17:20:00',2.37),('8537','2013-05-28','17:25:00',2.2),('8537','2013-05-28','17:30:00',2.11),('8537','2013-05-28','17:35:00',1.99),('8537','2013-05-28','17:40:00',1.63),('8537','2013-05-28','17:45:00',1.72),('8537','2013-05-28','17:50:00',1.71),('8537','2013-05-28','17:55:00',1.59),('8537','2013-05-28','18:00:00',1.59),('8537','2013-05-28','18:05:00',1.49),('8537','2013-05-28','18:10:00',1.03),('8537','2013-05-27','07:25:00',1.04),('8537','2013-05-27','07:30:00',1.21),('8537','2013-05-27','07:35:00',1.27),('8537','2013-05-27','07:40:00',1.34),('8537','2013-05-27','07:45:00',1.52),('8537','2013-05-27','07:50:00',1.33),('8537','2013-05-27','08:00:00',1.53),('8537','2013-05-27','08:05:00',1.95),('8537','2013-05-27','08:10:00',2.23),('8537','2013-05-27','08:15:00',2.06),('8537','2013-05-27','08:20:00',1.93),('8537','2013-05-27','08:25:00',1.94),('8537','2013-05-27','08:30:00',2.5),('8537','2013-05-27','08:35:00',2.57),('8537','2013-05-27','08:40:00',2.71),('8537','2013-05-27','08:45:00',2.87),('8537','2013-05-27','08:50:00',3.27),('8537','2013-05-27','08:55:00',3.22),('8537','2013-05-27','09:00:00',3.29),('8537','2013-05-27','09:05:00',3.61),('8537','2013-05-27','09:10:00',2.75),('8537','2013-05-27','09:15:00',3.02),('8537','2013-05-27','09:20:00',2.53),('8537','2013-05-27','09:25:00',3.03),('8537','2013-05-27','09:30:00',3.69),('8537','2013-05-27','09:35:00',3.84),('8537','2013-05-27','09:40:00',3.9),('8537','2013-05-27','09:45:00',4),('8537','2013-05-27','09:50:00',3.95),('8537','2013-05-27','09:55:00',4.26),('8537','2013-05-27','10:00:00',4.33),('8537','2013-05-27','10:05:00',4.37),('8537','2013-05-27','10:10:00',4.43),('8537','2013-05-27','10:15:00',4.54),('8537','2013-05-27','10:20:00',3.6),('8537','2013-05-27','10:25:00',2.41),('8537','2013-05-27','10:30:00',3.41),('8537','2013-05-27','10:35:00',1.39),('8537','2013-05-27','10:40:00',2.55),('8537','2013-05-27','10:45:00',3.36),('8537','2013-05-27','10:50:00',3.02),('8537','2013-05-27','10:55:00',2.98),('8537','2013-05-27','11:00:00',3.91),('8537','2013-05-27','11:05:00',4.96),('8537','2013-05-27','11:10:00',3.65),('8537','2013-05-27','11:15:00',2.83),('8537','2013-05-27','11:20:00',3.63),('8537','2013-05-27','11:25:00',5.14),('8537','2013-05-27','11:30:00',2.67),('8537','2013-05-27','11:35:00',2.85),('8537','2013-05-27','11:40:00',4.08),('8537','2013-05-27','11:45:00',3.9),('8537','2013-05-27','11:50:00',2.53),('8537','2013-05-27','11:55:00',2.93),('8537','2013-05-27','12:00:00',5.56),('8537','2013-05-27','12:05:00',3.18),('8537','2013-05-27','12:10:00',4.19),('8537','2013-05-27','12:15:00',4.98),('8537','2013-05-27','12:20:00',5.32),('8537','2013-05-27','12:25:00',5.12),('8537','2013-05-27','12:30:00',5.56),('8537','2013-05-27','12:35:00',3.72),('8537','2013-05-27','12:40:00',5.67),('8537','2013-05-27','12:45:00',5.49),('8537','2013-05-27','12:50:00',5.5),('8537','2013-05-27','12:55:00',5.77),('8537','2013-05-27','13:00:00',5.11),('8537','2013-05-27','13:05:00',1.58),('8537','2013-05-27','13:10:00',5.51),('8537','2013-05-27','13:15:00',3.35),('8537','2013-05-27','13:20:00',3.99),('8537','2013-05-27','13:25:00',5.6),('8537','2013-05-27','13:30:00',5.63),('8537','2013-05-27','13:35:00',3.76),('8537','2013-05-27','13:40:00',5.93),('8537','2013-05-27','13:45:00',5.03),('8537','2013-05-27','13:50:00',4.16),('8537','2013-05-27','13:55:00',4.33),('8537','2013-05-27','14:00:00',5.33),('8537','2013-05-27','14:05:00',5.38),('8537','2013-05-27','14:10:00',4.45),('8537','2013-05-27','14:15:00',4.07),('8537','2013-05-27','14:20:00',3.3),('8537','2013-05-27','14:25:00',4.87),('8537','2013-05-27','14:30:00',4.59),('8537','2013-05-27','14:35:00',4.7),('8537','2013-05-27','14:40:00',1.41),('8537','2013-05-27','14:45:00',5.61),('8537','2013-05-27','14:50:00',5.26),('8537','2013-05-27','14:55:00',4.31),('8537','2013-05-27','15:00:00',3.3),('8537','2013-05-27','15:05:00',3.03),('8537','2013-05-27','15:10:00',4.84),('8537','2013-05-27','15:15:00',3.4),('8537','2013-05-27','15:20:00',4.09),('8537','2013-05-27','15:25:00',3.83),('8537','2013-05-27','15:30:00',4.15),('8537','2013-05-27','15:35:00',4.64),('8537','2013-05-27','15:40:00',3.8),('8537','2013-05-27','15:45:00',3.49),('8537','2013-05-27','15:50:00',4.24),('8537','2013-05-27','15:55:00',2.87),('8537','2013-05-27','16:00:00',3.48),('8537','2013-05-27','16:05:00',2.48),('8537','2013-05-27','16:10:00',2.97),('8537','2013-05-27','16:15:00',2.65),('8537','2013-05-27','16:20:00',4.18),('8537','2013-05-27','16:25:00',3.85),('8537','2013-05-27','16:30:00',3.59),('8537','2013-05-27','16:35:00',3.28),('8537','2013-05-27','16:40:00',1.54),('8537','2013-05-27','16:45:00',1.41),('8537','2013-05-27','16:50:00',1.47),('8537','2013-05-27','16:55:00',1.58),('8537','2013-05-27','17:00:00',1.64),('8537','2013-05-27','17:05:00',1.67),('8537','2013-05-27','17:10:00',1.99),('8537','2013-05-27','17:15:00',1.67),('8537','2013-05-27','17:20:00',1.46),('8537','2013-05-27','17:25:00',1.34),('8537','2013-05-27','17:30:00',1.31),('8537','2013-05-27','17:35:00',1.22),('8537','2013-05-27','17:40:00',1.12),('8537','2013-05-27','17:45:00',1.06),('8537','2013-05-27','17:50:00',1.02),('8537','2013-05-27','17:55:00',1.04),('8537','2013-05-27','18:00:00',1.03),('8537','2013-05-27','18:15:00',1.05),('8537','2013-05-27','18:20:00',1.24),('8537','2013-05-27','18:25:00',1.55),('8537','2013-05-27','18:30:00',1.3),('8537','2013-05-26','07:20:00',1.09),('8537','2013-05-26','07:35:00',1.16),('8537','2013-05-26','07:40:00',1.44),('8537','2013-05-26','07:45:00',1.64),('8537','2013-05-26','07:50:00',2.33),('8537','2013-05-26','08:05:00',1.94),('8537','2013-05-26','08:10:00',2.18),('8537','2013-05-26','08:20:00',1.11),('8537','2013-05-26','08:25:00',1.57),('8537','2013-05-26','08:30:00',2.53),('8537','2013-05-26','08:35:00',2.27),('8537','2013-05-26','08:40:00',2.7),('8537','2013-05-26','08:45:00',2.76),('8537','2013-05-26','08:50:00',3.16),('8537','2013-05-26','08:55:00',1.02),('8537','2013-05-26','09:00:00',2.44),('8537','2013-05-26','09:10:00',2.43),('8537','2013-05-26','09:15:00',2.26),('8537','2013-05-26','09:25:00',1.67),('8537','2013-05-26','09:40:00',1.07),('8537','2013-05-26','09:45:00',2.78),('8537','2013-05-26','09:55:00',1.25),('8537','2013-05-26','10:00:00',1.77),('8537','2013-05-26','10:05:00',3.29),('8537','2013-05-26','10:10:00',4.64),('8537','2013-05-26','10:15:00',3.01),('8537','2013-05-26','10:20:00',1.88),('8537','2013-05-26','10:25:00',3.51),('8537','2013-05-26','10:30:00',4.5),('8537','2013-05-26','10:35:00',4.37),('8537','2013-05-26','10:40:00',4.88),('8537','2013-05-26','10:45:00',4.93),('8537','2013-05-26','10:50:00',5),('8537','2013-05-26','10:55:00',5.13),('8537','2013-05-26','11:00:00',4.98),('8537','2013-05-26','11:05:00',5.16),('8537','2013-05-26','11:10:00',5.19),('8537','2013-05-26','11:15:00',5.21),('8537','2013-05-26','11:20:00',5.28),('8537','2013-05-26','11:25:00',5.3),('8537','2013-05-26','11:30:00',5.42),('8537','2013-05-26','11:35:00',5.13),('8537','2013-05-26','11:40:00',5.34),('8537','2013-05-26','11:45:00',5.57),('8537','2013-05-26','11:50:00',5.51),('8537','2013-05-26','11:55:00',5.66),('8537','2013-05-26','12:00:00',5.58),('8537','2013-05-26','12:05:00',5.63),('8537','2013-05-26','12:10:00',5.18),('8537','2013-05-26','12:15:00',4.67),('8537','2013-05-26','12:20:00',4.46),('8537','2013-05-26','12:25:00',5.02),('8537','2013-05-26','12:30:00',5.78),('8537','2013-05-26','12:35:00',5.75),('8537','2013-05-26','12:40:00',5.1),('8537','2013-05-26','12:45:00',4.06),('8537','2013-05-26','12:50:00',5.8),('8537','2013-05-26','12:55:00',5.77),('8537','2013-05-26','13:00:00',5.66),('8537','2013-05-26','13:05:00',5.19),('8537','2013-05-26','13:10:00',5.66),('8537','2013-05-26','13:15:00',5.15),('8537','2013-05-26','13:20:00',5.79),('8537','2013-05-26','13:25:00',5.66),('8537','2013-05-26','13:30:00',5.76),('8537','2013-05-26','13:35:00',5.7),('8537','2013-05-26','13:40:00',5.59),('8537','2013-05-26','13:45:00',5.59),('8537','2013-05-26','13:50:00',5.45),('8537','2013-05-26','13:55:00',5.47),('8537','2013-05-26','14:00:00',5.47),('8537','2013-05-26','14:05:00',5.45),('8537','2013-05-26','14:10:00',5.41),('8537','2013-05-26','14:15:00',5.38),('8537','2013-05-26','14:20:00',5.34),('8537','2013-05-26','14:25:00',5.27),('8537','2013-05-26','14:30:00',5.24),('8537','2013-05-26','14:35:00',5.16),('8537','2013-05-26','14:40:00',5.02),('8537','2013-05-26','14:45:00',4.88),('8537','2013-05-26','14:50:00',5.02),('8537','2013-05-26','14:55:00',4.99),('8537','2013-05-26','15:00:00',4.9),('8537','2013-05-26','15:05:00',4.89),('8537','2013-05-26','15:10:00',4.84),('8537','2013-05-26','15:15:00',4.78),('8537','2013-05-26','15:20:00',4.74),('8537','2013-05-26','15:25:00',4.68),('8537','2013-05-26','15:30:00',4.64),('8537','2013-05-26','15:35:00',4.41),('8537','2013-05-26','15:40:00',4.28),('8537','2013-05-26','15:45:00',4.35),('8537','2013-05-26','15:50:00',4.3),('8537','2013-05-26','15:55:00',4.23),('8537','2013-05-26','16:00:00',4.16),('8537','2013-05-26','16:05:00',4.09),('8537','2013-05-26','16:10:00',4.03),('8537','2013-05-26','16:15:00',3.94),('8537','2013-05-26','16:20:00',3.74),('8537','2013-05-26','16:25:00',3.48),('8537','2013-05-26','16:30:00',3.64),('8537','2013-05-26','16:35:00',3.54),('8537','2013-05-26','16:40:00',3.45),('8537','2013-05-26','16:45:00',3.38),('8537','2013-05-26','16:50:00',3.29),('8537','2013-05-26','16:55:00',3.18),('8537','2013-05-26','17:00:00',3.02),('8537','2013-05-26','17:05:00',2.96),('8537','2013-05-26','17:10:00',2.85),('8537','2013-05-26','17:15:00',2.76),('8537','2013-05-26','17:20:00',2.61),('8537','2013-05-26','17:25:00',2.46),('8537','2013-05-26','17:30:00',2.37),('8537','2013-05-26','17:35:00',2.26),('8537','2013-05-26','17:40:00',2.16),('8537','2013-05-26','17:45:00',2),('8537','2013-05-26','17:50:00',1.94),('8537','2013-05-26','17:55:00',1.79),('8537','2013-05-26','18:00:00',1.71),('8537','2013-05-26','18:05:00',1.6),('8537','2013-05-26','18:10:00',1.49),('8537','2013-05-26','18:15:00',1.37),('8537','2013-05-26','18:20:00',1.26),('8537','2013-05-26','18:25:00',1.16),('8537','2013-05-26','18:30:00',1.06),('8537','2013-05-25','07:15:00',1.19),('8537','2013-05-25','07:20:00',1.14),('8537','2013-05-25','07:30:00',1.29),('8537','2013-05-25','07:35:00',1.76),('8537','2013-05-25','07:40:00',1.56),('8537','2013-05-25','07:55:00',1.89),('8537','2013-05-25','08:00:00',2.3),('8537','2013-05-25','08:05:00',2.22),('8537','2013-05-25','08:10:00',1.85),('8537','2013-05-25','08:20:00',1.8),('8537','2013-05-25','08:25:00',2.78),('8537','2013-05-25','08:30:00',3),('8537','2013-05-25','08:35:00',1.79),('8537','2013-05-25','08:40:00',2.05),('8537','2013-05-25','08:45:00',1.5),('8537','2013-05-25','08:50:00',2.07),('8537','2013-05-25','08:55:00',2.16),('8537','2013-05-25','09:00:00',2.1),('8537','2013-05-25','09:05:00',3.55),('8537','2013-05-25','09:10:00',3.57),('8537','2013-05-25','09:15:00',4.15),('8537','2013-05-25','09:20:00',1.82),('8537','2013-05-25','09:25:00',1.81),('8537','2013-05-25','09:30:00',1.34),('8537','2013-05-25','09:35:00',2.91),('8537','2013-05-25','09:40:00',4.43),('8537','2013-05-25','09:45:00',3.13),('8537','2013-05-25','09:50:00',3.92),('8537','2013-05-25','09:55:00',2.66),('8537','2013-05-25','10:00:00',1.16),('8537','2013-05-25','10:10:00',1.24),('8537','2013-05-25','10:15:00',1.31),('8537','2013-05-25','10:25:00',1.04),('8537','2013-05-25','10:30:00',1.14),('8537','2013-05-25','10:35:00',1),('8537','2013-05-25','10:40:00',1.76),('8537','2013-05-25','10:45:00',1.69),('8537','2013-05-25','10:50:00',1.66),('8537','2013-05-25','10:55:00',1.04),('8537','2013-05-25','11:00:00',1.26),('8537','2013-05-25','11:05:00',2.3),('8537','2013-05-25','11:10:00',4.91),('8537','2013-05-25','11:15:00',4.41),('8537','2013-05-25','11:20:00',3.34),('8537','2013-05-25','11:25:00',1.21),('8537','2013-05-25','11:35:00',1.47),('8537','2013-05-25','11:40:00',2.28),('8537','2013-05-25','11:45:00',2.81),('8537','2013-05-25','11:50:00',2.16),('8537','2013-05-25','11:55:00',2.3),('8537','2013-05-25','12:00:00',1.58),('8537','2013-05-25','12:05:00',1.47),('8537','2013-05-25','12:10:00',1.93),('8537','2013-05-25','12:15:00',1.28),('8537','2013-05-25','12:20:00',1.54),('8537','2013-05-25','12:25:00',2.2),('8537','2013-05-25','12:30:00',1.77),('8537','2013-05-25','12:35:00',1.54),('8537','2013-05-25','12:40:00',1.94),('8537','2013-05-25','12:45:00',2.2),('8537','2013-05-25','12:50:00',1.63),('8537','2013-05-25','12:55:00',2.93),('8537','2013-05-25','13:00:00',1.27),('8537','2013-05-25','13:05:00',1.85),('8537','2013-05-25','13:10:00',1.71),('8537','2013-05-25','13:15:00',2.09),('8537','2013-05-25','13:20:00',2.39),('8537','2013-05-25','13:25:00',3.79),('8537','2013-05-25','13:30:00',2.37),('8537','2013-05-25','13:35:00',1.57),('8537','2013-05-25','13:40:00',2.38),('8537','2013-05-25','13:45:00',2.24),('8537','2013-05-25','13:50:00',2.64),('8537','2013-05-25','13:55:00',3.88),('8537','2013-05-25','14:00:00',4.09),('8537','2013-05-25','14:05:00',5.46),('8537','2013-05-25','14:10:00',5.28),('8537','2013-05-25','14:15:00',5.2),('8537','2013-05-25','14:20:00',4.34),('8537','2013-05-25','14:25:00',3.22),('8537','2013-05-25','14:30:00',3.93),('8537','2013-05-25','14:35:00',2.99),('8537','2013-05-25','14:40:00',1.51),('8537','2013-05-25','14:45:00',2.95),('8537','2013-05-25','14:50:00',1.93),('8537','2013-05-25','14:55:00',2),('8537','2013-05-25','15:00:00',4.09),('8537','2013-05-25','15:05:00',3.38),('8537','2013-05-25','15:10:00',2.2),('8537','2013-05-25','15:15:00',3),('8537','2013-05-25','15:20:00',1.57),('8537','2013-05-25','15:25:00',3.15),('8537','2013-05-25','15:30:00',2.92),('8537','2013-05-25','15:35:00',4.91),('8537','2013-05-25','15:40:00',4.29),('8537','2013-05-25','15:45:00',4.47),('8537','2013-05-25','15:50:00',4.81),('8537','2013-05-25','15:55:00',4.94),('8537','2013-05-25','16:00:00',3.65),('8537','2013-05-25','16:05:00',1.62),('8537','2013-05-25','16:10:00',2.68),('8537','2013-05-25','16:15:00',1.69),('8537','2013-05-25','16:20:00',1.92),('8537','2013-05-25','16:25:00',1.58),('8537','2013-05-25','16:30:00',2.97),('8537','2013-05-25','16:35:00',3.35),('8537','2013-05-25','16:40:00',3.42),('8537','2013-05-25','16:45:00',2.65),('8537','2013-05-25','16:50:00',1.94),('8537','2013-05-25','16:55:00',1.02),('8537','2013-05-25','17:00:00',1.04),('8537','2013-05-25','17:05:00',1.49),('8537','2013-05-25','17:10:00',3.18),('8537','2013-05-25','17:15:00',2.22),('8537','2013-05-25','17:20:00',2.39),('8537','2013-05-25','17:25:00',1.45),('8537','2013-05-25','17:35:00',1.7),('8537','2013-05-25','17:40:00',1.2),('8537','2013-05-25','17:45:00',1.13),('8537','2013-05-25','17:50:00',1.41),('8537','2013-05-24','08:05:00',2.1),('8537','2013-05-24','08:10:00',2.4),('8537','2013-05-24','08:15:00',2.4),('8537','2013-05-24','08:20:00',1.08),('8537','2013-05-24','08:25:00',1.11),('8537','2013-05-24','08:30:00',2.5),('8537','2013-05-24','08:35:00',1.97),('8537','2013-05-24','08:45:00',2.54),('8537','2013-05-24','08:50:00',2.9),('8537','2013-05-24','08:55:00',3.06),('8537','2013-05-24','09:00:00',3.27),('8537','2013-05-24','09:05:00',3.71),('8537','2013-05-24','09:10:00',1.29),('8537','2013-05-24','09:20:00',2.67),('8537','2013-05-24','09:25:00',2.17),('8537','2013-05-24','09:30:00',2.41),('8537','2013-05-24','09:40:00',1.72),('8537','2013-05-24','09:45:00',1.34),('8537','2013-05-24','09:50:00',1.72),('8537','2013-05-24','09:55:00',3.18),('8537','2013-05-24','10:00:00',2.76),('8537','2013-05-24','10:05:00',1),('8537','2013-05-24','10:20:00',1.15),('8537','2013-05-24','10:25:00',2.73),('8537','2013-05-24','10:30:00',4.91),('8537','2013-05-24','10:35:00',4.56),('8537','2013-05-24','10:40:00',4.15),('8537','2013-05-24','10:45:00',4.47),('8537','2013-05-24','10:50:00',3.36),('8537','2013-05-24','10:55:00',5.41),('8537','2013-05-24','11:00:00',4.19),('8537','2013-05-24','11:05:00',3.64),('8537','2013-05-24','11:10:00',4.67),('8537','2013-05-24','11:15:00',3.99),('8537','2013-05-24','11:20:00',5.53),('8537','2013-05-24','11:25:00',5.55),('8537','2013-05-24','11:30:00',3.81),('8537','2013-05-24','11:35:00',1.58),('8537','2013-05-24','11:40:00',1.12),('8537','2013-05-24','11:45:00',3.29),('8537','2013-05-24','11:50:00',5.79),('8537','2013-05-24','11:55:00',3.94),('8537','2013-05-24','12:00:00',2.42),('8537','2013-05-24','12:05:00',3.57),('8537','2013-05-24','12:10:00',4.48),('8537','2013-05-24','12:15:00',2.91),('8537','2013-05-24','12:20:00',2.52),('8537','2013-05-24','12:25:00',3.12),('8537','2013-05-24','12:30:00',5.31),('8537','2013-05-24','12:35:00',2.5),('8537','2013-05-24','12:40:00',3.24),('8537','2013-05-24','12:45:00',4.05),('8537','2013-05-24','12:50:00',3.57),('8537','2013-05-24','12:55:00',2.91),('8537','2013-05-24','13:00:00',2.8),('8537','2013-05-24','13:05:00',2.4),('8537','2013-05-24','13:10:00',3.02),('8537','2013-05-24','13:15:00',3.45),('8537','2013-05-24','13:20:00',3.92),('8537','2013-05-24','13:25:00',3),('8537','2013-05-24','13:30:00',2.41),('8537','2013-05-24','13:35:00',4.1),('8537','2013-05-24','13:40:00',2.98),('8537','2013-05-24','13:45:00',1.55),('8537','2013-05-24','13:50:00',1.49),('8537','2013-05-24','13:55:00',3.74),('8537','2013-05-24','14:00:00',3.16),('8537','2013-05-24','14:05:00',2.74),('8537','2013-05-24','14:10:00',1.46),('8537','2013-05-24','14:15:00',4.7),('8537','2013-05-24','14:20:00',4.26),('8537','2013-05-24','14:25:00',3.91),('8537','2013-05-24','14:30:00',3.18),('8537','2013-05-24','14:35:00',3.65),('8537','2013-05-24','14:40:00',2.95),('8537','2013-05-24','14:45:00',3.72),('8537','2013-05-24','14:50:00',1.68),('8537','2013-05-24','14:55:00',1.99),('8537','2013-05-24','15:00:00',2.72),('8537','2013-05-24','15:05:00',4.31),('8537','2013-05-24','15:10:00',3.06),('8537','2013-05-24','15:15:00',3.28),('8537','2013-05-24','15:20:00',4.33),('8537','2013-05-24','15:25:00',3.66),('8537','2013-05-24','15:30:00',4.34),('8537','2013-05-24','15:35:00',3.47),('8537','2013-05-24','15:40:00',3.67),('8537','2013-05-24','15:45:00',4.52),('8537','2013-05-24','15:50:00',4.83),('8537','2013-05-24','15:55:00',5.18),('8537','2013-05-24','16:00:00',2.6),('8537','2013-05-24','16:05:00',2.42),('8537','2013-05-24','16:10:00',2.48),('8537','2013-05-24','16:15:00',3.03),('8537','2013-05-24','16:20:00',2.28),('8537','2013-05-24','16:25:00',2.91),('8537','2013-05-24','16:30:00',3.41),('8537','2013-05-24','16:35:00',1.66),('8537','2013-05-24','16:50:00',1.57),('8537','2013-05-24','16:55:00',2.1),('8537','2013-05-24','17:00:00',1.54),('8537','2013-05-24','17:05:00',1.07),('8537','2013-05-24','17:20:00',1.11),('8537','2013-05-24','17:25:00',1.19),('8537','2013-05-24','17:30:00',1.26),('8537','2013-05-24','17:35:00',1.27),('8537','2013-05-24','17:40:00',1.08),('8537','2013-05-23','07:10:00',1.01),('8537','2013-05-23','07:55:00',1.09),('8537','2013-05-23','08:00:00',1.33),('8537','2013-05-23','08:05:00',1.76),('8537','2013-05-23','08:10:00',1.66),('8537','2013-05-23','08:30:00',1.56),('8537','2013-05-23','08:35:00',2.48),('8537','2013-05-23','08:40:00',2.63),('8537','2013-05-23','08:45:00',2.04),('8537','2013-05-23','08:50:00',1.65),('8537','2013-05-23','09:00:00',3.25),('8537','2013-05-23','09:05:00',1.73),('8537','2013-05-23','09:15:00',1.17),('8537','2013-05-23','09:20:00',2.4),('8537','2013-05-23','09:25:00',3.81),('8537','2013-05-23','09:30:00',4.28),('8537','2013-05-23','09:35:00',2.85),('8537','2013-05-23','09:40:00',3.2),('8537','2013-05-23','09:45:00',2.07),('8537','2013-05-23','09:50:00',4.05),('8537','2013-05-23','09:55:00',1.95),('8537','2013-05-23','10:00:00',1.42),('8537','2013-05-23','10:05:00',3.73),('8537','2013-05-23','10:10:00',4.27),('8537','2013-05-23','10:15:00',4.55),('8537','2013-05-23','10:20:00',2.89),('8537','2013-05-23','10:25:00',4.74),('8537','2013-05-23','10:30:00',4.47),('8537','2013-05-23','10:35:00',4),('8537','2013-05-23','10:40:00',4.23),('8537','2013-05-23','10:45:00',5.19),('8537','2013-05-23','10:50:00',4.42),('8537','2013-05-23','10:55:00',5.51),('8537','2013-05-23','11:00:00',3.07),('8537','2013-05-23','11:05:00',3.56),('8537','2013-05-23','11:10:00',2.79),('8537','2013-05-23','11:15:00',2.57),('8537','2013-05-23','11:20:00',2.07),('8537','2013-05-23','11:25:00',1.86),('8537','2013-05-23','11:30:00',3.46),('8537','2013-05-23','11:35:00',4.66),('8537','2013-05-23','11:40:00',5.27),('8537','2013-05-23','11:45:00',3.17),('8537','2013-05-23','11:50:00',2.86),('8537','2013-05-23','11:55:00',5.29),('8537','2013-05-23','12:00:00',5.48),('8537','2013-05-23','12:05:00',5.59),('8537','2013-05-23','12:10:00',5.63),('8537','2013-05-23','12:15:00',4.34),('8537','2013-05-23','12:20:00',3.92),('8537','2013-05-23','12:25:00',5.36),('8537','2013-05-23','12:30:00',5.13),('8537','2013-05-23','12:35:00',2.31),('8537','2013-05-23','12:40:00',5.35),('8537','2013-05-23','12:45:00',4.49),('8537','2013-05-23','12:50:00',3.6),('8537','2013-05-23','12:55:00',5.12),('8537','2013-05-23','13:00:00',5.9),('8537','2013-05-23','13:05:00',3.31),('8537','2013-05-23','13:10:00',4.71),('8537','2013-05-23','13:15:00',4.45),('8537','2013-05-23','13:20:00',4.19),('8537','2013-05-23','13:25:00',3.17),('8537','2013-05-23','13:30:00',2.14),('8537','2013-05-23','13:35:00',2.32),('8537','2013-05-23','13:40:00',2.47),('8537','2013-05-23','13:45:00',4.46),('8537','2013-05-23','13:50:00',3.38),('8537','2013-05-23','13:55:00',4.5),('8537','2013-05-23','14:00:00',5.25),('8537','2013-05-23','14:05:00',5.19),('8537','2013-05-23','14:10:00',5.85),('8537','2013-05-23','14:15:00',4.03),('8537','2013-05-23','14:20:00',5.4),('8537','2013-05-23','14:25:00',4.38),('8537','2013-05-23','14:30:00',1.54),('8537','2013-05-23','14:35:00',5.79),('8537','2013-05-23','14:40:00',4.49),('8537','2013-05-23','14:45:00',2.53),('8537','2013-05-23','14:50:00',2.34),('8537','2013-05-23','14:55:00',3.2),('8537','2013-05-23','15:00:00',4.05),('8537','2013-05-23','15:05:00',3.8),('8537','2013-05-23','15:10:00',1.6),('8537','2013-05-23','15:15:00',1.7),('8537','2013-05-23','15:20:00',3.57),('8537','2013-05-23','15:25:00',1.52),('8537','2013-05-23','15:30:00',3.6),('8537','2013-05-23','15:35:00',3.93),('8537','2013-05-23','15:40:00',1.8),('8537','2013-05-23','15:45:00',3.1),('8537','2013-05-23','15:50:00',1.4),('8537','2013-05-23','15:55:00',1.7),('8537','2013-05-23','16:00:00',3.07),('8537','2013-05-23','16:05:00',4.29),('8537','2013-05-23','16:10:00',2.38),('8537','2013-05-23','16:15:00',2.77),('8537','2013-05-23','16:20:00',3.45),('8537','2013-05-23','16:25:00',2.98),('8537','2013-05-23','16:30:00',3.58),('8537','2013-05-23','16:35:00',2.27),('8537','2013-05-23','16:40:00',1.89),('8537','2013-05-23','16:45:00',1.84),('8537','2013-05-23','16:50:00',1.77),('8537','2013-05-23','17:05:00',1.13),('8537','2013-05-23','17:10:00',2.42),('8537','2013-05-23','17:15:00',1.93),('8537','2013-05-23','17:20:00',1.33),('8537','2013-05-23','17:25:00',1.02),('8537','2013-05-23','17:30:00',1.14),('8537','2013-05-23','17:35:00',1.45),('8537','2013-05-23','17:40:00',1.21),('8537','2013-05-23','17:45:00',1.15),('8537','2013-05-23','17:55:00',1.35),('8537','2013-05-23','18:00:00',1.6),('8537','2013-05-23','18:05:00',2.13),('8537','2013-05-23','18:10:00',1.13),('8537','2013-05-23','18:50:00',1.1),('8537','2013-05-23','18:55:00',1.01),('8537','2013-05-22','07:50:00',1.11),('8537','2013-05-22','07:55:00',1.21),('8537','2013-05-22','08:00:00',1.4),('8537','2013-05-22','08:05:00',1.78),('8537','2013-05-22','08:10:00',1.39),('8537','2013-05-22','08:15:00',2.37),('8537','2013-05-22','08:20:00',2.34),('8537','2013-05-22','08:25:00',2.21),('8537','2013-05-22','08:30:00',2.49),('8537','2013-05-22','08:35:00',2.97),('8537','2013-05-22','08:40:00',1.74),('8537','2013-05-22','08:45:00',2.08),('8537','2013-05-22','08:50:00',1.36),('8537','2013-05-22','09:15:00',1.05),('8537','2013-05-22','09:20:00',1.02),('8537','2013-05-22','09:25:00',1.31),('8537','2013-05-22','09:30:00',3.4),('8537','2013-05-22','09:35:00',3.54),('8537','2013-05-22','09:40:00',3.52),('8537','2013-05-22','09:45:00',3.56),('8537','2013-05-22','09:50:00',3.65),('8537','2013-05-22','09:55:00',3.73),('8537','2013-05-22','10:00:00',3.81),('8537','2013-05-22','10:05:00',3.88),('8537','2013-05-22','10:10:00',3.97),('8537','2013-05-22','10:15:00',4),('8537','2013-05-22','10:20:00',4),('8537','2013-05-22','10:25:00',4.2),('8537','2013-05-22','10:30:00',4.24),('8537','2013-05-22','10:35:00',4.26),('8537','2013-05-22','10:40:00',4.43),('8537','2013-05-22','10:45:00',4.45),('8537','2013-05-22','10:50:00',4.42),('8537','2013-05-22','10:55:00',4.47),('8537','2013-05-22','11:00:00',4.49),('8537','2013-05-22','11:05:00',4.71),('8537','2013-05-22','11:10:00',4.13),('8537','2013-05-22','11:15:00',4.39),('8537','2013-05-22','11:20:00',4.84),('8537','2013-05-22','11:25:00',4.94),('8537','2013-05-22','11:30:00',4.42),('8537','2013-05-22','11:35:00',4.2),('8537','2013-05-22','11:40:00',4.29),('8537','2013-05-22','11:45:00',5.02),('8537','2013-05-22','11:50:00',2.97),('8537','2013-05-22','11:55:00',2.56),('8537','2013-05-22','12:00:00',3.67),('8537','2013-05-22','12:05:00',2.8),('8537','2013-05-22','12:10:00',2.68),('8537','2013-05-22','12:15:00',3.63),('8537','2013-05-22','12:20:00',4.76),('8537','2013-05-22','12:25:00',3.57),('8537','2013-05-22','12:30:00',2.75),('8537','2013-05-22','12:35:00',2.84),('8537','2013-05-22','12:40:00',1.91),('8537','2013-05-22','13:00:00',1.44),('8537','2013-05-22','13:05:00',4.96),('8537','2013-05-22','13:10:00',2.75),('8537','2013-05-22','13:15:00',2.76),('8537','2013-05-22','13:20:00',2.8),('8537','2013-05-22','13:25:00',1.38),('8537','2013-05-22','13:30:00',2.19),('8537','2013-05-22','13:35:00',3.96),('8537','2013-05-22','13:40:00',3.94),('8537','2013-05-22','13:45:00',3.08),('8537','2013-05-22','13:50:00',2.74),('8537','2013-05-22','13:55:00',2.82),('8537','2013-05-22','14:00:00',2.87),('8537','2013-05-22','14:05:00',4.56),('8537','2013-05-22','14:10:00',4.78),('8537','2013-05-22','14:15:00',5.13),('8537','2013-05-22','14:20:00',5),('8537','2013-05-22','14:25:00',4.91),('8537','2013-05-22','14:30:00',4.86),('8537','2013-05-22','14:35:00',4.73),('8537','2013-05-22','14:40:00',4.62),('8537','2013-05-22','14:45:00',4.52),('8537','2013-05-22','14:50:00',4.66),('8537','2013-05-22','14:55:00',4.59),('8537','2013-05-22','15:00:00',4.5),('8537','2013-05-22','15:05:00',4.48),('8537','2013-05-22','15:10:00',4.43),('8537','2013-05-22','15:15:00',4.34),('8537','2013-05-22','15:20:00',4),('8537','2013-05-22','15:25:00',2.7),('8537','2013-05-22','15:30:00',1.99),('8537','2013-05-22','15:35:00',2.66),('8537','2013-05-22','15:40:00',2.51),('8537','2013-05-22','15:45:00',3.17),('8537','2013-05-22','15:50:00',3.93),('8537','2013-05-22','15:55:00',3.74),('8537','2013-05-22','16:00:00',3.74),('8537','2013-05-22','16:05:00',3.65),('8537','2013-05-22','16:10:00',3.54),('8537','2013-05-22','16:15:00',3.51),('8537','2013-05-22','16:20:00',3.33),('8537','2013-05-22','16:25:00',3.09),('8537','2013-05-22','16:30:00',3.19),('8537','2013-05-22','16:35:00',3.09),('8537','2013-05-22','16:40:00',3.03),('8537','2013-05-22','16:45:00',2.41),('8537','2013-05-22','16:50:00',1.81),('8537','2013-05-22','17:15:00',1.11),('8537','2013-05-22','17:20:00',1.35),('8537','2013-05-22','17:25:00',1.87),('8537','2013-05-22','17:30:00',1.4),('8537','2013-05-22','17:35:00',1.63),('8537','2013-05-22','17:55:00',1.35),('8537','2013-05-22','18:00:00',1.37),('8537','2014-04-01','08:10:00',1.07),('8537','2014-04-01','08:15:00',1.18),('8537','2014-04-01','08:20:00',1.28),('8537','2014-04-01','08:25:00',1.4),('8537','2014-04-01','08:30:00',1.52),('8537','2014-04-01','08:35:00',1.64),('8537','2014-04-01','08:40:00',1.76),('8537','2014-04-01','08:45:00',1.87),('8537','2014-04-01','08:50:00',1.98),('8537','2014-04-01','08:55:00',2.09),('8537','2014-04-01','09:00:00',2.22),('8537','2014-04-01','09:05:00',2.33),('8537','2014-04-01','09:10:00',2.43),('8537','2014-04-01','09:15:00',2.53),('8537','2014-04-01','09:20:00',2.62),('8537','2014-04-01','09:25:00',2.72),('8537','2014-04-01','09:30:00',2.81),('8537','2014-04-01','09:35:00',2.88),('8537','2014-04-01','09:40:00',3.01),('8537','2014-04-01','09:45:00',3.13),('8537','2014-04-01','09:50:00',3.19),('8537','2014-04-01','09:55:00',3.28),('8537','2014-04-01','10:00:00',3.41),('8537','2014-04-01','10:05:00',3.4),('8537','2014-04-01','10:10:00',3.45),('8537','2014-04-01','10:15:00',3.64),('8537','2014-04-01','10:20:00',3.81),('8537','2014-04-01','10:25:00',4.01),('8537','2014-04-01','10:30:00',3.9),('8537','2014-04-01','10:35:00',3.81),('8537','2014-04-01','10:40:00',4.48),('8537','2014-04-01','10:45:00',2.66),('8537','2014-04-01','10:50:00',4.34),('8537','2014-04-01','10:55:00',4.28),('8537','2014-04-01','11:00:00',4.26),('8537','2014-04-01','11:05:00',4.38),('8537','2014-04-01','11:10:00',4.36),('8537','2014-04-01','11:15:00',4.41),('8537','2014-04-01','11:20:00',4.42),('8537','2014-04-01','11:25:00',4.45),('8537','2014-04-01','11:30:00',4.63),('8537','2014-04-01','11:35:00',4.66),('8537','2014-04-01','11:40:00',4.68),('8537','2014-04-01','11:45:00',4.73),('8537','2014-04-01','11:50:00',4.77),('8537','2014-04-01','11:55:00',4.74),('8537','2014-04-01','12:00:00',4.81),('8537','2014-04-01','12:05:00',4.87),('8537','2014-04-01','12:10:00',4.91),('8537','2014-04-01','12:15:00',4.92),('8537','2014-04-01','12:20:00',4.98),('8537','2014-04-01','12:25:00',5.03),('8537','2014-04-01','12:30:00',5.07),('8537','2014-04-01','12:35:00',5.12),('8537','2014-04-01','12:40:00',5.08),('8537','2014-04-01','12:45:00',5.14),('8537','2014-04-01','12:50:00',5.17),('8537','2014-04-01','12:55:00',5.14),('8537','2014-04-01','13:00:00',5.14),('8537','2014-04-01','13:05:00',5.18),('8537','2014-04-01','13:10:00',4.21),('8537','2014-04-01','13:15:00',5.15),('8537','2014-04-01','13:20:00',4.83),('8537','2014-04-01','13:25:00',5.14),('8537','2014-04-01','13:30:00',5.09),('8537','2014-04-01','13:35:00',5.14),('8537','2014-04-01','13:40:00',5.19),('8537','2014-04-01','13:45:00',5.14),('8537','2014-04-01','13:50:00',5.06),('8537','2014-04-01','13:55:00',5.11),('8537','2014-04-01','14:00:00',5.05),('8537','2014-04-01','14:05:00',5.05),('8537','2014-04-01','14:10:00',5.04),('8537','2014-04-01','14:15:00',3.91),('8537','2014-04-01','14:20:00',4.79),('8537','2014-04-01','14:25:00',4.76),('8537','2014-04-01','14:30:00',3.67),('8537','2014-04-01','14:35:00',4.6),('8537','2014-04-01','14:40:00',4.13),('8537','2014-04-01','14:45:00',5.06),('8537','2014-04-01','14:50:00',4.92),('8537','2014-04-01','14:55:00',3.9),('8537','2014-04-01','15:00:00',4.69),('8537','2014-04-01','15:05:00',4.41),('8537','2014-04-01','15:10:00',4.22),('8537','2014-04-01','15:15:00',4.64),('8537','2014-04-01','15:20:00',4),('8537','2014-04-01','15:25:00',3.59),('8537','2014-04-01','15:30:00',3.87),('8537','2014-04-01','15:35:00',3.56),('8537','2014-04-01','15:40:00',3.67),('8537','2014-04-01','15:45:00',3.19),('8537','2014-04-01','15:50:00',4.05),('8537','2014-04-01','15:55:00',3.45),('8537','2014-04-01','16:00:00',2.68),('8537','2014-04-01','16:05:00',3.12),('8537','2014-04-01','16:10:00',2.44),('8537','2014-04-01','16:15:00',2.91),('8537','2014-04-01','16:20:00',1.87),('8537','2014-04-01','16:25:00',2.17),('8537','2014-04-01','16:30:00',2.67),('8537','2014-04-01','16:35:00',3.11),('8537','2014-04-01','16:40:00',3),('8537','2014-04-01','16:45:00',2.08),('8537','2014-04-01','16:50:00',1.24),('8537','2014-04-01','16:55:00',1.88),('8537','2014-04-01','17:00:00',2.6),('8537','2014-04-01','17:05:00',2.23),('8537','2014-04-01','17:10:00',2),('8537','2014-04-01','17:15:00',2.16),('8537','2014-04-01','17:20:00',2),('8537','2014-04-01','17:25:00',1.88),('8537','2014-04-01','17:30:00',1.75),('8537','2014-04-01','17:35:00',1.6),('8537','2014-04-01','17:40:00',1.53),('8537','2014-04-01','17:45:00',1.38),('8537','2014-04-01','17:50:00',1.29),('8537','2014-04-01','17:55:00',1.15),('8537','2014-04-01','18:00:00',1.04),('8537','2013-05-21','07:25:00',1.02),('8537','2013-05-21','07:30:00',1.2),('8537','2013-05-21','07:35:00',1.49),('8537','2013-05-21','07:40:00',1.72),('8537','2013-05-21','07:45:00',1.49),('8537','2013-05-21','07:50:00',1.24),('8537','2013-05-21','07:55:00',1.15),('8537','2013-05-21','08:00:00',1.47),('8537','2013-05-21','08:05:00',1.05),('8537','2013-05-21','08:10:00',1.59),('8537','2013-05-21','08:15:00',2.2),('8537','2013-05-21','08:20:00',1.82),('8537','2013-05-21','08:25:00',2.21),('8537','2013-05-21','08:30:00',1.63),('8537','2013-05-21','08:35:00',1.49),('8537','2013-05-21','08:40:00',1.75),('8537','2013-05-21','08:45:00',1.5),('8537','2013-05-21','08:50:00',1.61),('8537','2013-05-21','08:55:00',2.14),('8537','2013-05-21','09:00:00',1.86),('8537','2013-05-21','09:05:00',1.61),('8537','2013-05-21','09:10:00',1.75),('8537','2013-05-21','09:15:00',1.94),('8537','2013-05-21','09:20:00',2.68),('8537','2013-05-21','09:25:00',2.93),('8537','2013-05-21','09:30:00',2.27),('8537','2013-05-21','09:35:00',2.39),('8537','2013-05-21','09:40:00',2.34),('8537','2013-05-21','09:45:00',2.02),('8537','2013-05-21','09:50:00',1.93),('8537','2013-05-21','09:55:00',2.21),('8537','2013-05-21','10:00:00',2.31),('8537','2013-05-21','10:05:00',2.68),('8537','2013-05-21','10:10:00',2.8),('8537','2013-05-21','10:15:00',2.73),('8537','2013-05-21','10:20:00',2.5),('8537','2013-05-21','10:25:00',2.27),('8537','2013-05-21','10:30:00',2.12),('8537','2013-05-21','10:35:00',2.2),('8537','2013-05-21','10:40:00',2.51),('8537','2013-05-21','10:45:00',3.6),('8537','2013-05-21','10:50:00',2.51),('8537','2013-05-21','10:55:00',1.94),('8537','2013-05-21','11:00:00',2.32),('8537','2013-05-21','11:05:00',2.17),('8537','2013-05-21','11:10:00',3.71),('8537','2013-05-21','11:15:00',4.75),('8537','2013-05-21','11:20:00',3.73),('8537','2013-05-21','11:25:00',4.89),('8537','2013-05-21','11:30:00',3.4),('8537','2013-05-21','11:35:00',3.08),('8537','2013-05-21','11:40:00',3.35),('8537','2013-05-21','11:45:00',3.96),('8537','2013-05-21','11:50:00',3.17),('8537','2013-05-21','11:55:00',4.47),('8537','2013-05-21','12:00:00',3.87),('8537','2013-05-21','12:05:00',4.23),('8537','2013-05-21','12:10:00',3.3),('8537','2013-05-21','12:15:00',3.88),('8537','2013-05-21','12:20:00',2.78),('8537','2013-05-21','12:25:00',3.96),('8537','2013-05-21','12:30:00',4.74),('8537','2013-05-21','12:35:00',3.03),('8537','2013-05-21','12:40:00',4.61),('8537','2013-05-21','12:45:00',4.74),('8537','2013-05-21','12:50:00',2.8),('8537','2013-05-21','12:55:00',5.18),('8537','2013-05-21','13:00:00',4.73),('8537','2013-05-21','13:05:00',5.07),('8537','2013-05-21','13:10:00',3.11),('8537','2013-05-21','13:15:00',4.36),('8537','2013-05-21','13:20:00',3.64),('8537','2013-05-21','13:25:00',4.07),('8537','2013-05-21','13:30:00',3.65),('8537','2013-05-21','13:35:00',1.74),('8537','2013-05-21','13:40:00',1.05),('8537','2013-05-21','14:05:00',1.31),('8537','2013-05-21','14:10:00',2),('8537','2013-05-21','14:15:00',2.3),('8537','2013-05-21','14:20:00',2.05),('8537','2013-05-21','14:25:00',2.99),('8537','2013-05-21','14:30:00',2.79),('8537','2013-05-21','14:35:00',2.32),('8537','2013-05-21','14:40:00',2.21),('8537','2013-05-21','14:45:00',1.85),('8537','2013-05-21','14:50:00',1.19),('8537','2013-05-21','15:15:00',1.27),('8537','2013-05-21','15:20:00',1.73),('8537','2013-05-21','15:25:00',1.79),('8537','2013-05-21','15:30:00',2.51),('8537','2013-05-21','15:35:00',1.88),('8537','2013-05-21','15:40:00',1.52),('8537','2013-05-21','15:45:00',1.58),('8537','2013-05-21','15:50:00',1.44),('8537','2013-05-21','15:55:00',1.43),('8537','2013-05-21','16:00:00',1.42),('8537','2013-05-21','16:05:00',1.4),('8537','2013-05-21','16:10:00',1.52),('8537','2013-05-21','16:15:00',1.34),('8537','2013-05-21','16:20:00',1.11),('8537','2013-05-21','16:25:00',1.49),('8537','2013-05-21','16:30:00',1.95),('8537','2013-05-21','16:35:00',2.11),('8537','2013-05-21','16:40:00',2.25),('8537','2013-05-21','16:45:00',2.01),('8537','2013-05-21','16:50:00',1.3),('8537','2013-05-20','07:30:00',1.12),('8537','2013-05-20','07:35:00',1.24),('8537','2013-05-20','07:40:00',1.33),('8537','2013-05-20','07:45:00',1.45),('8537','2013-05-20','07:50:00',1.53),('8537','2013-05-20','07:55:00',1.64),('8537','2013-05-20','08:00:00',1.84),('8537','2013-05-20','08:05:00',1.77),('8537','2013-05-20','08:10:00',1.53),('8537','2013-05-20','08:20:00',1.57),('8537','2013-05-20','08:25:00',1.11),('8537','2013-05-20','08:45:00',1.63),('8537','2013-05-20','08:50:00',3.16),('8537','2013-05-20','08:55:00',3.39),('8537','2013-05-20','09:00:00',3.51),('8537','2013-05-20','09:05:00',3.24),('8537','2013-05-20','09:10:00',3.84),('8537','2013-05-20','09:15:00',2.44),('8537','2013-05-20','09:20:00',2.97),('8537','2013-05-20','09:25:00',1.65),('8537','2013-05-20','09:35:00',2.7),('8537','2013-05-20','09:40:00',1.02),('8537','2013-05-20','09:50:00',2.7),('8537','2013-05-20','10:05:00',1.39),('8537','2013-05-20','10:10:00',2.03),('8537','2013-05-20','10:15:00',1.18),('8537','2013-05-20','10:25:00',1.08),('8537','2013-05-20','10:30:00',2.97),('8537','2013-05-20','10:35:00',2.64),('8537','2013-05-20','10:40:00',1.44),('8537','2013-05-20','10:45:00',1.33),('8537','2013-05-20','10:50:00',2.98),('8537','2013-05-20','10:55:00',2.15),('8537','2013-05-20','11:00:00',4.19),('8537','2013-05-20','11:05:00',5.32),('8537','2013-05-20','11:10:00',5.69),('8537','2013-05-20','11:15:00',5.06),('8537','2013-05-20','11:20:00',3.38),('8537','2013-05-20','11:25:00',4.73),('8537','2013-05-20','11:30:00',2.66),('8537','2013-05-20','11:35:00',4.68),('8537','2013-05-20','11:40:00',1.13),('8537','2013-05-20','11:45:00',2.17),('8537','2013-05-20','11:50:00',1.15),('8537','2013-05-20','11:55:00',5.03),('8537','2013-05-20','12:00:00',1.85),('8537','2013-05-20','12:05:00',3.43),('8537','2013-05-20','12:10:00',4.16),('8537','2013-05-20','12:15:00',1.98),('8537','2013-05-20','12:20:00',3.95),('8537','2013-05-20','12:25:00',2.39),('8537','2013-05-20','12:30:00',3.25),('8537','2013-05-20','12:35:00',1.88),('8537','2013-05-20','12:40:00',5.31),('8537','2013-05-20','12:45:00',5.89),('8537','2013-05-20','12:50:00',2.02),('8537','2013-05-20','12:55:00',2.32),('8537','2013-05-20','13:00:00',3.27),('8537','2013-05-20','13:05:00',4.89),('8537','2013-05-20','13:10:00',2.14),('8537','2013-05-20','13:15:00',1.82),('8537','2013-05-20','13:20:00',3.35),('8537','2013-05-20','13:25:00',3.95),('8537','2013-05-20','13:30:00',3.14),('8537','2013-05-20','13:35:00',3.67),('8537','2013-05-20','13:40:00',3.33),('8537','2013-05-20','13:45:00',3.67),('8537','2013-05-20','13:50:00',5.44),('8537','2013-05-20','13:55:00',3.66),('8537','2013-05-20','14:00:00',5.7),('8537','2013-05-20','14:05:00',2.75),('8537','2013-05-20','14:10:00',1.88),('8537','2013-05-20','14:15:00',5.33),('8537','2013-05-20','14:20:00',3.84),('8537','2013-05-20','14:25:00',3.22),('8537','2013-05-20','14:30:00',5.35),('8537','2013-05-20','14:35:00',2.56),('8537','2013-05-20','14:40:00',1.79),('8537','2013-05-20','14:45:00',3.75),('8537','2013-05-20','14:50:00',5.42),('8537','2013-05-20','14:55:00',2.89),('8537','2013-05-20','15:00:00',3.64),('8537','2013-05-20','15:05:00',1.42),('8537','2013-05-20','15:10:00',5.29),('8537','2013-05-20','15:15:00',3.15),('8537','2013-05-20','15:20:00',3.3),('8537','2013-05-20','15:25:00',3.82),('8537','2013-05-20','15:30:00',3.41),('8537','2013-05-20','15:35:00',4.85),('8537','2013-05-20','15:40:00',3.49),('8537','2013-05-20','15:45:00',1.75),('8537','2013-05-20','15:50:00',3.58),('8537','2013-05-20','15:55:00',1.42),('8537','2013-05-20','16:00:00',2.63),('8537','2013-05-20','16:05:00',3.8),('8537','2013-05-20','16:10:00',3.54),('8537','2013-05-20','16:15:00',2.85),('8537','2013-05-20','16:20:00',3.9),('8537','2013-05-20','16:25:00',3.81),('8537','2013-05-20','16:30:00',3.64),('8537','2013-05-20','16:35:00',3.5),('8537','2013-05-20','16:40:00',3.45),('8537','2013-05-20','16:45:00',3.2),('8537','2013-05-20','16:50:00',3.12),('8537','2013-05-20','16:55:00',2.94),('8537','2013-05-20','17:00:00',2.5),('8537','2013-05-20','17:05:00',2.89),('8537','2013-05-20','17:10:00',2),('8537','2013-05-20','17:15:00',1.35),('8537','2013-05-20','17:20:00',1.73),('8537','2013-05-20','17:25:00',2.2),('8537','2013-05-20','17:30:00',2.18),('8537','2013-05-20','17:35:00',2.14),('8537','2013-05-20','17:40:00',1.94),('8537','2013-05-20','17:45:00',1.88),('8537','2013-05-20','17:50:00',1.73),('8537','2013-05-20','17:55:00',1.65),('8537','2013-05-20','18:00:00',1.59),('8537','2013-05-20','18:05:00',1.63),('8537','2013-05-20','18:10:00',1.16),('8537','2013-05-20','18:15:00',1.24),('8537','2013-05-20','18:20:00',1.18),('8537','2013-05-20','18:25:00',1.08),('8537','2013-05-19','08:30:00',1.04),('8537','2013-05-19','08:35:00',1.38),('8537','2013-05-19','08:40:00',1.13),('8537','2013-05-19','08:45:00',1.2),('8537','2013-05-19','08:50:00',1.4),('8537','2013-05-19','08:55:00',2.03),('8537','2013-05-19','09:00:00',1.83),('8537','2013-05-19','09:05:00',1.35),('8537','2013-05-19','09:10:00',1.49),('8537','2013-05-19','09:15:00',1.6),('8537','2013-05-19','09:20:00',1.27),('8537','2013-05-19','09:40:00',1.21),('8537','2013-05-19','09:45:00',1.44),('8537','2013-05-19','09:55:00',1.12),('8537','2013-05-19','10:00:00',1.79),('8537','2013-05-19','10:05:00',1.88),('8537','2013-05-19','10:10:00',2.4),('8537','2013-05-19','10:15:00',4.14),('8537','2013-05-19','10:20:00',3.11),('8537','2013-05-19','10:25:00',2.92),('8537','2013-05-19','10:30:00',3.56),('8537','2013-05-19','10:35:00',2.79),('8537','2013-05-19','10:40:00',3.37),('8537','2013-05-19','10:45:00',3.72),('8537','2013-05-19','10:50:00',2.28),('8537','2013-05-19','10:55:00',2.67),('8537','2013-05-19','11:00:00',2.42),('8537','2013-05-19','11:05:00',3.89),('8537','2013-05-19','11:10:00',2.86),('8537','2013-05-19','11:15:00',4.78),('8537','2013-05-19','11:20:00',5.28),('8537','2013-05-19','11:25:00',5.29),('8537','2013-05-19','11:30:00',5.26),('8537','2013-05-19','11:35:00',5.25),('8537','2013-05-19','11:40:00',5.38),('8537','2013-05-19','11:45:00',5.4),('8537','2013-05-19','11:50:00',5.38),('8537','2013-05-19','11:55:00',5.46),('8537','2013-05-19','12:00:00',5.48),('8537','2013-05-19','12:05:00',5.47),('8537','2013-05-19','12:10:00',5.46),('8537','2013-05-19','12:15:00',5.5),('8537','2013-05-19','12:20:00',5.83),('8537','2013-05-19','12:25:00',5.66),('8537','2013-05-19','12:30:00',4.65),('8537','2013-05-19','12:35:00',5.48),('8537','2013-05-19','12:40:00',5.75),('8537','2013-05-19','12:45:00',5.57),('8537','2013-05-19','12:50:00',4.14),('8537','2013-05-19','12:55:00',3.2),('8537','2013-05-19','13:00:00',4.59),('8537','2013-05-19','13:05:00',5.19),('8537','2013-05-19','13:10:00',4.39),('8537','2013-05-19','13:15:00',4.48),('8537','2013-05-19','13:20:00',5.57),('8537','2013-05-19','13:25:00',4.99),('8537','2013-05-19','13:30:00',5.41),('8537','2013-05-19','13:35:00',5.37),('8537','2013-05-19','13:40:00',5.33),('8537','2013-05-19','13:45:00',5.32),('8537','2013-05-19','13:50:00',5.3),('8537','2013-05-19','13:55:00',5.28),('8537','2013-05-19','14:00:00',5.3),('8537','2013-05-19','14:05:00',5.23),('8537','2013-05-19','14:10:00',5.23),('8537','2013-05-19','14:15:00',5.21),('8537','2013-05-19','14:20:00',5.17),('8537','2013-05-19','14:25:00',5.14),('8537','2013-05-19','14:30:00',5.15),('8537','2013-05-19','14:35:00',5.05),('8537','2013-05-19','14:40:00',4.77),('8537','2013-05-19','14:45:00',4.35),('8537','2013-05-19','14:50:00',4.82),('8537','2013-05-19','14:55:00',4.88),('8537','2013-05-19','15:00:00',4.85),('8537','2013-05-19','15:05:00',4.81),('8537','2013-05-19','15:10:00',4.72),('8537','2013-05-19','15:15:00',4.68),('8537','2013-05-19','15:20:00',4.6),('8537','2013-05-19','15:25:00',4.58),('8537','2013-05-19','15:30:00',4.51),('8537','2013-05-19','15:35:00',4.37),('8537','2013-05-19','15:40:00',4.28),('8537','2013-05-19','15:45:00',4.21),('8537','2013-05-19','15:50:00',4.12),('8537','2013-05-19','15:55:00',4.14),('8537','2013-05-19','16:00:00',4.06),('8537','2013-05-19','16:05:00',4),('8537','2013-05-19','16:10:00',3.91),('8537','2013-05-19','16:15:00',3.81),('8537','2013-05-19','16:20:00',3.66),('8537','2013-05-19','16:25:00',3.63),('8537','2013-05-19','16:30:00',3.51),('8537','2013-05-19','16:35:00',3.46),('8537','2013-05-19','16:40:00',3.38),('8537','2013-05-19','16:45:00',3.3),('8537','2013-05-19','16:50:00',3.21),('8537','2013-05-19','16:55:00',3),('8537','2013-05-19','17:00:00',2.46),('8537','2013-05-19','17:05:00',2.61),('8537','2013-05-19','17:10:00',2.78),('8537','2013-05-19','17:15:00',2.67),('8537','2013-05-19','17:20:00',2.52),('8537','2013-05-19','17:25:00',2.41),('8537','2013-05-19','17:30:00',2.31),('8537','2013-05-19','17:35:00',2.22),('8537','2013-05-19','17:40:00',2.03),('8537','2013-05-19','17:45:00',1.98),('8537','2013-05-19','17:50:00',1.86),('8537','2013-05-19','17:55:00',1.74),('8537','2013-05-19','18:00:00',1.64),('8537','2013-05-19','18:05:00',1.54),('8537','2013-05-19','18:10:00',1.43),('8537','2013-05-19','18:15:00',1.32),('8537','2013-05-19','18:20:00',1.21),('8537','2013-05-19','18:25:00',1.12),('8537','2013-05-18','07:30:00',1.08),('8537','2013-05-18','07:35:00',1.19),('8537','2013-05-18','07:40:00',1.36),('8537','2013-05-18','07:45:00',1.5),('8537','2013-05-18','07:50:00',1.27),('8537','2013-05-18','07:55:00',2.09),('8537','2013-05-18','08:00:00',2.23),('8537','2013-05-18','08:05:00',2.27),('8537','2013-05-18','08:10:00',1.18),('8537','2013-05-18','08:15:00',1.15),('8537','2013-05-18','08:20:00',1.37),('8537','2013-05-18','08:25:00',2.97),('8537','2013-05-18','08:30:00',2.66),('8537','2013-05-18','08:35:00',2.29),('8537','2013-05-18','08:40:00',2.62),('8537','2013-05-18','08:45:00',2.68),('8537','2013-05-18','08:50:00',2.78),('8537','2013-05-18','08:55:00',2.88),('8537','2013-05-18','09:00:00',2.98),('8537','2013-05-18','09:05:00',3.03),('8537','2013-05-18','09:10:00',3.21),('8537','2013-05-18','09:15:00',3.27),('8537','2013-05-18','09:20:00',3.32),('8537','2013-05-18','09:25:00',3.4),('8537','2013-05-18','09:30:00',3.49),('8537','2013-05-18','09:35:00',3.61),('8537','2013-05-18','09:40:00',3.66),('8537','2013-05-18','09:45:00',3.72),('8537','2013-05-18','09:50:00',3.79),('8537','2013-05-18','09:55:00',3.88),('8537','2013-05-18','10:00:00',3.94),('8537','2013-05-18','10:05:00',4.02),('8537','2013-05-18','10:10:00',4.12),('8537','2013-05-18','10:15:00',4.14),('8537','2013-05-18','10:20:00',4.19),('8537','2013-05-18','10:25:00',4.24),('8537','2013-05-18','10:30:00',4.3),('8537','2013-05-18','10:35:00',4.29),('8537','2013-05-18','10:40:00',4.41),('8537','2013-05-18','10:45:00',4.47),('8537','2013-05-18','10:50:00',4.5),('8537','2013-05-18','10:55:00',4.64),('8537','2013-05-18','11:00:00',4.83),('8537','2013-05-18','11:05:00',4.5),('8537','2013-05-18','11:10:00',4),('8537','2013-05-18','11:15:00',5.04),('8537','2013-05-18','11:20:00',4.92),('8537','2013-05-18','11:25:00',5),('8537','2013-05-18','11:30:00',4.88),('8537','2013-05-18','11:35:00',4.72),('8537','2013-05-18','11:40:00',4.9),('8537','2013-05-18','11:45:00',4.59),('8537','2013-05-18','11:50:00',4.67),('8537','2013-05-18','11:55:00',4.85),('8537','2013-05-18','12:00:00',4.98),('8537','2013-05-18','12:05:00',4.87),('8537','2013-05-18','12:10:00',4.88),('8537','2013-05-18','12:15:00',4.89),('8537','2013-05-18','12:20:00',4.92),('8537','2013-05-18','12:25:00',5.04),('8537','2013-05-18','12:30:00',3.8),('8537','2013-05-18','12:35:00',5.13),('8537','2013-05-18','12:40:00',5.1),('8537','2013-05-18','12:45:00',5.01),('8537','2013-05-18','12:50:00',5.08),('8537','2013-05-18','12:55:00',5),('8537','2013-05-18','13:00:00',4.91),('8537','2013-05-18','13:05:00',4.94),('8537','2013-05-18','13:10:00',3.96),('8537','2013-05-18','13:15:00',4.98),('8537','2013-05-18','13:20:00',5.05),('8537','2013-05-18','13:25:00',4.99),('8537','2013-05-18','13:30:00',4.97),('8537','2013-05-18','13:35:00',4.44),('8537','2013-05-18','13:40:00',5.03),('8537','2013-05-18','13:45:00',5.28),('8537','2013-05-18','13:50:00',4.41),('8537','2013-05-18','13:55:00',4.37),('8537','2013-05-18','14:00:00',3.95),('8537','2013-05-18','14:05:00',3.73),('8537','2013-05-18','14:10:00',5.34),('8537','2013-05-18','14:15:00',5.11),('8537','2013-05-18','14:20:00',5.02),('8537','2013-05-18','14:25:00',4.79),('8537','2013-05-18','14:30:00',4.78),('8537','2013-05-18','14:35:00',4.72),('8537','2013-05-18','14:40:00',4.83),('8537','2013-05-18','14:45:00',4.55),('8537','2013-05-18','14:50:00',4.1),('8537','2013-05-18','14:55:00',3.8),('8537','2013-05-18','15:00:00',4.28),('8537','2013-05-18','15:05:00',4.25),('8537','2013-05-18','15:10:00',4.14),('8537','2013-05-18','15:15:00',4.06),('8537','2013-05-18','15:20:00',3.98),('8537','2013-05-18','15:25:00',3.91),('8537','2013-05-18','15:30:00',3.84),('8537','2013-05-18','15:35:00',3.64),('8537','2013-05-18','15:40:00',3.5),('8537','2013-05-18','15:45:00',3.59),('8537','2013-05-18','15:50:00',3.58),('8537','2013-05-18','15:55:00',3.49),('8537','2013-05-18','16:00:00',3.41),('8537','2013-05-18','16:05:00',3.36),('8537','2013-05-18','16:10:00',3.27),('8537','2013-05-18','16:15:00',3.18),('8537','2013-05-18','16:20:00',3.07),('8537','2013-05-18','16:25:00',3.01),('8537','2013-05-18','16:30:00',2.93),('8537','2013-05-18','16:35:00',2.85),('8537','2013-05-18','16:40:00',2.79),('8537','2013-05-18','16:45:00',2.7),('8537','2013-05-18','16:50:00',2.59),('8537','2013-05-18','16:55:00',2.47),('8537','2013-05-18','17:00:00',2.26),('8537','2013-05-18','17:05:00',2.32),('8537','2013-05-18','17:10:00',2.25),('8537','2013-05-18','17:15:00',2.15),('8537','2013-05-18','17:20:00',2.06),('8537','2013-05-18','17:25:00',1.96),('8537','2013-05-18','17:30:00',1.85),('8537','2013-05-18','17:35:00',1.77),('8537','2013-05-18','17:40:00',1.64),('8537','2013-05-18','17:45:00',1.56),('8537','2013-05-18','17:50:00',1.48),('8537','2013-05-18','17:55:00',1.42),('8537','2013-05-18','18:00:00',1.33),('8537','2013-05-18','18:05:00',1.24),('8537','2013-05-18','18:10:00',1.15),('8537','2013-05-18','18:15:00',1.07),('8537','2013-05-17','07:40:00',1.27),('8537','2013-05-17','07:45:00',1.28),('8537','2013-05-17','07:50:00',1.24),('8537','2013-05-17','07:55:00',1.08),('8537','2013-05-17','08:00:00',1.65),('8537','2013-05-17','08:05:00',1.04),('8537','2013-05-17','08:15:00',1.85),('8537','2013-05-17','08:20:00',2.52),('8537','2013-05-17','08:25:00',1.75),('8537','2013-05-17','08:30:00',1.14),('8537','2013-05-17','09:25:00',1.37),('8537','2013-05-17','10:20:00',1.03),('8537','2013-05-17','10:25:00',1.5),('8537','2013-05-17','10:30:00',1.87),('8537','2013-05-17','10:35:00',1.51),('8537','2013-05-17','10:40:00',1.71),('8537','2013-05-17','10:45:00',1.82),('8537','2013-05-17','10:50:00',3.39),('8537','2013-05-17','10:55:00',3.82),('8537','2013-05-17','11:00:00',2.62),('8537','2013-05-17','11:05:00',2.46),('8537','2013-05-17','11:10:00',1.69),('8537','2013-05-17','11:15:00',2.41),('8537','2013-05-17','11:20:00',2.35),('8537','2013-05-17','11:25:00',2.01),('8537','2013-05-17','11:30:00',2.43),('8537','2013-05-17','11:35:00',3.08),('8537','2013-05-17','11:40:00',1.89),('8537','2013-05-17','11:45:00',1.81),('8537','2013-05-17','11:50:00',2.94),('8537','2013-05-17','11:55:00',3.15),('8537','2013-05-17','12:00:00',2.02),('8537','2013-05-17','12:05:00',3.3),('8537','2013-05-17','12:10:00',3.75),('8537','2013-05-17','12:15:00',3.13),('8537','2013-05-17','12:20:00',2.96),('8537','2013-05-17','12:25:00',3.34),('8537','2013-05-17','12:30:00',3.03),('8537','2013-05-17','12:35:00',3.59),('8537','2013-05-17','12:40:00',4.89),('8537','2013-05-17','12:45:00',4.84),('8537','2013-05-17','12:50:00',5.57),('8537','2013-05-17','12:55:00',5.43),('8537','2013-05-17','13:00:00',4.9),('8537','2013-05-17','13:05:00',5.49),('8537','2013-05-17','13:10:00',3.47),('8537','2013-05-17','13:15:00',4.9),('8537','2013-05-17','13:20:00',5.62),('8537','2013-05-17','13:25:00',5.01),('8537','2013-05-17','13:30:00',3.91),('8537','2013-05-17','13:35:00',5.48),('8537','2013-05-17','13:40:00',3.92),('8537','2013-05-17','13:45:00',5.24),('8537','2013-05-17','13:50:00',5),('8537','2013-05-17','13:55:00',4.4),('8537','2013-05-17','14:00:00',3.95),('8537','2013-05-17','14:05:00',3.14),('8537','2013-05-17','14:10:00',4.65),('8537','2013-05-17','14:15:00',4.91),('8537','2013-05-17','14:20:00',5.48),('8537','2013-05-17','14:25:00',4.42),('8537','2013-05-17','14:30:00',4.86),('8537','2013-05-17','14:35:00',4.13),('8537','2013-05-17','14:40:00',3.72),('8537','2013-05-17','14:45:00',3.82),('8537','2013-05-17','14:50:00',3.3),('8537','2013-05-17','14:55:00',3.18),('8537','2013-05-17','15:00:00',4.15),('8537','2013-05-17','15:05:00',3.11),('8537','2013-05-17','15:10:00',2.04),('8537','2013-05-17','15:15:00',3.36),('8537','2013-05-17','15:20:00',3.47),('8537','2013-05-17','15:25:00',3.2),('8537','2013-05-17','15:30:00',2.67),('8537','2013-05-17','15:35:00',4.14),('8537','2013-05-17','15:40:00',4.49),('8537','2013-05-17','15:45:00',1.66),('8537','2013-05-17','15:50:00',2.87),('8537','2013-05-17','15:55:00',3.87),('8537','2013-05-17','16:00:00',3.5),('8537','2013-05-17','16:05:00',1.92),('8537','2013-05-17','16:10:00',2.34),('8537','2013-05-17','16:15:00',3.15),('8537','2013-05-17','16:20:00',3.48),('8537','2013-05-17','16:25:00',3.53),('8537','2013-05-17','16:30:00',3.66),('8537','2013-05-17','16:35:00',3.21),('8537','2013-05-17','16:40:00',3.63),('8537','2013-05-17','16:45:00',3.45),('8537','2013-05-17','16:50:00',3.15),('8537','2013-05-17','16:55:00',2.91),('8537','2013-05-17','17:00:00',2.85),('8537','2013-05-17','17:05:00',2.74),('8537','2013-05-17','17:10:00',2.66),('8537','2013-05-17','17:15:00',2.53),('8537','2013-05-17','17:20:00',2.39),('8537','2013-05-17','17:25:00',2.31),('8537','2013-05-17','17:30:00',2.23),('8537','2013-05-17','17:35:00',2.13),('8537','2013-05-17','17:40:00',1.99),('8537','2013-05-17','17:45:00',1.9),('8537','2013-05-17','17:50:00',1.76),('8537','2013-05-17','17:55:00',1.69),('8537','2013-05-17','18:00:00',1.59),('8537','2013-05-17','18:05:00',1.49),('8537','2013-05-17','18:10:00',1.35),('8537','2013-05-17','18:15:00',1.25),('8537','2013-05-17','18:20:00',1.15),('8537','2013-05-17','18:25:00',1.07),('8537','2013-05-16','09:15:00',1.08),('8537','2013-05-16','09:20:00',1.34),('8537','2013-05-16','09:25:00',1.93),('8537','2013-05-16','09:30:00',1.86),('8537','2013-05-16','09:35:00',2.17),('8537','2013-05-16','09:40:00',2.51),('8537','2013-05-16','09:45:00',2.95),('8537','2013-05-16','09:50:00',1.5),('8537','2013-05-16','09:55:00',1.42),('8537','2013-05-16','10:00:00',1.89),('8537','2013-05-16','10:05:00',1.55),('8537','2013-05-16','10:10:00',1.41),('8537','2013-05-16','10:15:00',1.83),('8537','2013-05-16','10:20:00',2.45),('8537','2013-05-16','10:25:00',2.74),('8537','2013-05-16','10:30:00',2.26),('8537','2013-05-16','10:35:00',1.64),('8537','2013-05-16','10:40:00',1.65),('8537','2013-05-16','10:45:00',1.51),('8537','2013-05-16','10:50:00',1.79),('8537','2013-05-16','10:55:00',2.17),('8537','2013-05-16','11:00:00',4.78),('8537','2013-05-16','11:05:00',4.09),('8537','2013-05-16','11:10:00',3.7),('8537','2013-05-16','11:15:00',2.19),('8537','2013-05-16','11:20:00',1.3),('8537','2013-05-16','11:25:00',1.5),('8537','2013-05-16','11:30:00',1.8),('8537','2013-05-16','11:35:00',3.31),('8537','2013-05-16','11:40:00',4.76),('8537','2013-05-16','11:45:00',4.28),('8537','2013-05-16','11:50:00',3.94),('8537','2013-05-16','11:55:00',2.74),('8537','2013-05-16','12:00:00',2.1),('8537','2013-05-16','12:05:00',1.96),('8537','2013-05-16','12:10:00',2.05),('8537','2013-05-16','12:15:00',3.35),('8537','2013-05-16','12:20:00',2.32),('8537','2013-05-16','12:25:00',2.63),('8537','2013-05-16','12:30:00',3.84),('8537','2013-05-16','12:35:00',4.01),('8537','2013-05-16','12:40:00',4.46),('8537','2013-05-16','12:45:00',4.26),('8537','2013-05-16','12:50:00',3.21),('8537','2013-05-16','12:55:00',5.17),('8537','2013-05-16','13:00:00',4.87),('8537','2013-05-16','13:05:00',4.69),('8537','2013-05-16','13:10:00',4.99),('8537','2013-05-16','13:15:00',4.25),('8537','2013-05-16','13:20:00',4.12),('8537','2013-05-16','13:25:00',4.99),('8537','2013-05-16','13:30:00',4.89),('8537','2013-05-16','13:35:00',4.88),('8537','2013-05-16','13:40:00',4.79),('8537','2013-05-16','13:45:00',4.77),('8537','2013-05-16','13:50:00',4.76),('8537','2013-05-16','13:55:00',4.79),('8537','2013-05-16','14:00:00',4.75),('8537','2013-05-16','14:05:00',4.73),('8537','2013-05-16','14:10:00',4.7),('8537','2013-05-16','14:15:00',4.66),('8537','2013-05-16','14:20:00',4.62),('8537','2013-05-16','14:25:00',4.49),('8537','2013-05-16','14:30:00',4.48),('8537','2013-05-16','14:35:00',4.33),('8537','2013-05-16','14:40:00',4.15),('8537','2013-05-16','14:45:00',3.92),('8537','2013-05-16','14:50:00',3.79),('8537','2013-05-16','14:55:00',3.65),('8537','2013-05-16','15:00:00',4.14),('8537','2013-05-16','15:05:00',4.16),('8537','2013-05-16','15:10:00',4.13),('8537','2013-05-16','15:15:00',3.66),('8537','2013-05-16','15:20:00',3.89),('8537','2013-05-16','15:25:00',3.91),('8537','2013-05-16','15:30:00',3.78),('8537','2013-05-16','15:35:00',3.59),('8537','2013-05-16','15:40:00',3.73),('8537','2013-05-16','15:45:00',3.6),('8537','2013-05-16','15:50:00',3.58),('8537','2013-05-16','15:55:00',3.57),('8537','2013-05-16','16:00:00',3.5),('8537','2013-05-16','16:05:00',3.32),('8537','2013-05-16','16:10:00',3.33),('8537','2013-05-16','16:15:00',3.08),('8537','2013-05-16','16:20:00',3.23),('8537','2013-05-16','16:25:00',3.08),('8537','2013-05-16','16:30:00',3.05),('8537','2013-05-16','16:35:00',2.89),('8537','2013-05-16','16:40:00',1.84),('8537','2013-05-16','16:45:00',1.66),('8537','2013-05-16','16:50:00',2.1),('8537','2013-05-16','16:55:00',1.65),('8537','2013-05-16','17:00:00',1.63),('8537','2013-05-16','17:05:00',1.03),('8537','2013-05-16','17:15:00',1.37),('8537','2013-05-16','17:20:00',1.57),('8537','2013-05-16','17:25:00',1.55),('8537','2013-05-16','17:30:00',1.82),('8537','2013-05-16','17:35:00',1.9),('8537','2013-05-16','17:40:00',1.55),('8537','2013-05-16','17:45:00',1.16),('8537','2013-05-16','18:50:00',1.02),('8537','2013-05-16','18:55:00',1.03),('8537','2013-05-16','19:00:00',1.09),('8537','2013-05-16','19:05:00',1.05),('8537','2013-05-15','07:30:00',1.07),('8537','2013-05-15','07:35:00',1.2),('8537','2013-05-15','07:40:00',1.33),('8537','2013-05-15','07:45:00',1.53),('8537','2013-05-15','07:50:00',1.58),('8537','2013-05-15','07:55:00',1.52),('8537','2013-05-15','08:00:00',1.62),('8537','2013-05-15','08:05:00',1.57),('8537','2013-05-15','08:10:00',1.87),('8537','2013-05-15','08:15:00',2.03),('8537','2013-05-15','08:20:00',2.08),('8537','2013-05-15','08:25:00',2.16),('8537','2013-05-15','08:30:00',2.2),('8537','2013-05-15','08:35:00',2.39),('8537','2013-05-15','08:40:00',2.52),('8537','2013-05-15','08:45:00',2.63),('8537','2013-05-15','08:50:00',2.73),('8537','2013-05-15','08:55:00',2.83),('8537','2013-05-15','09:00:00',2.73),('8537','2013-05-15','09:05:00',2.98),('8537','2013-05-15','09:10:00',2.95),('8537','2013-05-15','09:15:00',3.05),('8537','2013-05-15','09:20:00',3.03),('8537','2013-05-15','09:25:00',3.17),('8537','2013-05-15','09:30:00',3.35),('8537','2013-05-15','09:35:00',3.42),('8537','2013-05-15','09:40:00',3.43),('8537','2013-05-15','09:45:00',3.51),('8537','2013-05-15','09:50:00',3.65),('8537','2013-05-15','09:55:00',3.67),('8537','2013-05-15','10:00:00',3.79),('8537','2013-05-15','10:05:00',3.86),('8537','2013-05-15','10:10:00',3.99),('8537','2013-05-15','10:15:00',3.95),('8537','2013-05-15','10:20:00',4.12),('8537','2013-05-15','10:25:00',4.23),('8537','2013-05-15','10:30:00',4.08),('8537','2013-05-15','10:35:00',4.19),('8537','2013-05-15','10:40:00',4.34),('8537','2013-05-15','10:45:00',4.4),('8537','2013-05-15','10:50:00',4.42),('8537','2013-05-15','10:55:00',4.29),('8537','2013-05-15','11:00:00',4.31),('8537','2013-05-15','11:05:00',4.57),('8537','2013-05-15','11:10:00',4.58),('8537','2013-05-15','11:15:00',4.62),('8537','2013-05-15','11:20:00',4.43),('8537','2013-05-15','11:25:00',4.62),('8537','2013-05-15','11:30:00',4.62),('8537','2013-05-15','11:35:00',4.55),('8537','2013-05-15','11:40:00',4.03),('8537','2013-05-15','11:45:00',3.51),('8537','2013-05-15','11:50:00',3.04),('8537','2013-05-15','11:55:00',2.31),('8537','2013-05-15','12:00:00',2.47),('8537','2013-05-15','12:05:00',3.88),('8537','2013-05-15','12:10:00',5.11),('8537','2013-05-15','12:15:00',5.21),('8537','2013-05-15','12:20:00',3.14),('8537','2013-05-15','12:25:00',4.18),('8537','2013-05-15','12:30:00',3.42),('8537','2013-05-15','12:35:00',3.42),('8537','2013-05-15','12:40:00',5.46),('8537','2013-05-15','12:45:00',2.89),('8537','2013-05-15','12:50:00',2.89),('8537','2013-05-15','12:55:00',3.24),('8537','2013-05-15','13:00:00',3.28),('8537','2013-05-15','13:05:00',3.79),('8537','2013-05-15','13:10:00',3.34),('8537','2013-05-15','13:15:00',2.75),('8537','2013-05-15','13:20:00',3.23),('8537','2013-05-15','13:25:00',3.13),('8537','2013-05-15','13:30:00',3.24),('8537','2013-05-15','13:35:00',2.88),('8537','2013-05-15','13:40:00',2.93),('8537','2013-05-15','13:45:00',2.96),('8537','2013-05-15','13:50:00',2.48),('8537','2013-05-15','13:55:00',2.4),('8537','2013-05-15','14:00:00',2.09),('8537','2013-05-15','14:05:00',1.84),('8537','2013-05-15','14:10:00',1.9),('8537','2013-05-15','14:15:00',1.9),('8537','2013-05-15','14:20:00',1.96),('8537','2013-05-15','14:25:00',1.88),('8537','2013-05-15','14:30:00',1.67),('8537','2013-05-15','14:35:00',1.65),('8537','2013-05-15','14:40:00',1.81),('8537','2013-05-15','14:45:00',1.7),('8537','2013-05-15','14:50:00',1.71),('8537','2013-05-15','14:55:00',1.72),('8537','2013-05-15','15:00:00',1.68),('8537','2013-05-15','15:05:00',1.32),('8537','2013-05-15','15:10:00',1.03),('8537','2013-05-15','15:45:00',1.25),('8537','2013-05-15','15:50:00',1.71),('8537','2013-05-15','15:55:00',2.21),('8537','2013-05-15','16:00:00',2.19),('8537','2013-05-15','16:05:00',2.04),('8537','2013-05-15','16:10:00',1.85),('8537','2013-05-15','16:15:00',1.62),('8537','2013-05-15','16:20:00',1.79),('8537','2013-05-15','16:25:00',1.83),('8537','2013-05-15','16:30:00',1.65),('8537','2013-05-15','16:35:00',1.52),('8537','2013-05-15','16:40:00',1.41),('8537','2013-05-15','16:45:00',1.36),('8537','2013-05-15','16:50:00',1.37),('8537','2013-05-15','16:55:00',1.57),('8537','2013-05-15','17:00:00',1.86),('8537','2013-05-15','17:05:00',2.21),('8537','2013-05-15','17:10:00',2.02),('8537','2013-05-15','17:15:00',2.39),('8537','2013-05-15','17:20:00',2.19),('8537','2013-05-15','17:30:00',1.06),('8537','2013-05-14','07:30:00',1.1),('8537','2013-05-14','07:35:00',1.21),('8537','2013-05-14','07:40:00',1.33),('8537','2013-05-14','07:45:00',1.44),('8537','2013-05-14','07:50:00',1.56),('8537','2013-05-14','07:55:00',1.68),('8537','2013-05-14','08:00:00',1.79),('8537','2013-05-14','08:05:00',1.9),('8537','2013-05-14','08:10:00',2.03),('8537','2013-05-14','08:15:00',2.14),('8537','2013-05-14','08:20:00',2.25),('8537','2013-05-14','08:25:00',2.37),('8537','2013-05-14','08:30:00',2.46),('8537','2013-05-14','08:35:00',2.58),('8537','2013-05-14','08:40:00',2.68),('8537','2013-05-14','08:45:00',2.78),('8537','2013-05-14','08:50:00',2.88),('8537','2013-05-14','08:55:00',2.97),('8537','2013-05-14','09:00:00',3.07),('8537','2013-05-14','09:05:00',3.17),('8537','2013-05-14','09:10:00',3.25),('8537','2013-05-14','09:15:00',3.35),('8537','2013-05-14','09:20:00',3.42),('8537','2013-05-14','09:25:00',3.5),('8537','2013-05-14','09:30:00',3.58),('8537','2013-05-14','09:35:00',3.67),('8537','2013-05-14','09:40:00',3.74),('8537','2013-05-14','09:45:00',3.79),('8537','2013-05-14','09:50:00',3.87),('8537','2013-05-14','09:55:00',3.98),('8537','2013-05-14','10:00:00',4.04),('8537','2013-05-14','10:05:00',4.15),('8537','2013-05-14','10:10:00',4.18),('8537','2013-05-14','10:15:00',4.27),('8537','2013-05-14','10:20:00',4.35),('8537','2013-05-14','10:25:00',4.36),('8537','2013-05-14','10:30:00',4.41),('8537','2013-05-14','10:35:00',4.47),('8537','2013-05-14','10:40:00',4.52),('8537','2013-05-14','10:45:00',4.57),('8537','2013-05-14','10:50:00',4.63),('8537','2013-05-14','10:55:00',4.67),('8537','2013-05-14','11:00:00',4.66),('8537','2013-05-14','11:05:00',4.73),('8537','2013-05-14','11:10:00',4.78),('8537','2013-05-14','11:15:00',4.81),('8537','2013-05-14','11:20:00',4.82),('8537','2013-05-14','11:25:00',4.85),('8537','2013-05-14','11:30:00',4.88),('8537','2013-05-14','11:35:00',4.9),('8537','2013-05-14','11:40:00',4.93),('8537','2013-05-14','11:45:00',4.93),('8537','2013-05-14','11:50:00',4.98),('8537','2013-05-14','11:55:00',5.02),('8537','2013-05-14','12:00:00',5.06),('8537','2013-05-14','12:05:00',5.03),('8537','2013-05-14','12:10:00',5.07),('8537','2013-05-14','12:15:00',5.09),('8537','2013-05-14','12:20:00',5.19),('8537','2013-05-14','12:25:00',5.19),('8537','2013-05-14','12:30:00',5.21),('8537','2013-05-14','12:35:00',5.21),('8537','2013-05-14','12:40:00',5.17),('8537','2013-05-14','12:45:00',5.19),('8537','2013-05-14','12:50:00',5.19),('8537','2013-05-14','12:55:00',5.26),('8537','2013-05-14','13:00:00',5.26),('8537','2013-05-14','13:05:00',5.18),('8537','2013-05-14','13:10:00',5.18),('8537','2013-05-14','13:15:00',5.22),('8537','2013-05-14','13:20:00',5.18),('8537','2013-05-14','13:25:00',5.11),('8537','2013-05-14','13:30:00',5.03),('8537','2013-05-14','13:35:00',5.09),('8537','2013-05-14','13:40:00',5.12),('8537','2013-05-14','13:45:00',5.03),('8537','2013-05-14','13:50:00',5.04),('8537','2013-05-14','13:55:00',5.04),('8537','2013-05-14','14:00:00',5.02),('8537','2013-05-14','14:05:00',5.04),('8537','2013-05-14','14:10:00',5.01),('8537','2013-05-14','14:15:00',4.97),('8537','2013-05-14','14:20:00',4.86),('8537','2013-05-14','14:25:00',4.83),('8537','2013-05-14','14:30:00',4.77),('8537','2013-05-14','14:35:00',4.61),('8537','2013-05-14','14:40:00',4.39),('8537','2013-05-14','14:45:00',4.66),('8537','2013-05-14','14:50:00',4.67),('8537','2013-05-14','14:55:00',4.67),('8537','2013-05-14','15:00:00',4.65),('8537','2013-05-14','15:05:00',4.6),('8537','2013-05-14','15:10:00',4.54),('8537','2013-05-14','15:15:00',4.51),('8537','2013-05-14','15:20:00',4.45),('8537','2013-05-14','15:25:00',4.42),('8537','2013-05-14','15:30:00',4.3),('8537','2013-05-14','15:35:00',4.1),('8537','2013-05-14','15:40:00',4.16),('8537','2013-05-14','15:45:00',4.11),('8537','2013-05-14','15:50:00',4.02),('8537','2013-05-14','15:55:00',3.97),('8537','2013-05-14','16:00:00',3.91),('8537','2013-05-14','16:05:00',3.83),('8537','2013-05-14','16:10:00',3.73),('8537','2013-05-14','16:15:00',3.6),('8537','2013-05-14','16:20:00',3.51),('8537','2013-05-14','16:25:00',3.47),('8537','2013-05-14','16:30:00',3.38),('8537','2013-05-14','16:35:00',3.3),('8537','2013-05-14','16:40:00',3.2),('8537','2013-05-14','16:45:00',3.12),('8537','2013-05-14','16:50:00',3.01),('8537','2013-05-14','16:55:00',2.61),('8537','2013-05-14','17:00:00',2.38),('8537','2013-05-14','17:05:00',2.7),('8537','2013-05-14','17:10:00',2.61),('8537','2013-05-14','17:15:00',2.48),('8537','2013-05-14','17:20:00',2.35),('8537','2013-05-14','17:25:00',2.25),('8537','2013-05-14','17:30:00',2.16),('8537','2013-05-14','17:35:00',2.02),('8537','2013-05-14','17:40:00',1.92),('8537','2013-05-14','17:45:00',1.8),('8537','2013-05-14','17:50:00',1.69),('8537','2013-05-14','17:55:00',1.6),('8537','2013-05-14','18:00:00',1.49),('8537','2013-05-14','18:05:00',1.39),('8537','2013-05-14','18:10:00',1.26),('8537','2013-05-14','18:15:00',1.17),('8537','2013-05-14','18:20:00',1.08),('8537','2013-05-13','07:35:00',1.08),('8537','2013-05-13','07:40:00',1.16),('8537','2013-05-13','07:45:00',1.3),('8537','2013-05-13','07:50:00',1.34),('8537','2013-05-13','07:55:00',1.19),('8537','2013-05-13','08:00:00',1.58),('8537','2013-05-13','08:05:00',1.7),('8537','2013-05-13','08:10:00',1.84),('8537','2013-05-13','08:15:00',1.96),('8537','2013-05-13','08:20:00',2.07),('8537','2013-05-13','08:25:00',2.16),('8537','2013-05-13','08:30:00',2.23),('8537','2013-05-13','08:35:00',2.34),('8537','2013-05-13','08:40:00',2.47),('8537','2013-05-13','08:45:00',2.57),('8537','2013-05-13','08:50:00',2.66),('8537','2013-05-13','08:55:00',2.7),('8537','2013-05-13','09:00:00',2.84),('8537','2013-05-13','09:05:00',2.93),('8537','2013-05-13','09:10:00',3),('8537','2013-05-13','09:15:00',3.11),('8537','2013-05-13','09:20:00',3.24),('8537','2013-05-13','09:25:00',3.36),('8537','2013-05-13','09:30:00',3.44),('8537','2013-05-13','09:35:00',3.46),('8537','2013-05-13','09:40:00',3.59),('8537','2013-05-13','09:45:00',3.67),('8537','2013-05-13','09:50:00',3.8),('8537','2013-05-13','09:55:00',3.99),('8537','2013-05-13','10:00:00',4.1),('8537','2013-05-13','10:05:00',4.1),('8537','2013-05-13','10:10:00',4.05),('8537','2013-05-13','10:15:00',4.36),('8537','2013-05-13','10:20:00',3.89),('8537','2013-05-13','10:25:00',2.45),('8537','2013-05-13','10:30:00',3.85),('8537','2013-05-13','10:35:00',2.58),('8537','2013-05-13','10:40:00',1.18),('8537','2013-05-13','10:45:00',4.12),('8537','2013-05-13','10:50:00',5.23),('8537','2013-05-13','10:55:00',2.51),('8537','2013-05-13','11:00:00',2.83),('8537','2013-05-13','11:05:00',2.96),('8537','2013-05-13','11:10:00',2.21),('8537','2013-05-13','11:15:00',2.81),('8537','2013-05-13','11:20:00',1.84),('8537','2013-05-13','11:25:00',2.46),('8537','2013-05-13','11:30:00',2.07),('8537','2013-05-13','11:35:00',1.58),('8537','2013-05-13','11:40:00',2.87),('8537','2013-05-13','11:45:00',3.26),('8537','2013-05-13','11:50:00',2.29),('8537','2013-05-13','11:55:00',2.02),('8537','2013-05-13','12:00:00',2),('8537','2013-05-13','12:05:00',1.97),('8537','2013-05-13','12:10:00',3.44),('8537','2013-05-13','12:15:00',3.27),('8537','2013-05-13','12:20:00',1.81),('8537','2013-05-13','12:25:00',2.03),('8537','2013-05-13','12:30:00',2.71),('8537','2013-05-13','12:35:00',5.3),('8537','2013-05-13','12:40:00',4.56),('8537','2013-05-13','12:45:00',2.12),('8537','2013-05-13','12:50:00',4.41),('8537','2013-05-13','12:55:00',3.74),('8537','2013-05-13','13:00:00',5.91),('8537','2013-05-13','13:05:00',5.81),('8537','2013-05-13','13:10:00',5.42),('8537','2013-05-13','13:15:00',5.62),('8537','2013-05-13','13:20:00',4.2),('8537','2013-05-13','13:25:00',5.81),('8537','2013-05-13','13:30:00',5.89),('8537','2013-05-13','13:35:00',5.68),('8537','2013-05-13','13:40:00',5.25),('8537','2013-05-13','13:45:00',2.02),('8537','2013-05-13','13:50:00',1.51),('8537','2013-05-13','13:55:00',1.42),('8537','2013-05-13','14:00:00',1.35),('8537','2013-05-13','14:05:00',3.63),('8537','2013-05-13','14:10:00',5.81),('8537','2013-05-13','14:15:00',5.52),('8537','2013-05-13','14:20:00',5.18),('8537','2013-05-13','14:25:00',4.02),('8537','2013-05-13','14:30:00',1.06),('8537','2013-05-13','14:35:00',5.17),('8537','2013-05-13','14:40:00',5.22),('8537','2013-05-13','14:45:00',3.93),('8537','2013-05-13','14:50:00',1.33),('8537','2013-05-13','14:55:00',4.6),('8537','2013-05-13','15:00:00',3.73),('8537','2013-05-13','15:05:00',3.22),('8537','2013-05-13','15:10:00',1.32),('8537','2013-05-13','15:15:00',1.16),('8537','2013-05-13','15:20:00',1.33),('8537','2013-05-13','15:25:00',1.04),('8537','2013-05-13','16:00:00',1.27),('8537','2013-05-13','16:05:00',1.5),('8537','2013-05-13','16:10:00',2.21),('8537','2013-05-13','16:15:00',1.45),('8537','2013-05-13','16:20:00',1.63),('8537','2013-05-13','16:25:00',1.57),('8537','2013-05-13','16:30:00',2.05),('8537','2013-05-13','16:35:00',1.49),('8537','2013-05-13','16:40:00',1.96),('8537','2013-05-13','16:45:00',2.32),('8537','2013-05-13','16:50:00',3.6),('8537','2013-05-13','16:55:00',3.43),('8537','2013-05-13','17:00:00',3.07),('8537','2013-05-13','17:05:00',2.84),('8537','2013-05-13','17:10:00',2.07),('8537','2013-05-13','17:15:00',3.16),('8537','2013-05-13','17:20:00',3.15),('8537','2013-05-13','17:25:00',2.92),('8537','2013-05-13','17:30:00',2.65),('8537','2013-05-13','17:35:00',2.51),('8537','2013-05-13','17:40:00',2.3),('8537','2013-05-13','17:45:00',2.23),('8537','2013-05-13','17:50:00',1.76),('8537','2013-05-13','17:55:00',1.01),('8537','2013-05-12','08:05:00',1.17),('8537','2013-05-12','08:10:00',1.54),('8537','2013-05-12','08:15:00',2.31),('8537','2013-05-12','08:20:00',1.78),('8537','2013-05-12','08:25:00',1.42),('8537','2013-05-12','08:30:00',1.11),('8537','2013-05-12','08:40:00',1.08),('8537','2013-05-12','08:45:00',1.61),('8537','2013-05-12','08:50:00',1.64),('8537','2013-05-12','08:55:00',1.2),('8537','2013-05-12','09:00:00',1.5),('8537','2013-05-12','09:05:00',1.81),('8537','2013-05-12','09:10:00',1.29),('8537','2013-05-12','09:15:00',1.55),('8537','2013-05-12','09:20:00',1.64),('8537','2013-05-12','09:25:00',1.78),('8537','2013-05-12','09:30:00',3.22),('8537','2013-05-12','09:35:00',1.64),('8537','2013-05-12','09:40:00',1.51),('8537','2013-05-12','09:45:00',4.57),('8537','2013-05-12','09:50:00',4.42),('8537','2013-05-12','09:55:00',3.99),('8537','2013-05-12','10:00:00',3.64),('8537','2013-05-12','10:05:00',1.4),('8537','2013-05-12','10:10:00',2.76),('8537','2013-05-12','10:15:00',1.4),('8537','2013-05-12','10:20:00',1.03),('8537','2013-05-12','10:25:00',1.22),('8537','2013-05-12','10:30:00',1.59),('8537','2013-05-12','10:35:00',1.33),('8537','2013-05-12','10:40:00',1.17),('8537','2013-05-12','10:45:00',1.25),('8537','2013-05-12','10:50:00',2.45),('8537','2013-05-12','10:55:00',5.46),('8537','2013-05-12','11:00:00',2.08),('8537','2013-05-12','11:05:00',1.17),('8537','2013-05-12','11:10:00',1.56),('8537','2013-05-12','11:15:00',5.41),('8537','2013-05-12','11:20:00',4.5),('8537','2013-05-12','11:25:00',3.34),('8537','2013-05-12','11:30:00',5.36),('8537','2013-05-12','11:35:00',4.56),('8537','2013-05-12','11:40:00',3.83),('8537','2013-05-12','11:45:00',5.37),('8537','2013-05-12','11:50:00',4.32),('8537','2013-05-12','11:55:00',2.41),('8537','2013-05-12','12:00:00',3.52),('8537','2013-05-12','12:05:00',4.46),('8537','2013-05-12','12:10:00',4.92),('8537','2013-05-12','12:15:00',1.94),('8537','2013-05-12','12:20:00',1.31),('8537','2013-05-12','12:25:00',1.23),('8537','2013-05-12','12:30:00',1.32),('8537','2013-05-12','12:35:00',2.59),('8537','2013-05-12','12:40:00',3.32),('8537','2013-05-12','12:45:00',4.65),('8537','2013-05-12','12:50:00',4.92),('8537','2013-05-12','12:55:00',2.69),('8537','2013-05-12','13:00:00',1.68),('8537','2013-05-12','13:05:00',1.71),('8537','2013-05-12','13:10:00',3.08),('8537','2013-05-12','13:15:00',2.98),('8537','2013-05-12','13:20:00',2.04),('8537','2013-05-12','13:25:00',3.36),('8537','2013-05-12','13:30:00',4.13),('8537','2013-05-12','13:35:00',5.02),('8537','2013-05-12','13:40:00',5.69),('8537','2013-05-12','13:45:00',4.21),('8537','2013-05-12','13:50:00',3.44),('8537','2013-05-12','13:55:00',3.87),('8537','2013-05-12','14:00:00',3.14),('8537','2013-05-12','14:05:00',5.45),('8537','2013-05-12','14:10:00',4.31),('8537','2013-05-12','14:15:00',4.66),('8537','2013-05-12','14:20:00',5.53),('8537','2013-05-12','14:25:00',5.25),('8537','2013-05-12','14:30:00',5.19),('8537','2013-05-12','14:35:00',5.07),('8537','2013-05-12','14:40:00',5.07),('8537','2013-05-12','14:45:00',4.76),('8537','2013-05-12','14:50:00',4.87),('8537','2013-05-12','14:55:00',4.91),('8537','2013-05-12','15:00:00',4.12),('8537','2013-05-12','15:05:00',4.82),('8537','2013-05-12','15:10:00',4.81),('8537','2013-05-12','15:15:00',4.82),('8537','2013-05-12','15:20:00',3.34),('8537','2013-05-12','15:25:00',4.08),('8537','2013-05-12','15:30:00',3.99),('8537','2013-05-12','15:35:00',4.07),('8537','2013-05-12','15:40:00',4.16),('8537','2013-05-12','15:45:00',4.11),('8537','2013-05-12','15:50:00',3.99),('8537','2013-05-12','15:55:00',3.9),('8537','2013-05-12','16:00:00',3.83),('8537','2013-05-12','16:05:00',3.76),('8537','2013-05-12','16:10:00',3.69),('8537','2013-05-12','16:15:00',3.55),('8537','2013-05-12','16:20:00',3.51),('8537','2013-05-12','16:25:00',3.39),('8537','2013-05-12','16:30:00',3.27),('8537','2013-05-12','16:35:00',3.28),('8537','2013-05-12','16:40:00',3.26),('8537','2013-05-12','16:45:00',3.2),('8537','2013-05-12','16:50:00',3.11),('8537','2013-05-12','16:55:00',2.97),('8537','2013-05-12','17:00:00',3.14),('8537','2013-05-12','17:05:00',2.92),('8537','2013-05-12','17:10:00',2.77),('8537','2013-05-12','17:15:00',2.87),('8537','2013-05-12','17:20:00',2.47),('8537','2013-05-12','17:25:00',2.13),('8537','2013-05-12','17:30:00',2.15),('8537','2013-05-12','17:35:00',1.71),('8537','2013-05-12','17:40:00',1.87),('8537','2013-05-12','17:45:00',1.35),('8537','2013-05-12','17:50:00',1.24),('8537','2013-05-12','17:55:00',1.1),('8537','2013-05-12','18:00:00',1.38),('8537','2013-05-12','18:05:00',1.77),('8537','2013-05-12','18:10:00',1.77),('8537','2013-05-12','18:15:00',1.6),('8537','2013-05-12','18:20:00',1.21),('8537','2013-05-12','18:25:00',1.4),('8537','2013-05-12','18:30:00',1.22),('8537','2013-05-12','18:35:00',1.32),('8537','2013-05-12','18:40:00',1.11),('8537','2014-03-31','08:10:00',1.07),('8537','2014-03-31','08:15:00',1.19),('8537','2014-03-31','08:20:00',1.3),('8537','2014-03-31','08:25:00',1.41),('8537','2014-03-31','08:30:00',1.53),('8537','2014-03-31','08:35:00',1.63),('8537','2014-03-31','08:40:00',1.75),('8537','2014-03-31','08:45:00',1.83),('8537','2014-03-31','08:50:00',1.99),('8537','2014-03-31','08:55:00',2.11),('8537','2014-03-31','09:00:00',2.22),('8537','2014-03-31','09:05:00',2.33),('8537','2014-03-31','09:10:00',2.44),('8537','2014-03-31','09:15:00',2.55),('8537','2014-03-31','09:20:00',2.65),('8537','2014-03-31','09:25:00',2.75),('8537','2014-03-31','09:30:00',2.84),('8537','2014-03-31','09:35:00',2.94),('8537','2014-03-31','09:40:00',3.03),('8537','2014-03-31','09:45:00',3.12),('8537','2014-03-31','09:50:00',3.19),('8537','2014-03-31','09:55:00',3.27),('8537','2014-03-31','10:00:00',3.35),('8537','2014-03-31','10:05:00',3.43),('8537','2014-03-31','10:10:00',3.51),('8537','2014-03-31','10:15:00',3.6),('8537','2014-03-31','10:20:00',3.67),('8537','2014-03-31','10:25:00',3.7),('8537','2014-03-31','10:30:00',3.75),('8537','2014-03-31','10:35:00',3.82),('8537','2014-03-31','10:40:00',3.91),('8537','2014-03-31','10:45:00',3.96),('8537','2014-03-31','10:50:00',4.01),('8537','2014-03-31','10:55:00',4.09),('8537','2014-03-31','11:00:00',4.14),('8537','2014-03-31','11:05:00',4.18),('8537','2014-03-31','11:10:00',4.23),('8537','2014-03-31','11:15:00',4.31),('8537','2014-03-31','11:20:00',4.37),('8537','2014-03-31','11:25:00',4.43),('8537','2014-03-31','11:30:00',4.44),('8537','2014-03-31','11:35:00',4.48),('8537','2014-03-31','11:40:00',4.53),('8537','2014-03-31','11:45:00',4.52),('8537','2014-03-31','11:50:00',4.53),('8537','2014-03-31','11:55:00',4.65),('8537','2014-03-31','12:00:00',4.7),('8537','2014-03-31','12:05:00',4.64),('8537','2014-03-31','12:10:00',4.64),('8537','2014-03-31','12:15:00',4.68),('8537','2014-03-31','12:20:00',4.74),('8537','2014-03-31','12:25:00',4.76),('8537','2014-03-31','12:30:00',4.76),('8537','2014-03-31','12:35:00',4.79),('8537','2014-03-31','12:40:00',4.84),('8537','2014-03-31','12:45:00',4.83),('8537','2014-03-31','12:50:00',4.77),('8537','2014-03-31','12:55:00',4.74),('8537','2014-03-31','13:00:00',4.78),('8537','2014-03-31','13:05:00',4.83),('8537','2014-03-31','13:10:00',4.82),('8537','2014-03-31','13:15:00',4.85),('8537','2014-03-31','13:20:00',4.9),('8537','2014-03-31','13:25:00',4.84),('8537','2014-03-31','13:30:00',4.83),('8537','2014-03-31','13:35:00',4.88),('8537','2014-03-31','13:40:00',4.89),('8537','2014-03-31','13:45:00',4.87),('8537','2014-03-31','13:50:00',4.85),('8537','2014-03-31','13:55:00',4.82),('8537','2014-03-31','14:00:00',4.82),('8537','2014-03-31','14:05:00',4.82),('8537','2014-03-31','14:10:00',4.79),('8537','2014-03-31','14:15:00',4.79),('8537','2014-03-31','14:20:00',4.74),('8537','2014-03-31','14:25:00',4.69),('8537','2014-03-31','14:30:00',4.62),('8537','2014-03-31','14:35:00',4.48),('8537','2014-03-31','14:40:00',4.53),('8537','2014-03-31','14:45:00',4.51),('8537','2014-03-31','14:50:00',4.4),('8537','2014-03-31','14:55:00',4.39),('8537','2014-03-31','15:00:00',4.39),('8537','2014-03-31','15:05:00',4.32),('8537','2014-03-31','15:10:00',4.28),('8537','2014-03-31','15:15:00',4.25),('8537','2014-03-31','15:20:00',4.13),('8537','2014-03-31','15:25:00',3.75),('8537','2014-03-31','15:30:00',3.26),('8537','2014-03-31','15:35:00',3.23),('8537','2014-03-31','15:40:00',3.84),('8537','2014-03-31','15:45:00',3.78),('8537','2014-03-31','15:50:00',3.69),('8537','2014-03-31','15:55:00',3.6),('8537','2014-03-31','16:00:00',3.46),('8537','2014-03-31','16:05:00',3.33),('8537','2014-03-31','16:10:00',3.31),('8537','2014-03-31','16:15:00',3.22),('8537','2014-03-31','16:20:00',3.14),('8537','2014-03-31','16:25:00',3.05),('8537','2014-03-31','16:30:00',2.96),('8537','2014-03-31','16:35:00',2.79),('8537','2014-03-31','16:40:00',2.73),('8537','2014-03-31','16:45:00',2.66),('8537','2014-03-31','16:50:00',2.55),('8537','2014-03-31','16:55:00',2.37),('8537','2014-03-31','17:00:00',2.28),('8537','2014-03-31','17:05:00',2.19),('8537','2014-03-31','17:10:00',2.11),('8537','2014-03-31','17:15:00',1.99),('8537','2014-03-31','17:20:00',1.85),('8537','2014-03-31','17:25:00',1.7),('8537','2014-03-31','17:30:00',1.63),('8537','2014-03-31','17:35:00',1.53),('8537','2014-03-31','17:40:00',1.43),('8537','2014-03-31','17:45:00',1.31),('8537','2014-03-31','17:50:00',1.2),('8537','2014-03-31','17:55:00',1.11),('8537','2014-03-31','18:00:00',1.01),('8537','2013-05-11','07:45:00',1.24),('8537','2013-05-11','07:50:00',1.48),('8537','2013-05-11','07:55:00',1.67),('8537','2013-05-11','08:00:00',1.55),('8537','2013-05-11','08:05:00',1.53),('8537','2013-05-11','08:15:00',1.69),('8537','2013-05-11','08:20:00',1.53),('8537','2013-05-11','08:25:00',1.05),('8537','2013-05-11','08:30:00',1.09),('8537','2013-05-11','08:35:00',1.51),('8537','2013-05-11','09:05:00',1.21),('8537','2013-05-11','09:10:00',1.21),('8537','2013-05-11','09:15:00',1.34),('8537','2013-05-11','09:20:00',1.84),('8537','2013-05-11','09:25:00',2.01),('8537','2013-05-11','09:30:00',2.34),('8537','2013-05-11','09:35:00',3.76),('8537','2013-05-11','09:40:00',2.18),('8537','2013-05-11','09:45:00',2.15),('8537','2013-05-11','09:50:00',1.75),('8537','2013-05-11','09:55:00',1.59),('8537','2013-05-11','10:00:00',1.81),('8537','2013-05-11','10:05:00',2.05),('8537','2013-05-11','10:10:00',1.19),('8537','2013-05-11','10:20:00',1.26),('8537','2013-05-11','10:25:00',1.18),('8537','2013-05-11','10:30:00',1.39),('8537','2013-05-11','10:35:00',1.43),('8537','2013-05-11','10:40:00',1.15),('8537','2013-05-11','10:50:00',1.25),('8537','2013-05-11','10:55:00',4.36),('8537','2013-05-11','11:00:00',3.78),('8537','2013-05-11','11:05:00',3.15),('8537','2013-05-11','11:10:00',1.45),('8537','2013-05-11','11:15:00',1.11),('8537','2013-05-11','11:25:00',1.06),('8537','2013-05-11','11:30:00',1.68),('8537','2013-05-11','11:35:00',3.43),('8537','2013-05-11','11:40:00',2.54),('8537','2013-05-11','11:45:00',4.97),('8537','2013-05-11','11:50:00',2.81),('8537','2013-05-11','11:55:00',1.22),('8537','2013-05-11','12:00:00',1.53),('8537','2013-05-11','12:05:00',2.27),('8537','2013-05-11','12:10:00',1.72),('8537','2013-05-11','12:15:00',1.68),('8537','2013-05-11','12:20:00',2.35),('8537','2013-05-11','12:25:00',5.07),('8537','2013-05-11','12:30:00',3.81),('8537','2013-05-11','12:35:00',2.06),('8537','2013-05-11','12:40:00',2.26),('8537','2013-05-11','12:45:00',2.78),('8537','2013-05-11','12:50:00',2.26),('8537','2013-05-11','12:55:00',1.93),('8537','2013-05-11','13:00:00',1.81),('8537','2013-05-11','13:05:00',1.85),('8537','2013-05-11','13:10:00',1.4),('8537','2013-05-11','13:25:00',1.16),('8537','2013-05-11','13:30:00',1.29),('8537','2013-05-11','13:35:00',1.26),('8537','2013-05-11','14:00:00',1.98),('8537','2013-05-11','14:05:00',3.23),('8537','2013-05-11','14:10:00',3.62),('8537','2013-05-11','14:15:00',3.07),('8537','2013-05-11','14:20:00',4.97),('8537','2013-05-11','14:25:00',5.05),('8537','2013-05-11','14:30:00',3.24),('8537','2013-05-11','14:35:00',3.31),('8537','2013-05-11','14:40:00',4.51),('8537','2013-05-11','14:45:00',4.03),('8537','2013-05-11','14:50:00',5.22),('8537','2013-05-11','14:55:00',5.01),('8537','2013-05-11','15:00:00',4.83),('8537','2013-05-11','15:05:00',4.72),('8537','2013-05-11','15:10:00',4.24),('8537','2013-05-11','15:15:00',4.73),('8537','2013-05-11','15:20:00',4.2),('8537','2013-05-11','15:25:00',4.51),('8537','2013-05-11','15:30:00',4.4),('8537','2013-05-11','15:35:00',4.3),('8537','2013-05-11','15:40:00',4.27),('8537','2013-05-11','15:45:00',4.2),('8537','2013-05-11','15:50:00',4),('8537','2013-05-11','15:55:00',3.72),('8537','2013-05-11','16:00:00',2.66),('8537','2013-05-11','16:05:00',3.67),('8537','2013-05-11','16:10:00',3.63),('8537','2013-05-11','16:15:00',3.04),('8537','2013-05-11','16:20:00',3.49),('8537','2013-05-11','16:25:00',3.63),('8537','2013-05-11','16:30:00',3.56),('8537','2013-05-11','16:35:00',2.81),('8537','2013-05-11','16:40:00',3.19),('8537','2013-05-11','16:45:00',3.22),('8537','2013-05-11','16:50:00',2.75),('8537','2013-05-11','16:55:00',3.04),('8537','2013-05-11','17:00:00',2.94),('8537','2013-05-11','17:05:00',2.81),('8537','2013-05-11','17:10:00',2.65),('8537','2013-05-11','17:15:00',1.92),('8537','2013-05-11','17:20:00',2.36),('8537','2013-05-11','17:25:00',1.65),('8537','2013-05-11','17:30:00',1.72),('8537','2013-05-11','17:35:00',1.83),('8537','2013-05-11','17:40:00',1.67),('8537','2013-05-11','17:45:00',1.87),('8537','2013-05-11','17:50:00',1.27),('8537','2013-05-11','17:55:00',1.31),('8537','2013-05-11','18:05:00',1.04),('8537','2013-05-11','18:10:00',1.54),('8537','2013-05-11','18:15:00',1.41),('8537','2013-05-11','18:25:00',1.12),('8537','2013-05-10','07:40:00',1.02),('8537','2013-05-10','07:45:00',1.07),('8537','2013-05-10','07:55:00',1.25),('8537','2013-05-10','08:00:00',1.86),('8537','2013-05-10','08:05:00',2.22),('8537','2013-05-10','08:10:00',2.08),('8537','2013-05-10','08:15:00',2.47),('8537','2013-05-10','08:20:00',2.3),('8537','2013-05-10','08:25:00',2.21),('8537','2013-05-10','08:30:00',2.19),('8537','2013-05-10','08:35:00',2.36),('8537','2013-05-10','08:40:00',1.24),('8537','2013-05-10','09:00:00',1.76),('8537','2013-05-10','09:05:00',2.72),('8537','2013-05-10','09:10:00',3.17),('8537','2013-05-10','09:15:00',3.26),('8537','2013-05-10','09:20:00',3.11),('8537','2013-05-10','09:25:00',2.93),('8537','2013-05-10','09:30:00',2.86),('8537','2013-05-10','09:35:00',3.54),('8537','2013-05-10','09:40:00',3.07),('8537','2013-05-10','09:45:00',3.44),('8537','2013-05-10','09:50:00',2.91),('8537','2013-05-10','09:55:00',2.68),('8537','2013-05-10','10:00:00',2.39),('8537','2013-05-10','10:05:00',2.29),('8537','2013-05-10','10:10:00',3.77),('8537','2013-05-10','10:15:00',3.84),('8537','2013-05-10','10:20:00',3.43),('8537','2013-05-10','10:25:00',1.32),('8537','2013-05-10','10:30:00',1.82),('8537','2013-05-10','10:35:00',1.32),('8537','2013-05-10','10:40:00',4.03),('8537','2013-05-10','10:45:00',4.76),('8537','2013-05-10','10:50:00',4.91),('8537','2013-05-10','10:55:00',4.48),('8537','2013-05-10','11:00:00',4.53),('8537','2013-05-10','11:05:00',4.6),('8537','2013-05-10','11:10:00',4.63),('8537','2013-05-10','11:15:00',4.33),('8537','2013-05-10','11:20:00',5.18),('8537','2013-05-10','11:25:00',4.31),('8537','2013-05-10','11:30:00',4.19),('8537','2013-05-10','11:35:00',4.63),('8537','2013-05-10','11:40:00',3.7),('8537','2013-05-10','11:45:00',2.72),('8537','2013-05-10','11:50:00',3.15),('8537','2013-05-10','11:55:00',4.87),('8537','2013-05-10','12:00:00',4.51),('8537','2013-05-10','12:05:00',3.72),('8537','2013-05-10','12:10:00',3.17),('8537','2013-05-10','12:15:00',3.01),('8537','2013-05-10','12:20:00',3.14),('8537','2013-05-10','12:25:00',2.75),('8537','2013-05-10','12:30:00',2.52),('8537','2013-05-10','12:35:00',2.74),('8537','2013-05-10','12:40:00',3.59),('8537','2013-05-10','12:45:00',5.26),('8537','2013-05-10','12:50:00',4.5),('8537','2013-05-10','12:55:00',3.44),('8537','2013-05-10','13:00:00',4.24),('8537','2013-05-10','13:05:00',3.73),('8537','2013-05-10','13:10:00',5.41),('8537','2013-05-10','13:15:00',5.53),('8537','2013-05-10','13:20:00',3.7),('8537','2013-05-10','13:25:00',3.51),('8537','2013-05-10','13:30:00',4.16),('8537','2013-05-10','13:35:00',4.79),('8537','2013-05-10','13:40:00',5.15),('8537','2013-05-10','13:45:00',4.54),('8537','2013-05-10','13:50:00',2.89),('8537','2013-05-10','13:55:00',2.49),('8537','2013-05-10','14:00:00',2.27),('8537','2013-05-10','14:05:00',2.34),('8537','2013-05-10','14:10:00',2.73),('8537','2013-05-10','14:15:00',3.02),('8537','2013-05-10','14:20:00',3),('8537','2013-05-10','14:25:00',2.96),('8537','2013-05-10','14:30:00',3.02),('8537','2013-05-10','14:35:00',3.68),('8537','2013-05-10','14:40:00',3.29),('8537','2013-05-10','14:45:00',2.41),('8537','2013-05-10','14:50:00',1.77),('8537','2013-05-10','14:55:00',1.51),('8537','2013-05-10','15:00:00',1.42),('8537','2013-05-10','15:05:00',1.52),('8537','2013-05-10','15:10:00',2.04),('8537','2013-05-10','15:15:00',3.37),('8537','2013-05-10','15:20:00',3.36),('8537','2013-05-10','15:25:00',2.35),('8537','2013-05-10','15:30:00',2.21),('8537','2013-05-10','15:35:00',2.29),('8537','2013-05-10','15:40:00',2.38),('8537','2013-05-10','15:45:00',2.3),('8537','2013-05-10','15:50:00',2.09),('8537','2013-05-10','15:55:00',1.93),('8537','2013-05-10','16:00:00',1.9),('8537','2013-05-10','16:05:00',1.85),('8537','2013-05-10','16:10:00',1.81),('8537','2013-05-10','16:15:00',1.69),('8537','2013-05-10','16:20:00',1.52),('8537','2013-05-10','16:25:00',1.51),('8537','2013-05-10','16:30:00',1.59),('8537','2013-05-10','16:35:00',1.67),('8537','2013-05-10','16:40:00',1.6),('8537','2013-05-10','16:45:00',1.6),('8537','2013-05-10','16:50:00',1.57),('8537','2013-05-10','16:55:00',1.34),('8537','2013-05-10','17:00:00',1.08),('8537','2013-05-10','17:05:00',1.04),('8537','2013-05-10','17:10:00',1.29),('8537','2013-05-10','17:15:00',1.59),('8537','2013-05-10','17:20:00',2.14),('8537','2013-05-10','17:25:00',2.12),('8537','2013-05-10','17:30:00',1.97),('8537','2013-05-10','17:35:00',2.24),('8537','2013-05-10','17:40:00',1.6),('8537','2013-05-10','17:45:00',1.44),('8537','2013-05-10','17:50:00',1.26),('8537','2013-05-10','17:55:00',1.14),('8537','2013-05-10','18:00:00',1.05),('8537','2013-05-10','18:05:00',1.02),('8537','2013-05-09','07:35:00',1.08),('8537','2013-05-09','07:40:00',1.19),('8537','2013-05-09','07:45:00',1.3),('8537','2013-05-09','07:50:00',1.4),('8537','2013-05-09','07:55:00',1.5),('8537','2013-05-09','08:00:00',1.62),('8537','2013-05-09','08:05:00',1.73),('8537','2013-05-09','08:10:00',1.84),('8537','2013-05-09','08:15:00',1.96),('8537','2013-05-09','08:20:00',2.07),('8537','2013-05-09','08:25:00',2.18),('8537','2013-05-09','08:30:00',2.29),('8537','2013-05-09','08:35:00',2.38),('8537','2013-05-09','08:40:00',2.48),('8537','2013-05-09','08:45:00',2.6),('8537','2013-05-09','08:50:00',2.69),('8537','2013-05-09','08:55:00',2.79),('8537','2013-05-09','09:00:00',2.89),('8537','2013-05-09','09:05:00',2.98),('8537','2013-05-09','09:10:00',3.09),('8537','2013-05-09','09:15:00',3.2),('8537','2013-05-09','09:20:00',3.27),('8537','2013-05-09','09:25:00',3.36),('8537','2013-05-09','09:30:00',3.48),('8537','2013-05-09','09:35:00',3.57),('8537','2013-05-09','09:40:00',3.65),('8537','2013-05-09','09:45:00',3.72),('8537','2013-05-09','09:50:00',3.81),('8537','2013-05-09','09:55:00',3.86),('8537','2013-05-09','10:00:00',3.95),('8537','2013-05-09','10:05:00',4.01),('8537','2013-05-09','10:10:00',4.08),('8537','2013-05-09','10:15:00',4.16),('8537','2013-05-09','10:20:00',4.18),('8537','2013-05-09','10:25:00',4.25),('8537','2013-05-09','10:30:00',4.32),('8537','2013-05-09','10:35:00',4.34),('8537','2013-05-09','10:40:00',4.45),('8537','2013-05-09','10:45:00',4.48),('8537','2013-05-09','10:50:00',4.51),('8537','2013-05-09','10:55:00',4.61),('8537','2013-05-09','11:00:00',4.64),('8537','2013-05-09','11:05:00',4.69),('8537','2013-05-09','11:10:00',4.66),('8537','2013-05-09','11:15:00',4.79),('8537','2013-05-09','11:20:00',4.77),('8537','2013-05-09','11:25:00',4.79),('8537','2013-05-09','11:30:00',4.77),('8537','2013-05-09','11:35:00',4.81),('8537','2013-05-09','11:40:00',4.86),('8537','2013-05-09','11:45:00',4.9),('8537','2013-05-09','11:50:00',4.84),('8537','2013-05-09','11:55:00',4.86),('8537','2013-05-09','12:00:00',5),('8537','2013-05-09','12:05:00',5.02),('8537','2013-05-09','12:10:00',5.04),('8537','2013-05-09','12:15:00',5.04),('8537','2013-05-09','12:20:00',4.98),('8537','2013-05-09','12:25:00',4.86),('8537','2013-05-09','12:30:00',5.13),('8537','2013-05-09','12:35:00',5.11),('8537','2013-05-09','12:40:00',4.27),('8537','2013-05-09','12:45:00',1.99),('8537','2013-05-09','12:50:00',5.41),('8537','2013-05-09','12:55:00',5.21),('8537','2013-05-09','13:00:00',5.13),('8537','2013-05-09','13:05:00',5.08),('8537','2013-05-09','13:10:00',5.12),('8537','2013-05-09','13:15:00',5.09),('8537','2013-05-09','13:20:00',5.12),('8537','2013-05-09','13:25:00',5.1),('8537','2013-05-09','13:30:00',5.15),('8537','2013-05-09','13:35:00',5.18),('8537','2013-05-09','13:40:00',5.15),('8537','2013-05-09','13:45:00',5.17),('8537','2013-05-09','13:50:00',5.11),('8537','2013-05-09','13:55:00',5.08),('8537','2013-05-09','14:00:00',4.05),('8537','2013-05-09','14:05:00',5.15),('8537','2013-05-09','14:10:00',3.79),('8537','2013-05-09','14:15:00',4.14),('8537','2013-05-09','14:20:00',4.97),('8537','2013-05-09','14:25:00',4.54),('8537','2013-05-09','14:30:00',4.48),('8537','2013-05-09','14:35:00',4.65),('8537','2013-05-09','14:40:00',4.39),('8537','2013-05-09','14:45:00',4.64),('8537','2013-05-09','14:50:00',4.6),('8537','2013-05-09','14:55:00',4.62),('8537','2013-05-09','15:00:00',4.59),('8537','2013-05-09','15:05:00',4.51),('8537','2013-05-09','15:10:00',4.44),('8537','2013-05-09','15:15:00',4.39),('8537','2013-05-09','15:20:00',4.31),('8537','2013-05-09','15:25:00',4.26),('8537','2013-05-09','15:30:00',4.16),('8537','2013-05-09','15:35:00',4.06),('8537','2013-05-09','15:40:00',4.07),('8537','2013-05-09','15:45:00',4.01),('8537','2013-05-09','15:50:00',3.95),('8537','2013-05-09','15:55:00',3.85),('8537','2013-05-09','16:00:00',3.79),('8537','2013-05-09','16:05:00',3.72),('8537','2013-05-09','16:10:00',3.65),('8537','2013-05-09','16:15:00',3.52),('8537','2013-05-09','16:20:00',3.45),('8537','2013-05-09','16:25:00',3.34),('8537','2013-05-09','16:30:00',3.27),('8537','2013-05-09','16:35:00',3.2),('8537','2013-05-09','16:40:00',3.09),('8537','2013-05-09','16:45:00',3),('8537','2013-05-09','16:50:00',2.83),('8537','2013-05-09','16:55:00',2.37),('8537','2013-05-09','17:00:00',2.65),('8537','2013-05-09','17:05:00',2.58),('8537','2013-05-09','17:10:00',2.46),('8537','2013-05-09','17:15:00',2.31),('8537','2013-05-09','17:20:00',2.25),('8537','2013-05-09','17:25:00',2.16),('8537','2013-05-09','17:30:00',2.06),('8537','2013-05-09','17:35:00',1.93),('8537','2013-05-09','17:40:00',1.83),('8537','2013-05-09','17:45:00',1.68),('8537','2013-05-09','17:50:00',1.6),('8537','2013-05-09','17:55:00',1.5),('8537','2013-05-09','18:00:00',1.41),('8537','2013-05-09','18:05:00',1.3),('8537','2013-05-09','18:10:00',1.18),('8537','2013-05-09','18:15:00',1.1),('8537','2013-05-09','18:20:00',1.01),('8537','2013-05-08','08:05:00',1.61),('8537','2013-05-08','08:10:00',2.02),('8537','2013-05-08','08:15:00',2.07),('8537','2013-05-08','08:20:00',2.13),('8537','2013-05-08','08:25:00',2.15),('8537','2013-05-08','08:30:00',2.24),('8537','2013-05-08','08:35:00',2.36),('8537','2013-05-08','08:40:00',2.53),('8537','2013-05-08','08:45:00',2.74),('8537','2013-05-08','08:50:00',3.02),('8537','2013-05-08','08:55:00',3.08),('8537','2013-05-08','09:00:00',2.43),('8537','2013-05-08','09:05:00',3.04),('8537','2013-05-08','09:10:00',2.31),('8537','2013-05-08','09:15:00',2.17),('8537','2013-05-08','09:20:00',1.28),('8537','2013-05-08','09:35:00',1.04),('8537','2013-05-08','09:40:00',1.53),('8537','2013-05-08','09:45:00',1.43),('8537','2013-05-08','09:50:00',1.46),('8537','2013-05-08','09:55:00',1.83),('8537','2013-05-08','10:00:00',1.7),('8537','2013-05-08','10:05:00',4.44),('8537','2013-05-08','10:10:00',3.5),('8537','2013-05-08','10:15:00',1.67),('8537','2013-05-08','10:20:00',1.37),('8537','2013-05-08','10:25:00',1.28),('8537','2013-05-08','10:30:00',1.15),('8537','2013-05-08','10:35:00',1.05),('8537','2013-05-08','10:40:00',1.02),('8537','2013-05-08','10:55:00',1.72),('8537','2013-05-08','11:00:00',1.73),('8537','2013-05-08','11:05:00',3.65),('8537','2013-05-08','11:10:00',5.36),('8537','2013-05-08','11:15:00',5.2),('8537','2013-05-08','11:20:00',4.83),('8537','2013-05-08','11:25:00',4.96),('8537','2013-05-08','11:30:00',5.16),('8537','2013-05-08','11:35:00',5.28),('8537','2013-05-08','11:40:00',5.24),('8537','2013-05-08','11:45:00',3.24),('8537','2013-05-08','11:50:00',2.51),('8537','2013-05-08','11:55:00',2.03),('8537','2013-05-08','12:00:00',4.85),('8537','2013-05-08','12:05:00',1.9),('8537','2013-05-08','12:15:00',1.06),('8537','2013-05-08','12:20:00',1.63),('8537','2013-05-08','12:25:00',5.43),('8537','2013-05-08','12:30:00',2.86),('8537','2013-05-08','12:35:00',1.29),('8537','2013-05-08','12:40:00',1.44),('8537','2013-05-08','12:45:00',1.6),('8537','2013-05-08','12:50:00',2.67),('8537','2013-05-08','12:55:00',3.37),('8537','2013-05-08','13:00:00',4.93),('8537','2013-05-08','13:05:00',3.56),('8537','2013-05-08','13:10:00',5.9),('8537','2013-05-08','13:15:00',3.12),('8537','2013-05-08','13:20:00',1.33),('8537','2013-05-08','13:25:00',1.69),('8537','2013-05-08','13:30:00',1.13),('8537','2013-05-08','13:35:00',1.08),('8537','2013-05-08','13:40:00',1.26),('8537','2013-05-08','13:45:00',5.65),('8537','2013-05-08','13:50:00',5.24),('8537','2013-05-08','13:55:00',4.63),('8537','2013-05-08','14:00:00',3.84),('8537','2013-05-08','14:05:00',2.19),('8537','2013-05-08','14:10:00',1.79),('8537','2013-05-08','14:15:00',1.72),('8537','2013-05-08','14:20:00',3.9),('8537','2013-05-08','14:25:00',1.81),('8537','2013-05-08','14:30:00',4.06),('8537','2013-05-08','14:35:00',4.32),('8537','2013-05-08','14:40:00',4.54),('8537','2013-05-08','14:45:00',2.28),('8537','2013-05-08','14:50:00',3.24),('8537','2013-05-08','14:55:00',4.7),('8537','2013-05-08','15:00:00',4.15),('8537','2013-05-08','15:05:00',4.63),('8537','2013-05-08','15:10:00',3.63),('8537','2013-05-08','15:15:00',4.53),('8537','2013-05-08','15:20:00',4.45),('8537','2013-05-08','15:25:00',4.4),('8537','2013-05-08','15:30:00',4.3),('8537','2013-05-08','15:35:00',4.15),('8537','2013-05-08','15:40:00',4.07),('8537','2013-05-08','15:45:00',4.03),('8537','2013-05-08','15:50:00',3.96),('8537','2013-05-08','15:55:00',3.87),('8537','2013-05-08','16:00:00',3.86),('8537','2013-05-08','16:05:00',3.77),('8537','2013-05-08','16:10:00',3.68),('8537','2013-05-08','16:15:00',3.58),('8537','2013-05-08','16:20:00',3.48),('8537','2013-05-08','16:25:00',3.38),('8537','2013-05-08','16:30:00',3.41),('8537','2013-05-08','16:35:00',3.3),('8537','2013-05-08','16:40:00',3.18),('8537','2013-05-08','16:45:00',3.07),('8537','2013-05-08','16:50:00',3.09),('8537','2013-05-08','16:55:00',2.79),('8537','2013-05-08','17:00:00',2.37),('8537','2013-05-08','17:05:00',3.14),('8537','2013-05-08','17:10:00',2.22),('8537','2013-05-08','17:15:00',2.35),('8537','2013-05-08','17:20:00',2.47),('8537','2013-05-08','17:25:00',1.76),('8537','2013-05-08','17:30:00',2.1),('8537','2013-05-08','17:35:00',2.37),('8537','2013-05-08','17:40:00',2.3),('8537','2013-05-08','17:45:00',2.26),('8537','2013-05-08','17:50:00',2.26),('8537','2013-05-08','17:55:00',1.8),('8537','2013-05-08','18:15:00',1.3),('8537','2013-05-08','18:20:00',1.38),('8537','2013-05-08','18:25:00',1.23),('8537','2013-05-08','18:30:00',1.05),('8537','2013-05-07','07:35:00',1.08),('8537','2013-05-07','07:40:00',1.19),('8537','2013-05-07','07:45:00',1.3),('8537','2013-05-07','07:50:00',1.4),('8537','2013-05-07','07:55:00',1.49),('8537','2013-05-07','08:00:00',1.62),('8537','2013-05-07','08:05:00',1.72),('8537','2013-05-07','08:10:00',1.84),('8537','2013-05-07','08:15:00',1.95),('8537','2013-05-07','08:20:00',2.05),('8537','2013-05-07','08:25:00',2.16),('8537','2013-05-07','08:30:00',2.27),('8537','2013-05-07','08:35:00',2.39),('8537','2013-05-07','08:40:00',2.51),('8537','2013-05-07','08:45:00',2.61),('8537','2013-05-07','08:50:00',2.8),('8537','2013-05-07','08:55:00',2.99),('8537','2013-05-07','09:00:00',2.54),('8537','2013-05-07','09:05:00',2.77),('8537','2013-05-07','09:10:00',1.49),('8537','2013-05-07','09:15:00',1.69),('8537','2013-05-07','09:20:00',2.08),('8537','2013-05-07','09:30:00',1.35),('8537','2013-05-07','09:35:00',3.85),('8537','2013-05-07','09:45:00',1.57),('8537','2013-05-07','09:50:00',1.97),('8537','2013-05-07','09:55:00',1.66),('8537','2013-05-07','10:00:00',1.25),('8537','2013-05-07','10:05:00',1.08),('8537','2013-05-07','11:00:00',1.22),('8537','2013-05-07','11:05:00',1.41),('8537','2013-05-07','11:10:00',1.47),('8537','2013-05-07','11:15:00',1.59),('8537','2013-05-07','11:20:00',1.94),('8537','2013-05-07','11:25:00',2.95),('8537','2013-05-07','11:30:00',1.04),('8537','2013-05-07','12:05:00',1.07),('8537','2013-05-07','12:10:00',5),('8537','2013-05-07','12:15:00',1.28),('8537','2013-05-07','12:20:00',1.29),('8537','2013-05-07','12:25:00',3.53),('8537','2013-05-07','12:30:00',3.59),('8537','2013-05-07','12:35:00',1.22),('8537','2013-05-07','12:40:00',1.07),('8537','2013-05-07','13:15:00',1.32),('8537','2013-05-07','13:20:00',1.55),('8537','2013-05-07','13:25:00',1.74),('8537','2013-05-07','13:30:00',3.97),('8537','2013-05-07','13:35:00',3.84),('8537','2013-05-07','13:40:00',5),('8537','2013-05-07','13:45:00',5.27),('8537','2013-05-07','13:50:00',5.56),('8537','2013-05-07','13:55:00',5.59),('8537','2013-05-07','14:00:00',5.42),('8537','2013-05-07','14:05:00',5.36),('8537','2013-05-07','14:10:00',5.36),('8537','2013-05-07','14:15:00',5.36),('8537','2013-05-07','14:20:00',5.33),('8537','2013-05-07','14:25:00',5.29),('8537','2013-05-07','14:30:00',4),('8537','2013-05-07','14:35:00',5.18),('8537','2013-05-07','14:40:00',5.32),('8537','2013-05-07','14:45:00',5.15),('8537','2013-05-07','14:50:00',4.71),('8537','2013-05-07','14:55:00',4.85),('8537','2013-05-07','15:00:00',4.97),('8537','2013-05-07','15:05:00',4.87),('8537','2013-05-07','15:10:00',3.77),('8537','2013-05-07','15:15:00',4.5),('8537','2013-05-07','15:20:00',4.26),('8537','2013-05-07','15:25:00',3.12),('8537','2013-05-07','15:30:00',3.24),('8537','2013-05-07','15:35:00',2.86),('8537','2013-05-07','15:40:00',2.28),('8537','2013-05-07','15:45:00',2.37),('8537','2013-05-07','15:50:00',1.75),('8537','2013-05-07','15:55:00',2.2),('8537','2013-05-07','16:00:00',3.63),('8537','2013-05-07','16:05:00',3.12),('8537','2013-05-07','16:10:00',1.43),('8537','2013-05-07','16:15:00',2.53),('8537','2013-05-07','16:20:00',3.62),('8537','2013-05-07','16:25:00',3.39),('8537','2013-05-07','16:30:00',3.4),('8537','2013-05-07','16:35:00',4.02),('8537','2013-05-07','16:40:00',4.1),('8537','2013-05-07','16:45:00',3.11),('8537','2013-05-07','16:50:00',3.58),('8537','2013-05-07','16:55:00',2.79),('8537','2013-05-07','17:00:00',2.6),('8537','2013-05-07','17:05:00',2.81),('8537','2013-05-07','17:10:00',1.91),('8537','2013-05-07','17:15:00',1.41),('8537','2013-05-07','17:20:00',1.35),('8537','2013-05-07','17:25:00',1.41),('8537','2013-05-07','17:30:00',1.22),('8537','2013-05-07','17:35:00',1.17),('8537','2013-05-07','17:40:00',1.1),('8537','2013-05-07','17:45:00',1),('8537','2013-05-06','08:25:00',1.3),('8537','2013-05-06','08:30:00',1.51),('8537','2013-05-06','08:35:00',1.26),('8537','2013-05-06','08:40:00',1.05),('8537','2013-05-06','08:50:00',1.24),('8537','2013-05-06','08:55:00',2.07),('8537','2013-05-06','09:00:00',2.45),('8537','2013-05-06','09:05:00',1.6),('8537','2013-05-06','09:10:00',1.76),('8537','2013-05-06','09:15:00',1.52),('8537','2013-05-06','09:20:00',1.41),('8537','2013-05-06','09:25:00',1.21),('8537','2013-05-06','09:30:00',1.07),('8537','2013-05-06','09:55:00',1.19),('8537','2013-05-06','10:00:00',1.86),('8537','2013-05-06','10:05:00',1.5),('8537','2013-05-06','10:10:00',1.34),('8537','2013-05-06','10:15:00',1.75),('8537','2013-05-06','10:20:00',2.33),('8537','2013-05-06','10:25:00',1.99),('8537','2013-05-06','10:30:00',2.2),('8537','2013-05-06','10:35:00',2.04),('8537','2013-05-06','10:40:00',2.02),('8537','2013-05-06','10:45:00',3.56),('8537','2013-05-06','10:50:00',2.84),('8537','2013-05-06','10:55:00',2.36),('8537','2013-05-06','11:00:00',2.35),('8537','2013-05-06','11:05:00',2.37),('8537','2013-05-06','11:10:00',2.24),('8537','2013-05-06','11:15:00',2.08),('8537','2013-05-06','11:20:00',2.44),('8537','2013-05-06','11:25:00',2.54),('8537','2013-05-06','11:30:00',2.38),('8537','2013-05-06','11:35:00',2.25),('8537','2013-05-06','11:40:00',3.47),('8537','2013-05-06','11:45:00',4.5),('8537','2013-05-06','11:50:00',3.06),('8537','2013-05-06','11:55:00',2.03),('8537','2013-05-06','12:00:00',2.29),('8537','2013-05-06','12:05:00',2.11),('8537','2013-05-06','12:10:00',4.39),('8537','2013-05-06','12:15:00',2.86),('8537','2013-05-06','12:20:00',2.94),('8537','2013-05-06','12:25:00',4.63),('8537','2013-05-06','12:30:00',3.42),('8537','2013-05-06','12:35:00',4.81),('8537','2013-05-06','12:40:00',3.99),('8537','2013-05-06','12:45:00',2.32),('8537','2013-05-06','12:50:00',3.03),('8537','2013-05-06','12:55:00',4.61),('8537','2013-05-06','13:00:00',2.23),('8537','2013-05-06','13:05:00',2.87),('8537','2013-05-06','13:10:00',4.82),('8537','2013-05-06','13:15:00',3.84),('8537','2013-05-06','13:20:00',5.33),('8537','2013-05-06','13:25:00',3.52),('8537','2013-05-06','13:30:00',4.53),('8537','2013-05-06','13:35:00',2.56),('8537','2013-05-06','13:40:00',4.97),('8537','2013-05-06','13:45:00',4.69),('8537','2013-05-06','13:50:00',5.88),('8537','2013-05-06','13:55:00',5.07),('8537','2013-05-06','14:00:00',4.66),('8537','2013-05-06','14:05:00',5.01),('8537','2013-05-06','14:10:00',3.3),('8537','2013-05-06','14:15:00',5.31),('8537','2013-05-06','14:20:00',5),('8537','2013-05-06','14:25:00',2.89),('8537','2013-05-06','14:30:00',4.5),('8537','2013-05-06','14:35:00',5.13),('8537','2013-05-06','14:40:00',3.88),('8537','2013-05-06','14:45:00',3.39),('8537','2013-05-06','14:50:00',4.09),('8537','2013-05-06','14:55:00',4.7),('8537','2013-05-06','15:00:00',3.32),('8537','2013-05-06','15:05:00',2.15),('8537','2013-05-06','15:10:00',3.26),('8537','2013-05-06','15:15:00',3.83),('8537','2013-05-06','15:20:00',2.58),('8537','2013-05-06','15:25:00',1.91),('8537','2013-05-06','15:30:00',2.92),('8537','2013-05-06','15:35:00',2.67),('8537','2013-05-06','15:40:00',2.68),('8537','2013-05-06','15:45:00',1.57),('8537','2013-05-06','15:50:00',1.78),('8537','2013-05-06','15:55:00',2.62),('8537','2013-05-06','16:00:00',1.72),('8537','2013-05-06','16:05:00',1.74),('8537','2013-05-06','16:10:00',1.52),('8537','2013-05-06','16:15:00',1.5),('8537','2013-05-06','16:20:00',2.13),('8537','2013-05-06','16:25:00',2.15),('8537','2013-05-06','16:30:00',4.11),('8537','2013-05-06','16:35:00',2.22),('8537','2013-05-06','16:40:00',2.87),('8537','2013-05-06','16:45:00',2.05),('8537','2013-05-06','16:50:00',2.6),('8537','2013-05-06','16:55:00',2.91),('8537','2013-05-06','17:00:00',1.54),('8537','2013-05-06','17:15:00',1.69),('8537','2013-05-06','17:20:00',1.24),('8537','2013-05-06','17:35:00',1.52),('8537','2013-05-06','17:40:00',1.56),('8537','2013-05-06','17:45:00',1.16),('8537','2013-05-06','17:50:00',1.21),('8537','2013-05-06','18:00:00',1.05),('8537','2013-05-06','18:05:00',1.26),('8537','2013-05-06','18:20:00',1.06),('8537','2013-05-05','07:45:00',1.19),('8537','2013-05-05','07:50:00',1.25),('8537','2013-05-05','07:55:00',1.27),('8537','2013-05-05','08:00:00',1.4),('8537','2013-05-05','08:05:00',1.57),('8537','2013-05-05','08:10:00',1.7),('8537','2013-05-05','08:15:00',1.83),('8537','2013-05-05','08:20:00',2.11),('8537','2013-05-05','08:25:00',2.49),('8537','2013-05-05','08:30:00',2.58),('8537','2013-05-05','08:35:00',2.35),('8537','2013-05-05','08:40:00',2.49),('8537','2013-05-05','08:45:00',2),('8537','2013-05-05','08:50:00',1.61),('8537','2013-05-05','08:55:00',1.49),('8537','2013-05-05','09:00:00',1.62),('8537','2013-05-05','09:05:00',1.74),('8537','2013-05-05','09:10:00',1.99),('8537','2013-05-05','09:15:00',2.2),('8537','2013-05-05','09:20:00',1.88),('8537','2013-05-05','09:25:00',1.93),('8537','2013-05-05','09:30:00',2.1),('8537','2013-05-05','09:35:00',1.82),('8537','2013-05-05','09:40:00',2.4),('8537','2013-05-05','09:45:00',3.36),('8537','2013-05-05','09:50:00',2.69),('8537','2013-05-05','09:55:00',4.39),('8537','2013-05-05','10:00:00',2.97),('8537','2013-05-05','10:05:00',2.99),('8537','2013-05-05','10:10:00',2.71),('8537','2013-05-05','10:15:00',2.46),('8537','2013-05-05','10:20:00',4.21),('8537','2013-05-05','10:25:00',2.87),('8537','2013-05-05','10:30:00',3.07),('8537','2013-05-05','10:35:00',2.86),('8537','2013-05-05','10:40:00',2.94),('8537','2013-05-05','10:45:00',3.02),('8537','2013-05-05','10:50:00',2.28),('8537','2013-05-05','10:55:00',1.97),('8537','2013-05-05','11:00:00',1.83),('8537','2013-05-05','11:05:00',2.21),('8537','2013-05-05','11:10:00',2.05),('8537','2013-05-05','11:15:00',2.07),('8537','2013-05-05','11:20:00',2.91),('8537','2013-05-05','11:25:00',4.18),('8537','2013-05-05','11:30:00',3.27),('8537','2013-05-05','11:35:00',4.5),('8537','2013-05-05','11:40:00',3.68),('8537','2013-05-05','11:45:00',3.49),('8537','2013-05-05','11:50:00',3.18),('8537','2013-05-05','11:55:00',4.06),('8537','2013-05-05','12:00:00',3.11),('8537','2013-05-05','12:05:00',3.3),('8537','2013-05-05','12:10:00',2.95),('8537','2013-05-05','12:15:00',3.67),('8537','2013-05-05','12:20:00',3.56),('8537','2013-05-05','12:25:00',4.47),('8537','2013-05-05','12:30:00',4.95),('8537','2013-05-05','12:35:00',4.67),('8537','2013-05-05','12:40:00',4.73),('8537','2013-05-05','12:45:00',4.54),('8537','2013-05-05','12:50:00',4.62),('8537','2013-05-05','12:55:00',4.55),('8537','2013-05-05','13:00:00',5.1),('8537','2013-05-05','13:05:00',5.14),('8537','2013-05-05','13:10:00',4.58),('8537','2013-05-05','13:15:00',5.42),('8537','2013-05-05','13:20:00',3.96),('8537','2013-05-05','13:25:00',2.48),('8537','2013-05-05','13:30:00',1.87),('8537','2013-05-05','13:35:00',4.78),('8537','2013-05-05','13:40:00',5.33),('8537','2013-05-05','13:45:00',5.12),('8537','2013-05-05','13:50:00',5.14),('8537','2013-05-05','13:55:00',5.16),('8537','2013-05-05','14:00:00',5.23),('8537','2013-05-05','14:05:00',5.37),('8537','2013-05-05','14:10:00',4.09),('8537','2013-05-05','14:15:00',3.72),('8537','2013-05-05','14:20:00',4.79),('8537','2013-05-05','14:25:00',4.69),('8537','2013-05-05','14:30:00',4.56),('8537','2013-05-05','14:35:00',4.36),('8537','2013-05-05','14:40:00',4.06),('8537','2013-05-05','14:45:00',4.38),('8537','2013-05-05','14:50:00',4.31),('8537','2013-05-05','14:55:00',4.28),('8537','2013-05-05','15:00:00',4.25),('8537','2013-05-05','15:05:00',4.2),('8537','2013-05-05','15:10:00',4.15),('8537','2013-05-05','15:15:00',4.03),('8537','2013-05-05','15:20:00',4.03),('8537','2013-05-05','15:25:00',4),('8537','2013-05-05','15:30:00',3.82),('8537','2013-05-05','15:35:00',3.79),('8537','2013-05-05','15:40:00',3.78),('8537','2013-05-05','15:45:00',3.74),('8537','2013-05-05','15:50:00',3.67),('8537','2013-05-05','15:55:00',3.6),('8537','2013-05-05','16:00:00',3.56),('8537','2013-05-05','16:05:00',3.49),('8537','2013-05-05','16:10:00',3.39),('8537','2013-05-05','16:15:00',3.31),('8537','2013-05-05','16:20:00',3.24),('8537','2013-05-05','16:25:00',3.16),('8537','2013-05-05','16:30:00',3.07),('8537','2013-05-05','16:35:00',3),('8537','2013-05-05','16:40:00',2.92),('8537','2013-05-05','16:45:00',2.83),('8537','2013-05-05','16:50:00',2.71),('8537','2013-05-05','16:55:00',2.62),('8537','2013-05-05','17:00:00',2.51),('8537','2013-05-05','17:05:00',2.42),('8537','2013-05-05','17:10:00',2.27),('8537','2013-05-05','17:15:00',2.18),('8537','2013-05-05','17:20:00',2.09),('8537','2013-05-05','17:25:00',1.99),('8537','2013-05-05','17:30:00',1.89),('8537','2013-05-05','17:35:00',1.77),('8537','2013-05-05','17:40:00',1.67),('8537','2013-05-05','17:45:00',1.57),('8537','2013-05-05','17:50:00',1.48),('8537','2013-05-05','17:55:00',1.37),('8537','2013-05-05','18:00:00',1.28),('8537','2013-05-05','18:05:00',1.17),('8537','2013-05-05','18:10:00',1.08),('8537','2013-05-04','07:40:00',1.04),('8537','2013-05-04','07:45:00',1.06),('8537','2013-05-04','07:50:00',1.13),('8537','2013-05-04','07:55:00',1.32),('8537','2013-05-04','08:00:00',1.45),('8537','2013-05-04','08:05:00',1.53),('8537','2013-05-04','08:10:00',1.62),('8537','2013-05-04','08:15:00',1.72),('8537','2013-05-04','08:20:00',1.82),('8537','2013-05-04','08:25:00',1.89),('8537','2013-05-04','08:30:00',1.99),('8537','2013-05-04','08:35:00',2.09),('8537','2013-05-04','08:40:00',2.2),('8537','2013-05-04','08:45:00',2.33),('8537','2013-05-04','08:50:00',2.42),('8537','2013-05-04','08:55:00',2.51),('8537','2013-05-04','09:00:00',2.59),('8537','2013-05-04','09:05:00',2.71),('8537','2013-05-04','09:10:00',2.79),('8537','2013-05-04','09:15:00',2.87),('8537','2013-05-04','09:20:00',3),('8537','2013-05-04','09:25:00',3.05),('8537','2013-05-04','09:30:00',3.1),('8537','2013-05-04','09:35:00',3.23),('8537','2013-05-04','09:40:00',3.33),('8537','2013-05-04','09:45:00',3.45),('8537','2013-05-04','09:50:00',3.52),('8537','2013-05-04','09:55:00',3.57),('8537','2013-05-04','10:00:00',3.69),('8537','2013-05-04','10:05:00',3.74),('8537','2013-05-04','10:10:00',3.84),('8537','2013-05-04','10:15:00',3.9),('8537','2013-05-04','10:20:00',3.97),('8537','2013-05-04','10:25:00',3.98),('8537','2013-05-04','10:30:00',4.1),('8537','2013-05-04','10:35:00',4.14),('8537','2013-05-04','10:40:00',4.12),('8537','2013-05-04','10:45:00',4.1),('8537','2013-05-04','10:50:00',4.13),('8537','2013-05-04','10:55:00',4.07),('8537','2013-05-04','11:00:00',4.16),('8537','2013-05-04','11:05:00',4.18),('8537','2013-05-04','11:10:00',3.99),('8537','2013-05-04','11:15:00',3.82),('8537','2013-05-04','11:20:00',4.14),('8537','2013-05-04','11:25:00',4.17),('8537','2013-05-04','11:30:00',4.03),('8537','2013-05-04','11:35:00',4.15),('8537','2013-05-04','11:40:00',3.98),('8537','2013-05-04','11:45:00',4.09),('8537','2013-05-04','11:50:00',4.12),('8537','2013-05-04','11:55:00',4.11),('8537','2013-05-04','12:00:00',4.08),('8537','2013-05-04','12:05:00',4.21),('8537','2013-05-04','12:10:00',4.24),('8537','2013-05-04','12:15:00',4.4),('8537','2013-05-04','12:20:00',4.48),('8537','2013-05-04','12:25:00',4.56),('8537','2013-05-04','12:30:00',4.6),('8537','2013-05-04','12:35:00',4.64),('8537','2013-05-04','12:40:00',4.62),('8537','2013-05-04','12:45:00',4.63),('8537','2013-05-04','12:50:00',4.47),('8537','2013-05-04','12:55:00',4.38),('8537','2013-05-04','13:00:00',4.28),('8537','2013-05-04','13:05:00',3.93),('8537','2013-05-04','13:10:00',4.28),('8537','2013-05-04','13:15:00',4.83),('8537','2013-05-04','13:20:00',4.86),('8537','2013-05-04','13:25:00',4.57),('8537','2013-05-04','13:30:00',4.64),('8537','2013-05-04','13:35:00',4.41),('8537','2013-05-04','13:40:00',4.48),('8537','2013-05-04','13:45:00',4.43),('8537','2013-05-04','13:50:00',3.96),('8537','2013-05-04','13:55:00',4.23),('8537','2013-05-04','14:00:00',4.34),('8537','2013-05-04','14:05:00',4.42),('8537','2013-05-04','14:10:00',4.16),('8537','2013-05-04','14:15:00',4.25),('8537','2013-05-04','14:20:00',4.29),('8537','2013-05-04','14:25:00',4.04),('8537','2013-05-04','14:30:00',4.19),('8537','2013-05-04','14:35:00',3.87),('8537','2013-05-04','14:40:00',4.04),('8537','2013-05-04','14:45:00',3.99),('8537','2013-05-04','14:50:00',3.78),('8537','2013-05-04','14:55:00',3.89),('8537','2013-05-04','15:00:00',3.92),('8537','2013-05-04','15:05:00',3.97),('8537','2013-05-04','15:10:00',3.72),('8537','2013-05-04','15:15:00',3.85),('8537','2013-05-04','15:20:00',3.93),('8537','2013-05-04','15:25:00',3.94),('8537','2013-05-04','15:30:00',3.73),('8537','2013-05-04','15:35:00',3.62),('8537','2013-05-04','15:40:00',3.66),('8537','2013-05-04','15:45:00',3.66),('8537','2013-05-04','15:50:00',3.61),('8537','2013-05-04','15:55:00',3.52),('8537','2013-05-04','16:00:00',3.43),('8537','2013-05-04','16:05:00',3.37),('8537','2013-05-04','16:10:00',3.24),('8537','2013-05-04','16:15:00',3.15),('8537','2013-05-04','16:20:00',3.09),('8537','2013-05-04','16:25:00',3.02),('8537','2013-05-04','16:30:00',2.94),('8537','2013-05-04','16:35:00',2.88),('8537','2013-05-04','16:40:00',2.79),('8537','2013-05-04','16:45:00',2.7),('8537','2013-05-04','16:50:00',2.56),('8537','2013-05-04','16:55:00',2.48),('8537','2013-05-04','17:00:00',2.41),('8537','2013-05-04','17:05:00',2.27),('8537','2013-05-04','17:10:00',1.74),('8537','2013-05-04','17:15:00',1.97),('8537','2013-05-04','17:20:00',2.03),('8537','2013-05-04','17:25:00',1.93),('8537','2013-05-04','17:30:00',1.81),('8537','2013-05-04','17:35:00',1.65),('8537','2013-05-04','17:40:00',1.5),('8537','2013-05-04','17:45:00',1.46),('8537','2013-05-04','17:50:00',1.44),('8537','2013-05-04','17:55:00',1.36),('8537','2013-05-04','18:00:00',1.27),('8537','2013-05-04','18:05:00',1.18),('8537','2013-05-04','18:10:00',1.01),('8537','2013-05-03','08:00:00',1.04),('8537','2013-05-03','08:05:00',1.51),('8537','2013-05-03','08:10:00',1.79),('8537','2013-05-03','08:15:00',2.03),('8537','2013-05-03','08:20:00',1.99),('8537','2013-05-03','08:25:00',2.15),('8537','2013-05-03','08:30:00',2.24),('8537','2013-05-03','08:35:00',2.31),('8537','2013-05-03','08:40:00',2.39),('8537','2013-05-03','08:45:00',2.48),('8537','2013-05-03','08:50:00',2.45),('8537','2013-05-03','08:55:00',2.49),('8537','2013-05-03','09:00:00',2.64),('8537','2013-05-03','09:05:00',2.82),('8537','2013-05-03','09:10:00',2.87),('8537','2013-05-03','09:15:00',2.96),('8537','2013-05-03','09:20:00',3.04),('8537','2013-05-03','09:25:00',3.13),('8537','2013-05-03','09:30:00',3.24),('8537','2013-05-03','09:35:00',3.37),('8537','2013-05-03','09:40:00',3.45),('8537','2013-05-03','09:45:00',3.52),('8537','2013-05-03','09:50:00',3.61),('8537','2013-05-03','09:55:00',3.68),('8537','2013-05-03','10:00:00',3.77),('8537','2013-05-03','10:05:00',3.84),('8537','2013-05-03','10:10:00',3.86),('8537','2013-05-03','10:15:00',3.89),('8537','2013-05-03','10:20:00',3.96),('8537','2013-05-03','10:25:00',4.05),('8537','2013-05-03','10:30:00',4.14),('8537','2013-05-03','10:35:00',4.21),('8537','2013-05-03','10:40:00',4.23),('8537','2013-05-03','10:45:00',4.24),('8537','2013-05-03','10:50:00',4.31),('8537','2013-05-03','10:55:00',4.34),('8537','2013-05-03','11:00:00',4.36),('8537','2013-05-03','11:05:00',4.37),('8537','2013-05-03','11:10:00',4.45),('8537','2013-05-03','11:15:00',4.54),('8537','2013-05-03','11:20:00',4.57),('8537','2013-05-03','11:25:00',4.66),('8537','2013-05-03','11:30:00',4.68),('8537','2013-05-03','11:35:00',4.71),('8537','2013-05-03','11:40:00',4.75),('8537','2013-05-03','11:45:00',4.76),('8537','2013-05-03','11:50:00',4.73),('8537','2013-05-03','11:55:00',4.75),('8537','2013-05-03','12:00:00',4.78),('8537','2013-05-03','12:05:00',4.8),('8537','2013-05-03','12:10:00',4.89),('8537','2013-05-03','12:15:00',4.87),('8537','2013-05-03','12:20:00',4.86),('8537','2013-05-03','12:25:00',4.84),('8537','2013-05-03','12:30:00',4.83),('8537','2013-05-03','12:35:00',4.82),('8537','2013-05-03','12:40:00',4.83),('8537','2013-05-03','12:45:00',4.84),('8537','2013-05-03','12:50:00',4.95),('8537','2013-05-03','12:55:00',4.89),('8537','2013-05-03','13:00:00',4.86),('8537','2013-05-03','13:05:00',4.87),('8537','2013-05-03','13:10:00',4.87),('8537','2013-05-03','13:15:00',4.86),('8537','2013-05-03','13:20:00',4.88),('8537','2013-05-03','13:25:00',4.93),('8537','2013-05-03','13:30:00',4.85),('8537','2013-05-03','13:35:00',4.72),('8537','2013-05-03','13:40:00',4.65),('8537','2013-05-03','13:45:00',4.64),('8537','2013-05-03','13:50:00',4.63),('8537','2013-05-03','13:55:00',4.69),('8537','2013-05-03','14:00:00',4.65),('8537','2013-05-03','14:05:00',4.42),('8537','2013-05-03','14:10:00',4.53),('8537','2013-05-03','14:15:00',4.36),('8537','2013-05-03','14:20:00',4.5),('8537','2013-05-03','14:25:00',4.47),('8537','2013-05-03','14:30:00',4.41),('8537','2013-05-03','14:35:00',4.41),('8537','2013-05-03','14:40:00',4.31),('8537','2013-05-03','14:45:00',4.24),('8537','2013-05-03','14:50:00',4.2),('8537','2013-05-03','14:55:00',4.23),('8537','2013-05-03','15:00:00',4.23),('8537','2013-05-03','15:05:00',4.13),('8537','2013-05-03','15:10:00',4.14),('8537','2013-05-03','15:15:00',4.12),('8537','2013-05-03','15:20:00',4.06),('8537','2013-05-03','15:25:00',4),('8537','2013-05-03','15:30:00',3.83),('8537','2013-05-03','15:35:00',3.87),('8537','2013-05-03','15:40:00',3.8),('8537','2013-05-03','15:45:00',3.75),('8537','2013-05-03','15:50:00',3.64),('8537','2013-05-03','15:55:00',3.58),('8537','2013-05-03','16:00:00',3.55),('8537','2013-05-03','16:05:00',3.5),('8537','2013-05-03','16:10:00',3.38),('8537','2013-05-03','16:15:00',3.28),('8537','2013-05-03','16:20:00',3.12),('8537','2013-05-03','16:25:00',3.05),('8537','2013-05-03','16:30:00',3.05),('8537','2013-05-03','16:35:00',3),('8537','2013-05-03','16:40:00',2.89),('8537','2013-05-03','16:45:00',2.79),('8537','2013-05-03','16:50:00',2.66),('8537','2013-05-03','16:55:00',2.58),('8537','2013-05-03','17:00:00',2.49),('8537','2013-05-03','17:05:00',2.38),('8537','2013-05-03','17:10:00',2.22),('8537','2013-05-03','17:15:00',2.13),('8537','2013-05-03','17:20:00',2.01),('8537','2013-05-03','17:25:00',1.89),('8537','2013-05-03','17:30:00',1.78),('8537','2013-05-03','17:35:00',1.65),('8537','2013-05-03','17:40:00',1.53),('8537','2013-05-03','17:45:00',1.42),('8537','2013-05-03','17:50:00',1.36),('8537','2013-05-03','17:55:00',1.27),('8537','2013-05-03','18:00:00',1.21),('8537','2013-05-03','18:05:00',1.09),('8537','2013-05-03','18:10:00',1.03),('8537','2013-05-02','08:55:00',1.37),('8537','2013-05-02','09:00:00',2.3),('8537','2013-05-02','09:05:00',1.97),('8537','2013-05-02','09:10:00',1.06),('8537','2013-05-02','09:20:00',1.12),('8537','2013-05-02','09:25:00',1.91),('8537','2013-05-02','09:30:00',2.25),('8537','2013-05-02','09:35:00',2.4),('8537','2013-05-02','09:40:00',1.74),('8537','2013-05-02','09:45:00',3.05),('8537','2013-05-02','09:50:00',1.52),('8537','2013-05-02','09:55:00',1.16),('8537','2013-05-02','10:00:00',1.24),('8537','2013-05-02','10:05:00',1.77),('8537','2013-05-02','10:10:00',1.7),('8537','2013-05-02','10:15:00',1.75),('8537','2013-05-02','10:20:00',1.82),('8537','2013-05-02','10:25:00',2.23),('8537','2013-05-02','10:30:00',3.52),('8537','2013-05-02','10:35:00',3.21),('8537','2013-05-02','10:40:00',4.41),('8537','2013-05-02','10:45:00',3.21),('8537','2013-05-02','10:50:00',4.05),('8537','2013-05-02','10:55:00',4.66),('8537','2013-05-02','11:00:00',4.84),('8537','2013-05-02','11:05:00',4.53),('8537','2013-05-02','11:10:00',3.54),('8537','2013-05-02','11:15:00',3.46),('8537','2013-05-02','11:20:00',3.25),('8537','2013-05-02','11:25:00',4.78),('8537','2013-05-02','11:30:00',4.79),('8537','2013-05-02','11:35:00',4.68),('8537','2013-05-02','11:40:00',4.63),('8537','2013-05-02','11:45:00',4.61),('8537','2013-05-02','11:50:00',4.62),('8537','2013-05-02','11:55:00',4.65),('8537','2013-05-02','12:00:00',4.65),('8537','2013-05-02','12:05:00',4.61),('8537','2013-05-02','12:10:00',4.58),('8537','2013-05-02','12:15:00',4.61),('8537','2013-05-02','12:20:00',4.54),('8537','2013-05-02','12:25:00',4.65),('8537','2013-05-02','12:30:00',4.74),('8537','2013-05-02','12:35:00',4.78),('8537','2013-05-02','12:40:00',4.84),('8537','2013-05-02','12:45:00',4.83),('8537','2013-05-02','12:50:00',4.85),('8537','2013-05-02','12:55:00',4.88),('8537','2013-05-02','13:00:00',4.92),('8537','2013-05-02','13:05:00',4.96),('8537','2013-05-02','13:10:00',4.98),('8537','2013-05-02','13:15:00',4.98),('8537','2013-05-02','13:20:00',4.99),('8537','2013-05-02','13:25:00',4.98),('8537','2013-05-02','13:30:00',4.97),('8537','2013-05-02','13:35:00',4.95),('8537','2013-05-02','13:40:00',4.95),('8537','2013-05-02','13:45:00',4.94),('8537','2013-05-02','13:50:00',4.91),('8537','2013-05-02','13:55:00',4.91),('8537','2013-05-02','14:00:00',4.84),('8537','2013-05-02','14:05:00',4.76),('8537','2013-05-02','14:10:00',4.73),('8537','2013-05-02','14:15:00',4.71),('8537','2013-05-02','14:20:00',4.67),('8537','2013-05-02','14:25:00',4.62),('8537','2013-05-02','14:30:00',4.58),('8537','2013-05-02','14:35:00',4.52),('8537','2013-05-02','14:40:00',4.5),('8537','2013-05-02','14:45:00',4.47),('8537','2013-05-02','14:50:00',4.44),('8537','2013-05-02','14:55:00',4.41),('8537','2013-05-02','15:00:00',4.35),('8537','2013-05-02','15:05:00',4.28),('8537','2013-05-02','15:10:00',4.24),('8537','2013-05-02','15:15:00',4.18),('8537','2013-05-02','15:20:00',4.07),('8537','2013-05-02','15:25:00',4.04),('8537','2013-05-02','15:30:00',3.8),('8537','2013-05-02','15:35:00',3.8),('8537','2013-05-02','15:40:00',3.74),('8537','2013-05-02','15:45:00',3.67),('8537','2013-05-02','15:50:00',3.65),('8537','2013-05-02','15:55:00',3.56),('8537','2013-05-02','16:00:00',3.5),('8537','2013-05-02','16:05:00',3.46),('8537','2013-05-02','16:10:00',3.35),('8537','2013-05-02','16:15:00',3.27),('8537','2013-05-02','16:20:00',3.19),('8537','2013-05-02','16:25:00',3.13),('8537','2013-05-02','16:30:00',3.04),('8537','2013-05-02','16:35:00',2.93),('8537','2013-05-02','16:40:00',2.86),('8537','2013-05-02','16:45:00',2.76),('8537','2013-05-02','16:50:00',2.65),('8537','2013-05-02','16:55:00',2.57),('8537','2013-05-02','17:00:00',2.49),('8537','2013-05-02','17:05:00',2.39),('8537','2013-05-02','17:10:00',2.23),('8537','2013-05-02','17:15:00',2.16),('8537','2013-05-02','17:20:00',2.07),('8537','2013-05-02','17:25:00',1.98),('8537','2013-05-02','17:30:00',1.87),('8537','2013-05-02','17:35:00',1.76),('8537','2013-05-02','17:40:00',1.64),('8537','2013-05-02','17:45:00',1.56),('8537','2013-05-02','17:50:00',1.47),('8537','2013-05-02','17:55:00',1.37),('8537','2013-05-02','18:00:00',1.27),('8537','2013-05-02','18:05:00',1.17),('8537','2013-05-02','18:10:00',1.08),('8537','2014-03-30','08:10:00',1.02),('8537','2014-03-30','08:15:00',1.14),('8537','2014-03-30','08:20:00',1.31),('8537','2014-03-30','08:25:00',1.46),('8537','2014-03-30','08:30:00',1.54),('8537','2014-03-30','08:35:00',1.65),('8537','2014-03-30','08:40:00',1.67),('8537','2014-03-30','08:45:00',1.65),('8537','2014-03-30','08:50:00',1.65),('8537','2014-03-30','08:55:00',1.73),('8537','2014-03-30','09:00:00',1.8),('8537','2014-03-30','09:05:00',1.8),('8537','2014-03-30','09:10:00',1.76),('8537','2014-03-30','09:15:00',1.69),('8537','2014-03-30','09:20:00',1.99),('8537','2014-03-30','09:25:00',2.11),('8537','2014-03-30','09:30:00',2.44),('8537','2014-03-30','09:35:00',2.64),('8537','2014-03-30','09:40:00',2.74),('8537','2014-03-30','09:45:00',2.8),('8537','2014-03-30','09:50:00',2.89),('8537','2014-03-30','09:55:00',2.89),('8537','2014-03-30','10:00:00',2.89),('8537','2014-03-30','10:05:00',3.27),('8537','2014-03-30','10:10:00',3.33),('8537','2014-03-30','10:15:00',3.31),('8537','2014-03-30','10:20:00',3.35),('8537','2014-03-30','10:25:00',3.48),('8537','2014-03-30','10:30:00',3.62),('8537','2014-03-30','10:35:00',3.71),('8537','2014-03-30','10:40:00',3.82),('8537','2014-03-30','10:45:00',3.81),('8537','2014-03-30','10:50:00',3.81),('8537','2014-03-30','10:55:00',3.87),('8537','2014-03-30','11:00:00',3.86),('8537','2014-03-30','11:05:00',3.83),('8537','2014-03-30','11:10:00',3.9),('8537','2014-03-30','11:15:00',3.81),('8537','2014-03-30','11:20:00',3.73),('8537','2014-03-30','11:25:00',3.9),('8537','2014-03-30','11:30:00',4.05),('8537','2014-03-30','11:35:00',4.12),('8537','2014-03-30','11:40:00',4.32),('8537','2014-03-30','11:45:00',4.41),('8537','2014-03-30','11:50:00',4.52),('8537','2014-03-30','11:55:00',4.59),('8537','2014-03-30','12:00:00',4.62),('8537','2014-03-30','12:05:00',4.8),('8537','2014-03-30','12:10:00',4.9),('8537','2014-03-30','12:15:00',5.01),('8537','2014-03-30','12:20:00',4.94),('8537','2014-03-30','12:25:00',4.91),('8537','2014-03-30','12:30:00',4.49),('8537','2014-03-30','12:35:00',4.5),('8537','2014-03-30','12:40:00',4.82),('8537','2014-03-30','12:45:00',4.69),('8537','2014-03-30','12:50:00',4.78),('8537','2014-03-30','12:55:00',4.8),('8537','2014-03-30','13:00:00',4.97),('8537','2014-03-30','13:05:00',5),('8537','2014-03-30','13:10:00',4.99),('8537','2014-03-30','13:15:00',4.96),('8537','2014-03-30','13:20:00',4.95),('8537','2014-03-30','13:25:00',4.95),('8537','2014-03-30','13:30:00',4.97),('8537','2014-03-30','13:35:00',5.02),('8537','2014-03-30','13:40:00',4.99),('8537','2014-03-30','13:45:00',5.01),('8537','2014-03-30','13:50:00',4.98),('8537','2014-03-30','13:55:00',4.86),('8537','2014-03-30','14:00:00',4.78),('8537','2014-03-30','14:05:00',4.85),('8537','2014-03-30','14:10:00',4.68),('8537','2014-03-30','14:15:00',4.63),('8537','2014-03-30','14:20:00',4.76),('8537','2014-03-30','14:25:00',4.81),('8537','2014-03-30','14:30:00',4.74),('8537','2014-03-30','14:35:00',4.72),('8537','2014-03-30','14:40:00',4.42),('8537','2014-03-30','14:45:00',4.09),('8537','2014-03-30','14:50:00',3.6),('8537','2014-03-30','14:55:00',3.06),('8537','2014-03-30','15:00:00',2.53),('8537','2014-03-30','15:05:00',1.88),('8537','2014-03-30','15:10:00',1.46),('8537','2014-03-30','15:15:00',1.58),('8537','2014-03-30','15:20:00',2.76),('8537','2014-03-30','15:25:00',3.4),('8537','2014-03-30','15:30:00',3.19),('8537','2014-03-30','15:35:00',3.67),('8537','2014-03-30','15:40:00',3.67),('8537','2014-03-30','15:45:00',3.72),('8537','2014-03-30','15:50:00',3.7),('8537','2014-03-30','15:55:00',3.54),('8537','2014-03-30','16:00:00',3.36),('8537','2014-03-30','16:05:00',3.02),('8537','2014-03-30','16:10:00',2.98),('8537','2014-03-30','16:15:00',2.89),('8537','2014-03-30','16:20:00',3.14),('8537','2014-03-30','16:25:00',3.16),('8537','2014-03-30','16:30:00',3.04),('8537','2014-03-30','16:35:00',2.99),('8537','2014-03-30','16:40:00',2.48),('8537','2014-03-30','16:45:00',2.34),('8537','2014-03-30','16:50:00',2.32),('8537','2014-03-30','16:55:00',1.88),('8537','2014-03-30','17:00:00',1.93),('8537','2014-03-30','17:05:00',2.17),('8537','2014-03-30','17:10:00',2.24),('8537','2014-03-30','17:15:00',2.2),('8537','2014-03-30','17:20:00',2.08),('8537','2014-03-30','17:25:00',1.78),('8537','2014-03-30','17:30:00',1.76),('8537','2014-03-30','17:35:00',1.64),('8537','2014-03-30','17:40:00',1.45),('8537','2014-03-30','17:45:00',1.42),('8537','2014-03-30','17:50:00',1.2),('8537','2013-05-01','07:50:00',1.07),('8537','2013-05-01','07:55:00',1.18),('8537','2013-05-01','08:00:00',1.27),('8537','2013-05-01','08:05:00',1.34),('8537','2013-05-01','08:10:00',1.41),('8537','2013-05-01','08:15:00',1.53),('8537','2013-05-01','08:20:00',1.65),('8537','2013-05-01','08:25:00',1.76),('8537','2013-05-01','08:30:00',1.87),('8537','2013-05-01','08:35:00',1.98),('8537','2013-05-01','08:40:00',2.06),('8537','2013-05-01','08:45:00',2.15),('8537','2013-05-01','08:50:00',2.29),('8537','2013-05-01','08:55:00',2.39),('8537','2013-05-01','09:00:00',2.5),('8537','2013-05-01','09:05:00',2.58),('8537','2013-05-01','09:10:00',2.67),('8537','2013-05-01','09:15:00',2.73),('8537','2013-05-01','09:20:00',2.79),('8537','2013-05-01','09:25:00',2.86),('8537','2013-05-01','09:30:00',2.9),('8537','2013-05-01','09:35:00',2.96),('8537','2013-05-01','09:40:00',3.07),('8537','2013-05-01','09:45:00',3.16),('8537','2013-05-01','09:50:00',3.19),('8537','2013-05-01','09:55:00',3.26),('8537','2013-05-01','10:00:00',3.33),('8537','2013-05-01','10:05:00',3.36),('8537','2013-05-01','10:10:00',3.47),('8537','2013-05-01','10:15:00',3.57),('8537','2013-05-01','10:20:00',3.6),('8537','2013-05-01','10:25:00',3.68),('8537','2013-05-01','10:30:00',3.73),('8537','2013-05-01','10:35:00',3.77),('8537','2013-05-01','10:40:00',3.94),('8537','2013-05-01','10:45:00',4.11),('8537','2013-05-01','10:50:00',4.17),('8537','2013-05-01','10:55:00',4.2),('8537','2013-05-01','11:00:00',4.25),('8537','2013-05-01','11:05:00',4.28),('8537','2013-05-01','11:10:00',4.3),('8537','2013-05-01','11:15:00',4.03),('8537','2013-05-01','11:20:00',3.96),('8537','2013-05-01','11:25:00',3.92),('8537','2013-05-01','11:30:00',3.87),('8537','2013-05-01','11:35:00',4.06),('8537','2013-05-01','11:40:00',3.38),('8537','2013-05-01','11:45:00',3.27),('8537','2013-05-01','11:50:00',3.93),('8537','2013-05-01','11:55:00',4.6),('8537','2013-05-01','12:00:00',4.54),('8537','2013-05-01','12:05:00',4.47),('8537','2013-05-01','12:10:00',4.5),('8537','2013-05-01','12:15:00',4.5),('8537','2013-05-01','12:20:00',4.57),('8537','2013-05-01','12:25:00',4.65),('8537','2013-05-01','12:30:00',4.64),('8537','2013-05-01','12:35:00',4.67),('8537','2013-05-01','12:40:00',4.77),('8537','2013-05-01','12:45:00',4.35),('8537','2013-05-01','12:50:00',3.82),('8537','2013-05-01','12:55:00',1.74),('8537','2013-05-01','13:00:00',1.99),('8537','2013-05-01','13:05:00',2.1),('8537','2013-05-01','13:10:00',2.77),('8537','2013-05-01','13:15:00',5.02),('8537','2013-05-01','13:20:00',5.36),('8537','2013-05-01','13:25:00',4.46),('8537','2013-05-01','13:30:00',3.25),('8537','2013-05-01','13:35:00',3.88),('8537','2013-05-01','13:40:00',4.85),('8537','2013-05-01','13:45:00',5.08),('8537','2013-05-01','13:50:00',4.77),('8537','2013-05-01','13:55:00',4.64),('8537','2013-05-01','14:00:00',4.58),('8537','2013-05-01','14:05:00',4.47),('8537','2013-05-01','14:10:00',4.48),('8537','2013-05-01','14:15:00',3.85),('8537','2013-05-01','14:20:00',4.65),('8537','2013-05-01','14:25:00',4.65),('8537','2013-05-01','14:30:00',4.65),('8537','2013-05-01','14:35:00',4.36),('8537','2013-05-01','14:40:00',3.97),('8537','2013-05-01','14:45:00',4.18),('8537','2013-05-01','14:50:00',3.54),('8537','2013-05-01','14:55:00',3.27),('8537','2013-05-01','15:00:00',3.53),('8537','2013-05-01','15:05:00',3.93),('8537','2013-05-01','15:10:00',3.95),('8537','2013-05-01','15:15:00',3.84),('8537','2013-05-01','15:20:00',3.67),('8537','2013-05-01','15:25:00',3.79),('8537','2013-05-01','15:30:00',3.11),('8537','2013-05-01','15:35:00',2.66),('8537','2013-05-01','15:40:00',2.66),('8537','2013-05-01','15:45:00',2.63),('8537','2013-05-01','15:50:00',1.97),('8537','2013-05-01','15:55:00',1.9),('8537','2013-05-01','16:00:00',2.24),('8537','2013-05-01','16:05:00',2.17),('8537','2013-05-01','16:10:00',1.97),('8537','2013-05-01','16:15:00',1.79),('8537','2013-05-01','16:20:00',1.56),('8537','2013-05-01','16:25:00',1.26),('8537','2013-05-01','16:30:00',1.19),('8537','2013-05-01','16:35:00',1.25),('8537','2013-05-01','16:40:00',1.34),('8537','2013-05-01','16:45:00',1.26),('8537','2013-05-01','16:50:00',1.11),('8537','2013-05-01','16:55:00',1.01),('8537','2013-05-01','17:00:00',1.04),('8537','2013-05-01','17:05:00',1.05),('8537','2013-05-01','17:10:00',1.07),('8537','2013-05-01','17:15:00',1.06),('8537','2013-04-30','08:35:00',1.03),('8537','2013-04-30','08:45:00',1.03),('8537','2013-04-30','08:50:00',1.29),('8537','2013-04-30','08:55:00',1.84),('8537','2013-04-30','09:00:00',2.03),('8537','2013-04-30','09:05:00',1.8),('8537','2013-04-30','09:10:00',2.49),('8537','2013-04-30','09:15:00',3.01),('8537','2013-04-30','09:20:00',3.07),('8537','2013-04-30','09:25:00',3.28),('8537','2013-04-30','09:30:00',3.2),('8537','2013-04-30','09:35:00',2.66),('8537','2013-04-30','09:40:00',1.91),('8537','2013-04-30','09:45:00',2.34),('8537','2013-04-30','09:50:00',3.06),('8537','2013-04-30','09:55:00',3.4),('8537','2013-04-30','10:00:00',3.93),('8537','2013-04-30','10:05:00',3.87),('8537','2013-04-30','10:10:00',3.34),('8537','2013-04-30','10:15:00',2.87),('8537','2013-04-30','10:20:00',2.58),('8537','2013-04-30','10:25:00',2.83),('8537','2013-04-30','10:30:00',2.41),('8537','2013-04-30','10:35:00',2.19),('8537','2013-04-30','10:40:00',1.9),('8537','2013-04-30','10:45:00',1.53),('8537','2013-04-30','10:50:00',1.66),('8537','2013-04-30','10:55:00',1.76),('8537','2013-04-30','11:00:00',1.78),('8537','2013-04-30','11:05:00',2.03),('8537','2013-04-30','11:10:00',2.07),('8537','2013-04-30','11:15:00',2.18),('8537','2013-04-30','11:20:00',2.5),('8537','2013-04-30','11:25:00',2.28),('8537','2013-04-30','11:30:00',2.24),('8537','2013-04-30','11:35:00',2.38),('8537','2013-04-30','11:40:00',2.29),('8537','2013-04-30','11:45:00',1.94),('8537','2013-04-30','11:50:00',2),('8537','2013-04-30','11:55:00',2.04),('8537','2013-04-30','12:00:00',2.05),('8537','2013-04-30','12:05:00',2.07),('8537','2013-04-30','12:10:00',2.02),('8537','2013-04-30','12:15:00',1.86),('8537','2013-04-30','12:20:00',1.66),('8537','2013-04-30','12:25:00',1.52),('8537','2013-04-30','12:30:00',1.56),('8537','2013-04-30','12:35:00',2.82),('8537','2013-04-30','12:40:00',5.06),('8537','2013-04-30','12:45:00',5.34),('8537','2013-04-30','12:50:00',5.16),('8537','2013-04-30','12:55:00',4.59),('8537','2013-04-30','13:00:00',4.98),('8537','2013-04-30','13:05:00',4.81),('8537','2013-04-30','13:10:00',4.92),('8537','2013-04-30','13:15:00',4.84),('8537','2013-04-30','13:20:00',4.81),('8537','2013-04-30','13:25:00',4.77),('8537','2013-04-30','13:30:00',4.75),('8537','2013-04-30','13:35:00',4.75),('8537','2013-04-30','13:40:00',4.69),('8537','2013-04-30','13:45:00',4.64),('8537','2013-04-30','13:50:00',4.57),('8537','2013-04-30','13:55:00',4.53),('8537','2013-04-30','14:00:00',4.44),('8537','2013-04-30','14:05:00',4.5),('8537','2013-04-30','14:10:00',4.48),('8537','2013-04-30','14:15:00',4.45),('8537','2013-04-30','14:20:00',4.44),('8537','2013-04-30','14:25:00',4.42),('8537','2013-04-30','14:30:00',4.37),('8537','2013-04-30','14:35:00',4.23),('8537','2013-04-30','14:40:00',3.96),('8537','2013-04-30','14:45:00',3.64),('8537','2013-04-30','14:50:00',4.1),('8537','2013-04-30','14:55:00',4),('8537','2013-04-30','15:00:00',3.96),('8537','2013-04-30','15:05:00',3.89),('8537','2013-04-30','15:10:00',3.82),('8537','2013-04-30','15:15:00',3.75),('8537','2013-04-30','15:20:00',3.66),('8537','2013-04-30','15:25:00',3.61),('8537','2013-04-30','15:30:00',3.44),('8537','2013-04-30','15:35:00',3.52),('8537','2013-04-30','15:40:00',3.45),('8537','2013-04-30','15:45:00',3.39),('8537','2013-04-30','15:50:00',3.26),('8537','2013-04-30','15:55:00',3.23),('8537','2013-04-30','16:00:00',3.17),('8537','2013-04-30','16:05:00',3.11),('8537','2013-04-30','16:10:00',3.01),('8537','2013-04-30','16:15:00',2.92),('8537','2013-04-30','16:20:00',2.85),('8537','2013-04-30','16:25:00',2.77),('8537','2013-04-30','16:30:00',2.72),('8537','2013-04-30','16:35:00',2.58),('8537','2013-04-30','16:40:00',2.19),('8537','2013-04-30','16:45:00',2.23),('8537','2013-04-30','16:50:00',1.96),('8537','2013-04-30','16:55:00',2.23),('8537','2013-04-30','17:00:00',2.05),('8537','2013-04-30','17:05:00',2.02),('8537','2013-04-30','17:10:00',1.71),('8537','2013-04-30','17:20:00',1.39),('8537','2013-04-30','17:25:00',1.64),('8537','2013-04-30','17:30:00',1.55),('8537','2013-04-30','17:35:00',1.49),('8537','2013-04-30','17:40:00',1.38),('8537','2013-04-30','17:45:00',1.31),('8537','2013-04-30','17:50:00',1.22),('8537','2013-04-30','17:55:00',1.13),('8537','2013-04-30','18:00:00',1.05),('8537','2013-04-29','07:50:00',1.04),('8537','2013-04-29','07:55:00',1.21),('8537','2013-04-29','08:00:00',1.39),('8537','2013-04-29','08:05:00',1.49),('8537','2013-04-29','08:10:00',1.45),('8537','2013-04-29','08:15:00',1.48),('8537','2013-04-29','08:20:00',1.61),('8537','2013-04-29','08:25:00',1.84),('8537','2013-04-29','08:30:00',2.09),('8537','2013-04-29','08:35:00',2.35),('8537','2013-04-29','08:40:00',2.38),('8537','2013-04-29','08:45:00',2.33),('8537','2013-04-29','08:50:00',2.49),('8537','2013-04-29','08:55:00',2.49),('8537','2013-04-29','09:00:00',1.95),('8537','2013-04-29','09:05:00',2.66),('8537','2013-04-29','09:10:00',2.94),('8537','2013-04-29','09:15:00',3.11),('8537','2013-04-29','09:20:00',2.92),('8537','2013-04-29','09:25:00',2.87),('8537','2013-04-29','09:30:00',2.89),('8537','2013-04-29','09:35:00',3.08),('8537','2013-04-29','09:40:00',3.09),('8537','2013-04-29','09:45:00',3.21),('8537','2013-04-29','09:50:00',3.42),('8537','2013-04-29','09:55:00',3.2),('8537','2013-04-29','10:00:00',3.37),('8537','2013-04-29','10:05:00',3.32),('8537','2013-04-29','10:10:00',3.31),('8537','2013-04-29','10:15:00',2.79),('8537','2013-04-29','10:20:00',2.74),('8537','2013-04-29','10:25:00',3.28),('8537','2013-04-29','10:30:00',3.32),('8537','2013-04-29','10:35:00',3.86),('8537','2013-04-29','10:40:00',3.89),('8537','2013-04-29','10:45:00',3.96),('8537','2013-04-29','10:50:00',3.8),('8537','2013-04-29','10:55:00',3.58),('8537','2013-04-29','11:00:00',4.02),('8537','2013-04-29','11:05:00',3.86),('8537','2013-04-29','11:10:00',3.77),('8537','2013-04-29','11:15:00',3.51),('8537','2013-04-29','11:20:00',4),('8537','2013-04-29','11:25:00',4.16),('8537','2013-04-29','11:30:00',4.37),('8537','2013-04-29','11:35:00',4.17),('8537','2013-04-29','11:40:00',4.21),('8537','2013-04-29','11:45:00',4.12),('8537','2013-04-29','11:50:00',4.54),('8537','2013-04-29','11:55:00',4.51),('8537','2013-04-29','12:00:00',4.65),('8537','2013-04-29','12:05:00',4.64),('8537','2013-04-29','12:10:00',4.48),('8537','2013-04-29','12:15:00',4.53),('8537','2013-04-29','12:20:00',4.57),('8537','2013-04-29','12:25:00',4.45),('8537','2013-04-29','12:30:00',4.57),('8537','2013-04-29','12:35:00',4.64),('8537','2013-04-29','12:40:00',4.75),('8537','2013-04-29','12:45:00',4.75),('8537','2013-04-29','12:50:00',4.73),('8537','2013-04-29','12:55:00',4.62),('8537','2013-04-29','13:00:00',4.71),('8537','2013-04-29','13:05:00',4.65),('8537','2013-04-29','13:10:00',4.55),('8537','2013-04-29','13:15:00',4.24),('8537','2013-04-29','13:20:00',4.55),('8537','2013-04-29','13:25:00',4.78),('8537','2013-04-29','13:30:00',4.67),('8537','2013-04-29','13:35:00',4.62),('8537','2013-04-29','13:40:00',4.67),('8537','2013-04-29','13:45:00',4.66),('8537','2013-04-29','13:50:00',4.4),('8537','2013-04-29','13:55:00',4.82),('8537','2013-04-29','14:00:00',4.47),('8537','2013-04-29','14:05:00',4.44),('8537','2013-04-29','14:10:00',4.56),('8537','2013-04-29','14:15:00',4.63),('8537','2013-04-29','14:20:00',4.59),('8537','2013-04-29','14:25:00',4.46),('8537','2013-04-29','14:30:00',4.23),('8537','2013-04-29','14:35:00',4.07),('8537','2013-04-29','14:40:00',3.9),('8537','2013-04-29','14:45:00',4.21),('8537','2013-04-29','14:50:00',4.06),('8537','2013-04-29','14:55:00',4.16),('8537','2013-04-29','15:00:00',4),('8537','2013-04-29','15:05:00',4.24),('8537','2013-04-29','15:10:00',3.84),('8537','2013-04-29','15:15:00',3.58),('8537','2013-04-29','15:20:00',3.82),('8537','2013-04-29','15:25:00',4.02),('8537','2013-04-29','15:30:00',3.72),('8537','2013-04-29','15:35:00',3.41),('8537','2013-04-29','15:40:00',3.11),('8537','2013-04-29','15:45:00',3),('8537','2013-04-29','15:50:00',3.08),('8537','2013-04-29','15:55:00',3.27),('8537','2013-04-29','16:00:00',3.18),('8537','2013-04-29','16:05:00',3.4),('8537','2013-04-29','16:10:00',3.14),('8537','2013-04-29','16:15:00',3.51),('8537','2013-04-29','16:20:00',3.15),('8537','2013-04-29','16:25:00',2.66),('8537','2013-04-29','16:30:00',2.82),('8537','2013-04-29','16:35:00',2.84),('8537','2013-04-29','16:40:00',3),('8537','2013-04-29','16:45:00',2.91),('8537','2013-04-29','16:50:00',2.97),('8537','2013-04-29','16:55:00',3.07),('8537','2013-04-29','17:00:00',2.81),('8537','2013-04-29','17:05:00',2.41),('8537','2013-04-29','17:10:00',2.43),('8537','2013-04-29','17:15:00',2.07),('8537','2013-04-29','17:20:00',1.74),('8537','2013-04-29','17:25:00',1.64),('8537','2013-04-29','17:30:00',1.57),('8537','2013-04-29','17:35:00',1.39),('8537','2013-04-29','17:40:00',1.18),('8537','2013-04-29','17:45:00',1.12),('8537','2013-04-29','17:50:00',1.27),('8537','2013-04-29','17:55:00',1.44),('8537','2013-04-29','18:00:00',1.38),('8537','2013-04-29','18:05:00',1.48),('8537','2013-04-29','18:10:00',1.33),('8537','2013-04-29','18:15:00',1.24),('8537','2013-04-29','18:20:00',1.02),('8537','2013-04-28','07:40:00',1.01),('8537','2013-04-28','07:45:00',1.12),('8537','2013-04-28','07:50:00',1.2),('8537','2013-04-28','07:55:00',1.31),('8537','2013-04-28','08:00:00',1.4),('8537','2013-04-28','08:05:00',1.53),('8537','2013-04-28','08:10:00',1.66),('8537','2013-04-28','08:15:00',1.76),('8537','2013-04-28','08:20:00',1.87),('8537','2013-04-28','08:25:00',1.99),('8537','2013-04-28','08:30:00',2.06),('8537','2013-04-28','08:35:00',2.16),('8537','2013-04-28','08:40:00',2.27),('8537','2013-04-28','08:45:00',2.38),('8537','2013-04-28','08:50:00',2.47),('8537','2013-04-28','08:55:00',2.57),('8537','2013-04-28','09:00:00',2.67),('8537','2013-04-28','09:05:00',2.73),('8537','2013-04-28','09:10:00',2.88),('8537','2013-04-28','09:15:00',2.98),('8537','2013-04-28','09:20:00',3.06),('8537','2013-04-28','09:25:00',3.16),('8537','2013-04-28','09:30:00',3.26),('8537','2013-04-28','09:35:00',3.35),('8537','2013-04-28','09:40:00',3.43),('8537','2013-04-28','09:45:00',3.52),('8537','2013-04-28','09:50:00',3.6),('8537','2013-04-28','09:55:00',3.68),('8537','2013-04-28','10:00:00',3.73),('8537','2013-04-28','10:05:00',3.77),('8537','2013-04-28','10:10:00',3.84),('8537','2013-04-28','10:15:00',3.86),('8537','2013-04-28','10:20:00',3.94),('8537','2013-04-28','10:25:00',4.08),('8537','2013-04-28','10:30:00',4.02),('8537','2013-04-28','10:35:00',4.15),('8537','2013-04-28','10:40:00',3.83),('8537','2013-04-28','10:45:00',4.34),('8537','2013-04-28','10:50:00',4.33),('8537','2013-04-28','10:55:00',4.34),('8537','2013-04-28','11:00:00',4.38),('8537','2013-04-28','11:05:00',4.43),('8537','2013-04-28','11:10:00',4.55),('8537','2013-04-28','11:15:00',4.62),('8537','2013-04-28','11:20:00',4.58),('8537','2013-04-28','11:25:00',4.63),('8537','2013-04-28','11:30:00',4.65),('8537','2013-04-28','11:35:00',4.54),('8537','2013-04-28','11:40:00',4.57),('8537','2013-04-28','11:45:00',4.36),('8537','2013-04-28','11:50:00',4.42),('8537','2013-04-28','11:55:00',4.63),('8537','2013-04-28','12:00:00',4.13),('8537','2013-04-28','12:05:00',4.06),('8537','2013-04-28','12:10:00',4.51),('8537','2013-04-28','12:15:00',4.64),('8537','2013-04-28','12:20:00',4.55),('8537','2013-04-28','12:25:00',4.04),('8537','2013-04-28','12:30:00',3.9),('8537','2013-04-28','12:35:00',3.46),('8537','2013-04-28','12:40:00',3.58),('8537','2013-04-28','12:45:00',4.72),('8537','2013-04-28','12:50:00',4.77),('8537','2013-04-28','12:55:00',4.45),('8537','2013-04-28','13:00:00',4.64),('8537','2013-04-28','13:05:00',5.03),('8537','2013-04-28','13:10:00',4.83),('8537','2013-04-28','13:15:00',4.48),('8537','2013-04-28','13:20:00',4.59),('8537','2013-04-28','13:25:00',4.46),('8537','2013-04-28','13:30:00',4.8),('8537','2013-04-28','13:35:00',4.87),('8537','2013-04-28','13:40:00',5.12),('8537','2013-04-28','13:45:00',4.9),('8537','2013-04-28','13:50:00',3.45),('8537','2013-04-28','13:55:00',2.91),('8537','2013-04-28','14:00:00',4.9),('8537','2013-04-28','14:05:00',4.77),('8537','2013-04-28','14:10:00',4.65),('8537','2013-04-28','14:15:00',4.59),('8537','2013-04-28','14:20:00',2.47),('8537','2013-04-28','14:25:00',4.5),('8537','2013-04-28','14:30:00',4.56),('8537','2013-04-28','14:35:00',4.45),('8537','2013-04-28','14:40:00',4.4),('8537','2013-04-28','14:45:00',4.33),('8537','2013-04-28','14:50:00',4.29),('8537','2013-04-28','14:55:00',4.27),('8537','2013-04-28','15:00:00',4.24),('8537','2013-04-28','15:05:00',4.21),('8537','2013-04-28','15:10:00',4.16),('8537','2013-04-28','15:15:00',4.11),('8537','2013-04-28','15:20:00',4.03),('8537','2013-04-28','15:25:00',3.93),('8537','2013-04-28','15:30:00',3.81),('8537','2013-04-28','15:35:00',3.81),('8537','2013-04-28','15:40:00',3.77),('8537','2013-04-28','15:45:00',3.72),('8537','2013-04-28','15:50:00',3.64),('8537','2013-04-28','15:55:00',3.56),('8537','2013-04-28','16:00:00',3.49),('8537','2013-04-28','16:05:00',3.44),('8537','2013-04-28','16:10:00',3.31),('8537','2013-04-28','16:15:00',3.22),('8537','2013-04-28','16:20:00',3.14),('8537','2013-04-28','16:25:00',3.07),('8537','2013-04-28','16:30:00',3),('8537','2013-04-28','16:35:00',2.92),('8537','2013-04-28','16:40:00',2.84),('8537','2013-04-28','16:45:00',2.73),('8537','2013-04-28','16:50:00',2.65),('8537','2013-04-28','16:55:00',2.55),('8537','2013-04-28','17:00:00',2.48),('8537','2013-04-28','17:05:00',2.27),('8537','2013-04-28','17:10:00',2.12),('8537','2013-04-28','17:15:00',2.18),('8537','2013-04-28','17:20:00',2.06),('8537','2013-04-28','17:25:00',2),('8537','2013-04-28','17:30:00',1.68),('8537','2013-04-28','17:35:00',1.64),('8537','2013-04-28','17:40:00',1.5),('8537','2013-04-28','17:45:00',1.52),('8537','2013-04-28','17:50:00',1.44),('8537','2013-04-28','17:55:00',1.25),('8537','2013-04-28','18:00:00',1.2),('8537','2013-04-28','18:05:00',1.13),('8537','2013-04-27','12:45:00',1.01),('8537','2013-04-27','12:50:00',1.15),('8537','2013-04-27','12:55:00',1.51),('8537','2013-04-27','13:00:00',1.64),('8537','2013-04-27','13:05:00',1.26),('8537','2013-04-27','13:10:00',1.29),('8537','2013-04-27','13:15:00',1.63),('8537','2013-04-27','13:20:00',1.68),('8537','2013-04-27','13:25:00',1.27),('8537','2013-04-27','13:30:00',1.38),('8537','2013-04-27','13:35:00',1.7),('8537','2013-04-27','13:40:00',2.16),('8537','2013-04-27','13:45:00',1.35),('8537','2013-04-27','13:50:00',1.25),('8537','2013-04-27','14:25:00',1.55),('8537','2013-04-27','14:30:00',2.53),('8537','2013-04-27','14:35:00',2.13),('8537','2013-04-27','14:40:00',1.49),('8537','2013-04-27','14:45:00',1.43),('8537','2013-04-27','14:55:00',1.05),('8537','2013-04-27','15:00:00',1.29),('8537','2013-04-27','15:05:00',2.03),('8537','2013-04-27','15:10:00',1.59),('8537','2013-04-27','15:15:00',1.35),('8537','2013-04-27','16:40:00',1.05),('8537','2013-04-27','16:45:00',1.43),('8537','2013-04-27','16:50:00',2.05),('8537','2013-04-27','16:55:00',2.19),('8537','2013-04-27','17:00:00',2.7),('8537','2013-04-27','17:05:00',1.78),('8537','2013-04-27','17:20:00',1.13),('8537','2013-04-27','17:40:00',1.13),('8537','2013-04-26','08:05:00',1.1),('8537','2013-04-26','08:10:00',1.39),('8537','2013-04-26','08:15:00',1.55),('8537','2013-04-26','08:20:00',1.61),('8537','2013-04-26','08:25:00',1.7),('8537','2013-04-26','08:30:00',1.77),('8537','2013-04-26','08:35:00',1.92),('8537','2013-04-26','08:40:00',2),('8537','2013-04-26','08:45:00',2.11),('8537','2013-04-26','08:50:00',2.09),('8537','2013-04-26','08:55:00',1.73),('8537','2013-04-26','09:00:00',1.69),('8537','2013-04-26','09:05:00',2.25),('8537','2013-04-26','09:10:00',2.12),('8537','2013-04-26','09:15:00',1.36),('8537','2013-04-26','09:20:00',1.34),('8537','2013-04-26','09:25:00',1.57),('8537','2013-04-26','09:30:00',1.9),('8537','2013-04-26','09:35:00',2.2),('8537','2013-04-26','09:40:00',2.34),('8537','2013-04-26','09:45:00',3.12),('8537','2013-04-26','09:50:00',2.87),('8537','2013-04-26','09:55:00',1.97),('8537','2013-04-26','10:00:00',2.25),('8537','2013-04-26','10:05:00',2.89),('8537','2013-04-26','10:10:00',3.52),('8537','2013-04-26','10:15:00',3.73),('8537','2013-04-26','10:20:00',3.72),('8537','2013-04-26','10:25:00',3.03),('8537','2013-04-26','10:30:00',4.01),('8537','2013-04-26','10:35:00',4.15),('8537','2013-04-26','10:40:00',3.98),('8537','2013-04-26','10:45:00',3.52),('8537','2013-04-26','10:50:00',2.68),('8537','2013-04-26','10:55:00',2.83),('8537','2013-04-26','11:00:00',3.74),('8537','2013-04-26','11:05:00',4.11),('8537','2013-04-26','11:10:00',3.77),('8537','2013-04-26','11:15:00',4.25),('8537','2013-04-26','11:20:00',3.13),('8537','2013-04-26','11:25:00',3.61),('8537','2013-04-26','11:30:00',3.62),('8537','2013-04-26','11:35:00',4.19),('8537','2013-04-26','11:40:00',3.99),('8537','2013-04-26','11:45:00',3.9),('8537','2013-04-26','11:50:00',3.02),('8537','2013-04-26','11:55:00',3.01),('8537','2013-04-26','12:00:00',3.33),('8537','2013-04-26','12:05:00',2.99),('8537','2013-04-26','12:10:00',2.66),('8537','2013-04-26','12:15:00',3.1),('8537','2013-04-26','12:20:00',2.98),('8537','2013-04-26','12:25:00',2.27),('8537','2013-04-26','12:30:00',2.14),('8537','2013-04-26','12:35:00',2.59),('8537','2013-04-26','12:40:00',3.93),('8537','2013-04-26','12:45:00',4.24),('8537','2013-04-26','12:50:00',2.45),('8537','2013-04-26','12:55:00',2.25),('8537','2013-04-26','13:00:00',1.61),('8537','2013-04-26','13:05:00',1.54),('8537','2013-04-26','13:10:00',1.86),('8537','2013-04-26','13:15:00',2.68),('8537','2013-04-26','13:20:00',1.92),('8537','2013-04-26','13:25:00',2.31),('8537','2013-04-26','13:30:00',2.88),('8537','2013-04-26','13:35:00',2.63),('8537','2013-04-26','13:40:00',3.09),('8537','2013-04-26','13:45:00',2.53),('8537','2013-04-26','13:50:00',3.37),('8537','2013-04-26','13:55:00',2.89),('8537','2013-04-26','14:00:00',3.04),('8537','2013-04-26','14:05:00',4.19),('8537','2013-04-26','14:10:00',3.82),('8537','2013-04-26','14:15:00',4.02),('8537','2013-04-26','14:20:00',3.66),('8537','2013-04-26','14:25:00',4.12),('8537','2013-04-26','14:30:00',4.56),('8537','2013-04-26','14:35:00',3.31),('8537','2013-04-26','14:40:00',1.98),('8537','2013-04-26','14:45:00',2.02),('8537','2013-04-26','14:50:00',3.77),('8537','2013-04-26','14:55:00',3.7),('8537','2013-04-26','15:00:00',3.83),('8537','2013-04-26','15:05:00',3.16),('8537','2013-04-26','15:10:00',1.54),('8537','2013-04-26','15:15:00',2),('8537','2013-04-26','15:20:00',1.66),('8537','2013-04-26','15:25:00',1.81),('8537','2013-04-26','15:30:00',2.44),('8537','2013-04-26','15:35:00',2.13),('8537','2013-04-26','15:40:00',2.21),('8537','2013-04-26','15:45:00',2.23),('8537','2013-04-26','15:50:00',2),('8537','2013-04-26','15:55:00',1.26),('8537','2013-04-25','08:05:00',1.18),('8537','2013-04-25','08:10:00',1.26),('8537','2013-04-25','08:15:00',1.62),('8537','2013-04-25','08:20:00',1.34),('8537','2013-04-25','08:25:00',1.14),('8537','2013-04-25','08:30:00',1.16),('8537','2013-04-25','08:35:00',1.22),('8537','2013-04-25','08:40:00',1.28),('8537','2013-04-25','08:45:00',1.55),('8537','2013-04-25','08:50:00',2.42),('8537','2013-04-25','08:55:00',2.76),('8537','2013-04-25','09:00:00',2.37),('8537','2013-04-25','09:05:00',1.72),('8537','2013-04-25','09:10:00',1.59),('8537','2013-04-25','09:15:00',1.47),('8537','2013-04-25','09:20:00',1.54),('8537','2013-04-25','09:25:00',1.84),('8537','2013-04-25','09:30:00',1.66),('8537','2013-04-25','09:35:00',1.85),('8537','2013-04-25','09:40:00',2.59),('8537','2013-04-25','09:45:00',3.17),('8537','2013-04-25','09:50:00',3.65),('8537','2013-04-25','09:55:00',3.68),('8537','2013-04-25','10:00:00',3.73),('8537','2013-04-25','10:05:00',3.56),('8537','2013-04-25','10:10:00',3.23),('8537','2013-04-25','10:15:00',3.3),('8537','2013-04-25','10:20:00',3.86),('8537','2013-04-25','10:25:00',3.96),('8537','2013-04-25','10:30:00',4.14),('8537','2013-04-25','10:35:00',4.18),('8537','2013-04-25','10:40:00',4.18),('8537','2013-04-25','10:45:00',4.02),('8537','2013-04-25','10:50:00',4.22),('8537','2013-04-25','10:55:00',4.32),('8537','2013-04-25','11:00:00',4.44),('8537','2013-04-25','11:05:00',4.49),('8537','2013-04-25','11:10:00',4.53),('8537','2013-04-25','11:15:00',4.56),('8537','2013-04-25','11:20:00',4.6),('8537','2013-04-25','11:25:00',4.64),('8537','2013-04-25','11:30:00',4.65),('8537','2013-04-25','11:35:00',4.73),('8537','2013-04-25','11:40:00',4.78),('8537','2013-04-25','11:45:00',4.82),('8537','2013-04-25','11:50:00',4.84),('8537','2013-04-25','11:55:00',4.75),('8537','2013-04-25','12:00:00',4.68),('8537','2013-04-25','12:05:00',4.68),('8537','2013-04-25','12:10:00',4.8),('8537','2013-04-25','12:15:00',4.84),('8537','2013-04-25','12:20:00',4.87),('8537','2013-04-25','12:25:00',4.85),('8537','2013-04-25','12:30:00',4.88),('8537','2013-04-25','12:35:00',4.92),('8537','2013-04-25','12:40:00',4.89),('8537','2013-04-25','12:45:00',4.94),('8537','2013-04-25','12:50:00',4.93),('8537','2013-04-25','12:55:00',4.95),('8537','2013-04-25','13:00:00',5),('8537','2013-04-25','13:05:00',5.05),('8537','2013-04-25','13:10:00',4.84),('8537','2013-04-25','13:15:00',4.37),('8537','2013-04-25','13:20:00',4.48),('8537','2013-04-25','13:25:00',4.42),('8537','2013-04-25','13:30:00',3.37),('8537','2013-04-25','13:35:00',3.23),('8537','2013-04-25','13:40:00',2.79),('8537','2013-04-25','13:45:00',2.57),('8537','2013-04-25','13:50:00',2.42),('8537','2013-04-25','13:55:00',2.58),('8537','2013-04-25','14:00:00',2.63),('8537','2013-04-25','14:05:00',2.46),('8537','2013-04-25','14:10:00',2.69),('8537','2013-04-25','14:15:00',2.79),('8537','2013-04-25','14:20:00',2.84),('8537','2013-04-25','14:25:00',2.91),('8537','2013-04-25','14:30:00',3.38),('8537','2013-04-25','14:35:00',4.1),('8537','2013-04-25','14:40:00',3.91),('8537','2013-04-25','14:45:00',3.89),('8537','2013-04-25','14:50:00',3.68),('8537','2013-04-25','14:55:00',3.79),('8537','2013-04-25','15:00:00',3.68),('8537','2013-04-25','15:05:00',3.35),('8537','2013-04-25','15:10:00',3.29),('8537','2013-04-25','15:15:00',3.71),('8537','2013-04-25','15:20:00',3.92),('8537','2013-04-25','15:25:00',4.05),('8537','2013-04-25','15:30:00',3.86),('8537','2013-04-25','15:35:00',3.72),('8537','2013-04-25','15:40:00',3.47),('8537','2013-04-25','15:45:00',3.25),('8537','2013-04-25','15:50:00',3.04),('8537','2013-04-25','15:55:00',2.95),('8537','2013-04-25','16:00:00',3.04),('8537','2013-04-25','16:05:00',2.49),('8537','2013-04-25','16:10:00',2.5),('8537','2013-04-25','16:15:00',2.34),('8537','2013-04-25','16:20:00',2.5),('8537','2013-04-25','16:25:00',2.2),('8537','2013-04-25','16:30:00',2.11),('8537','2013-04-25','16:35:00',2.62),('8537','2013-04-25','16:40:00',2.27),('8537','2013-04-25','16:45:00',2.27),('8537','2013-04-25','16:50:00',1.95),('8537','2013-04-25','16:55:00',2.07),('8537','2013-04-25','17:00:00',1.92),('8537','2013-04-25','17:05:00',2.21),('8537','2013-04-25','17:10:00',2.29),('8537','2013-04-25','17:15:00',2.07),('8537','2013-04-25','17:20:00',2.19),('8537','2013-04-25','17:25:00',1.85),('8537','2013-04-25','17:30:00',1.45),('8537','2013-04-25','17:35:00',1.38),('8537','2013-04-25','17:40:00',1.39),('8537','2013-04-25','17:45:00',1.2),('8537','2013-04-25','17:50:00',1.04),('8537','2013-04-24','07:50:00',1.06),('8537','2013-04-24','07:55:00',1.19),('8537','2013-04-24','08:00:00',1.28),('8537','2013-04-24','08:05:00',1.33),('8537','2013-04-24','08:10:00',1.52),('8537','2013-04-24','08:15:00',1.74),('8537','2013-04-24','08:20:00',1.84),('8537','2013-04-24','08:25:00',2),('8537','2013-04-24','08:30:00',1.99),('8537','2013-04-24','08:35:00',1.93),('8537','2013-04-24','08:40:00',2.01),('8537','2013-04-24','08:45:00',2.08),('8537','2013-04-24','08:50:00',2.19),('8537','2013-04-24','08:55:00',2.31),('8537','2013-04-24','09:00:00',2.56),('8537','2013-04-24','09:05:00',2.79),('8537','2013-04-24','09:10:00',2.84),('8537','2013-04-24','09:15:00',2.74),('8537','2013-04-24','09:20:00',2.32),('8537','2013-04-24','09:25:00',2.81),('8537','2013-04-24','09:30:00',3.25),('8537','2013-04-24','09:35:00',3.4),('8537','2013-04-24','09:40:00',3.14),('8537','2013-04-24','09:45:00',3.03),('8537','2013-04-24','09:50:00',3.33),('8537','2013-04-24','09:55:00',3.75),('8537','2013-04-24','10:00:00',3.85),('8537','2013-04-24','10:05:00',3.97),('8537','2013-04-24','10:10:00',4.01),('8537','2013-04-24','10:15:00',4),('8537','2013-04-24','10:20:00',3.93),('8537','2013-04-24','10:25:00',3.94),('8537','2013-04-24','10:30:00',3.9),('8537','2013-04-24','10:35:00',3.88),('8537','2013-04-24','10:40:00',4.28),('8537','2013-04-24','10:45:00',4.35),('8537','2013-04-24','10:50:00',4.39),('8537','2013-04-24','10:55:00',4.52),('8537','2013-04-24','11:00:00',4.59),('8537','2013-04-24','11:05:00',4.47),('8537','2013-04-24','11:10:00',4.79),('8537','2013-04-24','11:15:00',4.9),('8537','2013-04-24','11:20:00',5.04),('8537','2013-04-24','11:25:00',5.11),('8537','2013-04-24','11:30:00',4.95),('8537','2013-04-24','11:35:00',4.22),('8537','2013-04-24','11:40:00',3.11),('8537','2013-04-24','11:45:00',3.5),('8537','2013-04-24','11:50:00',2.42),('8537','2013-04-24','11:55:00',3.39),('8537','2013-04-24','12:00:00',4.27),('8537','2013-04-24','12:05:00',2.8),('8537','2013-04-24','12:10:00',3.32),('8537','2013-04-24','12:15:00',4.65),('8537','2013-04-24','12:20:00',5.49),('8537','2013-04-24','12:25:00',4.75),('8537','2013-04-24','12:30:00',4.63),('8537','2013-04-24','12:35:00',4.72),('8537','2013-04-24','12:40:00',4.43),('8537','2013-04-24','12:45:00',4.64),('8537','2013-04-24','12:50:00',4.96),('8537','2013-04-24','12:55:00',4.81),('8537','2013-04-24','13:00:00',4.66),('8537','2013-04-24','13:05:00',4.05),('8537','2013-04-24','13:10:00',5.27),('8537','2013-04-24','13:15:00',4.86),('8537','2013-04-24','13:20:00',4.59),('8537','2013-04-24','13:25:00',4.76),('8537','2013-04-24','13:30:00',4.43),('8537','2013-04-24','13:35:00',4.63),('8537','2013-04-24','13:40:00',5.2),('8537','2013-04-24','13:45:00',4.43),('8537','2013-04-24','13:50:00',3.15),('8537','2013-04-24','13:55:00',4.91),('8537','2013-04-24','14:00:00',4.88),('8537','2013-04-24','14:05:00',3.46),('8537','2013-04-24','14:10:00',3.38),('8537','2013-04-24','14:15:00',4.91),('8537','2013-04-24','14:20:00',4.43),('8537','2013-04-24','14:25:00',4.56),('8537','2013-04-24','14:30:00',4.3),('8537','2013-04-24','14:35:00',3.75),('8537','2013-04-24','14:40:00',3.59),('8537','2013-04-24','14:45:00',3.47),('8537','2013-04-24','14:50:00',3.08),('8537','2013-04-24','14:55:00',2.73),('8537','2013-04-24','15:00:00',3.01),('8537','2013-04-24','15:05:00',2.73),('8537','2013-04-24','15:10:00',2.56),('8537','2013-04-24','15:15:00',2.71),('8537','2013-04-24','15:20:00',2.86),('8537','2013-04-24','15:25:00',2.41),('8537','2013-04-24','15:30:00',2.06),('8537','2013-04-24','15:35:00',2),('8537','2013-04-24','15:40:00',1.97),('8537','2013-04-24','15:45:00',1.98),('8537','2013-04-24','15:50:00',2.01),('8537','2013-04-24','15:55:00',2.33),('8537','2013-04-24','16:00:00',2.75),('8537','2013-04-24','16:05:00',2.9),('8537','2013-04-24','16:10:00',3.07),('8537','2013-04-24','16:15:00',2.74),('8537','2013-04-24','16:20:00',3.29),('8537','2013-04-24','16:25:00',2.79),('8537','2013-04-24','16:30:00',2.43),('8537','2013-04-24','16:35:00',2.02),('8537','2013-04-24','16:40:00',2.78),('8537','2013-04-24','16:45:00',2.8),('8537','2013-04-24','16:50:00',2.47),('8537','2013-04-24','16:55:00',2.96),('8537','2013-04-24','17:00:00',2.97),('8537','2013-04-24','17:05:00',2.72),('8537','2013-04-24','17:10:00',2.57),('8537','2013-04-24','17:15:00',1.91),('8537','2013-04-24','17:20:00',1.74),('8537','2013-04-24','17:25:00',1.69),('8537','2013-04-24','17:50:00',1.02),('8537','2013-04-24','17:55:00',1.37),('8537','2013-04-24','18:00:00',1.07),('8537','2013-04-24','18:05:00',1.08),('8537','2013-04-23','07:45:00',1.09),('8537','2013-04-23','07:50:00',1.2),('8537','2013-04-23','07:55:00',1.32),('8537','2013-04-23','08:00:00',1.43),('8537','2013-04-23','08:05:00',1.54),('8537','2013-04-23','08:10:00',1.66),('8537','2013-04-23','08:15:00',1.77),('8537','2013-04-23','08:20:00',1.89),('8537','2013-04-23','08:25:00',2.01),('8537','2013-04-23','08:30:00',2.09),('8537','2013-04-23','08:35:00',2.26),('8537','2013-04-23','08:40:00',2.37),('8537','2013-04-23','08:45:00',2.47),('8537','2013-04-23','08:50:00',2.58),('8537','2013-04-23','08:55:00',2.69),('8537','2013-04-23','09:00:00',2.8),('8537','2013-04-23','09:05:00',2.91),('8537','2013-04-23','09:10:00',3.02),('8537','2013-04-23','09:15:00',3.13),('8537','2013-04-23','09:20:00',3.24),('8537','2013-04-23','09:25:00',3.33),('8537','2013-04-23','09:30:00',3.4),('8537','2013-04-23','09:35:00',3.5),('8537','2013-04-23','09:40:00',3.29),('8537','2013-04-23','09:45:00',3.2),('8537','2013-04-23','09:50:00',3.83),('8537','2013-04-23','09:55:00',3.89),('8537','2013-04-23','10:00:00',3.93),('8537','2013-04-23','10:05:00',3.99),('8537','2013-04-23','10:10:00',4.07),('8537','2013-04-23','10:15:00',4.11),('8537','2013-04-23','10:20:00',4.22),('8537','2013-04-23','10:25:00',4.29),('8537','2013-04-23','10:30:00',4.34),('8537','2013-04-23','10:35:00',4.41),('8537','2013-04-23','10:40:00',4.49),('8537','2013-04-23','10:45:00',4.43),('8537','2013-04-23','10:50:00',4.54),('8537','2013-04-23','10:55:00',4.62),('8537','2013-04-23','11:00:00',4.64),('8537','2013-04-23','11:05:00',4.68),('8537','2013-04-23','11:10:00',4.73),('8537','2013-04-23','11:15:00',4.77),('8537','2013-04-23','11:20:00',4.81),('8537','2013-04-23','11:25:00',4.85),('8537','2013-04-23','11:30:00',4.85),('8537','2013-04-23','11:35:00',4.88),('8537','2013-04-23','11:40:00',4.86),('8537','2013-04-23','11:45:00',4.95),('8537','2013-04-23','11:50:00',5.02),('8537','2013-04-23','11:55:00',5.01),('8537','2013-04-23','12:00:00',4.96),('8537','2013-04-23','12:05:00',4.88),('8537','2013-04-23','12:10:00',4.91),('8537','2013-04-23','12:15:00',4.89),('8537','2013-04-23','12:20:00',4.92),('8537','2013-04-23','12:25:00',4.99),('8537','2013-04-23','12:30:00',3.41),('8537','2013-04-23','12:35:00',4.19),('8537','2013-04-23','12:40:00',4.97),('8537','2013-04-23','12:45:00',2.33),('8537','2013-04-23','12:50:00',3.04),('8537','2013-04-23','12:55:00',3.34),('8537','2013-04-23','13:00:00',3.07),('8537','2013-04-23','13:05:00',3.67),('8537','2013-04-23','13:10:00',1.87),('8537','2013-04-23','13:15:00',4.31),('8537','2013-04-23','13:20:00',5.55),('8537','2013-04-23','13:25:00',5.4),('8537','2013-04-23','13:30:00',5.17),('8537','2013-04-23','13:35:00',5.26),('8537','2013-04-23','13:40:00',5.3),('8537','2013-04-23','13:45:00',3.62),('8537','2013-04-23','13:50:00',4.59),('8537','2013-04-23','13:55:00',5.06),('8537','2013-04-23','14:00:00',2.31),('8537','2013-04-23','14:05:00',5.47),('8537','2013-04-23','14:10:00',3.06),('8537','2013-04-23','14:15:00',4.72),('8537','2013-04-23','14:20:00',4.63),('8537','2013-04-23','14:25:00',4.24),('8537','2013-04-23','14:30:00',4.83),('8537','2013-04-23','14:35:00',4.77),('8537','2013-04-23','14:40:00',4.72),('8537','2013-04-23','14:45:00',3.92),('8537','2013-04-23','14:50:00',2.5),('8537','2013-04-23','14:55:00',2.73),('8537','2013-04-23','15:00:00',2.66),('8537','2013-04-23','15:05:00',2.78),('8537','2013-04-23','15:10:00',3.07),('8537','2013-04-23','15:15:00',3.12),('8537','2013-04-23','15:20:00',3.14),('8537','2013-04-23','15:25:00',2.86),('8537','2013-04-23','15:30:00',2.8),('8537','2013-04-23','15:35:00',2.61),('8537','2013-04-23','15:40:00',2.3),('8537','2013-04-23','15:45:00',2.63),('8537','2013-04-23','15:50:00',2.16),('8537','2013-04-23','15:55:00',1.87),('8537','2013-04-23','16:00:00',2.03),('8537','2013-04-23','16:05:00',1.97),('8537','2013-04-23','16:10:00',1.93),('8537','2013-04-23','16:15:00',1.97),('8537','2013-04-23','16:20:00',1.44),('8537','2013-04-23','16:25:00',1.43),('8537','2013-04-23','16:30:00',1.32),('8537','2013-04-23','16:35:00',1.3),('8537','2013-04-23','16:40:00',1.34),('8537','2013-04-23','16:45:00',1.32),('8537','2013-04-23','16:50:00',1.17),('8537','2013-04-23','16:55:00',1.19),('8537','2013-04-23','17:00:00',1.22),('8537','2013-04-23','17:05:00',1.27),('8537','2013-04-23','17:10:00',1.7),('8537','2013-04-23','17:15:00',2.01),('8537','2013-04-23','17:20:00',1.17),('8537','2013-04-23','17:25:00',1.52),('8537','2013-04-23','17:30:00',1.36),('8537','2013-04-23','17:35:00',1.19),('8537','2013-04-23','17:40:00',1.23),('8537','2013-04-23','17:45:00',1.14),('8537','2013-04-23','17:50:00',1.02),('8537','2013-04-22','09:30:00',1.29),('8537','2013-04-22','09:35:00',1.16),('8537','2013-04-22','10:35:00',2.59),('8537','2013-04-22','10:40:00',4.22),('8537','2013-04-22','10:45:00',5.79),('8537','2013-04-22','10:50:00',2.56),('8537','2013-04-22','10:55:00',2.6),('8537','2013-04-22','11:00:00',2.43),('8537','2013-04-22','11:05:00',2.26),('8537','2013-04-22','11:10:00',2.71),('8537','2013-04-22','11:15:00',1.67),('8537','2013-04-22','11:20:00',1.7),('8537','2013-04-22','11:25:00',2.2),('8537','2013-04-22','11:30:00',3.55),('8537','2013-04-22','11:35:00',4.49),('8537','2013-04-22','11:40:00',4.79),('8537','2013-04-22','11:45:00',2.39),('8537','2013-04-22','11:50:00',1.98),('8537','2013-04-22','11:55:00',4.41),('8537','2013-04-22','12:00:00',4.21),('8537','2013-04-22','12:05:00',3.72),('8537','2013-04-22','12:10:00',4.19),('8537','2013-04-22','12:15:00',3.69),('8537','2013-04-22','12:20:00',3.66),('8537','2013-04-22','12:25:00',3.23),('8537','2013-04-22','12:30:00',2.51),('8537','2013-04-22','12:35:00',2.75),('8537','2013-04-22','12:40:00',5.5),('8537','2013-04-22','12:45:00',4.99),('8537','2013-04-22','12:50:00',5.6),('8537','2013-04-22','12:55:00',5.64),('8537','2013-04-22','13:00:00',5.65),('8537','2013-04-22','13:05:00',4.68),('8537','2013-04-22','13:10:00',4.58),('8537','2013-04-22','13:15:00',4.65),('8537','2013-04-22','13:20:00',3.45),('8537','2013-04-22','13:25:00',2.6),('8537','2013-04-22','13:30:00',2.86),('8537','2013-04-22','13:35:00',3.13),('8537','2013-04-22','13:40:00',2.34),('8537','2013-04-22','13:45:00',4.5),('8537','2013-04-22','13:50:00',1.31),('8537','2013-04-22','13:55:00',3.11),('8537','2013-04-22','14:00:00',1.41),('8537','2013-04-22','14:05:00',1.63),('8537','2013-04-22','14:10:00',2.35),('8537','2013-04-22','14:15:00',2.13),('8537','2013-04-22','14:20:00',5.27),('8537','2013-04-22','14:25:00',3.07),('8537','2013-04-22','14:30:00',5.95),('8537','2013-04-22','14:35:00',3.03),('8537','2013-04-22','14:40:00',5.43),('8537','2013-04-22','14:45:00',5.19),('8537','2013-04-22','14:50:00',5.2),('8537','2013-04-22','14:55:00',4.66),('8537','2013-04-22','15:00:00',3.27),('8537','2013-04-22','15:05:00',2.69),('8537','2013-04-22','15:10:00',2.22),('8537','2013-04-22','15:15:00',1.06),('8537','2013-04-22','15:20:00',1.12),('8537','2013-04-22','15:25:00',2.97),('8537','2013-04-22','15:30:00',1.81),('8537','2013-04-22','15:35:00',1.2),('8537','2013-04-22','15:40:00',2.25),('8537','2013-04-22','15:45:00',4.68),('8537','2013-04-22','15:50:00',3),('8537','2013-04-22','15:55:00',1.45),('8537','2013-04-22','16:45:00',1.65),('8537','2013-04-22','17:35:00',1.07),('8537','2014-03-29','07:15:00',1.1),('8537','2014-03-29','07:20:00',1.21),('8537','2014-03-29','07:25:00',1.31),('8537','2014-03-29','07:30:00',1.43),('8537','2014-03-29','07:35:00',1.53),('8537','2014-03-29','07:40:00',1.68),('8537','2014-03-29','07:45:00',1.79),('8537','2014-03-29','07:50:00',1.91),('8537','2014-03-29','07:55:00',2.02),('8537','2014-03-29','08:00:00',2.14),('8537','2014-03-29','08:05:00',2.28),('8537','2014-03-29','08:10:00',2.39),('8537','2014-03-29','08:15:00',2.48),('8537','2014-03-29','08:20:00',2.54),('8537','2014-03-29','08:25:00',2.7),('8537','2014-03-29','08:30:00',2.78),('8537','2014-03-29','08:35:00',2.88),('8537','2014-03-29','08:40:00',2.96),('8537','2014-03-29','08:45:00',3.05),('8537','2014-03-29','08:50:00',3.15),('8537','2014-03-29','08:55:00',3.2),('8537','2014-03-29','09:00:00',3.26),('8537','2014-03-29','09:05:00',3.34),('8537','2014-03-29','09:10:00',3.44),('8537','2014-03-29','09:15:00',3.55),('8537','2014-03-29','09:20:00',3.65),('8537','2014-03-29','09:25:00',3.73),('8537','2014-03-29','09:30:00',3.77),('8537','2014-03-29','09:35:00',3.84),('8537','2014-03-29','09:40:00',3.95),('8537','2014-03-29','09:45:00',3.98),('8537','2014-03-29','09:50:00',4.09),('8537','2014-03-29','09:55:00',4.18),('8537','2014-03-29','10:00:00',4.27),('8537','2014-03-29','10:05:00',4.31),('8537','2014-03-29','10:10:00',4.44),('8537','2014-03-29','10:15:00',4.51),('8537','2014-03-29','10:20:00',4.54),('8537','2014-03-29','10:25:00',4.59),('8537','2014-03-29','10:30:00',4.61),('8537','2014-03-29','10:35:00',4.64),('8537','2014-03-29','10:40:00',4.67),('8537','2014-03-29','10:45:00',4.68),('8537','2014-03-29','10:50:00',4.78),('8537','2014-03-29','10:55:00',4.83),('8537','2014-03-29','11:00:00',4.84),('8537','2014-03-29','11:05:00',4.84),('8537','2014-03-29','11:10:00',4.86),('8537','2014-03-29','11:15:00',4.9),('8537','2014-03-29','11:20:00',4.9),('8537','2014-03-29','11:25:00',4.91),('8537','2014-03-29','11:30:00',4.93),('8537','2014-03-29','11:35:00',4.87),('8537','2014-03-29','11:40:00',4.83),('8537','2014-03-29','11:45:00',5.04),('8537','2014-03-29','11:50:00',4.99),('8537','2014-03-29','11:55:00',4.94),('8537','2014-03-29','12:00:00',4.96),('8537','2014-03-29','12:05:00',4.99),('8537','2014-03-29','12:10:00',4.99),('8537','2014-03-29','12:15:00',4.97),('8537','2014-03-29','12:20:00',5.04),('8537','2014-03-29','12:25:00',5.02),('8537','2014-03-29','12:30:00',5.03),('8537','2014-03-29','12:35:00',5.02),('8537','2014-03-29','12:40:00',4.9),('8537','2014-03-29','12:45:00',4.99),('8537','2014-03-29','12:50:00',4.96),('8537','2014-03-29','12:55:00',4.92),('8537','2014-03-29','13:00:00',4.86),('8537','2014-03-29','13:05:00',4.89),('8537','2014-03-29','13:10:00',4.83),('8537','2014-03-29','13:15:00',4.82),('8537','2014-03-29','13:20:00',4.77),('8537','2014-03-29','13:25:00',4.69),('8537','2014-03-29','13:30:00',4.59),('8537','2014-03-29','13:35:00',4.26),('8537','2014-03-29','13:40:00',4.3),('8537','2014-03-29','13:45:00',4.36),('8537','2014-03-29','13:50:00',4.34),('8537','2014-03-29','13:55:00',4.3),('8537','2014-03-29','14:00:00',4.25),('8537','2014-03-29','14:05:00',4.23),('8537','2014-03-29','14:10:00',4.19),('8537','2014-03-29','14:15:00',4.08),('8537','2014-03-29','14:20:00',3.99),('8537','2014-03-29','14:25:00',3.82),('8537','2014-03-29','14:30:00',3.82),('8537','2014-03-29','14:35:00',3.34),('8537','2014-03-29','14:40:00',3.33),('8537','2014-03-29','14:45:00',3.44),('8537','2014-03-29','14:50:00',3.55),('8537','2014-03-29','14:55:00',3.57),('8537','2014-03-29','15:00:00',3.41),('8537','2014-03-29','15:05:00',3.28),('8537','2014-03-29','15:10:00',3.14),('8537','2014-03-29','15:15:00',3.13),('8537','2014-03-29','15:20:00',3.07),('8537','2014-03-29','15:25:00',2.97),('8537','2014-03-29','15:30:00',2.81),('8537','2014-03-29','15:35:00',2.6),('8537','2014-03-29','15:40:00',2.47),('8537','2014-03-29','15:45:00',2.54),('8537','2014-03-29','15:50:00',2.44),('8537','2014-03-29','15:55:00',2.29),('8537','2014-03-29','16:00:00',2.19),('8537','2014-03-29','16:05:00',2.1),('8537','2014-03-29','16:10:00',1.98),('8537','2014-03-29','16:15:00',1.88),('8537','2014-03-29','16:20:00',1.69),('8537','2014-03-29','16:25:00',1.62),('8537','2014-03-29','16:30:00',1.54),('8537','2014-03-29','16:35:00',1.38),('8537','2014-03-29','16:40:00',1.21),('8537','2014-03-29','16:50:00',1.02),('8537','2014-03-29','16:55:00',1.04),('8537','2013-04-21','08:00:00',1),('8537','2013-04-21','08:05:00',1.14),('8537','2013-04-21','08:10:00',1.24),('8537','2013-04-21','08:15:00',1.49),('8537','2013-04-21','08:20:00',1.18),('8537','2013-04-21','08:25:00',1.36),('8537','2013-04-21','08:30:00',1.25),('8537','2013-04-21','08:35:00',1.51),('8537','2013-04-21','08:40:00',1.73),('8537','2013-04-21','08:45:00',1.62),('8537','2013-04-21','08:50:00',1.6),('8537','2013-04-21','08:55:00',2.36),('8537','2013-04-21','09:00:00',2.25),('8537','2013-04-21','09:05:00',2.21),('8537','2013-04-21','09:10:00',2.91),('8537','2013-04-21','09:15:00',2.66),('8537','2013-04-21','09:20:00',1.98),('8537','2013-04-21','09:25:00',2.41),('8537','2013-04-21','09:30:00',3.57),('8537','2013-04-21','09:35:00',3.67),('8537','2013-04-21','09:40:00',3.73),('8537','2013-04-21','09:45:00',3.98),('8537','2013-04-21','09:50:00',4.54),('8537','2013-04-21','09:55:00',3.93),('8537','2013-04-21','10:00:00',3.6),('8537','2013-04-21','10:05:00',2.84),('8537','2013-04-21','10:10:00',2.35),('8537','2013-04-21','10:15:00',2.16),('8537','2013-04-21','10:20:00',3.83),('8537','2013-04-21','10:25:00',3.43),('8537','2013-04-21','10:30:00',3.46),('8537','2013-04-21','10:35:00',2.39),('8537','2013-04-21','10:40:00',3.3),('8537','2013-04-21','10:45:00',3.51),('8537','2013-04-21','10:50:00',4.77),('8537','2013-04-21','10:55:00',3.37),('8537','2013-04-21','11:00:00',4.8),('8537','2013-04-21','11:05:00',3.87),('8537','2013-04-21','11:10:00',4.59),('8537','2013-04-21','11:15:00',3.53),('8537','2013-04-21','11:20:00',3.7),('8537','2013-04-21','11:25:00',3.75),('8537','2013-04-21','11:30:00',3.34),('8537','2013-04-21','11:35:00',3.34),('8537','2013-04-21','11:40:00',3.67),('8537','2013-04-21','11:45:00',4.1),('8537','2013-04-21','11:50:00',3.62),('8537','2013-04-21','11:55:00',3.81),('8537','2013-04-21','12:00:00',2.88),('8537','2013-04-21','12:05:00',2.98),('8537','2013-04-21','12:10:00',2.97),('8537','2013-04-21','12:15:00',2.66),('8537','2013-04-21','12:20:00',2.41),('8537','2013-04-21','12:25:00',2.32),('8537','2013-04-21','12:30:00',2.55),('8537','2013-04-21','12:35:00',2.6),('8537','2013-04-21','12:40:00',2.6),('8537','2013-04-21','12:45:00',2.61),('8537','2013-04-21','12:50:00',2.43),('8537','2013-04-21','12:55:00',2.37),('8537','2013-04-21','13:00:00',2.72),('8537','2013-04-21','13:05:00',3.14),('8537','2013-04-21','13:10:00',3.26),('8537','2013-04-21','13:15:00',2.97),('8537','2013-04-21','13:20:00',2.8),('8537','2013-04-21','13:25:00',2.68),('8537','2013-04-21','13:30:00',4.05),('8537','2013-04-21','13:35:00',2.85),('8537','2013-04-21','13:40:00',3.44),('8537','2013-04-21','13:45:00',3.54),('8537','2013-04-21','13:50:00',3.12),('8537','2013-04-21','13:55:00',4.65),('8537','2013-04-21','14:00:00',5.56),('8537','2013-04-21','14:05:00',4.86),('8537','2013-04-21','14:10:00',4.91),('8537','2013-04-21','14:15:00',4.28),('8537','2013-04-21','14:20:00',5.88),('8537','2013-04-21','14:25:00',4.57),('8537','2013-04-21','14:30:00',4.8),('8537','2013-04-21','14:35:00',5.1),('8537','2013-04-21','14:40:00',5.41),('8537','2013-04-21','14:45:00',4.5),('8537','2013-04-21','14:50:00',2.56),('8537','2013-04-21','14:55:00',2.44),('8537','2013-04-21','15:00:00',3.05),('8537','2013-04-21','15:05:00',4.94),('8537','2013-04-21','15:10:00',4.97),('8537','2013-04-21','15:15:00',3.67),('8537','2013-04-21','15:20:00',2.51),('8537','2013-04-21','15:25:00',2.32),('8537','2013-04-21','15:30:00',2.04),('8537','2013-04-21','15:35:00',1.7),('8537','2013-04-21','15:40:00',1.77),('8537','2013-04-21','15:45:00',1.47),('8537','2013-04-21','15:50:00',1.24),('8537','2013-04-21','15:55:00',1.12),('8537','2013-04-21','16:00:00',1),('8537','2013-04-21','17:00:00',1.05),('8537','2013-04-21','17:05:00',1.05),('8537','2013-04-20','07:35:00',1.01),('8537','2013-04-20','07:40:00',1.08),('8537','2013-04-20','07:55:00',1.11),('8537','2013-04-20','08:00:00',1.26),('8537','2013-04-20','08:05:00',1.41),('8537','2013-04-20','08:10:00',1.57),('8537','2013-04-20','08:15:00',1.45),('8537','2013-04-20','08:20:00',1.41),('8537','2013-04-20','08:25:00',1.56),('8537','2013-04-20','08:30:00',1.81),('8537','2013-04-20','08:35:00',2),('8537','2013-04-20','08:40:00',2.15),('8537','2013-04-20','08:45:00',2.25),('8537','2013-04-20','08:50:00',2.24),('8537','2013-04-20','08:55:00',2.15),('8537','2013-04-20','09:00:00',2.63),('8537','2013-04-20','09:05:00',2.75),('8537','2013-04-20','09:10:00',2.72),('8537','2013-04-20','09:15:00',2.74),('8537','2013-04-20','09:20:00',3.14),('8537','2013-04-20','09:25:00',2.86),('8537','2013-04-20','09:30:00',2.53),('8537','2013-04-20','09:35:00',1.64),('8537','2013-04-20','09:40:00',1.3),('8537','2013-04-20','09:45:00',1.41),('8537','2013-04-20','09:50:00',1.4),('8537','2013-04-20','10:40:00',1.84),('8537','2013-04-20','10:45:00',4.02),('8537','2013-04-20','10:50:00',3.31),('8537','2013-04-20','10:55:00',2.22),('8537','2013-04-20','11:00:00',3.4),('8537','2013-04-20','11:05:00',2.85),('8537','2013-04-20','11:10:00',4.37),('8537','2013-04-20','11:15:00',5.31),('8537','2013-04-20','11:20:00',2.96),('8537','2013-04-20','11:25:00',3.73),('8537','2013-04-20','11:30:00',5.34),('8537','2013-04-20','11:35:00',3.26),('8537','2013-04-20','11:40:00',1.98),('8537','2013-04-20','11:45:00',3.19),('8537','2013-04-20','11:50:00',5.54),('8537','2013-04-20','11:55:00',5.47),('8537','2013-04-20','12:00:00',5.34),('8537','2013-04-20','12:05:00',4.73),('8537','2013-04-20','12:10:00',5.25),('8537','2013-04-20','12:15:00',3),('8537','2013-04-20','12:20:00',5.35),('8537','2013-04-20','12:25:00',2.76),('8537','2013-04-20','12:30:00',5.02),('8537','2013-04-20','12:35:00',3.31),('8537','2013-04-20','12:40:00',3.47),('8537','2013-04-20','12:45:00',5.73),('8537','2013-04-20','12:50:00',5.39),('8537','2013-04-20','12:55:00',5.18),('8537','2013-04-20','13:00:00',4.62),('8537','2013-04-20','13:05:00',3.05),('8537','2013-04-20','13:10:00',5.51),('8537','2013-04-20','13:15:00',4.38),('8537','2013-04-20','13:20:00',2.72),('8537','2013-04-20','13:25:00',5.52),('8537','2013-04-20','13:30:00',3.29),('8537','2013-04-20','13:35:00',2.18),('8537','2013-04-20','13:40:00',4.89),('8537','2013-04-20','13:45:00',3.12),('8537','2013-04-20','13:50:00',3.16),('8537','2013-04-20','13:55:00',3.85),('8537','2013-04-20','14:00:00',2.98),('8537','2013-04-20','14:05:00',5.41),('8537','2013-04-20','14:10:00',4.58),('8537','2013-04-20','14:15:00',5.01),('8537','2013-04-20','14:20:00',4.88),('8537','2013-04-20','14:25:00',4.84),('8537','2013-04-20','14:30:00',4.69),('8537','2013-04-20','14:35:00',4.45),('8537','2013-04-20','14:40:00',4.14),('8537','2013-04-20','14:45:00',4.27),('8537','2013-04-20','14:50:00',4.66),('8537','2013-04-20','14:55:00',4.65),('8537','2013-04-20','15:00:00',4.59),('8537','2013-04-20','15:05:00',4.51),('8537','2013-04-20','15:10:00',2.64),('8537','2013-04-20','15:15:00',3.31),('8537','2013-04-20','15:20:00',2.74),('8537','2013-04-20','15:25:00',3.84),('8537','2013-04-20','15:30:00',2.28),('8537','2013-04-20','15:35:00',1.04),('8537','2013-04-20','16:05:00',1.21),('8537','2013-04-20','16:10:00',1.67),('8537','2013-04-20','16:15:00',2.37),('8537','2013-04-20','16:20:00',2.38),('8537','2013-04-20','16:25:00',2.97),('8537','2013-04-20','16:30:00',3.08),('8537','2013-04-20','16:35:00',2.95),('8537','2013-04-20','16:40:00',3.26),('8537','2013-04-20','16:45:00',3.3),('8537','2013-04-20','16:50:00',3),('8537','2013-04-20','16:55:00',2.85),('8537','2013-04-20','17:00:00',2.69),('8537','2013-04-20','17:05:00',2.46),('8537','2013-04-20','17:10:00',2.35),('8537','2013-04-20','17:15:00',2.12),('8537','2013-04-20','17:20:00',1.9),('8537','2013-04-20','17:25:00',2.03),('8537','2013-04-20','17:30:00',2.15),('8537','2013-04-20','17:35:00',2.04),('8537','2013-04-20','17:40:00',1.91),('8537','2013-04-20','17:55:00',1.41),('8537','2013-04-20','18:00:00',1.19),('8537','2013-04-20','18:05:00',1.29),('8537','2013-04-20','18:10:00',1.24),('8537','2013-04-19','08:00:00',1.02),('8537','2013-04-19','08:05:00',1.35),('8537','2013-04-19','08:15:00',1.08),('8537','2013-04-19','08:20:00',1.68),('8537','2013-04-19','08:25:00',1.77),('8537','2013-04-19','08:30:00',1.71),('8537','2013-04-19','08:35:00',1.93),('8537','2013-04-19','08:40:00',2.15),('8537','2013-04-19','08:45:00',2.25),('8537','2013-04-19','08:50:00',2.37),('8537','2013-04-19','08:55:00',2.48),('8537','2013-04-19','09:00:00',2.59),('8537','2013-04-19','09:05:00',2.65),('8537','2013-04-19','09:10:00',2.74),('8537','2013-04-19','09:15:00',2.81),('8537','2013-04-19','09:20:00',2.92),('8537','2013-04-19','09:25:00',2.99),('8537','2013-04-19','09:30:00',3.1),('8537','2013-04-19','09:35:00',3.23),('8537','2013-04-19','09:40:00',3.31),('8537','2013-04-19','09:45:00',3.39),('8537','2013-04-19','09:50:00',3.41),('8537','2013-04-19','09:55:00',3.44),('8537','2013-04-19','10:00:00',3.5),('8537','2013-04-19','10:05:00',3.63),('8537','2013-04-19','10:10:00',3.68),('8537','2013-04-19','10:15:00',3.82),('8537','2013-04-19','10:20:00',3.63),('8537','2013-04-19','10:25:00',3.63),('8537','2013-04-19','10:30:00',3.48),('8537','2013-04-19','10:35:00',2.67),('8537','2013-04-19','10:40:00',4.12),('8537','2013-04-19','10:45:00',4.13),('8537','2013-04-19','10:50:00',4.14),('8537','2013-04-19','10:55:00',4.17),('8537','2013-04-19','11:00:00',4.22),('8537','2013-04-19','11:05:00',4.3),('8537','2013-04-19','11:10:00',4.31),('8537','2013-04-19','11:15:00',4.35),('8537','2013-04-19','11:20:00',4.4),('8537','2013-04-19','11:25:00',4.4),('8537','2013-04-19','11:30:00',4.43),('8537','2013-04-19','11:35:00',4.49),('8537','2013-04-19','11:40:00',4.56),('8537','2013-04-19','11:45:00',4.64),('8537','2013-04-19','11:50:00',4.68),('8537','2013-04-19','11:55:00',4.69),('8537','2013-04-19','12:00:00',4.67),('8537','2013-04-19','12:05:00',4.65),('8537','2013-04-19','12:10:00',4.68),('8537','2013-04-19','12:15:00',4.71),('8537','2013-04-19','12:20:00',4.78),('8537','2013-04-19','12:25:00',4.78),('8537','2013-04-19','12:30:00',4.73),('8537','2013-04-19','12:35:00',4.83),('8537','2013-04-19','12:40:00',4.84),('8537','2013-04-19','12:45:00',4.84),('8537','2013-04-19','12:50:00',4.71),('8537','2013-04-19','12:55:00',4.81),('8537','2013-04-19','13:00:00',4.87),('8537','2013-04-19','13:05:00',4.86),('8537','2013-04-19','13:10:00',4.92),('8537','2013-04-19','13:15:00',4.96),('8537','2013-04-19','13:20:00',4.86),('8537','2013-04-19','13:25:00',4.91),('8537','2013-04-19','13:30:00',4.97),('8537','2013-04-19','13:35:00',4.76),('8537','2013-04-19','13:40:00',4.84),('8537','2013-04-19','13:45:00',4.81),('8537','2013-04-19','13:50:00',4.76),('8537','2013-04-19','13:55:00',4.75),('8537','2013-04-19','14:00:00',4.71),('8537','2013-04-19','14:05:00',4.63),('8537','2013-04-19','14:10:00',4.7),('8537','2013-04-19','14:15:00',4.62),('8537','2013-04-19','14:20:00',4.61),('8537','2013-04-19','14:25:00',4.6),('8537','2013-04-19','14:30:00',4.47),('8537','2013-04-19','14:35:00',4.34),('8537','2013-04-19','14:40:00',4.39),('8537','2013-04-19','14:45:00',4.36),('8537','2013-04-19','14:50:00',4.33),('8537','2013-04-19','14:55:00',4.27),('8537','2013-04-19','15:00:00',4.21),('8537','2013-04-19','15:05:00',4.15),('8537','2013-04-19','15:10:00',4.1),('8537','2013-04-19','15:15:00',4.09),('8537','2013-04-19','15:20:00',3.97),('8537','2013-04-19','15:25:00',3.92),('8537','2013-04-19','15:30:00',3.69),('8537','2013-04-19','15:35:00',3.82),('8537','2013-04-19','15:40:00',3.71),('8537','2013-04-19','15:45:00',3.68),('8537','2013-04-19','15:50:00',3.6),('8537','2013-04-19','15:55:00',3.57),('8537','2013-04-19','16:00:00',3.51),('8537','2013-04-19','16:05:00',3.37),('8537','2013-04-19','16:10:00',3.26),('8537','2013-04-19','16:15:00',3.17),('8537','2013-04-19','16:20:00',3.09),('8537','2013-04-19','16:25:00',3.05),('8537','2013-04-19','16:30:00',2.94),('8537','2013-04-19','16:35:00',2.8),('8537','2013-04-19','16:40:00',2.76),('8537','2013-04-19','16:45:00',2.44),('8537','2013-04-19','16:50:00',2.09),('8537','2013-04-19','16:55:00',2.44),('8537','2013-04-19','17:00:00',2.35),('8537','2013-04-19','17:05:00',2.2),('8537','2013-04-19','17:10:00',2.07),('8537','2013-04-19','17:15:00',1.99),('8537','2013-04-19','17:20:00',1.89),('8537','2013-04-19','17:25:00',1.78),('8537','2013-04-19','17:30:00',1.69),('8537','2013-04-19','17:35:00',1.56),('8537','2013-04-19','17:40:00',1.47),('8537','2013-04-19','17:45:00',1.37),('8537','2013-04-19','17:50:00',1.24),('8537','2013-04-19','17:55:00',1.15),('8537','2013-04-19','18:00:00',1.07),('8537','2013-04-18','08:05:00',1.01),('8537','2013-04-18','08:10:00',1.29),('8537','2013-04-18','08:15:00',1.44),('8537','2013-04-18','08:20:00',1.46),('8537','2013-04-18','08:25:00',1.48),('8537','2013-04-18','08:30:00',1.67),('8537','2013-04-18','08:35:00',1.75),('8537','2013-04-18','08:40:00',1.72),('8537','2013-04-18','08:45:00',1.78),('8537','2013-04-18','08:50:00',1.96),('8537','2013-04-18','08:55:00',2.26),('8537','2013-04-18','09:00:00',2.11),('8537','2013-04-18','09:05:00',2.5),('8537','2013-04-18','09:10:00',2.52),('8537','2013-04-18','09:15:00',2.59),('8537','2013-04-18','09:20:00',2.73),('8537','2013-04-18','09:25:00',2.82),('8537','2013-04-18','09:30:00',3),('8537','2013-04-18','09:35:00',3.16),('8537','2013-04-18','09:40:00',3.61),('8537','2013-04-18','09:45:00',3.24),('8537','2013-04-18','09:50:00',2.85),('8537','2013-04-18','09:55:00',2.86),('8537','2013-04-18','10:00:00',3.4),('8537','2013-04-18','10:05:00',3.77),('8537','2013-04-18','10:10:00',3.83),('8537','2013-04-18','10:15:00',3.94),('8537','2013-04-18','10:20:00',4.05),('8537','2013-04-18','10:25:00',4),('8537','2013-04-18','10:30:00',4.12),('8537','2013-04-18','10:35:00',4.15),('8537','2013-04-18','10:40:00',4.24),('8537','2013-04-18','10:45:00',4.32),('8537','2013-04-18','10:50:00',4.38),('8537','2013-04-18','10:55:00',4.43),('8537','2013-04-18','11:00:00',4.49),('8537','2013-04-18','11:05:00',4.53),('8537','2013-04-18','11:10:00',4.59),('8537','2013-04-18','11:15:00',4.64),('8537','2013-04-18','11:20:00',4.67),('8537','2013-04-18','11:25:00',4.67),('8537','2013-04-18','11:30:00',4.68),('8537','2013-04-18','11:35:00',4.72),('8537','2013-04-18','11:40:00',4.75),('8537','2013-04-18','11:45:00',4.73),('8537','2013-04-18','11:50:00',4.78),('8537','2013-04-18','11:55:00',4.85),('8537','2013-04-18','12:00:00',4.75),('8537','2013-04-18','12:05:00',4.92),('8537','2013-04-18','12:10:00',4.95),('8537','2013-04-18','12:15:00',4.98),('8537','2013-04-18','12:20:00',5.03),('8537','2013-04-18','12:25:00',5.03),('8537','2013-04-18','12:30:00',5.04),('8537','2013-04-18','12:35:00',5.03),('8537','2013-04-18','12:40:00',5.02),('8537','2013-04-18','12:45:00',5.05),('8537','2013-04-18','12:50:00',5.05),('8537','2013-04-18','12:55:00',5.05),('8537','2013-04-18','13:00:00',5.07),('8537','2013-04-18','13:05:00',5.08),('8537','2013-04-18','13:10:00',5.09),('8537','2013-04-18','13:15:00',5.02),('8537','2013-04-18','13:20:00',5.05),('8537','2013-04-18','13:25:00',5.06),('8537','2013-04-18','13:30:00',5.09),('8537','2013-04-18','13:35:00',5.05),('8537','2013-04-18','13:40:00',5.02),('8537','2013-04-18','13:45:00',4.98),('8537','2013-04-18','13:50:00',5.02),('8537','2013-04-18','13:55:00',5.04),('8537','2013-04-18','14:00:00',5),('8537','2013-04-18','14:05:00',4.96),('8537','2013-04-18','14:10:00',4.93),('8537','2013-04-18','14:15:00',4.91),('8537','2013-04-18','14:20:00',4.87),('8537','2013-04-18','14:25:00',4.85),('8537','2013-04-18','14:30:00',4.77),('8537','2013-04-18','14:35:00',4.72),('8537','2013-04-18','14:40:00',4.65),('8537','2013-04-18','14:45:00',4.59),('8537','2013-04-18','14:50:00',4.56),('8537','2013-04-18','14:55:00',4.54),('8537','2013-04-18','15:00:00',4.44),('8537','2013-04-18','15:05:00',4.42),('8537','2013-04-18','15:10:00',4.37),('8537','2013-04-18','15:15:00',4.32),('8537','2013-04-18','15:20:00',4.26),('8537','2013-04-18','15:25:00',4.09),('8537','2013-04-18','15:30:00',3.89),('8537','2013-04-18','15:35:00',4.02),('8537','2013-04-18','15:40:00',3.98),('8537','2013-04-18','15:45:00',3.91),('8537','2013-04-18','15:50:00',3.84),('8537','2013-04-18','15:55:00',3.76),('8537','2013-04-18','16:00:00',3.66),('8537','2013-04-18','16:05:00',3.5),('8537','2013-04-18','16:10:00',3.01),('8537','2013-04-18','16:15:00',3.35),('8537','2013-04-18','16:20:00',3.26),('8537','2013-04-18','16:25:00',3.16),('8537','2013-04-18','16:30:00',3.09),('8537','2013-04-18','16:35:00',3.01),('8537','2013-04-18','16:40:00',2.88),('8537','2013-04-18','16:45:00',2.48),('8537','2013-04-18','16:50:00',2.63),('8537','2013-04-18','16:55:00',2.62),('8537','2013-04-18','17:00:00',2.48),('8537','2013-04-18','17:05:00',2.3),('8537','2013-04-18','17:10:00',2.23),('8537','2013-04-18','17:15:00',2.16),('8537','2013-04-18','17:20:00',2.05),('8537','2013-04-18','17:25:00',1.92),('8537','2013-04-18','17:30:00',1.82),('8537','2013-04-18','17:35:00',1.69),('8537','2013-04-18','17:40:00',1.59),('8537','2013-04-18','17:45:00',1.49),('8537','2013-04-18','17:50:00',1.4),('8537','2013-04-18','17:55:00',1.28),('8537','2013-04-18','18:00:00',1.18),('8537','2013-04-18','18:05:00',1.08),('8537','2013-04-17','07:50:00',1.05),('8537','2013-04-17','07:55:00',1.16),('8537','2013-04-17','08:00:00',1.28),('8537','2013-04-17','08:05:00',1.39),('8537','2013-04-17','08:10:00',1.52),('8537','2013-04-17','08:15:00',1.65),('8537','2013-04-17','08:20:00',1.76),('8537','2013-04-17','08:25:00',1.88),('8537','2013-04-17','08:30:00',1.99),('8537','2013-04-17','08:35:00',2.11),('8537','2013-04-17','08:40:00',2.22),('8537','2013-04-17','08:45:00',2.33),('8537','2013-04-17','08:50:00',2.44),('8537','2013-04-17','08:55:00',2.55),('8537','2013-04-17','09:00:00',2.65),('8537','2013-04-17','09:05:00',2.77),('8537','2013-04-17','09:10:00',2.87),('8537','2013-04-17','09:15:00',2.97),('8537','2013-04-17','09:20:00',3.06),('8537','2013-04-17','09:25:00',3.16),('8537','2013-04-17','09:30:00',3.24),('8537','2013-04-17','09:35:00',3.35),('8537','2013-04-17','09:40:00',3.45),('8537','2013-04-17','09:45:00',3.52),('8537','2013-04-17','09:50:00',3.59),('8537','2013-04-17','09:55:00',3.68),('8537','2013-04-17','10:00:00',3.74),('8537','2013-04-17','10:05:00',3.85),('8537','2013-04-17','10:10:00',3.93),('8537','2013-04-17','10:15:00',4),('8537','2013-04-17','10:20:00',4.04),('8537','2013-04-17','10:25:00',4.13),('8537','2013-04-17','10:30:00',4.19),('8537','2013-04-17','10:35:00',4.23),('8537','2013-04-17','10:40:00',4.3),('8537','2013-04-17','10:45:00',4.35),('8537','2013-04-17','10:50:00',4.41),('8537','2013-04-17','10:55:00',4.47),('8537','2013-04-17','11:00:00',4.55),('8537','2013-04-17','11:05:00',4.54),('8537','2013-04-17','11:10:00',4.68),('8537','2013-04-17','11:15:00',4.72),('8537','2013-04-17','11:20:00',4.71),('8537','2013-04-17','11:25:00',4.76),('8537','2013-04-17','11:30:00',4.78),('8537','2013-04-17','11:35:00',4.82),('8537','2013-04-17','11:40:00',4.84),('8537','2013-04-17','11:45:00',4.86),('8537','2013-04-17','11:50:00',4.92),('8537','2013-04-17','11:55:00',4.96),('8537','2013-04-17','12:00:00',4.95),('8537','2013-04-17','12:05:00',4.94),('8537','2013-04-17','12:10:00',4.93),('8537','2013-04-17','12:15:00',5.02),('8537','2013-04-17','12:20:00',5),('8537','2013-04-17','12:25:00',5.06),('8537','2013-04-17','12:30:00',5.13),('8537','2013-04-17','12:35:00',5.11),('8537','2013-04-17','12:40:00',5.06),('8537','2013-04-17','12:45:00',5.03),('8537','2013-04-17','12:50:00',4.97),('8537','2013-04-17','12:55:00',5.11),('8537','2013-04-17','13:00:00',5.13),('8537','2013-04-17','13:05:00',5.1),('8537','2013-04-17','13:10:00',5.1),('8537','2013-04-17','13:15:00',5.2),('8537','2013-04-17','13:20:00',5.23),('8537','2013-04-17','13:25:00',5.21),('8537','2013-04-17','13:30:00',5.16),('8537','2013-04-17','13:35:00',5.09),('8537','2013-04-17','13:40:00',5.2),('8537','2013-04-17','13:45:00',4.84),('8537','2013-04-17','13:50:00',4.78),('8537','2013-04-17','13:55:00',5.14),('8537','2013-04-17','14:00:00',4.99),('8537','2013-04-17','14:05:00',5.36),('8537','2013-04-17','14:10:00',5.21),('8537','2013-04-17','14:15:00',4.7),('8537','2013-04-17','14:20:00',4.61),('8537','2013-04-17','14:25:00',4.54),('8537','2013-04-17','14:30:00',4.5),('8537','2013-04-17','14:35:00',5.09),('8537','2013-04-17','14:40:00',4.88),('8537','2013-04-17','14:45:00',4.21),('8537','2013-04-17','14:50:00',4.82),('8537','2013-04-17','14:55:00',4.96),('8537','2013-04-17','15:00:00',4.88),('8537','2013-04-17','15:05:00',4.95),('8537','2013-04-17','15:10:00',5.11),('8537','2013-04-17','15:15:00',4.75),('8537','2013-04-17','15:20:00',2.53),('8537','2013-04-17','15:25:00',2.62),('8537','2013-04-17','15:30:00',4.02),('8537','2013-04-17','15:35:00',4.28),('8537','2013-04-17','15:40:00',4.28),('8537','2013-04-17','15:45:00',4.24),('8537','2013-04-17','15:50:00',4.22),('8537','2013-04-17','15:55:00',4.23),('8537','2013-04-17','16:00:00',4.09),('8537','2013-04-17','16:05:00',2.94),('8537','2013-04-17','16:10:00',3.82),('8537','2013-04-17','16:15:00',3.66),('8537','2013-04-17','16:20:00',3.5),('8537','2013-04-17','16:25:00',3.4),('8537','2013-04-17','16:30:00',3.32),('8537','2013-04-17','16:35:00',3.3),('8537','2013-04-17','16:40:00',2.97),('8537','2013-04-17','16:45:00',3.1),('8537','2013-04-17','16:50:00',2.87),('8537','2013-04-17','16:55:00',2.74),('8537','2013-04-17','17:00:00',2.6),('8537','2013-04-17','17:05:00',2.33),('8537','2013-04-17','17:10:00',2.31),('8537','2013-04-17','17:15:00',2.22),('8537','2013-04-17','17:20:00',2.1),('8537','2013-04-17','17:25:00',1.98),('8537','2013-04-17','17:30:00',1.86),('8537','2013-04-17','17:35:00',1.71),('8537','2013-04-17','17:40:00',1.61),('8537','2013-04-17','17:45:00',1.51),('8537','2013-04-17','17:50:00',1.39),('8537','2013-04-17','17:55:00',1.29),('8537','2013-04-17','18:00:00',1.19),('8537','2013-04-17','18:05:00',1.1),('8537','2013-04-16','07:55:00',1.02),('8537','2013-04-16','08:05:00',1.26),('8537','2013-04-16','08:10:00',1.32),('8537','2013-04-16','08:25:00',1.04),('8537','2013-04-16','08:30:00',1.06),('8537','2013-04-16','08:35:00',1.01),('8537','2013-04-16','08:40:00',1.04),('8537','2013-04-16','08:45:00',1.12),('8537','2013-04-16','08:50:00',1.25),('8537','2013-04-16','08:55:00',1.31),('8537','2013-04-16','09:00:00',1.47),('8537','2013-04-16','09:05:00',1.13),('8537','2013-04-16','09:10:00',1.61),('8537','2013-04-16','09:15:00',1.44),('8537','2013-04-16','09:20:00',1.53),('8537','2013-04-16','09:25:00',1.99),('8537','2013-04-16','09:30:00',2),('8537','2013-04-16','09:35:00',1.98),('8537','2013-04-16','09:40:00',1.67),('8537','2013-04-16','09:45:00',1.74),('8537','2013-04-16','09:50:00',1.68),('8537','2013-04-16','09:55:00',1.62),('8537','2013-04-16','10:00:00',1.56),('8537','2013-04-16','10:05:00',1.55),('8537','2013-04-16','10:10:00',1.63),('8537','2013-04-16','10:15:00',1.74),('8537','2013-04-16','10:20:00',1.83),('8537','2013-04-16','10:25:00',1.87),('8537','2013-04-16','10:30:00',1.89),('8537','2013-04-16','10:35:00',1.92),('8537','2013-04-16','10:40:00',1.87),('8537','2013-04-16','10:45:00',1.79),('8537','2013-04-16','10:50:00',1.81),('8537','2013-04-16','10:55:00',1.92),('8537','2013-04-16','11:00:00',2.1),('8537','2013-04-16','11:05:00',2.16),('8537','2013-04-16','11:10:00',2.16),('8537','2013-04-16','11:15:00',2.23),('8537','2013-04-16','11:20:00',2.29),('8537','2013-04-16','11:25:00',2.24),('8537','2013-04-16','11:30:00',2.2),('8537','2013-04-16','11:35:00',2.15),('8537','2013-04-16','11:40:00',2.37),('8537','2013-04-16','11:45:00',2.78),('8537','2013-04-16','11:50:00',2.97),('8537','2013-04-16','11:55:00',3.07),('8537','2013-04-16','12:00:00',3.15),('8537','2013-04-16','12:05:00',3.51),('8537','2013-04-16','12:10:00',3.64),('8537','2013-04-16','12:15:00',4.16),('8537','2013-04-16','12:20:00',3.73),('8537','2013-04-16','12:25:00',3.61),('8537','2013-04-16','12:30:00',4.22),('8537','2013-04-16','12:35:00',5.08),('8537','2013-04-16','12:40:00',5.22),('8537','2013-04-16','12:45:00',4.96),('8537','2013-04-16','12:50:00',3.76),('8537','2013-04-16','12:55:00',4.91),('8537','2013-04-16','13:00:00',5.04),('8537','2013-04-16','13:05:00',4.86),('8537','2013-04-16','13:10:00',4.88),('8537','2013-04-16','13:15:00',4.88),('8537','2013-04-16','13:20:00',4.96),('8537','2013-04-16','13:25:00',4.95),('8537','2013-04-16','13:30:00',4.97),('8537','2013-04-16','13:35:00',4.92),('8537','2013-04-16','13:40:00',4.88),('8537','2013-04-16','13:45:00',4.84),('8537','2013-04-16','13:50:00',4.81),('8537','2013-04-16','13:55:00',4.57),('8537','2013-04-16','14:00:00',4.73),('8537','2013-04-16','14:05:00',4.82),('8537','2013-04-16','14:10:00',4.83),('8537','2013-04-16','14:15:00',4.78),('8537','2013-04-16','14:20:00',4.7),('8537','2013-04-16','14:25:00',3.77),('8537','2013-04-16','14:30:00',3.94),('8537','2013-04-16','14:35:00',3.66),('8537','2013-04-16','14:40:00',4.37),('8537','2013-04-16','14:45:00',4.58),('8537','2013-04-16','14:50:00',4.38),('8537','2013-04-16','14:55:00',4.26),('8537','2013-04-16','15:00:00',4.39),('8537','2013-04-16','15:05:00',4.33),('8537','2013-04-16','15:10:00',4.31),('8537','2013-04-16','15:15:00',4.29),('8537','2013-04-16','15:20:00',4.23),('8537','2013-04-16','15:25:00',3.92),('8537','2013-04-16','15:30:00',3.88),('8537','2013-04-16','15:35:00',3.9),('8537','2013-04-16','15:40:00',3.88),('8537','2013-04-16','15:45:00',3.81),('8537','2013-04-16','15:50:00',3.79),('8537','2013-04-16','15:55:00',3.69),('8537','2013-04-16','16:00:00',3.5),('8537','2013-04-16','16:05:00',3.43),('8537','2013-04-16','16:10:00',3.01),('8537','2013-04-16','16:15:00',3.19),('8537','2013-04-16','16:20:00',3.28),('8537','2013-04-16','16:25:00',3.19),('8537','2013-04-16','16:30:00',3.11),('8537','2013-04-16','16:35:00',3.05),('8537','2013-04-16','16:40:00',3.12),('8537','2013-04-16','16:45:00',3.2),('8537','2013-04-16','16:50:00',2.92),('8537','2013-04-16','16:55:00',2.52),('8537','2013-04-16','17:00:00',2.49),('8537','2013-04-16','17:05:00',2.44),('8537','2013-04-16','17:10:00',2.5),('8537','2013-04-16','17:15:00',2.41),('8537','2013-04-16','17:20:00',2.32),('8537','2013-04-16','17:25:00',2.26),('8537','2013-04-16','17:30:00',2.02),('8537','2013-04-16','17:35:00',2),('8537','2013-04-16','17:40:00',1.95),('8537','2013-04-16','17:45:00',1.78),('8537','2013-04-16','17:50:00',1.6),('8537','2013-04-16','17:55:00',1.33),('8537','2013-04-15','07:50:00',1),('8537','2013-04-15','07:55:00',1.11),('8537','2013-04-15','08:00:00',1.22),('8537','2013-04-15','08:05:00',1.33),('8537','2013-04-15','08:10:00',1.43),('8537','2013-04-15','08:15:00',1.53),('8537','2013-04-15','08:20:00',1.64),('8537','2013-04-15','08:25:00',1.76),('8537','2013-04-15','08:30:00',1.87),('8537','2013-04-15','08:35:00',1.98),('8537','2013-04-15','08:40:00',2.09),('8537','2013-04-15','08:45:00',2.18),('8537','2013-04-15','08:50:00',2.3),('8537','2013-04-15','08:55:00',2.41),('8537','2013-04-15','09:00:00',2.5),('8537','2013-04-15','09:05:00',2.62),('8537','2013-04-15','09:10:00',2.74),('8537','2013-04-15','09:15:00',2.84),('8537','2013-04-15','09:20:00',2.93),('8537','2013-04-15','09:25:00',3.01),('8537','2013-04-15','09:30:00',3.12),('8537','2013-04-15','09:35:00',3.2),('8537','2013-04-15','09:40:00',3.23),('8537','2013-04-15','09:45:00',3.16),('8537','2013-04-15','09:50:00',3.33),('8537','2013-04-15','09:55:00',3.44),('8537','2013-04-15','10:00:00',3.42),('8537','2013-04-15','10:05:00',3.42),('8537','2013-04-15','10:10:00',3.5),('8537','2013-04-15','10:15:00',3.54),('8537','2013-04-15','10:20:00',3.67),('8537','2013-04-15','10:25:00',3.86),('8537','2013-04-15','10:30:00',3.64),('8537','2013-04-15','10:35:00',3.76),('8537','2013-04-15','10:40:00',3.94),('8537','2013-04-15','10:45:00',4.11),('8537','2013-04-15','10:50:00',4.2),('8537','2013-04-15','10:55:00',4.39),('8537','2013-04-15','11:00:00',4.29),('8537','2013-04-15','11:05:00',4.28),('8537','2013-04-15','11:10:00',4.39),('8537','2013-04-15','11:15:00',4.57),('8537','2013-04-15','11:20:00',4.75),('8537','2013-04-15','11:25:00',4.79),('8537','2013-04-15','11:30:00',4.82),('8537','2013-04-15','11:35:00',4.87),('8537','2013-04-15','11:40:00',4.86),('8537','2013-04-15','11:45:00',4.91),('8537','2013-04-15','11:50:00',4.92),('8537','2013-04-15','11:55:00',4.93),('8537','2013-04-15','12:00:00',4.96),('8537','2013-04-15','12:05:00',4.98),('8537','2013-04-15','12:10:00',4.98),('8537','2013-04-15','12:15:00',4.99),('8537','2013-04-15','12:20:00',5.05),('8537','2013-04-15','12:25:00',5),('8537','2013-04-15','12:30:00',5.07),('8537','2013-04-15','12:35:00',5.13),('8537','2013-04-15','12:40:00',5.04),('8537','2013-04-15','12:45:00',5.04),('8537','2013-04-15','12:50:00',5.02),('8537','2013-04-15','12:55:00',5),('8537','2013-04-15','13:00:00',5.07),('8537','2013-04-15','13:05:00',5.05),('8537','2013-04-15','13:10:00',5.11),('8537','2013-04-15','13:15:00',5.12),('8537','2013-04-15','13:20:00',5.11),('8537','2013-04-15','13:25:00',5.08),('8537','2013-04-15','13:30:00',5.04),('8537','2013-04-15','13:35:00',5.03),('8537','2013-04-15','13:40:00',4.98),('8537','2013-04-15','13:45:00',4.93),('8537','2013-04-15','13:50:00',4.94),('8537','2013-04-15','13:55:00',4.98),('8537','2013-04-15','14:00:00',4.97),('8537','2013-04-15','14:05:00',4.99),('8537','2013-04-15','14:10:00',4.98),('8537','2013-04-15','14:15:00',4.94),('8537','2013-04-15','14:20:00',4.92),('8537','2013-04-15','14:25:00',4.9),('8537','2013-04-15','14:30:00',4.78),('8537','2013-04-15','14:35:00',4.44),('8537','2013-04-15','14:40:00',4.04),('8537','2013-04-15','14:45:00',4.67),('8537','2013-04-15','14:50:00',4.62),('8537','2013-04-15','14:55:00',4.58),('8537','2013-04-15','15:00:00',4.53),('8537','2013-04-15','15:05:00',4.51),('8537','2013-04-15','15:10:00',4.46),('8537','2013-04-15','15:15:00',4.39),('8537','2013-04-15','15:20:00',4.32),('8537','2013-04-15','15:25:00',4.09),('8537','2013-04-15','15:30:00',4.09),('8537','2013-04-15','15:35:00',4.11),('8537','2013-04-15','15:40:00',4.04),('8537','2013-04-15','15:45:00',3.97),('8537','2013-04-15','15:50:00',3.9),('8537','2013-04-15','15:55:00',3.82),('8537','2013-04-15','16:00:00',3.74),('8537','2013-04-15','16:05:00',3.58),('8537','2013-04-15','16:10:00',3.54),('8537','2013-04-15','16:15:00',3.46),('8537','2013-04-15','16:20:00',3.36),('8537','2013-04-15','16:25:00',3.27),('8537','2013-04-15','16:30:00',3.19),('8537','2013-04-15','16:35:00',3.11),('8537','2013-04-15','16:40:00',2.88),('8537','2013-04-15','16:45:00',2.8),('8537','2013-04-15','16:50:00',2.77),('8537','2013-04-15','16:55:00',2.66),('8537','2013-04-15','17:00:00',2.53),('8537','2013-04-15','17:05:00',2.39),('8537','2013-04-15','17:10:00',2.3),('8537','2013-04-15','17:15:00',2.2),('8537','2013-04-15','17:20:00',2.09),('8537','2013-04-15','17:25:00',1.97),('8537','2013-04-15','17:30:00',1.84),('8537','2013-04-15','17:35:00',1.72),('8537','2013-04-15','17:40:00',1.62),('8537','2013-04-15','17:45:00',1.51),('8537','2013-04-15','17:50:00',1.4),('8537','2013-04-15','17:55:00',1.29),('8537','2013-04-15','18:00:00',1.19),('8537','2013-04-15','18:05:00',1.09),('8537','2013-04-14','07:55:00',1.07),('8537','2013-04-14','08:00:00',1.15),('8537','2013-04-14','08:05:00',1.13),('8537','2013-04-14','08:10:00',1.29),('8537','2013-04-14','08:15:00',1.43),('8537','2013-04-14','08:20:00',1.53),('8537','2013-04-14','08:25:00',1.64),('8537','2013-04-14','08:30:00',1.75),('8537','2013-04-14','08:35:00',1.85),('8537','2013-04-14','08:40:00',1.96),('8537','2013-04-14','08:45:00',2.06),('8537','2013-04-14','08:50:00',2.17),('8537','2013-04-14','08:55:00',2.28),('8537','2013-04-14','09:00:00',2.38),('8537','2013-04-14','09:05:00',2.47),('8537','2013-04-14','09:10:00',2.56),('8537','2013-04-14','09:15:00',2.65),('8537','2013-04-14','09:20:00',2.76),('8537','2013-04-14','09:25:00',2.86),('8537','2013-04-14','09:30:00',2.95),('8537','2013-04-14','09:35:00',3.04),('8537','2013-04-14','09:40:00',3.11),('8537','2013-04-14','09:45:00',3.22),('8537','2013-04-14','09:50:00',3.3),('8537','2013-04-14','09:55:00',3.41),('8537','2013-04-14','10:00:00',3.5),('8537','2013-04-14','10:05:00',3.56),('8537','2013-04-14','10:10:00',3.64),('8537','2013-04-14','10:15:00',3.71),('8537','2013-04-14','10:20:00',3.79),('8537','2013-04-14','10:25:00',3.83),('8537','2013-04-14','10:30:00',3.94),('8537','2013-04-14','10:35:00',3.98),('8537','2013-04-14','10:40:00',4.08),('8537','2013-04-14','10:45:00',4.11),('8537','2013-04-14','10:50:00',4.14),('8537','2013-04-14','10:55:00',4.19),('8537','2013-04-14','11:00:00',4.25),('8537','2013-04-14','11:05:00',4.35),('8537','2013-04-14','11:10:00',4.42),('8537','2013-04-14','11:15:00',4.47),('8537','2013-04-14','11:20:00',4.52),('8537','2013-04-14','11:25:00',4.48),('8537','2013-04-14','11:30:00',4.52),('8537','2013-04-14','11:35:00',4.53),('8537','2013-04-14','11:40:00',4.61),('8537','2013-04-14','11:45:00',4.64),('8537','2013-04-14','11:50:00',4.66),('8537','2013-04-14','11:55:00',4.7),('8537','2013-04-14','12:00:00',4.71),('8537','2013-04-14','12:05:00',4.74),('8537','2013-04-14','12:10:00',4.75),('8537','2013-04-14','12:15:00',4.73),('8537','2013-04-14','12:20:00',4.78),('8537','2013-04-14','12:25:00',4.8),('8537','2013-04-14','12:30:00',4.82),('8537','2013-04-14','12:35:00',4.8),('8537','2013-04-14','12:40:00',3.58),('8537','2013-04-14','12:45:00',3.28),('8537','2013-04-14','12:50:00',5.19),('8537','2013-04-14','12:55:00',4.86),('8537','2013-04-14','13:00:00',4.95),('8537','2013-04-14','13:05:00',3.46),('8537','2013-04-14','13:10:00',4.26),('8537','2013-04-14','13:15:00',5.1),('8537','2013-04-14','13:20:00',5.05),('8537','2013-04-14','13:25:00',4.99),('8537','2013-04-14','13:30:00',4.94),('8537','2013-04-14','13:35:00',4.91),('8537','2013-04-14','13:40:00',4.84),('8537','2013-04-14','13:45:00',4.83),('8537','2013-04-14','13:50:00',4.74),('8537','2013-04-14','13:55:00',4.72),('8537','2013-04-14','14:00:00',4.72),('8537','2013-04-14','14:05:00',4.76),('8537','2013-04-14','14:10:00',4.73),('8537','2013-04-14','14:15:00',4.75),('8537','2013-04-14','14:20:00',4.75),('8537','2013-04-14','14:25:00',4.67),('8537','2013-04-14','14:30:00',4.54),('8537','2013-04-14','14:35:00',4.37),('8537','2013-04-14','14:40:00',4.08),('8537','2013-04-14','14:45:00',4.55),('8537','2013-04-14','14:50:00',4.7),('8537','2013-04-14','14:55:00',4.53),('8537','2013-04-14','15:00:00',4.36),('8537','2013-04-14','15:05:00',4.35),('8537','2013-04-14','15:10:00',4.08),('8537','2013-04-14','15:15:00',3.38),('8537','2013-04-14','15:20:00',3.99),('8537','2013-04-14','15:25:00',3.43),('8537','2013-04-14','15:30:00',2.91),('8537','2013-04-14','15:35:00',4.02),('8537','2013-04-14','15:40:00',3.97),('8537','2013-04-14','15:45:00',3.91),('8537','2013-04-14','15:50:00',3.78),('8537','2013-04-14','15:55:00',2.86),('8537','2013-04-14','16:00:00',3.23),('8537','2013-04-14','16:05:00',3.28),('8537','2013-04-14','16:10:00',3.05),('8537','2013-04-14','16:15:00',3.11),('8537','2013-04-14','16:20:00',3.04),('8537','2013-04-14','16:25:00',3.05),('8537','2013-04-14','16:30:00',2.94),('8537','2013-04-14','16:35:00',2.81),('8537','2013-04-14','16:40:00',2.62),('8537','2013-04-14','16:45:00',2.42),('8537','2013-04-14','16:50:00',2.5),('8537','2013-04-14','16:55:00',2.38),('8537','2013-04-14','17:00:00',2.26),('8537','2013-04-14','17:05:00',2.14),('8537','2013-04-14','17:10:00',2.06),('8537','2013-04-14','17:15:00',1.95),('8537','2013-04-14','17:20:00',1.85),('8537','2013-04-14','17:25:00',1.72),('8537','2013-04-14','17:30:00',1.61),('8537','2013-04-14','17:35:00',1.53),('8537','2013-04-14','17:40:00',1.43),('8537','2013-04-14','17:45:00',1.35),('8537','2013-04-14','17:50:00',1.25),('8537','2013-04-14','17:55:00',1.13),('8537','2013-04-14','18:00:00',1.04),('8537','2013-04-13','08:00:00',1.11),('8537','2013-04-13','08:05:00',1.16),('8537','2013-04-13','08:10:00',1.25),('8537','2013-04-13','08:15:00',1.12),('8537','2013-04-13','08:50:00',1.01),('8537','2013-04-13','08:55:00',1.34),('8537','2013-04-13','09:00:00',1.23),('8537','2013-04-13','09:05:00',1.81),('8537','2013-04-13','09:10:00',1.5),('8537','2013-04-13','09:15:00',1.62),('8537','2013-04-13','09:20:00',1.14),('8537','2013-04-13','09:25:00',2.34),('8537','2013-04-13','09:30:00',2.91),('8537','2013-04-13','09:35:00',2.92),('8537','2013-04-13','09:40:00',2.73),('8537','2013-04-13','09:45:00',3.21),('8537','2013-04-13','09:50:00',3.33),('8537','2013-04-13','09:55:00',3.43),('8537','2013-04-13','10:00:00',3.48),('8537','2013-04-13','10:05:00',3.53),('8537','2013-04-13','10:10:00',3.83),('8537','2013-04-13','10:15:00',3.14),('8537','2013-04-13','10:20:00',1.79),('8537','2013-04-13','10:25:00',3.9),('8537','2013-04-13','10:30:00',4.19),('8537','2013-04-13','10:35:00',1.25),('8537','2013-04-13','10:40:00',3.54),('8537','2013-04-13','10:45:00',3.14),('8537','2013-04-13','10:50:00',1.87),('8537','2013-04-13','10:55:00',3.12),('8537','2013-04-13','11:00:00',1.92),('8537','2013-04-13','11:05:00',3.68),('8537','2013-04-13','11:10:00',4.38),('8537','2013-04-13','11:15:00',4.59),('8537','2013-04-13','11:20:00',4.93),('8537','2013-04-13','11:25:00',2.65),('8537','2013-04-13','11:30:00',3.01),('8537','2013-04-13','11:35:00',5.11),('8537','2013-04-13','11:40:00',4.96),('8537','2013-04-13','11:45:00',4.17),('8537','2013-04-13','11:50:00',4.09),('8537','2013-04-13','11:55:00',4.62),('8537','2013-04-13','12:00:00',5.13),('8537','2013-04-13','12:05:00',5),('8537','2013-04-13','12:10:00',5.12),('8537','2013-04-13','12:15:00',5.04),('8537','2013-04-13','12:20:00',4.95),('8537','2013-04-13','12:25:00',4.17),('8537','2013-04-13','12:30:00',4.6),('8537','2013-04-13','12:35:00',5.11),('8537','2013-04-13','12:40:00',5.1),('8537','2013-04-13','12:45:00',4.99),('8537','2013-04-13','12:50:00',4.91),('8537','2013-04-13','12:55:00',4.94),('8537','2013-04-13','13:00:00',4.78),('8537','2013-04-13','13:05:00',5.04),('8537','2013-04-13','13:10:00',5.14),('8537','2013-04-13','13:15:00',4.8),('8537','2013-04-13','13:20:00',4.86),('8537','2013-04-13','13:25:00',5.03),('8537','2013-04-13','13:30:00',4.17),('8537','2013-04-13','13:35:00',1.96),('8537','2013-04-13','13:40:00',2.8),('8537','2013-04-13','13:45:00',3.66),('8537','2013-04-13','13:50:00',2.48),('8537','2013-04-13','13:55:00',1.92),('8537','2013-04-13','14:00:00',1.87),('8537','2013-04-13','14:05:00',2.89),('8537','2013-04-13','14:10:00',1.87),('8537','2013-04-13','14:15:00',2.53),('8537','2013-04-13','14:20:00',4.21),('8537','2013-04-13','14:25:00',4.06),('8537','2013-04-13','14:30:00',4.29),('8537','2013-04-13','14:35:00',4.33),('8537','2013-04-13','14:40:00',4.23),('8537','2013-04-13','14:45:00',4.26),('8537','2013-04-13','14:50:00',4.05),('8537','2013-04-13','14:55:00',4.11),('8537','2013-04-13','15:00:00',3.77),('8537','2013-04-13','15:05:00',3.28),('8537','2013-04-13','15:10:00',3.6),('8537','2013-04-13','15:15:00',3.28),('8537','2013-04-13','15:20:00',3.26),('8537','2013-04-13','15:25:00',3.02),('8537','2013-04-13','15:30:00',3.05),('8537','2013-04-13','15:35:00',2.98),('8537','2013-04-13','15:40:00',3.1),('8537','2013-04-13','15:45:00',3.15),('8537','2013-04-13','15:50:00',3.04),('8537','2013-04-13','15:55:00',3.05),('8537','2013-04-13','16:00:00',3),('8537','2013-04-13','16:05:00',2.77),('8537','2013-04-13','16:10:00',2.56),('8537','2013-04-13','16:15:00',2.63),('8537','2013-04-13','16:20:00',2.57),('8537','2013-04-13','16:25:00',2.38),('8537','2013-04-13','16:30:00',2.27),('8537','2013-04-13','16:35:00',2.13),('8537','2013-04-13','16:40:00',2.02),('8537','2013-04-13','16:45:00',1.87),('8537','2013-04-13','16:50:00',1.94),('8537','2013-04-13','16:55:00',1.61),('8537','2013-04-13','17:00:00',1.39),('8537','2013-04-13','17:05:00',1.33),('8537','2013-04-13','17:10:00',1.63),('8537','2013-04-13','17:15:00',1.75),('8537','2013-04-13','17:20:00',1.68),('8537','2013-04-13','17:25:00',1.88),('8537','2013-04-13','17:30:00',1.62),('8537','2013-04-13','17:35:00',1.61),('8537','2013-04-13','17:40:00',1.52),('8537','2013-04-13','17:45:00',1.35),('8537','2013-04-13','17:50:00',1.17),('8537','2013-04-13','17:55:00',1.24),('8537','2013-04-12','08:00:00',1.13),('8537','2013-04-12','08:05:00',1.31),('8537','2013-04-12','08:10:00',1.34),('8537','2013-04-12','08:15:00',1.06),('8537','2013-04-12','08:20:00',1.23),('8537','2013-04-12','08:35:00',1.41),('8537','2013-04-12','08:40:00',1.18),('8537','2013-04-12','08:45:00',1.33),('8537','2013-04-12','08:50:00',1.58),('8537','2013-04-12','08:55:00',1.83),('8537','2013-04-12','09:00:00',2.48),('8537','2013-04-12','09:05:00',2.05),('8537','2013-04-12','09:10:00',1.69),('8537','2013-04-12','09:15:00',2.05),('8537','2013-04-12','09:20:00',2.34),('8537','2013-04-12','09:25:00',1.89),('8537','2013-04-12','09:30:00',1.79),('8537','2013-04-12','09:35:00',1.33),('8537','2013-04-12','09:40:00',1.53),('8537','2013-04-12','09:45:00',1.86),('8537','2013-04-12','09:50:00',1.34),('8537','2013-04-12','09:55:00',1.07),('8537','2013-04-12','10:05:00',1.05),('8537','2013-04-12','10:10:00',1),('8537','2013-04-12','10:15:00',1.15),('8537','2013-04-12','10:20:00',2.49),('8537','2013-04-12','10:25:00',1.72),('8537','2013-04-12','10:30:00',1.29),('8537','2013-04-12','10:35:00',1.72),('8537','2013-04-12','10:40:00',2.18),('8537','2013-04-12','10:45:00',5.15),('8537','2013-04-12','10:50:00',4.89),('8537','2013-04-12','10:55:00',4.74),('8537','2013-04-12','11:00:00',2),('8537','2013-04-12','11:05:00',2.29),('8537','2013-04-12','11:10:00',2.05),('8537','2013-04-12','11:15:00',3.97),('8537','2013-04-12','11:20:00',5.11),('8537','2013-04-12','11:25:00',4.85),('8537','2013-04-12','11:30:00',3.83),('8537','2013-04-12','11:35:00',3.97),('8537','2013-04-12','11:40:00',5.46),('8537','2013-04-12','11:45:00',3.3),('8537','2013-04-12','11:50:00',4.36),('8537','2013-04-12','11:55:00',5.07),('8537','2013-04-12','12:00:00',5),('8537','2013-04-12','12:05:00',4.82),('8537','2013-04-12','12:10:00',4.71),('8537','2013-04-12','12:15:00',4.91),('8537','2013-04-12','12:20:00',5.11),('8537','2013-04-12','12:25:00',4.89),('8537','2013-04-12','12:30:00',5.04),('8537','2013-04-12','12:35:00',5.02),('8537','2013-04-12','12:40:00',4.74),('8537','2013-04-12','12:45:00',4.86),('8537','2013-04-12','12:50:00',4.78),('8537','2013-04-12','12:55:00',4.94),('8537','2013-04-12','13:00:00',5.05),('8537','2013-04-12','13:05:00',5.01),('8537','2013-04-12','13:10:00',5.04),('8537','2013-04-12','13:15:00',5.02),('8537','2013-04-12','13:20:00',5.04),('8537','2013-04-12','13:25:00',5.03),('8537','2013-04-12','13:30:00',4.98),('8537','2013-04-12','13:35:00',5.03),('8537','2013-04-12','13:40:00',4.98),('8537','2013-04-12','13:45:00',5),('8537','2013-04-12','13:50:00',4.94),('8537','2013-04-12','13:55:00',4.91),('8537','2013-04-12','14:00:00',4.89),('8537','2013-04-12','14:05:00',4.88),('8537','2013-04-12','14:10:00',4.85),('8537','2013-04-12','14:15:00',4.81),('8537','2013-04-12','14:20:00',4.78),('8537','2013-04-12','14:25:00',4.73),('8537','2013-04-12','14:30:00',4.61),('8537','2013-04-12','14:35:00',4.3),('8537','2013-04-12','14:40:00',4.54),('8537','2013-04-12','14:45:00',4.5),('8537','2013-04-12','14:50:00',4.45),('8537','2013-04-12','14:55:00',4.38),('8537','2013-04-12','15:00:00',4.35),('8537','2013-04-12','15:05:00',4.29),('8537','2013-04-12','15:10:00',4.2),('8537','2013-04-12','15:15:00',4.16),('8537','2013-04-12','15:20:00',4.09),('8537','2013-04-12','15:25:00',3.96),('8537','2013-04-12','15:30:00',3.9),('8537','2013-04-12','15:35:00',3.86),('8537','2013-04-12','15:40:00',3.79),('8537','2013-04-12','15:45:00',3.73),('8537','2013-04-12','15:50:00',3.68),('8537','2013-04-12','15:55:00',3.52),('8537','2013-04-12','16:00:00',3.53),('8537','2013-04-12','16:05:00',3.34),('8537','2013-04-12','16:10:00',3.29),('8537','2013-04-12','16:15:00',2.94),('8537','2013-04-12','16:20:00',3.12),('8537','2013-04-12','16:25:00',3.09),('8537','2013-04-12','16:30:00',1.94),('8537','2013-04-12','16:35:00',1.39),('8537','2013-04-12','16:40:00',1.82),('8537','2013-04-12','16:45:00',2.78),('8537','2013-04-12','16:50:00',2.57),('8537','2013-04-12','16:55:00',2.48),('8537','2013-04-12','17:00:00',2.32),('8537','2013-04-12','17:05:00',2.22),('8537','2013-04-12','17:10:00',2.08),('8537','2013-04-12','17:15:00',1.99),('8537','2013-04-12','17:20:00',1.9),('8537','2013-04-12','17:25:00',1.77),('8537','2013-04-12','17:30:00',1.68),('8537','2013-04-12','17:35:00',1.57),('8537','2013-04-12','17:40:00',1.47),('8537','2013-04-12','17:45:00',1.37),('8537','2013-04-12','17:50:00',1.27),('8537','2013-04-12','17:55:00',1.15),('8537','2013-04-12','18:00:00',1.07),('8537','2014-03-28','07:10:00',1.1),('8537','2014-03-28','07:15:00',1.2),('8537','2014-03-28','07:20:00',1.29),('8537','2014-03-28','07:25:00',1.34),('8537','2014-03-28','07:30:00',1.39),('8537','2014-03-28','07:35:00',1.62),('8537','2014-03-28','07:40:00',1.68),('8537','2014-03-28','07:45:00',1.89),('8537','2014-03-28','07:50:00',2.02),('8537','2014-03-28','07:55:00',2.12),('8537','2014-03-28','08:00:00',2.22),('8537','2014-03-28','08:05:00',2.36),('8537','2014-03-28','08:10:00',2.48),('8537','2014-03-28','08:15:00',2.61),('8537','2014-03-28','08:20:00',2.72),('8537','2014-03-28','08:25:00',2.8),('8537','2014-03-28','08:30:00',2.9),('8537','2014-03-28','08:35:00',3),('8537','2014-03-28','08:40:00',3.11),('8537','2014-03-28','08:45:00',3.19),('8537','2014-03-28','08:50:00',3.3),('8537','2014-03-28','08:55:00',3.36),('8537','2014-03-28','09:00:00',3.42),('8537','2014-03-28','09:05:00',3.65),('8537','2014-03-28','09:10:00',3.84),('8537','2014-03-28','09:15:00',3.83),('8537','2014-03-28','09:20:00',3.34),('8537','2014-03-28','09:25:00',3.99),('8537','2014-03-28','09:30:00',4.27),('8537','2014-03-28','09:35:00',3.84),('8537','2014-03-28','09:40:00',2.55),('8537','2014-03-28','09:45:00',2.13),('8537','2014-03-28','09:50:00',2.74),('8537','2014-03-28','09:55:00',4.22),('8537','2014-03-28','10:00:00',4.59),('8537','2014-03-28','10:05:00',4.54),('8537','2014-03-28','10:10:00',3.83),('8537','2014-03-28','10:15:00',3.45),('8537','2014-03-28','10:20:00',3.24),('8537','2014-03-28','10:25:00',4.39),('8537','2014-03-28','10:30:00',4.64),('8537','2014-03-28','10:35:00',4.13),('8537','2014-03-28','10:40:00',4.31),('8537','2014-03-28','10:45:00',3.37),('8537','2014-03-28','10:50:00',4.83),('8537','2014-03-28','10:55:00',4.95),('8537','2014-03-28','11:00:00',4.5),('8537','2014-03-28','11:05:00',4.96),('8537','2014-03-28','11:10:00',4.16),('8537','2014-03-28','11:15:00',2.75),('8537','2014-03-28','11:20:00',4.27),('8537','2014-03-28','11:25:00',1.93),('8537','2014-03-28','11:30:00',3.3),('8537','2014-03-28','11:35:00',3.25),('8537','2014-03-28','11:40:00',2.82),('8537','2014-03-28','11:45:00',2.3),('8537','2014-03-28','11:50:00',1.55),('8537','2014-03-28','11:55:00',1.48),('8537','2014-03-28','12:00:00',4.18),('8537','2014-03-28','12:05:00',5.13),('8537','2014-03-28','12:10:00',5.45),('8537','2014-03-28','12:15:00',5.62),('8537','2014-03-28','12:20:00',5.12),('8537','2014-03-28','12:25:00',1.87),('8537','2014-03-28','12:30:00',1.22),('8537','2014-03-28','12:35:00',4.15),('8537','2014-03-28','12:40:00',4.52),('8537','2014-03-28','12:45:00',5.29),('8537','2014-03-28','12:50:00',5.19),('8537','2014-03-28','12:55:00',4.91),('8537','2014-03-28','13:00:00',5.68),('8537','2014-03-28','13:05:00',3.49),('8537','2014-03-28','13:10:00',1.77),('8537','2014-03-28','13:15:00',2.44),('8537','2014-03-28','13:20:00',4.7),('8537','2014-03-28','13:25:00',3.09),('8537','2014-03-28','13:30:00',1.95),('8537','2014-03-28','13:35:00',5.22),('8537','2014-03-28','13:40:00',5.02),('8537','2014-03-28','13:45:00',4.77),('8537','2014-03-28','13:50:00',4.61),('8537','2014-03-28','13:55:00',4.46),('8537','2014-03-28','14:00:00',4.55),('8537','2014-03-28','14:05:00',4.49),('8537','2014-03-28','14:10:00',4.24),('8537','2014-03-28','14:15:00',4.33),('8537','2014-03-28','14:20:00',4.18),('8537','2014-03-28','14:25:00',3.93),('8537','2014-03-28','14:30:00',4.1),('8537','2014-03-28','14:35:00',4.06),('8537','2014-03-28','14:40:00',4),('8537','2014-03-28','14:45:00',3.92),('8537','2014-03-28','14:50:00',3.86),('8537','2014-03-28','14:55:00',3.74),('8537','2014-03-28','15:00:00',3.69),('8537','2014-03-28','15:05:00',3.6),('8537','2014-03-28','15:10:00',3.5),('8537','2014-03-28','15:15:00',3.41),('8537','2014-03-28','15:20:00',3.31),('8537','2014-03-28','15:25:00',3.21),('8537','2014-03-28','15:30:00',3.15),('8537','2014-03-28','15:35:00',2.88),('8537','2014-03-28','15:40:00',2.66),('8537','2014-03-28','15:45:00',2.91),('8537','2014-03-28','15:50:00',2.83),('8537','2014-03-28','15:55:00',2.58),('8537','2014-03-28','16:00:00',2.7),('8537','2014-03-28','16:05:00',2.75),('8537','2014-03-28','16:10:00',2.64),('8537','2014-03-28','16:15:00',2.52),('8537','2014-03-28','16:20:00',2.18),('8537','2014-03-28','16:25:00',1.84),('8537','2014-03-28','16:30:00',1.55),('8537','2014-03-28','16:35:00',1.02),('8537','2014-03-28','16:45:00',1.15),('8537','2014-03-28','16:50:00',1.16),('8537','2013-04-11','08:00:00',1.1),('8537','2013-04-11','08:05:00',1.2),('8537','2013-04-11','08:10:00',1.31),('8537','2013-04-11','08:15:00',1.41),('8537','2013-04-11','08:20:00',1.52),('8537','2013-04-11','08:25:00',1.63),('8537','2013-04-11','08:30:00',1.73),('8537','2013-04-11','08:35:00',1.83),('8537','2013-04-11','08:40:00',1.94),('8537','2013-04-11','08:45:00',2.04),('8537','2013-04-11','08:50:00',2.16),('8537','2013-04-11','08:55:00',2.28),('8537','2013-04-11','09:00:00',2.37),('8537','2013-04-11','09:05:00',2.47),('8537','2013-04-11','09:10:00',2.57),('8537','2013-04-11','09:15:00',2.67),('8537','2013-04-11','09:20:00',2.78),('8537','2013-04-11','09:25:00',2.8),('8537','2013-04-11','09:30:00',2.94),('8537','2013-04-11','09:35:00',3.01),('8537','2013-04-11','09:40:00',3.15),('8537','2013-04-11','09:45:00',3.29),('8537','2013-04-11','09:50:00',3.47),('8537','2013-04-11','09:55:00',2.83),('8537','2013-04-11','10:00:00',1.12),('8537','2013-04-11','10:05:00',1.39),('8537','2013-04-11','10:10:00',1.53),('8537','2013-04-11','10:15:00',2.38),('8537','2013-04-11','10:20:00',3.04),('8537','2013-04-11','10:25:00',4.02),('8537','2013-04-11','10:30:00',4.07),('8537','2013-04-11','10:35:00',4.34),('8537','2013-04-11','10:40:00',4.54),('8537','2013-04-11','10:45:00',4.59),('8537','2013-04-11','10:50:00',2.74),('8537','2013-04-11','10:55:00',1.39),('8537','2013-04-11','11:05:00',3.46),('8537','2013-04-11','11:10:00',4.07),('8537','2013-04-11','11:15:00',4.8),('8537','2013-04-11','11:20:00',3.77),('8537','2013-04-11','11:25:00',1.18),('8537','2013-04-11','11:30:00',4.01),('8537','2013-04-11','11:35:00',3.8),('8537','2013-04-11','11:40:00',2.58),('8537','2013-04-11','11:45:00',1.62),('8537','2013-04-11','11:50:00',1.32),('8537','2013-04-11','11:55:00',4.51),('8537','2013-04-11','12:00:00',5.64),('8537','2013-04-11','12:05:00',5.39),('8537','2013-04-11','12:10:00',5.41),('8537','2013-04-11','12:15:00',2.62),('8537','2013-04-11','12:20:00',4.34),('8537','2013-04-11','12:25:00',5.33),('8537','2013-04-11','12:30:00',5.19),('8537','2013-04-11','12:35:00',4.83),('8537','2013-04-11','12:40:00',5.26),('8537','2013-04-11','12:45:00',5.05),('8537','2013-04-11','12:50:00',4.45),('8537','2013-04-11','12:55:00',5.02),('8537','2013-04-11','13:00:00',5.22),('8537','2013-04-11','13:05:00',5.35),('8537','2013-04-11','13:10:00',5.23),('8537','2013-04-11','13:15:00',5.13),('8537','2013-04-11','13:20:00',3.3),('8537','2013-04-11','13:25:00',5.13),('8537','2013-04-11','13:30:00',5.15),('8537','2013-04-11','13:35:00',5.11),('8537','2013-04-11','13:40:00',5.04),('8537','2013-04-11','13:45:00',5),('8537','2013-04-11','13:50:00',4.98),('8537','2013-04-11','13:55:00',4.99),('8537','2013-04-11','14:00:00',4.98),('8537','2013-04-11','14:05:00',4.93),('8537','2013-04-11','14:10:00',4.98),('8537','2013-04-11','14:15:00',4.92),('8537','2013-04-11','14:20:00',4.87),('8537','2013-04-11','14:25:00',4.83),('8537','2013-04-11','14:30:00',4.72),('8537','2013-04-11','14:35:00',4.72),('8537','2013-04-11','14:40:00',4.83),('8537','2013-04-11','14:45:00',4.71),('8537','2013-04-11','14:50:00',4.55),('8537','2013-04-11','14:55:00',4.48),('8537','2013-04-11','15:00:00',4.43),('8537','2013-04-11','15:05:00',4.37),('8537','2013-04-11','15:10:00',4.32),('8537','2013-04-11','15:15:00',4.25),('8537','2013-04-11','15:20:00',4.17),('8537','2013-04-11','15:25:00',3.89),('8537','2013-04-11','15:30:00',4.01),('8537','2013-04-11','15:35:00',3.95),('8537','2013-04-11','15:40:00',3.87),('8537','2013-04-11','15:45:00',3.81),('8537','2013-04-11','15:50:00',3.71),('8537','2013-04-11','15:55:00',3.64),('8537','2013-04-11','16:00:00',3.58),('8537','2013-04-11','16:05:00',3.42),('8537','2013-04-11','16:10:00',3.37),('8537','2013-04-11','16:15:00',3.28),('8537','2013-04-11','16:20:00',3.21),('8537','2013-04-11','16:25:00',3.13),('8537','2013-04-11','16:30:00',3.04),('8537','2013-04-11','16:35:00',2.95),('8537','2013-04-11','16:40:00',2.71),('8537','2013-04-11','16:45:00',2.14),('8537','2013-04-11','16:50:00',2.47),('8537','2013-04-11','16:55:00',2.54),('8537','2013-04-11','17:00:00',2.38),('8537','2013-04-11','17:05:00',2.25),('8537','2013-04-11','17:10:00',2.16),('8537','2013-04-11','17:15:00',2.07),('8537','2013-04-11','17:20:00',1.93),('8537','2013-04-11','17:25:00',1.83),('8537','2013-04-11','17:30:00',1.72),('8537','2013-04-11','17:35:00',1.62),('8537','2013-04-11','17:40:00',1.53),('8537','2013-04-11','17:45:00',1.42),('8537','2013-04-11','17:50:00',1.32),('8537','2013-04-11','17:55:00',1.19),('8537','2013-04-11','18:00:00',1.07),('8537','2013-04-10','08:55:00',2.04),('8537','2013-04-10','09:00:00',2.37),('8537','2013-04-10','09:05:00',2.58),('8537','2013-04-10','09:10:00',2.72),('8537','2013-04-10','09:15:00',2.58),('8537','2013-04-10','09:20:00',2.81),('8537','2013-04-10','09:25:00',2.62),('8537','2013-04-10','09:30:00',2.87),('8537','2013-04-10','09:35:00',3.15),('8537','2013-04-10','09:40:00',3.23),('8537','2013-04-10','09:45:00',3.35),('8537','2013-04-10','09:50:00',3.45),('8537','2013-04-10','09:55:00',3.57),('8537','2013-04-10','10:00:00',3.65),('8537','2013-04-10','10:05:00',3.79),('8537','2013-04-10','10:10:00',4.06),('8537','2013-04-10','10:15:00',4.16),('8537','2013-04-10','10:20:00',4.2),('8537','2013-04-10','10:25:00',4.25),('8537','2013-04-10','10:30:00',4.26),('8537','2013-04-10','10:35:00',4.28),('8537','2013-04-10','10:40:00',4.28),('8537','2013-04-10','10:45:00',4.44),('8537','2013-04-10','10:50:00',4.2),('8537','2013-04-10','10:55:00',4.09),('8537','2013-04-10','11:00:00',4.15),('8537','2013-04-10','11:05:00',4.15),('8537','2013-04-10','11:10:00',4.26),('8537','2013-04-10','11:15:00',3.66),('8537','2013-04-10','11:20:00',4.53),('8537','2013-04-10','11:25:00',4.32),('8537','2013-04-10','11:30:00',4.65),('8537','2013-04-10','11:35:00',4.77),('8537','2013-04-10','11:40:00',4.8),('8537','2013-04-10','11:45:00',4.81),('8537','2013-04-10','11:50:00',4.77),('8537','2013-04-10','11:55:00',4.91),('8537','2013-04-10','12:00:00',4.93),('8537','2013-04-10','12:05:00',4.99),('8537','2013-04-10','12:10:00',5.01),('8537','2013-04-10','12:15:00',5.02),('8537','2013-04-10','12:20:00',5.08),('8537','2013-04-10','12:25:00',5.12),('8537','2013-04-10','12:30:00',5.17),('8537','2013-04-10','12:35:00',5.13),('8537','2013-04-10','12:40:00',5.01),('8537','2013-04-10','12:45:00',5.12),('8537','2013-04-10','12:50:00',5.22),('8537','2013-04-10','12:55:00',5.14),('8537','2013-04-10','13:00:00',5.28),('8537','2013-04-10','13:05:00',4.71),('8537','2013-04-10','13:10:00',4.96),('8537','2013-04-10','13:15:00',3),('8537','2013-04-10','13:20:00',5.06),('8537','2013-04-10','13:25:00',2.39),('8537','2013-04-10','13:30:00',3.79),('8537','2013-04-10','13:35:00',4.35),('8537','2013-04-10','13:40:00',4.18),('8537','2013-04-10','13:45:00',5.04),('8537','2013-04-10','13:50:00',4.26),('8537','2013-04-10','13:55:00',2.64),('8537','2013-04-10','14:00:00',4.59),('8537','2013-04-10','14:05:00',5.08),('8537','2013-04-10','14:10:00',5.17),('8537','2013-04-10','14:15:00',5.01),('8537','2013-04-10','14:20:00',5.02),('8537','2013-04-10','14:25:00',4.95),('8537','2013-04-10','14:30:00',4.89),('8537','2013-04-10','14:35:00',4.72),('8537','2013-04-10','14:40:00',4.79),('8537','2013-04-10','14:45:00',4.16),('8537','2013-04-10','14:50:00',4.52),('8537','2013-04-10','14:55:00',4.48),('8537','2013-04-10','15:00:00',4.49),('8537','2013-04-10','15:05:00',3.92),('8537','2013-04-10','15:10:00',3.55),('8537','2013-04-10','15:15:00',3.67),('8537','2013-04-10','15:20:00',2.56),('8537','2013-04-10','15:25:00',4.14),('8537','2013-04-10','15:30:00',4.04),('8537','2013-04-10','15:35:00',3.23),('8537','2013-04-10','15:40:00',3.98),('8537','2013-04-10','15:45:00',3.94),('8537','2013-04-10','15:50:00',3.44),('8537','2013-04-10','15:55:00',3.99),('8537','2013-04-10','16:00:00',3.57),('8537','2013-04-10','16:05:00',3.08),('8537','2013-04-10','16:10:00',3.59),('8537','2013-04-10','16:15:00',3.21),('8537','2013-04-10','16:20:00',3.21),('8537','2013-04-10','16:25:00',3.19),('8537','2013-04-10','16:30:00',3.24),('8537','2013-04-10','16:35:00',1.82),('8537','2013-04-10','16:40:00',2.94),('8537','2013-04-10','16:45:00',2.57),('8537','2013-04-10','16:50:00',2.59),('8537','2013-04-10','16:55:00',1.18),('8537','2013-04-10','17:00:00',2.55),('8537','2013-04-10','17:05:00',2.47),('8537','2013-04-10','17:10:00',1.41),('8537','2013-04-10','17:15:00',1.87),('8537','2013-04-10','17:20:00',1.54),('8537','2013-04-10','17:25:00',1.19),('8537','2013-04-10','17:30:00',1.67),('8537','2013-04-10','17:40:00',1.35),('8537','2013-04-10','17:45:00',1.47),('8537','2013-04-10','17:50:00',1.21),('8537','2013-04-10','17:55:00',1.29),('8537','2013-04-10','18:00:00',1.15),('8537','2013-04-09','07:55:00',1.1),('8537','2013-04-09','08:00:00',1.36),('8537','2013-04-09','08:10:00',1.16),('8537','2013-04-09','08:20:00',1.56),('8537','2013-04-09','08:30:00',1.11),('8537','2013-04-09','08:35:00',1.14),('8537','2013-04-09','08:50:00',1.09),('8537','2013-04-09','09:05:00',1.12),('8537','2013-04-09','09:10:00',1.18),('8537','2013-04-09','09:15:00',1.31),('8537','2013-04-09','09:20:00',1.19),('8537','2013-04-09','09:25:00',1.26),('8537','2013-04-09','09:30:00',1.51),('8537','2013-04-09','09:45:00',2.27),('8537','2013-04-09','09:50:00',2.17),('8537','2013-04-09','09:55:00',4.14),('8537','2013-04-09','10:00:00',3.51),('8537','2013-04-09','10:05:00',1.44),('8537','2013-04-09','10:10:00',2.07),('8537','2013-04-09','10:15:00',2.7),('8537','2013-04-09','10:20:00',2.04),('8537','2013-04-09','10:25:00',1.27),('8537','2013-04-09','10:35:00',4.02),('8537','2013-04-09','10:40:00',3.17),('8537','2013-04-09','10:45:00',5.06),('8537','2013-04-09','10:50:00',4.87),('8537','2013-04-09','10:55:00',3.48),('8537','2013-04-09','11:00:00',4.88),('8537','2013-04-09','11:05:00',3.8),('8537','2013-04-09','11:10:00',5.01),('8537','2013-04-09','11:15:00',1.92),('8537','2013-04-09','11:20:00',1.17),('8537','2013-04-09','11:25:00',3.38),('8537','2013-04-09','11:30:00',4.92),('8537','2013-04-09','11:35:00',3.69),('8537','2013-04-09','11:40:00',1.71),('8537','2013-04-09','11:45:00',4.13),('8537','2013-04-09','11:50:00',4.77),('8537','2013-04-09','11:55:00',4.03),('8537','2013-04-09','12:00:00',5.44),('8537','2013-04-09','12:05:00',5.36),('8537','2013-04-09','12:10:00',5.38),('8537','2013-04-09','12:15:00',5.35),('8537','2013-04-09','12:20:00',5.01),('8537','2013-04-09','12:25:00',5.2),('8537','2013-04-09','12:30:00',5.24),('8537','2013-04-09','12:35:00',5.23),('8537','2013-04-09','12:40:00',5.32),('8537','2013-04-09','12:45:00',5.52),('8537','2013-04-09','12:50:00',5.42),('8537','2013-04-09','12:55:00',4.96),('8537','2013-04-09','13:00:00',5.07),('8537','2013-04-09','13:05:00',5.54),('8537','2013-04-09','13:10:00',5.68),('8537','2013-04-09','13:15:00',5.13),('8537','2013-04-09','13:20:00',2.37),('8537','2013-04-09','13:25:00',3.06),('8537','2013-04-09','13:30:00',2.63),('8537','2013-04-09','13:35:00',1.35),('8537','2013-04-09','13:40:00',4.01),('8537','2013-04-09','13:45:00',3.44),('8537','2013-04-09','13:50:00',3.69),('8537','2013-04-09','13:55:00',5.16),('8537','2013-04-09','14:00:00',4.87),('8537','2013-04-09','14:05:00',4.88),('8537','2013-04-09','14:10:00',2.92),('8537','2013-04-09','14:15:00',3.96),('8537','2013-04-09','14:20:00',2.75),('8537','2013-04-09','14:25:00',4.01),('8537','2013-04-09','14:30:00',3.72),('8537','2013-04-09','14:35:00',3.96),('8537','2013-04-09','14:40:00',4.31),('8537','2013-04-09','14:45:00',4.26),('8537','2013-04-09','14:50:00',4.02),('8537','2013-04-09','14:55:00',3.59),('8537','2013-04-09','15:00:00',3.87),('8537','2013-04-09','15:05:00',3.71),('8537','2013-04-09','15:10:00',4.64),('8537','2013-04-09','15:15:00',3.24),('8537','2013-04-09','15:20:00',4.21),('8537','2013-04-09','15:25:00',4.48),('8537','2013-04-09','15:30:00',3.03),('8537','2013-04-09','15:35:00',4.06),('8537','2013-04-09','15:40:00',3.82),('8537','2013-04-09','15:45:00',4.05),('8537','2013-04-09','15:50:00',4.15),('8537','2013-04-09','15:55:00',3.42),('8537','2013-04-09','16:00:00',3.11),('8537','2013-04-09','16:05:00',2.69),('8537','2013-04-09','16:10:00',2.74),('8537','2013-04-09','16:15:00',1.87),('8537','2013-04-09','16:25:00',1.18),('8537','2013-04-09','16:30:00',1.19),('8537','2013-04-09','16:35:00',1.24),('8537','2013-04-09','16:40:00',1.31),('8537','2013-04-09','16:45:00',1.17),('8537','2013-04-09','16:50:00',2.87),('8537','2013-04-09','16:55:00',2.65),('8537','2013-04-09','17:20:00',1.14),('8537','2013-04-09','17:25:00',1.21),('8537','2013-04-09','17:30:00',1.12),('8537','2013-04-08','08:10:00',1),('8537','2013-04-08','08:35:00',1.04),('8537','2013-04-08','08:40:00',1.95),('8537','2013-04-08','08:45:00',1.1),('8537','2013-04-08','08:50:00',1.75),('8537','2013-04-08','08:55:00',1.41),('8537','2013-04-08','09:00:00',1.85),('8537','2013-04-08','09:05:00',1.64),('8537','2013-04-08','09:10:00',2.64),('8537','2013-04-08','09:15:00',2.62),('8537','2013-04-08','09:20:00',2.38),('8537','2013-04-08','09:25:00',3.19),('8537','2013-04-08','09:30:00',3.22),('8537','2013-04-08','09:35:00',3.37),('8537','2013-04-08','09:40:00',3.41),('8537','2013-04-08','09:45:00',3.5),('8537','2013-04-08','09:50:00',2.17),('8537','2013-04-08','09:55:00',2.15),('8537','2013-04-08','10:00:00',3.7),('8537','2013-04-08','10:05:00',3.95),('8537','2013-04-08','10:10:00',3.73),('8537','2013-04-08','10:15:00',3.92),('8537','2013-04-08','10:20:00',3.86),('8537','2013-04-08','10:25:00',3.92),('8537','2013-04-08','10:30:00',4.01),('8537','2013-04-08','10:35:00',3.81),('8537','2013-04-08','10:40:00',4.21),('8537','2013-04-08','10:45:00',4.47),('8537','2013-04-08','10:50:00',4.46),('8537','2013-04-08','10:55:00',4.26),('8537','2013-04-08','11:00:00',4.47),('8537','2013-04-08','11:05:00',3.92),('8537','2013-04-08','11:10:00',3.62),('8537','2013-04-08','11:15:00',3.41),('8537','2013-04-08','11:20:00',2.85),('8537','2013-04-08','11:25:00',2.41),('8537','2013-04-08','11:30:00',2.65),('8537','2013-04-08','11:35:00',3.56),('8537','2013-04-08','11:40:00',3.89),('8537','2013-04-08','11:45:00',3.42),('8537','2013-04-08','11:50:00',3.19),('8537','2013-04-08','11:55:00',2.75),('8537','2013-04-08','12:00:00',2.61),('8537','2013-04-08','12:05:00',2.48),('8537','2013-04-08','12:10:00',2.66),('8537','2013-04-08','12:15:00',3.2),('8537','2013-04-08','12:20:00',3.28),('8537','2013-04-08','12:25:00',3.26),('8537','2013-04-08','12:30:00',3.61),('8537','2013-04-08','12:35:00',3.02),('8537','2013-04-08','12:40:00',2.83),('8537','2013-04-08','12:45:00',3.06),('8537','2013-04-08','12:50:00',2.99),('8537','2013-04-08','12:55:00',2.46),('8537','2013-04-08','13:00:00',1.94),('8537','2013-04-08','13:05:00',2.64),('8537','2013-04-08','13:10:00',3.27),('8537','2013-04-08','13:15:00',3.77),('8537','2013-04-08','13:20:00',4.37),('8537','2013-04-08','13:25:00',3.91),('8537','2013-04-08','13:30:00',3.41),('8537','2013-04-08','13:35:00',3.43),('8537','2013-04-08','13:40:00',3.52),('8537','2013-04-08','13:45:00',3.77),('8537','2013-04-08','13:50:00',3.54),('8537','2013-04-08','13:55:00',4.56),('8537','2013-04-08','14:00:00',4.54),('8537','2013-04-08','14:05:00',3.98),('8537','2013-04-08','14:10:00',4),('8537','2013-04-08','14:15:00',4.54),('8537','2013-04-08','14:20:00',4.04),('8537','2013-04-08','14:25:00',4.77),('8537','2013-04-08','14:30:00',4.63),('8537','2013-04-08','14:35:00',4.19),('8537','2013-04-08','14:40:00',3.95),('8537','2013-04-08','14:45:00',4.1),('8537','2013-04-08','14:50:00',4.28),('8537','2013-04-08','14:55:00',4.63),('8537','2013-04-08','15:00:00',3.62),('8537','2013-04-08','15:05:00',3.39),('8537','2013-04-08','15:10:00',3.32),('8537','2013-04-08','15:15:00',3.58),('8537','2013-04-08','15:20:00',3.39),('8537','2013-04-08','15:25:00',3.93),('8537','2013-04-08','15:30:00',4.22),('8537','2013-04-08','15:35:00',4.05),('8537','2013-04-08','15:40:00',3.9),('8537','2013-04-08','15:45:00',3.77),('8537','2013-04-08','15:50:00',3.77),('8537','2013-04-08','15:55:00',3.69),('8537','2013-04-08','16:00:00',3.55),('8537','2013-04-08','16:05:00',3.27),('8537','2013-04-08','16:10:00',3.14),('8537','2013-04-08','16:15:00',3.31),('8537','2013-04-08','16:20:00',3.31),('8537','2013-04-08','16:25:00',3.14),('8537','2013-04-08','16:30:00',3.06),('8537','2013-04-08','16:35:00',2.98),('8537','2013-04-08','16:40:00',2.68),('8537','2013-04-08','16:45:00',2.77),('8537','2013-04-08','16:50:00',2.68),('8537','2013-04-08','16:55:00',2.58),('8537','2013-04-08','17:00:00',2.41),('8537','2013-04-08','17:05:00',2.32),('8537','2013-04-08','17:10:00',2.16),('8537','2013-04-08','17:15:00',2.07),('8537','2013-04-08','17:20:00',1.9),('8537','2013-04-08','17:25:00',1.95),('8537','2013-04-08','17:30:00',1.76),('8537','2013-04-08','17:35:00',1.64),('8537','2013-04-08','17:40:00',1.46),('8537','2013-04-08','17:45:00',1.34),('8537','2013-04-08','17:50:00',1.08),('8537','2013-04-08','18:20:00',1.01),('8537','2013-04-07','08:25:00',1.12),('8537','2013-04-07','08:30:00',1.28),('8537','2013-04-07','08:35:00',1.42),('8537','2013-04-07','08:40:00',1.54),('8537','2013-04-07','08:45:00',1.57),('8537','2013-04-07','08:50:00',1.57),('8537','2013-04-07','08:55:00',1.63),('8537','2013-04-07','09:00:00',1.61),('8537','2013-04-07','09:05:00',1.66),('8537','2013-04-07','09:10:00',1.82),('8537','2013-04-07','09:15:00',1.8),('8537','2013-04-07','09:20:00',1.89),('8537','2013-04-07','09:25:00',1.86),('8537','2013-04-07','09:30:00',1.78),('8537','2013-04-07','09:35:00',1.69),('8537','2013-04-07','09:40:00',1.7),('8537','2013-04-07','09:45:00',2.19),('8537','2013-04-07','09:50:00',2.47),('8537','2013-04-07','09:55:00',2.69),('8537','2013-04-07','10:00:00',3.18),('8537','2013-04-07','10:05:00',3.31),('8537','2013-04-07','10:10:00',3.26),('8537','2013-04-07','10:15:00',3.47),('8537','2013-04-07','10:20:00',3.42),('8537','2013-04-07','10:25:00',3.45),('8537','2013-04-07','10:30:00',3),('8537','2013-04-07','10:35:00',3.32),('8537','2013-04-07','10:40:00',3.31),('8537','2013-04-07','10:45:00',3.23),('8537','2013-04-07','10:50:00',3.11),('8537','2013-04-07','10:55:00',2.73),('8537','2013-04-07','11:00:00',2.51),('8537','2013-04-07','11:05:00',2.19),('8537','2013-04-07','11:10:00',2.59),('8537','2013-04-07','11:15:00',3.6),('8537','2013-04-07','11:20:00',4.11),('8537','2013-04-07','11:25:00',4.55),('8537','2013-04-07','11:30:00',4.27),('8537','2013-04-07','11:35:00',4.09),('8537','2013-04-07','11:40:00',3.63),('8537','2013-04-07','11:45:00',2.97),('8537','2013-04-07','11:50:00',2.74),('8537','2013-04-07','11:55:00',2.88),('8537','2013-04-07','12:00:00',2.98),('8537','2013-04-07','12:05:00',2.9),('8537','2013-04-07','12:10:00',3.17),('8537','2013-04-07','12:15:00',3.04),('8537','2013-04-07','12:20:00',3.37),('8537','2013-04-07','12:25:00',3.67),('8537','2013-04-07','12:30:00',3.2),('8537','2013-04-07','12:35:00',3.46),('8537','2013-04-07','12:40:00',3.31),('8537','2013-04-07','12:45:00',2.83),('8537','2013-04-07','12:50:00',3.16),('8537','2013-04-07','12:55:00',3.21),('8537','2013-04-07','13:00:00',3.87),('8537','2013-04-07','13:05:00',4.25),('8537','2013-04-07','13:10:00',4.03),('8537','2013-04-07','13:15:00',3.68),('8537','2013-04-07','13:20:00',3.41),('8537','2013-04-07','13:25:00',3.94),('8537','2013-04-07','13:30:00',3.91),('8537','2013-04-07','13:35:00',3.65),('8537','2013-04-07','13:40:00',4.05),('8537','2013-04-07','13:45:00',4.03),('8537','2013-04-07','13:50:00',3.74),('8537','2013-04-07','13:55:00',3.62),('8537','2013-04-07','14:00:00',4.44),('8537','2013-04-07','14:05:00',3.83),('8537','2013-04-07','14:10:00',2.97),('8537','2013-04-07','14:15:00',2.94),('8537','2013-04-07','14:20:00',2.63),('8537','2013-04-07','14:25:00',2.71),('8537','2013-04-07','14:30:00',2.53),('8537','2013-04-07','14:35:00',2.85),('8537','2013-04-07','14:40:00',2.6),('8537','2013-04-07','14:45:00',2.48),('8537','2013-04-07','14:50:00',2.61),('8537','2013-04-07','14:55:00',3.03),('8537','2013-04-07','15:00:00',2.32),('8537','2013-04-07','15:05:00',3.46),('8537','2013-04-07','15:10:00',3.4),('8537','2013-04-07','15:15:00',3.49),('8537','2013-04-07','15:20:00',3.26),('8537','2013-04-07','15:25:00',3.32),('8537','2013-04-07','15:30:00',3.49),('8537','2013-04-07','15:35:00',3.28),('8537','2013-04-07','15:40:00',3.38),('8537','2013-04-07','15:45:00',3.11),('8537','2013-04-07','15:50:00',3.03),('8537','2013-04-07','15:55:00',2.87),('8537','2013-04-07','16:00:00',2.8),('8537','2013-04-07','16:05:00',2.39),('8537','2013-04-07','16:10:00',2.02),('8537','2013-04-07','16:15:00',1.81),('8537','2013-04-07','16:20:00',1.71),('8537','2013-04-07','16:25:00',1.54),('8537','2013-04-07','16:30:00',1.54),('8537','2013-04-07','16:35:00',1.77),('8537','2013-04-07','16:40:00',1.79),('8537','2013-04-07','16:45:00',2.18),('8537','2013-04-07','16:50:00',2.57),('8537','2013-04-07','16:55:00',2.48),('8537','2013-04-07','17:00:00',2.26),('8537','2013-04-07','17:05:00',1.86),('8537','2013-04-07','17:10:00',1.19),('8537','2013-04-07','17:15:00',1.04),('8537','2013-04-07','17:20:00',1.51),('8537','2013-04-07','17:25:00',1.76),('8537','2013-04-07','17:30:00',1.65),('8537','2013-04-07','17:35:00',1.75),('8537','2013-04-07','17:40:00',1.73),('8537','2013-04-07','17:45:00',1.63),('8537','2013-04-07','17:50:00',1.47),('8537','2013-04-07','17:55:00',1.24),('8537','2013-04-06','08:00:00',1.02),('8537','2013-04-06','08:05:00',1.12),('8537','2013-04-06','08:10:00',1.22),('8537','2013-04-06','08:15:00',1.33),('8537','2013-04-06','08:20:00',1.43),('8537','2013-04-06','08:25:00',1.54),('8537','2013-04-06','08:30:00',1.67),('8537','2013-04-06','08:35:00',1.79),('8537','2013-04-06','08:40:00',1.88),('8537','2013-04-06','08:45:00',2),('8537','2013-04-06','08:50:00',2.1),('8537','2013-04-06','08:55:00',2.21),('8537','2013-04-06','09:00:00',2.31),('8537','2013-04-06','09:05:00',2.42),('8537','2013-04-06','09:10:00',2.53),('8537','2013-04-06','09:15:00',2.65),('8537','2013-04-06','09:20:00',2.77),('8537','2013-04-06','09:25:00',2.88),('8537','2013-04-06','09:30:00',2.97),('8537','2013-04-06','09:35:00',3.02),('8537','2013-04-06','09:40:00',3.14),('8537','2013-04-06','09:45:00',3.2),('8537','2013-04-06','09:50:00',3.27),('8537','2013-04-06','09:55:00',3.3),('8537','2013-04-06','10:00:00',3.47),('8537','2013-04-06','10:05:00',3.55),('8537','2013-04-06','10:10:00',3.59),('8537','2013-04-06','10:15:00',3.64),('8537','2013-04-06','10:20:00',3.8),('8537','2013-04-06','10:25:00',3.8),('8537','2013-04-06','10:30:00',3.86),('8537','2013-04-06','10:35:00',3.93),('8537','2013-04-06','10:40:00',4.01),('8537','2013-04-06','10:45:00',4.07),('8537','2013-04-06','10:50:00',4.1),('8537','2013-04-06','10:55:00',4.19),('8537','2013-04-06','11:00:00',4.27),('8537','2013-04-06','11:05:00',4.34),('8537','2013-04-06','11:10:00',4.39),('8537','2013-04-06','11:15:00',4.45),('8537','2013-04-06','11:20:00',4.53),('8537','2013-04-06','11:25:00',4.52),('8537','2013-04-06','11:30:00',4.57),('8537','2013-04-06','11:35:00',4.58),('8537','2013-04-06','11:40:00',4.62),('8537','2013-04-06','11:45:00',4.65),('8537','2013-04-06','11:50:00',4.68),('8537','2013-04-06','11:55:00',4.71),('8537','2013-04-06','12:00:00',4.74),('8537','2013-04-06','12:05:00',4.74),('8537','2013-04-06','12:10:00',4.79),('8537','2013-04-06','12:15:00',4.81),('8537','2013-04-06','12:20:00',4.88),('8537','2013-04-06','12:25:00',3.27),('8537','2013-04-06','12:30:00',5.09),('8537','2013-04-06','12:35:00',5.04),('8537','2013-04-06','12:40:00',5.02),('8537','2013-04-06','12:45:00',5.07),('8537','2013-04-06','12:50:00',5.06),('8537','2013-04-06','12:55:00',5.03),('8537','2013-04-06','13:00:00',5.07),('8537','2013-04-06','13:05:00',4.87),('8537','2013-04-06','13:10:00',2.4),('8537','2013-04-06','13:15:00',1.27),('8537','2013-04-06','13:20:00',1.76),('8537','2013-04-06','13:25:00',2.45),('8537','2013-04-06','13:30:00',4.18),('8537','2013-04-06','13:35:00',4.32),('8537','2013-04-06','13:40:00',5.55),('8537','2013-04-06','13:45:00',5.52),('8537','2013-04-06','13:50:00',5.17),('8537','2013-04-06','13:55:00',5.32),('8537','2013-04-06','14:00:00',2.64),('8537','2013-04-06','14:05:00',2.43),('8537','2013-04-06','14:10:00',4.41),('8537','2013-04-06','14:15:00',3.17),('8537','2013-04-06','14:20:00',1.88),('8537','2013-04-06','14:25:00',1.36),('8537','2013-04-06','14:30:00',2.92),('8537','2013-04-06','14:35:00',4.44),('8537','2013-04-06','14:45:00',4.32),('8537','2013-04-06','14:50:00',4.64),('8537','2013-04-06','14:55:00',4.7),('8537','2013-04-06','15:00:00',4.38),('8537','2013-04-06','15:05:00',4.45),('8537','2013-04-06','15:10:00',4.21),('8537','2013-04-06','15:15:00',4.13),('8537','2013-04-06','15:20:00',4.07),('8537','2013-04-06','15:25:00',3.88),('8537','2013-04-06','15:30:00',3.8),('8537','2013-04-06','15:35:00',3.75),('8537','2013-04-06','15:40:00',3.73),('8537','2013-04-06','15:45:00',3.42),('8537','2013-04-06','15:50:00',3.32),('8537','2013-04-06','15:55:00',3.6),('8537','2013-04-06','16:00:00',3.27),('8537','2013-04-06','16:05:00',3.17),('8537','2013-04-06','16:10:00',3.32),('8537','2013-04-06','16:15:00',3.04),('8537','2013-04-06','16:20:00',2.6),('8537','2013-04-06','16:25:00',2.21),('8537','2013-04-06','16:30:00',2.7),('8537','2013-04-06','16:35:00',2.52),('8537','2013-04-06','16:40:00',1.93),('8537','2013-04-06','16:45:00',2.65),('8537','2013-04-06','16:50:00',2.47),('8537','2013-04-06','16:55:00',2.17),('8537','2013-04-06','17:00:00',2.07),('8537','2013-04-06','17:05:00',1.82),('8537','2013-04-06','17:10:00',1.63),('8537','2013-04-06','17:15:00',1.26),('8537','2013-04-06','17:25:00',1.04),('8537','2013-04-06','17:30:00',1.02),('8537','2013-04-05','08:15:00',1.33),('8537','2013-04-05','08:20:00',1.47),('8537','2013-04-05','08:25:00',1.02),('8537','2013-04-05','08:55:00',2),('8537','2013-04-05','09:00:00',1.07),('8537','2013-04-05','09:05:00',2.9),('8537','2013-04-05','09:10:00',1.63),('8537','2013-04-05','09:15:00',2.91),('8537','2013-04-05','09:20:00',2.22),('8537','2013-04-05','09:25:00',1.27),('8537','2013-04-05','09:35:00',1.25),('8537','2013-04-05','09:40:00',2.64),('8537','2013-04-05','09:45:00',2.54),('8537','2013-04-05','09:50:00',1.42),('8537','2013-04-05','09:55:00',1.21),('8537','2013-04-05','10:00:00',1.97),('8537','2013-04-05','10:05:00',1.07),('8537','2013-04-05','10:10:00',2.93),('8537','2013-04-05','10:15:00',3.73),('8537','2013-04-05','10:20:00',1.47),('8537','2013-04-05','10:25:00',2.98),('8537','2013-04-05','10:30:00',2.08),('8537','2013-04-05','10:35:00',1.62),('8537','2013-04-05','10:40:00',3.96),('8537','2013-04-05','10:45:00',2.45),('8537','2013-04-05','10:50:00',3.27),('8537','2013-04-05','10:55:00',2.63),('8537','2013-04-05','11:00:00',2.1),('8537','2013-04-05','11:05:00',3.68),('8537','2013-04-05','11:10:00',4.91),('8537','2013-04-05','11:15:00',4.94),('8537','2013-04-05','11:20:00',3.94),('8537','2013-04-05','11:25:00',4.41),('8537','2013-04-05','11:30:00',4.49),('8537','2013-04-05','11:35:00',5.05),('8537','2013-04-05','11:40:00',5.2),('8537','2013-04-05','11:45:00',4.18),('8537','2013-04-05','11:50:00',4.89),('8537','2013-04-05','11:55:00',5.13),('8537','2013-04-05','12:00:00',5.67),('8537','2013-04-05','12:05:00',3.2),('8537','2013-04-05','12:10:00',2.28),('8537','2013-04-05','12:15:00',3.75),('8537','2013-04-05','12:20:00',1.71),('8537','2013-04-05','12:25:00',2.68),('8537','2013-04-05','12:30:00',1.47),('8537','2013-04-05','12:35:00',1.56),('8537','2013-04-05','12:40:00',2.25),('8537','2013-04-05','12:45:00',3.97),('8537','2013-04-05','12:50:00',4.79),('8537','2013-04-05','12:55:00',5.58),('8537','2013-04-05','13:00:00',3.98),('8537','2013-04-05','13:05:00',3.94),('8537','2013-04-05','13:10:00',3.98),('8537','2013-04-05','13:15:00',4.63),('8537','2013-04-05','13:20:00',4.08),('8537','2013-04-05','13:25:00',5.1),('8537','2013-04-05','13:30:00',4.02),('8537','2013-04-05','13:35:00',4.23),('8537','2013-04-05','13:40:00',4.72),('8537','2013-04-05','13:45:00',3.47),('8537','2013-04-05','13:50:00',5.51),('8537','2013-04-05','13:55:00',4.89),('8537','2013-04-05','14:00:00',3.17),('8537','2013-04-05','14:05:00',5.62),('8537','2013-04-05','14:10:00',4.7),('8537','2013-04-05','14:15:00',4.88),('8537','2013-04-05','14:20:00',4.54),('8537','2013-04-05','14:25:00',5.26),('8537','2013-04-05','14:30:00',4.42),('8537','2013-04-05','14:35:00',4.39),('8537','2013-04-05','14:40:00',4.16),('8537','2013-04-05','14:45:00',4.8),('8537','2013-04-05','14:50:00',2.91),('8537','2013-04-05','14:55:00',5.56),('8537','2013-04-05','15:00:00',4.3),('8537','2013-04-05','15:05:00',3.39),('8537','2013-04-05','15:10:00',3.79),('8537','2013-04-05','15:15:00',1.96),('8537','2013-04-05','15:20:00',1.99),('8537','2013-04-05','15:25:00',2.94),('8537','2013-04-05','15:30:00',2.19),('8537','2013-04-05','15:35:00',1.67),('8537','2013-04-05','15:40:00',1.39),('8537','2013-04-05','15:45:00',1.72),('8537','2013-04-05','15:50:00',2.2),('8537','2013-04-05','15:55:00',1.96),('8537','2013-04-05','16:00:00',2.05),('8537','2013-04-05','16:05:00',1.89),('8537','2013-04-05','16:10:00',1.83),('8537','2013-04-05','16:15:00',2.45),('8537','2013-04-05','16:20:00',2.49),('8537','2013-04-05','16:25:00',2.09),('8537','2013-04-05','16:30:00',1.81),('8537','2013-04-05','16:35:00',2.4),('8537','2013-04-05','16:40:00',1.66),('8537','2013-04-05','16:45:00',2.04),('8537','2013-04-05','16:50:00',2.67),('8537','2013-04-05','16:55:00',1.84),('8537','2013-04-05','17:00:00',1.55),('8537','2013-04-05','17:05:00',1.24),('8537','2013-04-05','17:10:00',1.95),('8537','2013-04-05','17:15:00',2.14),('8537','2013-04-05','17:20:00',1.76),('8537','2013-04-05','17:25:00',1.71),('8537','2013-04-05','17:30:00',1.96),('8537','2013-04-05','17:35:00',1.24),('8537','2013-04-05','17:40:00',1.38),('8537','2013-04-05','17:55:00',1.34),('8537','2013-04-05','18:00:00',1.07),('8537','2013-04-04','08:35:00',1.03),('8537','2013-04-04','08:55:00',1.58),('8537','2013-04-04','09:00:00',2.37),('8537','2013-04-04','09:05:00',1.74),('8537','2013-04-04','09:10:00',1.54),('8537','2013-04-04','09:15:00',1.55),('8537','2013-04-04','09:20:00',1.58),('8537','2013-04-04','09:25:00',1.16),('8537','2013-04-04','09:30:00',1.74),('8537','2013-04-04','09:35:00',2.93),('8537','2013-04-04','09:40:00',2.83),('8537','2013-04-04','09:45:00',2.45),('8537','2013-04-04','09:50:00',1.3),('8537','2013-04-04','09:55:00',1.42),('8537','2013-04-04','10:00:00',2.15),('8537','2013-04-04','10:05:00',2.88),('8537','2013-04-04','10:10:00',2.55),('8537','2013-04-04','10:15:00',1.82),('8537','2013-04-04','10:20:00',2.06),('8537','2013-04-04','10:25:00',4.01),('8537','2013-04-04','10:30:00',3.7),('8537','2013-04-04','10:35:00',2.27),('8537','2013-04-04','10:40:00',4.6),('8537','2013-04-04','10:45:00',2.54),('8537','2013-04-04','10:50:00',2.7),('8537','2013-04-04','10:55:00',4.4),('8537','2013-04-04','11:00:00',2.72),('8537','2013-04-04','11:05:00',1.46),('8537','2013-04-04','11:10:00',1.23),('8537','2013-04-04','11:15:00',1.64),('8537','2013-04-04','11:20:00',1.61),('8537','2013-04-04','11:25:00',1.22),('8537','2013-04-04','11:30:00',1.34),('8537','2013-04-04','11:35:00',1.96),('8537','2013-04-04','11:40:00',3.39),('8537','2013-04-04','11:45:00',4.11),('8537','2013-04-04','11:50:00',4.66),('8537','2013-04-04','11:55:00',4.85),('8537','2013-04-04','12:00:00',4.85),('8537','2013-04-04','12:05:00',4.68),('8537','2013-04-04','12:10:00',4.73),('8537','2013-04-04','12:15:00',4.58),('8537','2013-04-04','12:20:00',3.89),('8537','2013-04-04','12:25:00',3.61),('8537','2013-04-04','12:30:00',3.3),('8537','2013-04-04','12:35:00',2.95),('8537','2013-04-04','12:40:00',4.44),('8537','2013-04-04','12:45:00',4.03),('8537','2013-04-04','12:50:00',4.92),('8537','2013-04-04','12:55:00',4.59),('8537','2013-04-04','13:00:00',4.46),('8537','2013-04-04','13:05:00',4.5),('8537','2013-04-04','13:10:00',4.62),('8537','2013-04-04','13:15:00',4.85),('8537','2013-04-04','13:20:00',4.7),('8537','2013-04-04','13:25:00',4.81),('8537','2013-04-04','13:30:00',4.73),('8537','2013-04-04','13:35:00',4.31),('8537','2013-04-04','13:40:00',3.67),('8537','2013-04-04','13:45:00',3.88),('8537','2013-04-04','13:50:00',3.83),('8537','2013-04-04','13:55:00',2.89),('8537','2013-04-04','14:00:00',3.04),('8537','2013-04-04','14:05:00',4.02),('8537','2013-04-04','14:10:00',4.58),('8537','2013-04-04','14:15:00',4.6),('8537','2013-04-04','14:20:00',4.55),('8537','2013-04-04','14:25:00',4.45),('8537','2013-04-04','14:30:00',4.4),('8537','2013-04-04','14:35:00',4.21),('8537','2013-04-04','14:40:00',4.32),('8537','2013-04-04','14:45:00',4.31),('8537','2013-04-04','14:50:00',4.24),('8537','2013-04-04','14:55:00',4.22),('8537','2013-04-04','15:00:00',4.16),('8537','2013-04-04','15:05:00',4.02),('8537','2013-04-04','15:10:00',3.82),('8537','2013-04-04','15:15:00',3.8),('8537','2013-04-04','15:20:00',3.79),('8537','2013-04-04','15:25:00',3.8),('8537','2013-04-04','15:30:00',3.76),('8537','2013-04-04','15:35:00',3.68),('8537','2013-04-04','15:40:00',3.59),('8537','2013-04-04','15:45:00',3.51),('8537','2013-04-04','15:50:00',3.37),('8537','2013-04-04','15:55:00',3.33),('8537','2013-04-04','16:00:00',3.24),('8537','2013-04-04','16:05:00',2.98),('8537','2013-04-04','16:10:00',2.85),('8537','2013-04-04','16:15:00',2.76),('8537','2013-04-04','16:20:00',2.5),('8537','2013-04-04','16:25:00',2.43),('8537','2013-04-04','16:30:00',2.03),('8537','2013-04-04','16:35:00',2.07),('8537','2013-04-04','16:40:00',2.06),('8537','2013-04-04','16:45:00',1.99),('8537','2013-04-04','16:50:00',1.59),('8537','2013-04-04','16:55:00',1.92),('8537','2013-04-04','17:00:00',1.8),('8537','2013-04-04','17:05:00',1.81),('8537','2013-04-04','17:10:00',1.62),('8537','2013-04-04','17:15:00',1.51),('8537','2013-04-04','17:20:00',1.08),('8537','2013-04-04','17:25:00',1.07),('8537','2013-04-04','17:55:00',1.09),('8537','2013-04-03','08:05:00',1.1),('8537','2013-04-03','08:10:00',1.22),('8537','2013-04-03','08:15:00',1.34),('8537','2013-04-03','08:20:00',1.48),('8537','2013-04-03','08:25:00',1.24),('8537','2013-04-03','08:30:00',1.75),('8537','2013-04-03','08:35:00',1.82),('8537','2013-04-03','08:40:00',1.29),('8537','2013-04-03','08:45:00',1.3),('8537','2013-04-03','08:50:00',1.68),('8537','2013-04-03','08:55:00',2.04),('8537','2013-04-03','09:00:00',2.46),('8537','2013-04-03','09:05:00',2.13),('8537','2013-04-03','09:10:00',2.8),('8537','2013-04-03','09:15:00',2.95),('8537','2013-04-03','09:20:00',2.43),('8537','2013-04-03','09:25:00',1.68),('8537','2013-04-03','09:30:00',2.34),('8537','2013-04-03','09:35:00',3.71),('8537','2013-04-03','09:40:00',3.61),('8537','2013-04-03','09:45:00',3.07),('8537','2013-04-03','09:50:00',3.12),('8537','2013-04-03','09:55:00',3.91),('8537','2013-04-03','10:00:00',3.15),('8537','2013-04-03','10:05:00',1.45),('8537','2013-04-03','10:10:00',1.34),('8537','2013-04-03','10:15:00',1.79),('8537','2013-04-03','10:20:00',3.78),('8537','2013-04-03','10:25:00',3.86),('8537','2013-04-03','10:30:00',3.6),('8537','2013-04-03','10:35:00',2.43),('8537','2013-04-03','10:40:00',2.19),('8537','2013-04-03','10:45:00',1.56),('8537','2013-04-03','10:50:00',2.66),('8537','2013-04-03','10:55:00',1.77),('8537','2013-04-03','11:00:00',4.08),('8537','2013-04-03','11:05:00',3.96),('8537','2013-04-03','11:10:00',3.26),('8537','2013-04-03','11:15:00',3.83),('8537','2013-04-03','11:20:00',4.27),('8537','2013-04-03','11:25:00',2.72),('8537','2013-04-03','11:30:00',2.03),('8537','2013-04-03','11:35:00',2.15),('8537','2013-04-03','11:40:00',2.57),('8537','2013-04-03','11:45:00',1.79),('8537','2013-04-03','11:50:00',4.22),('8537','2013-04-03','11:55:00',3.17),('8537','2013-04-03','12:00:00',3.83),('8537','2013-04-03','12:05:00',5.67),('8537','2013-04-03','12:10:00',4.3),('8537','2013-04-03','12:15:00',2.39),('8537','2013-04-03','12:20:00',4.41),('8537','2013-04-03','12:25:00',4.87),('8537','2013-04-03','12:30:00',4.63),('8537','2013-04-03','12:35:00',4.4),('8537','2013-04-03','12:40:00',5.56),('8537','2013-04-03','12:45:00',5.45),('8537','2013-04-03','12:50:00',4.89),('8537','2013-04-03','12:55:00',3.97),('8537','2013-04-03','13:00:00',4.57),('8537','2013-04-03','13:05:00',4.61),('8537','2013-04-03','13:10:00',3.38),('8537','2013-04-03','13:15:00',5.79),('8537','2013-04-03','13:20:00',4.23),('8537','2013-04-03','13:25:00',3.91),('8537','2013-04-03','13:30:00',2.9),('8537','2013-04-03','13:35:00',4.76),('8537','2013-04-03','13:40:00',4.38),('8537','2013-04-03','13:45:00',3.65),('8537','2013-04-03','13:50:00',3.69),('8537','2013-04-03','13:55:00',3.28),('8537','2013-04-03','14:00:00',4.69),('8537','2013-04-03','14:05:00',5.22),('8537','2013-04-03','14:10:00',4.82),('8537','2013-04-03','14:15:00',4.17),('8537','2013-04-03','14:20:00',2.4),('8537','2013-04-03','14:25:00',3.52),('8537','2013-04-03','14:30:00',4.14),('8537','2013-04-03','14:35:00',3.04),('8537','2013-04-03','14:40:00',3.53),('8537','2013-04-03','14:45:00',3.42),('8537','2013-04-03','14:50:00',2.82),('8537','2013-04-03','14:55:00',3.24),('8537','2013-04-03','15:00:00',4.26),('8537','2013-04-03','15:05:00',3.52),('8537','2013-04-03','15:10:00',4.42),('8537','2013-04-03','15:15:00',5.04),('8537','2013-04-03','15:20:00',4.56),('8537','2013-04-03','15:25:00',4.62),('8537','2013-04-03','15:30:00',2.87),('8537','2013-04-03','15:35:00',2.68),('8537','2013-04-03','15:40:00',4.16),('8537','2013-04-03','15:45:00',3.68),('8537','2013-04-03','15:50:00',4.32),('8537','2013-04-03','15:55:00',4.19),('8537','2013-04-03','16:00:00',3.95),('8537','2013-04-03','16:05:00',3.66),('8537','2013-04-03','16:10:00',3.74),('8537','2013-04-03','16:15:00',3.57),('8537','2013-04-03','16:20:00',3.45),('8537','2013-04-03','16:25:00',3.34),('8537','2013-04-03','16:30:00',3.23),('8537','2013-04-03','16:35:00',3.24),('8537','2013-04-03','16:40:00',3.02),('8537','2013-04-03','16:45:00',2.91),('8537','2013-04-03','16:50:00',2.82),('8537','2013-04-03','16:55:00',2.67),('8537','2013-04-03','17:00:00',2.51),('8537','2013-04-03','17:05:00',2.43),('8537','2013-04-03','17:10:00',2.32),('8537','2013-04-03','17:15:00',2.21),('8537','2013-04-03','17:20:00',2.07),('8537','2013-04-03','17:25:00',1.91),('8537','2013-04-03','17:30:00',1.81),('8537','2013-04-03','17:35:00',1.68),('8537','2013-04-03','17:40:00',1.58),('8537','2013-04-03','17:45:00',1.45),('8537','2013-04-03','17:50:00',1.34),('8537','2013-04-03','17:55:00',1.24),('8537','2013-04-03','18:00:00',1.12),('8537','2013-04-02','08:40:00',1.82),('8537','2013-04-02','08:45:00',2.14),('8537','2013-04-02','08:50:00',1.55),('8537','2013-04-02','08:55:00',1.31),('8537','2013-04-02','09:00:00',2.35),('8537','2013-04-02','09:05:00',2.45),('8537','2013-04-02','09:10:00',2.59),('8537','2013-04-02','09:15:00',2.82),('8537','2013-04-02','09:20:00',2.14),('8537','2013-04-02','09:25:00',1.2),('8537','2013-04-02','09:30:00',3.28),('8537','2013-04-02','09:35:00',3.02),('8537','2013-04-02','09:40:00',2.88),('8537','2013-04-02','09:45:00',3.47),('8537','2013-04-02','09:50:00',1.95),('8537','2013-04-02','09:55:00',2.41),('8537','2013-04-02','10:00:00',2.26),('8537','2013-04-02','10:05:00',2.34),('8537','2013-04-02','10:10:00',1.49),('8537','2013-04-02','10:15:00',1.53),('8537','2013-04-02','10:20:00',2.52),('8537','2013-04-02','10:25:00',1.76),('8537','2013-04-02','10:35:00',1.74),('8537','2013-04-02','10:40:00',1.93),('8537','2013-04-02','10:45:00',3.58),('8537','2013-04-02','10:50:00',4.27),('8537','2013-04-02','10:55:00',2.21),('8537','2013-04-02','11:00:00',1.12),('8537','2013-04-02','11:05:00',3.13),('8537','2013-04-02','11:10:00',2.81),('8537','2013-04-02','11:15:00',1.19),('8537','2013-04-02','11:25:00',1.17),('8537','2013-04-02','11:30:00',1.17),('8537','2013-04-02','11:35:00',1.88),('8537','2013-04-02','11:45:00',1.98),('8537','2013-04-02','11:50:00',2.1),('8537','2013-04-02','11:55:00',1.63),('8537','2013-04-02','12:00:00',1.21),('8537','2013-04-02','12:05:00',3.01),('8537','2013-04-02','12:10:00',2.64),('8537','2013-04-02','12:15:00',2.89),('8537','2013-04-02','12:35:00',1.91),('8537','2013-04-02','12:40:00',2.7),('8537','2013-04-02','12:45:00',2.44),('8537','2013-04-02','12:50:00',2.35),('8537','2013-04-02','12:55:00',2.65),('8537','2013-04-02','13:00:00',2.48),('8537','2013-04-02','13:05:00',2.93),('8537','2013-04-02','13:10:00',3.77),('8537','2013-04-02','13:15:00',2.68),('8537','2013-04-02','13:20:00',2.18),('8537','2013-04-02','13:25:00',3.93),('8537','2013-04-02','13:30:00',3.16),('8537','2013-04-02','13:35:00',2.17),('8537','2013-04-02','13:40:00',2.88),('8537','2013-04-02','13:45:00',2.92),('8537','2013-04-02','13:50:00',2.42),('8537','2013-04-02','13:55:00',1.99),('8537','2013-04-02','14:00:00',3.04),('8537','2013-04-02','14:05:00',2.65),('8537','2013-04-02','14:10:00',4.05),('8537','2013-04-02','14:15:00',2.73),('8537','2013-04-02','14:20:00',4.98),('8537','2013-04-02','14:25:00',5.63),('8537','2013-04-02','14:30:00',3.62),('8537','2013-04-02','14:35:00',2.16),('8537','2013-04-02','14:40:00',2.67),('8537','2013-04-02','14:45:00',2.6),('8537','2013-04-02','14:50:00',2.32),('8537','2013-04-02','14:55:00',1.89),('8537','2013-04-02','15:00:00',1.85),('8537','2013-04-02','15:40:00',1),('8537','2013-04-02','15:45:00',1.36),('8537','2013-04-02','16:00:00',1.11),('8537','2013-04-02','16:05:00',1.34),('8537','2013-04-02','16:10:00',1.02),('8537','2013-04-02','16:15:00',1.2),('8537','2013-04-02','16:20:00',1.25),('8537','2013-04-02','16:25:00',1.05),('8537','2013-04-02','16:30:00',1.04),('8537','2013-04-02','16:35:00',1.16),('8537','2013-04-02','16:40:00',1.01),('8537','2013-04-02','17:40:00',1.13),('8537','2013-04-02','17:45:00',1.24),('8537','2014-05-02','07:30:00',1.06),('8537','2014-05-02','07:35:00',1.05),('8537','2014-05-02','07:40:00',1.13),('8537','2014-05-02','07:45:00',1.22),('8537','2014-05-02','07:50:00',1.23),('8537','2014-05-02','08:00:00',1.51),('8537','2014-05-02','08:05:00',1.54),('8537','2014-05-02','08:15:00',1.92),('8537','2014-05-02','08:20:00',2.47),('8537','2014-05-02','08:25:00',1.49),('8537','2014-05-02','08:30:00',1.15),('8537','2014-05-02','08:45:00',1.22),('8537','2014-05-02','08:50:00',1.39),('8537','2014-05-02','09:15:00',1.23),('8537','2014-05-02','09:20:00',1.54),('8537','2014-05-02','09:25:00',1.79),('8537','2014-05-02','09:30:00',2.24),('8537','2014-05-02','09:35:00',1.95),('8537','2014-05-02','09:40:00',1.62),('8537','2014-05-02','09:45:00',1.72),('8537','2014-05-02','09:50:00',1.74),('8537','2014-05-02','09:55:00',1.7),('8537','2014-05-02','10:00:00',2.04),('8537','2014-05-02','10:05:00',2.06),('8537','2014-05-02','10:10:00',2.35),('8537','2014-05-02','10:15:00',1.99),('8537','2014-05-02','10:20:00',1.87),('8537','2014-05-02','10:25:00',1.38),('8537','2014-05-02','10:30:00',1.05),('8537','2014-05-02','10:35:00',1.02),('8537','2014-05-02','10:40:00',1.09),('8537','2014-05-02','10:45:00',1.35),('8537','2014-05-02','10:50:00',1.25),('8537','2014-05-02','10:55:00',1.01),('8537','2014-05-02','12:30:00',1.21),('8537','2014-05-02','12:35:00',1.36),('8537','2014-05-02','12:40:00',1.22),('8537','2014-05-02','12:45:00',1.39),('8537','2014-05-02','12:50:00',2),('8537','2014-05-02','12:55:00',1.83),('8537','2014-05-02','13:00:00',1.75),('8537','2014-05-02','13:05:00',2.09),('8537','2014-05-02','13:10:00',2.32),('8537','2014-05-02','13:15:00',2.41),('8537','2014-05-02','13:20:00',3.91),('8537','2014-05-02','13:25:00',3.33),('8537','2014-05-02','13:30:00',3.38),('8537','2014-05-02','13:35:00',2.72),('8537','2014-05-02','13:40:00',3.23),('8537','2014-05-02','13:45:00',2.32),('8537','2014-05-02','13:50:00',1.7),('8537','2014-05-02','13:55:00',1.54),('8537','2014-05-02','14:00:00',1.62),('8537','2014-05-02','14:05:00',2.03),('8537','2014-05-02','14:10:00',1.58),('8537','2014-05-02','14:30:00',1.39),('8537','2014-05-02','14:35:00',2.1),('8537','2014-05-02','14:40:00',3.84),('8537','2014-05-02','14:45:00',2.26),('8537','2014-05-02','14:50:00',1.64),('8537','2014-05-02','14:55:00',2.16),('8537','2014-05-02','15:00:00',3.05),('8537','2014-05-02','15:05:00',2.28),('8537','2014-05-02','15:10:00',3.4),('8537','2014-05-02','15:15:00',4.18),('8537','2014-05-02','15:20:00',2.05),('8537','2014-05-02','15:25:00',1.7),('8537','2014-05-02','15:30:00',1.42),('8537','2014-05-02','15:35:00',2.84),('8537','2014-05-02','15:40:00',4.7),('8537','2014-05-02','15:45:00',1.62),('8537','2014-05-02','16:00:00',1.39),('8537','2014-05-02','16:05:00',2.01),('8537','2014-05-02','16:10:00',1.36),('8537','2014-05-02','16:15:00',1.01),('8537','2014-05-02','16:20:00',3.29),('8537','2014-05-02','17:15:00',1.03),('8537','2014-05-02','17:20:00',1.21),('8537','2014-05-02','17:25:00',1.41),('8537','2014-05-02','17:30:00',1.09),('8537','2014-03-27','07:55:00',1.33),('8537','2014-03-27','08:00:00',1.59),('8537','2014-03-27','08:05:00',1.62),('8537','2014-03-27','10:00:00',1.04),('8537','2014-03-27','10:05:00',1.18),('8537','2014-03-27','10:10:00',1.53),('8537','2014-03-27','10:15:00',1.25),('8537','2014-03-27','10:20:00',1.8),('8537','2014-03-27','10:25:00',2.19),('8537','2014-03-27','10:30:00',2.42),('8537','2014-03-27','10:35:00',2.18),('8537','2014-03-27','10:40:00',2.79),('8537','2014-03-27','10:45:00',1.6),('8537','2014-03-27','11:10:00',3.32),('8537','2014-03-27','11:15:00',3.44),('8537','2014-03-27','11:20:00',2.36),('8537','2014-03-27','11:50:00',1.07),('8537','2014-03-27','11:55:00',1.59),('8537','2014-03-27','12:00:00',1.54),('8537','2014-03-27','12:05:00',1.07),('8537','2014-03-27','12:10:00',1.83),('8537','2014-03-27','12:15:00',1.35),('8537','2014-03-27','12:20:00',1.24),('8537','2014-03-27','13:00:00',1.08),('8537','2014-03-27','13:05:00',1.2),('8537','2014-03-27','13:10:00',1.73),('8537','2014-03-27','13:15:00',2.42),('8537','2014-03-27','13:20:00',2.62),('8537','2014-03-27','13:25:00',2.83),('8537','2014-03-27','13:30:00',2.43),('8537','2014-03-27','13:35:00',2.24),('8537','2014-03-27','13:40:00',2.08),('8537','2014-03-27','13:45:00',2),('8537','2014-03-27','13:50:00',2.35),('8537','2014-03-27','13:55:00',3.09),('8537','2014-03-27','14:00:00',2.44),('8537','2014-03-27','14:05:00',1.37),('8537','2014-03-27','14:15:00',2.39),('8537','2014-03-27','14:20:00',3.6),('8537','2014-03-27','14:25:00',3.54),('8537','2014-03-27','14:30:00',3.91),('8537','2014-03-27','14:35:00',2.58),('8537','2014-03-27','14:40:00',2.04),('8537','2014-03-27','14:45:00',1.92),('8537','2014-03-27','14:50:00',2.59),('8537','2014-03-27','14:55:00',2.5),('8537','2014-03-27','15:00:00',2.16),('8537','2014-03-27','15:05:00',1.67),('8537','2014-03-27','15:20:00',1.2),('8537','2014-03-27','15:25:00',2.78),('8537','2014-03-27','15:30:00',2.45),('8537','2014-03-27','15:35:00',1.62),('8537','2014-03-27','15:40:00',1.05),('8537','2014-03-27','15:50:00',1.13),('8537','2014-03-27','15:55:00',1.1),('8537','2014-03-27','16:05:00',1.15),('8537','2014-03-27','16:10:00',1.44),('8537','2014-03-27','16:15:00',1.39),('8537','2014-03-27','16:20:00',1.04),('8537','2014-03-27','16:25:00',1.14),('8537','2014-03-27','16:30:00',1.27),('8537','2014-03-27','16:35:00',1),('8537','2014-03-27','16:40:00',1.1),('8537','2014-03-27','16:45:00',1.11),('8537','2013-04-01','08:25:00',1.56),('8537','2013-04-01','08:30:00',1.61),('8537','2013-04-01','08:35:00',1.67),('8537','2013-04-01','08:40:00',1.99),('8537','2013-04-01','08:45:00',1.15),('8537','2013-04-01','08:50:00',1.77),('8537','2013-04-01','08:55:00',2.17),('8537','2013-04-01','09:00:00',2.34),('8537','2013-04-01','09:05:00',2.46),('8537','2013-04-01','09:10:00',2.66),('8537','2013-04-01','09:15:00',2.76),('8537','2013-04-01','09:20:00',2.53),('8537','2013-04-01','09:25:00',2.82),('8537','2013-04-01','09:30:00',2.92),('8537','2013-04-01','09:35:00',1.89),('8537','2013-04-01','09:40:00',2.98),('8537','2013-04-01','09:45:00',3.31),('8537','2013-04-01','09:50:00',3.38),('8537','2013-04-01','09:55:00',3.17),('8537','2013-04-01','10:00:00',3.52),('8537','2013-04-01','10:05:00',3.65),('8537','2013-04-01','10:10:00',3.43),('8537','2013-04-01','10:15:00',3.62),('8537','2013-04-01','10:20:00',3.33),('8537','2013-04-01','10:25:00',3.93),('8537','2013-04-01','10:30:00',2.61),('8537','2013-04-01','10:35:00',1.51),('8537','2013-04-01','10:40:00',2.42),('8537','2013-04-01','10:45:00',4.46),('8537','2013-04-01','10:50:00',2.32),('8537','2013-04-01','10:55:00',1.12),('8537','2013-04-01','11:00:00',1.6),('8537','2013-04-01','11:05:00',1.58),('8537','2013-04-01','11:10:00',3.07),('8537','2013-04-01','11:15:00',3.66),('8537','2013-04-01','11:20:00',3.65),('8537','2013-04-01','11:25:00',3),('8537','2013-04-01','11:30:00',1.99),('8537','2013-04-01','11:35:00',2.34),('8537','2013-04-01','11:40:00',3.81),('8537','2013-04-01','11:45:00',3.78),('8537','2013-04-01','11:50:00',2.94),('8537','2013-04-01','11:55:00',2.61),('8537','2013-04-01','12:00:00',3.51),('8537','2013-04-01','12:05:00',2.27),('8537','2013-04-01','12:10:00',2.75),('8537','2013-04-01','12:15:00',2.29),('8537','2013-04-01','12:20:00',2.01),('8537','2013-04-01','12:25:00',2.16),('8537','2013-04-01','12:30:00',2.98),('8537','2013-04-01','12:35:00',2.8),('8537','2013-04-01','12:40:00',2.73),('8537','2013-04-01','12:45:00',3.11),('8537','2013-04-01','12:50:00',3.3),('8537','2013-04-01','12:55:00',3.63),('8537','2013-04-01','13:00:00',3.46),('8537','2013-04-01','13:05:00',3.79),('8537','2013-04-01','13:10:00',3.38),('8537','2013-04-01','13:15:00',3.47),('8537','2013-04-01','13:20:00',3.42),('8537','2013-04-01','13:25:00',3.15),('8537','2013-04-01','13:30:00',3.58),('8537','2013-04-01','13:35:00',3.1),('8537','2013-04-01','13:40:00',3.97),('8537','2013-04-01','13:45:00',4.36),('8537','2013-04-01','13:50:00',4.83),('8537','2013-04-01','13:55:00',4.9),('8537','2013-04-01','14:00:00',2.79),('8537','2013-04-01','14:05:00',2.08),('8537','2013-04-01','14:10:00',2.69),('8537','2013-04-01','14:15:00',3.04),('8537','2013-04-01','14:20:00',3.16),('8537','2013-04-01','14:25:00',4.98),('8537','2013-04-01','14:30:00',3.23),('8537','2013-04-01','14:35:00',2.55),('8537','2013-04-01','14:40:00',2.27),('8537','2013-04-01','14:45:00',2.2),('8537','2013-04-01','14:50:00',2.37),('8537','2013-04-01','14:55:00',2.55),('8537','2013-04-01','15:00:00',2.27),('8537','2013-04-01','15:05:00',2.28),('8537','2013-04-01','15:10:00',2.32),('8537','2013-04-01','15:15:00',2.48),('8537','2013-04-01','15:20:00',2.54),('8537','2013-04-01','15:25:00',2.58),('8537','2013-04-01','15:30:00',2.26),('8537','2013-04-01','15:35:00',2.82),('8537','2013-04-01','15:40:00',2.71),('8537','2013-04-01','15:45:00',2.73),('8537','2013-04-01','15:50:00',3.17),('8537','2013-04-01','15:55:00',2.4),('8537','2013-04-01','16:00:00',2.18),('8537','2013-04-01','16:05:00',1.77),('8537','2013-04-01','16:10:00',1.5),('8537','2013-04-01','16:15:00',1.23),('8537','2013-04-01','16:20:00',1.16),('8537','2013-04-01','16:25:00',1.07),('8537','2013-03-31','08:20:00',1.03),('8537','2013-03-31','08:30:00',1.13),('8537','2013-03-31','08:35:00',1.35),('8537','2013-03-31','08:40:00',1.25),('8537','2013-03-31','08:45:00',1.5),('8537','2013-03-31','08:50:00',1.16),('8537','2013-03-31','08:55:00',1.28),('8537','2013-03-31','09:00:00',1.35),('8537','2013-03-31','09:05:00',1.24),('8537','2013-03-31','09:10:00',1.31),('8537','2013-03-31','09:15:00',1.37),('8537','2013-03-31','09:20:00',2.77),('8537','2013-03-31','09:25:00',3.33),('8537','2013-03-31','09:30:00',2.48),('8537','2013-03-31','09:35:00',2.44),('8537','2013-03-31','09:40:00',1.43),('8537','2013-03-31','09:45:00',3.17),('8537','2013-03-31','09:50:00',1.63),('8537','2013-03-31','09:55:00',2.31),('8537','2013-03-31','10:00:00',2.76),('8537','2013-03-31','10:15:00',1.04),('8537','2013-03-31','10:20:00',2.25),('8537','2013-03-31','10:25:00',2.96),('8537','2013-03-31','10:30:00',3.39),('8537','2013-03-31','10:35:00',3.36),('8537','2013-03-31','10:45:00',1.3),('8537','2013-03-31','10:50:00',2.3),('8537','2013-03-31','10:55:00',1.26),('8537','2013-03-31','11:10:00',1.68),('8537','2013-03-31','11:15:00',1.58),('8537','2013-03-31','11:20:00',1.31),('8537','2013-03-31','11:25:00',1.7),('8537','2013-03-31','11:30:00',1.22),('8537','2013-03-31','11:35:00',1.61),('8537','2013-03-31','11:40:00',1.85),('8537','2013-03-31','11:45:00',1.53),('8537','2013-03-31','11:50:00',1.7),('8537','2013-03-31','11:55:00',1.91),('8537','2013-03-31','12:00:00',1.73),('8537','2013-03-31','12:05:00',1.61),('8537','2013-03-31','12:10:00',1.5),('8537','2013-03-31','12:15:00',1.58),('8537','2013-03-31','12:20:00',1.52),('8537','2013-03-31','12:25:00',1.74),('8537','2013-03-31','12:30:00',2.07),('8537','2013-03-31','12:35:00',3.24),('8537','2013-03-31','12:40:00',3.36),('8537','2013-03-31','12:45:00',1.82),('8537','2013-03-31','12:50:00',1.86),('8537','2013-03-31','12:55:00',2.26),('8537','2013-03-31','13:00:00',2.78),('8537','2013-03-31','13:05:00',2.49),('8537','2013-03-31','13:10:00',3.32),('8537','2013-03-31','13:15:00',2.65),('8537','2013-03-31','13:20:00',4.4),('8537','2013-03-31','13:25:00',3.11),('8537','2013-03-31','13:40:00',1.58),('8537','2013-03-31','13:45:00',2.04),('8537','2013-03-31','13:50:00',2.49),('8537','2013-03-31','13:55:00',2.14),('8537','2013-03-31','14:00:00',1.93),('8537','2013-03-31','14:05:00',3.52),('8537','2013-03-31','14:10:00',2.35),('8537','2013-03-31','14:15:00',4),('8537','2013-03-31','14:20:00',1.81),('8537','2013-03-31','14:25:00',1.96),('8537','2013-03-31','14:30:00',3.63),('8537','2013-03-31','14:35:00',4.86),('8537','2013-03-31','14:40:00',5.45),('8537','2013-03-31','14:45:00',3.69),('8537','2013-03-31','14:50:00',3.9),('8537','2013-03-31','14:55:00',3.36),('8537','2013-03-31','15:00:00',3.06),('8537','2013-03-31','15:05:00',2.24),('8537','2013-03-31','15:10:00',3.11),('8537','2013-03-31','15:15:00',3.08),('8537','2013-03-31','15:20:00',4.64),('8537','2013-03-31','15:25:00',3.1),('8537','2013-03-31','15:30:00',2.68),('8537','2013-03-31','15:35:00',3.37),('8537','2013-03-31','15:40:00',4.68),('8537','2013-03-31','15:45:00',3.49),('8537','2013-03-31','15:50:00',1.22),('8537','2013-03-31','16:00:00',2.77),('8537','2013-03-31','16:05:00',1.51),('8537','2013-03-31','16:10:00',1.71),('8537','2013-03-31','16:15:00',2.11),('8537','2013-03-31','16:20:00',2.02),('8537','2013-03-31','16:25:00',1.5),('8537','2013-03-31','16:30:00',1.21),('8537','2013-03-31','16:35:00',1.28),('8537','2013-03-31','16:40:00',1.35),('8537','2013-03-31','16:45:00',1.16),('8537','2013-03-31','16:50:00',1.05),('8537','2013-03-31','17:00:00',1.38),('8537','2013-03-31','17:05:00',2),('8537','2013-03-31','17:10:00',1.72),('8537','2013-03-31','17:15:00',1.15),('8537','2013-03-31','17:20:00',1.24),('8537','2013-03-31','17:25:00',1.34),('8537','2013-03-31','17:30:00',1.45),('8537','2013-03-31','17:35:00',1.41),('8537','2013-03-31','17:50:00',1.05),('8537','2013-03-31','17:55:00',1.48),('8537','2013-03-31','18:15:00',1.11),('8537','2013-03-30','07:55:00',1.07),('8537','2013-03-30','08:25:00',1.02),('8537','2013-03-30','08:30:00',1.06),('8537','2013-03-30','08:35:00',1.27),('8537','2013-03-30','08:40:00',1.25),('8537','2013-03-30','08:50:00',1.04),('8537','2013-03-30','09:05:00',2.16),('8537','2013-03-30','09:10:00',2.06),('8537','2013-03-30','09:15:00',1.98),('8537','2013-03-30','09:20:00',4.51),('8537','2013-03-30','09:25:00',2.87),('8537','2013-03-30','09:30:00',1.54),('8537','2013-03-30','09:35:00',1.94),('8537','2013-03-30','09:40:00',1.66),('8537','2013-03-30','09:45:00',1.49),('8537','2013-03-30','09:50:00',1.17),('8537','2013-03-30','09:55:00',1.4),('8537','2013-03-30','10:00:00',1.88),('8537','2013-03-30','10:05:00',1.93),('8537','2013-03-30','10:10:00',2.14),('8537','2013-03-30','10:15:00',1.95),('8537','2013-03-30','10:20:00',1.66),('8537','2013-03-30','10:25:00',1.62),('8537','2013-03-30','10:30:00',1.87),('8537','2013-03-30','10:35:00',2.28),('8537','2013-03-30','10:40:00',2.92),('8537','2013-03-30','10:45:00',3.98),('8537','2013-03-30','10:50:00',3.84),('8537','2013-03-30','10:55:00',2.64),('8537','2013-03-30','11:00:00',3.84),('8537','2013-03-30','11:05:00',4.59),('8537','2013-03-30','11:10:00',5.43),('8537','2013-03-30','11:15:00',3.74),('8537','2013-03-30','11:20:00',5.83),('8537','2013-03-30','11:25:00',5.5),('8537','2013-03-30','11:30:00',2.82),('8537','2013-03-30','11:35:00',3.68),('8537','2013-03-30','11:40:00',2.64),('8537','2013-03-30','11:45:00',4.03),('8537','2013-03-30','11:50:00',4.26),('8537','2013-03-30','11:55:00',4.52),('8537','2013-03-30','12:00:00',4.95),('8537','2013-03-30','12:05:00',3.08),('8537','2013-03-30','12:10:00',2.31),('8537','2013-03-30','12:15:00',2.26),('8537','2013-03-30','12:20:00',2.21),('8537','2013-03-30','12:25:00',1.34),('8537','2013-03-30','12:30:00',1.34),('8537','2013-03-30','12:35:00',1.19),('8537','2013-03-30','13:10:00',1.28),('8537','2013-03-30','13:15:00',3.62),('8537','2013-03-30','13:20:00',3.69),('8537','2013-03-30','13:25:00',1.65),('8537','2013-03-30','13:45:00',1.54),('8537','2013-03-30','13:50:00',3.92),('8537','2013-03-30','13:55:00',3.07),('8537','2013-03-30','14:00:00',2.6),('8537','2013-03-30','14:05:00',2.48),('8537','2013-03-30','14:10:00',1.31),('8537','2013-03-30','14:15:00',1.68),('8537','2013-03-30','14:20:00',2.13),('8537','2013-03-30','14:25:00',1.57),('8537','2013-03-30','14:30:00',1.81),('8537','2013-03-30','14:35:00',1.86),('8537','2013-03-30','14:40:00',1.3),('8537','2013-03-30','14:45:00',1.33),('8537','2013-03-30','14:50:00',1.77),('8537','2013-03-30','14:55:00',1.16),('8537','2013-03-30','15:20:00',1.06),('8537','2013-03-30','15:25:00',1.08),('8537','2013-03-29','07:10:00',1.02),('8537','2013-03-29','07:15:00',1.12),('8537','2013-03-29','07:20:00',1.24),('8537','2013-03-29','07:25:00',1.38),('8537','2013-03-29','07:30:00',1.36),('8537','2013-03-29','07:35:00',1.32),('8537','2013-03-29','07:40:00',1.7),('8537','2013-03-29','07:45:00',1.91),('8537','2013-03-29','07:50:00',1.92),('8537','2013-03-29','07:55:00',1.19),('8537','2013-03-29','08:00:00',1.56),('8537','2013-03-29','08:05:00',2.05),('8537','2013-03-29','08:10:00',2.53),('8537','2013-03-29','08:15:00',2.51),('8537','2013-03-29','08:20:00',2.62),('8537','2013-03-29','08:25:00',2.68),('8537','2013-03-29','08:30:00',2.75),('8537','2013-03-29','08:35:00',2.92),('8537','2013-03-29','08:40:00',3.01),('8537','2013-03-29','08:45:00',2.95),('8537','2013-03-29','08:50:00',2.93),('8537','2013-03-29','08:55:00',2.86),('8537','2013-03-29','09:00:00',2.94),('8537','2013-03-29','09:05:00',3.16),('8537','2013-03-29','09:10:00',3.31),('8537','2013-03-29','09:15:00',3.68),('8537','2013-03-29','09:20:00',3.86),('8537','2013-03-29','09:25:00',3.55),('8537','2013-03-29','09:30:00',4.11),('8537','2013-03-29','09:35:00',4.12),('8537','2013-03-29','09:40:00',4.1),('8537','2013-03-29','09:45:00',3.67),('8537','2013-03-29','09:50:00',3.96),('8537','2013-03-29','09:55:00',4.01),('8537','2013-03-29','10:00:00',4.06),('8537','2013-03-29','10:05:00',3.78),('8537','2013-03-29','10:10:00',3.18),('8537','2013-03-29','10:15:00',4.04),('8537','2013-03-29','10:20:00',3.74),('8537','2013-03-29','10:25:00',3.67),('8537','2013-03-29','10:30:00',3.79),('8537','2013-03-29','10:35:00',3.38),('8537','2013-03-29','10:40:00',3.22),('8537','2013-03-29','10:45:00',2.65),('8537','2013-03-29','10:50:00',3.8),('8537','2013-03-29','10:55:00',4.16),('8537','2013-03-29','11:00:00',4.9),('8537','2013-03-29','11:05:00',4.8),('8537','2013-03-29','11:10:00',5.33),('8537','2013-03-29','11:15:00',3.06),('8537','2013-03-29','11:20:00',2.51),('8537','2013-03-29','11:25:00',5.14),('8537','2013-03-29','11:30:00',5.21),('8537','2013-03-29','11:35:00',4.31),('8537','2013-03-29','11:40:00',5.11),('8537','2013-03-29','11:45:00',5.08),('8537','2013-03-29','11:50:00',5.12),('8537','2013-03-29','11:55:00',5.11),('8537','2013-03-29','12:00:00',5.11),('8537','2013-03-29','12:05:00',5.23),('8537','2013-03-29','12:10:00',5.18),('8537','2013-03-29','12:15:00',4.78),('8537','2013-03-29','12:20:00',5.1),('8537','2013-03-29','12:25:00',4.9),('8537','2013-03-29','12:30:00',4.58),('8537','2013-03-29','12:35:00',4.86),('8537','2013-03-29','12:40:00',4.75),('8537','2013-03-29','12:45:00',3.64),('8537','2013-03-29','12:50:00',4.64),('8537','2013-03-29','12:55:00',3.54),('8537','2013-03-29','13:00:00',4.28),('8537','2013-03-29','13:05:00',3.45),('8537','2013-03-29','13:10:00',4.72),('8537','2013-03-29','13:15:00',4.06),('8537','2013-03-29','13:20:00',4.09),('8537','2013-03-29','13:25:00',5.09),('8537','2013-03-29','13:30:00',4.44),('8537','2013-03-29','13:35:00',3.83),('8537','2013-03-29','13:40:00',3.94),('8537','2013-03-29','13:45:00',3.97),('8537','2013-03-29','13:50:00',3.77),('8537','2013-03-29','13:55:00',3.99),('8537','2013-03-29','14:00:00',4.1),('8537','2013-03-29','14:05:00',3.46),('8537','2013-03-29','14:10:00',2.74),('8537','2013-03-29','14:15:00',2.79),('8537','2013-03-29','14:20:00',2.8),('8537','2013-03-29','14:25:00',2.8),('8537','2013-03-29','14:30:00',2.36),('8537','2013-03-29','14:35:00',2.38),('8537','2013-03-29','14:40:00',2.27),('8537','2013-03-29','14:45:00',2.11),('8537','2013-03-29','14:50:00',2.04),('8537','2013-03-29','14:55:00',1.97),('8537','2013-03-29','15:00:00',1.77),('8537','2013-03-29','15:05:00',1.78),('8537','2013-03-29','15:10:00',1.69),('8537','2013-03-29','15:15:00',1.64),('8537','2013-03-29','15:20:00',1.56),('8537','2013-03-29','15:25:00',1.42),('8537','2013-03-29','15:30:00',1.31),('8537','2013-03-29','15:35:00',1.25),('8537','2013-03-29','15:40:00',1.2),('8537','2013-03-29','15:45:00',1.15),('8537','2013-03-29','15:50:00',1.24),('8537','2013-03-29','15:55:00',1.41),('8537','2013-03-29','16:00:00',1.68),('8537','2013-03-29','16:05:00',1.57),('8537','2013-03-29','16:10:00',1.28),('8537','2013-03-29','16:15:00',1.13),('8537','2013-03-29','16:20:00',1.03),('8537','2013-03-29','16:25:00',1.07),('8537','2013-03-29','16:30:00',1.15),('8537','2013-03-29','16:35:00',1.11),('8537','2013-03-29','16:40:00',1.71),('8537','2013-03-29','16:45:00',1.49),('8537','2013-03-29','16:50:00',1.19),('8537','2013-03-29','17:00:00',1.02),('8537','2013-03-28','09:05:00',1.2),('8537','2013-03-28','09:10:00',2.01),('8537','2013-03-28','09:15:00',3.79),('8537','2013-03-28','09:20:00',1.91),('8537','2013-03-28','09:25:00',1.77),('8537','2013-03-28','09:30:00',1.31),('8537','2013-03-28','09:35:00',1.11),('8537','2013-03-28','09:45:00',1.16),('8537','2013-03-28','09:50:00',1.25),('8537','2013-03-28','09:55:00',1.23),('8537','2013-03-28','10:00:00',1.34),('8537','2013-03-28','10:05:00',1.04),('8537','2013-03-28','11:00:00',1.24),('8537','2013-03-28','11:30:00',1.01),('8537','2013-03-28','11:35:00',1.57),('8537','2013-03-28','11:40:00',2.12),('8537','2013-03-28','11:45:00',1.52),('8537','2013-03-28','11:50:00',1.51),('8537','2013-03-28','11:55:00',2.53),('8537','2013-03-28','12:00:00',1.99),('8537','2013-03-28','12:05:00',1.36),('8537','2013-03-28','12:10:00',1.25),('8537','2013-03-28','12:15:00',1.41),('8537','2013-03-28','12:20:00',1.45),('8537','2013-03-28','12:25:00',1.23),('8537','2013-03-28','12:30:00',1.16),('8537','2013-03-28','12:35:00',1.05),('8537','2013-03-28','12:40:00',1.44),('8537','2013-03-28','12:45:00',1.89),('8537','2013-03-28','12:50:00',3.7),('8537','2013-03-28','12:55:00',4.07),('8537','2013-03-28','13:00:00',3.93),('8537','2013-03-28','13:05:00',4.28),('8537','2013-03-28','13:10:00',4.5),('8537','2013-03-28','13:15:00',4.35),('8537','2013-03-28','13:20:00',3.65),('8537','2013-03-28','13:25:00',3.96),('8537','2013-03-28','13:30:00',4.42),('8537','2013-03-28','13:35:00',3.48),('8537','2013-03-28','13:40:00',2.75),('8537','2013-03-28','13:45:00',2.84),('8537','2013-03-28','13:50:00',3.46),('8537','2013-03-28','13:55:00',1.98),('8537','2013-03-28','14:00:00',2.06),('8537','2013-03-28','14:05:00',2.96),('8537','2013-03-28','14:10:00',1.8),('8537','2013-03-28','14:15:00',1.74),('8537','2013-03-28','14:20:00',1.77),('8537','2013-03-28','14:25:00',1.8),('8537','2013-03-28','14:30:00',2.08),('8537','2013-03-28','14:35:00',1.92),('8537','2013-03-28','14:40:00',1.41),('8537','2013-03-28','14:45:00',1.39),('8537','2013-03-28','14:50:00',1.23),('8537','2013-03-28','14:55:00',1.05),('8537','2013-03-28','15:00:00',1.34),('8537','2013-03-28','15:05:00',1.53),('8537','2013-03-28','15:10:00',2.36),('8537','2013-03-28','15:15:00',2.26),('8537','2013-03-28','15:20:00',2.07),('8537','2013-03-28','15:25:00',2.22),('8537','2013-03-28','15:30:00',1.71),('8537','2013-03-28','15:35:00',2.56),('8537','2013-03-28','15:40:00',1.86),('8537','2013-03-28','15:45:00',2.06),('8537','2013-03-28','15:50:00',1.53),('8537','2013-03-28','15:55:00',2.54),('8537','2013-03-28','16:00:00',1.53),('8537','2013-03-28','16:10:00',1.68),('8537','2013-03-28','16:35:00',1.46),('8537','2013-03-28','16:45:00',1.01),('8537','2013-03-28','17:00:00',1.27),('8537','2013-03-28','17:05:00',1.09),('8537','2013-03-27','07:15:00',1.06),('8537','2013-03-27','07:20:00',1.17),('8537','2013-03-27','07:25:00',1.29),('8537','2013-03-27','07:30:00',1.4),('8537','2013-03-27','07:35:00',1.37),('8537','2013-03-27','07:40:00',1.49),('8537','2013-03-27','07:45:00',1.36),('8537','2013-03-27','07:55:00',1.48),('8537','2013-03-27','08:00:00',1.55),('8537','2013-03-27','08:05:00',1.81),('8537','2013-03-27','08:10:00',1.56),('8537','2013-03-27','08:15:00',1.76),('8537','2013-03-27','08:20:00',1.52),('8537','2013-03-27','08:25:00',1.76),('8537','2013-03-27','08:30:00',2.36),('8537','2013-03-27','08:35:00',2.1),('8537','2013-03-27','08:40:00',1.62),('8537','2013-03-27','08:45:00',1.56),('8537','2013-03-27','08:50:00',1.76),('8537','2013-03-27','08:55:00',1.75),('8537','2013-03-27','09:00:00',1.61),('8537','2013-03-27','09:05:00',1.32),('8537','2013-03-27','09:15:00',2.2),('8537','2013-03-27','09:20:00',2.4),('8537','2013-03-27','09:25:00',1.6),('8537','2013-03-27','09:30:00',1.21),('8537','2013-03-27','09:40:00',1.14),('8537','2013-03-27','09:45:00',2),('8537','2013-03-27','09:50:00',3.04),('8537','2013-03-27','09:55:00',1.75),('8537','2013-03-27','10:00:00',2.02),('8537','2013-03-27','10:05:00',1.21),('8537','2013-03-27','10:10:00',1.69),('8537','2013-03-27','10:15:00',2.11),('8537','2013-03-27','10:20:00',1.82),('8537','2013-03-27','10:25:00',2.17),('8537','2013-03-27','10:30:00',2.67),('8537','2013-03-27','10:35:00',2.12),('8537','2013-03-27','10:40:00',2.3),('8537','2013-03-27','10:45:00',2.55),('8537','2013-03-27','10:50:00',2.35),('8537','2013-03-27','10:55:00',2.3),('8537','2013-03-27','11:00:00',1.87),('8537','2013-03-27','11:05:00',1.86),('8537','2013-03-27','11:10:00',2.02),('8537','2013-03-27','11:15:00',2.12),('8537','2013-03-27','11:20:00',2.18),('8537','2013-03-27','11:25:00',2.06),('8537','2013-03-27','11:30:00',2.33),('8537','2013-03-27','11:35:00',2.18),('8537','2013-03-27','11:40:00',2.06),('8537','2013-03-27','11:45:00',2.05),('8537','2013-03-27','11:50:00',1.96),('8537','2013-03-27','11:55:00',2.94),('8537','2013-03-27','12:00:00',3.46),('8537','2013-03-27','12:05:00',3.4),('8537','2013-03-27','12:10:00',3),('8537','2013-03-27','12:15:00',2.1),('8537','2013-03-27','12:20:00',2.32),('8537','2013-03-27','12:25:00',2.01),('8537','2013-03-27','12:30:00',3.83),('8537','2013-03-27','12:35:00',5.67),('8537','2013-03-27','12:40:00',5.38),('8537','2013-03-27','12:45:00',5.17),('8537','2013-03-27','12:50:00',3.58),('8537','2013-03-27','12:55:00',2.84),('8537','2013-03-27','13:00:00',1.8),('8537','2013-03-27','13:05:00',2.09),('8537','2013-03-27','13:10:00',3.07),('8537','2013-03-27','13:15:00',2.19),('8537','2013-03-27','13:20:00',1.63),('8537','2013-03-27','13:25:00',1.57),('8537','2013-03-27','13:30:00',2.39),('8537','2013-03-27','13:35:00',2.81),('8537','2013-03-27','13:40:00',2.19),('8537','2013-03-27','13:45:00',2.54),('8537','2013-03-27','13:50:00',2.87),('8537','2013-03-27','13:55:00',2.65),('8537','2013-03-27','14:00:00',2.11),('8537','2013-03-27','14:05:00',1.78),('8537','2013-03-27','14:10:00',1.87),('8537','2013-03-27','14:15:00',2.11),('8537','2013-03-27','14:20:00',2.49),('8537','2013-03-27','14:25:00',2.11),('8537','2013-03-27','14:30:00',1.74),('8537','2013-03-27','14:35:00',1.87),('8537','2013-03-27','14:40:00',2.57),('8537','2013-03-27','14:45:00',2.48),('8537','2013-03-27','14:50:00',1.77),('8537','2013-03-27','14:55:00',1.5),('8537','2013-03-27','15:00:00',1.26),('8537','2013-03-27','15:05:00',1.57),('8537','2013-03-27','15:10:00',1.78),('8537','2013-03-27','15:15:00',1.23),('8537','2013-03-27','15:20:00',1.23),('8537','2013-03-27','15:25:00',1.24),('8537','2013-03-27','16:40:00',1.04),('8537','2013-03-27','16:45:00',1.2),('8537','2013-03-27','16:50:00',1.09),('8537','2013-03-27','16:55:00',1.19),('8537','2013-03-27','17:00:00',1.23),('8537','2013-03-27','17:05:00',1.31),('8537','2013-03-27','17:10:00',1.07),('8537','2013-03-26','07:45:00',1.22),('8537','2013-03-26','07:50:00',2.14),('8537','2013-03-26','07:55:00',2.32),('8537','2013-03-26','08:30:00',1.03),('8537','2013-03-26','08:35:00',1.63),('8537','2013-03-26','08:40:00',1.75),('8537','2013-03-26','09:10:00',1.18),('8537','2013-03-26','09:15:00',1.98),('8537','2013-03-26','09:20:00',1.27),('8537','2013-03-26','09:50:00',1),('8537','2013-03-26','09:55:00',2.75),('8537','2013-03-26','10:00:00',1.62),('8537','2013-03-26','10:50:00',1.02),('8537','2013-03-26','11:00:00',1.26),('8537','2013-03-26','11:05:00',1.26),('8537','2013-03-26','11:10:00',3.06),('8537','2013-03-26','11:15:00',2.19),('8537','2013-03-26','11:20:00',2.13),('8537','2013-03-26','11:25:00',1.18),('8537','2013-03-26','11:50:00',2.04),('8537','2013-03-26','11:55:00',1.39),('8537','2013-03-26','12:00:00',1.27),('8537','2013-03-26','12:05:00',1.37),('8537','2013-03-26','12:10:00',1.49),('8537','2013-03-26','12:15:00',1.61),('8537','2013-03-26','12:20:00',1.71),('8537','2013-03-26','12:25:00',2.57),('8537','2013-03-26','12:30:00',2.21),('8537','2013-03-26','12:35:00',3.63),('8537','2013-03-26','12:40:00',2.4),('8537','2013-03-26','12:45:00',3.05),('8537','2013-03-26','12:50:00',2.12),('8537','2013-03-26','12:55:00',1.22),('8537','2013-03-26','13:00:00',1.83),('8537','2013-03-26','13:05:00',2.87),('8537','2013-03-26','13:10:00',2.95),('8537','2013-03-26','13:15:00',2.31),('8537','2013-03-26','13:20:00',1.68),('8537','2013-03-26','13:25:00',2.41),('8537','2013-03-26','13:30:00',1.85),('8537','2013-03-26','13:35:00',2.16),('8537','2013-03-26','13:40:00',2.55),('8537','2013-03-26','13:45:00',2.26),('8537','2013-03-26','13:50:00',1.97),('8537','2013-03-26','13:55:00',1.83),('8537','2013-03-26','14:00:00',1.76),('8537','2013-03-26','14:05:00',1.68),('8537','2013-03-26','14:10:00',1.72),('8537','2013-03-26','14:15:00',1.6),('8537','2013-03-26','14:20:00',1.4),('8537','2013-03-26','14:25:00',1.23),('8537','2013-03-26','14:30:00',1.03),('8537','2013-03-26','14:45:00',1.03),('8537','2013-03-26','15:35:00',1.07),('8537','2013-03-25','08:20:00',1.41),('8537','2013-03-25','08:25:00',2.13),('8537','2013-03-25','08:30:00',1.5),('8537','2013-03-25','08:45:00',1.09),('8537','2013-03-25','08:50:00',1.05),('8537','2013-03-25','08:55:00',1.3),('8537','2013-03-25','09:00:00',1.3),('8537','2013-03-25','09:05:00',1.24),('8537','2013-03-25','09:10:00',1.28),('8537','2013-03-25','09:15:00',1.25),('8537','2013-03-25','09:20:00',2.86),('8537','2013-03-25','09:25:00',3.51),('8537','2013-03-25','09:30:00',1.67),('8537','2013-03-25','09:35:00',1.11),('8537','2013-03-25','09:50:00',4.11),('8537','2013-03-25','09:55:00',4.37),('8537','2013-03-25','10:00:00',2.94),('8537','2013-03-25','10:05:00',1.66),('8537','2013-03-25','10:10:00',1.12),('8537','2013-03-25','10:15:00',1.23),('8537','2013-03-25','10:20:00',1.86),('8537','2013-03-25','10:25:00',3.01),('8537','2013-03-25','10:30:00',2.62),('8537','2013-03-25','10:35:00',1.77),('8537','2013-03-25','10:40:00',2.18),('8537','2013-03-25','10:45:00',3.05),('8537','2013-03-25','10:50:00',2.94),('8537','2013-03-25','10:55:00',2.99),('8537','2013-03-25','11:00:00',2.7),('8537','2013-03-25','11:05:00',2.26),('8537','2013-03-25','11:10:00',2.82),('8537','2013-03-25','11:15:00',3.11),('8537','2013-03-25','11:20:00',4.95),('8537','2013-03-25','11:25:00',4.28),('8537','2013-03-25','11:30:00',3.04),('8537','2013-03-25','11:35:00',3.24),('8537','2013-03-25','11:40:00',1.77),('8537','2013-03-25','11:45:00',1.91),('8537','2013-03-25','11:50:00',2.2),('8537','2013-03-25','11:55:00',3.71),('8537','2013-03-25','12:00:00',4.65),('8537','2013-03-25','12:05:00',3.81),('8537','2013-03-25','12:10:00',5.04),('8537','2013-03-25','12:15:00',4.9),('8537','2013-03-25','12:20:00',3.01),('8537','2013-03-25','12:25:00',4.42),('8537','2013-03-25','12:30:00',4.97),('8537','2013-03-25','12:35:00',3.91),('8537','2013-03-25','12:40:00',3.1),('8537','2013-03-25','12:45:00',2.95),('8537','2013-03-25','12:50:00',3.54),('8537','2013-03-25','12:55:00',3.34),('8537','2013-03-25','13:00:00',2.91),('8537','2013-03-25','13:05:00',5.25),('8537','2013-03-25','13:10:00',4.41),('8537','2013-03-25','13:15:00',4.4),('8537','2013-03-25','13:20:00',5.01),('8537','2013-03-25','13:25:00',2.48),('8537','2013-03-25','13:30:00',2.35),('8537','2013-03-25','13:35:00',1.4),('8537','2013-03-25','13:40:00',1.39),('8537','2013-03-25','13:45:00',2.16),('8537','2013-03-25','13:50:00',2.47),('8537','2013-03-25','13:55:00',2.33),('8537','2013-03-25','14:00:00',1.22),('8537','2013-03-25','14:05:00',1.27),('8537','2013-03-25','14:10:00',3.17),('8537','2013-03-25','14:15:00',1.96),('8537','2013-03-25','14:20:00',2.39),('8537','2013-03-25','14:25:00',3.28),('8537','2013-03-25','14:30:00',3.49),('8537','2013-03-25','14:35:00',2.54),('8537','2013-03-25','14:40:00',1.61),('8537','2013-03-25','14:45:00',1.97),('8537','2013-03-25','14:50:00',1.79),('8537','2013-03-25','14:55:00',2.77),('8537','2013-03-25','15:00:00',3.14),('8537','2013-03-25','15:05:00',2.83),('8537','2013-03-25','15:10:00',3.25),('8537','2013-03-25','15:15:00',2.67),('8537','2013-03-25','15:20:00',2.28),('8537','2013-03-25','15:25:00',3.45),('8537','2013-03-25','15:30:00',2.55),('8537','2013-03-25','15:35:00',2.42),('8537','2013-03-25','15:40:00',2.86),('8537','2013-03-25','15:45:00',2.33),('8537','2013-03-25','15:50:00',1.27),('8537','2013-03-25','15:55:00',1.25),('8537','2013-03-25','16:00:00',2.2),('8537','2013-03-25','16:05:00',1.33),('8537','2013-03-25','16:10:00',1.39),('8537','2013-03-25','16:15:00',1.29),('8537','2013-03-25','16:30:00',1.13),('8537','2013-03-25','16:35:00',1.65),('8537','2013-03-25','16:40:00',1.88),('8537','2013-03-25','16:45:00',1.13),('8537','2013-03-24','07:25:00',1.03),('8537','2013-03-24','07:35:00',1.1),('8537','2013-03-24','07:40:00',1.15),('8537','2013-03-24','07:45:00',1.27),('8537','2013-03-24','07:50:00',1.48),('8537','2013-03-24','07:55:00',1.69),('8537','2013-03-24','08:00:00',2.01),('8537','2013-03-24','08:05:00',2.14),('8537','2013-03-24','08:10:00',2.2),('8537','2013-03-24','08:15:00',2.35),('8537','2013-03-24','08:20:00',2.44),('8537','2013-03-24','08:25:00',2.58),('8537','2013-03-24','08:30:00',2.68),('8537','2013-03-24','08:35:00',2.77),('8537','2013-03-24','08:40:00',2.85),('8537','2013-03-24','08:45:00',2.94),('8537','2013-03-24','08:50:00',2.98),('8537','2013-03-24','08:55:00',3.08),('8537','2013-03-24','09:00:00',3.15),('8537','2013-03-24','09:05:00',3.25),('8537','2013-03-24','09:10:00',3.36),('8537','2013-03-24','09:15:00',3.43),('8537','2013-03-24','09:20:00',3.51),('8537','2013-03-24','09:25:00',3.59),('8537','2013-03-24','09:30:00',3.65),('8537','2013-03-24','09:35:00',3.69),('8537','2013-03-24','09:40:00',3.75),('8537','2013-03-24','09:45:00',3.85),('8537','2013-03-24','09:50:00',3.9),('8537','2013-03-24','09:55:00',3.97),('8537','2013-03-24','10:00:00',4.04),('8537','2013-03-24','10:05:00',4.08),('8537','2013-03-24','10:10:00',4.16),('8537','2013-03-24','10:15:00',4.2),('8537','2013-03-24','10:20:00',4.24),('8537','2013-03-24','10:25:00',4.3),('8537','2013-03-24','10:30:00',4.33),('8537','2013-03-24','10:35:00',4.36),('8537','2013-03-24','10:40:00',4.39),('8537','2013-03-24','10:45:00',4.4),('8537','2013-03-24','10:50:00',4.46),('8537','2013-03-24','10:55:00',4.5),('8537','2013-03-24','11:00:00',4.54),('8537','2013-03-24','11:05:00',4.57),('8537','2013-03-24','11:10:00',4.59),('8537','2013-03-24','11:15:00',4.64),('8537','2013-03-24','11:20:00',4.58),('8537','2013-03-24','11:25:00',4.6),('8537','2013-03-24','11:30:00',4.62),('8537','2013-03-24','11:35:00',4.64),('8537','2013-03-24','11:40:00',4.66),('8537','2013-03-24','11:45:00',4.68),('8537','2013-03-24','11:50:00',4.69),('8537','2013-03-24','11:55:00',4.7),('8537','2013-03-24','12:00:00',4.75),('8537','2013-03-24','12:05:00',4.73),('8537','2013-03-24','12:10:00',4.78),('8537','2013-03-24','12:15:00',4.81),('8537','2013-03-24','12:20:00',4.88),('8537','2013-03-24','12:25:00',4.94),('8537','2013-03-24','12:30:00',4.92),('8537','2013-03-24','12:35:00',4.89),('8537','2013-03-24','12:40:00',4.87),('8537','2013-03-24','12:45:00',4.88),('8537','2013-03-24','12:50:00',4.88),('8537','2013-03-24','12:55:00',4.85),('8537','2013-03-24','13:00:00',4.8),('8537','2013-03-24','13:05:00',4.81),('8537','2013-03-24','13:10:00',4.78),('8537','2013-03-24','13:15:00',4.76),('8537','2013-03-24','13:20:00',4.74),('8537','2013-03-24','13:25:00',4.65),('8537','2013-03-24','13:30:00',4.56),('8537','2013-03-24','13:35:00',4.39),('8537','2013-03-24','13:40:00',4.5),('8537','2013-03-24','13:45:00',4.45),('8537','2013-03-24','13:50:00',4.42),('8537','2013-03-24','13:55:00',4.35),('8537','2013-03-24','14:00:00',4.31),('8537','2013-03-24','14:05:00',4.24),('8537','2013-03-24','14:10:00',4.16),('8537','2013-03-24','14:15:00',4.11),('8537','2013-03-24','14:20:00',3.93),('8537','2013-03-24','14:25:00',3.92),('8537','2013-03-24','14:30:00',3.8),('8537','2013-03-24','14:35:00',3.66),('8537','2013-03-24','14:40:00',3.62),('8537','2013-03-24','14:45:00',3.58),('8537','2013-03-24','14:50:00',3.41),('8537','2013-03-24','14:55:00',3.39),('8537','2013-03-24','15:00:00',3.23),('8537','2013-03-24','15:05:00',3.17),('8537','2013-03-24','15:10:00',2.9),('8537','2013-03-24','15:15:00',3.23),('8537','2013-03-24','15:20:00',3.09),('8537','2013-03-24','15:25:00',2.91),('8537','2013-03-24','15:30:00',2.6),('8537','2013-03-24','15:35:00',2.4),('8537','2013-03-24','15:40:00',2.53),('8537','2013-03-24','15:45:00',2.09),('8537','2013-03-24','15:50:00',1.43),('8537','2013-03-24','15:55:00',1.38),('8537','2013-03-24','16:00:00',1.38),('8537','2013-03-24','16:05:00',1.57),('8537','2013-03-24','16:10:00',1.15),('8537','2013-03-24','16:15:00',1.44),('8537','2013-03-24','16:20:00',1.23),('8537','2013-03-24','16:25:00',1.16),('8537','2013-03-24','16:30:00',1.21),('8537','2013-03-24','16:35:00',1.12),('8537','2013-03-23','07:15:00',1.03),('8537','2013-03-23','07:20:00',1.1),('8537','2013-03-23','07:25:00',1.14),('8537','2013-03-23','07:30:00',1.2),('8537','2013-03-23','07:35:00',1.26),('8537','2013-03-23','07:40:00',1.44),('8537','2013-03-23','07:45:00',1.47),('8537','2013-03-23','07:50:00',1.62),('8537','2013-03-23','07:55:00',1.83),('8537','2013-03-23','08:00:00',2.01),('8537','2013-03-23','08:05:00',2.21),('8537','2013-03-23','08:10:00',2.3),('8537','2013-03-23','08:15:00',2.38),('8537','2013-03-23','08:20:00',2.49),('8537','2013-03-23','08:25:00',2.58),('8537','2013-03-23','08:30:00',2.62),('8537','2013-03-23','08:35:00',2.74),('8537','2013-03-23','08:40:00',2.87),('8537','2013-03-23','08:45:00',2.96),('8537','2013-03-23','08:50:00',3.06),('8537','2013-03-23','08:55:00',3.23),('8537','2013-03-23','09:00:00',3.31),('8537','2013-03-23','09:05:00',3.4),('8537','2013-03-23','09:10:00',3.45),('8537','2013-03-23','09:15:00',3.55),('8537','2013-03-23','09:20:00',3.67),('8537','2013-03-23','09:25:00',3.72),('8537','2013-03-23','09:30:00',3.74),('8537','2013-03-23','09:35:00',3.91),('8537','2013-03-23','09:40:00',3.77),('8537','2013-03-23','09:45:00',3.97),('8537','2013-03-23','09:50:00',3.99),('8537','2013-03-23','09:55:00',4.07),('8537','2013-03-23','10:00:00',4.17),('8537','2013-03-23','10:05:00',4.18),('8537','2013-03-23','10:10:00',4.22),('8537','2013-03-23','10:15:00',4.16),('8537','2013-03-23','10:20:00',4.16),('8537','2013-03-23','10:25:00',4.31),('8537','2013-03-23','10:30:00',4.48),('8537','2013-03-23','10:35:00',4.57),('8537','2013-03-23','10:40:00',4.47),('8537','2013-03-23','10:45:00',4.45),('8537','2013-03-23','10:50:00',4.5),('8537','2013-03-23','10:55:00',4.35),('8537','2013-03-23','11:00:00',4.33),('8537','2013-03-23','11:05:00',4.09),('8537','2013-03-23','11:10:00',3.35),('8537','2013-03-23','11:15:00',3.63),('8537','2013-03-23','11:20:00',4.56),('8537','2013-03-23','11:25:00',4.49),('8537','2013-03-23','11:30:00',4.55),('8537','2013-03-23','11:35:00',4.77),('8537','2013-03-23','11:40:00',4.72),('8537','2013-03-23','11:45:00',4.72),('8537','2013-03-23','11:50:00',4.57),('8537','2013-03-23','11:55:00',4.77),('8537','2013-03-23','12:00:00',4.78),('8537','2013-03-23','12:05:00',4.74),('8537','2013-03-23','12:10:00',4.78),('8537','2013-03-23','12:15:00',4.83),('8537','2013-03-23','12:20:00',4.91),('8537','2013-03-23','12:25:00',4.79),('8537','2013-03-23','12:30:00',4.81),('8537','2013-03-23','12:35:00',4.83),('8537','2013-03-23','12:40:00',4.59),('8537','2013-03-23','12:45:00',4.71),('8537','2013-03-23','12:50:00',4.82),('8537','2013-03-23','12:55:00',4.68),('8537','2013-03-23','13:00:00',3.76),('8537','2013-03-23','13:05:00',4.78),('8537','2013-03-23','13:10:00',4.78),('8537','2013-03-23','13:15:00',4.56),('8537','2013-03-23','13:20:00',4.66),('8537','2013-03-23','13:25:00',4.65),('8537','2013-03-23','13:30:00',4.38),('8537','2013-03-23','13:35:00',3.65),('8537','2013-03-23','13:40:00',4.32),('8537','2013-03-23','13:45:00',4.38),('8537','2013-03-23','13:50:00',4.48),('8537','2013-03-23','13:55:00',4.34),('8537','2013-03-23','14:00:00',4.27),('8537','2013-03-23','14:05:00',4.29),('8537','2013-03-23','14:10:00',4.19),('8537','2013-03-23','14:15:00',4.01),('8537','2013-03-23','14:20:00',4.03),('8537','2013-03-23','14:25:00',3.59),('8537','2013-03-23','14:30:00',3.13),('8537','2013-03-23','14:35:00',3.86),('8537','2013-03-23','14:40:00',3.79),('8537','2013-03-23','14:45:00',3.54),('8537','2013-03-23','14:50:00',3.49),('8537','2013-03-23','14:55:00',3.5),('8537','2013-03-23','15:00:00',3.32),('8537','2013-03-23','15:05:00',3.11),('8537','2013-03-23','15:10:00',3.22),('8537','2013-03-23','15:15:00',2.99),('8537','2013-03-23','15:20:00',3.01),('8537','2013-03-23','15:25:00',2.99),('8537','2013-03-23','15:30:00',2.69),('8537','2013-03-23','15:35:00',2.63),('8537','2013-03-23','15:40:00',2.49),('8537','2013-03-23','15:45:00',2.32),('8537','2013-03-23','15:50:00',2.15),('8537','2013-03-23','15:55:00',2.06),('8537','2013-03-23','16:00:00',1.92),('8537','2013-03-23','16:05:00',1.68),('8537','2013-03-23','16:10:00',2.15),('8537','2013-03-23','16:15:00',1.9),('8537','2013-03-23','16:20:00',1.58),('8537','2013-03-23','16:25:00',1.61),('8537','2013-03-23','16:30:00',1.23),('8537','2013-03-23','16:35:00',1.32),('8537','2013-03-23','16:40:00',1.13),('8537','2013-03-23','16:45:00',1.12),('8537','2013-03-23','17:00:00',1.02),('8537','2013-03-23','17:05:00',1.03),('8537','2014-03-26','07:15:00',1.11),('8537','2014-03-26','07:20:00',1.22),('8537','2014-03-26','07:25:00',1.33),('8537','2014-03-26','07:30:00',1.47),('8537','2014-03-26','07:35:00',1.57),('8537','2014-03-26','07:40:00',1.69),('8537','2014-03-26','07:45:00',1.81),('8537','2014-03-26','07:50:00',1.94),('8537','2014-03-26','07:55:00',2.06),('8537','2014-03-26','08:00:00',2.16),('8537','2014-03-26','08:05:00',2.32),('8537','2014-03-26','08:10:00',2.48),('8537','2014-03-26','08:15:00',2.71),('8537','2014-03-26','08:20:00',2.91),('8537','2014-03-26','08:25:00',1.58),('8537','2014-03-26','08:30:00',1.31),('8537','2014-03-26','08:35:00',1.07),('8537','2014-03-26','08:40:00',1.24),('8537','2014-03-26','08:45:00',1.38),('8537','2014-03-26','08:50:00',1.66),('8537','2014-03-26','08:55:00',1.48),('8537','2014-03-26','09:00:00',1.6),('8537','2014-03-26','09:05:00',1.55),('8537','2014-03-26','09:10:00',1.84),('8537','2014-03-26','09:15:00',1.54),('8537','2014-03-26','09:20:00',1.35),('8537','2014-03-26','09:25:00',1.86),('8537','2014-03-26','09:30:00',4.17),('8537','2014-03-26','09:35:00',4.06),('8537','2014-03-26','09:40:00',4.08),('8537','2014-03-26','09:45:00',4.12),('8537','2014-03-26','09:50:00',4.22),('8537','2014-03-26','09:55:00',3.97),('8537','2014-03-26','10:00:00',3.08),('8537','2014-03-26','10:05:00',4.66),('8537','2014-03-26','10:10:00',4.86),('8537','2014-03-26','10:15:00',4.67),('8537','2014-03-26','10:20:00',3.89),('8537','2014-03-26','10:25:00',5),('8537','2014-03-26','10:30:00',4.97),('8537','2014-03-26','10:35:00',3.5),('8537','2014-03-26','10:40:00',1.27),('8537','2014-03-26','10:45:00',4.04),('8537','2014-03-26','10:50:00',3.05),('8537','2014-03-26','10:55:00',4.35),('8537','2014-03-26','11:00:00',3.99),('8537','2014-03-26','11:05:00',2.3),('8537','2014-03-26','11:10:00',4.05),('8537','2014-03-26','11:15:00',4.9),('8537','2014-03-26','11:20:00',3.45),('8537','2014-03-26','11:25:00',1.52),('8537','2014-03-26','11:30:00',1.91),('8537','2014-03-26','11:35:00',2.13),('8537','2014-03-26','11:40:00',2.33),('8537','2014-03-26','11:45:00',2.89),('8537','2014-03-26','11:50:00',3.28),('8537','2014-03-26','11:55:00',5.22),('8537','2014-03-26','12:00:00',5.73),('8537','2014-03-26','12:05:00',4.48),('8537','2014-03-26','12:10:00',4.7),('8537','2014-03-26','12:15:00',1.82),('8537','2014-03-26','12:20:00',2.11),('8537','2014-03-26','12:25:00',2.06),('8537','2014-03-26','12:30:00',1.99),('8537','2014-03-26','12:35:00',1.96),('8537','2014-03-26','12:40:00',2.17),('8537','2014-03-26','12:45:00',2.75),('8537','2014-03-26','12:50:00',1.83),('8537','2014-03-26','12:55:00',1.49),('8537','2014-03-26','13:00:00',1.65),('8537','2014-03-26','13:05:00',1.45),('8537','2014-03-26','13:10:00',1.18),('8537','2014-03-26','13:20:00',1.48),('8537','2014-03-26','13:25:00',5.51),('8537','2014-03-26','13:30:00',4.85),('8537','2014-03-26','13:35:00',2.94),('8537','2014-03-26','13:40:00',3.16),('8537','2014-03-26','13:45:00',1.02),('8537','2014-03-26','13:55:00',1.35),('8537','2014-03-26','14:00:00',2.04),('8537','2014-03-26','14:05:00',3.96),('8537','2014-03-26','14:10:00',4.29),('8537','2014-03-26','14:15:00',1.69),('8537','2014-03-26','14:20:00',1.17),('8537','2014-03-26','14:45:00',2.19),('8537','2014-03-26','14:50:00',3.8),('8537','2014-03-26','14:55:00',3.94),('8537','2014-03-26','15:00:00',3.34),('8537','2014-03-26','15:05:00',3.6),('8537','2014-03-26','15:10:00',3.63),('8537','2014-03-26','15:15:00',3.75),('8537','2014-03-26','15:20:00',3.45),('8537','2014-03-26','15:25:00',3.6),('8537','2014-03-26','15:30:00',3.62),('8537','2014-03-26','15:35:00',3.29),('8537','2014-03-26','15:40:00',2.23),('8537','2014-03-26','15:45:00',2.21),('8537','2014-03-26','15:50:00',2.23),('8537','2014-03-26','15:55:00',2.03),('8537','2014-03-26','16:00:00',1.46),('8537','2014-03-26','16:05:00',1.4),('8537','2014-03-26','16:10:00',1.4),('8537','2014-03-26','16:15:00',1.27),('8537','2014-03-26','16:20:00',1.17),('8537','2013-03-22','07:20:00',1.08),('8537','2013-03-22','07:25:00',1.2),('8537','2013-03-22','07:30:00',1.32),('8537','2013-03-22','07:35:00',1.44),('8537','2013-03-22','07:40:00',1.57),('8537','2013-03-22','07:45:00',1.69),('8537','2013-03-22','07:50:00',1.79),('8537','2013-03-22','07:55:00',1.89),('8537','2013-03-22','08:00:00',2.01),('8537','2013-03-22','08:05:00',2.14),('8537','2013-03-22','08:10:00',2.25),('8537','2013-03-22','08:15:00',2.35),('8537','2013-03-22','08:20:00',2.49),('8537','2013-03-22','08:25:00',2.59),('8537','2013-03-22','08:30:00',2.71),('8537','2013-03-22','08:35:00',2.82),('8537','2013-03-22','08:40:00',2.91),('8537','2013-03-22','08:45:00',3),('8537','2013-03-22','08:50:00',3.11),('8537','2013-03-22','08:55:00',3.2),('8537','2013-03-22','09:00:00',3.28),('8537','2013-03-22','09:05:00',3.36),('8537','2013-03-22','09:10:00',3.44),('8537','2013-03-22','09:15:00',3.54),('8537','2013-03-22','09:20:00',3.59),('8537','2013-03-22','09:25:00',3.67),('8537','2013-03-22','09:30:00',3.74),('8537','2013-03-22','09:35:00',3.83),('8537','2013-03-22','09:40:00',3.89),('8537','2013-03-22','09:45:00',4),('8537','2013-03-22','09:50:00',4.04),('8537','2013-03-22','09:55:00',4.1),('8537','2013-03-22','10:00:00',4.17),('8537','2013-03-22','10:05:00',4.24),('8537','2013-03-22','10:10:00',4.31),('8537','2013-03-22','10:15:00',4.36),('8537','2013-03-22','10:20:00',4.38),('8537','2013-03-22','10:25:00',4.5),('8537','2013-03-22','10:30:00',4.58),('8537','2013-03-22','10:35:00',4.63),('8537','2013-03-22','10:40:00',4.65),('8537','2013-03-22','10:45:00',4.68),('8537','2013-03-22','10:50:00',4.73),('8537','2013-03-22','10:55:00',4.78),('8537','2013-03-22','11:00:00',4.77),('8537','2013-03-22','11:05:00',4.78),('8537','2013-03-22','11:10:00',4.81),('8537','2013-03-22','11:15:00',4.87),('8537','2013-03-22','11:20:00',4.87),('8537','2013-03-22','11:25:00',4.9),('8537','2013-03-22','11:30:00',4.97),('8537','2013-03-22','11:35:00',4.98),('8537','2013-03-22','11:40:00',4.98),('8537','2013-03-22','11:45:00',5.04),('8537','2013-03-22','11:50:00',5.03),('8537','2013-03-22','11:55:00',5.04),('8537','2013-03-22','12:00:00',5.07),('8537','2013-03-22','12:05:00',5.06),('8537','2013-03-22','12:10:00',5.06),('8537','2013-03-22','12:15:00',5.04),('8537','2013-03-22','12:20:00',5.03),('8537','2013-03-22','12:25:00',5.06),('8537','2013-03-22','12:30:00',5.05),('8537','2013-03-22','12:35:00',5),('8537','2013-03-22','12:40:00',5.06),('8537','2013-03-22','12:45:00',5.04),('8537','2013-03-22','12:50:00',4.96),('8537','2013-03-22','12:55:00',4.77),('8537','2013-03-22','13:00:00',5),('8537','2013-03-22','13:05:00',4.84),('8537','2013-03-22','13:10:00',4.98),('8537','2013-03-22','13:15:00',4.96),('8537','2013-03-22','13:20:00',4.9),('8537','2013-03-22','13:25:00',4.64),('8537','2013-03-22','13:30:00',4.55),('8537','2013-03-22','13:35:00',4.58),('8537','2013-03-22','13:40:00',3.97),('8537','2013-03-22','13:45:00',4.08),('8537','2013-03-22','13:50:00',4.68),('8537','2013-03-22','13:55:00',4.59),('8537','2013-03-22','14:00:00',4.47),('8537','2013-03-22','14:05:00',4.43),('8537','2013-03-22','14:10:00',4.39),('8537','2013-03-22','14:15:00',4.33),('8537','2013-03-22','14:20:00',4.18),('8537','2013-03-22','14:25:00',4.15),('8537','2013-03-22','14:30:00',4.1),('8537','2013-03-22','14:35:00',4.01),('8537','2013-03-22','14:40:00',3.92),('8537','2013-03-22','14:45:00',3.86),('8537','2013-03-22','14:50:00',3.81),('8537','2013-03-22','14:55:00',3.71),('8537','2013-03-22','15:00:00',3.62),('8537','2013-03-22','15:05:00',3.53),('8537','2013-03-22','15:10:00',3.15),('8537','2013-03-22','15:15:00',2.6),('8537','2013-03-22','15:20:00',2.55),('8537','2013-03-22','15:25:00',2.69),('8537','2013-03-22','15:30:00',2.44),('8537','2013-03-22','15:35:00',2.46),('8537','2013-03-22','15:40:00',2.62),('8537','2013-03-22','15:45:00',2.32),('8537','2013-03-22','15:50:00',2.45),('8537','2013-03-22','15:55:00',2.1),('8537','2013-03-22','16:00:00',1.53),('8537','2013-03-22','16:05:00',1.55),('8537','2013-03-22','16:10:00',1.77),('8537','2013-03-22','16:15:00',2.07),('8537','2013-03-22','16:20:00',1.66),('8537','2013-03-22','16:25:00',1.63),('8537','2013-03-22','16:30:00',1.75),('8537','2013-03-22','16:35:00',1.73),('8537','2013-03-22','16:40:00',1.64),('8537','2013-03-22','16:45:00',1.47),('8537','2013-03-22','16:50:00',1.35),('8537','2013-03-22','16:55:00',1.28),('8537','2013-03-22','17:00:00',1.12),('8537','2013-03-21','07:35:00',1.12),('8537','2013-03-21','07:40:00',1.49),('8537','2013-03-21','07:45:00',1.75),('8537','2013-03-21','07:50:00',1.94),('8537','2013-03-21','07:55:00',1.01),('8537','2013-03-21','08:10:00',1.22),('8537','2013-03-21','08:15:00',2.46),('8537','2013-03-21','08:20:00',2.7),('8537','2013-03-21','08:25:00',2.85),('8537','2013-03-21','08:30:00',2.74),('8537','2013-03-21','08:35:00',2.96),('8537','2013-03-21','08:40:00',3.24),('8537','2013-03-21','08:45:00',3.24),('8537','2013-03-21','08:50:00',3.19),('8537','2013-03-21','08:55:00',2.91),('8537','2013-03-21','09:00:00',3.49),('8537','2013-03-21','09:05:00',3.73),('8537','2013-03-21','09:10:00',4.21),('8537','2013-03-21','09:15:00',3.25),('8537','2013-03-21','09:20:00',3.69),('8537','2013-03-21','09:25:00',3.83),('8537','2013-03-21','09:30:00',4.12),('8537','2013-03-21','09:35:00',4.13),('8537','2013-03-21','09:40:00',3.89),('8537','2013-03-21','09:45:00',4.21),('8537','2013-03-21','09:50:00',4.36),('8537','2013-03-21','09:55:00',4.46),('8537','2013-03-21','10:00:00',4.53),('8537','2013-03-21','10:05:00',4.53),('8537','2013-03-21','10:10:00',4.59),('8537','2013-03-21','10:15:00',4.63),('8537','2013-03-21','10:20:00',4.7),('8537','2013-03-21','10:25:00',4.7),('8537','2013-03-21','10:30:00',4.74),('8537','2013-03-21','10:35:00',4.82),('8537','2013-03-21','10:40:00',4.88),('8537','2013-03-21','10:45:00',4.86),('8537','2013-03-21','10:50:00',4.85),('8537','2013-03-21','10:55:00',3.41),('8537','2013-03-21','11:00:00',3.44),('8537','2013-03-21','11:05:00',5.05),('8537','2013-03-21','11:10:00',5.08),('8537','2013-03-21','11:15:00',5.16),('8537','2013-03-21','11:20:00',5.17),('8537','2013-03-21','11:25:00',5.18),('8537','2013-03-21','11:30:00',5.23),('8537','2013-03-21','11:35:00',5.28),('8537','2013-03-21','11:40:00',5.29),('8537','2013-03-21','11:45:00',5.32),('8537','2013-03-21','11:50:00',5.34),('8537','2013-03-21','11:55:00',5.33),('8537','2013-03-21','12:00:00',5.32),('8537','2013-03-21','12:05:00',5.33),('8537','2013-03-21','12:10:00',5.34),('8537','2013-03-21','12:15:00',5.33),('8537','2013-03-21','12:20:00',5.32),('8537','2013-03-21','12:25:00',5.31),('8537','2013-03-21','12:30:00',5.32),('8537','2013-03-21','12:35:00',5.29),('8537','2013-03-21','12:40:00',5.29),('8537','2013-03-21','12:45:00',5.26),('8537','2013-03-21','12:50:00',5.23),('8537','2013-03-21','12:55:00',5.21),('8537','2013-03-21','13:00:00',5.18),('8537','2013-03-21','13:05:00',5.14),('8537','2013-03-21','13:10:00',5.03),('8537','2013-03-21','13:15:00',5.09),('8537','2013-03-21','13:20:00',5.03),('8537','2013-03-21','13:25:00',4.98),('8537','2013-03-21','13:30:00',4.93),('8537','2013-03-21','13:35:00',4.66),('8537','2013-03-21','13:40:00',4.64),('8537','2013-03-21','13:45:00',4.78),('8537','2013-03-21','13:50:00',4.72),('8537','2013-03-21','13:55:00',4.66),('8537','2013-03-21','14:00:00',4.61),('8537','2013-03-21','14:05:00',4.52),('8537','2013-03-21','14:10:00',4.43),('8537','2013-03-21','14:15:00',4.39),('8537','2013-03-21','14:20:00',4.19),('8537','2013-03-21','14:25:00',4.07),('8537','2013-03-21','14:30:00',4.14),('8537','2013-03-21','14:35:00',4.05),('8537','2013-03-21','14:40:00',3.97),('8537','2013-03-21','14:45:00',3.91),('8537','2013-03-21','14:50:00',3.85),('8537','2013-03-21','14:55:00',3.74),('8537','2013-03-21','15:00:00',3.62),('8537','2013-03-21','15:05:00',3.57),('8537','2013-03-21','15:10:00',3.48),('8537','2013-03-21','15:15:00',3.39),('8537','2013-03-21','15:20:00',3.29),('8537','2013-03-21','15:25:00',3.21),('8537','2013-03-21','15:30:00',3.05),('8537','2013-03-21','15:35:00',2.63),('8537','2013-03-21','15:40:00',2.88),('8537','2013-03-21','15:45:00',2.77),('8537','2013-03-21','15:50:00',2.6),('8537','2013-03-21','15:55:00',2.49),('8537','2013-03-21','16:00:00',2.39),('8537','2013-03-21','16:05:00',2.29),('8537','2013-03-21','16:10:00',2.12),('8537','2013-03-21','16:15:00',2.03),('8537','2013-03-21','16:20:00',1.89),('8537','2013-03-21','16:25:00',1.77),('8537','2013-03-21','16:30:00',1.65),('8537','2013-03-21','16:35:00',1.53),('8537','2013-03-21','16:40:00',1.38),('8537','2013-03-21','16:45:00',1.29),('8537','2013-03-21','16:50:00',1.19),('8537','2013-03-21','16:55:00',1.06),('8537','2013-03-20','07:20:00',1.05),('8537','2013-03-20','07:25:00',1.19),('8537','2013-03-20','07:30:00',1.33),('8537','2013-03-20','07:35:00',1.49),('8537','2013-03-20','07:40:00',1.52),('8537','2013-03-20','07:45:00',1.6),('8537','2013-03-20','07:50:00',1.64),('8537','2013-03-20','07:55:00',1.94),('8537','2013-03-20','08:00:00',1.71),('8537','2013-03-20','08:05:00',1.79),('8537','2013-03-20','08:10:00',2.21),('8537','2013-03-20','08:15:00',2.34),('8537','2013-03-20','08:20:00',2.43),('8537','2013-03-20','08:25:00',2.58),('8537','2013-03-20','08:30:00',2.73),('8537','2013-03-20','08:35:00',2.77),('8537','2013-03-20','08:40:00',2.77),('8537','2013-03-20','08:45:00',2.88),('8537','2013-03-20','08:50:00',3.02),('8537','2013-03-20','08:55:00',2.97),('8537','2013-03-20','09:00:00',3),('8537','2013-03-20','09:05:00',3.96),('8537','2013-03-20','09:10:00',3.46),('8537','2013-03-20','09:15:00',3.49),('8537','2013-03-20','09:20:00',3.51),('8537','2013-03-20','09:25:00',3.76),('8537','2013-03-20','09:30:00',3.82),('8537','2013-03-20','09:35:00',3.71),('8537','2013-03-20','09:40:00',3.84),('8537','2013-03-20','09:45:00',4.01),('8537','2013-03-20','09:50:00',4.04),('8537','2013-03-20','09:55:00',4.01),('8537','2013-03-20','10:00:00',4.18),('8537','2013-03-20','10:05:00',4.25),('8537','2013-03-20','10:10:00',3.54),('8537','2013-03-20','10:15:00',3.7),('8537','2013-03-20','10:20:00',3.4),('8537','2013-03-20','10:25:00',3.04),('8537','2013-03-20','10:30:00',3.78),('8537','2013-03-20','10:35:00',4.34),('8537','2013-03-20','10:40:00',3.89),('8537','2013-03-20','10:45:00',2.91),('8537','2013-03-20','10:50:00',4.01),('8537','2013-03-20','10:55:00',3.54),('8537','2013-03-20','11:00:00',3.48),('8537','2013-03-20','11:05:00',4.13),('8537','2013-03-20','11:10:00',3.21),('8537','2013-03-20','11:15:00',2.96),('8537','2013-03-20','11:20:00',3.35),('8537','2013-03-20','11:25:00',3.18),('8537','2013-03-20','11:30:00',2.95),('8537','2013-03-20','11:35:00',3.27),('8537','2013-03-20','11:40:00',2.65),('8537','2013-03-20','11:45:00',2.5),('8537','2013-03-20','11:50:00',2.36),('8537','2013-03-20','11:55:00',2.67),('8537','2013-03-20','12:00:00',2.56),('8537','2013-03-20','12:05:00',2.84),('8537','2013-03-20','12:10:00',2.31),('8537','2013-03-20','12:15:00',2),('8537','2013-03-20','12:20:00',1.85),('8537','2013-03-20','12:25:00',1.54),('8537','2013-03-20','12:30:00',1.24),('8537','2013-03-20','12:35:00',1.57),('8537','2013-03-20','12:40:00',1.12),('8537','2013-03-20','12:45:00',1.23),('8537','2013-03-20','12:50:00',1.72),('8537','2013-03-20','12:55:00',2.01),('8537','2013-03-20','13:00:00',2.19),('8537','2013-03-20','13:05:00',1.69),('8537','2013-03-20','13:10:00',1.71),('8537','2013-03-20','13:15:00',1.38),('8537','2013-03-20','13:20:00',1.48),('8537','2013-03-20','13:25:00',1.57),('8537','2013-03-20','13:30:00',1.7),('8537','2013-03-20','13:35:00',1.62),('8537','2013-03-20','13:40:00',2.05),('8537','2013-03-20','13:45:00',2.39),('8537','2013-03-20','13:50:00',2),('8537','2013-03-20','13:55:00',1.85),('8537','2013-03-20','14:00:00',1.85),('8537','2013-03-20','14:05:00',1.58),('8537','2013-03-20','14:10:00',1.5),('8537','2013-03-20','14:15:00',1.98),('8537','2013-03-20','14:20:00',2.46),('8537','2013-03-20','14:25:00',2.25),('8537','2013-03-20','14:30:00',1.93),('8537','2013-03-20','14:35:00',1.59),('8537','2013-03-20','14:40:00',1.27),('8537','2013-03-20','14:45:00',1.24),('8537','2013-03-20','14:50:00',1.01),('8537','2013-03-19','07:10:00',1.07),('8537','2013-03-19','07:15:00',1.16),('8537','2013-03-19','07:20:00',1.01),('8537','2013-03-19','07:25:00',1.12),('8537','2013-03-19','07:30:00',1.23),('8537','2013-03-19','07:35:00',1.34),('8537','2013-03-19','07:40:00',1.47),('8537','2013-03-19','07:45:00',1.6),('8537','2013-03-19','07:50:00',1.71),('8537','2013-03-19','07:55:00',1.76),('8537','2013-03-19','08:00:00',1.21),('8537','2013-03-19','08:05:00',1.74),('8537','2013-03-19','08:10:00',2.14),('8537','2013-03-19','08:15:00',2.33),('8537','2013-03-19','08:20:00',2.41),('8537','2013-03-19','08:25:00',2.5),('8537','2013-03-19','08:30:00',2.66),('8537','2013-03-19','08:35:00',2.49),('8537','2013-03-19','08:40:00',2.5),('8537','2013-03-19','08:45:00',3.05),('8537','2013-03-19','08:50:00',3.12),('8537','2013-03-19','08:55:00',3.21),('8537','2013-03-19','09:00:00',3.29),('8537','2013-03-19','09:05:00',3.3),('8537','2013-03-19','09:10:00',3.5),('8537','2013-03-19','09:15:00',3.14),('8537','2013-03-19','09:20:00',3.18),('8537','2013-03-19','09:25:00',3.07),('8537','2013-03-19','09:30:00',3.76),('8537','2013-03-19','09:35:00',3.91),('8537','2013-03-19','09:40:00',4.09),('8537','2013-03-19','09:45:00',4.23),('8537','2013-03-19','09:50:00',3.99),('8537','2013-03-19','09:55:00',3.27),('8537','2013-03-19','10:00:00',3.54),('8537','2013-03-19','10:05:00',3.64),('8537','2013-03-19','10:10:00',4.36),('8537','2013-03-19','10:15:00',4.52),('8537','2013-03-19','10:20:00',4.6),('8537','2013-03-19','10:25:00',4.12),('8537','2013-03-19','10:30:00',4.67),('8537','2013-03-19','10:35:00',4.77),('8537','2013-03-19','10:40:00',4.82),('8537','2013-03-19','10:45:00',4.9),('8537','2013-03-19','10:50:00',4.81),('8537','2013-03-19','10:55:00',5.03),('8537','2013-03-19','11:00:00',5.05),('8537','2013-03-19','11:05:00',5.05),('8537','2013-03-19','11:10:00',4.99),('8537','2013-03-19','11:15:00',5.16),('8537','2013-03-19','11:20:00',5.16),('8537','2013-03-19','11:25:00',5.15),('8537','2013-03-19','11:30:00',5.11),('8537','2013-03-19','11:35:00',3.17),('8537','2013-03-19','11:40:00',4.61),('8537','2013-03-19','11:45:00',4.77),('8537','2013-03-19','11:50:00',5.27),('8537','2013-03-19','11:55:00',5.31),('8537','2013-03-19','12:00:00',5.25),('8537','2013-03-19','12:05:00',5.2),('8537','2013-03-19','12:10:00',5.16),('8537','2013-03-19','12:15:00',4.86),('8537','2013-03-19','12:20:00',5.21),('8537','2013-03-19','12:25:00',5.13),('8537','2013-03-19','12:30:00',5.09),('8537','2013-03-19','12:35:00',5.14),('8537','2013-03-19','12:40:00',5.15),('8537','2013-03-19','12:45:00',5.15),('8537','2013-03-19','12:50:00',5.09),('8537','2013-03-19','12:55:00',5.09),('8537','2013-03-19','13:00:00',5.1),('8537','2013-03-19','13:05:00',5.06),('8537','2013-03-19','13:10:00',4.99),('8537','2013-03-19','13:15:00',4.94),('8537','2013-03-19','13:20:00',4.92),('8537','2013-03-19','13:25:00',4.86),('8537','2013-03-19','13:30:00',4.82),('8537','2013-03-19','13:35:00',4.64),('8537','2013-03-19','13:40:00',4.53),('8537','2013-03-19','13:45:00',4.65),('8537','2013-03-19','13:50:00',4.6),('8537','2013-03-19','13:55:00',4.53),('8537','2013-03-19','14:00:00',4.5),('8537','2013-03-19','14:05:00',4.46),('8537','2013-03-19','14:10:00',4.41),('8537','2013-03-19','14:15:00',4.33),('8537','2013-03-19','14:20:00',4.18),('8537','2013-03-19','14:25:00',4.06),('8537','2013-03-19','14:30:00',4.09),('8537','2013-03-19','14:35:00',4),('8537','2013-03-19','14:40:00',3.94),('8537','2013-03-19','14:45:00',3.86),('8537','2013-03-19','14:50:00',3.77),('8537','2013-03-19','14:55:00',3.69),('8537','2013-03-19','15:00:00',3.55),('8537','2013-03-19','15:05:00',3.47),('8537','2013-03-19','15:10:00',3.35),('8537','2013-03-19','15:15:00',3.32),('8537','2013-03-19','15:20:00',3.25),('8537','2013-03-19','15:25:00',3.14),('8537','2013-03-19','15:30:00',2.99),('8537','2013-03-19','15:35:00',2.56),('8537','2013-03-19','15:40:00',2.75),('8537','2013-03-19','15:45:00',2.73),('8537','2013-03-19','15:50:00',2.56),('8537','2013-03-19','15:55:00',2.45),('8537','2013-03-19','16:00:00',2.34),('8537','2013-03-19','16:05:00',2.24),('8537','2013-03-19','16:10:00',2.11),('8537','2013-03-19','16:15:00',1.98),('8537','2013-03-19','16:20:00',1.84),('8537','2013-03-19','16:25:00',1.74),('8537','2013-03-19','16:30:00',1.64),('8537','2013-03-19','16:35:00',1.54),('8537','2013-03-19','16:40:00',1.41),('8537','2013-03-19','16:45:00',1.13),('8537','2013-03-18','08:45:00',1.07),('8537','2013-03-18','09:55:00',1.12),('8537','2013-03-18','10:00:00',1.42),('8537','2013-03-18','10:05:00',1.77),('8537','2013-03-18','10:10:00',1.74),('8537','2013-03-18','10:15:00',1.5),('8537','2013-03-18','10:20:00',1.86),('8537','2013-03-18','10:25:00',2.41),('8537','2013-03-18','10:30:00',2.25),('8537','2013-03-18','10:35:00',1.79),('8537','2013-03-18','10:40:00',1.63),('8537','2013-03-18','10:45:00',1.69),('8537','2013-03-18','10:50:00',1.63),('8537','2013-03-18','10:55:00',1.36),('8537','2013-03-18','11:00:00',1.46),('8537','2013-03-18','11:05:00',1.61),('8537','2013-03-18','11:10:00',1.85),('8537','2013-03-18','11:15:00',2.01),('8537','2013-03-18','11:20:00',2.08),('8537','2013-03-18','11:25:00',2.22),('8537','2013-03-18','11:30:00',2.71),('8537','2013-03-18','11:35:00',2.29),('8537','2013-03-18','11:40:00',2.1),('8537','2013-03-18','11:45:00',1.77),('8537','2013-03-18','11:50:00',1.45),('8537','2013-03-18','11:55:00',1.72),('8537','2013-03-18','12:00:00',1.81),('8537','2013-03-18','12:05:00',3.15),('8537','2013-03-18','12:10:00',2.88),('8537','2013-03-18','12:15:00',3.39),('8537','2013-03-18','12:20:00',3.31),('8537','2013-03-18','12:25:00',2.26),('8537','2013-03-18','12:30:00',4),('8537','2013-03-18','12:35:00',4.37),('8537','2013-03-18','12:40:00',3.67),('8537','2013-03-18','12:45:00',3.11),('8537','2013-03-18','12:50:00',4.39),('8537','2013-03-18','12:55:00',4.76),('8537','2013-03-18','13:00:00',3.74),('8537','2013-03-18','13:05:00',1.97),('8537','2013-03-18','13:10:00',1.37),('8537','2013-03-18','13:15:00',1.03),('8537','2013-03-18','13:20:00',1.19),('8537','2013-03-18','13:25:00',2.14),('8537','2013-03-18','13:30:00',1.64),('8537','2013-03-18','13:35:00',1.36),('8537','2013-03-18','13:40:00',2.3),('8537','2013-03-18','13:45:00',2.08),('8537','2013-03-18','13:50:00',1.95),('8537','2013-03-18','13:55:00',1.8),('8537','2013-03-18','14:00:00',1.96),('8537','2013-03-18','14:05:00',3.01),('8537','2013-03-18','14:10:00',2.87),('8537','2013-03-18','14:15:00',1.47),('8537','2013-03-18','14:20:00',1.42),('8537','2013-03-18','14:25:00',2),('8537','2013-03-18','14:35:00',1.28),('8537','2013-03-18','14:40:00',1.42),('8537','2013-03-18','14:45:00',1.33),('8537','2013-03-18','14:55:00',1.07),('8537','2013-03-18','15:00:00',1.26),('8537','2013-03-18','15:05:00',1.05),('8537','2013-03-18','15:15:00',1.02),('8537','2013-03-17','08:10:00',1.13),('8537','2013-03-17','08:15:00',1.34),('8537','2013-03-17','08:20:00',1.55),('8537','2013-03-17','08:25:00',1.87),('8537','2013-03-17','08:30:00',1.6),('8537','2013-03-17','08:35:00',1.41),('8537','2013-03-17','08:40:00',1.44),('8537','2013-03-17','08:45:00',1.73),('8537','2013-03-17','08:50:00',1.69),('8537','2013-03-17','08:55:00',1.59),('8537','2013-03-17','09:00:00',1.55),('8537','2013-03-17','09:05:00',1.79),('8537','2013-03-17','09:10:00',2.04),('8537','2013-03-17','09:15:00',2.26),('8537','2013-03-17','09:20:00',1.85),('8537','2013-03-17','09:25:00',1.54),('8537','2013-03-17','09:30:00',1.68),('8537','2013-03-17','09:35:00',1.93),('8537','2013-03-17','09:40:00',1.8),('8537','2013-03-17','09:45:00',1.85),('8537','2013-03-17','09:50:00',2.07),('8537','2013-03-17','09:55:00',2.25),('8537','2013-03-17','10:00:00',2.49),('8537','2013-03-17','10:05:00',2.06),('8537','2013-03-17','10:10:00',2.01),('8537','2013-03-17','10:15:00',2.2),('8537','2013-03-17','10:20:00',2.23),('8537','2013-03-17','10:25:00',2.33),('8537','2013-03-17','10:30:00',2.26),('8537','2013-03-17','10:35:00',2.15),('8537','2013-03-17','10:40:00',2.02),('8537','2013-03-17','10:45:00',2.14),('8537','2013-03-17','10:50:00',2.09),('8537','2013-03-17','10:55:00',1.89),('8537','2013-03-17','11:00:00',1.91),('8537','2013-03-17','11:05:00',1.63),('8537','2013-03-17','11:10:00',1.56),('8537','2013-03-17','11:15:00',1.65),('8537','2013-03-17','11:20:00',1.9),('8537','2013-03-17','11:25:00',1.99),('8537','2013-03-17','11:30:00',1.79),('8537','2013-03-17','11:35:00',1.75),('8537','2013-03-17','11:40:00',1.64),('8537','2013-03-17','11:45:00',1.54),('8537','2013-03-17','11:50:00',1.42),('8537','2013-03-17','11:55:00',1.27),('8537','2013-03-17','12:00:00',1.25),('8537','2013-03-17','12:05:00',1.29),('8537','2013-03-17','12:10:00',1.64),('8537','2013-03-17','12:15:00',2.22),('8537','2013-03-17','12:20:00',2.72),('8537','2013-03-17','12:25:00',4.09),('8537','2013-03-17','12:30:00',4.36),('8537','2013-03-17','12:35:00',2.98),('8537','2013-03-17','12:40:00',3.23),('8537','2013-03-17','12:45:00',2.94),('8537','2013-03-17','12:50:00',2.56),('8537','2013-03-17','12:55:00',2.02),('8537','2013-03-17','13:00:00',2.4),('8537','2013-03-17','13:05:00',2.66),('8537','2013-03-17','13:10:00',2.93),('8537','2013-03-17','13:15:00',2.93),('8537','2013-03-17','13:20:00',2.42),('8537','2013-03-17','13:25:00',2.1),('8537','2013-03-17','13:30:00',3.15),('8537','2013-03-17','13:35:00',3.55),('8537','2013-03-17','13:40:00',2.38),('8537','2013-03-17','13:45:00',2.16),('8537','2013-03-17','13:50:00',1.68),('8537','2013-03-17','13:55:00',2.52),('8537','2013-03-17','14:00:00',2.51),('8537','2013-03-17','14:05:00',2.48),('8537','2013-03-17','14:10:00',2.92),('8537','2013-03-17','14:15:00',3.16),('8537','2013-03-17','14:20:00',3.11),('8537','2013-03-17','14:25:00',2.9),('8537','2013-03-17','14:30:00',2.7),('8537','2013-03-17','14:35:00',2.22),('8537','2013-03-17','14:40:00',1.74),('8537','2013-03-17','14:45:00',1.54),('8537','2013-03-17','14:50:00',1.34),('8537','2013-03-17','14:55:00',1.38),('8537','2013-03-17','15:00:00',1.8),('8537','2013-03-17','15:05:00',1.96),('8537','2013-03-17','15:10:00',2.38),('8537','2013-03-17','15:15:00',2.28),('8537','2013-03-17','15:20:00',2.74),('8537','2013-03-17','15:25:00',2.06),('8537','2013-03-17','15:30:00',1.49),('8537','2013-03-17','15:35:00',1.58),('8537','2013-03-17','15:40:00',1.68),('8537','2013-03-17','15:45:00',1.71),('8537','2013-03-17','15:50:00',1.04),('8537','2013-03-17','15:55:00',1.01),('8537','2013-03-17','16:45:00',1.16),('8537','2013-03-16','07:50:00',1.22),('8537','2013-03-16','08:00:00',1.2),('8537','2013-03-16','08:05:00',1.26),('8537','2013-03-16','08:10:00',1.28),('8537','2013-03-16','08:15:00',2.48),('8537','2013-03-16','08:20:00',2.85),('8537','2013-03-16','08:25:00',2.82),('8537','2013-03-16','08:30:00',2.75),('8537','2013-03-16','08:35:00',2.88),('8537','2013-03-16','08:40:00',3.03),('8537','2013-03-16','08:45:00',3.04),('8537','2013-03-16','08:50:00',3.28),('8537','2013-03-16','08:55:00',3.48),('8537','2013-03-16','09:00:00',3.48),('8537','2013-03-16','09:05:00',2.61),('8537','2013-03-16','09:10:00',3.7),('8537','2013-03-16','09:15:00',3.78),('8537','2013-03-16','09:20:00',3.74),('8537','2013-03-16','09:25:00',2.62),('8537','2013-03-16','09:30:00',3.79),('8537','2013-03-16','09:35:00',4.24),('8537','2013-03-16','09:40:00',3.84),('8537','2013-03-16','09:45:00',3.9),('8537','2013-03-16','09:50:00',4.43),('8537','2013-03-16','09:55:00',4.5),('8537','2013-03-16','10:00:00',3.59),('8537','2013-03-16','10:05:00',2.37),('8537','2013-03-16','10:10:00',3.32),('8537','2013-03-16','10:15:00',2.98),('8537','2013-03-16','10:20:00',2.43),('8537','2013-03-16','10:25:00',3.08),('8537','2013-03-16','10:30:00',2.75),('8537','2013-03-16','10:35:00',3.06),('8537','2013-03-16','10:40:00',4.49),('8537','2013-03-16','10:45:00',4.95),('8537','2013-03-16','10:50:00',4.96),('8537','2013-03-16','10:55:00',4.94),('8537','2013-03-16','11:00:00',5.03),('8537','2013-03-16','11:05:00',5.02),('8537','2013-03-16','11:10:00',5.1),('8537','2013-03-16','11:15:00',5.16),('8537','2013-03-16','11:20:00',5.12),('8537','2013-03-16','11:25:00',5.13),('8537','2013-03-16','11:30:00',5.17),('8537','2013-03-16','11:35:00',5.17),('8537','2013-03-16','11:40:00',5.17),('8537','2013-03-16','11:45:00',5.22),('8537','2013-03-16','11:50:00',5.21),('8537','2013-03-16','11:55:00',5.21),('8537','2013-03-16','12:00:00',5.22),('8537','2013-03-16','12:05:00',5.18),('8537','2013-03-16','12:10:00',5.21),('8537','2013-03-16','12:15:00',5.22),('8537','2013-03-16','12:20:00',5.16),('8537','2013-03-16','12:25:00',5.19),('8537','2013-03-16','12:30:00',5.21),('8537','2013-03-16','12:35:00',5.17),('8537','2013-03-16','12:40:00',5.16),('8537','2013-03-16','12:45:00',5.13),('8537','2013-03-16','12:50:00',5.05),('8537','2013-03-16','12:55:00',5),('8537','2013-03-16','13:00:00',4.99),('8537','2013-03-16','13:05:00',4.94),('8537','2013-03-16','13:10:00',4.85),('8537','2013-03-16','13:15:00',4.9),('8537','2013-03-16','13:20:00',3.76),('8537','2013-03-16','13:25:00',1.08),('8537','2013-03-16','13:30:00',1.1),('8537','2013-03-16','13:35:00',4.01),('8537','2013-03-16','13:40:00',4.91),('8537','2013-03-16','13:45:00',4.88),('8537','2013-03-16','13:50:00',4.43),('8537','2013-03-16','13:55:00',1.24),('8537','2013-03-16','14:00:00',4.66),('8537','2013-03-16','14:05:00',4.77),('8537','2013-03-16','14:10:00',2.43),('8537','2013-03-16','14:15:00',3.49),('8537','2013-03-16','14:20:00',2.73),('8537','2013-03-16','14:25:00',1.42),('8537','2013-03-16','14:30:00',2.51),('8537','2013-03-16','14:35:00',4.14),('8537','2013-03-16','14:40:00',2.06),('8537','2013-03-16','14:45:00',2.15),('8537','2013-03-16','15:40:00',1.05),('8537','2013-03-16','16:00:00',1),('8537','2013-03-16','16:05:00',1.59),('8537','2013-03-16','16:10:00',1.43),('8537','2013-03-16','16:15:00',1.37),('8537','2013-03-15','10:35:00',1.15),('8537','2013-03-15','10:40:00',1.34),('8537','2013-03-15','10:45:00',1.59),('8537','2013-03-15','10:50:00',1.57),('8537','2013-03-15','10:55:00',1.71),('8537','2013-03-15','11:00:00',1.67),('8537','2013-03-15','11:05:00',1.5),('8537','2013-03-15','11:10:00',1.42),('8537','2013-03-15','11:15:00',1.24),('8537','2013-03-15','11:20:00',1.48),('8537','2013-03-15','11:25:00',1.77),('8537','2013-03-15','11:30:00',1.96),('8537','2013-03-15','11:35:00',2.37),('8537','2013-03-15','11:40:00',2.82),('8537','2013-03-15','11:45:00',2.69),('8537','2013-03-15','11:50:00',2.35),('8537','2013-03-15','11:55:00',2.42),('8537','2013-03-15','12:00:00',2.17),('8537','2013-03-15','12:05:00',2.13),('8537','2013-03-15','12:10:00',2.23),('8537','2013-03-15','12:15:00',1.96),('8537','2013-03-15','12:20:00',1.96),('8537','2013-03-15','12:25:00',2),('8537','2013-03-15','12:30:00',2.07),('8537','2013-03-15','12:35:00',2.38),('8537','2013-03-15','12:40:00',2.11),('8537','2013-03-15','12:45:00',1.83),('8537','2013-03-15','12:50:00',1.71),('8537','2013-03-15','12:55:00',1.61),('8537','2013-03-15','13:00:00',1.5),('8537','2013-03-15','13:05:00',1.4),('8537','2013-03-15','13:10:00',1.42),('8537','2013-03-15','13:15:00',1.54),('8537','2013-03-15','13:20:00',1.64),('8537','2013-03-15','13:25:00',1.82),('8537','2013-03-15','13:30:00',1.78),('8537','2013-03-15','13:35:00',1.63),('8537','2013-03-15','13:40:00',1.71),('8537','2013-03-15','13:45:00',1.85),('8537','2013-03-15','13:50:00',1.54),('8537','2013-03-15','13:55:00',1.33),('8537','2013-03-15','14:00:00',1.19),('8537','2013-03-15','14:05:00',1.06),('8537','2013-03-15','14:50:00',1.09),('8537','2013-03-15','14:55:00',1.29),('8537','2013-03-15','15:00:00',1.38),('8537','2013-03-15','15:05:00',1.34),('8537','2013-03-15','15:10:00',1.32),('8537','2013-03-15','15:15:00',1.44),('8537','2013-03-15','15:20:00',1.45),('8537','2013-03-15','15:25:00',1.57),('8537','2013-03-15','15:30:00',1.44),('8537','2013-03-15','15:35:00',1.23),('8537','2013-03-15','15:40:00',1.01),('8537','2013-03-15','15:45:00',1.02),('8537','2013-03-15','15:50:00',1),('8537','2013-03-15','16:00:00',1.07),('8537','2013-03-14','11:40:00',1.01),('8537','2013-03-14','11:45:00',1.01),('8537','2013-03-14','12:50:00',1.05),('8537','2013-03-14','12:55:00',1.14),('8537','2013-03-14','13:00:00',1),('8537','2013-03-14','13:05:00',1.17),('8537','2013-03-14','13:10:00',1.25),('8537','2013-03-14','13:15:00',1.29),('8537','2013-03-14','13:20:00',1.39),('8537','2013-03-14','13:25:00',1.37),('8537','2013-03-14','13:30:00',1.35),('8537','2013-03-14','13:35:00',1.38),('8537','2013-03-14','13:40:00',1.32),('8537','2013-03-14','13:45:00',1.71),('8537','2013-03-14','13:50:00',2.14),('8537','2013-03-14','13:55:00',2.56),('8537','2013-03-14','14:00:00',2.22),('8537','2013-03-14','14:05:00',2.3),('8537','2013-03-14','14:10:00',1.77),('8537','2013-03-14','14:15:00',1.45),('8537','2013-03-14','14:20:00',1.29),('8537','2013-03-14','14:25:00',1.28),('8537','2013-03-14','14:30:00',1.24),('8537','2013-03-14','15:05:00',1.04),('8537','2013-03-14','15:10:00',1.49),('8537','2013-03-14','15:15:00',1.53),('8537','2013-03-14','15:20:00',1.41),('8537','2013-03-14','15:25:00',1.46),('8537','2013-03-14','15:30:00',1.42),('8537','2013-03-14','15:35:00',1.18),('8537','2013-03-13','08:50:00',1.37),('8537','2013-03-13','08:55:00',1.35),('8537','2013-03-13','09:10:00',1.45),('8537','2013-03-13','09:15:00',1.24),('8537','2013-03-13','09:20:00',1.28),('8537','2013-03-13','09:25:00',1.07),('8537','2013-03-13','09:45:00',1.21),('8537','2013-03-13','10:05:00',1.22),('8537','2013-03-13','10:10:00',1.47),('8537','2013-03-13','10:15:00',2.99),('8537','2013-03-13','10:20:00',2.06),('8537','2013-03-13','10:25:00',2.49),('8537','2013-03-13','10:30:00',4.39),('8537','2013-03-13','10:35:00',4.16),('8537','2013-03-13','10:40:00',3.48),('8537','2013-03-13','10:45:00',1.59),('8537','2013-03-13','10:50:00',1.45),('8537','2013-03-13','10:55:00',1.34),('8537','2013-03-13','11:00:00',1.36),('8537','2013-03-13','11:10:00',1.16),('8537','2013-03-13','11:15:00',1.15),('8537','2013-03-13','11:30:00',1.41),('8537','2013-03-13','11:35:00',1.39),('8537','2013-03-13','11:40:00',1.36),('8537','2013-03-13','11:45:00',1.48),('8537','2013-03-13','11:50:00',1.34),('8537','2013-03-13','11:55:00',1.07),('8537','2013-03-13','12:45:00',1.27),('8537','2013-03-13','12:50:00',1.53),('8537','2013-03-13','12:55:00',1.33),('8537','2013-03-13','13:00:00',1.31),('8537','2013-03-13','13:05:00',1.27),('8537','2013-03-13','13:10:00',1.15),('8537','2013-03-13','13:15:00',1.01),('8537','2013-03-13','13:35:00',1.15),('8537','2013-03-13','13:40:00',1),('8537','2014-03-25','07:10:00',1.1),('8537','2014-03-25','07:15:00',1.38),('8537','2014-03-25','07:20:00',1.6),('8537','2014-03-25','07:25:00',1.7),('8537','2014-03-25','07:30:00',1.82),('8537','2014-03-25','07:35:00',1.43),('8537','2014-03-25','07:40:00',1.32),('8537','2014-03-25','07:45:00',1.46),('8537','2014-03-25','07:50:00',1.55),('8537','2014-03-25','07:55:00',1.57),('8537','2014-03-25','08:00:00',1.47),('8537','2014-03-25','08:05:00',1.51),('8537','2014-03-25','08:10:00',1.63),('8537','2014-03-25','08:15:00',1.72),('8537','2014-03-25','08:20:00',1.56),('8537','2014-03-25','08:25:00',1.4),('8537','2014-03-25','08:30:00',1.26),('8537','2014-03-25','08:35:00',1.28),('8537','2014-03-25','08:40:00',1.52),('8537','2014-03-25','08:45:00',2.18),('8537','2014-03-25','08:50:00',2.27),('8537','2014-03-25','08:55:00',2.4),('8537','2014-03-25','09:00:00',2.18),('8537','2014-03-25','09:05:00',2.11),('8537','2014-03-25','09:10:00',2.15),('8537','2014-03-25','09:15:00',2.81),('8537','2014-03-25','09:20:00',3.02),('8537','2014-03-25','09:25:00',2.64),('8537','2014-03-25','09:30:00',2.35),('8537','2014-03-25','09:35:00',2.17),('8537','2014-03-25','09:40:00',2.22),('8537','2014-03-25','09:45:00',2.08),('8537','2014-03-25','09:50:00',2.16),('8537','2014-03-25','09:55:00',2.44),('8537','2014-03-25','10:00:00',2.87),('8537','2014-03-25','10:05:00',3.05),('8537','2014-03-25','10:10:00',3.25),('8537','2014-03-25','10:15:00',3.51),('8537','2014-03-25','10:20:00',3.51),('8537','2014-03-25','10:25:00',3.4),('8537','2014-03-25','10:30:00',3.65),('8537','2014-03-25','10:35:00',3.04),('8537','2014-03-25','10:40:00',2.49),('8537','2014-03-25','10:45:00',2.27),('8537','2014-03-25','10:50:00',2.2),('8537','2014-03-25','10:55:00',2.2),('8537','2014-03-25','11:00:00',2.38),('8537','2014-03-25','11:05:00',2.72),('8537','2014-03-25','11:10:00',3.06),('8537','2014-03-25','11:15:00',3.52),('8537','2014-03-25','11:20:00',3.64),('8537','2014-03-25','11:25:00',3.38),('8537','2014-03-25','11:30:00',3.02),('8537','2014-03-25','11:35:00',3.31),('8537','2014-03-25','11:40:00',2.77),('8537','2014-03-25','11:45:00',2.47),('8537','2014-03-25','11:50:00',2.48),('8537','2014-03-25','11:55:00',2.07),('8537','2014-03-25','12:00:00',1.47),('8537','2014-03-25','12:15:00',1.07),('8537','2014-03-25','12:20:00',1.44),('8537','2014-03-25','12:25:00',1.58),('8537','2014-03-25','12:30:00',1.14),('8537','2014-03-25','13:35:00',1.11),('8537','2014-03-25','13:40:00',1.07),('8537','2014-03-25','14:10:00',1),('8537','2014-03-25','14:15:00',1.08),('8537','2013-03-12','08:20:00',2.3),('8537','2013-03-12','08:25:00',2.31),('8537','2013-03-12','08:30:00',2.39),('8537','2013-03-12','08:35:00',2.18),('8537','2013-03-12','08:40:00',2.42),('8537','2013-03-12','08:45:00',2.91),('8537','2013-03-12','08:50:00',1.52),('8537','2013-03-12','09:00:00',1.71),('8537','2013-03-12','09:05:00',3.2),('8537','2013-03-12','09:10:00',3.26),('8537','2013-03-12','09:15:00',3.32),('8537','2013-03-12','09:20:00',3.4),('8537','2013-03-12','09:25:00',3.43),('8537','2013-03-12','09:30:00',3.4),('8537','2013-03-12','09:35:00',3.68),('8537','2013-03-12','09:40:00',3.65),('8537','2013-03-12','09:45:00',3.72),('8537','2013-03-12','09:50:00',2.38),('8537','2013-03-12','09:55:00',4.26),('8537','2013-03-12','10:00:00',4.11),('8537','2013-03-12','10:05:00',4.07),('8537','2013-03-12','10:10:00',3.63),('8537','2013-03-12','10:15:00',3.07),('8537','2013-03-12','10:20:00',1.25),('8537','2013-03-12','10:25:00',3.75),('8537','2013-03-12','10:30:00',3.04),('8537','2013-03-12','10:35:00',3.06),('8537','2013-03-12','10:40:00',2.83),('8537','2013-03-12','10:45:00',1.58),('8537','2013-03-12','10:50:00',4.19),('8537','2013-03-12','10:55:00',4.38),('8537','2013-03-12','11:00:00',5.07),('8537','2013-03-12','11:05:00',5.29),('8537','2013-03-12','11:10:00',4.11),('8537','2013-03-12','11:15:00',3.98),('8537','2013-03-12','11:20:00',5.08),('8537','2013-03-12','11:25:00',1.85),('8537','2013-03-12','11:30:00',1.79),('8537','2013-03-12','11:35:00',2.16),('8537','2013-03-12','11:40:00',2.5),('8537','2013-03-12','11:45:00',2.65),('8537','2013-03-12','11:50:00',2.9),('8537','2013-03-12','11:55:00',3.94),('8537','2013-03-12','12:00:00',1.06),('8537','2013-03-12','12:10:00',4.15),('8537','2013-03-12','12:15:00',3.26),('8537','2013-03-12','12:20:00',2.23),('8537','2013-03-12','12:25:00',2.48),('8537','2013-03-12','12:30:00',5.55),('8537','2013-03-12','12:35:00',3.16),('8537','2013-03-12','12:40:00',4.95),('8537','2013-03-12','12:45:00',1.27),('8537','2013-03-12','12:50:00',2.01),('8537','2013-03-12','12:55:00',3.6),('8537','2013-03-12','13:00:00',4.26),('8537','2013-03-12','13:05:00',4.28),('8537','2013-03-12','13:10:00',3.2),('8537','2013-03-12','13:15:00',2.34),('8537','2013-03-12','13:20:00',1.99),('8537','2013-03-12','13:25:00',2.44),('8537','2013-03-12','13:30:00',1.65),('8537','2013-03-12','13:35:00',1.81),('8537','2013-03-12','13:40:00',1.53),('8537','2013-03-12','13:45:00',1.13),('8537','2013-03-12','13:50:00',1.17),('8537','2013-03-12','13:55:00',1.75),('8537','2013-03-12','14:00:00',2.71),('8537','2013-03-12','14:05:00',3.66),('8537','2013-03-12','14:10:00',2.54),('8537','2013-03-12','14:15:00',1.45),('8537','2013-03-12','14:20:00',1.3),('8537','2013-03-12','15:10:00',1.06),('8537','2013-03-11','08:10:00',1.85),('8537','2013-03-11','08:15:00',2.03),('8537','2013-03-11','08:20:00',2.14),('8537','2013-03-11','08:25:00',2.27),('8537','2013-03-11','08:30:00',2.37),('8537','2013-03-11','08:35:00',2.51),('8537','2013-03-11','08:40:00',2.59),('8537','2013-03-11','08:45:00',2.7),('8537','2013-03-11','08:50:00',2.82),('8537','2013-03-11','08:55:00',2.91),('8537','2013-03-11','09:00:00',2.98),('8537','2013-03-11','09:05:00',3.09),('8537','2013-03-11','09:10:00',3.15),('8537','2013-03-11','09:15:00',3.3),('8537','2013-03-11','09:20:00',3.26),('8537','2013-03-11','09:25:00',1.86),('8537','2013-03-11','09:30:00',1.77),('8537','2013-03-11','09:35:00',3.74),('8537','2013-03-11','09:40:00',3.61),('8537','2013-03-11','09:45:00',3.18),('8537','2013-03-11','09:50:00',1.54),('8537','2013-03-11','09:55:00',1.02),('8537','2013-03-11','10:05:00',1.06),('8537','2013-03-11','10:10:00',1.29),('8537','2013-03-11','10:15:00',1.32),('8537','2013-03-11','10:20:00',1.47),('8537','2013-03-11','10:25:00',1.65),('8537','2013-03-11','10:30:00',1.58),('8537','2013-03-11','10:35:00',1.8),('8537','2013-03-11','10:40:00',2.84),('8537','2013-03-11','10:45:00',3.11),('8537','2013-03-11','10:50:00',3.36),('8537','2013-03-11','10:55:00',2.17),('8537','2013-03-11','11:00:00',1.8),('8537','2013-03-11','11:05:00',1.53),('8537','2013-03-11','11:10:00',1.78),('8537','2013-03-11','11:15:00',1.8),('8537','2013-03-11','11:20:00',1.56),('8537','2013-03-11','11:25:00',1.46),('8537','2013-03-11','11:30:00',2.38),('8537','2013-03-11','11:35:00',3.89),('8537','2013-03-11','11:40:00',2.53),('8537','2013-03-11','11:45:00',3.47),('8537','2013-03-11','11:50:00',2.55),('8537','2013-03-11','11:55:00',2.27),('8537','2013-03-11','12:00:00',2.04),('8537','2013-03-11','12:05:00',1.94),('8537','2013-03-11','12:10:00',1.72),('8537','2013-03-11','12:20:00',1.18),('8537','2013-03-11','12:25:00',1.08),('8537','2013-03-11','12:30:00',1.18),('8537','2013-03-11','12:35:00',1.51),('8537','2013-03-11','12:40:00',1.45),('8537','2013-03-11','12:45:00',1.51),('8537','2013-03-11','12:50:00',2.87),('8537','2013-03-11','12:55:00',4.55),('8537','2013-03-11','13:00:00',2.68),('8537','2013-03-11','13:05:00',3.02),('8537','2013-03-11','13:10:00',4.06),('8537','2013-03-11','13:15:00',4.25),('8537','2013-03-11','13:20:00',4.54),('8537','2013-03-11','13:25:00',4.5),('8537','2013-03-11','13:30:00',4.76),('8537','2013-03-11','13:35:00',4.65),('8537','2013-03-11','13:40:00',2.97),('8537','2013-03-11','13:45:00',3.73),('8537','2013-03-11','13:50:00',4.87),('8537','2013-03-11','13:55:00',1.47),('8537','2013-03-11','14:00:00',1.16),('8537','2013-03-11','14:05:00',1.01),('8537','2013-03-11','14:25:00',2.1),('8537','2013-03-11','14:30:00',1.35),('8537','2013-03-11','14:35:00',1.15),('8537','2013-03-11','14:40:00',1.42),('8537','2013-03-11','14:45:00',1.06),('8537','2013-03-11','15:30:00',1.34),('8537','2013-03-11','15:35:00',1.12),('8537','2013-03-11','15:40:00',1.38),('8537','2013-03-11','15:45:00',2.49),('8537','2013-03-11','15:50:00',2.55),('8537','2013-03-11','15:55:00',2.32),('8537','2013-03-11','16:00:00',2.17),('8537','2013-03-11','16:05:00',1.9),('8537','2013-03-11','16:10:00',1.6),('8537','2013-03-11','16:15:00',1.38),('8537','2013-03-11','16:20:00',1.81),('8537','2013-03-11','16:25:00',1.52),('8537','2013-03-11','16:30:00',1.58),('8537','2013-03-11','16:35:00',1.26),('8537','2013-03-11','16:45:00',1.44),('8537','2013-03-11','16:50:00',1.06),('8537','2013-03-10','07:45:00',1.21),('8537','2013-03-10','07:50:00',1.4),('8537','2013-03-10','07:55:00',1.61),('8537','2013-03-10','08:00:00',1.7),('8537','2013-03-10','08:05:00',1.84),('8537','2013-03-10','08:10:00',1.83),('8537','2013-03-10','08:15:00',1.85),('8537','2013-03-10','08:20:00',2.17),('8537','2013-03-10','08:25:00',2.27),('8537','2013-03-10','08:30:00',2.36),('8537','2013-03-10','08:35:00',2.48),('8537','2013-03-10','08:40:00',2.58),('8537','2013-03-10','08:45:00',2.69),('8537','2013-03-10','08:50:00',2.79),('8537','2013-03-10','08:55:00',2.91),('8537','2013-03-10','09:00:00',3.01),('8537','2013-03-10','09:05:00',3.08),('8537','2013-03-10','09:10:00',3.19),('8537','2013-03-10','09:15:00',3.28),('8537','2013-03-10','09:20:00',3.36),('8537','2013-03-10','09:25:00',3.46),('8537','2013-03-10','09:30:00',3.56),('8537','2013-03-10','09:35:00',3.63),('8537','2013-03-10','09:40:00',3.7),('8537','2013-03-10','09:45:00',3.85),('8537','2013-03-10','09:50:00',3.47),('8537','2013-03-10','09:55:00',4.19),('8537','2013-03-10','10:00:00',4.23),('8537','2013-03-10','10:05:00',2.53),('8537','2013-03-10','10:10:00',2.48),('8537','2013-03-10','10:15:00',3),('8537','2013-03-10','10:20:00',4.31),('8537','2013-03-10','10:25:00',3.44),('8537','2013-03-10','10:30:00',3.97),('8537','2013-03-10','10:35:00',4.14),('8537','2013-03-10','10:40:00',4.06),('8537','2013-03-10','10:45:00',3.52),('8537','2013-03-10','10:50:00',3.49),('8537','2013-03-10','10:55:00',3.04),('8537','2013-03-10','11:00:00',1.8),('8537','2013-03-10','11:05:00',4.12),('8537','2013-03-10','11:10:00',3.41),('8537','2013-03-10','11:15:00',2.53),('8537','2013-03-10','11:20:00',2.48),('8537','2013-03-10','11:25:00',3.86),('8537','2013-03-10','11:30:00',2.53),('8537','2013-03-10','11:35:00',3.91),('8537','2013-03-10','11:40:00',1.68),('8537','2013-03-10','11:45:00',2.23),('8537','2013-03-10','11:50:00',3.88),('8537','2013-03-10','11:55:00',5.04),('8537','2013-03-10','12:00:00',5),('8537','2013-03-10','12:05:00',4.83),('8537','2013-03-10','12:10:00',4.02),('8537','2013-03-10','12:15:00',4.12),('8537','2013-03-10','12:20:00',3.97),('8537','2013-03-10','12:25:00',4.69),('8537','2013-03-10','12:30:00',1.52),('8537','2013-03-10','12:35:00',2.44),('8537','2013-03-10','12:40:00',4.1),('8537','2013-03-10','12:45:00',4.98),('8537','2013-03-10','12:50:00',4.81),('8537','2013-03-10','12:55:00',4.95),('8537','2013-03-10','13:00:00',4.73),('8537','2013-03-10','13:05:00',4.67),('8537','2013-03-10','13:10:00',4.48),('8537','2013-03-10','13:15:00',4.65),('8537','2013-03-10','13:20:00',4.67),('8537','2013-03-10','13:25:00',4.3),('8537','2013-03-10','13:30:00',4.06),('8537','2013-03-10','13:35:00',3.97),('8537','2013-03-10','13:40:00',2.36),('8537','2013-03-10','13:45:00',2.61),('8537','2013-03-10','13:50:00',2.16),('8537','2013-03-10','13:55:00',2.04),('8537','2013-03-10','14:00:00',1.78),('8537','2013-03-10','14:05:00',2.18),('8537','2013-03-10','14:10:00',2.45),('8537','2013-03-10','14:15:00',3.15),('8537','2013-03-10','14:20:00',3.4),('8537','2013-03-10','14:25:00',1.95),('8537','2013-03-10','14:30:00',2.35),('8537','2013-03-10','14:35:00',3.54),('8537','2013-03-10','14:40:00',3.39),('8537','2013-03-10','14:45:00',1.88),('8537','2013-03-10','14:50:00',1.95),('8537','2013-03-10','14:55:00',1.79),('8537','2013-03-10','15:00:00',1.42),('8537','2013-03-10','15:05:00',1.6),('8537','2013-03-10','15:10:00',1.59),('8537','2013-03-10','15:15:00',1.04),('8537','2013-03-10','15:20:00',1.04),('8537','2013-03-10','15:50:00',1.03),('8537','2013-03-09','08:00:00',1.24),('8537','2013-03-09','08:05:00',2.04),('8537','2013-03-09','08:10:00',1.93),('8537','2013-03-09','08:15:00',1.94),('8537','2013-03-09','08:20:00',1.86),('8537','2013-03-09','08:25:00',2.22),('8537','2013-03-09','08:30:00',2.34),('8537','2013-03-09','08:35:00',2.09),('8537','2013-03-09','08:40:00',2.47),('8537','2013-03-09','08:45:00',1.82),('8537','2013-03-09','08:50:00',1.54),('8537','2013-03-09','08:55:00',2.12),('8537','2013-03-09','09:00:00',1.9),('8537','2013-03-09','09:05:00',1.04),('8537','2013-03-09','09:25:00',1.36),('8537','2013-03-09','09:30:00',3.03),('8537','2013-03-09','09:35:00',2.69),('8537','2013-03-09','09:40:00',4.08),('8537','2013-03-09','09:45:00',4.25),('8537','2013-03-09','09:50:00',2.62),('8537','2013-03-09','09:55:00',3.61),('8537','2013-03-09','10:00:00',1.73),('8537','2013-03-09','10:05:00',1.35),('8537','2013-03-09','10:10:00',1.4),('8537','2013-03-09','10:15:00',2),('8537','2013-03-09','10:20:00',1.4),('8537','2013-03-09','10:25:00',1.1),('8537','2013-03-09','10:30:00',1.14),('8537','2013-03-09','10:35:00',1.36),('8537','2013-03-09','10:40:00',1.63),('8537','2013-03-09','10:45:00',2.1),('8537','2013-03-09','10:50:00',3.53),('8537','2013-03-09','10:55:00',3.37),('8537','2013-03-09','11:00:00',3.08),('8537','2013-03-09','11:05:00',4.24),('8537','2013-03-09','11:10:00',4.02),('8537','2013-03-09','11:15:00',5),('8537','2013-03-09','11:20:00',5.03),('8537','2013-03-09','11:25:00',2.83),('8537','2013-03-09','11:30:00',3.28),('8537','2013-03-09','11:35:00',5.06),('8537','2013-03-09','11:40:00',4.48),('8537','2013-03-09','11:45:00',4.66),('8537','2013-03-09','11:50:00',4.9),('8537','2013-03-09','11:55:00',4.52),('8537','2013-03-09','12:00:00',3.61),('8537','2013-03-09','12:05:00',1.99),('8537','2013-03-09','12:10:00',2.14),('8537','2013-03-09','12:15:00',1.39),('8537','2013-03-09','12:20:00',1.63),('8537','2013-03-09','12:25:00',2.35),('8537','2013-03-09','12:30:00',1.63),('8537','2013-03-09','12:35:00',1.95),('8537','2013-03-09','12:40:00',1.71),('8537','2013-03-09','12:45:00',2.42),('8537','2013-03-09','12:50:00',2.52),('8537','2013-03-09','12:55:00',3.3),('8537','2013-03-09','13:00:00',4.94),('8537','2013-03-09','13:05:00',4.31),('8537','2013-03-09','13:10:00',4.72),('8537','2013-03-09','13:15:00',5.24),('8537','2013-03-09','13:20:00',4.45),('8537','2013-03-09','13:25:00',2.43),('8537','2013-03-09','13:30:00',4.51),('8537','2013-03-09','13:35:00',3.1),('8537','2013-03-09','13:40:00',4.2),('8537','2013-03-09','13:45:00',4.68),('8537','2013-03-09','13:50:00',4.08),('8537','2013-03-09','13:55:00',1.15),('8537','2013-03-09','14:00:00',1.27),('8537','2013-03-09','14:05:00',3.39),('8537','2013-03-09','14:10:00',4.59),('8537','2013-03-09','14:15:00',3.77),('8537','2013-03-09','14:20:00',4.02),('8537','2013-03-09','14:25:00',3.92),('8537','2013-03-09','14:30:00',3.87),('8537','2013-03-09','14:35:00',3.78),('8537','2013-03-09','14:40:00',3.72),('8537','2013-03-09','14:45:00',3.64),('8537','2013-03-09','14:50:00',3.46),('8537','2013-03-09','14:55:00',3.18),('8537','2013-03-09','15:00:00',3.31),('8537','2013-03-09','15:05:00',3.3),('8537','2013-03-09','15:10:00',3.21),('8537','2013-03-09','15:15:00',3.13),('8537','2013-03-09','15:20:00',3.03),('8537','2013-03-09','15:25:00',2.88),('8537','2013-03-09','15:30:00',2.79),('8537','2013-03-09','15:35:00',2.67),('8537','2013-03-09','15:40:00',2.65),('8537','2013-03-09','15:45:00',2.52),('8537','2013-03-09','15:50:00',2.4),('8537','2013-03-09','15:55:00',2.16),('8537','2013-03-09','16:00:00',1.93),('8537','2013-03-09','16:05:00',1.99),('8537','2013-03-09','16:10:00',1.6),('8537','2013-03-09','16:15:00',1.77),('8537','2013-03-09','16:20:00',1.43),('8537','2013-03-09','16:25:00',1.62),('8537','2013-03-09','16:30:00',1.45),('8537','2013-03-09','16:35:00',1.18),('8537','2013-03-09','16:40:00',1.04),('8537','2013-03-08','08:10:00',1.27),('8537','2013-03-08','08:15:00',1.22),('8537','2013-03-08','08:30:00',1.84),('8537','2013-03-08','08:35:00',1.92),('8537','2013-03-08','08:40:00',1.02),('8537','2013-03-08','08:50:00',1.36),('8537','2013-03-08','08:55:00',1.25),('8537','2013-03-08','09:15:00',1.3),('8537','2013-03-08','09:20:00',1.03),('8537','2013-03-08','09:30:00',1.87),('8537','2013-03-08','09:35:00',2.25),('8537','2013-03-08','09:40:00',1.42),('8537','2013-03-08','09:45:00',2.56),('8537','2013-03-08','09:50:00',2.96),('8537','2013-03-08','09:55:00',2.06),('8537','2013-03-08','10:00:00',1.21),('8537','2013-03-08','10:05:00',1.28),('8537','2013-03-08','10:10:00',1.69),('8537','2013-03-08','10:15:00',1.95),('8537','2013-03-08','10:20:00',2.11),('8537','2013-03-08','10:25:00',1.6),('8537','2013-03-08','10:30:00',2.14),('8537','2013-03-08','10:35:00',3.15),('8537','2013-03-08','10:40:00',2.37),('8537','2013-03-08','10:45:00',1.27),('8537','2013-03-08','10:50:00',1.56),('8537','2013-03-08','10:55:00',1.43),('8537','2013-03-08','11:00:00',1.37),('8537','2013-03-08','11:05:00',1.02),('8537','2013-03-08','11:35:00',2.08),('8537','2013-03-08','11:40:00',2.79),('8537','2013-03-08','11:45:00',2.17),('8537','2013-03-08','11:50:00',1.89),('8537','2013-03-08','11:55:00',2.05),('8537','2013-03-08','12:00:00',2.41),('8537','2013-03-08','12:05:00',1.48),('8537','2013-03-08','12:10:00',1.11),('8537','2013-03-08','12:20:00',1.65),('8537','2013-03-08','12:25:00',1.35),('8537','2013-03-08','12:30:00',1.24),('8537','2013-03-08','12:35:00',1.82),('8537','2013-03-08','12:40:00',2.55),('8537','2013-03-08','12:45:00',2.77),('8537','2013-03-08','12:50:00',2.9),('8537','2013-03-08','12:55:00',2.41),('8537','2013-03-08','13:00:00',2.64),('8537','2013-03-08','13:05:00',2.72),('8537','2013-03-08','13:10:00',1.76),('8537','2013-03-08','13:15:00',1.42),('8537','2013-03-08','13:20:00',1.35),('8537','2013-03-08','13:25:00',1.76),('8537','2013-03-08','13:30:00',2.21),('8537','2013-03-08','13:35:00',1.57),('8537','2013-03-08','13:40:00',1.45),('8537','2013-03-08','13:55:00',1.06),('8537','2013-03-08','17:10:00',1.16),('8537','2013-03-08','17:15:00',1.13),('8537','2013-03-07','08:40:00',1.05),('8537','2013-03-07','08:45:00',1.03),('8537','2013-03-07','08:50:00',1.23),('8537','2013-03-07','09:20:00',1.17),('8537','2013-03-07','10:30:00',1.09),('8537','2013-03-07','10:50:00',1.17),('8537','2013-03-07','10:55:00',1.47),('8537','2013-03-07','11:00:00',1.26),('8537','2013-03-07','11:05:00',1.8),('8537','2013-03-07','11:10:00',1.27),('8537','2013-03-07','11:30:00',1.71),('8537','2013-03-07','11:35:00',2.28),('8537','2013-03-07','11:40:00',2.14),('8537','2013-03-07','11:45:00',2.58),('8537','2013-03-07','11:50:00',2.35),('8537','2013-03-07','11:55:00',1.67),('8537','2013-03-07','12:00:00',1.33),('8537','2013-03-07','12:05:00',1.23),('8537','2013-03-07','12:30:00',1.09),('8537','2013-03-07','12:40:00',1.7),('8537','2013-03-07','12:45:00',2.5),('8537','2013-03-07','12:50:00',2.04),('8537','2013-03-07','12:55:00',1.81),('8537','2013-03-07','13:00:00',1.95),('8537','2013-03-07','13:05:00',1.9),('8537','2013-03-07','13:10:00',1.58),('8537','2013-03-07','13:15:00',1.9),('8537','2013-03-07','13:20:00',2.51),('8537','2013-03-07','13:25:00',2.21),('8537','2013-03-07','13:30:00',1.8),('8537','2013-03-07','13:35:00',1.57),('8537','2013-03-07','14:05:00',1.06),('8537','2013-03-07','14:10:00',1.14),('8537','2013-03-07','16:40:00',1.03),('8537','2013-03-05','08:10:00',1.14),('8537','2013-03-05','08:15:00',1.57),('8537','2013-03-05','08:20:00',1.34),('8537','2013-03-05','08:25:00',1.68),('8537','2013-03-05','08:30:00',2.51),('8537','2013-03-05','08:35:00',2.14),('8537','2013-03-05','08:40:00',2.26),('8537','2013-03-05','08:45:00',1.82),('8537','2013-03-05','08:50:00',1.93),('8537','2013-03-05','08:55:00',1.81),('8537','2013-03-05','09:00:00',2.02),('8537','2013-03-05','09:05:00',1.98),('8537','2013-03-05','09:10:00',1.85),('8537','2013-03-05','09:15:00',1.75),('8537','2013-03-05','09:20:00',1.74),('8537','2013-03-05','09:25:00',1.71),('8537','2013-03-05','09:30:00',1.81),('8537','2013-03-05','09:35:00',1.96),('8537','2013-03-05','09:40:00',2.08),('8537','2013-03-05','09:45:00',2.1),('8537','2013-03-05','09:50:00',2.13),('8537','2013-03-05','09:55:00',2),('8537','2013-03-05','10:00:00',1.92),('8537','2013-03-05','10:05:00',2.15),('8537','2013-03-05','10:10:00',2.25),('8537','2013-03-05','10:15:00',2.26),('8537','2013-03-05','10:20:00',2.54),('8537','2013-03-05','10:25:00',2.36),('8537','2013-03-05','10:30:00',2.27),('8537','2013-03-05','10:35:00',2.75),('8537','2013-03-05','10:40:00',2.84),('8537','2013-03-05','10:45:00',2.95),('8537','2013-03-05','10:50:00',3.16),('8537','2013-03-05','10:55:00',3.24),('8537','2013-03-05','11:00:00',3.06),('8537','2013-03-05','11:05:00',3.24),('8537','2013-03-05','11:10:00',3.37),('8537','2013-03-05','11:15:00',3.29),('8537','2013-03-05','11:20:00',3.18),('8537','2013-03-05','11:25:00',3.04),('8537','2013-03-05','11:30:00',3.07),('8537','2013-03-05','11:35:00',3.42),('8537','2013-03-05','11:40:00',3.76),('8537','2013-03-05','11:45:00',3.63),('8537','2013-03-05','11:50:00',3.7),('8537','2013-03-05','11:55:00',3.77),('8537','2013-03-05','12:00:00',3.88),('8537','2013-03-05','12:05:00',4.05),('8537','2013-03-05','12:10:00',4.19),('8537','2013-03-05','12:15:00',3.38),('8537','2013-03-05','12:20:00',3.82),('8537','2013-03-05','12:25:00',3.87),('8537','2013-03-05','12:30:00',3.24),('8537','2013-03-05','12:35:00',3.26),('8537','2013-03-05','12:40:00',3.07),('8537','2013-03-05','12:45:00',3.21),('8537','2013-03-05','12:50:00',2.78),('8537','2013-03-05','12:55:00',2.5),('8537','2013-03-05','13:00:00',2.03),('8537','2013-03-05','13:05:00',1.92),('8537','2013-03-05','13:10:00',2.05),('8537','2013-03-05','13:15:00',2.19),('8537','2013-03-05','13:20:00',2.11),('8537','2013-03-05','13:25:00',1.88),('8537','2013-03-05','13:30:00',1.72),('8537','2013-03-05','13:35:00',1.61),('8537','2013-03-05','13:40:00',1.53),('8537','2013-03-05','13:45:00',1.38),('8537','2013-03-05','13:50:00',1.26),('8537','2013-03-05','13:55:00',1.18),('8537','2013-03-05','14:00:00',1.17),('8537','2013-03-05','14:05:00',1.19),('8537','2013-03-05','14:10:00',1.25),('8537','2013-03-05','14:15:00',1.17),('8537','2013-03-05','14:20:00',1.1),('8537','2013-03-05','14:25:00',1.11),('8537','2013-03-05','14:30:00',1.06),('8537','2013-03-05','14:35:00',1.09),('8537','2013-03-05','14:40:00',1.13),('8537','2013-03-05','14:45:00',1.16),('8537','2013-03-05','14:50:00',1.13),('8537','2013-03-05','14:55:00',1.02),('8537','2013-03-05','15:40:00',1.04),('8537','2013-03-05','15:45:00',1.29),('8537','2013-03-05','15:50:00',1.29),('8537','2013-03-05','15:55:00',1.08),('8537','2013-03-04','07:45:00',1.1),('8537','2013-03-04','07:50:00',1.21),('8537','2013-03-04','07:55:00',1.33),('8537','2013-03-04','08:00:00',1.45),('8537','2013-03-04','08:05:00',1.57),('8537','2013-03-04','08:10:00',1.68),('8537','2013-03-04','08:15:00',1.8),('8537','2013-03-04','08:20:00',1.91),('8537','2013-03-04','08:25:00',2.03),('8537','2013-03-04','08:30:00',2.14),('8537','2013-03-04','08:35:00',2.24),('8537','2013-03-04','08:40:00',2.36),('8537','2013-03-04','08:45:00',2.45),('8537','2013-03-04','08:50:00',2.56),('8537','2013-03-04','08:55:00',2.67),('8537','2013-03-04','09:00:00',2.75),('8537','2013-03-04','09:05:00',2.84),('8537','2013-03-04','09:10:00',2.93),('8537','2013-03-04','09:15:00',3.02),('8537','2013-03-04','09:20:00',3.14),('8537','2013-03-04','09:25:00',3.22),('8537','2013-03-04','09:30:00',3.3),('8537','2013-03-04','09:35:00',3.4),('8537','2013-03-04','09:40:00',3.48),('8537','2013-03-04','09:45:00',3.55),('8537','2013-03-04','09:50:00',3.62),('8537','2013-03-04','09:55:00',3.7),('8537','2013-03-04','10:00:00',3.77),('8537','2013-03-04','10:05:00',3.82),('8537','2013-03-04','10:10:00',3.93),('8537','2013-03-04','10:15:00',3.98),('8537','2013-03-04','10:20:00',4),('8537','2013-03-04','10:25:00',4.07),('8537','2013-03-04','10:30:00',4.13),('8537','2013-03-04','10:35:00',4.19),('8537','2013-03-04','10:40:00',4.22),('8537','2013-03-04','10:45:00',4.25),('8537','2013-03-04','10:50:00',4.31),('8537','2013-03-04','10:55:00',4.36),('8537','2013-03-04','11:00:00',4.33),('8537','2013-03-04','11:05:00',4.38),('8537','2013-03-04','11:10:00',4.43),('8537','2013-03-04','11:15:00',4.51),('8537','2013-03-04','11:20:00',4.51),('8537','2013-03-04','11:25:00',4.52),('8537','2013-03-04','11:30:00',4.53),('8537','2013-03-04','11:35:00',4.57),('8537','2013-03-04','11:40:00',4.6),('8537','2013-03-04','11:45:00',4.59),('8537','2013-03-04','11:50:00',4.56),('8537','2013-03-04','11:55:00',4.57),('8537','2013-03-04','12:00:00',4.52),('8537','2013-03-04','12:05:00',4.49),('8537','2013-03-04','12:10:00',4.55),('8537','2013-03-04','12:15:00',4.6),('8537','2013-03-04','12:20:00',4.66),('8537','2013-03-04','12:25:00',4.64),('8537','2013-03-04','12:30:00',4.54),('8537','2013-03-04','12:35:00',4.55),('8537','2013-03-04','12:40:00',4.58),('8537','2013-03-04','12:45:00',4.52),('8537','2013-03-04','12:50:00',4.5),('8537','2013-03-04','12:55:00',4.47),('8537','2013-03-04','13:00:00',4.37),('8537','2013-03-04','13:05:00',4.36),('8537','2013-03-04','13:10:00',4.31),('8537','2013-03-04','13:15:00',4.34),('8537','2013-03-04','13:20:00',4.35),('8537','2013-03-04','13:25:00',4.29),('8537','2013-03-04','13:30:00',2.69),('8537','2013-03-04','13:35:00',3.43),('8537','2013-03-04','13:40:00',4.1),('8537','2013-03-04','13:45:00',3.68),('8537','2013-03-04','13:50:00',4.13),('8537','2013-03-04','13:55:00',4.05),('8537','2013-03-04','14:00:00',3.98),('8537','2013-03-04','14:05:00',4),('8537','2013-03-04','14:10:00',3.65),('8537','2013-03-04','14:15:00',3.4),('8537','2013-03-04','14:20:00',3.62),('8537','2013-03-04','14:25:00',3.42),('8537','2013-03-04','14:30:00',3.43),('8537','2013-03-04','14:35:00',3.46),('8537','2013-03-04','14:40:00',3.39),('8537','2013-03-04','14:45:00',3.33),('8537','2013-03-04','14:50:00',3.23),('8537','2013-03-04','14:55:00',3.21),('8537','2013-03-04','15:00:00',2.97),('8537','2013-03-04','15:05:00',2.95),('8537','2013-03-04','15:10:00',2.88),('8537','2013-03-04','15:15:00',2.75),('8537','2013-03-04','15:20:00',2.67),('8537','2013-03-04','15:25:00',2.56),('8537','2013-03-04','15:30:00',2.53),('8537','2013-03-04','15:35:00',2.4),('8537','2013-03-04','15:40:00',2.29),('8537','2013-03-04','15:45:00',2.13),('8537','2013-03-04','15:50:00',2.01),('8537','2013-03-04','15:55:00',1.97),('8537','2013-03-04','16:00:00',1.9),('8537','2013-03-04','16:05:00',1.8),('8537','2013-03-04','16:10:00',1.62),('8537','2013-03-04','16:15:00',1.43),('8537','2013-03-04','16:20:00',1.44),('8537','2013-03-04','16:25:00',1.36),('8537','2013-03-04','16:30:00',1.27),('8537','2013-03-04','16:35:00',1.14),('8537','2013-03-04','16:40:00',1.02),('8537','2013-03-03','07:40:00',1.03),('8537','2013-03-03','07:45:00',1.15),('8537','2013-03-03','07:50:00',1.27),('8537','2013-03-03','07:55:00',1.4),('8537','2013-03-03','08:00:00',1.52),('8537','2013-03-03','08:05:00',1.65),('8537','2013-03-03','08:10:00',1.78),('8537','2013-03-03','08:15:00',1.9),('8537','2013-03-03','08:20:00',2.03),('8537','2013-03-03','08:25:00',2.16),('8537','2013-03-03','08:30:00',2.28),('8537','2013-03-03','08:35:00',2.4),('8537','2013-03-03','08:40:00',2.53),('8537','2013-03-03','08:45:00',2.64),('8537','2013-03-03','08:50:00',2.74),('8537','2013-03-03','08:55:00',2.84),('8537','2013-03-03','09:00:00',2.93),('8537','2013-03-03','09:05:00',3.02),('8537','2013-03-03','09:10:00',3.11),('8537','2013-03-03','09:15:00',3.2),('8537','2013-03-03','09:20:00',3.29),('8537','2013-03-03','09:25:00',3.38),('8537','2013-03-03','09:30:00',3.48),('8537','2013-03-03','09:35:00',3.58),('8537','2013-03-03','09:40:00',3.65),('8537','2013-03-03','09:45:00',3.76),('8537','2013-03-03','09:50:00',3.82),('8537','2013-03-03','09:55:00',3.97),('8537','2013-03-03','10:00:00',4.04),('8537','2013-03-03','10:05:00',4.09),('8537','2013-03-03','10:10:00',4.16),('8537','2013-03-03','10:15:00',4.25),('8537','2013-03-03','10:20:00',4.32),('8537','2013-03-03','10:25:00',4.37),('8537','2013-03-03','10:30:00',4.41),('8537','2013-03-03','10:35:00',4.47),('8537','2013-03-03','10:40:00',4.49),('8537','2013-03-03','10:45:00',4.54),('8537','2013-03-03','10:50:00',4.58),('8537','2013-03-03','10:55:00',4.61),('8537','2013-03-03','11:00:00',4.6),('8537','2013-03-03','11:05:00',4.6),('8537','2013-03-03','11:10:00',4.6),('8537','2013-03-03','11:15:00',4.63),('8537','2013-03-03','11:20:00',4.67),('8537','2013-03-03','11:25:00',4.69),('8537','2013-03-03','11:30:00',4.72),('8537','2013-03-03','11:35:00',4.71),('8537','2013-03-03','11:40:00',4.75),('8537','2013-03-03','11:45:00',4.75),('8537','2013-03-03','11:50:00',4.79),('8537','2013-03-03','11:55:00',4.78),('8537','2013-03-03','12:00:00',4.8),('8537','2013-03-03','12:05:00',4.82),('8537','2013-03-03','12:10:00',4.8),('8537','2013-03-03','12:15:00',4.76),('8537','2013-03-03','12:20:00',4.76),('8537','2013-03-03','12:25:00',4.77),('8537','2013-03-03','12:30:00',4.77),('8537','2013-03-03','12:35:00',4.79),('8537','2013-03-03','12:40:00',4.76),('8537','2013-03-03','12:45:00',4.74),('8537','2013-03-03','12:50:00',4.72),('8537','2013-03-03','12:55:00',4.68),('8537','2013-03-03','13:00:00',4.64),('8537','2013-03-03','13:05:00',4.63),('8537','2013-03-03','13:10:00',4.62),('8537','2013-03-03','13:15:00',4.6),('8537','2013-03-03','13:20:00',4.6),('8537','2013-03-03','13:25:00',4.57),('8537','2013-03-03','13:30:00',4.54),('8537','2013-03-03','13:35:00',4.49),('8537','2013-03-03','13:40:00',4.44),('8537','2013-03-03','13:45:00',4.39),('8537','2013-03-03','13:50:00',4.29),('8537','2013-03-03','13:55:00',4.28),('8537','2013-03-03','14:00:00',4.2),('8537','2013-03-03','14:05:00',4.15),('8537','2013-03-03','14:10:00',4.06),('8537','2013-03-03','14:15:00',4.03),('8537','2013-03-03','14:20:00',3.98),('8537','2013-03-03','14:25:00',3.9),('8537','2013-03-03','14:30:00',3.81),('8537','2013-03-03','14:35:00',3.76),('8537','2013-03-03','14:40:00',3.7),('8537','2013-03-03','14:45:00',3.62),('8537','2013-03-03','14:50:00',3.53),('8537','2013-03-03','14:55:00',3.4),('8537','2013-03-03','15:00:00',3.22),('8537','2013-03-03','15:05:00',2.91),('8537','2013-03-03','15:10:00',3.09),('8537','2013-03-03','15:15:00',3.07),('8537','2013-03-03','15:20:00',2.99),('8537','2013-03-03','15:25:00',2.89),('8537','2013-03-03','15:30:00',2.81),('8537','2013-03-03','15:35:00',2.67),('8537','2013-03-03','15:40:00',2.56),('8537','2013-03-03','15:45:00',2.39),('8537','2013-03-03','15:50:00',2.31),('8537','2013-03-03','15:55:00',2.21),('8537','2013-03-03','16:00:00',2.11),('8537','2013-03-03','16:05:00',1.99),('8537','2013-03-03','16:10:00',1.86),('8537','2013-03-03','16:15:00',1.71),('8537','2013-03-03','16:20:00',1.6),('8537','2013-03-03','16:25:00',1.48),('8537','2013-03-03','16:30:00',1.35),('8537','2013-03-03','16:35:00',1.21),('8537','2013-03-03','16:40:00',1.1),('8537','2014-03-24','07:45:00',1.46),('8537','2014-03-24','07:50:00',1.02),('8537','2014-03-24','08:40:00',1.06),('8537','2014-03-24','08:55:00',1.85),('8537','2014-03-24','09:00:00',2.22),('8537','2014-03-24','09:05:00',1.69),('8537','2014-03-24','09:20:00',2.33),('8537','2014-03-24','09:25:00',1.01),('8537','2014-03-24','09:30:00',1.74),('8537','2014-03-24','09:35:00',1.03),('8537','2014-03-24','09:40:00',1.72),('8537','2014-03-24','09:45:00',1.39),('8537','2014-03-24','09:50:00',1.23),('8537','2014-03-24','10:00:00',2.41),('8537','2014-03-24','10:05:00',2.96),('8537','2014-03-24','10:10:00',4.19),('8537','2014-03-24','10:15:00',3.52),('8537','2014-03-24','10:20:00',1.1),('8537','2014-03-24','10:35:00',1.61),('8537','2014-03-24','10:40:00',1.32),('8537','2014-03-24','10:45:00',1.93),('8537','2014-03-24','10:50:00',5.77),('8537','2014-03-24','10:55:00',4.93),('8537','2014-03-24','11:00:00',1.9),('8537','2014-03-24','11:05:00',3.45),('8537','2014-03-24','11:10:00',2.79),('8537','2014-03-24','11:15:00',3.67),('8537','2014-03-24','11:20:00',2.95),('8537','2014-03-24','11:25:00',3.56),('8537','2014-03-24','11:30:00',4.16),('8537','2014-03-24','11:35:00',1.99),('8537','2014-03-24','12:30:00',1.26),('8537','2014-03-24','12:35:00',2.17),('8537','2014-03-24','12:40:00',2.35),('8537','2014-03-24','12:45:00',2.07),('8537','2014-03-24','12:50:00',1.72),('8537','2014-03-24','12:55:00',1.61),('8537','2014-03-24','13:00:00',1.64),('8537','2014-03-24','13:05:00',1.63),('8537','2014-03-24','13:10:00',1.45),('8537','2014-03-24','13:15:00',1.18),('8537','2014-03-24','13:20:00',1.15),('8537','2014-03-24','13:25:00',1.41),('8537','2014-03-24','13:30:00',1.64),('8537','2014-03-24','13:35:00',1.44),('8537','2014-03-24','13:45:00',1.07),('8537','2014-03-24','13:50:00',1.56),('8537','2014-03-24','13:55:00',1.52),('8537','2014-03-24','14:00:00',1.38),('8537','2014-03-24','14:05:00',1.23),('8537','2014-03-24','14:10:00',1.44),('8537','2014-03-24','14:15:00',1.87),('8537','2014-03-24','14:20:00',2.43),('8537','2014-03-24','14:25:00',2.36),('8537','2014-03-24','14:30:00',2.08),('8537','2014-03-24','14:35:00',2.58),('8537','2014-03-24','14:40:00',3.4),('8537','2014-03-24','14:45:00',3.92),('8537','2014-03-24','14:50:00',4.05),('8537','2014-03-24','14:55:00',3.54),('8537','2014-03-24','15:00:00',3.1),('8537','2014-03-24','15:05:00',2.76),('8537','2014-03-24','15:10:00',2.44),('8537','2014-03-24','15:15:00',1.6),('8537','2014-03-24','15:20:00',1.85),('8537','2014-03-24','15:25:00',1.56),('8537','2014-03-24','15:30:00',1.9),('8537','2014-03-24','15:35:00',1.63),('8537','2014-03-24','15:40:00',1.44),('8537','2014-03-24','15:45:00',1.31),('8537','2014-03-24','15:50:00',1.48),('8537','2014-03-24','15:55:00',1.42),('8537','2014-03-24','16:00:00',2.37),('8537','2014-03-24','16:05:00',1.49),('8537','2014-03-24','16:10:00',1.3),('8537','2014-03-24','16:15:00',1.01),('8537','2013-03-02','10:40:00',1.08),('8537','2013-03-02','10:45:00',1.08),('8537','2013-03-02','10:50:00',1.2),('8537','2013-03-02','10:55:00',1.26),('8537','2013-03-02','11:00:00',1.34),('8537','2013-03-02','11:05:00',1.35),('8537','2013-03-02','11:10:00',1.46),('8537','2013-03-02','11:15:00',1.64),('8537','2013-03-02','11:20:00',1.47),('8537','2013-03-02','11:25:00',1.27),('8537','2013-03-02','11:30:00',1.19),('8537','2013-03-02','11:35:00',1.24),('8537','2013-03-02','11:40:00',1.39),('8537','2013-03-02','11:45:00',1.26),('8537','2013-03-02','11:50:00',1.24),('8537','2013-03-02','11:55:00',1.18),('8537','2013-03-02','12:00:00',1.17),('8537','2013-03-02','12:05:00',1.35),('8537','2013-03-02','12:10:00',1.36),('8537','2013-03-02','12:15:00',1.38),('8537','2013-03-02','12:20:00',1.28),('8537','2013-03-02','12:25:00',1.38),('8537','2013-03-02','12:30:00',1.43),('8537','2013-03-02','12:35:00',1.6),('8537','2013-03-02','12:40:00',1.8),('8537','2013-03-02','12:45:00',1.59),('8537','2013-03-02','12:50:00',1.5),('8537','2013-03-02','12:55:00',1.74),('8537','2013-03-02','13:00:00',1.69),('8537','2013-03-02','13:05:00',1.48),('8537','2013-03-02','13:10:00',1.23),('8537','2013-03-02','13:15:00',1.07),('8537','2013-03-02','13:20:00',1.02),('8537','2013-03-02','13:30:00',1.08),('8537','2013-03-02','13:35:00',1.08),('8537','2013-03-02','13:40:00',1.17),('8537','2013-03-02','13:45:00',1.3),('8537','2013-03-02','13:50:00',1.26),('8537','2013-03-02','13:55:00',1.34),('8537','2013-03-02','14:00:00',1.53),('8537','2013-03-02','14:05:00',1.53),('8537','2013-03-02','14:10:00',1.3),('8537','2013-03-02','14:15:00',1.15),('8537','2013-03-02','14:20:00',1.1),('8537','2013-03-01','07:55:00',1.1),('8537','2013-03-01','08:00:00',1.23),('8537','2013-03-01','08:05:00',1.29),('8537','2013-03-01','08:10:00',1.28),('8537','2013-03-01','08:15:00',1.36),('8537','2013-03-01','08:20:00',1.44),('8537','2013-03-01','08:25:00',1.45),('8537','2013-03-01','08:30:00',1.56),('8537','2013-03-01','08:35:00',1.67),('8537','2013-03-01','08:40:00',1.8),('8537','2013-03-01','08:45:00',1.91),('8537','2013-03-01','08:50:00',2),('8537','2013-03-01','08:55:00',2.16),('8537','2013-03-01','09:00:00',2.3),('8537','2013-03-01','09:05:00',2.54),('8537','2013-03-01','09:10:00',2.53),('8537','2013-03-01','09:15:00',2.56),('8537','2013-03-01','09:20:00',2.64),('8537','2013-03-01','09:25:00',2.62),('8537','2013-03-01','09:30:00',2.92),('8537','2013-03-01','09:35:00',2.82),('8537','2013-03-01','09:40:00',3.01),('8537','2013-03-01','09:45:00',3.2),('8537','2013-03-01','09:50:00',3.21),('8537','2013-03-01','09:55:00',3.14),('8537','2013-03-01','10:00:00',3.26),('8537','2013-03-01','10:05:00',3.27),('8537','2013-03-01','10:10:00',3.22),('8537','2013-03-01','10:15:00',2.73),('8537','2013-03-01','10:20:00',2.62),('8537','2013-03-01','10:25:00',2.78),('8537','2013-03-01','10:30:00',3.1),('8537','2013-03-01','10:35:00',3.35),('8537','2013-03-01','10:40:00',2.97),('8537','2013-03-01','10:45:00',2.8),('8537','2013-03-01','10:50:00',2.64),('8537','2013-03-01','10:55:00',2.47),('8537','2013-03-01','11:00:00',2.13),('8537','2013-03-01','11:05:00',1.84),('8537','2013-03-01','11:10:00',1.77),('8537','2013-03-01','11:15:00',1.98),('8537','2013-03-01','11:20:00',2.09),('8537','2013-03-01','11:25:00',2.08),('8537','2013-03-01','11:30:00',2.11),('8537','2013-03-01','11:35:00',2.14),('8537','2013-03-01','11:40:00',2.02),('8537','2013-03-01','11:45:00',1.92),('8537','2013-03-01','11:50:00',1.9),('8537','2013-03-01','11:55:00',1.8),('8537','2013-03-01','12:00:00',1.72),('8537','2013-03-01','12:05:00',1.64),('8537','2013-03-01','12:10:00',1.52),('8537','2013-03-01','12:15:00',1.38),('8537','2013-03-01','12:20:00',1.29),('8537','2013-03-01','12:25:00',1.28),('8537','2013-03-01','12:30:00',1.32),('8537','2013-03-01','12:35:00',1.31),('8537','2013-03-01','12:40:00',1.26),('8537','2013-03-01','12:45:00',1.27),('8537','2013-03-01','12:50:00',1.29),('8537','2013-03-01','12:55:00',1.37),('8537','2013-03-01','13:00:00',1.45),('8537','2013-03-01','13:05:00',1.47),('8537','2013-03-01','13:10:00',1.52),('8537','2013-03-01','13:15:00',1.64),('8537','2013-03-01','13:20:00',1.77),('8537','2013-03-01','13:25:00',1.95),('8537','2013-03-01','13:30:00',1.9),('8537','2013-03-01','13:35:00',1.76),('8537','2013-03-01','13:40:00',1.68),('8537','2013-03-01','13:45:00',1.66),('8537','2013-03-01','13:50:00',1.65),('8537','2013-03-01','13:55:00',1.58),('8537','2013-03-01','14:00:00',1.53),('8537','2013-03-01','14:05:00',1.46),('8537','2013-03-01','14:10:00',1.37),('8537','2013-03-01','14:15:00',1.29),('8537','2013-03-01','14:20:00',1.25),('8537','2013-03-01','14:25:00',1.24),('8537','2013-03-01','14:30:00',1.29),('8537','2013-03-01','14:35:00',1.3),('8537','2013-03-01','14:40:00',1.23),('8537','2013-03-01','14:45:00',1.15),('8537','2013-03-01','14:50:00',1.09),('8537','2013-03-01','14:55:00',1.08),('8537','2013-03-01','15:00:00',1.09),('8537','2013-03-01','15:05:00',1.05),('8537','2013-02-28','07:50:00',1.01),('8537','2013-02-28','07:55:00',1.12),('8537','2013-02-28','08:00:00',1.23),('8537','2013-02-28','08:05:00',1.32),('8537','2013-02-28','08:10:00',1.43),('8537','2013-02-28','08:15:00',1.54),('8537','2013-02-28','08:20:00',1.66),('8537','2013-02-28','08:25:00',1.75),('8537','2013-02-28','08:30:00',1.87),('8537','2013-02-28','08:35:00',1.98),('8537','2013-02-28','08:40:00',2.1),('8537','2013-02-28','08:45:00',2.23),('8537','2013-02-28','08:50:00',2.37),('8537','2013-02-28','08:55:00',2.48),('8537','2013-02-28','09:00:00',2.59),('8537','2013-02-28','09:05:00',2.66),('8537','2013-02-28','09:10:00',2.72),('8537','2013-02-28','09:15:00',2.79),('8537','2013-02-28','09:20:00',2.92),('8537','2013-02-28','09:25:00',3),('8537','2013-02-28','09:30:00',3.09),('8537','2013-02-28','09:35:00',3.17),('8537','2013-02-28','09:40:00',3.24),('8537','2013-02-28','09:45:00',3.34),('8537','2013-02-28','09:50:00',3.17),('8537','2013-02-28','09:55:00',3.43),('8537','2013-02-28','10:00:00',3.56),('8537','2013-02-28','10:05:00',3.65),('8537','2013-02-28','10:10:00',3.68),('8537','2013-02-28','10:15:00',3.74),('8537','2013-02-28','10:20:00',3.77),('8537','2013-02-28','10:25:00',3.79),('8537','2013-02-28','10:30:00',3.82),('8537','2013-02-28','10:35:00',3.93),('8537','2013-02-28','10:40:00',3.99),('8537','2013-02-28','10:45:00',4.03),('8537','2013-02-28','10:50:00',4.03),('8537','2013-02-28','10:55:00',4.06),('8537','2013-02-28','11:00:00',4.16),('8537','2013-02-28','11:05:00',4.22),('8537','2013-02-28','11:10:00',4.24),('8537','2013-02-28','11:15:00',4.25),('8537','2013-02-28','11:20:00',4.35),('8537','2013-02-28','11:25:00',4.4),('8537','2013-02-28','11:30:00',4.41),('8537','2013-02-28','11:35:00',4.42),('8537','2013-02-28','11:40:00',4.41),('8537','2013-02-28','11:45:00',4.47),('8537','2013-02-28','11:50:00',4.49),('8537','2013-02-28','11:55:00',4.47),('8537','2013-02-28','12:00:00',4.2),('8537','2013-02-28','12:05:00',4.31),('8537','2013-02-28','12:10:00',4.51),('8537','2013-02-28','12:15:00',4.54),('8537','2013-02-28','12:20:00',4.51),('8537','2013-02-28','12:25:00',4.42),('8537','2013-02-28','12:30:00',4.44),('8537','2013-02-28','12:35:00',4.47),('8537','2013-02-28','12:40:00',4.44),('8537','2013-02-28','12:45:00',4.41),('8537','2013-02-28','12:50:00',4.36),('8537','2013-02-28','12:55:00',4.35),('8537','2013-02-28','13:00:00',4.26),('8537','2013-02-28','13:05:00',4.36),('8537','2013-02-28','13:10:00',4.33),('8537','2013-02-28','13:15:00',4.34),('8537','2013-02-28','13:20:00',4.31),('8537','2013-02-28','13:25:00',4.13),('8537','2013-02-28','13:30:00',3.67),('8537','2013-02-28','13:35:00',4.13),('8537','2013-02-28','13:40:00',4.14),('8537','2013-02-28','13:45:00',4.16),('8537','2013-02-28','13:50:00',4.22),('8537','2013-02-28','13:55:00',4.25),('8537','2013-02-28','14:00:00',4.26),('8537','2013-02-28','14:05:00',4.14),('8537','2013-02-28','14:10:00',3.95),('8537','2013-02-28','14:15:00',3.8),('8537','2013-02-28','14:20:00',3.3),('8537','2013-02-28','14:25:00',3.05),('8537','2013-02-28','14:30:00',3.35),('8537','2013-02-28','14:35:00',3.2),('8537','2013-02-28','14:40:00',3.29),('8537','2013-02-28','14:45:00',3.24),('8537','2013-02-28','14:50:00',3.18),('8537','2013-02-28','14:55:00',3.08),('8537','2013-02-28','15:00:00',2.98),('8537','2013-02-28','15:05:00',2.75),('8537','2013-02-28','15:10:00',2.51),('8537','2013-02-28','15:15:00',2.65),('8537','2013-02-28','15:20:00',2.59),('8537','2013-02-28','15:25:00',2.4),('8537','2013-02-28','15:30:00',2.27),('8537','2013-02-28','15:35:00',2.19),('8537','2013-02-28','15:40:00',2.1),('8537','2013-02-28','15:45:00',1.97),('8537','2013-02-28','15:50:00',1.95),('8537','2013-02-28','15:55:00',1.83),('8537','2013-02-28','16:00:00',1.73),('8537','2013-02-28','16:05:00',1.62),('8537','2013-02-28','16:10:00',1.5),('8537','2013-02-28','16:15:00',1.38),('8537','2013-02-28','16:20:00',1.23),('8537','2013-02-28','16:25:00',1.14),('8537','2013-02-28','16:30:00',1.01),('8537','2013-02-27','07:55:00',1.07),('8537','2013-02-27','08:00:00',1.19),('8537','2013-02-27','08:05:00',1.31),('8537','2013-02-27','08:10:00',1.41),('8537','2013-02-27','08:15:00',1.51),('8537','2013-02-27','08:20:00',1.63),('8537','2013-02-27','08:25:00',1.74),('8537','2013-02-27','08:30:00',1.86),('8537','2013-02-27','08:35:00',1.97),('8537','2013-02-27','08:40:00',2.03),('8537','2013-02-27','08:45:00',2.15),('8537','2013-02-27','08:50:00',2.26),('8537','2013-02-27','08:55:00',2.36),('8537','2013-02-27','09:00:00',2.48),('8537','2013-02-27','09:05:00',2.6),('8537','2013-02-27','09:10:00',2.7),('8537','2013-02-27','09:15:00',2.79),('8537','2013-02-27','09:20:00',2.86),('8537','2013-02-27','09:25:00',2.96),('8537','2013-02-27','09:30:00',3.05),('8537','2013-02-27','09:35:00',3.14),('8537','2013-02-27','09:40:00',3.2),('8537','2013-02-27','09:45:00',3.29),('8537','2013-02-27','09:50:00',3.35),('8537','2013-02-27','09:55:00',3.42),('8537','2013-02-27','10:00:00',3.48),('8537','2013-02-27','10:05:00',3.58),('8537','2013-02-27','10:10:00',3.62),('8537','2013-02-27','10:15:00',3.66),('8537','2013-02-27','10:20:00',3.75),('8537','2013-02-27','10:25:00',3.82),('8537','2013-02-27','10:30:00',3.83),('8537','2013-02-27','10:35:00',3.91),('8537','2013-02-27','10:40:00',4.03),('8537','2013-02-27','10:45:00',4.06),('8537','2013-02-27','10:50:00',4.08),('8537','2013-02-27','10:55:00',4.19),('8537','2013-02-27','11:00:00',4.2),('8537','2013-02-27','11:05:00',4.12),('8537','2013-02-27','11:10:00',4.13),('8537','2013-02-27','11:15:00',4.13),('8537','2013-02-27','11:20:00',4.17),('8537','2013-02-27','11:25:00',4.4),('8537','2013-02-27','11:30:00',4.26),('8537','2013-02-27','11:35:00',2.72),('8537','2013-02-27','11:40:00',2.63),('8537','2013-02-27','11:45:00',1.69),('8537','2013-02-27','11:50:00',2.65),('8537','2013-02-27','11:55:00',3.79),('8537','2013-02-27','12:00:00',4.67),('8537','2013-02-27','12:05:00',4.63),('8537','2013-02-27','12:10:00',4.58),('8537','2013-02-27','12:15:00',3.73),('8537','2013-02-27','12:20:00',4.8),('8537','2013-02-27','12:25:00',4.64),('8537','2013-02-27','12:30:00',4.49),('8537','2013-02-27','12:35:00',4.52),('8537','2013-02-27','12:40:00',4.57),('8537','2013-02-27','12:45:00',4.49),('8537','2013-02-27','12:50:00',4.46),('8537','2013-02-27','12:55:00',4.39),('8537','2013-02-27','13:00:00',4.4),('8537','2013-02-27','13:05:00',4.53),('8537','2013-02-27','13:10:00',4.31),('8537','2013-02-27','13:15:00',3.99),('8537','2013-02-27','13:20:00',2.08),('8537','2013-02-27','13:25:00',3.21),('8537','2013-02-27','13:30:00',4.03),('8537','2013-02-27','13:35:00',4.44),('8537','2013-02-27','13:40:00',4.42),('8537','2013-02-27','13:45:00',4.26),('8537','2013-02-27','13:50:00',4.09),('8537','2013-02-27','13:55:00',2.55),('8537','2013-02-27','14:00:00',3.79),('8537','2013-02-27','14:05:00',2.13),('8537','2013-02-27','14:10:00',3.77),('8537','2013-02-27','14:15:00',2.3),('8537','2013-02-27','14:20:00',3.39),('8537','2013-02-27','14:25:00',2.82),('8537','2013-02-27','14:30:00',2.18),('8537','2013-02-27','14:35:00',3.58),('8537','2013-02-27','14:40:00',3.51),('8537','2013-02-27','14:45:00',3.49),('8537','2013-02-27','14:50:00',3.17),('8537','2013-02-27','14:55:00',3.02),('8537','2013-02-27','15:00:00',3.14),('8537','2013-02-27','15:05:00',3.04),('8537','2013-02-27','15:10:00',2.71),('8537','2013-02-27','15:15:00',2.44),('8537','2013-02-27','15:20:00',2.27),('8537','2013-02-27','15:25:00',2.6),('8537','2013-02-27','15:30:00',2.55),('8537','2013-02-27','15:35:00',2.42),('8537','2013-02-27','15:40:00',2.28),('8537','2013-02-27','15:45:00',2.16),('8537','2013-02-27','15:50:00',2.06),('8537','2013-02-27','15:55:00',1.99),('8537','2013-02-27','16:00:00',1.86),('8537','2013-02-27','16:05:00',1.78),('8537','2013-02-27','16:10:00',1.63),('8537','2013-02-27','16:15:00',1.48),('8537','2013-02-27','16:20:00',1.35),('8537','2013-02-27','16:25:00',1.23),('8537','2013-02-27','16:30:00',1.09),('8537','2013-02-27','16:35:00',1.03),('8537','2013-02-26','09:10:00',1.03),('8537','2013-02-26','09:15:00',1.11),('8537','2013-02-26','09:20:00',1.19),('8537','2013-02-26','09:25:00',1.31),('8537','2013-02-26','09:30:00',1.6),('8537','2013-02-26','09:35:00',2),('8537','2013-02-26','09:40:00',2.24),('8537','2013-02-26','09:45:00',2.24),('8537','2013-02-26','09:50:00',2.31),('8537','2013-02-26','09:55:00',2.57),('8537','2013-02-26','10:00:00',2.44),('8537','2013-02-26','10:05:00',2.46),('8537','2013-02-26','10:10:00',2.8),('8537','2013-02-26','10:15:00',3.35),('8537','2013-02-26','10:20:00',3.95),('8537','2013-02-26','10:25:00',4.31),('8537','2013-02-26','10:30:00',4.2),('8537','2013-02-26','10:35:00',4.22),('8537','2013-02-26','10:40:00',2.4),('8537','2013-02-26','10:45:00',1.76),('8537','2013-02-26','10:50:00',2.01),('8537','2013-02-26','10:55:00',2.08),('8537','2013-02-26','11:00:00',2.65),('8537','2013-02-26','11:05:00',2.37),('8537','2013-02-26','11:10:00',2.29),('8537','2013-02-26','11:15:00',2.07),('8537','2013-02-26','11:20:00',2.03),('8537','2013-02-26','11:25:00',1.88),('8537','2013-02-26','11:30:00',1.82),('8537','2013-02-26','11:35:00',1.76),('8537','2013-02-26','11:40:00',1.88),('8537','2013-02-26','11:45:00',1.86),('8537','2013-02-26','11:50:00',2.04),('8537','2013-02-26','11:55:00',2.09),('8537','2013-02-26','12:00:00',1.98),('8537','2013-02-26','12:05:00',1.92),('8537','2013-02-26','12:10:00',1.95),('8537','2013-02-26','12:15:00',1.71),('8537','2013-02-26','12:20:00',1.71),('8537','2013-02-26','12:25:00',1.54),('8537','2013-02-26','12:30:00',1.53),('8537','2013-02-26','12:35:00',1.4),('8537','2013-02-26','12:40:00',1.26),('8537','2013-02-26','12:45:00',1.15),('8537','2013-02-26','12:50:00',1.07),('8537','2013-02-26','12:55:00',1.15),('8537','2013-02-26','13:00:00',1.15),('8537','2013-02-26','13:05:00',1),('8537','2013-02-26','13:15:00',1.01),('8537','2013-02-26','13:20:00',1.09),('8537','2013-02-26','13:25:00',1.13),('8537','2013-02-26','13:30:00',1.19),('8537','2013-02-26','13:35:00',1.19),('8537','2013-02-26','13:40:00',1.17),('8537','2013-02-26','13:45:00',1.03),('8537','2013-02-25','08:40:00',1.46),('8537','2013-02-25','08:45:00',1.3),('8537','2013-02-25','08:50:00',1.47),('8537','2013-02-25','08:55:00',1.13),('8537','2013-02-25','09:00:00',1.55),('8537','2013-02-25','09:10:00',1.02),('8537','2013-02-25','09:15:00',1.03),('8537','2013-02-25','09:20:00',1.16),('8537','2013-02-25','09:25:00',1.58),('8537','2013-02-25','09:30:00',1.72),('8537','2013-02-25','09:35:00',1.72),('8537','2013-02-25','09:40:00',1.3),('8537','2013-02-25','10:45:00',2.06),('8537','2013-02-25','10:50:00',3.68),('8537','2013-02-25','10:55:00',5.14),('8537','2013-02-25','11:00:00',5.31),('8537','2013-02-25','11:05:00',2.97),('8537','2013-02-25','11:10:00',2.32),('8537','2013-02-25','11:15:00',2.22),('8537','2013-02-25','11:20:00',1.31),('8537','2013-02-25','11:25:00',1.24),('8537','2013-02-25','11:30:00',1.91),('8537','2013-02-25','11:35:00',1.46),('8537','2013-02-25','11:40:00',1.59),('8537','2013-02-25','11:45:00',1.99),('8537','2013-02-25','11:50:00',2.83),('8537','2013-02-25','11:55:00',5.86),('8537','2013-02-25','12:00:00',3.31),('8537','2013-02-25','12:05:00',2.56),('8537','2013-02-25','12:10:00',2.26),('8537','2013-02-25','12:15:00',2.77),('8537','2013-02-25','12:20:00',5.17),('8537','2013-02-25','12:25:00',5.33),('8537','2013-02-25','12:30:00',4.6),('8537','2013-02-25','12:35:00',4.05),('8537','2013-02-25','12:40:00',5.13),('8537','2013-02-25','12:45:00',4.82),('8537','2013-02-25','12:50:00',4.65),('8537','2013-02-25','12:55:00',4.68),('8537','2013-02-25','13:00:00',4.89),('8537','2013-02-25','13:05:00',3.49),('8537','2013-02-25','13:10:00',3.41),('8537','2013-02-25','13:15:00',3.54),('8537','2013-02-25','13:20:00',2.88),('8537','2013-02-25','13:25:00',1.85),('8537','2013-02-25','13:30:00',1.86),('8537','2013-02-25','13:35:00',1.55),('8537','2013-02-25','13:40:00',1.19),('8537','2013-02-25','13:45:00',1.04),('8537','2013-02-25','13:50:00',1.06),('8537','2013-02-25','14:40:00',1.04),('8537','2013-02-24','08:05:00',1),('8537','2013-02-24','10:45:00',1.07),('8537','2013-02-24','10:50:00',1.51),('8537','2013-02-24','10:55:00',1.4),('8537','2013-02-24','11:00:00',1.09),('8537','2013-02-24','11:05:00',1.06),('8537','2013-02-24','11:25:00',1.02),('8537','2013-02-24','11:30:00',1.12),('8537','2013-02-24','11:45:00',1.05),('8537','2013-02-24','11:50:00',1.06),('8537','2013-02-24','11:55:00',1.03),('8537','2013-02-24','12:35:00',1.08),('8537','2013-02-24','12:40:00',1.29),('8537','2013-02-24','12:45:00',1.52),('8537','2013-02-24','12:50:00',1.37),('8537','2013-02-24','12:55:00',1.14),('8537','2013-02-24','13:00:00',1.37),('8537','2013-02-24','13:05:00',1.92),('8537','2013-02-24','13:10:00',1.91),('8537','2013-02-24','13:15:00',1.65),('8537','2013-02-24','13:20:00',1.77),('8537','2013-02-24','13:25:00',1.26),('8537','2013-02-24','13:30:00',1.08),('8537','2013-02-24','13:35:00',1.47),('8537','2013-02-24','13:40:00',1.65),('8537','2013-02-24','13:45:00',1.73),('8537','2013-02-24','13:50:00',1.32),('8537','2013-02-24','13:55:00',1.13),('8537','2013-02-24','14:00:00',1.26),('8537','2013-02-24','14:05:00',2.21),('8537','2013-02-24','14:10:00',1.78),('8537','2013-02-24','14:15:00',1.31),('8537','2013-02-24','14:20:00',1.2),('8537','2013-02-24','14:25:00',1.07),('8537','2013-02-24','14:30:00',1.33),('8537','2013-02-24','14:35:00',1.44),('8537','2013-02-24','15:10:00',2.58),('8537','2013-02-24','15:15:00',1.73),('8537','2013-02-24','15:20:00',1.26),('8537','2013-02-24','15:25:00',2.36),('8537','2013-02-24','15:30:00',1.43),('8537','2013-02-24','15:35:00',1.72),('8537','2013-02-24','15:40:00',1.74),('8537','2013-02-24','15:45:00',1.64),('8537','2013-02-24','15:50:00',1.37),('8537','2013-02-24','15:55:00',1.48),('8537','2013-02-24','16:00:00',1.75),('8537','2013-02-24','16:05:00',1.18),('8537','2013-02-23','07:50:00',1.02),('8537','2013-02-23','07:55:00',1.21),('8537','2013-02-23','08:00:00',1.34),('8537','2013-02-23','08:05:00',1.5),('8537','2013-02-23','08:10:00',1.82),('8537','2013-02-23','08:15:00',2.16),('8537','2013-02-23','08:20:00',1.27),('8537','2013-02-23','08:55:00',1.23),('8537','2013-02-23','09:00:00',1.55),('8537','2013-02-23','09:05:00',1.59),('8537','2013-02-23','09:10:00',1.19),('8537','2013-02-23','09:40:00',1.15),('8537','2013-02-23','09:45:00',1.59),('8537','2013-02-23','09:50:00',1.6),('8537','2013-02-23','09:55:00',1.53),('8537','2013-02-23','10:00:00',1.25),('8537','2013-02-23','10:05:00',1.18),('8537','2013-02-23','10:10:00',1.03),('8537','2013-02-23','10:25:00',1.2),('8537','2013-02-23','10:30:00',1.06),('8537','2013-02-23','10:35:00',1.03),('8537','2013-02-23','11:35:00',1.01),('8537','2013-02-23','11:40:00',1.03),('8537','2013-02-23','13:55:00',1.11),('8537','2013-02-23','14:00:00',1.18),('8537','2013-02-23','14:05:00',2.11),('8537','2013-02-23','14:10:00',1.72),('8537','2013-02-22','09:35:00',1),('8537','2013-02-22','09:40:00',1.1),('8537','2013-02-22','12:55:00',1.01),('8537','2013-02-22','14:20:00',1.03),('8537','2013-02-22','14:30:00',1.04),('8537','2013-02-22','14:35:00',1.44),('8537','2013-02-22','14:40:00',1.56),('8537','2013-02-22','14:45:00',1.28),('8537','2013-02-22','14:55:00',1.56),('8537','2013-02-22','16:20:00',1.18),('8537','2013-02-22','16:25:00',1.33),('8537','2013-02-22','16:30:00',1.13),('8537','2013-02-21','11:25:00',1.01),('8537','2013-02-21','11:30:00',1.07),('8537','2013-02-21','11:35:00',1.14),('8537','2013-02-21','11:40:00',1.12),('8537','2013-02-21','11:45:00',1.17),('8537','2013-02-21','11:50:00',1.3),('8537','2013-02-21','11:55:00',1.34),('8537','2013-02-21','12:00:00',1.33),('8537','2013-02-21','12:05:00',1.33),('8537','2013-02-21','12:10:00',1.38),('8537','2013-02-21','12:15:00',1.46),('8537','2013-02-21','12:20:00',1.58),('8537','2013-02-21','12:25:00',1.55),('8537','2013-02-21','12:30:00',1.46),('8537','2013-02-21','12:35:00',1.38),('8537','2013-02-21','12:40:00',1.34),('8537','2013-02-21','12:45:00',1.34),('8537','2013-02-21','12:50:00',1.36),('8537','2013-02-21','12:55:00',1.46),('8537','2013-02-21','13:00:00',1.48),('8537','2013-02-21','13:05:00',1.39),('8537','2013-02-21','13:10:00',1.31),('8537','2013-02-21','13:15:00',1.33),('8537','2013-02-21','13:20:00',1.39),('8537','2013-02-21','13:25:00',1.43),('8537','2013-02-21','13:30:00',1.45),('8537','2013-02-21','13:35:00',1.45),('8537','2013-02-21','13:40:00',1.41),('8537','2013-02-21','13:45:00',1.34),('8537','2013-02-21','13:50:00',1.36),('8537','2013-02-21','13:55:00',1.37),('8537','2013-02-21','14:00:00',1.38),('8537','2013-02-21','14:05:00',1.33),('8537','2013-02-21','14:10:00',1.24),('8537','2013-02-21','14:15:00',1.09),('8537','2013-02-21','16:00:00',1.03),('8537','2013-02-21','16:05:00',1.11),('8537','2013-02-21','16:20:00',1.33),('8537','2013-02-21','16:25:00',1.47),('8537','2013-02-21','16:30:00',1.37),('8537','2013-02-21','16:35:00',1.24),('8537','2014-03-23','08:25:00',1.04),('8537','2014-03-23','08:30:00',1.19),('8537','2014-03-23','08:35:00',1.33),('8537','2014-03-23','08:45:00',1.02),('8537','2014-03-23','08:50:00',1.43),('8537','2014-03-23','08:55:00',1.92),('8537','2014-03-23','09:00:00',1.16),('8537','2014-03-23','09:05:00',1.96),('8537','2014-03-23','09:10:00',3.14),('8537','2014-03-23','09:15:00',3.09),('8537','2014-03-23','09:20:00',2.17),('8537','2014-03-23','09:25:00',1.2),('8537','2014-03-23','09:30:00',1.62),('8537','2014-03-23','09:35:00',1.64),('8537','2014-03-23','09:40:00',1.48),('8537','2014-03-23','09:45:00',1.12),('8537','2014-03-23','10:25:00',1.34),('8537','2014-03-23','10:30:00',1.13),('8537','2014-03-23','10:40:00',1.35),('8537','2014-03-23','10:45:00',1.22),('8537','2014-03-23','10:50:00',1.32),('8537','2014-03-23','10:55:00',1.9),('8537','2014-03-23','11:00:00',1.47),('8537','2014-03-23','11:05:00',1.19),('8537','2014-03-23','11:10:00',1.53),('8537','2014-03-23','11:25:00',1.21),('8537','2014-03-23','11:35:00',1.55),('8537','2014-03-23','11:40:00',3.85),('8537','2014-03-23','11:45:00',1.17),('8537','2014-03-23','11:55:00',1.05),('8537','2014-03-23','12:00:00',1.09),('8537','2014-03-23','13:45:00',2.54),('8537','2014-03-23','13:50:00',2.03),('8537','2014-03-23','13:55:00',1.31),('8537','2014-03-23','14:00:00',1.18),('8537','2014-03-23','14:50:00',1.06),('8537','2014-03-23','14:55:00',1.16),('8537','2014-03-23','15:05:00',1.09),('8537','2014-03-23','15:10:00',1.48),('8537','2014-03-23','15:15:00',2.15),('8537','2014-03-23','15:20:00',1.71),('8537','2014-03-23','15:25:00',1.96),('8537','2014-03-23','15:30:00',1.17),('8537','2014-03-23','15:35:00',1.14),('8537','2014-03-23','15:40:00',1.25),('8537','2013-02-20','08:20:00',1.56),('8537','2013-02-20','08:25:00',1.72),('8537','2013-02-20','08:30:00',1.82),('8537','2013-02-20','08:35:00',1.96),('8537','2013-02-20','08:40:00',2.07),('8537','2013-02-20','08:45:00',2.18),('8537','2013-02-20','08:50:00',2.26),('8537','2013-02-20','08:55:00',2.42),('8537','2013-02-20','09:00:00',2.56),('8537','2013-02-20','09:05:00',1.6),('8537','2013-02-20','09:10:00',1.73),('8537','2013-02-20','09:15:00',1.81),('8537','2013-02-20','09:20:00',1.57),('8537','2013-02-20','09:25:00',2.38),('8537','2013-02-20','09:30:00',1.96),('8537','2013-02-20','09:35:00',2.29),('8537','2013-02-20','09:40:00',1.37),('8537','2013-02-20','09:45:00',1.57),('8537','2013-02-20','09:50:00',1.98),('8537','2013-02-20','09:55:00',2.24),('8537','2013-02-20','10:00:00',1.26),('8537','2013-02-20','10:05:00',1.89),('8537','2013-02-20','10:10:00',2.18),('8537','2013-02-20','10:15:00',1.77),('8537','2013-02-20','10:45:00',1.78),('8537','2013-02-20','10:50:00',4.6),('8537','2013-02-20','10:55:00',3),('8537','2013-02-20','11:05:00',2.31),('8537','2013-02-20','11:10:00',4.64),('8537','2013-02-20','11:15:00',4.28),('8537','2013-02-20','11:20:00',1.72),('8537','2013-02-20','11:25:00',3.53),('8537','2013-02-20','11:30:00',2.63),('8537','2013-02-20','11:35:00',4.36),('8537','2013-02-20','11:40:00',5),('8537','2013-02-20','11:45:00',5.12),('8537','2013-02-20','11:50:00',4.73),('8537','2013-02-20','11:55:00',1.88),('8537','2013-02-20','12:00:00',4.63),('8537','2013-02-20','12:05:00',2.41),('8537','2013-02-20','12:10:00',3.78),('8537','2013-02-20','12:15:00',2.4),('8537','2013-02-20','12:20:00',1.83),('8537','2013-02-20','12:25:00',3.25),('8537','2013-02-20','12:30:00',5.57),('8537','2013-02-20','12:35:00',3.87),('8537','2013-02-20','12:40:00',2.31),('8537','2013-02-20','12:45:00',1.76),('8537','2013-02-20','12:50:00',1.32),('8537','2013-02-20','12:55:00',1.48),('8537','2013-02-20','13:00:00',3.53),('8537','2013-02-20','13:05:00',4.1),('8537','2013-02-20','13:10:00',4.28),('8537','2013-02-20','13:15:00',4.36),('8537','2013-02-20','13:20:00',2.01),('8537','2013-02-20','13:25:00',2.66),('8537','2013-02-20','13:30:00',3.08),('8537','2013-02-20','13:35:00',2.82),('8537','2013-02-20','13:40:00',2.21),('8537','2013-02-20','13:45:00',1.54),('8537','2013-02-20','13:50:00',1.44),('8537','2013-02-20','13:55:00',1.32),('8537','2013-02-20','14:00:00',2.16),('8537','2013-02-20','14:05:00',1.2),('8537','2013-02-20','14:10:00',1.17),('8537','2013-02-20','14:15:00',1.08),('8537','2013-02-20','14:35:00',1.18),('8537','2013-02-20','14:40:00',1.24),('8537','2013-02-20','14:45:00',1.15),('8537','2013-02-20','14:50:00',1.07),('8537','2013-02-20','14:55:00',1.05),('8537','2013-02-20','15:05:00',1.09),('8537','2013-02-20','15:10:00',1.2),('8537','2013-02-20','15:15:00',2.4),('8537','2013-02-20','15:20:00',2.32),('8537','2013-02-20','15:25:00',2.64),('8537','2013-02-20','15:30:00',1.86),('8537','2013-02-20','15:55:00',1.03),('8537','2013-02-20','16:00:00',1.42),('8537','2013-02-20','16:05:00',1.64),('8537','2013-02-20','16:10:00',1.67),('8537','2013-02-20','16:15:00',1.82),('8537','2013-02-20','16:20:00',1.61),('8537','2013-02-20','16:25:00',1.34),('8537','2013-02-20','16:30:00',1.21),('8537','2013-02-19','08:00:00',1.01),('8537','2013-02-19','08:05:00',1.14),('8537','2013-02-19','08:10:00',1.29),('8537','2013-02-19','08:15:00',1.44),('8537','2013-02-19','08:20:00',1.56),('8537','2013-02-19','08:25:00',1.68),('8537','2013-02-19','08:30:00',1.79),('8537','2013-02-19','08:35:00',1.91),('8537','2013-02-19','08:40:00',2.01),('8537','2013-02-19','08:45:00',2.12),('8537','2013-02-19','08:50:00',2.25),('8537','2013-02-19','08:55:00',2.35),('8537','2013-02-19','09:00:00',2.44),('8537','2013-02-19','09:05:00',2.51),('8537','2013-02-19','09:10:00',2.64),('8537','2013-02-19','09:15:00',2.73),('8537','2013-02-19','09:20:00',2.84),('8537','2013-02-19','09:25:00',2.92),('8537','2013-02-19','09:30:00',3),('8537','2013-02-19','09:35:00',3.08),('8537','2013-02-19','09:40:00',3.15),('8537','2013-02-19','09:45:00',3.24),('8537','2013-02-19','09:50:00',3.32),('8537','2013-02-19','09:55:00',3.39),('8537','2013-02-19','10:00:00',3.47),('8537','2013-02-19','10:05:00',3.55),('8537','2013-02-19','10:10:00',3.64),('8537','2013-02-19','10:15:00',3.7),('8537','2013-02-19','10:20:00',3.74),('8537','2013-02-19','10:25:00',3.85),('8537','2013-02-19','10:30:00',3.9),('8537','2013-02-19','10:35:00',3.93),('8537','2013-02-19','10:40:00',3.99),('8537','2013-02-19','10:45:00',4.05),('8537','2013-02-19','10:50:00',4.01),('8537','2013-02-19','10:55:00',4.05),('8537','2013-02-19','11:00:00',4.13),('8537','2013-02-19','11:05:00',4.2),('8537','2013-02-19','11:10:00',4.26),('8537','2013-02-19','11:15:00',4.31),('8537','2013-02-19','11:20:00',4.31),('8537','2013-02-19','11:25:00',4.38),('8537','2013-02-19','11:30:00',4.32),('8537','2013-02-19','11:35:00',4.33),('8537','2013-02-19','11:40:00',4.41),('8537','2013-02-19','11:45:00',4.36),('8537','2013-02-19','11:50:00',4.45),('8537','2013-02-19','11:55:00',4.48),('8537','2013-02-19','12:00:00',4.46),('8537','2013-02-19','12:05:00',4.46),('8537','2013-02-19','12:10:00',4.43),('8537','2013-02-19','12:15:00',4.42),('8537','2013-02-19','12:20:00',4.36),('8537','2013-02-19','12:25:00',4.36),('8537','2013-02-19','12:30:00',4.4),('8537','2013-02-19','12:35:00',4.37),('8537','2013-02-19','12:40:00',4.44),('8537','2013-02-19','12:45:00',4.44),('8537','2013-02-19','12:50:00',4.39),('8537','2013-02-19','12:55:00',4.42),('8537','2013-02-19','13:00:00',4.36),('8537','2013-02-19','13:05:00',4.36),('8537','2013-02-19','13:10:00',4.34),('8537','2013-02-19','13:15:00',4.28),('8537','2013-02-19','13:20:00',4.22),('8537','2013-02-19','13:25:00',4.17),('8537','2013-02-19','13:30:00',4.24),('8537','2013-02-19','13:35:00',4.21),('8537','2013-02-19','13:40:00',4.15),('8537','2013-02-19','13:45:00',4.05),('8537','2013-02-19','13:50:00',4.02),('8537','2013-02-19','13:55:00',4),('8537','2013-02-19','14:00:00',3.88),('8537','2013-02-19','14:05:00',3.81),('8537','2013-02-19','14:10:00',3.76),('8537','2013-02-19','14:15:00',3.65),('8537','2013-02-19','14:20:00',3.41),('8537','2013-02-19','14:25:00',3.31),('8537','2013-02-19','14:30:00',3.37),('8537','2013-02-19','14:35:00',3.34),('8537','2013-02-19','14:40:00',3.2),('8537','2013-02-19','14:45:00',3.13),('8537','2013-02-19','14:50:00',3.12),('8537','2013-02-19','14:55:00',3.04),('8537','2013-02-19','15:00:00',2.96),('8537','2013-02-19','15:05:00',2.88),('8537','2013-02-19','15:10:00',2.83),('8537','2013-02-19','15:15:00',2.68),('8537','2013-02-19','15:20:00',2.38),('8537','2013-02-19','15:25:00',2.42),('8537','2013-02-19','15:30:00',2.36),('8537','2013-02-19','15:35:00',2.23),('8537','2013-02-19','15:40:00',2.14),('8537','2013-02-19','15:45:00',2.09),('8537','2013-02-19','15:50:00',1.96),('8537','2013-02-19','15:55:00',1.8),('8537','2013-02-19','16:00:00',1.56),('8537','2013-02-19','16:05:00',1.33),('8537','2013-02-19','16:10:00',1.35),('8537','2013-02-19','16:15:00',1.37),('8537','2013-02-19','16:20:00',1.23),('8537','2013-02-19','16:25:00',1.08),('8537','2013-02-18','08:05:00',1.04),('8537','2013-02-18','08:10:00',1.17),('8537','2013-02-18','08:15:00',1.32),('8537','2013-02-18','08:20:00',1.45),('8537','2013-02-18','08:25:00',1.56),('8537','2013-02-18','08:30:00',1.68),('8537','2013-02-18','08:35:00',1.8),('8537','2013-02-18','08:40:00',1.92),('8537','2013-02-18','08:45:00',1.99),('8537','2013-02-18','08:50:00',2.08),('8537','2013-02-18','08:55:00',2.19),('8537','2013-02-18','09:00:00',2.28),('8537','2013-02-18','09:05:00',2.38),('8537','2013-02-18','09:10:00',2.49),('8537','2013-02-18','09:15:00',2.58),('8537','2013-02-18','09:20:00',2.82),('8537','2013-02-18','09:25:00',3.08),('8537','2013-02-18','09:30:00',2.82),('8537','2013-02-18','09:35:00',1.42),('8537','2013-02-18','09:40:00',1.25),('8537','2013-02-18','09:45:00',1.43),('8537','2013-02-18','09:50:00',2),('8537','2013-02-18','10:05:00',1.51),('8537','2013-02-18','10:10:00',1.65),('8537','2013-02-18','10:55:00',1.13),('8537','2013-02-18','11:00:00',1.46),('8537','2013-02-18','11:05:00',1.47),('8537','2013-02-18','11:10:00',1.57),('8537','2013-02-18','11:15:00',1.39),('8537','2013-02-18','11:20:00',1.62),('8537','2013-02-18','11:25:00',1.84),('8537','2013-02-18','11:30:00',1.6),('8537','2013-02-18','11:35:00',1.64),('8537','2013-02-18','11:40:00',1.62),('8537','2013-02-18','11:45:00',1.54),('8537','2013-02-18','11:50:00',1.64),('8537','2013-02-18','11:55:00',1.92),('8537','2013-02-18','12:00:00',2.11),('8537','2013-02-18','12:05:00',1.84),('8537','2013-02-18','12:10:00',1.69),('8537','2013-02-18','12:15:00',1.64),('8537','2013-02-18','12:20:00',1.58),('8537','2013-02-18','12:25:00',1.63),('8537','2013-02-18','12:30:00',1.53),('8537','2013-02-18','12:35:00',1.43),('8537','2013-02-18','12:40:00',1.51),('8537','2013-02-18','12:45:00',1.82),('8537','2013-02-18','12:50:00',1.82),('8537','2013-02-18','12:55:00',1.68),('8537','2013-02-18','13:00:00',1.69),('8537','2013-02-18','13:05:00',1.72),('8537','2013-02-18','13:10:00',1.69),('8537','2013-02-18','13:15:00',2.11),('8537','2013-02-18','13:20:00',1.74),('8537','2013-02-18','13:25:00',2.12),('8537','2013-02-18','13:30:00',1.92),('8537','2013-02-18','13:35:00',1.6),('8537','2013-02-18','13:40:00',1.51),('8537','2013-02-18','13:45:00',1.36),('8537','2013-02-18','13:50:00',1.44),('8537','2013-02-18','13:55:00',1.82),('8537','2013-02-18','14:00:00',1.78),('8537','2013-02-18','14:05:00',1.58),('8537','2013-02-18','14:10:00',1.45),('8537','2013-02-18','14:15:00',1.22),('8537','2013-02-18','14:20:00',1.37),('8537','2013-02-17','08:10:00',1.05),('8537','2013-02-17','08:15:00',1.2),('8537','2013-02-17','08:20:00',1.37),('8537','2013-02-17','08:25:00',1.5),('8537','2013-02-17','08:30:00',1.67),('8537','2013-02-17','08:35:00',1.85),('8537','2013-02-17','08:40:00',2.02),('8537','2013-02-17','08:45:00',2),('8537','2013-02-17','08:50:00',1.71),('8537','2013-02-17','08:55:00',2.03),('8537','2013-02-17','09:00:00',2.23),('8537','2013-02-17','09:05:00',2.23),('8537','2013-02-17','09:10:00',2.38),('8537','2013-02-17','09:15:00',2.54),('8537','2013-02-17','09:20:00',2.66),('8537','2013-02-17','09:25:00',2.74),('8537','2013-02-17','09:30:00',2.81),('8537','2013-02-17','09:35:00',2.89),('8537','2013-02-17','09:40:00',2.96),('8537','2013-02-17','09:45:00',3.04),('8537','2013-02-17','09:50:00',3.13),('8537','2013-02-17','09:55:00',3.22),('8537','2013-02-17','10:00:00',3.31),('8537','2013-02-17','10:05:00',3.37),('8537','2013-02-17','10:10:00',3.39),('8537','2013-02-17','10:15:00',3.53),('8537','2013-02-17','10:20:00',3.57),('8537','2013-02-17','10:25:00',3.62),('8537','2013-02-17','10:30:00',3.69),('8537','2013-02-17','10:35:00',3.76),('8537','2013-02-17','10:40:00',3.78),('8537','2013-02-17','10:45:00',3.83),('8537','2013-02-17','10:50:00',3.83),('8537','2013-02-17','10:55:00',3.88),('8537','2013-02-17','11:00:00',3.97),('8537','2013-02-17','11:05:00',4.05),('8537','2013-02-17','11:10:00',4.03),('8537','2013-02-17','11:15:00',4.02),('8537','2013-02-17','11:20:00',4.1),('8537','2013-02-17','11:25:00',4.14),('8537','2013-02-17','11:30:00',4.17),('8537','2013-02-17','11:35:00',4.18),('8537','2013-02-17','11:40:00',4.21),('8537','2013-02-17','11:45:00',4.21),('8537','2013-02-17','11:50:00',4.21),('8537','2013-02-17','11:55:00',4.22),('8537','2013-02-17','12:00:00',4.23),('8537','2013-02-17','12:05:00',4.25),('8537','2013-02-17','12:10:00',4.28),('8537','2013-02-17','12:15:00',4.29),('8537','2013-02-17','12:20:00',4.29),('8537','2013-02-17','12:25:00',4.28),('8537','2013-02-17','12:30:00',4.23),('8537','2013-02-17','12:35:00',4.22),('8537','2013-02-17','12:40:00',4.21),('8537','2013-02-17','12:45:00',4.17),('8537','2013-02-17','12:50:00',4.13),('8537','2013-02-17','12:55:00',4.13),('8537','2013-02-17','13:00:00',4.12),('8537','2013-02-17','13:05:00',4.11),('8537','2013-02-17','13:10:00',3.96),('8537','2013-02-17','13:15:00',3.97),('8537','2013-02-17','13:20:00',2.57),('8537','2013-02-17','13:25:00',1.19),('8537','2013-02-17','13:30:00',2.64),('8537','2013-02-17','13:35:00',3.91),('8537','2013-02-17','13:40:00',3.76),('8537','2013-02-17','13:45:00',3.62),('8537','2013-02-17','13:50:00',3.44),('8537','2013-02-17','13:55:00',3.29),('8537','2013-02-17','14:10:00',3.39),('8537','2013-02-17','14:15:00',2.69),('8537','2013-02-17','14:20:00',1.33),('8537','2013-02-17','14:25:00',1.17),('8537','2013-02-17','14:30:00',2.5),('8537','2013-02-17','14:35:00',2.48),('8537','2013-02-17','14:40:00',1.13),('8537','2013-02-17','15:00:00',1.38),('8537','2013-02-17','15:05:00',2.6),('8537','2013-02-17','15:10:00',2.61),('8537','2013-02-17','15:15:00',3),('8537','2013-02-17','15:20:00',2.87),('8537','2013-02-17','15:25:00',2.55),('8537','2013-02-17','15:30:00',2.41),('8537','2013-02-17','15:35:00',2.48),('8537','2013-02-17','15:40:00',2.36),('8537','2013-02-17','15:45:00',2.27),('8537','2013-02-17','15:50:00',2.14),('8537','2013-02-17','15:55:00',1.94),('8537','2013-02-17','16:00:00',1.83),('8537','2013-02-17','16:05:00',1.65),('8537','2013-02-17','16:25:00',1.16),('8537','2013-02-17','16:30:00',1.23),('8537','2013-02-16','08:10:00',1.02),('8537','2013-02-16','08:15:00',1.15),('8537','2013-02-16','08:20:00',1.27),('8537','2013-02-16','08:25:00',1.45),('8537','2013-02-16','08:30:00',1.59),('8537','2013-02-16','08:35:00',1.72),('8537','2013-02-16','08:40:00',1.84),('8537','2013-02-16','08:45:00',1.91),('8537','2013-02-16','09:15:00',2.61),('8537','2013-02-16','09:20:00',2.78),('8537','2013-02-16','09:25:00',2.86),('8537','2013-02-16','09:30:00',2.92),('8537','2013-02-16','09:35:00',3),('8537','2013-02-16','09:40:00',3.07),('8537','2013-02-16','09:45:00',3.15),('8537','2013-02-16','09:50:00',3.26),('8537','2013-02-16','09:55:00',3.3),('8537','2013-02-16','10:00:00',3.34),('8537','2013-02-16','10:05:00',3.41),('8537','2013-02-16','10:10:00',3.55),('8537','2013-02-16','10:15:00',3.58),('8537','2013-02-16','10:20:00',3.68),('8537','2013-02-16','10:25:00',3.73),('8537','2013-02-16','10:30:00',3.77),('8537','2013-02-16','10:35:00',3.87),('8537','2013-02-16','10:40:00',3.83),('8537','2013-02-16','10:45:00',3.88),('8537','2013-02-16','10:50:00',4.11),('8537','2013-02-16','10:55:00',3.8),('8537','2013-02-16','11:00:00',4.17),('8537','2013-02-16','11:05:00',3.93),('8537','2013-02-16','11:10:00',3.97),('8537','2013-02-16','11:15:00',4.28),('8537','2013-02-16','11:20:00',3.86),('8537','2013-02-16','11:25:00',4.13),('8537','2013-02-16','11:30:00',4.31),('8537','2013-02-16','11:35:00',4.35),('8537','2013-02-16','11:40:00',4.35),('8537','2013-02-16','11:45:00',4.36),('8537','2013-02-16','11:50:00',4.45),('8537','2013-02-16','11:55:00',4.46),('8537','2013-02-16','12:00:00',4.46),('8537','2013-02-16','12:05:00',4.45),('8537','2013-02-16','12:10:00',4.42),('8537','2013-02-16','12:15:00',4.43),('8537','2013-02-16','12:20:00',4.41),('8537','2013-02-16','12:25:00',4.42),('8537','2013-02-16','12:30:00',4.43),('8537','2013-02-16','12:35:00',4.43),('8537','2013-02-16','12:40:00',4.42),('8537','2013-02-16','12:45:00',4.43),('8537','2013-02-16','12:50:00',4.45),('8537','2013-02-16','12:55:00',4.41),('8537','2013-02-16','13:00:00',4.34),('8537','2013-02-16','13:05:00',4.35),('8537','2013-02-16','13:10:00',4.29),('8537','2013-02-16','13:15:00',4.29),('8537','2013-02-16','13:20:00',4.24),('8537','2013-02-16','13:25:00',4.22),('8537','2013-02-16','13:30:00',4.18),('8537','2013-02-16','13:35:00',4.16),('8537','2013-02-16','13:40:00',4.14),('8537','2013-02-16','13:45:00',4.15),('8537','2013-02-16','13:50:00',4.12),('8537','2013-02-16','13:55:00',4.03),('8537','2013-02-16','14:00:00',3.95),('8537','2013-02-16','14:05:00',3.89),('8537','2013-02-16','14:10:00',3.84),('8537','2013-02-16','14:15:00',3.86),('8537','2013-02-16','14:20:00',3.25),('8537','2013-02-16','14:25:00',1.09),('8537','2013-02-16','14:30:00',1.2),('8537','2013-02-16','14:35:00',1.1),('8537','2013-02-16','14:40:00',1.14),('8537','2013-02-16','14:45:00',1.21),('8537','2013-02-16','14:50:00',1.21),('8537','2013-02-16','14:55:00',1.1),('8537','2013-02-16','15:15:00',1.14),('8537','2013-02-16','15:20:00',1.37),('8537','2013-02-16','15:25:00',1.26),('8537','2013-02-16','15:30:00',2.17),('8537','2013-02-16','15:35:00',2.32),('8537','2013-02-16','15:40:00',2.33),('8537','2013-02-16','15:45:00',2.63),('8537','2013-02-16','15:50:00',2.52),('8537','2013-02-16','15:55:00',1.57),('8537','2013-02-16','16:00:00',1.4),('8537','2013-02-16','16:05:00',1.8),('8537','2013-02-16','16:10:00',1.33),('8537','2013-02-15','09:20:00',1.25),('8537','2013-02-15','09:25:00',1.86),('8537','2013-02-15','09:30:00',1.32),('8537','2013-02-15','09:35:00',1.28),('8537','2013-02-15','09:40:00',1.24),('8537','2013-02-15','09:45:00',1.25),('8537','2013-02-15','09:50:00',1.29),('8537','2013-02-15','09:55:00',1.56),('8537','2013-02-15','10:00:00',2.12),('8537','2013-02-15','10:05:00',2.19),('8537','2013-02-15','10:10:00',1.62),('8537','2013-02-15','10:15:00',1.64),('8537','2013-02-15','10:20:00',1.73),('8537','2013-02-15','10:25:00',2.74),('8537','2013-02-15','10:30:00',2.25),('8537','2013-02-15','10:35:00',3.52),('8537','2013-02-15','10:40:00',3.47),('8537','2013-02-15','10:45:00',3.76),('8537','2013-02-15','10:50:00',3.55),('8537','2013-02-15','10:55:00',2.29),('8537','2013-02-15','11:00:00',2.15),('8537','2013-02-15','11:05:00',2.28),('8537','2013-02-15','11:10:00',2.5),('8537','2013-02-15','11:15:00',3.15),('8537','2013-02-15','11:20:00',4.3),('8537','2013-02-15','11:25:00',4.19),('8537','2013-02-15','11:30:00',4.18),('8537','2013-02-15','11:35:00',3.45),('8537','2013-02-15','11:40:00',2.37),('8537','2013-02-15','11:45:00',2.59),('8537','2013-02-15','11:50:00',4.66),('8537','2013-02-15','11:55:00',4.27),('8537','2013-02-15','12:00:00',3.5),('8537','2013-02-15','12:05:00',3.56),('8537','2013-02-15','12:10:00',3.3),('8537','2013-02-15','12:15:00',3.66),('8537','2013-02-15','12:20:00',4.82),('8537','2013-02-15','12:25:00',4.3),('8537','2013-02-15','12:30:00',4.43),('8537','2013-02-15','12:35:00',4.42),('8537','2013-02-15','12:40:00',4.34),('8537','2013-02-15','12:45:00',4.35),('8537','2013-02-15','12:50:00',4.34),('8537','2013-02-15','12:55:00',4.35),('8537','2013-02-15','13:00:00',4.28),('8537','2013-02-15','13:05:00',4.27),('8537','2013-02-15','13:10:00',4.25),('8537','2013-02-15','13:15:00',4.32),('8537','2013-02-15','13:20:00',4.04),('8537','2013-02-15','13:25:00',3.73),('8537','2013-02-15','13:30:00',2.79),('8537','2013-02-15','13:35:00',2.91),('8537','2013-02-15','13:40:00',3.87),('8537','2013-02-15','13:45:00',3.19),('8537','2013-02-15','13:50:00',3.07),('8537','2013-02-15','13:55:00',3.76),('8537','2013-02-15','14:00:00',2.53),('8537','2013-02-15','14:05:00',3.67),('8537','2013-02-15','14:10:00',4.46),('8537','2013-02-15','14:15:00',3),('8537','2013-02-15','14:20:00',3.11),('8537','2013-02-15','14:25:00',2.08),('8537','2013-02-15','14:30:00',2.15),('8537','2013-02-15','14:35:00',3.22),('8537','2013-02-15','14:40:00',3.41),('8537','2013-02-15','14:45:00',2.92),('8537','2013-02-15','14:50:00',1.54),('8537','2013-02-15','14:55:00',1.44),('8537','2013-02-15','15:00:00',2.12),('8537','2013-02-15','15:05:00',1.53),('8537','2013-02-15','15:10:00',1.62),('8537','2013-02-15','15:15:00',2.03),('8537','2013-02-15','15:20:00',1.58),('8537','2013-02-15','15:25:00',1.73),('8537','2013-02-15','15:30:00',1.97),('8537','2013-02-15','15:35:00',1.62),('8537','2013-02-15','15:40:00',1.45),('8537','2013-02-15','15:45:00',1.4),('8537','2013-02-14','08:10:00',1.09),('8537','2013-02-14','08:15:00',1.19),('8537','2013-02-14','08:20:00',1.3),('8537','2013-02-14','08:25:00',1.42),('8537','2013-02-14','08:30:00',1.63),('8537','2013-02-14','08:35:00',1.84),('8537','2013-02-14','08:40:00',1.98),('8537','2013-02-14','08:45:00',2.1),('8537','2013-02-14','08:50:00',2.2),('8537','2013-02-14','08:55:00',2.32),('8537','2013-02-14','09:00:00',2.41),('8537','2013-02-14','09:05:00',2.53),('8537','2013-02-14','09:10:00',2.63),('8537','2013-02-14','09:15:00',2.74),('8537','2013-02-14','09:20:00',2.84),('8537','2013-02-14','09:25:00',2.95),('8537','2013-02-14','09:30:00',3.03),('8537','2013-02-14','09:35:00',3.12),('8537','2013-02-14','09:40:00',3.2),('8537','2013-02-14','09:45:00',3.3),('8537','2013-02-14','09:50:00',3.38),('8537','2013-02-14','09:55:00',3.47),('8537','2013-02-14','10:00:00',3.54),('8537','2013-02-14','10:05:00',3.62),('8537','2013-02-14','10:10:00',3.7),('8537','2013-02-14','10:15:00',3.78),('8537','2013-02-14','10:20:00',3.84),('8537','2013-02-14','10:25:00',3.89),('8537','2013-02-14','10:30:00',3.94),('8537','2013-02-14','10:35:00',4.02),('8537','2013-02-14','10:40:00',4.07),('8537','2013-02-14','10:45:00',4.06),('8537','2013-02-14','10:50:00',4.17),('8537','2013-02-14','10:55:00',4.21),('8537','2013-02-14','11:00:00',4.25),('8537','2013-02-14','11:05:00',4.3),('8537','2013-02-14','11:10:00',4.33),('8537','2013-02-14','11:15:00',4.35),('8537','2013-02-14','11:20:00',4.38),('8537','2013-02-14','11:25:00',4.4),('8537','2013-02-14','11:30:00',4.42),('8537','2013-02-14','11:35:00',4.45),('8537','2013-02-14','11:40:00',4.46),('8537','2013-02-14','11:45:00',4.48),('8537','2013-02-14','11:50:00',4.5),('8537','2013-02-14','11:55:00',4.53),('8537','2013-02-14','12:00:00',4.51),('8537','2013-02-14','12:05:00',4.54),('8537','2013-02-14','12:10:00',4.53),('8537','2013-02-14','12:15:00',4.53),('8537','2013-02-14','12:20:00',4.53),('8537','2013-02-14','12:25:00',4.54),('8537','2013-02-14','12:30:00',4.51),('8537','2013-02-14','12:35:00',4.52),('8537','2013-02-14','12:40:00',4.5),('8537','2013-02-14','12:45:00',4.47),('8537','2013-02-14','12:50:00',4.44),('8537','2013-02-14','12:55:00',4.43),('8537','2013-02-14','13:00:00',4.4),('8537','2013-02-14','13:05:00',4.4),('8537','2013-02-14','13:10:00',4.38),('8537','2013-02-14','13:15:00',4.34),('8537','2013-02-14','13:20:00',4.32),('8537','2013-02-14','13:25:00',4.27),('8537','2013-02-14','13:30:00',4.22),('8537','2013-02-14','13:35:00',4.2),('8537','2013-02-14','13:40:00',4.16),('8537','2013-02-14','13:45:00',4.12),('8537','2013-02-14','13:50:00',4.05),('8537','2013-02-14','13:55:00',3.98),('8537','2013-02-14','14:00:00',3.93),('8537','2013-02-14','14:05:00',3.88),('8537','2013-02-14','14:10:00',3.81),('8537','2013-02-14','14:15:00',3.72),('8537','2013-02-14','14:20:00',3.67),('8537','2013-02-14','14:25:00',3.49),('8537','2013-02-14','14:30:00',3.23),('8537','2013-02-14','14:35:00',3.36),('8537','2013-02-14','14:40:00',3.33),('8537','2013-02-14','14:45:00',3.26),('8537','2013-02-14','14:50:00',3.18),('8537','2013-02-14','14:55:00',3.09),('8537','2013-02-14','15:00:00',3),('8537','2013-02-14','15:05:00',2.89),('8537','2013-02-14','15:10:00',2.83),('8537','2013-02-14','15:15:00',2.73),('8537','2013-02-14','15:20:00',2.59),('8537','2013-02-14','15:25:00',2.49),('8537','2013-02-14','15:30:00',2.4),('8537','2013-02-14','15:35:00',2.25),('8537','2013-02-14','15:40:00',2.14),('8537','2013-02-14','15:45:00',2.04),('8537','2013-02-14','15:50:00',1.88),('8537','2013-02-14','15:55:00',1.53),('8537','2013-02-14','16:00:00',1.17),('8537','2013-02-14','16:05:00',1.32),('8537','2013-02-14','16:10:00',1.33),('8537','2013-02-14','16:15:00',1.17),('8537','2013-02-14','16:20:00',1.03),('8537','2013-02-13','08:55:00',1.09),('8537','2013-02-13','09:00:00',1.3),('8537','2013-02-13','09:05:00',1.5),('8537','2013-02-13','09:10:00',1.62),('8537','2013-02-13','09:15:00',1.56),('8537','2013-02-13','09:20:00',1.58),('8537','2013-02-13','09:25:00',1.64),('8537','2013-02-13','09:30:00',1.75),('8537','2013-02-13','09:35:00',2.26),('8537','2013-02-13','09:40:00',2.64),('8537','2013-02-13','09:45:00',3.02),('8537','2013-02-13','09:50:00',3.13),('8537','2013-02-13','09:55:00',2.98),('8537','2013-02-13','10:00:00',2.98),('8537','2013-02-13','10:05:00',3.2),('8537','2013-02-13','10:10:00',3.36),('8537','2013-02-13','10:15:00',3.57),('8537','2013-02-13','10:20:00',3.67),('8537','2013-02-13','10:25:00',3.8),('8537','2013-02-13','10:30:00',3.88),('8537','2013-02-13','10:35:00',3.89),('8537','2013-02-13','10:40:00',3.97),('8537','2013-02-13','10:45:00',4.15),('8537','2013-02-13','10:50:00',4.26),('8537','2013-02-13','10:55:00',4.22),('8537','2013-02-13','11:00:00',4.23),('8537','2013-02-13','11:05:00',4.19),('8537','2013-02-13','11:10:00',4.12),('8537','2013-02-13','11:15:00',4.21),('8537','2013-02-13','11:20:00',4.14),('8537','2013-02-13','11:25:00',3.34),('8537','2013-02-13','11:30:00',3.04),('8537','2013-02-13','11:35:00',2.08),('8537','2013-02-13','11:40:00',2.08),('8537','2013-02-13','11:45:00',1.84),('8537','2013-02-13','11:50:00',2.61),('8537','2013-02-13','11:55:00',1.48),('8537','2013-02-13','12:00:00',1.2),('8537','2013-02-13','12:05:00',1.41),('8537','2013-02-13','12:10:00',2.6),('8537','2013-02-13','12:15:00',2.82),('8537','2013-02-13','12:20:00',2.28),('8537','2013-02-13','12:25:00',2.3),('8537','2013-02-13','12:30:00',1.2),('8537','2013-02-13','12:35:00',1.52),('8537','2013-02-13','12:40:00',1.36),('8537','2013-02-13','12:45:00',2.38),('8537','2013-02-13','12:50:00',3.12),('8537','2013-02-13','12:55:00',2.83),('8537','2013-02-13','13:00:00',3.29),('8537','2013-02-13','13:05:00',3.27),('8537','2013-02-13','13:10:00',3.13),('8537','2013-02-13','13:15:00',1.93),('8537','2013-02-13','13:20:00',4.31),('8537','2013-02-13','13:25:00',4.17),('8537','2013-02-13','13:30:00',4.4),('8537','2013-02-13','13:35:00',4.28),('8537','2013-02-13','13:40:00',3.91),('8537','2013-02-13','13:45:00',3.58),('8537','2013-02-13','13:50:00',3.24),('8537','2013-02-13','13:55:00',3.26),('8537','2013-02-13','14:00:00',3.84),('8537','2013-02-13','14:05:00',4.01),('8537','2013-02-13','14:10:00',3.44),('8537','2013-02-13','14:15:00',3.55),('8537','2013-02-13','14:20:00',3.26),('8537','2013-02-13','14:25:00',3.04),('8537','2013-02-13','14:30:00',3.23),('8537','2013-02-13','14:35:00',3.45),('8537','2013-02-13','14:40:00',3.33),('8537','2013-02-13','14:45:00',3.11),('8537','2013-02-13','14:50:00',3.15),('8537','2013-02-13','14:55:00',3.08),('8537','2013-02-13','15:00:00',2.96),('8537','2013-02-13','15:05:00',2.88),('8537','2013-02-13','15:10:00',2.79),('8537','2013-02-13','15:15:00',2.67),('8537','2013-02-13','15:20:00',2.5),('8537','2013-02-13','15:25:00',2.31),('8537','2013-02-13','15:30:00',2.24),('8537','2013-02-13','15:35:00',2.29),('8537','2013-02-13','15:40:00',2.19),('8537','2013-02-13','15:45:00',2.09),('8537','2013-02-13','15:50:00',1.84),('8537','2013-02-13','15:55:00',1.48),('8537','2013-02-13','16:00:00',1.41),('8537','2013-02-13','16:05:00',1.48),('8537','2013-02-13','16:10:00',1.33),('8537','2013-02-13','16:15:00',1.17),('8537','2013-02-13','16:20:00',1.01),('8537','2013-02-11','10:20:00',1.12),('8537','2013-02-11','10:25:00',1.17),('8537','2013-02-11','10:30:00',1.24),('8537','2013-02-11','10:35:00',1.48),('8537','2013-02-11','10:40:00',1.28),('8537','2013-02-11','11:00:00',1.19),('8537','2013-02-11','11:05:00',1.49),('8537','2013-02-11','11:10:00',1.63),('8537','2013-02-11','11:15:00',1.65),('8537','2013-02-11','11:20:00',1.32),('8537','2013-02-11','11:45:00',1.2),('8537','2013-02-11','12:45:00',1.43),('8537','2013-02-11','14:00:00',1.11),('8537','2013-02-11','14:05:00',1.2),('8537','2013-02-11','14:10:00',1.31),('8537','2013-02-11','14:15:00',1.09),('8537','2013-02-11','14:20:00',1.15),('8537','2013-02-11','14:25:00',1.74),('8537','2013-02-11','14:30:00',2.33),('8537','2013-02-11','14:35:00',1.17),('8537','2013-02-11','14:40:00',1.74),('8537','2013-02-11','14:45:00',1.42),('8537','2013-02-11','15:10:00',1.19),('8537','2014-03-22','07:40:00',1.56),('8537','2014-03-22','07:45:00',1.5),('8537','2014-03-22','07:50:00',1.41),('8537','2014-03-22','08:10:00',1.33),('8537','2014-03-22','08:15:00',1.76),('8537','2014-03-22','08:20:00',2.12),('8537','2014-03-22','08:25:00',2.06),('8537','2014-03-22','08:30:00',2.23),('8537','2014-03-22','08:35:00',1.12),('8537','2014-03-22','08:40:00',2.21),('8537','2014-03-22','08:45:00',2.81),('8537','2014-03-22','08:50:00',1.98),('8537','2014-03-22','08:55:00',1.96),('8537','2014-03-22','09:00:00',2.51),('8537','2014-03-22','09:05:00',1.5),('8537','2014-03-22','09:10:00',1.69),('8537','2014-03-22','09:15:00',1.45),('8537','2014-03-22','09:20:00',1.59),('8537','2014-03-22','09:25:00',1.91),('8537','2014-03-22','09:30:00',3.1),('8537','2014-03-22','09:35:00',2.05),('8537','2014-03-22','09:40:00',2.41),('8537','2014-03-22','09:45:00',3.74),('8537','2014-03-22','09:50:00',3.64),('8537','2014-03-22','09:55:00',3.8),('8537','2014-03-22','10:00:00',3.93),('8537','2014-03-22','10:05:00',3.75),('8537','2014-03-22','10:10:00',4.3),('8537','2014-03-22','10:15:00',2.4),('8537','2014-03-22','10:20:00',1.39),('8537','2014-03-22','10:25:00',1.2),('8537','2014-03-22','10:30:00',1.26),('8537','2014-03-22','10:35:00',1.82),('8537','2014-03-22','10:40:00',2.63),('8537','2014-03-22','10:45:00',3.04),('8537','2014-03-22','10:50:00',3.36),('8537','2014-03-22','10:55:00',1.86),('8537','2014-03-22','11:00:00',1.38),('8537','2014-03-22','11:05:00',1.58),('8537','2014-03-22','11:10:00',1.36),('8537','2014-03-22','11:15:00',1.75),('8537','2014-03-22','11:20:00',3.57),('8537','2014-03-22','11:25:00',5.26),('8537','2014-03-22','11:30:00',4.56),('8537','2014-03-22','11:35:00',1.73),('8537','2014-03-22','11:40:00',2.92),('8537','2014-03-22','11:45:00',2.08),('8537','2014-03-22','11:50:00',2.41),('8537','2014-03-22','11:55:00',3.49),('8537','2014-03-22','12:00:00',4.05),('8537','2014-03-22','12:05:00',1.86),('8537','2014-03-22','12:10:00',1.58),('8537','2014-03-22','12:15:00',3.2),('8537','2014-03-22','12:20:00',4.59),('8537','2014-03-22','12:25:00',3.34),('8537','2014-03-22','12:30:00',2.38),('8537','2014-03-22','12:35:00',3.09),('8537','2014-03-22','12:40:00',2.9),('8537','2014-03-22','12:45:00',5.07),('8537','2014-03-22','12:50:00',3.06),('8537','2014-03-22','12:55:00',2.35),('8537','2014-03-22','13:00:00',2.78),('8537','2014-03-22','13:05:00',2.44),('8537','2014-03-22','13:10:00',4.66),('8537','2014-03-22','13:15:00',2.45),('8537','2014-03-22','13:20:00',4.78),('8537','2014-03-22','13:25:00',3.62),('8537','2014-03-22','13:30:00',3.97),('8537','2014-03-22','13:35:00',3.69),('8537','2014-03-22','13:40:00',3.12),('8537','2014-03-22','13:45:00',4.23),('8537','2014-03-22','13:50:00',3.09),('8537','2014-03-22','13:55:00',1.81),('8537','2014-03-22','14:00:00',3.87),('8537','2014-03-22','14:05:00',1.86),('8537','2014-03-22','14:10:00',3.36),('8537','2014-03-22','14:15:00',3.61),('8537','2014-03-22','14:20:00',3.89),('8537','2014-03-22','14:25:00',3.48),('8537','2014-03-22','14:30:00',3.43),('8537','2014-03-22','14:35:00',3.65),('8537','2014-03-22','14:40:00',3.55),('8537','2014-03-22','14:45:00',3.49),('8537','2014-03-22','14:50:00',3.43),('8537','2014-03-22','14:55:00',3.33),('8537','2014-03-22','15:00:00',3.16),('8537','2014-03-22','15:05:00',3.19),('8537','2014-03-22','15:10:00',2.98),('8537','2014-03-22','15:15:00',2.88),('8537','2014-03-22','15:20:00',2.94),('8537','2014-03-22','15:25:00',2.45),('8537','2014-03-22','15:30:00',1.55),('8537','2014-03-22','15:35:00',1.91),('8537','2014-03-22','15:40:00',2.05),('8537','2014-03-22','15:45:00',1.89),('8537','2014-03-22','15:50:00',2.37),('8537','2014-03-22','15:55:00',2.24),('8537','2014-03-22','16:00:00',2.1),('8537','2014-03-22','16:05:00',2.15),('8537','2014-03-22','16:10:00',1.98),('8537','2014-03-22','16:15:00',1.5),('8537','2014-03-22','16:20:00',1.34),('8537','2014-03-22','16:25:00',1.1),('8537','2013-02-10','09:45:00',1.68),('8537','2013-02-10','09:50:00',2.24),('8537','2013-02-10','09:55:00',1.74),('8537','2013-02-10','10:00:00',3.1),('8537','2013-02-10','10:05:00',3.58),('8537','2013-02-10','10:10:00',3.56),('8537','2013-02-10','10:15:00',3.71),('8537','2013-02-10','10:20:00',3.75),('8537','2013-02-10','10:25:00',3.82),('8537','2013-02-10','10:30:00',3.89),('8537','2013-02-10','10:35:00',3.94),('8537','2013-02-10','10:40:00',3.98),('8537','2013-02-10','10:45:00',4.05),('8537','2013-02-10','10:50:00',4.09),('8537','2013-02-10','10:55:00',4.12),('8537','2013-02-10','11:00:00',4.18),('8537','2013-02-10','11:05:00',4.22),('8537','2013-02-10','11:10:00',4.25),('8537','2013-02-10','11:15:00',4.27),('8537','2013-02-10','11:20:00',4.29),('8537','2013-02-10','11:25:00',4.31),('8537','2013-02-10','11:30:00',4.35),('8537','2013-02-10','11:35:00',4.37),('8537','2013-02-10','11:40:00',4.39),('8537','2013-02-10','11:45:00',4.37),('8537','2013-02-10','11:50:00',4.44),('8537','2013-02-10','11:55:00',4.48),('8537','2013-02-10','12:00:00',4.51),('8537','2013-02-10','12:05:00',4.49),('8537','2013-02-10','12:10:00',4.52),('8537','2013-02-10','12:15:00',4.54),('8537','2013-02-10','12:20:00',4.54),('8537','2013-02-10','12:25:00',4.53),('8537','2013-02-10','12:30:00',4.54),('8537','2013-02-10','12:35:00',4.51),('8537','2013-02-10','12:40:00',4.46),('8537','2013-02-10','12:45:00',4.44),('8537','2013-02-10','12:50:00',4.46),('8537','2013-02-10','12:55:00',4.42),('8537','2013-02-10','13:00:00',4.35),('8537','2013-02-10','13:05:00',4.28),('8537','2013-02-10','13:10:00',4.26),('8537','2013-02-10','13:15:00',4.26),('8537','2013-02-10','13:20:00',4.23),('8537','2013-02-10','13:25:00',4.18),('8537','2013-02-10','13:30:00',4.17),('8537','2013-02-10','13:35:00',4.09),('8537','2013-02-10','13:40:00',4.02),('8537','2013-02-10','13:45:00',3.96),('8537','2013-02-10','13:50:00',3.94),('8537','2013-02-10','13:55:00',3.86),('8537','2013-02-10','14:00:00',3.76),('8537','2013-02-10','14:05:00',3.7),('8537','2013-02-10','14:10:00',3.64),('8537','2013-02-10','14:15:00',3.6),('8537','2013-02-10','14:20:00',3.56),('8537','2013-02-10','14:25:00',3.38),('8537','2013-02-10','14:30:00',3.26),('8537','2013-02-10','14:35:00',2.92),('8537','2013-02-10','14:40:00',3),('8537','2013-02-10','14:45:00',3.08),('8537','2013-02-10','14:50:00',3.07),('8537','2013-02-10','14:55:00',2.95),('8537','2013-02-10','15:00:00',1.84),('8537','2013-02-10','15:05:00',1.74),('8537','2013-02-10','15:10:00',2.37),('8537','2013-02-10','15:15:00',1.67),('8537','2013-02-10','15:20:00',1.37),('8537','2013-02-10','15:25:00',2.55),('8537','2013-02-10','15:30:00',1.82),('8537','2013-02-10','15:35:00',2.17),('8537','2013-02-10','15:40:00',1.16),('8537','2013-02-09','09:35:00',1.05),('8537','2013-02-09','10:50:00',1.01),('8537','2013-02-09','10:55:00',1.09),('8537','2013-02-09','11:00:00',1.16),('8537','2013-02-09','11:05:00',1.2),('8537','2013-02-09','11:10:00',1.24),('8537','2013-02-09','11:15:00',1.3),('8537','2013-02-09','11:20:00',1.34),('8537','2013-02-09','11:25:00',1.36),('8537','2013-02-09','11:30:00',1.35),('8537','2013-02-09','11:35:00',1.35),('8537','2013-02-09','11:40:00',1.31),('8537','2013-02-09','11:45:00',1.34),('8537','2013-02-09','11:50:00',1.33),('8537','2013-02-09','11:55:00',1.29),('8537','2013-02-09','12:00:00',1.3),('8537','2013-02-09','12:05:00',1.3),('8537','2013-02-09','12:10:00',1.28),('8537','2013-02-09','12:15:00',1.28),('8537','2013-02-09','12:20:00',1.31),('8537','2013-02-09','12:25:00',1.31),('8537','2013-02-09','12:30:00',1.34),('8537','2013-02-09','12:35:00',1.42),('8537','2013-02-09','12:40:00',1.45),('8537','2013-02-09','12:45:00',1.45),('8537','2013-02-09','12:50:00',1.48),('8537','2013-02-09','12:55:00',1.46),('8537','2013-02-09','13:00:00',1.56),('8537','2013-02-09','13:05:00',1.8),('8537','2013-02-09','13:10:00',2.03),('8537','2013-02-09','13:15:00',2.24),('8537','2013-02-09','13:20:00',2.5),('8537','2013-02-09','13:25:00',2.67),('8537','2013-02-09','13:30:00',3.17),('8537','2013-02-09','13:35:00',3.19),('8537','2013-02-09','13:40:00',3.39),('8537','2013-02-09','13:45:00',3.64),('8537','2013-02-09','13:50:00',3.91),('8537','2013-02-09','13:55:00',3.81),('8537','2013-02-09','14:00:00',3.91),('8537','2013-02-09','14:05:00',3.65),('8537','2013-02-09','14:10:00',2.79),('8537','2013-02-09','14:15:00',3.71),('8537','2013-02-09','14:20:00',4.02),('8537','2013-02-09','14:25:00',4.26),('8537','2013-02-09','14:30:00',3.73),('8537','2013-02-09','14:35:00',3.52),('8537','2013-02-09','14:40:00',3.21),('8537','2013-02-09','14:45:00',3.02),('8537','2013-02-09','14:50:00',2.96),('8537','2013-02-09','14:55:00',3.02),('8537','2013-02-09','15:00:00',2.88),('8537','2013-02-09','15:05:00',2.71),('8537','2013-02-09','15:10:00',2.63),('8537','2013-02-09','15:15:00',2.48),('8537','2013-02-09','15:20:00',2.38),('8537','2013-02-09','15:25:00',2.09),('8537','2013-02-09','15:30:00',2.13),('8537','2013-02-09','15:35:00',1.99),('8537','2013-02-09','15:40:00',1.81),('8537','2013-02-09','15:45:00',1.31),('8537','2013-02-09','15:50:00',1.54),('8537','2013-02-09','15:55:00',1.41),('8537','2013-02-08','09:30:00',1.03),('8537','2013-02-08','09:35:00',2.49),('8537','2013-02-08','09:40:00',3.2),('8537','2013-02-08','09:45:00',3.45),('8537','2013-02-08','09:50:00',3.81),('8537','2013-02-08','09:55:00',3.76),('8537','2013-02-08','10:00:00',3.95),('8537','2013-02-08','10:05:00',4.2),('8537','2013-02-08','10:10:00',4.25),('8537','2013-02-08','10:15:00',4.35),('8537','2013-02-08','10:20:00',3.6),('8537','2013-02-08','10:25:00',3.89),('8537','2013-02-08','10:30:00',4.24),('8537','2013-02-08','10:35:00',1.72),('8537','2013-02-08','10:40:00',3.99),('8537','2013-02-08','10:45:00',4.03),('8537','2013-02-08','10:50:00',4.53),('8537','2013-02-08','10:55:00',4.48),('8537','2013-02-08','11:00:00',4.36),('8537','2013-02-08','11:05:00',4.21),('8537','2013-02-08','11:10:00',4.34),('8537','2013-02-08','11:15:00',4.33),('8537','2013-02-08','11:20:00',4.35),('8537','2013-02-08','11:25:00',4.37),('8537','2013-02-08','11:30:00',4.37),('8537','2013-02-08','11:35:00',4.37),('8537','2013-02-08','11:40:00',4.4),('8537','2013-02-08','11:45:00',4.41),('8537','2013-02-08','11:50:00',4.43),('8537','2013-02-08','11:55:00',4.42),('8537','2013-02-08','12:00:00',4.43),('8537','2013-02-08','12:05:00',4.44),('8537','2013-02-08','12:10:00',4.45),('8537','2013-02-08','12:15:00',4.46),('8537','2013-02-08','12:20:00',4.46),('8537','2013-02-08','12:25:00',4.45),('8537','2013-02-08','12:30:00',4.47),('8537','2013-02-08','12:35:00',4.49),('8537','2013-02-08','12:40:00',4.59),('8537','2013-02-08','12:45:00',4.72),('8537','2013-02-08','12:50:00',3.48),('8537','2013-02-08','12:55:00',2.51),('8537','2013-02-08','13:00:00',2.37),('8537','2013-02-08','13:05:00',2.12),('8537','2013-02-08','13:10:00',2.36),('8537','2013-02-08','13:15:00',2.22),('8537','2013-02-08','13:20:00',2.33),('8537','2013-02-08','13:25:00',2.2),('8537','2013-02-08','13:30:00',2.18),('8537','2013-02-08','13:35:00',3.02),('8537','2013-02-08','13:40:00',2.31),('8537','2013-02-08','13:45:00',1.82),('8537','2013-02-08','13:50:00',1.9),('8537','2013-02-08','13:55:00',1.91),('8537','2013-02-08','14:00:00',1.77),('8537','2013-02-08','14:05:00',1.74),('8537','2013-02-08','14:10:00',1.58),('8537','2013-02-08','14:15:00',1.43),('8537','2013-02-08','14:20:00',1.44),('8537','2013-02-08','14:25:00',1.6),('8537','2013-02-08','14:30:00',2.47),('8537','2013-02-08','14:35:00',2.23),('8537','2013-02-08','14:40:00',4.1),('8537','2013-02-08','14:45:00',3.55),('8537','2013-02-08','14:50:00',2.64),('8537','2013-02-08','14:55:00',3.49),('8537','2013-02-08','15:00:00',3.1),('8537','2013-02-08','15:05:00',3.73),('8537','2013-02-08','15:10:00',3.62),('8537','2013-02-08','15:15:00',3.1),('8537','2013-02-08','15:20:00',2.11),('8537','2013-02-08','15:25:00',2.61),('8537','2013-02-08','15:30:00',2.26),('8537','2013-02-08','15:35:00',2.12),('8537','2013-02-08','15:40:00',2.03),('8537','2013-02-08','15:45:00',1.87),('8537','2013-02-08','15:50:00',1.66),('8537','2013-02-08','15:55:00',1.5),('8537','2013-02-08','16:00:00',1.33),('8537','2013-02-08','16:05:00',1.2),('8537','2013-02-08','16:10:00',1.16),('8537','2013-02-07','10:35:00',1.08),('8537','2013-02-07','10:40:00',1.44),('8537','2013-02-07','10:45:00',1.71),('8537','2013-02-07','10:55:00',1.58),('8537','2013-02-07','11:00:00',2.15),('8537','2013-02-07','11:05:00',1.5),('8537','2013-02-07','11:10:00',1),('8537','2013-02-07','12:25:00',3.59),('8537','2013-02-07','12:30:00',2.52),('8537','2013-02-07','12:35:00',1.2),('8537','2013-02-07','13:15:00',1.52),('8537','2013-02-07','13:20:00',1.75),('8537','2013-02-07','13:25:00',1.63),('8537','2013-02-07','13:30:00',1.2),('8537','2013-02-07','13:40:00',1.03),('8537','2013-02-07','13:45:00',1.03),('8537','2013-02-07','13:50:00',1.06),('8537','2013-02-07','13:55:00',1.24),('8537','2013-02-07','14:00:00',1.53),('8537','2013-02-07','14:05:00',2.24),('8537','2013-02-07','14:10:00',3.71),('8537','2013-02-07','14:15:00',3.32),('8537','2013-02-07','14:20:00',2.99),('8537','2013-02-07','14:25:00',1.33),('8537','2013-02-07','14:30:00',1.09),('8537','2013-02-07','14:35:00',2),('8537','2013-02-07','14:40:00',2.07),('8537','2013-02-07','14:45:00',2.09),('8537','2013-02-07','14:50:00',1.6),('8537','2013-02-07','14:55:00',1.6),('8537','2013-02-07','15:00:00',2.37),('8537','2013-02-07','15:05:00',2.97),('8537','2013-02-07','15:10:00',3.11),('8537','2013-02-07','15:15:00',2.64),('8537','2013-02-07','15:20:00',1.23),('8537','2013-02-07','15:25:00',2.23),('8537','2013-02-07','15:35:00',1.14),('8537','2013-02-06','08:40:00',1.01),('8537','2013-02-06','08:45:00',1.23),('8537','2013-02-06','08:50:00',1.64),('8537','2013-02-06','08:55:00',1.23),('8537','2013-02-06','09:00:00',1.39),('8537','2013-02-06','09:05:00',1.54),('8537','2013-02-06','09:10:00',1.97),('8537','2013-02-06','09:15:00',1.19),('8537','2013-02-06','09:20:00',1.21),('8537','2013-02-06','09:25:00',1.35),('8537','2013-02-06','09:30:00',1.9),('8537','2013-02-06','09:35:00',1.36),('8537','2013-02-06','09:40:00',2.09),('8537','2013-02-06','09:45:00',1.47),('8537','2013-02-06','09:50:00',1.49),('8537','2013-02-06','09:55:00',1.96),('8537','2013-02-06','10:00:00',1.58),('8537','2013-02-06','10:05:00',2.18),('8537','2013-02-06','10:10:00',1.81),('8537','2013-02-06','10:15:00',1.61),('8537','2013-02-06','10:20:00',1.45),('8537','2013-02-06','10:25:00',1.95),('8537','2013-02-06','10:30:00',1.74),('8537','2013-02-06','10:35:00',2.4),('8537','2013-02-06','10:40:00',1.67),('8537','2013-02-06','10:45:00',1.28),('8537','2013-02-06','10:50:00',2.19),('8537','2013-02-06','10:55:00',2.73),('8537','2013-02-06','11:00:00',2.17),('8537','2013-02-06','11:05:00',1.62),('8537','2013-02-06','11:10:00',1.91),('8537','2013-02-06','11:15:00',1.67),('8537','2013-02-06','11:20:00',2.15),('8537','2013-02-06','11:25:00',3.24),('8537','2013-02-06','11:30:00',2.05),('8537','2013-02-06','11:35:00',1.76),('8537','2013-02-06','11:40:00',1.91),('8537','2013-02-06','11:45:00',1.93),('8537','2013-02-06','11:50:00',1.98),('8537','2013-02-06','11:55:00',1.81),('8537','2013-02-06','12:00:00',1.57),('8537','2013-02-06','12:05:00',1.31),('8537','2013-02-06','12:15:00',1.23),('8537','2013-02-06','12:20:00',1.2),('8537','2013-02-06','12:25:00',1.16),('8537','2013-02-06','13:20:00',1.01),('8537','2013-02-06','13:25:00',1.12),('8537','2013-02-06','13:30:00',1.34),('8537','2013-02-06','13:35:00',1.46),('8537','2013-02-06','13:40:00',1.25),('8537','2013-02-06','13:45:00',1.14),('8537','2013-02-06','13:50:00',1.93),('8537','2013-02-06','13:55:00',1.51),('8537','2013-02-06','14:00:00',1.72),('8537','2013-02-06','14:05:00',1.52),('8537','2013-02-06','14:30:00',2.03),('8537','2013-02-06','14:35:00',2.84),('8537','2013-02-06','14:40:00',1.61),('8537','2013-02-06','15:25:00',1.12),('8537','2013-02-05','08:20:00',1.02),('8537','2013-02-05','08:25:00',1.13),('8537','2013-02-05','08:30:00',1.23),('8537','2013-02-05','08:35:00',1.34),('8537','2013-02-05','08:40:00',1.44),('8537','2013-02-05','08:45:00',1.53),('8537','2013-02-05','08:50:00',1.64),('8537','2013-02-05','08:55:00',1.76),('8537','2013-02-05','09:00:00',1.88),('8537','2013-02-05','09:05:00',2),('8537','2013-02-05','09:10:00',2.17),('8537','2013-02-05','09:15:00',2.34),('8537','2013-02-05','09:20:00',2.47),('8537','2013-02-05','09:25:00',2.57),('8537','2013-02-05','09:30:00',2.65),('8537','2013-02-05','09:35:00',2.73),('8537','2013-02-05','09:40:00',2.83),('8537','2013-02-05','09:45:00',2.91),('8537','2013-02-05','09:50:00',2.99),('8537','2013-02-05','09:55:00',3.07),('8537','2013-02-05','10:00:00',3.07),('8537','2013-02-05','10:05:00',3.15),('8537','2013-02-05','10:10:00',2.98),('8537','2013-02-05','10:15:00',3.04),('8537','2013-02-05','10:20:00',3.35),('8537','2013-02-05','10:25:00',3.45),('8537','2013-02-05','10:30:00',3.5),('8537','2013-02-05','10:35:00',3.5),('8537','2013-02-05','10:40:00',3.56),('8537','2013-02-05','10:45:00',3.6),('8537','2013-02-05','10:50:00',3.6),('8537','2013-02-05','10:55:00',3.63),('8537','2013-02-05','11:00:00',3.66),('8537','2013-02-05','11:05:00',3.7),('8537','2013-02-05','11:10:00',3.81),('8537','2013-02-05','11:15:00',3.83),('8537','2013-02-05','11:20:00',3.8),('8537','2013-02-05','11:25:00',3.82),('8537','2013-02-05','11:30:00',3.84),('8537','2013-02-05','11:35:00',3.6),('8537','2013-02-05','11:40:00',3.22),('8537','2013-02-05','11:45:00',2.54),('8537','2013-02-05','11:50:00',2.09),('8537','2013-02-05','11:55:00',1.73),('8537','2013-02-05','12:00:00',1.4),('8537','2013-02-05','12:05:00',1.75),('8537','2013-02-05','12:10:00',2.18),('8537','2013-02-05','12:15:00',1.93),('8537','2013-02-05','12:20:00',1.42),('8537','2013-02-05','12:25:00',1.32),('8537','2013-02-05','12:30:00',1.31),('8537','2013-02-05','12:35:00',1.53),('8537','2013-02-05','12:40:00',2.23),('8537','2013-02-05','12:45:00',2.29),('8537','2013-02-05','12:50:00',2.93),('8537','2013-02-05','12:55:00',1.1),('8537','2013-02-05','13:10:00',1.13),('8537','2013-02-05','13:15:00',1.48),('8537','2013-02-05','13:20:00',1.49),('8537','2013-02-05','13:25:00',1.41),('8537','2013-02-05','13:30:00',1.46),('8537','2013-02-05','13:35:00',1.09),('8537','2013-02-05','13:40:00',1.06),('8537','2013-02-05','13:45:00',1.46),('8537','2013-02-05','13:50:00',1.55),('8537','2013-02-05','13:55:00',1.33),('8537','2013-02-05','14:00:00',1.3),('8537','2013-02-05','14:05:00',1.36),('8537','2013-02-05','14:10:00',1.07),('8537','2013-02-05','14:15:00',1.18),('8537','2013-02-05','14:20:00',1.28),('8537','2013-02-05','14:25:00',1.85),('8537','2013-02-05','14:30:00',2.21),('8537','2013-02-05','14:35:00',1.66),('8537','2013-02-05','14:40:00',2.25),('8537','2013-02-05','14:45:00',1.56),('8537','2013-02-05','14:50:00',1.14),('8537','2013-02-05','15:05:00',1.2),('8537','2013-02-04','08:20:00',1.07),('8537','2013-02-04','08:25:00',1.16),('8537','2013-02-04','08:30:00',1.29),('8537','2013-02-04','08:35:00',1.4),('8537','2013-02-04','08:40:00',1.51),('8537','2013-02-04','08:45:00',1.61),('8537','2013-02-04','08:50:00',1.71),('8537','2013-02-04','08:55:00',1.58),('8537','2013-02-04','09:00:00',1.97),('8537','2013-02-04','09:05:00',2.18),('8537','2013-02-04','09:10:00',2.38),('8537','2013-02-04','09:15:00',2.52),('8537','2013-02-04','09:20:00',2.55),('8537','2013-02-04','09:25:00',2.55),('8537','2013-02-04','09:30:00',2.8),('8537','2013-02-04','09:35:00',2.81),('8537','2013-02-04','09:40:00',2.84),('8537','2013-02-04','09:45:00',2.58),('8537','2013-02-04','09:50:00',3.07),('8537','2013-02-04','09:55:00',3.33),('8537','2013-02-04','10:00:00',3.42),('8537','2013-02-04','10:05:00',3.49),('8537','2013-02-04','10:10:00',3.6),('8537','2013-02-04','10:15:00',3.72),('8537','2013-02-04','10:20:00',3.54),('8537','2013-02-04','10:25:00',3.69),('8537','2013-02-04','10:30:00',3.52),('8537','2013-02-04','10:35:00',3.34),('8537','2013-02-04','10:40:00',3.56),('8537','2013-02-04','10:45:00',3.88),('8537','2013-02-04','10:50:00',3.93),('8537','2013-02-04','10:55:00',3.94),('8537','2013-02-04','11:00:00',3.97),('8537','2013-02-04','11:05:00',4.04),('8537','2013-02-04','11:10:00',4.09),('8537','2013-02-04','11:15:00',4.12),('8537','2013-02-04','11:20:00',4.14),('8537','2013-02-04','11:25:00',4.16),('8537','2013-02-04','11:30:00',4.16),('8537','2013-02-04','11:35:00',4.19),('8537','2013-02-04','11:40:00',4.21),('8537','2013-02-04','11:45:00',4.22),('8537','2013-02-04','11:50:00',4.26),('8537','2013-02-04','11:55:00',4.24),('8537','2013-02-04','12:00:00',4.23),('8537','2013-02-04','12:05:00',4.29),('8537','2013-02-04','12:10:00',4.3),('8537','2013-02-04','12:15:00',4.27),('8537','2013-02-04','12:20:00',4.26),('8537','2013-02-04','12:25:00',4.24),('8537','2013-02-04','12:30:00',4.23),('8537','2013-02-04','12:35:00',4.23),('8537','2013-02-04','12:40:00',4.19),('8537','2013-02-04','12:45:00',4.17),('8537','2013-02-04','12:50:00',4.12),('8537','2013-02-04','12:55:00',4.13),('8537','2013-02-04','13:00:00',4.16),('8537','2013-02-04','13:05:00',4.14),('8537','2013-02-04','13:10:00',4.11),('8537','2013-02-04','13:15:00',4.09),('8537','2013-02-04','13:20:00',4.05),('8537','2013-02-04','13:25:00',4.02),('8537','2013-02-04','13:30:00',3.97),('8537','2013-02-04','13:35:00',3.93),('8537','2013-02-04','13:40:00',3.89),('8537','2013-02-04','13:45:00',3.87),('8537','2013-02-04','13:50:00',3.83),('8537','2013-02-04','13:55:00',3.79),('8537','2013-02-04','14:00:00',3.74),('8537','2013-02-04','14:05:00',3.68),('8537','2013-02-04','14:10:00',3.62),('8537','2013-02-04','14:15:00',3.55),('8537','2013-02-04','14:20:00',3.5),('8537','2013-02-04','14:25:00',3.41),('8537','2013-02-04','14:30:00',3.28),('8537','2013-02-04','14:35:00',3.03),('8537','2013-02-04','14:40:00',2.8),('8537','2013-02-04','14:45:00',3.08),('8537','2013-02-04','14:50:00',3),('8537','2013-02-04','14:55:00',2.9),('8537','2013-02-04','15:00:00',2.82),('8537','2013-02-04','15:05:00',2.72),('8537','2013-02-04','15:10:00',2.63),('8537','2013-02-04','15:15:00',2.49),('8537','2013-02-04','15:20:00',2.34),('8537','2013-02-04','15:25:00',2.2),('8537','2013-02-04','15:30:00',2.04),('8537','2013-02-04','15:35:00',1.85),('8537','2013-02-04','15:40:00',1.66),('8537','2013-02-04','15:45:00',1.52),('8537','2013-02-04','15:50:00',1.28),('8537','2013-02-04','15:55:00',1.16),('8537','2013-02-04','16:00:00',1.25),('8537','2013-02-04','16:05:00',1.18),('8537','2013-02-04','16:10:00',1.06),('8537','2013-02-03','09:20:00',1.15),('8537','2013-02-03','09:25:00',1.44),('8537','2013-02-03','09:30:00',1.12),('8537','2013-02-03','09:40:00',1.57),('8537','2013-02-03','09:45:00',2.09),('8537','2013-02-03','09:50:00',2.11),('8537','2013-02-03','09:55:00',1.64),('8537','2013-02-03','10:00:00',2.26),('8537','2013-02-03','10:05:00',1.21),('8537','2013-02-03','10:20:00',1.16),('8537','2013-02-03','11:20:00',1.56),('8537','2013-02-03','11:50:00',1.09),('8537','2013-02-03','11:55:00',1.35),('8537','2013-02-03','12:00:00',1.39),('8537','2013-02-03','12:05:00',1.34),('8537','2013-02-03','12:10:00',1.27),('8537','2013-02-02','10:15:00',1.17),('8537','2013-02-02','10:20:00',1.24),('8537','2013-02-02','10:25:00',1.23),('8537','2013-02-02','10:30:00',1.36),('8537','2013-02-02','10:35:00',1.54),('8537','2013-02-02','10:40:00',1.71),('8537','2013-02-02','10:45:00',1.81),('8537','2013-02-02','10:50:00',1.48),('8537','2013-02-02','10:55:00',2.09),('8537','2013-02-02','11:00:00',2.45),('8537','2013-02-02','11:05:00',2.21),('8537','2013-02-02','11:10:00',2.36),('8537','2013-02-02','11:15:00',2.38),('8537','2013-02-02','11:20:00',2.33),('8537','2013-02-02','11:25:00',2.68),('8537','2013-02-02','11:30:00',2.44),('8537','2013-02-02','11:35:00',2.11),('8537','2013-02-02','11:40:00',2.05),('8537','2013-02-02','11:45:00',1.37),('8537','2013-02-02','11:50:00',1.22),('8537','2013-02-02','11:55:00',1.35),('8537','2013-02-02','12:00:00',1.03),('8537','2013-02-02','12:55:00',2.82),('8537','2013-02-02','13:00:00',2.14),('8537','2013-02-02','13:05:00',2.38),('8537','2013-02-02','13:10:00',2.25),('8537','2013-02-02','13:15:00',2.67),('8537','2013-02-02','13:20:00',2.07),('8537','2013-02-02','13:25:00',2.08),('8537','2013-02-02','13:30:00',1.48),('8537','2013-02-02','13:35:00',2.58),('8537','2013-02-02','13:40:00',3.11),('8537','2013-02-02','13:45:00',2.46),('8537','2013-02-02','13:50:00',2.39),('8537','2013-02-02','13:55:00',1.42),('8537','2013-02-01','08:35:00',1.11),('8537','2013-02-01','08:40:00',1.16),('8537','2013-02-01','08:45:00',1.28),('8537','2013-02-01','08:55:00',1.06),('8537','2013-02-01','09:00:00',1.5),('8537','2013-02-01','09:05:00',1.83),('8537','2013-02-01','09:10:00',2.07),('8537','2013-02-01','09:25:00',2.16),('8537','2013-02-01','09:35:00',1.63),('8537','2013-02-01','09:40:00',2.08),('8537','2013-02-01','09:45:00',1.78),('8537','2013-02-01','09:50:00',1.17),('8537','2013-02-01','09:55:00',1.19),('8537','2013-02-01','10:00:00',1.69),('8537','2013-02-01','10:05:00',1.12),('8537','2013-02-01','10:10:00',1.27),('8537','2013-02-01','10:15:00',1.41),('8537','2013-02-01','10:20:00',2.07),('8537','2013-02-01','10:25:00',1.63),('8537','2013-02-01','10:30:00',1.95),('8537','2013-02-01','10:35:00',1.8),('8537','2013-02-01','10:45:00',1.25),('8537','2013-02-01','10:50:00',3.6),('8537','2013-02-01','10:55:00',3.24),('8537','2013-02-01','11:00:00',3.88),('8537','2013-02-01','11:05:00',3.36),('8537','2013-02-01','11:10:00',3.54),('8537','2013-02-01','11:15:00',2.43),('8537','2013-02-01','11:20:00',3.88),('8537','2013-02-01','11:25:00',2.21),('8537','2013-02-01','11:30:00',1.39),('8537','2013-02-01','11:35:00',2.98),('8537','2013-02-01','11:40:00',4.52),('8537','2013-02-01','11:45:00',2.08),('8537','2013-02-01','11:50:00',1.78),('8537','2013-02-01','11:55:00',1.37),('8537','2013-02-01','12:00:00',1.53),('8537','2013-02-01','12:05:00',2.3),('8537','2013-02-01','12:10:00',2.12),('8537','2013-02-01','12:15:00',2.69),('8537','2013-02-01','12:20:00',4.7),('8537','2013-02-01','12:25:00',3.37),('8537','2013-02-01','12:30:00',1.08),('8537','2013-02-01','12:35:00',1.91),('8537','2013-02-01','12:40:00',3.13),('8537','2013-02-01','12:45:00',4.01),('8537','2013-02-01','12:50:00',4.23),('8537','2013-02-01','12:55:00',4.38),('8537','2013-02-01','13:00:00',3.12),('8537','2013-02-01','13:05:00',3.51),('8537','2013-02-01','13:10:00',3.89),('8537','2013-02-01','13:15:00',3.74),('8537','2013-02-01','13:20:00',3.61),('8537','2013-02-01','13:25:00',2.8),('8537','2013-02-01','13:30:00',3.05),('8537','2013-02-01','13:35:00',2.8),('8537','2013-02-01','13:40:00',2.9),('8537','2013-02-01','13:45:00',2.55),('8537','2013-02-01','13:50:00',2.4),('8537','2013-02-01','13:55:00',1.3),('8537','2013-02-01','14:05:00',1),('8537','2013-02-01','14:10:00',1.29),('8537','2013-02-01','14:15:00',2.45),('8537','2013-02-01','14:20:00',3.57),('8537','2013-02-01','14:25:00',3.15),('8537','2013-02-01','14:30:00',3.1),('8537','2013-02-01','14:35:00',3.02),('8537','2013-02-01','14:40:00',2.67),('8537','2013-02-01','14:45:00',1.14),('8537','2013-02-01','14:55:00',1.01),('8537','2013-02-01','15:00:00',1.57),('8537','2013-02-01','15:05:00',2.73),('8537','2013-02-01','15:10:00',2.71),('8537','2013-02-01','15:15:00',1.68),('8537','2013-02-01','15:20:00',1.68),('8537','2013-02-01','15:30:00',1.11),('8537','2013-02-01','15:40:00',1.08),('8537','2014-03-21','07:35:00',1.08),('8537','2014-03-21','07:40:00',1.22),('8537','2014-03-21','07:45:00',1.37),('8537','2014-03-21','07:50:00',1.51),('8537','2014-03-21','07:55:00',1.64),('8537','2014-03-21','08:00:00',1.73),('8537','2014-03-21','08:05:00',1.8),('8537','2014-03-21','08:10:00',1.92),('8537','2014-03-21','08:15:00',2.05),('8537','2014-03-21','08:20:00',2.16),('8537','2014-03-21','08:25:00',2.29),('8537','2014-03-21','08:30:00',2.41),('8537','2014-03-21','08:35:00',2.52),('8537','2014-03-21','08:40:00',2.59),('8537','2014-03-21','08:45:00',2.68),('8537','2014-03-21','08:50:00',2.79),('8537','2014-03-21','08:55:00',2.91),('8537','2014-03-21','09:00:00',2.97),('8537','2014-03-21','09:05:00',3.05),('8537','2014-03-21','09:10:00',3.18),('8537','2014-03-21','09:15:00',3.25),('8537','2014-03-21','09:20:00',3.37),('8537','2014-03-21','09:25:00',3.29),('8537','2014-03-21','09:30:00',3.46),('8537','2014-03-21','09:35:00',3.51),('8537','2014-03-21','09:40:00',3.57),('8537','2014-03-21','09:45:00',3.66),('8537','2014-03-21','09:50:00',3.77),('8537','2014-03-21','09:55:00',3.82),('8537','2014-03-21','10:00:00',3.84),('8537','2014-03-21','10:05:00',3.88),('8537','2014-03-21','10:10:00',3.92),('8537','2014-03-21','10:15:00',4),('8537','2014-03-21','10:20:00',4.04),('8537','2014-03-21','10:25:00',4.16),('8537','2014-03-21','10:30:00',4.18),('8537','2014-03-21','10:35:00',4.16),('8537','2014-03-21','10:40:00',4.23),('8537','2014-03-21','10:45:00',4.21),('8537','2014-03-21','10:50:00',4.22),('8537','2014-03-21','10:55:00',4.23),('8537','2014-03-21','11:00:00',4.26),('8537','2014-03-21','11:05:00',4.26),('8537','2014-03-21','11:10:00',4.23),('8537','2014-03-21','11:15:00',4.17),('8537','2014-03-21','11:20:00',4.3),('8537','2014-03-21','11:25:00',4.42),('8537','2014-03-21','11:30:00',3.05),('8537','2014-03-21','11:35:00',2.43),('8537','2014-03-21','11:40:00',3.11),('8537','2014-03-21','11:45:00',2.54),('8537','2014-03-21','11:50:00',4.63),('8537','2014-03-21','11:55:00',4.57),('8537','2014-03-21','12:00:00',3.97),('8537','2014-03-21','12:05:00',4.58),('8537','2014-03-21','12:10:00',4.72),('8537','2014-03-21','12:15:00',4.82),('8537','2014-03-21','12:20:00',4.68),('8537','2014-03-21','12:25:00',4.61),('8537','2014-03-21','12:30:00',4.55),('8537','2014-03-21','12:35:00',4.54),('8537','2014-03-21','12:40:00',4.6),('8537','2014-03-21','12:45:00',4.61),('8537','2014-03-21','12:50:00',4.56),('8537','2014-03-21','12:55:00',4.53),('8537','2014-03-21','13:00:00',4.5),('8537','2014-03-21','13:05:00',4.53),('8537','2014-03-21','13:10:00',4.49),('8537','2014-03-21','13:15:00',4.47),('8537','2014-03-21','13:20:00',4.46),('8537','2014-03-21','13:25:00',4.41),('8537','2014-03-21','13:30:00',4.36),('8537','2014-03-21','13:35:00',4.24),('8537','2014-03-21','13:40:00',4.21),('8537','2014-03-21','13:45:00',4.19),('8537','2014-03-21','13:50:00',4.15),('8537','2014-03-21','13:55:00',4.08),('8537','2014-03-21','14:00:00',4.08),('8537','2014-03-21','14:05:00',4.08),('8537','2014-03-21','14:10:00',4.01),('8537','2014-03-21','14:15:00',3.99),('8537','2014-03-21','14:20:00',3.81),('8537','2014-03-21','14:25:00',3.7),('8537','2014-03-21','14:30:00',3.6),('8537','2014-03-21','14:35:00',3.47),('8537','2014-03-21','14:40:00',3.54),('8537','2014-03-21','14:45:00',3.44),('8537','2014-03-21','14:50:00',2.82),('8537','2014-03-21','14:55:00',1.56),('8537','2014-03-21','15:05:00',1.89),('8537','2014-03-21','15:10:00',3.5),('8537','2014-03-21','15:15:00',3.61),('8537','2014-03-21','15:20:00',3.32),('8537','2014-03-21','15:25:00',3.26),('8537','2014-03-21','15:30:00',3.33),('8537','2014-03-21','15:35:00',3),('8537','2014-03-21','15:40:00',3.05),('8537','2014-03-21','15:45:00',2.97),('8537','2014-03-21','15:50:00',2.83),('8537','2014-03-21','15:55:00',2.64),('8537','2014-03-21','16:00:00',2.53),('8537','2014-03-21','16:05:00',2.3),('8537','2014-03-21','16:10:00',2.15),('8537','2014-03-21','16:15:00',1.96),('8537','2014-03-21','16:20:00',1.76),('8537','2014-03-21','16:25:00',1.62),('8537','2014-03-21','16:30:00',1.52),('8537','2014-03-21','16:35:00',1.4),('8537','2014-03-21','16:40:00',1.28),('8537','2014-03-21','16:45:00',1.18),('8537','2014-03-21','16:50:00',1.08),('8537','2013-01-31','09:10:00',1.14),('8537','2013-01-31','09:20:00',1.14),('8537','2013-01-31','09:25:00',1.96),('8537','2013-01-31','09:30:00',2.69),('8537','2013-01-31','09:35:00',2.5),('8537','2013-01-31','09:40:00',2.57),('8537','2013-01-31','09:45:00',2.61),('8537','2013-01-31','09:50:00',2.68),('8537','2013-01-31','09:55:00',2.97),('8537','2013-01-31','10:00:00',2.9),('8537','2013-01-31','10:05:00',2.96),('8537','2013-01-31','10:10:00',3.02),('8537','2013-01-31','10:15:00',3.03),('8537','2013-01-31','10:20:00',2.98),('8537','2013-01-31','10:25:00',3.25),('8537','2013-01-31','10:30:00',3.42),('8537','2013-01-31','10:35:00',3.06),('8537','2013-01-31','10:40:00',3.57),('8537','2013-01-31','10:45:00',3.82),('8537','2013-01-31','10:50:00',3.49),('8537','2013-01-31','10:55:00',3),('8537','2013-01-31','11:00:00',1.13),('8537','2013-01-31','11:05:00',3.49),('8537','2013-01-31','11:10:00',4.14),('8537','2013-01-31','11:15:00',4.11),('8537','2013-01-31','11:20:00',4.2),('8537','2013-01-31','11:25:00',4.09),('8537','2013-01-31','11:30:00',3.87),('8537','2013-01-31','11:35:00',3.61),('8537','2013-01-31','11:40:00',3.87),('8537','2013-01-31','11:45:00',3.89),('8537','2013-01-31','11:50:00',3.81),('8537','2013-01-31','11:55:00',3.82),('8537','2013-01-31','12:00:00',3.84),('8537','2013-01-31','12:05:00',3.91),('8537','2013-01-31','12:10:00',3.92),('8537','2013-01-31','12:15:00',3.87),('8537','2013-01-31','12:20:00',3.89),('8537','2013-01-31','12:25:00',3.82),('8537','2013-01-31','12:30:00',3.87),('8537','2013-01-31','12:35:00',3.9),('8537','2013-01-31','12:40:00',3.84),('8537','2013-01-31','12:45:00',3.81),('8537','2013-01-31','12:50:00',3.79),('8537','2013-01-31','12:55:00',3.76),('8537','2013-01-31','13:00:00',3.72),('8537','2013-01-31','13:05:00',3.72),('8537','2013-01-31','13:10:00',3.55),('8537','2013-01-31','13:15:00',3.64),('8537','2013-01-31','13:20:00',3.58),('8537','2013-01-31','13:25:00',3.52),('8537','2013-01-31','13:30:00',3.52),('8537','2013-01-31','13:35:00',3.44),('8537','2013-01-31','13:40:00',3.39),('8537','2013-01-31','13:45:00',3.35),('8537','2013-01-31','13:50:00',3.51),('8537','2013-01-31','13:55:00',3.42),('8537','2013-01-31','14:00:00',3.37),('8537','2013-01-31','14:05:00',3.25),('8537','2013-01-31','14:10:00',3.09),('8537','2013-01-31','14:15:00',3.05),('8537','2013-01-31','14:20:00',3.05),('8537','2013-01-31','14:25:00',3),('8537','2013-01-31','14:30:00',2.83),('8537','2013-01-31','14:35:00',2.77),('8537','2013-01-31','14:40:00',2.74),('8537','2013-01-31','14:45:00',2.65),('8537','2013-01-31','14:50:00',2.52),('8537','2013-01-31','14:55:00',2.34),('8537','2013-01-31','15:00:00',2.25),('8537','2013-01-31','15:05:00',2.17),('8537','2013-01-31','15:10:00',2.05),('8537','2013-01-31','15:15:00',1.98),('8537','2013-01-31','15:20:00',1.86),('8537','2013-01-31','15:25:00',1.69),('8537','2013-01-31','15:30:00',1.56),('8537','2013-01-31','15:35:00',1.52),('8537','2013-01-31','15:40:00',1.4),('8537','2013-01-31','15:45:00',1.2),('8537','2013-01-31','15:50:00',1.11),('8537','2013-01-31','15:55:00',1.1),('8537','2013-01-30','10:00:00',1.1),('8537','2013-01-30','10:05:00',1.1),('8537','2013-01-30','10:10:00',2.27),('8537','2013-01-30','10:15:00',1.29),('8537','2013-01-30','10:20:00',2.06),('8537','2013-01-30','10:25:00',2.11),('8537','2013-01-30','10:30:00',1.87),('8537','2013-01-30','10:35:00',1.54),('8537','2013-01-30','10:40:00',1.57),('8537','2013-01-30','10:45:00',2.16),('8537','2013-01-30','10:50:00',3.45),('8537','2013-01-30','10:55:00',2.53),('8537','2013-01-30','11:00:00',3.57),('8537','2013-01-30','11:05:00',3.44),('8537','2013-01-30','11:10:00',3.45),('8537','2013-01-30','11:15:00',3.56),('8537','2013-01-30','11:20:00',3.62),('8537','2013-01-30','11:25:00',3.69),('8537','2013-01-30','11:30:00',3.59),('8537','2013-01-30','11:35:00',3.73),('8537','2013-01-30','11:40:00',3.46),('8537','2013-01-30','11:45:00',3.79),('8537','2013-01-30','11:50:00',3.83),('8537','2013-01-30','11:55:00',3.29),('8537','2013-01-30','12:00:00',3.74),('8537','2013-01-30','12:05:00',3.43),('8537','2013-01-30','12:10:00',2.46),('8537','2013-01-30','12:15:00',3.76),('8537','2013-01-30','12:20:00',2.13),('8537','2013-01-30','12:25:00',1.09),('8537','2013-01-30','12:35:00',1.11),('8537','2013-01-30','12:40:00',2.25),('8537','2013-01-30','12:45:00',1.1),('8537','2013-01-30','12:50:00',3.42),('8537','2013-01-30','12:55:00',4.31),('8537','2013-01-30','13:00:00',4.15),('8537','2013-01-30','13:05:00',4.27),('8537','2013-01-30','13:10:00',2.97),('8537','2013-01-30','13:15:00',3.61),('8537','2013-01-30','13:20:00',4.07),('8537','2013-01-30','13:25:00',3.92),('8537','2013-01-30','13:30:00',3.7),('8537','2013-01-30','13:35:00',2.59),('8537','2013-01-30','13:40:00',3.12),('8537','2013-01-30','13:45:00',1.65),('8537','2013-01-30','13:50:00',3.59),('8537','2013-01-30','13:55:00',2.56),('8537','2013-01-30','14:00:00',3.24),('8537','2013-01-30','14:05:00',3.26),('8537','2013-01-30','14:10:00',2.29),('8537','2013-01-30','14:15:00',1.31),('8537','2013-01-30','14:20:00',2),('8537','2013-01-30','14:25:00',2.73),('8537','2013-01-30','14:30:00',1.56),('8537','2013-01-30','14:35:00',2.45),('8537','2013-01-30','14:40:00',2.59),('8537','2013-01-30','14:45:00',2.06),('8537','2013-01-30','14:50:00',1.09),('8537','2013-01-30','14:55:00',1.21),('8537','2013-01-30','15:00:00',1.69),('8537','2013-01-30','15:05:00',1.6),('8537','2013-01-30','15:10:00',1.11),('8537','2013-01-29','08:30:00',1.02),('8537','2013-01-29','08:35:00',1.12),('8537','2013-01-29','08:40:00',1.24),('8537','2013-01-29','08:45:00',1.34),('8537','2013-01-29','08:50:00',1.4),('8537','2013-01-29','08:55:00',1.44),('8537','2013-01-29','09:00:00',1.54),('8537','2013-01-29','09:05:00',1.7),('8537','2013-01-29','09:10:00',1.78),('8537','2013-01-29','09:15:00',1.88),('8537','2013-01-29','09:20:00',2.02),('8537','2013-01-29','09:25:00',2.13),('8537','2013-01-29','09:30:00',2.26),('8537','2013-01-29','09:35:00',2.4),('8537','2013-01-29','09:40:00',2.54),('8537','2013-01-29','09:45:00',2.68),('8537','2013-01-29','09:50:00',2.8),('8537','2013-01-29','09:55:00',2.88),('8537','2013-01-29','10:00:00',2.96),('8537','2013-01-29','10:05:00',3.08),('8537','2013-01-29','10:10:00',3.19),('8537','2013-01-29','10:15:00',3.27),('8537','2013-01-29','10:20:00',3.35),('8537','2013-01-29','10:25:00',3.43),('8537','2013-01-29','10:30:00',3.48),('8537','2013-01-29','10:35:00',3.53),('8537','2013-01-29','10:40:00',3.58),('8537','2013-01-29','10:45:00',3.61),('8537','2013-01-29','10:50:00',3.67),('8537','2013-01-29','10:55:00',3.69),('8537','2013-01-29','11:00:00',3.69),('8537','2013-01-29','11:05:00',3.71),('8537','2013-01-29','11:10:00',3.72),('8537','2013-01-29','11:15:00',3.78),('8537','2013-01-29','11:20:00',3.84),('8537','2013-01-29','11:25:00',3.82),('8537','2013-01-29','11:30:00',3.77),('8537','2013-01-29','11:35:00',3.93),('8537','2013-01-29','11:40:00',3.98),('8537','2013-01-29','11:45:00',3.99),('8537','2013-01-29','11:50:00',3.99),('8537','2013-01-29','11:55:00',3.98),('8537','2013-01-29','12:00:00',3.94),('8537','2013-01-29','12:05:00',3.96),('8537','2013-01-29','12:10:00',4.01),('8537','2013-01-29','12:15:00',3.96),('8537','2013-01-29','12:20:00',4),('8537','2013-01-29','12:25:00',4.01),('8537','2013-01-29','12:30:00',3.95),('8537','2013-01-29','12:35:00',3.9),('8537','2013-01-29','12:40:00',3.9),('8537','2013-01-29','12:45:00',3.87),('8537','2013-01-29','12:50:00',3.85),('8537','2013-01-29','12:55:00',3.93),('8537','2013-01-29','13:00:00',3.9),('8537','2013-01-29','13:05:00',3.82),('8537','2013-01-29','13:10:00',3.82),('8537','2013-01-29','13:15:00',3.77),('8537','2013-01-29','13:20:00',3.67),('8537','2013-01-29','13:25:00',3.75),('8537','2013-01-29','13:30:00',3.7),('8537','2013-01-29','13:35:00',3.64),('8537','2013-01-29','13:40:00',3.58),('8537','2013-01-29','13:45:00',3.56),('8537','2013-01-29','13:50:00',3.48),('8537','2013-01-29','13:55:00',3.39),('8537','2013-01-29','14:00:00',3.36),('8537','2013-01-29','14:05:00',3.24),('8537','2013-01-29','14:10:00',3.15),('8537','2013-01-29','14:15:00',3.18),('8537','2013-01-29','14:20:00',3.2),('8537','2013-01-29','14:25:00',3.12),('8537','2013-01-29','14:30:00',3.01),('8537','2013-01-29','14:35:00',2.89),('8537','2013-01-29','14:40:00',2.81),('8537','2013-01-29','14:45:00',2.73),('8537','2013-01-29','14:50:00',2.61),('8537','2013-01-29','14:55:00',2.47),('8537','2013-01-29','15:00:00',2.31),('8537','2013-01-29','15:05:00',2.18),('8537','2013-01-29','15:10:00',2.03),('8537','2013-01-29','15:15:00',1.88),('8537','2013-01-29','15:20:00',1.73),('8537','2013-01-29','15:25:00',1.58),('8537','2013-01-29','15:30:00',1.42),('8537','2013-01-29','15:35:00',1.41),('8537','2013-01-29','15:40:00',1.34),('8537','2013-01-29','15:45:00',1.13),('8537','2013-01-29','15:50:00',1.13),('8537','2013-01-29','15:55:00',1.13),('8537','2013-01-29','16:00:00',1.09),('8537','2013-01-28','11:10:00',1.01),('8537','2013-01-28','12:45:00',1.21),('8537','2013-01-28','12:50:00',1.46),('8537','2013-01-28','12:55:00',1.37),('8537','2013-01-28','13:00:00',1.27),('8537','2013-01-28','13:05:00',1.23),('8537','2013-01-28','13:10:00',1.13),('8537','2013-01-28','13:15:00',1.08),('8537','2013-01-28','13:20:00',1.1),('8537','2013-01-28','13:25:00',1.12),('8537','2013-01-28','13:30:00',1.08),('8537','2013-01-27','08:30:00',1.1),('8537','2013-01-27','08:35:00',1.26),('8537','2013-01-27','08:40:00',1.37),('8537','2013-01-27','08:45:00',1.34),('8537','2013-01-27','08:50:00',1.37),('8537','2013-01-27','08:55:00',1.4),('8537','2013-01-27','09:00:00',1.48),('8537','2013-01-27','09:05:00',1.65),('8537','2013-01-27','09:10:00',1.72),('8537','2013-01-27','09:15:00',1.79),('8537','2013-01-27','09:20:00',1.9),('8537','2013-01-27','09:25:00',2.01),('8537','2013-01-27','09:30:00',2.14),('8537','2013-01-27','09:35:00',2.29),('8537','2013-01-27','09:40:00',2.44),('8537','2013-01-27','09:45:00',2.56),('8537','2013-01-27','09:50:00',2.7),('8537','2013-01-27','09:55:00',2.83),('8537','2013-01-27','10:00:00',2.94),('8537','2013-01-27','10:05:00',3.01),('8537','2013-01-27','10:10:00',3.07),('8537','2013-01-27','10:15:00',3.15),('8537','2013-01-27','10:20:00',3.19),('8537','2013-01-27','10:25:00',3.26),('8537','2013-01-27','10:30:00',3.34),('8537','2013-01-27','10:35:00',3.4),('8537','2013-01-27','10:40:00',3.43),('8537','2013-01-27','10:45:00',3.47),('8537','2013-01-27','10:50:00',3.52),('8537','2013-01-27','10:55:00',3.56),('8537','2013-01-27','11:00:00',3.57),('8537','2013-01-27','11:05:00',3.65),('8537','2013-01-27','11:10:00',3.69),('8537','2013-01-27','11:15:00',3.71),('8537','2013-01-27','11:20:00',3.75),('8537','2013-01-27','11:25:00',3.78),('8537','2013-01-27','11:30:00',3.79),('8537','2013-01-27','11:35:00',3.81),('8537','2013-01-27','11:40:00',3.81),('8537','2013-01-27','11:45:00',3.87),('8537','2013-01-27','11:50:00',3.88),('8537','2013-01-27','11:55:00',3.87),('8537','2013-01-27','12:00:00',3.9),('8537','2013-01-27','12:05:00',3.89),('8537','2013-01-27','12:10:00',3.9),('8537','2013-01-27','12:15:00',3.91),('8537','2013-01-27','12:20:00',3.97),('8537','2013-01-27','12:25:00',3.9),('8537','2013-01-27','12:30:00',3.89),('8537','2013-01-27','12:35:00',3.88),('8537','2013-01-27','12:40:00',3.88),('8537','2013-01-27','12:45:00',3.86),('8537','2013-01-27','12:50:00',3.91),('8537','2013-01-27','12:55:00',3.88),('8537','2013-01-27','13:00:00',3.87),('8537','2013-01-27','13:05:00',3.87),('8537','2013-01-27','13:10:00',3.84),('8537','2013-01-27','13:15:00',3.78),('8537','2013-01-27','13:20:00',3.66),('8537','2013-01-27','13:25:00',3.6),('8537','2013-01-27','13:30:00',3.55),('8537','2013-01-27','13:35:00',3.48),('8537','2013-01-27','13:40:00',3.45),('8537','2013-01-27','13:45:00',3.36),('8537','2013-01-27','13:50:00',3.3),('8537','2013-01-27','13:55:00',3.27),('8537','2013-01-27','14:00:00',3.25),('8537','2013-01-27','14:05:00',3.14),('8537','2013-01-27','14:10:00',3.11),('8537','2013-01-27','14:15:00',3.01),('8537','2013-01-27','14:20:00',2.98),('8537','2013-01-27','14:25:00',2.88),('8537','2013-01-27','14:30:00',2.76),('8537','2013-01-27','14:35:00',2.61),('8537','2013-01-27','14:40:00',2.43),('8537','2013-01-27','14:45:00',2.26),('8537','2013-01-27','14:50:00',2.32),('8537','2013-01-27','14:55:00',2.27),('8537','2013-01-27','15:00:00',2.12),('8537','2013-01-27','15:05:00',1.97),('8537','2013-01-27','15:10:00',1.81),('8537','2013-01-27','15:15:00',1.68),('8537','2013-01-27','15:20:00',1.6),('8537','2013-01-27','15:25:00',1.53),('8537','2013-01-27','15:30:00',1.46),('8537','2013-01-27','15:35:00',1.37),('8537','2013-01-27','15:40:00',1.21),('8537','2013-01-27','15:45:00',1.01),('8537','2013-01-27','15:50:00',1.05),('8537','2013-01-27','15:55:00',1.07),('8537','2013-01-26','09:00:00',1.47),('8537','2013-01-26','09:05:00',1.16),('8537','2013-01-26','09:10:00',1.42),('8537','2013-01-26','09:15:00',1.17),('8537','2013-01-26','09:20:00',1.26),('8537','2013-01-26','09:25:00',1.11),('8537','2013-01-26','09:35:00',1.06),('8537','2013-01-26','09:50:00',1.23),('8537','2013-01-26','09:55:00',1.67),('8537','2013-01-26','10:00:00',1.08),('8537','2013-01-26','10:05:00',1.07),('8537','2013-01-26','10:15:00',1.14),('8537','2013-01-26','10:20:00',1.44),('8537','2013-01-26','10:25:00',1.51),('8537','2013-01-26','10:40:00',1.03),('8537','2013-01-26','10:45:00',1.07),('8537','2013-01-26','10:50:00',1.31),('8537','2013-01-26','10:55:00',1.26),('8537','2013-01-26','11:00:00',1),('8537','2013-01-26','11:05:00',1.23),('8537','2013-01-26','11:10:00',1.09),('8537','2013-01-26','11:15:00',1.04),('8537','2013-01-26','11:25:00',1.15),('8537','2013-01-26','11:30:00',1.13),('8537','2013-01-26','11:35:00',1.06),('8537','2013-01-26','11:40:00',1.07),('8537','2013-01-26','11:50:00',1.02),('8537','2013-01-26','11:55:00',1.01),('8537','2013-01-26','12:25:00',1.12),('8537','2013-01-26','12:30:00',1.05),('8537','2013-01-26','12:35:00',1.04),('8537','2013-01-26','12:50:00',1.01),('8537','2013-01-25','08:30:00',1.02),('8537','2013-01-25','08:35:00',1.23),('8537','2013-01-25','08:40:00',1.34),('8537','2013-01-25','08:45:00',1.42),('8537','2013-01-25','08:50:00',1.42),('8537','2013-01-25','08:55:00',1.46),('8537','2013-01-25','09:00:00',1.71),('8537','2013-01-25','09:05:00',1.41),('8537','2013-01-25','09:10:00',1.57),('8537','2013-01-25','09:15:00',1.89),('8537','2013-01-25','09:20:00',2.04),('8537','2013-01-25','09:25:00',2.16),('8537','2013-01-25','09:30:00',2.27),('8537','2013-01-25','09:35:00',2.24),('8537','2013-01-25','09:40:00',2.24),('8537','2013-01-25','09:45:00',2.37),('8537','2013-01-25','09:50:00',2.96),('8537','2013-01-25','09:55:00',3.07),('8537','2013-01-25','10:00:00',3.19),('8537','2013-01-25','10:05:00',3.25),('8537','2013-01-25','10:10:00',3.32),('8537','2013-01-25','10:15:00',3.38),('8537','2013-01-25','10:20:00',3.37),('8537','2013-01-25','10:25:00',3.46),('8537','2013-01-25','10:30:00',3.17),('8537','2013-01-25','10:35:00',2.14),('8537','2013-01-25','10:40:00',3.37),('8537','2013-01-25','10:45:00',3.51),('8537','2013-01-25','10:50:00',2.43),('8537','2013-01-25','10:55:00',4.07),('8537','2013-01-25','11:00:00',2.08),('8537','2013-01-25','11:05:00',3.17),('8537','2013-01-25','11:10:00',3.52),('8537','2013-01-25','11:15:00',3.92),('8537','2013-01-25','11:20:00',3.91),('8537','2013-01-25','11:25:00',3.88),('8537','2013-01-25','11:30:00',3.92),('8537','2013-01-25','11:35:00',4),('8537','2013-01-25','11:40:00',3.98),('8537','2013-01-25','11:45:00',4.02),('8537','2013-01-25','11:50:00',4.07),('8537','2013-01-25','11:55:00',4.05),('8537','2013-01-25','12:00:00',4.02),('8537','2013-01-25','12:05:00',4),('8537','2013-01-25','12:10:00',4.04),('8537','2013-01-25','12:15:00',4.09),('8537','2013-01-25','12:20:00',4.1),('8537','2013-01-25','12:25:00',4.1),('8537','2013-01-25','12:30:00',4.05),('8537','2013-01-25','12:35:00',3.5),('8537','2013-01-25','12:40:00',3.67),('8537','2013-01-25','12:45:00',3.91),('8537','2013-01-25','12:50:00',3.95),('8537','2013-01-25','12:55:00',3.88),('8537','2013-01-25','13:00:00',3.87),('8537','2013-01-25','13:05:00',3.81),('8537','2013-01-25','13:10:00',3.8),('8537','2013-01-25','13:15:00',3.8),('8537','2013-01-25','13:20:00',3.79),('8537','2013-01-25','13:25:00',3.76),('8537','2013-01-25','13:30:00',3.91),('8537','2013-01-25','13:35:00',3.83),('8537','2013-01-25','13:40:00',3.75),('8537','2013-01-25','13:45:00',3.66),('8537','2013-01-25','13:50:00',3.55),('8537','2013-01-25','13:55:00',3.48),('8537','2013-01-25','14:00:00',3.37),('8537','2013-01-25','14:05:00',3.23),('8537','2013-01-25','14:10:00',2.99),('8537','2013-01-25','14:15:00',2.83),('8537','2013-01-25','14:20:00',2.64),('8537','2013-01-25','14:25:00',2.62),('8537','2013-01-25','14:30:00',2.44),('8537','2013-01-25','14:35:00',2.28),('8537','2013-01-25','14:40:00',2.17),('8537','2013-01-25','14:45:00',2),('8537','2013-01-25','14:50:00',1.96),('8537','2013-01-25','14:55:00',1.91),('8537','2013-01-25','15:00:00',1.73),('8537','2013-01-25','15:05:00',1.61),('8537','2013-01-25','15:10:00',1.55),('8537','2013-01-25','15:15:00',1.44),('8537','2013-01-25','15:20:00',1.38),('8537','2013-01-25','15:25:00',1.36),('8537','2013-01-25','15:30:00',1.4),('8537','2013-01-25','15:35:00',1.42),('8537','2013-01-25','15:40:00',1.28),('8537','2013-01-25','15:45:00',1.25),('8537','2013-01-25','15:50:00',1.3),('8537','2013-01-25','15:55:00',1.11),('8537','2013-01-24','09:25:00',1.01),('8537','2013-01-24','09:30:00',1.09),('8537','2013-01-24','09:45:00',1.77),('8537','2013-01-24','09:50:00',1.54),('8537','2013-01-24','09:55:00',2.7),('8537','2013-01-24','10:00:00',2.84),('8537','2013-01-24','10:05:00',2.97),('8537','2013-01-24','10:10:00',3.28),('8537','2013-01-24','10:15:00',3.28),('8537','2013-01-24','10:20:00',3.41),('8537','2013-01-24','10:25:00',3.43),('8537','2013-01-24','10:30:00',3.49),('8537','2013-01-24','10:35:00',3.52),('8537','2013-01-24','10:40:00',3.59),('8537','2013-01-24','10:45:00',3.64),('8537','2013-01-24','10:50:00',3.71),('8537','2013-01-24','10:55:00',3.25),('8537','2013-01-24','11:00:00',1.61),('8537','2013-01-24','11:05:00',1.23),('8537','2013-01-24','12:50:00',1.08),('8537','2013-01-24','12:55:00',1.11),('8537','2013-01-24','13:00:00',1.1),('8537','2013-01-24','13:05:00',1.07),('8537','2013-01-24','13:30:00',1.01),('8537','2013-01-24','13:45:00',1.01),('8537','2013-01-24','13:50:00',1.05),('8537','2013-01-24','13:55:00',1.11),('8537','2013-01-24','14:00:00',1.43),('8537','2013-01-24','14:05:00',1.39),('8537','2013-01-24','14:10:00',1.33),('8537','2013-01-24','14:15:00',1.55),('8537','2013-01-24','14:20:00',2.33),('8537','2013-01-24','14:25:00',4.04),('8537','2013-01-24','14:30:00',3.44),('8537','2013-01-24','14:35:00',2.51),('8537','2013-01-24','14:40:00',1.67),('8537','2013-01-24','14:45:00',2.27),('8537','2013-01-24','14:50:00',2.35),('8537','2013-01-24','14:55:00',2.35),('8537','2013-01-24','15:00:00',1.67),('8537','2013-01-24','15:05:00',1.19),('8537','2013-01-24','15:20:00',1.46),('8537','2013-01-24','15:25:00',1.47),('8537','2013-01-24','15:30:00',1.52),('8537','2013-01-24','15:35:00',1.28),('8537','2013-01-24','15:50:00',1.2),('8537','2013-01-24','15:55:00',1.09),('8537','2013-01-23','09:55:00',2.06),('8537','2013-01-23','10:00:00',1.06),('8537','2013-01-23','10:25:00',1.21),('8537','2013-01-23','10:30:00',2.49),('8537','2013-01-23','10:35:00',3.4),('8537','2013-01-23','10:40:00',1.57),('8537','2013-01-23','10:45:00',2.07),('8537','2013-01-23','10:50:00',2.62),('8537','2013-01-23','10:55:00',2.3),('8537','2013-01-22','08:50:00',1.07),('8537','2013-01-22','09:00:00',1.32),('8537','2013-01-22','09:05:00',1.47),('8537','2013-01-22','09:30:00',1.97),('8537','2013-01-22','09:35:00',2.29),('8537','2013-01-22','09:40:00',1.87),('8537','2013-01-22','09:45:00',3),('8537','2013-01-22','09:50:00',1.84),('8537','2013-01-22','09:55:00',2.28),('8537','2013-01-22','10:00:00',1.69),('8537','2013-01-22','10:05:00',2.72),('8537','2013-01-22','10:10:00',3.15),('8537','2013-01-22','10:15:00',2.95),('8537','2013-01-22','10:20:00',3.07),('8537','2013-01-22','10:25:00',3.29),('8537','2013-01-22','10:30:00',3.48),('8537','2013-01-22','10:35:00',3.63),('8537','2013-01-22','10:40:00',3.63),('8537','2013-01-22','10:45:00',3.31),('8537','2013-01-22','10:50:00',2.86),('8537','2013-01-22','10:55:00',1.6),('8537','2013-01-22','11:10:00',1.35),('8537','2013-01-22','11:15:00',2.13),('8537','2013-01-22','11:20:00',2.32),('8537','2013-01-22','11:25:00',1.38),('8537','2013-01-22','11:45:00',1.98),('8537','2013-01-22','11:50:00',2.73),('8537','2013-01-22','11:55:00',1.11),('8537','2013-01-22','12:00:00',1.21),('8537','2013-01-22','12:05:00',1.06),('8537','2013-01-22','12:10:00',3.17),('8537','2013-01-22','12:15:00',3.16),('8537','2013-01-22','12:20:00',2.09),('8537','2013-01-22','12:25:00',2.91),('8537','2013-01-22','12:30:00',1.3),('8537','2013-01-22','12:35:00',1.07),('8537','2013-01-22','12:40:00',4.34),('8537','2013-01-22','12:45:00',1.3),('8537','2013-01-22','12:50:00',1.1),('8537','2013-01-22','12:55:00',1.36),('8537','2013-01-22','13:00:00',2.76),('8537','2013-01-22','13:05:00',4.43),('8537','2013-01-22','13:10:00',3.12),('8537','2013-01-22','13:15:00',1.26),('8537','2013-01-22','13:20:00',3.42),('8537','2013-01-22','13:25:00',1.04),('8537','2013-01-22','13:30:00',1.23),('8537','2013-01-22','13:40:00',1.11),('8537','2013-01-22','13:45:00',1.21),('8537','2013-01-22','13:50:00',1.75),('8537','2013-01-22','14:10:00',1.52),('8537','2013-01-22','14:15:00',1.64),('8537','2013-01-22','14:20:00',1.27),('8537','2013-01-22','14:25:00',2.14),('8537','2013-01-22','14:35:00',1.78),('8537','2013-01-22','14:40:00',1.3),('8537','2013-01-22','14:45:00',1.91),('8537','2013-01-22','14:50:00',1.47),('8537','2014-03-20','07:25:00',1.08),('8537','2014-03-20','07:30:00',1.08),('8537','2014-03-20','07:35:00',1.28),('8537','2014-03-20','07:40:00',1.43),('8537','2014-03-20','07:45:00',1.55),('8537','2014-03-20','07:50:00',1.64),('8537','2014-03-20','07:55:00',1.75),('8537','2014-03-20','08:00:00',1.86),('8537','2014-03-20','08:05:00',1.97),('8537','2014-03-20','08:10:00',2.04),('8537','2014-03-20','08:15:00',2.1),('8537','2014-03-20','08:20:00',2.17),('8537','2014-03-20','08:25:00',2.26),('8537','2014-03-20','08:30:00',2.39),('8537','2014-03-20','08:35:00',2.52),('8537','2014-03-20','08:40:00',2.65),('8537','2014-03-20','08:45:00',2.77),('8537','2014-03-20','08:50:00',2.88),('8537','2014-03-20','08:55:00',2.94),('8537','2014-03-20','09:00:00',3),('8537','2014-03-20','09:05:00',3.1),('8537','2014-03-20','09:10:00',3.23),('8537','2014-03-20','09:15:00',3.28),('8537','2014-03-20','09:20:00',3.39),('8537','2014-03-20','09:25:00',3.44),('8537','2014-03-20','09:30:00',3.49),('8537','2014-03-20','09:35:00',3.61),('8537','2014-03-20','09:40:00',3.62),('8537','2014-03-20','09:45:00',3.66),('8537','2014-03-20','09:50:00',3.57),('8537','2014-03-20','09:55:00',3.71),('8537','2014-03-20','10:00:00',3.89),('8537','2014-03-20','10:05:00',4.04),('8537','2014-03-20','10:10:00',4.09),('8537','2014-03-20','10:15:00',4.04),('8537','2014-03-20','10:20:00',4.1),('8537','2014-03-20','10:25:00',4.15),('8537','2014-03-20','10:30:00',4.17),('8537','2014-03-20','10:35:00',4.1),('8537','2014-03-20','10:40:00',4),('8537','2014-03-20','10:45:00',4),('8537','2014-03-20','10:50:00',4.28),('8537','2014-03-20','10:55:00',4.5),('8537','2014-03-20','11:00:00',4.54),('8537','2014-03-20','11:05:00',4.45),('8537','2014-03-20','11:10:00',4.48),('8537','2014-03-20','11:15:00',4.28),('8537','2014-03-20','11:20:00',4.43),('8537','2014-03-20','11:25:00',4.49),('8537','2014-03-20','11:30:00',4.6),('8537','2014-03-20','11:35:00',4.75),('8537','2014-03-20','11:40:00',4.66),('8537','2014-03-20','11:45:00',4.74),('8537','2014-03-20','11:50:00',4.7),('8537','2014-03-20','11:55:00',4.49),('8537','2014-03-20','12:00:00',4.15),('8537','2014-03-20','12:05:00',4.45),('8537','2014-03-20','12:10:00',4.65),('8537','2014-03-20','12:15:00',4.69),('8537','2014-03-20','12:20:00',4.54),('8537','2014-03-20','12:25:00',4.31),('8537','2014-03-20','12:30:00',4.48),('8537','2014-03-20','12:35:00',4.57),('8537','2014-03-20','12:40:00',4.54),('8537','2014-03-20','12:45:00',4.71),('8537','2014-03-20','12:50:00',4.68),('8537','2014-03-20','12:55:00',4.59),('8537','2014-03-20','13:00:00',4.6),('8537','2014-03-20','13:05:00',4.57),('8537','2014-03-20','13:10:00',4.44),('8537','2014-03-20','13:15:00',4.43),('8537','2014-03-20','13:20:00',4.47),('8537','2014-03-20','13:25:00',4.34),('8537','2014-03-20','13:30:00',4.38),('8537','2014-03-20','13:35:00',4.22),('8537','2014-03-20','13:40:00',3.92),('8537','2014-03-20','13:45:00',3.8),('8537','2014-03-20','13:50:00',3.66),('8537','2014-03-20','13:55:00',3.48),('8537','2014-03-20','14:00:00',3.52),('8537','2014-03-20','14:05:00',3.76),('8537','2014-03-20','14:10:00',3.69),('8537','2014-03-20','14:15:00',3.48),('8537','2014-03-20','14:20:00',3.45),('8537','2014-03-20','14:25:00',3.47),('8537','2014-03-20','14:30:00',2.97),('8537','2014-03-20','14:35:00',2.7),('8537','2014-03-20','14:40:00',3.02),('8537','2014-03-20','14:45:00',2.96),('8537','2014-03-20','14:50:00',2.86),('8537','2014-03-20','14:55:00',2.7),('8537','2014-03-20','15:00:00',2.44),('8537','2014-03-20','15:05:00',2.44),('8537','2014-03-20','15:10:00',2.45),('8537','2014-03-20','15:15:00',2.28),('8537','2014-03-20','15:20:00',2.44),('8537','2014-03-20','15:25:00',2.23),('8537','2014-03-20','15:30:00',2.12),('8537','2014-03-20','15:35:00',2),('8537','2014-03-20','15:40:00',1.85),('8537','2014-03-20','15:45:00',1.84),('8537','2014-03-20','15:50:00',1.61),('8537','2014-03-20','15:55:00',1.44),('8537','2014-03-20','16:00:00',1.21),('8537','2014-03-20','16:05:00',1.1),('8537','2014-03-20','16:10:00',1.15),('8537','2014-03-20','16:15:00',1.1),('8537','2014-03-20','16:20:00',1.13),('8537','2014-03-20','16:25:00',1.15),('8537','2014-03-20','16:30:00',1.04),('8537','2013-01-21','11:00:00',1.02),('8537','2013-01-21','11:10:00',1.25),('8537','2013-01-21','11:15:00',1.41),('8537','2013-01-21','11:20:00',1.13),('8537','2013-01-21','11:25:00',1.06),('8537','2013-01-21','11:50:00',1.45),('8537','2013-01-21','11:55:00',4.26),('8537','2013-01-21','12:00:00',3.81),('8537','2013-01-21','12:05:00',3.73),('8537','2013-01-21','12:10:00',3.76),('8537','2013-01-21','12:15:00',3),('8537','2013-01-21','12:25:00',1.73),('8537','2013-01-21','12:40:00',1.34),('8537','2013-01-21','12:50:00',1.41),('8537','2013-01-21','13:00:00',1.03),('8537','2013-01-21','13:05:00',2.24),('8537','2013-01-21','13:10:00',1.71),('8537','2013-01-21','13:15:00',1.08),('8537','2013-01-21','13:20:00',1.02),('8537','2013-01-21','13:30:00',3.57),('8537','2013-01-21','13:35:00',4.1),('8537','2013-01-21','13:40:00',3.42),('8537','2013-01-21','13:45:00',1.06),('8537','2013-01-21','13:50:00',2.19),('8537','2013-01-21','13:55:00',3.44),('8537','2013-01-21','14:00:00',3.32),('8537','2013-01-21','14:05:00',3.24),('8537','2013-01-21','14:10:00',3.04),('8537','2013-01-21','14:15:00',2.42),('8537','2013-01-21','14:20:00',2.5),('8537','2013-01-21','14:25:00',2.89),('8537','2013-01-21','14:30:00',1.55),('8537','2013-01-20','10:50:00',1.15),('8537','2013-01-20','10:55:00',1.28),('8537','2013-01-20','11:00:00',1.41),('8537','2013-01-20','11:05:00',1.39),('8537','2013-01-20','11:10:00',1.46),('8537','2013-01-20','11:15:00',2.03),('8537','2013-01-20','11:20:00',1.58),('8537','2013-01-20','11:25:00',2.19),('8537','2013-01-20','11:30:00',2.89),('8537','2013-01-20','11:35:00',2.14),('8537','2013-01-20','11:40:00',1.21),('8537','2013-01-20','11:45:00',1.14),('8537','2013-01-20','12:20:00',1.07),('8537','2013-01-20','12:25:00',1.11),('8537','2013-01-20','12:30:00',1.03),('8537','2013-01-20','13:40:00',1.04),('8537','2013-01-20','13:45:00',1.01),('8537','2013-01-19','09:10:00',1),('8537','2013-01-19','09:15:00',1.46),('8537','2013-01-19','09:20:00',1.42),('8537','2013-01-19','09:25:00',1.1),('8537','2013-01-19','09:50:00',1.26),('8537','2013-01-19','09:55:00',1.8),('8537','2013-01-19','10:00:00',1.59),('8537','2013-01-19','10:05:00',1.24),('8537','2013-01-19','10:35:00',1.05),('8537','2013-01-19','10:40:00',1.3),('8537','2013-01-19','10:45:00',1.52),('8537','2013-01-19','10:50:00',1.64),('8537','2013-01-19','11:10:00',1),('8537','2013-01-19','11:15:00',1.07),('8537','2013-01-19','11:20:00',1.3),('8537','2013-01-19','11:25:00',1.33),('8537','2013-01-18','10:15:00',2.85),('8537','2013-01-18','10:20:00',2.67),('8537','2013-01-18','10:25:00',1.93),('8537','2013-01-18','10:30:00',1.57),('8537','2013-01-18','10:35:00',1.23),('8537','2013-01-18','11:05:00',1.03),('8537','2013-01-18','11:10:00',1.04),('8537','2013-01-18','11:30:00',1.15),('8537','2013-01-18','11:35:00',1.39),('8537','2013-01-18','11:40:00',1.34),('8537','2013-01-18','11:45:00',1.11),('8537','2013-01-18','12:00:00',1.02),('8537','2013-01-18','12:05:00',1.02),('8537','2013-01-18','12:10:00',1.15),('8537','2013-01-18','12:15:00',1.17),('8537','2013-01-18','12:20:00',1.15),('8537','2013-01-18','12:25:00',1.19),('8537','2013-01-18','12:30:00',1.21),('8537','2013-01-18','12:35:00',1.47),('8537','2013-01-18','12:40:00',1.68),('8537','2013-01-18','12:45:00',1.77),('8537','2013-01-18','12:50:00',2.54),('8537','2013-01-18','12:55:00',2.38),('8537','2013-01-18','13:00:00',2.99),('8537','2013-01-18','13:05:00',2.65),('8537','2013-01-18','13:10:00',2.55),('8537','2013-01-18','13:15:00',2.8),('8537','2013-01-18','13:20:00',2.25),('8537','2013-01-18','13:25:00',1.84),('8537','2013-01-18','13:30:00',1.72),('8537','2013-01-18','13:35:00',1.93),('8537','2013-01-18','13:40:00',1.78),('8537','2013-01-18','13:45:00',2.15),('8537','2013-01-18','13:50:00',3.32),('8537','2013-01-18','13:55:00',3.71),('8537','2013-01-18','14:00:00',2.94),('8537','2013-01-18','14:05:00',2.38),('8537','2013-01-18','14:10:00',3.14),('8537','2013-01-18','14:15:00',2.02),('8537','2013-01-18','14:20:00',2.03),('8537','2013-01-18','14:25:00',1.66),('8537','2013-01-18','14:30:00',1.36),('8537','2013-01-18','14:35:00',1.15),('8537','2013-01-18','14:40:00',1.05),('8537','2013-01-18','14:45:00',1.13),('8537','2013-01-18','14:50:00',1.2),('8537','2013-01-18','14:55:00',1.01),('8537','2013-01-18','15:25:00',1.03),('8537','2013-01-17','09:45:00',1.22),('8537','2013-01-17','09:50:00',1.5),('8537','2013-01-17','09:55:00',1.4),('8537','2013-01-17','10:00:00',1.03),('8537','2013-01-17','10:05:00',1.1),('8537','2013-01-17','10:10:00',1.3),('8537','2013-01-17','10:15:00',1.54),('8537','2013-01-17','10:20:00',1.52),('8537','2013-01-17','10:25:00',1.96),('8537','2013-01-17','10:30:00',2.08),('8537','2013-01-17','10:35:00',1.91),('8537','2013-01-17','10:40:00',1.81),('8537','2013-01-17','10:45:00',1.96),('8537','2013-01-17','10:50:00',1.85),('8537','2013-01-17','10:55:00',2.21),('8537','2013-01-17','11:00:00',1.96),('8537','2013-01-17','11:05:00',1.93),('8537','2013-01-17','11:10:00',2.33),('8537','2013-01-17','11:15:00',2.28),('8537','2013-01-17','11:20:00',2.14),('8537','2013-01-17','11:25:00',1.84),('8537','2013-01-17','11:30:00',1.62),('8537','2013-01-17','11:35:00',1.85),('8537','2013-01-17','11:40:00',1.95),('8537','2013-01-17','11:45:00',1.74),('8537','2013-01-17','11:50:00',1.86),('8537','2013-01-17','11:55:00',2),('8537','2013-01-17','12:00:00',2.23),('8537','2013-01-17','12:05:00',2.22),('8537','2013-01-17','12:10:00',2.23),('8537','2013-01-17','12:15:00',2.58),('8537','2013-01-17','12:20:00',2.17),('8537','2013-01-17','12:25:00',1.85),('8537','2013-01-17','12:30:00',1.55),('8537','2013-01-17','12:35:00',1.93),('8537','2013-01-17','12:40:00',2.08),('8537','2013-01-17','12:45:00',1.64),('8537','2013-01-17','12:50:00',1.02),('8537','2013-01-17','12:55:00',1.03),('8537','2013-01-17','13:00:00',2.03),('8537','2013-01-17','13:05:00',1.88),('8537','2013-01-17','13:10:00',1.26),('8537','2013-01-17','13:15:00',1.8),('8537','2013-01-17','13:20:00',1.93),('8537','2013-01-17','13:25:00',1.65),('8537','2013-01-17','13:30:00',1.49),('8537','2013-01-17','13:35:00',1.94),('8537','2013-01-17','13:40:00',2.29),('8537','2013-01-17','13:45:00',2.28),('8537','2013-01-17','13:50:00',2.02),('8537','2013-01-17','13:55:00',1.03),('8537','2013-01-17','14:00:00',1.31),('8537','2013-01-17','14:05:00',1.15),('8537','2013-01-17','14:10:00',1.02),('8537','2013-01-17','14:25:00',1),('8537','2013-01-17','14:30:00',1.36),('8537','2013-01-17','14:35:00',1.81),('8537','2013-01-16','09:15:00',1.38),('8537','2013-01-16','09:20:00',1.08),('8537','2013-01-16','09:25:00',1.82),('8537','2013-01-16','09:30:00',1.95),('8537','2013-01-16','09:35:00',2.03),('8537','2013-01-16','09:40:00',2.11),('8537','2013-01-16','09:45:00',1.27),('8537','2013-01-16','09:55:00',1.12),('8537','2013-01-16','10:00:00',1.17),('8537','2013-01-16','10:35:00',2.35),('8537','2013-01-16','10:40:00',2.53),('8537','2013-01-16','10:45:00',2.94),('8537','2013-01-16','10:55:00',2.56),('8537','2013-01-16','11:25:00',1.97),('8537','2013-01-16','12:00:00',1.68),('8537','2013-01-16','12:05:00',1.48),('8537','2013-01-16','12:10:00',1.84),('8537','2013-01-16','12:15:00',4.44),('8537','2013-01-16','12:20:00',4.18),('8537','2013-01-16','12:25:00',1.58),('8537','2013-01-16','13:05:00',2.44),('8537','2013-01-16','13:10:00',4.55),('8537','2013-01-16','13:15:00',4.85),('8537','2013-01-16','13:20:00',3.57),('8537','2013-01-16','13:25:00',2.4),('8537','2013-01-16','13:55:00',3.16),('8537','2013-01-16','14:00:00',1.98),('8537','2013-01-16','14:05:00',1.79),('8537','2013-01-16','15:05:00',1.01),('8537','2013-01-15','09:55:00',1.14),('8537','2013-01-15','10:00:00',1.24),('8537','2013-01-15','10:10:00',1.18),('8537','2013-01-15','10:15:00',1.12),('8537','2013-01-15','10:20:00',1.17),('8537','2013-01-15','10:25:00',1.21),('8537','2013-01-15','10:40:00',1.12),('8537','2013-01-15','10:45:00',1.29),('8537','2013-01-15','10:50:00',1.63),('8537','2013-01-15','10:55:00',1.78),('8537','2013-01-15','11:00:00',1.69),('8537','2013-01-15','11:05:00',1.81),('8537','2013-01-15','11:10:00',1.85),('8537','2013-01-15','11:15:00',1.77),('8537','2013-01-15','11:20:00',1.87),('8537','2013-01-15','11:25:00',1.83),('8537','2013-01-15','11:30:00',1.75),('8537','2013-01-15','11:35:00',1.63),('8537','2013-01-15','11:40:00',1.45),('8537','2013-01-15','11:45:00',1.24),('8537','2013-01-15','11:50:00',1.15),('8537','2013-01-15','11:55:00',1.25),('8537','2013-01-15','12:00:00',1.19),('8537','2013-01-15','12:05:00',1.14),('8537','2013-01-15','12:10:00',1.09),('8537','2013-01-15','12:15:00',1.29),('8537','2013-01-15','12:20:00',1.5),('8537','2013-01-15','12:25:00',1.45),('8537','2013-01-15','12:30:00',1.34),('8537','2013-01-15','12:35:00',1.35),('8537','2013-01-15','12:40:00',1.54),('8537','2013-01-15','12:45:00',1.65),('8537','2013-01-15','12:50:00',1.53),('8537','2013-01-15','12:55:00',1.32),('8537','2013-01-15','13:00:00',1.06),('8537','2013-01-15','13:05:00',1.13),('8537','2013-01-15','13:10:00',1.13),('8537','2013-01-15','13:15:00',1.16),('8537','2013-01-15','13:20:00',1.17),('8537','2013-01-15','13:25:00',1.13),('8537','2013-01-15','13:30:00',1.25),('8537','2013-01-15','13:35:00',1.28),('8537','2013-01-15','13:40:00',1.5),('8537','2013-01-15','13:45:00',1.35),('8537','2013-01-15','13:50:00',1.34),('8537','2013-01-15','13:55:00',1.49),('8537','2013-01-15','14:00:00',2.31),('8537','2013-01-15','14:05:00',3.04),('8537','2013-01-15','14:10:00',2.92),('8537','2013-01-15','14:15:00',3.16),('8537','2013-01-15','14:20:00',3.21),('8537','2013-01-15','14:25:00',3.04),('8537','2013-01-15','14:30:00',1.4),('8537','2013-01-15','14:35:00',1.92),('8537','2013-01-15','14:40:00',1.84),('8537','2013-01-15','14:45:00',2.01),('8537','2013-01-15','14:50:00',1.93),('8537','2013-01-15','14:55:00',1.87),('8537','2013-01-15','15:00:00',1.89),('8537','2013-01-15','15:05:00',1.89),('8537','2013-01-15','15:10:00',1.51),('8537','2013-01-15','15:25:00',1.02),('8537','2013-01-15','15:30:00',1.02),('8537','2013-01-14','12:40:00',1.04),('8537','2013-01-14','12:45:00',1.15),('8537','2013-01-14','12:50:00',1.38),('8537','2013-01-14','12:55:00',1.31),('8537','2013-01-14','13:00:00',1.37),('8537','2013-01-14','13:05:00',1.34),('8537','2013-01-14','13:10:00',1.2),('8537','2013-01-14','13:15:00',1.02),('8537','2013-01-14','15:15:00',1.34),('8537','2013-01-14','15:20:00',1),('8537','2013-01-14','15:25:00',1.01),('8537','2013-01-13','09:15:00',1.79),('8537','2013-01-13','09:20:00',1.89),('8537','2013-01-13','09:25:00',1.84),('8537','2013-01-13','09:30:00',1.92),('8537','2013-01-13','09:35:00',1.96),('8537','2013-01-13','09:40:00',1.29),('8537','2013-01-13','09:50:00',1.6),('8537','2013-01-13','09:55:00',1.93),('8537','2013-01-13','10:00:00',2.02),('8537','2013-01-13','10:05:00',2.25),('8537','2013-01-13','10:10:00',1.52),('8537','2013-01-13','10:20:00',1.71),('8537','2013-01-13','10:25:00',1.55),('8537','2013-01-13','10:30:00',2.33),('8537','2013-01-13','10:35:00',1.12),('8537','2013-01-12','08:40:00',1.09),('8537','2013-01-12','08:45:00',1.15),('8537','2013-01-12','08:50:00',1.24),('8537','2013-01-12','08:55:00',1.3),('8537','2013-01-12','09:00:00',1.38),('8537','2013-01-12','09:05:00',1.46),('8537','2013-01-12','09:10:00',1.52),('8537','2013-01-12','09:15:00',1.59),('8537','2013-01-12','09:20:00',1.66),('8537','2013-01-12','09:25:00',1.72),('8537','2013-01-12','09:30:00',1.8),('8537','2013-01-12','09:35:00',1.78),('8537','2013-01-12','09:40:00',1.87),('8537','2013-01-12','09:45:00',1.96),('8537','2013-01-12','09:50:00',2.02),('8537','2013-01-12','09:55:00',2.08),('8537','2013-01-12','10:00:00',2.14),('8537','2013-01-12','10:05:00',2.22),('8537','2013-01-12','10:10:00',2.28),('8537','2013-01-12','10:15:00',2.37),('8537','2013-01-12','10:20:00',2.43),('8537','2013-01-12','10:25:00',2.56),('8537','2013-01-12','10:30:00',2.67),('8537','2013-01-12','10:35:00',2.75),('8537','2013-01-12','10:40:00',2.83),('8537','2013-01-12','10:45:00',2.92),('8537','2013-01-12','10:50:00',2.99),('8537','2013-01-12','10:55:00',3.08),('8537','2013-01-12','11:00:00',3.11),('8537','2013-01-12','11:05:00',3.11),('8537','2013-01-12','11:10:00',3.17),('8537','2013-01-12','11:15:00',3.25),('8537','2013-01-12','11:20:00',3.3),('8537','2013-01-12','11:25:00',3.3),('8537','2013-01-12','11:30:00',3.34),('8537','2013-01-12','11:35:00',3.37),('8537','2013-01-12','11:40:00',3.39),('8537','2013-01-12','11:45:00',3.42),('8537','2013-01-12','11:50:00',3.46),('8537','2013-01-12','11:55:00',3.47),('8537','2013-01-12','12:00:00',3.46),('8537','2013-01-12','12:05:00',3.45),('8537','2013-01-12','12:10:00',3.41),('8537','2013-01-12','12:15:00',3.45),('8537','2013-01-12','12:20:00',3.43),('8537','2013-01-12','12:25:00',3.34),('8537','2013-01-12','12:30:00',3.35),('8537','2013-01-12','12:35:00',2.55),('8537','2013-01-12','12:40:00',1.69),('8537','2013-01-12','12:50:00',3.2),('8537','2013-01-12','12:55:00',2.22),('8537','2013-01-12','13:00:00',3.09),('8537','2013-01-12','13:05:00',3.16),('8537','2013-01-12','13:10:00',2.44),('8537','2013-01-12','13:15:00',1.74),('8537','2013-01-12','13:20:00',1.17),('8537','2013-01-12','13:25:00',2.61),('8537','2013-01-12','13:30:00',2.86),('8537','2013-01-12','13:35:00',2.84),('8537','2013-01-12','13:40:00',1.41),('8537','2013-01-12','13:45:00',1.82),('8537','2013-01-12','13:50:00',2.27),('8537','2013-01-12','13:55:00',2.95),('8537','2013-01-12','14:00:00',1.67),('8537','2013-01-12','14:05:00',2.34),('8537','2013-01-12','14:10:00',2.54),('8537','2013-01-12','14:15:00',2.38),('8537','2013-01-12','14:20:00',2.09),('8537','2013-01-12','14:25:00',2.03),('8537','2013-01-12','14:30:00',1.92),('8537','2013-01-12','14:35:00',1.9),('8537','2013-01-12','14:40:00',1.85),('8537','2013-01-12','14:45:00',1.75),('8537','2013-01-12','14:50:00',1.69),('8537','2013-01-12','14:55:00',1.66),('8537','2013-01-12','15:00:00',1.59),('8537','2013-01-12','15:05:00',1.49),('8537','2013-01-12','15:10:00',1.36),('8537','2013-01-12','15:15:00',1.15),('8537','2013-01-12','15:20:00',1.22),('8537','2013-01-12','15:25:00',1.14),('8537','2014-03-19','08:50:00',1.02),('8537','2014-03-19','08:55:00',1.13),('8537','2014-03-19','09:00:00',1.23),('8537','2014-03-19','09:05:00',1.39),('8537','2014-03-19','09:10:00',1.62),('8537','2014-03-19','09:15:00',1.82),('8537','2014-03-19','09:20:00',1.78),('8537','2014-03-19','09:25:00',2.58),('8537','2014-03-19','09:30:00',2.45),('8537','2014-03-19','09:35:00',2.69),('8537','2014-03-19','09:40:00',3.71),('8537','2014-03-19','09:45:00',4.12),('8537','2014-03-19','09:50:00',4.1),('8537','2014-03-19','09:55:00',2.9),('8537','2014-03-19','10:00:00',1.78),('8537','2014-03-19','10:05:00',1.37),('8537','2014-03-19','10:10:00',1.18),('8537','2014-03-19','10:15:00',1),('8537','2014-03-19','10:20:00',1.11),('8537','2014-03-19','10:25:00',1.15),('8537','2014-03-19','10:30:00',1.37),('8537','2014-03-19','10:35:00',2),('8537','2014-03-19','10:40:00',3.21),('8537','2014-03-19','10:45:00',3.99),('8537','2014-03-19','10:50:00',2.7),('8537','2014-03-19','10:55:00',1.74),('8537','2014-03-19','11:00:00',1.64),('8537','2014-03-19','11:05:00',4.38),('8537','2014-03-19','11:10:00',3.53),('8537','2014-03-19','11:15:00',2.06),('8537','2014-03-19','11:20:00',2.11),('8537','2014-03-19','11:25:00',2.31),('8537','2014-03-19','11:30:00',2.43),('8537','2014-03-19','11:35:00',2.56),('8537','2014-03-19','11:40:00',2.17),('8537','2014-03-19','11:45:00',2.18),('8537','2014-03-19','11:50:00',1.96),('8537','2014-03-19','11:55:00',1.91),('8537','2014-03-19','12:00:00',4.19),('8537','2014-03-19','12:05:00',4.94),('8537','2014-03-19','12:10:00',5.07),('8537','2014-03-19','12:15:00',5),('8537','2014-03-19','12:20:00',5.13),('8537','2014-03-19','12:25:00',4.87),('8537','2014-03-19','12:30:00',4.82),('8537','2014-03-19','12:35:00',4.65),('8537','2014-03-19','12:40:00',4.89),('8537','2014-03-19','12:45:00',4.66),('8537','2014-03-19','12:50:00',4.6),('8537','2014-03-19','12:55:00',3.09),('8537','2014-03-19','13:00:00',4.74),('8537','2014-03-19','13:05:00',4.52),('8537','2014-03-19','13:10:00',4.6),('8537','2014-03-19','13:15:00',4.52),('8537','2014-03-19','13:20:00',2.81),('8537','2014-03-19','13:25:00',3.13),('8537','2014-03-19','13:30:00',4.35),('8537','2014-03-19','13:35:00',4.26),('8537','2014-03-19','13:40:00',4.34),('8537','2014-03-19','13:45:00',4.29),('8537','2014-03-19','13:50:00',4.2),('8537','2014-03-19','13:55:00',3.81),('8537','2014-03-19','14:00:00',4.04),('8537','2014-03-19','14:05:00',4.04),('8537','2014-03-19','14:10:00',3.99),('8537','2014-03-19','14:15:00',3.8),('8537','2014-03-19','14:20:00',3.77),('8537','2014-03-19','14:25:00',3.53),('8537','2014-03-19','14:30:00',3.12),('8537','2014-03-19','14:35:00',3.51),('8537','2014-03-19','14:40:00',3.56),('8537','2014-03-19','14:45:00',3.48),('8537','2014-03-19','14:50:00',3.36),('8537','2014-03-19','14:55:00',3.32),('8537','2014-03-19','15:00:00',3.16),('8537','2014-03-19','15:05:00',3.11),('8537','2014-03-19','15:10:00',3.06),('8537','2014-03-19','15:15:00',3.02),('8537','2014-03-19','15:20:00',2.9),('8537','2014-03-19','15:25:00',2.84),('8537','2014-03-19','15:30:00',2.71),('8537','2014-03-19','15:35:00',2.53),('8537','2014-03-19','15:40:00',2.55),('8537','2014-03-19','15:45:00',2.47),('8537','2014-03-19','15:50:00',2.31),('8537','2014-03-19','15:55:00',2.22),('8537','2014-03-19','16:00:00',2.1),('8537','2014-03-19','16:05:00',2.02),('8537','2014-03-19','16:10:00',1.92),('8537','2014-03-19','16:15:00',1.79),('8537','2014-03-19','16:20:00',1.64),('8537','2014-03-19','16:25:00',1.5),('8537','2014-03-19','16:30:00',1.41),('8537','2014-03-19','16:35:00',1.24),('8537','2014-03-19','16:40:00',1.14),('8537','2014-03-19','16:45:00',1.08),('8537','2013-01-11','09:45:00',1.09),('8537','2013-01-11','10:00:00',1.49),('8537','2013-01-11','10:05:00',1.8),('8537','2013-01-11','10:10:00',1.57),('8537','2013-01-11','10:15:00',1.81),('8537','2013-01-11','10:20:00',1.4),('8537','2013-01-11','10:25:00',2.5),('8537','2013-01-11','10:30:00',2.61),('8537','2013-01-11','10:35:00',2.7),('8537','2013-01-11','10:40:00',2.76),('8537','2013-01-11','10:45:00',2.84),('8537','2013-01-11','10:50:00',2.88),('8537','2013-01-11','10:55:00',2.98),('8537','2013-01-11','11:00:00',3.02),('8537','2013-01-11','11:05:00',3.07),('8537','2013-01-11','11:10:00',3.02),('8537','2013-01-11','11:15:00',3.05),('8537','2013-01-11','11:20:00',3),('8537','2013-01-11','11:25:00',2.21),('8537','2013-01-11','11:30:00',1.37),('8537','2013-01-11','11:35:00',1.83),('8537','2013-01-11','11:40:00',1.68),('8537','2013-01-11','11:45:00',1.83),('8537','2013-01-11','11:50:00',1.71),('8537','2013-01-11','11:55:00',1.39),('8537','2013-01-11','12:00:00',1.12),('8537','2013-01-11','12:55:00',2.23),('8537','2013-01-11','13:00:00',1.61),('8537','2013-01-11','13:05:00',1.59),('8537','2013-01-11','13:10:00',2.24),('8537','2013-01-11','13:15:00',1.32),('8537','2013-01-11','13:20:00',1.02),('8537','2013-01-11','13:30:00',1.27),('8537','2013-01-11','13:35:00',2.88),('8537','2013-01-11','13:40:00',1.95),('8537','2013-01-11','13:45:00',1.7),('8537','2013-01-11','14:20:00',1.63),('8537','2013-01-11','14:25:00',1.47),('8537','2013-01-11','14:45:00',1.47),('8537','2013-01-11','14:50:00',1.69),('8537','2013-01-11','14:55:00',1.13),('8537','2013-01-11','15:00:00',1.51),('8537','2013-01-11','15:05:00',1.64),('8537','2013-01-10','11:30:00',1.15),('8537','2013-01-10','11:55:00',1.39),('8537','2013-01-10','12:00:00',1.42),('8537','2013-01-10','12:05:00',1.4),('8537','2013-01-10','12:10:00',1.24),('8537','2013-01-09','10:30:00',1.02),('8537','2013-01-09','10:35:00',1.08),('8537','2013-01-09','10:40:00',1.35),('8537','2013-01-09','10:45:00',1.66),('8537','2013-01-09','10:50:00',1.25),('8537','2013-01-09','10:55:00',1.87),('8537','2013-01-09','11:00:00',1.16),('8537','2013-01-09','11:05:00',1.23),('8537','2013-01-09','11:10:00',1.5),('8537','2013-01-09','11:15:00',2.5),('8537','2013-01-09','11:20:00',2.05),('8537','2013-01-09','11:25:00',1.41),('8537','2013-01-09','11:30:00',1.47),('8537','2013-01-09','11:35:00',1.43),('8537','2013-01-09','11:40:00',1.4),('8537','2013-01-09','11:45:00',1.29),('8537','2013-01-09','11:50:00',1.47),('8537','2013-01-09','11:55:00',1.55),('8537','2013-01-09','12:00:00',1.69),('8537','2013-01-09','12:05:00',1.39),('8537','2013-01-09','12:10:00',1.34),('8537','2013-01-09','12:15:00',1.3),('8537','2013-01-09','12:20:00',1.31),('8537','2013-01-09','12:25:00',1.2),('8537','2013-01-09','12:30:00',1.12),('8537','2013-01-09','12:35:00',1.19),('8537','2013-01-09','12:40:00',1.17),('8537','2013-01-09','12:45:00',1.12),('8537','2013-01-09','12:50:00',1.17),('8537','2013-01-09','12:55:00',1.31),('8537','2013-01-09','13:00:00',1.42),('8537','2013-01-09','13:05:00',2.03),('8537','2013-01-09','13:10:00',2.38),('8537','2013-01-09','13:15:00',1.45),('8537','2013-01-09','13:20:00',1.26),('8537','2013-01-09','13:25:00',1.1),('8537','2013-01-09','13:45:00',1.01),('8537','2013-01-08','08:35:00',1.11),('8537','2013-01-08','08:40:00',1.33),('8537','2013-01-08','08:45:00',1.42),('8537','2013-01-08','08:50:00',1.5),('8537','2013-01-08','08:55:00',1.59),('8537','2013-01-08','09:00:00',1.71),('8537','2013-01-08','09:05:00',1.72),('8537','2013-01-08','09:10:00',1.08),('8537','2013-01-08','09:15:00',1.44),('8537','2013-01-08','09:20:00',1.73),('8537','2013-01-08','09:25:00',1.84),('8537','2013-01-08','09:30:00',1.61),('8537','2013-01-08','09:35:00',1.32),('8537','2013-01-08','09:40:00',1.96),('8537','2013-01-08','09:45:00',2.21),('8537','2013-01-08','09:50:00',2.32),('8537','2013-01-08','09:55:00',2.26),('8537','2013-01-08','10:00:00',2.1),('8537','2013-01-08','10:05:00',2.02),('8537','2013-01-08','10:10:00',2.09),('8537','2013-01-08','10:15:00',2.19),('8537','2013-01-08','10:20:00',2.07),('8537','2013-01-08','10:25:00',2.29),('8537','2013-01-08','10:30:00',2.31),('8537','2013-01-08','10:35:00',2.55),('8537','2013-01-08','10:40:00',2.78),('8537','2013-01-08','10:45:00',2.78),('8537','2013-01-08','10:50:00',2.82),('8537','2013-01-08','10:55:00',2.91),('8537','2013-01-08','11:00:00',2.9),('8537','2013-01-08','11:05:00',3.05),('8537','2013-01-08','11:10:00',3.09),('8537','2013-01-08','11:15:00',3.13),('8537','2013-01-08','11:20:00',3.16),('8537','2013-01-08','11:25:00',3.2),('8537','2013-01-08','11:30:00',3.24),('8537','2013-01-08','11:35:00',3.26),('8537','2013-01-08','11:40:00',3.22),('8537','2013-01-08','11:45:00',3.8),('8537','2013-01-08','11:50:00',2.82),('8537','2013-01-08','11:55:00',2.13),('8537','2013-01-08','12:00:00',1.87),('8537','2013-01-08','12:05:00',1.78),('8537','2013-01-08','12:10:00',1.87),('8537','2013-01-08','12:15:00',1.72),('8537','2013-01-08','12:20:00',1.52),('8537','2013-01-08','12:25:00',1.49),('8537','2013-01-08','12:30:00',1.43),('8537','2013-01-08','12:35:00',1.41),('8537','2013-01-08','12:40:00',1.83),('8537','2013-01-08','12:45:00',2.27),('8537','2013-01-08','12:50:00',2.97),('8537','2013-01-08','12:55:00',2.11),('8537','2013-01-08','13:20:00',1.53),('8537','2013-01-08','13:25:00',1.14),('8537','2013-01-08','13:40:00',1.04),('8537','2013-01-08','13:45:00',1.29),('8537','2013-01-08','13:50:00',1.53),('8537','2013-01-08','13:55:00',1.65),('8537','2013-01-08','14:00:00',1.23),('8537','2013-01-08','14:05:00',1.63),('8537','2013-01-08','14:30:00',1.06),('8537','2013-01-08','14:35:00',1.05),('8537','2013-01-08','14:40:00',1.16),('8537','2013-01-07','08:45:00',1.05),('8537','2013-01-07','08:50:00',1.16),('8537','2013-01-07','08:55:00',1.24),('8537','2013-01-07','09:00:00',1.28),('8537','2013-01-07','09:05:00',1.15),('8537','2013-01-07','09:10:00',1.16),('8537','2013-01-07','09:20:00',1.52),('8537','2013-01-07','09:25:00',1.69),('8537','2013-01-07','09:30:00',1.72),('8537','2013-01-07','09:35:00',1.71),('8537','2013-01-07','09:40:00',1.74),('8537','2013-01-07','09:45:00',1.92),('8537','2013-01-07','09:50:00',1.96),('8537','2013-01-07','09:55:00',2.02),('8537','2013-01-07','10:00:00',2.09),('8537','2013-01-07','10:05:00',2.2),('8537','2013-01-07','10:10:00',2.26),('8537','2013-01-07','10:15:00',2.34),('8537','2013-01-07','10:20:00',2.35),('8537','2013-01-07','10:25:00',2.4),('8537','2013-01-07','10:30:00',2.5),('8537','2013-01-07','10:35:00',2.56),('8537','2013-01-07','10:40:00',2.65),('8537','2013-01-07','10:45:00',2.74),('8537','2013-01-07','10:50:00',2.75),('8537','2013-01-07','10:55:00',2.79),('8537','2013-01-07','11:00:00',2.86),('8537','2013-01-07','11:05:00',2.89),('8537','2013-01-07','11:10:00',2.98),('8537','2013-01-07','11:15:00',3.08),('8537','2013-01-07','11:20:00',3.09),('8537','2013-01-07','11:25:00',3.18),('8537','2013-01-07','11:30:00',3.17),('8537','2013-01-07','11:35:00',3.22),('8537','2013-01-07','11:40:00',3.22),('8537','2013-01-07','11:45:00',3.25),('8537','2013-01-07','11:50:00',3.28),('8537','2013-01-07','11:55:00',3.32),('8537','2013-01-07','12:00:00',3.34),('8537','2013-01-07','12:05:00',3.34),('8537','2013-01-07','12:10:00',3.34),('8537','2013-01-07','12:15:00',3.36),('8537','2013-01-07','12:20:00',3.33),('8537','2013-01-07','12:25:00',3.33),('8537','2013-01-07','12:30:00',3.31),('8537','2013-01-07','12:35:00',3.27),('8537','2013-01-07','12:40:00',3.24),('8537','2013-01-07','12:45:00',3.2),('8537','2013-01-07','12:50:00',3.17),('8537','2013-01-07','12:55:00',3.12),('8537','2013-01-07','13:00:00',3.09),('8537','2013-01-07','13:05:00',3.05),('8537','2013-01-07','13:10:00',2.98),('8537','2013-01-07','13:15:00',2.9),('8537','2013-01-07','13:20:00',2.83),('8537','2013-01-07','13:25:00',2.78),('8537','2013-01-07','13:30:00',2.73),('8537','2013-01-07','13:35:00',2.64),('8537','2013-01-07','13:40:00',2.56),('8537','2013-01-07','13:45:00',2.48),('8537','2013-01-07','13:50:00',2.38),('8537','2013-01-07','13:55:00',2.29),('8537','2013-01-07','14:00:00',2.23),('8537','2013-01-07','14:05:00',2.11),('8537','2013-01-07','14:10:00',2.01),('8537','2013-01-07','14:15:00',2.06),('8537','2013-01-07','14:20:00',2.07),('8537','2013-01-07','14:25:00',2),('8537','2013-01-07','14:30:00',1.93),('8537','2013-01-07','14:35:00',1.88),('8537','2013-01-07','14:40:00',1.83),('8537','2013-01-07','14:45:00',1.74),('8537','2013-01-07','14:50:00',1.71),('8537','2013-01-07','14:55:00',1.62),('8537','2013-01-07','15:00:00',1.53),('8537','2013-01-07','15:05:00',1.49),('8537','2013-01-07','15:10:00',1.39),('8537','2013-01-07','15:15:00',1.31),('8537','2013-01-07','15:20:00',1.29),('8537','2013-01-07','15:25:00',1.13),('8537','2013-01-07','15:30:00',1.14),('8537','2013-01-07','15:35:00',1.11),('8537','2013-01-07','15:40:00',1.01),('8537','2013-01-06','08:40:00',1.07),('8537','2013-01-06','08:45:00',1.15),('8537','2013-01-06','08:50:00',1.24),('8537','2013-01-06','08:55:00',1.29),('8537','2013-01-06','09:00:00',1.39),('8537','2013-01-06','09:05:00',1.46),('8537','2013-01-06','09:10:00',1.54),('8537','2013-01-06','09:15:00',1.63),('8537','2013-01-06','09:20:00',1.68),('8537','2013-01-06','09:25:00',1.74),('8537','2013-01-06','09:30:00',1.79),('8537','2013-01-06','09:35:00',1.76),('8537','2013-01-06','09:40:00',1.86),('8537','2013-01-06','09:45:00',1.98),('8537','2013-01-06','09:50:00',2.06),('8537','2013-01-06','09:55:00',2.1),('8537','2013-01-06','10:00:00',2.18),('8537','2013-01-06','10:05:00',2.23),('8537','2013-01-06','10:10:00',2.29),('8537','2013-01-06','10:15:00',2.32),('8537','2013-01-06','10:20:00',2.34),('8537','2013-01-06','10:25:00',2.42),('8537','2013-01-06','10:30:00',2.51),('8537','2013-01-06','10:35:00',2.61),('8537','2013-01-06','10:40:00',2.69),('8537','2013-01-06','10:45:00',2.77),('8537','2013-01-06','10:50:00',2.84),('8537','2013-01-06','10:55:00',2.9),('8537','2013-01-06','11:00:00',2.36),('8537','2013-01-06','11:05:00',2.99),('8537','2013-01-06','11:10:00',3.02),('8537','2013-01-06','11:15:00',3.08),('8537','2013-01-06','11:20:00',3.11),('8537','2013-01-06','11:25:00',3.17),('8537','2013-01-06','11:30:00',3.22),('8537','2013-01-06','11:35:00',3.24),('8537','2013-01-06','11:40:00',3.25),('8537','2013-01-06','11:45:00',3.27),('8537','2013-01-06','11:50:00',3.29),('8537','2013-01-06','11:55:00',3.32),('8537','2013-01-06','12:00:00',3.32),('8537','2013-01-06','12:05:00',3.34),('8537','2013-01-06','12:10:00',3.33),('8537','2013-01-06','12:15:00',3.3),('8537','2013-01-06','12:20:00',3.29),('8537','2013-01-06','12:25:00',3.17),('8537','2013-01-06','12:30:00',3.22),('8537','2013-01-06','12:35:00',3.15),('8537','2013-01-06','12:40:00',3.13),('8537','2013-01-06','12:45:00',3.15),('8537','2013-01-06','12:50:00',3.14),('8537','2013-01-06','12:55:00',3.14),('8537','2013-01-06','13:00:00',3.13),('8537','2013-01-06','13:05:00',3.06),('8537','2013-01-06','13:10:00',3.01),('8537','2013-01-06','13:15:00',2.94),('8537','2013-01-06','13:20:00',2.9),('8537','2013-01-06','13:25:00',2.83),('8537','2013-01-06','13:30:00',2.76),('8537','2013-01-06','13:35:00',2.69),('8537','2013-01-06','13:40:00',2.6),('8537','2013-01-06','13:45:00',2.52),('8537','2013-01-06','13:50:00',2.4),('8537','2013-01-06','13:55:00',2.31),('8537','2013-01-06','14:00:00',2.29),('8537','2013-01-06','14:05:00',2.26),('8537','2013-01-06','14:10:00',2.04),('8537','2013-01-06','14:15:00',1.85),('8537','2013-01-06','14:20:00',1.97),('8537','2013-01-06','14:25:00',1.89),('8537','2013-01-06','14:30:00',1.9),('8537','2013-01-06','14:35:00',1.83),('8537','2013-01-06','14:40:00',1.74),('8537','2013-01-06','14:45:00',1.68),('8537','2013-01-06','14:50:00',1.62),('8537','2013-01-06','14:55:00',1.55),('8537','2013-01-06','15:00:00',1.49),('8537','2013-01-06','15:05:00',1.38),('8537','2013-01-06','15:10:00',1.3),('8537','2013-01-06','15:15:00',1.25),('8537','2013-01-06','15:20:00',1.16),('8537','2013-01-06','15:25:00',1),('8537','2013-01-05','10:05:00',1.14),('8537','2013-01-05','10:10:00',1.28),('8537','2013-01-05','10:15:00',1.36),('8537','2013-01-05','10:20:00',1.24),('8537','2013-01-05','10:25:00',1.08),('8537','2013-01-05','10:30:00',1.11),('8537','2013-01-05','10:35:00',1.27),('8537','2013-01-05','10:40:00',1.35),('8537','2013-01-05','10:45:00',1.33),('8537','2013-01-05','10:50:00',1.55),('8537','2013-01-05','10:55:00',2.54),('8537','2013-01-05','11:00:00',2.17),('8537','2013-01-05','11:05:00',2.49),('8537','2013-01-05','11:10:00',2.48),('8537','2013-01-05','11:15:00',2.08),('8537','2013-01-05','11:20:00',2.78),('8537','2013-01-05','11:25:00',2.92),('8537','2013-01-05','11:30:00',2.95),('8537','2013-01-05','11:35:00',2.75),('8537','2013-01-05','11:40:00',2.49),('8537','2013-01-05','11:45:00',2.51),('8537','2013-01-05','11:50:00',2.18),('8537','2013-01-05','11:55:00',1.98),('8537','2013-01-05','12:00:00',1.84),('8537','2013-01-05','12:05:00',1.81),('8537','2013-01-05','12:10:00',1.79),('8537','2013-01-05','12:15:00',1.8),('8537','2013-01-05','12:20:00',1.63),('8537','2013-01-05','12:25:00',1.38),('8537','2013-01-05','12:30:00',1.43),('8537','2013-01-05','12:35:00',1.96),('8537','2013-01-05','12:40:00',2.4),('8537','2013-01-05','12:45:00',2.73),('8537','2013-01-05','12:50:00',1.71),('8537','2013-01-05','12:55:00',1.42),('8537','2013-01-05','13:00:00',1.5),('8537','2013-01-05','13:05:00',1.39),('8537','2013-01-05','13:10:00',1.34),('8537','2013-01-05','13:15:00',1.23),('8537','2013-01-05','13:20:00',1.22),('8537','2013-01-05','13:25:00',1.25),('8537','2013-01-05','13:30:00',2.12),('8537','2013-01-05','13:35:00',1.87),('8537','2013-01-05','13:40:00',1.34),('8537','2013-01-05','13:45:00',1.09),('8537','2013-01-05','13:50:00',1.21),('8537','2013-01-05','13:55:00',1.35),('8537','2013-01-05','14:00:00',1.26),('8537','2013-01-05','14:05:00',1.87),('8537','2013-01-05','14:10:00',1.72),('8537','2013-01-05','14:15:00',1.32),('8537','2013-01-05','14:20:00',1.18),('8537','2013-01-05','14:30:00',1.29),('8537','2013-01-05','14:35:00',1.28),('8537','2013-01-05','14:40:00',1.36),('8537','2013-01-05','14:45:00',1.41),('8537','2013-01-05','15:00:00',1.23),('8537','2013-01-05','15:05:00',1),('8537','2013-01-04','08:45:00',1.15),('8537','2013-01-04','08:50:00',1.25),('8537','2013-01-04','08:55:00',1.22),('8537','2013-01-04','09:00:00',1.27),('8537','2013-01-04','09:05:00',1.36),('8537','2013-01-04','09:10:00',1.44),('8537','2013-01-04','09:15:00',1.12),('8537','2013-01-04','09:20:00',1.45),('8537','2013-01-04','09:25:00',1.32),('8537','2013-01-04','09:30:00',1.31),('8537','2013-01-04','09:35:00',1.21),('8537','2013-01-04','09:40:00',1.3),('8537','2013-01-04','09:45:00',1.32),('8537','2013-01-04','09:50:00',1.43),('8537','2013-01-04','09:55:00',1.83),('8537','2013-01-04','10:00:00',2.24),('8537','2013-01-04','10:05:00',2.29),('8537','2013-01-04','10:10:00',1.96),('8537','2013-01-04','10:15:00',2.3),('8537','2013-01-04','10:20:00',1.97),('8537','2013-01-04','10:25:00',2.31),('8537','2013-01-04','10:30:00',2.47),('8537','2013-01-04','10:35:00',2.57),('8537','2013-01-04','10:40:00',2.67),('8537','2013-01-04','10:45:00',2.87),('8537','2013-01-04','10:50:00',3.06),('8537','2013-01-04','10:55:00',3.2),('8537','2013-01-04','11:00:00',2.83),('8537','2013-01-04','11:05:00',1.71),('8537','2013-01-04','11:10:00',1.08),('8537','2013-01-04','11:15:00',1.17),('8537','2013-01-04','11:20:00',1.37),('8537','2013-01-04','11:25:00',1.06),('8537','2013-01-04','11:30:00',1.09),('8537','2013-01-04','11:35:00',1.61),('8537','2013-01-04','11:40:00',1.31),('8537','2013-01-04','11:45:00',1.94),('8537','2013-01-04','11:50:00',3.07),('8537','2013-01-04','11:55:00',3.72),('8537','2013-01-04','12:00:00',3.71),('8537','2013-01-04','12:05:00',3.18),('8537','2013-01-04','12:10:00',2.51),('8537','2013-01-04','12:15:00',1.66),('8537','2013-01-04','12:20:00',1.31),('8537','2013-01-04','12:25:00',1.52),('8537','2013-01-04','12:30:00',2.32),('8537','2013-01-04','12:35:00',2.13),('8537','2013-01-04','12:40:00',3.15),('8537','2013-01-04','12:45:00',3.24),('8537','2013-01-04','12:50:00',3.27),('8537','2013-01-04','12:55:00',3.19),('8537','2013-01-04','13:00:00',3.06),('8537','2013-01-04','13:05:00',2.92),('8537','2013-01-04','13:10:00',2.81),('8537','2013-01-04','13:15:00',2.43),('8537','2013-01-04','13:20:00',2.7),('8537','2013-01-04','13:25:00',2.59),('8537','2013-01-04','13:30:00',2.52),('8537','2013-01-04','13:35:00',2.41),('8537','2013-01-04','13:40:00',2.33),('8537','2013-01-04','13:45:00',2.24),('8537','2013-01-04','13:50:00',2.2),('8537','2013-01-04','13:55:00',2.1),('8537','2013-01-04','14:00:00',2.06),('8537','2013-01-04','14:05:00',2.04),('8537','2013-01-04','14:10:00',1.97),('8537','2013-01-04','14:15:00',1.92),('8537','2013-01-04','14:20:00',1.9),('8537','2013-01-04','14:25:00',1.85),('8537','2013-01-04','14:30:00',1.79),('8537','2013-01-04','14:35:00',1.75),('8537','2013-01-04','14:40:00',1.69),('8537','2013-01-04','14:45:00',1.58),('8537','2013-01-04','14:50:00',1.52),('8537','2013-01-04','14:55:00',1.48),('8537','2013-01-04','15:00:00',1.43),('8537','2013-01-04','15:05:00',1.31),('8537','2013-01-04','15:10:00',1.13),('8537','2013-01-04','15:15:00',1.16),('8537','2013-01-04','15:20:00',1.05),('8537','2013-01-03','08:40:00',1.02),('8537','2013-01-03','08:45:00',1.09),('8537','2013-01-03','08:50:00',1.16),('8537','2013-01-03','08:55:00',1.21),('8537','2013-01-03','09:00:00',1.33),('8537','2013-01-03','09:05:00',1.42),('8537','2013-01-03','09:10:00',1.52),('8537','2013-01-03','09:15:00',1.6),('8537','2013-01-03','09:20:00',1.68),('8537','2013-01-03','09:25:00',1.75),('8537','2013-01-03','09:30:00',1.77),('8537','2013-01-03','09:35:00',1.75),('8537','2013-01-03','09:40:00',1.87),('8537','2013-01-03','09:45:00',2.14),('8537','2013-01-03','09:50:00',2.31),('8537','2013-01-03','09:55:00',2.46),('8537','2013-01-03','10:00:00',2.55),('8537','2013-01-03','10:05:00',2.61),('8537','2013-01-03','10:10:00',2.63),('8537','2013-01-03','10:15:00',2.9),('8537','2013-01-03','10:20:00',2.47),('8537','2013-01-03','10:25:00',2.7),('8537','2013-01-03','10:30:00',2.29),('8537','2013-01-03','10:35:00',2.24),('8537','2013-01-03','10:40:00',2.15),('8537','2013-01-03','10:45:00',1.94),('8537','2013-01-03','10:50:00',1.96),('8537','2013-01-03','10:55:00',1.82),('8537','2013-01-03','11:00:00',2),('8537','2013-01-03','11:05:00',1.91),('8537','2013-01-03','11:10:00',1.82),('8537','2013-01-03','11:15:00',1.74),('8537','2013-01-03','11:20:00',1.55),('8537','2013-01-03','11:25:00',1.37),('8537','2013-01-03','11:30:00',1.33),('8537','2013-01-03','11:35:00',2.26),('8537','2013-01-03','11:40:00',3.45),('8537','2013-01-03','11:45:00',3.35),('8537','2013-01-03','11:50:00',3.32),('8537','2013-01-03','11:55:00',3.3),('8537','2013-01-03','12:00:00',3.28),('8537','2013-01-03','12:05:00',3.28),('8537','2013-01-03','12:10:00',3.28),('8537','2013-01-03','12:15:00',3.26),('8537','2013-01-03','12:20:00',3.28),('8537','2013-01-03','12:25:00',3.26),('8537','2013-01-03','12:30:00',3.23),('8537','2013-01-03','12:35:00',3.21),('8537','2013-01-03','12:40:00',3.17),('8537','2013-01-03','12:45:00',3.15),('8537','2013-01-03','12:50:00',3.1),('8537','2013-01-03','12:55:00',3.05),('8537','2013-01-03','13:00:00',2.97),('8537','2013-01-03','13:05:00',2.96),('8537','2013-01-03','13:10:00',2.91),('8537','2013-01-03','13:15:00',2.84),('8537','2013-01-03','13:20:00',2.77),('8537','2013-01-03','13:25:00',2.71),('8537','2013-01-03','13:30:00',2.62),('8537','2013-01-03','13:35:00',2.56),('8537','2013-01-03','13:40:00',2.47),('8537','2013-01-03','13:45:00',2.39),('8537','2013-01-03','13:50:00',2.29),('8537','2013-01-03','13:55:00',2.21),('8537','2013-01-03','14:00:00',2.15),('8537','2013-01-03','14:05:00',2.2),('8537','2013-01-03','14:10:00',2.16),('8537','2013-01-03','14:15:00',2.13),('8537','2013-01-03','14:20:00',2.06),('8537','2013-01-03','14:25:00',2.01),('8537','2013-01-03','14:30:00',1.95),('8537','2013-01-03','14:35:00',1.89),('8537','2013-01-03','14:40:00',1.82),('8537','2013-01-03','14:45:00',1.74),('8537','2013-01-03','14:50:00',1.71),('8537','2013-01-03','14:55:00',1.64),('8537','2013-01-03','15:00:00',1.56),('8537','2013-01-03','15:05:00',1.47),('8537','2013-01-03','15:10:00',1.33),('8537','2013-01-03','15:15:00',1.24),('8537','2013-01-03','15:20:00',1.07),('8537','2013-01-02','13:40:00',1.05),('8537','2013-01-02','13:45:00',1.03),('8537','2013-01-02','13:50:00',1.01),('8537','2014-03-18','07:50:00',1.19),('8537','2014-03-18','07:55:00',1.79),('8537','2014-03-18','08:00:00',1.36),('8537','2014-03-18','08:10:00',1.07),('8537','2014-03-18','08:15:00',1.11),('8537','2014-03-18','08:20:00',1.53),('8537','2014-03-18','08:25:00',1.26),('8537','2014-03-18','08:30:00',1.13),('8537','2014-03-18','08:45:00',1.01),('8537','2014-03-18','08:50:00',1.51),('8537','2014-03-18','08:55:00',3.07),('8537','2014-03-18','09:00:00',2.54),('8537','2014-03-18','09:05:00',1.75),('8537','2014-03-18','09:10:00',1.71),('8537','2014-03-18','09:15:00',3.16),('8537','2014-03-18','09:20:00',3.91),('8537','2014-03-18','09:25:00',2.98),('8537','2014-03-18','09:30:00',1.52),('8537','2014-03-18','09:35:00',2.01),('8537','2014-03-18','09:40:00',2.22),('8537','2014-03-18','09:45:00',1.86),('8537','2014-03-18','09:50:00',2.55),('8537','2014-03-18','09:55:00',2.62),('8537','2014-03-18','10:00:00',2.37),('8537','2014-03-18','10:05:00',2.67),('8537','2014-03-18','10:10:00',4.16),('8537','2014-03-18','10:15:00',4.03),('8537','2014-03-18','10:20:00',4.41),('8537','2014-03-18','10:25:00',4.61),('8537','2014-03-18','10:30:00',2.46),('8537','2014-03-18','10:35:00',4.86),('8537','2014-03-18','10:40:00',4.92),('8537','2014-03-18','10:45:00',3.19),('8537','2014-03-18','10:50:00',4.28),('8537','2014-03-18','10:55:00',3.66),('8537','2014-03-18','11:00:00',4.85),('8537','2014-03-18','11:05:00',3.09),('8537','2014-03-18','11:10:00',3.24),('8537','2014-03-18','11:15:00',1.83),('8537','2014-03-18','11:20:00',1.75),('8537','2014-03-18','11:25:00',2.12),('8537','2014-03-18','11:30:00',3.74),('8537','2014-03-18','11:35:00',3.21),('8537','2014-03-18','11:40:00',3.71),('8537','2014-03-18','11:45:00',2.9),('8537','2014-03-18','11:50:00',3.12),('8537','2014-03-18','11:55:00',2.03),('8537','2014-03-18','12:00:00',1.94),('8537','2014-03-18','12:05:00',2.09),('8537','2014-03-18','12:10:00',2.23),('8537','2014-03-18','12:15:00',3.83),('8537','2014-03-18','12:20:00',3.25),('8537','2014-03-18','12:25:00',3.6),('8537','2014-03-18','12:30:00',2.95),('8537','2014-03-18','12:35:00',5.18),('8537','2014-03-18','12:40:00',3.25),('8537','2014-03-18','12:45:00',3.99),('8537','2014-03-18','12:50:00',3.55),('8537','2014-03-18','12:55:00',3.01),('8537','2014-03-18','13:00:00',4.96),('8537','2014-03-18','13:05:00',4.87),('8537','2014-03-18','13:10:00',4.77),('8537','2014-03-18','13:15:00',4.64),('8537','2014-03-18','13:20:00',4.59),('8537','2014-03-18','13:25:00',4.3),('8537','2014-03-18','13:30:00',4.23),('8537','2014-03-18','13:35:00',4.29),('8537','2014-03-18','13:40:00',4.09),('8537','2014-03-18','13:45:00',3.79),('8537','2014-03-18','13:50:00',4.12),('8537','2014-03-18','13:55:00',4.21),('8537','2014-03-18','14:00:00',4.16),('8537','2014-03-18','14:05:00',4.03),('8537','2014-03-18','14:10:00',4.07),('8537','2014-03-18','14:15:00',4),('8537','2014-03-18','14:20:00',3.91),('8537','2014-03-18','14:25:00',3.66),('8537','2014-03-18','14:31:00',3.77),('8537','2014-03-18','14:35:00',3.73),('8537','2014-03-18','14:40:00',3.64),('8537','2014-03-18','14:45:00',3.53),('8537','2014-03-18','14:50:00',3.49),('8537','2014-03-18','14:55:00',3.42),('8537','2014-03-18','15:01:00',3.24),('8537','2014-03-18','15:05:00',3.18),('8537','2014-03-18','15:10:00',3.11),('8537','2014-03-18','15:15:00',3.06),('8537','2014-03-18','15:20:00',2.97),('8537','2014-03-18','15:25:00',2.89),('8537','2014-03-18','15:31:00',2.69),('8537','2014-03-18','15:35:00',2.64),('8537','2014-03-18','15:40:00',2.56),('8537','2014-03-18','15:45:00',2.44),('8537','2014-03-18','15:50:00',2.29),('8537','2014-03-18','15:55:00',2.18),('8537','2014-03-18','16:01:00',2.13),('8537','2014-03-18','16:05:00',2),('8537','2014-03-18','16:10:00',1.9),('8537','2014-03-18','16:15:00',1.8),('8537','2014-03-18','16:20:00',1.65),('8537','2014-03-18','16:25:00',1.55),('8537','2014-03-18','16:32:00',1.47),('8537','2014-03-18','16:35:00',1.28),('8537','2014-03-18','16:40:00',1.23),('8537','2014-03-18','16:45:00',1.1),('8537','2014-03-18','16:50:00',1.02),('8537','2013-01-01','08:40:00',1.01),('8537','2013-01-01','08:45:00',1.09),('8537','2013-01-01','08:50:00',1.15),('8537','2013-01-01','08:55:00',1.21),('8537','2013-01-01','09:00:00',1.31),('8537','2013-01-01','09:05:00',1.38),('8537','2013-01-01','09:10:00',1.46),('8537','2013-01-01','09:15:00',1.52),('8537','2013-01-01','09:20:00',1.59),('8537','2013-01-01','09:25:00',1.66),('8537','2013-01-01','09:30:00',1.66),('8537','2013-01-01','09:35:00',1.66),('8537','2013-01-01','09:40:00',1.82),('8537','2013-01-01','09:45:00',1.9),('8537','2013-01-01','09:50:00',1.96),('8537','2013-01-01','09:55:00',2.01),('8537','2013-01-01','10:00:00',2.03),('8537','2013-01-01','10:05:00',2.09),('8537','2013-01-01','10:10:00',2.14),('8537','2013-01-01','10:15:00',2.18),('8537','2013-01-01','10:20:00',2.22),('8537','2013-01-01','10:25:00',2.27),('8537','2013-01-01','10:30:00',2.34),('8537','2013-01-01','10:35:00',2.37),('8537','2013-01-01','10:40:00',2.47),('8537','2013-01-01','10:45:00',2.63),('8537','2013-01-01','10:50:00',2.5),('8537','2013-01-01','10:55:00',1.7),('8537','2013-01-01','11:05:00',2.88),('8537','2013-01-01','11:10:00',2.97),('8537','2013-01-01','11:15:00',2.68),('8537','2013-01-01','11:20:00',1.97),('8537','2013-01-01','11:25:00',2.57),('8537','2013-01-01','11:30:00',2.92),('8537','2013-01-01','11:35:00',1.67),('8537','2013-01-01','11:40:00',2.19),('8537','2013-01-01','11:45:00',2.88),('8537','2013-01-01','11:50:00',2.77),('8537','2013-01-01','11:55:00',2.29),('8537','2013-01-01','12:00:00',1.69),('8537','2013-01-01','12:05:00',1.37),('8537','2013-01-01','12:10:00',1.48),('8537','2013-01-01','12:15:00',1.5),('8537','2013-01-01','12:20:00',1.49),('8537','2013-01-01','12:25:00',1.39),('8537','2013-01-01','12:30:00',1.22),('8537','2013-01-01','12:35:00',1.2),('8537','2013-01-01','12:40:00',1.32),('8537','2013-01-01','12:45:00',1.53),('8537','2013-01-01','12:50:00',1.32),('8537','2013-01-01','12:55:00',1.4),('8537','2013-01-01','13:00:00',1.11),('8537','2013-01-01','13:05:00',1.15),('8537','2012-12-31','08:30:00',1.03),('8537','2012-12-31','08:35:00',1.04),('8537','2012-12-31','09:00:00',1.02),('8537','2012-12-31','09:05:00',1.1),('8537','2012-12-31','09:10:00',1.15),('8537','2012-12-31','09:15:00',1.54),('8537','2012-12-31','09:20:00',1.71),('8537','2012-12-31','09:25:00',1.9),('8537','2012-12-31','09:30:00',1.81),('8537','2012-12-31','10:00:00',1.12),('8537','2012-12-31','10:10:00',1.7),('8537','2012-12-31','10:15:00',2.38),('8537','2012-12-31','10:20:00',2.54),('8537','2012-12-31','10:25:00',2.52),('8537','2012-12-31','10:30:00',2.54),('8537','2012-12-31','10:35:00',2.57),('8537','2012-12-31','10:40:00',2.66),('8537','2012-12-31','10:45:00',2.65),('8537','2012-12-31','10:50:00',2.68),('8537','2012-12-31','10:55:00',2.78),('8537','2012-12-31','11:00:00',2.84),('8537','2012-12-31','11:05:00',2.83),('8537','2012-12-31','11:10:00',2.8),('8537','2012-12-31','11:15:00',2.89),('8537','2012-12-31','11:20:00',3.03),('8537','2012-12-31','11:25:00',3.09),('8537','2012-12-31','11:30:00',3.14),('8537','2012-12-31','11:35:00',3.18),('8537','2012-12-31','11:40:00',3.22),('8537','2012-12-31','11:45:00',3.23),('8537','2012-12-31','11:50:00',3.25),('8537','2012-12-31','11:55:00',3.28),('8537','2012-12-31','12:00:00',3.3),('8537','2012-12-31','12:05:00',3.34),('8537','2012-12-31','12:10:00',3.34),('8537','2012-12-31','12:15:00',3.33),('8537','2012-12-31','12:20:00',3.33),('8537','2012-12-31','12:25:00',3.31),('8537','2012-12-31','12:30:00',3.26),('8537','2012-12-31','12:35:00',3.24),('8537','2012-12-31','12:40:00',3.21),('8537','2012-12-31','12:45:00',3.16),('8537','2012-12-31','12:50:00',3.12),('8537','2012-12-31','12:55:00',3.1),('8537','2012-12-31','13:00:00',3.02),('8537','2012-12-31','13:05:00',2.96),('8537','2012-12-31','13:10:00',2.92),('8537','2012-12-31','13:15:00',2.85),('8537','2012-12-31','13:20:00',2.76),('8537','2012-12-31','13:25:00',2.7),('8537','2012-12-31','13:30:00',2.62),('8537','2012-12-31','13:35:00',2.55),('8537','2012-12-31','13:40:00',2.48),('8537','2012-12-31','13:45:00',2.4),('8537','2012-12-31','13:50:00',2.32),('8537','2012-12-31','13:55:00',2.33),('8537','2012-12-31','14:00:00',2.26),('8537','2012-12-31','14:05:00',2.21),('8537','2012-12-31','14:10:00',2.14),('8537','2012-12-31','14:15:00',2.12),('8537','2012-12-31','14:20:00',2.06),('8537','2012-12-31','14:25:00',1.99),('8537','2012-12-31','14:30:00',1.94),('8537','2012-12-31','14:35:00',1.9),('8537','2012-12-31','14:40:00',1.82),('8537','2012-12-31','14:45:00',1.74),('8537','2012-12-31','14:50:00',1.7),('8537','2012-12-31','14:55:00',1.62),('8537','2012-12-31','15:00:00',1.55),('8537','2012-12-31','15:05:00',1.47),('8537','2012-12-31','15:10:00',1.37),('8537','2012-12-31','15:15:00',1.28),('8537','2012-12-31','15:20:00',1.1),('8537','2012-12-31','15:25:00',1.1),('8537','2012-12-31','15:30:00',1.05),('8537','2012-12-30','08:40:00',1.06),('8537','2012-12-30','08:45:00',1.15),('8537','2012-12-30','08:50:00',1.21),('8537','2012-12-30','08:55:00',1.29),('8537','2012-12-30','09:00:00',1.37),('8537','2012-12-30','09:05:00',1.46),('8537','2012-12-30','09:10:00',1.56),('8537','2012-12-30','09:15:00',1.62),('8537','2012-12-30','09:20:00',1.7),('8537','2012-12-30','09:25:00',1.77),('8537','2012-12-30','09:30:00',1.76),('8537','2012-12-30','09:35:00',1.77),('8537','2012-12-30','09:40:00',1.94),('8537','2012-12-30','09:45:00',2),('8537','2012-12-30','09:50:00',2.06),('8537','2012-12-30','09:55:00',2.1),('8537','2012-12-30','10:00:00',2.17),('8537','2012-12-30','10:05:00',2.25),('8537','2012-12-30','10:10:00',2.31),('8537','2012-12-30','10:15:00',2.36),('8537','2012-12-30','10:20:00',2.39),('8537','2012-12-30','10:25:00',2.41),('8537','2012-12-30','10:30:00',2.45),('8537','2012-12-30','10:35:00',2.49),('8537','2012-12-30','10:40:00',2.55),('8537','2012-12-30','10:45:00',2.67),('8537','2012-12-30','10:50:00',2.7),('8537','2012-12-30','10:55:00',2.73),('8537','2012-12-30','11:00:00',2.83),('8537','2012-12-30','11:05:00',2.89),('8537','2012-12-30','11:10:00',2.93),('8537','2012-12-30','11:15:00',2.99),('8537','2012-12-30','11:20:00',3.03),('8537','2012-12-30','11:25:00',3.04),('8537','2012-12-30','11:30:00',3.11),('8537','2012-12-30','11:35:00',3.14),('8537','2012-12-30','11:40:00',3.17),('8537','2012-12-30','11:45:00',3.2),('8537','2012-12-30','11:50:00',3.2),('8537','2012-12-30','11:55:00',3.18),('8537','2012-12-30','12:00:00',3.2),('8537','2012-12-30','12:05:00',3.2),('8537','2012-12-30','12:10:00',3.2),('8537','2012-12-30','12:15:00',3.2),('8537','2012-12-30','12:20:00',3.2),('8537','2012-12-30','12:25:00',3.18),('8537','2012-12-30','12:30:00',3.12),('8537','2012-12-30','12:35:00',3.1),('8537','2012-12-30','12:40:00',3.06),('8537','2012-12-30','12:45:00',3.02),('8537','2012-12-30','12:50:00',2.97),('8537','2012-12-30','12:55:00',2.92),('8537','2012-12-30','13:00:00',2.95),('8537','2012-12-30','13:05:00',2.94),('8537','2012-12-30','13:10:00',2.85),('8537','2012-12-30','13:15:00',2.81),('8537','2012-12-30','13:20:00',2.73),('8537','2012-12-30','13:25:00',2.65),('8537','2012-12-30','13:30:00',2.58),('8537','2012-12-30','13:35:00',2.52),('8537','2012-12-30','13:40:00',2.4),('8537','2012-12-30','13:45:00',2.45),('8537','2012-12-30','13:50:00',2.4),('8537','2012-12-30','13:55:00',2.35),('8537','2012-12-30','14:00:00',2.33),('8537','2012-12-30','14:05:00',2.26),('8537','2012-12-30','14:10:00',2.19),('8537','2012-12-30','14:15:00',2.15),('8537','2012-12-30','14:20:00',2.09),('8537','2012-12-30','14:25:00',2.02),('8537','2012-12-30','14:30:00',1.94),('8537','2012-12-30','14:35:00',1.89),('8537','2012-12-30','14:40:00',1.83),('8537','2012-12-30','14:45:00',1.76),('8537','2012-12-30','14:50:00',1.71),('8537','2012-12-30','14:55:00',1.62),('8537','2012-12-30','15:00:00',1.52),('8537','2012-12-30','15:05:00',1.44),('8537','2012-12-30','15:10:00',1.36),('8537','2012-12-30','15:15:00',1.26),('8537','2012-12-30','15:20:00',1.07),('8537','2012-12-30','15:30:00',1),('8537','2012-12-29','08:35:00',1),('8537','2012-12-29','08:40:00',1.12),('8537','2012-12-29','08:45:00',1.22),('8537','2012-12-29','08:50:00',1.29),('8537','2012-12-29','08:55:00',1.35),('8537','2012-12-29','09:00:00',1.42),('8537','2012-12-29','09:05:00',1.5),('8537','2012-12-29','09:10:00',1.6),('8537','2012-12-29','09:15:00',1.67),('8537','2012-12-29','09:20:00',1.73),('8537','2012-12-29','09:25:00',1.78),('8537','2012-12-29','09:30:00',1.76),('8537','2012-12-29','09:35:00',1.81),('8537','2012-12-29','09:40:00',1.97),('8537','2012-12-29','09:45:00',2.06),('8537','2012-12-29','09:50:00',2.13),('8537','2012-12-29','09:55:00',2.2),('8537','2012-12-29','10:00:00',2.26),('8537','2012-12-29','10:05:00',2.32),('8537','2012-12-29','10:10:00',2.34),('8537','2012-12-29','10:15:00',2.43),('8537','2012-12-29','10:20:00',2.46),('8537','2012-12-29','10:25:00',2.5),('8537','2012-12-29','10:30:00',2.53),('8537','2012-12-29','10:35:00',2.55),('8537','2012-12-29','10:40:00',2.59),('8537','2012-12-29','10:45:00',2.74),('8537','2012-12-29','10:50:00',2.8),('8537','2012-12-29','10:55:00',2.81),('8537','2012-12-29','11:00:00',2.93),('8537','2012-12-29','11:05:00',2.97),('8537','2012-12-29','11:10:00',3.03),('8537','2012-12-29','11:15:00',3.08),('8537','2012-12-29','11:20:00',3.13),('8537','2012-12-29','11:25:00',3.16),('8537','2012-12-29','11:30:00',3.18),('8537','2012-12-29','11:35:00',3.24),('8537','2012-12-29','11:40:00',3.24),('8537','2012-12-29','11:45:00',3.25),('8537','2012-12-29','11:50:00',3.28),('8537','2012-12-29','11:55:00',3.28),('8537','2012-12-29','12:00:00',3.3),('8537','2012-12-29','12:05:00',3.32),('8537','2012-12-29','12:10:00',3.33),('8537','2012-12-29','12:15:00',3.29),('8537','2012-12-29','12:20:00',3.24),('8537','2012-12-29','12:25:00',3.22),('8537','2012-12-29','12:30:00',3.21),('8537','2012-12-29','12:35:00',3.23),('8537','2012-12-29','12:40:00',3.19),('8537','2012-12-29','12:45:00',3.11),('8537','2012-12-29','12:50:00',3.05),('8537','2012-12-29','12:55:00',3.02),('8537','2012-12-29','13:00:00',3),('8537','2012-12-29','13:05:00',2.96),('8537','2012-12-29','13:10:00',2.89),('8537','2012-12-29','13:15:00',2.87),('8537','2012-12-29','13:20:00',2.77),('8537','2012-12-29','13:25:00',2.69),('8537','2012-12-29','13:30:00',2.6),('8537','2012-12-29','13:35:00',2.53),('8537','2012-12-29','13:40:00',2.45),('8537','2012-12-29','13:45:00',2.46),('8537','2012-12-29','13:50:00',2.43),('8537','2012-12-29','13:55:00',2.39),('8537','2012-12-29','14:00:00',2.34),('8537','2012-12-29','14:05:00',2.28),('8537','2012-12-29','14:10:00',2.24),('8537','2012-12-29','14:15:00',2.17),('8537','2012-12-29','14:20:00',2.13),('8537','2012-12-29','14:25:00',2.07),('8537','2012-12-29','14:30:00',2),('8537','2012-12-29','14:35:00',1.93),('8537','2012-12-29','14:40:00',1.87),('8537','2012-12-29','14:45:00',1.81),('8537','2012-12-29','14:50:00',1.77),('8537','2012-12-29','14:55:00',1.69),('8537','2012-12-29','15:00:00',1.62),('8537','2012-12-29','15:05:00',1.53),('8537','2012-12-29','15:10:00',1.44),('8537','2012-12-29','15:15:00',1.34),('8537','2012-12-29','15:20:00',1.25),('8537','2012-12-29','15:25:00',1.18),('8537','2012-12-29','15:30:00',1.08),('8537','2012-12-28','08:50:00',1.09),('8537','2012-12-28','08:55:00',1.2),('8537','2012-12-28','09:00:00',1.29),('8537','2012-12-28','09:05:00',1.38),('8537','2012-12-28','09:10:00',1.46),('8537','2012-12-28','09:15:00',1.52),('8537','2012-12-28','09:20:00',1.58),('8537','2012-12-28','09:25:00',1.61),('8537','2012-12-28','09:30:00',1.65),('8537','2012-12-28','09:35:00',1.73),('8537','2012-12-28','09:40:00',1.79),('8537','2012-12-28','09:45:00',1.84),('8537','2012-12-28','09:50:00',1.86),('8537','2012-12-28','09:55:00',1.92),('8537','2012-12-28','10:00:00',2.01),('8537','2012-12-28','10:05:00',2.09),('8537','2012-12-28','10:10:00',2.17),('8537','2012-12-28','10:15:00',2.25),('8537','2012-12-28','10:20:00',2.28),('8537','2012-12-28','10:25:00',2.32),('8537','2012-12-28','10:30:00',2.38),('8537','2012-12-28','10:35:00',2.45),('8537','2012-12-28','10:40:00',2.48),('8537','2012-12-28','10:45:00',2.54),('8537','2012-12-28','10:50:00',2.58),('8537','2012-12-28','10:55:00',2.64),('8537','2012-12-28','11:00:00',2.68),('8537','2012-12-28','11:05:00',2.8),('8537','2012-12-28','11:10:00',2.89),('8537','2012-12-28','11:15:00',2.92),('8537','2012-12-28','11:20:00',2.96),('8537','2012-12-28','11:25:00',2.99),('8537','2012-12-28','11:30:00',2.74),('8537','2012-12-28','11:35:00',3.08),('8537','2012-12-28','11:40:00',3.1),('8537','2012-12-28','11:45:00',3.05),('8537','2012-12-28','11:50:00',3.15),('8537','2012-12-28','11:55:00',2.96),('8537','2012-12-28','12:00:00',2.59),('8537','2012-12-28','12:05:00',2.39),('8537','2012-12-28','12:10:00',2.93),('8537','2012-12-28','12:15:00',3),('8537','2012-12-28','12:20:00',3.12),('8537','2012-12-28','12:25:00',3.05),('8537','2012-12-28','12:30:00',3.03),('8537','2012-12-28','12:35:00',2.96),('8537','2012-12-28','12:40:00',2.57),('8537','2012-12-28','12:45:00',2.73),('8537','2012-12-28','12:50:00',2.94),('8537','2012-12-28','12:55:00',2.89),('8537','2012-12-28','13:00:00',2.82),('8537','2012-12-28','13:05:00',2.77),('8537','2012-12-28','13:10:00',2.71),('8537','2012-12-28','13:15:00',2.58),('8537','2012-12-28','13:20:00',2.56),('8537','2012-12-28','13:25:00',2.49),('8537','2012-12-28','13:30:00',2.42),('8537','2012-12-28','13:35:00',2.32),('8537','2012-12-28','13:40:00',2.23),('8537','2012-12-28','13:45:00',2.15),('8537','2012-12-28','13:50:00',2.25),('8537','2012-12-28','13:55:00',2.17),('8537','2012-12-28','14:00:00',2.1),('8537','2012-12-28','14:05:00',2.04),('8537','2012-12-28','14:10:00',1.7),('8537','2012-12-28','14:15:00',1.88),('8537','2012-12-28','14:20:00',1.86),('8537','2012-12-28','14:25:00',1.83),('8537','2012-12-28','14:30:00',1.72),('8537','2012-12-28','14:35:00',1.52),('8537','2012-12-28','14:45:00',1.45),('8537','2012-12-28','14:50:00',1.54),('8537','2012-12-28','14:55:00',1.47),('8537','2012-12-28','15:00:00',1.41),('8537','2012-12-28','15:05:00',1.32),('8537','2012-12-28','15:10:00',1.24),('8537','2012-12-28','15:15:00',1.12),('8537','2012-12-28','15:20:00',1.05),('8537','2012-12-27','09:20:00',1.08),('8537','2012-12-27','09:25:00',1.1),('8537','2012-12-27','09:30:00',1.2),('8537','2012-12-27','09:35:00',1.5),('8537','2012-12-27','09:40:00',1.43),('8537','2012-12-27','09:45:00',1.48),('8537','2012-12-27','09:50:00',1.97),('8537','2012-12-27','09:55:00',1.38),('8537','2012-12-27','10:00:00',1.12),('8537','2012-12-27','10:05:00',1.22),('8537','2012-12-27','10:10:00',1.78),('8537','2012-12-27','10:15:00',2.1),('8537','2012-12-27','10:20:00',2.08),('8537','2012-12-27','10:25:00',2.06),('8537','2012-12-27','10:30:00',2.1),('8537','2012-12-27','10:35:00',2.24),('8537','2012-12-27','10:40:00',2.33),('8537','2012-12-27','10:45:00',2.42),('8537','2012-12-27','10:50:00',2.36),('8537','2012-12-27','10:55:00',2.45),('8537','2012-12-27','11:00:00',2.5),('8537','2012-12-27','11:05:00',2.56),('8537','2012-12-27','11:10:00',2.72),('8537','2012-12-27','11:15:00',1.52),('8537','2012-12-27','11:20:00',1.29),('8537','2012-12-27','11:50:00',1.27),('8537','2012-12-27','11:55:00',2.73),('8537','2012-12-27','12:00:00',2.79),('8537','2012-12-27','12:05:00',3.07),('8537','2012-12-27','12:10:00',3.3),('8537','2012-12-27','12:15:00',2.53),('8537','2012-12-27','12:20:00',1.6),('8537','2012-12-27','12:25:00',2.69),('8537','2012-12-27','12:30:00',2.72),('8537','2012-12-27','12:35:00',2.87),('8537','2012-12-27','12:40:00',2.87),('8537','2012-12-27','12:45:00',3.22),('8537','2012-12-27','12:50:00',2.78),('8537','2012-12-27','12:55:00',2.81),('8537','2012-12-27','13:00:00',2.71),('8537','2012-12-27','13:05:00',2.85),('8537','2012-12-27','13:10:00',2.36),('8537','2012-12-27','13:15:00',2.71),('8537','2012-12-27','13:20:00',2.43),('8537','2012-12-27','13:25:00',2.47),('8537','2012-12-27','13:30:00',2.52),('8537','2012-12-27','14:00:00',1.1),('8537','2012-12-27','14:05:00',1.8),('8537','2012-12-27','14:10:00',2.1),('8537','2012-12-27','14:15:00',2.05),('8537','2012-12-27','14:20:00',1.92),('8537','2012-12-27','14:25:00',1.84),('8537','2012-12-27','14:30:00',1.8),('8537','2012-12-27','14:35:00',1.76),('8537','2012-12-27','14:40:00',1.66),('8537','2012-12-27','14:45:00',1.44),('8537','2012-12-27','15:00:00',1.22),('8537','2012-12-27','15:05:00',1.18),('8537','2012-12-26','09:20:00',1.52),('8537','2012-12-26','09:25:00',1.67),('8537','2012-12-26','09:30:00',1.63),('8537','2012-12-26','09:35:00',1.74),('8537','2012-12-26','09:40:00',1.82),('8537','2012-12-26','09:45:00',1.89),('8537','2012-12-26','09:50:00',1.95),('8537','2012-12-26','09:55:00',2.01),('8537','2012-12-26','10:00:00',2.07),('8537','2012-12-26','10:05:00',2.11),('8537','2012-12-26','10:10:00',2.16),('8537','2012-12-26','10:15:00',2.18),('8537','2012-12-26','10:20:00',2.19),('8537','2012-12-26','10:25:00',2.2),('8537','2012-12-26','10:30:00',2.23),('8537','2012-12-26','10:35:00',2.29),('8537','2012-12-26','10:40:00',2.36),('8537','2012-12-26','10:45:00',2.39),('8537','2012-12-26','10:50:00',2.43),('8537','2012-12-26','10:55:00',2.52),('8537','2012-12-26','11:00:00',2.57),('8537','2012-12-26','11:05:00',2.61),('8537','2012-12-26','11:10:00',2.66),('8537','2012-12-26','11:15:00',2.7),('8537','2012-12-26','11:20:00',2.74),('8537','2012-12-26','11:25:00',2.76),('8537','2012-12-26','11:30:00',2.77),('8537','2012-12-26','11:35:00',2.8),('8537','2012-12-26','11:40:00',2.85),('8537','2012-12-26','11:45:00',2.9),('8537','2012-12-26','11:50:00',2.95),('8537','2012-12-26','11:55:00',2.98),('8537','2012-12-26','12:00:00',3.03),('8537','2012-12-26','12:05:00',2.98),('8537','2012-12-26','12:10:00',2.99),('8537','2012-12-26','12:15:00',3.01),('8537','2012-12-26','12:20:00',3),('8537','2012-12-26','12:25:00',3),('8537','2012-12-26','12:30:00',2.98),('8537','2012-12-26','12:35:00',2.96),('8537','2012-12-26','12:40:00',2.93),('8537','2012-12-26','12:45:00',2.89),('8537','2012-12-26','12:50:00',2.82),('8537','2012-12-26','12:55:00',2.74),('8537','2012-12-26','13:00:00',2.82),('8537','2012-12-26','13:05:00',2.76),('8537','2012-12-26','13:10:00',2.76),('8537','2012-12-26','13:15:00',2.65),('8537','2012-12-26','13:20:00',2.72),('8537','2012-12-26','13:25:00',2.77),('8537','2012-12-26','13:30:00',2.85),('8537','2012-12-26','13:35:00',2.88),('8537','2012-12-26','13:40:00',2.81),('8537','2012-12-26','13:45:00',2.76),('8537','2012-12-26','13:50:00',2.53),('8537','2012-12-26','13:55:00',2.42),('8537','2012-12-26','14:00:00',2.26),('8537','2012-12-26','14:05:00',2.28),('8537','2012-12-25','11:25:00',1.07),('8537','2012-12-25','11:30:00',1.03),('8537','2012-12-25','11:50:00',1),('8537','2012-12-25','11:55:00',1.08),('8537','2012-12-25','12:00:00',1.09),('8537','2012-12-25','13:15:00',1.04),('8537','2012-12-25','13:20:00',1.04),('8537','2012-12-25','14:45:00',1.03),('8537','2012-12-25','14:50:00',1.05),('8537','2012-12-25','14:55:00',1.05),('8537','2012-12-25','15:00:00',1.01),('8537','2012-12-23','08:40:00',1.09),('8537','2012-12-23','08:45:00',1.19),('8537','2012-12-23','08:50:00',1.24),('8537','2012-12-23','08:55:00',1.35),('8537','2012-12-23','09:00:00',1.43),('8537','2012-12-23','09:05:00',1.53),('8537','2012-12-23','09:10:00',1.6),('8537','2012-12-23','09:15:00',1.62),('8537','2012-12-23','09:20:00',1.69),('8537','2012-12-23','09:25:00',1.74),('8537','2012-12-23','09:30:00',1.65),('8537','2012-12-23','09:35:00',1.82),('8537','2012-12-23','09:40:00',1.89),('8537','2012-12-23','09:45:00',1.94),('8537','2012-12-23','09:50:00',2),('8537','2012-12-23','09:55:00',2.04),('8537','2012-12-23','10:00:00',2.07),('8537','2012-12-23','10:05:00',2.15),('8537','2012-12-23','10:10:00',2.19),('8537','2012-12-23','10:15:00',2.21),('8537','2012-12-23','10:20:00',2.25),('8537','2012-12-23','10:25:00',2.24),('8537','2012-12-23','10:30:00',2.21),('8537','2012-12-23','10:35:00',2.28),('8537','2012-12-23','10:40:00',2.42),('8537','2012-12-23','10:45:00',2.51),('8537','2012-12-23','10:50:00',2.48),('8537','2012-12-23','10:55:00',2.42),('8537','2012-12-23','11:00:00',2.65),('8537','2012-12-23','11:05:00',2.71),('8537','2012-12-23','11:10:00',2.73),('8537','2012-12-23','11:15:00',2.79),('8537','2012-12-23','11:20:00',2.91),('8537','2012-12-23','11:25:00',2.64),('8537','2012-12-23','11:30:00',2.79),('8537','2012-12-23','11:35:00',2.98),('8537','2012-12-23','11:40:00',2.99),('8537','2012-12-23','11:45:00',2.95),('8537','2012-12-23','11:50:00',3.05),('8537','2012-12-23','11:55:00',2.83),('8537','2012-12-23','12:00:00',2.65),('8537','2012-12-23','12:05:00',2.69),('8537','2012-12-23','12:10:00',2.71),('8537','2012-12-23','12:15:00',2.18),('8537','2012-12-23','12:20:00',1.95),('8537','2012-12-23','12:25:00',1.23),('8537','2012-12-23','12:30:00',1.62),('8537','2012-12-23','12:35:00',1.34),('8537','2012-12-23','12:40:00',1.65),('8537','2012-12-23','12:45:00',1.29),('8537','2012-12-23','12:50:00',1.88),('8537','2012-12-23','12:55:00',2.6),('8537','2012-12-23','13:00:00',2.67),('8537','2012-12-23','13:05:00',2.34),('8537','2012-12-23','13:10:00',2.55),('8537','2012-12-23','13:15:00',1.71),('8537','2012-12-23','13:20:00',1.44),('8537','2012-12-23','13:25:00',1.45),('8537','2012-12-23','13:30:00',1.3),('8537','2012-12-23','13:35:00',1.18),('8537','2012-12-23','13:40:00',1.7),('8537','2012-12-23','13:45:00',1.72),('8537','2012-12-23','13:50:00',1.56),('8537','2012-12-23','13:55:00',1.41),('8537','2012-12-23','14:00:00',1.95),('8537','2012-12-23','14:05:00',1.71),('8537','2012-12-23','14:10:00',1.64),('8537','2012-12-23','14:15:00',1.76),('8537','2012-12-23','14:20:00',1.38),('8537','2012-12-23','14:25:00',1.07),('8537','2012-12-23','14:30:00',1.06),('8537','2012-12-23','14:35:00',1.24),('8537','2012-12-23','14:40:00',1.49),('8537','2012-12-23','14:45:00',1.56),('8537','2012-12-23','14:50:00',1.13),('8537','2014-05-01','07:50:00',1.33),('8537','2014-05-01','07:55:00',1.48),('8537','2014-05-01','08:00:00',1.62),('8537','2014-05-01','08:05:00',1.69),('8537','2014-05-01','08:10:00',1.76),('8537','2014-05-01','08:15:00',1.9),('8537','2014-05-01','08:20:00',2.01),('8537','2014-05-01','08:25:00',2.13),('8537','2014-05-01','08:30:00',2.24),('8537','2014-05-01','08:35:00',2.35),('8537','2014-05-01','08:40:00',2.45),('8537','2014-05-01','08:45:00',2.56),('8537','2014-05-01','08:50:00',2.72),('8537','2014-05-01','08:55:00',2.97),('8537','2014-05-01','09:00:00',2.24),('8537','2014-05-01','09:05:00',1.6),('8537','2014-05-01','09:10:00',1.95),('8537','2014-05-01','09:15:00',2.01),('8537','2014-05-01','09:20:00',1.53),('8537','2014-05-01','09:25:00',3.44),('8537','2014-05-01','09:30:00',3.61),('8537','2014-05-01','09:35:00',3.71),('8537','2014-05-01','09:40:00',3.9),('8537','2014-05-01','09:45:00',2.92),('8537','2014-05-01','09:50:00',2.37),('8537','2014-05-01','09:55:00',2.19),('8537','2014-05-01','10:00:00',2.23),('8537','2014-05-01','10:05:00',2.45),('8537','2014-05-01','10:10:00',4.4),('8537','2014-05-01','10:15:00',2.81),('8537','2014-05-01','10:20:00',3.39),('8537','2014-05-01','10:25:00',3.68),('8537','2014-05-01','10:30:00',3.97),('8537','2014-05-01','10:35:00',3.29),('8537','2014-05-01','10:40:00',1.62),('8537','2014-05-01','10:45:00',4.97),('8537','2014-05-01','10:50:00',4.95),('8537','2014-05-01','10:55:00',3.81),('8537','2014-05-01','11:00:00',5.13),('8537','2014-05-01','11:05:00',3.69),('8537','2014-05-01','11:10:00',2.19),('8537','2014-05-01','11:15:00',3.7),('8537','2014-05-01','11:20:00',5.59),('8537','2014-05-01','11:25:00',3.54),('8537','2014-05-01','11:30:00',3.4),('8537','2014-05-01','11:35:00',5.57),('8537','2014-05-01','11:40:00',5.46),('8537','2014-05-01','11:45:00',5.16),('8537','2014-05-01','11:50:00',4.63),('8537','2014-05-01','11:55:00',5.61),('8537','2014-05-01','12:00:00',5.54),('8537','2014-05-01','12:05:00',4.81),('8537','2014-05-01','12:10:00',4.26),('8537','2014-05-01','12:15:00',4.28),('8537','2014-05-01','12:20:00',4.43),('8537','2014-05-01','12:25:00',2.86),('8537','2014-05-01','12:30:00',3.84),('8537','2014-05-01','12:35:00',5.87),('8537','2014-05-01','12:40:00',5.72),('8537','2014-05-01','12:45:00',5.66),('8537','2014-05-01','12:50:00',2.14),('8537','2014-05-01','12:55:00',3.74),('8537','2014-05-01','13:00:00',5.85),('8537','2014-05-01','13:05:00',5.55),('8537','2014-05-01','13:10:00',5.61),('8537','2014-05-01','13:15:00',5.03),('8537','2014-05-01','13:20:00',5.49),('8537','2014-05-01','13:25:00',4.25),('8537','2014-05-01','13:30:00',2.46),('8537','2014-05-01','13:35:00',5.27),('8537','2014-05-01','13:40:00',5.71),('8537','2014-05-01','13:45:00',5.7),('8537','2014-05-01','13:50:00',5.89),('8537','2014-05-01','13:55:00',5.32),('8537','2014-05-01','14:00:00',3.77),('8537','2014-05-01','14:05:00',4.28),('8537','2014-05-01','14:10:00',5.49),('8537','2014-05-01','14:15:00',5.43),('8537','2014-05-01','14:20:00',5.29),('8537','2014-05-01','14:25:00',5.39),('8537','2014-05-01','14:30:00',5.08),('8537','2014-05-01','14:35:00',2.74),('8537','2014-05-01','14:40:00',3.87),('8537','2014-05-01','14:45:00',5.35),('8537','2014-05-01','14:50:00',5.21),('8537','2014-05-01','14:55:00',5.02),('8537','2014-05-01','15:00:00',5.16),('8537','2014-05-01','15:05:00',5.12),('8537','2014-05-01','15:10:00',4.03),('8537','2014-05-01','15:15:00',4.66),('8537','2014-05-01','15:20:00',4.59),('8537','2014-05-01','15:25:00',4.47),('8537','2014-05-01','15:30:00',4.25),('8537','2014-05-01','15:35:00',4.25),('8537','2014-05-01','15:40:00',4.18),('8537','2014-05-01','15:45:00',4.12),('8537','2014-05-01','15:50:00',4.02),('8537','2014-05-01','15:55:00',3.94),('8537','2014-05-01','16:00:00',3.9),('8537','2014-05-01','16:05:00',3.87),('8537','2014-05-01','16:10:00',3.61),('8537','2014-05-01','16:15:00',3.39),('8537','2014-05-01','16:20:00',3.47),('8537','2014-05-01','16:25:00',3.15),('8537','2014-05-01','16:30:00',3.27),('8537','2014-05-01','16:35:00',3.26),('8537','2014-05-01','16:40:00',3.11),('8537','2014-05-01','16:45:00',2.6),('8537','2014-05-01','16:50:00',2.5),('8537','2014-05-01','16:55:00',2.5),('8537','2014-05-01','17:00:00',2.52),('8537','2014-05-01','17:05:00',2.5),('8537','2014-05-01','17:10:00',2.55),('8537','2014-05-01','17:15:00',2.43),('8537','2014-05-01','17:20:00',2.33),('8537','2014-05-01','17:25:00',2.21),('8537','2014-05-01','17:30:00',2.07),('8537','2014-05-01','17:35:00',1.98),('8537','2014-05-01','17:40:00',1.81),('8537','2014-05-01','17:45:00',1.73),('8537','2014-05-01','17:50:00',1.63),('8537','2014-05-01','17:55:00',1.56),('8537','2014-05-01','18:00:00',1.54),('8537','2014-05-01','18:05:00',1.35),('8537','2014-05-01','18:10:00',1.2),('8537','2014-05-01','18:15:00',1.09),('8537','2014-03-17','09:05:00',1.03),('8537','2014-03-17','09:10:00',1.13),('8537','2014-03-17','09:15:00',1.34),('8537','2014-03-17','09:20:00',1.45),('8537','2014-03-17','09:25:00',1.61),('8537','2014-03-17','09:30:00',1.86),('8537','2014-03-17','09:35:00',1.88),('8537','2014-03-17','09:40:00',1.53),('8537','2014-03-17','09:45:00',1.44),('8537','2014-03-17','09:50:00',2.47),('8537','2014-03-17','09:55:00',2.34),('8537','2014-03-17','10:00:00',2.45),('8537','2014-03-17','10:05:00',1.89),('8537','2014-03-17','10:10:00',2.04),('8537','2014-03-17','10:15:00',1.99),('8537','2014-03-17','10:20:00',2.94),('8537','2014-03-17','10:25:00',2.04),('8537','2014-03-17','10:30:00',1.58),('8537','2014-03-17','10:35:00',1.71),('8537','2014-03-17','10:40:00',1.63),('8537','2014-03-17','10:45:00',2.12),('8537','2014-03-17','10:50:00',1.79),('8537','2014-03-17','10:55:00',1.64),('8537','2014-03-17','11:00:00',1.69),('8537','2014-03-17','11:05:00',1.64),('8537','2014-03-17','11:10:00',2.02),('8537','2014-03-17','11:15:00',2.08),('8537','2014-03-17','11:20:00',1.56),('8537','2014-03-17','11:25:00',1.55),('8537','2014-03-17','11:30:00',1.88),('8537','2014-03-17','11:35:00',1.53),('8537','2014-03-17','11:40:00',1.4),('8537','2014-03-17','11:45:00',1.43),('8537','2014-03-17','11:50:00',2.26),('8537','2014-03-17','11:55:00',2.03),('8537','2014-03-17','12:00:00',2.94),('8537','2014-03-17','12:05:00',2.44),('8537','2014-03-17','12:10:00',1.96),('8537','2014-03-17','12:15:00',1.81),('8537','2014-03-17','12:20:00',2.41),('8537','2014-03-17','12:25:00',4.06),('8537','2014-03-17','12:30:00',1.92),('8537','2014-03-17','12:35:00',2.77),('8537','2014-03-17','12:40:00',2.4),('8537','2014-03-17','12:45:00',2.7),('8537','2014-03-17','12:50:00',3.92),('8537','2014-03-17','12:55:00',4.65),('8537','2014-03-17','13:00:00',4.77),('8537','2014-03-17','13:05:00',2.39),('8537','2014-03-17','13:10:00',3.3),('8537','2014-03-17','13:15:00',4.47),('8537','2014-03-17','13:20:00',4.44),('8537','2014-03-17','13:25:00',4.43),('8537','2014-03-17','13:30:00',3.5),('8537','2014-03-17','13:35:00',4.48),('8537','2014-03-17','13:40:00',4.3),('8537','2014-03-17','13:45:00',4.45),('8537','2014-03-17','13:50:00',3.98),('8537','2014-03-17','13:55:00',3.69),('8537','2014-03-17','14:00:00',2.44),('8537','2014-03-17','14:05:00',3.17),('8537','2014-03-17','14:10:00',1.83),('8537','2014-03-17','14:15:00',1.33),('8537','2014-03-17','14:20:00',2.6),('8537','2014-03-17','14:25:00',2.38),('8537','2014-03-17','14:30:00',2.7),('8537','2014-03-17','14:35:00',2.33),('8537','2014-03-17','14:40:00',2.67),('8537','2014-03-17','14:45:00',3.35),('8537','2014-03-17','14:50:00',3.63),('8537','2014-03-17','14:55:00',3.5),('8537','2014-03-17','15:00:00',3.33),('8537','2014-03-17','15:05:00',3.19),('8537','2014-03-17','15:10:00',3.18),('8537','2014-03-17','15:15:00',2.75),('8537','2014-03-17','15:20:00',2),('8537','2014-03-17','15:25:00',2.49),('8537','2014-03-17','15:30:00',2.59),('8537','2014-03-17','15:35:00',2.41),('8537','2014-03-17','15:40:00',1.99),('8537','2014-03-17','15:45:00',2.31),('8537','2014-03-17','15:50:00',2.08),('8537','2014-03-17','15:55:00',2.02),('8537','2014-03-17','16:00:00',1.91),('8537','2014-03-17','16:05:00',1.9),('8537','2014-03-17','16:10:00',1.17),('8537','2014-03-17','16:15:00',1.43),('8537','2014-03-17','16:20:00',1.75),('8537','2014-03-17','16:25:00',1.64),('8537','2014-03-17','16:30:00',1.17),('8537','2014-03-17','16:35:00',1.12),('8537','2014-03-17','16:40:00',1.05),('8537','2014-03-17','16:45:00',1.02),('8537','2012-12-22','10:20:00',1.06),('8537','2012-12-22','10:25:00',2.18),('8537','2012-12-22','10:30:00',2.38),('8537','2012-12-22','10:35:00',2.89),('8537','2012-12-22','10:40:00',2.88),('8537','2012-12-22','10:45:00',2.9),('8537','2012-12-22','10:50:00',2.89),('8537','2012-12-22','10:55:00',2.85),('8537','2012-12-22','11:00:00',1.33),('8537','2012-12-22','11:40:00',1.56),('8537','2012-12-22','11:45:00',2.1),('8537','2012-12-22','11:50:00',2.45),('8537','2012-12-22','11:55:00',1.92),('8537','2012-12-22','12:00:00',2.57),('8537','2012-12-22','12:05:00',1.36),('8537','2012-12-22','12:45:00',2.47),('8537','2012-12-22','12:50:00',2.7),('8537','2012-12-22','12:55:00',2.31),('8537','2012-12-22','13:00:00',2.84),('8537','2012-12-22','13:05:00',3.21),('8537','2012-12-22','13:10:00',3.28),('8537','2012-12-22','13:15:00',3.42),('8537','2012-12-22','13:20:00',3.38),('8537','2012-12-22','13:25:00',3.26),('8537','2012-12-22','13:30:00',2.87),('8537','2012-12-22','13:35:00',2.87),('8537','2012-12-22','13:40:00',2.48),('8537','2012-12-22','13:45:00',1.01),('8537','2012-12-22','13:55:00',1.11),('8537','2012-12-22','14:00:00',1.16),('8537','2012-12-22','14:05:00',1.33),('8537','2012-12-22','14:10:00',1.24),('8537','2012-12-22','14:15:00',1.48),('8537','2012-12-22','14:20:00',1.46),('8537','2012-12-22','15:00:00',1.1),('8537','2014-03-16','07:40:00',1),('8537','2014-03-16','07:45:00',1.08),('8537','2014-03-16','07:50:00',1.19),('8537','2014-03-16','07:55:00',1.35),('8537','2014-03-16','08:00:00',1.5),('8537','2014-03-16','08:05:00',1.58),('8537','2014-03-16','08:10:00',1.62),('8537','2014-03-16','08:15:00',1.69),('8537','2014-03-16','08:20:00',1.81),('8537','2014-03-16','08:25:00',1.92),('8537','2014-03-16','08:30:00',2.04),('8537','2014-03-16','08:35:00',2.13),('8537','2014-03-16','08:40:00',2.2),('8537','2014-03-16','08:45:00',2.33),('8537','2014-03-16','08:50:00',2.44),('8537','2014-03-16','08:55:00',2.48),('8537','2014-03-16','09:00:00',2.46),('8537','2014-03-16','09:05:00',2.57),('8537','2014-03-16','09:10:00',2.74),('8537','2014-03-16','09:15:00',2.94),('8537','2014-03-16','09:20:00',2.98),('8537','2014-03-16','09:25:00',2.97),('8537','2014-03-16','09:30:00',3.07),('8537','2014-03-16','09:35:00',3.06),('8537','2014-03-16','09:40:00',3.06),('8537','2014-03-16','09:45:00',3.31),('8537','2014-03-16','09:50:00',3.52),('8537','2014-03-16','09:55:00',3.53),('8537','2014-03-16','10:00:00',3.55),('8537','2014-03-16','10:05:00',3.64),('8537','2014-03-16','10:10:00',3.56),('8537','2014-03-16','10:15:00',3.76),('8537','2014-03-16','10:20:00',3.82),('8537','2014-03-16','10:25:00',3.74),('8537','2014-03-16','10:30:00',3.85),('8537','2014-03-16','10:35:00',3.89),('8537','2014-03-16','10:40:00',4.01),('8537','2014-03-16','10:45:00',4.06),('8537','2014-03-16','10:50:00',3.96),('8537','2014-03-16','10:55:00',3.89),('8537','2014-03-16','11:00:00',3.02),('8537','2014-03-16','11:05:00',4),('8537','2014-03-16','11:10:00',4.1),('8537','2014-03-16','11:15:00',4.1),('8537','2014-03-16','11:20:00',4.38),('8537','2014-03-16','11:25:00',4.38),('8537','2014-03-16','11:30:00',4.36),('8537','2014-03-16','11:35:00',4.4),('8537','2014-03-16','11:40:00',4.43),('8537','2014-03-16','11:45:00',4.33),('8537','2014-03-16','11:50:00',4.32),('8537','2014-03-16','11:55:00',4.35),('8537','2014-03-16','12:00:00',4.32),('8537','2014-03-16','12:05:00',4.31),('8537','2014-03-16','12:10:00',4.38),('8537','2014-03-16','12:15:00',4.35),('8537','2014-03-16','12:20:00',4.29),('8537','2014-03-16','12:25:00',4.2),('8537','2014-03-16','12:30:00',4.28),('8537','2014-03-16','12:35:00',4.34),('8537','2014-03-16','12:40:00',4.39),('8537','2014-03-16','12:45:00',4.34),('8537','2014-03-16','12:50:00',4.23),('8537','2014-03-16','12:55:00',4.26),('8537','2014-03-16','13:00:00',4.18),('8537','2014-03-16','13:05:00',4.19),('8537','2014-03-16','13:10:00',4.18),('8537','2014-03-16','13:15:00',4.19),('8537','2014-03-16','13:20:00',4.11),('8537','2014-03-16','13:25:00',4.1),('8537','2014-03-16','13:30:00',4.1),('8537','2014-03-16','13:35:00',4.03),('8537','2014-03-16','13:40:00',4.12),('8537','2014-03-16','13:45:00',3.99),('8537','2014-03-16','13:50:00',3.94),('8537','2014-03-16','13:55:00',3.95),('8537','2014-03-16','14:00:00',3.82),('8537','2014-03-16','14:05:00',3.78),('8537','2014-03-16','14:10:00',3.7),('8537','2014-03-16','14:15:00',3.6),('8537','2014-03-16','14:20:00',3.59),('8537','2014-03-16','14:25:00',3.46),('8537','2014-03-16','14:30:00',3.43),('8537','2014-03-16','14:35:00',3.35),('8537','2014-03-16','14:40:00',3.28),('8537','2014-03-16','14:45:00',3.18),('8537','2014-03-16','14:50:00',3),('8537','2014-03-16','14:55:00',2.98),('8537','2014-03-16','15:00:00',3.09),('8537','2014-03-16','15:05:00',2.88),('8537','2014-03-16','15:10:00',2.68),('8537','2014-03-16','15:15:00',2.5),('8537','2014-03-16','15:20:00',2.13),('8537','2014-03-16','15:25:00',2.37),('8537','2014-03-16','15:30:00',2.19),('8537','2014-03-16','15:35:00',2),('8537','2014-03-16','15:40:00',1.57),('8537','2014-03-16','15:45:00',1.56),('8537','2014-03-16','15:50:00',1.74),('8537','2014-03-16','15:55:00',1.53),('8537','2014-03-16','16:00:00',1.4),('8537','2014-03-16','16:06:00',1.67),('8537','2014-03-16','16:10:00',1.7),('8537','2014-03-16','16:15:00',1.64),('8537','2014-03-16','16:20:00',1.43),('8537','2014-03-16','16:25:00',1.46),('8537','2014-03-16','16:30:00',1.43),('8537','2014-03-16','16:35:00',1.3),('8537','2014-03-16','16:40:00',1.11),('8537','2014-03-15','07:45:00',1.06),('8537','2014-03-15','07:50:00',1.15),('8537','2014-03-15','07:55:00',1.27),('8537','2014-03-15','08:00:00',1.37),('8537','2014-03-15','08:05:00',1.46),('8537','2014-03-15','08:10:00',1.53),('8537','2014-03-15','08:15:00',1.65),('8537','2014-03-15','08:20:00',1.76),('8537','2014-03-15','08:25:00',1.87),('8537','2014-03-15','08:30:00',1.95),('8537','2014-03-15','08:35:00',2.05),('8537','2014-03-15','08:40:00',2.14),('8537','2014-03-15','08:45:00',2.23),('8537','2014-03-15','08:50:00',2.33),('8537','2014-03-15','08:55:00',2.41),('8537','2014-03-15','09:00:00',2.5),('8537','2014-03-15','09:05:00',2.58),('8537','2014-03-15','09:10:00',2.68),('8537','2014-03-15','09:15:00',2.81),('8537','2014-03-15','09:20:00',2.89),('8537','2014-03-15','09:25:00',2.97),('8537','2014-03-15','09:30:00',3.03),('8537','2014-03-15','09:35:00',3.07),('8537','2014-03-15','09:40:00',3.17),('8537','2014-03-15','09:45:00',3.21),('8537','2014-03-15','09:50:00',3.23),('8537','2014-03-15','09:55:00',3.32),('8537','2014-03-15','10:00:00',3.37),('8537','2014-03-15','10:05:00',3.43),('8537','2014-03-15','10:10:00',3.53),('8537','2014-03-15','10:15:00',3.54),('8537','2014-03-15','10:20:00',3.63),('8537','2014-03-15','10:25:00',3.74),('8537','2014-03-15','10:30:00',3.77),('8537','2014-03-15','10:35:00',3.8),('8537','2014-03-15','10:40:00',3.87),('8537','2014-03-15','10:45:00',3.92),('8537','2014-03-15','10:50:00',3.89),('8537','2014-03-15','10:55:00',3.87),('8537','2014-03-15','11:00:00',3.91),('8537','2014-03-15','11:05:00',4.01),('8537','2014-03-15','11:10:00',4),('8537','2014-03-15','11:15:00',4.03),('8537','2014-03-15','11:20:00',4.19),('8537','2014-03-15','11:25:00',4.27),('8537','2014-03-15','11:30:00',4.27),('8537','2014-03-15','11:35:00',4.28),('8537','2014-03-15','11:40:00',4.29),('8537','2014-03-15','11:45:00',4.3),('8537','2014-03-15','11:50:00',4.29),('8537','2014-03-15','11:55:00',4.27),('8537','2014-03-15','12:00:00',4.3),('8537','2014-03-15','12:05:00',4.24),('8537','2014-03-15','12:10:00',4.26),('8537','2014-03-15','12:15:00',4.35),('8537','2014-03-15','12:20:00',4.31),('8537','2014-03-15','12:25:00',4.28),('8537','2014-03-15','12:30:00',4.31),('8537','2014-03-15','12:35:00',4.35),('8537','2014-03-15','12:40:00',4.41),('8537','2014-03-15','12:45:00',4.36),('8537','2014-03-15','12:50:00',4.37),('8537','2014-03-15','12:55:00',4.33),('8537','2014-03-15','13:00:00',4.28),('8537','2014-03-15','13:05:00',4.34),('8537','2014-03-15','13:10:00',4.35),('8537','2014-03-15','13:15:00',4.3),('8537','2014-03-15','13:20:00',4.28),('8537','2014-03-15','13:25:00',4.25),('8537','2014-03-15','13:30:00',4.22),('8537','2014-03-15','13:35:00',4.2),('8537','2014-03-15','13:40:00',4.05),('8537','2014-03-15','13:45:00',3.9),('8537','2014-03-15','13:50:00',3.8),('8537','2014-03-15','13:55:00',4.01),('8537','2014-03-15','14:00:00',3.98),('8537','2014-03-15','14:05:00',3.96),('8537','2014-03-15','14:10:00',3.91),('8537','2014-03-15','14:15:00',3.83),('8537','2014-03-15','14:20:00',3.76),('8537','2014-03-15','14:25:00',3.64),('8537','2014-03-15','14:30:00',3.45),('8537','2014-03-15','14:35:00',3.32),('8537','2014-03-15','14:40:00',3.44),('8537','2014-03-15','14:45:00',3.34),('8537','2014-03-15','14:50:00',3.26),('8537','2014-03-15','14:55:00',3.22),('8537','2014-03-15','15:00:00',3.13),('8537','2014-03-15','15:05:00',3.03),('8537','2014-03-15','15:10:00',2.94),('8537','2014-03-15','15:15:00',2.87),('8537','2014-03-15','15:20:00',2.76),('8537','2014-03-15','15:25:00',2.66),('8537','2014-03-15','15:30:00',2.58),('8537','2014-03-15','15:35:00',2.41),('8537','2014-03-15','15:40:00',2.34),('8537','2014-03-15','15:45:00',2.23),('8537','2014-03-15','15:50:00',2.05),('8537','2014-03-15','15:55:00',1.99),('8537','2014-03-15','16:00:00',1.88),('8537','2014-03-15','16:05:00',1.72),('8537','2014-03-15','16:10:00',1.67),('8537','2014-03-15','16:15:00',1.51),('8537','2014-03-15','16:20:00',1.43),('8537','2014-03-15','16:25:00',1.31),('8537','2014-03-15','16:30:00',1.21),('8537','2014-03-15','16:35:00',1.1),('8537','2014-03-14','08:10:00',1.06),('8537','2014-03-14','08:15:00',1.21),('8537','2014-03-14','08:20:00',1.36),('8537','2014-03-14','08:25:00',1.43),('8537','2014-03-14','08:30:00',1.54),('8537','2014-03-14','08:35:00',1.55),('8537','2014-03-14','08:40:00',1.49),('8537','2014-03-14','08:45:00',1.27),('8537','2014-03-14','08:50:00',1.21),('8537','2014-03-14','08:55:00',1.26),('8537','2014-03-14','09:00:00',1.36),('8537','2014-03-14','09:05:00',1.56),('8537','2014-03-14','09:10:00',1.74),('8537','2014-03-14','09:15:00',1.77),('8537','2014-03-14','09:20:00',1.74),('8537','2014-03-14','09:25:00',1.87),('8537','2014-03-14','09:30:00',1.87),('8537','2014-03-14','09:35:00',2.23),('8537','2014-03-14','09:40:00',2.82),('8537','2014-03-14','09:45:00',3.23),('8537','2014-03-14','09:50:00',3.81),('8537','2014-03-14','09:55:00',3.97),('8537','2014-03-14','10:00:00',4.21),('8537','2014-03-14','10:05:00',4.19),('8537','2014-03-14','10:10:00',4.12),('8537','2014-03-14','10:15:00',4.05),('8537','2014-03-14','10:20:00',3.97),('8537','2014-03-14','10:25:00',3.84),('8537','2014-03-14','10:30:00',3.8),('8537','2014-03-14','10:35:00',4.02),('8537','2014-03-14','10:40:00',4.09),('8537','2014-03-14','10:45:00',3.66),('8537','2014-03-14','10:50:00',2.36),('8537','2014-03-14','10:55:00',3.17),('8537','2014-03-14','11:00:00',4.01),('8537','2014-03-14','11:05:00',4.17),('8537','2014-03-14','11:10:00',4.44),('8537','2014-03-14','11:15:00',4.5),('8537','2014-03-14','11:20:00',4.36),('8537','2014-03-14','11:25:00',4.29),('8537','2014-03-14','11:30:00',4.32),('8537','2014-03-14','11:35:00',4.4),('8537','2014-03-14','11:40:00',4.37),('8537','2014-03-14','11:45:00',4.43),('8537','2014-03-14','11:50:00',4.47),('8537','2014-03-14','11:55:00',4.61),('8537','2014-03-14','12:00:00',4.68),('8537','2014-03-14','12:05:00',4.63),('8537','2014-03-14','12:10:00',4.34),('8537','2014-03-14','12:15:00',4.12),('8537','2014-03-14','12:20:00',3.49),('8537','2014-03-14','12:25:00',2.95),('8537','2014-03-14','12:30:00',2.8),('8537','2014-03-14','12:35:00',2.3),('8537','2014-03-14','12:40:00',2.81),('8537','2014-03-14','12:45:00',3.03),('8537','2014-03-14','12:50:00',3.71),('8537','2014-03-14','12:55:00',3.66),('8537','2014-03-14','13:00:00',2.57),('8537','2014-03-14','13:05:00',2.31),('8537','2014-03-14','13:10:00',2.8),('8537','2014-03-14','13:15:00',3.21),('8537','2014-03-14','13:20:00',3.38),('8537','2014-03-14','13:25:00',3.15),('8537','2014-03-14','13:30:00',2.86),('8537','2014-03-14','13:35:00',2.59),('8537','2014-03-14','13:40:00',2.4),('8537','2014-03-14','13:45:00',2.47),('8537','2014-03-14','13:50:00',2.31),('8537','2014-03-14','13:55:00',2.37),('8537','2014-03-14','14:00:00',2.78),('8537','2014-03-14','14:05:00',3.09),('8537','2014-03-14','14:10:00',3.07),('8537','2014-03-14','14:15:00',3.24),('8537','2014-03-14','14:20:00',3.32),('8537','2014-03-14','14:25:00',3.32),('8537','2014-03-14','14:30:00',3.01),('8537','2014-03-14','14:35:00',2.77),('8537','2014-03-14','14:40:00',2.31),('8537','2014-03-14','14:45:00',1.88),('8537','2014-03-14','14:50:00',1.67),('8537','2014-03-14','14:55:00',1.54),('8537','2014-03-14','15:00:00',1.42),('8537','2014-03-14','15:05:00',1.39),('8537','2014-03-14','15:10:00',1.35),('8537','2014-03-14','15:15:00',1.35),('8537','2014-03-14','15:20:00',1.42),('8537','2014-03-14','15:25:00',1.49),('8537','2014-03-14','15:30:00',1.67),('8537','2014-03-14','15:35:00',1.78),('8537','2014-03-14','15:40:00',1.59),('8537','2014-03-14','15:45:00',1.41),('8537','2014-03-14','15:50:00',1.28),('8537','2014-03-14','15:55:00',1.3),('8537','2014-03-14','16:00:00',1.2),('8537','2014-03-14','16:05:00',1.15),('8537','2014-03-14','16:10:00',1.03),('8537','2014-03-13','07:30:00',1.02),('8537','2014-03-13','07:35:00',1.12),('8537','2014-03-13','07:40:00',1.23),('8537','2014-03-13','07:45:00',1.33),('8537','2014-03-13','07:50:00',1.47),('8537','2014-03-13','07:55:00',1.59),('8537','2014-03-13','08:00:00',1.7),('8537','2014-03-13','08:05:00',1.81),('8537','2014-03-13','08:10:00',1.93),('8537','2014-03-13','08:15:00',2.05),('8537','2014-03-13','08:20:00',2.16),('8537','2014-03-13','08:25:00',2.27),('8537','2014-03-13','08:30:00',2.36),('8537','2014-03-13','08:35:00',2.48),('8537','2014-03-13','08:40:00',2.58),('8537','2014-03-13','08:45:00',2.69),('8537','2014-03-13','08:50:00',2.78),('8537','2014-03-13','08:55:00',2.9),('8537','2014-03-13','09:00:00',3.01),('8537','2014-03-13','09:05:00',3.08),('8537','2014-03-13','09:10:00',3.18),('8537','2014-03-13','09:15:00',3.26),('8537','2014-03-13','09:20:00',3.35),('8537','2014-03-13','09:25:00',3.44),('8537','2014-03-13','09:30:00',3.52),('8537','2014-03-13','09:35:00',3.59),('8537','2014-03-13','09:40:00',3.69),('8537','2014-03-13','09:45:00',3.77),('8537','2014-03-13','09:50:00',3.85),('8537','2014-03-13','09:55:00',3.9),('8537','2014-03-13','10:00:00',3.99),('8537','2014-03-13','10:05:00',4.05),('8537','2014-03-13','10:10:00',4.12),('8537','2014-03-13','10:15:00',4.17),('8537','2014-03-13','10:20:00',4.18),('8537','2014-03-13','10:25:00',4.21),('8537','2014-03-13','10:30:00',4.28),('8537','2014-03-13','10:35:00',4.3),('8537','2014-03-13','10:40:00',4.31),('8537','2014-03-13','10:45:00',4.34),('8537','2014-03-13','10:50:00',4.35),('8537','2014-03-13','10:55:00',4.41),('8537','2014-03-13','11:00:00',4.43),('8537','2014-03-13','11:05:00',4.49),('8537','2014-03-13','11:10:00',4.52),('8537','2014-03-13','11:15:00',4.55),('8537','2014-03-13','11:20:00',4.55),('8537','2014-03-13','11:25:00',4.58),('8537','2014-03-13','11:30:00',4.63),('8537','2014-03-13','11:35:00',4.6),('8537','2014-03-13','11:40:00',4.63),('8537','2014-03-13','11:45:00',4.69),('8537','2014-03-13','11:50:00',4.67),('8537','2014-03-13','11:55:00',4.75),('8537','2014-03-13','12:00:00',4.75),('8537','2014-03-13','12:05:00',4.65),('8537','2014-03-13','12:10:00',4.66),('8537','2014-03-13','12:15:00',4.65),('8537','2014-03-13','12:20:00',4.66),('8537','2014-03-13','12:25:00',4.68),('8537','2014-03-13','12:30:00',4.69),('8537','2014-03-13','12:35:00',4.64),('8537','2014-03-13','12:40:00',4.62),('8537','2014-03-13','12:45:00',4.54),('8537','2014-03-13','12:50:00',4.53),('8537','2014-03-13','12:55:00',4.51),('8537','2014-03-13','13:00:00',4.48),('8537','2014-03-13','13:05:00',4.42),('8537','2014-03-13','13:10:00',4.38),('8537','2014-03-13','13:15:00',4.31),('8537','2014-03-13','13:20:00',4.34),('8537','2014-03-13','13:25:00',4.33),('8537','2014-03-13','13:30:00',4.35),('8537','2014-03-13','13:35:00',4.31),('8537','2014-03-13','13:40:00',4.2),('8537','2014-03-13','13:45:00',4.07),('8537','2014-03-13','13:50:00',3.98),('8537','2014-03-13','13:55:00',4),('8537','2014-03-13','14:00:00',3.93),('8537','2014-03-13','14:05:00',3.89),('8537','2014-03-13','14:10:00',3.85),('8537','2014-03-13','14:15:00',3.83),('8537','2014-03-13','14:20:00',3.75),('8537','2014-03-13','14:25:00',3.67),('8537','2014-03-13','14:30:00',3.55),('8537','2014-03-13','14:35:00',3.46),('8537','2014-03-13','14:40:00',3.46),('8537','2014-03-13','14:45:00',3.36),('8537','2014-03-13','14:50:00',3.3),('8537','2014-03-13','14:55:00',3.22),('8537','2014-03-13','15:00:00',3.14),('8537','2014-03-13','15:05:00',3.04),('8537','2014-03-13','15:10:00',2.94),('8537','2014-03-13','15:15:00',2.88),('8537','2014-03-13','15:20:00',2.8),('8537','2014-03-13','15:25:00',2.72),('8537','2014-03-13','15:30:00',2.64),('8537','2014-03-13','15:35:00',2.54),('8537','2014-03-13','15:40:00',2.43),('8537','2014-03-13','15:45:00',2.33),('8537','2014-03-13','15:50:00',2.17),('8537','2014-03-13','15:55:00',2.09),('8537','2014-03-13','16:00:00',1.98),('8537','2014-03-13','16:05:00',1.87),('8537','2014-03-13','16:10:00',1.77),('8537','2014-03-13','16:15:00',1.62),('8537','2014-03-13','16:20:00',1.51),('8537','2014-03-13','16:25:00',1.43),('8537','2014-03-13','16:30:00',1.31),('8537','2014-03-13','16:35:00',1.21),('8537','2014-03-13','16:40:00',1.09),('8537','2014-03-12','07:35:00',1.07),('8537','2014-03-12','07:40:00',1.19),('8537','2014-03-12','07:45:00',1.31),('8537','2014-03-12','07:50:00',1.43),('8537','2014-03-12','07:55:00',1.55),('8537','2014-03-12','08:00:00',1.67),('8537','2014-03-12','08:05:00',1.78),('8537','2014-03-12','08:10:00',1.91),('8537','2014-03-12','08:15:00',2.03),('8537','2014-03-12','08:20:00',2.14),('8537','2014-03-12','08:25:00',2.26),('8537','2014-03-12','08:30:00',2.37),('8537','2014-03-12','08:35:00',2.49),('8537','2014-03-12','08:40:00',2.6),('8537','2014-03-12','08:45:00',2.7),('8537','2014-03-12','08:50:00',2.8),('8537','2014-03-12','08:55:00',2.9),('8537','2014-03-12','09:00:00',2.98),('8537','2014-03-12','09:05:00',3.08),('8537','2014-03-12','09:10:00',3.18),('8537','2014-03-12','09:15:00',3.27),('8537','2014-03-12','09:20:00',3.33),('8537','2014-03-12','09:25:00',3.42),('8537','2014-03-12','09:30:00',3.5),('8537','2014-03-12','09:35:00',3.59),('8537','2014-03-12','09:40:00',3.65),('8537','2014-03-12','09:45:00',3.73),('8537','2014-03-12','09:50:00',3.8),('8537','2014-03-12','09:55:00',3.88),('8537','2014-03-12','10:00:00',3.95),('8537','2014-03-12','10:05:00',4.02),('8537','2014-03-12','10:10:00',4.08),('8537','2014-03-12','10:15:00',4.13),('8537','2014-03-12','10:20:00',4.18),('8537','2014-03-12','10:25:00',4.23),('8537','2014-03-12','10:30:00',4.28),('8537','2014-03-12','10:35:00',4.34),('8537','2014-03-12','10:40:00',4.43),('8537','2014-03-12','10:45:00',4.5),('8537','2014-03-12','10:50:00',4.53),('8537','2014-03-12','10:55:00',4.56),('8537','2014-03-12','11:00:00',4.6),('8537','2014-03-12','11:05:00',4.66),('8537','2014-03-12','11:10:00',4.7),('8537','2014-03-12','11:15:00',4.74),('8537','2014-03-12','11:20:00',4.77),('8537','2014-03-12','11:25:00',4.78),('8537','2014-03-12','11:30:00',4.8),('8537','2014-03-12','11:35:00',4.83),('8537','2014-03-12','11:40:00',4.86),('8537','2014-03-12','11:45:00',4.85),('8537','2014-03-12','11:50:00',4.82),('8537','2014-03-12','11:55:00',4.88),('8537','2014-03-12','12:00:00',4.87),('8537','2014-03-12','12:05:00',4.86),('8537','2014-03-12','12:10:00',4.82),('8537','2014-03-12','12:15:00',4.82),('8537','2014-03-12','12:20:00',4.72),('8537','2014-03-12','12:25:00',4.79),('8537','2014-03-12','12:30:00',4.79),('8537','2014-03-12','12:35:00',4.77),('8537','2014-03-12','12:40:00',4.73),('8537','2014-03-12','12:45:00',4.74),('8537','2014-03-12','12:50:00',4.72),('8537','2014-03-12','12:55:00',4.69),('8537','2014-03-12','13:00:00',4.7),('8537','2014-03-12','13:05:00',4.64),('8537','2014-03-12','13:10:00',4.6),('8537','2014-03-12','13:15:00',4.6),('8537','2014-03-12','13:20:00',4.56),('8537','2014-03-12','13:25:00',4.51),('8537','2014-03-12','13:30:00',4.45),('8537','2014-03-12','13:35:00',4.43),('8537','2014-03-12','13:40:00',4.34),('8537','2014-03-12','13:45:00',4.3),('8537','2014-03-12','13:50:00',4.16),('8537','2014-03-12','13:55:00',4.21),('8537','2014-03-12','14:00:00',4.18),('8537','2014-03-12','14:05:00',4.15),('8537','2014-03-12','14:10:00',4.06),('8537','2014-03-12','14:15:00',4.02),('8537','2014-03-12','14:20:00',3.93),('8537','2014-03-12','14:25:00',3.86),('8537','2014-03-12','14:30:00',3.79),('8537','2014-03-12','14:35:00',3.57),('8537','2014-03-12','14:40:00',3.52),('8537','2014-03-12','14:45:00',3.41),('8537','2014-03-12','14:50:00',3.36),('8537','2014-03-12','14:55:00',3.16),('8537','2014-03-12','15:00:00',3.12),('8537','2014-03-12','15:05:00',3.09),('8537','2014-03-12','15:10:00',3),('8537','2014-03-12','15:15:00',2.87),('8537','2014-03-12','15:20:00',2.81),('8537','2014-03-12','15:25:00',2.71),('8537','2014-03-12','15:30:00',2.59),('8537','2014-03-12','15:35:00',2.48),('8537','2014-03-12','15:40:00',2.42),('8537','2014-03-12','15:45:00',2.32),('8537','2014-03-12','15:50:00',2.21),('8537','2014-03-12','15:55:00',2.11),('8537','2014-03-12','16:00:00',2.04),('8537','2014-03-12','16:05:00',1.91),('8537','2014-03-12','16:10:00',1.78),('8537','2014-03-12','16:15:00',1.65),('8537','2014-03-12','16:20:00',1.54),('8537','2014-03-12','16:25:00',1.42),('8537','2014-03-12','16:30:00',1.3),('8537','2014-03-12','16:35:00',1.2),('8537','2014-03-12','16:40:00',1.1),('8537','2014-03-11','10:20:00',1),('8537','2014-03-11','10:25:00',1.03),('8537','2014-03-11','10:30:00',1.06),('8537','2014-03-11','10:35:00',1.07),('8537','2014-03-11','10:40:00',1.06),('8537','2014-03-11','11:00:00',1.08),('8537','2014-03-11','11:05:00',1.11),('8537','2014-03-11','11:10:00',1.13),('8537','2014-03-11','11:15:00',1.16),('8537','2014-03-11','11:20:00',1.05),('8537','2014-03-11','11:25:00',1.04),('8537','2014-03-11','11:30:00',1.03),('8537','2014-03-11','11:35:00',1.13),('8537','2014-03-11','11:40:00',1.21),('8537','2014-03-11','11:45:00',1.23),('8537','2014-03-11','11:50:00',1.06),('8537','2014-03-11','11:55:00',1.16),('8537','2014-03-11','12:00:00',1.21),('8537','2014-03-11','12:05:00',1.23),('8537','2014-03-11','12:10:00',1.28),('8537','2014-03-11','12:15:00',1.43),('8537','2014-03-11','12:20:00',1.52),('8537','2014-03-11','12:25:00',1.39),('8537','2014-03-11','12:30:00',1.33),('8537','2014-03-11','12:35:00',1.42),('8537','2014-03-11','12:40:00',1.55),('8537','2014-03-11','12:45:00',1.49),('8537','2014-03-11','12:50:00',1.45),('8537','2014-03-11','12:55:00',1.34),('8537','2014-03-11','13:00:00',1.24),('8537','2014-03-11','13:05:00',1.44),('8537','2014-03-11','13:10:00',1.48),('8537','2014-03-11','13:15:00',1.46),('8537','2014-03-11','13:20:00',1.47),('8537','2014-03-11','13:25:00',1.26),('8537','2014-03-11','13:30:00',1.24),('8537','2014-03-11','13:35:00',1.17),('8537','2014-03-11','13:40:00',1.22),('8537','2014-03-11','13:45:00',1.56),('8537','2014-03-11','13:50:00',1.86),('8537','2014-03-11','13:55:00',2.24),('8537','2014-03-11','14:00:00',2.25),('8537','2014-03-11','14:05:00',2.36),('8537','2014-03-11','14:10:00',2.74),('8537','2014-03-11','14:15:00',3.04),('8537','2014-03-11','14:20:00',2.43),('8537','2014-03-11','14:25:00',2.15),('8537','2014-03-11','14:30:00',1.58),('8537','2014-03-11','14:35:00',1.64),('8537','2014-03-11','14:40:00',1.61),('8537','2014-03-11','14:45:00',1.68),('8537','2014-03-11','14:50:00',1.53),('8537','2014-03-11','14:55:00',1.55),('8537','2014-03-11','15:00:00',1.79),('8537','2014-03-11','15:05:00',1.96),('8537','2014-03-11','15:10:00',2.07),('8537','2014-03-11','15:15:00',1.77),('8537','2014-03-11','15:20:00',1.67),('8537','2014-03-11','15:25:00',1.51),('8537','2014-03-11','15:30:00',1.45),('8537','2014-03-11','15:35:00',1.3),('8537','2014-03-11','15:40:00',1.29),('8537','2014-03-11','15:45:00',1.21),('8537','2014-03-11','15:50:00',1.2),('8537','2014-03-10','08:40:00',1.05),('8537','2014-03-10','08:45:00',1.04),('8537','2014-03-10','08:50:00',1.07),('8537','2014-03-10','08:55:00',1.08),('8537','2014-03-10','09:00:00',1.11),('8537','2014-03-10','09:05:00',1.2),('8537','2014-03-10','09:10:00',1.24),('8537','2014-03-10','09:15:00',1.17),('8537','2014-03-10','09:20:00',1.14),('8537','2014-03-10','09:25:00',1.14),('8537','2014-03-10','09:30:00',1.2),('8537','2014-03-10','09:35:00',1.15),('8537','2014-03-10','09:40:00',1.18),('8537','2014-03-10','09:45:00',1.06),('8537','2014-03-10','10:10:00',1.12),('8537','2014-03-10','10:15:00',1.31),('8537','2014-03-10','10:20:00',1.08),('8537','2014-03-10','10:25:00',1.05),('8537','2014-03-10','10:30:00',1.28),('8537','2014-03-10','10:35:00',1.43),('8537','2014-03-10','11:15:00',1.02),('8537','2014-03-10','11:20:00',1.13),('8537','2014-03-10','11:25:00',1.05),('8537','2014-03-10','12:40:00',1.03),('8537','2014-03-10','12:45:00',1.18),('8537','2014-03-10','12:50:00',1.31),('8537','2014-03-10','12:55:00',1.4),('8537','2014-03-10','13:00:00',1.48),('8537','2014-03-10','13:05:00',1.52),('8537','2014-03-10','13:10:00',1.72),('8537','2014-03-10','13:15:00',1.96),('8537','2014-03-10','13:20:00',1.84),('8537','2014-03-10','13:25:00',1.63),('8537','2014-03-10','13:30:00',1.37),('8537','2014-03-10','13:35:00',1.14),('8537','2014-03-10','13:40:00',1.04),('8537','2014-03-10','13:50:00',1.45),('8537','2014-03-10','13:55:00',1.26),('8537','2014-03-10','14:00:00',1.25),('8537','2014-03-10','14:05:00',1.86),('8537','2014-03-10','14:10:00',2.56),('8537','2014-03-10','14:15:00',3.44),('8537','2014-03-10','14:20:00',2.22),('8537','2014-03-10','14:25:00',1.83),('8537','2014-03-10','14:30:00',1.54),('8537','2014-03-10','14:35:00',2.66),('8537','2014-03-10','14:40:00',3.41),('8537','2014-03-10','14:45:00',2.67),('8537','2014-03-10','14:50:00',2.69),('8537','2014-03-10','14:55:00',1.77),('8537','2014-03-10','15:00:00',1.69),('8537','2014-03-10','15:05:00',1.44),('8537','2014-03-10','15:10:00',1.15),('8537','2014-03-10','15:15:00',1.36),('8537','2014-03-10','15:20:00',2.58),('8537','2014-03-10','15:25:00',2.67),('8537','2014-03-10','15:30:00',1.62),('8537','2014-03-10','15:35:00',1.14),('8537','2014-03-10','15:40:00',1.28),('8537','2014-03-10','15:45:00',1.03),('8537','2014-03-10','15:50:00',1.01),('8537','2014-03-10','16:00:00',1.02),('8537','2014-03-10','16:05:00',1.12),('8537','2014-03-10','16:25:00',1),('8537','2014-03-10','16:30:00',1.09),('8537','2014-03-09','07:50:00',1.3),('8537','2014-03-09','07:55:00',1.41),('8537','2014-03-09','08:00:00',1.55),('8537','2014-03-09','08:05:00',1.66),('8537','2014-03-09','08:10:00',1.8),('8537','2014-03-09','08:15:00',1.93),('8537','2014-03-09','08:20:00',1.86),('8537','2014-03-09','08:25:00',1.38),('8537','2014-03-09','08:30:00',1.63),('8537','2014-03-09','08:35:00',1.47),('8537','2014-03-09','08:40:00',1.67),('8537','2014-03-09','08:45:00',1.15),('8537','2014-03-09','08:50:00',1.5),('8537','2014-03-09','08:55:00',2.09),('8537','2014-03-09','09:00:00',2.57),('8537','2014-03-09','09:05:00',1.56),('8537','2014-03-09','09:15:00',2.04),('8537','2014-03-09','09:20:00',3.37),('8537','2014-03-09','09:25:00',3.57),('8537','2014-03-09','09:30:00',2.86),('8537','2014-03-09','09:35:00',3.75),('8537','2014-03-09','09:40:00',3.91),('8537','2014-03-09','09:45:00',4),('8537','2014-03-09','09:50:00',4.06),('8537','2014-03-09','09:55:00',4.04),('8537','2014-03-09','10:00:00',4.08),('8537','2014-03-09','10:05:00',4.16),('8537','2014-03-09','10:10:00',4.26),('8537','2014-03-09','10:15:00',4.27),('8537','2014-03-09','10:20:00',4.28),('8537','2014-03-09','10:25:00',4.26),('8537','2014-03-09','10:30:00',4.42),('8537','2014-03-09','10:35:00',4.48),('8537','2014-03-09','10:40:00',4.5),('8537','2014-03-09','10:45:00',4.55),('8537','2014-03-09','10:50:00',4.63),('8537','2014-03-09','10:55:00',4.7),('8537','2014-03-09','11:00:00',5.06),('8537','2014-03-09','11:05:00',4.49),('8537','2014-03-09','11:10:00',5.28),('8537','2014-03-09','11:15:00',5.36),('8537','2014-03-09','11:20:00',5.09),('8537','2014-03-09','11:25:00',3.75),('8537','2014-03-09','11:30:00',2.91),('8537','2014-03-09','11:35:00',3.35),('8537','2014-03-09','11:40:00',3.08),('8537','2014-03-09','11:45:00',3.14),('8537','2014-03-09','11:50:00',3.77),('8537','2014-03-09','11:55:00',4.95),('8537','2014-03-09','12:00:00',4.87),('8537','2014-03-09','12:05:00',5.61),('8537','2014-03-09','12:10:00',5.52),('8537','2014-03-09','12:15:00',5.44),('8537','2014-03-09','12:20:00',5.43),('8537','2014-03-09','12:25:00',5.37),('8537','2014-03-09','12:30:00',5.39),('8537','2014-03-09','12:35:00',5.49),('8537','2014-03-09','12:40:00',5.26),('8537','2014-03-09','12:45:00',5.16),('8537','2014-03-09','12:50:00',5.21),('8537','2014-03-09','12:55:00',5.25),('8537','2014-03-09','13:00:00',5.33),('8537','2014-03-09','13:05:00',5.35),('8537','2014-03-09','13:10:00',5.3),('8537','2014-03-09','13:15:00',4.95),('8537','2014-03-09','13:20:00',4.74),('8537','2014-03-09','13:25:00',4.92),('8537','2014-03-09','13:30:00',4.87),('8537','2014-03-09','13:35:00',3.33),('8537','2014-03-09','13:45:00',1.63),('8537','2014-03-09','13:50:00',2.53),('8537','2014-03-09','13:55:00',2.48),('8537','2014-03-09','14:00:00',4.57),('8537','2014-03-09','14:05:00',4.22),('8537','2014-03-09','14:10:00',3.88),('8537','2014-03-09','14:15:00',3.38),('8537','2014-03-09','14:20:00',3.96),('8537','2014-03-09','14:25:00',2.39),('8537','2014-03-09','14:30:00',1.19),('8537','2014-03-09','14:35:00',1.3),('8537','2014-03-09','14:40:00',2.64),('8537','2014-03-09','14:45:00',3.84),('8537','2014-03-09','14:50:00',3.25),('8537','2014-03-09','14:55:00',3.4),('8537','2014-03-09','15:00:00',3.34),('8537','2014-03-09','15:05:00',2.74),('8537','2014-03-09','15:10:00',3.3),('8537','2014-03-09','15:15:00',3.13),('8537','2014-03-09','15:20:00',3.09),('8537','2014-03-09','15:25:00',3.03),('8537','2014-03-09','15:30:00',2.94),('8537','2014-03-09','15:35:00',2.79),('8537','2014-03-09','15:40:00',2.65),('8537','2014-03-09','15:45:00',1.9),('8537','2014-03-09','15:50:00',1.08),('8537','2014-03-09','15:55:00',2.16),('8537','2014-03-09','16:00:00',2.2),('8537','2014-03-09','16:05:00',1.97),('8537','2014-03-09','16:10:00',1.4),('8537','2014-03-09','16:20:00',1.49),('8537','2014-03-09','16:25:00',1.44),('8537','2014-03-09','16:30:00',1.36),('8537','2014-03-09','16:35:00',1.27),('8537','2014-03-09','16:40:00',1.21),('8537','2014-03-09','16:45:00',1.04),('8537','2014-03-08','07:40:00',1.07),('8537','2014-03-08','07:45:00',1.19),('8537','2014-03-08','07:50:00',1.31),('8537','2014-03-08','07:55:00',1.42),('8537','2014-03-08','08:00:00',1.55),('8537','2014-03-08','08:05:00',1.66),('8537','2014-03-08','08:10:00',1.78),('8537','2014-03-08','08:15:00',1.91),('8537','2014-03-08','08:20:00',2.02),('8537','2014-03-08','08:25:00',2.15),('8537','2014-03-08','08:30:00',2.26),('8537','2014-03-08','08:35:00',2.37),('8537','2014-03-08','08:40:00',2.49),('8537','2014-03-08','08:45:00',2.59),('8537','2014-03-08','08:50:00',2.7),('8537','2014-03-08','08:55:00',2.81),('8537','2014-03-08','09:00:00',2.91),('8537','2014-03-08','09:05:00',3.01),('8537','2014-03-08','09:10:00',3.12),('8537','2014-03-08','09:15:00',3.2),('8537','2014-03-08','09:20:00',3.29),('8537','2014-03-08','09:25:00',3.37),('8537','2014-03-08','09:30:00',3.47),('8537','2014-03-08','09:35:00',3.54),('8537','2014-03-08','09:40:00',3.61),('8537','2014-03-08','09:45:00',3.7),('8537','2014-03-08','09:50:00',3.79),('8537','2014-03-08','09:55:00',3.86),('8537','2014-03-08','10:00:00',3.92),('8537','2014-03-08','10:05:00',3.98),('8537','2014-03-08','10:10:00',4.03),('8537','2014-03-08','10:15:00',4.12),('8537','2014-03-08','10:20:00',4.19),('8537','2014-03-08','10:25:00',4.24),('8537','2014-03-08','10:30:00',4.33),('8537','2014-03-08','10:35:00',4.37),('8537','2014-03-08','10:40:00',4.36),('8537','2014-03-08','10:45:00',4.45),('8537','2014-03-08','10:50:00',4.48),('8537','2014-03-08','10:55:00',4.5),('8537','2014-03-08','11:00:00',4.55),('8537','2014-03-08','11:05:00',4.58),('8537','2014-03-08','11:10:00',4.62),('8537','2014-03-08','11:15:00',4.7),('8537','2014-03-08','11:20:00',4.78),('8537','2014-03-08','11:25:00',4.92),('8537','2014-03-08','11:30:00',4.99),('8537','2014-03-08','11:35:00',3.1),('8537','2014-03-08','11:40:00',3.35),('8537','2014-03-08','11:45:00',1.67),('8537','2014-03-08','11:50:00',2.02),('8537','2014-03-08','11:55:00',4.02),('8537','2014-03-08','12:00:00',1.74),('8537','2014-03-08','12:05:00',1.22),('8537','2014-03-08','12:10:00',1.26),('8537','2014-03-08','12:15:00',1.36),('8537','2014-03-08','12:20:00',1.58),('8537','2014-03-08','12:25:00',1.73),('8537','2014-03-08','12:30:00',2.32),('8537','2014-03-08','12:35:00',4.67),('8537','2014-03-08','12:40:00',2.31),('8537','2014-03-08','12:45:00',2.52),('8537','2014-03-08','12:50:00',3.4),('8537','2014-03-08','12:55:00',4.54),('8537','2014-03-08','13:00:00',2.06),('8537','2014-03-08','13:05:00',1.89),('8537','2014-03-08','13:10:00',1.62),('8537','2014-03-08','13:15:00',1.27),('8537','2014-03-08','13:20:00',1.12),('8537','2014-03-08','13:25:00',1.28),('8537','2014-03-08','13:30:00',2.33),('8537','2014-03-08','13:35:00',1.89),('8537','2014-03-08','13:40:00',2.98),('8537','2014-03-08','13:45:00',3.09),('8537','2014-03-08','13:50:00',2.14),('8537','2014-03-08','13:55:00',1.54),('8537','2014-03-08','14:00:00',1.23),('8537','2014-03-08','14:05:00',1.17),('8537','2014-03-08','14:10:00',1.06),('8537','2014-03-08','14:35:00',1.11),('8537','2014-03-08','14:40:00',1.19),('8537','2014-03-08','14:45:00',1.1),('8537','2014-03-08','14:50:00',1.14),('8537','2014-03-08','14:55:00',1.19),('8537','2014-03-08','15:00:00',1.01),('8537','2014-03-08','15:10:00',1.02),('8537','2014-03-08','15:15:00',1.29),('8537','2014-03-08','15:20:00',2.07),('8537','2014-03-08','15:25:00',2.34),('8537','2014-03-08','15:30:00',1.59),('8537','2014-03-08','15:55:00',1.05),('8537','2014-03-08','16:00:00',1.27),('8537','2014-03-08','16:05:00',1.31),('8537','2014-03-08','16:30:00',1.3),('8537','2014-03-08','16:35:00',1.38),('8537','2014-03-08','16:40:00',1.18),('8537','2014-03-08','16:45:00',1.07),('8537','2014-04-30','07:40:00',1.09),('8537','2014-04-30','07:45:00',1.2),('8537','2014-04-30','07:50:00',1.3),('8537','2014-04-30','07:55:00',1.4),('8537','2014-04-30','08:00:00',1.51),('8537','2014-04-30','08:05:00',1.57),('8537','2014-04-30','08:10:00',1.75),('8537','2014-04-30','08:15:00',1.83),('8537','2014-04-30','08:20:00',1.94),('8537','2014-04-30','08:25:00',2.04),('8537','2014-04-30','08:30:00',2.14),('8537','2014-04-30','08:35:00',2.25),('8537','2014-04-30','08:40:00',2.36),('8537','2014-04-30','08:45:00',2.34),('8537','2014-04-30','08:50:00',2.22),('8537','2014-04-30','08:55:00',2.72),('8537','2014-04-30','09:00:00',2.88),('8537','2014-04-30','09:05:00',3.02),('8537','2014-04-30','09:10:00',2.92),('8537','2014-04-30','09:15:00',3.49),('8537','2014-04-30','09:20:00',1.28),('8537','2014-04-30','09:25:00',2.93),('8537','2014-04-30','09:30:00',1.71),('8537','2014-04-30','09:35:00',3.18),('8537','2014-04-30','09:40:00',3.74),('8537','2014-04-30','09:45:00',3.44),('8537','2014-04-30','09:50:00',1.96),('8537','2014-04-30','09:55:00',3.26),('8537','2014-04-30','10:00:00',3.61),('8537','2014-04-30','10:05:00',3.34),('8537','2014-04-30','10:10:00',1.79),('8537','2014-04-30','10:15:00',3.84),('8537','2014-04-30','10:20:00',2.15),('8537','2014-04-30','10:25:00',2.1),('8537','2014-04-30','10:30:00',2.09),('8537','2014-04-30','10:35:00',2.62),('8537','2014-04-30','10:40:00',2.51),('8537','2014-04-30','10:45:00',2.04),('8537','2014-04-30','10:50:00',1.8),('8537','2014-04-30','10:55:00',4.3),('8537','2014-04-30','11:00:00',5.2),('8537','2014-04-30','11:05:00',4.5),('8537','2014-04-30','11:10:00',3.58),('8537','2014-04-30','11:15:00',3.21),('8537','2014-04-30','11:20:00',1.97),('8537','2014-04-30','11:25:00',2.93),('8537','2014-04-30','11:30:00',2.51),('8537','2014-04-30','11:35:00',2.46),('8537','2014-04-30','11:40:00',3.55),('8537','2014-04-30','11:45:00',2.27),('8537','2014-04-30','11:50:00',3.87),('8537','2014-04-30','11:55:00',3.11),('8537','2014-04-30','12:00:00',4.42),('8537','2014-04-30','12:05:00',1.79),('8537','2014-04-30','12:10:00',1.58),('8537','2014-04-30','12:15:00',2.25),('8537','2014-04-30','12:20:00',2.14),('8537','2014-04-30','12:25:00',1.87),('8537','2014-04-30','12:30:00',2.11),('8537','2014-04-30','12:35:00',1.78),('8537','2014-04-30','12:40:00',1.73),('8537','2014-04-30','12:45:00',1.85),('8537','2014-04-30','12:50:00',1.95),('8537','2014-04-30','12:55:00',5.08),('8537','2014-04-30','13:00:00',5.39),('8537','2014-04-30','13:05:00',2.81),('8537','2014-04-30','13:10:00',4.26),('8537','2014-04-30','13:15:00',3.07),('8537','2014-04-30','13:20:00',2.49),('8537','2014-04-30','13:25:00',3.04),('8537','2014-04-30','13:30:00',2.52),('8537','2014-04-30','13:35:00',2.33),('8537','2014-04-30','13:40:00',4),('8537','2014-04-30','13:45:00',3.49),('8537','2014-04-30','13:50:00',3.21),('8537','2014-04-30','13:55:00',4.85),('8537','2014-04-30','14:00:00',2.71),('8537','2014-04-30','14:05:00',2.7),('8537','2014-04-30','14:10:00',1.9),('8537','2014-04-30','14:15:00',2.13),('8537','2014-04-30','14:20:00',3.72),('8537','2014-04-30','14:25:00',4.21),('8537','2014-04-30','14:30:00',5.24),('8537','2014-04-30','14:35:00',5.44),('8537','2014-04-30','14:40:00',2.73),('8537','2014-04-30','14:45:00',1.76),('8537','2014-04-30','14:50:00',1.92),('8537','2014-04-30','14:55:00',2.14),('8537','2014-04-30','15:00:00',1.8),('8537','2014-04-30','15:05:00',1.74),('8537','2014-04-30','15:10:00',1.65),('8537','2014-04-30','15:15:00',1.54),('8537','2014-04-30','15:20:00',1.4),('8537','2014-04-30','15:25:00',1.53),('8537','2014-04-30','15:30:00',2.09),('8537','2014-04-30','15:35:00',3.24),('8537','2014-04-30','15:40:00',4.1),('8537','2014-04-30','15:45:00',4.01),('8537','2014-04-30','15:50:00',4.94),('8537','2014-04-30','15:55:00',3.37),('8537','2014-04-30','16:00:00',1.53),('8537','2014-04-30','16:05:00',3.01),('8537','2014-04-30','16:10:00',2.1),('8537','2014-04-30','16:15:00',3.17),('8537','2014-04-30','16:20:00',2.05),('8537','2014-04-30','16:25:00',2.12),('8537','2014-04-30','16:30:00',2.52),('8537','2014-04-30','16:35:00',1.5),('8537','2014-04-30','16:40:00',2.41),('8537','2014-04-30','16:45:00',1.73),('8537','2014-04-30','16:50:00',2.2),('8537','2014-04-30','16:55:00',3.24),('8537','2014-04-30','17:00:00',1.55),('8537','2014-04-30','17:05:00',2.34),('8537','2014-04-30','17:10:00',1.45),('8537','2014-04-30','17:15:00',1.52),('8537','2014-04-30','17:20:00',1.11),('8537','2014-04-30','17:35:00',1.18),('8537','2014-04-30','17:40:00',1.29),('8537','2014-03-07','11:30:00',1.12),('8537','2014-03-07','11:35:00',1.03),('8537','2014-03-07','11:45:00',2.62),('8537','2014-03-07','11:50:00',2.37),('8537','2014-03-07','11:55:00',5.23),('8537','2014-03-07','12:00:00',5.72),('8537','2014-03-07','12:05:00',4.54),('8537','2014-03-07','12:10:00',5.52),('8537','2014-03-07','12:15:00',5.25),('8537','2014-03-07','12:20:00',5.35),('8537','2014-03-07','12:25:00',5.28),('8537','2014-03-07','12:30:00',5.35),('8537','2014-03-07','12:35:00',5.18),('8537','2014-03-07','12:40:00',3.39),('8537','2014-03-07','12:45:00',3.62),('8537','2014-03-07','12:50:00',2.27),('8537','2014-03-07','13:00:00',1.35),('8537','2014-03-07','13:05:00',3.32),('8537','2014-03-07','13:10:00',1.25),('8537','2014-03-07','13:15:00',1.69),('8537','2014-03-07','13:20:00',2.98),('8537','2014-03-07','13:25:00',3.89),('8537','2014-03-07','13:30:00',2.76),('8537','2014-03-07','13:35:00',3.37),('8537','2014-03-07','13:40:00',3.69),('8537','2014-03-07','13:45:00',2.94),('8537','2014-03-07','13:50:00',1.67),('8537','2014-03-07','13:55:00',1.36),('8537','2014-03-07','14:00:00',1.31),('8537','2014-03-07','14:05:00',1.26),('8537','2014-03-07','14:10:00',1.28),('8537','2014-03-07','14:15:00',1.25),('8537','2014-03-07','14:20:00',1.19),('8537','2014-03-07','14:25:00',1.16),('8537','2014-03-07','14:30:00',1.23),('8537','2014-03-07','14:35:00',1.29),('8537','2014-03-07','14:40:00',1.34),('8537','2014-03-07','14:45:00',1.29),('8537','2014-03-07','14:50:00',1.59),('8537','2014-03-07','14:55:00',2.28),('8537','2014-03-07','15:00:00',3.19),('8537','2014-03-07','15:05:00',3.63),('8537','2014-03-07','15:10:00',3.65),('8537','2014-03-07','15:15:00',3.76),('8537','2014-03-07','15:20:00',3.89),('8537','2014-03-07','15:25:00',3.72),('8537','2014-03-07','15:30:00',3.59),('8537','2014-03-07','15:35:00',3.34),('8537','2014-03-07','15:40:00',3.1),('8537','2014-03-07','15:45:00',2.48),('8537','2014-03-07','15:50:00',1.04),('8537','2014-03-07','16:00:00',1.46),('8537','2014-03-07','16:05:00',1.63),('8537','2014-03-07','16:10:00',1.61),('8537','2014-03-07','16:15:00',2.03),('8537','2014-03-07','16:20:00',1.9),('8537','2014-03-07','16:25:00',1.77),('8537','2014-03-07','16:30:00',1.58),('8537','2014-03-07','16:35:00',1.4),('8537','2014-03-07','16:40:00',1.46),('8537','2014-03-07','16:45:00',1.35),('8537','2014-03-07','16:50:00',1.23),('8537','2014-03-07','16:55:00',1.16),('8537','2014-03-07','17:00:00',1.06),('8537','2014-03-06','08:00:00',1.32),('8537','2014-03-06','08:05:00',1.23),('8537','2014-03-06','08:10:00',2),('8537','2014-03-06','08:15:00',2.29),('8537','2014-03-06','08:20:00',1.84),('8537','2014-03-06','08:25:00',1.65),('8537','2014-03-06','08:35:00',1.27),('8537','2014-03-06','08:40:00',1.26),('8537','2014-03-06','08:45:00',1.17),('8537','2014-03-06','08:50:00',1.24),('8537','2014-03-06','08:55:00',1.09),('8537','2014-03-06','09:00:00',1.1),('8537','2014-03-06','09:15:00',1.19),('8537','2014-03-06','09:20:00',1.29),('8537','2014-03-06','09:25:00',1.13),('8537','2014-03-06','09:30:00',1.26),('8537','2014-03-06','09:35:00',1.48),('8537','2014-03-06','09:40:00',1.8),('8537','2014-03-06','09:45:00',2.13),('8537','2014-03-06','09:50:00',2.23),('8537','2014-03-06','09:55:00',2.37),('8537','2014-03-06','10:00:00',2.36),('8537','2014-03-06','10:05:00',2.88),('8537','2014-03-06','10:10:00',3.6),('8537','2014-03-06','10:15:00',4.23),('8537','2014-03-06','10:20:00',3.6),('8537','2014-03-06','10:25:00',2.73),('8537','2014-03-06','10:30:00',1.51),('8537','2014-03-06','10:35:00',1.54),('8537','2014-03-06','10:40:00',1.94),('8537','2014-03-06','10:45:00',2.28),('8537','2014-03-06','10:50:00',1.57),('8537','2014-03-06','10:55:00',1.94),('8537','2014-03-06','11:00:00',2.99),('8537','2014-03-06','11:05:00',4.25),('8537','2014-03-06','11:10:00',2.83),('8537','2014-03-06','11:15:00',3.7),('8537','2014-03-06','11:20:00',2.04),('8537','2014-03-06','11:25:00',2.09),('8537','2014-03-06','11:30:00',2.18),('8537','2014-03-06','11:35:00',1.54),('8537','2014-03-06','11:40:00',1.95),('8537','2014-03-06','11:45:00',3.73),('8537','2014-03-06','11:50:00',4.33),('8537','2014-03-06','11:55:00',4.22),('8537','2014-03-06','12:00:00',1.82),('8537','2014-03-06','12:05:00',3.88),('8537','2014-03-06','12:10:00',5.72),('8537','2014-03-06','12:15:00',4.12),('8537','2014-03-06','12:20:00',2.8),('8537','2014-03-06','12:25:00',5.24),('8537','2014-03-06','12:30:00',5.29),('8537','2014-03-06','12:35:00',2.62),('8537','2014-03-06','12:40:00',1.84),('8537','2014-03-06','12:45:00',1.33),('8537','2014-03-06','12:50:00',1.22),('8537','2014-03-06','12:55:00',1.45),('8537','2014-03-06','13:00:00',1.54),('8537','2014-03-06','13:05:00',1.57),('8537','2014-03-06','13:10:00',1.48),('8537','2014-03-06','13:15:00',1.88),('8537','2014-03-06','13:20:00',1.41),('8537','2014-03-06','13:25:00',1.27),('8537','2014-03-06','13:30:00',1.38),('8537','2014-03-06','13:35:00',1.37),('8537','2014-03-06','13:40:00',1.47),('8537','2014-03-06','13:45:00',1.23),('8537','2014-03-06','13:50:00',1.13),('8537','2014-03-06','13:55:00',1.04),('8537','2014-03-06','14:00:00',1.06),('8537','2014-03-06','14:05:00',1.22),('8537','2014-03-06','14:10:00',1.23),('8537','2014-03-06','14:15:00',1.2),('8537','2014-03-06','14:20:00',1.39),('8537','2014-03-06','14:25:00',1.34),('8537','2014-03-06','14:30:00',1.33),('8537','2014-03-06','14:35:00',1.74),('8537','2014-03-06','14:40:00',1.31),('8537','2014-03-06','14:50:00',1.09),('8537','2014-03-06','14:55:00',1.02),('8537','2014-03-06','15:00:00',1.07),('8537','2014-03-06','15:05:00',1.24),('8537','2014-03-06','15:10:00',1.46),('8537','2014-03-06','16:25:00',1.55),('8537','2014-03-06','16:30:00',1.24),('8537','2014-03-05','07:30:00',1.04),('8537','2014-03-05','07:35:00',1.2),('8537','2014-03-05','07:40:00',1.34),('8537','2014-03-05','07:45:00',1.48),('8537','2014-03-05','07:50:00',1.59),('8537','2014-03-05','07:55:00',1.7),('8537','2014-03-05','08:00:00',1.73),('8537','2014-03-05','08:05:00',1.84),('8537','2014-03-05','08:10:00',2),('8537','2014-03-05','08:15:00',1.94),('8537','2014-03-05','08:20:00',1.12),('8537','2014-03-05','08:30:00',2.42),('8537','2014-03-05','08:35:00',2.78),('8537','2014-03-05','08:40:00',3.02),('8537','2014-03-05','08:45:00',2.7),('8537','2014-03-05','08:50:00',1),('8537','2014-03-05','08:55:00',1.23),('8537','2014-03-05','09:00:00',3.5),('8537','2014-03-05','09:05:00',1.52),('8537','2014-03-05','09:15:00',2.72),('8537','2014-03-05','09:20:00',3.44),('8537','2014-03-05','09:25:00',3.45),('8537','2014-03-05','09:30:00',3.5),('8537','2014-03-05','09:35:00',3.63),('8537','2014-03-05','09:40:00',3.69),('8537','2014-03-05','09:45:00',3.75),('8537','2014-03-05','09:50:00',3.8),('8537','2014-03-05','09:55:00',3.88),('8537','2014-03-05','10:00:00',3.97),('8537','2014-03-05','10:05:00',4.05),('8537','2014-03-05','10:10:00',4.14),('8537','2014-03-05','10:15:00',4.16),('8537','2014-03-05','10:20:00',4.21),('8537','2014-03-05','10:25:00',4.25),('8537','2014-03-05','10:30:00',4.3),('8537','2014-03-05','10:35:00',4.35),('8537','2014-03-05','10:40:00',4.37),('8537','2014-03-05','10:45:00',4.42),('8537','2014-03-05','10:50:00',4.48),('8537','2014-03-05','10:55:00',4.52),('8537','2014-03-05','11:00:00',4.56),('8537','2014-03-05','11:05:00',4.55),('8537','2014-03-05','11:10:00',4.69),('8537','2014-03-05','11:15:00',4.75),('8537','2014-03-05','11:20:00',4.77),('8537','2014-03-05','11:25:00',4.78),('8537','2014-03-05','11:30:00',4.89),('8537','2014-03-05','11:35:00',5.12),('8537','2014-03-05','11:40:00',4.97),('8537','2014-03-05','11:45:00',4.98),('8537','2014-03-05','11:50:00',4.94),('8537','2014-03-05','11:55:00',4.16),('8537','2014-03-05','12:00:00',4.31),('8537','2014-03-05','12:05:00',3.77),('8537','2014-03-05','12:10:00',1.43),('8537','2014-03-05','12:15:00',1.32),('8537','2014-03-05','12:25:00',1.03),('8537','2014-03-05','12:30:00',1.29),('8537','2014-03-05','12:35:00',1.98),('8537','2014-03-05','12:40:00',1.53),('8537','2014-03-05','12:45:00',1.49),('8537','2014-03-05','12:50:00',2.05),('8537','2014-03-05','12:55:00',2.24),('8537','2014-03-05','13:00:00',2.73),('8537','2014-03-05','13:05:00',3.41),('8537','2014-03-05','13:10:00',4.01),('8537','2014-03-05','13:15:00',3.35),('8537','2014-03-05','13:20:00',2.73),('8537','2014-03-05','13:25:00',2.21),('8537','2014-03-05','13:30:00',1.45),('8537','2014-03-05','13:35:00',1.6),('8537','2014-03-05','13:40:00',1.86),('8537','2014-03-05','13:45:00',1.71),('8537','2014-03-05','13:50:00',1.45),('8537','2014-03-05','13:55:00',1.32),('8537','2014-03-05','14:00:00',1.21),('8537','2014-03-05','14:05:00',1.19),('8537','2014-03-05','14:10:00',1.24),('8537','2014-03-05','14:15:00',1.4),('8537','2014-03-05','14:20:00',1.47),('8537','2014-03-05','14:25:00',1.6),('8537','2014-03-05','14:30:00',1.71),('8537','2014-03-05','14:35:00',1.45),('8537','2014-03-05','14:40:00',1.69),('8537','2014-03-05','14:45:00',1.92),('8537','2014-03-05','14:50:00',2.64),('8537','2014-03-05','14:55:00',1.63),('8537','2014-03-05','15:00:00',1.13),('8537','2014-03-05','15:30:00',1.17),('8537','2014-03-05','15:35:00',1.29),('8537','2014-03-05','15:40:00',2.38),('8537','2014-03-05','15:45:00',2.19),('8537','2014-03-05','15:50:00',1.49),('8537','2014-03-05','15:55:00',2.28),('8537','2014-03-05','16:00:00',2.64),('8537','2014-03-05','16:05:00',2.53),('8537','2014-03-05','16:10:00',2.28),('8537','2014-03-05','16:15:00',1.62),('8537','2014-03-04','09:05:00',1.23),('8537','2014-03-04','09:10:00',1.45),('8537','2014-03-04','09:15:00',2.48),('8537','2014-03-04','09:20:00',3.22),('8537','2014-03-04','09:25:00',1.12),('8537','2014-03-04','09:30:00',1.2),('8537','2014-03-04','09:35:00',1.2),('8537','2014-03-04','09:40:00',1.68),('8537','2014-03-04','09:45:00',2.01),('8537','2014-03-04','09:55:00',2.25),('8537','2014-03-04','10:00:00',1.97),('8537','2014-03-04','10:05:00',1.22),('8537','2014-03-04','10:20:00',1.04),('8537','2014-03-04','10:25:00',4.14),('8537','2014-03-04','10:30:00',3),('8537','2014-03-04','10:35:00',4.03),('8537','2014-03-04','10:40:00',5),('8537','2014-03-04','10:45:00',4.73),('8537','2014-03-04','10:50:00',1.66),('8537','2014-03-04','10:55:00',3.34),('8537','2014-03-04','11:00:00',3.04),('8537','2014-03-04','11:05:00',2.03),('8537','2014-03-04','11:10:00',4.32),('8537','2014-03-04','11:15:00',5.61),('8537','2014-03-04','11:20:00',4.08),('8537','2014-03-04','11:25:00',1.29),('8537','2014-03-04','11:30:00',1.12),('8537','2014-03-04','11:40:00',1.05),('8537','2014-03-04','11:45:00',2.56),('8537','2014-03-04','11:50:00',5.59),('8537','2014-03-04','11:55:00',5.16),('8537','2014-03-04','12:00:00',4.96),('8537','2014-03-04','12:05:00',4.9),('8537','2014-03-04','12:10:00',4.89),('8537','2014-03-04','12:15:00',4.86),('8537','2014-03-04','12:20:00',4.88),('8537','2014-03-04','12:25:00',4.82),('8537','2014-03-04','12:30:00',4.77),('8537','2014-03-04','12:35:00',4.73),('8537','2014-03-04','12:40:00',4.76),('8537','2014-03-04','12:45:00',4.07),('8537','2014-03-04','12:50:00',4.45),('8537','2014-03-04','12:55:00',3.22),('8537','2014-03-04','13:00:00',4.15),('8537','2014-03-04','13:05:00',4.76),('8537','2014-03-04','13:10:00',5.03),('8537','2014-03-04','13:15:00',3.98),('8537','2014-03-04','13:20:00',1.67),('8537','2014-03-04','13:25:00',1.18),('8537','2014-03-04','13:30:00',1.22),('8537','2014-03-04','13:45:00',1.04),('8537','2014-03-04','13:50:00',1.41),('8537','2014-03-04','13:55:00',1.34),('8537','2014-03-04','14:05:00',1.68),('8537','2014-03-04','14:10:00',4.01),('8537','2014-03-04','14:15:00',3.39),('8537','2014-03-04','14:20:00',1.55),('8537','2014-03-04','14:25:00',3.21),('8537','2014-03-04','14:30:00',4.03),('8537','2014-03-04','14:35:00',3.83),('8537','2014-03-04','14:40:00',3.78),('8537','2014-03-04','14:45:00',3.76),('8537','2014-03-04','14:50:00',3.15),('8537','2014-03-04','14:55:00',1.91),('8537','2014-03-04','15:00:00',3.24),('8537','2014-03-04','15:05:00',3.36),('8537','2014-03-04','15:10:00',3.28),('8537','2014-03-04','15:15:00',2.96),('8537','2014-03-04','15:20:00',1.93),('8537','2014-03-04','15:25:00',2.81),('8537','2014-03-04','15:30:00',1.54),('8537','2014-03-04','15:35:00',3.15),('8537','2014-03-04','15:40:00',2.91),('8537','2014-03-04','15:45:00',2.19),('8537','2014-03-04','15:50:00',1.93),('8537','2014-03-04','15:55:00',1.02),('8537','2014-03-04','16:05:00',1.05),('8537','2014-03-04','16:10:00',1.14),('8537','2014-03-04','16:20:00',1.04),('8537','2014-03-04','16:25:00',1.33),('8537','2014-03-04','16:30:00',1.03),('8537','2014-03-04','16:40:00',1.08),('8537','2014-03-04','16:45:00',1.11),('8537','2014-03-03','07:40:00',1.07),('8537','2014-03-03','07:45:00',1.19),('8537','2014-03-03','07:50:00',1.29),('8537','2014-03-03','07:55:00',1.13),('8537','2014-03-03','08:00:00',1.21),('8537','2014-03-03','08:05:00',1.23),('8537','2014-03-03','08:10:00',1.74),('8537','2014-03-03','08:15:00',1.92),('8537','2014-03-03','08:20:00',2.02),('8537','2014-03-03','08:25:00',2.1),('8537','2014-03-03','08:30:00',2.22),('8537','2014-03-03','08:35:00',2.32),('8537','2014-03-03','08:40:00',2.48),('8537','2014-03-03','08:45:00',2.56),('8537','2014-03-03','08:50:00',2.51),('8537','2014-03-03','08:55:00',2.83),('8537','2014-03-03','09:00:00',2.89),('8537','2014-03-03','09:05:00',2.93),('8537','2014-03-03','09:10:00',2.8),('8537','2014-03-03','09:15:00',2.85),('8537','2014-03-03','09:20:00',3.1),('8537','2014-03-03','09:25:00',3.26),('8537','2014-03-03','09:30:00',3.15),('8537','2014-03-03','09:35:00',2.9),('8537','2014-03-03','09:40:00',2.69),('8537','2014-03-03','09:45:00',2.77),('8537','2014-03-03','09:50:00',2.83),('8537','2014-03-03','09:55:00',3.34),('8537','2014-03-03','10:00:00',3.66),('8537','2014-03-03','10:05:00',3.87),('8537','2014-03-03','10:10:00',3.88),('8537','2014-03-03','10:15:00',3.94),('8537','2014-03-03','10:20:00',3.98),('8537','2014-03-03','10:25:00',4.05),('8537','2014-03-03','10:30:00',4.14),('8537','2014-03-03','10:35:00',4.17),('8537','2014-03-03','10:40:00',4.22),('8537','2014-03-03','10:45:00',4.23),('8537','2014-03-03','10:50:00',4.27),('8537','2014-03-03','10:55:00',4.3),('8537','2014-03-03','11:00:00',4.34),('8537','2014-03-03','11:05:00',4.28),('8537','2014-03-03','11:10:00',4.4),('8537','2014-03-03','11:15:00',4.43),('8537','2014-03-03','11:20:00',4.48),('8537','2014-03-03','11:25:00',4.56),('8537','2014-03-03','11:30:00',4.62),('8537','2014-03-03','11:35:00',4.56),('8537','2014-03-03','11:40:00',4.05),('8537','2014-03-03','11:45:00',4.73),('8537','2014-03-03','11:50:00',4.78),('8537','2014-03-03','11:55:00',4.78),('8537','2014-03-03','12:00:00',4.77),('8537','2014-03-03','12:05:00',4.78),('8537','2014-03-03','12:10:00',4.78),('8537','2014-03-03','12:15:00',4.76),('8537','2014-03-03','12:20:00',4.76),('8537','2014-03-03','12:25:00',4.71),('8537','2014-03-03','12:30:00',4.75),('8537','2014-03-03','12:35:00',4.74),('8537','2014-03-03','12:40:00',4.74),('8537','2014-03-03','12:45:00',4.7),('8537','2014-03-03','12:50:00',4.72),('8537','2014-03-03','12:55:00',4.69),('8537','2014-03-03','13:00:00',4.69),('8537','2014-03-03','13:05:00',4.67),('8537','2014-03-03','13:10:00',4.64),('8537','2014-03-03','13:15:00',4.59),('8537','2014-03-03','13:20:00',4.61),('8537','2014-03-03','13:25:00',4.57),('8537','2014-03-03','13:30:00',4.54),('8537','2014-03-03','13:35:00',4.5),('8537','2014-03-03','13:40:00',4.45),('8537','2014-03-03','13:45:00',4.42),('8537','2014-03-03','13:50:00',4.37),('8537','2014-03-03','13:55:00',4.33),('8537','2014-03-03','14:00:00',4.31),('8537','2014-03-03','14:05:00',4.25),('8537','2014-03-03','14:10:00',4.17),('8537','2014-03-03','14:15:00',4.18),('8537','2014-03-03','14:20:00',4.03),('8537','2014-03-03','14:25:00',3.13),('8537','2014-03-03','14:30:00',3.95),('8537','2014-03-03','14:35:00',3.89),('8537','2014-03-03','14:40:00',3.79),('8537','2014-03-03','14:45:00',3.68),('8537','2014-03-03','14:50:00',3.58),('8537','2014-03-03','14:55:00',3.51),('8537','2014-03-03','15:00:00',3.3),('8537','2014-03-03','15:05:00',2.97),('8537','2014-03-03','15:10:00',3.02),('8537','2014-03-03','15:15:00',3.12),('8537','2014-03-03','15:20:00',3.04),('8537','2014-03-03','15:25:00',2.93),('8537','2014-03-03','15:30:00',2.84),('8537','2014-03-03','15:35:00',2.72),('8537','2014-03-03','15:40:00',2.61),('8537','2014-03-03','15:45:00',2.44),('8537','2014-03-03','15:50:00',2.36),('8537','2014-03-03','15:55:00',2.24),('8537','2014-03-03','16:00:00',2.13),('8537','2014-03-03','16:05:00',2.02),('8537','2014-03-03','16:10:00',1.87),('8537','2014-03-03','16:15:00',1.62),('8537','2014-03-03','16:20:00',1.63),('8537','2014-03-03','16:25:00',1.52),('8537','2014-03-03','16:30:00',1.38),('8537','2014-03-03','16:35:00',1.23),('8537','2014-03-03','16:40:00',1.12),('8537','2014-03-03','16:45:00',1.04),('8537','2014-03-02','08:00:00',1.38),('8537','2014-03-02','08:05:00',1.62),('8537','2014-03-02','08:10:00',2.38),('8537','2014-03-02','08:15:00',2.33),('8537','2014-03-02','08:20:00',2.4),('8537','2014-03-02','08:25:00',2.18),('8537','2014-03-02','08:30:00',2.21),('8537','2014-03-02','08:35:00',2.34),('8537','2014-03-02','08:40:00',2.47),('8537','2014-03-02','08:45:00',2.59),('8537','2014-03-02','08:50:00',2.7),('8537','2014-03-02','08:55:00',2.81),('8537','2014-03-02','09:00:00',2.89),('8537','2014-03-02','09:05:00',3.02),('8537','2014-03-02','09:10:00',3.19),('8537','2014-03-02','09:15:00',3.29),('8537','2014-03-02','09:20:00',2.51),('8537','2014-03-02','09:25:00',3.32),('8537','2014-03-02','09:30:00',3.69),('8537','2014-03-02','09:35:00',3.69),('8537','2014-03-02','09:40:00',3.16),('8537','2014-03-02','09:45:00',1.75),('8537','2014-03-02','09:55:00',1.13),('8537','2014-03-02','10:00:00',1.7),('8537','2014-03-02','10:05:00',1.8),('8537','2014-03-02','10:10:00',1.73),('8537','2014-03-02','10:15:00',1.4),('8537','2014-03-02','10:20:00',1.43),('8537','2014-03-02','10:25:00',1.57),('8537','2014-03-02','10:30:00',1.77),('8537','2014-03-02','10:35:00',2.27),('8537','2014-03-02','10:40:00',3.13),('8537','2014-03-02','10:45:00',1.43),('8537','2014-03-02','10:50:00',1.37),('8537','2014-03-02','10:55:00',1.42),('8537','2014-03-02','11:00:00',2.66),('8537','2014-03-02','11:05:00',4.37),('8537','2014-03-02','11:10:00',1.9),('8537','2014-03-02','11:15:00',1.46),('8537','2014-03-02','11:20:00',1.82),('8537','2014-03-02','11:25:00',2.34),('8537','2014-03-02','11:30:00',2.35),('8537','2014-03-02','11:35:00',3.78),('8537','2014-03-02','11:40:00',3.99),('8537','2014-03-02','11:45:00',4.87),('8537','2014-03-02','11:50:00',5.72),('8537','2014-03-02','11:55:00',5.52),('8537','2014-03-02','12:00:00',3.72),('8537','2014-03-02','12:05:00',2.47),('8537','2014-03-02','12:10:00',2.39),('8537','2014-03-02','12:15:00',4.13),('8537','2014-03-02','12:20:00',2.91),('8537','2014-03-02','12:25:00',2.53),('8537','2014-03-02','12:30:00',1.74),('8537','2014-03-02','12:35:00',1.36),('8537','2014-03-02','12:40:00',1.15),('8537','2014-03-02','12:45:00',1.15),('8537','2014-03-02','12:50:00',1.27),('8537','2014-03-02','12:55:00',1.48),('8537','2014-03-02','13:00:00',1.69),('8537','2014-03-02','13:05:00',1.75),('8537','2014-03-02','13:10:00',1.74),('8537','2014-03-02','13:15:00',1.7),('8537','2014-03-02','13:20:00',1.62),('8537','2014-03-02','13:25:00',1.44),('8537','2014-03-02','13:30:00',1.29),('8537','2014-03-02','13:35:00',1.07),('8537','2014-03-02','13:50:00',1.02),('8537','2014-03-02','13:55:00',1.14),('8537','2014-03-02','14:00:00',1.44),('8537','2014-03-02','14:05:00',1.58),('8537','2014-03-02','14:10:00',1.53),('8537','2014-03-02','14:15:00',1.46),('8537','2014-03-02','14:20:00',1.37),('8537','2014-03-02','14:25:00',1.37),('8537','2014-03-02','14:30:00',1.47),('8537','2014-03-02','14:35:00',1.46),('8537','2014-03-02','14:40:00',1.48),('8537','2014-03-02','14:45:00',1.53),('8537','2014-03-02','14:50:00',1.51),('8537','2014-03-02','14:55:00',1.47),('8537','2014-03-02','15:00:00',1.52),('8537','2014-03-02','15:05:00',1.61),('8537','2014-03-02','15:10:00',1.62),('8537','2014-03-02','15:15:00',1.6),('8537','2014-03-02','15:20:00',1.51),('8537','2014-03-02','15:25:00',1.65),('8537','2014-03-02','15:30:00',1.6),('8537','2014-03-02','15:35:00',1.67),('8537','2014-03-02','15:40:00',1.55),('8537','2014-03-02','15:45:00',1.37),('8537','2014-03-02','15:50:00',1.25),('8537','2014-03-02','15:55:00',1.11),('8537','2014-02-28','07:45:00',1.03),('8537','2014-02-28','07:50:00',1.17),('8537','2014-02-28','07:55:00',1.38),('8537','2014-02-28','08:00:00',1.7),('8537','2014-02-28','08:05:00',1.2),('8537','2014-02-28','08:10:00',1),('8537','2014-02-28','08:15:00',1.53),('8537','2014-02-28','08:20:00',2.34),('8537','2014-02-28','08:25:00',1.78),('8537','2014-02-28','08:35:00',2.39),('8537','2014-02-28','08:40:00',1.17),('8537','2014-02-28','09:15:00',1.46),('8537','2014-02-28','09:20:00',1.52),('8537','2014-02-28','09:25:00',1.8),('8537','2014-02-28','09:30:00',2.28),('8537','2014-02-28','09:35:00',1.28),('8537','2014-02-28','09:40:00',2.68),('8537','2014-02-28','09:45:00',3.75),('8537','2014-02-28','09:50:00',4.33),('8537','2014-02-28','09:55:00',3.58),('8537','2014-02-28','10:00:00',1.56),('8537','2014-02-28','10:05:00',1.35),('8537','2014-02-28','10:10:00',2.23),('8537','2014-02-28','10:15:00',1.51),('8537','2014-02-28','10:20:00',2),('8537','2014-02-28','10:25:00',4.38),('8537','2014-02-28','10:30:00',4.78),('8537','2014-02-28','10:35:00',3.45),('8537','2014-02-28','10:40:00',1.64),('8537','2014-02-28','11:15:00',1.07),('8537','2014-02-28','11:20:00',1.47),('8537','2014-02-28','11:25:00',1.5),('8537','2014-02-28','11:30:00',1.27),('8537','2014-02-28','11:45:00',1.02),('8537','2014-02-28','11:50:00',1.31),('8537','2014-02-28','11:55:00',1.35),('8537','2014-02-28','12:00:00',1.68),('8537','2014-02-28','12:05:00',2.46),('8537','2014-02-28','12:10:00',2.49),('8537','2014-02-28','12:15:00',1.45),('8537','2014-02-28','12:20:00',1.16),('8537','2014-02-28','12:25:00',1.84),('8537','2014-02-28','12:30:00',2.73),('8537','2014-02-28','12:35:00',3.81),('8537','2014-02-28','12:40:00',3.68),('8537','2014-02-28','12:45:00',1.4),('8537','2014-02-28','12:50:00',3.33),('8537','2014-02-28','12:55:00',2.27),('8537','2014-02-28','13:00:00',2.94),('8537','2014-02-28','13:05:00',2.14),('8537','2014-02-28','13:10:00',1.89),('8537','2014-02-28','13:15:00',1.28),('8537','2014-02-28','13:45:00',1.03),('8537','2014-02-28','13:50:00',4.47),('8537','2014-02-28','13:55:00',4.11),('8537','2014-02-28','14:00:00',1.89),('8537','2014-02-28','14:05:00',1.21),('8537','2014-02-28','14:15:00',1.34),('8537','2014-02-28','14:20:00',2.02),('8537','2014-02-28','14:25:00',2.62),('8537','2014-02-28','14:30:00',2.19),('8537','2014-02-28','14:35:00',1.71),('8537','2014-02-28','14:40:00',1.51),('8537','2014-02-28','14:45:00',1.49),('8537','2014-02-28','14:50:00',1.59),('8537','2014-02-28','14:55:00',1.73),('8537','2014-02-28','15:00:00',2.21),('8537','2014-02-28','15:05:00',1.46),('8537','2014-02-28','15:25:00',2.57),('8537','2014-02-28','15:30:00',2.58),('8537','2014-02-28','15:35:00',2.89),('8537','2014-02-28','15:40:00',2.52),('8537','2014-02-28','16:10:00',1.15),('8537','2014-02-28','16:15:00',2.22),('8537','2014-02-28','16:20:00',1.89),('8537','2014-02-28','16:35:00',1.04),('8537','2014-02-28','16:40:00',1.25),('8537','2014-02-28','16:45:00',1.46),('8537','2014-02-28','16:50:00',1.31),('8537','2014-02-27','10:35:00',1.13),('8537','2014-02-27','10:40:00',1.29),('8537','2014-02-27','10:45:00',1.42),('8537','2014-02-27','10:50:00',1.5),('8537','2014-02-27','10:55:00',1.61),('8537','2014-02-27','11:00:00',1.83),('8537','2014-02-27','11:05:00',2.06),('8537','2014-02-27','11:10:00',1.89),('8537','2014-02-27','11:15:00',1.84),('8537','2014-02-27','11:20:00',1.72),('8537','2014-02-27','11:25:00',1.85),('8537','2014-02-27','11:30:00',2.31),('8537','2014-02-27','11:35:00',2.19),('8537','2014-02-27','11:40:00',1.78),('8537','2014-02-27','11:45:00',1.54),('8537','2014-02-27','11:50:00',1.46),('8537','2014-02-27','11:55:00',1.48),('8537','2014-02-27','12:00:00',1.45),('8537','2014-02-27','12:05:00',1.45),('8537','2014-02-27','12:10:00',1.26),('8537','2014-02-27','12:15:00',1.37),('8537','2014-02-27','12:20:00',1.48),('8537','2014-02-27','12:25:00',1.51),('8537','2014-02-27','12:30:00',1.41),('8537','2014-02-27','12:35:00',1.36),('8537','2014-02-27','12:40:00',1.33),('8537','2014-02-27','12:45:00',1.31),('8537','2014-02-27','12:50:00',1.28),('8537','2014-02-27','12:55:00',1.3),('8537','2014-02-27','13:00:00',1.38),('8537','2014-02-27','13:05:00',1.25),('8537','2014-02-27','13:10:00',1.3),('8537','2014-02-27','13:15:00',1.46),('8537','2014-02-27','13:20:00',1.47),('8537','2014-02-27','13:25:00',1.56),('8537','2014-02-27','13:30:00',1.75),('8537','2014-02-27','13:35:00',1.95),('8537','2014-02-27','13:40:00',1.97),('8537','2014-02-27','13:45:00',1.98),('8537','2014-02-27','13:50:00',2.05),('8537','2014-02-27','13:55:00',2.35),('8537','2014-02-27','14:00:00',2.32),('8537','2014-02-27','14:05:00',2.05),('8537','2014-02-27','14:10:00',1.79),('8537','2014-02-27','14:15:00',1.64),('8537','2014-02-27','14:20:00',1.67),('8537','2014-02-27','14:25:00',1.68),('8537','2014-02-27','14:30:00',1.82),('8537','2014-02-27','14:35:00',1.77),('8537','2014-02-27','14:40:00',1.56),('8537','2014-02-27','14:45:00',1.55),('8537','2014-02-27','14:50:00',1.45),('8537','2014-02-27','14:55:00',1.32),('8537','2014-02-27','15:00:00',1.39),('8537','2014-02-27','15:05:00',1.29),('8537','2014-02-27','15:10:00',1.37),('8537','2014-02-27','15:15:00',1.58),('8537','2014-02-27','15:20:00',1.7),('8537','2014-02-27','15:25:00',1.54),('8537','2014-02-27','15:30:00',1.5),('8537','2014-02-27','15:35:00',1.53),('8537','2014-02-27','15:40:00',1.27),('8537','2014-02-27','15:45:00',1.03),('8537','2014-02-27','16:40:00',1.09),('8537','2014-02-27','16:50:00',1.16),('8537','2014-02-27','16:55:00',1.14),('8537','2014-02-26','07:55:00',1.09),('8537','2014-02-26','08:00:00',1.3),('8537','2014-02-26','08:05:00',1.41),('8537','2014-02-26','08:10:00',1.59),('8537','2014-02-26','08:15:00',1.72),('8537','2014-02-26','08:20:00',1.83),('8537','2014-02-26','08:25:00',1.93),('8537','2014-02-26','08:30:00',2),('8537','2014-02-26','08:35:00',2.18),('8537','2014-02-26','08:40:00',2.31),('8537','2014-02-26','08:45:00',2.55),('8537','2014-02-26','08:50:00',2.51),('8537','2014-02-26','08:55:00',2.55),('8537','2014-02-26','09:00:00',2.62),('8537','2014-02-26','09:05:00',2.65),('8537','2014-02-26','09:10:00',2.69),('8537','2014-02-26','09:15:00',2.91),('8537','2014-02-26','09:20:00',2.99),('8537','2014-02-26','09:25:00',2.97),('8537','2014-02-26','09:30:00',2.69),('8537','2014-02-26','09:35:00',2.71),('8537','2014-02-26','09:40:00',2.52),('8537','2014-02-26','09:45:00',2.73),('8537','2014-02-26','09:50:00',2.98),('8537','2014-02-26','09:55:00',1.78),('8537','2014-02-26','10:00:00',1.71),('8537','2014-02-26','10:05:00',1.32),('8537','2014-02-26','10:10:00',1),('8537','2014-02-26','10:20:00',1.19),('8537','2014-02-26','10:25:00',1.16),('8537','2014-02-26','10:30:00',1.17),('8537','2014-02-26','10:35:00',1.08),('8537','2014-02-26','11:00:00',1.09),('8537','2014-02-26','11:05:00',1.21),('8537','2014-02-26','11:10:00',1.2),('8537','2014-02-26','11:15:00',1.19),('8537','2014-02-26','11:50:00',1.02),('8537','2014-02-26','11:55:00',1.13),('8537','2014-02-26','12:00:00',1.38),('8537','2014-02-26','12:05:00',2.62),('8537','2014-02-26','12:10:00',2.27),('8537','2014-02-26','12:15:00',1.47),('8537','2014-02-26','12:20:00',1.22),('8537','2014-02-26','12:25:00',1.48),('8537','2014-02-26','12:30:00',2.46),('8537','2014-02-26','12:35:00',2.26),('8537','2014-02-26','12:40:00',2.89),('8537','2014-02-26','12:45:00',3.14),('8537','2014-02-26','12:50:00',3.86),('8537','2014-02-26','12:55:00',3.51),('8537','2014-02-26','13:00:00',4.39),('8537','2014-02-26','13:05:00',3.92),('8537','2014-02-26','13:10:00',3.78),('8537','2014-02-26','13:15:00',3.63),('8537','2014-02-26','13:20:00',3.81),('8537','2014-02-26','13:25:00',2.89),('8537','2014-02-26','13:30:00',4.61),('8537','2014-02-26','13:35:00',4.28),('8537','2014-02-26','13:40:00',3.92),('8537','2014-02-26','13:45:00',3.62),('8537','2014-02-26','13:50:00',2.3),('8537','2014-02-26','13:55:00',1.46),('8537','2014-02-26','14:00:00',4.4),('8537','2014-02-26','14:05:00',4.08),('8537','2014-02-26','14:10:00',2.02),('8537','2014-02-26','14:15:00',2.72),('8537','2014-02-26','14:20:00',4.32),('8537','2014-02-26','14:25:00',3.95),('8537','2014-02-26','14:30:00',1.76),('8537','2014-02-26','14:35:00',1.89),('8537','2014-02-26','14:40:00',3.9),('8537','2014-02-26','14:45:00',3.6),('8537','2014-02-26','14:50:00',3.15),('8537','2014-02-26','14:55:00',3.71),('8537','2014-02-26','15:00:00',3.41),('8537','2014-02-26','15:05:00',3.15),('8537','2014-02-26','15:10:00',2.95),('8537','2014-02-26','15:15:00',2.59),('8537','2014-02-26','15:20:00',2.16),('8537','2014-02-26','15:25:00',1.14),('8537','2014-02-26','15:30:00',1.48),('8537','2014-02-26','15:35:00',2.05),('8537','2014-02-26','15:40:00',1.98),('8537','2014-02-26','15:45:00',1.59),('8537','2014-02-26','15:50:00',1.44),('8537','2014-02-26','15:55:00',1.79),('8537','2014-02-26','16:00:00',2.08),('8537','2014-02-26','16:05:00',1.9),('8537','2014-02-26','16:10:00',1.31),('8537','2014-04-29','09:50:00',1.17),('8537','2014-04-29','09:55:00',1.31),('8537','2014-04-29','10:00:00',1.34),('8537','2014-04-29','10:05:00',2.07),('8537','2014-04-29','10:10:00',3.79),('8537','2014-04-29','10:15:00',3.94),('8537','2014-04-29','10:20:00',3.72),('8537','2014-04-29','10:25:00',4.37),('8537','2014-04-29','10:30:00',4.68),('8537','2014-04-29','10:35:00',4.64),('8537','2014-04-29','10:40:00',4.67),('8537','2014-04-29','10:45:00',4.69),('8537','2014-04-29','10:50:00',4.78),('8537','2014-04-29','10:55:00',4.58),('8537','2014-04-29','11:00:00',4.69),('8537','2014-04-29','11:05:00',4.74),('8537','2014-04-29','11:10:00',4.77),('8537','2014-04-29','11:15:00',4.41),('8537','2014-04-29','11:20:00',5.28),('8537','2014-04-29','11:25:00',4.07),('8537','2014-04-29','11:30:00',4.72),('8537','2014-04-29','11:35:00',4.85),('8537','2014-04-29','11:40:00',4.02),('8537','2014-04-29','11:45:00',2.44),('8537','2014-04-29','11:50:00',1.69),('8537','2014-04-29','11:55:00',1.35),('8537','2014-04-29','12:00:00',1.6),('8537','2014-04-29','12:05:00',2.26),('8537','2014-04-29','12:10:00',2.48),('8537','2014-04-29','12:15:00',2.81),('8537','2014-04-29','12:20:00',2.53),('8537','2014-04-29','12:25:00',3.35),('8537','2014-04-29','12:30:00',3.46),('8537','2014-04-29','12:35:00',2.12),('8537','2014-04-29','12:40:00',4.64),('8537','2014-04-29','12:45:00',3.24),('8537','2014-04-29','12:50:00',4.85),('8537','2014-04-29','12:55:00',2.43),('8537','2014-04-29','13:00:00',2.53),('8537','2014-04-29','13:05:00',2.15),('8537','2014-04-29','13:10:00',2.15),('8537','2014-04-29','13:15:00',2.88),('8537','2014-04-29','13:20:00',3.63),('8537','2014-04-29','13:25:00',4.13),('8537','2014-04-29','13:30:00',3.63),('8537','2014-04-29','13:35:00',2.12),('8537','2014-04-29','13:40:00',1.75),('8537','2014-04-29','13:45:00',1.89),('8537','2014-04-29','13:50:00',1.95),('8537','2014-04-29','13:55:00',1.39),('8537','2014-04-29','15:05:00',1.3),('8537','2014-04-29','16:15:00',1.05),('8537','2014-04-29','16:20:00',1.22),('8537','2014-04-29','16:25:00',1.36),('8537','2014-04-29','16:30:00',1.17),('8537','2014-04-29','17:00:00',1.1),('8537','2014-04-29','17:05:00',1.39),('8537','2014-04-29','17:10:00',1.37),('8537','2014-04-29','17:15:00',1.07),('8537','2014-04-29','17:25:00',2.08),('8537','2014-04-29','17:30:00',1.85),('8537','2014-04-29','17:35:00',1.64),('8537','2014-04-29','17:40:00',1.88),('8537','2014-04-29','17:45:00',1.73),('8537','2014-02-25','07:50:00',1.02),('8537','2014-02-25','07:55:00',1.14),('8537','2014-02-25','08:00:00',1.26),('8537','2014-02-25','08:05:00',1.39),('8537','2014-02-25','08:10:00',1.5),('8537','2014-02-25','08:15:00',1.63),('8537','2014-02-25','08:20:00',1.74),('8537','2014-02-25','08:25:00',1.86),('8537','2014-02-25','08:30:00',1.96),('8537','2014-02-25','08:35:00',2.07),('8537','2014-02-25','08:40:00',2.17),('8537','2014-02-25','08:45:00',2.27),('8537','2014-02-25','08:50:00',2.37),('8537','2014-02-25','08:55:00',2.47),('8537','2014-02-25','09:00:00',2.58),('8537','2014-02-25','09:05:00',2.68),('8537','2014-02-25','09:10:00',2.78),('8537','2014-02-25','09:15:00',2.87),('8537','2014-02-25','09:20:00',2.95),('8537','2014-02-25','09:25:00',3.04),('8537','2014-02-25','09:30:00',3.11),('8537','2014-02-25','09:35:00',3.16),('8537','2014-02-25','09:40:00',3.25),('8537','2014-02-25','09:45:00',3.34),('8537','2014-02-25','09:50:00',3.4),('8537','2014-02-25','09:55:00',3.46),('8537','2014-02-25','10:00:00',3.51),('8537','2014-02-25','10:05:00',3.59),('8537','2014-02-25','10:10:00',3.68),('8537','2014-02-25','10:15:00',3.75),('8537','2014-02-25','10:20:00',3.79),('8537','2014-02-25','10:25:00',3.84),('8537','2014-02-25','10:30:00',3.91),('8537','2014-02-25','10:35:00',3.93),('8537','2014-02-25','10:40:00',3.96),('8537','2014-02-25','10:45:00',3.98),('8537','2014-02-25','10:50:00',4.05),('8537','2014-02-25','10:55:00',4.05),('8537','2014-02-25','11:00:00',4.09),('8537','2014-02-25','11:05:00',4.14),('8537','2014-02-25','11:10:00',4.22),('8537','2014-02-25','11:15:00',4.24),('8537','2014-02-25','11:20:00',4.26),('8537','2014-02-25','11:25:00',4.24),('8537','2014-02-25','11:30:00',4.23),('8537','2014-02-25','11:35:00',4.32),('8537','2014-02-25','11:40:00',4.29),('8537','2014-02-25','11:45:00',4.28),('8537','2014-02-25','11:50:00',4.29),('8537','2014-02-25','11:55:00',4.34),('8537','2014-02-25','12:00:00',4.37),('8537','2014-02-25','12:05:00',4.42),('8537','2014-02-25','12:10:00',4.48),('8537','2014-02-25','12:15:00',4.39),('8537','2014-02-25','12:20:00',4.36),('8537','2014-02-25','12:25:00',4.37),('8537','2014-02-25','12:30:00',4.41),('8537','2014-02-25','12:35:00',4.39),('8537','2014-02-25','12:40:00',4.43),('8537','2014-02-25','12:45:00',4.46),('8537','2014-02-25','12:50:00',4.49),('8537','2014-02-25','12:55:00',4.43),('8537','2014-02-25','13:00:00',4.34),('8537','2014-02-25','13:05:00',4.33),('8537','2014-02-25','13:10:00',4.3),('8537','2014-02-25','13:15:00',3.45),('8537','2014-02-25','13:20:00',1.2),('8537','2014-02-25','13:25:00',1.2),('8537','2014-02-25','13:30:00',1.06),('8537','2014-02-25','13:35:00',1.25),('8537','2014-02-25','13:40:00',2.07),('8537','2014-02-25','13:45:00',1.33),('8537','2014-02-25','13:50:00',1.21),('8537','2014-02-25','13:55:00',1.44),('8537','2014-02-25','14:00:00',1.55),('8537','2014-02-25','14:05:00',1.39),('8537','2014-02-25','14:10:00',1.21),('8537','2014-02-25','14:15:00',1.31),('8537','2014-02-25','14:20:00',1.38),('8537','2014-02-25','14:25:00',1.66),('8537','2014-02-25','14:30:00',1.69),('8537','2014-02-25','14:35:00',2.63),('8537','2014-02-25','14:40:00',3.61),('8537','2014-02-25','14:45:00',3.62),('8537','2014-02-25','14:50:00',3.37),('8537','2014-02-25','14:55:00',2.36),('8537','2014-02-25','15:00:00',2.7),('8537','2014-02-25','15:05:00',2.85),('8537','2014-02-25','15:10:00',2.8),('8537','2014-02-25','15:15:00',2.65),('8537','2014-02-25','15:20:00',2.68),('8537','2014-02-25','15:25:00',2.33),('8537','2014-02-25','15:30:00',2.06),('8537','2014-02-25','15:35:00',1.93),('8537','2014-02-25','15:40:00',2.06),('8537','2014-02-25','15:45:00',1.42),('8537','2014-02-25','15:50:00',1.06),('8537','2014-02-25','15:55:00',1.27),('8537','2014-02-25','16:00:00',1.1),('8537','2014-02-25','16:05:00',1.19),('8537','2014-02-25','16:10:00',1.1),('8537','2014-02-25','16:15:00',1.19),('8537','2014-02-25','16:20:00',1.27),('8537','2014-02-24','07:55:00',1.14),('8537','2014-02-24','08:00:00',1.33),('8537','2014-02-24','08:05:00',1.57),('8537','2014-02-24','08:10:00',1.78),('8537','2014-02-24','08:15:00',1.93),('8537','2014-02-24','08:20:00',2.09),('8537','2014-02-24','08:25:00',2.24),('8537','2014-02-24','08:30:00',2.29),('8537','2014-02-24','08:35:00',2.49),('8537','2014-02-24','08:40:00',2.13),('8537','2014-02-24','08:45:00',2.55),('8537','2014-02-24','08:50:00',2.58),('8537','2014-02-24','08:55:00',2.56),('8537','2014-02-24','09:00:00',2.6),('8537','2014-02-24','09:05:00',2.67),('8537','2014-02-24','09:10:00',2.76),('8537','2014-02-24','09:15:00',2.87),('8537','2014-02-24','09:20:00',2.97),('8537','2014-02-24','09:25:00',3.07),('8537','2014-02-24','09:30:00',3.16),('8537','2014-02-24','09:35:00',3.24),('8537','2014-02-24','09:40:00',3.31),('8537','2014-02-24','09:45:00',3.41),('8537','2014-02-24','09:50:00',3.47),('8537','2014-02-24','09:55:00',3.55),('8537','2014-02-24','10:00:00',3.6),('8537','2014-02-24','10:05:00',3.68),('8537','2014-02-24','10:10:00',3.77),('8537','2014-02-24','10:15:00',3.85),('8537','2014-02-24','10:20:00',3.92),('8537','2014-02-24','10:25:00',3.97),('8537','2014-02-24','10:30:00',4.04),('8537','2014-02-24','10:35:00',4.07),('8537','2014-02-24','10:40:00',4.08),('8537','2014-02-24','10:45:00',4.15),('8537','2014-02-24','10:50:00',4.23),('8537','2014-02-24','10:55:00',4.26),('8537','2014-02-24','11:00:00',4.3),('8537','2014-02-24','11:05:00',4.33),('8537','2014-02-24','11:10:00',4.36),('8537','2014-02-24','11:15:00',4.3),('8537','2014-02-24','11:20:00',4.41),('8537','2014-02-24','11:25:00',4.55),('8537','2014-02-24','11:30:00',4.89),('8537','2014-02-24','11:35:00',3.44),('8537','2014-02-24','11:40:00',3.87),('8537','2014-02-24','11:45:00',4.76),('8537','2014-02-24','11:50:00',3.77),('8537','2014-02-24','11:55:00',3.73),('8537','2014-02-24','12:00:00',4.06),('8537','2014-02-24','12:05:00',3.69),('8537','2014-02-24','12:10:00',2.66),('8537','2014-02-24','12:15:00',2.9),('8537','2014-02-24','12:20:00',2.22),('8537','2014-02-24','12:25:00',4.1),('8537','2014-02-24','12:30:00',4.33),('8537','2014-02-24','12:35:00',3.74),('8537','2014-02-24','12:40:00',5.06),('8537','2014-02-24','12:45:00',4.47),('8537','2014-02-24','12:50:00',4.73),('8537','2014-02-24','12:55:00',4.5),('8537','2014-02-24','13:00:00',4.74),('8537','2014-02-24','13:05:00',3.89),('8537','2014-02-24','13:10:00',5.12),('8537','2014-02-24','13:15:00',4.99),('8537','2014-02-24','13:20:00',1.81),('8537','2014-02-24','13:25:00',1.25),('8537','2014-02-24','13:30:00',1.12),('8537','2014-02-24','13:35:00',1.03),('8537','2014-02-24','14:00:00',1.01),('8537','2014-02-24','14:05:00',1.06),('8537','2014-02-24','14:10:00',1.13),('8537','2014-02-24','14:15:00',1.13),('8537','2014-02-24','14:20:00',1.11),('8537','2014-02-24','14:25:00',1.14),('8537','2014-02-24','14:30:00',1.21),('8537','2014-02-24','14:35:00',1.2),('8537','2014-02-24','14:40:00',1.2),('8537','2014-02-24','14:45:00',1.29),('8537','2014-02-24','14:50:00',1.18),('8537','2014-02-24','15:05:00',1),('8537','2014-02-24','15:10:00',1.1),('8537','2014-02-24','15:15:00',1.16),('8537','2014-02-24','15:20:00',1.35),('8537','2014-02-24','15:25:00',1.65),('8537','2014-02-24','15:30:00',1.4),('8537','2014-02-24','15:35:00',2.74),('8537','2014-02-24','15:40:00',3.09),('8537','2014-02-24','15:45:00',2.81),('8537','2014-02-24','15:50:00',2.56),('8537','2014-02-24','15:55:00',2.29),('8537','2014-02-24','16:00:00',2.45),('8537','2014-02-24','16:05:00',2.41),('8537','2014-02-24','16:10:00',2.16),('8537','2014-02-24','16:15:00',1.9),('8537','2014-02-24','16:20:00',1.69),('8537','2014-02-24','16:25:00',1.32),('8537','2014-02-23','07:55:00',1.08),('8537','2014-02-23','08:00:00',1.22),('8537','2014-02-23','08:05:00',1.33),('8537','2014-02-23','08:10:00',1.46),('8537','2014-02-23','08:15:00',1.57),('8537','2014-02-23','08:20:00',1.69),('8537','2014-02-23','08:25:00',1.8),('8537','2014-02-23','08:30:00',1.9),('8537','2014-02-23','08:35:00',1.98),('8537','2014-02-23','08:40:00',2.12),('8537','2014-02-23','08:45:00',2.23),('8537','2014-02-23','08:50:00',2.34),('8537','2014-02-23','08:55:00',2.42),('8537','2014-02-23','09:00:00',2.54),('8537','2014-02-23','09:05:00',2.65),('8537','2014-02-23','09:10:00',2.76),('8537','2014-02-23','09:15:00',2.87),('8537','2014-02-23','09:20:00',2.98),('8537','2014-02-23','09:25:00',2.96),('8537','2014-02-23','09:30:00',2.79),('8537','2014-02-23','09:35:00',3.23),('8537','2014-02-23','09:40:00',3.3),('8537','2014-02-23','09:45:00',3.36),('8537','2014-02-23','09:50:00',3.36),('8537','2014-02-23','09:55:00',3.47),('8537','2014-02-23','10:00:00',3.54),('8537','2014-02-23','10:05:00',3.59),('8537','2014-02-23','10:10:00',3.62),('8537','2014-02-23','10:15:00',3.64),('8537','2014-02-23','10:20:00',3.81),('8537','2014-02-23','10:25:00',3.85),('8537','2014-02-23','10:30:00',3.92),('8537','2014-02-23','10:35:00',4.01),('8537','2014-02-23','10:40:00',4.01),('8537','2014-02-23','10:45:00',4.02),('8537','2014-02-23','10:50:00',4.01),('8537','2014-02-23','10:55:00',4.15),('8537','2014-02-23','11:00:00',4.18),('8537','2014-02-23','11:05:00',3.25),('8537','2014-02-23','11:10:00',4.34),('8537','2014-02-23','11:15:00',4.31),('8537','2014-02-23','11:20:00',3.68),('8537','2014-02-23','11:25:00',4.46),('8537','2014-02-23','11:30:00',4.57),('8537','2014-02-23','11:35:00',4.56),('8537','2014-02-23','11:40:00',4.6),('8537','2014-02-23','11:45:00',4.35),('8537','2014-02-23','11:50:00',3.27),('8537','2014-02-23','11:55:00',4.24),('8537','2014-02-23','12:00:00',2.27),('8537','2014-02-23','12:05:00',4.84),('8537','2014-02-23','12:10:00',4.92),('8537','2014-02-23','12:15:00',4.92),('8537','2014-02-23','12:20:00',4.47),('8537','2014-02-23','12:25:00',2.9),('8537','2014-02-23','12:30:00',3.34),('8537','2014-02-23','12:35:00',5.01),('8537','2014-02-23','12:40:00',2.87),('8537','2014-02-23','12:45:00',2.89),('8537','2014-02-23','12:50:00',2.21),('8537','2014-02-23','12:55:00',2.68),('8537','2014-02-23','13:00:00',2.92),('8537','2014-02-23','13:05:00',4.61),('8537','2014-02-23','13:10:00',4.56),('8537','2014-02-23','13:15:00',4.5),('8537','2014-02-23','13:20:00',4.44),('8537','2014-02-23','13:25:00',4.44),('8537','2014-02-23','13:30:00',4.32),('8537','2014-02-23','13:35:00',2.51),('8537','2014-02-23','13:40:00',3.5),('8537','2014-02-23','13:45:00',3.78),('8537','2014-02-23','13:50:00',2.19),('8537','2014-02-23','14:00:00',3.61),('8537','2014-02-23','14:05:00',3.83),('8537','2014-02-23','14:10:00',4.22),('8537','2014-02-23','14:15:00',3.06),('8537','2014-02-23','14:20:00',2.38),('8537','2014-02-23','14:25:00',3.13),('8537','2014-02-23','14:30:00',3.51),('8537','2014-02-23','14:35:00',2.15),('8537','2014-02-23','14:40:00',1.35),('8537','2014-02-23','14:45:00',1.9),('8537','2014-02-23','14:50:00',1.66),('8537','2014-02-22','09:05:00',1),('8537','2014-02-22','09:10:00',1.34),('8537','2014-02-22','09:40:00',1),('8537','2014-02-22','09:45:00',1.02),('8537','2014-02-22','09:50:00',1.14),('8537','2014-02-22','09:55:00',1.16),('8537','2014-02-22','10:00:00',1.9),('8537','2014-02-22','10:05:00',2.81),('8537','2014-02-22','10:10:00',2.73),('8537','2014-02-22','10:15:00',2.6),('8537','2014-02-22','10:20:00',1.54),('8537','2014-02-22','10:25:00',2.4),('8537','2014-02-22','10:30:00',3.11),('8537','2014-02-22','10:35:00',2.15),('8537','2014-02-22','10:40:00',2.08),('8537','2014-02-22','10:45:00',4.01),('8537','2014-02-22','10:50:00',4.62),('8537','2014-02-22','10:55:00',1.38),('8537','2014-02-22','11:10:00',1.02),('8537','2014-02-22','12:00:00',1.12),('8537','2014-02-22','12:05:00',1.46),('8537','2014-02-22','12:10:00',1.74),('8537','2014-02-22','12:15:00',2.42),('8537','2014-02-22','12:20:00',2.09),('8537','2014-02-22','12:25:00',2.09),('8537','2014-02-22','12:30:00',1.25),('8537','2014-02-22','12:35:00',1.3),('8537','2014-02-22','12:40:00',1.53),('8537','2014-02-22','12:45:00',4.43),('8537','2014-02-22','12:50:00',3.94),('8537','2014-02-22','12:55:00',1.75),('8537','2014-02-22','13:00:00',1.66),('8537','2014-02-22','13:05:00',2.2),('8537','2014-02-22','13:10:00',5.51),('8537','2014-02-22','13:15:00',3.17),('8537','2014-02-22','13:20:00',1.77),('8537','2014-02-22','13:25:00',1.2),('8537','2014-02-22','13:30:00',1.38),('8537','2014-02-22','13:35:00',1.88),('8537','2014-02-22','13:40:00',2.78),('8537','2014-02-22','13:45:00',2.16),('8537','2014-02-22','13:50:00',1.91),('8537','2014-02-22','13:55:00',4.05),('8537','2014-02-22','14:00:00',4.4),('8537','2014-02-22','14:05:00',3.4),('8537','2014-02-22','14:10:00',4.23),('8537','2014-02-22','14:15:00',3.69),('8537','2014-02-22','14:20:00',3.9),('8537','2014-02-22','14:25:00',3.49),('8537','2014-02-22','14:30:00',3.45),('8537','2014-02-22','14:35:00',1.99),('8537','2014-02-22','14:40:00',3.18),('8537','2014-02-22','14:45:00',3.71),('8537','2014-02-22','14:50:00',3.46),('8537','2014-02-22','14:55:00',1.01),('8537','2014-02-22','15:00:00',1.97),('8537','2014-02-22','15:05:00',2.74),('8537','2014-02-22','15:10:00',1.77),('8537','2014-02-22','15:15:00',1.88),('8537','2014-02-22','15:20:00',1.22),('8537','2014-02-22','15:25:00',1.47),('8537','2014-02-22','15:30:00',2.16),('8537','2014-02-22','15:35:00',2.35),('8537','2014-02-22','15:45:00',2.37),('8537','2014-02-22','15:50:00',2.23),('8537','2014-02-22','15:55:00',1.19),('8537','2014-02-22','16:00:00',1.59),('8537','2014-02-22','16:10:00',1.26),('8537','2014-02-22','16:15:00',1.56),('8537','2014-02-22','16:20:00',1.4),('8537','2014-02-22','16:25:00',1.27),('8537','2014-02-22','16:30:00',1.07),('8537','2014-02-21','09:20:00',1),('8537','2014-02-21','09:25:00',1.06),('8537','2014-02-21','09:30:00',1.07),('8537','2014-02-21','09:35:00',1.14),('8537','2014-02-21','09:40:00',1.18),('8537','2014-02-21','09:45:00',1.24),('8537','2014-02-21','09:50:00',1.42),('8537','2014-02-21','09:55:00',1.45),('8537','2014-02-21','10:00:00',1.44),('8537','2014-02-21','10:05:00',1.74),('8537','2014-02-21','10:10:00',1.64),('8537','2014-02-21','10:15:00',1.8),('8537','2014-02-21','10:20:00',2.47),('8537','2014-02-21','10:25:00',3.04),('8537','2014-02-21','10:30:00',3.56),('8537','2014-02-21','10:35:00',2.64),('8537','2014-02-21','10:40:00',2.28),('8537','2014-02-21','10:45:00',2.18),('8537','2014-02-21','10:50:00',1.85),('8537','2014-02-21','10:55:00',2.67),('8537','2014-02-21','11:00:00',2.38),('8537','2014-02-21','11:05:00',1.81),('8537','2014-02-21','11:10:00',1.76),('8537','2014-02-21','11:15:00',1.96),('8537','2014-02-21','11:20:00',1.93),('8537','2014-02-21','11:25:00',2.58),('8537','2014-02-21','11:30:00',4.26),('8537','2014-02-21','11:35:00',3.04),('8537','2014-02-21','11:40:00',3.11),('8537','2014-02-21','11:45:00',3.6),('8537','2014-02-21','11:50:00',2.07),('8537','2014-02-21','11:55:00',2.96),('8537','2014-02-21','12:00:00',5.37),('8537','2014-02-21','12:05:00',4.34),('8537','2014-02-21','12:10:00',4.61),('8537','2014-02-21','12:15:00',2.63),('8537','2014-02-21','12:20:00',1.72),('8537','2014-02-21','12:25:00',1.87),('8537','2014-02-21','12:30:00',1.75),('8537','2014-02-21','12:35:00',1.51),('8537','2014-02-21','12:40:00',1.28),('8537','2014-02-21','12:45:00',1.01),('8537','2014-02-21','15:00:00',1.09),('8537','2014-02-21','15:05:00',1.47),('8537','2014-02-21','15:20:00',1.4),('8537','2014-02-21','15:25:00',2.02),('8537','2014-02-21','15:30:00',2.36),('8537','2014-02-21','15:35:00',2.34),('8537','2014-02-21','15:40:00',2.16),('8537','2014-02-21','15:45:00',2.12),('8537','2014-02-21','15:50:00',1.95),('8537','2014-02-21','15:55:00',1.81),('8537','2014-02-21','16:00:00',1.62),('8537','2014-02-21','16:05:00',1.52),('8537','2014-02-21','16:10:00',1.4),('8537','2014-02-21','16:15:00',1.35),('8537','2014-02-21','16:20:00',1.22),('8537','2014-02-21','16:25:00',1.11),('8537','2014-02-20','11:20:00',1.01),('8537','2014-02-20','11:25:00',1.23),('8537','2014-02-20','11:30:00',1.23),('8537','2014-02-20','11:35:00',1.03),('8537','2014-02-20','12:00:00',1.11),('8537','2014-02-20','12:25:00',1.07),('8537','2014-02-20','12:30:00',1.17),('8537','2014-02-20','12:35:00',1.16),('8537','2014-02-20','12:40:00',1.2),('8537','2014-02-20','12:45:00',1),('8537','2014-02-20','12:50:00',1.04),('8537','2014-02-20','12:55:00',1.34),('8537','2014-02-20','13:00:00',1.61),('8537','2014-02-20','13:15:00',1.44),('8537','2014-02-20','13:20:00',1.24),('8537','2014-02-20','13:30:00',1.32),('8537','2014-02-20','13:35:00',1.23),('8537','2014-02-20','14:00:00',1.04),('8537','2014-02-19','09:20:00',1.03),('8537','2014-02-19','09:25:00',1.18),('8537','2014-02-19','09:30:00',1.22),('8537','2014-02-19','09:35:00',1.42),('8537','2014-02-19','09:40:00',1.51),('8537','2014-02-19','09:45:00',1.82),('8537','2014-02-19','09:50:00',1.69),('8537','2014-02-19','09:55:00',1.56),('8537','2014-02-19','10:00:00',1.5),('8537','2014-02-19','10:05:00',1.49),('8537','2014-02-19','10:10:00',1.62),('8537','2014-02-19','10:15:00',1.68),('8537','2014-02-19','10:20:00',1.51),('8537','2014-02-19','10:25:00',1.54),('8537','2014-02-19','10:30:00',1.69),('8537','2014-02-19','10:35:00',1.77),('8537','2014-02-19','10:40:00',2.06),('8537','2014-02-19','10:45:00',2.3),('8537','2014-02-19','10:50:00',2.08),('8537','2014-02-19','10:55:00',1.83),('8537','2014-02-19','11:00:00',1.67),('8537','2014-02-19','11:05:00',1.76),('8537','2014-02-19','11:10:00',2.06),('8537','2014-02-19','11:15:00',1.99),('8537','2014-02-19','11:20:00',2.14),('8537','2014-02-19','11:25:00',2.02),('8537','2014-02-19','11:30:00',1.91),('8537','2014-02-19','11:35:00',1.84),('8537','2014-02-19','11:40:00',1.71),('8537','2014-02-19','11:45:00',1.65),('8537','2014-02-19','11:50:00',1.61),('8537','2014-02-19','11:55:00',1.4),('8537','2014-02-19','12:00:00',1.54),('8537','2014-02-19','12:05:00',1.75),('8537','2014-02-19','12:10:00',1.7),('8537','2014-02-19','12:15:00',1.64),('8537','2014-02-19','12:20:00',1.41),('8537','2014-02-19','12:25:00',1.66),('8537','2014-02-19','12:30:00',1.91),('8537','2014-02-19','12:35:00',1.58),('8537','2014-02-19','12:40:00',1.5),('8537','2014-02-19','12:45:00',1.51),('8537','2014-02-19','12:50:00',1.19),('8537','2014-02-19','13:00:00',1.15),('8537','2014-02-19','13:05:00',1.34),('8537','2014-02-19','13:10:00',1.25),('8537','2014-02-19','13:15:00',1.39),('8537','2014-02-19','13:20:00',1.5),('8537','2014-02-19','13:25:00',1.62),('8537','2014-02-19','13:30:00',1.63),('8537','2014-02-19','13:35:00',2),('8537','2014-02-19','13:40:00',1.86),('8537','2014-02-19','13:45:00',2.12),('8537','2014-02-19','13:50:00',2.46),('8537','2014-02-19','13:55:00',2.24),('8537','2014-02-19','14:00:00',2.05),('8537','2014-02-19','14:05:00',2.27),('8537','2014-02-19','14:10:00',1.84),('8537','2014-02-19','14:15:00',1.61),('8537','2014-02-19','14:20:00',2.49),('8537','2014-02-19','14:25:00',1.97),('8537','2014-02-19','14:30:00',1.83),('8537','2014-02-19','14:35:00',1.95),('8537','2014-02-19','14:40:00',1.61),('8537','2014-02-19','14:45:00',1.56),('8537','2014-02-19','14:50:00',1.96),('8537','2014-02-19','14:55:00',1.74),('8537','2014-02-19','15:00:00',1.43),('8537','2014-02-19','15:05:00',1.4),('8537','2014-02-19','15:10:00',1.34),('8537','2014-02-19','15:15:00',1.54),('8537','2014-02-19','15:20:00',1.21),('8537','2014-02-19','15:25:00',1.38),('8537','2014-02-19','15:30:00',1.18),('8537','2014-02-19','15:35:00',1.05),('8537','2014-02-19','15:40:00',1.1),('8537','2014-02-19','15:45:00',1.11),('8537','2014-02-19','15:50:00',1.36),('8537','2014-02-19','15:55:00',1.13),('8537','2014-04-28','08:15:00',1.89),('8537','2014-04-28','08:20:00',1.95),('8537','2014-04-28','08:25:00',1.95),('8537','2014-04-28','08:30:00',1.5),('8537','2014-04-28','08:35:00',1.43),('8537','2014-04-28','08:40:00',1.34),('8537','2014-04-28','08:45:00',1.59),('8537','2014-04-28','08:50:00',1.64),('8537','2014-04-28','08:55:00',1.59),('8537','2014-04-28','09:00:00',1.24),('8537','2014-04-28','09:05:00',1.13),('8537','2014-04-28','09:10:00',2.28),('8537','2014-04-28','09:15:00',3.52),('8537','2014-04-28','09:20:00',2.66),('8537','2014-04-28','09:25:00',2.74),('8537','2014-04-28','09:30:00',2.04),('8537','2014-04-28','09:35:00',2.62),('8537','2014-04-28','09:40:00',2.25),('8537','2014-04-28','09:45:00',2.36),('8537','2014-04-28','09:50:00',3.01),('8537','2014-04-28','09:55:00',1.48),('8537','2014-04-28','10:00:00',2.09),('8537','2014-04-28','10:05:00',2.7),('8537','2014-04-28','10:10:00',2.7),('8537','2014-04-28','10:15:00',2.58),('8537','2014-04-28','10:20:00',2.14),('8537','2014-04-28','10:25:00',1.56),('8537','2014-04-28','10:40:00',1.01),('8537','2014-04-28','10:45:00',1.74),('8537','2014-04-28','10:50:00',2.37),('8537','2014-04-28','10:55:00',2.25),('8537','2014-04-28','11:00:00',2.18),('8537','2014-04-28','11:05:00',2.73),('8537','2014-04-28','11:10:00',3.05),('8537','2014-04-28','11:15:00',2.94),('8537','2014-04-28','11:20:00',2.82),('8537','2014-04-28','11:25:00',2.17),('8537','2014-04-28','11:30:00',2.3),('8537','2014-04-28','11:35:00',2.15),('8537','2014-04-28','11:40:00',1.8),('8537','2014-04-28','11:45:00',1.89),('8537','2014-04-28','11:50:00',2.15),('8537','2014-04-28','11:55:00',2.31),('8537','2014-04-28','12:00:00',2.09),('8537','2014-04-28','12:05:00',1.56),('8537','2014-04-28','12:10:00',2.15),('8537','2014-04-28','12:15:00',3.23),('8537','2014-04-28','12:20:00',3.46),('8537','2014-04-28','12:25:00',3.3),('8537','2014-04-28','12:30:00',3.17),('8537','2014-04-28','12:35:00',2.89),('8537','2014-04-28','12:40:00',2.59),('8537','2014-04-28','12:45:00',2.24),('8537','2014-04-28','12:50:00',2.71),('8537','2014-04-28','12:55:00',2.6),('8537','2014-04-28','13:00:00',2.72),('8537','2014-04-28','13:05:00',3.16),('8537','2014-04-28','13:10:00',4.43),('8537','2014-04-28','13:15:00',2.71),('8537','2014-04-28','13:20:00',2.66),('8537','2014-04-28','13:25:00',3.16),('8537','2014-04-28','13:30:00',5.14),('8537','2014-04-28','13:35:00',4.16),('8537','2014-04-28','13:40:00',4.49),('8537','2014-04-28','13:45:00',2.81),('8537','2014-04-28','13:50:00',4.81),('8537','2014-04-28','13:55:00',4.43),('8537','2014-04-28','14:00:00',2.48),('8537','2014-04-28','14:05:00',3.62),('8537','2014-04-28','14:10:00',4.2),('8537','2014-04-28','14:15:00',3.78),('8537','2014-04-28','14:20:00',4.5),('8537','2014-04-28','14:25:00',3.7),('8537','2014-04-28','14:30:00',2.83),('8537','2014-04-28','14:35:00',5.1),('8537','2014-04-28','14:40:00',4.87),('8537','2014-04-28','14:45:00',2.42),('8537','2014-04-28','14:50:00',2.98),('8537','2014-04-28','14:55:00',4.26),('8537','2014-04-28','15:00:00',2.84),('8537','2014-04-28','15:05:00',3.45),('8537','2014-04-28','15:10:00',2.99),('8537','2014-04-28','15:15:00',2.96),('8537','2014-04-28','15:20:00',2.21),('8537','2014-04-28','15:25:00',2.16),('8537','2014-04-28','15:30:00',2.48),('8537','2014-04-28','15:35:00',3.31),('8537','2014-04-28','15:40:00',2.52),('8537','2014-04-28','15:45:00',2.1),('8537','2014-04-28','15:50:00',4.17),('8537','2014-04-28','15:55:00',1.97),('8537','2014-04-28','16:00:00',3.25),('8537','2014-04-28','16:05:00',3.79),('8537','2014-04-28','16:10:00',4),('8537','2014-04-28','16:15:00',2.95),('8537','2014-04-28','16:20:00',2.91),('8537','2014-04-28','16:25:00',1.81),('8537','2014-04-28','16:30:00',3.33),('8537','2014-04-28','16:35:00',3.41),('8537','2014-04-28','16:55:00',1.88),('8537','2014-04-28','17:00:00',1.05),('8537','2014-04-28','17:25:00',1.13),('8537','2014-04-28','17:30:00',1.04),('8537','2014-04-28','17:35:00',1.06),('8537','2014-04-28','17:40:00',1.37),('8537','2014-04-27','09:20:00',1.04),('8537','2014-04-27','09:45:00',1.04),('8537','2014-04-27','10:00:00',1.26),('8537','2014-04-27','10:05:00',1.27),('8537','2014-04-27','10:10:00',1.34),('8537','2014-04-27','10:15:00',1.16),('8537','2014-04-27','10:20:00',1.16),('8537','2014-04-27','10:25:00',1.01),('8537','2014-04-27','11:00:00',1.31),('8537','2014-04-27','11:05:00',1.57),('8537','2014-04-27','11:10:00',1.76),('8537','2014-04-27','11:15:00',1.72),('8537','2014-04-27','11:20:00',1.35),('8537','2014-04-27','11:30:00',1.11),('8537','2014-04-27','11:35:00',1.79),('8537','2014-04-27','11:40:00',1.95),('8537','2014-04-27','11:45:00',3.8),('8537','2014-04-27','11:50:00',3.27),('8537','2014-04-27','11:55:00',2.98),('8537','2014-04-27','12:00:00',2.97),('8537','2014-04-27','12:05:00',3.25),('8537','2014-04-27','12:10:00',3.74),('8537','2014-04-27','12:15:00',3.49),('8537','2014-04-27','12:20:00',3.42),('8537','2014-04-27','12:25:00',3.38),('8537','2014-04-27','12:30:00',3.03),('8537','2014-04-27','12:35:00',3.13),('8537','2014-04-27','12:40:00',2.79),('8537','2014-04-27','12:45:00',3.11),('8537','2014-04-27','12:50:00',2.5),('8537','2014-04-27','12:55:00',1.95),('8537','2014-04-27','13:00:00',2.47),('8537','2014-04-27','13:05:00',2.49),('8537','2014-04-27','13:10:00',2.05),('8537','2014-04-27','13:15:00',2.13),('8537','2014-04-27','13:20:00',2.86),('8537','2014-04-27','13:25:00',2.63),('8537','2014-04-27','13:30:00',2.35),('8537','2014-04-27','13:35:00',2.06),('8537','2014-04-27','13:40:00',1.94),('8537','2014-04-27','13:45:00',1.9),('8537','2014-04-27','13:50:00',1.84),('8537','2014-04-27','13:55:00',1.7),('8537','2014-04-27','14:00:00',2.13),('8537','2014-04-27','14:05:00',2.75),('8537','2014-04-27','14:10:00',1.97),('8537','2014-04-27','14:15:00',1.77),('8537','2014-04-27','14:20:00',2.1),('8537','2014-04-27','14:25:00',2.6),('8537','2014-04-27','14:30:00',2.73),('8537','2014-04-27','14:35:00',2.64),('8537','2014-04-27','14:40:00',2.67),('8537','2014-04-27','14:45:00',2.33),('8537','2014-04-27','14:50:00',2.21),('8537','2014-04-27','14:55:00',2.39),('8537','2014-04-27','15:00:00',2.53),('8537','2014-04-27','15:05:00',3.43),('8537','2014-04-27','15:10:00',4.58),('8537','2014-04-27','15:15:00',3.45),('8537','2014-04-27','15:20:00',2.21),('8537','2014-04-27','15:25:00',1.41),('8537','2014-04-27','15:30:00',1.11),('8537','2014-04-27','15:35:00',1.21),('8537','2014-04-27','15:40:00',1.24),('8537','2014-04-27','15:45:00',1.07),('8537','2014-04-27','15:50:00',1.06),('8784','2014-05-05','07:45:00',1.31),('8784','2014-05-05','07:50:00',1.43),('8784','2014-05-05','07:55:00',1.52),('8784','2014-05-05','08:00:00',1.6),('8784','2014-05-05','08:05:00',1.68),('8784','2014-05-05','08:10:00',1.78),('8784','2014-05-05','08:15:00',1.88),('8784','2014-05-05','08:20:00',1.96),('8784','2014-05-05','08:25:00',2.03),('8784','2014-05-05','08:30:00',2.15),('8784','2014-05-05','08:35:00',2.27),('8784','2014-05-05','08:40:00',2.36),('8784','2014-05-05','08:45:00',2.44),('8784','2014-05-05','08:50:00',2.52),('8784','2014-05-05','08:55:00',2.6),('8784','2014-05-05','09:00:00',2.67),('8784','2014-05-05','09:05:00',2.73),('8784','2014-05-05','09:10:00',2.82),('8784','2014-05-05','09:15:00',2.87),('8784','2014-05-05','09:20:00',2.97),('8784','2014-05-05','09:25:00',3.04),('8784','2014-05-05','09:30:00',3.14),('8784','2014-05-05','09:35:00',3.23),('8784','2014-05-05','09:40:00',3.29),('8784','2014-05-05','09:45:00',3.35),('8784','2014-05-05','09:50:00',3.42),('8784','2014-05-05','09:55:00',3.5),('8784','2014-05-05','10:00:00',3.57),('8784','2014-05-05','10:05:00',3.66),('8784','2014-05-05','10:10:00',3.72),('8784','2014-05-05','10:15:00',3.73),('8784','2014-05-05','10:20:00',3.7),('8784','2014-05-05','10:25:00',3.84),('8784','2014-05-05','10:30:00',3.89),('8784','2014-05-05','10:35:00',3.83),('8784','2014-05-05','10:40:00',3.86),('8784','2014-05-05','10:45:00',3.94),('8784','2014-05-05','10:50:00',4),('8784','2014-05-05','10:55:00',4),('8784','2014-05-05','11:00:00',4.05),('8784','2014-05-05','11:05:00',4.06),('8784','2014-05-05','11:10:00',4.16),('8784','2014-05-05','11:15:00',4.29),('8784','2014-05-05','11:20:00',4.29),('8784','2014-05-05','11:25:00',4.22),('8784','2014-05-05','11:30:00',4.2),('8784','2014-05-05','11:35:00',4.34),('8784','2014-05-05','11:40:00',4.37),('8784','2014-05-05','11:45:00',4.44),('8784','2014-05-05','11:50:00',4.46),('8784','2014-05-05','11:55:00',4.38),('8784','2014-05-05','12:00:00',4.71),('8784','2014-05-05','12:05:00',3.29),('8784','2014-05-05','12:10:00',1.35),('8784','2014-05-05','12:15:00',2.62),('8784','2014-05-05','12:20:00',1.95),('8784','2014-05-05','12:25:00',2.06),('8784','2014-05-05','12:30:00',4),('8784','2014-05-05','12:35:00',2.98),('8784','2014-05-05','12:40:00',2.05),('8784','2014-05-05','12:45:00',2.42),('8784','2014-05-05','12:50:00',4.95),('8784','2014-05-05','12:55:00',1.97),('8784','2014-05-05','13:00:00',1.36),('8784','2014-05-05','13:05:00',2.75),('8784','2014-05-05','13:10:00',5.02),('8784','2014-05-05','13:15:00',4.81),('8784','2014-05-05','13:20:00',4.68),('8784','2014-05-05','13:25:00',4.57),('8784','2014-05-05','13:30:00',4.54),('8784','2014-05-05','13:35:00',4.54),('8784','2014-05-05','13:40:00',4.49),('8784','2014-05-05','13:45:00',4.58),('8784','2014-05-05','13:50:00',4.58),('8784','2014-05-05','13:55:00',4.6),('8784','2014-05-05','14:00:00',4.53),('8784','2014-05-05','14:05:00',3.06),('8784','2014-05-05','14:10:00',3.13),('8784','2014-05-05','14:15:00',4.21),('8784','2014-05-05','14:20:00',4.9),('8784','2014-05-05','14:25:00',4.76),('8784','2014-05-05','14:30:00',3.92),('8784','2014-05-05','14:35:00',2.85),('8784','2014-05-05','14:40:00',2.61),('8784','2014-05-05','14:45:00',1.55),('8784','2014-05-05','14:50:00',1.51),('8784','2014-05-05','14:55:00',1.73),('8784','2014-05-05','15:00:00',2.64),('8784','2014-05-05','15:05:00',3.64),('8784','2014-05-05','15:10:00',2.73),('8784','2014-05-05','15:15:00',1.4),('8784','2014-05-05','15:20:00',1.42),('8784','2014-05-05','15:25:00',1.84),('8784','2014-05-05','15:30:00',2.96),('8784','2014-05-05','15:35:00',1.93),('8784','2014-05-05','15:40:00',3.72),('8784','2014-05-05','15:45:00',3.3),('8784','2014-05-05','15:50:00',1.33),('8784','2014-05-05','15:55:00',1.4),('8784','2014-05-05','16:00:00',1.68),('8784','2014-05-05','16:05:00',2.71),('8784','2014-05-05','16:10:00',1.88),('8784','2014-05-05','16:15:00',1.38),('8784','2014-05-05','16:20:00',1.66),('8784','2014-05-05','16:25:00',1.25),('8784','2014-05-05','16:30:00',1.27),('8784','2014-05-05','16:35:00',3.32),('8784','2014-05-05','16:40:00',2.7),('8784','2014-05-05','16:45:00',2.73),('8784','2014-05-05','16:50:00',3.08),('8784','2014-05-05','16:55:00',2.89),('8784','2014-05-05','17:00:00',2.66),('8784','2014-05-05','17:05:00',2.54),('8784','2014-05-05','17:10:00',2.56),('8784','2014-05-05','17:15:00',2.49),('8784','2014-05-05','17:20:00',2.39),('8784','2014-05-05','17:25:00',2.23),('8784','2014-05-05','17:30:00',2.1),('8784','2014-05-05','17:35:00',1.98),('8784','2014-05-05','17:40:00',1.85),('8784','2014-05-05','17:45:00',1.79),('8784','2014-05-05','17:50:00',1.7),('8784','2014-05-05','17:55:00',1.62),('8784','2014-05-05','18:00:00',1.49),('8784','2014-05-05','18:05:00',1.43),('8784','2014-05-05','18:10:00',1.36),('8784','2014-05-05','18:15:00',1.25),('8784','2014-05-05','18:20:00',1.16),('8784','2014-05-05','18:25:00',1.09),('8784','2014-05-05','18:30:00',1),('8784','2014-04-26','09:05:00',1.1),('8784','2014-04-26','09:40:00',1.03),('8784','2014-04-26','09:50:00',1.03),('8784','2014-04-26','09:55:00',1.49),('8784','2014-04-26','10:00:00',1.58),('8784','2014-04-26','10:05:00',1.44),('8784','2014-04-26','10:10:00',1.38),('8784','2014-04-26','10:15:00',1.45),('8784','2014-04-26','10:20:00',1.64),('8784','2014-04-26','10:25:00',1.78),('8784','2014-04-26','10:30:00',2.07),('8784','2014-04-26','10:35:00',2.24),('8784','2014-04-26','10:40:00',2.32),('8784','2014-04-26','10:45:00',1.34),('8784','2014-04-26','10:50:00',2.65),('8784','2014-04-26','10:55:00',3.94),('8784','2014-04-26','11:00:00',3.86),('8784','2014-04-26','11:05:00',3.72),('8784','2014-04-26','11:10:00',3.52),('8784','2014-04-26','11:15:00',3.44),('8784','2014-04-26','11:20:00',3.27),('8784','2014-04-26','11:25:00',3.21),('8784','2014-04-26','11:30:00',3.36),('8784','2014-04-26','11:35:00',3.25),('8784','2014-04-26','11:40:00',3.05),('8784','2014-04-26','11:45:00',3.28),('8784','2014-04-26','11:50:00',3.21),('8784','2014-04-26','11:55:00',3.07),('8784','2014-04-26','12:00:00',3.19),('8784','2014-04-26','12:05:00',3.44),('8784','2014-04-26','12:10:00',3.43),('8784','2014-04-26','12:15:00',2.81),('8784','2014-04-26','12:20:00',3.1),('8784','2014-04-26','12:25:00',2.75),('8784','2014-04-26','12:30:00',2.4),('8784','2014-04-26','12:35:00',3.81),('8784','2014-04-26','12:40:00',3.69),('8784','2014-04-26','12:45:00',3.99),('8784','2014-04-26','12:50:00',4.25),('8784','2014-04-26','12:55:00',4.5),('8784','2014-04-26','13:00:00',4.02),('8784','2014-04-26','13:05:00',3.02),('8784','2014-04-26','13:10:00',3.57),('8784','2014-04-26','13:15:00',4.47),('8784','2014-04-26','13:20:00',4.88),('8784','2014-04-26','13:25:00',4),('8784','2014-04-26','13:30:00',1.56),('8784','2014-04-26','13:35:00',1.95),('8784','2014-04-26','13:40:00',4.82),('8784','2014-04-26','13:45:00',4.51),('8784','2014-04-26','13:50:00',4.35),('8784','2014-04-26','13:55:00',4.57),('8784','2014-04-26','14:00:00',3.4),('8784','2014-04-26','14:10:00',2.15),('8784','2014-04-26','14:15:00',2.1),('8784','2014-04-26','14:30:00',1),('8784','2014-04-26','14:35:00',1.52),('8784','2014-04-26','14:40:00',2.26),('8784','2014-04-26','18:45:00',1),('8784','2014-01-26','09:30:00',1.05),('8784','2014-01-26','09:35:00',1.01),('8784','2014-01-26','09:45:00',1.1),('8784','2014-01-26','09:50:00',1.24),('8784','2014-01-26','09:55:00',1.02),('8784','2014-01-26','10:10:00',1.54),('8784','2014-01-26','10:15:00',2.03),('8784','2014-01-26','10:20:00',1.12),('8784','2014-01-26','10:25:00',1.02),('8784','2014-01-26','11:25:00',1.14),('8784','2014-01-26','12:15:00',1.22),('8784','2014-01-26','12:20:00',1.29),('8784','2014-01-26','12:25:00',1.4),('8784','2014-01-26','12:30:00',2.46),('8784','2014-01-26','12:35:00',1.95),('8784','2014-01-26','12:40:00',1.33),('8784','2014-01-26','12:45:00',1.17),('8784','2014-01-26','12:50:00',1.04),('8784','2014-01-26','13:00:00',1.08),('8784','2014-01-26','13:05:00',1.22),('8784','2014-01-26','13:10:00',1.33),('8784','2014-01-26','13:15:00',1.51),('8784','2014-01-26','13:20:00',1.54),('8784','2014-01-26','13:25:00',1.24),('8784','2014-01-26','15:45:00',1.06),('8784','2014-01-25','09:50:00',1.12),('8784','2014-01-25','09:55:00',1.6),('8784','2014-01-25','10:00:00',1.04),('8784','2014-01-25','10:05:00',1.9),('8784','2014-01-25','10:10:00',2.16),('8784','2014-01-25','10:15:00',2.43),('8784','2014-01-25','10:20:00',2.49),('8784','2014-01-25','10:25:00',1.72),('8784','2014-01-25','10:30:00',1.63),('8784','2014-01-25','10:35:00',1.6),('8784','2014-01-25','10:40:00',1.99),('8784','2014-01-25','10:45:00',1.57),('8784','2014-01-25','10:50:00',1.92),('8784','2014-01-25','10:55:00',1.61),('8784','2014-01-25','11:00:00',1.29),('8784','2014-01-25','11:05:00',1.22),('8784','2014-01-25','11:10:00',1.09),('8784','2014-01-25','11:15:00',1.13),('8784','2014-01-25','11:20:00',1.17),('8784','2014-01-25','11:25:00',1.45),('8784','2014-01-25','11:30:00',3.2),('8784','2014-01-25','11:35:00',3.37),('8784','2014-01-25','11:40:00',2.01),('8784','2014-01-25','11:45:00',1.46),('8784','2014-01-25','11:50:00',1.62),('8784','2014-01-25','11:55:00',1.68),('8784','2014-01-25','12:00:00',1.63),('8784','2014-01-25','12:05:00',1.74),('8784','2014-01-25','12:10:00',1.85),('8784','2014-01-25','12:15:00',1.77),('8784','2014-01-25','12:20:00',1.83),('8784','2014-01-25','12:25:00',1.97),('8784','2014-01-25','12:30:00',1.87),('8784','2014-01-25','12:35:00',1.67),('8784','2014-01-25','12:40:00',1.76),('8784','2014-01-25','12:45:00',2.08),('8784','2014-01-25','12:50:00',2.09),('8784','2014-01-25','12:55:00',2.3),('8784','2014-01-25','13:00:00',2.27),('8784','2014-01-25','13:05:00',2.12),('8784','2014-01-25','13:10:00',2.52),('8784','2014-01-25','13:15:00',2.27),('8784','2014-01-25','13:20:00',1.34),('8784','2014-01-25','13:25:00',1.48),('8784','2014-01-25','13:30:00',1.35),('8784','2014-01-25','13:35:00',1.22),('8784','2014-01-25','13:45:00',1.37),('8784','2014-01-25','13:50:00',1.29),('8784','2014-01-25','14:00:00',1.26),('8784','2014-01-25','14:05:00',1.47),('8784','2014-01-25','14:10:00',1.88),('8784','2014-01-25','14:15:00',1.3),('8784','2014-01-25','14:20:00',1.88),('8784','2014-01-25','14:25:00',2.05),('8784','2014-01-25','14:30:00',2.31),('8784','2014-01-25','14:35:00',2.36),('8784','2014-01-25','14:40:00',2.14),('8784','2014-01-25','14:45:00',2.21),('8784','2014-01-25','14:50:00',2.03),('8784','2014-01-25','14:55:00',1.82),('8784','2014-01-25','15:00:00',1.59),('8784','2014-01-25','15:05:00',1.47),('8784','2014-01-25','15:10:00',1.38),('8784','2014-01-25','15:15:00',1.28),('8784','2014-01-25','15:20:00',1.21),('8784','2014-01-25','15:25:00',1.12),('8784','2014-01-25','15:30:00',1.06),('8784','2014-01-24','10:15:00',1.55),('8784','2014-01-24','10:30:00',1.54),('8784','2014-01-24','10:35:00',1.52),('8784','2014-01-24','10:40:00',1.87),('8784','2014-01-24','10:45:00',1.76),('8784','2014-01-24','10:50:00',1.14),('8784','2014-01-24','10:55:00',1.08),('8784','2014-01-24','11:00:00',1.15),('8784','2014-01-24','11:25:00',1.17),('8784','2014-01-24','11:30:00',1.46),('8784','2014-01-24','11:35:00',1.29),('8784','2014-01-24','11:45:00',1.65),('8784','2014-01-24','11:50:00',2.81),('8784','2014-01-24','11:55:00',2.85),('8784','2014-01-24','12:00:00',1.52),('8784','2014-01-24','12:05:00',1.27),('8784','2014-01-24','12:10:00',1.08),('8784','2014-01-24','12:25:00',1.87),('8784','2014-01-24','12:30:00',1.29),('8784','2014-01-24','12:35:00',2.7),('8784','2014-01-24','12:40:00',2.46),('8784','2014-01-24','12:45:00',1.59),('8784','2014-01-24','12:50:00',1.27),('8784','2014-01-24','12:55:00',1.5),('8784','2014-01-24','13:00:00',1.73),('8784','2014-01-24','13:05:00',1.99),('8784','2014-01-24','13:10:00',1.28),('8784','2014-01-24','13:30:00',1.28),('8784','2014-01-24','13:35:00',1.62),('8784','2014-01-24','13:40:00',1.37),('8784','2014-01-24','13:45:00',1.18),('8784','2014-01-24','13:50:00',1.17),('8784','2014-01-24','13:55:00',1.63),('8784','2014-01-24','14:00:00',1.46),('8784','2014-01-24','14:10:00',2.71),('8784','2014-01-24','14:15:00',2.23),('8784','2014-01-24','14:20:00',1.99),('8784','2014-01-24','14:25:00',1.83),('8784','2014-01-24','14:45:00',1.03),('8784','2014-01-23','11:00:00',1.11),('8784','2014-01-23','11:05:00',1.11),('8784','2014-01-23','11:10:00',1.1),('8784','2014-01-23','11:15:00',1.11),('8784','2014-01-23','11:20:00',1.08),('8784','2014-01-23','12:30:00',1.1),('8784','2014-01-22','10:15:00',1.01),('8784','2014-01-22','11:05:00',1.03),('8784','2014-01-22','11:10:00',1.08),('8784','2014-01-22','11:20:00',1.07),('8784','2014-01-22','11:25:00',1.01),('8784','2014-01-22','11:40:00',1.04),('8784','2014-01-22','13:10:00',1.06),('8784','2014-01-22','13:15:00',1.83),('8784','2014-01-22','13:20:00',1.07),('8784','2014-01-21','09:55:00',1),('8784','2014-01-21','10:00:00',1.21),('8784','2014-01-21','10:05:00',1.23),('8784','2014-01-21','10:55:00',1.58),('8784','2014-01-21','11:00:00',2.2),('8784','2014-01-21','11:50:00',1.07),('8784','2014-01-21','11:55:00',1.02),('8784','2014-01-21','12:05:00',1.64),('8784','2014-01-21','12:10:00',1.84),('8784','2014-01-21','12:15:00',1.37),('8784','2014-01-21','12:20:00',1.14),('8784','2014-01-21','12:25:00',1.48),('8784','2014-01-21','12:30:00',1.88),('8784','2014-01-21','12:35:00',1.64),('8784','2014-01-21','12:40:00',1.43),('8784','2014-01-21','12:45:00',1.33),('8784','2014-01-21','12:50:00',1.79),('8784','2014-01-21','13:20:00',1.03),('8784','2014-01-21','14:00:00',1.06),('8784','2014-01-21','14:05:00',1.37),('8784','2014-01-21','14:10:00',1.26),('8784','2014-01-21','14:15:00',1.05),('8784','2014-01-20','11:20:00',1.59),('8784','2014-01-20','11:25:00',1.87),('8784','2014-01-20','11:30:00',1.94),('8784','2014-01-20','11:35:00',1.93),('8784','2014-01-20','11:40:00',2.77),('8784','2014-01-20','11:45:00',2.88),('8784','2014-01-20','11:50:00',1.69),('8784','2014-01-20','12:05:00',1.04),('8784','2014-01-20','12:25:00',1.2),('8784','2014-01-20','12:30:00',1.2),('8784','2014-01-20','13:15:00',1.16),('8784','2014-01-20','13:20:00',3.59),('8784','2014-01-20','13:25:00',3.19),('8784','2014-01-20','13:30:00',2.7),('8784','2014-01-20','13:35:00',2.41),('8784','2014-01-20','13:40:00',1.96),('8784','2014-01-20','13:45:00',1.97),('8784','2014-01-20','13:50:00',1.18),('8784','2014-01-20','13:55:00',1.38),('8784','2014-01-20','14:00:00',2.69),('8784','2014-01-20','14:05:00',1.7),('8784','2014-01-20','14:10:00',1.18),('8784','2014-01-20','14:15:00',1.01),('8784','2014-01-19','11:55:00',1.01),('8784','2014-01-19','12:00:00',1.1),('8784','2014-01-19','12:05:00',1.13),('8784','2014-01-19','12:10:00',1.09),('8784','2014-01-19','13:05:00',1.07),('8784','2014-01-19','13:10:00',1.2),('8784','2014-01-19','13:15:00',1.05),('8784','2014-01-19','14:20:00',1.37),('8784','2014-01-19','14:25:00',1.58),('8784','2014-01-19','14:30:00',1.8),('8784','2014-01-19','14:35:00',1.22),('8784','2014-01-19','14:40:00',1.02),('8784','2014-01-18','10:00:00',1.08),('8784','2014-01-18','10:05:00',1.16),('8784','2014-01-18','10:10:00',1.73),('8784','2014-01-18','10:15:00',1.99),('8784','2014-01-18','10:20:00',1.81),('8784','2014-01-18','10:25:00',1.48),('8784','2014-01-18','10:30:00',1.58),('8784','2014-01-18','10:35:00',1.14),('8784','2014-01-18','10:40:00',1.08),('8784','2014-01-18','10:45:00',1.19),('8784','2014-01-18','10:50:00',1.26),('8784','2014-01-18','10:55:00',1.14),('8784','2014-01-18','11:05:00',1.25),('8784','2014-01-18','11:10:00',1.82),('8784','2014-01-18','11:15:00',2.41),('8784','2014-01-18','11:20:00',2.16),('8784','2014-01-18','11:25:00',2.08),('8784','2014-01-18','11:30:00',2.19),('8784','2014-01-18','11:35:00',2.23),('8784','2014-01-18','11:40:00',2.36),('8784','2014-01-18','11:45:00',2.6),('8784','2014-01-18','11:50:00',2.44),('8784','2014-01-18','11:55:00',2.77),('8784','2014-01-18','12:00:00',2.55),('8784','2014-01-18','12:05:00',1.89),('8784','2014-01-18','12:10:00',2.41),('8784','2014-01-18','12:15:00',2.27),('8784','2014-01-18','12:20:00',2.26),('8784','2014-01-18','12:25:00',2.25),('8784','2014-01-18','12:30:00',2.23),('8784','2014-01-18','12:35:00',2.22),('8784','2014-01-18','12:40:00',2.26),('8784','2014-01-18','12:45:00',2.23),('8784','2014-01-18','12:50:00',1.95),('8784','2014-01-18','12:55:00',2.25),('8784','2014-01-18','13:00:00',1.61),('8784','2014-01-18','13:05:00',1.51),('8784','2014-01-18','13:10:00',2.09),('8784','2014-01-18','13:15:00',2.36),('8784','2014-01-18','13:20:00',1.58),('8784','2014-01-18','13:25:00',1.18),('8784','2014-01-18','13:30:00',1.85),('8784','2014-01-18','13:35:00',1.24),('8784','2014-01-18','13:40:00',1.79),('8784','2014-01-18','13:45:00',2.05),('8784','2014-01-18','13:50:00',1.46),('8784','2014-01-18','13:55:00',1.87),('8784','2014-01-18','14:00:00',1.95),('8784','2014-01-18','14:05:00',1.83),('8784','2014-01-18','14:10:00',1.65),('8784','2014-01-18','14:15:00',1.62),('8784','2014-01-18','14:20:00',1.67),('8784','2014-01-18','14:25:00',1.58),('8784','2014-01-18','14:30:00',1.5),('8784','2014-01-18','14:35:00',1.43),('8784','2014-01-18','14:40:00',1.39),('8784','2014-01-18','14:45:00',1.33),('8784','2014-01-18','14:50:00',1.25),('8784','2014-01-17','09:40:00',1.03),('8784','2014-01-17','09:45:00',1.24),('8784','2014-01-17','11:25:00',1.18),('8784','2014-01-17','11:30:00',1.75),('8784','2014-01-17','11:35:00',1.82),('8784','2014-01-17','11:40:00',1.58),('8784','2014-01-17','11:55:00',1.1),('8784','2014-01-17','12:00:00',1.35),('8784','2014-01-17','12:05:00',1.56),('8784','2014-01-17','12:10:00',1.29),('8784','2014-01-17','12:40:00',1.06),('8784','2014-01-17','12:45:00',1.18),('8784','2014-04-25','08:00:00',1.19),('8784','2014-04-25','08:05:00',1.4),('8784','2014-04-25','08:10:00',1.48),('8784','2014-04-25','08:15:00',1.5),('8784','2014-04-25','08:20:00',1.6),('8784','2014-04-25','08:25:00',1.69),('8784','2014-04-25','08:30:00',1.77),('8784','2014-04-25','08:35:00',1.82),('8784','2014-04-25','08:40:00',1.87),('8784','2014-04-25','08:45:00',1.89),('8784','2014-04-25','08:50:00',1.95),('8784','2014-04-25','08:55:00',1.35),('8784','2014-04-25','09:00:00',1.27),('8784','2014-04-25','09:05:00',1.16),('8784','2014-04-25','09:10:00',1.03),('8784','2014-04-25','09:20:00',1.11),('8784','2014-04-25','09:25:00',1.33),('8784','2014-04-25','09:30:00',1.18),('8784','2014-04-25','09:35:00',1.11),('8784','2014-04-25','09:40:00',1.04),('8784','2014-04-25','09:45:00',1.08),('8784','2014-04-25','09:50:00',1.08),('8784','2014-04-25','09:55:00',1.19),('8784','2014-04-25','10:00:00',1.4),('8784','2014-04-25','10:05:00',1.3),('8784','2014-04-25','10:10:00',1.38),('8784','2014-04-25','10:15:00',1.33),('8784','2014-04-25','10:20:00',1.42),('8784','2014-04-25','10:25:00',1.48),('8784','2014-04-25','10:30:00',1.91),('8784','2014-04-25','10:35:00',3.39),('8784','2014-04-25','10:40:00',2.31),('8784','2014-04-25','10:45:00',3.8),('8784','2014-04-25','10:50:00',2.34),('8784','2014-04-25','10:55:00',3.57),('8784','2014-04-25','11:00:00',2.84),('8784','2014-04-25','11:05:00',2.32),('8784','2014-04-25','11:10:00',3.81),('8784','2014-04-25','11:15:00',4.23),('8784','2014-04-25','11:20:00',3.2),('8784','2014-04-25','11:25:00',3.88),('8784','2014-04-25','11:30:00',2.3),('8784','2014-04-25','11:35:00',3.28),('8784','2014-04-25','11:40:00',3.04),('8784','2014-04-25','11:45:00',1.51),('8784','2014-04-25','11:50:00',1.48),('8784','2014-04-25','11:55:00',4.52),('8784','2014-04-25','12:00:00',2.93),('8784','2014-04-25','12:05:00',4.32),('8784','2014-04-25','12:10:00',4.28),('8784','2014-04-25','12:15:00',1.68),('8784','2014-04-25','12:20:00',3.89),('8784','2014-04-25','12:25:00',3.87),('8784','2014-04-25','12:30:00',4.47),('8784','2014-04-25','12:35:00',4.63),('8784','2014-04-25','12:40:00',4.84),('8784','2014-04-25','12:45:00',4.89),('8784','2014-04-25','12:50:00',2.47),('8784','2014-04-25','12:55:00',3.22),('8784','2014-04-25','13:00:00',3.08),('8784','2014-04-25','13:05:00',2.4),('8784','2014-04-25','13:10:00',4.02),('8784','2014-04-25','13:15:00',1.94),('8784','2014-04-25','13:20:00',1.57),('8784','2014-04-25','13:25:00',3.69),('8784','2014-04-25','13:30:00',1.36),('8784','2014-04-25','13:35:00',1.15),('8784','2014-04-25','13:40:00',1.44),('8784','2014-04-25','13:45:00',1.52),('8784','2014-04-25','13:50:00',1.46),('8784','2014-04-25','13:55:00',2.64),('8784','2014-04-25','14:00:00',1.48),('8784','2014-04-25','14:05:00',1.58),('8784','2014-04-25','14:10:00',1.29),('8784','2014-04-25','14:15:00',1.43),('8784','2014-04-25','14:20:00',4.28),('8784','2014-04-25','14:25:00',2.62),('8784','2014-04-25','14:30:00',2.24),('8784','2014-04-25','14:35:00',3.41),('8784','2014-04-25','14:40:00',4.09),('8784','2014-04-25','14:45:00',3.97),('8784','2014-04-25','14:50:00',3.94),('8784','2014-04-25','14:55:00',3.91),('8784','2014-04-25','15:00:00',3.84),('8784','2014-04-25','15:05:00',3.82),('8784','2014-04-25','15:10:00',3.78),('8784','2014-04-25','15:15:00',3.73),('8784','2014-04-25','15:20:00',3.56),('8784','2014-04-25','15:25:00',3.54),('8784','2014-04-25','15:30:00',3.45),('8784','2014-04-25','15:35:00',3.5),('8784','2014-04-25','15:40:00',3.44),('8784','2014-04-25','15:45:00',3.33),('8784','2014-04-25','15:50:00',3.31),('8784','2014-04-25','15:55:00',3.26),('8784','2014-04-25','16:00:00',3.2),('8784','2014-04-25','16:05:00',3.09),('8784','2014-04-25','16:10:00',2.95),('8784','2014-04-25','16:15:00',2.82),('8784','2014-04-25','16:20:00',2.63),('8784','2014-04-25','16:25:00',2.69),('8784','2014-04-25','16:30:00',2.76),('8784','2014-04-25','16:35:00',2.75),('8784','2014-04-25','16:40:00',2.72),('8784','2014-04-25','16:45:00',2.6),('8784','2014-04-25','16:50:00',2.34),('8784','2014-04-25','16:55:00',2.03),('8784','2014-04-25','17:00:00',2.02),('8784','2014-04-25','17:05:00',2.2),('8784','2014-04-25','17:10:00',1.83),('8784','2014-04-25','17:15:00',1.93),('8784','2014-04-25','17:20:00',1.31),('8784','2014-04-25','17:25:00',1.02),('8784','2014-04-25','17:30:00',1.09),('8784','2014-04-25','17:35:00',1.09),('8784','2014-04-25','17:40:00',1.07),('8784','2014-01-16','09:40:00',1.19),('8784','2014-01-16','09:45:00',1.2),('8784','2014-01-16','09:50:00',1.09),('8784','2014-01-16','10:10:00',1.03),('8784','2014-01-16','10:15:00',1.15),('8784','2014-01-16','10:20:00',1.2),('8784','2014-01-16','10:25:00',1.39),('8784','2014-01-16','10:30:00',1.88),('8784','2014-01-16','10:35:00',2.35),('8784','2014-01-16','10:40:00',2.13),('8784','2014-01-16','10:45:00',1.61),('8784','2014-01-16','10:50:00',1.71),('8784','2014-01-16','10:55:00',1.86),('8784','2014-01-16','11:00:00',1.88),('8784','2014-01-16','11:05:00',1.86),('8784','2014-01-16','11:10:00',1.97),('8784','2014-01-16','11:15:00',1.88),('8784','2014-01-16','11:20:00',1.7),('8784','2014-01-16','11:25:00',1.76),('8784','2014-01-16','11:30:00',1.65),('8784','2014-01-16','11:35:00',1.57),('8784','2014-01-16','11:40:00',1.42),('8784','2014-01-16','11:45:00',1.63),('8784','2014-01-16','11:50:00',1.41),('8784','2014-01-16','11:55:00',1.48),('8784','2014-01-16','12:00:00',1.44),('8784','2014-01-16','12:05:00',1.53),('8784','2014-01-16','12:10:00',1.67),('8784','2014-01-16','12:15:00',1.58),('8784','2014-01-16','12:20:00',1.46),('8784','2014-01-16','12:25:00',1.4),('8784','2014-01-16','12:30:00',1.48),('8784','2014-01-16','12:35:00',1.73),('8784','2014-01-16','12:40:00',1.77),('8784','2014-01-16','12:45:00',1.8),('8784','2014-01-16','12:50:00',1.93),('8784','2014-01-16','12:55:00',1.91),('8784','2014-01-16','13:00:00',2.05),('8784','2014-01-16','13:05:00',1.85),('8784','2014-01-16','13:10:00',2),('8784','2014-01-16','13:15:00',1.65),('8784','2014-01-16','13:20:00',1.39),('8784','2014-01-16','13:25:00',1.89),('8784','2014-01-16','13:30:00',1.22),('8784','2014-01-16','13:35:00',1.11),('8784','2014-01-16','13:40:00',1.29),('8784','2014-01-16','13:45:00',1.83),('8784','2014-01-16','13:50:00',1.71),('8784','2014-01-16','13:55:00',1.88),('8784','2014-01-16','14:00:00',1.11),('8784','2014-01-16','14:05:00',1.12),('8784','2014-01-16','14:10:00',1.07),('8784','2014-01-15','10:15:00',1.17),('8784','2014-01-15','10:20:00',1.61),('8784','2014-01-15','10:25:00',1.85),('8784','2014-01-15','10:30:00',1.73),('8784','2014-01-15','10:35:00',1.39),('8784','2014-01-15','10:40:00',1.64),('8784','2014-01-15','10:45:00',1.49),('8784','2014-01-15','10:55:00',1.03),('8784','2014-01-15','11:00:00',1.25),('8784','2014-01-15','11:05:00',1.74),('8784','2014-01-15','11:10:00',2.12),('8784','2014-01-15','11:15:00',2.25),('8784','2014-01-15','11:20:00',2.05),('8784','2014-01-15','11:25:00',1.98),('8784','2014-01-15','11:30:00',1.82),('8784','2014-01-15','11:35:00',1.24),('8784','2014-01-15','11:40:00',1.69),('8784','2014-01-15','11:45:00',2),('8784','2014-01-15','11:50:00',2.02),('8784','2014-01-15','11:55:00',1.74),('8784','2014-01-15','12:00:00',1.71),('8784','2014-01-15','12:05:00',1.58),('8784','2014-01-15','12:10:00',1.54),('8784','2014-01-15','12:15:00',1.76),('8784','2014-01-15','12:20:00',2.24),('8784','2014-01-15','12:25:00',1.8),('8784','2014-01-15','12:30:00',1.36),('8784','2014-01-15','12:35:00',1.51),('8784','2014-01-15','12:40:00',1.31),('8784','2014-01-15','12:45:00',1.34),('8784','2014-01-15','12:50:00',1.44),('8784','2014-01-15','12:55:00',1.26),('8784','2014-01-15','13:00:00',1.22),('8784','2014-01-15','13:05:00',1.35),('8784','2014-01-15','13:10:00',1.6),('8784','2014-01-15','13:15:00',2.42),('8784','2014-01-15','13:20:00',2.46),('8784','2014-01-15','13:25:00',2.31),('8784','2014-01-15','13:30:00',2.19),('8784','2014-01-15','13:35:00',1.92),('8784','2014-01-15','13:40:00',1.98),('8784','2014-01-15','13:45:00',1.92),('8784','2014-01-15','13:50:00',1.69),('8784','2014-01-15','14:00:00',1.73),('8784','2014-01-15','14:05:00',1.71),('8784','2014-01-15','14:10:00',1.66),('8784','2014-01-15','14:15:00',1.59),('8784','2014-01-15','14:20:00',1.59),('8784','2014-01-15','14:25:00',1.54),('8784','2014-01-15','14:30:00',1.49),('8784','2014-01-15','14:35:00',1.5),('8784','2014-01-15','14:40:00',1.56),('8784','2014-01-15','14:45:00',1.5),('8784','2014-01-15','14:50:00',1.4),('8784','2014-01-15','14:55:00',1.35),('8784','2014-01-15','15:00:00',1.3),('8784','2014-01-15','15:05:00',1.12),('8784','2014-01-15','15:10:00',1.21),('8784','2014-01-15','15:15:00',1.15),('8784','2014-01-14','10:25:00',1.48),('8784','2014-01-14','10:30:00',2.51),('8784','2014-01-14','10:35:00',2.53),('8784','2014-01-14','10:40:00',2.24),('8784','2014-01-14','10:45:00',2.13),('8784','2014-01-14','10:50:00',1.38),('8784','2014-01-14','10:55:00',1.26),('8784','2014-01-14','11:00:00',1.45),('8784','2014-01-14','11:05:00',1.19),('8784','2014-01-14','11:20:00',1.01),('8784','2014-01-14','11:30:00',1.05),('8784','2014-01-14','11:35:00',1.17),('8784','2014-01-14','11:40:00',1.33),('8784','2014-01-13','09:50:00',1.11),('8784','2014-01-13','09:55:00',1.22),('8784','2014-01-13','10:00:00',1.26),('8784','2014-01-13','10:05:00',1.3),('8784','2014-01-13','10:10:00',1.28),('8784','2014-01-13','10:15:00',1.41),('8784','2014-01-13','10:20:00',1.57),('8784','2014-01-13','10:25:00',1.67),('8784','2014-01-13','10:30:00',1.71),('8784','2014-01-13','10:35:00',1.75),('8784','2014-01-13','10:40:00',1.8),('8784','2014-01-13','10:45:00',1.83),('8784','2014-01-13','10:50:00',1.87),('8784','2014-01-13','10:55:00',1.9),('8784','2014-01-13','11:00:00',1.95),('8784','2014-01-13','11:05:00',2),('8784','2014-01-13','11:10:00',2.03),('8784','2014-01-13','11:15:00',1.99),('8784','2014-01-13','11:20:00',2.01),('8784','2014-01-13','11:25:00',2.02),('8784','2014-01-13','11:30:00',2.02),('8784','2014-01-13','11:35:00',2.01),('8784','2014-01-13','11:40:00',2.03),('8784','2014-01-13','11:45:00',2.02),('8784','2014-01-13','11:50:00',2.01),('8784','2014-01-13','11:55:00',2),('8784','2014-01-13','12:00:00',2.01),('8784','2014-01-13','12:05:00',1.99),('8784','2014-01-13','12:10:00',1.97),('8784','2014-01-13','12:15:00',1.97),('8784','2014-01-13','12:20:00',2),('8784','2014-01-13','12:25:00',2.02),('8784','2014-01-13','12:30:00',2),('8784','2014-01-13','12:35:00',1.97),('8784','2014-01-13','12:40:00',1.92),('8784','2014-01-13','12:45:00',1.93),('8784','2014-01-13','12:50:00',1.82),('8784','2014-01-13','12:55:00',1.8),('8784','2014-01-13','13:00:00',1.78),('8784','2014-01-13','13:05:00',1.8),('8784','2014-01-13','13:10:00',1.83),('8784','2014-01-13','13:15:00',1.82),('8784','2014-01-13','13:20:00',1.86),('8784','2014-01-13','13:25:00',1.82),('8784','2014-01-13','13:30:00',1.73),('8784','2014-01-13','13:35:00',1.7),('8784','2014-01-13','13:40:00',1.65),('8784','2014-01-13','13:45:00',1.57),('8784','2014-01-13','13:50:00',1.64),('8784','2014-01-13','13:55:00',1.61),('8784','2014-01-13','14:00:00',1.56),('8784','2014-01-13','14:05:00',1.48),('8784','2014-01-13','14:10:00',1.43),('8784','2014-01-13','14:15:00',1.44),('8784','2014-01-13','14:20:00',1.42),('8784','2014-01-13','14:25:00',1.36),('8784','2014-01-13','14:30:00',1.3),('8784','2014-01-13','14:35:00',1.25),('8784','2014-01-13','14:40:00',1.21),('8784','2014-01-13','14:45:00',1.12),('8784','2014-01-13','14:50:00',1.07),('8784','2014-01-13','14:55:00',1.07),('8784','2014-01-12','10:20:00',1.08),('8784','2014-01-12','10:25:00',1.06),('8784','2014-01-12','10:30:00',1.05),('8784','2014-01-12','10:35:00',1.2),('8784','2014-01-12','10:40:00',1.36),('8784','2014-01-12','10:45:00',1.34),('8784','2014-01-12','10:50:00',1.45),('8784','2014-01-12','10:55:00',1.52),('8784','2014-01-12','11:00:00',1.47),('8784','2014-01-12','11:05:00',1.54),('8784','2014-01-12','11:10:00',1.82),('8784','2014-01-12','11:15:00',1.57),('8784','2014-01-12','11:20:00',1.42),('8784','2014-01-12','11:25:00',1.42),('8784','2014-01-12','11:30:00',1.52),('8784','2014-01-12','11:35:00',1.4),('8784','2014-01-12','11:40:00',1.7),('8784','2014-01-12','11:45:00',1.8),('8784','2014-01-12','11:50:00',1.89),('8784','2014-01-12','11:55:00',1.77),('8784','2014-01-12','12:00:00',1.45),('8784','2014-01-12','12:05:00',1.48),('8784','2014-01-12','12:10:00',1.26),('8784','2014-01-12','12:20:00',1.25),('8784','2014-01-12','12:25:00',1.21),('8784','2014-01-12','12:30:00',1.25),('8784','2014-01-12','12:35:00',1.26),('8784','2014-01-12','12:40:00',1.31),('8784','2014-01-12','12:45:00',1.28),('8784','2014-01-12','12:50:00',1.32),('8784','2014-01-12','12:55:00',1.28),('8784','2014-01-12','13:00:00',1.28),('8784','2014-01-12','13:05:00',1.2),('8784','2014-01-12','13:10:00',1.14),('8784','2014-01-12','13:15:00',1.05),('8784','2014-01-12','13:25:00',1.18),('8784','2014-01-12','13:30:00',1.34),('8784','2014-01-12','13:35:00',1.25),('8784','2014-01-12','13:40:00',1.13),('8784','2014-01-12','13:45:00',1.01),('8784','2014-01-11','10:15:00',1.08),('8784','2014-01-11','10:20:00',1.14),('8784','2014-01-11','10:25:00',1.41),('8784','2014-01-11','10:30:00',1.38),('8784','2014-01-11','10:35:00',1.46),('8784','2014-01-11','10:40:00',1.83),('8784','2014-01-11','10:45:00',1.93),('8784','2014-01-11','10:50:00',1.97),('8784','2014-01-11','10:55:00',1.97),('8784','2014-01-11','11:00:00',1.9),('8784','2014-01-11','11:05:00',1.9),('8784','2014-01-11','11:10:00',2.02),('8784','2014-01-11','11:15:00',1.78),('8784','2014-01-11','11:20:00',1.67),('8784','2014-01-11','11:25:00',1.68),('8784','2014-01-11','11:30:00',1.68),('8784','2014-01-11','11:35:00',1.48),('8784','2014-01-11','11:40:00',1.4),('8784','2014-01-11','11:45:00',1.45),('8784','2014-01-11','11:50:00',1.65),('8784','2014-01-11','11:55:00',1.63),('8784','2014-01-11','12:00:00',1.67),('8784','2014-01-11','12:05:00',1.83),('8784','2014-01-11','12:10:00',1.71),('8784','2014-01-11','12:15:00',1.68),('8784','2014-01-11','12:20:00',1.68),('8784','2014-01-11','12:25:00',1.58),('8784','2014-01-11','12:30:00',1.43),('8784','2014-01-11','12:35:00',1.37),('8784','2014-01-11','12:40:00',1.23),('8784','2014-01-11','12:45:00',1.43),('8784','2014-01-11','12:50:00',1.69),('8784','2014-01-11','12:55:00',1.83),('8784','2014-01-11','13:00:00',1.81),('8784','2014-01-11','13:05:00',1.61),('8784','2014-01-11','13:10:00',1.34),('8784','2014-01-11','13:15:00',1.84),('8784','2014-01-11','13:20:00',1.58),('8784','2014-01-11','13:25:00',1.34),('8784','2014-01-11','13:30:00',1.06),('8784','2014-01-11','13:35:00',1.04),('8784','2014-01-11','13:40:00',1.05),('8784','2014-01-11','13:45:00',1.15),('8784','2014-01-11','13:55:00',1.05),('8784','2014-01-11','14:00:00',1.35),('8784','2014-01-11','14:05:00',1.41),('8784','2014-01-11','14:10:00',1.19),('8784','2014-04-24','07:45:00',1.03),('8784','2014-04-24','07:50:00',1.12),('8784','2014-04-24','07:55:00',1.19),('8784','2014-04-24','08:05:00',1.37),('8784','2014-04-24','08:10:00',1.45),('8784','2014-04-24','08:15:00',1.56),('8784','2014-04-24','08:20:00',1.62),('8784','2014-04-24','08:25:00',1.73),('8784','2014-04-24','08:30:00',1.81),('8784','2014-04-24','08:35:00',1.91),('8784','2014-04-24','08:40:00',1.99),('8784','2014-04-24','08:45:00',2.08),('8784','2014-04-24','08:50:00',2.17),('8784','2014-04-24','08:55:00',2.23),('8784','2014-04-24','09:00:00',2.27),('8784','2014-04-24','09:05:00',2.35),('8784','2014-04-24','09:10:00',2.47),('8784','2014-04-24','09:15:00',2.56),('8784','2014-04-24','09:20:00',2.62),('8784','2014-04-24','09:25:00',2.67),('8784','2014-04-24','09:30:00',2.75),('8784','2014-04-24','09:35:00',2.83),('8784','2014-04-24','09:40:00',2.9),('8784','2014-04-24','09:45:00',2.97),('8784','2014-04-24','09:50:00',2.98),('8784','2014-04-24','09:55:00',3.09),('8784','2014-04-24','10:00:00',3.16),('8784','2014-04-24','10:05:00',3.2),('8784','2014-04-24','10:10:00',3.25),('8784','2014-04-24','10:15:00',3.32),('8784','2014-04-24','10:20:00',3.38),('8784','2014-04-24','10:25:00',3.44),('8784','2014-04-24','10:30:00',3.48),('8784','2014-04-24','10:35:00',3.53),('8784','2014-04-24','10:40:00',3.57),('8784','2014-04-24','10:45:00',3.61),('8784','2014-04-24','10:50:00',3.67),('8784','2014-04-24','10:55:00',3.71),('8784','2014-04-24','11:00:00',3.7),('8784','2014-04-24','11:05:00',3.75),('8784','2014-04-24','11:10:00',3.82),('8784','2014-04-24','11:15:00',3.86),('8784','2014-04-24','11:20:00',3.88),('8784','2014-04-24','11:25:00',3.84),('8784','2014-04-24','11:30:00',3.83),('8784','2014-04-24','11:35:00',3.93),('8784','2014-04-24','11:40:00',3.97),('8784','2014-04-24','11:45:00',4.02),('8784','2014-04-24','11:50:00',3.97),('8784','2014-04-24','11:55:00',3.99),('8784','2014-04-24','12:00:00',4.02),('8784','2014-04-24','12:05:00',4.13),('8784','2014-04-24','12:10:00',3.28),('8784','2014-04-24','12:15:00',4.29),('8784','2014-04-24','12:20:00',4.18),('8784','2014-04-24','12:25:00',4.25),('8784','2014-04-24','12:30:00',4.31),('8784','2014-04-24','12:35:00',4.34),('8784','2014-04-24','12:40:00',4.3),('8784','2014-04-24','12:45:00',4.26),('8784','2014-04-24','12:50:00',4.24),('8784','2014-04-24','12:55:00',4.32),('8784','2014-04-24','13:00:00',4.31),('8784','2014-04-24','13:05:00',4.24),('8784','2014-04-24','13:10:00',4.35),('8784','2014-04-24','13:15:00',4.45),('8784','2014-04-24','13:20:00',4.37),('8784','2014-04-24','13:25:00',4.36),('8784','2014-04-24','13:30:00',2.92),('8784','2014-04-24','13:35:00',2.36),('8784','2014-04-24','13:40:00',1.19),('8784','2014-04-24','13:45:00',1.25),('8784','2014-04-24','13:50:00',4.57),('8784','2014-04-24','13:55:00',4.95),('8784','2014-04-24','14:00:00',4.71),('8784','2014-04-24','14:05:00',4.84),('8784','2014-04-24','14:10:00',4.87),('8784','2014-04-24','14:15:00',3.39),('8784','2014-04-24','14:20:00',4.19),('8784','2014-04-24','14:25:00',4.41),('8784','2014-04-24','14:30:00',3.97),('8784','2014-04-24','14:35:00',4.13),('8784','2014-04-24','14:40:00',3.02),('8784','2014-04-24','14:45:00',2.3),('8784','2014-04-24','14:50:00',2.32),('8784','2014-04-24','14:55:00',4.51),('8784','2014-04-24','15:00:00',4.56),('8784','2014-04-24','15:05:00',4.5),('8784','2014-04-24','15:10:00',4.51),('8784','2014-04-24','15:15:00',4.4),('8784','2014-04-24','15:20:00',2.98),('8784','2014-04-24','15:25:00',2.4),('8784','2014-04-24','15:30:00',2.84),('8784','2014-04-24','15:35:00',2.76),('8784','2014-04-24','15:40:00',2.51),('8784','2014-04-24','15:45:00',2.23),('8784','2014-04-24','15:50:00',2.42),('8784','2014-04-24','15:55:00',2.61),('8784','2014-04-24','16:00:00',4.03),('8784','2014-04-24','16:05:00',3.68),('8784','2014-04-24','16:10:00',3.12),('8784','2014-04-24','16:15:00',3.77),('8784','2014-04-24','16:20:00',3.02),('8784','2014-04-24','16:25:00',3.34),('8784','2014-04-24','16:30:00',3.13),('8784','2014-04-24','16:35:00',2.05),('8784','2014-04-24','16:40:00',2.02),('8784','2014-04-24','16:45:00',1.64),('8784','2014-04-24','16:50:00',1.4),('8784','2014-04-24','16:55:00',1.46),('8784','2014-04-24','17:00:00',1.49),('8784','2014-04-24','17:05:00',1.37),('8784','2014-04-24','17:10:00',1.29),('8784','2014-04-24','17:15:00',1.16),('8784','2014-04-24','17:20:00',1.13),('8784','2014-04-24','17:25:00',1.13),('8784','2014-04-24','17:30:00',1.14),('8784','2014-04-24','17:35:00',1.03),('8784','2014-04-23','13:10:00',1.1),('8784','2014-04-23','13:15:00',1.27),('8784','2014-04-23','13:20:00',1.39),('8784','2014-04-23','13:25:00',1.44),('8784','2014-04-23','13:30:00',1.55),('8784','2014-04-23','13:35:00',1.61),('8784','2014-04-23','13:40:00',1.71),('8784','2014-04-23','13:45:00',1.73),('8784','2014-04-23','13:50:00',1.73),('8784','2014-04-23','13:55:00',1.73),('8784','2014-04-23','14:00:00',1.63),('8784','2014-04-23','14:05:00',1.64),('8784','2014-04-23','14:10:00',1.56),('8784','2014-04-23','14:15:00',1.31),('8784','2014-04-23','14:20:00',1.15),('8784','2014-04-23','14:25:00',1.05),('8784','2014-04-23','14:45:00',1.15),('8784','2014-04-23','14:50:00',1.39),('8784','2014-04-23','14:55:00',1.6),('8784','2014-04-23','15:00:00',1.78),('8784','2014-04-23','15:05:00',1.87),('8784','2014-04-23','15:10:00',1.8),('8784','2014-04-23','15:15:00',1.9),('8784','2014-04-23','15:20:00',1.57),('8784','2014-04-23','15:25:00',1.44),('8784','2014-04-23','15:30:00',1.38),('8784','2014-04-23','15:35:00',1.32),('8784','2014-04-23','15:40:00',1.33),('8784','2014-04-23','15:45:00',1.49),('8784','2014-04-23','15:50:00',1.16),('8784','2014-04-23','15:55:00',1.08),('8784','2014-04-22','07:50:00',1.05),('8784','2014-04-22','07:55:00',1.13),('8784','2014-04-22','08:00:00',1.22),('8784','2014-04-22','08:05:00',1.29),('8784','2014-04-22','08:10:00',1.4),('8784','2014-04-22','08:15:00',1.5),('8784','2014-04-22','08:20:00',1.58),('8784','2014-04-22','08:25:00',1.67),('8784','2014-04-22','08:30:00',1.77),('8784','2014-04-22','08:35:00',1.84),('8784','2014-04-22','08:40:00',1.94),('8784','2014-04-22','08:45:00',2.01),('8784','2014-04-22','08:50:00',2.08),('8784','2014-04-22','08:55:00',2.1),('8784','2014-04-22','09:00:00',2.12),('8784','2014-04-22','09:05:00',2.45),('8784','2014-04-22','09:10:00',2.12),('8784','2014-04-22','09:15:00',2.24),('8784','2014-04-22','09:20:00',2.51),('8784','2014-04-22','09:25:00',2.74),('8784','2014-04-22','09:30:00',2.76),('8784','2014-04-22','09:35:00',2.92),('8784','2014-04-22','09:40:00',2.9),('8784','2014-04-22','09:45:00',2.98),('8784','2014-04-22','09:50:00',2.31),('8784','2014-04-22','09:55:00',1.54),('8784','2014-04-22','10:00:00',1.45),('8784','2014-04-22','10:05:00',1.55),('8784','2014-04-22','10:10:00',2.09),('8784','2014-04-22','10:15:00',2.21),('8784','2014-04-22','10:20:00',3.29),('8784','2014-04-22','10:25:00',2.31),('8784','2014-04-22','10:30:00',3.79),('8784','2014-04-22','10:35:00',3.81),('8784','2014-04-22','10:40:00',3.59),('8784','2014-04-22','10:45:00',3.92),('8784','2014-04-22','10:50:00',4.1),('8784','2014-04-22','10:55:00',2.97),('8784','2014-04-22','11:00:00',2.14),('8784','2014-04-22','11:05:00',2.41),('8784','2014-04-22','11:10:00',1.78),('8784','2014-04-22','11:15:00',1.47),('8784','2014-04-22','11:20:00',1.33),('8784','2014-04-22','11:25:00',1.31),('8784','2014-04-22','11:30:00',1.2),('8784','2014-04-22','11:35:00',1.26),('8784','2014-04-22','11:40:00',1.14),('8784','2014-04-22','11:50:00',1.01),('8784','2014-04-22','12:00:00',1.06),('8784','2014-04-22','12:05:00',1.28),('8784','2014-04-22','12:10:00',1.3),('8784','2014-04-22','12:15:00',1.31),('8784','2014-04-22','12:20:00',1.36),('8784','2014-04-22','12:25:00',1.47),('8784','2014-04-22','12:30:00',1.69),('8784','2014-04-22','12:35:00',1.47),('8784','2014-04-22','12:40:00',1.12),('8784','2014-04-22','13:10:00',1.01),('8784','2014-04-22','13:15:00',1.57),('8784','2014-04-22','13:20:00',2.39),('8784','2014-04-22','13:25:00',2.76),('8784','2014-04-22','13:30:00',2.95),('8784','2014-04-22','13:35:00',2.79),('8784','2014-04-22','13:40:00',3.33),('8784','2014-04-22','13:45:00',3.35),('8784','2014-04-22','13:50:00',2.82),('8784','2014-04-22','13:55:00',1.66),('8784','2014-04-22','14:00:00',1.48),('8784','2014-04-22','14:05:00',2),('8784','2014-04-22','14:10:00',3.68),('8784','2014-04-22','14:15:00',3.46),('8784','2014-04-22','14:20:00',4.14),('8784','2014-04-22','14:25:00',2.55),('8784','2014-04-22','14:30:00',2.21),('8784','2014-04-22','14:35:00',2.64),('8784','2014-04-22','14:40:00',3.48),('8784','2014-04-22','14:45:00',4.3),('8784','2014-04-22','14:50:00',3.91),('8784','2014-04-22','14:55:00',3),('8784','2014-04-22','15:00:00',1.43),('8784','2014-04-22','15:05:00',1.38),('8784','2014-04-22','15:10:00',1.27),('8784','2014-04-22','15:15:00',1.27),('8784','2014-04-22','15:20:00',1.42),('8784','2014-04-22','15:25:00',1.55),('8784','2014-04-22','15:30:00',1.93),('8784','2014-04-22','15:35:00',2.65),('8784','2014-04-22','15:40:00',2.17),('8784','2014-04-22','15:45:00',1.97),('8784','2014-04-22','15:50:00',2.28),('8784','2014-04-22','15:55:00',1.92),('8784','2014-04-22','16:00:00',2.24),('8784','2014-04-22','16:05:00',1.6),('8784','2014-04-22','16:10:00',1.54),('8784','2014-04-22','16:15:00',1.5),('8784','2014-04-22','16:20:00',1.73),('8784','2014-04-22','16:25:00',1.64),('8784','2014-04-22','16:30:00',1.4),('8784','2014-04-22','16:35:00',1.53),('8784','2014-04-22','16:40:00',1.92),('8784','2014-04-22','16:45:00',1.74),('8784','2014-04-22','16:50:00',1.39),('8784','2014-04-22','16:55:00',1.22),('8784','2014-04-22','17:00:00',1.38),('8784','2014-04-22','17:05:00',1.54),('8784','2014-04-22','17:10:00',1.2),('8784','2014-04-22','17:15:00',1.08),('8784','2014-04-21','08:40:00',1.01),('8784','2014-04-21','09:00:00',1.05),('8784','2014-04-21','09:05:00',1.04),('8784','2014-04-21','09:10:00',1.05),('8784','2014-04-21','09:15:00',1.17),('8784','2014-04-21','09:20:00',1.69),('8784','2014-04-21','09:25:00',1.47),('8784','2014-04-21','09:50:00',1.05),('8784','2014-04-21','09:55:00',1.12),('8784','2014-04-21','10:00:00',1.49),('8784','2014-04-21','10:05:00',3.35),('8784','2014-04-21','10:10:00',3.4),('8784','2014-04-21','10:15:00',3.51),('8784','2014-04-21','10:20:00',3.41),('8784','2014-04-21','10:25:00',3.43),('8784','2014-04-21','10:30:00',3.43),('8784','2014-04-21','10:35:00',3.46),('8784','2014-04-21','10:40:00',3.5),('8784','2014-04-21','10:45:00',3.56),('8784','2014-04-21','10:50:00',3.6),('8784','2014-04-21','10:55:00',3.64),('8784','2014-04-21','11:00:00',3.67),('8784','2014-04-21','11:05:00',3.72),('8784','2014-04-21','11:10:00',3.73),('8784','2014-04-21','11:15:00',3.77),('8784','2014-04-21','11:20:00',3.8),('8784','2014-04-21','11:25:00',3.87),('8784','2014-04-21','11:30:00',3.9),('8784','2014-04-21','11:35:00',3.92),('8784','2014-04-21','11:40:00',3.95),('8784','2014-04-21','11:45:00',3.98),('8784','2014-04-21','11:50:00',4.01),('8784','2014-04-21','11:55:00',4.04),('8784','2014-04-21','12:00:00',4.07),('8784','2014-04-21','12:05:00',4.09),('8784','2014-04-21','12:10:00',4.13),('8784','2014-04-21','12:15:00',4.17),('8784','2014-04-21','12:20:00',4.2),('8784','2014-04-21','12:25:00',4.21),('8784','2014-04-21','12:30:00',4.23),('8784','2014-04-21','12:35:00',4.22),('8784','2014-04-21','12:40:00',4.24),('8784','2014-04-21','12:45:00',4.24),('8784','2014-04-21','12:50:00',4.26),('8784','2014-04-21','12:55:00',4.23),('8784','2014-04-21','13:00:00',4.25),('8784','2014-04-21','13:05:00',4.27),('8784','2014-04-21','13:10:00',4.25),('8784','2014-04-21','13:15:00',4.25),('8784','2014-04-21','13:20:00',4.24),('8784','2014-04-21','13:25:00',4.24),('8784','2014-04-21','13:30:00',4.23),('8784','2014-04-21','13:35:00',4.21),('8784','2014-04-21','13:40:00',4.21),('8784','2014-04-21','13:45:00',4.25),('8784','2014-04-21','13:50:00',4.25),('8784','2014-04-21','13:55:00',4.24),('8784','2014-04-21','14:00:00',4.21),('8784','2014-04-21','14:05:00',4.2),('8784','2014-04-21','14:10:00',4.19),('8784','2014-04-21','14:15:00',4.18),('8784','2014-04-21','14:20:00',4.16),('8784','2014-04-21','14:25:00',4.12),('8784','2014-04-21','14:30:00',4.1),('8784','2014-04-21','14:35:00',4.07),('8784','2014-04-21','14:40:00',4.02),('8784','2014-04-21','14:45:00',3.98),('8784','2014-04-21','14:50:00',3.95),('8784','2014-04-21','14:55:00',3.92),('8784','2014-04-21','15:00:00',3.88),('8784','2014-04-21','15:05:00',3.85),('8784','2014-04-21','15:10:00',3.79),('8784','2014-04-21','15:15:00',3.74),('8784','2014-04-21','15:20:00',3.68),('8784','2014-04-21','15:25:00',3.63),('8784','2014-04-21','15:30:00',3.57),('8784','2014-04-21','15:35:00',3.52),('8784','2014-04-21','15:40:00',3.47),('8784','2014-04-21','15:45:00',3.41),('8784','2014-04-21','15:50:00',3.33),('8784','2014-04-21','15:55:00',3.28),('8784','2014-04-21','16:00:00',3.21),('8784','2014-04-21','16:05:00',3.2),('8784','2014-04-21','16:10:00',3.14),('8784','2014-04-21','16:15:00',3.08),('8784','2014-04-21','16:20:00',3.02),('8784','2014-04-21','16:25:00',2.63),('8784','2014-04-21','16:30:00',2.84),('8784','2014-04-21','16:35:00',2.78),('8784','2014-04-21','16:40:00',2.71),('8784','2014-04-21','16:45:00',2.63),('8784','2014-04-21','16:50:00',2.55),('8784','2014-04-21','16:55:00',2.47),('8784','2014-04-21','17:00:00',2.38),('8784','2014-04-21','17:05:00',2.32),('8784','2014-04-21','17:10:00',2.23),('8784','2014-04-21','17:15:00',2.14),('8784','2014-04-21','17:20:00',2.03),('8784','2014-04-21','17:25:00',1.98),('8784','2014-04-21','17:30:00',1.91),('8784','2014-04-21','17:35:00',1.83),('8784','2014-04-21','17:40:00',1.65),('8784','2014-04-21','17:45:00',1.64),('8784','2014-04-21','17:50:00',1.56),('8784','2014-04-21','17:55:00',1.46),('8784','2014-04-21','18:00:00',1.36),('8784','2014-04-21','18:05:00',1.27),('8784','2014-04-21','18:10:00',1.18),('8784','2014-04-21','18:15:00',1.1),('8784','2014-04-21','18:20:00',1.02),('8784','2013-12-04','09:35:00',1.18),('8784','2013-12-04','09:40:00',1.27),('8784','2013-12-04','09:45:00',1.33),('8784','2013-12-04','09:50:00',1.38),('8784','2013-12-04','09:55:00',1.42),('8784','2013-12-04','10:00:00',1.57),('8784','2013-12-04','10:05:00',1.71),('8784','2013-12-04','10:10:00',1.78),('8784','2013-12-04','10:15:00',1.85),('8784','2013-12-04','10:20:00',1.91),('8784','2013-12-04','10:25:00',1.95),('8784','2013-12-04','10:30:00',1.99),('8784','2013-12-04','10:35:00',2.04),('8784','2013-12-04','10:40:00',2.07),('8784','2013-12-04','10:45:00',2.1),('8784','2013-12-04','10:50:00',2.15),('8784','2013-12-04','10:55:00',2.13),('8784','2013-12-04','11:00:00',2.13),('8784','2013-12-04','11:05:00',2.12),('8784','2013-12-04','11:10:00',2.13),('8784','2013-12-04','11:15:00',2.15),('8784','2013-12-04','11:20:00',2.17),('8784','2013-12-04','11:25:00',2.19),('8784','2013-12-04','11:30:00',2.19),('8784','2013-12-04','11:35:00',2.18),('8784','2013-12-04','11:40:00',2.16),('8784','2013-12-04','11:45:00',2.17),('8784','2013-12-04','11:50:00',2.14),('8784','2013-12-04','11:55:00',2.18),('8784','2013-12-04','12:00:00',2.17),('8784','2013-12-04','12:05:00',2.17),('8784','2013-12-04','12:10:00',2.16),('8784','2013-12-04','12:15:00',2.14),('8784','2013-12-04','12:20:00',2.09),('8784','2013-12-04','12:25:00',2.09),('8784','2013-12-04','12:30:00',1.92),('8784','2013-12-04','12:35:00',1.98),('8784','2013-12-04','12:40:00',2.07),('8784','2013-12-04','12:45:00',2.04),('8784','2013-12-04','12:50:00',2),('8784','2013-12-04','12:55:00',1.96),('8784','2013-12-04','13:00:00',1.93),('8784','2013-12-04','13:05:00',1.93),('8784','2013-12-04','13:10:00',1.9),('8784','2013-12-04','13:15:00',1.85),('8784','2013-12-04','13:20:00',1.8),('8784','2013-12-04','13:25:00',1.74),('8784','2013-12-04','13:30:00',1.74),('8784','2013-12-04','13:35:00',1.69),('8784','2013-12-04','13:40:00',1.66),('8784','2013-12-04','13:45:00',1.64),('8784','2013-12-04','13:50:00',1.58),('8784','2013-12-04','13:55:00',1.51),('8784','2013-12-04','14:00:00',1.49),('8784','2013-12-04','14:05:00',1.4),('8784','2013-12-04','14:10:00',1.35),('8784','2013-12-04','14:15:00',1.37),('8784','2013-12-04','14:20:00',1.27),('8784','2013-12-04','14:25:00',1.25),('8784','2013-12-04','14:30:00',1.22),('8784','2013-12-04','14:35:00',1.17),('8784','2013-12-04','14:40:00',1.1),('8784','2013-12-04','14:45:00',1.04),('8784','2013-12-03','09:45:00',1.11),('8784','2013-12-03','09:50:00',1.18),('8784','2013-12-03','09:55:00',1.11),('8784','2013-12-03','10:00:00',1.54),('8784','2013-12-03','10:05:00',1.72),('8784','2013-12-03','10:10:00',1.77),('8784','2013-12-03','10:15:00',1.81),('8784','2013-12-03','10:20:00',1.85),('8784','2013-12-03','10:25:00',1.91),('8784','2013-12-03','10:30:00',1.94),('8784','2013-12-03','10:35:00',2),('8784','2013-12-03','10:40:00',2.03),('8784','2013-12-03','10:45:00',2.06),('8784','2013-12-03','10:50:00',2.13),('8784','2013-12-03','10:55:00',2.13),('8784','2013-12-03','11:00:00',2.14),('8784','2013-12-03','11:05:00',2.15),('8784','2013-12-03','11:10:00',2.16),('8784','2013-12-03','11:15:00',2.15),('8784','2013-12-03','11:20:00',2.14),('8784','2013-12-03','11:25:00',2.1),('8784','2013-12-03','11:30:00',2.16),('8784','2013-12-03','11:35:00',2.2),('8784','2013-12-03','11:40:00',2.2),('8784','2013-12-03','11:45:00',2.21),('8784','2013-12-03','11:50:00',2.19),('8784','2013-12-03','11:55:00',2.23),('8784','2013-12-03','12:00:00',2.1),('8784','2013-12-03','12:05:00',2.22),('8784','2013-12-03','12:10:00',2.24),('8784','2013-12-03','12:15:00',2.29),('8784','2013-12-03','12:20:00',2.24),('8784','2013-12-03','12:25:00',2.24),('8784','2013-12-03','12:30:00',2.24),('8784','2013-12-03','12:35:00',2.31),('8784','2013-12-03','12:40:00',2.41),('8784','2013-12-03','12:45:00',2.47),('8784','2013-12-03','12:50:00',2.54),('8784','2013-12-03','12:55:00',2.64),('8784','2013-12-03','13:00:00',2.59),('8784','2013-12-03','13:05:00',2.61),('8784','2013-12-03','13:10:00',2.68),('8784','2013-12-03','13:15:00',2.58),('8784','2013-12-03','13:20:00',2.54),('8784','2013-12-03','13:25:00',2.41),('8784','2013-12-03','13:30:00',2.28),('8784','2013-12-03','13:35:00',2.18),('8784','2013-12-03','13:40:00',2.07),('8784','2013-12-03','13:45:00',1.91),('8784','2013-12-03','13:50:00',1.82),('8784','2013-12-03','13:55:00',1.69),('8784','2013-12-03','14:00:00',1.61),('8784','2013-12-03','14:05:00',1.49),('8784','2013-12-03','14:10:00',1.32),('8784','2013-12-03','14:15:00',1.34),('8784','2013-12-03','14:20:00',1.1),('8784','2013-12-03','14:25:00',1.06),('8784','2013-12-03','14:30:00',1.12),('8784','2013-12-03','14:35:00',1.13),('8784','2013-12-03','14:40:00',1.11),('8784','2013-12-03','14:45:00',1.04),('8784','2013-12-01','11:35:00',1.18),('8784','2013-12-01','11:40:00',1.19),('8784','2013-12-01','11:55:00',1.32),('8784','2013-12-01','12:00:00',1.17),('8784','2013-12-01','12:05:00',1.32),('8784','2013-12-01','12:10:00',1.61),('8784','2013-12-01','12:15:00',1.21),('8784','2013-11-30','09:20:00',1.01),('8784','2013-11-30','09:25:00',1.07),('8784','2013-11-30','09:30:00',1.17),('8784','2013-11-30','09:35:00',1.32),('8784','2013-11-30','09:40:00',1.62),('8784','2013-11-30','09:45:00',1.32),('8784','2013-11-30','09:50:00',1.17),('8784','2013-11-30','09:55:00',1.15),('8784','2013-11-30','10:00:00',1.15),('8784','2013-11-30','10:05:00',1.06),('8784','2013-11-30','10:10:00',1.03),('8784','2013-11-30','10:15:00',1.12),('8784','2013-11-30','10:20:00',1.23),('8784','2013-11-30','10:25:00',1.19),('8784','2013-11-30','10:30:00',1.25),('8784','2013-11-30','10:35:00',1.37),('8784','2013-11-30','10:40:00',1.49),('8784','2013-11-30','10:45:00',1.4),('8784','2013-11-30','10:50:00',1.29),('8784','2013-11-30','10:55:00',1.17),('8784','2013-11-30','11:00:00',1.13),('8784','2013-11-30','11:05:00',1.34),('8784','2013-11-30','11:10:00',1.42),('8784','2013-11-30','11:15:00',1.37),('8784','2013-11-30','11:20:00',1.29),('8784','2013-11-30','11:25:00',1.33),('8784','2013-11-30','11:30:00',1.2),('8784','2013-11-30','11:35:00',1.13),('8784','2013-11-30','11:40:00',1.07),('8784','2013-11-29','09:30:00',1.18),('8784','2013-11-29','09:35:00',1.29),('8784','2013-11-29','09:40:00',1.35),('8784','2013-11-29','09:45:00',1.38),('8784','2013-11-29','09:50:00',1.41),('8784','2013-11-29','09:55:00',1.56),('8784','2013-11-29','10:00:00',1.72),('8784','2013-11-29','10:05:00',1.82),('8784','2013-11-29','10:10:00',1.88),('8784','2013-11-29','10:15:00',1.92),('8784','2013-11-29','10:20:00',1.96),('8784','2013-11-29','10:25:00',2.02),('8784','2013-11-29','10:30:00',2.06),('8784','2013-11-29','10:35:00',2.09),('8784','2013-11-29','10:40:00',2.13),('8784','2013-11-29','10:45:00',2.18),('8784','2013-11-29','10:50:00',2.21),('8784','2013-11-29','10:55:00',2.1),('8784','2013-11-29','11:00:00',2.15),('8784','2013-11-29','11:05:00',2.16),('8784','2013-11-29','11:10:00',2.19),('8784','2013-11-29','11:15:00',2.17),('8784','2013-11-29','11:20:00',2.2),('8784','2013-11-29','11:25:00',2.25),('8784','2013-11-29','11:30:00',2.26),('8784','2013-11-29','11:35:00',2.27),('8784','2013-11-29','11:40:00',2.28),('8784','2013-11-29','11:45:00',2.28),('8784','2013-11-29','11:50:00',2.28),('8784','2013-11-29','11:55:00',2.28),('8784','2013-11-29','12:00:00',2.26),('8784','2013-11-29','12:05:00',2.22),('8784','2013-11-29','12:10:00',2.22),('8784','2013-11-29','12:15:00',2.21),('8784','2013-11-29','12:20:00',2.2),('8784','2013-11-29','12:25:00',2.09),('8784','2013-11-29','12:30:00',2.14),('8784','2013-11-29','12:35:00',2.11),('8784','2013-11-29','12:40:00',2.09),('8784','2013-11-29','12:45:00',2.11),('8784','2013-11-29','12:50:00',2.09),('8784','2013-11-29','12:55:00',2.06),('8784','2013-11-29','13:00:00',2.03),('8784','2013-11-29','13:05:00',1.96),('8784','2013-11-29','13:10:00',1.92),('8784','2013-11-29','13:15:00',1.92),('8784','2013-11-29','13:20:00',1.87),('8784','2013-11-29','13:25:00',1.84),('8784','2013-11-29','13:30:00',1.75),('8784','2013-11-29','13:35:00',1.74),('8784','2013-11-29','13:40:00',1.72),('8784','2013-11-29','13:45:00',1.68),('8784','2013-11-29','13:50:00',1.59),('8784','2013-11-29','13:55:00',1.58),('8784','2013-11-29','14:00:00',1.53),('8784','2013-11-29','14:05:00',1.46),('8784','2013-11-29','14:10:00',1.42),('8784','2013-11-29','14:15:00',1.38),('8784','2013-11-29','14:20:00',1.29),('8784','2013-11-29','14:25:00',1.27),('8784','2013-11-29','14:30:00',1.23),('8784','2013-11-29','14:35:00',1.16),('8784','2013-11-29','14:40:00',1.07),('8784','2013-11-29','14:45:00',1.05),('8784','2013-11-28','12:55:00',1.13),('8784','2014-04-20','07:50:00',1.14),('8784','2014-04-20','07:55:00',1.25),('8784','2014-04-20','08:00:00',1.21),('8784','2014-04-20','08:05:00',1.26),('8784','2014-04-20','08:10:00',1.37),('8784','2014-04-20','08:15:00',1.52),('8784','2014-04-20','08:20:00',1.91),('8784','2014-04-20','08:25:00',2.34),('8784','2014-04-20','08:30:00',2.44),('8784','2014-04-20','08:35:00',2.19),('8784','2014-04-20','08:45:00',2.06),('8784','2014-04-20','08:50:00',1.43),('8784','2014-04-20','08:55:00',1.35),('8784','2014-04-20','09:00:00',1.79),('8784','2014-04-20','09:05:00',1.09),('8784','2014-04-20','09:10:00',2.53),('8784','2014-04-20','09:15:00',2.69),('8784','2014-04-20','09:20:00',2.84),('8784','2014-04-20','09:25:00',3.18),('8784','2014-04-20','09:30:00',3.66),('8784','2014-04-20','09:35:00',3.28),('8784','2014-04-20','09:40:00',2.07),('8784','2014-04-20','09:45:00',1.45),('8784','2014-04-20','09:50:00',1.73),('8784','2014-04-20','09:55:00',1.96),('8784','2014-04-20','10:00:00',2.39),('8784','2014-04-20','10:05:00',3.01),('8784','2014-04-20','10:10:00',2.88),('8784','2014-04-20','10:15:00',3.11),('8784','2014-04-20','10:20:00',3.19),('8784','2014-04-20','10:25:00',2.99),('8784','2014-04-20','10:30:00',2.78),('8784','2014-04-20','10:35:00',2.96),('8784','2014-04-20','10:40:00',2.79),('8784','2014-04-20','10:45:00',2.9),('8784','2014-04-20','10:50:00',3.1),('8784','2014-04-20','10:55:00',3.06),('8784','2014-04-20','11:00:00',3.56),('8784','2014-04-20','11:05:00',3.53),('8784','2014-04-20','11:10:00',3.67),('8784','2014-04-20','11:15:00',2.69),('8784','2014-04-20','11:20:00',2.8),('8784','2014-04-20','11:25:00',4.28),('8784','2014-04-20','11:30:00',4.31),('8784','2014-04-20','11:35:00',4.44),('8784','2014-04-20','11:40:00',2.42),('8784','2014-04-20','11:45:00',1.6),('8784','2014-04-20','11:50:00',2.99),('8784','2014-04-20','11:55:00',3.96),('8784','2014-04-20','12:00:00',4.3),('8784','2014-04-20','12:05:00',4.5),('8784','2014-04-20','12:10:00',2.82),('8784','2014-04-20','12:15:00',1.46),('8784','2014-04-20','12:20:00',3.34),('8784','2014-04-20','12:25:00',2.81),('8784','2014-04-20','12:30:00',4.46),('8784','2014-04-20','12:35:00',4.51),('8784','2014-04-20','12:40:00',4.51),('8784','2014-04-20','12:45:00',4.46),('8784','2014-04-20','12:50:00',4.48),('8784','2014-04-20','12:55:00',4.45),('8784','2014-04-20','13:00:00',4.47),('8784','2014-04-20','13:05:00',4.43),('8784','2014-04-20','13:10:00',4.4),('8784','2014-04-20','13:15:00',4.45),('8784','2014-04-20','13:20:00',4.39),('8784','2014-04-20','13:25:00',4.38),('8784','2014-04-20','13:30:00',4.39),('8784','2014-04-20','13:35:00',4.4),('8784','2014-04-20','13:40:00',4.4),('8784','2014-04-20','13:45:00',4.39),('8784','2014-04-20','13:50:00',4.34),('8784','2014-04-20','13:55:00',4.34),('8784','2014-04-20','14:00:00',4.26),('8784','2014-04-20','14:05:00',4.3),('8784','2014-04-20','14:10:00',4.32),('8784','2014-04-20','14:15:00',4.48),('8784','2014-04-20','14:20:00',3.31),('8784','2014-04-20','14:25:00',3.28),('8784','2014-04-20','14:30:00',3.09),('8784','2014-04-20','14:35:00',2.63),('8784','2014-04-20','14:40:00',2.62),('8784','2014-04-20','14:45:00',2.86),('8784','2014-04-20','14:50:00',2.77),('8784','2014-04-20','14:55:00',3.1),('8784','2014-04-20','15:00:00',4.1),('8784','2014-04-20','15:05:00',3.51),('8784','2014-04-20','15:10:00',3.95),('8784','2014-04-20','15:15:00',3.9),('8784','2014-04-20','15:20:00',3.79),('8784','2014-04-20','15:25:00',3.71),('8784','2014-04-20','15:30:00',3.65),('8784','2014-04-20','15:35:00',3.54),('8784','2014-04-20','15:40:00',3.6),('8784','2014-04-20','15:45:00',2.62),('8784','2014-04-20','15:50:00',2.65),('8784','2014-04-20','15:55:00',3.47),('8784','2014-04-20','16:00:00',3.3),('8784','2014-04-20','16:05:00',3.24),('8784','2014-04-20','16:10:00',3.2),('8784','2014-04-20','16:15:00',3.17),('8784','2014-04-20','16:20:00',3.13),('8784','2014-04-20','16:25:00',2.8),('8784','2014-04-20','16:30:00',3.06),('8784','2014-04-20','16:35:00',2.81),('8784','2014-04-20','16:40:00',2.36),('8784','2014-04-20','16:45:00',2.11),('8784','2014-04-20','16:50:00',2.52),('8784','2014-04-20','16:55:00',2.63),('8784','2014-04-20','17:00:00',2.49),('8784','2014-04-20','17:05:00',2.37),('8784','2014-04-20','17:10:00',2.24),('8784','2014-04-20','17:15:00',2.14),('8784','2014-04-20','17:20:00',2.06),('8784','2014-04-20','17:25:00',1.96),('8784','2014-04-20','17:30:00',1.89),('8784','2014-04-20','17:35:00',1.8),('8784','2014-04-20','17:40:00',1.71),('8784','2014-04-20','17:45:00',1.61),('8784','2014-04-20','17:50:00',1.52),('8784','2014-04-20','17:55:00',1.43),('8784','2014-04-20','18:00:00',1.35),('8784','2014-04-20','18:05:00',1.26),('8784','2014-04-20','18:10:00',1.17),('8784','2014-04-20','18:15:00',1.04),('8784','2013-11-27','09:50:00',1.05),('8784','2013-11-27','09:55:00',1.25),('8784','2013-11-27','10:00:00',1.23),('8784','2013-11-27','10:05:00',1.26),('8784','2013-11-27','10:10:00',1.25),('8784','2013-11-27','10:15:00',1.25),('8784','2013-11-27','10:20:00',1.17),('8784','2013-11-27','10:25:00',1.08),('8784','2013-11-27','10:30:00',1.08),('8784','2013-11-27','10:35:00',1.14),('8784','2013-11-27','10:40:00',1.29),('8784','2013-11-27','10:45:00',1.43),('8784','2013-11-27','10:50:00',1.34),('8784','2013-11-27','10:55:00',1.35),('8784','2013-11-27','11:00:00',1.4),('8784','2013-11-27','11:05:00',1.44),('8784','2013-11-27','11:10:00',1.83),('8784','2013-11-27','11:15:00',1.38),('8784','2013-11-27','11:20:00',1.41),('8784','2013-11-27','11:25:00',1.45),('8784','2013-11-27','11:30:00',2.22),('8784','2013-11-27','11:35:00',2.06),('8784','2013-11-27','11:40:00',1.59),('8784','2013-11-27','11:45:00',1.57),('8784','2013-11-27','11:50:00',2.31),('8784','2013-11-27','11:55:00',2.56),('8784','2013-11-27','12:00:00',2.64),('8784','2013-11-27','12:05:00',2.02),('8784','2013-11-27','12:10:00',1.37),('8784','2013-11-27','12:15:00',1.67),('8784','2013-11-27','12:20:00',2.55),('8784','2013-11-27','12:25:00',1.64),('8784','2013-11-27','12:30:00',1.34),('8784','2013-11-27','12:35:00',2.49),('8784','2013-11-27','12:40:00',1.34),('8784','2013-11-27','12:55:00',1.01),('8784','2013-11-27','13:00:00',1.08),('8784','2013-11-27','13:05:00',1.07),('8784','2013-11-27','13:10:00',1.07),('8784','2013-11-27','13:15:00',1.05),('8784','2013-11-27','13:20:00',1.03),('8784','2013-11-27','13:25:00',1.01),('8784','2013-11-27','13:30:00',1.02),('8784','2013-11-27','13:40:00',1.01),('8784','2013-11-26','09:35:00',1.1),('8784','2013-11-26','09:40:00',1.31),('8784','2013-11-26','09:50:00',1.07),('8784','2013-11-26','09:55:00',1.68),('8784','2013-11-26','10:00:00',1.26),('8784','2013-11-26','10:05:00',1.49),('8784','2013-11-26','10:10:00',1.25),('8784','2013-11-26','10:20:00',1.35),('8784','2013-11-26','10:25:00',1.6),('8784','2013-11-26','10:30:00',1.88),('8784','2013-11-26','10:35:00',2.3),('8784','2013-11-26','10:40:00',2.33),('8784','2013-11-26','10:45:00',2.41),('8784','2013-11-26','10:50:00',2.37),('8784','2013-11-26','10:55:00',2.23),('8784','2013-11-26','11:00:00',2.48),('8784','2013-11-26','11:05:00',2.34),('8784','2013-11-26','11:10:00',2.77),('8784','2013-11-26','11:15:00',2.97),('8784','2013-11-26','11:20:00',2.35),('8784','2013-11-26','11:25:00',2.69),('8784','2013-11-26','11:30:00',2.61),('8784','2013-11-26','11:35:00',2.03),('8784','2013-11-26','11:40:00',2.57),('8784','2013-11-26','11:45:00',2.91),('8784','2013-11-26','11:50:00',2.58),('8784','2013-11-26','11:55:00',1.9),('8784','2013-11-26','12:00:00',1.16),('8784','2013-11-26','12:05:00',1.47),('8784','2013-11-26','12:15:00',1.07),('8784','2013-11-26','12:20:00',2.44),('8784','2013-11-26','12:25:00',2.27),('8784','2013-11-26','12:30:00',2.27),('8784','2013-11-26','12:35:00',2.31),('8784','2013-11-26','12:40:00',2.35),('8784','2013-11-26','12:45:00',2.3),('8784','2013-11-26','12:50:00',2.26),('8784','2013-11-26','12:55:00',2.22),('8784','2013-11-26','13:00:00',2.18),('8784','2013-11-26','13:05:00',2.16),('8784','2013-11-26','13:10:00',2.12),('8784','2013-11-26','13:15:00',1.99),('8784','2013-11-26','13:20:00',2.02),('8784','2013-11-26','13:25:00',2.01),('8784','2013-11-26','13:30:00',1.95),('8784','2013-11-26','13:35:00',1.93),('8784','2013-11-26','13:40:00',1.9),('8784','2013-11-26','13:45:00',1.88),('8784','2013-11-26','13:50:00',1.89),('8784','2013-11-26','13:55:00',1.81),('8784','2013-11-26','14:00:00',2.1),('8784','2013-11-26','14:05:00',1.9),('8784','2013-11-26','14:10:00',2.11),('8784','2013-11-26','14:15:00',2.45),('8784','2013-11-26','14:20:00',2.19),('8784','2013-11-26','14:25:00',1.46),('8784','2013-11-26','14:30:00',1.01),('8784','2013-11-26','14:35:00',1.27),('8784','2013-11-26','14:40:00',1.34),('8784','2013-11-26','14:45:00',1.31),('8784','2013-11-26','14:50:00',1.33),('8784','2013-11-26','14:55:00',1.58),('8784','2013-11-26','15:00:00',1.43),('8784','2013-11-26','15:05:00',1.21),('8784','2013-11-26','15:10:00',1.04),('8784','2013-11-25','09:00:00',1.08),('8784','2013-11-25','09:05:00',1.23),('8784','2013-11-25','09:10:00',1.25),('8784','2013-11-25','09:15:00',1.35),('8784','2013-11-25','09:20:00',1.52),('8784','2013-11-25','09:25:00',1.32),('8784','2013-11-25','09:30:00',1.19),('8784','2013-11-25','09:35:00',1.47),('8784','2013-11-25','09:40:00',1.52),('8784','2013-11-25','09:45:00',1.01),('8784','2013-11-25','09:50:00',1.14),('8784','2013-11-25','09:55:00',1.26),('8784','2013-11-25','10:00:00',1.23),('8784','2013-11-25','10:05:00',1.9),('8784','2013-11-25','10:10:00',1.35),('8784','2013-11-25','10:15:00',2.01),('8784','2013-11-25','10:20:00',1.18),('8784','2013-11-25','10:25:00',1.41),('8784','2013-11-25','10:30:00',1.73),('8784','2013-11-25','10:35:00',2.13),('8784','2013-11-25','10:40:00',2.85),('8784','2013-11-25','10:45:00',2.63),('8784','2013-11-25','10:50:00',2.12),('8784','2013-11-25','10:55:00',1.75),('8784','2013-11-25','11:00:00',2.18),('8784','2013-11-25','11:05:00',2.54),('8784','2013-11-25','11:10:00',2.96),('8784','2013-11-25','11:15:00',2.67),('8784','2013-11-25','11:20:00',1.17),('8784','2013-11-25','11:25:00',1.25),('8784','2013-11-25','11:30:00',1.41),('8784','2013-11-25','11:35:00',1.2),('8784','2013-11-25','11:40:00',1.08),('8784','2013-11-25','11:45:00',1.18),('8784','2013-11-25','11:50:00',1.35),('8784','2013-11-25','11:55:00',1.18),('8784','2013-11-25','12:00:00',1.48),('8784','2013-11-25','12:05:00',1.48),('8784','2013-11-25','12:10:00',1.98),('8784','2013-11-25','12:15:00',1.62),('8784','2013-11-25','12:20:00',1.39),('8784','2013-11-25','12:25:00',1.43),('8784','2013-11-25','12:30:00',1.26),('8784','2013-11-25','12:35:00',1.17),('8784','2013-11-25','12:40:00',2.53),('8784','2013-11-25','12:45:00',2.48),('8784','2013-11-25','12:50:00',2.01),('8784','2013-11-25','12:55:00',2.18),('8784','2013-11-25','13:00:00',2.72),('8784','2013-11-25','13:05:00',2.57),('8784','2013-11-25','13:10:00',1.76),('8784','2013-11-25','13:15:00',1.67),('8784','2013-11-25','13:20:00',2.86),('8784','2013-11-25','13:25:00',2.73),('8784','2013-11-25','13:30:00',1.5),('8784','2013-11-25','13:35:00',1.04),('8784','2013-11-24','09:55:00',1.25),('8784','2013-11-24','10:00:00',1.5),('8784','2013-11-24','10:05:00',1.59),('8784','2013-11-24','10:10:00',1.62),('8784','2013-11-24','10:15:00',1.48),('8784','2013-11-24','10:20:00',1.31),('8784','2013-11-24','10:25:00',1.79),('8784','2013-11-24','10:30:00',1.54),('8784','2013-11-24','10:35:00',1.33),('8784','2013-11-24','10:40:00',1.09),('8784','2013-11-24','10:45:00',1.01),('8784','2013-11-24','10:50:00',1.05),('8784','2013-11-24','10:55:00',1.16),('8784','2013-11-24','11:00:00',1.21),('8784','2013-11-24','11:05:00',1.27),('8784','2013-11-24','11:10:00',1.34),('8784','2013-11-24','11:15:00',1.38),('8784','2013-11-24','11:20:00',1.52),('8784','2013-11-24','11:25:00',1.53),('8784','2013-11-24','11:30:00',1.46),('8784','2013-11-24','11:35:00',1.26),('8784','2013-11-24','11:40:00',1.17),('8784','2013-11-24','11:45:00',1.17),('8784','2013-11-24','11:50:00',1.29),('8784','2013-11-24','11:55:00',1.17),('8784','2013-11-24','12:25:00',1.03),('8784','2013-11-24','12:30:00',1.02),('8784','2013-11-24','12:35:00',1.01),('8784','2013-11-24','12:40:00',1.03),('8784','2013-11-24','13:00:00',1.1),('8784','2013-11-24','13:05:00',1.37),('8784','2013-11-24','13:10:00',1.44),('8784','2013-11-24','13:15:00',1.4),('8784','2013-11-24','13:20:00',1.17),('8784','2013-11-24','13:25:00',1),('8784','2013-11-23','10:15:00',1.15),('8784','2013-11-23','10:20:00',1.2),('8784','2013-11-23','10:25:00',1.53),('8784','2013-11-23','10:30:00',1.65),('8784','2013-11-23','10:35:00',1.04),('8784','2013-11-23','10:40:00',2.34),('8784','2013-11-23','13:20:00',1.03),('8784','2013-11-23','13:25:00',1.26),('8784','2013-11-23','13:30:00',1.15),('8784','2013-11-23','13:35:00',1.47),('8784','2013-11-23','13:40:00',1.25),('8784','2013-11-23','13:55:00',1.08),('8784','2013-11-23','14:00:00',1.14),('8784','2013-11-23','14:05:00',1.08),('8784','2013-11-21','09:45:00',1.46),('8784','2013-11-21','09:50:00',1.23),('8784','2013-11-21','09:55:00',1.66),('8784','2013-11-21','10:00:00',1.63),('8784','2013-11-21','10:05:00',1.98),('8784','2013-11-21','10:10:00',1.84),('8784','2013-11-21','10:15:00',2.18),('8784','2013-11-21','10:20:00',1.98),('8784','2013-11-21','10:25:00',1.33),('8784','2013-11-21','10:30:00',2.13),('8784','2013-11-21','10:35:00',2.27),('8784','2013-11-21','10:40:00',2.52),('8784','2013-11-21','10:45:00',1.78),('8784','2013-11-21','11:15:00',1.26),('8784','2013-11-21','11:20:00',1.3),('8784','2013-11-21','11:25:00',1.32),('8784','2013-11-21','11:30:00',1.91),('8784','2013-11-21','11:35:00',1.64),('8784','2013-11-21','11:40:00',1.91),('8784','2013-11-21','11:45:00',1.9),('8784','2013-11-21','11:50:00',2.19),('8784','2013-11-21','11:55:00',2.23),('8784','2013-11-21','12:00:00',1.07),('8784','2013-11-21','12:05:00',2.41),('8784','2013-11-21','12:10:00',2.39),('8784','2013-11-21','12:15:00',2.39),('8784','2013-11-21','12:20:00',2.41),('8784','2013-11-21','12:25:00',2.41),('8784','2013-11-21','12:30:00',2.62),('8784','2013-11-21','12:35:00',2.55),('8784','2013-11-21','12:40:00',2.61),('8784','2013-11-21','12:45:00',2.69),('8784','2013-11-21','12:50:00',2.66),('8784','2013-11-21','12:55:00',2.72),('8784','2013-11-21','13:00:00',2.78),('8784','2013-11-21','13:05:00',2.55),('8784','2013-11-21','13:10:00',2.38),('8784','2013-11-21','13:15:00',2.58),('8784','2013-11-21','13:20:00',2.38),('8784','2013-11-21','13:25:00',1.86),('8784','2013-11-21','13:40:00',1.72),('8784','2013-11-21','13:45:00',2.08),('8784','2013-11-21','13:50:00',1.19),('8784','2013-11-21','13:55:00',1.89),('8784','2013-11-21','14:00:00',2.01),('8784','2013-11-21','14:05:00',1.11),('8784','2013-11-21','14:25:00',1.01),('8784','2013-11-21','14:40:00',1.25),('8784','2013-11-21','14:45:00',1.18),('8784','2013-11-21','14:50:00',1.13),('8784','2013-11-21','14:55:00',1),('8784','2013-11-20','09:20:00',1.13),('8784','2013-11-20','09:25:00',1.26),('8784','2013-11-20','09:30:00',1.08),('8784','2013-11-20','10:00:00',1.52),('8784','2013-11-20','10:15:00',1.92),('8784','2013-11-20','11:20:00',1.05),('8784','2013-11-20','11:25:00',1.26),('8784','2013-11-20','11:30:00',1.17),('8784','2013-11-20','11:35:00',1.15),('8784','2013-11-20','11:40:00',1.24),('8784','2013-11-20','11:45:00',3.55),('8784','2013-11-20','11:50:00',3.49),('8784','2013-11-20','11:55:00',1.88),('8784','2013-11-20','12:15:00',1.06),('8784','2013-11-20','12:20:00',1.76),('8784','2013-11-20','12:25:00',1.28),('8784','2013-11-20','12:40:00',1.01),('8784','2013-11-20','12:45:00',1.17),('8784','2013-11-20','12:50:00',1.86),('8784','2013-11-20','12:55:00',2.41),('8784','2013-11-20','13:00:00',1.66),('8784','2013-11-20','13:05:00',1.57),('8784','2013-11-20','13:20:00',1.42),('8784','2013-11-20','13:25:00',1.24),('8784','2013-11-20','13:35:00',1.06),('8784','2013-11-20','13:45:00',1.27),('8784','2013-11-20','13:50:00',1.77),('8784','2013-11-20','14:25:00',1.31),('8784','2013-11-20','14:45:00',1.15),('8784','2013-11-20','15:05:00',1.06),('8784','2013-11-20','15:10:00',1.03),('8784','2013-11-19','09:40:00',1.6),('8784','2013-11-19','09:45:00',1.63),('8784','2013-11-19','10:00:00',1.13),('8784','2013-11-19','10:05:00',1.2),('8784','2013-11-19','10:50:00',1.46),('8784','2013-11-19','11:20:00',2.34),('8784','2013-11-19','11:25:00',1.95),('8784','2013-11-19','11:30:00',2.05),('8784','2013-11-19','11:35:00',2.54),('8784','2013-11-19','11:40:00',1.94),('8784','2013-11-19','11:45:00',2.3),('8784','2013-11-19','11:50:00',2.26),('8784','2013-11-19','11:55:00',1.97),('8784','2013-11-19','12:00:00',1.85),('8784','2013-11-19','12:05:00',2.29),('8784','2013-11-19','12:10:00',2.21),('8784','2013-11-19','12:15:00',2.19),('8784','2013-11-19','12:20:00',1.07),('8784','2013-11-19','12:30:00',1.52),('8784','2013-11-19','12:40:00',1.28),('8784','2013-11-19','12:45:00',2.06),('8784','2013-11-19','12:50:00',2.04),('8784','2013-11-19','12:55:00',2.67),('8784','2013-11-19','13:00:00',1.1),('8784','2013-11-19','13:05:00',1.1),('8784','2013-11-19','13:10:00',1.12),('8784','2013-11-19','13:15:00',2.06),('8784','2013-11-19','13:20:00',1.72),('8784','2013-11-19','15:25:00',1.16),('8784','2013-11-19','15:30:00',1.37),('8784','2013-11-18','09:20:00',1.19),('8784','2013-11-18','09:25:00',1.37),('8784','2013-11-18','09:30:00',1.27),('8784','2013-11-18','09:35:00',1.63),('8784','2013-11-18','09:40:00',1.26),('8784','2013-11-18','09:45:00',1.17),('8784','2013-11-18','09:50:00',1.02),('8784','2013-11-18','09:55:00',1.09),('8784','2013-11-18','10:00:00',1.24),('8784','2013-11-18','10:05:00',1.38),('8784','2013-11-18','10:10:00',1.63),('8784','2013-11-18','10:15:00',1.72),('8784','2013-11-18','10:20:00',1.41),('8784','2013-11-18','10:25:00',1.36),('8784','2013-11-18','10:30:00',1.25),('8784','2013-11-18','10:35:00',1.25),('8784','2013-11-18','10:40:00',1.31),('8784','2013-11-18','10:45:00',1.35),('8784','2013-11-18','10:50:00',1.28),('8784','2013-11-18','10:55:00',1.14),('8784','2013-11-18','11:00:00',1.04),('8784','2013-11-18','11:25:00',1.02),('8784','2013-11-18','11:30:00',1.13),('8784','2013-11-18','11:35:00',1.2),('8784','2013-11-18','11:40:00',1.23),('8784','2013-11-18','11:45:00',1.25),('8784','2013-11-18','11:50:00',1.32),('8784','2013-11-18','11:55:00',1.41),('8784','2013-11-18','12:00:00',1.47),('8784','2013-11-18','12:05:00',1.54),('8784','2013-11-18','12:10:00',1.52),('8784','2013-11-18','12:15:00',1.57),('8784','2013-11-18','12:20:00',1.64),('8784','2013-11-18','12:25:00',1.64),('8784','2013-11-18','12:30:00',1.52),('8784','2013-11-18','12:35:00',1.35),('8784','2013-11-18','12:40:00',1.18),('8784','2013-11-18','12:45:00',1.06),('8784','2013-11-18','13:10:00',1.09),('8784','2013-11-18','13:15:00',1.03),('8784','2013-11-18','13:35:00',1.18),('8784','2013-11-18','13:40:00',1.23),('8784','2013-11-18','13:45:00',1.14),('8784','2013-11-18','13:50:00',1.08),('8784','2014-04-19','07:35:00',1.1),('8784','2014-04-19','07:40:00',1.25),('8784','2014-04-19','07:55:00',2.05),('8784','2014-04-19','08:00:00',1.59),('8784','2014-04-19','08:05:00',1.23),('8784','2014-04-19','08:10:00',1.62),('8784','2014-04-19','08:15:00',1.2),('8784','2014-04-19','08:20:00',1.31),('8784','2014-04-19','08:25:00',1.73),('8784','2014-04-19','08:30:00',2.35),('8784','2014-04-19','08:35:00',2.51),('8784','2014-04-19','08:40:00',2.16),('8784','2014-04-19','08:45:00',1.93),('8784','2014-04-19','08:50:00',1.54),('8784','2014-04-19','08:55:00',1.05),('8784','2014-04-19','09:20:00',1.15),('8784','2014-04-19','09:25:00',1.61),('8784','2014-04-19','09:30:00',2.3),('8784','2014-04-19','09:35:00',2.09),('8784','2014-04-19','09:40:00',1.28),('8784','2014-04-19','10:35:00',1.02),('8784','2014-04-19','10:40:00',1.33),('8784','2014-04-19','10:45:00',1.26),('8784','2014-04-19','10:50:00',1.34),('8784','2014-04-19','10:55:00',1.72),('8784','2014-04-19','11:00:00',1.73),('8784','2014-04-19','11:05:00',1.37),('8784','2014-04-19','11:10:00',1.36),('8784','2014-04-19','11:15:00',2.09),('8784','2014-04-19','11:20:00',3.31),('8784','2014-04-19','11:25:00',2.72),('8784','2014-04-19','11:30:00',2.77),('8784','2014-04-19','11:35:00',2.74),('8784','2014-04-19','11:40:00',2.56),('8784','2014-04-19','11:45:00',2.23),('8784','2014-04-19','11:50:00',1.79),('8784','2014-04-19','11:55:00',1.14),('8784','2014-04-19','13:15:00',1.67),('8784','2014-04-19','13:20:00',1.39),('8784','2014-04-19','14:30:00',1.52),('8784','2014-04-19','14:35:00',1.64),('8784','2014-04-19','14:40:00',1.97),('8784','2014-04-19','14:45:00',2.06),('8784','2014-04-19','14:50:00',1.3),('8784','2014-04-19','14:55:00',1.17),('8784','2014-04-19','15:00:00',1.55),('8784','2014-04-19','15:05:00',1.3),('8784','2014-04-19','15:25:00',1.21),('8784','2014-04-19','15:30:00',1.15),('8784','2014-04-19','15:45:00',1.15),('8784','2014-04-19','15:50:00',3.84),('8784','2014-04-19','15:55:00',2.83),('8784','2014-04-19','16:00:00',2.43),('8784','2014-04-19','16:05:00',2.24),('8784','2014-04-19','16:10:00',1.97),('8784','2014-04-19','16:15:00',1.83),('8784','2014-04-19','16:20:00',2.15),('8784','2014-04-19','16:25:00',2.09),('8784','2014-04-19','16:30:00',3.01),('8784','2014-04-19','16:35:00',1.63),('8784','2014-04-19','16:40:00',1.2),('8784','2014-04-19','16:45:00',1.08),('8784','2014-04-19','17:05:00',1),('8784','2014-04-19','17:10:00',1.05),('8784','2014-04-19','17:15:00',1.14),('8784','2014-04-19','17:20:00',1.84),('8784','2014-04-19','17:25:00',1.42),('8784','2014-04-19','17:30:00',1.27),('8784','2014-04-19','17:35:00',1.03),('8784','2013-11-17','08:55:00',1.18),('8784','2013-11-17','09:00:00',1.09),('8784','2013-11-17','09:10:00',1.04),('8784','2013-11-17','09:20:00',1.35),('8784','2013-11-17','09:25:00',1.49),('8784','2013-11-17','09:30:00',1.53),('8784','2013-11-17','09:35:00',1.52),('8784','2013-11-17','09:40:00',1.56),('8784','2013-11-17','09:45:00',1.69),('8784','2013-11-17','09:50:00',1.82),('8784','2013-11-17','09:55:00',1.87),('8784','2013-11-17','10:00:00',1.94),('8784','2013-11-17','10:05:00',1.99),('8784','2013-11-17','10:10:00',2.05),('8784','2013-11-17','10:15:00',2.08),('8784','2013-11-17','10:20:00',2.12),('8784','2013-11-17','10:25:00',2.12),('8784','2013-11-17','10:30:00',2.21),('8784','2013-11-17','10:35:00',2.23),('8784','2013-11-17','10:40:00',2.24),('8784','2013-11-17','10:45:00',2.18),('8784','2013-11-17','10:50:00',2.15),('8784','2013-11-17','10:55:00',2.25),('8784','2013-11-17','11:00:00',2.28),('8784','2013-11-17','11:05:00',2.24),('8784','2013-11-17','11:10:00',2.25),('8784','2013-11-17','11:15:00',2.27),('8784','2013-11-17','11:20:00',2.32),('8784','2013-11-17','11:25:00',2.32),('8784','2013-11-17','11:30:00',2.31),('8784','2013-11-17','11:35:00',2.3),('8784','2013-11-17','11:40:00',2.32),('8784','2013-11-17','11:45:00',2.32),('8784','2013-11-17','11:50:00',2.31),('8784','2013-11-17','11:55:00',2.32),('8784','2013-11-17','12:00:00',2.31),('8784','2013-11-17','12:05:00',2.29),('8784','2013-11-17','12:10:00',2.27),('8784','2013-11-17','12:15:00',2.24),('8784','2013-11-17','12:20:00',2.22),('8784','2013-11-17','12:25:00',2.06),('8784','2013-11-17','12:30:00',2.15),('8784','2013-11-17','12:35:00',2.12),('8784','2013-11-17','12:40:00',2.13),('8784','2013-11-17','12:45:00',2.15),('8784','2013-11-17','12:50:00',2.07),('8784','2013-11-17','12:55:00',2.03),('8784','2013-11-17','13:00:00',2.03),('8784','2013-11-17','13:05:00',1.98),('8784','2013-11-17','13:10:00',1.96),('8784','2013-11-17','13:15:00',1.96),('8784','2013-11-17','13:20:00',1.88),('8784','2013-11-17','13:25:00',1.52),('8784','2013-11-17','13:30:00',1.69),('8784','2013-11-17','13:35:00',1.14),('8784','2013-11-17','13:40:00',1.61),('8784','2013-11-17','14:10:00',1.54),('8784','2013-11-17','14:15:00',1.46),('8784','2013-11-17','14:20:00',1.35),('8784','2013-11-17','14:25:00',1.31),('8784','2013-11-17','14:30:00',1.24),('8784','2013-11-17','14:35:00',1.19),('8784','2013-11-17','14:40:00',1.13),('8784','2013-11-16','13:05:00',1.09),('8784','2013-11-15','09:10:00',1.11),('8784','2013-11-15','09:15:00',1.28),('8784','2013-11-15','09:20:00',1.07),('8784','2013-11-15','09:25:00',1.01),('8784','2013-11-15','09:30:00',1.26),('8784','2013-11-15','09:35:00',1.36),('8784','2013-11-15','09:40:00',1.15),('8784','2013-11-15','10:10:00',1.13),('8784','2013-11-15','10:15:00',1.41),('8784','2013-11-15','10:20:00',1.32),('8784','2013-11-15','10:25:00',1.05),('8784','2013-11-15','10:50:00',1.17),('8784','2013-11-15','10:55:00',1.44),('8784','2013-11-15','11:00:00',1.35),('8784','2013-11-15','11:05:00',1.27),('8784','2013-11-15','11:10:00',1.23),('8784','2013-11-15','11:15:00',1.32),('8784','2013-11-15','11:20:00',1.68),('8784','2013-11-15','11:25:00',1.81),('8784','2013-11-15','11:30:00',1.79),('8784','2013-11-15','11:35:00',1.74),('8784','2013-11-15','11:40:00',2.03),('8784','2013-11-15','11:45:00',1.53),('8784','2013-11-15','11:50:00',1.33),('8784','2013-11-15','11:55:00',1.22),('8784','2013-11-15','12:00:00',1.23),('8784','2013-11-15','12:05:00',1.31),('8784','2013-11-15','12:10:00',1.13),('8784','2013-11-15','12:15:00',1.2),('8784','2013-11-15','12:20:00',1.42),('8784','2013-11-15','12:25:00',1.6),('8784','2013-11-15','12:30:00',1.34),('8784','2013-11-15','12:35:00',1.22),('8784','2013-11-15','12:40:00',1.15),('8784','2013-11-15','12:45:00',1.12),('8784','2013-11-15','12:50:00',1.17),('8784','2013-11-15','12:55:00',1.35),('8784','2013-11-15','13:00:00',1.4),('8784','2013-11-15','13:05:00',1.23),('8784','2013-11-15','13:10:00',1.11),('8784','2013-11-15','13:30:00',1.08),('8784','2013-11-15','13:35:00',1.21),('8784','2013-11-15','13:40:00',1.35),('8784','2013-11-15','13:45:00',1.71),('8784','2013-11-15','13:50:00',1.82),('8784','2013-11-15','13:55:00',1.19),('8784','2013-11-15','14:00:00',1.08),('8784','2013-11-14','09:15:00',1.16),('8784','2013-11-14','09:20:00',1.45),('8784','2013-11-14','09:25:00',1.49),('8784','2013-11-14','09:30:00',1.41),('8784','2013-11-14','09:35:00',1.53),('8784','2013-11-14','09:40:00',1.69),('8784','2013-11-14','09:45:00',1.75),('8784','2013-11-14','09:50:00',1.28),('8784','2013-11-14','09:55:00',1.06),('8784','2013-11-14','10:00:00',1),('8784','2013-11-14','10:05:00',1.46),('8784','2013-11-14','10:10:00',1.35),('8784','2013-11-14','10:15:00',2.15),('8784','2013-11-14','10:20:00',2.2),('8784','2013-11-14','10:25:00',2.18),('8784','2013-11-14','10:30:00',2.23),('8784','2013-11-14','10:35:00',2.25),('8784','2013-11-14','10:40:00',2.26),('8784','2013-11-14','10:45:00',2.19),('8784','2013-11-14','10:50:00',2.17),('8784','2013-11-14','10:55:00',2.16),('8784','2013-11-14','11:00:00',2.26),('8784','2013-11-14','11:05:00',2.38),('8784','2013-11-14','11:10:00',2.43),('8784','2013-11-14','11:15:00',2.47),('8784','2013-11-14','11:20:00',2.53),('8784','2013-11-14','11:25:00',2.53),('8784','2013-11-14','11:30:00',2.52),('8784','2013-11-14','11:35:00',2.24),('8784','2013-11-14','11:40:00',2.16),('8784','2013-11-14','11:45:00',1.62),('8784','2013-11-14','11:50:00',1.77),('8784','2013-11-14','11:55:00',1.87),('8784','2013-11-14','12:00:00',2.83),('8784','2013-11-14','12:05:00',1.9),('8784','2013-11-14','12:10:00',1.36),('8784','2013-11-14','12:15:00',1.42),('8784','2013-11-14','12:20:00',1.31),('8784','2013-11-14','12:25:00',1.13),('8784','2013-11-14','12:30:00',1.12),('8784','2013-11-14','12:35:00',1.17),('8784','2013-11-14','12:40:00',1.15),('8784','2013-11-14','12:45:00',1.17),('8784','2013-11-14','12:50:00',1.22),('8784','2013-11-14','12:55:00',1.19),('8784','2013-11-14','13:00:00',1.17),('8784','2013-11-14','13:05:00',1.05),('8784','2013-11-14','13:30:00',1),('8784','2013-11-14','13:55:00',1.38),('8784','2013-11-13','10:05:00',1.11),('8784','2013-11-13','10:10:00',1.13),('8784','2013-11-13','10:15:00',1.12),('8784','2013-11-13','10:20:00',2.27),('8784','2013-11-13','10:25:00',3.26),('8784','2013-11-13','10:30:00',2.85),('8784','2013-11-13','10:35:00',3.22),('8784','2013-11-13','10:40:00',2.94),('8784','2013-11-13','10:45:00',2.83),('8784','2013-11-13','10:50:00',3.26),('8784','2013-11-13','10:55:00',3),('8784','2013-11-13','11:00:00',1.5),('8784','2013-11-13','11:25:00',1.02),('8784','2013-11-13','11:30:00',1.08),('8784','2013-11-13','11:45:00',1.11),('8784','2013-11-13','11:50:00',1.26),('8784','2013-11-13','11:55:00',1.16),('8784','2013-11-13','12:55:00',1.05),('8784','2013-11-13','13:00:00',1.18),('8784','2013-11-13','13:05:00',1.37),('8784','2013-11-13','13:10:00',1.26),('8784','2013-11-13','13:15:00',1.25),('8784','2013-11-13','13:20:00',1.01),('8784','2013-11-13','13:40:00',1.03),('8784','2013-11-13','13:55:00',1.52),('8784','2013-11-13','14:00:00',1.69),('8784','2013-11-13','14:05:00',1.58),('8784','2013-11-13','14:10:00',1.52),('8784','2013-11-13','14:15:00',1.53),('8784','2013-11-13','14:20:00',1.43),('8784','2013-11-13','14:25:00',1.52),('8784','2013-11-13','14:30:00',1.41),('8784','2013-11-13','14:35:00',1.08),('8784','2013-11-12','11:25:00',1.39),('8784','2013-11-12','11:35:00',1.16),('8784','2013-11-12','11:40:00',2.29),('8784','2013-11-12','11:45:00',1.2),('8784','2013-11-12','11:50:00',1.78),('8784','2013-11-12','11:55:00',1.06),('8784','2013-11-12','12:00:00',2.44),('8784','2013-11-12','12:05:00',1.43),('8784','2013-11-12','12:30:00',3.27),('8784','2013-11-12','12:35:00',3.17),('8784','2013-11-12','12:40:00',2.08),('8784','2013-11-12','12:45:00',2.01),('8784','2013-11-12','12:50:00',2),('8784','2013-11-12','12:55:00',2.23),('8784','2013-11-12','13:00:00',1.98),('8784','2013-11-12','13:05:00',1.94),('8784','2013-11-12','13:10:00',2.24),('8784','2013-11-12','13:15:00',2.06),('8784','2013-11-12','13:20:00',1.98),('8784','2013-11-12','13:25:00',2.12),('8784','2013-11-12','13:30:00',1.91),('8784','2013-11-12','13:35:00',1.99),('8784','2013-11-12','13:40:00',2.12),('8784','2013-11-12','13:45:00',1.67),('8784','2013-11-12','13:50:00',1.31),('8784','2013-11-12','13:55:00',1.44),('8784','2013-11-12','14:00:00',1.39),('8784','2013-11-12','14:05:00',1.24),('8784','2013-11-12','14:10:00',2.38),('8784','2013-11-12','14:15:00',2.35),('8784','2013-11-12','14:20:00',2.06),('8784','2013-11-12','14:25:00',1.26),('8784','2013-11-12','14:30:00',1.6),('8784','2013-11-12','14:35:00',1.35),('8784','2013-11-12','14:40:00',1.46),('8784','2013-11-12','14:45:00',1.25),('8784','2013-11-11','09:50:00',1.27),('8784','2013-11-11','09:55:00',1.33),('8784','2013-11-11','10:00:00',1.04),('8784','2013-11-11','10:05:00',1.28),('8784','2013-11-11','10:10:00',1.27),('8784','2013-11-11','10:15:00',1.93),('8784','2013-11-11','10:20:00',2.47),('8784','2013-11-11','10:25:00',1.35),('8784','2013-11-11','11:05:00',1.52),('8784','2013-11-11','11:10:00',3.2),('8784','2013-11-11','11:15:00',2.54),('8784','2013-11-11','11:20:00',2.06),('8784','2013-11-11','11:25:00',2.45),('8784','2013-11-11','11:30:00',3.33),('8784','2013-11-11','11:35:00',2.37),('8784','2013-11-11','11:40:00',3.54),('8784','2013-11-11','11:45:00',2.73),('8784','2013-11-11','11:50:00',3.36),('8784','2013-11-11','11:55:00',3.1),('8784','2013-11-11','12:00:00',2.84),('8784','2013-11-11','12:05:00',2.73),('8784','2013-11-11','12:10:00',2.68),('8784','2013-11-11','12:15:00',2.22),('8784','2013-11-11','12:20:00',2.69),('8784','2013-11-11','12:25:00',2.51),('8784','2013-11-11','12:30:00',1.1),('8784','2013-11-11','12:40:00',1.74),('8784','2013-11-11','12:45:00',1.9),('8784','2013-11-11','13:00:00',1.15),('8784','2013-11-11','13:10:00',1.78),('8784','2013-11-11','13:15:00',1.7),('8784','2013-11-11','13:35:00',1.13),('8784','2013-11-11','13:40:00',1.63),('8784','2013-11-11','14:00:00',2.16),('8784','2013-11-11','14:05:00',1.29),('8784','2013-11-11','14:20:00',1.41),('8784','2013-11-11','14:25:00',1.89),('8784','2013-11-11','14:30:00',1.66),('8784','2013-11-11','14:35:00',1.6),('8784','2013-11-11','14:40:00',1.41),('8784','2013-11-10','08:35:00',1.03),('8784','2013-11-10','08:50:00',1.19),('8784','2013-11-10','08:55:00',1.24),('8784','2013-11-10','09:00:00',1.18),('8784','2013-11-10','09:20:00',1.33),('8784','2013-11-10','09:25:00',1.76),('8784','2013-11-10','09:30:00',1.53),('8784','2013-11-10','09:35:00',1.52),('8784','2013-11-10','09:40:00',1.69),('8784','2013-11-10','09:45:00',1.95),('8784','2013-11-10','09:50:00',2.04),('8784','2013-11-10','09:55:00',2),('8784','2013-11-10','10:00:00',2.06),('8784','2013-11-10','10:05:00',2.34),('8784','2013-11-10','10:10:00',2.46),('8784','2013-11-10','10:15:00',2.45),('8784','2013-11-10','10:20:00',2.27),('8784','2013-11-10','10:25:00',2.71),('8784','2013-11-10','10:30:00',2.72),('8784','2013-11-10','10:35:00',1.86),('8784','2013-11-10','10:40:00',2.67),('8784','2013-11-10','10:45:00',2.1),('8784','2013-11-10','10:50:00',3.05),('8784','2013-11-10','10:55:00',2.91),('8784','2013-11-10','11:00:00',1.82),('8784','2013-11-10','11:05:00',1.47),('8784','2013-11-10','11:10:00',1.02),('8784','2013-11-10','11:20:00',1.03),('8784','2013-11-10','11:25:00',1.32),('8784','2013-11-10','11:35:00',1.24),('8784','2013-11-10','11:40:00',2.03),('8784','2013-11-10','11:45:00',2.19),('8784','2013-11-10','11:55:00',1.52),('8784','2013-11-10','12:05:00',1.22),('8784','2013-11-10','12:10:00',1.59),('8784','2013-11-10','12:15:00',2.58),('8784','2013-11-10','12:20:00',2.32),('8784','2013-11-10','12:25:00',2.2),('8784','2013-11-10','12:30:00',1.55),('8784','2013-11-10','12:35:00',2.17),('8784','2013-11-10','12:40:00',2.7),('8784','2013-11-10','12:45:00',2.9),('8784','2013-11-10','12:50:00',2.89),('8784','2013-11-10','12:55:00',1.59),('8784','2013-11-10','13:00:00',1.36),('8784','2013-11-10','13:45:00',1.17),('8784','2013-11-10','13:50:00',2.16),('8784','2013-11-10','13:55:00',1.71),('8784','2013-11-10','14:30:00',1.05),('8784','2013-11-09','09:40:00',1.65),('8784','2013-11-09','09:45:00',1.45),('8784','2013-11-09','09:50:00',2.66),('8784','2013-11-09','09:55:00',2.52),('8784','2013-11-09','10:00:00',2.44),('8784','2013-11-09','10:05:00',2.17),('8784','2013-11-09','10:10:00',1.93),('8784','2013-11-09','10:15:00',2.11),('8784','2013-11-09','10:20:00',2.13),('8784','2013-11-09','10:25:00',1.4),('8784','2013-11-09','10:30:00',1.19),('8784','2013-11-09','10:35:00',1.39),('8784','2013-11-09','10:40:00',1.39),('8784','2013-11-09','10:45:00',1.47),('8784','2013-11-09','10:50:00',1.62),('8784','2013-11-09','10:55:00',1.94),('8784','2013-11-09','11:00:00',1.86),('8784','2013-11-09','11:05:00',2.51),('8784','2013-11-09','11:10:00',2.95),('8784','2013-11-09','11:15:00',2.8),('8784','2013-11-09','11:20:00',1.65),('8784','2013-11-09','11:25:00',2.09),('8784','2013-11-09','11:30:00',1.82),('8784','2013-11-09','11:35:00',1.82),('8784','2013-11-09','11:40:00',2.62),('8784','2013-11-09','11:45:00',2.11),('8784','2013-11-09','11:50:00',2.35),('8784','2013-11-09','11:55:00',2.8),('8784','2013-11-09','12:00:00',3.2),('8784','2013-11-09','12:05:00',3.16),('8784','2013-11-09','12:10:00',1.71),('8784','2013-11-09','12:15:00',1.74),('8784','2013-11-09','12:20:00',1.18),('8784','2013-11-09','12:25:00',1.78),('8784','2013-11-09','12:30:00',2.18),('8784','2013-11-09','12:35:00',2.93),('8784','2013-11-09','12:40:00',3.25),('8784','2013-11-09','12:45:00',1.66),('8784','2013-11-09','12:50:00',1.77),('8784','2013-11-09','12:55:00',1.85),('8784','2013-11-09','13:00:00',2.74),('8784','2013-11-09','13:05:00',2.2),('8784','2013-11-09','13:10:00',2.65),('8784','2013-11-09','13:15:00',2.53),('8784','2013-11-09','13:25:00',2.27),('8784','2013-11-09','13:30:00',2.16),('8784','2013-11-09','13:35:00',2.16),('8784','2013-11-09','13:40:00',2.05),('8784','2013-11-09','13:45:00',2.03),('8784','2013-11-09','13:50:00',2.05),('8784','2013-11-09','13:55:00',2),('8784','2013-11-09','14:00:00',1.88),('8784','2013-11-09','14:05:00',1.63),('8784','2013-11-09','14:10:00',1.07),('8784','2013-11-09','14:15:00',1.29),('8784','2013-11-09','14:20:00',1.9),('8784','2013-11-09','14:25:00',1.38),('8784','2013-11-09','14:35:00',1.08),('8784','2013-11-09','14:40:00',1.26),('8784','2013-11-09','14:50:00',1.26),('8784','2013-11-08','09:10:00',1.09),('8784','2013-11-08','09:15:00',1.01),('8784','2013-11-08','09:25:00',1.11),('8784','2013-11-08','09:30:00',1.44),('8784','2013-11-08','09:35:00',1.52),('8784','2013-11-08','09:40:00',1.26),('8784','2013-11-08','09:45:00',1.3),('8784','2013-11-08','09:50:00',2.13),('8784','2013-11-08','09:55:00',1.45),('8784','2013-11-08','10:00:00',2.46),('8784','2013-11-08','10:05:00',1.58),('8784','2013-11-08','10:10:00',1.28),('8784','2013-11-08','10:45:00',1.25),('8784','2013-11-08','10:50:00',2.31),('8784','2013-11-08','10:55:00',1),('8784','2013-11-08','11:20:00',1.48),('8784','2013-11-08','11:35:00',2.05),('8784','2013-11-08','11:40:00',2.58),('8784','2013-11-08','11:45:00',2.67),('8784','2013-11-08','11:50:00',2.92),('8784','2013-11-08','11:55:00',2.86),('8784','2013-11-08','12:00:00',2.41),('8784','2013-11-08','12:05:00',2.55),('8784','2013-11-08','12:10:00',2.51),('8784','2013-11-08','12:35:00',2.3),('8784','2013-11-08','12:40:00',2.66),('8784','2013-11-08','12:45:00',2.66),('8784','2013-11-08','12:55:00',2.67),('8784','2013-11-08','13:00:00',2.52),('8784','2013-11-08','13:05:00',2.46),('8784','2013-11-08','13:10:00',2.5),('8784','2013-11-08','13:15:00',1.31),('8784','2013-11-08','13:20:00',2.22),('8784','2013-11-08','13:25:00',1.07),('8784','2013-11-08','13:30:00',1.21),('8784','2013-11-08','13:35:00',2.16),('8784','2013-11-08','13:40:00',2.09),('8784','2013-11-08','13:45:00',2.02),('8784','2013-11-08','13:50:00',1.7),('8784','2013-11-08','13:55:00',1.9),('8784','2013-11-08','14:00:00',1.9),('8784','2013-11-08','14:05:00',1.8),('8784','2013-11-08','14:10:00',1.75),('8784','2013-11-08','14:15:00',1.51),('8784','2013-11-08','14:20:00',1.47),('8784','2013-11-08','14:25:00',1.54),('8784','2013-11-08','14:30:00',1.6),('8784','2013-11-08','14:35:00',1.6),('8784','2013-11-08','14:40:00',1.44),('8784','2013-11-08','14:45:00',1.33),('8784','2013-11-08','14:50:00',1.17),('8784','2013-11-08','15:00:00',1.1),('8784','2013-11-08','15:05:00',1.1),('8784','2013-11-08','15:10:00',1.05),('8784','2014-04-18','08:05:00',1.76),('8784','2014-04-18','08:10:00',1.71),('8784','2014-04-18','08:35:00',1.07),('8784','2014-04-18','08:40:00',1.57),('8784','2014-04-18','08:45:00',1.65),('8784','2014-04-18','08:50:00',1.2),('8784','2014-04-18','08:55:00',1.1),('8784','2014-04-18','09:00:00',1.26),('8784','2014-04-18','09:05:00',2.53),('8784','2014-04-18','09:10:00',3.36),('8784','2014-04-18','09:15:00',3.08),('8784','2014-04-18','09:20:00',2.87),('8784','2014-04-18','09:25:00',1.85),('8784','2014-04-18','09:30:00',3.25),('8784','2014-04-18','09:35:00',1.95),('8784','2014-04-18','09:40:00',1.16),('8784','2014-04-18','09:45:00',1.99),('8784','2014-04-18','09:50:00',3.05),('8784','2014-04-18','09:55:00',3.34),('8784','2014-04-18','10:00:00',2.77),('8784','2014-04-18','10:05:00',1.83),('8784','2014-04-18','10:10:00',1.62),('8784','2014-04-18','10:15:00',1.77),('8784','2014-04-18','10:20:00',1.62),('8784','2014-04-18','10:25:00',1.66),('8784','2014-04-18','10:30:00',1.39),('8784','2014-04-18','10:35:00',1.28),('8784','2014-04-18','10:40:00',1.51),('8784','2014-04-18','10:45:00',2.55),('8784','2014-04-18','10:50:00',2.99),('8784','2014-04-18','10:55:00',3.21),('8784','2014-04-18','11:00:00',2.06),('8784','2014-04-18','11:05:00',1.82),('8784','2014-04-18','11:10:00',2.01),('8784','2014-04-18','11:15:00',3.36),('8784','2014-04-18','11:20:00',2.07),('8784','2014-04-18','11:25:00',1.54),('8784','2014-04-18','11:30:00',1.82),('8784','2014-04-18','11:35:00',1.79),('8784','2014-04-18','11:40:00',1.86),('8784','2014-04-18','11:45:00',1.79),('8784','2014-04-18','11:50:00',2.16),('8784','2014-04-18','11:55:00',1.93),('8784','2014-04-18','12:00:00',2),('8784','2014-04-18','12:05:00',3.7),('8784','2014-04-18','12:10:00',3.59),('8784','2014-04-18','12:15:00',3.8),('8784','2014-04-18','12:20:00',4.09),('8784','2014-04-18','12:25:00',3.04),('8784','2014-04-18','12:30:00',4.65),('8784','2014-04-18','12:35:00',4.39),('8784','2014-04-18','12:40:00',4.65),('8784','2014-04-18','12:45:00',3.79),('8784','2014-04-18','12:50:00',3.8),('8784','2014-04-18','12:55:00',2.86),('8784','2014-04-18','13:00:00',4.55),('8784','2014-04-18','13:05:00',2.75),('8784','2014-04-18','13:10:00',2.67),('8784','2014-04-18','13:15:00',2.57),('8784','2014-04-18','13:20:00',2.43),('8784','2014-04-18','13:25:00',1.82),('8784','2014-04-18','13:30:00',1.49),('8784','2014-04-18','13:35:00',1.51),('8784','2014-04-18','13:40:00',1.44),('8784','2014-04-18','13:45:00',1.24),('8784','2014-04-18','13:50:00',1.5),('8784','2014-04-18','13:55:00',2.49),('8784','2014-04-18','14:00:00',2.19),('8784','2014-04-18','14:05:00',1.88),('8784','2014-04-18','14:10:00',1.61),('8784','2014-04-18','14:15:00',1.46),('8784','2014-04-18','14:20:00',1.71),('8784','2014-04-18','14:25:00',2.18),('8784','2014-04-18','14:30:00',2.45),('8784','2014-04-18','14:35:00',2.76),('8784','2014-04-18','14:40:00',2.43),('8784','2014-04-18','14:45:00',2.85),('8784','2014-04-18','14:50:00',3.12),('8784','2014-04-18','14:55:00',2.46),('8784','2014-04-18','15:00:00',4.46),('8784','2014-04-18','15:05:00',2.76),('8784','2014-04-18','15:10:00',1.96),('8784','2014-04-18','15:15:00',2.57),('8784','2014-04-18','15:20:00',1.97),('8784','2014-04-18','15:25:00',2.35),('8784','2014-04-18','15:30:00',3.44),('8784','2014-04-18','15:35:00',3.67),('8784','2014-04-18','15:40:00',3.49),('8784','2014-04-18','15:45:00',2.48),('8784','2014-04-18','15:50:00',2.85),('8784','2014-04-18','15:55:00',2.96),('8784','2014-04-18','16:00:00',2.52),('8784','2014-04-18','16:05:00',1.98),('8784','2014-04-18','16:10:00',1.59),('8784','2014-04-18','16:15:00',1.39),('8784','2014-04-18','16:20:00',1.43),('8784','2014-04-18','16:25:00',2.48),('8784','2014-04-18','16:30:00',2.49),('8784','2014-04-18','16:35:00',2.8),('8784','2014-04-18','16:40:00',3.08),('8784','2014-04-18','16:45:00',2.8),('8784','2014-04-18','16:50:00',2.79),('8784','2014-04-18','16:55:00',2.65),('8784','2014-04-18','17:00:00',2.76),('8784','2014-04-18','17:05:00',2.78),('8784','2014-04-18','17:10:00',2.39),('8784','2014-04-18','17:15:00',2.06),('8784','2014-04-18','17:20:00',2.09),('8784','2014-04-18','17:25:00',2.07),('8784','2014-04-18','17:30:00',1.88),('8784','2014-04-18','17:35:00',1.79),('8784','2014-04-18','17:40:00',1.73),('8784','2014-04-18','17:45:00',1.63),('8784','2014-04-18','17:50:00',1.55),('8784','2014-04-18','17:55:00',1.47),('8784','2014-04-18','18:00:00',1.39),('8784','2014-04-18','18:05:00',1.25),('8784','2014-04-18','18:10:00',1.16),('8784','2014-04-18','18:15:00',1.02),('8784','2013-11-07','08:45:00',1.05),('8784','2013-11-07','08:50:00',1.15),('8784','2013-11-07','08:55:00',1.19),('8784','2013-11-07','09:00:00',1.26),('8784','2013-11-07','09:05:00',1.35),('8784','2013-11-07','09:10:00',1.5),('8784','2013-11-07','09:15:00',1.6),('8784','2013-11-07','09:20:00',1.66),('8784','2013-11-07','09:25:00',1.7),('8784','2013-11-07','09:30:00',1.75),('8784','2013-11-07','09:35:00',1.79),('8784','2013-11-07','09:40:00',1.88),('8784','2013-11-07','09:45:00',2.02),('8784','2013-11-07','09:50:00',2.06),('8784','2013-11-07','09:55:00',2.11),('8784','2013-11-07','10:00:00',2.15),('8784','2013-11-07','10:05:00',2.18),('8784','2013-11-07','10:10:00',2.19),('8784','2013-11-07','10:15:00',2.22),('8784','2013-11-07','10:20:00',2.24),('8784','2013-11-07','10:25:00',2.29),('8784','2013-11-07','10:30:00',2.31),('8784','2013-11-07','10:35:00',2.34),('8784','2013-11-07','10:40:00',2.33),('8784','2013-11-07','10:45:00',2.34),('8784','2013-11-07','10:50:00',2.35),('8784','2013-11-07','10:55:00',2.36),('8784','2013-11-07','11:00:00',2.35),('8784','2013-11-07','11:05:00',2.33),('8784','2013-11-07','11:10:00',2.35),('8784','2013-11-07','11:15:00',2.36),('8784','2013-11-07','11:20:00',2.34),('8784','2013-11-07','11:25:00',2.33),('8784','2013-11-07','11:30:00',2.38),('8784','2013-11-07','11:35:00',2.43),('8784','2013-11-07','11:40:00',2.42),('8784','2013-11-07','11:45:00',2.42),('8784','2013-11-07','11:50:00',2.43),('8784','2013-11-07','11:55:00',2.42),('8784','2013-11-07','12:00:00',2.39),('8784','2013-11-07','12:05:00',2.36),('8784','2013-11-07','12:10:00',2.36),('8784','2013-11-07','12:15:00',2.34),('8784','2013-11-07','12:20:00',2.32),('8784','2013-11-07','12:25:00',2.22),('8784','2013-11-07','12:30:00',2.28),('8784','2013-11-07','12:35:00',2.23),('8784','2013-11-07','12:40:00',2.25),('8784','2013-11-07','12:45:00',2.24),('8784','2013-11-07','12:50:00',2.24),('8784','2013-11-07','12:55:00',2.24),('8784','2013-11-07','13:00:00',2.44),('8784','2013-11-07','13:05:00',2.43),('8784','2013-11-07','13:10:00',1.44),('8784','2013-11-07','13:15:00',1.07),('8784','2013-11-07','13:20:00',1.02),('8784','2013-11-07','13:25:00',1.3),('8784','2013-11-07','13:30:00',1.56),('8784','2013-11-07','13:35:00',2.22),('8784','2013-11-07','13:40:00',1.64),('8784','2013-11-07','13:45:00',1.41),('8784','2013-11-07','13:50:00',2.06),('8784','2013-11-07','13:55:00',1.72),('8784','2013-11-07','14:05:00',1.17),('8784','2013-11-07','14:10:00',1.4),('8784','2013-11-07','14:15:00',1.23),('8784','2013-11-07','14:20:00',1.1),('8784','2013-11-07','14:25:00',1.29),('8784','2013-11-07','14:30:00',1.54),('8784','2013-11-07','14:35:00',1.34),('8784','2013-11-07','14:40:00',1.39),('8784','2013-11-07','14:45:00',1.27),('8784','2013-11-07','14:50:00',1.26),('8784','2013-11-07','14:55:00',1.22),('8784','2013-11-07','15:00:00',1.12),('8784','2013-11-07','15:05:00',1.08),('8784','2013-11-06','08:40:00',1.02),('8784','2013-11-06','08:45:00',1.09),('8784','2013-11-06','08:50:00',1.07),('8784','2013-11-06','08:55:00',1.18),('8784','2013-11-06','09:15:00',1.35),('8784','2013-11-06','09:20:00',1.44),('8784','2013-11-06','09:25:00',1.72),('8784','2013-11-06','09:30:00',1.85),('8784','2013-11-06','09:35:00',1.89),('8784','2013-11-06','09:40:00',1.93),('8784','2013-11-06','09:45:00',1.97),('8784','2013-11-06','09:50:00',2.09),('8784','2013-11-06','09:55:00',2.14),('8784','2013-11-06','10:00:00',2.18),('8784','2013-11-06','10:05:00',2.27),('8784','2013-11-06','10:10:00',2.34),('8784','2013-11-06','10:15:00',2.37),('8784','2013-11-06','10:20:00',2.41),('8784','2013-11-06','10:25:00',2.45),('8784','2013-11-06','10:30:00',2.41),('8784','2013-11-06','10:35:00',2.48),('8784','2013-11-06','10:40:00',2.5),('8784','2013-11-06','10:45:00',2.48),('8784','2013-11-06','10:50:00',2.5),('8784','2013-11-06','10:55:00',2.5),('8784','2013-11-06','11:00:00',2.5),('8784','2013-11-06','11:05:00',2.56),('8784','2013-11-06','11:10:00',2.56),('8784','2013-11-06','11:15:00',2.58),('8784','2013-11-06','11:20:00',2.57),('8784','2013-11-06','11:25:00',2.6),('8784','2013-11-06','11:30:00',2.62),('8784','2013-11-06','11:35:00',2.61),('8784','2013-11-06','11:40:00',2.6),('8784','2013-11-06','11:45:00',2.58),('8784','2013-11-06','11:50:00',2.6),('8784','2013-11-06','11:55:00',2.6),('8784','2013-11-06','12:00:00',2.59),('8784','2013-11-06','12:05:00',2.59),('8784','2013-11-06','12:10:00',2.57),('8784','2013-11-06','12:15:00',2.55),('8784','2013-11-06','12:20:00',2.55),('8784','2013-11-06','12:25:00',2.39),('8784','2013-11-06','12:30:00',2.08),('8784','2013-11-06','12:35:00',2.35),('8784','2013-11-06','12:40:00',2.38),('8784','2013-11-06','12:45:00',2.32),('8784','2013-11-06','12:50:00',2.36),('8784','2013-11-06','12:55:00',2.38),('8784','2013-11-06','13:00:00',2.34),('8784','2013-11-06','13:05:00',2.33),('8784','2013-11-06','13:10:00',2.26),('8784','2013-11-06','13:15:00',2.21),('8784','2013-11-06','13:20:00',2.21),('8784','2013-11-06','13:25:00',2.18),('8784','2013-11-06','13:30:00',2.13),('8784','2013-11-06','13:35:00',2.06),('8784','2013-11-06','13:40:00',1.92),('8784','2013-11-06','13:45:00',1.99),('8784','2013-11-06','13:50:00',1.95),('8784','2013-11-06','13:55:00',1.93),('8784','2013-11-06','14:00:00',1.87),('8784','2013-11-06','14:05:00',1.78),('8784','2013-11-06','14:10:00',1.74),('8784','2013-11-06','14:15:00',1.73),('8784','2013-11-06','14:20:00',1.67),('8784','2013-11-06','14:25:00',1.6),('8784','2013-11-06','14:30:00',1.53),('8784','2013-11-06','14:35:00',1.45),('8784','2013-11-06','14:40:00',1.38),('8784','2013-11-06','14:45:00',1.36),('8784','2013-11-06','14:50:00',1.29),('8784','2013-11-06','14:55:00',1.2),('8784','2013-11-06','15:00:00',1.14),('8784','2013-11-06','15:05:00',1.12),('8784','2013-11-06','15:10:00',1.04),('8784','2013-11-06','15:15:00',1),('8784','2013-11-05','08:35:00',1.18),('8784','2013-11-05','08:40:00',1.26),('8784','2013-11-05','10:15:00',1),('8784','2013-11-05','10:20:00',1.73),('8784','2013-11-05','10:25:00',2.22),('8784','2013-11-05','10:30:00',1.59),('8784','2013-11-05','10:35:00',2.37),('8784','2013-11-05','10:40:00',1.61),('8784','2013-11-05','10:45:00',1.76),('8784','2013-11-05','10:50:00',1.51),('8784','2013-11-05','10:55:00',1.33),('8784','2013-11-05','11:00:00',1.12),('8784','2013-11-05','11:35:00',1.18),('8784','2013-11-05','11:40:00',1.57),('8784','2013-11-05','11:45:00',1.52),('8784','2013-11-05','11:50:00',1.4),('8784','2013-11-05','11:55:00',1.19),('8784','2013-11-05','12:00:00',1.05),('8784','2013-11-05','12:05:00',1.28),('8784','2013-11-05','12:10:00',1.59),('8784','2013-11-05','12:15:00',1.56),('8784','2013-11-05','12:20:00',1.66),('8784','2013-11-05','12:25:00',1.48),('8784','2013-11-05','12:30:00',1.27),('8784','2013-11-05','12:35:00',1.09),('8784','2013-11-05','13:30:00',1.19),('8784','2013-11-05','13:35:00',2.14),('8784','2013-11-05','13:40:00',2.21),('8784','2013-11-05','13:45:00',2.07),('8784','2013-11-05','13:50:00',1.13),('8784','2013-11-05','13:55:00',1.37),('8784','2013-11-05','14:00:00',1.62),('8784','2013-11-05','14:05:00',1.98),('8784','2013-11-05','14:10:00',2.29),('8784','2013-11-05','14:20:00',1.61),('8784','2013-11-05','14:25:00',1.5),('8784','2013-11-05','14:30:00',1.66),('8784','2013-11-05','14:35:00',1.66),('8784','2013-11-05','14:45:00',1.28),('8784','2013-11-04','09:10:00',1.67),('8784','2013-11-04','09:15:00',1.88),('8784','2013-11-04','09:20:00',1.77),('8784','2013-11-04','09:25:00',1.64),('8784','2013-11-04','09:30:00',1.12),('8784','2013-11-04','10:00:00',1.71),('8784','2013-11-04','10:05:00',2.4),('8784','2013-11-04','10:10:00',2.43),('8784','2013-11-04','10:15:00',2.48),('8784','2013-11-04','10:20:00',2.53),('8784','2013-11-04','10:25:00',2.84),('8784','2013-11-04','10:30:00',2.87),('8784','2013-11-04','10:35:00',2.7),('8784','2013-11-04','10:40:00',3.04),('8784','2013-11-04','10:45:00',1.88),('8784','2013-11-04','10:50:00',1.97),('8784','2013-11-04','10:55:00',2.84),('8784','2013-11-04','11:00:00',2.39),('8784','2013-11-04','11:05:00',2.71),('8784','2013-11-04','11:10:00',1.35),('8784','2013-11-04','11:15:00',2.06),('8784','2013-11-04','11:20:00',1.57),('8784','2013-11-04','11:25:00',1.38),('8784','2013-11-04','11:30:00',2.49),('8784','2013-11-04','11:35:00',2.44),('8784','2013-11-04','11:40:00',2.07),('8784','2013-11-04','11:45:00',2.52),('8784','2013-11-04','11:50:00',3.55),('8784','2013-11-04','11:55:00',3.06),('8784','2013-11-04','12:00:00',3.06),('8784','2013-11-04','12:05:00',2.68),('8784','2013-11-04','12:10:00',2.73),('8784','2013-11-04','12:15:00',2.67),('8784','2013-11-04','12:20:00',2.53),('8784','2013-11-04','12:25:00',2.55),('8784','2013-11-04','12:30:00',2.54),('8784','2013-11-04','12:35:00',2.59),('8784','2013-11-04','12:40:00',2.57),('8784','2013-11-04','12:45:00',2.55),('8784','2013-11-04','12:50:00',2.51),('8784','2013-11-04','12:55:00',2.45),('8784','2013-11-04','13:00:00',2.42),('8784','2013-11-04','13:05:00',2.27),('8784','2013-11-04','13:10:00',2.39),('8784','2013-11-04','13:15:00',2.28),('8784','2013-11-04','13:20:00',1.8),('8784','2013-11-04','13:25:00',2.31),('8784','2013-11-04','13:30:00',2.25),('8784','2013-11-04','13:35:00',2.34),('8784','2013-11-04','13:40:00',1.69),('8784','2013-11-04','13:45:00',2.33),('8784','2013-11-04','13:50:00',2.18),('8784','2013-11-04','13:55:00',1.45),('8784','2013-11-04','14:00:00',1.33),('8784','2013-11-04','14:05:00',1.52),('8784','2013-11-04','14:10:00',1.99),('8784','2013-11-04','14:15:00',2.01),('8784','2013-11-04','14:20:00',2.03),('8784','2013-11-04','14:25:00',1.19),('8784','2013-11-04','14:30:00',1.25),('8784','2013-11-04','14:35:00',1.94),('8784','2013-11-04','14:40:00',1.65),('8784','2013-11-04','14:45:00',1.58),('8784','2013-11-04','14:50:00',1.52),('8784','2013-11-04','14:55:00',1.3),('8784','2013-11-04','15:00:00',1.28),('8784','2013-11-04','15:25:00',1.01),('8784','2013-11-03','09:40:00',2.44),('8784','2013-11-03','09:45:00',1.44),('8784','2013-11-03','10:10:00',1.39),('8784','2013-11-03','10:20:00',2.24),('8784','2013-11-03','10:25:00',1.68),('8784','2013-11-03','10:30:00',2.51),('8784','2013-11-03','10:35:00',1.63),('8784','2013-11-03','11:15:00',1.05),('8784','2013-11-03','11:20:00',1.78),('8784','2013-11-03','11:25:00',1.07),('8784','2013-11-03','11:30:00',2.37),('8784','2013-11-03','11:35:00',2.55),('8784','2013-11-03','11:40:00',2.96),('8784','2013-11-03','11:45:00',3.05),('8784','2013-11-03','11:50:00',3.21),('8784','2013-11-03','11:55:00',2.32),('8784','2013-11-03','12:00:00',2.89),('8784','2013-11-03','12:05:00',3.13),('8784','2013-11-03','12:10:00',2.84),('8784','2013-11-03','12:15:00',1.72),('8784','2013-11-03','12:25:00',1.46),('8784','2013-11-03','12:35:00',1.17),('8784','2013-11-03','12:40:00',1.37),('8784','2013-11-03','12:45:00',1.14),('8784','2013-11-03','12:50:00',1.13),('8784','2013-11-03','13:25:00',1.05),('8784','2013-11-03','13:30:00',1.01),('8784','2013-11-03','13:35:00',1.2),('8784','2013-11-03','13:40:00',1.42),('8784','2013-11-03','13:45:00',2.06),('8784','2013-11-03','13:55:00',1.23),('8784','2013-11-03','14:00:00',1.41),('8784','2013-11-03','14:05:00',2.11),('8784','2013-11-03','14:10:00',2.21),('8784','2013-11-03','14:15:00',2.05),('8784','2013-11-03','14:20:00',1.76),('8784','2013-11-03','14:25:00',1.95),('8784','2013-11-03','14:30:00',1.22),('8784','2013-11-03','14:35:00',1.23),('8784','2013-11-03','14:40:00',1.68),('8784','2013-11-03','14:45:00',1.46),('8784','2013-11-03','14:50:00',1.14),('8784','2013-11-02','08:40:00',1.07),('8784','2013-11-02','08:45:00',1.14),('8784','2013-11-02','08:50:00',1.18),('8784','2013-11-02','08:55:00',1.24),('8784','2013-11-02','09:00:00',1.36),('8784','2013-11-02','09:05:00',1.58),('8784','2013-11-02','09:10:00',1.54),('8784','2013-11-02','09:15:00',1.61),('8784','2013-11-02','09:20:00',1.55),('8784','2013-11-02','09:25:00',1.72),('8784','2013-11-02','09:30:00',1.83),('8784','2013-11-02','09:35:00',1.83),('8784','2013-11-02','09:40:00',1.98),('8784','2013-11-02','09:45:00',2.03),('8784','2013-11-02','09:50:00',2.28),('8784','2013-11-02','09:55:00',2.25),('8784','2013-11-02','10:00:00',2.21),('8784','2013-11-02','10:05:00',1.81),('8784','2013-11-02','10:10:00',1.34),('8784','2013-11-02','10:15:00',1.28),('8784','2013-11-02','11:00:00',1.3),('8784','2013-11-02','11:05:00',1.47),('8784','2013-11-02','11:10:00',1.26),('8784','2013-11-02','11:50:00',1.28),('8784','2013-11-02','11:55:00',2.07),('8784','2013-11-02','12:00:00',3.02),('8784','2013-11-02','12:05:00',3.05),('8784','2013-11-02','12:10:00',2.83),('8784','2013-11-02','12:15:00',2.67),('8784','2013-11-02','12:20:00',3.08),('8784','2013-11-02','12:25:00',3.04),('8784','2013-11-02','12:30:00',3.38),('8784','2013-11-02','12:35:00',2.86),('8784','2013-11-02','12:40:00',2.69),('8784','2013-11-02','12:45:00',2),('8784','2013-11-02','12:50:00',2.8),('8784','2013-11-02','12:55:00',2.93),('8784','2013-11-02','13:00:00',2.27),('8784','2013-11-02','13:05:00',2.98),('8784','2013-11-02','13:10:00',3.07),('8784','2013-11-02','13:15:00',1.45),('8784','2013-11-02','13:20:00',1.05),('8784','2013-11-02','13:25:00',1.08),('8784','2013-11-02','13:30:00',1.47),('8784','2013-11-02','13:35:00',2.52),('8784','2013-11-02','13:40:00',2.42),('8784','2013-11-02','13:45:00',2.73),('8784','2013-11-02','13:50:00',2.79),('8784','2013-11-02','13:55:00',2.65),('8784','2013-11-02','14:00:00',2.39),('8784','2013-11-02','14:05:00',2.07),('8784','2013-11-02','14:10:00',1.88),('8784','2013-11-02','14:15:00',1.81),('8784','2013-11-02','14:20:00',1.73),('8784','2013-11-02','14:25:00',1.67),('8784','2013-11-02','14:30:00',1.61),('8784','2013-11-02','14:35:00',1.56),('8784','2013-11-02','14:40:00',1.46),('8784','2013-11-02','14:45:00',1.42),('8784','2013-11-02','14:50:00',1.37),('8784','2013-11-02','14:55:00',1.22),('8784','2013-11-02','15:00:00',1.24),('8784','2013-11-02','15:10:00',1.13),('8784','2013-11-01','08:40:00',1.11),('8784','2013-11-01','08:45:00',1.14),('8784','2013-11-01','08:50:00',1.11),('8784','2013-11-01','08:55:00',1.12),('8784','2013-11-01','09:00:00',1.21),('8784','2013-11-01','09:05:00',1.44),('8784','2013-11-01','09:10:00',1.55),('8784','2013-11-01','09:15:00',1.62),('8784','2013-11-01','09:20:00',1.67),('8784','2013-11-01','09:25:00',1.71),('8784','2013-11-01','09:30:00',1.77),('8784','2013-11-01','09:35:00',1.86),('8784','2013-11-01','09:40:00',2),('8784','2013-11-01','09:45:00',2.01),('8784','2013-11-01','09:50:00',2.09),('8784','2013-11-01','09:55:00',2.15),('8784','2013-11-01','10:00:00',2.22),('8784','2013-11-01','10:05:00',2.27),('8784','2013-11-01','10:10:00',2.26),('8784','2013-11-01','10:15:00',2.32),('8784','2013-11-01','10:20:00',2.37),('8784','2013-11-01','10:25:00',2.42),('8784','2013-11-01','10:30:00',2.37),('8784','2013-11-01','10:35:00',2.41),('8784','2013-11-01','10:40:00',2.45),('8784','2013-11-01','10:45:00',2.43),('8784','2013-11-01','10:50:00',2.42),('8784','2013-11-01','10:55:00',2.43),('8784','2013-11-01','11:00:00',2.42),('8784','2013-11-01','11:05:00',2.22),('8784','2013-11-01','11:10:00',1.98),('8784','2013-11-01','11:15:00',2.24),('8784','2013-11-01','11:20:00',2.56),('8784','2013-11-01','11:25:00',2.71),('8784','2013-11-01','11:30:00',2.75),('8784','2013-11-01','11:35:00',2.65),('8784','2013-11-01','11:40:00',2.34),('8784','2013-11-01','11:45:00',2.5),('8784','2013-11-01','11:50:00',2.73),('8784','2013-11-01','11:55:00',2.78),('8784','2013-11-01','12:00:00',2.71),('8784','2013-11-01','12:05:00',2.62),('8784','2013-11-01','12:10:00',2.44),('8784','2013-11-01','12:15:00',2.24),('8784','2013-11-01','12:20:00',2.08),('8784','2013-11-01','12:25:00',2.13),('8784','2013-11-01','12:30:00',1.88),('8784','2013-11-01','13:15:00',1.17),('8784','2013-11-01','13:20:00',1.17),('8784','2013-11-01','13:25:00',1.04),('8784','2013-11-01','13:30:00',1.23),('8784','2013-11-01','13:35:00',1.23),('8784','2013-11-01','13:40:00',1.09),('8784','2013-10-31','08:40:00',1.22),('8784','2013-10-31','08:45:00',1.24),('8784','2013-10-31','08:50:00',1.33),('8784','2013-10-31','08:55:00',1.29),('8784','2013-10-31','09:00:00',1.29),('8784','2013-10-31','09:05:00',1.2),('8784','2013-10-31','09:20:00',1.41),('8784','2013-10-31','09:25:00',1.44),('8784','2013-10-31','09:30:00',1.47),('8784','2013-10-31','09:35:00',1.64),('8784','2013-10-31','09:40:00',1.6),('8784','2013-10-31','09:50:00',1.61),('8784','2013-10-31','09:55:00',1.67),('8784','2013-10-31','10:00:00',1.73),('8784','2013-10-31','10:05:00',1.71),('8784','2013-10-31','10:10:00',1.59),('8784','2013-10-31','10:15:00',1.44),('8784','2013-10-31','10:20:00',1.39),('8784','2013-10-31','10:25:00',1.52),('8784','2013-10-31','10:30:00',1.58),('8784','2013-10-31','10:35:00',1.77),('8784','2013-10-31','10:40:00',1.82),('8784','2013-10-31','10:45:00',1.67),('8784','2013-10-31','10:50:00',1.7),('8784','2013-10-31','10:55:00',1.87),('8784','2013-10-31','11:00:00',2.25),('8784','2013-10-31','11:05:00',2.56),('8784','2013-10-31','11:10:00',2.5),('8784','2013-10-31','11:15:00',2.54),('8784','2013-10-31','11:20:00',2.42),('8784','2013-10-31','11:25:00',2.14),('8784','2013-10-31','11:30:00',2.42),('8784','2013-10-31','11:35:00',2.31),('8784','2013-10-31','11:40:00',2.56),('8784','2013-10-31','11:45:00',2.65),('8784','2013-10-31','11:50:00',2.63),('8784','2013-10-31','11:55:00',2.62),('8784','2013-10-31','12:00:00',2.57),('8784','2013-10-31','12:05:00',2.49),('8784','2013-10-31','12:10:00',2.58),('8784','2013-10-31','12:15:00',2.54),('8784','2013-10-31','12:20:00',2.49),('8784','2013-10-31','12:25:00',2.47),('8784','2013-10-31','12:30:00',2.22),('8784','2013-10-31','12:35:00',2.31),('8784','2013-10-31','12:40:00',2.4),('8784','2013-10-31','12:45:00',2.46),('8784','2013-10-31','12:50:00',2.53),('8784','2013-10-31','12:55:00',2.56),('8784','2013-10-31','13:00:00',2.49),('8784','2013-10-31','13:05:00',2.4),('8784','2013-10-31','13:10:00',2.35),('8784','2013-10-31','13:15:00',2.3),('8784','2013-10-31','13:20:00',2.26),('8784','2013-10-31','13:25:00',2.19),('8784','2013-10-31','13:30:00',2.1),('8784','2013-10-31','13:35:00',2.07),('8784','2013-10-31','13:40:00',1.91),('8784','2013-10-31','13:45:00',1.75),('8784','2013-10-31','13:50:00',1.36),('8784','2013-10-31','13:55:00',1.37),('8784','2013-10-31','14:00:00',1.78),('8784','2013-10-31','14:05:00',1.8),('8784','2013-10-31','14:10:00',1.65),('8784','2013-10-31','14:15:00',1.16),('8784','2013-10-31','14:25:00',1.22),('8784','2013-10-30','08:50:00',1.2),('8784','2013-10-30','08:55:00',1.16),('8784','2013-10-30','09:00:00',1.31),('8784','2013-10-30','09:05:00',1.45),('8784','2013-10-30','09:10:00',1.56),('8784','2013-10-30','09:15:00',1.59),('8784','2013-10-30','09:20:00',1.67),('8784','2013-10-30','09:25:00',1.76),('8784','2013-10-30','09:30:00',1.79),('8784','2013-10-30','09:35:00',1.87),('8784','2013-10-30','09:40:00',1.94),('8784','2013-10-30','09:45:00',2.03),('8784','2013-10-30','09:50:00',2.03),('8784','2013-10-30','09:55:00',1.94),('8784','2013-10-30','10:00:00',1.78),('8784','2013-10-30','10:05:00',1.95),('8784','2013-10-30','10:10:00',2.2),('8784','2013-10-30','10:15:00',2.37),('8784','2013-10-30','10:20:00',2.31),('8784','2013-10-30','10:25:00',2.22),('8784','2013-10-30','10:30:00',2.3),('8784','2013-10-30','10:35:00',2.22),('8784','2013-10-30','10:40:00',2.41),('8784','2013-10-30','10:45:00',2.44),('8784','2013-10-30','10:50:00',1.26),('8784','2013-10-30','10:55:00',1.53),('8784','2013-10-30','11:00:00',2.51),('8784','2013-10-30','11:05:00',2.49),('8784','2013-10-30','11:10:00',2.56),('8784','2013-10-30','11:15:00',2.52),('8784','2013-10-30','11:20:00',1.97),('8784','2013-10-30','11:25:00',1.44),('8784','2013-10-30','11:30:00',1.1),('8784','2013-10-30','11:40:00',1.14),('8784','2013-10-30','11:45:00',1.56),('8784','2013-10-30','11:50:00',1.43),('8784','2013-10-30','12:00:00',1.05),('8784','2013-10-30','12:05:00',1.15),('8784','2013-10-30','12:10:00',1.17),('8784','2013-10-30','12:15:00',2.37),('8784','2013-10-30','12:20:00',2.17),('8784','2013-10-30','12:25:00',2.64),('8784','2013-10-30','12:30:00',2.34),('8784','2013-10-30','12:35:00',1.26),('8784','2013-10-30','12:40:00',1.22),('8784','2013-10-30','12:45:00',1.21),('8784','2013-10-30','12:50:00',1.26),('8784','2013-10-30','12:55:00',2.62),('8784','2013-10-30','13:00:00',1.85),('8784','2013-10-30','13:05:00',2.49),('8784','2013-10-30','13:10:00',2.53),('8784','2013-10-30','13:15:00',2.71),('8784','2013-10-30','13:20:00',2.63),('8784','2013-10-30','13:25:00',2.66),('8784','2013-10-30','13:30:00',1.47),('8784','2013-10-30','13:35:00',1.29),('8784','2013-10-30','13:40:00',2.27),('8784','2013-10-30','13:45:00',2.13),('8784','2013-10-30','13:50:00',1.23),('8784','2013-10-30','13:55:00',2.1),('8784','2013-10-30','14:00:00',2.27),('8784','2013-10-30','14:05:00',2.3),('8784','2013-10-30','14:10:00',1.11),('8784','2013-10-30','14:40:00',1.54),('8784','2013-10-30','14:45:00',1.33),('8784','2013-10-30','15:15:00',1.02),('8784','2013-10-30','15:20:00',1.02),('8784','2013-10-29','08:50:00',1.06),('8784','2013-10-29','08:55:00',1.35),('8784','2013-10-29','09:00:00',1.44),('8784','2013-10-29','09:05:00',1.54),('8784','2013-10-29','09:10:00',1.62),('8784','2013-10-29','09:15:00',1.69),('8784','2013-10-29','09:20:00',1.8),('8784','2013-10-29','09:25:00',1.83),('8784','2013-10-29','09:30:00',1.89),('8784','2013-10-29','09:35:00',2),('8784','2013-10-29','09:40:00',1.88),('8784','2013-10-29','09:45:00',2.11),('8784','2013-10-29','09:50:00',2.06),('8784','2013-10-29','09:55:00',2.14),('8784','2013-10-29','10:00:00',2.31),('8784','2013-10-29','10:05:00',1.59),('8784','2013-10-29','10:10:00',1.59),('8784','2013-10-29','10:15:00',1.05),('8784','2013-10-29','10:25:00',1.1),('8784','2013-10-29','10:30:00',1),('8784','2013-10-29','10:35:00',1.96),('8784','2013-10-29','10:40:00',2.55),('8784','2013-10-29','10:45:00',2.88),('8784','2013-10-29','10:50:00',2.82),('8784','2013-10-29','10:55:00',3.03),('8784','2013-10-29','11:00:00',2.95),('8784','2013-10-29','11:05:00',2.89),('8784','2013-10-29','11:10:00',2.95),('8784','2013-10-29','11:15:00',2.77),('8784','2013-10-29','11:20:00',2.73),('8784','2013-10-29','11:25:00',2.75),('8784','2013-10-29','11:30:00',2.76),('8784','2013-10-29','11:35:00',2.81),('8784','2013-10-29','11:40:00',2.72),('8784','2013-10-29','11:45:00',2.78),('8784','2013-10-29','11:50:00',2.75),('8784','2013-10-29','11:55:00',2.7),('8784','2013-10-29','12:00:00',2.6),('8784','2013-10-29','12:05:00',2.6),('8784','2013-10-29','12:10:00',2.61),('8784','2013-10-29','12:15:00',2.59),('8784','2013-10-29','12:20:00',2.56),('8784','2013-10-29','12:25:00',2.45),('8784','2013-10-29','12:30:00',2.28),('8784','2013-10-29','12:35:00',2.49),('8784','2013-10-29','12:40:00',2.45),('8784','2013-10-29','12:45:00',2.33),('8784','2013-10-29','12:50:00',2.16),('8784','2013-10-29','12:55:00',2.29),('8784','2013-10-29','13:00:00',2.27),('8784','2013-10-29','13:05:00',2.27),('8784','2013-10-29','13:10:00',2.32),('8784','2013-10-29','13:15:00',2.27),('8784','2013-10-29','13:20:00',2.26),('8784','2013-10-29','13:25:00',2.17),('8784','2013-10-29','13:30:00',2.18),('8784','2013-10-29','13:35:00',2.13),('8784','2013-10-29','13:40:00',1.99),('8784','2013-10-29','13:45:00',1.78),('8784','2013-10-29','13:50:00',1.74),('8784','2013-10-29','13:55:00',1.8),('8784','2013-10-29','14:00:00',1.55),('8784','2013-10-29','14:05:00',1.81),('8784','2013-10-29','14:10:00',1.75),('8784','2013-10-29','14:15:00',1.72),('8784','2013-10-29','14:20:00',1.69),('8784','2013-10-29','14:25:00',1.62),('8784','2013-10-29','14:30:00',1.57),('8784','2013-10-29','14:35:00',1.52),('8784','2013-10-29','14:40:00',1.44),('8784','2013-10-29','14:45:00',1.37),('8784','2013-10-29','14:50:00',1.32),('8784','2013-10-29','14:55:00',1.25),('8784','2013-10-29','15:00:00',1.18),('8784','2013-10-29','15:05:00',1.14),('8784','2013-10-29','15:10:00',1.1),('8784','2013-10-29','15:15:00',1.05),('8784','2014-04-17','08:00:00',1.25),('8784','2014-04-17','08:05:00',1.38),('8784','2014-04-17','08:10:00',1.48),('8784','2014-04-17','08:15:00',1.58),('8784','2014-04-17','08:20:00',1.62),('8784','2014-04-17','08:25:00',1.73),('8784','2014-04-17','08:30:00',1.8),('8784','2014-04-17','08:35:00',1.91),('8784','2014-04-17','08:40:00',2.02),('8784','2014-04-17','08:45:00',2.11),('8784','2014-04-17','08:50:00',2.23),('8784','2014-04-17','08:55:00',2.07),('8784','2014-04-17','09:00:00',1.96),('8784','2014-04-17','09:05:00',2.34),('8784','2014-04-17','09:10:00',2.55),('8784','2014-04-17','09:15:00',2.62),('8784','2014-04-17','09:20:00',2.75),('8784','2014-04-17','09:25:00',2.82),('8784','2014-04-17','09:30:00',2.9),('8784','2014-04-17','09:35:00',3),('8784','2014-04-17','09:40:00',3.08),('8784','2014-04-17','09:45:00',3.15),('8784','2014-04-17','09:50:00',3.2),('8784','2014-04-17','09:55:00',3.35),('8784','2014-04-17','10:00:00',3.49),('8784','2014-04-17','10:05:00',3.8),('8784','2014-04-17','10:10:00',3.65),('8784','2014-04-17','10:15:00',2.75),('8784','2014-04-17','10:20:00',3.87),('8784','2014-04-17','10:25:00',4.03),('8784','2014-04-17','10:30:00',4.28),('8784','2014-04-17','10:35:00',4.49),('8784','2014-04-17','10:40:00',4.09),('8784','2014-04-17','10:45:00',3.75),('8784','2014-04-17','10:50:00',2.77),('8784','2014-04-17','10:55:00',2.58),('8784','2014-04-17','11:00:00',2.91),('8784','2014-04-17','11:05:00',3.15),('8784','2014-04-17','11:10:00',3.32),('8784','2014-04-17','11:15:00',2.5),('8784','2014-04-17','11:20:00',3.26),('8784','2014-04-17','11:25:00',4.29),('8784','2014-04-17','11:30:00',2.67),('8784','2014-04-17','11:35:00',2.49),('8784','2014-04-17','11:40:00',2.62),('8784','2014-04-17','11:45:00',4.24),('8784','2014-04-17','11:50:00',3.29),('8784','2014-04-17','11:55:00',2.4),('8784','2014-04-17','12:00:00',3.06),('8784','2014-04-17','12:05:00',3.24),('8784','2014-04-17','12:10:00',2.83),('8784','2014-04-17','12:15:00',2.51),('8784','2014-04-17','12:20:00',2.55),('8784','2014-04-17','12:25:00',2.8),('8784','2014-04-17','12:30:00',3.63),('8784','2014-04-17','12:35:00',3.87),('8784','2014-04-17','12:40:00',4.56),('8784','2014-04-17','12:45:00',4.31),('8784','2014-04-17','12:50:00',1.8),('8784','2014-04-17','12:55:00',3.74),('8784','2014-04-17','13:00:00',4.79),('8784','2014-04-17','13:05:00',4.14),('8784','2014-04-17','13:10:00',4.4),('8784','2014-04-17','13:15:00',2.97),('8784','2014-04-17','13:20:00',1.52),('8784','2014-04-17','13:25:00',4.19),('8784','2014-04-17','13:30:00',5.4),('8784','2014-04-17','13:35:00',2.04),('8784','2014-04-17','13:40:00',1.01),('8784','2014-04-17','13:45:00',1.02),('8784','2014-04-17','13:50:00',1.38),('8784','2014-04-17','13:55:00',1.43),('8784','2014-04-17','14:00:00',1.14),('8784','2014-04-17','14:05:00',1.25),('8784','2014-04-17','14:10:00',2.74),('8784','2014-04-17','14:15:00',4.09),('8784','2014-04-17','14:20:00',1.55),('8784','2014-04-17','14:25:00',2.05),('8784','2014-04-17','14:30:00',2.23),('8784','2014-04-17','14:35:00',2.35),('8784','2014-04-17','14:40:00',4.09),('8784','2014-04-17','14:45:00',1.58),('8784','2014-04-17','15:25:00',1.3),('8784','2014-04-17','15:30:00',2.07),('8784','2014-04-17','15:35:00',2.75),('8784','2014-04-17','15:40:00',1.95),('8784','2014-04-17','15:45:00',1.44),('8784','2014-04-17','15:50:00',1.32),('8784','2014-04-17','15:55:00',1.47),('8784','2014-04-17','16:00:00',1.23),('8784','2014-04-17','16:05:00',1),('8784','2014-04-17','16:10:00',1.13),('8784','2014-04-17','16:15:00',1.15),('8784','2014-04-17','16:20:00',1.12),('8784','2014-04-17','16:25:00',1.26),('8784','2014-04-17','16:30:00',1.28),('8784','2014-04-17','16:35:00',1.16),('8784','2014-04-17','16:40:00',1.34),('8784','2014-04-17','16:45:00',1.79),('8784','2014-04-17','16:50:00',1.73),('8784','2014-04-17','16:55:00',1.3),('8784','2014-04-17','17:00:00',1.08),('8784','2014-04-17','17:15:00',1.04),('8784','2014-04-17','17:20:00',1.16),('8784','2014-04-17','17:25:00',1.02),('8784','2014-04-17','17:30:00',1.05),('8784','2014-04-17','17:35:00',1.09),('8784','2014-04-17','17:40:00',1.04),('8784','2013-10-28','09:00:00',1.17),('8784','2013-10-28','09:05:00',1.78),('8784','2013-10-28','09:10:00',1.89),('8784','2013-10-28','09:15:00',1.9),('8784','2013-10-28','09:20:00',1.72),('8784','2013-10-28','09:25:00',1.97),('8784','2013-10-28','09:30:00',2.01),('8784','2013-10-28','09:35:00',1.63),('8784','2013-10-28','09:40:00',2.22),('8784','2013-10-28','09:45:00',2.31),('8784','2013-10-28','09:50:00',2.13),('8784','2013-10-28','09:55:00',1.65),('8784','2013-10-28','10:50:00',2.69),('8784','2013-10-28','10:55:00',2.65),('8784','2013-10-28','11:00:00',2.65),('8784','2013-10-28','11:05:00',2.63),('8784','2013-10-28','11:10:00',2.64),('8784','2013-10-28','11:15:00',2.66),('8784','2013-10-28','11:20:00',2.7),('8784','2013-10-28','11:25:00',2.69),('8784','2013-10-28','11:30:00',2.7),('8784','2013-10-28','11:35:00',2.68),('8784','2013-10-28','11:40:00',2.71),('8784','2013-10-28','11:45:00',2.71),('8784','2013-10-28','11:50:00',2.73),('8784','2013-10-28','11:55:00',2.3),('8784','2013-10-28','12:00:00',2.08),('8784','2013-10-28','12:05:00',2.07),('8784','2013-10-28','12:10:00',2.8),('8784','2013-10-28','12:15:00',2.82),('8784','2013-10-28','12:20:00',2.49),('8784','2013-10-28','12:25:00',2.04),('8784','2013-10-28','12:30:00',2.79),('8784','2013-10-28','12:35:00',3.14),('8784','2013-10-28','12:40:00',2.81),('8784','2013-10-28','12:45:00',2.91),('8784','2013-10-28','12:50:00',2.85),('8784','2013-10-28','12:55:00',2.59),('8784','2013-10-28','13:00:00',2.51),('8784','2013-10-28','13:05:00',2.51),('8784','2013-10-28','13:10:00',2.45),('8784','2013-10-28','13:15:00',2.43),('8784','2013-10-28','13:20:00',2.32),('8784','2013-10-28','13:25:00',2.31),('8784','2013-10-28','13:30:00',2.26),('8784','2013-10-28','13:35:00',2.2),('8784','2013-10-28','13:40:00',2.2),('8784','2013-10-28','13:45:00',1.91),('8784','2013-10-28','13:50:00',2.03),('8784','2013-10-28','13:55:00',2.11),('8784','2013-10-28','14:00:00',2.14),('8784','2013-10-28','14:05:00',2.18),('8784','2013-10-28','14:10:00',2.08),('8784','2013-10-28','14:15:00',1.94),('8784','2013-10-28','14:20:00',1.96),('8784','2013-10-28','14:25:00',1.97),('8784','2013-10-28','14:30:00',1.02),('8784','2013-10-28','14:35:00',1.58),('8784','2013-10-28','14:45:00',1.64),('8784','2013-10-28','14:50:00',1.48),('8784','2013-10-28','14:55:00',1.43),('8784','2013-10-28','15:00:00',1.35),('8784','2013-10-28','15:05:00',1.28),('8784','2013-10-28','15:10:00',1.22),('8784','2013-10-28','15:40:00',1.01),('8784','2013-10-27','09:55:00',1.08),('8784','2013-10-27','10:00:00',1.13),('8784','2013-10-27','10:05:00',1.15),('8784','2013-10-27','10:10:00',1.21),('8784','2013-10-27','10:15:00',1.28),('8784','2013-10-27','10:20:00',1.36),('8784','2013-10-27','10:25:00',1.34),('8784','2013-10-27','10:30:00',1.32),('8784','2013-10-27','10:35:00',1.36),('8784','2013-10-27','10:40:00',1.38),('8784','2013-10-27','10:45:00',1.51),('8784','2013-10-27','10:50:00',1.52),('8784','2013-10-27','10:55:00',1.38),('8784','2013-10-27','11:00:00',1.23),('8784','2013-10-27','11:05:00',1.07),('8784','2013-10-27','11:30:00',1.16),('8784','2013-10-27','11:35:00',1.55),('8784','2013-10-27','11:40:00',2.29),('8784','2013-10-27','11:45:00',2.48),('8784','2013-10-27','11:50:00',1.35),('8784','2013-10-27','11:55:00',1.17),('8784','2013-10-27','12:00:00',1.28),('8784','2013-10-27','12:05:00',1.33),('8784','2013-10-27','12:10:00',1.2),('8784','2013-10-27','12:15:00',1.6),('8784','2013-10-27','12:20:00',2.5),('8784','2013-10-27','12:25:00',2.63),('8784','2013-10-27','12:30:00',2.32),('8784','2013-10-27','12:35:00',3.32),('8784','2013-10-27','12:40:00',1.93),('8784','2013-10-27','12:45:00',2.61),('8784','2013-10-27','12:50:00',2.95),('8784','2013-10-27','12:55:00',2.3),('8784','2013-10-27','13:00:00',1.42),('8784','2013-10-27','13:05:00',1.4),('8784','2013-10-27','13:10:00',1.71),('8784','2013-10-27','13:15:00',1.03),('8784','2013-10-27','13:25:00',1.85),('8784','2013-10-27','13:30:00',2.46),('8784','2013-10-27','13:35:00',2.1),('8784','2013-10-27','13:40:00',1.16),('8784','2013-10-27','14:00:00',1.17),('8784','2013-10-27','14:10:00',1.06),('8784','2013-10-27','14:15:00',1.25),('8784','2013-10-27','14:20:00',1.13),('8784','2013-10-27','14:25:00',1.09),('8784','2013-10-27','14:30:00',1.67),('8784','2013-10-27','14:35:00',1.51),('8784','2013-10-27','14:40:00',1.62),('8784','2013-10-27','14:45:00',1.16),('8784','2013-10-27','14:55:00',1.1),('8784','2013-10-27','15:00:00',1.33),('8784','2013-10-27','15:05:00',1.18),('8784','2013-10-27','15:10:00',1.22),('8784','2013-10-27','15:15:00',1.16),('8784','2013-10-27','15:20:00',1.1),('8784','2013-10-26','09:20:00',1.05),('8784','2013-10-26','09:25:00',1.14),('8784','2013-10-26','09:35:00',1.07),('8784','2013-10-26','09:40:00',1.16),('8784','2013-10-26','09:45:00',1.35),('8784','2013-10-26','09:50:00',1.36),('8784','2013-10-26','09:55:00',1.49),('8784','2013-10-26','10:00:00',1.6),('8784','2013-10-26','10:05:00',1.66),('8784','2013-10-26','10:10:00',1.74),('8784','2013-10-26','10:15:00',1.8),('8784','2013-10-26','10:20:00',1.86),('8784','2013-10-26','10:25:00',1.94),('8784','2013-10-26','10:30:00',1.99),('8784','2013-10-26','10:35:00',2.07),('8784','2013-10-26','10:40:00',2.13),('8784','2013-10-26','10:45:00',2.19),('8784','2013-10-26','10:50:00',2.25),('8784','2013-10-26','10:55:00',2.29),('8784','2013-10-26','11:00:00',2.32),('8784','2013-10-26','11:05:00',2.35),('8784','2013-10-26','11:10:00',2.37),('8784','2013-10-26','11:15:00',2.4),('8784','2013-10-26','11:20:00',2.46),('8784','2013-10-26','11:25:00',2.49),('8784','2013-10-26','11:30:00',2.5),('8784','2013-10-26','11:35:00',2.54),('8784','2013-10-26','11:40:00',2.57),('8784','2013-10-26','11:45:00',2.57),('8784','2013-10-26','11:50:00',2.6),('8784','2013-10-26','11:55:00',2.6),('8784','2013-10-26','12:00:00',2.62),('8784','2013-10-26','12:05:00',2.6),('8784','2013-10-26','12:10:00',2.62),('8784','2013-10-26','12:15:00',2.6),('8784','2013-10-26','12:20:00',2.67),('8784','2013-10-26','12:25:00',2.66),('8784','2013-10-26','12:30:00',2.58),('8784','2013-10-26','12:35:00',2.66),('8784','2013-10-26','12:40:00',2.69),('8784','2013-10-26','12:45:00',2.5),('8784','2013-10-26','12:50:00',2.58),('8784','2013-10-26','12:55:00',2.58),('8784','2013-10-26','13:00:00',2.61),('8784','2013-10-26','13:05:00',2.52),('8784','2013-10-26','13:10:00',2.17),('8784','2013-10-26','13:15:00',2.67),('8784','2013-10-26','13:20:00',2.49),('8784','2013-10-26','13:25:00',2.54),('8784','2013-10-26','13:30:00',2.57),('8784','2013-10-26','13:35:00',2.65),('8784','2013-10-26','13:40:00',2.58),('8784','2013-10-26','13:45:00',2.52),('8784','2013-10-26','13:50:00',2.47),('8784','2013-10-26','13:55:00',2.33),('8784','2013-10-26','14:00:00',2.19),('8784','2013-10-26','14:05:00',2.13),('8784','2013-10-26','14:10:00',2.18),('8784','2013-10-26','14:15:00',1.55),('8784','2013-10-26','14:20:00',1.51),('8784','2013-10-26','14:25:00',1.43),('8784','2013-10-26','14:30:00',1.78),('8784','2013-10-26','14:35:00',1.82),('8784','2013-10-26','14:40:00',1.85),('8784','2013-10-26','14:45:00',1.74),('8784','2013-10-26','14:50:00',1.32),('8784','2013-10-26','14:55:00',1.67),('8784','2013-10-26','15:00:00',1.83),('8784','2013-10-26','15:05:00',1.8),('8784','2013-10-26','15:10:00',1.84),('8784','2013-10-26','15:15:00',1.66),('8784','2013-10-26','15:20:00',1.58),('8784','2013-10-26','15:25:00',1.68),('8784','2013-10-26','15:30:00',1.64),('8784','2013-10-26','15:35:00',1.74),('8784','2013-10-26','15:40:00',1.59),('8784','2013-10-26','15:45:00',1.51),('8784','2013-10-26','15:50:00',1.4),('8784','2013-10-26','15:55:00',1.28),('8784','2013-10-26','16:00:00',1.22),('8784','2013-10-26','16:05:00',1.18),('8784','2013-10-26','16:10:00',1.15),('8784','2013-10-26','16:15:00',1.05),('8784','2013-10-26','16:20:00',1.01),('8784','2013-10-25','09:15:00',1.02),('8784','2013-10-25','09:20:00',1.1),('8784','2013-10-25','09:25:00',1.16),('8784','2013-10-25','09:30:00',1.01),('8784','2013-10-25','09:35:00',1.26),('8784','2013-10-25','09:40:00',1.31),('8784','2013-10-25','09:45:00',1.37),('8784','2013-10-25','09:50:00',1.51),('8784','2013-10-25','09:55:00',1.56),('8784','2013-10-25','10:00:00',1.64),('8784','2013-10-25','10:05:00',1.71),('8784','2013-10-25','10:10:00',1.72),('8784','2013-10-25','10:15:00',1.88),('8784','2013-10-25','10:20:00',1.93),('8784','2013-10-25','10:25:00',1.99),('8784','2013-10-25','10:30:00',2.06),('8784','2013-10-25','10:35:00',2.14),('8784','2013-10-25','10:40:00',2.17),('8784','2013-10-25','10:45:00',2.19),('8784','2013-10-25','10:50:00',2.24),('8784','2013-10-25','10:55:00',2.3),('8784','2013-10-25','11:00:00',2.33),('8784','2013-10-25','11:05:00',2.38),('8784','2013-10-25','11:10:00',2.46),('8784','2013-10-25','11:15:00',2.44),('8784','2013-10-25','11:20:00',2.43),('8784','2013-10-25','11:25:00',2.45),('8784','2013-10-25','11:30:00',2.52),('8784','2013-10-25','11:35:00',2.57),('8784','2013-10-25','11:40:00',2.63),('8784','2013-10-25','11:45:00',2.68),('8784','2013-10-25','11:50:00',2.7),('8784','2013-10-25','11:55:00',2.71),('8784','2013-10-25','12:00:00',2.73),('8784','2013-10-25','12:05:00',2.74),('8784','2013-10-25','12:10:00',2.76),('8784','2013-10-25','12:15:00',2.78),('8784','2013-10-25','12:20:00',2.79),('8784','2013-10-25','12:25:00',2.79),('8784','2013-10-25','12:30:00',2.78),('8784','2013-10-25','12:35:00',2.81),('8784','2013-10-25','12:40:00',2.8),('8784','2013-10-25','12:45:00',2.81),('8784','2013-10-25','12:50:00',2.8),('8784','2013-10-25','12:55:00',2.8),('8784','2013-10-25','13:00:00',2.75),('8784','2013-10-25','13:05:00',2.75),('8784','2013-10-25','13:10:00',2.68),('8784','2013-10-25','13:15:00',2.72),('8784','2013-10-25','13:20:00',2.7),('8784','2013-10-25','13:25:00',2.67),('8784','2013-10-25','13:30:00',2.62),('8784','2013-10-25','13:35:00',2.61),('8784','2013-10-25','13:40:00',2.52),('8784','2013-10-25','13:45:00',2.58),('8784','2013-10-25','13:50:00',2.56),('8784','2013-10-25','13:55:00',2.49),('8784','2013-10-25','14:00:00',2.48),('8784','2013-10-25','14:05:00',2.44),('8784','2013-10-25','14:10:00',2.37),('8784','2013-10-25','14:15:00',2.38),('8784','2013-10-25','14:20:00',2.38),('8784','2013-10-25','14:25:00',2.34),('8784','2013-10-25','14:30:00',2.32),('8784','2013-10-25','14:35:00',2.25),('8784','2013-10-25','14:40:00',2.17),('8784','2013-10-25','14:45:00',2.11),('8784','2013-10-25','14:50:00',2.03),('8784','2013-10-25','14:55:00',1.99),('8784','2013-10-25','15:00:00',1.93),('8784','2013-10-25','15:05:00',1.92),('8784','2013-10-25','15:10:00',1.88),('8784','2013-10-25','15:15:00',1.83),('8784','2013-10-25','15:20:00',1.79),('8784','2013-10-25','15:25:00',1.71),('8784','2013-10-25','15:30:00',1.63),('8784','2013-10-25','15:35:00',1.57),('8784','2013-10-25','15:40:00',1.57),('8784','2013-10-25','15:45:00',1.5),('8784','2013-10-25','15:50:00',1.42),('8784','2013-10-25','15:55:00',1.38),('8784','2013-10-25','16:00:00',1.31),('8784','2013-10-25','16:05:00',1.27),('8784','2013-10-25','16:10:00',1.19),('8784','2013-10-25','16:15:00',1.15),('8784','2013-10-25','16:20:00',1.11),('8784','2013-10-25','16:25:00',1.04),('8784','2013-10-24','09:05:00',1.08),('8784','2013-10-24','09:15:00',1.14),('8784','2013-10-24','09:20:00',1.01),('8784','2013-10-24','09:35:00',1.07),('8784','2013-10-24','09:40:00',1.14),('8784','2013-10-24','09:45:00',1.17),('8784','2013-10-24','09:50:00',1.19),('8784','2013-10-24','09:55:00',1.13),('8784','2013-10-24','10:00:00',1.11),('8784','2013-10-24','10:05:00',1.07),('8784','2013-10-24','10:20:00',1.48),('8784','2013-10-24','10:35:00',1.66),('8784','2013-10-24','10:40:00',1.12),('8784','2013-10-24','10:45:00',2.07),('8784','2013-10-24','10:50:00',1.63),('8784','2013-10-24','10:55:00',1.99),('8784','2013-10-24','11:00:00',2.87),('8784','2013-10-24','11:05:00',3.29),('8784','2013-10-24','11:10:00',2.19),('8784','2013-10-24','11:15:00',1.89),('8784','2013-10-24','11:20:00',1.77),('8784','2013-10-24','11:25:00',1.54),('8784','2013-10-24','11:30:00',1.21),('8784','2013-10-24','11:35:00',1.2),('8784','2013-10-24','11:40:00',1.14),('8784','2013-10-24','11:45:00',1.25),('8784','2013-10-24','11:50:00',1.88),('8784','2013-10-24','11:55:00',2.66),('8784','2013-10-24','12:00:00',1.74),('8784','2013-10-24','12:05:00',1.46),('8784','2013-10-24','12:10:00',1.36),('8784','2013-10-24','12:15:00',1.36),('8784','2013-10-24','12:20:00',1.43),('8784','2013-10-24','12:25:00',1.54),('8784','2013-10-24','12:30:00',1.6),('8784','2013-10-24','12:35:00',1.75),('8784','2013-10-24','12:40:00',2),('8784','2013-10-24','12:45:00',2.34),('8784','2013-10-24','12:50:00',1.97),('8784','2013-10-24','12:55:00',2.9),('8784','2013-10-24','13:00:00',3.06),('8784','2013-10-24','13:05:00',3.17),('8784','2013-10-24','13:10:00',2.58),('8784','2013-10-24','13:15:00',2.27),('8784','2013-10-24','13:20:00',2.27),('8784','2013-10-24','13:25:00',1.84),('8784','2013-10-24','13:30:00',1.38),('8784','2013-10-24','13:35:00',1.33),('8784','2013-10-24','13:40:00',1.33),('8784','2013-10-24','13:45:00',1.43),('8784','2013-10-24','13:50:00',1.91),('8784','2013-10-24','13:55:00',2.15),('8784','2013-10-24','14:00:00',2.23),('8784','2013-10-24','14:05:00',1.56),('8784','2013-10-24','14:10:00',1.42),('8784','2013-10-24','14:15:00',1.37),('8784','2013-10-24','14:20:00',1.49),('8784','2013-10-24','14:25:00',1.51),('8784','2013-10-24','14:30:00',1.56),('8784','2013-10-24','14:35:00',1.78),('8784','2013-10-24','14:40:00',1.92),('8784','2013-10-24','14:45:00',2.08),('8784','2013-10-24','14:50:00',1.51),('8784','2013-10-24','15:05:00',1.23),('8784','2013-10-24','15:10:00',1.78),('8784','2013-10-24','15:15:00',1.14),('8784','2013-10-24','15:20:00',1.26),('8784','2013-10-24','15:25:00',1.03),('8784','2013-10-24','15:30:00',1.28),('8784','2013-10-24','15:35:00',1.99),('8784','2013-10-24','15:40:00',1.86),('8784','2013-10-24','15:45:00',1.75),('8784','2013-10-24','15:50:00',1.09),('8784','2013-10-23','10:20:00',1.15),('8784','2013-10-23','10:25:00',1.19),('8784','2013-10-23','10:30:00',1.21),('8784','2013-10-23','10:35:00',1.31),('8784','2013-10-23','10:40:00',1.16),('8784','2013-10-23','10:45:00',1.16),('8784','2013-10-23','10:50:00',1.37),('8784','2013-10-23','10:55:00',1.31),('8784','2013-10-23','11:00:00',1.45),('8784','2013-10-23','11:05:00',1.64),('8784','2013-10-23','11:10:00',1.82),('8784','2013-10-23','11:15:00',1.79),('8784','2013-10-23','11:20:00',2.54),('8784','2013-10-23','11:25:00',2.52),('8784','2013-10-23','11:30:00',2.64),('8784','2013-10-23','11:35:00',2.6),('8784','2013-10-23','11:40:00',2.57),('8784','2013-10-23','11:45:00',2.63),('8784','2013-10-23','11:50:00',2.7),('8784','2013-10-23','11:55:00',2.65),('8784','2013-10-23','12:00:00',2.58),('8784','2013-10-23','12:05:00',2.56),('8784','2013-10-23','12:10:00',2.47),('8784','2013-10-23','12:15:00',2.34),('8784','2013-10-23','12:20:00',2.59),('8784','2013-10-23','12:25:00',2.65),('8784','2013-10-23','12:30:00',2.66),('8784','2013-10-23','12:35:00',2.7),('8784','2013-10-23','12:40:00',2.63),('8784','2013-10-23','12:45:00',2.58),('8784','2013-10-23','12:50:00',1.87),('8784','2013-10-23','12:55:00',2.02),('8784','2013-10-23','13:00:00',2.38),('8784','2013-10-23','13:05:00',2.64),('8784','2013-10-23','13:10:00',2.55),('8784','2013-10-23','13:15:00',2.41),('8784','2013-10-23','13:20:00',2.54),('8784','2013-10-23','13:25:00',2.58),('8784','2013-10-23','13:30:00',2.46),('8784','2013-10-23','13:35:00',2.43),('8784','2013-10-23','13:40:00',2.38),('8784','2013-10-23','13:45:00',2.35),('8784','2013-10-23','13:50:00',2.13),('8784','2013-10-23','13:55:00',2.19),('8784','2013-10-23','14:00:00',2.09),('8784','2013-10-23','14:05:00',2.33),('8784','2013-10-23','14:10:00',2.17),('8784','2013-10-23','14:15:00',2.26),('8784','2013-10-23','14:20:00',2.13),('8784','2013-10-23','14:25:00',2.04),('8784','2013-10-23','14:30:00',2.08),('8784','2013-10-23','14:35:00',2.03),('8784','2013-10-23','14:40:00',2.17),('8784','2013-10-23','14:45:00',2.08),('8784','2013-10-23','14:50:00',1.86),('8784','2013-10-23','14:55:00',1.96),('8784','2013-10-23','15:00:00',2.03),('8784','2013-10-23','15:05:00',2),('8784','2013-10-23','15:10:00',1.85),('8784','2013-10-23','15:15:00',1.74),('8784','2013-10-23','15:20:00',1.65),('8784','2013-10-23','15:25:00',1.81),('8784','2013-10-23','15:30:00',1.64),('8784','2013-10-23','15:35:00',1.52),('8784','2013-10-23','15:40:00',1.69),('8784','2013-10-23','15:45:00',1.68),('8784','2013-10-23','15:50:00',1.51),('8784','2013-10-23','15:55:00',1.2),('8784','2013-10-22','09:15:00',1.05),('8784','2013-10-22','09:20:00',1.11),('8784','2013-10-22','09:25:00',1.15),('8784','2013-10-22','09:30:00',1.21),('8784','2013-10-22','09:35:00',1.37),('8784','2013-10-22','09:40:00',1.43),('8784','2013-10-22','09:45:00',1.48),('8784','2013-10-22','09:50:00',1.57),('8784','2013-10-22','09:55:00',1.64),('8784','2013-10-22','10:00:00',1.72),('8784','2013-10-22','10:05:00',1.77),('8784','2013-10-22','10:10:00',1.83),('8784','2013-10-22','10:15:00',1.87),('8784','2013-10-22','10:20:00',1.94),('8784','2013-10-22','10:25:00',1.97),('8784','2013-10-22','10:30:00',1.99),('8784','2013-10-22','10:35:00',2.13),('8784','2013-10-22','10:40:00',2.13),('8784','2013-10-22','10:45:00',2.22),('8784','2013-10-22','10:50:00',2.26),('8784','2013-10-22','10:55:00',2.32),('8784','2013-10-22','11:00:00',2.35),('8784','2013-10-22','11:05:00',2.39),('8784','2013-10-22','11:10:00',2.41),('8784','2013-10-22','11:15:00',2.42),('8784','2013-10-22','11:20:00',2.42),('8784','2013-10-22','11:25:00',2.46),('8784','2013-10-22','11:30:00',2.49),('8784','2013-10-22','11:35:00',2.49),('8784','2013-10-22','11:40:00',2.54),('8784','2013-10-22','11:45:00',2.53),('8784','2013-10-22','11:50:00',2.57),('8784','2013-10-22','11:55:00',2.55),('8784','2013-10-22','12:00:00',2.61),('8784','2013-10-22','12:05:00',2.62),('8784','2013-10-22','12:10:00',2.64),('8784','2013-10-22','12:15:00',2.68),('8784','2013-10-22','12:20:00',2.64),('8784','2013-10-22','12:25:00',2.66),('8784','2013-10-22','12:30:00',2.7),('8784','2013-10-22','12:35:00',2.73),('8784','2013-10-22','12:40:00',2.7),('8784','2013-10-22','12:45:00',2.68),('8784','2013-10-22','12:50:00',2.7),('8784','2013-10-22','12:55:00',2.68),('8784','2013-10-22','13:00:00',2.61),('8784','2013-10-22','13:05:00',2.62),('8784','2013-10-22','13:10:00',2.62),('8784','2013-10-22','13:15:00',2.63),('8784','2013-10-22','13:20:00',2.6),('8784','2013-10-22','13:25:00',2.66),('8784','2013-10-22','13:30:00',2.55),('8784','2013-10-22','13:35:00',2.52),('8784','2013-10-22','13:40:00',2.39),('8784','2013-10-22','13:45:00',2.36),('8784','2013-10-22','13:50:00',2.41),('8784','2013-10-22','13:55:00',2.39),('8784','2013-10-22','14:00:00',2.17),('8784','2013-10-22','14:05:00',2.07),('8784','2013-10-22','14:10:00',2.49),('8784','2013-10-22','14:15:00',2.52),('8784','2013-10-22','14:20:00',2.59),('8784','2013-10-22','14:25:00',2.65),('8784','2013-10-22','14:30:00',2.49),('8784','2013-10-22','14:35:00',2.35),('8784','2013-10-22','14:40:00',2.13),('8784','2013-10-22','14:45:00',2.21),('8784','2013-10-22','14:50:00',1.98),('8784','2013-10-22','14:55:00',1.94),('8784','2013-10-22','15:00:00',1.97),('8784','2013-10-22','15:05:00',1.93),('8784','2013-10-22','15:10:00',1.86),('8784','2013-10-22','15:15:00',1.82),('8784','2013-10-22','15:20:00',1.72),('8784','2013-10-22','15:25:00',1.61),('8784','2013-10-22','15:30:00',1.68),('8784','2013-10-22','15:35:00',1.75),('8784','2013-10-22','15:40:00',1.74),('8784','2013-10-22','15:45:00',1.22),('8784','2013-10-22','15:50:00',1.43),('8784','2013-10-22','15:55:00',1.32),('8784','2013-10-22','16:00:00',1.3),('8784','2013-10-22','16:05:00',1.21),('8784','2013-10-22','16:10:00',1.19),('8784','2013-10-22','16:15:00',1.15),('8784','2013-10-22','16:20:00',1.06),('8784','2013-10-22','16:25:00',1.02),('8784','2013-10-21','09:15:00',1.1),('8784','2013-10-21','09:20:00',1.34),('8784','2013-10-21','09:25:00',1.37),('8784','2013-10-21','09:30:00',1.19),('8784','2013-10-21','09:35:00',1.24),('8784','2013-10-21','09:40:00',1.44),('8784','2013-10-21','09:45:00',1.31),('8784','2013-10-21','09:50:00',1.45),('8784','2013-10-21','09:55:00',1.64),('8784','2013-10-21','10:00:00',1.55),('8784','2013-10-21','10:05:00',1.85),('8784','2013-10-21','10:10:00',1.92),('8784','2013-10-21','10:15:00',2),('8784','2013-10-21','10:20:00',1.98),('8784','2013-10-21','10:25:00',2.15),('8784','2013-10-21','10:30:00',2.1),('8784','2013-10-21','10:35:00',2.15),('8784','2013-10-21','10:40:00',2.09),('8784','2013-10-21','10:45:00',2.12),('8784','2013-10-21','10:50:00',2.3),('8784','2013-10-21','10:55:00',2.27),('8784','2013-10-21','11:00:00',2.48),('8784','2013-10-21','11:05:00',2.18),('8784','2013-10-21','11:10:00',2.27),('8784','2013-10-21','11:15:00',2.58),('8784','2013-10-21','11:20:00',2.56),('8784','2013-10-21','11:25:00',2.52),('8784','2013-10-21','11:30:00',2.63),('8784','2013-10-21','11:35:00',2.59),('8784','2013-10-21','11:40:00',2.57),('8784','2013-10-21','11:45:00',2.67),('8784','2013-10-21','11:50:00',2.7),('8784','2013-10-21','11:55:00',2.75),('8784','2013-10-21','12:00:00',2.77),('8784','2013-10-21','12:05:00',2.85),('8784','2013-10-21','12:10:00',2.88),('8784','2013-10-21','12:15:00',2.85),('8784','2013-10-21','12:20:00',2.83),('8784','2013-10-21','12:25:00',2.82),('8784','2013-10-21','12:30:00',2.72),('8784','2013-10-21','12:35:00',2.86),('8784','2013-10-21','12:40:00',2.89),('8784','2013-10-21','12:45:00',2.87),('8784','2013-10-21','12:50:00',2.87),('8784','2013-10-21','12:55:00',2.85),('8784','2013-10-21','13:00:00',2.81),('8784','2013-10-21','13:05:00',2.76),('8784','2013-10-21','13:10:00',2.7),('8784','2013-10-21','13:15:00',2.75),('8784','2013-10-21','13:20:00',2.71),('8784','2013-10-21','13:25:00',2.78),('8784','2013-10-21','13:30:00',2.8),('8784','2013-10-21','13:35:00',2.77),('8784','2013-10-21','13:40:00',2.72),('8784','2013-10-21','13:45:00',2.68),('8784','2013-10-21','13:50:00',2.56),('8784','2013-10-21','13:55:00',2.52),('8784','2013-10-21','14:00:00',2.52),('8784','2013-10-21','14:05:00',2.55),('8784','2013-10-21','14:10:00',2.5),('8784','2013-10-21','14:15:00',2.47),('8784','2013-10-21','14:20:00',2.44),('8784','2013-10-21','14:25:00',2.34),('8784','2013-10-21','14:30:00',2.34),('8784','2013-10-21','14:35:00',2.27),('8784','2013-10-21','14:40:00',2.13),('8784','2013-10-21','14:45:00',2.1),('8784','2013-10-21','14:50:00',1.92),('8784','2013-10-21','14:55:00',1.66),('8784','2013-10-21','15:00:00',1.76),('8784','2013-10-21','15:05:00',1.99),('8784','2013-10-21','15:10:00',1.94),('8784','2013-10-21','15:15:00',1.91),('8784','2013-10-21','15:20:00',1.85),('8784','2013-10-21','15:25:00',1.73),('8784','2013-10-21','15:30:00',1.56),('8784','2013-10-21','15:35:00',1.65),('8784','2013-10-21','15:40:00',1.63),('8784','2013-10-21','15:45:00',1.57),('8784','2013-10-21','15:50:00',1.51),('8784','2013-10-21','15:55:00',1.48),('8784','2013-10-21','16:00:00',1.43),('8784','2013-10-21','16:05:00',1.36),('8784','2013-10-21','16:10:00',1.32),('8784','2013-10-21','16:15:00',1.25),('8784','2013-10-21','16:20:00',1.17),('8784','2013-10-21','16:25:00',1.1),('8784','2013-10-21','16:30:00',1.04),('8784','2013-10-20','09:05:00',1.06),('8784','2013-10-20','09:10:00',1.15),('8784','2013-10-20','09:15:00',1.2),('8784','2013-10-20','09:20:00',1.32),('8784','2013-10-20','09:25:00',1.06),('8784','2013-10-20','09:30:00',1.19),('8784','2013-10-20','09:35:00',1.31),('8784','2013-10-20','09:40:00',1.61),('8784','2013-10-20','09:45:00',1.66),('8784','2013-10-20','09:50:00',1.72),('8784','2013-10-20','09:55:00',1.78),('8784','2013-10-20','10:00:00',1.89),('8784','2013-10-20','10:05:00',1.92),('8784','2013-10-20','10:10:00',2.01),('8784','2013-10-20','10:15:00',2.07),('8784','2013-10-20','10:20:00',2.13),('8784','2013-10-20','10:25:00',2.18),('8784','2013-10-20','10:30:00',2.23),('8784','2013-10-20','10:35:00',2.28),('8784','2013-10-20','10:40:00',2.31),('8784','2013-10-20','10:45:00',2.37),('8784','2013-10-20','10:50:00',2.38),('8784','2013-10-20','10:55:00',2.48),('8784','2013-10-20','11:00:00',2.52),('8784','2013-10-20','11:05:00',2.56),('8784','2013-10-20','11:10:00',2.58),('8784','2013-10-20','11:15:00',2.6),('8784','2013-10-20','11:20:00',2.64),('8784','2013-10-20','11:25:00',2.69),('8784','2013-10-20','11:30:00',2.75),('8784','2013-10-20','11:35:00',2.78),('8784','2013-10-20','11:40:00',2.79),('8784','2013-10-20','11:45:00',2.79),('8784','2013-10-20','11:50:00',2.82),('8784','2013-10-20','11:55:00',2.83),('8784','2013-10-20','12:00:00',2.81),('8784','2013-10-20','12:05:00',2.89),('8784','2013-10-20','12:10:00',2.91),('8784','2013-10-20','12:15:00',2.81),('8784','2013-10-20','12:20:00',2.17),('8784','2013-10-20','12:25:00',1.96),('8784','2013-10-20','12:30:00',3.23),('8784','2013-10-20','12:35:00',2.37),('8784','2013-10-20','12:40:00',1.19),('8784','2013-10-20','12:45:00',2.86),('8784','2013-10-20','12:50:00',2.5),('8784','2013-10-20','12:55:00',1.71),('8784','2013-10-20','13:00:00',2.69),('8784','2013-10-20','13:05:00',1.24),('8784','2013-10-20','13:10:00',1.66),('8784','2013-10-20','13:15:00',1.1),('8784','2013-10-20','13:20:00',1.68),('8784','2013-10-20','13:25:00',1.95),('8784','2013-10-20','13:30:00',1.16),('8784','2013-10-20','13:35:00',1.09),('8784','2013-10-20','13:40:00',1.87),('8784','2013-10-20','13:45:00',1.8),('8784','2013-10-20','13:50:00',1.14),('8784','2013-10-20','13:55:00',1.39),('8784','2013-10-20','14:00:00',1),('8784','2013-10-20','14:10:00',1.06),('8784','2013-10-20','16:35:00',1.04),('8784','2013-10-20','16:50:00',1.22),('8784','2013-10-20','16:55:00',1.2),('8784','2013-10-20','17:00:00',1.1),('8784','2013-10-19','08:50:00',1.08),('8784','2013-10-19','09:05:00',1.03),('8784','2013-10-19','09:15:00',1.58),('8784','2013-10-19','09:20:00',1.64),('8784','2013-10-19','09:25:00',1.7),('8784','2013-10-19','09:30:00',1.75),('8784','2013-10-19','09:35:00',1.8),('8784','2013-10-19','09:40:00',1.91),('8784','2013-10-19','09:45:00',1.99),('8784','2013-10-19','09:50:00',2.06),('8784','2013-10-19','09:55:00',2.17),('8784','2013-10-19','10:00:00',2.11),('8784','2013-10-19','10:05:00',2.12),('8784','2013-10-19','10:10:00',2.26),('8784','2013-10-19','10:15:00',2.18),('8784','2013-10-19','10:20:00',2.27),('8784','2013-10-19','10:25:00',2.53),('8784','2013-10-19','10:30:00',2.58),('8784','2013-10-19','10:35:00',2.57),('8784','2013-10-19','10:40:00',2.55),('8784','2013-10-19','10:45:00',2.57),('8784','2013-10-19','10:50:00',2.6),('8784','2013-10-19','10:55:00',2.68),('8784','2013-10-19','11:00:00',2.57),('8784','2013-10-19','11:05:00',2.61),('8784','2013-10-19','11:10:00',1.11),('8784','2013-10-19','11:15:00',1.2),('8784','2013-10-19','11:20:00',2.59),('8784','2013-10-19','11:25:00',3.05),('8784','2013-10-19','11:30:00',3.1),('8784','2013-10-19','11:35:00',3.03),('8784','2013-10-19','11:40:00',2.94),('8784','2013-10-19','11:45:00',3.12),('8784','2013-10-19','11:50:00',2.81),('8784','2013-10-19','11:55:00',3.12),('8784','2013-10-19','12:00:00',3.18),('8784','2013-10-19','12:05:00',3.19),('8784','2013-10-19','12:10:00',3.13),('8784','2013-10-19','12:15:00',3.15),('8784','2013-10-19','12:20:00',3.1),('8784','2013-10-19','12:25:00',2.93),('8784','2013-10-19','12:30:00',3.15),('8784','2013-10-19','12:35:00',3.25),('8784','2013-10-19','12:40:00',3.35),('8784','2013-10-19','12:45:00',3.41),('8784','2013-10-19','12:50:00',3.43),('8784','2013-10-19','12:55:00',3.54),('8784','2013-10-19','13:00:00',3.74),('8784','2013-10-19','13:05:00',3.01),('8784','2013-10-19','13:10:00',3.27),('8784','2013-10-19','13:15:00',3.08),('8784','2013-10-19','13:20:00',3.11),('8784','2013-10-19','13:25:00',3.17),('8784','2013-10-19','13:30:00',3.44),('8784','2013-10-19','13:35:00',2.48),('8784','2013-10-19','13:40:00',2.19),('8784','2013-10-19','13:45:00',2.07),('8784','2013-10-19','13:50:00',2.7),('8784','2013-10-19','13:55:00',3.29),('8784','2013-10-19','14:00:00',2.66),('8784','2013-10-19','14:05:00',2.26),('8784','2013-10-19','14:10:00',1.69),('8784','2013-10-19','14:15:00',2.33),('8784','2013-10-19','14:20:00',1.86),('8784','2013-10-19','14:25:00',1.63),('8784','2013-10-19','14:30:00',2.23),('8784','2013-10-19','14:35:00',2.77),('8784','2013-10-19','14:40:00',2.36),('8784','2013-10-19','14:45:00',1.94),('8784','2013-10-19','14:50:00',2.65),('8784','2013-10-19','14:55:00',2.48),('8784','2013-10-19','15:00:00',2.46),('8784','2013-10-19','15:05:00',2.4),('8784','2013-10-19','15:10:00',2.33),('8784','2013-10-19','15:15:00',2.28),('8784','2013-10-19','15:20:00',2.11),('8784','2013-10-19','15:25:00',2.02),('8784','2013-10-19','15:30:00',1.9),('8784','2013-10-19','15:35:00',1.83),('8784','2013-10-19','15:40:00',1.69),('8784','2013-10-19','15:45:00',1.51),('8784','2013-10-19','15:50:00',1.67),('8784','2013-10-19','15:55:00',1.77),('8784','2013-10-19','16:00:00',1.43),('8784','2013-10-19','16:05:00',1.55),('8784','2013-10-19','16:10:00',1.47),('8784','2013-10-19','16:15:00',1.57),('8784','2013-10-19','16:20:00',1.38),('8784','2013-10-19','16:25:00',1.08),('8784','2013-10-19','16:30:00',1.35),('8784','2013-10-19','16:35:00',1.31),('8784','2013-10-19','16:40:00',1.26),('8784','2013-10-19','16:45:00',1.19),('8784','2013-10-19','16:50:00',1.08),('8784','2014-05-04','07:45:00',1.42),('8784','2014-05-04','07:50:00',1.48),('8784','2014-05-04','07:55:00',1.55),('8784','2014-05-04','08:00:00',1.63),('8784','2014-05-04','08:05:00',1.74),('8784','2014-05-04','08:10:00',1.79),('8784','2014-05-04','08:15:00',1.91),('8784','2014-05-04','08:20:00',2.05),('8784','2014-05-04','08:25:00',2.18),('8784','2014-05-04','08:30:00',2.22),('8784','2014-05-04','08:35:00',2.62),('8784','2014-05-04','08:40:00',1.74),('8784','2014-05-04','08:45:00',1.31),('8784','2014-05-04','08:50:00',1.71),('8784','2014-05-04','08:55:00',1.33),('8784','2014-05-04','09:00:00',1.47),('8784','2014-05-04','09:05:00',2.27),('8784','2014-05-04','09:10:00',2.4),('8784','2014-05-04','09:15:00',2.09),('8784','2014-05-04','09:20:00',3.66),('8784','2014-05-04','09:25:00',3.62),('8784','2014-05-04','09:30:00',2.01),('8784','2014-05-04','09:35:00',1.31),('8784','2014-05-04','09:40:00',1.49),('8784','2014-05-04','09:45:00',2.16),('8784','2014-05-04','09:50:00',2.12),('8784','2014-05-04','09:55:00',2.17),('8784','2014-05-04','10:00:00',3.95),('8784','2014-05-04','10:05:00',3.83),('8784','2014-05-04','10:10:00',3.83),('8784','2014-05-04','10:15:00',2.75),('8784','2014-05-04','10:20:00',2.12),('8784','2014-05-04','10:25:00',2.1),('8784','2014-05-04','10:30:00',2.21),('8784','2014-05-04','10:35:00',2.35),('8784','2014-05-04','10:40:00',2.35),('8784','2014-05-04','10:45:00',2.92),('8784','2014-05-04','10:50:00',3.28),('8784','2014-05-04','10:55:00',2.61),('8784','2014-05-04','11:00:00',2.49),('8784','2014-05-04','11:05:00',3.05),('8784','2014-05-04','11:10:00',4.58),('8784','2014-05-04','11:15:00',3.86),('8784','2014-05-04','11:20:00',4.74),('8784','2014-05-04','11:25:00',4.62),('8784','2014-05-04','11:30:00',3.9),('8784','2014-05-04','11:35:00',3.61),('8784','2014-05-04','11:40:00',3.26),('8784','2014-05-04','11:45:00',4.22),('8784','2014-05-04','11:50:00',3.64),('8784','2014-05-04','11:55:00',4.12),('8784','2014-05-04','12:00:00',2.79),('8784','2014-05-04','12:05:00',2.42),('8784','2014-05-04','12:10:00',1.91),('8784','2014-05-04','12:15:00',1.73),('8784','2014-05-04','12:20:00',1.7),('8784','2014-05-04','12:25:00',1.92),('8784','2014-05-04','12:30:00',3.21),('8784','2014-05-04','12:35:00',5.37),('8784','2014-05-04','12:40:00',3.36),('8784','2014-05-04','12:45:00',3.13),('8784','2014-05-04','12:50:00',1.9),('8784','2014-05-04','12:55:00',2.23),('8784','2014-05-04','13:00:00',2.69),('8784','2014-05-04','13:05:00',1.89),('8784','2014-05-04','13:10:00',1.97),('8784','2014-05-04','13:15:00',1.91),('8784','2014-05-04','13:20:00',1.78),('8784','2014-05-04','13:25:00',1.69),('8784','2014-05-04','13:30:00',1.64),('8784','2014-05-04','13:35:00',1.76),('8784','2014-05-04','13:40:00',1.75),('8784','2014-05-04','13:45:00',1.53),('8784','2014-05-04','13:50:00',1.45),('8784','2014-05-04','13:55:00',1.53),('8784','2014-05-04','14:00:00',1.55),('8784','2014-05-04','14:05:00',1.54),('8784','2014-05-04','14:10:00',1.5),('8784','2014-05-04','14:15:00',1.37),('8784','2014-05-04','14:20:00',1.05),('8784','2014-05-04','14:50:00',1.33),('8784','2014-05-04','14:55:00',1.9),('8784','2014-05-04','15:00:00',2.17),('8784','2014-05-04','15:05:00',2.46),('8784','2014-05-04','15:10:00',3.48),('8784','2014-05-04','15:15:00',2.5),('8784','2014-05-04','15:20:00',2.1),('8784','2014-05-04','15:25:00',1.6),('8784','2014-05-04','15:30:00',1.32),('8784','2014-05-04','15:45:00',1),('8784','2014-05-04','15:50:00',1.21),('8784','2014-05-04','15:55:00',1.24),('8784','2014-05-04','16:00:00',1.09),('8784','2014-05-04','16:05:00',1.13),('8784','2014-05-04','16:10:00',1.37),('8784','2014-05-04','16:15:00',1.31),('8784','2014-05-04','16:20:00',1.11),('8784','2014-05-04','17:25:00',1.01),('8784','2014-05-04','17:30:00',1.03),('8784','2014-05-04','17:35:00',1.1),('8784','2014-05-04','17:40:00',1.13),('8784','2014-04-16','07:50:00',1.08),('8784','2014-04-16','07:55:00',1.16),('8784','2014-04-16','08:00:00',1.25),('8784','2014-04-16','08:05:00',1.34),('8784','2014-04-16','08:10:00',1.44),('8784','2014-04-16','08:15:00',1.55),('8784','2014-04-16','08:20:00',1.66),('8784','2014-04-16','08:25:00',1.74),('8784','2014-04-16','08:30:00',1.3),('8784','2014-04-16','08:35:00',1.02),('8784','2014-04-16','08:40:00',1.07),('8784','2014-04-16','08:45:00',1.88),('8784','2014-04-16','08:50:00',2),('8784','2014-04-16','08:55:00',2.32),('8784','2014-04-16','09:00:00',2.4),('8784','2014-04-16','09:05:00',2.48),('8784','2014-04-16','09:10:00',2.56),('8784','2014-04-16','09:15:00',2.62),('8784','2014-04-16','09:20:00',2.72),('8784','2014-04-16','09:25:00',2.85),('8784','2014-04-16','09:30:00',1.95),('8784','2014-04-16','09:35:00',1.1),('8784','2014-04-16','09:50:00',1.06),('8784','2014-04-16','09:55:00',3.34),('8784','2014-04-16','10:00:00',3.47),('8784','2014-04-16','10:05:00',3.51),('8784','2014-04-16','10:10:00',3.58),('8784','2014-04-16','10:15:00',3.65),('8784','2014-04-16','10:20:00',3.73),('8784','2014-04-16','10:25:00',3.78),('8784','2014-04-16','10:30:00',3.83),('8784','2014-04-16','10:35:00',3.89),('8784','2014-04-16','10:40:00',3.96),('8784','2014-04-16','10:45:00',4.04),('8784','2014-04-16','10:50:00',4.19),('8784','2014-04-16','10:55:00',3.93),('8784','2014-04-16','11:00:00',4.05),('8784','2014-04-16','11:05:00',2.15),('8784','2014-04-16','11:10:00',1.62),('8784','2014-04-16','11:15:00',2.08),('8784','2014-04-16','11:20:00',3.83),('8784','2014-04-16','11:25:00',3.62),('8784','2014-04-16','11:30:00',4.03),('8784','2014-04-16','11:35:00',2.99),('8784','2014-04-16','11:40:00',3.52),('8784','2014-04-16','11:45:00',4.01),('8784','2014-04-16','11:50:00',4.68),('8784','2014-04-16','11:55:00',5.02),('8784','2014-04-16','12:00:00',5.05),('8784','2014-04-16','12:05:00',3.86),('8784','2014-04-16','12:10:00',3.84),('8784','2014-04-16','12:15:00',4.66),('8784','2014-04-16','12:20:00',2.61),('8784','2014-04-16','12:25:00',1.38),('8784','2014-04-16','12:30:00',1.59),('8784','2014-04-16','12:35:00',4.92),('8784','2014-04-16','12:40:00',5.03),('8784','2014-04-16','12:45:00',4.93),('8784','2014-04-16','12:50:00',4.46),('8784','2014-04-16','12:55:00',1.16),('8784','2014-04-16','13:00:00',2.81),('8784','2014-04-16','13:05:00',1.48),('8784','2014-04-16','13:20:00',1.57),('8784','2014-04-16','13:25:00',1.25),('8784','2014-04-16','13:30:00',1.02),('8784','2014-04-16','13:35:00',1.86),('8784','2014-04-16','13:40:00',2.76),('8784','2014-04-16','13:45:00',5.45),('8784','2014-04-16','13:50:00',4.8),('8784','2014-04-16','13:55:00',4.21),('8784','2014-04-16','14:00:00',1.87),('8784','2014-04-16','14:05:00',4),('8784','2014-04-16','14:10:00',5.06),('8784','2014-04-16','14:15:00',5.27),('8784','2014-04-16','14:20:00',4.25),('8784','2014-04-16','14:25:00',4.51),('8784','2014-04-16','14:30:00',4.76),('8784','2014-04-16','14:35:00',4.52),('8784','2014-04-16','14:40:00',4.41),('8784','2014-04-16','14:45:00',4.42),('8784','2014-04-16','14:50:00',4.57),('8784','2014-04-16','14:55:00',1.66),('8784','2014-04-16','15:00:00',1.33),('8784','2014-04-16','15:05:00',3.66),('8784','2014-04-16','15:10:00',4.92),('8784','2014-04-16','15:15:00',3.11),('8784','2014-04-16','15:25:00',1.32),('8784','2014-04-16','15:30:00',3.15),('8784','2014-04-16','15:35:00',4.22),('8784','2014-04-16','15:40:00',4.07),('8784','2014-04-16','15:45:00',3.89),('8784','2014-04-16','15:50:00',3.63),('8784','2014-04-16','15:55:00',3.67),('8784','2014-04-16','16:00:00',3.56),('8784','2014-04-16','16:05:00',3.43),('8784','2014-04-16','16:10:00',3.34),('8784','2014-04-16','16:15:00',3.27),('8784','2014-04-16','16:20:00',3.27),('8784','2014-04-16','16:25:00',3.15),('8784','2014-04-16','16:30:00',3.08),('8784','2014-04-16','16:35:00',2.99),('8784','2014-04-16','16:40:00',2.92),('8784','2014-04-16','16:45:00',2.84),('8784','2014-04-16','16:50:00',2.73),('8784','2014-04-16','16:55:00',2.64),('8784','2014-04-16','17:00:00',2.56),('8784','2014-04-16','17:05:00',2.46),('8784','2014-04-16','17:10:00',2.36),('8784','2014-04-16','17:15:00',2.29),('8784','2014-04-16','17:20:00',2.18),('8784','2014-04-16','17:25:00',2.07),('8784','2014-04-16','17:30:00',1.99),('8784','2014-04-16','17:35:00',1.92),('8784','2014-04-16','17:40:00',1.81),('8784','2014-04-16','17:45:00',1.74),('8784','2014-04-16','17:50:00',1.72),('8784','2014-04-16','17:55:00',1.73),('8784','2014-04-16','18:00:00',1.55),('8784','2014-04-16','18:05:00',1.46),('8784','2014-04-16','18:10:00',1.27),('8784','2014-04-16','18:15:00',1.02),('8784','2014-04-16','18:20:00',1.19),('8784','2014-04-16','18:25:00',1.01),('8784','2013-10-18','08:55:00',1.02),('8784','2013-10-18','09:00:00',1.15),('8784','2013-10-18','09:05:00',1.27),('8784','2013-10-18','09:10:00',1.36),('8784','2013-10-18','09:15:00',1.38),('8784','2013-10-18','09:20:00',1.55),('8784','2013-10-18','09:25:00',1.6),('8784','2013-10-18','09:30:00',1.69),('8784','2013-10-18','09:35:00',1.77),('8784','2013-10-18','09:40:00',1.85),('8784','2013-10-18','09:45:00',1.92),('8784','2013-10-18','09:50:00',1.99),('8784','2013-10-18','09:55:00',2.06),('8784','2013-10-18','10:00:00',2.11),('8784','2013-10-18','10:05:00',2.17),('8784','2013-10-18','10:10:00',2.2),('8784','2013-10-18','10:15:00',2.19),('8784','2013-10-18','10:20:00',2.22),('8784','2013-10-18','10:25:00',2.34),('8784','2013-10-18','10:30:00',2.47),('8784','2013-10-18','10:35:00',2.49),('8784','2013-10-18','10:40:00',2.51),('8784','2013-10-18','10:45:00',2.57),('8784','2013-10-18','10:50:00',2.64),('8784','2013-10-18','10:55:00',2.69),('8784','2013-10-18','11:00:00',2.62),('8784','2013-10-18','11:05:00',2.59),('8784','2013-10-18','11:10:00',2.66),('8784','2013-10-18','11:15:00',2.71),('8784','2013-10-18','11:20:00',2.91),('8784','2013-10-18','11:25:00',2.89),('8784','2013-10-18','11:30:00',2.86),('8784','2013-10-18','11:35:00',2.93),('8784','2013-10-18','11:40:00',3.02),('8784','2013-10-18','11:45:00',2.93),('8784','2013-10-18','11:50:00',2.93),('8784','2013-10-18','11:55:00',3.08),('8784','2013-10-18','12:00:00',3.04),('8784','2013-10-18','12:05:00',3.04),('8784','2013-10-18','12:10:00',3.06),('8784','2013-10-18','12:15:00',3.02),('8784','2013-10-18','12:20:00',3),('8784','2013-10-18','12:25:00',3.05),('8784','2013-10-18','12:30:00',3.09),('8784','2013-10-18','12:35:00',3.04),('8784','2013-10-18','12:40:00',3.04),('8784','2013-10-18','12:45:00',2.97),('8784','2013-10-18','12:50:00',2.98),('8784','2013-10-18','12:55:00',3.04),('8784','2013-10-18','13:00:00',3),('8784','2013-10-18','13:05:00',2.95),('8784','2013-10-18','13:10:00',2.83),('8784','2013-10-18','13:15:00',2.91),('8784','2013-10-18','13:20:00',2.99),('8784','2013-10-18','13:25:00',3.03),('8784','2013-10-18','13:30:00',3.05),('8784','2013-10-18','13:35:00',3.01),('8784','2013-10-18','13:40:00',2.97),('8784','2013-10-18','13:45:00',2.88),('8784','2013-10-18','13:50:00',2.88),('8784','2013-10-18','13:55:00',2.84),('8784','2013-10-18','14:00:00',2.67),('8784','2013-10-18','14:05:00',2.64),('8784','2013-10-18','14:10:00',2.6),('8784','2013-10-18','14:15:00',2.62),('8784','2013-10-18','14:20:00',2.63),('8784','2013-10-18','14:25:00',2.62),('8784','2013-10-18','14:30:00',2.58),('8784','2013-10-18','14:35:00',2.47),('8784','2013-10-18','14:40:00',2.49),('8784','2013-10-18','14:45:00',2.36),('8784','2013-10-18','14:50:00',2.28),('8784','2013-10-18','14:55:00',1.92),('8784','2013-10-18','15:00:00',1.7),('8784','2013-10-18','15:05:00',1.8),('8784','2013-10-18','15:10:00',2.03),('8784','2013-10-18','15:15:00',2.01),('8784','2013-10-18','15:20:00',2.07),('8784','2013-10-18','15:25:00',1.94),('8784','2013-10-18','15:30:00',1.84),('8784','2013-10-18','15:35:00',1.81),('8784','2013-10-18','15:40:00',1.7),('8784','2013-10-18','15:45:00',1.6),('8784','2013-10-18','15:50:00',1.52),('8784','2013-10-18','15:55:00',1.41),('8784','2013-10-18','16:00:00',1.49),('8784','2013-10-18','16:05:00',1.39),('8784','2013-10-18','16:10:00',1.36),('8784','2013-10-18','16:15:00',1.24),('8784','2013-10-18','16:20:00',1.18),('8784','2013-10-18','16:25:00',1.02),('8784','2013-10-17','08:50:00',1.07),('8784','2013-10-17','08:55:00',1.15),('8784','2013-10-17','09:00:00',1.22),('8784','2013-10-17','09:05:00',1.31),('8784','2013-10-17','09:10:00',1.39),('8784','2013-10-17','09:15:00',1.46),('8784','2013-10-17','09:20:00',1.54),('8784','2013-10-17','09:25:00',1.6),('8784','2013-10-17','09:30:00',1.67),('8784','2013-10-17','09:35:00',1.73),('8784','2013-10-17','09:40:00',1.82),('8784','2013-10-17','09:45:00',1.9),('8784','2013-10-17','09:50:00',1.98),('8784','2013-10-17','09:55:00',2.05),('8784','2013-10-17','10:00:00',2.1),('8784','2013-10-17','10:05:00',2.16),('8784','2013-10-17','10:10:00',2.22),('8784','2013-10-17','10:15:00',2.3),('8784','2013-10-17','10:20:00',2.37),('8784','2013-10-17','10:25:00',2.43),('8784','2013-10-17','10:30:00',2.48),('8784','2013-10-17','10:35:00',2.54),('8784','2013-10-17','10:40:00',2.6),('8784','2013-10-17','10:45:00',2.67),('8784','2013-10-17','10:50:00',2.72),('8784','2013-10-17','10:55:00',2.76),('8784','2013-10-17','11:00:00',2.79),('8784','2013-10-17','11:05:00',2.83),('8784','2013-10-17','11:10:00',2.88),('8784','2013-10-17','11:15:00',2.93),('8784','2013-10-17','11:20:00',2.96),('8784','2013-10-17','11:25:00',2.99),('8784','2013-10-17','11:30:00',3),('8784','2013-10-17','11:35:00',3.06),('8784','2013-10-17','11:40:00',3.1),('8784','2013-10-17','11:45:00',3.11),('8784','2013-10-17','11:50:00',3.12),('8784','2013-10-17','11:55:00',3.14),('8784','2013-10-17','12:00:00',3.16),('8784','2013-10-17','12:05:00',3.18),('8784','2013-10-17','12:10:00',3.19),('8784','2013-10-17','12:15:00',3.2),('8784','2013-10-17','12:20:00',3.19),('8784','2013-10-17','12:25:00',3.19),('8784','2013-10-17','12:30:00',3.19),('8784','2013-10-17','12:35:00',3.2),('8784','2013-10-17','12:40:00',3.24),('8784','2013-10-17','12:45:00',3.23),('8784','2013-10-17','12:50:00',3.26),('8784','2013-10-17','12:55:00',3.25),('8784','2013-10-17','13:00:00',3.24),('8784','2013-10-17','13:05:00',3.21),('8784','2013-10-17','13:10:00',3.2),('8784','2013-10-17','13:15:00',3.19),('8784','2013-10-17','13:20:00',3.16),('8784','2013-10-17','13:25:00',3.15),('8784','2013-10-17','13:30:00',3.13),('8784','2013-10-17','13:35:00',3.13),('8784','2013-10-17','13:40:00',3.09),('8784','2013-10-17','13:45:00',3.06),('8784','2013-10-17','13:50:00',3.04),('8784','2013-10-17','13:55:00',3),('8784','2013-10-17','14:00:00',2.97),('8784','2013-10-17','14:05:00',2.94),('8784','2013-10-17','14:10:00',2.91),('8784','2013-10-17','14:15:00',2.87),('8784','2013-10-17','14:20:00',2.85),('8784','2013-10-17','14:25:00',2.82),('8784','2013-10-17','14:30:00',2.76),('8784','2013-10-17','14:35:00',2.7),('8784','2013-10-17','14:40:00',2.68),('8784','2013-10-17','14:45:00',2.6),('8784','2013-10-17','14:50:00',2.51),('8784','2013-10-17','14:55:00',2.13),('8784','2013-10-17','15:00:00',2.21),('8784','2013-10-17','15:05:00',2.36),('8784','2013-10-17','15:10:00',2.34),('8784','2013-10-17','15:15:00',2.29),('8784','2013-10-17','15:20:00',2.22),('8784','2013-10-17','15:25:00',2.16),('8784','2013-10-17','15:30:00',2.09),('8784','2013-10-17','15:35:00',2),('8784','2013-10-17','15:40:00',1.94),('8784','2013-10-17','15:45:00',1.9),('8784','2013-10-17','15:50:00',1.82),('8784','2013-10-17','15:55:00',1.77),('8784','2013-10-17','16:00:00',1.69),('8784','2013-10-17','16:05:00',1.62),('8784','2013-10-17','16:10:00',1.57),('8784','2013-10-17','16:15:00',1.49),('8784','2013-10-17','16:20:00',1.44),('8784','2013-10-17','16:25:00',1.36),('8784','2013-10-17','16:30:00',1.28),('8784','2013-10-17','16:35:00',1.21),('8784','2013-10-17','16:40:00',1.1),('8784','2013-10-17','16:45:00',1.05),('8784','2013-10-16','09:45:00',1.64),('8784','2013-10-16','09:50:00',1.08),('8784','2013-10-16','11:15:00',1.37),('8784','2013-10-16','11:55:00',1.25),('8784','2013-10-16','12:00:00',1.02),('8784','2013-10-16','12:10:00',1.46),('8784','2013-10-16','12:15:00',3.25),('8784','2013-10-16','12:20:00',1.82),('8784','2013-10-16','12:30:00',1.33),('8784','2013-10-16','12:35:00',1.36),('8784','2013-10-16','12:40:00',3.68),('8784','2013-10-16','12:45:00',2.57),('8784','2013-10-16','12:50:00',3.29),('8784','2013-10-16','12:55:00',2.28),('8784','2013-10-16','13:00:00',2.43),('8784','2013-10-16','13:05:00',3.57),('8784','2013-10-16','13:10:00',2.08),('8784','2013-10-16','13:15:00',3.26),('8784','2013-10-16','13:20:00',3.47),('8784','2013-10-16','13:25:00',3.29),('8784','2013-10-16','13:30:00',3.29),('8784','2013-10-16','13:35:00',3.13),('8784','2013-10-16','13:40:00',3.15),('8784','2013-10-16','13:45:00',3.11),('8784','2013-10-16','13:50:00',2.9),('8784','2013-10-16','13:55:00',3.26),('8784','2013-10-16','14:00:00',2.74),('8784','2013-10-16','14:05:00',2.06),('8784','2013-10-16','14:10:00',3.25),('8784','2013-10-16','14:15:00',2.76),('8784','2013-10-16','14:20:00',2.49),('8784','2013-10-16','14:25:00',3.24),('8784','2013-10-16','14:30:00',2.93),('8784','2013-10-16','14:35:00',2.84),('8784','2013-10-16','14:40:00',2.82),('8784','2013-10-16','14:45:00',2.34),('8784','2013-10-16','14:50:00',2.3),('8784','2013-10-16','14:55:00',2.44),('8784','2013-10-16','15:00:00',2.51),('8784','2013-10-16','15:05:00',1.57),('8784','2013-10-16','15:10:00',2.06),('8784','2013-10-16','15:15:00',2.09),('8784','2013-10-16','15:20:00',1.85),('8784','2013-10-16','15:25:00',1.61),('8784','2013-10-16','15:35:00',1.42),('8784','2013-10-16','15:40:00',2.08),('8784','2013-10-16','15:45:00',1.92),('8784','2013-10-16','15:50:00',1.85),('8784','2013-10-16','15:55:00',1.81),('8784','2013-10-16','16:00:00',1.74),('8784','2013-10-16','16:05:00',1.68),('8784','2013-10-16','16:10:00',1.57),('8784','2013-10-16','16:15:00',1.52),('8784','2013-10-16','16:20:00',1.44),('8784','2013-10-16','16:25:00',1.36),('8784','2013-10-16','16:30:00',1.28),('8784','2013-10-16','16:35:00',1.06),('8784','2013-10-16','16:40:00',1.17),('8784','2013-10-16','16:45:00',1.07),('8784','2013-10-16','16:50:00',1.01),('8784','2013-10-15','09:10:00',1.03),('8784','2013-10-15','09:20:00',1.06),('8784','2013-10-15','09:25:00',1.09),('8784','2013-10-15','09:30:00',1.5),('8784','2013-10-15','09:35:00',1.02),('8784','2013-10-15','09:40:00',1.38),('8784','2013-10-15','09:45:00',1.82),('8784','2013-10-15','09:50:00',2),('8784','2013-10-15','09:55:00',2.12),('8784','2013-10-15','10:00:00',2.11),('8784','2013-10-15','10:05:00',2.37),('8784','2013-10-15','10:10:00',1.83),('8784','2013-10-15','10:15:00',1.19),('8784','2013-10-15','10:20:00',1.19),('8784','2013-10-15','10:25:00',1.54),('8784','2013-10-15','10:30:00',1.94),('8784','2013-10-15','10:35:00',1.66),('8784','2013-10-15','10:40:00',1.96),('8784','2013-10-15','10:45:00',2.28),('8784','2013-10-15','10:50:00',2.18),('8784','2013-10-15','10:55:00',1.9),('8784','2013-10-15','11:00:00',1.89),('8784','2013-10-15','11:05:00',2.04),('8784','2013-10-15','11:10:00',2.61),('8784','2013-10-15','11:15:00',2.83),('8784','2013-10-15','11:20:00',2.88),('8784','2013-10-15','11:25:00',2.68),('8784','2013-10-15','11:30:00',2.77),('8784','2013-10-15','11:35:00',2.34),('8784','2013-10-15','11:40:00',1.9),('8784','2013-10-15','11:45:00',1.58),('8784','2013-10-15','11:50:00',1.52),('8784','2013-10-15','11:55:00',1.52),('8784','2013-10-15','12:00:00',1.59),('8784','2013-10-15','12:05:00',1.61),('8784','2013-10-15','12:10:00',1.63),('8784','2013-10-15','12:15:00',1.59),('8784','2013-10-15','12:20:00',1.67),('8784','2013-10-15','12:25:00',1.51),('8784','2013-10-15','12:30:00',1.39),('8784','2013-10-15','12:35:00',1.37),('8784','2013-10-15','12:40:00',1.37),('8784','2013-10-15','12:45:00',1.51),('8784','2013-10-15','12:50:00',1.44),('8784','2013-10-15','12:55:00',1.31),('8784','2013-10-15','13:00:00',1.29),('8784','2013-10-15','13:05:00',1.67),('8784','2013-10-15','13:10:00',1.87),('8784','2013-10-15','13:15:00',1.87),('8784','2013-10-15','13:20:00',2.63),('8784','2013-10-15','13:25:00',2.95),('8784','2013-10-15','13:30:00',1.91),('8784','2013-10-15','13:35:00',1.66),('8784','2013-10-15','13:40:00',1.6),('8784','2013-10-15','13:45:00',1.66),('8784','2013-10-15','13:50:00',1.53),('8784','2013-10-15','13:55:00',1.39),('8784','2013-10-15','14:00:00',1.27),('8784','2013-10-15','14:05:00',1.27),('8784','2013-10-15','14:10:00',1.39),('8784','2013-10-15','14:15:00',1.87),('8784','2013-10-15','14:20:00',2.03),('8784','2013-10-15','14:25:00',2.24),('8784','2013-10-15','14:30:00',2.06),('8784','2013-10-15','14:35:00',1.42),('8784','2013-10-15','14:40:00',1.97),('8784','2013-10-15','14:45:00',1.98),('8784','2013-10-15','14:50:00',2.44),('8784','2013-10-15','14:55:00',1.89),('8784','2013-10-15','15:00:00',1.32),('8784','2013-10-15','15:05:00',1.36),('8784','2013-10-15','15:10:00',1.37),('8784','2013-10-15','15:15:00',1.28),('8784','2013-10-15','15:20:00',1.17),('8784','2013-10-15','15:25:00',1.07),('8784','2013-10-15','15:30:00',1.03),('8784','2013-10-15','15:35:00',1.1),('8784','2013-10-15','15:40:00',1.15),('8784','2013-10-15','15:45:00',1.11),('8784','2013-10-15','16:30:00',1.18),('8784','2013-10-15','16:35:00',1.21),('8784','2013-10-14','08:45:00',1.09),('8784','2013-10-14','08:50:00',1.02),('8784','2013-10-14','08:55:00',1.18),('8784','2013-10-14','09:00:00',1.04),('8784','2013-10-14','09:05:00',1.12),('8784','2013-10-14','09:20:00',1.02),('8784','2013-10-14','09:25:00',1.52),('8784','2013-10-14','09:30:00',1.69),('8784','2013-10-14','09:35:00',1.56),('8784','2013-10-14','09:40:00',1.45),('8784','2013-10-14','09:45:00',1.23),('8784','2013-10-14','09:50:00',1.59),('8784','2013-10-14','09:55:00',1.84),('8784','2013-10-14','10:00:00',1.82),('8784','2013-10-14','10:05:00',1.99),('8784','2013-10-14','10:10:00',2.11),('8784','2013-10-14','10:15:00',2.25),('8784','2013-10-14','10:20:00',2.29),('8784','2013-10-14','10:25:00',2.34),('8784','2013-10-14','10:30:00',2.38),('8784','2013-10-14','10:35:00',2.41),('8784','2013-10-14','10:40:00',2.39),('8784','2013-10-14','10:45:00',2.46),('8784','2013-10-14','10:50:00',2.55),('8784','2013-10-14','10:55:00',2.61),('8784','2013-10-14','11:00:00',2.65),('8784','2013-10-14','11:05:00',2.66),('8784','2013-10-14','11:10:00',2.8),('8784','2013-10-14','11:15:00',2.77),('8784','2013-10-14','11:20:00',2.79),('8784','2013-10-14','11:25:00',2.86),('8784','2013-10-14','11:30:00',2.93),('8784','2013-10-14','11:35:00',2.87),('8784','2013-10-14','11:40:00',2.89),('8784','2013-10-14','11:45:00',2.87),('8784','2013-10-14','11:50:00',2.92),('8784','2013-10-14','11:55:00',2.94),('8784','2013-10-14','12:00:00',2.96),('8784','2013-10-14','12:05:00',2.98),('8784','2013-10-14','12:10:00',3.04),('8784','2013-10-14','12:15:00',2.96),('8784','2013-10-14','12:20:00',2.79),('8784','2013-10-14','12:25:00',2.96),('8784','2013-10-14','12:30:00',3.1),('8784','2013-10-14','12:35:00',3.07),('8784','2013-10-14','12:40:00',3.07),('8784','2013-10-14','12:45:00',3.08),('8784','2013-10-14','12:50:00',3.01),('8784','2013-10-14','12:55:00',3.04),('8784','2013-10-14','13:00:00',3.03),('8784','2013-10-14','13:05:00',3.02),('8784','2013-10-14','13:10:00',3.01),('8784','2013-10-14','13:15:00',3),('8784','2013-10-14','13:20:00',3.01),('8784','2013-10-14','13:25:00',2.98),('8784','2013-10-14','13:30:00',2.96),('8784','2013-10-14','13:35:00',2.94),('8784','2013-10-14','13:40:00',2.94),('8784','2013-10-14','13:45:00',2.9),('8784','2013-10-14','13:50:00',2.9),('8784','2013-10-14','13:55:00',2.87),('8784','2013-10-14','14:00:00',2.84),('8784','2013-10-14','14:05:00',2.81),('8784','2013-10-14','14:10:00',2.8),('8784','2013-10-14','14:15:00',2.76),('8784','2013-10-14','14:20:00',2.71),('8784','2013-10-14','14:25:00',2.67),('8784','2013-10-14','14:30:00',2.64),('8784','2013-10-14','14:35:00',2.58),('8784','2013-10-14','14:40:00',2.56),('8784','2013-10-14','14:45:00',2.49),('8784','2013-10-14','14:50:00',2.43),('8784','2013-10-14','14:55:00',2.34),('8784','2013-10-14','15:00:00',2.32),('8784','2013-10-14','15:05:00',2.27),('8784','2013-10-14','15:10:00',2.22),('8784','2013-10-14','15:15:00',2.15),('8784','2013-10-14','15:20:00',2.08),('8784','2013-10-14','15:25:00',2.02),('8784','2013-10-14','15:30:00',1.93),('8784','2013-10-14','15:35:00',1.86),('8784','2013-10-14','15:40:00',1.68),('8784','2013-10-14','15:45:00',1.36),('8784','2013-10-14','15:50:00',1.41),('8784','2013-10-14','16:00:00',1.21),('8784','2013-10-14','16:05:00',1.05),('8784','2013-10-13','09:00:00',1.01),('8784','2013-10-13','09:10:00',1.03),('8784','2013-10-13','09:15:00',1.51),('8784','2013-10-13','09:20:00',1.6),('8784','2013-10-13','09:25:00',1.47),('8784','2013-10-13','09:30:00',1.05),('8784','2013-10-13','09:35:00',1.35),('8784','2013-10-13','09:40:00',1.98),('8784','2013-10-13','09:45:00',2.48),('8784','2013-10-13','09:50:00',2.46),('8784','2013-10-13','09:55:00',2.55),('8784','2013-10-13','10:00:00',1.85),('8784','2013-10-13','10:05:00',1.49),('8784','2013-10-13','10:10:00',2.12),('8784','2013-10-13','10:15:00',2.2),('8784','2013-10-13','10:20:00',1.86),('8784','2013-10-13','10:25:00',2.08),('8784','2013-10-13','10:30:00',2.65),('8784','2013-10-13','10:35:00',3.06),('8784','2013-10-13','10:40:00',3.15),('8784','2013-10-13','10:45:00',3.23),('8784','2013-10-13','10:50:00',2.69),('8784','2013-10-13','10:55:00',2.23),('8784','2013-10-13','11:00:00',2.84),('8784','2013-10-13','11:05:00',2.83),('8784','2013-10-13','11:10:00',2.84),('8784','2013-10-13','11:15:00',3.07),('8784','2013-10-13','11:20:00',2.96),('8784','2013-10-13','11:25:00',2.9),('8784','2013-10-13','11:30:00',2.98),('8784','2013-10-13','11:35:00',2.95),('8784','2013-10-13','11:40:00',2.96),('8784','2013-10-13','11:45:00',2.97),('8784','2013-10-13','11:50:00',3.01),('8784','2013-10-13','11:55:00',3),('8784','2013-10-13','12:00:00',3.04),('8784','2013-10-13','12:05:00',3.05),('8784','2013-10-13','12:10:00',3.05),('8784','2013-10-13','12:15:00',3.08),('8784','2013-10-13','12:20:00',2.99),('8784','2013-10-13','12:25:00',2.99),('8784','2013-10-13','12:30:00',3.1),('8784','2013-10-13','12:35:00',3.14),('8784','2013-10-13','12:40:00',3.14),('8784','2013-10-13','12:45:00',3.09),('8784','2013-10-13','12:50:00',3.05),('8784','2013-10-13','12:55:00',3.04),('8784','2013-10-13','13:00:00',3.06),('8784','2013-10-13','13:05:00',3.04),('8784','2013-10-13','13:10:00',3.08),('8784','2013-10-13','13:15:00',3.08),('8784','2013-10-13','13:20:00',3.14),('8784','2013-10-13','13:25:00',2.76),('8784','2013-10-13','13:30:00',2.31),('8784','2013-10-13','13:35:00',2.54),('8784','2013-10-13','13:40:00',1.77),('8784','2013-10-13','13:45:00',2.02),('8784','2013-10-13','13:50:00',2.24),('8784','2013-10-13','13:55:00',2.42),('8784','2013-10-13','14:00:00',3),('8784','2013-10-13','14:05:00',2.98),('8784','2013-10-13','14:10:00',2.96),('8784','2013-10-13','14:15:00',2.7),('8784','2013-10-13','14:20:00',2.98),('8784','2013-10-13','14:25:00',2.96),('8784','2013-10-13','14:30:00',2.46),('8784','2013-10-13','14:35:00',2.29),('8784','2013-10-13','14:40:00',2.56),('8784','2013-10-13','14:45:00',1.99),('8784','2013-10-13','14:50:00',1.69),('8784','2013-10-13','14:55:00',2.03),('8784','2013-10-13','15:00:00',2.49),('8784','2013-10-13','15:05:00',2.15),('8784','2013-10-13','15:10:00',1.56),('8784','2013-10-13','15:15:00',1.81),('8784','2013-10-13','15:20:00',2.01),('8784','2013-10-13','15:25:00',2.06),('8784','2013-10-13','15:30:00',1.63),('8784','2013-10-13','15:35:00',1.5),('8784','2013-10-13','15:40:00',1.47),('8784','2013-10-13','15:45:00',1.43),('8784','2013-10-13','15:50:00',1.34),('8784','2013-10-13','15:55:00',1.3),('8784','2013-10-13','16:00:00',1.43),('8784','2013-10-13','16:05:00',1.68),('8784','2013-10-13','16:10:00',1.43),('8784','2013-10-13','16:15:00',1.26),('8784','2013-10-13','16:20:00',1.34),('8784','2013-10-13','16:25:00',1.68),('8784','2013-10-13','16:30:00',1.6),('8784','2013-10-13','16:35:00',1.34),('8784','2013-10-13','16:40:00',1.1),('8784','2013-10-12','11:15:00',1.02),('8784','2013-10-12','11:20:00',1.19),('8784','2013-10-12','11:25:00',1.26),('8784','2013-10-12','11:30:00',1.5),('8784','2013-10-12','11:35:00',1.96),('8784','2013-10-12','11:40:00',2.94),('8784','2013-10-12','11:45:00',1.58),('8784','2013-10-12','11:50:00',1.5),('8784','2013-10-12','11:55:00',1.29),('8784','2013-10-12','12:15:00',1.17),('8784','2013-10-12','12:20:00',2.08),('8784','2013-10-12','12:25:00',3.44),('8784','2013-10-12','12:30:00',2.58),('8784','2013-10-12','12:35:00',3.12),('8784','2013-10-12','12:40:00',2.94),('8784','2013-10-12','12:45:00',2.91),('8784','2013-10-12','12:50:00',2.65),('8784','2013-10-12','12:55:00',2.31),('8784','2013-10-12','13:00:00',1.73),('8784','2013-10-12','13:05:00',1.14),('8784','2013-10-12','13:15:00',1.34),('8784','2013-10-12','13:20:00',1.44),('8784','2013-10-12','13:25:00',1.68),('8784','2013-10-12','13:30:00',3.69),('8784','2013-10-12','13:35:00',1.57),('8784','2013-10-12','15:55:00',1.02),('8784','2013-10-12','16:00:00',1.18),('8784','2013-10-12','16:05:00',1.12),('8784','2013-10-12','16:10:00',1.17),('8784','2013-10-12','16:15:00',1.78),('8784','2013-10-12','16:20:00',1.8),('8784','2013-10-12','16:25:00',1.13),('8784','2013-10-11','09:20:00',1.11),('8784','2013-10-11','09:40:00',1.28),('8784','2013-10-11','09:45:00',2.04),('8784','2013-10-11','09:50:00',2.11),('8784','2013-10-11','09:55:00',2.18),('8784','2013-10-11','10:00:00',2.24),('8784','2013-10-11','10:05:00',2.33),('8784','2013-10-11','10:10:00',2.4),('8784','2013-10-11','10:15:00',2.06),('8784','2013-10-11','10:20:00',2.13),('8784','2013-10-11','10:25:00',2.29),('8784','2013-10-11','10:30:00',2.56),('8784','2013-10-11','10:35:00',2.7),('8784','2013-10-11','10:40:00',1.53),('8784','2013-10-11','11:05:00',2.69),('8784','2013-10-11','11:10:00',2.34),('8784','2013-10-11','11:15:00',1.08),('8784','2013-10-11','11:20:00',1.13),('8784','2013-10-11','11:25:00',1.11),('8784','2013-10-11','11:35:00',1.44),('8784','2013-10-11','11:40:00',2.16),('8784','2013-10-11','11:45:00',1.86),('8784','2013-10-11','11:50:00',2.12),('8784','2013-10-11','11:55:00',1.92),('8784','2013-10-11','12:00:00',2.99),('8784','2013-10-11','12:05:00',3.18),('8784','2013-10-11','12:10:00',1.56),('8784','2013-10-11','12:15:00',1.23),('8784','2013-10-11','12:20:00',1.01),('8784','2013-10-11','12:25:00',1.36),('8784','2013-10-11','12:30:00',1.28),('8784','2013-10-11','13:05:00',2.44),('8784','2013-10-11','13:10:00',1.96),('8784','2013-10-11','13:15:00',1.58),('8784','2013-10-11','13:20:00',2.3),('8784','2013-10-11','13:25:00',4.08),('8784','2013-10-11','13:30:00',1.64),('8784','2013-10-11','13:40:00',2.97),('8784','2013-10-11','13:45:00',3.18),('8784','2013-10-11','15:30:00',1.03),('8784','2013-10-11','15:35:00',1.19),('8784','2013-10-11','15:40:00',1.72),('8784','2013-10-11','15:45:00',1.2),('8784','2013-10-11','16:00:00',2.27),('8784','2013-10-11','16:30:00',1.02),('8784','2013-10-11','16:35:00',1.06),('8784','2013-10-11','17:00:00',1.03),('8784','2013-10-10','08:50:00',1.05),('8784','2013-10-10','08:55:00',1.26),('8784','2013-10-10','09:10:00',1.49),('8784','2013-10-10','09:15:00',1.6),('8784','2013-10-10','09:20:00',1.64),('8784','2013-10-10','09:25:00',1.65),('8784','2013-10-10','09:30:00',1.78),('8784','2013-10-10','09:35:00',1.22),('8784','2013-10-10','09:40:00',1.53),('8784','2013-10-10','09:45:00',1.45),('8784','2013-10-10','09:50:00',1.74),('8784','2013-10-10','09:55:00',2.03),('8784','2013-10-10','10:10:00',1.5),('8784','2013-10-10','10:15:00',2.4),('8784','2013-10-10','10:20:00',2.43),('8784','2013-10-10','10:25:00',1.37),('8784','2013-10-10','10:30:00',1.08),('8784','2013-10-10','10:40:00',2.22),('8784','2013-10-10','10:45:00',2.55),('8784','2013-10-10','10:50:00',2.23),('8784','2013-10-10','10:55:00',1.7),('8784','2013-10-10','11:20:00',2.17),('8784','2013-10-10','11:25:00',3.2),('8784','2013-10-10','11:30:00',1.03),('8784','2013-10-10','11:35:00',2.89),('8784','2013-10-10','11:40:00',1.74),('8784','2013-10-10','11:50:00',2.81),('8784','2013-10-10','11:55:00',3.51),('8784','2013-10-10','12:00:00',3.5),('8784','2013-10-10','12:05:00',3.57),('8784','2013-10-10','12:10:00',1.19),('8784','2013-10-10','12:20:00',2.5),('8784','2013-10-10','12:25:00',3.53),('8784','2013-10-10','12:35:00',3.74),('8784','2013-10-10','12:40:00',3.78),('8784','2013-10-10','12:45:00',2.68),('8784','2013-10-10','12:50:00',1.76),('8784','2013-10-10','12:55:00',3.69),('8784','2013-10-10','13:00:00',3.92),('8784','2013-10-10','13:05:00',3.94),('8784','2013-10-10','13:10:00',3.76),('8784','2013-10-10','13:15:00',2.55),('8784','2013-10-10','13:20:00',1.45),('8784','2013-10-10','13:25:00',4.06),('8784','2013-10-10','13:30:00',3.68),('8784','2013-10-10','13:35:00',2.03),('8784','2013-10-10','13:40:00',2.22),('8784','2013-10-10','13:45:00',2.99),('8784','2013-10-10','13:50:00',3.28),('8784','2013-10-10','13:55:00',3.45),('8784','2013-10-10','14:00:00',3.34),('8784','2013-10-10','14:05:00',3.44),('8784','2013-10-10','14:10:00',2.88),('8784','2013-10-10','14:15:00',1.76),('8784','2013-10-10','14:20:00',2.66),('8784','2013-10-10','14:25:00',3.49),('8784','2013-10-10','14:30:00',3.51),('8784','2013-10-10','14:35:00',3.47),('8784','2013-10-10','14:40:00',3.22),('8784','2013-10-10','14:45:00',3.08),('8784','2013-10-10','14:50:00',2.95),('8784','2013-10-10','14:55:00',2.84),('8784','2013-10-10','15:00:00',2.78),('8784','2013-10-10','15:05:00',2.78),('8784','2013-10-10','15:10:00',2.77),('8784','2013-10-10','15:15:00',1.58),('8784','2013-10-10','15:20:00',2.58),('8784','2013-10-10','15:25:00',1.76),('8784','2013-10-10','15:30:00',2.44),('8784','2013-10-10','15:40:00',2.29),('8784','2013-10-10','15:45:00',1.31),('8784','2013-10-10','15:50:00',1.45),('8784','2013-10-10','15:55:00',1.85),('8784','2013-10-10','16:00:00',1.37),('8784','2013-10-10','16:15:00',1.45),('8784','2013-10-10','16:25:00',1.72),('8784','2013-10-10','16:45:00',1.32),('8784','2013-10-10','16:50:00',1.11),('8784','2013-10-10','16:55:00',1.12),('8784','2013-10-09','08:40:00',1.06),('8784','2013-10-09','08:45:00',1.11),('8784','2013-10-09','08:50:00',1.18),('8784','2013-10-09','08:55:00',1.29),('8784','2013-10-09','09:00:00',1.36),('8784','2013-10-09','09:05:00',1.48),('8784','2013-10-09','09:10:00',1.58),('8784','2013-10-09','09:15:00',1.47),('8784','2013-10-09','09:20:00',1.55),('8784','2013-10-09','09:25:00',1.81),('8784','2013-10-09','09:30:00',1.88),('8784','2013-10-09','09:35:00',1.95),('8784','2013-10-09','09:40:00',2.07),('8784','2013-10-09','09:45:00',2.15),('8784','2013-10-09','09:50:00',2.22),('8784','2013-10-09','09:55:00',2.3),('8784','2013-10-09','10:00:00',2.5),('8784','2013-10-09','10:05:00',2.65),('8784','2013-10-09','10:10:00',2.06),('8784','2013-10-09','10:15:00',1.42),('8784','2013-10-09','10:25:00',1.05),('8784','2013-10-09','10:30:00',1.22),('8784','2013-10-09','10:35:00',1.32),('8784','2013-10-09','10:40:00',1.38),('8784','2013-10-09','10:45:00',2.16),('8784','2013-10-09','10:50:00',3.85),('8784','2013-10-09','10:55:00',2.83),('8784','2013-10-09','11:00:00',3.06),('8784','2013-10-09','11:05:00',3.85),('8784','2013-10-09','11:10:00',3.89),('8784','2013-10-09','11:15:00',3.8),('8784','2013-10-09','11:20:00',2.52),('8784','2013-10-09','11:25:00',3.43),('8784','2013-10-09','11:30:00',3.89),('8784','2013-10-09','11:35:00',4.11),('8784','2013-10-09','11:40:00',3.7),('8784','2013-10-09','11:45:00',3.61),('8784','2013-10-09','11:50:00',2.87),('8784','2013-10-09','11:55:00',3.44),('8784','2013-10-09','12:00:00',1.64),('8784','2013-10-09','12:05:00',2.4),('8784','2013-10-09','12:10:00',1.77),('8784','2013-10-09','12:15:00',4.27),('8784','2013-10-09','12:20:00',3.89),('8784','2013-10-09','12:25:00',2.62),('8784','2013-10-09','12:30:00',2.09),('8784','2013-10-09','12:35:00',2.43),('8784','2013-10-09','12:40:00',1.47),('8784','2013-10-09','12:55:00',1.18),('8784','2013-10-09','13:10:00',1.18),('8784','2013-10-09','13:15:00',1.5),('8784','2013-10-09','13:20:00',2.25),('8784','2013-10-09','13:25:00',2.62),('8784','2013-10-09','13:30:00',2.32),('8784','2013-10-09','13:35:00',3.22),('8784','2013-10-09','13:40:00',2.45),('8784','2013-10-09','13:45:00',2.16),('8784','2013-10-09','13:50:00',2.44),('8784','2013-10-09','13:55:00',3.93),('8784','2013-10-09','14:00:00',2.28),('8784','2013-10-09','14:05:00',2.32),('8784','2013-10-09','14:10:00',1.04),('8784','2013-10-09','14:55:00',2.44),('8784','2013-10-09','15:00:00',1.45),('8784','2013-10-09','15:05:00',3.19),('8784','2013-10-09','15:10:00',2.87),('8784','2013-10-09','15:15:00',2.82),('8784','2013-10-09','15:20:00',2.46),('8784','2013-10-09','15:25:00',2.52),('8784','2013-10-09','15:30:00',2.34),('8784','2013-10-09','15:35:00',2.41),('8784','2013-10-09','15:40:00',1.99),('8784','2013-10-09','15:45:00',1.33),('8784','2013-10-09','16:15:00',1.17),('8784','2013-10-09','16:20:00',1.57),('8784','2013-10-09','16:25:00',1.76),('8784','2013-10-09','16:30:00',1.83),('8784','2013-10-09','16:35:00',1.47),('8784','2013-10-09','16:40:00',1.38),('8784','2013-10-09','17:35:00',1.13),('8784','2014-04-15','09:00:00',1.85),('8784','2014-04-15','09:05:00',1.64),('8784','2014-04-15','09:10:00',1.74),('8784','2014-04-15','09:15:00',2.33),('8784','2014-04-15','09:20:00',2.78),('8784','2014-04-15','09:25:00',2.99),('8784','2014-04-15','09:30:00',1.91),('8784','2014-04-15','09:35:00',1.06),('8784','2014-04-15','09:45:00',1.34),('8784','2014-04-15','09:50:00',2.41),('8784','2014-04-15','09:55:00',1.16),('8784','2014-04-15','10:00:00',1.75),('8784','2014-04-15','10:05:00',1.96),('8784','2014-04-15','10:10:00',2.36),('8784','2014-04-15','10:15:00',1.96),('8784','2014-04-15','10:20:00',2.22),('8784','2014-04-15','10:25:00',2.47),('8784','2014-04-15','10:30:00',3.81),('8784','2014-04-15','10:35:00',2.05),('8784','2014-04-15','10:40:00',2.85),('8784','2014-04-15','10:45:00',3.01),('8784','2014-04-15','10:50:00',2.64),('8784','2014-04-15','10:55:00',1.83),('8784','2014-04-15','11:00:00',2.37),('8784','2014-04-15','11:05:00',3.4),('8784','2014-04-15','11:10:00',1.86),('8784','2014-04-15','11:15:00',1.55),('8784','2014-04-15','11:20:00',1.19),('8784','2014-04-15','11:25:00',1.75),('8784','2014-04-15','11:30:00',1.31),('8784','2014-04-15','11:35:00',1.04),('8784','2014-04-15','11:45:00',1.2),('8784','2014-04-15','11:50:00',1.49),('8784','2014-04-15','11:55:00',1.11),('8784','2014-04-15','12:10:00',1.07),('8784','2014-04-15','12:15:00',1.74),('8784','2014-04-15','12:20:00',1.81),('8784','2014-04-15','13:05:00',1.13),('8784','2014-04-15','13:10:00',1.52),('8784','2014-04-15','13:15:00',2.52),('8784','2014-04-15','13:20:00',2.75),('8784','2014-04-15','13:25:00',2.3),('8784','2014-04-15','13:30:00',2.77),('8784','2014-04-15','13:35:00',3.32),('8784','2014-04-15','13:40:00',1.83),('8784','2014-04-15','14:00:00',3.59),('8784','2014-04-15','14:05:00',1.63),('8784','2014-04-15','14:10:00',2.99),('8784','2014-04-15','14:15:00',2.66),('8784','2014-04-15','14:20:00',3.89),('8784','2014-04-15','14:25:00',3.38),('8784','2014-04-15','14:30:00',2.3),('8784','2014-04-15','14:35:00',1.57),('8784','2014-04-15','14:40:00',2.51),('8784','2014-04-15','14:45:00',3.01),('8784','2014-04-15','14:50:00',2.17),('8784','2014-04-15','14:55:00',1.49),('8784','2014-04-15','15:05:00',1.03),('8784','2014-04-15','15:10:00',1.21),('8784','2014-04-15','15:15:00',1.79),('8784','2014-04-15','15:20:00',2.27),('8784','2014-04-15','15:25:00',2.03),('8784','2014-04-15','15:30:00',1.7),('8784','2014-04-15','15:35:00',1.57),('8784','2014-04-15','15:40:00',1.58),('8784','2014-04-15','15:45:00',1.48),('8784','2014-04-15','15:50:00',1.49),('8784','2014-04-15','15:55:00',1.52),('8784','2014-04-15','16:00:00',1.66),('8784','2014-04-15','16:05:00',1.7),('8784','2013-10-08','08:15:00',1.2),('8784','2013-10-08','08:20:00',1.19),('8784','2013-10-08','10:05:00',1.03),('8784','2013-10-08','10:55:00',1.38),('8784','2013-10-08','11:00:00',1.78),('8784','2013-10-08','11:05:00',1.37),('8784','2013-10-08','11:10:00',2.05),('8784','2013-10-08','11:15:00',2.96),('8784','2013-10-08','11:20:00',3.83),('8784','2013-10-08','11:25:00',2.07),('8784','2013-10-08','11:30:00',2.45),('8784','2013-10-08','11:35:00',2.24),('8784','2013-10-08','11:40:00',1.63),('8784','2013-10-08','11:45:00',1.46),('8784','2013-10-08','12:20:00',1.19),('8784','2013-10-08','12:25:00',1.61),('8784','2013-10-08','12:30:00',2.48),('8784','2013-10-08','12:35:00',2.16),('8784','2013-10-08','12:40:00',3.94),('8784','2013-10-08','12:45:00',3.97),('8784','2013-10-08','12:50:00',3.25),('8784','2013-10-08','12:55:00',3.76),('8784','2013-10-08','13:00:00',3.69),('8784','2013-10-08','13:05:00',2.72),('8784','2013-10-08','13:10:00',1.77),('8784','2013-10-08','13:15:00',2.89),('8784','2013-10-08','13:20:00',1.52),('8784','2013-10-08','13:25:00',2.91),('8784','2013-10-08','13:30:00',1.96),('8784','2013-10-08','13:35:00',1.42),('8784','2013-10-08','13:40:00',1.21),('8784','2013-10-08','14:05:00',1.52),('8784','2013-10-08','14:10:00',1.93),('8784','2013-10-08','14:15:00',2.35),('8784','2013-10-08','14:20:00',2.64),('8784','2013-10-08','14:25:00',2.84),('8784','2013-10-08','14:30:00',2.55),('8784','2013-10-08','14:35:00',1.34),('8784','2013-10-08','14:40:00',1.5),('8784','2013-10-08','14:45:00',2.93),('8784','2013-10-08','14:50:00',3.12),('8784','2013-10-08','14:55:00',2.86),('8784','2013-10-08','15:00:00',2.76),('8784','2013-10-08','15:05:00',2.63),('8784','2013-10-08','15:10:00',2.79),('8784','2013-10-08','15:15:00',2.64),('8784','2013-10-08','15:20:00',2.46),('8784','2013-10-08','15:25:00',3.16),('8784','2013-10-08','15:30:00',3.16),('8784','2013-10-08','15:35:00',2.69),('8784','2013-10-08','15:40:00',1.73),('8784','2013-10-08','15:45:00',1.08),('8784','2013-10-08','15:50:00',2.13),('8784','2013-10-08','15:55:00',1.31),('8784','2013-10-08','16:00:00',1.09),('8784','2013-10-07','08:35:00',1.03),('8784','2013-10-07','08:40:00',1.06),('8784','2013-10-07','09:00:00',1.59),('8784','2013-10-07','09:05:00',1.65),('8784','2013-10-07','09:10:00',1.61),('8784','2013-10-07','09:15:00',1.65),('8784','2013-10-07','09:20:00',1.71),('8784','2013-10-07','09:25:00',1.8),('8784','2013-10-07','09:30:00',1.86),('8784','2013-10-07','09:35:00',1.95),('8784','2013-10-07','09:40:00',1.99),('8784','2013-10-07','09:45:00',2.08),('8784','2013-10-07','09:50:00',2.16),('8784','2013-10-07','09:55:00',2.22),('8784','2013-10-07','10:00:00',2.29),('8784','2013-10-07','10:05:00',2.36),('8784','2013-10-07','10:10:00',2.38),('8784','2013-10-07','10:15:00',2.44),('8784','2013-10-07','10:20:00',2.5),('8784','2013-10-07','10:25:00',2.28),('8784','2013-10-07','10:30:00',2.66),('8784','2013-10-07','10:35:00',2.87),('8784','2013-10-07','10:40:00',2.79),('8784','2013-10-07','10:45:00',2.82),('8784','2013-10-07','10:50:00',2.88),('8784','2013-10-07','10:55:00',2.83),('8784','2013-10-07','11:00:00',3),('8784','2013-10-07','11:05:00',3.06),('8784','2013-10-07','11:10:00',1.94),('8784','2013-10-07','11:15:00',2.63),('8784','2013-10-07','11:20:00',2.65),('8784','2013-10-07','11:25:00',3.16),('8784','2013-10-07','11:30:00',3.16),('8784','2013-10-07','11:35:00',3.19),('8784','2013-10-07','11:40:00',3.17),('8784','2013-10-07','11:45:00',3.24),('8784','2013-10-07','11:50:00',3.28),('8784','2013-10-07','11:55:00',3.32),('8784','2013-10-07','12:00:00',3.32),('8784','2013-10-07','12:05:00',3.41),('8784','2013-10-07','12:10:00',3.63),('8784','2013-10-07','12:15:00',1.67),('8784','2013-10-07','12:20:00',2.01),('8784','2013-10-07','12:25:00',4.04),('8784','2013-10-07','12:30:00',3.85),('8784','2013-10-07','12:35:00',3.62),('8784','2013-10-07','12:40:00',2.76),('8784','2013-10-07','12:45:00',3.67),('8784','2013-10-07','12:50:00',2.49),('8784','2013-10-07','12:55:00',3.79),('8784','2013-10-07','13:00:00',3.7),('8784','2013-10-07','13:05:00',3.68),('8784','2013-10-07','13:10:00',3.81),('8784','2013-10-07','13:15:00',3.77),('8784','2013-10-07','13:20:00',3.09),('8784','2013-10-07','13:25:00',1.49),('8784','2013-10-07','13:30:00',1.53),('8784','2013-10-07','13:35:00',2.29),('8784','2013-10-07','13:40:00',3.63),('8784','2013-10-07','13:45:00',1.37),('8784','2013-10-07','13:50:00',2.26),('8784','2013-10-07','13:55:00',3.69),('8784','2013-10-07','14:00:00',2.84),('8784','2013-10-07','14:05:00',1.83),('8784','2013-10-07','14:10:00',1.27),('8784','2013-10-07','14:15:00',1.15),('8784','2013-10-07','14:20:00',1.6),('8784','2013-10-07','14:30:00',2.71),('8784','2013-10-07','14:35:00',3.76),('8784','2013-10-07','14:40:00',2.31),('8784','2013-10-07','14:45:00',3.14),('8784','2013-10-07','14:50:00',3.49),('8784','2013-10-07','14:55:00',3.43),('8784','2013-10-07','15:00:00',2.68),('8784','2013-10-07','15:05:00',2.31),('8784','2013-10-07','15:10:00',2.36),('8784','2013-10-07','15:15:00',1.82),('8784','2013-10-07','15:20:00',1.28),('8784','2013-10-07','15:25:00',2.89),('8784','2013-10-07','15:30:00',1.32),('8784','2013-10-07','15:35:00',1.03),('8784','2013-10-07','15:40:00',1.67),('8784','2013-10-07','15:45:00',2.91),('8784','2013-10-07','15:50:00',2.25),('8784','2013-10-07','16:00:00',1.04),('8784','2013-10-07','16:05:00',2.13),('8784','2013-10-07','16:10:00',2.28),('8784','2013-10-07','16:15:00',2.07),('8784','2013-10-07','16:20:00',1.96),('8784','2013-10-07','16:25:00',1.9),('8784','2013-10-07','16:30:00',1.11),('8784','2013-10-07','16:35:00',1.45),('8784','2013-10-07','16:40:00',1.56),('8784','2013-10-07','16:45:00',1.52),('8784','2013-10-07','16:50:00',1.41),('8784','2013-10-07','16:55:00',1.27),('8784','2013-10-07','17:00:00',1.13),('8784','2013-10-07','17:05:00',1.03),('8784','2013-10-06','09:05:00',1.21),('8784','2013-10-06','09:30:00',1.22),('8784','2013-10-06','09:35:00',1.5),('8784','2013-10-06','09:40:00',1.34),('8784','2013-10-06','09:45:00',1.18),('8784','2013-10-06','09:50:00',2.08),('8784','2013-10-06','09:55:00',2.44),('8784','2013-10-06','10:00:00',2.81),('8784','2013-10-06','10:05:00',2.89),('8784','2013-10-06','10:10:00',2.82),('8784','2013-10-06','10:15:00',2.6),('8784','2013-10-06','10:20:00',2.66),('8784','2013-10-06','10:25:00',2.95),('8784','2013-10-06','10:30:00',2.87),('8784','2013-10-06','10:35:00',2.82),('8784','2013-10-06','10:40:00',2.42),('8784','2013-10-06','10:45:00',1.91),('8784','2013-10-06','10:50:00',2.26),('8784','2013-10-06','10:55:00',2.32),('8784','2013-10-06','11:00:00',2.47),('8784','2013-10-06','11:05:00',2.71),('8784','2013-10-06','11:10:00',2.76),('8784','2013-10-06','11:15:00',2.71),('8784','2013-10-06','11:20:00',2.82),('8784','2013-10-06','11:25:00',2.88),('8784','2013-10-06','11:30:00',2.81),('8784','2013-10-06','11:35:00',2.59),('8784','2013-10-06','11:40:00',2.17),('8784','2013-10-06','11:45:00',2.08),('8784','2013-10-06','11:50:00',1.88),('8784','2013-10-06','11:55:00',2.19),('8784','2013-10-06','12:00:00',2.56),('8784','2013-10-06','12:05:00',2.23),('8784','2013-10-06','12:10:00',3.3),('8784','2013-10-06','12:15:00',3.11),('8784','2013-10-06','12:20:00',3.09),('8784','2013-10-06','12:25:00',2.4),('8784','2013-10-06','12:30:00',2.49),('8784','2013-10-06','12:35:00',2.63),('8784','2013-10-06','12:40:00',2.53),('8784','2013-10-06','12:45:00',2.57),('8784','2013-10-06','12:50:00',2.74),('8784','2013-10-06','12:55:00',2.93),('8784','2013-10-06','13:00:00',3.28),('8784','2013-10-06','13:05:00',3.15),('8784','2013-10-06','13:10:00',3.02),('8784','2013-10-06','13:15:00',3.77),('8784','2013-10-06','13:20:00',2.19),('8784','2013-10-06','13:25:00',1.12),('8784','2013-10-06','13:45:00',1.58),('8784','2013-10-06','13:50:00',3.43),('8784','2013-10-06','13:55:00',3.56),('8784','2013-10-06','14:00:00',2.52),('8784','2013-10-06','14:05:00',1.97),('8784','2013-10-06','14:10:00',1.64),('8784','2013-10-06','14:15:00',1.48),('8784','2013-10-06','14:20:00',1.71),('8784','2013-10-06','14:25:00',1.77),('8784','2013-10-06','14:30:00',2.59),('8784','2013-10-06','14:35:00',2.19),('8784','2013-10-06','14:40:00',2.11),('8784','2013-10-06','14:45:00',1.69),('8784','2013-10-06','14:50:00',1.83),('8784','2013-10-06','14:55:00',2.52),('8784','2013-10-06','15:00:00',2.11),('8784','2013-10-06','15:05:00',1.49),('8784','2013-10-06','15:10:00',1.23),('8784','2013-10-06','15:15:00',1.21),('8784','2013-10-06','15:20:00',1.05),('8784','2013-10-06','15:55:00',1.14),('8784','2013-10-06','16:00:00',1.16),('8784','2013-10-05','16:00:00',1.07),('8784','2013-10-05','16:05:00',1.29),('8784','2013-10-05','16:10:00',1.25),('8784','2013-10-05','16:15:00',1.14),('8784','2013-10-05','16:20:00',1.16),('8784','2013-10-05','16:25:00',1.12),('8784','2013-10-04','09:25:00',1.05),('8784','2013-10-04','09:30:00',1.14),('8784','2013-10-04','09:35:00',1.21),('8784','2013-10-04','09:40:00',1.21),('8784','2013-10-04','09:45:00',1.19),('8784','2013-10-04','09:50:00',1.45),('8784','2013-10-04','09:55:00',2.83),('8784','2013-10-04','10:00:00',2.1),('8784','2013-10-04','10:05:00',1.52),('8784','2013-10-04','10:10:00',1.57),('8784','2013-10-04','10:15:00',1.78),('8784','2013-10-04','10:20:00',1.54),('8784','2013-10-04','10:25:00',1.76),('8784','2013-10-04','10:30:00',2.55),('8784','2013-10-04','10:35:00',2.16),('8784','2013-10-04','10:40:00',2.44),('8784','2013-10-04','10:45:00',2.18),('8784','2013-10-04','10:50:00',1.95),('8784','2013-10-04','10:55:00',2.71),('8784','2013-10-04','11:00:00',2.18),('8784','2013-10-04','11:05:00',1.73),('8784','2013-10-04','11:10:00',1.93),('8784','2013-10-04','11:15:00',3.04),('8784','2013-10-04','11:20:00',3),('8784','2013-10-04','11:25:00',2.83),('8784','2013-10-04','11:30:00',3.72),('8784','2013-10-04','11:35:00',3.5),('8784','2013-10-04','11:40:00',3.47),('8784','2013-10-04','11:45:00',3.47),('8784','2013-10-04','11:50:00',3.43),('8784','2013-10-04','11:55:00',3.44),('8784','2013-10-04','12:00:00',3.46),('8784','2013-10-04','12:05:00',3.48),('8784','2013-10-04','12:10:00',3.5),('8784','2013-10-04','12:15:00',3.25),('8784','2013-10-04','12:20:00',3.45),('8784','2013-10-04','12:25:00',3.57),('8784','2013-10-04','12:30:00',3.7),('8784','2013-10-04','12:35:00',3.37),('8784','2013-10-04','12:40:00',3.46),('8784','2013-10-04','12:45:00',3.48),('8784','2013-10-04','12:50:00',3.41),('8784','2013-10-04','12:55:00',3.4),('8784','2013-10-04','13:00:00',3.42),('8784','2013-10-04','13:05:00',3.48),('8784','2013-10-04','13:10:00',3.52),('8784','2013-10-04','13:15:00',3.69),('8784','2013-10-04','13:20:00',3.59),('8784','2013-10-04','13:25:00',3.33),('8784','2013-10-04','13:30:00',3.58),('8784','2013-10-04','13:35:00',3.58),('8784','2013-10-04','13:40:00',3.33),('8784','2013-10-04','13:45:00',3.32),('8784','2013-10-04','13:50:00',3.29),('8784','2013-10-04','13:55:00',3.25),('8784','2013-10-04','14:00:00',3.25),('8784','2013-10-04','14:05:00',3.21),('8784','2013-10-04','14:10:00',2.93),('8784','2013-10-04','14:15:00',2.46),('8784','2013-10-04','14:20:00',2.95),('8784','2013-10-04','14:25:00',3.09),('8784','2013-10-04','14:30:00',2.68),('8784','2013-10-04','14:35:00',1.91),('8784','2013-10-04','14:40:00',1.61),('8784','2013-10-04','14:45:00',1.94),('8784','2013-10-04','14:50:00',2.47),('8784','2013-10-04','14:55:00',2.43),('8784','2013-10-04','15:00:00',2.08),('8784','2013-10-04','15:05:00',2.33),('8784','2013-10-04','15:10:00',1.92),('8784','2013-10-04','15:15:00',1.56),('8784','2013-10-04','15:20:00',1.39),('8784','2013-10-04','15:25:00',2.51),('8784','2013-10-04','15:30:00',2.16),('8784','2013-10-04','15:35:00',1.24),('8784','2013-10-04','16:00:00',1.15),('8784','2013-10-04','16:05:00',1.19),('8784','2013-10-04','16:10:00',1.1),('8784','2013-10-03','08:30:00',1.05),('8784','2013-10-03','08:35:00',1.13),('8784','2013-10-03','08:40:00',1.21),('8784','2013-10-03','08:45:00',1.3),('8784','2013-10-03','08:50:00',1.39),('8784','2013-10-03','08:55:00',1.48),('8784','2013-10-03','09:00:00',1.57),('8784','2013-10-03','09:05:00',1.65),('8784','2013-10-03','09:10:00',1.74),('8784','2013-10-03','09:15:00',1.83),('8784','2013-10-03','09:20:00',1.91),('8784','2013-10-03','09:25:00',1.99),('8784','2013-10-03','09:30:00',2.08),('8784','2013-10-03','09:35:00',2.16),('8784','2013-10-03','09:40:00',2.24),('8784','2013-10-03','09:45:00',2.31),('8784','2013-10-03','09:50:00',2.39),('8784','2013-10-03','09:55:00',2.47),('8784','2013-10-03','10:00:00',2.54),('8784','2013-10-03','10:05:00',2.61),('8784','2013-10-03','10:10:00',2.68),('8784','2013-10-03','10:15:00',2.74),('8784','2013-10-03','10:20:00',2.8),('8784','2013-10-03','10:25:00',2.87),('8784','2013-10-03','10:30:00',2.91),('8784','2013-10-03','10:35:00',2.99),('8784','2013-10-03','10:40:00',3.05),('8784','2013-10-03','10:45:00',3.1),('8784','2013-10-03','10:50:00',3.14),('8784','2013-10-03','10:55:00',3.19),('8784','2013-10-03','11:00:00',3.18),('8784','2013-10-03','11:05:00',3.26),('8784','2013-10-03','11:10:00',3.32),('8784','2013-10-03','11:15:00',3.35),('8784','2013-10-03','11:20:00',3.4),('8784','2013-10-03','11:25:00',3.44),('8784','2013-10-03','11:30:00',3.47),('8784','2013-10-03','11:35:00',3.5),('8784','2013-10-03','11:40:00',3.54),('8784','2013-10-03','11:45:00',3.56),('8784','2013-10-03','11:50:00',3.6),('8784','2013-10-03','11:55:00',3.63),('8784','2013-10-03','12:00:00',3.64),('8784','2013-10-03','12:05:00',3.66),('8784','2013-10-03','12:10:00',3.67),('8784','2013-10-03','12:15:00',3.66),('8784','2013-10-03','12:20:00',3.67),('8784','2013-10-03','12:25:00',3.68),('8784','2013-10-03','12:30:00',3.7),('8784','2013-10-03','12:35:00',3.71),('8784','2013-10-03','12:40:00',3.69),('8784','2013-10-03','12:45:00',3.68),('8784','2013-10-03','12:50:00',3.68),('8784','2013-10-03','12:55:00',3.69),('8784','2013-10-03','13:00:00',3.68),('8784','2013-10-03','13:05:00',3.61),('8784','2013-10-03','13:10:00',3.66),('8784','2013-10-03','13:15:00',3.64),('8784','2013-10-03','13:20:00',3.62),('8784','2013-10-03','13:25:00',3.61),('8784','2013-10-03','13:30:00',3.62),('8784','2013-10-03','13:35:00',3.62),('8784','2013-10-03','13:40:00',3.6),('8784','2013-10-03','13:45:00',3.57),('8784','2013-10-03','13:50:00',3.54),('8784','2013-10-03','13:55:00',3.51),('8784','2013-10-03','14:00:00',3.5),('8784','2013-10-03','14:05:00',3.45),('8784','2013-10-03','14:10:00',3.45),('8784','2013-10-03','14:15:00',3.41),('8784','2013-10-03','14:20:00',3.37),('8784','2013-10-03','14:25:00',3.32),('8784','2013-10-03','14:30:00',3.3),('8784','2013-10-03','14:35:00',3.26),('8784','2013-10-03','14:40:00',3.2),('8784','2013-10-03','14:45:00',3.16),('8784','2013-10-03','14:50:00',3.11),('8784','2013-10-03','14:55:00',3.05),('8784','2013-10-03','15:00:00',2.99),('8784','2013-10-03','15:05:00',2.95),('8784','2013-10-03','15:10:00',2.89),('8784','2013-10-03','15:15:00',2.83),('8784','2013-10-03','15:20:00',2.77),('8784','2013-10-03','15:25:00',2.71),('8784','2013-10-03','15:30:00',2.65),('8784','2013-10-03','15:35:00',2.58),('8784','2013-10-03','15:40:00',2.51),('8784','2013-10-03','15:45:00',2.43),('8784','2013-10-03','15:50:00',2.34),('8784','2013-10-03','15:55:00',2.29),('8784','2013-10-03','16:00:00',2.21),('8784','2013-10-03','16:05:00',2.13),('8784','2013-10-03','16:10:00',2.06),('8784','2013-10-03','16:15:00',1.97),('8784','2013-10-03','16:20:00',1.88),('8784','2013-10-03','16:25:00',1.81),('8784','2013-10-03','16:30:00',1.73),('8784','2013-10-03','16:35:00',1.66),('8784','2013-10-03','16:40:00',1.56),('8784','2013-10-03','16:45:00',1.48),('8784','2013-10-03','16:50:00',1.4),('8784','2013-10-03','16:55:00',1.31),('8784','2013-10-03','17:00:00',1.22),('8784','2013-10-03','17:05:00',1.14),('8784','2013-10-03','17:10:00',1.06),('8784','2013-10-02','08:30:00',1.04),('8784','2013-10-02','08:35:00',1.07),('8784','2013-10-02','08:40:00',1.13),('8784','2013-10-02','08:45:00',1.22),('8784','2013-10-02','08:50:00',1.31),('8784','2013-10-02','08:55:00',1.4),('8784','2013-10-02','09:00:00',1.49),('8784','2013-10-02','09:05:00',1.57),('8784','2013-10-02','09:10:00',1.66),('8784','2013-10-02','09:15:00',1.74),('8784','2013-10-02','09:20:00',1.82),('8784','2013-10-02','09:25:00',1.9),('8784','2013-10-02','09:30:00',1.98),('8784','2013-10-02','09:35:00',2.06),('8784','2013-10-02','09:40:00',2.13),('8784','2013-10-02','09:45:00',2.17),('8784','2013-10-02','09:50:00',2.27),('8784','2013-10-02','09:55:00',2.34),('8784','2013-10-02','10:00:00',1.78),('8784','2013-10-02','10:05:00',2.45),('8784','2013-10-02','10:10:00',2.5),('8784','2013-10-02','10:15:00',2.57),('8784','2013-10-02','10:20:00',2.64),('8784','2013-10-02','10:25:00',2.71),('8784','2013-10-02','10:30:00',2.77),('8784','2013-10-02','10:35:00',2.83),('8784','2013-10-02','10:40:00',2.9),('8784','2013-10-02','10:45:00',2.97),('8784','2013-10-02','10:50:00',3.02),('8784','2013-10-02','10:55:00',3.07),('8784','2013-10-02','11:00:00',3.12),('8784','2013-10-02','11:05:00',3.16),('8784','2013-10-02','11:10:00',3.2),('8784','2013-10-02','11:15:00',3.21),('8784','2013-10-02','11:20:00',3.28),('8784','2013-10-02','11:25:00',3.3),('8784','2013-10-02','11:30:00',3.33),('8784','2013-10-02','11:35:00',3.36),('8784','2013-10-02','11:40:00',3.38),('8784','2013-10-02','11:45:00',3.41),('8784','2013-10-02','11:50:00',3.45),('8784','2013-10-02','11:55:00',3.48),('8784','2013-10-02','12:00:00',3.49),('8784','2013-10-02','12:05:00',3.51),('8784','2013-10-02','12:10:00',3.53),('8784','2013-10-02','12:15:00',3.55),('8784','2013-10-02','12:20:00',3.56),('8784','2013-10-02','12:25:00',3.56),('8784','2013-10-02','12:30:00',3.56),('8784','2013-10-02','12:35:00',3.56),('8784','2013-10-02','12:40:00',3.56),('8784','2013-10-02','12:45:00',3.56),('8784','2013-10-02','12:50:00',3.58),('8784','2013-10-02','12:55:00',3.58),('8784','2013-10-02','13:00:00',3.56),('8784','2013-10-02','13:05:00',3.53),('8784','2013-10-02','13:10:00',3.56),('8784','2013-10-02','13:15:00',3.56),('8784','2013-10-02','13:20:00',3.54),('8784','2013-10-02','13:25:00',3.53),('8784','2013-10-02','13:30:00',3.52),('8784','2013-10-02','13:35:00',3.51),('8784','2013-10-02','13:40:00',3.51),('8784','2013-10-02','13:45:00',3.48),('8784','2013-10-02','13:50:00',3.44),('8784','2013-10-02','13:55:00',3.41),('8784','2013-10-02','14:00:00',3.39),('8784','2013-10-02','14:05:00',3.38),('8784','2013-10-02','14:10:00',3.35),('8784','2013-10-02','14:15:00',3.3),('8784','2013-10-02','14:20:00',3.24),('8784','2013-10-02','14:25:00',3.23),('8784','2013-10-02','14:30:00',3.2),('8784','2013-10-02','14:35:00',3.15),('8784','2013-10-02','14:40:00',3.11),('8784','2013-10-02','14:45:00',3.06),('8784','2013-10-02','14:50:00',3.02),('8784','2013-10-02','14:55:00',2.98),('8784','2013-10-02','15:00:00',2.93),('8784','2013-10-02','15:05:00',2.88),('8784','2013-10-02','15:10:00',2.81),('8784','2013-10-02','15:15:00',2.77),('8784','2013-10-02','15:20:00',2.71),('8784','2013-10-02','15:25:00',2.64),('8784','2013-10-02','15:30:00',2.58),('8784','2013-10-02','15:35:00',2.52),('8784','2013-10-02','15:40:00',2.45),('8784','2013-10-02','15:45:00',2.39),('8784','2013-10-02','15:50:00',2.32),('8784','2013-10-02','15:55:00',2.26),('8784','2013-10-02','16:00:00',2.17),('8784','2013-10-02','16:05:00',2.09),('8784','2013-10-02','16:10:00',2.02),('8784','2013-10-02','16:15:00',1.94),('8784','2013-10-02','16:20:00',1.86),('8784','2013-10-02','16:25:00',1.78),('8784','2013-10-02','16:30:00',1.7),('8784','2013-10-02','16:35:00',1.63),('8784','2013-10-02','16:40:00',1.55),('8784','2013-10-02','16:45:00',1.47),('8784','2013-10-02','16:50:00',1.39),('8784','2013-10-02','16:55:00',1.3),('8784','2013-10-02','17:00:00',1.22),('8784','2013-10-02','17:05:00',1.14),('8784','2013-10-02','17:10:00',1.05),('8784','2013-10-01','08:30:00',1.04),('8784','2013-10-01','08:35:00',1.09),('8784','2013-10-01','08:40:00',1.17),('8784','2013-10-01','08:45:00',1.26),('8784','2013-10-01','08:50:00',1.36),('8784','2013-10-01','08:55:00',1.42),('8784','2013-10-01','09:00:00',1.51),('8784','2013-10-01','09:05:00',1.58),('8784','2013-10-01','09:10:00',1.68),('8784','2013-10-01','09:15:00',1.7),('8784','2013-10-01','09:20:00',1.69),('8784','2013-10-01','09:25:00',1.84),('8784','2013-10-01','09:30:00',1.91),('8784','2013-10-01','09:35:00',2.01),('8784','2013-10-01','09:40:00',2.11),('8784','2013-10-01','09:45:00',2.16),('8784','2013-10-01','09:50:00',2.24),('8784','2013-10-01','09:55:00',2.29),('8784','2013-10-01','10:00:00',2.36),('8784','2013-10-01','10:05:00',2.42),('8784','2013-10-01','10:10:00',2.46),('8784','2013-10-01','10:15:00',2.54),('8784','2013-10-01','10:20:00',2.62),('8784','2013-10-01','10:25:00',2.69),('8784','2013-10-01','10:30:00',2.75),('8784','2013-10-01','10:35:00',2.8),('8784','2013-10-01','10:40:00',2.84),('8784','2013-10-01','10:45:00',2.91),('8784','2013-10-01','10:50:00',2.97),('8784','2013-10-01','10:55:00',3.06),('8784','2013-10-01','11:00:00',3.12),('8784','2013-10-01','11:05:00',3.37),('8784','2013-10-01','11:10:00',3.61),('8784','2013-10-01','11:15:00',3.63),('8784','2013-10-01','11:20:00',2.44),('8784','2013-10-01','11:25:00',1.07),('8784','2013-10-01','11:30:00',2.05),('8784','2013-10-01','11:35:00',3.65),('8784','2013-10-01','11:40:00',3.54),('8784','2013-10-01','11:45:00',3.56),('8784','2013-10-01','11:50:00',2.87),('8784','2013-10-01','11:55:00',1.82),('8784','2013-10-01','12:00:00',2.74),('8784','2013-10-01','12:05:00',2.95),('8784','2013-10-01','12:10:00',3.64),('8784','2013-10-01','12:15:00',3.69),('8784','2013-10-01','12:20:00',3.77),('8784','2013-10-01','12:25:00',3.5),('8784','2013-10-01','12:30:00',3.25),('8784','2013-10-01','12:35:00',1.29),('8784','2013-10-01','12:40:00',1.13),('8784','2013-10-01','12:45:00',3.72),('8784','2013-10-01','12:50:00',1.8),('8784','2013-10-01','12:55:00',1.75),('8784','2013-10-01','13:00:00',3.84),('8784','2013-10-01','13:05:00',3.13),('8784','2013-10-01','13:10:00',1.04),('8784','2013-10-01','13:15:00',1.95),('8784','2013-10-01','13:20:00',3.96),('8784','2013-10-01','13:25:00',2.51),('8784','2013-10-01','13:30:00',1.53),('8784','2013-10-01','13:35:00',4.09),('8784','2013-10-01','13:40:00',3.9),('8784','2013-10-01','13:45:00',3.79),('8784','2013-10-01','13:50:00',3.51),('8784','2013-10-01','13:55:00',3.51),('8784','2013-10-01','14:00:00',3.35),('8784','2013-10-01','14:05:00',3.32),('8784','2013-10-01','14:10:00',3.26),('8784','2013-10-01','14:15:00',3.21),('8784','2013-10-01','14:20:00',3.22),('8784','2013-10-01','14:25:00',3.1),('8784','2013-10-01','14:30:00',3.14),('8784','2013-10-01','14:35:00',3.16),('8784','2013-10-01','14:40:00',2.96),('8784','2013-10-01','14:45:00',3.15),('8784','2013-10-01','14:50:00',3.18),('8784','2013-10-01','14:55:00',3.1),('8784','2013-10-01','15:00:00',3.01),('8784','2013-10-01','15:05:00',2.91),('8784','2013-10-01','15:10:00',2.82),('8784','2013-10-01','15:15:00',2.78),('8784','2013-10-01','15:20:00',2.72),('8784','2013-10-01','15:25:00',2.66),('8784','2013-10-01','15:30:00',2.61),('8784','2013-10-01','15:35:00',2.51),('8784','2013-10-01','15:40:00',2.48),('8784','2013-10-01','15:45:00',2.41),('8784','2013-10-01','15:50:00',2.34),('8784','2013-10-01','15:55:00',2.26),('8784','2013-10-01','16:00:00',2.18),('8784','2013-10-01','16:05:00',2.13),('8784','2013-10-01','16:10:00',2.04),('8784','2013-10-01','16:15:00',1.97),('8784','2013-10-01','16:20:00',1.89),('8784','2013-10-01','16:25:00',1.82),('8784','2013-10-01','16:30:00',1.74),('8784','2013-10-01','16:35:00',1.65),('8784','2013-10-01','16:40:00',1.55),('8784','2013-10-01','16:45:00',1.48),('8784','2013-10-01','16:50:00',1.41),('8784','2013-10-01','16:55:00',1.32),('8784','2013-10-01','17:00:00',1.25),('8784','2013-10-01','17:05:00',1.17),('8784','2013-10-01','17:10:00',1.09),('8784','2013-09-30','09:45:00',1.01),('8784','2013-09-30','09:50:00',1.28),('8784','2013-09-30','09:55:00',1.11),('8784','2013-09-30','10:00:00',1.06),('8784','2013-09-30','10:05:00',1.05),('8784','2013-09-30','10:10:00',1.15),('8784','2013-09-30','10:15:00',1.17),('8784','2013-09-30','10:20:00',1.18),('8784','2013-09-30','10:25:00',1.34),('8784','2013-09-30','10:30:00',1.51),('8784','2013-09-30','10:35:00',1.66),('8784','2013-09-30','10:40:00',2.15),('8784','2013-09-30','10:45:00',3.08),('8784','2013-09-30','10:50:00',3.19),('8784','2013-09-30','10:55:00',2.93),('8784','2013-09-30','11:00:00',2.11),('8784','2013-09-30','11:05:00',1.87),('8784','2013-09-30','11:10:00',3.2),('8784','2013-09-30','11:15:00',2.22),('8784','2013-09-30','11:20:00',3.26),('8784','2013-09-30','11:25:00',2),('8784','2013-09-30','11:30:00',2.22),('8784','2013-09-30','11:35:00',1.73),('8784','2013-09-30','11:40:00',3.97),('8784','2013-09-30','11:45:00',1.93),('8784','2013-09-30','11:50:00',1.6),('8784','2013-09-30','11:55:00',1.38),('8784','2013-09-30','12:00:00',1.55),('8784','2013-09-30','12:05:00',1.02),('8784','2013-09-30','12:10:00',1.76),('8784','2013-09-30','12:15:00',3.83),('8784','2013-09-30','12:20:00',3.87),('8784','2013-09-30','12:25:00',3.8),('8784','2013-09-30','12:30:00',3.66),('8784','2013-09-30','12:35:00',3.68),('8784','2013-09-30','12:40:00',3.51),('8784','2013-09-30','12:45:00',3.11),('8784','2013-09-30','12:50:00',3.83),('8784','2013-09-30','12:55:00',3.75),('8784','2013-09-30','13:00:00',3.81),('8784','2013-09-30','13:05:00',3.94),('8784','2013-09-30','13:10:00',3.83),('8784','2013-09-30','13:15:00',3.97),('8784','2013-09-30','13:20:00',4.14),('8784','2013-09-30','13:25:00',4.39),('8784','2013-09-30','13:30:00',4.15),('8784','2013-09-30','13:35:00',3.59),('8784','2013-09-30','13:40:00',3.45),('8784','2013-09-30','13:45:00',1.92),('8784','2013-09-30','13:50:00',3.4),('8784','2013-09-30','13:55:00',2.65),('8784','2013-09-30','14:00:00',1.96),('8784','2013-09-30','14:05:00',1.39),('8784','2013-09-30','14:10:00',1.38),('8784','2013-09-30','14:15:00',1.31),('8784','2013-09-30','14:20:00',1.13),('8784','2013-09-30','14:25:00',1.27),('8784','2013-09-30','14:30:00',2.78),('8784','2013-09-30','14:35:00',2.54),('8784','2013-09-30','14:40:00',3.81),('8784','2013-09-30','14:45:00',3.36),('8784','2013-09-30','14:50:00',2.55),('8784','2013-09-30','14:55:00',2.42),('8784','2013-09-30','15:00:00',2.05),('8784','2013-09-30','15:05:00',2.77),('8784','2013-09-30','15:10:00',3.62),('8784','2013-09-30','15:15:00',2.31),('8784','2013-09-30','15:20:00',1.55),('8784','2013-09-30','15:25:00',2.79),('8784','2013-09-30','15:30:00',1.86),('8784','2013-09-30','15:35:00',3.18),('8784','2013-09-30','15:40:00',3.1),('8784','2013-09-30','15:45:00',1.86),('8784','2013-09-30','16:10:00',1.19),('8784','2013-09-30','16:15:00',1.74),('8784','2013-09-30','16:20:00',1.75),('8784','2013-09-30','16:25:00',1.08),('8784','2013-09-30','16:45:00',1.31),('8784','2013-09-29','08:45:00',1.02),('8784','2013-09-29','08:50:00',1.29),('8784','2013-09-29','08:55:00',1.09),('8784','2013-09-29','09:00:00',1.08),('8784','2013-09-29','09:10:00',1.07),('8784','2013-09-29','09:15:00',1.28),('8784','2013-09-29','09:50:00',1.05),('8784','2013-09-29','09:55:00',1.1),('8784','2013-09-29','10:00:00',1.28),('8784','2013-09-29','10:05:00',1.73),('8784','2013-09-29','10:10:00',2),('8784','2013-09-29','10:15:00',2.51),('8784','2013-09-29','10:20:00',2.08),('8784','2013-09-29','10:25:00',2.01),('8784','2013-09-29','10:30:00',2.3),('8784','2013-09-29','10:35:00',2.45),('8784','2013-09-29','10:40:00',2.46),('8784','2013-09-29','10:45:00',2.58),('8784','2013-09-29','10:50:00',2.7),('8784','2013-09-29','10:55:00',2.72),('8784','2013-09-29','11:00:00',2.77),('8784','2013-09-29','11:05:00',2.66),('8784','2013-09-29','11:10:00',2.7),('8784','2013-09-29','11:15:00',2.9),('8784','2013-09-29','11:20:00',2.82),('8784','2013-09-29','11:25:00',2.69),('8784','2013-09-29','11:30:00',2.91),('8784','2013-09-29','11:35:00',2.88),('8784','2013-09-29','11:40:00',2.93),('8784','2013-09-29','11:45:00',3.09),('8784','2013-09-29','11:50:00',3.18),('8784','2013-09-29','11:55:00',3.24),('8784','2013-09-29','12:00:00',2.9),('8784','2013-09-29','12:05:00',2.45),('8784','2013-09-29','12:10:00',3.35),('8784','2013-09-29','12:15:00',3.67),('8784','2013-09-29','12:20:00',2.09),('8784','2013-09-29','12:25:00',1.85),('8784','2013-09-29','12:30:00',1.96),('8784','2013-09-29','12:35:00',1.87),('8784','2013-09-29','12:40:00',1.66),('8784','2013-09-29','12:45:00',1.47),('8784','2013-09-29','12:50:00',1.46),('8784','2013-09-29','12:55:00',1.3),('8784','2013-09-29','13:00:00',1.26),('8784','2013-09-29','13:05:00',1.11),('8784','2013-09-29','13:10:00',1.15),('8784','2013-09-29','13:20:00',1.03),('8784','2013-09-29','13:25:00',1.49),('8784','2013-09-29','13:30:00',1.86),('8784','2013-09-29','13:35:00',1.96),('8784','2013-09-29','13:40:00',1.78),('8784','2013-09-29','13:45:00',1.62),('8784','2013-09-29','13:50:00',1.76),('8784','2013-09-29','13:55:00',2.07),('8784','2013-09-29','14:00:00',2.03),('8784','2013-09-29','14:05:00',2.27),('8784','2013-09-29','14:10:00',1.38),('8784','2013-09-29','14:15:00',1.78),('8784','2013-09-29','14:20:00',2.58),('8784','2013-09-29','14:25:00',1.53),('8784','2013-09-29','14:30:00',1.56),('8784','2013-09-29','14:35:00',1.31),('8784','2013-09-29','14:40:00',1.02),('8784','2013-09-29','14:50:00',1.02),('8784','2013-09-29','14:55:00',1.09),('8784','2013-09-29','15:00:00',1.27),('8784','2013-09-29','15:20:00',1.02),('8784','2013-09-29','15:55:00',1.04),('8784','2013-09-29','16:00:00',1.23),('8784','2013-09-29','16:05:00',1.02),('8784','2013-09-29','16:30:00',1.24),('8784','2013-09-29','16:35:00',1.11),('8784','2014-04-14','07:55:00',1.08),('8784','2014-04-14','08:00:00',1.16),('8784','2014-04-14','08:05:00',1.23),('8784','2014-04-14','08:10:00',1.33),('8784','2014-04-14','08:15:00',1.41),('8784','2014-04-14','08:20:00',1.51),('8784','2014-04-14','08:25:00',1.6),('8784','2014-04-14','08:30:00',1.7),('8784','2014-04-14','08:35:00',1.79),('8784','2014-04-14','08:40:00',1.87),('8784','2014-04-14','08:45:00',1.96),('8784','2014-04-14','08:50:00',2.04),('8784','2014-04-14','08:55:00',2.13),('8784','2014-04-14','09:00:00',2.23),('8784','2014-04-14','09:05:00',2.3),('8784','2014-04-14','09:10:00',2.36),('8784','2014-04-14','09:15:00',2.46),('8784','2014-04-14','09:20:00',2.54),('8784','2014-04-14','09:25:00',2.63),('8784','2014-04-14','09:30:00',2.7),('8784','2014-04-14','09:35:00',2.77),('8784','2014-04-14','09:40:00',2.84),('8784','2014-04-14','09:45:00',2.9),('8784','2014-04-14','09:50:00',2.98),('8784','2014-04-14','09:55:00',3.07),('8784','2014-04-14','10:00:00',3.13),('8784','2014-04-14','10:05:00',3.18),('8784','2014-04-14','10:10:00',3.24),('8784','2014-04-14','10:15:00',3.33),('8784','2014-04-14','10:20:00',3.37),('8784','2014-04-14','10:25:00',3.43),('8784','2014-04-14','10:30:00',3.51),('8784','2014-04-14','10:35:00',3.57),('8784','2014-04-14','10:40:00',3.61),('8784','2014-04-14','10:45:00',3.63),('8784','2014-04-14','10:50:00',3.71),('8784','2014-04-14','10:55:00',3.75),('8784','2014-04-14','11:00:00',3.8),('8784','2014-04-14','11:05:00',3.81),('8784','2014-04-14','11:10:00',3.89),('8784','2014-04-14','11:15:00',3.92),('8784','2014-04-14','11:20:00',3.95),('8784','2014-04-14','11:25:00',3.95),('8784','2014-04-14','11:30:00',4.04),('8784','2014-04-14','11:35:00',4.07),('8784','2014-04-14','11:40:00',4.1),('8784','2014-04-14','11:45:00',4.12),('8784','2014-04-14','11:50:00',4.12),('8784','2014-04-14','11:55:00',4.17),('8784','2014-04-14','12:00:00',4.17),('8784','2014-04-14','12:05:00',4.21),('8784','2014-04-14','12:10:00',4.18),('8784','2014-04-14','12:15:00',4.25),('8784','2014-04-14','12:20:00',4.27),('8784','2014-04-14','12:25:00',4.25),('8784','2014-04-14','12:30:00',4.21),('8784','2014-04-14','12:35:00',4.29),('8784','2014-04-14','12:40:00',4.27),('8784','2014-04-14','12:45:00',4.3),('8784','2014-04-14','12:50:00',4.3),('8784','2014-04-14','12:55:00',4.35),('8784','2014-04-14','13:00:00',4.35),('8784','2014-04-14','13:05:00',4.3),('8784','2014-04-14','13:10:00',4.26),('8784','2014-04-14','13:15:00',4.33),('8784','2014-04-14','13:20:00',4.34),('8784','2014-04-14','13:25:00',4.34),('8784','2014-04-14','13:30:00',4.31),('8784','2014-04-14','13:35:00',4.34),('8784','2014-04-14','13:40:00',4.33),('8784','2014-04-14','13:45:00',4.31),('8784','2014-04-14','13:50:00',4.32),('8784','2014-04-14','13:55:00',4.32),('8784','2014-04-14','14:00:00',4.28),('8784','2014-04-14','14:05:00',4.29),('8784','2014-04-14','14:10:00',4.26),('8784','2014-04-14','14:15:00',4.24),('8784','2014-04-14','14:20:00',4.22),('8784','2014-04-14','14:25:00',4.19),('8784','2014-04-14','14:30:00',4.17),('8784','2014-04-14','14:35:00',4.13),('8784','2014-04-14','14:40:00',4.1),('8784','2014-04-14','14:45:00',4.07),('8784','2014-04-14','14:50:00',4.04),('8784','2014-04-14','14:55:00',4),('8784','2014-04-14','15:00:00',3.96),('8784','2014-04-14','15:05:00',3.91),('8784','2014-04-14','15:10:00',3.87),('8784','2014-04-14','15:15:00',3.74),('8784','2014-04-14','15:20:00',3.77),('8784','2014-04-14','15:25:00',3.72),('8784','2014-04-14','15:30:00',3.67),('8784','2014-04-14','15:35:00',3.58),('8784','2014-04-14','15:40:00',3.5),('8784','2014-04-14','15:45:00',3.48),('8784','2014-04-14','15:50:00',3.44),('8784','2014-04-14','15:55:00',3.37),('8784','2014-04-14','16:00:00',3.27),('8784','2014-04-14','16:05:00',3.21),('8784','2014-04-14','16:10:00',3.14),('8784','2014-04-14','16:15:00',3.07),('8784','2014-04-14','16:20:00',3.01),('8784','2014-04-14','16:25:00',2.94),('8784','2014-04-14','16:30:00',2.85),('8784','2014-04-14','16:35:00',2.79),('8784','2014-04-14','16:40:00',2.7),('8784','2014-04-14','16:45:00',2.62),('8784','2014-04-14','16:50:00',2.54),('8784','2014-04-14','16:55:00',2.43),('8784','2014-04-14','17:00:00',2.36),('8784','2014-04-14','17:05:00',2.27),('8784','2014-04-14','17:10:00',2.18),('8784','2014-04-14','17:15:00',2.09),('8784','2014-04-14','17:20:00',1.98),('8784','2014-04-14','17:25:00',1.9),('8784','2014-04-14','17:30:00',1.78),('8784','2014-04-14','17:35:00',1.7),('8784','2014-04-14','17:40:00',1.62),('8784','2014-04-14','17:45:00',1.53),('8784','2014-04-14','17:50:00',1.44),('8784','2014-04-14','17:55:00',1.35),('8784','2014-04-14','18:00:00',1.25),('8784','2014-04-14','18:05:00',1.16),('8784','2014-04-14','18:10:00',1.07),('8784','2013-09-28','08:35:00',1.02),('8784','2013-09-28','08:40:00',1.12),('8784','2013-09-28','08:45:00',1.19),('8784','2013-09-28','08:50:00',1.28),('8784','2013-09-28','08:55:00',1.35),('8784','2013-09-28','09:00:00',1.42),('8784','2013-09-28','09:05:00',1.53),('8784','2013-09-28','09:10:00',1.63),('8784','2013-09-28','09:15:00',1.67),('8784','2013-09-28','09:20:00',1.77),('8784','2013-09-28','09:25:00',1.86),('8784','2013-09-28','09:30:00',1.78),('8784','2013-09-28','09:35:00',1.66),('8784','2013-09-28','09:40:00',1.94),('8784','2013-09-28','09:45:00',2.18),('8784','2013-09-28','09:50:00',2.26),('8784','2013-09-28','09:55:00',2.52),('8784','2013-09-28','10:00:00',1.8),('8784','2013-09-28','10:05:00',1.43),('8784','2013-09-28','10:10:00',1.1),('8784','2013-09-28','10:15:00',1.58),('8784','2013-09-28','10:20:00',2.59),('8784','2013-09-28','10:25:00',1.25),('8784','2013-09-28','10:30:00',2.31),('8784','2013-09-28','10:35:00',1.87),('8784','2013-09-28','10:40:00',1.9),('8784','2013-09-28','10:45:00',3.44),('8784','2013-09-28','10:50:00',3.56),('8784','2013-09-28','10:55:00',3.09),('8784','2013-09-28','11:00:00',1.91),('8784','2013-09-28','11:05:00',1.34),('8784','2013-09-28','11:10:00',3),('8784','2013-09-28','11:15:00',3.57),('8784','2013-09-28','11:20:00',3.64),('8784','2013-09-28','11:25:00',3.74),('8784','2013-09-28','11:30:00',3.75),('8784','2013-09-28','11:35:00',2.71),('8784','2013-09-28','11:40:00',1.26),('8784','2013-09-28','11:50:00',1.9),('8784','2013-09-28','11:55:00',2.12),('8784','2013-09-28','12:00:00',3.92),('8784','2013-09-28','12:05:00',2.72),('8784','2013-09-28','12:10:00',3.6),('8784','2013-09-28','12:15:00',3.54),('8784','2013-09-28','12:20:00',3.26),('8784','2013-09-28','12:25:00',1.91),('8784','2013-09-28','12:30:00',2.63),('8784','2013-09-28','12:35:00',2.9),('8784','2013-09-28','12:40:00',3.31),('8784','2013-09-28','12:45:00',3.68),('8784','2013-09-28','12:50:00',2.98),('8784','2013-09-28','12:55:00',3.92),('8784','2013-09-28','13:00:00',3.5),('8784','2013-09-28','13:05:00',1.23),('8784','2013-09-28','13:10:00',1.43),('8784','2013-09-28','13:15:00',3.61),('8784','2013-09-28','13:20:00',3.89),('8784','2013-09-28','13:25:00',2.27),('8784','2013-09-28','13:30:00',1.59),('8784','2013-09-28','13:35:00',1.73),('8784','2013-09-28','13:40:00',1.72),('8784','2013-09-28','13:45:00',2.84),('8784','2013-09-28','13:50:00',1.72),('8784','2013-09-28','13:55:00',1.79),('8784','2013-09-28','14:00:00',2),('8784','2013-09-28','14:05:00',2.46),('8784','2013-09-28','14:10:00',3.67),('8784','2013-09-28','14:15:00',4),('8784','2013-09-28','14:20:00',3.78),('8784','2013-09-28','14:25:00',3.49),('8784','2013-09-28','14:30:00',3.57),('8784','2013-09-28','14:35:00',3.52),('8784','2013-09-28','14:40:00',3.44),('8784','2013-09-28','14:45:00',3.33),('8784','2013-09-28','14:50:00',3.24),('8784','2013-09-28','14:55:00',3.22),('8784','2013-09-28','15:00:00',3.28),('8784','2013-09-28','15:05:00',3.13),('8784','2013-09-28','15:10:00',2.98),('8784','2013-09-28','15:15:00',2.82),('8784','2013-09-28','15:20:00',2.96),('8784','2013-09-28','15:25:00',2.8),('8784','2013-09-28','15:30:00',2.67),('8784','2013-09-28','15:35:00',2.64),('8784','2013-09-28','15:40:00',2.58),('8784','2013-09-28','15:45:00',2.16),('8784','2013-09-28','15:50:00',2.23),('8784','2013-09-28','15:55:00',2.37),('8784','2013-09-28','16:00:00',2.41),('8784','2013-09-28','16:05:00',2.34),('8784','2013-09-28','16:10:00',2.27),('8784','2013-09-28','16:15:00',1.82),('8784','2013-09-28','16:20:00',1.4),('8784','2013-09-28','16:25:00',1.74),('8784','2013-09-28','16:30:00',1.69),('8784','2013-09-28','16:35:00',1.7),('8784','2013-09-28','16:40:00',1.61),('8784','2013-09-28','16:45:00',1.5),('8784','2013-09-28','16:50:00',1.44),('8784','2013-09-28','16:55:00',1.35),('8784','2013-09-28','17:00:00',1.27),('8784','2013-09-28','17:05:00',1.19),('8784','2013-09-28','17:10:00',1.1),('8784','2013-09-28','17:15:00',1.03),('8784','2013-09-27','08:25:00',1.03),('8784','2013-09-27','08:30:00',1),('8784','2013-09-27','08:35:00',1.17),('8784','2013-09-27','08:40:00',1.12),('8784','2013-09-27','08:45:00',1.1),('8784','2013-09-27','08:50:00',1.29),('8784','2013-09-27','08:55:00',1.57),('8784','2013-09-27','09:00:00',1.39),('8784','2013-09-27','09:05:00',1.08),('8784','2013-09-27','09:15:00',1.14),('8784','2013-09-27','09:50:00',2.12),('8784','2013-09-27','09:55:00',2.11),('8784','2013-09-27','10:00:00',2.21),('8784','2013-09-27','10:05:00',1.94),('8784','2013-09-27','10:10:00',2.28),('8784','2013-09-27','10:15:00',1.88),('8784','2013-09-27','10:20:00',2.65),('8784','2013-09-27','10:25:00',1.66),('8784','2013-09-27','10:30:00',1.35),('8784','2013-09-27','10:35:00',1.54),('8784','2013-09-27','10:40:00',1.4),('8784','2013-09-27','10:45:00',1.19),('8784','2013-09-27','10:50:00',1.22),('8784','2013-09-27','10:55:00',2.48),('8784','2013-09-27','11:00:00',2.7),('8784','2013-09-27','11:05:00',2.5),('8784','2013-09-27','11:10:00',2.38),('8784','2013-09-27','11:15:00',2.43),('8784','2013-09-27','11:20:00',3.39),('8784','2013-09-27','11:25:00',3.04),('8784','2013-09-27','11:30:00',1.93),('8784','2013-09-27','11:35:00',1.12),('8784','2013-09-27','11:45:00',1.34),('8784','2013-09-27','11:50:00',1.33),('8784','2013-09-27','11:55:00',1.68),('8784','2013-09-27','12:00:00',3.23),('8784','2013-09-27','12:05:00',2.21),('8784','2013-09-27','12:10:00',3.78),('8784','2013-09-27','12:15:00',1.29),('8784','2013-09-27','12:30:00',1),('8784','2013-09-27','12:40:00',1.12),('8784','2013-09-27','12:45:00',1.67),('8784','2013-09-27','12:50:00',3.07),('8784','2013-09-27','12:55:00',3.59),('8784','2013-09-27','13:00:00',3.47),('8784','2013-09-27','13:05:00',3.38),('8784','2013-09-27','13:10:00',3.38),('8784','2013-09-27','13:15:00',1.65),('8784','2013-09-27','13:20:00',2.12),('8784','2013-09-27','13:25:00',1.2),('8784','2013-09-27','13:40:00',1.28),('8784','2013-09-27','13:45:00',1.15),('8784','2013-09-27','13:50:00',1.06),('8784','2013-09-27','13:55:00',1.97),('8784','2013-09-27','14:00:00',3.36),('8784','2013-09-27','14:05:00',3.24),('8784','2013-09-27','14:10:00',3.47),('8784','2013-09-27','14:15:00',3.45),('8784','2013-09-27','14:20:00',3.32),('8784','2013-09-27','14:25:00',2.7),('8784','2013-09-27','14:30:00',3.28),('8784','2013-09-27','14:35:00',3.18),('8784','2013-09-27','14:40:00',3.18),('8784','2013-09-27','14:45:00',3.12),('8784','2013-09-27','14:50:00',2.75),('8784','2013-09-27','14:55:00',3.07),('8784','2013-09-27','15:00:00',3.07),('8784','2013-09-27','15:05:00',1.44),('8784','2013-09-27','15:10:00',2.69),('8784','2013-09-27','15:15:00',2.68),('8784','2013-09-27','15:20:00',2.51),('8784','2013-09-27','15:25:00',2.47),('8784','2013-09-27','15:30:00',2.63),('8784','2013-09-27','15:35:00',2.67),('8784','2013-09-27','15:40:00',1.59),('8784','2013-09-27','15:45:00',2.28),('8784','2013-09-27','15:50:00',2.63),('8784','2013-09-27','15:55:00',2.4),('8784','2013-09-27','16:00:00',2.07),('8784','2013-09-27','16:05:00',1.35),('8784','2013-09-27','16:10:00',1.19),('8784','2013-09-27','16:15:00',1.68),('8784','2013-09-27','16:20:00',2.01),('8784','2013-09-27','16:25:00',1.73),('8784','2013-09-27','16:30:00',1.79),('8784','2013-09-27','16:35:00',1.69),('8784','2013-09-27','16:40:00',1.64),('8784','2013-09-27','16:45:00',1.61),('8784','2013-09-27','16:50:00',1.48),('8784','2013-09-27','17:10:00',1.26),('8784','2013-09-27','17:15:00',1.23),('8784','2013-09-27','17:20:00',1.06),('8784','2013-09-26','08:40:00',1.2),('8784','2013-09-26','08:45:00',1.29),('8784','2013-09-26','08:50:00',1.37),('8784','2013-09-26','08:55:00',1.49),('8784','2013-09-26','09:00:00',1.57),('8784','2013-09-26','09:05:00',1.66),('8784','2013-09-26','09:10:00',1.7),('8784','2013-09-26','09:15:00',1.82),('8784','2013-09-26','09:20:00',1.89),('8784','2013-09-26','09:25:00',1.95),('8784','2013-09-26','09:30:00',2.03),('8784','2013-09-26','09:35:00',2.11),('8784','2013-09-26','09:40:00',2.17),('8784','2013-09-26','09:45:00',2.25),('8784','2013-09-26','09:50:00',2.32),('8784','2013-09-26','09:55:00',2.38),('8784','2013-09-26','10:00:00',2.44),('8784','2013-09-26','10:05:00',2.5),('8784','2013-09-26','10:10:00',2.52),('8784','2013-09-26','10:15:00',2.57),('8784','2013-09-26','10:20:00',2.66),('8784','2013-09-26','10:25:00',2.67),('8784','2013-09-26','10:30:00',2.77),('8784','2013-09-26','10:35:00',2.8),('8784','2013-09-26','10:40:00',2.84),('8784','2013-09-26','10:45:00',2.88),('8784','2013-09-26','10:50:00',2.93),('8784','2013-09-26','10:55:00',2.91),('8784','2013-09-26','11:00:00',2.97),('8784','2013-09-26','11:05:00',3.02),('8784','2013-09-26','11:10:00',3.09),('8784','2013-09-26','11:15:00',3.1),('8784','2013-09-26','11:20:00',3.1),('8784','2013-09-26','11:25:00',3.08),('8784','2013-09-26','11:30:00',2.83),('8784','2013-09-26','11:35:00',1.96),('8784','2013-09-26','11:40:00',3.26),('8784','2013-09-26','11:45:00',2.79),('8784','2013-09-26','11:50:00',3.43),('8784','2013-09-26','11:55:00',3.67),('8784','2013-09-26','12:00:00',2.64),('8784','2013-09-26','12:05:00',3.73),('8784','2013-09-26','12:10:00',1.35),('8784','2013-09-26','12:15:00',1.43),('8784','2013-09-26','12:20:00',1.83),('8784','2013-09-26','12:25:00',1.27),('8784','2013-09-26','12:30:00',1.47),('8784','2013-09-26','12:35:00',1.68),('8784','2013-09-26','12:40:00',1.62),('8784','2013-09-26','12:45:00',1.63),('8784','2013-09-26','12:50:00',1.66),('8784','2013-09-26','12:55:00',3.54),('8784','2013-09-26','13:00:00',2.61),('8784','2013-09-26','13:05:00',2.24),('8784','2013-09-26','13:10:00',2.24),('8784','2013-09-26','13:15:00',4.13),('8784','2013-09-26','13:20:00',3.98),('8784','2013-09-26','13:25:00',2.39),('8784','2013-09-26','13:30:00',2.2),('8784','2013-09-26','13:35:00',2.08),('8784','2013-09-26','13:40:00',1.63),('8784','2013-09-26','13:45:00',1.57),('8784','2013-09-26','13:50:00',2.44),('8784','2013-09-26','13:55:00',2.09),('8784','2013-09-26','14:00:00',2.52),('8784','2013-09-26','14:05:00',3.61),('8784','2013-09-26','14:10:00',3.48),('8784','2013-09-26','14:15:00',2.79),('8784','2013-09-26','14:20:00',1.55),('8784','2013-09-26','14:30:00',2.03),('8784','2013-09-26','14:35:00',1.09),('8784','2013-09-26','14:40:00',1.8),('8784','2013-09-26','14:45:00',3.82),('8784','2013-09-26','14:50:00',3.52),('8784','2013-09-26','14:55:00',1.83),('8784','2013-09-26','15:00:00',1.23),('8784','2013-09-26','15:05:00',1.86),('8784','2013-09-26','15:10:00',1.1),('8784','2013-09-26','15:15:00',1.09),('8784','2013-09-26','15:20:00',2.61),('8784','2013-09-26','15:25:00',1.3),('8784','2013-09-26','15:35:00',2.28),('8784','2013-09-26','15:45:00',1.41),('8784','2013-09-26','15:50:00',2.03),('8784','2013-09-26','15:55:00',2.44),('8784','2013-09-26','16:00:00',2.23),('8784','2013-09-26','16:05:00',1.17),('8784','2013-09-26','16:10:00',2.16),('8784','2013-09-26','16:15:00',1.99),('8784','2013-09-26','16:20:00',2.02),('8784','2013-09-26','16:25:00',2),('8784','2013-09-26','16:30:00',1.86),('8784','2013-09-26','16:35:00',1.77),('8784','2013-09-26','16:40:00',1.68),('8784','2013-09-26','16:45:00',1.59),('8784','2013-09-26','16:50:00',1.5),('8784','2013-09-26','16:55:00',1.44),('8784','2013-09-26','17:00:00',1.32),('8784','2013-09-26','17:05:00',1.29),('8784','2013-09-26','17:10:00',1.26),('8784','2013-09-26','17:15:00',1.1),('8784','2013-09-26','17:20:00',1.08),('8784','2013-09-25','08:25:00',1),('8784','2013-09-25','08:30:00',1.04),('8784','2013-09-25','08:45:00',1.56),('8784','2013-09-25','08:50:00',1.03),('8784','2013-09-25','09:05:00',1.47),('8784','2013-09-25','09:10:00',1.51),('8784','2013-09-25','09:15:00',1.44),('8784','2013-09-25','09:20:00',1.12),('8784','2013-09-25','09:25:00',1.76),('8784','2013-09-25','09:30:00',1.41),('8784','2013-09-25','09:35:00',2.23),('8784','2013-09-25','09:40:00',1.8),('8784','2013-09-25','09:50:00',2.2),('8784','2013-09-25','09:55:00',1.43),('8784','2013-09-25','10:00:00',1.78),('8784','2013-09-25','10:05:00',1.02),('8784','2013-09-25','10:20:00',1.02),('8784','2013-09-25','10:25:00',1.62),('8784','2013-09-25','10:30:00',1.31),('8784','2013-09-25','10:35:00',1.05),('8784','2013-09-25','10:40:00',1.62),('8784','2013-09-25','10:45:00',2.98),('8784','2013-09-25','10:50:00',3.31),('8784','2013-09-25','10:55:00',3.46),('8784','2013-09-25','11:00:00',2.7),('8784','2013-09-25','11:05:00',1.63),('8784','2013-09-25','11:10:00',1.73),('8784','2013-09-25','11:15:00',3.09),('8784','2013-09-25','11:20:00',2.91),('8784','2013-09-25','11:25:00',3.3),('8784','2013-09-25','11:30:00',3.15),('8784','2013-09-25','11:35:00',2.76),('8784','2013-09-25','11:40:00',3.65),('8784','2013-09-25','11:45:00',3.16),('8784','2013-09-25','11:50:00',1.88),('8784','2013-09-25','11:55:00',1.76),('8784','2013-09-25','12:10:00',2.54),('8784','2013-09-25','12:15:00',3.74),('8784','2013-09-25','12:20:00',1.3),('8784','2013-09-25','12:25:00',1.34),('8784','2013-09-25','12:30:00',3.52),('8784','2013-09-25','12:35:00',3.73),('8784','2013-09-25','12:40:00',1.13),('8784','2013-09-25','12:45:00',1.2),('8784','2013-09-25','12:50:00',1.32),('8784','2013-09-25','13:00:00',1.24),('8784','2013-09-25','13:05:00',1.02),('8784','2013-09-25','13:10:00',1.38),('8784','2013-09-25','13:15:00',1.51),('8784','2013-09-25','13:20:00',1.28),('8784','2013-09-25','13:25:00',3.53),('8784','2013-09-25','13:30:00',3.77),('8784','2013-09-25','13:35:00',4.04),('8784','2013-09-25','13:40:00',4.28),('8784','2013-09-25','13:45:00',4.26),('8784','2013-09-25','13:50:00',4.14),('8784','2013-09-25','13:55:00',1.48),('8784','2013-09-25','14:05:00',1.09),('8784','2013-09-25','14:10:00',1.19),('8784','2013-09-25','14:15:00',1),('8784','2013-09-25','14:20:00',1.14),('8784','2013-09-25','14:25:00',1.34),('8784','2013-09-25','14:30:00',3.46),('8784','2013-09-25','14:35:00',3.89),('8784','2013-09-25','14:40:00',3.76),('8784','2013-09-25','14:45:00',2.6),('8784','2013-09-25','14:50:00',3.18),('8784','2013-09-25','14:55:00',2.55),('8784','2013-09-25','15:00:00',3.67),('8784','2013-09-25','15:05:00',3.32),('8784','2013-09-25','15:10:00',3.18),('8784','2013-09-25','15:15:00',3.13),('8784','2013-09-25','15:20:00',2.69),('8784','2013-09-25','15:25:00',2.91),('8784','2013-09-25','15:30:00',2.66),('8784','2013-09-25','15:35:00',3.09),('8784','2013-09-25','15:40:00',2.94),('8784','2013-09-25','15:45:00',2.65),('8784','2013-09-25','15:50:00',2.67),('8784','2013-09-25','15:55:00',2.6),('8784','2013-09-25','16:00:00',2.53),('8784','2013-09-25','16:05:00',2.4),('8784','2013-09-25','16:10:00',2.32),('8784','2013-09-25','16:15:00',2.24),('8784','2013-09-25','16:20:00',1.83),('8784','2013-09-25','16:25:00',1.47),('8784','2013-09-25','16:30:00',2.04),('8784','2013-09-25','16:35:00',1.86),('8784','2013-09-25','16:40:00',1.36),('8784','2013-09-25','16:45:00',1.71),('8784','2013-09-25','16:50:00',1.63),('8784','2013-09-25','16:55:00',1.54),('8784','2013-09-25','17:00:00',1.45),('8784','2013-09-25','17:05:00',1.38),('8784','2013-09-25','17:10:00',1.29),('8784','2013-09-25','17:15:00',1.19),('8784','2013-09-25','17:20:00',1.1),('8784','2013-09-25','17:25:00',1.03),('8784','2013-09-24','08:25:00',1.08),('8784','2013-09-24','08:30:00',1.16),('8784','2013-09-24','08:35:00',1.24),('8784','2013-09-24','08:40:00',1.33),('8784','2013-09-24','08:45:00',1.41),('8784','2013-09-24','08:50:00',1.5),('8784','2013-09-24','08:55:00',1.59),('8784','2013-09-24','09:00:00',1.65),('8784','2013-09-24','09:05:00',1.74),('8784','2013-09-24','09:10:00',1.83),('8784','2013-09-24','09:15:00',1.89),('8784','2013-09-24','09:20:00',1.99),('8784','2013-09-24','09:25:00',2.08),('8784','2013-09-24','09:30:00',2.15),('8784','2013-09-24','09:35:00',2.23),('8784','2013-09-24','09:40:00',2.29),('8784','2013-09-24','09:45:00',2.36),('8784','2013-09-24','09:50:00',2.43),('8784','2013-09-24','09:55:00',2.5),('8784','2013-09-24','10:00:00',2.56),('8784','2013-09-24','10:05:00',2.61),('8784','2013-09-24','10:10:00',2.69),('8784','2013-09-24','10:15:00',2.77),('8784','2013-09-24','10:20:00',2.83),('8784','2013-09-24','10:25:00',2.89),('8784','2013-09-24','10:30:00',2.94),('8784','2013-09-24','10:35:00',2.99),('8784','2013-09-24','10:40:00',3.03),('8784','2013-09-24','10:45:00',3.08),('8784','2013-09-24','10:50:00',3.13),('8784','2013-09-24','10:55:00',3.17),('8784','2013-09-24','11:00:00',3.2),('8784','2013-09-24','11:05:00',3.24),('8784','2013-09-24','11:10:00',3.27),('8784','2013-09-24','11:15:00',3.28),('8784','2013-09-24','11:20:00',3.32),('8784','2013-09-24','11:25:00',3.35),('8784','2013-09-24','11:30:00',3.4),('8784','2013-09-24','11:35:00',3.4),('8784','2013-09-24','11:40:00',3.43),('8784','2013-09-24','11:45:00',3.45),('8784','2013-09-24','11:50:00',3.46),('8784','2013-09-24','11:55:00',3.5),('8784','2013-09-24','12:00:00',3.51),('8784','2013-09-24','12:05:00',3.51),('8784','2013-09-24','12:10:00',3.53),('8784','2013-09-24','12:15:00',3.54),('8784','2013-09-24','12:20:00',3.55),('8784','2013-09-24','12:25:00',3.55),('8784','2013-09-24','12:30:00',3.59),('8784','2013-09-24','12:35:00',3.6),('8784','2013-09-24','12:40:00',3.65),('8784','2013-09-24','12:45:00',3.65),('8784','2013-09-24','12:50:00',3.63),('8784','2013-09-24','12:55:00',3.63),('8784','2013-09-24','13:00:00',3.64),('8784','2013-09-24','13:05:00',3.63),('8784','2013-09-24','13:10:00',3.61),('8784','2013-09-24','13:15:00',3.61),('8784','2013-09-24','13:20:00',3.62),('8784','2013-09-24','13:25:00',3.55),('8784','2013-09-24','13:30:00',3.58),('8784','2013-09-24','13:35:00',3.59),('8784','2013-09-24','13:40:00',3.61),('8784','2013-09-24','13:45:00',3.55),('8784','2013-09-24','13:50:00',3.53),('8784','2013-09-24','13:55:00',3.5),('8784','2013-09-24','14:00:00',3.52),('8784','2013-09-24','14:05:00',3.46),('8784','2013-09-24','14:10:00',3.46),('8784','2013-09-24','14:15:00',3.42),('8784','2013-09-24','14:20:00',3.39),('8784','2013-09-24','14:25:00',3.36),('8784','2013-09-24','14:30:00',3.32),('8784','2013-09-24','14:35:00',3.27),('8784','2013-09-24','14:40:00',3.25),('8784','2013-09-24','14:45:00',3.21),('8784','2013-09-24','14:50:00',3.16),('8784','2013-09-24','14:55:00',3.07),('8784','2013-09-24','15:00:00',3.08),('8784','2013-09-24','15:05:00',3.06),('8784','2013-09-24','15:10:00',2.97),('8784','2013-09-24','15:15:00',2.92),('8784','2013-09-24','15:20:00',2.9),('8784','2013-09-24','15:25:00',2.87),('8784','2013-09-24','15:30:00',2.8),('8784','2013-09-24','15:35:00',2.73),('8784','2013-09-24','15:40:00',2.69),('8784','2013-09-24','15:45:00',2.65),('8784','2013-09-24','15:50:00',2.57),('8784','2013-09-24','15:55:00',2.51),('8784','2013-09-24','16:00:00',2.44),('8784','2013-09-24','16:05:00',2.36),('8784','2013-09-24','16:10:00',2.28),('8784','2013-09-24','16:15:00',2.22),('8784','2013-09-24','16:20:00',2.15),('8784','2013-09-24','16:25:00',2.05),('8784','2013-09-24','16:30:00',1.97),('8784','2013-09-24','16:35:00',1.89),('8784','2013-09-24','16:40:00',1.8),('8784','2013-09-24','16:45:00',1.74),('8784','2013-09-24','16:50:00',1.68),('8784','2013-09-24','16:55:00',1.59),('8784','2013-09-24','17:00:00',1.5),('8784','2013-09-24','17:05:00',1.4),('8784','2013-09-24','17:10:00',1.32),('8784','2013-09-24','17:15:00',1.24),('8784','2013-09-24','17:20:00',1.15),('8784','2013-09-24','17:25:00',1.06),('8784','2013-09-23','08:20:00',1.03),('8784','2013-09-23','08:25:00',1.12),('8784','2013-09-23','08:30:00',1.2),('8784','2013-09-23','08:35:00',1.28),('8784','2013-09-23','08:40:00',1.37),('8784','2013-09-23','08:45:00',1.45),('8784','2013-09-23','08:50:00',1.52),('8784','2013-09-23','08:55:00',1.63),('8784','2013-09-23','09:00:00',1.67),('8784','2013-09-23','09:05:00',1.79),('8784','2013-09-23','09:10:00',1.89),('8784','2013-09-23','09:15:00',1.97),('8784','2013-09-23','09:20:00',2.05),('8784','2013-09-23','09:25:00',2.13),('8784','2013-09-23','09:30:00',2.21),('8784','2013-09-23','09:35:00',2.28),('8784','2013-09-23','09:40:00',2.36),('8784','2013-09-23','09:45:00',2.42),('8784','2013-09-23','09:50:00',2.46),('8784','2013-09-23','09:55:00',2.56),('8784','2013-09-23','10:00:00',2.62),('8784','2013-09-23','10:05:00',2.69),('8784','2013-09-23','10:10:00',2.75),('8784','2013-09-23','10:15:00',2.81),('8784','2013-09-23','10:20:00',2.87),('8784','2013-09-23','10:25:00',2.93),('8784','2013-09-23','10:30:00',2.97),('8784','2013-09-23','10:35:00',3.03),('8784','2013-09-23','10:40:00',3.09),('8784','2013-09-23','10:45:00',3.14),('8784','2013-09-23','10:50:00',3.19),('8784','2013-09-23','10:55:00',3.25),('8784','2013-09-23','11:00:00',3.26),('8784','2013-09-23','11:05:00',3.3),('8784','2013-09-23','11:10:00',3.37),('8784','2013-09-23','11:15:00',3.43),('8784','2013-09-23','11:20:00',3.47),('8784','2013-09-23','11:25:00',3.5),('8784','2013-09-23','11:30:00',3.53),('8784','2013-09-23','11:35:00',3.54),('8784','2013-09-23','11:40:00',3.59),('8784','2013-09-23','11:45:00',3.6),('8784','2013-09-23','11:50:00',3.64),('8784','2013-09-23','11:55:00',3.68),('8784','2013-09-23','12:00:00',3.71),('8784','2013-09-23','12:05:00',3.72),('8784','2013-09-23','12:10:00',3.74),('8784','2013-09-23','12:15:00',3.76),('8784','2013-09-23','12:20:00',3.75),('8784','2013-09-23','12:25:00',3.78),('8784','2013-09-23','12:30:00',3.77),('8784','2013-09-23','12:35:00',3.76),('8784','2013-09-23','12:40:00',3.75),('8784','2013-09-23','12:45:00',3.75),('8784','2013-09-23','12:50:00',3.75),('8784','2013-09-23','12:55:00',3.72),('8784','2013-09-23','13:00:00',3.76),('8784','2013-09-23','13:05:00',3.73),('8784','2013-09-23','13:10:00',3.71),('8784','2013-09-23','13:15:00',3.69),('8784','2013-09-23','13:20:00',3.67),('8784','2013-09-23','13:25:00',3.62),('8784','2013-09-23','13:30:00',3.67),('8784','2013-09-23','13:35:00',3.66),('8784','2013-09-23','13:40:00',3.66),('8784','2013-09-23','13:45:00',3.64),('8784','2013-09-23','13:50:00',3.59),('8784','2013-09-23','13:55:00',3.57),('8784','2013-09-23','14:00:00',3.54),('8784','2013-09-23','14:05:00',3.47),('8784','2013-09-23','14:10:00',3.43),('8784','2013-09-23','14:15:00',3.51),('8784','2013-09-23','14:20:00',3.42),('8784','2013-09-23','14:25:00',3.42),('8784','2013-09-23','14:30:00',3.44),('8784','2013-09-23','14:35:00',3.36),('8784','2013-09-23','14:40:00',3.22),('8784','2013-09-23','14:45:00',3.25),('8784','2013-09-23','14:50:00',3.01),('8784','2013-09-23','14:55:00',2.69),('8784','2013-09-23','15:00:00',3.2),('8784','2013-09-23','15:05:00',3.16),('8784','2013-09-23','15:10:00',2.13),('8784','2013-09-23','15:15:00',2.31),('8784','2013-09-23','15:20:00',2.23),('8784','2013-09-23','15:25:00',2.52),('8784','2013-09-23','15:30:00',2.84),('8784','2013-09-23','15:35:00',2.77),('8784','2013-09-23','15:40:00',2.72),('8784','2013-09-23','15:45:00',2.65),('8784','2013-09-23','15:50:00',2.57),('8784','2013-09-23','15:55:00',2.4),('8784','2013-09-23','16:00:00',2.4),('8784','2013-09-23','16:05:00',2.35),('8784','2013-09-23','16:10:00',2.05),('8784','2013-09-23','16:15:00',2.22),('8784','2013-09-23','16:20:00',2.01),('8784','2013-09-23','16:25:00',2.05),('8784','2013-09-23','16:30:00',1.78),('8784','2013-09-23','16:35:00',1.75),('8784','2013-09-23','16:40:00',1.77),('8784','2013-09-23','16:45:00',1.71),('8784','2013-09-23','16:50:00',1.61),('8784','2013-09-23','16:55:00',1.53),('8784','2013-09-23','17:00:00',1.46),('8784','2013-09-23','17:05:00',1.38),('8784','2013-09-23','17:10:00',1.3),('8784','2013-09-23','17:15:00',1.22),('8784','2013-09-23','17:20:00',1.14),('8784','2013-09-23','17:25:00',1.06),('8784','2013-09-22','08:20:00',1.11),('8784','2013-09-22','08:25:00',1.12),('8784','2013-09-22','08:30:00',1.19),('8784','2013-09-22','08:35:00',1.27),('8784','2013-09-22','08:40:00',1.34),('8784','2013-09-22','08:45:00',1.42),('8784','2013-09-22','08:50:00',1.51),('8784','2013-09-22','08:55:00',1.59),('8784','2013-09-22','09:00:00',1.69),('8784','2013-09-22','09:05:00',1.78),('8784','2013-09-22','09:10:00',1.88),('8784','2013-09-22','09:15:00',1.97),('8784','2013-09-22','09:20:00',2.05),('8784','2013-09-22','09:25:00',2.12),('8784','2013-09-22','09:30:00',2.2),('8784','2013-09-22','09:35:00',2.29),('8784','2013-09-22','09:40:00',2.35),('8784','2013-09-22','09:45:00',2.4),('8784','2013-09-22','09:50:00',2.49),('8784','2013-09-22','09:55:00',2.55),('8784','2013-09-22','10:00:00',2.64),('8784','2013-09-22','10:05:00',2.71),('8784','2013-09-22','10:10:00',2.79),('8784','2013-09-22','10:15:00',2.85),('8784','2013-09-22','10:20:00',2.91),('8784','2013-09-22','10:25:00',2.96),('8784','2013-09-22','10:30:00',3.02),('8784','2013-09-22','10:35:00',3.08),('8784','2013-09-22','10:40:00',3.08),('8784','2013-09-22','10:45:00',3.16),('8784','2013-09-22','10:50:00',3.22),('8784','2013-09-22','10:55:00',3.26),('8784','2013-09-22','11:00:00',3.29),('8784','2013-09-22','11:05:00',3.32),('8784','2013-09-22','11:10:00',3.35),('8784','2013-09-22','11:15:00',3.42),('8784','2013-09-22','11:20:00',3.47),('8784','2013-09-22','11:25:00',3.51),('8784','2013-09-22','11:30:00',3.54),('8784','2013-09-22','11:35:00',3.6),('8784','2013-09-22','11:40:00',3.64),('8784','2013-09-22','11:45:00',3.67),('8784','2013-09-22','11:50:00',3.7),('8784','2013-09-22','11:55:00',3.7),('8784','2013-09-22','12:00:00',3.74),('8784','2013-09-22','12:05:00',3.76),('8784','2013-09-22','12:10:00',3.78),('8784','2013-09-22','12:15:00',3.77),('8784','2013-09-22','12:20:00',3.8),('8784','2013-09-22','12:25:00',3.76),('8784','2013-09-22','12:30:00',3.81),('8784','2013-09-22','12:35:00',3.8),('8784','2013-09-22','12:40:00',3.84),('8784','2013-09-22','12:45:00',3.83),('8784','2013-09-22','12:50:00',3.85),('8784','2013-09-22','12:55:00',3.91),('8784','2013-09-22','13:00:00',3.87),('8784','2013-09-22','13:05:00',3.85),('8784','2013-09-22','13:10:00',3.88),('8784','2013-09-22','13:15:00',3.83),('8784','2013-09-22','13:20:00',3.81),('8784','2013-09-22','13:25:00',3.77),('8784','2013-09-22','13:30:00',3.81),('8784','2013-09-22','13:35:00',3.76),('8784','2013-09-22','13:40:00',3.69),('8784','2013-09-22','13:45:00',3.74),('8784','2013-09-22','13:50:00',3.75),('8784','2013-09-22','13:55:00',3.72),('8784','2013-09-22','14:00:00',3.66),('8784','2013-09-22','14:05:00',3.71),('8784','2013-09-22','14:10:00',3.72),('8784','2013-09-22','14:15:00',3.29),('8784','2013-09-22','14:20:00',2.62),('8784','2013-09-22','14:25:00',3.43),('8784','2013-09-22','14:30:00',1.17),('8784','2013-09-22','14:35:00',3.54),('8784','2013-09-22','14:40:00',3.55),('8784','2013-09-22','14:45:00',3.45),('8784','2013-09-22','14:50:00',3.36),('8784','2013-09-22','14:55:00',3.32),('8784','2013-09-22','15:00:00',3.36),('8784','2013-09-22','15:05:00',3.43),('8784','2013-09-22','15:10:00',3.32),('8784','2013-09-22','15:15:00',3.46),('8784','2013-09-22','15:20:00',3.66),('8784','2013-09-22','15:25:00',1.99),('8784','2013-09-22','15:30:00',1.31),('8784','2013-09-22','15:35:00',1.1),('8784','2013-09-22','15:40:00',3.07),('8784','2013-09-22','15:45:00',2.89),('8784','2013-09-22','15:50:00',2.73),('8784','2013-09-22','15:55:00',2.67),('8784','2013-09-22','16:00:00',2.91),('8784','2013-09-22','16:05:00',2.89),('8784','2013-09-22','16:10:00',2.96),('8784','2013-09-22','16:15:00',2.76),('8784','2013-09-22','16:20:00',1.61),('8784','2013-09-22','16:25:00',1.6),('8784','2013-09-22','16:30:00',1.46),('8784','2013-09-22','16:35:00',1.11),('8784','2013-09-22','16:40:00',1.06),('8784','2013-09-22','16:45:00',1.6),('8784','2013-09-22','16:50:00',1.89),('8784','2013-09-22','16:55:00',1.51),('8784','2013-09-22','17:00:00',1.29),('8784','2013-09-22','17:05:00',1.81),('8784','2013-09-22','17:10:00',1.56),('8784','2013-09-21','08:20:00',1.04),('8784','2013-09-21','08:25:00',1.11),('8784','2013-09-21','08:30:00',1.2),('8784','2013-09-21','08:35:00',1.28),('8784','2013-09-21','08:40:00',1.34),('8784','2013-09-21','08:45:00',1.37),('8784','2013-09-21','08:50:00',1.48),('8784','2013-09-21','08:55:00',1.59),('8784','2013-09-21','09:00:00',1.69),('8784','2013-09-21','09:05:00',1.77),('8784','2013-09-21','09:10:00',1.85),('8784','2013-09-21','09:15:00',1.93),('8784','2013-09-21','09:20:00',1.99),('8784','2013-09-21','09:25:00',2.08),('8784','2013-09-21','09:30:00',2.13),('8784','2013-09-21','09:35:00',2.24),('8784','2013-09-21','09:40:00',2.29),('8784','2013-09-21','09:45:00',2.36),('8784','2013-09-21','09:50:00',2.45),('8784','2013-09-21','09:55:00',2.51),('8784','2013-09-21','10:00:00',2.58),('8784','2013-09-21','10:05:00',2.64),('8784','2013-09-21','10:10:00',2.71),('8784','2013-09-21','10:15:00',2.78),('8784','2013-09-21','10:20:00',2.83),('8784','2013-09-21','10:25:00',2.89),('8784','2013-09-21','10:30:00',2.96),('8784','2013-09-21','10:35:00',3.01),('8784','2013-09-21','10:40:00',3.05),('8784','2013-09-21','10:45:00',3.1),('8784','2013-09-21','10:50:00',3.16),('8784','2013-09-21','10:55:00',3.2),('8784','2013-09-21','11:00:00',3.23),('8784','2013-09-21','11:05:00',3.21),('8784','2013-09-21','11:10:00',3.31),('8784','2013-09-21','11:15:00',3.34),('8784','2013-09-21','11:20:00',3.39),('8784','2013-09-21','11:25:00',3.43),('8784','2013-09-21','11:30:00',3.46),('8784','2013-09-21','11:35:00',3.5),('8784','2013-09-21','11:40:00',3.55),('8784','2013-09-21','11:45:00',3.58),('8784','2013-09-21','11:50:00',3.61),('8784','2013-09-21','11:55:00',3.55),('8784','2013-09-21','12:00:00',3.59),('8784','2013-09-21','12:05:00',3.68),('8784','2013-09-21','12:10:00',3.7),('8784','2013-09-21','12:15:00',3.73),('8784','2013-09-21','12:20:00',3.55),('8784','2013-09-21','12:25:00',3.42),('8784','2013-09-21','12:30:00',3.79),('8784','2013-09-21','12:35:00',3.68),('8784','2013-09-21','12:40:00',3.55),('8784','2013-09-21','12:45:00',3.65),('8784','2013-09-21','12:50:00',3.72),('8784','2013-09-21','12:55:00',3.78),('8784','2013-09-21','13:00:00',3.78),('8784','2013-09-21','13:05:00',3.67),('8784','2013-09-21','13:10:00',3.75),('8784','2013-09-21','13:15:00',3.84),('8784','2013-09-21','13:20:00',3.17),('8784','2013-09-21','13:25:00',3.61),('8784','2013-09-21','13:30:00',3.6),('8784','2013-09-21','13:35:00',3.6),('8784','2013-09-21','13:40:00',3.19),('8784','2013-09-21','13:45:00',3.19),('8784','2013-09-21','13:50:00',3.26),('8784','2013-09-21','13:55:00',3.17),('8784','2013-09-21','14:00:00',3.39),('8784','2013-09-21','14:05:00',3.5),('8784','2013-09-21','14:10:00',3.4),('8784','2013-09-21','14:15:00',3.53),('8784','2013-09-21','14:20:00',3.51),('8784','2013-09-21','14:25:00',3.48),('8784','2013-09-21','14:30:00',3.41),('8784','2013-09-21','14:35:00',3.38),('8784','2013-09-21','14:40:00',3.34),('8784','2013-09-21','14:45:00',3.28),('8784','2013-09-21','14:50:00',3.25),('8784','2013-09-21','14:55:00',3.19),('8784','2013-09-21','15:00:00',3.16),('8784','2013-09-21','15:05:00',3.11),('8784','2013-09-21','15:10:00',3.02),('8784','2013-09-21','15:15:00',2.94),('8784','2013-09-21','15:20:00',2.94),('8784','2013-09-21','15:25:00',2.88),('8784','2013-09-21','15:30:00',2.83),('8784','2013-09-21','15:35:00',2.79),('8784','2013-09-21','15:40:00',2.5),('8784','2013-09-21','15:45:00',1.82),('8784','2013-09-21','15:50:00',2.6),('8784','2013-09-21','15:55:00',2.4),('8784','2013-09-21','16:00:00',1.87),('8784','2013-09-21','16:05:00',1.31),('8784','2013-09-21','16:10:00',1.54),('8784','2013-09-21','16:15:00',1.38),('8784','2013-09-21','16:20:00',1.59),('8784','2013-09-21','16:30:00',1.18),('8784','2013-09-21','16:35:00',1.41),('8784','2013-09-21','16:55:00',1.12),('8784','2013-09-20','08:30:00',1.23),('8784','2013-09-20','08:35:00',1.33),('8784','2013-09-20','08:40:00',1.51),('8784','2013-09-20','08:45:00',1.28),('8784','2013-09-20','08:50:00',1.04),('8784','2013-09-20','08:55:00',1),('8784','2013-09-20','09:00:00',1.13),('8784','2013-09-20','09:05:00',1.26),('8784','2013-09-20','09:10:00',1.14),('8784','2013-09-20','09:15:00',1.34),('8784','2013-09-20','09:20:00',1.41),('8784','2013-09-20','09:25:00',1.44),('8784','2013-09-20','09:30:00',1.28),('8784','2013-09-20','09:35:00',1.3),('8784','2013-09-20','09:40:00',1.34),('8784','2013-09-20','09:45:00',1.38),('8784','2013-09-20','09:50:00',1.39),('8784','2013-09-20','09:55:00',1.58),('8784','2013-09-20','10:00:00',1.93),('8784','2013-09-20','10:05:00',2.41),('8784','2013-09-20','10:10:00',2.48),('8784','2013-09-20','10:15:00',3.5),('8784','2013-09-20','10:20:00',2.85),('8784','2013-09-20','10:25:00',2.54),('8784','2013-09-20','10:30:00',2.85),('8784','2013-09-20','10:35:00',2.46),('8784','2013-09-20','10:40:00',3.7),('8784','2013-09-20','10:45:00',3.14),('8784','2013-09-20','10:50:00',2.75),('8784','2013-09-20','10:55:00',2.17),('8784','2013-09-20','11:00:00',1.99),('8784','2013-09-20','11:05:00',2.02),('8784','2013-09-20','11:10:00',2.31),('8784','2013-09-20','11:15:00',2.44),('8784','2013-09-20','11:20:00',2.52),('8784','2013-09-20','11:25:00',2.34),('8784','2013-09-20','11:30:00',2.83),('8784','2013-09-20','11:35:00',2.52),('8784','2013-09-20','11:40:00',3.85),('8784','2013-09-20','11:45:00',3.8),('8784','2013-09-20','11:50:00',3.86),('8784','2013-09-20','11:55:00',3.77),('8784','2013-09-20','12:00:00',3.72),('8784','2013-09-20','12:05:00',3.72),('8784','2013-09-20','12:10:00',3.75),('8784','2013-09-20','12:15:00',3.83),('8784','2013-09-20','12:20:00',3.91),('8784','2013-09-20','12:25:00',3.2),('8784','2013-09-20','12:30:00',3.64),('8784','2013-09-20','12:35:00',2.71),('8784','2013-09-20','12:40:00',3.31),('8784','2013-09-20','12:45:00',2.38),('8784','2013-09-20','12:50:00',4.02),('8784','2013-09-20','12:55:00',3.91),('8784','2013-09-20','13:00:00',3.02),('8784','2013-09-20','13:05:00',3.78),('8784','2013-09-20','13:10:00',3.74),('8784','2013-09-20','13:15:00',2.29),('8784','2013-09-20','13:20:00',1.16),('8784','2013-09-20','13:25:00',2.72),('8784','2013-09-20','13:30:00',3.88),('8784','2013-09-20','13:35:00',3.4),('8784','2013-09-20','13:40:00',3.46),('8784','2013-09-20','13:45:00',3.79),('8784','2013-09-20','13:50:00',3.59),('8784','2013-09-20','13:55:00',3.3),('8784','2013-09-20','14:00:00',1.77),('8784','2013-09-20','14:10:00',2.84),('8784','2013-09-20','14:15:00',3.26),('8784','2013-09-20','14:20:00',1.53),('8784','2013-09-20','14:25:00',3.77),('8784','2013-09-20','14:30:00',3.76),('8784','2013-09-20','14:35:00',3.57),('8784','2013-09-20','14:40:00',2.72),('8784','2013-09-20','14:45:00',3.48),('8784','2013-09-20','14:50:00',3.55),('8784','2013-09-20','14:55:00',3.51),('8784','2013-09-20','15:00:00',2.31),('8784','2013-09-20','15:05:00',3.45),('8784','2013-09-20','15:10:00',2.33),('8784','2013-09-20','15:15:00',2.2),('8784','2013-09-20','15:20:00',2.3),('8784','2013-09-20','15:25:00',1.11),('8784','2013-09-20','15:30:00',1.48),('8784','2013-09-20','15:35:00',3.26),('8784','2013-09-20','15:40:00',3.08),('8784','2013-09-20','15:45:00',2.9),('8784','2013-09-20','15:50:00',2.83),('8784','2013-09-20','15:55:00',2.91),('8784','2013-09-20','16:00:00',3.08),('8784','2013-09-20','16:05:00',2.15),('8784','2013-09-20','16:10:00',1.59),('8784','2013-09-20','16:15:00',2.36),('8784','2013-09-20','16:20:00',1.55),('8784','2013-09-20','16:25:00',1.32),('8784','2013-09-20','16:45:00',1.8),('8784','2013-09-20','16:50:00',2.16),('8784','2013-09-20','16:55:00',2.16),('8784','2013-09-20','17:00:00',2.04),('8784','2013-09-20','17:05:00',2.15),('8784','2013-09-20','17:10:00',2.2),('8784','2013-09-20','17:15:00',2.06),('8784','2013-09-20','17:20:00',2),('8784','2013-09-20','17:25:00',1.7),('8784','2013-09-20','17:30:00',1.43),('8784','2013-09-20','17:35:00',1.06),('8784','2013-09-20','17:40:00',1.05),('8784','2013-09-20','17:45:00',1.09),('8784','2013-09-20','17:50:00',1.01),('8784','2013-09-20','18:05:00',1.01),('8784','2013-09-19','08:20:00',1.03),('8784','2013-09-19','08:25:00',1.06),('8784','2013-09-19','08:30:00',1.27),('8784','2013-09-19','08:35:00',1.27),('8784','2013-09-19','08:40:00',1.21),('8784','2013-09-19','08:45:00',1.23),('8784','2013-09-19','08:50:00',1.21),('8784','2013-09-19','08:55:00',1.35),('8784','2013-09-19','09:00:00',1.25),('8784','2013-09-19','09:10:00',1.82),('8784','2013-09-19','09:15:00',1.75),('8784','2013-09-19','09:20:00',1.34),('8784','2013-09-19','10:05:00',2.46),('8784','2013-09-19','10:10:00',1.74),('8784','2013-09-19','10:15:00',1.31),('8784','2013-09-19','10:25:00',1.14),('8784','2013-09-19','10:30:00',1.19),('8784','2013-09-19','10:35:00',3.45),('8784','2013-09-19','10:40:00',3.04),('8784','2013-09-19','10:45:00',2.9),('8784','2013-09-19','10:50:00',1.65),('8784','2013-09-19','10:55:00',3.7),('8784','2013-09-19','11:00:00',3.98),('8784','2013-09-19','11:05:00',3.12),('8784','2013-09-19','11:10:00',2.24),('8784','2013-09-19','11:15:00',1.78),('8784','2013-09-19','11:20:00',2.59),('8784','2013-09-19','11:25:00',2.94),('8784','2013-09-19','11:30:00',3.45),('8784','2013-09-19','11:35:00',3.49),('8784','2013-09-19','11:40:00',2.54),('8784','2013-09-19','11:45:00',4.01),('8784','2013-09-19','11:50:00',3.5),('8784','2013-09-19','11:55:00',3.37),('8784','2013-09-19','12:00:00',2.7),('8784','2013-09-19','12:05:00',1.76),('8784','2013-09-19','12:10:00',3.64),('8784','2013-09-19','12:15:00',2.02),('8784','2013-09-19','12:20:00',4.13),('8784','2013-09-19','12:25:00',3.73),('8784','2013-09-19','12:30:00',4.17),('8784','2013-09-19','12:35:00',3.98),('8784','2013-09-19','12:40:00',3.73),('8784','2013-09-19','12:45:00',2.91),('8784','2013-09-19','12:50:00',4.21),('8784','2013-09-19','12:55:00',4.14),('8784','2013-09-19','13:00:00',4.14),('8784','2013-09-19','13:05:00',4.18),('8784','2013-09-19','13:10:00',4.39),('8784','2013-09-19','13:15:00',4.34),('8784','2013-09-19','13:20:00',3.97),('8784','2013-09-19','13:25:00',3.51),('8784','2013-09-19','13:30:00',4.02),('8784','2013-09-19','13:35:00',4.09),('8784','2013-09-19','13:40:00',4.39),('8784','2013-09-19','13:45:00',4.48),('8784','2013-09-19','13:50:00',3.44),('8784','2013-09-19','13:55:00',1.56),('8784','2013-09-19','14:00:00',1.24),('8784','2013-09-19','14:05:00',4),('8784','2013-09-19','14:10:00',3.87),('8784','2013-09-19','14:15:00',3.74),('8784','2013-09-19','14:20:00',3.66),('8784','2013-09-19','14:25:00',3.58),('8784','2013-09-19','14:30:00',3.56),('8784','2013-09-19','14:35:00',3.53),('8784','2013-09-19','14:40:00',3.21),('8784','2013-09-19','14:45:00',3.38),('8784','2013-09-19','14:50:00',3.24),('8784','2013-09-19','14:55:00',3.5),('8784','2013-09-19','15:00:00',3.28),('8784','2013-09-19','15:05:00',2.88),('8784','2013-09-19','15:10:00',2.81),('8784','2013-09-19','15:15:00',2.84),('8784','2013-09-19','15:20:00',3.26),('8784','2013-09-19','15:25:00',2.82),('8784','2013-09-19','15:30:00',2.08),('8784','2013-09-19','15:35:00',2.12),('8784','2013-09-19','15:40:00',3.19),('8784','2013-09-19','15:45:00',2.99),('8784','2013-09-19','15:50:00',2.78),('8784','2013-09-19','15:55:00',2.52),('8784','2013-09-19','16:00:00',2.61),('8784','2013-09-19','16:05:00',2.55),('8784','2013-09-19','16:10:00',2.36),('8784','2013-09-19','16:15:00',2.41),('8784','2013-09-19','16:20:00',2.48),('8784','2013-09-19','16:25:00',2.12),('8784','2013-09-19','16:30:00',1.77),('8784','2013-09-19','16:35:00',1.92),('8784','2013-09-19','16:40:00',1.36),('8784','2013-09-19','16:45:00',1.71),('8784','2013-09-19','16:50:00',1.61),('8784','2013-09-19','16:55:00',1.94),('8784','2013-09-19','17:00:00',1.56),('8784','2013-09-19','17:05:00',1.57),('8784','2013-09-19','17:10:00',1.47),('8784','2013-09-19','17:15:00',1.4),('8784','2013-09-19','17:20:00',1.22),('8784','2013-09-19','17:25:00',1.18),('8784','2013-09-19','17:30:00',1.08),('8784','2014-04-13','09:00:00',1.01),('8784','2014-04-13','09:05:00',1.37),('8784','2014-04-13','09:10:00',1.6),('8784','2014-04-13','09:15:00',1.35),('8784','2014-04-13','09:20:00',1.53),('8784','2014-04-13','09:25:00',1.73),('8784','2014-04-13','09:30:00',2.51),('8784','2014-04-13','09:35:00',1.7),('8784','2014-04-13','09:40:00',2.24),('8784','2014-04-13','09:45:00',1.99),('8784','2014-04-13','09:50:00',1.51),('8784','2014-04-13','09:55:00',1.55),('8784','2014-04-13','10:00:00',2.74),('8784','2014-04-13','10:05:00',3.93),('8784','2014-04-13','10:10:00',2.65),('8784','2014-04-13','10:15:00',2.5),('8784','2014-04-13','10:20:00',2.86),('8784','2014-04-13','10:25:00',1.96),('8784','2014-04-13','10:30:00',3.46),('8784','2014-04-13','10:35:00',3.13),('8784','2014-04-13','10:40:00',3.52),('8784','2014-04-13','10:45:00',3.7),('8784','2014-04-13','10:50:00',3.7),('8784','2014-04-13','10:55:00',3.76),('8784','2014-04-13','11:00:00',3.75),('8784','2014-04-13','11:05:00',3.87),('8784','2014-04-13','11:10:00',3.79),('8784','2014-04-13','11:15:00',4.06),('8784','2014-04-13','11:20:00',3.7),('8784','2014-04-13','11:25:00',3.08),('8784','2014-04-13','11:30:00',2.23),('8784','2014-04-13','11:35:00',2.53),('8784','2014-04-13','11:40:00',4.04),('8784','2014-04-13','11:45:00',3.93),('8784','2014-04-13','11:50:00',4.08),('8784','2014-04-13','11:55:00',2.88),('8784','2014-04-13','12:00:00',2.29),('8784','2014-04-13','12:05:00',1.82),('8784','2014-04-13','12:10:00',1.61),('8784','2014-04-13','12:15:00',1.5),('8784','2014-04-13','12:20:00',1.34),('8784','2014-04-13','13:05:00',1.45),('8784','2014-04-13','13:10:00',2.12),('8784','2014-04-13','13:15:00',2.12),('8784','2014-04-13','13:20:00',2.95),('8784','2014-04-13','13:25:00',3.21),('8784','2014-04-13','13:30:00',4.64),('8784','2014-04-13','13:35:00',4.14),('8784','2014-04-13','13:40:00',3.8),('8784','2014-04-13','13:45:00',2.09),('8784','2014-04-13','13:50:00',3.11),('8784','2014-04-13','13:55:00',2.75),('8784','2014-04-13','14:00:00',4.37),('8784','2014-04-13','14:05:00',4.16),('8784','2014-04-13','14:10:00',4.31),('8784','2014-04-13','14:15:00',4.46),('8784','2014-04-13','14:20:00',2.13),('8784','2014-04-13','14:25:00',1.79),('8784','2014-04-13','14:30:00',1.79),('8784','2014-04-13','14:35:00',1.71),('8784','2014-04-13','14:40:00',1.48),('8784','2014-04-13','14:45:00',2.08),('8784','2014-04-13','14:50:00',4.27),('8784','2014-04-13','14:55:00',3.42),('8784','2014-04-13','15:00:00',3.38),('8784','2014-04-13','15:05:00',3.82),('8784','2014-04-13','15:10:00',3.96),('8784','2014-04-13','15:15:00',3.41),('8784','2014-04-13','15:20:00',3.34),('8784','2014-04-13','15:25:00',3.57),('8784','2014-04-13','15:30:00',3.39),('8784','2014-04-13','15:35:00',2.37),('8784','2014-04-13','15:40:00',1.47),('8784','2014-04-13','15:45:00',1.72),('8784','2014-04-13','15:50:00',1.88),('8784','2014-04-13','15:55:00',1.81),('8784','2014-04-13','16:00:00',3.46),('8784','2014-04-13','16:05:00',2.84),('8784','2014-04-13','16:10:00',1.34),('8784','2014-04-13','16:15:00',1.42),('8784','2014-04-13','16:20:00',1.47),('8784','2014-04-13','16:25:00',1.77),('8784','2014-04-13','16:30:00',1.4),('8784','2014-04-13','16:35:00',1.54),('8784','2014-04-13','16:40:00',2.89),('8784','2014-04-13','16:45:00',2.82),('8784','2014-04-13','16:50:00',2.43),('8784','2014-04-13','16:55:00',2.36),('8784','2014-04-13','17:00:00',2.22),('8784','2014-04-13','17:05:00',1.52),('8784','2014-04-13','17:10:00',1.06),('8784','2014-04-13','17:15:00',1.15),('8784','2014-04-13','17:20:00',1.7),('8784','2014-04-13','17:25:00',1.38),('8784','2014-04-13','17:50:00',1.02),('8784','2014-04-13','17:55:00',1.23),('8784','2014-04-13','18:00:00',1.1),('8784','2013-09-18','08:45:00',1.32),('8784','2013-09-18','08:50:00',1.11),('8784','2013-09-18','08:55:00',1.4),('8784','2013-09-18','09:00:00',1.56),('8784','2013-09-18','09:05:00',1.54),('8784','2013-09-18','09:15:00',1.67),('8784','2013-09-18','09:20:00',2.36),('8784','2013-09-18','09:25:00',1.87),('8784','2013-09-18','09:30:00',1.06),('8784','2013-09-18','09:35:00',2.3),('8784','2013-09-18','09:40:00',2.07),('8784','2013-09-18','09:55:00',2.02),('8784','2013-09-18','10:00:00',2.65),('8784','2013-09-18','10:05:00',2.87),('8784','2013-09-18','10:10:00',2.93),('8784','2013-09-18','10:15:00',2.79),('8784','2013-09-18','10:20:00',2.86),('8784','2013-09-18','10:25:00',2.88),('8784','2013-09-18','10:30:00',2.92),('8784','2013-09-18','10:35:00',2.98),('8784','2013-09-18','10:40:00',3.02),('8784','2013-09-18','10:45:00',2.93),('8784','2013-09-18','10:50:00',2.73),('8784','2013-09-18','10:55:00',2.81),('8784','2013-09-18','11:00:00',3.45),('8784','2013-09-18','11:05:00',3.5),('8784','2013-09-18','11:10:00',3.57),('8784','2013-09-18','11:15:00',2.4),('8784','2013-09-18','11:20:00',3.05),('8784','2013-09-18','11:25:00',3.56),('8784','2013-09-18','11:30:00',3.64),('8784','2013-09-18','11:35:00',3.91),('8784','2013-09-18','11:40:00',2.87),('8784','2013-09-18','11:45:00',3.76),('8784','2013-09-18','11:50:00',3.71),('8784','2013-09-18','11:55:00',3.56),('8784','2013-09-18','12:00:00',3.85),('8784','2013-09-18','12:05:00',3.96),('8784','2013-09-18','12:10:00',3.96),('8784','2013-09-18','12:15:00',4.04),('8784','2013-09-18','12:20:00',3.79),('8784','2013-09-18','12:25:00',2.19),('8784','2013-09-18','12:30:00',2.28),('8784','2013-09-18','12:35:00',4.44),('8784','2013-09-18','12:40:00',3.08),('8784','2013-09-18','12:45:00',2.84),('8784','2013-09-18','12:50:00',3.26),('8784','2013-09-18','12:55:00',3.83),('8784','2013-09-18','13:00:00',1.54),('8784','2013-09-18','13:05:00',3.72),('8784','2013-09-18','13:10:00',4.17),('8784','2013-09-18','13:15:00',4.07),('8784','2013-09-18','13:20:00',3.99),('8784','2013-09-18','13:25:00',4.03),('8784','2013-09-18','13:30:00',3.98),('8784','2013-09-18','13:35:00',3.95),('8784','2013-09-18','13:40:00',3.96),('8784','2013-09-18','13:45:00',3.84),('8784','2013-09-18','13:50:00',4.12),('8784','2013-09-18','13:55:00',3.99),('8784','2013-09-18','14:00:00',3.51),('8784','2013-09-18','14:05:00',2.54),('8784','2013-09-18','14:10:00',3.27),('8784','2013-09-18','14:15:00',3.12),('8784','2013-09-18','14:20:00',3.74),('8784','2013-09-18','14:25:00',3.67),('8784','2013-09-18','14:30:00',3.6),('8784','2013-09-18','14:35:00',3.57),('8784','2013-09-18','14:40:00',3.56),('8784','2013-09-18','14:45:00',3.41),('8784','2013-09-18','14:50:00',3.34),('8784','2013-09-18','14:55:00',2.63),('8784','2013-09-18','15:00:00',3.16),('8784','2013-09-18','15:10:00',1.39),('8784','2013-09-18','15:15:00',2.18),('8784','2013-09-18','15:20:00',2.41),('8784','2013-09-18','15:25:00',3.25),('8784','2013-09-18','15:30:00',3.21),('8784','2013-09-18','15:35:00',3.19),('8784','2013-09-18','15:40:00',3.02),('8784','2013-09-18','15:45:00',2.85),('8784','2013-09-18','15:50:00',1.89),('8784','2013-09-18','15:55:00',2.43),('8784','2013-09-18','16:00:00',2.88),('8784','2013-09-18','16:05:00',2.91),('8784','2013-09-18','16:10:00',2.67),('8784','2013-09-18','16:15:00',2.53),('8784','2013-09-18','16:20:00',2.38),('8784','2013-09-18','16:25:00',2.07),('8784','2013-09-18','16:30:00',2),('8784','2013-09-18','16:35:00',1.86),('8784','2013-09-18','16:40:00',1.92),('8784','2013-09-18','16:45:00',1.87),('8784','2013-09-18','16:50:00',1.66),('8784','2013-09-18','16:55:00',1.63),('8784','2013-09-18','17:00:00',1.71),('8784','2013-09-18','17:05:00',1.5),('8784','2013-09-18','17:10:00',1.52),('8784','2013-09-18','17:15:00',1.45),('8784','2013-09-18','17:20:00',1.25),('8784','2013-09-18','17:25:00',1.11),('8784','2013-09-18','17:30:00',1.23),('8784','2013-09-18','17:35:00',1.1),('8784','2013-09-18','17:40:00',1.02),('8784','2013-09-17','09:20:00',1.44),('8784','2013-09-17','09:30:00',1.21),('8784','2013-09-17','09:40:00',1.42),('8784','2013-09-17','09:45:00',2.2),('8784','2013-09-17','09:50:00',1.33),('8784','2013-09-17','09:55:00',1.84),('8784','2013-09-17','10:00:00',2.13),('8784','2013-09-17','10:05:00',1.5),('8784','2013-09-17','10:10:00',1.78),('8784','2013-09-17','10:20:00',1.38),('8784','2013-09-17','10:25:00',2.36),('8784','2013-09-17','10:30:00',3.21),('8784','2013-09-17','10:35:00',1.76),('8784','2013-09-17','10:40:00',1.87),('8784','2013-09-17','10:45:00',2.4),('8784','2013-09-17','10:50:00',3.75),('8784','2013-09-17','10:55:00',3.03),('8784','2013-09-17','11:00:00',2.36),('8784','2013-09-17','11:05:00',2.08),('8784','2013-09-17','11:10:00',3.63),('8784','2013-09-17','11:15:00',2.88),('8784','2013-09-17','11:20:00',2.49),('8784','2013-09-17','11:25:00',1.8),('8784','2013-09-17','11:30:00',1.95),('8784','2013-09-17','11:35:00',3.22),('8784','2013-09-17','11:40:00',3.26),('8784','2013-09-17','11:45:00',2.96),('8784','2013-09-17','11:50:00',3.57),('8784','2013-09-17','11:55:00',3.25),('8784','2013-09-17','12:00:00',3.53),('8784','2013-09-17','12:05:00',3.13),('8784','2013-09-17','12:10:00',1.83),('8784','2013-09-17','12:15:00',2.27),('8784','2013-09-17','12:20:00',2.27),('8784','2013-09-17','12:25:00',4.08),('8784','2013-09-17','12:30:00',2.77),('8784','2013-09-17','12:35:00',2.31),('8784','2013-09-17','12:40:00',3.22),('8784','2013-09-17','12:45:00',3.94),('8784','2013-09-17','12:50:00',3.07),('8784','2013-09-17','12:55:00',3.09),('8784','2013-09-17','13:00:00',2.2),('8784','2013-09-17','13:05:00',1.56),('8784','2013-09-17','13:10:00',2.98),('8784','2013-09-17','13:15:00',3.06),('8784','2013-09-17','13:20:00',2.71),('8784','2013-09-17','13:25:00',2.53),('8784','2013-09-17','13:30:00',1.9),('8784','2013-09-17','13:35:00',2.25),('8784','2013-09-17','13:40:00',2.55),('8784','2013-09-17','13:45:00',1.53),('8784','2013-09-17','13:50:00',1.02),('8784','2013-09-17','13:55:00',1.4),('8784','2013-09-17','14:00:00',2.04),('8784','2013-09-17','14:05:00',1.28),('8784','2013-09-17','14:10:00',1.04),('8784','2013-09-17','14:15:00',1.37),('8784','2013-09-17','14:25:00',1.75),('8784','2013-09-17','14:30:00',1.05),('8784','2013-09-17','14:35:00',1.25),('8784','2013-09-17','14:50:00',1.44),('8784','2013-09-17','14:55:00',3.46),('8784','2013-09-17','15:00:00',3.39),('8784','2013-09-17','15:05:00',2.74),('8784','2013-09-17','15:10:00',2.45),('8784','2013-09-17','15:15:00',2.96),('8784','2013-09-17','15:20:00',3.04),('8784','2013-09-17','15:25:00',2.75),('8784','2013-09-17','15:30:00',2.38),('8784','2013-09-17','15:35:00',1.23),('8784','2013-09-17','15:45:00',1.39),('8784','2013-09-17','15:50:00',1.87),('8784','2013-09-17','15:55:00',2.07),('8784','2013-09-17','16:00:00',1.44),('8784','2013-09-17','16:05:00',2.04),('8784','2013-09-17','16:10:00',1.79),('8784','2013-09-17','16:15:00',1.61),('8784','2013-09-17','16:20:00',1.08),('8784','2013-09-17','16:40:00',1.29),('8784','2013-09-17','16:45:00',1.56),('8784','2013-09-17','16:50:00',1.26),('8784','2013-09-17','16:55:00',1.06),('8784','2013-09-17','17:00:00',1.57),('8784','2013-09-17','17:05:00',1.72),('8784','2013-09-17','17:10:00',1.59),('8784','2013-09-17','17:15:00',1.58),('8784','2013-09-17','17:20:00',1.23),('8784','2013-09-17','17:25:00',1.3),('8784','2013-09-17','17:30:00',1.27),('8784','2013-09-17','17:40:00',1.02),('8784','2013-09-16','08:10:00',1.09),('8784','2013-09-16','08:15:00',1.09),('8784','2013-09-16','08:20:00',1.12),('8784','2013-09-16','08:25:00',1.19),('8784','2013-09-16','08:30:00',1.27),('8784','2013-09-16','08:35:00',1.36),('8784','2013-09-16','08:40:00',1.57),('8784','2013-09-16','08:45:00',1.46),('8784','2013-09-16','08:50:00',1.17),('8784','2013-09-16','09:05:00',1.98),('8784','2013-09-16','09:10:00',1.87),('8784','2013-09-16','09:15:00',2.12),('8784','2013-09-16','09:20:00',2.13),('8784','2013-09-16','09:25:00',2),('8784','2013-09-16','09:30:00',1.7),('8784','2013-09-16','09:35:00',2.29),('8784','2013-09-16','09:40:00',2.36),('8784','2013-09-16','09:45:00',2.42),('8784','2013-09-16','09:50:00',2.5),('8784','2013-09-16','09:55:00',2.09),('8784','2013-09-16','10:00:00',2.66),('8784','2013-09-16','10:05:00',2.86),('8784','2013-09-16','10:10:00',1.89),('8784','2013-09-16','10:15:00',1.05),('8784','2013-09-16','10:20:00',2.77),('8784','2013-09-16','10:25:00',2.01),('8784','2013-09-16','10:30:00',3.28),('8784','2013-09-16','10:35:00',3.49),('8784','2013-09-16','10:40:00',3.7),('8784','2013-09-16','10:45:00',3.92),('8784','2013-09-16','10:50:00',2.75),('8784','2013-09-16','11:00:00',1.27),('8784','2013-09-16','11:05:00',1.18),('8784','2013-09-16','11:25:00',3.5),('8784','2013-09-16','11:30:00',3.87),('8784','2013-09-16','11:35:00',3.86),('8784','2013-09-16','11:40:00',3.94),('8784','2013-09-16','11:45:00',2.89),('8784','2013-09-16','11:50:00',4.1),('8784','2013-09-16','11:55:00',3.95),('8784','2013-09-16','12:00:00',4.11),('8784','2013-09-16','12:05:00',4.03),('8784','2013-09-16','12:10:00',4.42),('8784','2013-09-16','12:15:00',3.9),('8784','2013-09-16','12:20:00',3.98),('8784','2013-09-16','12:25:00',3.96),('8784','2013-09-16','12:30:00',3.94),('8784','2013-09-16','12:35:00',3.88),('8784','2013-09-16','12:40:00',4.17),('8784','2013-09-16','12:45:00',3.25),('8784','2013-09-16','12:50:00',4.6),('8784','2013-09-16','12:55:00',4.19),('8784','2013-09-16','13:00:00',3.19),('8784','2013-09-16','13:05:00',2.99),('8784','2013-09-16','13:10:00',4.23),('8784','2013-09-16','13:15:00',3.85),('8784','2013-09-16','13:20:00',3.94),('8784','2013-09-16','13:25:00',3.94),('8784','2013-09-16','13:30:00',3.89),('8784','2013-09-16','13:35:00',3.91),('8784','2013-09-16','13:40:00',3.91),('8784','2013-09-16','13:45:00',3.9),('8784','2013-09-16','13:50:00',3.95),('8784','2013-09-16','13:55:00',3.99),('8784','2013-09-16','14:00:00',3.68),('8784','2013-09-16','14:05:00',3.83),('8784','2013-09-16','14:10:00',3.74),('8784','2013-09-16','14:15:00',3.71),('8784','2013-09-16','14:20:00',3.67),('8784','2013-09-16','14:25:00',3.64),('8784','2013-09-16','14:30:00',3.6),('8784','2013-09-16','14:35:00',3.56),('8784','2013-09-16','14:40:00',3.5),('8784','2013-09-16','14:45:00',3.48),('8784','2013-09-16','14:50:00',3.45),('8784','2013-09-16','14:55:00',3.4),('8784','2013-09-16','15:00:00',3.38),('8784','2013-09-16','15:05:00',3.32),('8784','2013-09-16','15:10:00',3.28),('8784','2013-09-16','15:15:00',3.25),('8784','2013-09-16','15:20:00',3.18),('8784','2013-09-16','15:25:00',3.13),('8784','2013-09-16','15:30:00',3.06),('8784','2013-09-16','15:35:00',3.02),('8784','2013-09-16','15:40:00',2.97),('8784','2013-09-16','15:45:00',2.89),('8784','2013-09-16','15:50:00',2.8),('8784','2013-09-16','15:55:00',2.77),('8784','2013-09-16','16:00:00',2.61),('8784','2013-09-16','16:05:00',2.13),('8784','2013-09-16','16:10:00',2.66),('8784','2013-09-16','16:15:00',2.51),('8784','2013-09-16','16:20:00',2.42),('8784','2013-09-16','16:25:00',2.35),('8784','2013-09-16','16:30:00',2.27),('8784','2013-09-16','16:35:00',2.19),('8784','2013-09-16','16:40:00',2.13),('8784','2013-09-16','16:45:00',2.04),('8784','2013-09-16','16:50:00',1.92),('8784','2013-09-16','16:55:00',1.86),('8784','2013-09-16','17:00:00',1.78),('8784','2013-09-16','17:05:00',1.7),('8784','2013-09-16','17:10:00',1.61),('8784','2013-09-16','17:15:00',1.51),('8784','2013-09-16','17:20:00',1.43),('8784','2013-09-16','17:25:00',1.35),('8784','2013-09-16','17:30:00',1.29),('8784','2013-09-16','17:45:00',1.04),('8784','2013-09-15','08:15:00',1.09),('8784','2013-09-15','08:20:00',1.17),('8784','2013-09-15','08:25:00',1.26),('8784','2013-09-15','08:30:00',1.35),('8784','2013-09-15','08:35:00',1.45),('8784','2013-09-15','08:40:00',1.56),('8784','2013-09-15','08:45:00',1.66),('8784','2013-09-15','08:50:00',1.68),('8784','2013-09-15','08:55:00',1.62),('8784','2013-09-15','09:00:00',1.72),('8784','2013-09-15','09:05:00',1.79),('8784','2013-09-15','09:10:00',1.96),('8784','2013-09-15','09:15:00',2.14),('8784','2013-09-15','09:20:00',2.08),('8784','2013-09-15','09:25:00',2.19),('8784','2013-09-15','09:30:00',2.21),('8784','2013-09-15','09:35:00',2.38),('8784','2013-09-15','09:40:00',2.43),('8784','2013-09-15','09:45:00',2.47),('8784','2013-09-15','09:50:00',2.59),('8784','2013-09-15','09:55:00',2.65),('8784','2013-09-15','10:00:00',2.73),('8784','2013-09-15','10:05:00',2.81),('8784','2013-09-15','10:10:00',2.84),('8784','2013-09-15','10:15:00',2.81),('8784','2013-09-15','10:20:00',2.85),('8784','2013-09-15','10:25:00',2.92),('8784','2013-09-15','10:30:00',2.81),('8784','2013-09-15','10:35:00',1.61),('8784','2013-09-15','10:40:00',1.61),('8784','2013-09-15','10:50:00',2.12),('8784','2013-09-15','10:55:00',3.45),('8784','2013-09-15','11:00:00',3.76),('8784','2013-09-15','11:05:00',3.84),('8784','2013-09-15','11:10:00',1.93),('8784','2013-09-15','11:15:00',1.27),('8784','2013-09-15','11:20:00',1.38),('8784','2013-09-15','11:30:00',3.01),('8784','2013-09-15','11:35:00',2.1),('8784','2013-09-15','11:40:00',1.52),('8784','2013-09-15','11:45:00',2.57),('8784','2013-09-15','11:50:00',2.53),('8784','2013-09-15','11:55:00',1.54),('8784','2013-09-15','12:00:00',1.43),('8784','2013-09-15','12:05:00',1.24),('8784','2013-09-15','12:10:00',1.22),('8784','2013-09-15','12:15:00',1.32),('8784','2013-09-15','12:20:00',1.63),('8784','2013-09-15','12:25:00',1.83),('8784','2013-09-15','12:30:00',1.72),('8784','2013-09-15','12:35:00',1.58),('8784','2013-09-15','12:40:00',1.54),('8784','2013-09-15','12:45:00',1.23),('8784','2013-09-15','12:50:00',1.45),('8784','2013-09-15','12:55:00',1.44),('8784','2013-09-15','13:00:00',1.34),('8784','2013-09-15','13:05:00',1.11),('8784','2013-09-15','13:25:00',1.14),('8784','2013-09-15','13:30:00',1.17),('8784','2013-09-15','13:35:00',1.28),('8784','2013-09-15','13:40:00',1.49),('8784','2013-09-15','13:45:00',2.35),('8784','2013-09-15','13:50:00',1.81),('8784','2013-09-15','13:55:00',1.3),('8784','2013-09-15','14:00:00',2.01),('8784','2013-09-15','14:05:00',1.86),('8784','2013-09-15','14:10:00',1.66),('8784','2013-09-15','14:15:00',1.6),('8784','2013-09-15','14:20:00',1.53),('8784','2013-09-15','14:25:00',1.5),('8784','2013-09-15','14:30:00',1.41),('8784','2013-09-15','14:35:00',1.19),('8784','2013-09-15','14:40:00',1.22),('8784','2013-09-15','14:45:00',1.11),('8784','2013-09-15','14:50:00',1.18),('8784','2013-09-15','14:55:00',1.19),('8784','2013-09-15','15:00:00',1.21),('8784','2013-09-15','15:05:00',1.29),('8784','2013-09-15','15:10:00',1.48),('8784','2013-09-15','15:15:00',2.96),('8784','2013-09-15','15:20:00',2.13),('8784','2013-09-15','15:25:00',1.58),('8784','2013-09-15','15:30:00',1.19),('8784','2013-09-15','15:35:00',1.19),('8784','2013-09-15','15:40:00',1.11),('8784','2013-09-15','15:45:00',1.07),('8784','2013-09-15','15:50:00',1.06),('8784','2013-09-15','15:55:00',1.04),('8784','2013-09-15','16:05:00',1.01),('8784','2013-09-14','08:15:00',1.05),('8784','2013-09-14','08:20:00',1.12),('8784','2013-09-14','08:25:00',1.2),('8784','2013-09-14','08:30:00',1.28),('8784','2013-09-14','08:35:00',1.37),('8784','2013-09-14','08:40:00',1.47),('8784','2013-09-14','08:45:00',1.54),('8784','2013-09-14','08:50:00',1.64),('8784','2013-09-14','08:55:00',1.72),('8784','2013-09-14','09:00:00',1.82),('8784','2013-09-14','09:05:00',1.9),('8784','2013-09-14','09:10:00',1.98),('8784','2013-09-14','09:15:00',2.07),('8784','2013-09-14','09:20:00',2.14),('8784','2013-09-14','09:25:00',2.22),('8784','2013-09-14','09:30:00',2.29),('8784','2013-09-14','09:35:00',2.33),('8784','2013-09-14','09:40:00',2.41),('8784','2013-09-14','09:45:00',2.49),('8784','2013-09-14','09:50:00',2.53),('8784','2013-09-14','09:55:00',2.64),('8784','2013-09-14','10:00:00',2.58),('8784','2013-09-14','10:05:00',2.69),('8784','2013-09-14','10:10:00',2.53),('8784','2013-09-14','10:15:00',2.64),('8784','2013-09-14','10:20:00',2.84),('8784','2013-09-14','10:25:00',2.94),('8784','2013-09-14','10:30:00',2.97),('8784','2013-09-14','10:35:00',3.17),('8784','2013-09-14','10:40:00',3.31),('8784','2013-09-14','10:45:00',2.46),('8784','2013-09-14','10:50:00',3.95),('8784','2013-09-14','10:55:00',3.01),('8784','2013-09-14','11:00:00',2.69),('8784','2013-09-14','11:05:00',1.06),('8784','2013-09-14','11:10:00',2.32),('8784','2013-09-14','11:15:00',1.21),('8784','2013-09-14','11:25:00',3.74),('8784','2013-09-14','11:30:00',3.72),('8784','2013-09-14','11:35:00',3.91),('8784','2013-09-14','11:40:00',3.89),('8784','2013-09-14','11:45:00',3.9),('8784','2013-09-14','11:50:00',2.17),('8784','2013-09-14','11:55:00',1.08),('8784','2013-09-14','12:10:00',2.36),('8784','2013-09-14','12:30:00',1.52),('8784','2013-09-14','12:35:00',2.64),('8784','2013-09-14','12:40:00',1.29),('8784','2013-09-14','12:45:00',1.08),('8784','2013-09-14','12:55:00',1.04),('8784','2013-09-14','13:00:00',1.01),('8784','2013-09-14','13:10:00',2.51),('8784','2013-09-14','13:15:00',4.14),('8784','2013-09-14','13:20:00',3.25),('8784','2013-09-14','13:25:00',4.24),('8784','2013-09-14','13:30:00',3.3),('8784','2013-09-14','13:35:00',2.43),('8784','2013-09-14','13:40:00',3.48),('8784','2013-09-14','13:45:00',2.7),('8784','2013-09-14','13:50:00',3.2),('8784','2013-09-14','13:55:00',4.58),('8784','2013-09-14','14:00:00',4.13),('8784','2013-09-14','14:05:00',3.92),('8784','2013-09-14','14:10:00',3.82),('8784','2013-09-14','14:15:00',3.83),('8784','2013-09-14','14:20:00',3.72),('8784','2013-09-14','14:25:00',3.73),('8784','2013-09-14','14:30:00',3.69),('8784','2013-09-14','14:35:00',3.62),('8784','2013-09-14','14:40:00',3.61),('8784','2013-09-14','14:45:00',3.54),('8784','2013-09-14','14:50:00',3.51),('8784','2013-09-14','14:55:00',3.47),('8784','2013-09-14','15:00:00',3.4),('8784','2013-09-14','15:05:00',3.32),('8784','2013-09-14','15:10:00',3.3),('8784','2013-09-14','15:15:00',3.25),('8784','2013-09-14','15:20:00',3.2),('8784','2013-09-14','15:25:00',2.5),('8784','2013-09-14','15:30:00',3.14),('8784','2013-09-14','15:35:00',3.05),('8784','2013-09-14','15:40:00',2.99),('8784','2013-09-14','15:45:00',2.91),('8784','2013-09-14','15:50:00',2.84),('8784','2013-09-14','15:55:00',2.77),('8784','2013-09-14','16:00:00',2.69),('8784','2013-09-14','16:05:00',2.63),('8784','2013-09-14','16:10:00',2.55),('8784','2013-09-14','16:15:00',2.49),('8784','2013-09-14','16:20:00',2.39),('8784','2013-09-14','16:25:00',2.37),('8784','2013-09-14','16:30:00',2.29),('8784','2013-09-14','16:35:00',2.2),('8784','2013-09-14','16:40:00',2.12),('8784','2013-09-14','16:45:00',2.05),('8784','2013-09-14','16:50:00',1.98),('8784','2013-09-14','16:55:00',1.88),('8784','2013-09-14','17:00:00',1.79),('8784','2013-09-14','17:05:00',1.72),('8784','2013-09-14','17:10:00',1.61),('8784','2013-09-14','17:15:00',1.57),('8784','2013-09-14','17:20:00',1.46),('8784','2013-09-14','17:25:00',1.37),('8784','2013-09-14','17:30:00',1.28),('8784','2013-09-14','17:40:00',1.12),('8784','2013-09-14','17:45:00',1.06),('8784','2013-09-13','08:50:00',1.02),('8784','2013-09-13','08:55:00',1.1),('8784','2013-09-13','09:00:00',1.05),('8784','2013-09-13','09:05:00',1.02),('8784','2013-09-13','09:15:00',1.04),('8784','2013-09-13','09:20:00',1.08),('8784','2013-09-13','09:25:00',1.2),('8784','2013-09-13','09:30:00',1.28),('8784','2013-09-13','09:35:00',1.38),('8784','2013-09-13','09:40:00',1.48),('8784','2013-09-13','09:45:00',1.41),('8784','2013-09-13','09:50:00',1.7),('8784','2013-09-13','09:55:00',2.86),('8784','2013-09-13','10:00:00',2.37),('8784','2013-09-13','10:05:00',1.42),('8784','2013-09-13','10:10:00',2.35),('8784','2013-09-13','10:15:00',3.75),('8784','2013-09-13','10:20:00',3.46),('8784','2013-09-13','10:25:00',1.67),('8784','2013-09-13','10:30:00',2.59),('8784','2013-09-13','10:35:00',3.25),('8784','2013-09-13','10:40:00',3.23),('8784','2013-09-13','10:45:00',3.25),('8784','2013-09-13','10:50:00',3.31),('8784','2013-09-13','10:55:00',3.35),('8784','2013-09-13','11:00:00',3.39),('8784','2013-09-13','11:05:00',3.41),('8784','2013-09-13','11:10:00',3.47),('8784','2013-09-13','11:15:00',3.51),('8784','2013-09-13','11:20:00',3.54),('8784','2013-09-13','11:25:00',3.57),('8784','2013-09-13','11:30:00',3.61),('8784','2013-09-13','11:35:00',3.67),('8784','2013-09-13','11:40:00',3.69),('8784','2013-09-13','11:45:00',3.71),('8784','2013-09-13','11:50:00',3.69),('8784','2013-09-13','11:55:00',3.75),('8784','2013-09-13','12:00:00',3.72),('8784','2013-09-13','12:05:00',3.79),('8784','2013-09-13','12:10:00',3.71),('8784','2013-09-13','12:15:00',3.84),('8784','2013-09-13','12:20:00',3.9),('8784','2013-09-13','12:25:00',3.91),('8784','2013-09-13','12:30:00',3.98),('8784','2013-09-13','12:35:00',3.97),('8784','2013-09-13','12:40:00',4.03),('8784','2013-09-13','12:45:00',4.04),('8784','2013-09-13','12:50:00',4.03),('8784','2013-09-13','12:55:00',4.03),('8784','2013-09-13','13:00:00',3.97),('8784','2013-09-13','13:05:00',3.93),('8784','2013-09-13','13:10:00',3.93),('8784','2013-09-13','13:15:00',3.88),('8784','2013-09-13','13:20:00',3.86),('8784','2013-09-13','13:25:00',3.85),('8784','2013-09-13','13:30:00',3.81),('8784','2013-09-13','13:35:00',3.79),('8784','2013-09-13','13:40:00',3.78),('8784','2013-09-13','13:45:00',3.8),('8784','2013-09-13','13:50:00',3.78),('8784','2013-09-13','13:55:00',3.75),('8784','2013-09-13','14:00:00',3.74),('8784','2013-09-13','14:05:00',3.71),('8784','2013-09-13','14:10:00',3.71),('8784','2013-09-13','14:15:00',3.68),('8784','2013-09-13','14:20:00',3.68),('8784','2013-09-13','14:25:00',1.86),('8784','2013-09-13','14:35:00',2.43),('8784','2013-09-13','14:40:00',3.62),('8784','2013-09-13','14:45:00',2.29),('8784','2013-09-13','14:50:00',3.39),('8784','2013-09-13','14:55:00',3.36),('8784','2013-09-13','15:00:00',3.42),('8784','2013-09-13','15:05:00',3.37),('8784','2013-09-13','15:10:00',3.34),('8784','2013-09-13','15:15:00',3.27),('8784','2013-09-13','15:20:00',3.18),('8784','2013-09-13','15:25:00',3.16),('8784','2013-09-13','15:30:00',3.12),('8784','2013-09-13','15:35:00',3.07),('8784','2013-09-13','15:40:00',3.01),('8784','2013-09-13','15:45:00',2.96),('8784','2013-09-13','15:50:00',2.9),('8784','2013-09-13','15:55:00',2.82),('8784','2013-09-13','16:00:00',2.76),('8784','2013-09-13','16:05:00',2.7),('8784','2013-09-13','16:10:00',2.64),('8784','2013-09-13','16:15:00',2.56),('8784','2013-09-13','16:20:00',2.48),('8784','2013-09-13','16:25:00',2.41),('8784','2013-09-13','16:30:00',2.34),('8784','2013-09-13','16:35:00',2.24),('8784','2013-09-13','16:40:00',2.16),('8784','2013-09-13','16:45:00',2.08),('8784','2013-09-13','16:50:00',1.99),('8784','2013-09-13','16:55:00',1.9),('8784','2013-09-13','17:00:00',1.82),('8784','2013-09-13','17:05:00',1.73),('8784','2013-09-13','17:10:00',1.64),('8784','2013-09-13','17:15:00',1.56),('8784','2013-09-13','17:20:00',1.48),('8784','2013-09-13','17:25:00',1.39),('8784','2013-09-13','17:30:00',1.29),('8784','2013-09-13','17:35:00',1.22),('8784','2013-09-13','17:40:00',1.13),('8784','2013-09-13','17:45:00',1.05),('8784','2013-09-12','08:00:00',1.01),('8784','2013-09-12','08:15:00',1.27),('8784','2013-09-12','08:20:00',1.28),('8784','2013-09-12','08:25:00',1.5),('8784','2013-09-12','08:30:00',1.61),('8784','2013-09-12','08:35:00',1.58),('8784','2013-09-12','08:40:00',1.06),('8784','2013-09-12','08:55:00',1.5),('8784','2013-09-12','09:00:00',1.83),('8784','2013-09-12','09:05:00',1.71),('8784','2013-09-12','09:10:00',1.27),('8784','2013-09-12','09:15:00',1.97),('8784','2013-09-12','09:20:00',2.06),('8784','2013-09-12','09:25:00',2.25),('8784','2013-09-12','09:30:00',2.42),('8784','2013-09-12','09:35:00',2.32),('8784','2013-09-12','09:40:00',1.78),('8784','2013-09-12','09:45:00',2.42),('8784','2013-09-12','09:50:00',2.09),('8784','2013-09-12','09:55:00',1.24),('8784','2013-09-12','10:00:00',1.16),('8784','2013-09-12','10:05:00',1.53),('8784','2013-09-12','10:10:00',1.85),('8784','2013-09-12','10:15:00',1.9),('8784','2013-09-12','10:20:00',1.23),('8784','2013-09-12','10:25:00',1.12),('8784','2013-09-12','10:30:00',2.52),('8784','2013-09-12','10:35:00',1.94),('8784','2013-09-12','10:55:00',2.09),('8784','2013-09-12','11:00:00',2.53),('8784','2013-09-12','11:05:00',3.62),('8784','2013-09-12','11:10:00',2.87),('8784','2013-09-12','11:15:00',2.63),('8784','2013-09-12','11:20:00',1.4),('8784','2013-09-12','11:40:00',1.39),('8784','2013-09-12','11:45:00',2.3),('8784','2013-09-12','11:50:00',1.71),('8784','2013-09-12','11:55:00',2.53),('8784','2013-09-12','12:00:00',2.96),('8784','2013-09-12','12:05:00',3.73),('8784','2013-09-12','12:10:00',2.72),('8784','2013-09-12','12:15:00',2.82),('8784','2013-09-12','12:20:00',1.45),('8784','2013-09-12','12:25:00',2.06),('8784','2013-09-12','12:30:00',1.54),('8784','2013-09-12','12:35:00',3.14),('8784','2013-09-12','12:40:00',2.96),('8784','2013-09-12','12:45:00',1.08),('8784','2013-09-12','12:50:00',2.18),('8784','2013-09-12','12:55:00',2.49),('8784','2013-09-12','13:00:00',3.9),('8784','2013-09-12','13:05:00',2.25),('8784','2013-09-12','13:10:00',2.19),('8784','2013-09-12','13:15:00',4.13),('8784','2013-09-12','13:20:00',4.52),('8784','2013-09-12','13:25:00',4.44),('8784','2013-09-12','13:30:00',3.42),('8784','2013-09-12','13:35:00',2.37),('8784','2013-09-12','13:40:00',3.27),('8784','2013-09-12','13:45:00',2.63),('8784','2013-09-12','13:50:00',3.79),('8784','2013-09-12','13:55:00',4),('8784','2013-09-12','14:00:00',3.63),('8784','2013-09-12','14:05:00',3.58),('8784','2013-09-12','14:10:00',3.63),('8784','2013-09-12','14:15:00',3.67),('8784','2013-09-12','14:20:00',3.95),('8784','2013-09-12','14:25:00',3.77),('8784','2013-09-12','14:30:00',3.95),('8784','2013-09-12','14:35:00',2),('8784','2013-09-12','14:40:00',1.93),('8784','2013-09-12','14:45:00',3.58),('8784','2013-09-12','14:50:00',3.63),('8784','2013-09-12','14:55:00',3.54),('8784','2013-09-12','15:00:00',2.93),('8784','2013-09-12','15:05:00',2.34),('8784','2013-09-12','15:10:00',2.52),('8784','2013-09-12','15:15:00',3.32),('8784','2013-09-12','15:20:00',3.27),('8784','2013-09-12','15:25:00',3.09),('8784','2013-09-12','15:30:00',3.2),('8784','2013-09-12','15:35:00',3.12),('8784','2013-09-12','15:40:00',3.08),('8784','2013-09-12','15:45:00',3.03),('8784','2013-09-12','15:50:00',2.97),('8784','2013-09-12','15:55:00',2.92),('8784','2013-09-12','16:00:00',2.92),('8784','2013-09-12','16:05:00',1.6),('8784','2013-09-12','16:10:00',2.88),('8784','2013-09-12','16:15:00',1.8),('8784','2013-09-12','16:20:00',1.99),('8784','2013-09-12','16:25:00',1.49),('8784','2013-09-12','16:30:00',2.34),('8784','2013-09-12','16:40:00',2.41),('8784','2013-09-12','16:45:00',2.29),('8784','2013-09-12','16:55:00',1.18),('8784','2013-09-12','17:00:00',1.85),('8784','2013-09-12','17:05:00',1.92),('8784','2013-09-12','17:10:00',1.66),('8784','2013-09-12','17:15:00',1.39),('8784','2013-09-12','17:30:00',1.5),('8784','2013-09-12','17:35:00',1.38),('8784','2013-09-12','17:40:00',1.27),('8784','2013-09-12','17:45:00',1.17),('8784','2013-09-12','17:50:00',1.04),('8784','2013-09-11','08:05:00',1.18),('8784','2013-09-11','08:10:00',1.13),('8784','2013-09-11','08:15:00',1.03),('8784','2013-09-11','08:30:00',1.16),('8784','2013-09-11','08:55:00',1.17),('8784','2013-09-11','09:00:00',1.93),('8784','2013-09-11','09:05:00',2.14),('8784','2013-09-11','09:10:00',1.87),('8784','2013-09-11','09:15:00',2.3),('8784','2013-09-11','09:20:00',2.49),('8784','2013-09-11','09:25:00',1.68),('8784','2013-09-11','09:30:00',1.3),('8784','2013-09-11','09:35:00',2.04),('8784','2013-09-11','09:40:00',1.54),('8784','2013-09-11','10:00:00',1.11),('8784','2013-09-11','10:05:00',1.98),('8784','2013-09-11','10:15:00',2.73),('8784','2013-09-11','10:20:00',2.47),('8784','2013-09-11','10:25:00',1.92),('8784','2013-09-11','10:30:00',3.21),('8784','2013-09-11','10:35:00',2.33),('8784','2013-09-11','10:40:00',2.6),('8784','2013-09-11','10:45:00',2.51),('8784','2013-09-11','10:50:00',2.67),('8784','2013-09-11','10:55:00',1.73),('8784','2013-09-11','11:00:00',1.91),('8784','2013-09-11','11:05:00',2.84),('8784','2013-09-11','11:10:00',3.38),('8784','2013-09-11','11:15:00',3.32),('8784','2013-09-11','11:20:00',3.48),('8784','2013-09-11','11:25:00',2.08),('8784','2013-09-11','11:30:00',2.1),('8784','2013-09-11','11:35:00',2.31),('8784','2013-09-11','11:40:00',4),('8784','2013-09-11','11:45:00',3.91),('8784','2013-09-11','11:50:00',3.85),('8784','2013-09-11','11:55:00',3.01),('8784','2013-09-11','12:00:00',3.87),('8784','2013-09-11','12:05:00',3.53),('8784','2013-09-11','12:10:00',2.43),('8784','2013-09-11','12:15:00',1.87),('8784','2013-09-11','12:20:00',2.3),('8784','2013-09-11','12:25:00',2.83),('8784','2013-09-11','12:30:00',2.07),('8784','2013-09-11','12:35:00',2.75),('8784','2013-09-11','12:40:00',2.2),('8784','2013-09-11','12:45:00',3.14),('8784','2013-09-11','14:05:00',2.55),('8784','2013-09-11','14:10:00',2.8),('8784','2013-09-11','14:15:00',3.79),('8784','2013-09-11','14:20:00',3.17),('8784','2013-09-11','14:25:00',3.48),('8784','2013-09-11','14:30:00',1.16),('8784','2013-09-11','14:35:00',2.87),('8784','2013-09-11','14:40:00',2.54),('8784','2013-09-11','14:45:00',3.38),('8784','2013-09-11','14:50:00',2.4),('8784','2013-09-11','14:55:00',1.79),('8784','2013-09-11','15:00:00',3.45),('8784','2013-09-11','15:05:00',3.74),('8784','2013-09-11','15:10:00',2.51),('8784','2013-09-11','15:15:00',3.7),('8784','2013-09-11','15:20:00',3.66),('8784','2013-09-11','15:25:00',1.42),('8784','2013-09-11','15:30:00',1.59),('8784','2013-09-11','15:40:00',1.41),('8784','2013-09-11','15:45:00',2.9),('8784','2013-09-11','15:50:00',3.09),('8784','2013-09-11','15:55:00',2.8),('8784','2013-09-11','16:00:00',2.33),('8784','2013-09-11','16:05:00',3.04),('8784','2013-09-11','16:10:00',2.81),('8784','2013-09-11','16:15:00',2.64),('8784','2013-09-11','16:20:00',2.21),('8784','2013-09-11','16:25:00',2.14),('8784','2013-09-11','16:30:00',1.5),('8784','2013-09-11','16:35:00',1.28),('8784','2013-09-11','16:40:00',1.66),('8784','2013-09-11','16:45:00',2.21),('8784','2013-09-11','16:50:00',1.84),('8784','2013-09-11','16:55:00',1.21),('8784','2013-09-11','17:00:00',1.86),('8784','2013-09-11','17:05:00',1.82),('8784','2013-09-11','17:10:00',1.74),('8784','2013-09-11','17:15:00',1.62),('8784','2013-09-11','17:20:00',1.55),('8784','2013-09-11','17:25:00',1.44),('8784','2013-09-11','17:30:00',1.36),('8784','2013-09-11','17:35:00',1.29),('8784','2013-09-11','17:40:00',1.06),('8784','2013-09-11','17:45:00',1.11),('8784','2013-09-10','08:55:00',1.66),('8784','2013-09-10','09:00:00',1.75),('8784','2013-09-10','09:05:00',1.82),('8784','2013-09-10','09:10:00',2.33),('8784','2013-09-10','09:15:00',1.91),('8784','2013-09-10','09:20:00',1.55),('8784','2013-09-10','09:25:00',1.6),('8784','2013-09-10','09:30:00',2.65),('8784','2013-09-10','09:35:00',2.85),('8784','2013-09-10','09:40:00',1.66),('8784','2013-09-10','09:45:00',1.42),('8784','2013-09-10','09:50:00',1.31),('8784','2013-09-10','09:55:00',1.18),('8784','2013-09-10','10:25:00',1.1),('8784','2013-09-10','10:30:00',1.08),('8784','2013-09-10','10:35:00',1.23),('8784','2013-09-10','10:40:00',1.64),('8784','2013-09-10','10:45:00',2.28),('8784','2013-09-10','10:50:00',1.35),('8784','2013-09-10','10:55:00',1.43),('8784','2013-09-10','11:00:00',1.71),('8784','2013-09-10','11:05:00',1.5),('8784','2013-09-10','11:10:00',1.5),('8784','2013-09-10','11:15:00',1.3),('8784','2013-09-10','11:20:00',1.42),('8784','2013-09-10','11:25:00',1.52),('8784','2013-09-10','11:30:00',1.18),('8784','2013-09-10','11:45:00',1.43),('8784','2013-09-10','11:50:00',1.4),('8784','2013-09-10','11:55:00',1.71),('8784','2013-09-10','12:00:00',1.49),('8784','2013-09-10','12:05:00',1.12),('8784','2013-09-10','12:10:00',1.12),('8784','2013-09-10','12:15:00',1.1),('8784','2013-09-10','12:20:00',1.08),('8784','2013-09-10','12:25:00',1.01),('8784','2013-09-10','13:25:00',1.2),('8784','2013-09-10','13:30:00',1.1),('8784','2013-09-10','13:35:00',1.2),('8784','2013-09-10','13:40:00',1.96),('8784','2013-09-10','13:45:00',2.86),('8784','2013-09-10','13:50:00',1.91),('8784','2013-09-10','13:55:00',1.63),('8784','2013-09-10','14:00:00',1.21),('8784','2013-09-10','14:05:00',1.42),('8784','2013-09-10','14:10:00',1.46),('8784','2013-09-10','14:15:00',1.73),('8784','2013-09-10','14:20:00',1.71),('8784','2013-09-10','14:25:00',2.32),('8784','2013-09-10','14:30:00',2.03),('8784','2013-09-10','14:35:00',1.56),('8784','2013-09-10','14:40:00',1.87),('8784','2013-09-10','14:45:00',1.97),('8784','2013-09-10','14:50:00',2.25),('8784','2013-09-10','14:55:00',1.95),('8784','2013-09-10','15:00:00',2.53),('8784','2013-09-10','15:05:00',2.27),('8784','2013-09-10','15:10:00',1.76),('8784','2013-09-10','15:15:00',1.66),('8784','2013-09-10','15:20:00',2.04),('8784','2013-09-10','15:25:00',1.83),('8784','2013-09-10','15:30:00',2.15),('8784','2013-09-10','15:35:00',1.78),('8784','2013-09-10','15:40:00',1.26),('8784','2013-09-10','15:45:00',1.1),('8784','2013-09-10','15:50:00',1.14),('8784','2013-09-10','15:55:00',1.11),('8784','2013-09-10','16:00:00',1.1),('8784','2013-09-10','16:05:00',1.19),('8784','2013-09-10','16:10:00',1.39),('8784','2013-09-10','16:15:00',1.51),('8784','2013-09-10','16:20:00',1.09),('8784','2013-09-10','16:25:00',1.02),('8784','2013-09-09','07:45:00',1.06),('8784','2013-09-09','07:50:00',1.09),('8784','2013-09-09','08:50:00',1.05),('8784','2013-09-09','08:55:00',1.27),('8784','2013-09-09','09:00:00',1.3),('8784','2013-09-09','09:05:00',1.18),('8784','2013-09-09','09:10:00',1.02),('8784','2013-09-09','09:35:00',1.21),('8784','2013-09-09','09:40:00',1.07),('8784','2013-09-09','10:00:00',1.53),('8784','2013-09-09','10:05:00',1.88),('8784','2013-09-09','10:10:00',1.84),('8784','2013-09-09','10:15:00',1.77),('8784','2013-09-09','10:20:00',1.65),('8784','2013-09-09','10:25:00',1.61),('8784','2013-09-09','10:30:00',1.66),('8784','2013-09-09','10:35:00',1.67),('8784','2013-09-09','10:40:00',1.84),('8784','2013-09-09','10:45:00',2.08),('8784','2013-09-09','10:50:00',2.63),('8784','2013-09-09','10:55:00',2.53),('8784','2013-09-09','11:00:00',2.81),('8784','2013-09-09','11:05:00',2.12),('8784','2013-09-09','11:10:00',2.21),('8784','2013-09-09','11:15:00',2.3),('8784','2013-09-09','11:20:00',2.53),('8784','2013-09-09','11:25:00',2.54),('8784','2013-09-09','11:30:00',2.22),('8784','2013-09-09','11:35:00',2.3),('8784','2013-09-09','11:40:00',3.29),('8784','2013-09-09','11:45:00',3.5),('8784','2013-09-09','11:50:00',3.67),('8784','2013-09-09','11:55:00',2.89),('8784','2013-09-09','12:00:00',2.82),('8784','2013-09-09','12:05:00',2.81),('8784','2013-09-09','12:10:00',2.98),('8784','2013-09-09','12:15:00',2.5),('8784','2013-09-09','12:20:00',1.53),('8784','2013-09-09','12:25:00',1.23),('8784','2013-09-09','12:30:00',1.14),('8784','2013-09-09','12:35:00',1.12),('8784','2013-09-09','12:40:00',1.69),('8784','2013-09-09','12:45:00',1.58),('8784','2013-09-09','12:50:00',1.3),('8784','2013-09-09','12:55:00',1.69),('8784','2013-09-09','13:00:00',1.78),('8784','2013-09-09','13:05:00',2.56),('8784','2013-09-09','13:10:00',2.34),('8784','2013-09-09','13:15:00',3.43),('8784','2013-09-09','13:20:00',3.04),('8784','2013-09-09','13:25:00',2.76),('8784','2013-09-09','13:30:00',3.33),('8784','2013-09-09','13:35:00',3.88),('8784','2013-09-09','13:40:00',3.16),('8784','2013-09-09','13:45:00',3.84),('8784','2013-09-09','13:50:00',3.89),('8784','2013-09-09','13:55:00',3.92),('8784','2013-09-09','14:00:00',3.6),('8784','2013-09-09','14:05:00',3.42),('8784','2013-09-09','14:10:00',3.46),('8784','2013-09-09','14:15:00',2.21),('8784','2013-09-09','14:20:00',2.17),('8784','2013-09-09','14:25:00',1.62),('8784','2013-09-09','14:30:00',2.18),('8784','2013-09-09','14:35:00',3.62),('8784','2013-09-09','14:40:00',3.56),('8784','2013-09-09','14:45:00',2.67),('8784','2013-09-09','14:50:00',3.38),('8784','2013-09-09','14:55:00',2.75),('8784','2013-09-09','15:00:00',2.59),('8784','2013-09-09','15:05:00',2.68),('8784','2013-09-09','15:10:00',2.49),('8784','2013-09-09','15:15:00',1.38),('8784','2013-09-09','15:20:00',2.38),('8784','2013-09-09','15:25:00',1.34),('8784','2013-09-09','15:30:00',2.5),('8784','2013-09-09','15:35:00',2.06),('8784','2013-09-09','15:40:00',2.21),('8784','2013-09-09','15:45:00',1.42),('8784','2013-09-09','15:50:00',1.43),('8784','2013-09-09','15:55:00',1.57),('8784','2013-09-09','16:00:00',1.77),('8784','2013-09-09','16:05:00',1.38),('8784','2013-09-09','16:10:00',1.83),('8784','2013-09-09','16:15:00',2.31),('8784','2013-09-09','16:20:00',1.79),('8784','2013-09-09','16:25:00',1.17),('8784','2013-09-09','16:30:00',1.15),('8784','2013-09-09','16:35:00',1.31),('8784','2013-09-09','16:40:00',1.44),('8784','2013-09-09','16:45:00',2),('8784','2013-09-09','17:00:00',1.07),('8784','2014-04-12','09:10:00',1.13),('8784','2014-04-12','09:15:00',1.55),('8784','2014-04-12','09:20:00',2.55),('8784','2014-04-12','09:25:00',2.65),('8784','2014-04-12','09:30:00',1.91),('8784','2014-04-12','09:35:00',1.54),('8784','2014-04-12','09:40:00',1.39),('8784','2014-04-12','09:45:00',1.4),('8784','2014-04-12','09:50:00',1.53),('8784','2014-04-12','09:55:00',1.48),('8784','2014-04-12','10:00:00',1.49),('8784','2014-04-12','10:05:00',1.52),('8784','2014-04-12','10:10:00',1.64),('8784','2014-04-12','10:15:00',1.79),('8784','2014-04-12','10:20:00',1.95),('8784','2014-04-12','10:25:00',2.01),('8784','2014-04-12','10:30:00',2.12),('8784','2014-04-12','10:35:00',2.42),('8784','2014-04-12','10:40:00',2.38),('8784','2014-04-12','10:45:00',2.84),('8784','2014-04-12','10:50:00',2.67),('8784','2014-04-12','10:55:00',3.28),('8784','2014-04-12','11:00:00',3.08),('8784','2014-04-12','11:05:00',2.56),('8784','2014-04-12','11:10:00',2.68),('8784','2014-04-12','11:15:00',2.86),('8784','2014-04-12','11:20:00',4.06),('8784','2014-04-12','11:25:00',3.55),('8784','2014-04-12','11:30:00',3.6),('8784','2014-04-12','11:35:00',4.04),('8784','2014-04-12','11:40:00',3.72),('8784','2014-04-12','11:45:00',3.91),('8784','2014-04-12','11:50:00',2.58),('8784','2014-04-12','11:55:00',3.29),('8784','2014-04-12','12:00:00',2.93),('8784','2014-04-12','12:05:00',1.9),('8784','2014-04-12','12:10:00',1.84),('8784','2014-04-12','12:15:00',1.92),('8784','2014-04-12','12:20:00',2.69),('8784','2014-04-12','12:25:00',3.12),('8784','2014-04-12','12:30:00',2.77),('8784','2014-04-12','12:35:00',2.76),('8784','2014-04-12','12:40:00',3.12),('8784','2014-04-12','12:45:00',2.54),('8784','2014-04-12','12:50:00',2.03),('8784','2014-04-12','12:55:00',2.05),('8784','2014-04-12','13:00:00',2.05),('8784','2014-04-12','13:05:00',3.29);
INSERT INTO `solarlog` VALUES ('8784','2014-04-12','13:10:00',3.11),('8784','2014-04-12','13:15:00',3.91),('8784','2014-04-12','13:20:00',4.09),('8784','2014-04-12','13:25:00',4.25),('8784','2014-04-12','13:30:00',2.8),('8784','2014-04-12','13:35:00',1.53),('8784','2014-04-12','13:40:00',1.85),('8784','2014-04-12','13:45:00',4.12),('8784','2014-04-12','13:50:00',2.52),('8784','2014-04-12','13:55:00',2.77),('8784','2014-04-12','14:00:00',4),('8784','2014-04-12','14:05:00',4.35),('8784','2014-04-12','14:10:00',3.69),('8784','2014-04-12','14:15:00',2.14),('8784','2014-04-12','14:20:00',3.7),('8784','2014-04-12','14:25:00',1.8),('8784','2014-04-12','14:30:00',3.3),('8784','2014-04-12','14:35:00',2.14),('8784','2014-04-12','14:40:00',1.58),('8784','2014-04-12','14:45:00',3.56),('8784','2014-04-12','14:50:00',4.42),('8784','2014-04-12','14:55:00',3.72),('8784','2014-04-12','15:00:00',2.75),('8784','2014-04-12','15:05:00',3.51),('8784','2014-04-12','15:10:00',3.63),('8784','2014-04-12','15:15:00',3.59),('8784','2014-04-12','15:20:00',2.83),('8784','2014-04-12','15:25:00',2),('8784','2014-04-12','15:30:00',2.31),('8784','2014-04-12','15:35:00',2.14),('8784','2014-04-12','15:40:00',2.72),('8784','2014-04-12','15:45:00',3.08),('8784','2014-04-12','15:50:00',3.49),('8784','2014-04-12','15:55:00',3.38),('8784','2014-04-12','16:00:00',3.36),('8784','2014-04-12','16:05:00',3.3),('8784','2014-04-12','16:10:00',3.07),('8784','2014-04-12','16:15:00',3.25),('8784','2014-04-12','16:20:00',3.28),('8784','2014-04-12','16:25:00',2.94),('8784','2014-04-12','16:30:00',2.81),('8784','2014-04-12','16:35:00',2.42),('8784','2014-04-12','16:40:00',2.32),('8784','2014-04-12','16:45:00',2.39),('8784','2014-04-12','16:50:00',1.62),('8784','2014-04-12','16:55:00',2.4),('8784','2014-04-12','17:00:00',2.3),('8784','2014-04-12','17:05:00',2.14),('8784','2014-04-12','17:10:00',2.09),('8784','2014-04-12','17:15:00',2.02),('8784','2014-04-12','17:20:00',1.61),('8784','2014-04-12','17:25:00',1.88),('8784','2014-04-12','17:30:00',1.82),('8784','2014-04-12','17:35:00',1.36),('8784','2014-04-12','17:40:00',1.8),('8784','2014-04-12','17:45:00',1.84),('8784','2014-04-12','17:50:00',1.59),('8784','2014-04-12','17:55:00',1.52),('8784','2014-04-12','18:00:00',1.13),('8784','2013-09-08','09:00:00',1.02),('8784','2013-09-08','09:05:00',1.18),('8784','2013-09-08','09:10:00',1.2),('8784','2013-09-08','09:15:00',1.25),('8784','2013-09-08','09:20:00',1.32),('8784','2013-09-08','09:25:00',1.53),('8784','2013-09-08','09:30:00',2.33),('8784','2013-09-08','09:35:00',2.18),('8784','2013-09-08','09:40:00',2.2),('8784','2013-09-08','09:45:00',2.41),('8784','2013-09-08','09:50:00',2.41),('8784','2013-09-08','09:55:00',2.44),('8784','2013-09-08','10:00:00',2.54),('8784','2013-09-08','10:05:00',2.63),('8784','2013-09-08','10:10:00',2.7),('8784','2013-09-08','10:15:00',2.71),('8784','2013-09-08','10:20:00',2.8),('8784','2013-09-08','10:25:00',2.84),('8784','2013-09-08','10:30:00',2.9),('8784','2013-09-08','10:35:00',2.97),('8784','2013-09-08','10:40:00',3.02),('8784','2013-09-08','10:45:00',3.06),('8784','2013-09-08','10:50:00',3.05),('8784','2013-09-08','10:55:00',3.05),('8784','2013-09-08','11:00:00',3.01),('8784','2013-09-08','11:05:00',3.11),('8784','2013-09-08','11:10:00',3.19),('8784','2013-09-08','11:15:00',3.26),('8784','2013-09-08','11:20:00',3.29),('8784','2013-09-08','11:25:00',3.26),('8784','2013-09-08','11:30:00',3.27),('8784','2013-09-08','11:35:00',3.28),('8784','2013-09-08','11:40:00',3.36),('8784','2013-09-08','11:45:00',3.39),('8784','2013-09-08','11:50:00',3.36),('8784','2013-09-08','11:55:00',3.34),('8784','2013-09-08','12:00:00',3.33),('8784','2013-09-08','12:05:00',3.26),('8784','2013-09-08','12:10:00',3.31),('8784','2013-09-08','12:15:00',3.53),('8784','2013-09-08','12:20:00',3.52),('8784','2013-09-08','12:25:00',3.53),('8784','2013-09-08','12:30:00',3.51),('8784','2013-09-08','12:35:00',3.4),('8784','2013-09-08','12:40:00',3.35),('8784','2013-09-08','12:45:00',3.52),('8784','2013-09-08','12:50:00',3.52),('8784','2013-09-08','12:55:00',3.55),('8784','2013-09-08','13:00:00',3.52),('8784','2013-09-08','13:05:00',3.61),('8784','2013-09-08','13:10:00',3.5),('8784','2013-09-08','13:15:00',3.52),('8784','2013-09-08','13:20:00',3.55),('8784','2013-09-08','13:25:00',3.23),('8784','2013-09-08','13:30:00',3.18),('8784','2013-09-08','13:35:00',3.12),('8784','2013-09-08','13:40:00',2.31),('8784','2013-09-08','13:45:00',2.13),('8784','2013-09-08','13:50:00',2.85),('8784','2013-09-08','13:55:00',2.93),('8784','2013-09-08','14:00:00',3.4),('8784','2013-09-08','14:05:00',3.28),('8784','2013-09-08','14:10:00',3.71),('8784','2013-09-08','14:15:00',3.28),('8784','2013-09-08','14:20:00',3.7),('8784','2013-09-08','14:25:00',3.91),('8784','2013-09-08','14:30:00',3.39),('8784','2013-09-08','14:35:00',3.6),('8784','2013-09-08','14:40:00',3.45),('8784','2013-09-08','14:45:00',3.37),('8784','2013-09-08','14:50:00',3.41),('8784','2013-09-08','14:55:00',3.37),('8784','2013-09-08','15:00:00',3.34),('8784','2013-09-08','15:05:00',2.67),('8784','2013-09-08','15:10:00',1.85),('8784','2013-09-08','15:15:00',2.46),('8784','2013-09-08','15:20:00',3.18),('8784','2013-09-08','15:25:00',3.19),('8784','2013-09-08','15:30:00',3.2),('8784','2013-09-08','15:35:00',3.08),('8784','2013-09-08','15:40:00',2.85),('8784','2013-09-08','15:45:00',2.91),('8784','2013-09-08','15:50:00',2.82),('8784','2013-09-08','15:55:00',2.29),('8784','2013-09-08','16:00:00',2.43),('8784','2013-09-08','16:05:00',2.42),('8784','2013-09-08','16:10:00',2.19),('8784','2013-09-08','16:15:00',2.49),('8784','2013-09-08','16:20:00',2.21),('8784','2013-09-08','16:25:00',2.16),('8784','2013-09-08','16:30:00',2.24),('8784','2013-09-08','16:35:00',2.05),('8784','2013-09-08','16:40:00',1.74),('8784','2013-09-08','16:45:00',1.29),('8784','2013-09-08','16:50:00',1.26),('8784','2013-09-08','16:55:00',1.17),('8784','2013-09-08','17:00:00',1.48),('8784','2013-09-08','17:05:00',1.95),('8784','2013-09-08','17:10:00',1.83),('8784','2013-09-08','17:15:00',1.67),('8784','2013-09-08','17:20:00',1.42),('8784','2013-09-08','17:25:00',1.42),('8784','2013-09-08','17:30:00',1.29),('8784','2013-09-08','17:45:00',1.03),('8784','2013-09-08','17:50:00',1.03),('8784','2013-09-07','08:10:00',1.01),('8784','2013-09-07','08:15:00',1.09),('8784','2013-09-07','08:20:00',1.16),('8784','2013-09-07','08:25:00',1.23),('8784','2013-09-07','08:30:00',1.32),('8784','2013-09-07','08:35:00',1.4),('8784','2013-09-07','08:40:00',1.49),('8784','2013-09-07','08:45:00',1.56),('8784','2013-09-07','08:50:00',1.64),('8784','2013-09-07','08:55:00',1.72),('8784','2013-09-07','09:00:00',1.8),('8784','2013-09-07','09:05:00',1.87),('8784','2013-09-07','09:10:00',1.95),('8784','2013-09-07','09:15:00',2),('8784','2013-09-07','09:20:00',2.11),('8784','2013-09-07','09:25:00',2.2),('8784','2013-09-07','09:30:00',2.26),('8784','2013-09-07','09:35:00',2.33),('8784','2013-09-07','09:40:00',2.39),('8784','2013-09-07','09:45:00',2.44),('8784','2013-09-07','09:50:00',2.49),('8784','2013-09-07','09:55:00',2.58),('8784','2013-09-07','10:00:00',2.64),('8784','2013-09-07','10:05:00',2.7),('8784','2013-09-07','10:10:00',2.72),('8784','2013-09-07','10:15:00',2.79),('8784','2013-09-07','10:20:00',2.88),('8784','2013-09-07','10:25:00',2.91),('8784','2013-09-07','10:30:00',2.95),('8784','2013-09-07','10:35:00',3.02),('8784','2013-09-07','10:40:00',3.06),('8784','2013-09-07','10:45:00',3.1),('8784','2013-09-07','10:50:00',3.16),('8784','2013-09-07','10:55:00',3.2),('8784','2013-09-07','11:00:00',3.25),('8784','2013-09-07','11:05:00',3.25),('8784','2013-09-07','11:10:00',3.31),('8784','2013-09-07','11:15:00',3.34),('8784','2013-09-07','11:20:00',3.37),('8784','2013-09-07','11:25:00',3.41),('8784','2013-09-07','11:30:00',3.45),('8784','2013-09-07','11:35:00',3.44),('8784','2013-09-07','11:40:00',3.53),('8784','2013-09-07','11:45:00',3.55),('8784','2013-09-07','11:50:00',3.56),('8784','2013-09-07','11:55:00',3.58),('8784','2013-09-07','12:00:00',3.61),('8784','2013-09-07','12:05:00',3.63),('8784','2013-09-07','12:10:00',3.65),('8784','2013-09-07','12:15:00',3.66),('8784','2013-09-07','12:20:00',3.66),('8784','2013-09-07','12:25:00',3.66),('8784','2013-09-07','12:30:00',3.65),('8784','2013-09-07','12:35:00',3.67),('8784','2013-09-07','12:40:00',3.65),('8784','2013-09-07','12:45:00',3.66),('8784','2013-09-07','12:50:00',3.68),('8784','2013-09-07','12:55:00',3.6),('8784','2013-09-07','13:00:00',3.59),('8784','2013-09-07','13:05:00',3.71),('8784','2013-09-07','13:10:00',3.65),('8784','2013-09-07','13:15:00',3.67),('8784','2013-09-07','13:20:00',3.7),('8784','2013-09-07','13:25:00',3.73),('8784','2013-09-07','13:30:00',3.78),('8784','2013-09-07','13:35:00',3.73),('8784','2013-09-07','13:40:00',3.44),('8784','2013-09-07','13:45:00',3.29),('8784','2013-09-07','13:50:00',3.12),('8784','2013-09-07','13:55:00',3.61),('8784','2013-09-07','14:00:00',3.74),('8784','2013-09-07','14:05:00',3.71),('8784','2013-09-07','14:10:00',3.7),('8784','2013-09-07','14:15:00',3.64),('8784','2013-09-07','14:20:00',3.56),('8784','2013-09-07','14:25:00',3.52),('8784','2013-09-07','14:30:00',3.48),('8784','2013-09-07','14:35:00',3.5),('8784','2013-09-07','14:40:00',3.43),('8784','2013-09-07','14:45:00',3.47),('8784','2013-09-07','14:50:00',3.4),('8784','2013-09-07','14:55:00',3.37),('8784','2013-09-07','15:00:00',3.33),('8784','2013-09-07','15:05:00',3.29),('8784','2013-09-07','15:10:00',3.25),('8784','2013-09-07','15:15:00',3.22),('8784','2013-09-07','15:20:00',3.18),('8784','2013-09-07','15:25:00',3.15),('8784','2013-09-07','15:30:00',3.09),('8784','2013-09-07','15:35:00',3.03),('8784','2013-09-07','15:40:00',2.95),('8784','2013-09-07','15:45:00',2.89),('8784','2013-09-07','15:50:00',2.82),('8784','2013-09-07','15:55:00',2.75),('8784','2013-09-07','16:00:00',2.71),('8784','2013-09-07','16:05:00',2.64),('8784','2013-09-07','16:10:00',2.58),('8784','2013-09-07','16:15:00',2.51),('8784','2013-09-07','16:20:00',2.43),('8784','2013-09-07','16:25:00',2.32),('8784','2013-09-07','16:30:00',2.27),('8784','2013-09-07','16:35:00',2.2),('8784','2013-09-07','16:40:00',2.13),('8784','2013-09-07','16:45:00',2.07),('8784','2013-09-07','16:50:00',1.98),('8784','2013-09-07','16:55:00',1.91),('8784','2013-09-07','17:00:00',1.82),('8784','2013-09-07','17:05:00',1.74),('8784','2013-09-07','17:10:00',1.66),('8784','2013-09-07','17:15:00',1.6),('8784','2013-09-07','17:20:00',1.52),('8784','2013-09-07','17:25:00',1.43),('8784','2013-09-07','17:30:00',1.33),('8784','2013-09-07','17:35:00',1.27),('8784','2013-09-07','17:40:00',1.19),('8784','2013-09-07','17:45:00',1.12),('8784','2013-09-07','17:50:00',1.04),('8784','2013-09-06','08:10:00',1.04),('8784','2013-09-06','08:15:00',1.11),('8784','2013-09-06','08:20:00',1.2),('8784','2013-09-06','08:25:00',1.25),('8784','2013-09-06','08:30:00',1.33),('8784','2013-09-06','08:35:00',1.41),('8784','2013-09-06','08:40:00',1.51),('8784','2013-09-06','08:45:00',1.61),('8784','2013-09-06','08:50:00',1.67),('8784','2013-09-06','08:55:00',1.76),('8784','2013-09-06','09:00:00',1.85),('8784','2013-09-06','09:05:00',1.93),('8784','2013-09-06','09:10:00',2),('8784','2013-09-06','09:15:00',2.07),('8784','2013-09-06','09:20:00',2.14),('8784','2013-09-06','09:25:00',2.21),('8784','2013-09-06','09:30:00',2.29),('8784','2013-09-06','09:35:00',2.35),('8784','2013-09-06','09:40:00',2.44),('8784','2013-09-06','09:45:00',2.51),('8784','2013-09-06','09:50:00',2.56),('8784','2013-09-06','09:55:00',2.61),('8784','2013-09-06','10:00:00',2.68),('8784','2013-09-06','10:05:00',2.74),('8784','2013-09-06','10:10:00',2.79),('8784','2013-09-06','10:15:00',2.84),('8784','2013-09-06','10:20:00',2.89),('8784','2013-09-06','10:25:00',2.94),('8784','2013-09-06','10:30:00',3.02),('8784','2013-09-06','10:35:00',3.09),('8784','2013-09-06','10:40:00',3.16),('8784','2013-09-06','10:45:00',3.21),('8784','2013-09-06','10:50:00',3.2),('8784','2013-09-06','10:55:00',3.26),('8784','2013-09-06','11:00:00',3.29),('8784','2013-09-06','11:05:00',3.34),('8784','2013-09-06','11:10:00',3.4),('8784','2013-09-06','11:15:00',3.44),('8784','2013-09-06','11:20:00',3.45),('8784','2013-09-06','11:25:00',3.46),('8784','2013-09-06','11:30:00',3.51),('8784','2013-09-06','11:35:00',3.57),('8784','2013-09-06','11:40:00',3.58),('8784','2013-09-06','11:45:00',3.61),('8784','2013-09-06','11:50:00',3.61),('8784','2013-09-06','11:55:00',3.62),('8784','2013-09-06','12:00:00',3.61),('8784','2013-09-06','12:05:00',3.59),('8784','2013-09-06','12:10:00',3.66),('8784','2013-09-06','12:15:00',3.71),('8784','2013-09-06','12:20:00',3.71),('8784','2013-09-06','12:25:00',3.73),('8784','2013-09-06','12:30:00',3.76),('8784','2013-09-06','12:35:00',3.79),('8784','2013-09-06','12:40:00',3.78),('8784','2013-09-06','12:45:00',3.75),('8784','2013-09-06','12:50:00',3.74),('8784','2013-09-06','12:55:00',3.74),('8784','2013-09-06','13:00:00',3.75),('8784','2013-09-06','13:05:00',3.76),('8784','2013-09-06','13:10:00',3.74),('8784','2013-09-06','13:15:00',3.78),('8784','2013-09-06','13:20:00',3.75),('8784','2013-09-06','13:25:00',3.71),('8784','2013-09-06','13:30:00',3.7),('8784','2013-09-06','13:35:00',3.71),('8784','2013-09-06','13:40:00',3.67),('8784','2013-09-06','13:45:00',3.66),('8784','2013-09-06','13:50:00',3.64),('8784','2013-09-06','13:55:00',3.58),('8784','2013-09-06','14:00:00',3.57),('8784','2013-09-06','14:05:00',3.54),('8784','2013-09-06','14:10:00',3.54),('8784','2013-09-06','14:15:00',3.54),('8784','2013-09-06','14:20:00',3.51),('8784','2013-09-06','14:25:00',3.49),('8784','2013-09-06','14:30:00',3.43),('8784','2013-09-06','14:35:00',3.31),('8784','2013-09-06','14:40:00',3.33),('8784','2013-09-06','14:45:00',3.33),('8784','2013-09-06','14:50:00',3.35),('8784','2013-09-06','14:55:00',3.37),('8784','2013-09-06','15:00:00',3.3),('8784','2013-09-06','15:05:00',3.24),('8784','2013-09-06','15:10:00',3.17),('8784','2013-09-06','15:15:00',3.17),('8784','2013-09-06','15:20:00',3.15),('8784','2013-09-06','15:25:00',3.02),('8784','2013-09-06','15:30:00',2.97),('8784','2013-09-06','15:35:00',2.87),('8784','2013-09-06','15:40:00',2.87),('8784','2013-09-06','15:45:00',2.87),('8784','2013-09-06','15:50:00',2.74),('8784','2013-09-06','15:55:00',2.72),('8784','2013-09-06','16:00:00',2.68),('8784','2013-09-06','16:05:00',2.63),('8784','2013-09-06','16:10:00',2.56),('8784','2013-09-06','16:15:00',2.51),('8784','2013-09-06','16:20:00',2.45),('8784','2013-09-06','16:25:00',2.39),('8784','2013-09-06','16:30:00',2.36),('8784','2013-09-06','16:35:00',2.27),('8784','2013-09-06','16:40:00',2.2),('8784','2013-09-06','16:45:00',2.1),('8784','2013-09-06','16:50:00',2.03),('8784','2013-09-06','16:55:00',1.93),('8784','2013-09-06','17:00:00',1.89),('8784','2013-09-06','17:05:00',1.78),('8784','2013-09-06','17:10:00',1.69),('8784','2013-09-06','17:15:00',1.64),('8784','2013-09-06','17:20:00',1.54),('8784','2013-09-06','17:25:00',1.44),('8784','2013-09-06','17:30:00',1.36),('8784','2013-09-06','17:35:00',1.28),('8784','2013-09-06','17:40:00',1.23),('8784','2013-09-06','17:45:00',1.13),('8784','2013-09-06','17:50:00',1.03),('8784','2013-09-05','08:05:00',1.06),('8784','2013-09-05','08:10:00',1.13),('8784','2013-09-05','08:15:00',1.22),('8784','2013-09-05','08:20:00',1.31),('8784','2013-09-05','08:25:00',1.4),('8784','2013-09-05','08:30:00',1.48),('8784','2013-09-05','08:35:00',1.57),('8784','2013-09-05','08:40:00',1.65),('8784','2013-09-05','08:45:00',1.72),('8784','2013-09-05','08:50:00',1.79),('8784','2013-09-05','08:55:00',1.9),('8784','2013-09-05','09:00:00',1.98),('8784','2013-09-05','09:05:00',2.07),('8784','2013-09-05','09:10:00',2.15),('8784','2013-09-05','09:15:00',2.22),('8784','2013-09-05','09:20:00',2.3),('8784','2013-09-05','09:25:00',2.37),('8784','2013-09-05','09:30:00',2.43),('8784','2013-09-05','09:35:00',2.49),('8784','2013-09-05','09:40:00',2.52),('8784','2013-09-05','09:45:00',2.62),('8784','2013-09-05','09:50:00',2.7),('8784','2013-09-05','09:55:00',2.76),('8784','2013-09-05','10:00:00',2.78),('8784','2013-09-05','10:05:00',2.87),('8784','2013-09-05','10:10:00',2.93),('8784','2013-09-05','10:15:00',2.99),('8784','2013-09-05','10:20:00',3.05),('8784','2013-09-05','10:25:00',3.1),('8784','2013-09-05','10:30:00',3.14),('8784','2013-09-05','10:35:00',3.15),('8784','2013-09-05','10:40:00',3.23),('8784','2013-09-05','10:45:00',3.29),('8784','2013-09-05','10:50:00',3.32),('8784','2013-09-05','10:55:00',3.36),('8784','2013-09-05','11:00:00',3.42),('8784','2013-09-05','11:05:00',3.45),('8784','2013-09-05','11:10:00',3.49),('8784','2013-09-05','11:15:00',3.5),('8784','2013-09-05','11:20:00',3.51),('8784','2013-09-05','11:25:00',3.58),('8784','2013-09-05','11:30:00',3.61),('8784','2013-09-05','11:35:00',3.62),('8784','2013-09-05','11:40:00',3.57),('8784','2013-09-05','11:45:00',3.59),('8784','2013-09-05','11:50:00',3.64),('8784','2013-09-05','11:55:00',3.72),('8784','2013-09-05','12:00:00',3.72),('8784','2013-09-05','12:05:00',3.74),('8784','2013-09-05','12:10:00',3.79),('8784','2013-09-05','12:15:00',3.81),('8784','2013-09-05','12:20:00',3.78),('8784','2013-09-05','12:25:00',3.81),('8784','2013-09-05','12:30:00',3.82),('8784','2013-09-05','12:35:00',3.84),('8784','2013-09-05','12:40:00',3.85),('8784','2013-09-05','12:45:00',3.86),('8784','2013-09-05','12:50:00',3.88),('8784','2013-09-05','12:55:00',3.87),('8784','2013-09-05','13:00:00',3.85),('8784','2013-09-05','13:05:00',3.81),('8784','2013-09-05','13:10:00',3.85),('8784','2013-09-05','13:15:00',3.84),('8784','2013-09-05','13:20:00',3.84),('8784','2013-09-05','13:25:00',3.84),('8784','2013-09-05','13:30:00',3.87),('8784','2013-09-05','13:35:00',3.84),('8784','2013-09-05','13:40:00',3.82),('8784','2013-09-05','13:45:00',3.79),('8784','2013-09-05','13:50:00',3.74),('8784','2013-09-05','13:55:00',3.73),('8784','2013-09-05','14:00:00',3.71),('8784','2013-09-05','14:05:00',3.73),('8784','2013-09-05','14:10:00',3.73),('8784','2013-09-05','14:15:00',3.68),('8784','2013-09-05','14:20:00',3.64),('8784','2013-09-05','14:25:00',3.57),('8784','2013-09-05','14:30:00',3.57),('8784','2013-09-05','14:35:00',3.51),('8784','2013-09-05','14:40:00',3.49),('8784','2013-09-05','14:45:00',3.48),('8784','2013-09-05','14:50:00',3.44),('8784','2013-09-05','14:55:00',3.44),('8784','2013-09-05','15:00:00',3.42),('8784','2013-09-05','15:05:00',3.39),('8784','2013-09-05','15:10:00',3.31),('8784','2013-09-05','15:15:00',3.28),('8784','2013-09-05','15:20:00',3.19),('8784','2013-09-05','15:25:00',3.17),('8784','2013-09-05','15:30:00',3.11),('8784','2013-09-05','15:35:00',3.07),('8784','2013-09-05','15:40:00',3.02),('8784','2013-09-05','15:45:00',2.96),('8784','2013-09-05','15:50:00',2.91),('8784','2013-09-05','15:55:00',2.86),('8784','2013-09-05','16:00:00',2.79),('8784','2013-09-05','16:05:00',2.75),('8784','2013-09-05','16:10:00',2.69),('8784','2013-09-05','16:15:00',2.63),('8784','2013-09-05','16:20:00',2.53),('8784','2013-09-05','16:25:00',2.5),('8784','2013-09-05','16:30:00',2.45),('8784','2013-09-05','16:35:00',2.42),('8784','2013-09-05','16:40:00',2.35),('8784','2013-09-05','16:45:00',2.3),('8784','2013-09-05','16:50:00',1.9),('8784','2013-09-05','16:55:00',1.53),('8784','2013-09-05','17:00:00',1.23),('8784','2013-09-05','17:05:00',1.37),('8784','2013-09-05','17:10:00',1.35),('8784','2013-09-05','17:15:00',1.21),('8784','2013-09-05','17:20:00',1.37),('8784','2013-09-05','17:25:00',1.37),('8784','2013-09-05','17:30:00',1.35),('8784','2013-09-05','17:35:00',1.44),('8784','2013-09-05','17:40:00',1.51),('8784','2013-09-05','17:45:00',1.35),('8784','2013-09-05','17:50:00',1.23),('8784','2013-09-05','17:55:00',1.07),('8784','2013-09-04','08:05:00',1.07),('8784','2013-09-04','08:10:00',1.15),('8784','2013-09-04','08:15:00',1.24),('8784','2013-09-04','08:20:00',1.32),('8784','2013-09-04','08:25:00',1.4),('8784','2013-09-04','08:30:00',1.49),('8784','2013-09-04','08:35:00',1.56),('8784','2013-09-04','08:40:00',1.64),('8784','2013-09-04','08:45:00',1.72),('8784','2013-09-04','08:50:00',1.82),('8784','2013-09-04','08:55:00',1.87),('8784','2013-09-04','09:00:00',1.96),('8784','2013-09-04','09:05:00',2.08),('8784','2013-09-04','09:10:00',2.16),('8784','2013-09-04','09:15:00',2.25),('8784','2013-09-04','09:20:00',2.34),('8784','2013-09-04','09:25:00',2.42),('8784','2013-09-04','09:30:00',2.45),('8784','2013-09-04','09:35:00',2.59),('8784','2013-09-04','09:40:00',2.67),('8784','2013-09-04','09:45:00',2.73),('8784','2013-09-04','09:50:00',2.78),('8784','2013-09-04','09:55:00',2.85),('8784','2013-09-04','10:00:00',2.93),('8784','2013-09-04','10:05:00',2.99),('8784','2013-09-04','10:10:00',3.04),('8784','2013-09-04','10:15:00',3.09),('8784','2013-09-04','10:20:00',3.14),('8784','2013-09-04','10:25:00',3.2),('8784','2013-09-04','10:30:00',3.26),('8784','2013-09-04','10:35:00',3.31),('8784','2013-09-04','10:40:00',3.36),('8784','2013-09-04','10:45:00',3.4),('8784','2013-09-04','10:50:00',3.39),('8784','2013-09-04','10:55:00',3.48),('8784','2013-09-04','11:00:00',3.53),('8784','2013-09-04','11:05:00',3.58),('8784','2013-09-04','11:10:00',3.61),('8784','2013-09-04','11:15:00',3.63),('8784','2013-09-04','11:20:00',3.68),('8784','2013-09-04','11:25:00',3.71),('8784','2013-09-04','11:30:00',3.74),('8784','2013-09-04','11:35:00',3.79),('8784','2013-09-04','11:40:00',3.81),('8784','2013-09-04','11:45:00',3.84),('8784','2013-09-04','11:50:00',3.87),('8784','2013-09-04','11:55:00',3.9),('8784','2013-09-04','12:00:00',3.91),('8784','2013-09-04','12:05:00',3.92),('8784','2013-09-04','12:10:00',3.94),('8784','2013-09-04','12:15:00',3.93),('8784','2013-09-04','12:20:00',3.95),('8784','2013-09-04','12:25:00',3.99),('8784','2013-09-04','12:30:00',4.01),('8784','2013-09-04','12:35:00',3.97),('8784','2013-09-04','12:40:00',4.04),('8784','2013-09-04','12:45:00',4.02),('8784','2013-09-04','12:50:00',3.99),('8784','2013-09-04','12:55:00',4.01),('8784','2013-09-04','13:00:00',4.01),('8784','2013-09-04','13:05:00',4),('8784','2013-09-04','13:10:00',4.02),('8784','2013-09-04','13:15:00',4),('8784','2013-09-04','13:20:00',4),('8784','2013-09-04','13:25:00',3.98),('8784','2013-09-04','13:30:00',3.97),('8784','2013-09-04','13:35:00',3.96),('8784','2013-09-04','13:40:00',3.96),('8784','2013-09-04','13:45:00',3.94),('8784','2013-09-04','13:50:00',3.91),('8784','2013-09-04','13:55:00',3.9),('8784','2013-09-04','14:00:00',3.87),('8784','2013-09-04','14:05:00',3.86),('8784','2013-09-04','14:10:00',3.85),('8784','2013-09-04','14:15:00',3.82),('8784','2013-09-04','14:20:00',3.77),('8784','2013-09-04','14:25:00',3.76),('8784','2013-09-04','14:30:00',3.74),('8784','2013-09-04','14:35:00',3.7),('8784','2013-09-04','14:40:00',3.66),('8784','2013-09-04','14:45:00',3.62),('8784','2013-09-04','14:50:00',3.6),('8784','2013-09-04','14:55:00',3.55),('8784','2013-09-04','15:00:00',3.51),('8784','2013-09-04','15:05:00',3.46),('8784','2013-09-04','15:10:00',3.43),('8784','2013-09-04','15:15:00',3.38),('8784','2013-09-04','15:20:00',3.34),('8784','2013-09-04','15:25:00',3.28),('8784','2013-09-04','15:30:00',3.23),('8784','2013-09-04','15:35:00',3.16),('8784','2013-09-04','15:40:00',3.11),('8784','2013-09-04','15:45:00',3.06),('8784','2013-09-04','15:50:00',3),('8784','2013-09-04','15:55:00',2.93),('8784','2013-09-04','16:00:00',2.86),('8784','2013-09-04','16:05:00',2.78),('8784','2013-09-04','16:10:00',2.72),('8784','2013-09-04','16:15:00',2.67),('8784','2013-09-04','16:20:00',2.6),('8784','2013-09-04','16:25:00',2.53),('8784','2013-09-04','16:30:00',2.46),('8784','2013-09-04','16:35:00',2.39),('8784','2013-09-04','16:40:00',2.31),('8784','2013-09-04','16:45:00',2.25),('8784','2013-09-04','16:50:00',2.15),('8784','2013-09-04','16:55:00',2.08),('8784','2013-09-04','17:00:00',2),('8784','2013-09-04','17:05:00',1.91),('8784','2013-09-04','17:10:00',1.83),('8784','2013-09-04','17:15:00',1.75),('8784','2013-09-04','17:20:00',1.66),('8784','2013-09-04','17:25:00',1.58),('8784','2013-09-04','17:30:00',1.51),('8784','2013-09-04','17:35:00',1.42),('8784','2013-09-04','17:40:00',1.32),('8784','2013-09-04','17:45:00',1.23),('8784','2013-09-04','17:50:00',1.14),('8784','2013-09-04','17:55:00',1.05),('8784','2013-09-03','08:10:00',1.03),('8784','2013-09-03','08:15:00',1.11),('8784','2013-09-03','08:20:00',1.18),('8784','2013-09-03','08:25:00',1.25),('8784','2013-09-03','08:30:00',1.35),('8784','2013-09-03','08:35:00',1.44),('8784','2013-09-03','08:40:00',1.51),('8784','2013-09-03','08:45:00',1.6),('8784','2013-09-03','08:50:00',1.69),('8784','2013-09-03','08:55:00',1.78),('8784','2013-09-03','09:00:00',1.85),('8784','2013-09-03','09:05:00',1.91),('8784','2013-09-03','09:10:00',2.02),('8784','2013-09-03','09:15:00',2.09),('8784','2013-09-03','09:20:00',2.18),('8784','2013-09-03','09:25:00',2.28),('8784','2013-09-03','09:30:00',2.35),('8784','2013-09-03','09:35:00',2.43),('8784','2013-09-03','09:40:00',2.49),('8784','2013-09-03','09:45:00',2.55),('8784','2013-09-03','09:50:00',2.61),('8784','2013-09-03','09:55:00',2.66),('8784','2013-09-03','10:00:00',2.72),('8784','2013-09-03','10:05:00',2.78),('8784','2013-09-03','10:10:00',2.83),('8784','2013-09-03','10:15:00',2.9),('8784','2013-09-03','10:20:00',2.98),('8784','2013-09-03','10:25:00',3.04),('8784','2013-09-03','10:30:00',3.09),('8784','2013-09-03','10:35:00',3.17),('8784','2013-09-03','10:40:00',3.24),('8784','2013-09-03','10:45:00',3.31),('8784','2013-09-03','10:50:00',3.34),('8784','2013-09-03','10:55:00',3.37),('8784','2013-09-03','11:00:00',3.41),('8784','2013-09-03','11:05:00',3.45),('8784','2013-09-03','11:10:00',3.48),('8784','2013-09-03','11:15:00',3.51),('8784','2013-09-03','11:20:00',3.54),('8784','2013-09-03','11:25:00',3.56),('8784','2013-09-03','11:30:00',3.59),('8784','2013-09-03','11:35:00',3.64),('8784','2013-09-03','11:40:00',3.65),('8784','2013-09-03','11:45:00',3.68),('8784','2013-09-03','11:50:00',3.72),('8784','2013-09-03','11:55:00',3.78),('8784','2013-09-03','12:00:00',3.79),('8784','2013-09-03','12:05:00',3.8),('8784','2013-09-03','12:10:00',3.81),('8784','2013-09-03','12:15:00',3.86),('8784','2013-09-03','12:20:00',3.88),('8784','2013-09-03','12:25:00',3.89),('8784','2013-09-03','12:30:00',3.91),('8784','2013-09-03','12:35:00',3.92),('8784','2013-09-03','12:40:00',3.94),('8784','2013-09-03','12:45:00',3.94),('8784','2013-09-03','12:50:00',3.9),('8784','2013-09-03','12:55:00',3.94),('8784','2013-09-03','13:00:00',3.94),('8784','2013-09-03','13:05:00',3.92),('8784','2013-09-03','13:10:00',3.94),('8784','2013-09-03','13:15:00',3.92),('8784','2013-09-03','13:20:00',3.9),('8784','2013-09-03','13:25:00',3.88),('8784','2013-09-03','13:30:00',3.87),('8784','2013-09-03','13:35:00',3.89),('8784','2013-09-03','13:40:00',3.87),('8784','2013-09-03','13:45:00',3.84),('8784','2013-09-03','13:50:00',3.87),('8784','2013-09-03','13:55:00',3.86),('8784','2013-09-03','14:00:00',3.79),('8784','2013-09-03','14:05:00',3.73),('8784','2013-09-03','14:10:00',3.68),('8784','2013-09-03','14:15:00',3.7),('8784','2013-09-03','14:20:00',3.69),('8784','2013-09-03','14:25:00',3.68),('8784','2013-09-03','14:30:00',3.67),('8784','2013-09-03','14:35:00',3.66),('8784','2013-09-03','14:40:00',3.64),('8784','2013-09-03','14:45:00',3.57),('8784','2013-09-03','14:50:00',3.57),('8784','2013-09-03','14:55:00',3.55),('8784','2013-09-03','15:00:00',3.48),('8784','2013-09-03','15:05:00',3.39),('8784','2013-09-03','15:10:00',3.31),('8784','2013-09-03','15:15:00',3.33),('8784','2013-09-03','15:20:00',3.3),('8784','2013-09-03','15:25:00',3.22),('8784','2013-09-03','15:30:00',3.18),('8784','2013-09-03','15:35:00',3.09),('8784','2013-09-03','15:40:00',3.04),('8784','2013-09-03','15:45:00',2.96),('8784','2013-09-03','15:50:00',2.92),('8784','2013-09-03','15:55:00',2.88),('8784','2013-09-03','16:00:00',2.84),('8784','2013-09-03','16:05:00',2.8),('8784','2013-09-03','16:10:00',2.73),('8784','2013-09-03','16:15:00',2.64),('8784','2013-09-03','16:20:00',2.58),('8784','2013-09-03','16:25:00',2.52),('8784','2013-09-03','16:30:00',2.45),('8784','2013-09-03','16:35:00',2.38),('8784','2013-09-03','16:40:00',2.3),('8784','2013-09-03','16:45:00',2.24),('8784','2013-09-03','16:50:00',2.16),('8784','2013-09-03','16:55:00',2.09),('8784','2013-09-03','17:00:00',2.01),('8784','2013-09-03','17:05:00',1.92),('8784','2013-09-03','17:10:00',1.85),('8784','2013-09-03','17:15:00',1.76),('8784','2013-09-03','17:20:00',1.68),('8784','2013-09-03','17:25:00',1.6),('8784','2013-09-03','17:30:00',1.53),('8784','2013-09-03','17:35:00',1.42),('8784','2013-09-03','17:40:00',1.35),('8784','2013-09-03','17:45:00',1.27),('8784','2013-09-03','17:50:00',1.19),('8784','2013-09-03','17:55:00',1.08),('8784','2013-09-02','08:10:00',1.08),('8784','2013-09-02','08:15:00',1.16),('8784','2013-09-02','08:20:00',1.24),('8784','2013-09-02','08:25:00',1.31),('8784','2013-09-02','08:30:00',1.37),('8784','2013-09-02','08:35:00',1.41),('8784','2013-09-02','08:40:00',1.52),('8784','2013-09-02','08:45:00',1.61),('8784','2013-09-02','08:50:00',1.68),('8784','2013-09-02','08:55:00',1.77),('8784','2013-09-02','09:00:00',1.83),('8784','2013-09-02','09:05:00',1.9),('8784','2013-09-02','09:10:00',1.96),('8784','2013-09-02','09:15:00',2.04),('8784','2013-09-02','09:20:00',2.09),('8784','2013-09-02','09:25:00',2.23),('8784','2013-09-02','09:30:00',2.25),('8784','2013-09-02','09:35:00',2.31),('8784','2013-09-02','09:40:00',2.46),('8784','2013-09-02','09:45:00',2.52),('8784','2013-09-02','09:50:00',2.68),('8784','2013-09-02','09:55:00',2.74),('8784','2013-09-02','10:00:00',2.79),('8784','2013-09-02','10:05:00',2.86),('8784','2013-09-02','10:10:00',2.92),('8784','2013-09-02','10:15:00',2.98),('8784','2013-09-02','10:20:00',3.06),('8784','2013-09-02','10:25:00',3.12),('8784','2013-09-02','10:30:00',3.18),('8784','2013-09-02','10:35:00',3.22),('8784','2013-09-02','10:40:00',3.26),('8784','2013-09-02','10:45:00',3.28),('8784','2013-09-02','10:50:00',3.35),('8784','2013-09-02','10:55:00',3.38),('8784','2013-09-02','11:00:00',3.4),('8784','2013-09-02','11:05:00',3.46),('8784','2013-09-02','11:10:00',3.51),('8784','2013-09-02','11:15:00',3.53),('8784','2013-09-02','11:20:00',3.56),('8784','2013-09-02','11:25:00',3.59),('8784','2013-09-02','11:30:00',3.65),('8784','2013-09-02','11:35:00',3.66),('8784','2013-09-02','11:40:00',3.68),('8784','2013-09-02','11:45:00',3.69),('8784','2013-09-02','11:50:00',3.72),('8784','2013-09-02','11:55:00',3.73),('8784','2013-09-02','12:00:00',3.75),('8784','2013-09-02','12:05:00',3.77),('8784','2013-09-02','12:10:00',3.81),('8784','2013-09-02','12:15:00',3.86),('8784','2013-09-02','12:20:00',3.84),('8784','2013-09-02','12:25:00',3.87),('8784','2013-09-02','12:30:00',3.83),('8784','2013-09-02','12:35:00',3.76),('8784','2013-09-02','12:40:00',3.85),('8784','2013-09-02','12:45:00',3.84),('8784','2013-09-02','12:50:00',3.89),('8784','2013-09-02','12:55:00',3.91),('8784','2013-09-02','13:00:00',3.9),('8784','2013-09-02','13:05:00',3.87),('8784','2013-09-02','13:10:00',3.87),('8784','2013-09-02','13:15:00',3.85),('8784','2013-09-02','13:20:00',3.83),('8784','2013-09-02','13:25:00',3.83),('8784','2013-09-02','13:30:00',3.79),('8784','2013-09-02','13:35:00',3.75),('8784','2013-09-02','13:40:00',3.78),('8784','2013-09-02','13:45:00',2.37),('8784','2013-09-02','13:50:00',1.01),('8784','2013-09-02','14:00:00',3.56),('8784','2013-09-02','14:05:00',3.97),('8784','2013-09-02','14:10:00',3.84),('8784','2013-09-02','14:15:00',3.81),('8784','2013-09-02','14:20:00',3.74),('8784','2013-09-02','14:25:00',3.71),('8784','2013-09-02','14:30:00',3.69),('8784','2013-09-02','14:35:00',3.62),('8784','2013-09-02','14:40:00',3.6),('8784','2013-09-02','14:45:00',3.71),('8784','2013-09-02','14:50:00',3.55),('8784','2013-09-02','14:55:00',2.65),('8784','2013-09-02','15:00:00',1.9),('8784','2013-09-02','15:05:00',3.51),('8784','2013-09-02','15:10:00',3.29),('8784','2013-09-02','15:15:00',2.53),('8784','2013-09-02','15:25:00',2.51),('8784','2013-09-02','15:30:00',3.04),('8784','2013-09-02','15:35:00',2.56),('8784','2013-09-02','15:40:00',2.72),('8784','2013-09-02','15:45:00',2.89),('8784','2013-09-02','15:50:00',3.04),('8784','2013-09-02','15:55:00',2.97),('8784','2013-09-02','16:00:00',2.92),('8784','2013-09-02','16:05:00',2.82),('8784','2013-09-02','16:10:00',2.77),('8784','2013-09-02','16:15:00',2.75),('8784','2013-09-02','16:20:00',2.69),('8784','2013-09-02','16:25:00',2.58),('8784','2013-09-02','16:30:00',2.5),('8784','2013-09-02','16:35:00',2.43),('8784','2013-09-02','16:40:00',2.32),('8784','2013-09-02','16:45:00',2.23),('8784','2013-09-02','16:50:00',2.14),('8784','2013-09-02','16:55:00',2.02),('8784','2013-09-02','17:00:00',1.95),('8784','2013-09-02','17:05:00',1.85),('8784','2013-09-02','17:10:00',1.79),('8784','2013-09-02','17:15:00',1.72),('8784','2013-09-02','17:20:00',1.62),('8784','2013-09-02','17:25:00',1.58),('8784','2013-09-02','17:30:00',1.49),('8784','2013-09-02','17:35:00',1.4),('8784','2013-09-02','17:40:00',1.32),('8784','2013-09-02','17:45:00',1.25),('8784','2013-09-02','17:50:00',1.16),('8784','2013-09-02','17:55:00',1.09),('8784','2013-09-02','18:00:00',1.02),('8784','2013-09-01','08:05:00',1.05),('8784','2013-09-01','08:10:00',1.12),('8784','2013-09-01','08:15:00',1.19),('8784','2013-09-01','08:20:00',1.24),('8784','2013-09-01','08:25:00',1.36),('8784','2013-09-01','08:30:00',1.35),('8784','2013-09-01','08:35:00',1.51),('8784','2013-09-01','08:40:00',1.57),('8784','2013-09-01','08:45:00',1.65),('8784','2013-09-01','08:50:00',1.73),('8784','2013-09-01','08:55:00',1.73),('8784','2013-09-01','09:00:00',1.79),('8784','2013-09-01','09:05:00',1.87),('8784','2013-09-01','09:10:00',1.89),('8784','2013-09-01','09:15:00',2.1),('8784','2013-09-01','09:20:00',2.15),('8784','2013-09-01','09:25:00',2.28),('8784','2013-09-01','09:30:00',2.41),('8784','2013-09-01','09:35:00',2.47),('8784','2013-09-01','09:40:00',2.49),('8784','2013-09-01','09:45:00',2.55),('8784','2013-09-01','09:50:00',2.72),('8784','2013-09-01','09:55:00',2.78),('8784','2013-09-01','10:00:00',2.82),('8784','2013-09-01','10:05:00',2.89),('8784','2013-09-01','10:10:00',2.96),('8784','2013-09-01','10:15:00',3.01),('8784','2013-09-01','10:20:00',3.06),('8784','2013-09-01','10:25:00',3.12),('8784','2013-09-01','10:30:00',3.17),('8784','2013-09-01','10:35:00',3.22),('8784','2013-09-01','10:40:00',3.27),('8784','2013-09-01','10:45:00',3.29),('8784','2013-09-01','10:50:00',3.33),('8784','2013-09-01','10:55:00',3.38),('8784','2013-09-01','11:00:00',3.43),('8784','2013-09-01','11:05:00',3.49),('8784','2013-09-01','11:10:00',3.51),('8784','2013-09-01','11:15:00',3.51),('8784','2013-09-01','11:20:00',3.54),('8784','2013-09-01','11:25:00',3.59),('8784','2013-09-01','11:30:00',3.59),('8784','2013-09-01','11:35:00',3.64),('8784','2013-09-01','11:40:00',3.7),('8784','2013-09-01','11:45:00',3.76),('8784','2013-09-01','11:50:00',3.77),('8784','2013-09-01','11:55:00',3.78),('8784','2013-09-01','12:00:00',3.78),('8784','2013-09-01','12:05:00',3.73),('8784','2013-09-01','12:10:00',3.82),('8784','2013-09-01','12:15:00',3.86),('8784','2013-09-01','12:20:00',3.88),('8784','2013-09-01','12:25:00',3.75),('8784','2013-09-01','12:30:00',3.88),('8784','2013-09-01','12:35:00',3.89),('8784','2013-09-01','12:40:00',3.9),('8784','2013-09-01','12:45:00',3.86),('8784','2013-09-01','12:50:00',3.89),('8784','2013-09-01','12:55:00',3.88),('8784','2013-09-01','13:00:00',3.9),('8784','2013-09-01','13:05:00',3.93),('8784','2013-09-01','13:10:00',3.94),('8784','2013-09-01','13:15:00',3.58),('8784','2013-09-01','13:20:00',3.97),('8784','2013-09-01','13:25:00',3.93),('8784','2013-09-01','13:30:00',3.97),('8784','2013-09-01','13:35:00',3.91),('8784','2013-09-01','13:40:00',3.91),('8784','2013-09-01','13:45:00',3.7),('8784','2013-09-01','13:50:00',3.27),('8784','2013-09-01','13:55:00',3.31),('8784','2013-09-01','14:00:00',3.04),('8784','2013-09-01','14:05:00',3.04),('8784','2013-09-01','14:10:00',3.47),('8784','2013-09-01','14:15:00',3.43),('8784','2013-09-01','14:20:00',3.12),('8784','2013-09-01','14:25:00',3.16),('8784','2013-09-01','14:30:00',3.3),('8784','2013-09-01','14:35:00',3.24),('8784','2013-09-01','14:40:00',3.27),('8784','2013-09-01','14:45:00',3.31),('8784','2013-09-01','14:50:00',3.29),('8784','2013-09-01','14:55:00',3.19),('8784','2013-09-01','15:00:00',3.19),('8784','2013-09-01','15:05:00',3.14),('8784','2013-09-01','15:10:00',3.12),('8784','2013-09-01','15:15:00',3.1),('8784','2013-09-01','15:20:00',2.91),('8784','2013-09-01','15:25:00',2.54),('8784','2013-09-01','15:30:00',2.16),('8784','2013-09-01','15:35:00',2.37),('8784','2013-09-01','15:40:00',2.78),('8784','2013-09-01','15:45:00',2.53),('8784','2013-09-01','15:50:00',1.89),('8784','2013-09-01','15:55:00',2.17),('8784','2013-09-01','16:00:00',2.64),('8784','2013-09-01','16:05:00',2.77),('8784','2013-09-01','16:10:00',2.74),('8784','2013-09-01','16:15:00',2.66),('8784','2013-09-01','16:20:00',2.43),('8784','2013-09-01','16:25:00',2.51),('8784','2013-09-01','16:30:00',2.64),('8784','2013-09-01','16:35:00',2.51),('8784','2013-09-01','16:40:00',2.47),('8784','2013-09-01','16:45:00',2.23),('8784','2013-09-01','16:50:00',2.2),('8784','2013-09-01','16:55:00',1.95),('8784','2013-09-01','17:00:00',1.59),('8784','2013-09-01','17:05:00',1.68),('8784','2013-09-01','17:10:00',1.4),('8784','2013-09-01','17:15:00',1.43),('8784','2013-09-01','17:20:00',1.55),('8784','2013-09-01','17:25:00',1.48),('8784','2013-09-01','17:30:00',1.31),('8784','2013-09-01','17:35:00',1.31),('8784','2013-09-01','17:40:00',1.37),('8784','2013-09-01','17:45:00',1.14),('8784','2013-09-01','17:50:00',1.02),('8784','2013-09-01','17:55:00',1),('8784','2013-09-01','18:00:00',1),('8784','2013-09-01','18:10:00',1.04),('8784','2013-08-31','08:20:00',1.07),('8784','2013-08-31','08:25:00',1.27),('8784','2013-08-31','08:30:00',1.49),('8784','2013-08-31','08:35:00',1.56),('8784','2013-08-31','08:40:00',1.68),('8784','2013-08-31','08:45:00',1.79),('8784','2013-08-31','08:50:00',1.97),('8784','2013-08-31','08:55:00',2.14),('8784','2013-08-31','09:00:00',2.25),('8784','2013-08-31','09:05:00',2.02),('8784','2013-08-31','09:10:00',1.65),('8784','2013-08-31','09:15:00',2.11),('8784','2013-08-31','09:20:00',2.3),('8784','2013-08-31','09:25:00',2.5),('8784','2013-08-31','09:30:00',2.57),('8784','2013-08-31','09:35:00',2.68),('8784','2013-08-31','09:40:00',2.72),('8784','2013-08-31','09:45:00',2.59),('8784','2013-08-31','09:50:00',2.62),('8784','2013-08-31','09:55:00',2.82),('8784','2013-08-31','10:00:00',2.98),('8784','2013-08-31','10:05:00',2.95),('8784','2013-08-31','10:10:00',3.09),('8784','2013-08-31','10:15:00',3.11),('8784','2013-08-31','10:20:00',3.15),('8784','2013-08-31','10:25:00',3.2),('8784','2013-08-31','10:30:00',3.28),('8784','2013-08-31','10:35:00',3.37),('8784','2013-08-31','10:40:00',3.37),('8784','2013-08-31','10:45:00',3.44),('8784','2013-08-31','10:50:00',3.52),('8784','2013-08-31','10:55:00',3.56),('8784','2013-08-31','11:00:00',3.63),('8784','2013-08-31','11:05:00',3.66),('8784','2013-08-31','11:10:00',3.69),('8784','2013-08-31','11:15:00',3.74),('8784','2013-08-31','11:20:00',3.75),('8784','2013-08-31','11:25:00',3.75),('8784','2013-08-31','11:30:00',3.84),('8784','2013-08-31','11:35:00',3.88),('8784','2013-08-31','11:40:00',3.91),('8784','2013-08-31','11:45:00',3.94),('8784','2013-08-31','11:50:00',3.97),('8784','2013-08-31','11:55:00',3.99),('8784','2013-08-31','12:00:00',3.78),('8784','2013-08-31','12:05:00',3.18),('8784','2013-08-31','12:10:00',3.35),('8784','2013-08-31','12:15:00',3.74),('8784','2013-08-31','12:20:00',4.02),('8784','2013-08-31','12:25:00',3.99),('8784','2013-08-31','12:30:00',4),('8784','2013-08-31','12:35:00',4.04),('8784','2013-08-31','12:40:00',3.97),('8784','2013-08-31','12:45:00',4.01),('8784','2013-08-31','12:50:00',4),('8784','2013-08-31','12:55:00',4.03),('8784','2013-08-31','13:00:00',4.01),('8784','2013-08-31','13:05:00',4.02),('8784','2013-08-31','13:10:00',3.96),('8784','2013-08-31','13:15:00',4.02),('8784','2013-08-31','13:20:00',3.99),('8784','2013-08-31','13:25:00',3.98),('8784','2013-08-31','13:30:00',4.02),('8784','2013-08-31','13:35:00',3.96),('8784','2013-08-31','13:40:00',3.96),('8784','2013-08-31','13:45:00',3.91),('8784','2013-08-31','13:50:00',3.94),('8784','2013-08-31','13:55:00',3.9),('8784','2013-08-31','14:00:00',3.88),('8784','2013-08-31','14:05:00',3.87),('8784','2013-08-31','14:10:00',3.83),('8784','2013-08-31','14:15:00',3.8),('8784','2013-08-31','14:20:00',3.75),('8784','2013-08-31','14:25:00',3.68),('8784','2013-08-31','14:30:00',3.68),('8784','2013-08-31','14:35:00',3.52),('8784','2013-08-31','14:40:00',3.57),('8784','2013-08-31','14:45:00',3.57),('8784','2013-08-31','14:50:00',3.56),('8784','2013-08-31','14:55:00',3.43),('8784','2013-08-31','15:00:00',3.39),('8784','2013-08-31','15:05:00',3.39),('8784','2013-08-31','15:10:00',3.37),('8784','2013-08-31','15:15:00',3.31),('8784','2013-08-31','15:20:00',3.27),('8784','2013-08-31','15:25:00',3.22),('8784','2013-08-31','15:30:00',3.19),('8784','2013-08-31','15:35:00',3.09),('8784','2013-08-31','15:40:00',3.06),('8784','2013-08-31','15:45:00',3.01),('8784','2013-08-31','15:50:00',2.94),('8784','2013-08-31','15:55:00',2.87),('8784','2013-08-31','16:00:00',2.83),('8784','2013-08-31','16:05:00',2.77),('8784','2013-08-31','16:10:00',2.69),('8784','2013-08-31','16:15:00',2.67),('8784','2013-08-31','16:20:00',2.62),('8784','2013-08-31','16:25:00',2.52),('8784','2013-08-31','16:30:00',2.46),('8784','2013-08-31','16:35:00',2.45),('8784','2013-08-31','16:40:00',2.36),('8784','2013-08-31','16:45:00',2.23),('8784','2013-08-31','16:50:00',2.15),('8784','2013-08-31','16:55:00',2.08),('8784','2013-08-31','17:00:00',1.99),('8784','2013-08-31','17:05:00',1.98),('8784','2013-08-31','17:10:00',1.88),('8784','2013-08-31','17:15:00',1.78),('8784','2013-08-31','17:20:00',1.72),('8784','2013-08-31','17:25:00',1.63),('8784','2013-08-31','17:30:00',1.54),('8784','2013-08-31','17:35:00',1.42),('8784','2013-08-31','17:40:00',1.37),('8784','2013-08-31','17:45:00',1.26),('8784','2013-08-31','17:50:00',1.17),('8784','2013-08-31','17:55:00',1.02),('8784','2013-08-30','08:00:00',1.03),('8784','2013-08-30','08:05:00',1.23),('8784','2013-08-30','08:10:00',1.38),('8784','2013-08-30','08:15:00',1.33),('8784','2013-08-30','08:20:00',1.4),('8784','2013-08-30','08:25:00',1.45),('8784','2013-08-30','08:30:00',1.5),('8784','2013-08-30','08:35:00',1.59),('8784','2013-08-30','08:40:00',1.61),('8784','2013-08-30','08:45:00',1.45),('8784','2013-08-30','08:50:00',1.32),('8784','2013-08-30','08:55:00',1.34),('8784','2013-08-30','09:00:00',1.55),('8784','2013-08-30','09:05:00',1.69),('8784','2013-08-30','09:10:00',1.5),('8784','2013-08-30','09:15:00',1.39),('8784','2013-08-30','09:20:00',1.24),('8784','2013-08-30','09:25:00',1.34),('8784','2013-08-30','09:30:00',1.71),('8784','2013-08-30','09:35:00',1.92),('8784','2013-08-30','09:40:00',1.83),('8784','2013-08-30','09:45:00',1.86),('8784','2013-08-30','09:50:00',1.88),('8784','2013-08-30','09:55:00',1.98),('8784','2013-08-30','10:00:00',2.02),('8784','2013-08-30','10:05:00',2.01),('8784','2013-08-30','10:10:00',2.02),('8784','2013-08-30','10:15:00',2.16),('8784','2013-08-30','10:20:00',2.24),('8784','2013-08-30','10:25:00',2.08),('8784','2013-08-30','10:30:00',2.29),('8784','2013-08-30','10:35:00',2.19),('8784','2013-08-30','10:40:00',2.09),('8784','2013-08-30','10:45:00',2.05),('8784','2013-08-30','10:50:00',2.18),('8784','2013-08-30','10:55:00',2.07),('8784','2013-08-30','11:00:00',2.18),('8784','2013-08-30','11:05:00',2.28),('8784','2013-08-30','11:10:00',2.41),('8784','2013-08-30','11:15:00',2.43),('8784','2013-08-30','11:20:00',2.45),('8784','2013-08-30','11:25:00',2.52),('8784','2013-08-30','11:30:00',2.66),('8784','2013-08-30','11:35:00',2.52),('8784','2013-08-30','11:40:00',2.73),('8784','2013-08-30','11:45:00',2.71),('8784','2013-08-30','11:50:00',3.07),('8784','2013-08-30','11:55:00',2.7),('8784','2013-08-30','12:00:00',2.44),('8784','2013-08-30','12:05:00',2.13),('8784','2013-08-30','12:10:00',2.32),('8784','2013-08-30','12:15:00',2.54),('8784','2013-08-30','12:20:00',2.65),('8784','2013-08-30','12:25:00',3.04),('8784','2013-08-30','12:30:00',3.35),('8784','2013-08-30','12:35:00',3.18),('8784','2013-08-30','12:40:00',3.11),('8784','2013-08-30','12:45:00',3.22),('8784','2013-08-30','12:50:00',3.14),('8784','2013-08-30','12:55:00',2.94),('8784','2013-08-30','13:00:00',2.9),('8784','2013-08-30','13:05:00',2.91),('8784','2013-08-30','13:10:00',2.91),('8784','2013-08-30','13:15:00',2.83),('8784','2013-08-30','13:20:00',3.35),('8784','2013-08-30','13:25:00',3.8),('8784','2013-08-30','13:30:00',4.03),('8784','2013-08-30','13:35:00',3.73),('8784','2013-08-30','13:40:00',3.93),('8784','2013-08-30','13:45:00',3.55),('8784','2013-08-30','13:50:00',3.54),('8784','2013-08-30','13:55:00',3.86),('8784','2013-08-30','14:00:00',4),('8784','2013-08-30','14:05:00',3.8),('8784','2013-08-30','14:10:00',3.85),('8784','2013-08-30','14:15:00',3.76),('8784','2013-08-30','14:20:00',3.88),('8784','2013-08-30','14:25:00',3.82),('8784','2013-08-30','14:30:00',3.8),('8784','2013-08-30','14:35:00',3.86),('8784','2013-08-30','14:40:00',3.67),('8784','2013-08-30','14:45:00',2.92),('8784','2013-08-30','14:50:00',2.54),('8784','2013-08-30','14:55:00',2.93),('8784','2013-08-30','15:00:00',2.5),('8784','2013-08-30','15:05:00',2.32),('8784','2013-08-30','15:10:00',2.37),('8784','2013-08-30','15:15:00',2.93),('8784','2013-08-30','15:20:00',2.48),('8784','2013-08-30','15:25:00',2.24),('8784','2013-08-30','15:30:00',2.13),('8784','2013-08-30','15:35:00',1.75),('8784','2013-08-30','15:40:00',1.91),('8784','2013-08-30','15:45:00',2.27),('8784','2013-08-30','15:50:00',2.43),('8784','2013-08-30','15:55:00',2.36),('8784','2013-08-30','16:00:00',2.23),('8784','2013-08-30','16:05:00',1.96),('8784','2013-08-30','16:10:00',1.65),('8784','2013-08-30','16:15:00',1.52),('8784','2013-08-30','16:20:00',1.72),('8784','2013-08-30','16:25:00',1.67),('8784','2013-08-30','16:30:00',1.88),('8784','2013-08-30','16:35:00',1.4),('8784','2013-08-30','16:40:00',2.13),('8784','2013-08-30','16:45:00',2.5),('8784','2013-08-30','16:50:00',2.32),('8784','2013-08-30','16:55:00',1.6),('8784','2013-08-30','17:00:00',1.89),('8784','2013-08-30','17:05:00',1.37),('8784','2013-08-30','17:10:00',1.54),('8784','2013-08-30','17:15:00',1.43),('8784','2013-08-30','17:20:00',1.23),('8784','2013-08-30','17:25:00',1.3),('8784','2013-08-30','17:30:00',1.37),('8784','2013-08-30','17:35:00',1.52),('8784','2013-08-30','17:40:00',1.11),('8784','2013-08-30','17:45:00',1.4),('8784','2013-08-30','17:50:00',1.17),('8784','2013-08-30','17:55:00',1.17),('8784','2013-08-30','18:00:00',1.09),('8784','2014-04-11','07:50:00',1.02),('8784','2014-04-11','07:55:00',1.05),('8784','2014-04-11','08:35:00',1.84),('8784','2014-04-11','08:40:00',1.96),('8784','2014-04-11','08:45:00',2.03),('8784','2014-04-11','08:50:00',2.05),('8784','2014-04-11','08:55:00',2.05),('8784','2014-04-11','09:00:00',2.1),('8784','2014-04-11','09:05:00',2.16),('8784','2014-04-11','09:10:00',2.25),('8784','2014-04-11','09:15:00',2.33),('8784','2014-04-11','09:20:00',2.41),('8784','2014-04-11','09:25:00',2.49),('8784','2014-04-11','09:30:00',2.56),('8784','2014-04-11','09:35:00',2.64),('8784','2014-04-11','09:40:00',2.73),('8784','2014-04-11','09:45:00',2.77),('8784','2014-04-11','09:50:00',2.87),('8784','2014-04-11','09:55:00',2.95),('8784','2014-04-11','10:00:00',3.03),('8784','2014-04-11','10:05:00',3.11),('8784','2014-04-11','10:10:00',3.18),('8784','2014-04-11','10:15:00',3.25),('8784','2014-04-11','10:20:00',3.32),('8784','2014-04-11','10:25:00',3.39),('8784','2014-04-11','10:30:00',3.43),('8784','2014-04-11','10:35:00',3.44),('8784','2014-04-11','10:40:00',3.53),('8784','2014-04-11','10:45:00',3.61),('8784','2014-04-11','10:50:00',3.68),('8784','2014-04-11','10:55:00',3.72),('8784','2014-04-11','11:00:00',3.79),('8784','2014-04-11','11:05:00',3.83),('8784','2014-04-11','11:10:00',3.81),('8784','2014-04-11','11:15:00',3.87),('8784','2014-04-11','11:20:00',3.94),('8784','2014-04-11','11:25:00',4.01),('8784','2014-04-11','11:30:00',4.03),('8784','2014-04-11','11:35:00',4.07),('8784','2014-04-11','11:40:00',4.04),('8784','2014-04-11','11:45:00',4.08),('8784','2014-04-11','11:50:00',4.19),('8784','2014-04-11','11:55:00',4.36),('8784','2014-04-11','12:00:00',4.41),('8784','2014-04-11','12:05:00',4.32),('8784','2014-04-11','12:10:00',4.46),('8784','2014-04-11','12:15:00',3.54),('8784','2014-04-11','12:20:00',4.35),('8784','2014-04-11','12:25:00',4.41),('8784','2014-04-11','12:30:00',4.46),('8784','2014-04-11','12:35:00',4.53),('8784','2014-04-11','12:40:00',4.58),('8784','2014-04-11','12:45:00',3.9),('8784','2014-04-11','12:50:00',4.72),('8784','2014-04-11','12:55:00',4.57),('8784','2014-04-11','13:00:00',3.8),('8784','2014-04-11','13:05:00',4.05),('8784','2014-04-11','13:10:00',3.2),('8784','2014-04-11','13:15:00',3.38),('8784','2014-04-11','13:20:00',3.54),('8784','2014-04-11','13:25:00',3.31),('8784','2014-04-11','13:30:00',2.51),('8784','2014-04-11','13:35:00',3.48),('8784','2014-04-11','13:40:00',1.99),('8784','2014-04-11','13:45:00',4.63),('8784','2014-04-11','13:50:00',3.2),('8784','2014-04-11','13:55:00',4.37),('8784','2014-04-11','14:00:00',3.05),('8784','2014-04-11','14:05:00',4.55),('8784','2014-04-11','14:10:00',2.61),('8784','2014-04-11','14:15:00',2.85),('8784','2014-04-11','14:20:00',3.75),('8784','2014-04-11','14:25:00',2.88),('8784','2014-04-11','14:30:00',4.52),('8784','2014-04-11','14:35:00',4.52),('8784','2014-04-11','14:40:00',2.43),('8784','2014-04-11','14:45:00',3.64),('8784','2014-04-11','14:50:00',4.26),('8784','2014-04-11','14:55:00',3.08),('8784','2014-04-11','15:00:00',4.41),('8784','2014-04-11','15:05:00',3.86),('8784','2014-04-11','15:10:00',3.85),('8784','2014-04-11','15:15:00',3.92),('8784','2014-04-11','15:20:00',3.23),('8784','2014-04-11','15:25:00',3.78),('8784','2014-04-11','15:30:00',3.71),('8784','2014-04-11','15:35:00',1.91),('8784','2014-04-11','15:40:00',3.55),('8784','2014-04-11','15:45:00',3.41),('8784','2014-04-11','15:50:00',3.4),('8784','2014-04-11','15:55:00',3.36),('8784','2014-04-11','16:00:00',3.24),('8784','2014-04-11','16:05:00',3.11),('8784','2014-04-11','16:10:00',2.32),('8784','2014-04-11','16:15:00',2.97),('8784','2014-04-11','16:20:00',2.9),('8784','2014-04-11','16:25:00',2.84),('8784','2014-04-11','16:30:00',2.79),('8784','2014-04-11','16:35:00',2.33),('8784','2014-04-11','16:40:00',2.68),('8784','2014-04-11','16:45:00',2.59),('8784','2014-04-11','16:50:00',1.81),('8784','2014-04-11','16:55:00',2.15),('8784','2014-04-11','17:00:00',2.39),('8784','2014-04-11','17:05:00',2.06),('8784','2014-04-11','17:10:00',2),('8784','2014-04-11','17:15:00',2.06),('8784','2014-04-11','17:20:00',1.99),('8784','2014-04-11','17:25:00',1.9),('8784','2014-04-11','17:30:00',1.92),('8784','2014-04-11','17:35:00',1.87),('8784','2014-04-11','17:40:00',1.77),('8784','2014-04-11','17:45:00',1.57),('8784','2014-04-11','17:50:00',1.41),('8784','2014-04-11','17:55:00',1.31),('8784','2014-04-11','18:00:00',1.19),('8784','2014-04-11','18:05:00',1.11),('8784','2014-04-11','18:10:00',1.03),('8784','2013-08-29','07:55:00',1.01),('8784','2013-08-29','08:00:00',1.1),('8784','2013-08-29','08:05:00',1.15),('8784','2013-08-29','08:10:00',1.25),('8784','2013-08-29','08:15:00',1.37),('8784','2013-08-29','08:20:00',1.45),('8784','2013-08-29','08:25:00',1.67),('8784','2013-08-29','08:30:00',1.95),('8784','2013-08-29','08:35:00',1.89),('8784','2013-08-29','08:40:00',1.46),('8784','2013-08-29','08:45:00',1.17),('8784','2013-08-29','08:50:00',1.38),('8784','2013-08-29','08:55:00',1.8),('8784','2013-08-29','09:00:00',1.73),('8784','2013-08-29','09:05:00',1.69),('8784','2013-08-29','09:10:00',1.65),('8784','2013-08-29','09:15:00',1.76),('8784','2013-08-29','09:20:00',1.73),('8784','2013-08-29','09:25:00',1.58),('8784','2013-08-29','09:30:00',1.66),('8784','2013-08-29','09:35:00',1.82),('8784','2013-08-29','09:40:00',1.83),('8784','2013-08-29','09:45:00',1.64),('8784','2013-08-29','09:50:00',1.58),('8784','2013-08-29','09:55:00',1.64),('8784','2013-08-29','10:00:00',1.72),('8784','2013-08-29','10:05:00',1.65),('8784','2013-08-29','10:10:00',1.62),('8784','2013-08-29','10:15:00',1.62),('8784','2013-08-29','10:20:00',1.65),('8784','2013-08-29','10:25:00',1.65),('8784','2013-08-29','10:30:00',1.69),('8784','2013-08-29','10:35:00',1.6),('8784','2013-08-29','10:40:00',1.47),('8784','2013-08-29','10:45:00',1.38),('8784','2013-08-29','10:50:00',1.37),('8784','2013-08-29','10:55:00',1.53),('8784','2013-08-29','11:00:00',1.63),('8784','2013-08-29','11:05:00',1.65),('8784','2013-08-29','11:10:00',2.4),('8784','2013-08-29','11:15:00',2.63),('8784','2013-08-29','11:20:00',2.43),('8784','2013-08-29','11:25:00',1.89),('8784','2013-08-29','11:30:00',1.67),('8784','2013-08-29','11:35:00',1.51),('8784','2013-08-29','11:40:00',1.72),('8784','2013-08-29','11:45:00',1.99),('8784','2013-08-29','11:50:00',2.05),('8784','2013-08-29','11:55:00',1.97),('8784','2013-08-29','12:00:00',1.94),('8784','2013-08-29','12:05:00',2.23),('8784','2013-08-29','12:10:00',2.64),('8784','2013-08-29','12:15:00',3.01),('8784','2013-08-29','12:20:00',2.7),('8784','2013-08-29','12:25:00',2.71),('8784','2013-08-29','12:30:00',2.79),('8784','2013-08-29','12:35:00',3.34),('8784','2013-08-29','12:40:00',4.6),('8784','2013-08-29','12:45:00',4.33),('8784','2013-08-29','12:50:00',2.72),('8784','2013-08-29','12:55:00',3.91),('8784','2013-08-29','13:00:00',2.9),('8784','2013-08-29','13:05:00',2.72),('8784','2013-08-29','13:10:00',2.6),('8784','2013-08-29','13:15:00',2.51),('8784','2013-08-29','13:20:00',2.44),('8784','2013-08-29','13:25:00',2.11),('8784','2013-08-29','13:30:00',2),('8784','2013-08-29','13:35:00',1.88),('8784','2013-08-29','13:40:00',1.79),('8784','2013-08-29','13:45:00',1.69),('8784','2013-08-29','13:50:00',1.65),('8784','2013-08-29','13:55:00',1.92),('8784','2013-08-29','14:00:00',2.45),('8784','2013-08-29','14:05:00',1.81),('8784','2013-08-29','14:10:00',1.63),('8784','2013-08-29','14:15:00',1.36),('8784','2013-08-29','14:20:00',1.11),('8784','2013-08-29','14:40:00',1.02),('8784','2013-08-29','14:45:00',1.13),('8784','2013-08-29','14:50:00',1.31),('8784','2013-08-29','14:55:00',1.5),('8784','2013-08-29','15:00:00',1.65),('8784','2013-08-29','15:05:00',1.84),('8784','2013-08-29','15:10:00',1.46),('8784','2013-08-29','15:15:00',1.28),('8784','2013-08-29','15:20:00',1.41),('8784','2013-08-29','15:25:00',1.61),('8784','2013-08-29','15:30:00',2.58),('8784','2013-08-29','15:35:00',2.35),('8784','2013-08-29','15:40:00',2.29),('8784','2013-08-29','15:45:00',2.47),('8784','2013-08-29','15:50:00',3.01),('8784','2013-08-29','15:55:00',3.28),('8784','2013-08-29','16:00:00',3.01),('8784','2013-08-29','16:05:00',3.46),('8784','2013-08-29','16:10:00',3.22),('8784','2013-08-29','16:15:00',2.99),('8784','2013-08-29','16:20:00',2.85),('8784','2013-08-29','16:25:00',2.71),('8784','2013-08-29','16:30:00',2.64),('8784','2013-08-29','16:35:00',2.57),('8784','2013-08-29','16:40:00',2.49),('8784','2013-08-29','16:45:00',2.4),('8784','2013-08-29','16:50:00',2.33),('8784','2013-08-29','16:55:00',2.27),('8784','2013-08-29','17:00:00',2.19),('8784','2013-08-29','17:05:00',2.11),('8784','2013-08-29','17:10:00',2.02),('8784','2013-08-29','17:15:00',1.92),('8784','2013-08-29','17:20:00',1.86),('8784','2013-08-29','17:25:00',1.75),('8784','2013-08-29','17:30:00',1.67),('8784','2013-08-29','17:35:00',1.58),('8784','2013-08-29','17:40:00',1.49),('8784','2013-08-29','17:45:00',1.38),('8784','2013-08-29','17:50:00',1.3),('8784','2013-08-29','17:55:00',1.22),('8784','2013-08-29','18:00:00',1.13),('8784','2013-08-29','18:05:00',1.06),('8784','2013-08-28','08:00:00',1.1),('8784','2013-08-28','08:05:00',1.15),('8784','2013-08-28','08:10:00',1.22),('8784','2013-08-28','08:15:00',1.3),('8784','2013-08-28','08:20:00',1.38),('8784','2013-08-28','08:25:00',1.42),('8784','2013-08-28','08:30:00',1.54),('8784','2013-08-28','08:35:00',1.71),('8784','2013-08-28','08:40:00',1.54),('8784','2013-08-28','08:45:00',1.3),('8784','2013-08-28','08:50:00',1.39),('8784','2013-08-28','08:55:00',1.1),('8784','2013-08-28','09:00:00',1.78),('8784','2013-08-28','09:10:00',1.17),('8784','2013-08-28','09:15:00',2.25),('8784','2013-08-28','09:20:00',1.16),('8784','2013-08-28','09:30:00',1.35),('8784','2013-08-28','09:35:00',2.25),('8784','2013-08-28','09:40:00',2.62),('8784','2013-08-28','09:45:00',2.73),('8784','2013-08-28','09:50:00',2.81),('8784','2013-08-28','09:55:00',2.83),('8784','2013-08-28','10:00:00',2.85),('8784','2013-08-28','10:05:00',2.88),('8784','2013-08-28','10:10:00',3.03),('8784','2013-08-28','10:15:00',3.18),('8784','2013-08-28','10:20:00',2.97),('8784','2013-08-28','10:25:00',1.67),('8784','2013-08-28','10:30:00',2.33),('8784','2013-08-28','10:35:00',1.82),('8784','2013-08-28','10:40:00',2.76),('8784','2013-08-28','10:45:00',3.67),('8784','2013-08-28','10:50:00',2.27),('8784','2013-08-28','10:55:00',3.49),('8784','2013-08-28','11:00:00',1.39),('8784','2013-08-28','11:05:00',3.71),('8784','2013-08-28','11:10:00',1.33),('8784','2013-08-28','11:15:00',3.89),('8784','2013-08-28','11:20:00',4),('8784','2013-08-28','11:25:00',4.05),('8784','2013-08-28','11:30:00',4.14),('8784','2013-08-28','11:35:00',4.15),('8784','2013-08-28','11:40:00',4.28),('8784','2013-08-28','11:45:00',2.81),('8784','2013-08-28','11:50:00',3.22),('8784','2013-08-28','11:55:00',2.06),('8784','2013-08-28','12:00:00',3.21),('8784','2013-08-28','12:05:00',3.2),('8784','2013-08-28','12:10:00',3.77),('8784','2013-08-28','12:15:00',4.29),('8784','2013-08-28','12:20:00',3.94),('8784','2013-08-28','12:25:00',4.19),('8784','2013-08-28','12:30:00',4.16),('8784','2013-08-28','12:35:00',4.18),('8784','2013-08-28','12:40:00',4.23),('8784','2013-08-28','12:45:00',4.34),('8784','2013-08-28','12:50:00',4.28),('8784','2013-08-28','12:55:00',4.23),('8784','2013-08-28','13:00:00',4.3),('8784','2013-08-28','13:05:00',4.02),('8784','2013-08-28','13:10:00',4.4),('8784','2013-08-28','13:15:00',4.31),('8784','2013-08-28','13:20:00',4.25),('8784','2013-08-28','13:25:00',4.25),('8784','2013-08-28','13:30:00',4.04),('8784','2013-08-28','13:35:00',4.26),('8784','2013-08-28','13:40:00',3.59),('8784','2013-08-28','13:45:00',3.72),('8784','2013-08-28','13:50:00',4.31),('8784','2013-08-28','13:55:00',3.01),('8784','2013-08-28','14:00:00',4.23),('8784','2013-08-28','14:05:00',4.11),('8784','2013-08-28','14:10:00',4.14),('8784','2013-08-28','14:15:00',4.11),('8784','2013-08-28','14:20:00',4.06),('8784','2013-08-28','14:25:00',4.06),('8784','2013-08-28','14:30:00',3.45),('8784','2013-08-28','14:35:00',3.23),('8784','2013-08-28','14:40:00',4.1),('8784','2013-08-28','14:45:00',3.94),('8784','2013-08-28','14:50:00',3.88),('8784','2013-08-28','14:55:00',3.82),('8784','2013-08-28','15:00:00',3.74),('8784','2013-08-28','15:05:00',3.31),('8784','2013-08-28','15:10:00',3.8),('8784','2013-08-28','15:15:00',3.73),('8784','2013-08-28','15:20:00',3.55),('8784','2013-08-28','15:25:00',2.3),('8784','2013-08-28','15:30:00',2.69),('8784','2013-08-28','15:35:00',2.98),('8784','2013-08-28','15:40:00',1.35),('8784','2013-08-28','15:45:00',1.98),('8784','2013-08-28','15:50:00',1.8),('8784','2013-08-28','15:55:00',3.16),('8784','2013-08-28','16:00:00',3.4),('8784','2013-08-28','16:05:00',2.7),('8784','2013-08-28','16:10:00',2.1),('8784','2013-08-28','16:15:00',2.28),('8784','2013-08-28','16:20:00',2.28),('8784','2013-08-28','16:25:00',3.03),('8784','2013-08-28','16:30:00',2.83),('8784','2013-08-28','16:35:00',2.77),('8784','2013-08-28','16:40:00',2.7),('8784','2013-08-28','16:45:00',2.52),('8784','2013-08-28','16:50:00',2.31),('8784','2013-08-28','16:55:00',2.33),('8784','2013-08-28','17:00:00',2.28),('8784','2013-08-28','17:05:00',2.15),('8784','2013-08-28','17:10:00',1.77),('8784','2013-08-28','17:20:00',1.26),('8784','2013-08-28','17:25:00',1.6),('8784','2013-08-28','17:35:00',1.69),('8784','2013-08-28','17:40:00',1.66),('8784','2013-08-28','17:55:00',1.18),('8784','2013-08-28','18:15:00',1.03),('8784','2013-08-27','08:20:00',1.24),('8784','2013-08-27','08:25:00',1.59),('8784','2013-08-27','08:30:00',1.58),('8784','2013-08-27','08:35:00',1.12),('8784','2013-08-27','08:40:00',1.07),('8784','2013-08-27','08:45:00',1.25),('8784','2013-08-27','09:05:00',1.08),('8784','2013-08-27','09:10:00',1.09),('8784','2013-08-27','09:15:00',1.37),('8784','2013-08-27','09:20:00',1.63),('8784','2013-08-27','09:25:00',2.1),('8784','2013-08-27','09:30:00',2.29),('8784','2013-08-27','09:35:00',1.33),('8784','2013-08-27','09:40:00',1.06),('8784','2013-08-27','09:45:00',1.11),('8784','2013-08-27','09:50:00',1.17),('8784','2013-08-27','09:55:00',1.52),('8784','2013-08-27','10:00:00',1.93),('8784','2013-08-27','10:05:00',2.29),('8784','2013-08-27','10:10:00',2.85),('8784','2013-08-27','10:15:00',2.9),('8784','2013-08-27','10:20:00',3.06),('8784','2013-08-27','10:25:00',3.14),('8784','2013-08-27','10:30:00',3.11),('8784','2013-08-27','10:35:00',3.21),('8784','2013-08-27','10:40:00',3.15),('8784','2013-08-27','10:45:00',3.2),('8784','2013-08-27','10:50:00',3.18),('8784','2013-08-27','10:55:00',3.31),('8784','2013-08-27','11:00:00',3.36),('8784','2013-08-27','11:05:00',3.47),('8784','2013-08-27','11:10:00',3.49),('8784','2013-08-27','11:15:00',3.46),('8784','2013-08-27','11:20:00',3.47),('8784','2013-08-27','11:25:00',3.5),('8784','2013-08-27','11:30:00',3.53),('8784','2013-08-27','11:35:00',3.55),('8784','2013-08-27','11:40:00',3.43),('8784','2013-08-27','11:45:00',4.36),('8784','2013-08-27','11:50:00',3.2),('8784','2013-08-27','11:55:00',4.06),('8784','2013-08-27','12:00:00',4.15),('8784','2013-08-27','12:05:00',3.79),('8784','2013-08-27','12:10:00',3.18),('8784','2013-08-27','12:15:00',3.82),('8784','2013-08-27','12:20:00',4.06),('8784','2013-08-27','12:25:00',3.73),('8784','2013-08-27','12:30:00',3.9),('8784','2013-08-27','12:35:00',4.26),('8784','2013-08-27','12:40:00',4.37),('8784','2013-08-27','12:45:00',3.04),('8784','2013-08-27','12:50:00',2.17),('8784','2013-08-27','12:55:00',1.93),('8784','2013-08-27','13:00:00',1.4),('8784','2013-08-27','13:05:00',1.69),('8784','2013-08-27','13:10:00',2.11),('8784','2013-08-27','13:15:00',1.88),('8784','2013-08-27','13:20:00',2.19),('8784','2013-08-27','13:25:00',2.39),('8784','2013-08-27','13:30:00',2.56),('8784','2013-08-27','13:35:00',2.08),('8784','2013-08-27','13:40:00',1.96),('8784','2013-08-27','13:45:00',2.92),('8784','2013-08-27','13:50:00',3.75),('8784','2013-08-27','13:55:00',3.13),('8784','2013-08-27','14:00:00',4.12),('8784','2013-08-27','14:05:00',1.98),('8784','2013-08-27','14:10:00',2.38),('8784','2013-08-27','14:15:00',3.33),('8784','2013-08-27','14:20:00',2.06),('8784','2013-08-27','14:25:00',1.35),('8784','2013-08-27','14:30:00',1.32),('8784','2013-08-27','14:35:00',1.19),('8784','2013-08-27','14:40:00',1.33),('8784','2013-08-27','14:45:00',1.36),('8784','2013-08-27','14:50:00',1.06),('8784','2013-08-27','15:55:00',1.42),('8784','2013-08-27','16:00:00',1.54),('8784','2013-08-27','16:05:00',1.9),('8784','2013-08-27','16:10:00',3.67),('8784','2013-08-27','16:15:00',3.26),('8784','2013-08-27','16:20:00',2.2),('8784','2013-08-27','16:25:00',2.22),('8784','2013-08-27','16:35:00',1.26),('8784','2013-08-27','16:40:00',1.45),('8784','2013-08-27','16:45:00',1.98),('8784','2013-08-27','16:50:00',2.53),('8784','2013-08-27','16:55:00',1.83),('8784','2013-08-27','17:05:00',1.26),('8784','2013-08-27','17:10:00',2.64),('8784','2013-08-27','17:15:00',1.37),('8784','2013-08-27','17:45:00',1.28),('8784','2013-08-27','17:50:00',1.47),('8784','2013-08-27','17:55:00',1.47),('8784','2013-08-27','18:00:00',1.27),('8784','2013-08-26','08:05:00',1.51),('8784','2013-08-26','08:10:00',1.31),('8784','2013-08-26','08:20:00',1.59),('8784','2013-08-26','08:25:00',1.33),('8784','2013-08-26','08:30:00',1.55),('8784','2013-08-26','08:35:00',1.42),('8784','2013-08-26','08:40:00',1.72),('8784','2013-08-26','08:45:00',1.8),('8784','2013-08-26','08:50:00',1.85),('8784','2013-08-26','08:55:00',1.93),('8784','2013-08-26','09:00:00',1.99),('8784','2013-08-26','09:05:00',2.07),('8784','2013-08-26','09:10:00',2.11),('8784','2013-08-26','09:15:00',2.18),('8784','2013-08-26','09:20:00',2.3),('8784','2013-08-26','09:25:00',2.41),('8784','2013-08-26','09:30:00',2.44),('8784','2013-08-26','09:35:00',2.52),('8784','2013-08-26','09:40:00',2.58),('8784','2013-08-26','09:45:00',2.69),('8784','2013-08-26','09:50:00',2.74),('8784','2013-08-26','09:55:00',2.77),('8784','2013-08-26','10:00:00',2.82),('8784','2013-08-26','10:05:00',2.89),('8784','2013-08-26','10:10:00',2.96),('8784','2013-08-26','10:15:00',2.98),('8784','2013-08-26','10:20:00',3.1),('8784','2013-08-26','10:25:00',3.15),('8784','2013-08-26','10:30:00',3.18),('8784','2013-08-26','10:35:00',3.24),('8784','2013-08-26','10:40:00',3.32),('8784','2013-08-26','10:45:00',3.38),('8784','2013-08-26','10:50:00',3.41),('8784','2013-08-26','10:55:00',3.41),('8784','2013-08-26','11:00:00',3.48),('8784','2013-08-26','11:05:00',3.43),('8784','2013-08-26','11:10:00',3.54),('8784','2013-08-26','11:15:00',3.59),('8784','2013-08-26','11:20:00',3.61),('8784','2013-08-26','11:25:00',3.65),('8784','2013-08-26','11:30:00',3.7),('8784','2013-08-26','11:35:00',3.74),('8784','2013-08-26','11:40:00',3.75),('8784','2013-08-26','11:45:00',3.77),('8784','2013-08-26','11:50:00',3.8),('8784','2013-08-26','11:55:00',3.77),('8784','2013-08-26','12:00:00',3.82),('8784','2013-08-26','12:05:00',3.85),('8784','2013-08-26','12:10:00',3.87),('8784','2013-08-26','12:15:00',3.88),('8784','2013-08-26','12:20:00',3.84),('8784','2013-08-26','12:25:00',3.86),('8784','2013-08-26','12:30:00',3.87),('8784','2013-08-26','12:35:00',3.91),('8784','2013-08-26','12:40:00',3.93),('8784','2013-08-26','12:45:00',3.97),('8784','2013-08-26','12:50:00',3.97),('8784','2013-08-26','12:55:00',4.01),('8784','2013-08-26','13:00:00',4.15),('8784','2013-08-26','13:05:00',4.65),('8784','2013-08-26','13:10:00',4.07),('8784','2013-08-26','13:15:00',3.62),('8784','2013-08-26','13:20:00',2.65),('8784','2013-08-26','13:25:00',2.99),('8784','2013-08-26','13:30:00',2.89),('8784','2013-08-26','13:35:00',3.61),('8784','2013-08-26','13:40:00',3.92),('8784','2013-08-26','13:45:00',3.98),('8784','2013-08-26','13:50:00',3.98),('8784','2013-08-26','13:55:00',2.88),('8784','2013-08-26','14:00:00',2.69),('8784','2013-08-26','14:05:00',3.4),('8784','2013-08-26','14:10:00',2.67),('8784','2013-08-26','14:15:00',3.75),('8784','2013-08-26','14:20:00',3.83),('8784','2013-08-26','14:25:00',3.77),('8784','2013-08-26','14:30:00',3.72),('8784','2013-08-26','14:35:00',3.54),('8784','2013-08-26','14:40:00',3.19),('8784','2013-08-26','14:45:00',2.37),('8784','2013-08-26','14:50:00',2.13),('8784','2013-08-26','14:55:00',1.99),('8784','2013-08-26','15:00:00',1.9),('8784','2013-08-26','15:05:00',1.38),('8784','2013-08-26','15:10:00',1.12),('8784','2013-08-26','15:35:00',1.05),('8784','2013-08-26','15:40:00',1.66),('8784','2013-08-26','15:45:00',1.78),('8784','2013-08-26','15:50:00',1.73),('8784','2013-08-26','15:55:00',1.65),('8784','2013-08-26','16:00:00',2.57),('8784','2013-08-26','16:05:00',3.28),('8784','2013-08-26','16:10:00',2.9),('8784','2013-08-26','16:15:00',2.75),('8784','2013-08-26','16:20:00',2.69),('8784','2013-08-26','16:25:00',2.59),('8784','2013-08-26','16:30:00',2.5),('8784','2013-08-26','16:35:00',2.44),('8784','2013-08-26','16:40:00',2.38),('8784','2013-08-26','16:45:00',2.32),('8784','2013-08-26','16:50:00',2.14),('8784','2013-08-26','16:55:00',2.14),('8784','2013-08-26','17:00:00',2.1),('8784','2013-08-26','17:05:00',1.89),('8784','2013-08-26','17:10:00',1.93),('8784','2013-08-26','17:15:00',1.85),('8784','2013-08-26','17:20:00',1.33),('8784','2013-08-26','17:30:00',1.38),('8784','2013-08-26','17:35:00',1.06),('8784','2013-08-26','17:40:00',1.11),('8784','2013-08-26','17:45:00',1.3),('8784','2013-08-26','17:50:00',1.47),('8784','2013-08-26','17:55:00',1.44),('8784','2013-08-26','18:00:00',1.25),('8784','2013-08-26','18:05:00',1.09),('8784','2013-08-25','08:05:00',1.1),('8784','2013-08-25','08:10:00',1.28),('8784','2013-08-25','08:15:00',1.3),('8784','2013-08-25','08:20:00',1.23),('8784','2013-08-25','08:25:00',1.28),('8784','2013-08-25','08:35:00',1.06),('8784','2013-08-25','08:40:00',1.39),('8784','2013-08-25','08:45:00',1.5),('8784','2013-08-25','09:15:00',1.15),('8784','2013-08-25','09:20:00',2.36),('8784','2013-08-25','09:25:00',2.37),('8784','2013-08-25','09:30:00',2.02),('8784','2013-08-25','09:35:00',1.05),('8784','2013-08-25','09:40:00',2.71),('8784','2013-08-25','09:45:00',2.25),('8784','2013-08-25','09:50:00',3.15),('8784','2013-08-25','09:55:00',2.97),('8784','2013-08-25','10:00:00',2.46),('8784','2013-08-25','10:05:00',1.57),('8784','2013-08-25','15:05:00',1.04),('8784','2013-08-25','15:10:00',1.14),('8784','2013-08-25','15:15:00',1.32),('8784','2013-08-25','15:20:00',1.55),('8784','2013-08-25','15:25:00',1.65),('8784','2013-08-25','15:30:00',2.2),('8784','2013-08-25','15:35:00',3.37),('8784','2013-08-25','15:40:00',3.42),('8784','2013-08-25','15:45:00',3.71),('8784','2013-08-25','15:50:00',2.27),('8784','2013-08-25','15:55:00',2.72),('8784','2013-08-25','16:00:00',3.41),('8784','2013-08-25','16:05:00',3.2),('8784','2013-08-25','16:10:00',3),('8784','2013-08-25','16:15:00',2.92),('8784','2013-08-25','16:20:00',2.84),('8784','2013-08-25','16:25:00',2.8),('8784','2013-08-25','16:30:00',2.72),('8784','2013-08-25','16:35:00',2.6),('8784','2013-08-25','16:40:00',1.83),('8784','2013-08-25','16:45:00',1.24),('8784','2013-08-25','16:50:00',1.92),('8784','2013-08-25','17:40:00',1.37),('8784','2013-08-25','17:45:00',1.45),('8784','2013-08-25','17:50:00',1.3),('8784','2013-08-25','17:55:00',1.13),('8784','2013-08-24','08:10:00',1.05),('8784','2013-08-24','08:20:00',1.09),('8784','2013-08-24','08:25:00',1.34),('8784','2013-08-24','08:30:00',1.41),('8784','2013-08-24','08:35:00',1.55),('8784','2013-08-24','08:40:00',1.68),('8784','2013-08-24','08:45:00',1.75),('8784','2013-08-24','08:50:00',1.77),('8784','2013-08-24','08:55:00',1.96),('8784','2013-08-24','09:00:00',2.07),('8784','2013-08-24','09:05:00',2.18),('8784','2013-08-24','09:10:00',2.1),('8784','2013-08-24','09:15:00',2.21),('8784','2013-08-24','09:20:00',1.28),('8784','2013-08-24','09:25:00',2.12),('8784','2013-08-24','09:30:00',2.5),('8784','2013-08-24','09:35:00',2.61),('8784','2013-08-24','09:40:00',2.06),('8784','2013-08-24','09:45:00',2.58),('8784','2013-08-24','09:50:00',2.41),('8784','2013-08-24','09:55:00',2.08),('8784','2013-08-24','10:00:00',2.9),('8784','2013-08-24','10:05:00',2.93),('8784','2013-08-24','10:10:00',2.98),('8784','2013-08-24','10:15:00',3.03),('8784','2013-08-24','10:20:00',3.09),('8784','2013-08-24','10:25:00',3.13),('8784','2013-08-24','10:30:00',3.16),('8784','2013-08-24','10:35:00',3.26),('8784','2013-08-24','10:40:00',3.27),('8784','2013-08-24','10:45:00',2.86),('8784','2013-08-24','10:50:00',2.41),('8784','2013-08-24','10:55:00',3.53),('8784','2013-08-24','11:00:00',3.49),('8784','2013-08-24','11:05:00',3.59),('8784','2013-08-24','11:10:00',3.59),('8784','2013-08-24','11:15:00',3.54),('8784','2013-08-24','11:20:00',3.6),('8784','2013-08-24','11:25:00',3.64),('8784','2013-08-24','11:30:00',3.68),('8784','2013-08-24','11:35:00',3.71),('8784','2013-08-24','11:40:00',3.76),('8784','2013-08-24','11:45:00',3.78),('8784','2013-08-24','11:50:00',3.76),('8784','2013-08-24','11:55:00',3.79),('8784','2013-08-24','12:00:00',3.81),('8784','2013-08-24','12:05:00',3.84),('8784','2013-08-24','12:10:00',3.91),('8784','2013-08-24','12:15:00',3.87),('8784','2013-08-24','12:20:00',3.94),('8784','2013-08-24','12:25:00',3.9),('8784','2013-08-24','12:30:00',3.91),('8784','2013-08-24','12:35:00',3.93),('8784','2013-08-24','12:40:00',3.92),('8784','2013-08-24','12:45:00',3.91),('8784','2013-08-24','12:50:00',3.94),('8784','2013-08-24','12:55:00',3.87),('8784','2013-08-24','13:00:00',3.89),('8784','2013-08-24','13:05:00',3.96),('8784','2013-08-24','13:10:00',3.95),('8784','2013-08-24','13:15:00',3.94),('8784','2013-08-24','13:20:00',4.02),('8784','2013-08-24','13:25:00',3.96),('8784','2013-08-24','13:30:00',3.99),('8784','2013-08-24','13:35:00',3.99),('8784','2013-08-24','13:40:00',3.98),('8784','2013-08-24','13:45:00',3.95),('8784','2013-08-24','13:50:00',3.92),('8784','2013-08-24','13:55:00',3.93),('8784','2013-08-24','14:00:00',3.89),('8784','2013-08-24','14:05:00',3.91),('8784','2013-08-24','14:10:00',3.87),('8784','2013-08-24','14:15:00',3.86),('8784','2013-08-24','14:20:00',3.84),('8784','2013-08-24','14:25:00',3.8),('8784','2013-08-24','14:30:00',3.8),('8784','2013-08-24','14:35:00',3.72),('8784','2013-08-24','14:40:00',3.69),('8784','2013-08-24','14:45:00',3.65),('8784','2013-08-24','14:50:00',3.63),('8784','2013-08-24','14:55:00',3.55),('8784','2013-08-24','15:00:00',3.54),('8784','2013-08-24','15:05:00',3.54),('8784','2013-08-24','15:10:00',3.43),('8784','2013-08-24','15:15:00',3.4),('8784','2013-08-24','15:20:00',3.36),('8784','2013-08-24','15:25:00',3.32),('8784','2013-08-24','15:30:00',3.27),('8784','2013-08-24','15:35:00',3.23),('8784','2013-08-24','15:40:00',3.17),('8784','2013-08-24','15:45:00',3.09),('8784','2013-08-24','15:50:00',3.04),('8784','2013-08-24','15:55:00',3.01),('8784','2013-08-24','16:00:00',2.96),('8784','2013-08-24','16:05:00',2.9),('8784','2013-08-24','16:10:00',2.84),('8784','2013-08-24','16:15:00',2.82),('8784','2013-08-24','16:20:00',2.77),('8784','2013-08-24','16:25:00',2.7),('8784','2013-08-24','16:30:00',2.61),('8784','2013-08-24','16:35:00',2.52),('8784','2013-08-24','16:40:00',2.47),('8784','2013-08-24','16:45:00',2.37),('8784','2013-08-24','16:50:00',2.32),('8784','2013-08-24','16:55:00',2.25),('8784','2013-08-24','17:00:00',2.18),('8784','2013-08-24','17:05:00',2.11),('8784','2013-08-24','17:10:00',2.04),('8784','2013-08-24','17:15:00',1.97),('8784','2013-08-24','17:20:00',1.88),('8784','2013-08-24','17:25:00',1.8),('8784','2013-08-24','17:30:00',1.72),('8784','2013-08-24','17:35:00',1.63),('8784','2013-08-24','17:40:00',1.55),('8784','2013-08-24','17:45:00',1.48),('8784','2013-08-24','17:50:00',1.39),('8784','2013-08-24','17:55:00',1.31),('8784','2013-08-24','18:00:00',1.22),('8784','2013-08-24','18:05:00',1.15),('8784','2013-08-24','18:10:00',1.06),('8784','2013-08-23','08:10:00',1.06),('8784','2013-08-23','08:15:00',1.16),('8784','2013-08-23','08:20:00',1.22),('8784','2013-08-23','08:25:00',1.29),('8784','2013-08-23','08:30:00',1.37),('8784','2013-08-23','08:35:00',1.41),('8784','2013-08-23','08:40:00',1.49),('8784','2013-08-23','08:45:00',1.6),('8784','2013-08-23','08:50:00',1.65),('8784','2013-08-23','08:55:00',1.74),('8784','2013-08-23','09:00:00',1.79),('8784','2013-08-23','09:05:00',1.87),('8784','2013-08-23','09:10:00',1.94),('8784','2013-08-23','09:15:00',2.04),('8784','2013-08-23','09:20:00',2.14),('8784','2013-08-23','09:25:00',2.19),('8784','2013-08-23','09:30:00',2.24),('8784','2013-08-23','09:35:00',2.31),('8784','2013-08-23','09:40:00',2.34),('8784','2013-08-23','09:45:00',2.45),('8784','2013-08-23','09:50:00',2.48),('8784','2013-08-23','09:55:00',2.55),('8784','2013-08-23','10:00:00',2.6),('8784','2013-08-23','10:05:00',2.66),('8784','2013-08-23','10:10:00',2.71),('8784','2013-08-23','10:15:00',2.78),('8784','2013-08-23','10:20:00',2.81),('8784','2013-08-23','10:25:00',2.9),('8784','2013-08-23','10:30:00',2.95),('8784','2013-08-23','10:35:00',2.92),('8784','2013-08-23','10:40:00',3),('8784','2013-08-23','10:45:00',2.99),('8784','2013-08-23','10:50:00',3.16),('8784','2013-08-23','10:55:00',3.17),('8784','2013-08-23','11:00:00',3.12),('8784','2013-08-23','11:05:00',2.88),('8784','2013-08-23','11:10:00',1.2),('8784','2013-08-23','11:15:00',1.25),('8784','2013-08-23','11:20:00',1.49),('8784','2013-08-23','11:25:00',1.58),('8784','2013-08-23','11:30:00',2.84),('8784','2013-08-23','11:35:00',3.64),('8784','2013-08-23','11:40:00',3.68),('8784','2013-08-23','11:45:00',3.7),('8784','2013-08-23','11:50:00',3.82),('8784','2013-08-23','11:55:00',1.96),('8784','2013-08-23','12:00:00',1.85),('8784','2013-08-23','12:05:00',3.4),('8784','2013-08-23','12:10:00',3.91),('8784','2013-08-23','12:15:00',1.09),('8784','2013-08-23','12:20:00',1),('8784','2013-08-23','12:25:00',1.05),('8784','2013-08-23','12:30:00',1.59),('8784','2013-08-23','12:35:00',1.87),('8784','2013-08-23','12:40:00',1.33),('8784','2013-08-23','12:45:00',1.53),('8784','2013-08-23','12:50:00',2.11),('8784','2013-08-23','12:55:00',1.03),('8784','2013-08-23','13:00:00',1.59),('8784','2013-08-23','13:05:00',2.58),('8784','2013-08-23','13:10:00',1.38),('8784','2013-08-23','13:15:00',2.74),('8784','2013-08-23','13:20:00',3.66),('8784','2013-08-23','13:25:00',4.32),('8784','2013-08-23','13:30:00',4.22),('8784','2013-08-23','13:35:00',2.8),('8784','2013-08-23','13:40:00',3.83),('8784','2013-08-23','13:45:00',3.11),('8784','2013-08-23','13:50:00',2.47),('8784','2013-08-23','13:55:00',4.31),('8784','2013-08-23','14:00:00',4.22),('8784','2013-08-23','14:05:00',4.09),('8784','2013-08-23','14:10:00',3.99),('8784','2013-08-23','14:15:00',3.91),('8784','2013-08-23','14:20:00',3.84),('8784','2013-08-23','14:25:00',3.78),('8784','2013-08-23','14:30:00',3.43),('8784','2013-08-23','14:35:00',3.75),('8784','2013-08-23','14:40:00',3.69),('8784','2013-08-23','14:45:00',3.71),('8784','2013-08-23','14:50:00',3.58),('8784','2013-08-23','14:55:00',3.4),('8784','2013-08-23','15:00:00',3.41),('8784','2013-08-23','15:05:00',3.28),('8784','2013-08-23','15:10:00',3.49),('8784','2013-08-23','15:15:00',3.34),('8784','2013-08-23','15:20:00',3.33),('8784','2013-08-23','15:25:00',3.37),('8784','2013-08-23','15:30:00',3.45),('8784','2013-08-23','15:35:00',3.16),('8784','2013-08-23','15:40:00',3.12),('8784','2013-08-23','15:45:00',3.11),('8784','2013-08-23','15:50:00',2.83),('8784','2013-08-23','15:55:00',3.06),('8784','2013-08-23','16:00:00',2.91),('8784','2013-08-23','16:05:00',2.76),('8784','2013-08-23','16:10:00',2.52),('8784','2013-08-23','16:15:00',2.68),('8784','2013-08-23','16:20:00',2.88),('8784','2013-08-23','16:25:00',2.8),('8784','2013-08-23','16:30:00',2.71),('8784','2013-08-23','16:35:00',2.67),('8784','2013-08-23','16:40:00',2.59),('8784','2013-08-23','16:45:00',2.55),('8784','2013-08-23','16:50:00',2.43),('8784','2013-08-23','16:55:00',2.33),('8784','2013-08-23','17:00:00',2.23),('8784','2013-08-23','17:05:00',2.12),('8784','2013-08-23','17:10:00',2.03),('8784','2013-08-23','17:15:00',1.94),('8784','2013-08-23','17:20:00',1.86),('8784','2013-08-23','17:25:00',1.77),('8784','2013-08-23','17:30:00',1.67),('8784','2013-08-23','17:35:00',1.6),('8784','2013-08-23','17:40:00',1.5),('8784','2013-08-23','17:45:00',1.44),('8784','2013-08-23','17:50:00',1.37),('8784','2013-08-23','17:55:00',1.3),('8784','2013-08-23','18:00:00',1.2),('8784','2013-08-23','18:05:00',1.11),('8784','2013-08-22','08:05:00',1.03),('8784','2013-08-22','08:10:00',1.15),('8784','2013-08-22','08:15:00',1.21),('8784','2013-08-22','08:20:00',1.28),('8784','2013-08-22','08:25:00',1.35),('8784','2013-08-22','08:30:00',1.43),('8784','2013-08-22','08:35:00',1.52),('8784','2013-08-22','08:40:00',1.61),('8784','2013-08-22','08:45:00',1.72),('8784','2013-08-22','08:50:00',1.79),('8784','2013-08-22','08:55:00',1.9),('8784','2013-08-22','09:00:00',1.91),('8784','2013-08-22','09:05:00',2.08),('8784','2013-08-22','09:10:00',2.2),('8784','2013-08-22','09:15:00',2.32),('8784','2013-08-22','09:20:00',2.46),('8784','2013-08-22','09:25:00',2.57),('8784','2013-08-22','09:30:00',2.64),('8784','2013-08-22','09:35:00',1.69),('8784','2013-08-22','09:40:00',1.75),('8784','2013-08-22','09:45:00',2.51),('8784','2013-08-22','09:50:00',2.8),('8784','2013-08-22','09:55:00',2.38),('8784','2013-08-22','10:00:00',3.03),('8784','2013-08-22','10:05:00',3.05),('8784','2013-08-22','10:10:00',3.07),('8784','2013-08-22','10:15:00',3.05),('8784','2013-08-22','10:20:00',3.05),('8784','2013-08-22','10:25:00',3.1),('8784','2013-08-22','10:30:00',3.18),('8784','2013-08-22','10:35:00',3.21),('8784','2013-08-22','10:40:00',3.25),('8784','2013-08-22','10:45:00',3.27),('8784','2013-08-22','10:50:00',3.32),('8784','2013-08-22','10:55:00',3.37),('8784','2013-08-22','11:00:00',3.42),('8784','2013-08-22','11:05:00',3.44),('8784','2013-08-22','11:10:00',3.47),('8784','2013-08-22','11:15:00',3.48),('8784','2013-08-22','11:20:00',3.51),('8784','2013-08-22','11:25:00',3.55),('8784','2013-08-22','11:30:00',3.59),('8784','2013-08-22','11:35:00',3.63),('8784','2013-08-22','11:40:00',3.62),('8784','2013-08-22','11:45:00',3.69),('8784','2013-08-22','11:50:00',3.69),('8784','2013-08-22','11:55:00',3.73),('8784','2013-08-22','12:00:00',3.75),('8784','2013-08-22','12:05:00',3.78),('8784','2013-08-22','12:10:00',3.75),('8784','2013-08-22','12:15:00',3.78),('8784','2013-08-22','12:20:00',3.81),('8784','2013-08-22','12:25:00',3.8),('8784','2013-08-22','12:30:00',3.79),('8784','2013-08-22','12:35:00',3.79),('8784','2013-08-22','12:40:00',3.8),('8784','2013-08-22','12:45:00',3.83),('8784','2013-08-22','12:50:00',3.83),('8784','2013-08-22','12:55:00',3.83),('8784','2013-08-22','13:00:00',3.82),('8784','2013-08-22','13:05:00',3.78),('8784','2013-08-22','13:10:00',3.72),('8784','2013-08-22','13:15:00',3.73),('8784','2013-08-22','13:20:00',3.74),('8784','2013-08-22','13:25:00',3.77),('8784','2013-08-22','13:30:00',3.8),('8784','2013-08-22','13:35:00',3.77),('8784','2013-08-22','13:40:00',3.73),('8784','2013-08-22','13:45:00',3.77),('8784','2013-08-22','13:50:00',3.78),('8784','2013-08-22','13:55:00',3.71),('8784','2013-08-22','14:00:00',3.72),('8784','2013-08-22','14:05:00',3.72),('8784','2013-08-22','14:10:00',3.69),('8784','2013-08-22','14:15:00',3.69),('8784','2013-08-22','14:20:00',3.69),('8784','2013-08-22','14:25:00',3.7),('8784','2013-08-22','14:30:00',3.38),('8784','2013-08-22','14:35:00',3.68),('8784','2013-08-22','14:40:00',3.66),('8784','2013-08-22','14:45:00',3.58),('8784','2013-08-22','14:50:00',3.57),('8784','2013-08-22','14:55:00',3.54),('8784','2013-08-22','15:00:00',3.49),('8784','2013-08-22','15:05:00',3.4),('8784','2013-08-22','15:10:00',3.4),('8784','2013-08-22','15:15:00',3.28),('8784','2013-08-22','15:20:00',3.29),('8784','2013-08-22','15:25:00',3.24),('8784','2013-08-22','15:30:00',3.16),('8784','2013-08-22','15:35:00',3.09),('8784','2013-08-22','15:40:00',3.07),('8784','2013-08-22','15:45:00',3.05),('8784','2013-08-22','15:50:00',3.02),('8784','2013-08-22','15:55:00',2.92),('8784','2013-08-22','16:00:00',2.83),('8784','2013-08-22','16:05:00',2.76),('8784','2013-08-22','16:10:00',2.7),('8784','2013-08-22','16:15:00',2.71),('8784','2013-08-22','16:20:00',2.62),('8784','2013-08-22','16:25:00',2.57),('8784','2013-08-22','16:30:00',2.5),('8784','2013-08-22','16:35:00',2.42),('8784','2013-08-22','16:40:00',2.37),('8784','2013-08-22','16:45:00',2.31),('8784','2013-08-22','16:50:00',2.22),('8784','2013-08-22','16:55:00',2.16),('8784','2013-08-22','17:00:00',2.1),('8784','2013-08-22','17:05:00',2),('8784','2013-08-22','17:10:00',1.93),('8784','2013-08-22','17:15:00',1.85),('8784','2013-08-22','17:20:00',1.77),('8784','2013-08-22','17:25:00',1.7),('8784','2013-08-22','17:30:00',1.62),('8784','2013-08-22','17:35:00',1.56),('8784','2013-08-22','17:40:00',1.48),('8784','2013-08-22','17:45:00',1.39),('8784','2013-08-22','17:50:00',1.3),('8784','2013-08-22','17:55:00',1.25),('8784','2013-08-22','18:00:00',1.19),('8784','2013-08-22','18:05:00',1.12),('8784','2013-08-22','18:10:00',1.09),('8784','2013-08-22','18:15:00',1.1),('8784','2013-08-21','09:05:00',1.46),('8784','2013-08-21','09:10:00',1.45),('8784','2013-08-21','09:15:00',2.59),('8784','2013-08-21','09:20:00',2.54),('8784','2013-08-21','09:25:00',1.27),('8784','2013-08-21','09:40:00',1.08),('8784','2013-08-21','09:45:00',1.33),('8784','2013-08-21','09:50:00',2.64),('8784','2013-08-21','09:55:00',3.66),('8784','2013-08-21','10:00:00',3.39),('8784','2013-08-21','10:05:00',2.67),('8784','2013-08-21','10:10:00',2.41),('8784','2013-08-21','10:15:00',2.17),('8784','2013-08-21','10:20:00',2.27),('8784','2013-08-21','10:25:00',1.76),('8784','2013-08-21','10:30:00',2.57),('8784','2013-08-21','10:35:00',3.11),('8784','2013-08-21','10:40:00',2.08),('8784','2013-08-21','10:45:00',2.22),('8784','2013-08-21','10:50:00',2.16),('8784','2013-08-21','10:55:00',1.83),('8784','2013-08-21','11:00:00',2.63),('8784','2013-08-21','11:05:00',2),('8784','2013-08-21','11:10:00',1.83),('8784','2013-08-21','11:15:00',2.21),('8784','2013-08-21','11:20:00',2.9),('8784','2013-08-21','11:25:00',2.57),('8784','2013-08-21','11:30:00',3.23),('8784','2013-08-21','11:35:00',4.41),('8784','2013-08-21','11:40:00',4.14),('8784','2013-08-21','11:45:00',4.1),('8784','2013-08-21','11:50:00',3.8),('8784','2013-08-21','11:55:00',3.77),('8784','2013-08-21','12:00:00',4.06),('8784','2013-08-21','12:05:00',4.03),('8784','2013-08-21','12:10:00',4.02),('8784','2013-08-21','12:15:00',4.06),('8784','2013-08-21','12:20:00',3.95),('8784','2013-08-21','12:25:00',2.69),('8784','2013-08-21','12:30:00',2.49),('8784','2013-08-21','12:35:00',2.03),('8784','2013-08-21','12:40:00',3.73),('8784','2013-08-21','12:45:00',3.94),('8784','2013-08-21','12:50:00',3.77),('8784','2013-08-21','12:55:00',3.72),('8784','2013-08-21','13:00:00',3.88),('8784','2013-08-21','13:05:00',3.92),('8784','2013-08-21','13:10:00',3.96),('8784','2013-08-21','13:15:00',4.02),('8784','2013-08-21','13:20:00',4.05),('8784','2013-08-21','13:25:00',4.04),('8784','2013-08-21','13:30:00',3.94),('8784','2013-08-21','13:35:00',3.9),('8784','2013-08-21','13:40:00',3.84),('8784','2013-08-21','13:45:00',3.97),('8784','2013-08-21','13:50:00',3.85),('8784','2013-08-21','13:55:00',3.68),('8784','2013-08-21','14:00:00',3.53),('8784','2013-08-21','14:05:00',3.69),('8784','2013-08-21','14:10:00',3.85),('8784','2013-08-21','14:15:00',2.81),('8784','2013-08-21','14:20:00',1.58),('8784','2013-08-21','14:25:00',2.01),('8784','2013-08-21','14:30:00',3.38),('8784','2013-08-21','14:35:00',3.46),('8784','2013-08-21','14:40:00',3.46),('8784','2013-08-21','14:45:00',3.38),('8784','2013-08-21','14:50:00',3.26),('8784','2013-08-21','14:55:00',3.34),('8784','2013-08-21','15:00:00',3.44),('8784','2013-08-21','15:05:00',3.4),('8784','2013-08-21','15:10:00',3.31),('8784','2013-08-21','15:15:00',3.25),('8784','2013-08-21','15:20:00',3.18),('8784','2013-08-21','15:25:00',3),('8784','2013-08-21','15:30:00',2.97),('8784','2013-08-21','15:35:00',2.83),('8784','2013-08-21','15:40:00',2.66),('8784','2013-08-21','15:45:00',2.67),('8784','2013-08-21','15:50:00',2.7),('8784','2013-08-21','15:55:00',2.71),('8784','2013-08-21','16:00:00',2.54),('8784','2013-08-21','16:05:00',2.4),('8784','2013-08-21','16:10:00',2.37),('8784','2013-08-21','16:15:00',2.39),('8784','2013-08-21','16:20:00',2.54),('8784','2013-08-21','16:25:00',2.52),('8784','2013-08-21','16:30:00',2.68),('8784','2013-08-21','16:35:00',2.64),('8784','2013-08-21','16:40:00',2.53),('8784','2013-08-21','16:45:00',2.44),('8784','2013-08-21','16:50:00',2.37),('8784','2013-08-21','16:55:00',2.3),('8784','2013-08-21','17:00:00',2.24),('8784','2013-08-21','17:05:00',2.16),('8784','2013-08-21','17:10:00',2.12),('8784','2013-08-21','17:15:00',2.08),('8784','2013-08-21','17:20:00',2.06),('8784','2013-08-21','17:25:00',1.99),('8784','2013-08-21','17:30:00',1.89),('8784','2013-08-21','17:35:00',1.83),('8784','2013-08-21','17:40:00',1.77),('8784','2013-08-21','17:45:00',1.7),('8784','2013-08-21','17:50:00',1.66),('8784','2013-08-21','17:55:00',1.59),('8784','2013-08-21','18:00:00',1.5),('8784','2013-08-21','18:05:00',1.38),('8784','2013-08-21','18:10:00',1.27),('8784','2013-08-21','18:15:00',1.2),('8784','2013-08-21','18:20:00',1.09),('8784','2013-08-20','07:55:00',1.15),('8784','2013-08-20','08:00:00',1.01),('8784','2013-08-20','08:50:00',1.01),('8784','2013-08-20','08:55:00',1.17),('8784','2013-08-20','09:00:00',1.05),('8784','2013-08-20','09:05:00',1.02),('8784','2013-08-20','09:20:00',1.27),('8784','2013-08-20','09:25:00',2.03),('8784','2013-08-20','09:30:00',2.62),('8784','2013-08-20','09:35:00',2.98),('8784','2013-08-20','09:40:00',2.87),('8784','2013-08-20','09:45:00',2.28),('8784','2013-08-20','09:50:00',2.11),('8784','2013-08-20','09:55:00',3.23),('8784','2013-08-20','10:00:00',2.18),('8784','2013-08-20','10:05:00',1.66),('8784','2013-08-20','10:10:00',1.58),('8784','2013-08-20','10:15:00',2.93),('8784','2013-08-20','10:20:00',1.63),('8784','2013-08-20','10:25:00',1.06),('8784','2013-08-20','10:30:00',1.1),('8784','2013-08-20','10:35:00',1.09),('8784','2013-08-20','10:40:00',1.57),('8784','2013-08-20','10:45:00',3.34),('8784','2013-08-20','10:50:00',3.54),('8784','2013-08-20','10:55:00',1.63),('8784','2013-08-20','11:00:00',1.03),('8784','2013-08-20','11:10:00',2.35),('8784','2013-08-20','11:15:00',4.01),('8784','2013-08-20','11:20:00',4.01),('8784','2013-08-20','11:25:00',2.94),('8784','2013-08-20','11:30:00',1.79),('8784','2013-08-20','11:35:00',4.06),('8784','2013-08-20','11:40:00',4.22),('8784','2013-08-20','11:45:00',4.3),('8784','2013-08-20','11:50:00',4.64),('8784','2013-08-20','11:55:00',3.11),('8784','2013-08-20','12:00:00',2.27),('8784','2013-08-20','12:05:00',1.9),('8784','2013-08-20','12:10:00',1.48),('8784','2013-08-20','12:25:00',1.24),('8784','2013-08-20','12:30:00',1.61),('8784','2013-08-20','12:35:00',1.79),('8784','2013-08-20','12:40:00',1.9),('8784','2013-08-20','12:45:00',1.84),('8784','2013-08-20','12:50:00',1.85),('8784','2013-08-20','12:55:00',1.97),('8784','2013-08-20','13:00:00',1.95),('8784','2013-08-20','13:05:00',1.79),('8784','2013-08-20','13:10:00',1.75),('8784','2013-08-20','13:15:00',1.77),('8784','2013-08-20','13:20:00',1.8),('8784','2013-08-20','13:25:00',1.9),('8784','2013-08-20','13:30:00',2.1),('8784','2013-08-20','13:35:00',2.82),('8784','2013-08-20','13:40:00',4.45),('8784','2013-08-20','13:45:00',3.53),('8784','2013-08-20','13:50:00',4.35),('8784','2013-08-20','13:55:00',4.18),('8784','2013-08-20','14:00:00',4.14),('8784','2013-08-20','14:05:00',4.06),('8784','2013-08-20','14:10:00',3.42),('8784','2013-08-20','14:15:00',4.02),('8784','2013-08-20','14:20:00',4.02),('8784','2013-08-20','14:25:00',3.43),('8784','2013-08-20','14:30:00',3.75),('8784','2013-08-20','14:35:00',4.26),('8784','2013-08-20','14:40:00',4.08),('8784','2013-08-20','14:45:00',3.81),('8784','2013-08-20','14:50:00',3.95),('8784','2013-08-20','14:55:00',3.83),('8784','2013-08-20','15:00:00',3.69),('8784','2013-08-20','15:05:00',4),('8784','2013-08-20','15:10:00',3.89),('8784','2013-08-20','15:15:00',3.86),('8784','2013-08-20','15:20:00',3.74),('8784','2013-08-20','15:25:00',3.73),('8784','2013-08-20','15:30:00',3.74),('8784','2013-08-20','15:35:00',3.69),('8784','2013-08-20','15:40:00',3.78),('8784','2013-08-20','15:45:00',3.89),('8784','2013-08-20','15:50:00',4.04),('8784','2013-08-20','15:55:00',4.09),('8784','2013-08-20','16:00:00',3.87),('8784','2013-08-20','16:05:00',3.76),('8784','2013-08-20','16:10:00',3.69),('8784','2013-08-20','16:15:00',3.64),('8784','2013-08-20','16:20:00',3.6),('8784','2013-08-20','16:25:00',3.51),('8784','2013-08-20','16:30:00',3.26),('8784','2013-08-20','16:35:00',3.24),('8784','2013-08-20','16:40:00',3.25),('8784','2013-08-20','16:45:00',3.11),('8784','2013-08-20','16:50:00',2.93),('8784','2013-08-20','16:55:00',2.7),('8784','2013-08-20','17:00:00',2.51),('8784','2013-08-20','17:05:00',2.36),('8784','2013-08-20','17:10:00',2.27),('8784','2013-08-20','17:15:00',2.14),('8784','2013-08-20','17:20:00',2.07),('8784','2013-08-20','17:25:00',1.98),('8784','2013-08-20','17:30:00',1.92),('8784','2013-08-20','17:35:00',1.85),('8784','2013-08-20','17:40:00',1.77),('8784','2013-08-20','17:45:00',1.65),('8784','2013-08-20','17:50:00',1.5),('8784','2013-08-20','17:55:00',1.38),('8784','2013-08-20','18:00:00',1.25),('8784','2013-08-20','18:05:00',1.22),('8784','2013-08-20','18:10:00',1.26),('8784','2013-08-20','18:15:00',1.25),('8784','2013-08-20','18:20:00',1.19),('8784','2013-08-20','18:25:00',1.14),('8784','2013-08-20','18:30:00',1.15),('8784','2013-08-20','18:35:00',1.03),('8784','2014-04-10','07:55:00',1),('8784','2014-04-10','08:00:00',1.08),('8784','2014-04-10','08:05:00',1.18),('8784','2014-04-10','08:10:00',1.27),('8784','2014-04-10','08:15:00',1.36),('8784','2014-04-10','08:20:00',1.46),('8784','2014-04-10','08:25:00',1.55),('8784','2014-04-10','08:30:00',1.65),('8784','2014-04-10','08:35:00',1.76),('8784','2014-04-10','08:40:00',1.86),('8784','2014-04-10','08:45:00',1.96),('8784','2014-04-10','08:50:00',2.05),('8784','2014-04-10','08:55:00',2.13),('8784','2014-04-10','09:00:00',2.18),('8784','2014-04-10','09:05:00',2.32),('8784','2014-04-10','09:10:00',2.38),('8784','2014-04-10','09:15:00',2.42),('8784','2014-04-10','09:20:00',2.45),('8784','2014-04-10','09:25:00',2.6),('8784','2014-04-10','09:30:00',2.72),('8784','2014-04-10','09:35:00',2.8),('8784','2014-04-10','09:40:00',2.86),('8784','2014-04-10','09:45:00',2.92),('8784','2014-04-10','09:50:00',3.01),('8784','2014-04-10','09:55:00',3.1),('8784','2014-04-10','10:00:00',3.15),('8784','2014-04-10','10:05:00',3.2),('8784','2014-04-10','10:10:00',3.3),('8784','2014-04-10','10:15:00',3.3),('8784','2014-04-10','10:20:00',3.38),('8784','2014-04-10','10:25:00',3.44),('8784','2014-04-10','10:30:00',3.46),('8784','2014-04-10','10:35:00',3.59),('8784','2014-04-10','10:40:00',3.66),('8784','2014-04-10','10:45:00',3.67),('8784','2014-04-10','10:50:00',3.57),('8784','2014-04-10','10:55:00',3.69),('8784','2014-04-10','11:00:00',3.73),('8784','2014-04-10','11:05:00',3.87),('8784','2014-04-10','11:10:00',3.79),('8784','2014-04-10','11:15:00',3.95),('8784','2014-04-10','11:20:00',4.05),('8784','2014-04-10','11:25:00',4.11),('8784','2014-04-10','11:30:00',4.12),('8784','2014-04-10','11:35:00',4.19),('8784','2014-04-10','11:40:00',4.04),('8784','2014-04-10','11:45:00',4.17),('8784','2014-04-10','11:50:00',4.03),('8784','2014-04-10','11:55:00',4.23),('8784','2014-04-10','12:00:00',4.14),('8784','2014-04-10','12:05:00',3.93),('8784','2014-04-10','12:10:00',4.08),('8784','2014-04-10','12:15:00',4.16),('8784','2014-04-10','12:20:00',4.21),('8784','2014-04-10','12:25:00',3.99),('8784','2014-04-10','12:30:00',4.07),('8784','2014-04-10','12:35:00',4.31),('8784','2014-04-10','12:40:00',4.15),('8784','2014-04-10','12:45:00',4.26),('8784','2014-04-10','12:50:00',4.22),('8784','2014-04-10','12:55:00',4.18),('8784','2014-04-10','13:00:00',4.11),('8784','2014-04-10','13:05:00',3.95),('8784','2014-04-10','13:10:00',4.1),('8784','2014-04-10','13:15:00',4.06),('8784','2014-04-10','13:20:00',3.95),('8784','2014-04-10','13:25:00',4.27),('8784','2014-04-10','13:30:00',4.24),('8784','2014-04-10','13:35:00',4.31),('8784','2014-04-10','13:40:00',4.05),('8784','2014-04-10','13:45:00',4.3),('8784','2014-04-10','13:50:00',4.29),('8784','2014-04-10','13:55:00',4.25),('8784','2014-04-10','14:00:00',4.21),('8784','2014-04-10','14:05:00',4.13),('8784','2014-04-10','14:10:00',4.12),('8784','2014-04-10','14:15:00',4.11),('8784','2014-04-10','14:20:00',4.14),('8784','2014-04-10','14:25:00',4.08),('8784','2014-04-10','14:30:00',4.04),('8784','2014-04-10','14:35:00',4.01),('8784','2014-04-10','14:40:00',3.96),('8784','2014-04-10','14:45:00',3.56),('8784','2014-04-10','14:50:00',3.98),('8784','2014-04-10','14:55:00',3.91),('8784','2014-04-10','15:00:00',3.88),('8784','2014-04-10','15:05:00',3.83),('8784','2014-04-10','15:10:00',3.7),('8784','2014-04-10','15:15:00',3.71),('8784','2014-04-10','15:20:00',3.67),('8784','2014-04-10','15:25:00',3.6),('8784','2014-04-10','15:30:00',3.31),('8784','2014-04-10','15:35:00',3.13),('8784','2014-04-10','15:40:00',3.2),('8784','2014-04-10','15:45:00',3.23),('8784','2014-04-10','15:50:00',3.23),('8784','2014-04-10','15:55:00',3.18),('8784','2014-04-10','16:00:00',3.1),('8784','2014-04-10','16:05:00',3.14),('8784','2014-04-10','16:10:00',3.15),('8784','2014-04-10','16:15:00',3.19),('8784','2014-04-10','16:20:00',3.05),('8784','2014-04-10','16:25:00',3.01),('8784','2014-04-10','16:30:00',2.97),('8784','2014-04-10','16:35:00',2.83),('8784','2014-04-10','16:40:00',2.79),('8784','2014-04-10','16:45:00',2.77),('8784','2014-04-10','16:50:00',2.57),('8784','2014-04-10','16:55:00',2.51),('8784','2014-04-10','17:00:00',2.4),('8784','2014-04-10','17:05:00',2.32),('8784','2014-04-10','17:10:00',2.2),('8784','2014-04-10','17:15:00',2.07),('8784','2014-04-10','17:20:00',2.01),('8784','2014-04-10','17:25:00',1.9),('8784','2014-04-10','17:30:00',1.79),('8784','2014-04-10','17:35:00',1.69),('8784','2014-04-10','17:40:00',1.58),('8784','2014-04-10','17:45:00',1.49),('8784','2014-04-10','17:50:00',1.39),('8784','2014-04-10','17:55:00',1.3),('8784','2014-04-10','18:00:00',1.21),('8784','2014-04-10','18:05:00',1.12),('8784','2014-04-10','18:10:00',1.03),('8784','2013-08-19','07:55:00',1.01),('8784','2013-08-19','08:00:00',1.08),('8784','2013-08-19','08:05:00',1.17),('8784','2013-08-19','08:10:00',1.24),('8784','2013-08-19','08:15:00',1.32),('8784','2013-08-19','08:20:00',1.32),('8784','2013-08-19','08:25:00',1.41),('8784','2013-08-19','08:30:00',1.48),('8784','2013-08-19','08:35:00',1.59),('8784','2013-08-19','08:40:00',1.68),('8784','2013-08-19','08:45:00',1.78),('8784','2013-08-19','08:50:00',1.88),('8784','2013-08-19','08:55:00',1.97),('8784','2013-08-19','09:00:00',2.05),('8784','2013-08-19','09:05:00',2.11),('8784','2013-08-19','09:10:00',2.16),('8784','2013-08-19','09:15:00',2.27),('8784','2013-08-19','09:20:00',2.35),('8784','2013-08-19','09:25:00',2.46),('8784','2013-08-19','09:30:00',2.53),('8784','2013-08-19','09:35:00',2.57),('8784','2013-08-19','09:40:00',2.61),('8784','2013-08-19','09:45:00',2.7),('8784','2013-08-19','09:50:00',2.79),('8784','2013-08-19','09:55:00',2.84),('8784','2013-08-19','10:00:00',2.9),('8784','2013-08-19','10:05:00',2.95),('8784','2013-08-19','10:10:00',3),('8784','2013-08-19','10:15:00',3.07),('8784','2013-08-19','10:20:00',3.1),('8784','2013-08-19','10:25:00',3.13),('8784','2013-08-19','10:30:00',3.21),('8784','2013-08-19','10:35:00',3.21),('8784','2013-08-19','10:40:00',3.24),('8784','2013-08-19','10:45:00',3.33),('8784','2013-08-19','10:50:00',3.38),('8784','2013-08-19','10:55:00',3.43),('8784','2013-08-19','11:00:00',3.4),('8784','2013-08-19','11:05:00',3.47),('8784','2013-08-19','11:10:00',3.54),('8784','2013-08-19','11:15:00',3.58),('8784','2013-08-19','11:20:00',3.61),('8784','2013-08-19','11:25:00',3.6),('8784','2013-08-19','11:30:00',3.64),('8784','2013-08-19','11:35:00',3.7),('8784','2013-08-19','11:40:00',3.7),('8784','2013-08-19','11:45:00',3.7),('8784','2013-08-19','11:50:00',3.67),('8784','2013-08-19','11:55:00',3.68),('8784','2013-08-19','12:00:00',3.73),('8784','2013-08-19','12:05:00',3.79),('8784','2013-08-19','12:10:00',3.81),('8784','2013-08-19','12:15:00',3.87),('8784','2013-08-19','12:20:00',3.86),('8784','2013-08-19','12:25:00',3.89),('8784','2013-08-19','12:30:00',3.91),('8784','2013-08-19','12:35:00',3.91),('8784','2013-08-19','12:40:00',3.95),('8784','2013-08-19','12:45:00',3.98),('8784','2013-08-19','12:50:00',3.96),('8784','2013-08-19','12:55:00',4.01),('8784','2013-08-19','13:00:00',4),('8784','2013-08-19','13:05:00',4.01),('8784','2013-08-19','13:10:00',4),('8784','2013-08-19','13:15:00',4),('8784','2013-08-19','13:20:00',4.03),('8784','2013-08-19','13:25:00',3.97),('8784','2013-08-19','13:30:00',3.95),('8784','2013-08-19','13:35:00',3.96),('8784','2013-08-19','13:40:00',4),('8784','2013-08-19','13:45:00',4.02),('8784','2013-08-19','13:50:00',4),('8784','2013-08-19','13:55:00',3.98),('8784','2013-08-19','14:00:00',3.94),('8784','2013-08-19','14:05:00',3.91),('8784','2013-08-19','14:10:00',3.94),('8784','2013-08-19','14:15:00',3.91),('8784','2013-08-19','14:20:00',3.89),('8784','2013-08-19','14:25:00',3.84),('8784','2013-08-19','14:30:00',3.84),('8784','2013-08-19','14:35:00',3.83),('8784','2013-08-19','14:40:00',3.81),('8784','2013-08-19','14:45:00',3.8),('8784','2013-08-19','14:50:00',3.77),('8784','2013-08-19','14:55:00',3.73),('8784','2013-08-19','15:00:00',3.68),('8784','2013-08-19','15:05:00',3.65),('8784','2013-08-19','15:10:00',3.63),('8784','2013-08-19','15:15:00',3.58),('8784','2013-08-19','15:20:00',3.56),('8784','2013-08-19','15:25:00',3.48),('8784','2013-08-19','15:30:00',3.44),('8784','2013-08-19','15:35:00',3.42),('8784','2013-08-19','15:40:00',3.34),('8784','2013-08-19','15:45:00',3.27),('8784','2013-08-19','15:50:00',3.24),('8784','2013-08-19','15:55:00',3.19),('8784','2013-08-19','16:00:00',3.13),('8784','2013-08-19','16:05:00',3.09),('8784','2013-08-19','16:10:00',3.02),('8784','2013-08-19','16:15:00',2.97),('8784','2013-08-19','16:20:00',2.9),('8784','2013-08-19','16:25:00',2.76),('8784','2013-08-19','16:30:00',2.72),('8784','2013-08-19','16:35:00',2.66),('8784','2013-08-19','16:40:00',2.6),('8784','2013-08-19','16:45:00',2.54),('8784','2013-08-19','16:50:00',2.46),('8784','2013-08-19','16:55:00',2.4),('8784','2013-08-19','17:00:00',2.3),('8784','2013-08-19','17:05:00',2.24),('8784','2013-08-19','17:10:00',2.13),('8784','2013-08-19','17:15:00',2.08),('8784','2013-08-19','17:20:00',2.01),('8784','2013-08-19','17:25:00',1.92),('8784','2013-08-19','17:30:00',1.85),('8784','2013-08-19','17:35:00',1.77),('8784','2013-08-19','17:40:00',1.7),('8784','2013-08-19','17:45:00',1.61),('8784','2013-08-19','17:50:00',1.51),('8784','2013-08-19','17:55:00',1.42),('8784','2013-08-19','18:00:00',1.36),('8784','2013-08-19','18:05:00',1.3),('8784','2013-08-19','18:10:00',1.15),('8784','2013-08-19','18:15:00',1.11),('8784','2013-08-19','18:20:00',1.04),('8784','2013-08-18','07:55:00',1.03),('8784','2013-08-18','08:00:00',1.14),('8784','2013-08-18','08:05:00',1.22),('8784','2013-08-18','08:10:00',1.3),('8784','2013-08-18','08:15:00',1.39),('8784','2013-08-18','08:20:00',1.48),('8784','2013-08-18','08:25:00',1.47),('8784','2013-08-18','08:30:00',1.59),('8784','2013-08-18','08:35:00',1.71),('8784','2013-08-18','08:40:00',1.7),('8784','2013-08-18','08:45:00',1.82),('8784','2013-08-18','08:50:00',1.9),('8784','2013-08-18','08:55:00',1.98),('8784','2013-08-18','09:00:00',2.03),('8784','2013-08-18','09:05:00',2.13),('8784','2013-08-18','09:10:00',2.21),('8784','2013-08-18','09:15:00',2.31),('8784','2013-08-18','09:20:00',2.38),('8784','2013-08-18','09:25:00',2.48),('8784','2013-08-18','09:30:00',2.51),('8784','2013-08-18','09:35:00',2.64),('8784','2013-08-18','09:40:00',2.7),('8784','2013-08-18','09:45:00',2.57),('8784','2013-08-18','09:50:00',2.7),('8784','2013-08-18','09:55:00',1.27),('8784','2013-08-18','10:00:00',2.8),('8784','2013-08-18','10:05:00',2.4),('8784','2013-08-18','10:10:00',2.99),('8784','2013-08-18','10:15:00',3.1),('8784','2013-08-18','10:20:00',3.13),('8784','2013-08-18','10:25:00',3.18),('8784','2013-08-18','10:30:00',3.22),('8784','2013-08-18','10:35:00',3.26),('8784','2013-08-18','10:40:00',3.28),('8784','2013-08-18','10:45:00',3.27),('8784','2013-08-18','10:50:00',3.36),('8784','2013-08-18','10:55:00',3.34),('8784','2013-08-18','11:00:00',3.44),('8784','2013-08-18','11:05:00',3.51),('8784','2013-08-18','11:10:00',3.52),('8784','2013-08-18','11:15:00',3.57),('8784','2013-08-18','11:20:00',3.56),('8784','2013-08-18','11:25:00',3.59),('8784','2013-08-18','11:30:00',3.63),('8784','2013-08-18','11:35:00',3.67),('8784','2013-08-18','11:40:00',3.7),('8784','2013-08-18','11:45:00',3.72),('8784','2013-08-18','11:50:00',3.72),('8784','2013-08-18','11:55:00',3.73),('8784','2013-08-18','12:00:00',3.8),('8784','2013-08-18','12:05:00',3.82),('8784','2013-08-18','12:10:00',3.92),('8784','2013-08-18','12:15:00',4),('8784','2013-08-18','12:20:00',3.99),('8784','2013-08-18','12:25:00',3.96),('8784','2013-08-18','12:30:00',1.98),('8784','2013-08-18','12:45:00',1.76),('8784','2013-08-18','12:50:00',1.96),('8784','2013-08-18','12:55:00',1.15),('8784','2013-08-18','13:00:00',3.23),('8784','2013-08-18','13:05:00',4.16),('8784','2013-08-18','13:10:00',4.08),('8784','2013-08-18','13:15:00',4.09),('8784','2013-08-18','13:20:00',4.1),('8784','2013-08-18','13:25:00',4),('8784','2013-08-18','13:30:00',3.99),('8784','2013-08-18','13:35:00',3.99),('8784','2013-08-18','13:40:00',4.03),('8784','2013-08-18','13:45:00',4),('8784','2013-08-18','13:50:00',3.92),('8784','2013-08-18','13:55:00',3.9),('8784','2013-08-18','14:00:00',3.99),('8784','2013-08-18','14:05:00',3.94),('8784','2013-08-18','14:10:00',3.93),('8784','2013-08-18','14:15:00',3.91),('8784','2013-08-18','14:20:00',3.87),('8784','2013-08-18','14:25:00',3.86),('8784','2013-08-18','14:30:00',3.85),('8784','2013-08-18','14:35:00',3.84),('8784','2013-08-18','14:40:00',3.77),('8784','2013-08-18','14:45:00',3.73),('8784','2013-08-18','14:50:00',3.68),('8784','2013-08-18','14:55:00',3.65),('8784','2013-08-18','15:00:00',3.69),('8784','2013-08-18','15:05:00',3.65),('8784','2013-08-18','15:10:00',3.63),('8784','2013-08-18','15:15:00',3.55),('8784','2013-08-18','15:20:00',3.5),('8784','2013-08-18','15:25:00',3.47),('8784','2013-08-18','15:30:00',3.43),('8784','2013-08-18','15:35:00',3.37),('8784','2013-08-18','15:40:00',3.35),('8784','2013-08-18','15:45:00',3.29),('8784','2013-08-18','15:50:00',3.23),('8784','2013-08-18','15:55:00',3.17),('8784','2013-08-18','16:00:00',3.11),('8784','2013-08-18','16:05:00',3.05),('8784','2013-08-18','16:10:00',3.01),('8784','2013-08-18','16:15:00',2.94),('8784','2013-08-18','16:20:00',2.86),('8784','2013-08-18','16:25:00',2.82),('8784','2013-08-18','16:30:00',2.76),('8784','2013-08-18','16:35:00',2.69),('8784','2013-08-18','16:40:00',2.62),('8784','2013-08-18','16:45:00',2.56),('8784','2013-08-18','16:50:00',2.47),('8784','2013-08-18','16:55:00',2.41),('8784','2013-08-18','17:00:00',2.34),('8784','2013-08-18','17:05:00',2.27),('8784','2013-08-18','17:10:00',2.2),('8784','2013-08-18','17:15:00',2.12),('8784','2013-08-18','17:20:00',2.04),('8784','2013-08-18','17:25:00',1.97),('8784','2013-08-18','17:30:00',1.89),('8784','2013-08-18','17:35:00',1.8),('8784','2013-08-18','17:40:00',1.72),('8784','2013-08-18','17:45:00',1.63),('8784','2013-08-18','17:50:00',1.55),('8784','2013-08-18','17:55:00',1.46),('8784','2013-08-18','18:00:00',1.38),('8784','2013-08-18','18:05:00',1.3),('8784','2013-08-18','18:10:00',1.22),('8784','2013-08-18','18:15:00',1.15),('8784','2013-08-18','18:20:00',1.07),('8784','2013-08-17','07:55:00',1.05),('8784','2013-08-17','08:00:00',1.11),('8784','2013-08-17','08:05:00',1.17),('8784','2013-08-17','08:10:00',1.26),('8784','2013-08-17','08:15:00',1.28),('8784','2013-08-17','08:20:00',1.4),('8784','2013-08-17','08:25:00',1.5),('8784','2013-08-17','08:30:00',1.58),('8784','2013-08-17','08:35:00',1.69),('8784','2013-08-17','08:40:00',1.75),('8784','2013-08-17','08:45:00',1.79),('8784','2013-08-17','08:50:00',1.88),('8784','2013-08-17','08:55:00',1.93),('8784','2013-08-17','09:00:00',2.08),('8784','2013-08-17','09:05:00',2.17),('8784','2013-08-17','09:10:00',2.2),('8784','2013-08-17','09:15:00',2.31),('8784','2013-08-17','09:20:00',2.36),('8784','2013-08-17','09:25:00',2.45),('8784','2013-08-17','09:30:00',2.53),('8784','2013-08-17','09:35:00',2.61),('8784','2013-08-17','09:40:00',2.66),('8784','2013-08-17','09:45:00',2.71),('8784','2013-08-17','09:50:00',2.8),('8784','2013-08-17','09:55:00',2.88),('8784','2013-08-17','10:00:00',2.94),('8784','2013-08-17','10:05:00',3),('8784','2013-08-17','10:10:00',3.06),('8784','2013-08-17','10:15:00',3.11),('8784','2013-08-17','10:20:00',3.16),('8784','2013-08-17','10:25:00',3.22),('8784','2013-08-17','10:30:00',3.2),('8784','2013-08-17','10:35:00',3.29),('8784','2013-08-17','10:40:00',3.34),('8784','2013-08-17','10:45:00',3.39),('8784','2013-08-17','10:50:00',3.43),('8784','2013-08-17','10:55:00',3.46),('8784','2013-08-17','11:00:00',3.5),('8784','2013-08-17','11:05:00',3.55),('8784','2013-08-17','11:10:00',3.57),('8784','2013-08-17','11:15:00',3.59),('8784','2013-08-17','11:20:00',3.65),('8784','2013-08-17','11:25:00',3.68),('8784','2013-08-17','11:30:00',3.67),('8784','2013-08-17','11:35:00',3.7),('8784','2013-08-17','11:40:00',3.75),('8784','2013-08-17','11:45:00',3.78),('8784','2013-08-17','11:50:00',3.74),('8784','2013-08-17','11:55:00',3.65),('8784','2013-08-17','12:00:00',3.68),('8784','2013-08-17','12:05:00',3.89),('8784','2013-08-17','12:10:00',3.82),('8784','2013-08-17','12:15:00',3.77),('8784','2013-08-17','12:20:00',3.81),('8784','2013-08-17','12:25:00',3.97),('8784','2013-08-17','12:30:00',3.98),('8784','2013-08-17','12:35:00',4.01),('8784','2013-08-17','12:40:00',3.7),('8784','2013-08-17','12:45:00',3.93),('8784','2013-08-17','12:50:00',4),('8784','2013-08-17','12:55:00',4.01),('8784','2013-08-17','13:00:00',4.09),('8784','2013-08-17','13:05:00',3.97),('8784','2013-08-17','13:10:00',2.28),('8784','2013-08-17','13:15:00',4),('8784','2013-08-17','13:20:00',4.1),('8784','2013-08-17','13:25:00',4.19),('8784','2013-08-17','13:30:00',4.17),('8784','2013-08-17','13:35:00',4.11),('8784','2013-08-17','13:40:00',1.33),('8784','2013-08-17','13:45:00',3.52),('8784','2013-08-17','13:50:00',2.02),('8784','2013-08-17','13:55:00',2.61),('8784','2013-08-17','14:00:00',2.56),('8784','2013-08-17','14:05:00',3.85),('8784','2013-08-17','14:10:00',3.83),('8784','2013-08-17','14:15:00',3.75),('8784','2013-08-17','14:20:00',3.88),('8784','2013-08-17','14:25:00',3.88),('8784','2013-08-17','14:30:00',3.55),('8784','2013-08-17','14:35:00',3.83),('8784','2013-08-17','14:40:00',3.74),('8784','2013-08-17','14:45:00',3.76),('8784','2013-08-17','14:50:00',3.75),('8784','2013-08-17','14:55:00',3.67),('8784','2013-08-17','15:00:00',3.65),('8784','2013-08-17','15:05:00',3.64),('8784','2013-08-17','15:10:00',3.57),('8784','2013-08-17','15:15:00',3.52),('8784','2013-08-17','15:20:00',3.49),('8784','2013-08-17','15:25:00',3.48),('8784','2013-08-17','15:30:00',3.43),('8784','2013-08-17','15:35:00',3.4),('8784','2013-08-17','15:40:00',3.35),('8784','2013-08-17','15:45:00',3.31),('8784','2013-08-17','15:50:00',3.26),('8784','2013-08-17','15:55:00',3.19),('8784','2013-08-17','16:00:00',3.14),('8784','2013-08-17','16:05:00',3.07),('8784','2013-08-17','16:10:00',3),('8784','2013-08-17','16:15:00',2.96),('8784','2013-08-17','16:20:00',2.87),('8784','2013-08-17','16:25:00',2.82),('8784','2013-08-17','16:30:00',2.78),('8784','2013-08-17','16:35:00',2.72),('8784','2013-08-17','16:40:00',2.67),('8784','2013-08-17','16:45:00',2.56),('8784','2013-08-17','16:50:00',2.48),('8784','2013-08-17','16:55:00',2.44),('8784','2013-08-17','17:00:00',2.4),('8784','2013-08-17','17:05:00',2.28),('8784','2013-08-17','17:10:00',2.14),('8784','2013-08-17','17:15:00',1.97),('8784','2013-08-17','17:20:00',2),('8784','2013-08-17','17:25:00',2.05),('8784','2013-08-17','17:30:00',2),('8784','2013-08-17','17:35:00',1.91),('8784','2013-08-17','17:40:00',1.82),('8784','2013-08-17','17:45:00',1.75),('8784','2013-08-17','17:50:00',1.65),('8784','2013-08-17','17:55:00',1.57),('8784','2013-08-17','18:00:00',1.45),('8784','2013-08-17','18:05:00',1.35),('8784','2013-08-17','18:10:00',1.3),('8784','2013-08-17','18:15:00',1.22),('8784','2013-08-17','18:20:00',1.13),('8784','2013-08-17','18:25:00',1.04),('8784','2013-08-16','07:55:00',1.07),('8784','2013-08-16','08:00:00',1.13),('8784','2013-08-16','08:05:00',1.23),('8784','2013-08-16','08:10:00',1.32),('8784','2013-08-16','08:15:00',1.4),('8784','2013-08-16','08:20:00',1.5),('8784','2013-08-16','08:25:00',1.58),('8784','2013-08-16','08:30:00',1.67),('8784','2013-08-16','08:35:00',1.76),('8784','2013-08-16','08:40:00',1.84),('8784','2013-08-16','08:45:00',1.92),('8784','2013-08-16','08:50:00',1.99),('8784','2013-08-16','08:55:00',2.06),('8784','2013-08-16','09:00:00',2.09),('8784','2013-08-16','09:05:00',2.16),('8784','2013-08-16','09:10:00',2.26),('8784','2013-08-16','09:15:00',2.37),('8784','2013-08-16','09:20:00',2.48),('8784','2013-08-16','09:25:00',2.51),('8784','2013-08-16','09:30:00',2.62),('8784','2013-08-16','09:35:00',2.72),('8784','2013-08-16','09:40:00',2.79),('8784','2013-08-16','09:45:00',2.83),('8784','2013-08-16','09:50:00',2.89),('8784','2013-08-16','09:55:00',2.94),('8784','2013-08-16','10:00:00',3.01),('8784','2013-08-16','10:05:00',3.09),('8784','2013-08-16','10:10:00',3.16),('8784','2013-08-16','10:15:00',3.22),('8784','2013-08-16','10:20:00',3.28),('8784','2013-08-16','10:25:00',3.34),('8784','2013-08-16','10:30:00',3.38),('8784','2013-08-16','10:35:00',3.42),('8784','2013-08-16','10:40:00',3.47),('8784','2013-08-16','10:45:00',3.5),('8784','2013-08-16','10:50:00',3.57),('8784','2013-08-16','10:55:00',3.61),('8784','2013-08-16','11:00:00',3.65),('8784','2013-08-16','11:05:00',3.68),('8784','2013-08-16','11:10:00',3.72),('8784','2013-08-16','11:15:00',3.75),('8784','2013-08-16','11:20:00',3.78),('8784','2013-08-16','11:25:00',3.8),('8784','2013-08-16','11:30:00',3.8),('8784','2013-08-16','11:35:00',3.85),('8784','2013-08-16','11:40:00',3.87),('8784','2013-08-16','11:45:00',3.89),('8784','2013-08-16','11:50:00',3.89),('8784','2013-08-16','11:55:00',3.9),('8784','2013-08-16','12:00:00',3.92),('8784','2013-08-16','12:05:00',3.98),('8784','2013-08-16','12:10:00',3.99),('8784','2013-08-16','12:15:00',4),('8784','2013-08-16','12:20:00',4.01),('8784','2013-08-16','12:25:00',4.01),('8784','2013-08-16','12:30:00',4),('8784','2013-08-16','12:35:00',4.05),('8784','2013-08-16','12:40:00',4.03),('8784','2013-08-16','12:45:00',4.04),('8784','2013-08-16','12:50:00',4.06),('8784','2013-08-16','12:55:00',4.05),('8784','2013-08-16','13:00:00',4.05),('8784','2013-08-16','13:05:00',4.04),('8784','2013-08-16','13:10:00',4.03),('8784','2013-08-16','13:15:00',4.01),('8784','2013-08-16','13:20:00',4),('8784','2013-08-16','13:25:00',4),('8784','2013-08-16','13:30:00',3.99),('8784','2013-08-16','13:35:00',3.98),('8784','2013-08-16','13:40:00',3.92),('8784','2013-08-16','13:45:00',3.88),('8784','2013-08-16','13:50:00',3.94),('8784','2013-08-16','13:55:00',3.94),('8784','2013-08-16','14:00:00',3.92),('8784','2013-08-16','14:05:00',3.86),('8784','2013-08-16','14:10:00',3.85),('8784','2013-08-16','14:15:00',3.82),('8784','2013-08-16','14:20:00',3.83),('8784','2013-08-16','14:25:00',3.79),('8784','2013-08-16','14:30:00',3.74),('8784','2013-08-16','14:35:00',3.71),('8784','2013-08-16','14:40:00',3.74),('8784','2013-08-16','14:45:00',3.72),('8784','2013-08-16','14:50:00',3.67),('8784','2013-08-16','14:55:00',3.62),('8784','2013-08-16','15:00:00',3.57),('8784','2013-08-16','15:05:00',3.51),('8784','2013-08-16','15:10:00',3.52),('8784','2013-08-16','15:15:00',3.49),('8784','2013-08-16','15:20:00',3.5),('8784','2013-08-16','15:25:00',3.47),('8784','2013-08-16','15:30:00',3.42),('8784','2013-08-16','15:35:00',3.38),('8784','2013-08-16','15:40:00',3.33),('8784','2013-08-16','15:45:00',3.29),('8784','2013-08-16','15:50:00',3.25),('8784','2013-08-16','15:55:00',3.2),('8784','2013-08-16','16:00:00',3.15),('8784','2013-08-16','16:05:00',3.08),('8784','2013-08-16','16:10:00',3.03),('8784','2013-08-16','16:15:00',2.97),('8784','2013-08-16','16:20:00',2.9),('8784','2013-08-16','16:25:00',2.84),('8784','2013-08-16','16:30:00',2.79),('8784','2013-08-16','16:35:00',2.73),('8784','2013-08-16','16:40:00',2.66),('8784','2013-08-16','16:45:00',2.59),('8784','2013-08-16','16:50:00',2.52),('8784','2013-08-16','16:55:00',2.44),('8784','2013-08-16','17:00:00',2.36),('8784','2013-08-16','17:05:00',2.3),('8784','2013-08-16','17:10:00',2.22),('8784','2013-08-16','17:15:00',2.14),('8784','2013-08-16','17:20:00',2.03),('8784','2013-08-16','17:25:00',1.97),('8784','2013-08-16','17:30:00',1.89),('8784','2013-08-16','17:35:00',1.81),('8784','2013-08-16','17:40:00',1.73),('8784','2013-08-16','17:45:00',1.65),('8784','2013-08-16','17:50:00',1.57),('8784','2013-08-16','17:55:00',1.48),('8784','2013-08-16','18:00:00',1.39),('8784','2013-08-16','18:05:00',1.32),('8784','2013-08-16','18:10:00',1.24),('8784','2013-08-16','18:15:00',1.16),('8784','2013-08-16','18:20:00',1.09),('8784','2013-08-16','18:25:00',1.01),('8784','2013-08-15','08:05:00',1.36),('8784','2013-08-15','08:10:00',1.5),('8784','2013-08-15','08:15:00',1.44),('8784','2013-08-15','08:20:00',1.44),('8784','2013-08-15','08:25:00',1.66),('8784','2013-08-15','08:30:00',1.73),('8784','2013-08-15','08:35:00',1.8),('8784','2013-08-15','08:40:00',1.88),('8784','2013-08-15','08:45:00',1.97),('8784','2013-08-15','08:50:00',2.04),('8784','2013-08-15','08:55:00',2.14),('8784','2013-08-15','09:00:00',2.28),('8784','2013-08-15','09:05:00',2.2),('8784','2013-08-15','09:10:00',1.46),('8784','2013-08-15','09:15:00',2.12),('8784','2013-08-15','09:20:00',2.64),('8784','2013-08-15','09:25:00',2.61),('8784','2013-08-15','09:30:00',2.65),('8784','2013-08-15','09:35:00',2.71),('8784','2013-08-15','09:40:00',2.79),('8784','2013-08-15','09:45:00',2.85),('8784','2013-08-15','09:50:00',2.94),('8784','2013-08-15','09:55:00',3),('8784','2013-08-15','10:00:00',3.06),('8784','2013-08-15','10:05:00',3.12),('8784','2013-08-15','10:10:00',3.19),('8784','2013-08-15','10:15:00',3.25),('8784','2013-08-15','10:20:00',3.29),('8784','2013-08-15','10:25:00',3.37),('8784','2013-08-15','10:30:00',3.42),('8784','2013-08-15','10:35:00',3.47),('8784','2013-08-15','10:40:00',3.5),('8784','2013-08-15','10:45:00',3.52),('8784','2013-08-15','10:50:00',3.56),('8784','2013-08-15','10:55:00',3.26),('8784','2013-08-15','11:00:00',2.99),('8784','2013-08-15','11:05:00',3.03),('8784','2013-08-15','11:10:00',2.31),('8784','2013-08-15','11:15:00',2.37),('8784','2013-08-15','11:20:00',2.79),('8784','2013-08-15','11:25:00',3.16),('8784','2013-08-15','11:30:00',3.4),('8784','2013-08-15','11:35:00',3.86),('8784','2013-08-15','11:40:00',4.08),('8784','2013-08-15','11:45:00',4.18),('8784','2013-08-15','11:50:00',4.24),('8784','2013-08-15','11:55:00',4.25),('8784','2013-08-15','12:00:00',4.28),('8784','2013-08-15','12:05:00',4.23),('8784','2013-08-15','12:10:00',4.2),('8784','2013-08-15','12:15:00',4.18),('8784','2013-08-15','12:20:00',4.23),('8784','2013-08-15','12:25:00',4.21),('8784','2013-08-15','12:30:00',4.2),('8784','2013-08-15','12:35:00',4.2),('8784','2013-08-15','12:40:00',4.21),('8784','2013-08-15','12:45:00',4.19),('8784','2013-08-15','12:50:00',4.19),('8784','2013-08-15','12:55:00',4.07),('8784','2013-08-15','13:00:00',3.93),('8784','2013-08-15','13:05:00',4.01),('8784','2013-08-15','13:10:00',4.04),('8784','2013-08-15','13:15:00',3.94),('8784','2013-08-15','13:20:00',3.88),('8784','2013-08-15','13:25:00',3.97),('8784','2013-08-15','13:30:00',4.06),('8784','2013-08-15','13:35:00',4.12),('8784','2013-08-15','13:40:00',4.11),('8784','2013-08-15','13:45:00',4.08),('8784','2013-08-15','13:50:00',3.98),('8784','2013-08-15','13:55:00',3.98),('8784','2013-08-15','14:00:00',3.97),('8784','2013-08-15','14:05:00',4.01),('8784','2013-08-15','14:10:00',4),('8784','2013-08-15','14:15:00',3.99),('8784','2013-08-15','14:20:00',3.96),('8784','2013-08-15','14:25:00',3.89),('8784','2013-08-15','14:30:00',3.78),('8784','2013-08-15','14:35:00',3.83),('8784','2013-08-15','14:40:00',3.81),('8784','2013-08-15','14:45:00',3.76),('8784','2013-08-15','14:50:00',3.7),('8784','2013-08-15','14:55:00',3.67),('8784','2013-08-15','15:00:00',3.6),('8784','2013-08-15','15:05:00',3.59),('8784','2013-08-15','15:10:00',3.57),('8784','2013-08-15','15:15:00',3.54),('8784','2013-08-15','15:20:00',3.49),('8784','2013-08-15','15:25:00',3.43),('8784','2013-08-15','15:30:00',3.37),('8784','2013-08-15','15:35:00',3.31),('8784','2013-08-15','15:40:00',3.27),('8784','2013-08-15','15:45:00',3.22),('8784','2013-08-15','15:50:00',3.18),('8784','2013-08-15','15:55:00',3.11),('8784','2013-08-15','16:00:00',3.02),('8784','2013-08-15','16:05:00',2.99),('8784','2013-08-15','16:10:00',2.92),('8784','2013-08-15','16:15:00',2.78),('8784','2013-08-15','16:20:00',2.81),('8784','2013-08-15','16:25:00',2.73),('8784','2013-08-15','16:30:00',2.64),('8784','2013-08-15','16:35:00',2.52),('8784','2013-08-15','16:40:00',2.47),('8784','2013-08-15','16:45:00',2.45),('8784','2013-08-15','16:50:00',2.37),('8784','2013-08-15','16:55:00',2.35),('8784','2013-08-15','17:00:00',2.29),('8784','2013-08-15','17:05:00',2.2),('8784','2013-08-15','17:10:00',2.12),('8784','2013-08-15','17:15:00',2.01),('8784','2013-08-15','17:20:00',1.79),('8784','2013-08-15','17:25:00',1.84),('8784','2013-08-15','17:30:00',1.85),('8784','2013-08-15','17:35:00',1.78),('8784','2013-08-15','17:40:00',1.7),('8784','2013-08-15','17:45:00',1.62),('8784','2013-08-15','17:50:00',1.53),('8784','2013-08-15','17:55:00',1.47),('8784','2013-08-15','18:00:00',1.39),('8784','2013-08-15','18:05:00',1.29),('8784','2013-08-15','18:10:00',1.18),('8784','2013-08-15','18:15:00',1.13),('8784','2013-08-15','18:20:00',1.08),('8784','2013-08-14','07:55:00',1.07),('8784','2013-08-14','08:00:00',1.12),('8784','2013-08-14','08:05:00',1.24),('8784','2013-08-14','08:10:00',1.31),('8784','2013-08-14','08:15:00',1.4),('8784','2013-08-14','08:20:00',1.45),('8784','2013-08-14','08:25:00',1.5),('8784','2013-08-14','08:30:00',1.62),('8784','2013-08-14','08:35:00',1.68),('8784','2013-08-14','08:40:00',1.78),('8784','2013-08-14','08:45:00',1.78),('8784','2013-08-14','08:50:00',1.94),('8784','2013-08-14','08:55:00',2.01),('8784','2013-08-14','09:00:00',1.98),('8784','2013-08-14','09:05:00',1.98),('8784','2013-08-14','09:10:00',2.35),('8784','2013-08-14','09:15:00',2.47),('8784','2013-08-14','09:20:00',2.54),('8784','2013-08-14','09:25:00',2.32),('8784','2013-08-14','09:30:00',2.7),('8784','2013-08-14','09:35:00',2.06),('8784','2013-08-14','09:40:00',1.26),('8784','2013-08-14','09:45:00',2.43),('8784','2013-08-14','09:50:00',2.5),('8784','2013-08-14','09:55:00',2.92),('8784','2013-08-14','10:00:00',3.13),('8784','2013-08-14','10:05:00',2.75),('8784','2013-08-14','10:10:00',1.69),('8784','2013-08-14','10:15:00',1.09),('8784','2013-08-14','10:20:00',2.1),('8784','2013-08-14','10:25:00',3.55),('8784','2013-08-14','10:30:00',3.81),('8784','2013-08-14','10:35:00',3.47),('8784','2013-08-14','10:40:00',2.36),('8784','2013-08-14','10:45:00',1.11),('8784','2013-08-14','10:50:00',1.13),('8784','2013-08-14','10:55:00',1.23),('8784','2013-08-14','11:00:00',1.55),('8784','2013-08-14','11:05:00',3.84),('8784','2013-08-14','11:10:00',3.65),('8784','2013-08-14','11:15:00',3.65),('8784','2013-08-14','11:20:00',3.42),('8784','2013-08-14','11:25:00',3.59),('8784','2013-08-14','11:30:00',4.22),('8784','2013-08-14','11:35:00',3.9),('8784','2013-08-14','11:40:00',1.76),('8784','2013-08-14','11:45:00',1.55),('8784','2013-08-14','11:50:00',3.09),('8784','2013-08-14','11:55:00',4.05),('8784','2013-08-14','12:00:00',3.91),('8784','2013-08-14','12:05:00',3.36),('8784','2013-08-14','12:10:00',1.83),('8784','2013-08-14','12:15:00',1.4),('8784','2013-08-14','12:20:00',1.22),('8784','2013-08-14','12:25:00',1.55),('8784','2013-08-14','12:30:00',1.26),('8784','2013-08-14','12:35:00',1.31),('8784','2013-08-14','12:40:00',1.49),('8784','2013-08-14','12:45:00',2.04),('8784','2013-08-14','12:50:00',2.24),('8784','2013-08-14','12:55:00',2.58),('8784','2013-08-14','13:00:00',2.8),('8784','2013-08-14','13:05:00',1.16),('8784','2013-08-14','13:10:00',1.18),('8784','2013-08-14','13:15:00',1.53),('8784','2013-08-14','13:20:00',1.27),('8784','2013-08-14','13:25:00',3.38),('8784','2013-08-14','13:30:00',3.13),('8784','2013-08-14','13:35:00',1.85),('8784','2013-08-14','13:40:00',3.53),('8784','2013-08-14','13:45:00',4.24),('8784','2013-08-14','13:50:00',4.11),('8784','2013-08-14','13:55:00',2.44),('8784','2013-08-14','14:00:00',4.69),('8784','2013-08-14','14:05:00',4.5),('8784','2013-08-14','14:10:00',3.39),('8784','2013-08-14','14:15:00',4.35),('8784','2013-08-14','14:20:00',3.38),('8784','2013-08-14','14:25:00',2.84),('8784','2013-08-14','14:30:00',3.67),('8784','2013-08-14','14:35:00',4.16),('8784','2013-08-14','14:40:00',3.99),('8784','2013-08-14','14:45:00',3.95),('8784','2013-08-14','14:50:00',3.92),('8784','2013-08-14','14:55:00',3.88),('8784','2013-08-14','15:00:00',3.75),('8784','2013-08-14','15:05:00',3.67),('8784','2013-08-14','15:10:00',3.66),('8784','2013-08-14','15:15:00',3.78),('8784','2013-08-14','15:20:00',3.72),('8784','2013-08-14','15:25:00',3.62),('8784','2013-08-14','15:30:00',3.51),('8784','2013-08-14','15:35:00',3.43),('8784','2013-08-14','15:40:00',3.4),('8784','2013-08-14','15:45:00',3.34),('8784','2013-08-14','15:50:00',3.31),('8784','2013-08-14','15:55:00',3.26),('8784','2013-08-14','16:00:00',3.18),('8784','2013-08-14','16:05:00',3.13),('8784','2013-08-14','16:10:00',3.13),('8784','2013-08-14','16:15:00',3.11),('8784','2013-08-14','16:20:00',3.03),('8784','2013-08-14','16:25:00',2.95),('8784','2013-08-14','16:30:00',2.88),('8784','2013-08-14','16:35:00',2.81),('8784','2013-08-14','16:40:00',2.77),('8784','2013-08-14','16:45:00',2.68),('8784','2013-08-14','16:50:00',2.6),('8784','2013-08-14','16:55:00',2.54),('8784','2013-08-14','17:00:00',2.43),('8784','2013-08-14','17:05:00',2.38),('8784','2013-08-14','17:10:00',2.29),('8784','2013-08-14','17:15:00',2.22),('8784','2013-08-14','17:20:00',2.13),('8784','2013-08-14','17:25:00',2.04),('8784','2013-08-14','17:30:00',1.95),('8784','2013-08-14','17:35:00',1.86),('8784','2013-08-14','17:40:00',1.82),('8784','2013-08-14','17:45:00',1.72),('8784','2013-08-14','17:50:00',1.66),('8784','2013-08-14','17:55:00',1.56),('8784','2013-08-14','18:00:00',1.48),('8784','2013-08-14','18:05:00',1.42),('8784','2013-08-14','18:10:00',1.33),('8784','2013-08-14','18:15:00',1.25),('8784','2013-08-14','18:20:00',1.23),('8784','2013-08-14','18:25:00',1.22),('8784','2013-08-14','18:30:00',1.13),('8784','2013-08-13','07:50:00',1.03),('8784','2013-08-13','07:55:00',1.09),('8784','2013-08-13','08:00:00',1.17),('8784','2013-08-13','08:05:00',1.16),('8784','2013-08-13','08:10:00',1.33),('8784','2013-08-13','08:15:00',1.41),('8784','2013-08-13','08:20:00',1.48),('8784','2013-08-13','08:25:00',1.56),('8784','2013-08-13','08:30:00',1.64),('8784','2013-08-13','08:35:00',1.72),('8784','2013-08-13','08:40:00',1.84),('8784','2013-08-13','08:45:00',1.91),('8784','2013-08-13','08:50:00',2.02),('8784','2013-08-13','08:55:00',2.02),('8784','2013-08-13','09:00:00',2.19),('8784','2013-08-13','09:05:00',2.28),('8784','2013-08-13','09:10:00',2.34),('8784','2013-08-13','09:15:00',2.41),('8784','2013-08-13','09:20:00',2.5),('8784','2013-08-13','09:25:00',2.57),('8784','2013-08-13','09:30:00',2.62),('8784','2013-08-13','09:35:00',1.03),('8784','2013-08-13','09:40:00',2.78),('8784','2013-08-13','09:45:00',2.82),('8784','2013-08-13','09:50:00',2.84),('8784','2013-08-13','09:55:00',2.94),('8784','2013-08-13','10:00:00',3.02),('8784','2013-08-13','10:05:00',3.1),('8784','2013-08-13','10:10:00',3.01),('8784','2013-08-13','10:15:00',3.12),('8784','2013-08-13','10:20:00',3.23),('8784','2013-08-13','10:25:00',3.31),('8784','2013-08-13','10:30:00',3.37),('8784','2013-08-13','10:35:00',3.35),('8784','2013-08-13','10:40:00',3.32),('8784','2013-08-13','10:45:00',3.33),('8784','2013-08-13','10:50:00',3.47),('8784','2013-08-13','10:55:00',3.51),('8784','2013-08-13','11:00:00',3.56),('8784','2013-08-13','11:05:00',3.58),('8784','2013-08-13','11:10:00',3.6),('8784','2013-08-13','11:15:00',3.63),('8784','2013-08-13','11:20:00',3.66),('8784','2013-08-13','11:25:00',3.65),('8784','2013-08-13','11:30:00',3.71),('8784','2013-08-13','11:35:00',3.72),('8784','2013-08-13','11:40:00',3.76),('8784','2013-08-13','11:45:00',3.79),('8784','2013-08-13','11:50:00',3.84),('8784','2013-08-13','11:55:00',3.91),('8784','2013-08-13','12:00:00',3.75),('8784','2013-08-13','12:05:00',4.02),('8784','2013-08-13','12:10:00',4.02),('8784','2013-08-13','12:15:00',4.06),('8784','2013-08-13','12:20:00',4.16),('8784','2013-08-13','12:25:00',4.26),('8784','2013-08-13','12:30:00',4.3),('8784','2013-08-13','12:35:00',3.82),('8784','2013-08-13','12:40:00',1.31),('8784','2013-08-13','12:45:00',1.34),('8784','2013-08-13','12:50:00',2.81),('8784','2013-08-13','12:55:00',1.97),('8784','2013-08-13','13:00:00',1.39),('8784','2013-08-13','13:05:00',1.51),('8784','2013-08-13','13:10:00',4.47),('8784','2013-08-13','13:15:00',4.64),('8784','2013-08-13','13:20:00',4),('8784','2013-08-13','13:25:00',1.47),('8784','2013-08-13','13:30:00',2.88),('8784','2013-08-13','13:35:00',4.56),('8784','2013-08-13','13:40:00',3.41),('8784','2013-08-13','13:45:00',1.81),('8784','2013-08-13','13:50:00',1.58),('8784','2013-08-13','13:55:00',3.54),('8784','2013-08-13','14:00:00',4.3),('8784','2013-08-13','14:05:00',3.32),('8784','2013-08-13','14:10:00',4.34),('8784','2013-08-13','14:15:00',4.16),('8784','2013-08-13','14:20:00',3.89),('8784','2013-08-13','14:25:00',4.14),('8784','2013-08-13','14:30:00',4.57),('8784','2013-08-13','14:35:00',3.17),('8784','2013-08-13','14:40:00',3.44),('8784','2013-08-13','14:45:00',1.96),('8784','2013-08-13','14:50:00',3.1),('8784','2013-08-13','14:55:00',3.18),('8784','2013-08-13','15:00:00',3.96),('8784','2013-08-13','15:05:00',3.1),('8784','2013-08-13','15:10:00',3.9),('8784','2013-08-13','15:15:00',3.62),('8784','2013-08-13','15:20:00',2.86),('8784','2013-08-13','15:25:00',3.63),('8784','2013-08-13','15:30:00',3.32),('8784','2013-08-13','15:35:00',3.41),('8784','2013-08-13','15:40:00',3.46),('8784','2013-08-13','15:45:00',3.41),('8784','2013-08-13','15:50:00',3.31),('8784','2013-08-13','15:55:00',3.23),('8784','2013-08-13','16:00:00',3.21),('8784','2013-08-13','16:05:00',3.16),('8784','2013-08-13','16:10:00',3.08),('8784','2013-08-13','16:15:00',3.03),('8784','2013-08-13','16:20:00',2.99),('8784','2013-08-13','16:25:00',2.92),('8784','2013-08-13','16:30:00',2.86),('8784','2013-08-13','16:35:00',2.79),('8784','2013-08-13','16:40:00',2.72),('8784','2013-08-13','16:45:00',2.63),('8784','2013-08-13','16:50:00',2.58),('8784','2013-08-13','16:55:00',2.5),('8784','2013-08-13','17:00:00',2.44),('8784','2013-08-13','17:05:00',2.37),('8784','2013-08-13','17:10:00',2.29),('8784','2013-08-13','17:15:00',2.21),('8784','2013-08-13','17:20:00',2.14),('8784','2013-08-13','17:25:00',2.05),('8784','2013-08-13','17:30:00',1.96),('8784','2013-08-13','17:35:00',1.89),('8784','2013-08-13','17:40:00',1.81),('8784','2013-08-13','17:45:00',1.72),('8784','2013-08-13','17:50:00',1.65),('8784','2013-08-13','17:55:00',1.56),('8784','2013-08-13','18:00:00',1.47),('8784','2013-08-13','18:05:00',1.39),('8784','2013-08-13','18:10:00',1.3),('8784','2013-08-13','18:15:00',1.21),('8784','2013-08-13','18:20:00',1.15),('8784','2013-08-13','18:25:00',1.06),('8784','2013-08-12','07:50:00',1.02),('8784','2013-08-12','07:55:00',1.1),('8784','2013-08-12','08:00:00',1.18),('8784','2013-08-12','08:05:00',1.26),('8784','2013-08-12','08:10:00',1.33),('8784','2013-08-12','08:15:00',1.41),('8784','2013-08-12','08:20:00',1.45),('8784','2013-08-12','08:25:00',1.53),('8784','2013-08-12','08:30:00',1.66),('8784','2013-08-12','08:35:00',1.73),('8784','2013-08-12','08:40:00',1.79),('8784','2013-08-12','08:45:00',1.87),('8784','2013-08-12','08:50:00',1.91),('8784','2013-08-12','08:55:00',2.02),('8784','2013-08-12','09:00:00',2.14),('8784','2013-08-12','09:05:00',2.23),('8784','2013-08-12','09:10:00',2.31),('8784','2013-08-12','09:15:00',2.37),('8784','2013-08-12','09:20:00',2.45),('8784','2013-08-12','09:25:00',2.5),('8784','2013-08-12','09:30:00',2.58),('8784','2013-08-12','09:35:00',2.64),('8784','2013-08-12','09:40:00',2.7),('8784','2013-08-12','09:45:00',2.78),('8784','2013-08-12','09:50:00',2.83),('8784','2013-08-12','09:55:00',2.9),('8784','2013-08-12','10:00:00',2.9),('8784','2013-08-12','10:05:00',2.98),('8784','2013-08-12','10:10:00',3.05),('8784','2013-08-12','10:15:00',3.09),('8784','2013-08-12','10:20:00',3.09),('8784','2013-08-12','10:25:00',3.2),('8784','2013-08-12','10:30:00',3.21),('8784','2013-08-12','10:35:00',3.26),('8784','2013-08-12','10:40:00',3.3),('8784','2013-08-12','10:45:00',3.39),('8784','2013-08-12','10:50:00',3.41),('8784','2013-08-12','10:55:00',3.46),('8784','2013-08-12','11:00:00',3.47),('8784','2013-08-12','11:05:00',3.53),('8784','2013-08-12','11:10:00',3.56),('8784','2013-08-12','11:15:00',3.56),('8784','2013-08-12','11:20:00',3.61),('8784','2013-08-12','11:25:00',3.68),('8784','2013-08-12','11:30:00',3.73),('8784','2013-08-12','11:35:00',3.78),('8784','2013-08-12','11:40:00',3.79),('8784','2013-08-12','11:45:00',3.83),('8784','2013-08-12','11:50:00',3.92),('8784','2013-08-12','11:55:00',3.97),('8784','2013-08-12','12:00:00',4.02),('8784','2013-08-12','12:05:00',4),('8784','2013-08-12','12:10:00',4.06),('8784','2013-08-12','12:15:00',2.7),('8784','2013-08-12','12:20:00',1.48),('8784','2013-08-12','12:25:00',2.29),('8784','2013-08-12','12:30:00',1.59),('8784','2013-08-12','12:35:00',3.57),('8784','2013-08-12','12:40:00',3.18),('8784','2013-08-12','12:45:00',1.59),('8784','2013-08-12','12:50:00',1.35),('8784','2013-08-12','12:55:00',2.24),('8784','2013-08-12','13:15:00',1.06),('8784','2013-08-12','13:20:00',1.28),('8784','2013-08-12','13:25:00',1.59),('8784','2013-08-12','13:30:00',1.37),('8784','2013-08-12','13:35:00',1.36),('8784','2013-08-12','13:40:00',1.21),('8784','2013-08-12','13:45:00',1.27),('8784','2013-08-12','13:50:00',4.55),('8784','2013-08-12','13:55:00',4.05),('8784','2013-08-12','14:00:00',2.87),('8784','2013-08-12','14:05:00',3.52),('8784','2013-08-12','14:10:00',1.51),('8784','2013-08-12','14:15:00',1.15),('8784','2013-08-12','14:20:00',1),('8784','2013-08-12','14:35:00',1.2),('8784','2013-08-12','14:40:00',1.3),('8784','2013-08-12','14:45:00',1.42),('8784','2013-08-12','14:50:00',2.28),('8784','2013-08-12','14:55:00',4.34),('8784','2013-08-12','15:00:00',4.29),('8784','2013-08-12','15:05:00',3.78),('8784','2013-08-12','15:10:00',3.23),('8784','2013-08-12','15:15:00',2.81),('8784','2013-08-12','15:20:00',3.4),('8784','2013-08-12','15:25:00',3.61),('8784','2013-08-12','15:30:00',3.54),('8784','2013-08-12','15:35:00',3.46),('8784','2013-08-12','15:40:00',3.44),('8784','2013-08-12','15:45:00',3.39),('8784','2013-08-12','15:50:00',3.35),('8784','2013-08-12','15:55:00',3.27),('8784','2013-08-12','16:00:00',3.22),('8784','2013-08-12','16:05:00',3.12),('8784','2013-08-12','16:10:00',3.06),('8784','2013-08-12','16:15:00',2.96),('8784','2013-08-12','16:20:00',2.95),('8784','2013-08-12','16:25:00',2.91),('8784','2013-08-12','16:30:00',2.81),('8784','2013-08-12','16:35:00',2.77),('8784','2013-08-12','16:40:00',2.57),('8784','2013-08-12','16:45:00',2.57),('8784','2013-08-12','16:50:00',2.45),('8784','2013-08-12','16:55:00',2.53),('8784','2013-08-12','17:00:00',2.42),('8784','2013-08-12','17:05:00',2.35),('8784','2013-08-12','17:10:00',2.24),('8784','2013-08-12','17:15:00',2.17),('8784','2013-08-12','17:20:00',2.1),('8784','2013-08-12','17:25:00',2.04),('8784','2013-08-12','17:30:00',1.95),('8784','2013-08-12','17:35:00',1.88),('8784','2013-08-12','17:40:00',1.78),('8784','2013-08-12','17:45:00',1.7),('8784','2013-08-12','17:50:00',1.63),('8784','2013-08-12','17:55:00',1.56),('8784','2013-08-12','18:00:00',1.48),('8784','2013-08-12','18:05:00',1.38),('8784','2013-08-12','18:10:00',1.31),('8784','2013-08-12','18:15:00',1.24),('8784','2013-08-12','18:20:00',1.17),('8784','2013-08-12','18:25:00',1.11),('8784','2013-08-12','18:30:00',1.03),('8784','2013-08-11','07:50:00',1.07),('8784','2013-08-11','07:55:00',1.14),('8784','2013-08-11','08:00:00',1.23),('8784','2013-08-11','08:05:00',1.31),('8784','2013-08-11','08:10:00',1.39),('8784','2013-08-11','08:15:00',1.48),('8784','2013-08-11','08:20:00',1.55),('8784','2013-08-11','08:25:00',1.61),('8784','2013-08-11','08:30:00',1.71),('8784','2013-08-11','08:35:00',1.77),('8784','2013-08-11','08:40:00',1.87),('8784','2013-08-11','08:45:00',1.94),('8784','2013-08-11','08:50:00',1.98),('8784','2013-08-11','08:55:00',2.07),('8784','2013-08-11','09:00:00',2.16),('8784','2013-08-11','09:05:00',2.25),('8784','2013-08-11','09:10:00',2.28),('8784','2013-08-11','09:15:00',2.42),('8784','2013-08-11','09:20:00',2.47),('8784','2013-08-11','09:25:00',2.58),('8784','2013-08-11','09:30:00',2.65),('8784','2013-08-11','09:35:00',2.72),('8784','2013-08-11','09:40:00',2.78),('8784','2013-08-11','09:45:00',2.86),('8784','2013-08-11','09:50:00',2.92),('8784','2013-08-11','09:55:00',2.98),('8784','2013-08-11','10:00:00',3.04),('8784','2013-08-11','10:05:00',3.11),('8784','2013-08-11','10:10:00',3.15),('8784','2013-08-11','10:15:00',3.23),('8784','2013-08-11','10:20:00',3.27),('8784','2013-08-11','10:25:00',3.33),('8784','2013-08-11','10:30:00',3.38),('8784','2013-08-11','10:35:00',3.42),('8784','2013-08-11','10:40:00',3.45),('8784','2013-08-11','10:45:00',3.5),('8784','2013-08-11','10:50:00',3.54),('8784','2013-08-11','10:55:00',3.6),('8784','2013-08-11','11:00:00',3.64),('8784','2013-08-11','11:05:00',3.7),('8784','2013-08-11','11:10:00',3.75),('8784','2013-08-11','11:15:00',3.76),('8784','2013-08-11','11:20:00',3.76),('8784','2013-08-11','11:25:00',3.77),('8784','2013-08-11','11:30:00',3.85),('8784','2013-08-11','11:35:00',3.87),('8784','2013-08-11','11:40:00',3.9),('8784','2013-08-11','11:45:00',3.92),('8784','2013-08-11','11:50:00',3.91),('8784','2013-08-11','11:55:00',3.97),('8784','2013-08-11','12:00:00',4.01),('8784','2013-08-11','12:05:00',3.99),('8784','2013-08-11','12:10:00',4.02),('8784','2013-08-11','12:15:00',4.02),('8784','2013-08-11','12:20:00',4.03),('8784','2013-08-11','12:25:00',4.03),('8784','2013-08-11','12:30:00',4.07),('8784','2013-08-11','12:35:00',4.08),('8784','2013-08-11','12:40:00',4.06),('8784','2013-08-11','12:45:00',4.1),('8784','2013-08-11','12:50:00',4.06),('8784','2013-08-11','12:55:00',4.06),('8784','2013-08-11','13:00:00',4.07),('8784','2013-08-11','13:05:00',4.08),('8784','2013-08-11','13:10:00',4.02),('8784','2013-08-11','13:15:00',4.05),('8784','2013-08-11','13:20:00',3.99),('8784','2013-08-11','13:25:00',4.02),('8784','2013-08-11','13:30:00',4.02),('8784','2013-08-11','13:35:00',4.08),('8784','2013-08-11','13:40:00',4.05),('8784','2013-08-11','13:45:00',4.03),('8784','2013-08-11','13:50:00',3.99),('8784','2013-08-11','13:55:00',3.99),('8784','2013-08-11','14:00:00',3.98),('8784','2013-08-11','14:05:00',3.96),('8784','2013-08-11','14:10:00',3.95),('8784','2013-08-11','14:15:00',3.94),('8784','2013-08-11','14:20:00',3.84),('8784','2013-08-11','14:25:00',3.83),('8784','2013-08-11','14:30:00',3.83),('8784','2013-08-11','14:35:00',3.73),('8784','2013-08-11','14:40:00',3.77),('8784','2013-08-11','14:45:00',3.79),('8784','2013-08-11','14:50:00',3.76),('8784','2013-08-11','14:55:00',3.65),('8784','2013-08-11','15:00:00',2.65),('8784','2013-08-11','15:05:00',3.07),('8784','2013-08-11','15:10:00',3.6),('8784','2013-08-11','15:15:00',3.51),('8784','2013-08-11','15:20:00',3.08),('8784','2013-08-11','15:25:00',3.03),('8784','2013-08-11','15:30:00',3.08),('8784','2013-08-11','15:35:00',3.34),('8784','2013-08-11','15:40:00',3.33),('8784','2013-08-11','15:45:00',3.3),('8784','2013-08-11','15:50:00',3.27),('8784','2013-08-11','15:55:00',3.26),('8784','2013-08-11','16:00:00',3.18),('8784','2013-08-11','16:05:00',3.13),('8784','2013-08-11','16:10:00',3.09),('8784','2013-08-11','16:15:00',2.98),('8784','2013-08-11','16:20:00',2.95),('8784','2013-08-11','16:25:00',2.88),('8784','2013-08-11','16:30:00',2.82),('8784','2013-08-11','16:35:00',2.77),('8784','2013-08-11','16:40:00',2.69),('8784','2013-08-11','16:45:00',2.61),('8784','2013-08-11','16:50:00',2.54),('8784','2013-08-11','16:55:00',2.48),('8784','2013-08-11','17:00:00',2.41),('8784','2013-08-11','17:05:00',2.33),('8784','2013-08-11','17:10:00',2.26),('8784','2013-08-11','17:15:00',2.2),('8784','2013-08-11','17:20:00',2.11),('8784','2013-08-11','17:25:00',2.03),('8784','2013-08-11','17:30:00',1.96),('8784','2013-08-11','17:35:00',1.89),('8784','2013-08-11','17:40:00',1.8),('8784','2013-08-11','17:45:00',1.72),('8784','2013-08-11','17:50:00',1.64),('8784','2013-08-11','17:55:00',1.54),('8784','2013-08-11','18:00:00',1.44),('8784','2013-08-11','18:05:00',1.38),('8784','2013-08-11','18:10:00',1.25),('8784','2013-08-11','18:15:00',1.2),('8784','2013-08-11','18:20:00',1.14),('8784','2013-08-11','18:25:00',1.07),('8784','2013-08-10','07:50:00',1.06),('8784','2013-08-10','07:55:00',1.14),('8784','2013-08-10','08:00:00',1.23),('8784','2013-08-10','08:05:00',1.32),('8784','2013-08-10','08:10:00',1.38),('8784','2013-08-10','08:15:00',1.49),('8784','2013-08-10','08:20:00',1.61),('8784','2013-08-10','08:25:00',1.65),('8784','2013-08-10','08:30:00',1.78),('8784','2013-08-10','08:35:00',1.86),('8784','2013-08-10','08:40:00',1.94),('8784','2013-08-10','08:45:00',2.01),('8784','2013-08-10','08:50:00',2.1),('8784','2013-08-10','08:55:00',2.18),('8784','2013-08-10','09:00:00',2.25),('8784','2013-08-10','09:05:00',2.32),('8784','2013-08-10','09:10:00',2.37),('8784','2013-08-10','09:15:00',2.49),('8784','2013-08-10','09:20:00',2.56),('8784','2013-08-10','09:25:00',2.56),('8784','2013-08-10','09:30:00',2.6),('8784','2013-08-10','09:35:00',2.76),('8784','2013-08-10','09:40:00',2.82),('8784','2013-08-10','09:45:00',2.8),('8784','2013-08-10','09:50:00',2.95),('8784','2013-08-10','09:55:00',3.01),('8784','2013-08-10','10:00:00',3.05),('8784','2013-08-10','10:05:00',3.12),('8784','2013-08-10','10:30:00',3.39),('8784','2013-08-10','10:35:00',3.38),('8784','2013-08-10','10:40:00',3.45),('8784','2013-08-10','10:45:00',3.42),('8784','2013-08-10','10:50:00',3.54),('8784','2013-08-10','10:55:00',3.62),('8784','2013-08-10','11:00:00',3.73),('8784','2013-08-10','11:05:00',3.76),('8784','2013-08-10','11:10:00',3.9),('8784','2013-08-10','11:15:00',3.77),('8784','2013-08-10','11:20:00',3.68),('8784','2013-08-10','11:25:00',2.87),('8784','2013-08-10','11:30:00',3.88),('8784','2013-08-10','11:35:00',3.75),('8784','2013-08-10','11:40:00',3.96),('8784','2013-08-10','11:45:00',3.97),('8784','2013-08-10','11:50:00',3.98),('8784','2013-08-10','11:55:00',4.03),('8784','2013-08-10','12:00:00',4.04),('8784','2013-08-10','12:05:00',4.05),('8784','2013-08-10','12:10:00',4.05),('8784','2013-08-10','12:15:00',4.05),('8784','2013-08-10','12:20:00',4.05),('8784','2013-08-10','12:25:00',4.09),('8784','2013-08-10','12:30:00',4.12),('8784','2013-08-10','12:35:00',4.14),('8784','2013-08-10','12:40:00',4.17),('8784','2013-08-10','12:45:00',4.22),('8784','2013-08-10','12:50:00',4.33),('8784','2013-08-10','12:55:00',4.28),('8784','2013-08-10','13:00:00',4.25),('8784','2013-08-10','13:05:00',4.17),('8784','2013-08-10','13:10:00',4.25),('8784','2013-08-10','13:15:00',4.39),('8784','2013-08-10','13:20:00',4.31),('8784','2013-08-10','13:25:00',4.49),('8784','2013-08-10','13:30:00',4.6),('8784','2013-08-10','13:35:00',2.76),('8784','2013-08-10','13:40:00',1.57),('8784','2013-08-10','13:50:00',2.35),('8784','2013-08-10','13:55:00',4.39),('8784','2013-08-10','14:00:00',4.49),('8784','2013-08-10','14:05:00',4.32),('8784','2013-08-10','14:10:00',3.65),('8784','2013-08-10','14:15:00',4.69),('8784','2013-08-10','14:20:00',2.82),('8784','2013-08-10','14:25:00',1.39),('8784','2013-08-10','14:30:00',1.31),('8784','2013-08-10','14:35:00',1.17),('8784','2013-08-10','14:40:00',1.08),('8784','2013-08-10','14:45:00',1.04),('8784','2013-08-10','15:00:00',1.09),('8784','2013-08-10','15:05:00',1.14),('8784','2013-08-10','15:10:00',1.21),('8784','2013-08-10','15:15:00',1.34),('8784','2013-08-10','15:20:00',1.32),('8784','2013-08-10','15:25:00',1.17),('8784','2013-08-10','15:30:00',1.14),('8784','2013-08-10','15:35:00',1.44),('8784','2013-08-10','15:40:00',1.38),('8784','2013-08-10','15:45:00',1.55),('8784','2013-08-10','15:50:00',1.95),('8784','2013-08-10','15:55:00',2.19),('8784','2013-08-10','16:00:00',2.36),('8784','2013-08-10','16:05:00',4.49),('8784','2013-08-10','16:10:00',2.58),('8784','2013-08-10','16:15:00',2.4),('8784','2013-08-10','16:20:00',3.58),('8784','2013-08-10','16:25:00',1.16),('8784','2013-08-10','16:30:00',2.04),('8784','2013-08-10','16:35:00',2.38),('8784','2013-08-10','16:40:00',2.64),('8784','2013-08-10','16:45:00',2.98),('8784','2013-08-10','16:50:00',2.81),('8784','2013-08-10','16:55:00',2.66),('8784','2013-08-10','17:00:00',2.04),('8784','2013-08-10','17:05:00',1.7),('8784','2013-08-10','17:10:00',1.11),('8784','2013-08-10','17:15:00',1.2),('8784','2013-08-10','17:20:00',1.25),('8784','2013-08-10','17:25:00',1.56),('8784','2014-04-09','08:05:00',1.19),('8784','2014-04-09','08:10:00',1.04),('8784','2014-04-09','08:15:00',1.02),('8784','2014-04-09','08:20:00',1.23),('8784','2014-04-09','09:00:00',1.09),('8784','2014-04-09','09:25:00',1.01),('8784','2014-04-09','09:30:00',1.05),('8784','2014-04-09','09:50:00',2.41),('8784','2014-04-09','09:55:00',2.93),('8784','2014-04-09','10:00:00',2.96),('8784','2014-04-09','10:05:00',2.98),('8784','2014-04-09','10:10:00',3.1),('8784','2014-04-09','10:15:00',3.15),('8784','2014-04-09','10:20:00',3.31),('8784','2014-04-09','10:25:00',3.53),('8784','2014-04-09','10:30:00',3.47),('8784','2014-04-09','10:35:00',2.57),('8784','2014-04-09','10:40:00',1.52),('8784','2014-04-09','10:45:00',2.04),('8784','2014-04-09','10:50:00',1.28),('8784','2014-04-09','10:55:00',3.53),('8784','2014-04-09','11:00:00',3.37),('8784','2014-04-09','11:05:00',4.3),('8784','2014-04-09','11:10:00',4.34),('8784','2014-04-09','11:15:00',4.46),('8784','2014-04-09','11:20:00',3.67),('8784','2014-04-09','11:25:00',1.6),('8784','2014-04-09','11:30:00',1.2),('8784','2014-04-09','11:35:00',4.34),('8784','2014-04-09','11:40:00',4.56),('8784','2014-04-09','11:45:00',2.81),('8784','2014-04-09','11:50:00',4.21),('8784','2014-04-09','11:55:00',4.71),('8784','2014-04-09','12:00:00',4.78),('8784','2014-04-09','12:05:00',4.52),('8784','2014-04-09','12:10:00',3.86),('8784','2014-04-09','12:15:00',1.93),('8784','2014-04-09','12:20:00',1.52),('8784','2014-04-09','12:25:00',1.12),('8784','2014-04-09','13:15:00',1.1),('8784','2014-04-09','13:20:00',1.55),('8784','2014-04-09','13:25:00',1.49),('8784','2014-04-09','13:30:00',1.27),('8784','2014-04-09','13:35:00',1.27),('8784','2014-04-09','13:40:00',1.08),('8784','2014-04-09','14:00:00',1.14),('8784','2014-04-09','14:05:00',1.57),('8784','2014-04-09','14:10:00',1.7),('8784','2014-04-09','14:15:00',1.64),('8784','2014-04-09','14:20:00',1.5),('8784','2014-04-09','14:25:00',1.51),('8784','2014-04-09','14:30:00',1.77),('8784','2014-04-09','14:35:00',1.97),('8784','2014-04-09','14:40:00',1.94),('8784','2014-04-09','14:45:00',2.24),('8784','2014-04-09','14:50:00',2.27),('8784','2014-04-09','14:55:00',2.72),('8784','2014-04-09','15:00:00',2.1),('8784','2014-04-09','15:05:00',3.67),('8784','2014-04-09','15:10:00',4.31),('8784','2014-04-09','15:15:00',4.11),('8784','2014-04-09','15:20:00',4.05),('8784','2014-04-09','15:25:00',3.01),('8784','2014-04-09','15:30:00',2.53),('8784','2014-04-09','15:35:00',2.2),('8784','2014-04-09','15:40:00',2.25),('8784','2014-04-09','15:45:00',1.9),('8784','2014-04-09','15:50:00',1.42),('8784','2014-04-09','15:55:00',1.28),('8784','2014-04-09','16:00:00',1.56),('8784','2014-04-09','16:05:00',2.17),('8784','2014-04-09','16:10:00',2.86),('8784','2014-04-09','16:15:00',3.03),('8784','2014-04-09','16:20:00',2.96),('8784','2014-04-09','16:25:00',2.83),('8784','2014-04-09','16:30:00',3.15),('8784','2014-04-09','16:35:00',3),('8784','2014-04-09','16:40:00',2.45),('8784','2014-04-09','16:45:00',2.62),('8784','2014-04-09','16:50:00',2.95),('8784','2014-04-09','16:55:00',1.98),('8784','2014-04-09','17:00:00',2),('8784','2014-04-09','17:05:00',2.79),('8784','2014-04-09','17:10:00',2.24),('8784','2014-04-09','17:15:00',1.97),('8784','2014-04-09','17:20:00',1.9),('8784','2014-04-09','17:25:00',1.86),('8784','2014-04-09','17:30:00',1.51),('8784','2014-04-09','17:45:00',1.26),('8784','2014-04-09','17:50:00',1.26),('8784','2014-04-09','17:55:00',1.23),('8784','2014-04-09','18:00:00',1.05),('8784','2013-08-09','08:00:00',1.08),('8784','2013-08-09','08:05:00',1.2),('8784','2013-08-09','08:35:00',1.12),('8784','2013-08-09','08:40:00',1.63),('8784','2013-08-09','08:45:00',1.82),('8784','2013-08-09','08:50:00',1.94),('8784','2013-08-09','08:55:00',1.99),('8784','2013-08-09','09:00:00',2.07),('8784','2013-08-09','09:05:00',2.19),('8784','2013-08-09','09:10:00',1.88),('8784','2013-08-09','09:15:00',2.27),('8784','2013-08-09','09:20:00',1.83),('8784','2013-08-09','09:25:00',1.77),('8784','2013-08-09','09:30:00',1.74),('8784','2013-08-09','09:35:00',2.17),('8784','2013-08-09','09:40:00',2.07),('8784','2013-08-09','09:45:00',2.62),('8784','2013-08-09','09:50:00',2.16),('8784','2013-08-09','09:55:00',1.67),('8784','2013-08-09','10:00:00',1.98),('8784','2013-08-09','10:05:00',1.97),('8784','2013-08-09','10:10:00',2.46),('8784','2013-08-09','10:15:00',2.91),('8784','2013-08-09','10:20:00',2.88),('8784','2013-08-09','10:25:00',2.94),('8784','2013-08-09','10:30:00',2.69),('8784','2013-08-09','10:35:00',2.56),('8784','2013-08-09','10:40:00',2.89),('8784','2013-08-09','10:45:00',3.17),('8784','2013-08-09','10:50:00',3.16),('8784','2013-08-09','10:55:00',3.28),('8784','2013-08-09','11:00:00',3.36),('8784','2013-08-09','11:05:00',3.37),('8784','2013-08-09','11:10:00',3.39),('8784','2013-08-09','11:15:00',3.49),('8784','2013-08-09','11:20:00',3.49),('8784','2013-08-09','11:25:00',3.52),('8784','2013-08-09','11:30:00',3.55),('8784','2013-08-09','11:35:00',3.54),('8784','2013-08-09','11:40:00',3.64),('8784','2013-08-09','11:45:00',3.64),('8784','2013-08-09','11:50:00',3.64),('8784','2013-08-09','11:55:00',3.66),('8784','2013-08-09','12:00:00',3.69),('8784','2013-08-09','12:05:00',3.69),('8784','2013-08-09','12:10:00',3.7),('8784','2013-08-09','12:15:00',3.78),('8784','2013-08-09','12:20:00',3.87),('8784','2013-08-09','12:25:00',2.89),('8784','2013-08-09','12:30:00',2.44),('8784','2013-08-09','12:35:00',2.79),('8784','2013-08-09','12:40:00',4.14),('8784','2013-08-09','12:45:00',3.11),('8784','2013-08-09','12:50:00',2.26),('8784','2013-08-09','12:55:00',3.03),('8784','2013-08-09','13:00:00',1.32),('8784','2013-08-09','13:15:00',1.16),('8784','2013-08-09','13:20:00',1.62),('8784','2013-08-09','13:25:00',2.27),('8784','2013-08-09','13:30:00',1.99),('8784','2013-08-09','13:35:00',1.6),('8784','2013-08-09','13:40:00',1.56),('8784','2013-08-09','13:45:00',1.5),('8784','2013-08-09','13:50:00',1.59),('8784','2013-08-09','13:55:00',1.41),('8784','2013-08-09','14:00:00',1.35),('8784','2013-08-09','14:05:00',1.33),('8784','2013-08-09','14:10:00',1.54),('8784','2013-08-09','14:15:00',1.07),('8784','2013-08-09','14:25:00',1.09),('8784','2013-08-09','14:30:00',1.1),('8784','2013-08-09','15:05:00',1.36),('8784','2013-08-09','15:10:00',2.89),('8784','2013-08-09','15:15:00',2.65),('8784','2013-08-09','15:20:00',1.66),('8784','2013-08-09','15:25:00',1.27),('8784','2013-08-09','15:30:00',1.3),('8784','2013-08-09','15:35:00',2.28),('8784','2013-08-09','15:40:00',1.76),('8784','2013-08-09','15:45:00',2.61),('8784','2013-08-09','15:50:00',2.19),('8784','2013-08-09','15:55:00',1.89),('8784','2013-08-09','16:00:00',1.24),('8784','2013-08-09','16:50:00',1.61),('8784','2013-08-09','16:55:00',2.48),('8784','2013-08-09','17:00:00',1.61),('8784','2013-08-09','17:05:00',1.84),('8784','2013-08-09','17:10:00',1.05),('8784','2013-08-09','19:20:00',1.11),('8784','2013-08-09','19:25:00',1.1),('8784','2013-08-08','07:55:00',1.03),('8784','2013-08-08','08:00:00',1.1),('8784','2013-08-08','08:05:00',1.18),('8784','2013-08-08','08:10:00',1.27),('8784','2013-08-08','08:15:00',1.35),('8784','2013-08-08','08:20:00',1.42),('8784','2013-08-08','08:25:00',1.5),('8784','2013-08-08','08:30:00',1.58),('8784','2013-08-08','08:35:00',1.66),('8784','2013-08-08','08:40:00',1.73),('8784','2013-08-08','08:45:00',1.81),('8784','2013-08-08','08:50:00',1.89),('8784','2013-08-08','08:55:00',1.97),('8784','2013-08-08','09:00:00',2.05),('8784','2013-08-08','09:05:00',2.12),('8784','2013-08-08','09:10:00',2.16),('8784','2013-08-08','09:15:00',2.26),('8784','2013-08-08','09:20:00',2.35),('8784','2013-08-08','09:25:00',2.42),('8784','2013-08-08','09:30:00',2.47),('8784','2013-08-08','09:35:00',2.51),('8784','2013-08-08','09:40:00',2.6),('8784','2013-08-08','09:45:00',2.66),('8784','2013-08-08','09:50:00',2.72),('8784','2013-08-08','09:55:00',2.78),('8784','2013-08-08','10:00:00',2.83),('8784','2013-08-08','10:05:00',2.88),('8784','2013-08-08','10:10:00',2.95),('8784','2013-08-08','10:15:00',3),('8784','2013-08-08','10:20:00',3.04),('8784','2013-08-08','10:25:00',3.09),('8784','2013-08-08','10:30:00',3.13),('8784','2013-08-08','10:35:00',3.17),('8784','2013-08-08','10:40:00',3.21),('8784','2013-08-08','10:45:00',3.27),('8784','2013-08-08','10:50:00',3.3),('8784','2013-08-08','10:55:00',3.29),('8784','2013-08-08','11:00:00',3.36),('8784','2013-08-08','11:05:00',3.39),('8784','2013-08-08','11:10:00',3.43),('8784','2013-08-08','11:15:00',3.47),('8784','2013-08-08','11:20:00',3.42),('8784','2013-08-08','11:25:00',3.5),('8784','2013-08-08','11:30:00',3.54),('8784','2013-08-08','11:35:00',3.51),('8784','2013-08-08','11:40:00',3.56),('8784','2013-08-08','11:45:00',3.59),('8784','2013-08-08','11:50:00',3.64),('8784','2013-08-08','11:55:00',3.65),('8784','2013-08-08','12:00:00',3.65),('8784','2013-08-08','12:05:00',3.69),('8784','2013-08-08','12:10:00',3.71),('8784','2013-08-08','12:15:00',3.68),('8784','2013-08-08','12:20:00',3.7),('8784','2013-08-08','12:25:00',3.71),('8784','2013-08-08','12:30:00',3.65),('8784','2013-08-08','12:35:00',3.76),('8784','2013-08-08','12:40:00',3.79),('8784','2013-08-08','12:45:00',3.81),('8784','2013-08-08','12:50:00',3.84),('8784','2013-08-08','12:55:00',3.82),('8784','2013-08-08','13:00:00',3.82),('8784','2013-08-08','13:05:00',3.87),('8784','2013-08-08','13:10:00',3.85),('8784','2013-08-08','13:15:00',3.82),('8784','2013-08-08','13:20:00',3.88),('8784','2013-08-08','13:25:00',3.87),('8784','2013-08-08','13:30:00',3.85),('8784','2013-08-08','13:35:00',3.84),('8784','2013-08-08','13:40:00',3.79),('8784','2013-08-08','13:45:00',3.81),('8784','2013-08-08','13:50:00',3.81),('8784','2013-08-08','13:55:00',3.78),('8784','2013-08-08','14:00:00',3.81),('8784','2013-08-08','14:05:00',3.78),('8784','2013-08-08','14:10:00',3.74),('8784','2013-08-08','14:15:00',3.72),('8784','2013-08-08','14:20:00',3.69),('8784','2013-08-08','14:25:00',3.67),('8784','2013-08-08','14:30:00',3.67),('8784','2013-08-08','14:35:00',3.64),('8784','2013-08-08','14:40:00',3.59),('8784','2013-08-08','14:45:00',3.56),('8784','2013-08-08','14:50:00',3.53),('8784','2013-08-08','14:55:00',3.49),('8784','2013-08-08','15:00:00',3.47),('8784','2013-08-08','15:05:00',3.44),('8784','2013-08-08','15:10:00',3.42),('8784','2013-08-08','15:15:00',3.35),('8784','2013-08-08','15:20:00',3.3),('8784','2013-08-08','15:25:00',3.26),('8784','2013-08-08','15:30:00',3.21),('8784','2013-08-08','15:35:00',3.18),('8784','2013-08-08','15:40:00',3.13),('8784','2013-08-08','15:45:00',3.1),('8784','2013-08-08','15:50:00',3.05),('8784','2013-08-08','15:55:00',3.01),('8784','2013-08-08','16:00:00',2.98),('8784','2013-08-08','16:05:00',2.93),('8784','2013-08-08','16:10:00',2.88),('8784','2013-08-08','16:15:00',2.86),('8784','2013-08-08','16:20:00',2.83),('8784','2013-08-08','16:25:00',2.77),('8784','2013-08-08','16:30:00',2.72),('8784','2013-08-08','16:35:00',2.67),('8784','2013-08-08','16:40:00',2.58),('8784','2013-08-08','16:45:00',2.52),('8784','2013-08-08','16:50:00',2.43),('8784','2013-08-08','16:55:00',2.36),('8784','2013-08-08','17:00:00',2.3),('8784','2013-08-08','17:05:00',2.21),('8784','2013-08-08','17:10:00',2.15),('8784','2013-08-08','17:15:00',2.08),('8784','2013-08-08','17:20:00',2),('8784','2013-08-08','17:25:00',1.91),('8784','2013-08-08','17:30:00',1.85),('8784','2013-08-08','17:35:00',1.76),('8784','2013-08-08','17:40:00',1.7),('8784','2013-08-08','17:45:00',1.63),('8784','2013-08-08','17:50:00',1.56),('8784','2013-08-08','17:55:00',1.49),('8784','2013-08-08','18:00:00',1.42),('8784','2013-08-08','18:05:00',1.34),('8784','2013-08-08','18:10:00',1.26),('8784','2013-08-08','18:15:00',1.19),('8784','2013-08-08','18:20:00',1.11),('8784','2013-08-08','18:25:00',1.04),('8784','2013-08-07','07:50:00',1.03),('8784','2013-08-07','07:55:00',1.11),('8784','2013-08-07','08:00:00',1.18),('8784','2013-08-07','08:05:00',1.25),('8784','2013-08-07','08:10:00',1.33),('8784','2013-08-07','08:15:00',1.41),('8784','2013-08-07','08:20:00',1.49),('8784','2013-08-07','08:25:00',1.57),('8784','2013-08-07','08:30:00',1.55),('8784','2013-08-07','08:35:00',1.63),('8784','2013-08-07','08:40:00',1.8),('8784','2013-08-07','08:45:00',1.88),('8784','2013-08-07','08:50:00',1.95),('8784','2013-08-07','08:55:00',2.02),('8784','2013-08-07','09:00:00',2.08),('8784','2013-08-07','09:05:00',2.16),('8784','2013-08-07','09:10:00',2.24),('8784','2013-08-07','09:15:00',2.31),('8784','2013-08-07','09:20:00',2.38),('8784','2013-08-07','09:25:00',2.45),('8784','2013-08-07','09:30:00',2.5),('8784','2013-08-07','09:35:00',2.58),('8784','2013-08-07','09:40:00',2.64),('8784','2013-08-07','09:45:00',2.7),('8784','2013-08-07','09:50:00',2.76),('8784','2013-08-07','09:55:00',2.82),('8784','2013-08-07','10:00:00',2.85),('8784','2013-08-07','10:05:00',2.96),('8784','2013-08-07','10:10:00',2.97),('8784','2013-08-07','10:15:00',3.04),('8784','2013-08-07','10:20:00',3.07),('8784','2013-08-07','10:25:00',3.14),('8784','2013-08-07','10:30:00',3.19),('8784','2013-08-07','10:35:00',3.22),('8784','2013-08-07','10:40:00',3.25),('8784','2013-08-07','10:45:00',3.28),('8784','2013-08-07','10:50:00',3.33),('8784','2013-08-07','10:55:00',3.37),('8784','2013-08-07','11:00:00',3.39),('8784','2013-08-07','11:05:00',3.43),('8784','2013-08-07','11:10:00',3.45),('8784','2013-08-07','11:15:00',3.5),('8784','2013-08-07','11:20:00',3.53),('8784','2013-08-07','11:25:00',3.55),('8784','2013-08-07','11:30:00',3.57),('8784','2013-08-07','11:35:00',3.58),('8784','2013-08-07','11:40:00',3.6),('8784','2013-08-07','11:45:00',3.63),('8784','2013-08-07','11:50:00',3.66),('8784','2013-08-07','11:55:00',3.71),('8784','2013-08-07','12:00:00',3.71),('8784','2013-08-07','12:05:00',3.72),('8784','2013-08-07','12:10:00',3.75),('8784','2013-08-07','12:15:00',3.69),('8784','2013-08-07','12:20:00',3.68),('8784','2013-08-07','12:25:00',3.71),('8784','2013-08-07','12:30:00',3.75),('8784','2013-08-07','12:35:00',3.75),('8784','2013-08-07','12:40:00',3.78),('8784','2013-08-07','12:45:00',3.82),('8784','2013-08-07','12:50:00',3.82),('8784','2013-08-07','12:55:00',3.8),('8784','2013-08-07','13:00:00',3.76),('8784','2013-08-07','13:05:00',3.93),('8784','2013-08-07','13:10:00',3.91),('8784','2013-08-07','13:15:00',3.93),('8784','2013-08-07','13:20:00',3.88),('8784','2013-08-07','13:25:00',3.81),('8784','2013-08-07','13:30:00',3.88),('8784','2013-08-07','13:35:00',3.83),('8784','2013-08-07','13:40:00',3.91),('8784','2013-08-07','13:45:00',3.84),('8784','2013-08-07','13:50:00',3.86),('8784','2013-08-07','13:55:00',3.88),('8784','2013-08-07','14:00:00',3.86),('8784','2013-08-07','14:05:00',3.82),('8784','2013-08-07','14:10:00',3.74),('8784','2013-08-07','14:15:00',3.72),('8784','2013-08-07','14:20:00',3.67),('8784','2013-08-07','14:25:00',3.66),('8784','2013-08-07','14:30:00',3.58),('8784','2013-08-07','14:35:00',3.55),('8784','2013-08-07','14:40:00',3.58),('8784','2013-08-07','14:45:00',3.57),('8784','2013-08-07','14:50:00',3.6),('8784','2013-08-07','14:55:00',3.55),('8784','2013-08-07','15:00:00',3.54),('8784','2013-08-07','15:05:00',3.49),('8784','2013-08-07','15:10:00',3.43),('8784','2013-08-07','15:15:00',3.42),('8784','2013-08-07','15:20:00',3.4),('8784','2013-08-07','15:25:00',3.31),('8784','2013-08-07','15:30:00',3.31),('8784','2013-08-07','15:35:00',3.28),('8784','2013-08-07','15:40:00',3.23),('8784','2013-08-07','15:45:00',3.2),('8784','2013-08-07','15:50:00',3.13),('8784','2013-08-07','15:55:00',3.07),('8784','2013-08-07','16:00:00',3),('8784','2013-08-07','16:05:00',2.94),('8784','2013-08-07','16:10:00',2.87),('8784','2013-08-07','16:15:00',2.83),('8784','2013-08-07','16:20:00',2.78),('8784','2013-08-07','16:25:00',2.74),('8784','2013-08-07','16:30:00',2.71),('8784','2013-08-07','16:35:00',2.67),('8784','2013-08-07','16:40:00',2.59),('8784','2013-08-07','16:45:00',2.55),('8784','2013-08-07','16:50:00',2.48),('8784','2013-08-07','16:55:00',2.44),('8784','2013-08-07','17:00:00',2.37),('8784','2013-08-07','17:05:00',2.29),('8784','2013-08-07','17:10:00',2.21),('8784','2013-08-07','17:15:00',2.14),('8784','2013-08-07','17:20:00',2.08),('8784','2013-08-07','17:25:00',1.97),('8784','2013-08-07','17:30:00',1.89),('8784','2013-08-07','17:35:00',1.83),('8784','2013-08-07','17:40:00',1.74),('8784','2013-08-07','17:45:00',1.67),('8784','2013-08-07','17:50:00',1.59),('8784','2013-08-07','17:55:00',1.51),('8784','2013-08-07','18:00:00',1.44),('8784','2013-08-07','18:05:00',1.34),('8784','2013-08-07','18:10:00',1.24),('8784','2013-08-07','18:15:00',1.19),('8784','2013-08-07','18:20:00',1.12),('8784','2013-08-07','18:25:00',1.06),('8784','2013-08-06','07:55:00',1.07),('8784','2013-08-06','08:00:00',1.14),('8784','2013-08-06','08:05:00',1.22),('8784','2013-08-06','08:10:00',1.3),('8784','2013-08-06','08:15:00',1.38),('8784','2013-08-06','08:20:00',1.46),('8784','2013-08-06','08:25:00',1.52),('8784','2013-08-06','08:30:00',1.6),('8784','2013-08-06','08:35:00',1.66),('8784','2013-08-06','08:40:00',1.74),('8784','2013-08-06','08:45:00',1.84),('8784','2013-08-06','08:50:00',1.93),('8784','2013-08-06','08:55:00',2),('8784','2013-08-06','09:00:00',2.07),('8784','2013-08-06','09:05:00',2.14),('8784','2013-08-06','09:10:00',2.21),('8784','2013-08-06','09:15:00',2.3),('8784','2013-08-06','09:20:00',2.36),('8784','2013-08-06','09:25:00',2.43),('8784','2013-08-06','09:30:00',2.49),('8784','2013-08-06','09:35:00',2.57),('8784','2013-08-06','09:40:00',2.63),('8784','2013-08-06','09:45:00',2.69),('8784','2013-08-06','09:50:00',2.74),('8784','2013-08-06','09:55:00',2.8),('8784','2013-08-06','10:00:00',2.87),('8784','2013-08-06','10:05:00',2.93),('8784','2013-08-06','10:10:00',2.97),('8784','2013-08-06','10:15:00',3.03),('8784','2013-08-06','10:20:00',3.07),('8784','2013-08-06','10:25:00',3.11),('8784','2013-08-06','10:30:00',3.16),('8784','2013-08-06','10:35:00',3.16),('8784','2013-08-06','10:40:00',3.24),('8784','2013-08-06','10:45:00',3.27),('8784','2013-08-06','10:50:00',3.32),('8784','2013-08-06','10:55:00',3.36),('8784','2013-08-06','11:00:00',3.41),('8784','2013-08-06','11:05:00',3.42),('8784','2013-08-06','11:10:00',3.44),('8784','2013-08-06','11:15:00',3.45),('8784','2013-08-06','11:20:00',3.5),('8784','2013-08-06','11:25:00',3.55),('8784','2013-08-06','11:30:00',3.58),('8784','2013-08-06','11:35:00',3.61),('8784','2013-08-06','11:40:00',3.64),('8784','2013-08-06','11:45:00',3.63),('8784','2013-08-06','11:50:00',3.63),('8784','2013-08-06','11:55:00',3.68),('8784','2013-08-06','12:00:00',3.69),('8784','2013-08-06','12:05:00',3.7),('8784','2013-08-06','12:10:00',3.71),('8784','2013-08-06','12:15:00',3.69),('8784','2013-08-06','12:20:00',3.71),('8784','2013-08-06','12:25:00',3.74),('8784','2013-08-06','12:30:00',3.71),('8784','2013-08-06','12:35:00',3.73),('8784','2013-08-06','12:40:00',3.75),('8784','2013-08-06','12:45:00',3.82),('8784','2013-08-06','12:50:00',3.8),('8784','2013-08-06','12:55:00',3.79),('8784','2013-08-06','13:00:00',3.79),('8784','2013-08-06','13:05:00',3.75),('8784','2013-08-06','13:10:00',3.86),('8784','2013-08-06','13:15:00',3.89),('8784','2013-08-06','13:20:00',3.87),('8784','2013-08-06','13:25:00',3.81),('8784','2013-08-06','13:30:00',3.9),('8784','2013-08-06','13:35:00',3.91),('8784','2013-08-06','13:40:00',3.88),('8784','2013-08-06','13:45:00',3.9),('8784','2013-08-06','13:50:00',3.93),('8784','2013-08-06','13:55:00',3.93),('8784','2013-08-06','14:00:00',3.93),('8784','2013-08-06','14:05:00',3.92),('8784','2013-08-06','14:10:00',3.9),('8784','2013-08-06','14:15:00',3.9),('8784','2013-08-06','14:20:00',3.88),('8784','2013-08-06','14:25:00',3.86),('8784','2013-08-06','14:30:00',3.82),('8784','2013-08-06','14:35:00',3.8),('8784','2013-08-06','14:40:00',3.77),('8784','2013-08-06','14:45:00',3.75),('8784','2013-08-06','14:50:00',3.73),('8784','2013-08-06','14:55:00',3.69),('8784','2013-08-06','15:00:00',3.67),('8784','2013-08-06','15:05:00',3.64),('8784','2013-08-06','15:10:00',3.6),('8784','2013-08-06','15:15:00',3.58),('8784','2013-08-06','15:20:00',3.54),('8784','2013-08-06','15:25:00',3.45),('8784','2013-08-06','15:30:00',3.45),('8784','2013-08-06','15:35:00',3.41),('8784','2013-08-06','15:40:00',3.37),('8784','2013-08-06','15:45:00',3.3),('8784','2013-08-06','15:50:00',3.26),('8784','2013-08-06','15:55:00',3.2),('8784','2013-08-06','16:00:00',3.15),('8784','2013-08-06','16:05:00',3.09),('8784','2013-08-06','16:10:00',3.04),('8784','2013-08-06','16:15:00',3),('8784','2013-08-06','16:20:00',2.93),('8784','2013-08-06','16:25:00',2.86),('8784','2013-08-06','16:30:00',2.79),('8784','2013-08-06','16:35:00',2.73),('8784','2013-08-06','16:40:00',2.66),('8784','2013-08-06','16:45:00',2.6),('8784','2013-08-06','16:50:00',2.53),('8784','2013-08-06','16:55:00',2.48),('8784','2013-08-06','17:00:00',2.42),('8784','2013-08-06','17:05:00',2.35),('8784','2013-08-06','17:10:00',2.23),('8784','2013-08-06','17:15:00',2.19),('8784','2013-08-06','17:20:00',2.12),('8784','2013-08-06','17:25:00',2.05),('8784','2013-08-06','17:30:00',1.97),('8784','2013-08-06','17:35:00',1.89),('8784','2013-08-06','17:40:00',1.81),('8784','2013-08-06','17:45:00',1.73),('8784','2013-08-06','17:50:00',1.65),('8784','2013-08-06','17:55:00',1.57),('8784','2013-08-06','18:00:00',1.49),('8784','2013-08-06','18:05:00',1.41),('8784','2013-08-06','18:10:00',1.34),('8784','2013-08-06','18:15:00',1.26),('8784','2013-08-06','18:20:00',1.19),('8784','2013-08-06','18:25:00',1.09),('8784','2013-08-06','18:30:00',1.04),('8784','2013-08-05','07:50:00',1.07),('8784','2013-08-05','07:55:00',1.16),('8784','2013-08-05','08:00:00',1.23),('8784','2013-08-05','08:05:00',1.3),('8784','2013-08-05','08:10:00',1.39),('8784','2013-08-05','08:15:00',1.46),('8784','2013-08-05','08:20:00',1.54),('8784','2013-08-05','08:25:00',1.61),('8784','2013-08-05','08:30:00',1.68),('8784','2013-08-05','08:35:00',1.75),('8784','2013-08-05','08:40:00',1.83),('8784','2013-08-05','08:45:00',1.9),('8784','2013-08-05','08:50:00',1.97),('8784','2013-08-05','08:55:00',2.05),('8784','2013-08-05','09:00:00',2.11),('8784','2013-08-05','09:05:00',2.15),('8784','2013-08-05','09:10:00',2.24),('8784','2013-08-05','09:15:00',2.33),('8784','2013-08-05','09:20:00',2.38),('8784','2013-08-05','09:25:00',2.4),('8784','2013-08-05','09:30:00',2.49),('8784','2013-08-05','09:35:00',2.57),('8784','2013-08-05','09:40:00',2.65),('8784','2013-08-05','09:45:00',2.7),('8784','2013-08-05','09:50:00',2.75),('8784','2013-08-05','09:55:00',2.82),('8784','2013-08-05','10:00:00',2.89),('8784','2013-08-05','10:05:00',2.94),('8784','2013-08-05','10:10:00',2.99),('8784','2013-08-05','10:15:00',3.06),('8784','2013-08-05','10:20:00',3.08),('8784','2013-08-05','10:25:00',3.16),('8784','2013-08-05','10:30:00',3.18),('8784','2013-08-05','10:35:00',3.22),('8784','2013-08-05','10:40:00',3.28),('8784','2013-08-05','10:45:00',3.34),('8784','2013-08-05','10:50:00',3.38),('8784','2013-08-05','10:55:00',3.43),('8784','2013-08-05','11:00:00',3.46),('8784','2013-08-05','11:05:00',3.51),('8784','2013-08-05','11:10:00',3.53),('8784','2013-08-05','11:15:00',3.57),('8784','2013-08-05','11:20:00',3.61),('8784','2013-08-05','11:25:00',3.64),('8784','2013-08-05','11:30:00',3.66),('8784','2013-08-05','11:35:00',3.73),('8784','2013-08-05','11:40:00',3.74),('8784','2013-08-05','11:45:00',3.72),('8784','2013-08-05','11:50:00',3.75),('8784','2013-08-05','11:55:00',3.79),('8784','2013-08-05','12:00:00',3.82),('8784','2013-08-05','12:05:00',3.82),('8784','2013-08-05','12:10:00',3.84),('8784','2013-08-05','12:15:00',3.83),('8784','2013-08-05','12:20:00',3.83),('8784','2013-08-05','12:25:00',3.89),('8784','2013-08-05','12:30:00',3.9),('8784','2013-08-05','12:35:00',3.88),('8784','2013-08-05','12:40:00',3.91),('8784','2013-08-05','12:45:00',3.91),('8784','2013-08-05','12:50:00',3.89),('8784','2013-08-05','12:55:00',3.87),('8784','2013-08-05','13:00:00',3.88),('8784','2013-08-05','13:05:00',3.89),('8784','2013-08-05','13:10:00',3.89),('8784','2013-08-05','13:15:00',3.9),('8784','2013-08-05','13:20:00',3.85),('8784','2013-08-05','13:25:00',3.91),('8784','2013-08-05','13:30:00',3.9),('8784','2013-08-05','13:35:00',3.89),('8784','2013-08-05','13:40:00',3.87),('8784','2013-08-05','13:45:00',3.79),('8784','2013-08-05','13:50:00',3.84),('8784','2013-08-05','13:55:00',3.81),('8784','2013-08-05','14:00:00',3.83),('8784','2013-08-05','14:05:00',3.86),('8784','2013-08-05','14:10:00',3.83),('8784','2013-08-05','14:15:00',3.79),('8784','2013-08-05','14:20:00',3.78),('8784','2013-08-05','14:25:00',3.74),('8784','2013-08-05','14:30:00',3.71),('8784','2013-08-05','14:35:00',3.72),('8784','2013-08-05','14:40:00',3.71),('8784','2013-08-05','14:45:00',3.66),('8784','2013-08-05','14:50:00',3.62),('8784','2013-08-05','14:55:00',3.6),('8784','2013-08-05','15:00:00',3.57),('8784','2013-08-05','15:05:00',3.58),('8784','2013-08-05','15:10:00',3.54),('8784','2013-08-05','15:15:00',3.52),('8784','2013-08-05','15:20:00',3.48),('8784','2013-08-05','15:25:00',3.47),('8784','2013-08-05','15:30:00',3.44),('8784','2013-08-05','15:35:00',3.39),('8784','2013-08-05','15:40:00',3.33),('8784','2013-08-05','15:45:00',3.3),('8784','2013-08-05','15:50:00',3.25),('8784','2013-08-05','15:55:00',3.17),('8784','2013-08-05','16:00:00',3.16),('8784','2013-08-05','16:05:00',3.1),('8784','2013-08-05','16:10:00',3.06),('8784','2013-08-05','16:15:00',2.99),('8784','2013-08-05','16:20:00',2.91),('8784','2013-08-05','16:25:00',2.84),('8784','2013-08-05','16:30:00',2.78),('8784','2013-08-05','16:35:00',2.74),('8784','2013-08-05','16:40:00',2.66),('8784','2013-08-05','16:45:00',2.6),('8784','2013-08-05','16:50:00',2.53),('8784','2013-08-05','16:55:00',2.46),('8784','2013-08-05','17:00:00',2.38),('8784','2013-08-05','17:05:00',2.32),('8784','2013-08-05','17:10:00',2.24),('8784','2013-08-05','17:15:00',2.16),('8784','2013-08-05','17:20:00',2.09),('8784','2013-08-05','17:25:00',2.01),('8784','2013-08-05','17:30:00',1.94),('8784','2013-08-05','17:35:00',1.88),('8784','2013-08-05','17:40:00',1.81),('8784','2013-08-05','17:45:00',1.72),('8784','2013-08-05','17:50:00',1.63),('8784','2013-08-05','17:55:00',1.55),('8784','2013-08-05','18:00:00',1.47),('8784','2013-08-05','18:05:00',1.38),('8784','2013-08-05','18:10:00',1.3),('8784','2013-08-05','18:15:00',1.22),('8784','2013-08-05','18:20:00',1.15),('8784','2013-08-05','18:25:00',1.08),('8784','2013-08-05','18:30:00',1.01),('8784','2013-08-04','07:45:00',1.07),('8784','2013-08-04','07:50:00',1.15),('8784','2013-08-04','07:55:00',1.23),('8784','2013-08-04','08:00:00',1.31),('8784','2013-08-04','08:05:00',1.39),('8784','2013-08-04','08:10:00',1.47),('8784','2013-08-04','08:15:00',1.56),('8784','2013-08-04','08:20:00',1.64),('8784','2013-08-04','08:25:00',1.72),('8784','2013-08-04','08:30:00',1.78),('8784','2013-08-04','08:35:00',1.88),('8784','2013-08-04','08:40:00',1.95),('8784','2013-08-04','08:45:00',2.03),('8784','2013-08-04','08:50:00',2.1),('8784','2013-08-04','08:55:00',2.19),('8784','2013-08-04','09:00:00',2.26),('8784','2013-08-04','09:05:00',2.34),('8784','2013-08-04','09:10:00',2.4),('8784','2013-08-04','09:15:00',2.47),('8784','2013-08-04','09:20:00',2.52),('8784','2013-08-04','09:25:00',2.6),('8784','2013-08-04','09:30:00',2.66),('8784','2013-08-04','09:35:00',2.74),('8784','2013-08-04','09:40:00',2.8),('8784','2013-08-04','09:45:00',2.87),('8784','2013-08-04','09:50:00',2.92),('8784','2013-08-04','09:55:00',2.98),('8784','2013-08-04','10:00:00',3.03),('8784','2013-08-04','10:05:00',3.08),('8784','2013-08-04','10:10:00',3.14),('8784','2013-08-04','10:15:00',3.2),('8784','2013-08-04','10:20:00',3.25),('8784','2013-08-04','10:25:00',3.3),('8784','2013-08-04','10:30:00',3.34),('8784','2013-08-04','10:35:00',3.37),('8784','2013-08-04','10:40:00',3.41),('8784','2013-08-04','10:45:00',3.44),('8784','2013-08-04','10:50:00',3.48),('8784','2013-08-04','10:55:00',3.53),('8784','2013-08-04','11:00:00',3.55),('8784','2013-08-04','11:05:00',3.57),('8784','2013-08-04','11:10:00',3.59),('8784','2013-08-04','11:15:00',3.63),('8784','2013-08-04','11:20:00',3.67),('8784','2013-08-04','11:25:00',3.73),('8784','2013-08-04','11:30:00',3.75),('8784','2013-08-04','11:35:00',3.82),('8784','2013-08-04','11:40:00',3.83),('8784','2013-08-04','11:45:00',3.87),('8784','2013-08-04','11:50:00',3.9),('8784','2013-08-04','11:55:00',3.95),('8784','2013-08-04','12:00:00',3.96),('8784','2013-08-04','12:05:00',3.93),('8784','2013-08-04','12:10:00',3.97),('8784','2013-08-04','12:15:00',3.98),('8784','2013-08-04','12:20:00',3.98),('8784','2013-08-04','12:25:00',4),('8784','2013-08-04','12:30:00',4.01),('8784','2013-08-04','12:35:00',3.99),('8784','2013-08-04','12:40:00',4.03),('8784','2013-08-04','12:45:00',4.02),('8784','2013-08-04','12:50:00',4.03),('8784','2013-08-04','12:55:00',4.02),('8784','2013-08-04','13:00:00',3.93),('8784','2013-08-04','13:05:00',3.95),('8784','2013-08-04','13:10:00',4),('8784','2013-08-04','13:15:00',3.96),('8784','2013-08-04','13:20:00',3.99),('8784','2013-08-04','13:25:00',4.03),('8784','2013-08-04','13:30:00',4.01),('8784','2013-08-04','13:35:00',4.06),('8784','2013-08-04','13:40:00',4.05),('8784','2013-08-04','13:45:00',4.07),('8784','2013-08-04','13:50:00',4.05),('8784','2013-08-04','13:55:00',4.04),('8784','2013-08-04','14:00:00',4.05),('8784','2013-08-04','14:05:00',4.04),('8784','2013-08-04','14:10:00',4.02),('8784','2013-08-04','14:15:00',3.98),('8784','2013-08-04','14:20:00',3.96),('8784','2013-08-04','14:25:00',3.95),('8784','2013-08-04','14:30:00',3.89),('8784','2013-08-04','14:35:00',3.87),('8784','2013-08-04','14:40:00',3.85),('8784','2013-08-04','14:45:00',3.84),('8784','2013-08-04','14:50:00',3.81),('8784','2013-08-04','14:55:00',3.77),('8784','2013-08-04','15:00:00',3.72),('8784','2013-08-04','15:05:00',3.7),('8784','2013-08-04','15:10:00',3.69),('8784','2013-08-04','15:15:00',3.65),('8784','2013-08-04','15:20:00',3.61),('8784','2013-08-04','15:25:00',3.55),('8784','2013-08-04','15:30:00',3.48),('8784','2013-08-04','15:35:00',3.48),('8784','2013-08-04','15:40:00',3.39),('8784','2013-08-04','15:45:00',3.32),('8784','2013-08-04','15:50:00',3.24),('8784','2013-08-04','15:55:00',3.26),('8784','2013-08-04','16:00:00',3.15),('8784','2013-08-04','16:05:00',3.17),('8784','2013-08-04','16:10:00',3.13),('8784','2013-08-04','16:15:00',3.06),('8784','2013-08-04','16:20:00',2.96),('8784','2013-08-04','16:25:00',2.96),('8784','2013-08-04','16:30:00',2.89),('8784','2013-08-04','16:35:00',2.83),('8784','2013-08-04','16:40:00',2.77),('8784','2013-08-04','16:45:00',2.7),('8784','2013-08-04','16:50:00',2.6),('8784','2013-08-04','16:55:00',2.53),('8784','2013-08-04','17:00:00',2.51),('8784','2013-08-04','17:05:00',2.44),('8784','2013-08-04','17:10:00',2.36),('8784','2013-08-04','17:15:00',2.27),('8784','2013-08-04','17:20:00',2.2),('8784','2013-08-04','17:25:00',2.11),('8784','2013-08-04','17:30:00',2.03),('8784','2013-08-04','17:35:00',1.95),('8784','2013-08-04','17:40:00',1.87),('8784','2013-08-04','17:45:00',1.79),('8784','2013-08-04','17:50:00',1.71),('8784','2013-08-04','17:55:00',1.62),('8784','2013-08-04','18:00:00',1.54),('8784','2013-08-04','18:05:00',1.43),('8784','2013-08-04','18:10:00',1.35),('8784','2013-08-04','18:15:00',1.29),('8784','2013-08-04','18:20:00',1.22),('8784','2013-08-04','18:25:00',1.13),('8784','2013-08-04','18:30:00',1.05),('8784','2013-08-03','07:45:00',1.07),('8784','2013-08-03','07:50:00',1.15),('8784','2013-08-03','07:55:00',1.23),('8784','2013-08-03','08:00:00',1.29),('8784','2013-08-03','08:05:00',1.38),('8784','2013-08-03','08:10:00',1.46),('8784','2013-08-03','08:15:00',1.54),('8784','2013-08-03','08:20:00',1.62),('8784','2013-08-03','08:25:00',1.7),('8784','2013-08-03','08:30:00',1.79),('8784','2013-08-03','08:35:00',1.86),('8784','2013-08-03','08:40:00',1.93),('8784','2013-08-03','08:45:00',2.01),('8784','2013-08-03','08:50:00',2.06),('8784','2013-08-03','08:55:00',2.16),('8784','2013-08-03','09:00:00',2.24),('8784','2013-08-03','09:05:00',2.31),('8784','2013-08-03','09:10:00',2.39),('8784','2013-08-03','09:15:00',2.45),('8784','2013-08-03','09:20:00',2.52),('8784','2013-08-03','09:25:00',2.58),('8784','2013-08-03','09:30:00',2.64),('8784','2013-08-03','09:35:00',2.72),('8784','2013-08-03','09:40:00',2.78),('8784','2013-08-03','09:45:00',2.83),('8784','2013-08-03','09:50:00',2.89),('8784','2013-08-03','09:55:00',2.95),('8784','2013-08-03','10:00:00',3.01),('8784','2013-08-03','10:05:00',3.06),('8784','2013-08-03','10:10:00',3.1),('8784','2013-08-03','10:15:00',3.18),('8784','2013-08-03','10:20:00',3.24),('8784','2013-08-03','10:25:00',3.29),('8784','2013-08-03','10:30:00',3.31),('8784','2013-08-03','10:35:00',3.34),('8784','2013-08-03','10:40:00',3.4),('8784','2013-08-03','10:45:00',3.47),('8784','2013-08-03','10:50:00',3.5),('8784','2013-08-03','10:55:00',3.56),('8784','2013-08-03','11:00:00',3.56),('8784','2013-08-03','11:05:00',3.63),('8784','2013-08-03','11:10:00',3.63),('8784','2013-08-03','11:15:00',3.69),('8784','2013-08-03','11:20:00',3.7),('8784','2013-08-03','11:25:00',3.74),('8784','2013-08-03','11:30:00',3.77),('8784','2013-08-03','11:35:00',3.75),('8784','2013-08-03','11:40:00',3.8),('8784','2013-08-03','11:45:00',3.84),('8784','2013-08-03','11:50:00',3.84),('8784','2013-08-03','11:55:00',3.86),('8784','2013-08-03','12:00:00',3.89),('8784','2013-08-03','12:05:00',3.9),('8784','2013-08-03','12:10:00',3.87),('8784','2013-08-03','12:15:00',3.87),('8784','2013-08-03','12:20:00',3.91),('8784','2013-08-03','12:25:00',3.91),('8784','2013-08-03','12:30:00',3.92),('8784','2013-08-03','12:35:00',3.92),('8784','2013-08-03','12:40:00',3.91),('8784','2013-08-03','12:45:00',3.92),('8784','2013-08-03','12:50:00',3.83),('8784','2013-08-03','12:55:00',3.87),('8784','2013-08-03','13:00:00',3.89),('8784','2013-08-03','13:05:00',3.94),('8784','2013-08-03','13:10:00',3.92),('8784','2013-08-03','13:15:00',3.89),('8784','2013-08-03','13:20:00',3.86),('8784','2013-08-03','13:25:00',3.82),('8784','2013-08-03','13:30:00',3.82),('8784','2013-08-03','13:35:00',3.89),('8784','2013-08-03','13:40:00',3.93),('8784','2013-08-03','13:45:00',3.89),('8784','2013-08-03','13:50:00',3.86),('8784','2013-08-03','13:55:00',3.8),('8784','2013-08-03','14:00:00',3.81),('8784','2013-08-03','14:05:00',3.79),('8784','2013-08-03','14:10:00',3.77),('8784','2013-08-03','14:15:00',3.72),('8784','2013-08-03','14:20:00',3.76),('8784','2013-08-03','14:25:00',3.76),('8784','2013-08-03','14:30:00',3.76),('8784','2013-08-03','14:35:00',3.82),('8784','2013-08-03','14:40:00',3.82),('8784','2013-08-03','14:45:00',3.79),('8784','2013-08-03','14:50:00',3.8),('8784','2013-08-03','14:55:00',3.76),('8784','2013-08-03','15:00:00',3.73),('8784','2013-08-03','15:05:00',3.69),('8784','2013-08-03','15:10:00',3.64),('8784','2013-08-03','15:15:00',3.58),('8784','2013-08-03','15:20:00',3.54),('8784','2013-08-03','15:25:00',3.54),('8784','2013-08-03','15:30:00',3.52),('8784','2013-08-03','15:35:00',3.45),('8784','2013-08-03','15:40:00',3.41),('8784','2013-08-03','15:45:00',3.38),('8784','2013-08-03','15:50:00',3.32),('8784','2013-08-03','15:55:00',3.27),('8784','2013-08-03','16:00:00',3.2),('8784','2013-08-03','16:05:00',3.11),('8784','2013-08-03','16:10:00',3.06),('8784','2013-08-03','16:15:00',2.98),('8784','2013-08-03','16:20:00',2.93),('8784','2013-08-03','16:25:00',2.88),('8784','2013-08-03','16:30:00',2.83),('8784','2013-08-03','16:35:00',2.77),('8784','2013-08-03','16:40:00',2.71),('8784','2013-08-03','16:45:00',2.65),('8784','2013-08-03','16:50:00',2.61),('8784','2013-08-03','16:55:00',2.53),('8784','2013-08-03','17:00:00',2.47),('8784','2013-08-03','17:05:00',2.38),('8784','2013-08-03','17:10:00',2.32),('8784','2013-08-03','17:15:00',2.24),('8784','2013-08-03','17:20:00',2.16),('8784','2013-08-03','17:25:00',2.08),('8784','2013-08-03','17:30:00',2.01),('8784','2013-08-03','17:35:00',1.92),('8784','2013-08-03','17:40:00',1.87),('8784','2013-08-03','17:45:00',1.79),('8784','2013-08-03','17:50:00',1.7),('8784','2013-08-03','17:55:00',1.63),('8784','2013-08-03','18:00:00',1.55),('8784','2013-08-03','18:05:00',1.46),('8784','2013-08-03','18:10:00',1.39),('8784','2013-08-03','18:15:00',1.31),('8784','2013-08-03','18:20:00',1.24),('8784','2013-08-03','18:25:00',1.16),('8784','2013-08-03','18:30:00',1.09),('8784','2013-08-03','18:35:00',1.02),('8784','2013-08-02','07:40:00',1.06),('8784','2013-08-02','07:45:00',1.14),('8784','2013-08-02','07:50:00',1.22),('8784','2013-08-02','07:55:00',1.31),('8784','2013-08-02','08:00:00',1.39),('8784','2013-08-02','08:05:00',1.47),('8784','2013-08-02','08:10:00',1.55),('8784','2013-08-02','08:15:00',1.61),('8784','2013-08-02','08:20:00',1.72),('8784','2013-08-02','08:25:00',1.8),('8784','2013-08-02','08:30:00',1.88),('8784','2013-08-02','08:35:00',1.95),('8784','2013-08-02','08:40:00',2.03),('8784','2013-08-02','08:45:00',2.1),('8784','2013-08-02','08:50:00',2.18),('8784','2013-08-02','08:55:00',2.25),('8784','2013-08-02','09:00:00',2.32),('8784','2013-08-02','09:05:00',2.41),('8784','2013-08-02','09:10:00',2.48),('8784','2013-08-02','09:15:00',2.54),('8784','2013-08-02','09:20:00',2.62),('8784','2013-08-02','09:25:00',2.69),('8784','2013-08-02','09:30:00',2.69),('8784','2013-08-02','09:35:00',2.81),('8784','2013-08-02','09:40:00',2.86),('8784','2013-08-02','09:45:00',2.92),('8784','2013-08-02','09:50:00',2.97),('8784','2013-08-02','09:55:00',3.02),('8784','2013-08-02','10:00:00',3.09),('8784','2013-08-02','10:05:00',3.15),('8784','2013-08-02','10:10:00',3.19),('8784','2013-08-02','10:15:00',3.24),('8784','2013-08-02','10:20:00',3.29),('8784','2013-08-02','10:25:00',3.33),('8784','2013-08-02','10:30:00',3.37),('8784','2013-08-02','10:35:00',3.44),('8784','2013-08-02','10:40:00',3.48),('8784','2013-08-02','10:45:00',3.53),('8784','2013-08-02','10:50:00',3.56),('8784','2013-08-02','10:55:00',3.57),('8784','2013-08-02','11:00:00',3.61),('8784','2013-08-02','11:05:00',3.66),('8784','2013-08-02','11:10:00',3.7),('8784','2013-08-02','11:15:00',3.71),('8784','2013-08-02','11:20:00',3.76),('8784','2013-08-02','11:25:00',3.81),('8784','2013-08-02','11:30:00',3.85),('8784','2013-08-02','11:35:00',3.88),('8784','2013-08-02','11:40:00',3.88),('8784','2013-08-02','11:45:00',3.88),('8784','2013-08-02','11:50:00',3.92),('8784','2013-08-02','11:55:00',3.96),('8784','2013-08-02','12:00:00',4),('8784','2013-08-02','12:05:00',4),('8784','2013-08-02','12:10:00',4.01),('8784','2013-08-02','12:15:00',4.04),('8784','2013-08-02','12:20:00',4.03),('8784','2013-08-02','12:25:00',4.03),('8784','2013-08-02','12:30:00',4.01),('8784','2013-08-02','12:35:00',4.05),('8784','2013-08-02','12:40:00',4.04),('8784','2013-08-02','12:45:00',4.04),('8784','2013-08-02','12:50:00',4.04),('8784','2013-08-02','12:55:00',4.05),('8784','2013-08-02','13:00:00',4.05),('8784','2013-08-02','13:05:00',4.06),('8784','2013-08-02','13:10:00',4.05),('8784','2013-08-02','13:15:00',4.07),('8784','2013-08-02','13:20:00',4.04),('8784','2013-08-02','13:25:00',4.04),('8784','2013-08-02','13:30:00',4.01),('8784','2013-08-02','13:35:00',4.04),('8784','2013-08-02','13:40:00',4.05),('8784','2013-08-02','13:45:00',4.03),('8784','2013-08-02','13:50:00',4.01),('8784','2013-08-02','13:55:00',4.02),('8784','2013-08-02','14:00:00',4.02),('8784','2013-08-02','14:05:00',4),('8784','2013-08-02','14:10:00',3.94),('8784','2013-08-02','14:15:00',3.94),('8784','2013-08-02','14:20:00',3.82),('8784','2013-08-02','14:25:00',3.83),('8784','2013-08-02','14:30:00',3.86),('8784','2013-08-02','14:35:00',3.91),('8784','2013-08-02','14:40:00',3.91),('8784','2013-08-02','14:45:00',3.89),('8784','2013-08-02','14:50:00',3.84),('8784','2013-08-02','14:55:00',3.82),('8784','2013-08-02','15:00:00',3.78),('8784','2013-08-02','15:05:00',3.73),('8784','2013-08-02','15:10:00',3.68),('8784','2013-08-02','15:15:00',3.63),('8784','2013-08-02','15:20:00',3.62),('8784','2013-08-02','15:25:00',3.62),('8784','2013-08-02','15:30:00',3.57),('8784','2013-08-02','15:35:00',3.52),('8784','2013-08-02','15:40:00',3.46),('8784','2013-08-02','15:45:00',3.43),('8784','2013-08-02','15:50:00',3.35),('8784','2013-08-02','15:55:00',3.3),('8784','2013-08-02','16:00:00',3.29),('8784','2013-08-02','16:05:00',3.23),('8784','2013-08-02','16:10:00',3.16),('8784','2013-08-02','16:15:00',3.11),('8784','2013-08-02','16:20:00',3.05),('8784','2013-08-02','16:25:00',2.98),('8784','2013-08-02','16:30:00',2.93),('8784','2013-08-02','16:35:00',2.89),('8784','2013-08-02','16:40:00',2.82),('8784','2013-08-02','16:45:00',2.76),('8784','2013-08-02','16:50:00',2.68),('8784','2013-08-02','16:55:00',2.6),('8784','2013-08-02','17:00:00',2.51),('8784','2013-08-02','17:05:00',2.44),('8784','2013-08-02','17:10:00',2.39),('8784','2013-08-02','17:15:00',2.34),('8784','2013-08-02','17:20:00',2.24),('8784','2013-08-02','17:25:00',2.17),('8784','2013-08-02','17:30:00',2.08),('8784','2013-08-02','17:35:00',2.02),('8784','2013-08-02','17:40:00',1.94),('8784','2013-08-02','17:45:00',1.86),('8784','2013-08-02','17:50:00',1.76),('8784','2013-08-02','17:55:00',1.67),('8784','2013-08-02','18:00:00',1.61),('8784','2013-08-02','18:05:00',1.53),('8784','2013-08-02','18:10:00',1.44),('8784','2013-08-02','18:15:00',1.37),('8784','2013-08-02','18:20:00',1.28),('8784','2013-08-02','18:25:00',1.21),('8784','2013-08-02','18:30:00',1.13),('8784','2013-08-02','18:35:00',1.05),('8784','2013-08-01','07:40:00',1.08),('8784','2013-08-01','07:45:00',1.16),('8784','2013-08-01','07:50:00',1.23),('8784','2013-08-01','07:55:00',1.31),('8784','2013-08-01','08:00:00',1.39),('8784','2013-08-01','08:05:00',1.47),('8784','2013-08-01','08:10:00',1.55),('8784','2013-08-01','08:15:00',1.64),('8784','2013-08-01','08:20:00',1.72),('8784','2013-08-01','08:25:00',1.81),('8784','2013-08-01','08:30:00',1.89),('8784','2013-08-01','08:35:00',1.99),('8784','2013-08-01','08:40:00',2.07),('8784','2013-08-01','08:45:00',2.15),('8784','2013-08-01','08:50:00',2.23),('8784','2013-08-01','08:55:00',2.31),('8784','2013-08-01','09:00:00',2.39),('8784','2013-08-01','09:05:00',2.46),('8784','2013-08-01','09:10:00',2.54),('8784','2013-08-01','09:15:00',2.63),('8784','2013-08-01','09:20:00',2.71),('8784','2013-08-01','09:25:00',2.77),('8784','2013-08-01','09:30:00',2.83),('8784','2013-08-01','09:35:00',2.89),('8784','2013-08-01','09:40:00',2.96),('8784','2013-08-01','09:45:00',3.01),('8784','2013-08-01','09:50:00',3.1),('8784','2013-08-01','09:55:00',3.16),('8784','2013-08-01','10:00:00',3.23),('8784','2013-08-01','10:05:00',3.29),('8784','2013-08-01','10:10:00',3.36),('8784','2013-08-01','10:15:00',3.4),('8784','2013-08-01','10:20:00',3.41),('8784','2013-08-01','10:25:00',3.48),('8784','2013-08-01','10:30:00',3.56),('8784','2013-08-01','10:35:00',3.59),('8784','2013-08-01','10:40:00',3.62),('8784','2013-08-01','10:45:00',3.67),('8784','2013-08-01','10:50:00',3.74),('8784','2013-08-01','10:55:00',3.75),('8784','2013-08-01','11:00:00',3.78),('8784','2013-08-01','11:05:00',3.85),('8784','2013-08-01','11:10:00',3.91),('8784','2013-08-01','11:15:00',3.95),('8784','2013-08-01','11:20:00',3.97),('8784','2013-08-01','11:25:00',4.02),('8784','2013-08-01','11:30:00',3.97),('8784','2013-08-01','11:35:00',4.07),('8784','2013-08-01','11:40:00',4.12),('8784','2013-08-01','11:45:00',4.15),('8784','2013-08-01','11:50:00',4.17),('8784','2013-08-01','11:55:00',4.18),('8784','2013-08-01','12:00:00',4.19),('8784','2013-08-01','12:05:00',4.21),('8784','2013-08-01','12:10:00',4.2),('8784','2013-08-01','12:15:00',4.23),('8784','2013-08-01','12:20:00',4.26),('8784','2013-08-01','12:25:00',4.28),('8784','2013-08-01','12:30:00',4.27),('8784','2013-08-01','12:35:00',4.28),('8784','2013-08-01','12:40:00',4.3),('8784','2013-08-01','12:45:00',4.27),('8784','2013-08-01','12:50:00',4.34),('8784','2013-08-01','12:55:00',4.3),('8784','2013-08-01','13:00:00',4.31),('8784','2013-08-01','13:05:00',4.3),('8784','2013-08-01','13:10:00',4.32),('8784','2013-08-01','13:15:00',3.96),('8784','2013-08-01','13:20:00',4.36),('8784','2013-08-01','13:25:00',4.32),('8784','2013-08-01','13:30:00',4.27),('8784','2013-08-01','13:35:00',4.32),('8784','2013-08-01','13:40:00',4.29),('8784','2013-08-01','13:45:00',4.36),('8784','2013-08-01','13:50:00',4.27),('8784','2013-08-01','13:55:00',3.9),('8784','2013-08-01','14:00:00',3.99),('8784','2013-08-01','14:05:00',4.22),('8784','2013-08-01','14:10:00',4.16),('8784','2013-08-01','14:15:00',4.09),('8784','2013-08-01','14:20:00',4.04),('8784','2013-08-01','14:25:00',4.05),('8784','2013-08-01','14:30:00',3.98),('8784','2013-08-01','14:35:00',3.9),('8784','2013-08-01','14:40:00',3.84),('8784','2013-08-01','14:45:00',4),('8784','2013-08-01','14:50:00',2.89),('8784','2013-08-01','14:55:00',3.95),('8784','2013-08-01','15:00:00',3.84),('8784','2013-08-01','15:05:00',3.86),('8784','2013-08-01','15:10:00',3.87),('8784','2013-08-01','15:15:00',3.88),('8784','2013-08-01','15:20:00',3.81),('8784','2013-08-01','15:25:00',3.74),('8784','2013-08-01','15:30:00',3.66),('8784','2013-08-01','15:35:00',3.67),('8784','2013-08-01','15:40:00',2.88),('8784','2013-08-01','15:45:00',3.53),('8784','2013-08-01','15:50:00',3.45),('8784','2013-08-01','15:55:00',3.44),('8784','2013-08-01','16:00:00',3.43),('8784','2013-08-01','16:05:00',3.38),('8784','2013-08-01','16:10:00',3.26),('8784','2013-08-01','16:15:00',3.18),('8784','2013-08-01','16:20:00',3.13),('8784','2013-08-01','16:25:00',3.09),('8784','2013-08-01','16:30:00',3),('8784','2013-08-01','16:35:00',2.96),('8784','2013-08-01','16:40:00',2.89),('8784','2013-08-01','16:45:00',2.81),('8784','2013-08-01','16:50:00',2.74),('8784','2013-08-01','16:55:00',2.67),('8784','2013-08-01','17:00:00',2.59),('8784','2013-08-01','17:05:00',2.52),('8784','2013-08-01','17:10:00',2.45),('8784','2013-08-01','17:15:00',2.37),('8784','2013-08-01','17:20:00',2.29),('8784','2013-08-01','17:25:00',2.21),('8784','2013-08-01','17:30:00',2.14),('8784','2013-08-01','17:35:00',2.05),('8784','2013-08-01','17:40:00',1.98),('8784','2013-08-01','17:45:00',1.9),('8784','2013-08-01','17:50:00',1.82),('8784','2013-08-01','17:55:00',1.75),('8784','2013-08-01','18:00:00',1.66),('8784','2013-08-01','18:05:00',1.57),('8784','2013-08-01','18:10:00',1.49),('8784','2013-08-01','18:15:00',1.41),('8784','2013-08-01','18:20:00',1.34),('8784','2013-08-01','18:25:00',1.26),('8784','2013-08-01','18:30:00',1.18),('8784','2013-08-01','18:35:00',1.1),('8784','2013-08-01','18:40:00',1.02),('8784','2013-07-31','07:40:00',1.11),('8784','2013-07-31','07:45:00',1.2),('8784','2013-07-31','07:50:00',1.27),('8784','2013-07-31','07:55:00',1.35),('8784','2013-07-31','08:00:00',1.44),('8784','2013-07-31','08:05:00',1.53),('8784','2013-07-31','08:10:00',1.61),('8784','2013-07-31','08:15:00',1.7),('8784','2013-07-31','08:20:00',1.79),('8784','2013-07-31','08:25:00',1.86),('8784','2013-07-31','08:30:00',1.95),('8784','2013-07-31','08:35:00',2.04),('8784','2013-07-31','08:40:00',2.11),('8784','2013-07-31','08:45:00',2.19),('8784','2013-07-31','08:50:00',2.28),('8784','2013-07-31','08:55:00',2.36),('8784','2013-07-31','09:00:00',2.43),('8784','2013-07-31','09:05:00',2.51),('8784','2013-07-31','09:10:00',2.59),('8784','2013-07-31','09:15:00',2.66),('8784','2013-07-31','09:20:00',2.73),('8784','2013-07-31','09:25:00',2.79),('8784','2013-07-31','09:30:00',2.85),('8784','2013-07-31','09:35:00',2.94),('8784','2013-07-31','09:40:00',3),('8784','2013-07-31','09:45:00',3.05),('8784','2013-07-31','09:50:00',3.13),('8784','2013-07-31','09:55:00',3.19),('8784','2013-07-31','10:00:00',3.23),('8784','2013-07-31','10:05:00',3.31),('8784','2013-07-31','10:10:00',3.34),('8784','2013-07-31','10:15:00',3.37),('8784','2013-07-31','10:20:00',3.45),('8784','2013-07-31','10:25:00',3.5),('8784','2013-07-31','10:30:00',3.57),('8784','2013-07-31','10:35:00',3.61),('8784','2013-07-31','10:40:00',3.66),('8784','2013-07-31','10:45:00',3.71),('8784','2013-07-31','10:50:00',3.77),('8784','2013-07-31','10:55:00',3.82),('8784','2013-07-31','11:00:00',3.87),('8784','2013-07-31','11:05:00',3.89),('8784','2013-07-31','11:10:00',3.93),('8784','2013-07-31','11:15:00',3.98),('8784','2013-07-31','11:20:00',3.99),('8784','2013-07-31','11:25:00',4.04),('8784','2013-07-31','11:30:00',4.05),('8784','2013-07-31','11:35:00',4.09),('8784','2013-07-31','11:40:00',4.11),('8784','2013-07-31','11:45:00',4.17),('8784','2013-07-31','11:50:00',4.21),('8784','2013-07-31','11:55:00',4.23),('8784','2013-07-31','12:00:00',4.2),('8784','2013-07-31','12:05:00',4.23),('8784','2013-07-31','12:10:00',4.27),('8784','2013-07-31','12:15:00',4.31),('8784','2013-07-31','12:20:00',4.29),('8784','2013-07-31','12:25:00',4.36),('8784','2013-07-31','12:30:00',4.36),('8784','2013-07-31','12:35:00',4.32),('8784','2013-07-31','12:40:00',4.37),('8784','2013-07-31','12:45:00',3.84),('8784','2013-07-31','12:50:00',2.03),('8784','2013-07-31','12:55:00',4.56),('8784','2013-07-31','13:00:00',1.86),('8784','2013-07-31','13:05:00',3.62),('8784','2013-07-31','13:10:00',4.1),('8784','2013-07-31','13:15:00',4.42),('8784','2013-07-31','13:20:00',4.14),('8784','2013-07-31','13:25:00',4.17),('8784','2013-07-31','13:30:00',4.05),('8784','2013-07-31','13:35:00',4.39),('8784','2013-07-31','13:40:00',4.37),('8784','2013-07-31','13:45:00',4.46),('8784','2013-07-31','13:50:00',4.44),('8784','2013-07-31','13:55:00',3),('8784','2013-07-31','14:00:00',3.49),('8784','2013-07-31','14:05:00',4.39),('8784','2013-07-31','14:10:00',4.38),('8784','2013-07-31','14:15:00',3.69),('8784','2013-07-31','14:20:00',4.02),('8784','2013-07-31','14:25:00',3.63),('8784','2013-07-31','14:30:00',4.2),('8784','2013-07-31','14:35:00',4.12),('8784','2013-07-31','14:40:00',4.16),('8784','2013-07-31','14:45:00',4.06),('8784','2013-07-31','14:50:00',4.29),('8784','2013-07-31','14:55:00',3.09),('8784','2013-07-31','15:00:00',1.22),('8784','2013-07-31','15:05:00',3.61),('8784','2013-07-31','15:10:00',4.01),('8784','2013-07-31','15:15:00',3.48),('8784','2013-07-31','15:20:00',3.37),('8784','2013-07-31','15:25:00',3.88),('8784','2013-07-31','15:30:00',2.97),('8784','2013-07-31','15:35:00',3.7),('8784','2013-07-31','15:40:00',3.74),('8784','2013-07-31','15:45:00',3.28),('8784','2013-07-31','15:50:00',3.51),('8784','2013-07-31','15:55:00',3.46),('8784','2013-07-31','16:00:00',3.37),('8784','2013-07-31','16:05:00',3.37),('8784','2013-07-31','16:10:00',3.36),('8784','2013-07-31','16:15:00',3.24),('8784','2013-07-31','16:20:00',3.28),('8784','2013-07-31','16:25:00',3.28),('8784','2013-07-31','16:30:00',3.18),('8784','2013-07-31','16:35:00',3),('8784','2013-07-31','16:40:00',2.89),('8784','2013-07-31','16:45:00',2.74),('8784','2013-07-31','16:50:00',2.76),('8784','2013-07-31','16:55:00',2.69),('8784','2013-07-31','17:00:00',2.62),('8784','2013-07-31','17:05:00',2.5),('8784','2013-07-31','17:10:00',2.25),('8784','2013-07-31','17:15:00',2.45),('8784','2013-07-31','17:20:00',1.71),('8784','2013-07-31','17:25:00',2.24),('8784','2013-07-31','17:30:00',2.14),('8784','2013-07-31','17:35:00',2.02),('8784','2013-07-31','17:40:00',1.98),('8784','2013-07-31','17:45:00',1.9),('8784','2013-07-31','17:50:00',1.81),('8784','2013-07-31','17:55:00',1.73),('8784','2013-07-31','18:00:00',1.66),('8784','2013-07-31','18:05:00',1.57),('8784','2013-07-31','18:10:00',1.48),('8784','2013-07-31','18:15:00',1.43),('8784','2013-07-31','18:20:00',1.35),('8784','2013-07-31','18:25:00',1.29),('8784','2013-07-31','18:30:00',1.21),('8784','2013-07-31','18:35:00',1.13),('8784','2013-07-31','18:40:00',1.06),('8784','2014-04-08','08:15:00',1.15),('8784','2014-04-08','08:20:00',1.49),('8784','2014-04-08','08:25:00',1),('8784','2014-04-08','08:30:00',1.5),('8784','2014-04-08','08:35:00',1.47),('8784','2014-04-08','08:40:00',1.27),('8784','2014-04-08','08:45:00',1.67),('8784','2014-04-08','08:50:00',1.71),('8784','2014-04-08','08:55:00',1.84),('8784','2014-04-08','09:00:00',1.92),('8784','2014-04-08','09:05:00',1.98),('8784','2014-04-08','09:10:00',2.07),('8784','2014-04-08','09:15:00',2.15),('8784','2014-04-08','09:20:00',2.22),('8784','2014-04-08','09:25:00',2.34),('8784','2014-04-08','09:30:00',2.4),('8784','2014-04-08','09:35:00',2.45),('8784','2014-04-08','09:40:00',2.51),('8784','2014-04-08','09:45:00',2.57),('8784','2014-04-08','09:50:00',2.65),('8784','2014-04-08','09:55:00',2.69),('8784','2014-04-08','10:00:00',2.73),('8784','2014-04-08','10:05:00',2.71),('8784','2014-04-08','10:10:00',2.86),('8784','2014-04-08','10:15:00',3.01),('8784','2014-04-08','10:20:00',3.09),('8784','2014-04-08','10:25:00',3.13),('8784','2014-04-08','10:30:00',3.2),('8784','2014-04-08','10:35:00',3.28),('8784','2014-04-08','10:40:00',3.29),('8784','2014-04-08','10:45:00',3.33),('8784','2014-04-08','10:50:00',3.39),('8784','2014-04-08','10:55:00',3.46),('8784','2014-04-08','11:00:00',3.43),('8784','2014-04-08','11:05:00',3.47),('8784','2014-04-08','11:10:00',3.55),('8784','2014-04-08','11:15:00',3.19),('8784','2014-04-08','11:20:00',3.66),('8784','2014-04-08','11:25:00',3.65),('8784','2014-04-08','11:30:00',3.66),('8784','2014-04-08','11:35:00',3.56),('8784','2014-04-08','11:40:00',3.74),('8784','2014-04-08','11:45:00',3.74),('8784','2014-04-08','11:50:00',3.79),('8784','2014-04-08','11:55:00',3.84),('8784','2014-04-08','12:00:00',3.89),('8784','2014-04-08','12:05:00',3.84),('8784','2014-04-08','12:10:00',3.75),('8784','2014-04-08','12:15:00',3.53),('8784','2014-04-08','12:20:00',3.58),('8784','2014-04-08','12:25:00',3.56),('8784','2014-04-08','12:30:00',4.16),('8784','2014-04-08','12:35:00',4.1),('8784','2014-04-08','12:40:00',3.4),('8784','2014-04-08','12:45:00',2.65),('8784','2014-04-08','12:50:00',3.54),('8784','2014-04-08','12:55:00',4.03),('8784','2014-04-08','13:00:00',3.79),('8784','2014-04-08','13:05:00',3.99),('8784','2014-04-08','13:10:00',4.08),('8784','2014-04-08','13:15:00',4.18),('8784','2014-04-08','13:20:00',4.14),('8784','2014-04-08','13:25:00',4.19),('8784','2014-04-08','13:30:00',4.17),('8784','2014-04-08','13:35:00',4.18),('8784','2014-04-08','13:40:00',4.14),('8784','2014-04-08','13:45:00',4.07),('8784','2014-04-08','13:50:00',4.1),('8784','2014-04-08','13:55:00',4.12),('8784','2014-04-08','14:00:00',4.09),('8784','2014-04-08','14:05:00',4.08),('8784','2014-04-08','14:10:00',4.07),('8784','2014-04-08','14:15:00',3.99),('8784','2014-04-08','14:20:00',3.75),('8784','2014-04-08','14:25:00',3.79),('8784','2014-04-08','14:30:00',4.01),('8784','2014-04-08','14:35:00',3.82),('8784','2014-04-08','14:40:00',3.45),('8784','2014-04-08','14:45:00',3.44),('8784','2014-04-08','14:50:00',3.73),('8784','2014-04-08','14:55:00',3.83),('8784','2014-04-08','15:00:00',3.73),('8784','2014-04-08','15:05:00',3.64),('8784','2014-04-08','15:10:00',3.67),('8784','2014-04-08','15:15:00',3.59),('8784','2014-04-08','15:20:00',3.49),('8784','2014-04-08','15:25:00',3.31),('8784','2014-04-08','15:30:00',3.18),('8784','2014-04-08','15:35:00',3.37),('8784','2014-04-08','15:40:00',3.26),('8784','2014-04-08','15:45:00',3.12),('8784','2014-04-08','15:50:00',3.15),('8784','2014-04-08','15:55:00',3.1),('8784','2014-04-08','16:00:00',2.98),('8784','2014-04-08','16:05:00',2.94),('8784','2014-04-08','16:10:00',2.83),('8784','2014-04-08','16:15:00',2.64),('8784','2014-04-08','16:20:00',2.43),('8784','2014-04-08','16:25:00',2.56),('8784','2014-04-08','16:30:00',2.72),('8784','2014-04-08','16:35:00',2.62),('8784','2014-04-08','16:40:00',2.45),('8784','2014-04-08','16:45:00',2.33),('8784','2014-04-08','16:50:00',2.36),('8784','2014-04-08','16:55:00',2.17),('8784','2014-04-08','17:00:00',2.02),('8784','2014-04-08','17:05:00',2.09),('8784','2014-04-08','17:10:00',1.96),('8784','2014-04-08','17:15:00',1.87),('8784','2014-04-08','17:20:00',1.8),('8784','2014-04-08','17:25:00',1.59),('8784','2014-04-08','17:30:00',1.51),('8784','2014-04-08','17:35:00',1.38),('8784','2014-04-08','17:40:00',1.36),('8784','2014-04-08','17:45:00',1.31),('8784','2014-04-08','17:50:00',1.24),('8784','2014-04-08','17:55:00',1.1),('8784','2014-04-08','18:00:00',1.09),('8784','2014-04-08','18:05:00',1.05),('8784','2013-07-30','07:40:00',1.1),('8784','2013-07-30','07:45:00',1.16),('8784','2013-07-30','07:50:00',1.2),('8784','2013-07-30','07:55:00',1.27),('8784','2013-07-30','08:00:00',1.41),('8784','2013-07-30','08:05:00',1.53),('8784','2013-07-30','08:10:00',1.61),('8784','2013-07-30','08:15:00',1.72),('8784','2013-07-30','08:20:00',1.94),('8784','2013-07-30','08:25:00',1.87),('8784','2013-07-30','08:30:00',1.93),('8784','2013-07-30','08:35:00',1.97),('8784','2013-07-30','08:40:00',2.04),('8784','2013-07-30','08:45:00',2.13),('8784','2013-07-30','08:50:00',2.21),('8784','2013-07-30','08:55:00',2.35),('8784','2013-07-30','09:00:00',2.42),('8784','2013-07-30','09:05:00',2.51),('8784','2013-07-30','09:10:00',2.52),('8784','2013-07-30','09:15:00',2.68),('8784','2013-07-30','09:20:00',2.79),('8784','2013-07-30','09:25:00',2.8),('8784','2013-07-30','09:30:00',2.48),('8784','2013-07-30','09:35:00',2.92),('8784','2013-07-30','09:40:00',1.68),('8784','2013-07-30','09:45:00',1.75),('8784','2013-07-30','09:50:00',1.33),('8784','2013-07-30','09:55:00',2.8),('8784','2013-07-30','10:00:00',2.08),('8784','2013-07-30','10:05:00',1.38),('8784','2013-07-30','10:10:00',3.61),('8784','2013-07-30','10:15:00',3.55),('8784','2013-07-30','10:20:00',3.63),('8784','2013-07-30','10:25:00',3.7),('8784','2013-07-30','10:30:00',3.68),('8784','2013-07-30','10:35:00',3.66),('8784','2013-07-30','10:40:00',3.63),('8784','2013-07-30','10:45:00',3.68),('8784','2013-07-30','10:50:00',3.63),('8784','2013-07-30','10:55:00',3.65),('8784','2013-07-30','11:00:00',3.74),('8784','2013-07-30','11:05:00',3.77),('8784','2013-07-30','11:10:00',3.97),('8784','2013-07-30','11:15:00',3.32),('8784','2013-07-30','11:20:00',2.04),('8784','2013-07-30','11:25:00',1.11),('8784','2013-07-30','11:30:00',4.12),('8784','2013-07-30','11:35:00',4.25),('8784','2013-07-30','11:40:00',4.16),('8784','2013-07-30','11:45:00',4.08),('8784','2013-07-30','11:50:00',1.5),('8784','2013-07-30','11:55:00',4.02),('8784','2013-07-30','12:00:00',4.05),('8784','2013-07-30','12:05:00',4.14),('8784','2013-07-30','12:10:00',3.99),('8784','2013-07-30','12:15:00',4.08),('8784','2013-07-30','12:20:00',4.19),('8784','2013-07-30','12:25:00',4.21),('8784','2013-07-30','12:30:00',4.19),('8784','2013-07-30','12:35:00',3.04),('8784','2013-07-30','12:45:00',2.91),('8784','2013-07-30','12:50:00',4.54),('8784','2013-07-30','12:55:00',4.55),('8784','2013-07-30','13:00:00',3.29),('8784','2013-07-30','13:05:00',3.6),('8784','2013-07-30','13:10:00',4.04),('8784','2013-07-30','13:15:00',2.38),('8784','2013-07-30','13:20:00',4.02),('8784','2013-07-30','13:25:00',4.5),('8784','2013-07-30','13:30:00',4.47),('8784','2013-07-30','13:35:00',4.37),('8784','2013-07-30','13:40:00',4.39),('8784','2013-07-30','13:45:00',4.31),('8784','2013-07-30','13:50:00',4.34),('8784','2013-07-30','13:55:00',4.41),('8784','2013-07-30','14:00:00',4.37),('8784','2013-07-30','14:05:00',2.32),('8784','2013-07-30','14:10:00',2.23),('8784','2013-07-30','14:15:00',4.29),('8784','2013-07-30','14:20:00',4.28),('8784','2013-07-30','14:25:00',4.09),('8784','2013-07-30','14:30:00',4.09),('8784','2013-07-30','14:35:00',4.13),('8784','2013-07-30','14:40:00',3.99),('8784','2013-07-30','14:45:00',3.97),('8784','2013-07-30','14:50:00',3.98),('8784','2013-07-30','14:55:00',3.85),('8784','2013-07-30','15:00:00',3.87),('8784','2013-07-30','15:05:00',3.78),('8784','2013-07-30','15:10:00',3.7),('8784','2013-07-30','15:15:00',3.68),('8784','2013-07-30','15:20:00',3.64),('8784','2013-07-30','15:25:00',3.63),('8784','2013-07-30','15:30:00',3.59),('8784','2013-07-30','15:35:00',3.51),('8784','2013-07-30','15:40:00',3.49),('8784','2013-07-30','15:45:00',3.46),('8784','2013-07-30','15:50:00',3.4),('8784','2013-07-30','15:55:00',3.33),('8784','2013-07-30','16:00:00',3.31),('8784','2013-07-30','16:05:00',3.24),('8784','2013-07-30','16:10:00',3.16),('8784','2013-07-30','16:15:00',3.11),('8784','2013-07-30','16:20:00',3.08),('8784','2013-07-30','16:25:00',3.03),('8784','2013-07-30','16:30:00',2.93),('8784','2013-07-30','16:35:00',2.88),('8784','2013-07-30','16:40:00',2.86),('8784','2013-07-30','16:45:00',2.78),('8784','2013-07-30','16:50:00',2.69),('8784','2013-07-30','16:55:00',2.63),('8784','2013-07-30','17:00:00',2.56),('8784','2013-07-30','17:05:00',2.49),('8784','2013-07-30','17:10:00',2.41),('8784','2013-07-30','17:15:00',2.34),('8784','2013-07-30','17:20:00',2.26),('8784','2013-07-30','17:25:00',2.21),('8784','2013-07-30','17:30:00',2.13),('8784','2013-07-30','17:35:00',2.03),('8784','2013-07-30','17:40:00',1.97),('8784','2013-07-30','17:45:00',1.9),('8784','2013-07-30','17:50:00',1.79),('8784','2013-07-30','17:55:00',1.7),('8784','2013-07-30','18:00:00',1.62),('8784','2013-07-30','18:05:00',1.53),('8784','2013-07-30','18:10:00',1.45),('8784','2013-07-30','18:15:00',1.38),('8784','2013-07-30','18:20:00',1.32),('8784','2013-07-30','18:25:00',1.25),('8784','2013-07-30','18:30:00',1.16),('8784','2013-07-30','18:35:00',1.07),('8784','2013-07-29','07:45:00',1.05),('8784','2013-07-29','07:50:00',1.12),('8784','2013-07-29','07:55:00',1.2),('8784','2013-07-29','08:00:00',1.29),('8784','2013-07-29','08:05:00',1.38),('8784','2013-07-29','08:10:00',1.45),('8784','2013-07-29','08:15:00',1.51),('8784','2013-07-29','08:20:00',1.59),('8784','2013-07-29','08:25:00',1.66),('8784','2013-07-29','08:30:00',1.71),('8784','2013-07-29','08:35:00',1.8),('8784','2013-07-29','08:40:00',1.82),('8784','2013-07-29','08:45:00',1.92),('8784','2013-07-29','08:50:00',2.03),('8784','2013-07-29','08:55:00',2.06),('8784','2013-07-29','09:00:00',2.14),('8784','2013-07-29','09:05:00',2.23),('8784','2013-07-29','09:10:00',2.29),('8784','2013-07-29','09:15:00',2.35),('8784','2013-07-29','09:20:00',2.41),('8784','2013-07-29','09:25:00',2.47),('8784','2013-07-29','09:30:00',2.52),('8784','2013-07-29','09:35:00',2.6),('8784','2013-07-29','09:40:00',2.69),('8784','2013-07-29','09:45:00',2.77),('8784','2013-07-29','09:50:00',2.85),('8784','2013-07-29','09:55:00',2.9),('8784','2013-07-29','10:00:00',2.97),('8784','2013-07-29','10:05:00',3.04),('8784','2013-07-29','10:10:00',3.08),('8784','2013-07-29','10:15:00',3.14),('8784','2013-07-29','10:20:00',3.21),('8784','2013-07-29','10:25:00',3.28),('8784','2013-07-29','10:30:00',3.32),('8784','2013-07-29','10:35:00',3.32),('8784','2013-07-29','10:40:00',3.39),('8784','2013-07-29','10:45:00',3.42),('8784','2013-07-29','10:50:00',3.47),('8784','2013-07-29','10:55:00',3.47),('8784','2013-07-29','11:00:00',3.49),('8784','2013-07-29','11:05:00',3.54),('8784','2013-07-29','11:10:00',3.6),('8784','2013-07-29','11:15:00',3.61),('8784','2013-07-29','11:20:00',3.67),('8784','2013-07-29','11:25:00',3.68),('8784','2013-07-29','11:30:00',3.68),('8784','2013-07-29','11:35:00',3.7),('8784','2013-07-29','11:40:00',3.74),('8784','2013-07-29','11:45:00',3.74),('8784','2013-07-29','11:50:00',3.75),('8784','2013-07-29','11:55:00',3.74),('8784','2013-07-29','12:00:00',3.8),('8784','2013-07-29','12:05:00',3.85),('8784','2013-07-29','12:10:00',3.89),('8784','2013-07-29','12:15:00',3.87),('8784','2013-07-29','12:20:00',3.88),('8784','2013-07-29','12:25:00',3.9),('8784','2013-07-29','12:30:00',3.91),('8784','2013-07-29','12:35:00',3.92),('8784','2013-07-29','12:40:00',3.94),('8784','2013-07-29','12:45:00',3.94),('8784','2013-07-29','12:50:00',3.93),('8784','2013-07-29','12:55:00',3.86),('8784','2013-07-29','13:00:00',3.95),('8784','2013-07-29','13:05:00',3.93),('8784','2013-07-29','13:10:00',3.98),('8784','2013-07-29','13:15:00',3.98),('8784','2013-07-29','13:20:00',4.08),('8784','2013-07-29','13:25:00',4.11),('8784','2013-07-29','13:30:00',4.12),('8784','2013-07-29','13:35:00',4.12),('8784','2013-07-29','13:40:00',4.11),('8784','2013-07-29','13:45:00',4.11),('8784','2013-07-29','13:50:00',4.11),('8784','2013-07-29','13:55:00',4.09),('8784','2013-07-29','14:00:00',4.06),('8784','2013-07-29','14:05:00',4.05),('8784','2013-07-29','14:10:00',4.04),('8784','2013-07-29','14:15:00',4.05),('8784','2013-07-29','14:20:00',4.01),('8784','2013-07-29','14:25:00',3.96),('8784','2013-07-29','14:30:00',3.91),('8784','2013-07-29','14:35:00',3.93),('8784','2013-07-29','14:40:00',3.9),('8784','2013-07-29','14:45:00',3.85),('8784','2013-07-29','14:50:00',3.82),('8784','2013-07-29','14:55:00',3.8),('8784','2013-07-29','15:00:00',3.77),('8784','2013-07-29','15:05:00',3.75),('8784','2013-07-29','15:10:00',3.71),('8784','2013-07-29','15:15:00',3.66),('8784','2013-07-29','15:20:00',3.63),('8784','2013-07-29','15:25:00',3.6),('8784','2013-07-29','15:30:00',3.55),('8784','2013-07-29','15:35:00',3.53),('8784','2013-07-29','15:40:00',3.57),('8784','2013-07-29','15:45:00',3.62),('8784','2013-07-29','15:50:00',2.8),('8784','2013-07-29','15:55:00',2.02),('8784','2013-07-29','16:00:00',1.92),('8784','2013-07-29','16:05:00',2.94),('8784','2013-07-29','16:10:00',3.19),('8784','2013-07-29','16:15:00',2.45),('8784','2013-07-29','16:20:00',2.59),('8784','2013-07-29','16:25:00',2.6),('8784','2013-07-29','16:30:00',3.05),('8784','2013-07-29','16:35:00',2.58),('8784','2013-07-29','16:40:00',2.58),('8784','2013-07-29','16:45:00',3.04),('8784','2013-07-29','16:50:00',2.68),('8784','2013-07-29','16:55:00',1.93),('8784','2013-07-29','17:00:00',1.42),('8784','2013-07-29','17:05:00',2.09),('8784','2013-07-29','17:10:00',1.44),('8784','2013-07-29','17:15:00',1.2),('8784','2013-07-29','17:20:00',2.24),('8784','2013-07-29','17:25:00',2.12),('8784','2013-07-29','17:30:00',1.39),('8784','2013-07-29','17:40:00',1.27),('8784','2013-07-29','17:45:00',2.04),('8784','2013-07-29','17:50:00',1.81),('8784','2013-07-29','17:55:00',1.64),('8784','2013-07-29','18:00:00',1.16),('8784','2013-07-29','18:10:00',1.41),('8784','2013-07-29','18:15:00',1.17),('8784','2013-07-29','18:20:00',1.31),('8784','2013-07-29','18:25:00',1.26),('8784','2013-07-29','18:30:00',1.2),('8784','2013-07-29','18:35:00',1.04),('8784','2013-07-28','07:45:00',1.03),('8784','2013-07-28','07:50:00',1.11),('8784','2013-07-28','07:55:00',1.16),('8784','2013-07-28','08:00:00',1.26),('8784','2013-07-28','08:05:00',1.35),('8784','2013-07-28','08:10:00',1.43),('8784','2013-07-28','08:15:00',1.5),('8784','2013-07-28','08:20:00',1.59),('8784','2013-07-28','08:25:00',1.67),('8784','2013-07-28','08:30:00',1.77),('8784','2013-07-28','08:35:00',1.84),('8784','2013-07-28','08:40:00',1.92),('8784','2013-07-28','08:45:00',1.98),('8784','2013-07-28','08:50:00',2.07),('8784','2013-07-28','08:55:00',2.12),('8784','2013-07-28','09:00:00',2.19),('8784','2013-07-28','09:05:00',2.26),('8784','2013-07-28','09:10:00',2.37),('8784','2013-07-28','09:15:00',2.43),('8784','2013-07-28','09:20:00',2.5),('8784','2013-07-28','09:25:00',2.56),('8784','2013-07-28','09:30:00',2.61),('8784','2013-07-28','09:35:00',2.66),('8784','2013-07-28','09:40:00',2.74),('8784','2013-07-28','09:45:00',2.81),('8784','2013-07-28','09:50:00',2.86),('8784','2013-07-28','09:55:00',2.94),('8784','2013-07-28','10:00:00',2.98),('8784','2013-07-28','10:05:00',3.05),('8784','2013-07-28','10:10:00',3.11),('8784','2013-07-28','10:15:00',3.18),('8784','2013-07-28','10:20:00',3.19),('8784','2013-07-28','10:25:00',3.24),('8784','2013-07-28','10:30:00',3.31),('8784','2013-07-28','10:35:00',3.37),('8784','2013-07-28','10:40:00',3.4),('8784','2013-07-28','10:45:00',3.42),('8784','2013-07-28','10:50:00',3.48),('8784','2013-07-28','10:55:00',3.49),('8784','2013-07-28','11:00:00',3.53),('8784','2013-07-28','11:05:00',3.57),('8784','2013-07-28','11:10:00',3.55),('8784','2013-07-28','11:15:00',3.61),('8784','2013-07-28','11:20:00',3.63),('8784','2013-07-28','11:25:00',3.63),('8784','2013-07-28','11:30:00',3.71),('8784','2013-07-28','11:35:00',3.7),('8784','2013-07-28','11:40:00',3.75),('8784','2013-07-28','11:45:00',3.79),('8784','2013-07-28','11:50:00',3.81),('8784','2013-07-28','11:55:00',3.8),('8784','2013-07-28','12:00:00',3.85),('8784','2013-07-28','12:05:00',3.82),('8784','2013-07-28','12:10:00',3.77),('8784','2013-07-28','12:15:00',3.79),('8784','2013-07-28','12:20:00',3.88),('8784','2013-07-28','12:25:00',3.9),('8784','2013-07-28','12:30:00',3.97),('8784','2013-07-28','12:35:00',3.98),('8784','2013-07-28','12:40:00',3.98),('8784','2013-07-28','12:45:00',3.92),('8784','2013-07-28','12:50:00',3.94),('8784','2013-07-28','12:55:00',3.9),('8784','2013-07-28','13:00:00',3.85),('8784','2013-07-28','13:05:00',3.96),('8784','2013-07-28','13:10:00',4.04),('8784','2013-07-28','13:15:00',3.93),('8784','2013-07-28','13:20:00',3.97),('8784','2013-07-28','13:25:00',4.01),('8784','2013-07-28','13:30:00',4.04),('8784','2013-07-28','13:35:00',4.05),('8784','2013-07-28','13:40:00',4.05),('8784','2013-07-28','13:45:00',4.11),('8784','2013-07-28','13:50:00',4.04),('8784','2013-07-28','13:55:00',4),('8784','2013-07-28','14:00:00',3.99),('8784','2013-07-28','14:05:00',4.01),('8784','2013-07-28','14:10:00',4.02),('8784','2013-07-28','14:15:00',3.97),('8784','2013-07-28','14:20:00',3.92),('8784','2013-07-28','14:25:00',3.93),('8784','2013-07-28','14:30:00',3.91),('8784','2013-07-28','14:35:00',3.85),('8784','2013-07-28','14:40:00',3.84),('8784','2013-07-28','14:45:00',3.8),('8784','2013-07-28','14:50:00',3.78),('8784','2013-07-28','14:55:00',3.75),('8784','2013-07-28','15:00:00',3.73),('8784','2013-07-28','15:05:00',3.73),('8784','2013-07-28','15:10:00',3.67),('8784','2013-07-28','15:15:00',3.6),('8784','2013-07-28','15:20:00',3.54),('8784','2013-07-28','15:25:00',3.56),('8784','2013-07-28','15:30:00',3.49),('8784','2013-07-28','15:35:00',3.46),('8784','2013-07-28','15:40:00',3.45),('8784','2013-07-28','15:45:00',3.36),('8784','2013-07-28','15:50:00',3.32),('8784','2013-07-28','15:55:00',3.29),('8784','2013-07-28','16:00:00',3.26),('8784','2013-07-28','16:05:00',3.23),('8784','2013-07-28','16:10:00',3.17),('8784','2013-07-28','16:15:00',3.14),('8784','2013-07-28','16:20:00',3.07),('8784','2013-07-28','16:25:00',3.03),('8784','2013-07-28','16:30:00',2.97),('8784','2013-07-28','16:35:00',2.9),('8784','2013-07-28','16:40:00',2.84),('8784','2013-07-28','16:45:00',2.78),('8784','2013-07-28','16:50:00',2.73),('8784','2013-07-28','16:55:00',2.66),('8784','2013-07-28','17:00:00',2.58),('8784','2013-07-28','17:05:00',2.51),('8784','2013-07-28','17:10:00',2.44),('8784','2013-07-28','17:15:00',2.38),('8784','2013-07-28','17:20:00',2.31),('8784','2013-07-28','17:25:00',2.22),('8784','2013-07-28','17:30:00',2.15),('8784','2013-07-28','17:35:00',2.07),('8784','2013-07-28','17:40:00',2),('8784','2013-07-28','17:45:00',1.93),('8784','2013-07-28','17:50:00',1.84),('8784','2013-07-28','17:55:00',1.76),('8784','2013-07-28','18:00:00',1.66),('8784','2013-07-28','18:05:00',1.58),('8784','2013-07-28','18:10:00',1.5),('8784','2013-07-28','18:15:00',1.42),('8784','2013-07-28','18:20:00',1.35),('8784','2013-07-28','18:25:00',1.28),('8784','2013-07-28','18:30:00',1.19),('8784','2013-07-28','18:35:00',1.11),('8784','2013-07-28','18:40:00',1.03),('8784','2013-07-27','07:45:00',1.04),('8784','2013-07-27','07:50:00',1.13),('8784','2013-07-27','07:55:00',1.23),('8784','2013-07-27','08:00:00',1.32),('8784','2013-07-27','08:05:00',1.39),('8784','2013-07-27','08:10:00',1.47),('8784','2013-07-27','08:15:00',1.56),('8784','2013-07-27','08:20:00',1.64),('8784','2013-07-27','08:25:00',1.71),('8784','2013-07-27','08:30:00',1.79),('8784','2013-07-27','08:35:00',1.87),('8784','2013-07-27','08:40:00',1.95),('8784','2013-07-27','08:45:00',2.02),('8784','2013-07-27','08:50:00',2.08),('8784','2013-07-27','08:55:00',2.18),('8784','2013-07-27','09:00:00',2.24),('8784','2013-07-27','09:05:00',2.35),('8784','2013-07-27','09:10:00',2.42),('8784','2013-07-27','09:15:00',2.48),('8784','2013-07-27','09:20:00',2.56),('8784','2013-07-27','09:25:00',2.64),('8784','2013-07-27','09:30:00',2.71),('8784','2013-07-27','09:35:00',2.79),('8784','2013-07-27','09:40:00',2.82),('8784','2013-07-27','09:45:00',2.88),('8784','2013-07-27','09:50:00',2.95),('8784','2013-07-27','09:55:00',3),('8784','2013-07-27','10:00:00',3.08),('8784','2013-07-27','10:05:00',3.12),('8784','2013-07-27','10:10:00',3.2),('8784','2013-07-27','10:15:00',3.24),('8784','2013-07-27','10:20:00',3.27),('8784','2013-07-27','10:25:00',3.34),('8784','2013-07-27','10:30:00',3.38),('8784','2013-07-27','10:35:00',3.42),('8784','2013-07-27','10:40:00',3.46),('8784','2013-07-27','10:45:00',3.5),('8784','2013-07-27','10:50:00',3.54),('8784','2013-07-27','10:55:00',3.54),('8784','2013-07-27','11:00:00',3.58),('8784','2013-07-27','11:05:00',3.65),('8784','2013-07-27','11:10:00',3.74),('8784','2013-07-27','11:15:00',3.79),('8784','2013-07-27','11:20:00',3.79),('8784','2013-07-27','11:25:00',3.79),('8784','2013-07-27','11:30:00',3.8),('8784','2013-07-27','11:35:00',3.85),('8784','2013-07-27','11:40:00',3.85),('8784','2013-07-27','11:45:00',3.88),('8784','2013-07-27','11:50:00',3.91),('8784','2013-07-27','11:55:00',3.92),('8784','2013-07-27','12:00:00',3.94),('8784','2013-07-27','12:05:00',3.94),('8784','2013-07-27','12:10:00',3.94),('8784','2013-07-27','12:15:00',3.95),('8784','2013-07-27','12:20:00',3.89),('8784','2013-07-27','12:25:00',3.94),('8784','2013-07-27','12:30:00',3.98),('8784','2013-07-27','12:35:00',3.9),('8784','2013-07-27','12:40:00',3.82),('8784','2013-07-27','12:45:00',3.97),('8784','2013-07-27','12:50:00',4.01),('8784','2013-07-27','12:55:00',4.1),('8784','2013-07-27','13:00:00',3.9),('8784','2013-07-27','13:05:00',1.03),('8784','2013-07-27','13:10:00',1.81),('8784','2013-07-27','13:15:00',3.88),('8784','2013-07-27','13:20:00',4.12),('8784','2013-07-27','13:25:00',4.12),('8784','2013-07-27','13:30:00',4.09),('8784','2013-07-27','13:35:00',4.04),('8784','2013-07-27','13:40:00',4.11),('8784','2013-07-27','13:45:00',4.05),('8784','2013-07-27','13:50:00',4.06),('8784','2013-07-27','13:55:00',4.08),('8784','2013-07-27','14:00:00',3.98),('8784','2013-07-27','14:05:00',4.13),('8784','2013-07-27','14:10:00',4.15),('8784','2013-07-27','14:15:00',3.98),('8784','2013-07-27','14:20:00',3.94),('8784','2013-07-27','14:25:00',3.95),('8784','2013-07-27','14:30:00',3.88),('8784','2013-07-27','14:35:00',3.87),('8784','2013-07-27','14:40:00',3.85),('8784','2013-07-27','14:45:00',3.83),('8784','2013-07-27','14:50:00',3.85),('8784','2013-07-27','14:55:00',3.82),('8784','2013-07-27','15:00:00',3.76),('8784','2013-07-27','15:05:00',3.76),('8784','2013-07-27','15:10:00',3.71),('8784','2013-07-27','15:15:00',3.7),('8784','2013-07-27','15:20:00',3.66),('8784','2013-07-27','15:25:00',3.62),('8784','2013-07-27','15:30:00',3.57),('8784','2013-07-27','15:35:00',3.53),('8784','2013-07-27','15:40:00',3.47),('8784','2013-07-27','15:45:00',3.41),('8784','2013-07-27','15:50:00',3.39),('8784','2013-07-27','15:55:00',3.34),('8784','2013-07-27','16:00:00',3.3),('8784','2013-07-27','16:05:00',3.25),('8784','2013-07-27','16:10:00',3.19),('8784','2013-07-27','16:15:00',3.12),('8784','2013-07-27','16:20:00',3.08),('8784','2013-07-27','16:25:00',3.03),('8784','2013-07-27','16:30:00',3),('8784','2013-07-27','16:35:00',2.92),('8784','2013-07-27','16:40:00',2.88),('8784','2013-07-27','16:45:00',2.81),('8784','2013-07-27','16:50:00',2.75),('8784','2013-07-27','16:55:00',2.68),('8784','2013-07-27','17:00:00',2.58),('8784','2013-07-27','17:05:00',2.53),('8784','2013-07-27','17:10:00',2.46),('8784','2013-07-27','17:15:00',2.39),('8784','2013-07-27','17:20:00',2.31),('8784','2013-07-27','17:25:00',2.23),('8784','2013-07-27','17:30:00',2.13),('8784','2013-07-27','17:35:00',2.07),('8784','2013-07-27','17:40:00',2),('8784','2013-07-27','17:45:00',1.92),('8784','2013-07-27','17:50:00',1.85),('8784','2013-07-27','17:55:00',1.78),('8784','2013-07-27','18:00:00',1.7),('8784','2013-07-27','18:05:00',1.62),('8784','2013-07-27','18:10:00',1.54),('8784','2013-07-27','18:15:00',1.45),('8784','2013-07-27','18:20:00',1.37),('8784','2013-07-27','18:25:00',1.3),('8784','2013-07-27','18:30:00',1.23),('8784','2013-07-27','18:35:00',1.15),('8784','2013-07-27','18:40:00',1.07),('8784','2013-07-26','07:40:00',1.01),('8784','2013-07-26','07:45:00',1.06),('8784','2013-07-26','07:50:00',1.1),('8784','2013-07-26','07:55:00',1.17),('8784','2013-07-26','08:00:00',1.27),('8784','2013-07-26','08:05:00',1.36),('8784','2013-07-26','08:10:00',1.41),('8784','2013-07-26','08:15:00',1.49),('8784','2013-07-26','08:20:00',1.55),('8784','2013-07-26','08:25:00',1.66),('8784','2013-07-26','08:30:00',1.76),('8784','2013-07-26','08:35:00',1.84),('8784','2013-07-26','08:40:00',1.88),('8784','2013-07-26','08:45:00',1.99),('8784','2013-07-26','08:50:00',2.07),('8784','2013-07-26','08:55:00',2.15),('8784','2013-07-26','09:00:00',2.2),('8784','2013-07-26','09:05:00',2.28),('8784','2013-07-26','09:10:00',2.35),('8784','2013-07-26','09:15:00',2.39),('8784','2013-07-26','09:20:00',2.47),('8784','2013-07-26','09:25:00',2.54),('8784','2013-07-26','09:30:00',2.45),('8784','2013-07-26','09:35:00',2.55),('8784','2013-07-26','09:40:00',2.71),('8784','2013-07-26','09:45:00',2.8),('8784','2013-07-26','09:50:00',2.82),('8784','2013-07-26','09:55:00',2.97),('8784','2013-07-26','10:00:00',3.03),('8784','2013-07-26','10:05:00',3.11),('8784','2013-07-26','10:10:00',3.1),('8784','2013-07-26','10:15:00',3.08),('8784','2013-07-26','10:20:00',3.22),('8784','2013-07-26','10:25:00',3.28),('8784','2013-07-26','10:30:00',3.31),('8784','2013-07-26','10:35:00',3.36),('8784','2013-07-26','10:40:00',3.37),('8784','2013-07-26','10:45:00',3.46),('8784','2013-07-26','10:50:00',3.44),('8784','2013-07-26','10:55:00',3.43),('8784','2013-07-26','11:00:00',3.46),('8784','2013-07-26','11:05:00',3.53),('8784','2013-07-26','11:10:00',3.68),('8784','2013-07-26','11:15:00',3.71),('8784','2013-07-26','11:20:00',3.7),('8784','2013-07-26','11:25:00',3.74),('8784','2013-07-26','11:30:00',3.79),('8784','2013-07-26','11:35:00',3.85),('8784','2013-07-26','11:40:00',3.83),('8784','2013-07-26','11:45:00',3.86),('8784','2013-07-26','11:50:00',3.97),('8784','2013-07-26','11:55:00',3.97),('8784','2013-07-26','12:00:00',3.88),('8784','2013-07-26','12:05:00',3.95),('8784','2013-07-26','12:10:00',2.93),('8784','2013-07-26','12:15:00',3.91),('8784','2013-07-26','12:20:00',4.19),('8784','2013-07-26','12:25:00',4.17),('8784','2013-07-26','12:30:00',4.13),('8784','2013-07-26','12:35:00',4.11),('8784','2013-07-26','12:40:00',4.23),('8784','2013-07-26','12:45:00',4.27),('8784','2013-07-26','12:50:00',3.72),('8784','2013-07-26','12:55:00',1.99),('8784','2013-07-26','13:00:00',1.39),('8784','2013-07-26','13:05:00',1.23),('8784','2013-07-26','13:10:00',1.58),('8784','2013-07-26','13:15:00',2.11),('8784','2013-07-26','13:20:00',1.53),('8784','2013-07-26','13:25:00',2.38),('8784','2013-07-26','13:30:00',4.43),('8784','2013-07-26','13:35:00',4.23),('8784','2013-07-26','13:40:00',4.31),('8784','2013-07-26','13:45:00',4.4),('8784','2013-07-26','13:50:00',4.34),('8784','2013-07-26','13:55:00',3.93),('8784','2013-07-26','14:00:00',4.34),('8784','2013-07-26','14:05:00',3.08),('8784','2013-07-26','14:10:00',4.23),('8784','2013-07-26','14:15:00',4.18),('8784','2013-07-26','14:20:00',4.06),('8784','2013-07-26','14:25:00',4.01),('8784','2013-07-26','14:30:00',4.03),('8784','2013-07-26','14:35:00',4.05),('8784','2013-07-26','14:40:00',3.96),('8784','2013-07-26','14:45:00',3.94),('8784','2013-07-26','14:50:00',3.87),('8784','2013-07-26','14:55:00',3.84),('8784','2013-07-26','15:00:00',3.85),('8784','2013-07-26','15:05:00',3.79),('8784','2013-07-26','15:10:00',3.76),('8784','2013-07-26','15:15:00',3.75),('8784','2013-07-26','15:20:00',3.66),('8784','2013-07-26','15:25:00',3.61),('8784','2013-07-26','15:30:00',3.58),('8784','2013-07-26','15:35:00',3.55),('8784','2013-07-26','15:40:00',3.54),('8784','2013-07-26','15:45:00',3.47),('8784','2013-07-26','15:50:00',3.43),('8784','2013-07-26','15:55:00',3.39),('8784','2013-07-26','16:00:00',3.33),('8784','2013-07-26','16:05:00',3.29),('8784','2013-07-26','16:10:00',3.21),('8784','2013-07-26','16:15:00',3.11),('8784','2013-07-26','16:20:00',3.11),('8784','2013-07-26','16:25:00',3.07),('8784','2013-07-26','16:30:00',3.01),('8784','2013-07-26','16:35:00',2.93),('8784','2013-07-26','16:40:00',2.88),('8784','2013-07-26','16:45:00',2.82),('8784','2013-07-26','16:50:00',2.75),('8784','2013-07-26','16:55:00',2.63),('8784','2013-07-26','17:00:00',2.59),('8784','2013-07-26','17:05:00',2.54),('8784','2013-07-26','17:10:00',2.48),('8784','2013-07-26','17:15:00',2.38),('8784','2013-07-26','17:20:00',2.3),('8784','2013-07-26','17:25:00',2.23),('8784','2013-07-26','17:30:00',2.13),('8784','2013-07-26','17:35:00',2.05),('8784','2013-07-26','17:40:00',1.98),('8784','2013-07-26','17:45:00',1.9),('8784','2013-07-26','17:50:00',1.78),('8784','2013-07-26','17:55:00',1.68),('8784','2013-07-26','18:00:00',1.58),('8784','2013-07-26','18:05:00',1.54),('8784','2013-07-26','18:10:00',1.46),('8784','2013-07-26','18:15:00',1.36),('8784','2013-07-26','18:20:00',1.3),('8784','2013-07-26','18:25:00',1.26),('8784','2013-07-26','18:30:00',1.18),('8784','2013-07-26','18:35:00',1.1),('8784','2013-07-26','18:40:00',1.01),('8784','2013-07-25','07:45:00',1.08),('8784','2013-07-25','07:50:00',1.14),('8784','2013-07-25','07:55:00',1.23),('8784','2013-07-25','08:00:00',1.29),('8784','2013-07-25','08:05:00',1.37),('8784','2013-07-25','08:10:00',1.46),('8784','2013-07-25','08:15:00',1.49),('8784','2013-07-25','08:20:00',1.6),('8784','2013-07-25','08:25:00',1.68),('8784','2013-07-25','08:30:00',1.74),('8784','2013-07-25','08:35:00',1.83),('8784','2013-07-25','08:40:00',1.91),('8784','2013-07-25','08:45:00',2),('8784','2013-07-25','08:50:00',2.07),('8784','2013-07-25','08:55:00',2.18),('8784','2013-07-25','09:00:00',2.15),('8784','2013-07-25','09:05:00',2.23),('8784','2013-07-25','09:10:00',2.46),('8784','2013-07-25','09:15:00',2.67),('8784','2013-07-25','09:20:00',2.01),('8784','2013-07-25','09:25:00',1.81),('8784','2013-07-25','09:30:00',1.43),('8784','2013-07-25','09:35:00',1.74),('8784','2013-07-25','09:40:00',1.62),('8784','2013-07-25','09:45:00',1.25),('8784','2013-07-25','09:50:00',1.58),('8784','2013-07-25','10:00:00',2.09),('8784','2013-07-25','10:05:00',3.14),('8784','2013-07-25','10:10:00',3.16),('8784','2013-07-25','10:15:00',3.17),('8784','2013-07-25','10:20:00',3.28),('8784','2013-07-25','10:25:00',2.42),('8784','2013-07-25','10:30:00',1.7),('8784','2013-07-25','10:35:00',2.04),('8784','2013-07-25','10:40:00',2.28),('8784','2013-07-25','10:45:00',3.07),('8784','2013-07-25','10:50:00',3.74),('8784','2013-07-25','10:55:00',3.6),('8784','2013-07-25','11:00:00',3.88),('8784','2013-07-25','11:05:00',3.9),('8784','2013-07-25','11:10:00',3.83),('8784','2013-07-25','11:15:00',3.96),('8784','2013-07-25','11:20:00',3.86),('8784','2013-07-25','11:25:00',4.13),('8784','2013-07-25','11:30:00',4.03),('8784','2013-07-25','11:35:00',2.82),('8784','2013-07-25','11:40:00',3.69),('8784','2013-07-25','11:45:00',3.76),('8784','2013-07-25','11:50:00',4.25),('8784','2013-07-25','11:55:00',4.15),('8784','2013-07-25','12:00:00',4.15),('8784','2013-07-25','12:05:00',1.43),('8784','2013-07-25','12:10:00',2.91),('8784','2013-07-25','12:15:00',2.13),('8784','2013-07-25','12:20:00',2.73),('8784','2013-07-25','12:25:00',4.23),('8784','2013-07-25','12:30:00',4.55),('8784','2013-07-25','12:35:00',3.35),('8784','2013-07-25','12:40:00',4.2),('8784','2013-07-25','12:45:00',3.79),('8784','2013-07-25','12:50:00',2.98),('8784','2013-07-25','12:55:00',4.5),('8784','2013-07-25','13:00:00',4.36),('8784','2013-07-25','13:05:00',4.38),('8784','2013-07-25','13:10:00',4.49),('8784','2013-07-25','13:15:00',4.43),('8784','2013-07-25','13:20:00',4.34),('8784','2013-07-25','13:25:00',4.32),('8784','2013-07-25','13:30:00',4.27),('8784','2013-07-25','13:35:00',4.25),('8784','2013-07-25','13:40:00',4.26),('8784','2013-07-25','13:45:00',4.25),('8784','2013-07-25','13:50:00',4.28),('8784','2013-07-25','13:55:00',4.24),('8784','2013-07-25','14:00:00',4.26),('8784','2013-07-25','14:05:00',4.3),('8784','2013-07-25','14:10:00',4.24),('8784','2013-07-25','14:15:00',4.23),('8784','2013-07-25','14:20:00',4.21),('8784','2013-07-25','14:25:00',4.16),('8784','2013-07-25','14:30:00',4.16),('8784','2013-07-25','14:35:00',4.13),('8784','2013-07-25','14:40:00',4.11),('8784','2013-07-25','14:45:00',4.08),('8784','2013-07-25','14:50:00',4.05),('8784','2013-07-25','14:55:00',4.01),('8784','2013-07-25','15:00:00',4),('8784','2013-07-25','15:05:00',3.94),('8784','2013-07-25','15:10:00',3.88),('8784','2013-07-25','15:15:00',3.86),('8784','2013-07-25','15:20:00',3.83),('8784','2013-07-25','15:25:00',3.72),('8784','2013-07-25','15:30:00',3.75),('8784','2013-07-25','15:35:00',3.72),('8784','2013-07-25','15:40:00',3.69),('8784','2013-07-25','15:45:00',3.65),('8784','2013-07-25','15:50:00',3.57),('8784','2013-07-25','15:55:00',3.51),('8784','2013-07-25','16:00:00',3.47),('8784','2013-07-25','16:05:00',3.41),('8784','2013-07-25','16:10:00',3.37),('8784','2013-07-25','16:15:00',3.32),('8784','2013-07-25','16:20:00',3.24),('8784','2013-07-25','16:25:00',3.14),('8784','2013-07-25','16:30:00',3.08),('8784','2013-07-25','16:35:00',3.04),('8784','2013-07-25','16:40:00',3),('8784','2013-07-25','16:45:00',2.93),('8784','2013-07-25','16:50:00',2.86),('8784','2013-07-25','16:55:00',2.8),('8784','2013-07-25','17:00:00',2.73),('8784','2013-07-25','17:05:00',2.66),('8784','2013-07-25','17:10:00',2.57),('8784','2013-07-25','17:15:00',2.5),('8784','2013-07-25','17:20:00',2.42),('8784','2013-07-25','17:25:00',2.37),('8784','2013-07-25','17:30:00',2.29),('8784','2013-07-25','17:35:00',2.21),('8784','2013-07-25','17:40:00',2.12),('8784','2013-07-25','17:45:00',2.04),('8784','2013-07-25','17:50:00',1.94),('8784','2013-07-25','17:55:00',1.87),('8784','2013-07-25','18:00:00',1.78),('8784','2013-07-25','18:05:00',1.69),('8784','2013-07-25','18:10:00',1.6),('8784','2013-07-25','18:15:00',1.49),('8784','2013-07-25','18:20:00',1.42),('8784','2013-07-25','18:25:00',1.28),('8784','2013-07-25','18:30:00',1.26),('8784','2013-07-25','18:35:00',1.19),('8784','2013-07-25','18:40:00',1.1),('8784','2013-07-25','18:45:00',1.02),('8784','2013-07-24','08:00:00',1.12),('8784','2013-07-24','08:05:00',1.1),('8784','2013-07-24','08:10:00',1.04),('8784','2013-07-24','08:15:00',1.24),('8784','2013-07-24','08:20:00',1.28),('8784','2013-07-24','08:25:00',1.2),('8784','2013-07-24','08:30:00',1.17),('8784','2013-07-24','08:35:00',1.22),('8784','2013-07-24','08:40:00',1.21),('8784','2013-07-24','08:45:00',1.81),('8784','2013-07-24','08:50:00',2.25),('8784','2013-07-24','08:55:00',2.28),('8784','2013-07-24','09:00:00',2.39),('8784','2013-07-24','09:05:00',2.16),('8784','2013-07-24','09:10:00',2.6),('8784','2013-07-24','09:15:00',1.81),('8784','2013-07-24','09:20:00',2.12),('8784','2013-07-24','09:25:00',1.46),('8784','2013-07-24','09:30:00',2.11),('8784','2013-07-24','09:35:00',1.96),('8784','2013-07-24','09:40:00',1.85),('8784','2013-07-24','09:45:00',2),('8784','2013-07-24','09:50:00',1.48),('8784','2013-07-24','09:55:00',1.54),('8784','2013-07-24','10:15:00',1.29),('8784','2013-07-24','10:20:00',2.49),('8784','2013-07-24','10:25:00',3.61),('8784','2013-07-24','10:30:00',3.6),('8784','2013-07-24','10:35:00',3.81),('8784','2013-07-24','10:40:00',2.91),('8784','2013-07-24','10:45:00',1.66),('8784','2013-07-24','10:50:00',2.37),('8784','2013-07-24','10:55:00',2.59),('8784','2013-07-24','11:00:00',2.99),('8784','2013-07-24','11:05:00',1.84),('8784','2013-07-24','11:10:00',3.28),('8784','2013-07-24','11:15:00',4.1),('8784','2013-07-24','11:20:00',4.08),('8784','2013-07-24','11:25:00',3.77),('8784','2013-07-24','11:30:00',3.38),('8784','2013-07-24','11:35:00',3.8),('8784','2013-07-24','11:40:00',4.1),('8784','2013-07-24','11:45:00',4.12),('8784','2013-07-24','11:50:00',4.11),('8784','2013-07-24','11:55:00',4.14),('8784','2013-07-24','12:00:00',4.31),('8784','2013-07-24','12:05:00',4.09),('8784','2013-07-24','12:10:00',4.54),('8784','2013-07-24','12:15:00',4.33),('8784','2013-07-24','12:20:00',3.78),('8784','2013-07-24','12:25:00',1.8),('8784','2013-07-24','12:30:00',4.54),('8784','2013-07-24','12:35:00',2.15),('8784','2013-07-24','12:40:00',2.46),('8784','2013-07-24','12:45:00',2.81),('8784','2013-07-24','12:50:00',1.7),('8784','2013-07-24','12:55:00',4.25),('8784','2013-07-24','13:00:00',4.47),('8784','2013-07-24','13:05:00',4.23),('8784','2013-07-24','13:10:00',3.06),('8784','2013-07-24','13:15:00',2.45),('8784','2013-07-24','13:20:00',1.93),('8784','2013-07-24','13:25:00',4.12),('8784','2013-07-24','13:30:00',4.34),('8784','2013-07-24','13:35:00',2.9),('8784','2013-07-24','13:40:00',1.11),('8784','2013-07-24','13:45:00',3.15),('8784','2013-07-24','13:50:00',4.58),('8784','2013-07-24','13:55:00',4.59),('8784','2013-07-24','14:00:00',4.46),('8784','2013-07-24','14:05:00',4.29),('8784','2013-07-24','14:10:00',4.5),('8784','2013-07-24','14:15:00',4.21),('8784','2013-07-24','14:20:00',4.29),('8784','2013-07-24','14:25:00',4.4),('8784','2013-07-24','14:30:00',4.39),('8784','2013-07-24','14:35:00',4.48),('8784','2013-07-24','14:40:00',4.21),('8784','2013-07-24','14:45:00',4.26),('8784','2013-07-24','14:50:00',4.21),('8784','2013-07-24','14:55:00',4.17),('8784','2013-07-24','15:00:00',4.11),('8784','2013-07-24','15:05:00',4.05),('8784','2013-07-24','15:10:00',4.01),('8784','2013-07-24','15:15:00',3.99),('8784','2013-07-24','15:20:00',3.92),('8784','2013-07-24','15:25:00',3.89),('8784','2013-07-24','15:30:00',3.69),('8784','2013-07-24','15:35:00',3.62),('8784','2013-07-24','15:40:00',3.75),('8784','2013-07-24','15:45:00',3.62),('8784','2013-07-24','15:50:00',3.56),('8784','2013-07-24','15:55:00',3.56),('8784','2013-07-24','16:00:00',3.54),('8784','2013-07-24','16:05:00',3.43),('8784','2013-07-24','16:10:00',3.41),('8784','2013-07-24','16:15:00',3.4),('8784','2013-07-24','16:20:00',3.4),('8784','2013-07-24','16:25:00',3.36),('8784','2013-07-24','16:30:00',3.29),('8784','2013-07-24','16:35:00',3.21),('8784','2013-07-24','16:40:00',3.17),('8784','2013-07-24','16:45:00',3.04),('8784','2013-07-24','16:50:00',3.01),('8784','2013-07-24','16:55:00',3.04),('8784','2013-07-24','17:00:00',2.98),('8784','2013-07-24','17:05:00',2.86),('8784','2013-07-24','17:10:00',2.61),('8784','2013-07-24','17:15:00',2.61),('8784','2013-07-24','17:20:00',2.52),('8784','2013-07-24','17:25:00',2.41),('8784','2013-07-24','17:30:00',2.34),('8784','2013-07-24','17:35:00',2.21),('8784','2013-07-24','17:40:00',2.13),('8784','2013-07-24','17:45:00',2.03),('8784','2013-07-24','17:50:00',1.93),('8784','2013-07-24','17:55:00',1.84),('8784','2013-07-24','18:00:00',1.75),('8784','2013-07-24','18:05:00',1.64),('8784','2013-07-24','18:10:00',1.53),('8784','2013-07-24','18:15:00',1.46),('8784','2013-07-24','18:20:00',1.37),('8784','2013-07-24','18:25:00',1.33),('8784','2013-07-24','18:30:00',1.27),('8784','2013-07-24','18:35:00',1.21),('8784','2013-07-24','18:40:00',1.11),('8784','2013-07-23','07:35:00',1.05),('8784','2013-07-23','07:40:00',1.14),('8784','2013-07-23','07:45:00',1.2),('8784','2013-07-23','07:50:00',1.26),('8784','2013-07-23','07:55:00',1.33),('8784','2013-07-23','08:00:00',1.35),('8784','2013-07-23','08:05:00',1.48),('8784','2013-07-23','08:10:00',1.61),('8784','2013-07-23','08:15:00',1.71),('8784','2013-07-23','08:20:00',1.74),('8784','2013-07-23','08:25:00',1.84),('8784','2013-07-23','08:30:00',1.94),('8784','2013-07-23','08:35:00',2.02),('8784','2013-07-23','08:40:00',2.12),('8784','2013-07-23','08:45:00',2.2),('8784','2013-07-23','08:50:00',2.29),('8784','2013-07-23','08:55:00',2.38),('8784','2013-07-23','09:00:00',2.46),('8784','2013-07-23','09:05:00',2.49),('8784','2013-07-23','09:10:00',2.55),('8784','2013-07-23','09:15:00',2.61),('8784','2013-07-23','09:20:00',2.66),('8784','2013-07-23','09:25:00',2.74),('8784','2013-07-23','09:30:00',2.78),('8784','2013-07-23','09:35:00',2.81),('8784','2013-07-23','09:40:00',2.88),('8784','2013-07-23','09:45:00',2.92),('8784','2013-07-23','09:50:00',2.98),('8784','2013-07-23','09:55:00',3.05),('8784','2013-07-23','10:00:00',3.08),('8784','2013-07-23','10:05:00',3.13),('8784','2013-07-23','10:10:00',3.18),('8784','2013-07-23','10:15:00',3.2),('8784','2013-07-23','10:20:00',3.29),('8784','2013-07-23','10:25:00',3.38),('8784','2013-07-23','10:30:00',3.48),('8784','2013-07-23','10:35:00',3.53),('8784','2013-07-23','10:40:00',3.58),('8784','2013-07-23','10:45:00',3.6),('8784','2013-07-23','10:50:00',3.62),('8784','2013-07-23','10:55:00',3.7),('8784','2013-07-23','11:00:00',3.71),('8784','2013-07-23','11:05:00',3.75),('8784','2013-07-23','11:10:00',3.81),('8784','2013-07-23','11:15:00',3.86),('8784','2013-07-23','11:20:00',3.88),('8784','2013-07-23','11:25:00',3.88),('8784','2013-07-23','11:30:00',3.92),('8784','2013-07-23','11:35:00',3.96),('8784','2013-07-23','11:40:00',4.02),('8784','2013-07-23','11:45:00',4.02),('8784','2013-07-23','11:50:00',4.01),('8784','2013-07-23','11:55:00',4.11),('8784','2013-07-23','12:00:00',4.13),('8784','2013-07-23','12:05:00',4.17),('8784','2013-07-23','12:10:00',4.2),('8784','2013-07-23','12:15:00',4.22),('8784','2013-07-23','12:20:00',4.18),('8784','2013-07-23','12:25:00',4.1),('8784','2013-07-23','12:30:00',3.99),('8784','2013-07-23','12:35:00',2.05),('8784','2013-07-23','12:45:00',1.88),('8784','2013-07-23','12:50:00',1.81),('8784','2013-07-23','12:55:00',4.12),('8784','2013-07-23','13:00:00',1.52),('8784','2013-07-23','13:05:00',1),('8784','2013-07-23','13:30:00',2.83),('8784','2013-07-23','13:35:00',4.51),('8784','2013-07-23','13:40:00',2.27),('8784','2013-07-23','13:55:00',2),('8784','2013-07-23','14:00:00',4.18),('8784','2013-07-23','14:05:00',4.13),('8784','2013-07-23','14:10:00',1.21),('8784','2013-07-23','14:25:00',1.64),('8784','2013-07-23','14:30:00',2.27),('8784','2013-07-23','14:35:00',2.25),('8784','2013-07-23','14:40:00',1.79),('8784','2013-07-23','14:45:00',2.97),('8784','2013-07-23','14:50:00',2),('8784','2013-07-23','14:55:00',3),('8784','2013-07-23','15:00:00',4.67),('8784','2013-07-23','15:05:00',3.72),('8784','2013-07-23','15:10:00',4),('8784','2013-07-23','15:15:00',4.01),('8784','2013-07-23','15:20:00',3.85),('8784','2013-07-23','15:25:00',3.8),('8784','2013-07-23','15:30:00',3.73),('8784','2013-07-23','15:35:00',3.76),('8784','2013-07-23','15:40:00',3.56),('8784','2013-07-23','15:45:00',3.52),('8784','2013-07-23','15:50:00',3.52),('8784','2013-07-23','15:55:00',3.48),('8784','2013-07-23','16:00:00',3.44),('8784','2013-07-23','16:05:00',3.38),('8784','2013-07-23','16:10:00',3.29),('8784','2013-07-23','16:15:00',3.24),('8784','2013-07-23','16:20:00',3.22),('8784','2013-07-23','16:25:00',3.15),('8784','2013-07-23','16:30:00',3.08),('8784','2013-07-23','16:35:00',3.01),('8784','2013-07-23','16:40:00',2.96),('8784','2013-07-23','16:45:00',2.89),('8784','2013-07-23','16:50:00',2.84),('8784','2013-07-23','16:55:00',2.77),('8784','2013-07-23','17:00:00',2.69),('8784','2013-07-23','17:05:00',2.61),('8784','2013-07-23','17:10:00',2.57),('8784','2013-07-23','17:15:00',2.5),('8784','2013-07-23','17:20:00',2.44),('8784','2013-07-23','17:25:00',2.36),('8784','2013-07-23','17:30:00',2.29),('8784','2013-07-23','17:35:00',2.23),('8784','2013-07-23','17:40:00',2.15),('8784','2013-07-23','17:45:00',2.07),('8784','2013-07-23','17:50:00',1.99),('8784','2013-07-23','17:55:00',1.9),('8784','2013-07-23','18:00:00',1.83),('8784','2013-07-23','18:05:00',1.74),('8784','2013-07-23','18:10:00',1.65),('8784','2013-07-23','18:15:00',1.57),('8784','2013-07-23','18:20:00',1.5),('8784','2013-07-23','18:25:00',1.41),('8784','2013-07-23','18:30:00',1.34),('8784','2013-07-23','18:35:00',1.23),('8784','2013-07-22','07:35:00',1.02),('8784','2013-07-22','07:40:00',1.1),('8784','2013-07-22','07:45:00',1.16),('8784','2013-07-22','07:50:00',1.23),('8784','2013-07-22','07:55:00',1.3),('8784','2013-07-22','08:00:00',1.4),('8784','2013-07-22','08:05:00',1.49),('8784','2013-07-22','08:10:00',1.59),('8784','2013-07-22','08:15:00',1.67),('8784','2013-07-22','08:20:00',1.75),('8784','2013-07-22','08:25:00',1.85),('8784','2013-07-22','08:30:00',1.93),('8784','2013-07-22','08:35:00',2.01),('8784','2013-07-22','08:40:00',2.1),('8784','2013-07-22','08:45:00',2.16),('8784','2013-07-22','08:50:00',2.24),('8784','2013-07-22','08:55:00',2.31),('8784','2013-07-22','09:00:00',2.39),('8784','2013-07-22','09:05:00',2.49),('8784','2013-07-22','09:10:00',2.55),('8784','2013-07-22','09:15:00',2.63),('8784','2013-07-22','09:20:00',2.69),('8784','2013-07-22','09:25:00',2.74),('8784','2013-07-22','09:30:00',2.81),('8784','2013-07-22','09:35:00',2.87),('8784','2013-07-22','09:40:00',2.93),('8784','2013-07-22','09:45:00',2.99),('8784','2013-07-22','09:50:00',3.07),('8784','2013-07-22','09:55:00',3.13),('8784','2013-07-22','10:00:00',3.2),('8784','2013-07-22','10:05:00',3.22),('8784','2013-07-22','10:10:00',3.3),('8784','2013-07-22','10:15:00',3.36),('8784','2013-07-22','10:20:00',3.42),('8784','2013-07-22','10:25:00',3.46),('8784','2013-07-22','10:30:00',3.52),('8784','2013-07-22','10:35:00',3.57),('8784','2013-07-22','10:40:00',3.6),('8784','2013-07-22','10:45:00',3.63),('8784','2013-07-22','10:50:00',3.67),('8784','2013-07-22','10:55:00',3.71),('8784','2013-07-22','11:00:00',3.74),('8784','2013-07-22','11:05:00',3.78),('8784','2013-07-22','11:10:00',3.8),('8784','2013-07-22','11:15:00',3.86),('8784','2013-07-22','11:20:00',3.85),('8784','2013-07-22','11:25:00',3.9),('8784','2013-07-22','11:30:00',3.9),('8784','2013-07-22','11:35:00',3.91),('8784','2013-07-22','11:40:00',3.98),('8784','2013-07-22','11:45:00',3.98),('8784','2013-07-22','11:50:00',4),('8784','2013-07-22','11:55:00',4.02),('8784','2013-07-22','12:00:00',4.02),('8784','2013-07-22','12:05:00',4.06),('8784','2013-07-22','12:10:00',4.1),('8784','2013-07-22','12:15:00',4.13),('8784','2013-07-22','12:20:00',4.19),('8784','2013-07-22','12:25:00',4.17),('8784','2013-07-22','12:30:00',4.18),('8784','2013-07-22','12:35:00',4.21),('8784','2013-07-22','12:40:00',4.23),('8784','2013-07-22','12:45:00',4.18),('8784','2013-07-22','12:50:00',4.19),('8784','2013-07-22','12:55:00',4.18),('8784','2013-07-22','13:00:00',4.16),('8784','2013-07-22','13:05:00',4.16),('8784','2013-07-22','13:10:00',4.18),('8784','2013-07-22','13:15:00',4.19),('8784','2013-07-22','13:20:00',4.21),('8784','2013-07-22','13:25:00',4.24),('8784','2013-07-22','13:30:00',4.2),('8784','2013-07-22','13:35:00',4.19),('8784','2013-07-22','13:40:00',4.2),('8784','2013-07-22','13:45:00',4.23),('8784','2013-07-22','13:50:00',4.2),('8784','2013-07-22','13:55:00',4.15),('8784','2013-07-22','14:00:00',4.12),('8784','2013-07-22','14:05:00',4.12),('8784','2013-07-22','14:10:00',4.11),('8784','2013-07-22','14:15:00',4.07),('8784','2013-07-22','14:20:00',4.03),('8784','2013-07-22','14:25:00',4.03),('8784','2013-07-22','14:30:00',4.04),('8784','2013-07-22','14:35:00',3.98),('8784','2013-07-22','14:40:00',3.95),('8784','2013-07-22','14:45:00',3.96),('8784','2013-07-22','14:50:00',3.92),('8784','2013-07-22','14:55:00',3.8),('8784','2013-07-22','15:00:00',3.8),('8784','2013-07-22','15:05:00',3.79),('8784','2013-07-22','15:10:00',3.83),('8784','2013-07-22','15:15:00',3.77),('8784','2013-07-22','15:20:00',3.73),('8784','2013-07-22','15:25:00',3.74),('8784','2013-07-22','15:30:00',1.78),('8784','2013-07-22','15:40:00',1.53),('8784','2013-07-22','15:45:00',3.12),('8784','2013-07-22','15:50:00',3.82),('8784','2013-07-22','15:55:00',3.94),('8784','2013-07-22','16:00:00',3.92),('8784','2013-07-22','16:05:00',3.79),('8784','2013-07-22','16:10:00',3.32),('8784','2013-07-22','16:15:00',3.13),('8784','2013-07-22','16:20:00',3.56),('8784','2013-07-22','16:25:00',3.38),('8784','2013-07-22','16:30:00',3.21),('8784','2013-07-22','16:35:00',3.14),('8784','2013-07-22','16:40:00',2.91),('8784','2013-07-22','16:45:00',2.84),('8784','2013-07-22','16:50:00',2.77),('8784','2013-07-22','16:55:00',2.73),('8784','2013-07-22','17:00:00',2.66),('8784','2013-07-22','17:05:00',2.62),('8784','2013-07-22','17:10:00',2.54),('8784','2013-07-22','17:15:00',2.47),('8784','2013-07-22','17:20:00',2.4),('8784','2013-07-22','17:25:00',2.26),('8784','2013-07-22','17:30:00',2.16),('8784','2013-07-22','17:35:00',2.2),('8784','2013-07-22','17:40:00',2.1),('8784','2013-07-22','17:45:00',1.89),('8784','2013-07-22','17:50:00',1.83),('8784','2013-07-22','17:55:00',1.8),('8784','2013-07-22','18:00:00',1.8),('8784','2013-07-22','18:05:00',1.7),('8784','2013-07-22','18:10:00',1.55),('8784','2013-07-22','18:15:00',1.42),('8784','2013-07-22','18:20:00',1.37),('8784','2013-07-22','18:25:00',1.33),('8784','2013-07-22','18:30:00',1.24),('8784','2013-07-22','18:35:00',1.17),('8784','2013-07-22','18:40:00',1.05),('8784','2013-07-21','07:40:00',1.08),('8784','2013-07-21','07:45:00',1.19),('8784','2013-07-21','07:50:00',1.23),('8784','2013-07-21','07:55:00',1.28),('8784','2013-07-21','08:00:00',1.33),('8784','2013-07-21','08:05:00',1.41),('8784','2013-07-21','08:10:00',1.5),('8784','2013-07-21','08:15:00',1.58),('8784','2013-07-21','08:20:00',1.61),('8784','2013-07-21','08:25:00',1.69),('8784','2013-07-21','08:30:00',1.8),('8784','2013-07-21','08:35:00',1.89),('8784','2013-07-21','08:40:00',1.99),('8784','2013-07-21','08:45:00',2.05),('8784','2013-07-21','08:50:00',2.07),('8784','2013-07-21','08:55:00',2.22),('8784','2013-07-21','09:00:00',2.3),('8784','2013-07-21','09:05:00',2.36),('8784','2013-07-21','09:10:00',2.46),('8784','2013-07-21','09:15:00',2.54),('8784','2013-07-21','09:20:00',2.58),('8784','2013-07-21','09:25:00',2.67),('8784','2013-07-21','09:30:00',2.73),('8784','2013-07-21','09:35:00',2.78),('8784','2013-07-21','09:40:00',2.85),('8784','2013-07-21','09:45:00',2.92),('8784','2013-07-21','09:50:00',2.96),('8784','2013-07-21','09:55:00',3.01),('8784','2013-07-21','10:00:00',3.1),('8784','2013-07-21','10:05:00',3.16),('8784','2013-07-21','10:10:00',3.2),('8784','2013-07-21','10:15:00',3.26),('8784','2013-07-21','10:20:00',3.29),('8784','2013-07-21','10:25:00',3.36),('8784','2013-07-21','10:30:00',3.41),('8784','2013-07-21','10:35:00',3.45),('8784','2013-07-21','10:40:00',3.48),('8784','2013-07-21','10:45:00',3.53),('8784','2013-07-21','10:50:00',3.61),('8784','2013-07-21','10:55:00',3.61),('8784','2013-07-21','11:00:00',3.68),('8784','2013-07-21','11:05:00',3.71),('8784','2013-07-21','11:10:00',3.73),('8784','2013-07-21','11:15:00',3.75),('8784','2013-07-21','11:20:00',3.77),('8784','2013-07-21','11:25:00',3.86),('8784','2013-07-21','11:30:00',3.91),('8784','2013-07-21','11:35:00',3.89),('8784','2013-07-21','11:40:00',4.03),('8784','2013-07-21','11:45:00',4.07),('8784','2013-07-21','11:50:00',4.02),('8784','2013-07-21','11:55:00',4.03),('8784','2013-07-21','12:00:00',4.05),('8784','2013-07-21','12:05:00',4.15),('8784','2013-07-21','12:10:00',4.23),('8784','2013-07-21','12:15:00',4.34),('8784','2013-07-21','12:20:00',4.39),('8784','2013-07-21','12:25:00',4.69),('8784','2013-07-21','12:30:00',4.77),('8784','2013-07-21','12:35:00',4.84),('8784','2013-07-21','12:40:00',4.93),('8784','2013-07-21','12:45:00',4.72),('8784','2013-07-21','12:50:00',3.83),('8784','2013-07-21','12:55:00',5.16),('8784','2013-07-21','13:00:00',4.45),('8784','2013-07-21','13:05:00',4.95),('8784','2013-07-21','13:10:00',4.05),('8784','2013-07-21','13:15:00',3.95),('8784','2013-07-21','13:20:00',4.17),('8784','2013-07-21','13:25:00',4.29),('8784','2013-07-21','13:30:00',4.66),('8784','2013-07-21','13:35:00',4.54),('8784','2013-07-21','13:40:00',4.4),('8784','2013-07-21','13:45:00',4.3),('8784','2013-07-21','13:50:00',2.25),('8784','2013-07-21','13:55:00',1.06),('8784','2013-07-21','14:00:00',1.11),('8784','2013-07-21','14:05:00',1.21),('8784','2013-07-21','14:10:00',1.13),('8784','2013-07-21','14:15:00',1.12),('8784','2013-07-21','14:20:00',1.38),('8784','2013-07-21','14:25:00',1.52),('8784','2013-07-21','14:30:00',1.31),('8784','2013-07-21','14:35:00',1.4),('8784','2013-07-21','14:40:00',1.34),('8784','2013-07-21','14:45:00',1.51),('8784','2013-07-21','14:50:00',1.77),('8784','2013-07-21','14:55:00',1.75),('8784','2013-07-21','15:00:00',1.97),('8784','2013-07-21','15:05:00',1.78),('8784','2013-07-21','15:10:00',1.86),('8784','2013-07-21','15:15:00',4.06),('8784','2013-07-21','15:20:00',4.86),('8784','2013-07-21','15:25:00',1.76),('8784','2013-07-21','15:30:00',1.56),('8784','2013-07-21','15:35:00',1.75),('8784','2013-07-21','15:40:00',2.73),('8784','2013-07-21','15:45:00',3.92),('8784','2013-07-21','15:50:00',3.2),('8784','2013-07-21','15:55:00',2.2),('8784','2013-07-21','16:00:00',1.44),('8784','2013-07-21','16:05:00',1.09),('8784','2013-07-21','16:50:00',1.01),('8784','2013-07-21','16:55:00',1.13),('8784','2013-07-21','17:00:00',1.25),('8784','2013-07-21','17:05:00',1.35),('8784','2013-07-21','17:10:00',1.41),('8784','2013-07-21','17:15:00',1.17),('8784','2013-07-21','17:20:00',1.05),('8784','2014-04-07','08:20:00',1.1),('8784','2014-04-07','08:25:00',1.14),('8784','2014-04-07','08:30:00',1.29),('8784','2014-04-07','08:35:00',1.74),('8784','2014-04-07','08:40:00',1.79),('8784','2014-04-07','08:45:00',1.6),('8784','2014-04-07','08:50:00',1.49),('8784','2014-04-07','08:55:00',1.33),('8784','2014-04-07','09:00:00',1.25),('8784','2014-04-07','09:05:00',1.27),('8784','2014-04-07','09:10:00',1.47),('8784','2014-04-07','09:15:00',1.73),('8784','2014-04-07','09:20:00',1.38),('8784','2014-04-07','09:25:00',1.29),('8784','2014-04-07','09:30:00',1.28),('8784','2014-04-07','09:35:00',1.23),('8784','2014-04-07','09:40:00',1.26),('8784','2014-04-07','09:45:00',1.33),('8784','2014-04-07','09:50:00',1.4),('8784','2014-04-07','09:55:00',1.48),('8784','2014-04-07','10:00:00',1.48),('8784','2014-04-07','10:05:00',1.48),('8784','2014-04-07','10:10:00',1.52),('8784','2014-04-07','10:15:00',1.4),('8784','2014-04-07','10:20:00',1.4),('8784','2014-04-07','10:25:00',1.44),('8784','2014-04-07','10:30:00',1.48),('8784','2014-04-07','10:35:00',1.57),('8784','2014-04-07','10:40:00',1.6),('8784','2014-04-07','10:45:00',1.66),('8784','2014-04-07','10:50:00',1.74),('8784','2014-04-07','10:55:00',1.86),('8784','2014-04-07','11:00:00',2.01),('8784','2014-04-07','11:05:00',2.08),('8784','2014-04-07','11:10:00',2.32),('8784','2014-04-07','11:15:00',2.43),('8784','2014-04-07','11:20:00',2.46),('8784','2014-04-07','11:25:00',2.14),('8784','2014-04-07','11:30:00',2.15),('8784','2014-04-07','11:35:00',2.13),('8784','2014-04-07','11:40:00',2.07),('8784','2014-04-07','11:45:00',1.97),('8784','2014-04-07','11:50:00',1.86),('8784','2014-04-07','11:55:00',1.8),('8784','2014-04-07','12:00:00',2),('8784','2014-04-07','12:05:00',2.45),('8784','2014-04-07','12:10:00',2.62),('8784','2014-04-07','12:15:00',3.47),('8784','2014-04-07','12:20:00',4.13),('8784','2014-04-07','12:25:00',3.84),('8784','2014-04-07','12:30:00',2.41),('8784','2014-04-07','12:35:00',2.2),('8784','2014-04-07','12:40:00',2.7),('8784','2014-04-07','12:45:00',4.05),('8784','2014-04-07','12:50:00',4.1),('8784','2014-04-07','12:55:00',4.02),('8784','2014-04-07','13:00:00',4.04),('8784','2014-04-07','13:05:00',4.06),('8784','2014-04-07','13:10:00',4.01),('8784','2014-04-07','13:15:00',4),('8784','2014-04-07','13:20:00',3.98),('8784','2014-04-07','13:25:00',3.98),('8784','2014-04-07','13:30:00',3.99),('8784','2014-04-07','13:35:00',3.96),('8784','2014-04-07','13:40:00',3.94),('8784','2014-04-07','13:45:00',3.92),('8784','2014-04-07','13:50:00',3.95),('8784','2014-04-07','13:55:00',3.96),('8784','2014-04-07','14:00:00',3.95),('8784','2014-04-07','14:05:00',3.91),('8784','2014-04-07','14:10:00',3.85),('8784','2014-04-07','14:15:00',3.81),('8784','2014-04-07','14:20:00',3.81),('8784','2014-04-07','14:25:00',3.91),('8784','2014-04-07','14:30:00',3.87),('8784','2014-04-07','14:35:00',3.77),('8784','2014-04-07','14:40:00',3.73),('8784','2014-04-07','14:45:00',3.61),('8784','2014-04-07','14:50:00',3.71),('8784','2014-04-07','14:55:00',3.56),('8784','2014-04-07','15:00:00',2.99),('8784','2014-04-07','15:05:00',3.7),('8784','2014-04-07','15:10:00',3.58),('8784','2014-04-07','15:15:00',3.7),('8784','2014-04-07','15:20:00',3.83),('8784','2014-04-07','15:25:00',3.79),('8784','2014-04-07','15:30:00',3.46),('8784','2014-04-07','15:35:00',3.48),('8784','2014-04-07','15:40:00',3.4),('8784','2014-04-07','15:45:00',3.49),('8784','2014-04-07','15:50:00',3.65),('8784','2014-04-07','15:55:00',3.59),('8784','2014-04-07','16:00:00',2.61),('8784','2014-04-07','16:05:00',1.96),('8784','2014-04-07','16:10:00',3.03),('8784','2014-04-07','16:15:00',2.89),('8784','2014-04-07','16:20:00',2.66),('8784','2014-04-07','16:25:00',2.6),('8784','2014-04-07','16:30:00',2.42),('8784','2014-04-07','16:35:00',1.37),('8784','2014-04-07','16:40:00',1.38),('8784','2014-04-07','16:45:00',1.82),('8784','2014-04-07','16:50:00',2.42),('8784','2014-04-07','16:55:00',2.49),('8784','2014-04-07','17:00:00',2.56),('8784','2014-04-07','17:05:00',2.39),('8784','2014-04-07','17:10:00',1.78),('8784','2014-04-07','17:15:00',1.87),('8784','2014-04-07','17:20:00',1.48),('8784','2014-04-07','17:55:00',1.13),('8784','2014-04-07','18:00:00',1.03),('8784','2013-07-20','07:35:00',1.04),('8784','2013-07-20','07:40:00',1.1),('8784','2013-07-20','07:45:00',1.18),('8784','2013-07-20','07:50:00',1.27),('8784','2013-07-20','07:55:00',1.34),('8784','2013-07-20','08:00:00',1.41),('8784','2013-07-20','08:05:00',1.49),('8784','2013-07-20','08:10:00',1.58),('8784','2013-07-20','08:15:00',1.67),('8784','2013-07-20','08:20:00',1.73),('8784','2013-07-20','08:25:00',1.85),('8784','2013-07-20','08:30:00',1.93),('8784','2013-07-20','08:35:00',2),('8784','2013-07-20','08:40:00',2.1),('8784','2013-07-20','08:45:00',2.19),('8784','2013-07-20','08:50:00',2.24),('8784','2013-07-20','08:55:00',2.34),('8784','2013-07-20','09:00:00',2.42),('8784','2013-07-20','09:05:00',2.53),('8784','2013-07-20','09:10:00',2.65),('8784','2013-07-20','09:15:00',2.75),('8784','2013-07-20','09:20:00',2.76),('8784','2013-07-20','09:25:00',2.73),('8784','2013-07-20','09:30:00',2.72),('8784','2013-07-20','09:35:00',2.76),('8784','2013-07-20','09:40:00',2.78),('8784','2013-07-20','09:45:00',3.03),('8784','2013-07-20','09:50:00',2.97),('8784','2013-07-20','09:55:00',2.97),('8784','2013-07-20','10:00:00',3.17),('8784','2013-07-20','10:05:00',3.24),('8784','2013-07-20','10:10:00',3.32),('8784','2013-07-20','10:15:00',3.34),('8784','2013-07-20','10:20:00',3.4),('8784','2013-07-20','10:25:00',3.44),('8784','2013-07-20','10:30:00',3.48),('8784','2013-07-20','10:35:00',3.51),('8784','2013-07-20','10:40:00',3.55),('8784','2013-07-20','10:45:00',3.58),('8784','2013-07-20','10:50:00',3.62),('8784','2013-07-20','10:55:00',3.69),('8784','2013-07-20','11:00:00',3.74),('8784','2013-07-20','11:05:00',3.73),('8784','2013-07-20','11:10:00',3.76),('8784','2013-07-20','11:15:00',3.79),('8784','2013-07-20','11:20:00',3.78),('8784','2013-07-20','11:25:00',3.81),('8784','2013-07-20','11:30:00',3.87),('8784','2013-07-20','11:35:00',3.91),('8784','2013-07-20','11:40:00',3.95),('8784','2013-07-20','11:45:00',4.03),('8784','2013-07-20','11:50:00',4.02),('8784','2013-07-20','11:55:00',4.09),('8784','2013-07-20','12:00:00',4.12),('8784','2013-07-20','12:05:00',4.2),('8784','2013-07-20','12:10:00',4.23),('8784','2013-07-20','12:15:00',4.2),('8784','2013-07-20','12:20:00',4.21),('8784','2013-07-20','12:25:00',4.19),('8784','2013-07-20','12:30:00',4.16),('8784','2013-07-20','12:35:00',4.21),('8784','2013-07-20','12:40:00',4.24),('8784','2013-07-20','12:45:00',4.31),('8784','2013-07-20','12:50:00',4.31),('8784','2013-07-20','12:55:00',4.3),('8784','2013-07-20','13:00:00',4.42),('8784','2013-07-20','13:05:00',4.41),('8784','2013-07-20','13:10:00',2.24),('8784','2013-07-20','13:15:00',1.07),('8784','2013-07-20','13:20:00',1.98),('8784','2013-07-20','13:25:00',1.56),('8784','2013-07-20','13:30:00',4.61),('8784','2013-07-20','13:35:00',4.55),('8784','2013-07-20','13:40:00',4.56),('8784','2013-07-20','13:45:00',3.98),('8784','2013-07-20','13:50:00',1.26),('8784','2013-07-20','14:00:00',3.07),('8784','2013-07-20','14:05:00',4.45),('8784','2013-07-20','14:10:00',4.46),('8784','2013-07-20','14:15:00',4.5),('8784','2013-07-20','14:20:00',4.36),('8784','2013-07-20','14:25:00',4.23),('8784','2013-07-20','14:30:00',4.08),('8784','2013-07-20','14:35:00',4.14),('8784','2013-07-20','14:40:00',4.21),('8784','2013-07-20','14:45:00',4.16),('8784','2013-07-20','14:50:00',4.2),('8784','2013-07-20','14:55:00',4.12),('8784','2013-07-20','15:00:00',4.17),('8784','2013-07-20','15:05:00',4.04),('8784','2013-07-20','15:10:00',4),('8784','2013-07-20','15:15:00',3.91),('8784','2013-07-20','15:20:00',3.82),('8784','2013-07-20','15:25:00',3.78),('8784','2013-07-20','15:30:00',3.73),('8784','2013-07-20','15:35:00',3.67),('8784','2013-07-20','15:40:00',3.64),('8784','2013-07-20','15:45:00',3.6),('8784','2013-07-20','15:50:00',3.54),('8784','2013-07-20','15:55:00',3.47),('8784','2013-07-20','16:00:00',3.43),('8784','2013-07-20','16:05:00',3.41),('8784','2013-07-20','16:10:00',3.34),('8784','2013-07-20','16:15:00',3.32),('8784','2013-07-20','16:20:00',3.25),('8784','2013-07-20','16:25:00',3.19),('8784','2013-07-20','16:30:00',3.11),('8784','2013-07-20','16:35:00',3),('8784','2013-07-20','16:40:00',2.97),('8784','2013-07-20','16:45:00',2.91),('8784','2013-07-20','16:50:00',2.85),('8784','2013-07-20','16:55:00',2.73),('8784','2013-07-20','17:00:00',2.67),('8784','2013-07-20','17:05:00',2.61),('8784','2013-07-20','17:10:00',2.53),('8784','2013-07-20','17:15:00',2.46),('8784','2013-07-20','17:20:00',2.37),('8784','2013-07-20','17:25:00',2.31),('8784','2013-07-20','17:30:00',2.25),('8784','2013-07-20','17:35:00',2.19),('8784','2013-07-20','17:40:00',2.1),('8784','2013-07-20','17:45:00',2.03),('8784','2013-07-20','17:50:00',1.96),('8784','2013-07-20','17:55:00',1.86),('8784','2013-07-20','18:00:00',1.79),('8784','2013-07-20','18:05:00',1.7),('8784','2013-07-20','18:10:00',1.62),('8784','2013-07-20','18:15:00',1.53),('8784','2013-07-20','18:20:00',1.46),('8784','2013-07-20','18:25:00',1.38),('8784','2013-07-20','18:30:00',1.3),('8784','2013-07-20','18:35:00',1.21),('8784','2013-07-20','18:40:00',1.13),('8784','2013-07-20','18:45:00',1.04),('8784','2013-07-19','07:35:00',1),('8784','2013-07-19','07:40:00',1.08),('8784','2013-07-19','07:45:00',1.16),('8784','2013-07-19','07:50:00',1.24),('8784','2013-07-19','07:55:00',1.31),('8784','2013-07-19','08:00:00',1.39),('8784','2013-07-19','08:05:00',1.45),('8784','2013-07-19','08:10:00',1.53),('8784','2013-07-19','08:15:00',1.61),('8784','2013-07-19','08:20:00',1.67),('8784','2013-07-19','08:25:00',1.75),('8784','2013-07-19','08:30:00',1.84),('8784','2013-07-19','08:35:00',1.93),('8784','2013-07-19','08:40:00',2.02),('8784','2013-07-19','08:45:00',2.12),('8784','2013-07-19','08:50:00',2.17),('8784','2013-07-19','08:55:00',2.26),('8784','2013-07-19','09:00:00',2.31),('8784','2013-07-19','09:05:00',2.39),('8784','2013-07-19','09:10:00',2.46),('8784','2013-07-19','09:15:00',2.53),('8784','2013-07-19','09:20:00',2.59),('8784','2013-07-19','09:25:00',2.63),('8784','2013-07-19','09:30:00',2.72),('8784','2013-07-19','09:35:00',2.75),('8784','2013-07-19','09:40:00',2.82),('8784','2013-07-19','09:45:00',2.89),('8784','2013-07-19','09:50:00',2.94),('8784','2013-07-19','09:55:00',2.99),('8784','2013-07-19','10:00:00',3.04),('8784','2013-07-19','10:05:00',3.08),('8784','2013-07-19','10:10:00',3.15),('8784','2013-07-19','10:15:00',3.2),('8784','2013-07-19','10:20:00',3.22),('8784','2013-07-19','10:25:00',3.31),('8784','2013-07-19','10:30:00',3.31),('8784','2013-07-19','10:35:00',3.38),('8784','2013-07-19','10:40:00',3.44),('8784','2013-07-19','10:45:00',3.49),('8784','2013-07-19','10:50:00',3.48),('8784','2013-07-19','10:55:00',3.51),('8784','2013-07-19','11:00:00',3.54),('8784','2013-07-19','11:05:00',3.59),('8784','2013-07-19','11:10:00',3.65),('8784','2013-07-19','11:15:00',3.7),('8784','2013-07-19','11:20:00',3.76),('8784','2013-07-19','11:25:00',3.77),('8784','2013-07-19','11:30:00',3.77),('8784','2013-07-19','11:35:00',3.81),('8784','2013-07-19','11:40:00',3.9),('8784','2013-07-19','11:45:00',3.87),('8784','2013-07-19','11:50:00',3.82),('8784','2013-07-19','11:55:00',3.88),('8784','2013-07-19','12:00:00',3.72),('8784','2013-07-19','12:05:00',4.15),('8784','2013-07-19','12:10:00',4.12),('8784','2013-07-19','12:15:00',4.24),('8784','2013-07-19','12:20:00',4.24),('8784','2013-07-19','12:25:00',4.15),('8784','2013-07-19','12:30:00',4.16),('8784','2013-07-19','12:35:00',4.12),('8784','2013-07-19','12:40:00',4.08),('8784','2013-07-19','12:45:00',3.94),('8784','2013-07-19','12:50:00',4.19),('8784','2013-07-19','12:55:00',4.28),('8784','2013-07-19','13:00:00',4.15),('8784','2013-07-19','13:05:00',4.24),('8784','2013-07-19','13:10:00',3.75),('8784','2013-07-19','13:15:00',1.57),('8784','2013-07-19','13:20:00',2.93),('8784','2013-07-19','13:25:00',4.69),('8784','2013-07-19','13:30:00',4.48),('8784','2013-07-19','13:35:00',4.37),('8784','2013-07-19','13:40:00',4.37),('8784','2013-07-19','13:45:00',4.34),('8784','2013-07-19','13:50:00',4.39),('8784','2013-07-19','13:55:00',4.38),('8784','2013-07-19','14:00:00',4.34),('8784','2013-07-19','14:05:00',4.32),('8784','2013-07-19','14:10:00',3.57),('8784','2013-07-19','14:15:00',3.93),('8784','2013-07-19','14:20:00',4.24),('8784','2013-07-19','14:25:00',3.98),('8784','2013-07-19','14:30:00',4.31),('8784','2013-07-19','14:35:00',3.99),('8784','2013-07-19','14:40:00',3.68),('8784','2013-07-19','14:45:00',4.18),('8784','2013-07-19','14:50:00',3.94),('8784','2013-07-19','14:55:00',4.2),('8784','2013-07-19','15:00:00',4.08),('8784','2013-07-19','15:05:00',4.1),('8784','2013-07-19','15:10:00',4.01),('8784','2013-07-19','15:15:00',2.2),('8784','2013-07-19','15:20:00',3.12),('8784','2013-07-19','15:25:00',3.37),('8784','2013-07-19','15:30:00',4.04),('8784','2013-07-19','15:35:00',3.94),('8784','2013-07-19','15:40:00',3.92),('8784','2013-07-19','15:45:00',3.78),('8784','2013-07-19','15:50:00',3.72),('8784','2013-07-19','15:55:00',3.66),('8784','2013-07-19','16:00:00',3.58),('8784','2013-07-19','16:05:00',3.53),('8784','2013-07-19','16:10:00',3.5),('8784','2013-07-19','16:15:00',3.42),('8784','2013-07-19','16:20:00',3.37),('8784','2013-07-19','16:25:00',3.31),('8784','2013-07-19','16:30:00',3.29),('8784','2013-07-19','16:35:00',3.25),('8784','2013-07-19','16:40:00',3.18),('8784','2013-07-19','16:45:00',3.14),('8784','2013-07-19','16:50:00',3.09),('8784','2013-07-19','16:55:00',3.1),('8784','2013-07-19','17:00:00',2.7),('8784','2013-07-19','17:05:00',3.08),('8784','2013-07-19','17:10:00',2.69),('8784','2013-07-19','17:15:00',2.74),('8784','2013-07-19','17:20:00',2.47),('8784','2013-07-19','17:25:00',2.01),('8784','2013-07-19','17:30:00',2.36),('8784','2013-07-19','17:35:00',2.53),('8784','2013-07-19','17:40:00',1.98),('8784','2013-07-19','17:45:00',1.45),('8784','2013-07-19','17:50:00',1.06),('8784','2013-07-18','07:30:00',1.01),('8784','2013-07-18','07:35:00',1.09),('8784','2013-07-18','07:40:00',1.16),('8784','2013-07-18','07:45:00',1.25),('8784','2013-07-18','07:50:00',1.34),('8784','2013-07-18','07:55:00',1.42),('8784','2013-07-18','08:00:00',1.48),('8784','2013-07-18','08:05:00',1.55),('8784','2013-07-18','08:10:00',1.64),('8784','2013-07-18','08:15:00',1.65),('8784','2013-07-18','08:20:00',1.75),('8784','2013-07-18','08:25:00',1.84),('8784','2013-07-18','08:30:00',1.95),('8784','2013-07-18','08:35:00',2.06),('8784','2013-07-18','08:40:00',2.14),('8784','2013-07-18','08:45:00',2.21),('8784','2013-07-18','08:50:00',2.28),('8784','2013-07-18','08:55:00',2.34),('8784','2013-07-18','09:00:00',2.43),('8784','2013-07-18','09:05:00',2.47),('8784','2013-07-18','09:10:00',2.55),('8784','2013-07-18','09:15:00',2.63),('8784','2013-07-18','09:20:00',2.7),('8784','2013-07-18','09:25:00',2.75),('8784','2013-07-18','09:30:00',2.83),('8784','2013-07-18','09:35:00',2.9),('8784','2013-07-18','09:40:00',2.96),('8784','2013-07-18','09:45:00',2.99),('8784','2013-07-18','09:50:00',3.08),('8784','2013-07-18','09:55:00',3.13),('8784','2013-07-18','10:00:00',3.18),('8784','2013-07-18','10:05:00',3.21),('8784','2013-07-18','10:10:00',3.3),('8784','2013-07-18','10:15:00',3.32),('8784','2013-07-18','10:20:00',3.37),('8784','2013-07-18','10:25:00',3.43),('8784','2013-07-18','10:30:00',3.49),('8784','2013-07-18','10:35:00',3.55),('8784','2013-07-18','10:40:00',3.6),('8784','2013-07-18','10:45:00',3.66),('8784','2013-07-18','10:50:00',3.69),('8784','2013-07-18','10:55:00',3.71),('8784','2013-07-18','11:00:00',3.72),('8784','2013-07-18','11:05:00',3.75),('8784','2013-07-18','11:10:00',3.78),('8784','2013-07-18','11:15:00',3.83),('8784','2013-07-18','11:20:00',3.87),('8784','2013-07-18','11:25:00',3.88),('8784','2013-07-18','11:30:00',3.9),('8784','2013-07-18','11:35:00',3.89),('8784','2013-07-18','11:40:00',3.95),('8784','2013-07-18','11:45:00',3.97),('8784','2013-07-18','11:50:00',3.99),('8784','2013-07-18','11:55:00',4.05),('8784','2013-07-18','12:00:00',4.04),('8784','2013-07-18','12:05:00',4),('8784','2013-07-18','12:10:00',3.95),('8784','2013-07-18','12:15:00',3.97),('8784','2013-07-18','12:20:00',3.96),('8784','2013-07-18','12:25:00',4.08),('8784','2013-07-18','12:30:00',4.28),('8784','2013-07-18','12:35:00',4.24),('8784','2013-07-18','12:40:00',4.35),('8784','2013-07-18','12:45:00',4.54),('8784','2013-07-18','12:50:00',3.95),('8784','2013-07-18','12:55:00',4.3),('8784','2013-07-18','13:00:00',4.22),('8784','2013-07-18','13:05:00',3.19),('8784','2013-07-18','13:10:00',3.97),('8784','2013-07-18','13:15:00',4.21),('8784','2013-07-18','13:20:00',4.23),('8784','2013-07-18','13:25:00',3.84),('8784','2013-07-18','13:30:00',3.83),('8784','2013-07-18','13:35:00',4.29),('8784','2013-07-18','13:40:00',3.68),('8784','2013-07-18','13:45:00',4.29),('8784','2013-07-18','13:50:00',4.36),('8784','2013-07-18','13:55:00',4.32),('8784','2013-07-18','14:00:00',4.23),('8784','2013-07-18','14:05:00',4.18),('8784','2013-07-18','14:10:00',4.21),('8784','2013-07-18','14:15:00',4.21),('8784','2013-07-18','14:20:00',4.19),('8784','2013-07-18','14:25:00',4.1),('8784','2013-07-18','14:30:00',4.07),('8784','2013-07-18','14:35:00',4.06),('8784','2013-07-18','14:40:00',4.04),('8784','2013-07-18','14:45:00',4),('8784','2013-07-18','14:50:00',3.94),('8784','2013-07-18','14:55:00',3.91),('8784','2013-07-18','15:00:00',3.92),('8784','2013-07-18','15:05:00',3.91),('8784','2013-07-18','15:10:00',3.84),('8784','2013-07-18','15:15:00',3.8),('8784','2013-07-18','15:20:00',3.83),('8784','2013-07-18','15:25:00',3.78),('8784','2013-07-18','15:30:00',3.72),('8784','2013-07-18','15:35:00',3.7),('8784','2013-07-18','15:40:00',3.62),('8784','2013-07-18','15:45:00',3.59),('8784','2013-07-18','15:50:00',3.53),('8784','2013-07-18','15:55:00',3.48),('8784','2013-07-18','16:00:00',3.45),('8784','2013-07-18','16:05:00',3.38),('8784','2013-07-18','16:10:00',3.33),('8784','2013-07-18','16:15:00',3.24),('8784','2013-07-18','16:20:00',3.15),('8784','2013-07-18','16:25:00',3.14),('8784','2013-07-18','16:30:00',3.08),('8784','2013-07-18','16:35:00',3.02),('8784','2013-07-18','16:40:00',2.93),('8784','2013-07-18','16:45:00',2.89),('8784','2013-07-18','16:50:00',2.81),('8784','2013-07-18','16:55:00',2.72),('8784','2013-07-18','17:00:00',2.65),('8784','2013-07-18','17:05:00',2.58),('8784','2013-07-18','17:10:00',2.46),('8784','2013-07-18','17:15:00',2.43),('8784','2013-07-18','17:20:00',2.39),('8784','2013-07-18','17:25:00',2.29),('8784','2013-07-18','17:30:00',2.19),('8784','2013-07-18','17:35:00',2.09),('8784','2013-07-18','17:40:00',1.87),('8784','2013-07-18','17:45:00',1.92),('8784','2013-07-18','17:50:00',1.83),('8784','2013-07-18','17:55:00',1.72),('8784','2013-07-18','18:00:00',1.62),('8784','2013-07-18','18:05:00',1.4),('8784','2013-07-18','18:10:00',1.46),('8784','2013-07-18','18:15:00',1.37),('8784','2013-07-18','18:20:00',1.29),('8784','2013-07-18','18:25:00',1.21),('8784','2013-07-17','07:30:00',1.01),('8784','2013-07-17','07:35:00',1.08),('8784','2013-07-17','07:40:00',1.16),('8784','2013-07-17','07:45:00',1.27),('8784','2013-07-17','07:50:00',1.34),('8784','2013-07-17','07:55:00',1.41),('8784','2013-07-17','08:00:00',1.52),('8784','2013-07-17','08:05:00',1.63),('8784','2013-07-17','08:10:00',1.72),('8784','2013-07-17','08:15:00',1.81),('8784','2013-07-17','08:20:00',1.91),('8784','2013-07-17','08:25:00',1.98),('8784','2013-07-17','08:30:00',2.04),('8784','2013-07-17','08:35:00',2.16),('8784','2013-07-17','08:40:00',2.24),('8784','2013-07-17','08:45:00',2.33),('8784','2013-07-17','08:50:00',2.4),('8784','2013-07-17','08:55:00',2.47),('8784','2013-07-17','09:00:00',2.55),('8784','2013-07-17','09:05:00',2.63),('8784','2013-07-17','09:10:00',2.71),('8784','2013-07-17','09:15:00',2.79),('8784','2013-07-17','09:20:00',2.86),('8784','2013-07-17','09:25:00',2.93),('8784','2013-07-17','09:30:00',2.99),('8784','2013-07-17','09:35:00',3.03),('8784','2013-07-17','09:40:00',3.1),('8784','2013-07-17','09:45:00',3.19),('8784','2013-07-17','09:50:00',3.24),('8784','2013-07-17','09:55:00',3.28),('8784','2013-07-17','10:00:00',3.33),('8784','2013-07-17','10:05:00',3.39),('8784','2013-07-17','10:10:00',3.44),('8784','2013-07-17','10:15:00',3.46),('8784','2013-07-17','10:20:00',3.54),('8784','2013-07-17','10:25:00',3.57),('8784','2013-07-17','10:30:00',3.63),('8784','2013-07-17','10:35:00',3.7),('8784','2013-07-17','10:40:00',3.72),('8784','2013-07-17','10:45:00',3.76),('8784','2013-07-17','10:50:00',3.83),('8784','2013-07-17','10:55:00',3.84),('8784','2013-07-17','11:00:00',3.88),('8784','2013-07-17','11:05:00',3.95),('8784','2013-07-17','11:10:00',3.98),('8784','2013-07-17','11:15:00',4),('8784','2013-07-17','11:20:00',4.04),('8784','2013-07-17','11:25:00',4.06),('8784','2013-07-17','11:30:00',4.1),('8784','2013-07-17','11:35:00',4.11),('8784','2013-07-17','11:40:00',4.14),('8784','2013-07-17','11:45:00',4.16),('8784','2013-07-17','11:50:00',4.19),('8784','2013-07-17','11:55:00',4.21),('8784','2013-07-17','12:00:00',4.28),('8784','2013-07-17','12:05:00',4.21),('8784','2013-07-17','12:10:00',4.28),('8784','2013-07-17','12:15:00',4.31),('8784','2013-07-17','12:20:00',4.26),('8784','2013-07-17','12:25:00',4.26),('8784','2013-07-17','12:30:00',4.32),('8784','2013-07-17','12:35:00',4.3),('8784','2013-07-17','12:40:00',4.3),('8784','2013-07-17','12:45:00',4.3),('8784','2013-07-17','12:50:00',4.28),('8784','2013-07-17','12:55:00',4.29),('8784','2013-07-17','13:00:00',4.33),('8784','2013-07-17','13:05:00',4.33),('8784','2013-07-17','13:10:00',4.32),('8784','2013-07-17','13:15:00',4.34),('8784','2013-07-17','13:20:00',4.3),('8784','2013-07-17','13:25:00',4.23),('8784','2013-07-17','13:30:00',4.24),('8784','2013-07-17','13:35:00',4.24),('8784','2013-07-17','13:40:00',4.2),('8784','2013-07-17','13:45:00',4.22),('8784','2013-07-17','13:50:00',4.15),('8784','2013-07-17','13:55:00',4.15),('8784','2013-07-17','14:00:00',4.22),('8784','2013-07-17','14:05:00',4.25),('8784','2013-07-17','14:10:00',4.23),('8784','2013-07-17','14:15:00',4.22),('8784','2013-07-17','14:20:00',4.16),('8784','2013-07-17','14:25:00',4.14),('8784','2013-07-17','14:30:00',4.08),('8784','2013-07-17','14:35:00',4.04),('8784','2013-07-17','14:40:00',4.18),('8784','2013-07-17','14:45:00',4.11),('8784','2013-07-17','14:50:00',3.98),('8784','2013-07-17','14:55:00',3.93),('8784','2013-07-17','15:00:00',3.9),('8784','2013-07-17','15:05:00',3.91),('8784','2013-07-17','15:10:00',3.01),('8784','2013-07-17','15:15:00',3.94),('8784','2013-07-17','15:20:00',3.84),('8784','2013-07-17','15:25:00',3.82),('8784','2013-07-17','15:30:00',3.77),('8784','2013-07-17','15:35:00',3.75),('8784','2013-07-17','15:40:00',3.69),('8784','2013-07-17','15:45:00',3.57),('8784','2013-07-17','15:50:00',3.32),('8784','2013-07-17','15:55:00',3.32),('8784','2013-07-17','16:00:00',3.51),('8784','2013-07-17','16:05:00',3.44),('8784','2013-07-17','16:10:00',3.43),('8784','2013-07-17','16:15:00',3.36),('8784','2013-07-17','16:20:00',3.26),('8784','2013-07-17','16:25:00',3.13),('8784','2013-07-17','16:30:00',3.03),('8784','2013-07-17','16:35:00',3.01),('8784','2013-07-17','16:40:00',2.8),('8784','2013-07-17','16:45:00',2.92),('8784','2013-07-17','16:50:00',2.83),('8784','2013-07-17','16:55:00',2.78),('8784','2013-07-17','17:00:00',2.77),('8784','2013-07-17','17:05:00',2.68),('8784','2013-07-17','17:10:00',2.67),('8784','2013-07-17','17:15:00',2.56),('8784','2013-07-17','17:20:00',2.47),('8784','2013-07-17','17:25:00',2.36),('8784','2013-07-17','17:30:00',2.27),('8784','2013-07-17','17:35:00',2.21),('8784','2013-07-17','17:40:00',2.1),('8784','2013-07-17','17:45:00',2.03),('8784','2013-07-17','17:50:00',1.98),('8784','2013-07-17','17:55:00',1.89),('8784','2013-07-17','18:00:00',1.79),('8784','2013-07-17','18:05:00',1.72),('8784','2013-07-17','18:10:00',1.65),('8784','2013-07-17','18:15:00',1.57),('8784','2013-07-17','18:20:00',1.47),('8784','2013-07-17','18:25:00',1.4),('8784','2013-07-17','18:30:00',1.32),('8784','2013-07-17','18:35:00',1.23),('8784','2013-07-17','18:40:00',1.16),('8784','2013-07-17','18:45:00',1.07),('8784','2013-07-17','18:50:00',1),('8784','2013-07-16','07:30:00',1.05),('8784','2013-07-16','07:35:00',1.09),('8784','2013-07-16','07:40:00',1.18),('8784','2013-07-16','07:45:00',1.27),('8784','2013-07-16','07:50:00',1.37),('8784','2013-07-16','07:55:00',1.4),('8784','2013-07-16','08:00:00',1.48),('8784','2013-07-16','08:05:00',1.54),('8784','2013-07-16','08:10:00',1.63),('8784','2013-07-16','08:15:00',1.71),('8784','2013-07-16','08:20:00',1.81),('8784','2013-07-16','08:25:00',1.9),('8784','2013-07-16','08:30:00',1.98),('8784','2013-07-16','08:35:00',2.07),('8784','2013-07-16','08:40:00',2.14),('8784','2013-07-16','08:45:00',2.2),('8784','2013-07-16','08:50:00',2.28),('8784','2013-07-16','08:55:00',2.38),('8784','2013-07-16','09:00:00',2.46),('8784','2013-07-16','09:05:00',2.52),('8784','2013-07-16','09:10:00',2.6),('8784','2013-07-16','09:15:00',2.61),('8784','2013-07-16','09:20:00',2.64),('8784','2013-07-16','09:25:00',2.74),('8784','2013-07-16','09:30:00',2.82),('8784','2013-07-16','09:35:00',2.87),('8784','2013-07-16','09:40:00',2.98),('8784','2013-07-16','09:45:00',3.03),('8784','2013-07-16','09:50:00',3.11),('8784','2013-07-16','09:55:00',3.19),('8784','2013-07-16','10:00:00',3.27),('8784','2013-07-16','10:05:00',3.31),('8784','2013-07-16','10:10:00',3.39),('8784','2013-07-16','10:15:00',3.43),('8784','2013-07-16','10:20:00',3.49),('8784','2013-07-16','10:25:00',3.55),('8784','2013-07-16','10:30:00',3.61),('8784','2013-07-16','10:35:00',3.64),('8784','2013-07-16','10:40:00',3.67),('8784','2013-07-16','10:45:00',3.64),('8784','2013-07-16','10:50:00',3.76),('8784','2013-07-16','10:55:00',3.79),('8784','2013-07-16','11:00:00',3.84),('8784','2013-07-16','11:05:00',3.89),('8784','2013-07-16','11:10:00',3.92),('8784','2013-07-16','11:15:00',3.93),('8784','2013-07-16','11:20:00',3.96),('8784','2013-07-16','11:25:00',4),('8784','2013-07-16','11:30:00',4.04),('8784','2013-07-16','11:35:00',4.05),('8784','2013-07-16','11:40:00',4.05),('8784','2013-07-16','11:45:00',4.09),('8784','2013-07-16','11:50:00',4.15),('8784','2013-07-16','11:55:00',4.21),('8784','2013-07-16','12:00:00',4.23),('8784','2013-07-16','12:05:00',4.24),('8784','2013-07-16','12:10:00',4.24),('8784','2013-07-16','12:15:00',4.27),('8784','2013-07-16','12:20:00',4.28),('8784','2013-07-16','12:25:00',4.26),('8784','2013-07-16','12:30:00',4.28),('8784','2013-07-16','12:35:00',4.2),('8784','2013-07-16','12:40:00',4.25),('8784','2013-07-16','12:45:00',4.28),('8784','2013-07-16','12:50:00',4.22),('8784','2013-07-16','12:55:00',4.24),('8784','2013-07-16','13:00:00',4.25),('8784','2013-07-16','13:05:00',4.28),('8784','2013-07-16','13:10:00',4.24),('8784','2013-07-16','13:15:00',4.3),('8784','2013-07-16','13:20:00',4.3),('8784','2013-07-16','13:25:00',4.3),('8784','2013-07-16','13:30:00',4.3),('8784','2013-07-16','13:35:00',4.25),('8784','2013-07-16','13:40:00',4.32),('8784','2013-07-16','13:45:00',4.39),('8784','2013-07-16','13:50:00',4.48),('8784','2013-07-16','13:55:00',3.98),('8784','2013-07-16','14:00:00',4.24),('8784','2013-07-16','14:05:00',4.16),('8784','2013-07-16','14:10:00',2.33),('8784','2013-07-16','14:15:00',4.25),('8784','2013-07-16','14:20:00',1.52),('8784','2013-07-16','14:25:00',3.44),('8784','2013-07-16','14:30:00',4.25),('8784','2013-07-16','14:35:00',4.17),('8784','2013-07-16','14:40:00',4.12),('8784','2013-07-16','14:45:00',4.06),('8784','2013-07-16','14:50:00',4.04),('8784','2013-07-16','14:55:00',4.03),('8784','2013-07-16','15:00:00',3.98),('8784','2013-07-16','15:05:00',3.93),('8784','2013-07-16','15:10:00',3.88),('8784','2013-07-16','15:15:00',3.82),('8784','2013-07-16','15:20:00',3.79),('8784','2013-07-16','15:25:00',3.8),('8784','2013-07-16','15:30:00',3.78),('8784','2013-07-16','15:35:00',3.31),('8784','2013-07-16','15:40:00',3.67),('8784','2013-07-16','15:45:00',2.13),('8784','2013-07-16','15:50:00',3.57),('8784','2013-07-16','15:55:00',3.55),('8784','2013-07-16','16:00:00',3.46),('8784','2013-07-16','16:05:00',1.65),('8784','2013-07-16','16:10:00',3.01),('8784','2013-07-16','16:15:00',2.49),('8784','2013-07-16','16:20:00',1.71),('8784','2013-07-16','16:25:00',1.56),('8784','2013-07-16','16:30:00',1.26),('8784','2013-07-16','16:45:00',1.32),('8784','2013-07-16','16:50:00',1.68),('8784','2013-07-16','16:55:00',1.84),('8784','2013-07-16','17:00:00',2.81),('8784','2013-07-16','17:05:00',3.1),('8784','2013-07-16','17:10:00',2.78),('8784','2013-07-16','17:15:00',2.66),('8784','2013-07-16','17:20:00',1.31),('8784','2013-07-16','17:25:00',2.03),('8784','2013-07-16','17:30:00',1.66),('8784','2013-07-16','17:35:00',2.11),('8784','2013-07-16','17:40:00',2.27),('8784','2013-07-16','17:45:00',2.32),('8784','2013-07-16','17:50:00',2.04),('8784','2013-07-16','17:55:00',1.22),('8784','2013-07-16','18:05:00',1.49),('8784','2013-07-16','18:10:00',1.29),('8784','2013-07-16','18:15:00',1.56),('8784','2013-07-16','18:20:00',1.43),('8784','2013-07-16','18:25:00',1.4),('8784','2013-07-16','18:30:00',1.32),('8784','2013-07-16','18:35:00',1.23),('8784','2013-07-16','18:40:00',1.11),('8784','2013-07-16','18:45:00',1.02),('8784','2013-07-15','07:25:00',1.01),('8784','2013-07-15','07:30:00',1.08),('8784','2013-07-15','07:35:00',1.16),('8784','2013-07-15','07:40:00',1.24),('8784','2013-07-15','07:45:00',1.33),('8784','2013-07-15','07:50:00',1.41),('8784','2013-07-15','07:55:00',1.49),('8784','2013-07-15','08:00:00',1.58),('8784','2013-07-15','08:05:00',1.66),('8784','2013-07-15','08:10:00',1.75),('8784','2013-07-15','08:15:00',1.83),('8784','2013-07-15','08:20:00',1.92),('8784','2013-07-15','08:25:00',2),('8784','2013-07-15','08:30:00',2.08),('8784','2013-07-15','08:35:00',2.15),('8784','2013-07-15','08:40:00',2.16),('8784','2013-07-15','08:45:00',2.27),('8784','2013-07-15','08:50:00',2.4),('8784','2013-07-15','08:55:00',2.47),('8784','2013-07-15','09:00:00',2.55),('8784','2013-07-15','09:05:00',2.63),('8784','2013-07-15','09:10:00',2.7),('8784','2013-07-15','09:15:00',2.76),('8784','2013-07-15','09:20:00',2.85),('8784','2013-07-15','09:25:00',2.9),('8784','2013-07-15','09:30:00',2.97),('8784','2013-07-15','09:35:00',3.03),('8784','2013-07-15','09:40:00',3.09),('8784','2013-07-15','09:45:00',3.16),('8784','2013-07-15','09:50:00',3.2),('8784','2013-07-15','09:55:00',3.26),('8784','2013-07-15','10:00:00',3.3),('8784','2013-07-15','10:05:00',3.36),('8784','2013-07-15','10:10:00',3.41),('8784','2013-07-15','10:15:00',3.47),('8784','2013-07-15','10:20:00',3.51),('8784','2013-07-15','10:25:00',3.55),('8784','2013-07-15','10:30:00',3.57),('8784','2013-07-15','10:35:00',3.62),('8784','2013-07-15','10:40:00',3.65),('8784','2013-07-15','10:45:00',3.67),('8784','2013-07-15','10:50:00',3.71),('8784','2013-07-15','10:55:00',3.79),('8784','2013-07-15','11:00:00',3.83),('8784','2013-07-15','11:05:00',3.87),('8784','2013-07-15','11:10:00',3.89),('8784','2013-07-15','11:15:00',3.9),('8784','2013-07-15','11:20:00',3.92),('8784','2013-07-15','11:25:00',3.97),('8784','2013-07-15','11:30:00',3.99),('8784','2013-07-15','11:35:00',4.04),('8784','2013-07-15','11:40:00',4.06),('8784','2013-07-15','11:45:00',4.07),('8784','2013-07-15','11:50:00',4.1),('8784','2013-07-15','11:55:00',4.12),('8784','2013-07-15','12:00:00',4.21),('8784','2013-07-15','12:05:00',4.19),('8784','2013-07-15','12:10:00',4.18),('8784','2013-07-15','12:15:00',4.2),('8784','2013-07-15','12:20:00',4.3),('8784','2013-07-15','12:25:00',4.28),('8784','2013-07-15','12:30:00',4.27),('8784','2013-07-15','12:35:00',4.28),('8784','2013-07-15','12:40:00',4.25),('8784','2013-07-15','12:45:00',4.22),('8784','2013-07-15','12:50:00',4.19),('8784','2013-07-15','12:55:00',4.18),('8784','2013-07-15','13:00:00',4.33),('8784','2013-07-15','13:05:00',3.24),('8784','2013-07-15','13:10:00',2.44),('8784','2013-07-15','13:15:00',4.44),('8784','2013-07-15','13:20:00',4.36),('8784','2013-07-15','13:25:00',4.49),('8784','2013-07-15','13:30:00',4.62),('8784','2013-07-15','13:35:00',4.64),('8784','2013-07-15','13:40:00',1.96),('8784','2013-07-15','13:45:00',2.83),('8784','2013-07-15','13:50:00',1.74),('8784','2013-07-15','13:55:00',3.75),('8784','2013-07-15','14:00:00',4.61),('8784','2013-07-15','14:05:00',4.6),('8784','2013-07-15','14:10:00',2.77),('8784','2013-07-15','14:20:00',1.69),('8784','2013-07-15','14:25:00',4.58),('8784','2013-07-15','14:30:00',4.39),('8784','2013-07-15','14:35:00',4.33),('8784','2013-07-15','14:40:00',4.25),('8784','2013-07-15','14:45:00',4.24),('8784','2013-07-15','14:50:00',4.16),('8784','2013-07-15','14:55:00',4.18),('8784','2013-07-15','15:00:00',4.15),('8784','2013-07-15','15:05:00',4.06),('8784','2013-07-15','15:10:00',4),('8784','2013-07-15','15:15:00',3.92),('8784','2013-07-15','15:20:00',2.8),('8784','2013-07-15','15:30:00',3.92),('8784','2013-07-15','15:35:00',3.93),('8784','2013-07-15','15:40:00',3.89),('8784','2013-07-15','15:45:00',3.69),('8784','2013-07-15','15:50:00',3.71),('8784','2013-07-15','15:55:00',3.63),('8784','2013-07-15','16:00:00',3.49),('8784','2013-07-15','16:05:00',3.46),('8784','2013-07-15','16:10:00',3.38),('8784','2013-07-15','16:15:00',3.29),('8784','2013-07-15','16:20:00',3.18),('8784','2013-07-15','16:25:00',3.11),('8784','2013-07-15','16:30:00',3.09),('8784','2013-07-15','16:35:00',3.02),('8784','2013-07-15','16:40:00',2.99),('8784','2013-07-15','16:45:00',2.91),('8784','2013-07-15','16:50:00',2.85),('8784','2013-07-15','16:55:00',2.8),('8784','2013-07-15','17:00:00',2.72),('8784','2013-07-15','17:05:00',2.66),('8784','2013-07-15','17:10:00',2.57),('8784','2013-07-15','17:15:00',2.51),('8784','2013-07-15','17:20:00',2.43),('8784','2013-07-15','17:25:00',2.37),('8784','2013-07-15','17:30:00',2.3),('8784','2013-07-15','17:35:00',2.19),('8784','2013-07-15','17:40:00',2.11),('8784','2013-07-15','17:45:00',2.03),('8784','2013-07-15','17:50:00',1.93),('8784','2013-07-15','17:55:00',1.85),('8784','2013-07-15','18:00:00',1.77),('8784','2013-07-15','18:05:00',1.69),('8784','2013-07-15','18:10:00',1.62),('8784','2013-07-15','18:15:00',1.53),('8784','2013-07-15','18:20:00',1.44),('8784','2013-07-15','18:25:00',1.37),('8784','2013-07-15','18:30:00',1.29),('8784','2013-07-15','18:35:00',1.19),('8784','2013-07-15','18:40:00',1.13),('8784','2013-07-15','18:45:00',1.06),('8784','2013-07-14','07:50:00',1.41),('8784','2013-07-14','07:55:00',1.69),('8784','2013-07-14','08:00:00',1.67),('8784','2013-07-14','08:05:00',1.5),('8784','2013-07-14','08:10:00',2.03),('8784','2013-07-14','08:15:00',1.47),('8784','2013-07-14','08:20:00',2.3),('8784','2013-07-14','08:25:00',1.6),('8784','2013-07-14','08:30:00',1.09),('8784','2013-07-14','08:35:00',1.32),('8784','2013-07-14','08:40:00',1.17),('8784','2013-07-14','08:45:00',1.03),('8784','2013-07-14','08:50:00',1.12),('8784','2013-07-14','08:55:00',1.13),('8784','2013-07-14','09:00:00',1.14),('8784','2013-07-14','09:05:00',1.23),('8784','2013-07-14','09:10:00',1.65),('8784','2013-07-14','09:15:00',1.49),('8784','2013-07-14','09:20:00',1.46),('8784','2013-07-14','09:25:00',2.38),('8784','2013-07-14','09:30:00',2.45),('8784','2013-07-14','09:35:00',2.2),('8784','2013-07-14','09:40:00',1.82),('8784','2013-07-14','09:45:00',1.79),('8784','2013-07-14','09:50:00',1.72),('8784','2013-07-14','09:55:00',1.74),('8784','2013-07-14','10:00:00',1.71),('8784','2013-07-14','10:05:00',1.92),('8784','2013-07-14','10:10:00',1.73),('8784','2013-07-14','10:15:00',1.7),('8784','2013-07-14','10:20:00',2.42),('8784','2013-07-14','10:25:00',3.17),('8784','2013-07-14','10:30:00',3.08),('8784','2013-07-14','10:35:00',3.73),('8784','2013-07-14','10:40:00',3.34),('8784','2013-07-14','10:45:00',3.04),('8784','2013-07-14','10:50:00',3.98),('8784','2013-07-14','10:55:00',3.58),('8784','2013-07-14','11:00:00',3.08),('8784','2013-07-14','11:05:00',1.22),('8784','2013-07-14','11:10:00',1.47),('8784','2013-07-14','11:15:00',1.91),('8784','2013-07-14','11:20:00',2.69),('8784','2013-07-14','11:25:00',1.49),('8784','2013-07-14','11:30:00',1.47),('8784','2013-07-14','11:35:00',2.3),('8784','2013-07-14','11:40:00',4.06),('8784','2013-07-14','11:45:00',1.96),('8784','2013-07-14','11:50:00',1.83),('8784','2013-07-14','11:55:00',3.8),('8784','2013-07-14','12:00:00',3.34),('8784','2013-07-14','12:05:00',3.97),('8784','2013-07-14','12:10:00',2.9),('8784','2013-07-14','12:15:00',3.23),('8784','2013-07-14','12:20:00',2.72),('8784','2013-07-14','12:25:00',4.11),('8784','2013-07-14','12:30:00',4.76),('8784','2013-07-14','12:35:00',4.79),('8784','2013-07-14','12:40:00',4.82),('8784','2013-07-14','12:45:00',4.53),('8784','2013-07-14','12:50:00',4.62),('8784','2013-07-14','12:55:00',4.6),('8784','2013-07-14','13:00:00',2.42),('8784','2013-07-14','13:05:00',4.89),('8784','2013-07-14','13:10:00',4.74),('8784','2013-07-14','13:15:00',4.58),('8784','2013-07-14','13:20:00',4.54),('8784','2013-07-14','13:25:00',4.4),('8784','2013-07-14','13:30:00',4.48),('8784','2013-07-14','13:35:00',4.4),('8784','2013-07-14','13:40:00',4.45),('8784','2013-07-14','13:45:00',4.45),('8784','2013-07-14','13:50:00',4.5),('8784','2013-07-14','13:55:00',4.46),('8784','2013-07-14','14:00:00',4.49),('8784','2013-07-14','14:05:00',4.49),('8784','2013-07-14','14:10:00',4.49),('8784','2013-07-14','14:15:00',4.38),('8784','2013-07-14','14:20:00',4.4),('8784','2013-07-14','14:25:00',4.37),('8784','2013-07-14','14:30:00',4.33),('8784','2013-07-14','14:35:00',4.25),('8784','2013-07-14','14:40:00',4.19),('8784','2013-07-14','14:45:00',4.13),('8784','2013-07-14','14:50:00',4.06),('8784','2013-07-14','14:55:00',4.02),('8784','2013-07-14','15:00:00',4.02),('8784','2013-07-14','15:05:00',3.99),('8784','2013-07-14','15:10:00',3.94),('8784','2013-07-14','15:15:00',3.94),('8784','2013-07-14','15:20:00',3.87),('8784','2013-07-14','15:25:00',3.81),('8784','2013-07-14','15:30:00',3.77),('8784','2013-07-14','15:35:00',3.77),('8784','2013-07-14','15:40:00',3.7),('8784','2013-07-14','15:45:00',3.63),('8784','2013-07-14','15:50:00',3.57),('8784','2013-07-14','15:55:00',3.58),('8784','2013-07-14','16:00:00',3.48),('8784','2013-07-14','16:05:00',3.29),('8784','2013-07-14','16:10:00',3.43),('8784','2013-07-14','16:15:00',3.34),('8784','2013-07-14','16:20:00',3.35),('8784','2013-07-14','16:25:00',2.37),('8784','2013-07-14','16:30:00',2.94),('8784','2013-07-14','16:35:00',3.28),('8784','2013-07-14','16:40:00',3.08),('8784','2013-07-14','16:45:00',2.74),('8784','2013-07-14','16:50:00',2.32),('8784','2013-07-14','16:55:00',2.1),('8784','2013-07-14','17:00:00',2.99),('8784','2013-07-14','17:05:00',1.64),('8784','2013-07-14','17:10:00',2.42),('8784','2013-07-14','17:15:00',2.43),('8784','2013-07-14','17:20:00',1.47),('8784','2013-07-14','17:25:00',2.16),('8784','2013-07-14','17:30:00',2.74),('8784','2013-07-14','17:35:00',2.36),('8784','2013-07-14','17:40:00',1.66),('8784','2013-07-14','17:45:00',1.9),('8784','2013-07-14','17:50:00',1.75),('8784','2013-07-14','17:55:00',1.96),('8784','2013-07-14','18:00:00',1.43),('8784','2013-07-14','18:05:00',1.58),('8784','2013-07-13','07:40:00',1.11),('8784','2013-07-13','07:45:00',1.17),('8784','2013-07-13','07:50:00',1.31),('8784','2013-07-13','07:55:00',1.38),('8784','2013-07-13','08:00:00',1.44),('8784','2013-07-13','08:05:00',1.51),('8784','2013-07-13','08:10:00',1.58),('8784','2013-07-13','08:15:00',1.6),('8784','2013-07-13','08:20:00',1.68),('8784','2013-07-13','08:25:00',1.85),('8784','2013-07-13','08:30:00',1.95),('8784','2013-07-13','08:35:00',2.02),('8784','2013-07-13','08:40:00',2.13),('8784','2013-07-13','08:45:00',2.17),('8784','2013-07-13','08:50:00',2.28),('8784','2013-07-13','08:55:00',2.34),('8784','2013-07-13','09:00:00',2.4),('8784','2013-07-13','09:05:00',2.5),('8784','2013-07-13','09:10:00',2.51),('8784','2013-07-13','09:15:00',2.58),('8784','2013-07-13','09:20:00',2.63),('8784','2013-07-13','09:25:00',2.78),('8784','2013-07-13','09:30:00',2.84),('8784','2013-07-13','09:35:00',2.88),('8784','2013-07-13','09:40:00',2.96),('8784','2013-07-13','09:45:00',3.03),('8784','2013-07-13','09:50:00',3.09),('8784','2013-07-13','09:55:00',3.16),('8784','2013-07-13','10:00:00',3.17),('8784','2013-07-13','10:05:00',3.24),('8784','2013-07-13','10:10:00',3.3),('8784','2013-07-13','10:15:00',3.39),('8784','2013-07-13','10:20:00',3.48),('8784','2013-07-13','10:25:00',2.91),('8784','2013-07-13','10:30:00',2.87),('8784','2013-07-13','10:35:00',3.45),('8784','2013-07-13','10:40:00',3.69),('8784','2013-07-13','10:45:00',3.66),('8784','2013-07-13','10:50:00',3.57),('8784','2013-07-13','10:55:00',3.9),('8784','2013-07-13','11:00:00',4.04),('8784','2013-07-13','11:05:00',3.6),('8784','2013-07-13','11:10:00',3.62),('8784','2013-07-13','11:15:00',3.75),('8784','2013-07-13','11:20:00',2.74),('8784','2013-07-13','11:25:00',2.77),('8784','2013-07-13','11:30:00',4.36),('8784','2013-07-13','11:35:00',4.38),('8784','2013-07-13','11:40:00',2.49),('8784','2013-07-13','11:45:00',1.04),('8784','2013-07-13','11:50:00',3.45),('8784','2013-07-13','11:55:00',4.07),('8784','2013-07-13','12:00:00',1.9),('8784','2013-07-13','12:05:00',4.59),('8784','2013-07-13','12:10:00',4.51),('8784','2013-07-13','12:15:00',4.47),('8784','2013-07-13','12:20:00',4.43),('8784','2013-07-13','12:25:00',4.42),('8784','2013-07-13','12:30:00',3.77),('8784','2013-07-13','12:35:00',4.15),('8784','2013-07-13','12:40:00',4.1),('8784','2013-07-13','12:45:00',3.67),('8784','2013-07-13','12:50:00',2.13),('8784','2013-07-13','12:55:00',3.64),('8784','2013-07-13','13:00:00',4.63),('8784','2013-07-13','13:05:00',4.59),('8784','2013-07-13','13:10:00',4),('8784','2013-07-13','13:15:00',4.53),('8784','2013-07-13','13:20:00',4.46),('8784','2013-07-13','13:25:00',4.38),('8784','2013-07-13','13:30:00',4.37),('8784','2013-07-13','13:35:00',4.42),('8784','2013-07-13','13:40:00',4.4),('8784','2013-07-13','13:45:00',4.4),('8784','2013-07-13','13:50:00',4.38),('8784','2013-07-13','13:55:00',4.34),('8784','2013-07-13','14:00:00',4.35),('8784','2013-07-13','14:05:00',4.34),('8784','2013-07-13','14:10:00',4.32),('8784','2013-07-13','14:15:00',4.3),('8784','2013-07-13','14:20:00',4.28),('8784','2013-07-13','14:25:00',4.26),('8784','2013-07-13','14:30:00',4.24),('8784','2013-07-13','14:35:00',4.23),('8784','2013-07-13','14:40:00',4.19),('8784','2013-07-13','14:45:00',4.2),('8784','2013-07-13','14:50:00',4.12),('8784','2013-07-13','14:55:00',4.13),('8784','2013-07-13','15:00:00',4.12),('8784','2013-07-13','15:05:00',4.13),('8784','2013-07-13','15:10:00',4.08),('8784','2013-07-13','15:15:00',4.06),('8784','2013-07-13','15:20:00',3.84),('8784','2013-07-13','15:25:00',4),('8784','2013-07-13','15:30:00',3.87),('8784','2013-07-13','15:35:00',3.91),('8784','2013-07-13','15:40:00',3.84),('8784','2013-07-13','15:45:00',3.77),('8784','2013-07-13','15:50:00',3.71),('8784','2013-07-13','15:55:00',3.67),('8784','2013-07-13','16:00:00',3.61),('8784','2013-07-13','16:05:00',3.56),('8784','2013-07-13','16:10:00',3.5),('8784','2013-07-13','16:15:00',3.44),('8784','2013-07-13','16:20:00',3.39),('8784','2013-07-13','16:25:00',3.37),('8784','2013-07-13','16:30:00',3.28),('8784','2013-07-13','16:35:00',3.19),('8784','2013-07-13','16:40:00',3.16),('8784','2013-07-13','16:45:00',3.07),('8784','2013-07-13','16:50:00',2.99),('8784','2013-07-13','16:55:00',2.93),('8784','2013-07-13','17:00:00',2.83),('8784','2013-07-13','17:05:00',2.72),('8784','2013-07-13','17:10:00',2.69),('8784','2013-07-13','17:15:00',2.61),('8784','2013-07-13','17:20:00',2.46),('8784','2013-07-13','17:25:00',2.5),('8784','2013-07-13','17:30:00',2.34),('8784','2013-07-13','17:35:00',2.25),('8784','2013-07-13','17:40:00',2.21),('8784','2013-07-13','17:45:00',2.15),('8784','2013-07-13','17:50:00',2.02),('8784','2013-07-13','17:55:00',2.03),('8784','2013-07-13','18:00:00',1.85),('8784','2013-07-13','18:05:00',1.72),('8784','2013-07-13','18:10:00',1.72),('8784','2013-07-13','18:15:00',1.65),('8784','2013-07-13','18:20:00',1.56),('8784','2013-07-13','18:25:00',1.5),('8784','2013-07-13','18:30:00',1.4),('8784','2013-07-13','18:35:00',1.3),('8784','2013-07-13','18:55:00',1.08),('8784','2013-07-12','08:10:00',1.47),('8784','2013-07-12','08:15:00',1.56),('8784','2013-07-12','08:20:00',1.35),('8784','2013-07-12','08:40:00',1.14),('8784','2013-07-12','08:45:00',1.31),('8784','2013-07-12','08:50:00',1.02),('8784','2013-07-12','09:05:00',1.02),('8784','2013-07-12','09:10:00',1.5),('8784','2013-07-12','09:15:00',1.84),('8784','2013-07-12','09:20:00',2.79),('8784','2013-07-12','09:25:00',2.61),('8784','2013-07-12','09:30:00',1.68),('8784','2013-07-12','09:35:00',2.49),('8784','2013-07-12','09:40:00',2.42),('8784','2013-07-12','09:45:00',2.94),('8784','2013-07-12','09:50:00',3.05),('8784','2013-07-12','09:55:00',3.21),('8784','2013-07-12','10:00:00',2.92),('8784','2013-07-12','10:05:00',3.28),('8784','2013-07-12','10:10:00',3.46),('8784','2013-07-12','10:15:00',3.38),('8784','2013-07-12','10:20:00',3.31),('8784','2013-07-12','10:25:00',2.53),('8784','2013-07-12','10:30:00',1.25),('8784','2013-07-12','10:40:00',1.05),('8784','2013-07-12','10:45:00',1.33),('8784','2013-07-12','10:50:00',2.65),('8784','2013-07-12','10:55:00',4.38),('8784','2013-07-12','11:00:00',1.74),('8784','2013-07-12','11:05:00',1.49),('8784','2013-07-12','11:10:00',1.97),('8784','2013-07-12','11:15:00',3.38),('8784','2013-07-12','11:20:00',4.36),('8784','2013-07-12','11:25:00',3.57),('8784','2013-07-12','11:30:00',3.75),('8784','2013-07-12','11:35:00',3.2),('8784','2013-07-12','11:40:00',4.48),('8784','2013-07-12','11:45:00',2.48),('8784','2013-07-12','11:50:00',3.22),('8784','2013-07-12','11:55:00',4.43),('8784','2013-07-12','12:00:00',4.52),('8784','2013-07-12','12:05:00',2.46),('8784','2013-07-12','12:10:00',3.51),('8784','2013-07-12','12:15:00',4.62),('8784','2013-07-12','12:20:00',4.16),('8784','2013-07-12','12:25:00',4.58),('8784','2013-07-12','12:30:00',4.83),('8784','2013-07-12','12:35:00',4.01),('8784','2013-07-12','12:40:00',3.97),('8784','2013-07-12','12:45:00',4.77),('8784','2013-07-12','12:50:00',2.73),('8784','2013-07-12','12:55:00',3.69),('8784','2013-07-12','13:00:00',4.55),('8784','2013-07-12','13:05:00',4.32),('8784','2013-07-12','13:10:00',4.55),('8784','2013-07-12','13:15:00',4.46),('8784','2013-07-12','13:20:00',3.88),('8784','2013-07-12','13:25:00',4.49),('8784','2013-07-12','13:30:00',4.48),('8784','2013-07-12','13:35:00',4.46),('8784','2013-07-12','13:40:00',4.5),('8784','2013-07-12','13:45:00',3.1),('8784','2013-07-12','13:50:00',4.55),('8784','2013-07-12','13:55:00',4.42),('8784','2013-07-12','14:00:00',4.53),('8784','2013-07-12','14:05:00',3.69),('8784','2013-07-12','14:10:00',3.13),('8784','2013-07-12','14:15:00',4.74),('8784','2013-07-12','14:20:00',4.68),('8784','2013-07-12','14:25:00',4.51),('8784','2013-07-12','14:30:00',3.7),('8784','2013-07-12','14:35:00',4.2),('8784','2013-07-12','14:40:00',4.19),('8784','2013-07-12','14:45:00',4.15),('8784','2013-07-12','14:50:00',4.1),('8784','2013-07-12','14:55:00',4.07),('8784','2013-07-12','15:00:00',3.98),('8784','2013-07-12','15:05:00',4.02),('8784','2013-07-12','15:10:00',4),('8784','2013-07-12','15:15:00',3.92),('8784','2013-07-12','15:20:00',3.91),('8784','2013-07-12','15:25:00',3.89),('8784','2013-07-12','15:30:00',3.82),('8784','2013-07-12','15:35:00',3.76),('8784','2013-07-12','15:40:00',3.7),('8784','2013-07-12','15:45:00',3.71),('8784','2013-07-12','15:50:00',3.57),('8784','2013-07-12','15:55:00',3.57),('8784','2013-07-12','16:00:00',3.51),('8784','2013-07-12','16:05:00',3.43),('8784','2013-07-12','16:10:00',3.4),('8784','2013-07-12','16:15:00',3.34),('8784','2013-07-12','16:20:00',3.26),('8784','2013-07-12','16:25:00',3.22),('8784','2013-07-12','16:30:00',3.15),('8784','2013-07-12','16:35:00',3.12),('8784','2013-07-12','16:40:00',3.07),('8784','2013-07-12','16:45:00',2.97),('8784','2013-07-12','16:50:00',2.9),('8784','2013-07-12','16:55:00',2.81),('8784','2013-07-12','17:00:00',2.75),('8784','2013-07-12','17:05:00',2.68),('8784','2013-07-12','17:10:00',2.62),('8784','2013-07-12','17:15:00',2.56),('8784','2013-07-12','17:20:00',2.44),('8784','2013-07-12','17:25:00',2.32),('8784','2013-07-12','17:30:00',2.26),('8784','2013-07-12','17:35:00',2.24),('8784','2013-07-12','17:40:00',2.15),('8784','2013-07-12','17:45:00',2.06),('8784','2013-07-12','17:50:00',2),('8784','2013-07-12','17:55:00',1.89),('8784','2013-07-12','18:00:00',1.82),('8784','2013-07-12','18:05:00',1.72),('8784','2013-07-12','18:10:00',1.62),('8784','2013-07-12','18:15:00',1.59),('8784','2013-07-12','18:20:00',1.43),('8784','2013-07-12','18:25:00',1.44),('8784','2013-07-12','18:30:00',1.35),('8784','2013-07-12','18:35:00',1.27),('8784','2013-07-12','18:40:00',1.18),('8784','2013-07-12','18:45:00',1.1),('8784','2013-07-12','18:50:00',1.02),('8784','2013-07-11','07:30:00',1.01),('8784','2013-07-11','07:35:00',1.09),('8784','2013-07-11','07:40:00',1.16),('8784','2013-07-11','07:45:00',1.22),('8784','2013-07-11','07:50:00',1.32),('8784','2013-07-11','07:55:00',1.38),('8784','2013-07-11','08:00:00',1.48),('8784','2013-07-11','08:05:00',1.53),('8784','2013-07-11','08:10:00',1.58),('8784','2013-07-11','08:15:00',1.63),('8784','2013-07-11','08:20:00',1.78),('8784','2013-07-11','08:25:00',1.89),('8784','2013-07-11','08:30:00',1.95),('8784','2013-07-11','08:35:00',1.99),('8784','2013-07-11','08:40:00',2.1),('8784','2013-07-11','08:45:00',2.11),('8784','2013-07-11','08:50:00',2.23),('8784','2013-07-11','08:55:00',2.32),('8784','2013-07-11','09:00:00',2.4),('8784','2013-07-11','09:05:00',2.31),('8784','2013-07-11','09:10:00',2.58),('8784','2013-07-11','09:15:00',2.64),('8784','2013-07-11','09:20:00',2.65),('8784','2013-07-11','09:25:00',2.66),('8784','2013-07-11','09:30:00',2.76),('8784','2013-07-11','09:35:00',2.92),('8784','2013-07-11','09:40:00',2.9),('8784','2013-07-11','09:45:00',3.18),('8784','2013-07-11','09:50:00',3.02),('8784','2013-07-11','09:55:00',1.99),('8784','2013-07-11','10:00:00',1.74),('8784','2013-07-11','10:05:00',2.52),('8784','2013-07-11','10:10:00',3.48),('8784','2013-07-11','10:15:00',3.28),('8784','2013-07-11','10:20:00',3.61),('8784','2013-07-11','10:25:00',3.4),('8784','2013-07-11','10:30:00',2.99),('8784','2013-07-11','10:35:00',2.64),('8784','2013-07-11','10:40:00',2.58),('8784','2013-07-11','10:45:00',3.83),('8784','2013-07-11','10:50:00',3.96),('8784','2013-07-11','10:55:00',4.06),('8784','2013-07-11','11:00:00',4.02),('8784','2013-07-11','11:05:00',3.52),('8784','2013-07-11','11:10:00',4.23),('8784','2013-07-11','11:15:00',4.2),('8784','2013-07-11','11:20:00',4.38),('8784','2013-07-11','11:25:00',2.69),('8784','2013-07-11','11:30:00',3.59),('8784','2013-07-11','11:35:00',2.08),('8784','2013-07-11','11:40:00',3.63),('8784','2013-07-11','11:45:00',1.82),('8784','2013-07-11','11:50:00',3.58),('8784','2013-07-11','11:55:00',4.81),('8784','2013-07-11','12:00:00',3.33),('8784','2013-07-11','12:05:00',1.31),('8784','2013-07-11','12:10:00',1.64),('8784','2013-07-11','12:15:00',3.59),('8784','2013-07-11','12:20:00',4.71),('8784','2013-07-11','12:25:00',4.78),('8784','2013-07-11','12:30:00',4.79),('8784','2013-07-11','12:35:00',4.67),('8784','2013-07-11','12:40:00',4.7),('8784','2013-07-11','12:45:00',4.52),('8784','2013-07-11','12:50:00',4.6),('8784','2013-07-11','12:55:00',2.46),('8784','2013-07-11','13:00:00',4.65),('8784','2013-07-11','13:05:00',4.59),('8784','2013-07-11','13:10:00',4.38),('8784','2013-07-11','13:15:00',4.51),('8784','2013-07-11','13:20:00',4.2),('8784','2013-07-11','13:25:00',3.78),('8784','2013-07-11','13:30:00',4.45),('8784','2013-07-11','13:35:00',3.43),('8784','2013-07-11','13:40:00',3.77),('8784','2013-07-11','13:45:00',4.13),('8784','2013-07-11','13:50:00',2.83),('8784','2013-07-11','13:55:00',2.36),('8784','2013-07-11','14:00:00',4.51),('8784','2013-07-11','14:05:00',4.42),('8784','2013-07-11','14:10:00',4.24),('8784','2013-07-11','14:15:00',4.22),('8784','2013-07-11','14:20:00',4.38),('8784','2013-07-11','14:25:00',4.42),('8784','2013-07-11','14:30:00',4.4),('8784','2013-07-11','14:35:00',4.3),('8784','2013-07-11','14:40:00',4.22),('8784','2013-07-11','14:45:00',4.28),('8784','2013-07-11','14:50:00',4.2),('8784','2013-07-11','14:55:00',3.49),('8784','2013-07-11','15:00:00',2.97),('8784','2013-07-11','15:05:00',2.1),('8784','2013-07-11','15:10:00',4.16),('8784','2013-07-11','15:15:00',2.18),('8784','2013-07-11','15:20:00',3.87),('8784','2013-07-11','15:25:00',3.38),('8784','2013-07-11','15:30:00',3.68),('8784','2013-07-11','15:35:00',3.06),('8784','2013-07-11','15:40:00',4.01),('8784','2013-07-11','15:45:00',3.24),('8784','2013-07-11','15:50:00',2.68),('8784','2013-07-11','15:55:00',1.48),('8784','2013-07-11','16:00:00',3.63),('8784','2013-07-11','16:05:00',2.6),('8784','2013-07-11','16:10:00',3.71),('8784','2013-07-11','16:15:00',1.85),('8784','2013-07-11','16:20:00',3.15),('8784','2013-07-11','16:25:00',1.66),('8784','2013-07-11','16:30:00',3),('8784','2013-07-11','16:35:00',2.02),('8784','2013-07-11','16:40:00',3.16),('8784','2013-07-11','16:45:00',3.45),('8784','2013-07-11','16:50:00',3.06),('8784','2013-07-11','16:55:00',2.89),('8784','2013-07-11','17:00:00',2.01),('8784','2013-07-11','17:05:00',2.38),('8784','2013-07-11','17:10:00',2.76),('8784','2013-07-11','17:15:00',2.51),('8784','2013-07-11','17:20:00',2.41),('8784','2013-07-11','17:25:00',2.38),('8784','2013-07-11','17:30:00',2.63),('8784','2013-07-11','17:35:00',2.11),('8784','2013-07-11','17:40:00',2.19),('8784','2013-07-11','17:45:00',1.79),('8784','2013-07-11','17:50:00',1.94),('8784','2013-07-11','17:55:00',2.07),('8784','2013-07-11','18:00:00',2.12),('8784','2013-07-11','18:05:00',1.49),('8784','2013-07-11','18:10:00',1.99),('8784','2013-07-11','18:15:00',1.79),('8784','2013-07-11','18:20:00',1.36),('8784','2013-07-11','18:25:00',1.45),('8784','2013-07-11','18:30:00',1.32),('8784','2013-07-11','18:35:00',1.05),('8784','2014-05-03','07:30:00',1.08),('8784','2014-05-03','07:35:00',1.17),('8784','2014-05-03','07:40:00',1.27),('8784','2014-05-03','07:45:00',1.33),('8784','2014-05-03','07:50:00',1.43),('8784','2014-05-03','07:55:00',1.49),('8784','2014-05-03','08:00:00',1.69),('8784','2014-05-03','08:05:00',1.73),('8784','2014-05-03','08:10:00',2.08),('8784','2014-05-03','08:15:00',1.72),('8784','2014-05-03','08:20:00',1.17),('8784','2014-05-03','08:25:00',1.16),('8784','2014-05-03','08:30:00',1.47),('8784','2014-05-03','08:45:00',1.96),('8784','2014-05-03','08:50:00',2.75),('8784','2014-05-03','08:55:00',3.21),('8784','2014-05-03','09:00:00',2.39),('8784','2014-05-03','09:05:00',1.9),('8784','2014-05-03','09:10:00',1.67),('8784','2014-05-03','09:15:00',2.76),('8784','2014-05-03','09:20:00',3.33),('8784','2014-05-03','09:25:00',2.16),('8784','2014-05-03','09:30:00',2.87),('8784','2014-05-03','09:35:00',3.38),('8784','2014-05-03','09:40:00',2.93),('8784','2014-05-03','09:45:00',3.36),('8784','2014-05-03','09:50:00',1.64),('8784','2014-05-03','09:55:00',3.34),('8784','2014-05-03','10:00:00',3.75),('8784','2014-05-03','10:05:00',3.74),('8784','2014-05-03','10:10:00',4.03),('8784','2014-05-03','10:15:00',4.34),('8784','2014-05-03','10:20:00',4.12),('8784','2014-05-03','10:25:00',2.25),('8784','2014-05-03','10:30:00',2.11),('8784','2014-05-03','10:35:00',1.16),('8784','2014-05-03','10:40:00',1.16),('8784','2014-05-03','10:45:00',1.25),('8784','2014-05-03','10:50:00',1.17),('8784','2014-05-03','10:55:00',1.57),('8784','2014-05-03','11:00:00',1.33),('8784','2014-05-03','11:05:00',4.2),('8784','2014-05-03','11:10:00',4.35),('8784','2014-05-03','11:15:00',5.29),('8784','2014-05-03','11:20:00',4.8),('8784','2014-05-03','11:25:00',3.77),('8784','2014-05-03','11:30:00',4.84),('8784','2014-05-03','11:35:00',2.96),('8784','2014-05-03','11:40:00',3.28),('8784','2014-05-03','11:45:00',2.75),('8784','2014-05-03','11:50:00',2.47),('8784','2014-05-03','11:55:00',2.55),('8784','2014-05-03','12:00:00',1.99),('8784','2014-05-03','12:05:00',1.61),('8784','2014-05-03','12:10:00',1.48),('8784','2014-05-03','12:15:00',1.39),('8784','2014-05-03','12:20:00',1.31),('8784','2014-05-03','12:25:00',1.38),('8784','2014-05-03','12:30:00',1.81),('8784','2014-05-03','12:35:00',2.27),('8784','2014-05-03','12:40:00',2.19),('8784','2014-05-03','12:45:00',2.21),('8784','2014-05-03','12:50:00',1.96),('8784','2014-05-03','12:55:00',1.93),('8784','2014-05-03','13:00:00',2.13),('8784','2014-05-03','13:05:00',2.55),('8784','2014-05-03','13:10:00',3.08),('8784','2014-05-03','13:15:00',2.98),('8784','2014-05-03','13:20:00',2.47),('8784','2014-05-03','13:25:00',2.99),('8784','2014-05-03','13:30:00',3.76),('8784','2014-05-03','13:35:00',2.96),('8784','2014-05-03','13:40:00',2.17),('8784','2014-05-03','13:45:00',2.03),('8784','2014-05-03','13:50:00',2),('8784','2014-05-03','13:55:00',2.01),('8784','2014-05-03','14:00:00',1.98),('8784','2014-05-03','14:05:00',1.99),('8784','2014-05-03','14:10:00',2.22),('8784','2014-05-03','14:15:00',2.58),('8784','2014-05-03','14:20:00',2.99),('8784','2014-05-03','14:25:00',3.51),('8784','2014-05-03','14:30:00',2.19),('8784','2014-05-03','14:35:00',1.68),('8784','2014-05-03','14:40:00',1.27),('8784','2014-05-03','14:55:00',3.38),('8784','2014-05-03','15:00:00',2.51),('8784','2014-05-03','15:05:00',1.27),('8784','2014-05-03','15:10:00',1),('8784','2014-05-03','16:50:00',1),('8784','2014-05-03','16:55:00',1.03),('8784','2014-05-03','17:00:00',1.05),('8784','2014-05-03','17:05:00',1.04),('8784','2014-05-03','17:10:00',1.03),('8784','2014-05-03','17:15:00',1.04),('8784','2014-05-03','17:20:00',1.02),('8784','2014-05-03','17:25:00',1.04),('8784','2014-05-03','17:45:00',1.04),('8784','2014-05-03','17:50:00',1.2),('8784','2014-05-03','17:55:00',1.23),('8784','2014-04-06','08:15:00',1.22),('8784','2014-04-06','08:20:00',1.29),('8784','2014-04-06','08:25:00',1.4),('8784','2014-04-06','08:30:00',1.48),('8784','2014-04-06','08:35:00',1.59),('8784','2014-04-06','08:40:00',1.71),('8784','2014-04-06','08:45:00',1.77),('8784','2014-04-06','08:50:00',1.67),('8784','2014-04-06','09:10:00',1.79),('8784','2014-04-06','09:15:00',2.49),('8784','2014-04-06','09:20:00',2.17),('8784','2014-04-06','09:25:00',1.85),('8784','2014-04-06','09:30:00',1.84),('8784','2014-04-06','09:35:00',2.41),('8784','2014-04-06','09:40:00',2.6),('8784','2014-04-06','09:45:00',3.2),('8784','2014-04-06','09:50:00',3.71),('8784','2014-04-06','09:55:00',3.75),('8784','2014-04-06','10:00:00',3.47),('8784','2014-04-06','10:05:00',2.54),('8784','2014-04-06','10:10:00',2.1),('8784','2014-04-06','10:15:00',2.44),('8784','2014-04-06','10:20:00',1.76),('8784','2014-04-06','10:25:00',1.35),('8784','2014-04-06','10:30:00',1.44),('8784','2014-04-06','10:35:00',1.59),('8784','2014-04-06','10:40:00',1.71),('8784','2014-04-06','10:45:00',2.84),('8784','2014-04-06','10:50:00',3.34),('8784','2014-04-06','10:55:00',1.6),('8784','2014-04-06','11:00:00',3),('8784','2014-04-06','11:05:00',3.18),('8784','2014-04-06','11:10:00',4.35),('8784','2014-04-06','11:15:00',1.76),('8784','2014-04-06','11:20:00',4.05),('8784','2014-04-06','11:25:00',4.16),('8784','2014-04-06','11:30:00',4.38),('8784','2014-04-06','11:35:00',4.69),('8784','2014-04-06','11:40:00',4.65),('8784','2014-04-06','11:45:00',4.52),('8784','2014-04-06','11:50:00',3.6),('8784','2014-04-06','11:55:00',4.55),('8784','2014-04-06','12:00:00',4.47),('8784','2014-04-06','12:05:00',4.36),('8784','2014-04-06','12:10:00',4.34),('8784','2014-04-06','12:15:00',4.48),('8784','2014-04-06','12:20:00',3.5),('8784','2014-04-06','12:25:00',1.9),('8784','2014-04-06','12:30:00',2.18),('8784','2014-04-06','12:35:00',2.04),('8784','2014-04-06','12:40:00',1.49),('8784','2014-04-06','12:45:00',1.16),('8784','2014-04-06','12:50:00',1.18),('8784','2014-04-06','12:55:00',1.9),('8784','2014-04-06','13:00:00',4.35),('8784','2014-04-06','13:05:00',3.24),('8784','2014-04-06','13:10:00',4.62),('8784','2014-04-06','13:15:00',3.87),('8784','2014-04-06','13:20:00',3.16),('8784','2014-04-06','13:25:00',1.21),('8784','2014-04-06','13:30:00',3.56),('8784','2014-04-06','13:35:00',3.41),('8784','2014-04-06','13:40:00',1.39),('8784','2014-04-06','13:45:00',4.12),('8784','2014-04-06','13:50:00',4.54),('8784','2014-04-06','13:55:00',4.48),('8784','2014-04-06','14:00:00',4.32),('8784','2014-04-06','14:05:00',4.17),('8784','2014-04-06','14:10:00',4.39),('8784','2014-04-06','14:15:00',4.51),('8784','2014-04-06','14:20:00',2.06),('8784','2014-04-06','14:25:00',1.64),('8784','2014-04-06','14:30:00',1.16),('8784','2014-04-06','14:35:00',1.36),('8784','2014-04-06','14:40:00',1.94),('8784','2014-04-06','14:45:00',4.97),('8784','2014-04-06','14:50:00',3.76),('8784','2014-04-06','14:55:00',3),('8784','2014-04-06','15:00:00',2.33),('8784','2014-04-06','15:05:00',1.33),('8784','2014-04-06','15:10:00',3.12),('8784','2014-04-06','15:15:00',3.15),('8784','2014-04-06','15:20:00',2.79),('8784','2014-04-06','15:25:00',1.38),('8784','2014-04-06','15:30:00',1.21),('8784','2014-04-06','15:45:00',1.01),('8784','2014-04-06','15:50:00',1.64),('8784','2014-04-06','15:55:00',3.76),('8784','2014-04-06','16:00:00',3.3),('8784','2014-04-06','16:05:00',1.53),('8784','2014-04-06','16:10:00',2.2),('8784','2014-04-06','16:15:00',1.31),('8784','2014-04-06','16:30:00',1.03),('8784','2014-04-06','16:35:00',1.53),('8784','2014-04-06','16:40:00',2.41),('8784','2014-04-06','16:45:00',3.09),('8784','2014-04-06','16:50:00',3.03),('8784','2014-04-06','16:55:00',2.59),('8784','2014-04-06','17:25:00',1.83),('8784','2014-04-06','17:30:00',1.85),('8784','2014-04-06','17:35:00',1.27),('8784','2014-04-06','17:45:00',1.11),('8784','2014-04-06','17:50:00',1.49),('8784','2014-04-06','17:55:00',1.33),('8784','2014-04-06','18:00:00',1.22),('8784','2014-04-06','18:05:00',1.11),('8784','2014-04-06','18:10:00',1.06),('8784','2014-04-06','18:15:00',1.04),('8784','2014-04-06','18:20:00',1.04),('8784','2013-07-10','07:20:00',1.19),('8784','2013-07-10','07:25:00',1.37),('8784','2013-07-10','07:30:00',1.51),('8784','2013-07-10','07:35:00',1.67),('8784','2013-07-10','07:40:00',1.79),('8784','2013-07-10','07:45:00',1.91),('8784','2013-07-10','07:50:00',2.04),('8784','2013-07-10','07:55:00',2.18),('8784','2013-07-10','08:00:00',1.86),('8784','2013-07-10','08:05:00',1.52),('8784','2013-07-10','08:10:00',1.95),('8784','2013-07-10','08:15:00',2.01),('8784','2013-07-10','08:20:00',2.16),('8784','2013-07-10','08:25:00',2.23),('8784','2013-07-10','08:30:00',1.86),('8784','2013-07-10','08:35:00',2),('8784','2013-07-10','08:40:00',2.74),('8784','2013-07-10','08:45:00',2.53),('8784','2013-07-10','08:50:00',2.56),('8784','2013-07-10','08:55:00',2.56),('8784','2013-07-10','09:00:00',2.51),('8784','2013-07-10','09:05:00',2.65),('8784','2013-07-10','09:10:00',2.81),('8784','2013-07-10','09:15:00',2.91),('8784','2013-07-10','09:20:00',2.56),('8784','2013-07-10','09:25:00',1.87),('8784','2013-07-10','09:30:00',2.8),('8784','2013-07-10','09:35:00',3.04),('8784','2013-07-10','09:40:00',3.05),('8784','2013-07-10','09:45:00',3.12),('8784','2013-07-10','09:50:00',3.15),('8784','2013-07-10','09:55:00',2.35),('8784','2013-07-10','10:00:00',3.28),('8784','2013-07-10','10:05:00',3.32),('8784','2013-07-10','10:10:00',3.36),('8784','2013-07-10','10:15:00',3.43),('8784','2013-07-10','10:20:00',3.52),('8784','2013-07-10','10:25:00',3.57),('8784','2013-07-10','10:30:00',3.6),('8784','2013-07-10','10:35:00',3.63),('8784','2013-07-10','10:40:00',3.69),('8784','2013-07-10','10:45:00',3.74),('8784','2013-07-10','10:50:00',3.78),('8784','2013-07-10','10:55:00',3.8),('8784','2013-07-10','11:00:00',3.82),('8784','2013-07-10','11:05:00',3.83),('8784','2013-07-10','11:10:00',3.87),('8784','2013-07-10','11:15:00',3.92),('8784','2013-07-10','11:20:00',3.94),('8784','2013-07-10','11:25:00',3.96),('8784','2013-07-10','11:30:00',3.96),('8784','2013-07-10','11:35:00',3.99),('8784','2013-07-10','11:40:00',4.02),('8784','2013-07-10','11:45:00',4.07),('8784','2013-07-10','11:50:00',4.07),('8784','2013-07-10','11:55:00',4.11),('8784','2013-07-10','12:00:00',4.12),('8784','2013-07-10','12:05:00',4.18),('8784','2013-07-10','12:10:00',4.2),('8784','2013-07-10','12:15:00',4.23),('8784','2013-07-10','12:20:00',4.24),('8784','2013-07-10','12:25:00',4.3),('8784','2013-07-10','12:30:00',4.27),('8784','2013-07-10','12:35:00',4.33),('8784','2013-07-10','12:40:00',4.33),('8784','2013-07-10','12:45:00',4.31),('8784','2013-07-10','12:50:00',4.32),('8784','2013-07-10','12:55:00',4.28),('8784','2013-07-10','13:00:00',4.37),('8784','2013-07-10','13:05:00',4.37),('8784','2013-07-10','13:10:00',4.4),('8784','2013-07-10','13:15:00',4.35),('8784','2013-07-10','13:20:00',4.35),('8784','2013-07-10','13:25:00',4.35),('8784','2013-07-10','13:30:00',4.33),('8784','2013-07-10','13:35:00',4.36),('8784','2013-07-10','13:40:00',4.37),('8784','2013-07-10','13:45:00',4.36),('8784','2013-07-10','13:50:00',4.37),('8784','2013-07-10','13:55:00',4.35),('8784','2013-07-10','14:00:00',4.35),('8784','2013-07-10','14:05:00',4.37),('8784','2013-07-10','14:10:00',4.34),('8784','2013-07-10','14:15:00',4.31),('8784','2013-07-10','14:20:00',4.32),('8784','2013-07-10','14:25:00',4.29),('8784','2013-07-10','14:30:00',4.29),('8784','2013-07-10','14:35:00',4.25),('8784','2013-07-10','14:40:00',4.23),('8784','2013-07-10','14:45:00',4.16),('8784','2013-07-10','14:50:00',4.14),('8784','2013-07-10','14:55:00',4.13),('8784','2013-07-10','15:00:00',4.09),('8784','2013-07-10','15:05:00',4.08),('8784','2013-07-10','15:10:00',4.04),('8784','2013-07-10','15:15:00',4),('8784','2013-07-10','15:20:00',3.94),('8784','2013-07-10','15:25:00',3.92),('8784','2013-07-10','15:30:00',3.87),('8784','2013-07-10','15:35:00',3.85),('8784','2013-07-10','15:40:00',3.01),('8784','2013-07-10','15:45:00',3.73),('8784','2013-07-10','15:50:00',3.69),('8784','2013-07-10','15:55:00',3.66),('8784','2013-07-10','16:00:00',3.6),('8784','2013-07-10','16:05:00',3.53),('8784','2013-07-10','16:10:00',3.49),('8784','2013-07-10','16:15:00',3.41),('8784','2013-07-10','16:20:00',3.38),('8784','2013-07-10','16:25:00',3.3),('8784','2013-07-10','16:30:00',3.21),('8784','2013-07-10','16:35:00',3.14),('8784','2013-07-10','16:40:00',3.08),('8784','2013-07-10','16:45:00',3.02),('8784','2013-07-10','16:50:00',2.98),('8784','2013-07-10','16:55:00',2.96),('8784','2013-07-10','17:00:00',3),('8784','2013-07-10','17:05:00',2.53),('8784','2013-07-10','17:10:00',2.43),('8784','2013-07-10','17:15:00',1.57),('8784','2013-07-10','17:20:00',1.85),('8784','2013-07-10','17:35:00',2.06),('8784','2013-07-10','17:40:00',2.03),('8784','2013-07-10','17:45:00',2.06),('8784','2013-07-10','17:50:00',2.04),('8784','2013-07-10','17:55:00',1.88),('8784','2013-07-10','18:00:00',1.98),('8784','2013-07-10','18:05:00',1.6),('8784','2013-07-10','18:10:00',1.38),('8784','2013-07-10','18:20:00',1.03),('8784','2013-07-09','07:40:00',1.29),('8784','2013-07-09','07:45:00',1.35),('8784','2013-07-09','07:50:00',1.43),('8784','2013-07-09','07:55:00',1.47),('8784','2013-07-09','08:00:00',1.52),('8784','2013-07-09','08:05:00',1.65),('8784','2013-07-09','08:10:00',1.65),('8784','2013-07-09','08:15:00',1.76),('8784','2013-07-09','08:20:00',1.86),('8784','2013-07-09','08:25:00',1.89),('8784','2013-07-09','08:30:00',1.98),('8784','2013-07-09','08:35:00',2.08),('8784','2013-07-09','08:40:00',2.14),('8784','2013-07-09','08:45:00',2.26),('8784','2013-07-09','08:50:00',2.33),('8784','2013-07-09','08:55:00',2.38),('8784','2013-07-09','09:00:00',2.45),('8784','2013-07-09','09:05:00',2.55),('8784','2013-07-09','09:10:00',2.64),('8784','2013-07-09','09:15:00',2.73),('8784','2013-07-09','09:20:00',2.78),('8784','2013-07-09','09:25:00',2.84),('8784','2013-07-09','09:30:00',2.91),('8784','2013-07-09','09:35:00',2.97),('8784','2013-07-09','09:40:00',3.03),('8784','2013-07-09','09:45:00',3.07),('8784','2013-07-09','09:50:00',3.14),('8784','2013-07-09','09:55:00',3.21),('8784','2013-07-09','10:00:00',2.97),('8784','2013-07-09','10:05:00',3.2),('8784','2013-07-09','10:10:00',3.34),('8784','2013-07-09','10:15:00',3.38),('8784','2013-07-09','10:20:00',3.41),('8784','2013-07-09','10:25:00',3.47),('8784','2013-07-09','10:30:00',3.54),('8784','2013-07-09','10:35:00',3.59),('8784','2013-07-09','10:40:00',3.64),('8784','2013-07-09','10:45:00',3.69),('8784','2013-07-09','10:50:00',3.72),('8784','2013-07-09','10:55:00',3.8),('8784','2013-07-09','11:00:00',3.87),('8784','2013-07-09','11:05:00',3.89),('8784','2013-07-09','11:10:00',3.9),('8784','2013-07-09','11:15:00',3.82),('8784','2013-07-09','11:20:00',3.84),('8784','2013-07-09','11:25:00',3.61),('8784','2013-07-09','11:30:00',2.26),('8784','2013-07-09','11:35:00',2.97),('8784','2013-07-09','11:40:00',3.4),('8784','2013-07-09','11:45:00',4.19),('8784','2013-07-09','11:50:00',4.64),('8784','2013-07-09','11:55:00',4.52),('8784','2013-07-09','12:00:00',4.49),('8784','2013-07-09','12:05:00',4.42),('8784','2013-07-09','12:10:00',4.35),('8784','2013-07-09','12:15:00',4.31),('8784','2013-07-09','12:20:00',4.25),('8784','2013-07-09','12:25:00',4.22),('8784','2013-07-09','12:30:00',4.21),('8784','2013-07-09','12:35:00',4.17),('8784','2013-07-09','12:40:00',4.24),('8784','2013-07-09','12:45:00',4.24),('8784','2013-07-09','12:50:00',4.28),('8784','2013-07-09','12:55:00',4.23),('8784','2013-07-09','13:00:00',4.28),('8784','2013-07-09','13:05:00',4.42),('8784','2013-07-09','13:10:00',4.39),('8784','2013-07-09','13:15:00',4.37),('8784','2013-07-09','13:20:00',4.26),('8784','2013-07-09','13:25:00',4.46),('8784','2013-07-09','13:30:00',4.53),('8784','2013-07-09','13:35:00',4.35),('8784','2013-07-09','13:40:00',4.33),('8784','2013-07-09','13:45:00',3.78),('8784','2013-07-09','13:50:00',3.29),('8784','2013-07-09','13:55:00',3.44),('8784','2013-07-09','14:00:00',3.5),('8784','2013-07-09','14:05:00',3.3),('8784','2013-07-09','14:10:00',3.65),('8784','2013-07-09','14:15:00',3.75),('8784','2013-07-09','14:20:00',2.69),('8784','2013-07-09','14:25:00',2.86),('8784','2013-07-09','14:30:00',1.76),('8784','2013-07-09','14:35:00',1.1),('8784','2013-07-08','07:40:00',1.57),('8784','2013-07-08','07:45:00',1.49),('8784','2013-07-08','07:50:00',1.14),('8784','2013-07-08','07:55:00',1.17),('8784','2013-07-08','08:00:00',1.41),('8784','2013-07-08','08:05:00',1.42),('8784','2013-07-08','08:10:00',1.6),('8784','2013-07-08','08:15:00',1.78),('8784','2013-07-08','08:20:00',1.89),('8784','2013-07-08','08:25:00',1.98),('8784','2013-07-08','08:30:00',2.08),('8784','2013-07-08','08:35:00',2.15),('8784','2013-07-08','08:40:00',2.19),('8784','2013-07-08','08:45:00',2.28),('8784','2013-07-08','08:50:00',2.36),('8784','2013-07-08','08:55:00',2.43),('8784','2013-07-08','09:00:00',2.48),('8784','2013-07-08','09:05:00',2.56),('8784','2013-07-08','09:10:00',2.61),('8784','2013-07-08','09:15:00',2.66),('8784','2013-07-08','09:20:00',2.69),('8784','2013-07-08','09:25:00',2.66),('8784','2013-07-08','09:30:00',2.82),('8784','2013-07-08','09:35:00',2.97),('8784','2013-07-08','09:40:00',3.06),('8784','2013-07-08','09:45:00',3.08),('8784','2013-07-08','09:50:00',3.16),('8784','2013-07-08','09:55:00',3.23),('8784','2013-07-08','10:00:00',3.32),('8784','2013-07-08','10:05:00',3.37),('8784','2013-07-08','10:10:00',3.38),('8784','2013-07-08','10:15:00',3.44),('8784','2013-07-08','10:20:00',3.5),('8784','2013-07-08','10:25:00',3.54),('8784','2013-07-08','10:30:00',3.61),('8784','2013-07-08','10:35:00',3.63),('8784','2013-07-08','10:40:00',3.63),('8784','2013-07-08','10:45:00',3.68),('8784','2013-07-08','10:50:00',3.71),('8784','2013-07-08','10:55:00',3.72),('8784','2013-07-08','11:00:00',3.73),('8784','2013-07-08','11:05:00',3.82),('8784','2013-07-08','11:10:00',3.88),('8784','2013-07-08','11:15:00',3.96),('8784','2013-07-08','11:20:00',4.01),('8784','2013-07-08','11:25:00',4.07),('8784','2013-07-08','11:30:00',4.1),('8784','2013-07-08','11:35:00',4.14),('8784','2013-07-08','11:40:00',3.95),('8784','2013-07-08','11:45:00',4.13),('8784','2013-07-08','11:50:00',4.19),('8784','2013-07-08','11:55:00',4.16),('8784','2013-07-08','12:00:00',4.18),('8784','2013-07-08','12:05:00',4.29),('8784','2013-07-08','12:10:00',4.38),('8784','2013-07-08','12:15:00',4.51),('8784','2013-07-08','12:20:00',4.57),('8784','2013-07-08','12:25:00',4.53),('8784','2013-07-08','12:30:00',3.89),('8784','2013-07-08','12:35:00',4.4),('8784','2013-07-08','12:40:00',4.34),('8784','2013-07-08','12:45:00',4.28),('8784','2013-07-08','12:50:00',4.3),('8784','2013-07-08','12:55:00',4.42),('8784','2013-07-08','13:00:00',4.59),('8784','2013-07-08','13:05:00',4.7),('8784','2013-07-08','13:10:00',4.63),('8784','2013-07-08','13:15:00',4.98),('8784','2013-07-08','13:20:00',3.28),('8784','2013-07-08','13:25:00',1.45),('8784','2013-07-08','14:30:00',1.06),('8784','2013-07-08','14:35:00',1.26),('8784','2013-07-08','14:40:00',1.32),('8784','2013-07-08','14:45:00',1.25),('8784','2013-07-08','14:50:00',1.23),('8784','2013-07-08','14:55:00',1.22),('8784','2013-07-08','15:00:00',1.13),('8784','2013-07-08','15:05:00',1.02),('8784','2013-07-08','17:30:00',1.02),('8784','2013-07-08','17:35:00',1.11),('8784','2013-07-08','17:40:00',1.13),('8784','2013-07-08','17:45:00',1.13),('8784','2013-07-08','17:50:00',1.13),('8784','2013-07-08','17:55:00',1.08),('8784','2013-07-08','18:25:00',1.02),('8784','2013-07-08','18:40:00',1.39),('8784','2013-07-08','18:45:00',1.38),('8784','2013-07-08','18:50:00',1.22),('8784','2013-07-08','18:55:00',1.02),('8784','2013-07-07','07:20:00',1.01),('8784','2013-07-07','07:25:00',1.09),('8784','2013-07-07','07:30:00',1.17),('8784','2013-07-07','07:35:00',1.25),('8784','2013-07-07','07:40:00',1.34),('8784','2013-07-07','07:45:00',1.42),('8784','2013-07-07','07:50:00',1.5),('8784','2013-07-07','07:55:00',1.57),('8784','2013-07-07','08:00:00',1.61),('8784','2013-07-07','08:05:00',1.7),('8784','2013-07-07','08:10:00',1.79),('8784','2013-07-07','08:15:00',1.84),('8784','2013-07-07','08:20:00',1.44),('8784','2013-07-07','08:25:00',1.58),('8784','2013-07-07','08:30:00',1.88),('8784','2013-07-07','08:35:00',2.26),('8784','2013-07-07','08:40:00',1.79),('8784','2013-07-07','08:50:00',1.95),('8784','2013-07-07','08:55:00',2.6),('8784','2013-07-07','09:00:00',2.63),('8784','2013-07-07','09:05:00',2.41),('8784','2013-07-07','09:10:00',2.54),('8784','2013-07-07','09:15:00',2.68),('8784','2013-07-07','09:20:00',1.72),('8784','2013-07-07','09:25:00',2.15),('8784','2013-07-07','09:30:00',3.03),('8784','2013-07-07','09:35:00',3.08),('8784','2013-07-07','09:40:00',2.99),('8784','2013-07-07','09:45:00',3.2),('8784','2013-07-07','09:50:00',3.32),('8784','2013-07-07','09:55:00',3.46),('8784','2013-07-07','10:00:00',3.54),('8784','2013-07-07','10:05:00',3.29),('8784','2013-07-07','10:10:00',3.35),('8784','2013-07-07','10:15:00',3.32),('8784','2013-07-07','10:20:00',3.27),('8784','2013-07-07','10:25:00',3.51),('8784','2013-07-07','10:30:00',3.11),('8784','2013-07-07','10:35:00',3.86),('8784','2013-07-07','10:40:00',3.65),('8784','2013-07-07','10:45:00',3.75),('8784','2013-07-07','10:50:00',3.91),('8784','2013-07-07','10:55:00',3.89),('8784','2013-07-07','11:00:00',3.93),('8784','2013-07-07','11:05:00',3.97),('8784','2013-07-07','11:10:00',4.06),('8784','2013-07-07','11:15:00',4.06),('8784','2013-07-07','11:20:00',3.8),('8784','2013-07-07','11:25:00',3.48),('8784','2013-07-07','11:30:00',3.56),('8784','2013-07-07','11:35:00',3.44),('8784','2013-07-07','11:40:00',3.62),('8784','2013-07-07','11:45:00',3.01),('8784','2013-07-07','11:50:00',3.16),('8784','2013-07-07','11:55:00',2.26),('8784','2013-07-07','12:00:00',2.31),('8784','2013-07-07','12:05:00',4.09),('8784','2013-07-07','12:10:00',4.17),('8784','2013-07-07','12:15:00',4.22),('8784','2013-07-07','12:20:00',4.3),('8784','2013-07-07','12:25:00',4.11),('8784','2013-07-07','12:30:00',4.05),('8784','2013-07-07','12:35:00',4.24),('8784','2013-07-07','12:40:00',4.43),('8784','2013-07-07','12:45:00',4.47),('8784','2013-07-07','12:50:00',4.28),('8784','2013-07-07','12:55:00',4.54),('8784','2013-07-07','13:00:00',4.4),('8784','2013-07-07','13:05:00',4.41),('8784','2013-07-07','13:10:00',4.44),('8784','2013-07-07','13:15:00',4.45),('8784','2013-07-07','13:20:00',4.4),('8784','2013-07-07','13:25:00',3.63),('8784','2013-07-07','13:30:00',3.9),('8784','2013-07-07','13:35:00',4.53),('8784','2013-07-07','13:40:00',4.47),('8784','2013-07-07','13:45:00',4.2),('8784','2013-07-07','13:50:00',4.9),('8784','2013-07-07','13:55:00',4.1),('8784','2013-07-07','14:00:00',2.68),('8784','2013-07-07','14:05:00',3.76),('8784','2013-07-07','14:10:00',2.44),('8784','2013-07-07','14:15:00',1.61),('8784','2013-07-07','14:20:00',1.34),('8784','2013-07-07','14:25:00',1.18),('8784','2013-07-07','14:30:00',1.11),('8784','2013-07-07','14:35:00',1.02),('8784','2013-07-07','15:00:00',1.09),('8784','2013-07-07','15:05:00',1.23),('8784','2013-07-07','17:00:00',1.02),('8784','2013-07-07','17:05:00',1.1),('8784','2013-07-07','17:10:00',1.14),('8784','2013-07-07','17:15:00',1.18),('8784','2013-07-07','17:20:00',1.19),('8784','2013-07-07','17:25:00',1.17),('8784','2013-07-07','17:30:00',1.14),('8784','2013-07-07','17:35:00',1.07),('8784','2013-07-07','17:40:00',1.01),('8784','2013-07-06','07:25:00',1.04),('8784','2013-07-06','07:30:00',1.1),('8784','2013-07-06','07:35:00',1.15),('8784','2013-07-06','07:40:00',1.24),('8784','2013-07-06','07:45:00',1.33),('8784','2013-07-06','07:50:00',1.43),('8784','2013-07-06','07:55:00',1.52),('8784','2013-07-06','08:00:00',1.6),('8784','2013-07-06','08:05:00',1.7),('8784','2013-07-06','08:10:00',1.74),('8784','2013-07-06','08:15:00',1.84),('8784','2013-07-06','08:20:00',1.88),('8784','2013-07-06','08:25:00',2.02),('8784','2013-07-06','08:30:00',2.11),('8784','2013-07-06','08:35:00',2.19),('8784','2013-07-06','08:40:00',2.27),('8784','2013-07-06','08:45:00',2.34),('8784','2013-07-06','08:50:00',2.4),('8784','2013-07-06','08:55:00',2.47),('8784','2013-07-06','09:00:00',2.55),('8784','2013-07-06','09:05:00',2.63),('8784','2013-07-06','09:10:00',2.71),('8784','2013-07-06','09:15:00',2.78),('8784','2013-07-06','09:20:00',2.85),('8784','2013-07-06','09:25:00',2.86),('8784','2013-07-06','09:30:00',2.94),('8784','2013-07-06','09:35:00',3.01),('8784','2013-07-06','09:40:00',3.07),('8784','2013-07-06','09:45:00',3.12),('8784','2013-07-06','09:50:00',3.2),('8784','2013-07-06','09:55:00',3.28),('8784','2013-07-06','10:00:00',3.34),('8784','2013-07-06','10:05:00',3.41),('8784','2013-07-06','10:10:00',3.48),('8784','2013-07-06','10:15:00',3.51),('8784','2013-07-06','10:20:00',3.54),('8784','2013-07-06','10:25:00',3.59),('8784','2013-07-06','10:30:00',3.63),('8784','2013-07-06','10:35:00',3.66),('8784','2013-07-06','10:40:00',3.69),('8784','2013-07-06','10:45:00',3.76),('8784','2013-07-06','10:50:00',3.81),('8784','2013-07-06','10:55:00',3.87),('8784','2013-07-06','11:00:00',3.92),('8784','2013-07-06','11:05:00',3.95),('8784','2013-07-06','11:10:00',3.96),('8784','2013-07-06','11:15:00',4),('8784','2013-07-06','11:20:00',4),('8784','2013-07-06','11:25:00',4.05),('8784','2013-07-06','11:30:00',4.09),('8784','2013-07-06','11:35:00',4.1),('8784','2013-07-06','11:40:00',4.1),('8784','2013-07-06','11:45:00',4.17),('8784','2013-07-06','11:50:00',4.2),('8784','2013-07-06','11:55:00',4.17),('8784','2013-07-06','12:00:00',4.19),('8784','2013-07-06','12:05:00',4.23),('8784','2013-07-06','12:10:00',4.32),('8784','2013-07-06','12:15:00',4.35),('8784','2013-07-06','12:20:00',4.38),('8784','2013-07-06','12:25:00',4.36),('8784','2013-07-06','12:30:00',4.4),('8784','2013-07-06','12:35:00',4.4),('8784','2013-07-06','12:40:00',4.37),('8784','2013-07-06','12:45:00',4.4),('8784','2013-07-06','12:50:00',4.38),('8784','2013-07-06','12:55:00',4.37),('8784','2013-07-06','13:00:00',4.43),('8784','2013-07-06','13:05:00',4.42),('8784','2013-07-06','13:10:00',4.43),('8784','2013-07-06','13:15:00',4.45),('8784','2013-07-06','13:20:00',4.46),('8784','2013-07-06','13:25:00',4.43),('8784','2013-07-06','13:30:00',4.45),('8784','2013-07-06','13:35:00',4.36),('8784','2013-07-06','13:40:00',4.45),('8784','2013-07-06','13:45:00',4.44),('8784','2013-07-06','13:50:00',4.38),('8784','2013-07-06','13:55:00',4.36),('8784','2013-07-06','14:00:00',4.36),('8784','2013-07-06','14:05:00',4.4),('8784','2013-07-06','14:10:00',4.29),('8784','2013-07-06','14:15:00',4.35),('8784','2013-07-06','14:20:00',4.23),('8784','2013-07-06','14:25:00',4.33),('8784','2013-07-06','14:30:00',4.23),('8784','2013-07-06','14:35:00',4.23),('8784','2013-07-06','14:40:00',4.19),('8784','2013-07-06','14:45:00',4.11),('8784','2013-07-06','14:50:00',4.06),('8784','2013-07-06','14:55:00',2.78),('8784','2013-07-06','15:00:00',3.12),('8784','2013-07-06','15:05:00',4.28),('8784','2013-07-06','15:10:00',4.14),('8784','2013-07-06','15:15:00',4.04),('8784','2013-07-06','15:20:00',3.95),('8784','2013-07-06','15:25:00',3.97),('8784','2013-07-06','15:30:00',3.33),('8784','2013-07-06','15:35:00',2.31),('8784','2013-07-06','16:50:00',1.64),('8784','2013-07-06','16:55:00',2.06),('8784','2013-07-06','17:00:00',1.2),('8784','2013-07-06','17:05:00',1.11),('8784','2013-07-06','17:10:00',1.35),('8784','2013-07-06','17:15:00',2.14),('8784','2013-07-06','17:20:00',1.21),('8784','2013-07-06','17:25:00',1.09),('8784','2013-07-06','17:30:00',1.27),('8784','2013-07-06','17:35:00',1.18),('8784','2013-07-05','07:20:00',1.02),('8784','2013-07-05','07:25:00',1.07),('8784','2013-07-05','07:30:00',1.16),('8784','2013-07-05','07:35:00',1.25),('8784','2013-07-05','07:40:00',1.33),('8784','2013-07-05','07:45:00',1.39),('8784','2013-07-05','07:50:00',1.48),('8784','2013-07-05','07:55:00',1.52),('8784','2013-07-05','08:00:00',1.62),('8784','2013-07-05','08:05:00',1.62),('8784','2013-07-05','08:10:00',1.75),('8784','2013-07-05','08:15:00',1.82),('8784','2013-07-05','08:20:00',1.86),('8784','2013-07-05','08:25:00',2),('8784','2013-07-05','08:30:00',2.07),('8784','2013-07-05','08:35:00',2.18),('8784','2013-07-05','08:40:00',2.25),('8784','2013-07-05','08:45:00',2.3),('8784','2013-07-05','08:50:00',2.39),('8784','2013-07-05','08:55:00',2.43),('8784','2013-07-05','09:00:00',2.53),('8784','2013-07-05','09:05:00',2.62),('8784','2013-07-05','09:10:00',2.69),('8784','2013-07-05','09:15:00',2.76),('8784','2013-07-05','09:20:00',2.83),('8784','2013-07-05','09:25:00',2.91),('8784','2013-07-05','09:30:00',2.97),('8784','2013-07-05','09:35:00',3.02),('8784','2013-07-05','09:40:00',3.07),('8784','2013-07-05','09:45:00',3.14),('8784','2013-07-05','09:50:00',3.2),('8784','2013-07-05','09:55:00',3.26),('8784','2013-07-05','10:00:00',3.31),('8784','2013-07-05','10:05:00',3.36),('8784','2013-07-05','10:10:00',3.43),('8784','2013-07-05','10:15:00',3.47),('8784','2013-07-05','10:20:00',3.52),('8784','2013-07-05','10:25:00',3.57),('8784','2013-07-05','10:30:00',3.62),('8784','2013-07-05','10:35:00',3.66),('8784','2013-07-05','10:40:00',3.71),('8784','2013-07-05','10:45:00',3.74),('8784','2013-07-05','10:50:00',3.76),('8784','2013-07-05','10:55:00',3.76),('8784','2013-07-05','11:00:00',3.82),('8784','2013-07-05','11:05:00',3.85),('8784','2013-07-05','11:10:00',3.88),('8784','2013-07-05','11:15:00',3.9),('8784','2013-07-05','11:20:00',3.95),('8784','2013-07-05','11:25:00',4),('8784','2013-07-05','11:30:00',4.07),('8784','2013-07-05','11:35:00',4.1),('8784','2013-07-05','11:40:00',4.11),('8784','2013-07-05','11:45:00',4.11),('8784','2013-07-05','11:50:00',4.13),('8784','2013-07-05','11:55:00',4.2),('8784','2013-07-05','12:00:00',4.19),('8784','2013-07-05','12:05:00',4.21),('8784','2013-07-05','12:10:00',4.23),('8784','2013-07-05','12:15:00',4.24),('8784','2013-07-05','12:20:00',4.34),('8784','2013-07-05','12:25:00',3.35),('8784','2013-07-05','12:30:00',3.99),('8784','2013-07-05','12:35:00',3.55),('8784','2013-07-05','12:40:00',3.76),('8784','2013-07-05','12:45:00',4.39),('8784','2013-07-05','12:50:00',4.42),('8784','2013-07-05','12:55:00',4.45),('8784','2013-07-05','13:00:00',3.66),('8784','2013-07-05','13:05:00',2.83),('8784','2013-07-05','13:10:00',4.58),('8784','2013-07-05','13:15:00',4.52),('8784','2013-07-05','13:20:00',2.9),('8784','2013-07-05','13:25:00',4.39),('8784','2013-07-05','13:30:00',4.49),('8784','2013-07-05','13:35:00',4.39),('8784','2013-07-05','13:40:00',4.45),('8784','2013-07-05','13:45:00',4.45),('8784','2013-07-05','13:50:00',4.41),('8784','2013-07-05','13:55:00',4.41),('8784','2013-07-05','14:00:00',4.45),('8784','2013-07-05','14:05:00',4.22),('8784','2013-07-05','14:10:00',2.12),('8784','2013-07-05','14:15:00',4.33),('8784','2013-07-05','14:20:00',4.24),('8784','2013-07-05','14:25:00',4.24),('8784','2013-07-05','14:30:00',4.18),('8784','2013-07-05','14:35:00',3.6),('8784','2013-07-05','14:40:00',4.22),('8784','2013-07-05','14:45:00',2.86),('8784','2013-07-05','14:50:00',3.51),('8784','2013-07-05','14:55:00',3.7),('8784','2013-07-05','15:00:00',4.04),('8784','2013-07-05','15:05:00',2.86),('8784','2013-07-05','15:10:00',4.18),('8784','2013-07-05','15:15:00',4.05),('8784','2013-07-05','15:20:00',3.08),('8784','2013-07-05','15:25:00',3.37),('8784','2013-07-05','15:30:00',3.47),('8784','2013-07-05','15:35:00',3.92),('8784','2013-07-05','15:40:00',3.8),('8784','2013-07-05','15:45:00',3.81),('8784','2013-07-05','15:50:00',3.75),('8784','2013-07-05','15:55:00',3.64),('8784','2013-07-05','16:00:00',3.56),('8784','2013-07-05','16:05:00',3.54),('8784','2013-07-05','16:10:00',3.44),('8784','2013-07-05','16:15:00',3.38),('8784','2013-07-05','16:20:00',3.36),('8784','2013-07-05','16:25:00',3.31),('8784','2013-07-05','16:30:00',3.23),('8784','2013-07-05','16:35:00',3.17),('8784','2013-07-05','16:40:00',3.09),('8784','2013-07-05','16:45:00',3.06),('8784','2013-07-05','16:50:00',2.93),('8784','2013-07-05','16:55:00',2.84),('8784','2013-07-05','17:00:00',2.79),('8784','2013-07-05','17:05:00',2.72),('8784','2013-07-05','17:10:00',2.7),('8784','2013-07-05','17:15:00',2.67),('8784','2013-07-05','17:20:00',2.61),('8784','2013-07-05','17:25:00',2.46),('8784','2013-07-05','17:30:00',2.42),('8784','2013-07-05','17:35:00',2.31),('8784','2013-07-05','17:40:00',2.18),('8784','2013-07-05','17:45:00',2.08),('8784','2013-07-05','17:50:00',1.98),('8784','2013-07-05','17:55:00',1.92),('8784','2013-07-05','18:00:00',1.91),('8784','2013-07-05','18:05:00',1.84),('8784','2013-07-05','18:10:00',1.61),('8784','2013-07-05','18:15:00',1.06),('8784','2013-07-05','18:20:00',1.3),('8784','2013-07-05','18:30:00',1.14),('8784','2013-07-05','18:35:00',1.23),('8784','2013-07-05','18:40:00',1.18),('8784','2013-07-05','18:45:00',1.12),('8784','2013-07-05','18:50:00',1.04),('8784','2013-07-04','08:55:00',1),('8784','2013-07-04','11:10:00',1.15),('8784','2013-07-04','11:15:00',1.19),('8784','2013-07-04','11:20:00',1.14),('8784','2013-07-04','11:25:00',1.21),('8784','2013-07-04','11:30:00',1.31),('8784','2013-07-04','11:35:00',1.51),('8784','2013-07-04','11:40:00',1.71),('8784','2013-07-04','11:45:00',1.83),('8784','2013-07-04','11:50:00',1.85),('8784','2013-07-04','11:55:00',1.68),('8784','2013-07-04','12:00:00',1.6),('8784','2013-07-04','12:05:00',2.12),('8784','2013-07-04','12:10:00',2.65),('8784','2013-07-04','12:15:00',2.74),('8784','2013-07-04','12:20:00',2.65),('8784','2013-07-04','12:25:00',3.5),('8784','2013-07-04','12:30:00',2.89),('8784','2013-07-04','12:35:00',2.45),('8784','2013-07-04','12:40:00',1.77),('8784','2013-07-04','12:45:00',1.42),('8784','2013-07-04','12:50:00',1.11),('8784','2013-07-04','12:55:00',1.01),('8784','2013-07-04','13:00:00',1.13),('8784','2013-07-04','13:05:00',1.36),('8784','2013-07-04','13:10:00',1.79),('8784','2013-07-04','13:15:00',2.08),('8784','2013-07-04','13:20:00',2.15),('8784','2013-07-04','13:25:00',2.98),('8784','2013-07-04','13:30:00',2.4),('8784','2013-07-04','13:35:00',2.55),('8784','2013-07-04','13:40:00',2.97),('8784','2013-07-04','13:45:00',4.28),('8784','2013-07-04','13:50:00',5.14),('8784','2013-07-04','13:55:00',3.7),('8784','2013-07-04','14:00:00',2.82),('8784','2013-07-04','14:05:00',2.51),('8784','2013-07-04','14:10:00',2.37),('8784','2013-07-04','14:15:00',2.44),('8784','2013-07-04','14:20:00',2.52),('8784','2013-07-04','14:25:00',2.16),('8784','2013-07-04','14:30:00',2.18),('8784','2013-07-04','14:35:00',2.3),('8784','2013-07-04','14:40:00',2.82),('8784','2013-07-04','14:45:00',3.53),('8784','2013-07-04','14:50:00',2.67),('8784','2013-07-04','14:55:00',2.33),('8784','2013-07-04','15:00:00',1.99),('8784','2013-07-04','15:05:00',2.3),('8784','2013-07-04','15:10:00',3.5),('8784','2013-07-04','15:15:00',3.46),('8784','2013-07-04','15:20:00',2.98),('8784','2013-07-04','15:25:00',2.55),('8784','2013-07-04','15:30:00',2.81),('8784','2013-07-04','15:35:00',2.63),('8784','2013-07-04','15:40:00',2.74),('8784','2013-07-04','15:45:00',3.71),('8784','2013-07-04','15:50:00',2.23),('8784','2013-07-04','15:55:00',2.34),('8784','2013-07-04','16:00:00',2.47),('8784','2013-07-04','16:05:00',2.48),('8784','2013-07-04','16:10:00',2),('8784','2013-07-04','16:15:00',1.92),('8784','2013-07-04','16:20:00',2.02),('8784','2013-07-04','16:25:00',2.28),('8784','2013-07-04','16:30:00',2.52),('8784','2013-07-04','16:35:00',2.43),('8784','2013-07-04','16:40:00',1.9),('8784','2013-07-04','16:45:00',1.77),('8784','2013-07-04','16:50:00',1.66),('8784','2013-07-04','16:55:00',1.59),('8784','2013-07-04','17:00:00',1.41),('8784','2013-07-04','17:05:00',1.38),('8784','2013-07-04','17:10:00',2.27),('8784','2013-07-04','17:15:00',2.71),('8784','2013-07-04','17:20:00',2.29),('8784','2013-07-04','17:25:00',2.9),('8784','2013-07-04','17:30:00',2.66),('8784','2013-07-04','17:35:00',2.11),('8784','2013-07-04','17:40:00',2.56),('8784','2013-07-04','17:45:00',2.4),('8784','2013-07-04','17:50:00',2.37),('8784','2013-07-04','17:55:00',2.23),('8784','2013-07-04','18:00:00',2.25),('8784','2013-07-04','18:05:00',2.14),('8784','2013-07-04','18:10:00',2.03),('8784','2013-07-04','18:15:00',2.02),('8784','2013-07-04','18:20:00',1.85),('8784','2013-07-04','18:25:00',1.48),('8784','2013-07-04','18:30:00',1.04),('8784','2013-07-03','07:20:00',1.06),('8784','2013-07-03','07:25:00',1.14),('8784','2013-07-03','07:30:00',1.21),('8784','2013-07-03','07:35:00',1.29),('8784','2013-07-03','07:40:00',1.37),('8784','2013-07-03','07:45:00',1.46),('8784','2013-07-03','07:50:00',1.53),('8784','2013-07-03','07:55:00',1.63),('8784','2013-07-03','08:00:00',1.71),('8784','2013-07-03','08:05:00',1.77),('8784','2013-07-03','08:10:00',1.86),('8784','2013-07-03','08:15:00',1.95),('8784','2013-07-03','08:20:00',2.04),('8784','2013-07-03','08:25:00',2.12),('8784','2013-07-03','08:30:00',2.2),('8784','2013-07-03','08:35:00',2.23),('8784','2013-07-03','08:40:00',2.32),('8784','2013-07-03','08:45:00',2.44),('8784','2013-07-03','08:50:00',2.5),('8784','2013-07-03','08:55:00',2.59),('8784','2013-07-03','09:00:00',2.64),('8784','2013-07-03','09:05:00',2.7),('8784','2013-07-03','09:10:00',2.76),('8784','2013-07-03','09:15:00',2.82),('8784','2013-07-03','09:20:00',2.88),('8784','2013-07-03','09:25:00',2.96),('8784','2013-07-03','09:30:00',3.05),('8784','2013-07-03','09:35:00',3.12),('8784','2013-07-03','09:40:00',3.17),('8784','2013-07-03','09:45:00',3.19),('8784','2013-07-03','09:50:00',3.2),('8784','2013-07-03','09:55:00',3.3),('8784','2013-07-03','10:00:00',3.37),('8784','2013-07-03','10:05:00',3.43),('8784','2013-07-03','10:10:00',3.43),('8784','2013-07-03','10:15:00',3.52),('8784','2013-07-03','10:20:00',3.53),('8784','2013-07-03','10:25:00',3.51),('8784','2013-07-03','10:30:00',3.56),('8784','2013-07-03','10:35:00',3.7),('8784','2013-07-03','10:40:00',3.72),('8784','2013-07-03','10:45:00',3.77),('8784','2013-07-03','10:50:00',3.77),('8784','2013-07-03','10:55:00',3.8),('8784','2013-07-03','11:00:00',3.9),('8784','2013-07-03','11:05:00',3.94),('8784','2013-07-03','11:10:00',4.01),('8784','2013-07-03','11:15:00',4.05),('8784','2013-07-03','11:20:00',4.07),('8784','2013-07-03','11:25:00',4.03),('8784','2013-07-03','11:30:00',4.06),('8784','2013-07-03','11:35:00',4.06),('8784','2013-07-03','11:40:00',4.19),('8784','2013-07-03','11:45:00',4.22),('8784','2013-07-03','11:50:00',4.2),('8784','2013-07-03','11:55:00',4.24),('8784','2013-07-03','12:00:00',4.28),('8784','2013-07-03','12:05:00',4.26),('8784','2013-07-03','12:10:00',4.29),('8784','2013-07-03','12:15:00',4.3),('8784','2013-07-03','12:20:00',4.33),('8784','2013-07-03','12:25:00',4.34),('8784','2013-07-03','12:30:00',4.41),('8784','2013-07-03','12:35:00',4.42),('8784','2013-07-03','12:40:00',4.41),('8784','2013-07-03','12:45:00',4.45),('8784','2013-07-03','12:50:00',4.47),('8784','2013-07-03','12:55:00',4.45),('8784','2013-07-03','13:00:00',4.49),('8784','2013-07-03','13:05:00',4.51),('8784','2013-07-03','13:10:00',4.5),('8784','2013-07-03','13:15:00',4.53),('8784','2013-07-03','13:20:00',4.47),('8784','2013-07-03','13:25:00',4.46),('8784','2013-07-03','13:30:00',4.47),('8784','2013-07-03','13:35:00',4.47),('8784','2013-07-03','13:40:00',4.48),('8784','2013-07-03','13:45:00',4.46),('8784','2013-07-03','13:50:00',4.42),('8784','2013-07-03','13:55:00',4.43),('8784','2013-07-03','14:00:00',4.41),('8784','2013-07-03','14:05:00',4.41),('8784','2013-07-03','14:10:00',4.37),('8784','2013-07-03','14:15:00',4.38),('8784','2013-07-03','14:20:00',4.36),('8784','2013-07-03','14:25:00',4.34),('8784','2013-07-03','14:30:00',4.34),('8784','2013-07-03','14:35:00',4.32),('8784','2013-07-03','14:40:00',4.25),('8784','2013-07-03','14:45:00',4.29),('8784','2013-07-03','14:50:00',4.25),('8784','2013-07-03','14:55:00',4.21),('8784','2013-07-03','15:00:00',4.2),('8784','2013-07-03','15:05:00',4.13),('8784','2013-07-03','15:10:00',4.11),('8784','2013-07-03','15:15:00',4.1),('8784','2013-07-03','15:20:00',4.06),('8784','2013-07-03','15:25:00',4),('8784','2013-07-03','15:30:00',3.96),('8784','2013-07-03','15:35:00',3.9),('8784','2013-07-03','15:40:00',3.86),('8784','2013-07-03','15:45:00',3.81),('8784','2013-07-03','15:50:00',3.76),('8784','2013-07-03','15:55:00',3.69),('8784','2013-07-03','16:00:00',3.63),('8784','2013-07-03','16:05:00',3.62),('8784','2013-07-03','16:10:00',3.56),('8784','2013-07-03','16:15:00',3.5),('8784','2013-07-03','16:20:00',3.44),('8784','2013-07-03','16:25:00',3.36),('8784','2013-07-03','16:30:00',3.34),('8784','2013-07-03','16:35:00',3.27),('8784','2013-07-03','16:40:00',3.21),('8784','2013-07-03','16:45:00',3.11),('8784','2013-07-03','16:50:00',3.06),('8784','2013-07-03','16:55:00',3),('8784','2013-07-03','17:00:00',2.93),('8784','2013-07-03','17:05:00',2.86),('8784','2013-07-03','17:10:00',2.79),('8784','2013-07-03','17:15:00',2.72),('8784','2013-07-03','17:20:00',2.65),('8784','2013-07-03','17:25:00',2.57),('8784','2013-07-03','17:30:00',2.5),('8784','2013-07-03','17:35:00',2.43),('8784','2013-07-03','17:40:00',2.34),('8784','2013-07-03','17:45:00',2.27),('8784','2013-07-03','17:50:00',2.18),('8784','2013-07-03','17:55:00',2.1),('8784','2013-07-03','18:00:00',2.02),('8784','2013-07-03','18:05:00',1.89),('8784','2013-07-03','18:10:00',1.82),('8784','2013-07-03','18:15:00',1.76),('8784','2013-07-03','18:20:00',1.67),('8784','2013-07-03','18:25:00',1.6),('8784','2013-07-03','18:30:00',1.51),('8784','2013-07-03','18:35:00',1.43),('8784','2013-07-03','18:40:00',1.34),('8784','2013-07-03','18:45:00',1.26),('8784','2013-07-03','18:50:00',1.17),('8784','2013-07-03','18:55:00',1.1),('8784','2013-07-03','19:00:00',1.02),('8784','2013-07-02','07:20:00',1.02),('8784','2013-07-02','07:25:00',1.1),('8784','2013-07-02','07:30:00',1.16),('8784','2013-07-02','07:35:00',1.25),('8784','2013-07-02','07:40:00',1.35),('8784','2013-07-02','07:45:00',1.41),('8784','2013-07-02','07:50:00',1.48),('8784','2013-07-02','07:55:00',1.59),('8784','2013-07-02','08:00:00',1.67),('8784','2013-07-02','08:05:00',1.76),('8784','2013-07-02','08:10:00',1.82),('8784','2013-07-02','08:15:00',1.93),('8784','2013-07-02','08:20:00',2.01),('8784','2013-07-02','08:25:00',2.1),('8784','2013-07-02','08:30:00',2.18),('8784','2013-07-02','08:35:00',2.26),('8784','2013-07-02','08:40:00',2.32),('8784','2013-07-02','08:45:00',2.39),('8784','2013-07-02','08:50:00',2.47),('8784','2013-07-02','08:55:00',2.54),('8784','2013-07-02','09:00:00',2.61),('8784','2013-07-02','09:05:00',2.67),('8784','2013-07-02','09:10:00',2.73),('8784','2013-07-02','09:15:00',2.77),('8784','2013-07-02','09:20:00',2.88),('8784','2013-07-02','09:25:00',2.93),('8784','2013-07-02','09:30:00',3),('8784','2013-07-02','09:35:00',3.05),('8784','2013-07-02','09:40:00',3.1),('8784','2013-07-02','09:45:00',3.19),('8784','2013-07-02','09:50:00',3.24),('8784','2013-07-02','09:55:00',3.29),('8784','2013-07-02','10:00:00',3.36),('8784','2013-07-02','10:05:00',3.41),('8784','2013-07-02','10:10:00',3.44),('8784','2013-07-02','10:15:00',3.48),('8784','2013-07-02','10:20:00',3.55),('8784','2013-07-02','10:25:00',3.58),('8784','2013-07-02','10:30:00',3.6),('8784','2013-07-02','10:35:00',3.61),('8784','2013-07-02','10:40:00',3.67),('8784','2013-07-02','10:45:00',3.71),('8784','2013-07-02','10:50:00',3.72),('8784','2013-07-02','10:55:00',3.78),('8784','2013-07-02','11:00:00',3.81),('8784','2013-07-02','11:05:00',3.81),('8784','2013-07-02','11:10:00',3.84),('8784','2013-07-02','11:15:00',3.86),('8784','2013-07-02','11:20:00',3.91),('8784','2013-07-02','11:25:00',3.96),('8784','2013-07-02','11:30:00',3.94),('8784','2013-07-02','11:35:00',3.96),('8784','2013-07-02','11:40:00',4),('8784','2013-07-02','11:45:00',4.02),('8784','2013-07-02','11:50:00',4.04),('8784','2013-07-02','11:55:00',4.04),('8784','2013-07-02','12:00:00',4.06),('8784','2013-07-02','12:05:00',4.18),('8784','2013-07-02','12:10:00',4.18),('8784','2013-07-02','12:15:00',4.18),('8784','2013-07-02','12:20:00',4.17),('8784','2013-07-02','12:25:00',4.18),('8784','2013-07-02','12:30:00',4.23),('8784','2013-07-02','12:35:00',4.4),('8784','2013-07-02','12:40:00',4.46),('8784','2013-07-02','12:45:00',4.52),('8784','2013-07-02','12:50:00',4.68),('8784','2013-07-02','12:55:00',3.99),('8784','2013-07-02','13:00:00',2.32),('8784','2013-07-02','13:05:00',4.85),('8784','2013-07-02','13:10:00',4.45),('8784','2013-07-02','13:15:00',3.71),('8784','2013-07-02','13:20:00',4.45),('8784','2013-07-02','13:25:00',4.37),('8784','2013-07-02','13:30:00',4.43),('8784','2013-07-02','13:35:00',4.43),('8784','2013-07-02','13:40:00',4.3),('8784','2013-07-02','13:45:00',4.28),('8784','2013-07-02','13:50:00',4.24),('8784','2013-07-02','13:55:00',4.24),('8784','2013-07-02','14:00:00',4.25),('8784','2013-07-02','14:05:00',4.25),('8784','2013-07-02','14:10:00',4.27),('8784','2013-07-02','14:15:00',4.3),('8784','2013-07-02','14:20:00',4.28),('8784','2013-07-02','14:25:00',4.24),('8784','2013-07-02','14:30:00',4.21),('8784','2013-07-02','14:35:00',4.2),('8784','2013-07-02','14:40:00',4.18),('8784','2013-07-02','14:45:00',4.14),('8784','2013-07-02','14:50:00',4.07),('8784','2013-07-02','14:55:00',4.08),('8784','2013-07-02','15:00:00',4.06),('8784','2013-07-02','15:05:00',4.05),('8784','2013-07-02','15:10:00',4.01),('8784','2013-07-02','15:15:00',3.97),('8784','2013-07-02','15:20:00',3.94),('8784','2013-07-02','15:25:00',3.91),('8784','2013-07-02','15:30:00',3.88),('8784','2013-07-02','15:35:00',3.84),('8784','2013-07-02','15:40:00',3.75),('8784','2013-07-02','15:45:00',3.72),('8784','2013-07-02','15:50:00',3.69),('8784','2013-07-02','15:55:00',3.64),('8784','2013-07-02','16:00:00',3.59),('8784','2013-07-02','16:05:00',3.56),('8784','2013-07-02','16:10:00',3.5),('8784','2013-07-02','16:15:00',3.41),('8784','2013-07-02','16:20:00',3.36),('8784','2013-07-02','16:25:00',3.31),('8784','2013-07-02','16:30:00',3.22),('8784','2013-07-02','16:35:00',3.17),('8784','2013-07-02','16:40:00',3.12),('8784','2013-07-02','16:45:00',3.05),('8784','2013-07-02','16:50:00',2.97),('8784','2013-07-02','16:55:00',2.93),('8784','2013-07-02','17:00:00',2.86),('8784','2013-07-02','17:05:00',2.78),('8784','2013-07-02','17:10:00',2.7),('8784','2013-07-02','17:15:00',2.64),('8784','2013-07-02','17:20:00',2.56),('8784','2013-07-02','17:25:00',2.46),('8784','2013-07-02','17:30:00',2.41),('8784','2013-07-02','17:35:00',2.33),('8784','2013-07-02','17:40:00',2.24),('8784','2013-07-02','17:45:00',2.15),('8784','2013-07-02','17:50:00',2.08),('8784','2013-07-02','17:55:00',2),('8784','2013-07-02','18:00:00',1.91),('8784','2013-07-02','18:05:00',1.83),('8784','2013-07-02','18:10:00',1.74),('8784','2013-07-02','18:15:00',1.68),('8784','2013-07-02','18:20:00',1.6),('8784','2013-07-02','18:25:00',1.51),('8784','2013-07-02','18:30:00',1.42),('8784','2013-07-02','18:35:00',1.35),('8784','2013-07-02','18:40:00',1.26),('8784','2013-07-02','18:45:00',1.18),('8784','2013-07-02','18:50:00',1.1),('8784','2013-07-02','18:55:00',1.04),('8784','2013-07-01','07:20:00',1.04),('8784','2013-07-01','07:25:00',1.11),('8784','2013-07-01','07:30:00',1.19),('8784','2013-07-01','07:35:00',1.28),('8784','2013-07-01','07:40:00',1.36),('8784','2013-07-01','07:45:00',1.44),('8784','2013-07-01','07:50:00',1.5),('8784','2013-07-01','07:55:00',1.62),('8784','2013-07-01','08:00:00',1.72),('8784','2013-07-01','08:05:00',1.79),('8784','2013-07-01','08:10:00',1.88),('8784','2013-07-01','08:15:00',1.97),('8784','2013-07-01','08:20:00',2.04),('8784','2013-07-01','08:25:00',2.13),('8784','2013-07-01','08:30:00',2.22),('8784','2013-07-01','08:35:00',2.26),('8784','2013-07-01','08:40:00',2.39),('8784','2013-07-01','08:45:00',2.46),('8784','2013-07-01','08:50:00',2.53),('8784','2013-07-01','08:55:00',2.6),('8784','2013-07-01','09:00:00',2.66),('8784','2013-07-01','09:05:00',2.73),('8784','2013-07-01','09:10:00',2.81),('8784','2013-07-01','09:15:00',2.88),('8784','2013-07-01','09:20:00',2.96),('8784','2013-07-01','09:25:00',3.03),('8784','2013-07-01','09:30:00',3.13),('8784','2013-07-01','09:35:00',3.18),('8784','2013-07-01','09:40:00',3.23),('8784','2013-07-01','09:45:00',3.28),('8784','2013-07-01','09:50:00',3.34),('8784','2013-07-01','09:55:00',3.37),('8784','2013-07-01','10:00:00',3.38),('8784','2013-07-01','10:05:00',3.4),('8784','2013-07-01','10:10:00',3.46),('8784','2013-07-01','10:15:00',3.55),('8784','2013-07-01','10:20:00',3.62),('8784','2013-07-01','10:25:00',3.66),('8784','2013-07-01','10:30:00',3.75),('8784','2013-07-01','10:35:00',3.8),('8784','2013-07-01','10:40:00',3.85),('8784','2013-07-01','10:45:00',3.91),('8784','2013-07-01','10:50:00',3.93),('8784','2013-07-01','10:55:00',3.94),('8784','2013-07-01','11:00:00',4.02),('8784','2013-07-01','11:05:00',4),('8784','2013-07-01','11:10:00',4.06),('8784','2013-07-01','11:15:00',4.13),('8784','2013-07-01','11:20:00',4.2),('8784','2013-07-01','11:25:00',4.24),('8784','2013-07-01','11:30:00',4.19),('8784','2013-07-01','11:35:00',4.2),('8784','2013-07-01','11:40:00',4.28),('8784','2013-07-01','11:45:00',4.31),('8784','2013-07-01','11:50:00',4.34),('8784','2013-07-01','11:55:00',4.31),('8784','2013-07-01','12:00:00',4.31),('8784','2013-07-01','12:05:00',4.3),('8784','2013-07-01','12:10:00',4.31),('8784','2013-07-01','12:15:00',4.33),('8784','2013-07-01','12:20:00',4.37),('8784','2013-07-01','12:25:00',4.36),('8784','2013-07-01','12:30:00',4.39),('8784','2013-07-01','12:35:00',4.41),('8784','2013-07-01','12:40:00',4.37),('8784','2013-07-01','12:45:00',4.36),('8784','2013-07-01','12:50:00',4.41),('8784','2013-07-01','12:55:00',4.42),('8784','2013-07-01','13:00:00',4.41),('8784','2013-07-01','13:05:00',4.43),('8784','2013-07-01','13:10:00',4.45),('8784','2013-07-01','13:15:00',4.44),('8784','2013-07-01','13:20:00',4.48),('8784','2013-07-01','13:25:00',4.48),('8784','2013-07-01','13:30:00',4.45),('8784','2013-07-01','13:35:00',4.46),('8784','2013-07-01','13:40:00',4.46),('8784','2013-07-01','13:45:00',4.4),('8784','2013-07-01','13:50:00',4.38),('8784','2013-07-01','13:55:00',4.34),('8784','2013-07-01','14:00:00',4.38),('8784','2013-07-01','14:05:00',4.42),('8784','2013-07-01','14:10:00',4.43),('8784','2013-07-01','14:15:00',4.36),('8784','2013-07-01','14:20:00',4.33),('8784','2013-07-01','14:25:00',4.26),('8784','2013-07-01','14:30:00',4.28),('8784','2013-07-01','14:35:00',4.24),('8784','2013-07-01','14:40:00',4.21),('8784','2013-07-01','14:45:00',4.17),('8784','2013-07-01','14:50:00',4.12),('8784','2013-07-01','14:55:00',4.08),('8784','2013-07-01','15:00:00',4.03),('8784','2013-07-01','15:05:00',4.01),('8784','2013-07-01','15:10:00',4),('8784','2013-07-01','15:15:00',3.97),('8784','2013-07-01','15:20:00',3.93),('8784','2013-07-01','15:25:00',3.89),('8784','2013-07-01','15:30:00',3.83),('8784','2013-07-01','15:35:00',3.76),('8784','2013-07-01','15:40:00',3.67),('8784','2013-07-01','15:45:00',3.71),('8784','2013-07-01','15:50:00',3.67),('8784','2013-07-01','15:55:00',3.59),('8784','2013-07-01','16:00:00',3.55),('8784','2013-07-01','16:05:00',3.5),('8784','2013-07-01','16:10:00',3.44),('8784','2013-07-01','16:15:00',3.35),('8784','2013-07-01','16:20:00',3.28),('8784','2013-07-01','16:25:00',3.22),('8784','2013-07-01','16:30:00',3.17),('8784','2013-07-01','16:35:00',3.11),('8784','2013-07-01','16:40:00',3.05),('8784','2013-07-01','16:45:00',3.02),('8784','2013-07-01','16:50:00',2.95),('8784','2013-07-01','16:55:00',2.91),('8784','2013-07-01','17:00:00',2.81),('8784','2013-07-01','17:05:00',2.77),('8784','2013-07-01','17:10:00',2.7),('8784','2013-07-01','17:15:00',2.62),('8784','2013-07-01','17:20:00',2.53),('8784','2013-07-01','17:25:00',2.44),('8784','2013-07-01','17:30:00',2.37),('8784','2013-07-01','17:35:00',2.29),('8784','2013-07-01','17:40:00',2.21),('8784','2013-07-01','17:45:00',2.14),('8784','2013-07-01','17:50:00',2.08),('8784','2013-07-01','17:55:00',2),('8784','2013-07-01','18:00:00',1.76),('8784','2013-07-01','18:05:00',1.81),('8784','2013-07-01','18:10:00',1.72),('8784','2013-07-01','18:15:00',1.39),('8784','2013-07-01','18:20:00',1.47),('8784','2013-07-01','18:25:00',1.56),('8784','2013-07-01','18:30:00',1.48),('8784','2013-07-01','18:35:00',1.37),('8784','2013-07-01','18:40:00',1.22),('8784','2013-07-01','18:45:00',1.17),('8784','2013-07-01','18:50:00',1.07),('8784','2014-04-05','09:15:00',1.23),('8784','2014-04-05','09:20:00',1.68),('8784','2014-04-05','09:25:00',2.11),('8784','2014-04-05','09:30:00',3.79),('8784','2014-04-05','09:35:00',3.73),('8784','2014-04-05','09:40:00',3.69),('8784','2014-04-05','09:45:00',3.44),('8784','2014-04-05','09:50:00',2.05),('8784','2014-04-05','09:55:00',1.69),('8784','2014-04-05','10:00:00',2.12),('8784','2014-04-05','10:05:00',2.16),('8784','2014-04-05','10:10:00',2.48),('8784','2014-04-05','10:15:00',1.81),('8784','2014-04-05','10:20:00',2.38),('8784','2014-04-05','10:25:00',2.68),('8784','2014-04-05','10:30:00',2.62),('8784','2014-04-05','10:35:00',2.83),('8784','2014-04-05','10:40:00',3.19),('8784','2014-04-05','10:45:00',3.4),('8784','2014-04-05','10:50:00',2.71),('8784','2014-04-05','10:55:00',2.95),('8784','2014-04-05','11:00:00',3.36),('8784','2014-04-05','11:05:00',3.5),('8784','2014-04-05','11:10:00',3.98),('8784','2014-04-05','11:15:00',4.07),('8784','2014-04-05','11:20:00',4.35),('8784','2014-04-05','11:25:00',3.88),('8784','2014-04-05','11:30:00',2.63),('8784','2014-04-05','11:35:00',2.25),('8784','2014-04-05','11:40:00',3.03),('8784','2014-04-05','11:45:00',3.99),('8784','2014-04-05','11:50:00',4.17),('8784','2014-04-05','11:55:00',4.09),('8784','2014-04-05','12:00:00',4.15),('8784','2014-04-05','12:05:00',3.2),('8784','2014-04-05','12:10:00',3.05),('8784','2014-04-05','12:15:00',3.54),('8784','2014-04-05','12:20:00',3.26),('8784','2014-04-05','12:25:00',3.77),('8784','2014-04-05','12:30:00',2.9),('8784','2014-04-05','12:35:00',2.44),('8784','2014-04-05','12:40:00',3.25),('8784','2014-04-05','12:45:00',4.67),('8784','2014-04-05','12:50:00',4.41),('8784','2014-04-05','12:55:00',4.56),('8784','2014-04-05','13:00:00',3.74),('8784','2014-04-05','13:05:00',3.04),('8784','2014-04-05','13:10:00',2.81),('8784','2014-04-05','13:15:00',1.98),('8784','2014-04-05','13:20:00',2.91),('8784','2014-04-05','13:25:00',4.62),('8784','2014-04-05','13:30:00',4),('8784','2014-04-05','13:35:00',4.33),('8784','2014-04-05','13:40:00',3.05),('8784','2014-04-05','13:45:00',4.28),('8784','2014-04-05','13:50:00',4.75),('8784','2014-04-05','13:55:00',3.61),('8784','2014-04-05','14:00:00',3.82),('8784','2014-04-05','14:05:00',4.98),('8784','2014-04-05','14:10:00',3.28),('8784','2014-04-05','14:25:00',1.34),('8784','2014-04-05','14:30:00',1.88),('8784','2014-04-05','14:35:00',1.26),('8784','2014-04-05','14:55:00',3.86),('8784','2014-04-05','15:00:00',4.19),('8784','2014-04-05','15:05:00',3.51),('8784','2014-04-05','15:10:00',3.2),('8784','2014-04-05','15:15:00',1.9),('8784','2014-04-05','15:20:00',3.89),('8784','2014-04-05','15:25:00',2.58),('8784','2014-04-05','15:30:00',1.61),('8784','2014-04-05','15:35:00',1.6),('8784','2014-04-05','15:40:00',1.97),('8784','2014-04-05','15:45:00',2.14),('8784','2014-04-05','15:50:00',2.5),('8784','2014-04-05','15:55:00',1.41),('8784','2014-04-05','16:00:00',1.37),('8784','2014-04-05','16:05:00',1.36),('8784','2014-04-05','16:10:00',1.32),('8784','2014-04-05','16:15:00',1.87),('8784','2014-04-05','16:20:00',4),('8784','2014-04-05','16:25:00',2.69),('8784','2014-04-05','16:30:00',2.1),('8784','2014-04-05','16:35:00',2.88),('8784','2014-04-05','16:40:00',1.61),('8784','2014-04-05','16:45:00',2.42),('8784','2014-04-05','16:50:00',1.59),('8784','2014-04-05','16:55:00',2.57),('8784','2014-04-05','17:00:00',1.54),('8784','2014-04-05','17:05:00',2.06),('8784','2014-04-05','17:10:00',1.74),('8784','2014-04-05','17:20:00',1.27),('8784','2014-04-05','17:25:00',1.27),('8784','2014-04-05','17:30:00',1.34),('8784','2014-04-05','17:35:00',1.13),('8784','2014-04-05','17:40:00',1),('8784','2014-04-05','17:50:00',1.17),('8784','2014-04-05','17:55:00',1.17),('8784','2014-04-05','18:00:00',1.11),('8784','2014-04-05','18:05:00',1.06),('8784','2014-04-05','18:10:00',1.01),('8784','2014-04-05','18:15:00',1.04),('8784','2013-06-30','07:15:00',1.05),('8784','2013-06-30','07:20:00',1.13),('8784','2013-06-30','07:25:00',1.21),('8784','2013-06-30','07:30:00',1.29),('8784','2013-06-30','07:35:00',1.37),('8784','2013-06-30','07:40:00',1.47),('8784','2013-06-30','07:45:00',1.54),('8784','2013-06-30','07:50:00',1.63),('8784','2013-06-30','07:55:00',1.72),('8784','2013-06-30','08:00:00',1.8),('8784','2013-06-30','08:05:00',1.89),('8784','2013-06-30','08:10:00',1.97),('8784','2013-06-30','08:15:00',2.05),('8784','2013-06-30','08:20:00',2.14),('8784','2013-06-30','08:25:00',2.23),('8784','2013-06-30','08:30:00',2.31),('8784','2013-06-30','08:35:00',2.39),('8784','2013-06-30','08:40:00',2.47),('8784','2013-06-30','08:45:00',2.55),('8784','2013-06-30','08:50:00',2.61),('8784','2013-06-30','08:55:00',2.7),('8784','2013-06-30','09:00:00',2.77),('8784','2013-06-30','09:05:00',2.84),('8784','2013-06-30','09:10:00',2.91),('8784','2013-06-30','09:15:00',2.98),('8784','2013-06-30','09:20:00',3.04),('8784','2013-06-30','09:25:00',3.08),('8784','2013-06-30','09:30:00',3.13),('8784','2013-06-30','09:35:00',3.2),('8784','2013-06-30','09:40:00',3.29),('8784','2013-06-30','09:45:00',3.39),('8784','2013-06-30','09:50:00',3.44),('8784','2013-06-30','09:55:00',3.49),('8784','2013-06-30','10:00:00',3.54),('8784','2013-06-30','10:05:00',3.6),('8784','2013-06-30','10:10:00',3.66),('8784','2013-06-30','10:15:00',3.71),('8784','2013-06-30','10:20:00',3.76),('8784','2013-06-30','10:25:00',3.8),('8784','2013-06-30','10:30:00',3.83),('8784','2013-06-30','10:35:00',3.85),('8784','2013-06-30','10:40:00',3.93),('8784','2013-06-30','10:45:00',3.96),('8784','2013-06-30','10:50:00',4),('8784','2013-06-30','10:55:00',4.03),('8784','2013-06-30','11:00:00',4.07),('8784','2013-06-30','11:05:00',4.13),('8784','2013-06-30','11:10:00',4.14),('8784','2013-06-30','11:15:00',4.15),('8784','2013-06-30','11:20:00',4.17),('8784','2013-06-30','11:25:00',4.2),('8784','2013-06-30','11:30:00',4.23),('8784','2013-06-30','11:35:00',4.24),('8784','2013-06-30','11:40:00',4.27),('8784','2013-06-30','11:45:00',4.31),('8784','2013-06-30','11:50:00',4.29),('8784','2013-06-30','11:55:00',4.34),('8784','2013-06-30','12:00:00',4.35),('8784','2013-06-30','12:05:00',4.37),('8784','2013-06-30','12:10:00',4.42),('8784','2013-06-30','12:15:00',4.44),('8784','2013-06-30','12:20:00',4.44),('8784','2013-06-30','12:25:00',4.43),('8784','2013-06-30','12:30:00',4.45),('8784','2013-06-30','12:35:00',4.48),('8784','2013-06-30','12:40:00',4.49),('8784','2013-06-30','12:45:00',4.45),('8784','2013-06-30','12:50:00',4.52),('8784','2013-06-30','12:55:00',4.56),('8784','2013-06-30','13:00:00',4.55),('8784','2013-06-30','13:05:00',4.52),('8784','2013-06-30','13:10:00',4.49),('8784','2013-06-30','13:15:00',4.54),('8784','2013-06-30','13:20:00',4.52),('8784','2013-06-30','13:25:00',4.57),('8784','2013-06-30','13:30:00',4.56),('8784','2013-06-30','13:35:00',4.54),('8784','2013-06-30','13:40:00',4.24),('8784','2013-06-30','13:45:00',4.19),('8784','2013-06-30','13:50:00',4.61),('8784','2013-06-30','13:55:00',4.42),('8784','2013-06-30','14:00:00',4.32),('8784','2013-06-30','14:05:00',4.51),('8784','2013-06-30','14:10:00',4.48),('8784','2013-06-30','14:15:00',4.38),('8784','2013-06-30','14:20:00',4.4),('8784','2013-06-30','14:25:00',4.37),('8784','2013-06-30','14:30:00',4.27),('8784','2013-06-30','14:35:00',4.24),('8784','2013-06-30','14:40:00',4.26),('8784','2013-06-30','14:45:00',4.27),('8784','2013-06-30','14:50:00',4.2),('8784','2013-06-30','14:55:00',4.18),('8784','2013-06-30','15:00:00',4.14),('8784','2013-06-30','15:05:00',4.06),('8784','2013-06-30','15:10:00',4.06),('8784','2013-06-30','15:15:00',4.01),('8784','2013-06-30','15:20:00',4.05),('8784','2013-06-30','15:25:00',4.01),('8784','2013-06-30','15:30:00',3.98),('8784','2013-06-30','15:35:00',3.94),('8784','2013-06-30','15:40:00',3.92),('8784','2013-06-30','15:45:00',3.87),('8784','2013-06-30','15:50:00',3.84),('8784','2013-06-30','15:55:00',3.75),('8784','2013-06-30','16:00:00',3.71),('8784','2013-06-30','16:05:00',3.66),('8784','2013-06-30','16:10:00',3.65),('8784','2013-06-30','16:15:00',3.59),('8784','2013-06-30','16:20:00',3.6),('8784','2013-06-30','16:25:00',3.62),('8784','2013-06-30','16:30:00',3.49),('8784','2013-06-30','16:35:00',3.41),('8784','2013-06-30','16:40:00',3.16),('8784','2013-06-30','16:45:00',3.14),('8784','2013-06-30','16:50:00',3.08),('8784','2013-06-30','16:55:00',2.98),('8784','2013-06-30','17:00:00',2.87),('8784','2013-06-30','17:05:00',2.79),('8784','2013-06-30','17:10:00',2.76),('8784','2013-06-30','17:15:00',2.67),('8784','2013-06-30','17:20:00',2.58),('8784','2013-06-30','17:25:00',2.49),('8784','2013-06-30','17:30:00',2.4),('8784','2013-06-30','17:35:00',2.32),('8784','2013-06-30','17:40:00',2.27),('8784','2013-06-30','17:45:00',2.17),('8784','2013-06-30','17:50:00',2.1),('8784','2013-06-30','17:55:00',2),('8784','2013-06-30','18:00:00',1.89),('8784','2013-06-30','18:05:00',1.75),('8784','2013-06-30','18:10:00',1.75),('8784','2013-06-30','18:15:00',1.68),('8784','2013-06-30','18:20:00',1.6),('8784','2013-06-30','18:25:00',1.52),('8784','2013-06-30','18:30:00',1.43),('8784','2013-06-30','18:35:00',1.35),('8784','2013-06-30','18:40:00',1.28),('8784','2013-06-30','18:45:00',1.19),('8784','2013-06-30','18:50:00',1.12),('8784','2013-06-30','18:55:00',1.05),('8784','2013-06-29','07:30:00',1.51),('8784','2013-06-29','07:35:00',1.77),('8784','2013-06-29','07:40:00',1.82),('8784','2013-06-29','07:45:00',1.83),('8784','2013-06-29','07:50:00',1.94),('8784','2013-06-29','07:55:00',2.15),('8784','2013-06-29','08:00:00',2.3),('8784','2013-06-29','08:05:00',2.52),('8784','2013-06-29','08:10:00',2.56),('8784','2013-06-29','08:15:00',2.06),('8784','2013-06-29','08:20:00',1.44),('8784','2013-06-29','08:25:00',2.32),('8784','2013-06-29','08:30:00',2.41),('8784','2013-06-29','08:35:00',2.5),('8784','2013-06-29','08:40:00',1.42),('8784','2013-06-29','08:45:00',2.45),('8784','2013-06-29','08:50:00',2.63),('8784','2013-06-29','08:55:00',2.69),('8784','2013-06-29','09:00:00',2.74),('8784','2013-06-29','09:05:00',2.8),('8784','2013-06-29','09:10:00',2.87),('8784','2013-06-29','09:15:00',2.93),('8784','2013-06-29','09:20:00',3),('8784','2013-06-29','09:25:00',3.05),('8784','2013-06-29','09:30:00',3.08),('8784','2013-06-29','09:35:00',3.16),('8784','2013-06-29','09:40:00',3.26),('8784','2013-06-29','09:45:00',3.35),('8784','2013-06-29','09:50:00',3.38),('8784','2013-06-29','09:55:00',3.42),('8784','2013-06-29','10:00:00',3.49),('8784','2013-06-29','10:05:00',3.55),('8784','2013-06-29','10:10:00',3.62),('8784','2013-06-29','10:15:00',3.66),('8784','2013-06-29','10:20:00',3.7),('8784','2013-06-29','10:25:00',3.77),('8784','2013-06-29','10:30:00',3.79),('8784','2013-06-29','10:35:00',3.83),('8784','2013-06-29','10:40:00',3.91),('8784','2013-06-29','10:45:00',3.81),('8784','2013-06-29','10:50:00',1.69),('8784','2013-06-29','10:55:00',2.91),('8784','2013-06-29','11:00:00',4.04),('8784','2013-06-29','11:05:00',4.19),('8784','2013-06-29','11:10:00',4.29),('8784','2013-06-29','11:15:00',4.4),('8784','2013-06-29','11:20:00',4.58),('8784','2013-06-29','11:25:00',4.67),('8784','2013-06-29','11:30:00',3.87),('8784','2013-06-29','11:35:00',3.42),('8784','2013-06-29','11:40:00',3.44),('8784','2013-06-29','11:45:00',4.98),('8784','2013-06-29','11:50:00',4.77),('8784','2013-06-29','11:55:00',4.26),('8784','2013-06-29','12:00:00',3.8),('8784','2013-06-29','12:05:00',3.81),('8784','2013-06-29','12:10:00',4.73),('8784','2013-06-29','12:15:00',4.77),('8784','2013-06-29','12:20:00',2.1),('8784','2013-06-29','12:25:00',4.4),('8784','2013-06-29','12:30:00',4.89),('8784','2013-06-29','12:35:00',3.52),('8784','2013-06-29','12:40:00',2.92),('8784','2013-06-29','12:45:00',5.23),('8784','2013-06-29','12:50:00',3.37),('8784','2013-06-29','12:55:00',5.15),('8784','2013-06-29','13:00:00',3.4),('8784','2013-06-29','13:05:00',4.7),('8784','2013-06-29','13:10:00',3.65),('8784','2013-06-29','13:15:00',3.95),('8784','2013-06-29','13:20:00',2.21),('8784','2013-06-29','13:25:00',3.63),('8784','2013-06-29','13:30:00',1.2),('8784','2013-06-29','13:40:00',1.07),('8784','2013-06-29','13:45:00',1.78),('8784','2013-06-29','13:50:00',1.93),('8784','2013-06-29','13:55:00',3.86),('8784','2013-06-29','14:00:00',4.71),('8784','2013-06-29','14:05:00',5.21),('8784','2013-06-29','14:10:00',4.92),('8784','2013-06-29','14:15:00',5.04),('8784','2013-06-29','14:20:00',4.95),('8784','2013-06-29','14:25:00',5.06),('8784','2013-06-29','14:30:00',4.89),('8784','2013-06-29','14:35:00',4.82),('8784','2013-06-29','14:40:00',4.83),('8784','2013-06-29','14:45:00',4.9),('8784','2013-06-29','14:50:00',5.11),('8784','2013-06-29','14:55:00',2.7),('8784','2013-06-29','15:00:00',4.05),('8784','2013-06-29','15:05:00',5.25),('8784','2013-06-29','15:10:00',2.64),('8784','2013-06-29','15:15:00',2.4),('8784','2013-06-29','15:20:00',1.49),('8784','2013-06-29','15:25:00',1.12),('8784','2013-06-29','16:35:00',1.02),('8784','2013-06-29','16:40:00',1.37),('8784','2013-06-29','16:45:00',1.7),('8784','2013-06-29','16:50:00',2.67),('8784','2013-06-29','16:55:00',1.41),('8784','2013-06-29','17:00:00',1.25),('8784','2013-06-29','17:05:00',1.61),('8784','2013-06-29','17:10:00',1.24),('8784','2013-06-29','17:15:00',1.17),('8784','2013-06-29','17:20:00',1.41),('8784','2013-06-29','17:25:00',1.65),('8784','2013-06-29','17:30:00',2.82),('8784','2013-06-29','17:35:00',2.06),('8784','2013-06-29','17:40:00',1.16),('8784','2013-06-29','17:45:00',2.22),('8784','2013-06-29','17:50:00',2.17),('8784','2013-06-29','17:55:00',2.09),('8784','2013-06-29','18:00:00',1.96),('8784','2013-06-29','18:05:00',1.88),('8784','2013-06-29','18:15:00',1.66),('8784','2013-06-29','18:20:00',1.65),('8784','2013-06-29','18:25:00',1.37),('8784','2013-06-29','18:35:00',1.35),('8784','2013-06-29','18:40:00',1.36),('8784','2013-06-28','07:10:00',1.09),('8784','2013-06-28','07:15:00',1.08),('8784','2013-06-28','07:20:00',1.11),('8784','2013-06-28','07:25:00',1.19),('8784','2013-06-28','07:30:00',1.28),('8784','2013-06-28','07:35:00',1.34),('8784','2013-06-28','07:40:00',1.34),('8784','2013-06-28','07:45:00',1.57),('8784','2013-06-28','07:50:00',1.61),('8784','2013-06-28','07:55:00',1.69),('8784','2013-06-28','08:00:00',1.73),('8784','2013-06-28','08:05:00',1.67),('8784','2013-06-28','08:10:00',1.74),('8784','2013-06-28','08:15:00',1.95),('8784','2013-06-28','08:20:00',1.99),('8784','2013-06-28','08:25:00',1.99),('8784','2013-06-28','08:30:00',2.2),('8784','2013-06-28','08:35:00',2.29),('8784','2013-06-28','08:40:00',2.35),('8784','2013-06-28','08:45:00',2.46),('8784','2013-06-28','08:50:00',2.51),('8784','2013-06-28','08:55:00',2.64),('8784','2013-06-28','09:00:00',2.7),('8784','2013-06-28','09:05:00',2.74),('8784','2013-06-28','09:10:00',2.85),('8784','2013-06-28','09:15:00',2.16),('8784','2013-06-28','09:20:00',1.18),('8784','2013-06-28','09:25:00',1.52),('8784','2013-06-28','09:30:00',3.19),('8784','2013-06-28','09:35:00',3.33),('8784','2013-06-28','09:40:00',3.48),('8784','2013-06-28','09:45:00',3.59),('8784','2013-06-28','09:50:00',3.51),('8784','2013-06-28','09:55:00',3.62),('8784','2013-06-28','10:05:00',2.3),('8784','2013-06-28','10:10:00',3.93),('8784','2013-06-28','10:15:00',4.06),('8784','2013-06-28','10:20:00',1.57),('8784','2013-06-28','10:25:00',1.44),('8784','2013-06-28','10:30:00',3.18),('8784','2013-06-28','10:35:00',4.82),('8784','2013-06-28','10:40:00',3.97),('8784','2013-06-28','10:45:00',4.38),('8784','2013-06-28','10:50:00',1.72),('8784','2013-06-28','10:55:00',2.18),('8784','2013-06-28','11:00:00',2.89),('8784','2013-06-28','11:05:00',2.2),('8784','2013-06-28','11:10:00',1.78),('8784','2013-06-28','11:15:00',2.01),('8784','2013-06-28','11:20:00',1.41),('8784','2013-06-28','11:25:00',3.63),('8784','2013-06-28','11:30:00',4.74),('8784','2013-06-28','11:35:00',3.87),('8784','2013-06-28','11:40:00',3.54),('8784','2013-06-28','11:45:00',3.47),('8784','2013-06-28','11:50:00',4.55),('8784','2013-06-28','11:55:00',3),('8784','2013-06-28','12:00:00',2.39),('8784','2013-06-28','12:05:00',3.24),('8784','2013-06-28','12:10:00',5.17),('8784','2013-06-28','12:15:00',4.85),('8784','2013-06-28','12:20:00',4.65),('8784','2013-06-28','12:25:00',4.79),('8784','2013-06-28','12:30:00',4.57),('8784','2013-06-28','12:35:00',3.86),('8784','2013-06-28','12:40:00',2.66),('8784','2013-06-28','12:45:00',4.81),('8784','2013-06-28','12:50:00',4.77),('8784','2013-06-28','12:55:00',4.63),('8784','2013-06-28','13:00:00',4.7),('8784','2013-06-28','13:05:00',4.73),('8784','2013-06-28','13:10:00',4.88),('8784','2013-06-28','13:15:00',4.56),('8784','2013-06-28','13:20:00',3.55),('8784','2013-06-28','13:25:00',4.64),('8784','2013-06-28','13:30:00',4.66),('8784','2013-06-28','13:35:00',4.72),('8784','2013-06-28','13:40:00',4.19),('8784','2013-06-28','13:45:00',4.59),('8784','2013-06-28','13:50:00',4.51),('8784','2013-06-28','13:55:00',4.74),('8784','2013-06-28','14:00:00',3.93),('8784','2013-06-28','14:05:00',4.48),('8784','2013-06-28','14:10:00',3.97),('8784','2013-06-28','14:15:00',4.39),('8784','2013-06-28','14:20:00',4.7),('8784','2013-06-28','14:25:00',2.72),('8784','2013-06-28','14:30:00',3.44),('8784','2013-06-28','14:35:00',4.28),('8784','2013-06-28','14:40:00',3.97),('8784','2013-06-28','14:45:00',4.75),('8784','2013-06-28','14:50:00',4.43),('8784','2013-06-28','14:55:00',4.24),('8784','2013-06-28','15:00:00',3.83),('8784','2013-06-28','15:05:00',4.28),('8784','2013-06-28','15:10:00',4.38),('8784','2013-06-28','15:15:00',4.29),('8784','2013-06-28','15:20:00',4.44),('8784','2013-06-28','15:25:00',4.36),('8784','2013-06-28','15:30:00',2.46),('8784','2013-06-28','15:35:00',3.91),('8784','2013-06-28','15:40:00',2.39),('8784','2013-06-28','15:45:00',3.52),('8784','2013-06-28','15:50:00',4.17),('8784','2013-06-28','15:55:00',3.3),('8784','2013-06-28','16:00:00',3.86),('8784','2013-06-28','16:05:00',3.53),('8784','2013-06-28','16:10:00',1.73),('8784','2013-06-28','16:15:00',3.18),('8784','2013-06-28','16:20:00',3.61),('8784','2013-06-28','16:25:00',2.05),('8784','2013-06-28','16:30:00',3.07),('8784','2013-06-28','16:35:00',1.01),('8784','2013-06-28','16:40:00',1.9),('8784','2013-06-28','16:45:00',1.63),('8784','2013-06-28','16:50:00',3.35),('8784','2013-06-28','16:55:00',3.01),('8784','2013-06-28','17:00:00',3.08),('8784','2013-06-28','17:05:00',2.53),('8784','2013-06-28','17:10:00',2.76),('8784','2013-06-28','17:15:00',2.69),('8784','2013-06-28','17:20:00',2.58),('8784','2013-06-28','17:25:00',2.57),('8784','2013-06-28','17:30:00',2.46),('8784','2013-06-28','17:35:00',2.38),('8784','2013-06-28','17:40:00',2.26),('8784','2013-06-28','17:45:00',2.22),('8784','2013-06-28','17:50:00',2.14),('8784','2013-06-28','17:55:00',2.07),('8784','2013-06-28','18:00:00',2),('8784','2013-06-28','18:05:00',1.9),('8784','2013-06-28','18:10:00',1.81),('8784','2013-06-28','18:15:00',1.75),('8784','2013-06-28','18:20:00',1.68),('8784','2013-06-28','18:25:00',1.6),('8784','2013-06-28','18:30:00',1.27),('8784','2013-06-28','18:40:00',1.29),('8784','2013-06-28','18:50:00',1.14),('8784','2013-06-27','07:25:00',1.07),('8784','2013-06-27','07:30:00',1.24),('8784','2013-06-27','07:35:00',1.32),('8784','2013-06-27','07:40:00',1.41),('8784','2013-06-27','07:45:00',1.5),('8784','2013-06-27','07:50:00',1.62),('8784','2013-06-27','07:55:00',1.68),('8784','2013-06-27','08:00:00',1.77),('8784','2013-06-27','08:05:00',1.87),('8784','2013-06-27','08:10:00',1.93),('8784','2013-06-27','08:15:00',2.02),('8784','2013-06-27','08:20:00',2.11),('8784','2013-06-27','08:25:00',2.17),('8784','2013-06-27','08:30:00',2.25),('8784','2013-06-27','08:35:00',2.3),('8784','2013-06-27','08:40:00',2.38),('8784','2013-06-27','08:45:00',2.48),('8784','2013-06-27','08:50:00',2.56),('8784','2013-06-27','08:55:00',2.65),('8784','2013-06-27','09:00:00',2.74),('8784','2013-06-27','09:05:00',2.79),('8784','2013-06-27','09:10:00',2.88),('8784','2013-06-27','09:15:00',2.92),('8784','2013-06-27','09:20:00',3.05),('8784','2013-06-27','09:25:00',3.1),('8784','2013-06-27','09:30:00',3.11),('8784','2013-06-27','09:35:00',3.15),('8784','2013-06-27','09:40:00',3.24),('8784','2013-06-27','09:45:00',3.28),('8784','2013-06-27','09:50:00',3.44),('8784','2013-06-27','09:55:00',3.38),('8784','2013-06-27','10:00:00',3.42),('8784','2013-06-27','10:05:00',3.86),('8784','2013-06-27','10:10:00',3.82),('8784','2013-06-27','10:15:00',2.89),('8784','2013-06-27','10:20:00',2.09),('8784','2013-06-27','10:25:00',3.84),('8784','2013-06-27','10:30:00',3.91),('8784','2013-06-27','10:35:00',4.03),('8784','2013-06-27','10:40:00',4.24),('8784','2013-06-27','10:45:00',4.27),('8784','2013-06-27','10:50:00',3.78),('8784','2013-06-27','10:55:00',4.24),('8784','2013-06-27','11:00:00',4.23),('8784','2013-06-27','11:05:00',4.3),('8784','2013-06-27','11:10:00',4.37),('8784','2013-06-27','11:15:00',4.42),('8784','2013-06-27','11:20:00',4.41),('8784','2013-06-27','11:25:00',4.46),('8784','2013-06-27','11:30:00',4.42),('8784','2013-06-27','11:35:00',4.46),('8784','2013-06-27','11:40:00',4.65),('8784','2013-06-27','11:45:00',4.67),('8784','2013-06-27','11:50:00',2.37),('8784','2013-06-27','11:55:00',1.45),('8784','2013-06-27','12:00:00',1.46),('8784','2013-06-27','12:05:00',1.35),('8784','2013-06-27','12:10:00',1.32),('8784','2013-06-27','12:15:00',1.14),('8784','2013-06-27','12:20:00',1.22),('8784','2013-06-27','12:25:00',2.02),('8784','2013-06-27','12:30:00',1.74),('8784','2013-06-27','12:35:00',3.4),('8784','2013-06-27','12:40:00',1.86),('8784','2013-06-27','12:45:00',1.77),('8784','2013-06-27','12:50:00',1.45),('8784','2013-06-27','12:55:00',1.26),('8784','2013-06-27','13:00:00',1.06),('8784','2013-06-27','13:05:00',1.22),('8784','2013-06-27','13:10:00',1.49),('8784','2013-06-27','13:15:00',1.8),('8784','2013-06-27','13:20:00',1.62),('8784','2013-06-27','13:25:00',1.72),('8784','2013-06-27','13:30:00',1.55),('8784','2013-06-27','13:35:00',1.47),('8784','2013-06-27','13:40:00',1.36),('8784','2013-06-27','13:45:00',1.41),('8784','2013-06-27','13:50:00',1.67),('8784','2013-06-27','13:55:00',1.46),('8784','2013-06-27','14:00:00',1.48),('8784','2013-06-27','14:05:00',1.46),('8784','2013-06-27','14:10:00',2.19),('8784','2013-06-27','14:15:00',2.75),('8784','2013-06-27','14:20:00',3.84),('8784','2013-06-27','14:25:00',3.22),('8784','2013-06-27','14:30:00',3.31),('8784','2013-06-27','14:35:00',2.31),('8784','2013-06-27','14:40:00',3.97),('8784','2013-06-27','14:45:00',1.58),('8784','2013-06-27','14:50:00',2.4),('8784','2013-06-27','14:55:00',4.12),('8784','2013-06-27','15:00:00',4.18),('8784','2013-06-27','15:05:00',4.08),('8784','2013-06-27','15:10:00',4.05),('8784','2013-06-27','15:15:00',3.99),('8784','2013-06-27','15:20:00',3.94),('8784','2013-06-27','15:25:00',3.91),('8784','2013-06-27','15:30:00',3.9),('8784','2013-06-27','15:35:00',3.87),('8784','2013-06-27','15:40:00',3.76),('8784','2013-06-27','15:45:00',3.76),('8784','2013-06-27','15:50:00',3.72),('8784','2013-06-27','15:55:00',3.5),('8784','2013-06-27','16:00:00',3.56),('8784','2013-06-27','16:05:00',3.47),('8784','2013-06-27','16:10:00',3.45),('8784','2013-06-27','16:15:00',3.42),('8784','2013-06-27','16:20:00',3.36),('8784','2013-06-27','16:25:00',3.32),('8784','2013-06-27','16:30:00',3.26),('8784','2013-06-27','16:35:00',3.02),('8784','2013-06-27','16:40:00',3.08),('8784','2013-06-27','16:45:00',3.08),('8784','2013-06-27','16:50:00',2.97),('8784','2013-06-27','16:55:00',2.9),('8784','2013-06-27','17:00:00',2.85),('8784','2013-06-27','17:05:00',2.76),('8784','2013-06-27','17:10:00',2.61),('8784','2013-06-27','17:15:00',2.53),('8784','2013-06-27','17:20:00',2.6),('8784','2013-06-27','17:25:00',2.52),('8784','2013-06-27','17:30:00',2.47),('8784','2013-06-27','17:35:00',2.38),('8784','2013-06-27','17:40:00',1.69),('8784','2013-06-27','17:45:00',1.19),('8784','2013-06-27','17:50:00',1.98),('8784','2013-06-27','17:55:00',2),('8784','2013-06-27','18:00:00',1.89),('8784','2013-06-27','18:05:00',1.81),('8784','2013-06-27','18:10:00',1.72),('8784','2013-06-27','18:15:00',1.61),('8784','2013-06-27','18:20:00',1.54),('8784','2013-06-27','18:25:00',1.55),('8784','2013-06-27','18:30:00',1.46),('8784','2013-06-27','18:35:00',1.35),('8784','2013-06-27','18:40:00',1.18),('8784','2013-06-27','18:45:00',1.09),('8784','2013-06-27','18:50:00',1.07),('8784','2013-06-27','18:55:00',1.02),('8784','2013-06-26','07:15:00',1.04),('8784','2013-06-26','07:20:00',1.11),('8784','2013-06-26','07:25:00',1.19),('8784','2013-06-26','07:30:00',1.27),('8784','2013-06-26','07:35:00',1.36),('8784','2013-06-26','07:40:00',1.45),('8784','2013-06-26','07:45:00',1.54),('8784','2013-06-26','07:50:00',1.65),('8784','2013-06-26','07:55:00',1.69),('8784','2013-06-26','08:00:00',1.75),('8784','2013-06-26','08:05:00',1.85),('8784','2013-06-26','08:10:00',1.95),('8784','2013-06-26','08:15:00',2.02),('8784','2013-06-26','08:20:00',2.09),('8784','2013-06-26','08:25:00',2.17),('8784','2013-06-26','08:30:00',2.24),('8784','2013-06-26','08:35:00',2.3),('8784','2013-06-26','08:40:00',2.38),('8784','2013-06-26','08:45:00',2.47),('8784','2013-06-26','08:50:00',2.53),('8784','2013-06-26','08:55:00',2.6),('8784','2013-06-26','09:00:00',2.67),('8784','2013-06-26','09:05:00',2.75),('8784','2013-06-26','09:10:00',2.8),('8784','2013-06-26','09:15:00',2.84),('8784','2013-06-26','09:20:00',2.88),('8784','2013-06-26','09:25:00',3.01),('8784','2013-06-26','09:30:00',3.07),('8784','2013-06-26','09:35:00',3.11),('8784','2013-06-26','09:40:00',3.17),('8784','2013-06-26','09:45:00',3.25),('8784','2013-06-26','09:50:00',3.24),('8784','2013-06-26','09:55:00',3.31),('8784','2013-06-26','10:00:00',3.39),('8784','2013-06-26','10:05:00',3.46),('8784','2013-06-26','10:10:00',3.54),('8784','2013-06-26','10:15:00',3.62),('8784','2013-06-26','10:20:00',3.66),('8784','2013-06-26','10:25:00',3.68),('8784','2013-06-26','10:30:00',3.7),('8784','2013-06-26','10:35:00',3.74),('8784','2013-06-26','10:40:00',3.8),('8784','2013-06-26','10:45:00',3.85),('8784','2013-06-26','10:50:00',3.91),('8784','2013-06-26','10:55:00',3.93),('8784','2013-06-26','11:00:00',3.95),('8784','2013-06-26','11:05:00',3.99),('8784','2013-06-26','11:10:00',4),('8784','2013-06-26','11:15:00',4.03),('8784','2013-06-26','11:20:00',4.11),('8784','2013-06-26','11:25:00',4.08),('8784','2013-06-26','11:30:00',4.13),('8784','2013-06-26','11:35:00',4.14),('8784','2013-06-26','11:40:00',4.16),('8784','2013-06-26','11:45:00',4.18),('8784','2013-06-26','11:50:00',4.24),('8784','2013-06-26','11:55:00',4.27),('8784','2013-06-26','12:00:00',4.33),('8784','2013-06-26','12:05:00',4.36),('8784','2013-06-26','12:10:00',4.32),('8784','2013-06-26','12:15:00',4.36),('8784','2013-06-26','12:20:00',4.31),('8784','2013-06-26','12:25:00',4.28),('8784','2013-06-26','12:30:00',3.99),('8784','2013-06-26','12:35:00',2.4),('8784','2013-06-26','12:40:00',3.16),('8784','2013-06-26','12:45:00',1.76),('8784','2013-06-26','12:50:00',1.02),('8784','2013-06-26','12:55:00',1.1),('8784','2013-06-26','13:00:00',1.06),('8784','2013-06-26','13:05:00',1.52),('8784','2013-06-26','13:10:00',2.31),('8784','2013-06-26','13:15:00',4.91),('8784','2013-06-26','13:20:00',4.82),('8784','2013-06-26','13:25:00',4.89),('8784','2013-06-26','13:30:00',4.05),('8784','2013-06-26','13:35:00',1.08),('8784','2013-06-26','13:40:00',1.16),('8784','2013-06-26','13:45:00',1.59),('8784','2013-06-26','13:50:00',3.29),('8784','2013-06-26','13:55:00',1.45),('8784','2013-06-26','14:00:00',4.86),('8784','2013-06-26','14:05:00',4.84),('8784','2013-06-26','14:10:00',2.87),('8784','2013-06-26','14:15:00',3.22),('8784','2013-06-26','14:20:00',4.64),('8784','2013-06-26','14:25:00',3.96),('8784','2013-06-26','14:30:00',4.04),('8784','2013-06-26','14:35:00',4.01),('8784','2013-06-26','14:40:00',3.7),('8784','2013-06-26','14:45:00',2.73),('8784','2013-06-26','14:50:00',4.6),('8784','2013-06-26','14:55:00',4.43),('8784','2013-06-26','15:00:00',4.18),('8784','2013-06-26','15:05:00',4.14),('8784','2013-06-26','15:10:00',4.07),('8784','2013-06-26','15:15:00',4.01),('8784','2013-06-26','15:20:00',3.99),('8784','2013-06-26','15:25:00',3.9),('8784','2013-06-26','15:30:00',3.87),('8784','2013-06-26','15:35:00',3.79),('8784','2013-06-26','15:40:00',3.75),('8784','2013-06-26','15:45:00',3.76),('8784','2013-06-26','15:50:00',3.77),('8784','2013-06-26','15:55:00',3.68),('8784','2013-06-26','16:00:00',3.61),('8784','2013-06-26','16:05:00',3.58),('8784','2013-06-26','16:10:00',3.43),('8784','2013-06-26','16:15:00',3.37),('8784','2013-06-26','16:20:00',3.41),('8784','2013-06-26','16:25:00',3.35),('8784','2013-06-26','16:30:00',3.27),('8784','2013-06-26','16:35:00',3.19),('8784','2013-06-26','16:40:00',3.1),('8784','2013-06-26','16:45:00',3.06),('8784','2013-06-26','16:50:00',2.99),('8784','2013-06-26','16:55:00',2.93),('8784','2013-06-26','17:00:00',2.87),('8784','2013-06-26','17:05:00',2.81),('8784','2013-06-26','17:10:00',2.75),('8784','2013-06-26','17:15:00',2.65),('8784','2013-06-26','17:20:00',2.56),('8784','2013-06-26','17:25:00',2.48),('8784','2013-06-26','17:30:00',2.41),('8784','2013-06-26','17:35:00',2.34),('8784','2013-06-26','17:40:00',2.23),('8784','2013-06-26','17:45:00',2.18),('8784','2013-06-26','17:50:00',2.09),('8784','2013-06-26','17:55:00',2.01),('8784','2013-06-26','18:00:00',1.92),('8784','2013-06-26','18:05:00',1.93),('8784','2013-06-26','18:10:00',2.14),('8784','2013-06-26','18:15:00',1.46),('8784','2013-06-25','07:15:00',1.01),('8784','2013-06-25','07:20:00',1.08),('8784','2013-06-25','07:25:00',1.14),('8784','2013-06-25','07:30:00',1.23),('8784','2013-06-25','07:35:00',1.38),('8784','2013-06-25','07:40:00',1.49),('8784','2013-06-25','07:45:00',1.61),('8784','2013-06-25','07:50:00',1.26),('8784','2013-06-25','07:55:00',1.04),('8784','2013-06-25','08:00:00',2.02),('8784','2013-06-25','08:05:00',1.67),('8784','2013-06-25','08:10:00',1.16),('8784','2013-06-25','08:20:00',1.49),('8784','2013-06-25','08:25:00',2.24),('8784','2013-06-25','08:30:00',2.31),('8784','2013-06-25','08:35:00',2.37),('8784','2013-06-25','08:40:00',2.46),('8784','2013-06-25','08:45:00',2.53),('8784','2013-06-25','08:50:00',2.56),('8784','2013-06-25','08:55:00',2.67),('8784','2013-06-25','09:00:00',2.75),('8784','2013-06-25','09:05:00',2.75),('8784','2013-06-25','09:10:00',2.83),('8784','2013-06-25','09:15:00',2.97),('8784','2013-06-25','09:20:00',3.03),('8784','2013-06-25','09:25:00',3.08),('8784','2013-06-25','09:30:00',3.15),('8784','2013-06-25','09:35:00',3.37),('8784','2013-06-25','09:40:00',3.49),('8784','2013-06-25','09:45:00',3.28),('8784','2013-06-25','09:50:00',2.39),('8784','2013-06-25','09:55:00',3.4),('8784','2013-06-25','10:00:00',3.96),('8784','2013-06-25','10:05:00',3.96),('8784','2013-06-25','10:10:00',4.15),('8784','2013-06-25','10:15:00',4.12),('8784','2013-06-25','10:20:00',1.55),('8784','2013-06-25','10:25:00',1.09),('8784','2013-06-25','10:30:00',4.23),('8784','2013-06-25','10:35:00',4.3),('8784','2013-06-25','10:40:00',4.28),('8784','2013-06-25','10:45:00',4),('8784','2013-06-25','10:50:00',1.96),('8784','2013-06-25','10:55:00',3.52),('8784','2013-06-25','11:00:00',2.35),('8784','2013-06-25','11:05:00',3.89),('8784','2013-06-25','11:10:00',2.43),('8784','2013-06-25','11:15:00',1.23),('8784','2013-06-25','11:20:00',1.15),('8784','2013-06-25','11:25:00',1.19),('8784','2013-06-25','11:30:00',1.23),('8784','2013-06-25','11:35:00',3.6),('8784','2013-06-25','11:40:00',5.23),('8784','2013-06-25','11:45:00',4.87),('8784','2013-06-25','11:50:00',4.98),('8784','2013-06-25','11:55:00',2.2),('8784','2013-06-25','12:00:00',1.23),('8784','2013-06-25','12:05:00',1.16),('8784','2013-06-25','12:10:00',1.29),('8784','2013-06-25','12:15:00',1.26),('8784','2013-06-25','12:20:00',1.35),('8784','2013-06-25','12:25:00',1.31),('8784','2013-06-25','12:30:00',1.3),('8784','2013-06-25','12:35:00',2.41),('8784','2013-06-25','12:40:00',3.25),('8784','2013-06-25','12:45:00',4.74),('8784','2013-06-25','12:50:00',2.01),('8784','2013-06-25','12:55:00',1.82),('8784','2013-06-25','13:00:00',4.72),('8784','2013-06-25','13:05:00',4.51),('8784','2013-06-25','13:10:00',2.91),('8784','2013-06-25','13:15:00',4.45),('8784','2013-06-25','13:20:00',4.86),('8784','2013-06-25','13:25:00',4.79),('8784','2013-06-25','13:30:00',3.58),('8784','2013-06-25','13:35:00',4.22),('8784','2013-06-25','13:40:00',4.96),('8784','2013-06-25','13:45:00',4.32),('8784','2013-06-25','13:50:00',3.96),('8784','2013-06-25','13:55:00',4.22),('8784','2013-06-25','14:00:00',3.9),('8784','2013-06-25','14:05:00',4.66),('8784','2013-06-25','14:10:00',4.6),('8784','2013-06-25','14:15:00',4.61),('8784','2013-06-25','14:20:00',4.55),('8784','2013-06-25','14:25:00',4.39),('8784','2013-06-25','14:30:00',4.37),('8784','2013-06-25','14:35:00',4.3),('8784','2013-06-25','14:40:00',3.89),('8784','2013-06-25','14:45:00',4.36),('8784','2013-06-25','14:50:00',4.29),('8784','2013-06-25','14:55:00',4.24),('8784','2013-06-25','15:00:00',4.19),('8784','2013-06-25','15:05:00',4.17),('8784','2013-06-25','15:10:00',4.14),('8784','2013-06-25','15:15:00',4.07),('8784','2013-06-25','15:20:00',4.04),('8784','2013-06-25','15:25:00',3.96),('8784','2013-06-25','15:30:00',3.92),('8784','2013-06-25','15:35:00',3.86),('8784','2013-06-25','15:40:00',3.83),('8784','2013-06-25','15:45:00',3.77),('8784','2013-06-25','15:50:00',3.72),('8784','2013-06-25','15:55:00',3.64),('8784','2013-06-25','16:00:00',3.59),('8784','2013-06-25','16:05:00',3.54),('8784','2013-06-25','16:10:00',3.45),('8784','2013-06-25','16:15:00',3.42),('8784','2013-06-25','16:20:00',3.36),('8784','2013-06-25','16:25:00',3.26),('8784','2013-06-25','16:30:00',3.25),('8784','2013-06-25','16:35:00',3.18),('8784','2013-06-25','16:40:00',3.1),('8784','2013-06-25','16:45:00',3.03),('8784','2013-06-25','16:50:00',2.98),('8784','2013-06-25','16:55:00',2.91),('8784','2013-06-25','17:00:00',2.84),('8784','2013-06-25','17:05:00',2.78),('8784','2013-06-25','17:10:00',2.69),('8784','2013-06-25','17:15:00',2.62),('8784','2013-06-25','17:20:00',2.52),('8784','2013-06-25','17:25:00',2.43),('8784','2013-06-25','17:30:00',2.4),('8784','2013-06-25','17:35:00',2.31),('8784','2013-06-25','17:40:00',2.24),('8784','2013-06-25','17:45:00',2.15),('8784','2013-06-25','17:50:00',2.07),('8784','2013-06-25','17:55:00',2),('8784','2013-06-25','18:00:00',1.92),('8784','2013-06-25','18:05:00',1.83),('8784','2013-06-25','18:10:00',1.74),('8784','2013-06-25','18:15:00',1.65),('8784','2013-06-25','18:20:00',1.58),('8784','2013-06-25','18:25:00',1.49),('8784','2013-06-25','18:30:00',1.42),('8784','2013-06-25','18:35:00',1.35),('8784','2013-06-25','18:40:00',1.22),('8784','2013-06-25','18:45:00',1.17),('8784','2013-06-25','18:50:00',1.09),('8784','2013-06-25','18:55:00',1.02),('8784','2013-06-24','07:10:00',1.05),('8784','2013-06-24','08:40:00',1.76),('8784','2013-06-24','08:45:00',2.69),('8784','2013-06-24','08:50:00',2.73),('8784','2013-06-24','08:55:00',2.66),('8784','2013-06-24','09:00:00',2.3),('8784','2013-06-24','09:05:00',2.12),('8784','2013-06-24','09:10:00',1.92),('8784','2013-06-24','09:15:00',2.51),('8784','2013-06-24','09:20:00',2.9),('8784','2013-06-24','09:25:00',3.67),('8784','2013-06-24','09:30:00',3.09),('8784','2013-06-24','09:35:00',2.35),('8784','2013-06-24','09:40:00',3.56),('8784','2013-06-24','09:45:00',3.76),('8784','2013-06-24','09:50:00',3.71),('8784','2013-06-24','09:55:00',3.62),('8784','2013-06-24','10:00:00',3.64),('8784','2013-06-24','10:05:00',3.75),('8784','2013-06-24','10:10:00',3.96),('8784','2013-06-24','10:15:00',3.02),('8784','2013-06-24','10:20:00',4.18),('8784','2013-06-24','10:25:00',4.45),('8784','2013-06-24','10:30:00',4.11),('8784','2013-06-24','10:35:00',4.43),('8784','2013-06-24','10:40:00',1.82),('8784','2013-06-24','10:45:00',1.84),('8784','2013-06-24','10:50:00',3.1),('8784','2013-06-24','10:55:00',3.22),('8784','2013-06-24','11:00:00',4.29),('8784','2013-06-24','11:05:00',4.09),('8784','2013-06-24','11:10:00',1.45),('8784','2013-06-24','11:15:00',4.08),('8784','2013-06-24','11:20:00',3.78),('8784','2013-06-24','11:25:00',1.71),('8784','2013-06-24','11:30:00',2.37),('8784','2013-06-24','11:35:00',1.53),('8784','2013-06-24','11:40:00',1.39),('8784','2013-06-24','11:45:00',2.46),('8784','2013-06-24','11:50:00',2.08),('8784','2013-06-24','11:55:00',4.3),('8784','2013-06-24','12:00:00',3.09),('8784','2013-06-24','12:05:00',3.59),('8784','2013-06-24','12:10:00',4.65),('8784','2013-06-24','12:15:00',2.59),('8784','2013-06-24','12:20:00',5.2),('8784','2013-06-24','12:25:00',4.23),('8784','2013-06-24','12:30:00',3.22),('8784','2013-06-24','12:35:00',5.17),('8784','2013-06-24','12:40:00',3.87),('8784','2013-06-24','12:45:00',3.78),('8784','2013-06-24','12:50:00',4.68),('8784','2013-06-24','12:55:00',4.8),('8784','2013-06-24','13:00:00',3.75),('8784','2013-06-24','13:05:00',5.2),('8784','2013-06-24','13:10:00',3.58),('8784','2013-06-24','13:15:00',3.4),('8784','2013-06-24','13:20:00',1.99),('8784','2013-06-24','13:25:00',4.2),('8784','2013-06-24','13:30:00',4.9),('8784','2013-06-24','13:35:00',3.58),('8784','2013-06-24','13:40:00',4.52),('8784','2013-06-24','13:45:00',4.78),('8784','2013-06-24','13:50:00',4.75),('8784','2013-06-24','13:55:00',4.7),('8784','2013-06-24','14:00:00',4.24),('8784','2013-06-24','14:05:00',4.64),('8784','2013-06-24','14:10:00',4.63),('8784','2013-06-24','14:15:00',4.62),('8784','2013-06-24','14:20:00',4.57),('8784','2013-06-24','14:25:00',4.59),('8784','2013-06-24','14:30:00',4.59),('8784','2013-06-24','14:35:00',4.56),('8784','2013-06-24','14:40:00',4.56),('8784','2013-06-24','14:45:00',4.66),('8784','2013-06-24','14:50:00',4.15),('8784','2013-06-24','14:55:00',3.21),('8784','2013-06-24','15:00:00',4.29),('8784','2013-06-24','15:05:00',2.31),('8784','2013-06-24','15:10:00',3.84),('8784','2013-06-24','15:15:00',4.3),('8784','2013-06-24','15:20:00',3.73),('8784','2013-06-24','15:25:00',2.88),('8784','2013-06-24','15:30:00',3.44),('8784','2013-06-24','15:35:00',2.04),('8784','2013-06-24','15:40:00',2.97),('8784','2013-06-24','15:45:00',2.96),('8784','2013-06-24','15:50:00',3.46),('8784','2013-06-24','15:55:00',3.86),('8784','2013-06-24','16:00:00',4.24),('8784','2013-06-24','16:05:00',3.96),('8784','2013-06-24','16:10:00',3.04),('8784','2013-06-24','16:15:00',3.95),('8784','2013-06-24','16:20:00',2.33),('8784','2013-06-24','16:25:00',2.91),('8784','2013-06-24','16:30:00',3.54),('8784','2013-06-24','16:35:00',3.13),('8784','2013-06-24','16:40:00',2.42),('8784','2013-06-24','16:45:00',2.33),('8784','2013-06-24','16:50:00',2.01),('8784','2013-06-24','16:55:00',1.36),('8784','2013-06-24','17:00:00',1.49),('8784','2013-06-24','17:05:00',2.58),('8784','2013-06-24','17:10:00',2.59),('8784','2013-06-24','17:15:00',3.04),('8784','2013-06-24','17:20:00',2.15),('8784','2013-06-24','17:25:00',2.72),('8784','2013-06-24','17:30:00',1.63),('8784','2013-06-24','17:35:00',1.05),('8784','2013-06-24','17:50:00',1.62),('8784','2013-06-24','17:55:00',1.4),('8784','2013-06-24','18:00:00',2.32),('8784','2013-06-24','18:05:00',1.91),('8784','2013-06-24','18:10:00',1.69),('8784','2013-06-24','18:15:00',1.83),('8784','2013-06-24','18:20:00',1.67),('8784','2013-06-24','18:25:00',1.6),('8784','2013-06-24','18:30:00',1.18),('8784','2013-06-24','18:35:00',1.48),('8784','2013-06-24','18:45:00',1.35),('8784','2013-06-24','18:50:00',1.16),('8784','2013-06-24','18:55:00',1.06),('8784','2013-06-24','19:00:00',1.04),('8784','2013-06-23','08:45:00',1.16),('8784','2013-06-23','08:50:00',1.62),('8784','2013-06-23','08:55:00',1.17),('8784','2013-06-23','09:00:00',2.04),('8784','2013-06-23','09:05:00',1.47),('8784','2013-06-23','09:20:00',1.96),('8784','2013-06-23','09:25:00',2.94),('8784','2013-06-23','09:30:00',3.11),('8784','2013-06-23','09:35:00',3.24),('8784','2013-06-23','09:40:00',3.71),('8784','2013-06-23','09:45:00',2.2),('8784','2013-06-23','09:50:00',1.14),('8784','2013-06-23','09:55:00',1.17),('8784','2013-06-23','10:00:00',3.4),('8784','2013-06-23','10:05:00',2.87),('8784','2013-06-23','10:10:00',1.22),('8784','2013-06-23','10:15:00',2.3),('8784','2013-06-23','10:20:00',1.26),('8784','2013-06-23','10:25:00',2.77),('8784','2013-06-23','10:30:00',3.09),('8784','2013-06-23','10:35:00',1.38),('8784','2013-06-23','10:40:00',3.74),('8784','2013-06-23','10:45:00',3.57),('8784','2013-06-23','10:50:00',3.87),('8784','2013-06-23','10:55:00',3.81),('8784','2013-06-23','11:00:00',3.88),('8784','2013-06-23','11:05:00',3.97),('8784','2013-06-23','11:10:00',4.03),('8784','2013-06-23','11:15:00',3.85),('8784','2013-06-23','11:20:00',4.06),('8784','2013-06-23','11:25:00',4.13),('8784','2013-06-23','11:30:00',3.96),('8784','2013-06-23','11:35:00',3.88),('8784','2013-06-23','11:40:00',4.08),('8784','2013-06-23','11:45:00',4.17),('8784','2013-06-23','11:50:00',4.1),('8784','2013-06-23','11:55:00',4.13),('8784','2013-06-23','12:00:00',4.29),('8784','2013-06-23','12:05:00',4.34),('8784','2013-06-23','12:10:00',4.38),('8784','2013-06-23','12:15:00',4.3),('8784','2013-06-23','12:20:00',4.33),('8784','2013-06-23','12:25:00',4.45),('8784','2013-06-23','12:30:00',4.43),('8784','2013-06-23','12:35:00',4.41),('8784','2013-06-23','12:40:00',4.45),('8784','2013-06-23','12:45:00',4.42),('8784','2013-06-23','12:50:00',4.43),('8784','2013-06-23','12:55:00',4.42),('8784','2013-06-23','13:00:00',4.43),('8784','2013-06-23','13:05:00',4.43),('8784','2013-06-23','13:10:00',4.44),('8784','2013-06-23','13:15:00',4.46),('8784','2013-06-23','13:20:00',4.45),('8784','2013-06-23','13:25:00',4.46),('8784','2013-06-23','13:30:00',4.48),('8784','2013-06-23','13:35:00',4.51),('8784','2013-06-23','13:40:00',4.49),('8784','2013-06-23','13:45:00',4.51),('8784','2013-06-23','13:50:00',4.48),('8784','2013-06-23','13:55:00',4.46),('8784','2013-06-23','14:00:00',4.44),('8784','2013-06-23','14:05:00',4.45),('8784','2013-06-23','14:10:00',4.36),('8784','2013-06-23','14:15:00',4.32),('8784','2013-06-23','14:20:00',4.29),('8784','2013-06-23','14:25:00',4.38),('8784','2013-06-23','14:30:00',4.32),('8784','2013-06-23','14:35:00',4.31),('8784','2013-06-23','14:40:00',4.24),('8784','2013-06-23','14:45:00',4.27),('8784','2013-06-23','14:50:00',4.25),('8784','2013-06-23','14:55:00',4.23),('8784','2013-06-23','15:00:00',4.2),('8784','2013-06-23','15:05:00',4.16),('8784','2013-06-23','15:10:00',4.13),('8784','2013-06-23','15:15:00',4.09),('8784','2013-06-23','15:20:00',4.04),('8784','2013-06-23','15:25:00',3.98),('8784','2013-06-23','15:30:00',3.92),('8784','2013-06-23','15:35:00',3.88),('8784','2013-06-23','15:40:00',3.75),('8784','2013-06-23','15:45:00',3.7),('8784','2013-06-23','15:50:00',3.71),('8784','2013-06-23','15:55:00',3.68),('8784','2013-06-23','16:00:00',3.66),('8784','2013-06-23','16:05:00',3.58),('8784','2013-06-23','16:10:00',3.52),('8784','2013-06-23','16:15:00',3.43),('8784','2013-06-23','16:20:00',3.37),('8784','2013-06-23','16:25:00',3.32),('8784','2013-06-23','16:30:00',3.24),('8784','2013-06-23','16:35:00',3.21),('8784','2013-06-23','16:40:00',3.16),('8784','2013-06-23','16:45:00',3.09),('8784','2013-06-23','16:50:00',3.02),('8784','2013-06-23','16:55:00',2.95),('8784','2013-06-23','17:00:00',2.87),('8784','2013-06-23','17:05:00',2.81),('8784','2013-06-23','17:10:00',2.75),('8784','2013-06-23','17:15:00',2.68),('8784','2013-06-23','17:20:00',2.42),('8784','2013-06-23','17:25:00',2.53),('8784','2013-06-23','17:30:00',2.42),('8784','2013-06-23','17:35:00',2.36),('8784','2013-06-23','17:40:00',2.3),('8784','2013-06-23','17:45:00',2.24),('8784','2013-06-23','17:50:00',2.15),('8784','2013-06-23','17:55:00',2.04),('8784','2013-06-23','18:00:00',1.97),('8784','2013-06-23','18:05:00',1.89),('8784','2013-06-23','18:10:00',1.81),('8784','2013-06-23','18:15:00',1.7),('8784','2013-06-23','18:20:00',1.6),('8784','2013-06-23','18:25:00',1.51),('8784','2013-06-23','18:30:00',1.45),('8784','2013-06-23','18:35:00',1.37),('8784','2013-06-23','18:40:00',1.31),('8784','2013-06-23','18:45:00',1.24),('8784','2013-06-23','18:50:00',1.17),('8784','2013-06-23','18:55:00',1.05),('8784','2013-06-22','07:20:00',1.02),('8784','2013-06-22','07:25:00',1.09),('8784','2013-06-22','07:30:00',1.17),('8784','2013-06-22','07:35:00',1.24),('8784','2013-06-22','07:40:00',1.31),('8784','2013-06-22','07:45:00',1.4),('8784','2013-06-22','07:50:00',1.47),('8784','2013-06-22','07:55:00',1.56),('8784','2013-06-22','08:00:00',1.6),('8784','2013-06-22','08:05:00',1.69),('8784','2013-06-22','08:10:00',1.77),('8784','2013-06-22','08:15:00',1.85),('8784','2013-06-22','08:20:00',1.95),('8784','2013-06-22','08:25:00',2.04),('8784','2013-06-22','08:30:00',2.12),('8784','2013-06-22','08:35:00',2.21),('8784','2013-06-22','08:40:00',2.3),('8784','2013-06-22','08:45:00',2.37),('8784','2013-06-22','08:50:00',2.44),('8784','2013-06-22','08:55:00',2.51),('8784','2013-06-22','09:00:00',2.56),('8784','2013-06-22','09:05:00',2.63),('8784','2013-06-22','09:10:00',2.69),('8784','2013-06-22','09:15:00',2.74),('8784','2013-06-22','09:20:00',2.8),('8784','2013-06-22','09:25:00',2.86),('8784','2013-06-22','09:30:00',2.92),('8784','2013-06-22','09:35:00',2.98),('8784','2013-06-22','09:40:00',3.05),('8784','2013-06-22','09:45:00',3.05),('8784','2013-06-22','09:50:00',3.16),('8784','2013-06-22','09:55:00',3.25),('8784','2013-06-22','10:00:00',3.29),('8784','2013-06-22','10:05:00',3.35),('8784','2013-06-22','10:10:00',3.4),('8784','2013-06-22','10:15:00',3.47),('8784','2013-06-22','10:20:00',3.52),('8784','2013-06-22','10:25:00',3.56),('8784','2013-06-22','10:30:00',3.55),('8784','2013-06-22','10:35:00',3.61),('8784','2013-06-22','10:40:00',3.69),('8784','2013-06-22','10:45:00',3.75),('8784','2013-06-22','10:50:00',3.81),('8784','2013-06-22','10:55:00',3.84),('8784','2013-06-22','11:00:00',3.8),('8784','2013-06-22','11:05:00',3.9),('8784','2013-06-22','11:10:00',3.95),('8784','2013-06-22','11:15:00',3.96),('8784','2013-06-22','11:20:00',4.01),('8784','2013-06-22','11:25:00',4.02),('8784','2013-06-22','11:30:00',4.07),('8784','2013-06-22','11:35:00',4.11),('8784','2013-06-22','11:40:00',4.12),('8784','2013-06-22','11:45:00',4.14),('8784','2013-06-22','11:50:00',4.14),('8784','2013-06-22','11:55:00',4.15),('8784','2013-06-22','12:00:00',4.22),('8784','2013-06-22','12:05:00',4.15),('8784','2013-06-22','12:10:00',4.09),('8784','2013-06-22','12:15:00',4.27),('8784','2013-06-22','12:20:00',4.21),('8784','2013-06-22','12:25:00',4.22),('8784','2013-06-22','12:30:00',4.26),('8784','2013-06-22','12:35:00',4.29),('8784','2013-06-22','12:40:00',4.31),('8784','2013-06-22','12:45:00',4.24),('8784','2013-06-22','12:50:00',4.19),('8784','2013-06-22','12:55:00',4.18),('8784','2013-06-22','13:00:00',4.13),('8784','2013-06-22','13:05:00',4.17),('8784','2013-06-22','13:10:00',4.13),('8784','2013-06-22','13:15:00',4.06),('8784','2013-06-22','13:20:00',4),('8784','2013-06-22','13:25:00',4.28),('8784','2013-06-22','13:30:00',4.48),('8784','2013-06-22','13:35:00',4.5),('8784','2013-06-22','13:40:00',4.04),('8784','2013-06-22','13:45:00',4.33),('8784','2013-06-22','13:50:00',4.42),('8784','2013-06-22','13:55:00',3.16),('8784','2013-06-22','14:00:00',2.88),('8784','2013-06-22','14:05:00',4.75),('8784','2013-06-22','14:10:00',4.55),('8784','2013-06-22','14:15:00',4.52),('8784','2013-06-22','14:20:00',3.75),('8784','2013-06-22','14:25:00',4.38),('8784','2013-06-22','14:30:00',3.12),('8784','2013-06-22','14:35:00',2.41),('8784','2013-06-22','14:40:00',1.85),('8784','2013-06-22','14:45:00',2.38),('8784','2013-06-22','14:50:00',3.88),('8784','2013-06-22','14:55:00',4.31),('8784','2013-06-22','15:00:00',4.17),('8784','2013-06-22','15:05:00',3.23),('8784','2013-06-22','15:10:00',4.12),('8784','2013-06-22','15:15:00',4.24),('8784','2013-06-22','15:20:00',3.81),('8784','2013-06-22','15:25:00',3.43),('8784','2013-06-22','15:30:00',2.51),('8784','2013-06-22','15:35:00',1.96),('8784','2013-06-22','15:40:00',2.26),('8784','2013-06-22','15:45:00',2.97),('8784','2013-06-22','15:50:00',2.62),('8784','2013-06-22','15:55:00',2.65),('8784','2013-06-22','16:00:00',1.98),('8784','2013-06-22','16:05:00',1.35),('8784','2013-06-22','16:10:00',1.38),('8784','2013-06-22','16:15:00',1.74),('8784','2013-06-22','16:20:00',2),('8784','2013-06-22','16:25:00',1.42),('8784','2013-06-22','16:30:00',1.15),('8784','2013-06-22','16:55:00',1.35),('8784','2013-06-22','17:00:00',1.66),('8784','2013-06-22','17:05:00',1.61),('8784','2013-06-22','17:10:00',2.27),('8784','2013-06-22','17:15:00',3.14),('8784','2013-06-22','17:20:00',2.98),('8784','2013-06-22','17:25:00',2.95),('8784','2013-06-22','17:30:00',2.32),('8784','2013-06-22','17:35:00',2.06),('8784','2013-06-22','17:40:00',2.33),('8784','2013-06-22','17:45:00',2.32),('8784','2013-06-22','17:50:00',2.11),('8784','2013-06-22','17:55:00',2.08),('8784','2013-06-22','18:00:00',1.9),('8784','2013-06-22','18:05:00',1.57),('8784','2013-06-22','18:10:00',1.07),('8784','2013-06-22','18:15:00',1.13),('8784','2013-06-22','18:20:00',1.14),('8784','2013-06-21','07:20:00',1.01),('8784','2013-06-21','07:25:00',1.09),('8784','2013-06-21','07:30:00',1.17),('8784','2013-06-21','07:35:00',1.24),('8784','2013-06-21','07:40:00',1.31),('8784','2013-06-21','07:45:00',1.38),('8784','2013-06-21','07:50:00',1.48),('8784','2013-06-21','07:55:00',1.57),('8784','2013-06-21','08:00:00',1.65),('8784','2013-06-21','08:05:00',1.73),('8784','2013-06-21','08:10:00',1.8),('8784','2013-06-21','08:15:00',1.87),('8784','2013-06-21','08:20:00',1.92),('8784','2013-06-21','08:25:00',1.99),('8784','2013-06-21','08:30:00',2.09),('8784','2013-06-21','08:35:00',2.15),('8784','2013-06-21','08:40:00',2.21),('8784','2013-06-21','08:45:00',2.3),('8784','2013-06-21','08:50:00',2.36),('8784','2013-06-21','08:55:00',2.43),('8784','2013-06-21','09:00:00',2.48),('8784','2013-06-21','09:05:00',2.52),('8784','2013-06-21','09:10:00',2.58),('8784','2013-06-21','09:15:00',2.63),('8784','2013-06-21','09:20:00',2.66),('8784','2013-06-21','09:25:00',2.76),('8784','2013-06-21','09:30:00',2.78),('8784','2013-06-21','09:35:00',2.85),('8784','2013-06-21','09:40:00',2.9),('8784','2013-06-21','09:45:00',2.98),('8784','2013-06-21','09:50:00',3.03),('8784','2013-06-21','09:55:00',3.07),('8784','2013-06-21','10:00:00',3.13),('8784','2013-06-21','10:05:00',3.17),('8784','2013-06-21','10:10:00',3.23),('8784','2013-06-21','10:15:00',3.27),('8784','2013-06-21','10:20:00',3.28),('8784','2013-06-21','10:25:00',3.34),('8784','2013-06-21','10:30:00',3.34),('8784','2013-06-21','10:35:00',3.4),('8784','2013-06-21','10:40:00',3.43),('8784','2013-06-21','10:45:00',3.51),('8784','2013-06-21','10:50:00',3.46),('8784','2013-06-21','10:55:00',3.5),('8784','2013-06-21','11:00:00',3.56),('8784','2013-06-21','11:05:00',3.6),('8784','2013-06-21','11:10:00',3.65),('8784','2013-06-21','11:15:00',3.69),('8784','2013-06-21','11:20:00',3.78),('8784','2013-06-21','11:25:00',3.82),('8784','2013-06-21','11:30:00',3.84),('8784','2013-06-21','11:35:00',3.85),('8784','2013-06-21','11:40:00',3.85),('8784','2013-06-21','11:45:00',3.87),('8784','2013-06-21','11:50:00',3.9),('8784','2013-06-21','11:55:00',3.93),('8784','2013-06-21','12:00:00',3.92),('8784','2013-06-21','12:05:00',3.94),('8784','2013-06-21','12:10:00',3.98),('8784','2013-06-21','12:15:00',3.96),('8784','2013-06-21','12:20:00',3.99),('8784','2013-06-21','12:25:00',3.96),('8784','2013-06-21','12:30:00',3.97),('8784','2013-06-21','12:35:00',3.92),('8784','2013-06-21','12:40:00',4),('8784','2013-06-21','12:45:00',4.06),('8784','2013-06-21','12:50:00',4.01),('8784','2013-06-21','12:55:00',3.97),('8784','2013-06-21','13:00:00',3.99),('8784','2013-06-21','13:05:00',3.96),('8784','2013-06-21','13:10:00',3.94),('8784','2013-06-21','13:15:00',4),('8784','2013-06-21','13:20:00',4.08),('8784','2013-06-21','13:25:00',4.11),('8784','2013-06-21','13:30:00',4.13),('8784','2013-06-21','13:35:00',4.09),('8784','2013-06-21','13:40:00',4.07),('8784','2013-06-21','13:45:00',4.09),('8784','2013-06-21','13:50:00',4.04),('8784','2013-06-21','13:55:00',4.05),('8784','2013-06-21','14:00:00',4.08),('8784','2013-06-21','14:05:00',4.1),('8784','2013-06-21','14:10:00',4.1),('8784','2013-06-21','14:15:00',4.06),('8784','2013-06-21','14:20:00',4.08),('8784','2013-06-21','14:25:00',4.09),('8784','2013-06-21','14:30:00',4.07),('8784','2013-06-21','14:35:00',4.04),('8784','2013-06-21','14:40:00',4.02),('8784','2013-06-21','14:45:00',3.99),('8784','2013-06-21','14:50:00',3.98),('8784','2013-06-21','14:55:00',3.96),('8784','2013-06-21','15:00:00',3.93),('8784','2013-06-21','15:05:00',3.91),('8784','2013-06-21','15:10:00',3.87),('8784','2013-06-21','15:15:00',3.85),('8784','2013-06-21','15:20:00',3.82),('8784','2013-06-21','15:25:00',3.74),('8784','2013-06-21','15:30:00',3.71),('8784','2013-06-21','15:35:00',3.6),('8784','2013-06-21','15:40:00',3.63),('8784','2013-06-21','15:45:00',3.55),('8784','2013-06-21','15:50:00',3.53),('8784','2013-06-21','15:55:00',3.5),('8784','2013-06-21','16:00:00',3.44),('8784','2013-06-21','16:05:00',3.4),('8784','2013-06-21','16:10:00',3.37),('8784','2013-06-21','16:15:00',3.31),('8784','2013-06-21','16:20:00',3.26),('8784','2013-06-21','16:25:00',3.2),('8784','2013-06-21','16:30:00',3.15),('8784','2013-06-21','16:35:00',3.08),('8784','2013-06-21','16:40:00',3.02),('8784','2013-06-21','16:45:00',2.96),('8784','2013-06-21','16:50:00',2.89),('8784','2013-06-21','16:55:00',2.83),('8784','2013-06-21','17:00:00',2.75),('8784','2013-06-21','17:05:00',2.68),('8784','2013-06-21','17:10:00',2.6),('8784','2013-06-21','17:15:00',2.54),('8784','2013-06-21','17:20:00',2.44),('8784','2013-06-21','17:25:00',2.4),('8784','2013-06-21','17:30:00',2.31),('8784','2013-06-21','17:35:00',2.25),('8784','2013-06-21','17:40:00',2.18),('8784','2013-06-21','17:45:00',2.09),('8784','2013-06-21','17:50:00',2.02),('8784','2013-06-21','17:55:00',1.93),('8784','2013-06-21','18:00:00',1.86),('8784','2013-06-21','18:05:00',1.78),('8784','2013-06-21','18:10:00',1.7),('8784','2013-06-21','18:15:00',1.61),('8784','2013-06-21','18:20:00',1.53),('8784','2013-06-21','18:25:00',1.45),('8784','2013-06-21','18:30:00',1.36),('8784','2013-06-21','18:35:00',1.29),('8784','2013-06-21','18:40:00',1.19),('8784','2013-06-21','18:45:00',1.13),('8784','2013-06-21','18:50:00',1.05),('8784','2014-04-04','08:50:00',1.03),('8784','2014-04-04','08:55:00',1),('8784','2014-04-04','09:00:00',1.03),('8784','2014-04-04','09:05:00',1.65),('8784','2014-04-04','09:10:00',2.09),('8784','2014-04-04','09:15:00',2.02),('8784','2014-04-04','09:20:00',1.29),('8784','2014-04-04','13:10:00',1.26),('8784','2014-04-04','13:20:00',2.03),('8784','2014-04-04','13:25:00',2.29),('8784','2014-04-04','13:30:00',2.24),('8784','2014-04-04','13:35:00',2.7),('8784','2014-04-04','13:40:00',4.56),('8784','2014-04-04','13:45:00',3.45),('8784','2014-04-04','13:50:00',4.6),('8784','2014-04-04','13:55:00',2.14),('8784','2014-04-04','14:00:00',3.21),('8784','2014-04-04','14:05:00',4.9),('8784','2014-04-04','14:10:00',4.53),('8784','2014-04-04','14:15:00',3.59),('8784','2014-04-04','14:20:00',3.25),('8784','2014-04-04','14:25:00',3.7),('8784','2014-04-04','14:30:00',1.37),('8784','2014-04-04','14:35:00',2.45),('8784','2014-04-04','14:40:00',1.46),('8784','2014-04-04','14:45:00',1.52),('8784','2014-04-04','14:50:00',3.4),('8784','2014-04-04','14:55:00',3.85),('8784','2014-04-04','15:00:00',3.65),('8784','2014-04-04','15:05:00',3.92),('8784','2014-04-04','15:10:00',3.24),('8784','2014-04-04','15:15:00',3.46),('8784','2014-04-04','15:20:00',2.3),('8784','2014-04-04','15:25:00',1.96),('8784','2014-04-04','15:30:00',1.55),('8784','2014-04-04','15:35:00',1.63),('8784','2014-04-04','15:40:00',2.43),('8784','2014-04-04','15:45:00',1.94),('8784','2014-04-04','15:50:00',1.76),('8784','2014-04-04','15:55:00',3.31),('8784','2014-04-04','16:00:00',2.71),('8784','2014-04-04','16:05:00',2.42),('8784','2014-04-04','16:10:00',3.44),('8784','2014-04-04','16:15:00',1.83),('8784','2014-04-04','16:20:00',1.22),('8784','2014-04-04','16:25:00',1.16),('8784','2014-04-04','16:30:00',2.33),('8784','2014-04-04','16:35:00',1.78),('8784','2014-04-04','16:40:00',1.5),('8784','2014-04-04','16:45:00',2.71),('8784','2014-04-04','16:50:00',2.89),('8784','2014-04-04','16:55:00',2.54),('8784','2014-04-04','17:00:00',2.11),('8784','2014-04-04','17:05:00',1.95),('8784','2014-04-04','17:10:00',1.88),('8784','2014-04-04','17:15:00',1.62),('8784','2014-04-04','17:20:00',2.08),('8784','2014-04-04','17:25:00',1.73),('8784','2014-04-04','17:30:00',2.09),('8784','2014-04-04','17:35:00',1.7),('8784','2014-04-04','17:40:00',1.6),('8784','2014-04-04','17:45:00',1.6),('8784','2014-04-04','17:50:00',1.51),('8784','2014-04-04','17:55:00',1.31),('8784','2014-04-04','18:00:00',1.16),('8784','2014-04-04','18:05:00',1.05),('8784','2013-06-20','07:25:00',1.06),('8784','2013-06-20','07:30:00',1.14),('8784','2013-06-20','07:35:00',1.2),('8784','2013-06-20','07:40:00',1.24),('8784','2013-06-20','07:45:00',1.34),('8784','2013-06-20','07:50:00',1.41),('8784','2013-06-20','07:55:00',1.5),('8784','2013-06-20','08:00:00',1.6),('8784','2013-06-20','08:05:00',1.69),('8784','2013-06-20','08:10:00',1.79),('8784','2013-06-20','08:15:00',1.89),('8784','2013-06-20','08:20:00',1.96),('8784','2013-06-20','08:25:00',2.03),('8784','2013-06-20','08:30:00',2.08),('8784','2013-06-20','08:35:00',2.19),('8784','2013-06-20','08:40:00',2.27),('8784','2013-06-20','08:45:00',2.34),('8784','2013-06-20','08:50:00',2.41),('8784','2013-06-20','08:55:00',2.48),('8784','2013-06-20','09:00:00',2.54),('8784','2013-06-20','09:05:00',2.58),('8784','2013-06-20','09:10:00',2.66),('8784','2013-06-20','09:15:00',2.69),('8784','2013-06-20','09:20:00',2.77),('8784','2013-06-20','09:25:00',2.83),('8784','2013-06-20','09:30:00',2.89),('8784','2013-06-20','09:35:00',2.95),('8784','2013-06-20','09:40:00',3.01),('8784','2013-06-20','09:45:00',3.01),('8784','2013-06-20','09:50:00',3.12),('8784','2013-06-20','09:55:00',3.19),('8784','2013-06-20','10:00:00',3.24),('8784','2013-06-20','10:05:00',3.28),('8784','2013-06-20','10:10:00',3.35),('8784','2013-06-20','10:15:00',3.37),('8784','2013-06-20','10:20:00',3.45),('8784','2013-06-20','10:25:00',3.46),('8784','2013-06-20','10:30:00',3.54),('8784','2013-06-20','10:35:00',3.59),('8784','2013-06-20','10:40:00',3.62),('8784','2013-06-20','10:45:00',3.62),('8784','2013-06-20','10:50:00',3.64),('8784','2013-06-20','10:55:00',3.69),('8784','2013-06-20','11:00:00',3.72),('8784','2013-06-20','11:05:00',3.75),('8784','2013-06-20','11:10:00',3.77),('8784','2013-06-20','11:15:00',3.77),('8784','2013-06-20','11:20:00',3.76),('8784','2013-06-20','11:25:00',3.76),('8784','2013-06-20','11:30:00',3.79),('8784','2013-06-20','11:35:00',3.89),('8784','2013-06-20','11:40:00',3.94),('8784','2013-06-20','11:45:00',3.91),('8784','2013-06-20','11:50:00',3.81),('8784','2013-06-20','11:55:00',3.86),('8784','2013-06-20','12:00:00',3.79),('8784','2013-06-20','12:05:00',3.87),('8784','2013-06-20','12:10:00',3.49),('8784','2013-06-20','12:15:00',3.63),('8784','2013-06-20','12:20:00',3.01),('8784','2013-06-20','12:25:00',3.77),('8784','2013-06-20','12:30:00',4.16),('8784','2013-06-20','12:35:00',4.1),('8784','2013-06-20','12:40:00',4.06),('8784','2013-06-20','12:45:00',3.84),('8784','2013-06-20','12:50:00',3.72),('8784','2013-06-20','12:55:00',3.45),('8784','2013-06-20','13:00:00',4.21),('8784','2013-06-20','13:05:00',4.21),('8784','2013-06-20','13:10:00',3.64),('8784','2013-06-20','13:15:00',2.5),('8784','2013-06-20','13:20:00',4.16),('8784','2013-06-20','13:25:00',4.07),('8784','2013-06-20','13:30:00',4.08),('8784','2013-06-20','13:35:00',4.16),('8784','2013-06-20','13:40:00',4.16),('8784','2013-06-20','13:45:00',4.19),('8784','2013-06-20','13:50:00',4.2),('8784','2013-06-20','13:55:00',4.15),('8784','2013-06-20','14:00:00',4.23),('8784','2013-06-20','14:05:00',4.23),('8784','2013-06-20','14:10:00',4.2),('8784','2013-06-20','14:15:00',4.2),('8784','2013-06-20','14:20:00',4.22),('8784','2013-06-20','14:25:00',4.18),('8784','2013-06-20','14:30:00',4.2),('8784','2013-06-20','14:35:00',4.17),('8784','2013-06-20','14:40:00',4.19),('8784','2013-06-20','14:45:00',4.17),('8784','2013-06-20','14:50:00',4.13),('8784','2013-06-20','14:55:00',4.1),('8784','2013-06-20','15:00:00',4.06),('8784','2013-06-20','15:05:00',4.02),('8784','2013-06-20','15:10:00',3.98),('8784','2013-06-20','15:15:00',3.94),('8784','2013-06-20','15:20:00',3.88),('8784','2013-06-20','15:25:00',3.85),('8784','2013-06-20','15:30:00',3.81),('8784','2013-06-20','15:35:00',3.76),('8784','2013-06-20','15:40:00',3.73),('8784','2013-06-20','15:45:00',3.66),('8784','2013-06-20','15:50:00',3.62),('8784','2013-06-20','15:55:00',3.56),('8784','2013-06-20','16:00:00',3.52),('8784','2013-06-20','16:05:00',3.48),('8784','2013-06-20','16:10:00',3.43),('8784','2013-06-20','16:15:00',3.38),('8784','2013-06-20','16:20:00',3.27),('8784','2013-06-20','16:25:00',3.26),('8784','2013-06-20','16:30:00',3.19),('8784','2013-06-20','16:35:00',3.11),('8784','2013-06-20','16:40:00',3.04),('8784','2013-06-20','16:45:00',2.98),('8784','2013-06-20','16:50:00',2.9),('8784','2013-06-20','16:55:00',2.85),('8784','2013-06-20','17:00:00',2.76),('8784','2013-06-20','17:05:00',2.71),('8784','2013-06-20','17:10:00',2.64),('8784','2013-06-20','17:15:00',2.57),('8784','2013-06-20','17:20:00',2.49),('8784','2013-06-20','17:25:00',2.41),('8784','2013-06-20','17:30:00',2.34),('8784','2013-06-20','17:35:00',2.26),('8784','2013-06-20','17:40:00',2.21),('8784','2013-06-20','17:45:00',2.13),('8784','2013-06-20','17:50:00',2.06),('8784','2013-06-20','17:55:00',1.98),('8784','2013-06-20','18:00:00',1.91),('8784','2013-06-20','18:05:00',1.81),('8784','2013-06-20','18:10:00',1.74),('8784','2013-06-20','18:15:00',1.66),('8784','2013-06-20','18:20:00',1.58),('8784','2013-06-20','18:25:00',1.49),('8784','2013-06-20','18:30:00',1.39),('8784','2013-06-20','18:35:00',1.32),('8784','2013-06-20','18:40:00',1.23),('8784','2013-06-20','18:45:00',1.15),('8784','2013-06-20','18:50:00',1.06),('8784','2013-06-19','07:25:00',1.05),('8784','2013-06-19','07:30:00',1.12),('8784','2013-06-19','07:35:00',1.21),('8784','2013-06-19','07:40:00',1.28),('8784','2013-06-19','07:45:00',1.36),('8784','2013-06-19','07:50:00',1.44),('8784','2013-06-19','07:55:00',1.51),('8784','2013-06-19','08:00:00',1.56),('8784','2013-06-19','08:05:00',1.65),('8784','2013-06-19','08:10:00',1.74),('8784','2013-06-19','08:15:00',1.81),('8784','2013-06-19','08:20:00',1.88),('8784','2013-06-19','08:25:00',1.97),('8784','2013-06-19','08:30:00',2.05),('8784','2013-06-19','08:35:00',2.12),('8784','2013-06-19','08:40:00',2.19),('8784','2013-06-19','08:45:00',2.26),('8784','2013-06-19','08:50:00',2.33),('8784','2013-06-19','08:55:00',2.4),('8784','2013-06-19','09:00:00',2.47),('8784','2013-06-19','09:05:00',2.55),('8784','2013-06-19','09:10:00',2.59),('8784','2013-06-19','09:15:00',2.63),('8784','2013-06-19','09:20:00',2.72),('8784','2013-06-19','09:25:00',2.81),('8784','2013-06-19','09:30:00',2.85),('8784','2013-06-19','09:35:00',2.88),('8784','2013-06-19','09:40:00',2.91),('8784','2013-06-19','09:45:00',3),('8784','2013-06-19','09:50:00',3.06),('8784','2013-06-19','09:55:00',3.11),('8784','2013-06-19','10:00:00',3.16),('8784','2013-06-19','10:05:00',3.2),('8784','2013-06-19','10:10:00',3.26),('8784','2013-06-19','10:15:00',3.31),('8784','2013-06-19','10:20:00',3.34),('8784','2013-06-19','10:25:00',3.4),('8784','2013-06-19','10:30:00',3.41),('8784','2013-06-19','10:35:00',3.45),('8784','2013-06-19','10:40:00',3.48),('8784','2013-06-19','10:45:00',3.51),('8784','2013-06-19','10:50:00',3.54),('8784','2013-06-19','10:55:00',3.57),('8784','2013-06-19','11:00:00',3.6),('8784','2013-06-19','11:05:00',3.6),('8784','2013-06-19','11:10:00',3.67),('8784','2013-06-19','11:15:00',3.63),('8784','2013-06-19','11:20:00',3.71),('8784','2013-06-19','11:25:00',3.74),('8784','2013-06-19','11:30:00',3.81),('8784','2013-06-19','11:35:00',3.84),('8784','2013-06-19','11:40:00',3.82),('8784','2013-06-19','11:45:00',3.87),('8784','2013-06-19','11:50:00',3.87),('8784','2013-06-19','11:55:00',3.92),('8784','2013-06-19','12:00:00',3.89),('8784','2013-06-19','12:05:00',3.92),('8784','2013-06-19','12:10:00',3.88),('8784','2013-06-19','12:15:00',3.91),('8784','2013-06-19','12:20:00',3.9),('8784','2013-06-19','12:25:00',3.87),('8784','2013-06-19','12:30:00',4),('8784','2013-06-19','12:35:00',4.1),('8784','2013-06-19','12:40:00',4.1),('8784','2013-06-19','12:45:00',4.05),('8784','2013-06-19','12:50:00',4.06),('8784','2013-06-19','12:55:00',4.12),('8784','2013-06-19','13:00:00',4.09),('8784','2013-06-19','13:05:00',4.12),('8784','2013-06-19','13:10:00',4.09),('8784','2013-06-19','13:15:00',4.06),('8784','2013-06-19','13:20:00',4.13),('8784','2013-06-19','13:25:00',4.16),('8784','2013-06-19','13:30:00',4.12),('8784','2013-06-19','13:35:00',4.13),('8784','2013-06-19','13:40:00',4.11),('8784','2013-06-19','13:45:00',4.11),('8784','2013-06-19','13:50:00',4.15),('8784','2013-06-19','13:55:00',4.15),('8784','2013-06-19','14:00:00',4.15),('8784','2013-06-19','14:05:00',4.12),('8784','2013-06-19','14:10:00',4.1),('8784','2013-06-19','14:15:00',4.07),('8784','2013-06-19','14:20:00',4.07),('8784','2013-06-19','14:25:00',4.04),('8784','2013-06-19','14:30:00',4),('8784','2013-06-19','14:35:00',3.98),('8784','2013-06-19','14:40:00',3.94),('8784','2013-06-19','14:45:00',3.9),('8784','2013-06-19','14:50:00',3.88),('8784','2013-06-19','14:55:00',3.87),('8784','2013-06-19','15:00:00',3.85),('8784','2013-06-19','15:05:00',3.82),('8784','2013-06-19','15:10:00',3.78),('8784','2013-06-19','15:15:00',3.71),('8784','2013-06-19','15:20:00',3.71),('8784','2013-06-19','15:25:00',3.7),('8784','2013-06-19','15:30:00',3.65),('8784','2013-06-19','15:35:00',3.61),('8784','2013-06-19','15:40:00',3.54),('8784','2013-06-19','15:45:00',3.48),('8784','2013-06-19','15:50:00',3.37),('8784','2013-06-19','15:55:00',3.37),('8784','2013-06-19','16:00:00',3.34),('8784','2013-06-19','16:05:00',3.27),('8784','2013-06-19','16:10:00',3.22),('8784','2013-06-19','16:15:00',3.17),('8784','2013-06-19','16:20:00',3.11),('8784','2013-06-19','16:25:00',3.06),('8784','2013-06-19','16:30:00',3),('8784','2013-06-19','16:35:00',2.95),('8784','2013-06-19','16:40:00',2.89),('8784','2013-06-19','16:45:00',2.84),('8784','2013-06-19','16:50:00',2.79),('8784','2013-06-19','16:55:00',2.73),('8784','2013-06-19','17:00:00',2.67),('8784','2013-06-19','17:05:00',2.59),('8784','2013-06-19','17:10:00',2.51),('8784','2013-06-19','17:15:00',2.47),('8784','2013-06-19','17:20:00',2.44),('8784','2013-06-19','17:25:00',2.38),('8784','2013-06-19','17:30:00',2.31),('8784','2013-06-19','17:35:00',2.19),('8784','2013-06-19','17:40:00',2.15),('8784','2013-06-19','17:45:00',2.08),('8784','2013-06-19','17:50:00',1.99),('8784','2013-06-19','18:00:00',1.85),('8784','2013-06-19','18:05:00',1.75),('8784','2013-06-19','18:10:00',1.64),('8784','2013-06-19','18:15:00',1.55),('8784','2013-06-19','18:20:00',1.49),('8784','2013-06-19','18:25:00',1.41),('8784','2013-06-19','18:30:00',1.29),('8784','2013-06-19','18:35:00',1.19),('8784','2013-06-19','18:40:00',1.06),('8784','2013-06-19','18:45:00',1.03),('8784','2013-06-18','07:30:00',1.09),('8784','2013-06-18','07:35:00',1.18),('8784','2013-06-18','07:40:00',1.25),('8784','2013-06-18','07:45:00',1.33),('8784','2013-06-18','07:50:00',1.41),('8784','2013-06-18','07:55:00',1.49),('8784','2013-06-18','08:00:00',1.55),('8784','2013-06-18','08:05:00',1.65),('8784','2013-06-18','08:10:00',1.74),('8784','2013-06-18','08:15:00',1.8),('8784','2013-06-18','08:20:00',1.88),('8784','2013-06-18','08:25:00',1.96),('8784','2013-06-18','08:30:00',2.03),('8784','2013-06-18','08:35:00',2.1),('8784','2013-06-17','07:20:00',1.03),('8784','2013-06-17','07:25:00',1.11),('8784','2013-06-17','07:30:00',1.19),('8784','2013-06-17','07:35:00',1.27),('8784','2013-06-17','07:40:00',1.35),('8784','2013-06-17','07:45:00',1.43),('8784','2013-06-17','07:50:00',1.52),('8784','2013-06-17','07:55:00',1.6),('8784','2013-06-17','08:00:00',1.68),('8784','2013-06-17','08:05:00',1.76),('8784','2013-06-17','08:10:00',1.84),('8784','2013-06-17','08:15:00',1.92),('8784','2013-06-17','08:20:00',1.99),('8784','2013-06-17','08:25:00',2.07),('8784','2013-06-17','08:30:00',2.12),('8784','2013-06-17','08:35:00',2.21),('8784','2013-06-17','08:40:00',2.3),('8784','2013-06-17','08:45:00',2.38),('8784','2013-06-17','08:50:00',2.44),('8784','2013-06-17','08:55:00',2.51),('8784','2013-06-17','09:00:00',2.58),('8784','2013-06-17','09:05:00',2.65),('8784','2013-06-17','09:10:00',2.72),('8784','2013-06-17','09:15:00',2.79),('8784','2013-06-17','09:20:00',2.85),('8784','2013-06-17','09:25:00',2.9),('8784','2013-06-17','09:30:00',2.97),('8784','2013-06-17','09:35:00',3.01),('8784','2013-06-17','09:40:00',3.07),('8784','2013-06-17','09:45:00',3.11),('8784','2013-06-17','09:50:00',3.19),('8784','2013-06-17','09:55:00',3.24),('8784','2013-06-17','10:00:00',3.27),('8784','2013-06-17','10:05:00',3.32),('8784','2013-06-17','10:10:00',3.36),('8784','2013-06-17','10:15:00',3.39),('8784','2013-06-17','10:20:00',3.43),('8784','2013-06-17','10:25:00',3.48),('8784','2013-06-17','10:30:00',3.54),('8784','2013-06-17','10:35:00',3.58),('8784','2013-06-17','10:40:00',3.61),('8784','2013-06-17','10:45:00',3.64),('8784','2013-06-17','10:50:00',3.69),('8784','2013-06-17','10:55:00',3.71),('8784','2013-06-17','11:00:00',3.74),('8784','2013-06-17','11:05:00',3.77),('8784','2013-06-17','11:10:00',3.78),('8784','2013-06-17','11:15:00',3.81),('8784','2013-06-17','11:20:00',3.84),('8784','2013-06-17','11:25:00',3.87),('8784','2013-06-17','11:30:00',3.89),('8784','2013-06-17','11:35:00',3.9),('8784','2013-06-17','11:40:00',3.92),('8784','2013-06-17','11:45:00',3.94),('8784','2013-06-17','11:50:00',3.96),('8784','2013-06-17','11:55:00',3.97),('8784','2013-06-17','12:00:00',3.94),('8784','2013-06-17','12:05:00',3.98),('8784','2013-06-17','12:10:00',3.97),('8784','2013-06-17','12:15:00',4),('8784','2013-06-17','12:20:00',4.01),('8784','2013-06-17','12:25:00',4.03),('8784','2013-06-17','12:30:00',3.99),('8784','2013-06-17','12:35:00',4.05),('8784','2013-06-17','12:40:00',4.06),('8784','2013-06-17','12:45:00',4.14),('8784','2013-06-17','12:50:00',4.13),('8784','2013-06-17','12:55:00',4.23),('8784','2013-06-17','13:00:00',4.26),('8784','2013-06-17','13:05:00',4.21),('8784','2013-06-17','13:10:00',4.18),('8784','2013-06-17','13:15:00',4.2),('8784','2013-06-17','13:20:00',4.18),('8784','2013-06-17','13:25:00',4.19),('8784','2013-06-17','13:30:00',4.16),('8784','2013-06-17','13:35:00',4.17),('8784','2013-06-17','13:40:00',4.15),('8784','2013-06-17','13:45:00',4.15),('8784','2013-06-17','13:50:00',4.16),('8784','2013-06-17','13:55:00',4.12),('8784','2013-06-17','14:00:00',4.1),('8784','2013-06-17','14:05:00',4.11),('8784','2013-06-17','14:10:00',4.11),('8784','2013-06-17','14:15:00',4.09),('8784','2013-06-17','14:20:00',4.08),('8784','2013-06-17','14:25:00',4.06),('8784','2013-06-17','14:30:00',4.01),('8784','2013-06-17','14:35:00',3.97),('8784','2013-06-17','14:40:00',4),('8784','2013-06-17','14:45:00',3.97),('8784','2013-06-17','14:50:00',3.93),('8784','2013-06-17','14:55:00',3.89),('8784','2013-06-17','15:00:00',3.87),('8784','2013-06-17','15:05:00',3.84),('8784','2013-06-17','15:10:00',3.8),('8784','2013-06-17','15:15:00',3.76),('8784','2013-06-17','15:20:00',3.75),('8784','2013-06-17','15:25:00',3.71),('8784','2013-06-17','15:30:00',3.66),('8784','2013-06-17','15:35:00',3.64),('8784','2013-06-17','15:40:00',3.58),('8784','2013-06-17','15:45:00',3.52),('8784','2013-06-17','15:50:00',3.48),('8784','2013-06-17','15:55:00',3.44),('8784','2013-06-17','16:00:00',3.4),('8784','2013-06-17','16:05:00',3.36),('8784','2013-06-17','16:10:00',3.32),('8784','2013-06-17','16:15:00',3.27),('8784','2013-06-17','16:20:00',3.19),('8784','2013-06-17','16:25:00',3.15),('8784','2013-06-17','16:30:00',3.1),('8784','2013-06-17','16:35:00',3.02),('8784','2013-06-17','16:40:00',2.97),('8784','2013-06-17','16:45:00',2.91),('8784','2013-06-17','16:50:00',2.86),('8784','2013-06-17','16:55:00',2.81),('8784','2013-06-17','17:00:00',2.73),('8784','2013-06-17','17:05:00',2.67),('8784','2013-06-17','17:10:00',2.61),('8784','2013-06-17','17:15:00',2.55),('8784','2013-06-17','17:20:00',2.49),('8784','2013-06-17','17:25:00',2.42),('8784','2013-06-17','17:30:00',2.37),('8784','2013-06-17','17:35:00',2.3),('8784','2013-06-17','17:40:00',2.22),('8784','2013-06-17','17:45:00',2.14),('8784','2013-06-17','17:50:00',2.06),('8784','2013-06-17','17:55:00',1.99),('8784','2013-06-17','18:00:00',1.91),('8784','2013-06-17','18:05:00',1.81),('8784','2013-06-17','18:10:00',1.76),('8784','2013-06-17','18:15:00',1.67),('8784','2013-06-17','18:20:00',1.61),('8784','2013-06-17','18:25:00',1.44),('8784','2013-06-17','18:30:00',1.43),('8784','2013-06-17','18:35:00',1.26),('8784','2013-06-17','18:40:00',1.29),('8784','2013-06-17','18:45:00',1.26),('8784','2013-06-17','18:50:00',1.19),('8784','2013-06-17','18:55:00',1.13),('8784','2013-06-17','19:00:00',1.06),('8784','2013-06-16','07:20:00',1.07),('8784','2013-06-16','07:25:00',1.11),('8784','2013-06-16','07:30:00',1.21),('8784','2013-06-16','07:35:00',1.31),('8784','2013-06-16','07:40:00',1.39),('8784','2013-06-16','07:45:00',1.47),('8784','2013-06-16','07:50:00',1.55),('8784','2013-06-16','07:55:00',1.62),('8784','2013-06-16','08:00:00',1.7),('8784','2013-06-16','08:05:00',1.77),('8784','2013-06-16','08:10:00',1.86),('8784','2013-06-16','08:15:00',1.93),('8784','2013-06-16','08:20:00',2.02),('8784','2013-06-16','08:25:00',2.11),('8784','2013-06-16','08:30:00',2.13),('8784','2013-06-16','08:35:00',2.23),('8784','2013-06-16','08:40:00',2.32),('8784','2013-06-16','08:45:00',2.42),('8784','2013-06-16','08:50:00',2.49),('8784','2013-06-16','08:55:00',2.53),('8784','2013-06-16','09:00:00',2.61),('8784','2013-06-16','09:05:00',2.68),('8784','2013-06-16','09:10:00',2.76),('8784','2013-06-16','09:15:00',2.82),('8784','2013-06-16','09:20:00',2.89),('8784','2013-06-16','09:25:00',2.97),('8784','2013-06-16','09:30:00',3),('8784','2013-06-16','09:35:00',3.07),('8784','2013-06-16','09:40:00',3.13),('8784','2013-06-16','09:45:00',3.12),('8784','2013-06-16','09:50:00',3.21),('8784','2013-06-16','09:55:00',3.28),('8784','2013-06-16','10:00:00',3.35),('8784','2013-06-16','10:05:00',3.39),('8784','2013-06-16','10:10:00',3.41),('8784','2013-06-16','10:15:00',3.43),('8784','2013-06-16','10:20:00',3.5),('8784','2013-06-16','10:25:00',3.54),('8784','2013-06-16','10:30:00',3.58),('8784','2013-06-16','10:35:00',3.6),('8784','2013-06-16','10:40:00',3.67),('8784','2013-06-16','10:45:00',3.71),('8784','2013-06-16','10:50:00',3.76),('8784','2013-06-16','10:55:00',3.8),('8784','2013-06-16','11:00:00',3.83),('8784','2013-06-16','11:05:00',3.86),('8784','2013-06-16','11:10:00',3.89),('8784','2013-06-16','11:15:00',3.95),('8784','2013-06-16','11:20:00',3.96),('8784','2013-06-16','11:25:00',4.02),('8784','2013-06-16','11:30:00',4.02),('8784','2013-06-16','11:35:00',4.08),('8784','2013-06-16','11:40:00',4.07),('8784','2013-06-16','11:45:00',4.09),('8784','2013-06-16','11:50:00',4.11),('8784','2013-06-16','11:55:00',4.14),('8784','2013-06-16','12:00:00',4.16),('8784','2013-06-16','12:05:00',4.21),('8784','2013-06-16','12:10:00',4.2),('8784','2013-06-16','12:15:00',4.23),('8784','2013-06-16','12:20:00',4.23),('8784','2013-06-16','12:25:00',4.2),('8784','2013-06-16','12:30:00',4.22),('8784','2013-06-16','12:35:00',4.22),('8784','2013-06-16','12:40:00',4.23),('8784','2013-06-16','12:45:00',4.24),('8784','2013-06-16','12:50:00',4.21),('8784','2013-06-16','12:55:00',4.28),('8784','2013-06-16','13:00:00',4.32),('8784','2013-06-16','13:05:00',4.34),('8784','2013-06-16','13:10:00',4.37),('8784','2013-06-16','13:15:00',4.34),('8784','2013-06-16','13:20:00',4.36),('8784','2013-06-16','13:25:00',4.36),('8784','2013-06-16','13:30:00',4.34),('8784','2013-06-16','13:35:00',4.38),('8784','2013-06-16','13:40:00',4.35),('8784','2013-06-16','13:45:00',4.33),('8784','2013-06-16','13:50:00',4.33),('8784','2013-06-16','13:55:00',4.28),('8784','2013-06-16','14:00:00',4.28),('8784','2013-06-16','14:05:00',4.26),('8784','2013-06-16','14:10:00',4.27),('8784','2013-06-16','14:15:00',4.26),('8784','2013-06-16','14:20:00',4.24),('8784','2013-06-16','14:25:00',4.21),('8784','2013-06-16','14:30:00',4.18),('8784','2013-06-16','14:35:00',4.1),('8784','2013-06-16','14:40:00',4.11),('8784','2013-06-16','14:45:00',4.08),('8784','2013-06-16','14:50:00',4.05),('8784','2013-06-16','14:55:00',4.02),('8784','2013-06-16','15:00:00',3.99),('8784','2013-06-16','15:05:00',3.97),('8784','2013-06-16','15:10:00',3.95),('8784','2013-06-16','15:15:00',3.9),('8784','2013-06-16','15:20:00',3.86),('8784','2013-06-16','15:25:00',3.83),('8784','2013-06-16','15:30:00',3.77),('8784','2013-06-16','15:35:00',3.74),('8784','2013-06-16','15:40:00',3.7),('8784','2013-06-16','15:45:00',3.68),('8784','2013-06-16','15:50:00',3.61),('8784','2013-06-16','15:55:00',3.55),('8784','2013-06-16','16:00:00',3.49),('8784','2013-06-16','16:05:00',3.44),('8784','2013-06-16','16:10:00',3.41),('8784','2013-06-16','16:15:00',3.34),('8784','2013-06-16','16:20:00',3.24),('8784','2013-06-16','16:25:00',3.23),('8784','2013-06-16','16:30:00',3.16),('8784','2013-06-16','16:35:00',3.1),('8784','2013-06-16','16:40:00',3.04),('8784','2013-06-16','16:45:00',2.96),('8784','2013-06-16','16:50:00',2.9),('8784','2013-06-16','16:55:00',2.83),('8784','2013-06-16','17:00:00',2.76),('8784','2013-06-16','17:05:00',2.68),('8784','2013-06-16','17:10:00',2.6),('8784','2013-06-16','17:15:00',2.54),('8784','2013-06-16','17:20:00',2.47),('8784','2013-06-16','17:25:00',2.39),('8784','2013-06-16','17:30:00',2.32),('8784','2013-06-16','17:35:00',2.23),('8784','2013-06-16','17:40:00',2.15),('8784','2013-06-16','17:45:00',2.07),('8784','2013-06-16','17:50:00',1.98),('8784','2013-06-16','17:55:00',1.9),('8784','2013-06-16','18:00:00',1.84),('8784','2013-06-16','18:05:00',1.75),('8784','2013-06-16','18:10:00',1.68),('8784','2013-06-16','18:15:00',1.59),('8784','2013-06-16','18:20:00',1.51),('8784','2013-06-16','18:25:00',1.44),('8784','2013-06-16','18:30:00',1.36),('8784','2013-06-16','18:35:00',1.28),('8784','2013-06-16','18:40:00',1.21),('8784','2013-06-16','18:45:00',1.13),('8784','2013-06-16','18:50:00',1.05),('8784','2013-06-15','07:20:00',1),('8784','2013-06-15','07:25:00',1.07),('8784','2013-06-15','07:30:00',1.15),('8784','2013-06-15','07:35:00',1.24),('8784','2013-06-15','07:40:00',1.32),('8784','2013-06-15','07:45:00',1.41),('8784','2013-06-15','07:50:00',1.49),('8784','2013-06-15','07:55:00',1.55),('8784','2013-06-15','08:00:00',1.63),('8784','2013-06-15','08:05:00',1.73),('8784','2013-06-15','08:10:00',1.78),('8784','2013-06-15','08:15:00',1.88),('8784','2013-06-15','08:20:00',1.95),('8784','2013-06-15','08:25:00',2),('8784','2013-06-15','08:30:00',2.12),('8784','2013-06-15','08:35:00',2.18),('8784','2013-06-15','08:40:00',2.19),('8784','2013-06-15','08:45:00',1.93),('8784','2013-06-15','08:50:00',2.43),('8784','2013-06-15','08:55:00',2.49),('8784','2013-06-15','09:00:00',2.46),('8784','2013-06-15','09:05:00',2.44),('8784','2013-06-15','09:10:00',2.66),('8784','2013-06-15','09:15:00',2.69),('8784','2013-06-15','09:20:00',2.16),('8784','2013-06-15','09:25:00',2.92),('8784','2013-06-15','09:30:00',2.97),('8784','2013-06-15','09:35:00',3.21),('8784','2013-06-15','09:40:00',3.19),('8784','2013-06-15','09:45:00',3.05),('8784','2013-06-15','09:50:00',3.17),('8784','2013-06-15','09:55:00',2.29),('8784','2013-06-15','10:00:00',2.18),('8784','2013-06-15','10:05:00',3.48),('8784','2013-06-15','10:10:00',3.35),('8784','2013-06-15','10:15:00',3.23),('8784','2013-06-15','10:20:00',2.71),('8784','2013-06-15','10:25:00',3.46),('8784','2013-06-15','10:30:00',2.75),('8784','2013-06-15','10:35:00',2.27),('8784','2013-06-15','10:40:00',2.64),('8784','2013-06-15','10:45:00',3.5),('8784','2013-06-15','10:50:00',2.4),('8784','2013-06-15','10:55:00',2.3),('8784','2013-06-15','11:00:00',3.81),('8784','2013-06-15','11:05:00',3.99),('8784','2013-06-15','11:10:00',3.58),('8784','2013-06-15','11:15:00',3.32),('8784','2013-06-15','11:20:00',2.2),('8784','2013-06-15','11:25:00',3.89),('8784','2013-06-15','11:30:00',4.19),('8784','2013-06-15','11:35:00',4.21),('8784','2013-06-15','11:40:00',4.24),('8784','2013-06-15','11:45:00',4.03),('8784','2013-06-15','11:50:00',4.37),('8784','2013-06-15','11:55:00',4.36),('8784','2013-06-15','12:00:00',4.39),('8784','2013-06-15','12:05:00',4.23),('8784','2013-06-15','12:10:00',4.38),('8784','2013-06-15','12:15:00',4.38),('8784','2013-06-15','12:20:00',4.36),('8784','2013-06-15','12:25:00',4.34),('8784','2013-06-15','12:30:00',4.35),('8784','2013-06-15','12:35:00',4.35),('8784','2013-06-15','12:40:00',4.37),('8784','2013-06-15','12:45:00',4.33),('8784','2013-06-15','12:50:00',4.38),('8784','2013-06-15','12:55:00',4.4),('8784','2013-06-15','13:00:00',4.38),('8784','2013-06-15','13:05:00',4.4),('8784','2013-06-15','13:10:00',4.38),('8784','2013-06-15','13:15:00',4.41),('8784','2013-06-15','13:20:00',4.36),('8784','2013-06-15','13:25:00',4.36),('8784','2013-06-15','13:30:00',4.32),('8784','2013-06-15','13:35:00',4.3),('8784','2013-06-15','13:40:00',4.34),('8784','2013-06-15','13:45:00',4.33),('8784','2013-06-15','13:50:00',4.26),('8784','2013-06-15','13:55:00',4.32),('8784','2013-06-15','14:00:00',4.28),('8784','2013-06-15','14:05:00',4.26),('8784','2013-06-15','14:10:00',4.24),('8784','2013-06-15','14:15:00',4.19),('8784','2013-06-15','14:20:00',4.19),('8784','2013-06-15','14:25:00',4.13),('8784','2013-06-15','14:30:00',4.1),('8784','2013-06-15','14:35:00',4.04),('8784','2013-06-15','14:40:00',4.08),('8784','2013-06-15','14:45:00',4.03),('8784','2013-06-15','14:50:00',4),('8784','2013-06-15','14:55:00',4),('8784','2013-06-15','15:00:00',3.93),('8784','2013-06-15','15:05:00',3.94),('8784','2013-06-15','15:10:00',3.92),('8784','2013-06-15','15:15:00',3.9),('8784','2013-06-15','15:20:00',3.87),('8784','2013-06-15','15:25:00',3.84),('8784','2013-06-15','15:30:00',3.81),('8784','2013-06-15','15:35:00',3.71),('8784','2013-06-15','15:40:00',3.71),('8784','2013-06-15','15:45:00',3.66),('8784','2013-06-15','15:50:00',3.61),('8784','2013-06-15','15:55:00',3.57),('8784','2013-06-15','16:00:00',3.51),('8784','2013-06-15','16:05:00',3.44),('8784','2013-06-15','16:10:00',3.38),('8784','2013-06-15','16:15:00',3.33),('8784','2013-06-15','16:20:00',3.27),('8784','2013-06-15','16:25:00',3.21),('8784','2013-06-15','16:30:00',3.16),('8784','2013-06-15','16:35:00',3.08),('8784','2013-06-15','16:40:00',3.01),('8784','2013-06-15','16:45:00',2.95),('8784','2013-06-15','16:50:00',2.88),('8784','2013-06-15','16:55:00',2.82),('8784','2013-06-15','17:00:00',2.75),('8784','2013-06-15','17:05:00',2.67),('8784','2013-06-15','17:10:00',2.61),('8784','2013-06-15','17:15:00',2.53),('8784','2013-06-15','17:20:00',2.45),('8784','2013-06-15','17:25:00',2.38),('8784','2013-06-15','17:30:00',2.29),('8784','2013-06-15','17:35:00',2.2),('8784','2013-06-15','17:40:00',2.12),('8784','2013-06-15','17:45:00',2.02),('8784','2013-06-15','17:50:00',1.93),('8784','2013-06-15','17:55:00',1.87),('8784','2013-06-15','18:00:00',1.81),('8784','2013-06-15','18:05:00',1.72),('8784','2013-06-15','18:10:00',1.64),('8784','2013-06-15','18:15:00',1.54),('8784','2013-06-15','18:20:00',1.47),('8784','2013-06-15','18:25:00',1.38),('8784','2013-06-15','18:30:00',1.32),('8784','2013-06-15','18:35:00',1.23),('8784','2013-06-15','18:40:00',1.18),('8784','2013-06-15','18:45:00',1.09),('8784','2013-06-15','18:50:00',1.01),('8784','2013-06-14','07:15:00',1.08),('8784','2013-06-14','07:20:00',1.16),('8784','2013-06-14','07:25:00',1.25),('8784','2013-06-14','07:30:00',1.32),('8784','2013-06-14','07:35:00',1.42),('8784','2013-06-14','07:40:00',1.5),('8784','2013-06-14','07:45:00',1.58),('8784','2013-06-14','07:50:00',1.66),('8784','2013-06-14','07:55:00',1.74),('8784','2013-06-14','08:00:00',1.82),('8784','2013-06-14','08:05:00',1.92),('8784','2013-06-14','08:10:00',2),('8784','2013-06-14','08:15:00',2.07),('8784','2013-06-14','08:20:00',2.15),('8784','2013-06-14','08:25:00',2.23),('8784','2013-06-14','08:30:00',2.31),('8784','2013-06-14','08:35:00',2.38),('8784','2013-06-14','08:40:00',2.46),('8784','2013-06-14','08:45:00',2.53),('8784','2013-06-14','08:50:00',2.62),('8784','2013-06-14','08:55:00',2.67),('8784','2013-06-14','09:00:00',2.75),('8784','2013-06-14','09:05:00',2.81),('8784','2013-06-14','09:10:00',2.88),('8784','2013-06-14','09:15:00',2.92),('8784','2013-06-14','09:20:00',3),('8784','2013-06-14','09:25:00',3.07),('8784','2013-06-14','09:30:00',3.1),('8784','2013-06-14','09:35:00',3.2),('8784','2013-06-14','09:40:00',3.27),('8784','2013-06-14','09:45:00',3.32),('8784','2013-06-14','09:50:00',3.37),('8784','2013-06-14','09:55:00',3.44),('8784','2013-06-14','10:00:00',3.48),('8784','2013-06-14','10:05:00',3.51),('8784','2013-06-14','10:10:00',3.57),('8784','2013-06-14','10:15:00',3.6),('8784','2013-06-14','10:20:00',3.64),('8784','2013-06-14','10:25:00',3.68),('8784','2013-06-14','10:30:00',3.66),('8784','2013-06-14','10:35:00',3.85),('8784','2013-06-14','10:40:00',3.88),('8784','2013-06-14','10:45:00',3.91),('8784','2013-06-14','10:50:00',3.91),('8784','2013-06-14','10:55:00',3.9),('8784','2013-06-14','11:00:00',3.87),('8784','2013-06-14','11:05:00',3.94),('8784','2013-06-14','11:10:00',3.99),('8784','2013-06-14','11:15:00',4.06),('8784','2013-06-14','11:20:00',4.05),('8784','2013-06-14','11:25:00',3.98),('8784','2013-06-14','11:30:00',4.18),('8784','2013-06-14','11:35:00',4.19),('8784','2013-06-14','11:40:00',4.22),('8784','2013-06-14','11:45:00',4.21),('8784','2013-06-14','11:50:00',4.22),('8784','2013-06-14','11:55:00',4.23),('8784','2013-06-14','12:00:00',4.24),('8784','2013-06-14','12:05:00',4.28),('8784','2013-06-14','12:10:00',4.27),('8784','2013-06-14','12:15:00',4.27),('8784','2013-06-14','12:20:00',4.28),('8784','2013-06-14','12:25:00',4.26),('8784','2013-06-14','12:30:00',4.3),('8784','2013-06-14','12:35:00',4.29),('8784','2013-06-14','12:40:00',4.27),('8784','2013-06-14','12:45:00',4.37),('8784','2013-06-14','12:50:00',4.31),('8784','2013-06-14','12:55:00',4.3),('8784','2013-06-14','13:00:00',4.33),('8784','2013-06-14','13:05:00',4.36),('8784','2013-06-14','13:10:00',4.42),('8784','2013-06-14','13:15:00',4.45),('8784','2013-06-14','13:20:00',4.43),('8784','2013-06-14','13:25:00',4.42),('8784','2013-06-14','13:30:00',4.34),('8784','2013-06-14','13:35:00',4.3),('8784','2013-06-14','13:40:00',4.34),('8784','2013-06-14','13:45:00',4.3),('8784','2013-06-14','13:50:00',4.34),('8784','2013-06-14','13:55:00',4.26),('8784','2013-06-14','14:00:00',4.23),('8784','2013-06-14','14:05:00',4.27),('8784','2013-06-14','14:10:00',4.29),('8784','2013-06-14','14:15:00',4.27),('8784','2013-06-14','14:20:00',4.21),('8784','2013-06-14','14:25:00',4.17),('8784','2013-06-14','14:30:00',4.15),('8784','2013-06-14','14:35:00',4.15),('8784','2013-06-14','14:40:00',4.13),('8784','2013-06-14','14:45:00',4.09),('8784','2013-06-14','14:50:00',4.06),('8784','2013-06-14','14:55:00',4.09),('8784','2013-06-14','15:00:00',4.06),('8784','2013-06-14','15:05:00',4.03),('8784','2013-06-14','15:10:00',4.01),('8784','2013-06-14','15:15:00',3.95),('8784','2013-06-14','15:20:00',3.86),('8784','2013-06-14','15:25:00',3.89),('8784','2013-06-14','15:30:00',3.87),('8784','2013-06-14','15:35:00',3.82),('8784','2013-06-14','15:40:00',3.77),('8784','2013-06-14','15:45:00',3.73),('8784','2013-06-14','15:50:00',3.69),('8784','2013-06-14','15:55:00',3.62),('8784','2013-06-14','16:00:00',3.56),('8784','2013-06-14','16:05:00',3.51),('8784','2013-06-14','16:10:00',3.44),('8784','2013-06-14','16:15:00',3.38),('8784','2013-06-14','16:20:00',3.32),('8784','2013-06-14','16:25:00',3.25),('8784','2013-06-14','16:30:00',3.18),('8784','2013-06-14','16:35:00',3.09),('8784','2013-06-14','16:40:00',3.05),('8784','2013-06-14','16:45:00',3.01),('8784','2013-06-14','16:50:00',2.95),('8784','2013-06-14','16:55:00',2.87),('8784','2013-06-14','17:00:00',2.82),('8784','2013-06-14','17:05:00',2.66),('8784','2013-06-14','17:10:00',2.64),('8784','2013-06-14','17:15:00',2.61),('8784','2013-06-14','17:20:00',2.52),('8784','2013-06-14','17:25:00',2.43),('8784','2013-06-14','17:30:00',2.29),('8784','2013-06-14','17:35:00',2.26),('8784','2013-06-14','17:40:00',2.23),('8784','2013-06-14','17:45:00',2.15),('8784','2013-06-14','17:50:00',2.07),('8784','2013-06-14','17:55:00',1.98),('8784','2013-06-14','18:00:00',1.88),('8784','2013-06-14','18:05:00',1.82),('8784','2013-06-14','18:10:00',1.74),('8784','2013-06-14','18:15:00',1.66),('8784','2013-06-14','18:20:00',1.56),('8784','2013-06-14','18:25:00',1.49),('8784','2013-06-14','18:30:00',1.41),('8784','2013-06-14','18:35:00',1.33),('8784','2013-06-14','18:40:00',1.26),('8784','2013-06-14','18:45:00',1.18),('8784','2013-06-14','18:50:00',1.09),('8784','2013-06-14','18:55:00',1.02),('8784','2013-06-13','07:10:00',1.01),('8784','2013-06-13','07:15:00',1.09),('8784','2013-06-13','07:20:00',1.17),('8784','2013-06-13','07:25:00',1.26),('8784','2013-06-13','07:30:00',1.34),('8784','2013-06-13','07:35:00',1.44),('8784','2013-06-13','07:40:00',1.52),('8784','2013-06-13','07:45:00',1.61),('8784','2013-06-13','07:50:00',1.69),('8784','2013-06-13','07:55:00',1.78),('8784','2013-06-13','08:00:00',1.86),('8784','2013-06-13','08:05:00',1.95),('8784','2013-06-13','08:10:00',2.03),('8784','2013-06-13','08:15:00',2.08),('8784','2013-06-13','08:20:00',2.18),('8784','2013-06-13','08:25:00',2.24),('8784','2013-06-13','08:30:00',2.3),('8784','2013-06-13','08:35:00',2.39),('8784','2013-06-13','08:40:00',2.46),('8784','2013-06-13','08:45:00',2.53),('8784','2013-06-13','08:50:00',2.6),('8784','2013-06-13','08:55:00',2.67),('8784','2013-06-13','09:00:00',2.75),('8784','2013-06-13','09:05:00',2.84),('8784','2013-06-13','09:10:00',2.91),('8784','2013-06-13','09:15:00',2.98),('8784','2013-06-13','09:20:00',3.04),('8784','2013-06-13','09:25:00',3.13),('8784','2013-06-13','09:30:00',3.21),('8784','2013-06-13','09:35:00',3.3),('8784','2013-06-13','09:40:00',3.37),('8784','2013-06-13','09:45:00',3.42),('8784','2013-06-13','09:50:00',3.49),('8784','2013-06-13','09:55:00',3.54),('8784','2013-06-13','10:00:00',3.57),('8784','2013-06-13','10:05:00',3.62),('8784','2013-06-13','10:10:00',3.67),('8784','2013-06-13','10:15:00',3.71),('8784','2013-06-13','10:20:00',3.76),('8784','2013-06-13','10:25:00',3.8),('8784','2013-06-13','10:30:00',3.85),('8784','2013-06-13','10:35:00',3.93),('8784','2013-06-13','10:40:00',3.95),('8784','2013-06-13','10:45:00',4.03),('8784','2013-06-13','10:50:00',4.06),('8784','2013-06-13','10:55:00',4.1),('8784','2013-06-13','11:00:00',4.12),('8784','2013-06-13','11:05:00',4.13),('8784','2013-06-13','11:10:00',4.16),('8784','2013-06-13','11:15:00',4.2),('8784','2013-06-13','11:20:00',4.17),('8784','2013-06-13','11:25:00',4.29),('8784','2013-06-13','11:30:00',4.32),('8784','2013-06-13','11:35:00',4.35),('8784','2013-06-13','11:40:00',4.39),('8784','2013-06-13','11:45:00',4.42),('8784','2013-06-13','11:50:00',4.45),('8784','2013-06-13','11:55:00',4.44),('8784','2013-06-13','12:00:00',4.45),('8784','2013-06-13','12:05:00',4.5),('8784','2013-06-13','12:10:00',4.51),('8784','2013-06-13','12:15:00',4.49),('8784','2013-06-13','12:20:00',4.5),('8784','2013-06-13','12:25:00',4.52),('8784','2013-06-13','12:30:00',4.56),('8784','2013-06-13','12:35:00',4.54),('8784','2013-06-13','12:40:00',4.53),('8784','2013-06-13','12:45:00',4.53),('8784','2013-06-13','12:50:00',4.54),('8784','2013-06-13','12:55:00',4.52),('8784','2013-06-13','13:00:00',4.55),('8784','2013-06-13','13:05:00',4.55),('8784','2013-06-13','13:10:00',4.53),('8784','2013-06-13','13:15:00',4.55),('8784','2013-06-13','13:20:00',4.5),('8784','2013-06-13','13:25:00',4.52),('8784','2013-06-13','13:30:00',4.49),('8784','2013-06-13','13:35:00',4.52),('8784','2013-06-13','13:40:00',4.5),('8784','2013-06-13','13:45:00',4.46),('8784','2013-06-13','13:50:00',4.46),('8784','2013-06-13','13:55:00',4.41),('8784','2013-06-13','14:00:00',4.43),('8784','2013-06-13','14:05:00',4.43),('8784','2013-06-13','14:10:00',4.39),('8784','2013-06-13','14:15:00',4.39),('8784','2013-06-13','14:20:00',4.39),('8784','2013-06-13','14:25:00',4.39),('8784','2013-06-13','14:30:00',3.57),('8784','2013-06-13','14:35:00',2.89),('8784','2013-06-13','14:40:00',4.42),('8784','2013-06-13','14:45:00',4.3),('8784','2013-06-13','14:50:00',4.17),('8784','2013-06-13','14:55:00',4.11),('8784','2013-06-13','15:00:00',4.15),('8784','2013-06-13','15:05:00',4.1),('8784','2013-06-13','15:10:00',4),('8784','2013-06-13','15:15:00',3.98),('8784','2013-06-13','15:20:00',3.93),('8784','2013-06-13','15:25:00',3.92),('8784','2013-06-13','15:30:00',3.87),('8784','2013-06-13','15:35:00',3.82),('8784','2013-06-13','15:40:00',3.77),('8784','2013-06-13','15:45:00',3.74),('8784','2013-06-13','15:50:00',3.69),('8784','2013-06-13','15:55:00',3.62),('8784','2013-06-13','16:00:00',3.57),('8784','2013-06-13','16:05:00',3.48),('8784','2013-06-13','16:10:00',3.43),('8784','2013-06-13','16:15:00',3.37),('8784','2013-06-13','16:20:00',3.29),('8784','2013-06-13','16:25:00',3.23),('8784','2013-06-13','16:30:00',3.16),('8784','2013-06-13','16:35:00',3.11),('8784','2013-06-13','16:40:00',3.04),('8784','2013-06-13','16:45:00',2.96),('8784','2013-06-13','16:50:00',2.86),('8784','2013-06-13','16:55:00',2.81),('8784','2013-06-13','17:00:00',2.75),('8784','2013-06-13','17:05:00',2.71),('8784','2013-06-13','17:10:00',2.63),('8784','2013-06-13','17:15:00',2.56),('8784','2013-06-13','17:20:00',2.52),('8784','2013-06-13','17:25:00',2.45),('8784','2013-06-13','17:30:00',2.37),('8784','2013-06-13','17:35:00',2.29),('8784','2013-06-13','17:40:00',2.19),('8784','2013-06-13','17:45:00',2.12),('8784','2013-06-13','17:50:00',2.03),('8784','2013-06-13','17:55:00',1.93),('8784','2013-06-13','18:00:00',1.85),('8784','2013-06-13','18:05:00',1.76),('8784','2013-06-13','18:10:00',1.68),('8784','2013-06-13','18:15:00',1.62),('8784','2013-06-13','18:20:00',1.55),('8784','2013-06-13','18:25:00',1.46),('8784','2013-06-13','18:30:00',1.38),('8784','2013-06-13','18:35:00',1.29),('8784','2013-06-13','18:40:00',1.21),('8784','2013-06-13','18:45:00',1.13),('8784','2013-06-13','18:50:00',1.06),('8784','2013-06-12','07:10:00',1.04),('8784','2013-06-12','07:15:00',1.11),('8784','2013-06-12','07:20:00',1.2),('8784','2013-06-12','07:25:00',1.28),('8784','2013-06-12','07:30:00',1.36),('8784','2013-06-12','07:35:00',1.44),('8784','2013-06-12','07:40:00',1.53),('8784','2013-06-12','07:45:00',1.62),('8784','2013-06-12','07:50:00',1.7),('8784','2013-06-12','07:55:00',1.78),('8784','2013-06-12','08:00:00',1.87),('8784','2013-06-12','08:05:00',1.95),('8784','2013-06-12','08:10:00',2.05),('8784','2013-06-12','08:15:00',2.13),('8784','2013-06-12','08:20:00',2.22),('8784','2013-06-12','08:25:00',2.31),('8784','2013-06-12','08:30:00',2.39),('8784','2013-06-12','08:35:00',2.45),('8784','2013-06-12','08:40:00',2.54),('8784','2013-06-12','08:45:00',2.63),('8784','2013-06-12','08:50:00',2.71),('8784','2013-06-12','08:55:00',2.77),('8784','2013-06-12','09:00:00',2.85),('8784','2013-06-12','09:05:00',2.93),('8784','2013-06-12','09:10:00',3),('8784','2013-06-12','09:15:00',3.08),('8784','2013-06-12','09:20:00',3.15),('8784','2013-06-12','09:25:00',3.2),('8784','2013-06-12','09:30:00',3.27),('8784','2013-06-12','09:35:00',3.32),('8784','2013-06-12','09:40:00',3.4),('8784','2013-06-12','09:45:00',3.46),('8784','2013-06-12','09:50:00',3.48),('8784','2013-06-12','09:55:00',3.55),('8784','2013-06-12','10:00:00',3.58),('8784','2013-06-12','10:05:00',3.66),('8784','2013-06-12','10:10:00',3.71),('8784','2013-06-12','10:15:00',3.74),('8784','2013-06-12','10:20:00',3.82),('8784','2013-06-12','10:25:00',3.88),('8784','2013-06-12','10:30:00',3.81),('8784','2013-06-12','10:35:00',3.92),('8784','2013-06-12','10:40:00',3.94),('8784','2013-06-12','10:45:00',3.99),('8784','2013-06-12','10:50:00',4.06),('8784','2013-06-12','10:55:00',4.14),('8784','2013-06-12','11:00:00',4.2),('8784','2013-06-12','11:05:00',4.24),('8784','2013-06-12','11:10:00',4.28),('8784','2013-06-12','11:15:00',4.29),('8784','2013-06-12','11:20:00',4.32),('8784','2013-06-12','11:25:00',4.3),('8784','2013-06-12','11:30:00',4.34),('8784','2013-06-12','11:35:00',4.31),('8784','2013-06-12','11:40:00',4.35),('8784','2013-06-12','11:45:00',4.4),('8784','2013-06-12','11:50:00',4.39),('8784','2013-06-12','11:55:00',4.46),('8784','2013-06-12','12:00:00',4.48),('8784','2013-06-12','12:05:00',4.42),('8784','2013-06-12','12:10:00',4.49),('8784','2013-06-12','12:15:00',4.51),('8784','2013-06-12','12:20:00',4.65),('8784','2013-06-12','12:25:00',3.45),('8784','2013-06-12','12:30:00',2.48),('8784','2013-06-12','12:35:00',4.86),('8784','2013-06-12','12:40:00',3.38),('8784','2013-06-12','12:45:00',1.26),('8784','2013-06-12','12:50:00',1.87),('8784','2013-06-12','12:55:00',2.65),('8784','2013-06-12','13:00:00',4.59),('8784','2013-06-12','13:05:00',1.67),('8784','2013-06-12','13:10:00',4.83),('8784','2013-06-12','13:15:00',4.68),('8784','2013-06-12','13:20:00',4.62),('8784','2013-06-12','13:25:00',4.42),('8784','2013-06-12','13:30:00',4.55),('8784','2013-06-12','13:35:00',4.58),('8784','2013-06-12','13:40:00',4.6),('8784','2013-06-12','13:45:00',4.19),('8784','2013-06-12','13:50:00',4.54),('8784','2013-06-12','13:55:00',4.64),('8784','2013-06-12','14:00:00',3.57),('8784','2013-06-12','14:05:00',2.73),('8784','2013-06-12','14:10:00',1.68),('8784','2013-06-12','14:15:00',4.6),('8784','2013-06-12','14:20:00',2.46),('8784','2013-06-12','14:25:00',2.9),('8784','2013-06-12','14:30:00',4.48),('8784','2013-06-12','14:35:00',3.69),('8784','2013-06-12','14:40:00',3.81),('8784','2013-06-12','14:45:00',4.51),('8784','2013-06-12','14:50:00',4.49),('8784','2013-06-12','14:55:00',4.46),('8784','2013-06-12','15:00:00',4.38),('8784','2013-06-12','15:05:00',4.32),('8784','2013-06-12','15:10:00',4.25),('8784','2013-06-12','15:15:00',3.56),('8784','2013-06-12','15:20:00',4.2),('8784','2013-06-12','15:25:00',4.01),('8784','2013-06-12','15:30:00',3.99),('8784','2013-06-12','15:35:00',3.99),('8784','2013-06-12','15:40:00',3.96),('8784','2013-06-12','15:45:00',3.9),('8784','2013-06-12','15:50:00',3.8),('8784','2013-06-12','15:55:00',3.82),('8784','2013-06-12','16:00:00',3.82),('8784','2013-06-12','16:05:00',3.62),('8784','2013-06-12','16:10:00',3.6),('8784','2013-06-12','16:15:00',3.54),('8784','2013-06-12','16:20:00',3.43),('8784','2013-06-12','16:25:00',3.44),('8784','2013-06-12','16:30:00',3.04),('8784','2013-06-12','16:35:00',3.16),('8784','2013-06-12','16:40:00',3.26),('8784','2013-06-12','16:45:00',2.93),('8784','2013-06-12','16:50:00',3.1),('8784','2013-06-12','16:55:00',2.4),('8784','2013-06-12','17:00:00',2.85),('8784','2013-06-12','17:05:00',2.81),('8784','2013-06-12','17:10:00',2.74),('8784','2013-06-12','17:15:00',2.66),('8784','2013-06-12','17:20:00',2.58),('8784','2013-06-12','17:25:00',2.5),('8784','2013-06-12','17:30:00',2.43),('8784','2013-06-12','17:35:00',2.38),('8784','2013-06-12','17:40:00',2.3),('8784','2013-06-12','17:45:00',1.08),('8784','2013-06-12','18:05:00',1.67),('8784','2013-06-12','18:10:00',1.77),('8784','2013-06-12','18:15:00',1.72),('8784','2013-06-12','18:20:00',1.65),('8784','2013-06-12','18:25:00',1.44),('8784','2013-06-12','18:30:00',1.41),('8784','2013-06-12','18:35:00',1.3),('8784','2013-06-12','18:40:00',1.21),('8784','2013-06-12','18:45:00',1.11),('8784','2013-06-12','18:50:00',1.03),('8784','2013-06-11','07:25:00',1.26),('8784','2013-06-11','07:30:00',1.27),('8784','2013-06-11','07:35:00',1.36),('8784','2013-06-11','07:40:00',1.45),('8784','2013-06-11','07:50:00',1.68),('8784','2013-06-11','07:55:00',1.82),('8784','2013-06-11','08:00:00',1.96),('8784','2013-06-11','08:05:00',2.06),('8784','2013-06-11','08:10:00',2.15),('8784','2013-06-11','08:15:00',1.69),('8784','2013-06-11','08:20:00',1.04),('8784','2013-06-11','08:25:00',2.56),('8784','2013-06-11','08:30:00',2.55),('8784','2013-06-11','08:35:00',2.61),('8784','2013-06-11','08:40:00',1.3),('8784','2013-06-11','08:45:00',2.17),('8784','2013-06-11','08:50:00',1.24),('8784','2013-06-11','09:00:00',2.2),('8784','2013-06-11','09:05:00',2.62),('8784','2013-06-11','09:10:00',3.15),('8784','2013-06-11','09:15:00',3.27),('8784','2013-06-11','09:20:00',3.35),('8784','2013-06-11','09:25:00',2.03),('8784','2013-06-11','09:30:00',2.75),('8784','2013-06-11','09:35:00',1.52),('8784','2013-06-11','09:40:00',2.47),('8784','2013-06-11','09:45:00',3.64),('8784','2013-06-11','09:50:00',3.64),('8784','2013-06-11','09:55:00',3.39),('8784','2013-06-11','10:00:00',2.79),('8784','2013-06-11','10:05:00',2.27),('8784','2013-06-11','10:10:00',3.28),('8784','2013-06-11','10:15:00',3.95),('8784','2013-06-11','10:20:00',4.04),('8784','2013-06-11','10:25:00',4.02),('8784','2013-06-11','10:30:00',4),('8784','2013-06-11','10:35:00',4.07),('8784','2013-06-11','10:40:00',3.92),('8784','2013-06-11','10:45:00',4.18),('8784','2013-06-11','10:50:00',3.24),('8784','2013-06-11','10:55:00',1.09),('8784','2013-06-11','11:00:00',4.55),('8784','2013-06-11','11:05:00',2.76),('8784','2013-06-11','11:10:00',2.69),('8784','2013-06-11','11:15:00',4.6),('8784','2013-06-11','11:20:00',4.41),('8784','2013-06-11','11:25:00',4.42),('8784','2013-06-11','11:30:00',4.42),('8784','2013-06-11','11:35:00',4.42),('8784','2013-06-11','11:40:00',4.42),('8784','2013-06-11','11:45:00',4.5),('8784','2013-06-11','11:50:00',4.55),('8784','2013-06-11','11:55:00',4.55),('8784','2013-06-11','12:00:00',4.6),('8784','2013-06-11','12:05:00',4.67),('8784','2013-06-11','12:10:00',4.62),('8784','2013-06-11','12:15:00',4.63),('8784','2013-06-11','12:20:00',4.68),('8784','2013-06-11','12:25:00',4.63),('8784','2013-06-11','12:30:00',4.66),('8784','2013-06-11','12:35:00',4.67),('8784','2013-06-11','12:40:00',4.68),('8784','2013-06-11','12:45:00',4.7),('8784','2013-06-11','12:50:00',4.75),('8784','2013-06-11','12:55:00',4.73),('8784','2013-06-11','13:00:00',4.71),('8784','2013-06-11','13:05:00',4.73),('8784','2013-06-11','13:10:00',4.74),('8784','2013-06-11','13:15:00',4.77),('8784','2013-06-11','13:20:00',4.74),('8784','2013-06-11','13:25:00',4.73),('8784','2013-06-11','13:30:00',4.75),('8784','2013-06-11','13:35:00',4.7),('8784','2013-06-11','13:40:00',4.76),('8784','2013-06-11','13:45:00',4.3),('8784','2013-06-11','13:50:00',3.5),('8784','2013-06-11','13:55:00',4.74),('8784','2013-06-11','14:00:00',4.72),('8784','2013-06-11','14:05:00',4.62),('8784','2013-06-11','14:10:00',4.59),('8784','2013-06-11','14:15:00',4.54),('8784','2013-06-11','14:20:00',4.51),('8784','2013-06-11','14:25:00',4.49),('8784','2013-06-11','14:30:00',4.46),('8784','2013-06-11','14:35:00',4.41),('8784','2013-06-11','14:40:00',4.34),('8784','2013-06-11','14:45:00',4.39),('8784','2013-06-11','14:50:00',4.34),('8784','2013-06-11','14:55:00',4.28),('8784','2013-06-11','15:00:00',4.26),('8784','2013-06-11','15:05:00',4.24),('8784','2013-06-11','15:10:00',4.22),('8784','2013-06-11','15:15:00',4.16),('8784','2013-06-11','15:20:00',4.12),('8784','2013-06-11','15:25:00',4.04),('8784','2013-06-11','15:30:00',4.04),('8784','2013-06-11','15:35:00',4.05),('8784','2013-06-11','15:40:00',3.89),('8784','2013-06-11','15:45:00',4.08),('8784','2013-06-11','15:50:00',3.86),('8784','2013-06-11','15:55:00',3.86),('8784','2013-06-11','16:00:00',3.71),('8784','2013-06-11','16:05:00',3.74),('8784','2013-06-11','16:10:00',3.65),('8784','2013-06-11','16:15:00',3.59),('8784','2013-06-11','16:20:00',3.54),('8784','2013-06-11','16:25:00',3.43),('8784','2013-06-11','16:30:00',3.44),('8784','2013-06-11','16:35:00',3.38),('8784','2013-06-11','16:40:00',3.41),('8784','2013-06-11','16:45:00',3.57),('8784','2013-06-11','16:50:00',3.58),('8784','2013-06-11','16:55:00',3.44),('8784','2013-06-11','17:00:00',2.87),('8784','2013-06-11','17:05:00',1.89),('8784','2014-04-03','08:50:00',1.02),('8784','2014-04-03','08:55:00',1.17),('8784','2014-04-03','09:00:00',1.3),('8784','2014-04-03','09:05:00',1.41),('8784','2014-04-03','09:10:00',1.36),('8784','2014-04-03','09:15:00',1.25),('8784','2014-04-03','09:20:00',1.27),('8784','2014-04-03','09:25:00',1.35),('8784','2014-04-03','09:30:00',1.59),('8784','2014-04-03','09:35:00',1.89),('8784','2014-04-03','09:40:00',2),('8784','2014-04-03','09:45:00',1.97),('8784','2014-04-03','09:50:00',1.87),('8784','2014-04-03','09:55:00',1.97),('8784','2014-04-03','10:00:00',2.33),('8784','2014-04-03','10:05:00',2.69),('8784','2014-04-03','10:10:00',2.85),('8784','2014-04-03','10:15:00',3.23),('8784','2014-04-03','10:20:00',3.25),('8784','2014-04-03','10:25:00',2.89),('8784','2014-04-03','10:30:00',2.77),('8784','2014-04-03','10:35:00',2.97),('8784','2014-04-03','10:40:00',2.35),('8784','2014-04-03','10:45:00',2.54),('8784','2014-04-03','10:50:00',2.22),('8784','2014-04-03','10:55:00',2.31),('8784','2014-04-03','11:00:00',2.17),('8784','2014-04-03','11:05:00',1.84),('8784','2014-04-03','11:10:00',1.75),('8784','2014-04-03','11:15:00',1.64),('8784','2014-04-03','11:20:00',1.57),('8784','2014-04-03','11:25:00',1.45),('8784','2014-04-03','11:30:00',1.44),('8784','2014-04-03','11:35:00',1.53),('8784','2014-04-03','11:40:00',1.67),('8784','2014-04-03','11:45:00',1.91),('8784','2014-04-03','11:50:00',2.32),('8784','2014-04-03','11:55:00',2.54),('8784','2014-04-03','12:00:00',2.42),('8784','2014-04-03','12:05:00',2.44),('8784','2014-04-03','12:10:00',2.37),('8784','2014-04-03','12:15:00',2.32),('8784','2014-04-03','12:20:00',2.6),('8784','2014-04-03','12:25:00',3.16),('8784','2014-04-03','12:30:00',3.93),('8784','2014-04-03','12:35:00',3.87),('8784','2014-04-03','12:40:00',4.3),('8784','2014-04-03','12:45:00',2.42),('8784','2014-04-03','12:50:00',2.93),('8784','2014-04-03','12:55:00',2.83),('8784','2014-04-03','13:00:00',2.74),('8784','2014-04-03','13:05:00',3.47),('8784','2014-04-03','13:10:00',2.68),('8784','2014-04-03','13:15:00',4.7),('8784','2014-04-03','13:20:00',2.83),('8784','2014-04-03','13:25:00',2.95),('8784','2014-04-03','13:30:00',3.01),('8784','2014-04-03','13:35:00',4.67),('8784','2014-04-03','13:40:00',4.03),('8784','2014-04-03','13:45:00',2.25),('8784','2014-04-03','13:50:00',2.26),('8784','2014-04-03','13:55:00',2.76),('8784','2014-04-03','14:00:00',3.84),('8784','2014-04-03','14:05:00',3.55),('8784','2014-04-03','14:10:00',2.81),('8784','2014-04-03','14:15:00',3.72),('8784','2014-04-03','14:20:00',3.77),('8784','2014-04-03','14:25:00',3.89),('8784','2014-04-03','14:30:00',3.93),('8784','2014-04-03','14:35:00',3.97),('8784','2014-04-03','14:40:00',3.82),('8784','2014-04-03','14:45:00',3.74),('8784','2014-04-03','14:50:00',3.68),('8784','2014-04-03','14:55:00',3.57),('8784','2014-04-03','15:00:00',3.51),('8784','2014-04-03','15:05:00',3.49),('8784','2014-04-03','15:10:00',3.45),('8784','2014-04-03','15:15:00',3.43),('8784','2014-04-03','15:20:00',3.42),('8784','2014-04-03','15:25:00',3.39),('8784','2014-04-03','15:30:00',3.34),('8784','2014-04-03','15:35:00',3.27),('8784','2014-04-03','15:40:00',3.24),('8784','2014-04-03','15:45:00',3.19),('8784','2014-04-03','15:50:00',3.13),('8784','2014-04-03','15:55:00',3.1),('8784','2014-04-03','16:00:00',3.08),('8784','2014-04-03','16:05:00',2.99),('8784','2014-04-03','16:10:00',2.97),('8784','2014-04-03','16:15:00',2.85),('8784','2014-04-03','16:20:00',2.81),('8784','2014-04-03','16:25:00',2.7),('8784','2014-04-03','16:30:00',2.62),('8784','2014-04-03','16:35:00',2.56),('8784','2014-04-03','16:40:00',2.49),('8784','2014-04-03','16:45:00',2.35),('8784','2014-04-03','16:50:00',1.74),('8784','2014-04-03','16:55:00',1.43),('8784','2014-04-03','17:00:00',1.1),('8784','2014-04-03','17:05:00',1),('8784','2014-04-03','17:25:00',1.02),('8784','2014-04-03','17:45:00',1.11),('8784','2014-04-03','17:50:00',1.33),('8784','2014-04-03','17:55:00',1.18),('8784','2014-04-03','18:00:00',1.07),('8784','2013-06-10','07:25:00',1.03),('8784','2013-06-10','07:30:00',1.37),('8784','2013-06-10','07:35:00',1.88),('8784','2013-06-10','07:40:00',1.1),('8784','2013-06-10','08:00:00',1.32),('8784','2013-06-10','08:05:00',1.85),('8784','2013-06-10','08:10:00',2.38),('8784','2013-06-10','08:15:00',1.74),('8784','2013-06-10','08:20:00',1.95),('8784','2013-06-10','08:25:00',1.7),('8784','2013-06-10','08:30:00',1.27),('8784','2013-06-10','08:35:00',1.14),('8784','2013-06-10','08:40:00',1.45),('8784','2013-06-10','08:55:00',1.15),('8784','2013-06-10','09:00:00',1.24),('8784','2013-06-10','09:05:00',1.2),('8784','2013-06-10','09:10:00',1.58),('8784','2013-06-10','09:15:00',1.41),('8784','2013-06-10','09:20:00',2.02),('8784','2013-06-10','09:25:00',3.07),('8784','2013-06-10','09:30:00',2.46),('8784','2013-06-10','09:35:00',3.56),('8784','2013-06-10','09:40:00',2.02),('8784','2013-06-10','09:45:00',3.64),('8784','2013-06-10','09:50:00',2.05),('8784','2013-06-10','09:55:00',1.73),('8784','2013-06-10','10:00:00',2.39),('8784','2013-06-10','10:05:00',2.46),('8784','2013-06-10','10:10:00',1.58),('8784','2013-06-10','10:15:00',2.26),('8784','2013-06-10','10:20:00',2.35),('8784','2013-06-10','10:25:00',1.82),('8784','2013-06-10','10:30:00',1.57),('8784','2013-06-10','10:35:00',2.01),('8784','2013-06-10','10:40:00',1.73),('8784','2013-06-10','10:45:00',1.34),('8784','2013-06-10','10:50:00',1.92),('8784','2013-06-10','10:55:00',3.76),('8784','2013-06-10','11:00:00',2.61),('8784','2013-06-10','11:05:00',2.43),('8784','2013-06-10','11:10:00',2.88),('8784','2013-06-10','11:15:00',4.12),('8784','2013-06-10','11:20:00',4.51),('8784','2013-06-10','11:25:00',4.06),('8784','2013-06-10','11:30:00',4.38),('8784','2013-06-10','11:35:00',4.53),('8784','2013-06-10','11:40:00',2.91),('8784','2013-06-10','11:45:00',3.63),('8784','2013-06-10','11:50:00',2.02),('8784','2013-06-10','11:55:00',4.6),('8784','2013-06-10','12:00:00',4.13),('8784','2013-06-10','12:05:00',1.51),('8784','2013-06-10','12:10:00',4.75),('8784','2013-06-10','12:15:00',4.67),('8784','2013-06-10','12:20:00',4.87),('8784','2013-06-10','12:25:00',5.05),('8784','2013-06-10','12:30:00',5.17),('8784','2013-06-10','12:35:00',4.23),('8784','2013-06-10','12:40:00',3.5),('8784','2013-06-10','12:45:00',3.26),('8784','2013-06-10','12:50:00',2.71),('8784','2013-06-10','12:55:00',3.62),('8784','2013-06-10','13:00:00',5.6),('8784','2013-06-10','13:05:00',4.1),('8784','2013-06-10','13:10:00',2.32),('8784','2013-06-10','13:15:00',4.49),('8784','2013-06-10','13:20:00',3.56),('8784','2013-06-10','13:25:00',2.97),('8784','2013-06-10','13:30:00',2.71),('8784','2013-06-10','13:35:00',4.72),('8784','2013-06-10','13:40:00',3.55),('8784','2013-06-10','13:45:00',3.83),('8784','2013-06-10','13:50:00',3.83),('8784','2013-06-10','13:55:00',4.81),('8784','2013-06-10','14:00:00',4.47),('8784','2013-06-10','14:05:00',4.92),('8784','2013-06-10','14:10:00',4.16),('8784','2013-06-10','14:15:00',4.75),('8784','2013-06-10','14:20:00',4.65),('8784','2013-06-10','14:25:00',4.57),('8784','2013-06-10','14:30:00',4.47),('8784','2013-06-10','14:35:00',4.49),('8784','2013-06-10','14:40:00',3.99),('8784','2013-06-10','14:45:00',4.45),('8784','2013-06-10','14:50:00',4.37),('8784','2013-06-10','14:55:00',4.34),('8784','2013-06-10','15:00:00',4.3),('8784','2013-06-10','15:05:00',4.18),('8784','2013-06-10','15:10:00',4.22),('8784','2013-06-10','15:15:00',4.19),('8784','2013-06-10','15:20:00',4.15),('8784','2013-06-10','15:25:00',4.12),('8784','2013-06-10','15:30:00',4.09),('8784','2013-06-10','15:35:00',4.06),('8784','2013-06-10','15:40:00',4.01),('8784','2013-06-10','15:45:00',3.96),('8784','2013-06-10','15:50:00',3.9),('8784','2013-06-10','15:55:00',3.85),('8784','2013-06-10','16:00:00',3.77),('8784','2013-06-10','16:05:00',3.71),('8784','2013-06-10','16:10:00',3.66),('8784','2013-06-10','16:15:00',3.61),('8784','2013-06-10','16:20:00',3.51),('8784','2013-06-10','16:25:00',3.47),('8784','2013-06-10','16:30:00',3.39),('8784','2013-06-10','16:35:00',3.34),('8784','2013-06-10','16:40:00',3.26),('8784','2013-06-10','16:45:00',3.19),('8784','2013-06-10','16:50:00',3.13),('8784','2013-06-10','16:55:00',3.04),('8784','2013-06-10','17:00:00',2.99),('8784','2013-06-10','17:05:00',2.93),('8784','2013-06-10','17:10:00',2.85),('8784','2013-06-10','17:15:00',2.78),('8784','2013-06-10','17:20:00',2.7),('8784','2013-06-10','17:25:00',2.61),('8784','2013-06-10','17:30:00',2.52),('8784','2013-06-10','17:35:00',2.44),('8784','2013-06-10','17:40:00',2.33),('8784','2013-06-10','17:45:00',2.26),('8784','2013-06-10','17:50:00',2.18),('8784','2013-06-10','17:55:00',2.09),('8784','2013-06-10','18:00:00',2.02),('8784','2013-06-10','18:05:00',1.92),('8784','2013-06-10','18:10:00',1.81),('8784','2013-06-10','18:15:00',1.74),('8784','2013-06-10','18:20:00',1.66),('8784','2013-06-10','18:25:00',1.57),('8784','2013-06-10','18:30:00',1.48),('8784','2013-06-10','18:35:00',1.39),('8784','2013-06-10','18:40:00',1.3),('8784','2013-06-10','18:45:00',1.22),('8784','2013-06-10','18:50:00',1.14),('8784','2013-06-10','18:55:00',1.05),('8784','2013-06-09','07:35:00',1.42),('8784','2013-06-09','07:40:00',1.32),('8784','2013-06-09','07:50:00',1.18),('8784','2013-06-09','07:55:00',1.65),('8784','2013-06-09','08:00:00',1.69),('8784','2013-06-09','08:05:00',1.74),('8784','2013-06-09','08:10:00',1.89),('8784','2013-06-09','08:15:00',1.53),('8784','2013-06-09','08:20:00',1.33),('8784','2013-06-09','08:25:00',2.2),('8784','2013-06-09','08:30:00',2.28),('8784','2013-06-09','08:35:00',2.37),('8784','2013-06-09','08:40:00',2.4),('8784','2013-06-09','08:45:00',2.45),('8784','2013-06-09','08:50:00',2.57),('8784','2013-06-09','08:55:00',2.63),('8784','2013-06-09','09:00:00',2.68),('8784','2013-06-09','09:05:00',2.74),('8784','2013-06-09','09:10:00',2.77),('8784','2013-06-09','09:15:00',2.89),('8784','2013-06-09','09:20:00',2.92),('8784','2013-06-09','09:25:00',3.02),('8784','2013-06-09','09:30:00',3.12),('8784','2013-06-09','09:35:00',3.14),('8784','2013-06-09','09:40:00',3.14),('8784','2013-06-09','09:45:00',3.21),('8784','2013-06-09','09:50:00',3.33),('8784','2013-06-09','09:55:00',3.39),('8784','2013-06-09','10:00:00',3.42),('8784','2013-06-09','10:05:00',3.46),('8784','2013-06-09','10:10:00',3.52),('8784','2013-06-09','10:15:00',3.55),('8784','2013-06-09','10:20:00',3.57),('8784','2013-06-09','10:25:00',3.61),('8784','2013-06-09','10:30:00',3.73),('8784','2013-06-09','10:35:00',3.77),('8784','2013-06-09','10:40:00',3.81),('8784','2013-06-09','10:45:00',3.81),('8784','2013-06-09','10:50:00',3.87),('8784','2013-06-09','10:55:00',3.88),('8784','2013-06-09','11:00:00',3.87),('8784','2013-06-09','11:05:00',3.87),('8784','2013-06-09','11:10:00',3.93),('8784','2013-06-09','11:15:00',4.03),('8784','2013-06-09','11:20:00',4),('8784','2013-06-09','11:25:00',4),('8784','2013-06-09','11:30:00',4.02),('8784','2013-06-09','11:35:00',4.07),('8784','2013-06-09','11:40:00',4.11),('8784','2013-06-09','11:45:00',4.22),('8784','2013-06-09','11:50:00',4.21),('8784','2013-06-09','11:55:00',4.15),('8784','2013-06-09','12:00:00',4.18),('8784','2013-06-09','12:05:00',4.22),('8784','2013-06-09','12:10:00',3.69),('8784','2013-06-09','12:15:00',4.18),('8784','2013-06-09','12:20:00',4.21),('8784','2013-06-09','12:25:00',4.26),('8784','2013-06-09','12:30:00',4.27),('8784','2013-06-09','12:35:00',4.22),('8784','2013-06-09','12:40:00',4.27),('8784','2013-06-09','12:45:00',4.23),('8784','2013-06-09','12:50:00',4.44),('8784','2013-06-09','12:55:00',4.05),('8784','2013-06-09','13:00:00',4.03),('8784','2013-06-09','13:05:00',3.22),('8784','2013-06-09','13:10:00',2.26),('8784','2013-06-09','13:15:00',2.73),('8784','2013-06-09','13:20:00',3.51),('8784','2013-06-09','13:25:00',4.72),('8784','2013-06-09','13:30:00',4.5),('8784','2013-06-09','13:35:00',4.57),('8784','2013-06-09','13:40:00',4.73),('8784','2013-06-09','13:45:00',4.76),('8784','2013-06-09','13:50:00',4.94),('8784','2013-06-09','13:55:00',4.31),('8784','2013-06-09','14:00:00',4.61),('8784','2013-06-09','14:05:00',4.59),('8784','2013-06-09','14:10:00',4.48),('8784','2013-06-09','14:15:00',3),('8784','2013-06-09','14:20:00',1.93),('8784','2013-06-09','14:25:00',1.24),('8784','2013-06-09','14:30:00',1.68),('8784','2013-06-09','14:35:00',4.03),('8784','2013-06-09','14:40:00',4.23),('8784','2013-06-09','14:45:00',4.11),('8784','2013-06-09','14:50:00',4.28),('8784','2013-06-09','14:55:00',4.3),('8784','2013-06-09','15:00:00',4.21),('8784','2013-06-09','15:05:00',4.03),('8784','2013-06-09','15:10:00',4.07),('8784','2013-06-09','15:15:00',3.97),('8784','2013-06-09','15:20:00',3.92),('8784','2013-06-09','15:25:00',3.93),('8784','2013-06-09','15:30:00',3.74),('8784','2013-06-09','15:35:00',3.8),('8784','2013-06-09','15:40:00',3.04),('8784','2013-06-09','15:45:00',3.16),('8784','2013-06-09','15:50:00',3.57),('8784','2013-06-09','15:55:00',3.75),('8784','2013-06-09','16:00:00',2.48),('8784','2013-06-09','16:05:00',3.46),('8784','2013-06-09','16:10:00',3.34),('8784','2013-06-09','16:15:00',1.56),('8784','2013-06-09','16:20:00',1.68),('8784','2013-06-09','16:25:00',2.38),('8784','2013-06-09','16:30:00',1.46),('8784','2013-06-09','16:35:00',1.05),('8784','2013-06-09','16:40:00',1.02),('8784','2013-06-09','16:45:00',1.03),('8784','2013-06-09','17:05:00',1.08),('8784','2013-06-09','17:10:00',1.05),('8784','2013-06-09','18:00:00',1.09),('8784','2013-06-09','18:10:00',1.52),('8784','2013-06-09','18:15:00',1.05),('8784','2013-06-09','18:30:00',1),('8784','2013-06-08','07:15:00',1.04),('8784','2013-06-08','07:20:00',1.12),('8784','2013-06-08','07:25:00',1.2),('8784','2013-06-08','07:30:00',1.25),('8784','2013-06-08','07:35:00',1.35),('8784','2013-06-08','07:40:00',1.45),('8784','2013-06-08','07:45:00',1.52),('8784','2013-06-08','07:50:00',1.6),('8784','2013-06-08','07:55:00',1.67),('8784','2013-06-08','08:00:00',1.73),('8784','2013-06-08','08:05:00',1.83),('8784','2013-06-08','08:10:00',1.92),('8784','2013-06-08','08:15:00',2),('8784','2013-06-08','08:20:00',2.09),('8784','2013-06-08','08:25:00',2.16),('8784','2013-06-08','08:30:00',2.25),('8784','2013-06-08','08:35:00',2.33),('8784','2013-06-08','08:40:00',2.41),('8784','2013-06-08','08:45:00',2.5),('8784','2013-06-08','08:50:00',2.58),('8784','2013-06-08','08:55:00',2.64),('8784','2013-06-08','09:00:00',2.68),('8784','2013-06-08','09:05:00',2.76),('8784','2013-06-08','09:10:00',2.83),('8784','2013-06-08','09:15:00',2.88),('8784','2013-06-08','09:20:00',2.93),('8784','2013-06-08','09:25:00',2.98),('8784','2013-06-08','09:30:00',3.09),('8784','2013-06-08','09:35:00',3.14),('8784','2013-06-08','09:40:00',3.21),('8784','2013-06-08','09:45:00',3.26),('8784','2013-06-08','09:50:00',3.35),('8784','2013-06-08','09:55:00',3.45),('8784','2013-06-08','10:00:00',3.45),('8784','2013-06-08','10:05:00',3.43),('8784','2013-06-08','10:10:00',3.62),('8784','2013-06-08','10:15:00',3.43),('8784','2013-06-08','10:20:00',3.65),('8784','2013-06-08','10:25:00',3.57),('8784','2013-06-08','10:30:00',3.37),('8784','2013-06-08','10:35:00',3.79),('8784','2013-06-08','10:40:00',3.96),('8784','2013-06-08','10:45:00',4),('8784','2013-06-08','10:50:00',4.19),('8784','2013-06-08','10:55:00',2),('8784','2013-06-08','11:00:00',2.13),('8784','2013-06-08','11:05:00',4.02),('8784','2013-06-08','11:10:00',2.66),('8784','2013-06-08','11:15:00',4.8),('8784','2013-06-08','11:20:00',4.65),('8784','2013-06-08','11:25:00',1.93),('8784','2013-06-08','11:30:00',1.17),('8784','2013-06-08','11:35:00',4.44),('8784','2013-06-08','11:40:00',4.69),('8784','2013-06-08','11:45:00',2.71),('8784','2013-06-08','11:50:00',4.42),('8784','2013-06-08','11:55:00',3.62),('8784','2013-06-08','12:00:00',4.69),('8784','2013-06-08','12:05:00',1.24),('8784','2013-06-08','12:10:00',3.59),('8784','2013-06-08','12:15:00',3.38),('8784','2013-06-08','12:20:00',1.28),('8784','2013-06-08','12:25:00',3.14),('8784','2013-06-08','12:30:00',1.2),('8784','2013-06-08','12:35:00',3.91),('8784','2013-06-08','12:40:00',4.62),('8784','2013-06-08','12:45:00',4.16),('8784','2013-06-08','12:50:00',4.75),('8784','2013-06-08','12:55:00',4.61),('8784','2013-06-08','13:00:00',4.69),('8784','2013-06-08','13:05:00',4.63),('8784','2013-06-08','13:10:00',4.16),('8784','2013-06-08','13:15:00',4.17),('8784','2013-06-08','13:20:00',4.75),('8784','2013-06-08','13:25:00',4.7),('8784','2013-06-08','13:30:00',4.76),('8784','2013-06-08','13:35:00',4.61),('8784','2013-06-08','13:40:00',4.59),('8784','2013-06-08','13:45:00',4.56),('8784','2013-06-08','13:50:00',4.55),('8784','2013-06-08','13:55:00',4.51),('8784','2013-06-08','14:00:00',4.53),('8784','2013-06-08','14:05:00',4.52),('8784','2013-06-08','14:10:00',4.52),('8784','2013-06-08','14:15:00',4.47),('8784','2013-06-08','14:20:00',4.43),('8784','2013-06-08','14:25:00',4.43),('8784','2013-06-08','14:30:00',4.38),('8784','2013-06-08','14:35:00',4.34),('8784','2013-06-08','14:40:00',4.35),('8784','2013-06-08','14:45:00',4.31),('8784','2013-06-08','14:50:00',4.31),('8784','2013-06-08','14:55:00',4.28),('8784','2013-06-08','15:00:00',4.26),('8784','2013-06-08','15:05:00',4.1),('8784','2013-06-08','15:10:00',3.78),('8784','2013-06-08','15:15:00',3.97),('8784','2013-06-08','15:20:00',4.11),('8784','2013-06-08','15:25:00',3.84),('8784','2013-06-08','15:30:00',3.9),('8784','2013-06-08','15:35:00',3.9),('8784','2013-06-08','15:40:00',3.85),('8784','2013-06-08','15:45:00',4.01),('8784','2013-06-08','15:50:00',4.03),('8784','2013-06-08','15:55:00',3.67),('8784','2013-06-08','16:00:00',3.77),('8784','2013-06-08','16:05:00',3.76),('8784','2013-06-08','16:10:00',3.75),('8784','2013-06-08','16:15:00',3.72),('8784','2013-06-08','16:20:00',3.63),('8784','2013-06-08','16:25:00',3.47),('8784','2013-06-08','16:30:00',3.3),('8784','2013-06-08','16:35:00',3.21),('8784','2013-06-08','16:40:00',3.17),('8784','2013-06-08','16:45:00',3.1),('8784','2013-06-08','16:50:00',2.63),('8784','2013-06-08','16:55:00',2.69),('8784','2013-06-08','17:00:00',2.95),('8784','2013-06-08','17:05:00',2.81),('8784','2013-06-08','17:10:00',3.09),('8784','2013-06-08','17:15:00',3.03),('8784','2013-06-08','17:20:00',2.87),('8784','2013-06-08','17:25:00',2.67),('8784','2013-06-08','17:30:00',1.95),('8784','2013-06-08','17:35:00',1.48),('8784','2013-06-08','17:40:00',2.26),('8784','2013-06-08','17:45:00',2.38),('8784','2013-06-08','17:50:00',2.18),('8784','2013-06-08','17:55:00',2.2),('8784','2013-06-08','18:00:00',1.8),('8784','2013-06-08','18:05:00',1.58),('8784','2013-06-08','18:10:00',1.31),('8784','2013-06-08','18:15:00',1.35),('8784','2013-06-08','18:20:00',1.29),('8784','2013-06-08','18:25:00',1.2),('8784','2013-06-07','07:10:00',1.01),('8784','2013-06-07','07:15:00',1.09),('8784','2013-06-07','07:20:00',1.18),('8784','2013-06-07','07:25:00',1.27),('8784','2013-06-07','07:30:00',1.35),('8784','2013-06-07','07:35:00',1.44),('8784','2013-06-07','07:40:00',1.53),('8784','2013-06-07','07:45:00',1.61),('8784','2013-06-07','07:50:00',1.71),('8784','2013-06-07','07:55:00',1.79),('8784','2013-06-07','08:00:00',1.87),('8784','2013-06-07','08:05:00',1.96),('8784','2013-06-07','08:10:00',2.04),('8784','2013-06-07','08:15:00',2.11),('8784','2013-06-07','08:20:00',2.22),('8784','2013-06-07','08:25:00',2.3),('8784','2013-06-07','08:30:00',2.38),('8784','2013-06-07','08:35:00',2.47),('8784','2013-06-07','08:40:00',2.56),('8784','2013-06-07','08:45:00',2.64),('8784','2013-06-07','08:50:00',2.72),('8784','2013-06-07','08:55:00',2.8),('8784','2013-06-07','09:00:00',2.84),('8784','2013-06-07','09:05:00',2.96),('8784','2013-06-07','09:10:00',3.03),('8784','2013-06-07','09:15:00',3.1),('8784','2013-06-07','09:20:00',3.16),('8784','2013-06-07','09:25:00',3.23),('8784','2013-06-07','09:30:00',3.3),('8784','2013-06-07','09:35:00',3.36),('8784','2013-06-07','09:40:00',3.44),('8784','2013-06-07','09:45:00',3.53),('8784','2013-06-07','09:50:00',3.6),('8784','2013-06-07','09:55:00',3.64),('8784','2013-06-07','10:00:00',3.71),('8784','2013-06-07','10:05:00',3.76),('8784','2013-06-07','10:10:00',3.81),('8784','2013-06-07','10:15:00',3.82),('8784','2013-06-07','10:20:00',3.92),('8784','2013-06-07','10:25:00',3.96),('8784','2013-06-07','10:30:00',3.99),('8784','2013-06-07','10:35:00',4.02),('8784','2013-06-07','10:40:00',4.06),('8784','2013-06-07','10:45:00',4.08),('8784','2013-06-07','10:50:00',4.13),('8784','2013-06-07','10:55:00',4.18),('8784','2013-06-07','11:00:00',4.24),('8784','2013-06-07','11:05:00',4.27),('8784','2013-06-07','11:10:00',4.31),('8784','2013-06-07','11:15:00',4.31),('8784','2013-06-07','11:20:00',4.33),('8784','2013-06-07','11:25:00',4.35),('8784','2013-06-07','11:30:00',4.43),('8784','2013-06-07','11:35:00',4.45),('8784','2013-06-07','11:40:00',4.48),('8784','2013-06-07','11:45:00',4.51),('8784','2013-06-07','11:50:00',4.52),('8784','2013-06-07','11:55:00',4.53),('8784','2013-06-07','12:00:00',4.55),('8784','2013-06-07','12:05:00',4.5),('8784','2013-06-07','12:10:00',4.57),('8784','2013-06-07','12:15:00',4.57),('8784','2013-06-07','12:20:00',4.59),('8784','2013-06-07','12:25:00',4.58),('8784','2013-06-07','12:30:00',4.6),('8784','2013-06-07','12:35:00',4.6),('8784','2013-06-07','12:40:00',4.59),('8784','2013-06-07','12:45:00',4.62),('8784','2013-06-07','12:50:00',4.62),('8784','2013-06-07','12:55:00',4.61),('8784','2013-06-07','13:00:00',4.62),('8784','2013-06-07','13:05:00',4.61),('8784','2013-06-07','13:10:00',4.59),('8784','2013-06-07','13:15:00',4.56),('8784','2013-06-07','13:20:00',4.56),('8784','2013-06-07','13:25:00',4.57),('8784','2013-06-07','13:30:00',4.57),('8784','2013-06-07','13:35:00',4.54),('8784','2013-06-07','13:40:00',4.48),('8784','2013-06-07','13:45:00',4.45),('8784','2013-06-07','13:50:00',4.43),('8784','2013-06-07','13:55:00',4.45),('8784','2013-06-07','14:00:00',4.41),('8784','2013-06-07','14:05:00',4.37),('8784','2013-06-07','14:10:00',4.36),('8784','2013-06-07','14:15:00',4.33),('8784','2013-06-07','14:20:00',4.27),('8784','2013-06-07','14:25:00',4.24),('8784','2013-06-07','14:30:00',4.22),('8784','2013-06-07','14:35:00',4.17),('8784','2013-06-07','14:40:00',4.19),('8784','2013-06-07','14:45:00',4.18),('8784','2013-06-07','14:50:00',4.16),('8784','2013-06-07','14:55:00',4.09),('8784','2013-06-07','15:00:00',4.07),('8784','2013-06-07','15:05:00',4.06),('8784','2013-06-07','15:10:00',4.06),('8784','2013-06-07','15:15:00',3.99),('8784','2013-06-07','15:20:00',3.96),('8784','2013-06-07','15:25:00',4),('8784','2013-06-07','15:30:00',3.98),('8784','2013-06-07','15:35:00',3.91),('8784','2013-06-07','15:40:00',3.85),('8784','2013-06-07','15:45:00',3.81),('8784','2013-06-07','15:50:00',3.75),('8784','2013-06-07','15:55:00',3.7),('8784','2013-06-07','16:00:00',3.64),('8784','2013-06-07','16:05:00',3.58),('8784','2013-06-07','16:10:00',3.45),('8784','2013-06-07','16:15:00',3.27),('8784','2013-06-07','16:20:00',3.27),('8784','2013-06-07','16:25:00',3.32),('8784','2013-06-07','16:30:00',3.29),('8784','2013-06-07','16:35:00',3.24),('8784','2013-06-07','16:40:00',3.16),('8784','2013-06-07','16:45:00',3.1),('8784','2013-06-07','16:50:00',3.02),('8784','2013-06-07','16:55:00',2.98),('8784','2013-06-07','17:00:00',2.9),('8784','2013-06-07','17:05:00',2.82),('8784','2013-06-07','17:10:00',2.77),('8784','2013-06-07','17:15:00',2.62),('8784','2013-06-07','17:20:00',2.56),('8784','2013-06-07','17:25:00',2.51),('8784','2013-06-07','17:30:00',2.44),('8784','2013-06-07','17:35:00',2.36),('8784','2013-06-07','17:40:00',2.3),('8784','2013-06-07','17:45:00',2.25),('8784','2013-06-07','17:50:00',2.23),('8784','2013-06-07','17:55:00',2.11),('8784','2013-06-07','18:00:00',1.98),('8784','2013-06-07','18:05:00',1.89),('8784','2013-06-07','18:10:00',1.78),('8784','2013-06-07','18:15:00',1.65),('8784','2013-06-07','18:20:00',1.54),('8784','2013-06-07','18:25:00',1.39),('8784','2013-06-07','18:30:00',1.34),('8784','2013-06-07','18:35:00',1.26),('8784','2013-06-07','18:40:00',1.18),('8784','2013-06-07','18:45:00',1.08),('8784','2013-06-07','18:50:00',1.01),('8784','2013-06-06','07:00:00',1.17),('8784','2013-06-06','07:05:00',1.29),('8784','2013-06-06','07:10:00',1.15),('8784','2013-06-06','07:15:00',1.32),('8784','2013-06-06','07:50:00',1.41),('8784','2013-06-06','07:55:00',1.87),('8784','2013-06-06','08:00:00',1.91),('8784','2013-06-06','08:05:00',1.47),('8784','2013-06-06','08:10:00',1.96),('8784','2013-06-06','08:15:00',1.57),('8784','2013-06-06','08:20:00',1.91),('8784','2013-06-06','08:25:00',2.3),('8784','2013-06-06','08:30:00',2.37),('8784','2013-06-06','08:35:00',2.43),('8784','2013-06-06','08:40:00',2.5),('8784','2013-06-06','08:45:00',2.55),('8784','2013-06-06','08:50:00',2.65),('8784','2013-06-06','08:55:00',2.7),('8784','2013-06-06','09:00:00',2.82),('8784','2013-06-06','09:05:00',2.89),('8784','2013-06-06','09:10:00',2.95),('8784','2013-06-06','09:15:00',3.04),('8784','2013-06-06','09:20:00',3.1),('8784','2013-06-06','09:25:00',3.17),('8784','2013-06-06','09:30:00',3.22),('8784','2013-06-06','09:35:00',3.24),('8784','2013-06-06','09:40:00',3.31),('8784','2013-06-06','09:45:00',3.4),('8784','2013-06-06','09:50:00',3.47),('8784','2013-06-06','09:55:00',3.53),('8784','2013-06-06','10:00:00',3.54),('8784','2013-06-06','10:05:00',3.49),('8784','2013-06-06','10:10:00',3.62),('8784','2013-06-06','10:15:00',3.69),('8784','2013-06-06','10:20:00',3.78),('8784','2013-06-06','10:25:00',3.76),('8784','2013-06-06','10:30:00',3.86),('8784','2013-06-06','10:35:00',3.85),('8784','2013-06-06','10:40:00',3.94),('8784','2013-06-06','10:45:00',3.98),('8784','2013-06-06','10:50:00',4.04),('8784','2013-06-06','10:55:00',4.11),('8784','2013-06-06','11:00:00',4.13),('8784','2013-06-06','11:05:00',4.08),('8784','2013-06-06','11:10:00',4.13),('8784','2013-06-06','11:15:00',4.14),('8784','2013-06-06','11:20:00',4.11),('8784','2013-06-06','11:25:00',4.26),('8784','2013-06-06','11:30:00',4.31),('8784','2013-06-06','11:35:00',4.32),('8784','2013-06-06','11:40:00',4.29),('8784','2013-06-06','11:45:00',4.34),('8784','2013-06-06','11:50:00',4.38),('8784','2013-06-06','11:55:00',4.41),('8784','2013-06-06','12:00:00',4.45),('8784','2013-06-06','12:05:00',4.43),('8784','2013-06-06','12:10:00',4.39),('8784','2013-06-06','12:15:00',4.38),('8784','2013-06-06','12:20:00',4.39),('8784','2013-06-06','12:25:00',4.42),('8784','2013-06-06','12:30:00',4.42),('8784','2013-06-06','12:35:00',4.38),('8784','2013-06-06','12:40:00',4.4),('8784','2013-06-06','12:45:00',4.43),('8784','2013-06-06','12:50:00',4.52),('8784','2013-06-06','12:55:00',4.5),('8784','2013-06-06','13:00:00',4.49),('8784','2013-06-06','13:05:00',4.53),('8784','2013-06-06','13:10:00',4.57),('8784','2013-06-06','13:15:00',4.59),('8784','2013-06-06','13:20:00',4.55),('8784','2013-06-06','13:25:00',3.96),('8784','2013-06-06','13:30:00',4.67),('8784','2013-06-06','13:35:00',4.57),('8784','2013-06-06','13:40:00',1.48),('8784','2013-06-06','13:50:00',1.68),('8784','2013-06-06','13:55:00',4.17),('8784','2013-06-06','14:00:00',4.35),('8784','2013-06-06','14:05:00',2.44),('8784','2013-06-06','14:10:00',2.6),('8784','2013-06-06','14:15:00',4.65),('8784','2013-06-06','14:20:00',3.36),('8784','2013-06-06','14:25:00',3.48),('8784','2013-06-06','14:30:00',3.72),('8784','2013-06-06','14:35:00',4.29),('8784','2013-06-06','14:40:00',4.47),('8784','2013-06-06','14:45:00',3.52),('8784','2013-06-06','14:50:00',4.59),('8784','2013-06-06','14:55:00',4.3),('8784','2013-06-06','15:00:00',4.18),('8784','2013-06-06','15:05:00',4.25),('8784','2013-06-06','15:10:00',4.2),('8784','2013-06-06','15:15:00',4.07),('8784','2013-06-06','15:20:00',4.06),('8784','2013-06-06','15:25:00',3.65),('8784','2013-06-06','15:30:00',3.83),('8784','2013-06-06','15:35:00',3.84),('8784','2013-06-06','15:40:00',3.85),('8784','2013-06-06','15:45:00',3.78),('8784','2013-06-06','15:50:00',3.71),('8784','2013-06-06','15:55:00',3.72),('8784','2013-06-06','16:00:00',3.59),('8784','2013-06-06','16:05:00',3.63),('8784','2013-06-06','16:10:00',3.52),('8784','2013-06-06','16:15:00',3.25),('8784','2013-06-06','16:20:00',3.28),('8784','2013-06-06','16:25:00',3.21),('8784','2013-06-06','16:30:00',3.16),('8784','2013-06-06','16:35:00',3.15),('8784','2013-06-06','16:40:00',3.1),('8784','2013-06-06','16:45:00',2.98),('8784','2013-06-06','16:50:00',2.92),('8784','2013-06-06','16:55:00',2.82),('8784','2013-06-06','17:00:00',2.72),('8784','2013-06-06','17:05:00',2.66),('8784','2013-06-06','17:10:00',2.6),('8784','2013-06-06','17:15:00',2.51),('8784','2013-06-06','17:20:00',2.43),('8784','2013-06-06','17:25:00',2.39),('8784','2013-06-06','17:30:00',2.33),('8784','2013-06-06','17:35:00',2.23),('8784','2013-06-06','17:40:00',2.15),('8784','2013-06-06','17:45:00',2.07),('8784','2013-06-06','17:50:00',1.96),('8784','2013-06-06','17:55:00',1.88),('8784','2013-06-06','18:00:00',1.81),('8784','2013-06-06','18:05:00',1.75),('8784','2013-06-06','18:10:00',1.65),('8784','2013-06-06','18:15:00',1.54),('8784','2013-06-06','18:20:00',1.45),('8784','2013-06-06','18:25:00',1.37),('8784','2013-06-06','18:30:00',1.29),('8784','2013-06-06','18:35:00',1.22),('8784','2013-06-06','18:40:00',1.16),('8784','2013-06-06','18:45:00',1.07),('8784','2013-06-05','07:25:00',1.06),('8784','2013-06-05','07:45:00',1.2),('8784','2013-06-05','07:50:00',1.75),('8784','2013-06-05','07:55:00',1.91),('8784','2013-06-05','08:00:00',2.03),('8784','2013-06-05','08:05:00',1.59),('8784','2013-06-05','08:10:00',1.84),('8784','2013-06-05','08:15:00',2.01),('8784','2013-06-05','08:20:00',2.09),('8784','2013-06-05','08:25:00',2.22),('8784','2013-06-05','08:30:00',2.32),('8784','2013-06-05','08:35:00',2.4),('8784','2013-06-05','08:40:00',2.49),('8784','2013-06-05','08:45:00',2.56),('8784','2013-06-05','08:50:00',2.66),('8784','2013-06-05','08:55:00',2.74),('8784','2013-06-05','09:00:00',2.79),('8784','2013-06-05','09:05:00',3),('8784','2013-06-05','09:10:00',2.71),('8784','2013-06-05','09:15:00',3.15),('8784','2013-06-05','09:20:00',3.43),('8784','2013-06-05','09:25:00',3.6),('8784','2013-06-05','09:30:00',3.11),('8784','2013-06-05','09:35:00',2.14),('8784','2013-06-05','09:40:00',3.51),('8784','2013-06-05','09:45:00',1.3),('8784','2013-06-05','09:50:00',1.35),('8784','2013-06-05','09:55:00',2.43),('8784','2013-06-05','10:00:00',4.12),('8784','2013-06-05','10:05:00',3.46),('8784','2013-06-05','10:10:00',3.43),('8784','2013-06-05','10:15:00',1.26),('8784','2013-06-05','10:20:00',1.6),('8784','2013-06-05','10:25:00',1.54),('8784','2013-06-05','10:30:00',1.63),('8784','2013-06-05','10:35:00',1.74),('8784','2013-06-05','10:40:00',4.53),('8784','2013-06-05','10:45:00',4.61),('8784','2013-06-05','10:50:00',4.43),('8784','2013-06-05','10:55:00',3.94),('8784','2013-06-05','11:00:00',2.89),('8784','2013-06-05','11:05:00',2.68),('8784','2013-06-05','11:10:00',1.51),('8784','2013-06-05','11:15:00',1.23),('8784','2013-06-05','11:20:00',1.15),('8784','2013-06-05','11:25:00',1.19),('8784','2013-06-05','11:30:00',1.34),('8784','2013-06-05','11:35:00',3.37),('8784','2013-06-05','11:40:00',4.99),('8784','2013-06-05','11:45:00',4.08),('8784','2013-06-05','11:50:00',1.98),('8784','2013-06-05','11:55:00',4.8),('8784','2013-06-05','12:00:00',5.04),('8784','2013-06-05','12:05:00',4.96),('8784','2013-06-05','12:10:00',4.99),('8784','2013-06-05','12:15:00',4.99),('8784','2013-06-05','12:20:00',5.22),('8784','2013-06-05','12:25:00',4.6),('8784','2013-06-05','12:30:00',4.84),('8784','2013-06-05','12:35:00',2.17),('8784','2013-06-05','12:40:00',4.6),('8784','2013-06-05','12:45:00',5.42),('8784','2013-06-05','12:50:00',2.09),('8784','2013-06-05','12:55:00',3.34),('8784','2013-06-05','13:00:00',5.77),('8784','2013-06-05','13:05:00',2.8),('8784','2013-06-05','13:10:00',4.19),('8784','2013-06-05','13:15:00',3.34),('8784','2013-06-05','13:20:00',2.86),('8784','2013-06-05','13:25:00',2.75),('8784','2013-06-05','13:30:00',4.49),('8784','2013-06-05','13:35:00',5.19),('8784','2013-06-05','13:40:00',4.92),('8784','2013-06-05','13:45:00',4.88),('8784','2013-06-05','13:50:00',4.79),('8784','2013-06-05','13:55:00',4.74),('8784','2013-06-05','14:00:00',4.69),('8784','2013-06-05','14:05:00',4.69),('8784','2013-06-05','14:10:00',4.61),('8784','2013-06-05','14:15:00',4.55),('8784','2013-06-05','14:20:00',4.51),('8784','2013-06-05','14:25:00',4.49),('8784','2013-06-05','14:30:00',4.15),('8784','2013-06-05','14:35:00',4.09),('8784','2013-06-05','14:40:00',4.44),('8784','2013-06-05','14:45:00',4.44),('8784','2013-06-05','14:50:00',4.37),('8784','2013-06-05','14:55:00',4.34),('8784','2013-06-05','15:00:00',4.24),('8784','2013-06-05','15:05:00',4.21),('8784','2013-06-05','15:10:00',4.2),('8784','2013-06-05','15:15:00',4.17),('8784','2013-06-05','15:20:00',4.13),('8784','2013-06-05','15:25:00',4.09),('8784','2013-06-05','15:30:00',4.14),('8784','2013-06-05','15:35:00',4.17),('8784','2013-06-05','15:40:00',4.05),('8784','2013-06-05','15:45:00',3.99),('8784','2013-06-05','15:50:00',3.92),('8784','2013-06-05','15:55:00',3.86),('8784','2013-06-05','16:00:00',3.81),('8784','2013-06-05','16:05:00',3.63),('8784','2013-06-05','16:10:00',3.31),('8784','2013-06-05','16:15:00',3.63),('8784','2013-06-05','16:20:00',3.51),('8784','2013-06-05','16:25:00',3.44),('8784','2013-06-05','16:30:00',3.38),('8784','2013-06-05','16:35:00',3.28),('8784','2013-06-05','16:40:00',3.17),('8784','2013-06-05','16:45:00',3.18),('8784','2013-06-05','16:50:00',3.08),('8784','2013-06-05','16:55:00',3.03),('8784','2013-06-05','17:00:00',1.5),('8784','2013-06-05','17:05:00',2.47),('8784','2013-06-05','17:10:00',1.43),('8784','2013-06-05','17:15:00',2.22),('8784','2013-06-05','17:20:00',2.05),('8784','2013-06-05','17:25:00',2.11),('8784','2013-06-05','17:30:00',2.07),('8784','2013-06-05','17:35:00',1.75),('8784','2013-06-05','17:40:00',2.3),('8784','2013-06-05','17:45:00',2.17),('8784','2013-06-05','17:50:00',2.06),('8784','2013-06-05','17:55:00',1.94),('8784','2013-06-05','18:00:00',1.79),('8784','2013-06-05','18:05:00',1.16),('8784','2013-06-05','18:10:00',1.33),('8784','2013-06-05','18:15:00',1.16),('8784','2013-06-05','18:25:00',1.46),('8784','2013-06-05','18:30:00',1.43),('8784','2013-06-05','18:35:00',1.45),('8784','2013-06-05','18:40:00',1.31),('8784','2013-06-05','18:55:00',1.01),('8784','2013-06-04','07:05:00',1.03),('8784','2013-06-04','07:10:00',1.09),('8784','2013-06-04','07:15:00',1.13),('8784','2013-06-04','07:20:00',1.16),('8784','2013-06-04','07:25:00',1.26),('8784','2013-06-04','07:30:00',1.35),('8784','2013-06-04','07:35:00',1.45),('8784','2013-06-04','07:40:00',1.62),('8784','2013-06-04','07:45:00',1.84),('8784','2013-06-04','07:50:00',2.01),('8784','2013-06-04','07:55:00',2.12),('8784','2013-06-04','08:00:00',2.33),('8784','2013-06-04','08:05:00',2.5),('8784','2013-06-04','08:10:00',2.51),('8784','2013-06-04','08:15:00',2.54),('8784','2013-06-04','08:20:00',2.54),('8784','2013-06-04','08:25:00',2.53),('8784','2013-06-04','08:30:00',2.81),('8784','2013-06-04','08:35:00',2.52),('8784','2013-06-04','08:40:00',2.18),('8784','2013-06-04','08:45:00',1.96),('8784','2013-06-04','08:50:00',1.57),('8784','2013-06-04','08:55:00',1.58),('8784','2013-06-04','09:00:00',1.86),('8784','2013-06-04','09:05:00',1.88),('8784','2013-06-04','09:10:00',2.63),('8784','2013-06-04','09:15:00',3.38),('8784','2013-06-04','09:20:00',3.7),('8784','2013-06-04','09:25:00',2.83),('8784','2013-06-04','09:30:00',3.43),('8784','2013-06-04','09:35:00',2.57),('8784','2013-06-04','09:40:00',2.19),('8784','2013-06-04','09:45:00',2.36),('8784','2013-06-04','09:50:00',2.06),('8784','2013-06-04','09:55:00',1.92),('8784','2013-06-04','10:00:00',2.18),('8784','2013-06-04','10:05:00',2.9),('8784','2013-06-04','10:10:00',2.67),('8784','2013-06-04','10:15:00',2),('8784','2013-06-04','10:20:00',2.09),('8784','2013-06-04','10:25:00',2.03),('8784','2013-06-04','10:30:00',1.86),('8784','2013-06-04','10:35:00',1.89),('8784','2013-06-04','10:40:00',2.08),('8784','2013-06-04','10:45:00',2.48),('8784','2013-06-04','10:50:00',3.23),('8784','2013-06-04','10:55:00',3),('8784','2013-06-04','11:00:00',2.44),('8784','2013-06-04','11:05:00',3.06),('8784','2013-06-04','11:10:00',4.16),('8784','2013-06-04','11:15:00',3.43),('8784','2013-06-04','11:20:00',2.46),('8784','2013-06-04','11:25:00',3.07),('8784','2013-06-04','11:30:00',3.63),('8784','2013-06-04','11:35:00',3.26),('8784','2013-06-04','11:40:00',3.49),('8784','2013-06-04','11:45:00',4.13),('8784','2013-06-04','11:50:00',4.53),('8784','2013-06-04','11:55:00',4.12),('8784','2013-06-04','12:00:00',2.41),('8784','2013-06-04','12:05:00',4.33),('8784','2013-06-04','12:10:00',2.86),('8784','2013-06-04','12:15:00',2.73),('8784','2013-06-04','12:20:00',1.99),('8784','2013-06-04','12:25:00',2.28),('8784','2013-06-04','12:30:00',3.33),('8784','2013-06-04','12:35:00',4.01),('8784','2013-06-04','12:40:00',2.52),('8784','2013-06-04','12:45:00',3.18),('8784','2013-06-04','12:50:00',2.38),('8784','2013-06-04','12:55:00',1.96),('8784','2013-06-04','13:00:00',1.87),('8784','2013-06-04','13:05:00',1.6),('8784','2013-06-04','13:10:00',1.54),('8784','2013-06-04','13:15:00',1.26),('8784','2013-06-04','13:20:00',1.27),('8784','2013-06-04','13:25:00',1.54),('8784','2013-06-04','13:30:00',2.16),('8784','2013-06-04','13:35:00',4.5),('8784','2013-06-04','13:40:00',3.93),('8784','2013-06-04','13:45:00',3.14),('8784','2013-06-04','13:50:00',4.12),('8784','2013-06-04','13:55:00',3.9),('8784','2013-06-04','14:00:00',2.41),('8784','2013-06-04','14:05:00',4.09),('8784','2013-06-04','14:10:00',4.85),('8784','2013-06-04','14:15:00',2.12),('8784','2013-06-04','14:20:00',4.84),('8784','2013-06-04','14:25:00',1.75),('8784','2013-06-04','14:30:00',1.3),('8784','2013-06-04','14:35:00',1.64),('8784','2013-06-04','14:40:00',2.77),('8784','2013-06-04','14:45:00',1.37),('8784','2013-06-04','14:50:00',1.41),('8784','2013-06-04','14:55:00',3.87),('8784','2013-06-04','15:00:00',5.3),('8784','2013-06-04','15:05:00',2.68),('8784','2013-06-04','15:10:00',1.69),('8784','2013-06-04','15:15:00',1.9),('8784','2013-06-04','15:20:00',1.22),('8784','2013-06-04','17:40:00',1.01),('8784','2013-06-04','18:40:00',1.02),('8784','2013-06-04','18:45:00',1.05),('8784','2013-06-03','07:20:00',1.09),('8784','2013-06-03','07:25:00',1.21),('8784','2013-06-03','07:40:00',1.44),('8784','2013-06-03','07:45:00',1.48),('8784','2013-06-03','07:50:00',1.69),('8784','2013-06-03','07:55:00',1.75),('8784','2013-06-03','08:00:00',1.8),('8784','2013-06-03','08:05:00',1.87),('8784','2013-06-03','08:10:00',1.95),('8784','2013-06-03','08:15:00',2.02),('8784','2013-06-03','08:20:00',2.09),('8784','2013-06-03','08:25:00',2.27),('8784','2013-06-03','08:30:00',2.36),('8784','2013-06-03','08:35:00',2.42),('8784','2013-06-03','08:40:00',2.5),('8784','2013-06-03','08:45:00',2.58),('8784','2013-06-03','08:50:00',2.62),('8784','2013-06-03','08:55:00',2.73),('8784','2013-06-03','09:00:00',2.85),('8784','2013-06-03','09:05:00',2.92),('8784','2013-06-03','09:10:00',3.04),('8784','2013-06-03','09:15:00',3.33),('8784','2013-06-03','09:20:00',2.89),('8784','2013-06-03','09:25:00',2.62),('8784','2013-06-03','09:30:00',1.99),('8784','2013-06-03','09:35:00',1.97),('8784','2013-06-03','09:40:00',2.85),('8784','2013-06-03','09:45:00',3.72),('8784','2013-06-03','09:50:00',3.06),('8784','2013-06-03','09:55:00',4.18),('8784','2013-06-03','10:00:00',3.96),('8784','2013-06-03','10:05:00',4.18),('8784','2013-06-03','10:10:00',2.69),('8784','2013-06-03','10:15:00',1.37),('8784','2013-06-03','10:20:00',1.01),('8784','2013-06-03','10:30:00',1.15),('8784','2013-06-03','10:35:00',1.31),('8784','2013-06-03','10:40:00',1.47),('8784','2013-06-03','10:45:00',2.61),('8784','2013-06-03','10:50:00',3.98),('8784','2013-06-03','10:55:00',2.78),('8784','2013-06-03','11:00:00',3.05),('8784','2013-06-03','11:05:00',2.87),('8784','2013-06-03','11:10:00',1.62),('8784','2013-06-03','11:15:00',1.46),('8784','2013-06-03','11:20:00',1.79),('8784','2013-06-03','11:25:00',1.74),('8784','2013-06-03','11:30:00',2.38),('8784','2013-06-03','11:35:00',1.52),('8784','2013-06-03','11:40:00',1.56),('8784','2013-06-03','11:45:00',1.62),('8784','2013-06-03','11:50:00',1.75),('8784','2013-06-03','11:55:00',1.78),('8784','2013-06-03','12:00:00',1.9),('8784','2013-06-03','12:05:00',1.65),('8784','2013-06-03','12:10:00',2.25),('8784','2013-06-03','12:15:00',1.5),('8784','2013-06-03','12:20:00',1.59),('8784','2013-06-03','12:25:00',1.36),('8784','2013-06-03','12:30:00',1.59),('8784','2013-06-03','12:35:00',2.96),('8784','2013-06-03','12:40:00',5.41),('8784','2013-06-03','12:45:00',3.1),('8784','2013-06-03','12:50:00',2.33),('8784','2013-06-03','12:55:00',3.95),('8784','2013-06-03','13:00:00',2.89),('8784','2013-06-03','13:05:00',2.29),('8784','2013-06-03','13:10:00',2.3),('8784','2013-06-03','13:15:00',4.92),('8784','2013-06-03','13:20:00',5.52),('8784','2013-06-03','13:25:00',5.43),('8784','2013-06-03','13:30:00',3.88),('8784','2013-06-03','13:35:00',5.09),('8784','2013-06-03','13:40:00',4.89),('8784','2013-06-03','13:45:00',4.09),('8784','2013-06-03','13:50:00',4.5),('8784','2013-06-03','13:55:00',2.1),('8784','2013-06-03','14:00:00',3.19),('8784','2013-06-03','14:05:00',3.54),('8784','2013-06-03','14:10:00',2.42),('8784','2013-06-03','14:15:00',2.9),('8784','2013-06-03','14:20:00',3.09),('8784','2013-06-03','14:25:00',2.94),('8784','2013-06-03','14:30:00',4.99),('8784','2013-06-03','14:35:00',4.78),('8784','2013-06-03','14:40:00',3.63),('8784','2013-06-03','14:45:00',3),('8784','2013-06-03','14:50:00',2.73),('8784','2013-06-03','14:55:00',3.68),('8784','2013-06-03','15:00:00',4.17),('8784','2013-06-03','15:05:00',4.35),('8784','2013-06-03','15:10:00',3.96),('8784','2013-06-03','15:15:00',4.7),('8784','2013-06-03','15:20:00',3.39),('8784','2013-06-03','15:25:00',4.19),('8784','2013-06-03','15:30:00',4.11),('8784','2013-06-03','15:35:00',4.05),('8784','2013-06-03','15:40:00',3.98),('8784','2013-06-03','15:45:00',3.91),('8784','2013-06-03','15:50:00',3.88),('8784','2013-06-03','15:55:00',3.84),('8784','2013-06-03','16:00:00',3.77),('8784','2013-06-03','16:05:00',3.73),('8784','2013-06-03','16:10:00',3.67),('8784','2013-06-03','16:15:00',3.6),('8784','2013-06-03','16:20:00',3.34),('8784','2013-06-03','16:25:00',3.48),('8784','2013-06-03','16:30:00',3.65),('8784','2013-06-03','16:35:00',3.47),('8784','2013-06-03','16:40:00',3.53),('8784','2013-06-03','16:45:00',2.97),('8784','2013-06-03','16:50:00',2.51),('8784','2013-06-03','16:55:00',2.08),('8784','2013-06-03','17:00:00',2.78),('8784','2013-06-03','17:05:00',3.3),('8784','2013-06-03','17:10:00',3.13),('8784','2013-06-03','17:15:00',2.57),('8784','2013-06-03','17:20:00',2.31),('8784','2013-06-03','17:25:00',1.66),('8784','2013-06-02','06:50:00',1.11),('8784','2013-06-02','06:55:00',1.35),('8784','2013-06-02','07:00:00',1.18),('8784','2013-06-02','08:35:00',1.02),('8784','2013-06-02','08:40:00',1),('8784','2013-06-02','08:45:00',1.11),('8784','2013-06-02','08:50:00',1.13),('8784','2013-06-02','09:00:00',1.03),('8784','2013-06-02','09:05:00',1.1),('8784','2013-06-02','09:10:00',1.22),('8784','2013-06-02','09:15:00',1.35),('8784','2013-06-02','09:20:00',2.27),('8784','2013-06-02','09:25:00',3.66),('8784','2013-06-02','09:30:00',3.52),('8784','2013-06-02','09:35:00',3.46),('8784','2013-06-02','09:40:00',3.48),('8784','2013-06-02','09:45:00',3.5),('8784','2013-06-02','09:50:00',3.58),('8784','2013-06-02','09:55:00',3.63),('8784','2013-06-02','10:00:00',3.69),('8784','2013-06-02','10:05:00',3.74),('8784','2013-06-02','10:10:00',3.8),('8784','2013-06-02','10:15:00',3.82),('8784','2013-06-02','10:20:00',3.92),('8784','2013-06-02','10:25:00',3.89),('8784','2013-06-02','10:30:00',3.35),('8784','2013-06-02','10:35:00',1.36),('8784','2013-06-02','10:40:00',1.58),('8784','2013-06-02','10:45:00',3.12),('8784','2013-06-02','10:50:00',3.09),('8784','2013-06-02','10:55:00',4.76),('8784','2013-06-02','11:00:00',4.86),('8784','2013-06-02','11:05:00',4.75),('8784','2013-06-02','11:10:00',1.59),('8784','2013-06-02','11:15:00',3.75),('8784','2013-06-02','11:20:00',4.4),('8784','2013-06-02','11:25:00',3.63),('8784','2013-06-02','11:30:00',1.81),('8784','2013-06-02','11:35:00',2.15),('8784','2013-06-02','11:40:00',2.73),('8784','2013-06-02','11:45:00',1.72),('8784','2013-06-02','11:50:00',1.47),('8784','2013-06-02','11:55:00',3.76),('8784','2013-06-02','12:00:00',1.89),('8784','2013-06-02','12:05:00',1.58),('8784','2013-06-02','12:10:00',3.21),('8784','2013-06-02','12:15:00',3.07),('8784','2013-06-02','12:20:00',2.7),('8784','2013-06-02','12:25:00',4.18),('8784','2013-06-02','12:30:00',3.49),('8784','2013-06-02','12:35:00',3.75),('8784','2013-06-02','12:40:00',4.39),('8784','2013-06-02','12:45:00',3.57),('8784','2013-06-02','12:50:00',2.11),('8784','2013-06-02','12:55:00',3.87),('8784','2013-06-02','13:00:00',2.32),('8784','2013-06-02','13:05:00',2.43),('8784','2013-06-02','13:10:00',4.37),('8784','2013-06-02','13:15:00',5.03),('8784','2013-06-02','13:20:00',4.87),('8784','2013-06-02','13:25:00',4.79),('8784','2013-06-02','13:30:00',4.76),('8784','2013-06-02','13:35:00',4.68),('8784','2013-06-02','13:40:00',4.69),('8784','2013-06-02','13:45:00',4.66),('8784','2013-06-02','13:50:00',4.63),('8784','2013-06-02','13:55:00',4.62),('8784','2013-06-02','14:00:00',4.59),('8784','2013-06-02','14:05:00',4.58),('8784','2013-06-02','14:10:00',4.67),('8784','2013-06-02','14:15:00',4.59),('8784','2013-06-02','14:20:00',4.55),('8784','2013-06-02','14:25:00',4.53),('8784','2013-06-02','14:30:00',4.51),('8784','2013-06-02','14:35:00',4.47),('8784','2013-06-02','14:40:00',4.42),('8784','2013-06-02','14:45:00',4.41),('8784','2013-06-02','14:50:00',4.38),('8784','2013-06-02','14:55:00',4.3),('8784','2013-06-02','15:00:00',4.28),('8784','2013-06-02','15:05:00',4.23),('8784','2013-06-02','15:10:00',4.17),('8784','2013-06-02','15:15:00',4.18),('8784','2013-06-02','15:20:00',3.06),('8784','2013-06-02','15:25:00',3.67),('8784','2013-06-02','15:30:00',3.89),('8784','2013-06-02','15:35:00',2.85),('8784','2013-06-02','15:40:00',3.35),('8784','2013-06-02','15:45:00',3.3),('8784','2013-06-02','15:50:00',2.75),('8784','2013-06-02','15:55:00',3.75),('8784','2013-06-02','16:00:00',3.93),('8784','2013-06-02','16:05:00',3.45),('8784','2013-06-02','16:10:00',3.64),('8784','2013-06-02','16:15:00',3.75),('8784','2013-06-02','16:20:00',3.6),('8784','2013-06-02','16:25:00',3.53),('8784','2013-06-02','16:30:00',3.37),('8784','2013-06-02','16:35:00',3.33),('8784','2013-06-02','16:40:00',3.31),('8784','2013-06-02','16:45:00',2.91),('8784','2013-06-02','16:50:00',3.21),('8784','2013-06-02','16:55:00',3.01),('8784','2013-06-02','17:00:00',2.6),('8784','2013-06-02','17:05:00',2.9),('8784','2013-06-02','17:10:00',2.78),('8784','2013-06-02','17:15:00',2.73),('8784','2013-06-02','17:20:00',2.61),('8784','2013-06-02','17:25:00',2.5),('8784','2013-06-02','17:30:00',1.97),('8784','2013-06-02','17:35:00',1.81),('8784','2013-06-02','17:40:00',1.26),('8784','2013-06-02','17:45:00',1.5),('8784','2013-06-02','17:50:00',1.6),('8784','2013-06-02','17:55:00',1.05),('8784','2013-06-02','18:10:00',1.03),('8784','2013-06-01','07:10:00',1.06),('8784','2013-06-01','07:15:00',1.14),('8784','2013-06-01','07:20:00',1.22),('8784','2013-06-01','07:25:00',1.3),('8784','2013-06-01','07:30:00',1.39),('8784','2013-06-01','07:35:00',1.46),('8784','2013-06-01','07:40:00',1.59),('8784','2013-06-01','07:45:00',1.61),('8784','2013-06-01','07:50:00',1.17),('8784','2013-06-01','07:55:00',1.47),('8784','2013-06-01','08:10:00',1.11),('8784','2013-06-01','08:15:00',1.59),('8784','2013-06-01','08:20:00',1.18),('8784','2013-06-01','08:30:00',1.58),('8784','2013-06-01','08:35:00',1.34),('8784','2013-06-01','09:00:00',1.06),('8784','2013-06-01','09:50:00',1.03),('8784','2013-06-01','10:35:00',1.39),('8784','2013-06-01','10:40:00',1.18),('8784','2013-06-01','10:50:00',2.69),('8784','2013-06-01','10:55:00',1.26),('8784','2013-06-01','11:50:00',1.57),('8784','2013-06-01','11:55:00',1.92),('8784','2013-06-01','12:00:00',3.37),('8784','2013-06-01','12:05:00',2.75),('8784','2013-06-01','12:10:00',3.26),('8784','2013-06-01','12:15:00',1.42),('8784','2013-06-01','12:20:00',1.1),('8784','2013-06-01','12:25:00',1.33),('8784','2013-06-01','12:30:00',1.24),('8784','2013-06-01','12:40:00',1.2),('8784','2013-06-01','12:45:00',1.96),('8784','2013-06-01','12:50:00',2.13),('8784','2013-06-01','12:55:00',2.23),('8784','2013-06-01','13:00:00',2.41),('8784','2013-06-01','13:05:00',2.51),('8784','2013-06-01','13:10:00',2.65),('8784','2013-06-01','13:15:00',2.8),('8784','2013-06-01','13:20:00',2.37),('8784','2013-06-01','13:25:00',2.01),('8784','2013-06-01','13:30:00',1.71),('8784','2013-06-01','13:35:00',1.36),('8784','2013-06-01','13:40:00',1.19),('8784','2013-06-01','13:45:00',1.3),('8784','2013-06-01','13:50:00',1.43),('8784','2013-06-01','13:55:00',1.64),('8784','2013-06-01','14:00:00',2.3),('8784','2013-06-01','14:05:00',2.58),('8784','2013-06-01','14:10:00',2.57),('8784','2013-06-01','14:15:00',2.78),('8784','2013-06-01','14:20:00',2.59),('8784','2013-06-01','14:25:00',1.78),('8784','2013-06-01','14:30:00',1.49),('8784','2013-06-01','14:35:00',1.51),('8784','2013-06-01','14:40:00',1.41),('8784','2013-06-01','14:45:00',1.32),('8784','2013-06-01','14:50:00',1.24),('8784','2013-06-01','18:30:00',1.06),('8784','2013-06-01','18:35:00',1.11),('8784','2013-06-01','19:00:00',1.58),('8784','2014-04-02','08:50:00',1.27),('8784','2014-04-02','08:55:00',1.6),('8784','2014-04-02','09:15:00',1.16),('8784','2014-04-02','09:50:00',1.07),('8784','2014-04-02','09:55:00',2.84),('8784','2014-04-02','10:00:00',2.42),('8784','2014-04-02','10:05:00',3.03),('8784','2014-04-02','10:10:00',3.49),('8784','2014-04-02','10:15:00',3.23),('8784','2014-04-02','10:20:00',3.08),('8784','2014-04-02','10:25:00',2.5),('8784','2014-04-02','10:30:00',1.65),('8784','2014-04-02','10:35:00',1.23),('8784','2014-04-02','10:40:00',1.33),('8784','2014-04-02','10:45:00',1.34),('8784','2014-04-02','10:50:00',3.02),('8784','2014-04-02','10:55:00',3.93),('8784','2014-04-02','11:00:00',3.31),('8784','2014-04-02','11:05:00',1.74),('8784','2014-04-02','11:10:00',1.23),('8784','2014-04-02','11:15:00',3.8),('8784','2014-04-02','11:20:00',3.89),('8784','2014-04-02','11:25:00',4.41),('8784','2014-04-02','11:30:00',3.9),('8784','2014-04-02','11:35:00',1.43),('8784','2014-04-02','11:40:00',1.27),('8784','2014-04-02','11:45:00',2.8),('8784','2014-04-02','11:50:00',4.33),('8784','2014-04-02','11:55:00',4.38),('8784','2014-04-02','12:00:00',4.85),('8784','2014-04-02','12:05:00',2.32),('8784','2014-04-02','12:10:00',1.5),('8784','2014-04-02','12:15:00',4.61),('8784','2014-04-02','12:20:00',4.3),('8784','2014-04-02','12:25:00',1.38),('8784','2014-04-02','12:30:00',4.42),('8784','2014-04-02','12:35:00',4.13),('8784','2014-04-02','12:40:00',4.27),('8784','2014-04-02','12:45:00',4.17),('8784','2014-04-02','12:50:00',4.63),('8784','2014-04-02','12:55:00',2.09),('8784','2014-04-02','13:00:00',3.09),('8784','2014-04-02','13:05:00',4.39),('8784','2014-04-02','13:10:00',4.22),('8784','2014-04-02','13:15:00',4.57),('8784','2014-04-02','13:20:00',4.33),('8784','2014-04-02','13:25:00',4.39),('8784','2014-04-02','13:30:00',4.42),('8784','2014-04-02','13:35:00',4.35),('8784','2014-04-02','13:40:00',4.48),('8784','2014-04-02','13:45:00',4.25),('8784','2014-04-02','13:50:00',4.21),('8784','2014-04-02','13:55:00',4.25),('8784','2014-04-02','14:00:00',4.12),('8784','2014-04-02','14:05:00',4.15),('8784','2014-04-02','14:10:00',4.13),('8784','2014-04-02','14:15:00',4.1),('8784','2014-04-02','14:20:00',4.02),('8784','2014-04-02','14:25:00',4.09),('8784','2014-04-02','14:30:00',4.01),('8784','2014-04-02','14:35:00',4),('8784','2014-04-02','14:40:00',3.83),('8784','2014-04-02','14:45:00',3.88),('8784','2014-04-02','14:50:00',3.64),('8784','2014-04-02','14:55:00',3.49),('8784','2014-04-02','15:00:00',3.65),('8784','2014-04-02','15:05:00',3.69),('8784','2014-04-02','15:10:00',3.32),('8784','2014-04-02','15:15:00',3.47),('8784','2014-04-02','15:20:00',3.45),('8784','2014-04-02','15:25:00',3.41),('8784','2014-04-02','15:30:00',3.2),('8784','2014-04-02','15:35:00',3.12),('8784','2014-04-02','15:40:00',3.14),('8784','2014-04-02','15:45:00',3.22),('8784','2014-04-02','15:50:00',3.24),('8784','2014-04-02','15:55:00',2.81),('8784','2014-04-02','16:00:00',2.94),('8784','2014-04-02','16:05:00',2.92),('8784','2014-04-02','16:10:00',2.86),('8784','2014-04-02','16:15:00',2.77),('8784','2014-04-02','16:20:00',2.67),('8784','2014-04-02','16:25:00',2.57),('8784','2014-04-02','16:30:00',2.62),('8784','2014-04-02','16:35:00',2.56),('8784','2014-04-02','16:40:00',2.47),('8784','2014-04-02','16:45:00',2.36),('8784','2014-04-02','16:50:00',2.14),('8784','2014-04-02','16:55:00',2.12),('8784','2014-04-02','17:00:00',2.17),('8784','2014-04-02','17:05:00',1.95),('8784','2014-04-02','17:10:00',1.86),('8784','2014-04-02','17:15:00',1.64),('8784','2014-04-02','17:20:00',1.65),('8784','2014-04-02','17:25:00',1.56),('8784','2014-04-02','17:30:00',1.4),('8784','2014-04-02','17:35:00',1.37),('8784','2014-04-02','17:40:00',1.03),('8784','2014-04-02','17:45:00',1.04),('8784','2014-04-02','17:50:00',1.27),('8784','2014-04-02','17:55:00',1.1),('8784','2014-04-02','18:00:00',1.01),('8784','2013-05-31','07:10:00',1.03),('8784','2013-05-31','07:15:00',1.11),('8784','2013-05-31','07:20:00',1.21),('8784','2013-05-31','07:25:00',1.3),('8784','2013-05-31','07:30:00',1.39),('8784','2013-05-31','07:35:00',1.48),('8784','2013-05-31','07:40:00',1.59),('8784','2013-05-31','07:45:00',1.67),('8784','2013-05-31','07:50:00',1.74),('8784','2013-05-31','07:55:00',1.89),('8784','2013-05-31','08:00:00',2),('8784','2013-05-31','08:05:00',2.06),('8784','2013-05-31','08:10:00',2.12),('8784','2013-05-31','08:15:00',2.18),('8784','2013-05-31','08:20:00',2.22),('8784','2013-05-31','08:25:00',2.39),('8784','2013-05-31','08:30:00',2.09),('8784','2013-05-31','08:35:00',2.67),('8784','2013-05-31','08:40:00',1.52),('8784','2013-05-31','08:45:00',1.8),('8784','2013-05-31','08:50:00',2.87),('8784','2013-05-31','08:55:00',1.21),('8784','2013-05-31','09:10:00',1.2),('8784','2013-05-31','09:15:00',1.43),('8784','2013-05-31','09:25:00',1.04),('8784','2013-05-31','09:30:00',2.21),('8784','2013-05-31','09:35:00',2.54),('8784','2013-05-31','09:40:00',2.83),('8784','2013-05-31','09:45:00',3.62),('8784','2013-05-31','09:50:00',4),('8784','2013-05-31','09:55:00',3.74),('8784','2013-05-31','10:00:00',3.97),('8784','2013-05-31','10:05:00',2.88),('8784','2013-05-31','10:10:00',1.92),('8784','2013-05-31','10:15:00',3.66),('8784','2013-05-31','10:20:00',3.82),('8784','2013-05-31','10:25:00',1.69),('8784','2013-05-31','10:30:00',2.89),('8784','2013-05-31','10:35:00',2.31),('8784','2013-05-31','10:40:00',4.44),('8784','2013-05-31','10:45:00',4.57),('8784','2013-05-31','10:50:00',2.07),('8784','2013-05-31','10:55:00',4.2),('8784','2013-05-31','11:00:00',1.77),('8784','2013-05-31','11:05:00',2.43),('8784','2013-05-31','11:10:00',5.4),('8784','2013-05-31','11:15:00',4.53),('8784','2013-05-31','11:20:00',1.37),('8784','2013-05-31','11:25:00',2.71),('8784','2013-05-31','11:30:00',3.62),('8784','2013-05-31','11:35:00',2.59),('8784','2013-05-31','11:45:00',4.91),('8784','2013-05-31','11:50:00',3.55),('8784','2013-05-31','11:55:00',3.69),('8784','2013-05-31','12:00:00',1.74),('8784','2013-05-31','12:05:00',5.37),('8784','2013-05-31','12:10:00',3.86),('8784','2013-05-31','12:15:00',1.76),('8784','2013-05-31','12:20:00',1.93),('8784','2013-05-31','12:25:00',3.88),('8784','2013-05-31','12:30:00',1.85),('8784','2013-05-31','12:35:00',2.5),('8784','2013-05-31','12:40:00',4.46),('8784','2013-05-31','12:45:00',2.11),('8784','2013-05-31','12:50:00',1.02),('8784','2013-05-31','12:55:00',1.67),('8784','2013-05-31','13:00:00',5.56),('8784','2013-05-31','13:05:00',1.85),('8784','2013-05-31','13:20:00',1.4),('8784','2013-05-31','13:25:00',2.05),('8784','2013-05-31','13:30:00',4.27),('8784','2013-05-31','13:35:00',5.15),('8784','2013-05-31','13:40:00',2.58),('8784','2013-05-31','13:45:00',1.42),('8784','2013-05-31','13:55:00',1.52),('8784','2013-05-31','14:00:00',2.2),('8784','2013-05-31','14:25:00',1.14),('8784','2013-05-31','15:00:00',1.11),('8784','2013-05-31','15:05:00',1.7),('8784','2013-05-31','15:10:00',2.02),('8784','2013-05-31','15:15:00',3.22),('8784','2013-05-31','15:20:00',5.2),('8784','2013-05-31','15:25:00',3.68),('8784','2013-05-31','15:30:00',2.59),('8784','2013-05-31','15:35:00',2.22),('8784','2013-05-31','15:40:00',1.9),('8784','2013-05-31','15:45:00',1.76),('8784','2013-05-31','15:50:00',2.59),('8784','2013-05-31','15:55:00',2.42),('8784','2013-05-31','16:00:00',1.64),('8784','2013-05-31','16:05:00',1.42),('8784','2013-05-31','16:10:00',1.06),('8784','2013-05-31','16:20:00',1.18),('8784','2013-05-31','16:25:00',1.46),('8784','2013-05-31','16:30:00',1.3),('8784','2013-05-31','16:35:00',1.12),('8784','2013-05-31','16:40:00',1.29),('8784','2013-05-31','16:45:00',1.32),('8784','2013-05-30','07:45:00',1.06),('8784','2013-05-30','07:50:00',1.41),('8784','2013-05-30','08:20:00',1.03),('8784','2013-05-30','08:25:00',1.47),('8784','2013-05-30','08:30:00',1.05),('8784','2013-05-30','08:35:00',1.16),('8784','2013-05-30','08:40:00',2.78),('8784','2013-05-30','08:45:00',2.79),('8784','2013-05-30','08:50:00',2.84),('8784','2013-05-30','08:55:00',2.91),('8784','2013-05-30','09:00:00',2.98),('8784','2013-05-30','09:05:00',2.83),('8784','2013-05-30','09:10:00',3.15),('8784','2013-05-30','09:15:00',3.25),('8784','2013-05-30','09:20:00',3.34),('8784','2013-05-30','09:25:00',3.44),('8784','2013-05-30','09:30:00',3.47),('8784','2013-05-30','09:35:00',3.55),('8784','2013-05-30','09:40:00',3.64),('8784','2013-05-30','09:45:00',3),('8784','2013-05-30','09:50:00',4.37),('8784','2013-05-30','09:55:00',1.71),('8784','2013-05-30','10:00:00',1.57),('8784','2013-05-30','10:05:00',1.82),('8784','2013-05-30','10:10:00',3.32),('8784','2013-05-30','10:15:00',2.51),('8784','2013-05-30','10:20:00',4.3),('8784','2013-05-30','10:25:00',1.21),('8784','2013-05-30','10:30:00',1.91),('8784','2013-05-30','10:35:00',1.75),('8784','2013-05-30','10:40:00',3.05),('8784','2013-05-30','10:45:00',4.41),('8784','2013-05-30','10:50:00',4.13),('8784','2013-05-30','10:55:00',3.64),('8784','2013-05-30','11:00:00',5.17),('8784','2013-05-30','11:05:00',4.84),('8784','2013-05-30','11:10:00',1.31),('8784','2013-05-30','11:15:00',2.31),('8784','2013-05-30','11:20:00',3.43),('8784','2013-05-30','11:25:00',1.86),('8784','2013-05-30','11:30:00',4.34),('8784','2013-05-30','11:35:00',5.09),('8784','2013-05-30','11:40:00',4.97),('8784','2013-05-30','11:45:00',4.01),('8784','2013-05-30','11:50:00',4.56),('8784','2013-05-30','11:55:00',1.44),('8784','2013-05-30','12:00:00',5.44),('8784','2013-05-30','12:05:00',5.44),('8784','2013-05-30','12:10:00',2.62),('8784','2013-05-30','12:15:00',4.44),('8784','2013-05-30','12:20:00',3.42),('8784','2013-05-30','12:25:00',5.05),('8784','2013-05-30','12:30:00',3.77),('8784','2013-05-30','12:35:00',3.43),('8784','2013-05-30','12:40:00',5.11),('8784','2013-05-30','12:45:00',3.08),('8784','2013-05-30','12:50:00',4.35),('8784','2013-05-30','12:55:00',5.18),('8784','2013-05-30','13:00:00',4.66),('8784','2013-05-30','13:05:00',3.96),('8784','2013-05-30','13:10:00',2.8),('8784','2013-05-30','13:15:00',2.32),('8784','2013-05-30','13:20:00',2.17),('8784','2013-05-30','13:25:00',1.92),('8784','2013-05-30','13:30:00',2.43),('8784','2013-05-30','13:35:00',2.26),('8784','2013-05-30','13:40:00',4.55),('8784','2013-05-30','13:45:00',4.88),('8784','2013-05-30','13:50:00',1.77),('8784','2013-05-30','13:55:00',2.01),('8784','2013-05-30','14:00:00',4.08),('8784','2013-05-30','14:05:00',5.49),('8784','2013-05-30','14:10:00',3.76),('8784','2013-05-30','14:15:00',5.32),('8784','2013-05-30','14:20:00',3.58),('8784','2013-05-30','14:25:00',4.68),('8784','2013-05-30','14:30:00',4.89),('8784','2013-05-30','14:35:00',4.06),('8784','2013-05-30','14:40:00',4.93),('8784','2013-05-30','14:45:00',5),('8784','2013-05-30','14:50:00',4.91),('8784','2013-05-30','14:55:00',4.43),('8784','2013-05-30','15:00:00',3.09),('8784','2013-05-30','15:05:00',3.26),('8784','2013-05-30','15:10:00',2.29),('8784','2013-05-30','15:15:00',4.48),('8784','2013-05-30','15:20:00',4.64),('8784','2013-05-30','15:25:00',4.42),('8784','2013-05-30','15:30:00',4.05),('8784','2013-05-30','15:35:00',4.38),('8784','2013-05-30','15:40:00',4.39),('8784','2013-05-30','15:45:00',4.61),('8784','2013-05-30','15:50:00',2.2),('8784','2013-05-30','15:55:00',3.96),('8784','2013-05-30','16:00:00',4.24),('8784','2013-05-30','16:05:00',4.48),('8784','2013-05-30','16:10:00',4.13),('8784','2013-05-30','16:15:00',3.89),('8784','2013-05-30','16:20:00',3.59),('8784','2013-05-30','16:25:00',2.33),('8784','2013-05-30','16:30:00',1.39),('8784','2013-05-30','16:35:00',2.34),('8784','2013-05-30','16:40:00',1.19),('8784','2013-05-30','16:45:00',3.12),('8784','2013-05-30','16:50:00',2.88),('8784','2013-05-30','16:55:00',2.37),('8784','2013-05-30','17:00:00',1.79),('8784','2013-05-30','17:05:00',2.13),('8784','2013-05-30','17:15:00',1.05),('8784','2013-05-30','17:20:00',1.41),('8784','2013-05-30','17:25:00',1.03),('8784','2013-05-30','17:30:00',1.12),('8784','2013-05-30','18:00:00',1.05),('8784','2013-05-30','18:05:00',1.15),('8784','2013-05-30','18:10:00',1.39),('8784','2013-05-30','18:35:00',1.53),('8784','2013-05-30','18:40:00',1.42),('8784','2013-05-30','18:45:00',1.64),('8784','2013-05-30','18:50:00',1.51),('8784','2013-05-29','07:15:00',1.08),('8784','2013-05-29','07:20:00',1.16),('8784','2013-05-29','07:25:00',1.25),('8784','2013-05-29','07:30:00',1.34),('8784','2013-05-29','07:35:00',1.44),('8784','2013-05-29','07:40:00',1.53),('8784','2013-05-29','07:45:00',1.61),('8784','2013-05-29','07:50:00',1.69),('8784','2013-05-29','07:55:00',1.78),('8784','2013-05-29','08:00:00',1.88),('8784','2013-05-29','08:05:00',1.96),('8784','2013-05-29','08:10:00',2.06),('8784','2013-05-29','08:15:00',2.14),('8784','2013-05-29','08:20:00',2.23),('8784','2013-05-29','08:25:00',2.31),('8784','2013-05-29','08:30:00',2.4),('8784','2013-05-29','08:35:00',2.49),('8784','2013-05-29','08:40:00',2.58),('8784','2013-05-29','08:45:00',2.66),('8784','2013-05-29','08:50:00',2.74),('8784','2013-05-29','08:55:00',2.83),('8784','2013-05-29','09:00:00',2.91),('8784','2013-05-29','09:05:00',2.98),('8784','2013-05-29','09:10:00',3.05),('8784','2013-05-29','09:15:00',3.12),('8784','2013-05-29','09:20:00',3.2),('8784','2013-05-29','09:25:00',3.26),('8784','2013-05-29','09:30:00',3.32),('8784','2013-05-29','09:35:00',3.41),('8784','2013-05-29','09:40:00',3.49),('8784','2013-05-29','09:45:00',3.55),('8784','2013-05-29','09:50:00',3.63),('8784','2013-05-29','09:55:00',3.69),('8784','2013-05-29','10:00:00',3.72),('8784','2013-05-29','10:05:00',3.79),('8784','2013-05-29','10:10:00',3.85),('8784','2013-05-29','10:15:00',3.91),('8784','2013-05-29','10:20:00',3.93),('8784','2013-05-29','10:25:00',4.01),('8784','2013-05-29','10:30:00',4.08),('8784','2013-05-29','10:35:00',4.16),('8784','2013-05-29','10:40:00',4.2),('8784','2013-05-29','10:45:00',4.25),('8784','2013-05-29','10:50:00',4.29),('8784','2013-05-29','10:55:00',4.32),('8784','2013-05-29','11:00:00',4.39),('8784','2013-05-29','11:05:00',4.38),('8784','2013-05-29','11:10:00',4.39),('8784','2013-05-29','11:15:00',3.62),('8784','2013-05-29','11:20:00',4.81),('8784','2013-05-29','11:25:00',4.34),('8784','2013-05-29','11:30:00',4.78),('8784','2013-05-29','11:35:00',4.75),('8784','2013-05-29','11:40:00',3.8),('8784','2013-05-29','11:45:00',3.37),('8784','2013-05-29','11:50:00',3.99),('8784','2013-05-29','11:55:00',4.63),('8784','2013-05-29','12:00:00',3.47),('8784','2013-05-29','12:05:00',3.17),('8784','2013-05-29','12:10:00',4.7),('8784','2013-05-29','12:15:00',3.79),('8784','2013-05-29','12:20:00',5.02),('8784','2013-05-29','12:25:00',4.99),('8784','2013-05-29','12:30:00',4.89),('8784','2013-05-29','12:35:00',4.91),('8784','2013-05-29','12:40:00',3.74),('8784','2013-05-29','12:45:00',4.9),('8784','2013-05-29','12:50:00',4.64),('8784','2013-05-29','12:55:00',4.86),('8784','2013-05-29','13:00:00',4.9),('8784','2013-05-29','13:05:00',4.54),('8784','2013-05-29','13:10:00',4.49),('8784','2013-05-29','13:15:00',4.17),('8784','2013-05-29','13:20:00',3.91),('8784','2013-05-29','13:25:00',5.33),('8784','2013-05-29','13:30:00',5.19),('8784','2013-05-29','13:35:00',4.01),('8784','2013-05-29','13:40:00',5.05),('8784','2013-05-29','13:45:00',4.57),('8784','2013-05-29','13:50:00',4.33),('8784','2013-05-29','13:55:00',4.17),('8784','2013-05-29','14:00:00',4.92),('8784','2013-05-29','14:05:00',4.65),('8784','2013-05-29','14:10:00',4.66),('8784','2013-05-29','14:15:00',4.74),('8784','2013-05-29','14:20:00',4.73),('8784','2013-05-29','14:25:00',4.41),('8784','2013-05-29','14:30:00',4.72),('8784','2013-05-29','14:35:00',3.51),('8784','2013-05-29','14:40:00',4.83),('8784','2013-05-29','14:45:00',4.75),('8784','2013-05-29','14:50:00',4.09),('8784','2013-05-29','14:55:00',4.3),('8784','2013-05-29','15:00:00',4.67),('8784','2013-05-29','15:05:00',4.34),('8784','2013-05-29','15:10:00',3.53),('8784','2013-05-29','15:15:00',3.15),('8784','2013-05-29','15:20:00',3.78),('8784','2013-05-29','15:25:00',3.02),('8784','2013-05-29','15:30:00',3.72),('8784','2013-05-29','15:35:00',3.37),('8784','2013-05-29','15:40:00',2.76),('8784','2013-05-29','15:45:00',3.23),('8784','2013-05-29','15:50:00',3.22),('8784','2013-05-29','15:55:00',3.05),('8784','2013-05-29','16:00:00',2.87),('8784','2013-05-29','16:05:00',2.89),('8784','2013-05-29','16:10:00',2.52),('8784','2013-05-29','16:15:00',2.41),('8784','2013-05-29','16:20:00',2.34),('8784','2013-05-29','16:25:00',2.4),('8784','2013-05-29','16:30:00',2.01),('8784','2013-05-29','16:35:00',2.06),('8784','2013-05-29','16:40:00',2.49),('8784','2013-05-29','16:45:00',2.22),('8784','2013-05-29','16:50:00',1.72),('8784','2013-05-29','16:55:00',1.6),('8784','2013-05-29','17:00:00',1.47),('8784','2013-05-29','17:35:00',1.26),('8784','2013-05-29','17:40:00',1.74),('8784','2013-05-29','17:45:00',1.23),('8784','2013-05-29','18:00:00',1.05),('8784','2013-05-29','18:05:00',1.32),('8784','2013-05-29','18:10:00',1.45),('8784','2013-05-29','18:15:00',2.42),('8784','2013-05-29','18:20:00',1.66),('8784','2013-05-28','07:15:00',1.2),('8784','2013-05-28','07:20:00',1.35),('8784','2013-05-28','07:25:00',1.4),('8784','2013-05-28','07:30:00',1.02),('8784','2013-05-28','07:40:00',1.26),('8784','2013-05-28','07:45:00',1.33),('8784','2013-05-28','07:50:00',1.35),('8784','2013-05-28','07:55:00',1.31),('8784','2013-05-28','08:00:00',1.38),('8784','2013-05-28','08:05:00',1.48),('8784','2013-05-28','08:10:00',1.69),('8784','2013-05-28','08:15:00',1.96),('8784','2013-05-28','08:20:00',2.08),('8784','2013-05-28','08:25:00',1.79),('8784','2013-05-28','08:30:00',2.05),('8784','2013-05-28','08:35:00',1.85),('8784','2013-05-28','08:40:00',1.64),('8784','2013-05-28','08:45:00',1.58),('8784','2013-05-28','08:50:00',1.83),('8784','2013-05-28','08:55:00',1.73),('8784','2013-05-28','09:00:00',1.81),('8784','2013-05-28','09:05:00',2.05),('8784','2013-05-28','09:10:00',1.85),('8784','2013-05-28','09:15:00',1.77),('8784','2013-05-28','09:20:00',2.06),('8784','2013-05-28','09:25:00',2.32),('8784','2013-05-28','09:30:00',2.51),('8784','2013-05-28','09:35:00',2.55),('8784','2013-05-28','09:40:00',2.44),('8784','2013-05-28','09:45:00',2.3),('8784','2013-05-28','09:50:00',2.35),('8784','2013-05-28','09:55:00',2.51),('8784','2013-05-28','10:00:00',2.34),('8784','2013-05-28','10:05:00',2.51),('8784','2013-05-28','10:10:00',2.78),('8784','2013-05-28','10:15:00',2.91),('8784','2013-05-28','10:20:00',3.04),('8784','2013-05-28','10:25:00',3.01),('8784','2013-05-28','10:30:00',3.29),('8784','2013-05-28','10:35:00',3.32),('8784','2013-05-28','10:40:00',3.02),('8784','2013-05-28','10:45:00',2.84),('8784','2013-05-28','10:50:00',3.08),('8784','2013-05-28','10:55:00',2.59),('8784','2013-05-28','11:00:00',2.69),('8784','2013-05-28','11:05:00',2.62),('8784','2013-05-28','11:10:00',2.69),('8784','2013-05-28','11:15:00',2.54),('8784','2013-05-28','11:20:00',2.39),('8784','2013-05-28','11:25:00',2.5),('8784','2013-05-28','11:30:00',4.53),('8784','2013-05-28','11:35:00',3.3),('8784','2013-05-28','11:40:00',4.24),('8784','2013-05-28','11:45:00',3.5),('8784','2013-05-28','11:50:00',1.26),('8784','2013-05-28','11:55:00',1.86),('8784','2013-05-28','12:00:00',1.66),('8784','2013-05-28','12:05:00',2.13),('8784','2013-05-28','12:10:00',3.04),('8784','2013-05-28','12:15:00',2.88),('8784','2013-05-28','12:20:00',2.57),('8784','2013-05-28','12:25:00',2.65),('8784','2013-05-28','12:30:00',2.93),('8784','2013-05-28','12:35:00',2.84),('8784','2013-05-28','12:40:00',2.91),('8784','2013-05-28','12:45:00',3.24),('8784','2013-05-28','12:50:00',2.89),('8784','2013-05-28','12:55:00',2.96),('8784','2013-05-28','13:00:00',3.01),('8784','2013-05-28','13:05:00',3.23),('8784','2013-05-28','13:10:00',3.35),('8784','2013-05-28','13:15:00',2.94),('8784','2013-05-28','13:20:00',3.38),('8784','2013-05-28','13:25:00',1.94),('8784','2013-05-28','13:30:00',2.35),('8784','2013-05-28','13:35:00',1.98),('8784','2013-05-28','13:40:00',2.23),('8784','2013-05-28','13:45:00',2.15),('8784','2013-05-28','13:50:00',2.88),('8784','2013-05-28','13:55:00',2.76),('8784','2013-05-28','14:00:00',2.87),('8784','2013-05-28','14:05:00',3),('8784','2013-05-28','14:10:00',4.27),('8784','2013-05-28','14:15:00',4.13),('8784','2013-05-28','14:20:00',2.74),('8784','2013-05-28','14:25:00',2.97),('8784','2013-05-28','14:30:00',3.71),('8784','2013-05-28','14:35:00',3.17),('8784','2013-05-28','14:40:00',3.49),('8784','2013-05-28','14:45:00',4.03),('8784','2013-05-28','14:50:00',3.18),('8784','2013-05-28','14:55:00',2.89),('8784','2013-05-28','15:00:00',2.71),('8784','2013-05-28','15:05:00',3.77),('8784','2013-05-28','15:10:00',1.8),('8784','2013-05-28','15:15:00',2.9),('8784','2013-05-28','15:20:00',3.29),('8784','2013-05-28','15:25:00',2.43),('8784','2013-05-28','15:30:00',1.63),('8784','2013-05-28','15:35:00',1.69),('8784','2013-05-28','15:40:00',2.77),('8784','2013-05-28','15:45:00',3.88),('8784','2013-05-28','15:50:00',3.29),('8784','2013-05-28','15:55:00',2.34),('8784','2013-05-28','16:00:00',1.74),('8784','2013-05-28','16:05:00',1.47),('8784','2013-05-28','16:10:00',1.53),('8784','2013-05-28','16:15:00',1.76),('8784','2013-05-28','16:20:00',2.78),('8784','2013-05-28','16:25:00',2.34),('8784','2013-05-28','16:30:00',2.8),('8784','2013-05-28','16:35:00',3.3),('8784','2013-05-28','16:40:00',3.06),('8784','2013-05-28','16:45:00',2.94),('8784','2013-05-28','16:50:00',2.87),('8784','2013-05-28','16:55:00',2.8),('8784','2013-05-28','17:00:00',2.74),('8784','2013-05-28','17:05:00',2.66),('8784','2013-05-28','17:10:00',2.56),('8784','2013-05-28','17:15:00',2.49),('8784','2013-05-28','17:20:00',2.41),('8784','2013-05-28','17:25:00',2.3),('8784','2013-05-28','17:30:00',2.23),('8784','2013-05-28','17:35:00',2.11),('8784','2013-05-28','17:40:00',2.02),('8784','2013-05-28','17:45:00',1.94),('8784','2013-05-28','17:50:00',1.88),('8784','2013-05-28','17:55:00',1.81),('8784','2013-05-28','18:00:00',1.8),('8784','2013-05-28','18:05:00',1.71),('8784','2013-05-28','18:35:00',1.17),('8784','2013-05-28','18:40:00',1.1),('8784','2013-05-28','18:45:00',1.02),('8784','2013-05-27','07:25:00',1.29),('8784','2013-05-27','07:30:00',1.34),('8784','2013-05-27','07:35:00',1.44),('8784','2013-05-27','07:40:00',1.5),('8784','2013-05-27','07:45:00',1.67),('8784','2013-05-27','07:50:00',1.62),('8784','2013-05-27','08:00:00',1.7),('8784','2013-05-27','08:05:00',2.17),('8784','2013-05-27','08:10:00',2.28),('8784','2013-05-27','08:15:00',2.28),('8784','2013-05-27','08:20:00',1.62),('8784','2013-05-27','08:25:00',2.06),('8784','2013-05-27','08:30:00',2.47),('8784','2013-05-27','08:35:00',2.53),('8784','2013-05-27','08:40:00',2.63),('8784','2013-05-27','08:45:00',2.77),('8784','2013-05-27','08:50:00',2.75),('8784','2013-05-27','08:55:00',3.08),('8784','2013-05-27','09:00:00',3.31),('8784','2013-05-27','09:05:00',3.51),('8784','2013-05-27','09:10:00',1.91),('8784','2013-05-27','09:15:00',2.93),('8784','2013-05-27','09:20:00',1.88),('8784','2013-05-27','09:25:00',2.83),('8784','2013-05-27','09:30:00',3.53),('8784','2013-05-27','09:35:00',3.58),('8784','2013-05-27','09:40:00',3.62),('8784','2013-05-27','09:45:00',3.69),('8784','2013-05-27','09:50:00',2.7),('8784','2013-05-27','09:55:00',3.89),('8784','2013-05-27','10:00:00',3.99),('8784','2013-05-27','10:05:00',3.91),('8784','2013-05-27','10:10:00',4.1),('8784','2013-05-27','10:15:00',3.75),('8784','2013-05-27','10:20:00',2.11),('8784','2013-05-27','10:25:00',4.26),('8784','2013-05-27','10:30:00',2.08),('8784','2013-05-27','10:35:00',1.79),('8784','2013-05-27','10:40:00',4.33),('8784','2013-05-27','10:45:00',1.99),('8784','2013-05-27','10:50:00',1.73),('8784','2013-05-27','10:55:00',1.69),('8784','2013-05-27','11:00:00',4.26),('8784','2013-05-27','11:05:00',3.02),('8784','2013-05-27','11:10:00',4.07),('8784','2013-05-27','11:15:00',1.85),('8784','2013-05-27','11:20:00',3.78),('8784','2013-05-27','11:25:00',4.22),('8784','2013-05-27','11:30:00',2.78),('8784','2013-05-27','11:35:00',1.57),('8784','2013-05-27','11:40:00',5.53),('8784','2013-05-27','11:45:00',2.2),('8784','2013-05-27','11:50:00',1.93),('8784','2013-05-27','11:55:00',2.62),('8784','2013-05-27','12:00:00',5.46),('8784','2013-05-27','12:05:00',2.14),('8784','2013-05-27','12:10:00',5.13),('8784','2013-05-27','12:15:00',4.13),('8784','2013-05-27','12:20:00',5.56),('8784','2013-05-27','12:25:00',4.4),('8784','2013-05-27','12:30:00',5.21),('8784','2013-05-27','12:35:00',3.74),('8784','2013-05-27','12:40:00',5.32),('8784','2013-05-27','12:45:00',2.43),('8784','2013-05-27','12:50:00',5.27),('8784','2013-05-27','12:55:00',3.51),('8784','2013-05-27','13:00:00',1.67),('8784','2013-05-27','13:05:00',2.79),('8784','2013-05-27','13:10:00',4.71),('8784','2013-05-27','13:15:00',1.71),('8784','2013-05-27','13:20:00',5.26),('8784','2013-05-27','13:25:00',4.81),('8784','2013-05-27','13:30:00',5.05),('8784','2013-05-27','13:35:00',2.8),('8784','2013-05-27','13:40:00',4.73),('8784','2013-05-27','13:45:00',4.74),('8784','2013-05-27','13:50:00',4.87),('8784','2013-05-27','13:55:00',4.85),('8784','2013-05-27','14:00:00',4.7),('8784','2013-05-27','14:05:00',4.71),('8784','2013-05-27','14:10:00',4.16),('8784','2013-05-27','14:15:00',4.28),('8784','2013-05-27','14:20:00',2.71),('8784','2013-05-27','14:25:00',4.74),('8784','2013-05-27','14:30:00',4.43),('8784','2013-05-27','14:35:00',3.37),('8784','2013-05-27','14:40:00',3.03),('8784','2013-05-27','14:45:00',4.84),('8784','2013-05-27','14:50:00',4.72),('8784','2013-05-27','14:55:00',3.97),('8784','2013-05-27','15:00:00',3.01),('8784','2013-05-27','15:05:00',2.87),('8784','2013-05-27','15:10:00',4.49),('8784','2013-05-27','15:15:00',3.16),('8784','2013-05-27','15:20:00',3.88),('8784','2013-05-27','15:25:00',3.46),('8784','2013-05-27','15:30:00',3.97),('8784','2013-05-27','15:35:00',4.4),('8784','2013-05-27','15:40:00',3.65),('8784','2013-05-27','15:45:00',3.33),('8784','2013-05-27','15:50:00',4.1),('8784','2013-05-27','15:55:00',2.73),('8784','2013-05-27','16:00:00',3.28),('8784','2013-05-27','16:05:00',2.33),('8784','2013-05-27','16:10:00',2.69),('8784','2013-05-27','16:15:00',2.52),('8784','2013-05-27','16:20:00',4.04),('8784','2013-05-27','16:25:00',3.82),('8784','2013-05-27','16:30:00',3.54),('8784','2013-05-27','16:35:00',2.99),('8784','2013-05-27','16:40:00',1.52),('8784','2013-05-27','16:45:00',1.37),('8784','2013-05-27','16:50:00',1.4),('8784','2013-05-27','16:55:00',1.49),('8784','2013-05-27','17:00:00',1.56),('8784','2013-05-27','17:05:00',1.63),('8784','2013-05-27','17:10:00',2.05),('8784','2013-05-27','17:15:00',1.62),('8784','2013-05-27','17:20:00',1.4),('8784','2013-05-27','17:25:00',1.29),('8784','2013-05-27','17:30:00',1.26),('8784','2013-05-27','17:35:00',1.17),('8784','2013-05-27','17:40:00',1.08),('8784','2013-05-27','17:45:00',1.02),('8784','2013-05-27','18:15:00',1.05),('8784','2013-05-27','18:20:00',1.43),('8784','2013-05-27','18:25:00',2.03),('8784','2013-05-27','18:30:00',1.61),('8784','2013-05-27','18:35:00',1.14),('8784','2013-05-27','18:45:00',1.15),('8784','2013-05-27','18:55:00',1.17),('8784','2013-05-27','19:00:00',1.24),('8784','2013-05-27','19:05:00',1.19),('8784','2013-05-27','19:10:00',1.06),('8784','2013-05-26','07:20:00',1.23),('8784','2013-05-26','07:35:00',1.39),('8784','2013-05-26','07:40:00',1.61),('8784','2013-05-26','07:45:00',1.81),('8784','2013-05-26','07:50:00',2.48),('8784','2013-05-26','08:05:00',2.52),('8784','2013-05-26','08:10:00',1.82),('8784','2013-05-26','08:20:00',1.21),('8784','2013-05-26','08:25:00',1.57),('8784','2013-05-26','08:30:00',2.37),('8784','2013-05-26','08:35:00',1.85),('8784','2013-05-26','08:40:00',2.53),('8784','2013-05-26','08:45:00',3.03),('8784','2013-05-26','08:50:00',3.2),('8784','2013-05-26','08:55:00',1.01),('8784','2013-05-26','09:00:00',1.98),('8784','2013-05-26','09:10:00',2.83),('8784','2013-05-26','09:15:00',1.36),('8784','2013-05-26','09:25:00',1.62),('8784','2013-05-26','09:40:00',1.5),('8784','2013-05-26','09:45:00',2.23),('8784','2013-05-26','09:55:00',1.39),('8784','2013-05-26','10:00:00',1.29),('8784','2013-05-26','10:05:00',3.67),('8784','2013-05-26','10:10:00',4.39),('8784','2013-05-26','10:15:00',2.18),('8784','2013-05-26','10:20:00',2.93),('8784','2013-05-26','10:25:00',3.5),('8784','2013-05-26','10:30:00',4.16),('8784','2013-05-26','10:35:00',4.55),('8784','2013-05-26','10:40:00',4.41),('8784','2013-05-26','10:45:00',4.48),('8784','2013-05-26','10:50:00',4.56),('8784','2013-05-26','10:55:00',4.01),('8784','2013-05-26','11:00:00',4.61),('8784','2013-05-26','11:05:00',4.63),('8784','2013-05-26','11:10:00',4.65),('8784','2013-05-26','11:15:00',4.66),('8784','2013-05-26','11:20:00',4.58),('8784','2013-05-26','11:25:00',4.78),('8784','2013-05-26','11:30:00',4.85),('8784','2013-05-26','11:35:00',4.58),('8784','2013-05-26','11:40:00',4.58),('8784','2013-05-26','11:45:00',4.71),('8784','2013-05-26','11:50:00',4.92),('8784','2013-05-26','11:55:00',4.6),('8784','2013-05-26','12:00:00',4.82),('8784','2013-05-26','12:05:00',5.01),('8784','2013-05-26','12:10:00',4.37),('8784','2013-05-26','12:15:00',3.11),('8784','2013-05-26','12:20:00',4.48),('8784','2013-05-26','12:25:00',4.56),('8784','2013-05-26','12:30:00',5.17),('8784','2013-05-26','12:35:00',5.17),('8784','2013-05-26','12:40:00',4.84),('8784','2013-05-26','12:45:00',4.73),('8784','2013-05-26','12:50:00',5.11),('8784','2013-05-26','12:55:00',5.1),('8784','2013-05-26','13:00:00',4.39),('8784','2013-05-26','13:05:00',4.76),('8784','2013-05-26','13:10:00',5.16),('8784','2013-05-26','13:15:00',5.14),('8784','2013-05-26','13:20:00',5.1),('8784','2013-05-26','13:25:00',5.05),('8784','2013-05-26','13:30:00',4.94),('8784','2013-05-26','13:35:00',5.06),('8784','2013-05-26','13:40:00',4.98),('8784','2013-05-26','13:45:00',5),('8784','2013-05-26','13:50:00',4.99),('8784','2013-05-26','13:55:00',4.9),('8784','2013-05-26','14:00:00',4.94),('8784','2013-05-26','14:05:00',4.88),('8784','2013-05-26','14:10:00',4.84),('8784','2013-05-26','14:15:00',4.8),('8784','2013-05-26','14:20:00',4.78),('8784','2013-05-26','14:25:00',4.71),('8784','2013-05-26','14:30:00',4.72),('8784','2013-05-26','14:35:00',4.67),('8784','2013-05-26','14:40:00',4.67),('8784','2013-05-26','14:45:00',4.6),('8784','2013-05-26','14:50:00',4.59),('8784','2013-05-26','14:55:00',4.54),('8784','2013-05-26','15:00:00',4.48),('8784','2013-05-26','15:05:00',4.46),('8784','2013-05-26','15:10:00',4.43),('8784','2013-05-26','15:15:00',4.41),('8784','2013-05-26','15:20:00',4.35),('8784','2013-05-26','15:25:00',4.3),('8784','2013-05-26','15:30:00',4.27),('8784','2013-05-26','15:35:00',4.21),('8784','2013-05-26','15:40:00',4.16),('8784','2013-05-26','15:45:00',4.08),('8784','2013-05-26','15:50:00',4.03),('8784','2013-05-26','15:55:00',3.98),('8784','2013-05-26','16:00:00',3.9),('8784','2013-05-26','16:05:00',3.87),('8784','2013-05-26','16:10:00',3.8),('8784','2013-05-26','16:15:00',3.71),('8784','2013-05-26','16:20:00',3.64),('8784','2013-05-26','16:25:00',3.58),('8784','2013-05-26','16:30:00',3.5),('8784','2013-05-26','16:35:00',3.42),('8784','2013-05-26','16:40:00',3.35),('8784','2013-05-26','16:45:00',3.28),('8784','2013-05-26','16:50:00',3.19),('8784','2013-05-26','16:55:00',3.11),('8784','2013-05-26','17:00:00',3.03),('8784','2013-05-26','17:05:00',2.96),('8784','2013-05-26','17:10:00',2.86),('8784','2013-05-26','17:15:00',2.77),('8784','2013-05-26','17:20:00',2.69),('8784','2013-05-26','17:25:00',2.61),('8784','2013-05-26','17:30:00',2.52),('8784','2013-05-26','17:35:00',2.35),('8784','2013-05-26','17:40:00',2.35),('8784','2013-05-26','17:45:00',2.24),('8784','2013-05-26','17:50:00',2.15),('8784','2013-05-26','17:55:00',2.06),('8784','2013-05-26','18:00:00',1.98),('8784','2013-05-26','18:05:00',1.88),('8784','2013-05-26','18:10:00',1.78),('8784','2013-05-26','18:15:00',1.68),('8784','2013-05-26','18:20:00',1.6),('8784','2013-05-26','18:25:00',1.51),('8784','2013-05-26','18:30:00',1.42),('8784','2013-05-26','18:35:00',1.32),('8784','2013-05-26','18:40:00',1.22),('8784','2013-05-26','18:45:00',1.14),('8784','2013-05-26','18:50:00',1.06),('8784','2013-05-25','07:15:00',1.34),('8784','2013-05-25','07:20:00',1.2),('8784','2013-05-25','07:25:00',1.03),('8784','2013-05-25','07:30:00',1.52),('8784','2013-05-25','07:35:00',1.97),('8784','2013-05-25','07:40:00',1.46),('8784','2013-05-25','07:50:00',1.04),('8784','2013-05-25','07:55:00',2.02),('8784','2013-05-25','08:00:00',2.46),('8784','2013-05-25','08:05:00',2.16),('8784','2013-05-25','08:10:00',1.56),('8784','2013-05-25','08:20:00',1.83),('8784','2013-05-25','08:25:00',2.76),('8784','2013-05-25','08:30:00',2.92),('8784','2013-05-25','08:35:00',1.67),('8784','2013-05-25','08:40:00',1.64),('8784','2013-05-25','08:45:00',1.35),('8784','2013-05-25','08:50:00',2.1),('8784','2013-05-25','08:55:00',1.7),('8784','2013-05-25','09:00:00',2.46),('8784','2013-05-25','09:05:00',2.92),('8784','2013-05-25','09:10:00',3.4),('8784','2013-05-25','09:15:00',3.74),('8784','2013-05-25','09:20:00',1.6),('8784','2013-05-25','09:25:00',1.64),('8784','2013-05-25','09:30:00',1.2),('8784','2013-05-25','09:35:00',2.85),('8784','2013-05-25','09:40:00',3.85),('8784','2013-05-25','09:45:00',2.88),('8784','2013-05-25','09:50:00',4.01),('8784','2013-05-25','09:55:00',2.24),('8784','2013-05-25','10:10:00',1.29),('8784','2013-05-25','10:15:00',1.15),('8784','2013-05-25','10:25:00',1),('8784','2013-05-25','10:40:00',1.71),('8784','2013-05-25','10:45:00',1.51),('8784','2013-05-25','10:50:00',1.49),('8784','2013-05-25','11:00:00',1.25),('8784','2013-05-25','11:05:00',2.15),('8784','2013-05-25','11:10:00',4.48),('8784','2013-05-25','11:15:00',4.29),('8784','2013-05-25','11:20:00',3),('8784','2013-05-25','11:25:00',1.06),('8784','2013-05-25','11:35:00',1.87),('8784','2013-05-25','11:40:00',2.37),('8784','2013-05-25','11:45:00',2.69),('8784','2013-05-25','11:50:00',2.16),('8784','2013-05-25','11:55:00',2.1),('8784','2013-05-25','12:00:00',1.78),('8784','2013-05-25','12:05:00',1.51),('8784','2013-05-25','12:10:00',1.93),('8784','2013-05-25','12:15:00',1.34),('8784','2013-05-25','12:20:00',1.69),('8784','2013-05-25','12:25:00',2.16),('8784','2013-05-25','12:30:00',1.5),('8784','2013-05-25','12:35:00',1.7),('8784','2013-05-25','12:40:00',1.98),('8784','2013-05-25','12:45:00',1.96),('8784','2013-05-25','12:50:00',1.47),('8784','2013-05-25','12:55:00',2.12),('8784','2013-05-25','13:00:00',1.14),('8784','2013-05-25','13:05:00',1.81),('8784','2013-05-25','13:10:00',1.59),('8784','2013-05-25','13:15:00',2.06),('8784','2013-05-25','13:20:00',2.3),('8784','2013-05-25','13:25:00',4.17),('8784','2013-05-25','13:30:00',1.81),('8784','2013-05-25','13:35:00',1.59),('8784','2013-05-25','13:40:00',2.27),('8784','2013-05-25','13:45:00',2.05),('8784','2013-05-25','13:50:00',2.58),('8784','2013-05-25','13:55:00',3.85),('8784','2013-05-25','14:00:00',3.89),('8784','2013-05-25','14:05:00',4.33),('8784','2013-05-25','14:10:00',4.68),('8784','2013-05-25','14:15:00',3.95),('8784','2013-05-25','14:20:00',4.54),('8784','2013-05-25','14:25:00',3.09),('8784','2013-05-25','14:30:00',3.56),('8784','2013-05-25','14:35:00',3.03),('8784','2013-05-25','14:40:00',1.45),('8784','2013-05-25','14:45:00',3.46),('8784','2013-05-25','14:50:00',1.32),('8784','2013-05-25','14:55:00',2.03),('8784','2013-05-25','15:00:00',4.39),('8784','2013-05-25','15:05:00',2.67),('8784','2013-05-25','15:10:00',2.32),('8784','2013-05-25','15:15:00',2.6),('8784','2013-05-25','15:20:00',1.6),('8784','2013-05-25','15:25:00',3.04),('8784','2013-05-25','15:30:00',2.91),('8784','2013-05-25','15:35:00',4.71),('8784','2013-05-25','15:40:00',4.46),('8784','2013-05-25','15:45:00',3.92),('8784','2013-05-25','15:50:00',4.61),('8784','2013-05-25','15:55:00',4.44),('8784','2013-05-25','16:00:00',2.78),('8784','2013-05-25','16:05:00',2.31),('8784','2013-05-25','16:10:00',2.73),('8784','2013-05-25','16:15:00',2.27),('8784','2013-05-25','16:20:00',1.72),('8784','2013-05-25','16:25:00',1.94),('8784','2013-05-25','16:30:00',2.79),('8784','2013-05-25','16:35:00',3.56),('8784','2013-05-25','16:40:00',3.25),('8784','2013-05-25','16:45:00',2.74),('8784','2013-05-25','16:50:00',1.73),('8784','2013-05-25','16:55:00',1.05),('8784','2013-05-25','17:00:00',1.01),('8784','2013-05-25','17:05:00',1.98),('8784','2013-05-25','17:10:00',3.2),('8784','2013-05-25','17:15:00',2.55),('8784','2013-05-25','17:20:00',2.16),('8784','2013-05-25','17:25:00',1.33),('8784','2013-05-25','17:30:00',1.03),('8784','2013-05-25','17:35:00',1.67),('8784','2013-05-25','17:40:00',1.12),('8784','2013-05-25','17:45:00',1.18),('8784','2013-05-25','17:50:00',1.78),('8784','2013-05-25','18:00:00',1.04),('8784','2013-05-25','18:10:00',1.1),('8784','2013-05-24','07:00:00',1.03),('8784','2013-05-24','08:00:00',1.13),('8784','2013-05-24','08:05:00',2.14),('8784','2013-05-24','08:10:00',2.5),('8784','2013-05-24','08:15:00',1.94),('8784','2013-05-24','08:25:00',1.58),('8784','2013-05-24','08:30:00',2.56),('8784','2013-05-24','08:35:00',1.72),('8784','2013-05-24','08:40:00',1.49),('8784','2013-05-24','08:45:00',2.68),('8784','2013-05-24','08:50:00',2.76),('8784','2013-05-24','08:55:00',2.88),('8784','2013-05-24','09:00:00',3.11),('8784','2013-05-24','09:05:00',3.53),('8784','2013-05-24','09:20:00',2.79),('8784','2013-05-24','09:25:00',1.57),('8784','2013-05-24','09:30:00',1.83),('8784','2013-05-24','09:40:00',1.69),('8784','2013-05-24','09:45:00',1.23),('8784','2013-05-24','09:50:00',1.61),('8784','2013-05-24','09:55:00',3.4),('8784','2013-05-24','10:00:00',1.89),('8784','2013-05-24','10:20:00',1.38),('8784','2013-05-24','10:25:00',2.83),('8784','2013-05-24','10:30:00',4.36),('8784','2013-05-24','10:35:00',4.11),('8784','2013-05-24','10:40:00',3.9),('8784','2013-05-24','10:45:00',4.12),('8784','2013-05-24','10:50:00',3.25),('8784','2013-05-24','10:55:00',4.94),('8784','2013-05-24','11:00:00',3.38),('8784','2013-05-24','11:05:00',3.69),('8784','2013-05-24','11:10:00',4.55),('8784','2013-05-24','11:15:00',3.69),('8784','2013-05-24','11:20:00',4.71),('8784','2013-05-24','11:25:00',4.98),('8784','2013-05-24','11:30:00',3.02),('8784','2013-05-24','11:35:00',1.5),('8784','2013-05-24','11:40:00',1.02),('8784','2013-05-24','11:45:00',3.39),('8784','2013-05-24','11:50:00',5.41),('8784','2013-05-24','11:55:00',3.37),('8784','2013-05-24','12:00:00',2.74),('8784','2013-05-24','12:05:00',2.88),('8784','2013-05-24','12:10:00',4.09),('8784','2013-05-24','12:15:00',2.7),('8784','2013-05-24','12:20:00',2.44),('8784','2013-05-24','12:25:00',4.31),('8784','2013-05-24','12:30:00',4.72),('8784','2013-05-24','12:35:00',2.45),('8784','2013-05-24','12:40:00',3.11),('8784','2013-05-24','12:45:00',3.9),('8784','2013-05-24','12:50:00',3.26),('8784','2013-05-24','12:55:00',2.91),('8784','2013-05-24','13:00:00',2.75),('8784','2013-05-24','13:05:00',2.3),('8784','2013-05-24','13:10:00',2.87),('8784','2013-05-24','13:15:00',3.2),('8784','2013-05-24','13:20:00',3.37),('8784','2013-05-24','13:25:00',2.6),('8784','2013-05-24','13:30:00',2.26),('8784','2013-05-24','13:35:00',2.83),('8784','2013-05-24','13:40:00',2.39),('8784','2013-05-24','13:45:00',1.27),('8784','2013-05-24','13:50:00',1.4),('8784','2013-05-24','13:55:00',2.89),('8784','2013-05-24','14:00:00',2.37),('8784','2013-05-24','14:05:00',2.12),('8784','2013-05-24','14:10:00',1.54),('8784','2013-05-24','14:15:00',3.75),('8784','2013-05-24','14:20:00',3.53),('8784','2013-05-24','14:25:00',3.69),('8784','2013-05-24','14:30:00',2.76),('8784','2013-05-24','14:35:00',3.69),('8784','2013-05-24','14:40:00',2.71),('8784','2013-05-24','14:45:00',3.09),('8784','2013-05-24','14:50:00',1.54),('8784','2013-05-24','14:55:00',1.85),('8784','2013-05-24','15:00:00',3),('8784','2013-05-24','15:05:00',2.85),('8784','2013-05-24','15:10:00',2.43),('8784','2013-05-24','15:15:00',4.07),('8784','2013-05-24','15:20:00',4.25),('8784','2013-05-24','15:25:00',3.68),('8784','2013-05-24','15:30:00',4.98),('8784','2013-05-24','15:35:00',4.22),('8784','2013-05-24','15:40:00',3.43),('8784','2013-05-24','15:45:00',4.3),('8784','2013-05-24','15:50:00',4.8),('8784','2013-05-24','15:55:00',4.78),('8784','2013-05-24','16:00:00',2.36),('8784','2013-05-24','16:05:00',2.38),('8784','2013-05-24','16:10:00',2.5),('8784','2013-05-24','16:15:00',3.09),('8784','2013-05-24','16:20:00',2.4),('8784','2013-05-24','16:25:00',3.33),('8784','2013-05-24','16:30:00',3.14),('8784','2013-05-24','16:35:00',1.76),('8784','2013-05-24','16:50:00',1.65),('8784','2013-05-24','16:55:00',1.98),('8784','2013-05-24','17:00:00',1.5),('8784','2013-05-24','17:05:00',1.1),('8784','2013-05-24','17:20:00',1.14),('8784','2013-05-24','17:25:00',1.18),('8784','2013-05-24','17:30:00',1.22),('8784','2013-05-24','17:35:00',1.23),('8784','2013-05-24','17:40:00',1.06),('8784','2013-05-23','07:55:00',1.06),('8784','2013-05-23','08:00:00',1.3),('8784','2013-05-23','08:05:00',1.79),('8784','2013-05-23','08:10:00',1.34),('8784','2013-05-23','08:30:00',2.23),('8784','2013-05-23','08:35:00',2.19),('8784','2013-05-23','08:40:00',2.73),('8784','2013-05-23','08:45:00',1.72),('8784','2013-05-23','08:55:00',1.15),('8784','2013-05-23','09:00:00',3.06),('8784','2013-05-23','09:05:00',1.25),('8784','2013-05-23','09:15:00',1.12),('8784','2013-05-23','09:20:00',2.44),('8784','2013-05-23','09:25:00',3.63),('8784','2013-05-23','09:30:00',3.58),('8784','2013-05-23','09:35:00',2.81),('8784','2013-05-23','09:40:00',3.3),('8784','2013-05-23','09:45:00',2.18),('8784','2013-05-23','09:50:00',3.16),('8784','2013-05-23','09:55:00',1.83),('8784','2013-05-23','10:00:00',1.27),('8784','2013-05-23','10:05:00',3.91),('8784','2013-05-23','10:10:00',4.25),('8784','2013-05-23','10:15:00',4.3),('8784','2013-05-23','10:20:00',2.33),('8784','2013-05-23','10:25:00',3.74),('8784','2013-05-23','10:30:00',3.87),('8784','2013-05-23','10:35:00',3.92),('8784','2013-05-23','10:40:00',4.02),('8784','2013-05-23','10:45:00',4.4),('8784','2013-05-23','10:50:00',3.01),('8784','2013-05-23','10:55:00',4.02),('8784','2013-05-23','11:00:00',2.54),('8784','2013-05-23','11:05:00',4.14),('8784','2013-05-23','11:10:00',2.31),('8784','2013-05-23','11:15:00',2.61),('8784','2013-05-23','11:20:00',1.89),('8784','2013-05-23','11:25:00',2.74),('8784','2013-05-23','11:30:00',3.31),('8784','2013-05-23','11:35:00',3.48),('8784','2013-05-23','11:40:00',4.9),('8784','2013-05-23','11:45:00',2.52),('8784','2013-05-23','11:50:00',3.71),('8784','2013-05-23','11:55:00',4.39),('8784','2013-05-23','12:00:00',5.04),('8784','2013-05-23','12:05:00',5.06),('8784','2013-05-23','12:10:00',5.17),('8784','2013-05-23','12:15:00',3.25),('8784','2013-05-23','12:20:00',3.52),('8784','2013-05-23','12:25:00',4.33),('8784','2013-05-23','12:30:00',5.1),('8784','2013-05-23','12:35:00',1.69),('8784','2013-05-23','12:40:00',5.71),('8784','2013-05-23','12:45:00',3.32),('8784','2013-05-23','12:50:00',4.05),('8784','2013-05-23','12:55:00',5.29),('8784','2013-05-23','13:00:00',4.97),('8784','2013-05-23','13:05:00',3.85),('8784','2013-05-23','13:10:00',4.64),('8784','2013-05-23','13:15:00',4.36),('8784','2013-05-23','13:20:00',3.86),('8784','2013-05-23','13:25:00',4.56),('8784','2013-05-23','13:30:00',3.26),('8784','2013-05-23','13:35:00',2.65),('8784','2013-05-23','13:40:00',2.8),('8784','2013-05-23','13:45:00',3.55),('8784','2013-05-23','13:50:00',3.87),('8784','2013-05-23','13:55:00',4.56),('8784','2013-05-23','14:00:00',4.85),('8784','2013-05-23','14:05:00',4.99),('8784','2013-05-23','14:10:00',4.92),('8784','2013-05-23','14:15:00',3.84),('8784','2013-05-23','14:20:00',4.29),('8784','2013-05-23','14:25:00',3.15),('8784','2013-05-23','14:30:00',2.04),('8784','2013-05-23','14:35:00',5.28),('8784','2013-05-23','14:40:00',3.7),('8784','2013-05-23','14:45:00',2.05),('8784','2013-05-23','14:50:00',2.19),('8784','2013-05-23','14:55:00',3.4),('8784','2013-05-23','15:00:00',3.37),('8784','2013-05-23','15:05:00',3.3),('8784','2013-05-23','15:10:00',1.48),('8784','2013-05-23','15:15:00',2),('8784','2013-05-23','15:20:00',3.46),('8784','2013-05-23','15:25:00',1.56),('8784','2013-05-23','15:30:00',4.01),('8784','2013-05-23','15:35:00',3.5),('8784','2013-05-23','15:40:00',1.5),('8784','2013-05-23','15:45:00',2.6),('8784','2013-05-23','15:50:00',1.3),('8784','2013-05-23','15:55:00',2.12),('8784','2013-05-23','16:00:00',2.93),('8784','2013-05-23','16:05:00',4.05),('8784','2013-05-23','16:10:00',2.06),('8784','2013-05-23','16:15:00',3.44),('8784','2013-05-23','16:20:00',2.81),('8784','2013-05-23','16:25:00',2.96),('8784','2013-05-23','16:30:00',3.37),('8784','2013-05-23','16:35:00',1.74),('8784','2013-05-23','16:40:00',1.31),('8784','2013-05-23','16:45:00',1.99),('8784','2013-05-23','16:50:00',1.28),('8784','2013-05-23','17:05:00',1.3),('8784','2013-05-23','17:10:00',2.69),('8784','2013-05-23','17:15:00',2.12),('8784','2013-05-23','17:20:00',1.59),('8784','2013-05-23','17:25:00',1.05),('8784','2013-05-23','17:35:00',1.73),('8784','2013-05-23','17:40:00',1.11),('8784','2013-05-23','17:45:00',1.05),('8784','2013-05-23','17:55:00',1.55),('8784','2013-05-23','18:00:00',2.08),('8784','2013-05-23','18:05:00',2.6),('8784','2013-05-23','18:45:00',1.11),('8784','2013-05-23','18:50:00',1.32),('8784','2013-05-23','18:55:00',1.03),('8784','2013-05-22','07:50:00',1.08),('8784','2013-05-22','07:55:00',1.18),('8784','2013-05-22','08:00:00',1.31),('8784','2013-05-22','08:05:00',1.63),('8784','2013-05-22','08:10:00',1.44),('8784','2013-05-22','08:15:00',2.38),('8784','2013-05-22','08:20:00',2.25),('8784','2013-05-22','08:25:00',1.97),('8784','2013-05-22','08:30:00',2.49),('8784','2013-05-22','08:35:00',2.99),('8784','2013-05-22','08:40:00',1.64),('8784','2013-05-22','08:45:00',1.83),('8784','2013-05-22','08:50:00',1.11),('8784','2013-05-22','09:25:00',1.43),('8784','2013-05-22','09:30:00',3.27),('8784','2013-05-22','09:35:00',3.25),('8784','2013-05-22','09:40:00',3.23),('8784','2013-05-22','09:45:00',3.24),('8784','2013-05-22','09:50:00',3.3),('8784','2013-05-22','09:55:00',3.36),('8784','2013-05-22','10:00:00',3.43),('8784','2013-05-22','10:05:00',3.48),('8784','2013-05-22','10:10:00',3.55),('8784','2013-05-22','10:15:00',3.61),('8784','2013-05-22','10:20:00',3.47),('8784','2013-05-22','10:25:00',3.76),('8784','2013-05-22','10:30:00',3.8),('8784','2013-05-22','10:35:00',3.81),('8784','2013-05-22','10:40:00',4.04),('8784','2013-05-22','10:45:00',4.02),('8784','2013-05-22','10:50:00',3.95),('8784','2013-05-22','10:55:00',3.97),('8784','2013-05-22','11:00:00',4.06),('8784','2013-05-22','11:05:00',4.19),('8784','2013-05-22','11:10:00',3.03),('8784','2013-05-22','11:15:00',4.11),('8784','2013-05-22','11:20:00',4.28),('8784','2013-05-22','11:25:00',4.34),('8784','2013-05-22','11:30:00',3.54),('8784','2013-05-22','11:35:00',3.73),('8784','2013-05-22','11:40:00',2.96),('8784','2013-05-22','11:45:00',4.37),('8784','2013-05-22','11:50:00',2.62),('8784','2013-05-22','11:55:00',2.21),('8784','2013-05-22','12:00:00',3.2),('8784','2013-05-22','12:05:00',2.54),('8784','2013-05-22','12:10:00',2.52),('8784','2013-05-22','12:15:00',3.3),('8784','2013-05-22','12:20:00',4.05),('8784','2013-05-22','12:25:00',3.44),('8784','2013-05-22','12:30:00',2.36),('8784','2013-05-22','12:35:00',2.59),('8784','2013-05-22','12:40:00',1.78),('8784','2013-05-22','13:00:00',1.11),('8784','2013-05-22','13:05:00',4.6),('8784','2013-05-22','13:10:00',2.9),('8784','2013-05-22','13:15:00',2.92),('8784','2013-05-22','13:20:00',3.3),('8784','2013-05-22','13:25:00',1.23),('8784','2013-05-22','13:30:00',1.85),('8784','2013-05-22','13:35:00',4.07),('8784','2013-05-22','13:40:00',2.82),('8784','2013-05-22','13:45:00',2.36),('8784','2013-05-22','13:50:00',1.85),('8784','2013-05-22','13:55:00',2.14),('8784','2013-05-22','14:00:00',2.93),('8784','2013-05-22','14:05:00',3.51),('8784','2013-05-22','14:10:00',4.53),('8784','2013-05-22','14:15:00',4.47),('8784','2013-05-22','14:20:00',4.35),('8784','2013-05-22','14:25:00',4.29),('8784','2013-05-22','14:30:00',4.24),('8784','2013-05-22','14:35:00',4.09),('8784','2013-05-22','14:40:00',4.17),('8784','2013-05-22','14:45:00',4.18),('8784','2013-05-22','14:50:00',4.15),('8784','2013-05-22','14:55:00',4.1),('8784','2013-05-22','15:00:00',4.06),('8784','2013-05-22','15:05:00',4),('8784','2013-05-22','15:10:00',3.87),('8784','2013-05-22','15:15:00',3.84),('8784','2013-05-22','15:20:00',3.39),('8784','2013-05-22','15:25:00',2.33),('8784','2013-05-22','15:30:00',2.1),('8784','2013-05-22','15:35:00',2.23),('8784','2013-05-22','15:40:00',3.67),('8784','2013-05-22','15:45:00',2.95),('8784','2013-05-22','15:50:00',3.62),('8784','2013-05-22','15:55:00',3.52),('8784','2013-05-22','16:00:00',3.47),('8784','2013-05-22','16:05:00',3.36),('8784','2013-05-22','16:10:00',3.31),('8784','2013-05-22','16:15:00',3.2),('8784','2013-05-22','16:20:00',3.17),('8784','2013-05-22','16:25:00',3.11),('8784','2013-05-22','16:30:00',3.01),('8784','2013-05-22','16:35:00',2.86),('8784','2013-05-22','16:40:00',2.88),('8784','2013-05-22','16:45:00',2.63),('8784','2013-05-22','16:50:00',1.25),('8784','2013-05-22','17:15:00',1.19),('8784','2013-05-22','17:20:00',1.32),('8784','2013-05-22','17:25:00',1.74),('8784','2013-05-22','17:30:00',1.43),('8784','2013-05-22','17:35:00',1.73),('8784','2013-05-22','17:55:00',1.6),('8784','2013-05-22','18:00:00',1.76),('8784','2014-04-01','08:15:00',1.02),('8784','2014-04-01','08:20:00',1.1),('8784','2014-04-01','08:25:00',1.19),('8784','2014-04-01','08:30:00',1.29),('8784','2014-04-01','08:35:00',1.36),('8784','2014-04-01','08:40:00',1.47),('8784','2014-04-01','08:45:00',1.57),('8784','2014-04-01','08:50:00',1.67),('8784','2014-04-01','08:55:00',1.76),('8784','2014-04-01','09:00:00',1.84),('8784','2014-04-01','09:05:00',1.95),('8784','2014-04-01','09:10:00',2.02),('8784','2014-04-01','09:15:00',2.09),('8784','2014-04-01','09:20:00',2.16),('8784','2014-04-01','09:25:00',2.26),('8784','2014-04-01','09:30:00',2.3),('8784','2014-04-01','09:35:00',2.41),('8784','2014-04-01','09:40:00',2.54),('8784','2014-04-01','09:45:00',2.58),('8784','2014-04-01','09:50:00',2.67),('8784','2014-04-01','09:55:00',2.77),('8784','2014-04-01','10:00:00',2.84),('8784','2014-04-01','10:05:00',2.89),('8784','2014-04-01','10:10:00',2.95),('8784','2014-04-01','10:15:00',3.08),('8784','2014-04-01','10:20:00',3.25),('8784','2014-04-01','10:25:00',3.44),('8784','2014-04-01','10:30:00',3.59),('8784','2014-04-01','10:35:00',3.16),('8784','2014-04-01','10:40:00',2.39),('8784','2014-04-01','10:45:00',2.6),('8784','2014-04-01','10:50:00',3.58),('8784','2014-04-01','10:55:00',3.54),('8784','2014-04-01','11:00:00',3.6),('8784','2014-04-01','11:05:00',3.63),('8784','2014-04-01','11:10:00',3.66),('8784','2014-04-01','11:15:00',3.68),('8784','2014-04-01','11:20:00',3.76),('8784','2014-04-01','11:25:00',3.78),('8784','2014-04-01','11:30:00',3.87),('8784','2014-04-01','11:35:00',3.9),('8784','2014-04-01','11:40:00',3.92),('8784','2014-04-01','11:45:00',3.98),('8784','2014-04-01','11:50:00',3.97),('8784','2014-04-01','11:55:00',4),('8784','2014-04-01','12:00:00',4.05),('8784','2014-04-01','12:05:00',4.08),('8784','2014-04-01','12:10:00',4.12),('8784','2014-04-01','12:15:00',4.13),('8784','2014-04-01','12:20:00',4.16),('8784','2014-04-01','12:25:00',4.2),('8784','2014-04-01','12:30:00',4.24),('8784','2014-04-01','12:35:00',4.25),('8784','2014-04-01','12:40:00',4.24),('8784','2014-04-01','12:45:00',4.31),('8784','2014-04-01','12:50:00',4.1),('8784','2014-04-01','12:55:00',4.31),('8784','2014-04-01','13:00:00',4.33),('8784','2014-04-01','13:05:00',4.03),('8784','2014-04-01','13:10:00',4.38),('8784','2014-04-01','13:15:00',3.83),('8784','2014-04-01','13:20:00',4),('8784','2014-04-01','13:25:00',4.3),('8784','2014-04-01','13:30:00',4.3),('8784','2014-04-01','13:35:00',4.33),('8784','2014-04-01','13:40:00',4.43),('8784','2014-04-01','13:45:00',4.34),('8784','2014-04-01','13:50:00',4.22),('8784','2014-04-01','13:55:00',4.24),('8784','2014-04-01','14:00:00',4.19),('8784','2014-04-01','14:05:00',4.22),('8784','2014-04-01','14:10:00',3.82),('8784','2014-04-01','14:15:00',3.54),('8784','2014-04-01','14:20:00',3.08),('8784','2014-04-01','14:25:00',3.83),('8784','2014-04-01','14:30:00',3.47),('8784','2014-04-01','14:35:00',3.99),('8784','2014-04-01','14:40:00',3.39),('8784','2014-04-01','14:45:00',4.3),('8784','2014-04-01','14:50:00',3.92),('8784','2014-04-01','14:55:00',3.05),('8784','2014-04-01','15:00:00',4.02),('8784','2014-04-01','15:05:00',3.25),('8784','2014-04-01','15:10:00',3.66),('8784','2014-04-01','15:15:00',2.99),('8784','2014-04-01','15:20:00',2.04),('8784','2014-04-01','15:25:00',3.37),('8784','2014-04-01','15:30:00',3.32),('8784','2014-04-01','15:35:00',2.71),('8784','2014-04-01','15:40:00',3.81),('8784','2014-04-01','15:45:00',2.91),('8784','2014-04-01','15:50:00',3.38),('8784','2014-04-01','15:55:00',3.05),('8784','2014-04-01','16:00:00',1.96),('8784','2014-04-01','16:05:00',3.09),('8784','2014-04-01','16:10:00',2.77),('8784','2014-04-01','16:15:00',2.12),('8784','2014-04-01','16:20:00',1.31),('8784','2014-04-01','16:25:00',2.37),('8784','2014-04-01','16:30:00',2.56),('8784','2014-04-01','16:35:00',2.79),('8784','2014-04-01','16:40:00',2.34),('8784','2014-04-01','16:45:00',1.33),('8784','2014-04-01','16:50:00',1.61),('8784','2014-04-01','16:55:00',1.99),('8784','2014-04-01','17:00:00',2.24),('8784','2014-04-01','17:05:00',2.1),('8784','2014-04-01','17:10:00',1.62),('8784','2014-04-01','17:15:00',1.96),('8784','2014-04-01','17:20:00',1.83),('8784','2014-04-01','17:25:00',1.54),('8784','2014-04-01','17:30:00',1.62),('8784','2014-04-01','17:35:00',1.49),('8784','2014-04-01','17:40:00',1.42),('8784','2014-04-01','17:45:00',1.33),('8784','2014-04-01','17:50:00',1.25),('8784','2014-04-01','17:55:00',1.13),('8784','2014-04-01','18:00:00',1.04),('8784','2013-05-21','07:20:00',1.04),('8784','2013-05-21','07:25:00',1.14),('8784','2013-05-21','07:30:00',1.3),('8784','2013-05-21','07:35:00',1.57),('8784','2013-05-21','07:40:00',1.78),('8784','2013-05-21','07:45:00',1.44),('8784','2013-05-21','07:50:00',1.21),('8784','2013-05-21','07:55:00',1.25),('8784','2013-05-21','08:00:00',1.37),('8784','2013-05-21','08:05:00',1.02),('8784','2013-05-21','08:10:00',1.69),('8784','2013-05-21','08:15:00',2.16),('8784','2013-05-21','08:20:00',1.8),('8784','2013-05-21','08:25:00',2.11),('8784','2013-05-21','08:30:00',1.51),('8784','2013-05-21','08:35:00',1.44),('8784','2013-05-21','08:40:00',1.64),('8784','2013-05-21','08:45:00',1.41),('8784','2013-05-21','08:50:00',1.54),('8784','2013-05-21','08:55:00',1.97),('8784','2013-05-21','09:00:00',1.68),('8784','2013-05-21','09:05:00',1.5),('8784','2013-05-21','09:10:00',1.66),('8784','2013-05-21','09:15:00',1.83),('8784','2013-05-21','09:20:00',2.63),('8784','2013-05-21','09:25:00',2.55),('8784','2013-05-21','09:30:00',2.09),('8784','2013-05-21','09:35:00',2.19),('8784','2013-05-21','09:40:00',2.18),('8784','2013-05-21','09:45:00',1.87),('8784','2013-05-21','09:50:00',1.82),('8784','2013-05-21','09:55:00',2.05),('8784','2013-05-21','10:00:00',2.22),('8784','2013-05-21','10:05:00',2.48),('8784','2013-05-21','10:10:00',2.5),('8784','2013-05-21','10:15:00',2.67),('8784','2013-05-21','10:20:00',2.22),('8784','2013-05-21','10:25:00',2.12),('8784','2013-05-21','10:30:00',1.97),('8784','2013-05-21','10:35:00',2.06),('8784','2013-05-21','10:40:00',2.28),('8784','2013-05-21','10:45:00',3.22),('8784','2013-05-21','10:50:00',2.31),('8784','2013-05-21','10:55:00',1.81),('8784','2013-05-21','11:00:00',2.12),('8784','2013-05-21','11:05:00',2),('8784','2013-05-21','11:10:00',2.98),('8784','2013-05-21','11:15:00',4.1),('8784','2013-05-21','11:20:00',3.88),('8784','2013-05-21','11:25:00',4.42),('8784','2013-05-21','11:30:00',3.25),('8784','2013-05-21','11:35:00',2.83),('8784','2013-05-21','11:40:00',2.84),('8784','2013-05-21','11:45:00',2.38),('8784','2013-05-21','11:50:00',3.03),('8784','2013-05-21','11:55:00',3.86),('8784','2013-05-21','12:00:00',3.47),('8784','2013-05-21','12:05:00',4.07),('8784','2013-05-21','12:10:00',2.96),('8784','2013-05-21','12:15:00',3.34),('8784','2013-05-21','12:20:00',2.58),('8784','2013-05-21','12:25:00',3.44),('8784','2013-05-21','12:30:00',4.37),('8784','2013-05-21','12:35:00',2.93),('8784','2013-05-21','12:40:00',4.59),('8784','2013-05-21','12:45:00',4.17),('8784','2013-05-21','12:50:00',2.9),('8784','2013-05-21','12:55:00',4.99),('8784','2013-05-21','13:00:00',4.26),('8784','2013-05-21','13:05:00',4.31),('8784','2013-05-21','13:10:00',2.75),('8784','2013-05-21','13:15:00',3.84),('8784','2013-05-21','13:20:00',3.28),('8784','2013-05-21','13:25:00',3.27),('8784','2013-05-21','13:30:00',3.14),('8784','2013-05-21','13:35:00',1.59),('8784','2013-05-21','14:05:00',1.19),('8784','2013-05-21','14:10:00',1.89),('8784','2013-05-21','14:15:00',2.26),('8784','2013-05-21','14:20:00',1.89),('8784','2013-05-21','14:25:00',2.91),('8784','2013-05-21','14:30:00',2.78),('8784','2013-05-21','14:35:00',2.14),('8784','2013-05-21','14:40:00',2.05),('8784','2013-05-21','14:45:00',1.73),('8784','2013-05-21','14:50:00',1.09),('8784','2013-05-21','15:15:00',1.24),('8784','2013-05-21','15:20:00',1.65),('8784','2013-05-21','15:25:00',1.69),('8784','2013-05-21','15:30:00',2.63),('8784','2013-05-21','15:35:00',1.78),('8784','2013-05-21','15:40:00',1.46),('8784','2013-05-21','15:45:00',1.52),('8784','2013-05-21','15:50:00',1.37),('8784','2013-05-21','15:55:00',1.32),('8784','2013-05-21','16:00:00',1.29),('8784','2013-05-21','16:05:00',1.3),('8784','2013-05-21','16:10:00',1.44),('8784','2013-05-21','16:15:00',1.21),('8784','2013-05-21','16:20:00',1.01),('8784','2013-05-21','16:25:00',1.38),('8784','2013-05-21','16:30:00',1.9),('8784','2013-05-21','16:35:00',2.2),('8784','2013-05-21','16:40:00',2.07),('8784','2013-05-21','16:45:00',1.88),('8784','2013-05-21','16:50:00',1.21),('8784','2013-05-20','07:15:00',1.03),('8784','2013-05-20','07:20:00',1.1),('8784','2013-05-20','07:25:00',1.08),('8784','2013-05-20','07:30:00',1.27),('8784','2013-05-20','07:35:00',1.39),('8784','2013-05-20','07:40:00',1.47),('8784','2013-05-20','07:45:00',1.55),('8784','2013-05-20','07:50:00',1.6),('8784','2013-05-20','07:55:00',1.7),('8784','2013-05-20','08:00:00',1.83),('8784','2013-05-20','08:05:00',1.52),('8784','2013-05-20','08:10:00',1.52),('8784','2013-05-20','08:15:00',1.88),('8784','2013-05-20','08:20:00',1.94),('8784','2013-05-20','08:45:00',2.46),('8784','2013-05-20','08:50:00',3.47),('8784','2013-05-20','08:55:00',3.02),('8784','2013-05-20','09:00:00',3.08),('8784','2013-05-20','09:05:00',2.5),('8784','2013-05-20','09:10:00',3.74),('8784','2013-05-20','09:15:00',1.69),('8784','2013-05-20','09:20:00',2.26),('8784','2013-05-20','09:25:00',1.38),('8784','2013-05-20','09:35:00',2.91),('8784','2013-05-20','09:45:00',2.2),('8784','2013-05-20','09:50:00',2.56),('8784','2013-05-20','10:00:00',1.11),('8784','2013-05-20','10:05:00',1.49),('8784','2013-05-20','10:10:00',2.6),('8784','2013-05-20','10:25:00',2.07),('8784','2013-05-20','10:30:00',3.32),('8784','2013-05-20','10:35:00',1.54),('8784','2013-05-20','10:40:00',1.72),('8784','2013-05-20','10:45:00',1.93),('8784','2013-05-20','10:50:00',2.02),('8784','2013-05-20','10:55:00',1.22),('8784','2013-05-20','11:00:00',4.51),('8784','2013-05-20','11:05:00',4.06),('8784','2013-05-20','11:10:00',5.05),('8784','2013-05-20','11:15:00',4.35),('8784','2013-05-20','11:20:00',2.67),('8784','2013-05-20','11:25:00',4.22),('8784','2013-05-20','11:30:00',3.78),('8784','2013-05-20','11:35:00',3.75),('8784','2013-05-20','11:40:00',1.88),('8784','2013-05-20','11:45:00',1.95),('8784','2013-05-20','11:50:00',1.47),('8784','2013-05-20','11:55:00',4.59),('8784','2013-05-20','12:00:00',2.98),('8784','2013-05-20','12:05:00',3.39),('8784','2013-05-20','12:10:00',2.71),('8784','2013-05-20','12:15:00',2.53),('8784','2013-05-20','12:20:00',4.28),('8784','2013-05-20','12:25:00',2.83),('8784','2013-05-20','12:30:00',2.67),('8784','2013-05-20','12:35:00',1.89),('8784','2013-05-20','12:40:00',4.98),('8784','2013-05-20','12:45:00',4.2),('8784','2013-05-20','12:50:00',1.39),('8784','2013-05-20','12:55:00',3.97),('8784','2013-05-20','13:00:00',2.99),('8784','2013-05-20','13:05:00',3.1),('8784','2013-05-20','13:10:00',2.21),('8784','2013-05-20','13:15:00',2.23),('8784','2013-05-20','13:20:00',3.86),('8784','2013-05-20','13:25:00',5.37),('8784','2013-05-20','13:30:00',1.35),('8784','2013-05-20','13:35:00',4.72),('8784','2013-05-20','13:40:00',1.78),('8784','2013-05-20','13:45:00',4.78),('8784','2013-05-20','13:50:00',3.34),('8784','2013-05-20','13:55:00',4.41),('8784','2013-05-20','14:00:00',4.58),('8784','2013-05-20','14:05:00',1.02),('8784','2013-05-20','14:10:00',3.1),('8784','2013-05-20','14:15:00',3.92),('8784','2013-05-20','14:20:00',2.14),('8784','2013-05-20','14:25:00',4.27),('8784','2013-05-20','14:30:00',4.82),('8784','2013-05-20','14:35:00',2.93),('8784','2013-05-20','14:40:00',2.08),('8784','2013-05-20','14:45:00',4.26),('8784','2013-05-20','14:50:00',3.6),('8784','2013-05-20','14:55:00',4.14),('8784','2013-05-20','15:00:00',2.64),('8784','2013-05-20','15:05:00',2.69),('8784','2013-05-20','15:10:00',4.73),('8784','2013-05-20','15:15:00',1.96),('8784','2013-05-20','15:20:00',4.62),('8784','2013-05-20','15:25:00',4.07),('8784','2013-05-20','15:30:00',4.49),('8784','2013-05-20','15:35:00',4.5),('8784','2013-05-20','15:40:00',2.58),('8784','2013-05-20','15:45:00',2.07),('8784','2013-05-20','15:50:00',2.98),('8784','2013-05-20','15:55:00',2.32),('8784','2013-05-20','16:00:00',2.15),('8784','2013-05-20','16:05:00',3.74),('8784','2013-05-20','16:10:00',3.84),('8784','2013-05-20','16:15:00',3.25),('8784','2013-05-20','16:20:00',3.66),('8784','2013-05-20','16:25:00',3.57),('8784','2013-05-20','16:30:00',3.38),('8784','2013-05-20','16:35:00',3.31),('8784','2013-05-20','16:40:00',3.25),('8784','2013-05-20','16:45:00',3.02),('8784','2013-05-20','16:50:00',3.01),('8784','2013-05-20','16:55:00',2.86),('8784','2013-05-20','17:00:00',2.84),('8784','2013-05-20','17:05:00',2.81),('8784','2013-05-20','17:10:00',1.99),('8784','2013-05-20','17:15:00',1.39),('8784','2013-05-20','17:20:00',2.33),('8784','2013-05-20','17:25:00',2.88),('8784','2013-05-20','17:30:00',2.77),('8784','2013-05-20','17:35:00',2.3),('8784','2013-05-20','17:40:00',2.15),('8784','2013-05-20','17:45:00',2.05),('8784','2013-05-20','17:50:00',1.94),('8784','2013-05-20','17:55:00',1.87),('8784','2013-05-20','18:00:00',1.81),('8784','2013-05-20','18:05:00',1.78),('8784','2013-05-20','18:10:00',1.48),('8784','2013-05-20','18:15:00',1.72),('8784','2013-05-20','18:20:00',1.47),('8784','2013-05-20','18:25:00',1.35),('8784','2013-05-20','18:30:00',1.25),('8784','2013-05-20','18:35:00',1.16),('8784','2013-05-20','18:40:00',1.01),('8784','2013-05-19','08:30:00',1.01),('8784','2013-05-19','08:35:00',1.33),('8784','2013-05-19','08:40:00',1.04),('8784','2013-05-19','08:45:00',1.15),('8784','2013-05-19','08:50:00',1.4),('8784','2013-05-19','08:55:00',1.54),('8784','2013-05-19','09:00:00',1.44),('8784','2013-05-19','09:05:00',1.31),('8784','2013-05-19','09:10:00',1.48),('8784','2013-05-19','09:15:00',1.51),('8784','2013-05-19','09:20:00',1.05),('8784','2013-05-19','09:40:00',1.25),('8784','2013-05-19','09:45:00',1.38),('8784','2013-05-19','09:55:00',1.19),('8784','2013-05-19','10:00:00',1.54),('8784','2013-05-19','10:05:00',1.8),('8784','2013-05-19','10:10:00',2.64),('8784','2013-05-19','10:15:00',3.1),('8784','2013-05-19','10:20:00',3.18),('8784','2013-05-19','10:25:00',2.65),('8784','2013-05-19','10:30:00',3.52),('8784','2013-05-19','10:35:00',3.79),('8784','2013-05-19','10:40:00',4.38),('8784','2013-05-19','10:45:00',4.4),('8784','2013-05-19','10:50:00',4.1),('8784','2013-05-19','10:55:00',4.99),('8784','2013-05-19','11:00:00',3.87),('8784','2013-05-19','11:05:00',2.39),('8784','2013-05-19','11:10:00',3.23),('8784','2013-05-19','11:15:00',4.71),('8784','2013-05-19','11:20:00',4.61),('8784','2013-05-19','11:25:00',4.65),('8784','2013-05-19','11:30:00',4.67),('8784','2013-05-19','11:35:00',4.66),('8784','2013-05-19','11:40:00',4.71),('8784','2013-05-19','11:45:00',4.76),('8784','2013-05-19','11:50:00',4.76),('8784','2013-05-19','11:55:00',4.83),('8784','2013-05-19','12:00:00',4.87),('8784','2013-05-19','12:05:00',4.82),('8784','2013-05-19','12:10:00',4.8),('8784','2013-05-19','12:15:00',4.89),('8784','2013-05-19','12:20:00',5.28),('8784','2013-05-19','12:25:00',3.65),('8784','2013-05-19','12:30:00',3.25),('8784','2013-05-19','12:35:00',3.44),('8784','2013-05-19','12:40:00',4.4),('8784','2013-05-19','12:45:00',4.52),('8784','2013-05-19','12:50:00',3.44),('8784','2013-05-19','12:55:00',2.8),('8784','2013-05-19','13:00:00',4.28),('8784','2013-05-19','13:05:00',4.67),('8784','2013-05-19','13:10:00',4.21),('8784','2013-05-19','13:15:00',3.69),('8784','2013-05-19','13:20:00',4.19),('8784','2013-05-19','13:25:00',4.47),('8784','2013-05-19','13:30:00',4.68),('8784','2013-05-19','13:35:00',4.74),('8784','2013-05-19','13:40:00',4.73),('8784','2013-05-19','13:45:00',4.68),('8784','2013-05-19','13:50:00',4.73),('8784','2013-05-19','13:55:00',4.69),('8784','2013-05-19','14:00:00',4.7),('8784','2013-05-19','14:05:00',4.64),('8784','2013-05-19','14:10:00',4.67),('8784','2013-05-19','14:15:00',4.65),('8784','2013-05-19','14:20:00',4.65),('8784','2013-05-19','14:25:00',4.63),('8784','2013-05-19','14:30:00',4.59),('8784','2013-05-19','14:35:00',4.54),('8784','2013-05-19','14:40:00',4.51),('8784','2013-05-19','14:45:00',4.47),('8784','2013-05-19','14:50:00',4.43),('8784','2013-05-19','14:55:00',4.41),('8784','2013-05-19','15:00:00',4.37),('8784','2013-05-19','15:05:00',4.33),('8784','2013-05-19','15:10:00',4.27),('8784','2013-05-19','15:15:00',4.22),('8784','2013-05-19','15:20:00',4.18),('8784','2013-05-19','15:25:00',4.17),('8784','2013-05-19','15:30:00',4.14),('8784','2013-05-19','15:35:00',4),('8784','2013-05-19','15:40:00',3.97),('8784','2013-05-19','15:45:00',3.93),('8784','2013-05-19','15:50:00',3.9),('8784','2013-05-19','15:55:00',3.82),('8784','2013-05-19','16:00:00',3.8),('8784','2013-05-19','16:05:00',3.71),('8784','2013-05-19','16:10:00',3.63),('8784','2013-05-19','16:15:00',3.57),('8784','2013-05-19','16:20:00',3.49),('8784','2013-05-19','16:25:00',3.44),('8784','2013-05-19','16:30:00',3.35),('8784','2013-05-19','16:35:00',3.3),('8784','2013-05-19','16:40:00',3.24),('8784','2013-05-19','16:45:00',3.17),('8784','2013-05-19','16:50:00',3.05),('8784','2013-05-19','16:55:00',3.01),('8784','2013-05-19','17:00:00',2.94),('8784','2013-05-19','17:05:00',2.84),('8784','2013-05-19','17:10:00',2.76),('8784','2013-05-19','17:15:00',2.68),('8784','2013-05-19','17:20:00',2.6),('8784','2013-05-19','17:25:00',2.51),('8784','2013-05-19','17:30:00',2.41),('8784','2013-05-19','17:35:00',2.34),('8784','2013-05-19','17:40:00',2.24),('8784','2013-05-19','17:45:00',2.16),('8784','2013-05-19','17:50:00',2.07),('8784','2013-05-19','17:55:00',1.97),('8784','2013-05-19','18:00:00',1.89),('8784','2013-05-19','18:05:00',1.8),('8784','2013-05-19','18:10:00',1.71),('8784','2013-05-19','18:15:00',1.6),('8784','2013-05-19','18:20:00',1.52),('8784','2013-05-19','18:25:00',1.43),('8784','2013-05-19','18:30:00',1.34),('8784','2013-05-19','18:35:00',1.25),('8784','2013-05-19','18:40:00',1.17),('8784','2013-05-19','18:45:00',1.07),('8784','2013-05-18','07:20:00',1.04),('8784','2013-05-18','07:25:00',1.12),('8784','2013-05-18','07:30:00',1.21),('8784','2013-05-18','07:35:00',1.3),('8784','2013-05-18','07:40:00',1.44),('8784','2013-05-18','07:45:00',1.37),('8784','2013-05-18','07:50:00',1.33),('8784','2013-05-18','07:55:00',2.03),('8784','2013-05-18','08:00:00',2.2),('8784','2013-05-18','08:05:00',2),('8784','2013-05-18','08:10:00',1.11),('8784','2013-05-18','08:15:00',1.1),('8784','2013-05-18','08:20:00',1.58),('8784','2013-05-18','08:25:00',2.65),('8784','2013-05-18','08:30:00',2.36),('8784','2013-05-18','08:35:00',2.16),('8784','2013-05-18','08:40:00',2.49),('8784','2013-05-18','08:45:00',2.53),('8784','2013-05-18','08:50:00',2.58),('8784','2013-05-18','08:55:00',2.67),('8784','2013-05-18','09:00:00',2.75),('8784','2013-05-18','09:05:00',2.77),('8784','2013-05-18','09:10:00',2.93),('8784','2013-05-18','09:15:00',2.98),('8784','2013-05-18','09:20:00',3.06),('8784','2013-05-18','09:25:00',3.12),('8784','2013-05-18','09:30:00',3.18),('8784','2013-05-18','09:35:00',3.25),('8784','2013-05-18','09:40:00',3.32),('8784','2013-05-18','09:45:00',3.38),('8784','2013-05-18','09:50:00',3.43),('8784','2013-05-18','09:55:00',3.5),('8784','2013-05-18','10:00:00',3.55),('8784','2013-05-18','10:05:00',3.6),('8784','2013-05-18','10:10:00',3.67),('8784','2013-05-18','10:15:00',3.71),('8784','2013-05-18','10:20:00',3.76),('8784','2013-05-18','10:25:00',3.78),('8784','2013-05-18','10:30:00',3.83),('8784','2013-05-18','10:35:00',3.87),('8784','2013-05-18','10:40:00',3.91),('8784','2013-05-18','10:45:00',3.96),('8784','2013-05-18','10:50:00',4.02),('8784','2013-05-18','10:55:00',3.94),('8784','2013-05-18','11:00:00',4.26),('8784','2013-05-18','11:05:00',3.85),('8784','2013-05-18','11:10:00',3.4),('8784','2013-05-18','11:15:00',4.49),('8784','2013-05-18','11:20:00',4.35),('8784','2013-05-18','11:25:00',4.44),('8784','2013-05-18','11:30:00',4.17),('8784','2013-05-18','11:35:00',4.19),('8784','2013-05-18','11:40:00',4.33),('8784','2013-05-18','11:45:00',4.3),('8784','2013-05-18','11:50:00',4.15),('8784','2013-05-18','11:55:00',4.1),('8784','2013-05-18','12:00:00',4.13),('8784','2013-05-18','12:05:00',4.34),('8784','2013-05-18','12:10:00',4.31),('8784','2013-05-18','12:15:00',4.32),('8784','2013-05-18','12:20:00',4.36),('8784','2013-05-18','12:25:00',4.44),('8784','2013-05-18','12:30:00',3.33),('8784','2013-05-18','12:35:00',4.43),('8784','2013-05-18','12:40:00',4.39),('8784','2013-05-18','12:45:00',4.03),('8784','2013-05-18','12:50:00',4.39),('8784','2013-05-18','12:55:00',4.34),('8784','2013-05-18','13:00:00',4.38),('8784','2013-05-18','13:05:00',4.37),('8784','2013-05-18','13:10:00',3.51),('8784','2013-05-18','13:15:00',4.35),('8784','2013-05-18','13:20:00',4.39),('8784','2013-05-18','13:25:00',4.39),('8784','2013-05-18','13:30:00',4.37),('8784','2013-05-18','13:35:00',4.07),('8784','2013-05-18','13:40:00',4.34),('8784','2013-05-18','13:45:00',4.59),('8784','2013-05-18','13:50:00',3.99),('8784','2013-05-18','13:55:00',3.34),('8784','2013-05-18','14:00:00',3.29),('8784','2013-05-18','14:05:00',3.73),('8784','2013-05-18','14:10:00',4.69),('8784','2013-05-18','14:15:00',4.51),('8784','2013-05-18','14:20:00',4.48),('8784','2013-05-18','14:25:00',4.36),('8784','2013-05-18','14:30:00',4.34),('8784','2013-05-18','14:35:00',4.17),('8784','2013-05-18','14:40:00',4.48),('8784','2013-05-18','14:45:00',4.15),('8784','2013-05-18','14:50:00',4.21),('8784','2013-05-18','14:55:00',3.74),('8784','2013-05-18','15:00:00',3.84),('8784','2013-05-18','15:05:00',3.76),('8784','2013-05-18','15:10:00',3.69),('8784','2013-05-18','15:15:00',3.65),('8784','2013-05-18','15:20:00',3.59),('8784','2013-05-18','15:25:00',3.54),('8784','2013-05-18','15:30:00',3.5),('8784','2013-05-18','15:35:00',3.47),('8784','2013-05-18','15:40:00',3.41),('8784','2013-05-18','15:45:00',3.32),('8784','2013-05-18','15:50:00',3.27),('8784','2013-05-18','15:55:00',3.22),('8784','2013-05-18','16:00:00',3.16),('8784','2013-05-18','16:05:00',3.12),('8784','2013-05-18','16:10:00',3.04),('8784','2013-05-18','16:15:00',2.97),('8784','2013-05-18','16:20:00',2.93),('8784','2013-05-18','16:25:00',2.87),('8784','2013-05-18','16:30:00',2.79),('8784','2013-05-18','16:35:00',2.72),('8784','2013-05-18','16:40:00',2.66),('8784','2013-05-18','16:45:00',2.59),('8784','2013-05-18','16:50:00',2.51),('8784','2013-05-18','16:55:00',2.45),('8784','2013-05-18','17:00:00',2.37),('8784','2013-05-18','17:05:00',2.3),('8784','2013-05-18','17:10:00',2.25),('8784','2013-05-18','17:15:00',2.18),('8784','2013-05-18','17:20:00',2.11),('8784','2013-05-18','17:25:00',2.03),('8784','2013-05-18','17:30:00',1.94),('8784','2013-05-18','17:35:00',1.86),('8784','2013-05-18','17:40:00',1.79),('8784','2013-05-18','17:45:00',1.72),('8784','2013-05-18','17:50:00',1.65),('8784','2013-05-18','17:55:00',1.58),('8784','2013-05-18','18:00:00',1.49),('8784','2013-05-18','18:05:00',1.4),('8784','2013-05-18','18:10:00',1.33),('8784','2013-05-18','18:15:00',1.25),('8784','2013-05-18','18:20:00',1.17),('8784','2013-05-18','18:25:00',1.09),('8784','2013-05-18','18:30:00',1.02),('8784','2013-05-17','07:40:00',1.34),('8784','2013-05-17','07:45:00',1.38),('8784','2013-05-17','07:50:00',1.32),('8784','2013-05-17','07:55:00',1.31),('8784','2013-05-17','08:00:00',1.34),('8784','2013-05-17','08:05:00',1.08),('8784','2013-05-17','08:10:00',1.29),('8784','2013-05-17','08:15:00',2.07),('8784','2013-05-17','08:20:00',2.37),('8784','2013-05-17','08:25:00',1.75),('8784','2013-05-17','08:30:00',1.02),('8784','2013-05-17','09:25:00',1.2),('8784','2013-05-17','10:20:00',1.02),('8784','2013-05-17','10:25:00',1.45),('8784','2013-05-17','10:30:00',1.76),('8784','2013-05-17','10:35:00',1.37),('8784','2013-05-17','10:40:00',1.54),('8784','2013-05-17','10:45:00',1.7),('8784','2013-05-17','10:50:00',3.14),('8784','2013-05-17','10:55:00',3.37),('8784','2013-05-17','11:00:00',2.56),('8784','2013-05-17','11:05:00',2.17),('8784','2013-05-17','11:10:00',1.6),('8784','2013-05-17','11:15:00',2.27),('8784','2013-05-17','11:20:00',2.12),('8784','2013-05-17','11:25:00',1.86),('8784','2013-05-17','11:30:00',1.74),('8784','2013-05-17','11:35:00',2.35),('8784','2013-05-17','11:40:00',1.72),('8784','2013-05-17','11:45:00',3.88),('8784','2013-05-17','11:50:00',4.8),('8784','2013-05-17','11:55:00',4.04),('8784','2013-05-17','12:00:00',4.15),('8784','2013-05-17','12:05:00',3.86),('8784','2013-05-17','12:10:00',3.32),('8784','2013-05-17','12:15:00',2.49),('8784','2013-05-17','12:20:00',3.57),('8784','2013-05-17','12:25:00',3.22),('8784','2013-05-17','12:30:00',2.73),('8784','2013-05-17','12:35:00',3.52),('8784','2013-05-17','12:40:00',4.61),('8784','2013-05-17','12:45:00',5.02),('8784','2013-05-17','12:50:00',5.09),('8784','2013-05-17','12:55:00',4.65),('8784','2013-05-17','13:00:00',4.23),('8784','2013-05-17','13:05:00',4.81),('8784','2013-05-17','13:10:00',4.29),('8784','2013-05-17','13:15:00',4.71),('8784','2013-05-17','13:20:00',5.23),('8784','2013-05-17','13:25:00',4.54),('8784','2013-05-17','13:30:00',3.76),('8784','2013-05-17','13:35:00',4.8),('8784','2013-05-17','13:40:00',4.32),('8784','2013-05-17','13:45:00',4.3),('8784','2013-05-17','13:50:00',4.4),('8784','2013-05-17','13:55:00',5.17),('8784','2013-05-17','14:00:00',3.04),('8784','2013-05-17','14:05:00',3.66),('8784','2013-05-17','14:10:00',4.29),('8784','2013-05-17','14:15:00',4.37),('8784','2013-05-17','14:20:00',4.79),('8784','2013-05-17','14:25:00',4.03),('8784','2013-05-17','14:30:00',4.37),('8784','2013-05-17','14:35:00',4.18),('8784','2013-05-17','14:40:00',2.98),('8784','2013-05-17','14:45:00',3.51),('8784','2013-05-17','14:50:00',4.6),('8784','2013-05-17','14:55:00',2.6),('8784','2013-05-17','15:00:00',4.33),('8784','2013-05-17','15:05:00',3.21),('8784','2013-05-17','15:10:00',1.58),('8784','2013-05-17','15:15:00',3.81),('8784','2013-05-17','15:20:00',2.33),('8784','2013-05-17','15:25:00',2.08),('8784','2013-05-17','15:30:00',2.3),('8784','2013-05-17','15:35:00',3.03),('8784','2013-05-17','15:40:00',3.7),('8784','2013-05-17','15:45:00',1.85),('8784','2013-05-17','15:50:00',3.14),('8784','2013-05-17','15:55:00',4.4),('8784','2013-05-17','16:00:00',4.17),('8784','2013-05-17','16:05:00',2.2),('8784','2013-05-17','16:10:00',3.4),('8784','2013-05-17','16:15:00',3.32),('8784','2013-05-17','16:20:00',2.89),('8784','2013-05-17','16:25:00',3.43),('8784','2013-05-17','16:30:00',3.59),('8784','2013-05-17','16:35:00',3.55),('8784','2013-05-17','16:40:00',3.57),('8784','2013-05-17','16:45:00',3.28),('8784','2013-05-17','16:50:00',3),('8784','2013-05-17','16:55:00',2.86),('8784','2013-05-17','17:00:00',2.82),('8784','2013-05-17','17:05:00',2.7),('8784','2013-05-17','17:10:00',2.62),('8784','2013-05-17','17:15:00',2.56),('8784','2013-05-17','17:20:00',2.49),('8784','2013-05-17','17:25:00',2.41),('8784','2013-05-17','17:30:00',2.33),('8784','2013-05-17','17:35:00',2.24),('8784','2013-05-17','17:40:00',2.15),('8784','2013-05-17','17:45:00',2.06),('8784','2013-05-17','17:50:00',1.98),('8784','2013-05-17','17:55:00',1.88),('8784','2013-05-17','18:00:00',1.81),('8784','2013-05-17','18:05:00',1.73),('8784','2013-05-17','18:10:00',1.62),('8784','2013-05-17','18:15:00',1.52),('8784','2013-05-17','18:20:00',1.43),('8784','2013-05-17','18:25:00',1.35),('8784','2013-05-17','18:30:00',1.26),('8784','2013-05-17','18:35:00',1.2),('8784','2013-05-17','18:40:00',1.09),('8784','2013-05-16','09:20:00',1.23),('8784','2013-05-16','09:25:00',1.7),('8784','2013-05-16','09:30:00',1.73),('8784','2013-05-16','09:35:00',2.06),('8784','2013-05-16','09:40:00',2.31),('8784','2013-05-16','09:45:00',2.75),('8784','2013-05-16','09:50:00',1.42),('8784','2013-05-16','09:55:00',1.38),('8784','2013-05-16','10:00:00',1.67),('8784','2013-05-16','10:05:00',1.39),('8784','2013-05-16','10:10:00',1.29),('8784','2013-05-16','10:15:00',1.68),('8784','2013-05-16','10:20:00',2.21),('8784','2013-05-16','10:25:00',2.02),('8784','2013-05-16','10:30:00',2.06),('8784','2013-05-16','10:35:00',1.5),('8784','2013-05-16','10:40:00',1.5),('8784','2013-05-16','10:45:00',1.36),('8784','2013-05-16','10:50:00',1.56),('8784','2013-05-16','10:55:00',1.82),('8784','2013-05-16','11:00:00',4.34),('8784','2013-05-16','11:05:00',3.64),('8784','2013-05-16','11:10:00',3.4),('8784','2013-05-16','11:15:00',2.37),('8784','2013-05-16','11:20:00',1.28),('8784','2013-05-16','11:25:00',1.38),('8784','2013-05-16','11:30:00',1.68),('8784','2013-05-16','11:35:00',2.67),('8784','2013-05-16','11:40:00',3.76),('8784','2013-05-16','11:45:00',3.54),('8784','2013-05-16','11:50:00',3.56),('8784','2013-05-16','11:55:00',2.76),('8784','2013-05-16','12:00:00',2),('8784','2013-05-16','12:05:00',1.85),('8784','2013-05-16','12:10:00',1.87),('8784','2013-05-16','12:15:00',2.61),('8784','2013-05-16','12:20:00',2.15),('8784','2013-05-16','12:25:00',2.29),('8784','2013-05-16','12:30:00',3.64),('8784','2013-05-16','12:35:00',3.67),('8784','2013-05-16','12:40:00',4.96),('8784','2013-05-16','12:45:00',3.44),('8784','2013-05-16','12:50:00',2.87),('8784','2013-05-16','12:55:00',4.26),('8784','2013-05-16','13:00:00',4.31),('8784','2013-05-16','13:05:00',4.28),('8784','2013-05-16','13:10:00',4.3),('8784','2013-05-16','13:15:00',3.93),('8784','2013-05-16','13:20:00',3.14),('8784','2013-05-16','13:25:00',4.34),('8784','2013-05-16','13:30:00',4.26),('8784','2013-05-16','13:35:00',4.21),('8784','2013-05-16','13:40:00',4.16),('8784','2013-05-16','13:45:00',4.16),('8784','2013-05-16','13:50:00',4.19),('8784','2013-05-16','13:55:00',4.17),('8784','2013-05-16','14:00:00',4.13),('8784','2013-05-16','14:05:00',4.13),('8784','2013-05-16','14:10:00',4.08),('8784','2013-05-16','14:15:00',4.04),('8784','2013-05-16','14:20:00',4),('8784','2013-05-16','14:25:00',3.91),('8784','2013-05-16','14:30:00',3.91),('8784','2013-05-16','14:35:00',3.85),('8784','2013-05-16','14:40:00',3.84),('8784','2013-05-16','14:45:00',3.81),('8784','2013-05-16','14:50:00',3.47),('8784','2013-05-16','14:55:00',3.31),('8784','2013-05-16','15:00:00',3.75),('8784','2013-05-16','15:05:00',3.64),('8784','2013-05-16','15:10:00',3.61),('8784','2013-05-16','15:15:00',3.24),('8784','2013-05-16','15:20:00',3.55),('8784','2013-05-16','15:25:00',3.5),('8784','2013-05-16','15:30:00',3.39),('8784','2013-05-16','15:35:00',3.3),('8784','2013-05-16','15:40:00',3.4),('8784','2013-05-16','15:45:00',3.28),('8784','2013-05-16','15:50:00',3.26),('8784','2013-05-16','15:55:00',3.22),('8784','2013-05-16','16:00:00',3.17),('8784','2013-05-16','16:05:00',3.01),('8784','2013-05-16','16:10:00',3.05),('8784','2013-05-16','16:15:00',2.8),('8784','2013-05-16','16:20:00',3.01),('8784','2013-05-16','16:25:00',2.9),('8784','2013-05-16','16:30:00',2.88),('8784','2013-05-16','16:35:00',2.71),('8784','2013-05-16','16:40:00',1.73),('8784','2013-05-16','16:45:00',1.53),('8784','2013-05-16','16:50:00',2.04),('8784','2013-05-16','16:55:00',1.89),('8784','2013-05-16','17:00:00',1.72),('8784','2013-05-16','17:15:00',1.46),('8784','2013-05-16','17:20:00',1.56),('8784','2013-05-16','17:25:00',1.68),('8784','2013-05-16','17:30:00',1.98),('8784','2013-05-16','17:35:00',1.85),('8784','2013-05-16','17:40:00',1.57),('8784','2013-05-16','17:45:00',1.14),('8784','2013-05-16','18:45:00',1.03),('8784','2013-05-16','18:50:00',1.08),('8784','2013-05-16','18:55:00',1.09),('8784','2013-05-16','19:00:00',1.12),('8784','2013-05-16','19:05:00',1.04),('8784','2013-05-15','07:20:00',1.03),('8784','2013-05-15','07:25:00',1.13),('8784','2013-05-15','07:30:00',1.24),('8784','2013-05-15','07:35:00',1.32),('8784','2013-05-15','07:40:00',1.42),('8784','2013-05-15','07:45:00',1.61),('8784','2013-05-15','07:50:00',1.63),('8784','2013-05-15','07:55:00',1.54),('8784','2013-05-15','08:00:00',1.62),('8784','2013-05-15','08:05:00',1.56),('8784','2013-05-15','08:10:00',1.84),('8784','2013-05-15','08:15:00',1.98),('8784','2013-05-15','08:20:00',2.02),('8784','2013-05-15','08:25:00',2.07),('8784','2013-05-15','08:30:00',2.11),('8784','2013-05-15','08:35:00',2.26),('8784','2013-05-15','08:40:00',2.36),('8784','2013-05-15','08:45:00',2.46),('8784','2013-05-15','08:50:00',2.54),('8784','2013-05-15','08:55:00',2.62),('8784','2013-05-15','09:00:00',2.55),('8784','2013-05-15','09:05:00',2.76),('8784','2013-05-15','09:10:00',2.74),('8784','2013-05-15','09:15:00',2.79),('8784','2013-05-15','09:20:00',2.8),('8784','2013-05-15','09:25:00',2.9),('8784','2013-05-15','09:30:00',3.07),('8784','2013-05-15','09:35:00',3.13),('8784','2013-05-15','09:40:00',3.13),('8784','2013-05-15','09:45:00',3.23),('8784','2013-05-15','09:50:00',3.29),('8784','2013-05-15','09:55:00',3.32),('8784','2013-05-15','10:00:00',3.41),('8784','2013-05-15','10:05:00',3.48),('8784','2013-05-15','10:10:00',3.5),('8784','2013-05-15','10:15:00',3.45),('8784','2013-05-15','10:20:00',3.57),('8784','2013-05-15','10:25:00',3.7),('8784','2013-05-15','10:30:00',3.64),('8784','2013-05-15','10:35:00',3.76),('8784','2013-05-15','10:40:00',3.85),('8784','2013-05-15','10:45:00',3.89),('8784','2013-05-15','10:50:00',3.91),('8784','2013-05-15','10:55:00',3.78),('8784','2013-05-15','11:00:00',3.77),('8784','2013-05-15','11:05:00',3.99),('8784','2013-05-15','11:10:00',4.03),('8784','2013-05-15','11:15:00',4.08),('8784','2013-05-15','11:20:00',3.88),('8784','2013-05-15','11:25:00',4.12),('8784','2013-05-15','11:30:00',4.01),('8784','2013-05-15','11:35:00',4.08),('8784','2013-05-15','11:40:00',3.28),('8784','2013-05-15','11:45:00',3.17),('8784','2013-05-15','11:50:00',2.64),('8784','2013-05-15','11:55:00',1.97),('8784','2013-05-15','12:00:00',2.19),('8784','2013-05-15','12:05:00',3.41),('8784','2013-05-15','12:10:00',4.99),('8784','2013-05-15','12:15:00',4.52),('8784','2013-05-15','12:20:00',3.24),('8784','2013-05-15','12:25:00',3.88),('8784','2013-05-15','12:30:00',3.02),('8784','2013-05-15','12:35:00',3.68),('8784','2013-05-15','12:40:00',4.86),('8784','2013-05-15','12:45:00',2.67),('8784','2013-05-15','12:50:00',2.68),('8784','2013-05-15','12:55:00',2.99),('8784','2013-05-15','13:00:00',2.95),('8784','2013-05-15','13:05:00',3.63),('8784','2013-05-15','13:10:00',2.93),('8784','2013-05-15','13:15:00',2.67),('8784','2013-05-15','13:20:00',2.93),('8784','2013-05-15','13:25:00',2.95),('8784','2013-05-15','13:30:00',2.97),('8784','2013-05-15','13:35:00',2.6),('8784','2013-05-15','13:40:00',2.88),('8784','2013-05-15','13:45:00',2.68),('8784','2013-05-15','13:50:00',2.31),('8784','2013-05-15','13:55:00',2.3),('8784','2013-05-15','14:00:00',2.01),('8784','2013-05-15','14:05:00',1.8),('8784','2013-05-15','14:10:00',1.88),('8784','2013-05-15','14:15:00',1.85),('8784','2013-05-15','14:20:00',1.95),('8784','2013-05-15','14:25:00',1.82),('8784','2013-05-15','14:30:00',1.62),('8784','2013-05-15','14:35:00',1.59),('8784','2013-05-15','14:40:00',1.75),('8784','2013-05-15','14:45:00',1.61),('8784','2013-05-15','14:50:00',1.59),('8784','2013-05-15','14:55:00',1.61),('8784','2013-05-15','15:00:00',1.55),('8784','2013-05-15','15:05:00',1.24),('8784','2013-05-15','15:45:00',1.19),('8784','2013-05-15','15:50:00',1.64),('8784','2013-05-15','15:55:00',2.14),('8784','2013-05-15','16:00:00',2.06),('8784','2013-05-15','16:05:00',1.95),('8784','2013-05-15','16:10:00',1.76),('8784','2013-05-15','16:15:00',1.57),('8784','2013-05-15','16:20:00',1.7),('8784','2013-05-15','16:25:00',1.72),('8784','2013-05-15','16:30:00',1.53),('8784','2013-05-15','16:35:00',1.42),('8784','2013-05-15','16:40:00',1.34),('8784','2013-05-15','16:45:00',1.29),('8784','2013-05-15','16:50:00',1.32),('8784','2013-05-15','16:55:00',1.51),('8784','2013-05-15','17:00:00',1.81),('8784','2013-05-15','17:05:00',2.09),('8784','2013-05-15','17:10:00',2.57),('8784','2013-05-15','17:15:00',2.8),('8784','2013-05-15','17:20:00',1.93),('8784','2013-05-15','17:30:00',1.09),('8784','2013-05-14','07:20:00',1.08),('8784','2013-05-14','07:25:00',1.17),('8784','2013-05-14','07:30:00',1.25),('8784','2013-05-14','07:35:00',1.35),('8784','2013-05-14','07:40:00',1.43),('8784','2013-05-14','07:45:00',1.52),('8784','2013-05-14','07:50:00',1.62),('8784','2013-05-14','07:55:00',1.72),('8784','2013-05-14','08:00:00',1.78),('8784','2013-05-14','08:05:00',1.9),('8784','2013-05-14','08:10:00',1.99),('8784','2013-05-14','08:15:00',2.08),('8784','2013-05-14','08:20:00',2.17),('8784','2013-05-14','08:25:00',2.26),('8784','2013-05-14','08:30:00',2.32),('8784','2013-05-14','08:35:00',2.44),('8784','2013-05-14','08:40:00',2.52),('8784','2013-05-14','08:45:00',2.6),('8784','2013-05-14','08:50:00',2.68),('8784','2013-05-14','08:55:00',2.75),('8784','2013-05-14','09:00:00',2.83),('8784','2013-05-14','09:05:00',2.91),('8784','2013-05-14','09:10:00',2.98),('8784','2013-05-14','09:15:00',3.05),('8784','2013-05-14','09:20:00',3.13),('8784','2013-05-14','09:25:00',3.19),('8784','2013-05-14','09:30:00',3.25),('8784','2013-05-14','09:35:00',3.32),('8784','2013-05-14','09:40:00',3.38),('8784','2013-05-14','09:45:00',3.4),('8784','2013-05-14','09:50:00',3.49),('8784','2013-05-14','09:55:00',3.54),('8784','2013-05-14','10:00:00',3.62),('8784','2013-05-14','10:05:00',3.68),('8784','2013-05-14','10:10:00',3.76),('8784','2013-05-14','10:15:00',3.8),('8784','2013-05-14','10:20:00',3.86),('8784','2013-05-14','10:25:00',3.87),('8784','2013-05-14','10:30:00',3.9),('8784','2013-05-14','10:35:00',3.98),('8784','2013-05-14','10:40:00',4),('8784','2013-05-14','10:45:00',4.08),('8784','2013-05-14','10:50:00',4.1),('8784','2013-05-14','10:55:00',4.12),('8784','2013-05-14','11:00:00',4.14),('8784','2013-05-14','11:05:00',4.19),('8784','2013-05-14','11:10:00',4.22),('8784','2013-05-14','11:15:00',4.24),('8784','2013-05-14','11:20:00',4.27),('8784','2013-05-14','11:25:00',4.28),('8784','2013-05-14','11:30:00',4.26),('8784','2013-05-14','11:35:00',4.29),('8784','2013-05-14','11:40:00',4.32),('8784','2013-05-14','11:45:00',4.34),('8784','2013-05-14','11:50:00',4.36),('8784','2013-05-14','11:55:00',4.38),('8784','2013-05-14','12:00:00',4.4),('8784','2013-05-14','12:05:00',4.43),('8784','2013-05-14','12:10:00',4.47),('8784','2013-05-14','12:15:00',4.5),('8784','2013-05-14','12:20:00',4.55),('8784','2013-05-14','12:25:00',4.55),('8784','2013-05-14','12:30:00',4.55),('8784','2013-05-14','12:35:00',4.56),('8784','2013-05-14','12:40:00',4.56),('8784','2013-05-14','12:45:00',4.57),('8784','2013-05-14','12:50:00',4.53),('8784','2013-05-14','12:55:00',4.56),('8784','2013-05-14','13:00:00',4.58),('8784','2013-05-14','13:05:00',4.56),('8784','2013-05-14','13:10:00',4.55),('8784','2013-05-14','13:15:00',4.54),('8784','2013-05-14','13:20:00',4.5),('8784','2013-05-14','13:25:00',4.48),('8784','2013-05-14','13:30:00',4.47),('8784','2013-05-14','13:35:00',4.47),('8784','2013-05-14','13:40:00',4.51),('8784','2013-05-14','13:45:00',4.49),('8784','2013-05-14','13:50:00',4.45),('8784','2013-05-14','13:55:00',4.45),('8784','2013-05-14','14:00:00',4.39),('8784','2013-05-14','14:05:00',4.33),('8784','2013-05-14','14:10:00',4.3),('8784','2013-05-14','14:15:00',4.29),('8784','2013-05-14','14:20:00',4.25),('8784','2013-05-14','14:25:00',4.22),('8784','2013-05-14','14:30:00',4.2),('8784','2013-05-14','14:35:00',4.15),('8784','2013-05-14','14:40:00',4.2),('8784','2013-05-14','14:45:00',4.23),('8784','2013-05-14','14:50:00',4.24),('8784','2013-05-14','14:55:00',4.19),('8784','2013-05-14','15:00:00',4.18),('8784','2013-05-14','15:05:00',4.15),('8784','2013-05-14','15:10:00',4.11),('8784','2013-05-14','15:15:00',4.07),('8784','2013-05-14','15:20:00',4.02),('8784','2013-05-14','15:25:00',4.01),('8784','2013-05-14','15:30:00',3.96),('8784','2013-05-14','15:35:00',3.91),('8784','2013-05-14','15:40:00',3.85),('8784','2013-05-14','15:45:00',3.79),('8784','2013-05-14','15:50:00',3.71),('8784','2013-05-14','15:55:00',3.66),('8784','2013-05-14','16:00:00',3.6),('8784','2013-05-14','16:05:00',3.54),('8784','2013-05-14','16:10:00',3.48),('8784','2013-05-14','16:15:00',3.4),('8784','2013-05-14','16:20:00',3.33),('8784','2013-05-14','16:25:00',3.28),('8784','2013-05-14','16:30:00',3.21),('8784','2013-05-14','16:35:00',3.14),('8784','2013-05-14','16:40:00',3.06),('8784','2013-05-14','16:45:00',2.98),('8784','2013-05-14','16:50:00',2.91),('8784','2013-05-14','16:55:00',2.83),('8784','2013-05-14','17:00:00',2.75),('8784','2013-05-14','17:05:00',2.66),('8784','2013-05-14','17:10:00',2.58),('8784','2013-05-14','17:15:00',2.47),('8784','2013-05-14','17:20:00',2.41),('8784','2013-05-14','17:25:00',2.33),('8784','2013-05-14','17:30:00',2.25),('8784','2013-05-14','17:35:00',2.14),('8784','2013-05-14','17:40:00',2.07),('8784','2013-05-14','17:45:00',1.98),('8784','2013-05-14','17:50:00',1.88),('8784','2013-05-14','17:55:00',1.8),('8784','2013-05-14','18:00:00',1.7),('8784','2013-05-14','18:05:00',1.59),('8784','2013-05-14','18:10:00',1.52),('8784','2013-05-14','18:15:00',1.42),('8784','2013-05-14','18:20:00',1.34),('8784','2013-05-14','18:25:00',1.27),('8784','2013-05-14','18:30:00',1.17),('8784','2013-05-14','18:35:00',1.1),('8784','2013-05-14','18:40:00',1.01),('8784','2013-05-13','07:35:00',1.18),('8784','2013-05-13','07:40:00',1.27),('8784','2013-05-13','07:45:00',1.36),('8784','2013-05-13','07:50:00',1.43),('8784','2013-05-13','07:55:00',1.33),('8784','2013-05-13','08:00:00',1.54),('8784','2013-05-13','08:05:00',1.59),('8784','2013-05-13','08:10:00',1.8),('8784','2013-05-13','08:15:00',1.91),('8784','2013-05-13','08:20:00',2.01),('8784','2013-05-13','08:25:00',2.07),('8784','2013-05-13','08:30:00',2.14),('8784','2013-05-13','08:35:00',2.23),('8784','2013-05-13','08:40:00',2.31),('8784','2013-05-13','08:45:00',2.41),('8784','2013-05-13','08:50:00',2.48),('8784','2013-05-13','08:55:00',2.58),('8784','2013-05-13','09:00:00',2.66),('8784','2013-05-13','09:05:00',2.71),('8784','2013-05-13','09:10:00',2.78),('8784','2013-05-13','09:15:00',2.85),('8784','2013-05-13','09:20:00',2.94),('8784','2013-05-13','09:25:00',3.02),('8784','2013-05-13','09:30:00',3.09),('8784','2013-05-13','09:35:00',3.14),('8784','2013-05-13','09:40:00',3.22),('8784','2013-05-13','09:45:00',3.35),('8784','2013-05-13','09:50:00',3.07),('8784','2013-05-13','09:55:00',3.61),('8784','2013-05-13','10:00:00',3.45),('8784','2013-05-13','10:05:00',3.76),('8784','2013-05-13','10:10:00',3.68),('8784','2013-05-13','10:15:00',3.76),('8784','2013-05-13','10:20:00',3.6),('8784','2013-05-13','10:25:00',4.09),('8784','2013-05-13','10:30:00',4.08),('8784','2013-05-13','10:35:00',1.38),('8784','2013-05-13','10:40:00',1.23),('8784','2013-05-13','10:45:00',1.03),('8784','2013-05-13','10:50:00',3.83),('8784','2013-05-13','10:55:00',2.46),('8784','2013-05-13','11:00:00',3.87),('8784','2013-05-13','11:05:00',3.64),('8784','2013-05-13','11:10:00',3.31),('8784','2013-05-13','11:15:00',1.98),('8784','2013-05-13','11:20:00',1.67),('8784','2013-05-13','11:25:00',1.76),('8784','2013-05-13','11:30:00',1.82),('8784','2013-05-13','11:35:00',2.72),('8784','2013-05-13','11:40:00',3.92),('8784','2013-05-13','11:45:00',2.63),('8784','2013-05-13','11:50:00',3.06),('8784','2013-05-13','11:55:00',1.93),('8784','2013-05-13','12:00:00',2),('8784','2013-05-13','12:05:00',1.97),('8784','2013-05-13','12:10:00',3.97),('8784','2013-05-13','12:15:00',2.4),('8784','2013-05-13','12:20:00',1.32),('8784','2013-05-13','12:25:00',1.21),('8784','2013-05-13','12:30:00',1.42),('8784','2013-05-13','12:35:00',5.44),('8784','2013-05-13','12:40:00',5.07),('8784','2013-05-13','12:45:00',4.18),('8784','2013-05-13','12:50:00',4.3),('8784','2013-05-13','12:55:00',3.42),('8784','2013-05-13','13:00:00',3.72),('8784','2013-05-13','13:05:00',5.17),('8784','2013-05-13','13:10:00',4.06),('8784','2013-05-13','13:15:00',2.83),('8784','2013-05-13','13:20:00',5.13),('8784','2013-05-13','13:25:00',4.99),('8784','2013-05-13','13:30:00',4.75),('8784','2013-05-13','13:35:00',4.8),('8784','2013-05-13','13:40:00',4.75),('8784','2013-05-13','13:45:00',4.59),('8784','2013-05-13','13:50:00',1.9),('8784','2013-05-13','13:55:00',3.02),('8784','2013-05-13','14:00:00',3.24),('8784','2013-05-13','14:05:00',4.15),('8784','2013-05-13','14:10:00',4.99),('8784','2013-05-13','14:15:00',4.85),('8784','2013-05-13','14:20:00',4.66),('8784','2013-05-13','14:25:00',4.62),('8784','2013-05-13','14:30:00',4.2),('8784','2013-05-13','14:35:00',2.37),('8784','2013-05-13','14:40:00',2.53),('8784','2013-05-13','14:45:00',2.59),('8784','2013-05-13','14:50:00',4.68),('8784','2013-05-13','14:55:00',4.75),('8784','2013-05-13','15:00:00',4.28),('8784','2013-05-13','15:05:00',1.73),('8784','2013-05-13','15:10:00',1.28),('8784','2013-05-13','15:15:00',1.07),('8784','2013-05-13','15:20:00',1.26),('8784','2013-05-13','15:40:00',1.18),('8784','2013-05-13','16:00:00',1.68),('8784','2013-05-13','16:05:00',2.11),('8784','2013-05-13','16:10:00',2.16),('8784','2013-05-13','16:15:00',1.45),('8784','2013-05-13','16:20:00',1.44),('8784','2013-05-13','16:25:00',1.47),('8784','2013-05-13','16:30:00',2),('8784','2013-05-13','16:35:00',1.31),('8784','2013-05-13','16:40:00',1.69),('8784','2013-05-13','16:45:00',2.47),('8784','2013-05-13','16:50:00',3.33),('8784','2013-05-13','16:55:00',3.18),('8784','2013-05-13','17:00:00',2.99),('8784','2013-05-13','17:05:00',3.07),('8784','2013-05-13','17:10:00',1.29),('8784','2013-05-13','17:15:00',2.84),('8784','2013-05-13','17:20:00',3.36),('8784','2013-05-13','17:25:00',3.19),('8784','2013-05-13','17:30:00',3.01),('8784','2013-05-13','17:35:00',2.83),('8784','2013-05-13','17:40:00',2.64),('8784','2013-05-13','17:45:00',2.51),('8784','2013-05-13','17:50:00',2.15),('8784','2013-05-13','17:55:00',1.28),('8784','2013-05-13','18:00:00',1.97),('8784','2013-05-13','18:05:00',1.5),('8784','2013-05-13','18:10:00',1.34),('8784','2013-05-13','18:15:00',1.53),('8784','2013-05-13','18:20:00',1.06),('8784','2013-05-12','08:05:00',1.19),('8784','2013-05-12','08:10:00',2.08),('8784','2013-05-12','08:15:00',1.77),('8784','2013-05-12','08:20:00',1.46),('8784','2013-05-12','08:25:00',1.96),('8784','2013-05-12','08:30:00',1.16),('8784','2013-05-12','08:40:00',1.03),('8784','2013-05-12','08:45:00',2.36),('8784','2013-05-12','08:50:00',1.43),('8784','2013-05-12','08:55:00',1.18),('8784','2013-05-12','09:00:00',1.8),('8784','2013-05-12','09:05:00',2.5),('8784','2013-05-12','09:10:00',1.74),('8784','2013-05-12','09:15:00',2.13),('8784','2013-05-12','09:20:00',3.19),('8784','2013-05-12','09:25:00',1.86),('8784','2013-05-12','09:30:00',1.29),('8784','2013-05-12','09:35:00',1.25),('8784','2013-05-12','09:40:00',1.25),('8784','2013-05-12','09:45:00',2.49),('8784','2013-05-12','09:50:00',3.99),('8784','2013-05-12','09:55:00',4.02),('8784','2013-05-12','10:00:00',3.9),('8784','2013-05-12','10:05:00',2.58),('8784','2013-05-12','10:10:00',3.79),('8784','2013-05-12','10:15:00',1.81),('8784','2013-05-12','10:20:00',1.3),('8784','2013-05-12','10:25:00',4.18),('8784','2013-05-12','10:30:00',1.76),('8784','2013-05-12','10:35:00',1.29),('8784','2013-05-12','10:40:00',1.09),('8784','2013-05-12','10:45:00',1.19),('8784','2013-05-12','10:50:00',2.31),('8784','2013-05-12','10:55:00',4.23),('8784','2013-05-12','11:00:00',2.48),('8784','2013-05-12','11:05:00',3.68),('8784','2013-05-12','11:10:00',4.67),('8784','2013-05-12','11:15:00',4.61),('8784','2013-05-12','11:20:00',4.33),('8784','2013-05-12','11:25:00',3.72),('8784','2013-05-12','11:30:00',3.31),('8784','2013-05-12','11:35:00',4.69),('8784','2013-05-12','11:40:00',3.73),('8784','2013-05-12','11:45:00',3.36),('8784','2013-05-12','11:50:00',2.01),('8784','2013-05-12','11:55:00',1.56),('8784','2013-05-12','12:00:00',3.17),('8784','2013-05-12','12:05:00',3.16),('8784','2013-05-12','12:10:00',1.76),('8784','2013-05-12','12:15:00',1.34),('8784','2013-05-12','12:20:00',1.22),('8784','2013-05-12','12:25:00',1.24),('8784','2013-05-12','12:30:00',1.88),('8784','2013-05-12','12:35:00',2.12),('8784','2013-05-12','12:40:00',2.62),('8784','2013-05-12','12:45:00',4.58),('8784','2013-05-12','12:50:00',3.45),('8784','2013-05-12','12:55:00',3.4),('8784','2013-05-12','13:00:00',1.78),('8784','2013-05-12','13:05:00',2.54),('8784','2013-05-12','13:10:00',4.5),('8784','2013-05-12','13:15:00',1.76),('8784','2013-05-12','13:20:00',3.51),('8784','2013-05-12','13:25:00',3.22),('8784','2013-05-12','13:30:00',5.11),('8784','2013-05-12','13:35:00',4.59),('8784','2013-05-12','13:40:00',3.94),('8784','2013-05-12','13:45:00',3.9),('8784','2013-05-12','13:50:00',4.86),('8784','2013-05-12','13:55:00',2.08),('8784','2013-05-12','14:00:00',4.09),('8784','2013-05-12','14:05:00',4.76),('8784','2013-05-12','14:10:00',5.01),('8784','2013-05-12','14:15:00',4.2),('8784','2013-05-12','14:20:00',4.83),('8784','2013-05-12','14:25:00',4.59),('8784','2013-05-12','14:30:00',4.68),('8784','2013-05-12','14:35:00',4.56),('8784','2013-05-12','14:40:00',4.5),('8784','2013-05-12','14:45:00',4.47),('8784','2013-05-12','14:50:00',4.53),('8784','2013-05-12','14:55:00',3.91),('8784','2013-05-12','15:00:00',4.49),('8784','2013-05-12','15:05:00',4.4),('8784','2013-05-12','15:10:00',3.77),('8784','2013-05-12','15:15:00',4.09),('8784','2013-05-12','15:20:00',2.21),('8784','2013-05-12','15:25:00',4.18),('8784','2013-05-12','15:30:00',3.82),('8784','2013-05-12','15:35:00',3.91),('8784','2013-05-12','15:40:00',3.87),('8784','2013-05-12','15:45:00',3.78),('8784','2013-05-12','15:50:00',3.7),('8784','2013-05-12','15:55:00',3.61),('8784','2013-05-12','16:00:00',3.43),('8784','2013-05-12','16:05:00',3.47),('8784','2013-05-12','16:10:00',3.44),('8784','2013-05-12','16:15:00',3.37),('8784','2013-05-12','16:20:00',3.32),('8784','2013-05-12','16:25:00',3.21),('8784','2013-05-12','16:30:00',3.14),('8784','2013-05-12','16:35:00',3.12),('8784','2013-05-12','16:40:00',3.12),('8784','2013-05-12','16:45:00',3.08),('8784','2013-05-12','16:50:00',2.85),('8784','2013-05-12','16:55:00',3.68),('8784','2013-05-12','17:00:00',3.59),('8784','2013-05-12','17:05:00',3.06),('8784','2013-05-12','17:10:00',3.41),('8784','2013-05-12','17:15:00',3.24),('8784','2013-05-12','17:20:00',2.99),('8784','2013-05-12','17:25:00',2.37),('8784','2013-05-12','17:30:00',2.01),('8784','2013-05-12','17:35:00',2.62),('8784','2013-05-12','17:40:00',1.85),('8784','2013-05-12','17:45:00',1.67),('8784','2013-05-12','17:50:00',1.47),('8784','2013-05-12','17:55:00',1.01),('8784','2013-05-12','18:00:00',1.88),('8784','2013-05-12','18:05:00',1.99),('8784','2013-05-12','18:10:00',1.91),('8784','2013-05-12','18:15:00',1.72),('8784','2013-05-12','18:20:00',1.19),('8784','2013-05-12','18:25:00',1.43),('8784','2013-05-12','18:30:00',1.24),('8784','2013-05-12','18:35:00',1.34),('8784','2013-05-12','18:40:00',1.08),('8784','2014-03-31','08:15:00',1.03),('8784','2014-03-31','08:20:00',1.12),('8784','2014-03-31','08:25:00',1.21),('8784','2014-03-31','08:30:00',1.29),('8784','2014-03-31','08:35:00',1.38),('8784','2014-03-31','08:40:00',1.47),('8784','2014-03-31','08:45:00',1.51),('8784','2014-03-31','08:50:00',1.61),('8784','2014-03-31','08:55:00',1.72),('8784','2014-03-31','09:00:00',1.81),('8784','2014-03-31','09:05:00',1.91),('8784','2014-03-31','09:10:00',1.99),('8784','2014-03-31','09:15:00',2.1),('8784','2014-03-31','09:20:00',2.13),('8784','2014-03-31','09:25:00',2.27),('8784','2014-03-31','09:30:00',2.35),('8784','2014-03-31','09:35:00',2.44),('8784','2014-03-31','09:40:00',2.51),('8784','2014-03-31','09:45:00',2.58),('8784','2014-03-31','09:50:00',2.65),('8784','2014-03-31','09:55:00',2.7),('8784','2014-03-31','10:00:00',2.77),('8784','2014-03-31','10:05:00',2.83),('8784','2014-03-31','10:10:00',2.89),('8784','2014-03-31','10:15:00',2.94),('8784','2014-03-31','10:20:00',3.02),('8784','2014-03-31','10:25:00',3.12),('8784','2014-03-31','10:30:00',3.16),('8784','2014-03-31','10:35:00',3.18),('8784','2014-03-31','10:40:00',3.25),('8784','2014-03-31','10:45:00',3.32),('8784','2014-03-31','10:50:00',3.37),('8784','2014-03-31','10:55:00',3.42),('8784','2014-03-31','11:00:00',3.45),('8784','2014-03-31','11:05:00',3.5),('8784','2014-03-31','11:10:00',3.54),('8784','2014-03-31','11:15:00',3.57),('8784','2014-03-31','11:20:00',3.63),('8784','2014-03-31','11:25:00',3.66),('8784','2014-03-31','11:30:00',3.7),('8784','2014-03-31','11:35:00',3.72),('8784','2014-03-31','11:40:00',3.74),('8784','2014-03-31','11:45:00',3.8),('8784','2014-03-31','11:50:00',3.85),('8784','2014-03-31','11:55:00',3.89),('8784','2014-03-31','12:00:00',3.87),('8784','2014-03-31','12:05:00',3.87),('8784','2014-03-31','12:10:00',3.92),('8784','2014-03-31','12:15:00',3.97),('8784','2014-03-31','12:20:00',3.92),('8784','2014-03-31','12:25:00',3.98),('8784','2014-03-31','12:30:00',4),('8784','2014-03-31','12:35:00',4.02),('8784','2014-03-31','12:40:00',4.03),('8784','2014-03-31','12:45:00',4),('8784','2014-03-31','12:50:00',3.99),('8784','2014-03-31','12:55:00',3.99),('8784','2014-03-31','13:00:00',4.02),('8784','2014-03-31','13:05:00',4.07),('8784','2014-03-31','13:10:00',4.06),('8784','2014-03-31','13:15:00',4.06),('8784','2014-03-31','13:20:00',4.07),('8784','2014-03-31','13:25:00',4.05),('8784','2014-03-31','13:30:00',4.07),('8784','2014-03-31','13:35:00',4.04),('8784','2014-03-31','13:40:00',4.08),('8784','2014-03-31','13:45:00',4.07),('8784','2014-03-31','13:50:00',4.04),('8784','2014-03-31','13:55:00',4.02),('8784','2014-03-31','14:00:00',4.01),('8784','2014-03-31','14:05:00',3.99),('8784','2014-03-31','14:10:00',3.97),('8784','2014-03-31','14:15:00',3.95),('8784','2014-03-31','14:20:00',3.94),('8784','2014-03-31','14:25:00',3.9),('8784','2014-03-31','14:30:00',3.88),('8784','2014-03-31','14:35:00',3.86),('8784','2014-03-31','14:40:00',3.83),('8784','2014-03-31','14:45:00',3.79),('8784','2014-03-31','14:50:00',3.75),('8784','2014-03-31','14:55:00',3.7),('8784','2014-03-31','15:00:00',3.69),('8784','2014-03-31','15:05:00',3.63),('8784','2014-03-31','15:10:00',3.59),('8784','2014-03-31','15:15:00',3.55),('8784','2014-03-31','15:20:00',3.48),('8784','2014-03-31','15:25:00',3.45),('8784','2014-03-31','15:30:00',3.38),('8784','2014-03-31','15:35:00',3.32),('8784','2014-03-31','15:40:00',3.26),('8784','2014-03-31','15:45:00',3.21),('8784','2014-03-31','15:50:00',3.12),('8784','2014-03-31','15:55:00',3.04),('8784','2014-03-31','16:00:00',2.98),('8784','2014-03-31','16:05:00',2.89),('8784','2014-03-31','16:10:00',2.83),('8784','2014-03-31','16:15:00',2.74),('8784','2014-03-31','16:20:00',2.68),('8784','2014-03-31','16:25:00',2.59),('8784','2014-03-31','16:30:00',2.53),('8784','2014-03-31','16:35:00',2.42),('8784','2014-03-31','16:40:00',2.37),('8784','2014-03-31','16:45:00',2.3),('8784','2014-03-31','16:50:00',2.21),('8784','2014-03-31','16:55:00',2.13),('8784','2014-03-31','17:00:00',2.04),('8784','2014-03-31','17:05:00',1.93),('8784','2014-03-31','17:10:00',1.88),('8784','2014-03-31','17:15:00',1.77),('8784','2014-03-31','17:20:00',1.67),('8784','2014-03-31','17:25:00',1.6),('8784','2014-03-31','17:30:00',1.52),('8784','2014-03-31','17:35:00',1.41),('8784','2014-03-31','17:40:00',1.35),('8784','2014-03-31','17:45:00',1.26),('8784','2014-03-31','17:50:00',1.18),('8784','2014-03-31','17:55:00',1.09),('8784','2014-03-31','18:00:00',1.01),('8784','2013-05-11','07:30:00',1.05),('8784','2013-05-11','07:40:00',1.1),('8784','2013-05-11','07:45:00',1.37),('8784','2013-05-11','07:50:00',1.53),('8784','2013-05-11','07:55:00',1.71),('8784','2013-05-11','08:00:00',1.51),('8784','2013-05-11','08:05:00',1.35),('8784','2013-05-11','08:10:00',1.01),('8784','2013-05-11','08:15:00',1.65),('8784','2013-05-11','08:20:00',1.74),('8784','2013-05-11','08:35:00',1.04),('8784','2013-05-11','09:05:00',1.43),('8784','2013-05-11','09:10:00',1.4),('8784','2013-05-11','09:15:00',1.53),('8784','2013-05-11','09:20:00',1.94),('8784','2013-05-11','09:25:00',2.19),('8784','2013-05-11','09:30:00',2.78),('8784','2013-05-11','09:35:00',2.24),('8784','2013-05-11','09:40:00',1.42),('8784','2013-05-11','09:45:00',1.54),('8784','2013-05-11','09:50:00',1.58),('8784','2013-05-11','09:55:00',2.07),('8784','2013-05-11','10:00:00',3.04),('8784','2013-05-11','10:05:00',1.36),('8784','2013-05-11','10:20:00',1.22),('8784','2013-05-11','10:25:00',1.08),('8784','2013-05-11','10:30:00',1.48),('8784','2013-05-11','10:35:00',1.3),('8784','2013-05-11','10:40:00',1.01),('8784','2013-05-11','10:45:00',1.05),('8784','2013-05-11','10:50:00',1.5),('8784','2013-05-11','10:55:00',4.29),('8784','2013-05-11','11:00:00',4.78),('8784','2013-05-11','11:05:00',1.99),('8784','2013-05-11','11:10:00',1.31),('8784','2013-05-11','11:15:00',1.02),('8784','2013-05-11','11:25:00',1.17),('8784','2013-05-11','11:30:00',2.89),('8784','2013-05-11','11:35:00',2.69),('8784','2013-05-11','11:40:00',2.89),('8784','2013-05-11','11:45:00',4.98),('8784','2013-05-11','11:50:00',1.74),('8784','2013-05-11','11:55:00',1.15),('8784','2013-05-11','12:00:00',1.79),('8784','2013-05-11','12:05:00',2.31),('8784','2013-05-11','12:10:00',1.55),('8784','2013-05-11','12:15:00',1.49),('8784','2013-05-11','12:20:00',3.04),('8784','2013-05-11','12:25:00',5.08),('8784','2013-05-11','12:30:00',2.57),('8784','2013-05-11','12:35:00',2.02),('8784','2013-05-11','12:40:00',1.98),('8784','2013-05-11','12:45:00',2.06),('8784','2013-05-11','12:50:00',1.77),('8784','2013-05-11','12:55:00',1.7),('8784','2013-05-11','13:00:00',1.84),('8784','2013-05-11','13:05:00',1.6),('8784','2013-05-11','13:10:00',1.12),('8784','2013-05-11','13:25:00',1.07),('8784','2013-05-11','13:30:00',1.19),('8784','2013-05-11','13:35:00',1.24),('8784','2013-05-11','13:50:00',1.04),('8784','2013-05-11','13:55:00',1.16),('8784','2013-05-11','14:00:00',2.06),('8784','2013-05-11','14:05:00',4.1),('8784','2013-05-11','14:10:00',2.66),('8784','2013-05-11','14:15:00',3.3),('8784','2013-05-11','14:20:00',3.09),('8784','2013-05-11','14:25:00',3.82),('8784','2013-05-11','14:30:00',2.04),('8784','2013-05-11','14:35:00',3.4),('8784','2013-05-11','14:40:00',3.42),('8784','2013-05-11','14:45:00',4.29),('8784','2013-05-11','14:50:00',4.75),('8784','2013-05-11','14:55:00',4.4),('8784','2013-05-11','15:00:00',4.28),('8784','2013-05-11','15:05:00',4.29),('8784','2013-05-11','15:10:00',4.36),('8784','2013-05-11','15:15:00',4.19),('8784','2013-05-11','15:20:00',4.01),('8784','2013-05-11','15:25:00',4.11),('8784','2013-05-11','15:30:00',4.04),('8784','2013-05-11','15:35:00',3.43),('8784','2013-05-11','15:40:00',4.06),('8784','2013-05-11','15:45:00',3.48),('8784','2013-05-11','15:50:00',3.31),('8784','2013-05-11','15:55:00',3.53),('8784','2013-05-11','16:00:00',2.97),('8784','2013-05-11','16:05:00',3.75),('8784','2013-05-11','16:10:00',2.97),('8784','2013-05-11','16:15:00',3.56),('8784','2013-05-11','16:20:00',3.58),('8784','2013-05-11','16:25:00',3.37),('8784','2013-05-11','16:30:00',3.11),('8784','2013-05-11','16:35:00',2.24),('8784','2013-05-11','16:40:00',2.9),('8784','2013-05-11','16:45:00',3.05),('8784','2013-05-11','16:50:00',2.99),('8784','2013-05-11','16:55:00',2.97),('8784','2013-05-11','17:00:00',2.87),('8784','2013-05-11','17:05:00',1.86),('8784','2013-05-11','17:10:00',2.56),('8784','2013-05-11','17:15:00',1.62),('8784','2013-05-11','17:20:00',2.03),('8784','2013-05-11','17:25:00',1.63),('8784','2013-05-11','17:30:00',2.28),('8784','2013-05-11','17:35:00',1.81),('8784','2013-05-11','17:40:00',2.22),('8784','2013-05-11','17:45:00',1.87),('8784','2013-05-11','17:50:00',1.01),('8784','2013-05-11','17:55:00',1.42),('8784','2013-05-11','18:00:00',1.01),('8784','2013-05-11','18:05:00',1.71),('8784','2013-05-11','18:10:00',1.99),('8784','2013-05-11','18:15:00',1.19),('8784','2013-05-11','18:20:00',1.16),('8784','2013-05-11','18:25:00',1.24),('8784','2013-05-11','18:30:00',1.31),('8784','2013-05-11','18:40:00',1.1),('8784','2013-05-10','07:30:00',1.05),('8784','2013-05-10','07:40:00',1.29),('8784','2013-05-10','07:45:00',1.1),('8784','2013-05-10','07:55:00',1.42),('8784','2013-05-10','08:00:00',1.72),('8784','2013-05-10','08:05:00',2.23),('8784','2013-05-10','08:10:00',2.26),('8784','2013-05-10','08:15:00',2.4),('8784','2013-05-10','08:20:00',2.18),('8784','2013-05-10','08:25:00',2.14),('8784','2013-05-10','08:30:00',2.14),('8784','2013-05-10','08:35:00',2.16),('8784','2013-05-10','09:00:00',1.68),('8784','2013-05-10','09:05:00',2.52),('8784','2013-05-10','09:10:00',2.84),('8784','2013-05-10','09:15:00',2.95),('8784','2013-05-10','09:20:00',2.81),('8784','2013-05-10','09:25:00',2.68),('8784','2013-05-10','09:30:00',2.68),('8784','2013-05-10','09:35:00',3.25),('8784','2013-05-10','09:40:00',3.01),('8784','2013-05-10','09:45:00',2.97),('8784','2013-05-10','09:50:00',3.37),('8784','2013-05-10','09:55:00',1.5),('8784','2013-05-10','10:00:00',1.6),('8784','2013-05-10','10:05:00',1.54),('8784','2013-05-10','10:10:00',1.65),('8784','2013-05-10','10:15:00',1.42),('8784','2013-05-10','10:20:00',2.78),('8784','2013-05-10','10:25:00',1.56),('8784','2013-05-10','10:30:00',1.77),('8784','2013-05-10','10:35:00',3.88),('8784','2013-05-10','10:40:00',4.2),('8784','2013-05-10','10:45:00',4.36),('8784','2013-05-10','10:50:00',3.42),('8784','2013-05-10','10:55:00',4.25),('8784','2013-05-10','11:00:00',4.2),('8784','2013-05-10','11:05:00',4.19),('8784','2013-05-10','11:10:00',4.1),('8784','2013-05-10','11:15:00',4.26),('8784','2013-05-10','11:20:00',4.63),('8784','2013-05-10','11:25:00',3.52),('8784','2013-05-10','11:30:00',3.93),('8784','2013-05-10','11:35:00',2.87),('8784','2013-05-10','11:40:00',4.11),('8784','2013-05-10','11:45:00',3.14),('8784','2013-05-10','11:50:00',3.78),('8784','2013-05-10','11:55:00',4.59),('8784','2013-05-10','12:00:00',2.91),('8784','2013-05-10','12:05:00',2.29),('8784','2013-05-10','12:10:00',2.38),('8784','2013-05-10','12:15:00',2.89),('8784','2013-05-10','12:20:00',3.39),('8784','2013-05-10','12:25:00',2.43),('8784','2013-05-10','12:30:00',2.47),('8784','2013-05-10','12:35:00',2.1),('8784','2013-05-10','12:40:00',3.43),('8784','2013-05-10','12:45:00',4.64),('8784','2013-05-10','12:50:00',3.43),('8784','2013-05-10','12:55:00',3.02),('8784','2013-05-10','13:00:00',4.09),('8784','2013-05-10','13:05:00',4.43),('8784','2013-05-10','13:10:00',5.41),('8784','2013-05-10','13:15:00',4.61),('8784','2013-05-10','13:20:00',3.43),('8784','2013-05-10','13:25:00',2.98),('8784','2013-05-10','13:30:00',3.71),('8784','2013-05-10','13:35:00',4.1),('8784','2013-05-10','13:40:00',4.07),('8784','2013-05-10','13:45:00',4.11),('8784','2013-05-10','13:50:00',2.44),('8784','2013-05-10','13:55:00',2.32),('8784','2013-05-10','14:00:00',2.13),('8784','2013-05-10','14:05:00',2.28),('8784','2013-05-10','14:10:00',2.7),('8784','2013-05-10','14:15:00',2.96),('8784','2013-05-10','14:20:00',2.77),('8784','2013-05-10','14:25:00',2.88),('8784','2013-05-10','14:30:00',2.81),('8784','2013-05-10','14:35:00',3.26),('8784','2013-05-10','14:40:00',2.92),('8784','2013-05-10','14:45:00',2.09),('8784','2013-05-10','14:50:00',1.61),('8784','2013-05-10','14:55:00',1.41),('8784','2013-05-10','15:00:00',1.35),('8784','2013-05-10','15:05:00',1.53),('8784','2013-05-10','15:10:00',2.14),('8784','2013-05-10','15:15:00',3.59),('8784','2013-05-10','15:20:00',2.64),('8784','2013-05-10','15:25:00',2.16),('8784','2013-05-10','15:30:00',2.1),('8784','2013-05-10','15:35:00',2.15),('8784','2013-05-10','15:40:00',2.24),('8784','2013-05-10','15:45:00',2.12),('8784','2013-05-10','15:50:00',1.93),('8784','2013-05-10','15:55:00',1.83),('8784','2013-05-10','16:00:00',1.8),('8784','2013-05-10','16:05:00',1.76),('8784','2013-05-10','16:10:00',1.7),('8784','2013-05-10','16:15:00',1.56),('8784','2013-05-10','16:20:00',1.43),('8784','2013-05-10','16:25:00',1.45),('8784','2013-05-10','16:30:00',1.6),('8784','2013-05-10','16:35:00',1.65),('8784','2013-05-10','16:40:00',1.55),('8784','2013-05-10','16:45:00',1.58),('8784','2013-05-10','16:50:00',1.48),('8784','2013-05-10','16:55:00',1.21),('8784','2013-05-10','17:00:00',1.01),('8784','2013-05-10','17:05:00',1.07),('8784','2013-05-10','17:10:00',1.43),('8784','2013-05-10','17:15:00',1.66),('8784','2013-05-10','17:20:00',2.61),('8784','2013-05-10','17:25:00',2.3),('8784','2013-05-10','17:30:00',2.16),('8784','2013-05-10','17:35:00',2.31),('8784','2013-05-10','17:40:00',1.5),('8784','2013-05-10','17:45:00',1.56),('8784','2013-05-10','17:50:00',1.2),('8784','2013-05-10','17:55:00',1.06),('8784','2013-05-10','18:00:00',1.01),('8784','2013-05-09','07:25:00',1.04),('8784','2013-05-09','07:30:00',1.11),('8784','2013-05-09','07:35:00',1.2),('8784','2013-05-09','07:40:00',1.28),('8784','2013-05-09','07:45:00',1.37),('8784','2013-05-09','07:50:00',1.46),('8784','2013-05-09','07:55:00',1.54),('8784','2013-05-09','08:00:00',1.63),('8784','2013-05-09','08:05:00',1.73),('8784','2013-05-09','08:10:00',1.78),('8784','2013-05-09','08:15:00',1.91),('8784','2013-05-09','08:20:00',1.99),('8784','2013-05-09','08:25:00',2.07),('8784','2013-05-09','08:30:00',2.16),('8784','2013-05-09','08:35:00',2.24),('8784','2013-05-09','08:40:00',2.34),('8784','2013-05-09','08:45:00',2.4),('8784','2013-05-09','08:50:00',2.49),('8784','2013-05-09','08:55:00',2.56),('8784','2013-05-09','09:00:00',2.65),('8784','2013-05-09','09:05:00',2.71),('8784','2013-05-09','09:10:00',2.8),('8784','2013-05-09','09:15:00',2.89),('8784','2013-05-09','09:20:00',2.96),('8784','2013-05-09','09:25:00',3.01),('8784','2013-05-09','09:30:00',3.12),('8784','2013-05-09','09:35:00',3.2),('8784','2013-05-09','09:40:00',3.26),('8784','2013-05-09','09:45:00',3.33),('8784','2013-05-09','09:50:00',3.39),('8784','2013-05-09','09:55:00',3.43),('8784','2013-05-09','10:00:00',3.52),('8784','2013-05-09','10:05:00',3.57),('8784','2013-05-09','10:10:00',3.61),('8784','2013-05-09','10:15:00',3.68),('8784','2013-05-09','10:20:00',3.72),('8784','2013-05-09','10:25:00',3.75),('8784','2013-05-09','10:30:00',3.8),('8784','2013-05-09','10:35:00',3.84),('8784','2013-05-09','10:40:00',3.9),('8784','2013-05-09','10:45:00',3.9),('8784','2013-05-09','10:50:00',3.94),('8784','2013-05-09','10:55:00',4.01),('8784','2013-05-09','11:00:00',4.03),('8784','2013-05-09','11:05:00',4.06),('8784','2013-05-09','11:10:00',4.07),('8784','2013-05-09','11:15:00',4.17),('8784','2013-05-09','11:20:00',4.18),('8784','2013-05-09','11:25:00',4.21),('8784','2013-05-09','11:30:00',4.24),('8784','2013-05-09','11:35:00',4.22),('8784','2013-05-09','11:40:00',4.24),('8784','2013-05-09','11:45:00',4.3),('8784','2013-05-09','11:50:00',4.31),('8784','2013-05-09','11:55:00',4.31),('8784','2013-05-09','12:00:00',4.34),('8784','2013-05-09','12:05:00',4.35),('8784','2013-05-09','12:10:00',4.41),('8784','2013-05-09','12:15:00',4.44),('8784','2013-05-09','12:20:00',4.47),('8784','2013-05-09','12:25:00',4.48),('8784','2013-05-09','12:30:00',4.46),('8784','2013-05-09','12:35:00',4.48),('8784','2013-05-09','12:40:00',4.49),('8784','2013-05-09','12:45:00',4.51),('8784','2013-05-09','12:50:00',4.48),('8784','2013-05-09','12:55:00',4.49),('8784','2013-05-09','13:00:00',4.46),('8784','2013-05-09','13:05:00',4.44),('8784','2013-05-09','13:10:00',4.43),('8784','2013-05-09','13:15:00',4.48),('8784','2013-05-09','13:20:00',4.48),('8784','2013-05-09','13:25:00',4.42),('8784','2013-05-09','13:30:00',4.46),('8784','2013-05-09','13:35:00',4.49),('8784','2013-05-09','13:40:00',4.53),('8784','2013-05-09','13:45:00',4.58),('8784','2013-05-09','13:50:00',4.54),('8784','2013-05-09','13:55:00',4.59),('8784','2013-05-09','14:00:00',3.94),('8784','2013-05-09','14:05:00',3.13),('8784','2013-05-09','14:10:00',4.34),('8784','2013-05-09','14:15:00',4.53),('8784','2013-05-09','14:20:00',3.94),('8784','2013-05-09','14:25:00',3.67),('8784','2013-05-09','14:30:00',4.31),('8784','2013-05-09','14:35:00',4.22),('8784','2013-05-09','14:40:00',4.18),('8784','2013-05-09','14:45:00',4.18),('8784','2013-05-09','14:50:00',4.11),('8784','2013-05-09','14:55:00',4.16),('8784','2013-05-09','15:00:00',4.09),('8784','2013-05-09','15:05:00',4.05),('8784','2013-05-09','15:10:00',4),('8784','2013-05-09','15:15:00',3.97),('8784','2013-05-09','15:20:00',3.91),('8784','2013-05-09','15:25:00',3.88),('8784','2013-05-09','15:30:00',3.8),('8784','2013-05-09','15:35:00',3.77),('8784','2013-05-09','15:40:00',3.71),('8784','2013-05-09','15:45:00',3.67),('8784','2013-05-09','15:50:00',3.62),('8784','2013-05-09','15:55:00',3.51),('8784','2013-05-09','16:00:00',3.46),('8784','2013-05-09','16:05:00',3.43),('8784','2013-05-09','16:10:00',3.38),('8784','2013-05-09','16:15:00',3.28),('8784','2013-05-09','16:20:00',3.23),('8784','2013-05-09','16:25:00',3.15),('8784','2013-05-09','16:30:00',3.09),('8784','2013-05-09','16:35:00',3.03),('8784','2013-05-09','16:40:00',2.92),('8784','2013-05-09','16:45:00',2.84),('8784','2013-05-09','16:50:00',2.77),('8784','2013-05-09','16:55:00',2.69),('8784','2013-05-09','17:00:00',2.61),('8784','2013-05-09','17:05:00',2.53),('8784','2013-05-09','17:10:00',2.44),('8784','2013-05-09','17:15:00',2.36),('8784','2013-05-09','17:20:00',2.29),('8784','2013-05-09','17:25:00',2.21),('8784','2013-05-09','17:30:00',2.12),('8784','2013-05-09','17:35:00',2.02),('8784','2013-05-09','17:40:00',1.95),('8784','2013-05-09','17:45:00',1.85),('8784','2013-05-09','17:50:00',1.77),('8784','2013-05-09','17:55:00',1.69),('8784','2013-05-09','18:00:00',1.59),('8784','2013-05-09','18:05:00',1.5),('8784','2013-05-09','18:10:00',1.41),('8784','2013-05-09','18:15:00',1.34),('8784','2013-05-09','18:20:00',1.25),('8784','2013-05-09','18:25:00',1.16),('8784','2013-05-09','18:30:00',1.07),('8784','2013-05-08','08:05:00',1.85),('8784','2013-05-08','08:10:00',1.85),('8784','2013-05-08','08:15:00',1.93),('8784','2013-05-08','08:20:00',2),('8784','2013-05-08','08:25:00',2.03),('8784','2013-05-08','08:30:00',2.09),('8784','2013-05-08','08:35:00',2.18),('8784','2013-05-08','08:40:00',2.29),('8784','2013-05-08','08:45:00',1.83),('8784','2013-05-08','08:50:00',1.06),('8784','2013-05-08','08:55:00',1.21),('8784','2013-05-08','09:00:00',1.04),('8784','2013-05-08','09:05:00',1.52),('8784','2013-05-08','09:35:00',2.75),('8784','2013-05-08','09:40:00',3.91),('8784','2013-05-08','09:45:00',2.28),('8784','2013-05-08','09:50:00',3.36),('8784','2013-05-08','09:55:00',1.67),('8784','2013-05-08','10:00:00',1.5),('8784','2013-05-08','10:05:00',3.82),('8784','2013-05-08','10:10:00',2.2),('8784','2013-05-08','10:15:00',1.1),('8784','2013-05-08','10:20:00',1.15),('8784','2013-05-08','10:25:00',1.04),('8784','2013-05-08','10:30:00',1.07),('8784','2013-05-08','10:35:00',1.04),('8784','2013-05-08','10:55:00',1.62),('8784','2013-05-08','11:00:00',2.5),('8784','2013-05-08','11:05:00',4.63),('8784','2013-05-08','11:10:00',4.34),('8784','2013-05-08','11:15:00',3.84),('8784','2013-05-08','11:20:00',3.67),('8784','2013-05-08','11:25:00',4.56),('8784','2013-05-08','11:30:00',4.67),('8784','2013-05-08','11:35:00',4.73),('8784','2013-05-08','11:40:00',2.8),('8784','2013-05-08','11:45:00',3.49),('8784','2013-05-08','11:50:00',2.45),('8784','2013-05-08','11:55:00',2.56),('8784','2013-05-08','12:00:00',2.95),('8784','2013-05-08','12:05:00',1.11),('8784','2013-05-08','12:15:00',1.19),('8784','2013-05-08','12:20:00',2.86),('8784','2013-05-08','12:25:00',1.9),('8784','2013-05-08','12:30:00',1.63),('8784','2013-05-08','12:35:00',1.35),('8784','2013-05-08','12:40:00',1.3),('8784','2013-05-08','12:45:00',1.36),('8784','2013-05-08','12:50:00',2.76),('8784','2013-05-08','12:55:00',3.42),('8784','2013-05-08','13:00:00',1.69),('8784','2013-05-08','13:05:00',1.6),('8784','2013-05-08','13:10:00',5.38),('8784','2013-05-08','13:15:00',3.44),('8784','2013-05-08','13:20:00',1.22),('8784','2013-05-08','13:25:00',2.52),('8784','2013-05-08','13:30:00',1.09),('8784','2013-05-08','13:35:00',1.06),('8784','2013-05-08','13:40:00',2.86),('8784','2013-05-08','13:45:00',5.29),('8784','2013-05-08','13:50:00',5.23),('8784','2013-05-08','13:55:00',4.82),('8784','2013-05-08','14:00:00',2.89),('8784','2013-05-08','14:05:00',3.23),('8784','2013-05-08','14:10:00',1.84),('8784','2013-05-08','14:15:00',3.14),('8784','2013-05-08','14:20:00',2.76),('8784','2013-05-08','14:25:00',1.81),('8784','2013-05-08','14:30:00',3.87),('8784','2013-05-08','14:35:00',4.15),('8784','2013-05-08','14:40:00',4.82),('8784','2013-05-08','14:45:00',4.76),('8784','2013-05-08','14:50:00',4.5),('8784','2013-05-08','14:55:00',4.32),('8784','2013-05-08','15:00:00',4.21),('8784','2013-05-08','15:05:00',4.12),('8784','2013-05-08','15:10:00',4.14),('8784','2013-05-08','15:15:00',4.09),('8784','2013-05-08','15:20:00',4),('8784','2013-05-08','15:25:00',3.99),('8784','2013-05-08','15:30:00',3.93),('8784','2013-05-08','15:35:00',3.81),('8784','2013-05-08','15:40:00',3.74),('8784','2013-05-08','15:45:00',3.7),('8784','2013-05-08','15:50:00',3.67),('8784','2013-05-08','15:55:00',3.64),('8784','2013-05-08','16:00:00',3.59),('8784','2013-05-08','16:05:00',3.51),('8784','2013-05-08','16:10:00',3.37),('8784','2013-05-08','16:15:00',3.37),('8784','2013-05-08','16:20:00',3.3),('8784','2013-05-08','16:25:00',3.24),('8784','2013-05-08','16:30:00',3.27),('8784','2013-05-08','16:35:00',3.17),('8784','2013-05-08','16:40:00',2.41),('8784','2013-05-08','16:45:00',3.1),('8784','2013-05-08','16:50:00',2.06),('8784','2013-05-08','16:55:00',2.72),('8784','2013-05-08','17:00:00',2.64),('8784','2013-05-08','17:05:00',2.94),('8784','2013-05-08','17:10:00',2.49),('8784','2013-05-08','17:15:00',2.51),('8784','2013-05-08','17:20:00',2.39),('8784','2013-05-08','17:25:00',2.22),('8784','2013-05-08','17:30:00',2.56),('8784','2013-05-08','17:35:00',2.46),('8784','2013-05-08','17:40:00',2.43),('8784','2013-05-08','17:45:00',2.47),('8784','2013-05-08','17:50:00',2.47),('8784','2013-05-08','17:55:00',2.36),('8784','2013-05-08','18:00:00',1.2),('8784','2013-05-08','18:10:00',1.02),('8784','2013-05-08','18:15:00',1.76),('8784','2013-05-08','18:20:00',1.65),('8784','2013-05-08','18:25:00',1.49),('8784','2013-05-08','18:30:00',1.29),('8784','2013-05-08','18:35:00',1.11),('8784','2013-05-07','07:25:00',1),('8784','2013-05-07','07:30:00',1.09),('8784','2013-05-07','07:35:00',1.18),('8784','2013-05-07','07:40:00',1.27),('8784','2013-05-07','07:45:00',1.34),('8784','2013-05-07','07:50:00',1.43),('8784','2013-05-07','07:55:00',1.51),('8784','2013-05-07','08:00:00',1.6),('8784','2013-05-07','08:05:00',1.67),('8784','2013-05-07','08:10:00',1.77),('8784','2013-05-07','08:15:00',1.86),('8784','2013-05-07','08:20:00',1.95),('8784','2013-05-07','08:25:00',2.04),('8784','2013-05-07','08:30:00',2.09),('8784','2013-05-07','08:35:00',2.23),('8784','2013-05-07','08:40:00',2.3),('8784','2013-05-07','08:45:00',2.4),('8784','2013-05-07','08:50:00',2.56),('8784','2013-05-07','08:55:00',2.55),('8784','2013-05-07','09:00:00',2.56),('8784','2013-05-07','09:15:00',2.79),('8784','2013-05-07','09:20:00',1.01),('8784','2013-05-07','09:30:00',1.63),('8784','2013-05-07','09:35:00',3.11),('8784','2013-05-07','09:40:00',2.06),('8784','2013-05-07','09:45:00',1.7),('8784','2013-05-07','09:50:00',1.58),('8784','2013-05-07','09:55:00',1.1),('8784','2013-05-07','10:50:00',1),('8784','2013-05-07','10:55:00',1.25),('8784','2013-05-07','11:00:00',1.41),('8784','2013-05-07','11:05:00',1.48),('8784','2013-05-07','11:10:00',1.56),('8784','2013-05-07','11:15:00',1.54),('8784','2013-05-07','11:20:00',2.82),('8784','2013-05-07','11:25:00',1.6),('8784','2013-05-07','11:55:00',1.03),('8784','2013-05-07','12:00:00',1.72),('8784','2013-05-07','12:05:00',4.25),('8784','2013-05-07','12:10:00',4.21),('8784','2013-05-07','12:15:00',2.46),('8784','2013-05-07','12:20:00',5.35),('8784','2013-05-07','12:25:00',3.23),('8784','2013-05-07','12:30:00',1.17),('8784','2013-05-07','12:40:00',1.02),('8784','2013-05-07','13:10:00',1.22),('8784','2013-05-07','13:15:00',1.45),('8784','2013-05-07','13:20:00',1.71),('8784','2013-05-07','13:25:00',2.8),('8784','2013-05-07','13:30:00',3.2),('8784','2013-05-07','13:35:00',5.55),('8784','2013-05-07','13:40:00',5.48),('8784','2013-05-07','13:45:00',5.11),('8784','2013-05-07','13:50:00',4.87),('8784','2013-05-07','13:55:00',1.65),('8784','2013-05-07','14:00:00',5.05),('8784','2013-05-07','14:05:00',4.96),('8784','2013-05-07','14:10:00',4.24),('8784','2013-05-07','14:15:00',4.94),('8784','2013-05-07','14:20:00',2.28),('8784','2013-05-07','14:25:00',4.47),('8784','2013-05-07','14:30:00',2.68),('8784','2013-05-07','14:35:00',5.04),('8784','2013-05-07','14:40:00',4.43),('8784','2013-05-07','14:45:00',3.14),('8784','2013-05-07','14:50:00',3.68),('8784','2013-05-07','14:55:00',3.49),('8784','2013-05-07','15:00:00',4.57),('8784','2013-05-07','15:05:00',4.03),('8784','2013-05-07','15:10:00',4.04),('8784','2013-05-07','15:15:00',4.34),('8784','2013-05-07','15:20:00',4.41),('8784','2013-05-07','15:25:00',3.08),('8784','2013-05-07','15:30:00',2.88),('8784','2013-05-07','15:35:00',3.13),('8784','2013-05-07','15:40:00',3.5),('8784','2013-05-07','15:45:00',3.37),('8784','2013-05-07','15:50:00',2.07),('8784','2013-05-07','15:55:00',2.55),('8784','2013-05-07','16:00:00',4.29),('8784','2013-05-07','16:05:00',1.76),('8784','2013-05-07','16:10:00',1.83),('8784','2013-05-07','16:15:00',3.6),('8784','2013-05-07','16:20:00',4.3),('8784','2013-05-07','16:25:00',4.19),('8784','2013-05-07','16:30:00',3.91),('8784','2013-05-07','16:35:00',3.81),('8784','2013-05-07','16:40:00',3.55),('8784','2013-05-07','16:45:00',3.54),('8784','2013-05-07','16:50:00',3.35),('8784','2013-05-07','16:55:00',2.72),('8784','2013-05-07','17:00:00',2.99),('8784','2013-05-07','17:05:00',3.1),('8784','2013-05-07','17:10:00',1.43),('8784','2013-05-07','17:15:00',1.32),('8784','2013-05-07','17:20:00',1.33),('8784','2013-05-07','17:25:00',1.31),('8784','2013-05-07','17:30:00',1.18),('8784','2013-05-07','17:35:00',1.11),('8784','2013-05-07','17:40:00',1.04),('8784','2013-05-06','08:25:00',1.26),('8784','2013-05-06','08:30:00',1.37),('8784','2013-05-06','08:35:00',1.25),('8784','2013-05-06','08:40:00',1.14),('8784','2013-05-06','08:50:00',1.4),('8784','2013-05-06','08:55:00',2.54),('8784','2013-05-06','09:00:00',2.58),('8784','2013-05-06','09:05:00',1.66),('8784','2013-05-06','09:10:00',1.5),('8784','2013-05-06','09:15:00',1.4),('8784','2013-05-06','09:20:00',1.51),('8784','2013-05-06','09:25:00',1.3),('8784','2013-05-06','09:30:00',1.06),('8784','2013-05-06','09:55:00',1.19),('8784','2013-05-06','10:00:00',2.1),('8784','2013-05-06','10:05:00',1.26),('8784','2013-05-06','10:10:00',1.14),('8784','2013-05-06','10:15:00',1.65),('8784','2013-05-06','10:20:00',2.53),('8784','2013-05-06','10:25:00',2.11),('8784','2013-05-06','10:30:00',2.14),('8784','2013-05-06','10:35:00',2.07),('8784','2013-05-06','10:40:00',2.01),('8784','2013-05-06','10:45:00',3.01),('8784','2013-05-06','10:50:00',2.41),('8784','2013-05-06','10:55:00',2.08),('8784','2013-05-06','11:00:00',1.95),('8784','2013-05-06','11:05:00',2.27),('8784','2013-05-06','11:10:00',2.26),('8784','2013-05-06','11:15:00',1.93),('8784','2013-05-06','11:20:00',2.24),('8784','2013-05-06','11:25:00',2.24),('8784','2013-05-06','11:30:00',1.4),('8784','2013-05-06','11:35:00',2.04),('8784','2013-05-06','11:40:00',2.46),('8784','2013-05-06','11:45:00',3.98),('8784','2013-05-06','11:50:00',2.51),('8784','2013-05-06','11:55:00',1.8),('8784','2013-05-06','12:00:00',2.06),('8784','2013-05-06','12:05:00',1.95),('8784','2013-05-06','12:10:00',2.85),('8784','2013-05-06','12:15:00',2.45),('8784','2013-05-06','12:20:00',2.58),('8784','2013-05-06','12:25:00',4.1),('8784','2013-05-06','12:30:00',3.92),('8784','2013-05-06','12:35:00',4.7),('8784','2013-05-06','12:40:00',2.29),('8784','2013-05-06','12:45:00',2.31),('8784','2013-05-06','12:50:00',3.3),('8784','2013-05-06','12:55:00',3),('8784','2013-05-06','13:00:00',2.3),('8784','2013-05-06','13:05:00',3.67),('8784','2013-05-06','13:10:00',4.28),('8784','2013-05-06','13:15:00',3.5),('8784','2013-05-06','13:20:00',4.34),('8784','2013-05-06','13:25:00',3.29),('8784','2013-05-06','13:30:00',3.3),('8784','2013-05-06','13:35:00',3.14),('8784','2013-05-06','13:40:00',3.29),('8784','2013-05-06','13:45:00',3.99),('8784','2013-05-06','13:50:00',4.78),('8784','2013-05-06','13:55:00',4.7),('8784','2013-05-06','14:00:00',4.24),('8784','2013-05-06','14:05:00',3.51),('8784','2013-05-06','14:10:00',3.93),('8784','2013-05-06','14:15:00',4.77),('8784','2013-05-06','14:20:00',4.72),('8784','2013-05-06','14:25:00',2.17),('8784','2013-05-06','14:30:00',4.65),('8784','2013-05-06','14:35:00',4.43),('8784','2013-05-06','14:40:00',3.47),('8784','2013-05-06','14:45:00',2.75),('8784','2013-05-06','14:50:00',3.52),('8784','2013-05-06','14:55:00',4.27),('8784','2013-05-06','15:00:00',2.72),('8784','2013-05-06','15:05:00',2.68),('8784','2013-05-06','15:10:00',2.71),('8784','2013-05-06','15:15:00',3.11),('8784','2013-05-06','15:20:00',2.27),('8784','2013-05-06','15:25:00',2.2),('8784','2013-05-06','15:30:00',2.7),('8784','2013-05-06','15:35:00',3.14),('8784','2013-05-06','15:40:00',1.41),('8784','2013-05-06','15:45:00',1.52),('8784','2013-05-06','15:50:00',2.36),('8784','2013-05-06','15:55:00',1.57),('8784','2013-05-06','16:00:00',1.77),('8784','2013-05-06','16:05:00',1.61),('8784','2013-05-06','16:10:00',1.6),('8784','2013-05-06','16:15:00',1.62),('8784','2013-05-06','16:20:00',2.66),('8784','2013-05-06','16:25:00',2.37),('8784','2013-05-06','16:30:00',3.12),('8784','2013-05-06','16:35:00',2.49),('8784','2013-05-06','16:40:00',2.86),('8784','2013-05-06','16:45:00',1.91),('8784','2013-05-06','16:50:00',3.27),('8784','2013-05-06','16:55:00',2.52),('8784','2013-05-06','17:15:00',1.49),('8784','2013-05-06','17:20:00',1.12),('8784','2013-05-06','17:35:00',1.88),('8784','2013-05-06','17:40:00',1.61),('8784','2013-05-06','17:45:00',1.27),('8784','2013-05-06','17:50:00',1.16),('8784','2013-05-06','17:55:00',1.34),('8784','2013-05-06','18:00:00',1.57),('8784','2013-05-06','18:05:00',1.88),('8784','2013-05-06','18:15:00',1.17),('8784','2013-05-06','18:20:00',1.71),('8784','2013-05-06','18:25:00',1.36),('8784','2013-05-06','18:30:00',1.11),('8784','2013-05-05','07:45:00',1.2),('8784','2013-05-05','07:50:00',1.25),('8784','2013-05-05','07:55:00',1.15),('8784','2013-05-05','08:00:00',1.34),('8784','2013-05-05','08:05:00',1.53),('8784','2013-05-05','08:10:00',1.62),('8784','2013-05-05','08:15:00',1.75),('8784','2013-05-05','08:20:00',1.99),('8784','2013-05-05','08:25:00',2.37),('8784','2013-05-05','08:30:00',2.45),('8784','2013-05-05','08:35:00',2.36),('8784','2013-05-05','08:40:00',2.3),('8784','2013-05-05','08:45:00',1.74),('8784','2013-05-05','08:50:00',1.43),('8784','2013-05-05','08:55:00',1.5),('8784','2013-05-05','09:00:00',1.5),('8784','2013-05-05','09:05:00',1.48),('8784','2013-05-05','09:10:00',1.52),('8784','2013-05-05','09:15:00',1.47),('8784','2013-05-05','09:20:00',1.34),('8784','2013-05-05','09:25:00',1.71),('8784','2013-05-05','09:30:00',1.73),('8784','2013-05-05','09:35:00',1.62),('8784','2013-05-05','09:40:00',2.69),('8784','2013-05-05','09:45:00',3.37),('8784','2013-05-05','09:50:00',3.39),('8784','2013-05-05','09:55:00',3.21),('8784','2013-05-05','10:00:00',3.18),('8784','2013-05-05','10:05:00',2.78),('8784','2013-05-05','10:10:00',2.31),('8784','2013-05-05','10:15:00',3.3),('8784','2013-05-05','10:20:00',4.02),('8784','2013-05-05','10:25:00',2.41),('8784','2013-05-05','10:30:00',2.86),('8784','2013-05-05','10:35:00',3.03),('8784','2013-05-05','10:40:00',3.12),('8784','2013-05-05','10:45:00',2.91),('8784','2013-05-05','10:50:00',1.89),('8784','2013-05-05','10:55:00',1.64),('8784','2013-05-05','11:00:00',1.61),('8784','2013-05-05','11:05:00',1.87),('8784','2013-05-05','11:10:00',1.7),('8784','2013-05-05','11:15:00',1.84),('8784','2013-05-05','11:20:00',2.87),('8784','2013-05-05','11:25:00',3.72),('8784','2013-05-05','11:30:00',2.8),('8784','2013-05-05','11:35:00',3.89),('8784','2013-05-05','11:40:00',2.88),('8784','2013-05-05','11:45:00',2.9),('8784','2013-05-05','11:50:00',3.14),('8784','2013-05-05','11:55:00',4.26),('8784','2013-05-05','12:00:00',3.31),('8784','2013-05-05','12:05:00',3.45),('8784','2013-05-05','12:10:00',3.12),('8784','2013-05-05','12:15:00',3.78),('8784','2013-05-05','12:20:00',2.11),('8784','2013-05-05','12:25:00',4.25),('8784','2013-05-05','12:30:00',3.64),('8784','2013-05-05','12:35:00',4.15),('8784','2013-05-05','12:40:00',4.74),('8784','2013-05-05','12:45:00',4.74),('8784','2013-05-05','12:50:00',4.33),('8784','2013-05-05','12:55:00',4.67),('8784','2013-05-05','13:00:00',4.65),('8784','2013-05-05','13:05:00',4.51),('8784','2013-05-05','13:10:00',4.56),('8784','2013-05-05','13:15:00',3.69),('8784','2013-05-05','13:20:00',3.01),('8784','2013-05-05','13:25:00',2.08),('8784','2013-05-05','13:30:00',1.88),('8784','2013-05-05','13:35:00',4.79),('8784','2013-05-05','13:40:00',4.66),('8784','2013-05-05','13:45:00',4.53),('8784','2013-05-05','13:50:00',4.6),('8784','2013-05-05','13:55:00',4.61),('8784','2013-05-05','14:00:00',4.71),('8784','2013-05-05','14:05:00',4.4),('8784','2013-05-05','14:10:00',3.46),('8784','2013-05-05','14:15:00',3.92),('8784','2013-05-05','14:20:00',4.34),('8784','2013-05-05','14:25:00',4.08),('8784','2013-05-05','14:30:00',3.96),('8784','2013-05-05','14:35:00',3.94),('8784','2013-05-05','14:40:00',3.92),('8784','2013-05-05','14:45:00',3.89),('8784','2013-05-05','14:50:00',3.85),('8784','2013-05-05','14:55:00',3.82),('8784','2013-05-05','15:00:00',3.72),('8784','2013-05-05','15:05:00',3.73),('8784','2013-05-05','15:10:00',3.71),('8784','2013-05-05','15:15:00',3.66),('8784','2013-05-05','15:20:00',3.6),('8784','2013-05-05','15:25:00',3.59),('8784','2013-05-05','15:30:00',3.57),('8784','2013-05-05','15:35:00',3.54),('8784','2013-05-05','15:40:00',3.47),('8784','2013-05-05','15:45:00',3.4),('8784','2013-05-05','15:50:00',3.35),('8784','2013-05-05','15:55:00',3.29),('8784','2013-05-05','16:00:00',3.25),('8784','2013-05-05','16:05:00',3.19),('8784','2013-05-05','16:10:00',3.13),('8784','2013-05-05','16:15:00',3.05),('8784','2013-05-05','16:20:00',2.99),('8784','2013-05-05','16:25:00',2.94),('8784','2013-05-05','16:30:00',2.88),('8784','2013-05-05','16:35:00',2.8),('8784','2013-05-05','16:40:00',2.73),('8784','2013-05-05','16:45:00',2.64),('8784','2013-05-05','16:50:00',2.57),('8784','2013-05-05','16:55:00',2.5),('8784','2013-05-05','17:00:00',2.41),('8784','2013-05-05','17:05:00',2.34),('8784','2013-05-05','17:10:00',2.26),('8784','2013-05-05','17:15:00',2.19),('8784','2013-05-05','17:20:00',2.11),('8784','2013-05-05','17:25:00',2),('8784','2013-05-05','17:30:00',1.92),('8784','2013-05-05','17:35:00',1.84),('8784','2013-05-05','17:40:00',1.76),('8784','2013-05-05','17:45:00',1.69),('8784','2013-05-05','17:50:00',1.6),('8784','2013-05-05','17:55:00',1.5),('8784','2013-05-05','18:00:00',1.41),('8784','2013-05-05','18:05:00',1.34),('8784','2013-05-05','18:10:00',1.25),('8784','2013-05-05','18:15:00',1.18),('8784','2013-05-05','18:20:00',1.1),('8784','2013-05-05','18:25:00',1.02),('8784','2013-05-04','07:40:00',1.08),('8784','2013-05-04','07:45:00',1.05),('8784','2013-05-04','07:50:00',1.11),('8784','2013-05-04','07:55:00',1.29),('8784','2013-05-04','08:00:00',1.41),('8784','2013-05-04','08:05:00',1.48),('8784','2013-05-04','08:10:00',1.56),('8784','2013-05-04','08:15:00',1.64),('8784','2013-05-04','08:20:00',1.72),('8784','2013-05-04','08:25:00',1.78),('8784','2013-05-04','08:30:00',1.86),('8784','2013-05-04','08:35:00',1.92),('8784','2013-05-04','08:40:00',1.97),('8784','2013-05-04','08:45:00',2.06),('8784','2013-05-04','08:50:00',2.13),('8784','2013-05-04','08:55:00',2.19),('8784','2013-05-04','09:00:00',2.26),('8784','2013-05-04','09:05:00',2.36),('8784','2013-05-04','09:10:00',2.43),('8784','2013-05-04','09:15:00',2.49),('8784','2013-05-04','09:20:00',2.61),('8784','2013-05-04','09:25:00',2.64),('8784','2013-05-04','09:30:00',2.68),('8784','2013-05-04','09:35:00',2.8),('8784','2013-05-04','09:40:00',2.89),('8784','2013-05-04','09:45:00',2.97),('8784','2013-05-04','09:50:00',3.04),('8784','2013-05-04','09:55:00',3.05),('8784','2013-05-04','10:00:00',3.14),('8784','2013-05-04','10:05:00',3.18),('8784','2013-05-04','10:10:00',3.29),('8784','2013-05-04','10:15:00',3.36),('8784','2013-05-04','10:20:00',3.4),('8784','2013-05-04','10:25:00',3.44),('8784','2013-05-04','10:30:00',3.48),('8784','2013-05-04','10:35:00',3.52),('8784','2013-05-04','10:40:00',3.5),('8784','2013-05-04','10:45:00',3.53),('8784','2013-05-04','10:50:00',3.45),('8784','2013-05-04','10:55:00',3.47),('8784','2013-05-04','11:00:00',3.47),('8784','2013-05-04','11:05:00',3.45),('8784','2013-05-04','11:10:00',3.29),('8784','2013-05-04','11:15:00',3.26),('8784','2013-05-04','11:20:00',3.57),('8784','2013-05-04','11:25:00',3.58),('8784','2013-05-04','11:30:00',3.49),('8784','2013-05-04','11:35:00',3.53),('8784','2013-05-04','11:40:00',3.39),('8784','2013-05-04','11:45:00',3.57),('8784','2013-05-04','11:50:00',3.53),('8784','2013-05-04','11:55:00',3.52),('8784','2013-05-04','12:00:00',3.51),('8784','2013-05-04','12:05:00',3.64),('8784','2013-05-04','12:10:00',3.66),('8784','2013-05-04','12:15:00',3.75),('8784','2013-05-04','12:20:00',3.79),('8784','2013-05-04','12:25:00',3.88),('8784','2013-05-04','12:30:00',3.92),('8784','2013-05-04','12:35:00',3.95),('8784','2013-05-04','12:40:00',3.92),('8784','2013-05-04','12:45:00',3.92),('8784','2013-05-04','12:50:00',3.8),('8784','2013-05-04','12:55:00',3.76),('8784','2013-05-04','13:00:00',3.71),('8784','2013-05-04','13:05:00',3.32),('8784','2013-05-04','13:10:00',3.7),('8784','2013-05-04','13:15:00',4.1),('8784','2013-05-04','13:20:00',4.1),('8784','2013-05-04','13:25:00',3.91),('8784','2013-05-04','13:30:00',4.01),('8784','2013-05-04','13:35:00',3.67),('8784','2013-05-04','13:40:00',3.82),('8784','2013-05-04','13:45:00',3.81),('8784','2013-05-04','13:50:00',3.38),('8784','2013-05-04','13:55:00',3.48),('8784','2013-05-04','14:00:00',3.81),('8784','2013-05-04','14:05:00',3.7),('8784','2013-05-04','14:10:00',3.58),('8784','2013-05-04','14:15:00',3.69),('8784','2013-05-04','14:20:00',3.65),('8784','2013-05-04','14:25:00',3.41),('8784','2013-05-04','14:30:00',3.57),('8784','2013-05-04','14:35:00',3.33),('8784','2013-05-04','14:40:00',3.47),('8784','2013-05-04','14:45:00',3.41),('8784','2013-05-04','14:50:00',3.33),('8784','2013-05-04','14:55:00',3.44),('8784','2013-05-04','15:00:00',3.5),('8784','2013-05-04','15:05:00',3.57),('8784','2013-05-04','15:10:00',3.35),('8784','2013-05-04','15:15:00',3.43),('8784','2013-05-04','15:20:00',3.39),('8784','2013-05-04','15:25:00',3.41),('8784','2013-05-04','15:30:00',3.37),('8784','2013-05-04','15:35:00',3.22),('8784','2013-05-04','15:40:00',3.34),('8784','2013-05-04','15:45:00',3.27),('8784','2013-05-04','15:50:00',3.21),('8784','2013-05-04','15:55:00',3.15),('8784','2013-05-04','16:00:00',3.09),('8784','2013-05-04','16:05:00',3.03),('8784','2013-05-04','16:10:00',2.97),('8784','2013-05-04','16:15:00',2.91),('8784','2013-05-04','16:20:00',2.85),('8784','2013-05-04','16:25:00',2.78),('8784','2013-05-04','16:30:00',2.66),('8784','2013-05-04','16:35:00',2.63),('8784','2013-05-04','16:40:00',2.57),('8784','2013-05-04','16:45:00',2.49),('8784','2013-05-04','16:50:00',2.4),('8784','2013-05-04','16:55:00',2.34),('8784','2013-05-04','17:00:00',2.29),('8784','2013-05-04','17:05:00',2.18),('8784','2013-05-04','17:10:00',1.69),('8784','2013-05-04','17:15:00',1.98),('8784','2013-05-04','17:20:00',2.03),('8784','2013-05-04','17:25:00',1.94),('8784','2013-05-04','17:30:00',1.82),('8784','2013-05-04','17:35:00',1.67),('8784','2013-05-04','17:40:00',1.59),('8784','2013-05-04','17:45:00',1.56),('8784','2013-05-04','17:50:00',1.55),('8784','2013-05-04','17:55:00',1.48),('8784','2013-05-04','18:00:00',1.41),('8784','2013-05-04','18:05:00',1.33),('8784','2013-05-04','18:10:00',1.12),('8784','2013-05-03','08:05:00',1.45),('8784','2013-05-03','08:10:00',1.64),('8784','2013-05-03','08:15:00',1.85),('8784','2013-05-03','08:20:00',1.81),('8784','2013-05-03','08:25:00',1.96),('8784','2013-05-03','08:30:00',2.03),('8784','2013-05-03','08:35:00',2.08),('8784','2013-05-03','08:40:00',2.15),('8784','2013-05-03','08:45:00',2.19),('8784','2013-05-03','08:50:00',2.16),('8784','2013-05-03','08:55:00',2.22),('8784','2013-05-03','09:00:00',2.4),('8784','2013-05-03','09:05:00',2.49),('8784','2013-05-03','09:10:00',2.55),('8784','2013-05-03','09:15:00',2.63),('8784','2013-05-03','09:20:00',2.7),('8784','2013-05-03','09:25:00',2.75),('8784','2013-05-03','09:30:00',2.84),('8784','2013-05-03','09:35:00',2.91),('8784','2013-05-03','09:40:00',2.98),('8784','2013-05-03','09:45:00',3.05),('8784','2013-05-03','09:50:00',3.09),('8784','2013-05-03','09:55:00',3.18),('8784','2013-05-03','10:00:00',3.25),('8784','2013-05-03','10:05:00',3.31),('8784','2013-05-03','10:10:00',3.36),('8784','2013-05-03','10:15:00',3.4),('8784','2013-05-03','10:20:00',3.45),('8784','2013-05-03','10:25:00',3.49),('8784','2013-05-03','10:30:00',3.49),('8784','2013-05-03','10:35:00',3.58),('8784','2013-05-03','10:40:00',3.64),('8784','2013-05-03','10:45:00',3.7),('8784','2013-05-03','10:50:00',3.76),('8784','2013-05-03','10:55:00',3.79),('8784','2013-05-03','11:00:00',3.8),('8784','2013-05-03','11:05:00',3.83),('8784','2013-05-03','11:10:00',3.86),('8784','2013-05-03','11:15:00',3.9),('8784','2013-05-03','11:20:00',3.93),('8784','2013-05-03','11:25:00',3.98),('8784','2013-05-03','11:30:00',3.97),('8784','2013-05-03','11:35:00',4.03),('8784','2013-05-03','11:40:00',4.07),('8784','2013-05-03','11:45:00',4.05),('8784','2013-05-03','11:50:00',4.09),('8784','2013-05-03','11:55:00',4.12),('8784','2013-05-03','12:00:00',4.09),('8784','2013-05-03','12:05:00',4.06),('8784','2013-05-03','12:10:00',4.11),('8784','2013-05-03','12:15:00',4.17),('8784','2013-05-03','12:20:00',4.2),('8784','2013-05-03','12:25:00',4.19),('8784','2013-05-03','12:30:00',4.18),('8784','2013-05-03','12:35:00',4.18),('8784','2013-05-03','12:40:00',4.18),('8784','2013-05-03','12:45:00',4.11),('8784','2013-05-03','12:50:00',4.23),('8784','2013-05-03','12:55:00',4.24),('8784','2013-05-03','13:00:00',4.22),('8784','2013-05-03','13:05:00',4.2),('8784','2013-05-03','13:10:00',4.2),('8784','2013-05-03','13:15:00',4.19),('8784','2013-05-03','13:20:00',4.18),('8784','2013-05-03','13:25:00',4.19),('8784','2013-05-03','13:30:00',4.16),('8784','2013-05-03','13:35:00',4.05),('8784','2013-05-03','13:40:00',4),('8784','2013-05-03','13:45:00',4),('8784','2013-05-03','13:50:00',4.02),('8784','2013-05-03','13:55:00',4.01),('8784','2013-05-03','14:00:00',3.95),('8784','2013-05-03','14:05:00',3.8),('8784','2013-05-03','14:10:00',3.83),('8784','2013-05-03','14:15:00',3.79),('8784','2013-05-03','14:20:00',3.92),('8784','2013-05-03','14:25:00',3.88),('8784','2013-05-03','14:30:00',3.86),('8784','2013-05-03','14:35:00',3.87),('8784','2013-05-03','14:40:00',3.8),('8784','2013-05-03','14:45:00',3.77),('8784','2013-05-03','14:50:00',3.72),('8784','2013-05-03','14:55:00',3.73),('8784','2013-05-03','15:00:00',3.74),('8784','2013-05-03','15:05:00',3.66),('8784','2013-05-03','15:10:00',3.66),('8784','2013-05-03','15:15:00',3.66),('8784','2013-05-03','15:20:00',3.58),('8784','2013-05-03','15:25:00',3.58),('8784','2013-05-03','15:30:00',3.56),('8784','2013-05-03','15:35:00',3.47),('8784','2013-05-03','15:40:00',3.43),('8784','2013-05-03','15:45:00',3.37),('8784','2013-05-03','15:50:00',3.3),('8784','2013-05-03','15:55:00',3.24),('8784','2013-05-03','16:00:00',3.21),('8784','2013-05-03','16:05:00',3.15),('8784','2013-05-03','16:10:00',3.1),('8784','2013-05-03','16:15:00',3.01),('8784','2013-05-03','16:20:00',2.87),('8784','2013-05-03','16:25:00',2.85),('8784','2013-05-03','16:30:00',2.84),('8784','2013-05-03','16:35:00',2.77),('8784','2013-05-03','16:40:00',2.69),('8784','2013-05-03','16:45:00',2.62),('8784','2013-05-03','16:50:00',2.54),('8784','2013-05-03','16:55:00',2.45),('8784','2013-05-03','17:00:00',2.38),('8784','2013-05-03','17:05:00',2.29),('8784','2013-05-03','17:10:00',2.18),('8784','2013-05-03','17:15:00',2.11),('8784','2013-05-03','17:20:00',2),('8784','2013-05-03','17:25:00',1.9),('8784','2013-05-03','17:30:00',1.8),('8784','2013-05-03','17:35:00',1.71),('8784','2013-05-03','17:40:00',1.63),('8784','2013-05-03','17:45:00',1.54),('8784','2013-05-03','17:50:00',1.44),('8784','2013-05-03','17:55:00',1.39),('8784','2013-05-03','18:00:00',1.34),('8784','2013-05-03','18:05:00',1.27),('8784','2013-05-03','18:10:00',1.19),('8784','2013-05-03','18:15:00',1.11),('8784','2013-05-03','18:20:00',1.03),('8784','2013-05-02','08:55:00',1.36),('8784','2013-05-02','09:00:00',1.95),('8784','2013-05-02','09:05:00',1.52),('8784','2013-05-02','09:20:00',1.12),('8784','2013-05-02','09:25:00',1.83),('8784','2013-05-02','09:30:00',2.36),('8784','2013-05-02','09:35:00',2.05),('8784','2013-05-02','09:40:00',1.6),('8784','2013-05-02','09:45:00',2.79),('8784','2013-05-02','09:50:00',1.46),('8784','2013-05-02','09:55:00',1.13),('8784','2013-05-02','10:00:00',1.13),('8784','2013-05-02','10:05:00',1.57),('8784','2013-05-02','10:10:00',1.51),('8784','2013-05-02','10:15:00',1.63),('8784','2013-05-02','10:20:00',1.59),('8784','2013-05-02','10:25:00',1.89),('8784','2013-05-02','10:30:00',3.01),('8784','2013-05-02','10:35:00',2.85),('8784','2013-05-02','10:40:00',3.63),('8784','2013-05-02','10:45:00',3.33),('8784','2013-05-02','10:50:00',3.89),('8784','2013-05-02','10:55:00',4.14),('8784','2013-05-02','11:00:00',4.06),('8784','2013-05-02','11:05:00',3.66),('8784','2013-05-02','11:10:00',3.14),('8784','2013-05-02','11:15:00',3.04),('8784','2013-05-02','11:20:00',3.07),('8784','2013-05-02','11:25:00',4.01),('8784','2013-05-02','11:30:00',4.19),('8784','2013-05-02','11:35:00',4.02),('8784','2013-05-02','11:40:00',3.99),('8784','2013-05-02','11:45:00',3.99),('8784','2013-05-02','11:50:00',3.99),('8784','2013-05-02','11:55:00',4.01),('8784','2013-05-02','12:00:00',4),('8784','2013-05-02','12:05:00',4),('8784','2013-05-02','12:10:00',4),('8784','2013-05-02','12:15:00',4.04),('8784','2013-05-02','12:20:00',4.04),('8784','2013-05-02','12:25:00',4.05),('8784','2013-05-02','12:30:00',4.11),('8784','2013-05-02','12:35:00',4.12),('8784','2013-05-02','12:40:00',4.18),('8784','2013-05-02','12:45:00',4.19),('8784','2013-05-02','12:50:00',4.19),('8784','2013-05-02','12:55:00',4.23),('8784','2013-05-02','13:00:00',4.26),('8784','2013-05-02','13:05:00',4.29),('8784','2013-05-02','13:10:00',4.32),('8784','2013-05-02','13:15:00',4.31),('8784','2013-05-02','13:20:00',4.31),('8784','2013-05-02','13:25:00',4.32),('8784','2013-05-02','13:30:00',4.32),('8784','2013-05-02','13:35:00',4.3),('8784','2013-05-02','13:40:00',4.27),('8784','2013-05-02','13:45:00',4.24),('8784','2013-05-02','13:50:00',4.22),('8784','2013-05-02','13:55:00',4.22),('8784','2013-05-02','14:00:00',4.17),('8784','2013-05-02','14:05:00',4.12),('8784','2013-05-02','14:10:00',4.08),('8784','2013-05-02','14:15:00',4.09),('8784','2013-05-02','14:20:00',4),('8784','2013-05-02','14:25:00',4.02),('8784','2013-05-02','14:30:00',3.97),('8784','2013-05-02','14:35:00',3.94),('8784','2013-05-02','14:40:00',3.92),('8784','2013-05-02','14:45:00',3.88),('8784','2013-05-02','14:50:00',3.85),('8784','2013-05-02','14:55:00',3.81),('8784','2013-05-02','15:00:00',3.79),('8784','2013-05-02','15:05:00',3.74),('8784','2013-05-02','15:10:00',3.69),('8784','2013-05-02','15:15:00',3.62),('8784','2013-05-02','15:20:00',3.58),('8784','2013-05-02','15:25:00',3.52),('8784','2013-05-02','15:30:00',3.46),('8784','2013-05-02','15:35:00',3.42),('8784','2013-05-02','15:40:00',3.37),('8784','2013-05-02','15:45:00',3.34),('8784','2013-05-02','15:50:00',3.28),('8784','2013-05-02','15:55:00',3.24),('8784','2013-05-02','16:00:00',3.19),('8784','2013-05-02','16:05:00',3.09),('8784','2013-05-02','16:10:00',3.07),('8784','2013-05-02','16:15:00',2.99),('8784','2013-05-02','16:20:00',2.93),('8784','2013-05-02','16:25:00',2.87),('8784','2013-05-02','16:30:00',2.79),('8784','2013-05-02','16:35:00',2.73),('8784','2013-05-02','16:40:00',2.66),('8784','2013-05-02','16:45:00',2.58),('8784','2013-05-02','16:50:00',2.51),('8784','2013-05-02','16:55:00',2.44),('8784','2013-05-02','17:00:00',2.38),('8784','2013-05-02','17:05:00',2.3),('8784','2013-05-02','17:10:00',2.23),('8784','2013-05-02','17:15:00',2.15),('8784','2013-05-02','17:20:00',2.05),('8784','2013-05-02','17:25:00',1.99),('8784','2013-05-02','17:30:00',1.91),('8784','2013-05-02','17:35:00',1.81),('8784','2013-05-02','17:40:00',1.74),('8784','2013-05-02','17:45:00',1.66),('8784','2013-05-02','17:50:00',1.58),('8784','2013-05-02','17:55:00',1.49),('8784','2013-05-02','18:00:00',1.41),('8784','2013-05-02','18:05:00',1.34),('8784','2013-05-02','18:10:00',1.25),('8784','2013-05-02','18:15:00',1.17),('8784','2013-05-02','18:20:00',1.09),('8784','2013-05-02','18:25:00',1.01),('8784','2014-03-30','08:20:00',1.16),('8784','2014-03-30','08:25:00',1.25),('8784','2014-03-30','08:30:00',1.35),('8784','2014-03-30','08:35:00',1.38),('8784','2014-03-30','08:40:00',1.42),('8784','2014-03-30','08:45:00',1.39),('8784','2014-03-30','08:50:00',1.41),('8784','2014-03-30','08:55:00',1.47),('8784','2014-03-30','09:00:00',1.53),('8784','2014-03-30','09:05:00',1.5),('8784','2014-03-30','09:10:00',1.44),('8784','2014-03-30','09:15:00',1.52),('8784','2014-03-30','09:20:00',1.74),('8784','2014-03-30','09:25:00',1.9),('8784','2014-03-30','09:30:00',2.13),('8784','2014-03-30','09:35:00',2.25),('8784','2014-03-30','09:40:00',2.3),('8784','2014-03-30','09:45:00',2.39),('8784','2014-03-30','09:50:00',2.46),('8784','2014-03-30','09:55:00',2.38),('8784','2014-03-30','10:00:00',2.51),('8784','2014-03-30','10:05:00',2.76),('8784','2014-03-30','10:10:00',2.76),('8784','2014-03-30','10:15:00',2.75),('8784','2014-03-30','10:20:00',2.8),('8784','2014-03-30','10:25:00',2.98),('8784','2014-03-30','10:30:00',3.06),('8784','2014-03-30','10:35:00',3.13),('8784','2014-03-30','10:40:00',3.18),('8784','2014-03-30','10:45:00',3.2),('8784','2014-03-30','10:50:00',3.21),('8784','2014-03-30','10:55:00',3.23),('8784','2014-03-30','11:00:00',3.2),('8784','2014-03-30','11:05:00',3.17),('8784','2014-03-30','11:10:00',3.17),('8784','2014-03-30','11:15:00',3.1),('8784','2014-03-30','11:20:00',3.09),('8784','2014-03-30','11:25:00',3.24),('8784','2014-03-30','11:30:00',3.48),('8784','2014-03-30','11:35:00',3.52),('8784','2014-03-30','11:40:00',3.65),('8784','2014-03-30','11:45:00',3.78),('8784','2014-03-30','11:50:00',3.81),('8784','2014-03-30','11:55:00',3.92),('8784','2014-03-30','12:00:00',3.96),('8784','2014-03-30','12:05:00',4.05),('8784','2014-03-30','12:10:00',4.15),('8784','2014-03-30','12:15:00',4.24),('8784','2014-03-30','12:20:00',4.13),('8784','2014-03-30','12:25:00',4.09),('8784','2014-03-30','12:30:00',3.76),('8784','2014-03-30','12:35:00',3.82),('8784','2014-03-30','12:40:00',4),('8784','2014-03-30','12:45:00',3.96),('8784','2014-03-30','12:50:00',3.96),('8784','2014-03-30','12:55:00',4.07),('8784','2014-03-30','13:00:00',4.13),('8784','2014-03-30','13:05:00',4.21),('8784','2014-03-30','13:10:00',4.14),('8784','2014-03-30','13:15:00',4.14),('8784','2014-03-30','13:20:00',4.14),('8784','2014-03-30','13:25:00',4.13),('8784','2014-03-30','13:30:00',4.14),('8784','2014-03-30','13:35:00',4.16),('8784','2014-03-30','13:40:00',4.16),('8784','2014-03-30','13:45:00',4.18),('8784','2014-03-30','13:50:00',4.12),('8784','2014-03-30','13:55:00',4),('8784','2014-03-30','14:00:00',3.97),('8784','2014-03-30','14:05:00',3.96),('8784','2014-03-30','14:10:00',3.8),('8784','2014-03-30','14:15:00',3.8),('8784','2014-03-30','14:20:00',3.94),('8784','2014-03-30','14:25:00',4),('8784','2014-03-30','14:30:00',3.92),('8784','2014-03-30','14:35:00',3.48),('8784','2014-03-30','14:40:00',3.5),('8784','2014-03-30','14:45:00',3.19),('8784','2014-03-30','14:50:00',2.4),('8784','2014-03-30','14:55:00',2.28),('8784','2014-03-30','15:00:00',1.48),('8784','2014-03-30','15:05:00',1.7),('8784','2014-03-30','15:10:00',1.73),('8784','2014-03-30','15:15:00',2.83),('8784','2014-03-30','15:20:00',2.94),('8784','2014-03-30','15:25:00',3.18),('8784','2014-03-30','15:30:00',3.2),('8784','2014-03-30','15:35:00',3.19),('8784','2014-03-30','15:40:00',3.14),('8784','2014-03-30','15:45:00',3.21),('8784','2014-03-30','15:50:00',3.13),('8784','2014-03-30','15:55:00',3.07),('8784','2014-03-30','16:00:00',2.7),('8784','2014-03-30','16:05:00',2.57),('8784','2014-03-30','16:10:00',2.46),('8784','2014-03-30','16:15:00',2.74),('8784','2014-03-30','16:20:00',2.79),('8784','2014-03-30','16:25:00',2.74),('8784','2014-03-30','16:30:00',2.64),('8784','2014-03-30','16:35:00',2.65),('8784','2014-03-30','16:40:00',2.48),('8784','2014-03-30','16:45:00',2.23),('8784','2014-03-30','16:50:00',1.93),('8784','2014-03-30','16:55:00',1.81),('8784','2014-03-30','17:00:00',1.94),('8784','2014-03-30','17:05:00',2.03),('8784','2014-03-30','17:10:00',2.08),('8784','2014-03-30','17:15:00',2.01),('8784','2014-03-30','17:20:00',1.89),('8784','2014-03-30','17:25:00',1.67),('8784','2014-03-30','17:30:00',1.66),('8784','2014-03-30','17:35:00',1.54),('8784','2014-03-30','17:40:00',1.38),('8784','2014-03-30','17:45:00',1.36),('8784','2014-03-30','17:50:00',1.15),('8784','2013-05-01','07:50:00',1.08),('8784','2013-05-01','07:55:00',1.15),('8784','2013-05-01','08:00:00',1.24),('8784','2013-05-01','08:05:00',1.3),('8784','2013-05-01','08:10:00',1.35),('8784','2013-05-01','08:15:00',1.47),('8784','2013-05-01','08:20:00',1.56),('8784','2013-05-01','08:25:00',1.66),('8784','2013-05-01','08:30:00',1.75),('8784','2013-05-01','08:35:00',1.85),('8784','2013-05-01','08:40:00',1.92),('8784','2013-05-01','08:45:00',2),('8784','2013-05-01','08:50:00',2.09),('8784','2013-05-01','08:55:00',2.18),('8784','2013-05-01','09:00:00',2.26),('8784','2013-05-01','09:05:00',2.35),('8784','2013-05-01','09:10:00',2.41),('8784','2013-05-01','09:15:00',2.47),('8784','2013-05-01','09:20:00',2.51),('8784','2013-05-01','09:25:00',2.57),('8784','2013-05-01','09:30:00',2.58),('8784','2013-05-01','09:35:00',2.68),('8784','2013-05-01','09:40:00',2.75),('8784','2013-05-01','09:45:00',2.81),('8784','2013-05-01','09:50:00',2.87),('8784','2013-05-01','09:55:00',2.93),('8784','2013-05-01','10:00:00',2.96),('8784','2013-05-01','10:05:00',2.97),('8784','2013-05-01','10:10:00',3.12),('8784','2013-05-01','10:15:00',3.18),('8784','2013-05-01','10:20:00',3.23),('8784','2013-05-01','10:25:00',3.27),('8784','2013-05-01','10:30:00',3.34),('8784','2013-05-01','10:35:00',3.36),('8784','2013-05-01','10:40:00',3.58),('8784','2013-05-01','10:45:00',3.65),('8784','2013-05-01','10:50:00',3.68),('8784','2013-05-01','10:55:00',3.69),('8784','2013-05-01','11:00:00',3.75),('8784','2013-05-01','11:05:00',3.75),('8784','2013-05-01','11:10:00',3.8),('8784','2013-05-01','11:15:00',3.5),('8784','2013-05-01','11:20:00',3.55),('8784','2013-05-01','11:25:00',3.53),('8784','2013-05-01','11:30:00',3.45),('8784','2013-05-01','11:35:00',3.56),('8784','2013-05-01','11:40:00',2.76),('8784','2013-05-01','11:45:00',2.76),('8784','2013-05-01','11:50:00',3.57),('8784','2013-05-01','11:55:00',4.05),('8784','2013-05-01','12:00:00',4.02),('8784','2013-05-01','12:05:00',3.96),('8784','2013-05-01','12:10:00',3.98),('8784','2013-05-01','12:15:00',3.93),('8784','2013-05-01','12:20:00',3.98),('8784','2013-05-01','12:25:00',4.04),('8784','2013-05-01','12:30:00',4.07),('8784','2013-05-01','12:35:00',4.13),('8784','2013-05-01','12:40:00',4.23),('8784','2013-05-01','12:45:00',3.83),('8784','2013-05-01','12:50:00',2.62),('8784','2013-05-01','12:55:00',1.58),('8784','2013-05-01','13:00:00',1.7),('8784','2013-05-01','13:05:00',1.98),('8784','2013-05-01','13:10:00',2.49),('8784','2013-05-01','13:15:00',4.39),('8784','2013-05-01','13:20:00',4.8),('8784','2013-05-01','13:25:00',4.16),('8784','2013-05-01','13:30:00',3.64),('8784','2013-05-01','13:35:00',4.21),('8784','2013-05-01','13:40:00',4.39),('8784','2013-05-01','13:45:00',4.46),('8784','2013-05-01','13:50:00',4.22),('8784','2013-05-01','13:55:00',4.09),('8784','2013-05-01','14:00:00',4.02),('8784','2013-05-01','14:05:00',3.99),('8784','2013-05-01','14:10:00',3.96),('8784','2013-05-01','14:15:00',3.48),('8784','2013-05-01','14:20:00',4.14),('8784','2013-05-01','14:25:00',4.12),('8784','2013-05-01','14:30:00',4.12),('8784','2013-05-01','14:35:00',3.9),('8784','2013-05-01','14:40:00',3.63),('8784','2013-05-01','14:45:00',3.68),('8784','2013-05-01','14:50:00',3.19),('8784','2013-05-01','14:55:00',2.94),('8784','2013-05-01','15:00:00',3.16),('8784','2013-05-01','15:05:00',3.58),('8784','2013-05-01','15:10:00',3.63),('8784','2013-05-01','15:15:00',3.45),('8784','2013-05-01','15:20:00',3.39),('8784','2013-05-01','15:25:00',3.38),('8784','2013-05-01','15:30:00',2.78),('8784','2013-05-01','15:35:00',2.48),('8784','2013-05-01','15:40:00',2.49),('8784','2013-05-01','15:45:00',2.44),('8784','2013-05-01','15:50:00',1.83),('8784','2013-05-01','15:55:00',1.83),('8784','2013-05-01','16:00:00',2.17),('8784','2013-05-01','16:05:00',2.07),('8784','2013-05-01','16:10:00',1.88),('8784','2013-05-01','16:15:00',1.74),('8784','2013-05-01','16:20:00',1.52),('8784','2013-05-01','16:25:00',1.22),('8784','2013-05-01','16:30:00',1.13),('8784','2013-05-01','16:35:00',1.18),('8784','2013-05-01','16:40:00',1.25),('8784','2013-05-01','16:45:00',1.18),('8784','2013-05-01','16:50:00',1.04),('8784','2013-05-01','17:10:00',1),('8784','2013-04-30','08:50:00',1.28),('8784','2013-04-30','08:55:00',1.93),('8784','2013-04-30','09:00:00',1.85),('8784','2013-04-30','09:05:00',1.59),('8784','2013-04-30','09:10:00',2.45),('8784','2013-04-30','09:15:00',2.77),('8784','2013-04-30','09:20:00',2.85),('8784','2013-04-30','09:25:00',3.03),('8784','2013-04-30','09:30:00',2.91),('8784','2013-04-30','09:35:00',2.36),('8784','2013-04-30','09:40:00',1.6),('8784','2013-04-30','09:45:00',2.29),('8784','2013-04-30','09:50:00',2.78),('8784','2013-04-30','09:55:00',3.09),('8784','2013-04-30','10:00:00',3.51),('8784','2013-04-30','10:05:00',3.2),('8784','2013-04-30','10:10:00',2.91),('8784','2013-04-30','10:15:00',2.39),('8784','2013-04-30','10:20:00',2.29),('8784','2013-04-30','10:25:00',3.56),('8784','2013-04-30','10:30:00',2.38),('8784','2013-04-30','10:35:00',2),('8784','2013-04-30','10:40:00',1.8),('8784','2013-04-30','10:45:00',1.45),('8784','2013-04-30','10:50:00',1.57),('8784','2013-04-30','10:55:00',1.68),('8784','2013-04-30','11:00:00',1.75),('8784','2013-04-30','11:05:00',1.97),('8784','2013-04-30','11:10:00',1.97),('8784','2013-04-30','11:15:00',2.08),('8784','2013-04-30','11:20:00',2.41),('8784','2013-04-30','11:25:00',2.16),('8784','2013-04-30','11:30:00',2.18),('8784','2013-04-30','11:35:00',2.37),('8784','2013-04-30','11:40:00',2.13),('8784','2013-04-30','11:45:00',1.77),('8784','2013-04-30','11:50:00',1.83),('8784','2013-04-30','11:55:00',1.88),('8784','2013-04-30','12:00:00',1.91),('8784','2013-04-30','12:05:00',1.96),('8784','2013-04-30','12:10:00',1.87),('8784','2013-04-30','12:15:00',1.73),('8784','2013-04-30','12:20:00',1.59),('8784','2013-04-30','12:25:00',1.48),('8784','2013-04-30','12:30:00',1.52),('8784','2013-04-30','12:35:00',2.93),('8784','2013-04-30','12:40:00',4.53),('8784','2013-04-30','12:45:00',4.73),('8784','2013-04-30','12:50:00',4.49),('8784','2013-04-30','12:55:00',4.09),('8784','2013-04-30','13:00:00',4.32),('8784','2013-04-30','13:05:00',4.28),('8784','2013-04-30','13:10:00',4.24),('8784','2013-04-30','13:15:00',4.21),('8784','2013-04-30','13:20:00',4.15),('8784','2013-04-30','13:25:00',4.11),('8784','2013-04-30','13:30:00',4.08),('8784','2013-04-30','13:35:00',4.05),('8784','2013-04-30','13:40:00',4.03),('8784','2013-04-30','13:45:00',3.96),('8784','2013-04-30','13:50:00',3.96),('8784','2013-04-30','13:55:00',3.92),('8784','2013-04-30','14:00:00',3.89),('8784','2013-04-30','14:05:00',3.88),('8784','2013-04-30','14:10:00',3.87),('8784','2013-04-30','14:15:00',3.84),('8784','2013-04-30','14:20:00',3.8),('8784','2013-04-30','14:25:00',3.78),('8784','2013-04-30','14:30:00',3.78),('8784','2013-04-30','14:35:00',3.75),('8784','2013-04-30','14:40:00',3.72),('8784','2013-04-30','14:45:00',3.65),('8784','2013-04-30','14:50:00',3.6),('8784','2013-04-30','14:55:00',3.56),('8784','2013-04-30','15:00:00',3.51),('8784','2013-04-30','15:05:00',3.44),('8784','2013-04-30','15:10:00',3.4),('8784','2013-04-30','15:15:00',3.36),('8784','2013-04-30','15:20:00',3.32),('8784','2013-04-30','15:25:00',3.24),('8784','2013-04-30','15:30:00',3.23),('8784','2013-04-30','15:35:00',3.2),('8784','2013-04-30','15:40:00',3.13),('8784','2013-04-30','15:45:00',3.07),('8784','2013-04-30','15:50:00',3),('8784','2013-04-30','15:55:00',2.94),('8784','2013-04-30','16:00:00',2.89),('8784','2013-04-30','16:05:00',2.83),('8784','2013-04-30','16:10:00',2.79),('8784','2013-04-30','16:15:00',2.72),('8784','2013-04-30','16:20:00',2.66),('8784','2013-04-30','16:25:00',2.61),('8784','2013-04-30','16:30:00',2.55),('8784','2013-04-30','16:35:00',2.3),('8784','2013-04-30','16:40:00',2),('8784','2013-04-30','16:45:00',2.05),('8784','2013-04-30','16:50:00',1.99),('8784','2013-04-30','16:55:00',2.15),('8784','2013-04-30','17:00:00',2.05),('8784','2013-04-30','17:05:00',1.99),('8784','2013-04-30','17:10:00',1.65),('8784','2013-04-30','17:20:00',1.53),('8784','2013-04-30','17:25:00',1.68),('8784','2013-04-30','17:30:00',1.6),('8784','2013-04-30','17:35:00',1.55),('8784','2013-04-30','17:40:00',1.48),('8784','2013-04-30','17:45:00',1.4),('8784','2013-04-30','17:50:00',1.31),('8784','2013-04-30','17:55:00',1.23),('8784','2013-04-30','18:00:00',1.16),('8784','2013-04-30','18:05:00',1.08),('8784','2013-04-30','18:10:00',1.02),('8784','2013-04-29','07:50:00',1),('8784','2013-04-29','07:55:00',1.19),('8784','2013-04-29','08:00:00',1.36),('8784','2013-04-29','08:05:00',1.44),('8784','2013-04-29','08:10:00',1.38),('8784','2013-04-29','08:15:00',1.43),('8784','2013-04-29','08:20:00',1.53),('8784','2013-04-29','08:25:00',1.75),('8784','2013-04-29','08:30:00',1.98),('8784','2013-04-29','08:35:00',2.22),('8784','2013-04-29','08:40:00',2.22),('8784','2013-04-29','08:45:00',2.17),('8784','2013-04-29','08:50:00',2.3),('8784','2013-04-29','08:55:00',2.23),('8784','2013-04-29','09:00:00',1.83),('8784','2013-04-29','09:05:00',2.6),('8784','2013-04-29','09:10:00',2.68),('8784','2013-04-29','09:15:00',2.81),('8784','2013-04-29','09:20:00',2.61),('8784','2013-04-29','09:25:00',2.55),('8784','2013-04-29','09:30:00',2.61),('8784','2013-04-29','09:35:00',2.74),('8784','2013-04-29','09:40:00',2.78),('8784','2013-04-29','09:45:00',2.83),('8784','2013-04-29','09:50:00',2.98),('8784','2013-04-29','09:55:00',2.83),('8784','2013-04-29','10:00:00',2.96),('8784','2013-04-29','10:05:00',2.93),('8784','2013-04-29','10:10:00',2.88),('8784','2013-04-29','10:15:00',2.36),('8784','2013-04-29','10:20:00',2.49),('8784','2013-04-29','10:25:00',2.89),('8784','2013-04-29','10:30:00',3.1),('8784','2013-04-29','10:35:00',3.34),('8784','2013-04-29','10:40:00',3.42),('8784','2013-04-29','10:45:00',3.44),('8784','2013-04-29','10:50:00',3.34),('8784','2013-04-29','10:55:00',3.12),('8784','2013-04-29','11:00:00',3.54),('8784','2013-04-29','11:05:00',3.29),('8784','2013-04-29','11:10:00',3.21),('8784','2013-04-29','11:15:00',3.1),('8784','2013-04-29','11:20:00',3.64),('8784','2013-04-29','11:25:00',3.68),('8784','2013-04-29','11:30:00',3.84),('8784','2013-04-29','11:35:00',3.64),('8784','2013-04-29','11:40:00',3.74),('8784','2013-04-29','11:45:00',3.56),('8784','2013-04-29','11:50:00',4.01),('8784','2013-04-29','11:55:00',3.93),('8784','2013-04-29','12:00:00',4.05),('8784','2013-04-29','12:05:00',3.98),('8784','2013-04-29','12:10:00',3.91),('8784','2013-04-29','12:15:00',3.97),('8784','2013-04-29','12:20:00',3.95),('8784','2013-04-29','12:25:00',3.88),('8784','2013-04-29','12:30:00',3.99),('8784','2013-04-29','12:35:00',4.04),('8784','2013-04-29','12:40:00',4.07),('8784','2013-04-29','12:45:00',4.08),('8784','2013-04-29','12:50:00',4.02),('8784','2013-04-29','12:55:00',4.04),('8784','2013-04-29','13:00:00',4.13),('8784','2013-04-29','13:05:00',4.04),('8784','2013-04-29','13:10:00',3.91),('8784','2013-04-29','13:15:00',3.49),('8784','2013-04-29','13:20:00',3.99),('8784','2013-04-29','13:25:00',4.17),('8784','2013-04-29','13:30:00',4.02),('8784','2013-04-29','13:35:00',3.87),('8784','2013-04-29','13:40:00',4),('8784','2013-04-29','13:45:00',3.99),('8784','2013-04-29','13:50:00',3.8),('8784','2013-04-29','13:55:00',4.3),('8784','2013-04-29','14:00:00',3.9),('8784','2013-04-29','14:05:00',3.83),('8784','2013-04-29','14:10:00',3.95),('8784','2013-04-29','14:15:00',4.04),('8784','2013-04-29','14:20:00',4.07),('8784','2013-04-29','14:25:00',3.84),('8784','2013-04-29','14:30:00',3.68),('8784','2013-04-29','14:35:00',3.63),('8784','2013-04-29','14:40:00',3.43),('8784','2013-04-29','14:45:00',3.69),('8784','2013-04-29','14:50:00',3.65),('8784','2013-04-29','14:55:00',3.66),('8784','2013-04-29','15:00:00',3.58),('8784','2013-04-29','15:05:00',3.65),('8784','2013-04-29','15:10:00',3.26),('8784','2013-04-29','15:15:00',3.24),('8784','2013-04-29','15:20:00',3.48),('8784','2013-04-29','15:25:00',3.57),('8784','2013-04-29','15:30:00',3.46),('8784','2013-04-29','15:35:00',3),('8784','2013-04-29','15:40:00',2.78),('8784','2013-04-29','15:45:00',2.71),('8784','2013-04-29','15:50:00',2.83),('8784','2013-04-29','15:55:00',2.98),('8784','2013-04-29','16:00:00',2.92),('8784','2013-04-29','16:05:00',3.13),('8784','2013-04-29','16:10:00',3.01),('8784','2013-04-29','16:15:00',3.51),('8784','2013-04-29','16:20:00',3.2),('8784','2013-04-29','16:25:00',2.56),('8784','2013-04-29','16:30:00',2.64),('8784','2013-04-29','16:35:00',2.68),('8784','2013-04-29','16:40:00',2.78),('8784','2013-04-29','16:45:00',2.78),('8784','2013-04-29','16:50:00',2.86),('8784','2013-04-29','16:55:00',2.93),('8784','2013-04-29','17:00:00',2.69),('8784','2013-04-29','17:05:00',2.33),('8784','2013-04-29','17:10:00',2.38),('8784','2013-04-29','17:15:00',2.01),('8784','2013-04-29','17:20:00',1.72),('8784','2013-04-29','17:25:00',1.6),('8784','2013-04-29','17:30:00',1.58),('8784','2013-04-29','17:35:00',1.46),('8784','2013-04-29','17:40:00',1.24),('8784','2013-04-29','17:45:00',1.15),('8784','2013-04-29','17:50:00',1.43),('8784','2013-04-29','17:55:00',1.6),('8784','2013-04-29','18:00:00',1.55),('8784','2013-04-29','18:05:00',1.73),('8784','2013-04-29','18:10:00',1.55),('8784','2013-04-29','18:15:00',1.45),('8784','2013-04-29','18:20:00',1.24),('8784','2013-04-29','18:25:00',1.19),('8784','2013-04-29','18:30:00',1.09),('8784','2013-04-28','07:40:00',1.05),('8784','2013-04-28','07:45:00',1.14),('8784','2013-04-28','07:50:00',1.23),('8784','2013-04-28','07:55:00',1.29),('8784','2013-04-28','08:00:00',1.35),('8784','2013-04-28','08:05:00',1.47),('8784','2013-04-28','08:10:00',1.58),('8784','2013-04-28','08:15:00',1.67),('8784','2013-04-28','08:20:00',1.77),('8784','2013-04-28','08:25:00',1.87),('8784','2013-04-28','08:30:00',1.92),('8784','2013-04-28','08:35:00',2.01),('8784','2013-04-28','08:40:00',2.09),('8784','2013-04-28','08:45:00',2.17),('8784','2013-04-28','08:50:00',2.25),('8784','2013-04-28','08:55:00',2.33),('8784','2013-04-28','09:00:00',2.41),('8784','2013-04-28','09:05:00',2.49),('8784','2013-04-28','09:10:00',2.58),('8784','2013-04-28','09:15:00',2.65),('8784','2013-04-28','09:20:00',2.73),('8784','2013-04-28','09:25:00',2.81),('8784','2013-04-28','09:30:00',2.88),('8784','2013-04-28','09:35:00',2.95),('8784','2013-04-28','09:40:00',3.01),('8784','2013-04-28','09:45:00',3.09),('8784','2013-04-28','09:50:00',3.16),('8784','2013-04-28','09:55:00',3.22),('8784','2013-04-28','10:00:00',3.28),('8784','2013-04-28','10:05:00',3.3),('8784','2013-04-28','10:10:00',3.35),('8784','2013-04-28','10:15:00',3.41),('8784','2013-04-28','10:20:00',3.47),('8784','2013-04-28','10:25:00',3.59),('8784','2013-04-28','10:30:00',3.51),('8784','2013-04-28','10:35:00',3.59),('8784','2013-04-28','10:40:00',3.32),('8784','2013-04-28','10:45:00',3.76),('8784','2013-04-28','10:50:00',3.78),('8784','2013-04-28','10:55:00',3.82),('8784','2013-04-28','11:00:00',3.85),('8784','2013-04-28','11:05:00',3.88),('8784','2013-04-28','11:10:00',3.95),('8784','2013-04-28','11:15:00',3.99),('8784','2013-04-28','11:20:00',3.97),('8784','2013-04-28','11:25:00',4.03),('8784','2013-04-28','11:30:00',4.01),('8784','2013-04-28','11:35:00',3.94),('8784','2013-04-28','11:40:00',4),('8784','2013-04-28','11:45:00',3.86),('8784','2013-04-28','11:50:00',3.82),('8784','2013-04-28','11:55:00',4.05),('8784','2013-04-28','12:00:00',3.55),('8784','2013-04-28','12:05:00',3.54),('8784','2013-04-28','12:10:00',3.92),('8784','2013-04-28','12:15:00',3.99),('8784','2013-04-28','12:20:00',4),('8784','2013-04-28','12:25:00',3.58),('8784','2013-04-28','12:30:00',3.38),('8784','2013-04-28','12:35:00',3.18),('8784','2013-04-28','12:40:00',3.21),('8784','2013-04-28','12:45:00',4.18),('8784','2013-04-28','12:50:00',4.16),('8784','2013-04-28','12:55:00',3.92),('8784','2013-04-28','13:00:00',4.05),('8784','2013-04-28','13:05:00',4.34),('8784','2013-04-28','13:10:00',4.22),('8784','2013-04-28','13:15:00',3.91),('8784','2013-04-28','13:20:00',4.03),('8784','2013-04-28','13:25:00',3.83),('8784','2013-04-28','13:30:00',4.19),('8784','2013-04-28','13:35:00',4.02),('8784','2013-04-28','13:40:00',2.73),('8784','2013-04-28','13:45:00',1.57),('8784','2013-04-28','13:50:00',2.06),('8784','2013-04-28','13:55:00',1.6),('8784','2013-04-28','14:00:00',2.51),('8784','2013-04-28','14:05:00',3.54),('8784','2013-04-28','14:10:00',3.97),('8784','2013-04-28','14:15:00',3.79),('8784','2013-04-28','14:20:00',3.28),('8784','2013-04-28','14:25:00',3.87),('8784','2013-04-28','14:30:00',3.97),('8784','2013-04-28','14:35:00',3.98),('8784','2013-04-28','14:40:00',3.91),('8784','2013-04-28','14:45:00',3.85),('8784','2013-04-28','14:50:00',3.82),('8784','2013-04-28','14:55:00',3.75),('8784','2013-04-28','15:00:00',3.75),('8784','2013-04-28','15:05:00',3.73),('8784','2013-04-28','15:10:00',3.68),('8784','2013-04-28','15:15:00',3.61),('8784','2013-04-28','15:20:00',3.57),('8784','2013-04-28','15:25:00',3.51),('8784','2013-04-28','15:30:00',3.46),('8784','2013-04-28','15:35:00',3.41),('8784','2013-04-28','15:40:00',3.35),('8784','2013-04-28','15:45:00',3.31),('8784','2013-04-28','15:50:00',3.27),('8784','2013-04-28','15:55:00',3.2),('8784','2013-04-28','16:00:00',3.15),('8784','2013-04-28','16:05:00',3.09),('8784','2013-04-28','16:10:00',3.02),('8784','2013-04-28','16:15:00',2.97),('8784','2013-04-28','16:20:00',2.9),('8784','2013-04-28','16:25:00',2.84),('8784','2013-04-28','16:30:00',2.77),('8784','2013-04-28','16:35:00',2.7),('8784','2013-04-28','16:40:00',2.61),('8784','2013-04-28','16:45:00',2.56),('8784','2013-04-28','16:50:00',2.49),('8784','2013-04-28','16:55:00',2.4),('8784','2013-04-28','17:00:00',2.33),('8784','2013-04-28','17:05:00',2.14),('8784','2013-04-28','17:10:00',2.07),('8784','2013-04-28','17:15:00',2.14),('8784','2013-04-28','17:20:00',2.02),('8784','2013-04-28','17:25:00',1.97),('8784','2013-04-28','17:30:00',1.68),('8784','2013-04-28','17:35:00',1.68),('8784','2013-04-28','17:40:00',1.58),('8784','2013-04-28','17:45:00',1.6),('8784','2013-04-28','17:50:00',1.52),('8784','2013-04-28','17:55:00',1.34),('8784','2013-04-28','18:00:00',1.32),('8784','2013-04-28','18:05:00',1.24),('8784','2013-04-28','18:20:00',1.06),('8784','2013-04-28','18:25:00',1),('8784','2013-04-27','12:50:00',1.11),('8784','2013-04-27','12:55:00',1.45),('8784','2013-04-27','13:00:00',1.56),('8784','2013-04-27','13:05:00',1.18),('8784','2013-04-27','13:10:00',1.27),('8784','2013-04-27','13:15:00',1.65),('8784','2013-04-27','13:20:00',1.73),('8784','2013-04-27','13:25:00',1.24),('8784','2013-04-27','13:30:00',1.36),('8784','2013-04-27','13:35:00',1.67),('8784','2013-04-27','13:40:00',1.89),('8784','2013-04-27','13:45:00',1.28),('8784','2013-04-27','13:50:00',1.23),('8784','2013-04-27','14:25:00',1.39),('8784','2013-04-27','14:30:00',2.35),('8784','2013-04-27','14:35:00',1.98),('8784','2013-04-27','14:40:00',1.42),('8784','2013-04-27','14:45:00',1.24),('8784','2013-04-27','15:00:00',1.15),('8784','2013-04-27','15:05:00',1.88),('8784','2013-04-27','15:10:00',1.44),('8784','2013-04-27','15:15:00',1.11),('8784','2013-04-27','16:40:00',1.1),('8784','2013-04-27','16:45:00',1.55),('8784','2013-04-27','16:50:00',1.97),('8784','2013-04-27','16:55:00',2.25),('8784','2013-04-27','17:00:00',2.59),('8784','2013-04-27','17:05:00',1.67),('8784','2013-04-27','17:20:00',1.18),('8784','2013-04-27','17:40:00',1.28),('8784','2013-04-27','17:45:00',1.1),('8784','2013-04-26','08:05:00',1.11),('8784','2013-04-26','08:10:00',1.34),('8784','2013-04-26','08:15:00',1.46),('8784','2013-04-26','08:20:00',1.53),('8784','2013-04-26','08:25:00',1.58),('8784','2013-04-26','08:30:00',1.66),('8784','2013-04-26','08:35:00',1.79),('8784','2013-04-26','08:40:00',1.84),('8784','2013-04-26','08:45:00',1.94),('8784','2013-04-26','08:50:00',1.66),('8784','2013-04-26','08:55:00',1.48),('8784','2013-04-26','09:00:00',1.52),('8784','2013-04-26','09:05:00',2.2),('8784','2013-04-26','09:10:00',1.82),('8784','2013-04-26','09:15:00',1.29),('8784','2013-04-26','09:20:00',1.3),('8784','2013-04-26','09:25:00',1.86),('8784','2013-04-26','09:30:00',2.17),('8784','2013-04-26','09:35:00',1.92),('8784','2013-04-26','09:40:00',2.02),('8784','2013-04-26','09:45:00',2.58),('8784','2013-04-26','09:50:00',2.95),('8784','2013-04-26','09:55:00',1.89),('8784','2013-04-26','10:00:00',2.71),('8784','2013-04-26','10:05:00',3.21),('8784','2013-04-26','10:10:00',3.19),('8784','2013-04-26','10:15:00',3.33),('8784','2013-04-26','10:20:00',3.15),('8784','2013-04-26','10:25:00',3.19),('8784','2013-04-26','10:30:00',3.4),('8784','2013-04-26','10:35:00',3.62),('8784','2013-04-26','10:40:00',3.47),('8784','2013-04-26','10:45:00',3.49),('8784','2013-04-26','10:50:00',2.61),('8784','2013-04-26','10:55:00',1.93),('8784','2013-04-26','11:00:00',3.43),('8784','2013-04-26','11:05:00',3.56),('8784','2013-04-26','11:10:00',3.38),('8784','2013-04-26','11:15:00',3.15),('8784','2013-04-26','11:20:00',2.55),('8784','2013-04-26','11:25:00',3.27),('8784','2013-04-26','11:30:00',3.26),('8784','2013-04-26','11:35:00',3.75),('8784','2013-04-26','11:40:00',3.01),('8784','2013-04-26','11:45:00',3.27),('8784','2013-04-26','11:50:00',2.7),('8784','2013-04-26','11:55:00',2.64),('8784','2013-04-26','12:00:00',3.12),('8784','2013-04-26','12:05:00',2.76),('8784','2013-04-26','12:10:00',2.63),('8784','2013-04-26','12:15:00',2.93),('8784','2013-04-26','12:20:00',2.82),('8784','2013-04-26','12:25:00',1.93),('8784','2013-04-26','12:30:00',1.91),('8784','2013-04-26','12:35:00',2.57),('8784','2013-04-26','12:40:00',3.24),('8784','2013-04-26','12:45:00',3.06),('8784','2013-04-26','12:50:00',2.26),('8784','2013-04-26','12:55:00',2.01),('8784','2013-04-26','13:00:00',1.45),('8784','2013-04-26','13:05:00',1.41),('8784','2013-04-26','13:10:00',1.75),('8784','2013-04-26','13:15:00',2.68),('8784','2013-04-26','13:20:00',1.9),('8784','2013-04-26','13:25:00',2.26),('8784','2013-04-26','13:30:00',3.31),('8784','2013-04-26','13:35:00',2.55),('8784','2013-04-26','13:40:00',2.98),('8784','2013-04-26','13:45:00',2.38),('8784','2013-04-26','13:50:00',3.44),('8784','2013-04-26','13:55:00',2.6),('8784','2013-04-26','14:00:00',2.93),('8784','2013-04-26','14:05:00',3.68),('8784','2013-04-26','14:10:00',3.2),('8784','2013-04-26','14:15:00',3.26),('8784','2013-04-26','14:20:00',3.65),('8784','2013-04-26','14:25:00',3.92),('8784','2013-04-26','14:30:00',3.95),('8784','2013-04-26','14:35:00',2.68),('8784','2013-04-26','14:40:00',1.78),('8784','2013-04-26','14:45:00',1.65),('8784','2013-04-26','14:50:00',3.98),('8784','2013-04-26','14:55:00',4.09),('8784','2013-04-26','15:00:00',3.75),('8784','2013-04-26','15:05:00',2.31),('8784','2013-04-26','15:10:00',1.64),('8784','2013-04-26','15:15:00',2.18),('8784','2013-04-26','15:20:00',1.55),('8784','2013-04-26','15:25:00',1.71),('8784','2013-04-26','15:30:00',2.46),('8784','2013-04-26','15:35:00',1.98),('8784','2013-04-26','15:40:00',2.12),('8784','2013-04-26','15:45:00',2.52),('8784','2013-04-26','15:50:00',1.94),('8784','2013-04-26','15:55:00',1.16),('8784','2013-04-25','08:05:00',1.17),('8784','2013-04-25','08:10:00',1.19),('8784','2013-04-25','08:15:00',1.54),('8784','2013-04-25','08:20:00',1.2),('8784','2013-04-25','08:25:00',1.03),('8784','2013-04-25','08:30:00',1.08),('8784','2013-04-25','08:35:00',1.12),('8784','2013-04-25','08:40:00',1.19),('8784','2013-04-25','08:45:00',1.57),('8784','2013-04-25','08:50:00',2.38),('8784','2013-04-25','08:55:00',2.54),('8784','2013-04-25','09:00:00',1.98),('8784','2013-04-25','09:05:00',1.5),('8784','2013-04-25','09:10:00',1.49),('8784','2013-04-25','09:15:00',1.34),('8784','2013-04-25','09:20:00',1.48),('8784','2013-04-25','09:25:00',1.61),('8784','2013-04-25','09:30:00',1.48),('8784','2013-04-25','09:35:00',1.7),('8784','2013-04-25','09:40:00',2.35),('8784','2013-04-25','09:45:00',2.88),('8784','2013-04-25','09:50:00',3.23),('8784','2013-04-25','09:55:00',3.27),('8784','2013-04-25','10:00:00',3.26),('8784','2013-04-25','10:05:00',3.08),('8784','2013-04-25','10:10:00',2.85),('8784','2013-04-25','10:15:00',3.01),('8784','2013-04-25','10:20:00',3.31),('8784','2013-04-25','10:25:00',3.45),('8784','2013-04-25','10:30:00',3.61),('8784','2013-04-25','10:35:00',3.62),('8784','2013-04-25','10:40:00',3.6),('8784','2013-04-25','10:45:00',3.46),('8784','2013-04-25','10:50:00',3.72),('8784','2013-04-25','10:55:00',3.62),('8784','2013-04-25','11:00:00',3.83),('8784','2013-04-25','11:05:00',3.83),('8784','2013-04-25','11:10:00',3.87),('8784','2013-04-25','11:15:00',3.9),('8784','2013-04-25','11:20:00',3.96),('8784','2013-04-25','11:25:00',3.99),('8784','2013-04-25','11:30:00',4.03),('8784','2013-04-25','11:35:00',3.98),('8784','2013-04-25','11:40:00',4.1),('8784','2013-04-25','11:45:00',4.14),('8784','2013-04-25','11:50:00',4.16),('8784','2013-04-25','11:55:00',4.12),('8784','2013-04-25','12:00:00',4.01),('8784','2013-04-25','12:05:00',4.08),('8784','2013-04-25','12:10:00',4.17),('8784','2013-04-25','12:15:00',4.21),('8784','2013-04-25','12:20:00',4.19),('8784','2013-04-25','12:25:00',4.19),('8784','2013-04-25','12:30:00',4.21),('8784','2013-04-25','12:35:00',4.22),('8784','2013-04-25','12:40:00',4.2),('8784','2013-04-25','12:45:00',4.22),('8784','2013-04-25','12:50:00',4.2),('8784','2013-04-25','12:55:00',4.23),('8784','2013-04-25','13:00:00',4.28),('8784','2013-04-25','13:05:00',4.35),('8784','2013-04-25','13:10:00',4.13),('8784','2013-04-25','13:15:00',4.18),('8784','2013-04-25','13:20:00',3.85),('8784','2013-04-25','13:25:00',3.59),('8784','2013-04-25','13:30:00',2.77),('8784','2013-04-25','13:35:00',2.74),('8784','2013-04-25','13:40:00',2.5),('8784','2013-04-25','13:45:00',2.35),('8784','2013-04-25','13:50:00',2.26),('8784','2013-04-25','13:55:00',2.43),('8784','2013-04-25','14:00:00',2.46),('8784','2013-04-25','14:05:00',2.3),('8784','2013-04-25','14:10:00',2.47),('8784','2013-04-25','14:15:00',2.64),('8784','2013-04-25','14:20:00',2.69),('8784','2013-04-25','14:25:00',2.82),('8784','2013-04-25','14:30:00',3.3),('8784','2013-04-25','14:35:00',3.67),('8784','2013-04-25','14:40:00',3.53),('8784','2013-04-25','14:45:00',3.56),('8784','2013-04-25','14:50:00',3.25),('8784','2013-04-25','14:55:00',3.37),('8784','2013-04-25','15:00:00',3.2),('8784','2013-04-25','15:05:00',2.91),('8784','2013-04-25','15:10:00',2.93),('8784','2013-04-25','15:15:00',3.31),('8784','2013-04-25','15:20:00',3.52),('8784','2013-04-25','15:25:00',3.6),('8784','2013-04-25','15:30:00',3.49),('8784','2013-04-25','15:35:00',3.31),('8784','2013-04-25','15:40:00',3.04),('8784','2013-04-25','15:45:00',2.95),('8784','2013-04-25','15:50:00',2.73),('8784','2013-04-25','15:55:00',2.68),('8784','2013-04-25','16:00:00',2.68),('8784','2013-04-25','16:05:00',2.28),('8784','2013-04-25','16:10:00',2.29),('8784','2013-04-25','16:15:00',2.26),('8784','2013-04-25','16:20:00',2.38),('8784','2013-04-25','16:25:00',2.07),('8784','2013-04-25','16:30:00',2.05),('8784','2013-04-25','16:35:00',2.45),('8784','2013-04-25','16:40:00',2.15),('8784','2013-04-25','16:45:00',2.15),('8784','2013-04-25','16:50:00',1.86),('8784','2013-04-25','16:55:00',1.98),('8784','2013-04-25','17:00:00',1.89),('8784','2013-04-25','17:05:00',2.33),('8784','2013-04-25','17:10:00',2.43),('8784','2013-04-25','17:15:00',2.24),('8784','2013-04-25','17:20:00',2.2),('8784','2013-04-25','17:25:00',1.84),('8784','2013-04-25','17:30:00',1.48),('8784','2013-04-25','17:35:00',1.43),('8784','2013-04-25','17:40:00',1.45),('8784','2013-04-25','17:45:00',1.24),('8784','2013-04-25','17:50:00',1.04),('8784','2013-04-24','07:50:00',1.09),('8784','2013-04-24','07:55:00',1.2),('8784','2013-04-24','08:00:00',1.23),('8784','2013-04-24','08:05:00',1.3),('8784','2013-04-24','08:10:00',1.47),('8784','2013-04-24','08:15:00',1.67),('8784','2013-04-24','08:20:00',1.72),('8784','2013-04-24','08:25:00',1.85),('8784','2013-04-24','08:30:00',1.82),('8784','2013-04-24','08:35:00',1.77),('8784','2013-04-24','08:40:00',1.83),('8784','2013-04-24','08:45:00',1.89),('8784','2013-04-24','08:50:00',1.99),('8784','2013-04-24','08:55:00',2.07),('8784','2013-04-24','09:00:00',2.31),('8784','2013-04-24','09:05:00',2.53),('8784','2013-04-24','09:10:00',2.63),('8784','2013-04-24','09:15:00',2.26),('8784','2013-04-24','09:20:00',2.01),('8784','2013-04-24','09:25:00',2.7),('8784','2013-04-24','09:30:00',2.82),('8784','2013-04-24','09:35:00',2.99),('8784','2013-04-24','09:40:00',2.85),('8784','2013-04-24','09:45:00',2.85),('8784','2013-04-24','09:50:00',2.97),('8784','2013-04-24','09:55:00',3.28),('8784','2013-04-24','10:00:00',3.39),('8784','2013-04-24','10:05:00',3.48),('8784','2013-04-24','10:10:00',3.53),('8784','2013-04-24','10:15:00',3.5),('8784','2013-04-24','10:20:00',3.42),('8784','2013-04-24','10:25:00',3.39),('8784','2013-04-24','10:30:00',3.34),('8784','2013-04-24','10:35:00',3.37),('8784','2013-04-24','10:40:00',3.74),('8784','2013-04-24','10:45:00',3.75),('8784','2013-04-24','10:50:00',3.81),('8784','2013-04-24','10:55:00',3.94),('8784','2013-04-24','11:00:00',3.92),('8784','2013-04-24','11:05:00',3.86),('8784','2013-04-24','11:10:00',4.18),('8784','2013-04-24','11:15:00',4.19),('8784','2013-04-24','11:20:00',4.32),('8784','2013-04-24','11:25:00',4.27),('8784','2013-04-24','11:30:00',4.17),('8784','2013-04-24','11:35:00',3.78),('8784','2013-04-24','11:40:00',3.01),('8784','2013-04-24','11:45:00',2.83),('8784','2013-04-24','11:50:00',2.17),('8784','2013-04-24','11:55:00',3.19),('8784','2013-04-24','12:00:00',3.53),('8784','2013-04-24','12:05:00',2.51),('8784','2013-04-24','12:10:00',3.08),('8784','2013-04-24','12:15:00',4.16),('8784','2013-04-24','12:20:00',4.76),('8784','2013-04-24','12:25:00',4.07),('8784','2013-04-24','12:30:00',4.02),('8784','2013-04-24','12:35:00',4.14),('8784','2013-04-24','12:40:00',3.94),('8784','2013-04-24','12:45:00',4.07),('8784','2013-04-24','12:50:00',4.3),('8784','2013-04-24','12:55:00',4.16),('8784','2013-04-24','13:00:00',4.04),('8784','2013-04-24','13:05:00',3.59),('8784','2013-04-24','13:10:00',4.62),('8784','2013-04-24','13:15:00',4.29),('8784','2013-04-24','13:20:00',4.02),('8784','2013-04-24','13:25:00',4.21),('8784','2013-04-24','13:30:00',3.81),('8784','2013-04-24','13:35:00',4.18),('8784','2013-04-24','13:40:00',4.55),('8784','2013-04-24','13:45:00',3.8),('8784','2013-04-24','13:50:00',2.94),('8784','2013-04-24','13:55:00',4.4),('8784','2013-04-24','14:00:00',4.22),('8784','2013-04-24','14:05:00',3.02),('8784','2013-04-24','14:10:00',3.15),('8784','2013-04-24','14:15:00',4.21),('8784','2013-04-24','14:20:00',3.87),('8784','2013-04-24','14:25:00',3.97),('8784','2013-04-24','14:30:00',3.7),('8784','2013-04-24','14:35:00',3.38),('8784','2013-04-24','14:40:00',3.17),('8784','2013-04-24','14:45:00',3.12),('8784','2013-04-24','14:50:00',2.81),('8784','2013-04-24','14:55:00',2.46),('8784','2013-04-24','15:00:00',2.7),('8784','2013-04-24','15:05:00',2.48),('8784','2013-04-24','15:10:00',2.3),('8784','2013-04-24','15:15:00',2.45),('8784','2013-04-24','15:20:00',2.64),('8784','2013-04-24','15:25:00',2.18),('8784','2013-04-24','15:30:00',1.9),('8784','2013-04-24','15:35:00',1.84),('8784','2013-04-24','15:40:00',1.81),('8784','2013-04-24','15:45:00',1.82),('8784','2013-04-24','15:50:00',1.85),('8784','2013-04-24','15:55:00',2.35),('8784','2013-04-24','16:00:00',2.84),('8784','2013-04-24','16:05:00',2.95),('8784','2013-04-24','16:10:00',2.87),('8784','2013-04-24','16:15:00',2.71),('8784','2013-04-24','16:20:00',3.4),('8784','2013-04-24','16:25:00',2.62),('8784','2013-04-24','16:30:00',2.24),('8784','2013-04-24','16:35:00',2),('8784','2013-04-24','16:40:00',2.63),('8784','2013-04-24','16:45:00',2.66),('8784','2013-04-24','16:50:00',2.46),('8784','2013-04-24','16:55:00',2.86),('8784','2013-04-24','17:00:00',2.85),('8784','2013-04-24','17:05:00',2.66),('8784','2013-04-24','17:10:00',2.5),('8784','2013-04-24','17:15:00',1.83),('8784','2013-04-24','17:20:00',1.85),('8784','2013-04-24','17:25:00',1.58),('8784','2013-04-24','17:30:00',1.04),('8784','2013-04-24','17:50:00',1.15),('8784','2013-04-24','17:55:00',1.49),('8784','2013-04-24','18:00:00',1.15),('8784','2013-04-24','18:05:00',1.22),('8784','2013-04-24','18:20:00',1.01),('8784','2013-04-23','07:40:00',1.09),('8784','2013-04-23','07:45:00',1.17),('8784','2013-04-23','07:50:00',1.26),('8784','2013-04-23','07:55:00',1.35),('8784','2013-04-23','08:00:00',1.43),('8784','2013-04-23','08:05:00',1.52),('8784','2013-04-23','08:10:00',1.62),('8784','2013-04-23','08:15:00',1.7),('8784','2013-04-23','08:20:00',1.8),('8784','2013-04-23','08:25:00',1.9),('8784','2013-04-23','08:30:00',1.98),('8784','2013-04-23','08:35:00',2.08),('8784','2013-04-23','08:40:00',2.16),('8784','2013-04-23','08:45:00',2.25),('8784','2013-04-23','08:50:00',2.34),('8784','2013-04-23','08:55:00',2.43),('8784','2013-04-23','09:00:00',2.49),('8784','2013-04-23','09:05:00',2.57),('8784','2013-04-23','09:10:00',2.66),('8784','2013-04-23','09:15:00',2.76),('8784','2013-04-23','09:20:00',2.84),('8784','2013-04-23','09:25:00',2.93),('8784','2013-04-23','09:30:00',3),('8784','2013-04-23','09:35:00',3.08),('8784','2013-04-23','09:40:00',2.85),('8784','2013-04-23','09:45:00',2.81),('8784','2013-04-23','09:50:00',3.34),('8784','2013-04-23','09:55:00',3.38),('8784','2013-04-23','10:00:00',3.42),('8784','2013-04-23','10:05:00',3.48),('8784','2013-04-23','10:10:00',3.53),('8784','2013-04-23','10:15:00',3.57),('8784','2013-04-23','10:20:00',3.6),('8784','2013-04-23','10:25:00',3.66),('8784','2013-04-23','10:30:00',3.74),('8784','2013-04-23','10:35:00',3.8),('8784','2013-04-23','10:40:00',3.84),('8784','2013-04-23','10:45:00',3.79),('8784','2013-04-23','10:50:00',3.94),('8784','2013-04-23','10:55:00',4),('8784','2013-04-23','11:00:00',4.01),('8784','2013-04-23','11:05:00',4.03),('8784','2013-04-23','11:10:00',4.06),('8784','2013-04-23','11:15:00',4.09),('8784','2013-04-23','11:20:00',4.15),('8784','2013-04-23','11:25:00',4.16),('8784','2013-04-23','11:30:00',4.16),('8784','2013-04-23','11:35:00',4.2),('8784','2013-04-23','11:40:00',4.22),('8784','2013-04-23','11:45:00',4.21),('8784','2013-04-23','11:50:00',4.18),('8784','2013-04-23','11:55:00',4.2),('8784','2013-04-23','12:00:00',4.22),('8784','2013-04-23','12:05:00',4.26),('8784','2013-04-23','12:10:00',4.28),('8784','2013-04-23','12:15:00',4.25),('8784','2013-04-23','12:20:00',4.33),('8784','2013-04-23','12:25:00',4.38),('8784','2013-04-23','12:30:00',4.56),('8784','2013-04-23','12:35:00',4.82),('8784','2013-04-23','12:40:00',4.97),('8784','2013-04-23','12:45:00',3.86),('8784','2013-04-23','12:50:00',1.91),('8784','2013-04-23','12:55:00',5.14),('8784','2013-04-23','13:00:00',5.13),('8784','2013-04-23','13:05:00',4.46),('8784','2013-04-23','13:10:00',2.15),('8784','2013-04-23','13:15:00',3.62),('8784','2013-04-23','13:20:00',4.74),('8784','2013-04-23','13:25:00',4.63),('8784','2013-04-23','13:30:00',4.52),('8784','2013-04-23','13:35:00',4.61),('8784','2013-04-23','13:40:00',4.56),('8784','2013-04-23','13:45:00',3.2),('8784','2013-04-23','13:50:00',4.16),('8784','2013-04-23','13:55:00',4.51),('8784','2013-04-23','14:00:00',4.01),('8784','2013-04-23','14:05:00',4.61),('8784','2013-04-23','14:10:00',4.13),('8784','2013-04-23','14:15:00',4.03),('8784','2013-04-23','14:20:00',3.96),('8784','2013-04-23','14:25:00',3.66),('8784','2013-04-23','14:30:00',4.28),('8784','2013-04-23','14:35:00',4.06),('8784','2013-04-23','14:40:00',4.09),('8784','2013-04-23','14:45:00',3.5),('8784','2013-04-23','14:50:00',2.22),('8784','2013-04-23','14:55:00',2.42),('8784','2013-04-23','15:00:00',2.48),('8784','2013-04-23','15:05:00',2.63),('8784','2013-04-23','15:10:00',3.22),('8784','2013-04-23','15:15:00',3.12),('8784','2013-04-23','15:20:00',2.87),('8784','2013-04-23','15:25:00',2.61),('8784','2013-04-23','15:30:00',2.6),('8784','2013-04-23','15:35:00',2.46),('8784','2013-04-23','15:40:00',2.52),('8784','2013-04-23','15:45:00',2.72),('8784','2013-04-23','15:50:00',2.1),('8784','2013-04-23','15:55:00',1.92),('8784','2013-04-23','16:00:00',2.29),('8784','2013-04-23','16:05:00',2.49),('8784','2013-04-23','16:10:00',2.52),('8784','2013-04-23','16:15:00',2.24),('8784','2013-04-23','16:20:00',1.43),('8784','2013-04-23','16:25:00',1.47),('8784','2013-04-23','16:30:00',1.26),('8784','2013-04-23','16:35:00',1.2),('8784','2013-04-23','16:40:00',1.18),('8784','2013-04-23','16:45:00',1.26),('8784','2013-04-23','16:50:00',1.08),('8784','2013-04-23','16:55:00',1.12),('8784','2013-04-23','17:00:00',1.18),('8784','2013-04-23','17:05:00',1.23),('8784','2013-04-23','17:10:00',2.04),('8784','2013-04-23','17:15:00',1.25),('8784','2013-04-23','17:20:00',1.03),('8784','2013-04-23','17:25:00',1.76),('8784','2013-04-23','17:30:00',1.56),('8784','2013-04-23','17:35:00',1.14),('8784','2013-04-22','09:30:00',1.26),('8784','2013-04-22','09:35:00',1.13),('8784','2013-04-22','10:35:00',2.2),('8784','2013-04-22','10:40:00',3.53),('8784','2013-04-22','10:45:00',4.74),('8784','2013-04-22','10:50:00',2.53),('8784','2013-04-22','10:55:00',2.51),('8784','2013-04-22','11:00:00',2.22),('8784','2013-04-22','11:05:00',1.92),('8784','2013-04-22','11:10:00',2.47),('8784','2013-04-22','11:15:00',1.51),('8784','2013-04-22','11:20:00',1.57),('8784','2013-04-22','11:25:00',2.08),('8784','2013-04-22','11:30:00',3.11),('8784','2013-04-22','11:35:00',4.52),('8784','2013-04-22','11:40:00',3.6),('8784','2013-04-22','11:45:00',2.48),('8784','2013-04-22','11:50:00',1.83),('8784','2013-04-22','11:55:00',3.95),('8784','2013-04-22','12:00:00',3.87),('8784','2013-04-22','12:05:00',4.18),('8784','2013-04-22','12:10:00',2.29),('8784','2013-04-22','12:15:00',2.68),('8784','2013-04-22','12:20:00',2.5),('8784','2013-04-22','12:25:00',1.96),('8784','2013-04-22','12:30:00',2.23),('8784','2013-04-22','12:35:00',2.26),('8784','2013-04-22','12:40:00',3.66),('8784','2013-04-22','12:45:00',3.69),('8784','2013-04-22','12:50:00',4.83),('8784','2013-04-22','12:55:00',4.8),('8784','2013-04-22','13:00:00',4.36),('8784','2013-04-22','13:05:00',3.71),('8784','2013-04-22','13:10:00',3.38),('8784','2013-04-22','13:15:00',4.25),('8784','2013-04-22','13:20:00',4.98),('8784','2013-04-22','13:25:00',2.05),('8784','2013-04-22','13:30:00',1.69),('8784','2013-04-22','13:35:00',2.39),('8784','2013-04-22','13:40:00',2.49),('8784','2013-04-22','13:45:00',1.68),('8784','2013-04-22','13:50:00',1.21),('8784','2013-04-22','13:55:00',2.55),('8784','2013-04-22','14:00:00',1.29),('8784','2013-04-22','14:05:00',2.3),('8784','2013-04-22','14:10:00',2.88),('8784','2013-04-22','14:15:00',4.47),('8784','2013-04-22','14:20:00',5.42),('8784','2013-04-22','14:25:00',3.26),('8784','2013-04-22','14:30:00',3.57),('8784','2013-04-22','14:35:00',3.42),('8784','2013-04-22','14:40:00',4.72),('8784','2013-04-22','14:45:00',3.71),('8784','2013-04-22','14:50:00',4.47),('8784','2013-04-22','14:55:00',3.57),('8784','2013-04-22','15:00:00',1.26),('8784','2013-04-22','15:05:00',1.81),('8784','2013-04-22','15:10:00',1.24),('8784','2013-04-22','15:15:00',1.18),('8784','2013-04-22','15:20:00',2.46),('8784','2013-04-22','15:25:00',4.21),('8784','2013-04-22','15:30:00',1.43),('8784','2013-04-22','15:35:00',1.92),('8784','2013-04-22','15:40:00',2.63),('8784','2013-04-22','15:45:00',4.13),('8784','2013-04-22','15:50:00',2.51),('8784','2013-04-22','15:55:00',1.34),('8784','2013-04-22','16:45:00',1.2),('8784','2013-04-22','16:50:00',1.09),('8784','2014-03-29','07:20:00',1.05),('8784','2014-03-29','07:25:00',1.12),('8784','2014-03-29','07:30:00',1.21),('8784','2014-03-29','07:35:00',1.29),('8784','2014-03-29','07:40:00',1.39),('8784','2014-03-29','07:45:00',1.49),('8784','2014-03-29','07:50:00',1.58),('8784','2014-03-29','07:55:00',1.67),('8784','2014-03-29','08:00:00',1.77),('8784','2014-03-29','08:05:00',1.86),('8784','2014-03-29','08:10:00',1.96),('8784','2014-03-29','08:15:00',2.03),('8784','2014-03-29','08:20:00',2.11),('8784','2014-03-29','08:25:00',2.21),('8784','2014-03-29','08:30:00',2.28),('8784','2014-03-29','08:35:00',2.35),('8784','2014-03-29','08:40:00',2.43),('8784','2014-03-29','08:45:00',2.49),('8784','2014-03-29','08:50:00',2.57),('8784','2014-03-29','08:55:00',2.62),('8784','2014-03-29','09:00:00',2.66),('8784','2014-03-29','09:05:00',2.73),('8784','2014-03-29','09:10:00',2.77),('8784','2014-03-29','09:15:00',2.91),('8784','2014-03-29','09:20:00',2.93),('8784','2014-03-29','09:25:00',3.06),('8784','2014-03-29','09:30:00',3.1),('8784','2014-03-29','09:35:00',3.16),('8784','2014-03-29','09:40:00',3.25),('8784','2014-03-29','09:45:00',3.28),('8784','2014-03-29','09:50:00',3.36),('8784','2014-03-29','09:55:00',3.43),('8784','2014-03-29','10:00:00',3.48),('8784','2014-03-29','10:05:00',3.51),('8784','2014-03-29','10:10:00',3.58),('8784','2014-03-29','10:15:00',3.68),('8784','2014-03-29','10:20:00',3.7),('8784','2014-03-29','10:25:00',3.74),('8784','2014-03-29','10:30:00',3.76),('8784','2014-03-29','10:35:00',3.76),('8784','2014-03-29','10:40:00',3.81),('8784','2014-03-29','10:45:00',3.81),('8784','2014-03-29','10:50:00',3.88),('8784','2014-03-29','10:55:00',3.94),('8784','2014-03-29','11:00:00',3.97),('8784','2014-03-29','11:05:00',3.98),('8784','2014-03-29','11:10:00',3.98),('8784','2014-03-29','11:15:00',4.02),('8784','2014-03-29','11:20:00',4.04),('8784','2014-03-29','11:25:00',4.05),('8784','2014-03-29','11:30:00',4.04),('8784','2014-03-29','11:35:00',4.04),('8784','2014-03-29','11:40:00',3.92),('8784','2014-03-29','11:45:00',4.12),('8784','2014-03-29','11:50:00',4.12),('8784','2014-03-29','11:55:00',4.1),('8784','2014-03-29','12:00:00',4.1),('8784','2014-03-29','12:05:00',4.12),('8784','2014-03-29','12:10:00',4.1),('8784','2014-03-29','12:15:00',4.08),('8784','2014-03-29','12:20:00',4.12),('8784','2014-03-29','12:25:00',4.08),('8784','2014-03-29','12:30:00',4.12),('8784','2014-03-29','12:35:00',4.09),('8784','2014-03-29','12:40:00',4.05),('8784','2014-03-29','12:45:00',4.08),('8784','2014-03-29','12:50:00',4.07),('8784','2014-03-29','12:55:00',4.03),('8784','2014-03-29','13:00:00',3.97),('8784','2014-03-29','13:05:00',4),('8784','2014-03-29','13:10:00',3.94),('8784','2014-03-29','13:15:00',3.93),('8784','2014-03-29','13:20:00',3.91),('8784','2014-03-29','13:25:00',3.83),('8784','2014-03-29','13:30:00',3.79),('8784','2014-03-29','13:35:00',3.72),('8784','2014-03-29','13:40:00',3.7),('8784','2014-03-29','13:45:00',3.63),('8784','2014-03-29','13:50:00',3.58),('8784','2014-03-29','13:55:00',3.56),('8784','2014-03-29','14:00:00',3.54),('8784','2014-03-29','14:05:00',3.49),('8784','2014-03-29','14:10:00',3.46),('8784','2014-03-29','14:15:00',3.41),('8784','2014-03-29','14:20:00',3.35),('8784','2014-03-29','14:25:00',3.06),('8784','2014-03-29','14:30:00',3.21),('8784','2014-03-29','14:35:00',3.01),('8784','2014-03-29','14:40:00',2.56),('8784','2014-03-29','14:45:00',2.97),('8784','2014-03-29','14:50:00',3.01),('8784','2014-03-29','14:55:00',2.98),('8784','2014-03-29','15:00:00',2.96),('8784','2014-03-29','15:05:00',2.83),('8784','2014-03-29','15:10:00',2.73),('8784','2014-03-29','15:15:00',2.69),('8784','2014-03-29','15:20:00',2.63),('8784','2014-03-29','15:25:00',2.5),('8784','2014-03-29','15:30:00',2.37),('8784','2014-03-29','15:35:00',2.29),('8784','2014-03-29','15:40:00',2.25),('8784','2014-03-29','15:45:00',2.19),('8784','2014-03-29','15:50:00',2.1),('8784','2014-03-29','15:55:00',2.01),('8784','2014-03-29','16:00:00',1.95),('8784','2014-03-29','16:05:00',1.86),('8784','2014-03-29','16:10:00',1.75),('8784','2014-03-29','16:15:00',1.67),('8784','2014-03-29','16:20:00',1.51),('8784','2014-03-29','16:25:00',1.49),('8784','2014-03-29','16:30:00',1.43),('8784','2014-03-29','16:35:00',1.29),('8784','2014-03-29','16:40:00',1.12),('8784','2013-04-21','08:05:00',1.27),('8784','2013-04-21','08:10:00',1.07),('8784','2013-04-21','08:15:00',1.19),('8784','2013-04-21','08:20:00',1.13),('8784','2013-04-21','08:25:00',1.34),('8784','2013-04-21','08:30:00',1.46),('8784','2013-04-21','08:35:00',1.44),('8784','2013-04-21','08:40:00',1.53),('8784','2013-04-21','08:45:00',1.2),('8784','2013-04-21','08:50:00',1.36),('8784','2013-04-21','08:55:00',1.96),('8784','2013-04-21','09:00:00',2.05),('8784','2013-04-21','09:05:00',2.42),('8784','2013-04-21','09:10:00',2.08),('8784','2013-04-21','09:15:00',1.69),('8784','2013-04-21','09:20:00',1.5),('8784','2013-04-21','09:25:00',2.47),('8784','2013-04-21','09:30:00',2.97),('8784','2013-04-21','09:35:00',3.06),('8784','2013-04-21','09:40:00',2.88),('8784','2013-04-21','09:45:00',3.37),('8784','2013-04-21','09:50:00',3.47),('8784','2013-04-21','09:55:00',4.14),('8784','2013-04-21','10:00:00',2.84),('8784','2013-04-21','10:05:00',1.97),('8784','2013-04-21','10:10:00',2.06),('8784','2013-04-21','10:15:00',1.84),('8784','2013-04-21','10:20:00',4.14),('8784','2013-04-21','10:25:00',2.75),('8784','2013-04-21','10:30:00',2.28),('8784','2013-04-21','10:35:00',1.87),('8784','2013-04-21','10:40:00',2.54),('8784','2013-04-21','10:45:00',2.55),('8784','2013-04-21','10:50:00',2.53),('8784','2013-04-21','10:55:00',2.47),('8784','2013-04-21','11:00:00',4.24),('8784','2013-04-21','11:05:00',3.5),('8784','2013-04-21','11:10:00',4.16),('8784','2013-04-21','11:15:00',3.23),('8784','2013-04-21','11:20:00',3.04),('8784','2013-04-21','11:25:00',2.92),('8784','2013-04-21','11:30:00',2.78),('8784','2013-04-21','11:35:00',2.69),('8784','2013-04-21','11:40:00',2.83),('8784','2013-04-21','11:45:00',3.04),('8784','2013-04-21','11:50:00',3.17),('8784','2013-04-21','11:55:00',3.44),('8784','2013-04-21','12:00:00',2.48),('8784','2013-04-21','12:05:00',2.61),('8784','2013-04-21','12:10:00',2.42),('8784','2013-04-21','12:15:00',2.29),('8784','2013-04-21','12:20:00',2.07),('8784','2013-04-21','12:25:00',2.06),('8784','2013-04-21','12:30:00',2.19),('8784','2013-04-21','12:35:00',2.26),('8784','2013-04-21','12:40:00',2.24),('8784','2013-04-21','12:45:00',2.27),('8784','2013-04-21','12:50:00',2.16),('8784','2013-04-21','12:55:00',2.09),('8784','2013-04-21','13:00:00',2.4),('8784','2013-04-21','13:05:00',2.75),('8784','2013-04-21','13:10:00',2.66),('8784','2013-04-21','13:15:00',2.5),('8784','2013-04-21','13:20:00',2.38),('8784','2013-04-21','13:25:00',2.35),('8784','2013-04-21','13:30:00',3.29),('8784','2013-04-21','13:35:00',3.81),('8784','2013-04-21','13:40:00',2.99),('8784','2013-04-21','13:45:00',3.35),('8784','2013-04-21','13:50:00',3.27),('8784','2013-04-21','13:55:00',4.03),('8784','2013-04-21','14:00:00',4.01),('8784','2013-04-21','14:05:00',4.68),('8784','2013-04-21','14:10:00',4.17),('8784','2013-04-21','14:15:00',4.47),('8784','2013-04-21','14:20:00',4.83),('8784','2013-04-21','14:25:00',4.32),('8784','2013-04-21','14:30:00',3.97),('8784','2013-04-21','14:35:00',4.53),('8784','2013-04-21','14:40:00',4.59),('8784','2013-04-21','14:45:00',3.44),('8784','2013-04-21','14:50:00',2.24),('8784','2013-04-21','14:55:00',2.23),('8784','2013-04-21','15:00:00',2.03),('8784','2013-04-21','15:05:00',3.76),('8784','2013-04-21','15:10:00',4),('8784','2013-04-21','15:15:00',2.66),('8784','2013-04-21','15:20:00',1.8),('8784','2013-04-21','15:25:00',1.98),('8784','2013-04-21','15:30:00',1.77),('8784','2013-04-21','15:35:00',1.52),('8784','2013-04-21','15:40:00',1.6),('8784','2013-04-21','15:45:00',1.32),('8784','2013-04-21','15:50:00',1.07),('8784','2013-04-20','07:35:00',1.01),('8784','2013-04-20','07:40:00',1.08),('8784','2013-04-20','07:55:00',1.08),('8784','2013-04-20','08:00:00',1.18),('8784','2013-04-20','08:05:00',1.27),('8784','2013-04-20','08:10:00',1.36),('8784','2013-04-20','08:15:00',1.23),('8784','2013-04-20','08:20:00',1.26),('8784','2013-04-20','08:25:00',1.34),('8784','2013-04-20','08:30:00',1.54),('8784','2013-04-20','08:35:00',1.67),('8784','2013-04-20','08:40:00',1.88),('8784','2013-04-20','08:45:00',1.92),('8784','2013-04-20','08:50:00',1.93),('8784','2013-04-20','08:55:00',1.97),('8784','2013-04-20','09:00:00',2.19),('8784','2013-04-20','09:05:00',2.28),('8784','2013-04-20','09:10:00',2.15),('8784','2013-04-20','09:15:00',2.28),('8784','2013-04-20','09:20:00',2.7),('8784','2013-04-20','09:25:00',2.3),('8784','2013-04-20','09:30:00',2.25),('8784','2013-04-20','09:35:00',1.57),('8784','2013-04-20','09:40:00',1.02),('8784','2013-04-20','09:45:00',1.13),('8784','2013-04-20','09:50:00',1.07),('8784','2013-04-20','10:40:00',1.45),('8784','2013-04-20','10:45:00',3.12),('8784','2013-04-20','10:50:00',2.58),('8784','2013-04-20','10:55:00',3.24),('8784','2013-04-20','11:00:00',3.73),('8784','2013-04-20','11:05:00',3.52),('8784','2013-04-20','11:10:00',3.99),('8784','2013-04-20','11:15:00',4.4),('8784','2013-04-20','11:20:00',3.23),('8784','2013-04-20','11:25:00',4.39),('8784','2013-04-20','11:30:00',3.97),('8784','2013-04-20','11:35:00',2.09),('8784','2013-04-20','11:40:00',2.3),('8784','2013-04-20','11:45:00',3.08),('8784','2013-04-20','11:50:00',4.18),('8784','2013-04-20','11:55:00',4.61),('8784','2013-04-20','12:00:00',4.56),('8784','2013-04-20','12:05:00',3.89),('8784','2013-04-20','12:10:00',4.43),('8784','2013-04-20','12:15:00',4.5),('8784','2013-04-20','12:20:00',4.38),('8784','2013-04-20','12:25:00',4.48),('8784','2013-04-20','12:30:00',3.99),('8784','2013-04-20','12:35:00',1.51),('8784','2013-04-20','12:40:00',4.24),('8784','2013-04-20','12:45:00',4.71),('8784','2013-04-20','12:50:00',1.57),('8784','2013-04-20','12:55:00',4.8),('8784','2013-04-20','13:00:00',1.5),('8784','2013-04-20','13:05:00',2.89),('8784','2013-04-20','13:10:00',3.09),('8784','2013-04-20','13:15:00',4.42),('8784','2013-04-20','13:20:00',3.05),('8784','2013-04-20','13:25:00',1.77),('8784','2013-04-20','13:30:00',2.64),('8784','2013-04-20','13:35:00',4.48),('8784','2013-04-20','13:40:00',3.1),('8784','2013-04-20','13:45:00',2.2),('8784','2013-04-20','13:50:00',1.7),('8784','2013-04-20','13:55:00',3.31),('8784','2013-04-20','14:00:00',2.43),('8784','2013-04-20','14:05:00',3.28),('8784','2013-04-20','14:10:00',4.17),('8784','2013-04-20','14:15:00',4.12),('8784','2013-04-20','14:20:00',3.51),('8784','2013-04-20','14:25:00',3.93),('8784','2013-04-20','14:30:00',3.81),('8784','2013-04-20','14:35:00',3.78),('8784','2013-04-20','14:40:00',3.77),('8784','2013-04-20','14:45:00',3.8),('8784','2013-04-20','14:50:00',3.77),('8784','2013-04-20','14:55:00',3.77),('8784','2013-04-20','15:00:00',3.73),('8784','2013-04-20','15:05:00',3.72),('8784','2013-04-20','15:10:00',2.17),('8784','2013-04-20','15:15:00',2.38),('8784','2013-04-20','15:20:00',2.93),('8784','2013-04-20','15:25:00',3.14),('8784','2013-04-20','15:30:00',1.47),('8784','2013-04-20','16:05:00',1.15),('8784','2013-04-20','16:10:00',2),('8784','2013-04-20','16:15:00',2.29),('8784','2013-04-20','16:20:00',2.17),('8784','2013-04-20','16:25:00',2.61),('8784','2013-04-20','16:30:00',2.94),('8784','2013-04-20','16:35:00',2.63),('8784','2013-04-20','16:40:00',3.02),('8784','2013-04-20','16:45:00',2.91),('8784','2013-04-20','16:50:00',2.6),('8784','2013-04-20','16:55:00',2.46),('8784','2013-04-20','17:00:00',2.33),('8784','2013-04-20','17:05:00',2.26),('8784','2013-04-20','17:10:00',2.19),('8784','2013-04-20','17:15:00',1.82),('8784','2013-04-20','17:20:00',2.03),('8784','2013-04-20','17:25:00',1.91),('8784','2013-04-20','17:30:00',2),('8784','2013-04-20','17:35:00',2),('8784','2013-04-20','17:40:00',1.79),('8784','2013-04-20','17:55:00',1.65),('8784','2013-04-20','18:00:00',1.22),('8784','2013-04-20','18:05:00',1.24),('8784','2013-04-20','18:10:00',1.42),('8784','2013-04-20','18:15:00',1.15),('8784','2013-04-19','08:05:00',1.09),('8784','2013-04-19','08:15:00',1.01),('8784','2013-04-19','08:20:00',1.43),('8784','2013-04-19','08:25:00',1.42),('8784','2013-04-19','08:30:00',1.37),('8784','2013-04-19','08:35:00',1.67),('8784','2013-04-19','08:40:00',1.75),('8784','2013-04-19','08:45:00',1.86),('8784','2013-04-19','08:50:00',1.91),('8784','2013-04-19','08:55:00',2.01),('8784','2013-04-19','09:00:00',2.07),('8784','2013-04-19','09:05:00',2.13),('8784','2013-04-19','09:10:00',2.18),('8784','2013-04-19','09:15:00',2.24),('8784','2013-04-19','09:20:00',2.35),('8784','2013-04-19','09:25:00',2.41),('8784','2013-04-19','09:30:00',2.51),('8784','2013-04-19','09:35:00',2.58),('8784','2013-04-19','09:40:00',2.62),('8784','2013-04-19','09:45:00',2.68),('8784','2013-04-19','09:50:00',2.73),('8784','2013-04-19','09:55:00',2.77),('8784','2013-04-19','10:00:00',2.82),('8784','2013-04-19','10:05:00',2.89),('8784','2013-04-19','10:10:00',2.93),('8784','2013-04-19','10:15:00',3.03),('8784','2013-04-19','10:20:00',3.14),('8784','2013-04-19','10:25:00',3.18),('8784','2013-04-19','10:30:00',3.21),('8784','2013-04-19','10:35:00',2.44),('8784','2013-04-19','10:40:00',3.27),('8784','2013-04-19','10:45:00',3.35),('8784','2013-04-19','10:50:00',3.31),('8784','2013-04-19','10:55:00',3.36),('8784','2013-04-19','11:00:00',3.38),('8784','2013-04-19','11:05:00',3.44),('8784','2013-04-19','11:10:00',3.49),('8784','2013-04-19','11:15:00',3.55),('8784','2013-04-19','11:20:00',3.56),('8784','2013-04-19','11:25:00',3.61),('8784','2013-04-19','11:30:00',3.56),('8784','2013-04-19','11:35:00',3.65),('8784','2013-04-19','11:40:00',3.74),('8784','2013-04-19','11:45:00',3.77),('8784','2013-04-19','11:50:00',3.8),('8784','2013-04-19','11:55:00',3.8),('8784','2013-04-19','12:00:00',3.85),('8784','2013-04-19','12:05:00',3.83),('8784','2013-04-19','12:10:00',3.88),('8784','2013-04-19','12:15:00',3.86),('8784','2013-04-19','12:20:00',3.83),('8784','2013-04-19','12:25:00',3.89),('8784','2013-04-19','12:30:00',3.95),('8784','2013-04-19','12:35:00',3.87),('8784','2013-04-19','12:40:00',3.93),('8784','2013-04-19','12:45:00',3.8),('8784','2013-04-19','12:50:00',3.92),('8784','2013-04-19','12:55:00',3.95),('8784','2013-04-19','13:00:00',3.93),('8784','2013-04-19','13:05:00',3.96),('8784','2013-04-19','13:10:00',3.97),('8784','2013-04-19','13:15:00',3.96),('8784','2013-04-19','13:20:00',3.94),('8784','2013-04-19','13:25:00',4.01),('8784','2013-04-19','13:30:00',3.96),('8784','2013-04-19','13:35:00',3.9),('8784','2013-04-19','13:40:00',3.97),('8784','2013-04-19','13:45:00',3.87),('8784','2013-04-19','13:50:00',3.77),('8784','2013-04-19','13:55:00',3.85),('8784','2013-04-19','14:00:00',3.8),('8784','2013-04-19','14:05:00',3.79),('8784','2013-04-19','14:10:00',3.78),('8784','2013-04-19','14:15:00',3.76),('8784','2013-04-19','14:20:00',3.71),('8784','2013-04-19','14:25:00',3.72),('8784','2013-04-19','14:30:00',3.67),('8784','2013-04-19','14:35:00',3.65),('8784','2013-04-19','14:40:00',3.58),('8784','2013-04-19','14:45:00',3.57),('8784','2013-04-19','14:50:00',3.56),('8784','2013-04-19','14:55:00',3.54),('8784','2013-04-19','15:00:00',3.48),('8784','2013-04-19','15:05:00',3.42),('8784','2013-04-19','15:10:00',3.38),('8784','2013-04-19','15:15:00',3.32),('8784','2013-04-19','15:20:00',3.25),('8784','2013-04-19','15:25:00',3.25),('8784','2013-04-19','15:30:00',3.18),('8784','2013-04-19','15:35:00',3.16),('8784','2013-04-19','15:40:00',3.12),('8784','2013-04-19','15:45:00',3.07),('8784','2013-04-19','15:50:00',2.99),('8784','2013-04-19','15:55:00',2.95),('8784','2013-04-19','16:00:00',2.89),('8784','2013-04-19','16:05:00',2.83),('8784','2013-04-19','16:10:00',2.76),('8784','2013-04-19','16:15:00',2.7),('8784','2013-04-19','16:20:00',2.64),('8784','2013-04-19','16:25:00',2.59),('8784','2013-04-19','16:30:00',2.51),('8784','2013-04-19','16:35:00',2.41),('8784','2013-04-19','16:40:00',2.36),('8784','2013-04-19','16:45:00',2.28),('8784','2013-04-19','16:50:00',2.2),('8784','2013-04-19','16:55:00',2.1),('8784','2013-04-19','17:00:00',2.04),('8784','2013-04-19','17:05:00',1.96),('8784','2013-04-19','17:10:00',1.86),('8784','2013-04-19','17:15:00',1.78),('8784','2013-04-19','17:20:00',1.71),('8784','2013-04-19','17:25:00',1.62),('8784','2013-04-19','17:30:00',1.55),('8784','2013-04-19','17:35:00',1.47),('8784','2013-04-19','17:40:00',1.39),('8784','2013-04-19','17:45:00',1.31),('8784','2013-04-19','17:50:00',1.2),('8784','2013-04-19','17:55:00',1.13),('8784','2013-04-19','18:00:00',1.07),('8784','2013-04-19','18:05:00',1),('8784','2013-04-18','08:10:00',1.2),('8784','2013-04-18','08:15:00',1.21),('8784','2013-04-18','08:20:00',1.31),('8784','2013-04-18','08:25:00',1.25),('8784','2013-04-18','08:30:00',1.38),('8784','2013-04-18','08:35:00',1.46),('8784','2013-04-18','08:40:00',1.38),('8784','2013-04-18','08:45:00',1.41),('8784','2013-04-18','08:50:00',1.57),('8784','2013-04-18','08:55:00',1.76),('8784','2013-04-18','09:00:00',1.86),('8784','2013-04-18','09:05:00',1.95),('8784','2013-04-18','09:10:00',1.99),('8784','2013-04-18','09:15:00',2.08),('8784','2013-04-18','09:20:00',2.07),('8784','2013-04-18','09:25:00',2.11),('8784','2013-04-18','09:30:00',2.28),('8784','2013-04-18','09:35:00',2.55),('8784','2013-04-18','09:40:00',2.79),('8784','2013-04-18','09:45:00',2.74),('8784','2013-04-18','09:50:00',2.37),('8784','2013-04-18','09:55:00',2.24),('8784','2013-04-18','10:00:00',2.59),('8784','2013-04-18','10:05:00',2.88),('8784','2013-04-18','10:10:00',3.08),('8784','2013-04-18','10:15:00',3.28),('8784','2013-04-18','10:20:00',3.31),('8784','2013-04-18','10:25:00',3.28),('8784','2013-04-18','10:30:00',3.34),('8784','2013-04-18','10:35:00',3.38),('8784','2013-04-18','10:40:00',3.42),('8784','2013-04-18','10:45:00',3.49),('8784','2013-04-18','10:50:00',3.51),('8784','2013-04-18','10:55:00',3.55),('8784','2013-04-18','11:00:00',3.6),('8784','2013-04-18','11:05:00',3.65),('8784','2013-04-18','11:10:00',3.66),('8784','2013-04-18','11:15:00',3.73),('8784','2013-04-18','11:20:00',3.77),('8784','2013-04-18','11:25:00',3.8),('8784','2013-04-18','11:30:00',3.82),('8784','2013-04-18','11:35:00',3.85),('8784','2013-04-18','11:40:00',3.87),('8784','2013-04-18','11:45:00',3.79),('8784','2013-04-18','11:50:00',3.94),('8784','2013-04-18','11:55:00',3.96),('8784','2013-04-18','12:00:00',3.93),('8784','2013-04-18','12:05:00',4.01),('8784','2013-04-18','12:10:00',4.06),('8784','2013-04-18','12:15:00',4.03),('8784','2013-04-18','12:20:00',4.08),('8784','2013-04-18','12:25:00',4.09),('8784','2013-04-18','12:30:00',4.11),('8784','2013-04-18','12:35:00',4.11),('8784','2013-04-18','12:40:00',4.13),('8784','2013-04-18','12:45:00',4.16),('8784','2013-04-18','12:50:00',4.15),('8784','2013-04-18','12:55:00',4.18),('8784','2013-04-18','13:00:00',4.15),('8784','2013-04-18','13:05:00',4.12),('8784','2013-04-18','13:10:00',4.08),('8784','2013-04-18','13:15:00',4.15),('8784','2013-04-18','13:20:00',4.15),('8784','2013-04-18','13:25:00',4.17),('8784','2013-04-18','13:30:00',4.15),('8784','2013-04-18','13:35:00',4.16),('8784','2013-04-18','13:40:00',4.12),('8784','2013-04-18','13:45:00',4.11),('8784','2013-04-18','13:50:00',4.12),('8784','2013-04-18','13:55:00',4.09),('8784','2013-04-18','14:00:00',4.07),('8784','2013-04-18','14:05:00',4.05),('8784','2013-04-18','14:10:00',4.03),('8784','2013-04-18','14:15:00',4.02),('8784','2013-04-18','14:20:00',3.97),('8784','2013-04-18','14:25:00',3.95),('8784','2013-04-18','14:30:00',3.93),('8784','2013-04-18','14:35:00',3.91),('8784','2013-04-18','14:40:00',3.87),('8784','2013-04-18','14:45:00',3.77),('8784','2013-04-18','14:50:00',3.77),('8784','2013-04-18','14:55:00',3.73),('8784','2013-04-18','15:00:00',3.69),('8784','2013-04-18','15:05:00',3.65),('8784','2013-04-18','15:10:00',3.6),('8784','2013-04-18','15:15:00',3.55),('8784','2013-04-18','15:20:00',3.49),('8784','2013-04-18','15:25:00',3.46),('8784','2013-04-18','15:30:00',3.38),('8784','2013-04-18','15:35:00',3.33),('8784','2013-04-18','15:40:00',3.28),('8784','2013-04-18','15:45:00',3.23),('8784','2013-04-18','15:50:00',3.18),('8784','2013-04-18','15:55:00',3.1),('8784','2013-04-18','16:00:00',3.04),('8784','2013-04-18','16:05:00',2.98),('8784','2013-04-18','16:10:00',2.9),('8784','2013-04-18','16:15:00',2.82),('8784','2013-04-18','16:20:00',2.76),('8784','2013-04-18','16:25:00',2.68),('8784','2013-04-18','16:30:00',2.58),('8784','2013-04-18','16:35:00',2.52),('8784','2013-04-18','16:40:00',2.46),('8784','2013-04-18','16:45:00',2.4),('8784','2013-04-18','16:50:00',2.33),('8784','2013-04-18','16:55:00',2.24),('8784','2013-04-18','17:00:00',2.14),('8784','2013-04-18','17:05:00',2),('8784','2013-04-18','17:10:00',1.98),('8784','2013-04-18','17:15:00',1.92),('8784','2013-04-18','17:20:00',1.83),('8784','2013-04-18','17:25:00',1.74),('8784','2013-04-18','17:30:00',1.66),('8784','2013-04-18','17:35:00',1.58),('8784','2013-04-18','17:40:00',1.5),('8784','2013-04-18','17:45:00',1.43),('8784','2013-04-18','17:50:00',1.36),('8784','2013-04-18','17:55:00',1.27),('8784','2013-04-18','18:00:00',1.19),('8784','2013-04-18','18:05:00',1.1),('8784','2013-04-18','18:10:00',1.01),('8784','2013-04-17','07:55:00',1.04),('8784','2013-04-17','08:00:00',1.12),('8784','2013-04-17','08:05:00',1.2),('8784','2013-04-17','08:10:00',1.29),('8784','2013-04-17','08:15:00',1.38),('8784','2013-04-17','08:20:00',1.46),('8784','2013-04-17','08:25:00',1.55),('8784','2013-04-17','08:30:00',1.63),('8784','2013-04-17','08:35:00',1.71),('8784','2013-04-17','08:40:00',1.79),('8784','2013-04-17','08:45:00',1.88),('8784','2013-04-17','08:50:00',1.97),('8784','2013-04-17','08:55:00',2.04),('8784','2013-04-17','09:00:00',2.12),('8784','2013-04-17','09:05:00',2.21),('8784','2013-04-17','09:10:00',2.29),('8784','2013-04-17','09:15:00',2.36),('8784','2013-04-17','09:20:00',2.44),('8784','2013-04-17','09:25:00',2.52),('8784','2013-04-17','09:30:00',2.59),('8784','2013-04-17','09:35:00',2.67),('8784','2013-04-17','09:40:00',2.76),('8784','2013-04-17','09:45:00',2.82),('8784','2013-04-17','09:50:00',2.89),('8784','2013-04-17','09:55:00',2.95),('8784','2013-04-17','10:00:00',3.01),('8784','2013-04-17','10:05:00',3.08),('8784','2013-04-17','10:10:00',3.15),('8784','2013-04-17','10:15:00',3.2),('8784','2013-04-17','10:20:00',3.25),('8784','2013-04-17','10:25:00',3.33),('8784','2013-04-17','10:30:00',3.36),('8784','2013-04-17','10:35:00',3.38),('8784','2013-04-17','10:40:00',3.48),('8784','2013-04-17','10:45:00',3.51),('8784','2013-04-17','10:50:00',3.55),('8784','2013-04-17','10:55:00',3.6),('8784','2013-04-17','11:00:00',3.64),('8784','2013-04-17','11:05:00',3.69),('8784','2013-04-17','11:10:00',3.74),('8784','2013-04-17','11:15:00',3.77),('8784','2013-04-17','11:20:00',3.81),('8784','2013-04-17','11:25:00',3.8),('8784','2013-04-17','11:30:00',3.84),('8784','2013-04-17','11:35:00',3.86),('8784','2013-04-17','11:40:00',3.9),('8784','2013-04-17','11:45:00',3.93),('8784','2013-04-17','11:50:00',3.92),('8784','2013-04-17','11:55:00',4.02),('8784','2013-04-17','12:00:00',4.01),('8784','2013-04-17','12:05:00',4.01),('8784','2013-04-17','12:10:00',4.02),('8784','2013-04-17','12:15:00',4.03),('8784','2013-04-17','12:20:00',4.05),('8784','2013-04-17','12:25:00',4.09),('8784','2013-04-17','12:30:00',4.11),('8784','2013-04-17','12:35:00',4.14),('8784','2013-04-17','12:40:00',4.15),('8784','2013-04-17','12:45:00',4.15),('8784','2013-04-17','12:50:00',4.13),('8784','2013-04-17','12:55:00',4.13),('8784','2013-04-17','13:00:00',4.1),('8784','2013-04-17','13:05:00',4.1),('8784','2013-04-17','13:10:00',4.1),('8784','2013-04-17','13:15:00',4.17),('8784','2013-04-17','13:20:00',4.19),('8784','2013-04-17','13:25:00',4.18),('8784','2013-04-17','13:30:00',4.16),('8784','2013-04-17','13:35:00',4.12),('8784','2013-04-17','13:40:00',4.13),('8784','2013-04-17','13:45:00',4.07),('8784','2013-04-17','13:50:00',3.96),('8784','2013-04-17','13:55:00',4.22),('8784','2013-04-17','14:00:00',4.04),('8784','2013-04-17','14:05:00',4.38),('8784','2013-04-17','14:10:00',4.37),('8784','2013-04-17','14:15:00',4),('8784','2013-04-17','14:20:00',3.96),('8784','2013-04-17','14:25:00',3.72),('8784','2013-04-17','14:30:00',4.03),('8784','2013-04-17','14:35:00',4.21),('8784','2013-04-17','14:40:00',3.83),('8784','2013-04-17','14:45:00',3.68),('8784','2013-04-17','14:50:00',4.18),('8784','2013-04-17','14:55:00',4.06),('8784','2013-04-17','15:00:00',4.03),('8784','2013-04-17','15:05:00',4.11),('8784','2013-04-17','15:10:00',4.24),('8784','2013-04-17','15:15:00',3.82),('8784','2013-04-17','15:20:00',2.28),('8784','2013-04-17','15:25:00',1.79),('8784','2013-04-17','15:30:00',3.13),('8784','2013-04-17','15:35:00',3.48),('8784','2013-04-17','15:40:00',3.57),('8784','2013-04-17','15:45:00',3.56),('8784','2013-04-17','15:50:00',3.55),('8784','2013-04-17','15:55:00',3.45),('8784','2013-04-17','16:00:00',3.31),('8784','2013-04-17','16:05:00',2.44),('8784','2013-04-17','16:10:00',3.13),('8784','2013-04-17','16:15:00',3.05),('8784','2013-04-17','16:20:00',2.92),('8784','2013-04-17','16:25:00',2.83),('8784','2013-04-17','16:30:00',2.76),('8784','2013-04-17','16:35:00',2.74),('8784','2013-04-17','16:40:00',2.35),('8784','2013-04-17','16:45:00',2.6),('8784','2013-04-17','16:50:00',2.42),('8784','2013-04-17','16:55:00',2.3),('8784','2013-04-17','17:00:00',2.21),('8784','2013-04-17','17:05:00',2.11),('8784','2013-04-17','17:10:00',2.02),('8784','2013-04-17','17:15:00',1.93),('8784','2013-04-17','17:20:00',1.85),('8784','2013-04-17','17:25:00',1.77),('8784','2013-04-17','17:30:00',1.68),('8784','2013-04-17','17:35:00',1.6),('8784','2013-04-17','17:40:00',1.51),('8784','2013-04-17','17:45:00',1.43),('8784','2013-04-17','17:50:00',1.34),('8784','2013-04-17','17:55:00',1.26),('8784','2013-04-17','18:00:00',1.18),('8784','2013-04-17','18:05:00',1.11),('8784','2013-04-17','18:10:00',1.03),('8784','2013-04-16','08:05:00',1.1),('8784','2013-04-16','08:10:00',1.07),('8784','2013-04-16','08:50:00',1.11),('8784','2013-04-16','08:55:00',1.07),('8784','2013-04-16','09:10:00',1.76),('8784','2013-04-16','09:15:00',2.35),('8784','2013-04-16','09:20:00',1.28),('8784','2013-04-16','09:25:00',1.38),('8784','2013-04-16','09:30:00',1.73),('8784','2013-04-16','09:35:00',1.64),('8784','2013-04-16','09:40:00',1.52),('8784','2013-04-16','09:45:00',1.6),('8784','2013-04-16','09:50:00',1.48),('8784','2013-04-16','09:55:00',1.42),('8784','2013-04-16','10:00:00',1.36),('8784','2013-04-16','10:05:00',1.35),('8784','2013-04-16','10:10:00',1.44),('8784','2013-04-16','10:15:00',1.53),('8784','2013-04-16','10:20:00',1.61),('8784','2013-04-16','10:25:00',1.62),('8784','2013-04-16','10:30:00',1.65),('8784','2013-04-16','10:35:00',1.69),('8784','2013-04-16','10:40:00',1.66),('8784','2013-04-16','10:45:00',1.6),('8784','2013-04-16','10:50:00',1.61),('8784','2013-04-16','10:55:00',1.69),('8784','2013-04-16','11:00:00',1.86),('8784','2013-04-16','11:05:00',1.92),('8784','2013-04-16','11:10:00',1.91),('8784','2013-04-16','11:15:00',1.95),('8784','2013-04-16','11:20:00',2.01),('8784','2013-04-16','11:25:00',1.93),('8784','2013-04-16','11:30:00',1.91),('8784','2013-04-16','11:35:00',1.84),('8784','2013-04-16','11:40:00',2),('8784','2013-04-16','11:45:00',2.31),('8784','2013-04-16','11:50:00',2.48),('8784','2013-04-16','11:55:00',2.55),('8784','2013-04-16','12:00:00',2.59),('8784','2013-04-16','12:05:00',2.82),('8784','2013-04-16','12:10:00',3.06),('8784','2013-04-16','12:15:00',3.02),('8784','2013-04-16','12:20:00',3.21),('8784','2013-04-16','12:25:00',3.07),('8784','2013-04-16','12:30:00',2.42),('8784','2013-04-16','12:35:00',2.98),('8784','2013-04-16','12:40:00',4.12),('8784','2013-04-16','12:45:00',3.48),('8784','2013-04-16','12:50:00',3.13),('8784','2013-04-16','12:55:00',3.74),('8784','2013-04-16','13:00:00',4.07),('8784','2013-04-16','13:05:00',4.06),('8784','2013-04-16','13:10:00',3.96),('8784','2013-04-16','13:15:00',4.05),('8784','2013-04-16','13:20:00',4.08),('8784','2013-04-16','13:25:00',4.09),('8784','2013-04-16','13:30:00',4.06),('8784','2013-04-16','13:35:00',4),('8784','2013-04-16','13:40:00',4.02),('8784','2013-04-16','13:45:00',3.84),('8784','2013-04-16','13:50:00',3.95),('8784','2013-04-16','13:55:00',3.82),('8784','2013-04-16','14:00:00',3.9),('8784','2013-04-16','14:05:00',3.95),('8784','2013-04-16','14:10:00',3.92),('8784','2013-04-16','14:15:00',3.97),('8784','2013-04-16','14:20:00',3.91),('8784','2013-04-16','14:25:00',3.55),('8784','2013-04-16','14:30:00',3.44),('8784','2013-04-16','14:35:00',2.76),('8784','2013-04-16','14:40:00',3.56),('8784','2013-04-16','14:45:00',3.65),('8784','2013-04-16','14:50:00',3.63),('8784','2013-04-16','14:55:00',3.56),('8784','2013-04-16','15:00:00',3.59),('8784','2013-04-16','15:05:00',3.61),('8784','2013-04-16','15:10:00',3.61),('8784','2013-04-16','15:15:00',3.5),('8784','2013-04-16','15:20:00',3.42),('8784','2013-04-16','15:25:00',3.18),('8784','2013-04-16','15:30:00',3.08),('8784','2013-04-16','15:35:00',3.24),('8784','2013-04-16','15:40:00',3.2),('8784','2013-04-16','15:45:00',3.16),('8784','2013-04-16','15:50:00',3.11),('8784','2013-04-16','15:55:00',3.07),('8784','2013-04-16','16:00:00',2.93),('8784','2013-04-16','16:05:00',2.91),('8784','2013-04-16','16:10:00',2.84),('8784','2013-04-16','16:15:00',2.71),('8784','2013-04-16','16:20:00',2.75),('8784','2013-04-16','16:25:00',2.68),('8784','2013-04-16','16:30:00',2.63),('8784','2013-04-16','16:35:00',2.59),('8784','2013-04-16','16:40:00',2.68),('8784','2013-04-16','16:45:00',2.74),('8784','2013-04-16','16:50:00',2.5),('8784','2013-04-16','16:55:00',2.1),('8784','2013-04-16','17:00:00',2.11),('8784','2013-04-16','17:05:00',2.21),('8784','2013-04-16','17:10:00',2.21),('8784','2013-04-16','17:15:00',2.12),('8784','2013-04-16','17:20:00',2.08),('8784','2013-04-16','17:25:00',2.06),('8784','2013-04-16','17:30:00',1.85),('8784','2013-04-16','17:35:00',1.91),('8784','2013-04-16','17:40:00',1.82),('8784','2013-04-16','17:45:00',1.66),('8784','2013-04-16','17:50:00',1.51),('8784','2013-04-16','17:55:00',1.31),('8784','2013-04-15','07:55:00',1.04),('8784','2013-04-15','08:00:00',1.12),('8784','2013-04-15','08:05:00',1.2),('8784','2013-04-15','08:10:00',1.27),('8784','2013-04-15','08:15:00',1.35),('8784','2013-04-15','08:20:00',1.43),('8784','2013-04-15','08:25:00',1.51),('8784','2013-04-15','08:30:00',1.61),('8784','2013-04-15','08:35:00',1.7),('8784','2013-04-15','08:40:00',1.79),('8784','2013-04-15','08:45:00',1.87),('8784','2013-04-15','08:50:00',1.95),('8784','2013-04-15','08:55:00',2),('8784','2013-04-15','09:00:00',2.13),('8784','2013-04-15','09:05:00',2.21),('8784','2013-04-15','09:10:00',2.29),('8784','2013-04-15','09:15:00',2.38),('8784','2013-04-15','09:20:00',2.45),('8784','2013-04-15','09:25:00',2.52),('8784','2013-04-15','09:30:00',2.6),('8784','2013-04-15','09:35:00',2.66),('8784','2013-04-15','09:40:00',2.73),('8784','2013-04-15','09:45:00',2.79),('8784','2013-04-15','09:50:00',2.87),('8784','2013-04-15','09:55:00',2.93),('8784','2013-04-15','10:00:00',3),('8784','2013-04-15','10:05:00',3.06),('8784','2013-04-15','10:10:00',3.12),('8784','2013-04-15','10:15:00',3.18),('8784','2013-04-15','10:20:00',3.26),('8784','2013-04-15','10:25:00',3.3),('8784','2013-04-15','10:30:00',3.35),('8784','2013-04-15','10:35:00',3.4),('8784','2013-04-15','10:40:00',3.45),('8784','2013-04-15','10:45:00',3.5),('8784','2013-04-15','10:50:00',3.53),('8784','2013-04-15','10:55:00',3.56),('8784','2013-04-15','11:00:00',3.63),('8784','2013-04-15','11:05:00',3.67),('8784','2013-04-15','11:10:00',3.68),('8784','2013-04-15','11:15:00',3.76),('8784','2013-04-15','11:20:00',3.79),('8784','2013-04-15','11:25:00',3.82),('8784','2013-04-15','11:30:00',3.84),('8784','2013-04-15','11:35:00',3.89),('8784','2013-04-15','11:40:00',3.92),('8784','2013-04-15','11:45:00',3.97),('8784','2013-04-15','11:50:00',3.97),('8784','2013-04-15','11:55:00',3.98),('8784','2013-04-15','12:00:00',3.99),('8784','2013-04-15','12:05:00',4.04),('8784','2013-04-15','12:10:00',4.05),('8784','2013-04-15','12:15:00',4.03),('8784','2013-04-15','12:20:00',4.04),('8784','2013-04-15','12:25:00',4.04),('8784','2013-04-15','12:30:00',4.06),('8784','2013-04-15','12:35:00',4.09),('8784','2013-04-15','12:40:00',4.12),('8784','2013-04-15','12:45:00',4.11),('8784','2013-04-15','12:50:00',4.08),('8784','2013-04-15','12:55:00',4.06),('8784','2013-04-15','13:00:00',4.11),('8784','2013-04-15','13:05:00',4.12),('8784','2013-04-15','13:10:00',4.14),('8784','2013-04-15','13:15:00',4.12),('8784','2013-04-15','13:20:00',4.09),('8784','2013-04-15','13:25:00',4.13),('8784','2013-04-15','13:30:00',4.1),('8784','2013-04-15','13:35:00',4.08),('8784','2013-04-15','13:40:00',4.04),('8784','2013-04-15','13:45:00',4.04),('8784','2013-04-15','13:50:00',4.06),('8784','2013-04-15','13:55:00',4.08),('8784','2013-04-15','14:00:00',4.06),('8784','2013-04-15','14:05:00',4.05),('8784','2013-04-15','14:10:00',3.99),('8784','2013-04-15','14:15:00',4.01),('8784','2013-04-15','14:20:00',4),('8784','2013-04-15','14:25:00',3.99),('8784','2013-04-15','14:30:00',3.95),('8784','2013-04-15','14:35:00',3.92),('8784','2013-04-15','14:40:00',3.89),('8784','2013-04-15','14:45:00',3.84),('8784','2013-04-15','14:50:00',3.81),('8784','2013-04-15','14:55:00',3.76),('8784','2013-04-15','15:00:00',3.72),('8784','2013-04-15','15:05:00',3.69),('8784','2013-04-15','15:10:00',3.64),('8784','2013-04-15','15:15:00',3.6),('8784','2013-04-15','15:20:00',3.55),('8784','2013-04-15','15:25:00',3.5),('8784','2013-04-15','15:30:00',3.46),('8784','2013-04-15','15:35:00',3.39),('8784','2013-04-15','15:40:00',3.32),('8784','2013-04-15','15:45:00',3.26),('8784','2013-04-15','15:50:00',3.22),('8784','2013-04-15','15:55:00',3.16),('8784','2013-04-15','16:00:00',3.07),('8784','2013-04-15','16:05:00',3.01),('8784','2013-04-15','16:10:00',2.94),('8784','2013-04-15','16:15:00',2.87),('8784','2013-04-15','16:20:00',2.79),('8784','2013-04-15','16:25:00',2.72),('8784','2013-04-15','16:30:00',2.64),('8784','2013-04-15','16:35:00',2.57),('8784','2013-04-15','16:40:00',2.49),('8784','2013-04-15','16:45:00',2.42),('8784','2013-04-15','16:50:00',2.34),('8784','2013-04-15','16:55:00',2.25),('8784','2013-04-15','17:00:00',2.17),('8784','2013-04-15','17:05:00',2.09),('8784','2013-04-15','17:10:00',2.01),('8784','2013-04-15','17:15:00',1.93),('8784','2013-04-15','17:20:00',1.85),('8784','2013-04-15','17:25:00',1.77),('8784','2013-04-15','17:30:00',1.67),('8784','2013-04-15','17:35:00',1.59),('8784','2013-04-15','17:40:00',1.5),('8784','2013-04-15','17:45:00',1.42),('8784','2013-04-15','17:50:00',1.34),('8784','2013-04-15','17:55:00',1.26),('8784','2013-04-15','18:00:00',1.18),('8784','2013-04-15','18:05:00',1.09),('8784','2013-04-15','18:10:00',1.01),('8784','2013-04-14','07:55:00',1.02),('8784','2013-04-14','08:00:00',1.08),('8784','2013-04-14','08:05:00',1.06),('8784','2013-04-14','08:10:00',1.18),('8784','2013-04-14','08:15:00',1.3),('8784','2013-04-14','08:20:00',1.39),('8784','2013-04-14','08:25:00',1.46),('8784','2013-04-14','08:30:00',1.57),('8784','2013-04-14','08:35:00',1.65),('8784','2013-04-14','08:40:00',1.73),('8784','2013-04-14','08:45:00',1.8),('8784','2013-04-14','08:50:00',1.88),('8784','2013-04-14','08:55:00',1.94),('8784','2013-04-14','09:00:00',2.02),('8784','2013-04-14','09:05:00',2.11),('8784','2013-04-14','09:10:00',2.2),('8784','2013-04-14','09:15:00',2.27),('8784','2013-04-14','09:20:00',2.33),('8784','2013-04-14','09:25:00',2.38),('8784','2013-04-14','09:30:00',2.48),('8784','2013-04-14','09:35:00',2.56),('8784','2013-04-14','09:40:00',2.62),('8784','2013-04-14','09:45:00',2.69),('8784','2013-04-14','09:50:00',2.7),('8784','2013-04-14','09:55:00',2.77),('8784','2013-04-14','10:00:00',2.89),('8784','2013-04-14','10:05:00',2.97),('8784','2013-04-14','10:10:00',3.03),('8784','2013-04-14','10:15:00',3.09),('8784','2013-04-14','10:20:00',3.15),('8784','2013-04-14','10:25:00',3.2),('8784','2013-04-14','10:30:00',3.25),('8784','2013-04-14','10:35:00',3.3),('8784','2013-04-14','10:40:00',3.37),('8784','2013-04-14','10:45:00',3.43),('8784','2013-04-14','10:50:00',3.44),('8784','2013-04-14','10:55:00',3.5),('8784','2013-04-14','11:00:00',3.56),('8784','2013-04-14','11:05:00',3.59),('8784','2013-04-14','11:10:00',3.58),('8784','2013-04-14','11:15:00',3.69),('8784','2013-04-14','11:20:00',3.75),('8784','2013-04-14','11:25:00',3.77),('8784','2013-04-14','11:30:00',3.77),('8784','2013-04-14','11:35:00',3.78),('8784','2013-04-14','11:40:00',3.8),('8784','2013-04-14','11:45:00',3.86),('8784','2013-04-14','11:50:00',3.89),('8784','2013-04-14','11:55:00',3.88),('8784','2013-04-14','12:00:00',3.93),('8784','2013-04-14','12:05:00',3.91),('8784','2013-04-14','12:10:00',3.94),('8784','2013-04-14','12:15:00',3.98),('8784','2013-04-14','12:20:00',4),('8784','2013-04-14','12:25:00',4.03),('8784','2013-04-14','12:30:00',4.03),('8784','2013-04-14','12:35:00',4.03),('8784','2013-04-14','12:40:00',3),('8784','2013-04-14','12:45:00',1.75),('8784','2013-04-14','12:50:00',4.19),('8784','2013-04-14','12:55:00',4.27),('8784','2013-04-14','13:00:00',3.43),('8784','2013-04-14','13:05:00',3.31),('8784','2013-04-14','13:10:00',4.2),('8784','2013-04-14','13:15:00',3.86),('8784','2013-04-14','13:20:00',4.2),('8784','2013-04-14','13:25:00',4.16),('8784','2013-04-14','13:30:00',4.14),('8784','2013-04-14','13:35:00',4.09),('8784','2013-04-14','13:40:00',4.05),('8784','2013-04-14','13:45:00',4.02),('8784','2013-04-14','13:50:00',3.97),('8784','2013-04-14','13:55:00',3.98),('8784','2013-04-14','14:00:00',3.97),('8784','2013-04-14','14:05:00',3.97),('8784','2013-04-14','14:10:00',3.93),('8784','2013-04-14','14:15:00',3.88),('8784','2013-04-14','14:20:00',3.85),('8784','2013-04-14','14:25:00',3.85),('8784','2013-04-14','14:30:00',3.84),('8784','2013-04-14','14:35:00',3.92),('8784','2013-04-14','14:40:00',3.91),('8784','2013-04-14','14:45:00',3.99),('8784','2013-04-14','14:50:00',3.94),('8784','2013-04-14','14:55:00',3.83),('8784','2013-04-14','15:00:00',3.79),('8784','2013-04-14','15:05:00',3.73),('8784','2013-04-14','15:10:00',3.71),('8784','2013-04-14','15:15:00',3.24),('8784','2013-04-14','15:20:00',3.5),('8784','2013-04-14','15:25:00',3.36),('8784','2013-04-14','15:30:00',2.88),('8784','2013-04-14','15:35:00',3.44),('8784','2013-04-14','15:40:00',3.43),('8784','2013-04-14','15:45:00',3.38),('8784','2013-04-14','15:50:00',3.3),('8784','2013-04-14','15:55:00',3.14),('8784','2013-04-14','16:00:00',2.6),('8784','2013-04-14','16:05:00',2.9),('8784','2013-04-14','16:10:00',2.83),('8784','2013-04-14','16:15:00',2.76),('8784','2013-04-14','16:20:00',2.67),('8784','2013-04-14','16:25:00',2.63),('8784','2013-04-14','16:30:00',2.57),('8784','2013-04-14','16:35:00',2.48),('8784','2013-04-14','16:40:00',2.42),('8784','2013-04-14','16:45:00',2.32),('8784','2013-04-14','16:50:00',2.27),('8784','2013-04-14','16:55:00',2.19),('8784','2013-04-14','17:00:00',2.07),('8784','2013-04-14','17:05:00',1.99),('8784','2013-04-14','17:10:00',1.93),('8784','2013-04-14','17:15:00',1.85),('8784','2013-04-14','17:20:00',1.76),('8784','2013-04-14','17:25:00',1.68),('8784','2013-04-14','17:30:00',1.59),('8784','2013-04-14','17:35:00',1.52),('8784','2013-04-14','17:40:00',1.44),('8784','2013-04-14','17:45:00',1.36),('8784','2013-04-14','17:50:00',1.29),('8784','2013-04-14','17:55:00',1.21),('8784','2013-04-14','18:00:00',1.12),('8784','2013-04-14','18:05:00',1.04),('8784','2013-04-13','08:05:00',1.02),('8784','2013-04-13','08:10:00',1.15),('8784','2013-04-13','08:15:00',1.22),('8784','2013-04-13','08:50:00',1.13),('8784','2013-04-13','08:55:00',1.48),('8784','2013-04-13','09:00:00',1.06),('8784','2013-04-13','09:05:00',1.7),('8784','2013-04-13','09:10:00',1.81),('8784','2013-04-13','09:15:00',1.17),('8784','2013-04-13','09:20:00',1.44),('8784','2013-04-13','09:25:00',1.34),('8784','2013-04-13','09:30:00',2.54),('8784','2013-04-13','09:35:00',2.49),('8784','2013-04-13','09:40:00',2.35),('8784','2013-04-13','09:45:00',2.72),('8784','2013-04-13','09:50:00',2.78),('8784','2013-04-13','09:55:00',2.85),('8784','2013-04-13','10:00:00',2.96),('8784','2013-04-13','10:05:00',3.02),('8784','2013-04-13','10:10:00',2.98),('8784','2013-04-13','10:15:00',2.81),('8784','2013-04-13','10:20:00',2.62),('8784','2013-04-13','10:25:00',3.47),('8784','2013-04-13','10:30:00',2.88),('8784','2013-04-13','10:35:00',3.37),('8784','2013-04-13','10:40:00',3.54),('8784','2013-04-13','10:45:00',3.37),('8784','2013-04-13','10:50:00',3.46),('8784','2013-04-13','10:55:00',2.83),('8784','2013-04-13','11:00:00',1.68),('8784','2013-04-13','11:05:00',4),('8784','2013-04-13','11:10:00',4.01),('8784','2013-04-13','11:15:00',4.24),('8784','2013-04-13','11:20:00',2.59),('8784','2013-04-13','11:25:00',1.26),('8784','2013-04-13','11:30:00',4.09),('8784','2013-04-13','11:35:00',4.26),('8784','2013-04-13','11:40:00',3.57),('8784','2013-04-13','11:45:00',3.22),('8784','2013-04-13','11:50:00',2.41),('8784','2013-04-13','11:55:00',4.31),('8784','2013-04-13','12:00:00',4.4),('8784','2013-04-13','12:05:00',4.31),('8784','2013-04-13','12:10:00',4.35),('8784','2013-04-13','12:15:00',3.99),('8784','2013-04-13','12:20:00',4.24),('8784','2013-04-13','12:25:00',4.39),('8784','2013-04-13','12:30:00',4.34),('8784','2013-04-13','12:35:00',4.28),('8784','2013-04-13','12:40:00',4.23),('8784','2013-04-13','12:45:00',4.15),('8784','2013-04-13','12:50:00',4.08),('8784','2013-04-13','12:55:00',3.98),('8784','2013-04-13','13:00:00',4.12),('8784','2013-04-13','13:05:00',4.21),('8784','2013-04-13','13:10:00',4.39),('8784','2013-04-13','13:15:00',4.26),('8784','2013-04-13','13:20:00',4.27),('8784','2013-04-13','13:25:00',4.24),('8784','2013-04-13','13:30:00',3.86),('8784','2013-04-13','13:35:00',2.91),('8784','2013-04-13','13:40:00',3.61),('8784','2013-04-13','13:45:00',3.22),('8784','2013-04-13','13:50:00',1.84),('8784','2013-04-13','13:55:00',1.95),('8784','2013-04-13','14:00:00',2.22),('8784','2013-04-13','14:05:00',2.16),('8784','2013-04-13','14:10:00',2.31),('8784','2013-04-13','14:15:00',3.62),('8784','2013-04-13','14:20:00',3.56),('8784','2013-04-13','14:25:00',3.65),('8784','2013-04-13','14:30:00',3.61),('8784','2013-04-13','14:35:00',3.72),('8784','2013-04-13','14:40:00',3.65),('8784','2013-04-13','14:45:00',3.69),('8784','2013-04-13','14:50:00',3.52),('8784','2013-04-13','14:55:00',3.62),('8784','2013-04-13','15:00:00',3.28),('8784','2013-04-13','15:05:00',2.64),('8784','2013-04-13','15:10:00',3.1),('8784','2013-04-13','15:15:00',2.83),('8784','2013-04-13','15:20:00',2.87),('8784','2013-04-13','15:25:00',2.67),('8784','2013-04-13','15:30:00',2.71),('8784','2013-04-13','15:35:00',2.65),('8784','2013-04-13','15:40:00',2.74),('8784','2013-04-13','15:45:00',2.78),('8784','2013-04-13','15:50:00',2.66),('8784','2013-04-13','15:55:00',2.71),('8784','2013-04-13','16:00:00',2.65),('8784','2013-04-13','16:05:00',2.51),('8784','2013-04-13','16:10:00',2.38),('8784','2013-04-13','16:15:00',2.43),('8784','2013-04-13','16:20:00',2.35),('8784','2013-04-13','16:25:00',2.17),('8784','2013-04-13','16:30:00',2.06),('8784','2013-04-13','16:35:00',1.95),('8784','2013-04-13','16:40:00',1.84),('8784','2013-04-13','16:45:00',1.75),('8784','2013-04-13','16:50:00',1.76),('8784','2013-04-13','16:55:00',1.47),('8784','2013-04-13','17:00:00',1.26),('8784','2013-04-13','17:05:00',1.21),('8784','2013-04-13','17:10:00',1.69),('8784','2013-04-13','17:15:00',1.91),('8784','2013-04-13','17:20:00',1.59),('8784','2013-04-13','17:25:00',1.79),('8784','2013-04-13','17:30:00',1.56),('8784','2013-04-13','17:35:00',1.55),('8784','2013-04-13','17:40:00',1.49),('8784','2013-04-13','17:45:00',1.34),('8784','2013-04-13','17:50:00',1.17),('8784','2013-04-13','17:55:00',1.28),('8784','2013-04-12','07:55:00',1.06),('8784','2013-04-12','08:00:00',1.11),('8784','2013-04-12','08:05:00',1.21),('8784','2013-04-12','08:10:00',1.1),('8784','2013-04-12','08:35:00',1.22),('8784','2013-04-12','08:45:00',1.13),('8784','2013-04-12','08:50:00',1.44),('8784','2013-04-12','08:55:00',1.99),('8784','2013-04-12','09:00:00',1.78),('8784','2013-04-12','09:05:00',1.41),('8784','2013-04-12','09:10:00',1.3),('8784','2013-04-12','09:15:00',1.8),('8784','2013-04-12','09:20:00',2.5),('8784','2013-04-12','09:25:00',2.12),('8784','2013-04-12','09:30:00',1.34),('8784','2013-04-12','09:35:00',1.26),('8784','2013-04-12','09:40:00',1.3),('8784','2013-04-12','09:45:00',1.42),('8784','2013-04-12','10:05:00',1.17),('8784','2013-04-12','10:15:00',1.15),('8784','2013-04-12','10:20:00',3.26),('8784','2013-04-12','10:25:00',2.66),('8784','2013-04-12','10:30:00',1.93),('8784','2013-04-12','10:35:00',3.48),('8784','2013-04-12','10:40:00',4.07),('8784','2013-04-12','10:45:00',4.48),('8784','2013-04-12','10:50:00',3.28),('8784','2013-04-12','10:55:00',1.43),('8784','2013-04-12','11:00:00',1.39),('8784','2013-04-12','11:05:00',1.94),('8784','2013-04-12','11:10:00',2.67),('8784','2013-04-12','11:15:00',4.68),('8784','2013-04-12','11:20:00',4.46),('8784','2013-04-12','11:25:00',4.48),('8784','2013-04-12','11:30:00',4.62),('8784','2013-04-12','11:35:00',2.46),('8784','2013-04-12','11:40:00',1.8),('8784','2013-04-12','11:45:00',1.97),('8784','2013-04-12','11:50:00',1.8),('8784','2013-04-12','11:55:00',4.22),('8784','2013-04-12','12:00:00',4.43),('8784','2013-04-12','12:05:00',4.27),('8784','2013-04-12','12:10:00',4.11),('8784','2013-04-12','12:15:00',4.3),('8784','2013-04-12','12:20:00',4.28),('8784','2013-04-12','12:25:00',4.22),('8784','2013-04-12','12:30:00',4.13),('8784','2013-04-12','12:35:00',4.12),('8784','2013-04-12','12:40:00',4.01),('8784','2013-04-12','12:45:00',4.14),('8784','2013-04-12','12:50:00',3.12),('8784','2013-04-12','12:55:00',3.89),('8784','2013-04-12','13:00:00',4.18),('8784','2013-04-12','13:05:00',4.13),('8784','2013-04-12','13:10:00',4.15),('8784','2013-04-12','13:15:00',4.18),('8784','2013-04-12','13:20:00',4.18),('8784','2013-04-12','13:25:00',4.17),('8784','2013-04-12','13:30:00',4.12),('8784','2013-04-12','13:35:00',4.2),('8784','2013-04-12','13:40:00',4.13),('8784','2013-04-12','13:45:00',4.13),('8784','2013-04-12','13:50:00',4.09),('8784','2013-04-12','13:55:00',4.09),('8784','2013-04-12','14:00:00',4.08),('8784','2013-04-12','14:05:00',4.05),('8784','2013-04-12','14:10:00',4),('8784','2013-04-12','14:15:00',3.98),('8784','2013-04-12','14:20:00',3.95),('8784','2013-04-12','14:25:00',3.93),('8784','2013-04-12','14:30:00',3.89),('8784','2013-04-12','14:35:00',3.86),('8784','2013-04-12','14:40:00',3.81),('8784','2013-04-12','14:45:00',3.77),('8784','2013-04-12','14:50:00',3.74),('8784','2013-04-12','14:55:00',3.68),('8784','2013-04-12','15:00:00',3.65),('8784','2013-04-12','15:05:00',3.6),('8784','2013-04-12','15:10:00',3.52),('8784','2013-04-12','15:15:00',3.49),('8784','2013-04-12','15:20:00',3.44),('8784','2013-04-12','15:25:00',3.38),('8784','2013-04-12','15:30:00',3.34),('8784','2013-04-12','15:35:00',3.3),('8784','2013-04-12','15:40:00',3.24),('8784','2013-04-12','15:45:00',3.21),('8784','2013-04-12','15:50:00',3.14),('8784','2013-04-12','15:55:00',3.09),('8784','2013-04-12','16:00:00',3.04),('8784','2013-04-12','16:05:00',2.97),('8784','2013-04-12','16:10:00',2.94),('8784','2013-04-12','16:15:00',2.56),('8784','2013-04-12','16:20:00',2.73),('8784','2013-04-12','16:25:00',2.71),('8784','2013-04-12','16:30:00',1.59),('8784','2013-04-12','16:35:00',1.23),('8784','2013-04-12','16:40:00',1.78),('8784','2013-04-12','16:45:00',2.48),('8784','2013-04-12','16:50:00',2.31),('8784','2013-04-12','16:55:00',2.23),('8784','2013-04-12','17:00:00',2.13),('8784','2013-04-12','17:05:00',2.04),('8784','2013-04-12','17:10:00',1.95),('8784','2013-04-12','17:15:00',1.88),('8784','2013-04-12','17:20:00',1.79),('8784','2013-04-12','17:25:00',1.72),('8784','2013-04-12','17:30:00',1.66),('8784','2013-04-12','17:35:00',1.56),('8784','2013-04-12','17:40:00',1.45),('8784','2013-04-12','17:45:00',1.35),('8784','2013-04-12','17:50:00',1.29),('8784','2013-04-12','17:55:00',1.22),('8784','2013-04-12','18:00:00',1.13),('8784','2013-04-12','18:05:00',1.04),('8784','2014-03-28','07:15:00',1.05),('8784','2014-03-28','07:20:00',1.09),('8784','2014-03-28','07:25:00',1.09),('8784','2014-03-28','07:30:00',1.17),('8784','2014-03-28','07:35:00',1.32),('8784','2014-03-28','07:40:00',1.37),('8784','2014-03-28','07:45:00',1.54),('8784','2014-03-28','07:50:00',1.63),('8784','2014-03-28','07:55:00',1.71),('8784','2014-03-28','08:00:00',1.79),('8784','2014-03-28','08:05:00',1.89),('8784','2014-03-28','08:10:00',2),('8784','2014-03-28','08:15:00',2.09),('8784','2014-03-28','08:20:00',2.18),('8784','2014-03-28','08:25:00',2.26),('8784','2014-03-28','08:30:00',2.33),('8784','2014-03-28','08:35:00',2.4),('8784','2014-03-28','08:40:00',2.51),('8784','2014-03-28','08:45:00',2.57),('8784','2014-03-28','08:50:00',2.68),('8784','2014-03-28','08:55:00',2.78),('8784','2014-03-28','09:00:00',2.86),('8784','2014-03-28','09:05:00',2.99),('8784','2014-03-28','09:10:00',3.14),('8784','2014-03-28','09:15:00',3.13),('8784','2014-03-28','09:20:00',2.96),('8784','2014-03-28','09:25:00',3.54),('8784','2014-03-28','09:30:00',3.6),('8784','2014-03-28','09:35:00',3.22),('8784','2014-03-28','09:40:00',1.96),('8784','2014-03-28','09:45:00',1.9),('8784','2014-03-28','09:50:00',2.53),('8784','2014-03-28','09:55:00',3.69),('8784','2014-03-28','10:00:00',3.64),('8784','2014-03-28','10:05:00',3.72),('8784','2014-03-28','10:10:00',3.5),('8784','2014-03-28','10:15:00',2.66),('8784','2014-03-28','10:20:00',2.57),('8784','2014-03-28','10:25:00',3.65),('8784','2014-03-28','10:30:00',3.82),('8784','2014-03-28','10:35:00',3.77),('8784','2014-03-28','10:40:00',3.55),('8784','2014-03-28','10:45:00',2.83),('8784','2014-03-28','10:50:00',4.01),('8784','2014-03-28','10:55:00',4.07),('8784','2014-03-28','11:00:00',4.08),('8784','2014-03-28','11:05:00',3.65),('8784','2014-03-28','11:10:00',2.92),('8784','2014-03-28','11:15:00',3.06),('8784','2014-03-28','11:20:00',2.27),('8784','2014-03-28','11:25:00',2.48),('8784','2014-03-28','11:30:00',1.87),('8784','2014-03-28','11:35:00',1.76),('8784','2014-03-28','11:40:00',1.53),('8784','2014-03-28','11:45:00',3.9),('8784','2014-03-28','11:50:00',2.19),('8784','2014-03-28','11:55:00',1.48),('8784','2014-03-28','12:00:00',1.34),('8784','2014-03-28','12:05:00',4.67),('8784','2014-03-28','12:10:00',4.57),('8784','2014-03-28','12:15:00',4.76),('8784','2014-03-28','12:20:00',4.91),('8784','2014-03-28','12:25:00',1.39),('8784','2014-03-28','12:35:00',3.76),('8784','2014-03-28','12:40:00',4.51),('8784','2014-03-28','12:45:00',4.39),('8784','2014-03-28','12:50:00',4.44),('8784','2014-03-28','12:55:00',1.82),('8784','2014-03-28','13:00:00',4.85),('8784','2014-03-28','13:05:00',2.65),('8784','2014-03-28','13:10:00',2.84),('8784','2014-03-28','13:15:00',1.69),('8784','2014-03-28','13:20:00',2.68),('8784','2014-03-28','13:25:00',1.62),('8784','2014-03-28','13:30:00',1.47),('8784','2014-03-28','13:35:00',3.75),('8784','2014-03-28','13:40:00',4.41),('8784','2014-03-28','13:45:00',4.05),('8784','2014-03-28','13:50:00',3.85),('8784','2014-03-28','13:55:00',3.74),('8784','2014-03-28','14:00:00',3.79),('8784','2014-03-28','14:05:00',3.72),('8784','2014-03-28','14:10:00',3.64),('8784','2014-03-28','14:15:00',3.6),('8784','2014-03-28','14:20:00',3.55),('8784','2014-03-28','14:25:00',3.51),('8784','2014-03-28','14:30:00',3.45),('8784','2014-03-28','14:35:00',3.38),('8784','2014-03-28','14:40:00',3.35),('8784','2014-03-28','14:45:00',3.29),('8784','2014-03-28','14:50:00',3.24),('8784','2014-03-28','14:55:00',3.18),('8784','2014-03-28','15:00:00',3.15),('8784','2014-03-28','15:05:00',3.06),('8784','2014-03-28','15:10:00',2.96),('8784','2014-03-28','15:15:00',2.88),('8784','2014-03-28','15:20:00',2.8),('8784','2014-03-28','15:25:00',2.72),('8784','2014-03-28','15:30:00',2.65),('8784','2014-03-28','15:35:00',2.58),('8784','2014-03-28','15:40:00',2.5),('8784','2014-03-28','15:45:00',2.48),('8784','2014-03-28','15:50:00',2.45),('8784','2014-03-28','15:55:00',1.93),('8784','2014-03-28','16:00:00',2.46),('8784','2014-03-28','16:05:00',2.49),('8784','2014-03-28','16:10:00',2.39),('8784','2014-03-28','16:15:00',2.28),('8784','2014-03-28','16:20:00',1.94),('8784','2014-03-28','16:25:00',1.69),('8784','2014-03-28','16:30:00',1.6),('8784','2014-03-28','16:40:00',1.01),('8784','2014-03-28','16:45:00',1.11),('8784','2014-03-28','16:50:00',1.15),('8784','2013-04-11','08:05:00',1.09),('8784','2013-04-11','08:10:00',1.18),('8784','2013-04-11','08:15:00',1.27),('8784','2013-04-11','08:20:00',1.36),('8784','2013-04-11','08:25:00',1.45),('8784','2013-04-11','08:30:00',1.53),('8784','2013-04-11','08:35:00',1.62),('8784','2013-04-11','08:40:00',1.69),('8784','2013-04-11','08:45:00',1.77),('8784','2013-04-11','08:50:00',1.85),('8784','2013-04-11','08:55:00',1.92),('8784','2013-04-11','09:00:00',2),('8784','2013-04-11','09:05:00',2.08),('8784','2013-04-11','09:10:00',2.16),('8784','2013-04-11','09:15:00',2.23),('8784','2013-04-11','09:20:00',2.3),('8784','2013-04-11','09:25:00',2.35),('8784','2013-04-11','09:30:00',2.44),('8784','2013-04-11','09:35:00',2.51),('8784','2013-04-11','09:40:00',1.93),('8784','2013-04-11','09:45:00',2.74),('8784','2013-04-11','09:50:00',1.77),('8784','2013-04-11','10:00:00',1.81),('8784','2013-04-11','10:05:00',1.07),('8784','2013-04-11','10:10:00',2.2),('8784','2013-04-11','10:15:00',3.22),('8784','2013-04-11','10:20:00',3.25),('8784','2013-04-11','10:25:00',3.49),('8784','2013-04-11','10:30:00',3.58),('8784','2013-04-11','10:35:00',3.61),('8784','2013-04-11','10:40:00',3.85),('8784','2013-04-11','10:45:00',3.25),('8784','2013-04-11','11:00:00',1.37),('8784','2013-04-11','11:05:00',3.75),('8784','2013-04-11','11:10:00',4),('8784','2013-04-11','11:15:00',3.76),('8784','2013-04-11','11:20:00',1.96),('8784','2013-04-11','11:25:00',2.92),('8784','2013-04-11','11:30:00',4.31),('8784','2013-04-11','11:35:00',3.29),('8784','2013-04-11','11:40:00',1.29),('8784','2013-04-11','11:45:00',1.17),('8784','2013-04-11','11:50:00',3.78),('8784','2013-04-11','11:55:00',4.87),('8784','2013-04-11','12:00:00',4.42),('8784','2013-04-11','12:05:00',4.53),('8784','2013-04-11','12:10:00',4.67),('8784','2013-04-11','12:15:00',4.55),('8784','2013-04-11','12:20:00',4.03),('8784','2013-04-11','12:25:00',4.35),('8784','2013-04-11','12:30:00',4.17),('8784','2013-04-11','12:35:00',3.71),('8784','2013-04-11','12:40:00',3.23),('8784','2013-04-11','12:45:00',1.74),('8784','2013-04-11','12:50:00',4.61),('8784','2013-04-11','12:55:00',4.49),('8784','2013-04-11','13:00:00',4.61),('8784','2013-04-11','13:05:00',4.57),('8784','2013-04-11','13:10:00',4.37),('8784','2013-04-11','13:15:00',3.77),('8784','2013-04-11','13:20:00',4.09),('8784','2013-04-11','13:25:00',4.32),('8784','2013-04-11','13:30:00',4.27),('8784','2013-04-11','13:35:00',4.29),('8784','2013-04-11','13:40:00',4.23),('8784','2013-04-11','13:45:00',4.15),('8784','2013-04-11','13:50:00',4.15),('8784','2013-04-11','13:55:00',4.18),('8784','2013-04-11','14:00:00',4.08),('8784','2013-04-11','14:05:00',4.17),('8784','2013-04-11','14:10:00',4.21),('8784','2013-04-11','14:15:00',4.17),('8784','2013-04-11','14:20:00',4.13),('8784','2013-04-11','14:25:00',4.04),('8784','2013-04-11','14:30:00',3.99),('8784','2013-04-11','14:35:00',4.02),('8784','2013-04-11','14:40:00',4.04),('8784','2013-04-11','14:45:00',3.94),('8784','2013-04-11','14:50:00',3.85),('8784','2013-04-11','14:55:00',3.83),('8784','2013-04-11','15:00:00',3.74),('8784','2013-04-11','15:05:00',3.68),('8784','2013-04-11','15:10:00',3.66),('8784','2013-04-11','15:15:00',3.59),('8784','2013-04-11','15:20:00',3.54),('8784','2013-04-11','15:25:00',3.49),('8784','2013-04-11','15:30:00',3.43),('8784','2013-04-11','15:35:00',3.38),('8784','2013-04-11','15:40:00',3.31),('8784','2013-04-11','15:45:00',3.25),('8784','2013-04-11','15:50:00',3.2),('8784','2013-04-11','15:55:00',3.14),('8784','2013-04-11','16:00:00',3.09),('8784','2013-04-11','16:05:00',3.01),('8784','2013-04-11','16:10:00',2.94),('8784','2013-04-11','16:15:00',2.88),('8784','2013-04-11','16:20:00',2.82),('8784','2013-04-11','16:25:00',2.75),('8784','2013-04-11','16:30:00',2.67),('8784','2013-04-11','16:35:00',2.59),('8784','2013-04-11','16:40:00',2.52),('8784','2013-04-11','16:45:00',2.45),('8784','2013-04-11','16:50:00',2.36),('8784','2013-04-11','16:55:00',2.29),('8784','2013-04-11','17:00:00',2.17),('8784','2013-04-11','17:05:00',2.08),('8784','2013-04-11','17:10:00',2.01),('8784','2013-04-11','17:15:00',1.93),('8784','2013-04-11','17:20:00',1.83),('8784','2013-04-11','17:25:00',1.76),('8784','2013-04-11','17:30:00',1.68),('8784','2013-04-11','17:35:00',1.57),('8784','2013-04-11','17:40:00',1.51),('8784','2013-04-11','17:45:00',1.42),('8784','2013-04-11','17:50:00',1.34),('8784','2013-04-11','17:55:00',1.22),('8784','2013-04-11','18:00:00',1.11),('8784','2013-04-11','18:05:00',1.01),('8784','2013-04-10','08:50:00',1.07),('8784','2013-04-10','08:55:00',1.87),('8784','2013-04-10','09:00:00',2.03),('8784','2013-04-10','09:05:00',2.21),('8784','2013-04-10','09:10:00',2.31),('8784','2013-04-10','09:15:00',2.35),('8784','2013-04-10','09:20:00',2.37),('8784','2013-04-10','09:25:00',2.45),('8784','2013-04-10','09:30:00',2.54),('8784','2013-04-10','09:35:00',2.59),('8784','2013-04-10','09:40:00',2.69),('8784','2013-04-10','09:45:00',2.67),('8784','2013-04-10','09:50:00',2.75),('8784','2013-04-10','09:55:00',2.9),('8784','2013-04-10','10:00:00',3.05),('8784','2013-04-10','10:05:00',3.16),('8784','2013-04-10','10:10:00',3.3),('8784','2013-04-10','10:15:00',3.44),('8784','2013-04-10','10:20:00',3.47),('8784','2013-04-10','10:25:00',3.49),('8784','2013-04-10','10:30:00',3.51),('8784','2013-04-10','10:35:00',3.56),('8784','2013-04-10','10:40:00',3.54),('8784','2013-04-10','10:45:00',3.67),('8784','2013-04-10','10:50:00',3.47),('8784','2013-04-10','10:55:00',3.15),('8784','2013-04-10','11:00:00',3.55),('8784','2013-04-10','11:05:00',3.51),('8784','2013-04-10','11:10:00',3.63),('8784','2013-04-10','11:15:00',3.62),('8784','2013-04-10','11:20:00',3.75),('8784','2013-04-10','11:25:00',3.92),('8784','2013-04-10','11:30:00',3.84),('8784','2013-04-10','11:35:00',3.97),('8784','2013-04-10','11:40:00',4.04),('8784','2013-04-10','11:45:00',4.02),('8784','2013-04-10','11:50:00',4.09),('8784','2013-04-10','11:55:00',4.11),('8784','2013-04-10','12:00:00',4.19),('8784','2013-04-10','12:05:00',4.25),('8784','2013-04-10','12:10:00',4.25),('8784','2013-04-10','12:15:00',4.3),('8784','2013-04-10','12:20:00',4.3),('8784','2013-04-10','12:25:00',4.33),('8784','2013-04-10','12:30:00',4.37),('8784','2013-04-10','12:35:00',4.07),('8784','2013-04-10','12:40:00',4.37),('8784','2013-04-10','12:45:00',4.36),('8784','2013-04-10','12:50:00',4.31),('8784','2013-04-10','12:55:00',4.37),('8784','2013-04-10','13:00:00',3.31),('8784','2013-04-10','13:05:00',3.55),('8784','2013-04-10','13:10:00',1.57),('8784','2013-04-10','13:15:00',3.45),('8784','2013-04-10','13:20:00',4.8),('8784','2013-04-10','13:25:00',4.25),('8784','2013-04-10','13:30:00',4.06),('8784','2013-04-10','13:35:00',3.92),('8784','2013-04-10','13:40:00',3.58),('8784','2013-04-10','13:45:00',2.15),('8784','2013-04-10','13:50:00',4.82),('8784','2013-04-10','13:55:00',2.84),('8784','2013-04-10','14:00:00',4.47),('8784','2013-04-10','14:05:00',4.27),('8784','2013-04-10','14:10:00',4.25),('8784','2013-04-10','14:15:00',4.16),('8784','2013-04-10','14:20:00',4.15),('8784','2013-04-10','14:25:00',4.2),('8784','2013-04-10','14:30:00',4.18),('8784','2013-04-10','14:35:00',3.89),('8784','2013-04-10','14:40:00',4.08),('8784','2013-04-10','14:45:00',4.16),('8784','2013-04-10','14:50:00',4.11),('8784','2013-04-10','14:55:00',4),('8784','2013-04-10','15:00:00',4.04),('8784','2013-04-10','15:05:00',3.63),('8784','2013-04-10','15:10:00',3.23),('8784','2013-04-10','15:15:00',3.54),('8784','2013-04-10','15:20:00',3.89),('8784','2013-04-10','15:25:00',3.61),('8784','2013-04-10','15:30:00',3.51),('8784','2013-04-10','15:35:00',3.49),('8784','2013-04-10','15:40:00',3.11),('8784','2013-04-10','15:45:00',3.34),('8784','2013-04-10','15:50:00',3.37),('8784','2013-04-10','15:55:00',3.16),('8784','2013-04-10','16:00:00',2.77),('8784','2013-04-10','16:05:00',3.23),('8784','2013-04-10','16:10:00',3.12),('8784','2013-04-10','16:15:00',2.95),('8784','2013-04-10','16:20:00',2.61),('8784','2013-04-10','16:25:00',2.75),('8784','2013-04-10','16:30:00',2.57),('8784','2013-04-10','16:35:00',1.92),('8784','2013-04-10','16:40:00',2.41),('8784','2013-04-10','16:45:00',2.62),('8784','2013-04-10','16:50:00',2.07),('8784','2013-04-10','16:55:00',2.34),('8784','2013-04-10','17:00:00',2.16),('8784','2013-04-10','17:05:00',1.75),('8784','2013-04-10','17:10:00',1.78),('8784','2013-04-10','17:15:00',2.01),('8784','2013-04-10','17:20:00',1.96),('8784','2013-04-10','17:25:00',1.75),('8784','2013-04-10','17:30:00',1.71),('8784','2013-04-10','17:35:00',1.41),('8784','2013-04-10','17:40:00',1.18),('8784','2013-04-10','17:45:00',1.47),('8784','2013-04-10','17:50:00',1.21),('8784','2013-04-10','17:55:00',1.27),('8784','2013-04-09','07:55:00',1.11),('8784','2013-04-09','08:00:00',1.1),('8784','2013-04-09','08:10:00',1.12),('8784','2013-04-09','08:20:00',1.47),('8784','2013-04-09','08:30:00',1.04),('8784','2013-04-09','09:05:00',1.01),('8784','2013-04-09','09:10:00',1.07),('8784','2013-04-09','09:15:00',1.12),('8784','2013-04-09','09:20:00',1.01),('8784','2013-04-09','09:25:00',1.13),('8784','2013-04-09','09:30:00',1.13),('8784','2013-04-09','09:45:00',1.75),('8784','2013-04-09','09:50:00',2.81),('8784','2013-04-09','09:55:00',3.27),('8784','2013-04-09','10:00:00',1.76),('8784','2013-04-09','10:05:00',1.22),('8784','2013-04-09','10:10:00',1.89),('8784','2013-04-09','10:15:00',2.13),('8784','2013-04-09','10:20:00',1.54),('8784','2013-04-09','10:30:00',1.27),('8784','2013-04-09','10:35:00',2.7),('8784','2013-04-09','10:40:00',3.01),('8784','2013-04-09','10:45:00',4.34),('8784','2013-04-09','10:50:00',3.59),('8784','2013-04-09','10:55:00',3.95),('8784','2013-04-09','11:00:00',3.51),('8784','2013-04-09','11:05:00',3.84),('8784','2013-04-09','11:10:00',3.58),('8784','2013-04-09','11:20:00',1.45),('8784','2013-04-09','11:25:00',3.18),('8784','2013-04-09','11:30:00',4.49),('8784','2013-04-09','11:35:00',2.09),('8784','2013-04-09','11:40:00',1.77),('8784','2013-04-09','11:45:00',3.21),('8784','2013-04-09','11:50:00',4.19),('8784','2013-04-09','11:55:00',3.31),('8784','2013-04-09','12:00:00',4.66),('8784','2013-04-09','12:05:00',4.62),('8784','2013-04-09','12:10:00',4.64),('8784','2013-04-09','12:15:00',4.61),('8784','2013-04-09','12:20:00',3.92),('8784','2013-04-09','12:25:00',4.38),('8784','2013-04-09','12:30:00',4.48),('8784','2013-04-09','12:35:00',4.52),('8784','2013-04-09','12:40:00',4.53),('8784','2013-04-09','12:45:00',4.37),('8784','2013-04-09','12:50:00',4.64),('8784','2013-04-09','12:55:00',4.37),('8784','2013-04-09','13:00:00',4.55),('8784','2013-04-09','13:05:00',4.46),('8784','2013-04-09','13:10:00',4.92),('8784','2013-04-09','13:15:00',3.81),('8784','2013-04-09','13:20:00',2.98),('8784','2013-04-09','13:25:00',4),('8784','2013-04-09','13:30:00',1.6),('8784','2013-04-09','13:35:00',1.99),('8784','2013-04-09','13:40:00',1.92),('8784','2013-04-09','13:45:00',2.2),('8784','2013-04-09','13:50:00',4.54),('8784','2013-04-09','13:55:00',4.31),('8784','2013-04-09','14:00:00',4.03),('8784','2013-04-09','14:05:00',3.15),('8784','2013-04-09','14:10:00',3.36),('8784','2013-04-09','14:15:00',3.78),('8784','2013-04-09','14:20:00',2.44),('8784','2013-04-09','14:25:00',2.73),('8784','2013-04-09','14:30:00',3.1),('8784','2013-04-09','14:35:00',3.77),('8784','2013-04-09','14:40:00',3.91),('8784','2013-04-09','14:45:00',3.61),('8784','2013-04-09','14:50:00',3.26),('8784','2013-04-09','14:55:00',2.66),('8784','2013-04-09','15:00:00',3.88),('8784','2013-04-09','15:05:00',3.79),('8784','2013-04-09','15:10:00',3.49),('8784','2013-04-09','15:15:00',3.01),('8784','2013-04-09','15:20:00',3.88),('8784','2013-04-09','15:25:00',3.81),('8784','2013-04-09','15:30:00',2.01),('8784','2013-04-09','15:35:00',3.84),('8784','2013-04-09','15:40:00',3.63),('8784','2013-04-09','15:45:00',3.13),('8784','2013-04-09','15:50:00',3.53),('8784','2013-04-09','15:55:00',2.86),('8784','2013-04-09','16:00:00',2.63),('8784','2013-04-09','16:05:00',2.82),('8784','2013-04-09','16:10:00',1.92),('8784','2013-04-09','16:15:00',1.97),('8784','2013-04-09','16:25:00',1.36),('8784','2013-04-09','16:30:00',1.09),('8784','2013-04-09','16:35:00',1.27),('8784','2013-04-09','16:40:00',1.19),('8784','2013-04-09','16:45:00',1.07),('8784','2013-04-09','16:50:00',2.91),('8784','2013-04-09','16:55:00',2.03),('8784','2013-04-09','17:15:00',1.21),('8784','2013-04-09','17:20:00',1.22),('8784','2013-04-09','17:30:00',1.19),('8784','2013-04-08','08:40:00',1.28),('8784','2013-04-08','08:45:00',1.13),('8784','2013-04-08','08:50:00',1.89),('8784','2013-04-08','08:55:00',1.88),('8784','2013-04-08','09:00:00',1.7),('8784','2013-04-08','09:05:00',1.78),('8784','2013-04-08','09:10:00',1.29),('8784','2013-04-08','09:15:00',2.21),('8784','2013-04-08','09:20:00',2.57),('8784','2013-04-08','09:25:00',2.64),('8784','2013-04-08','09:30:00',2.63),('8784','2013-04-08','09:35:00',2.8),('8784','2013-04-08','09:40:00',2.79),('8784','2013-04-08','09:45:00',2.85),('8784','2013-04-08','09:50:00',1.65),('8784','2013-04-08','09:55:00',1.92),('8784','2013-04-08','10:00:00',3.01),('8784','2013-04-08','10:05:00',3.06),('8784','2013-04-08','10:10:00',3.07),('8784','2013-04-08','10:15:00',3.17),('8784','2013-04-08','10:20:00',3.16),('8784','2013-04-08','10:25:00',3.19),('8784','2013-04-08','10:30:00',3.3),('8784','2013-04-08','10:35:00',3.13),('8784','2013-04-08','10:40:00',3.51),('8784','2013-04-08','10:45:00',3.69),('8784','2013-04-08','10:50:00',3.69),('8784','2013-04-08','10:55:00',3.52),('8784','2013-04-08','11:00:00',3.69),('8784','2013-04-08','11:05:00',3.22),('8784','2013-04-08','11:10:00',3.14),('8784','2013-04-08','11:15:00',2.79),('8784','2013-04-08','11:20:00',2.39),('8784','2013-04-08','11:25:00',2.11),('8784','2013-04-08','11:30:00',2.44),('8784','2013-04-08','11:35:00',3.2),('8784','2013-04-08','11:40:00',3.33),('8784','2013-04-08','11:45:00',2.96),('8784','2013-04-08','11:50:00',2.71),('8784','2013-04-08','11:55:00',2.47),('8784','2013-04-08','12:00:00',2.32),('8784','2013-04-08','12:05:00',2.24),('8784','2013-04-08','12:10:00',2.44),('8784','2013-04-08','12:15:00',2.85),('8784','2013-04-08','12:20:00',2.87),('8784','2013-04-08','12:25:00',2.82),('8784','2013-04-08','12:30:00',3.18),('8784','2013-04-08','12:35:00',2.68),('8784','2013-04-08','12:40:00',2.85),('8784','2013-04-08','12:45:00',3.81),('8784','2013-04-08','12:50:00',2.47),('8784','2013-04-08','12:55:00',1.96),('8784','2013-04-08','13:00:00',1.94),('8784','2013-04-08','13:05:00',2.82),('8784','2013-04-08','13:10:00',2.87),('8784','2013-04-08','13:15:00',3.14),('8784','2013-04-08','13:20:00',3.73),('8784','2013-04-08','13:25:00',3.39),('8784','2013-04-08','13:30:00',2.9),('8784','2013-04-08','13:35:00',2.21),('8784','2013-04-08','13:40:00',2.8),('8784','2013-04-08','13:45:00',3.07),('8784','2013-04-08','13:50:00',3.17),('8784','2013-04-08','13:55:00',4.02),('8784','2013-04-08','14:00:00',3.8),('8784','2013-04-08','14:05:00',3.39),('8784','2013-04-08','14:10:00',3.42),('8784','2013-04-08','14:15:00',3.86),('8784','2013-04-08','14:20:00',3.44),('8784','2013-04-08','14:25:00',4.04),('8784','2013-04-08','14:30:00',3.88),('8784','2013-04-08','14:35:00',3.58),('8784','2013-04-08','14:40:00',3.69),('8784','2013-04-08','14:45:00',3.83),('8784','2013-04-08','14:50:00',3.73),('8784','2013-04-08','14:55:00',3.84),('8784','2013-04-08','15:00:00',2.88),('8784','2013-04-08','15:05:00',2.81),('8784','2013-04-08','15:10:00',3.03),('8784','2013-04-08','15:15:00',2.94),('8784','2013-04-08','15:20:00',3.09),('8784','2013-04-08','15:25:00',3.55),('8784','2013-04-08','15:30:00',3.62),('8784','2013-04-08','15:35:00',3.47),('8784','2013-04-08','15:40:00',3.34),('8784','2013-04-08','15:45:00',3.28),('8784','2013-04-08','15:50:00',3.21),('8784','2013-04-08','15:55:00',3.17),('8784','2013-04-08','16:00:00',3.06),('8784','2013-04-08','16:05:00',2.89),('8784','2013-04-08','16:10:00',2.75),('8784','2013-04-08','16:15:00',2.87),('8784','2013-04-08','16:20:00',2.87),('8784','2013-04-08','16:25:00',2.73),('8784','2013-04-08','16:30:00',2.66),('8784','2013-04-08','16:35:00',2.58),('8784','2013-04-08','16:40:00',2.5),('8784','2013-04-08','16:45:00',2.4),('8784','2013-04-08','16:50:00',2.37),('8784','2013-04-08','16:55:00',2.28),('8784','2013-04-08','17:00:00',2.22),('8784','2013-04-08','17:05:00',2.13),('8784','2013-04-08','17:10:00',1.98),('8784','2013-04-08','17:15:00',1.87),('8784','2013-04-08','17:20:00',1.79),('8784','2013-04-08','17:25:00',1.82),('8784','2013-04-08','17:30:00',1.68),('8784','2013-04-08','17:35:00',1.57),('8784','2013-04-08','17:40:00',1.4),('8784','2013-04-08','17:45:00',1.31),('8784','2013-04-08','17:50:00',1.07),('8784','2013-04-08','18:00:00',1.02),('8784','2013-04-08','18:20:00',1.16),('8784','2013-04-08','18:25:00',1.05),('8784','2013-04-07','08:30:00',1.09),('8784','2013-04-07','08:35:00',1.19),('8784','2013-04-07','08:40:00',1.24),('8784','2013-04-07','08:45:00',1.26),('8784','2013-04-07','08:50:00',1.25),('8784','2013-04-07','08:55:00',1.3),('8784','2013-04-07','09:00:00',1.35),('8784','2013-04-07','09:05:00',1.4),('8784','2013-04-07','09:10:00',1.51),('8784','2013-04-07','09:15:00',1.56),('8784','2013-04-07','09:20:00',1.66),('8784','2013-04-07','09:25:00',1.67),('8784','2013-04-07','09:30:00',1.56),('8784','2013-04-07','09:35:00',1.49),('8784','2013-04-07','09:40:00',1.45),('8784','2013-04-07','09:45:00',1.6),('8784','2013-04-07','09:50:00',2.02),('8784','2013-04-07','09:55:00',2.18),('8784','2013-04-07','10:00:00',2.54),('8784','2013-04-07','10:05:00',2.75),('8784','2013-04-07','10:10:00',2.76),('8784','2013-04-07','10:15:00',2.83),('8784','2013-04-07','10:20:00',2.86),('8784','2013-04-07','10:25:00',2.98),('8784','2013-04-07','10:30:00',2.57),('8784','2013-04-07','10:35:00',2.67),('8784','2013-04-07','10:40:00',2.83),('8784','2013-04-07','10:45:00',2.74),('8784','2013-04-07','10:50:00',2.67),('8784','2013-04-07','10:55:00',2.36),('8784','2013-04-07','11:00:00',2.2),('8784','2013-04-07','11:05:00',1.97),('8784','2013-04-07','11:10:00',2.09),('8784','2013-04-07','11:15:00',2.83),('8784','2013-04-07','11:20:00',3.6),('8784','2013-04-07','11:25:00',3.8),('8784','2013-04-07','11:30:00',3.87),('8784','2013-04-07','11:35:00',3.58),('8784','2013-04-07','11:40:00',3.3),('8784','2013-04-07','11:45:00',2.63),('8784','2013-04-07','11:50:00',2.38),('8784','2013-04-07','11:55:00',2.49),('8784','2013-04-07','12:00:00',2.55),('8784','2013-04-07','12:05:00',2.56),('8784','2013-04-07','12:10:00',2.75),('8784','2013-04-07','12:15:00',2.69),('8784','2013-04-07','12:20:00',2.9),('8784','2013-04-07','12:25:00',3.22),('8784','2013-04-07','12:30:00',2.91),('8784','2013-04-07','12:35:00',2.94),('8784','2013-04-07','12:40:00',2.95),('8784','2013-04-07','12:45:00',2.52),('8784','2013-04-07','12:50:00',2.73),('8784','2013-04-07','12:55:00',2.73),('8784','2013-04-07','13:00:00',3.24),('8784','2013-04-07','13:05:00',3.57),('8784','2013-04-07','13:10:00',3.41),('8784','2013-04-07','13:15:00',3.09),('8784','2013-04-07','13:20:00',2.97),('8784','2013-04-07','13:25:00',3.33),('8784','2013-04-07','13:30:00',2.91),('8784','2013-04-07','13:35:00',3.11),('8784','2013-04-07','13:40:00',3.42),('8784','2013-04-07','13:45:00',3.21),('8784','2013-04-07','13:50:00',2.78),('8784','2013-04-07','13:55:00',2.96),('8784','2013-04-07','14:00:00',3.72),('8784','2013-04-07','14:05:00',3.43),('8784','2013-04-07','14:10:00',1.9),('8784','2013-04-07','14:15:00',2.65),('8784','2013-04-07','14:20:00',2.53),('8784','2013-04-07','14:25:00',2.09),('8784','2013-04-07','14:30:00',1.65),('8784','2013-04-07','14:35:00',1.87),('8784','2013-04-07','14:40:00',2.18),('8784','2013-04-07','14:45:00',1.9),('8784','2013-04-07','14:50:00',2.25),('8784','2013-04-07','14:55:00',2.49),('8784','2013-04-07','15:00:00',1.74),('8784','2013-04-07','15:05:00',2.4),('8784','2013-04-07','15:10:00',2.06),('8784','2013-04-07','15:15:00',2.75),('8784','2013-04-07','15:20:00',2.72),('8784','2013-04-07','15:25:00',2.92),('8784','2013-04-07','15:30:00',2.99),('8784','2013-04-07','15:35:00',2.88),('8784','2013-04-07','15:40:00',2.58),('8784','2013-04-07','15:45:00',2.5),('8784','2013-04-07','15:50:00',2.65),('8784','2013-04-07','15:55:00',2.41),('8784','2013-04-07','16:00:00',2.34),('8784','2013-04-07','16:05:00',2.02),('8784','2013-04-07','16:10:00',1.81),('8784','2013-04-07','16:15:00',1.56),('8784','2013-04-07','16:20:00',1.55),('8784','2013-04-07','16:25:00',1.3),('8784','2013-04-07','16:30:00',1.42),('8784','2013-04-07','16:35:00',1.92),('8784','2013-04-07','16:40:00',1.66),('8784','2013-04-07','16:45:00',2.08),('8784','2013-04-07','16:50:00',2.34),('8784','2013-04-07','16:55:00',2.28),('8784','2013-04-07','17:00:00',2.17),('8784','2013-04-07','17:05:00',1.95),('8784','2013-04-07','17:10:00',1.6),('8784','2013-04-07','17:15:00',1.1),('8784','2013-04-07','17:20:00',1.63),('8784','2013-04-07','17:25:00',1.96),('8784','2013-04-07','17:30:00',1.77),('8784','2013-04-07','17:35:00',1.7),('8784','2013-04-07','17:40:00',1.69),('8784','2013-04-07','17:45:00',1.63),('8784','2013-04-07','17:50:00',1.48),('8784','2013-04-07','17:55:00',1.24),('8784','2013-04-06','08:05:00',1.01),('8784','2013-04-06','08:10:00',1.08),('8784','2013-04-06','08:15:00',1.17),('8784','2013-04-06','08:20:00',1.25),('8784','2013-04-06','08:25:00',1.34),('8784','2013-04-06','08:30:00',1.42),('8784','2013-04-06','08:35:00',1.52),('8784','2013-04-06','08:40:00',1.61),('8784','2013-04-06','08:45:00',1.7),('8784','2013-04-06','08:50:00',1.79),('8784','2013-04-06','08:55:00',1.87),('8784','2013-04-06','09:00:00',1.94),('8784','2013-04-06','09:05:00',2.02),('8784','2013-04-06','09:10:00',2.11),('8784','2013-04-06','09:15:00',2.18),('8784','2013-04-06','09:20:00',2.29),('8784','2013-04-06','09:25:00',2.39),('8784','2013-04-06','09:30:00',2.45),('8784','2013-04-06','09:35:00',2.48),('8784','2013-04-06','09:40:00',2.58),('8784','2013-04-06','09:45:00',2.65),('8784','2013-04-06','09:50:00',2.73),('8784','2013-04-06','09:55:00',2.78),('8784','2013-04-06','10:00:00',2.85),('8784','2013-04-06','10:05:00',2.94),('8784','2013-04-06','10:10:00',2.97),('8784','2013-04-06','10:15:00',3.03),('8784','2013-04-06','10:20:00',3.13),('8784','2013-04-06','10:25:00',3.13),('8784','2013-04-06','10:30:00',3.18),('8784','2013-04-06','10:35:00',3.21),('8784','2013-04-06','10:40:00',3.34),('8784','2013-04-06','10:45:00',3.39),('8784','2013-04-06','10:50:00',3.43),('8784','2013-04-06','10:55:00',3.49),('8784','2013-04-06','11:00:00',3.58),('8784','2013-04-06','11:05:00',3.63),('8784','2013-04-06','11:10:00',3.64),('8784','2013-04-06','11:15:00',3.66),('8784','2013-04-06','11:20:00',3.73),('8784','2013-04-06','11:25:00',3.75),('8784','2013-04-06','11:30:00',3.77),('8784','2013-04-06','11:35:00',3.8),('8784','2013-04-06','11:40:00',3.78),('8784','2013-04-06','11:45:00',3.81),('8784','2013-04-06','11:50:00',3.89),('8784','2013-04-06','11:55:00',3.91),('8784','2013-04-06','12:00:00',3.93),('8784','2013-04-06','12:05:00',3.99),('8784','2013-04-06','12:10:00',3.95),('8784','2013-04-06','12:15:00',4.04),('8784','2013-04-06','12:20:00',4.07),('8784','2013-04-06','12:25:00',4.1),('8784','2013-04-06','12:30:00',4.13),('8784','2013-04-06','12:35:00',4.19),('8784','2013-04-06','12:40:00',4.18),('8784','2013-04-06','12:45:00',4.23),('8784','2013-04-06','12:50:00',4.23),('8784','2013-04-06','12:55:00',4.31),('8784','2013-04-06','13:00:00',2.32),('8784','2013-04-06','13:05:00',4.06),('8784','2013-04-06','13:10:00',4.4),('8784','2013-04-06','13:15:00',4.73),('8784','2013-04-06','13:20:00',3.13),('8784','2013-04-06','13:25:00',1.23),('8784','2013-04-06','13:30:00',4.22),('8784','2013-04-06','13:35:00',4.17),('8784','2013-04-06','13:40:00',1.26),('8784','2013-04-06','13:45:00',2.52),('8784','2013-04-06','13:50:00',4.66),('8784','2013-04-06','13:55:00',4.79),('8784','2013-04-06','14:00:00',4.69),('8784','2013-04-06','14:05:00',4.62),('8784','2013-04-06','14:10:00',4.48),('8784','2013-04-06','14:15:00',2.06),('8784','2013-04-06','14:20:00',2.37),('8784','2013-04-06','14:25:00',1.12),('8784','2013-04-06','14:30:00',3.65),('8784','2013-04-06','14:35:00',4.11),('8784','2013-04-06','14:40:00',3.76),('8784','2013-04-06','14:45:00',3.02),('8784','2013-04-06','14:50:00',3.85),('8784','2013-04-06','14:55:00',2.59),('8784','2013-04-06','15:00:00',3.48),('8784','2013-04-06','15:05:00',3.67),('8784','2013-04-06','15:10:00',3.52),('8784','2013-04-06','15:15:00',3.5),('8784','2013-04-06','15:20:00',3.46),('8784','2013-04-06','15:25:00',3.38),('8784','2013-04-06','15:30:00',3.2),('8784','2013-04-06','15:35:00',3.2),('8784','2013-04-06','15:40:00',3.16),('8784','2013-04-06','15:45:00',2.72),('8784','2013-04-06','15:50:00',2.78),('8784','2013-04-06','15:55:00',2.97),('8784','2013-04-06','16:00:00',2.74),('8784','2013-04-06','16:05:00',2.96),('8784','2013-04-06','16:10:00',2.87),('8784','2013-04-06','16:15:00',2.61),('8784','2013-04-06','16:20:00',2.13),('8784','2013-04-06','16:25:00',1.91),('8784','2013-04-06','16:30:00',2.31),('8784','2013-04-06','16:35:00',2.12),('8784','2013-04-06','16:40:00',1.8),('8784','2013-04-06','16:45:00',2.32),('8784','2013-04-06','16:50:00',2.16),('8784','2013-04-06','16:55:00',1.97),('8784','2013-04-06','17:00:00',1.89),('8784','2013-04-06','17:05:00',1.67),('8784','2013-04-06','17:10:00',1.49),('8784','2013-04-06','17:15:00',1.14),('8784','2013-04-05','08:15:00',1.19),('8784','2013-04-05','08:20:00',1.3),('8784','2013-04-05','08:55:00',1.04),('8784','2013-04-05','09:05:00',2.39),('8784','2013-04-05','09:10:00',1.41),('8784','2013-04-05','09:15:00',2.31),('8784','2013-04-05','09:20:00',2.43),('8784','2013-04-05','09:25:00',1.15),('8784','2013-04-05','09:35:00',1.17),('8784','2013-04-05','09:40:00',2.53),('8784','2013-04-05','09:45:00',1.99),('8784','2013-04-05','09:50:00',1.39),('8784','2013-04-05','09:55:00',1.05),('8784','2013-04-05','10:00:00',1.64),('8784','2013-04-05','10:05:00',1.15),('8784','2013-04-05','10:10:00',2.72),('8784','2013-04-05','10:15:00',3.08),('8784','2013-04-05','10:20:00',1.16),('8784','2013-04-05','10:25:00',2.65),('8784','2013-04-05','10:30:00',1.78),('8784','2013-04-05','10:35:00',1.76),('8784','2013-04-05','10:40:00',4.11),('8784','2013-04-05','10:45:00',1.46),('8784','2013-04-05','10:50:00',2.6),('8784','2013-04-05','10:55:00',2.7),('8784','2013-04-05','11:00:00',2.83),('8784','2013-04-05','11:05:00',3.22),('8784','2013-04-05','11:10:00',4.02),('8784','2013-04-05','11:15:00',3.68),('8784','2013-04-05','11:20:00',3.39),('8784','2013-04-05','11:25:00',3.45),('8784','2013-04-05','11:30:00',3.9),('8784','2013-04-05','11:35:00',4.44),('8784','2013-04-05','11:40:00',4.25),('8784','2013-04-05','11:45:00',3.7),('8784','2013-04-05','11:50:00',4.24),('8784','2013-04-05','11:55:00',4.32),('8784','2013-04-05','12:00:00',4.34),('8784','2013-04-05','12:05:00',2.88),('8784','2013-04-05','12:10:00',2.32),('8784','2013-04-05','12:15:00',3.44),('8784','2013-04-05','12:20:00',1.65),('8784','2013-04-05','12:25:00',2.5),('8784','2013-04-05','12:30:00',1.39),('8784','2013-04-05','12:35:00',1.52),('8784','2013-04-05','12:40:00',1.98),('8784','2013-04-05','12:45:00',3.59),('8784','2013-04-05','12:50:00',4.4),('8784','2013-04-05','12:55:00',3.61),('8784','2013-04-05','13:00:00',3.62),('8784','2013-04-05','13:05:00',3.41),('8784','2013-04-05','13:10:00',3.16),('8784','2013-04-05','13:15:00',4.35),('8784','2013-04-05','13:20:00',4),('8784','2013-04-05','13:25:00',3.67),('8784','2013-04-05','13:30:00',4),('8784','2013-04-05','13:35:00',3.76),('8784','2013-04-05','13:40:00',3.27),('8784','2013-04-05','13:45:00',3.94),('8784','2013-04-05','13:50:00',4.42),('8784','2013-04-05','13:55:00',3.41),('8784','2013-04-05','14:00:00',3.29),('8784','2013-04-05','14:05:00',4.89),('8784','2013-04-05','14:10:00',4.32),('8784','2013-04-05','14:15:00',4.11),('8784','2013-04-05','14:20:00',2.63),('8784','2013-04-05','14:25:00',3.96),('8784','2013-04-05','14:30:00',4.25),('8784','2013-04-05','14:35:00',3.63),('8784','2013-04-05','14:40:00',3.42),('8784','2013-04-05','14:45:00',3.21),('8784','2013-04-05','14:50:00',2.84),('8784','2013-04-05','14:55:00',4.22),('8784','2013-04-05','15:00:00',4.01),('8784','2013-04-05','15:05:00',4.03),('8784','2013-04-05','15:10:00',2.63),('8784','2013-04-05','15:15:00',1.75),('8784','2013-04-05','15:20:00',1.84),('8784','2013-04-05','15:25:00',1.99),('8784','2013-04-05','15:30:00',1.7),('8784','2013-04-05','15:35:00',1.34),('8784','2013-04-05','15:40:00',1.21),('8784','2013-04-05','15:45:00',1.5),('8784','2013-04-05','15:50:00',1.87),('8784','2013-04-05','15:55:00',1.77),('8784','2013-04-05','16:00:00',1.81),('8784','2013-04-05','16:05:00',1.71),('8784','2013-04-05','16:10:00',1.76),('8784','2013-04-05','16:15:00',2.03),('8784','2013-04-05','16:20:00',1.85),('8784','2013-04-05','16:25:00',1.58),('8784','2013-04-05','16:30:00',1.63),('8784','2013-04-05','16:35:00',2.11),('8784','2013-04-05','16:40:00',1.67),('8784','2013-04-05','16:45:00',2.15),('8784','2013-04-05','16:50:00',2.65),('8784','2013-04-05','16:55:00',1.4),('8784','2013-04-05','17:00:00',1.36),('8784','2013-04-05','17:05:00',1.1),('8784','2013-04-05','17:10:00',2.81),('8784','2013-04-05','17:15:00',2.32),('8784','2013-04-05','17:20:00',1.83),('8784','2013-04-05','17:25:00',2.14),('8784','2013-04-05','17:30:00',1.41),('8784','2013-04-05','17:35:00',1.77),('8784','2013-04-05','17:40:00',1.21),('8784','2013-04-05','17:50:00',1.17),('8784','2013-04-05','17:55:00',1.66),('8784','2013-04-04','08:55:00',1.47),('8784','2013-04-04','09:00:00',2.1),('8784','2013-04-04','09:05:00',1.49),('8784','2013-04-04','09:10:00',1.42),('8784','2013-04-04','09:15:00',1.4),('8784','2013-04-04','09:20:00',1.37),('8784','2013-04-04','09:25:00',1.09),('8784','2013-04-04','09:30:00',1.66),('8784','2013-04-04','09:35:00',2.68),('8784','2013-04-04','09:40:00',2.42),('8784','2013-04-04','09:45:00',2.13),('8784','2013-04-04','09:50:00',1.19),('8784','2013-04-04','09:55:00',1.35),('8784','2013-04-04','10:00:00',1.97),('8784','2013-04-04','10:05:00',2.56),('8784','2013-04-04','10:10:00',2.13),('8784','2013-04-04','10:15:00',1.69),('8784','2013-04-04','10:20:00',2),('8784','2013-04-04','10:25:00',3.68),('8784','2013-04-04','10:30:00',3.07),('8784','2013-04-04','10:35:00',2.1),('8784','2013-04-04','10:40:00',3.91),('8784','2013-04-04','10:45:00',2.13),('8784','2013-04-04','10:50:00',2.38),('8784','2013-04-04','10:55:00',3.97),('8784','2013-04-04','11:00:00',2.4),('8784','2013-04-04','11:05:00',1.33),('8784','2013-04-04','11:10:00',1.19),('8784','2013-04-04','11:15:00',1.61),('8784','2013-04-04','11:20:00',1.46),('8784','2013-04-04','11:25:00',1.14),('8784','2013-04-04','11:30:00',1.25),('8784','2013-04-04','11:35:00',1.86),('8784','2013-04-04','11:40:00',3.07),('8784','2013-04-04','11:45:00',3.53),('8784','2013-04-04','11:50:00',4.01),('8784','2013-04-04','11:55:00',3.77),('8784','2013-04-04','12:00:00',3.46),('8784','2013-04-04','12:05:00',4),('8784','2013-04-04','12:10:00',4.14),('8784','2013-04-04','12:15:00',3.98),('8784','2013-04-04','12:20:00',3.39),('8784','2013-04-04','12:25:00',2.61),('8784','2013-04-04','12:30:00',3.33),('8784','2013-04-04','12:35:00',3.75),('8784','2013-04-04','12:40:00',3.97),('8784','2013-04-04','12:45:00',3.96),('8784','2013-04-04','12:50:00',4.02),('8784','2013-04-04','12:55:00',3.86),('8784','2013-04-04','13:00:00',3.87),('8784','2013-04-04','13:05:00',3.83),('8784','2013-04-04','13:10:00',3.99),('8784','2013-04-04','13:15:00',4.1),('8784','2013-04-04','13:20:00',3.97),('8784','2013-04-04','13:25:00',4.13),('8784','2013-04-04','13:30:00',3.95),('8784','2013-04-04','13:35:00',3.57),('8784','2013-04-04','13:40:00',3.05),('8784','2013-04-04','13:45:00',3.4),('8784','2013-04-04','13:50:00',3.29),('8784','2013-04-04','13:55:00',2.54),('8784','2013-04-04','14:00:00',2.77),('8784','2013-04-04','14:05:00',3.68),('8784','2013-04-04','14:10:00',3.99),('8784','2013-04-04','14:15:00',3.9),('8784','2013-04-04','14:20:00',3.85),('8784','2013-04-04','14:25:00',3.75),('8784','2013-04-04','14:30:00',3.72),('8784','2013-04-04','14:35:00',3.47),('8784','2013-04-04','14:40:00',3.72),('8784','2013-04-04','14:45:00',3.65),('8784','2013-04-04','14:50:00',3.6),('8784','2013-04-04','14:55:00',3.57),('8784','2013-04-04','15:00:00',3.53),('8784','2013-04-04','15:05:00',3.38),('8784','2013-04-04','15:10:00',3.21),('8784','2013-04-04','15:15:00',3.21),('8784','2013-04-04','15:20:00',3.24),('8784','2013-04-04','15:25:00',3.29),('8784','2013-04-04','15:30:00',3.25),('8784','2013-04-04','15:35:00',3.15),('8784','2013-04-04','15:40:00',3.1),('8784','2013-04-04','15:45:00',3.05),('8784','2013-04-04','15:50:00',2.93),('8784','2013-04-04','15:55:00',2.89),('8784','2013-04-04','16:00:00',2.8),('8784','2013-04-04','16:05:00',2.7),('8784','2013-04-04','16:10:00',2.51),('8784','2013-04-04','16:15:00',2.43),('8784','2013-04-04','16:20:00',2.35),('8784','2013-04-04','16:25:00',2.2),('8784','2013-04-04','16:30:00',1.87),('8784','2013-04-04','16:35:00',1.83),('8784','2013-04-04','16:40:00',1.92),('8784','2013-04-04','16:45:00',1.73),('8784','2013-04-04','16:50:00',1.62),('8784','2013-04-04','16:55:00',1.85),('8784','2013-04-04','17:00:00',1.71),('8784','2013-04-04','17:05:00',1.68),('8784','2013-04-04','17:10:00',1.55),('8784','2013-04-04','17:15:00',1.38),('8784','2013-04-04','17:25:00',1.07),('8784','2013-04-04','17:55:00',1.13),('8784','2013-04-03','08:05:00',1.01),('8784','2013-04-03','08:10:00',1.11),('8784','2013-04-03','08:15:00',1.21),('8784','2013-04-03','08:20:00',1.31),('8784','2013-04-03','08:25:00',1.21),('8784','2013-04-03','08:30:00',1.58),('8784','2013-04-03','08:45:00',1.71),('8784','2013-04-03','08:50:00',1.9),('8784','2013-04-03','08:55:00',1.98),('8784','2013-04-03','09:00:00',2.05),('8784','2013-04-03','09:05:00',2.21),('8784','2013-04-03','09:10:00',2.25),('8784','2013-04-03','09:15:00',2.46),('8784','2013-04-03','09:20:00',2.29),('8784','2013-04-03','09:25:00',2.88),('8784','2013-04-03','09:30:00',2.61),('8784','2013-04-03','09:35:00',1.76),('8784','2013-04-03','09:40:00',2.85),('8784','2013-04-03','09:45:00',2.85),('8784','2013-04-03','09:50:00',2.98),('8784','2013-04-03','09:55:00',2.35),('8784','2013-04-03','10:00:00',1.9),('8784','2013-04-03','10:05:00',1.25),('8784','2013-04-03','10:10:00',1.32),('8784','2013-04-03','10:15:00',2),('8784','2013-04-03','10:20:00',3.82),('8784','2013-04-03','10:25:00',3.41),('8784','2013-04-03','10:30:00',4),('8784','2013-04-03','10:35:00',2.48),('8784','2013-04-03','10:40:00',1.77),('8784','2013-04-03','10:45:00',1.44),('8784','2013-04-03','10:50:00',1.72),('8784','2013-04-03','10:55:00',1.82),('8784','2013-04-03','11:00:00',4.5),('8784','2013-04-03','11:05:00',3.45),('8784','2013-04-03','11:10:00',2.05),('8784','2013-04-03','11:15:00',4.55),('8784','2013-04-03','11:20:00',3.78),('8784','2013-04-03','11:25:00',1.91),('8784','2013-04-03','11:30:00',2.02),('8784','2013-04-03','11:35:00',2.96),('8784','2013-04-03','11:40:00',1.68),('8784','2013-04-03','11:45:00',1.93),('8784','2013-04-03','11:50:00',4.26),('8784','2013-04-03','11:55:00',2.57),('8784','2013-04-03','12:00:00',3.48),('8784','2013-04-03','12:05:00',4.31),('8784','2013-04-03','12:10:00',2.9),('8784','2013-04-03','12:15:00',3.41),('8784','2013-04-03','12:20:00',3.89),('8784','2013-04-03','12:25:00',4.98),('8784','2013-04-03','12:30:00',4.63),('8784','2013-04-03','12:35:00',4.92),('8784','2013-04-03','12:40:00',4.83),('8784','2013-04-03','12:45:00',4.61),('8784','2013-04-03','12:50:00',4.84),('8784','2013-04-03','12:55:00',3.43),('8784','2013-04-03','13:00:00',2.98),('8784','2013-04-03','13:05:00',4.43),('8784','2013-04-03','13:10:00',3.63),('8784','2013-04-03','13:15:00',4.84),('8784','2013-04-03','13:20:00',3.19),('8784','2013-04-03','13:25:00',3.55),('8784','2013-04-03','13:30:00',3.78),('8784','2013-04-03','13:35:00',4.03),('8784','2013-04-03','13:40:00',3.94),('8784','2013-04-03','13:45:00',3.47),('8784','2013-04-03','13:50:00',2.26),('8784','2013-04-03','13:55:00',2.96),('8784','2013-04-03','14:00:00',4.11),('8784','2013-04-03','14:05:00',5.09),('8784','2013-04-03','14:10:00',4.09),('8784','2013-04-03','14:15:00',2),('8784','2013-04-03','14:20:00',3.17),('8784','2013-04-03','14:25:00',3.81),('8784','2013-04-03','14:30:00',4.62),('8784','2013-04-03','14:35:00',4.14),('8784','2013-04-03','14:40:00',2.14),('8784','2013-04-03','14:45:00',2.96),('8784','2013-04-03','14:50:00',3.85),('8784','2013-04-03','14:55:00',3.94),('8784','2013-04-03','15:00:00',3.18),('8784','2013-04-03','15:05:00',3.78),('8784','2013-04-03','15:10:00',3.87),('8784','2013-04-03','15:15:00',4.2),('8784','2013-04-03','15:20:00',3.09),('8784','2013-04-03','15:25:00',3.79),('8784','2013-04-03','15:30:00',2.23),('8784','2013-04-03','15:35:00',2.71),('8784','2013-04-03','15:40:00',3.06),('8784','2013-04-03','15:45:00',3.03),('8784','2013-04-03','15:50:00',3.78),('8784','2013-04-03','15:55:00',3.6),('8784','2013-04-03','16:00:00',3.39),('8784','2013-04-03','16:05:00',3.36),('8784','2013-04-03','16:10:00',3.03),('8784','2013-04-03','16:15:00',3.11),('8784','2013-04-03','16:20:00',3.02),('8784','2013-04-03','16:25:00',2.94),('8784','2013-04-03','16:30:00',2.87),('8784','2013-04-03','16:35:00',2.59),('8784','2013-04-03','16:40:00',2.65),('8784','2013-04-03','16:45:00',2.52),('8784','2013-04-03','16:50:00',2.46),('8784','2013-04-03','16:55:00',2.38),('8784','2013-04-03','17:00:00',2.28),('8784','2013-04-03','17:05:00',2.2),('8784','2013-04-03','17:10:00',2.1),('8784','2013-04-03','17:15:00',2.02),('8784','2013-04-03','17:20:00',1.91),('8784','2013-04-03','17:25:00',1.75),('8784','2013-04-03','17:30:00',1.73),('8784','2013-04-03','17:35:00',1.61),('8784','2013-04-03','17:40:00',1.52),('8784','2013-04-03','17:45:00',1.42),('8784','2013-04-03','17:50:00',1.31),('8784','2013-04-03','17:55:00',1.23),('8784','2013-04-03','18:00:00',1.13),('8784','2013-04-03','18:05:00',1.03),('8784','2013-04-02','08:40:00',1.7),('8784','2013-04-02','08:45:00',1.79),('8784','2013-04-02','08:50:00',1.34),('8784','2013-04-02','08:55:00',1.33),('8784','2013-04-02','09:00:00',1.98),('8784','2013-04-02','09:05:00',2.04),('8784','2013-04-02','09:10:00',1.95),('8784','2013-04-02','09:15:00',1.7),('8784','2013-04-02','09:20:00',1.8),('8784','2013-04-02','09:25:00',1.18),('8784','2013-04-02','09:30:00',1.62),('8784','2013-04-02','09:35:00',2.83),('8784','2013-04-02','09:40:00',2.76),('8784','2013-04-02','09:45:00',2.4),('8784','2013-04-02','09:50:00',2.24),('8784','2013-04-02','09:55:00',1.87),('8784','2013-04-02','10:00:00',2.13),('8784','2013-04-02','10:05:00',1.39),('8784','2013-04-02','10:10:00',1.41),('8784','2013-04-02','10:15:00',1.57),('8784','2013-04-02','10:20:00',1.84),('8784','2013-04-02','10:25:00',1.81),('8784','2013-04-02','10:35:00',3.15),('8784','2013-04-02','10:40:00',2.1),('8784','2013-04-02','10:45:00',2.37),('8784','2013-04-02','10:50:00',3.89),('8784','2013-04-02','10:55:00',1.56),('8784','2013-04-02','11:00:00',1.19),('8784','2013-04-02','11:05:00',3.14),('8784','2013-04-02','11:10:00',1.54),('8784','2013-04-02','11:15:00',1.19),('8784','2013-04-02','11:20:00',1.01),('8784','2013-04-02','11:25:00',1.2),('8784','2013-04-02','11:30:00',1.32),('8784','2013-04-02','11:35:00',1.25),('8784','2013-04-02','11:40:00',1.08),('8784','2013-04-02','11:45:00',2.57),('8784','2013-04-02','11:50:00',2.36),('8784','2013-04-02','11:55:00',1.19),('8784','2013-04-02','12:00:00',1.11),('8784','2013-04-02','12:05:00',3.22),('8784','2013-04-02','12:10:00',2.09),('8784','2013-04-02','12:15:00',2.11),('8784','2013-04-02','12:30:00',1.04),('8784','2013-04-02','12:35:00',1.87),('8784','2013-04-02','12:40:00',2.03),('8784','2013-04-02','12:45:00',2.36),('8784','2013-04-02','12:50:00',2.32),('8784','2013-04-02','12:55:00',2.3),('8784','2013-04-02','13:00:00',2.55),('8784','2013-04-02','13:05:00',2.76),('8784','2013-04-02','13:10:00',3.36),('8784','2013-04-02','13:15:00',2.59),('8784','2013-04-02','13:20:00',2.12),('8784','2013-04-02','13:25:00',3.55),('8784','2013-04-02','13:30:00',2.67),('8784','2013-04-02','13:35:00',2.06),('8784','2013-04-02','13:40:00',3.07),('8784','2013-04-02','13:45:00',2.77),('8784','2013-04-02','13:50:00',2.26),('8784','2013-04-02','13:55:00',2.11),('8784','2013-04-02','14:00:00',2.62),('8784','2013-04-02','14:05:00',2.07),('8784','2013-04-02','14:10:00',2.62),('8784','2013-04-02','14:15:00',2.35),('8784','2013-04-02','14:20:00',4.14),('8784','2013-04-02','14:25:00',4.16),('8784','2013-04-02','14:30:00',2.34),('8784','2013-04-02','14:35:00',1.97),('8784','2013-04-02','14:40:00',2.63),('8784','2013-04-02','14:45:00',2.68),('8784','2013-04-02','14:50:00',2),('8784','2013-04-02','14:55:00',1.79),('8784','2013-04-02','15:00:00',1.55),('8784','2013-04-02','15:20:00',1.01),('8784','2013-04-02','15:45:00',1.25),('8784','2013-04-02','16:00:00',1.14),('8784','2013-04-02','16:05:00',1.25),('8784','2013-04-02','16:15:00',1.15),('8784','2013-04-02','16:20:00',1.11),('8784','2013-04-02','16:30:00',1.03),('8784','2013-04-02','16:35:00',1.03),('8784','2013-04-02','17:40:00',1.01),('8784','2014-05-02','07:35:00',1.07),('8784','2014-05-02','07:40:00',1.22),('8784','2014-05-02','07:45:00',1.31),('8784','2014-05-02','07:50:00',1.39),('8784','2014-05-02','07:55:00',1.56),('8784','2014-05-02','08:00:00',1.52),('8784','2014-05-02','08:05:00',1.49),('8784','2014-05-02','08:15:00',2.49),('8784','2014-05-02','08:20:00',1.99),('8784','2014-05-02','08:25:00',1.22),('8784','2014-05-02','08:45:00',1.34),('8784','2014-05-02','08:50:00',1.98),('8784','2014-05-02','09:15:00',1.3),('8784','2014-05-02','09:20:00',1.59),('8784','2014-05-02','09:25:00',1.83),('8784','2014-05-02','09:30:00',2.09),('8784','2014-05-02','09:35:00',1.9),('8784','2014-05-02','09:40:00',1.75),('8784','2014-05-02','09:45:00',1.89),('8784','2014-05-02','09:50:00',1.74),('8784','2014-05-02','09:55:00',1.66),('8784','2014-05-02','10:00:00',2),('8784','2014-05-02','10:05:00',2.24),('8784','2014-05-02','10:10:00',2.03),('8784','2014-05-02','10:15:00',1.78),('8784','2014-05-02','10:20:00',1.62),('8784','2014-05-02','10:25:00',1.35),('8784','2014-05-02','10:40:00',1.09),('8784','2014-05-02','10:45:00',1.36),('8784','2014-05-02','10:50:00',1.14),('8784','2014-05-02','12:30:00',1.18),('8784','2014-05-02','12:35:00',1.29),('8784','2014-05-02','12:40:00',1.27),('8784','2014-05-02','12:45:00',1.62),('8784','2014-05-02','12:50:00',2.07),('8784','2014-05-02','12:55:00',1.58),('8784','2014-05-02','13:00:00',1.77),('8784','2014-05-02','13:05:00',1.97),('8784','2014-05-02','13:10:00',2.03),('8784','2014-05-02','13:15:00',2.51),('8784','2014-05-02','13:20:00',3.32),('8784','2014-05-02','13:25:00',3.74),('8784','2014-05-02','13:30:00',2.99),('8784','2014-05-02','13:35:00',2.93),('8784','2014-05-02','13:40:00',2.68),('8784','2014-05-02','13:45:00',2.22),('8784','2014-05-02','13:50:00',1.83),('8784','2014-05-02','13:55:00',1.48),('8784','2014-05-02','14:00:00',1.6),('8784','2014-05-02','14:05:00',2.52),('8784','2014-05-02','14:10:00',1.12),('8784','2014-05-02','14:30:00',1.21),('8784','2014-05-02','14:35:00',1.83),('8784','2014-05-02','14:40:00',3.07),('8784','2014-05-02','14:45:00',1.72),('8784','2014-05-02','14:50:00',1.51),('8784','2014-05-02','14:55:00',2.09),('8784','2014-05-02','15:00:00',2.66),('8784','2014-05-02','15:05:00',2.09),('8784','2014-05-02','15:10:00',4.35),('8784','2014-05-02','15:15:00',2.84),('8784','2014-05-02','15:20:00',2.88),('8784','2014-05-02','15:25:00',1.62),('8784','2014-05-02','15:30:00',1.38),('8784','2014-05-02','15:35:00',2.92),('8784','2014-05-02','15:40:00',3.76),('8784','2014-05-02','15:45:00',1.41),('8784','2014-05-02','16:00:00',1.53),('8784','2014-05-02','16:05:00',1.88),('8784','2014-05-02','16:10:00',1.21),('8784','2014-05-02','16:15:00',1.34),('8784','2014-05-02','16:20:00',2.5),('8784','2014-05-02','17:20:00',1.09),('8784','2014-05-02','17:25:00',1.28),('8784','2014-03-27','07:55:00',1.26),('8784','2014-03-27','08:00:00',1.5),('8784','2014-03-27','08:05:00',1.58),('8784','2014-03-27','09:15:00',1.03),('8784','2014-03-27','10:05:00',1.22),('8784','2014-03-27','10:10:00',1.4),('8784','2014-03-27','10:15:00',1.31),('8784','2014-03-27','10:20:00',1.81),('8784','2014-03-27','10:25:00',2.24),('8784','2014-03-27','10:30:00',2.17),('8784','2014-03-27','10:35:00',1.95),('8784','2014-03-27','10:40:00',2.21),('8784','2014-03-27','10:45:00',1.14),('8784','2014-03-27','11:10:00',3.21),('8784','2014-03-27','11:15:00',2.38),('8784','2014-03-27','11:20:00',1.24),('8784','2014-03-27','11:50:00',1.16),('8784','2014-03-27','11:55:00',1.5),('8784','2014-03-27','12:00:00',1.25),('8784','2014-03-27','12:05:00',1.14),('8784','2014-03-27','12:10:00',1.39),('8784','2014-03-27','12:15:00',1.05),('8784','2014-03-27','12:20:00',1.12),('8784','2014-03-27','13:00:00',1.02),('8784','2014-03-27','13:05:00',1.25),('8784','2014-03-27','13:10:00',1.74),('8784','2014-03-27','13:15:00',2.34),('8784','2014-03-27','13:20:00',2.49),('8784','2014-03-27','13:25:00',2.56),('8784','2014-03-27','13:30:00',2.22),('8784','2014-03-27','13:35:00',2.01),('8784','2014-03-27','13:40:00',1.91),('8784','2014-03-27','13:45:00',1.77),('8784','2014-03-27','13:50:00',2.25),('8784','2014-03-27','13:55:00',2.89),('8784','2014-03-27','14:00:00',2.15),('8784','2014-03-27','14:05:00',1.18),('8784','2014-03-27','14:15:00',2.74),('8784','2014-03-27','14:20:00',3.73),('8784','2014-03-27','14:25:00',3.95),('8784','2014-03-27','14:30:00',3.78),('8784','2014-03-27','14:35:00',2.26),('8784','2014-03-27','14:40:00',1.97),('8784','2014-03-27','14:45:00',1.84),('8784','2014-03-27','14:50:00',2.34),('8784','2014-03-27','14:55:00',1.82),('8784','2014-03-27','15:00:00',3.77),('8784','2014-03-27','15:05:00',1.43),('8784','2014-03-27','15:20:00',1.05),('8784','2014-03-27','15:25:00',2.94),('8784','2014-03-27','15:30:00',2.73),('8784','2014-03-27','15:35:00',2.65),('8784','2014-03-27','15:40:00',1.24),('8784','2014-03-27','16:05:00',1.08),('8784','2014-03-27','16:10:00',1.28),('8784','2014-03-27','16:15:00',1.1),('8784','2014-03-27','16:25:00',1.1),('8784','2014-03-27','16:30:00',1.26),('8784','2013-04-01','08:25:00',1.4),('8784','2013-04-01','08:30:00',1.36),('8784','2013-04-01','08:35:00',1.49),('8784','2013-04-01','08:40:00',1.36),('8784','2013-04-01','08:50:00',1.15),('8784','2013-04-01','08:55:00',1.52),('8784','2013-04-01','09:00:00',1.94),('8784','2013-04-01','09:05:00',2.04),('8784','2013-04-01','09:10:00',2.19),('8784','2013-04-01','09:15:00',1.76),('8784','2013-04-01','09:20:00',1.96),('8784','2013-04-01','09:25:00',1.89),('8784','2013-04-01','09:30:00',1.9),('8784','2013-04-01','09:35:00',2.19),('8784','2013-04-01','09:40:00',1.97),('8784','2013-04-01','09:45:00',2.82),('8784','2013-04-01','09:50:00',2.86),('8784','2013-04-01','09:55:00',2.74),('8784','2013-04-01','10:00:00',3.07),('8784','2013-04-01','10:05:00',3.11),('8784','2013-04-01','10:10:00',2.46),('8784','2013-04-01','10:15:00',2.87),('8784','2013-04-01','10:20:00',2.39),('8784','2013-04-01','10:25:00',3.03),('8784','2013-04-01','10:30:00',2.39),('8784','2013-04-01','10:35:00',1.39),('8784','2013-04-01','10:40:00',2),('8784','2013-04-01','10:45:00',3.8),('8784','2013-04-01','10:50:00',1.81),('8784','2013-04-01','10:55:00',2.12),('8784','2013-04-01','11:00:00',1.23),('8784','2013-04-01','11:05:00',1.55),('8784','2013-04-01','11:10:00',2.87),('8784','2013-04-01','11:15:00',2.78),('8784','2013-04-01','11:20:00',3.92),('8784','2013-04-01','11:25:00',1.92),('8784','2013-04-01','11:30:00',1.68),('8784','2013-04-01','11:35:00',1.98),('8784','2013-04-01','11:40:00',3.19),('8784','2013-04-01','11:45:00',3.15),('8784','2013-04-01','11:50:00',2.62),('8784','2013-04-01','11:55:00',2.28),('8784','2013-04-01','12:00:00',3.01),('8784','2013-04-01','12:05:00',1.89),('8784','2013-04-01','12:10:00',2.51),('8784','2013-04-01','12:15:00',2.06),('8784','2013-04-01','12:20:00',1.75),('8784','2013-04-01','12:25:00',1.95),('8784','2013-04-01','12:30:00',2.73),('8784','2013-04-01','12:35:00',2.49),('8784','2013-04-01','12:40:00',2.55),('8784','2013-04-01','12:45:00',2.86),('8784','2013-04-01','12:50:00',3.03),('8784','2013-04-01','12:55:00',3.2),('8784','2013-04-01','13:00:00',3.15),('8784','2013-04-01','13:05:00',3.35),('8784','2013-04-01','13:10:00',3),('8784','2013-04-01','13:15:00',3.18),('8784','2013-04-01','13:20:00',3.03),('8784','2013-04-01','13:25:00',2.84),('8784','2013-04-01','13:30:00',3.06),('8784','2013-04-01','13:35:00',2.79),('8784','2013-04-01','13:40:00',3.68),('8784','2013-04-01','13:45:00',3.92),('8784','2013-04-01','13:50:00',4.32),('8784','2013-04-01','13:55:00',4.15),('8784','2013-04-01','14:00:00',2.48),('8784','2013-04-01','14:05:00',1.99),('8784','2013-04-01','14:10:00',2.52),('8784','2013-04-01','14:15:00',2.77),('8784','2013-04-01','14:20:00',2.93),('8784','2013-04-01','14:25:00',4.29),('8784','2013-04-01','14:30:00',2.63),('8784','2013-04-01','14:35:00',2.26),('8784','2013-04-01','14:40:00',1.97),('8784','2013-04-01','14:45:00',2.02),('8784','2013-04-01','14:50:00',2.18),('8784','2013-04-01','14:55:00',2.31),('8784','2013-04-01','15:00:00',2.1),('8784','2013-04-01','15:05:00',2.11),('8784','2013-04-01','15:10:00',2.17),('8784','2013-04-01','15:15:00',2.32),('8784','2013-04-01','15:20:00',2.36),('8784','2013-04-01','15:25:00',2.38),('8784','2013-04-01','15:30:00',2.1),('8784','2013-04-01','15:35:00',2.65),('8784','2013-04-01','15:40:00',2.45),('8784','2013-04-01','15:45:00',2.56),('8784','2013-04-01','15:50:00',2.83),('8784','2013-04-01','15:55:00',2.13),('8784','2013-04-01','16:00:00',1.99),('8784','2013-04-01','16:05:00',1.64),('8784','2013-04-01','16:10:00',1.4),('8784','2013-04-01','16:15:00',1.14),('8784','2013-04-01','16:20:00',1.1),('8784','2013-04-01','16:25:00',1.03),('8784','2013-03-31','08:30:00',1.11),('8784','2013-03-31','08:35:00',1.14),('8784','2013-03-31','08:40:00',1.14),('8784','2013-03-31','08:45:00',1.38),('8784','2013-03-31','08:50:00',1.13),('8784','2013-03-31','08:55:00',1.24),('8784','2013-03-31','09:00:00',1.17),('8784','2013-03-31','09:05:00',1.11),('8784','2013-03-31','09:10:00',1.2),('8784','2013-03-31','09:15:00',1.56),('8784','2013-03-31','09:20:00',2.52),('8784','2013-03-31','09:25:00',2.95),('8784','2013-03-31','09:30:00',2.12),('8784','2013-03-31','09:35:00',2.24),('8784','2013-03-31','09:40:00',1.42),('8784','2013-03-31','09:45:00',2.49),('8784','2013-03-31','09:50:00',1.65),('8784','2013-03-31','09:55:00',2.06),('8784','2013-03-31','10:00:00',1.96),('8784','2013-03-31','10:15:00',1.09),('8784','2013-03-31','10:20:00',2.32),('8784','2013-03-31','10:25:00',2.51),('8784','2013-03-31','10:30:00',3.01),('8784','2013-03-31','10:35:00',3.02),('8784','2013-03-31','10:45:00',1.32),('8784','2013-03-31','10:50:00',2.15),('8784','2013-03-31','10:55:00',1.02),('8784','2013-03-31','11:10:00',1.53),('8784','2013-03-31','11:15:00',1.38),('8784','2013-03-31','11:20:00',1.25),('8784','2013-03-31','11:25:00',1.68),('8784','2013-03-31','11:30:00',1.29),('8784','2013-03-31','11:35:00',1.67),('8784','2013-03-31','11:40:00',1.71),('8784','2013-03-31','11:45:00',1.52),('8784','2013-03-31','11:50:00',1.67),('8784','2013-03-31','11:55:00',1.81),('8784','2013-03-31','12:00:00',1.68),('8784','2013-03-31','12:05:00',1.55),('8784','2013-03-31','12:10:00',1.4),('8784','2013-03-31','12:15:00',1.55),('8784','2013-03-31','12:20:00',1.38),('8784','2013-03-31','12:25:00',1.7),('8784','2013-03-31','12:30:00',2),('8784','2013-03-31','12:35:00',3.14),('8784','2013-03-31','12:40:00',3.02),('8784','2013-03-31','12:45:00',1.76),('8784','2013-03-31','12:50:00',1.84),('8784','2013-03-31','12:55:00',2.17),('8784','2013-03-31','13:00:00',2.62),('8784','2013-03-31','13:05:00',2.1),('8784','2013-03-31','13:10:00',3.04),('8784','2013-03-31','13:15:00',3.5),('8784','2013-03-31','13:20:00',3.72),('8784','2013-03-31','13:25:00',2.33),('8784','2013-03-31','13:40:00',1.87),('8784','2013-03-31','13:45:00',1.77),('8784','2013-03-31','13:50:00',2.31),('8784','2013-03-31','13:55:00',1.68),('8784','2013-03-31','14:00:00',1.98),('8784','2013-03-31','14:05:00',2.96),('8784','2013-03-31','14:10:00',2.62),('8784','2013-03-31','14:15:00',2.9),('8784','2013-03-31','14:20:00',1.67),('8784','2013-03-31','14:25:00',1.84),('8784','2013-03-31','14:30:00',3.21),('8784','2013-03-31','14:35:00',4.45),('8784','2013-03-31','14:40:00',4.59),('8784','2013-03-31','14:45:00',3.34),('8784','2013-03-31','14:50:00',3.16),('8784','2013-03-31','14:55:00',3.1),('8784','2013-03-31','15:00:00',3.37),('8784','2013-03-31','15:05:00',2.23),('8784','2013-03-31','15:10:00',3.3),('8784','2013-03-31','15:15:00',3.29),('8784','2013-03-31','15:20:00',4.08),('8784','2013-03-31','15:25:00',2.63),('8784','2013-03-31','15:30:00',2.51),('8784','2013-03-31','15:35:00',3.4),('8784','2013-03-31','15:40:00',4.08),('8784','2013-03-31','15:45:00',2.62),('8784','2013-03-31','15:50:00',1.02),('8784','2013-03-31','15:55:00',1.03),('8784','2013-03-31','16:00:00',3.11),('8784','2013-03-31','16:05:00',1.21),('8784','2013-03-31','16:10:00',1.75),('8784','2013-03-31','16:15:00',2.38),('8784','2013-03-31','16:20:00',1.88),('8784','2013-03-31','16:25:00',1.4),('8784','2013-03-31','16:30:00',1.17),('8784','2013-03-31','16:35:00',1.23),('8784','2013-03-31','16:40:00',1.42),('8784','2013-03-31','16:45:00',1.14),('8784','2013-03-31','17:00:00',1.25),('8784','2013-03-31','17:05:00',1.4),('8784','2013-03-31','17:10:00',1.22),('8784','2013-03-31','17:20:00',1.16),('8784','2013-03-31','17:25:00',1.23),('8784','2013-03-31','17:30:00',1.33),('8784','2013-03-31','17:35:00',1.26),('8784','2013-03-31','17:45:00',1.03),('8784','2013-03-31','17:50:00',1.09),('8784','2013-03-31','17:55:00',1.6),('8784','2013-03-31','18:15:00',1.33),('8784','2013-03-30','08:30:00',1.03),('8784','2013-03-30','08:35:00',1.23),('8784','2013-03-30','08:40:00',1.16),('8784','2013-03-30','08:50:00',1),('8784','2013-03-30','09:00:00',1),('8784','2013-03-30','09:05:00',1.8),('8784','2013-03-30','09:10:00',1.9),('8784','2013-03-30','09:16:00',1.95),('8784','2013-03-30','09:20:00',4.26),('8784','2013-03-30','09:25:00',1.83),('8784','2013-03-30','09:30:00',1.27),('8784','2013-03-30','09:35:00',1.42),('8784','2013-03-30','09:40:00',1.48),('8784','2013-03-30','09:45:00',1.28),('8784','2013-03-30','09:55:00',1.3),('8784','2013-03-30','10:00:00',1.95),('8784','2013-03-30','10:05:00',1.87),('8784','2013-03-30','10:10:00',2.05),('8784','2013-03-30','10:15:00',1.84),('8784','2013-03-30','10:20:00',1.6),('8784','2013-03-30','10:25:00',1.58),('8784','2013-03-30','10:30:00',1.8),('8784','2013-03-30','10:35:00',2.16),('8784','2013-03-30','10:40:00',2.58),('8784','2013-03-30','10:45:00',3.46),('8784','2013-03-30','10:50:00',3.12),('8784','2013-03-30','10:55:00',2.34),('8784','2013-03-30','11:00:00',3.48),('8784','2013-03-30','11:05:00',4.16),('8784','2013-03-30','11:10:00',4.51),('8784','2013-03-30','11:15:00',3.8),('8784','2013-03-30','11:20:00',5.2),('8784','2013-03-30','11:25:00',4.72),('8784','2013-03-30','11:30:00',2.71),('8784','2013-03-30','11:35:00',3.47),('8784','2013-03-30','11:40:00',3.14),('8784','2013-03-30','11:45:00',4.01),('8784','2013-03-30','11:50:00',4.45),('8784','2013-03-30','11:55:00',4.1),('8784','2013-03-30','12:00:00',3.99),('8784','2013-03-30','12:05:00',2.76),('8784','2013-03-30','12:10:00',2.2),('8784','2013-03-30','12:15:00',2.18),('8784','2013-03-30','12:20:00',1.95),('8784','2013-03-30','12:25:00',1.13),('8784','2013-03-30','12:30:00',1.09),('8784','2013-03-30','12:35:00',1),('8784','2013-03-30','13:10:00',2.04),('8784','2013-03-30','13:15:00',3.79),('8784','2013-03-30','13:20:00',2.25),('8784','2013-03-30','13:25:00',1.95),('8784','2013-03-30','13:30:00',1.11),('8784','2013-03-30','13:45:00',2.68),('8784','2013-03-30','13:50:00',4.38),('8784','2013-03-30','13:55:00',1.73),('8784','2013-03-30','14:00:00',2.17),('8784','2013-03-30','14:05:00',1.87),('8784','2013-03-30','14:10:00',1.17),('8784','2013-03-30','14:15:00',1.15),('8784','2013-03-30','14:20:00',1.85),('8784','2013-03-30','14:25:00',1.41),('8784','2013-03-30','14:30:00',2.15),('8784','2013-03-30','14:35:00',2.06),('8784','2013-03-30','14:40:00',1.32),('8784','2013-03-30','14:45:00',1.08),('8784','2013-03-30','14:50:00',1.54),('8784','2013-03-30','15:25:00',1.06),('8784','2013-03-29','07:20:00',1.07),('8784','2013-03-29','07:25:00',1.21),('8784','2013-03-29','07:30:00',1.13),('8784','2013-03-29','07:35:00',1.24),('8784','2013-03-29','07:40:00',1.43),('8784','2013-03-29','07:45:00',1.57),('8784','2013-03-29','07:50:00',1.17),('8784','2013-03-29','07:55:00',1.04),('8784','2013-03-29','08:00:00',1.21),('8784','2013-03-29','08:05:00',1.71),('8784','2013-03-29','08:10:00',2.1),('8784','2013-03-29','08:15:00',2.06),('8784','2013-03-29','08:20:00',2.16),('8784','2013-03-29','08:25:00',2.25),('8784','2013-03-29','08:30:00',2.34),('8784','2013-03-29','08:35:00',2.46),('8784','2013-03-29','08:40:00',2.52),('8784','2013-03-29','08:45:00',2.48),('8784','2013-03-29','08:50:00',2.54),('8784','2013-03-29','08:55:00',2.29),('8784','2013-03-29','09:00:00',2.42),('8784','2013-03-29','09:05:00',2.73),('8784','2013-03-29','09:10:00',2.73),('8784','2013-03-29','09:15:00',3.11),('8784','2013-03-29','09:20:00',3.21),('8784','2013-03-29','09:25:00',3.07),('8784','2013-03-29','09:30:00',3.61),('8784','2013-03-29','09:35:00',3.58),('8784','2013-03-29','09:40:00',3.58),('8784','2013-03-29','09:45:00',3.14),('8784','2013-03-29','09:50:00',3.33),('8784','2013-03-29','09:55:00',3.54),('8784','2013-03-29','10:00:00',3.42),('8784','2013-03-29','10:05:00',3.42),('8784','2013-03-29','10:10:00',2.95),('8784','2013-03-29','10:15:00',3.48),('8784','2013-03-29','10:20:00',3.26),('8784','2013-03-29','10:25:00',2.93),('8784','2013-03-29','10:30:00',3.18),('8784','2013-03-29','10:35:00',2.83),('8784','2013-03-29','10:40:00',3.67),('8784','2013-03-29','10:45:00',3.19),('8784','2013-03-29','10:50:00',3.02),('8784','2013-03-29','10:55:00',3.56),('8784','2013-03-29','11:00:00',4.03),('8784','2013-03-29','11:05:00',3.99),('8784','2013-03-29','11:10:00',2.71),('8784','2013-03-29','11:15:00',1.7),('8784','2013-03-29','11:20:00',4.1),('8784','2013-03-29','11:25:00',4.55),('8784','2013-03-29','11:30:00',4.33),('8784','2013-03-29','11:35:00',4.18),('8784','2013-03-29','11:40:00',4.23),('8784','2013-03-29','11:45:00',4.15),('8784','2013-03-29','11:50:00',4.28),('8784','2013-03-29','11:55:00',4.3),('8784','2013-03-29','12:00:00',4.29),('8784','2013-03-29','12:05:00',4.37),('8784','2013-03-29','12:10:00',4.32),('8784','2013-03-29','12:15:00',4),('8784','2013-03-29','12:20:00',4.28),('8784','2013-03-29','12:25:00',4),('8784','2013-03-29','12:30:00',3.96),('8784','2013-03-29','12:35:00',4.1),('8784','2013-03-29','12:40:00',4.06),('8784','2013-03-29','12:45:00',3.72),('8784','2013-03-29','12:50:00',4.27),('8784','2013-03-29','12:55:00',3.95),('8784','2013-03-29','13:00:00',4.13),('8784','2013-03-29','13:05:00',3.54),('8784','2013-03-29','13:10:00',4.03),('8784','2013-03-29','13:15:00',3.62),('8784','2013-03-29','13:20:00',3.65),('8784','2013-03-29','13:25:00',4.21),('8784','2013-03-29','13:30:00',3.77),('8784','2013-03-29','13:35:00',3.39),('8784','2013-03-29','13:40:00',3.37),('8784','2013-03-29','13:45:00',3.62),('8784','2013-03-29','13:50:00',3.4),('8784','2013-03-29','13:55:00',3.51),('8784','2013-03-29','14:00:00',3.73),('8784','2013-03-29','14:05:00',3.01),('8784','2013-03-29','14:10:00',2.5),('8784','2013-03-29','14:15:00',2.5),('8784','2013-03-29','14:20:00',2.51),('8784','2013-03-29','14:25:00',2.6),('8784','2013-03-29','14:30:00',2.19),('8784','2013-03-29','14:35:00',2.16),('8784','2013-03-29','14:40:00',2.11),('8784','2013-03-29','14:45:00',1.94),('8784','2013-03-29','14:50:00',1.9),('8784','2013-03-29','14:55:00',1.85),('8784','2013-03-29','15:00:00',1.67),('8784','2013-03-29','15:05:00',1.66),('8784','2013-03-29','15:10:00',1.58),('8784','2013-03-29','15:15:00',1.55),('8784','2013-03-29','15:20:00',1.45),('8784','2013-03-29','15:25:00',1.33),('8784','2013-03-29','15:30:00',1.24),('8784','2013-03-29','15:35:00',1.18),('8784','2013-03-29','15:40:00',1.12),('8784','2013-03-29','15:45:00',1.09),('8784','2013-03-29','15:50:00',1.19),('8784','2013-03-29','15:55:00',1.37),('8784','2013-03-29','16:00:00',1.71),('8784','2013-03-29','16:05:00',1.6),('8784','2013-03-29','16:10:00',1.17),('8784','2013-03-29','16:15:00',1.06),('8784','2013-03-29','16:25:00',1.09),('8784','2013-03-29','16:30:00',1.12),('8784','2013-03-29','16:35:00',1.23),('8784','2013-03-29','16:40:00',1.97),('8784','2013-03-29','16:45:00',1.62),('8784','2013-03-29','16:50:00',1.19),('8784','2013-03-29','16:55:00',1),('8784','2013-03-29','17:00:00',1.14),('8784','2013-03-28','09:05:00',1.03),('8784','2013-03-28','09:10:00',1.88),('8784','2013-03-28','09:15:00',3.14),('8784','2013-03-28','09:20:00',1.64),('8784','2013-03-28','09:25:00',1.63),('8784','2013-03-28','09:30:00',1.19),('8784','2013-03-28','09:35:00',1.03),('8784','2013-03-28','09:45:00',1.15),('8784','2013-03-28','09:50:00',1.19),('8784','2013-03-28','09:55:00',1.1),('8784','2013-03-28','10:00:00',1.17),('8784','2013-03-28','10:05:00',1.02),('8784','2013-03-28','11:00:00',1.04),('8784','2013-03-28','11:35:00',1.29),('8784','2013-03-28','11:40:00',1.69),('8784','2013-03-28','11:45:00',1.28),('8784','2013-03-28','11:50:00',1.3),('8784','2013-03-28','11:55:00',2.41),('8784','2013-03-28','12:00:00',1.55),('8784','2013-03-28','12:10:00',1.11),('8784','2013-03-28','12:15:00',1.39),('8784','2013-03-28','12:20:00',1.1),('8784','2013-03-28','12:30:00',1.26),('8784','2013-03-28','12:35:00',1.01),('8784','2013-03-28','12:40:00',1.48),('8784','2013-03-28','12:45:00',1.85),('8784','2013-03-28','12:50:00',3.54),('8784','2013-03-28','12:55:00',3.71),('8784','2013-03-28','13:00:00',3.35),('8784','2013-03-28','13:05:00',4.77),('8784','2013-03-28','13:10:00',3.92),('8784','2013-03-28','13:15:00',3.26),('8784','2013-03-28','13:20:00',2.85),('8784','2013-03-28','13:25:00',2.25),('8784','2013-03-28','13:30:00',2.7),('8784','2013-03-28','13:35:00',3.15),('8784','2013-03-28','13:40:00',2.39),('8784','2013-03-28','13:45:00',2.65),('8784','2013-03-28','13:50:00',2.79),('8784','2013-03-28','13:55:00',1.78),('8784','2013-03-28','14:00:00',1.96),('8784','2013-03-28','14:05:00',2.15),('8784','2013-03-28','14:10:00',1.4),('8784','2013-03-28','14:15:00',1.53),('8784','2013-03-28','14:20:00',1.86),('8784','2013-03-28','14:25:00',1.64),('8784','2013-03-28','14:30:00',2.49),('8784','2013-03-28','14:35:00',1.71),('8784','2013-03-28','14:40:00',1.15),('8784','2013-03-28','14:45:00',1.24),('8784','2013-03-28','14:50:00',1.06),('8784','2013-03-28','15:00:00',1.29),('8784','2013-03-28','15:05:00',1.47),('8784','2013-03-28','15:10:00',2.64),('8784','2013-03-28','15:15:00',1.89),('8784','2013-03-28','15:20:00',1.87),('8784','2013-03-28','15:25:00',1.05),('8784','2013-03-28','15:30:00',1.46),('8784','2013-03-28','15:35:00',2.26),('8784','2013-03-28','15:40:00',1.72),('8784','2013-03-28','15:45:00',2.08),('8784','2013-03-28','15:50:00',1.49),('8784','2013-03-28','15:55:00',2.77),('8784','2013-03-28','16:00:00',1.28),('8784','2013-03-28','16:05:00',1.08),('8784','2013-03-28','16:10:00',1.78),('8784','2013-03-28','16:35:00',1.59),('8784','2013-03-28','16:40:00',1.09),('8784','2013-03-28','16:45:00',1.02),('8784','2013-03-28','17:00:00',1.46),('8784','2013-03-28','17:05:00',1.24),('8784','2013-03-28','17:10:00',1.01),('8784','2013-03-27','07:20:00',1.02),('8784','2013-03-27','07:25:00',1.11),('8784','2013-03-27','07:30:00',1.17),('8784','2013-03-27','07:40:00',1.27),('8784','2013-03-27','07:45:00',1.1),('8784','2013-03-27','07:55:00',1.32),('8784','2013-03-27','08:00:00',1.49),('8784','2013-03-27','08:05:00',1.51),('8784','2013-03-27','08:10:00',1.4),('8784','2013-03-27','08:15:00',1.53),('8784','2013-03-27','08:20:00',1.36),('8784','2013-03-27','08:25:00',1.64),('8784','2013-03-27','08:30:00',2.08),('8784','2013-03-27','08:35:00',1.72),('8784','2013-03-27','08:40:00',1.33),('8784','2013-03-27','08:45:00',1.4),('8784','2013-03-27','08:50:00',1.85),('8784','2013-03-27','08:55:00',1.38),('8784','2013-03-27','09:00:00',1.52),('8784','2013-03-27','09:05:00',1.2),('8784','2013-03-27','09:15:00',1.86),('8784','2013-03-27','09:20:00',1.65),('8784','2013-03-27','09:25:00',1.14),('8784','2013-03-27','09:40:00',1.04),('8784','2013-03-27','09:45:00',1.83),('8784','2013-03-27','09:50:00',1.72),('8784','2013-03-27','09:55:00',1.52),('8784','2013-03-27','10:00:00',1.58),('8784','2013-03-27','10:10:00',1.5),('8784','2013-03-27','10:15:00',1.98),('8784','2013-03-27','10:20:00',1.52),('8784','2013-03-27','10:25:00',2.03),('8784','2013-03-27','10:30:00',2.6),('8784','2013-03-27','10:35:00',2.09),('8784','2013-03-27','10:40:00',2.45),('8784','2013-03-27','10:45:00',2.23),('8784','2013-03-27','10:50:00',2.45),('8784','2013-03-27','10:55:00',2.23),('8784','2013-03-27','11:00:00',1.92),('8784','2013-03-27','11:05:00',1.73),('8784','2013-03-27','11:10:00',1.81),('8784','2013-03-27','11:15:00',1.94),('8784','2013-03-27','11:20:00',1.98),('8784','2013-03-27','11:25:00',1.82),('8784','2013-03-27','11:30:00',2.03),('8784','2013-03-27','11:35:00',1.92),('8784','2013-03-27','11:40:00',1.74),('8784','2013-03-27','11:45:00',1.9),('8784','2013-03-27','11:50:00',1.82),('8784','2013-03-27','11:55:00',2.87),('8784','2013-03-27','12:00:00',2.83),('8784','2013-03-27','12:05:00',2.64),('8784','2013-03-27','12:10:00',2.26),('8784','2013-03-27','12:15:00',1.78),('8784','2013-03-27','12:20:00',1.97),('8784','2013-03-27','12:25:00',1.83),('8784','2013-03-27','12:30:00',4.05),('8784','2013-03-27','12:35:00',4.39),('8784','2013-03-27','12:40:00',4.23),('8784','2013-03-27','12:45:00',3.95),('8784','2013-03-27','12:50:00',3.04),('8784','2013-03-27','12:55:00',1.77),('8784','2013-03-27','13:00:00',1.6),('8784','2013-03-27','13:05:00',1.7),('8784','2013-03-27','13:10:00',2.41),('8784','2013-03-27','13:15:00',1.8),('8784','2013-03-27','13:20:00',1.41),('8784','2013-03-27','13:25:00',1.48),('8784','2013-03-27','13:30:00',1.75),('8784','2013-03-27','13:35:00',2.45),('8784','2013-03-27','13:40:00',1.79),('8784','2013-03-27','13:45:00',2.15),('8784','2013-03-27','13:50:00',2.35),('8784','2013-03-27','13:55:00',2.03),('8784','2013-03-27','14:00:00',1.88),('8784','2013-03-27','14:05:00',1.64),('8784','2013-03-27','14:10:00',1.69),('8784','2013-03-27','14:15:00',1.89),('8784','2013-03-27','14:20:00',2.37),('8784','2013-03-27','14:25:00',1.91),('8784','2013-03-27','14:30:00',1.59),('8784','2013-03-27','14:35:00',1.87),('8784','2013-03-27','14:40:00',2.62),('8784','2013-03-27','14:45:00',2.39),('8784','2013-03-27','14:50:00',1.79),('8784','2013-03-27','14:55:00',1.3),('8784','2013-03-27','15:00:00',1.08),('8784','2013-03-27','15:05:00',1.42),('8784','2013-03-27','15:10:00',1.47),('8784','2013-03-27','15:15:00',1.11),('8784','2013-03-27','15:20:00',1.09),('8784','2013-03-27','15:25:00',1.13),('8784','2013-03-27','16:40:00',1.06),('8784','2013-03-27','16:45:00',1.22),('8784','2013-03-27','16:50:00',1.08),('8784','2013-03-27','16:55:00',1.23),('8784','2013-03-27','17:00:00',1.25),('8784','2013-03-27','17:05:00',1.41),('8784','2013-03-27','17:10:00',1.15),('8784','2013-03-26','07:45:00',1.29),('8784','2013-03-26','07:50:00',1.83),('8784','2013-03-26','07:55:00',1.71),('8784','2013-03-26','08:30:00',1.04),('8784','2013-03-26','08:35:00',1.59),('8784','2013-03-26','08:40:00',1.62),('8784','2013-03-26','09:10:00',1.28),('8784','2013-03-26','09:15:00',1.97),('8784','2013-03-26','09:20:00',1.13),('8784','2013-03-26','09:50:00',1.41),('8784','2013-03-26','09:55:00',2.6),('8784','2013-03-26','10:00:00',1.21),('8784','2013-03-26','10:50:00',1.07),('8784','2013-03-26','10:55:00',1.06),('8784','2013-03-26','11:00:00',1.26),('8784','2013-03-26','11:05:00',1.19),('8784','2013-03-26','11:10:00',2.47),('8784','2013-03-26','11:15:00',1.73),('8784','2013-03-26','11:20:00',1.89),('8784','2013-03-26','11:45:00',1.3),('8784','2013-03-26','11:50:00',2.44),('8784','2013-03-26','11:55:00',1.17),('8784','2013-03-26','12:00:00',1.51),('8784','2013-03-26','12:05:00',1.35),('8784','2013-03-26','12:10:00',1.48),('8784','2013-03-26','12:15:00',1.56),('8784','2013-03-26','12:20:00',1.68),('8784','2013-03-26','12:25:00',2.35),('8784','2013-03-26','12:30:00',2.03),('8784','2013-03-26','12:35:00',3.28),('8784','2013-03-26','12:40:00',2.01),('8784','2013-03-26','12:45:00',2.67),('8784','2013-03-26','12:50:00',1.84),('8784','2013-03-26','12:55:00',1.21),('8784','2013-03-26','13:00:00',2.01),('8784','2013-03-26','13:05:00',2.59),('8784','2013-03-26','13:10:00',2.77),('8784','2013-03-26','13:15:00',1.84),('8784','2013-03-26','13:20:00',1.98),('8784','2013-03-26','13:25:00',2.25),('8784','2013-03-26','13:30:00',1.78),('8784','2013-03-26','13:35:00',2.28),('8784','2013-03-26','13:40:00',2.43),('8784','2013-03-26','13:45:00',2.14),('8784','2013-03-26','13:50:00',1.81),('8784','2013-03-26','13:55:00',1.69),('8784','2013-03-26','14:00:00',1.66),('8784','2013-03-26','14:05:00',1.62),('8784','2013-03-26','14:10:00',1.7),('8784','2013-03-26','14:15:00',1.58),('8784','2013-03-26','14:20:00',1.34),('8784','2013-03-26','14:25:00',1.23),('8784','2013-03-26','15:35:00',1.03),('8784','2013-03-25','08:20:00',1.16),('8784','2013-03-25','08:25:00',2.28),('8784','2013-03-25','08:30:00',1.48),('8784','2013-03-25','08:50:00',1.03),('8784','2013-03-25','08:55:00',1.31),('8784','2013-03-25','09:00:00',1.19),('8784','2013-03-25','09:05:00',1.18),('8784','2013-03-25','09:10:00',1.32),('8784','2013-03-25','09:15:00',1.26),('8784','2013-03-25','09:20:00',2.32),('8784','2013-03-25','09:25:00',2.67),('8784','2013-03-25','09:30:00',1.63),('8784','2013-03-25','09:35:00',1.11),('8784','2013-03-25','09:45:00',1.14),('8784','2013-03-25','09:50:00',4.56),('8784','2013-03-25','09:55:00',4.03),('8784','2013-03-25','10:00:00',1.31),('8784','2013-03-25','10:05:00',1.21),('8784','2013-03-25','10:10:00',1.24),('8784','2013-03-25','10:15:00',1.2),('8784','2013-03-25','10:20:00',1.66),('8784','2013-03-25','10:25:00',2.84),('8784','2013-03-25','10:30:00',2.29),('8784','2013-03-25','10:35:00',1.98),('8784','2013-03-25','10:40:00',1.99),('8784','2013-03-25','10:45:00',2.7),('8784','2013-03-25','10:50:00',3.02),('8784','2013-03-25','10:55:00',3.6),('8784','2013-03-25','11:00:00',2.49),('8784','2013-03-25','11:05:00',2.35),('8784','2013-03-25','11:10:00',2.56),('8784','2013-03-25','11:15:00',2.71),('8784','2013-03-25','11:20:00',3.99),('8784','2013-03-25','11:25:00',4.03),('8784','2013-03-25','11:30:00',5.11),('8784','2013-03-25','11:35:00',3.23),('8784','2013-03-25','11:40:00',1.42),('8784','2013-03-25','11:45:00',1.73),('8784','2013-03-25','11:50:00',1.99),('8784','2013-03-25','11:55:00',3.51),('8784','2013-03-25','12:00:00',4.44),('8784','2013-03-25','12:05:00',4.45),('8784','2013-03-25','12:10:00',4.01),('8784','2013-03-25','12:15:00',3.49),('8784','2013-03-25','12:20:00',2.99),('8784','2013-03-25','12:25:00',4.18),('8784','2013-03-25','12:30:00',3.37),('8784','2013-03-25','12:35:00',3.02),('8784','2013-03-25','12:40:00',2.77),('8784','2013-03-25','12:45:00',2.63),('8784','2013-03-25','12:50:00',2.95),('8784','2013-03-25','12:55:00',3.31),('8784','2013-03-25','13:00:00',3.38),('8784','2013-03-25','13:05:00',4.89),('8784','2013-03-25','13:10:00',4.66),('8784','2013-03-25','13:15:00',4.37),('8784','2013-03-25','13:20:00',3.88),('8784','2013-03-25','13:25:00',1.75),('8784','2013-03-25','13:30:00',2.06),('8784','2013-03-25','13:35:00',1.23),('8784','2013-03-25','13:40:00',1.31),('8784','2013-03-25','13:45:00',2.51),('8784','2013-03-25','13:50:00',2.17),('8784','2013-03-25','13:55:00',1.93),('8784','2013-03-25','14:00:00',1.05),('8784','2013-03-25','14:05:00',1.39),('8784','2013-03-25','14:10:00',3.51),('8784','2013-03-25','14:15:00',1.93),('8784','2013-03-25','14:20:00',2.64),('8784','2013-03-25','14:25:00',3.57),('8784','2013-03-25','14:30:00',2.35),('8784','2013-03-25','14:35:00',1.79),('8784','2013-03-25','14:40:00',1.46),('8784','2013-03-25','14:45:00',2.2),('8784','2013-03-25','14:50:00',1.8),('8784','2013-03-25','14:55:00',2.92),('8784','2013-03-25','15:00:00',2.78),('8784','2013-03-25','15:05:00',2.79),('8784','2013-03-25','15:10:00',3.3),('8784','2013-03-25','15:15:00',2.53),('8784','2013-03-25','15:20:00',2.16),('8784','2013-03-25','15:25:00',2.52),('8784','2013-03-25','15:30:00',2.76),('8784','2013-03-25','15:35:00',2.09),('8784','2013-03-25','15:40:00',3.15),('8784','2013-03-25','15:45:00',2.34),('8784','2013-03-25','15:50:00',1.44),('8784','2013-03-25','15:55:00',1.97),('8784','2013-03-25','16:00:00',2.42),('8784','2013-03-25','16:05:00',1.08),('8784','2013-03-25','16:10:00',1.33),('8784','2013-03-25','16:30:00',1.44),('8784','2013-03-25','16:35:00',2.09),('8784','2013-03-25','16:40:00',1.71),('8784','2013-03-25','16:45:00',1.03),('8784','2013-03-24','07:40:00',1.01),('8784','2013-03-24','07:45:00',1.09),('8784','2013-03-24','07:50:00',1.27),('8784','2013-03-24','07:55:00',1.44),('8784','2013-03-24','08:00:00',1.69),('8784','2013-03-24','08:05:00',1.77),('8784','2013-03-24','08:10:00',1.81),('8784','2013-03-24','08:15:00',1.93),('8784','2013-03-24','08:20:00',2.02),('8784','2013-03-24','08:25:00',2.1),('8784','2013-03-24','08:30:00',2.17),('8784','2013-03-24','08:35:00',2.25),('8784','2013-03-24','08:40:00',2.32),('8784','2013-03-24','08:45:00',2.37),('8784','2013-03-24','08:50:00',2.42),('8784','2013-03-24','08:55:00',2.5),('8784','2013-03-24','09:00:00',2.56),('8784','2013-03-24','09:05:00',2.64),('8784','2013-03-24','09:10:00',2.73),('8784','2013-03-24','09:15:00',2.79),('8784','2013-03-24','09:20:00',2.86),('8784','2013-03-24','09:25:00',2.91),('8784','2013-03-24','09:30:00',2.97),('8784','2013-03-24','09:35:00',2.97),('8784','2013-03-24','09:40:00',3.07),('8784','2013-03-24','09:45:00',3.14),('8784','2013-03-24','09:50:00',3.19),('8784','2013-03-24','09:55:00',3.23),('8784','2013-03-24','10:00:00',3.3),('8784','2013-03-24','10:05:00',3.36),('8784','2013-03-24','10:10:00',3.42),('8784','2013-03-24','10:15:00',3.47),('8784','2013-03-24','10:20:00',3.5),('8784','2013-03-24','10:25:00',3.54),('8784','2013-03-24','10:30:00',3.59),('8784','2013-03-24','10:35:00',3.61),('8784','2013-03-24','10:40:00',3.63),('8784','2013-03-24','10:45:00',3.65),('8784','2013-03-24','10:50:00',3.65),('8784','2013-03-24','10:55:00',3.69),('8784','2013-03-24','11:00:00',3.71),('8784','2013-03-24','11:05:00',3.75),('8784','2013-03-24','11:10:00',3.76),('8784','2013-03-24','11:15:00',3.75),('8784','2013-03-24','11:20:00',3.8),('8784','2013-03-24','11:25:00',3.84),('8784','2013-03-24','11:30:00',3.83),('8784','2013-03-24','11:35:00',3.84),('8784','2013-03-24','11:40:00',3.84),('8784','2013-03-24','11:45:00',3.83),('8784','2013-03-24','11:50:00',3.86),('8784','2013-03-24','11:55:00',3.87),('8784','2013-03-24','12:00:00',3.88),('8784','2013-03-24','12:05:00',3.91),('8784','2013-03-24','12:10:00',3.94),('8784','2013-03-24','12:15:00',3.98),('8784','2013-03-24','12:20:00',4),('8784','2013-03-24','12:25:00',4.01),('8784','2013-03-24','12:30:00',4),('8784','2013-03-24','12:35:00',3.97),('8784','2013-03-24','12:40:00',4.01),('8784','2013-03-24','12:45:00',4.02),('8784','2013-03-24','12:50:00',3.97),('8784','2013-03-24','12:55:00',3.95),('8784','2013-03-24','13:00:00',3.9),('8784','2013-03-24','13:05:00',3.92),('8784','2013-03-24','13:10:00',3.9),('8784','2013-03-24','13:15:00',3.88),('8784','2013-03-24','13:20:00',3.88),('8784','2013-03-24','13:25:00',3.81),('8784','2013-03-24','13:30:00',3.76),('8784','2013-03-24','13:35:00',3.73),('8784','2013-03-24','13:40:00',3.71),('8784','2013-03-24','13:45:00',3.68),('8784','2013-03-24','13:50:00',3.62),('8784','2013-03-24','13:55:00',3.6),('8784','2013-03-24','14:00:00',3.54),('8784','2013-03-24','14:05:00',3.48),('8784','2013-03-24','14:10:00',3.43),('8784','2013-03-24','14:15:00',3.39),('8784','2013-03-24','14:20:00',3.32),('8784','2013-03-24','14:25:00',3.26),('8784','2013-03-24','14:30:00',3.16),('8784','2013-03-24','14:35:00',3.05),('8784','2013-03-24','14:40:00',3),('8784','2013-03-24','14:45:00',2.96),('8784','2013-03-24','14:50:00',2.82),('8784','2013-03-24','14:55:00',2.84),('8784','2013-03-24','15:00:00',2.73),('8784','2013-03-24','15:05:00',2.66),('8784','2013-03-24','15:10:00',2.49),('8784','2013-03-24','15:15:00',2.73),('8784','2013-03-24','15:20:00',2.61),('8784','2013-03-24','15:25:00',2.43),('8784','2013-03-24','15:30:00',2.19),('8784','2013-03-24','15:35:00',2.17),('8784','2013-03-24','15:40:00',2.13),('8784','2013-03-24','15:45:00',1.78),('8784','2013-03-24','15:50:00',1.27),('8784','2013-03-24','15:55:00',1.23),('8784','2013-03-24','16:00:00',1.24),('8784','2013-03-24','16:05:00',1.45),('8784','2013-03-24','16:10:00',1.08),('8784','2013-03-24','16:15:00',1.48),('8784','2013-03-24','16:20:00',1.21),('8784','2013-03-24','16:25:00',1.1),('8784','2013-03-24','16:30:00',1.23),('8784','2013-03-24','16:35:00',1.07),('8784','2013-03-23','07:30:00',1.01),('8784','2013-03-23','07:35:00',1.03),('8784','2013-03-23','07:40:00',1.19),('8784','2013-03-23','07:45:00',1.18),('8784','2013-03-23','07:50:00',1.3),('8784','2013-03-23','07:55:00',1.48),('8784','2013-03-23','08:00:00',1.61),('8784','2013-03-23','08:05:00',1.77),('8784','2013-03-23','08:10:00',1.85),('8784','2013-03-23','08:15:00',1.92),('8784','2013-03-23','08:20:00',2),('8784','2013-03-23','08:25:00',2.08),('8784','2013-03-23','08:30:00',2.12),('8784','2013-03-23','08:35:00',2.21),('8784','2013-03-23','08:40:00',2.33),('8784','2013-03-23','08:45:00',2.41),('8784','2013-03-23','08:50:00',2.47),('8784','2013-03-23','08:55:00',2.61),('8784','2013-03-23','09:00:00',2.69),('8784','2013-03-23','09:05:00',2.77),('8784','2013-03-23','09:10:00',2.81),('8784','2013-03-23','09:15:00',2.87),('8784','2013-03-23','09:20:00',2.9),('8784','2013-03-23','09:25:00',3.01),('8784','2013-03-23','09:30:00',3.1),('8784','2013-03-23','09:35:00',3.16),('8784','2013-03-23','09:40:00',3.08),('8784','2013-03-23','09:45:00',3.19),('8784','2013-03-23','09:50:00',3.27),('8784','2013-03-23','09:55:00',3.41),('8784','2013-03-23','10:00:00',3.41),('8784','2013-03-23','10:05:00',2.63),('8784','2013-03-23','10:10:00',3.27),('8784','2013-03-23','10:15:00',3.5),('8784','2013-03-23','10:20:00',3.52),('8784','2013-03-23','10:25:00',3.53),('8784','2013-03-23','10:30:00',3.69),('8784','2013-03-23','10:35:00',3.74),('8784','2013-03-23','10:40:00',3.73),('8784','2013-03-23','10:45:00',3.69),('8784','2013-03-23','10:50:00',3.66),('8784','2013-03-23','10:55:00',3.62),('8784','2013-03-23','11:00:00',3.54),('8784','2013-03-23','11:05:00',3.26),('8784','2013-03-23','11:10:00',2.95),('8784','2013-03-23','11:15:00',3.21),('8784','2013-03-23','11:20:00',3.53),('8784','2013-03-23','11:25:00',3.69),('8784','2013-03-23','11:30:00',3.68),('8784','2013-03-23','11:35:00',3.89),('8784','2013-03-23','11:40:00',3.88),('8784','2013-03-23','11:45:00',3.87),('8784','2013-03-23','11:50:00',3.69),('8784','2013-03-23','11:55:00',3.88),('8784','2013-03-23','12:00:00',3.94),('8784','2013-03-23','12:05:00',3.88),('8784','2013-03-23','12:10:00',3.92),('8784','2013-03-23','12:15:00',4.05),('8784','2013-03-23','12:20:00',4.07),('8784','2013-03-23','12:25:00',3.95),('8784','2013-03-23','12:30:00',3.98),('8784','2013-03-23','12:35:00',3.97),('8784','2013-03-23','12:40:00',3.85),('8784','2013-03-23','12:45:00',3.95),('8784','2013-03-23','12:50:00',4),('8784','2013-03-23','12:55:00',3.85),('8784','2013-03-23','13:00:00',3.17),('8784','2013-03-23','13:05:00',3.94),('8784','2013-03-23','13:10:00',3.92),('8784','2013-03-23','13:15:00',3.78),('8784','2013-03-23','13:20:00',3.83),('8784','2013-03-23','13:25:00',3.69),('8784','2013-03-23','13:30:00',3.57),('8784','2013-03-23','13:35:00',3.74),('8784','2013-03-23','13:40:00',3.69),('8784','2013-03-23','13:45:00',3.68),('8784','2013-03-23','13:50:00',3.68),('8784','2013-03-23','13:55:00',3.55),('8784','2013-03-23','14:00:00',3.51),('8784','2013-03-23','14:05:00',3.52),('8784','2013-03-23','14:10:00',3.38),('8784','2013-03-23','14:15:00',3.27),('8784','2013-03-23','14:20:00',3.37),('8784','2013-03-23','14:25:00',3.3),('8784','2013-03-23','14:30:00',3.28),('8784','2013-03-23','14:35:00',3.2),('8784','2013-03-23','14:40:00',3.1),('8784','2013-03-23','14:45:00',2.93),('8784','2013-03-23','14:50:00',2.89),('8784','2013-03-23','14:55:00',2.95),('8784','2013-03-23','15:00:00',2.83),('8784','2013-03-23','15:05:00',2.64),('8784','2013-03-23','15:10:00',2.72),('8784','2013-03-23','15:15:00',2.53),('8784','2013-03-23','15:20:00',2.55),('8784','2013-03-23','15:25:00',2.51),('8784','2013-03-23','15:30:00',2.3),('8784','2013-03-23','15:35:00',2.22),('8784','2013-03-23','15:40:00',2.16),('8784','2013-03-23','15:45:00',1.98),('8784','2013-03-23','15:50:00',1.88),('8784','2013-03-23','15:55:00',1.84),('8784','2013-03-23','16:00:00',1.7),('8784','2013-03-23','16:05:00',1.56),('8784','2013-03-23','16:10:00',1.94),('8784','2013-03-23','16:15:00',1.73),('8784','2013-03-23','16:20:00',1.48),('8784','2013-03-23','16:25:00',1.48),('8784','2013-03-23','16:30:00',1.14),('8784','2013-03-23','16:35:00',1.24),('8784','2013-03-23','16:40:00',1.07),('8784','2013-03-23','16:45:00',1.06),('8784','2013-03-23','17:00:00',1.03),('8784','2013-03-23','17:05:00',1.04),('8784','2014-03-26','07:25:00',1.09),('8784','2014-03-26','07:30:00',1.19),('8784','2014-03-26','07:35:00',1.28),('8784','2014-03-26','07:40:00',1.37),('8784','2014-03-26','07:45:00',1.47),('8784','2014-03-26','07:50:00',1.57),('8784','2014-03-26','07:55:00',1.66),('8784','2014-03-26','08:00:00',1.76),('8784','2014-03-26','08:05:00',1.89),('8784','2014-03-26','08:10:00',1.99),('8784','2014-03-26','08:15:00',2.2),('8784','2014-03-26','08:20:00',2.04),('8784','2014-03-26','08:25:00',1.28),('8784','2014-03-26','08:30:00',1.16),('8784','2014-03-26','08:40:00',1.13),('8784','2014-03-26','08:45:00',1.23),('8784','2014-03-26','08:50:00',1.46),('8784','2014-03-26','08:55:00',1.29),('8784','2014-03-26','09:00:00',1.43),('8784','2014-03-26','09:05:00',1.35),('8784','2014-03-26','09:10:00',1.61),('8784','2014-03-26','09:15:00',1.32),('8784','2014-03-26','09:20:00',1.08),('8784','2014-03-26','09:25:00',2.15),('8784','2014-03-26','09:30:00',3.32),('8784','2014-03-26','09:35:00',3.28),('8784','2014-03-26','09:40:00',3.31),('8784','2014-03-26','09:45:00',3.35),('8784','2014-03-26','09:50:00',3.41),('8784','2014-03-26','09:55:00',2.57),('8784','2014-03-26','10:00:00',3.79),('8784','2014-03-26','10:05:00',1.72),('8784','2014-03-26','10:10:00',4.26),('8784','2014-03-26','10:15:00',4.34),('8784','2014-03-26','10:20:00',2.48),('8784','2014-03-26','10:25:00',4.02),('8784','2014-03-26','10:30:00',3.38),('8784','2014-03-26','10:35:00',1.82),('8784','2014-03-26','10:45:00',1.72),('8784','2014-03-26','10:50:00',2.94),('8784','2014-03-26','10:55:00',5.05),('8784','2014-03-26','11:00:00',3.73),('8784','2014-03-26','11:05:00',1.23),('8784','2014-03-26','11:10:00',4.21),('8784','2014-03-26','11:15:00',5.17),('8784','2014-03-26','11:20:00',2.06),('8784','2014-03-26','11:25:00',1.36),('8784','2014-03-26','11:30:00',1.81),('8784','2014-03-26','11:35:00',1.86),('8784','2014-03-26','11:40:00',2.07),('8784','2014-03-26','11:45:00',3.86),('8784','2014-03-26','11:50:00',4.21),('8784','2014-03-26','11:55:00',5.05),('8784','2014-03-26','12:00:00',4.89),('8784','2014-03-26','12:05:00',4.29),('8784','2014-03-26','12:10:00',3.97),('8784','2014-03-26','12:15:00',1.72),('8784','2014-03-26','12:20:00',2),('8784','2014-03-26','12:25:00',1.87),('8784','2014-03-26','12:30:00',1.83),('8784','2014-03-26','12:35:00',1.75),('8784','2014-03-26','12:40:00',2.24),('8784','2014-03-26','12:45:00',2.24),('8784','2014-03-26','12:50:00',1.7),('8784','2014-03-26','12:55:00',1.33),('8784','2014-03-26','13:00:00',1.45),('8784','2014-03-26','13:05:00',1.3),('8784','2014-03-26','13:10:00',1.16),('8784','2014-03-26','13:20:00',2.85),('8784','2014-03-26','13:25:00',4.55),('8784','2014-03-26','13:30:00',3.68),('8784','2014-03-26','13:35:00',1.87),('8784','2014-03-26','13:40:00',1.26),('8784','2014-03-26','13:45:00',1),('8784','2014-03-26','13:55:00',1.38),('8784','2014-03-26','14:00:00',3.01),('8784','2014-03-26','14:05:00',4.45),('8784','2014-03-26','14:10:00',4.03),('8784','2014-03-26','14:15:00',1.18),('8784','2014-03-26','14:20:00',1.03),('8784','2014-03-26','14:45:00',2.26),('8784','2014-03-26','14:50:00',3.2),('8784','2014-03-26','14:55:00',3.4),('8784','2014-03-26','15:00:00',3.08),('8784','2014-03-26','15:05:00',3.05),('8784','2014-03-26','15:10:00',3.08),('8784','2014-03-26','15:15:00',3.18),('8784','2014-03-26','15:20:00',2.9),('8784','2014-03-26','15:25:00',2.97),('8784','2014-03-26','15:30:00',3.06),('8784','2014-03-26','15:35:00',2.89),('8784','2014-03-26','15:40:00',2.37),('8784','2014-03-26','15:45:00',2.3),('8784','2014-03-26','15:50:00',1.88),('8784','2014-03-26','15:55:00',1.6),('8784','2014-03-26','16:00:00',1.34),('8784','2014-03-26','16:05:00',1.28),('8784','2014-03-26','16:10:00',1.44),('8784','2014-03-26','16:15:00',1.56),('8784','2014-03-26','16:20:00',1.13),('8784','2013-03-22','07:30:00',1.08),('8784','2013-03-22','07:35:00',1.15),('8784','2013-03-22','07:40:00',1.25),('8784','2013-03-22','07:45:00',1.34),('8784','2013-03-22','07:50:00',1.43),('8784','2013-03-22','07:55:00',1.51),('8784','2013-03-22','08:00:00',1.59),('8784','2013-03-22','08:05:00',1.69),('8784','2013-03-22','08:10:00',1.8),('8784','2013-03-22','08:15:00',1.89),('8784','2013-03-22','08:20:00',1.99),('8784','2013-03-22','08:25:00',2.08),('8784','2013-03-22','08:30:00',2.16),('8784','2013-03-22','08:35:00',2.26),('8784','2013-03-22','08:40:00',2.33),('8784','2013-03-22','08:45:00',2.42),('8784','2013-03-22','08:50:00',2.48),('8784','2013-03-22','08:55:00',2.54),('8784','2013-03-22','09:00:00',2.61),('8784','2013-03-22','09:05:00',2.69),('8784','2013-03-22','09:10:00',2.77),('8784','2013-03-22','09:15:00',2.81),('8784','2013-03-22','09:20:00',2.87),('8784','2013-03-22','09:25:00',2.94),('8784','2013-03-22','09:30:00',3.02),('8784','2013-03-22','09:35:00',3.09),('8784','2013-03-22','09:40:00',3.13),('8784','2013-03-22','09:45:00',3.23),('8784','2013-03-22','09:50:00',3.21),('8784','2013-03-22','09:55:00',3.32),('8784','2013-03-22','10:00:00',3.4),('8784','2013-03-22','10:05:00',3.46),('8784','2013-03-22','10:10:00',3.47),('8784','2013-03-22','10:15:00',3.49),('8784','2013-03-22','10:20:00',3.59),('8784','2013-03-22','10:25:00',3.68),('8784','2013-03-22','10:30:00',3.73),('8784','2013-03-22','10:35:00',3.75),('8784','2013-03-22','10:40:00',3.79),('8784','2013-03-22','10:45:00',3.81),('8784','2013-03-22','10:50:00',3.86),('8784','2013-03-22','10:55:00',3.88),('8784','2013-03-22','11:00:00',3.92),('8784','2013-03-22','11:05:00',3.91),('8784','2013-03-22','11:10:00',3.95),('8784','2013-03-22','11:15:00',3.98),('8784','2013-03-22','11:20:00',4),('8784','2013-03-22','11:25:00',3.98),('8784','2013-03-22','11:30:00',4.05),('8784','2013-03-22','11:35:00',4.03),('8784','2013-03-22','11:40:00',4.12),('8784','2013-03-22','11:45:00',4.11),('8784','2013-03-22','11:50:00',4.13),('8784','2013-03-22','11:55:00',4.13),('8784','2013-03-22','12:00:00',4.14),('8784','2013-03-22','12:05:00',4.14),('8784','2013-03-22','12:10:00',4.15),('8784','2013-03-22','12:15:00',4.13),('8784','2013-03-22','12:20:00',4.14),('8784','2013-03-22','12:25:00',4.16),('8784','2013-03-22','12:30:00',4.15),('8784','2013-03-22','12:35:00',4.16),('8784','2013-03-22','12:40:00',4.16),('8784','2013-03-22','12:45:00',4.13),('8784','2013-03-22','12:50:00',3.98),('8784','2013-03-22','12:55:00',3.98),('8784','2013-03-22','13:00:00',4.09),('8784','2013-03-22','13:05:00',4.05),('8784','2013-03-22','13:10:00',4.1),('8784','2013-03-22','13:15:00',4.07),('8784','2013-03-22','13:20:00',4.01),('8784','2013-03-22','13:25:00',3.75),('8784','2013-03-22','13:30:00',3.71),('8784','2013-03-22','13:35:00',3.89),('8784','2013-03-22','13:40:00',3.36),('8784','2013-03-22','13:45:00',3.53),('8784','2013-03-22','13:50:00',3.85),('8784','2013-03-22','13:55:00',3.76),('8784','2013-03-22','14:00:00',3.68),('8784','2013-03-22','14:05:00',3.63),('8784','2013-03-22','14:10:00',3.6),('8784','2013-03-22','14:15:00',3.54),('8784','2013-03-22','14:20:00',3.49),('8784','2013-03-22','14:25:00',3.45),('8784','2013-03-22','14:30:00',3.39),('8784','2013-03-22','14:35:00',3.32),('8784','2013-03-22','14:40:00',3.25),('8784','2013-03-22','14:45:00',3.19),('8784','2013-03-22','14:50:00',3.13),('8784','2013-03-22','14:55:00',3.06),('8784','2013-03-22','15:00:00',2.98),('8784','2013-03-22','15:05:00',2.91),('8784','2013-03-22','15:10:00',2.56),('8784','2013-03-22','15:15:00',2.13),('8784','2013-03-22','15:20:00',2.03),('8784','2013-03-22','15:25:00',2.15),('8784','2013-03-22','15:30:00',2.05),('8784','2013-03-22','15:35:00',2.26),('8784','2013-03-22','15:40:00',2.14),('8784','2013-03-22','15:45:00',1.9),('8784','2013-03-22','15:50:00',2.05),('8784','2013-03-22','15:55:00',1.79),('8784','2013-03-22','16:00:00',1.35),('8784','2013-03-22','16:05:00',1.4),('8784','2013-03-22','16:10:00',1.58),('8784','2013-03-22','16:15:00',1.84),('8784','2013-03-22','16:20:00',1.48),('8784','2013-03-22','16:25:00',1.51),('8784','2013-03-22','16:30:00',1.61),('8784','2013-03-22','16:35:00',1.58),('8784','2013-03-22','16:40:00',1.52),('8784','2013-03-22','16:45:00',1.38),('8784','2013-03-22','16:50:00',1.31),('8784','2013-03-22','16:55:00',1.23),('8784','2013-03-22','17:00:00',1.1),('8784','2013-03-21','07:40:00',1.26),('8784','2013-03-21','07:45:00',1.42),('8784','2013-03-21','07:50:00',1.54),('8784','2013-03-21','08:10:00',1.11),('8784','2013-03-21','08:15:00',1.2),('8784','2013-03-21','08:20:00',1.95),('8784','2013-03-21','08:25:00',1.9),('8784','2013-03-21','08:30:00',1.87),('8784','2013-03-21','08:35:00',2.34),('8784','2013-03-21','08:40:00',2.59),('8784','2013-03-21','08:45:00',2.64),('8784','2013-03-21','08:50:00',2.13),('8784','2013-03-21','08:55:00',2.67),('8784','2013-03-21','09:00:00',2.8),('8784','2013-03-21','09:05:00',3.13),('8784','2013-03-21','09:10:00',3.34),('8784','2013-03-21','09:15:00',2.41),('8784','2013-03-21','09:20:00',2.23),('8784','2013-03-21','09:25:00',1.99),('8784','2013-03-21','09:30:00',2.24),('8784','2013-03-21','09:35:00',3.2),('8784','2013-03-21','09:40:00',3.09),('8784','2013-03-21','09:45:00',3.43),('8784','2013-03-21','09:50:00',3.48),('8784','2013-03-21','09:55:00',3.55),('8784','2013-03-21','10:00:00',3.59),('8784','2013-03-21','10:05:00',3.65),('8784','2013-03-21','10:10:00',3.69),('8784','2013-03-21','10:15:00',3.73),('8784','2013-03-21','10:20:00',3.75),('8784','2013-03-21','10:25:00',3.8),('8784','2013-03-21','10:30:00',3.86),('8784','2013-03-21','10:35:00',3.92),('8784','2013-03-21','10:40:00',3.93),('8784','2013-03-21','10:45:00',3.91),('8784','2013-03-21','10:50:00',3.93),('8784','2013-03-21','10:55:00',3.71),('8784','2013-03-21','11:00:00',4.02),('8784','2013-03-21','11:05:00',4.08),('8784','2013-03-21','11:10:00',4.09),('8784','2013-03-21','11:15:00',4.14),('8784','2013-03-21','11:20:00',4.16),('8784','2013-03-21','11:25:00',4.22),('8784','2013-03-21','11:30:00',4.24),('8784','2013-03-21','11:35:00',4.25),('8784','2013-03-21','11:40:00',4.26),('8784','2013-03-21','11:45:00',4.29),('8784','2013-03-21','11:50:00',4.31),('8784','2013-03-21','11:55:00',4.33),('8784','2013-03-21','12:00:00',4.33),('8784','2013-03-21','12:05:00',4.34),('8784','2013-03-21','12:10:00',4.33),('8784','2013-03-21','12:15:00',4.34),('8784','2013-03-21','12:20:00',4.31),('8784','2013-03-21','12:25:00',4.32),('8784','2013-03-21','12:30:00',4.31),('8784','2013-03-21','12:35:00',4.28),('8784','2013-03-21','12:40:00',4.28),('8784','2013-03-21','12:45:00',4.25),('8784','2013-03-21','12:50:00',4.23),('8784','2013-03-21','12:55:00',4.24),('8784','2013-03-21','13:00:00',4.2),('8784','2013-03-21','13:05:00',4.17),('8784','2013-03-21','13:10:00',4.14),('8784','2013-03-21','13:15:00',4.12),('8784','2013-03-21','13:20:00',4.09),('8784','2013-03-21','13:25:00',4.02),('8784','2013-03-21','13:30:00',4),('8784','2013-03-21','13:35:00',3.98),('8784','2013-03-21','13:40:00',3.94),('8784','2013-03-21','13:45:00',3.9),('8784','2013-03-21','13:50:00',3.86),('8784','2013-03-21','13:55:00',3.81),('8784','2013-03-21','14:00:00',3.74),('8784','2013-03-21','14:05:00',3.65),('8784','2013-03-21','14:10:00',3.61),('8784','2013-03-21','14:15:00',3.57),('8784','2013-03-21','14:20:00',3.51),('8784','2013-03-21','14:25:00',3.45),('8784','2013-03-21','14:30:00',3.38),('8784','2013-03-21','14:35:00',3.32),('8784','2013-03-21','14:40:00',3.25),('8784','2013-03-21','14:45:00',3.21),('8784','2013-03-21','14:50:00',3.16),('8784','2013-03-21','14:55:00',3.08),('8784','2013-03-21','15:00:00',3.01),('8784','2013-03-21','15:05:00',2.94),('8784','2013-03-21','15:10:00',2.85),('8784','2013-03-21','15:15:00',2.79),('8784','2013-03-21','15:20:00',2.72),('8784','2013-03-21','15:25:00',2.64),('8784','2013-03-21','15:30:00',2.55),('8784','2013-03-21','15:35:00',2.47),('8784','2013-03-21','15:40:00',2.37),('8784','2013-03-21','15:45:00',2.29),('8784','2013-03-21','15:50:00',2.2),('8784','2013-03-21','15:55:00',2.11),('8784','2013-03-21','16:00:00',2.02),('8784','2013-03-21','16:05:00',1.93),('8784','2013-03-21','16:10:00',1.8),('8784','2013-03-21','16:15:00',1.74),('8784','2013-03-21','16:20:00',1.66),('8784','2013-03-21','16:25:00',1.54),('8784','2013-03-21','16:30:00',1.44),('8784','2013-03-21','16:35:00',1.35),('8784','2013-03-21','16:40:00',1.23),('8784','2013-03-21','16:45:00',1.17),('8784','2013-03-21','16:50:00',1.08),('8784','2013-03-20','07:30:00',1.07),('8784','2013-03-20','07:35:00',1.16),('8784','2013-03-20','07:40:00',1.19),('8784','2013-03-20','07:45:00',1.26),('8784','2013-03-20','07:50:00',1.3),('8784','2013-03-20','07:55:00',1.59),('8784','2013-03-20','08:00:00',1.26),('8784','2013-03-20','08:05:00',1.53),('8784','2013-03-20','08:10:00',1.72),('8784','2013-03-20','08:15:00',1.82),('8784','2013-03-20','08:20:00',1.89),('8784','2013-03-20','08:25:00',2),('8784','2013-03-20','08:30:00',2.14),('8784','2013-03-20','08:35:00',2.23),('8784','2013-03-20','08:40:00',2.18),('8784','2013-03-20','08:45:00',2.29),('8784','2013-03-20','08:50:00',2.38),('8784','2013-03-20','08:55:00',2.35),('8784','2013-03-20','09:00:00',2.39),('8784','2013-03-20','09:05:00',3.12),('8784','2013-03-20','09:10:00',2.67),('8784','2013-03-20','09:15:00',2.77),('8784','2013-03-20','09:20:00',2.94),('8784','2013-03-20','09:25:00',2.94),('8784','2013-03-20','09:30:00',2.98),('8784','2013-03-20','09:35:00',2.87),('8784','2013-03-20','09:40:00',3.11),('8784','2013-03-20','09:45:00',3.18),('8784','2013-03-20','09:50:00',3.23),('8784','2013-03-20','09:55:00',3.23),('8784','2013-03-20','10:00:00',3.35),('8784','2013-03-20','10:05:00',3.19),('8784','2013-03-20','10:10:00',2.88),('8784','2013-03-20','10:15:00',3.13),('8784','2013-03-20','10:20:00',2.42),('8784','2013-03-20','10:25:00',2.58),('8784','2013-03-20','10:30:00',3.02),('8784','2013-03-20','10:35:00',3.95),('8784','2013-03-20','10:40:00',3),('8784','2013-03-20','10:45:00',2.71),('8784','2013-03-20','10:50:00',3.21),('8784','2013-03-20','10:55:00',2.95),('8784','2013-03-20','11:00:00',3.03),('8784','2013-03-20','11:05:00',3.48),('8784','2013-03-20','11:10:00',2.52),('8784','2013-03-20','11:15:00',2.47),('8784','2013-03-20','11:20:00',2.84),('8784','2013-03-20','11:25:00',2.68),('8784','2013-03-20','11:30:00',2.52),('8784','2013-03-20','11:35:00',2.79),('8784','2013-03-20','11:40:00',2.27),('8784','2013-03-20','11:45:00',2.19),('8784','2013-03-20','11:50:00',2.14),('8784','2013-03-20','11:55:00',2.34),('8784','2013-03-20','12:00:00',2.31),('8784','2013-03-20','12:05:00',2.53),('8784','2013-03-20','12:10:00',2.07),('8784','2013-03-20','12:15:00',1.83),('8784','2013-03-20','12:20:00',1.68),('8784','2013-03-20','12:25:00',1.42),('8784','2013-03-20','12:30:00',1.16),('8784','2013-03-20','12:35:00',1.5),('8784','2013-03-20','12:40:00',1.06),('8784','2013-03-20','12:45:00',1.17),('8784','2013-03-20','12:50:00',1.6),('8784','2013-03-20','12:55:00',1.9),('8784','2013-03-20','13:00:00',2.02),('8784','2013-03-20','13:05:00',1.56),('8784','2013-03-20','13:10:00',1.56),('8784','2013-03-20','13:15:00',1.29),('8784','2013-03-20','13:20:00',1.38),('8784','2013-03-20','13:25:00',1.47),('8784','2013-03-20','13:30:00',1.6),('8784','2013-03-20','13:35:00',1.52),('8784','2013-03-20','13:40:00',1.91),('8784','2013-03-20','13:45:00',2.18),('8784','2013-03-20','13:50:00',1.84),('8784','2013-03-20','13:55:00',1.72),('8784','2013-03-20','14:00:00',1.72),('8784','2013-03-20','14:05:00',1.47),('8784','2013-03-20','14:10:00',1.39),('8784','2013-03-20','14:15:00',1.87),('8784','2013-03-20','14:20:00',2.26),('8784','2013-03-20','14:25:00',2.08),('8784','2013-03-20','14:30:00',1.83),('8784','2013-03-20','14:35:00',1.5),('8784','2013-03-20','14:40:00',1.2),('8784','2013-03-20','14:45:00',1.17),('8784','2013-03-19','07:35:00',1.03),('8784','2013-03-19','07:40:00',1.14),('8784','2013-03-19','07:45:00',1.24),('8784','2013-03-19','07:50:00',1.35),('8784','2013-03-19','07:55:00',1.33),('8784','2013-03-19','08:00:00',1.01),('8784','2013-03-19','08:05:00',1.33),('8784','2013-03-19','08:10:00',1.66),('8784','2013-03-19','08:15:00',1.8),('8784','2013-03-19','08:20:00',1.87),('8784','2013-03-19','08:25:00',1.93),('8784','2013-03-19','08:30:00',2.06),('8784','2013-03-19','08:35:00',1.65),('8784','2013-03-19','08:40:00',2.1),('8784','2013-03-19','08:45:00',2.36),('8784','2013-03-19','08:50:00',2.43),('8784','2013-03-19','08:55:00',2.5),('8784','2013-03-19','09:00:00',2.56),('8784','2013-03-19','09:05:00',2.65),('8784','2013-03-19','09:10:00',2.72),('8784','2013-03-19','09:15:00',2.83),('8784','2013-03-19','09:20:00',2.04),('8784','2013-03-19','09:25:00',2.74),('8784','2013-03-19','09:30:00',3.07),('8784','2013-03-19','09:35:00',3.08),('8784','2013-03-19','09:40:00',3.22),('8784','2013-03-19','09:45:00',3.24),('8784','2013-03-19','09:50:00',2.97),('8784','2013-03-19','09:55:00',3),('8784','2013-03-19','10:00:00',2.75),('8784','2013-03-19','10:05:00',3.12),('8784','2013-03-19','10:10:00',3.56),('8784','2013-03-19','10:15:00',3.59),('8784','2013-03-19','10:20:00',3.65),('8784','2013-03-19','10:25:00',3.37),('8784','2013-03-19','10:30:00',3.74),('8784','2013-03-19','10:35:00',3.79),('8784','2013-03-19','10:40:00',3.8),('8784','2013-03-19','10:45:00',3.86),('8784','2013-03-19','10:50:00',3.83),('8784','2013-03-19','10:55:00',4.01),('8784','2013-03-19','11:00:00',4.01),('8784','2013-03-19','11:05:00',4.01),('8784','2013-03-19','11:10:00',3.92),('8784','2013-03-19','11:15:00',4.1),('8784','2013-03-19','11:20:00',4.09),('8784','2013-03-19','11:25:00',4.09),('8784','2013-03-19','11:30:00',4.09),('8784','2013-03-19','11:35:00',2.52),('8784','2013-03-19','11:40:00',3.8),('8784','2013-03-19','11:45:00',3.78),('8784','2013-03-19','11:50:00',4.35),('8784','2013-03-19','11:55:00',4.25),('8784','2013-03-19','12:00:00',4.2),('8784','2013-03-19','12:05:00',4.16),('8784','2013-03-19','12:10:00',4.16),('8784','2013-03-19','12:15:00',3.96),('8784','2013-03-19','12:20:00',4.18),('8784','2013-03-19','12:25:00',4.11),('8784','2013-03-19','12:30:00',4.07),('8784','2013-03-19','12:35:00',4.13),('8784','2013-03-19','12:40:00',4.13),('8784','2013-03-19','12:45:00',4.09),('8784','2013-03-19','12:50:00',4.12),('8784','2013-03-19','12:55:00',4.1),('8784','2013-03-19','13:00:00',4.08),('8784','2013-03-19','13:05:00',4.03),('8784','2013-03-19','13:10:00',4),('8784','2013-03-19','13:15:00',3.96),('8784','2013-03-19','13:20:00',3.94),('8784','2013-03-19','13:25:00',3.91),('8784','2013-03-19','13:30:00',3.89),('8784','2013-03-19','13:35:00',3.84),('8784','2013-03-19','13:40:00',3.74),('8784','2013-03-19','13:45:00',3.74),('8784','2013-03-19','13:50:00',3.72),('8784','2013-03-19','13:55:00',3.62),('8784','2013-03-19','14:00:00',3.63),('8784','2013-03-19','14:05:00',3.57),('8784','2013-03-19','14:10:00',3.52),('8784','2013-03-19','14:15:00',3.46),('8784','2013-03-19','14:20:00',3.42),('8784','2013-03-19','14:25:00',3.38),('8784','2013-03-19','14:30:00',3.31),('8784','2013-03-19','14:35:00',3.24),('8784','2013-03-19','14:40:00',3.19),('8784','2013-03-19','14:45:00',3.12),('8784','2013-03-19','14:50:00',3.06),('8784','2013-03-19','14:55:00',3),('8784','2013-03-19','15:00:00',2.93),('8784','2013-03-19','15:05:00',2.84),('8784','2013-03-19','15:10:00',2.77),('8784','2013-03-19','15:15:00',2.69),('8784','2013-03-19','15:20:00',2.64),('8784','2013-03-19','15:25:00',2.54),('8784','2013-03-19','15:30:00',2.48),('8784','2013-03-19','15:35:00',2.4),('8784','2013-03-19','15:40:00',2.32),('8784','2013-03-19','15:45:00',2.22),('8784','2013-03-19','15:50:00',2.14),('8784','2013-03-19','15:55:00',2.05),('8784','2013-03-19','16:00:00',1.96),('8784','2013-03-19','16:05:00',1.87),('8784','2013-03-19','16:10:00',1.78),('8784','2013-03-19','16:15:00',1.68),('8784','2013-03-19','16:20:00',1.58),('8784','2013-03-19','16:25:00',1.5),('8784','2013-03-19','16:30:00',1.43),('8784','2013-03-19','16:35:00',1.34),('8784','2013-03-19','16:40:00',1.23),('8784','2013-03-19','16:45:00',1),('8784','2013-03-18','08:45:00',1.03),('8784','2013-03-18','09:55:00',1.08),('8784','2013-03-18','10:00:00',1.34),('8784','2013-03-18','10:05:00',1.6),('8784','2013-03-18','10:10:00',1.6),('8784','2013-03-18','10:15:00',1.38),('8784','2013-03-18','10:20:00',1.65),('8784','2013-03-18','10:25:00',2),('8784','2013-03-18','10:30:00',1.91),('8784','2013-03-18','10:35:00',1.61),('8784','2013-03-18','10:40:00',1.53),('8784','2013-03-18','10:45:00',1.6),('8784','2013-03-18','10:50:00',1.51),('8784','2013-03-18','10:55:00',1.26),('8784','2013-03-18','11:00:00',1.37),('8784','2013-03-18','11:05:00',1.51),('8784','2013-03-18','11:10:00',1.72),('8784','2013-03-18','11:15:00',1.88),('8784','2013-03-18','11:20:00',1.93),('8784','2013-03-18','11:25:00',2.04),('8784','2013-03-18','11:30:00',2.5),('8784','2013-03-18','11:35:00',2.1),('8784','2013-03-18','11:40:00',1.92),('8784','2013-03-18','11:45:00',1.64),('8784','2013-03-18','11:50:00',1.35),('8784','2013-03-18','11:55:00',1.62),('8784','2013-03-18','12:00:00',1.68),('8784','2013-03-18','12:05:00',2.95),('8784','2013-03-18','12:10:00',2.69),('8784','2013-03-18','12:15:00',3.17),('8784','2013-03-18','12:20:00',2.99),('8784','2013-03-18','12:25:00',2.22),('8784','2013-03-18','12:30:00',3.36),('8784','2013-03-18','12:35:00',3.96),('8784','2013-03-18','12:40:00',2.96),('8784','2013-03-18','12:45:00',2.79),('8784','2013-03-18','12:50:00',3.76),('8784','2013-03-18','12:55:00',4.03),('8784','2013-03-18','13:00:00',3.64),('8784','2013-03-18','13:05:00',1.74),('8784','2013-03-18','13:10:00',1.29),('8784','2013-03-18','13:20:00',1.2),('8784','2013-03-18','13:25:00',2.12),('8784','2013-03-18','13:30:00',1.42),('8784','2013-03-18','13:35:00',1.28),('8784','2013-03-18','13:40:00',2.21),('8784','2013-03-18','13:45:00',1.95),('8784','2013-03-18','13:50:00',1.79),('8784','2013-03-18','13:55:00',1.62),('8784','2013-03-18','14:00:00',1.82),('8784','2013-03-18','14:05:00',2.72),('8784','2013-03-18','14:10:00',2.44),('8784','2013-03-18','14:15:00',1.32),('8784','2013-03-18','14:20:00',1.31),('8784','2013-03-18','14:25:00',1.83),('8784','2013-03-18','14:35:00',1.21),('8784','2013-03-18','14:40:00',1.28),('8784','2013-03-18','14:45:00',1.14),('8784','2013-03-18','15:00:00',1.15),('8784','2013-03-17','08:15:00',1.09),('8784','2013-03-17','08:20:00',1.23),('8784','2013-03-17','08:25:00',1.61),('8784','2013-03-17','08:30:00',1.44),('8784','2013-03-17','08:35:00',1.25),('8784','2013-03-17','08:40:00',1.3),('8784','2013-03-17','08:45:00',1.54),('8784','2013-03-17','08:50:00',1.49),('8784','2013-03-17','08:55:00',1.41),('8784','2013-03-17','09:00:00',1.38),('8784','2013-03-17','09:05:00',1.59),('8784','2013-03-17','09:10:00',1.84),('8784','2013-03-17','09:15:00',1.99),('8784','2013-03-17','09:20:00',1.65),('8784','2013-03-17','09:25:00',1.4),('8784','2013-03-17','09:30:00',1.57),('8784','2013-03-17','09:35:00',1.71),('8784','2013-03-17','09:40:00',1.67),('8784','2013-03-17','09:45:00',1.7),('8784','2013-03-17','09:50:00',1.9),('8784','2013-03-17','09:55:00',2.04),('8784','2013-03-17','10:00:00',2.27),('8784','2013-03-17','10:05:00',1.87),('8784','2013-03-17','10:10:00',1.86),('8784','2013-03-17','10:15:00',2.02),('8784','2013-03-17','10:20:00',2.05),('8784','2013-03-17','10:25:00',2.14),('8784','2013-03-17','10:30:00',2.07),('8784','2013-03-17','10:35:00',1.99),('8784','2013-03-17','10:40:00',1.89),('8784','2013-03-17','10:45:00',1.99),('8784','2013-03-17','10:50:00',1.88),('8784','2013-03-17','10:55:00',1.76),('8784','2013-03-17','11:00:00',1.72),('8784','2013-03-17','11:05:00',1.47),('8784','2013-03-17','11:10:00',1.44),('8784','2013-03-17','11:15:00',1.61),('8784','2013-03-17','11:20:00',1.84),('8784','2013-03-17','11:25:00',1.86),('8784','2013-03-17','11:30:00',1.68),('8784','2013-03-17','11:35:00',1.66),('8784','2013-03-17','11:40:00',1.58),('8784','2013-03-17','11:45:00',1.46),('8784','2013-03-17','11:50:00',1.35),('8784','2013-03-17','11:55:00',1.2),('8784','2013-03-17','12:00:00',1.15),('8784','2013-03-17','12:05:00',1.18),('8784','2013-03-17','12:10:00',1.55),('8784','2013-03-17','12:15:00',2.09),('8784','2013-03-17','12:20:00',2.53),('8784','2013-03-17','12:25:00',3.43),('8784','2013-03-17','12:30:00',3.56),('8784','2013-03-17','12:35:00',2.62),('8784','2013-03-17','12:40:00',2.75),('8784','2013-03-17','12:45:00',2.53),('8784','2013-03-17','12:50:00',2.27),('8784','2013-03-17','12:55:00',1.88),('8784','2013-03-17','13:00:00',2.2),('8784','2013-03-17','13:05:00',2.38),('8784','2013-03-17','13:10:00',2.66),('8784','2013-03-17','13:15:00',2.61),('8784','2013-03-17','13:20:00',2.18),('8784','2013-03-17','13:25:00',1.95),('8784','2013-03-17','13:30:00',2.83),('8784','2013-03-17','13:35:00',2.86),('8784','2013-03-17','13:40:00',2.12),('8784','2013-03-17','13:45:00',1.94),('8784','2013-03-17','13:50:00',1.55),('8784','2013-03-17','13:55:00',2.39),('8784','2013-03-17','14:00:00',2.21),('8784','2013-03-17','14:05:00',2.3),('8784','2013-03-17','14:10:00',2.67),('8784','2013-03-17','14:15:00',2.66),('8784','2013-03-17','14:20:00',2.85),('8784','2013-03-17','14:25:00',2.37),('8784','2013-03-17','14:30:00',2.35),('8784','2013-03-17','14:35:00',1.99),('8784','2013-03-17','14:40:00',1.5),('8784','2013-03-17','14:45:00',1.38),('8784','2013-03-17','14:50:00',1.2),('8784','2013-03-17','14:55:00',1.3),('8784','2013-03-17','15:00:00',1.67),('8784','2013-03-17','15:05:00',1.83),('8784','2013-03-17','15:10:00',2.33),('8784','2013-03-17','15:15:00',2.18),('8784','2013-03-17','15:20:00',2.66),('8784','2013-03-17','15:25:00',2.42),('8784','2013-03-17','15:30:00',1.5),('8784','2013-03-17','15:35:00',2.04),('8784','2013-03-17','15:40:00',1.69),('8784','2013-03-17','15:45:00',1.39),('8784','2013-03-17','16:45:00',1.19),('8784','2013-03-16','08:05:00',1.04),('8784','2013-03-16','08:10:00',1.72),('8784','2013-03-16','08:15:00',1.99),('8784','2013-03-16','08:20:00',2.13),('8784','2013-03-16','08:25:00',2.12),('8784','2013-03-16','08:30:00',2.08),('8784','2013-03-16','08:35:00',2.23),('8784','2013-03-16','08:40:00',2.29),('8784','2013-03-16','08:45:00',2.32),('8784','2013-03-16','08:50:00',2.53),('8784','2013-03-16','08:55:00',2.72),('8784','2013-03-16','09:00:00',2.7),('8784','2013-03-16','09:05:00',2.75),('8784','2013-03-16','09:10:00',2.57),('8784','2013-03-16','09:15:00',2.92),('8784','2013-03-16','09:20:00',2.73),('8784','2013-03-16','09:25:00',1.7),('8784','2013-03-16','09:30:00',2.58),('8784','2013-03-16','09:35:00',3.35),('8784','2013-03-16','09:40:00',2.87),('8784','2013-03-16','09:45:00',3.1),('8784','2013-03-16','09:50:00',3.44),('8784','2013-03-16','09:55:00',3.54),('8784','2013-03-16','10:00:00',2.82),('8784','2013-03-16','10:05:00',2.56),('8784','2013-03-16','10:10:00',3.27),('8784','2013-03-16','10:15:00',2.39),('8784','2013-03-16','10:20:00',2.24),('8784','2013-03-16','10:25:00',2.71),('8784','2013-03-16','10:30:00',2.32),('8784','2013-03-16','10:35:00',3.52),('8784','2013-03-16','10:40:00',3.95),('8784','2013-03-16','10:45:00',3.87),('8784','2013-03-16','10:50:00',3.92),('8784','2013-03-16','10:55:00',3.93),('8784','2013-03-16','11:00:00',3.96),('8784','2013-03-16','11:05:00',3.98),('8784','2013-03-16','11:10:00',4.01),('8784','2013-03-16','11:15:00',4.03),('8784','2013-03-16','11:20:00',4.05),('8784','2013-03-16','11:25:00',4.06),('8784','2013-03-16','11:30:00',4.11),('8784','2013-03-16','11:35:00',4.11),('8784','2013-03-16','11:40:00',4.12),('8784','2013-03-16','11:45:00',4.12),('8784','2013-03-16','11:50:00',4.14),('8784','2013-03-16','11:55:00',4.13),('8784','2013-03-16','12:00:00',4.14),('8784','2013-03-16','12:05:00',4.13),('8784','2013-03-16','12:10:00',4.08),('8784','2013-03-16','12:15:00',4.12),('8784','2013-03-16','12:20:00',4.12),('8784','2013-03-16','12:25:00',4.12),('8784','2013-03-16','12:30:00',4.13),('8784','2013-03-16','12:35:00',4.1),('8784','2013-03-16','12:40:00',4.11),('8784','2013-03-16','12:45:00',4.09),('8784','2013-03-16','12:50:00',4.06),('8784','2013-03-16','12:55:00',4.04),('8784','2013-03-16','13:00:00',3.99),('8784','2013-03-16','13:05:00',3.96),('8784','2013-03-16','13:10:00',3.93),('8784','2013-03-16','13:15:00',3.91),('8784','2013-03-16','13:20:00',4.02),('8784','2013-03-16','13:25:00',1.93),('8784','2013-03-16','13:30:00',1.4),('8784','2013-03-16','13:35:00',1.09),('8784','2013-03-16','13:40:00',2.88),('8784','2013-03-16','13:45:00',2.95),('8784','2013-03-16','13:50:00',3.24),('8784','2013-03-16','13:55:00',1.9),('8784','2013-03-16','14:00:00',3.31),('8784','2013-03-16','14:05:00',3.04),('8784','2013-03-16','14:10:00',1.08),('8784','2013-03-16','14:15:00',3.6),('8784','2013-03-16','14:20:00',1.26),('8784','2013-03-16','14:25:00',1.23),('8784','2013-03-16','14:30:00',3.66),('8784','2013-03-16','14:35:00',3.26),('8784','2013-03-16','14:40:00',2.55),('8784','2013-03-16','14:45:00',1.05),('8784','2013-03-16','16:00:00',1.72),('8784','2013-03-16','16:05:00',1.91),('8784','2013-03-16','16:10:00',1.85),('8784','2013-03-16','16:15:00',1.82),('8784','2013-03-16','16:20:00',1.05),('8784','2013-03-16','16:55:00',1.09),('8784','2013-03-16','17:00:00',1.01),('8784','2013-03-15','10:35:00',1.15),('8784','2013-03-15','10:40:00',1.3),('8784','2013-03-15','10:45:00',1.51),('8784','2013-03-15','10:50:00',1.49),('8784','2013-03-15','10:55:00',1.65),('8784','2013-03-15','11:00:00',1.63),('8784','2013-03-15','11:05:00',1.4),('8784','2013-03-15','11:10:00',1.39),('8784','2013-03-15','11:15:00',1.17),('8784','2013-03-15','11:20:00',1.35),('8784','2013-03-15','11:25:00',1.68),('8784','2013-03-15','11:30:00',1.86),('8784','2013-03-15','11:35:00',2.39),('8784','2013-03-15','11:40:00',2.59),('8784','2013-03-15','11:45:00',2.43),('8784','2013-03-15','11:50:00',2.17),('8784','2013-03-15','11:55:00',2.26),('8784','2013-03-15','12:00:00',2.05),('8784','2013-03-15','12:05:00',1.98),('8784','2013-03-15','12:10:00',2.14),('8784','2013-03-15','12:15:00',1.9),('8784','2013-03-15','12:20:00',1.86),('8784','2013-03-15','12:25:00',1.97),('8784','2013-03-15','12:30:00',2.05),('8784','2013-03-15','12:35:00',2.33),('8784','2013-03-15','12:40:00',1.98),('8784','2013-03-15','12:45:00',1.64),('8784','2013-03-15','12:50:00',1.54),('8784','2013-03-15','12:55:00',1.49),('8784','2013-03-15','13:00:00',1.39),('8784','2013-03-15','13:05:00',1.29),('8784','2013-03-15','13:10:00',1.35),('8784','2013-03-15','13:15:00',1.49),('8784','2013-03-15','13:20:00',1.6),('8784','2013-03-15','13:25:00',1.78),('8784','2013-03-15','13:30:00',1.7),('8784','2013-03-15','13:35:00',1.57),('8784','2013-03-15','13:40:00',1.63),('8784','2013-03-15','13:45:00',1.74),('8784','2013-03-15','13:50:00',1.42),('8784','2013-03-15','13:55:00',1.22),('8784','2013-03-15','14:00:00',1.11),('8784','2013-03-15','14:50:00',1.11),('8784','2013-03-15','14:55:00',1.26),('8784','2013-03-15','15:00:00',1.34),('8784','2013-03-15','15:05:00',1.27),('8784','2013-03-15','15:10:00',1.26),('8784','2013-03-15','15:15:00',1.35),('8784','2013-03-15','15:20:00',1.41),('8784','2013-03-15','15:25:00',1.51),('8784','2013-03-15','15:30:00',1.32),('8784','2013-03-15','15:35:00',1.12),('8784','2013-03-15','16:00:00',1),('8784','2013-03-14','13:05:00',1.09),('8784','2013-03-14','13:10:00',1.21),('8784','2013-03-14','13:15:00',1.23),('8784','2013-03-14','13:20:00',1.23),('8784','2013-03-14','13:25:00',1.21),('8784','2013-03-14','13:30:00',1.28),('8784','2013-03-14','13:35:00',1.4),('8784','2013-03-14','13:40:00',1.25),('8784','2013-03-14','13:45:00',1.34),('8784','2013-03-14','13:50:00',1.68),('8784','2013-03-14','13:55:00',1.93),('8784','2013-03-14','14:00:00',1.81),('8784','2013-03-14','14:05:00',1.97),('8784','2013-03-14','14:10:00',1.58),('8784','2013-03-14','14:15:00',1.36),('8784','2013-03-14','14:20:00',1.29),('8784','2013-03-14','14:25:00',1.29),('8784','2013-03-14','14:30:00',1.11),('8784','2013-03-14','15:10:00',1.39),('8784','2013-03-14','15:15:00',1.37),('8784','2013-03-14','15:20:00',1.3),('8784','2013-03-14','15:25:00',1.36),('8784','2013-03-14','15:30:00',1.35),('8784','2013-03-14','15:35:00',1.07),('8784','2013-03-13','08:50:00',1.26),('8784','2013-03-13','08:55:00',1.17),('8784','2013-03-13','09:10:00',1.27),('8784','2013-03-13','09:20:00',1.07),('8784','2013-03-13','09:45:00',1.1),('8784','2013-03-13','10:05:00',1.14),('8784','2013-03-13','10:10:00',1.43),('8784','2013-03-13','10:15:00',2.44),('8784','2013-03-13','10:20:00',1.68),('8784','2013-03-13','10:25:00',2.45),('8784','2013-03-13','10:30:00',3.56),('8784','2013-03-13','10:35:00',3.45),('8784','2013-03-13','10:40:00',2.4),('8784','2013-03-13','10:45:00',1.57),('8784','2013-03-13','10:50:00',1.29),('8784','2013-03-13','10:55:00',1.12),('8784','2013-03-13','11:00:00',1.25),('8784','2013-03-13','11:10:00',1.31),('8784','2013-03-13','11:15:00',1.18),('8784','2013-03-13','11:30:00',1.32),('8784','2013-03-13','11:35:00',1.36),('8784','2013-03-13','11:40:00',1.35),('8784','2013-03-13','11:45:00',1.53),('8784','2013-03-13','11:50:00',1.36),('8784','2013-03-13','11:55:00',1.03),('8784','2013-03-13','12:40:00',1),('8784','2013-03-13','12:45:00',1.22),('8784','2013-03-13','12:50:00',1.42),('8784','2013-03-13','12:55:00',1.29),('8784','2013-03-13','13:00:00',1.26),('8784','2013-03-13','13:05:00',1.22),('8784','2013-03-13','13:10:00',1.11),('8784','2013-03-13','13:35:00',1.13),('8784','2014-03-25','07:15:00',1.19),('8784','2014-03-25','07:20:00',1.36),('8784','2014-03-25','07:25:00',1.45),('8784','2014-03-25','07:30:00',1.52),('8784','2014-03-25','07:35:00',1.18),('8784','2014-03-25','07:40:00',1.14),('8784','2014-03-25','07:45:00',1.27),('8784','2014-03-25','07:50:00',1.36),('8784','2014-03-25','07:55:00',1.37),('8784','2014-03-25','08:00:00',1.31),('8784','2014-03-25','08:05:00',1.35),('8784','2014-03-25','08:10:00',1.41),('8784','2014-03-25','08:15:00',1.51),('8784','2014-03-25','08:20:00',1.39),('8784','2014-03-25','08:25:00',1.26),('8784','2014-03-25','08:30:00',1.15),('8784','2014-03-25','08:35:00',1.18),('8784','2014-03-25','08:40:00',1.39),('8784','2014-03-25','08:45:00',1.91),('8784','2014-03-25','08:50:00',2),('8784','2014-03-25','08:55:00',2.1),('8784','2014-03-25','09:00:00',1.9),('8784','2014-03-25','09:05:00',1.86),('8784','2014-03-25','09:10:00',1.87),('8784','2014-03-25','09:15:00',2.42),('8784','2014-03-25','09:20:00',2.63),('8784','2014-03-25','09:25:00',2.29),('8784','2014-03-25','09:30:00',2.09),('8784','2014-03-25','09:35:00',1.95),('8784','2014-03-25','09:40:00',1.95),('8784','2014-03-25','09:45:00',1.84),('8784','2014-03-25','09:50:00',1.91),('8784','2014-03-25','09:55:00',2.15),('8784','2014-03-25','10:00:00',2.44),('8784','2014-03-25','10:05:00',2.58),('8784','2014-03-25','10:10:00',2.7),('8784','2014-03-25','10:15:00',2.9),('8784','2014-03-25','10:20:00',2.87),('8784','2014-03-25','10:25:00',2.76),('8784','2014-03-25','10:30:00',3.05),('8784','2014-03-25','10:35:00',2.59),('8784','2014-03-25','10:40:00',2.19),('8784','2014-03-25','10:45:00',2.05),('8784','2014-03-25','10:50:00',1.99),('8784','2014-03-25','10:55:00',2),('8784','2014-03-25','11:00:00',2.17),('8784','2014-03-25','11:05:00',2.43),('8784','2014-03-25','11:10:00',2.68),('8784','2014-03-25','11:15:00',3.04),('8784','2014-03-25','11:20:00',3.08),('8784','2014-03-25','11:25:00',2.62),('8784','2014-03-25','11:30:00',3.02),('8784','2014-03-25','11:35:00',2.48),('8784','2014-03-25','11:40:00',2.73),('8784','2014-03-25','11:45:00',2.05),('8784','2014-03-25','11:50:00',2.56),('8784','2014-03-25','11:55:00',1.82),('8784','2014-03-25','12:00:00',1.29),('8784','2014-03-25','12:20:00',1.28),('8784','2014-03-25','12:25:00',1.37),('8784','2014-03-25','12:30:00',1.06),('8784','2013-03-12','08:20:00',1.82),('8784','2013-03-12','08:25:00',1.81),('8784','2013-03-12','08:30:00',1.9),('8784','2013-03-12','08:35:00',1.62),('8784','2013-03-12','08:40:00',1.79),('8784','2013-03-12','08:45:00',2.26),('8784','2013-03-12','08:50:00',1.09),('8784','2013-03-12','09:00:00',1.57),('8784','2013-03-12','09:05:00',2.46),('8784','2013-03-12','09:10:00',2.51),('8784','2013-03-12','09:15:00',2.57),('8784','2013-03-12','09:20:00',2.64),('8784','2013-03-12','09:25:00',2.69),('8784','2013-03-12','09:30:00',2.81),('8784','2013-03-12','09:35:00',2.86),('8784','2013-03-12','09:40:00',2.85),('8784','2013-03-12','09:45:00',2.06),('8784','2013-03-12','09:50:00',2.36),('8784','2013-03-12','09:55:00',3.3),('8784','2013-03-12','10:00:00',3.09),('8784','2013-03-12','10:05:00',3.34),('8784','2013-03-12','10:10:00',3.32),('8784','2013-03-12','10:15:00',2.42),('8784','2013-03-12','10:20:00',1.57),('8784','2013-03-12','10:25:00',2.82),('8784','2013-03-12','10:30:00',1.66),('8784','2013-03-12','10:35:00',2.32),('8784','2013-03-12','10:40:00',2.76),('8784','2013-03-12','10:45:00',1.52),('8784','2013-03-12','10:50:00',3.95),('8784','2013-03-12','10:55:00',3.72),('8784','2013-03-12','11:00:00',4.05),('8784','2013-03-12','11:05:00',3.73),('8784','2013-03-12','11:10:00',3.67),('8784','2013-03-12','11:15:00',3.67),('8784','2013-03-12','11:20:00',4.04),('8784','2013-03-12','11:25:00',1.54),('8784','2013-03-12','11:30:00',1.75),('8784','2013-03-12','11:35:00',2.18),('8784','2013-03-12','11:40:00',2.23),('8784','2013-03-12','11:45:00',2.52),('8784','2013-03-12','11:50:00',2.8),('8784','2013-03-12','11:55:00',2.9),('8784','2013-03-12','12:10:00',4.75),('8784','2013-03-12','12:15:00',2.16),('8784','2013-03-12','12:20:00',2.33),('8784','2013-03-12','12:25:00',3.18),('8784','2013-03-12','12:30:00',5.02),('8784','2013-03-12','12:35:00',2.86),('8784','2013-03-12','12:40:00',3.71),('8784','2013-03-12','12:45:00',1.29),('8784','2013-03-12','12:50:00',1.86),('8784','2013-03-12','12:55:00',2.63),('8784','2013-03-12','13:00:00',4.03),('8784','2013-03-12','13:05:00',2.15),('8784','2013-03-12','13:10:00',2.77),('8784','2013-03-12','13:15:00',1.94),('8784','2013-03-12','13:20:00',3.13),('8784','2013-03-12','13:25:00',1.94),('8784','2013-03-12','13:30:00',1.61),('8784','2013-03-12','13:35:00',1.8),('8784','2013-03-12','13:40:00',1.67),('8784','2013-03-12','13:45:00',1.28),('8784','2013-03-12','13:50:00',1.26),('8784','2013-03-12','13:55:00',1.81),('8784','2013-03-12','14:00:00',2.67),('8784','2013-03-12','14:05:00',2.72),('8784','2013-03-12','14:10:00',1.6),('8784','2013-03-12','14:15:00',1.21),('8784','2013-03-12','14:20:00',1.01),('8784','2013-03-12','15:00:00',1.06),('8784','2013-03-12','15:10:00',1.02),('8784','2013-03-12','15:20:00',1.06),('8784','2013-03-11','07:40:00',1.02),('8784','2013-03-11','08:10:00',1.35),('8784','2013-03-11','08:15:00',1.5),('8784','2013-03-11','08:20:00',1.6),('8784','2013-03-11','08:25:00',1.68),('8784','2013-03-11','08:30:00',1.79),('8784','2013-03-11','08:35:00',1.88),('8784','2013-03-11','08:40:00',1.95),('8784','2013-03-11','08:45:00',2.04),('8784','2013-03-11','08:50:00',2.16),('8784','2013-03-11','08:55:00',2.22),('8784','2013-03-11','09:00:00',2.3),('8784','2013-03-11','09:05:00',2.35),('8784','2013-03-11','09:10:00',2.45),('8784','2013-03-11','09:15:00',2.53),('8784','2013-03-11','09:20:00',2.13),('8784','2013-03-11','09:25:00',1.43),('8784','2013-03-11','09:30:00',1.01),('8784','2013-03-11','09:35:00',3.83),('8784','2013-03-11','09:40:00',2.68),('8784','2013-03-11','09:45:00',2.28),('8784','2013-03-11','10:05:00',1.03),('8784','2013-03-11','10:10:00',1.24),('8784','2013-03-11','10:15:00',1.26),('8784','2013-03-11','10:20:00',1.42),('8784','2013-03-11','10:25:00',1.54),('8784','2013-03-11','10:30:00',1.45),('8784','2013-03-11','10:35:00',1.69),('8784','2013-03-11','10:40:00',2.26),('8784','2013-03-11','10:45:00',2.55),('8784','2013-03-11','10:50:00',3.37),('8784','2013-03-11','10:55:00',1.97),('8784','2013-03-11','11:00:00',1.69),('8784','2013-03-11','11:05:00',1.4),('8784','2013-03-11','11:10:00',1.54),('8784','2013-03-11','11:15:00',1.59),('8784','2013-03-11','11:20:00',1.4),('8784','2013-03-11','11:25:00',1.32),('8784','2013-03-11','11:30:00',2.3),('8784','2013-03-11','11:35:00',2.26),('8784','2013-03-11','11:40:00',2.08),('8784','2013-03-11','11:45:00',2.69),('8784','2013-03-11','11:50:00',2.39),('8784','2013-03-11','11:55:00',2.12),('8784','2013-03-11','12:00:00',1.91),('8784','2013-03-11','12:05:00',1.86),('8784','2013-03-11','12:10:00',2.38),('8784','2013-03-11','12:25:00',1.03),('8784','2013-03-11','12:30:00',1.14),('8784','2013-03-11','12:35:00',1.58),('8784','2013-03-11','12:40:00',1.27),('8784','2013-03-11','12:45:00',1.41),('8784','2013-03-11','12:50:00',2.4),('8784','2013-03-11','12:55:00',2.94),('8784','2013-03-11','13:00:00',1.96),('8784','2013-03-11','13:05:00',1.96),('8784','2013-03-11','13:10:00',3.37),('8784','2013-03-11','13:15:00',3.26),('8784','2013-03-11','13:20:00',4.2),('8784','2013-03-11','13:25:00',3.65),('8784','2013-03-11','13:30:00',3.55),('8784','2013-03-11','13:35:00',3.88),('8784','2013-03-11','13:40:00',2.56),('8784','2013-03-11','13:45:00',4.03),('8784','2013-03-11','13:50:00',3.46),('8784','2013-03-11','13:55:00',1.69),('8784','2013-03-11','14:20:00',1.37),('8784','2013-03-11','14:25:00',1.82),('8784','2013-03-11','14:30:00',1.29),('8784','2013-03-11','14:35:00',1.07),('8784','2013-03-11','14:40:00',1.86),('8784','2013-03-11','15:25:00',1.23),('8784','2013-03-11','15:30:00',2.61),('8784','2013-03-11','15:35:00',1.26),('8784','2013-03-11','15:40:00',1.81),('8784','2013-03-11','15:45:00',2.65),('8784','2013-03-11','15:50:00',2.06),('8784','2013-03-11','15:55:00',1.81),('8784','2013-03-11','16:00:00',1.67),('8784','2013-03-11','16:05:00',1.53),('8784','2013-03-11','16:10:00',1.42),('8784','2013-03-11','16:15:00',1.19),('8784','2013-03-11','16:20:00',1.33),('8784','2013-03-11','16:25:00',1.21),('8784','2013-03-11','16:30:00',1.34),('8784','2013-03-11','16:35:00',1.12),('8784','2013-03-11','16:40:00',1.16),('8784','2013-03-11','16:45:00',1.29),('8784','2013-03-10','07:50:00',1.11),('8784','2013-03-10','07:55:00',1.19),('8784','2013-03-10','08:00:00',1.27),('8784','2013-03-10','08:05:00',1.37),('8784','2013-03-10','08:10:00',1.29),('8784','2013-03-10','08:15:00',1.43),('8784','2013-03-10','08:20:00',1.61),('8784','2013-03-10','08:25:00',1.7),('8784','2013-03-10','08:30:00',1.79),('8784','2013-03-10','08:35:00',1.87),('8784','2013-03-10','08:40:00',1.95),('8784','2013-03-10','08:45:00',2.03),('8784','2013-03-10','08:50:00',2.12),('8784','2013-03-10','08:55:00',2.21),('8784','2013-03-10','09:00:00',2.29),('8784','2013-03-10','09:05:00',2.36),('8784','2013-03-10','09:10:00',2.42),('8784','2013-03-10','09:15:00',2.51),('8784','2013-03-10','09:20:00',2.55),('8784','2013-03-10','09:25:00',2.64),('8784','2013-03-10','09:30:00',2.72),('8784','2013-03-10','09:35:00',2.76),('8784','2013-03-10','09:40:00',2.92),('8784','2013-03-10','09:45:00',2.71),('8784','2013-03-10','09:50:00',3.18),('8784','2013-03-10','09:55:00',2.79),('8784','2013-03-10','10:00:00',3.46),('8784','2013-03-10','10:05:00',2.07),('8784','2013-03-10','10:10:00',2.86),('8784','2013-03-10','10:15:00',2.99),('8784','2013-03-10','10:20:00',2.3),('8784','2013-03-10','10:25:00',3.55),('8784','2013-03-10','10:30:00',2.64),('8784','2013-03-10','10:35:00',2.36),('8784','2013-03-10','10:40:00',3.18),('8784','2013-03-10','10:45:00',3.58),('8784','2013-03-10','10:50:00',1.91),('8784','2013-03-10','10:55:00',2.01),('8784','2013-03-10','11:00:00',1.8),('8784','2013-03-10','11:05:00',2.89),('8784','2013-03-10','11:10:00',2.06),('8784','2013-03-10','11:15:00',1.92),('8784','2013-03-10','11:20:00',2.25),('8784','2013-03-10','11:25:00',2.86),('8784','2013-03-10','11:30:00',2),('8784','2013-03-10','11:35:00',2.7),('8784','2013-03-10','11:40:00',1.36),('8784','2013-03-10','11:45:00',1.59),('8784','2013-03-10','11:50:00',3.87),('8784','2013-03-10','11:55:00',3.95),('8784','2013-03-10','12:00:00',3.95),('8784','2013-03-10','12:05:00',3.82),('8784','2013-03-10','12:10:00',3.95),('8784','2013-03-10','12:15:00',3.01),('8784','2013-03-10','12:20:00',4.22),('8784','2013-03-10','12:25:00',3.25),('8784','2013-03-10','12:30:00',3.5),('8784','2013-03-10','12:35:00',3.21),('8784','2013-03-10','12:40:00',4.12),('8784','2013-03-10','12:45:00',4.12),('8784','2013-03-10','12:50:00',4.04),('8784','2013-03-10','12:55:00',3.92),('8784','2013-03-10','13:00:00',3.77),('8784','2013-03-10','13:05:00',3.7),('8784','2013-03-10','13:10:00',3.54),('8784','2013-03-10','13:15:00',3.75),('8784','2013-03-10','13:20:00',3.68),('8784','2013-03-10','13:25:00',3.6),('8784','2013-03-10','13:30:00',3.44),('8784','2013-03-10','13:35:00',3.37),('8784','2013-03-10','13:40:00',2.09),('8784','2013-03-10','13:45:00',2.31),('8784','2013-03-10','13:50:00',1.98),('8784','2013-03-10','13:55:00',1.88),('8784','2013-03-10','14:00:00',1.6),('8784','2013-03-10','14:05:00',2.12),('8784','2013-03-10','14:10:00',2.15),('8784','2013-03-10','14:15:00',2.91),('8784','2013-03-10','14:20:00',2.96),('8784','2013-03-10','14:25:00',1.76),('8784','2013-03-10','14:30:00',2.55),('8784','2013-03-10','14:35:00',3.01),('8784','2013-03-10','14:40:00',2.65),('8784','2013-03-10','14:45:00',1.73),('8784','2013-03-10','14:50:00',1.73),('8784','2013-03-10','14:55:00',1.53),('8784','2013-03-10','15:00:00',1.23),('8784','2013-03-10','15:05:00',1.45),('8784','2013-03-10','15:10:00',1.42),('8784','2013-03-09','08:00:00',1.27),('8784','2013-03-09','08:05:00',1.53),('8784','2013-03-09','08:10:00',1.41),('8784','2013-03-09','08:15:00',1.46),('8784','2013-03-09','08:20:00',1.53),('8784','2013-03-09','08:25:00',1.6),('8784','2013-03-09','08:30:00',1.72),('8784','2013-03-09','08:35:00',1.76),('8784','2013-03-09','08:40:00',1.83),('8784','2013-03-09','08:45:00',1.91),('8784','2013-03-09','08:50:00',1.6),('8784','2013-03-09','08:55:00',2.01),('8784','2013-03-09','09:00:00',2),('8784','2013-03-09','09:05:00',1.17),('8784','2013-03-09','09:15:00',1.01),('8784','2013-03-09','09:20:00',1.13),('8784','2013-03-09','09:25:00',2.14),('8784','2013-03-09','09:30:00',2.54),('8784','2013-03-09','09:35:00',2.78),('8784','2013-03-09','09:40:00',2.81),('8784','2013-03-09','09:45:00',3.54),('8784','2013-03-09','09:50:00',1.73),('8784','2013-03-09','09:55:00',2.93),('8784','2013-03-09','10:05:00',1.17),('8784','2013-03-09','10:10:00',1.11),('8784','2013-03-09','10:15:00',1.4),('8784','2013-03-09','10:20:00',1.1),('8784','2013-03-09','10:25:00',1.04),('8784','2013-03-09','10:30:00',1.05),('8784','2013-03-09','10:35:00',1.56),('8784','2013-03-09','10:40:00',2.12),('8784','2013-03-09','10:45:00',4),('8784','2013-03-09','10:50:00',3.74),('8784','2013-03-09','10:55:00',3.03),('8784','2013-03-09','11:00:00',3.07),('8784','2013-03-09','11:05:00',3.86),('8784','2013-03-09','11:10:00',3.88),('8784','2013-03-09','11:15:00',3.92),('8784','2013-03-09','11:20:00',3.96),('8784','2013-03-09','11:25:00',3.53),('8784','2013-03-09','11:30:00',3.78),('8784','2013-03-09','11:35:00',3.88),('8784','2013-03-09','11:40:00',3.89),('8784','2013-03-09','11:45:00',3.91),('8784','2013-03-09','11:50:00',3.83),('8784','2013-03-09','11:55:00',3.65),('8784','2013-03-09','12:00:00',2.79),('8784','2013-03-09','12:05:00',1.37),('8784','2013-03-09','12:10:00',1.87),('8784','2013-03-09','12:15:00',1.56),('8784','2013-03-09','12:20:00',2.09),('8784','2013-03-09','12:25:00',1.82),('8784','2013-03-09','12:30:00',1.65),('8784','2013-03-09','12:35:00',1.85),('8784','2013-03-09','12:40:00',1.68),('8784','2013-03-09','12:45:00',2.35),('8784','2013-03-09','12:50:00',2.01),('8784','2013-03-09','12:55:00',3.76),('8784','2013-03-09','13:00:00',3.83),('8784','2013-03-09','13:05:00',3.7),('8784','2013-03-09','13:10:00',3.76),('8784','2013-03-09','13:15:00',4.07),('8784','2013-03-09','13:20:00',3.38),('8784','2013-03-09','13:25:00',2.39),('8784','2013-03-09','13:30:00',3.92),('8784','2013-03-09','13:35:00',3.6),('8784','2013-03-09','13:40:00',3.76),('8784','2013-03-09','13:45:00',3.64),('8784','2013-03-09','13:50:00',2.74),('8784','2013-03-09','14:00:00',1.12),('8784','2013-03-09','14:05:00',1.54),('8784','2013-03-09','14:10:00',3.25),('8784','2013-03-09','14:15:00',3.38),('8784','2013-03-09','14:20:00',3.17),('8784','2013-03-09','14:25:00',3.05),('8784','2013-03-09','14:30:00',3),('8784','2013-03-09','14:35:00',2.93),('8784','2013-03-09','14:40:00',2.87),('8784','2013-03-09','14:45:00',2.8),('8784','2013-03-09','14:50:00',2.74),('8784','2013-03-09','14:55:00',2.69),('8784','2013-03-09','15:00:00',2.61),('8784','2013-03-09','15:05:00',2.53),('8784','2013-03-09','15:10:00',2.47),('8784','2013-03-09','15:15:00',2.38),('8784','2013-03-09','15:20:00',2.31),('8784','2013-03-09','15:25:00',2.23),('8784','2013-03-09','15:30:00',2.09),('8784','2013-03-09','15:35:00',1.98),('8784','2013-03-09','15:40:00',2),('8784','2013-03-09','15:45:00',1.94),('8784','2013-03-09','15:50:00',1.81),('8784','2013-03-09','15:55:00',1.63),('8784','2013-03-09','16:00:00',1.51),('8784','2013-03-09','16:05:00',1.56),('8784','2013-03-09','16:10:00',1.25),('8784','2013-03-09','16:15:00',1.44),('8784','2013-03-09','16:20:00',1.17),('8784','2013-03-09','16:25:00',1.35),('8784','2013-03-09','16:30:00',1.18),('8784','2013-03-08','08:25:00',1.04),('8784','2013-03-08','08:30:00',1.84),('8784','2013-03-08','08:35:00',1.68),('8784','2013-03-08','08:50:00',1.13),('8784','2013-03-08','09:30:00',2.09),('8784','2013-03-08','09:35:00',1.88),('8784','2013-03-08','09:40:00',1.77),('8784','2013-03-08','09:45:00',1.39),('8784','2013-03-08','09:50:00',1.69),('8784','2013-03-08','09:55:00',1.63),('8784','2013-03-08','10:00:00',1.04),('8784','2013-03-08','10:05:00',1.22),('8784','2013-03-08','10:10:00',1.6),('8784','2013-03-08','10:15:00',1.86),('8784','2013-03-08','10:20:00',1.42),('8784','2013-03-08','10:25:00',1.55),('8784','2013-03-08','10:30:00',1.98),('8784','2013-03-08','10:35:00',2.47),('8784','2013-03-08','10:40:00',1.66),('8784','2013-03-08','10:45:00',1.17),('8784','2013-03-08','10:50:00',1.49),('8784','2013-03-08','10:55:00',1.33),('8784','2013-03-08','11:00:00',1.23),('8784','2013-03-08','11:35:00',1.85),('8784','2013-03-08','11:40:00',2.32),('8784','2013-03-08','11:45:00',1.88),('8784','2013-03-08','11:50:00',1.64),('8784','2013-03-08','11:55:00',2),('8784','2013-03-08','12:00:00',2.27),('8784','2013-03-08','12:05:00',1.47),('8784','2013-03-08','12:10:00',1.13),('8784','2013-03-08','12:15:00',1.05),('8784','2013-03-08','12:20:00',1.5),('8784','2013-03-08','12:25:00',1.28),('8784','2013-03-08','12:30:00',1.16),('8784','2013-03-08','12:35:00',1.81),('8784','2013-03-08','12:40:00',2.3),('8784','2013-03-08','12:45:00',2.21),('8784','2013-03-08','12:50:00',2.64),('8784','2013-03-08','12:55:00',2.37),('8784','2013-03-08','13:00:00',2.3),('8784','2013-03-08','13:05:00',2.42),('8784','2013-03-08','13:10:00',1.57),('8784','2013-03-08','13:15:00',1.27),('8784','2013-03-08','13:20:00',1.22),('8784','2013-03-08','13:25:00',1.62),('8784','2013-03-08','13:30:00',2.22),('8784','2013-03-08','13:35:00',1.62),('8784','2013-03-08','13:40:00',1.4),('8784','2013-03-08','17:10:00',1.28),('8784','2013-03-07','08:40:00',1.05),('8784','2013-03-07','08:45:00',1.05),('8784','2013-03-07','08:50:00',1.2),('8784','2013-03-07','10:50:00',1.28),('8784','2013-03-07','10:55:00',1.32),('8784','2013-03-07','11:00:00',1.28),('8784','2013-03-07','11:05:00',1.56),('8784','2013-03-07','11:10:00',1.12),('8784','2013-03-07','11:30:00',1.96),('8784','2013-03-07','11:35:00',2.48),('8784','2013-03-07','11:40:00',2.32),('8784','2013-03-07','11:45:00',2.46),('8784','2013-03-07','11:50:00',2.72),('8784','2013-03-07','11:55:00',1.72),('8784','2013-03-07','12:00:00',1.35),('8784','2013-03-07','12:05:00',1.19),('8784','2013-03-07','12:25:00',1.16),('8784','2013-03-07','12:30:00',1.01),('8784','2013-03-07','12:40:00',1.47),('8784','2013-03-07','12:45:00',2.1),('8784','2013-03-07','12:50:00',1.86),('8784','2013-03-07','12:55:00',1.66),('8784','2013-03-07','13:00:00',1.93),('8784','2013-03-07','13:05:00',1.98),('8784','2013-03-07','13:10:00',1.75),('8784','2013-03-07','13:15:00',2.01),('8784','2013-03-07','13:20:00',2.37),('8784','2013-03-07','13:25:00',2.04),('8784','2013-03-07','13:30:00',1.71),('8784','2013-03-07','13:35:00',1.6),('8784','2013-03-07','14:05:00',1.04),('8784','2013-03-07','14:10:00',1.13),('8784','2013-03-05','08:15:00',1.26),('8784','2013-03-05','08:25:00',1.31),('8784','2013-03-05','08:30:00',1.86),('8784','2013-03-05','08:35:00',1.66),('8784','2013-03-05','08:40:00',1.73),('8784','2013-03-05','08:45:00',1.45),('8784','2013-03-05','08:50:00',1.65),('8784','2013-03-05','08:55:00',1.56),('8784','2013-03-05','09:00:00',1.63),('8784','2013-03-05','09:05:00',1.7),('8784','2013-03-05','09:10:00',1.58),('8784','2013-03-05','09:15:00',1.54),('8784','2013-03-05','09:20:00',1.57),('8784','2013-03-05','09:25:00',1.55),('8784','2013-03-05','09:30:00',1.63),('8784','2013-03-05','09:35:00',1.76),('8784','2013-03-05','09:40:00',1.86),('8784','2013-03-05','09:45:00',1.87),('8784','2013-03-05','09:50:00',1.85),('8784','2013-03-05','09:55:00',1.78),('8784','2013-03-05','10:00:00',1.69),('8784','2013-03-05','10:05:00',1.84),('8784','2013-03-05','10:10:00',1.89),('8784','2013-03-05','10:15:00',1.99),('8784','2013-03-05','10:20:00',2.16),('8784','2013-03-05','10:25:00',1.96),('8784','2013-03-05','10:30:00',1.94),('8784','2013-03-05','10:35:00',2.27),('8784','2013-03-05','10:40:00',2.32),('8784','2013-03-05','10:45:00',2.43),('8784','2013-03-05','10:50:00',2.61),('8784','2013-03-05','10:55:00',2.63),('8784','2013-03-05','11:00:00',2.45),('8784','2013-03-05','11:05:00',2.65),('8784','2013-03-05','11:10:00',2.73),('8784','2013-03-05','11:15:00',2.69),('8784','2013-03-05','11:20:00',2.65),('8784','2013-03-05','11:25:00',2.56),('8784','2013-03-05','11:30:00',2.64),('8784','2013-03-05','11:35:00',2.9),('8784','2013-03-05','11:40:00',3.13),('8784','2013-03-05','11:45:00',2.99),('8784','2013-03-05','11:50:00',3.04),('8784','2013-03-05','11:55:00',3.09),('8784','2013-03-05','12:00:00',3.18),('8784','2013-03-05','12:05:00',3.24),('8784','2013-03-05','12:10:00',3.36),('8784','2013-03-05','12:15:00',2.73),('8784','2013-03-05','12:20:00',3.11),('8784','2013-03-05','12:25:00',3.08),('8784','2013-03-05','12:30:00',2.59),('8784','2013-03-05','12:35:00',2.48),('8784','2013-03-05','12:40:00',2.5),('8784','2013-03-05','12:45:00',2.67),('8784','2013-03-05','12:50:00',2.34),('8784','2013-03-05','12:55:00',2.12),('8784','2013-03-05','13:00:00',1.8),('8784','2013-03-05','13:05:00',1.74),('8784','2013-03-05','13:10:00',1.86),('8784','2013-03-05','13:15:00',1.98),('8784','2013-03-05','13:20:00',1.89),('8784','2013-03-05','13:25:00',1.71),('8784','2013-03-05','13:30:00',1.58),('8784','2013-03-05','13:35:00',1.5),('8784','2013-03-05','13:40:00',1.42),('8784','2013-03-05','13:45:00',1.3),('8784','2013-03-05','13:50:00',1.19),('8784','2013-03-05','13:55:00',1.13),('8784','2013-03-05','14:00:00',1.12),('8784','2013-03-05','14:05:00',1.15),('8784','2013-03-05','14:10:00',1.19),('8784','2013-03-05','14:15:00',1.11),('8784','2013-03-05','14:20:00',1.04),('8784','2013-03-05','14:25:00',1.05),('8784','2013-03-05','14:30:00',1.03),('8784','2013-03-05','14:35:00',1.04),('8784','2013-03-05','14:40:00',1.07),('8784','2013-03-05','14:45:00',1.09),('8784','2013-03-05','14:50:00',1.07),('8784','2013-03-05','15:40:00',1),('8784','2013-03-05','15:45:00',1.21),('8784','2013-03-05','15:50:00',1.17),('8784','2013-03-04','08:00:00',1.05),('8784','2013-03-04','08:05:00',1.13),('8784','2013-03-04','08:10:00',1.21),('8784','2013-03-04','08:15:00',1.3),('8784','2013-03-04','08:20:00',1.38),('8784','2013-03-04','08:25:00',1.48),('8784','2013-03-04','08:30:00',1.57),('8784','2013-03-04','08:35:00',1.65),('8784','2013-03-04','08:40:00',1.73),('8784','2013-03-04','08:45:00',1.81),('8784','2013-03-04','08:50:00',1.89),('8784','2013-03-04','08:55:00',1.97),('8784','2013-03-04','09:00:00',2.04),('8784','2013-03-04','09:05:00',2.12),('8784','2013-03-04','09:10:00',2.2),('8784','2013-03-04','09:15:00',2.26),('8784','2013-03-04','09:20:00',2.34),('8784','2013-03-04','09:25:00',2.42),('8784','2013-03-04','09:30:00',2.5),('8784','2013-03-04','09:35:00',2.55),('8784','2013-03-04','09:40:00',2.61),('8784','2013-03-04','09:46:00',2.63),('8784','2013-03-04','09:50:00',2.75),('8784','2013-03-04','09:55:00',2.81),('8784','2013-03-04','10:00:00',2.84),('8784','2013-03-04','10:05:00',2.93),('8784','2013-03-04','10:10:00',2.94),('8784','2013-03-04','10:15:00',3),('8784','2013-03-04','10:20:00',3.07),('8784','2013-03-04','10:25:00',3.11),('8784','2013-03-04','10:30:00',3.11),('8784','2013-03-04','10:35:00',3.21),('8784','2013-03-04','10:40:00',3.23),('8784','2013-03-04','10:45:00',3.25),('8784','2013-03-04','10:50:00',3.28),('8784','2013-03-04','10:55:00',3.3),('8784','2013-03-04','11:00:00',3.33),('8784','2013-03-04','11:05:00',3.41),('8784','2013-03-04','11:10:00',3.45),('8784','2013-03-04','11:15:00',3.46),('8784','2013-03-04','11:20:00',3.47),('8784','2013-03-04','11:25:00',3.49),('8784','2013-03-04','11:30:00',3.49),('8784','2013-03-04','11:35:00',3.47),('8784','2013-03-04','11:40:00',3.52),('8784','2013-03-04','11:45:00',3.52),('8784','2013-03-04','11:50:00',3.53),('8784','2013-03-04','11:55:00',3.55),('8784','2013-03-04','12:00:00',3.54),('8784','2013-03-04','12:05:00',3.56),('8784','2013-03-04','12:10:00',3.6),('8784','2013-03-04','12:15:00',3.62),('8784','2013-03-04','12:20:00',3.59),('8784','2013-03-04','12:25:00',3.59),('8784','2013-03-04','12:30:00',3.54),('8784','2013-03-04','12:35:00',3.56),('8784','2013-03-04','12:40:00',3.56),('8784','2013-03-04','12:45:00',3.52),('8784','2013-03-04','12:50:00',3.49),('8784','2013-03-04','12:55:00',3.42),('8784','2013-03-04','13:00:00',3.4),('8784','2013-03-04','13:05:00',3.38),('8784','2013-03-04','13:10:00',3.39),('8784','2013-03-04','13:15:00',3.37),('8784','2013-03-04','13:20:00',3.32),('8784','2013-03-04','13:25:00',2.91),('8784','2013-03-04','13:30:00',3.04),('8784','2013-03-04','13:35:00',3.48),('8784','2013-03-04','13:40:00',3.27),('8784','2013-03-04','13:45:00',3.07),('8784','2013-03-04','13:50:00',3.11),('8784','2013-03-04','13:55:00',3.09),('8784','2013-03-04','14:00:00',3.08),('8784','2013-03-04','14:05:00',3),('8784','2013-03-04','14:10:00',2.86),('8784','2013-03-04','14:15:00',2.77),('8784','2013-03-04','14:20:00',2.77),('8784','2013-03-04','14:25:00',2.75),('8784','2013-03-04','14:30:00',2.66),('8784','2013-03-04','14:35:00',2.49),('8784','2013-03-04','14:40:00',2.53),('8784','2013-03-04','14:45:00',2.45),('8784','2013-03-04','14:50:00',2.34),('8784','2013-03-04','14:55:00',2.32),('8784','2013-03-04','15:00:00',2.3),('8784','2013-03-04','15:05:00',2.24),('8784','2013-03-04','15:10:00',2.17),('8784','2013-03-04','15:15:00',2.06),('8784','2013-03-04','15:20:00',2.01),('8784','2013-03-04','15:25:00',1.92),('8784','2013-03-04','15:30:00',1.9),('8784','2013-03-04','15:35:00',1.83),('8784','2013-03-04','15:40:00',1.75),('8784','2013-03-04','15:45:00',1.66),('8784','2013-03-04','15:50:00',1.59),('8784','2013-03-04','15:55:00',1.52),('8784','2013-03-04','16:00:00',1.44),('8784','2013-03-04','16:05:00',1.37),('8784','2013-03-04','16:10:00',1.29),('8784','2013-03-04','16:15:00',1.21),('8784','2013-03-04','16:20:00',1.15),('8784','2013-03-04','16:25:00',1.1),('8784','2013-03-04','16:30:00',1.03),('8784','2013-03-03','08:00:00',1.06),('8784','2013-03-03','08:05:00',1.15),('8784','2013-03-03','08:10:00',1.24),('8784','2013-03-03','08:15:00',1.33),('8784','2013-03-03','08:20:00',1.42),('8784','2013-03-03','08:25:00',1.52),('8784','2013-03-03','08:30:00',1.61),('8784','2013-03-03','08:35:00',1.7),('8784','2013-03-03','08:40:00',1.79),('8784','2013-03-03','08:45:00',1.86),('8784','2013-03-03','08:50:00',1.96),('8784','2013-03-03','08:55:00',2.04),('8784','2013-03-03','09:00:00',2.12),('8784','2013-03-03','09:05:00',2.2),('8784','2013-03-03','09:10:00',2.27),('8784','2013-03-03','09:15:00',2.33),('8784','2013-03-03','09:20:00',2.43),('8784','2013-03-03','09:25:00',2.49),('8784','2013-03-03','09:30:00',2.57),('8784','2013-03-03','09:35:00',2.63),('8784','2013-03-03','09:40:00',2.7),('8784','2013-03-03','09:45:00',2.77),('8784','2013-03-03','09:50:00',2.82),('8784','2013-03-03','09:55:00',2.94),('8784','2013-03-03','10:00:00',3),('8784','2013-03-03','10:05:00',3.05),('8784','2013-03-03','10:10:00',3.12),('8784','2013-03-03','10:15:00',3.18),('8784','2013-03-03','10:20:00',3.2),('8784','2013-03-03','10:25:00',3.29),('8784','2013-03-03','10:30:00',3.33),('8784','2013-03-03','10:35:00',3.37),('8784','2013-03-03','10:40:00',3.4),('8784','2013-03-03','10:45:00',3.44),('8784','2013-03-03','10:50:00',3.46),('8784','2013-03-03','10:55:00',3.48),('8784','2013-03-03','11:00:00',3.51),('8784','2013-03-03','11:05:00',3.53),('8784','2013-03-03','11:10:00',3.54),('8784','2013-03-03','11:15:00',3.57),('8784','2013-03-03','11:20:00',3.6),('8784','2013-03-03','11:25:00',3.61),('8784','2013-03-03','11:30:00',3.63),('8784','2013-03-03','11:35:00',3.65),('8784','2013-03-03','11:40:00',3.63),('8784','2013-03-03','11:45:00',3.67),('8784','2013-03-03','11:50:00',3.67),('8784','2013-03-03','11:55:00',3.67),('8784','2013-03-03','12:00:00',3.68),('8784','2013-03-03','12:05:00',3.66),('8784','2013-03-03','12:10:00',3.71),('8784','2013-03-03','12:15:00',3.7),('8784','2013-03-03','12:20:00',3.68),('8784','2013-03-03','12:25:00',3.67),('8784','2013-03-03','12:30:00',3.68),('8784','2013-03-03','12:35:00',3.67),('8784','2013-03-03','12:40:00',3.65),('8784','2013-03-03','12:45:00',3.67),('8784','2013-03-03','12:50:00',3.64),('8784','2013-03-03','12:55:00',3.62),('8784','2013-03-03','13:00:00',3.6),('8784','2013-03-03','13:05:00',3.59),('8784','2013-03-03','13:10:00',3.55),('8784','2013-03-03','13:15:00',3.51),('8784','2013-03-03','13:20:00',3.4),('8784','2013-03-03','13:25:00',3.46),('8784','2013-03-03','13:30:00',3.43),('8784','2013-03-03','13:35:00',3.39),('8784','2013-03-03','13:40:00',3.37),('8784','2013-03-03','13:45:00',3.3),('8784','2013-03-03','13:50:00',3.27),('8784','2013-03-03','13:55:00',3.23),('8784','2013-03-03','14:00:00',3.18),('8784','2013-03-03','14:05:00',3.15),('8784','2013-03-03','14:10:00',3.11),('8784','2013-03-03','14:15:00',3.05),('8784','2013-03-03','14:20:00',2.98),('8784','2013-03-03','14:25:00',2.9),('8784','2013-03-03','14:30:00',2.86),('8784','2013-03-03','14:35:00',2.81),('8784','2013-03-03','14:40:00',2.75),('8784','2013-03-03','14:45:00',2.69),('8784','2013-03-03','14:50:00',2.62),('8784','2013-03-03','14:55:00',2.53),('8784','2013-03-03','15:00:00',2.47),('8784','2013-03-03','15:05:00',2.4),('8784','2013-03-03','15:10:00',2.3),('8784','2013-03-03','15:15:00',2.27),('8784','2013-03-03','15:20:00',2.21),('8784','2013-03-03','15:25:00',2.14),('8784','2013-03-03','15:30:00',2.08),('8784','2013-03-03','15:35:00',1.99),('8784','2013-03-03','15:40:00',1.9),('8784','2013-03-03','15:45:00',1.81),('8784','2013-03-03','15:50:00',1.73),('8784','2013-03-03','15:55:00',1.65),('8784','2013-03-03','16:00:00',1.56),('8784','2013-03-03','16:05:00',1.48),('8784','2013-03-03','16:10:00',1.39),('8784','2013-03-03','16:15:00',1.3),('8784','2013-03-03','16:20:00',1.23),('8784','2013-03-03','16:25:00',1.14),('8784','2013-03-03','16:30:00',1.05),('8784','2014-03-24','07:45:00',1.37),('8784','2014-03-24','08:55:00',1.71),('8784','2014-03-24','09:00:00',1.92),('8784','2014-03-24','09:05:00',1.2),('8784','2014-03-24','09:15:00',1.05),('8784','2014-03-24','09:20:00',1.6),('8784','2014-03-24','09:30:00',1.36),('8784','2014-03-24','09:40:00',1.61),('8784','2014-03-24','09:45:00',1.18),('8784','2014-03-24','09:50:00',1.14),('8784','2014-03-24','10:00:00',2.39),('8784','2014-03-24','10:05:00',2.7),('8784','2014-03-24','10:10:00',3.55),('8784','2014-03-24','10:15:00',2.49),('8784','2014-03-24','10:20:00',1.01),('8784','2014-03-24','10:35:00',1.46),('8784','2014-03-24','10:40:00',1.11),('8784','2014-03-24','10:45:00',2.1),('8784','2014-03-24','10:50:00',4.75),('8784','2014-03-24','10:55:00',3.68),('8784','2014-03-24','11:00:00',1.82),('8784','2014-03-24','11:05:00',2.26),('8784','2014-03-24','11:10:00',2.99),('8784','2014-03-24','11:15:00',3.44),('8784','2014-03-24','11:20:00',2.83),('8784','2014-03-24','11:25:00',3.22),('8784','2014-03-24','11:30:00',3.82),('8784','2014-03-24','11:35:00',1.63),('8784','2014-03-24','12:30:00',1.27),('8784','2014-03-24','12:35:00',2.14),('8784','2014-03-24','12:40:00',2.18),('8784','2014-03-24','12:45:00',1.9),('8784','2014-03-24','12:50:00',1.61),('8784','2014-03-24','12:55:00',1.55),('8784','2014-03-24','13:00:00',1.57),('8784','2014-03-24','13:05:00',1.55),('8784','2014-03-24','13:10:00',1.34),('8784','2014-03-24','13:15:00',1.13),('8784','2014-03-24','13:20:00',1.15),('8784','2014-03-24','13:25:00',1.34),('8784','2014-03-24','13:30:00',1.51),('8784','2014-03-24','13:35:00',1.27),('8784','2014-03-24','13:45:00',1.23),('8784','2014-03-24','13:50:00',1.48),('8784','2014-03-24','13:55:00',1.45),('8784','2014-03-24','14:00:00',1.27),('8784','2014-03-24','14:05:00',1.17),('8784','2014-03-24','14:10:00',1.39),('8784','2014-03-24','14:15:00',1.77),('8784','2014-03-24','14:20:00',2.28),('8784','2014-03-24','14:25:00',2.22),('8784','2014-03-24','14:30:00',2.06),('8784','2014-03-24','14:35:00',2.48),('8784','2014-03-24','14:40:00',3.08),('8784','2014-03-24','14:45:00',3.45),('8784','2014-03-24','14:50:00',3.32),('8784','2014-03-24','14:55:00',3.02),('8784','2014-03-24','15:00:00',2.64),('8784','2014-03-24','15:05:00',2.36),('8784','2014-03-24','15:10:00',2.14),('8784','2014-03-24','15:15:00',1.56),('8784','2014-03-24','15:20:00',1.73),('8784','2014-03-24','15:25:00',1.61),('8784','2014-03-24','15:30:00',1.7),('8784','2014-03-24','15:35:00',1.56),('8784','2014-03-24','15:40:00',1.31),('8784','2014-03-24','15:45:00',1.16),('8784','2014-03-24','15:50:00',1.32),('8784','2014-03-24','15:55:00',1.49),('8784','2014-03-24','16:00:00',2.45),('8784','2014-03-24','16:05:00',1.39),('8784','2014-03-24','16:10:00',1.14),('8784','2013-03-02','10:40:00',1.07),('8784','2013-03-02','10:45:00',1.07),('8784','2013-03-02','10:50:00',1.18),('8784','2013-03-02','10:55:00',1.23),('8784','2013-03-02','11:00:00',1.31),('8784','2013-03-02','11:05:00',1.37),('8784','2013-03-02','11:10:00',1.45),('8784','2013-03-02','11:15:00',1.65),('8784','2013-03-02','11:20:00',1.46),('8784','2013-03-02','11:25:00',1.29),('8784','2013-03-02','11:30:00',1.19),('8784','2013-03-02','11:35:00',1.22),('8784','2013-03-02','11:40:00',1.39),('8784','2013-03-02','11:45:00',1.25),('8784','2013-03-02','11:50:00',1.29),('8784','2013-03-02','11:55:00',1.2),('8784','2013-03-02','12:00:00',1.18),('8784','2013-03-02','12:05:00',1.35),('8784','2013-03-02','12:10:00',1.33),('8784','2013-03-02','12:15:00',1.39),('8784','2013-03-02','12:20:00',1.3),('8784','2013-03-02','12:25:00',1.35),('8784','2013-03-02','12:30:00',1.48),('8784','2013-03-02','12:35:00',1.58),('8784','2013-03-02','12:40:00',1.8),('8784','2013-03-02','12:45:00',1.74),('8784','2013-03-02','12:50:00',1.54),('8784','2013-03-02','12:55:00',1.82),('8784','2013-03-02','13:00:00',1.62),('8784','2013-03-02','13:05:00',1.43),('8784','2013-03-02','13:10:00',1.13),('8784','2013-03-02','13:15:00',1.01),('8784','2013-03-02','13:30:00',1.07),('8784','2013-03-02','13:35:00',1.1),('8784','2013-03-02','13:40:00',1.17),('8784','2013-03-02','13:45:00',1.26),('8784','2013-03-02','13:50:00',1.23),('8784','2013-03-02','13:55:00',1.28),('8784','2013-03-02','14:00:00',1.42),('8784','2013-03-02','14:05:00',1.38),('8784','2013-03-02','14:10:00',1.2),('8784','2013-03-02','14:15:00',1.08),('8784','2013-03-02','14:20:00',1.04),('8784','2013-03-01','08:05:00',1.01),('8784','2013-03-01','08:10:00',1),('8784','2013-03-01','08:15:00',1.08),('8784','2013-03-01','08:20:00',1.14),('8784','2013-03-01','08:25:00',1.15),('8784','2013-03-01','08:30:00',1.25),('8784','2013-03-01','08:35:00',1.33),('8784','2013-03-01','08:40:00',1.43),('8784','2013-03-01','08:45:00',1.5),('8784','2013-03-01','08:50:00',1.59),('8784','2013-03-01','08:55:00',1.7),('8784','2013-03-01','09:00:00',1.81),('8784','2013-03-01','09:05:00',1.95),('8784','2013-03-01','09:10:00',1.93),('8784','2013-03-01','09:15:00',1.97),('8784','2013-03-01','09:20:00',2.01),('8784','2013-03-01','09:25:00',2),('8784','2013-03-01','09:30:00',2.19),('8784','2013-03-01','09:35:00',2.14),('8784','2013-03-01','09:40:00',2.31),('8784','2013-03-01','09:45:00',2.42),('8784','2013-03-01','09:50:00',2.41),('8784','2013-03-01','09:55:00',2.4),('8784','2013-03-01','10:00:00',2.47),('8784','2013-03-01','10:05:00',2.46),('8784','2013-03-01','10:10:00',2.4),('8784','2013-03-01','10:15:00',2.09),('8784','2013-03-01','10:20:00',2.1),('8784','2013-03-01','10:25:00',2.24),('8784','2013-03-01','10:30:00',2.57),('8784','2013-03-01','10:35:00',2.66),('8784','2013-03-01','10:40:00',2.37),('8784','2013-03-01','10:45:00',2.29),('8784','2013-03-01','10:50:00',2.19),('8784','2013-03-01','10:55:00',2.07),('8784','2013-03-01','11:00:00',1.81),('8784','2013-03-01','11:05:00',1.65),('8784','2013-03-01','11:10:00',1.61),('8784','2013-03-01','11:15:00',1.81),('8784','2013-03-01','11:20:00',1.87),('8784','2013-03-01','11:25:00',1.87),('8784','2013-03-01','11:30:00',1.92),('8784','2013-03-01','11:35:00',1.92),('8784','2013-03-01','11:40:00',1.79),('8784','2013-03-01','11:45:00',1.76),('8784','2013-03-01','11:50:00',1.73),('8784','2013-03-01','11:55:00',1.67),('8784','2013-03-01','12:00:00',1.6),('8784','2013-03-01','12:05:00',1.52),('8784','2013-03-01','12:10:00',1.41),('8784','2013-03-01','12:15:00',1.3),('8784','2013-03-01','12:20:00',1.23),('8784','2013-03-01','12:25:00',1.22),('8784','2013-03-01','12:30:00',1.26),('8784','2013-03-01','12:35:00',1.25),('8784','2013-03-01','12:40:00',1.21),('8784','2013-03-01','12:45:00',1.21),('8784','2013-03-01','12:50:00',1.24),('8784','2013-03-01','12:55:00',1.32),('8784','2013-03-01','13:00:00',1.38),('8784','2013-03-01','13:05:00',1.4),('8784','2013-03-01','13:10:00',1.45),('8784','2013-03-01','13:15:00',1.54),('8784','2013-03-01','13:20:00',1.67),('8784','2013-03-01','13:25:00',1.81),('8784','2013-03-01','13:30:00',1.75),('8784','2013-03-01','13:35:00',1.63),('8784','2013-03-01','13:40:00',1.56),('8784','2013-03-01','13:45:00',1.55),('8784','2013-03-01','13:50:00',1.53),('8784','2013-03-01','13:55:00',1.47),('8784','2013-03-01','14:00:00',1.43),('8784','2013-03-01','14:05:00',1.37),('8784','2013-03-01','14:10:00',1.29),('8784','2013-03-01','14:15:00',1.22),('8784','2013-03-01','14:20:00',1.18),('8784','2013-03-01','14:25:00',1.18),('8784','2013-03-01','14:30:00',1.21),('8784','2013-03-01','14:35:00',1.2),('8784','2013-03-01','14:40:00',1.15),('8784','2013-03-01','14:45:00',1.07),('8784','2013-03-01','14:50:00',1.02),('8784','2013-03-01','14:55:00',1.02),('8784','2013-03-01','15:00:00',1.02),('8784','2013-02-28','08:10:00',1.04),('8784','2013-02-28','08:15:00',1.12),('8784','2013-02-28','08:20:00',1.21),('8784','2013-02-28','08:25:00',1.27),('8784','2013-02-28','08:30:00',1.36),('8784','2013-02-28','08:35:00',1.45),('8784','2013-02-28','08:40:00',1.53),('8784','2013-02-28','08:45:00',1.61),('8784','2013-02-28','08:50:00',1.72),('8784','2013-02-28','08:55:00',1.78),('8784','2013-02-28','09:00:00',1.89),('8784','2013-02-28','09:05:00',1.96),('8784','2013-02-28','09:10:00',1.99),('8784','2013-02-28','09:15:00',2.07),('8784','2013-02-28','09:20:00',2.17),('8784','2013-02-28','09:25:00',2.19),('8784','2013-02-28','09:30:00',2.29),('8784','2013-02-28','09:35:00',2.37),('8784','2013-02-28','09:40:00',2.43),('8784','2013-02-28','09:45:00',2.53),('8784','2013-02-28','09:50:00',2.39),('8784','2013-02-28','09:55:00',2.59),('8784','2013-02-28','10:00:00',2.68),('8784','2013-02-28','10:05:00',2.74),('8784','2013-02-28','10:10:00',2.78),('8784','2013-02-28','10:15:00',2.8),('8784','2013-02-28','10:20:00',2.87),('8784','2013-02-28','10:25:00',2.94),('8784','2013-02-28','10:30:00',2.89),('8784','2013-02-28','10:35:00',2.94),('8784','2013-02-28','10:40:00',3),('8784','2013-02-28','10:45:00',3.06),('8784','2013-02-28','10:50:00',3.12),('8784','2013-02-28','10:55:00',3.1),('8784','2013-02-28','11:00:00',3.2),('8784','2013-02-28','11:05:00',3.26),('8784','2013-02-28','11:10:00',3.26),('8784','2013-02-28','11:15:00',3.29),('8784','2013-02-28','11:20:00',3.31),('8784','2013-02-28','11:25:00',3.4),('8784','2013-02-28','11:30:00',3.39),('8784','2013-02-28','11:35:00',3.34),('8784','2013-02-28','11:40:00',3.35),('8784','2013-02-28','11:45:00',3.23),('8784','2013-02-28','11:50:00',3.25),('8784','2013-02-28','11:55:00',3.29),('8784','2013-02-28','12:00:00',3.31),('8784','2013-02-28','12:05:00',3.3),('8784','2013-02-28','12:10:00',3.31),('8784','2013-02-28','12:15:00',3.38),('8784','2013-02-28','12:20:00',3.47),('8784','2013-02-28','12:25:00',3.45),('8784','2013-02-28','12:30:00',3.48),('8784','2013-02-28','12:35:00',3.49),('8784','2013-02-28','12:40:00',3.4),('8784','2013-02-28','12:45:00',3.33),('8784','2013-02-28','12:50:00',3.34),('8784','2013-02-28','12:55:00',3.3),('8784','2013-02-28','13:00:00',3.17),('8784','2013-02-28','13:05:00',3.37),('8784','2013-02-28','13:10:00',3.26),('8784','2013-02-28','13:15:00',3.22),('8784','2013-02-28','13:20:00',2.3),('8784','2013-02-28','13:25:00',2.82),('8784','2013-02-28','13:30:00',2.8),('8784','2013-02-28','13:35:00',3.24),('8784','2013-02-28','13:40:00',3.26),('8784','2013-02-28','13:45:00',3.25),('8784','2013-02-28','13:50:00',3.21),('8784','2013-02-28','13:55:00',3.2),('8784','2013-02-28','14:00:00',3.27),('8784','2013-02-28','14:05:00',3.28),('8784','2013-02-28','14:10:00',3.14),('8784','2013-02-28','14:15:00',2.99),('8784','2013-02-28','14:20:00',2.87),('8784','2013-02-28','14:25:00',2.71),('8784','2013-02-28','14:30:00',2.58),('8784','2013-02-28','14:35:00',2.43),('8784','2013-02-28','14:40:00',2.5),('8784','2013-02-28','14:45:00',2.44),('8784','2013-02-28','14:50:00',2.39),('8784','2013-02-28','14:55:00',2.3),('8784','2013-02-28','15:00:00',2.23),('8784','2013-02-28','15:05:00',2.15),('8784','2013-02-28','15:10:00',2.06),('8784','2013-02-28','15:15:00',1.98),('8784','2013-02-28','15:20:00',1.99),('8784','2013-02-28','15:25:00',1.84),('8784','2013-02-28','15:30:00',1.72),('8784','2013-02-28','15:35:00',1.67),('8784','2013-02-28','15:40:00',1.6),('8784','2013-02-28','15:45:00',1.56),('8784','2013-02-28','15:50:00',1.48),('8784','2013-02-28','15:55:00',1.4),('8784','2013-02-28','16:00:00',1.33),('8784','2013-02-28','16:05:00',1.24),('8784','2013-02-28','16:10:00',1.15),('8784','2013-02-28','16:15:00',1.09),('8784','2013-02-28','16:20:00',1.02),('8784','2013-02-27','08:15:00',1.07),('8784','2013-02-27','08:20:00',1.15),('8784','2013-02-27','08:25:00',1.23),('8784','2013-02-27','08:30:00',1.32),('8784','2013-02-27','08:35:00',1.41),('8784','2013-02-27','08:40:00',1.48),('8784','2013-02-27','08:45:00',1.56),('8784','2013-02-27','08:50:00',1.63),('8784','2013-02-27','08:55:00',1.7),('8784','2013-02-27','09:00:00',1.78),('8784','2013-02-27','09:05:00',1.87),('8784','2013-02-27','09:10:00',1.95),('8784','2013-02-27','09:15:00',2.02),('8784','2013-02-27','09:20:00',2.1),('8784','2013-02-27','09:25:00',2.18),('8784','2013-02-27','09:30:00',2.25),('8784','2013-02-27','09:35:00',2.31),('8784','2013-02-27','09:40:00',2.36),('8784','2013-02-27','09:45:00',2.43),('8784','2013-02-27','09:50:00',2.5),('8784','2013-02-27','09:55:00',2.57),('8784','2013-02-27','10:00:00',2.63),('8784','2013-02-27','10:05:00',2.69),('8784','2013-02-27','10:10:00',2.74),('8784','2013-02-27','10:15:00',2.79),('8784','2013-02-27','10:20:00',2.85),('8784','2013-02-27','10:25:00',2.91),('8784','2013-02-27','10:30:00',2.91),('8784','2013-02-27','10:35:00',2.99),('8784','2013-02-27','10:40:00',2.97),('8784','2013-02-27','10:46:00',3.05),('8784','2013-02-27','10:50:00',3.09),('8784','2013-02-27','10:58:00',3.11),('8784','2013-02-27','11:00:00',3.19),('8784','2013-02-27','11:05:00',3.2),('8784','2013-02-27','11:10:00',3.25),('8784','2013-02-27','11:15:00',3.14),('8784','2013-02-27','11:20:00',3.21),('8784','2013-02-27','11:25:00',2.86),('8784','2013-02-27','11:30:00',1.3),('8784','2013-02-27','11:35:00',1.87),('8784','2013-02-27','11:40:00',1.17),('8784','2013-02-27','11:45:00',1.2),('8784','2013-02-27','11:50:00',2.02),('8784','2013-02-27','11:55:00',2.6),('8784','2013-02-27','12:00:00',3.6),('8784','2013-02-27','12:05:00',3.11),('8784','2013-02-27','12:15:00',3),('8784','2013-02-27','12:20:00',3.74),('8784','2013-02-27','12:25:00',3.24),('8784','2013-02-27','12:30:00',3.54),('8784','2013-02-27','12:35:00',3.55),('8784','2013-02-27','12:40:00',3.55),('8784','2013-02-27','12:45:00',3.52),('8784','2013-02-27','12:50:00',3.43),('8784','2013-02-27','12:55:00',3.43),('8784','2013-02-27','13:00:00',3.44),('8784','2013-02-27','13:05:00',3.43),('8784','2013-02-27','13:10:00',3.31),('8784','2013-02-27','13:15:00',3.36),('8784','2013-02-27','13:20:00',3.43),('8784','2013-02-27','13:25:00',3.45),('8784','2013-02-27','13:30:00',3.43),('8784','2013-02-27','13:35:00',3.32),('8784','2013-02-27','13:40:00',3.33),('8784','2013-02-27','13:45:00',3.26),('8784','2013-02-27','13:50:00',3.2),('8784','2013-02-27','13:55:00',3.2),('8784','2013-02-27','14:00:00',3.01),('8784','2013-02-27','14:05:00',2.6),('8784','2013-02-27','14:10:00',2.07),('8784','2013-02-27','14:15:00',2.72),('8784','2013-02-27','14:20:00',2.68),('8784','2013-02-27','14:25:00',1.52),('8784','2013-02-27','14:30:00',2.07),('8784','2013-02-27','14:35:00',2.68),('8784','2013-02-27','14:40:00',2.6),('8784','2013-02-27','14:45:00',2.56),('8784','2013-02-27','14:50:00',1.78),('8784','2013-02-27','14:55:00',2.24),('8784','2013-02-27','15:00:00',2.28),('8784','2013-02-27','15:05:00',2.3),('8784','2013-02-27','15:10:00',2.09),('8784','2013-02-27','15:15:00',2.01),('8784','2013-02-27','15:20:00',1.94),('8784','2013-02-27','15:25:00',1.91),('8784','2013-02-27','15:30:00',1.85),('8784','2013-02-27','15:35:00',1.78),('8784','2013-02-27','15:40:00',1.72),('8784','2013-02-27','15:45:00',1.65),('8784','2013-02-27','15:50:00',1.56),('8784','2013-02-27','15:55:00',1.5),('8784','2013-02-27','16:00:00',1.4),('8784','2013-02-27','16:05:00',1.32),('8784','2013-02-27','16:10:00',1.24),('8784','2013-02-27','16:15:00',1.16),('8784','2013-02-27','16:20:00',1.09),('8784','2013-02-26','09:15:00',1.02),('8784','2013-02-26','09:20:00',1.08),('8784','2013-02-26','09:25:00',1.16),('8784','2013-02-26','09:30:00',1.35),('8784','2013-02-26','09:35:00',1.68),('8784','2013-02-26','09:40:00',1.85),('8784','2013-02-26','09:45:00',1.85),('8784','2013-02-26','09:50:00',1.89),('8784','2013-02-26','09:55:00',2.08),('8784','2013-02-26','10:00:00',1.99),('8784','2013-02-26','10:05:00',1.94),('8784','2013-02-26','10:10:00',2.26),('8784','2013-02-26','10:15:00',2.47),('8784','2013-02-26','10:20:00',3),('8784','2013-02-26','10:25:00',2.89),('8784','2013-02-26','10:30:00',2.9),('8784','2013-02-26','10:35:00',2.78),('8784','2013-02-26','10:40:00',2.13),('8784','2013-02-26','10:45:00',1.56),('8784','2013-02-26','10:50:00',1.79),('8784','2013-02-26','10:55:00',1.83),('8784','2013-02-26','11:00:00',2.23),('8784','2013-02-26','11:05:00',2.3),('8784','2013-02-26','11:10:00',2.38),('8784','2013-02-26','11:15:00',1.86),('8784','2013-02-26','11:20:00',1.9),('8784','2013-02-26','11:25:00',1.78),('8784','2013-02-26','11:30:00',1.64),('8784','2013-02-26','11:35:00',1.54),('8784','2013-02-26','11:40:00',1.57),('8784','2013-02-26','11:45:00',1.61),('8784','2013-02-26','11:50:00',1.74),('8784','2013-02-26','11:55:00',1.92),('8784','2013-02-26','12:00:00',1.67),('8784','2013-02-26','12:05:00',1.65),('8784','2013-02-26','12:10:00',1.72),('8784','2013-02-26','12:15:00',1.57),('8784','2013-02-26','12:20:00',1.59),('8784','2013-02-26','12:25:00',1.47),('8784','2013-02-26','12:30:00',1.46),('8784','2013-02-26','12:35:00',1.35),('8784','2013-02-26','12:40:00',1.25),('8784','2013-02-26','12:45:00',1.13),('8784','2013-02-26','12:50:00',1.05),('8784','2013-02-26','12:55:00',1.12),('8784','2013-02-26','13:00:00',1.16),('8784','2013-02-26','13:05:00',1.04),('8784','2013-02-26','13:15:00',1.01),('8784','2013-02-26','13:20:00',1.05),('8784','2013-02-26','13:25:00',1.08),('8784','2013-02-26','13:30:00',1.1),('8784','2013-02-26','13:35:00',1.11),('8784','2013-02-26','13:40:00',1.11),('8784','2013-02-26','13:45:00',1.04),('8784','2013-02-25','08:40:00',1.14),('8784','2013-02-25','08:45:00',1.1),('8784','2013-02-25','08:50:00',1.03),('8784','2013-02-25','09:00:00',1.24),('8784','2013-02-25','09:20:00',1.12),('8784','2013-02-25','09:25:00',1.48),('8784','2013-02-25','09:30:00',1.63),('8784','2013-02-25','09:35:00',1.59),('8784','2013-02-25','09:40:00',1.17),('8784','2013-02-25','10:45:00',1.86),('8784','2013-02-25','10:50:00',3.33),('8784','2013-02-25','10:55:00',4.46),('8784','2013-02-25','11:00:00',3.85),('8784','2013-02-25','11:05:00',2.09),('8784','2013-02-25','11:10:00',2.27),('8784','2013-02-25','11:15:00',2.27),('8784','2013-02-25','11:20:00',1.19),('8784','2013-02-25','11:25:00',1.2),('8784','2013-02-25','11:30:00',1.36),('8784','2013-02-25','11:35:00',1.39),('8784','2013-02-25','11:40:00',1.65),('8784','2013-02-25','11:45:00',1.85),('8784','2013-02-25','11:50:00',2.76),('8784','2013-02-25','11:55:00',4.69),('8784','2013-02-25','12:00:00',3.01),('8784','2013-02-25','12:05:00',2.44),('8784','2013-02-25','12:10:00',2.06),('8784','2013-02-25','12:15:00',2.06),('8784','2013-02-25','12:20:00',3.86),('8784','2013-02-25','12:25:00',4.17),('8784','2013-02-25','12:30:00',3.15),('8784','2013-02-25','12:35:00',2.93),('8784','2013-02-25','12:40:00',3.76),('8784','2013-02-25','12:45:00',3.28),('8784','2013-02-25','12:50:00',3.63),('8784','2013-02-25','12:55:00',3.58),('8784','2013-02-25','13:00:00',2.18),('8784','2013-02-25','13:05:00',2.88),('8784','2013-02-25','13:10:00',1.55),('8784','2013-02-25','13:15:00',2.36),('8784','2013-02-25','13:20:00',1.89),('8784','2013-02-25','13:25:00',1.7),('8784','2013-02-25','13:30:00',1.73),('8784','2013-02-25','13:35:00',1.6),('8784','2013-02-25','13:40:00',1.26),('8784','2013-02-25','13:45:00',1.08),('8784','2013-02-24','10:45:00',1.06),('8784','2013-02-24','10:50:00',1.54),('8784','2013-02-24','10:55:00',1.42),('8784','2013-02-24','11:00:00',1.11),('8784','2013-02-24','11:05:00',1.05),('8784','2013-02-24','11:25:00',1.01),('8784','2013-02-24','11:30:00',1.06),('8784','2013-02-24','11:45:00',1.01),('8784','2013-02-24','11:50:00',1),('8784','2013-02-24','12:35:00',1.07),('8784','2013-02-24','12:40:00',1.22),('8784','2013-02-24','12:45:00',1.33),('8784','2013-02-24','12:50:00',1.09),('8784','2013-02-24','12:55:00',1.03),('8784','2013-02-24','13:00:00',1.28),('8784','2013-02-24','13:05:00',1.58),('8784','2013-02-24','13:10:00',1.59),('8784','2013-02-24','13:15:00',1.49),('8784','2013-02-24','13:20:00',1.61),('8784','2013-02-24','13:25:00',1.02),('8784','2013-02-24','13:30:00',1.17),('8784','2013-02-24','13:35:00',1.43),('8784','2013-02-24','13:40:00',1.28),('8784','2013-02-24','13:45:00',1.37),('8784','2013-02-24','13:50:00',1.13),('8784','2013-02-24','13:55:00',1.08),('8784','2013-02-24','14:00:00',1.15),('8784','2013-02-24','14:05:00',1.81),('8784','2013-02-24','14:10:00',1.56),('8784','2013-02-24','14:15:00',1.15),('8784','2013-02-24','14:20:00',1.03),('8784','2013-02-24','14:25:00',1),('8784','2013-02-24','14:30:00',1.25),('8784','2013-02-24','14:35:00',1.28),('8784','2013-02-24','15:10:00',2.44),('8784','2013-02-24','15:20:00',1.42),('8784','2013-02-24','15:25:00',1.57),('8784','2013-02-24','15:30:00',1.62),('8784','2013-02-24','15:35:00',1.34),('8784','2013-02-24','15:40:00',1.12),('8784','2013-02-24','15:45:00',1.48),('8784','2013-02-24','15:55:00',1.53),('8784','2013-02-24','16:00:00',1.66),('8784','2013-02-23','08:05:00',1.06),('8784','2013-02-23','08:10:00',1.3),('8784','2013-02-23','08:15:00',1.62),('8784','2013-02-23','08:20:00',1.01),('8784','2013-02-23','08:55:00',1.11),('8784','2013-02-23','09:00:00',1.41),('8784','2013-02-23','09:05:00',1.36),('8784','2013-02-23','09:10:00',1.06),('8784','2013-02-23','09:40:00',1.08),('8784','2013-02-23','09:45:00',1.43),('8784','2013-02-23','09:50:00',1.48),('8784','2013-02-23','09:55:00',1.46),('8784','2013-02-23','10:00:00',1.16),('8784','2013-02-23','10:05:00',1.1),('8784','2013-02-23','10:25:00',1.17),('8784','2013-02-23','10:30:00',1.1),('8784','2013-02-23','10:35:00',1.03),('8784','2013-02-23','10:50:00',1.05),('8784','2013-02-23','13:55:00',1.03),('8784','2013-02-23','14:00:00',1.1),('8784','2013-02-23','14:05:00',1.89),('8784','2013-02-23','14:10:00',1.39),('8784','2013-02-22','12:55:00',1.05),('8784','2013-02-22','14:15:00',1.02),('8784','2013-02-22','14:20:00',1.01),('8784','2013-02-22','14:35:00',1.42),('8784','2013-02-22','14:40:00',1.45),('8784','2013-02-22','14:45:00',1.08),('8784','2013-02-22','14:50:00',1.01),('8784','2013-02-22','14:55:00',1.29),('8784','2013-02-22','16:20:00',1.2),('8784','2013-02-22','16:25:00',1.35),('8784','2013-02-22','16:30:00',1.03),('8784','2013-02-21','11:30:00',1.05),('8784','2013-02-21','11:35:00',1.1),('8784','2013-02-21','11:40:00',1.08),('8784','2013-02-21','11:45:00',1.14),('8784','2013-02-21','11:50:00',1.27),('8784','2013-02-21','11:55:00',1.28),('8784','2013-02-21','12:00:00',1.26),('8784','2013-02-21','12:05:00',1.27),('8784','2013-02-21','12:10:00',1.31),('8784','2013-02-21','12:15:00',1.4),('8784','2013-02-21','12:20:00',1.49),('8784','2013-02-21','12:25:00',1.44),('8784','2013-02-21','12:30:00',1.35),('8784','2013-02-21','12:35:00',1.29),('8784','2013-02-21','12:40:00',1.26),('8784','2013-02-21','12:45:00',1.27),('8784','2013-02-21','12:50:00',1.29),('8784','2013-02-21','12:55:00',1.38),('8784','2013-02-21','13:00:00',1.38),('8784','2013-02-21','13:05:00',1.28),('8784','2013-02-21','13:10:00',1.23),('8784','2013-02-21','13:15:00',1.26),('8784','2013-02-21','13:20:00',1.34),('8784','2013-02-21','13:25:00',1.37),('8784','2013-02-21','13:30:00',1.38),('8784','2013-02-21','13:35:00',1.37),('8784','2013-02-21','13:40:00',1.32),('8784','2013-02-21','13:45:00',1.23),('8784','2013-02-21','13:50:00',1.27),('8784','2013-02-21','13:55:00',1.27),('8784','2013-02-21','14:00:00',1.28),('8784','2013-02-21','14:05:00',1.22),('8784','2013-02-21','14:10:00',1.13),('8784','2013-02-21','16:05:00',1),('8784','2013-02-21','16:20:00',1.27),('8784','2013-02-21','16:25:00',1.34),('8784','2013-02-21','16:30:00',1.21),('8784','2013-02-21','16:35:00',1.03),('8784','2014-03-23','08:30:00',1.03),('8784','2014-03-23','08:35:00',1.09),('8784','2014-03-23','08:50:00',1.23),('8784','2014-03-23','08:55:00',1.56),('8784','2014-03-23','09:00:00',1.01),('8784','2014-03-23','09:05:00',1.78),('8784','2014-03-23','09:10:00',2.59),('8784','2014-03-23','09:15:00',2.54),('8784','2014-03-23','09:20:00',1.81),('8784','2014-03-23','09:25:00',1.13),('8784','2014-03-23','09:30:00',1.51),('8784','2014-03-23','09:35:00',1.55),('8784','2014-03-23','09:40:00',1.37),('8784','2014-03-23','10:25:00',1.26),('8784','2014-03-23','10:40:00',1.3),('8784','2014-03-23','10:45:00',1.2),('8784','2014-03-23','10:50:00',1.33),('8784','2014-03-23','10:55:00',1.79),('8784','2014-03-23','11:00:00',1.31),('8784','2014-03-23','11:05:00',1.1),('8784','2014-03-23','11:10:00',1.4),('8784','2014-03-23','11:25:00',1.11),('8784','2014-03-23','11:35:00',1.73),('8784','2014-03-23','11:40:00',3.69),('8784','2014-03-23','11:45:00',1.01),('8784','2014-03-23','13:40:00',1.1),('8784','2014-03-23','13:45:00',2.45),('8784','2014-03-23','13:50:00',1.71),('8784','2014-03-23','13:55:00',1.4),('8784','2014-03-23','14:00:00',1.01),('8784','2014-03-23','15:05:00',1.08),('8784','2014-03-23','15:10:00',1.38),('8784','2014-03-23','15:15:00',1.66),('8784','2014-03-23','15:20:00',1.69),('8784','2014-03-23','15:25:00',1.81),('8784','2014-03-23','15:30:00',1.23),('8784','2014-03-23','15:40:00',1.08),('8784','2013-02-20','08:20:00',1.06),('8784','2013-02-20','08:25:00',1.14),('8784','2013-02-20','08:30:00',1.21),('8784','2013-02-20','08:35:00',1.28),('8784','2013-02-20','08:40:00',1.37),('8784','2013-02-20','08:45:00',1.46),('8784','2013-02-20','08:50:00',1.54),('8784','2013-02-20','08:55:00',1.51),('8784','2013-02-20','09:00:00',1.72),('8784','2013-02-20','09:05:00',1.05),('8784','2013-02-20','09:10:00',1.47),('8784','2013-02-20','09:15:00',1.54),('8784','2013-02-20','09:20:00',1.45),('8784','2013-02-20','09:25:00',2.15),('8784','2013-02-20','09:30:00',1.35),('8784','2013-02-20','09:35:00',1.89),('8784','2013-02-20','09:40:00',1.06),('8784','2013-02-20','09:45:00',1.31),('8784','2013-02-20','09:50:00',1.94),('8784','2013-02-20','09:55:00',1.89),('8784','2013-02-20','10:05:00',2.37),('8784','2013-02-20','10:10:00',1.67),('8784','2013-02-20','10:15:00',1.04),('8784','2013-02-20','10:45:00',2.45),('8784','2013-02-20','10:50:00',2.73),('8784','2013-02-20','10:55:00',1.25),('8784','2013-02-20','11:05:00',2.47),('8784','2013-02-20','11:10:00',3.89),('8784','2013-02-20','11:15:00',3.01),('8784','2013-02-20','11:20:00',2.96),('8784','2013-02-20','11:25:00',2.05),('8784','2013-02-20','11:30:00',1.34),('8784','2013-02-20','11:35:00',3.78),('8784','2013-02-20','11:40:00',3.9),('8784','2013-02-20','11:45:00',4.14),('8784','2013-02-20','11:50:00',3.16),('8784','2013-02-20','11:55:00',3.45),('8784','2013-02-20','12:00:00',1.71),('8784','2013-02-20','12:05:00',1.09),('8784','2013-02-20','12:10:00',2.47),('8784','2013-02-20','12:15:00',3.76),('8784','2013-02-20','12:20:00',1.85),('8784','2013-02-20','12:25:00',3.81),('8784','2013-02-20','12:30:00',4.15),('8784','2013-02-20','12:35:00',2.12),('8784','2013-02-20','12:45:00',1.13),('8784','2013-02-20','12:50:00',1.23),('8784','2013-02-20','12:55:00',2.17),('8784','2013-02-20','13:00:00',3.54),('8784','2013-02-20','13:05:00',2.6),('8784','2013-02-20','13:10:00',3.76),('8784','2013-02-20','13:15:00',3.85),('8784','2013-02-20','13:20:00',1.79),('8784','2013-02-20','13:25:00',1.65),('8784','2013-02-20','13:30:00',1.91),('8784','2013-02-20','13:35:00',1.48),('8784','2013-02-20','13:40:00',1.8),('8784','2013-02-20','13:45:00',1.4),('8784','2013-02-20','13:50:00',1.25),('8784','2013-02-20','13:55:00',1.68),('8784','2013-02-20','14:00:00',1.42),('8784','2013-02-20','14:40:00',1.35),('8784','2013-02-20','14:45:00',1.13),('8784','2013-02-20','15:05:00',1.43),('8784','2013-02-20','15:10:00',2.17),('8784','2013-02-20','15:15:00',2.57),('8784','2013-02-20','15:20:00',2.28),('8784','2013-02-20','15:25:00',2.19),('8784','2013-02-20','15:30:00',1.7),('8784','2013-02-20','15:35:00',1.02),('8784','2013-02-20','16:05:00',1.66),('8784','2013-02-20','16:10:00',1.59),('8784','2013-02-20','16:15:00',1.46),('8784','2013-02-20','16:20:00',1.27),('8784','2013-02-20','16:25:00',1.05),('8784','2013-02-19','08:25:00',1.05),('8784','2013-02-19','08:30:00',1.15),('8784','2013-02-19','08:35:00',1.22),('8784','2013-02-19','08:40:00',1.2),('8784','2013-02-19','08:45:00',1.35),('8784','2013-02-19','08:50:00',1.45),('8784','2013-02-19','08:55:00',1.46),('8784','2013-02-19','09:00:00',1.6),('8784','2013-02-19','09:05:00',1.66),('8784','2013-02-19','09:10:00',1.76),('8784','2013-02-19','09:15:00',1.84),('8784','2013-02-19','09:20:00',1.95),('8784','2013-02-19','09:25:00',2.02),('8784','2013-02-19','09:30:00',2.09),('8784','2013-02-19','09:35:00',2.11),('8784','2013-02-19','09:40:00',2.21),('8784','2013-02-19','09:45:00',2.32),('8784','2013-02-19','09:50:00',2.39),('8784','2013-02-19','09:55:00',2.45),('8784','2013-02-19','10:00:00',2.52),('8784','2013-02-19','10:05:00',2.57),('8784','2013-02-19','10:10:00',2.62),('8784','2013-02-19','10:15:00',2.68),('8784','2013-02-19','10:20:00',2.74),('8784','2013-02-19','10:25:00',2.79),('8784','2013-02-19','10:30:00',2.83),('8784','2013-02-19','10:35:00',2.89),('8784','2013-02-19','10:40:00',2.91),('8784','2013-02-19','10:45:00',2.94),('8784','2013-02-19','10:50:00',2.99),('8784','2013-02-19','10:55:00',3.01),('8784','2013-02-19','11:00:00',3.07),('8784','2013-02-19','11:05:00',3.07),('8784','2013-02-19','11:10:00',3.14),('8784','2013-02-19','11:15:00',3.19),('8784','2013-02-19','11:20:00',3.19),('8784','2013-02-19','11:25:00',3.23),('8784','2013-02-19','11:30:00',3.24),('8784','2013-02-19','11:35:00',3.25),('8784','2013-02-19','11:40:00',3.23),('8784','2013-02-19','11:45:00',3.25),('8784','2013-02-19','11:50:00',3.27),('8784','2013-02-19','11:55:00',3.24),('8784','2013-02-19','12:00:00',3.26),('8784','2013-02-19','12:05:00',3.29),('8784','2013-02-19','12:10:00',3.25),('8784','2013-02-19','12:15:00',3.28),('8784','2013-02-19','12:20:00',3.27),('8784','2013-02-19','12:25:00',3.24),('8784','2013-02-19','12:30:00',3.23),('8784','2013-02-19','12:35:00',3.29),('8784','2013-02-19','12:40:00',3.26),('8784','2013-02-19','12:45:00',3.25),('8784','2013-02-19','12:50:00',3.26),('8784','2013-02-19','12:55:00',3.24),('8784','2013-02-19','13:00:00',3.21),('8784','2013-02-19','13:05:00',3.22),('8784','2013-02-19','13:10:00',3.19),('8784','2013-02-19','13:15:00',3.19),('8784','2013-02-19','13:20:00',3.18),('8784','2013-02-19','13:25:00',3.12),('8784','2013-02-19','13:30:00',3.06),('8784','2013-02-19','13:35:00',3.02),('8784','2013-02-19','13:40:00',2.98),('8784','2013-02-19','13:45:00',2.95),('8784','2013-02-19','13:50:00',2.9),('8784','2013-02-19','13:55:00',2.87),('8784','2013-02-19','14:00:00',2.77),('8784','2013-02-19','14:05:00',2.71),('8784','2013-02-19','14:10:00',2.67),('8784','2013-02-19','14:15:00',2.52),('8784','2013-02-19','14:20:00',2.02),('8784','2013-02-19','14:25:00',2.14),('8784','2013-02-19','14:30:00',2.39),('8784','2013-02-19','14:35:00',2.31),('8784','2013-02-19','14:40:00',2.25),('8784','2013-02-19','14:45:00',2.21),('8784','2013-02-19','14:50:00',2.06),('8784','2013-02-19','14:55:00',2.06),('8784','2013-02-19','15:00:00',2.06),('8784','2013-02-19','15:05:00',1.98),('8784','2013-02-19','15:10:00',1.92),('8784','2013-02-19','15:15:00',1.9),('8784','2013-02-19','15:20:00',1.81),('8784','2013-02-19','15:25:00',1.72),('8784','2013-02-19','15:30:00',1.63),('8784','2013-02-19','15:35:00',1.55),('8784','2013-02-19','15:40:00',1.52),('8784','2013-02-19','15:45:00',1.47),('8784','2013-02-19','15:50:00',1.38),('8784','2013-02-19','15:55:00',1.31),('8784','2013-02-19','16:00:00',1.22),('8784','2013-02-19','16:05:00',1.14),('8784','2013-02-19','16:10:00',1.07),('8784','2013-02-18','08:30:00',1.06),('8784','2013-02-18','08:35:00',1.14),('8784','2013-02-18','08:40:00',1.15),('8784','2013-02-18','08:45:00',1.24),('8784','2013-02-18','08:50:00',1.35),('8784','2013-02-18','08:55:00',1.38),('8784','2013-02-18','09:00:00',1.28),('8784','2013-02-18','09:05:00',1.27),('8784','2013-02-18','09:10:00',1.64),('8784','2013-02-18','09:15:00',1.75),('8784','2013-02-18','09:20:00',1.83),('8784','2013-02-18','09:25:00',2.18),('8784','2013-02-18','09:30:00',1.49),('8784','2013-02-18','09:35:00',1.26),('8784','2013-02-18','09:50:00',1.52),('8784','2013-02-18','09:55:00',1.18),('8784','2013-02-18','10:05:00',1.07),('8784','2013-02-18','10:55:00',1.04),('8784','2013-02-18','11:00:00',1.3),('8784','2013-02-18','11:05:00',1.3),('8784','2013-02-18','11:10:00',1.39),('8784','2013-02-18','11:15:00',1.25),('8784','2013-02-18','11:20:00',1.57),('8784','2013-02-18','11:25:00',1.59),('8784','2013-02-18','11:30:00',1.49),('8784','2013-02-18','11:35:00',1.56),('8784','2013-02-18','11:40:00',1.51),('8784','2013-02-18','11:45:00',1.39),('8784','2013-02-18','11:50:00',1.49),('8784','2013-02-18','11:55:00',1.91),('8784','2013-02-18','12:00:00',2.02),('8784','2013-02-18','12:05:00',1.72),('8784','2013-02-18','12:10:00',1.57),('8784','2013-02-18','12:15:00',1.54),('8784','2013-02-18','12:20:00',1.5),('8784','2013-02-18','12:25:00',1.56),('8784','2013-02-18','12:30:00',1.42),('8784','2013-02-18','12:35:00',1.35),('8784','2013-02-18','12:40:00',1.41),('8784','2013-02-18','12:45:00',1.67),('8784','2013-02-18','12:50:00',1.66),('8784','2013-02-18','12:55:00',1.53),('8784','2013-02-18','13:00:00',1.54),('8784','2013-02-18','13:05:00',1.56),('8784','2013-02-18','13:10:00',1.51),('8784','2013-02-18','13:15:00',1.88),('8784','2013-02-18','13:20:00',1.52),('8784','2013-02-18','13:25:00',1.74),('8784','2013-02-18','13:30:00',1.57),('8784','2013-02-18','13:35:00',1.38),('8784','2013-02-18','13:40:00',1.37),('8784','2013-02-18','13:45:00',1.27),('8784','2013-02-18','13:50:00',1.29),('8784','2013-02-18','13:55:00',1.54),('8784','2013-02-18','14:00:00',1.57),('8784','2013-02-18','14:05:00',1.42),('8784','2013-02-18','14:10:00',1.26),('8784','2013-02-18','14:15:00',1.11),('8784','2013-02-18','14:20:00',1.2),('8784','2013-02-17','08:30:00',1.08),('8784','2013-02-17','08:35:00',1.22),('8784','2013-02-17','08:40:00',1.26),('8784','2013-02-17','08:45:00',1.31),('8784','2013-02-17','08:50:00',1.12),('8784','2013-02-17','08:55:00',1.38),('8784','2013-02-17','09:10:00',1.16),('8784','2013-02-17','09:15:00',1.69),('8784','2013-02-17','09:20:00',1.75),('8784','2013-02-17','09:25:00',1.77),('8784','2013-02-17','09:30:00',1.89),('8784','2013-02-17','09:35:00',1.99),('8784','2013-02-17','09:40:00',2.08),('8784','2013-02-17','09:45:00',2.14),('8784','2013-02-17','09:50:00',2.2),('8784','2013-02-17','09:55:00',2.27),('8784','2013-02-17','10:00:00',2.33),('8784','2013-02-17','10:05:00',2.41),('8784','2013-02-17','10:10:00',2.5),('8784','2013-02-17','10:15:00',2.54),('8784','2013-02-17','10:20:00',2.56),('8784','2013-02-17','10:25:00',2.61),('8784','2013-02-17','10:30:00',2.7),('8784','2013-02-17','10:35:00',2.74),('8784','2013-02-17','10:40:00',2.78),('8784','2013-02-17','10:45:00',2.82),('8784','2013-02-17','10:50:00',2.85),('8784','2013-02-17','10:55:00',2.88),('8784','2013-02-17','11:00:00',2.91),('8784','2013-02-17','11:05:00',2.94),('8784','2013-02-17','11:10:00',2.96),('8784','2013-02-17','11:15:00',3.02),('8784','2013-02-17','11:20:00',3.06),('8784','2013-02-17','11:25:00',3.07),('8784','2013-02-17','11:30:00',3.07),('8784','2013-02-17','11:35:00',3.09),('8784','2013-02-17','11:40:00',3.1),('8784','2013-02-17','11:45:00',3.15),('8784','2013-02-17','11:50:00',3.18),('8784','2013-02-17','11:55:00',3.19),('8784','2013-02-17','12:00:00',3.19),('8784','2013-02-17','12:05:00',3.21),('8784','2013-02-17','12:10:00',3.19),('8784','2013-02-17','12:15:00',3.18),('8784','2013-02-17','12:20:00',3.16),('8784','2013-02-17','12:25:00',3.12),('8784','2013-02-17','12:30:00',3.13),('8784','2013-02-17','12:35:00',3.11),('8784','2013-02-17','12:40:00',3.05),('8784','2013-02-17','12:45:00',3.05),('8784','2013-02-17','12:50:00',3.03),('8784','2013-02-17','12:55:00',3.05),('8784','2013-02-17','13:00:00',3.03),('8784','2013-02-17','13:05:00',2.29),('8784','2013-02-17','13:10:00',2.52),('8784','2013-02-17','13:15:00',2.52),('8784','2013-02-17','13:25:00',1.5),('8784','2013-02-17','13:30:00',2.79),('8784','2013-02-17','13:35:00',1.5),('8784','2013-02-17','13:40:00',2.7),('8784','2013-02-17','13:45:00',2.5),('8784','2013-02-17','13:50:00',2.34),('8784','2013-02-17','13:55:00',1.88),('8784','2013-02-17','14:10:00',2.61),('8784','2013-02-17','14:15:00',1.64),('8784','2013-02-17','14:25:00',1.73),('8784','2013-02-17','14:30:00',2.42),('8784','2013-02-17','14:35:00',2.25),('8784','2013-02-17','14:40:00',1.15),('8784','2013-02-17','15:00:00',1.99),('8784','2013-02-17','15:05:00',2.09),('8784','2013-02-17','15:10:00',2.3),('8784','2013-02-17','15:15:00',2.2),('8784','2013-02-17','15:20:00',2.14),('8784','2013-02-17','15:25:00',1.96),('8784','2013-02-17','15:30:00',1.81),('8784','2013-02-17','15:35:00',1.81),('8784','2013-02-17','15:40:00',1.77),('8784','2013-02-17','15:45:00',1.62),('8784','2013-02-17','15:50:00',1.53),('8784','2013-02-17','15:55:00',1.45),('8784','2013-02-17','16:00:00',1.33),('8784','2013-02-17','16:05:00',1.23),('8784','2013-02-17','16:25:00',1.13),('8784','2013-02-17','16:30:00',1.11),('8784','2013-02-16','08:35:00',1.05),('8784','2013-02-16','08:40:00',1.07),('8784','2013-02-16','08:45:00',1.12),('8784','2013-02-16','09:15:00',1.52),('8784','2013-02-16','09:20:00',1.84),('8784','2013-02-16','09:25:00',1.87),('8784','2013-02-16','09:30:00',1.93),('8784','2013-02-16','09:35:00',2.02),('8784','2013-02-16','09:40:00',2.07),('8784','2013-02-16','09:45:00',2.17),('8784','2013-02-16','09:50:00',2.26),('8784','2013-02-16','09:55:00',2.29),('8784','2013-02-16','10:00:00',2.33),('8784','2013-02-16','10:05:00',2.4),('8784','2013-02-16','10:10:00',2.51),('8784','2013-02-16','10:15:00',2.55),('8784','2013-02-16','10:20:00',2.62),('8784','2013-02-16','10:25:00',2.67),('8784','2013-02-16','10:30:00',2.7),('8784','2013-02-16','10:35:00',2.71),('8784','2013-02-16','10:40:00',2.69),('8784','2013-02-16','10:45:00',2.98),('8784','2013-02-16','10:50:00',2.89),('8784','2013-02-16','10:55:00',2.78),('8784','2013-02-16','11:00:00',3.01),('8784','2013-02-16','11:05:00',2.98),('8784','2013-02-16','11:10:00',3.01),('8784','2013-02-16','11:15:00',3.04),('8784','2013-02-16','11:20:00',2.98),('8784','2013-02-16','11:25:00',3.02),('8784','2013-02-16','11:30:00',3.14),('8784','2013-02-16','11:35:00',3.16),('8784','2013-02-16','11:40:00',3.16),('8784','2013-02-16','11:45:00',3.19),('8784','2013-02-16','11:50:00',3.22),('8784','2013-02-16','11:55:00',3.23),('8784','2013-02-16','12:00:00',3.22),('8784','2013-02-16','12:05:00',3.23),('8784','2013-02-16','12:10:00',3.21),('8784','2013-02-16','12:15:00',3.21),('8784','2013-02-16','12:20:00',3.19),('8784','2013-02-16','12:25:00',3.19),('8784','2013-02-16','12:30:00',3.17),('8784','2013-02-16','12:35:00',3.18),('8784','2013-02-16','12:40:00',3.15),('8784','2013-02-16','12:45:00',3.18),('8784','2013-02-16','12:50:00',3.19),('8784','2013-02-16','12:55:00',3.11),('8784','2013-02-16','13:00:00',3.07),('8784','2013-02-16','13:05:00',3.08),('8784','2013-02-16','13:10:00',3.06),('8784','2013-02-16','13:20:00',2.98),('8784','2013-02-16','13:25:00',2.99),('8784','2013-02-16','13:30:00',2.94),('8784','2013-02-16','13:35:00',2.93),('8784','2013-02-16','13:40:00',2.86),('8784','2013-02-16','13:45:00',2.88),('8784','2013-02-16','13:50:00',2.84),('8784','2013-02-16','13:55:00',2.74),('8784','2013-02-16','14:00:00',2.67),('8784','2013-02-16','14:05:00',2.7),('8784','2013-02-16','14:10:00',2.63),('8784','2013-02-16','14:15:00',2.48),('8784','2013-02-16','14:20:00',2.22),('8784','2013-02-16','14:25:00',1.28),('8784','2013-02-16','14:45:00',1.02),('8784','2013-02-16','14:55:00',1.06),('8784','2013-02-16','15:20:00',1.09),('8784','2013-02-16','15:25:00',1.13),('8784','2013-02-16','15:30:00',1.94),('8784','2013-02-16','15:35:00',2.01),('8784','2013-02-16','15:40:00',1.9),('8784','2013-02-16','15:45:00',1.64),('8784','2013-02-16','15:50:00',1.81),('8784','2013-02-16','15:55:00',1.36),('8784','2013-02-16','16:05:00',1.33),('8784','2013-02-15','09:20:00',1.34),('8784','2013-02-15','09:25:00',1.45),('8784','2013-02-15','09:30:00',1.02),('8784','2013-02-15','09:50:00',1.12),('8784','2013-02-15','09:55:00',1.42),('8784','2013-02-15','10:00:00',1.77),('8784','2013-02-15','10:05:00',1.78),('8784','2013-02-15','10:10:00',1.23),('8784','2013-02-15','10:15:00',1.22),('8784','2013-02-15','10:20:00',1.66),('8784','2013-02-15','10:25:00',2.17),('8784','2013-02-15','10:30:00',1.94),('8784','2013-02-15','10:35:00',2.71),('8784','2013-02-15','10:40:00',2.55),('8784','2013-02-15','10:45:00',2.64),('8784','2013-02-15','10:50:00',2.29),('8784','2013-02-15','10:55:00',1.74),('8784','2013-02-15','11:00:00',1.79),('8784','2013-02-15','11:05:00',2),('8784','2013-02-15','11:10:00',1.91),('8784','2013-02-15','11:15:00',2.73),('8784','2013-02-15','11:20:00',2.98),('8784','2013-02-15','11:25:00',3.11),('8784','2013-02-15','11:30:00',3.05),('8784','2013-02-15','11:35:00',2.24),('8784','2013-02-15','11:40:00',1.8),('8784','2013-02-15','11:45:00',2.34),('8784','2013-02-15','11:50:00',3.64),('8784','2013-02-15','11:55:00',2.92),('8784','2013-02-15','12:00:00',2.82),('8784','2013-02-15','12:05:00',2.74),('8784','2013-02-15','12:10:00',2.86),('8784','2013-02-15','12:15:00',3.22),('8784','2013-02-15','12:20:00',3.57),('8784','2013-02-15','12:25:00',3.22),('8784','2013-02-15','12:30:00',3.28),('8784','2013-02-15','12:35:00',3.23),('8784','2013-02-15','12:40:00',3.17),('8784','2013-02-15','12:45:00',3.19),('8784','2013-02-15','12:50:00',3.17),('8784','2013-02-15','12:55:00',3.13),('8784','2013-02-15','13:00:00',3.06),('8784','2013-02-15','13:05:00',3.05),('8784','2013-02-15','13:10:00',3.11),('8784','2013-02-15','13:15:00',3.09),('8784','2013-02-15','13:20:00',2.87),('8784','2013-02-15','13:25:00',2.69),('8784','2013-02-15','13:30:00',2.01),('8784','2013-02-15','13:35:00',2.15),('8784','2013-02-15','13:40:00',2.84),('8784','2013-02-15','13:45:00',2.24),('8784','2013-02-15','13:50:00',2.27),('8784','2013-02-15','13:55:00',2.42),('8784','2013-02-15','14:00:00',1.87),('8784','2013-02-15','14:05:00',3.03),('8784','2013-02-15','14:10:00',3.14),('8784','2013-02-15','14:15:00',2.01),('8784','2013-02-15','14:20:00',1.92),('8784','2013-02-15','14:25:00',1.45),('8784','2013-02-15','14:30:00',1.44),('8784','2013-02-15','14:35:00',2.02),('8784','2013-02-15','14:40:00',2.13),('8784','2013-02-15','14:45:00',1.82),('8784','2013-02-15','14:50:00',1.15),('8784','2013-02-15','14:55:00',1.09),('8784','2013-02-15','15:00:00',1.62),('8784','2013-02-15','15:05:00',1.15),('8784','2013-02-15','15:10:00',1.25),('8784','2013-02-15','15:15:00',1.42),('8784','2013-02-15','15:20:00',1.16),('8784','2013-02-15','15:25:00',1.35),('8784','2013-02-15','15:30:00',1.45),('8784','2013-02-15','15:35:00',1.21),('8784','2013-02-15','15:40:00',1.21),('8784','2013-02-15','15:45:00',1.11),('8784','2013-02-14','08:35:00',1.03),('8784','2013-02-14','08:40:00',1.08),('8784','2013-02-14','08:45:00',1.16),('8784','2013-02-14','08:50:00',1.25),('8784','2013-02-14','08:55:00',1.33),('8784','2013-02-14','09:00:00',1.14),('8784','2013-02-14','09:05:00',1.28),('8784','2013-02-14','09:10:00',1.54),('8784','2013-02-14','09:15:00',1.6),('8784','2013-02-14','09:20:00',1.69),('8784','2013-02-14','09:25:00',1.79),('8784','2013-02-14','09:30:00',1.88),('8784','2013-02-14','09:35:00',2.01),('8784','2013-02-14','09:40:00',2.09),('8784','2013-02-14','09:45:00',2.18),('8784','2013-02-14','09:50:00',2.25),('8784','2013-02-14','09:55:00',2.32),('8784','2013-02-14','10:00:00',2.4),('8784','2013-02-14','10:05:00',2.52),('8784','2013-02-14','10:10:00',2.59),('8784','2013-02-14','10:15:00',2.64),('8784','2013-02-14','10:20:00',2.69),('8784','2013-02-14','10:25:00',2.74),('8784','2013-02-14','10:30:00',2.79),('8784','2013-02-14','10:35:00',2.84),('8784','2013-02-14','10:40:00',2.89),('8784','2013-02-14','10:45:00',2.94),('8784','2013-02-14','10:50:00',2.98),('8784','2013-02-14','10:55:00',3.02),('8784','2013-02-14','11:00:00',3.06),('8784','2013-02-14','11:05:00',3.08),('8784','2013-02-14','11:10:00',3.11),('8784','2013-02-14','11:15:00',3.13),('8784','2013-02-14','11:20:00',3.14),('8784','2013-02-14','11:25:00',3.17),('8784','2013-02-14','11:30:00',3.19),('8784','2013-02-14','11:35:00',3.21),('8784','2013-02-14','11:40:00',3.23),('8784','2013-02-14','11:45:00',3.23),('8784','2013-02-14','11:50:00',3.23),('8784','2013-02-14','11:55:00',3.25),('8784','2013-02-14','12:00:00',3.24),('8784','2013-02-14','12:05:00',3.25),('8784','2013-02-14','12:10:00',3.23),('8784','2013-02-14','12:15:00',3.23),('8784','2013-02-14','12:20:00',3.22),('8784','2013-02-14','12:25:00',3.22),('8784','2013-02-14','12:30:00',3.22),('8784','2013-02-14','12:35:00',3.2),('8784','2013-02-14','12:40:00',3.21),('8784','2013-02-14','12:45:00',3.19),('8784','2013-02-14','12:50:00',3.16),('8784','2013-02-14','12:55:00',3.1),('8784','2013-02-14','13:00:00',2.99),('8784','2013-02-14','13:05:00',3.07),('8784','2013-02-14','13:10:00',3.08),('8784','2013-02-14','13:15:00',3.08),('8784','2013-02-14','13:20:00',3.04),('8784','2013-02-14','13:25:00',2.97),('8784','2013-02-14','13:30:00',2.92),('8784','2013-02-14','13:35:00',2.91),('8784','2013-02-14','13:40:00',2.89),('8784','2013-02-14','13:45:00',2.85),('8784','2013-02-14','13:50:00',2.8),('8784','2013-02-14','13:55:00',2.74),('8784','2013-02-14','14:00:00',2.67),('8784','2013-02-14','14:05:00',2.65),('8784','2013-02-14','14:10:00',2.57),('8784','2013-02-14','14:15:00',2.34),('8784','2013-02-14','14:20:00',2.19),('8784','2013-02-14','14:25:00',2.4),('8784','2013-02-14','14:30:00',2.36),('8784','2013-02-14','14:35:00',2.28),('8784','2013-02-14','14:40:00',2.25),('8784','2013-02-14','14:45:00',2.19),('8784','2013-02-14','14:50:00',2.11),('8784','2013-02-14','14:55:00',2.05),('8784','2013-02-14','15:00:00',1.98),('8784','2013-02-14','15:05:00',1.92),('8784','2013-02-14','15:10:00',1.85),('8784','2013-02-14','15:15:00',1.76),('8784','2013-02-14','15:20:00',1.7),('8784','2013-02-14','15:25:00',1.62),('8784','2013-02-14','15:30:00',1.56),('8784','2013-02-14','15:35:00',1.48),('8784','2013-02-14','15:40:00',1.4),('8784','2013-02-14','15:45:00',1.33),('8784','2013-02-14','15:50:00',1.27),('8784','2013-02-14','15:55:00',1.18),('8784','2013-02-14','16:00:00',1.1),('8784','2013-02-14','16:05:00',1.02),('8784','2013-02-13','09:00:00',1.01),('8784','2013-02-13','09:05:00',1.06),('8784','2013-02-13','09:10:00',1.08),('8784','2013-02-13','09:15:00',1.07),('8784','2013-02-13','09:20:00',1.07),('8784','2013-02-13','09:25:00',1.14),('8784','2013-02-13','09:30:00',1.35),('8784','2013-02-13','09:35:00',1.81),('8784','2013-02-13','09:40:00',1.9),('8784','2013-02-13','09:45:00',2.1),('8784','2013-02-13','09:50:00',2.19),('8784','2013-02-13','09:55:00',2.09),('8784','2013-02-13','10:00:00',2.12),('8784','2013-02-13','10:05:00',2.27),('8784','2013-02-13','10:10:00',2.5),('8784','2013-02-13','10:15:00',2.62),('8784','2013-02-13','10:20:00',2.71),('8784','2013-02-13','10:25:00',2.77),('8784','2013-02-13','10:30:00',2.9),('8784','2013-02-13','10:35:00',2.97),('8784','2013-02-13','10:40:00',2.94),('8784','2013-02-13','10:45:00',3.07),('8784','2013-02-13','10:50:00',3.15),('8784','2013-02-13','10:55:00',3.15),('8784','2013-02-13','11:00:00',3.13),('8784','2013-02-13','11:05:00',3.21),('8784','2013-02-13','11:10:00',3.05),('8784','2013-02-13','11:15:00',3.06),('8784','2013-02-13','11:20:00',2.97),('8784','2013-02-13','11:25:00',2.69),('8784','2013-02-13','11:30:00',2.91),('8784','2013-02-13','11:35:00',1.71),('8784','2013-02-13','11:40:00',1.48),('8784','2013-02-13','11:45:00',1.67),('8784','2013-02-13','11:50:00',2.09),('8784','2013-02-13','11:55:00',1.41),('8784','2013-02-13','12:00:00',1.11),('8784','2013-02-13','12:05:00',1.58),('8784','2013-02-13','12:10:00',2.59),('8784','2013-02-13','12:15:00',2.11),('8784','2013-02-13','12:20:00',2.79),('8784','2013-02-13','12:25:00',1.86),('8784','2013-02-13','12:30:00',1.12),('8784','2013-02-13','12:35:00',1.49),('8784','2013-02-13','12:40:00',1.2),('8784','2013-02-13','12:45:00',2.36),('8784','2013-02-13','12:50:00',2.55),('8784','2013-02-13','12:55:00',2.3),('8784','2013-02-13','13:00:00',2.48),('8784','2013-02-13','13:05:00',1.71),('8784','2013-02-13','13:10:00',2.42),('8784','2013-02-13','13:15:00',2.28),('8784','2013-02-13','13:20:00',3.07),('8784','2013-02-13','13:25:00',3.07),('8784','2013-02-13','13:30:00',3.11),('8784','2013-02-13','13:35:00',3.17),('8784','2013-02-13','13:40:00',2.93),('8784','2013-02-13','13:45:00',2.54),('8784','2013-02-13','13:50:00',2.4),('8784','2013-02-13','13:55:00',2.5),('8784','2013-02-13','14:00:00',2.64),('8784','2013-02-13','14:05:00',2.81),('8784','2013-02-13','14:10:00',2.63),('8784','2013-02-13','14:15:00',2.36),('8784','2013-02-13','14:20:00',2.19),('8784','2013-02-13','14:25:00',1.8),('8784','2013-02-13','14:30:00',2.14),('8784','2013-02-13','14:35:00',2.32),('8784','2013-02-13','14:40:00',2.23),('8784','2013-02-13','14:45:00',2.1),('8784','2013-02-13','14:50:00',2.16),('8784','2013-02-13','14:55:00',2.07),('8784','2013-02-13','15:00:00',1.97),('8784','2013-02-13','15:05:00',1.92),('8784','2013-02-13','15:10:00',1.84),('8784','2013-02-13','15:15:00',1.76),('8784','2013-02-13','15:20:00',1.69),('8784','2013-02-13','15:25:00',1.65),('8784','2013-02-13','15:30:00',1.56),('8784','2013-02-13','15:35:00',1.52),('8784','2013-02-13','15:40:00',1.44),('8784','2013-02-13','15:45:00',1.36),('8784','2013-02-13','15:50:00',1.27),('8784','2013-02-13','15:55:00',1.2),('8784','2013-02-13','16:00:00',1.13),('8784','2013-02-13','16:05:00',1.04),('8784','2013-02-11','10:20:00',1.09),('8784','2013-02-11','10:25:00',1.13),('8784','2013-02-11','10:30:00',1.13),('8784','2013-02-11','10:35:00',1.35),('8784','2013-02-11','10:40:00',1.18),('8784','2013-02-11','11:00:00',1.03),('8784','2013-02-11','11:05:00',1.22),('8784','2013-02-11','11:10:00',1.45),('8784','2013-02-11','11:15:00',1.54),('8784','2013-02-11','11:20:00',1.2),('8784','2013-02-11','11:45:00',1.3),('8784','2013-02-11','12:45:00',1.37),('8784','2013-02-11','14:00:00',1.05),('8784','2013-02-11','14:05:00',1.14),('8784','2013-02-11','14:10:00',1.27),('8784','2013-02-11','14:15:00',1.05),('8784','2013-02-11','14:20:00',1.09),('8784','2013-02-11','14:25:00',1.62),('8784','2013-02-11','14:30:00',2.08),('8784','2013-02-11','14:35:00',1.21),('8784','2013-02-11','14:40:00',1.72),('8784','2013-02-11','14:45:00',1.39),('8784','2014-03-22','07:40:00',1.37),('8784','2014-03-22','07:45:00',1.32),('8784','2014-03-22','07:50:00',1.16),('8784','2014-03-22','08:10:00',1.19),('8784','2014-03-22','08:15:00',1.42),('8784','2014-03-22','08:20:00',1.7),('8784','2014-03-22','08:25:00',1.7),('8784','2014-03-22','08:30:00',1.63),('8784','2014-03-22','08:35:00',1.04),('8784','2014-03-22','08:40:00',2.18),('8784','2014-03-22','08:45:00',2.16),('8784','2014-03-22','08:50:00',1.77),('8784','2014-03-22','08:55:00',1.94),('8784','2014-03-22','09:00:00',2.07),('8784','2014-03-22','09:05:00',1.39),('8784','2014-03-22','09:10:00',1.53),('8784','2014-03-22','09:15:00',1.33),('8784','2014-03-22','09:20:00',1.46),('8784','2014-03-22','09:25:00',1.92),('8784','2014-03-22','09:30:00',2.44),('8784','2014-03-22','09:35:00',1.59),('8784','2014-03-22','09:40:00',2.22),('8784','2014-03-22','09:45:00',2.91),('8784','2014-03-22','09:50:00',3.03),('8784','2014-03-22','09:55:00',2.98),('8784','2014-03-22','10:00:00',3.11),('8784','2014-03-22','10:05:00',2.1),('8784','2014-03-22','10:10:00',2.01),('8784','2014-03-22','10:15:00',2),('8784','2014-03-22','10:20:00',1.17),('8784','2014-03-22','10:30:00',1.09),('8784','2014-03-22','10:35:00',1.66),('8784','2014-03-22','10:40:00',2.02),('8784','2014-03-22','10:45:00',2.69),('8784','2014-03-22','10:50:00',2.14),('8784','2014-03-22','10:55:00',1.42),('8784','2014-03-22','11:00:00',1.35),('8784','2014-03-22','11:05:00',1.17),('8784','2014-03-22','11:10:00',1.48),('8784','2014-03-22','11:15:00',1.86),('8784','2014-03-22','11:20:00',3.79),('8784','2014-03-22','11:25:00',4.45),('8784','2014-03-22','11:30:00',3.15),('8784','2014-03-22','11:35:00',2.04),('8784','2014-03-22','11:40:00',2.95),('8784','2014-03-22','11:45:00',1.55),('8784','2014-03-22','11:50:00',3.35),('8784','2014-03-22','11:55:00',4.31),('8784','2014-03-22','12:00:00',1.97),('8784','2014-03-22','12:05:00',1.54),('8784','2014-03-22','12:10:00',1.39),('8784','2014-03-22','12:15:00',2.66),('8784','2014-03-22','12:20:00',3.83),('8784','2014-03-22','12:25:00',1.98),('8784','2014-03-22','12:30:00',1.96),('8784','2014-03-22','12:35:00',2.53),('8784','2014-03-22','12:40:00',3.98),('8784','2014-03-22','12:45:00',3.48),('8784','2014-03-22','12:50:00',2.87),('8784','2014-03-22','12:55:00',2.09),('8784','2014-03-22','13:00:00',1.57),('8784','2014-03-22','13:05:00',3.4),('8784','2014-03-22','13:10:00',4.06),('8784','2014-03-22','13:15:00',2.93),('8784','2014-03-22','13:20:00',3.64),('8784','2014-03-22','13:25:00',3.46),('8784','2014-03-22','13:30:00',2.66),('8784','2014-03-22','13:35:00',3.16),('8784','2014-03-22','13:40:00',3.69),('8784','2014-03-22','13:45:00',3.16),('8784','2014-03-22','13:50:00',3.01),('8784','2014-03-22','13:55:00',2.59),('8784','2014-03-22','14:00:00',3.01),('8784','2014-03-22','14:05:00',2.47),('8784','2014-03-22','14:10:00',3.04),('8784','2014-03-22','14:15:00',2.43),('8784','2014-03-22','14:20:00',3.16),('8784','2014-03-22','14:25:00',3.15),('8784','2014-03-22','14:30:00',3.08),('8784','2014-03-22','14:35:00',3.01),('8784','2014-03-22','14:40:00',2.93),('8784','2014-03-22','14:45:00',2.85),('8784','2014-03-22','14:50:00',2.81),('8784','2014-03-22','14:55:00',2.74),('8784','2014-03-22','15:00:00',2.63),('8784','2014-03-22','15:05:00',2.61),('8784','2014-03-22','15:10:00',2.42),('8784','2014-03-22','15:15:00',2.43),('8784','2014-03-22','15:20:00',2.4),('8784','2014-03-22','15:25:00',1.87),('8784','2014-03-22','15:30:00',1.35),('8784','2014-03-22','15:35:00',2.35),('8784','2014-03-22','15:40:00',2.69),('8784','2014-03-22','15:45:00',2.63),('8784','2014-03-22','15:50:00',2.6),('8784','2014-03-22','15:55:00',2.3),('8784','2014-03-22','16:00:00',2.11),('8784','2014-03-22','16:05:00',1.84),('8784','2014-03-22','16:10:00',1.67),('8784','2014-03-22','16:15:00',1.52),('8784','2014-03-22','16:20:00',1.3),('8784','2014-03-22','16:25:00',1.29),('8784','2013-02-10','09:50:00',1.35),('8784','2013-02-10','10:00:00',2.22),('8784','2013-02-10','10:05:00',2.35),('8784','2013-02-10','10:10:00',2.45),('8784','2013-02-10','10:15:00',2.55),('8784','2013-02-10','10:20:00',2.61),('8784','2013-02-10','10:25:00',2.67),('8784','2013-02-10','10:30:00',2.72),('8784','2013-02-10','10:35:00',2.75),('8784','2013-02-10','10:40:00',2.8),('8784','2013-02-10','10:45:00',2.83),('8784','2013-02-10','10:50:00',2.87),('8784','2013-02-10','10:55:00',2.91),('8784','2013-02-10','11:00:00',2.95),('8784','2013-02-10','11:05:00',2.97),('8784','2013-02-10','11:10:00',2.99),('8784','2013-02-10','11:15:00',2.99),('8784','2013-02-10','11:20:00',3.02),('8784','2013-02-10','11:25:00',3.03),('8784','2013-02-10','11:30:00',3.02),('8784','2013-02-10','11:35:00',3.07),('8784','2013-02-10','11:40:00',3.08),('8784','2013-02-10','11:45:00',3.1),('8784','2013-02-10','11:50:00',3.12),('8784','2013-02-10','11:55:00',3.12),('8784','2013-02-10','12:00:00',3.1),('8784','2013-02-10','12:05:00',3.17),('8784','2013-02-10','12:10:00',3.17),('8784','2013-02-10','12:15:00',3.19),('8784','2013-02-10','12:20:00',3.18),('8784','2013-02-10','12:25:00',3.17),('8784','2013-02-10','12:30:00',3.12),('8784','2013-02-10','12:35:00',3.15),('8784','2013-02-10','12:40:00',3.12),('8784','2013-02-10','12:45:00',3.09),('8784','2013-02-10','12:50:00',3.07),('8784','2013-02-10','12:55:00',3.02),('8784','2013-02-10','13:00:00',2.98),('8784','2013-02-10','13:05:00',2.96),('8784','2013-02-10','13:10:00',2.86),('8784','2013-02-10','13:15:00',2.85),('8784','2013-02-10','13:20:00',2.91),('8784','2013-02-10','13:25:00',2.9),('8784','2013-02-10','13:30:00',2.84),('8784','2013-02-10','13:35:00',2.8),('8784','2013-02-10','13:40:00',2.73),('8784','2013-02-10','13:45:00',2.63),('8784','2013-02-10','13:50:00',2.66),('8784','2013-02-10','13:55:00',2.61),('8784','2013-02-10','14:00:00',2.54),('8784','2013-02-10','14:05:00',2.5),('8784','2013-02-10','14:10:00',2.39),('8784','2013-02-10','14:15:00',2.05),('8784','2013-02-10','14:20:00',2.33),('8784','2013-02-10','14:25:00',2.28),('8784','2013-02-10','14:30:00',2.28),('8784','2013-02-10','14:35:00',2.18),('8784','2013-02-10','14:40:00',2.16),('8784','2013-02-10','14:45:00',2.02),('8784','2013-02-10','14:50:00',1.99),('8784','2013-02-10','14:55:00',1.69),('8784','2013-02-10','15:00:00',1.34),('8784','2013-02-10','15:05:00',1.64),('8784','2013-02-10','15:10:00',1.78),('8784','2013-02-10','15:15:00',1.54),('8784','2013-02-10','15:20:00',1.73),('8784','2013-02-10','15:25:00',1.93),('8784','2013-02-10','15:30:00',1.49),('8784','2013-02-10','15:35:00',1.44),('8784','2013-02-10','15:40:00',1.19),('8784','2013-02-09','10:55:00',1.06),('8784','2013-02-09','11:00:00',1.14),('8784','2013-02-09','11:05:00',1.18),('8784','2013-02-09','11:10:00',1.21),('8784','2013-02-09','11:15:00',1.26),('8784','2013-02-09','11:20:00',1.3),('8784','2013-02-09','11:25:00',1.31),('8784','2013-02-09','11:30:00',1.33),('8784','2013-02-09','11:35:00',1.29),('8784','2013-02-09','11:40:00',1.26),('8784','2013-02-09','11:45:00',1.28),('8784','2013-02-09','11:50:00',1.26),('8784','2013-02-09','11:55:00',1.23),('8784','2013-02-09','12:00:00',1.25),('8784','2013-02-09','12:05:00',1.25),('8784','2013-02-09','12:10:00',1.22),('8784','2013-02-09','12:15:00',1.21),('8784','2013-02-09','12:20:00',1.23),('8784','2013-02-09','12:25:00',1.24),('8784','2013-02-09','12:30:00',1.27),('8784','2013-02-09','12:35:00',1.34),('8784','2013-02-09','12:40:00',1.36),('8784','2013-02-09','12:45:00',1.37),('8784','2013-02-09','12:50:00',1.38),('8784','2013-02-09','12:55:00',1.36),('8784','2013-02-09','13:00:00',1.46),('8784','2013-02-09','13:05:00',1.64),('8784','2013-02-09','13:10:00',1.82),('8784','2013-02-09','13:15:00',1.94),('8784','2013-02-09','13:20:00',2.12),('8784','2013-02-09','13:25:00',2.21),('8784','2013-02-09','13:30:00',2.38),('8784','2013-02-09','13:35:00',2.57),('8784','2013-02-09','13:40:00',2.53),('8784','2013-02-09','13:45:00',2.72),('8784','2013-02-09','13:50:00',2.78),('8784','2013-02-09','13:55:00',2.9),('8784','2013-02-09','14:00:00',2.69),('8784','2013-02-09','14:05:00',2.49),('8784','2013-02-09','14:10:00',2.18),('8784','2013-02-09','14:15:00',2.44),('8784','2013-02-09','14:20:00',3.01),('8784','2013-02-09','14:25:00',2.92),('8784','2013-02-09','14:30:00',2.6),('8784','2013-02-09','14:35:00',2.39),('8784','2013-02-09','14:40:00',2.16),('8784','2013-02-09','14:45:00',2.05),('8784','2013-02-09','14:50:00',1.97),('8784','2013-02-09','14:55:00',1.95),('8784','2013-02-09','15:00:00',1.86),('8784','2013-02-09','15:05:00',1.79),('8784','2013-02-09','15:10:00',1.72),('8784','2013-02-09','15:15:00',1.62),('8784','2013-02-09','15:20:00',1.58),('8784','2013-02-09','15:25:00',1.35),('8784','2013-02-09','15:30:00',1.4),('8784','2013-02-09','15:35:00',1.34),('8784','2013-02-09','15:40:00',1.25),('8784','2013-02-09','15:45:00',1.17),('8784','2013-02-09','15:50:00',1.14),('8784','2013-02-08','09:35:00',1.23),('8784','2013-02-08','09:40:00',1.33),('8784','2013-02-08','09:45:00',1.28),('8784','2013-02-08','09:50:00',2.06),('8784','2013-02-08','09:55:00',2.42),('8784','2013-02-08','10:00:00',2.33),('8784','2013-02-08','10:05:00',2.77),('8784','2013-02-08','10:10:00',2.91),('8784','2013-02-08','10:15:00',3.05),('8784','2013-02-08','10:20:00',2.85),('8784','2013-02-08','10:25:00',2.9),('8784','2013-02-08','10:30:00',2.56),('8784','2013-02-08','10:35:00',1.28),('8784','2013-02-08','10:40:00',3.21),('8784','2013-02-08','10:45:00',3.12),('8784','2013-02-08','10:50:00',3.19),('8784','2013-02-08','10:55:00',3.15),('8784','2013-02-08','11:00:00',3.06),('8784','2013-02-08','11:05:00',2.99),('8784','2013-02-08','11:10:00',3.02),('8784','2013-02-08','11:15:00',3.01),('8784','2013-02-08','11:20:00',3.02),('8784','2013-02-08','11:25:00',3),('8784','2013-02-08','11:30:00',3.04),('8784','2013-02-08','11:35:00',3.04),('8784','2013-02-08','11:40:00',3.07),('8784','2013-02-08','11:45:00',3.08),('8784','2013-02-08','11:50:00',3.09),('8784','2013-02-08','11:55:00',3.09),('8784','2013-02-08','12:00:00',3.1),('8784','2013-02-08','12:05:00',3.1),('8784','2013-02-08','12:10:00',3.1),('8784','2013-02-08','12:15:00',3.1),('8784','2013-02-08','12:20:00',3.11),('8784','2013-02-08','12:25:00',3.13),('8784','2013-02-08','12:30:00',3.09),('8784','2013-02-08','12:35:00',3.08),('8784','2013-02-08','12:40:00',3.2),('8784','2013-02-08','12:45:00',3.4),('8784','2013-02-08','12:50:00',2.01),('8784','2013-02-08','12:55:00',2.14),('8784','2013-02-08','13:00:00',2.02),('8784','2013-02-08','13:05:00',1.74),('8784','2013-02-08','13:10:00',1.89),('8784','2013-02-08','13:15:00',1.85),('8784','2013-02-08','13:20:00',1.93),('8784','2013-02-08','13:25:00',1.8),('8784','2013-02-08','13:30:00',1.81),('8784','2013-02-08','13:35:00',2.28),('8784','2013-02-08','13:40:00',1.85),('8784','2013-02-08','13:45:00',1.47),('8784','2013-02-08','13:50:00',1.54),('8784','2013-02-08','13:55:00',1.6),('8784','2013-02-08','14:00:00',1.46),('8784','2013-02-08','14:05:00',1.45),('8784','2013-02-08','14:10:00',1.35),('8784','2013-02-08','14:15:00',1.27),('8784','2013-02-08','14:20:00',1.31),('8784','2013-02-08','14:25:00',1.69),('8784','2013-02-08','14:30:00',2.25),('8784','2013-02-08','14:35:00',2.1),('8784','2013-02-08','14:40:00',3.13),('8784','2013-02-08','14:45:00',2.27),('8784','2013-02-08','14:50:00',2.2),('8784','2013-02-08','14:55:00',2.55),('8784','2013-02-08','15:00:00',2.44),('8784','2013-02-08','15:05:00',2.65),('8784','2013-02-08','15:10:00',2.46),('8784','2013-02-08','15:15:00',2.09),('8784','2013-02-08','15:20:00',1.27),('8784','2013-02-08','15:25:00',1.53),('8784','2013-02-08','15:30:00',1.52),('8784','2013-02-08','15:35:00',1.43),('8784','2013-02-08','15:40:00',1.36),('8784','2013-02-08','15:45:00',1.28),('8784','2013-02-08','15:50:00',1.18),('8784','2013-02-08','15:55:00',1.1),('8784','2013-02-08','16:00:00',1.01),('8784','2013-02-07','10:35:00',1.11),('8784','2013-02-07','10:40:00',1.35),('8784','2013-02-07','10:45:00',1.2),('8784','2013-02-07','10:55:00',1.39),('8784','2013-02-07','11:00:00',1.88),('8784','2013-02-07','11:05:00',1.19),('8784','2013-02-07','12:20:00',1.28),('8784','2013-02-07','12:25:00',2.5),('8784','2013-02-07','12:30:00',1.93),('8784','2013-02-07','12:35:00',1.01),('8784','2013-02-07','13:15:00',1.93),('8784','2013-02-07','13:20:00',1.43),('8784','2013-02-07','13:25:00',1.42),('8784','2013-02-07','13:30:00',1.04),('8784','2013-02-07','13:55:00',1.17),('8784','2013-02-07','14:00:00',1.42),('8784','2013-02-07','14:05:00',1.95),('8784','2013-02-07','14:10:00',2.82),('8784','2013-02-07','14:15:00',2.5),('8784','2013-02-07','14:20:00',2.15),('8784','2013-02-07','14:25:00',1.18),('8784','2013-02-07','14:30:00',1.02),('8784','2013-02-07','14:35:00',1.76),('8784','2013-02-07','14:40:00',2.08),('8784','2013-02-07','14:45:00',1.96),('8784','2013-02-07','14:50:00',1.24),('8784','2013-02-07','14:55:00',1.56),('8784','2013-02-07','15:00:00',1.92),('8784','2013-02-07','15:05:00',2.32),('8784','2013-02-07','15:10:00',2.33),('8784','2013-02-07','15:15:00',1.63),('8784','2013-02-07','15:20:00',1.05),('8784','2013-02-07','15:25:00',1.22),('8784','2013-02-06','09:00:00',1.01),('8784','2013-02-06','09:10:00',1.1),('8784','2013-02-06','09:20:00',1.04),('8784','2013-02-06','09:25:00',1.13),('8784','2013-02-06','09:30:00',1.3),('8784','2013-02-06','09:35:00',1.16),('8784','2013-02-06','09:40:00',1.3),('8784','2013-02-06','09:45:00',1.23),('8784','2013-02-06','09:50:00',1.26),('8784','2013-02-06','09:55:00',1.46),('8784','2013-02-06','10:00:00',1.33),('8784','2013-02-06','10:05:00',1.56),('8784','2013-02-06','10:10:00',1.38),('8784','2013-02-06','10:15:00',1.36),('8784','2013-02-06','10:20:00',1.23),('8784','2013-02-06','10:25:00',1.71),('8784','2013-02-06','10:30:00',1.46),('8784','2013-02-06','10:35:00',2.02),('8784','2013-02-06','10:40:00',1.35),('8784','2013-02-06','10:45:00',1.14),('8784','2013-02-06','10:50:00',1.87),('8784','2013-02-06','10:55:00',2.15),('8784','2013-02-06','11:00:00',1.77),('8784','2013-02-06','11:05:00',1.49),('8784','2013-02-06','11:10:00',1.64),('8784','2013-02-06','11:15:00',1.53),('8784','2013-02-06','11:20:00',1.9),('8784','2013-02-06','11:25:00',2.74),('8784','2013-02-06','11:30:00',1.58),('8784','2013-02-06','11:35:00',1.52),('8784','2013-02-06','11:40:00',1.69),('8784','2013-02-06','11:45:00',1.71),('8784','2013-02-06','11:50:00',1.78),('8784','2013-02-06','11:55:00',1.66),('8784','2013-02-06','12:00:00',1.44),('8784','2013-02-06','12:05:00',1.14),('8784','2013-02-06','12:15:00',1.25),('8784','2013-02-06','12:20:00',1.17),('8784','2013-02-06','12:25:00',1.12),('8784','2013-02-06','13:20:00',1.02),('8784','2013-02-06','13:25:00',1.14),('8784','2013-02-06','13:30:00',1.33),('8784','2013-02-06','13:35:00',1.4),('8784','2013-02-06','13:40:00',1.16),('8784','2013-02-06','13:45:00',1.19),('8784','2013-02-06','13:50:00',1.63),('8784','2013-02-06','13:55:00',1.34),('8784','2013-02-06','14:00:00',1.47),('8784','2013-02-06','14:05:00',1.36),('8784','2013-02-06','14:30:00',1.82),('8784','2013-02-06','14:35:00',1.99),('8784','2013-02-06','14:40:00',1.4),('8784','2013-02-06','15:25:00',1.1),('8784','2013-02-05','09:10:00',1.1),('8784','2013-02-05','09:15:00',1.24),('8784','2013-02-05','09:20:00',1.29),('8784','2013-02-05','09:25:00',1.36),('8784','2013-02-05','09:30:00',1.42),('8784','2013-02-05','09:35:00',1.52),('8784','2013-02-05','09:40:00',1.71),('8784','2013-02-05','09:45:00',1.78),('8784','2013-02-05','09:50:00',1.86),('8784','2013-02-05','09:55:00',1.93),('8784','2013-02-05','10:00:00',1.99),('8784','2013-02-05','10:05:00',2.01),('8784','2013-02-05','10:10:00',1.95),('8784','2013-02-05','10:15:00',2.03),('8784','2013-02-05','10:20:00',2.32),('8784','2013-02-05','10:25:00',2.39),('8784','2013-02-05','10:30:00',2.44),('8784','2013-02-05','10:35:00',2.46),('8784','2013-02-05','10:40:00',2.48),('8784','2013-02-05','10:45:00',2.49),('8784','2013-02-05','10:50:00',2.52),('8784','2013-02-05','10:55:00',2.55),('8784','2013-02-05','11:00:00',2.6),('8784','2013-02-05','11:05:00',2.61),('8784','2013-02-05','11:10:00',2.67),('8784','2013-02-05','11:15:00',2.64),('8784','2013-02-05','11:20:00',2.64),('8784','2013-02-05','11:25:00',2.73),('8784','2013-02-05','11:30:00',2.69),('8784','2013-02-05','11:35:00',2.52),('8784','2013-02-05','11:40:00',2.23),('8784','2013-02-05','11:45:00',2.33),('8784','2013-02-05','11:50:00',1.64),('8784','2013-02-05','11:55:00',1.4),('8784','2013-02-05','12:00:00',1.11),('8784','2013-02-05','12:05:00',1.51),('8784','2013-02-05','12:10:00',1.41),('8784','2013-02-05','12:15:00',1.53),('8784','2013-02-05','12:20:00',1.31),('8784','2013-02-05','12:25:00',1.3),('8784','2013-02-05','12:30:00',1.21),('8784','2013-02-05','12:35:00',1.89),('8784','2013-02-05','12:40:00',1.97),('8784','2013-02-05','12:45:00',2.18),('8784','2013-02-05','12:50:00',1.97),('8784','2013-02-05','13:10:00',1.16),('8784','2013-02-05','13:15:00',1.41),('8784','2013-02-05','13:20:00',1.4),('8784','2013-02-05','13:25:00',1.42),('8784','2013-02-05','13:30:00',1.32),('8784','2013-02-05','13:35:00',1.04),('8784','2013-02-05','13:40:00',1.15),('8784','2013-02-05','13:45:00',1.43),('8784','2013-02-05','13:50:00',1.45),('8784','2013-02-05','13:55:00',1.28),('8784','2013-02-05','14:00:00',1.29),('8784','2013-02-05','14:05:00',1.27),('8784','2013-02-05','14:10:00',1.02),('8784','2013-02-05','14:15:00',1.14),('8784','2013-02-05','14:20:00',1.32),('8784','2013-02-05','14:25:00',1.74),('8784','2013-02-05','14:30:00',1.72),('8784','2013-02-05','14:35:00',1.46),('8784','2013-02-05','14:40:00',1.52),('8784','2013-02-05','14:45:00',1.07),('8784','2013-02-05','15:05:00',1.01),('8784','2013-02-04','09:15:00',1.34),('8784','2013-02-04','09:20:00',1.32),('8784','2013-02-04','09:25:00',1.35),('8784','2013-02-04','09:30:00',1.44),('8784','2013-02-04','09:35:00',1.52),('8784','2013-02-04','09:40:00',1.68),('8784','2013-02-04','09:45:00',1.54),('8784','2013-02-04','09:50:00',1.92),('8784','2013-02-04','09:55:00',2.05),('8784','2013-02-04','10:00:00',2.08),('8784','2013-02-04','10:05:00',2.2),('8784','2013-02-04','10:10:00',2.31),('8784','2013-02-04','10:15:00',2.5),('8784','2013-02-04','10:20:00',2.39),('8784','2013-02-04','10:25:00',2.53),('8784','2013-02-04','10:30:00',2.4),('8784','2013-02-04','10:35:00',2.26),('8784','2013-02-04','10:40:00',2.41),('8784','2013-02-04','10:45:00',2.66),('8784','2013-02-04','10:50:00',2.73),('8784','2013-02-04','10:55:00',2.74),('8784','2013-02-04','11:00:00',2.75),('8784','2013-02-04','11:05:00',2.81),('8784','2013-02-04','11:10:00',2.82),('8784','2013-02-04','11:15:00',2.81),('8784','2013-02-04','11:20:00',2.85),('8784','2013-02-04','11:25:00',2.87),('8784','2013-02-04','11:30:00',2.86),('8784','2013-02-04','11:35:00',2.89),('8784','2013-02-04','11:40:00',2.89),('8784','2013-02-04','11:45:00',2.9),('8784','2013-02-04','11:50:00',2.87),('8784','2013-02-04','11:55:00',2.85),('8784','2013-02-04','12:00:00',2.91),('8784','2013-02-04','12:05:00',2.94),('8784','2013-02-04','12:10:00',2.94),('8784','2013-02-04','12:15:00',2.93),('8784','2013-02-04','12:20:00',2.92),('8784','2013-02-04','12:25:00',2.92),('8784','2013-02-04','12:30:00',2.9),('8784','2013-02-04','12:35:00',2.89),('8784','2013-02-04','12:40:00',2.88),('8784','2013-02-04','12:45:00',2.88),('8784','2013-02-04','12:50:00',2.88),('8784','2013-02-04','12:55:00',2.7),('8784','2013-02-04','13:00:00',2.74),('8784','2013-02-04','13:05:00',2.73),('8784','2013-02-04','13:10:00',2.74),('8784','2013-02-04','13:15:00',2.75),('8784','2013-02-04','13:20:00',2.72),('8784','2013-02-04','13:25:00',2.68),('8784','2013-02-04','13:30:00',2.64),('8784','2013-02-04','13:35:00',2.59),('8784','2013-02-04','13:40:00',2.56),('8784','2013-02-04','13:45:00',2.52),('8784','2013-02-04','13:50:00',2.47),('8784','2013-02-04','13:55:00',2.36),('8784','2013-02-04','14:00:00',2.38),('8784','2013-02-04','14:05:00',2.34),('8784','2013-02-04','14:10:00',2.06),('8784','2013-02-04','14:15:00',2.23),('8784','2013-02-04','14:20:00',2.21),('8784','2013-02-04','14:25:00',2.18),('8784','2013-02-04','14:30:00',2.12),('8784','2013-02-04','14:35:00',2.03),('8784','2013-02-04','14:40:00',1.96),('8784','2013-02-04','14:45:00',1.92),('8784','2013-02-04','14:50:00',1.86),('8784','2013-02-04','14:55:00',1.78),('8784','2013-02-04','15:00:00',1.75),('8784','2013-02-04','15:05:00',1.69),('8784','2013-02-04','15:10:00',1.61),('8784','2013-02-04','15:15:00',1.53),('8784','2013-02-04','15:20:00',1.47),('8784','2013-02-04','15:25:00',1.4),('8784','2013-02-04','15:30:00',1.32),('8784','2013-02-04','15:35:00',1.24),('8784','2013-02-04','15:40:00',1.18),('8784','2013-02-04','15:45:00',1.12),('8784','2013-02-04','15:50:00',1.04),('8784','2013-02-03','09:20:00',1.03),('8784','2013-02-03','09:25:00',1.31),('8784','2013-02-03','09:40:00',1.15),('8784','2013-02-03','09:45:00',1.37),('8784','2013-02-03','09:50:00',1.47),('8784','2013-02-03','09:55:00',1.33),('8784','2013-02-03','10:00:00',1.58),('8784','2013-02-03','10:20:00',1.12),('8784','2013-02-03','11:20:00',1.46),('8784','2013-02-03','11:50:00',1.22),('8784','2013-02-03','11:55:00',1.57),('8784','2013-02-03','12:00:00',1.41),('8784','2013-02-03','12:05:00',1.37),('8784','2013-02-03','12:10:00',1.37),('8784','2013-02-02','10:15:00',1.2),('8784','2013-02-02','10:20:00',1.09),('8784','2013-02-02','10:25:00',1.17),('8784','2013-02-02','10:30:00',1.24),('8784','2013-02-02','10:35:00',1.33),('8784','2013-02-02','10:40:00',1.45),('8784','2013-02-02','10:45:00',1.55),('8784','2013-02-02','10:50:00',1.28),('8784','2013-02-02','10:55:00',1.88),('8784','2013-02-02','11:00:00',1.96),('8784','2013-02-02','11:05:00',1.77),('8784','2013-02-02','11:10:00',1.89),('8784','2013-02-02','11:15:00',1.87),('8784','2013-02-02','11:20:00',1.8),('8784','2013-02-02','11:25:00',2.15),('8784','2013-02-02','11:30:00',2.02),('8784','2013-02-02','11:35:00',1.88),('8784','2013-02-02','11:40:00',1.81),('8784','2013-02-02','11:45:00',1.3),('8784','2013-02-02','11:50:00',1.21),('8784','2013-02-02','11:55:00',1.23),('8784','2013-02-02','12:55:00',2.07),('8784','2013-02-02','13:00:00',1.62),('8784','2013-02-02','13:05:00',1.6),('8784','2013-02-02','13:10:00',2.24),('8784','2013-02-02','13:15:00',2.01),('8784','2013-02-02','13:20:00',1.7),('8784','2013-02-02','13:25:00',1.74),('8784','2013-02-02','13:30:00',1.48),('8784','2013-02-02','13:35:00',1.9),('8784','2013-02-02','13:40:00',2.29),('8784','2013-02-02','13:45:00',1.98),('8784','2013-02-02','13:50:00',1.87),('8784','2013-02-02','13:55:00',1.03),('8784','2013-02-01','09:10:00',1.05),('8784','2013-02-01','09:30:00',1.26),('8784','2013-02-01','09:35:00',1.6),('8784','2013-02-01','09:40:00',1.8),('8784','2013-02-01','09:45:00',1.11),('8784','2013-02-01','09:50:00',1.15),('8784','2013-02-01','09:55:00',1.4),('8784','2013-02-01','10:00:00',1.14),('8784','2013-02-01','10:05:00',1.17),('8784','2013-02-01','10:15:00',1.65),('8784','2013-02-01','10:25:00',1.08),('8784','2013-02-01','10:30:00',1.15),('8784','2013-02-01','10:35:00',1.03),('8784','2013-02-01','10:45:00',1.09),('8784','2013-02-01','10:50:00',3.19),('8784','2013-02-01','10:55:00',2.79),('8784','2013-02-01','11:00:00',2.8),('8784','2013-02-01','11:05:00',2.76),('8784','2013-02-01','11:10:00',1.5),('8784','2013-02-01','11:15:00',1.64),('8784','2013-02-01','11:20:00',2.01),('8784','2013-02-01','11:30:00',1.56),('8784','2013-02-01','11:35:00',1.68),('8784','2013-02-01','11:40:00',1.45),('8784','2013-02-01','11:45:00',1.55),('8784','2013-02-01','11:50:00',1.48),('8784','2013-02-01','11:55:00',1.14),('8784','2013-02-01','12:00:00',1.46),('8784','2013-02-01','12:05:00',2.35),('8784','2013-02-01','12:10:00',1.99),('8784','2013-02-01','12:15:00',2.83),('8784','2013-02-01','12:20:00',2.96),('8784','2013-02-01','12:25:00',2.24),('8784','2013-02-01','12:30:00',2.13),('8784','2013-02-01','12:35:00',3.01),('8784','2013-02-01','12:40:00',2.95),('8784','2013-02-01','12:45:00',2.73),('8784','2013-02-01','12:50:00',2.63),('8784','2013-02-01','12:55:00',1.68),('8784','2013-02-01','13:00:00',1.36),('8784','2013-02-01','13:05:00',2.64),('8784','2013-02-01','13:10:00',2.64),('8784','2013-02-01','13:15:00',2.51),('8784','2013-02-01','13:20:00',2.64),('8784','2013-02-01','13:25:00',1.78),('8784','2013-02-01','13:30:00',2.13),('8784','2013-02-01','13:35:00',1.89),('8784','2013-02-01','13:40:00',1.78),('8784','2013-02-01','13:45:00',1.06),('8784','2013-02-01','13:50:00',1.05),('8784','2013-02-01','13:55:00',1.04),('8784','2013-02-01','14:00:00',1.02),('8784','2013-02-01','14:05:00',1.08),('8784','2013-02-01','14:10:00',2.5),('8784','2013-02-01','14:15:00',2.61),('8784','2013-02-01','14:20:00',1.98),('8784','2013-02-01','14:25:00',2.01),('8784','2013-02-01','14:30:00',2.01),('8784','2013-02-01','14:35:00',1.97),('8784','2013-02-01','14:40:00',1.24),('8784','2013-02-01','15:00:00',1.08),('8784','2013-02-01','15:05:00',1.58),('8784','2013-02-01','15:10:00',1.56),('8784','2013-02-01','15:15:00',1.51),('8784','2013-02-01','15:20:00',1.36),('8784','2013-02-01','15:25:00',1.18),('8784','2014-03-21','07:40:00',1.03),('8784','2014-03-21','07:45:00',1.12),('8784','2014-03-21','07:50:00',1.23),('8784','2014-03-21','07:55:00',1.35),('8784','2014-03-21','08:00:00',1.4),('8784','2014-03-21','08:05:00',1.47),('8784','2014-03-21','08:10:00',1.53),('8784','2014-03-21','08:15:00',1.62),('8784','2014-03-21','08:20:00',1.67),('8784','2014-03-21','08:25:00',1.72),('8784','2014-03-21','08:30:00',1.87),('8784','2014-03-21','08:35:00',1.94),('8784','2014-03-21','08:40:00',2.02),('8784','2014-03-21','08:45:00',2.03),('8784','2014-03-21','08:50:00',2.13),('8784','2014-03-21','08:55:00',2.23),('8784','2014-03-21','09:00:00',2.34),('8784','2014-03-21','09:05:00',2.42),('8784','2014-03-21','09:10:00',2.53),('8784','2014-03-21','09:15:00',2.58),('8784','2014-03-21','09:20:00',2.68),('8784','2014-03-21','09:25:00',2.61),('8784','2014-03-21','09:30:00',2.79),('8784','2014-03-21','09:35:00',2.79),('8784','2014-03-21','09:40:00',2.89),('8784','2014-03-21','09:45:00',2.93),('8784','2014-03-21','09:50:00',2.95),('8784','2014-03-21','09:55:00',2.99),('8784','2014-03-21','10:00:00',3.09),('8784','2014-03-21','10:05:00',3.11),('8784','2014-03-21','10:10:00',3.16),('8784','2014-03-21','10:15:00',3.18),('8784','2014-03-21','10:20:00',3.25),('8784','2014-03-21','10:25:00',3.28),('8784','2014-03-21','10:30:00',3.32),('8784','2014-03-21','10:35:00',3.37),('8784','2014-03-21','10:40:00',3.36),('8784','2014-03-21','10:45:00',3.36),('8784','2014-03-21','10:50:00',3.37),('8784','2014-03-21','10:55:00',3.38),('8784','2014-03-21','11:00:00',3.42),('8784','2014-03-21','11:05:00',3.46),('8784','2014-03-21','11:10:00',3.45),('8784','2014-03-21','11:15:00',3.56),('8784','2014-03-21','11:20:00',3.61),('8784','2014-03-21','11:25:00',3.65),('8784','2014-03-21','11:30:00',1.54),('8784','2014-03-21','11:35:00',2.6),('8784','2014-03-21','11:40:00',3.41),('8784','2014-03-21','11:45:00',3.96),('8784','2014-03-21','11:50:00',3.89),('8784','2014-03-21','11:55:00',3.94),('8784','2014-03-21','12:00:00',2.18),('8784','2014-03-21','12:05:00',2.96),('8784','2014-03-21','12:10:00',3.87),('8784','2014-03-21','12:15:00',3.88),('8784','2014-03-21','12:20:00',3.77),('8784','2014-03-21','12:25:00',3.75),('8784','2014-03-21','12:30:00',3.75),('8784','2014-03-21','12:35:00',3.7),('8784','2014-03-21','12:40:00',3.74),('8784','2014-03-21','12:45:00',3.74),('8784','2014-03-21','12:50:00',3.69),('8784','2014-03-21','12:55:00',3.65),('8784','2014-03-21','13:00:00',3.67),('8784','2014-03-21','13:05:00',3.65),('8784','2014-03-21','13:10:00',3.65),('8784','2014-03-21','13:15:00',3.65),('8784','2014-03-21','13:20:00',3.59),('8784','2014-03-21','13:25:00',3.55),('8784','2014-03-21','13:30:00',3.5),('8784','2014-03-21','13:35:00',3.47),('8784','2014-03-21','13:40:00',3.46),('8784','2014-03-21','13:45:00',3.44),('8784','2014-03-21','13:50:00',3.41),('8784','2014-03-21','13:55:00',3.37),('8784','2014-03-21','14:00:00',3.38),('8784','2014-03-21','14:05:00',3.33),('8784','2014-03-21','14:10:00',3.29),('8784','2014-03-21','14:15:00',3.24),('8784','2014-03-21','14:20:00',3.19),('8784','2014-03-21','14:25:00',3.12),('8784','2014-03-21','14:30:00',2.97),('8784','2014-03-21','14:35:00',2.87),('8784','2014-03-21','14:40:00',2.9),('8784','2014-03-21','14:45:00',2.79),('8784','2014-03-21','14:50:00',2.36),('8784','2014-03-21','14:55:00',1.06),('8784','2014-03-21','15:05:00',1.81),('8784','2014-03-21','15:10:00',2.99),('8784','2014-03-21','15:15:00',3.01),('8784','2014-03-21','15:20:00',2.61),('8784','2014-03-21','15:25:00',2.92),('8784','2014-03-21','15:30:00',2.82),('8784','2014-03-21','15:35:00',2.61),('8784','2014-03-21','15:40:00',2.62),('8784','2014-03-21','15:45:00',2.56),('8784','2014-03-21','15:50:00',2.49),('8784','2014-03-21','15:55:00',2.42),('8784','2014-03-21','16:00:00',2.24),('8784','2014-03-21','16:05:00',2.07),('8784','2014-03-21','16:10:00',1.92),('8784','2014-03-21','16:15:00',1.72),('8784','2014-03-21','16:20:00',1.58),('8784','2014-03-21','16:25:00',1.45),('8784','2014-03-21','16:30:00',1.34),('8784','2014-03-21','16:35:00',1.23),('8784','2014-03-21','16:40:00',1.14),('8784','2014-03-21','16:45:00',1.07),('8784','2013-01-31','09:30:00',1.27),('8784','2013-01-31','09:35:00',1.32),('8784','2013-01-31','09:40:00',1.39),('8784','2013-01-31','09:45:00',1.6),('8784','2013-01-31','09:50:00',1.65),('8784','2013-01-31','09:55:00',1.73),('8784','2013-01-31','10:00:00',1.72),('8784','2013-01-31','10:05:00',1.78),('8784','2013-01-31','10:10:00',1.87),('8784','2013-01-31','10:15:00',2.07),('8784','2013-01-31','10:20:00',2.07),('8784','2013-01-31','10:25:00',2.16),('8784','2013-01-31','10:30:00',2.33),('8784','2013-01-31','10:35:00',2.47),('8784','2013-01-31','10:40:00',2.09),('8784','2013-01-31','10:45:00',2.18),('8784','2013-01-31','10:50:00',2.92),('8784','2013-01-31','10:55:00',2.48),('8784','2013-01-31','11:00:00',2.85),('8784','2013-01-31','11:05:00',2.25),('8784','2013-01-31','11:10:00',1.38),('8784','2013-01-31','11:15:00',2.12),('8784','2013-01-31','11:20:00',3.11),('8784','2013-01-31','11:25:00',3.04),('8784','2013-01-31','11:30:00',2.77),('8784','2013-01-31','11:35:00',2.65),('8784','2013-01-31','11:40:00',2.58),('8784','2013-01-31','11:45:00',2.6),('8784','2013-01-31','11:50:00',2.64),('8784','2013-01-31','11:55:00',2.61),('8784','2013-01-31','12:00:00',2.63),('8784','2013-01-31','12:05:00',2.74),('8784','2013-01-31','12:10:00',2.67),('8784','2013-01-31','12:15:00',2.69),('8784','2013-01-31','12:20:00',2.74),('8784','2013-01-31','12:25:00',2.64),('8784','2013-01-31','12:30:00',2.61),('8784','2013-01-31','12:35:00',2.61),('8784','2013-01-31','12:40:00',2.57),('8784','2013-01-31','12:45:00',2.56),('8784','2013-01-31','12:50:00',2.55),('8784','2013-01-31','12:55:00',2.28),('8784','2013-01-31','13:00:00',2.25),('8784','2013-01-31','13:05:00',2.45),('8784','2013-01-31','13:10:00',2.45),('8784','2013-01-31','13:15:00',2.26),('8784','2013-01-31','13:20:00',2.39),('8784','2013-01-31','13:25:00',2.36),('8784','2013-01-31','13:30:00',2.29),('8784','2013-01-31','13:35:00',2.28),('8784','2013-01-31','13:40:00',2.24),('8784','2013-01-31','13:45:00',2.26),('8784','2013-01-31','13:50:00',2.32),('8784','2013-01-31','13:55:00',2.17),('8784','2013-01-31','14:00:00',2.06),('8784','2013-01-31','14:05:00',2.02),('8784','2013-01-31','14:10:00',2),('8784','2013-01-31','14:15:00',1.97),('8784','2013-01-31','14:20:00',1.96),('8784','2013-01-31','14:25:00',1.89),('8784','2013-01-31','14:30:00',1.83),('8784','2013-01-31','14:35:00',1.75),('8784','2013-01-31','14:40:00',1.73),('8784','2013-01-31','14:45:00',1.67),('8784','2013-01-31','14:50:00',1.62),('8784','2013-01-31','14:55:00',1.5),('8784','2013-01-31','15:00:00',1.44),('8784','2013-01-31','15:05:00',1.45),('8784','2013-01-31','15:10:00',1.4),('8784','2013-01-31','15:15:00',1.37),('8784','2013-01-31','15:20:00',1.3),('8784','2013-01-31','15:25:00',1.19),('8784','2013-01-31','15:30:00',1.15),('8784','2013-01-31','15:35:00',1.14),('8784','2013-01-31','15:40:00',1.06),('8784','2013-01-30','10:00:00',1.09),('8784','2013-01-30','10:05:00',1.29),('8784','2013-01-30','10:10:00',1.54),('8784','2013-01-30','10:15:00',1.19),('8784','2013-01-30','10:20:00',1.71),('8784','2013-01-30','10:25:00',1.77),('8784','2013-01-30','10:30:00',1.55),('8784','2013-01-30','10:35:00',1.33),('8784','2013-01-30','10:40:00',1.21),('8784','2013-01-30','10:45:00',1.83),('8784','2013-01-30','10:50:00',2.34),('8784','2013-01-30','10:55:00',2.11),('8784','2013-01-30','11:00:00',2.44),('8784','2013-01-30','11:05:00',2.34),('8784','2013-01-30','11:10:00',2.35),('8784','2013-01-30','11:15:00',2.38),('8784','2013-01-30','11:20:00',2.42),('8784','2013-01-30','11:25:00',2.48),('8784','2013-01-30','11:30:00',2.46),('8784','2013-01-30','11:35:00',2.31),('8784','2013-01-30','11:40:00',2.04),('8784','2013-01-30','11:45:00',2.3),('8784','2013-01-30','11:50:00',2.25),('8784','2013-01-30','11:55:00',2.52),('8784','2013-01-30','12:00:00',2.63),('8784','2013-01-30','12:05:00',2.03),('8784','2013-01-30','12:10:00',1.31),('8784','2013-01-30','12:15:00',1.64),('8784','2013-01-30','12:20:00',1.43),('8784','2013-01-30','12:35:00',1.13),('8784','2013-01-30','12:40:00',1.12),('8784','2013-01-30','12:45:00',1.95),('8784','2013-01-30','12:50:00',3.19),('8784','2013-01-30','12:55:00',2.83),('8784','2013-01-30','13:00:00',2.68),('8784','2013-01-30','13:05:00',2.94),('8784','2013-01-30','13:10:00',2.76),('8784','2013-01-30','13:15:00',2.73),('8784','2013-01-30','13:20:00',2.68),('8784','2013-01-30','13:25:00',2.69),('8784','2013-01-30','13:30:00',2.65),('8784','2013-01-30','13:35:00',2.05),('8784','2013-01-30','13:40:00',2),('8784','2013-01-30','13:45:00',2.1),('8784','2013-01-30','13:50:00',2.59),('8784','2013-01-30','13:55:00',2.54),('8784','2013-01-30','14:00:00',2.59),('8784','2013-01-30','14:05:00',2.57),('8784','2013-01-30','14:10:00',1.35),('8784','2013-01-30','14:15:00',1.83),('8784','2013-01-30','14:20:00',1.78),('8784','2013-01-30','14:25:00',2.24),('8784','2013-01-30','14:30:00',2.08),('8784','2013-01-30','14:35:00',1.89),('8784','2013-01-30','14:40:00',1.95),('8784','2013-01-30','14:45:00',1.55),('8784','2013-01-30','15:00:00',1.03),('8784','2013-01-30','15:05:00',1.11),('8784','2013-01-29','09:20:00',1.01),('8784','2013-01-29','09:25:00',1.08),('8784','2013-01-29','09:30:00',1.16),('8784','2013-01-29','09:35:00',1.2),('8784','2013-01-29','09:40:00',1.32),('8784','2013-01-29','09:45:00',1.53),('8784','2013-01-29','09:50:00',1.62),('8784','2013-01-29','09:55:00',1.71),('8784','2013-01-29','10:00:00',1.71),('8784','2013-01-29','10:05:00',1.82),('8784','2013-01-29','10:10:00',1.92),('8784','2013-01-29','10:15:00',2.06),('8784','2013-01-29','10:20:00',2.15),('8784','2013-01-29','10:25:00',2.22),('8784','2013-01-29','10:30:00',2.27),('8784','2013-01-29','10:35:00',2.32),('8784','2013-01-29','10:40:00',2.39),('8784','2013-01-29','10:45:00',2.43),('8784','2013-01-29','10:50:00',2.47),('8784','2013-01-29','10:55:00',2.5),('8784','2013-01-29','11:00:00',2.51),('8784','2013-01-29','11:05:00',2.53),('8784','2013-01-29','11:10:00',2.52),('8784','2013-01-29','11:15:00',2.52),('8784','2013-01-29','11:20:00',2.54),('8784','2013-01-29','11:25:00',2.54),('8784','2013-01-29','11:30:00',2.5),('8784','2013-01-29','11:35:00',2.63),('8784','2013-01-29','11:40:00',2.65),('8784','2013-01-29','11:45:00',2.65),('8784','2013-01-29','11:50:00',2.64),('8784','2013-01-29','11:55:00',2.66),('8784','2013-01-29','12:00:00',2.65),('8784','2013-01-29','12:05:00',2.64),('8784','2013-01-29','12:10:00',2.68),('8784','2013-01-29','12:15:00',2.65),('8784','2013-01-29','12:20:00',2.64),('8784','2013-01-29','12:25:00',2.64),('8784','2013-01-29','12:30:00',2.59),('8784','2013-01-29','12:35:00',2.6),('8784','2013-01-29','12:40:00',2.62),('8784','2013-01-29','12:45:00',2.55),('8784','2013-01-29','12:50:00',2.45),('8784','2013-01-29','12:55:00',2.26),('8784','2013-01-29','13:00:00',2.42),('8784','2013-01-29','13:05:00',2.48),('8784','2013-01-29','13:10:00',2.49),('8784','2013-01-29','13:15:00',2.37),('8784','2013-01-29','13:20:00',2.38),('8784','2013-01-29','13:25:00',2.36),('8784','2013-01-29','13:30:00',2.38),('8784','2013-01-29','13:35:00',2.33),('8784','2013-01-29','13:40:00',2.26),('8784','2013-01-29','13:45:00',2.25),('8784','2013-01-29','13:50:00',2.2),('8784','2013-01-29','13:55:00',2.16),('8784','2013-01-29','14:00:00',2.11),('8784','2013-01-29','14:05:00',2.04),('8784','2013-01-29','14:10:00',1.97),('8784','2013-01-29','14:15:00',1.91),('8784','2013-01-29','14:20:00',1.74),('8784','2013-01-29','14:25:00',1.92),('8784','2013-01-29','14:30:00',1.87),('8784','2013-01-29','14:35:00',1.79),('8784','2013-01-29','14:40:00',1.74),('8784','2013-01-29','14:45:00',1.66),('8784','2013-01-29','14:50:00',1.64),('8784','2013-01-29','14:55:00',1.54),('8784','2013-01-29','15:00:00',1.44),('8784','2013-01-29','15:05:00',1.42),('8784','2013-01-29','15:10:00',1.4),('8784','2013-01-29','15:15:00',1.31),('8784','2013-01-29','15:20:00',1.22),('8784','2013-01-29','15:25:00',1.16),('8784','2013-01-29','15:30:00',1.11),('8784','2013-01-29','15:35:00',1.05),('8784','2013-01-28','12:45:00',1.17),('8784','2013-01-28','12:50:00',1.35),('8784','2013-01-28','12:55:00',1.27),('8784','2013-01-28','13:00:00',1.17),('8784','2013-01-28','13:05:00',1.15),('8784','2013-01-28','13:10:00',1.06),('8784','2013-01-28','13:15:00',1.02),('8784','2013-01-28','13:20:00',1.02),('8784','2013-01-28','13:25:00',1.03),('8784','2013-01-27','09:30:00',1.11),('8784','2013-01-27','09:35:00',1.17),('8784','2013-01-27','09:40:00',1.26),('8784','2013-01-27','09:45:00',1.43),('8784','2013-01-27','09:50:00',1.56),('8784','2013-01-27','09:55:00',1.64),('8784','2013-01-27','10:00:00',1.65),('8784','2013-01-27','10:05:00',1.75),('8784','2013-01-27','10:10:00',1.83),('8784','2013-01-27','10:15:00',1.99),('8784','2013-01-27','10:20:00',2.05),('8784','2013-01-27','10:25:00',2.11),('8784','2013-01-27','10:30:00',2.18),('8784','2013-01-27','10:35:00',2.22),('8784','2013-01-27','10:40:00',2.26),('8784','2013-01-27','10:45:00',2.31),('8784','2013-01-27','10:50:00',2.37),('8784','2013-01-27','10:55:00',2.4),('8784','2013-01-27','11:00:00',2.44),('8784','2013-01-27','11:05:00',2.46),('8784','2013-01-27','11:10:00',2.47),('8784','2013-01-27','11:15:00',2.47),('8784','2013-01-27','11:20:00',2.45),('8784','2013-01-27','11:25:00',2.5),('8784','2013-01-27','11:30:00',2.51),('8784','2013-01-27','11:35:00',2.52),('8784','2013-01-27','11:40:00',2.55),('8784','2013-01-27','11:45:00',2.55),('8784','2013-01-27','11:50:00',2.55),('8784','2013-01-27','11:55:00',2.57),('8784','2013-01-27','12:00:00',2.54),('8784','2013-01-27','12:05:00',2.57),('8784','2013-01-27','12:10:00',2.61),('8784','2013-01-27','12:15:00',2.61),('8784','2013-01-27','12:20:00',2.6),('8784','2013-01-27','12:25:00',2.6),('8784','2013-01-27','12:30:00',2.57),('8784','2013-01-27','12:35:00',2.56),('8784','2013-01-27','12:40:00',2.53),('8784','2013-01-27','12:45:00',2.56),('8784','2013-01-27','12:50:00',2.49),('8784','2013-01-27','12:55:00',2.21),('8784','2013-01-27','13:00:00',2.37),('8784','2013-01-27','13:05:00',2.46),('8784','2013-01-27','13:10:00',2.46),('8784','2013-01-27','13:15:00',2.4),('8784','2013-01-27','13:20:00',2.38),('8784','2013-01-27','13:25:00',2.33),('8784','2013-01-27','13:30:00',2.28),('8784','2013-01-27','13:35:00',2.2),('8784','2013-01-27','13:40:00',2.15),('8784','2013-01-27','13:45:00',2.12),('8784','2013-01-27','13:50:00',2.09),('8784','2013-01-27','13:55:00',2.01),('8784','2013-01-27','14:00:00',1.91),('8784','2013-01-27','14:05:00',1.93),('8784','2013-01-27','14:10:00',1.94),('8784','2013-01-27','14:15:00',1.91),('8784','2013-01-27','14:20:00',1.85),('8784','2013-01-27','14:25:00',1.8),('8784','2013-01-27','14:30:00',1.72),('8784','2013-01-27','14:35:00',1.66),('8784','2013-01-27','14:40:00',1.62),('8784','2013-01-27','14:45:00',1.6),('8784','2013-01-27','14:50:00',1.57),('8784','2013-01-27','14:55:00',1.53),('8784','2013-01-27','15:00:00',1.47),('8784','2013-01-27','15:05:00',1.38),('8784','2013-01-27','15:10:00',1.29),('8784','2013-01-27','15:15:00',1.21),('8784','2013-01-27','15:20:00',1.15),('8784','2013-01-27','15:25:00',1.1),('8784','2013-01-27','15:30:00',1.03),('8784','2013-01-26','09:50:00',1.05),('8784','2013-01-26','09:55:00',1.04),('8784','2013-01-26','10:15:00',1.05),('8784','2013-01-26','10:20:00',1.14),('8784','2013-01-26','10:25:00',1.2),('8784','2013-01-26','10:45:00',1.02),('8784','2013-01-26','10:50:00',1.24),('8784','2013-01-26','10:55:00',1.23),('8784','2013-01-26','11:05:00',1.13),('8784','2013-01-26','11:25:00',1.09),('8784','2013-01-26','11:30:00',1.09),('8784','2013-01-26','11:40:00',1.01),('8784','2013-01-26','12:25:00',1.01),('8784','2013-01-25','09:25:00',1.04),('8784','2013-01-25','09:30:00',1.14),('8784','2013-01-25','09:35:00',1.14),('8784','2013-01-25','09:40:00',1.09),('8784','2013-01-25','09:45:00',1.39),('8784','2013-01-25','09:50:00',1.76),('8784','2013-01-25','09:55:00',1.77),('8784','2013-01-25','10:00:00',1.78),('8784','2013-01-25','10:05:00',1.79),('8784','2013-01-25','10:10:00',1.91),('8784','2013-01-25','10:15:00',2),('8784','2013-01-25','10:20:00',2.12),('8784','2013-01-25','10:25:00',2.21),('8784','2013-01-25','10:30:00',1.9),('8784','2013-01-25','10:35:00',1.28),('8784','2013-01-25','10:40:00',2.29),('8784','2013-01-25','10:45:00',2.06),('8784','2013-01-25','10:50:00',1.92),('8784','2013-01-25','10:55:00',2.61),('8784','2013-01-25','11:00:00',1.13),('8784','2013-01-25','11:05:00',1.15),('8784','2013-01-25','11:10:00',2.39),('8784','2013-01-25','11:15:00',2.46),('8784','2013-01-25','11:20:00',2.48),('8784','2013-01-25','11:25:00',2.54),('8784','2013-01-25','11:30:00',2.57),('8784','2013-01-25','11:35:00',2.56),('8784','2013-01-25','11:40:00',2.57),('8784','2013-01-25','11:45:00',2.56),('8784','2013-01-25','11:50:00',2.6),('8784','2013-01-25','11:55:00',2.6),('8784','2013-01-25','12:00:00',2.6),('8784','2013-01-25','12:05:00',2.58),('8784','2013-01-25','12:10:00',2.61),('8784','2013-01-25','12:15:00',2.61),('8784','2013-01-25','12:20:00',2.62),('8784','2013-01-25','12:25:00',2.59),('8784','2013-01-25','12:30:00',2.44),('8784','2013-01-25','12:35:00',2.19),('8784','2013-01-25','12:40:00',2.4),('8784','2013-01-25','12:45:00',2.51),('8784','2013-01-25','12:50:00',2.34),('8784','2013-01-25','12:55:00',2.24),('8784','2013-01-25','13:00:00',2.36),('8784','2013-01-25','13:05:00',2.35),('8784','2013-01-25','13:10:00',2.35),('8784','2013-01-25','13:15:00',2.32),('8784','2013-01-25','13:20:00',2.3),('8784','2013-01-25','13:25:00',2.35),('8784','2013-01-25','13:30:00',2.43),('8784','2013-01-25','13:35:00',2.37),('8784','2013-01-25','13:40:00',2.3),('8784','2013-01-25','13:45:00',2.26),('8784','2013-01-25','13:50:00',2.1),('8784','2013-01-25','13:55:00',2.02),('8784','2013-01-25','14:00:00',2.05),('8784','2013-01-25','14:05:00',1.94),('8784','2013-01-25','14:10:00',1.86),('8784','2013-01-25','14:15:00',1.72),('8784','2013-01-25','14:20:00',1.69),('8784','2013-01-25','14:25:00',1.68),('8784','2013-01-25','14:30:00',1.6),('8784','2013-01-25','14:35:00',1.53),('8784','2013-01-25','14:40:00',1.49),('8784','2013-01-25','14:45:00',1.43),('8784','2013-01-25','14:50:00',1.4),('8784','2013-01-25','14:55:00',1.33),('8784','2013-01-25','15:00:00',1.23),('8784','2013-01-25','15:05:00',1.18),('8784','2013-01-25','15:10:00',1.15),('8784','2013-01-25','15:15:00',1.09),('8784','2013-01-25','15:20:00',1),('8784','2013-01-25','15:30:00',1.06),('8784','2013-01-25','15:35:00',1.08),('8784','2013-01-25','15:40:00',1.04),('8784','2013-01-25','15:45:00',1.03),('8784','2013-01-25','15:50:00',1),('8784','2013-01-24','09:50:00',1.39),('8784','2013-01-24','09:55:00',1.57),('8784','2013-01-24','10:00:00',1.66),('8784','2013-01-24','10:05:00',1.71),('8784','2013-01-24','10:10:00',1.78),('8784','2013-01-24','10:15:00',1.98),('8784','2013-01-24','10:20:00',2.13),('8784','2013-01-24','10:25:00',2.19),('8784','2013-01-24','10:30:00',2.22),('8784','2013-01-24','10:35:00',2.26),('8784','2013-01-24','10:40:00',2.32),('8784','2013-01-24','10:45:00',2.32),('8784','2013-01-24','10:50:00',2.45),('8784','2013-01-24','10:55:00',2),('8784','2013-01-24','11:00:00',1.31),('8784','2013-01-24','12:50:00',1.05),('8784','2013-01-24','12:55:00',1.04),('8784','2013-01-24','13:55:00',1.03),('8784','2013-01-24','14:00:00',1.26),('8784','2013-01-24','14:05:00',1.19),('8784','2013-01-24','14:10:00',1.17),('8784','2013-01-24','14:15:00',1.31),('8784','2013-01-24','14:20:00',2.03),('8784','2013-01-24','14:25:00',2.81),('8784','2013-01-24','14:30:00',2.35),('8784','2013-01-24','14:35:00',1.64),('8784','2013-01-24','14:40:00',1.36),('8784','2013-01-24','14:45:00',1.63),('8784','2013-01-24','14:50:00',1.71),('8784','2013-01-24','14:55:00',1.62),('8784','2013-01-24','15:00:00',1.13),('8784','2013-01-24','15:20:00',1.03),('8784','2013-01-24','15:30:00',1.11),('8784','2013-01-23','09:55:00',1.18),('8784','2013-01-23','10:25:00',1.11),('8784','2013-01-23','10:30:00',2.22),('8784','2013-01-23','10:35:00',2.24),('8784','2013-01-23','10:40:00',1.46),('8784','2013-01-23','10:45:00',1.41),('8784','2013-01-23','10:50:00',2.11),('8784','2013-01-23','10:55:00',1.41),('8784','2013-01-22','09:00:00',1.19),('8784','2013-01-22','09:40:00',1.06),('8784','2013-01-22','09:45:00',1.82),('8784','2013-01-22','09:55:00',1.14),('8784','2013-01-22','10:10:00',1.72),('8784','2013-01-22','10:15:00',1.66),('8784','2013-01-22','10:20:00',2.08),('8784','2013-01-22','10:25:00',2.22),('8784','2013-01-22','10:30:00',2.27),('8784','2013-01-22','10:35:00',2.47),('8784','2013-01-22','10:40:00',2.73),('8784','2013-01-22','10:45:00',2.36),('8784','2013-01-22','10:50:00',1.85),('8784','2013-01-22','10:55:00',1.21),('8784','2013-01-22','11:10:00',1.11),('8784','2013-01-22','11:15:00',1.4),('8784','2013-01-22','11:20:00',1.56),('8784','2013-01-22','11:45:00',1.58),('8784','2013-01-22','11:50:00',1.84),('8784','2013-01-22','12:10:00',2.52),('8784','2013-01-22','12:15:00',2.19),('8784','2013-01-22','12:20:00',1.72),('8784','2013-01-22','12:25:00',1.99),('8784','2013-01-22','12:30:00',1.03),('8784','2013-01-22','12:35:00',1.19),('8784','2013-01-22','12:40:00',2.58),('8784','2013-01-22','12:50:00',1.25),('8784','2013-01-22','13:00:00',2.31),('8784','2013-01-22','13:05:00',2.9),('8784','2013-01-22','13:10:00',2.08),('8784','2013-01-22','13:15:00',1.32),('8784','2013-01-22','13:20:00',1.93),('8784','2013-01-22','13:40:00',1.05),('8784','2013-01-22','13:45:00',1.24),('8784','2013-01-22','13:50:00',1.1),('8784','2013-01-22','14:10:00',1.4),('8784','2013-01-22','14:15:00',1.24),('8784','2013-01-22','14:20:00',1.05),('8784','2013-01-22','14:25:00',1.54),('8784','2013-01-22','14:35:00',1.39),('8784','2013-01-22','14:40:00',1.16),('8784','2013-01-22','14:45:00',1.54),('8784','2013-01-22','14:50:00',1.04),('8784','2014-03-20','07:35:00',1.02),('8784','2014-03-20','07:40:00',1.15),('8784','2014-03-20','07:45:00',1.23),('8784','2014-03-20','07:50:00',1.3),('8784','2014-03-20','07:55:00',1.38),('8784','2014-03-20','08:00:00',1.46),('8784','2014-03-20','08:05:00',1.53),('8784','2014-03-20','08:10:00',1.56),('8784','2014-03-20','08:15:00',1.65),('8784','2014-03-20','08:20:00',1.67),('8784','2014-03-20','08:25:00',1.75),('8784','2014-03-20','08:30:00',1.82),('8784','2014-03-20','08:35:00',1.97),('8784','2014-03-20','08:40:00',2.08),('8784','2014-03-20','08:45:00',2.16),('8784','2014-03-20','08:50:00',2.17),('8784','2014-03-20','08:55:00',2.29),('8784','2014-03-20','09:00:00',2.34),('8784','2014-03-20','09:05:00',2.45),('8784','2014-03-20','09:10:00',2.53),('8784','2014-03-20','09:15:00',2.58),('8784','2014-03-20','09:20:00',2.65),('8784','2014-03-20','09:25:00',2.68),('8784','2014-03-20','09:30:00',2.73),('8784','2014-03-20','09:35:00',2.82),('8784','2014-03-20','09:40:00',2.84),('8784','2014-03-20','09:45:00',2.87),('8784','2014-03-20','09:50:00',2.83),('8784','2014-03-20','09:55:00',2.91),('8784','2014-03-20','10:00:00',3.03),('8784','2014-03-20','10:05:00',3.18),('8784','2014-03-20','10:10:00',3.2),('8784','2014-03-20','10:15:00',3.15),('8784','2014-03-20','10:20:00',3.2),('8784','2014-03-20','10:25:00',3.27),('8784','2014-03-20','10:30:00',3.29),('8784','2014-03-20','10:35:00',3.18),('8784','2014-03-20','10:40:00',3.13),('8784','2014-03-20','10:45:00',3.18),('8784','2014-03-20','10:50:00',3.39),('8784','2014-03-20','10:55:00',3.59),('8784','2014-03-20','11:00:00',3.64),('8784','2014-03-20','11:05:00',3.59),('8784','2014-03-20','11:10:00',3.56),('8784','2014-03-20','11:15:00',3.38),('8784','2014-03-20','11:20:00',3.57),('8784','2014-03-20','11:25:00',3.58),('8784','2014-03-20','11:30:00',3.66),('8784','2014-03-20','11:35:00',3.78),('8784','2014-03-20','11:40:00',3.71),('8784','2014-03-20','11:45:00',3.71),('8784','2014-03-20','11:50:00',3.75),('8784','2014-03-20','11:55:00',3.46),('8784','2014-03-20','12:00:00',3.28),('8784','2014-03-20','12:05:00',3.54),('8784','2014-03-20','12:10:00',3.71),('8784','2014-03-20','12:15:00',3.75),('8784','2014-03-20','12:20:00',3.63),('8784','2014-03-20','12:25:00',3.5),('8784','2014-03-20','12:30:00',3.63),('8784','2014-03-20','12:35:00',3.68),('8784','2014-03-20','12:40:00',3.68),('8784','2014-03-20','12:45:00',3.75),('8784','2014-03-20','12:50:00',3.72),('8784','2014-03-20','12:55:00',3.7),('8784','2014-03-20','13:00:00',3.64),('8784','2014-03-20','13:05:00',3.6),('8784','2014-03-20','13:10:00',3.52),('8784','2014-03-20','13:15:00',3.46),('8784','2014-03-20','13:20:00',3.5),('8784','2014-03-20','13:25:00',3.39),('8784','2014-03-20','13:30:00',3.46),('8784','2014-03-20','13:35:00',3.35),('8784','2014-03-20','13:40:00',3.18),('8784','2014-03-20','13:45:00',3.04),('8784','2014-03-20','13:50:00',2.93),('8784','2014-03-20','13:55:00',2.75),('8784','2014-03-20','14:00:00',2.89),('8784','2014-03-20','14:05:00',3.1),('8784','2014-03-20','14:10:00',2.99),('8784','2014-03-20','14:15:00',2.81),('8784','2014-03-20','14:20:00',2.75),('8784','2014-03-20','14:25:00',2.78),('8784','2014-03-20','14:30:00',2.32),('8784','2014-03-20','14:35:00',2.17),('8784','2014-03-20','14:40:00',2.43),('8784','2014-03-20','14:45:00',2.38),('8784','2014-03-20','14:50:00',2.25),('8784','2014-03-20','14:55:00',2.19),('8784','2014-03-20','15:00:00',2),('8784','2014-03-20','15:05:00',2),('8784','2014-03-20','15:10:00',2.03),('8784','2014-03-20','15:15:00',1.95),('8784','2014-03-20','15:20:00',2.07),('8784','2014-03-20','15:25:00',1.85),('8784','2014-03-20','15:30:00',1.79),('8784','2014-03-20','15:35:00',1.72),('8784','2014-03-20','15:40:00',1.58),('8784','2014-03-20','15:45:00',1.58),('8784','2014-03-20','15:50:00',1.39),('8784','2014-03-20','15:55:00',1.26),('8784','2014-03-20','16:00:00',1.08),('8784','2014-03-20','16:10:00',1),('8784','2014-03-20','16:25:00',1.04),('8784','2013-01-21','11:10:00',1.19),('8784','2013-01-21','11:15:00',1.29),('8784','2013-01-21','11:20:00',1.1),('8784','2013-01-21','11:25:00',1.03),('8784','2013-01-21','11:50:00',1.68),('8784','2013-01-21','11:55:00',2.79),('8784','2013-01-21','12:00:00',2.44),('8784','2013-01-21','12:05:00',2.44),('8784','2013-01-21','12:10:00',2.5),('8784','2013-01-21','12:15:00',1.74),('8784','2013-01-21','12:25:00',1.63),('8784','2013-01-21','12:40:00',1.05),('8784','2013-01-21','12:50:00',1.32),('8784','2013-01-21','13:05:00',1.87),('8784','2013-01-21','13:10:00',1.44),('8784','2013-01-21','13:30:00',2.91),('8784','2013-01-21','13:35:00',2.55),('8784','2013-01-21','13:40:00',2.12),('8784','2013-01-21','13:50:00',1.93),('8784','2013-01-21','13:55:00',2.69),('8784','2013-01-21','14:00:00',1.89),('8784','2013-01-21','14:05:00',2.43),('8784','2013-01-21','14:10:00',2.02),('8784','2013-01-21','14:15:00',1.41),('8784','2013-01-21','14:20:00',1.9),('8784','2013-01-21','14:25:00',1.89),('8784','2013-01-21','14:30:00',1.26),('8784','2013-01-20','10:50:00',1),('8784','2013-01-20','10:55:00',1.07),('8784','2013-01-20','11:00:00',1.19),('8784','2013-01-20','11:05:00',1.24),('8784','2013-01-20','11:10:00',1.33),('8784','2013-01-20','11:15:00',1.69),('8784','2013-01-20','11:20:00',1.37),('8784','2013-01-20','11:25:00',1.78),('8784','2013-01-20','11:30:00',2.21),('8784','2013-01-20','11:35:00',1.79),('8784','2013-01-20','11:40:00',1.11),('8784','2013-01-20','11:45:00',1.05),('8784','2013-01-20','12:25:00',1.03),('8784','2013-01-19','09:50:00',1.08),('8784','2013-01-19','09:55:00',1.41),('8784','2013-01-19','10:00:00',1.37),('8784','2013-01-19','10:05:00',1.1),('8784','2013-01-19','10:40:00',1.15),('8784','2013-01-19','10:45:00',1.38),('8784','2013-01-19','10:50:00',1.36),('8784','2013-01-19','11:20:00',1.23),('8784','2013-01-19','11:25:00',1.22),('8784','2013-01-18','10:15:00',2.04),('8784','2013-01-18','10:20:00',2.29),('8784','2013-01-18','10:25:00',1.61),('8784','2013-01-18','10:30:00',1.3),('8784','2013-01-18','10:35:00',1.08),('8784','2013-01-18','11:30:00',1.11),('8784','2013-01-18','11:35:00',1.29),('8784','2013-01-18','11:40:00',1.19),('8784','2013-01-18','12:10:00',1.1),('8784','2013-01-18','12:15:00',1.11),('8784','2013-01-18','12:20:00',1.1),('8784','2013-01-18','12:25:00',1.13),('8784','2013-01-18','12:30:00',1.13),('8784','2013-01-18','12:35:00',1.33),('8784','2013-01-18','12:40:00',1.42),('8784','2013-01-18','12:45:00',1.5),('8784','2013-01-18','12:50:00',1.9),('8784','2013-01-18','12:55:00',2.06),('8784','2013-01-18','13:00:00',2.54),('8784','2013-01-18','13:05:00',2.44),('8784','2013-01-18','13:10:00',2.22),('8784','2013-01-18','13:15:00',2.4),('8784','2013-01-18','13:20:00',1.9),('8784','2013-01-18','13:25:00',1.52),('8784','2013-01-18','13:30:00',1.43),('8784','2013-01-18','13:35:00',1.33),('8784','2013-01-18','13:40:00',1.51),('8784','2013-01-18','13:45:00',2.56),('8784','2013-01-18','13:50:00',2.63),('8784','2013-01-18','13:55:00',2.52),('8784','2013-01-18','14:00:00',2.5),('8784','2013-01-18','14:05:00',2.52),('8784','2013-01-18','14:10:00',1.64),('8784','2013-01-18','14:15:00',2.23),('8784','2013-01-18','14:20:00',1.83),('8784','2013-01-18','14:25:00',1.59),('8784','2013-01-18','14:30:00',1.21),('8784','2013-01-18','14:35:00',1.02),('8784','2013-01-17','09:50:00',1.04),('8784','2013-01-17','09:55:00',1.02),('8784','2013-01-17','10:10:00',1.14),('8784','2013-01-17','10:15:00',1.3),('8784','2013-01-17','10:20:00',1.27),('8784','2013-01-17','10:25:00',1.56),('8784','2013-01-17','10:30:00',1.62),('8784','2013-01-17','10:35:00',1.52),('8784','2013-01-17','10:40:00',1.5),('8784','2013-01-17','10:45:00',1.58),('8784','2013-01-17','10:50:00',1.52),('8784','2013-01-17','10:55:00',1.72),('8784','2013-01-17','11:00:00',1.56),('8784','2013-01-17','11:05:00',1.56),('8784','2013-01-17','11:10:00',1.81),('8784','2013-01-17','11:15:00',1.72),('8784','2013-01-17','11:20:00',1.62),('8784','2013-01-17','11:25:00',1.42),('8784','2013-01-17','11:30:00',1.28),('8784','2013-01-17','11:35:00',1.43),('8784','2013-01-17','11:40:00',1.47),('8784','2013-01-17','11:45:00',1.34),('8784','2013-01-17','11:50:00',1.44),('8784','2013-01-17','11:55:00',1.54),('8784','2013-01-17','12:00:00',1.7),('8784','2013-01-17','12:05:00',1.7),('8784','2013-01-17','12:10:00',1.77),('8784','2013-01-17','12:15:00',1.88),('8784','2013-01-17','12:20:00',1.78),('8784','2013-01-17','12:25:00',1.6),('8784','2013-01-17','12:30:00',1.33),('8784','2013-01-17','12:35:00',1.59),('8784','2013-01-17','12:40:00',1.62),('8784','2013-01-17','12:45:00',1.39),('8784','2013-01-17','12:55:00',1.11),('8784','2013-01-17','13:00:00',1.51),('8784','2013-01-17','13:05:00',1.42),('8784','2013-01-17','13:10:00',1.15),('8784','2013-01-17','13:15:00',1.43),('8784','2013-01-17','13:20:00',1.45),('8784','2013-01-17','13:25:00',1.25),('8784','2013-01-17','13:30:00',1.15),('8784','2013-01-17','13:35:00',1.51),('8784','2013-01-17','13:40:00',1.54),('8784','2013-01-17','13:45:00',1.42),('8784','2013-01-17','13:50:00',1.34),('8784','2013-01-17','14:00:00',1.34),('8784','2013-01-17','14:05:00',1.02),('8784','2013-01-17','14:30:00',1.19),('8784','2013-01-17','14:35:00',1.6),('8784','2013-01-16','10:35:00',1.61),('8784','2013-01-16','10:40:00',1.82),('8784','2013-01-16','10:45:00',1.72),('8784','2013-01-16','10:55:00',1.69),('8784','2013-01-16','11:25:00',1.56),('8784','2013-01-16','12:00:00',1.72),('8784','2013-01-16','12:05:00',1.33),('8784','2013-01-16','12:10:00',1.78),('8784','2013-01-16','12:15:00',3.11),('8784','2013-01-16','12:20:00',2.65),('8784','2013-01-16','13:05:00',2.24),('8784','2013-01-16','13:10:00',3.17),('8784','2013-01-16','13:15:00',3.35),('8784','2013-01-16','13:20:00',2.29),('8784','2013-01-16','13:25:00',1.51),('8784','2013-01-16','13:55:00',2.66),('8784','2013-01-16','14:00:00',1.85),('8784','2013-01-16','14:05:00',1.33),('8784','2013-01-15','10:00:00',1.02),('8784','2013-01-15','10:10:00',1.14),('8784','2013-01-15','10:25:00',1.02),('8784','2013-01-15','10:45:00',1.07),('8784','2013-01-15','10:50:00',1.33),('8784','2013-01-15','10:55:00',1.47),('8784','2013-01-15','11:00:00',1.45),('8784','2013-01-15','11:05:00',1.51),('8784','2013-01-15','11:10:00',1.55),('8784','2013-01-15','11:15:00',1.46),('8784','2013-01-15','11:20:00',1.49),('8784','2013-01-15','11:25:00',1.48),('8784','2013-01-15','11:30:00',1.43),('8784','2013-01-15','11:35:00',1.35),('8784','2013-01-15','11:40:00',1.21),('8784','2013-01-15','11:45:00',1.14),('8784','2013-01-15','11:50:00',1.09),('8784','2013-01-15','11:55:00',1.17),('8784','2013-01-15','12:00:00',1.11),('8784','2013-01-15','12:05:00',1.05),('8784','2013-01-15','12:10:00',1.02),('8784','2013-01-15','12:15:00',1.16),('8784','2013-01-15','12:20:00',1.31),('8784','2013-01-15','12:25:00',1.29),('8784','2013-01-15','12:30:00',1.23),('8784','2013-01-15','12:35:00',1.24),('8784','2013-01-15','12:40:00',1.37),('8784','2013-01-15','12:45:00',1.4),('8784','2013-01-15','12:50:00',1.42),('8784','2013-01-15','12:55:00',1.21),('8784','2013-01-15','13:00:00',1.01),('8784','2013-01-15','13:05:00',1.07),('8784','2013-01-15','13:10:00',1.08),('8784','2013-01-15','13:15:00',1.11),('8784','2013-01-15','13:20:00',1.11),('8784','2013-01-15','13:25:00',1.08),('8784','2013-01-15','13:30:00',1.18),('8784','2013-01-15','13:35:00',1.21),('8784','2013-01-15','13:40:00',1.37),('8784','2013-01-15','13:45:00',1.25),('8784','2013-01-15','13:50:00',1.19),('8784','2013-01-15','13:55:00',1.38),('8784','2013-01-15','14:00:00',2),('8784','2013-01-15','14:05:00',1.86),('8784','2013-01-15','14:10:00',1.47),('8784','2013-01-15','14:15:00',2.3),('8784','2013-01-15','14:20:00',2.36),('8784','2013-01-15','14:25:00',1.91),('8784','2013-01-15','14:30:00',1.91),('8784','2013-01-15','14:35:00',1.38),('8784','2013-01-15','14:40:00',1.13),('8784','2013-01-15','14:45:00',1.4),('8784','2013-01-15','14:50:00',1.15),('8784','2013-01-15','14:55:00',1.36),('8784','2013-01-15','15:00:00',1.36),('8784','2013-01-15','15:05:00',1.16),('8784','2013-01-14','12:45:00',1.1),('8784','2013-01-14','12:50:00',1.23),('8784','2013-01-14','12:55:00',1.21),('8784','2013-01-14','13:00:00',1.25),('8784','2013-01-14','13:05:00',1.21),('8784','2013-01-14','15:15:00',1.09),('8784','2013-01-13','09:15:00',1.05),('8784','2013-01-13','09:20:00',1.1),('8784','2013-01-13','09:25:00',1.03),('8784','2013-01-13','09:30:00',1.07),('8784','2013-01-13','09:35:00',1.05),('8784','2013-01-13','10:00:00',1.03),('8784','2013-01-13','10:05:00',1.49),('8784','2013-01-13','10:20:00',1.26),('8784','2013-01-13','10:25:00',1.33),('8784','2013-01-13','10:30:00',1.72),('8784','2013-01-12','09:50:00',1.11),('8784','2013-01-12','09:55:00',1.25),('8784','2013-01-12','10:00:00',1.31),('8784','2013-01-12','10:05:00',1.32),('8784','2013-01-12','10:10:00',1.35),('8784','2013-01-12','10:15:00',1.5),('8784','2013-01-12','10:20:00',1.64),('8784','2013-01-12','10:25:00',1.73),('8784','2013-01-12','10:30:00',1.79),('8784','2013-01-12','10:35:00',1.83),('8784','2013-01-12','10:40:00',1.88),('8784','2013-01-12','10:45:00',1.94),('8784','2013-01-12','10:50:00',1.96),('8784','2013-01-12','10:55:00',1.99),('8784','2013-01-12','11:00:00',2.02),('8784','2013-01-12','11:05:00',2.08),('8784','2013-01-12','11:10:00',2.11),('8784','2013-01-12','11:15:00',2),('8784','2013-01-12','11:20:00',2.06),('8784','2013-01-12','11:25:00',2.05),('8784','2013-01-12','11:30:00',2.07),('8784','2013-01-12','11:35:00',2.05),('8784','2013-01-12','11:40:00',2.07),('8784','2013-01-12','11:45:00',2.1),('8784','2013-01-12','11:50:00',2.1),('8784','2013-01-12','11:55:00',2.09),('8784','2013-01-12','12:00:00',2.14),('8784','2013-01-12','12:05:00',2.1),('8784','2013-01-12','12:10:00',2.07),('8784','2013-01-12','12:15:00',2.04),('8784','2013-01-12','12:20:00',2.06),('8784','2013-01-12','12:25:00',2.05),('8784','2013-01-12','12:30:00',2.03),('8784','2013-01-12','12:35:00',2.08),('8784','2013-01-12','12:40:00',1.75),('8784','2013-01-12','12:45:00',1.32),('8784','2013-01-12','12:50:00',1.64),('8784','2013-01-12','13:00:00',1.87),('8784','2013-01-12','13:05:00',2.09),('8784','2013-01-12','13:10:00',1.82),('8784','2013-01-12','13:15:00',1.18),('8784','2013-01-12','13:25:00',1.4),('8784','2013-01-12','13:30:00',1.71),('8784','2013-01-12','13:35:00',1.03),('8784','2013-01-12','13:45:00',1.35),('8784','2013-01-12','13:50:00',1.86),('8784','2013-01-12','13:55:00',2.17),('8784','2013-01-12','14:00:00',1.45),('8784','2013-01-12','14:05:00',1.85),('8784','2013-01-12','14:10:00',1.69),('8784','2013-01-12','14:15:00',1.25),('8784','2013-01-12','14:20:00',1.42),('8784','2013-01-12','14:25:00',1.42),('8784','2013-01-12','14:30:00',1.37),('8784','2013-01-12','14:35:00',1.34),('8784','2013-01-12','14:40:00',1.25),('8784','2013-01-12','14:45:00',1.19),('8784','2013-01-12','14:50:00',1.08),('8784','2013-01-12','14:55:00',1.11),('8784','2013-01-12','15:00:00',1.04),('8784','2014-03-19','08:50:00',1.01),('8784','2014-03-19','08:55:00',1.05),('8784','2014-03-19','09:00:00',1.09),('8784','2014-03-19','09:05:00',1.32),('8784','2014-03-19','09:10:00',1.44),('8784','2014-03-19','09:15:00',1.72),('8784','2014-03-19','09:20:00',1.65),('8784','2014-03-19','09:25:00',2.7),('8784','2014-03-19','09:30:00',3.41),('8784','2014-03-19','09:35:00',3.21),('8784','2014-03-19','09:40:00',3.14),('8784','2014-03-19','09:45:00',2.81),('8784','2014-03-19','09:50:00',2.88),('8784','2014-03-19','09:55:00',2.03),('8784','2014-03-19','10:00:00',1.41),('8784','2014-03-19','10:05:00',1.07),('8784','2014-03-19','10:25:00',1.11),('8784','2014-03-19','10:30:00',1.43),('8784','2014-03-19','10:35:00',2.77),('8784','2014-03-19','10:40:00',1.96),('8784','2014-03-19','10:45:00',1.81),('8784','2014-03-19','10:50:00',1.63),('8784','2014-03-19','10:55:00',1.69),('8784','2014-03-19','11:00:00',3.61),('8784','2014-03-19','11:05:00',3.68),('8784','2014-03-19','11:10:00',1.93),('8784','2014-03-19','11:15:00',1.81),('8784','2014-03-19','11:20:00',1.74),('8784','2014-03-19','11:25:00',1.88),('8784','2014-03-19','11:30:00',1.82),('8784','2014-03-19','11:35:00',2.3),('8784','2014-03-19','11:40:00',2.03),('8784','2014-03-19','11:45:00',1.97),('8784','2014-03-19','11:50:00',1.83),('8784','2014-03-19','11:55:00',1.88),('8784','2014-03-19','12:00:00',2.94),('8784','2014-03-19','12:05:00',4.16),('8784','2014-03-19','12:10:00',4.17),('8784','2014-03-19','12:15:00',4.22),('8784','2014-03-19','12:20:00',4.27),('8784','2014-03-19','12:25:00',3.8),('8784','2014-03-19','12:30:00',3.73),('8784','2014-03-19','12:35:00',3.63),('8784','2014-03-19','12:40:00',3.76),('8784','2014-03-19','12:45:00',3.91),('8784','2014-03-19','12:50:00',3.61),('8784','2014-03-19','12:55:00',3.29),('8784','2014-03-19','13:00:00',3.7),('8784','2014-03-19','13:05:00',3.6),('8784','2014-03-19','13:10:00',3.63),('8784','2014-03-19','13:15:00',3.5),('8784','2014-03-19','13:20:00',3.26),('8784','2014-03-19','13:25:00',3.12),('8784','2014-03-19','13:30:00',3.51),('8784','2014-03-19','13:35:00',3.62),('8784','2014-03-19','13:40:00',3.43),('8784','2014-03-19','13:45:00',3.35),('8784','2014-03-19','13:50:00',3.25),('8784','2014-03-19','13:55:00',3.41),('8784','2014-03-19','14:00:00',3.28),('8784','2014-03-19','14:05:00',3.3),('8784','2014-03-19','14:10:00',3.22),('8784','2014-03-19','14:15:00',3.13),('8784','2014-03-19','14:20:00',3.08),('8784','2014-03-19','14:25:00',3.02),('8784','2014-03-19','14:30:00',2.93),('8784','2014-03-19','14:35:00',2.97),('8784','2014-03-19','14:40:00',2.91),('8784','2014-03-19','14:45:00',2.84),('8784','2014-03-19','14:50:00',2.74),('8784','2014-03-19','14:55:00',2.7),('8784','2014-03-19','15:00:00',2.61),('8784','2014-03-19','15:05:00',2.55),('8784','2014-03-19','15:10:00',2.51),('8784','2014-03-19','15:15:00',2.46),('8784','2014-03-19','15:20:00',2.36),('8784','2014-03-19','15:25:00',2.32),('8784','2014-03-19','15:30:00',2.21),('8784','2014-03-19','15:35:00',2.09),('8784','2014-03-19','15:40:00',2.09),('8784','2014-03-19','15:45:00',2.01),('8784','2014-03-19','15:50:00',1.91),('8784','2014-03-19','15:55:00',1.87),('8784','2014-03-19','16:00:00',1.75),('8784','2014-03-19','16:05:00',1.69),('8784','2014-03-19','16:10:00',1.62),('8784','2014-03-19','16:15:00',1.52),('8784','2014-03-19','16:20:00',1.43),('8784','2014-03-19','16:25:00',1.29),('8784','2014-03-19','16:30:00',1.23),('8784','2014-03-19','16:35:00',1.1),('8784','2014-03-19','16:40:00',1.02),('8784','2013-01-11','10:05:00',1.11),('8784','2013-01-11','10:10:00',1.09),('8784','2013-01-11','10:15:00',1.29),('8784','2013-01-11','10:20:00',1.31),('8784','2013-01-11','10:25:00',1.75),('8784','2013-01-11','10:30:00',1.7),('8784','2013-01-11','10:35:00',1.78),('8784','2013-01-11','10:40:00',1.83),('8784','2013-01-11','10:45:00',1.89),('8784','2013-01-11','10:50:00',1.9),('8784','2013-01-11','10:55:00',1.94),('8784','2013-01-11','11:00:00',1.96),('8784','2013-01-11','11:05:00',2.03),('8784','2013-01-11','11:10:00',2.07),('8784','2013-01-11','11:15:00',2.02),('8784','2013-01-11','11:20:00',1.95),('8784','2013-01-11','11:25:00',1.28),('8784','2013-01-11','11:30:00',1.17),('8784','2013-01-11','11:35:00',1.32),('8784','2013-01-11','11:40:00',1.2),('8784','2013-01-11','11:45:00',1.46),('8784','2013-01-11','11:50:00',1.4),('8784','2013-01-11','11:55:00',1.25),('8784','2013-01-11','12:00:00',1.06),('8784','2013-01-11','12:55:00',1.93),('8784','2013-01-11','13:00:00',1.4),('8784','2013-01-11','13:05:00',1.14),('8784','2013-01-11','13:10:00',1.74),('8784','2013-01-11','13:15:00',1.13),('8784','2013-01-11','13:30:00',1.14),('8784','2013-01-11','13:35:00',2.33),('8784','2013-01-11','13:40:00',1.54),('8784','2013-01-11','13:45:00',1.17),('8784','2013-01-11','14:20:00',1.41),('8784','2013-01-11','14:25:00',1.15),('8784','2013-01-11','14:45:00',1.24),('8784','2013-01-11','14:50:00',1.35),('8784','2013-01-11','15:00:00',1.23),('8784','2013-01-11','15:05:00',1.1),('8784','2013-01-10','11:30:00',1.08),('8784','2013-01-10','11:55:00',1.26),('8784','2013-01-10','12:00:00',1.28),('8784','2013-01-10','12:05:00',1.26),('8784','2013-01-10','12:10:00',1.11),('8784','2013-01-09','10:40:00',1.01),('8784','2013-01-09','10:45:00',1.1),('8784','2013-01-09','10:50:00',1.14),('8784','2013-01-09','10:55:00',1.25),('8784','2013-01-09','11:00:00',1.01),('8784','2013-01-09','11:05:00',1.13),('8784','2013-01-09','11:10:00',1.58),('8784','2013-01-09','11:15:00',1.63),('8784','2013-01-09','11:20:00',1.34),('8784','2013-01-09','11:25:00',1.22),('8784','2013-01-09','11:30:00',1.21),('8784','2013-01-09','11:35:00',1.24),('8784','2013-01-09','11:40:00',1.17),('8784','2013-01-09','11:45:00',1.15),('8784','2013-01-09','11:50:00',1.23),('8784','2013-01-09','11:55:00',1.32),('8784','2013-01-09','12:00:00',1.18),('8784','2013-01-09','12:05:00',1.19),('8784','2013-01-09','12:10:00',1.2),('8784','2013-01-09','12:15:00',1.18),('8784','2013-01-09','12:20:00',1.17),('8784','2013-01-09','12:25:00',1.05),('8784','2013-01-09','12:30:00',1.03),('8784','2013-01-09','12:35:00',1.09),('8784','2013-01-09','12:40:00',1.05),('8784','2013-01-09','12:45:00',1.04),('8784','2013-01-09','12:50:00',1.1),('8784','2013-01-09','12:55:00',1.22),('8784','2013-01-09','13:00:00',1.23),('8784','2013-01-09','13:05:00',1.23),('8784','2013-01-09','13:10:00',1.33),('8784','2013-01-09','13:15:00',1.2),('8784','2013-01-09','13:20:00',1),('8784','2013-01-08','09:45:00',1.07),('8784','2013-01-08','09:50:00',1.38),('8784','2013-01-08','09:55:00',1.46),('8784','2013-01-08','10:00:00',1.42),('8784','2013-01-08','10:05:00',1.34),('8784','2013-01-08','10:10:00',1.34),('8784','2013-01-08','10:15:00',1.38),('8784','2013-01-08','10:20:00',1.4),('8784','2013-01-08','10:25:00',1.56),('8784','2013-01-08','10:30:00',1.59),('8784','2013-01-08','10:35:00',1.71),('8784','2013-01-08','10:40:00',1.89),('8784','2013-01-08','10:45:00',1.83),('8784','2013-01-08','10:50:00',1.83),('8784','2013-01-08','10:55:00',1.91),('8784','2013-01-08','11:00:00',1.92),('8784','2013-01-08','11:05:00',2.01),('8784','2013-01-08','11:10:00',2.05),('8784','2013-01-08','11:15:00',1.96),('8784','2013-01-08','11:20:00',2.03),('8784','2013-01-08','11:25:00',2.05),('8784','2013-01-08','11:30:00',2.05),('8784','2013-01-08','11:35:00',2.07),('8784','2013-01-08','11:40:00',2.09),('8784','2013-01-08','11:45:00',2.59),('8784','2013-01-08','11:50:00',1.96),('8784','2013-01-08','11:55:00',1.65),('8784','2013-01-08','12:00:00',1.58),('8784','2013-01-08','12:05:00',1.51),('8784','2013-01-08','12:10:00',1.6),('8784','2013-01-08','12:15:00',1.51),('8784','2013-01-08','12:20:00',1.32),('8784','2013-01-08','12:25:00',1.28),('8784','2013-01-08','12:30:00',1.23),('8784','2013-01-08','12:35:00',1.19),('8784','2013-01-08','12:40:00',1.49),('8784','2013-01-08','12:45:00',1.79),('8784','2013-01-08','12:50:00',1.89),('8784','2013-01-08','12:55:00',1.35),('8784','2013-01-08','13:40:00',1.01),('8784','2013-01-08','13:45:00',1.18),('8784','2013-01-08','13:50:00',1.48),('8784','2013-01-08','13:55:00',2.16),('8784','2013-01-08','14:00:00',1.19),('8784','2013-01-08','14:05:00',1.12),('8784','2013-01-08','14:40:00',1.03),('8784','2013-01-07','09:50:00',1.03),('8784','2013-01-07','09:55:00',1.18),('8784','2013-01-07','10:00:00',1.26),('8784','2013-01-07','10:05:00',1.32),('8784','2013-01-07','10:10:00',1.35),('8784','2013-01-07','10:15:00',1.5),('8784','2013-01-07','10:20:00',1.65),('8784','2013-01-07','10:25:00',1.68),('8784','2013-01-07','10:30:00',1.76),('8784','2013-01-07','10:35:00',1.81),('8784','2013-01-07','10:40:00',1.87),('8784','2013-01-07','10:45:00',1.91),('8784','2013-01-07','10:50:00',1.95),('8784','2013-01-07','10:55:00',1.97),('8784','2013-01-07','11:00:00',1.99),('8784','2013-01-07','11:05:00',2.03),('8784','2013-01-07','11:10:00',2.06),('8784','2013-01-07','11:15:00',2.03),('8784','2013-01-07','11:20:00',2.02),('8784','2013-01-07','11:25:00',2.02),('8784','2013-01-07','11:30:00',2.01),('8784','2013-01-07','11:35:00',2.05),('8784','2013-01-07','11:40:00',2.06),('8784','2013-01-07','11:45:00',2.05),('8784','2013-01-07','11:50:00',2.06),('8784','2013-01-07','11:55:00',2.02),('8784','2013-01-07','12:00:00',2.04),('8784','2013-01-07','12:05:00',2.03),('8784','2013-01-07','12:10:00',2.04),('8784','2013-01-07','12:15:00',2.01),('8784','2013-01-07','12:20:00',2.04),('8784','2013-01-07','12:25:00',2.06),('8784','2013-01-07','12:30:00',2.05),('8784','2013-01-07','12:35:00',1.99),('8784','2013-01-07','12:40:00',1.98),('8784','2013-01-07','12:45:00',1.94),('8784','2013-01-07','12:50:00',1.93),('8784','2013-01-07','12:55:00',1.95),('8784','2013-01-07','13:00:00',1.93),('8784','2013-01-07','13:05:00',1.91),('8784','2013-01-07','13:10:00',1.83),('8784','2013-01-07','13:15:00',1.83),('8784','2013-01-07','13:20:00',1.81),('8784','2013-01-07','13:25:00',1.77),('8784','2013-01-07','13:30:00',1.76),('8784','2013-01-07','13:35:00',1.68),('8784','2013-01-07','13:40:00',1.63),('8784','2013-01-07','13:45:00',1.64),('8784','2013-01-07','13:50:00',1.57),('8784','2013-01-07','13:55:00',1.55),('8784','2013-01-07','14:00:00',1.53),('8784','2013-01-07','14:05:00',1.49),('8784','2013-01-07','14:10:00',1.41),('8784','2013-01-07','14:15:00',1.39),('8784','2013-01-07','14:20:00',1.34),('8784','2013-01-07','14:25:00',1.21),('8784','2013-01-07','14:30:00',1.29),('8784','2013-01-07','14:35:00',1.17),('8784','2013-01-07','14:40:00',1.12),('8784','2013-01-07','14:45:00',1.14),('8784','2013-01-07','14:50:00',1.11),('8784','2013-01-07','14:55:00',1.05),('8784','2013-01-06','09:50:00',1.07),('8784','2013-01-06','09:55:00',1.2),('8784','2013-01-06','10:00:00',1.26),('8784','2013-01-06','10:05:00',1.28),('8784','2013-01-06','10:10:00',1.32),('8784','2013-01-06','10:15:00',1.45),('8784','2013-01-06','10:20:00',1.57),('8784','2013-01-06','10:25:00',1.67),('8784','2013-01-06','10:30:00',1.76),('8784','2013-01-06','10:35:00',1.81),('8784','2013-01-06','10:40:00',1.87),('8784','2013-01-06','10:45:00',1.9),('8784','2013-01-06','10:50:00',1.93),('8784','2013-01-06','10:55:00',1.98),('8784','2013-01-06','11:00:00',1.58),('8784','2013-01-06','11:05:00',2.03),('8784','2013-01-06','11:10:00',2.05),('8784','2013-01-06','11:15:00',2.01),('8784','2013-01-06','11:20:00',2),('8784','2013-01-06','11:25:00',1.98),('8784','2013-01-06','11:30:00',2),('8784','2013-01-06','11:35:00',2.03),('8784','2013-01-06','11:40:00',2.05),('8784','2013-01-06','11:45:00',2.05),('8784','2013-01-06','11:50:00',2.07),('8784','2013-01-06','11:55:00',2.05),('8784','2013-01-06','12:00:00',2.07),('8784','2013-01-06','12:05:00',2.01),('8784','2013-01-06','12:10:00',1.96),('8784','2013-01-06','12:15:00',2.02),('8784','2013-01-06','12:20:00',2.02),('8784','2013-01-06','12:25:00',2.01),('8784','2013-01-06','12:30:00',2),('8784','2013-01-06','12:35:00',1.94),('8784','2013-01-06','12:40:00',1.93),('8784','2013-01-06','12:45:00',1.9),('8784','2013-01-06','12:50:00',1.95),('8784','2013-01-06','12:55:00',1.98),('8784','2013-01-06','13:00:00',1.96),('8784','2013-01-06','13:05:00',1.91),('8784','2013-01-06','13:10:00',1.81),('8784','2013-01-06','13:15:00',1.78),('8784','2013-01-06','13:20:00',1.85),('8784','2013-01-06','13:25:00',1.8),('8784','2013-01-06','13:30:00',1.8),('8784','2013-01-06','13:35:00',1.73),('8784','2013-01-06','13:40:00',1.71),('8784','2013-01-06','13:45:00',1.68),('8784','2013-01-06','13:50:00',1.63),('8784','2013-01-06','13:55:00',1.6),('8784','2013-01-06','14:00:00',1.59),('8784','2013-01-06','14:05:00',1.6),('8784','2013-01-06','14:10:00',1.44),('8784','2013-01-06','14:15:00',1.45),('8784','2013-01-06','14:20:00',1.35),('8784','2013-01-06','14:25:00',1.25),('8784','2013-01-06','14:30:00',1.29),('8784','2013-01-06','14:35:00',1.14),('8784','2013-01-06','14:50:00',1.07),('8784','2013-01-06','14:55:00',1.01),('8784','2013-01-05','10:15:00',1.04),('8784','2013-01-05','10:35:00',1.06),('8784','2013-01-05','10:40:00',1.1),('8784','2013-01-05','10:45:00',1.07),('8784','2013-01-05','10:50:00',1.19),('8784','2013-01-05','10:55:00',1.81),('8784','2013-01-05','11:00:00',1.58),('8784','2013-01-05','11:05:00',1.81),('8784','2013-01-05','11:10:00',1.78),('8784','2013-01-05','11:15:00',1.47),('8784','2013-01-05','11:20:00',1.93),('8784','2013-01-05','11:25:00',2.02),('8784','2013-01-05','11:30:00',2.04),('8784','2013-01-05','11:35:00',1.99),('8784','2013-01-05','11:40:00',1.88),('8784','2013-01-05','11:45:00',1.92),('8784','2013-01-05','11:50:00',1.74),('8784','2013-01-05','11:55:00',1.6),('8784','2013-01-05','12:00:00',1.48),('8784','2013-01-05','12:05:00',1.46),('8784','2013-01-05','12:10:00',1.47),('8784','2013-01-05','12:15:00',1.51),('8784','2013-01-05','12:20:00',1.37),('8784','2013-01-05','12:25:00',1.18),('8784','2013-01-05','12:30:00',1.16),('8784','2013-01-05','12:35:00',1.48),('8784','2013-01-05','12:40:00',1.88),('8784','2013-01-05','12:45:00',2.05),('8784','2013-01-05','12:50:00',1.45),('8784','2013-01-05','12:55:00',1.22),('8784','2013-01-05','13:00:00',1.25),('8784','2013-01-05','13:05:00',1.22),('8784','2013-01-05','13:10:00',1.17),('8784','2013-01-05','13:25:00',1.08),('8784','2013-01-05','13:30:00',1.66),('8784','2013-01-05','13:35:00',1.38),('8784','2013-01-05','13:40:00',1.06),('8784','2013-01-05','13:50:00',1.01),('8784','2013-01-05','13:55:00',1.18),('8784','2013-01-05','14:00:00',1.06);
INSERT INTO `solarlog` VALUES ('8784','2013-01-05','14:05:00',1.54),('8784','2013-01-05','14:10:00',1.37),('8784','2013-01-05','14:15:00',1.16),('8784','2013-01-05','14:30:00',1.07),('8784','2013-01-05','14:35:00',1.03),('8784','2013-01-05','14:40:00',1.07),('8784','2013-01-05','14:45:00',1.17),('8784','2013-01-05','15:00:00',1.04),('8784','2013-01-04','09:55:00',1.03),('8784','2013-01-04','10:00:00',1.39),('8784','2013-01-04','10:05:00',1.43),('8784','2013-01-04','10:10:00',1.22),('8784','2013-01-04','10:15:00',1.47),('8784','2013-01-04','10:20:00',1.41),('8784','2013-01-04','10:25:00',1.55),('8784','2013-01-04','10:30:00',1.78),('8784','2013-01-04','10:35:00',1.85),('8784','2013-01-04','10:40:00',1.93),('8784','2013-01-04','10:45:00',2.06),('8784','2013-01-04','10:50:00',2.2),('8784','2013-01-04','10:55:00',2.35),('8784','2013-01-04','11:00:00',2.13),('8784','2013-01-04','11:05:00',1.48),('8784','2013-01-04','11:45:00',1.17),('8784','2013-01-04','11:50:00',1.91),('8784','2013-01-04','11:55:00',2.4),('8784','2013-01-04','12:00:00',2.62),('8784','2013-01-04','12:05:00',2.26),('8784','2013-01-04','12:10:00',1.81),('8784','2013-01-04','12:15:00',1.25),('8784','2013-01-04','12:25:00',1.01),('8784','2013-01-04','12:30:00',1.71),('8784','2013-01-04','12:35:00',1.42),('8784','2013-01-04','12:40:00',2.06),('8784','2013-01-04','12:45:00',2.05),('8784','2013-01-04','12:50:00',2.1),('8784','2013-01-04','12:55:00',2.07),('8784','2013-01-04','13:00:00',2),('8784','2013-01-04','13:05:00',1.88),('8784','2013-01-04','13:10:00',1.4),('8784','2013-01-04','13:15:00',1.65),('8784','2013-01-04','13:20:00',1.76),('8784','2013-01-04','13:25:00',1.71),('8784','2013-01-04','13:30:00',1.65),('8784','2013-01-04','13:35:00',1.65),('8784','2013-01-04','13:40:00',1.6),('8784','2013-01-04','13:45:00',1.58),('8784','2013-01-04','13:50:00',1.53),('8784','2013-01-04','13:55:00',1.5),('8784','2013-01-04','14:00:00',1.45),('8784','2013-01-04','14:05:00',1.37),('8784','2013-01-04','14:10:00',1.37),('8784','2013-01-04','14:15:00',1.33),('8784','2013-01-04','14:20:00',1.29),('8784','2013-01-04','14:25:00',1.28),('8784','2013-01-04','14:30:00',1.24),('8784','2013-01-04','14:50:00',1.02),('8784','2013-01-03','09:50:00',1.3),('8784','2013-01-03','09:55:00',1.49),('8784','2013-01-03','10:00:00',1.62),('8784','2013-01-03','10:05:00',1.7),('8784','2013-01-03','10:10:00',1.4),('8784','2013-01-03','10:15:00',1.89),('8784','2013-01-03','10:20:00',1.89),('8784','2013-01-03','10:25:00',2.11),('8784','2013-01-03','10:30:00',1.75),('8784','2013-01-03','10:35:00',1.76),('8784','2013-01-03','10:40:00',1.58),('8784','2013-01-03','10:45:00',1.49),('8784','2013-01-03','10:50:00',1.51),('8784','2013-01-03','10:55:00',1.42),('8784','2013-01-03','11:00:00',1.54),('8784','2013-01-03','11:05:00',1.49),('8784','2013-01-03','11:10:00',1.49),('8784','2013-01-03','11:15:00',1.33),('8784','2013-01-03','11:20:00',1.21),('8784','2013-01-03','11:40:00',2.13),('8784','2013-01-03','11:45:00',2.12),('8784','2013-01-03','11:50:00',2.07),('8784','2013-01-03','11:55:00',2.05),('8784','2013-01-03','12:00:00',2.04),('8784','2013-01-03','12:05:00',2.04),('8784','2013-01-03','12:10:00',2.06),('8784','2013-01-03','12:15:00',2.04),('8784','2013-01-03','12:20:00',2.02),('8784','2013-01-03','12:25:00',2.03),('8784','2013-01-03','12:30:00',2.03),('8784','2013-01-03','12:35:00',2.01),('8784','2013-01-03','12:40:00',1.93),('8784','2013-01-03','12:45:00',1.81),('8784','2013-01-03','12:50:00',1.94),('8784','2013-01-03','12:55:00',1.94),('8784','2013-01-03','13:00:00',1.89),('8784','2013-01-03','13:05:00',1.9),('8784','2013-01-03','13:10:00',1.88),('8784','2013-01-03','13:15:00',1.82),('8784','2013-01-03','13:20:00',1.81),('8784','2013-01-03','13:25:00',1.77),('8784','2013-01-03','13:30:00',1.72),('8784','2013-01-03','13:35:00',1.69),('8784','2013-01-03','13:40:00',1.67),('8784','2013-01-03','13:45:00',1.63),('8784','2013-01-03','13:50:00',1.58),('8784','2013-01-03','13:55:00',1.56),('8784','2013-01-03','14:00:00',1.49),('8784','2013-01-03','14:05:00',1.41),('8784','2013-01-03','14:10:00',1.41),('8784','2013-01-03','14:15:00',1.39),('8784','2013-01-03','14:20:00',1.35),('8784','2013-01-03','14:25:00',1.32),('8784','2013-01-03','14:30:00',1.28),('8784','2013-01-03','14:50:00',1.08),('8784','2013-01-03','14:55:00',1.03),('8784','2014-03-18','07:55:00',1.08),('8784','2014-03-18','08:15:00',1.01),('8784','2014-03-18','08:20:00',1.65),('8784','2014-03-18','08:25:00',1.09),('8784','2014-03-18','08:30:00',1.11),('8784','2014-03-18','08:50:00',2.01),('8784','2014-03-18','08:55:00',2.69),('8784','2014-03-18','09:00:00',2.24),('8784','2014-03-18','09:05:00',1.81),('8784','2014-03-18','09:10:00',1.73),('8784','2014-03-18','09:15:00',2.17),('8784','2014-03-18','09:20:00',2.31),('8784','2014-03-18','09:25:00',1.53),('8784','2014-03-18','09:30:00',2.49),('8784','2014-03-18','09:35:00',1.81),('8784','2014-03-18','09:40:00',1.42),('8784','2014-03-18','09:45:00',1.7),('8784','2014-03-18','09:50:00',2.04),('8784','2014-03-18','09:55:00',1.4),('8784','2014-03-18','10:00:00',2.62),('8784','2014-03-18','10:05:00',3.26),('8784','2014-03-18','10:10:00',3.47),('8784','2014-03-18','10:15:00',3.3),('8784','2014-03-18','10:20:00',3.26),('8784','2014-03-18','10:25:00',2.27),('8784','2014-03-18','10:30:00',3.19),('8784','2014-03-18','10:35:00',3.49),('8784','2014-03-18','10:40:00',2.27),('8784','2014-03-18','10:45:00',3.26),('8784','2014-03-18','10:50:00',4.42),('8784','2014-03-18','10:55:00',3.4),('8784','2014-03-18','11:00:00',2.08),('8784','2014-03-18','11:05:00',2.25),('8784','2014-03-18','11:10:00',1.52),('8784','2014-03-18','11:15:00',2.9),('8784','2014-03-18','11:20:00',3.65),('8784','2014-03-18','11:25:00',3.62),('8784','2014-03-18','11:30:00',2.68),('8784','2014-03-18','11:35:00',4.45),('8784','2014-03-18','11:40:00',2.49),('8784','2014-03-18','11:45:00',3.41),('8784','2014-03-18','11:50:00',2.23),('8784','2014-03-18','11:55:00',1.82),('8784','2014-03-18','12:00:00',2.12),('8784','2014-03-18','12:05:00',3.76),('8784','2014-03-18','12:10:00',3.06),('8784','2014-03-18','12:15:00',2.52),('8784','2014-03-18','12:20:00',1.53),('8784','2014-03-18','12:25:00',1.25),('8784','2014-03-18','12:30:00',1.95),('8784','2014-03-18','12:35:00',2.05),('8784','2014-03-18','12:40:00',1.76),('8784','2014-03-18','12:45:00',4.23),('8784','2014-03-18','12:50:00',2.74),('8784','2014-03-18','12:55:00',3.91),('8784','2014-03-18','13:00:00',3.86),('8784','2014-03-18','13:05:00',3.82),('8784','2014-03-18','13:10:00',3.75),('8784','2014-03-18','13:15:00',3.71),('8784','2014-03-18','13:20:00',3.57),('8784','2014-03-18','13:25:00',2.92),('8784','2014-03-18','13:30:00',3.55),('8784','2014-03-18','13:35:00',3.5),('8784','2014-03-18','13:40:00',3.5),('8784','2014-03-18','13:45:00',3.43),('8784','2014-03-18','13:50:00',3.39),('8784','2014-03-18','13:55:00',3.44),('8784','2014-03-18','14:00:00',3.31),('8784','2014-03-18','14:05:00',3.32),('8784','2014-03-18','14:10:00',3.28),('8784','2014-03-18','14:15:00',3.22),('8784','2014-03-18','14:20:00',3.17),('8784','2014-03-18','14:25:00',3.11),('8784','2014-03-18','14:30:00',3.07),('8784','2014-03-18','14:35:00',3),('8784','2014-03-18','14:40:00',2.92),('8784','2014-03-18','14:45:00',2.86),('8784','2014-03-18','14:50:00',2.83),('8784','2014-03-18','14:55:00',2.75),('8784','2014-03-18','15:00:00',2.65),('8784','2014-03-18','15:05:00',2.61),('8784','2014-03-18','15:10:00',2.55),('8784','2014-03-18','15:15:00',2.49),('8784','2014-03-18','15:20:00',2.4),('8784','2014-03-18','15:25:00',2.31),('8784','2014-03-18','15:30:00',2.24),('8784','2014-03-18','15:35:00',2.17),('8784','2014-03-18','15:40:00',2.07),('8784','2014-03-18','15:45:00',1.99),('8784','2014-03-18','15:50:00',1.9),('8784','2014-03-18','15:55:00',1.84),('8784','2014-03-18','16:00:00',1.76),('8784','2014-03-18','16:05:00',1.68),('8784','2014-03-18','16:10:00',1.59),('8784','2014-03-18','16:15:00',1.5),('8784','2014-03-18','16:20:00',1.4),('8784','2014-03-18','16:25:00',1.34),('8784','2014-03-18','16:30:00',1.27),('8784','2014-03-18','16:35:00',1.17),('8784','2014-03-18','16:40:00',1.09),('8784','2013-01-01','09:50:00',1.03),('8784','2013-01-01','09:55:00',1.15),('8784','2013-01-01','10:00:00',1.2),('8784','2013-01-01','10:05:00',1.22),('8784','2013-01-01','10:10:00',1.28),('8784','2013-01-01','10:15:00',1.39),('8784','2013-01-01','10:20:00',1.52),('8784','2013-01-01','10:25:00',1.59),('8784','2013-01-01','10:30:00',1.65),('8784','2013-01-01','10:35:00',1.69),('8784','2013-01-01','10:40:00',1.78),('8784','2013-01-01','10:45:00',1.96),('8784','2013-01-01','10:50:00',1.91),('8784','2013-01-01','10:55:00',1.18),('8784','2013-01-01','11:05:00',1.87),('8784','2013-01-01','11:10:00',1.85),('8784','2013-01-01','11:15:00',1.48),('8784','2013-01-01','11:20:00',1.28),('8784','2013-01-01','11:25:00',1.78),('8784','2013-01-01','11:30:00',2.31),('8784','2013-01-01','11:35:00',1.35),('8784','2013-01-01','11:40:00',1.62),('8784','2013-01-01','11:45:00',1.84),('8784','2013-01-01','11:50:00',1.57),('8784','2013-01-01','11:55:00',1.31),('8784','2013-01-01','12:00:00',1.3),('8784','2013-01-01','12:05:00',1.12),('8784','2013-01-01','12:10:00',1.29),('8784','2013-01-01','12:15:00',1.18),('8784','2013-01-01','12:20:00',1.28),('8784','2013-01-01','12:25:00',1.18),('8784','2013-01-01','12:30:00',1.04),('8784','2013-01-01','12:40:00',1.14),('8784','2013-01-01','12:45:00',1.35),('8784','2013-01-01','12:50:00',1.3),('8784','2013-01-01','12:55:00',1.19),('8784','2013-01-01','13:00:00',1.05),('8784','2013-01-01','13:05:00',1.01),('8784','2012-12-31','10:10:00',1.22),('8784','2012-12-31','10:15:00',1.54),('8784','2012-12-31','10:20:00',1.68),('8784','2012-12-31','10:25:00',1.75),('8784','2012-12-31','10:30:00',1.79),('8784','2012-12-31','10:35:00',1.81),('8784','2012-12-31','10:40:00',1.85),('8784','2012-12-31','10:45:00',1.83),('8784','2012-12-31','10:50:00',1.83),('8784','2012-12-31','10:55:00',1.91),('8784','2012-12-31','11:00:00',1.96),('8784','2012-12-31','11:05:00',1.96),('8784','2012-12-31','11:10:00',1.94),('8784','2012-12-31','11:15:00',1.92),('8784','2012-12-31','11:20:00',2.01),('8784','2012-12-31','11:25:00',2.04),('8784','2012-12-31','11:30:00',1.98),('8784','2012-12-31','11:35:00',2.02),('8784','2012-12-31','11:40:00',2.04),('8784','2012-12-31','11:45:00',2.05),('8784','2012-12-31','11:50:00',2.07),('8784','2012-12-31','11:55:00',2.07),('8784','2012-12-31','12:00:00',2.09),('8784','2012-12-31','12:05:00',2.1),('8784','2012-12-31','12:10:00',2.12),('8784','2012-12-31','12:15:00',2.1),('8784','2012-12-31','12:20:00',2.11),('8784','2012-12-31','12:25:00',2.11),('8784','2012-12-31','12:30:00',2.08),('8784','2012-12-31','12:35:00',2.06),('8784','2012-12-31','12:40:00',1.85),('8784','2012-12-31','12:45:00',1.9),('8784','2012-12-31','12:50:00',1.97),('8784','2012-12-31','12:55:00',1.96),('8784','2012-12-31','13:00:00',1.93),('8784','2012-12-31','13:05:00',1.9),('8784','2012-12-31','13:10:00',1.91),('8784','2012-12-31','13:15:00',1.85),('8784','2012-12-31','13:20:00',1.83),('8784','2012-12-31','13:25:00',1.79),('8784','2012-12-31','13:30:00',1.76),('8784','2012-12-31','13:35:00',1.72),('8784','2012-12-31','13:40:00',1.67),('8784','2012-12-31','13:45:00',1.63),('8784','2012-12-31','13:50:00',1.6),('8784','2012-12-31','13:55:00',1.56),('8784','2012-12-31','14:00:00',1.5),('8784','2012-12-31','14:05:00',1.47),('8784','2012-12-31','14:10:00',1.43),('8784','2012-12-31','14:15:00',1.4),('8784','2012-12-31','14:20:00',1.29),('8784','2012-12-31','14:25:00',1.29),('8784','2012-12-31','14:30:00',1.19),('8784','2012-12-31','14:35:00',1.1),('8784','2012-12-31','14:40:00',1.17),('8784','2012-12-31','14:45:00',1.12),('8784','2012-12-31','14:50:00',1.07),('8784','2012-12-31','14:55:00',1.01),('8784','2012-12-30','09:50:00',1.06),('8784','2012-12-30','09:55:00',1.17),('8784','2012-12-30','10:00:00',1.22),('8784','2012-12-30','10:05:00',1.22),('8784','2012-12-30','10:10:00',1.32),('8784','2012-12-30','10:15:00',1.45),('8784','2012-12-30','10:20:00',1.6),('8784','2012-12-30','10:25:00',1.66),('8784','2012-12-30','10:30:00',1.72),('8784','2012-12-30','10:35:00',1.76),('8784','2012-12-30','10:40:00',1.8),('8784','2012-12-30','10:45:00',1.8),('8784','2012-12-30','10:50:00',1.83),('8784','2012-12-30','10:55:00',1.89),('8784','2012-12-30','11:00:00',1.95),('8784','2012-12-30','11:05:00',2.02),('8784','2012-12-30','11:10:00',1.99),('8784','2012-12-30','11:15:00',1.89),('8784','2012-12-30','11:20:00',1.99),('8784','2012-12-30','11:25:00',1.99),('8784','2012-12-30','11:30:00',1.99),('8784','2012-12-30','11:35:00',2),('8784','2012-12-30','11:40:00',2),('8784','2012-12-30','11:45:00',2.02),('8784','2012-12-30','11:50:00',2.03),('8784','2012-12-30','11:55:00',2.06),('8784','2012-12-30','12:00:00',2.06),('8784','2012-12-30','12:05:00',2.07),('8784','2012-12-30','12:10:00',2.06),('8784','2012-12-30','12:15:00',2.06),('8784','2012-12-30','12:20:00',2.05),('8784','2012-12-30','12:25:00',2.04),('8784','2012-12-30','12:30:00',2),('8784','2012-12-30','12:35:00',2),('8784','2012-12-30','12:40:00',1.74),('8784','2012-12-30','12:45:00',1.9),('8784','2012-12-30','12:50:00',1.88),('8784','2012-12-30','12:55:00',1.78),('8784','2012-12-30','13:00:00',1.86),('8784','2012-12-30','13:05:00',1.91),('8784','2012-12-30','13:10:00',1.87),('8784','2012-12-30','13:15:00',1.84),('8784','2012-12-30','13:20:00',1.81),('8784','2012-12-30','13:25:00',1.79),('8784','2012-12-30','13:30:00',1.74),('8784','2012-12-30','13:35:00',1.72),('8784','2012-12-30','13:40:00',1.63),('8784','2012-12-30','13:45:00',1.63),('8784','2012-12-30','13:50:00',1.62),('8784','2012-12-30','13:55:00',1.57),('8784','2012-12-30','14:00:00',1.52),('8784','2012-12-30','14:05:00',1.48),('8784','2012-12-30','14:10:00',1.43),('8784','2012-12-30','14:15:00',1.4),('8784','2012-12-30','14:20:00',1.33),('8784','2012-12-30','14:25:00',1.29),('8784','2012-12-30','14:30:00',1.24),('8784','2012-12-30','14:35:00',1.18),('8784','2012-12-30','14:40:00',1.15),('8784','2012-12-30','14:45:00',1.09),('8784','2012-12-30','14:50:00',1.04),('8784','2012-12-29','09:50:00',1.06),('8784','2012-12-29','09:55:00',1.18),('8784','2012-12-29','10:00:00',1.24),('8784','2012-12-29','10:05:00',1.29),('8784','2012-12-29','10:10:00',1.36),('8784','2012-12-29','10:15:00',1.46),('8784','2012-12-29','10:20:00',1.61),('8784','2012-12-29','10:25:00',1.67),('8784','2012-12-29','10:30:00',1.73),('8784','2012-12-29','10:35:00',1.76),('8784','2012-12-29','10:40:00',1.8),('8784','2012-12-29','10:45:00',1.86),('8784','2012-12-29','10:50:00',1.91),('8784','2012-12-29','10:55:00',1.94),('8784','2012-12-29','11:00:00',1.97),('8784','2012-12-29','11:05:00',2.03),('8784','2012-12-29','11:10:00',2),('8784','2012-12-29','11:15:00',1.98),('8784','2012-12-29','11:20:00',1.98),('8784','2012-12-29','11:25:00',2),('8784','2012-12-29','11:30:00',1.99),('8784','2012-12-29','11:35:00',2.03),('8784','2012-12-29','11:40:00',2.02),('8784','2012-12-29','11:45:00',2.03),('8784','2012-12-29','11:50:00',2.06),('8784','2012-12-29','11:55:00',2.06),('8784','2012-12-29','12:00:00',2.08),('8784','2012-12-29','12:05:00',2.11),('8784','2012-12-29','12:10:00',2.11),('8784','2012-12-29','12:15:00',2.1),('8784','2012-12-29','12:20:00',2.06),('8784','2012-12-29','12:25:00',2.05),('8784','2012-12-29','12:30:00',2.03),('8784','2012-12-29','12:35:00',2.01),('8784','2012-12-29','12:40:00',1.81),('8784','2012-12-29','12:45:00',1.98),('8784','2012-12-29','12:50:00',1.88),('8784','2012-12-29','12:55:00',1.82),('8784','2012-12-29','13:00:00',1.94),('8784','2012-12-29','13:05:00',1.91),('8784','2012-12-29','13:10:00',1.88),('8784','2012-12-29','13:15:00',1.87),('8784','2012-12-29','13:20:00',1.84),('8784','2012-12-29','13:25:00',1.8),('8784','2012-12-29','13:30:00',1.75),('8784','2012-12-29','13:35:00',1.72),('8784','2012-12-29','13:40:00',1.67),('8784','2012-12-29','13:45:00',1.63),('8784','2012-12-29','13:50:00',1.62),('8784','2012-12-29','13:55:00',1.57),('8784','2012-12-29','14:00:00',1.52),('8784','2012-12-29','14:05:00',1.48),('8784','2012-12-29','14:10:00',1.42),('8784','2012-12-29','14:15:00',1.41),('8784','2012-12-29','14:20:00',1.35),('8784','2012-12-29','14:25:00',1.32),('8784','2012-12-29','14:30:00',1.22),('8784','2012-12-29','14:35:00',1.18),('8784','2012-12-29','14:40:00',1.17),('8784','2012-12-29','14:45:00',1.12),('8784','2012-12-29','14:50:00',1.06),('8784','2012-12-29','14:55:00',1.01),('8784','2012-12-28','09:55:00',1.05),('8784','2012-12-28','10:00:00',1.12),('8784','2012-12-28','10:05:00',1.16),('8784','2012-12-28','10:10:00',1.2),('8784','2012-12-28','10:15:00',1.34),('8784','2012-12-28','10:20:00',1.51),('8784','2012-12-28','10:25:00',1.57),('8784','2012-12-28','10:30:00',1.58),('8784','2012-12-28','10:35:00',1.68),('8784','2012-12-28','10:40:00',1.7),('8784','2012-12-28','10:45:00',1.75),('8784','2012-12-28','10:50:00',1.79),('8784','2012-12-28','10:55:00',1.8),('8784','2012-12-28','11:00:00',1.86),('8784','2012-12-28','11:05:00',1.95),('8784','2012-12-28','11:10:00',1.86),('8784','2012-12-28','11:15:00',1.85),('8784','2012-12-28','11:20:00',1.91),('8784','2012-12-28','11:25:00',1.94),('8784','2012-12-28','11:30:00',1.93),('8784','2012-12-28','11:35:00',1.98),('8784','2012-12-28','11:40:00',1.97),('8784','2012-12-28','11:45:00',2.02),('8784','2012-12-28','11:50:00',1.75),('8784','2012-12-28','11:55:00',1.98),('8784','2012-12-28','12:00:00',1.99),('8784','2012-12-28','12:05:00',2.02),('8784','2012-12-28','12:10:00',2.02),('8784','2012-12-28','12:15:00',2),('8784','2012-12-28','12:20:00',1.99),('8784','2012-12-28','12:25:00',1.98),('8784','2012-12-28','12:30:00',1.98),('8784','2012-12-28','12:35:00',1.94),('8784','2012-12-28','12:40:00',1.68),('8784','2012-12-28','12:45:00',1.83),('8784','2012-12-28','12:50:00',1.8),('8784','2012-12-28','12:55:00',1.63),('8784','2012-12-28','13:00:00',1.85),('8784','2012-12-28','13:05:00',1.82),('8784','2012-12-28','13:10:00',1.79),('8784','2012-12-28','13:15:00',1.77),('8784','2012-12-28','13:20:00',1.7),('8784','2012-12-28','13:25:00',1.71),('8784','2012-12-28','13:30:00',1.68),('8784','2012-12-28','13:35:00',1.65),('8784','2012-12-28','13:40:00',1.56),('8784','2012-12-28','13:45:00',1.53),('8784','2012-12-28','13:50:00',1.52),('8784','2012-12-28','13:55:00',1.43),('8784','2012-12-28','14:00:00',1.35),('8784','2012-12-28','14:05:00',1.32),('8784','2012-12-28','14:10:00',1.27),('8784','2012-12-28','14:15:00',1.28),('8784','2012-12-28','14:20:00',1.22),('8784','2012-12-28','14:25:00',1.19),('8784','2012-12-27','09:50:00',1.23),('8784','2012-12-27','10:15:00',1.19),('8784','2012-12-27','10:20:00',1.44),('8784','2012-12-27','10:25:00',1.44),('8784','2012-12-27','10:30:00',1.45),('8784','2012-12-27','10:35:00',1.6),('8784','2012-12-27','10:40:00',1.6),('8784','2012-12-27','10:45:00',1.71),('8784','2012-12-27','10:50:00',1.73),('8784','2012-12-27','10:55:00',1.51),('8784','2012-12-27','11:00:00',1.74),('8784','2012-12-27','11:05:00',1.76),('8784','2012-12-27','11:10:00',1.64),('8784','2012-12-27','11:50:00',1.65),('8784','2012-12-27','11:55:00',1.96),('8784','2012-12-27','12:00:00',1.99),('8784','2012-12-27','12:05:00',2.17),('8784','2012-12-27','12:10:00',2.26),('8784','2012-12-27','12:20:00',1.53),('8784','2012-12-27','12:25:00',1.85),('8784','2012-12-27','12:30:00',1.92),('8784','2012-12-27','12:35:00',1.89),('8784','2012-12-27','12:40:00',1.94),('8784','2012-12-27','12:45:00',2.2),('8784','2012-12-27','12:50:00',1.78),('8784','2012-12-27','12:55:00',1.92),('8784','2012-12-27','13:00:00',1.87),('8784','2012-12-27','13:05:00',1.96),('8784','2012-12-27','13:10:00',1.96),('8784','2012-12-27','13:15:00',2.05),('8784','2012-12-27','13:20:00',1.95),('8784','2012-12-27','13:25:00',1.93),('8784','2012-12-27','13:30:00',1.75),('8784','2012-12-27','14:00:00',1.35),('8784','2012-12-27','14:05:00',1.63),('8784','2012-12-27','14:10:00',1.69),('8784','2012-12-27','14:15:00',1.36),('8784','2012-12-27','14:20:00',1.27),('8784','2012-12-27','14:25:00',1.22),('8784','2012-12-27','14:35:00',1.07),('8784','2012-12-27','14:40:00',1.09),('8784','2012-12-26','09:50:00',1.02),('8784','2012-12-26','09:55:00',1.1),('8784','2012-12-26','10:00:00',1.16),('8784','2012-12-26','10:05:00',1.19),('8784','2012-12-26','10:10:00',1.28),('8784','2012-12-26','10:15:00',1.39),('8784','2012-12-26','10:20:00',1.49),('8784','2012-12-26','10:25:00',1.53),('8784','2012-12-26','10:30:00',1.57),('8784','2012-12-26','10:35:00',1.58),('8784','2012-12-26','10:40:00',1.66),('8784','2012-12-26','10:45:00',1.7),('8784','2012-12-26','10:50:00',1.72),('8784','2012-12-26','10:55:00',1.75),('8784','2012-12-26','11:00:00',1.82),('8784','2012-12-26','11:05:00',1.87),('8784','2012-12-26','11:10:00',1.8),('8784','2012-12-26','11:15:00',1.75),('8784','2012-12-26','11:20:00',1.78),('8784','2012-12-26','11:25:00',1.85),('8784','2012-12-26','11:30:00',1.81),('8784','2012-12-26','11:35:00',1.86),('8784','2012-12-26','11:40:00',1.9),('8784','2012-12-26','11:45:00',1.91),('8784','2012-12-26','11:50:00',1.95),('8784','2012-12-26','11:55:00',1.97),('8784','2012-12-26','12:00:00',1.98),('8784','2012-12-26','12:05:00',2.04),('8784','2012-12-26','12:10:00',2.01),('8784','2012-12-26','12:15:00',2.01),('8784','2012-12-26','12:20:00',2.01),('8784','2012-12-26','12:25:00',2.02),('8784','2012-12-26','12:30:00',1.99),('8784','2012-12-26','12:35:00',1.95),('8784','2012-12-26','12:40:00',1.95),('8784','2012-12-26','12:45:00',1.91),('8784','2012-12-26','12:50:00',1.77),('8784','2012-12-26','12:55:00',1.62),('8784','2012-12-26','13:00:00',1.93),('8784','2012-12-26','13:05:00',1.36),('8784','2012-12-26','13:10:00',1.95),('8784','2012-12-26','13:15:00',1.86),('8784','2012-12-26','13:20:00',2.02),('8784','2012-12-26','13:25:00',1.97),('8784','2012-12-26','13:30:00',2.22),('8784','2012-12-26','13:35:00',2.17),('8784','2012-12-26','13:40:00',2.06),('8784','2012-12-26','13:45:00',2.16),('8784','2012-12-26','13:50:00',1.98),('8784','2012-12-26','13:55:00',1.92),('8784','2012-12-26','14:00:00',1.8),('8784','2012-12-26','14:05:00',1.87),('8784','2012-12-26','14:10:00',1.13),('8784','2012-12-23','09:50:00',1.08),('8784','2012-12-23','09:55:00',1.17),('8784','2012-12-23','10:00:00',1.21),('8784','2012-12-23','10:05:00',1.19),('8784','2012-12-23','10:10:00',1.34),('8784','2012-12-23','10:15:00',1.49),('8784','2012-12-23','10:20:00',1.57),('8784','2012-12-23','10:25:00',1.56),('8784','2012-12-23','10:30:00',1.57),('8784','2012-12-23','10:35:00',1.61),('8784','2012-12-23','10:40:00',1.69),('8784','2012-12-23','10:45:00',1.76),('8784','2012-12-23','10:50:00',1.78),('8784','2012-12-23','10:55:00',1.72),('8784','2012-12-23','11:00:00',1.88),('8784','2012-12-23','11:05:00',1.91),('8784','2012-12-23','11:10:00',1.81),('8784','2012-12-23','11:15:00',1.85),('8784','2012-12-23','11:20:00',1.87),('8784','2012-12-23','11:25:00',1.72),('8784','2012-12-23','11:30:00',1.86),('8784','2012-12-23','11:35:00',1.97),('8784','2012-12-23','11:40:00',1.99),('8784','2012-12-23','11:45:00',1.97),('8784','2012-12-23','11:50:00',2.02),('8784','2012-12-23','11:55:00',1.9),('8784','2012-12-23','12:00:00',1.84),('8784','2012-12-23','12:05:00',1.87),('8784','2012-12-23','12:10:00',1.88),('8784','2012-12-23','12:15:00',1.48),('8784','2012-12-23','12:20:00',1.49),('8784','2012-12-23','12:30:00',1.08),('8784','2012-12-23','12:35:00',1.12),('8784','2012-12-23','12:40:00',1.31),('8784','2012-12-23','12:50:00',1.28),('8784','2012-12-23','12:55:00',1.68),('8784','2012-12-23','13:00:00',1.98),('8784','2012-12-23','13:05:00',1.69),('8784','2012-12-23','13:10:00',1.83),('8784','2012-12-23','13:15:00',1.37),('8784','2012-12-23','13:20:00',1.25),('8784','2012-12-23','13:25:00',1.11),('8784','2012-12-23','13:35:00',1.05),('8784','2012-12-23','13:40:00',1.27),('8784','2012-12-23','13:45:00',1.29),('8784','2012-12-23','13:50:00',1.22),('8784','2012-12-23','13:55:00',1.14),('8784','2012-12-23','14:00:00',1.54),('8784','2012-12-23','14:05:00',1.37),('8784','2012-12-23','14:10:00',1.26),('8784','2012-12-23','14:15:00',1.29),('8784','2012-12-23','14:20:00',1.02),('8784','2012-12-23','14:45:00',1.03),('8784','2014-05-01','07:50:00',1.38),('8784','2014-05-01','07:55:00',1.48),('8784','2014-05-01','08:00:00',1.63),('8784','2014-05-01','08:05:00',1.61),('8784','2014-05-01','08:10:00',1.66),('8784','2014-05-01','08:15:00',1.76),('8784','2014-05-01','08:20:00',1.85),('8784','2014-05-01','08:25:00',1.97),('8784','2014-05-01','08:30:00',2.05),('8784','2014-05-01','08:35:00',2.17),('8784','2014-05-01','08:40:00',2.25),('8784','2014-05-01','08:45:00',2.37),('8784','2014-05-01','08:50:00',2.56),('8784','2014-05-01','08:55:00',2.9),('8784','2014-05-01','09:00:00',1.72),('8784','2014-05-01','09:05:00',1.28),('8784','2014-05-01','09:10:00',2.21),('8784','2014-05-01','09:15:00',2.66),('8784','2014-05-01','09:20:00',2.02),('8784','2014-05-01','09:25:00',3.13),('8784','2014-05-01','09:30:00',3.23),('8784','2014-05-01','09:35:00',3.29),('8784','2014-05-01','09:40:00',3.61),('8784','2014-05-01','09:45:00',2.31),('8784','2014-05-01','09:50:00',2.58),('8784','2014-05-01','09:55:00',2.17),('8784','2014-05-01','10:00:00',2.19),('8784','2014-05-01','10:05:00',1.81),('8784','2014-05-01','10:10:00',3.14),('8784','2014-05-01','10:15:00',2.9),('8784','2014-05-01','10:20:00',1.86),('8784','2014-05-01','10:25:00',1.37),('8784','2014-05-01','10:30:00',2.96),('8784','2014-05-01','10:35:00',3.97),('8784','2014-05-01','10:40:00',2.11),('8784','2014-05-01','10:45:00',3.22),('8784','2014-05-01','10:50:00',4.35),('8784','2014-05-01','10:55:00',3.97),('8784','2014-05-01','11:00:00',3.57),('8784','2014-05-01','11:05:00',4.43),('8784','2014-05-01','11:10:00',3.74),('8784','2014-05-01','11:20:00',1.37),('8784','2014-05-01','11:25:00',4.89),('8784','2014-05-01','11:30:00',4.74),('8784','2014-05-01','11:35:00',4.71),('8784','2014-05-01','11:40:00',1.65),('8784','2014-05-01','11:45:00',2.83),('8784','2014-05-01','11:50:00',5.07),('8784','2014-05-01','11:55:00',2.89),('8784','2014-05-01','12:00:00',1.03),('8784','2014-05-01','12:05:00',4.46),('8784','2014-05-01','12:10:00',4.04),('8784','2014-05-01','12:15:00',3.79),('8784','2014-05-01','12:20:00',3.62),('8784','2014-05-01','12:25:00',4.9),('8784','2014-05-01','12:30:00',3.75),('8784','2014-05-01','12:35:00',4.84),('8784','2014-05-01','12:40:00',5),('8784','2014-05-01','12:45:00',2.92),('8784','2014-05-01','12:50:00',3.69),('8784','2014-05-01','12:55:00',5.12),('8784','2014-05-01','13:00:00',5.15),('8784','2014-05-01','13:05:00',4.91),('8784','2014-05-01','13:10:00',4.89),('8784','2014-05-01','13:15:00',4.22),('8784','2014-05-01','13:20:00',4.95),('8784','2014-05-01','13:25:00',1.81),('8784','2014-05-01','13:30:00',2.28),('8784','2014-05-01','13:35:00',2.85),('8784','2014-05-01','13:40:00',5.1),('8784','2014-05-01','13:45:00',5.08),('8784','2014-05-01','13:50:00',5.29),('8784','2014-05-01','13:55:00',5.06),('8784','2014-05-01','14:00:00',4.7),('8784','2014-05-01','14:05:00',4.78),('8784','2014-05-01','14:10:00',4.67),('8784','2014-05-01','14:15:00',4.58),('8784','2014-05-01','14:20:00',4.49),('8784','2014-05-01','14:25:00',4.51),('8784','2014-05-01','14:30:00',4.29),('8784','2014-05-01','14:35:00',4.26),('8784','2014-05-01','14:40:00',4.59),('8784','2014-05-01','14:45:00',4.58),('8784','2014-05-01','14:50:00',4.53),('8784','2014-05-01','14:55:00',4.1),('8784','2014-05-01','15:00:00',4.47),('8784','2014-05-01','15:05:00',4.48),('8784','2014-05-01','15:10:00',3.84),('8784','2014-05-01','15:15:00',4.02),('8784','2014-05-01','15:20:00',4.07),('8784','2014-05-01','15:25:00',4.01),('8784','2014-05-01','15:30:00',3.9),('8784','2014-05-01','15:35:00',3.82),('8784','2014-05-01','15:40:00',3.75),('8784','2014-05-01','15:45:00',3.58),('8784','2014-05-01','15:50:00',3.69),('8784','2014-05-01','15:55:00',3.55),('8784','2014-05-01','16:00:00',3.55),('8784','2014-05-01','16:05:00',3.53),('8784','2014-05-01','16:10:00',3.36),('8784','2014-05-01','16:15:00',3.28),('8784','2014-05-01','16:20:00',3.16),('8784','2014-05-01','16:25:00',2.89),('8784','2014-05-01','16:30:00',3.03),('8784','2014-05-01','16:35:00',3.04),('8784','2014-05-01','16:40:00',2.88),('8784','2014-05-01','16:45:00',2.41),('8784','2014-05-01','16:50:00',2.21),('8784','2014-05-01','16:55:00',2.44),('8784','2014-05-01','17:00:00',2.46),('8784','2014-05-01','17:05:00',2.35),('8784','2014-05-01','17:10:00',2.53),('8784','2014-05-01','17:15:00',2.38),('8784','2014-05-01','17:20:00',2.28),('8784','2014-05-01','17:25:00',2.19),('8784','2014-05-01','17:30:00',2.09),('8784','2014-05-01','17:35:00',2),('8784','2014-05-01','17:40:00',1.91),('8784','2014-05-01','17:45:00',1.83),('8784','2014-05-01','17:50:00',1.74),('8784','2014-05-01','17:55:00',1.67),('8784','2014-05-01','18:00:00',1.66),('8784','2014-05-01','18:05:00',1.51),('8784','2014-05-01','18:10:00',1.32),('8784','2014-05-01','18:15:00',1.28),('8784','2014-05-01','18:20:00',1.2),('8784','2014-05-01','18:25:00',1.12),('8784','2014-05-01','18:30:00',1.04),('8784','2014-03-17','09:10:00',1.05),('8784','2014-03-17','09:15:00',1.24),('8784','2014-03-17','09:20:00',1.27),('8784','2014-03-17','09:25:00',1.52),('8784','2014-03-17','09:30:00',1.72),('8784','2014-03-17','09:35:00',1.47),('8784','2014-03-17','09:40:00',1.29),('8784','2014-03-17','09:45:00',1.31),('8784','2014-03-17','09:50:00',2.24),('8784','2014-03-17','09:55:00',1.91),('8784','2014-03-17','10:00:00',2),('8784','2014-03-17','10:05:00',1.78),('8784','2014-03-17','10:10:00',1.72),('8784','2014-03-17','10:15:00',1.81),('8784','2014-03-17','10:20:00',2.16),('8784','2014-03-17','10:25:00',1.79),('8784','2014-03-17','10:30:00',1.5),('8784','2014-03-17','10:35:00',1.4),('8784','2014-03-17','10:40:00',1.52),('8784','2014-03-17','10:45:00',1.93),('8784','2014-03-17','10:50:00',1.55),('8784','2014-03-17','10:55:00',1.5),('8784','2014-03-17','11:00:00',1.59),('8784','2014-03-17','11:05:00',1.46),('8784','2014-03-17','11:10:00',1.99),('8784','2014-03-17','11:15:00',1.66),('8784','2014-03-17','11:20:00',1.42),('8784','2014-03-17','11:25:00',1.86),('8784','2014-03-17','11:30:00',1.56),('8784','2014-03-17','11:35:00',1.47),('8784','2014-03-17','11:40:00',1.31),('8784','2014-03-17','11:45:00',1.61),('8784','2014-03-17','11:50:00',1.78),('8784','2014-03-17','11:55:00',1.83),('8784','2014-03-17','12:00:00',2.18),('8784','2014-03-17','12:05:00',2.13),('8784','2014-03-17','12:10:00',1.56),('8784','2014-03-17','12:15:00',1.76),('8784','2014-03-17','12:20:00',3.43),('8784','2014-03-17','12:25:00',1.74),('8784','2014-03-17','12:30:00',1.72),('8784','2014-03-17','12:35:00',2.02),('8784','2014-03-17','12:40:00',2.93),('8784','2014-03-17','12:45:00',2.44),('8784','2014-03-17','12:50:00',4.01),('8784','2014-03-17','12:55:00',3.67),('8784','2014-03-17','13:00:00',2.34),('8784','2014-03-17','13:05:00',1.99),('8784','2014-03-17','13:10:00',3.46),('8784','2014-03-17','13:15:00',3.71),('8784','2014-03-17','13:20:00',3.63),('8784','2014-03-17','13:25:00',3.21),('8784','2014-03-17','13:30:00',3.53),('8784','2014-03-17','13:35:00',3.49),('8784','2014-03-17','13:40:00',3.66),('8784','2014-03-17','13:45:00',2.26),('8784','2014-03-17','13:50:00',3.59),('8784','2014-03-17','13:55:00',1.99),('8784','2014-03-17','14:00:00',2.62),('8784','2014-03-17','14:05:00',2.85),('8784','2014-03-17','14:10:00',1.14),('8784','2014-03-17','14:15:00',2.73),('8784','2014-03-17','14:20:00',1.92),('8784','2014-03-17','14:25:00',2.78),('8784','2014-03-17','14:30:00',1.83),('8784','2014-03-17','14:35:00',1.99),('8784','2014-03-17','14:40:00',2.82),('8784','2014-03-17','14:45:00',2.7),('8784','2014-03-17','14:50:00',3.01),('8784','2014-03-17','14:55:00',2.79),('8784','2014-03-17','15:00:00',2.83),('8784','2014-03-17','15:05:00',2.6),('8784','2014-03-17','15:10:00',2.36),('8784','2014-03-17','15:15:00',1.55),('8784','2014-03-17','15:20:00',2.06),('8784','2014-03-17','15:25:00',2.29),('8784','2014-03-17','15:30:00',2.15),('8784','2014-03-17','15:35:00',1.94),('8784','2014-03-17','15:40:00',1.92),('8784','2014-03-17','15:45:00',1.68),('8784','2014-03-17','15:50:00',1.59),('8784','2014-03-17','15:55:00',1.75),('8784','2014-03-17','16:00:00',1.67),('8784','2014-03-17','16:05:00',1.32),('8784','2014-03-17','16:15:00',1.01),('8784','2014-03-17','16:20:00',1.47),('8784','2014-03-17','16:25:00',1.41),('8784','2014-03-17','16:30:00',1.24),('8784','2014-03-17','16:35:00',1.28),('8784','2014-03-17','16:40:00',1.11),('8784','2014-03-17','16:45:00',1.06),('8784','2012-12-22','10:25:00',1.14),('8784','2012-12-22','10:30:00',1.6),('8784','2012-12-22','10:35:00',2.25),('8784','2012-12-22','10:40:00',2.17),('8784','2012-12-22','10:45:00',2.15),('8784','2012-12-22','10:50:00',2.07),('8784','2012-12-22','10:55:00',1.54),('8784','2012-12-22','11:35:00',1.19),('8784','2012-12-22','11:40:00',2.11),('8784','2012-12-22','11:45:00',2.27),('8784','2012-12-22','11:50:00',1.92),('8784','2012-12-22','11:55:00',1.5),('8784','2012-12-22','12:00:00',1.72),('8784','2012-12-22','12:30:00',1.05),('8784','2012-12-22','12:40:00',1.64),('8784','2012-12-22','12:45:00',2.53),('8784','2012-12-22','12:50:00',2.26),('8784','2012-12-22','12:55:00',2.03),('8784','2012-12-22','13:00:00',2.3),('8784','2012-12-22','13:05:00',1.96),('8784','2012-12-22','13:10:00',2.43),('8784','2012-12-22','13:15:00',2.53),('8784','2012-12-22','13:20:00',2.52),('8784','2012-12-22','13:25:00',2.44),('8784','2012-12-22','13:30:00',2.2),('8784','2012-12-22','13:35:00',2.23),('8784','2012-12-22','13:40:00',1.27),('8784','2012-12-22','13:50:00',1),('8784','2012-12-22','14:00:00',1.02),('8784','2012-12-22','14:10:00',1.2),('8784','2012-12-22','14:15:00',1),('8784','2014-03-16','07:55:00',1.09),('8784','2014-03-16','08:00:00',1.23),('8784','2014-03-16','08:05:00',1.29),('8784','2014-03-16','08:10:00',1.33),('8784','2014-03-16','08:15:00',1.36),('8784','2014-03-16','08:20:00',1.46),('8784','2014-03-16','08:25:00',1.55),('8784','2014-03-16','08:30:00',1.63),('8784','2014-03-16','08:35:00',1.69),('8784','2014-03-16','08:40:00',1.74),('8784','2014-03-16','08:45:00',1.81),('8784','2014-03-16','08:50:00',1.9),('8784','2014-03-16','08:55:00',1.93),('8784','2014-03-16','09:00:00',1.91),('8784','2014-03-16','09:05:00',1.99),('8784','2014-03-16','09:10:00',2.15),('8784','2014-03-16','09:15:00',2.32),('8784','2014-03-16','09:20:00',2.36),('8784','2014-03-16','09:25:00',2.36),('8784','2014-03-16','09:30:00',2.39),('8784','2014-03-16','09:35:00',2.43),('8784','2014-03-16','09:40:00',2.47),('8784','2014-03-16','09:45:00',2.64),('8784','2014-03-16','09:50:00',2.76),('8784','2014-03-16','09:55:00',2.73),('8784','2014-03-16','10:00:00',2.77),('8784','2014-03-16','10:05:00',2.86),('8784','2014-03-16','10:10:00',2.86),('8784','2014-03-16','10:15:00',3),('8784','2014-03-16','10:20:00',2.94),('8784','2014-03-16','10:25:00',2.98),('8784','2014-03-16','10:30:00',2.98),('8784','2014-03-16','10:35:00',3.1),('8784','2014-03-16','10:40:00',3.16),('8784','2014-03-16','10:45:00',3.14),('8784','2014-03-16','10:50:00',3.29),('8784','2014-03-16','10:55:00',3.22),('8784','2014-03-16','11:00:00',3.32),('8784','2014-03-16','11:05:00',3.35),('8784','2014-03-16','11:10:00',3.4),('8784','2014-03-16','11:15:00',3.39),('8784','2014-03-16','11:20:00',3.42),('8784','2014-03-16','11:25:00',3.43),('8784','2014-03-16','11:30:00',3.49),('8784','2014-03-16','11:35:00',3.51),('8784','2014-03-16','11:40:00',3.51),('8784','2014-03-16','11:45:00',3.43),('8784','2014-03-16','11:50:00',3.37),('8784','2014-03-16','11:55:00',3.36),('8784','2014-03-16','12:00:00',3.42),('8784','2014-03-16','12:05:00',3.51),('8784','2014-03-16','12:10:00',3.46),('8784','2014-03-16','12:15:00',3.33),('8784','2014-03-16','12:20:00',3.33),('8784','2014-03-16','12:25:00',3.44),('8784','2014-03-16','12:30:00',3.49),('8784','2014-03-16','12:35:00',3.49),('8784','2014-03-16','12:40:00',3.5),('8784','2014-03-16','12:45:00',3.48),('8784','2014-03-16','12:50:00',3.44),('8784','2014-03-16','12:55:00',3.44),('8784','2014-03-16','13:00:00',3.38),('8784','2014-03-16','13:05:00',3.39),('8784','2014-03-16','13:10:00',3.3),('8784','2014-03-16','13:15:00',3.32),('8784','2014-03-16','13:20:00',3.24),('8784','2014-03-16','13:25:00',3.25),('8784','2014-03-16','13:30:00',3.27),('8784','2014-03-16','13:35:00',3.2),('8784','2014-03-16','13:40:00',3.3),('8784','2014-03-16','13:45:00',3.27),('8784','2014-03-16','13:50:00',3.21),('8784','2014-03-16','13:55:00',3.17),('8784','2014-03-16','14:00:00',3.08),('8784','2014-03-16','14:05:00',3.02),('8784','2014-03-16','14:10:00',2.96),('8784','2014-03-16','14:15:00',2.9),('8784','2014-03-16','14:20:00',2.89),('8784','2014-03-16','14:25:00',2.85),('8784','2014-03-16','14:30:00',2.82),('8784','2014-03-16','14:35:00',2.75),('8784','2014-03-16','14:40:00',2.69),('8784','2014-03-16','14:45:00',2.63),('8784','2014-03-16','14:50:00',2.47),('8784','2014-03-16','14:55:00',2.47),('8784','2014-03-16','15:00:00',2.54),('8784','2014-03-16','15:05:00',2.45),('8784','2014-03-16','15:10:00',2.21),('8784','2014-03-16','15:15:00',2.12),('8784','2014-03-16','15:20:00',1.8),('8784','2014-03-16','15:25:00',2.01),('8784','2014-03-16','15:30:00',1.86),('8784','2014-03-16','15:35:00',1.74),('8784','2014-03-16','15:40:00',1.38),('8784','2014-03-16','15:45:00',1.33),('8784','2014-03-16','15:50:00',1.47),('8784','2014-03-16','15:55:00',1.35),('8784','2014-03-16','16:00:00',1.17),('8784','2014-03-16','16:05:00',1.39),('8784','2014-03-16','16:10:00',1.46),('8784','2014-03-16','16:15:00',1.43),('8784','2014-03-16','16:20:00',1.31),('8784','2014-03-16','16:25:00',1.3),('8784','2014-03-16','16:30:00',1.31),('8784','2014-03-16','16:35:00',1.19),('8784','2014-03-16','16:40:00',1.04),('8784','2014-03-15','07:55:00',1.03),('8784','2014-03-15','08:00:00',1.11),('8784','2014-03-15','08:05:00',1.17),('8784','2014-03-15','08:10:00',1.26),('8784','2014-03-15','08:15:00',1.34),('8784','2014-03-15','08:20:00',1.42),('8784','2014-03-15','08:25:00',1.49),('8784','2014-03-15','08:30:00',1.56),('8784','2014-03-15','08:35:00',1.62),('8784','2014-03-15','08:40:00',1.7),('8784','2014-03-15','08:45:00',1.77),('8784','2014-03-15','08:50:00',1.85),('8784','2014-03-15','08:55:00',1.93),('8784','2014-03-15','09:00:00',2),('8784','2014-03-15','09:05:00',2.03),('8784','2014-03-15','09:10:00',2.15),('8784','2014-03-15','09:15:00',2.23),('8784','2014-03-15','09:20:00',2.29),('8784','2014-03-15','09:25:00',2.35),('8784','2014-03-15','09:30:00',2.41),('8784','2014-03-15','09:35:00',2.46),('8784','2014-03-15','09:40:00',2.52),('8784','2014-03-15','09:45:00',2.57),('8784','2014-03-15','09:50:00',2.6),('8784','2014-03-15','09:55:00',2.65),('8784','2014-03-15','10:00:00',2.69),('8784','2014-03-15','10:05:00',2.76),('8784','2014-03-15','10:10:00',2.83),('8784','2014-03-15','10:15:00',2.9),('8784','2014-03-15','10:20:00',2.93),('8784','2014-03-15','10:25:00',2.95),('8784','2014-03-15','10:30:00',2.99),('8784','2014-03-15','10:35:00',2.99),('8784','2014-03-15','10:40:00',3.03),('8784','2014-03-15','10:45:00',3.11),('8784','2014-03-15','10:50:00',3.1),('8784','2014-03-15','10:55:00',3.12),('8784','2014-03-15','11:00:00',3.18),('8784','2014-03-15','11:05:00',3.21),('8784','2014-03-15','11:10:00',3.22),('8784','2014-03-15','11:15:00',3.31),('8784','2014-03-15','11:20:00',3.36),('8784','2014-03-15','11:25:00',3.45),('8784','2014-03-15','11:30:00',3.36),('8784','2014-03-15','11:35:00',3.39),('8784','2014-03-15','11:40:00',3.4),('8784','2014-03-15','11:45:00',3.52),('8784','2014-03-15','11:50:00',3.4),('8784','2014-03-15','11:55:00',3.39),('8784','2014-03-15','12:00:00',3.4),('8784','2014-03-15','12:05:00',3.37),('8784','2014-03-15','12:10:00',3.46),('8784','2014-03-15','12:15:00',3.51),('8784','2014-03-15','12:20:00',3.44),('8784','2014-03-15','12:25:00',3.49),('8784','2014-03-15','12:30:00',3.54),('8784','2014-03-15','12:35:00',3.57),('8784','2014-03-15','12:40:00',3.53),('8784','2014-03-15','12:45:00',3.52),('8784','2014-03-15','12:50:00',3.53),('8784','2014-03-15','12:55:00',3.46),('8784','2014-03-15','13:00:00',3.49),('8784','2014-03-15','13:05:00',3.49),('8784','2014-03-15','13:10:00',3.46),('8784','2014-03-15','13:15:00',3.34),('8784','2014-03-15','13:20:00',3.32),('8784','2014-03-15','13:25:00',3.35),('8784','2014-03-15','13:30:00',3.36),('8784','2014-03-15','13:35:00',3.36),('8784','2014-03-15','13:40:00',3.31),('8784','2014-03-15','13:45:00',3.28),('8784','2014-03-15','13:50:00',3.24),('8784','2014-03-15','13:55:00',3.23),('8784','2014-03-15','14:00:00',3.15),('8784','2014-03-15','14:05:00',3.17),('8784','2014-03-15','14:10:00',3.13),('8784','2014-03-15','14:15:00',3.06),('8784','2014-03-15','14:20:00',3),('8784','2014-03-15','14:25:00',2.95),('8784','2014-03-15','14:30:00',2.9),('8784','2014-03-15','14:35:00',2.84),('8784','2014-03-15','14:40:00',2.76),('8784','2014-03-15','14:45:00',2.69),('8784','2014-03-15','14:50:00',2.62),('8784','2014-03-15','14:55:00',2.59),('8784','2014-03-15','15:00:00',2.53),('8784','2014-03-15','15:05:00',2.46),('8784','2014-03-15','15:10:00',2.37),('8784','2014-03-15','15:15:00',2.31),('8784','2014-03-15','15:20:00',2.22),('8784','2014-03-15','15:25:00',2.15),('8784','2014-03-15','15:30:00',2.08),('8784','2014-03-15','15:35:00',1.98),('8784','2014-03-15','15:40:00',1.9),('8784','2014-03-15','15:45:00',1.82),('8784','2014-03-15','15:50:00',1.75),('8784','2014-03-15','15:55:00',1.67),('8784','2014-03-15','16:00:00',1.58),('8784','2014-03-15','16:05:00',1.45),('8784','2014-03-15','16:10:00',1.39),('8784','2014-03-15','16:15:00',1.3),('8784','2014-03-15','16:20:00',1.24),('8784','2014-03-15','16:25:00',1.13),('8784','2014-03-15','16:30:00',1.07),('8784','2014-03-14','08:15:00',1.08),('8784','2014-03-14','08:20:00',1.2),('8784','2014-03-14','08:25:00',1.23),('8784','2014-03-14','08:30:00',1.29),('8784','2014-03-14','08:35:00',1.29),('8784','2014-03-14','08:40:00',1.26),('8784','2014-03-14','08:45:00',1.1),('8784','2014-03-14','08:50:00',1.07),('8784','2014-03-14','08:55:00',1.11),('8784','2014-03-14','09:00:00',1.21),('8784','2014-03-14','09:05:00',1.38),('8784','2014-03-14','09:10:00',1.51),('8784','2014-03-14','09:15:00',1.55),('8784','2014-03-14','09:20:00',1.5),('8784','2014-03-14','09:25:00',1.59),('8784','2014-03-14','09:30:00',1.59),('8784','2014-03-14','09:35:00',1.84),('8784','2014-03-14','09:40:00',2.28),('8784','2014-03-14','09:45:00',2.65),('8784','2014-03-14','09:50:00',3.15),('8784','2014-03-14','09:55:00',3.31),('8784','2014-03-14','10:00:00',3.45),('8784','2014-03-14','10:05:00',3.45),('8784','2014-03-14','10:10:00',3.33),('8784','2014-03-14','10:15:00',3.28),('8784','2014-03-14','10:20:00',3.22),('8784','2014-03-14','10:25:00',3.07),('8784','2014-03-14','10:30:00',3.08),('8784','2014-03-14','10:35:00',3.23),('8784','2014-03-14','10:40:00',3.37),('8784','2014-03-14','10:45:00',2.88),('8784','2014-03-14','10:50:00',1.93),('8784','2014-03-14','10:55:00',2.66),('8784','2014-03-14','11:00:00',3.15),('8784','2014-03-14','11:05:00',3.36),('8784','2014-03-14','11:10:00',3.68),('8784','2014-03-14','11:15:00',3.72),('8784','2014-03-14','11:20:00',3.61),('8784','2014-03-14','11:25:00',3.51),('8784','2014-03-14','11:30:00',3.47),('8784','2014-03-14','11:35:00',3.52),('8784','2014-03-14','11:40:00',3.47),('8784','2014-03-14','11:45:00',3.6),('8784','2014-03-14','11:50:00',3.69),('8784','2014-03-14','11:55:00',3.72),('8784','2014-03-14','12:00:00',3.73),('8784','2014-03-14','12:05:00',3.66),('8784','2014-03-14','12:10:00',3.44),('8784','2014-03-14','12:15:00',3.34),('8784','2014-03-14','12:20:00',2.77),('8784','2014-03-14','12:25:00',2.4),('8784','2014-03-14','12:30:00',2.23),('8784','2014-03-14','12:35:00',1.84),('8784','2014-03-14','12:40:00',2.23),('8784','2014-03-14','12:45:00',2.43),('8784','2014-03-14','14:00:00',2.49),('8784','2014-03-14','14:05:00',2.71),('8784','2014-03-14','14:10:00',2.6),('8784','2014-03-14','14:15:00',2.82),('8784','2014-03-14','14:20:00',2.86),('8784','2014-03-14','14:25:00',2.57),('8784','2014-03-14','14:30:00',2.52),('8784','2014-03-14','14:35:00',2.4),('8784','2014-03-14','14:40:00',1.97),('8784','2014-03-14','14:45:00',1.64),('8784','2014-03-14','14:50:00',1.51),('8784','2014-03-14','14:55:00',1.39),('8784','2014-03-14','15:00:00',1.29),('8784','2014-03-14','15:05:00',1.28),('8784','2014-03-14','15:10:00',1.21),('8784','2014-03-14','15:15:00',1.18),('8784','2014-03-14','15:20:00',1.25),('8784','2014-03-14','15:25:00',1.36),('8784','2014-03-14','15:30:00',1.46),('8784','2014-03-14','15:35:00',1.65),('8784','2014-03-14','15:40:00',1.5),('8784','2014-03-14','15:45:00',1.28),('8784','2014-03-14','15:50:00',1.15),('8784','2014-03-14','15:55:00',1.17),('8784','2014-03-14','16:00:00',1.1),('8784','2014-03-14','16:05:00',1.09),('8784','2014-03-13','07:45:00',1.07),('8784','2014-03-13','07:50:00',1.15),('8784','2014-03-13','07:55:00',1.24),('8784','2014-03-13','08:00:00',1.31),('8784','2014-03-13','08:05:00',1.4),('8784','2014-03-13','08:10:00',1.48),('8784','2014-03-13','08:15:00',1.56),('8784','2014-03-13','08:20:00',1.66),('8784','2014-03-13','08:25:00',1.74),('8784','2014-03-13','08:30:00',1.82),('8784','2014-03-13','08:35:00',1.88),('8784','2014-03-13','08:40:00',1.98),('8784','2014-03-13','08:45:00',2.06),('8784','2014-03-13','08:50:00',2.13),('8784','2014-03-13','08:55:00',2.22),('8784','2014-03-13','09:00:00',2.31),('8784','2014-03-13','09:05:00',2.38),('8784','2014-03-13','09:10:00',2.45),('8784','2014-03-13','09:15:00',2.52),('8784','2014-03-13','09:20:00',2.55),('8784','2014-03-13','09:25:00',2.64),('8784','2014-03-13','09:30:00',2.71),('8784','2014-03-13','09:35:00',2.78),('8784','2014-03-13','09:40:00',2.85),('8784','2014-03-13','09:45:00',2.91),('8784','2014-03-13','09:50:00',2.98),('8784','2014-03-13','09:55:00',3.04),('8784','2014-03-13','10:00:00',3.1),('8784','2014-03-13','10:05:00',3.14),('8784','2014-03-13','10:10:00',3.2),('8784','2014-03-13','10:15:00',3.24),('8784','2014-03-13','10:20:00',3.28),('8784','2014-03-13','10:25:00',3.3),('8784','2014-03-13','10:30:00',3.33),('8784','2014-03-13','10:35:00',3.36),('8784','2014-03-13','10:40:00',3.4),('8784','2014-03-13','10:45:00',3.43),('8784','2014-03-13','10:50:00',3.47),('8784','2014-03-13','10:55:00',3.51),('8784','2014-03-13','11:00:00',3.54),('8784','2014-03-13','11:05:00',3.55),('8784','2014-03-13','11:10:00',3.57),('8784','2014-03-13','11:15:00',3.6),('8784','2014-03-13','11:20:00',3.65),('8784','2014-03-13','11:25:00',3.66),('8784','2014-03-13','11:30:00',3.66),('8784','2014-03-13','11:35:00',3.68),('8784','2014-03-13','11:40:00',3.7),('8784','2014-03-13','11:45:00',3.71),('8784','2014-03-13','11:50:00',3.72),('8784','2014-03-13','11:55:00',3.73),('8784','2014-03-13','12:00:00',3.75),('8784','2014-03-13','12:05:00',3.75),('8784','2014-03-13','12:10:00',3.69),('8784','2014-03-13','12:15:00',3.71),('8784','2014-03-13','12:20:00',3.68),('8784','2014-03-13','12:25:00',3.67),('8784','2014-03-13','12:30:00',3.67),('8784','2014-03-13','12:35:00',3.67),('8784','2014-03-13','12:40:00',3.64),('8784','2014-03-13','12:45:00',3.63),('8784','2014-03-13','12:50:00',3.58),('8784','2014-03-13','12:55:00',3.52),('8784','2014-03-13','13:00:00',3.53),('8784','2014-03-13','13:05:00',3.53),('8784','2014-03-13','13:10:00',3.44),('8784','2014-03-13','13:15:00',3.44),('8784','2014-03-13','13:20:00',3.45),('8784','2014-03-13','13:25:00',3.42),('8784','2014-03-13','13:30:00',3.43),('8784','2014-03-13','13:35:00',3.4),('8784','2014-03-13','13:40:00',3.35),('8784','2014-03-13','13:45:00',3.33),('8784','2014-03-13','13:50:00',3.28),('8784','2014-03-13','13:55:00',3.22),('8784','2014-03-13','14:00:00',3.14),('8784','2014-03-13','14:05:00',3.09),('8784','2014-03-13','14:10:00',3.07),('8784','2014-03-13','14:15:00',3.03),('8784','2014-03-13','14:20:00',2.99),('8784','2014-03-13','14:25:00',2.93),('8784','2014-03-13','14:30:00',2.87),('8784','2014-03-13','14:35:00',2.83),('8784','2014-03-13','14:40:00',2.77),('8784','2014-03-13','14:45:00',2.7),('8784','2014-03-13','14:50:00',2.63),('8784','2014-03-13','14:55:00',2.56),('8784','2014-03-13','15:00:00',2.5),('8784','2014-03-13','15:05:00',2.43),('8784','2014-03-13','15:10:00',2.37),('8784','2014-03-13','15:15:00',2.31),('8784','2014-03-13','15:20:00',2.23),('8784','2014-03-13','15:25:00',2.16),('8784','2014-03-13','15:30:00',2.09),('8784','2014-03-13','15:35:00',2.01),('8784','2014-03-13','15:40:00',1.93),('8784','2014-03-13','15:45:00',1.84),('8784','2014-03-13','15:50:00',1.77),('8784','2014-03-13','15:55:00',1.67),('8784','2014-03-13','16:00:00',1.55),('8784','2014-03-13','16:05:00',1.48),('8784','2014-03-13','16:10:00',1.41),('8784','2014-03-13','16:15:00',1.32),('8784','2014-03-13','16:20:00',1.25),('8784','2014-03-13','16:25:00',1.18),('8784','2014-03-13','16:30:00',1.09),('8784','2014-03-13','16:35:00',1.01),('8784','2014-03-12','07:50:00',1.07),('8784','2014-03-12','07:55:00',1.15),('8784','2014-03-12','08:00:00',1.23),('8784','2014-03-12','08:05:00',1.32),('8784','2014-03-12','08:10:00',1.41),('8784','2014-03-12','08:15:00',1.51),('8784','2014-03-12','08:20:00',1.59),('8784','2014-03-12','08:25:00',1.67),('8784','2014-03-12','08:30:00',1.75),('8784','2014-03-12','08:35:00',1.86),('8784','2014-03-12','08:40:00',1.94),('8784','2014-03-12','08:45:00',2.02),('8784','2014-03-12','08:50:00',2.1),('8784','2014-03-12','08:55:00',2.19),('8784','2014-03-12','09:00:00',2.27),('8784','2014-03-12','09:05:00',2.34),('8784','2014-03-12','09:10:00',2.4),('8784','2014-03-12','09:15:00',2.47),('8784','2014-03-12','09:20:00',2.56),('8784','2014-03-12','09:25:00',2.63),('8784','2014-03-12','09:30:00',2.69),('8784','2014-03-12','09:35:00',2.74),('8784','2014-03-12','09:40:00',2.81),('8784','2014-03-12','09:45:00',2.87),('8784','2014-03-12','09:50:00',2.92),('8784','2014-03-12','09:55:00',2.99),('8784','2014-03-12','10:00:00',3.06),('8784','2014-03-12','10:05:00',3.05),('8784','2014-03-12','10:10:00',3.17),('8784','2014-03-12','10:15:00',3.21),('8784','2014-03-12','10:20:00',3.24),('8784','2014-03-12','10:25:00',3.28),('8784','2014-03-12','10:30:00',3.33),('8784','2014-03-12','10:35:00',3.37),('8784','2014-03-12','10:40:00',3.44),('8784','2014-03-12','10:45:00',3.5),('8784','2014-03-12','10:50:00',3.54),('8784','2014-03-12','10:55:00',3.55),('8784','2014-03-12','11:00:00',3.59),('8784','2014-03-12','11:05:00',3.63),('8784','2014-03-12','11:10:00',3.66),('8784','2014-03-12','11:15:00',3.7),('8784','2014-03-12','11:20:00',3.72),('8784','2014-03-12','11:25:00',3.74),('8784','2014-03-12','11:30:00',3.77),('8784','2014-03-12','11:35:00',3.77),('8784','2014-03-12','11:40:00',3.8),('8784','2014-03-12','11:45:00',3.8),('8784','2014-03-12','11:50:00',3.8),('8784','2014-03-12','11:55:00',3.81),('8784','2014-03-12','12:00:00',3.81),('8784','2014-03-12','12:05:00',3.8),('8784','2014-03-12','12:10:00',3.81),('8784','2014-03-12','12:15:00',3.79),('8784','2014-03-12','12:20:00',3.77),('8784','2014-03-12','12:25:00',3.78),('8784','2014-03-12','12:30:00',3.75),('8784','2014-03-12','12:35:00',3.75),('8784','2014-03-12','12:40:00',3.73),('8784','2014-03-12','12:45:00',3.7),('8784','2014-03-12','12:50:00',3.69),('8784','2014-03-12','12:55:00',3.68),('8784','2014-03-12','13:00:00',3.66),('8784','2014-03-12','13:05:00',3.63),('8784','2014-03-12','13:10:00',3.57),('8784','2014-03-12','13:15:00',3.57),('8784','2014-03-12','13:20:00',3.58),('8784','2014-03-12','13:25:00',3.53),('8784','2014-03-12','13:30:00',3.51),('8784','2014-03-12','13:35:00',3.44),('8784','2014-03-12','13:40:00',3.4),('8784','2014-03-12','13:45:00',3.38),('8784','2014-03-12','13:50:00',3.32),('8784','2014-03-12','13:55:00',3.28),('8784','2014-03-12','14:00:00',3.28),('8784','2014-03-12','14:05:00',3.24),('8784','2014-03-12','14:10:00',3.18),('8784','2014-03-12','14:15:00',3.14),('8784','2014-03-12','14:20:00',3.09),('8784','2014-03-12','14:25:00',3.02),('8784','2014-03-12','14:30:00',2.99),('8784','2014-03-12','14:35:00',2.84),('8784','2014-03-12','14:40:00',2.78),('8784','2014-03-12','14:45:00',2.69),('8784','2014-03-12','14:50:00',2.65),('8784','2014-03-12','14:55:00',2.57),('8784','2014-03-12','15:00:00',2.3),('8784','2014-03-12','15:05:00',2.41),('8784','2014-03-12','15:10:00',2.35),('8784','2014-03-12','15:15:00',2.26),('8784','2014-03-12','15:20:00',2.21),('8784','2014-03-12','15:25:00',2.1),('8784','2014-03-12','15:30:00',2.02),('8784','2014-03-12','15:35:00',1.95),('8784','2014-03-12','15:40:00',1.9),('8784','2014-03-12','15:45:00',1.84),('8784','2014-03-12','15:50:00',1.77),('8784','2014-03-12','15:55:00',1.68),('8784','2014-03-12','16:00:00',1.63),('8784','2014-03-12','16:05:00',1.53),('8784','2014-03-12','16:10:00',1.43),('8784','2014-03-12','16:15:00',1.36),('8784','2014-03-12','16:20:00',1.27),('8784','2014-03-12','16:25:00',1.18),('8784','2014-03-12','16:30:00',1.09),('8784','2014-03-12','16:35:00',1.03),('8784','2014-03-11','10:25:00',1),('8784','2014-03-11','10:30:00',1.04),('8784','2014-03-11','10:35:00',1.03),('8784','2014-03-11','10:40:00',1.03),('8784','2014-03-11','11:00:00',1.07),('8784','2014-03-11','11:05:00',1.11),('8784','2014-03-11','11:10:00',1.11),('8784','2014-03-11','11:15:00',1.13),('8784','2014-03-11','11:20:00',1.03),('8784','2014-03-11','11:40:00',1.08),('8784','2014-03-11','11:45:00',1.13),('8784','2014-03-11','11:55:00',1.08),('8784','2014-03-11','12:00:00',1.14),('8784','2014-03-11','12:05:00',1.14),('8784','2014-03-11','12:10:00',1.18),('8784','2014-03-11','12:15:00',1.33),('8784','2014-03-11','12:20:00',1.43),('8784','2014-03-11','12:25:00',1.3),('8784','2014-03-11','12:30:00',1.25),('8784','2014-03-11','12:35:00',1.35),('8784','2014-03-11','12:40:00',1.49),('8784','2014-03-11','12:45:00',1.46),('8784','2014-03-11','12:50:00',1.4),('8784','2014-03-11','12:55:00',1.29),('8784','2014-03-11','13:00:00',1.24),('8784','2014-03-11','13:05:00',1.42),('8784','2014-03-11','13:10:00',1.42),('8784','2014-03-11','13:15:00',1.36),('8784','2014-03-11','13:20:00',1.42),('8784','2014-03-11','13:25:00',1.24),('8784','2014-03-11','13:30:00',1.2),('8784','2014-03-11','13:35:00',1.15),('8784','2014-03-11','13:40:00',1.19),('8784','2014-03-11','13:45:00',1.46),('8784','2014-03-11','13:50:00',1.7),('8784','2014-03-11','13:55:00',1.97),('8784','2014-03-11','14:00:00',2.05),('8784','2014-03-11','14:05:00',2.07),('8784','2014-03-11','14:10:00',2.5),('8784','2014-03-11','14:15:00',2.67),('8784','2014-03-11','14:20:00',2.34),('8784','2014-03-11','14:25:00',2.08),('8784','2014-03-11','14:30:00',1.5),('8784','2014-03-11','14:35:00',1.58),('8784','2014-03-11','14:40:00',1.5),('8784','2014-03-11','14:45:00',1.59),('8784','2014-03-11','14:50:00',1.45),('8784','2014-03-11','14:55:00',1.43),('8784','2014-03-11','15:00:00',1.63),('8784','2014-03-11','15:05:00',1.73),('8784','2014-03-11','15:10:00',1.82),('8784','2014-03-11','15:15:00',1.71),('8784','2014-03-11','15:20:00',1.87),('8784','2014-03-11','15:25:00',1.44),('8784','2014-03-11','15:30:00',1.35),('8784','2014-03-11','15:35:00',1.22),('8784','2014-03-11','15:40:00',1.18),('8784','2014-03-11','15:45:00',1.13),('8784','2014-03-11','15:50:00',1.12),('8784','2014-03-10','08:55:00',1.01),('8784','2014-03-10','09:00:00',1.03),('8784','2014-03-10','09:05:00',1.12),('8784','2014-03-10','09:10:00',1.12),('8784','2014-03-10','09:15:00',1.07),('8784','2014-03-10','09:20:00',1.01),('8784','2014-03-10','09:25:00',1.05),('8784','2014-03-10','09:30:00',1.1),('8784','2014-03-10','09:35:00',1.11),('8784','2014-03-10','09:40:00',1.15),('8784','2014-03-10','09:45:00',1.05),('8784','2014-03-10','10:10:00',1.08),('8784','2014-03-10','10:15:00',1.25),('8784','2014-03-10','10:20:00',1.02),('8784','2014-03-10','10:30:00',1.15),('8784','2014-03-10','10:35:00',1.32),('8784','2014-03-10','11:20:00',1.07),('8784','2014-03-10','12:45:00',1.09),('8784','2014-03-10','12:50:00',1.21),('8784','2014-03-10','12:55:00',1.29),('8784','2014-03-10','13:00:00',1.35),('8784','2014-03-10','13:05:00',1.36),('8784','2014-03-10','13:10:00',1.46),('8784','2014-03-10','13:15:00',1.59),('8784','2014-03-10','13:20:00',1.59),('8784','2014-03-10','13:25:00',1.43),('8784','2014-03-10','13:30:00',1.22),('8784','2014-03-10','13:35:00',1.01),('8784','2014-03-10','13:50:00',1.28),('8784','2014-03-10','13:55:00',1.38),('8784','2014-03-10','14:00:00',1.23),('8784','2014-03-10','14:05:00',1.82),('8784','2014-03-10','14:10:00',2.27),('8784','2014-03-10','14:15:00',3.09),('8784','2014-03-10','14:20:00',2.24),('8784','2014-03-10','14:25:00',1.68),('8784','2014-03-10','14:30:00',1.42),('8784','2014-03-10','14:35:00',1.95),('8784','2014-03-10','14:40:00',2.65),('8784','2014-03-10','14:45:00',2.73),('8784','2014-03-10','14:50:00',2.6),('8784','2014-03-10','14:55:00',1.33),('8784','2014-03-10','15:00:00',1.75),('8784','2014-03-10','15:05:00',1.34),('8784','2014-03-10','15:10:00',1),('8784','2014-03-10','15:15:00',1.21),('8784','2014-03-10','15:20:00',1.82),('8784','2014-03-10','15:25:00',2.35),('8784','2014-03-10','15:30:00',1.65),('8784','2014-03-10','15:35:00',1.11),('8784','2014-03-10','15:40:00',1.06),('8784','2014-03-10','16:30:00',1),('8784','2014-03-09','07:55:00',1.05),('8784','2014-03-09','08:00:00',1.14),('8784','2014-03-09','08:05:00',1.23),('8784','2014-03-09','08:10:00',1.32),('8784','2014-03-09','08:15:00',1.41),('8784','2014-03-09','08:20:00',1.43),('8784','2014-03-09','08:25:00',1.33),('8784','2014-03-09','08:30:00',1.31),('8784','2014-03-09','08:35:00',1.2),('8784','2014-03-09','08:40:00',1.22),('8784','2014-03-09','08:45:00',1.14),('8784','2014-03-09','08:55:00',1.64),('8784','2014-03-09','09:00:00',2.05),('8784','2014-03-09','09:05:00',1.72),('8784','2014-03-09','09:15:00',2.37),('8784','2014-03-09','09:20:00',2.54),('8784','2014-03-09','09:25:00',2.69),('8784','2014-03-09','09:30:00',2.77),('8784','2014-03-09','09:35:00',2.99),('8784','2014-03-09','09:40:00',3.02),('8784','2014-03-09','09:45:00',3.08),('8784','2014-03-09','09:50:00',3.11),('8784','2014-03-09','09:55:00',3.09),('8784','2014-03-09','10:00:00',3.12),('8784','2014-03-09','10:05:00',3.16),('8784','2014-03-09','10:10:00',3.25),('8784','2014-03-09','10:15:00',3.28),('8784','2014-03-09','10:20:00',3.27),('8784','2014-03-09','10:25:00',3.22),('8784','2014-03-09','10:30:00',3.4),('8784','2014-03-09','10:35:00',3.43),('8784','2014-03-09','10:40:00',3.46),('8784','2014-03-09','10:45:00',3.51),('8784','2014-03-09','10:50:00',3.62),('8784','2014-03-09','10:55:00',3.72),('8784','2014-03-09','11:00:00',3.94),('8784','2014-03-09','11:05:00',3.93),('8784','2014-03-09','11:10:00',4.09),('8784','2014-03-09','11:15:00',4.22),('8784','2014-03-09','11:20:00',2.8),('8784','2014-03-09','11:25:00',1.94),('8784','2014-03-09','11:30:00',1.41),('8784','2014-03-09','11:35:00',2.77),('8784','2014-03-09','11:40:00',2.17),('8784','2014-03-09','11:45:00',1.95),('8784','2014-03-09','11:50:00',3.27),('8784','2014-03-09','11:55:00',3.49),('8784','2014-03-09','12:00:00',3.69),('8784','2014-03-09','12:05:00',4.31),('8784','2014-03-09','12:10:00',4.43),('8784','2014-03-09','12:15:00',4.38),('8784','2014-03-09','12:20:00',4.32),('8784','2014-03-09','12:25:00',4.23),('8784','2014-03-09','12:30:00',4.25),('8784','2014-03-09','12:35:00',4.4),('8784','2014-03-09','12:40:00',4.14),('8784','2014-03-09','12:45:00',4.04),('8784','2014-03-09','12:50:00',4.07),('8784','2014-03-09','12:55:00',4.12),('8784','2014-03-09','13:00:00',4.22),('8784','2014-03-09','13:05:00',4.23),('8784','2014-03-09','13:10:00',4.2),('8784','2014-03-09','13:15:00',3.89),('8784','2014-03-09','13:20:00',3.8),('8784','2014-03-09','13:25:00',3.73),('8784','2014-03-09','13:30:00',3.69),('8784','2014-03-09','13:35:00',3.52),('8784','2014-03-09','13:45:00',1.03),('8784','2014-03-09','13:50:00',2.96),('8784','2014-03-09','14:00:00',2.12),('8784','2014-03-09','14:05:00',3.47),('8784','2014-03-09','14:10:00',3.36),('8784','2014-03-09','14:15:00',3.14),('8784','2014-03-09','14:20:00',1.74),('8784','2014-03-09','14:25:00',3.14),('8784','2014-03-09','14:30:00',1.16),('8784','2014-03-09','14:45:00',2.46),('8784','2014-03-09','14:50:00',1.6),('8784','2014-03-09','14:55:00',2.82),('8784','2014-03-09','15:00:00',2.7),('8784','2014-03-09','15:05:00',2.12),('8784','2014-03-09','15:10:00',2.48),('8784','2014-03-09','15:15:00',2.42),('8784','2014-03-09','15:20:00',2.39),('8784','2014-03-09','15:25:00',2.36),('8784','2014-03-09','15:30:00',2.3),('8784','2014-03-09','15:35:00',2.18),('8784','2014-03-09','15:40:00',2.05),('8784','2014-03-09','15:45:00',1.67),('8784','2014-03-09','15:55:00',1.38),('8784','2014-03-09','16:00:00',1.78),('8784','2014-03-09','16:05:00',1.59),('8784','2014-03-09','16:10:00',1.13),('8784','2014-03-09','16:15:00',1.05),('8784','2014-03-09','16:25:00',1.17),('8784','2014-03-09','16:30:00',1.12),('8784','2014-03-09','16:35:00',1.09),('8784','2014-03-09','16:40:00',1.05),('8784','2014-03-08','07:55:00',1.03),('8784','2014-03-08','08:00:00',1.12),('8784','2014-03-08','08:05:00',1.21),('8784','2014-03-08','08:10:00',1.29),('8784','2014-03-08','08:15:00',1.38),('8784','2014-03-08','08:20:00',1.47),('8784','2014-03-08','08:25:00',1.55),('8784','2014-03-08','08:30:00',1.65),('8784','2014-03-08','08:35:00',1.73),('8784','2014-03-08','08:40:00',1.83),('8784','2014-03-08','08:45:00',1.91),('8784','2014-03-08','08:50:00',1.96),('8784','2014-03-08','08:55:00',2.06),('8784','2014-03-08','09:00:00',2.15),('8784','2014-03-08','09:05:00',2.23),('8784','2014-03-08','09:10:00',2.31),('8784','2014-03-08','09:15:00',2.38),('8784','2014-03-08','09:20:00',2.46),('8784','2014-03-08','09:25:00',2.54),('8784','2014-03-08','09:30:00',2.62),('8784','2014-03-08','09:35:00',2.67),('8784','2014-03-08','09:40:00',2.72),('8784','2014-03-08','09:45:00',2.79),('8784','2014-03-08','09:50:00',2.85),('8784','2014-03-08','09:55:00',2.9),('8784','2014-03-08','10:00:00',2.97),('8784','2014-03-08','10:05:00',3.02),('8784','2014-03-08','10:10:00',3.08),('8784','2014-03-08','10:15:00',3.13),('8784','2014-03-08','10:20:00',3.19),('8784','2014-03-08','10:25:00',3.23),('8784','2014-03-08','10:30:00',3.3),('8784','2014-03-08','10:35:00',3.35),('8784','2014-03-08','10:40:00',3.39),('8784','2014-03-08','10:45:00',3.44),('8784','2014-03-08','10:50:00',3.47),('8784','2014-03-08','10:55:00',3.5),('8784','2014-03-08','11:00:00',3.54),('8784','2014-03-08','11:05:00',3.56),('8784','2014-03-08','11:10:00',3.59),('8784','2014-03-08','11:15:00',3.65),('8784','2014-03-08','11:20:00',3.71),('8784','2014-03-08','11:25:00',3.82),('8784','2014-03-08','11:30:00',4),('8784','2014-03-08','11:35:00',3.58),('8784','2014-03-08','11:40:00',2.62),('8784','2014-03-08','11:45:00',1.77),('8784','2014-03-08','11:50:00',1.53),('8784','2014-03-08','11:55:00',2.73),('8784','2014-03-08','12:00:00',2.25),('8784','2014-03-08','12:05:00',1.11),('8784','2014-03-08','12:10:00',1.15),('8784','2014-03-08','12:15:00',1.22),('8784','2014-03-08','12:20:00',1.4),('8784','2014-03-08','12:25:00',1.55),('8784','2014-03-08','12:30:00',1.67),('8784','2014-03-08','12:35:00',3.38),('8784','2014-03-08','12:40:00',2.1),('8784','2014-03-08','12:45:00',2.33),('8784','2014-03-08','12:50:00',2.52),('8784','2014-03-08','12:55:00',3.33),('8784','2014-03-08','13:00:00',2.09),('8784','2014-03-08','13:05:00',1.77),('8784','2014-03-08','13:10:00',1.56),('8784','2014-03-08','13:15:00',1.25),('8784','2014-03-08','13:20:00',1.06),('8784','2014-03-08','13:25:00',1.09),('8784','2014-03-08','13:30:00',1.65),('8784','2014-03-08','13:35:00',1.71),('8784','2014-03-08','13:40:00',2.34),('8784','2014-03-08','13:45:00',2.58),('8784','2014-03-08','13:50:00',2.32),('8784','2014-03-08','13:55:00',1.48),('8784','2014-03-08','14:00:00',1.18),('8784','2014-03-08','14:05:00',1.12),('8784','2014-03-08','14:10:00',1.03),('8784','2014-03-08','14:35:00',1.02),('8784','2014-03-08','14:40:00',1.1),('8784','2014-03-08','14:45:00',1.03),('8784','2014-03-08','14:50:00',1.05),('8784','2014-03-08','14:55:00',1.11),('8784','2014-03-08','15:15:00',1.27),('8784','2014-03-08','15:20:00',1.61),('8784','2014-03-08','15:25:00',1.53),('8784','2014-03-08','15:30:00',1.79),('8784','2014-03-08','16:00:00',1),('8784','2014-03-08','16:30:00',1),('8784','2014-03-08','16:35:00',1.16),('8784','2014-04-30','07:35:00',1.02),('8784','2014-04-30','07:40:00',1.11),('8784','2014-04-30','07:45:00',1.23),('8784','2014-04-30','07:50:00',1.31),('8784','2014-04-30','07:55:00',1.4),('8784','2014-04-30','08:00:00',1.47),('8784','2014-04-30','08:05:00',1.5),('8784','2014-04-30','08:10:00',1.63),('8784','2014-04-30','08:15:00',1.74),('8784','2014-04-30','08:20:00',1.82),('8784','2014-04-30','08:25:00',1.89),('8784','2014-04-30','08:30:00',1.93),('8784','2014-04-30','08:35:00',2.05),('8784','2014-04-30','08:40:00',2.12),('8784','2014-04-30','08:45:00',2.2),('8784','2014-04-30','08:50:00',2.29),('8784','2014-04-30','08:55:00',2.35),('8784','2014-04-30','09:00:00',2.63),('8784','2014-04-30','09:05:00',2.64),('8784','2014-04-30','09:10:00',2.83),('8784','2014-04-30','09:15:00',1.78),('8784','2014-04-30','09:20:00',2.46),('8784','2014-04-30','09:25:00',2.37),('8784','2014-04-30','09:30:00',1.79),('8784','2014-04-30','09:35:00',3.21),('8784','2014-04-30','09:40:00',3.22),('8784','2014-04-30','09:45:00',2.53),('8784','2014-04-30','09:50:00',2.09),('8784','2014-04-30','09:55:00',3.25),('8784','2014-04-30','10:00:00',3.86),('8784','2014-04-30','10:05:00',2.17),('8784','2014-04-30','10:10:00',2.84),('8784','2014-04-30','10:15:00',2.58),('8784','2014-04-30','10:20:00',1.83),('8784','2014-04-30','10:25:00',1.83),('8784','2014-04-30','10:30:00',2.09),('8784','2014-04-30','10:35:00',2.29),('8784','2014-04-30','10:40:00',2.32),('8784','2014-04-30','10:45:00',1.78),('8784','2014-04-30','10:50:00',2.11),('8784','2014-04-30','10:55:00',4.48),('8784','2014-04-30','11:00:00',4.27),('8784','2014-04-30','11:05:00',3.31),('8784','2014-04-30','11:10:00',3.11),('8784','2014-04-30','11:15:00',2.26),('8784','2014-04-30','11:20:00',2.33),('8784','2014-04-30','11:25:00',2.46),('8784','2014-04-30','11:30:00',2.35),('8784','2014-04-30','11:35:00',3.57),('8784','2014-04-30','11:40:00',2.97),('8784','2014-04-30','11:45:00',2.95),('8784','2014-04-30','11:50:00',4.13),('8784','2014-04-30','11:55:00',3.76),('8784','2014-04-30','12:00:00',3.17),('8784','2014-04-30','12:05:00',1.56),('8784','2014-04-30','12:10:00',1.51),('8784','2014-04-30','12:15:00',2.06),('8784','2014-04-30','12:20:00',1.86),('8784','2014-04-30','12:25:00',1.69),('8784','2014-04-30','12:30:00',2.19),('8784','2014-04-30','12:35:00',2),('8784','2014-04-30','12:40:00',1.61),('8784','2014-04-30','12:45:00',1.5),('8784','2014-04-30','12:50:00',2.01),('8784','2014-04-30','12:55:00',4.87),('8784','2014-04-30','13:00:00',4.18),('8784','2014-04-30','13:05:00',2.91),('8784','2014-04-30','13:10:00',3.95),('8784','2014-04-30','13:15:00',2.35),('8784','2014-04-30','13:20:00',2.52),('8784','2014-04-30','13:25:00',3.57),('8784','2014-04-30','13:30:00',2.2),('8784','2014-04-30','13:35:00',2.45),('8784','2014-04-30','13:40:00',3.76),('8784','2014-04-30','13:45:00',3.69),('8784','2014-04-30','13:50:00',3.07),('8784','2014-04-30','13:55:00',3.93),('8784','2014-04-30','14:00:00',2.19),('8784','2014-04-30','14:05:00',1.99),('8784','2014-04-30','14:10:00',1.77),('8784','2014-04-30','14:15:00',2.09),('8784','2014-04-30','14:20:00',4.11),('8784','2014-04-30','14:25:00',4.36),('8784','2014-04-30','14:30:00',4.77),('8784','2014-04-30','14:35:00',3.77),('8784','2014-04-30','14:40:00',2.24),('8784','2014-04-30','14:45:00',1.56),('8784','2014-04-30','14:50:00',1.86),('8784','2014-04-30','14:55:00',2.01),('8784','2014-04-30','15:00:00',1.69),('8784','2014-04-30','15:05:00',1.66),('8784','2014-04-30','15:10:00',1.78),('8784','2014-04-30','15:15:00',1.47),('8784','2014-04-30','15:20:00',1.37),('8784','2014-04-30','15:25:00',1.52),('8784','2014-04-30','15:30:00',1.92),('8784','2014-04-30','15:35:00',3.44),('8784','2014-04-30','15:40:00',4.88),('8784','2014-04-30','15:45:00',3.78),('8784','2014-04-30','15:50:00',4.18),('8784','2014-04-30','15:55:00',2.81),('8784','2014-04-30','16:00:00',1.59),('8784','2014-04-30','16:05:00',2.12),('8784','2014-04-30','16:10:00',2.26),('8784','2014-04-30','16:15:00',3.44),('8784','2014-04-30','16:20:00',2.1),('8784','2014-04-30','16:25:00',2.22),('8784','2014-04-30','16:30:00',2.19),('8784','2014-04-30','16:35:00',1.45),('8784','2014-04-30','16:40:00',2.68),('8784','2014-04-30','16:45:00',1.71),('8784','2014-04-30','16:50:00',2.67),('8784','2014-04-30','16:55:00',2.81),('8784','2014-04-30','17:00:00',2.13),('8784','2014-04-30','17:05:00',1.95),('8784','2014-04-30','17:15:00',1.02),('8784','2014-04-30','17:20:00',1.08),('8784','2014-04-30','17:35:00',1.12),('8784','2014-04-30','17:40:00',1.15),('8784','2014-03-07','11:20:00',1.02),('8784','2014-03-07','11:25:00',1.02),('8784','2014-03-07','11:30:00',1.12),('8784','2014-03-07','11:35:00',1.05),('8784','2014-03-07','11:45:00',2.02),('8784','2014-03-07','11:50:00',3.06),('8784','2014-03-07','11:55:00',3.84),('8784','2014-03-07','12:00:00',4.64),('8784','2014-03-07','12:05:00',3.77),('8784','2014-03-07','12:10:00',4.26),('8784','2014-03-07','12:15:00',4.12),('8784','2014-03-07','12:20:00',4.15),('8784','2014-03-07','12:25:00',4.12),('8784','2014-03-07','12:30:00',2.43),('8784','2014-03-07','12:35:00',3.75),('8784','2014-03-07','12:40:00',2.4),('8784','2014-03-07','12:45:00',1.02),('8784','2014-03-07','12:50:00',1.33),('8784','2014-03-07','13:00:00',3.19),('8784','2014-03-07','13:05:00',3.3),('8784','2014-03-07','13:10:00',1.61),('8784','2014-03-07','13:15:00',1.29),('8784','2014-03-07','13:20:00',2.49),('8784','2014-03-07','13:25:00',3.54),('8784','2014-03-07','13:30:00',3.37),('8784','2014-03-07','13:35:00',2.76),('8784','2014-03-07','13:40:00',2.8),('8784','2014-03-07','13:45:00',2.46),('8784','2014-03-07','13:50:00',1.61),('8784','2014-03-07','13:55:00',1.29),('8784','2014-03-07','14:00:00',1.23),('8784','2014-03-07','14:05:00',1.18),('8784','2014-03-07','14:10:00',1.2),('8784','2014-03-07','14:15:00',1.19),('8784','2014-03-07','14:20:00',1.16),('8784','2014-03-07','14:25:00',1.13),('8784','2014-03-07','14:30:00',1.19),('8784','2014-03-07','14:35:00',1.24),('8784','2014-03-07','14:40:00',1.31),('8784','2014-03-07','14:45:00',1.31),('8784','2014-03-07','14:50:00',1.67),('8784','2014-03-07','14:55:00',2.38),('8784','2014-03-07','15:00:00',2.83),('8784','2014-03-07','15:05:00',3.08),('8784','2014-03-07','15:10:00',3.08),('8784','2014-03-07','15:15:00',3.11),('8784','2014-03-07','15:20:00',3.11),('8784','2014-03-07','15:25:00',2.97),('8784','2014-03-07','15:30:00',2.84),('8784','2014-03-07','15:35:00',2.66),('8784','2014-03-07','15:40:00',1.97),('8784','2014-03-07','15:45:00',2.15),('8784','2014-03-07','15:50:00',1.67),('8784','2014-03-07','15:55:00',1.25),('8784','2014-03-07','16:00:00',1.78),('8784','2014-03-07','16:05:00',1.72),('8784','2014-03-07','16:10:00',1.65),('8784','2014-03-07','16:15:00',1.65),('8784','2014-03-07','16:20:00',1.48),('8784','2014-03-07','16:25:00',1.39),('8784','2014-03-07','16:30:00',1.27),('8784','2014-03-07','16:35:00',1.21),('8784','2014-03-07','16:40:00',1.25),('8784','2014-03-07','16:45:00',1.19),('8784','2014-03-07','16:50:00',1.12),('8784','2014-03-07','16:55:00',1.05),('8784','2014-03-06','08:00:00',1.39),('8784','2014-03-06','08:05:00',1.16),('8784','2014-03-06','08:10:00',1.46),('8784','2014-03-06','08:15:00',1.9),('8784','2014-03-06','08:20:00',1.77),('8784','2014-03-06','08:25:00',1.48),('8784','2014-03-06','08:45:00',1),('8784','2014-03-06','09:15:00',1.12),('8784','2014-03-06','09:20:00',1.22),('8784','2014-03-06','09:25:00',1.04),('8784','2014-03-06','09:30:00',1.05),('8784','2014-03-06','09:35:00',1.23),('8784','2014-03-06','09:40:00',1.38),('8784','2014-03-06','09:45:00',1.54),('8784','2014-03-06','09:50:00',1.75),('8784','2014-03-06','09:55:00',2.14),('8784','2014-03-06','10:00:00',2.24),('8784','2014-03-06','10:05:00',2.37),('8784','2014-03-06','10:10:00',2.58),('8784','2014-03-06','10:15:00',3.1),('8784','2014-03-06','10:20:00',3.06),('8784','2014-03-06','10:25:00',1.75),('8784','2014-03-06','10:30:00',1.05),('8784','2014-03-06','10:35:00',1.23),('8784','2014-03-06','10:40:00',2.41),('8784','2014-03-06','10:45:00',1.22),('8784','2014-03-06','10:50:00',1.76),('8784','2014-03-06','10:55:00',1.45),('8784','2014-03-06','11:00:00',2.91),('8784','2014-03-06','11:05:00',3.27),('8784','2014-03-06','11:10:00',2.86),('8784','2014-03-06','11:15:00',2.48),('8784','2014-03-06','11:20:00',2.36),('8784','2014-03-06','11:25:00',2.35),('8784','2014-03-06','11:30:00',1.66),('8784','2014-03-06','11:35:00',1.42),('8784','2014-03-06','11:40:00',1.79),('8784','2014-03-06','11:45:00',3.17),('8784','2014-03-06','11:50:00',3.44),('8784','2014-03-06','11:55:00',3.63),('8784','2014-03-06','12:00:00',1.55),('8784','2014-03-06','12:05:00',2.65),('8784','2014-03-06','12:10:00',3.97),('8784','2014-03-06','12:15:00',2.9),('8784','2014-03-06','12:20:00',1.42),('8784','2014-03-06','12:25:00',2.27),('8784','2014-03-06','12:30:00',4.11),('8784','2014-03-06','12:35:00',2.03),('8784','2014-03-06','12:40:00',1.54),('8784','2014-03-06','12:45:00',1.15),('8784','2014-03-06','12:50:00',1.13),('8784','2014-03-06','12:55:00',1.38),('8784','2014-03-06','13:00:00',1.68),('8784','2014-03-06','13:05:00',1.45),('8784','2014-03-06','13:10:00',1.35),('8784','2014-03-06','13:15:00',1.47),('8784','2014-03-06','13:20:00',1.21),('8784','2014-03-06','13:25:00',1.09),('8784','2014-03-06','13:30:00',1.2),('8784','2014-03-06','13:35:00',1.14),('8784','2014-03-06','13:40:00',1.26),('8784','2014-03-06','13:45:00',1.12),('8784','2014-03-06','13:50:00',1.01),('8784','2014-03-06','14:05:00',1.15),('8784','2014-03-06','14:10:00',1.17),('8784','2014-03-06','14:15:00',1.11),('8784','2014-03-06','14:20:00',1.34),('8784','2014-03-06','14:25:00',1.24),('8784','2014-03-06','14:30:00',1.14),('8784','2014-03-06','14:35:00',1.81),('8784','2014-03-06','14:40:00',1.35),('8784','2014-03-06','15:00:00',1.04),('8784','2014-03-06','15:05:00',1.33),('8784','2014-03-06','15:10:00',1.22),('8784','2014-03-05','07:40:00',1.08),('8784','2014-03-05','07:45:00',1.16),('8784','2014-03-05','07:50:00',1.23),('8784','2014-03-05','07:55:00',1.29),('8784','2014-03-05','08:00:00',1.29),('8784','2014-03-05','08:05:00',1.35),('8784','2014-03-05','08:10:00',1.48),('8784','2014-03-05','08:15:00',1.61),('8784','2014-03-05','08:30:00',1.04),('8784','2014-03-05','08:35:00',2.31),('8784','2014-03-05','08:40:00',2.03),('8784','2014-03-05','08:45:00',2.26),('8784','2014-03-05','08:50:00',1.5),('8784','2014-03-05','09:00:00',1.96),('8784','2014-03-05','09:05:00',2.1),('8784','2014-03-05','09:15:00',2.29),('8784','2014-03-05','09:20:00',2.55),('8784','2014-03-05','09:25:00',2.56),('8784','2014-03-05','09:30:00',2.61),('8784','2014-03-05','09:35:00',2.47),('8784','2014-03-05','09:40:00',2.75),('8784','2014-03-05','09:45:00',2.81),('8784','2014-03-05','09:50:00',2.86),('8784','2014-03-05','09:55:00',2.93),('8784','2014-03-05','10:00:00',2.99),('8784','2014-03-05','10:05:00',3.06),('8784','2014-03-05','10:10:00',3.15),('8784','2014-03-05','10:15:00',3.15),('8784','2014-03-05','10:20:00',3.12),('8784','2014-03-05','10:25:00',3.23),('8784','2014-03-05','10:30:00',3.26),('8784','2014-03-05','10:35:00',3.31),('8784','2014-03-05','10:40:00',3.33),('8784','2014-03-05','10:45:00',3.37),('8784','2014-03-05','10:50:00',3.41),('8784','2014-03-05','10:55:00',3.45),('8784','2014-03-05','11:00:00',3.51),('8784','2014-03-05','11:05:00',3.58),('8784','2014-03-05','11:10:00',3.6),('8784','2014-03-05','11:15:00',3.66),('8784','2014-03-05','11:20:00',3.7),('8784','2014-03-05','11:25:00',3.73),('8784','2014-03-05','11:30:00',3.79),('8784','2014-03-05','11:35:00',3.91),('8784','2014-03-05','11:40:00',3.85),('8784','2014-03-05','11:45:00',3.89),('8784','2014-03-05','11:50:00',3.83),('8784','2014-03-05','11:55:00',3.23),('8784','2014-03-05','12:00:00',3.44),('8784','2014-03-05','12:05:00',3.03),('8784','2014-03-05','12:10:00',2.04),('8784','2014-03-05','12:15:00',1.06),('8784','2014-03-05','12:30:00',1.29),('8784','2014-03-05','12:35:00',1.66),('8784','2014-03-05','12:40:00',1.81),('8784','2014-03-05','12:45:00',1.14),('8784','2014-03-05','12:50:00',1.55),('8784','2014-03-05','12:55:00',1.48),('8784','2014-03-05','13:00:00',1.99),('8784','2014-03-05','13:05:00',2.75),('8784','2014-03-05','13:10:00',3.34),('8784','2014-03-05','13:15:00',2.56),('8784','2014-03-05','13:20:00',2.28),('8784','2014-03-05','13:25:00',1.56),('8784','2014-03-05','13:30:00',1.29),('8784','2014-03-05','13:35:00',1.37),('8784','2014-03-05','13:40:00',1.64),('8784','2014-03-05','13:45:00',1.56),('8784','2014-03-05','13:50:00',1.33),('8784','2014-03-05','13:55:00',1.21),('8784','2014-03-05','14:00:00',1.13),('8784','2014-03-05','14:05:00',1.19),('8784','2014-03-05','14:10:00',1.14),('8784','2014-03-05','14:15:00',1.27),('8784','2014-03-05','14:20:00',1.33),('8784','2014-03-05','14:25:00',1.52),('8784','2014-03-05','14:30:00',1.51),('8784','2014-03-05','14:35:00',1.33),('8784','2014-03-05','14:40:00',1.72),('8784','2014-03-05','14:45:00',2.6),('8784','2014-03-05','14:50:00',2.84),('8784','2014-03-05','14:55:00',1.94),('8784','2014-03-05','15:00:00',1.01),('8784','2014-03-05','15:30:00',1.05),('8784','2014-03-05','15:35:00',1.23),('8784','2014-03-05','15:40:00',1.54),('8784','2014-03-05','15:45:00',1.93),('8784','2014-03-05','15:50:00',1.37),('8784','2014-03-05','15:55:00',2.03),('8784','2014-03-05','16:00:00',2.7),('8784','2014-03-05','16:05:00',2.39),('8784','2014-03-05','16:10:00',1.99),('8784','2014-03-05','16:15:00',1.43),('8784','2014-03-04','09:05:00',1.11),('8784','2014-03-04','09:10:00',1.36),('8784','2014-03-04','09:15:00',2.26),('8784','2014-03-04','09:20:00',2.25),('8784','2014-03-04','09:30:00',1.05),('8784','2014-03-04','09:35:00',1.04),('8784','2014-03-04','09:40:00',1.26),('8784','2014-03-04','09:45:00',1.14),('8784','2014-03-04','09:55:00',1.98),('8784','2014-03-04','10:00:00',1.41),('8784','2014-03-04','10:05:00',1.01),('8784','2014-03-04','10:20:00',1.02),('8784','2014-03-04','10:25:00',3.26),('8784','2014-03-04','10:30:00',2),('8784','2014-03-04','10:35:00',3.5),('8784','2014-03-04','10:40:00',4.06),('8784','2014-03-04','10:45:00',3.74),('8784','2014-03-04','10:50:00',1.07),('8784','2014-03-04','10:55:00',3.29),('8784','2014-03-04','11:00:00',2.1),('8784','2014-03-04','11:05:00',2.37),('8784','2014-03-04','11:10:00',4),('8784','2014-03-04','11:15:00',4.53),('8784','2014-03-04','11:20:00',2.69),('8784','2014-03-04','11:25:00',1.11),('8784','2014-03-04','11:30:00',1.12),('8784','2014-03-04','11:40:00',1),('8784','2014-03-04','11:45:00',2.01),('8784','2014-03-04','11:50:00',4.78),('8784','2014-03-04','11:55:00',4.07),('8784','2014-03-04','12:00:00',3.94),('8784','2014-03-04','12:05:00',3.83),('8784','2014-03-04','12:10:00',3.82),('8784','2014-03-04','12:15:00',3.78),('8784','2014-03-04','12:20:00',3.79),('8784','2014-03-04','12:25:00',3.78),('8784','2014-03-04','12:30:00',3.72),('8784','2014-03-04','12:35:00',3.71),('8784','2014-03-04','12:40:00',3.72),('8784','2014-03-04','12:45:00',2.5),('8784','2014-03-04','12:50:00',3.33),('8784','2014-03-04','12:55:00',2.34),('8784','2014-03-04','13:00:00',3.81),('8784','2014-03-04','13:05:00',3.24),('8784','2014-03-04','13:10:00',4.04),('8784','2014-03-04','13:15:00',2.42),('8784','2014-03-04','13:20:00',1.8),('8784','2014-03-04','13:25:00',1.05),('8784','2014-03-04','13:30:00',1.12),('8784','2014-03-04','13:45:00',1.23),('8784','2014-03-04','13:50:00',1.36),('8784','2014-03-04','13:55:00',1.19),('8784','2014-03-04','14:05:00',1.69),('8784','2014-03-04','14:10:00',2.42),('8784','2014-03-04','14:15:00',3.43),('8784','2014-03-04','14:20:00',1.89),('8784','2014-03-04','14:25:00',3.44),('8784','2014-03-04','14:30:00',3.03),('8784','2014-03-04','14:35:00',2.89),('8784','2014-03-04','14:40:00',2.82),('8784','2014-03-04','14:45:00',2.65),('8784','2014-03-04','14:50:00',2.99),('8784','2014-03-04','14:55:00',1.87),('8784','2014-03-04','15:00:00',2.81),('8784','2014-03-04','15:05:00',2.59),('8784','2014-03-04','15:10:00',2.41),('8784','2014-03-04','15:15:00',2.09),('8784','2014-03-04','15:20:00',1.23),('8784','2014-03-04','15:25:00',1.92),('8784','2014-03-04','15:30:00',1.03),('8784','2014-03-04','15:35:00',2.56),('8784','2014-03-04','15:40:00',2.12),('8784','2014-03-04','15:45:00',1.66),('8784','2014-03-04','15:50:00',1.49),('8784','2014-03-04','16:20:00',1.03),('8784','2014-03-04','16:25:00',1.24),('8784','2014-03-03','08:10:00',1.21),('8784','2014-03-03','08:15:00',1.35),('8784','2014-03-03','08:20:00',1.43),('8784','2014-03-03','08:25:00',1.52),('8784','2014-03-03','08:30:00',1.61),('8784','2014-03-03','08:35:00',1.69),('8784','2014-03-03','08:40:00',1.8),('8784','2014-03-03','08:45:00',1.89),('8784','2014-03-03','08:50:00',1.84),('8784','2014-03-03','08:55:00',2.08),('8784','2014-03-03','09:00:00',2.12),('8784','2014-03-03','09:05:00',2.11),('8784','2014-03-03','09:10:00',1.96),('8784','2014-03-03','09:15:00',2.07),('8784','2014-03-03','09:20:00',2.29),('8784','2014-03-03','09:25:00',2.48),('8784','2014-03-03','09:30:00',2.52),('8784','2014-03-03','09:35:00',2.27),('8784','2014-03-03','09:40:00',1.99),('8784','2014-03-03','09:45:00',2.24),('8784','2014-03-03','09:50:00',2.29),('8784','2014-03-03','09:55:00',2.56),('8784','2014-03-03','10:00:00',2.79),('8784','2014-03-03','10:05:00',2.95),('8784','2014-03-03','10:10:00',2.97),('8784','2014-03-03','10:15:00',3.05),('8784','2014-03-03','10:20:00',3.1),('8784','2014-03-03','10:25:00',3.11),('8784','2014-03-03','10:30:00',3.16),('8784','2014-03-03','10:35:00',3.19),('8784','2014-03-03','10:40:00',3.23),('8784','2014-03-03','10:45:00',3.28),('8784','2014-03-03','10:50:00',3.28),('8784','2014-03-03','10:55:00',3.32),('8784','2014-03-03','11:00:00',3.37),('8784','2014-03-03','11:05:00',3.41),('8784','2014-03-03','11:10:00',3.42),('8784','2014-03-03','11:15:00',3.43),('8784','2014-03-03','11:20:00',3.48),('8784','2014-03-03','11:25:00',3.5),('8784','2014-03-03','11:30:00',3.39),('8784','2014-03-03','11:35:00',1.92),('8784','2014-03-03','11:40:00',3.73),('8784','2014-03-03','11:45:00',3.66),('8784','2014-03-03','11:50:00',3.72),('8784','2014-03-03','11:55:00',3.7),('8784','2014-03-03','12:00:00',3.69),('8784','2014-03-03','12:05:00',3.73),('8784','2014-03-03','12:10:00',3.73),('8784','2014-03-03','12:15:00',3.72),('8784','2014-03-03','12:20:00',3.72),('8784','2014-03-03','12:25:00',3.71),('8784','2014-03-03','12:30:00',3.71),('8784','2014-03-03','12:35:00',3.71),('8784','2014-03-03','12:40:00',3.69),('8784','2014-03-03','12:45:00',3.68),('8784','2014-03-03','12:50:00',3.65),('8784','2014-03-03','12:55:00',3.64),('8784','2014-03-03','13:00:00',3.6),('8784','2014-03-03','13:05:00',3.58),('8784','2014-03-03','13:10:00',3.56),('8784','2014-03-03','13:15:00',3.54),('8784','2014-03-03','13:20:00',3.54),('8784','2014-03-03','13:25:00',3.44),('8784','2014-03-03','13:30:00',3.5),('8784','2014-03-03','13:35:00',3.46),('8784','2014-03-03','13:40:00',3.41),('8784','2014-03-03','13:45:00',3.37),('8784','2014-03-03','13:50:00',3.36),('8784','2014-03-03','13:55:00',3.3),('8784','2014-03-03','14:00:00',3.26),('8784','2014-03-03','14:05:00',3.22),('8784','2014-03-03','14:10:00',3.21),('8784','2014-03-03','14:15:00',3.18),('8784','2014-03-03','14:20:00',3),('8784','2014-03-03','14:25:00',2.52),('8784','2014-03-03','14:30:00',2.94),('8784','2014-03-03','14:35:00',2.88),('8784','2014-03-03','14:40:00',2.8),('8784','2014-03-03','14:45:00',2.72),('8784','2014-03-03','14:50:00',2.65),('8784','2014-03-03','14:55:00',2.6),('8784','2014-03-03','15:00:00',2.49),('8784','2014-03-03','15:05:00',2.43),('8784','2014-03-03','15:10:00',2.35),('8784','2014-03-03','15:15:00',2.3),('8784','2014-03-03','15:20:00',2.23),('8784','2014-03-03','15:25:00',2.17),('8784','2014-03-03','15:30:00',2.09),('8784','2014-03-03','15:35:00',2.01),('8784','2014-03-03','15:40:00',1.91),('8784','2014-03-03','15:45:00',1.83),('8784','2014-03-03','15:50:00',1.73),('8784','2014-03-03','15:55:00',1.64),('8784','2014-03-03','16:00:00',1.55),('8784','2014-03-03','16:05:00',1.46),('8784','2014-03-03','16:10:00',1.36),('8784','2014-03-03','16:15:00',1.29),('8784','2014-03-03','16:20:00',1.21),('8784','2014-03-03','16:25:00',1.12),('8784','2014-03-03','16:30:00',1.03),('8784','2014-03-02','08:05:00',1.19),('8784','2014-03-02','08:10:00',1.78),('8784','2014-03-02','08:15:00',1.66),('8784','2014-03-02','08:20:00',1.68),('8784','2014-03-02','08:25:00',1.55),('8784','2014-03-02','08:30:00',1.56),('8784','2014-03-02','08:35:00',1.64),('8784','2014-03-02','08:40:00',1.74),('8784','2014-03-02','08:45:00',1.83),('8784','2014-03-02','08:50:00',1.91),('8784','2014-03-02','08:55:00',2.01),('8784','2014-03-02','09:00:00',2.1),('8784','2014-03-02','09:05:00',2.19),('8784','2014-03-02','09:10:00',2.33),('8784','2014-03-02','09:15:00',2.41),('8784','2014-03-02','09:20:00',1.83),('8784','2014-03-02','09:25:00',2.67),('8784','2014-03-02','09:30:00',2.79),('8784','2014-03-02','09:35:00',2.77),('8784','2014-03-02','09:40:00',2.25),('8784','2014-03-02','09:55:00',1.23),('8784','2014-03-02','10:00:00',1.64),('8784','2014-03-02','10:05:00',1.66),('8784','2014-03-02','10:10:00',1.47),('8784','2014-03-02','10:15:00',1.34),('8784','2014-03-02','10:20:00',1.36),('8784','2014-03-02','10:25:00',1.6),('8784','2014-03-02','10:30:00',1.66),('8784','2014-03-02','10:35:00',2.76),('8784','2014-03-02','10:40:00',2.37),('8784','2014-03-02','10:45:00',1.04),('8784','2014-03-02','10:50:00',1.55),('8784','2014-03-02','10:55:00',1.35),('8784','2014-03-02','11:00:00',3.15),('8784','2014-03-02','11:05:00',2.9),('8784','2014-03-02','11:10:00',1.79),('8784','2014-03-02','11:15:00',1.32),('8784','2014-03-02','11:20:00',1.85),('8784','2014-03-02','11:25:00',1.98),('8784','2014-03-02','11:30:00',2.26),('8784','2014-03-02','11:35:00',3.01),('8784','2014-03-02','11:40:00',2.61),('8784','2014-03-02','11:45:00',4.67),('8784','2014-03-02','11:50:00',4.44),('8784','2014-03-02','11:55:00',3.99),('8784','2014-03-02','12:00:00',2.79),('8784','2014-03-02','12:05:00',2.02),('8784','2014-03-02','12:10:00',1.88),('8784','2014-03-02','12:15:00',2.83),('8784','2014-03-02','12:20:00',2.39),('8784','2014-03-02','12:25:00',2.36),('8784','2014-03-02','12:30:00',1.5),('8784','2014-03-02','12:35:00',1.21),('8784','2014-03-02','12:50:00',1.13),('8784','2014-03-02','12:55:00',1.37),('8784','2014-03-02','13:00:00',1.57),('8784','2014-03-02','13:05:00',1.66),('8784','2014-03-02','13:10:00',1.63),('8784','2014-03-02','13:15:00',1.47),('8784','2014-03-02','13:20:00',1.38),('8784','2014-03-02','13:25:00',1.29),('8784','2014-03-02','13:30:00',1.2),('8784','2014-03-02','13:35:00',1.05),('8784','2014-03-02','13:50:00',1.06),('8784','2014-03-02','13:55:00',1.11),('8784','2014-03-02','14:00:00',1.34),('8784','2014-03-02','14:05:00',1.47),('8784','2014-03-02','14:10:00',1.42),('8784','2014-03-02','14:15:00',1.37),('8784','2014-03-02','14:20:00',1.26),('8784','2014-03-02','14:25:00',1.27),('8784','2014-03-02','14:30:00',1.31),('8784','2014-03-02','14:35:00',1.3),('8784','2014-03-02','14:40:00',1.29),('8784','2014-03-02','14:45:00',1.34),('8784','2014-03-02','14:50:00',1.33),('8784','2014-03-02','14:55:00',1.31),('8784','2014-03-02','15:00:00',1.35),('8784','2014-03-02','15:05:00',1.44),('8784','2014-03-02','15:10:00',1.45),('8784','2014-03-02','15:15:00',1.42),('8784','2014-03-02','15:20:00',1.41),('8784','2014-03-02','15:25:00',1.44),('8784','2014-03-02','15:30:00',1.42),('8784','2014-03-02','15:35:00',1.4),('8784','2014-03-02','15:40:00',1.4),('8784','2014-03-02','15:45:00',1.2),('8784','2014-03-02','15:50:00',1.09),('8784','2014-02-28','08:00:00',1.27),('8784','2014-02-28','08:05:00',1.03),('8784','2014-02-28','08:15:00',1.14),('8784','2014-02-28','08:20:00',1.64),('8784','2014-02-28','08:25:00',1.28),('8784','2014-02-28','08:35:00',2.08),('8784','2014-02-28','09:15:00',1.2),('8784','2014-02-28','09:20:00',1.29),('8784','2014-02-28','09:25:00',1.46),('8784','2014-02-28','09:30:00',1.75),('8784','2014-02-28','09:40:00',2.33),('8784','2014-02-28','09:45:00',2.84),('8784','2014-02-28','09:50:00',3.3),('8784','2014-02-28','09:55:00',2.34),('8784','2014-02-28','10:00:00',1.21),('8784','2014-02-28','10:05:00',1.22),('8784','2014-02-28','10:10:00',1.63),('8784','2014-02-28','10:15:00',1.21),('8784','2014-02-28','10:20:00',1.94),('8784','2014-02-28','10:25:00',3.02),('8784','2014-02-28','10:30:00',3.66),('8784','2014-02-28','10:35:00',2.67),('8784','2014-02-28','10:40:00',1.29),('8784','2014-02-28','11:15:00',1.13),('8784','2014-02-28','11:20:00',1.48),('8784','2014-02-28','11:25:00',1.46),('8784','2014-02-28','11:30:00',1.19),('8784','2014-02-28','11:45:00',1.01),('8784','2014-02-28','11:50:00',1.16),('8784','2014-02-28','11:55:00',1.23),('8784','2014-02-28','12:00:00',1.57),('8784','2014-02-28','12:05:00',2.3),('8784','2014-02-28','12:10:00',2.04),('8784','2014-02-28','12:15:00',1.14),('8784','2014-02-28','12:20:00',1.04),('8784','2014-02-28','12:25:00',1.98),('8784','2014-02-28','12:30:00',2.14),('8784','2014-02-28','12:35:00',3.75),('8784','2014-02-28','12:40:00',2.65),('8784','2014-02-28','12:45:00',1.33),('8784','2014-02-28','12:50:00',3.12),('8784','2014-02-28','12:55:00',1.93),('8784','2014-02-28','13:00:00',2.53),('8784','2014-02-28','13:05:00',1.85),('8784','2014-02-28','13:10:00',1.71),('8784','2014-02-28','13:15:00',1.17),('8784','2014-02-28','13:45:00',1.1),('8784','2014-02-28','13:50:00',4.34),('8784','2014-02-28','13:55:00',2.16),('8784','2014-02-28','14:00:00',1.42),('8784','2014-02-28','14:15:00',1.16),('8784','2014-02-28','14:20:00',1.48),('8784','2014-02-28','14:25:00',2.35),('8784','2014-02-28','14:30:00',1.93),('8784','2014-02-28','14:35:00',1.54),('8784','2014-02-28','14:40:00',1.41),('8784','2014-02-28','14:45:00',1.33),('8784','2014-02-28','14:50:00',1.45),('8784','2014-02-28','14:55:00',1.57),('8784','2014-02-28','15:00:00',2.31),('8784','2014-02-28','15:05:00',1.46),('8784','2014-02-28','15:25:00',2.27),('8784','2014-02-28','15:30:00',2.05),('8784','2014-02-28','15:35:00',1.93),('8784','2014-02-28','15:40:00',1.86),('8784','2014-02-28','16:10:00',1.09),('8784','2014-02-28','16:15:00',1.8),('8784','2014-02-28','16:20:00',1.47),('8784','2014-02-28','16:40:00',1.16),('8784','2014-02-28','16:45:00',1.34),('8784','2014-02-28','16:50:00',1.15),('8784','2014-02-27','10:35:00',1.07),('8784','2014-02-27','10:40:00',1.26),('8784','2014-02-27','10:45:00',1.36),('8784','2014-02-27','10:50:00',1.41),('8784','2014-02-27','10:55:00',1.48),('8784','2014-02-27','11:00:00',1.69),('8784','2014-02-27','11:05:00',1.84),('8784','2014-02-27','11:10:00',1.72),('8784','2014-02-27','11:15:00',1.69),('8784','2014-02-27','11:20:00',1.55),('8784','2014-02-27','11:25:00',1.74),('8784','2014-02-27','11:30:00',2.06),('8784','2014-02-27','11:35:00',1.9),('8784','2014-02-27','11:40:00',1.62),('8784','2014-02-27','11:45:00',1.39),('8784','2014-02-27','11:50:00',1.36),('8784','2014-02-27','11:55:00',1.42),('8784','2014-02-27','12:00:00',1.39),('8784','2014-02-27','12:05:00',1.36),('8784','2014-02-27','12:10:00',1.26),('8784','2014-02-27','12:15:00',1.36),('8784','2014-02-27','12:20:00',1.43),('8784','2014-02-27','12:25:00',1.44),('8784','2014-02-27','12:30:00',1.35),('8784','2014-02-27','12:35:00',1.32),('8784','2014-02-27','12:40:00',1.29),('8784','2014-02-27','12:45:00',1.28),('8784','2014-02-27','12:50:00',1.26),('8784','2014-02-27','12:55:00',1.28),('8784','2014-02-27','13:00:00',1.35),('8784','2014-02-27','13:05:00',1.21),('8784','2014-02-27','13:10:00',1.27),('8784','2014-02-27','13:15:00',1.39),('8784','2014-02-27','13:20:00',1.4),('8784','2014-02-27','13:25:00',1.48),('8784','2014-02-27','13:30:00',1.67),('8784','2014-02-27','13:35:00',1.79),('8784','2014-02-27','13:40:00',1.83),('8784','2014-02-27','13:45:00',1.82),('8784','2014-02-27','13:50:00',1.83),('8784','2014-02-27','13:55:00',2.05),('8784','2014-02-27','14:00:00',2.07),('8784','2014-02-27','14:05:00',1.81),('8784','2014-02-27','14:10:00',1.62),('8784','2014-02-27','14:15:00',1.53),('8784','2014-02-27','14:20:00',1.54),('8784','2014-02-27','14:25:00',1.53),('8784','2014-02-27','14:30:00',1.57),('8784','2014-02-27','14:35:00',1.5),('8784','2014-02-27','14:40:00',1.34),('8784','2014-02-27','14:45:00',1.39),('8784','2014-02-27','14:50:00',1.32),('8784','2014-02-27','14:55:00',1.21),('8784','2014-02-27','15:00:00',1.26),('8784','2014-02-27','15:05:00',1.24),('8784','2014-02-27','15:10:00',1.27),('8784','2014-02-27','15:15:00',1.42),('8784','2014-02-27','15:20:00',1.52),('8784','2014-02-27','15:25:00',1.35),('8784','2014-02-27','15:30:00',1.33),('8784','2014-02-27','15:35:00',1.3),('8784','2014-02-27','15:40:00',1.06),('8784','2014-02-27','16:45:00',1.1),('8784','2014-02-27','16:50:00',1.17),('8784','2014-02-27','16:55:00',1.06),('8784','2014-02-26','08:10:00',1.1),('8784','2014-02-26','08:15:00',1.2),('8784','2014-02-26','08:20:00',1.28),('8784','2014-02-26','08:25:00',1.36),('8784','2014-02-26','08:30:00',1.38),('8784','2014-02-26','08:35:00',1.56),('8784','2014-02-26','08:40:00',1.68),('8784','2014-02-26','08:45:00',1.92),('8784','2014-02-26','08:50:00',1.87),('8784','2014-02-26','08:55:00',1.88),('8784','2014-02-26','09:00:00',1.9),('8784','2014-02-26','09:05:00',1.91),('8784','2014-02-26','09:10:00',1.97),('8784','2014-02-26','09:15:00',2.1),('8784','2014-02-26','09:20:00',2.22),('8784','2014-02-26','09:25:00',2.23),('8784','2014-02-26','09:30:00',2.16),('8784','2014-02-26','09:35:00',1.87),('8784','2014-02-26','09:40:00',1.99),('8784','2014-02-26','09:45:00',1.83),('8784','2014-02-26','09:50:00',1.9),('8784','2014-02-26','09:55:00',1.35),('8784','2014-02-26','10:00:00',1.35),('8784','2014-02-26','10:05:00',1.07),('8784','2014-02-26','10:20:00',1.01),('8784','2014-02-26','11:00:00',1.07),('8784','2014-02-26','11:05:00',1.12),('8784','2014-02-26','11:10:00',1.11),('8784','2014-02-26','11:15:00',1.08),('8784','2014-02-26','11:50:00',1.11),('8784','2014-02-26','11:55:00',1.22),('8784','2014-02-26','12:00:00',1.44),('8784','2014-02-26','12:05:00',1.73),('8784','2014-02-26','12:10:00',1.45),('8784','2014-02-26','12:15:00',1.26),('8784','2014-02-26','12:20:00',1.37),('8784','2014-02-26','12:25:00',1.9),('8784','2014-02-26','12:30:00',2.33),('8784','2014-02-26','12:35:00',2.64),('8784','2014-02-26','12:40:00',3.81),('8784','2014-02-26','12:45:00',2.9),('8784','2014-02-26','12:50:00',3.37),('8784','2014-02-26','12:55:00',3.55),('8784','2014-02-26','13:00:00',2.76),('8784','2014-02-26','13:05:00',2.84),('8784','2014-02-26','13:10:00',3.01),('8784','2014-02-26','13:15:00',2.9),('8784','2014-02-26','13:20:00',2.64),('8784','2014-02-26','13:25:00',3.09),('8784','2014-02-26','13:30:00',3.73),('8784','2014-02-26','13:35:00',3.07),('8784','2014-02-26','13:40:00',3.38),('8784','2014-02-26','13:45:00',2.18),('8784','2014-02-26','13:50:00',1.46),('8784','2014-02-26','13:55:00',2.52),('8784','2014-02-26','14:00:00',3.48),('8784','2014-02-26','14:05:00',1.88),('8784','2014-02-26','14:10:00',1.82),('8784','2014-02-26','14:15:00',2.64),('8784','2014-02-26','14:20:00',2.77),('8784','2014-02-26','14:25:00',3.04),('8784','2014-02-26','14:30:00',1.1),('8784','2014-02-26','14:35:00',2.6),('8784','2014-02-26','14:40:00',2.92),('8784','2014-02-26','14:45:00',2.71),('8784','2014-02-26','14:50:00',2.48),('8784','2014-02-26','14:55:00',2.64),('8784','2014-02-26','15:00:00',2.12),('8784','2014-02-26','15:05:00',2.26),('8784','2014-02-26','15:10:00',2.02),('8784','2014-02-26','15:15:00',1.9),('8784','2014-02-26','15:20:00',1.44),('8784','2014-02-26','15:25:00',1.06),('8784','2014-02-26','15:30:00',1.19),('8784','2014-02-26','15:35:00',1.56),('8784','2014-02-26','15:40:00',1.58),('8784','2014-02-26','15:45:00',1.24),('8784','2014-02-26','15:50:00',1.25),('8784','2014-02-26','15:55:00',1.45),('8784','2014-02-26','16:00:00',1.67),('8784','2014-02-26','16:05:00',1.48),('8784','2014-04-29','09:50:00',1.13),('8784','2014-04-29','09:55:00',1.24),('8784','2014-04-29','10:00:00',1.27),('8784','2014-04-29','10:05:00',2.25),('8784','2014-04-29','10:10:00',4.41),('8784','2014-04-29','10:15:00',3.25),('8784','2014-04-29','10:20:00',3.13),('8784','2014-04-29','10:25:00',4.15),('8784','2014-04-29','10:30:00',3.91),('8784','2014-04-29','10:35:00',4.03),('8784','2014-04-29','10:40:00',4.02),('8784','2014-04-29','10:45:00',4.09),('8784','2014-04-29','10:50:00',4.19),('8784','2014-04-29','10:55:00',3.92),('8784','2014-04-29','11:00:00',4.12),('8784','2014-04-29','11:05:00',4.12),('8784','2014-04-29','11:10:00',3.96),('8784','2014-04-29','11:15:00',5.12),('8784','2014-04-29','11:20:00',3.22),('8784','2014-04-29','11:25:00',3.43),('8784','2014-04-29','11:30:00',2.44),('8784','2014-04-29','11:35:00',2.97),('8784','2014-04-29','11:40:00',3.85),('8784','2014-04-29','11:45:00',1.79),('8784','2014-04-29','11:50:00',1.19),('8784','2014-04-29','11:55:00',1.19),('8784','2014-04-29','12:00:00',1.63),('8784','2014-04-29','12:05:00',1.84),('8784','2014-04-29','12:10:00',1.88),('8784','2014-04-29','12:15:00',1.76),('8784','2014-04-29','12:20:00',2.88),('8784','2014-04-29','12:25:00',2.17),('8784','2014-04-29','12:30:00',1.67),('8784','2014-04-29','12:35:00',1.92),('8784','2014-04-29','12:40:00',1.99),('8784','2014-04-29','12:45:00',3.45),('8784','2014-04-29','12:50:00',2.56),('8784','2014-04-29','12:55:00',1.87),('8784','2014-04-29','13:00:00',2.41),('8784','2014-04-29','13:05:00',2.73),('8784','2014-04-29','13:10:00',2.43),('8784','2014-04-29','13:15:00',2.57),('8784','2014-04-29','13:20:00',3.93),('8784','2014-04-29','13:25:00',3.11),('8784','2014-04-29','13:30:00',3.04),('8784','2014-04-29','13:35:00',1.62),('8784','2014-04-29','13:40:00',1.74),('8784','2014-04-29','13:45:00',3.62),('8784','2014-04-29','13:50:00',3.08),('8784','2014-04-29','13:55:00',1.08),('8784','2014-04-29','15:05:00',1.03),('8784','2014-04-29','16:20:00',1.02),('8784','2014-04-29','16:25:00',1.09),('8784','2014-04-29','17:00:00',1),('8784','2014-04-29','17:05:00',1.28),('8784','2014-04-29','17:10:00',1.2),('8784','2014-04-29','17:20:00',1.38),('8784','2014-04-29','17:25:00',1.35),('8784','2014-04-29','17:30:00',1.86),('8784','2014-04-29','17:35:00',1.29),('8784','2014-04-29','17:40:00',1.98),('8784','2014-04-29','17:45:00',1.99),('8784','2014-02-25','08:10:00',1.01),('8784','2014-02-25','08:15:00',1.1),('8784','2014-02-25','08:20:00',1.17),('8784','2014-02-25','08:25:00',1.26),('8784','2014-02-25','08:30:00',1.31),('8784','2014-02-25','08:35:00',1.41),('8784','2014-02-25','08:40:00',1.49),('8784','2014-02-25','08:45:00',1.58),('8784','2014-02-25','08:50:00',1.67),('8784','2014-02-25','08:55:00',1.75),('8784','2014-02-25','09:00:00',1.84),('8784','2014-02-25','09:05:00',1.91),('8784','2014-02-25','09:10:00',1.98),('8784','2014-02-25','09:15:00',2.05),('8784','2014-02-25','09:20:00',2.12),('8784','2014-02-25','09:25:00',2.18),('8784','2014-02-25','09:30:00',2.24),('8784','2014-02-25','09:35:00',2.29),('8784','2014-02-25','09:40:00',2.37),('8784','2014-02-25','09:45:00',2.45),('8784','2014-02-25','09:50:00',2.49),('8784','2014-02-25','09:55:00',2.56),('8784','2014-02-25','10:00:00',2.59),('8784','2014-02-25','10:05:00',2.65),('8784','2014-02-25','10:10:00',2.69),('8784','2014-02-25','10:15:00',2.76),('8784','2014-02-25','10:20:00',2.83),('8784','2014-02-25','10:25:00',2.87),('8784','2014-02-25','10:30:00',2.88),('8784','2014-02-25','10:35:00',2.98),('8784','2014-02-25','10:40:00',3.01),('8784','2014-02-25','10:45:00',3.03),('8784','2014-02-25','10:50:00',3.06),('8784','2014-02-25','10:55:00',3.07),('8784','2014-02-25','11:00:00',3.11),('8784','2014-02-25','11:05:00',3.08),('8784','2014-02-25','11:10:00',3.14),('8784','2014-02-25','11:15:00',3.19),('8784','2014-02-25','11:20:00',3.21),('8784','2014-02-25','11:25:00',3.21),('8784','2014-02-25','11:30:00',3.22),('8784','2014-02-25','11:35:00',3.26),('8784','2014-02-25','11:40:00',3.27),('8784','2014-02-25','11:45:00',3.24),('8784','2014-02-25','11:50:00',3.23),('8784','2014-02-25','11:55:00',3.29),('8784','2014-02-25','12:00:00',3.32),('8784','2014-02-25','12:05:00',3.32),('8784','2014-02-25','12:10:00',3.32),('8784','2014-02-25','12:15:00',3.33),('8784','2014-02-25','12:20:00',3.32),('8784','2014-02-25','12:25:00',3.38),('8784','2014-02-25','12:30:00',3.35),('8784','2014-02-25','12:35:00',3.34),('8784','2014-02-25','12:40:00',3.33),('8784','2014-02-25','12:45:00',3.29),('8784','2014-02-25','12:50:00',3.31),('8784','2014-02-25','12:55:00',3.3),('8784','2014-02-25','13:00:00',3.22),('8784','2014-02-25','13:05:00',3.14),('8784','2014-02-25','13:10:00',2.66),('8784','2014-02-25','13:20:00',1.04),('8784','2014-02-25','13:35:00',1.19),('8784','2014-02-25','13:40:00',1.38),('8784','2014-02-25','13:45:00',1.25),('8784','2014-02-25','13:50:00',1.09),('8784','2014-02-25','13:55:00',1.3),('8784','2014-02-25','14:00:00',1.36),('8784','2014-02-25','14:05:00',1.17),('8784','2014-02-25','14:10:00',1.12),('8784','2014-02-25','14:15:00',1.17),('8784','2014-02-25','14:20:00',1.75),('8784','2014-02-25','14:25:00',1.92),('8784','2014-02-25','14:30:00',2.27),('8784','2014-02-25','14:35:00',2.01),('8784','2014-02-25','14:40:00',2.42),('8784','2014-02-25','14:45:00',2.65),('8784','2014-02-25','14:50:00',2.16),('8784','2014-02-25','14:55:00',1.68),('8784','2014-02-25','15:00:00',2.18),('8784','2014-02-25','15:05:00',2.21),('8784','2014-02-25','15:10:00',2.15),('8784','2014-02-25','15:15:00',2.03),('8784','2014-02-25','15:20:00',1.94),('8784','2014-02-25','15:25:00',1.67),('8784','2014-02-25','15:30:00',1.53),('8784','2014-02-25','15:35:00',1.42),('8784','2014-02-25','15:40:00',1.48),('8784','2014-02-25','15:45:00',1.01),('8784','2014-02-24','08:05:00',1.12),('8784','2014-02-24','08:10:00',1.23),('8784','2014-02-24','08:15:00',1.37),('8784','2014-02-24','08:20:00',1.48),('8784','2014-02-24','08:25:00',1.58),('8784','2014-02-24','08:30:00',1.56),('8784','2014-02-24','08:35:00',1.48),('8784','2014-02-24','08:40:00',1.12),('8784','2014-02-24','08:45:00',1.55),('8784','2014-02-24','08:50:00',1.74),('8784','2014-02-24','08:55:00',1.79),('8784','2014-02-24','09:00:00',1.81),('8784','2014-02-24','09:05:00',1.87),('8784','2014-02-24','09:10:00',1.95),('8784','2014-02-24','09:15:00',2.02),('8784','2014-02-24','09:20:00',2.08),('8784','2014-02-24','09:25:00',2.15),('8784','2014-02-24','09:30:00',2.24),('8784','2014-02-24','09:35:00',2.33),('8784','2014-02-24','09:40:00',2.39),('8784','2014-02-24','09:45:00',2.45),('8784','2014-02-24','09:50:00',2.51),('8784','2014-02-24','09:55:00',2.57),('8784','2014-02-24','10:00:00',2.64),('8784','2014-02-24','10:05:00',2.7),('8784','2014-02-24','10:10:00',2.75),('8784','2014-02-24','10:15:00',2.8),('8784','2014-02-24','10:20:00',2.88),('8784','2014-02-24','10:25:00',2.94),('8784','2014-02-24','10:30:00',2.98),('8784','2014-02-24','10:35:00',3.02),('8784','2014-02-24','10:40:00',3.05),('8784','2014-02-24','10:45:00',3.08),('8784','2014-02-24','10:50:00',3.15),('8784','2014-02-24','10:55:00',3.18),('8784','2014-02-24','11:00:00',3.19),('8784','2014-02-24','11:05:00',3.23),('8784','2014-02-24','11:10:00',3.27),('8784','2014-02-24','11:15:00',3.3),('8784','2014-02-24','11:20:00',3.32),('8784','2014-02-24','11:25:00',3.43),('8784','2014-02-24','11:30:00',3.82),('8784','2014-02-24','11:35:00',2.52),('8784','2014-02-24','11:40:00',3.01),('8784','2014-02-24','11:45:00',3.25),('8784','2014-02-24','11:50:00',3.19),('8784','2014-02-24','11:55:00',2.6),('8784','2014-02-24','12:00:00',3.35),('8784','2014-02-24','12:05:00',3.52),('8784','2014-02-24','12:10:00',3.44),('8784','2014-02-24','12:15:00',3.5),('8784','2014-02-24','12:20:00',3.07),('8784','2014-02-24','12:25:00',3.03),('8784','2014-02-24','12:30:00',1.15),('8784','2014-02-24','12:35:00',3.27),('8784','2014-02-24','12:40:00',3.92),('8784','2014-02-24','12:45:00',3.76),('8784','2014-02-24','12:50:00',3.65),('8784','2014-02-24','12:55:00',3.35),('8784','2014-02-24','13:00:00',3.24),('8784','2014-02-24','13:05:00',2.78),('8784','2014-02-24','13:10:00',4.19),('8784','2014-02-24','13:15:00',2.4),('8784','2014-02-24','13:20:00',1.23),('8784','2014-02-24','14:10:00',1.07),('8784','2014-02-24','14:15:00',1.08),('8784','2014-02-24','14:20:00',1.05),('8784','2014-02-24','14:25:00',1.07),('8784','2014-02-24','14:30:00',1.11),('8784','2014-02-24','14:35:00',1.09),('8784','2014-02-24','14:40:00',1.06),('8784','2014-02-24','14:45:00',1.12),('8784','2014-02-24','14:50:00',1.08),('8784','2014-02-24','15:15:00',1.05),('8784','2014-02-24','15:20:00',1.17),('8784','2014-02-24','15:25:00',1.24),('8784','2014-02-24','15:30:00',1.02),('8784','2014-02-24','15:35:00',2.22),('8784','2014-02-24','15:40:00',2.29),('8784','2014-02-24','15:45:00',2.16),('8784','2014-02-24','15:50:00',2),('8784','2014-02-24','15:55:00',1.84),('8784','2014-02-24','16:00:00',1.97),('8784','2014-02-24','16:05:00',1.89),('8784','2014-02-24','16:10:00',1.76),('8784','2014-02-24','16:15:00',1.58),('8784','2014-02-24','16:20:00',1.3),('8784','2014-02-24','16:25:00',1.04),('8784','2014-02-23','08:15:00',1.02),('8784','2014-02-23','08:20:00',1.1),('8784','2014-02-23','08:25:00',1.16),('8784','2014-02-23','08:30:00',1.27),('8784','2014-02-23','08:35:00',1.36),('8784','2014-02-23','08:40:00',1.45),('8784','2014-02-23','08:45:00',1.53),('8784','2014-02-23','08:50:00',1.62),('8784','2014-02-23','08:55:00',1.69),('8784','2014-02-23','09:00:00',1.78),('8784','2014-02-23','09:05:00',1.87),('8784','2014-02-23','09:10:00',1.96),('8784','2014-02-23','09:15:00',2.04),('8784','2014-02-23','09:20:00',2.13),('8784','2014-02-23','09:25:00',1.95),('8784','2014-02-23','09:30:00',1.97),('8784','2014-02-23','09:35:00',2.27),('8784','2014-02-23','09:40:00',2.34),('8784','2014-02-23','09:45:00',2.4),('8784','2014-02-23','09:50:00',2.43),('8784','2014-02-23','09:55:00',2.47),('8784','2014-02-23','10:00:00',2.54),('8784','2014-02-23','10:05:00',2.61),('8784','2014-02-23','10:10:00',2.64),('8784','2014-02-23','10:15:00',2.69),('8784','2014-02-23','10:20:00',2.75),('8784','2014-02-23','10:25:00',2.8),('8784','2014-02-23','10:30:00',2.86),('8784','2014-02-23','10:35:00',2.92),('8784','2014-02-23','10:40:00',2.93),('8784','2014-02-23','10:45:00',3.03),('8784','2014-02-23','10:50:00',3.01),('8784','2014-02-23','10:55:00',3.06),('8784','2014-02-23','11:00:00',3.13),('8784','2014-02-23','11:05:00',3.17),('8784','2014-02-23','11:10:00',3.2),('8784','2014-02-23','11:15:00',3.26),('8784','2014-02-23','11:20:00',3.3),('8784','2014-02-23','11:25:00',3.32),('8784','2014-02-23','11:30:00',3.34),('8784','2014-02-23','11:35:00',3.37),('8784','2014-02-23','11:40:00',3.04),('8784','2014-02-23','11:45:00',1.91),('8784','2014-02-23','11:50:00',3.01),('8784','2014-02-23','11:55:00',2.87),('8784','2014-02-23','12:00:00',3.61),('8784','2014-02-23','12:05:00',3.66),('8784','2014-02-23','12:10:00',1.47),('8784','2014-02-23','12:15:00',3.86),('8784','2014-02-23','12:20:00',3.37),('8784','2014-02-23','12:25:00',2.26),('8784','2014-02-23','12:30:00',2.81),('8784','2014-02-23','12:35:00',3.68),('8784','2014-02-23','12:40:00',2.09),('8784','2014-02-23','12:45:00',2.39),('8784','2014-02-23','12:50:00',1.93),('8784','2014-02-23','12:55:00',1.97),('8784','2014-02-23','13:00:00',2.5),('8784','2014-02-23','13:05:00',3.49),('8784','2014-02-23','13:10:00',3.39),('8784','2014-02-23','13:15:00',3.33),('8784','2014-02-23','13:20:00',3.3),('8784','2014-02-23','13:25:00',3.26),('8784','2014-02-23','13:30:00',3.22),('8784','2014-02-23','13:35:00',2.88),('8784','2014-02-23','13:40:00',2.88),('8784','2014-02-23','13:45:00',2.45),('8784','2014-02-23','13:50:00',1.79),('8784','2014-02-23','14:00:00',1.14),('8784','2014-02-23','14:05:00',2.83),('8784','2014-02-23','14:10:00',3.17),('8784','2014-02-23','14:15:00',2.28),('8784','2014-02-23','14:20:00',1.89),('8784','2014-02-23','14:25:00',2.62),('8784','2014-02-23','14:30:00',3.39),('8784','2014-02-23','14:35:00',2.56),('8784','2014-02-23','14:40:00',1.57),('8784','2014-02-23','14:45:00',1.54),('8784','2014-02-23','14:50:00',1.66),('8784','2014-02-23','14:55:00',1.04),('8784','2014-02-23','15:00:00',1.12),('8784','2014-02-22','09:10:00',1.09),('8784','2014-02-22','09:50:00',1.03),('8784','2014-02-22','09:55:00',1.01),('8784','2014-02-22','10:00:00',1.79),('8784','2014-02-22','10:05:00',1.71),('8784','2014-02-22','10:10:00',2.81),('8784','2014-02-22','10:15:00',1.96),('8784','2014-02-22','10:20:00',1.43),('8784','2014-02-22','10:25:00',2.19),('8784','2014-02-22','10:30:00',2.33),('8784','2014-02-22','10:35:00',1.91),('8784','2014-02-22','10:40:00',1.6),('8784','2014-02-22','10:45:00',3.69),('8784','2014-02-22','10:50:00',3.41),('8784','2014-02-22','10:55:00',1.14),('8784','2014-02-22','12:05:00',1.51),('8784','2014-02-22','12:10:00',1.71),('8784','2014-02-22','12:15:00',1.97),('8784','2014-02-22','12:20:00',1.95),('8784','2014-02-22','12:25:00',1.73),('8784','2014-02-22','12:30:00',1.17),('8784','2014-02-22','12:35:00',1.29),('8784','2014-02-22','12:40:00',1.46),('8784','2014-02-22','12:45:00',3.41),('8784','2014-02-22','12:50:00',3.44),('8784','2014-02-22','12:55:00',1.55),('8784','2014-02-22','13:00:00',1.5),('8784','2014-02-22','13:05:00',2.6),('8784','2014-02-22','13:10:00',4.73),('8784','2014-02-22','13:15:00',2.68),('8784','2014-02-22','13:20:00',1.65),('8784','2014-02-22','13:30:00',1.28),('8784','2014-02-22','13:35:00',2.02),('8784','2014-02-22','13:40:00',1.99),('8784','2014-02-22','13:45:00',1.84),('8784','2014-02-22','13:50:00',1.89),('8784','2014-02-22','13:55:00',3.18),('8784','2014-02-22','14:00:00',3.16),('8784','2014-02-22','14:05:00',2.4),('8784','2014-02-22','14:10:00',2.84),('8784','2014-02-22','14:15:00',2.95),('8784','2014-02-22','14:20:00',2.71),('8784','2014-02-22','14:25:00',2.07),('8784','2014-02-22','14:30:00',1.75),('8784','2014-02-22','14:35:00',1.87),('8784','2014-02-22','14:40:00',2.29),('8784','2014-02-22','14:45:00',2.71),('8784','2014-02-22','14:50:00',2.17),('8784','2014-02-22','15:00:00',1.41),('8784','2014-02-22','15:05:00',2.35),('8784','2014-02-22','15:10:00',1.06),('8784','2014-02-22','15:15:00',1.04),('8784','2014-02-22','15:25:00',1.06),('8784','2014-02-22','15:30:00',1.9),('8784','2014-02-22','15:45:00',1.73),('8784','2014-02-22','15:50:00',1.53),('8784','2014-02-22','16:00:00',1.3),('8784','2014-02-22','16:10:00',1.18),('8784','2014-02-22','16:15:00',1.1),('8784','2014-02-22','16:20:00',1.01),('8784','2014-02-21','09:35:00',1.02),('8784','2014-02-21','09:40:00',1.09),('8784','2014-02-21','09:45:00',1.2),('8784','2014-02-21','09:50:00',1.25),('8784','2014-02-21','09:55:00',1.21),('8784','2014-02-21','10:00:00',1.28),('8784','2014-02-21','10:05:00',1.49),('8784','2014-02-21','10:10:00',1.38),('8784','2014-02-21','10:15:00',1.59),('8784','2014-02-21','10:20:00',2.15),('8784','2014-02-21','10:25:00',2.42),('8784','2014-02-21','10:30:00',2.7),('8784','2014-02-21','10:35:00',1.91),('8784','2014-02-21','10:40:00',1.83),('8784','2014-02-21','10:45:00',1.68),('8784','2014-02-21','10:50:00',1.72),('8784','2014-02-21','10:55:00',2.32),('8784','2014-02-21','11:00:00',1.7),('8784','2014-02-21','11:05:00',1.59),('8784','2014-02-21','11:10:00',1.57),('8784','2014-02-21','11:15:00',1.71),('8784','2014-02-21','11:20:00',1.56),('8784','2014-02-21','11:25:00',1.74),('8784','2014-02-21','11:30:00',1.91),('8784','2014-02-21','11:35:00',1.82),('8784','2014-02-21','11:40:00',1.91),('8784','2014-02-21','11:45:00',1.79),('8784','2014-02-21','11:50:00',1.6),('8784','2014-02-21','11:55:00',1.58),('8784','2014-02-21','12:00:00',1.98),('8784','2014-02-21','12:05:00',3.85),('8784','2014-02-21','12:10:00',4.19),('8784','2014-02-21','12:15:00',3.92),('8784','2014-02-21','12:20:00',3.32),('8784','2014-02-21','12:25:00',2.74),('8784','2014-02-21','12:30:00',1.74),('8784','2014-02-21','12:35:00',1.35),('8784','2014-02-21','12:40:00',1.12),('8784','2014-02-21','15:00:00',1.18),('8784','2014-02-21','15:05:00',1.1),('8784','2014-02-21','15:30:00',1.44),('8784','2014-02-21','15:35:00',1.6),('8784','2014-02-21','15:40:00',1.57),('8784','2014-02-21','15:45:00',1.51),('8784','2014-02-21','15:50:00',1.39),('8784','2014-02-21','15:55:00',1.3),('8784','2014-02-21','16:00:00',1.22),('8784','2014-02-21','16:05:00',1.16),('8784','2014-02-21','16:10:00',1.07),('8784','2014-02-20','11:20:00',1.14),('8784','2014-02-20','11:25:00',1.28),('8784','2014-02-20','11:30:00',1.28),('8784','2014-02-20','11:35:00',1.03),('8784','2014-02-20','12:25:00',1.13),('8784','2014-02-20','12:30:00',1.1),('8784','2014-02-20','12:35:00',1.15),('8784','2014-02-20','12:40:00',1.25),('8784','2014-02-20','12:45:00',1.09),('8784','2014-02-20','12:50:00',1.1),('8784','2014-02-20','12:55:00',1.3),('8784','2014-02-20','13:00:00',1.54),('8784','2014-02-20','13:15:00',1.29),('8784','2014-02-20','13:20:00',1.05),('8784','2014-02-20','13:30:00',1.3),('8784','2014-02-20','13:35:00',1.13),('8784','2014-02-19','09:25:00',1.06),('8784','2014-02-19','09:30:00',1.09),('8784','2014-02-19','09:35:00',1.23),('8784','2014-02-19','09:40:00',1.33),('8784','2014-02-19','09:45:00',1.57),('8784','2014-02-19','09:50:00',1.47),('8784','2014-02-19','09:55:00',1.37),('8784','2014-02-19','10:00:00',1.33),('8784','2014-02-19','10:05:00',1.34),('8784','2014-02-19','10:10:00',1.45),('8784','2014-02-19','10:15:00',1.52),('8784','2014-02-19','10:20:00',1.39),('8784','2014-02-19','10:25:00',1.42),('8784','2014-02-19','10:30:00',1.51),('8784','2014-02-19','10:35:00',1.59),('8784','2014-02-19','10:40:00',1.81),('8784','2014-02-19','10:45:00',1.96),('8784','2014-02-19','10:50:00',1.85),('8784','2014-02-19','10:55:00',1.66),('8784','2014-02-19','11:00:00',1.51),('8784','2014-02-19','11:05:00',1.54),('8784','2014-02-19','11:10:00',1.72),('8784','2014-02-19','11:15:00',1.72),('8784','2014-02-19','11:20:00',1.86),('8784','2014-02-19','11:25:00',1.7),('8784','2014-02-19','11:30:00',1.58),('8784','2014-02-19','11:35:00',1.62),('8784','2014-02-19','11:40:00',1.54),('8784','2014-02-19','11:45:00',1.46),('8784','2014-02-19','11:50:00',1.5),('8784','2014-02-19','11:55:00',1.32),('8784','2014-02-19','12:00:00',1.37),('8784','2014-02-19','12:05:00',1.49),('8784','2014-02-19','12:10:00',1.46),('8784','2014-02-19','12:15:00',1.41),('8784','2014-02-19','12:20:00',1.24),('8784','2014-02-19','12:25:00',1.45),('8784','2014-02-19','12:30:00',1.62),('8784','2014-02-19','12:35:00',1.34),('8784','2014-02-19','12:40:00',1.25),('8784','2014-02-19','12:45:00',1.28),('8784','2014-02-19','12:50:00',1.05),('8784','2014-02-19','13:00:00',1.04),('8784','2014-02-19','13:05:00',1.15),('8784','2014-02-19','13:10:00',1.12),('8784','2014-02-19','13:15:00',1.28),('8784','2014-02-19','13:20:00',1.25),('8784','2014-02-19','13:25:00',1.57),('8784','2014-02-19','13:30:00',1.56),('8784','2014-02-19','13:35:00',1.75),('8784','2014-02-19','13:40:00',1.61),('8784','2014-02-19','13:45:00',2.03),('8784','2014-02-19','13:50:00',2.1),('8784','2014-02-19','13:55:00',1.84),('8784','2014-02-19','14:00:00',1.65),('8784','2014-02-19','14:05:00',1.77),('8784','2014-02-19','14:10:00',1.44),('8784','2014-02-19','14:15:00',1.33),('8784','2014-02-19','14:20:00',2.04),('8784','2014-02-19','14:25:00',1.63),('8784','2014-02-19','14:30:00',1.56),('8784','2014-02-19','14:35:00',1.66),('8784','2014-02-19','14:40:00',1.37),('8784','2014-02-19','14:45:00',1.31),('8784','2014-02-19','14:50:00',1.69),('8784','2014-02-19','14:55:00',1.4),('8784','2014-02-19','15:00:00',1.07),('8784','2014-02-19','15:05:00',1.12),('8784','2014-02-19','15:10:00',1.15),('8784','2014-02-19','15:15:00',1.3),('8784','2014-02-19','15:25:00',1.14),('8784','2014-02-19','15:30:00',1.01),('8784','2014-02-19','15:50:00',1.18),('8784','2014-02-18','08:30:00',1.08),('8784','2014-02-18','08:35:00',1.16),('8784','2014-02-18','08:40:00',1.19),('8784','2014-02-18','08:45:00',1.25),('8784','2014-02-18','08:50:00',1.28),('8784','2014-02-18','08:55:00',1.4),('8784','2014-02-18','09:00:00',1.2),('8784','2014-02-18','09:05:00',1.32),('8784','2014-02-18','09:10:00',1.63),('8784','2014-02-18','09:15:00',1.7),('8784','2014-02-18','09:20:00',1.77),('8784','2014-02-18','09:25:00',1.83),('8784','2014-02-18','09:30:00',1.98),('8784','2014-02-18','09:35:00',2.02),('8784','2014-02-18','09:40:00',2.09),('8784','2014-02-18','09:45:00',2.16),('8784','2014-02-18','09:50:00',2.22),('8784','2014-02-18','09:55:00',2.29),('8784','2014-02-18','10:00:00',2.36),('8784','2014-02-18','10:05:00',2.39),('8784','2014-02-18','10:10:00',2.48),('8784','2014-02-18','10:15:00',2.49),('8784','2014-02-18','10:20:00',2.54),('8784','2014-02-18','10:25:00',2.61),('8784','2014-02-18','10:30:00',2.64),('8784','2014-02-18','10:35:00',2.67),('8784','2014-02-18','10:40:00',2.71),('8784','2014-02-18','10:45:00',2.76),('8784','2014-02-18','10:50:00',2.81),('8784','2014-02-18','10:55:00',2.84),('8784','2014-02-18','11:00:00',2.87),('8784','2014-02-18','11:05:00',2.45),('8784','2014-02-18','11:10:00',2.38),('8784','2014-02-18','11:15:00',2.32),('8784','2014-02-18','11:20:00',2.63),('8784','2014-02-18','11:25:00',2.93),('8784','2014-02-18','11:30:00',2.59),('8784','2014-02-18','11:35:00',2.54),('8784','2014-02-18','11:40:00',2.1),('8784','2014-02-18','11:45:00',2.05),('8784','2014-02-18','11:50:00',1.77),('8784','2014-02-18','11:55:00',1.57),('8784','2014-02-18','12:00:00',1.57),('8784','2014-02-18','12:05:00',1.59),('8784','2014-02-18','12:10:00',1.81),('8784','2014-02-18','12:15:00',1.93),('8784','2014-02-18','12:20:00',1.91),('8784','2014-02-18','12:25:00',2.21),('8784','2014-02-18','12:30:00',2.38),('8784','2014-02-18','12:35:00',1.84),('8784','2014-02-18','12:40:00',1.67),('8784','2014-02-18','12:45:00',1.63),('8784','2014-02-18','12:50:00',1.73),('8784','2014-02-18','12:55:00',1.82),('8784','2014-02-18','13:00:00',1.48),('8784','2014-02-18','13:05:00',1.41),('8784','2014-02-18','13:10:00',1.5),('8784','2014-02-18','13:15:00',1.93),('8784','2014-02-18','13:20:00',2.08),('8784','2014-02-18','13:25:00',2.5),('8784','2014-02-18','13:30:00',1.8),('8784','2014-02-18','13:35:00',1.5),('8784','2014-02-18','13:40:00',1.91),('8784','2014-02-18','13:45:00',2.14),('8784','2014-02-18','13:50:00',1.7),('8784','2014-02-18','13:55:00',1.67),('8784','2014-02-18','14:00:00',1.84),('8784','2014-02-18','14:05:00',2.6),('8784','2014-02-18','14:10:00',1.6),('8784','2014-02-18','14:15:00',1.27),('8784','2014-02-18','14:20:00',1.19),('8784','2014-02-18','14:25:00',1.21),('8784','2014-02-18','14:30:00',1.46),('8784','2014-02-18','14:35:00',1.4),('8784','2014-02-18','14:40:00',1.2),('8784','2014-02-18','14:45:00',1.1),('8784','2014-02-18','14:50:00',1.04),('8784','2014-02-18','15:35:00',1.07),('8784','2014-02-18','15:40:00',1.26),('8784','2014-02-18','15:45:00',1.32),('8784','2014-02-18','15:50:00',1.08),('8784','2014-02-18','16:05:00',1.06),('8784','2014-02-17','08:35:00',1.02),('8784','2014-02-17','08:40:00',1.04),('8784','2014-02-17','08:45:00',1.14),('8784','2014-02-17','08:50:00',1.2),('8784','2014-02-17','08:55:00',1.27),('8784','2014-02-17','09:10:00',1.23),('8784','2014-02-17','09:15:00',1.53),('8784','2014-02-17','09:20:00',1.62),('8784','2014-02-17','09:25:00',1.69),('8784','2014-02-17','09:30:00',1.8),('8784','2014-02-17','09:35:00',1.88),('8784','2014-02-17','09:40:00',1.95),('8784','2014-02-17','09:45:00',2.01),('8784','2014-02-17','09:50:00',2.05),('8784','2014-02-17','09:55:00',2.09),('8784','2014-02-17','10:00:00',2.17),('8784','2014-02-17','10:05:00',2.26),('8784','2014-02-17','10:10:00',2.28),('8784','2014-02-17','10:15:00',2.32),('8784','2014-02-17','10:20:00',2.31),('8784','2014-02-17','10:25:00',2.32),('8784','2014-02-17','10:30:00',2.36),('8784','2014-02-17','10:35:00',2.38),('8784','2014-02-17','10:40:00',2.38),('8784','2014-02-17','10:45:00',2.36),('8784','2014-02-17','10:50:00',2.38),('8784','2014-02-17','10:55:00',2.51),('8784','2014-02-17','11:00:00',2.57),('8784','2014-02-17','11:05:00',2.62),('8784','2014-02-17','11:10:00',2.65),('8784','2014-02-17','11:15:00',2.68),('8784','2014-02-17','11:20:00',2.73),('8784','2014-02-17','11:25:00',2.75),('8784','2014-02-17','11:30:00',2.84),('8784','2014-02-17','11:35:00',2.89),('8784','2014-02-17','11:40:00',2.91),('8784','2014-02-17','11:45:00',2.93),('8784','2014-02-17','11:50:00',2.94),('8784','2014-02-17','11:55:00',2.94),('8784','2014-02-17','12:00:00',2.95),('8784','2014-02-17','12:05:00',2.95),('8784','2014-02-17','12:10:00',2.94),('8784','2014-02-17','12:15:00',2.93),('8784','2014-02-17','12:20:00',2.92),('8784','2014-02-17','12:25:00',2.93),('8784','2014-02-17','12:30:00',2.91),('8784','2014-02-17','12:35:00',2.9),('8784','2014-02-17','12:40:00',2.86),('8784','2014-02-17','12:45:00',2.84),('8784','2014-02-17','12:50:00',2.79),('8784','2014-02-17','12:55:00',2.79),('8784','2014-02-17','13:00:00',2.78),('8784','2014-02-17','13:05:00',2.76),('8784','2014-02-17','13:10:00',2.73),('8784','2014-02-17','13:15:00',2.73),('8784','2014-02-17','13:20:00',2.71),('8784','2014-02-17','13:25:00',2.7),('8784','2014-02-17','13:30:00',2.69),('8784','2014-02-17','13:35:00',2.65),('8784','2014-02-17','13:40:00',2.6),('8784','2014-02-17','13:45:00',2.56),('8784','2014-02-17','13:50:00',2.53),('8784','2014-02-17','13:55:00',2.46),('8784','2014-02-17','14:00:00',2.43),('8784','2014-02-17','14:05:00',2.41),('8784','2014-02-17','14:10:00',2.3),('8784','2014-02-17','14:15:00',2.17),('8784','2014-02-17','14:20:00',2.02),('8784','2014-02-17','14:25:00',1.88),('8784','2014-02-17','14:30:00',2.06),('8784','2014-02-17','14:35:00',2.01),('8784','2014-02-17','14:40:00',1.81),('8784','2014-02-17','14:45:00',2.01),('8784','2014-02-17','14:50:00',1.91),('8784','2014-02-17','14:55:00',1.87),('8784','2014-02-17','15:00:00',1.76),('8784','2014-02-17','15:05:00',1.74),('8784','2014-02-17','15:10:00',1.7),('8784','2014-02-17','15:15:00',1.71),('8784','2014-02-17','15:20:00',1.66),('8784','2014-02-17','15:25:00',1.54),('8784','2014-02-17','15:30:00',1.49),('8784','2014-02-17','15:35:00',1.41),('8784','2014-02-17','15:40:00',1.31),('8784','2014-02-17','15:45:00',1.29),('8784','2014-02-17','15:50:00',1.21),('8784','2014-02-17','15:55:00',1.14),('8784','2014-02-17','16:00:00',1.02),('8784','2014-02-16','08:30:00',1.01),('8784','2014-02-16','08:35:00',1.1),('8784','2014-02-16','08:40:00',1.04),('8784','2014-02-16','08:45:00',1.16),('8784','2014-02-16','08:50:00',1.18),('8784','2014-02-16','08:55:00',1.36),('8784','2014-02-16','09:00:00',1.02),('8784','2014-02-16','09:10:00',1.09),('8784','2014-02-16','09:15:00',1.26),('8784','2014-02-16','09:20:00',1.69),('8784','2014-02-16','09:25:00',1.69),('8784','2014-02-16','09:30:00',1.76),('8784','2014-02-16','09:35:00',1.51),('8784','2014-02-16','09:40:00',1.97),('8784','2014-02-16','09:45:00',2.11),('8784','2014-02-16','09:50:00',2.22),('8784','2014-02-16','09:55:00',2.16),('8784','2014-02-16','10:00:00',2.13),('8784','2014-02-16','10:05:00',2.39),('8784','2014-02-16','10:10:00',2.45),('8784','2014-02-16','10:15:00',2.48),('8784','2014-02-16','10:20:00',2.58),('8784','2014-02-16','10:25:00',2.57),('8784','2014-02-16','10:30:00',2.7),('8784','2014-02-16','10:35:00',2.8),('8784','2014-02-16','10:40:00',2.87),('8784','2014-02-16','10:45:00',2.84),('8784','2014-02-16','10:50:00',2.45),('8784','2014-02-16','10:55:00',2.52),('8784','2014-02-16','11:00:00',2.89),('8784','2014-02-16','11:05:00',2.96),('8784','2014-02-16','11:10:00',2.82),('8784','2014-02-16','11:15:00',2.94),('8784','2014-02-16','11:20:00',2.82),('8784','2014-02-16','11:25:00',2.83),('8784','2014-02-16','11:30:00',2.85),('8784','2014-02-16','11:35:00',3.01),('8784','2014-02-16','11:40:00',2.96),('8784','2014-02-16','11:45:00',2.71),('8784','2014-02-16','11:50:00',2.99),('8784','2014-02-16','11:55:00',2.62),('8784','2014-02-16','12:00:00',3.06),('8784','2014-02-16','12:05:00',3.04),('8784','2014-02-16','12:10:00',3.01),('8784','2014-02-16','12:15:00',3.04),('8784','2014-02-16','12:20:00',3.04),('8784','2014-02-16','12:25:00',2.94),('8784','2014-02-16','12:30:00',2.96),('8784','2014-02-16','12:35:00',2.98),('8784','2014-02-16','12:40:00',2.97),('8784','2014-02-16','12:45:00',2.96),('8784','2014-02-16','12:50:00',2.94),('8784','2014-02-16','12:55:00',2.9),('8784','2014-02-16','13:00:00',2.89),('8784','2014-02-16','13:05:00',2.89),('8784','2014-02-16','13:10:00',2.78),('8784','2014-02-16','13:15:00',2.86),('8784','2014-02-16','13:20:00',2.83),('8784','2014-02-16','13:25:00',2.76),('8784','2014-02-16','13:30:00',2.77),('8784','2014-02-16','13:35:00',2.69),('8784','2014-02-16','13:40:00',2.7),('8784','2014-02-16','13:45:00',2.73),('8784','2014-02-16','13:50:00',2.67),('8784','2014-02-16','13:55:00',2.64),('8784','2014-02-16','14:00:00',2.62),('8784','2014-02-16','14:05:00',2.58),('8784','2014-02-16','14:10:00',2.5),('8784','2014-02-16','14:15:00',2.32),('8784','2014-02-16','14:20:00',2.21),('8784','2014-02-16','14:25:00',2.3),('8784','2014-02-16','14:30:00',2.28),('8784','2014-02-16','14:35:00',2.23),('8784','2014-02-16','14:40:00',2.15),('8784','2014-02-16','14:45:00',2.12),('8784','2014-02-16','14:50:00',2.04),('8784','2014-02-16','14:55:00',2.01),('8784','2014-02-16','15:00:00',1.93),('8784','2014-02-16','15:05:00',1.87),('8784','2014-02-16','15:10:00',1.8),('8784','2014-02-16','15:15:00',1.74),('8784','2014-02-16','15:20:00',1.65),('8784','2014-02-16','15:25:00',1.58),('8784','2014-02-16','15:30:00',1.5),('8784','2014-02-16','15:35:00',1.29),('8784','2014-02-16','15:40:00',1.18),('8784','2014-02-16','15:45:00',1.35),('8784','2014-02-16','15:50:00',1.07),('8784','2014-02-16','16:25:00',1.09),('8784','2014-02-16','16:30:00',1),('8784','2014-04-28','08:15:00',1.85),('8784','2014-04-28','08:20:00',1.97),('8784','2014-04-28','08:25:00',2.07),('8784','2014-04-28','08:30:00',1.34),('8784','2014-04-28','08:35:00',1.35),('8784','2014-04-28','08:40:00',1.38),('8784','2014-04-28','08:45:00',1.29),('8784','2014-04-28','08:50:00',1.35),('8784','2014-04-28','08:55:00',1.49),('8784','2014-04-28','09:00:00',1.1),('8784','2014-04-28','09:05:00',1.73),('8784','2014-04-28','09:10:00',2.93),('8784','2014-04-28','09:15:00',3.06),('8784','2014-04-28','09:20:00',2.28),('8784','2014-04-28','09:25:00',1.72),('8784','2014-04-28','09:30:00',2.85),('8784','2014-04-28','09:35:00',2.62),('8784','2014-04-28','09:40:00',2.04),('8784','2014-04-28','09:45:00',1.81),('8784','2014-04-28','09:50:00',1.78),('8784','2014-04-28','09:55:00',1.44),('8784','2014-04-28','10:00:00',2.46),('8784','2014-04-28','10:05:00',2.61),('8784','2014-04-28','10:10:00',2.53),('8784','2014-04-28','10:15:00',2.13),('8784','2014-04-28','10:20:00',1.73),('8784','2014-04-28','10:25:00',1.06),('8784','2014-04-28','10:40:00',1.19),('8784','2014-04-28','10:45:00',1.8),('8784','2014-04-28','10:50:00',2.18),('8784','2014-04-28','10:55:00',1.94),('8784','2014-04-28','11:00:00',2.13),('8784','2014-04-28','11:05:00',2.62),('8784','2014-04-28','11:10:00',2.95),('8784','2014-04-28','11:15:00',2.77),('8784','2014-04-28','11:20:00',2.41),('8784','2014-04-28','11:25:00',2.02),('8784','2014-04-28','11:30:00',2.07),('8784','2014-04-28','11:35:00',1.82),('8784','2014-04-28','11:40:00',1.67),('8784','2014-04-28','11:45:00',1.86),('8784','2014-04-28','11:50:00',2.17),('8784','2014-04-28','11:55:00',2.23),('8784','2014-04-28','12:00:00',1.95),('8784','2014-04-28','12:05:00',1.61),('8784','2014-04-28','12:10:00',2.29),('8784','2014-04-28','12:15:00',3.11),('8784','2014-04-28','12:20:00',3.1),('8784','2014-04-28','12:25:00',3.04),('8784','2014-04-28','12:30:00',3.02),('8784','2014-04-28','12:35:00',2.7),('8784','2014-04-28','12:40:00',2.31),('8784','2014-04-28','12:45:00',2.14),('8784','2014-04-28','12:50:00',2.43),('8784','2014-04-28','12:55:00',2.4),('8784','2014-04-28','13:00:00',2.5),('8784','2014-04-28','13:05:00',3.8),('8784','2014-04-28','13:10:00',3.25),('8784','2014-04-28','13:15:00',2.42),('8784','2014-04-28','13:20:00',2.76),('8784','2014-04-28','13:25:00',3.51),('8784','2014-04-28','13:30:00',5.32),('8784','2014-04-28','13:35:00',3.86),('8784','2014-04-28','13:40:00',2.93),('8784','2014-04-28','13:45:00',4.35),('8784','2014-04-28','13:50:00',4.74),('8784','2014-04-28','13:55:00',3.02),('8784','2014-04-28','14:00:00',2.25),('8784','2014-04-28','14:05:00',3.69),('8784','2014-04-28','14:10:00',3.92),('8784','2014-04-28','14:15:00',2.67),('8784','2014-04-28','14:20:00',4.4),('8784','2014-04-28','14:25:00',3.19),('8784','2014-04-28','14:30:00',3.39),('8784','2014-04-28','14:35:00',2.5),('8784','2014-04-28','14:40:00',4.22),('8784','2014-04-28','14:45:00',3.75),('8784','2014-04-28','14:50:00',3.54),('8784','2014-04-28','14:55:00',4.4),('8784','2014-04-28','15:00:00',3.53),('8784','2014-04-28','15:05:00',3.46),('8784','2014-04-28','15:10:00',2.15),('8784','2014-04-28','15:15:00',2.24),('8784','2014-04-28','15:20:00',2.07),('8784','2014-04-28','15:25:00',1.61),('8784','2014-04-28','15:30:00',2.12),('8784','2014-04-28','15:35:00',3.64),('8784','2014-04-28','15:40:00',2.53),('8784','2014-04-28','15:45:00',3.2),('8784','2014-04-28','15:50:00',2.54),('8784','2014-04-28','15:55:00',1.48),('8784','2014-04-28','16:00:00',2.77),('8784','2014-04-28','16:05:00',2.84),('8784','2014-04-28','16:10:00',4.05),('8784','2014-04-28','16:15:00',2.3),('8784','2014-04-28','16:20:00',2.15),('8784','2014-04-28','16:25:00',2.02),('8784','2014-04-28','16:30:00',2.94),('8784','2014-04-28','16:35:00',3.3),('8784','2014-04-28','16:50:00',1.17),('8784','2014-04-28','16:55:00',1.8),('8784','2014-04-28','17:25:00',1.05),('8784','2014-04-28','17:35:00',1.32),('8784','2014-04-28','17:40:00',1.44),('8784','2014-02-15','08:40:00',1.03),('8784','2014-02-15','08:45:00',1.1),('8784','2014-02-15','08:50:00',1.15),('8784','2014-02-15','08:55:00',1.19),('8784','2014-02-15','09:00:00',1),('8784','2014-02-15','09:05:00',1.21),('8784','2014-02-15','09:10:00',1.42),('8784','2014-02-15','09:15:00',1.51),('8784','2014-02-15','09:20:00',1.59),('8784','2014-02-15','09:25:00',1.65),('8784','2014-02-15','09:30:00',1.77),('8784','2014-02-15','09:35:00',1.87),('8784','2014-02-15','09:40:00',1.94),('8784','2014-02-15','09:45:00',1.97),('8784','2014-02-15','09:50:00',2.06),('8784','2014-02-15','09:55:00',2.1),('8784','2014-02-15','10:00:00',2.14),('8784','2014-02-15','10:05:00',2.23),('8784','2014-02-15','10:10:00',2.25),('8784','2014-02-15','10:15:00',2.31),('8784','2014-02-15','10:20:00',2.37),('8784','2014-02-15','10:25:00',2.38),('8784','2014-02-15','10:30:00',2.5),('8784','2014-02-15','10:35:00',2.53),('8784','2014-02-15','10:40:00',2.57),('8784','2014-02-15','10:45:00',2.64),('8784','2014-02-15','10:50:00',2.64),('8784','2014-02-15','10:55:00',2.62),('8784','2014-02-15','11:00:00',1.74),('8784','2014-02-15','11:05:00',2.83),('8784','2014-02-15','11:10:00',2.93),('8784','2014-02-15','11:15:00',2.98),('8784','2014-02-15','11:20:00',2.06),('8784','2014-02-15','11:25:00',3.03),('8784','2014-02-15','11:30:00',2.42),('8784','2014-02-15','11:35:00',2.54),('8784','2014-02-15','11:40:00',3.37),('8784','2014-02-15','11:45:00',3.41),('8784','2014-02-15','11:50:00',3.05),('8784','2014-02-15','11:55:00',2.08),('8784','2014-02-15','12:00:00',1.19),('8784','2014-02-15','12:05:00',1.61),('8784','2014-02-15','12:10:00',3.18),('8784','2014-02-15','12:15:00',3.54),('8784','2014-02-15','12:20:00',2.9),('8784','2014-02-15','12:25:00',1.43),('8784','2014-02-15','12:30:00',2.52),('8784','2014-02-15','12:35:00',3.37),('8784','2014-02-15','12:40:00',3.08),('8784','2014-02-15','12:45:00',3.42),('8784','2014-02-15','12:50:00',3.44),('8784','2014-02-15','12:55:00',2.11),('8784','2014-02-15','13:00:00',3.11),('8784','2014-02-15','13:05:00',3.31),('8784','2014-02-15','13:10:00',3.3),('8784','2014-02-15','13:15:00',3),('8784','2014-02-15','13:20:00',2.96),('8784','2014-02-15','13:25:00',2.87),('8784','2014-02-15','13:30:00',2.83),('8784','2014-02-15','13:35:00',2.73),('8784','2014-02-15','13:40:00',2.67),('8784','2014-02-15','13:45:00',2.61),('8784','2014-02-15','13:50:00',2.68),('8784','2014-02-15','13:55:00',2.59),('8784','2014-02-15','14:00:00',2.47),('8784','2014-02-15','14:05:00',2.49),('8784','2014-02-15','14:10:00',2.4),('8784','2014-02-15','14:15:00',2.24),('8784','2014-02-15','14:20:00',2),('8784','2014-02-15','14:25:00',2.12),('8784','2014-02-15','14:30:00',2.08),('8784','2014-02-15','14:35:00',2.14),('8784','2014-02-15','14:40:00',2.1),('8784','2014-02-15','14:45:00',2.02),('8784','2014-02-15','14:50:00',1.95),('8784','2014-02-15','14:55:00',1.85),('8784','2014-02-15','15:00:00',1.85),('8784','2014-02-15','15:05:00',1.8),('8784','2014-02-15','15:10:00',1.76),('8784','2014-02-15','15:15:00',1.68),('8784','2014-02-15','15:20:00',1.61),('8784','2014-02-15','15:25:00',1.56),('8784','2014-02-15','15:30:00',1.49),('8784','2014-02-15','15:35:00',1.43),('8784','2014-02-15','15:40:00',1.37),('8784','2014-02-15','15:45:00',1.29),('8784','2014-02-15','15:50:00',1.22),('8784','2014-02-15','15:55:00',1.16),('8784','2014-02-15','16:00:00',1.08),('8784','2014-02-14','08:50:00',1.17),('8784','2014-02-14','08:55:00',1.23),('8784','2014-02-14','09:05:00',1.06),('8784','2014-02-14','09:10:00',1.07),('8784','2014-02-14','09:20:00',1.21),('8784','2014-02-14','09:25:00',1.03),('8784','2014-02-14','09:30:00',1.73),('8784','2014-02-14','09:35:00',1.34),('8784','2014-02-14','09:45:00',1.03),('8784','2014-02-14','09:50:00',2.43),('8784','2014-02-14','09:55:00',2.18),('8784','2014-02-14','10:00:00',2.3),('8784','2014-02-14','10:05:00',2.52),('8784','2014-02-14','10:10:00',2.48),('8784','2014-02-14','10:15:00',1.57),('8784','2014-02-14','10:20:00',2.76),('8784','2014-02-14','10:25:00',2.67),('8784','2014-02-14','10:30:00',2.69),('8784','2014-02-14','10:35:00',2.56),('8784','2014-02-14','10:40:00',2.72),('8784','2014-02-14','10:45:00',2.83),('8784','2014-02-14','10:50:00',2.87),('8784','2014-02-14','10:55:00',2.86),('8784','2014-02-14','11:00:00',2.91),('8784','2014-02-14','11:05:00',2.94),('8784','2014-02-14','11:10:00',2.95),('8784','2014-02-14','11:15:00',2.98),('8784','2014-02-14','11:20:00',3.02),('8784','2014-02-14','11:25:00',3.05),('8784','2014-02-14','11:30:00',3.07),('8784','2014-02-14','11:35:00',3.09),('8784','2014-02-14','11:40:00',3.09),('8784','2014-02-14','11:45:00',3.12),('8784','2014-02-14','11:50:00',3.04),('8784','2014-02-14','11:55:00',3.14),('8784','2014-02-14','12:00:00',2.74),('8784','2014-02-14','12:05:00',3.09),('8784','2014-02-14','12:10:00',3.16),('8784','2014-02-14','12:15:00',3.11),('8784','2014-02-14','12:20:00',3.11),('8784','2014-02-14','12:25:00',3.12),('8784','2014-02-14','12:30:00',3.09),('8784','2014-02-14','12:35:00',3.03),('8784','2014-02-14','12:40:00',3.06),('8784','2014-02-14','12:45:00',3.05),('8784','2014-02-14','12:50:00',3.03),('8784','2014-02-14','12:55:00',2.97),('8784','2014-02-14','13:00:00',2.87),('8784','2014-02-14','13:05:00',2.91),('8784','2014-02-14','13:10:00',2.98),('8784','2014-02-14','13:15:00',2.97),('8784','2014-02-14','13:20:00',2.92),('8784','2014-02-14','13:25:00',2.86),('8784','2014-02-14','13:30:00',2.78),('8784','2014-02-14','13:35:00',2.76),('8784','2014-02-14','13:40:00',2.76),('8784','2014-02-14','13:45:00',2.74),('8784','2014-02-14','13:50:00',2.7),('8784','2014-02-14','13:55:00',2.66),('8784','2014-02-14','14:00:00',2.61),('8784','2014-02-14','14:05:00',2.55),('8784','2014-02-14','14:10:00',2.46),('8784','2014-02-14','14:15:00',2.22),('8784','2014-02-14','14:20:00',2.09),('8784','2014-02-14','14:25:00',2.28),('8784','2014-02-14','14:30:00',2.26),('8784','2014-02-14','14:35:00',2.21),('8784','2014-02-14','14:40:00',2.16),('8784','2014-02-14','14:45:00',2.08),('8784','2014-02-14','14:50:00',2.02),('8784','2014-02-14','14:55:00',1.96),('8784','2014-02-14','15:00:00',1.89),('8784','2014-02-14','15:05:00',1.85),('8784','2014-02-14','15:10:00',1.77),('8784','2014-02-14','15:15:00',1.69),('8784','2014-02-14','15:20:00',1.65),('8784','2014-02-14','15:25:00',1.57),('8784','2014-02-14','15:30:00',1.48),('8784','2014-02-14','15:35:00',1.4),('8784','2014-02-14','15:40:00',1.35),('8784','2014-02-14','15:45:00',1.26),('8784','2014-02-14','15:50:00',1.19),('8784','2014-02-14','15:55:00',1.12),('8784','2014-02-14','16:00:00',1.06),('8784','2014-02-13','08:45:00',1.04),('8784','2014-02-13','08:50:00',1.13),('8784','2014-02-13','08:55:00',1.19),('8784','2014-02-13','09:00:00',1.08),('8784','2014-02-13','09:05:00',1.19),('8784','2014-02-13','09:10:00',1.46),('8784','2014-02-13','09:15:00',1.49),('8784','2014-02-13','09:20:00',1.57),('8784','2014-02-13','09:25:00',1.66),('8784','2014-02-13','09:30:00',1.73),('8784','2014-02-13','09:35:00',1.87),('8784','2014-02-13','09:40:00',1.92),('8784','2014-02-13','09:45:00',1.99),('8784','2014-02-13','09:50:00',2.08),('8784','2014-02-13','09:55:00',2.13),('8784','2014-02-13','10:00:00',2.22),('8784','2014-02-13','10:05:00',2.26),('8784','2014-02-13','10:10:00',2.32),('8784','2014-02-13','10:15:00',2.34),('8784','2014-02-13','10:20:00',2.41),('8784','2014-02-13','10:25:00',2.5),('8784','2014-02-13','10:30:00',2.54),('8784','2014-02-13','10:35:00',2.61),('8784','2014-02-13','10:40:00',2.61),('8784','2014-02-13','10:45:00',2.65),('8784','2014-02-13','10:50:00',2.7),('8784','2014-02-13','10:55:00',2.72),('8784','2014-02-13','11:00:00',2.77),('8784','2014-02-13','11:05:00',2.81),('8784','2014-02-13','11:10:00',2.85),('8784','2014-02-13','11:15:00',2.94),('8784','2014-02-13','11:20:00',3.12),('8784','2014-02-13','11:25:00',3.06),('8784','2014-02-13','11:30:00',2.79),('8784','2014-02-13','11:35:00',1.73),('8784','2014-02-13','11:40:00',2.28),('8784','2014-02-13','11:45:00',1.72),('8784','2014-02-13','11:50:00',2.05),('8784','2014-02-13','11:55:00',2.01),('8784','2014-02-13','12:00:00',1.98),('8784','2014-02-13','12:05:00',1.49),('8784','2014-02-13','12:10:00',2.09),('8784','2014-02-13','12:15:00',1.67),('8784','2014-02-13','12:20:00',1.81),('8784','2014-02-13','12:25:00',2.83),('8784','2014-02-13','12:30:00',3.7),('8784','2014-02-13','12:35:00',3.58),('8784','2014-02-13','12:40:00',2.56),('8784','2014-02-13','12:45:00',1.61),('8784','2014-02-13','12:50:00',2.56),('8784','2014-02-13','12:55:00',3.19),('8784','2014-02-13','13:00:00',3.02),('8784','2014-02-13','13:05:00',3.06),('8784','2014-02-13','13:10:00',3.03),('8784','2014-02-13','13:15:00',2.98),('8784','2014-02-13','13:20:00',2.96),('8784','2014-02-13','13:25:00',2.91),('8784','2014-02-13','13:30:00',2.89),('8784','2014-02-13','13:35:00',2.85),('8784','2014-02-13','13:40:00',2.8),('8784','2014-02-13','13:45:00',2.77),('8784','2014-02-13','13:50:00',2.74),('8784','2014-02-13','13:55:00',2.68),('8784','2014-02-13','14:00:00',2.63),('8784','2014-02-13','14:05:00',2.53),('8784','2014-02-13','14:10:00',2.45),('8784','2014-02-13','14:15:00',2.14),('8784','2014-02-13','14:20:00',2.29),('8784','2014-02-13','14:25:00',2.34),('8784','2014-02-13','14:30:00',2.32),('8784','2014-02-13','14:35:00',2.26),('8784','2014-02-13','14:40:00',1.37),('8784','2014-02-13','14:45:00',1.86),('8784','2014-02-13','14:50:00',2.08),('8784','2014-02-13','14:55:00',2.07),('8784','2014-02-13','15:00:00',1.42),('8784','2014-02-13','15:05:00',2.06),('8784','2014-02-13','15:10:00',2),('8784','2014-02-13','15:15:00',1.86),('8784','2014-02-13','15:20:00',1.81),('8784','2014-02-13','15:25:00',1.05),('8784','2014-02-13','15:30:00',1.03),('8784','2014-02-13','15:40:00',1.58),('8784','2014-02-13','15:45:00',1.41),('8784','2014-02-13','16:10:00',1.16),('8784','2014-02-12','09:10:00',1.07),('8784','2014-02-12','09:15:00',1.39),('8784','2014-02-12','09:20:00',1.14),('8784','2014-02-12','09:40:00',1.19),('8784','2014-02-12','09:45:00',1.42),('8784','2014-02-12','09:50:00',1.59),('8784','2014-02-12','09:55:00',1.06),('8784','2014-02-12','10:00:00',1.11),('8784','2014-02-12','10:05:00',1.56),('8784','2014-02-12','10:10:00',1.42),('8784','2014-02-12','10:15:00',1.18),('8784','2014-02-12','10:20:00',1.12),('8784','2014-02-12','10:25:00',1.18),('8784','2014-02-12','10:30:00',1.46),('8784','2014-02-12','10:35:00',1.56),('8784','2014-02-12','10:40:00',1.34),('8784','2014-02-12','10:45:00',1.9),('8784','2014-02-12','10:50:00',1.41),('8784','2014-02-12','10:55:00',1.44),('8784','2014-02-12','11:00:00',1.54),('8784','2014-02-12','11:05:00',2.27),('8784','2014-02-12','11:10:00',1.61),('8784','2014-02-12','11:15:00',1.5),('8784','2014-02-12','11:20:00',1.53),('8784','2014-02-12','11:25:00',1.63),('8784','2014-02-12','11:30:00',1.6),('8784','2014-02-12','11:35:00',2.06),('8784','2014-02-12','11:40:00',1.14),('8784','2014-02-12','12:10:00',1.26),('8784','2014-02-12','12:15:00',1.36),('8784','2014-02-12','12:20:00',1.39),('8784','2014-02-12','12:25:00',1.46),('8784','2014-02-12','12:30:00',1.54),('8784','2014-02-12','12:35:00',1.49),('8784','2014-02-12','12:40:00',1.47),('8784','2014-02-12','12:45:00',1.63),('8784','2014-02-12','12:50:00',1.78),('8784','2014-02-12','12:55:00',1.83),('8784','2014-02-12','13:00:00',2.07),('8784','2014-02-12','13:05:00',1.82),('8784','2014-02-12','13:10:00',1.77),('8784','2014-02-12','13:15:00',1.37),('8784','2014-02-12','13:20:00',1.34),('8784','2014-02-12','13:25:00',1.56),('8784','2014-02-12','13:30:00',2.75),('8784','2014-02-12','13:35:00',2.54),('8784','2014-02-12','13:40:00',3.05),('8784','2014-02-12','13:45:00',2.22),('8784','2014-02-12','13:50:00',2.21),('8784','2014-02-12','13:55:00',2.05),('8784','2014-02-12','14:00:00',2.96),('8784','2014-02-12','14:05:00',2.88),('8784','2014-02-12','14:10:00',2.73),('8784','2014-02-12','14:15:00',2.36),('8784','2014-02-12','14:20:00',2.13),('8784','2014-02-12','14:25:00',1.62),('8784','2014-02-12','14:30:00',1.61),('8784','2014-02-12','14:35:00',2.28),('8784','2014-02-12','14:40:00',1.46),('8784','2014-02-12','14:45:00',2.5),('8784','2014-02-12','14:50:00',2.35),('8784','2014-02-12','14:55:00',2),('8784','2014-02-12','15:00:00',1.45),('8784','2014-02-12','15:10:00',1.25),('8784','2014-02-12','15:15:00',1.4),('8784','2014-02-12','15:20:00',1.67),('8784','2014-02-12','15:25:00',1.02),('8784','2014-02-12','15:30:00',1.65),('8784','2014-02-12','15:35:00',1.66),('8784','2014-02-12','15:40:00',1.73),('8784','2014-02-12','15:45:00',1.04),('8784','2014-02-12','15:50:00',1.58),('8784','2014-02-11','09:20:00',1.02),('8784','2014-02-11','09:25:00',1.15),('8784','2014-02-11','09:30:00',1.2),('8784','2014-02-11','09:35:00',1.23),('8784','2014-02-11','09:40:00',1.2),('8784','2014-02-11','09:45:00',1.2),('8784','2014-02-11','09:50:00',1.23),('8784','2014-02-11','09:55:00',1.22),('8784','2014-02-11','10:00:00',1.12),('8784','2014-02-11','10:10:00',1.36),('8784','2014-02-11','10:15:00',1.57),('8784','2014-02-11','10:20:00',1.84),('8784','2014-02-11','10:25:00',1.9),('8784','2014-02-11','10:30:00',2.02),('8784','2014-02-11','10:35:00',2.25),('8784','2014-02-11','10:40:00',2.25),('8784','2014-02-11','10:45:00',2.17),('8784','2014-02-11','10:50:00',2.34),('8784','2014-02-11','10:55:00',2.04),('8784','2014-02-11','11:00:00',1.85),('8784','2014-02-11','11:05:00',2.15),('8784','2014-02-11','11:10:00',2.15),('8784','2014-02-11','11:15:00',1.99),('8784','2014-02-11','11:20:00',1.58),('8784','2014-02-11','11:25:00',1.58),('8784','2014-02-11','11:30:00',1.67),('8784','2014-02-11','11:35:00',1.61),('8784','2014-02-11','11:40:00',1.57),('8784','2014-02-11','11:45:00',2.11),('8784','2014-02-11','11:50:00',1.54),('8784','2014-02-11','11:55:00',1.3),('8784','2014-02-11','12:00:00',1.36),('8784','2014-02-11','12:05:00',1.63),('8784','2014-02-11','12:10:00',1.93),('8784','2014-02-11','12:15:00',1.65),('8784','2014-02-11','12:20:00',1.76),('8784','2014-02-11','12:25:00',2.33),('8784','2014-02-11','12:30:00',2.21),('8784','2014-02-11','12:35:00',1.99),('8784','2014-02-11','12:40:00',1.51),('8784','2014-02-11','12:45:00',1.76),('8784','2014-02-11','12:50:00',1.44),('8784','2014-02-11','12:55:00',1.74),('8784','2014-02-11','13:00:00',1.78),('8784','2014-02-11','13:05:00',2.16),('8784','2014-02-11','13:10:00',2.66),('8784','2014-02-11','13:15:00',2.51),('8784','2014-02-11','13:20:00',2.84),('8784','2014-02-11','13:25:00',2.56),('8784','2014-02-11','13:30:00',2.35),('8784','2014-02-11','13:35:00',2.23),('8784','2014-02-11','13:40:00',2.61),('8784','2014-02-11','13:45:00',1.96),('8784','2014-02-11','13:50:00',1.57),('8784','2014-02-11','13:55:00',1.38),('8784','2014-02-11','14:00:00',1.78),('8784','2014-02-11','14:05:00',2.03),('8784','2014-02-11','14:10:00',1.53),('8784','2014-02-11','14:15:00',2.01),('8784','2014-02-11','14:20:00',1.5),('8784','2014-02-11','14:25:00',1.4),('8784','2014-02-11','14:30:00',1.47),('8784','2014-02-11','14:35:00',1.39),('8784','2014-02-11','14:40:00',1.16),('8784','2014-02-11','14:45:00',1.17),('8784','2014-02-11','15:10:00',1),('8784','2014-02-11','15:15:00',1.3),('8784','2014-02-11','15:20:00',1.4),('8784','2014-02-11','15:25:00',1.1),('8784','2014-02-10','12:55:00',1.04),('8784','2014-02-10','13:00:00',1.36),('8784','2014-02-10','13:05:00',1.15),('8784','2014-02-10','13:55:00',1.01),('8784','2014-02-10','14:00:00',1.05),('8784','2014-02-10','14:30:00',1.05),('8784','2014-02-10','14:35:00',1.12),('8784','2014-02-10','14:40:00',1.17),('8784','2014-02-10','14:45:00',1.06),('8784','2014-02-09','11:25:00',1.07),('8784','2014-02-09','11:30:00',1.2),('8784','2014-02-09','11:35:00',1.5),('8784','2014-02-09','12:15:00',1.01),('8784','2014-02-09','12:25:00',1.47),('8784','2014-02-09','12:30:00',1.52),('8784','2014-02-09','12:45:00',1.95),('8784','2014-02-09','12:55:00',1.92),('8784','2014-02-09','13:00:00',1.61),('8784','2014-02-09','13:05:00',2.93),('8784','2014-02-09','13:10:00',1.97),('8784','2014-02-09','13:15:00',1.49),('8784','2014-02-09','13:25:00',1.07),('8784','2014-02-09','13:40:00',1.59),('8784','2014-02-09','13:45:00',2.61),('8784','2014-02-09','13:50:00',1.39),('8784','2014-02-09','13:55:00',1.99),('8784','2014-02-09','14:00:00',1.51),('8784','2014-02-09','14:05:00',2.2),('8784','2014-02-09','14:10:00',1.82),('8784','2014-02-09','14:15:00',1.19),('8784','2014-02-09','14:20:00',1.17),('8784','2014-02-09','14:25:00',1.57),('8784','2014-02-09','14:30:00',1.68),('8784','2014-02-09','14:35:00',1.57),('8784','2014-02-09','14:40:00',1.03),('8784','2014-02-09','14:50:00',1.82),('8784','2014-02-09','15:15:00',1.28),('8784','2014-02-09','15:20:00',1.47),('8784','2014-02-09','15:25:00',1.36),('8784','2014-02-09','15:45:00',1.03),('8784','2014-02-09','15:50:00',1.05),('8784','2014-02-08','09:50:00',1.66),('8784','2014-02-08','10:15:00',1.31),('8784','2014-02-08','10:20:00',1.09),('8784','2014-02-08','10:25:00',1.07),('8784','2014-02-08','10:30:00',2.06),('8784','2014-02-08','10:35:00',2.44),('8784','2014-02-08','10:40:00',1.09),('8784','2014-02-08','10:45:00',1.53),('8784','2014-02-08','10:50:00',1.95),('8784','2014-02-08','10:55:00',2.15),('8784','2014-02-08','11:00:00',1.82),('8784','2014-02-08','11:05:00',2.82),('8784','2014-02-08','11:10:00',1.97),('8784','2014-02-08','11:15:00',1.81),('8784','2014-02-08','11:20:00',1.14),('8784','2014-02-08','11:30:00',2.01),('8784','2014-02-08','11:35:00',3.47),('8784','2014-02-08','11:40:00',1.75),('8784','2014-02-08','11:50:00',1.77),('8784','2014-02-08','11:55:00',3.35),('8784','2014-02-08','12:10:00',2.18),('8784','2014-02-08','12:15:00',2.83),('8784','2014-02-08','12:25:00',2.75),('8784','2014-02-08','12:30:00',3.24),('8784','2014-02-08','12:35:00',2.33),('8784','2014-02-08','12:40:00',1.74),('8784','2014-02-08','12:45:00',3.24),('8784','2014-02-08','12:50:00',2.6),('8784','2014-02-08','12:55:00',2.93),('8784','2014-02-08','13:00:00',2.65),('8784','2014-02-08','13:10:00',2.18),('8784','2014-02-08','13:15:00',3.67),('8784','2014-02-08','13:20:00',3.31),('8784','2014-02-08','13:25:00',2.74),('8784','2014-02-08','13:30:00',1.89),('8784','2014-02-08','13:35:00',1.85),('8784','2014-02-08','13:40:00',2.37),('8784','2014-02-08','13:45:00',2.89),('8784','2014-02-08','13:50:00',2.44),('8784','2014-02-08','13:55:00',2.61),('8784','2014-02-08','14:00:00',2.57),('8784','2014-02-08','14:05:00',2.57),('8784','2014-02-08','14:10:00',2.44),('8784','2014-02-08','14:15:00',1.15),('8784','2014-02-08','14:20:00',2.17),('8784','2014-02-08','14:25:00',1.66),('8784','2014-02-08','14:30:00',2.4),('8784','2014-02-08','14:35:00',1.29),('8784','2014-02-08','14:40:00',1.45),('8784','2014-02-08','14:50:00',2.09),('8784','2014-02-08','14:55:00',1.96),('8784','2014-02-08','15:00:00',1.09),('8784','2014-02-08','15:15:00',1.08),('8784','2014-02-08','15:20:00',1.76),('8784','2014-02-08','15:40:00',1.5),('8784','2014-02-08','15:45:00',1.42),('8784','2014-02-08','15:50:00',1.18),('8784','2014-02-07','09:10:00',1.15),('8784','2014-02-07','09:15:00',1.29),('8784','2014-02-07','09:20:00',1.31),('8784','2014-02-07','09:25:00',1.35),('8784','2014-02-07','09:30:00',1.45),('8784','2014-02-07','09:35:00',1.54),('8784','2014-02-07','09:40:00',1.7),('8784','2014-02-07','09:45:00',1.75),('8784','2014-02-07','09:50:00',1.83),('8784','2014-02-07','09:55:00',1.88),('8784','2014-02-07','10:00:00',1.95),('8784','2014-02-07','10:05:00',1.97),('8784','2014-02-07','10:10:00',2.16),('8784','2014-02-07','10:15:00',2.33),('8784','2014-02-07','10:20:00',2.4),('8784','2014-02-07','10:25:00',2.22),('8784','2014-02-07','10:30:00',1.87),('8784','2014-02-07','10:35:00',2.61),('8784','2014-02-07','10:40:00',2.45),('8784','2014-02-07','10:45:00',2.77),('8784','2014-02-07','10:50:00',2.81),('8784','2014-02-07','10:55:00',2.9),('8784','2014-02-07','11:00:00',2.98),('8784','2014-02-07','11:05:00',3.04),('8784','2014-02-07','11:10:00',3.02),('8784','2014-02-07','11:15:00',3.11),('8784','2014-02-07','11:20:00',2.97),('8784','2014-02-07','11:25:00',2.58),('8784','2014-02-07','11:30:00',2.88),('8784','2014-02-07','11:35:00',2.7),('8784','2014-02-07','11:40:00',3.04),('8784','2014-02-07','11:45:00',2.04),('8784','2014-02-07','11:50:00',2.73),('8784','2014-02-07','11:55:00',2.73),('8784','2014-02-07','12:00:00',2.32),('8784','2014-02-07','12:05:00',2.31),('8784','2014-02-07','12:10:00',2),('8784','2014-02-07','12:15:00',3.46),('8784','2014-02-07','12:20:00',2.51),('8784','2014-02-07','12:25:00',1.63),('8784','2014-02-07','12:30:00',1.9),('8784','2014-02-07','12:35:00',1.11),('8784','2014-02-07','12:40:00',1.57),('8784','2014-02-07','12:45:00',1.64),('8784','2014-02-07','12:50:00',3.47),('8784','2014-02-07','12:55:00',2.55),('8784','2014-02-07','13:00:00',1.43),('8784','2014-02-07','13:05:00',2.36),('8784','2014-02-07','13:10:00',3.08),('8784','2014-02-07','13:15:00',1.38),('8784','2014-02-07','13:20:00',1.99),('8784','2014-02-07','13:25:00',1.31),('8784','2014-02-07','13:30:00',1.25),('8784','2014-02-07','13:35:00',1.83),('8784','2014-02-07','13:40:00',1.03),('8784','2014-02-07','13:45:00',2.65),('8784','2014-02-07','13:50:00',2.56),('8784','2014-02-07','13:55:00',2.8),('8784','2014-02-07','14:00:00',1.64),('8784','2014-02-07','14:05:00',2.31),('8784','2014-02-07','14:10:00',2.35),('8784','2014-02-07','14:15:00',2),('8784','2014-02-07','14:20:00',1.87),('8784','2014-02-07','14:25:00',1.45),('8784','2014-02-07','14:30:00',1.83),('8784','2014-02-07','14:35:00',2.56),('8784','2014-02-07','14:40:00',2.34),('8784','2014-02-07','14:45:00',2.07),('8784','2014-02-07','14:50:00',2.01),('8784','2014-02-07','14:55:00',1.9),('8784','2014-02-07','15:00:00',1.77),('8784','2014-02-07','15:05:00',1.69),('8784','2014-02-07','15:10:00',1.63),('8784','2014-02-07','15:15:00',1.58),('8784','2014-02-07','15:20:00',1.55),('8784','2014-02-07','15:25:00',1.44),('8784','2014-02-07','15:30:00',1.36),('8784','2014-02-07','15:35:00',1.29),('8784','2014-02-07','15:40:00',1.23),('8784','2014-02-07','15:45:00',1.16),('8784','2014-02-07','15:50:00',1.07),('8784','2014-02-06','09:00:00',1.04),('8784','2014-02-06','09:05:00',1.17),('8784','2014-02-06','09:10:00',1.25),('8784','2014-02-06','09:15:00',1.23),('8784','2014-02-06','09:40:00',1.21),('8784','2014-02-06','09:45:00',1.75),('8784','2014-02-06','09:50:00',1.85),('8784','2014-02-06','09:55:00',1.91),('8784','2014-02-06','10:00:00',1.97),('8784','2014-02-06','10:05:00',2.01),('8784','2014-02-06','10:10:00',2.13),('8784','2014-02-06','10:15:00',2.28),('8784','2014-02-06','10:20:00',2.32),('8784','2014-02-06','10:25:00',2.15),('8784','2014-02-06','10:30:00',2.39),('8784','2014-02-06','10:35:00',2.21),('8784','2014-02-06','10:40:00',2.19),('8784','2014-02-06','10:45:00',2.29),('8784','2014-02-06','10:50:00',1.98),('8784','2014-02-06','10:55:00',2.15),('8784','2014-02-06','11:00:00',1.89),('8784','2014-02-06','11:05:00',1.95),('8784','2014-02-06','11:10:00',1.36),('8784','2014-02-06','11:15:00',1.61),('8784','2014-02-06','11:20:00',2.79),('8784','2014-02-06','11:25:00',1.9),('8784','2014-02-06','11:30:00',3.22),('8784','2014-02-06','11:35:00',2.94),('8784','2014-02-06','11:40:00',2.85),('8784','2014-02-06','11:45:00',2.88),('8784','2014-02-06','11:50:00',2.92),('8784','2014-02-06','11:55:00',2.93),('8784','2014-02-06','12:00:00',2.93),('8784','2014-02-06','12:05:00',3.03),('8784','2014-02-06','12:10:00',2.98),('8784','2014-02-06','12:15:00',2.97),('8784','2014-02-06','12:20:00',2.95),('8784','2014-02-06','12:25:00',2.92),('8784','2014-02-06','12:30:00',2.91),('8784','2014-02-06','12:35:00',2.48),('8784','2014-02-06','12:40:00',2.99),('8784','2014-02-06','12:45:00',2.95),('8784','2014-02-06','12:50:00',2.87),('8784','2014-02-06','12:55:00',2.68),('8784','2014-02-06','13:00:00',2.79),('8784','2014-02-06','13:05:00',2.29),('8784','2014-02-06','13:10:00',2.9),('8784','2014-02-06','13:15:00',2.83),('8784','2014-02-06','13:20:00',2.83),('8784','2014-02-06','13:25:00',1.63),('8784','2014-02-06','13:30:00',2.46),('8784','2014-02-06','13:35:00',2.66),('8784','2014-02-06','13:40:00',2.66),('8784','2014-02-06','13:45:00',2.59),('8784','2014-02-06','13:50:00',2.6),('8784','2014-02-06','13:55:00',2.56),('8784','2014-02-06','14:00:00',2.4),('8784','2014-02-06','14:05:00',2.36),('8784','2014-02-06','14:10:00',1.89),('8784','2014-02-06','14:15:00',2.24),('8784','2014-02-06','14:20:00',2.24),('8784','2014-02-06','14:25:00',2.26),('8784','2014-02-06','14:30:00',2.23),('8784','2014-02-06','14:35:00',2.12),('8784','2014-02-06','14:40:00',2.1),('8784','2014-02-06','14:45:00',2.08),('8784','2014-02-06','14:50:00',2.04),('8784','2014-02-06','14:55:00',1.86),('8784','2014-02-06','15:00:00',1.79),('8784','2014-02-06','15:05:00',1.73),('8784','2014-02-06','15:10:00',1.59),('8784','2014-02-06','15:15:00',1.58),('8784','2014-02-06','15:20:00',1.57),('8784','2014-02-06','15:25:00',1.4),('8784','2014-02-06','15:30:00',1.31),('8784','2014-02-06','15:35:00',1.24),('8784','2014-02-06','15:40:00',1.18),('8784','2014-02-06','15:45:00',1.11),('8784','2014-02-06','15:50:00',1.04),('8784','2014-04-27','09:20:00',1.02),('8784','2014-04-27','10:00:00',1.24),('8784','2014-04-27','10:05:00',1.33),('8784','2014-04-27','10:10:00',1.27),('8784','2014-04-27','10:15:00',1.23),('8784','2014-04-27','10:20:00',1.24),('8784','2014-04-27','10:25:00',1.11),('8784','2014-04-27','11:00:00',1.13),('8784','2014-04-27','11:05:00',1.33),('8784','2014-04-27','11:10:00',1.31),('8784','2014-04-27','11:15:00',1.32),('8784','2014-04-27','11:35:00',1.52),('8784','2014-04-27','11:40:00',1.77),('8784','2014-04-27','11:45:00',3.96),('8784','2014-04-27','11:50:00',3.19),('8784','2014-04-27','11:55:00',2.89),('8784','2014-04-27','12:00:00',2.69),('8784','2014-04-27','12:05:00',3.07),('8784','2014-04-27','12:10:00',3.24),('8784','2014-04-27','12:15:00',3.42),('8784','2014-04-27','12:20:00',3.06),('8784','2014-04-27','12:25:00',3),('8784','2014-04-27','12:30:00',2.7),('8784','2014-04-27','12:35:00',2.85),('8784','2014-04-27','12:40:00',2.51),('8784','2014-04-27','12:45:00',2.84),('8784','2014-04-27','12:50:00',2.33),('8784','2014-04-27','12:55:00',2.16),('8784','2014-04-27','13:00:00',2.65),('8784','2014-04-27','13:05:00',2.35),('8784','2014-04-27','13:10:00',2.01),('8784','2014-04-27','13:15:00',2.1),('8784','2014-04-27','13:20:00',2.63),('8784','2014-04-27','13:25:00',2.37),('8784','2014-04-27','13:30:00',2.19),('8784','2014-04-27','13:35:00',1.95),('8784','2014-04-27','13:40:00',1.82),('8784','2014-04-27','13:45:00',1.85),('8784','2014-04-27','13:50:00',1.84),('8784','2014-04-27','13:55:00',1.7),('8784','2014-04-27','14:00:00',2.13),('8784','2014-04-27','14:05:00',2.39),('8784','2014-04-27','14:10:00',1.67),('8784','2014-04-27','14:15:00',1.59),('8784','2014-04-27','14:20:00',1.94),('8784','2014-04-27','14:25:00',2.43),('8784','2014-04-27','14:30:00',2.47),('8784','2014-04-27','14:35:00',2.51),('8784','2014-04-27','14:40:00',2.59),('8784','2014-04-27','14:45:00',2.21),('8784','2014-04-27','14:50:00',2.1),('8784','2014-04-27','14:55:00',2.24),('8784','2014-04-27','15:00:00',2.42),('8784','2014-04-27','15:05:00',3.46),('8784','2014-04-27','15:10:00',4.41),('8784','2014-04-27','15:15:00',2.97),('8784','2014-04-27','15:20:00',1.97),('8784','2014-04-27','15:25:00',1.22),('8784','2014-04-27','15:35:00',1.11),('8784','2014-04-27','15:40:00',1.16),('8784','2014-02-05','10:15:00',1.72),('8784','2014-02-05','10:20:00',2.85),('8784','2014-02-05','10:25:00',2.55),('8784','2014-02-05','10:35:00',1.08),('8784','2014-02-05','10:40:00',1.08),('8784','2014-02-05','10:55:00',1.05),('8784','2014-02-05','11:10:00',1.5),('8784','2014-02-05','11:15:00',2.53),('8784','2014-02-05','11:20:00',3.69),('8784','2014-02-05','11:25:00',1.84),('8784','2014-02-05','11:30:00',1.18),('8784','2014-02-05','12:55:00',1.37),('8784','2014-02-05','13:00:00',1.1),('8784','2014-02-05','13:05:00',1.23),('8784','2014-02-05','13:10:00',1.49),('8784','2014-02-05','13:15:00',1.21),('8784','2014-02-05','13:20:00',1.45),('8784','2014-02-05','13:25:00',1.67),('8784','2014-02-05','13:30:00',1.64),('8784','2014-02-05','13:35:00',1.99),('8784','2014-02-05','13:40:00',2.03),('8784','2014-02-05','13:45:00',1.99),('8784','2014-02-05','13:50:00',1.72),('8784','2014-02-05','13:55:00',1.25),('8784','2014-02-05','14:30:00',2.55),('8784','2014-02-05','14:35:00',1.73),('8784','2014-02-04','09:15:00',1),('8784','2014-02-04','09:20:00',1.22),('8784','2014-02-04','09:25:00',1.27),('8784','2014-02-04','09:30:00',1.39),('8784','2014-02-04','09:35:00',1.2),('8784','2014-02-04','09:45:00',1.25),('8784','2014-02-04','09:50:00',1.82),('8784','2014-02-04','09:55:00',1.29),('8784','2014-02-04','10:00:00',1.9),('8784','2014-02-04','10:05:00',2.21),('8784','2014-02-04','10:10:00',1.51),('8784','2014-02-04','10:15:00',1.57),('8784','2014-02-04','10:20:00',1.21),('8784','2014-02-04','10:40:00',1.12),('8784','2014-02-04','10:45:00',1.39),('8784','2014-02-04','10:50:00',1.95),('8784','2014-02-04','10:55:00',2.47),('8784','2014-02-04','11:00:00',3.01),('8784','2014-02-04','11:05:00',1.26),('8784','2014-02-04','11:10:00',1.05),('8784','2014-02-04','11:20:00',1.06),('8784','2014-02-04','11:50:00',1.53),('8784','2014-02-04','11:55:00',3.15),('8784','2014-02-04','12:00:00',2.46),('8784','2014-02-04','12:05:00',1.57),('8784','2014-02-04','12:10:00',1.94),('8784','2014-02-04','12:15:00',1.67),('8784','2014-02-04','12:20:00',1.65),('8784','2014-02-04','12:25:00',1.4),('8784','2014-02-04','12:30:00',1.05),('8784','2014-02-04','12:45:00',1.17),('8784','2014-02-04','12:50:00',1.17),('8784','2014-02-04','12:55:00',1.08),('8784','2014-02-04','13:00:00',1.33),('8784','2014-02-04','13:05:00',1.37),('8784','2014-02-04','13:10:00',1.21),('8784','2014-02-04','13:15:00',1.37),('8784','2014-02-04','13:20:00',1.66),('8784','2014-02-04','13:25:00',1.52),('8784','2014-02-04','13:30:00',1.19),('8784','2014-02-04','13:35:00',1.07),('8784','2014-02-04','13:40:00',1.03),('8784','2014-02-03','09:50:00',1.04),('8784','2014-02-03','10:15:00',1.14),('8784','2014-02-03','10:20:00',1.07),('8784','2014-02-03','10:25:00',1.09),('8784','2014-02-03','10:30:00',1.11),('8784','2014-02-03','10:35:00',1.11),('8784','2014-02-03','10:40:00',1.17),('8784','2014-02-03','10:45:00',1.18),('8784','2014-02-03','10:50:00',1.15),('8784','2014-02-03','10:55:00',1.16),('8784','2014-02-03','11:00:00',1.1),('8784','2014-02-03','11:05:00',1.07),('8784','2014-02-03','11:10:00',1.05),('8784','2014-02-03','11:15:00',1.05),('8784','2014-02-03','11:20:00',1.11),('8784','2014-02-03','11:25:00',1.22),('8784','2014-02-03','11:30:00',1.35),('8784','2014-02-03','11:35:00',1.39),('8784','2014-02-03','11:40:00',1.39),('8784','2014-02-03','11:45:00',1.4),('8784','2014-02-03','11:50:00',1.37),('8784','2014-02-03','11:55:00',1.24),('8784','2014-02-03','12:00:00',1.11),('8784','2014-02-03','12:05:00',1.04),('8784','2014-02-03','12:10:00',1.05),('8784','2014-02-03','12:15:00',1.13),('8784','2014-02-03','12:20:00',1.12),('8784','2014-02-03','12:25:00',1.01),('8784','2014-02-03','14:30:00',1.02),('8784','2014-02-03','14:35:00',1.02),('8784','2014-02-03','14:40:00',1.01),('8784','2014-02-02','12:00:00',1.08),('8784','2014-02-02','12:05:00',1.11),('8784','2014-02-02','12:10:00',1.08),('8784','2014-02-01','11:00:00',1.25),('8784','2014-02-01','11:05:00',1.12),('8784','2014-02-01','11:15:00',1.11),('8784','2014-02-01','11:20:00',1.83),('8784','2014-02-01','11:25:00',1.32),('8784','2014-02-01','11:30:00',1.69),('8784','2014-02-01','11:35:00',1.6),('8784','2014-02-01','11:55:00',1.59),('8784','2014-02-01','12:00:00',1.29),('8784','2014-02-01','12:05:00',1.27),('8784','2014-02-01','12:10:00',1.82),('8784','2014-02-01','12:15:00',1.39),('8784','2014-02-01','12:20:00',2.2),('8784','2014-02-01','12:25:00',1.7),('8784','2014-02-01','12:35:00',1.08),('8784','2014-02-01','12:40:00',1.34),('8784','2014-02-01','12:45:00',2.03),('8784','2014-02-01','12:50:00',2.02),('8784','2014-02-01','12:55:00',1.77),('8784','2014-02-01','13:00:00',1.66),('8784','2014-02-01','13:05:00',1.25),('8784','2014-01-30','09:50:00',1.15),('8784','2014-01-30','09:55:00',1.56),('8784','2014-01-30','10:00:00',1.59),('8784','2014-01-30','10:05:00',1.21),('8784','2014-01-30','10:10:00',1.54),('8784','2014-01-30','10:15:00',2.06),('8784','2014-01-30','10:20:00',1.8),('8784','2014-01-30','10:25:00',2.19),('8784','2014-01-30','10:30:00',2.33),('8784','2014-01-30','10:35:00',2.33),('8784','2014-01-30','10:40:00',2.37),('8784','2014-01-30','10:45:00',2.07),('8784','2014-01-30','10:50:00',2.54),('8784','2014-01-30','10:55:00',2.99),('8784','2014-01-30','11:00:00',2.98),('8784','2014-01-30','11:05:00',2.84),('8784','2014-01-30','11:10:00',2.48),('8784','2014-01-30','11:15:00',2.28),('8784','2014-01-30','11:20:00',1.56),('8784','2014-01-30','11:25:00',2.25),('8784','2014-01-30','11:30:00',2.15),('8784','2014-01-30','11:35:00',2.17),('8784','2014-01-30','11:40:00',1.96),('8784','2014-01-30','11:45:00',2.65),('8784','2014-01-30','11:50:00',2.66),('8784','2014-01-30','11:55:00',2.64),('8784','2014-01-30','12:00:00',2.05),('8784','2014-01-30','12:05:00',2.84),('8784','2014-01-30','12:10:00',2.72),('8784','2014-01-30','12:15:00',2.55),('8784','2014-01-30','12:20:00',2.99),('8784','2014-01-30','12:25:00',2.41),('8784','2014-01-30','12:30:00',2.18),('8784','2014-01-30','12:35:00',2.29),('8784','2014-01-30','12:40:00',2.19),('8784','2014-01-30','12:45:00',2.59),('8784','2014-01-30','12:50:00',2.64),('8784','2014-01-30','12:55:00',2.43),('8784','2014-01-30','13:00:00',2.56),('8784','2014-01-30','13:05:00',2.79),('8784','2014-01-30','13:10:00',2.27),('8784','2014-01-30','13:15:00',2.55),('8784','2014-01-30','13:20:00',2.21),('8784','2014-01-30','13:25:00',2.35),('8784','2014-01-30','13:30:00',1.93),('8784','2014-01-30','13:35:00',1.75),('8784','2014-01-30','13:40:00',2.22),('8784','2014-01-30','13:45:00',2.41),('8784','2014-01-30','13:50:00',2.17),('8784','2014-01-30','13:55:00',1.92),('8784','2014-01-30','14:00:00',1.91),('8784','2014-01-30','14:05:00',1.82),('8784','2014-01-30','14:10:00',1.82),('8784','2014-01-30','14:15:00',1.61),('8784','2014-01-30','14:20:00',1.47),('8784','2014-01-30','14:25:00',1.57),('8784','2014-01-30','14:30:00',1.65),('8784','2014-01-30','14:35:00',1.57),('8784','2014-01-30','14:40:00',1.78),('8784','2014-01-30','14:45:00',1.65),('8784','2014-01-30','14:50:00',1.73),('8784','2014-01-30','14:55:00',1.62),('8784','2014-01-30','15:00:00',1.52),('8784','2014-01-30','15:05:00',1.45),('8784','2014-01-30','15:10:00',1.41),('8784','2014-01-30','15:15:00',1.33),('8784','2014-01-30','15:20:00',1.36),('8784','2014-01-30','15:25:00',1.35),('8784','2014-01-30','15:30:00',1.2),('8784','2014-01-30','15:35:00',1.19),('8784','2014-01-30','15:40:00',1.1),('8784','2014-01-29','09:30:00',1.04),('8784','2014-01-29','09:35:00',1.3),('8784','2014-01-29','09:40:00',1.3),('8784','2014-01-29','09:45:00',1.52),('8784','2014-01-29','09:50:00',1.47),('8784','2014-01-29','09:55:00',1.53),('8784','2014-01-29','10:00:00',1.26),('8784','2014-01-29','10:05:00',1.29),('8784','2014-01-29','10:10:00',1.66),('8784','2014-01-29','10:15:00',1.64),('8784','2014-01-29','10:20:00',1.26),('8784','2014-01-29','10:25:00',2.46),('8784','2014-01-29','10:30:00',2.66),('8784','2014-01-29','10:35:00',2.24),('8784','2014-01-29','10:40:00',2.08),('8784','2014-01-29','10:45:00',1.99),('8784','2014-01-29','10:50:00',2.01),('8784','2014-01-29','10:55:00',1.79),('8784','2014-01-29','11:00:00',1.83),('8784','2014-01-29','11:05:00',2.03),('8784','2014-01-29','11:10:00',1.74),('8784','2014-01-29','11:15:00',1.79),('8784','2014-01-29','11:20:00',1.92),('8784','2014-01-29','11:25:00',1.97),('8784','2014-01-29','11:30:00',2.44),('8784','2014-01-29','11:35:00',2.24),('8784','2014-01-29','11:40:00',1.25),('8784','2014-01-29','11:45:00',1.22),('8784','2014-01-29','12:45:00',1.2),('8784','2014-01-29','12:50:00',2.48),('8784','2014-01-29','12:55:00',2.64),('8784','2014-01-29','13:00:00',1.53),('8784','2014-01-29','13:05:00',1.34),('8784','2014-01-29','13:35:00',1.69),('8784','2014-01-29','13:40:00',2.65),('8784','2014-01-29','13:45:00',2.01),('8784','2014-01-29','13:50:00',1.55),('8784','2014-01-29','13:55:00',2.12),('8784','2014-01-29','14:00:00',1.06),('8784','2014-01-29','15:10:00',1.05),('8784','2014-01-29','15:15:00',1.4),('8784','2014-01-29','15:20:00',1.03),('8784','2014-01-28','09:35:00',1.11),('8784','2014-01-28','09:40:00',1),('8784','2014-01-28','09:45:00',1.31),('8784','2014-01-28','09:50:00',1.51),('8784','2014-01-28','09:55:00',1.65),('8784','2014-01-28','10:00:00',1.63),('8784','2014-01-28','10:05:00',1.59),('8784','2014-01-28','10:10:00',1.63),('8784','2014-01-28','10:15:00',1.81),('8784','2014-01-28','10:20:00',1.96),('8784','2014-01-28','10:25:00',2.12),('8784','2014-01-28','10:30:00',2.11),('8784','2014-01-28','10:35:00',2.21),('8784','2014-01-28','10:40:00',2.28),('8784','2014-01-28','10:45:00',2.12),('8784','2014-01-28','10:50:00',2.26),('8784','2014-01-28','10:55:00',1.77),('8784','2014-01-28','11:00:00',2.71),('8784','2014-01-28','11:05:00',1.82),('8784','2014-01-28','11:10:00',1.62),('8784','2014-01-28','11:15:00',1.53),('8784','2014-01-28','11:25:00',1.95),('8784','2014-01-28','11:30:00',1.29),('8784','2014-01-28','11:35:00',1.96),('8784','2014-01-28','11:40:00',3),('8784','2014-01-28','11:45:00',2.4),('8784','2014-01-28','12:00:00',2.61),('8784','2014-01-28','12:05:00',2.71),('8784','2014-01-28','12:10:00',1.86),('8784','2014-01-28','12:15:00',2.44),('8784','2014-01-28','12:20:00',1.49),('8784','2014-01-28','12:25:00',1.18),('8784','2014-01-28','12:30:00',1.19),('8784','2014-01-28','12:35:00',1.52),('8784','2014-01-28','12:40:00',1.64),('8784','2014-01-28','12:45:00',2.22),('8784','2014-01-28','12:50:00',2.53),('8784','2014-01-28','12:55:00',2.84),('8784','2014-01-28','13:00:00',2.86),('8784','2014-01-28','13:05:00',3.01),('8784','2014-01-28','13:10:00',2.18),('8784','2014-01-28','13:15:00',2.41),('8784','2014-01-28','13:20:00',2.2),('8784','2014-01-28','13:25:00',2.52),('8784','2014-01-28','13:30:00',2.54),('8784','2014-01-28','13:35:00',2.65),('8784','2014-01-28','13:40:00',2.52),('8784','2014-01-28','13:45:00',2.39),('8784','2014-01-28','13:50:00',2.27),('8784','2014-01-28','13:55:00',2.23),('8784','2014-01-28','14:00:00',2.2),('8784','2014-01-28','14:05:00',2.14),('8784','2014-01-28','14:10:00',2.1),('8784','2014-01-28','14:15:00',2.08),('8784','2014-01-28','14:20:00',2.03),('8784','2014-01-28','14:25:00',2.04),('8784','2014-01-28','14:30:00',2.02),('8784','2014-01-28','14:35:00',1.86),('8784','2014-01-28','14:40:00',1.77),('8784','2014-01-28','14:45:00',1.74),('8784','2014-01-28','14:50:00',1.62),('8784','2014-01-28','14:55:00',1.57),('8784','2014-01-28','15:00:00',1.54),('8784','2014-01-28','15:05:00',1.46),('8784','2014-01-28','15:10:00',1.36),('8784','2014-01-28','15:15:00',1.28),('8784','2014-01-28','15:20:00',1.23),('8784','2014-01-28','15:25:00',1.17),('8784','2014-01-28','15:30:00',1.1),('8784','2014-01-28','15:35:00',1.02),('8784','2014-01-27','11:05:00',1.09),('8784','2014-01-27','11:20:00',1.11),('8784','2014-01-27','11:25:00',1.12),('8902','2014-05-04','07:40:00',1.16),('8902','2014-05-04','07:45:00',1.55),('8902','2014-05-04','07:50:00',1.72),('8902','2014-05-04','07:55:00',1.88),('8902','2014-05-04','08:00:00',2.07),('8902','2014-05-04','08:05:00',2.26),('8902','2014-05-04','08:10:00',2.45),('8902','2014-05-04','08:15:00',2.66),('8902','2014-05-04','08:20:00',2.84),('8902','2014-05-04','08:25:00',3.04),('8902','2014-05-04','08:30:00',3.24),('8902','2014-05-04','08:35:00',3.44),('8902','2014-05-04','08:40:00',3.64),('8902','2014-05-04','08:45:00',3.82),('8902','2014-05-04','08:50:00',3.98),('8902','2014-05-04','08:55:00',4.13),('8902','2014-05-04','09:00:00',4.26),('8902','2014-05-04','09:05:00',4.42),('8902','2014-05-04','09:10:00',4.58),('8902','2014-05-04','09:15:00',4.76),('8902','2014-05-04','09:20:00',4.9),('8902','2014-05-04','09:25:00',5.08),('8902','2014-05-04','09:30:00',5.25),('8902','2014-05-04','09:35:00',5.42),('8902','2014-05-04','09:40:00',5.61),('8902','2014-05-04','09:45:00',5.75),('8902','2014-05-04','09:50:00',5.93),('8902','2014-05-04','09:55:00',6.07),('8902','2014-05-04','10:00:00',6.2),('8902','2014-05-04','10:05:00',6.32),('8902','2014-05-04','10:10:00',6.45),('8902','2014-05-04','10:15:00',6.52),('8902','2014-05-04','10:20:00',6.57),('8902','2014-05-04','10:25:00',6.73),('8902','2014-05-04','10:30:00',6.83),('8902','2014-05-04','10:35:00',6.97),('8902','2014-05-04','10:40:00',7.02),('8902','2014-05-04','10:45:00',7.07),('8902','2014-05-04','10:50:00',7.2),('8902','2014-05-04','10:55:00',7.3),('8902','2014-05-04','11:00:00',7.39),('8902','2014-05-04','11:05:00',7.47),('8902','2014-05-04','11:10:00',7.56),('8902','2014-05-04','11:15:00',7.69),('8902','2014-05-04','11:20:00',7.71),('8902','2014-05-04','11:25:00',7.76),('8902','2014-05-04','11:30:00',7.76),('8902','2014-05-04','11:35:00',7.85),('8902','2014-05-04','11:40:00',7.99),('8902','2014-05-04','11:45:00',8.08),('8902','2014-05-04','11:50:00',8.16),('8902','2014-05-04','11:55:00',8.34),('8902','2014-05-04','12:00:00',6.24),('8902','2014-05-04','12:05:00',4.09),('8902','2014-05-04','12:10:00',5.11),('8902','2014-05-04','12:15:00',8.16),('8902','2014-05-04','12:20:00',4.47),('8902','2014-05-04','12:25:00',7.26),('8902','2014-05-04','12:30:00',6.46),('8902','2014-05-04','12:35:00',3.87),('8902','2014-05-04','12:40:00',4.81),('8902','2014-05-04','12:45:00',8.48),('8902','2014-05-04','12:50:00',7.15),('8902','2014-05-04','12:55:00',4.37),('8902','2014-05-04','13:00:00',8.2),('8902','2014-05-04','13:05:00',6.7),('8902','2014-05-04','13:10:00',9.07),('8902','2014-05-04','13:15:00',8.86),('8902','2014-05-04','13:20:00',8.6),('8902','2014-05-04','13:25:00',8.51),('8902','2014-05-04','13:30:00',7.9),('8902','2014-05-04','13:35:00',7.76),('8902','2014-05-04','13:40:00',8.63),('8902','2014-05-04','13:45:00',8.62),('8902','2014-05-04','13:50:00',8.65),('8902','2014-05-04','13:55:00',8.59),('8902','2014-05-04','14:00:00',8.67),('8902','2014-05-04','14:05:00',9),('8902','2014-05-04','14:10:00',9.1),('8902','2014-05-04','14:15:00',9.08),('8902','2014-05-04','14:20:00',7.54),('8902','2014-05-04','14:25:00',5.07),('8902','2014-05-04','14:30:00',5.3),('8902','2014-05-04','14:35:00',3.13),('8902','2014-05-04','14:40:00',3.22),('8902','2014-05-04','14:45:00',2.35),('8902','2014-05-04','14:50:00',2.37),('8902','2014-05-04','14:55:00',2.82),('8902','2014-05-04','15:00:00',2.9),('8902','2014-05-04','15:05:00',6.01),('8902','2014-05-04','15:10:00',3.28),('8902','2014-05-04','15:15:00',2.62),('8902','2014-05-04','15:20:00',3.15),('8902','2014-05-04','15:25:00',3.76),('8902','2014-05-04','15:30:00',8.8),('8902','2014-05-04','15:35:00',8.33),('8902','2014-05-04','15:40:00',7.7),('8902','2014-05-04','15:45:00',2.94),('8902','2014-05-04','15:50:00',2.87),('8902','2014-05-04','15:55:00',2.7),('8902','2014-05-04','16:00:00',2.16),('8902','2014-05-04','16:05:00',2.51),('8902','2014-05-04','16:10:00',2.9),('8902','2014-05-04','16:15:00',2.64),('8902','2014-05-04','16:20:00',2.62),('8902','2014-05-04','16:25:00',2.08),('8902','2014-05-04','16:30:00',1.98),('8902','2014-05-04','16:35:00',1.54),('8902','2014-05-04','16:40:00',2.89),('8902','2014-05-04','16:45:00',4.05),('8902','2014-05-04','16:50:00',3.24),('8902','2014-05-04','16:55:00',4.71),('8902','2014-05-04','17:00:00',5.26),('8902','2014-05-04','17:05:00',5.12),('8902','2014-05-04','17:10:00',5.05),('8902','2014-05-04','17:15:00',4.88),('8902','2014-05-04','17:20:00',4.73),('8902','2014-05-04','17:25:00',4.46),('8902','2014-05-04','17:30:00',4.11),('8902','2014-05-04','17:35:00',3.95),('8902','2014-05-04','17:40:00',3.73),('8902','2014-05-04','17:45:00',3.49),('8902','2014-05-04','17:50:00',3.33),('8902','2014-05-04','17:55:00',3.19),('8902','2014-05-04','18:00:00',2.91),('8902','2014-05-04','18:05:00',2.76),('8902','2014-05-04','18:10:00',2.61),('8902','2014-05-04','18:15:00',2.4),('8902','2014-05-04','18:20:00',2.18),('8902','2014-05-04','18:25:00',2),('8902','2014-05-04','18:30:00',1.82),('8902','2014-05-04','18:35:00',1.65),('8902','2014-05-04','18:40:00',1.48),('8902','2014-05-04','18:45:00',1.32),('8902','2014-05-04','18:50:00',1.16),('8902','2014-05-04','18:55:00',1),('8902','2014-04-25','08:00:00',1.05),('8902','2014-04-25','08:05:00',1.14),('8902','2014-04-25','08:10:00',1.24),('8902','2014-04-25','08:15:00',1.25),('8902','2014-04-25','08:20:00',1.32),('8902','2014-04-25','08:25:00',1.37),('8902','2014-04-25','08:30:00',1.28),('8902','2014-04-25','08:35:00',1.42),('8902','2014-04-25','08:40:00',1.56),('8902','2014-04-25','08:45:00',1.72),('8902','2014-04-25','08:50:00',1.77),('8902','2014-04-25','08:55:00',1.63),('8902','2014-04-25','09:00:00',1.72),('8902','2014-04-25','09:05:00',1.86),('8902','2014-04-25','09:10:00',1.59),('8902','2014-04-25','09:15:00',1.46),('8902','2014-04-25','09:20:00',1.52),('8902','2014-04-25','09:25:00',1.52),('8902','2014-04-25','09:30:00',1.58),('8902','2014-04-25','09:35:00',1.77),('8902','2014-04-25','09:40:00',1.84),('8902','2014-04-25','09:45:00',1.61),('8902','2014-04-25','09:50:00',2.12),('8902','2014-04-25','09:55:00',2.77),('8902','2014-04-25','10:00:00',2.66),('8902','2014-04-25','10:05:00',2.48),('8902','2014-04-25','10:10:00',2.45),('8902','2014-04-25','10:15:00',2.56),('8902','2014-04-25','10:20:00',2.75),('8902','2014-04-25','10:25:00',2.98),('8902','2014-04-25','10:30:00',3.47),('8902','2014-04-25','10:35:00',3.69),('8902','2014-04-25','10:40:00',3.76),('8902','2014-04-25','10:45:00',3.96),('8902','2014-04-25','10:50:00',4.94),('8902','2014-04-25','10:55:00',7.04),('8902','2014-04-25','11:00:00',6.91),('8902','2014-04-25','11:05:00',6.67),('8902','2014-04-25','11:10:00',6.04),('8902','2014-04-25','11:15:00',6.32),('8902','2014-04-25','11:20:00',5.68),('8902','2014-04-25','11:25:00',5.67),('8902','2014-04-25','11:30:00',5.51),('8902','2014-04-25','11:35:00',5.89),('8902','2014-04-25','11:40:00',5.62),('8902','2014-04-25','11:45:00',5.97),('8902','2014-04-25','11:50:00',5.94),('8902','2014-04-25','11:55:00',5.51),('8902','2014-04-25','12:00:00',6.03),('8902','2014-04-25','12:05:00',6.45),('8902','2014-04-25','12:10:00',6.45),('8902','2014-04-25','12:15:00',5.48),('8902','2014-04-25','12:20:00',5.74),('8902','2014-04-25','12:25:00',4.14),('8902','2014-04-25','12:30:00',5.34),('8902','2014-04-25','12:35:00',6.6),('8902','2014-04-25','12:40:00',7.04),('8902','2014-04-25','12:45:00',7.37),('8902','2014-04-25','12:50:00',7.49),('8902','2014-04-25','12:55:00',8.48),('8902','2014-04-25','13:00:00',7.59),('8902','2014-04-25','13:05:00',5.66),('8902','2014-04-25','13:10:00',7.11),('8902','2014-04-25','13:15:00',8.26),('8902','2014-04-25','13:20:00',7.81),('8902','2014-04-25','13:25:00',4.88),('8902','2014-04-25','13:30:00',2.57),('8902','2014-04-25','13:35:00',3.82),('8902','2014-04-25','13:40:00',7.37),('8902','2014-04-25','13:45:00',8.47),('8902','2014-04-25','13:50:00',8.42),('8902','2014-04-25','13:55:00',8.67),('8902','2014-04-25','14:00:00',7.76),('8902','2014-04-25','14:05:00',2.24),('8902','2014-04-25','14:10:00',5.73),('8902','2014-04-25','14:15:00',2.99),('8902','2014-04-25','14:20:00',1.05),('8902','2014-04-25','14:25:00',1.6),('8902','2014-04-25','14:30:00',1.64),('8902','2014-04-25','14:35:00',4.75),('8902','2014-04-25','14:40:00',5.56),('8902','2014-04-25','14:45:00',2.07),('8902','2014-04-25','14:50:00',1.05),('8902','2014-04-25','15:00:00',1.04),('8902','2014-04-25','15:15:00',1.91),('8902','2014-04-25','15:20:00',1.49),('8902','2014-04-25','17:35:00',1.02),('8902','2014-04-25','17:40:00',1.43),('8902','2014-04-25','17:45:00',1.78),('8902','2014-04-25','17:50:00',1.8),('8902','2014-04-25','17:55:00',1.66),('8902','2014-04-25','18:00:00',1.03),('8902','2014-04-25','18:30:00',1.15),('8902','2014-04-25','18:35:00',1.39),('8902','2014-04-25','18:40:00',1.69),('8902','2014-04-25','18:45:00',1.68),('8902','2014-04-25','18:50:00',1.35),('8902','2014-01-25','08:45:00',1.11),('8902','2014-01-25','08:50:00',1.12),('8902','2014-01-25','08:55:00',1.21),('8902','2014-01-25','09:00:00',1.71),('8902','2014-01-25','09:05:00',2.69),('8902','2014-01-25','09:10:00',1.55),('8902','2014-01-25','09:15:00',1.16),('8902','2014-01-25','09:20:00',1.07),('8902','2014-01-25','09:25:00',1.67),('8902','2014-01-25','09:30:00',3.17),('8902','2014-01-25','09:35:00',3.59),('8902','2014-01-25','09:40:00',1.62),('8902','2014-01-25','09:45:00',2.69),('8902','2014-01-25','09:50:00',3.06),('8902','2014-01-25','09:55:00',2.13),('8902','2014-01-25','10:00:00',1.58),('8902','2014-01-25','10:05:00',1.68),('8902','2014-01-25','10:10:00',4.1),('8902','2014-01-25','10:15:00',5.49),('8902','2014-01-25','10:20:00',2.48),('8902','2014-01-25','10:25:00',1.98),('8902','2014-01-25','10:30:00',1.81),('8902','2014-01-25','10:35:00',1.57),('8902','2014-01-25','10:40:00',1.33),('8902','2014-01-25','10:45:00',1.45),('8902','2014-01-25','10:50:00',1.53),('8902','2014-01-25','10:55:00',1.77),('8902','2014-01-25','11:00:00',1.58),('8902','2014-01-25','11:05:00',1.6),('8902','2014-01-25','11:10:00',1.39),('8902','2014-01-25','11:15:00',1.39),('8902','2014-01-25','11:20:00',1.38),('8902','2014-01-25','11:25:00',1.91),('8902','2014-01-25','11:30:00',1.64),('8902','2014-01-25','11:35:00',1.44),('8902','2014-01-25','11:40:00',1.45),('8902','2014-01-25','11:45:00',1.3),('8902','2014-01-25','11:50:00',1.1),('8902','2014-01-25','11:55:00',1.12),('8902','2014-01-25','12:00:00',1.11),('8902','2014-01-25','12:05:00',1.2),('8902','2014-01-25','12:10:00',1.53),('8902','2014-01-25','12:15:00',2.08),('8902','2014-01-25','12:20:00',2.32),('8902','2014-01-25','12:25:00',2.51),('8902','2014-01-25','12:30:00',4.83),('8902','2014-01-25','12:35:00',4.82),('8902','2014-01-25','12:40:00',2.55),('8902','2014-01-25','12:45:00',2.14),('8902','2014-01-25','12:50:00',1.88),('8902','2014-01-25','12:55:00',1.75),('8902','2014-01-25','13:00:00',1.88),('8902','2014-01-25','13:05:00',2.16),('8902','2014-01-25','13:10:00',2.41),('8902','2014-01-25','13:15:00',3.24),('8902','2014-01-25','13:20:00',3.28),('8902','2014-01-25','13:25:00',2.41),('8902','2014-01-25','13:30:00',1.78),('8902','2014-01-25','13:35:00',1.47),('8902','2014-01-25','13:40:00',1.28),('8902','2014-01-25','13:45:00',1.23),('8902','2014-01-25','13:50:00',1.68),('8902','2014-01-25','13:55:00',1.23),('8902','2014-01-25','14:05:00',1.03),('8902','2014-01-25','14:10:00',1.25),('8902','2014-01-25','14:15:00',1.25),('8902','2014-01-25','15:25:00',1.53),('8902','2014-01-25','15:45:00',2.87),('8902','2014-01-25','15:50:00',1.6),('8902','2014-01-24','09:00:00',2.15),('8902','2014-01-24','09:05:00',3.44),('8902','2014-01-24','09:10:00',2.1),('8902','2014-01-24','09:15:00',2.33),('8902','2014-01-24','09:20:00',3.22),('8902','2014-01-24','09:25:00',1.27),('8902','2014-01-24','09:40:00',1.35),('8902','2014-01-24','09:45:00',2.22),('8902','2014-01-24','09:50:00',3),('8902','2014-01-24','09:55:00',3.92),('8902','2014-01-24','10:00:00',3.26),('8902','2014-01-24','10:05:00',5.1),('8902','2014-01-24','10:10:00',5.64),('8902','2014-01-24','10:15:00',5.62),('8902','2014-01-24','10:20:00',5.6),('8902','2014-01-24','10:25:00',3.48),('8902','2014-01-24','10:30:00',3.91),('8902','2014-01-24','10:35:00',3.37),('8902','2014-01-24','10:40:00',3.53),('8902','2014-01-24','10:45:00',2.82),('8902','2014-01-24','10:50:00',3.07),('8902','2014-01-24','10:55:00',2.95),('8902','2014-01-24','11:00:00',2.4),('8902','2014-01-24','11:05:00',2.2),('8902','2014-01-24','11:10:00',1.92),('8902','2014-01-24','11:15:00',1.73),('8902','2014-01-24','11:20:00',1.98),('8902','2014-01-24','11:25:00',2.36),('8902','2014-01-24','11:30:00',5.46),('8902','2014-01-24','11:35:00',7.65),('8902','2014-01-24','11:40:00',3.73),('8902','2014-01-24','11:45:00',2.87),('8902','2014-01-24','11:50:00',3.07),('8902','2014-01-24','11:55:00',3.08),('8902','2014-01-24','12:00:00',3.08),('8902','2014-01-24','12:05:00',3.14),('8902','2014-01-24','12:10:00',3.59),('8902','2014-01-24','12:15:00',3.57),('8902','2014-01-24','12:20:00',3.68),('8902','2014-01-24','12:25:00',3.79),('8902','2014-01-24','12:30:00',3.93),('8902','2014-01-24','12:35:00',3.41),('8902','2014-01-24','12:40:00',3.58),('8902','2014-01-24','12:45:00',4.21),('8902','2014-01-24','12:50:00',4.62),('8902','2014-01-24','12:55:00',5.58),('8902','2014-01-24','13:00:00',5.62),('8902','2014-01-24','13:05:00',6.31),('8902','2014-01-24','13:10:00',6.5),('8902','2014-01-24','13:15:00',4.89),('8902','2014-01-24','13:20:00',2.43),('8902','2014-01-24','13:25:00',2.21),('8902','2014-01-24','13:30:00',3.9),('8902','2014-01-24','13:35:00',2.23),('8902','2014-01-24','13:40:00',2.33),('8902','2014-01-24','13:45:00',4.68),('8902','2014-01-24','13:50:00',2.88),('8902','2014-01-24','13:55:00',1.27),('8902','2014-01-24','14:00:00',3.78),('8902','2014-01-24','14:05:00',4.53),('8902','2014-01-24','14:10:00',4.9),('8902','2014-01-24','14:15:00',4.96),('8902','2014-01-24','14:20:00',5.65),('8902','2014-01-24','14:25:00',5.66),('8902','2014-01-24','14:30:00',6.16),('8902','2014-01-24','14:35:00',4.47),('8902','2014-01-24','14:40:00',5.89),('8902','2014-01-24','14:45:00',5.86),('8902','2014-01-24','14:50:00',5.67),('8902','2014-01-24','14:55:00',5.31),('8902','2014-01-24','15:00:00',4.86),('8902','2014-01-24','15:05:00',4.56),('8902','2014-01-24','15:10:00',4.33),('8902','2014-01-24','15:15:00',4.13),('8902','2014-01-24','15:20:00',3.91),('8902','2014-01-24','15:25:00',3.76),('8902','2014-01-24','15:30:00',3.58),('8902','2014-01-24','15:35:00',3.37),('8902','2014-01-24','15:40:00',3.17),('8902','2014-01-24','15:45:00',2.99),('8902','2014-01-24','15:50:00',2.76),('8902','2014-01-24','15:55:00',2.56),('8902','2014-01-24','16:00:00',2.42),('8902','2014-01-24','16:05:00',2.26),('8902','2014-01-24','16:10:00',2.03),('8902','2014-01-24','16:15:00',1.85),('8902','2014-01-24','16:20:00',1.64),('8902','2014-01-24','16:25:00',1.45),('8902','2014-01-24','16:30:00',1.26),('8902','2014-01-24','16:35:00',1.07),('8902','2014-01-23','10:05:00',1.83),('8902','2014-01-23','10:10:00',2.4),('8902','2014-01-23','10:15:00',3.01),('8902','2014-01-23','10:20:00',1.98),('8902','2014-01-23','10:25:00',1.26),('8902','2014-01-23','10:30:00',3.03),('8902','2014-01-23','10:35:00',2.41),('8902','2014-01-23','10:40:00',3.61),('8902','2014-01-23','10:45:00',3.53),('8902','2014-01-23','10:50:00',1.98),('8902','2014-01-23','10:55:00',1.85),('8902','2014-01-23','11:00:00',1.82),('8902','2014-01-23','11:05:00',1.52),('8902','2014-01-23','11:20:00',1.14),('8902','2014-01-23','11:25:00',1.93),('8902','2014-01-23','11:30:00',2.38),('8902','2014-01-23','11:35:00',2.63),('8902','2014-01-23','11:40:00',1.2),('8902','2014-01-23','11:45:00',2.39),('8902','2014-01-23','11:50:00',6.99),('8902','2014-01-23','11:55:00',7.05),('8902','2014-01-23','12:00:00',5.57),('8902','2014-01-23','12:05:00',3.83),('8902','2014-01-23','12:10:00',1.66),('8902','2014-01-23','12:20:00',1.75),('8902','2014-01-23','12:25:00',2.86),('8902','2014-01-23','12:30:00',2.28),('8902','2014-01-23','12:35:00',5.47),('8902','2014-01-23','12:40:00',4.99),('8902','2014-01-23','12:45:00',4.35),('8902','2014-01-23','12:50:00',2.71),('8902','2014-01-23','12:55:00',2.28),('8902','2014-01-23','13:00:00',3.57),('8902','2014-01-23','13:05:00',3.94),('8902','2014-01-23','13:10:00',3.18),('8902','2014-01-23','13:15:00',2.39),('8902','2014-01-23','13:20:00',2),('8902','2014-01-23','13:25:00',1.57),('8902','2014-01-23','13:30:00',3.02),('8902','2014-01-23','13:35:00',3.24),('8902','2014-01-23','13:40:00',3.32),('8902','2014-01-23','13:45:00',3.96),('8902','2014-01-23','13:50:00',5.26),('8902','2014-01-23','13:55:00',4.86),('8902','2014-01-23','14:00:00',5.39),('8902','2014-01-23','14:10:00',6.53),('8902','2014-01-23','14:15:00',5.94),('8902','2014-01-23','14:20:00',5.87),('8902','2014-01-23','14:25:00',5.33),('8902','2014-01-23','14:30:00',1.67),('8902','2014-01-23','14:35:00',1.06),('8902','2014-01-23','14:40:00',1.23),('8902','2014-01-23','14:45:00',1.62),('8902','2014-01-22','10:15:00',1.33),('8902','2014-01-22','10:20:00',1.38),('8902','2014-01-22','10:25:00',1.43),('8902','2014-01-22','10:30:00',1.16),('8902','2014-01-22','10:40:00',1.06),('8902','2014-01-22','10:45:00',1.1),('8902','2014-01-22','10:50:00',1.4),('8902','2014-01-22','10:55:00',1.65),('8902','2014-01-22','11:00:00',1.9),('8902','2014-01-22','11:05:00',1.91),('8902','2014-01-22','11:10:00',2.02),('8902','2014-01-22','11:15:00',2.07),('8902','2014-01-22','11:20:00',1.85),('8902','2014-01-22','11:25:00',1.67),('8902','2014-01-22','11:30:00',1.19),('8902','2014-01-22','12:10:00',1.52),('8902','2014-01-22','12:15:00',1.13),('8902','2014-01-22','12:25:00',1.25),('8902','2014-01-22','12:30:00',1.86),('8902','2014-01-22','12:35:00',1.66),('8902','2014-01-22','12:40:00',1.04),('8902','2014-01-22','14:05:00',1.2),('8902','2014-01-22','14:10:00',1.42),('8902','2014-01-22','14:15:00',1.5),('8902','2014-01-22','14:20:00',1.31),('8902','2014-01-22','14:25:00',1.09),('8902','2014-01-21','10:15:00',1.65),('8902','2014-01-21','10:20:00',1.54),('8902','2014-01-21','10:40:00',1.06),('8902','2014-01-21','10:45:00',1.39),('8902','2014-01-21','10:50:00',1.46),('8902','2014-01-21','10:55:00',1.43),('8902','2014-01-21','11:00:00',1.66),('8902','2014-01-21','11:05:00',1.88),('8902','2014-01-21','11:10:00',1.93),('8902','2014-01-21','11:15:00',1.73),('8902','2014-01-21','11:20:00',1.81),('8902','2014-01-21','11:25:00',1.78),('8902','2014-01-21','11:30:00',1.38),('8902','2014-01-21','11:35:00',1.12),('8902','2014-01-21','11:40:00',1.6),('8902','2014-01-21','11:45:00',1.68),('8902','2014-01-21','11:50:00',1.27),('8902','2014-01-21','11:55:00',1.41),('8902','2014-01-21','12:00:00',1.53),('8902','2014-01-21','12:05:00',1.56),('8902','2014-01-21','12:10:00',1.38),('8902','2014-01-21','12:35:00',1.07),('8902','2014-01-21','12:40:00',1.17),('8902','2014-01-21','12:45:00',1.31),('8902','2014-01-21','12:50:00',1.57),('8902','2014-01-21','12:55:00',1.87),('8902','2014-01-21','13:00:00',1.82),('8902','2014-01-21','13:05:00',1.65),('8902','2014-01-21','13:10:00',1.82),('8902','2014-01-21','13:15:00',2.23),('8902','2014-01-21','13:20:00',2.36),('8902','2014-01-21','13:25:00',1.46),('8902','2014-01-21','13:30:00',1.14),('8902','2014-01-21','13:40:00',1.1),('8902','2014-01-21','13:45:00',1.14),('8902','2014-01-21','13:50:00',1.08),('8902','2014-01-21','13:55:00',1.34),('8902','2014-01-21','14:00:00',1.31),('8902','2014-01-21','14:05:00',1.09),('8902','2014-01-21','14:10:00',1.27),('8902','2014-01-21','14:15:00',1.27),('8902','2014-01-21','14:20:00',1.14),('8902','2014-01-21','14:25:00',1.08),('8902','2014-01-21','14:30:00',1.05),('8902','2014-01-21','14:35:00',1.02),('8902','2014-01-21','15:00:00',1.05),('8902','2014-01-21','15:05:00',1.17),('8902','2014-01-21','15:10:00',1.07),('8902','2014-01-21','16:05:00',1.88),('8902','2014-01-21','16:10:00',2.02),('8902','2014-01-21','16:15:00',1.97),('8902','2014-01-21','16:20:00',1.24),('8902','2014-01-20','09:15:00',1.01),('8902','2014-01-20','09:35:00',1.26),('8902','2014-01-20','09:40:00',1.49),('8902','2014-01-20','09:50:00',1.14),('8902','2014-01-20','09:55:00',1.6),('8902','2014-01-20','10:00:00',2.06),('8902','2014-01-20','10:05:00',2.46),('8902','2014-01-20','10:35:00',1.23),('8902','2014-01-20','10:40:00',1.56),('8902','2014-01-20','10:45:00',1.11),('8902','2014-01-20','10:55:00',3.13),('8902','2014-01-20','11:00:00',4.19),('8902','2014-01-20','11:05:00',2.05),('8902','2014-01-20','11:20:00',1.66),('8902','2014-01-20','11:30:00',1.67),('8902','2014-01-20','11:35:00',1.07),('8902','2014-01-20','11:40:00',1.02),('8902','2014-01-20','11:45:00',1.02),('8902','2014-01-20','11:50:00',1.72),('8902','2014-01-20','11:55:00',2.26),('8902','2014-01-20','12:00:00',1.89),('8902','2014-01-20','12:05:00',2.69),('8902','2014-01-20','12:10:00',4.09),('8902','2014-01-20','12:15:00',2.98),('8902','2014-01-20','12:20:00',2.14),('8902','2014-01-20','12:25:00',2.46),('8902','2014-01-20','12:30:00',3.66),('8902','2014-01-20','12:35:00',2.57),('8902','2014-01-20','12:40:00',2.7),('8902','2014-01-20','12:45:00',2.66),('8902','2014-01-20','12:50:00',3.72),('8902','2014-01-20','12:55:00',2.13),('8902','2014-01-20','13:15:00',1.49),('8902','2014-01-20','13:20:00',2.34),('8902','2014-01-20','13:25:00',1.17),('8902','2014-01-20','13:55:00',1.03),('8902','2014-01-20','14:00:00',1.78),('8902','2014-01-20','14:05:00',2.74),('8902','2014-01-20','14:10:00',2.5),('8902','2014-01-20','14:15:00',2.02),('8902','2014-01-20','14:20:00',1.52),('8902','2014-01-20','14:25:00',1.01),('8902','2014-01-20','15:10:00',1.24),('8902','2014-01-20','15:15:00',1.21),('8902','2014-01-20','15:25:00',1.09),('8902','2014-01-20','15:30:00',1.2),('8902','2014-01-20','15:35:00',1.7),('8902','2014-01-20','15:40:00',2.42),('8902','2014-01-20','15:45:00',1.08),('8902','2014-01-19','10:50:00',1.05),('8902','2014-01-19','11:15:00',1.72),('8902','2014-01-19','11:20:00',3.04),('8902','2014-01-19','11:25:00',3.78),('8902','2014-01-19','11:30:00',3.88),('8902','2014-01-19','11:35:00',3.9),('8902','2014-01-19','11:40:00',6.25),('8902','2014-01-19','11:45:00',6.03),('8902','2014-01-19','11:50:00',3.8),('8902','2014-01-19','11:55:00',1.83),('8902','2014-01-19','12:00:00',1.4),('8902','2014-01-19','12:05:00',1.09),('8902','2014-01-19','12:15:00',1.11),('8902','2014-01-19','12:20:00',1.16),('8902','2014-01-19','12:25:00',2.36),('8902','2014-01-19','12:30:00',2.27),('8902','2014-01-19','12:35:00',1.57),('8902','2014-01-19','13:05:00',1.12),('8902','2014-01-19','13:10:00',1.22),('8902','2014-01-19','13:15:00',1.7),('8902','2014-01-19','13:20:00',7.74),('8902','2014-01-19','13:25:00',7.3),('8902','2014-01-19','13:30:00',6.44),('8902','2014-01-19','13:35:00',6.12),('8902','2014-01-19','13:40:00',5.68),('8902','2014-01-19','13:45:00',5.23),('8902','2014-01-19','13:50:00',2.58),('8902','2014-01-19','13:55:00',2.69),('8902','2014-01-19','14:00:00',5.42),('8902','2014-01-19','14:05:00',4.45),('8902','2014-01-19','14:10:00',2.8),('8902','2014-01-19','14:15:00',2.31),('8902','2014-01-19','14:20:00',2.53),('8902','2014-01-19','14:25:00',1.51),('8902','2014-01-18','10:20:00',1.06),('8902','2014-01-18','11:05:00',1.04),('8902','2014-01-18','11:45:00',1.29),('8902','2014-01-18','11:50:00',1.7),('8902','2014-01-18','11:55:00',1.74),('8902','2014-01-18','12:00:00',1.94),('8902','2014-01-18','12:05:00',2),('8902','2014-01-18','12:10:00',1.93),('8902','2014-01-18','12:15:00',1.61),('8902','2014-01-18','12:20:00',1.76),('8902','2014-01-18','12:25:00',1.75),('8902','2014-01-18','12:30:00',1.06),('8902','2014-01-18','12:55:00',1.09),('8902','2014-01-18','13:00:00',1.4),('8902','2014-01-18','13:05:00',1.9),('8902','2014-01-18','13:10:00',2.11),('8902','2014-01-18','13:15:00',1.85),('8902','2014-01-18','13:20:00',1.47),('8902','2014-01-18','13:25:00',1.3),('8902','2014-01-18','13:30:00',1.26),('8902','2014-01-18','13:35:00',1.18),('8902','2014-01-18','13:40:00',1.06),('8902','2014-01-18','13:45:00',1.04),('8902','2014-01-18','13:50:00',1.1),('8902','2014-01-18','13:55:00',1.42),('8902','2014-01-18','14:00:00',1.25),('8902','2014-01-18','14:05:00',1.03),('8902','2014-01-18','14:15:00',1.32),('8902','2014-01-18','14:20:00',2.53),('8902','2014-01-18','14:25:00',3.42),('8902','2014-01-18','14:30:00',3.8),('8902','2014-01-18','14:35:00',2.22),('8902','2014-01-18','14:40:00',1.85),('8902','2014-01-18','14:45:00',1.55),('8902','2014-01-18','14:50:00',1.02),('8902','2014-01-18','15:40:00',1.29),('8902','2014-01-17','09:10:00',1.05),('8902','2014-01-17','09:15:00',1.02),('8902','2014-01-17','09:25:00',1.06),('8902','2014-01-17','09:30:00',1.28),('8902','2014-01-17','09:35:00',1.59),('8902','2014-01-17','09:40:00',1.7),('8902','2014-01-17','09:45:00',1.75),('8902','2014-01-17','09:50:00',1.62),('8902','2014-01-17','09:55:00',1.82),('8902','2014-01-17','10:00:00',2.35),('8902','2014-01-17','10:05:00',3.22),('8902','2014-01-17','10:10:00',4.92),('8902','2014-01-17','10:15:00',5.14),('8902','2014-01-17','10:20:00',4.76),('8902','2014-01-17','10:25:00',3.17),('8902','2014-01-17','10:30:00',3.43),('8902','2014-01-17','10:35:00',2.2),('8902','2014-01-17','10:40:00',2.1),('8902','2014-01-17','10:45:00',2.42),('8902','2014-01-17','10:50:00',2.49),('8902','2014-01-17','10:55:00',2.34),('8902','2014-01-17','11:00:00',1.67),('8902','2014-01-17','11:05:00',2.52),('8902','2014-01-17','11:10:00',4.31),('8902','2014-01-17','11:15:00',5.77),('8902','2014-01-17','11:20:00',5.62),('8902','2014-01-17','11:25:00',5.32),('8902','2014-01-17','11:30:00',5.41),('8902','2014-01-17','11:35:00',5.51),('8902','2014-01-17','11:40:00',5.04),('8902','2014-01-17','11:45:00',6.33),('8902','2014-01-17','11:50:00',6.8),('8902','2014-01-17','11:55:00',6.76),('8902','2014-01-17','12:00:00',6.42),('8902','2014-01-17','12:05:00',5.06),('8902','2014-01-17','12:10:00',5.99),('8902','2014-01-17','12:15:00',5.73),('8902','2014-01-17','12:20:00',5.68),('8902','2014-01-17','12:25:00',5.85),('8902','2014-01-17','12:30:00',5.89),('8902','2014-01-17','12:35:00',5.9),('8902','2014-01-17','12:40:00',5.97),('8902','2014-01-17','12:45:00',5.93),('8902','2014-01-17','12:50:00',5.7),('8902','2014-01-17','12:55:00',6.28),('8902','2014-01-17','13:00:00',4.13),('8902','2014-01-17','13:05:00',3.85),('8902','2014-01-17','13:10:00',4.91),('8902','2014-01-17','13:15:00',6),('8902','2014-01-17','13:20:00',3.74),('8902','2014-01-17','13:25:00',3.03),('8902','2014-01-17','13:30:00',5.44),('8902','2014-01-17','13:35:00',2.95),('8902','2014-01-17','13:40:00',4.64),('8902','2014-01-17','13:45:00',5.72),('8902','2014-01-17','13:50:00',3.64),('8902','2014-01-17','13:55:00',5.49),('8902','2014-01-17','14:00:00',5.4),('8902','2014-01-17','14:05:00',5.05),('8902','2014-01-17','14:10:00',4.91),('8902','2014-01-17','14:15:00',4.67),('8902','2014-01-17','14:20:00',4.86),('8902','2014-01-17','14:25:00',4.65),('8902','2014-01-17','14:30:00',4.48),('8902','2014-01-17','14:35:00',4.41),('8902','2014-01-17','14:40:00',4.29),('8902','2014-01-17','14:45:00',4.18),('8902','2014-01-17','14:50:00',4.04),('8902','2014-01-17','14:55:00',2.89),('8902','2014-01-17','15:15:00',1.07),('8902','2014-01-17','15:20:00',1.19),('8902','2014-01-17','15:25:00',1.26),('8902','2014-01-17','15:30:00',1.14),('8902','2014-01-17','15:35:00',1.19),('8902','2014-01-17','15:40:00',1),('8902','2014-01-17','15:55:00',1.89),('8902','2014-01-17','16:00:00',1.22),('8902','2014-01-17','16:05:00',1.83),('8902','2014-01-17','16:10:00',1.24),('8902','2014-01-17','16:15:00',1.05),('8902','2014-01-16','08:30:00',1.01),('8902','2014-01-16','08:35:00',1.06),('8902','2014-01-16','08:40:00',1.15),('8902','2014-01-16','08:50:00',1.41),('8902','2014-01-16','08:55:00',1.7),('8902','2014-01-16','09:00:00',2.32),('8902','2014-01-16','09:05:00',2.36),('8902','2014-01-16','09:10:00',2.15),('8902','2014-01-16','09:15:00',1.61),('8902','2014-01-16','09:20:00',2.81),('8902','2014-01-16','09:25:00',3.12),('8902','2014-01-16','09:30:00',3.06),('8902','2014-01-16','09:35:00',3.22),('8902','2014-01-16','09:40:00',3.66),('8902','2014-01-16','09:45:00',3.65),('8902','2014-01-16','09:50:00',1.85),('8902','2014-01-16','10:10:00',1.02),('8902','2014-01-16','11:20:00',1.31),('8902','2014-01-16','11:25:00',2.45),('8902','2014-01-16','11:30:00',4.76),('8902','2014-01-16','11:35:00',3.75),('8902','2014-01-16','11:40:00',2.59),('8902','2014-01-16','11:45:00',1.32),('8902','2014-01-16','11:50:00',1.72),('8902','2014-01-16','11:55:00',2.64),('8902','2014-01-16','12:00:00',2.21),('8902','2014-01-16','12:05:00',3.94),('8902','2014-01-16','12:10:00',3.36),('8902','2014-01-16','12:15:00',1.75),('8902','2014-01-16','12:20:00',1.66),('8902','2014-01-16','12:25:00',1.62),('8902','2014-01-16','12:30:00',1.21),('8902','2014-01-16','12:35:00',1.45),('8902','2014-01-16','12:40:00',2.06),('8902','2014-01-16','12:45:00',2.05),('8902','2014-01-16','12:50:00',1.47),('8902','2014-01-16','12:55:00',1.21),('8902','2014-01-16','13:10:00',1.27),('8902','2014-01-16','13:15:00',1.23),('8902','2014-01-16','13:20:00',1.08),('8902','2014-04-24','07:45:00',1.11),('8902','2014-04-24','07:50:00',1.53),('8902','2014-04-24','07:55:00',2.01),('8902','2014-04-24','08:00:00',1.89),('8902','2014-04-24','08:05:00',1.88),('8902','2014-04-24','08:10:00',2.04),('8902','2014-04-24','08:15:00',2.18),('8902','2014-04-24','08:20:00',2.35),('8902','2014-04-24','08:25:00',2.5),('8902','2014-04-24','08:30:00',2.67),('8902','2014-04-24','08:35:00',2.86),('8902','2014-04-24','08:40:00',3.04),('8902','2014-04-24','08:45:00',3.19),('8902','2014-04-24','08:50:00',3.37),('8902','2014-04-24','08:55:00',3.61),('8902','2014-04-24','09:00:00',4.14),('8902','2014-04-24','09:05:00',4.31),('8902','2014-04-24','09:10:00',4.54),('8902','2014-04-24','09:15:00',4.86),('8902','2014-04-24','09:20:00',5.38),('8902','2014-04-24','09:25:00',5.32),('8902','2014-04-24','09:30:00',5.22),('8902','2014-04-24','09:35:00',3.13),('8902','2014-04-24','09:40:00',2.14),('8902','2014-04-24','09:45:00',2.31),('8902','2014-04-24','09:50:00',2.16),('8902','2014-04-24','09:55:00',2.33),('8902','2014-04-24','10:00:00',2.82),('8902','2014-04-24','10:05:00',2.5),('8902','2014-04-24','10:10:00',2.08),('8902','2014-04-24','10:15:00',2.14),('8902','2014-04-24','10:20:00',2.28),('8902','2014-04-24','10:25:00',2.42),('8902','2014-04-24','10:30:00',2.52),('8902','2014-04-24','10:35:00',2.82),('8902','2014-04-24','10:40:00',4.25),('8902','2014-04-24','10:45:00',6.27),('8902','2014-04-24','10:50:00',7.18),('8902','2014-04-24','10:55:00',6.85),('8902','2014-04-24','11:00:00',6.96),('8902','2014-04-24','11:05:00',6.69),('8902','2014-04-24','11:10:00',6.02),('8902','2014-04-24','11:15:00',5.46),('8902','2014-04-24','11:20:00',6.77),('8902','2014-04-24','11:25:00',2.75),('8902','2014-04-24','11:30:00',2.34),('8902','2014-04-24','11:35:00',3.05),('8902','2014-04-24','11:40:00',3.51),('8902','2014-04-24','11:45:00',3.16),('8902','2014-04-24','11:50:00',2.62),('8902','2014-04-24','11:55:00',2.53),('8902','2014-04-24','12:00:00',3.07),('8902','2014-04-24','12:05:00',4.38),('8902','2014-04-24','12:10:00',3.94),('8902','2014-04-24','12:15:00',2.34),('8902','2014-04-24','12:20:00',4.47),('8902','2014-04-24','12:25:00',7.81),('8902','2014-04-24','12:30:00',8.54),('8902','2014-04-24','12:35:00',8.19),('8902','2014-04-24','12:40:00',8.17),('8902','2014-04-24','12:45:00',8.87),('8902','2014-04-24','12:50:00',8.05),('8902','2014-04-24','12:55:00',2.82),('8902','2014-04-24','13:00:00',2.87),('8902','2014-04-24','13:05:00',5.92),('8902','2014-04-24','13:10:00',2.34),('8902','2014-04-24','13:15:00',6.57),('8902','2014-04-24','13:20:00',2.58),('8902','2014-04-24','13:25:00',3.22),('8902','2014-04-24','13:30:00',2.53),('8902','2014-04-24','13:35:00',2.35),('8902','2014-04-24','13:40:00',2.79),('8902','2014-04-24','13:45:00',3.73),('8902','2014-04-24','13:50:00',2.22),('8902','2014-04-24','13:55:00',2.52),('8902','2014-04-24','14:00:00',2.5),('8902','2014-04-24','14:05:00',3.02),('8902','2014-04-24','14:10:00',2.65),('8902','2014-04-24','14:15:00',2.17),('8902','2014-04-24','14:20:00',7.61),('8902','2014-04-24','14:25:00',9.89),('8902','2014-04-24','14:30:00',8.86),('8902','2014-04-24','14:35:00',8.24),('8902','2014-04-24','14:40:00',7.46),('8902','2014-04-24','14:45:00',8.13),('8902','2014-04-24','14:50:00',7.76),('8902','2014-04-24','14:55:00',7.86),('8902','2014-04-24','15:00:00',7.78),('8902','2014-04-24','15:05:00',7.56),('8902','2014-04-24','15:10:00',7.5),('8902','2014-04-24','15:15:00',7.37),('8902','2014-04-24','15:20:00',7.12),('8902','2014-04-24','15:25:00',7.11),('8902','2014-04-24','15:30:00',6.73),('8902','2014-04-24','15:35:00',7.1),('8902','2014-04-24','15:40:00',6.99),('8902','2014-04-24','15:45:00',6.79),('8902','2014-04-24','15:50:00',6.69),('8902','2014-04-24','15:55:00',6.64),('8902','2014-04-24','16:00:00',6.63),('8902','2014-04-24','16:05:00',6.44),('8902','2014-04-24','16:10:00',6.06),('8902','2014-04-24','16:15:00',5.94),('8902','2014-04-24','16:20:00',5.53),('8902','2014-04-24','16:25:00',5.46),('8902','2014-04-24','16:30:00',5.72),('8902','2014-04-24','16:35:00',5.63),('8902','2014-04-24','16:40:00',5.65),('8902','2014-04-24','16:45:00',5.44),('8902','2014-04-24','16:50:00',5.13),('8902','2014-04-24','16:55:00',4.4),('8902','2014-04-24','17:00:00',3.99),('8902','2014-04-24','17:05:00',4.48),('8902','2014-04-24','17:10:00',3.96),('8902','2014-04-24','17:15:00',4.06),('8902','2014-04-24','17:20:00',3.06),('8902','2014-04-24','17:25:00',2.13),('8902','2014-04-24','17:30:00',2.05),('8902','2014-04-24','17:35:00',2.11),('8902','2014-04-24','17:40:00',2.11),('8902','2014-04-24','17:45:00',1.79),('8902','2014-04-24','17:50:00',1.6),('8902','2014-04-24','17:55:00',1.45),('8902','2014-04-24','18:00:00',1.38),('8902','2014-04-24','18:05:00',1.36),('8902','2014-04-24','18:10:00',1.38),('8902','2014-04-24','18:15:00',1.2),('8902','2014-04-24','18:20:00',1.13),('8902','2014-04-24','18:25:00',1.15),('8902','2014-04-24','18:30:00',1.07),('8902','2014-04-24','18:35:00',1.04),('8902','2014-01-15','08:20:00',1.1),('8902','2014-01-15','08:25:00',1.22),('8902','2014-01-15','08:30:00',1.22),('8902','2014-01-15','08:35:00',1.33),('8902','2014-01-15','08:40:00',1.39),('8902','2014-01-15','08:45:00',1.34),('8902','2014-01-15','08:50:00',1.45),('8902','2014-01-15','08:55:00',1.45),('8902','2014-01-15','09:00:00',1.7),('8902','2014-01-15','09:05:00',1.74),('8902','2014-01-15','09:10:00',2.06),('8902','2014-01-15','09:15:00',2.06),('8902','2014-01-15','09:20:00',2.9),('8902','2014-01-15','09:25:00',3.43),('8902','2014-01-15','09:30:00',3.65),('8902','2014-01-15','09:35:00',3.71),('8902','2014-01-15','09:40:00',3.97),('8902','2014-01-15','09:45:00',3.61),('8902','2014-01-15','09:50:00',2.72),('8902','2014-01-15','09:55:00',2.13),('8902','2014-01-15','10:00:00',1.83),('8902','2014-01-15','10:05:00',1.91),('8902','2014-01-15','10:10:00',2.14),('8902','2014-01-15','10:15:00',2.4),('8902','2014-01-15','10:20:00',2.58),('8902','2014-01-15','10:25:00',2.75),('8902','2014-01-15','10:30:00',3.83),('8902','2014-01-15','10:35:00',5.06),('8902','2014-01-15','10:40:00',5.06),('8902','2014-01-15','10:45:00',3.58),('8902','2014-01-15','10:50:00',3.79),('8902','2014-01-15','10:55:00',4.29),('8902','2014-01-15','11:00:00',4.28),('8902','2014-01-15','11:05:00',4.32),('8902','2014-01-15','11:10:00',4.44),('8902','2014-01-15','11:15:00',4.57),('8902','2014-01-15','11:20:00',4.08),('8902','2014-01-15','11:25:00',4.17),('8902','2014-01-15','11:30:00',3.72),('8902','2014-01-15','11:35:00',3.64),('8902','2014-01-15','11:40:00',3.48),('8902','2014-01-15','11:45:00',3.43),('8902','2014-01-15','11:50:00',3.54),('8902','2014-01-15','11:55:00',3.08),('8902','2014-01-15','12:00:00',3.4),('8902','2014-01-15','12:05:00',2.75),('8902','2014-01-15','12:10:00',3.6),('8902','2014-01-15','12:15:00',2.9),('8902','2014-01-15','12:20:00',2.86),('8902','2014-01-15','12:25:00',2.94),('8902','2014-01-15','12:30:00',2.97),('8902','2014-01-15','12:35:00',3.65),('8902','2014-01-15','12:40:00',3.88),('8902','2014-01-15','12:45:00',4.02),('8902','2014-01-15','12:50:00',4.35),('8902','2014-01-15','12:55:00',4.56),('8902','2014-01-15','13:00:00',4.58),('8902','2014-01-15','13:05:00',4.93),('8902','2014-01-15','13:10:00',4.63),('8902','2014-01-15','13:15:00',4.52),('8902','2014-01-15','13:20:00',3.33),('8902','2014-01-15','13:25:00',4.68),('8902','2014-01-15','13:30:00',4.76),('8902','2014-01-15','13:35:00',4.51),('8902','2014-01-15','13:40:00',3.32),('8902','2014-01-15','13:45:00',2.82),('8902','2014-01-15','13:50:00',4.06),('8902','2014-01-15','13:55:00',3.56),('8902','2014-01-15','14:00:00',2.25),('8902','2014-01-15','14:05:00',2.08),('8902','2014-01-15','14:10:00',2.04),('8902','2014-01-15','14:15:00',1.73),('8902','2014-01-15','14:20:00',1.44),('8902','2014-01-15','14:25:00',1.68),('8902','2014-01-15','14:30:00',1.9),('8902','2014-01-15','14:35:00',1.79),('8902','2014-01-15','14:40:00',1.53),('8902','2014-01-15','14:45:00',1.43),('8902','2014-01-15','14:50:00',1.56),('8902','2014-01-15','14:55:00',1.79),('8902','2014-01-15','15:00:00',1.69),('8902','2014-01-15','15:05:00',1.99),('8902','2014-01-15','15:10:00',2.04),('8902','2014-01-15','15:15:00',1.36),('8902','2014-01-14','08:55:00',1.05),('8902','2014-01-14','09:00:00',1.08),('8902','2014-01-14','09:05:00',1.02),('8902','2014-01-14','09:35:00',1.01),('8902','2014-01-14','09:40:00',1.15),('8902','2014-01-14','09:45:00',1.18),('8902','2014-01-14','09:50:00',1.07),('8902','2014-01-14','09:55:00',1.17),('8902','2014-01-14','10:00:00',1.66),('8902','2014-01-14','10:05:00',1.63),('8902','2014-01-14','10:10:00',1.87),('8902','2014-01-14','10:15:00',2.89),('8902','2014-01-14','10:20:00',3.91),('8902','2014-01-14','10:25:00',4.38),('8902','2014-01-14','10:30:00',4.53),('8902','2014-01-14','10:35:00',2.68),('8902','2014-01-14','10:40:00',2.94),('8902','2014-01-14','10:45:00',4.08),('8902','2014-01-14','10:50:00',3.26),('8902','2014-01-14','10:55:00',2.87),('8902','2014-01-14','11:00:00',2.38),('8902','2014-01-14','11:05:00',2.84),('8902','2014-01-14','11:10:00',6.26),('8902','2014-01-14','11:15:00',5.15),('8902','2014-01-14','11:20:00',5.17),('8902','2014-01-14','11:25:00',5.14),('8902','2014-01-14','11:30:00',4.83),('8902','2014-01-14','11:35:00',5.96),('8902','2014-01-14','11:40:00',4.55),('8902','2014-01-14','11:45:00',4.75),('8902','2014-01-14','11:50:00',5.26),('8902','2014-01-14','11:55:00',4.25),('8902','2014-01-14','12:00:00',3.45),('8902','2014-01-14','12:05:00',3.38),('8902','2014-01-14','12:10:00',3.49),('8902','2014-01-14','12:15:00',4.4),('8902','2014-01-14','12:20:00',5.62),('8902','2014-01-14','12:25:00',5.02),('8902','2014-01-14','12:30:00',3.04),('8902','2014-01-14','12:35:00',3.2),('8902','2014-01-14','12:40:00',3.09),('8902','2014-01-14','12:45:00',2.74),('8902','2014-01-14','12:50:00',3.52),('8902','2014-01-14','12:55:00',3.29),('8902','2014-01-14','13:00:00',2.85),('8902','2014-01-14','13:05:00',3.15),('8902','2014-01-14','13:10:00',3.56),('8902','2014-01-14','13:15:00',5.95),('8902','2014-01-14','13:20:00',6.23),('8902','2014-01-14','13:25:00',6.24),('8902','2014-01-14','13:30:00',6.02),('8902','2014-01-14','13:35:00',5.83),('8902','2014-01-14','13:40:00',5.56),('8902','2014-01-14','13:45:00',5.42),('8902','2014-01-14','13:50:00',4.01),('8902','2014-01-14','14:00:00',2.5),('8902','2014-01-14','14:05:00',2.38),('8902','2014-01-14','14:10:00',4.94),('8902','2014-01-14','14:15:00',4.76),('8902','2014-01-14','14:20:00',4.61),('8902','2014-01-14','14:25:00',4.6),('8902','2014-01-14','14:30:00',4.53),('8902','2014-01-14','14:35:00',4.43),('8902','2014-01-14','14:40:00',4.44),('8902','2014-01-14','14:45:00',4.47),('8902','2014-01-14','14:50:00',4.41),('8902','2014-01-14','14:55:00',4.32),('8902','2014-01-14','15:00:00',4.26),('8902','2014-01-14','15:05:00',4.04),('8902','2014-01-14','15:10:00',3.9),('8902','2014-01-14','15:15:00',3.67),('8902','2014-01-14','15:20:00',3.38),('8902','2014-01-14','15:25:00',1.91),('8902','2014-01-14','15:30:00',2.06),('8902','2014-01-14','15:35:00',2.66),('8902','2014-01-14','15:40:00',2.67),('8902','2014-01-14','15:45:00',2.49),('8902','2014-01-14','15:50:00',2.09),('8902','2014-01-14','16:15:00',1.08),('8902','2014-01-13','10:15:00',1.07),('8902','2014-01-13','10:20:00',1.51),('8902','2014-01-13','10:25:00',2.51),('8902','2014-01-13','10:30:00',5.69),('8902','2014-01-13','10:35:00',6.13),('8902','2014-01-13','10:40:00',5.3),('8902','2014-01-13','10:45:00',4.96),('8902','2014-01-13','10:50:00',3.13),('8902','2014-01-13','10:55:00',2.31),('8902','2014-01-13','11:00:00',2.57),('8902','2014-01-13','11:05:00',2.08),('8902','2014-01-13','11:10:00',1.52),('8902','2014-01-13','11:15:00',1.64),('8902','2014-01-13','11:20:00',1.64),('8902','2014-01-13','11:25:00',1.47),('8902','2014-01-13','11:30:00',2.04),('8902','2014-01-13','11:35:00',2.4),('8902','2014-01-13','11:40:00',3.3),('8902','2014-01-13','11:45:00',1.79),('8902','2014-01-13','11:50:00',1.6),('8902','2014-01-13','11:55:00',1.54),('8902','2014-01-13','12:00:00',1.35),('8902','2014-01-12','08:55:00',1.08),('8902','2014-01-12','09:00:00',1.31),('8902','2014-01-12','09:05:00',1.19),('8902','2014-01-12','09:10:00',1.54),('8902','2014-01-12','09:15:00',1.98),('8902','2014-01-12','09:20:00',2.82),('8902','2014-01-12','09:25:00',2.89),('8902','2014-01-12','09:30:00',3),('8902','2014-01-12','09:35:00',3.15),('8902','2014-01-12','09:40:00',3.29),('8902','2014-01-12','09:45:00',3.4),('8902','2014-01-12','09:50:00',3.5),('8902','2014-01-12','09:55:00',3.62),('8902','2014-01-12','10:00:00',3.73),('8902','2014-01-12','10:05:00',3.81),('8902','2014-01-12','10:10:00',3.92),('8902','2014-01-12','10:15:00',3.99),('8902','2014-01-12','10:20:00',4.17),('8902','2014-01-12','10:25:00',4.26),('8902','2014-01-12','10:30:00',4.36),('8902','2014-01-12','10:35:00',4.41),('8902','2014-01-12','10:40:00',4.51),('8902','2014-01-12','10:45:00',4.61),('8902','2014-01-12','10:50:00',4.7),('8902','2014-01-12','10:55:00',4.81),('8902','2014-01-12','11:00:00',4.85),('8902','2014-01-12','11:05:00',4.88),('8902','2014-01-12','11:10:00',4.98),('8902','2014-01-12','11:15:00',5.06),('8902','2014-01-12','11:20:00',5.12),('8902','2014-01-12','11:25:00',5.17),('8902','2014-01-12','11:30:00',5.16),('8902','2014-01-12','11:35:00',5.19),('8902','2014-01-12','11:40:00',5.23),('8902','2014-01-12','11:45:00',5.24),('8902','2014-01-12','11:50:00',5.23),('8902','2014-01-12','11:55:00',5.28),('8902','2014-01-12','12:00:00',5.18),('8902','2014-01-12','12:05:00',5.11),('8902','2014-01-12','12:10:00',5.14),('8902','2014-01-12','12:15:00',5.28),('8902','2014-01-12','12:20:00',5.27),('8902','2014-01-12','12:25:00',5.27),('8902','2014-01-12','12:30:00',5.23),('8902','2014-01-12','12:35:00',5.19),('8902','2014-01-12','12:40:00',5.17),('8902','2014-01-12','12:45:00',5.18),('8902','2014-01-12','12:50:00',5.03),('8902','2014-01-12','12:55:00',4.81),('8902','2014-01-12','13:00:00',4.96),('8902','2014-01-12','13:05:00',4.93),('8902','2014-01-12','13:10:00',4.92),('8902','2014-01-12','13:15:00',4.82),('8902','2014-01-12','13:20:00',4.84),('8902','2014-01-12','13:25:00',4.66),('8902','2014-01-12','13:30:00',4.68),('8902','2014-01-12','13:35:00',4.78),('8902','2014-01-12','13:40:00',4.44),('8902','2014-01-12','13:45:00',4.37),('8902','2014-01-12','13:50:00',4.36),('8902','2014-01-12','13:55:00',4.35),('8902','2014-01-12','14:00:00',4.36),('8902','2014-01-12','14:05:00',4.35),('8902','2014-01-12','14:10:00',4.1),('8902','2014-01-12','14:15:00',4.11),('8902','2014-01-12','14:20:00',4.11),('8902','2014-01-12','14:25:00',4.01),('8902','2014-01-12','14:30:00',3.89),('8902','2014-01-12','14:35:00',3.81),('8902','2014-01-12','14:40:00',3.78),('8902','2014-01-12','14:45:00',3.68),('8902','2014-01-12','14:50:00',3.51),('8902','2014-01-12','14:55:00',3.34),('8902','2014-01-12','15:00:00',3.23),('8902','2014-01-12','15:05:00',3.15),('8902','2014-01-12','15:10:00',2.99),('8902','2014-01-12','15:15:00',2.83),('8902','2014-01-12','15:20:00',2.69),('8902','2014-01-12','15:25:00',2.54),('8902','2014-01-12','15:30:00',2.36),('8902','2014-01-12','15:35:00',2.18),('8902','2014-01-12','15:40:00',2.02),('8902','2014-01-12','15:45:00',1.83),('8902','2014-01-12','15:50:00',1.67),('8902','2014-01-12','15:55:00',1.49),('8902','2014-01-12','16:00:00',1.33),('8902','2014-01-12','16:05:00',1.16),('8902','2014-01-12','16:10:00',1.01),('8902','2014-01-11','09:20:00',1.09),('8902','2014-01-11','09:25:00',1.23),('8902','2014-01-11','09:30:00',1.32),('8902','2014-01-11','09:35:00',1.3),('8902','2014-01-11','09:40:00',1.53),('8902','2014-01-11','09:45:00',1.7),('8902','2014-01-11','09:50:00',1.92),('8902','2014-01-11','09:55:00',1.9),('8902','2014-01-11','10:00:00',1.81),('8902','2014-01-11','10:05:00',1.68),('8902','2014-01-11','10:10:00',1.68),('8902','2014-01-11','10:15:00',1.79),('8902','2014-01-11','10:20:00',2.03),('8902','2014-01-11','10:25:00',2.07),('8902','2014-01-11','10:30:00',2.02),('8902','2014-01-11','10:35:00',2.24),('8902','2014-01-11','10:40:00',2.65),('8902','2014-01-11','10:45:00',2.62),('8902','2014-01-11','10:50:00',2.76),('8902','2014-01-11','10:55:00',2.94),('8902','2014-01-11','11:00:00',3.02),('8902','2014-01-11','11:05:00',2.92),('8902','2014-01-11','11:10:00',3.68),('8902','2014-01-11','11:15:00',3.27),('8902','2014-01-11','11:20:00',3.04),('8902','2014-01-11','11:25:00',2.89),('8902','2014-01-11','11:30:00',3.18),('8902','2014-01-11','11:35:00',2.65),('8902','2014-01-11','11:40:00',3.28),('8902','2014-01-11','11:45:00',3.45),('8902','2014-01-11','11:50:00',3.75),('8902','2014-01-11','11:55:00',3.79),('8902','2014-01-11','12:00:00',2.8),('8902','2014-01-11','12:05:00',2.76),('8902','2014-01-11','12:10:00',2.5),('8902','2014-01-11','12:15:00',2.26),('8902','2014-01-11','12:20:00',2.29),('8902','2014-01-11','12:25:00',2.2),('8902','2014-01-11','12:30:00',2.32),('8902','2014-01-11','12:35:00',2.42),('8902','2014-01-11','12:40:00',2.64),('8902','2014-01-11','12:45:00',2.49),('8902','2014-01-11','12:50:00',2.58),('8902','2014-01-11','12:55:00',2.5),('8902','2014-01-11','13:00:00',2.54),('8902','2014-01-11','13:05:00',2.3),('8902','2014-01-11','13:10:00',2.19),('8902','2014-01-11','13:15:00',2.25),('8902','2014-01-11','13:20:00',2.33),('8902','2014-01-11','13:25:00',2.31),('8902','2014-01-11','13:30:00',2.88),('8902','2014-01-11','13:35:00',2.51),('8902','2014-01-11','13:40:00',2.32),('8902','2014-01-11','13:45:00',2),('8902','2014-01-11','13:50:00',1.82),('8902','2014-01-11','13:55:00',1.62),('8902','2014-01-11','14:00:00',1.56),('8902','2014-01-11','14:05:00',1.49),('8902','2014-01-11','14:10:00',1.38),('8902','2014-01-11','14:15:00',1.25),('8902','2014-01-11','14:20:00',1.13),('8902','2014-01-11','14:25:00',1.06),('8902','2014-01-10','08:55:00',1.01),('8902','2014-01-10','09:10:00',1.09),('8902','2014-01-10','09:15:00',1.18),('8902','2014-01-10','09:20:00',1.4),('8902','2014-01-10','09:25:00',1.75),('8902','2014-01-10','09:30:00',1.32),('8902','2014-01-10','09:35:00',1.13),('8902','2014-01-10','09:40:00',1.11),('8902','2014-01-10','09:45:00',1.26),('8902','2014-01-10','09:50:00',1.97),('8902','2014-01-10','09:55:00',2.87),('8902','2014-01-10','10:00:00',3.36),('8902','2014-01-10','10:05:00',2.62),('8902','2014-01-10','10:10:00',2.54),('8902','2014-01-10','10:15:00',2.88),('8902','2014-01-10','10:20:00',2.84),('8902','2014-01-10','10:25:00',3.58),('8902','2014-01-10','10:30:00',3.47),('8902','2014-01-10','10:35:00',3.66),('8902','2014-01-10','10:40:00',4.55),('8902','2014-01-10','10:45:00',4.85),('8902','2014-01-10','10:50:00',4.92),('8902','2014-01-10','10:55:00',4.94),('8902','2014-01-10','11:00:00',4.84),('8902','2014-01-10','11:05:00',4.61),('8902','2014-01-10','11:10:00',4.95),('8902','2014-01-10','11:15:00',4.58),('8902','2014-01-10','11:20:00',4.16),('8902','2014-01-10','11:25:00',4.22),('8902','2014-01-10','11:30:00',4.22),('8902','2014-01-10','11:35:00',3.77),('8902','2014-01-10','11:40:00',3.45),('8902','2014-01-10','11:45:00',3.51),('8902','2014-01-10','11:50:00',3.8),('8902','2014-01-10','11:55:00',3.87),('8902','2014-01-10','12:00:00',3.92),('8902','2014-01-10','12:05:00',4.55),('8902','2014-01-10','12:10:00',4.17),('8902','2014-01-10','12:15:00',4.2),('8902','2014-01-10','12:20:00',3.92),('8902','2014-01-10','12:25:00',3.78),('8902','2014-01-10','12:30:00',3.46),('8902','2014-01-10','12:35:00',3.03),('8902','2014-01-10','12:40:00',2.9),('8902','2014-01-10','12:45:00',3.23),('8902','2014-01-10','12:50:00',3.57),('8902','2014-01-10','12:55:00',4.46),('8902','2014-01-10','13:00:00',4.2),('8902','2014-01-10','13:05:00',4.06),('8902','2014-01-10','13:10:00',4.19),('8902','2014-01-10','13:15:00',4.72),('8902','2014-01-10','13:20:00',4.03),('8902','2014-01-10','13:25:00',3.22),('8902','2014-01-10','13:30:00',2.78),('8902','2014-01-10','13:35:00',2.7),('8902','2014-01-10','13:40:00',2.43),('8902','2014-01-10','13:45:00',2.66),('8902','2014-01-10','13:50:00',1.93),('8902','2014-01-10','13:55:00',2.05),('8902','2014-01-10','14:00:00',2.99),('8902','2014-01-10','14:05:00',3.17),('8902','2014-01-10','14:10:00',2.91),('8902','2014-01-10','14:15:00',1.73),('8902','2014-01-10','14:20:00',1.24),('8902','2014-01-10','14:25:00',1.08),('8902','2014-01-10','14:30:00',1.16),('8902','2014-01-10','14:35:00',1.34),('8902','2014-01-10','14:40:00',1.57),('8902','2014-01-10','14:45:00',1.64),('8902','2014-01-10','14:50:00',1.49),('8902','2014-01-10','14:55:00',1.26),('8902','2014-01-10','15:00:00',1.22),('8902','2014-01-10','15:05:00',1.14),('8902','2014-01-10','15:10:00',1.09),('8902','2014-01-10','15:15:00',1.09),('8902','2014-01-10','15:20:00',1.04),('8902','2014-01-09','09:35:00',1.04),('8902','2014-01-09','09:40:00',1.04),('8902','2014-01-09','09:50:00',1.01),('8902','2014-01-09','09:55:00',1.04),('8902','2014-01-09','10:00:00',1.06),('8902','2014-01-09','10:05:00',1.02),('8902','2014-01-09','10:10:00',1.03),('8902','2014-01-09','10:15:00',1.08),('8902','2014-01-09','10:20:00',1.11),('8902','2014-01-09','10:25:00',1.18),('8902','2014-01-09','10:30:00',1.15),('8902','2014-01-09','10:35:00',1.11),('8902','2014-01-09','10:40:00',1.05),('8902','2014-01-09','10:45:00',1.1),('8902','2014-01-09','10:50:00',1.18),('8902','2014-01-09','10:55:00',1.18),('8902','2014-01-09','11:00:00',1.22),('8902','2014-01-09','11:05:00',1.34),('8902','2014-01-09','11:10:00',1.35),('8902','2014-01-09','11:15:00',1.15),('8902','2014-01-09','11:20:00',1.05),('8902','2014-01-09','11:25:00',1.14),('8902','2014-01-09','11:30:00',1.29),('8902','2014-01-09','11:35:00',1.46),('8902','2014-01-09','11:40:00',1.5),('8902','2014-01-09','11:45:00',1.37),('8902','2014-01-09','11:50:00',1.44),('8902','2014-01-09','11:55:00',1.54),('8902','2014-01-09','12:00:00',1.2),('8902','2014-01-09','12:10:00',1.02),('8902','2014-01-09','12:15:00',1.18),('8902','2014-01-09','12:20:00',1.37),('8902','2014-01-09','12:25:00',1.4),('8902','2014-01-09','12:30:00',1.53),('8902','2014-01-09','12:35:00',1.46),('8902','2014-01-09','12:40:00',1.39),('8902','2014-01-09','12:45:00',1.45),('8902','2014-01-09','12:50:00',1.7),('8902','2014-01-09','12:55:00',1.69),('8902','2014-01-09','13:00:00',1.74),('8902','2014-01-09','13:05:00',1.79),('8902','2014-01-09','13:10:00',1.66),('8902','2014-01-09','13:15:00',1.42),('8902','2014-01-09','13:20:00',1.3),('8902','2014-01-09','13:25:00',1.28),('8902','2014-01-09','13:30:00',1.37),('8902','2014-01-09','13:35:00',1.37),('8902','2014-01-09','13:40:00',1.44),('8902','2014-01-09','13:45:00',1.31),('8902','2014-01-09','13:50:00',1.35),('8902','2014-01-09','13:55:00',1.26),('8902','2014-01-09','14:00:00',1.07),('8902','2014-01-09','14:05:00',1.04),('8902','2014-01-08','08:55:00',1.05),('8902','2014-01-08','09:00:00',1.18),('8902','2014-01-08','09:05:00',1.23),('8902','2014-01-08','09:10:00',1.87),('8902','2014-01-08','09:15:00',2.36),('8902','2014-01-08','09:20:00',2.28),('8902','2014-01-08','09:25:00',2.25),('8902','2014-01-08','09:30:00',2.76),('8902','2014-01-08','09:35:00',3.3),('8902','2014-01-08','09:40:00',3.32),('8902','2014-01-08','09:45:00',3.47),('8902','2014-01-08','09:50:00',3.53),('8902','2014-01-08','09:55:00',3.71),('8902','2014-01-08','10:00:00',3.75),('8902','2014-01-08','10:05:00',3.8),('8902','2014-01-08','10:10:00',2.89),('8902','2014-01-08','10:15:00',3.38),('8902','2014-01-08','10:20:00',3.44),('8902','2014-01-08','10:25:00',3.59),('8902','2014-01-08','10:30:00',3.7),('8902','2014-01-08','10:35:00',3.72),('8902','2014-01-08','10:40:00',3.7),('8902','2014-01-08','10:45:00',3.92),('8902','2014-01-08','10:50:00',4.14),('8902','2014-01-08','10:55:00',3.44),('8902','2014-01-08','11:00:00',2.15),('8902','2014-01-08','11:05:00',1.92),('8902','2014-01-08','11:10:00',2.17),('8902','2014-01-08','11:15:00',2.1),('8902','2014-01-08','11:20:00',2.25),('8902','2014-01-08','11:25:00',2.37),('8902','2014-01-08','11:30:00',2.25),('8902','2014-01-08','11:35:00',2.06),('8902','2014-01-08','11:40:00',2.52),('8902','2014-01-08','11:45:00',2.71),('8902','2014-01-08','11:50:00',2.31),('8902','2014-01-08','11:55:00',2.17),('8902','2014-01-08','12:00:00',1.79),('8902','2014-01-08','12:05:00',1.75),('8902','2014-01-08','12:10:00',1.53),('8902','2014-01-08','12:15:00',1.95),('8902','2014-01-08','12:20:00',1.62),('8902','2014-01-08','12:25:00',1.63),('8902','2014-01-08','12:30:00',1.63),('8902','2014-01-08','12:35:00',1.67),('8902','2014-01-08','12:40:00',1.7),('8902','2014-01-08','12:45:00',1.95),('8902','2014-01-08','12:50:00',1.83),('8902','2014-01-08','12:55:00',1.63),('8902','2014-01-08','13:00:00',1.45),('8902','2014-01-08','13:05:00',1.48),('8902','2014-01-08','13:10:00',1.56),('8902','2014-01-08','13:15:00',2.02),('8902','2014-01-08','13:20:00',1.94),('8902','2014-01-08','13:25:00',1.81),('8902','2014-01-08','13:30:00',1.85),('8902','2014-01-08','13:35:00',1.71),('8902','2014-01-08','13:40:00',1.51),('8902','2014-01-08','13:45:00',1.4),('8902','2014-01-08','13:50:00',1.45),('8902','2014-01-08','13:55:00',1.44),('8902','2014-01-08','14:00:00',1.3),('8902','2014-01-08','14:05:00',1.22),('8902','2014-01-08','14:10:00',1.24),('8902','2014-01-08','14:15:00',1.32),('8902','2014-01-08','14:20:00',1.23),('8902','2014-01-08','14:25:00',1.15),('8902','2014-01-08','14:30:00',1.1),('8902','2014-01-08','14:35:00',1.16),('8902','2014-01-08','14:40:00',1.11),('8902','2014-01-08','14:45:00',1.11),('8902','2014-01-08','14:50:00',1.03),('8902','2014-01-07','08:35:00',1.11),('8902','2014-01-07','08:40:00',1.22),('8902','2014-01-07','08:45:00',1.23),('8902','2014-01-07','08:50:00',1.32),('8902','2014-01-07','08:55:00',1.79),('8902','2014-01-07','09:00:00',2.02),('8902','2014-01-07','09:05:00',2.14),('8902','2014-01-07','09:10:00',2.32),('8902','2014-01-07','09:15:00',2.48),('8902','2014-01-07','09:20:00',2.62),('8902','2014-01-07','09:25:00',2.79),('8902','2014-01-07','09:30:00',2.83),('8902','2014-01-07','09:35:00',2.93),('8902','2014-01-07','09:40:00',3.19),('8902','2014-01-07','09:45:00',3.36),('8902','2014-01-07','09:50:00',3.41),('8902','2014-01-07','09:55:00',3.58),('8902','2014-01-07','10:00:00',3.62),('8902','2014-01-07','10:05:00',3.62),('8902','2014-01-07','10:10:00',3.79),('8902','2014-01-07','10:15:00',3.96),('8902','2014-01-07','10:20:00',4.16),('8902','2014-01-07','10:25:00',4.14),('8902','2014-01-07','10:30:00',4.33),('8902','2014-01-07','10:35:00',4.27),('8902','2014-01-07','10:40:00',4.16),('8902','2014-01-07','10:45:00',4.54),('8902','2014-01-07','10:50:00',4.72),('8902','2014-01-07','10:55:00',4.84),('8902','2014-01-07','11:00:00',4.93),('8902','2014-01-07','11:05:00',4.98),('8902','2014-01-07','11:10:00',5.05),('8902','2014-01-07','11:15:00',5.11),('8902','2014-01-07','11:20:00',5.17),('8902','2014-01-07','11:25:00',5.15),('8902','2014-01-07','11:30:00',5.12),('8902','2014-01-07','11:35:00',5.34),('8902','2014-01-07','11:40:00',5.43),('8902','2014-01-07','11:45:00',5.38),('8902','2014-01-07','11:50:00',5.34),('8902','2014-01-07','11:55:00',5.35),('8902','2014-01-07','12:00:00',5.29),('8902','2014-01-07','12:05:00',5.21),('8902','2014-01-07','12:10:00',5.27),('8902','2014-01-07','12:15:00',5.38),('8902','2014-01-07','12:20:00',5.39),('8902','2014-01-07','12:25:00',5.4),('8902','2014-01-07','12:30:00',5.41),('8902','2014-01-07','12:35:00',5.23),('8902','2014-01-07','12:40:00',5.19),('8902','2014-01-07','12:45:00',5.08),('8902','2014-01-07','12:50:00',4.98),('8902','2014-01-07','12:55:00',5.05),('8902','2014-01-07','13:00:00',5.02),('8902','2014-01-07','13:05:00',4.98),('8902','2014-01-07','13:10:00',5),('8902','2014-01-07','13:15:00',4.98),('8902','2014-01-07','13:20:00',4.94),('8902','2014-01-07','13:25:00',4.82),('8902','2014-01-07','13:30:00',4.75),('8902','2014-01-07','13:35:00',4.64),('8902','2014-01-07','13:40:00',4.6),('8902','2014-01-07','13:45:00',4.52),('8902','2014-01-07','13:50:00',4.46),('8902','2014-01-07','13:55:00',4.35),('8902','2014-01-07','14:00:00',4.29),('8902','2014-01-07','14:05:00',4.27),('8902','2014-01-07','14:10:00',4.21),('8902','2014-01-07','14:15:00',4.16),('8902','2014-01-07','14:20:00',4.15),('8902','2014-01-07','14:25:00',4.08),('8902','2014-01-07','14:30:00',4.13),('8902','2014-01-07','14:35:00',4.03),('8902','2014-01-07','14:40:00',3.73),('8902','2014-01-07','14:45:00',3.55),('8902','2014-01-07','14:50:00',3.45),('8902','2014-01-07','14:55:00',3.04),('8902','2014-01-07','15:00:00',2.67),('8902','2014-01-07','15:05:00',2.69),('8902','2014-01-07','15:10:00',2.22),('8902','2014-01-07','15:15:00',2.32),('8902','2014-01-07','15:20:00',2.43),('8902','2014-01-07','15:25:00',2.46),('8902','2014-01-07','15:30:00',2.24),('8902','2014-01-07','15:35:00',2.06),('8902','2014-01-07','15:40:00',1.96),('8902','2014-01-07','15:45:00',1.72),('8902','2014-01-07','15:50:00',1.48),('8902','2014-01-07','15:55:00',1.12),('8902','2014-01-07','16:00:00',1.01),('8902','2014-01-06','08:35:00',1.1),('8902','2014-01-06','08:40:00',1.28),('8902','2014-01-06','08:45:00',1.63),('8902','2014-01-06','08:50:00',1.85),('8902','2014-01-06','08:55:00',2.03),('8902','2014-01-06','09:00:00',2.18),('8902','2014-01-06','09:05:00',2.34),('8902','2014-01-06','09:10:00',2.5),('8902','2014-01-06','09:15:00',2.65),('8902','2014-01-06','09:20:00',2.85),('8902','2014-01-06','09:25:00',3.01),('8902','2014-01-06','09:30:00',3.17),('8902','2014-01-06','09:35:00',3.32),('8902','2014-01-06','09:40:00',3.45),('8902','2014-01-06','09:45:00',3.59),('8902','2014-01-06','09:50:00',3.72),('8902','2014-01-06','09:55:00',3.84),('8902','2014-01-06','10:00:00',3.95),('8902','2014-01-06','10:05:00',4.06),('8902','2014-01-06','10:10:00',4.16),('8902','2014-01-06','10:15:00',4.27),('8902','2014-01-06','10:20:00',4.35),('8902','2014-01-06','10:25:00',4.45),('8902','2014-01-06','10:30:00',4.52),('8902','2014-01-06','10:35:00',4.62),('8902','2014-01-06','10:40:00',4.72),('8902','2014-01-06','10:45:00',4.82),('8902','2014-01-06','10:50:00',4.91),('8902','2014-01-06','10:55:00',4.99),('8902','2014-01-06','11:00:00',5.04),('8902','2014-01-06','11:05:00',5.11),('8902','2014-01-06','11:10:00',5.17),('8902','2014-01-06','11:15:00',5.21),('8902','2014-01-06','11:20:00',5.27),('8902','2014-01-06','11:25:00',5.32),('8902','2014-01-06','11:30:00',5.38),('8902','2014-01-06','11:35:00',5.41),('8902','2014-01-06','11:40:00',5.43),('8902','2014-01-06','11:45:00',5.51),('8902','2014-01-06','11:50:00',5.54),('8902','2014-01-06','11:55:00',5.55),('8902','2014-01-06','12:00:00',5.51),('8902','2014-01-06','12:05:00',5.58),('8902','2014-01-06','12:10:00',5.59),('8902','2014-01-06','12:15:00',5.56),('8902','2014-01-06','12:20:00',5.58),('8902','2014-01-06','12:25:00',5.56),('8902','2014-01-06','12:30:00',5.48),('8902','2014-01-06','12:35:00',5.51),('8902','2014-01-06','12:40:00',5.33),('8902','2014-01-06','12:45:00',5.2),('8902','2014-01-06','12:50:00',5.42),('8902','2014-01-06','12:55:00',5.54),('8902','2014-01-06','13:00:00',5.21),('8902','2014-01-06','13:05:00',5),('8902','2014-01-06','13:10:00',5.11),('8902','2014-01-06','13:15:00',5.15),('8902','2014-01-06','13:20:00',4.93),('8902','2014-01-06','13:25:00',4.84),('8902','2014-01-06','13:30:00',4.77),('8902','2014-01-06','13:35:00',4.69),('8902','2014-01-06','13:40:00',4.74),('8902','2014-01-06','13:45:00',4.89),('8902','2014-01-06','13:50:00',4.85),('8902','2014-01-06','13:55:00',4.73),('8902','2014-01-06','14:00:00',4.79),('8902','2014-01-06','14:05:00',4.57),('8902','2014-01-06','14:10:00',4.45),('8902','2014-01-06','14:15:00',4.37),('8902','2014-01-06','14:20:00',4.39),('8902','2014-01-06','14:25:00',4.18),('8902','2014-01-06','14:30:00',4.06),('8902','2014-01-06','14:35:00',3.95),('8902','2014-01-06','14:40:00',3.97),('8902','2014-01-06','14:45:00',3.75),('8902','2014-01-06','14:50:00',3.72),('8902','2014-01-06','14:55:00',3.67),('8902','2014-01-06','15:00:00',3.51),('8902','2014-01-06','15:05:00',3.47),('8902','2014-01-06','15:10:00',3.34),('8902','2014-01-06','15:15:00',3.15),('8902','2014-01-06','15:20:00',2.97),('8902','2014-01-06','15:25:00',2.72),('8902','2014-01-06','15:30:00',2.45),('8902','2014-01-06','15:35:00',2.16),('8902','2014-01-06','15:40:00',1.72),('8902','2014-01-06','15:45:00',1.65),('8902','2014-01-06','15:50:00',1.59),('8902','2014-01-06','15:55:00',1.47),('8902','2014-01-06','16:00:00',1.19),('8902','2014-01-06','16:05:00',1.08),('8902','2014-01-06','16:10:00',1.21),('8902','2014-04-23','07:45:00',1.19),('8902','2014-04-23','07:50:00',1.44),('8902','2014-04-23','07:55:00',1.59),('8902','2014-04-23','08:00:00',1.73),('8902','2014-04-23','08:05:00',1.89),('8902','2014-04-23','08:10:00',2.03),('8902','2014-04-23','08:15:00',2.2),('8902','2014-04-23','08:20:00',2.39),('8902','2014-04-23','08:25:00',2.58),('8902','2014-04-23','08:30:00',2.75),('8902','2014-04-23','08:35:00',2.93),('8902','2014-04-23','08:40:00',3.11),('8902','2014-04-23','08:45:00',3.29),('8902','2014-04-23','08:50:00',3.45),('8902','2014-04-23','08:55:00',3.63),('8902','2014-04-23','09:00:00',3.8),('8902','2014-04-23','09:05:00',3.96),('8902','2014-04-23','09:10:00',4.1),('8902','2014-04-23','09:15:00',4.25),('8902','2014-04-23','09:20:00',4.42),('8902','2014-04-23','09:25:00',4.55),('8902','2014-04-23','09:30:00',4.7),('8902','2014-04-23','09:35:00',4.86),('8902','2014-04-23','09:40:00',4.99),('8902','2014-04-23','09:45:00',5.13),('8902','2014-04-23','09:50:00',5.29),('8902','2014-04-23','09:55:00',5.44),('8902','2014-04-23','10:00:00',5.57),('8902','2014-04-23','10:05:00',5.68),('8902','2014-04-23','10:10:00',5.75),('8902','2014-04-23','10:15:00',5.84),('8902','2014-04-23','10:20:00',5.96),('8902','2014-04-23','10:25:00',6.07),('8902','2014-04-23','10:30:00',6.19),('8902','2014-04-23','10:35:00',6.26),('8902','2014-04-23','10:40:00',6.44),('8902','2014-04-23','10:45:00',6.56),('8902','2014-04-23','10:50:00',6.7),('8902','2014-04-23','10:55:00',6.8),('8902','2014-04-23','11:00:00',6.85),('8902','2014-04-23','11:05:00',6.85),('8902','2014-04-23','11:10:00',6.9),('8902','2014-04-23','11:15:00',7.02),('8902','2014-04-23','11:20:00',7.08),('8902','2014-04-23','11:25:00',7.15),('8902','2014-04-23','11:30:00',7.15),('8902','2014-04-23','11:35:00',7.22),('8902','2014-04-23','11:40:00',7.35),('8902','2014-04-23','11:45:00',7.4),('8902','2014-04-23','11:50:00',7.23),('8902','2014-04-23','11:55:00',7.67),('8902','2014-04-23','12:00:00',7.45),('8902','2014-04-23','12:05:00',7.57),('8902','2014-04-23','12:10:00',7.92),('8902','2014-04-23','12:15:00',5.82),('8902','2014-04-23','12:20:00',6.83),('8902','2014-04-23','12:25:00',8.1),('8902','2014-04-23','12:30:00',7.7),('8902','2014-04-23','12:35:00',5.27),('8902','2014-04-23','12:40:00',8.23),('8902','2014-04-23','12:45:00',5.79),('8902','2014-04-23','12:50:00',8.41),('8902','2014-04-23','12:55:00',8.21),('8902','2014-04-23','13:00:00',8.05),('8902','2014-04-23','13:05:00',8.1),('8902','2014-04-23','13:10:00',6.46),('8902','2014-04-23','13:15:00',2.14),('8902','2014-04-23','13:20:00',8.63),('8902','2014-04-23','13:25:00',8.6),('8902','2014-04-23','13:30:00',8.51),('8902','2014-04-23','13:35:00',8.11),('8902','2014-04-23','13:40:00',5.74),('8902','2014-04-23','13:45:00',2.53),('8902','2014-04-23','13:50:00',8.39),('8902','2014-04-23','13:55:00',9.12),('8902','2014-04-23','14:00:00',7.17),('8902','2014-04-23','14:05:00',6.36),('8902','2014-04-23','14:10:00',7.67),('8902','2014-04-23','14:15:00',6.45),('8902','2014-04-23','14:20:00',6.25),('8902','2014-04-23','14:25:00',8.02),('8902','2014-04-23','14:30:00',8.88),('8902','2014-04-23','14:35:00',8.52),('8902','2014-04-23','14:40:00',6.31),('8902','2014-04-23','14:45:00',7.02),('8902','2014-04-23','14:50:00',3.47),('8902','2014-04-23','14:55:00',6.74),('8902','2014-04-23','15:00:00',9.28),('8902','2014-04-23','15:05:00',8.97),('8902','2014-04-23','15:10:00',8.39),('8902','2014-04-23','15:15:00',7.61),('8902','2014-04-23','15:20:00',5.65),('8902','2014-04-23','15:25:00',4.47),('8902','2014-04-23','15:30:00',4.73),('8902','2014-04-23','15:35:00',5.7),('8902','2014-04-23','15:40:00',4.37),('8902','2014-04-23','15:45:00',3.97),('8902','2014-04-23','15:50:00',4.98),('8902','2014-04-23','15:55:00',5.43),('8902','2014-04-23','16:00:00',7.49),('8902','2014-04-23','16:05:00',7.5),('8902','2014-04-23','16:10:00',6.35),('8902','2014-04-23','16:15:00',6.77),('8902','2014-04-23','16:20:00',6.19),('8902','2014-04-23','16:25:00',4.63),('8902','2014-04-23','16:30:00',6.03),('8902','2014-04-23','16:35:00',3.56),('8902','2014-04-23','16:40:00',4.23),('8902','2014-04-23','16:45:00',4.61),('8902','2014-04-23','16:50:00',3.01),('8902','2014-04-23','16:55:00',3.48),('8902','2014-04-23','17:00:00',2.65),('8902','2014-04-23','17:05:00',2.39),('8902','2014-04-23','17:10:00',2.22),('8902','2014-04-23','17:15:00',2.03),('8902','2014-04-23','17:20:00',2.05),('8902','2014-04-23','17:25:00',2.04),('8902','2014-04-23','17:30:00',1.96),('8902','2014-04-23','17:35:00',1.9),('8902','2014-04-23','17:40:00',1.7),('8902','2014-04-23','17:45:00',1.15),('8902','2014-01-05','11:00:00',1.01),('8902','2014-01-05','11:05:00',1.29),('8902','2014-01-05','11:10:00',1.5),('8902','2014-01-05','11:15:00',1.71),('8902','2014-01-05','11:20:00',1.78),('8902','2014-01-05','11:25:00',1.68),('8902','2014-01-05','11:30:00',1.5),('8902','2014-01-05','11:35:00',2.74),('8902','2014-01-05','11:40:00',5.49),('8902','2014-01-05','11:45:00',5.79),('8902','2014-01-05','11:50:00',4.92),('8902','2014-01-05','11:55:00',4.55),('8902','2014-01-05','12:00:00',2.33),('8902','2014-01-05','12:05:00',5.47),('8902','2014-01-05','12:10:00',5.71),('8902','2014-01-05','12:15:00',5.57),('8902','2014-01-05','12:20:00',5.59),('8902','2014-01-05','12:25:00',5.56),('8902','2014-01-05','12:30:00',5.5),('8902','2014-01-05','12:35:00',5.48),('8902','2014-01-05','12:40:00',5.49),('8902','2014-01-05','12:45:00',5.53),('8902','2014-01-05','12:50:00',5.51),('8902','2014-01-05','12:55:00',5.46),('8902','2014-01-05','13:00:00',5.44),('8902','2014-01-05','13:05:00',5.35),('8902','2014-01-05','13:10:00',5.38),('8902','2014-01-05','13:15:00',5.52),('8902','2014-01-05','13:20:00',5.49),('8902','2014-01-05','13:25:00',5.33),('8902','2014-01-05','13:30:00',5.03),('8902','2014-01-05','13:35:00',5.06),('8902','2014-01-05','13:40:00',5.03),('8902','2014-01-05','13:45:00',4.88),('8902','2014-01-05','13:50:00',4.8),('8902','2014-01-05','13:55:00',4.79),('8902','2014-01-05','14:00:00',3.24),('8902','2014-01-05','14:10:00',1),('8902','2014-01-05','14:15:00',1.13),('8902','2014-01-05','14:20:00',4.3),('8902','2014-01-05','14:25:00',1.97),('8902','2014-01-05','14:30:00',1.45),('8902','2014-01-05','14:35:00',1.93),('8902','2014-01-05','14:40:00',4.4),('8902','2014-01-05','14:45:00',4.69),('8902','2014-01-05','14:50:00',3.19),('8902','2014-01-05','14:55:00',1.4),('8902','2014-01-05','15:00:00',2.06),('8902','2014-01-05','15:05:00',3.09),('8902','2014-01-05','15:10:00',3.15),('8902','2014-01-05','15:15:00',2.99),('8902','2014-01-05','15:20:00',2.76),('8902','2014-01-05','15:25:00',2.42),('8902','2014-01-05','15:30:00',2.18),('8902','2014-01-05','15:35:00',2.27),('8902','2014-01-05','15:40:00',2.13),('8902','2014-01-05','15:45:00',1.7),('8902','2014-01-05','15:50:00',1.62),('8902','2014-01-05','15:55:00',1.35),('8902','2014-01-05','16:00:00',1.23),('8902','2014-01-05','16:05:00',1.15),('8902','2014-01-05','16:10:00',1.04),('8902','2014-01-04','12:40:00',1),('8902','2014-01-04','13:20:00',1.07),('8902','2014-01-04','13:25:00',1.02),('8902','2014-01-04','13:30:00',1.06),('8902','2014-01-04','15:10:00',1.18),('8902','2014-01-04','15:15:00',1.19),('8902','2014-01-03','14:55:00',1.06),('8902','2014-01-03','15:00:00',1.64),('8902','2014-01-03','15:05:00',1.07),('8902','2014-01-02','08:55:00',1.53),('8902','2014-01-02','09:10:00',1.28),('8902','2014-01-02','09:15:00',1.76),('8902','2014-01-02','09:20:00',2.27),('8902','2014-01-02','09:25:00',1.72),('8902','2014-01-02','09:30:00',2.43),('8902','2014-01-02','09:35:00',3.29),('8902','2014-01-02','09:40:00',3.84),('8902','2014-01-02','09:45:00',3.2),('8902','2014-01-02','09:50:00',1.69),('8902','2014-01-02','09:55:00',1.52),('8902','2014-01-02','10:00:00',1.66),('8902','2014-01-02','10:05:00',3.46),('8902','2014-01-02','10:10:00',3.34),('8902','2014-01-02','10:15:00',1.6),('8902','2014-01-02','10:20:00',4.97),('8902','2014-01-02','10:25:00',2.59),('8902','2014-01-02','10:30:00',2.3),('8902','2014-01-02','10:35:00',2.08),('8902','2014-01-02','10:40:00',2.5),('8902','2014-01-02','10:45:00',2.6),('8902','2014-01-02','10:50:00',2.73),('8902','2014-01-02','10:55:00',2.27),('8902','2014-01-02','11:00:00',1.94),('8902','2014-01-02','11:05:00',2.13),('8902','2014-01-02','11:10:00',1.77),('8902','2014-01-02','11:15:00',1.48),('8902','2014-01-02','11:20:00',1.68),('8902','2014-01-02','11:25:00',1.5),('8902','2014-01-02','11:30:00',1.48),('8902','2014-01-02','11:35:00',1.72),('8902','2014-01-02','11:40:00',1.8),('8902','2014-01-02','11:45:00',2.18),('8902','2014-01-02','11:50:00',2.14),('8902','2014-01-02','11:55:00',2.05),('8902','2014-01-02','12:00:00',2.19),('8902','2014-01-02','12:05:00',3.09),('8902','2014-01-02','12:10:00',3.44),('8902','2014-01-02','12:15:00',2.94),('8902','2014-01-02','12:20:00',1.92),('8902','2014-01-02','12:25:00',3.35),('8902','2014-01-02','12:30:00',2.48),('8902','2014-01-02','12:35:00',3.14),('8902','2014-01-02','12:40:00',3.21),('8902','2014-01-02','12:45:00',3.47),('8902','2014-01-02','12:50:00',3.1),('8902','2014-01-02','12:55:00',4.17),('8902','2014-01-02','13:00:00',2.48),('8902','2014-01-02','13:05:00',2.04),('8902','2014-01-02','13:10:00',2.54),('8902','2014-01-02','13:15:00',2.24),('8902','2014-01-02','13:20:00',1.73),('8902','2014-01-02','13:25:00',1.84),('8902','2014-01-02','13:30:00',2.49),('8902','2014-01-02','13:35:00',3.77),('8902','2014-01-02','13:40:00',2.34),('8902','2014-01-02','13:45:00',2.84),('8902','2014-01-02','13:50:00',1.85),('8902','2014-01-02','13:55:00',1.52),('8902','2014-01-02','14:00:00',1.29),('8902','2014-01-01','08:35:00',1.15),('8902','2014-01-01','08:40:00',1.38),('8902','2014-01-01','08:45:00',1.56),('8902','2014-01-01','08:50:00',1.79),('8902','2014-01-01','08:55:00',1.93),('8902','2014-01-01','09:00:00',2.11),('8902','2014-01-01','09:05:00',2.29),('8902','2014-01-01','09:10:00',2.41),('8902','2014-01-01','09:15:00',2.57),('8902','2014-01-01','09:20:00',2.74),('8902','2014-01-01','09:25:00',2.84),('8902','2014-01-01','09:30:00',2.97),('8902','2014-01-01','09:35:00',3.07),('8902','2014-01-01','09:40:00',3.24),('8902','2014-01-01','09:45:00',3.36),('8902','2014-01-01','09:50:00',3.47),('8902','2014-01-01','09:55:00',3.64),('8902','2014-01-01','10:00:00',3.83),('8902','2014-01-01','10:05:00',3.99),('8902','2014-01-01','10:10:00',4.05),('8902','2014-01-01','10:15:00',4.1),('8902','2014-01-01','10:20:00',4.17),('8902','2014-01-01','10:25:00',4.32),('8902','2014-01-01','10:30:00',4.42),('8902','2014-01-01','10:35:00',4.38),('8902','2014-01-01','10:40:00',4.45),('8902','2014-01-01','10:45:00',4.54),('8902','2014-01-01','10:50:00',4.67),('8902','2014-01-01','10:55:00',4.89),('8902','2014-01-01','11:00:00',4.54),('8902','2014-01-01','11:05:00',4.87),('8902','2014-01-01','11:10:00',3.45),('8902','2014-01-01','11:15:00',2.75),('8902','2014-01-01','11:20:00',2.37),('8902','2014-01-01','11:25:00',2.69),('8902','2014-01-01','11:30:00',3.1),('8902','2014-01-01','11:35:00',3.18),('8902','2014-01-01','11:40:00',3.52),('8902','2014-01-01','11:45:00',2.96),('8902','2014-01-01','11:50:00',2.66),('8902','2014-01-01','11:55:00',2.38),('8902','2014-01-01','12:00:00',2.22),('8902','2014-01-01','12:05:00',2.26),('8902','2014-01-01','12:10:00',2.46),('8902','2014-01-01','12:15:00',2.11),('8902','2014-01-01','12:20:00',1.96),('8902','2014-01-01','12:25:00',1.89),('8902','2014-01-01','12:30:00',1.77),('8902','2014-01-01','12:35:00',1.42),('8902','2014-01-01','12:40:00',1.44),('8902','2014-01-01','12:45:00',1.76),('8902','2014-01-01','12:50:00',2.59),('8902','2014-01-01','12:55:00',6.38),('8902','2014-01-01','13:00:00',4.59),('8902','2014-01-01','13:05:00',1.46),('8902','2014-01-01','13:10:00',1.12),('8902','2014-01-01','13:15:00',1.06),('8902','2014-01-01','13:30:00',1.48),('8902','2014-01-01','13:35:00',1.78),('8902','2014-01-01','13:40:00',2.45),('8902','2014-01-01','13:45:00',2.9),('8902','2014-01-01','13:50:00',1.54),('8902','2014-01-01','13:55:00',1.06),('8902','2014-01-01','14:20:00',1.2),('8902','2014-01-01','14:25:00',1.19),('8902','2014-01-01','14:30:00',1.07),('8902','2013-12-31','08:25:00',1.07),('8902','2013-12-31','08:30:00',1.23),('8902','2013-12-31','08:35:00',1.13),('8902','2013-12-31','08:40:00',1.21),('8902','2013-12-31','08:50:00',1.13),('8902','2013-12-31','08:55:00',2.22),('8902','2013-12-31','09:00:00',2.64),('8902','2013-12-31','09:05:00',2.59),('8902','2013-12-31','09:10:00',3.2),('8902','2013-12-31','09:15:00',2.07),('8902','2013-12-31','09:20:00',2.1),('8902','2013-12-31','09:25:00',2.19),('8902','2013-12-31','09:30:00',3.68),('8902','2013-12-31','09:35:00',2.53),('8902','2013-12-31','09:40:00',3.01),('8902','2013-12-31','09:45:00',2.94),('8902','2013-12-31','09:50:00',4.4),('8902','2013-12-31','09:55:00',3),('8902','2013-12-31','10:00:00',2.25),('8902','2013-12-31','10:05:00',2.06),('8902','2013-12-31','10:10:00',1.75),('8902','2013-12-31','10:15:00',1.55),('8902','2013-12-31','10:20:00',1.44),('8902','2013-12-31','10:25:00',1.41),('8902','2013-12-31','10:30:00',1.4),('8902','2013-12-31','10:35:00',1.36),('8902','2013-12-31','10:40:00',1.37),('8902','2013-12-31','10:45:00',1.44),('8902','2013-12-31','10:50:00',1.53),('8902','2013-12-31','10:55:00',1.68),('8902','2013-12-31','11:00:00',1.71),('8902','2013-12-31','11:05:00',1.64),('8902','2013-12-31','11:10:00',1.59),('8902','2013-12-31','11:15:00',1.66),('8902','2013-12-31','11:20:00',1.76),('8902','2013-12-31','11:25:00',1.8),('8902','2013-12-31','11:30:00',1.83),('8902','2013-12-31','11:35:00',1.77),('8902','2013-12-31','11:40:00',1.76),('8902','2013-12-31','11:45:00',1.76),('8902','2013-12-31','11:50:00',1.72),('8902','2013-12-31','11:55:00',1.79),('8902','2013-12-31','12:00:00',1.97),('8902','2013-12-31','12:05:00',2.08),('8902','2013-12-31','12:10:00',2.22),('8902','2013-12-31','12:15:00',2.32),('8902','2013-12-31','12:20:00',2.39),('8902','2013-12-31','12:25:00',2.41),('8902','2013-12-31','12:30:00',2.56),('8902','2013-12-31','12:35:00',2.88),('8902','2013-12-31','12:40:00',2.75),('8902','2013-12-31','12:45:00',2.4),('8902','2013-12-31','12:50:00',2.75),('8902','2013-12-31','12:55:00',2.42),('8902','2013-12-31','13:00:00',2.46),('8902','2013-12-31','13:05:00',2.06),('8902','2013-12-31','13:10:00',1.94),('8902','2013-12-31','13:15:00',1.92),('8902','2013-12-31','13:20:00',2.02),('8902','2013-12-31','13:25:00',2.2),('8902','2013-12-31','13:30:00',2.68),('8902','2013-12-31','13:35:00',4.53),('8902','2013-12-31','13:40:00',3.74),('8902','2013-12-31','13:45:00',2.7),('8902','2013-12-31','13:50:00',2.76),('8902','2013-12-31','13:55:00',3.69),('8902','2013-12-31','14:00:00',4.28),('8902','2013-12-31','14:05:00',2.24),('8902','2013-12-31','14:10:00',2.07),('8902','2013-12-31','14:15:00',2.23),('8902','2013-12-31','14:20:00',2.07),('8902','2013-12-31','14:25:00',1.77),('8902','2013-12-31','14:30:00',1.75),('8902','2013-12-31','14:35:00',1.6),('8902','2013-12-31','14:40:00',1.74),('8902','2013-12-31','14:45:00',1.79),('8902','2013-12-31','14:50:00',1.63),('8902','2013-12-31','14:55:00',1.98),('8902','2013-12-31','15:00:00',1.62),('8902','2013-12-31','15:05:00',3.33),('8902','2013-12-31','15:10:00',3.69),('8902','2013-12-31','15:15:00',3.09),('8902','2013-12-31','15:20:00',2.76),('8902','2013-12-31','15:25:00',2.51),('8902','2013-12-31','15:30:00',2.28),('8902','2013-12-31','15:35:00',2.12),('8902','2013-12-31','15:40:00',1.93),('8902','2013-12-31','15:45:00',1.71),('8902','2013-12-31','15:50:00',1.54),('8902','2013-12-31','15:55:00',1.37),('8902','2013-12-31','16:00:00',1.19),('8902','2013-12-31','16:05:00',1),('8902','2013-12-30','08:45:00',1.52),('8902','2013-12-30','08:50:00',1.47),('8902','2013-12-30','08:55:00',1.07),('8902','2013-12-30','09:00:00',2.36),('8902','2013-12-30','09:05:00',1.26),('8902','2013-12-30','09:10:00',1.1),('8902','2013-12-30','09:15:00',1.9),('8902','2013-12-30','09:20:00',2.97),('8902','2013-12-30','09:25:00',3.13),('8902','2013-12-30','09:30:00',3.43),('8902','2013-12-30','09:35:00',3.61),('8902','2013-12-30','09:40:00',3.84),('8902','2013-12-30','09:45:00',3.19),('8902','2013-12-30','09:50:00',3.37),('8902','2013-12-30','09:55:00',2.81),('8902','2013-12-30','10:00:00',3.27),('8902','2013-12-30','10:05:00',2.48),('8902','2013-12-30','10:10:00',2.05),('8902','2013-12-30','10:15:00',1.75),('8902','2013-12-30','10:20:00',1.54),('8902','2013-12-30','10:25:00',1.65),('8902','2013-12-30','10:30:00',1.95),('8902','2013-12-30','10:35:00',1.89),('8902','2013-12-30','10:40:00',1.81),('8902','2013-12-30','10:45:00',1.85),('8902','2013-12-30','10:50:00',2.35),('8902','2013-12-30','10:55:00',2.59),('8902','2013-12-30','11:00:00',2.61),('8902','2013-12-30','11:05:00',2.61),('8902','2013-12-30','11:10:00',2.67),('8902','2013-12-30','11:15:00',3.21),('8902','2013-12-30','11:20:00',3.11),('8902','2013-12-30','11:25:00',3.74),('8902','2013-12-30','11:30:00',4.64),('8902','2013-12-30','11:35:00',2.61),('8902','2013-12-30','11:40:00',3.61),('8902','2013-12-30','11:45:00',2.52),('8902','2013-12-30','11:50:00',4.87),('8902','2013-12-30','11:55:00',4.73),('8902','2013-12-30','12:00:00',5.98),('8902','2013-12-30','12:05:00',5.85),('8902','2013-12-30','12:10:00',5.81),('8902','2013-12-30','12:15:00',5.77),('8902','2013-12-30','12:20:00',5.74),('8902','2013-12-30','12:25:00',5.69),('8902','2013-12-30','12:30:00',5.56),('8902','2013-12-30','12:35:00',5.58),('8902','2013-12-30','12:40:00',5.58),('8902','2013-12-30','12:45:00',5.55),('8902','2013-12-30','12:50:00',5.51),('8902','2013-12-30','12:55:00',5.49),('8902','2013-12-30','13:00:00',5.48),('8902','2013-12-30','13:05:00',5.44),('8902','2013-12-30','13:10:00',5.4),('8902','2013-12-30','13:15:00',5.38),('8902','2013-12-30','13:20:00',5.32),('8902','2013-12-30','13:25:00',5.28),('8902','2013-12-30','13:30:00',5.23),('8902','2013-12-30','13:35:00',5.12),('8902','2013-12-30','13:40:00',5.02),('8902','2013-12-30','13:45:00',4.94),('8902','2013-12-30','13:50:00',4.84),('8902','2013-12-30','13:55:00',4.77),('8902','2013-12-30','14:00:00',4.69),('8902','2013-12-30','14:05:00',4.62),('8902','2013-12-30','14:10:00',4.5),('8902','2013-12-30','14:15:00',4.41),('8902','2013-12-30','14:20:00',4.32),('8902','2013-12-30','14:25:00',4.23),('8902','2013-12-30','14:30:00',4.1),('8902','2013-12-30','14:35:00',3.98),('8902','2013-12-30','14:40:00',3.86),('8902','2013-12-30','14:45:00',3.72),('8902','2013-12-30','14:50:00',3.57),('8902','2013-12-30','14:55:00',3.43),('8902','2013-12-30','15:00:00',3.29),('8902','2013-12-30','15:05:00',3.14),('8902','2013-12-30','15:10:00',2.96),('8902','2013-12-30','15:15:00',2.79),('8902','2013-12-30','15:20:00',2.64),('8902','2013-12-30','15:25:00',2.48),('8902','2013-12-30','15:30:00',2.31),('8902','2013-12-30','15:35:00',2.13),('8902','2013-12-30','15:40:00',1.94),('8902','2013-12-30','15:45:00',1.74),('8902','2013-12-30','15:50:00',1.59),('8902','2013-12-30','15:55:00',1.41),('8902','2013-12-30','16:00:00',1.25),('8902','2013-12-30','16:05:00',1.07),('8902','2013-12-29','09:10:00',1.1),('8902','2013-12-29','09:15:00',1.08),('8902','2013-12-29','09:20:00',1.16),('8902','2013-12-29','09:25:00',1.33),('8902','2013-12-29','09:30:00',1.3),('8902','2013-12-29','09:35:00',1.05),('8902','2013-12-29','09:40:00',1.01),('8902','2013-12-29','11:05:00',1.07),('8902','2013-12-29','11:10:00',1.25),('8902','2013-12-29','11:15:00',1.48),('8902','2013-12-29','11:20:00',1.77),('8902','2013-12-29','11:25:00',2),('8902','2013-12-29','11:30:00',2.01),('8902','2013-12-29','11:35:00',1.88),('8902','2013-12-29','11:40:00',1.75),('8902','2013-12-29','11:45:00',1.7),('8902','2013-12-29','11:50:00',1.66),('8902','2013-12-29','11:55:00',1.46),('8902','2013-12-29','12:00:00',1.29),('8902','2013-12-29','12:05:00',1.29),('8902','2013-12-29','12:10:00',1.35),('8902','2013-12-29','12:15:00',1.36),('8902','2013-12-29','12:20:00',1.31),('8902','2013-12-29','12:25:00',1.37),('8902','2013-12-29','12:30:00',1.37),('8902','2013-12-29','12:35:00',1.35),('8902','2013-12-29','12:40:00',1.39),('8902','2013-12-29','12:45:00',1.49),('8902','2013-12-29','12:50:00',1.49),('8902','2013-12-29','12:55:00',1.35),('8902','2013-12-29','13:00:00',1.21),('8902','2013-12-29','13:05:00',1.25),('8902','2013-12-29','13:10:00',1.36),('8902','2013-12-29','13:15:00',1.27),('8902','2013-12-29','13:20:00',1.22),('8902','2013-12-29','13:25:00',1.27),('8902','2013-12-29','13:30:00',1.29),('8902','2013-12-29','13:35:00',1.26),('8902','2013-12-29','13:40:00',1.19),('8902','2013-12-29','13:45:00',1.14),('8902','2013-12-29','13:50:00',1.03),('8902','2013-12-28','08:20:00',1.07),('8902','2013-12-28','08:25:00',1.07),('8902','2013-12-28','08:30:00',1.15),('8902','2013-12-28','08:35:00',1.67),('8902','2013-12-28','08:40:00',1.73),('8902','2013-12-28','08:45:00',1.63),('8902','2013-12-28','08:50:00',1.65),('8902','2013-12-28','09:05:00',1.81),('8902','2013-12-28','09:10:00',2.43),('8902','2013-12-28','09:15:00',2.64),('8902','2013-12-28','09:20:00',3.02),('8902','2013-12-28','09:25:00',3.08),('8902','2013-12-28','09:30:00',3.25),('8902','2013-12-28','09:35:00',3.36),('8902','2013-12-28','09:40:00',3.55),('8902','2013-12-28','09:45:00',3.65),('8902','2013-12-28','09:50:00',3.53),('8902','2013-12-28','09:55:00',3.08),('8902','2013-12-28','10:00:00',3.13),('8902','2013-12-28','10:05:00',3.46),('8902','2013-12-28','10:10:00',3.43),('8902','2013-12-28','10:15:00',4.27),('8902','2013-12-28','10:20:00',4.63),('8902','2013-12-28','10:25:00',3.9),('8902','2013-12-28','10:30:00',4.77),('8902','2013-12-28','10:35:00',3.53),('8902','2013-12-28','10:40:00',5.46),('8902','2013-12-28','10:45:00',2.3),('8902','2013-12-28','10:50:00',1.82),('8902','2013-12-28','10:55:00',2.5),('8902','2013-12-28','11:00:00',2.04),('8902','2013-12-28','11:05:00',1.93),('8902','2013-12-28','11:10:00',2.03),('8902','2013-12-28','11:15:00',1.42),('8902','2013-12-28','11:20:00',1.17),('8902','2013-12-28','11:35:00',1.18),('8902','2013-12-28','11:40:00',1.2),('8902','2013-12-28','11:55:00',1.27),('8902','2013-12-28','12:00:00',1.37),('8902','2013-12-28','12:05:00',1.33),('8902','2013-12-28','12:10:00',1.26),('8902','2013-12-28','12:15:00',1.13),('8902','2013-12-28','13:40:00',1.28),('8902','2013-12-27','08:30:00',1.02),('8902','2013-12-27','08:35:00',1.3),('8902','2013-12-27','08:40:00',1.55),('8902','2013-12-27','08:45:00',1.72),('8902','2013-12-27','08:50:00',1.91),('8902','2013-12-27','08:55:00',2.1),('8902','2013-12-27','09:00:00',2.25),('8902','2013-12-27','09:05:00',2.39),('8902','2013-12-27','09:10:00',2.52),('8902','2013-12-27','09:15:00',2.71),('8902','2013-12-27','09:20:00',2.9),('8902','2013-12-27','09:25:00',3.05),('8902','2013-12-27','09:30:00',3.21),('8902','2013-12-27','09:35:00',3.36),('8902','2013-12-27','09:40:00',3.47),('8902','2013-12-27','09:45:00',3.61),('8902','2013-12-27','09:50:00',3.76),('8902','2013-12-27','09:55:00',3.89),('8902','2013-12-27','10:00:00',4.01),('8902','2013-12-27','10:05:00',4.12),('8902','2013-12-27','10:10:00',4.24),('8902','2013-12-27','10:15:00',4.33),('8902','2013-12-27','10:20:00',4.41),('8902','2013-12-27','10:25:00',4.5),('8902','2013-12-27','10:30:00',4.61),('8902','2013-12-27','10:35:00',4.72),('8902','2013-12-27','10:40:00',4.79),('8902','2013-12-27','10:45:00',4.86),('8902','2013-12-27','10:50:00',4.91),('8902','2013-12-27','10:55:00',4.98),('8902','2013-12-27','11:00:00',5.06),('8902','2013-12-27','11:05:00',5.12),('8902','2013-12-27','11:10:00',5.16),('8902','2013-12-27','11:15:00',5.23),('8902','2013-12-27','11:20:00',5.28),('8902','2013-12-27','11:25:00',5.33),('8902','2013-12-27','11:30:00',5.36),('8902','2013-12-27','11:35:00',5.41),('8902','2013-12-27','11:40:00',5.46),('8902','2013-12-27','11:45:00',5.49),('8902','2013-12-27','11:50:00',5.51),('8902','2013-12-27','11:55:00',5.51),('8902','2013-12-27','12:00:00',5.53),('8902','2013-12-27','12:05:00',5.5),('8902','2013-12-27','12:10:00',5.47),('8902','2013-12-27','12:15:00',5.5),('8902','2013-12-27','12:20:00',5.48),('8902','2013-12-27','12:25:00',5.42),('8902','2013-12-27','12:30:00',5.39),('8902','2013-12-27','12:35:00',5.4),('8902','2013-12-27','12:40:00',5.42),('8902','2013-12-27','12:45:00',5.35),('8902','2013-12-27','12:50:00',5.31),('8902','2013-12-27','12:55:00',5.28),('8902','2013-12-27','13:00:00',5.25),('8902','2013-12-27','13:05:00',5.17),('8902','2013-12-27','13:10:00',5.09),('8902','2013-12-27','13:15:00',5.06),('8902','2013-12-27','13:20:00',5.01),('8902','2013-12-27','13:25:00',4.88),('8902','2013-12-27','13:30:00',4.72),('8902','2013-12-27','13:35:00',4.68),('8902','2013-12-27','13:40:00',4.66),('8902','2013-12-27','13:45:00',4.46),('8902','2013-12-27','13:50:00',4.41),('8902','2013-12-27','13:55:00',4.44),('8902','2013-12-27','14:00:00',4.31),('8902','2013-12-27','14:05:00',4.16),('8902','2013-12-27','14:10:00',4.05),('8902','2013-12-27','14:15:00',3.97),('8902','2013-12-27','14:20:00',3.77),('8902','2013-12-27','14:25:00',3.64),('8902','2013-12-27','14:30:00',3.61),('8902','2013-12-27','14:35:00',3.46),('8902','2013-12-27','14:40:00',3.3),('8902','2013-12-27','14:45:00',2.96),('8902','2013-12-27','14:50:00',2.66),('8902','2013-12-27','14:55:00',1.37),('8902','2013-12-27','15:00:00',2.08),('8902','2013-12-27','15:05:00',2.92),('8902','2013-12-27','15:10:00',2.66),('8902','2013-12-27','15:15:00',2.49),('8902','2013-12-27','15:20:00',2.33),('8902','2013-12-27','15:25:00',2.19),('8902','2013-12-27','15:30:00',1.92),('8902','2013-12-27','15:35:00',1.89),('8902','2013-12-27','15:40:00',1.71),('8902','2013-12-27','15:45:00',1.57),('8902','2013-12-27','15:50:00',1.46),('8902','2013-12-27','15:55:00',1.23),('8902','2014-04-22','11:15:00',1.03),('8902','2014-04-22','11:20:00',1.01),('8902','2014-04-22','11:30:00',1.01),('8902','2014-04-22','11:35:00',1.14),('8902','2014-04-22','11:40:00',1.24),('8902','2014-04-22','11:45:00',1.31),('8902','2014-04-22','11:50:00',1.04),('8902','2014-04-22','12:25:00',1.03),('8902','2014-04-22','12:30:00',1.04),('8902','2014-04-22','12:35:00',1.07),('8902','2014-04-22','12:40:00',1.01),('8902','2014-04-22','12:45:00',1.05),('8902','2014-04-22','12:50:00',1.12),('8902','2014-04-22','12:55:00',1.23),('8902','2014-04-22','13:00:00',1.42),('8902','2014-04-22','13:05:00',1.73),('8902','2014-04-22','13:10:00',2.14),('8902','2014-04-22','13:15:00',2.33),('8902','2014-04-22','13:20:00',2.46),('8902','2014-04-22','13:25:00',2.54),('8902','2014-04-22','13:30:00',2.73),('8902','2014-04-22','13:35:00',2.85),('8902','2014-04-22','13:40:00',3.01),('8902','2014-04-22','13:45:00',3.04),('8902','2014-04-22','13:50:00',2.98),('8902','2014-04-22','13:55:00',2.9),('8902','2014-04-22','14:00:00',2.74),('8902','2014-04-22','14:05:00',2.83),('8902','2014-04-22','14:10:00',2.58),('8902','2014-04-22','14:15:00',2.15),('8902','2014-04-22','14:20:00',1.93),('8902','2014-04-22','14:25:00',1.78),('8902','2014-04-22','14:30:00',1.71),('8902','2014-04-22','14:35:00',1.71),('8902','2014-04-22','14:40:00',1.92),('8902','2014-04-22','14:45:00',2.35),('8902','2014-04-22','14:50:00',2.84),('8902','2014-04-22','14:55:00',3.23),('8902','2014-04-22','15:00:00',3.42),('8902','2014-04-22','15:05:00',3.46),('8902','2014-04-22','15:10:00',3.53),('8902','2014-04-22','15:15:00',3.47),('8902','2014-04-22','15:20:00',2.85),('8902','2014-04-22','15:25:00',2.71),('8902','2014-04-22','15:30:00',2.66),('8902','2014-04-22','15:35:00',2.5),('8902','2014-04-22','15:40:00',2.43),('8902','2014-04-22','15:45:00',2.27),('8902','2014-04-22','15:50:00',1.97),('8902','2014-04-22','15:55:00',1.9),('8902','2014-04-22','16:00:00',1.67),('8902','2014-04-22','16:05:00',1.6),('8902','2014-04-22','16:10:00',1.39),('8902','2014-04-22','16:15:00',1.23),('8902','2014-04-22','16:20:00',1.05),('8902','2013-12-26','09:30:00',1.04),('8902','2013-12-26','10:20:00',1.09),('8902','2013-12-26','10:25:00',1.29),('8902','2013-12-26','10:30:00',1.42),('8902','2013-12-26','10:35:00',1.44),('8902','2013-12-26','10:40:00',1.44),('8902','2013-12-26','10:45:00',1.4),('8902','2013-12-26','10:50:00',1.29),('8902','2013-12-26','10:55:00',1.14),('8902','2013-12-26','11:25:00',1.19),('8902','2013-12-26','11:30:00',1.53),('8902','2013-12-26','11:35:00',1.86),('8902','2013-12-26','11:40:00',1.74),('8902','2013-12-26','11:45:00',1.57),('8902','2013-12-26','11:50:00',1.45),('8902','2013-12-26','11:55:00',1.29),('8902','2013-12-26','12:00:00',1.27),('8902','2013-12-26','12:05:00',1.79),('8902','2013-12-26','12:10:00',2.68),('8902','2013-12-26','12:15:00',4.4),('8902','2013-12-26','12:20:00',3.34),('8902','2013-12-26','12:25:00',3.37),('8902','2013-12-26','12:30:00',2.21),('8902','2013-12-26','12:35:00',2.34),('8902','2013-12-26','12:40:00',3.23),('8902','2013-12-26','12:45:00',4.26),('8902','2013-12-26','12:50:00',4.93),('8902','2013-12-26','12:55:00',5.19),('8902','2013-12-26','13:00:00',5.22),('8902','2013-12-26','13:05:00',4.72),('8902','2013-12-26','13:10:00',2.21),('8902','2013-12-26','13:15:00',2.85),('8902','2013-12-26','13:20:00',2.56),('8902','2013-12-26','13:25:00',2.59),('8902','2013-12-26','13:30:00',4.49),('8902','2013-12-26','13:35:00',5.35),('8902','2013-12-26','13:40:00',2.96),('8902','2013-12-26','13:45:00',2.7),('8902','2013-12-26','13:50:00',2.12),('8902','2013-12-26','13:55:00',1.77),('8902','2013-12-26','14:00:00',1.62),('8902','2013-12-26','14:05:00',1.62),('8902','2013-12-26','14:10:00',1.85),('8902','2013-12-26','14:15:00',2.06),('8902','2013-12-26','14:20:00',2.2),('8902','2013-12-26','14:25:00',2.04),('8902','2013-12-26','14:30:00',2.31),('8902','2013-12-26','14:35:00',2.51),('8902','2013-12-26','14:40:00',2.63),('8902','2013-12-26','14:45:00',2.23),('8902','2013-12-26','14:50:00',1.69),('8902','2013-12-26','14:55:00',1.06),('8902','2013-12-26','15:30:00',1.01),('8902','2013-12-26','15:35:00',1.04),('8902','2013-12-25','09:55:00',1.14),('8902','2013-12-25','11:05:00',1.19),('8902','2013-12-24','09:10:00',1.13),('8902','2013-12-24','09:15:00',1.18),('8902','2013-12-24','09:20:00',1.14),('8902','2013-12-24','09:25:00',1.32),('8902','2013-12-24','09:30:00',1.32),('8902','2013-12-24','09:35:00',1.24),('8902','2013-12-24','09:40:00',1.13),('8902','2013-12-24','10:25:00',1.54),('8902','2013-12-24','10:30:00',3.02),('8902','2013-12-24','10:35:00',3.21),('8902','2013-12-24','10:40:00',3.08),('8902','2013-12-24','10:45:00',2.52),('8902','2013-12-24','10:50:00',3.16),('8902','2013-12-24','10:55:00',1.74),('8902','2013-12-24','11:00:00',1.58),('8902','2013-12-24','11:05:00',1.58),('8902','2013-12-24','11:10:00',1.78),('8902','2013-12-24','11:15:00',2.03),('8902','2013-12-24','11:20:00',3.15),('8902','2013-12-24','11:25:00',2.7),('8902','2013-12-24','11:30:00',4.49),('8902','2013-12-24','11:35:00',3.18),('8902','2013-12-24','11:40:00',3.59),('8902','2013-12-24','11:45:00',4.71),('8902','2013-12-24','11:50:00',2.76),('8902','2013-12-24','11:55:00',4.95),('8902','2013-12-24','12:00:00',4.24),('8902','2013-12-24','12:05:00',1.84),('8902','2013-12-24','12:10:00',2.16),('8902','2013-12-24','12:15:00',3.69),('8902','2013-12-24','12:20:00',4.8),('8902','2013-12-24','12:25:00',2.28),('8902','2013-12-24','12:30:00',5.1),('8902','2013-12-24','12:35:00',3.98),('8902','2013-12-24','12:40:00',2.47),('8902','2013-12-24','12:45:00',1.48),('8902','2013-12-24','12:50:00',2.78),('8902','2013-12-24','12:55:00',1.34),('8902','2013-12-24','13:05:00',1.23),('8902','2013-12-24','13:10:00',1.49),('8902','2013-12-24','13:15:00',1.19),('8902','2013-12-24','13:25:00',2.38),('8902','2013-12-24','13:30:00',2.69),('8902','2013-12-24','13:35:00',1.85),('8902','2013-12-24','13:40:00',2.14),('8902','2013-12-24','13:45:00',2.29),('8902','2013-12-24','13:50:00',2.59),('8902','2013-12-24','13:55:00',2.54),('8902','2013-12-24','14:00:00',2.06),('8902','2013-12-24','14:05:00',1.62),('8902','2013-12-24','14:10:00',1.46),('8902','2013-12-24','14:15:00',1.41),('8902','2013-12-24','14:20:00',1.29),('8902','2013-12-24','14:25:00',1.19),('8902','2013-12-24','14:30:00',1.17),('8902','2013-12-24','14:35:00',1.22),('8902','2013-12-24','14:40:00',1.2),('8902','2013-12-24','14:45:00',1.19),('8902','2013-12-24','14:50:00',1.2),('8902','2013-12-24','14:55:00',1.12),('8902','2013-12-24','15:10:00',1.15),('8902','2013-12-24','15:15:00',1.76),('8902','2013-12-24','15:20:00',1.81),('8902','2013-12-24','15:25:00',1.37),('8902','2013-12-23','08:45:00',1.02),('8902','2013-12-23','08:50:00',1.34),('8902','2013-12-23','08:55:00',1.68),('8902','2013-12-23','09:00:00',1.97),('8902','2013-12-23','09:05:00',2.17),('8902','2013-12-23','09:10:00',2.29),('8902','2013-12-23','09:15:00',2.48),('8902','2013-12-23','09:20:00',2.61),('8902','2013-12-23','09:25:00',2.74),('8902','2013-12-23','09:30:00',2.84),('8902','2013-12-23','09:35:00',3),('8902','2013-12-23','09:40:00',3.14),('8902','2013-12-23','09:45:00',3.21),('8902','2013-12-23','09:50:00',3.17),('8902','2013-12-23','09:55:00',3.17),('8902','2013-12-23','10:00:00',3.44),('8902','2013-12-23','10:05:00',3.58),('8902','2013-12-23','10:10:00',3.64),('8902','2013-12-23','10:15:00',3.92),('8902','2013-12-23','10:20:00',3.99),('8902','2013-12-23','10:25:00',4.12),('8902','2013-12-23','10:30:00',4.15),('8902','2013-12-23','10:35:00',4.23),('8902','2013-12-23','10:40:00',4.35),('8902','2013-12-23','10:45:00',4.43),('8902','2013-12-23','10:50:00',4.45),('8902','2013-12-23','10:55:00',4.51),('8902','2013-12-23','11:00:00',4.62),('8902','2013-12-23','11:05:00',4.61),('8902','2013-12-23','11:10:00',4.65),('8902','2013-12-23','11:15:00',4.71),('8902','2013-12-23','11:20:00',4.8),('8902','2013-12-23','11:25:00',4.87),('8902','2013-12-23','11:30:00',4.91),('8902','2013-12-23','11:35:00',4.95),('8902','2013-12-23','11:40:00',4.94),('8902','2013-12-23','11:45:00',4.92),('8902','2013-12-23','11:50:00',4.96),('8902','2013-12-23','11:55:00',4.92),('8902','2013-12-23','12:00:00',4.9),('8902','2013-12-23','12:05:00',4.84),('8902','2013-12-23','12:10:00',4.88),('8902','2013-12-23','12:15:00',4.92),('8902','2013-12-23','12:20:00',4.84),('8902','2013-12-23','12:25:00',4.79),('8902','2013-12-23','12:30:00',4.79),('8902','2013-12-23','12:35:00',4.78),('8902','2013-12-23','12:40:00',4.66),('8902','2013-12-23','12:45:00',4.67),('8902','2013-12-23','12:50:00',4.66),('8902','2013-12-23','12:55:00',4.62),('8902','2013-12-23','13:00:00',4.53),('8902','2013-12-23','13:05:00',4.48),('8902','2013-12-23','13:10:00',4.41),('8902','2013-12-23','13:15:00',4.38),('8902','2013-12-23','13:20:00',4.36),('8902','2013-12-23','13:25:00',4.28),('8902','2013-12-23','13:30:00',4.09),('8902','2013-12-23','13:35:00',4.06),('8902','2013-12-23','13:40:00',3.83),('8902','2013-12-23','13:45:00',3.79),('8902','2013-12-23','13:50:00',3.75),('8902','2013-12-23','13:55:00',3.69),('8902','2013-12-23','14:00:00',3.56),('8902','2013-12-23','14:05:00',3.49),('8902','2013-12-23','14:10:00',3.43),('8902','2013-12-23','14:15:00',3.35),('8902','2013-12-23','14:20:00',3.28),('8902','2013-12-23','14:25:00',3.08),('8902','2013-12-23','14:30:00',2.89),('8902','2013-12-23','14:35:00',2.68),('8902','2013-12-23','14:40:00',2.5),('8902','2013-12-23','14:45:00',2.34),('8902','2013-12-23','14:50:00',2.23),('8902','2013-12-23','14:55:00',2.04),('8902','2013-12-23','15:00:00',1.78),('8902','2013-12-23','15:05:00',1.46),('8902','2013-12-23','15:10:00',1.09),('8902','2013-12-23','15:20:00',1.11),('8902','2013-12-23','15:25:00',1.04),('8902','2013-12-23','15:30:00',1.05),('8902','2013-12-23','15:35:00',1.03),('8902','2013-12-22','09:00:00',1.07),('8902','2013-12-22','09:05:00',1.14),('8902','2013-12-22','09:10:00',1.15),('8902','2013-12-22','09:15:00',1.19),('8902','2013-12-22','09:20:00',1.32),('8902','2013-12-22','09:25:00',1.55),('8902','2013-12-22','09:30:00',1.8),('8902','2013-12-22','09:35:00',1.93),('8902','2013-12-22','09:40:00',2.06),('8902','2013-12-22','09:45:00',2.07),('8902','2013-12-22','09:50:00',2.35),('8902','2013-12-22','09:55:00',3.15),('8902','2013-12-22','10:00:00',3.59),('8902','2013-12-22','10:05:00',3.84),('8902','2013-12-22','10:10:00',3.83),('8902','2013-12-22','10:15:00',3.7),('8902','2013-12-22','10:20:00',4.15),('8902','2013-12-22','10:25:00',4.1),('8902','2013-12-22','10:30:00',3.83),('8902','2013-12-22','10:35:00',3.89),('8902','2013-12-22','10:40:00',4.12),('8902','2013-12-22','10:45:00',4.31),('8902','2013-12-22','10:50:00',3.83),('8902','2013-12-22','10:55:00',4.4),('8902','2013-12-22','11:00:00',5.05),('8902','2013-12-22','11:05:00',5.21),('8902','2013-12-22','11:10:00',5.19),('8902','2013-12-22','11:15:00',5.15),('8902','2013-12-22','11:20:00',4.98),('8902','2013-12-22','11:25:00',5.12),('8902','2013-12-22','11:30:00',5.03),('8902','2013-12-22','11:35:00',5.19),('8902','2013-12-22','11:40:00',5.26),('8902','2013-12-22','11:45:00',4.71),('8902','2013-12-22','11:50:00',4.73),('8902','2013-12-22','11:55:00',4.75),('8902','2013-12-22','12:00:00',5.13),('8902','2013-12-22','12:05:00',5.12),('8902','2013-12-22','12:10:00',5.17),('8902','2013-12-22','12:15:00',5.02),('8902','2013-12-22','12:20:00',5.07),('8902','2013-12-22','12:25:00',5.15),('8902','2013-12-22','12:30:00',5.24),('8902','2013-12-22','12:35:00',5.3),('8902','2013-12-22','12:40:00',5.28),('8902','2013-12-22','12:45:00',5.22),('8902','2013-12-22','12:50:00',5.21),('8902','2013-12-22','12:55:00',5.24),('8902','2013-12-22','13:00:00',5.17),('8902','2013-12-22','13:05:00',5.11),('8902','2013-12-22','13:10:00',5.05),('8902','2013-12-22','13:15:00',4.54),('8902','2013-12-22','13:20:00',4.15),('8902','2013-12-22','13:25:00',4.1),('8902','2013-12-22','13:30:00',4.71),('8902','2013-12-22','13:35:00',2.15),('8902','2013-12-22','13:40:00',3.38),('8902','2013-12-22','13:45:00',3.48),('8902','2013-12-22','13:50:00',3.65),('8902','2013-12-22','13:55:00',3.86),('8902','2013-12-22','14:00:00',4.3),('8902','2013-12-22','14:05:00',4.17),('8902','2013-12-22','14:10:00',4.12),('8902','2013-12-22','14:15:00',3.92),('8902','2013-12-22','14:20:00',3.72),('8902','2013-12-22','14:25:00',3.63),('8902','2013-12-22','14:30:00',3.3),('8902','2013-12-22','14:35:00',3.3),('8902','2013-12-22','14:40:00',3.19),('8902','2013-12-22','14:45:00',3.1),('8902','2013-12-22','14:50:00',2.96),('8902','2013-12-22','14:55:00',2.8),('8902','2013-12-22','15:00:00',2.71),('8902','2013-12-22','15:05:00',2.57),('8902','2013-12-22','15:10:00',2.41),('8902','2013-12-22','15:15:00',2.23),('8902','2013-12-22','15:20:00',2.02),('8902','2013-12-22','15:25:00',1.84),('8902','2013-12-22','15:30:00',1.69),('8902','2013-12-22','15:35:00',1.55),('8902','2013-12-22','15:40:00',1.39),('8902','2013-12-22','15:45:00',1.22),('8902','2013-12-22','15:50:00',1.06),('8902','2013-12-21','08:40:00',1.15),('8902','2013-12-21','08:45:00',1.26),('8902','2013-12-21','08:50:00',1.29),('8902','2013-12-21','08:55:00',1.31),('8902','2013-12-21','09:00:00',1.65),('8902','2013-12-21','09:05:00',2.14),('8902','2013-12-21','09:10:00',2.11),('8902','2013-12-21','09:15:00',2.18),('8902','2013-12-21','09:20:00',2.48),('8902','2013-12-21','09:25:00',2.41),('8902','2013-12-21','09:30:00',2.48),('8902','2013-12-21','09:35:00',3.26),('8902','2013-12-21','09:40:00',4.06),('8902','2013-12-21','09:45:00',4.21),('8902','2013-12-21','09:50:00',4.5),('8902','2013-12-21','09:55:00',4.54),('8902','2013-12-21','10:00:00',4.54),('8902','2013-12-21','10:05:00',4.61),('8902','2013-12-21','10:10:00',4.69),('8902','2013-12-21','10:15:00',4.6),('8902','2013-12-21','10:20:00',4.48),('8902','2013-12-21','10:25:00',4.49),('8902','2013-12-21','10:30:00',4.73),('8902','2013-12-21','10:35:00',4.44),('8902','2013-12-21','10:40:00',4.16),('8902','2013-12-21','10:45:00',4.41),('8902','2013-12-21','10:50:00',4.37),('8902','2013-12-21','10:55:00',4.16),('8902','2013-12-21','11:00:00',3.67),('8902','2013-12-21','11:05:00',3.88),('8902','2013-12-21','11:10:00',5.07),('8902','2013-12-21','11:15:00',4.99),('8902','2013-12-21','11:20:00',4.5),('8902','2013-12-21','11:25:00',4.66),('8902','2013-12-21','11:30:00',4.43),('8902','2013-12-21','11:35:00',4.34),('8902','2013-12-21','11:40:00',4.68),('8902','2013-12-21','11:45:00',4.4),('8902','2013-12-21','11:50:00',3.23),('8902','2013-12-21','11:55:00',2.39),('8902','2013-12-21','12:00:00',1.89),('8902','2013-12-21','12:05:00',1.7),('8902','2013-12-21','12:10:00',1.74),('8902','2013-12-21','12:15:00',1.91),('8902','2013-12-21','12:20:00',2.38),('8902','2013-12-21','12:25:00',2.49),('8902','2013-12-21','12:30:00',3.07),('8902','2013-12-21','12:35:00',3.58),('8902','2013-12-21','12:40:00',3.33),('8902','2013-12-21','12:45:00',3.27),('8902','2013-12-21','12:50:00',3.97),('8902','2013-12-21','12:55:00',5.01),('8902','2013-12-21','13:00:00',4.98),('8902','2013-12-21','13:05:00',5.78),('8902','2013-12-21','13:10:00',5.75),('8902','2013-12-21','13:15:00',4.3),('8902','2013-12-21','13:20:00',4.22),('8902','2013-12-21','13:25:00',4.23),('8902','2013-12-21','13:30:00',4.08),('8902','2013-12-21','13:35:00',3.78),('8902','2013-12-21','13:40:00',2.96),('8902','2013-12-21','13:45:00',3.65),('8902','2013-12-21','13:50:00',3.31),('8902','2013-12-21','13:55:00',3.06),('8902','2013-12-21','14:00:00',2.6),('8902','2013-12-21','14:05:00',3.02),('8902','2013-12-21','14:10:00',3.42),('8902','2013-12-21','14:15:00',2.49),('8902','2013-12-21','14:20:00',2.57),('8902','2013-12-21','14:25:00',2.25),('8902','2013-12-21','14:30:00',2.19),('8902','2013-12-21','14:35:00',2.61),('8902','2013-12-21','14:40:00',2.86),('8902','2013-12-21','14:45:00',2.73),('8902','2013-12-21','14:50:00',1.62),('8902','2013-12-21','14:55:00',1.56),('8902','2013-12-21','15:00:00',1.77),('8902','2013-12-21','15:05:00',1.61),('8902','2013-12-21','15:10:00',1.9),('8902','2013-12-21','15:15:00',1.15),('8902','2013-12-21','15:20:00',1.1),('8902','2013-12-20','08:30:00',1.16),('8902','2013-12-20','08:35:00',1.34),('8902','2013-12-20','08:40:00',1.5),('8902','2013-12-20','08:45:00',1.65),('8902','2013-12-20','08:50:00',1.84),('8902','2013-12-20','08:55:00',2.02),('8902','2013-12-20','09:00:00',2.16),('8902','2013-12-20','09:05:00',2.28),('8902','2013-12-20','09:10:00',2.39),('8902','2013-12-20','09:15:00',2.54),('8902','2013-12-20','09:20:00',2.69),('8902','2013-12-20','09:25:00',2.82),('8902','2013-12-20','09:30:00',2.95),('8902','2013-12-20','09:35:00',3.11),('8902','2013-12-20','09:40:00',3.27),('8902','2013-12-20','09:45:00',3.39),('8902','2013-12-20','09:50:00',3.54),('8902','2013-12-20','09:55:00',3.67),('8902','2013-12-20','10:00:00',3.78),('8902','2013-12-20','10:05:00',3.9),('8902','2013-12-20','10:10:00',4),('8902','2013-12-20','10:15:00',4.11),('8902','2013-12-20','10:20:00',4.2),('8902','2013-12-20','10:25:00',4.29),('8902','2013-12-20','10:30:00',4.39),('8902','2013-12-20','10:35:00',4.49),('8902','2013-12-20','10:40:00',4.57),('8902','2013-12-20','10:45:00',4.64),('8902','2013-12-20','10:50:00',4.7),('8902','2013-12-20','10:55:00',4.78),('8902','2013-12-20','11:00:00',4.87),('8902','2013-12-20','11:05:00',4.95),('8902','2013-12-20','11:10:00',5),('8902','2013-12-20','11:15:00',5.08),('8902','2013-12-20','11:20:00',5.12),('8902','2013-12-20','11:25:00',5.19),('8902','2013-12-20','11:30:00',5.26),('8902','2013-12-20','11:35:00',5.29),('8902','2013-12-20','11:40:00',5.32),('8902','2013-12-20','11:45:00',5.35),('8902','2013-12-20','11:50:00',5.38),('8902','2013-12-20','11:55:00',5.42),('8902','2013-12-20','12:00:00',5.44),('8902','2013-12-20','12:05:00',5.44),('8902','2013-12-20','12:10:00',5.45),('8902','2013-12-20','12:15:00',5.44),('8902','2013-12-20','12:20:00',5.44),('8902','2013-12-20','12:25:00',5.43),('8902','2013-12-20','12:30:00',5.44),('8902','2013-12-20','12:35:00',5.42),('8902','2013-12-20','12:40:00',5.39),('8902','2013-12-20','12:45:00',5.33),('8902','2013-12-20','12:50:00',5.34),('8902','2013-12-20','12:55:00',5.31),('8902','2013-12-20','13:00:00',5.23),('8902','2013-12-20','13:05:00',5.21),('8902','2013-12-20','13:10:00',5.15),('8902','2013-12-20','13:15:00',5.08),('8902','2013-12-20','13:20:00',4.98),('8902','2013-12-20','13:25:00',4.96),('8902','2013-12-20','13:30:00',4.87),('8902','2013-12-20','13:35:00',4.8),('8902','2013-12-20','13:40:00',4.71),('8902','2013-12-20','13:45:00',4.66),('8902','2013-12-20','13:50:00',4.58),('8902','2013-12-20','13:55:00',4.51),('8902','2013-12-20','14:00:00',4.39),('8902','2013-12-20','14:05:00',4.26),('8902','2013-12-20','14:10:00',4.15),('8902','2013-12-20','14:15:00',4.11),('8902','2013-12-20','14:20:00',4.07),('8902','2013-12-20','14:25:00',3.93),('8902','2013-12-20','14:30:00',3.82),('8902','2013-12-20','14:35:00',3.69),('8902','2013-12-20','14:40:00',3.55),('8902','2013-12-20','14:45:00',3.39),('8902','2013-12-20','14:50:00',3.22),('8902','2013-12-20','14:55:00',3.08),('8902','2013-12-20','15:00:00',2.92),('8902','2013-12-20','15:05:00',2.74),('8902','2013-12-20','15:10:00',2.6),('8902','2013-12-20','15:15:00',2.46),('8902','2013-12-20','15:20:00',2.31),('8902','2013-12-20','15:25:00',2.14),('8902','2013-12-20','15:30:00',1.96),('8902','2013-12-20','15:35:00',1.77),('8902','2013-12-20','15:40:00',1.58),('8902','2013-12-20','15:45:00',1.41),('8902','2013-12-20','15:50:00',1.24),('8902','2013-12-20','15:55:00',1.06),('8902','2013-12-19','08:20:00',1.04),('8902','2013-12-19','08:25:00',1.11),('8902','2013-12-19','08:30:00',1.19),('8902','2013-12-19','08:35:00',1.29),('8902','2013-12-19','08:40:00',1.48),('8902','2013-12-19','08:45:00',1.63),('8902','2013-12-19','08:50:00',1.74),('8902','2013-12-19','08:55:00',1.84),('8902','2013-12-19','09:00:00',1.95),('8902','2013-12-19','09:05:00',2.15),('8902','2013-12-19','09:10:00',2.33),('8902','2013-12-19','09:15:00',2.48),('8902','2013-12-19','09:20:00',2.63),('8902','2013-12-19','09:25:00',2.79),('8902','2013-12-19','09:30:00',2.93),('8902','2013-12-19','09:35:00',3.06),('8902','2013-12-19','09:40:00',3.19),('8902','2013-12-19','09:45:00',3.31),('8902','2013-12-19','09:50:00',3.44),('8902','2013-12-19','09:55:00',3.52),('8902','2013-12-19','10:00:00',3.62),('8902','2013-12-19','10:05:00',3.78),('8902','2013-12-19','10:10:00',3.86),('8902','2013-12-19','10:15:00',3.92),('8902','2013-12-19','10:20:00',4.02),('8902','2013-12-19','10:25:00',4.14),('8902','2013-12-19','10:30:00',4.19),('8902','2013-12-19','10:35:00',4.26),('8902','2013-12-19','10:40:00',4.39),('8902','2013-12-19','10:45:00',4.48),('8902','2013-12-19','10:50:00',4.52),('8902','2013-12-19','10:55:00',4.61),('8902','2013-12-19','11:00:00',4.67),('8902','2013-12-19','11:05:00',4.73),('8902','2013-12-19','11:10:00',4.76),('8902','2013-12-19','11:15:00',4.82),('8902','2013-12-19','11:20:00',4.88),('8902','2013-12-19','11:25:00',4.94),('8902','2013-12-19','11:30:00',5.01),('8902','2013-12-19','11:35:00',5.01),('8902','2013-12-19','11:40:00',5.06),('8902','2013-12-19','11:45:00',5.09),('8902','2013-12-19','11:50:00',5.06),('8902','2013-12-19','11:55:00',5.14),('8902','2013-12-19','12:00:00',5.14),('8902','2013-12-19','12:05:00',5.09),('8902','2013-12-19','12:10:00',5.15),('8902','2013-12-19','12:15:00',5.13),('8902','2013-12-19','12:20:00',5.11),('8902','2013-12-19','12:25:00',5.07),('8902','2013-12-19','12:30:00',5.13),('8902','2013-12-19','12:35:00',5.07),('8902','2013-12-19','12:40:00',5),('8902','2013-12-19','12:45:00',4.99),('8902','2013-12-19','12:50:00',4.9),('8902','2013-12-19','12:55:00',4.85),('8902','2013-12-19','13:00:00',4.86),('8902','2013-12-19','13:05:00',4.85),('8902','2013-12-19','13:10:00',4.8),('8902','2013-12-19','13:15:00',4.71),('8902','2013-12-19','13:20:00',4.5),('8902','2013-12-19','13:25:00',4.46),('8902','2013-12-19','13:30:00',4.34),('8902','2013-12-19','13:35:00',4.37),('8902','2013-12-19','13:40:00',4.14),('8902','2013-12-19','13:45:00',4.08),('8902','2013-12-19','13:50:00',4.07),('8902','2013-12-19','13:55:00',3.82),('8902','2013-12-19','14:00:00',3.71),('8902','2013-12-19','14:05:00',1.7),('8902','2013-12-19','14:10:00',1.05),('8902','2013-12-19','14:30:00',1.07),('8902','2013-12-19','14:35:00',1.15),('8902','2013-12-19','14:40:00',1.3),('8902','2013-12-19','14:45:00',1.11),('8902','2013-12-19','14:50:00',1.15),('8902','2013-12-18','08:45:00',1.05),('8902','2013-12-18','08:50:00',1.79),('8902','2013-12-18','08:55:00',2.03),('8902','2013-12-18','09:00:00',2.35),('8902','2013-12-18','09:05:00',2.65),('8902','2013-12-18','09:10:00',2.61),('8902','2013-12-18','09:15:00',2.14),('8902','2013-12-18','09:20:00',2.98),('8902','2013-12-18','09:25:00',3.3),('8902','2013-12-18','09:30:00',3),('8902','2013-12-18','09:35:00',3.48),('8902','2013-12-18','09:40:00',2.51),('8902','2013-12-18','09:45:00',1.91),('8902','2013-12-18','09:50:00',3.14),('8902','2013-12-18','09:55:00',4.32),('8902','2013-12-18','10:00:00',4.04),('8902','2013-12-18','10:05:00',3.82),('8902','2013-12-18','10:10:00',4.01),('8902','2013-12-18','10:15:00',4.07),('8902','2013-12-18','10:20:00',2.71),('8902','2013-12-18','10:25:00',1.54),('8902','2013-12-18','10:30:00',2.1),('8902','2013-12-18','10:35:00',1.81),('8902','2013-12-18','10:40:00',2.24),('8902','2013-12-18','10:45:00',2.95),('8902','2013-12-18','10:50:00',5),('8902','2013-12-18','10:55:00',3.6),('8902','2013-12-18','11:00:00',1.33),('8902','2013-12-18','11:05:00',1.24),('8902','2013-12-18','11:10:00',1.38),('8902','2013-12-18','11:15:00',3.2),('8902','2013-12-18','11:20:00',2.44),('8902','2013-12-18','11:25:00',1.89),('8902','2013-12-18','11:30:00',1.34),('8902','2013-12-18','11:35:00',1.14),('8902','2013-12-18','12:30:00',1.01),('8902','2013-12-18','12:35:00',1.17),('8902','2013-12-18','12:40:00',1.38),('8902','2013-12-18','12:45:00',1.42),('8902','2013-12-18','12:50:00',1.26),('8902','2013-12-18','12:55:00',1.14),('8902','2013-12-18','13:00:00',1.13),('8902','2013-12-18','13:05:00',1.04),('8902','2013-12-18','13:45:00',1),('8902','2013-12-18','13:50:00',1.07),('8902','2013-12-18','13:55:00',1.18),('8902','2013-12-18','14:00:00',1.39),('8902','2013-12-18','14:05:00',1.47),('8902','2013-12-18','14:10:00',1.47),('8902','2013-12-18','14:15:00',1.34),('8902','2013-12-18','14:20:00',2.22),('8902','2013-12-18','14:25:00',2.68),('8902','2013-12-18','14:30:00',3.79),('8902','2013-12-18','14:35:00',3.36),('8902','2013-12-18','14:40:00',3.29),('8902','2013-12-18','14:45:00',3.1),('8902','2013-12-18','14:50:00',1.48),('8902','2013-12-18','14:55:00',1.07),('8902','2013-12-17','08:25:00',1),('8902','2013-12-17','08:30:00',1.2),('8902','2013-12-17','08:35:00',1.42),('8902','2013-12-17','08:40:00',1.59),('8902','2013-12-17','08:45:00',1.79),('8902','2013-12-17','08:50:00',1.93),('8902','2013-12-17','08:55:00',2.11),('8902','2013-12-17','09:00:00',2.25),('8902','2013-12-17','09:05:00',2.37),('8902','2013-12-17','09:10:00',2.56),('8902','2013-12-17','09:15:00',2.69),('8902','2013-12-17','09:20:00',2.83),('8902','2013-12-17','09:25:00',2.98),('8902','2013-12-17','09:30:00',3.12),('8902','2013-12-17','09:35:00',3.24),('8902','2013-12-17','09:40:00',3.39),('8902','2013-12-17','09:45:00',3.55),('8902','2013-12-17','09:50:00',3.67),('8902','2013-12-17','09:55:00',3.8),('8902','2013-12-17','10:00:00',3.91),('8902','2013-12-17','10:05:00',4.02),('8902','2013-12-17','10:10:00',4.14),('8902','2013-12-17','10:15:00',4.27),('8902','2013-12-17','10:20:00',4.37),('8902','2013-12-17','10:25:00',4.46),('8902','2013-12-17','10:30:00',4.56),('8902','2013-12-17','10:35:00',4.64),('8902','2013-12-17','10:40:00',4.71),('8902','2013-12-17','10:45:00',4.75),('8902','2013-12-17','10:50:00',4.81),('8902','2013-12-17','10:55:00',4.87),('8902','2013-12-17','11:00:00',4.94),('8902','2013-12-17','11:05:00',5.01),('8902','2013-12-17','11:10:00',5.07),('8902','2013-12-17','11:15:00',5.13),('8902','2013-12-17','11:20:00',5.12),('8902','2013-12-17','11:25:00',5.16),('8902','2013-12-17','11:30:00',5.15),('8902','2013-12-17','11:35:00',5.22),('8902','2013-12-17','11:40:00',5.26),('8902','2013-12-17','11:45:00',5.26),('8902','2013-12-17','11:50:00',5.27),('8902','2013-12-17','11:55:00',5.28),('8902','2013-12-17','12:00:00',5.28),('8902','2013-12-17','12:05:00',5.28),('8902','2013-12-17','12:10:00',5.29),('8902','2013-12-17','12:15:00',5.29),('8902','2013-12-17','12:20:00',5.34),('8902','2013-12-17','12:25:00',5.31),('8902','2013-12-17','12:30:00',5.32),('8902','2013-12-17','12:35:00',5.28),('8902','2013-12-17','12:40:00',5.24),('8902','2013-12-17','12:45:00',5.17),('8902','2013-12-17','12:50:00',5.15),('8902','2013-12-17','12:55:00',5.2),('8902','2013-12-17','13:00:00',5.15),('8902','2013-12-17','13:05:00',5.06),('8902','2013-12-17','13:10:00',4.92),('8902','2013-12-17','13:15:00',4.89),('8902','2013-12-17','13:20:00',4.81),('8902','2013-12-17','13:25:00',4.8),('8902','2013-12-17','13:30:00',4.71),('8902','2013-12-17','13:35:00',4.65),('8902','2013-12-17','13:40:00',4.55),('8902','2013-12-17','13:45:00',4.45),('8902','2013-12-17','13:50:00',4.31),('8902','2013-12-17','13:55:00',4.15),('8902','2013-12-17','14:00:00',4.14),('8902','2013-12-17','14:05:00',4.01),('8902','2013-12-17','14:10:00',3.86),('8902','2013-12-17','14:15:00',3.77),('8902','2013-12-17','14:20:00',3.78),('8902','2013-12-17','14:25:00',3.64),('8902','2013-12-17','14:30:00',3.58),('8902','2013-12-17','14:35:00',3.49),('8902','2013-12-17','14:40:00',3.36),('8902','2013-12-17','14:45:00',3.21),('8902','2013-12-17','14:50:00',3.06),('8902','2013-12-17','14:55:00',2.97),('8902','2013-12-17','15:00:00',2.83),('8902','2013-12-17','15:05:00',2.67),('8902','2013-12-17','15:10:00',2.52),('8902','2013-12-17','15:15:00',2.39),('8902','2013-12-17','15:20:00',2.25),('8902','2013-12-17','15:25:00',2.03),('8902','2013-12-17','15:30:00',1.89),('8902','2013-12-17','15:35:00',1.72),('8902','2013-12-17','15:40:00',1.52),('8902','2013-12-17','15:45:00',1.34),('8902','2013-12-17','15:50:00',1.04),('8902','2014-04-21','07:45:00',1.13),('8902','2014-04-21','07:50:00',1.38),('8902','2014-04-21','07:55:00',1.54),('8902','2014-04-21','08:00:00',1.68),('8902','2014-04-21','08:05:00',1.83),('8902','2014-04-21','08:10:00',2),('8902','2014-04-21','08:15:00',2.17),('8902','2014-04-21','08:20:00',2.35),('8902','2014-04-21','08:25:00',2.52),('8902','2014-04-21','08:30:00',2.74),('8902','2014-04-21','08:35:00',2.91),('8902','2014-04-21','08:40:00',3.13),('8902','2014-04-21','08:45:00',3.24),('8902','2014-04-21','08:50:00',3.45),('8902','2014-04-21','08:55:00',3.53),('8902','2014-04-21','09:00:00',3.66),('8902','2014-04-21','09:05:00',4.11),('8902','2014-04-21','09:10:00',3.99),('8902','2014-04-21','09:15:00',3.84),('8902','2014-04-21','09:20:00',4.31),('8902','2014-04-21','09:25:00',4.61),('8902','2014-04-21','09:30:00',4.79),('8902','2014-04-21','09:35:00',5.07),('8902','2014-04-21','09:40:00',4.95),('8902','2014-04-21','09:45:00',5.32),('8902','2014-04-21','09:50:00',4.67),('8902','2014-04-21','09:55:00',2.79),('8902','2014-04-21','10:00:00',2.58),('8902','2014-04-21','10:05:00',2.74),('8902','2014-04-21','10:10:00',3.48),('8902','2014-04-21','10:15:00',4.03),('8902','2014-04-21','10:20:00',5.81),('8902','2014-04-21','10:25:00',4.15),('8902','2014-04-21','10:30:00',6.46),('8902','2014-04-21','10:35:00',6.94),('8902','2014-04-21','10:40:00',6.4),('8902','2014-04-21','10:45:00',6.56),('8902','2014-04-21','10:50:00',7.02),('8902','2014-04-21','10:55:00',5.89),('8902','2014-04-21','11:00:00',3.73),('8902','2014-04-21','11:05:00',4.65),('8902','2014-04-21','11:10:00',3.19),('8902','2014-04-21','11:15:00',2.64),('8902','2014-04-21','11:20:00',2.28),('8902','2014-04-21','11:25:00',2.36),('8902','2014-04-21','11:30:00',2.1),('8902','2014-04-21','11:35:00',2.22),('8902','2014-04-21','11:40:00',2.05),('8902','2014-04-21','11:45:00',1.73),('8902','2014-04-21','11:50:00',1.7),('8902','2014-04-21','11:55:00',1.6),('8902','2014-04-21','12:00:00',1.78),('8902','2014-04-21','12:05:00',2.19),('8902','2014-04-21','12:10:00',2.29),('8902','2014-04-21','12:15:00',2.33),('8902','2014-04-21','12:20:00',2.46),('8902','2014-04-21','12:25:00',2.64),('8902','2014-04-21','12:30:00',3.07),('8902','2014-04-21','12:35:00',2.72),('8902','2014-04-21','12:40:00',2),('8902','2014-04-21','12:45:00',1.64),('8902','2014-04-21','12:50:00',1.41),('8902','2014-04-21','12:55:00',1.33),('8902','2014-04-21','13:00:00',1.31),('8902','2014-04-21','13:05:00',1.42),('8902','2014-04-21','13:10:00',1.69),('8902','2014-04-21','13:15:00',2.63),('8902','2014-04-21','13:20:00',4.48),('8902','2014-04-21','13:25:00',5.12),('8902','2014-04-21','13:30:00',5.75),('8902','2014-04-21','13:35:00',5.08),('8902','2014-04-21','13:40:00',6.48),('8902','2014-04-21','13:45:00',6.59),('8902','2014-04-21','13:50:00',5.59),('8902','2014-04-21','13:55:00',3.03),('8902','2014-04-21','14:00:00',2.6),('8902','2014-04-21','14:05:00',3.02),('8902','2014-04-21','14:10:00',6.58),('8902','2014-04-21','14:15:00',6.75),('8902','2014-04-21','14:20:00',7.57),('8902','2014-04-21','14:25:00',5.29),('8902','2014-04-21','14:30:00',3.92),('8902','2014-04-21','14:35:00',4.62),('8902','2014-04-21','14:40:00',6.24),('8902','2014-04-21','14:45:00',7.99),('8902','2014-04-21','14:50:00',6.25),('8902','2014-04-21','14:55:00',5.48),('8902','2014-04-21','15:00:00',2.55),('8902','2014-04-21','15:05:00',2.47),('8902','2014-04-21','15:10:00',2.23),('8902','2014-04-21','15:15:00',2.17),('8902','2014-04-21','15:20:00',2.42),('8902','2014-04-21','15:25:00',2.83),('8902','2014-04-21','15:30:00',3.4),('8902','2014-04-21','15:35:00',5.11),('8902','2014-04-21','15:40:00',4.6),('8902','2014-04-21','15:45:00',3.55),('8902','2014-04-21','15:50:00',4.29),('8902','2014-04-21','15:55:00',3.5),('8902','2014-04-21','16:00:00',4.14),('8902','2014-04-21','16:05:00',2.88),('8902','2014-04-21','16:10:00',2.71),('8902','2014-04-21','16:15:00',2.6),('8902','2014-04-21','16:20:00',3.19),('8902','2014-04-21','16:25:00',2.92),('8902','2014-04-21','16:30:00',2.44),('8902','2014-04-21','16:35:00',2.41),('8902','2014-04-21','16:40:00',3.37),('8902','2014-04-21','16:45:00',3.38),('8902','2014-04-21','16:50:00',2.54),('8902','2014-04-21','16:55:00',2.18),('8902','2014-04-21','17:00:00',2.33),('8902','2014-04-21','17:05:00',2.68),('8902','2014-04-21','17:10:00',2.14),('8902','2014-04-21','17:15:00',1.93),('8902','2014-04-21','17:20:00',1.45),('8902','2014-04-21','17:25:00',1.23),('8902','2014-04-21','17:30:00',1.15),('8902','2014-04-21','17:35:00',1.3),('8902','2014-04-21','17:40:00',1.29),('8902','2014-04-21','17:45:00',1.16),('8902','2014-04-21','17:50:00',1.09),('8902','2013-12-16','08:30:00',1.22),('8902','2013-12-16','08:35:00',1.51),('8902','2013-12-16','08:40:00',1.69),('8902','2013-12-16','08:45:00',1.9),('8902','2013-12-16','08:50:00',2.07),('8902','2013-12-16','08:55:00',2.25),('8902','2013-12-16','09:00:00',2.41),('8902','2013-12-16','09:05:00',2.59),('8902','2013-12-16','09:10:00',2.76),('8902','2013-12-16','09:15:00',2.91),('8902','2013-12-16','09:20:00',3.05),('8902','2013-12-16','09:25:00',3.18),('8902','2013-12-16','09:30:00',3.31),('8902','2013-12-16','09:35:00',3.46),('8902','2013-12-16','09:40:00',3.58),('8902','2013-12-16','09:45:00',3.72),('8902','2013-12-16','09:50:00',3.84),('8902','2013-12-16','09:55:00',3.98),('8902','2013-12-16','10:00:00',4.1),('8902','2013-12-16','10:05:00',4.21),('8902','2013-12-16','10:10:00',4.32),('8902','2013-12-16','10:15:00',4.42),('8902','2013-12-16','10:20:00',4.53),('8902','2013-12-16','10:25:00',4.66),('8902','2013-12-16','10:30:00',4.77),('8902','2013-12-16','10:35:00',4.82),('8902','2013-12-16','10:40:00',4.91),('8902','2013-12-16','10:45:00',5.01),('8902','2013-12-16','10:50:00',5.02),('8902','2013-12-16','10:55:00',5.1),('8902','2013-12-16','11:00:00',5.17),('8902','2013-12-16','11:05:00',5.22),('8902','2013-12-16','11:10:00',5.28),('8902','2013-12-16','11:15:00',5.32),('8902','2013-12-16','11:20:00',5.36),('8902','2013-12-16','11:25:00',5.39),('8902','2013-12-16','11:30:00',5.44),('8902','2013-12-16','11:35:00',5.47),('8902','2013-12-16','11:40:00',5.52),('8902','2013-12-16','11:45:00',5.57),('8902','2013-12-16','11:50:00',5.64),('8902','2013-12-16','11:55:00',5.59),('8902','2013-12-16','12:00:00',5.6),('8902','2013-12-16','12:05:00',5.62),('8902','2013-12-16','12:10:00',5.61),('8902','2013-12-16','12:15:00',5.58),('8902','2013-12-16','12:20:00',5.6),('8902','2013-12-16','12:25:00',5.57),('8902','2013-12-16','12:30:00',5.57),('8902','2013-12-16','12:35:00',5.54),('8902','2013-12-16','12:40:00',5.56),('8902','2013-12-16','12:45:00',5.51),('8902','2013-12-16','12:50:00',5.45),('8902','2013-12-16','12:55:00',5.42),('8902','2013-12-16','13:00:00',5.39),('8902','2013-12-16','13:05:00',5.32),('8902','2013-12-16','13:10:00',5.24),('8902','2013-12-16','13:15:00',5.17),('8902','2013-12-16','13:20:00',5.08),('8902','2013-12-16','13:25:00',5.02),('8902','2013-12-16','13:30:00',4.98),('8902','2013-12-16','13:35:00',4.96),('8902','2013-12-16','13:40:00',4.91),('8902','2013-12-16','13:45:00',4.8),('8902','2013-12-16','13:50:00',4.69),('8902','2013-12-16','13:55:00',4.62),('8902','2013-12-16','14:00:00',4.52),('8902','2013-12-16','14:05:00',4.39),('8902','2013-12-16','14:10:00',4.28),('8902','2013-12-16','14:15:00',4.15),('8902','2013-12-16','14:20:00',4.03),('8902','2013-12-16','14:25:00',3.91),('8902','2013-12-16','14:30:00',3.81),('8902','2013-12-16','14:35:00',3.72),('8902','2013-12-16','14:40:00',3.56),('8902','2013-12-16','14:45:00',3.38),('8902','2013-12-16','14:50:00',3.26),('8902','2013-12-16','14:55:00',3.22),('8902','2013-12-16','15:00:00',3.07),('8902','2013-12-16','15:05:00',2.91),('8902','2013-12-16','15:10:00',2.79),('8902','2013-12-16','15:15:00',2.62),('8902','2013-12-16','15:20:00',2.46),('8902','2013-12-16','15:25:00',2.31),('8902','2013-12-16','15:30:00',2.1),('8902','2013-12-16','15:35:00',1.91),('8902','2013-12-16','15:40:00',1.74),('8902','2013-12-16','15:45:00',1.56),('8902','2013-12-16','15:50:00',1.38),('8902','2013-12-16','15:55:00',1.21),('8902','2013-12-16','16:00:00',1.02),('8902','2013-12-15','08:25:00',1.06),('8902','2013-12-15','08:30:00',1.26),('8902','2013-12-15','08:35:00',1.58),('8902','2013-12-15','08:40:00',1.75),('8902','2013-12-15','08:45:00',1.92),('8902','2013-12-15','08:50:00',2.07),('8902','2013-12-15','08:55:00',2.21),('8902','2013-12-15','09:00:00',2.36),('8902','2013-12-15','09:05:00',2.55),('8902','2013-12-15','09:10:00',2.73),('8902','2013-12-15','09:15:00',2.87),('8902','2013-12-15','09:20:00',3),('8902','2013-12-15','09:25:00',3.16),('8902','2013-12-15','09:30:00',3.3),('8902','2013-12-15','09:35:00',3.45),('8902','2013-12-15','09:40:00',3.59),('8902','2013-12-15','09:45:00',3.73),('8902','2013-12-15','09:50:00',3.84),('8902','2013-12-15','09:55:00',3.95),('8902','2013-12-15','10:00:00',4.04),('8902','2013-12-15','10:05:00',4.16),('8902','2013-12-15','10:10:00',4.25),('8902','2013-12-15','10:15:00',4.35),('8902','2013-12-15','10:20:00',4.39),('8902','2013-12-15','10:25:00',4.45),('8902','2013-12-15','10:30:00',4.53),('8902','2013-12-15','10:35:00',4.6),('8902','2013-12-15','10:40:00',4.67),('8902','2013-12-15','10:45:00',4.76),('8902','2013-12-15','10:50:00',4.83),('8902','2013-12-15','10:55:00',4.92),('8902','2013-12-15','11:00:00',5),('8902','2013-12-15','11:05:00',5.06),('8902','2013-12-15','11:10:00',5.07),('8902','2013-12-15','11:15:00',5.1),('8902','2013-12-15','11:20:00',5.12),('8902','2013-12-15','11:25:00',5.17),('8902','2013-12-15','11:30:00',5.25),('8902','2013-12-15','11:35:00',5.28),('8902','2013-12-15','11:40:00',5.34),('8902','2013-12-15','11:45:00',5.33),('8902','2013-12-15','11:50:00',5.36),('8902','2013-12-15','11:55:00',5.42),('8902','2013-12-15','12:00:00',5.49),('8902','2013-12-15','12:05:00',5.51),('8902','2013-12-15','12:10:00',5.51),('8902','2013-12-15','12:15:00',5.54),('8902','2013-12-15','12:20:00',5.59),('8902','2013-12-15','12:25:00',5.56),('8902','2013-12-15','12:30:00',5.54),('8902','2013-12-15','12:35:00',5.49),('8902','2013-12-15','12:40:00',5.49),('8902','2013-12-15','12:45:00',5.46),('8902','2013-12-15','12:50:00',5.44),('8902','2013-12-15','12:55:00',5.41),('8902','2013-12-15','13:00:00',5.4),('8902','2013-12-15','13:05:00',5.34),('8902','2013-12-15','13:10:00',5.26),('8902','2013-12-15','13:15:00',5.16),('8902','2013-12-15','13:20:00',5.04),('8902','2013-12-15','13:25:00',4.96),('8902','2013-12-15','13:30:00',4.91),('8902','2013-12-15','13:35:00',4.81),('8902','2013-12-15','13:40:00',4.74),('8902','2013-12-15','13:45:00',4.7),('8902','2013-12-15','13:50:00',4.65),('8902','2013-12-15','13:55:00',4.56),('8902','2013-12-15','14:00:00',4.37),('8902','2013-12-15','14:05:00',4.31),('8902','2013-12-15','14:10:00',4.2),('8902','2013-12-15','14:15:00',4.09),('8902','2013-12-15','14:20:00',4),('8902','2013-12-15','14:25:00',3.89),('8902','2013-12-15','14:30:00',3.75),('8902','2013-12-15','14:35:00',3.65),('8902','2013-12-15','14:40:00',3.51),('8902','2013-12-15','14:45:00',3.36),('8902','2013-12-15','14:50:00',3.22),('8902','2013-12-15','14:55:00',3.08),('8902','2013-12-15','15:00:00',2.94),('8902','2013-12-15','15:05:00',2.72),('8902','2013-12-15','15:10:00',2.57),('8902','2013-12-15','15:15:00',2.46),('8902','2013-12-15','15:20:00',2.34),('8902','2013-12-15','15:25:00',2.19),('8902','2013-12-15','15:30:00',2),('8902','2013-12-15','15:35:00',1.79),('8902','2013-12-15','15:40:00',1.57),('8902','2013-12-15','15:45:00',1.41),('8902','2013-12-15','15:50:00',1.23),('8902','2013-12-15','15:55:00',1.05),('8902','2013-12-14','09:45:00',1.12),('8902','2013-12-14','09:50:00',1.3),('8902','2013-12-14','09:55:00',1.33),('8902','2013-12-14','10:00:00',1.33),('8902','2013-12-14','10:05:00',1.34),('8902','2013-12-14','10:10:00',1.4),('8902','2013-12-14','10:15:00',1.52),('8902','2013-12-14','10:20:00',2.62),('8902','2013-12-14','10:25:00',2.41),('8902','2013-12-14','10:30:00',2.12),('8902','2013-12-14','10:35:00',2.38),('8902','2013-12-14','10:40:00',2.38),('8902','2013-12-14','10:45:00',2.42),('8902','2013-12-14','10:50:00',1.91),('8902','2013-12-14','10:55:00',1.53),('8902','2013-12-14','11:00:00',1.51),('8902','2013-12-14','11:05:00',1.47),('8902','2013-12-14','11:10:00',1.43),('8902','2013-12-14','11:15:00',1.44),('8902','2013-12-14','11:20:00',1.62),('8902','2013-12-14','11:25:00',1.64),('8902','2013-12-14','11:30:00',1.61),('8902','2013-12-14','11:35:00',1.66),('8902','2013-12-14','11:40:00',1.72),('8902','2013-12-14','11:45:00',1.78),('8902','2013-12-14','11:50:00',1.73),('8902','2013-12-14','11:55:00',1.73),('8902','2013-12-14','12:00:00',1.75),('8902','2013-12-14','12:05:00',1.79),('8902','2013-12-14','12:10:00',1.65),('8902','2013-12-14','12:15:00',1.52),('8902','2013-12-14','12:20:00',1.66),('8902','2013-12-14','12:25:00',1.35),('8902','2013-12-14','12:40:00',1.09),('8902','2013-12-14','12:45:00',1.27),('8902','2013-12-14','12:50:00',1.31),('8902','2013-12-14','12:55:00',1.03),('8902','2013-12-13','08:25:00',1.01),('8902','2013-12-13','08:30:00',1.14),('8902','2013-12-13','08:35:00',1.43),('8902','2013-12-13','08:40:00',1.59),('8902','2013-12-13','08:45:00',1.75),('8902','2013-12-13','08:50:00',1.97),('8902','2013-12-13','08:55:00',2.16),('8902','2013-12-13','09:00:00',2.34),('8902','2013-12-13','09:05:00',2.51),('8902','2013-12-13','09:10:00',2.69),('8902','2013-12-13','09:15:00',2.85),('8902','2013-12-13','09:20:00',2.98),('8902','2013-12-13','09:25:00',3.12),('8902','2013-12-13','09:30:00',3.26),('8902','2013-12-13','09:35:00',3.36),('8902','2013-12-13','09:40:00',3.49),('8902','2013-12-13','09:45:00',3.6),('8902','2013-12-13','09:50:00',3.72),('8902','2013-12-13','09:55:00',3.83),('8902','2013-12-13','10:00:00',3.93),('8902','2013-12-13','10:05:00',4.03),('8902','2013-12-13','10:10:00',4.15),('8902','2013-12-13','10:15:00',4.25),('8902','2013-12-13','10:20:00',4.38),('8902','2013-12-13','10:25:00',4.44),('8902','2013-12-13','10:30:00',4.5),('8902','2013-12-13','10:35:00',4.59),('8902','2013-12-13','10:40:00',4.66),('8902','2013-12-13','10:45:00',4.71),('8902','2013-12-13','10:50:00',4.73),('8902','2013-12-13','10:55:00',4.77),('8902','2013-12-13','11:00:00',4.82),('8902','2013-12-13','11:05:00',4.9),('8902','2013-12-13','11:10:00',4.92),('8902','2013-12-13','11:15:00',5.05),('8902','2013-12-13','11:20:00',5.06),('8902','2013-12-13','11:25:00',5.16),('8902','2013-12-13','11:30:00',5.16),('8902','2013-12-13','11:35:00',5.13),('8902','2013-12-13','11:40:00',5.11),('8902','2013-12-13','11:45:00',5.11),('8902','2013-12-13','11:50:00',5.08),('8902','2013-12-13','11:55:00',5.11),('8902','2013-12-13','12:00:00',5.05),('8902','2013-12-13','12:05:00',5.05),('8902','2013-12-13','12:10:00',5.03),('8902','2013-12-13','12:15:00',5.1),('8902','2013-12-13','12:20:00',5.11),('8902','2013-12-13','12:25:00',5.03),('8902','2013-12-13','12:30:00',4.87),('8902','2013-12-13','12:35:00',5.01),('8902','2013-12-13','12:40:00',5.02),('8902','2013-12-13','12:45:00',4.96),('8902','2013-12-13','12:50:00',5.1),('8902','2013-12-13','12:55:00',5.01),('8902','2013-12-13','13:00:00',4.91),('8902','2013-12-13','13:05:00',4.87),('8902','2013-12-13','13:10:00',4.92),('8902','2013-12-13','13:15:00',4.86),('8902','2013-12-13','13:20:00',4.82),('8902','2013-12-13','13:25:00',4.84),('8902','2013-12-13','13:30:00',4.76),('8902','2013-12-13','13:35:00',4.66),('8902','2013-12-13','13:40:00',4.58),('8902','2013-12-13','13:45:00',4.65),('8902','2013-12-13','13:50:00',4.51),('8902','2013-12-13','13:55:00',4.39),('8902','2013-12-13','14:00:00',4.31),('8902','2013-12-13','14:05:00',4.22),('8902','2013-12-13','14:10:00',4.16),('8902','2013-12-13','14:15:00',4.04),('8902','2013-12-13','14:20:00',3.9),('8902','2013-12-13','14:25:00',3.78),('8902','2013-12-13','14:30:00',3.67),('8902','2013-12-13','14:35:00',3.55),('8902','2013-12-13','14:40:00',3.39),('8902','2013-12-13','14:45:00',3.26),('8902','2013-12-13','14:50:00',3.07),('8902','2013-12-13','14:55:00',2.83),('8902','2013-12-13','15:00:00',2.68),('8902','2013-12-13','15:05:00',2.58),('8902','2013-12-13','15:10:00',2.41),('8902','2013-12-13','15:15:00',2.32),('8902','2013-12-13','15:20:00',2.2),('8902','2013-12-13','15:25:00',2.06),('8902','2013-12-13','15:30:00',1.89),('8902','2013-12-13','15:35:00',1.73),('8902','2013-12-13','15:40:00',1.57),('8902','2013-12-13','15:45:00',1.37),('8902','2013-12-13','15:50:00',1.22),('8902','2013-12-13','15:55:00',1.04),('8902','2013-12-12','08:30:00',1.17),('8902','2013-12-12','08:35:00',1.36),('8902','2013-12-12','08:40:00',1.53),('8902','2013-12-12','08:45:00',1.68),('8902','2013-12-12','08:50:00',1.86),('8902','2013-12-12','08:55:00',2.03),('8902','2013-12-12','09:00:00',2.19),('8902','2013-12-12','09:05:00',2.29),('8902','2013-12-12','09:10:00',2.44),('8902','2013-12-12','09:15:00',2.6),('8902','2013-12-12','09:20:00',2.73),('8902','2013-12-12','09:25:00',2.84),('8902','2013-12-12','09:30:00',2.93),('8902','2013-12-12','09:35:00',3.02),('8902','2013-12-12','09:40:00',3.18),('8902','2013-12-12','09:45:00',3.32),('8902','2013-12-12','09:50:00',3.44),('8902','2013-12-12','09:55:00',3.55),('8902','2013-12-12','10:00:00',3.65),('8902','2013-12-12','10:05:00',3.76),('8902','2013-12-12','10:10:00',3.84),('8902','2013-12-12','10:15:00',3.94),('8902','2013-12-12','10:20:00',4.01),('8902','2013-12-12','10:25:00',4.07),('8902','2013-12-12','10:30:00',4.21),('8902','2013-12-12','10:35:00',4.29),('8902','2013-12-12','10:40:00',4.35),('8902','2013-12-12','10:45:00',4.44),('8902','2013-12-12','10:50:00',4.53),('8902','2013-12-12','10:55:00',4.62),('8902','2013-12-12','11:00:00',4.64),('8902','2013-12-12','11:05:00',4.72),('8902','2013-12-12','11:10:00',4.71),('8902','2013-12-12','11:15:00',4.85),('8902','2013-12-12','11:20:00',4.9),('8902','2013-12-12','11:25:00',4.9),('8902','2013-12-12','11:30:00',4.94),('8902','2013-12-12','11:35:00',4.96),('8902','2013-12-12','11:40:00',5.04),('8902','2013-12-12','11:45:00',4.98),('8902','2013-12-12','11:50:00',4.98),('8902','2013-12-12','11:55:00',5.04),('8902','2013-12-12','12:00:00',5.01),('8902','2013-12-12','12:05:00',5.02),('8902','2013-12-12','12:10:00',5.05),('8902','2013-12-12','12:15:00',4.95),('8902','2013-12-12','12:20:00',4.93),('8902','2013-12-12','12:25:00',4.99),('8902','2013-12-12','12:30:00',4.94),('8902','2013-12-12','12:35:00',5),('8902','2013-12-12','12:40:00',4.84),('8902','2013-12-12','12:45:00',5.07),('8902','2013-12-12','12:50:00',4.96),('8902','2013-12-12','12:55:00',4.87),('8902','2013-12-12','13:00:00',4.81),('8902','2013-12-12','13:05:00',4.81),('8902','2013-12-12','13:10:00',4.81),('8902','2013-12-12','13:15:00',4.85),('8902','2013-12-12','13:20:00',4.67),('8902','2013-12-12','13:25:00',4.7),('8902','2013-12-12','13:30:00',4.74),('8902','2013-12-12','13:35:00',4.68),('8902','2013-12-12','13:40:00',4.49),('8902','2013-12-12','13:45:00',4.46),('8902','2013-12-12','13:50:00',4.34),('8902','2013-12-12','13:55:00',4.26),('8902','2013-12-12','14:00:00',4.23),('8902','2013-12-12','14:05:00',4.16),('8902','2013-12-12','14:10:00',4.04),('8902','2013-12-12','14:15:00',4),('8902','2013-12-12','14:20:00',3.86),('8902','2013-12-12','14:25:00',3.75),('8902','2013-12-12','14:30:00',3.62),('8902','2013-12-12','14:35:00',3.58),('8902','2013-12-12','14:40:00',3.46),('8902','2013-12-12','14:45:00',3.31),('8902','2013-12-12','14:50:00',3.24),('8902','2013-12-12','14:55:00',3.11),('8902','2013-12-12','15:00:00',2.79),('8902','2013-12-12','15:05:00',2.6),('8902','2013-12-12','15:10:00',2.47),('8902','2013-12-12','15:15:00',2.27),('8902','2013-12-12','15:20:00',2.12),('8902','2013-12-12','15:25:00',1.99),('8902','2013-12-12','15:30:00',1.82),('8902','2013-12-12','15:35:00',1.64),('8902','2013-12-12','15:40:00',1.47),('8902','2013-12-12','15:45:00',1.31),('8902','2013-12-12','15:50:00',1.13),('8902','2013-12-11','08:25:00',1.04),('8902','2013-12-11','08:30:00',1.16),('8902','2013-12-11','08:35:00',1.39),('8902','2013-12-11','08:40:00',1.67),('8902','2013-12-11','08:45:00',1.84),('8902','2013-12-11','08:50:00',2),('8902','2013-12-11','08:55:00',2.16),('8902','2013-12-11','09:00:00',2.28),('8902','2013-12-11','09:05:00',2.42),('8902','2013-12-11','09:10:00',2.61),('8902','2013-12-11','09:15:00',2.74),('8902','2013-12-11','09:20:00',2.87),('8902','2013-12-11','09:25:00',3.03),('8902','2013-12-11','09:30:00',3.18),('8902','2013-12-11','09:35:00',3.33),('8902','2013-12-11','09:40:00',3.46),('8902','2013-12-11','09:45:00',3.57),('8902','2013-12-11','09:50:00',3.7),('8902','2013-12-11','09:55:00',3.81),('8902','2013-12-11','10:00:00',3.93),('8902','2013-12-11','10:05:00',4.04),('8902','2013-12-11','10:10:00',4.16),('8902','2013-12-11','10:15:00',4.26),('8902','2013-12-11','10:20:00',4.34),('8902','2013-12-11','10:25:00',4.42),('8902','2013-12-11','10:30:00',4.5),('8902','2013-12-11','10:35:00',4.58),('8902','2013-12-11','10:40:00',4.65),('8902','2013-12-11','10:45:00',4.72),('8902','2013-12-11','10:50:00',4.8),('8902','2013-12-11','10:55:00',4.83),('8902','2013-12-11','11:00:00',4.89),('8902','2013-12-11','11:05:00',4.89),('8902','2013-12-11','11:10:00',4.92),('8902','2013-12-11','11:15:00',4.97),('8902','2013-12-11','11:20:00',5.02),('8902','2013-12-11','11:25:00',5.05),('8902','2013-12-11','11:30:00',5.06),('8902','2013-12-11','11:35:00',5.11),('8902','2013-12-11','11:40:00',5.18),('8902','2013-12-11','11:45:00',5.18),('8902','2013-12-11','11:50:00',5.22),('8902','2013-12-11','11:55:00',5.19),('8902','2013-12-11','12:00:00',5.17),('8902','2013-12-11','12:05:00',5.21),('8902','2013-12-11','12:10:00',5.23),('8902','2013-12-11','12:15:00',5.25),('8902','2013-12-11','12:20:00',5.27),('8902','2013-12-11','12:25:00',5.22),('8902','2013-12-11','12:30:00',5.25),('8902','2013-12-11','12:35:00',5.22),('8902','2013-12-11','12:40:00',5.12),('8902','2013-12-11','12:45:00',5.06),('8902','2013-12-11','12:50:00',5.14),('8902','2013-12-11','12:55:00',5.06),('8902','2013-12-11','13:00:00',4.94),('8902','2013-12-11','13:05:00',4.82),('8902','2013-12-11','13:10:00',4.71),('8902','2013-12-11','13:15:00',4.78),('8902','2013-12-11','13:20:00',4.91),('8902','2013-12-11','13:25:00',4.8),('8902','2013-12-11','13:30:00',4.62),('8902','2013-12-11','13:35:00',4.66),('8902','2013-12-11','13:40:00',4.6),('8902','2013-12-11','13:45:00',4.45),('8902','2013-12-11','13:50:00',4.37),('8902','2013-12-11','13:55:00',4.3),('8902','2013-12-11','14:00:00',4.22),('8902','2013-12-11','14:05:00',4.11),('8902','2013-12-11','14:10:00',4.04),('8902','2013-12-11','14:15:00',3.89),('8902','2013-12-11','14:20:00',3.81),('8902','2013-12-11','14:25:00',3.63),('8902','2013-12-11','14:30:00',3.51),('8902','2013-12-11','14:35:00',3.31),('8902','2013-12-11','14:40:00',3.22),('8902','2013-12-11','14:45:00',3.12),('8902','2013-12-11','14:50:00',2.94),('8902','2013-12-11','14:55:00',2.83),('8902','2013-12-11','15:00:00',2.58),('8902','2013-12-11','15:05:00',2.43),('8902','2013-12-11','15:10:00',2.26),('8902','2013-12-11','15:15:00',2.15),('8902','2013-12-11','15:20:00',2),('8902','2013-12-11','15:25:00',1.83),('8902','2013-12-11','15:30:00',1.68),('8902','2013-12-11','15:35:00',1.5),('8902','2013-12-11','15:40:00',1.35),('8902','2013-12-11','15:45:00',1.17),('8902','2013-12-11','15:50:00',1.03),('8902','2013-12-10','08:25:00',1.04),('8902','2013-12-10','08:30:00',1.31),('8902','2013-12-10','08:35:00',1.5),('8902','2013-12-10','08:40:00',1.66),('8902','2013-12-10','08:45:00',1.82),('8902','2013-12-10','08:50:00',2.02),('8902','2013-12-10','08:55:00',2.2),('8902','2013-12-10','09:00:00',2.34),('8902','2013-12-10','09:05:00',2.48),('8902','2013-12-10','09:10:00',2.68),('8902','2013-12-10','09:15:00',2.83),('8902','2013-12-10','09:20:00',2.98),('8902','2013-12-10','09:25:00',3.13),('8902','2013-12-10','09:30:00',3.27),('8902','2013-12-10','09:35:00',3.39),('8902','2013-12-10','09:40:00',3.55),('8902','2013-12-10','09:45:00',3.71),('8902','2013-12-10','09:50:00',3.84),('8902','2013-12-10','09:55:00',3.93),('8902','2013-12-10','10:00:00',4.03),('8902','2013-12-10','10:05:00',4.17),('8902','2013-12-10','10:10:00',4.26),('8902','2013-12-10','10:15:00',4.38),('8902','2013-12-10','10:20:00',4.48),('8902','2013-12-10','10:25:00',4.57),('8902','2013-12-10','10:30:00',4.71),('8902','2013-12-10','10:35:00',4.85),('8902','2013-12-10','10:40:00',4.89),('8902','2013-12-10','10:45:00',4.88),('8902','2013-12-10','10:50:00',4.95),('8902','2013-12-10','10:55:00',4.98),('8902','2013-12-10','11:00:00',5.12),('8902','2013-12-10','11:05:00',5.2),('8902','2013-12-10','11:10:00',5.25),('8902','2013-12-10','11:15:00',5.25),('8902','2013-12-10','11:20:00',5.3),('8902','2013-12-10','11:25:00',5.24),('8902','2013-12-10','11:30:00',5.18),('8902','2013-12-10','11:35:00',5.31),('8902','2013-12-10','11:40:00',5.4),('8902','2013-12-10','11:45:00',5.43),('8902','2013-12-10','11:50:00',5.48),('8902','2013-12-10','11:55:00',5.48),('8902','2013-12-10','12:00:00',5.52),('8902','2013-12-10','12:05:00',5.53),('8902','2013-12-10','12:10:00',5.51),('8902','2013-12-10','12:15:00',5.51),('8902','2013-12-10','12:20:00',5.49),('8902','2013-12-10','12:25:00',5.35),('8902','2013-12-10','12:30:00',5.32),('8902','2013-12-10','12:35:00',5.32),('8902','2013-12-10','12:40:00',5.34),('8902','2013-12-10','12:45:00',5.36),('8902','2013-12-10','12:50:00',5.3),('8902','2013-12-10','12:55:00',5.33),('8902','2013-12-10','13:00:00',5.33),('8902','2013-12-10','13:05:00',5.24),('8902','2013-12-10','13:10:00',5.15),('8902','2013-12-10','13:15:00',5.07),('8902','2013-12-10','13:20:00',4.99),('8902','2013-12-10','13:25:00',5),('8902','2013-12-10','13:30:00',4.98),('8902','2013-12-10','13:35:00',4.88),('8902','2013-12-10','13:40:00',4.78),('8902','2013-12-10','13:45:00',4.66),('8902','2013-12-10','13:50:00',4.58),('8902','2013-12-10','13:55:00',4.5),('8902','2013-12-10','14:00:00',4.39),('8902','2013-12-10','14:05:00',4.37),('8902','2013-12-10','14:10:00',4.3),('8902','2013-12-10','14:15:00',4.19),('8902','2013-12-10','14:20:00',4.04),('8902','2013-12-10','14:25:00',3.94),('8902','2013-12-10','14:30:00',3.84),('8902','2013-12-10','14:35:00',3.69),('8902','2013-12-10','14:40:00',3.55),('8902','2013-12-10','14:45:00',3.38),('8902','2013-12-10','14:50:00',3.23),('8902','2013-12-10','14:55:00',3.1),('8902','2013-12-10','15:00:00',2.93),('8902','2013-12-10','15:05:00',2.75),('8902','2013-12-10','15:10:00',2.58),('8902','2013-12-10','15:15:00',2.39),('8902','2013-12-10','15:20:00',2.26),('8902','2013-12-10','15:25:00',2.07),('8902','2013-12-10','15:30:00',1.86),('8902','2013-12-10','15:35:00',1.68),('8902','2013-12-10','15:40:00',1.54),('8902','2013-12-10','15:45:00',1.37),('8902','2013-12-10','15:50:00',1.18),('8902','2013-12-10','15:55:00',1.02),('8902','2013-12-09','08:25:00',1.11),('8902','2013-12-09','08:30:00',1.31),('8902','2013-12-09','08:35:00',1.62),('8902','2013-12-09','08:40:00',1.82),('8902','2013-12-09','08:45:00',1.98),('8902','2013-12-09','08:50:00',2.16),('8902','2013-12-09','08:55:00',2.33),('8902','2013-12-09','09:00:00',2.52),('8902','2013-12-09','09:05:00',2.67),('8902','2013-12-09','09:10:00',2.82),('8902','2013-12-09','09:15:00',2.98),('8902','2013-12-09','09:20:00',3.13),('8902','2013-12-09','09:25:00',3.28),('8902','2013-12-09','09:30:00',3.35),('8902','2013-12-09','09:35:00',3.49),('8902','2013-12-09','09:40:00',3.64),('8902','2013-12-09','09:45:00',3.74),('8902','2013-12-09','09:50:00',3.9),('8902','2013-12-09','09:55:00',4.03),('8902','2013-12-09','10:00:00',4.17),('8902','2013-12-09','10:05:00',4.28),('8902','2013-12-09','10:10:00',4.4),('8902','2013-12-09','10:15:00',4.48),('8902','2013-12-09','10:20:00',4.56),('8902','2013-12-09','10:25:00',4.63),('8902','2013-12-09','10:30:00',4.72),('8902','2013-12-09','10:35:00',4.8),('8902','2013-12-09','10:40:00',4.84),('8902','2013-12-09','10:45:00',4.95),('8902','2013-12-09','10:50:00',5.05),('8902','2013-12-09','10:55:00',5.1),('8902','2013-12-09','11:00:00',5.17),('8902','2013-12-09','11:05:00',5.23),('8902','2013-12-09','11:10:00',5.28),('8902','2013-12-09','11:15:00',5.33),('8902','2013-12-09','11:20:00',5.4),('8902','2013-12-09','11:25:00',5.45),('8902','2013-12-09','11:30:00',5.5),('8902','2013-12-09','11:35:00',5.52),('8902','2013-12-09','11:40:00',5.55),('8902','2013-12-09','11:45:00',5.52),('8902','2013-12-09','11:50:00',5.54),('8902','2013-12-09','11:55:00',5.57),('8902','2013-12-09','12:00:00',5.58),('8902','2013-12-09','12:05:00',5.57),('8902','2013-12-09','12:10:00',5.53),('8902','2013-12-09','12:15:00',5.52),('8902','2013-12-09','12:20:00',5.52),('8902','2013-12-09','12:25:00',5.46),('8902','2013-12-09','12:30:00',5.43),('8902','2013-12-09','12:35:00',5.39),('8902','2013-12-09','12:40:00',5.34),('8902','2013-12-09','12:45:00',5.32),('8902','2013-12-09','12:50:00',5.26),('8902','2013-12-09','12:55:00',5.16),('8902','2013-12-09','13:00:00',5.11),('8902','2013-12-09','13:05:00',5.12),('8902','2013-12-09','13:10:00',4.99),('8902','2013-12-09','13:15:00',4.9),('8902','2013-12-09','13:20:00',4.97),('8902','2013-12-09','13:25:00',4.92),('8902','2013-12-09','13:30:00',4.9),('8902','2013-12-09','13:35:00',4.91),('8902','2013-12-09','13:40:00',4.88),('8902','2013-12-09','13:45:00',4.78),('8902','2013-12-09','13:50:00',4.69),('8902','2013-12-09','13:55:00',4.62),('8902','2013-12-09','14:00:00',4.52),('8902','2013-12-09','14:05:00',4.42),('8902','2013-12-09','14:10:00',4.33),('8902','2013-12-09','14:15:00',4.24),('8902','2013-12-09','14:20:00',4.14),('8902','2013-12-09','14:25:00',4.07),('8902','2013-12-09','14:30:00',3.96),('8902','2013-12-09','14:35:00',3.84),('8902','2013-12-09','14:40:00',3.7),('8902','2013-12-09','14:45:00',3.51),('8902','2013-12-09','14:50:00',3.45),('8902','2013-12-09','14:55:00',3.28),('8902','2013-12-09','15:00:00',3.08),('8902','2013-12-09','15:05:00',2.87),('8902','2013-12-09','15:10:00',2.73),('8902','2013-12-09','15:15:00',2.56),('8902','2013-12-09','15:20:00',2.38),('8902','2013-12-09','15:25:00',2.17),('8902','2013-12-09','15:30:00',2),('8902','2013-12-09','15:35:00',1.81),('8902','2013-12-09','15:40:00',1.64),('8902','2013-12-09','15:45:00',1.44),('8902','2013-12-09','15:50:00',1.26),('8902','2013-12-09','15:55:00',1.11),('8902','2013-12-08','09:30:00',1.07),('8902','2013-12-08','09:35:00',3.26),('8902','2013-12-08','09:40:00',3.58),('8902','2013-12-08','09:45:00',3.69),('8902','2013-12-08','09:50:00',3.79),('8902','2013-12-08','09:55:00',3.93),('8902','2013-12-08','10:00:00',4.06),('8902','2013-12-08','10:05:00',4.22),('8902','2013-12-08','10:10:00',4.97),('8902','2013-12-08','10:15:00',5.22),('8902','2013-12-08','10:20:00',5.71),('8902','2013-12-08','10:25:00',4.83),('8902','2013-12-08','10:30:00',1.63),('8902','2013-12-08','10:35:00',1.33),('8902','2013-12-08','10:40:00',1.15),('8902','2013-12-08','11:45:00',1.04),('8902','2013-12-08','11:50:00',1.08),('8902','2013-12-08','11:55:00',1.18),('8902','2013-12-08','12:00:00',1.26),('8902','2013-12-08','12:05:00',1.36),('8902','2013-12-08','12:10:00',1.35),('8902','2013-12-08','12:15:00',1.29),('8902','2013-12-08','12:20:00',1.38),('8902','2013-12-08','12:25:00',1.76),('8902','2013-12-08','12:30:00',3.96),('8902','2013-12-08','12:35:00',2.4),('8902','2013-12-08','12:40:00',2.25),('8902','2013-12-08','12:45:00',3.54),('8902','2013-12-08','12:50:00',3.44),('8902','2013-12-08','12:55:00',3.7),('8902','2013-12-08','13:00:00',4.79),('8902','2013-12-08','13:05:00',4.24),('8902','2013-12-08','13:10:00',3.52),('8902','2013-12-08','13:15:00',3.84),('8902','2013-12-08','13:20:00',3.59),('8902','2013-12-08','13:25:00',2.57),('8902','2013-12-08','13:30:00',1.47),('8902','2013-12-08','13:35:00',1.09),('8902','2013-12-08','13:40:00',1.35),('8902','2013-12-08','13:45:00',1.82),('8902','2013-12-08','13:50:00',2.15),('8902','2013-12-08','13:55:00',2.34),('8902','2013-12-08','14:00:00',1.94),('8902','2013-12-08','14:05:00',1.5),('8902','2013-12-08','14:10:00',1.27),('8902','2013-12-08','14:15:00',1.1),('8902','2013-12-08','14:40:00',1.04),('8902','2013-12-08','14:45:00',1.09),('8902','2013-12-08','14:50:00',1.03),('8902','2013-12-08','14:55:00',1.04),('8902','2013-12-08','15:00:00',1),('8902','2013-12-07','15:30:00',2.11),('8902','2013-12-07','15:35:00',1.61),('8902','2013-12-07','15:40:00',1.14),('8902','2014-04-20','08:20:00',1.06),('8902','2014-04-20','08:25:00',1.15),('8902','2014-04-20','08:30:00',1.55),('8902','2014-04-20','08:35:00',1.6),('8902','2014-04-20','08:40:00',1.6),('8902','2014-04-20','08:45:00',1.53),('8902','2014-04-20','08:50:00',1.46),('8902','2014-04-20','08:55:00',1.42),('8902','2014-04-20','09:00:00',1.63),('8902','2014-04-20','09:05:00',1.64),('8902','2014-04-20','09:10:00',1.71),('8902','2014-04-20','09:15:00',1.82),('8902','2014-04-20','09:20:00',2.39),('8902','2014-04-20','09:25:00',1.88),('8902','2014-04-20','09:40:00',1.36),('8902','2014-04-20','09:45:00',1.63),('8902','2014-04-20','09:50:00',1.75),('8902','2014-04-20','09:55:00',2.03),('8902','2014-04-20','10:00:00',2.88),('8902','2014-04-20','10:05:00',4.46),('8902','2014-04-20','10:10:00',6.53),('8902','2014-04-20','10:15:00',6.23),('8902','2014-04-20','10:20:00',6.08),('8902','2014-04-20','10:25:00',6.14),('8902','2014-04-20','10:30:00',6.17),('8902','2014-04-20','10:35:00',6.2),('8902','2014-04-20','10:40:00',6.34),('8902','2014-04-20','10:45:00',6.41),('8902','2014-04-20','10:50:00',6.5),('8902','2014-04-20','10:55:00',6.58),('8902','2014-04-20','11:00:00',6.66),('8902','2014-04-20','11:05:00',6.75),('8902','2014-04-20','11:10:00',6.85),('8902','2014-04-20','11:15:00',6.89),('8902','2014-04-20','11:20:00',6.97),('8902','2014-04-20','11:25:00',7.06),('8902','2014-04-20','11:30:00',7.11),('8902','2014-04-20','11:35:00',7.22),('8902','2014-04-20','11:40:00',7.31),('8902','2014-04-20','11:45:00',7.38),('8902','2014-04-20','11:50:00',7.42),('8902','2014-04-20','11:55:00',7.42),('8902','2014-04-20','12:00:00',7.51),('8902','2014-04-20','12:05:00',7.57),('8902','2014-04-20','12:10:00',7.65),('8902','2014-04-20','12:15:00',7.71),('8902','2014-04-20','12:20:00',7.77),('8902','2014-04-20','12:25:00',7.81),('8902','2014-04-20','12:30:00',7.86),('8902','2014-04-20','12:35:00',7.89),('8902','2014-04-20','12:40:00',7.9),('8902','2014-04-20','12:45:00',7.96),('8902','2014-04-20','12:50:00',7.97),('8902','2014-04-20','12:55:00',7.98),('8902','2014-04-20','13:00:00',7.97),('8902','2014-04-20','13:05:00',8),('8902','2014-04-20','13:10:00',8.08),('8902','2014-04-20','13:15:00',8.03),('8902','2014-04-20','13:20:00',8.05),('8902','2014-04-20','13:25:00',8.03),('8902','2014-04-20','13:30:00',8.06),('8902','2014-04-20','13:35:00',8.04),('8902','2014-04-20','13:40:00',8.01),('8902','2014-04-20','13:45:00',8.09),('8902','2014-04-20','13:50:00',8.14),('8902','2014-04-20','13:55:00',8.16),('8902','2014-04-20','14:00:00',8.12),('8902','2014-04-20','14:05:00',8.2),('8902','2014-04-20','14:10:00',8.15),('8902','2014-04-20','14:15:00',8.1),('8902','2014-04-20','14:20:00',8.04),('8902','2014-04-20','14:25:00',8.01),('8902','2014-04-20','14:30:00',7.97),('8902','2014-04-20','14:35:00',7.94),('8902','2014-04-20','14:40:00',7.83),('8902','2014-04-20','14:45:00',7.75),('8902','2014-04-20','14:50:00',7.71),('8902','2014-04-20','14:55:00',7.71),('8902','2014-04-20','15:00:00',7.67),('8902','2014-04-20','15:05:00',7.63),('8902','2014-04-20','15:10:00',7.47),('8902','2014-04-20','15:15:00',7.38),('8902','2014-04-20','15:20:00',7.28),('8902','2014-04-20','15:25:00',7.17),('8902','2014-04-20','15:30:00',7.09),('8902','2014-04-20','15:35:00',6.99),('8902','2014-04-20','15:40:00',6.86),('8902','2014-04-20','15:45:00',6.77),('8902','2014-04-20','15:50:00',6.67),('8902','2014-04-20','15:55:00',6.58),('8902','2014-04-20','16:00:00',6.53),('8902','2014-04-20','16:05:00',6.39),('8902','2014-04-20','16:10:00',6.13),('8902','2014-04-20','16:15:00',4.77),('8902','2014-04-20','16:20:00',6.21),('8902','2014-04-20','16:25:00',5.87),('8902','2014-04-20','16:30:00',5.62),('8902','2014-04-20','16:35:00',5.64),('8902','2014-04-20','16:40:00',5.55),('8902','2014-04-20','16:45:00',5.31),('8902','2014-04-20','16:50:00',5.21),('8902','2014-04-20','16:55:00',5.09),('8902','2014-04-20','17:00:00',4.91),('8902','2014-04-20','17:05:00',4.73),('8902','2014-04-20','17:10:00',4.58),('8902','2014-04-20','17:15:00',4.44),('8902','2014-04-20','17:20:00',4.3),('8902','2014-04-20','17:25:00',4.14),('8902','2014-04-20','17:30:00',3.96),('8902','2014-04-20','17:35:00',3.77),('8902','2014-04-20','17:40:00',3.41),('8902','2014-04-20','17:45:00',3.4),('8902','2014-04-20','17:50:00',3.24),('8902','2014-04-20','17:55:00',3.02),('8902','2014-04-20','18:00:00',2.85),('8902','2014-04-20','18:05:00',2.61),('8902','2014-04-20','18:10:00',2.42),('8902','2014-04-20','18:15:00',2.21),('8902','2014-04-20','18:20:00',1.98),('8902','2014-04-20','18:25:00',1.83),('8902','2014-04-20','18:30:00',1.64),('8902','2014-04-20','18:35:00',1.45),('8902','2014-04-20','18:40:00',1.26),('8902','2014-04-20','18:45:00',1.13),('8902','2013-12-03','08:15:00',1.07),('8902','2013-12-03','08:20:00',1.19),('8902','2013-12-03','08:25:00',1.41),('8902','2013-12-03','08:30:00',1.76),('8902','2013-12-03','08:35:00',1.97),('8902','2013-12-03','08:40:00',2.14),('8902','2013-12-03','08:45:00',2.31),('8902','2013-12-03','08:50:00',2.5),('8902','2013-12-03','08:55:00',2.69),('8902','2013-12-03','09:00:00',2.88),('8902','2013-12-03','09:05:00',3.06),('8902','2013-12-03','09:10:00',3.22),('8902','2013-12-03','09:15:00',3.37),('8902','2013-12-03','09:20:00',3.51),('8902','2013-12-03','09:25:00',3.64),('8902','2013-12-03','09:30:00',3.79),('8902','2013-12-03','09:35:00',3.92),('8902','2013-12-03','09:40:00',4.07),('8902','2013-12-03','09:45:00',4.2),('8902','2013-12-03','09:50:00',4.31),('8902','2013-12-03','09:55:00',4.43),('8902','2013-12-03','10:00:00',4.53),('8902','2013-12-03','10:05:00',4.63),('8902','2013-12-03','10:10:00',4.72),('8902','2013-12-03','10:15:00',4.81),('8902','2013-12-03','10:20:00',4.9),('8902','2013-12-03','10:25:00',5.01),('8902','2013-12-03','10:30:00',5.11),('8902','2013-12-03','10:35:00',5.18),('8902','2013-12-03','10:40:00',5.26),('8902','2013-12-03','10:45:00',5.33),('8902','2013-12-03','10:50:00',5.39),('8902','2013-12-03','10:55:00',5.44),('8902','2013-12-03','11:00:00',5.5),('8902','2013-12-03','11:05:00',5.53),('8902','2013-12-03','11:10:00',5.57),('8902','2013-12-03','11:15:00',5.6),('8902','2013-12-03','11:20:00',5.64),('8902','2013-12-03','11:25:00',5.67),('8902','2013-12-03','11:30:00',5.7),('8902','2013-12-03','11:35:00',5.73),('8902','2013-12-03','11:40:00',5.73),('8902','2013-12-03','11:45:00',5.77),('8902','2013-12-03','11:50:00',5.77),('8902','2013-12-03','11:55:00',5.78),('8902','2013-12-03','12:00:00',5.8),('8902','2013-12-03','12:05:00',5.78),('8902','2013-12-03','12:10:00',5.81),('8902','2013-12-03','12:15:00',5.77),('8902','2013-12-03','12:20:00',5.75),('8902','2013-12-03','12:25:00',5.74),('8902','2013-12-03','12:30:00',5.74),('8902','2013-12-03','12:35:00',5.69),('8902','2013-12-03','12:40:00',5.63),('8902','2013-12-03','12:45:00',5.66),('8902','2013-12-03','12:50:00',5.61),('8902','2013-12-03','12:55:00',5.58),('8902','2013-12-03','13:00:00',5.53),('8902','2013-12-03','13:05:00',5.49),('8902','2013-12-03','13:10:00',5.44),('8902','2013-12-03','13:15:00',5.37),('8902','2013-12-03','13:20:00',5.31),('8902','2013-12-03','13:25:00',5.22),('8902','2013-12-03','13:30:00',5.17),('8902','2013-12-03','13:35:00',5.11),('8902','2013-12-03','13:40:00',5.03),('8902','2013-12-03','13:45:00',4.95),('8902','2013-12-03','13:50:00',4.86),('8902','2013-12-03','13:55:00',4.76),('8902','2013-12-03','14:00:00',4.7),('8902','2013-12-03','14:05:00',4.59),('8902','2013-12-03','14:10:00',4.5),('8902','2013-12-03','14:15:00',4.39),('8902','2013-12-03','14:20:00',4.28),('8902','2013-12-03','14:25:00',4.13),('8902','2013-12-03','14:30:00',4.01),('8902','2013-12-03','14:35:00',3.9),('8902','2013-12-03','14:40:00',3.84),('8902','2013-12-03','14:45:00',3.71),('8902','2013-12-03','14:50:00',3.55),('8902','2013-12-03','14:55:00',3.38),('8902','2013-12-03','15:00:00',3.22),('8902','2013-12-03','15:05:00',3.01),('8902','2013-12-03','15:10:00',2.84),('8902','2013-12-03','15:15:00',2.68),('8902','2013-12-03','15:20:00',2.5),('8902','2013-12-03','15:25:00',2.32),('8902','2013-12-03','15:30:00',2.13),('8902','2013-12-03','15:35:00',1.95),('8902','2013-12-03','15:40:00',1.78),('8902','2013-12-03','15:45:00',1.59),('8902','2013-12-03','15:50:00',1.41),('8902','2013-12-03','15:55:00',1.23),('8902','2013-12-03','16:00:00',1.02),('8902','2013-12-02','09:10:00',1.31),('8902','2013-12-02','09:15:00',1.72),('8902','2013-12-02','09:20:00',1.89),('8902','2013-12-02','09:25:00',2.1),('8902','2013-12-02','09:30:00',2.52),('8902','2013-12-02','09:35:00',2.6),('8902','2013-12-02','09:40:00',3.15),('8902','2013-12-02','09:45:00',3.29),('8902','2013-12-02','09:50:00',3.53),('8902','2013-12-02','09:55:00',3.34),('8902','2013-12-02','10:00:00',4.53),('8902','2013-12-02','10:05:00',4.61),('8902','2013-12-02','10:10:00',4.71),('8902','2013-12-02','10:15:00',4.81),('8902','2013-12-02','10:20:00',4.86),('8902','2013-12-02','10:25:00',4.97),('8902','2013-12-02','10:30:00',5.05),('8902','2013-12-02','10:35:00',5.12),('8902','2013-12-02','10:40:00',5.19),('8902','2013-12-02','10:45:00',5.24),('8902','2013-12-02','10:50:00',5.33),('8902','2013-12-02','10:55:00',5.46),('8902','2013-12-02','11:00:00',5.55),('8902','2013-12-02','11:05:00',5.61),('8902','2013-12-02','11:10:00',5.67),('8902','2013-12-02','11:15:00',5.73),('8902','2013-12-02','11:20:00',5.75),('8902','2013-12-02','11:25:00',5.75),('8902','2013-12-02','11:30:00',5.76),('8902','2013-12-02','11:35:00',5.8),('8902','2013-12-02','11:40:00',5.82),('8902','2013-12-02','11:45:00',5.84),('8902','2013-12-02','11:50:00',5.89),('8902','2013-12-02','11:55:00',5.91),('8902','2013-12-02','12:00:00',5.93),('8902','2013-12-02','12:05:00',5.95),('8902','2013-12-02','12:10:00',5.97),('8902','2013-12-02','12:15:00',6.02),('8902','2013-12-02','12:20:00',6.04),('8902','2013-12-02','12:25:00',6.09),('8902','2013-12-02','12:30:00',6.14),('8902','2013-12-02','12:35:00',6.17),('8902','2013-12-02','12:40:00',6.24),('8902','2013-12-02','12:45:00',6.33),('8902','2013-12-02','12:50:00',6.51),('8902','2013-12-02','12:55:00',6.68),('8902','2013-12-02','13:00:00',6.79),('8902','2013-12-02','13:05:00',6.87),('8902','2013-12-02','13:10:00',6.87),('8902','2013-12-02','13:15:00',6.61),('8902','2013-12-02','13:20:00',6.52),('8902','2013-12-02','13:25:00',6.32),('8902','2013-12-02','13:30:00',5.85),('8902','2013-12-02','13:35:00',6),('8902','2013-12-02','13:40:00',5.8),('8902','2013-12-02','13:45:00',5.5),('8902','2013-12-02','13:50:00',5.28),('8902','2013-12-02','13:55:00',5.17),('8902','2013-12-02','14:00:00',5.03),('8902','2013-12-02','14:05:00',4.77),('8902','2013-12-02','14:10:00',4.62),('8902','2013-12-02','14:15:00',4.34),('8902','2013-12-02','14:20:00',3.74),('8902','2013-12-02','14:25:00',3.44),('8902','2013-12-02','14:30:00',3.8),('8902','2013-12-02','14:35:00',3.89),('8902','2013-12-02','14:40:00',3.77),('8902','2013-12-02','14:45:00',3.61),('8902','2013-12-02','14:50:00',3.45),('8902','2013-12-02','14:55:00',3.25),('8902','2013-12-02','15:00:00',3.09),('8902','2013-12-02','15:05:00',2.94),('8902','2013-12-02','15:10:00',2.78),('8902','2013-12-02','15:15:00',2.61),('8902','2013-12-02','15:20:00',2.45),('8902','2013-12-02','15:25:00',2.23),('8902','2013-12-02','15:30:00',2.05),('8902','2013-12-02','15:35:00',1.85),('8902','2013-12-02','15:40:00',1.66),('8902','2013-12-02','15:45:00',1.46),('8902','2013-12-02','15:50:00',1.28),('8902','2013-12-02','15:55:00',1.1),('8902','2013-12-01','13:40:00',1.12),('8902','2013-12-01','13:45:00',1.13),('8902','2013-12-01','13:50:00',1.11),('8902','2013-12-01','13:55:00',1.23),('8902','2013-12-01','14:00:00',1.2),('8902','2013-12-01','14:05:00',1.11),('8902','2013-11-30','11:00:00',1.01),('8902','2013-11-30','11:05:00',1.11),('8902','2013-11-30','11:10:00',1.07),('8902','2013-11-30','11:25:00',1.16),('8902','2013-11-30','11:30:00',1.57),('8902','2013-11-30','11:35:00',1.98),('8902','2013-11-30','11:40:00',1.93),('8902','2013-11-30','11:45:00',1.52),('8902','2013-11-30','11:50:00',1.57),('8902','2013-11-30','11:55:00',2.34),('8902','2013-11-30','12:00:00',2.07),('8902','2013-11-30','12:05:00',2.52),('8902','2013-11-30','12:10:00',3.09),('8902','2013-11-30','12:15:00',2.18),('8902','2013-11-30','12:20:00',1.14),('8902','2013-11-30','12:45:00',1.34),('8902','2013-11-30','12:50:00',1.38),('8902','2013-11-30','12:55:00',1.36),('8902','2013-11-30','13:00:00',1.38),('8902','2013-11-30','13:05:00',1.13),('8902','2013-11-30','14:05:00',1.09),('8902','2013-11-30','14:10:00',1.03),('8902','2013-11-29','08:50:00',1.06),('8902','2013-11-29','08:55:00',1.48),('8902','2013-11-29','09:00:00',1.48),('8902','2013-11-29','09:05:00',1.82),('8902','2013-11-29','09:10:00',2.91),('8902','2013-11-29','09:15:00',3.35),('8902','2013-11-29','09:20:00',3.64),('8902','2013-11-29','09:25:00',3.66),('8902','2013-11-29','09:30:00',3.71),('8902','2013-11-29','09:35:00',4.53),('8902','2013-11-29','09:40:00',4.26),('8902','2013-11-29','09:45:00',3.78),('8902','2013-11-29','09:50:00',2.82),('8902','2013-11-29','09:55:00',2.44),('8902','2013-11-29','10:00:00',2.39),('8902','2013-11-29','10:05:00',2.06),('8902','2013-11-29','10:10:00',1.94),('8902','2013-11-29','10:15:00',2.12),('8902','2013-11-29','10:20:00',2.3),('8902','2013-11-29','10:25:00',2.24),('8902','2013-11-29','10:30:00',2.34),('8902','2013-11-29','10:35:00',2.51),('8902','2013-11-29','10:40:00',2.74),('8902','2013-11-29','10:45:00',2.78),('8902','2013-11-29','10:50:00',2.83),('8902','2013-11-29','10:55:00',2.25),('8902','2013-11-29','11:00:00',2.12),('8902','2013-11-29','11:05:00',2.55),('8902','2013-11-29','11:10:00',2.69),('8902','2013-11-29','11:15:00',2.74),('8902','2013-11-29','11:20:00',2.38),('8902','2013-11-29','11:25:00',2.42),('8902','2013-11-29','11:30:00',2.19),('8902','2013-11-29','11:35:00',2.03),('8902','2013-11-29','11:40:00',1.92),('8902','2013-11-29','11:45:00',1.74),('8902','2013-11-29','11:50:00',1.66),('8902','2013-11-29','11:55:00',1.47),('8902','2013-11-29','12:00:00',1.38),('8902','2013-11-29','12:05:00',1.33),('8902','2013-11-29','12:10:00',1.24),('8902','2013-11-29','12:15:00',1.2),('8902','2013-11-29','12:20:00',1.2),('8902','2013-11-29','12:25:00',1.28),('8902','2013-11-29','12:30:00',1.21),('8902','2013-11-29','12:35:00',1.14),('8902','2013-11-29','12:40:00',1.04),('8902','2013-11-29','13:40:00',1.07),('8902','2013-11-29','13:45:00',1.19),('8902','2013-11-29','13:50:00',1.47),('8902','2013-11-29','13:55:00',1.43),('8902','2013-11-29','14:00:00',1.22),('8902','2013-11-28','08:15:00',1.1),('8902','2013-11-28','08:20:00',1.24),('8902','2013-11-28','08:25:00',1.61),('8902','2013-11-28','08:30:00',1.84),('8902','2013-11-28','08:35:00',2.02),('8902','2013-11-28','08:40:00',2.2),('8902','2013-11-28','08:45:00',2.37),('8902','2013-11-28','08:50:00',2.56),('8902','2013-11-28','08:55:00',2.73),('8902','2013-11-28','09:00:00',2.92),('8902','2013-11-28','09:05:00',3.09),('8902','2013-11-28','09:10:00',3.25),('8902','2013-11-28','09:15:00',3.4),('8902','2013-11-28','09:20:00',3.55),('8902','2013-11-28','09:25:00',3.7),('8902','2013-11-28','09:30:00',3.83),('8902','2013-11-28','09:35:00',3.97),('8902','2013-11-28','09:40:00',4.12),('8902','2013-11-28','09:45:00',4.25),('8902','2013-11-28','09:50:00',4.37),('8902','2013-11-28','09:55:00',4.5),('8902','2013-11-28','10:00:00',4.61),('8902','2013-11-28','10:05:00',4.71),('8902','2013-11-28','10:10:00',4.81),('8902','2013-11-28','10:15:00',4.9),('8902','2013-11-28','10:20:00',5),('8902','2013-11-28','10:25:00',5.08),('8902','2013-11-28','10:30:00',5.17),('8902','2013-11-28','10:35:00',5.25),('8902','2013-11-28','10:40:00',5.34),('8902','2013-11-28','10:45:00',5.4),('8902','2013-11-28','10:50:00',5.48),('8902','2013-11-28','10:55:00',5.55),('8902','2013-11-28','11:00:00',5.6),('8902','2013-11-28','11:05:00',5.66),('8902','2013-11-28','11:10:00',5.72),('8902','2013-11-28','11:15:00',5.78),('8902','2013-11-28','11:20:00',5.81),('8902','2013-11-28','11:25:00',5.86),('8902','2013-11-28','11:30:00',5.88),('8902','2013-11-28','11:35:00',5.91),('8902','2013-11-28','11:40:00',5.94),('8902','2013-11-28','11:45:00',5.95),('8902','2013-11-28','11:50:00',5.95),('8902','2013-11-28','11:55:00',5.99),('8902','2013-11-28','12:00:00',5.98),('8902','2013-11-28','12:05:00',5.97),('8902','2013-11-28','12:10:00',5.99),('8902','2013-11-28','12:15:00',5.97),('8902','2013-11-28','12:20:00',5.95),('8902','2013-11-28','12:25:00',5.93),('8902','2013-11-28','12:30:00',5.89),('8902','2013-11-28','12:35:00',5.89),('8902','2013-11-28','12:40:00',5.88),('8902','2013-11-28','12:45:00',5.84),('8902','2013-11-28','12:50:00',5.78),('8902','2013-11-28','12:55:00',5.76),('8902','2013-11-28','13:00:00',5.72),('8902','2013-11-28','13:05:00',5.64),('8902','2013-11-28','13:10:00',5.57),('8902','2013-11-28','13:15:00',5.52),('8902','2013-11-28','13:20:00',5.45),('8902','2013-11-28','13:25:00',5.35),('8902','2013-11-28','13:30:00',5.27),('8902','2013-11-28','13:35:00',5.22),('8902','2013-11-28','13:40:00',5.14),('8902','2013-11-28','13:45:00',5.04),('8902','2013-11-28','13:50:00',4.93),('8902','2013-11-28','13:55:00',4.84),('8902','2013-11-28','14:00:00',4.74),('8902','2013-11-28','14:05:00',4.64),('8902','2013-11-28','14:10:00',4.54),('8902','2013-11-28','14:15:00',4.43),('8902','2013-11-28','14:20:00',4.29),('8902','2013-11-28','14:25:00',4.16),('8902','2013-11-28','14:30:00',4.05),('8902','2013-11-28','14:35:00',3.91),('8902','2013-11-28','14:40:00',3.76),('8902','2013-11-28','14:45:00',3.62),('8902','2013-11-28','14:50:00',3.47),('8902','2013-11-28','14:55:00',3.28),('8902','2013-11-28','15:00:00',3.12),('8902','2013-11-28','15:05:00',2.96),('8902','2013-11-28','15:10:00',2.78),('8902','2013-11-28','15:15:00',2.64),('8902','2013-11-28','15:20:00',2.46),('8902','2013-11-28','15:25:00',2.28),('8902','2013-11-28','15:30:00',2.1),('8902','2013-11-28','15:35:00',1.91),('8902','2013-11-28','15:40:00',1.71),('8902','2013-11-28','15:45:00',1.51),('8902','2013-11-28','15:50:00',1.34),('8902','2013-11-28','15:55:00',1.15),('8902','2013-11-27','09:20:00',1.01),('8902','2013-11-27','09:25:00',1.16),('8902','2013-11-27','09:30:00',1.34),('8902','2013-11-27','09:35:00',1.48),('8902','2013-11-27','09:40:00',1.76),('8902','2013-11-27','09:45:00',1.88),('8902','2013-11-27','09:50:00',1.9),('8902','2013-11-27','09:55:00',1.81),('8902','2013-11-27','10:00:00',1.46),('8902','2013-11-27','10:05:00',1.21),('8902','2013-11-27','11:20:00',1.21),('8902','2013-11-27','11:25:00',1.27),('8902','2013-11-27','12:25:00',1.01),('8902','2013-11-27','12:30:00',1.09),('8902','2013-11-27','12:35:00',1.07),('8902','2013-11-27','12:40:00',1.21),('8902','2013-11-27','12:45:00',1.37),('8902','2013-11-27','12:50:00',1.65),('8902','2013-11-27','12:55:00',2.03),('8902','2013-11-27','13:00:00',1.68),('8902','2013-11-27','13:25:00',1.67),('8902','2013-11-27','13:30:00',1.59),('8902','2013-11-27','13:35:00',1.71),('8902','2013-11-27','13:40:00',1.65),('8902','2013-11-27','13:45:00',1.38),('8902','2013-11-27','13:50:00',1.43),('8902','2013-11-27','14:10:00',1.47),('8902','2013-11-27','14:15:00',1.17),('8902','2014-04-19','07:50:00',1.31),('8902','2014-04-19','07:55:00',1.57),('8902','2014-04-19','08:00:00',1.64),('8902','2014-04-19','08:05:00',1.71),('8902','2014-04-19','08:10:00',1.9),('8902','2014-04-19','08:15:00',2.15),('8902','2014-04-19','08:20:00',2.53),('8902','2014-04-19','08:25:00',3.41),('8902','2014-04-19','08:30:00',4.12),('8902','2014-04-19','08:35:00',3.91),('8902','2014-04-19','08:40:00',4),('8902','2014-04-19','08:45:00',3.08),('8902','2014-04-19','08:50:00',3.03),('8902','2014-04-19','08:55:00',1.6),('8902','2014-04-19','09:00:00',2.82),('8902','2014-04-19','09:05:00',1.39),('8902','2014-04-19','09:10:00',2.77),('8902','2014-04-19','09:15:00',4.47),('8902','2014-04-19','09:20:00',4.9),('8902','2014-04-19','09:25:00',5.17),('8902','2014-04-19','09:30:00',5.9),('8902','2014-04-19','09:35:00',4.8),('8902','2014-04-19','09:40:00',3.56),('8902','2014-04-19','09:45:00',2.67),('8902','2014-04-19','09:50:00',2.81),('8902','2014-04-19','09:55:00',3.43),('8902','2014-04-19','10:00:00',4.2),('8902','2014-04-19','10:05:00',5.31),('8902','2014-04-19','10:10:00',4.96),('8902','2014-04-19','10:15:00',5.96),('8902','2014-04-19','10:20:00',5.78),('8902','2014-04-19','10:25:00',4.95),('8902','2014-04-19','10:30:00',4.69),('8902','2014-04-19','10:35:00',5.05),('8902','2014-04-19','10:40:00',4.97),('8902','2014-04-19','10:45:00',4.97),('8902','2014-04-19','10:50:00',5.42),('8902','2014-04-19','10:55:00',5.54),('8902','2014-04-19','11:00:00',5.08),('8902','2014-04-19','11:05:00',6.43),('8902','2014-04-19','11:10:00',5.88),('8902','2014-04-19','11:15:00',6.53),('8902','2014-04-19','11:20:00',7.08),('8902','2014-04-19','11:25:00',7.1),('8902','2014-04-19','11:30:00',7.45),('8902','2014-04-19','11:35:00',7.57),('8902','2014-04-19','11:40:00',3.59),('8902','2014-04-19','11:45:00',6.68),('8902','2014-04-19','11:50:00',6.2),('8902','2014-04-19','11:55:00',4.22),('8902','2014-04-19','12:00:00',5.6),('8902','2014-04-19','12:05:00',8.65),('8902','2014-04-19','12:10:00',6.97),('8902','2014-04-19','12:15:00',6.21),('8902','2014-04-19','12:20:00',4.37),('8902','2014-04-19','12:25:00',9.26),('8902','2014-04-19','12:30:00',8.51),('8902','2014-04-19','12:35:00',8.23),('8902','2014-04-19','12:40:00',8.27),('8902','2014-04-19','12:45:00',8.44),('8902','2014-04-19','12:50:00',8.53),('8902','2014-04-19','12:55:00',8.58),('8902','2014-04-19','13:00:00',8.63),('8902','2014-04-19','13:05:00',8.67),('8902','2014-04-19','13:10:00',8.75),('8902','2014-04-19','13:15:00',8.77),('8902','2014-04-19','13:20:00',8.51),('8902','2014-04-19','13:25:00',8.56),('8902','2014-04-19','13:30:00',8.59),('8902','2014-04-19','13:35:00',8.57),('8902','2014-04-19','13:40:00',8.59),('8902','2014-04-19','13:45:00',8.57),('8902','2014-04-19','13:50:00',8.53),('8902','2014-04-19','13:55:00',8.49),('8902','2014-04-19','14:00:00',8.44),('8902','2014-04-19','14:05:00',8.48),('8902','2014-04-19','14:10:00',8.46),('8902','2014-04-19','14:15:00',8.7),('8902','2014-04-19','14:20:00',7.03),('8902','2014-04-19','14:25:00',6.38),('8902','2014-04-19','14:30:00',6.18),('8902','2014-04-19','14:35:00',4.87),('8902','2014-04-19','14:40:00',4.8),('8902','2014-04-19','14:45:00',5.17),('8902','2014-04-19','14:50:00',5),('8902','2014-04-19','14:55:00',5.63),('8902','2014-04-19','15:00:00',7.06),('8902','2014-04-19','15:05:00',7.5),('8902','2014-04-19','15:10:00',7.53),('8902','2014-04-19','15:15:00',7.8),('8902','2014-04-19','15:20:00',7.35),('8902','2014-04-19','15:25:00',7.49),('8902','2014-04-19','15:30:00',7.35),('8902','2014-04-19','15:35:00',7.19),('8902','2014-04-19','15:40:00',7.34),('8902','2014-04-19','15:45:00',6.43),('8902','2014-04-19','15:50:00',4.8),('8902','2014-04-19','15:55:00',7.12),('8902','2014-04-19','16:00:00',6.84),('8902','2014-04-19','16:05:00',6.75),('8902','2014-04-19','16:10:00',6.64),('8902','2014-04-19','16:15:00',6.58),('8902','2014-04-19','16:20:00',6.61),('8902','2014-04-19','16:25:00',5.3),('8902','2014-04-19','16:30:00',6.45),('8902','2014-04-19','16:35:00',5.99),('8902','2014-04-19','16:40:00',6.12),('8902','2014-04-19','16:45:00',5.13),('8902','2014-04-19','16:50:00',5.39),('8902','2014-04-19','16:55:00',5.56),('8902','2014-04-19','17:00:00',5.27),('8902','2014-04-19','17:05:00',4.99),('8902','2014-04-19','17:10:00',4.72),('8902','2014-04-19','17:15:00',4.51),('8902','2014-04-19','17:20:00',4.36),('8902','2014-04-19','17:25:00',4.18),('8902','2014-04-19','17:30:00',3.98),('8902','2014-04-19','17:35:00',3.79),('8902','2014-04-19','17:40:00',3.57),('8902','2014-04-19','17:45:00',3.39),('8902','2014-04-19','17:50:00',3.21),('8902','2014-04-19','17:55:00',2.99),('8902','2014-04-19','18:00:00',2.82),('8902','2014-04-19','18:05:00',2.59),('8902','2014-04-19','18:10:00',2.42),('8902','2014-04-19','18:15:00',2.13),('8902','2014-04-19','18:20:00',1.48),('8902','2014-04-19','18:25:00',1),('8902','2014-04-19','18:30:00',1.58),('8902','2014-04-19','18:35:00',1.55),('8902','2014-04-19','18:40:00',1.26),('8902','2013-11-26','08:40:00',1.01),('8902','2013-11-26','08:45:00',1.19),('8902','2013-11-26','08:50:00',1.43),('8902','2013-11-26','08:55:00',1.51),('8902','2013-11-26','09:00:00',1.37),('8902','2013-11-26','09:05:00',1.26),('8902','2013-11-26','09:10:00',1.19),('8902','2013-11-26','09:15:00',1.22),('8902','2013-11-26','09:20:00',1.91),('8902','2013-11-26','09:25:00',2.06),('8902','2013-11-26','09:30:00',1.87),('8902','2013-11-26','09:35:00',1.84),('8902','2013-11-26','09:40:00',2.29),('8902','2013-11-26','09:45:00',1.82),('8902','2013-11-26','09:50:00',1.96),('8902','2013-11-26','09:55:00',2.74),('8902','2013-11-26','10:00:00',2.36),('8902','2013-11-26','10:05:00',2.41),('8902','2013-11-26','10:10:00',2.34),('8902','2013-11-26','10:15:00',2.27),('8902','2013-11-26','10:20:00',2.21),('8902','2013-11-26','10:25:00',2.29),('8902','2013-11-26','10:30:00',2.08),('8902','2013-11-26','10:35:00',2.25),('8902','2013-11-26','10:40:00',2.56),('8902','2013-11-26','10:45:00',3.01),('8902','2013-11-26','10:50:00',2.76),('8902','2013-11-26','10:55:00',2.52),('8902','2013-11-26','11:00:00',2.74),('8902','2013-11-26','11:05:00',3.04),('8902','2013-11-26','11:10:00',4.42),('8902','2013-11-26','11:15:00',2.8),('8902','2013-11-26','11:20:00',2.67),('8902','2013-11-26','11:25:00',2.88),('8902','2013-11-26','11:30:00',5.05),('8902','2013-11-26','11:35:00',3.87),('8902','2013-11-26','11:40:00',3.37),('8902','2013-11-26','11:45:00',3.07),('8902','2013-11-26','11:50:00',4.37),('8902','2013-11-26','11:55:00',6.9),('8902','2013-11-26','12:00:00',6.64),('8902','2013-11-26','12:05:00',5.73),('8902','2013-11-26','12:10:00',2.79),('8902','2013-11-26','12:15:00',4.28),('8902','2013-11-26','12:20:00',4.43),('8902','2013-11-26','12:25:00',2.72),('8902','2013-11-26','12:30:00',5.68),('8902','2013-11-26','12:35:00',4.15),('8902','2013-11-26','12:40:00',2.42),('8902','2013-11-26','12:45:00',1.91),('8902','2013-11-26','12:50:00',1.89),('8902','2013-11-26','12:55:00',1.91),('8902','2013-11-26','13:00:00',1.98),('8902','2013-11-26','13:05:00',1.98),('8902','2013-11-26','13:10:00',1.97),('8902','2013-11-26','13:15:00',1.9),('8902','2013-11-26','13:20:00',1.82),('8902','2013-11-26','13:25:00',1.76),('8902','2013-11-26','13:30:00',1.83),('8902','2013-11-26','13:35:00',1.84),('8902','2013-11-26','13:40:00',2.06),('8902','2013-11-26','13:45:00',1.92),('8902','2013-11-26','13:50:00',1.48),('8902','2013-11-26','13:55:00',1.25),('8902','2013-11-26','14:00:00',1.31),('8902','2013-11-26','14:05:00',1.12),('8902','2013-11-25','08:05:00',1.18),('8902','2013-11-25','08:10:00',1.44),('8902','2013-11-25','08:15:00',1.41),('8902','2013-11-25','08:20:00',1.16),('8902','2013-11-25','08:45:00',1.44),('8902','2013-11-25','08:50:00',1.43),('8902','2013-11-25','08:55:00',1.61),('8902','2013-11-25','09:00:00',1.62),('8902','2013-11-25','09:05:00',2.02),('8902','2013-11-25','09:10:00',2.4),('8902','2013-11-25','09:15:00',2.85),('8902','2013-11-25','09:20:00',2.68),('8902','2013-11-25','09:25:00',2.6),('8902','2013-11-25','09:30:00',2.36),('8902','2013-11-25','09:35:00',2.64),('8902','2013-11-25','09:40:00',4.05),('8902','2013-11-25','09:45:00',2.92),('8902','2013-11-25','09:50:00',3.02),('8902','2013-11-25','09:55:00',3.95),('8902','2013-11-25','10:00:00',4.79),('8902','2013-11-25','10:05:00',4.58),('8902','2013-11-25','10:10:00',2.34),('8902','2013-11-25','10:15:00',1.75),('8902','2013-11-25','10:20:00',1.58),('8902','2013-11-25','10:25:00',3.75),('8902','2013-11-25','10:30:00',5.26),('8902','2013-11-25','10:35:00',5.82),('8902','2013-11-25','10:40:00',5.78),('8902','2013-11-25','10:45:00',5.9),('8902','2013-11-25','10:50:00',5.97),('8902','2013-11-25','10:55:00',6.09),('8902','2013-11-25','11:00:00',6.44),('8902','2013-11-25','11:05:00',5.76),('8902','2013-11-25','11:10:00',6.73),('8902','2013-11-25','11:15:00',7.2),('8902','2013-11-25','11:20:00',6.75),('8902','2013-11-25','11:25:00',6.86),('8902','2013-11-25','11:30:00',6.98),('8902','2013-11-25','11:35:00',7.28),('8902','2013-11-25','11:40:00',6.9),('8902','2013-11-25','11:45:00',6.7),('8902','2013-11-25','11:50:00',6.19),('8902','2013-11-25','11:55:00',3.25),('8902','2013-11-25','12:00:00',2.13),('8902','2013-11-25','12:05:00',3.28),('8902','2013-11-25','12:10:00',1.62),('8902','2013-11-25','12:15:00',2.35),('8902','2013-11-25','12:20:00',6.61),('8902','2013-11-25','12:25:00',6.51),('8902','2013-11-25','12:30:00',6.34),('8902','2013-11-25','12:35:00',6.33),('8902','2013-11-25','12:40:00',6.33),('8902','2013-11-25','12:45:00',6.25),('8902','2013-11-25','12:50:00',6.26),('8902','2013-11-25','12:55:00',6.23),('8902','2013-11-25','13:00:00',6.21),('8902','2013-11-25','13:05:00',6.17),('8902','2013-11-25','13:10:00',6.12),('8902','2013-11-25','13:15:00',6.08),('8902','2013-11-25','13:20:00',6),('8902','2013-11-25','13:25:00',5.91),('8902','2013-11-25','13:30:00',5.82),('8902','2013-11-25','13:35:00',5.75),('8902','2013-11-25','13:40:00',5.67),('8902','2013-11-25','13:45:00',5.62),('8902','2013-11-25','13:50:00',5.61),('8902','2013-11-25','13:55:00',5.54),('8902','2013-11-25','14:00:00',5.38),('8902','2013-11-25','14:05:00',3.79),('8902','2013-11-25','14:10:00',6.35),('8902','2013-11-25','14:15:00',6.54),('8902','2013-11-25','14:20:00',5.38),('8902','2013-11-25','14:25:00',3.53),('8902','2013-11-25','14:30:00',3.03),('8902','2013-11-25','14:35:00',3.99),('8902','2013-11-25','14:40:00',4.24),('8902','2013-11-25','14:45:00',4.37),('8902','2013-11-25','14:50:00',4.81),('8902','2013-11-25','14:55:00',4.91),('8902','2013-11-25','15:00:00',4.67),('8902','2013-11-25','15:05:00',4.21),('8902','2013-11-25','15:10:00',3.61),('8902','2013-11-25','15:15:00',3.32),('8902','2013-11-25','15:20:00',3.06),('8902','2013-11-25','15:25:00',2.84),('8902','2013-11-25','15:30:00',2.6),('8902','2013-11-25','15:35:00',2.4),('8902','2013-11-25','15:40:00',2.17),('8902','2013-11-25','15:45:00',1.97),('8902','2013-11-25','15:50:00',1.86),('8902','2013-11-25','15:55:00',1.6),('8902','2013-11-24','08:05:00',1.06),('8902','2013-11-24','08:10:00',1.19),('8902','2013-11-24','08:15:00',1.33),('8902','2013-11-24','08:20:00',1.76),('8902','2013-11-24','08:25:00',2.15),('8902','2013-11-24','08:30:00',2.31),('8902','2013-11-24','08:35:00',2.52),('8902','2013-11-24','08:40:00',2.68),('8902','2013-11-24','08:45:00',2.98),('8902','2013-11-24','08:50:00',3.27),('8902','2013-11-24','08:55:00',3.61),('8902','2013-11-24','09:00:00',4.02),('8902','2013-11-24','09:05:00',4.16),('8902','2013-11-24','09:10:00',4.26),('8902','2013-11-24','09:15:00',4.51),('8902','2013-11-24','09:20:00',4.6),('8902','2013-11-24','09:25:00',3.66),('8902','2013-11-24','09:30:00',3.76),('8902','2013-11-24','09:35:00',4.71),('8902','2013-11-24','09:40:00',5.06),('8902','2013-11-24','09:45:00',2.64),('8902','2013-11-24','09:50:00',3.32),('8902','2013-11-24','09:55:00',2.68),('8902','2013-11-24','10:00:00',3.57),('8902','2013-11-24','10:05:00',3.49),('8902','2013-11-24','10:10:00',3.76),('8902','2013-11-24','10:15:00',3.85),('8902','2013-11-24','10:20:00',3.33),('8902','2013-11-24','10:25:00',3.99),('8902','2013-11-24','10:30:00',4.13),('8902','2013-11-24','10:35:00',3.97),('8902','2013-11-24','10:40:00',6.9),('8902','2013-11-24','10:45:00',6.07),('8902','2013-11-24','10:50:00',6.03),('8902','2013-11-24','10:55:00',4.5),('8902','2013-11-24','11:00:00',5.98),('8902','2013-11-24','11:05:00',6.21),('8902','2013-11-24','11:10:00',7.03),('8902','2013-11-24','11:15:00',5.15),('8902','2013-11-24','11:20:00',3.67),('8902','2013-11-24','11:25:00',2.49),('8902','2013-11-24','11:30:00',2.81),('8902','2013-11-24','11:35:00',2.6),('8902','2013-11-24','11:40:00',2.34),('8902','2013-11-24','11:45:00',2.44),('8902','2013-11-24','11:50:00',2.74),('8902','2013-11-24','11:55:00',3.71),('8902','2013-11-24','12:00:00',3.31),('8902','2013-11-24','12:05:00',3.47),('8902','2013-11-24','12:10:00',3.62),('8902','2013-11-24','12:15:00',3.36),('8902','2013-11-24','12:20:00',3.05),('8902','2013-11-24','12:25:00',2.97),('8902','2013-11-24','12:30:00',2.65),('8902','2013-11-24','12:35:00',2.41),('8902','2013-11-24','12:40:00',5.61),('8902','2013-11-24','12:45:00',6.46),('8902','2013-11-24','12:50:00',5),('8902','2013-11-24','12:55:00',5.41),('8902','2013-11-24','13:00:00',7.05),('8902','2013-11-24','13:05:00',7.44),('8902','2013-11-24','13:10:00',5.37),('8902','2013-11-24','13:15:00',4.7),('8902','2013-11-24','13:20:00',5.17),('8902','2013-11-24','13:25:00',3.43),('8902','2013-11-24','13:30:00',2.37),('8902','2013-11-24','13:35:00',1.96),('8902','2013-11-24','13:40:00',1.81),('8902','2013-11-24','13:45:00',1.79),('8902','2013-11-24','13:50:00',1.63),('8902','2013-11-24','13:55:00',1.32),('8902','2013-11-24','14:00:00',1.06),('8902','2013-11-23','09:50:00',1.48),('8902','2013-11-23','09:55:00',2.12),('8902','2013-11-23','10:00:00',2.62),('8902','2013-11-23','10:05:00',2.83),('8902','2013-11-23','10:10:00',2.92),('8902','2013-11-23','10:15:00',2.49),('8902','2013-11-23','10:20:00',2.32),('8902','2013-11-23','10:25:00',3.28),('8902','2013-11-23','10:30:00',3.04),('8902','2013-11-23','10:35:00',2.63),('8902','2013-11-23','10:40:00',2.28),('8902','2013-11-23','10:45:00',2.04),('8902','2013-11-23','10:50:00',2.07),('8902','2013-11-23','10:55:00',2.2),('8902','2013-11-23','11:00:00',2.24),('8902','2013-11-23','11:05:00',2.31),('8902','2013-11-23','11:10:00',2.44),('8902','2013-11-23','11:15:00',2.51),('8902','2013-11-23','11:20:00',2.94),('8902','2013-11-23','11:25:00',2.95),('8902','2013-11-23','11:30:00',2.62),('8902','2013-11-23','11:35:00',2.33),('8902','2013-11-23','11:40:00',2.3),('8902','2013-11-23','11:45:00',2.18),('8902','2013-11-23','11:50:00',2.4),('8902','2013-11-23','11:55:00',2.02),('8902','2013-11-23','12:00:00',1.49),('8902','2013-11-23','12:05:00',1.14),('8902','2013-11-23','12:10:00',1.09),('8902','2013-11-23','12:15:00',1.39),('8902','2013-11-23','12:20:00',1.56),('8902','2013-11-23','12:25:00',1.67),('8902','2013-11-23','12:30:00',1.65),('8902','2013-11-23','12:35:00',1.71),('8902','2013-11-23','12:40:00',1.73),('8902','2013-11-23','12:45:00',1.71),('8902','2013-11-23','12:50:00',1.73),('8902','2013-11-23','12:55:00',1.85),('8902','2013-11-23','13:00:00',2.04),('8902','2013-11-23','13:05:00',2.39),('8902','2013-11-23','13:10:00',2.78),('8902','2013-11-23','13:15:00',2.93),('8902','2013-11-23','13:20:00',2.2),('8902','2013-11-23','13:25:00',1.75),('8902','2013-11-23','13:30:00',1.51),('8902','2013-11-23','13:35:00',1.47),('8902','2013-11-23','13:40:00',1.37),('8902','2013-11-23','13:45:00',1.25),('8902','2013-11-23','13:50:00',1.12),('8902','2013-11-23','13:55:00',1.05),('8902','2013-11-23','14:00:00',1.1),('8902','2013-11-23','14:05:00',1.14),('8902','2013-11-23','14:10:00',1.1),('8902','2013-11-23','14:15:00',1.09),('8902','2013-11-23','14:20:00',1.1),('8902','2013-11-23','14:25:00',1.11),('8902','2013-11-23','14:30:00',1.05),('8902','2013-11-22','08:20:00',1.11),('8902','2013-11-22','08:25:00',1.26),('8902','2013-11-22','08:35:00',1.05),('8902','2013-11-22','08:40:00',1.29),('8902','2013-11-22','08:45:00',1.1),('8902','2013-11-22','10:00:00',1.08),('8902','2013-11-22','10:05:00',1.25),('8902','2013-11-22','10:10:00',1.33),('8902','2013-11-22','10:15:00',2.26),('8902','2013-11-22','10:20:00',2.43),('8902','2013-11-22','10:25:00',2.43),('8902','2013-11-22','10:30:00',3.38),('8902','2013-11-22','10:35:00',1.98),('8902','2013-11-22','10:40:00',5.75),('8902','2013-11-22','10:45:00',1.34),('8902','2013-11-22','11:15:00',1.06),('8902','2013-11-22','11:20:00',1.19),('8902','2013-11-22','11:25:00',1.43),('8902','2013-11-22','11:30:00',1.32),('8902','2013-11-22','11:35:00',1.23),('8902','2013-11-22','11:40:00',1.42),('8902','2013-11-22','11:45:00',1.33),('8902','2013-11-22','13:15:00',1.01),('8902','2013-11-22','13:20:00',1.57),('8902','2013-11-22','13:25:00',3.05),('8902','2013-11-22','13:30:00',1.96),('8902','2013-11-22','13:35:00',2.48),('8902','2013-11-22','13:40:00',2.3),('8902','2013-11-22','13:45:00',1.82),('8902','2013-11-22','13:50:00',1.86),('8902','2013-11-22','13:55:00',1.85),('8902','2013-11-22','14:00:00',2.22),('8902','2013-11-22','14:05:00',2.9),('8902','2013-11-22','14:10:00',1.15),('8902','2013-11-22','14:50:00',1.37),('8902','2013-11-22','14:55:00',1.6),('8902','2013-11-22','15:00:00',1.34),('8902','2013-11-22','15:05:00',1.16),('8902','2013-11-22','15:15:00',1.05),('8902','2013-11-22','15:20:00',1.03),('8902','2013-11-21','09:20:00',1.11),('8902','2013-11-21','09:25:00',1.02),('8902','2013-11-21','10:00:00',1.11),('8902','2013-11-20','08:10:00',1.76),('8902','2013-11-20','08:15:00',2.12),('8902','2013-11-20','08:20:00',1.47),('8902','2013-11-20','09:05:00',1.06),('8902','2013-11-20','09:10:00',1.92),('8902','2013-11-20','09:15:00',2.07),('8902','2013-11-20','09:20:00',2.59),('8902','2013-11-20','09:25:00',2.16),('8902','2013-11-20','09:30:00',2.4),('8902','2013-11-20','09:35:00',1.88),('8902','2013-11-20','09:40:00',2.88),('8902','2013-11-20','09:45:00',4.61),('8902','2013-11-20','09:50:00',3.92),('8902','2013-11-20','09:55:00',3.52),('8902','2013-11-20','10:00:00',3.54),('8902','2013-11-20','10:05:00',5.37),('8902','2013-11-20','10:10:00',4.68),('8902','2013-11-20','10:15:00',5.21),('8902','2013-11-20','10:20:00',5.23),('8902','2013-11-20','10:25:00',3.62),('8902','2013-11-20','10:30:00',3.88),('8902','2013-11-20','10:35:00',4.94),('8902','2013-11-20','10:40:00',5.38),('8902','2013-11-20','10:45:00',4.98),('8902','2013-11-20','10:50:00',1.3),('8902','2013-11-20','10:55:00',1.14),('8902','2013-11-20','11:00:00',1.32),('8902','2013-11-20','11:05:00',1.34),('8902','2013-11-20','11:10:00',1.53),('8902','2013-11-20','11:15:00',1.92),('8902','2013-11-20','11:20:00',2.84),('8902','2013-11-20','11:25:00',3.08),('8902','2013-11-20','11:30:00',4.55),('8902','2013-11-20','11:35:00',5.29),('8902','2013-11-20','11:40:00',6.09),('8902','2013-11-20','11:45:00',2.41),('8902','2013-11-20','11:50:00',6.29),('8902','2013-11-20','11:55:00',5.72),('8902','2013-11-20','12:00:00',4.24),('8902','2013-11-20','12:05:00',4.86),('8902','2013-11-20','12:10:00',6.28),('8902','2013-11-20','12:15:00',6.22),('8902','2013-11-20','12:20:00',6.24),('8902','2013-11-20','12:25:00',6.32),('8902','2013-11-20','12:30:00',6.66),('8902','2013-11-20','12:35:00',6.68),('8902','2013-11-20','12:40:00',6.88),('8902','2013-11-20','12:45:00',6.89),('8902','2013-11-20','12:50:00',6.3),('8902','2013-11-20','12:55:00',6.85),('8902','2013-11-20','13:00:00',6.72),('8902','2013-11-20','13:05:00',6.79),('8902','2013-11-20','13:10:00',6.16),('8902','2013-11-20','13:15:00',6.27),('8902','2013-11-20','13:20:00',6.32),('8902','2013-11-20','13:25:00',5.7),('8902','2013-11-20','13:30:00',2.4),('8902','2013-11-20','13:35:00',2),('8902','2013-11-20','13:40:00',4.69),('8902','2013-11-20','13:45:00',5.82),('8902','2013-11-20','13:50:00',3.09),('8902','2013-11-20','13:55:00',2.99),('8902','2013-11-20','14:00:00',5.62),('8902','2013-11-20','14:05:00',4.16),('8902','2013-11-20','14:10:00',3.29),('8902','2013-11-20','14:15:00',1.58),('8902','2013-11-20','14:20:00',1.12),('8902','2013-11-20','14:25:00',2.43),('8902','2013-11-20','14:30:00',1.25),('8902','2013-11-20','14:40:00',2.51),('8902','2013-11-20','14:45:00',3.89),('8902','2013-11-20','14:50:00',3.76),('8902','2013-11-20','14:55:00',2.74),('8902','2013-11-20','15:00:00',3.38),('8902','2013-11-20','15:05:00',3.2),('8902','2013-11-20','15:10:00',3.03),('8902','2013-11-20','15:15:00',2.79),('8902','2013-11-20','15:20:00',2.41),('8902','2013-11-20','15:25:00',2.43),('8902','2013-11-20','15:30:00',1.38),('8902','2013-11-19','08:20:00',2.37),('8902','2013-11-19','08:55:00',1.81),('8902','2013-11-19','09:00:00',2.51),('8902','2013-11-19','09:15:00',3.48),('8902','2013-11-19','09:20:00',3.46),('8902','2013-11-19','09:25:00',4.07),('8902','2013-11-19','09:30:00',4.31),('8902','2013-11-19','09:35:00',2.72),('8902','2013-11-19','09:40:00',1.61),('8902','2013-11-19','09:55:00',1.12),('8902','2013-11-19','10:00:00',2.71),('8902','2013-11-19','10:05:00',2.08),('8902','2013-11-19','10:10:00',2.16),('8902','2013-11-19','10:15:00',3.68),('8902','2013-11-19','10:20:00',1.7),('8902','2013-11-19','10:25:00',1.4),('8902','2013-11-19','10:30:00',1.81),('8902','2013-11-19','10:35:00',1.48),('8902','2013-11-19','10:40:00',1.4),('8902','2013-11-19','10:45:00',1.05),('8902','2013-11-19','10:50:00',1.52),('8902','2013-11-19','10:55:00',1.64),('8902','2013-11-19','11:00:00',1.39),('8902','2013-11-19','11:05:00',1.37),('8902','2013-11-19','11:10:00',1.26),('8902','2013-11-19','11:15:00',1.17),('8902','2013-11-19','11:20:00',1.75),('8902','2013-11-19','11:25:00',2.24),('8902','2013-11-19','11:30:00',2.27),('8902','2013-11-19','11:35:00',1.91),('8902','2013-11-19','11:40:00',1.86),('8902','2013-11-19','11:45:00',6.02),('8902','2013-11-19','11:50:00',8.08),('8902','2013-11-19','11:55:00',4.4),('8902','2013-11-19','12:00:00',2.26),('8902','2013-11-19','12:15:00',1.75),('8902','2013-11-19','12:20:00',3.39),('8902','2013-11-19','12:25:00',2.09),('8902','2013-11-19','12:30:00',1.85),('8902','2013-11-19','12:35:00',1.27),('8902','2013-11-19','12:40:00',2.36),('8902','2013-11-19','12:45:00',2.35),('8902','2013-11-19','12:50:00',3.31),('8902','2013-11-19','12:55:00',4.78),('8902','2013-11-19','13:00:00',5.83),('8902','2013-11-19','13:05:00',4.38),('8902','2013-11-19','13:10:00',2.94),('8902','2013-11-19','13:15:00',1.35),('8902','2013-11-19','13:20:00',3.59),('8902','2013-11-19','13:25:00',2.83),('8902','2013-11-19','13:30:00',2.71),('8902','2013-11-19','13:35:00',1.13),('8902','2013-11-19','13:40:00',3.69),('8902','2013-11-19','13:45:00',2.25),('8902','2013-11-19','13:50:00',3.21),('8902','2013-11-19','13:55:00',2.9),('8902','2013-11-19','14:00:00',2.15),('8902','2013-11-19','14:05:00',1.92),('8902','2013-11-19','14:10:00',1.63),('8902','2013-11-19','14:15:00',1.36),('8902','2013-11-19','14:20:00',1.53),('8902','2013-11-19','14:25:00',2.29),('8902','2013-11-19','14:30:00',1.82),('8902','2013-11-19','14:35:00',1.54),('8902','2013-11-19','14:40:00',2.39),('8902','2013-11-19','14:45:00',3.47),('8902','2013-11-19','15:05:00',2.53),('8902','2013-11-19','15:10:00',3.26),('8902','2013-11-19','15:15:00',2.52),('8902','2013-11-19','15:20:00',2.22),('8902','2013-11-19','15:25:00',2.37),('8902','2013-11-19','15:30:00',1.1),('8902','2013-11-19','15:35:00',1.6),('8902','2013-11-18','08:30:00',1.02),('8902','2013-11-18','09:35:00',2.13),('8902','2013-11-18','09:40:00',4.28),('8902','2013-11-18','09:45:00',4.15),('8902','2013-11-18','09:50:00',2.8),('8902','2013-11-18','09:55:00',1.19),('8902','2013-11-18','10:00:00',2.51),('8902','2013-11-18','10:05:00',2.88),('8902','2013-11-18','10:10:00',1.05),('8902','2013-11-18','10:20:00',1.37),('8902','2013-11-18','10:25:00',1.22),('8902','2013-11-18','10:45:00',1.78),('8902','2013-11-18','10:50:00',3.24),('8902','2013-11-18','10:55:00',1.91),('8902','2013-11-18','11:00:00',1.08),('8902','2013-11-18','11:05:00',1.38),('8902','2013-11-18','11:10:00',1.81),('8902','2013-11-18','11:15:00',1.66),('8902','2013-11-18','11:20:00',5.49),('8902','2013-11-18','11:25:00',4.85),('8902','2013-11-18','11:30:00',6.09),('8902','2013-11-18','11:35:00',6.03),('8902','2013-11-18','11:40:00',4.93),('8902','2013-11-18','11:45:00',5.61),('8902','2013-11-18','11:50:00',5.64),('8902','2013-11-18','11:55:00',5.62),('8902','2013-11-18','12:00:00',5.1),('8902','2013-11-18','12:05:00',5.01),('8902','2013-11-18','12:10:00',5.49),('8902','2013-11-18','12:15:00',5.66),('8902','2013-11-18','12:20:00',3.33),('8902','2013-11-18','12:25:00',1.27),('8902','2013-11-18','12:30:00',3.12),('8902','2013-11-18','12:35:00',1.18),('8902','2013-11-18','12:40:00',1.17),('8902','2013-11-18','12:45:00',3.91),('8902','2013-11-18','12:50:00',3.01),('8902','2013-11-18','12:55:00',6.28),('8902','2013-11-18','13:00:00',6.05),('8902','2013-11-18','13:05:00',1.96),('8902','2013-11-18','13:10:00',3.42),('8902','2013-11-18','13:15:00',4.24),('8902','2013-11-18','13:20:00',5.11),('8902','2013-11-18','13:25:00',2.87),('8902','2013-11-18','13:30:00',1.42),('8902','2013-11-18','14:30:00',1.07),('8902','2013-11-18','14:35:00',1.03),('8902','2013-11-18','14:40:00',1.2),('8902','2013-11-18','14:45:00',1.27),('8902','2013-11-18','14:50:00',1.18),('8902','2013-11-18','14:55:00',1.3),('8902','2013-11-18','15:25:00',2.75),('8902','2013-11-18','15:30:00',3.49),('8902','2013-11-18','15:35:00',2.84),('8902','2013-11-18','15:40:00',2.43),('8902','2013-11-18','15:45:00',2.13),('8902','2013-11-18','15:50:00',1.77),('8902','2013-11-18','15:55:00',1.36),('8902','2013-11-18','16:00:00',1.06),('8902','2013-11-17','07:55:00',1.06),('8902','2013-11-17','08:00:00',1.4),('8902','2013-11-17','08:05:00',1.42),('8902','2013-11-17','08:10:00',1.48),('8902','2013-11-17','08:15:00',1.66),('8902','2013-11-17','08:20:00',1.78),('8902','2013-11-17','08:25:00',1.92),('8902','2013-11-17','08:30:00',2.2),('8902','2013-11-17','08:35:00',2.19),('8902','2013-11-17','08:40:00',2.14),('8902','2013-11-17','08:45:00',2.09),('8902','2013-11-17','08:50:00',1.89),('8902','2013-11-17','08:55:00',1.86),('8902','2013-11-17','09:00:00',1.86),('8902','2013-11-17','09:05:00',1.71),('8902','2013-11-17','09:10:00',1.62),('8902','2013-11-17','09:15:00',2.39),('8902','2013-11-17','09:20:00',3.22),('8902','2013-11-17','09:25:00',3.37),('8902','2013-11-17','09:30:00',3.07),('8902','2013-11-17','09:35:00',4.03),('8902','2013-11-17','09:40:00',3.23),('8902','2013-11-17','09:45:00',2.78),('8902','2013-11-17','09:50:00',2.12),('8902','2013-11-17','09:55:00',2.14),('8902','2013-11-17','10:00:00',2.41),('8902','2013-11-17','10:05:00',2.73),('8902','2013-11-17','10:10:00',2.93),('8902','2013-11-17','10:15:00',3.59),('8902','2013-11-17','10:20:00',2.98),('8902','2013-11-17','10:25:00',2.65),('8902','2013-11-17','10:30:00',2.45),('8902','2013-11-17','10:35:00',2.32),('8902','2013-11-17','10:40:00',2.42),('8902','2013-11-17','10:45:00',2.52),('8902','2013-11-17','10:50:00',2.39),('8902','2013-11-17','10:55:00',2.09),('8902','2013-11-17','11:00:00',1.87),('8902','2013-11-17','11:05:00',1.71),('8902','2013-11-17','11:10:00',1.57),('8902','2013-11-17','11:15:00',1.46),('8902','2013-11-17','11:20:00',1.55),('8902','2013-11-17','11:25:00',1.82),('8902','2013-11-17','11:30:00',2.07),('8902','2013-11-17','11:35:00',2.19),('8902','2013-11-17','11:40:00',2.28),('8902','2013-11-17','11:45:00',2.36),('8902','2013-11-17','11:50:00',2.46),('8902','2013-11-17','11:55:00',2.65),('8902','2013-11-17','12:00:00',2.8),('8902','2013-11-17','12:05:00',2.97),('8902','2013-11-17','12:10:00',2.97),('8902','2013-11-17','12:15:00',3.06),('8902','2013-11-17','12:20:00',3.23),('8902','2013-11-17','12:25:00',3.45),('8902','2013-11-17','12:30:00',2.92),('8902','2013-11-17','12:35:00',2.51),('8902','2013-11-17','12:40:00',2.18),('8902','2013-11-17','12:45:00',1.94),('8902','2013-11-17','12:50:00',1.8),('8902','2013-11-17','12:55:00',1.73),('8902','2013-11-17','13:00:00',1.72),('8902','2013-11-17','13:05:00',1.84),('8902','2013-11-17','13:10:00',2.17),('8902','2013-11-17','13:15:00',2.01),('8902','2013-11-17','13:20:00',1.87),('8902','2013-11-17','13:25:00',1.65),('8902','2013-11-17','13:30:00',1.84),('8902','2013-11-17','13:35:00',2.3),('8902','2013-11-17','13:40:00',2.36),('8902','2013-11-17','13:45:00',2.09),('8902','2013-11-17','13:50:00',2.04),('8902','2013-11-17','13:55:00',1.71),('8902','2013-11-17','14:00:00',1.43),('8902','2013-11-17','14:05:00',1.14),('8902','2014-04-18','07:35:00',1.15),('8902','2014-04-18','07:40:00',1.4),('8902','2014-04-18','07:45:00',1.13),('8902','2014-04-18','07:50:00',1.32),('8902','2014-04-18','07:55:00',2.54),('8902','2014-04-18','08:00:00',2.62),('8902','2014-04-18','08:05:00',1.91),('8902','2014-04-18','08:10:00',2.34),('8902','2014-04-18','08:15:00',1.9),('8902','2014-04-18','08:20:00',2.06),('8902','2014-04-18','08:25:00',2.63),('8902','2014-04-18','08:30:00',3.33),('8902','2014-04-18','08:35:00',4.16),('8902','2014-04-18','08:40:00',3.51),('8902','2014-04-18','08:45:00',3.64),('8902','2014-04-18','08:50:00',2.89),('8902','2014-04-18','08:55:00',2.04),('8902','2014-04-18','09:00:00',1.23),('8902','2014-04-18','09:05:00',1.06),('8902','2014-04-18','09:10:00',1.24),('8902','2014-04-18','09:15:00',1.59),('8902','2014-04-18','09:20:00',1.89),('8902','2014-04-18','09:25:00',2.51),('8902','2014-04-18','09:30:00',3.83),('8902','2014-04-18','09:35:00',3.98),('8902','2014-04-18','09:40:00',2.42),('8902','2014-04-18','09:45:00',1.8),('8902','2014-04-18','09:50:00',1.51),('8902','2014-04-18','09:55:00',1.38),('8902','2014-04-18','10:00:00',1.47),('8902','2014-04-18','10:05:00',1.25),('8902','2014-04-18','10:10:00',1.12),('8902','2014-04-18','10:15:00',1.25),('8902','2014-04-18','10:20:00',1.59),('8902','2014-04-18','10:25:00',1.49),('8902','2014-04-18','10:30:00',1.45),('8902','2014-04-18','10:35:00',1.69),('8902','2014-04-18','10:40:00',2.32),('8902','2014-04-18','10:45:00',2.24),('8902','2014-04-18','10:50:00',2.26),('8902','2014-04-18','10:55:00',2.83),('8902','2014-04-18','11:00:00',3.08),('8902','2014-04-18','11:05:00',2.51),('8902','2014-04-18','11:10:00',2.28),('8902','2014-04-18','11:15:00',3.28),('8902','2014-04-18','11:20:00',5.56),('8902','2014-04-18','11:25:00',4.89),('8902','2014-04-18','11:30:00',5.2),('8902','2014-04-18','11:35:00',4.6),('8902','2014-04-18','11:40:00',4.28),('8902','2014-04-18','11:45:00',4.54),('8902','2014-04-18','11:50:00',3.63),('8902','2014-04-18','11:55:00',2.1),('8902','2014-04-18','12:00:00',1.63),('8902','2014-04-18','12:05:00',1.35),('8902','2014-04-18','12:10:00',1.03),('8902','2014-04-18','13:15:00',2.73),('8902','2014-04-18','13:20:00',2.21),('8902','2014-04-18','13:35:00',1.27),('8902','2014-04-18','13:40:00',1.37),('8902','2014-04-18','13:45:00',1.04),('8902','2014-04-18','13:50:00',1.59),('8902','2014-04-18','13:55:00',1.3),('8902','2014-04-18','14:20:00',1.07),('8902','2014-04-18','14:25:00',1.19),('8902','2014-04-18','14:30:00',2.49),('8902','2014-04-18','14:35:00',2.96),('8902','2014-04-18','14:40:00',3.44),('8902','2014-04-18','14:45:00',3.66),('8902','2014-04-18','14:50:00',2.6),('8902','2014-04-18','14:55:00',2.05),('8902','2014-04-18','15:00:00',2.65),('8902','2014-04-18','15:05:00',2.42),('8902','2014-04-18','15:10:00',1.17),('8902','2014-04-18','15:20:00',1.25),('8902','2014-04-18','15:25:00',2.08),('8902','2014-04-18','15:30:00',2.23),('8902','2014-04-18','15:35:00',1.34),('8902','2014-04-18','15:45:00',1.69),('8902','2014-04-18','15:50:00',6.7),('8902','2014-04-18','15:55:00',6.72),('8902','2014-04-18','16:00:00',3.34),('8902','2014-04-18','16:05:00',3.08),('8902','2014-04-18','16:10:00',3.1),('8902','2014-04-18','16:15:00',3.19),('8902','2014-04-18','16:20:00',4.1),('8902','2014-04-18','16:25:00',4.06),('8902','2014-04-18','16:30:00',6.25),('8902','2014-04-18','16:35:00',3.19),('8902','2014-04-18','16:40:00',2.16),('8902','2014-04-18','16:45:00',1.78),('8902','2014-04-18','16:50:00',1.45),('8902','2014-04-18','17:00:00',1.02),('8902','2014-04-18','17:05:00',1.47),('8902','2014-04-18','17:10:00',1.79),('8902','2014-04-18','17:15:00',1.88),('8902','2014-04-18','17:20:00',3.21),('8902','2014-04-18','17:25:00',2.71),('8902','2014-04-18','17:30:00',2.28),('8902','2014-04-18','17:35:00',1.88),('8902','2014-04-18','17:40:00',1.16),('8902','2013-11-16','08:40:00',1.07),('8902','2013-11-16','08:45:00',2.76),('8902','2013-11-16','08:50:00',3.69),('8902','2013-11-16','08:55:00',4.02),('8902','2013-11-16','09:00:00',2.98),('8902','2013-11-16','09:05:00',3.51),('8902','2013-11-16','09:10:00',3.6),('8902','2013-11-16','09:15:00',3.82),('8902','2013-11-16','09:20:00',3.91),('8902','2013-11-16','09:25:00',3.99),('8902','2013-11-16','09:30:00',4.11),('8902','2013-11-16','09:35:00',4.16),('8902','2013-11-16','09:40:00',4.26),('8902','2013-11-16','09:45:00',4.36),('8902','2013-11-16','09:50:00',4.47),('8902','2013-11-16','09:55:00',4.57),('8902','2013-11-16','10:00:00',4.67),('8902','2013-11-16','10:05:00',4.78),('8902','2013-11-16','10:10:00',4.87),('8902','2013-11-16','10:15:00',4.97),('8902','2013-11-16','10:20:00',5.03),('8902','2013-11-16','10:25:00',5.09),('8902','2013-11-16','10:30:00',5.18),('8902','2013-11-16','10:35:00',5.22),('8902','2013-11-16','10:40:00',5.28),('8902','2013-11-16','10:45:00',5.37),('8902','2013-11-16','10:50:00',5.43),('8902','2013-11-16','10:55:00',5.47),('8902','2013-11-16','11:00:00',5.51),('8902','2013-11-16','11:05:00',5.55),('8902','2013-11-16','11:10:00',5.57),('8902','2013-11-16','11:15:00',5.61),('8902','2013-11-16','11:20:00',5.61),('8902','2013-11-16','11:25:00',5.68),('8902','2013-11-16','11:30:00',5.67),('8902','2013-11-16','11:35:00',5.69),('8902','2013-11-16','11:40:00',5.68),('8902','2013-11-16','11:45:00',5.75),('8902','2013-11-16','11:50:00',5.74),('8902','2013-11-16','11:55:00',5.71),('8902','2013-11-16','12:00:00',5.71),('8902','2013-11-16','12:05:00',5.71),('8902','2013-11-16','12:10:00',5.7),('8902','2013-11-16','12:15:00',5.71),('8902','2013-11-16','12:20:00',5.75),('8902','2013-11-16','12:25:00',5.73),('8902','2013-11-16','12:30:00',5.71),('8902','2013-11-16','12:35:00',5.71),('8902','2013-11-16','12:40:00',5.66),('8902','2013-11-16','12:45:00',5.6),('8902','2013-11-16','12:50:00',5.54),('8902','2013-11-16','12:55:00',5.48),('8902','2013-11-16','13:00:00',5.44),('8902','2013-11-16','13:05:00',5.39),('8902','2013-11-16','13:10:00',5.35),('8902','2013-11-16','13:15:00',5.32),('8902','2013-11-16','13:20:00',5.27),('8902','2013-11-16','13:25:00',5.27),('8902','2013-11-16','13:30:00',5.22),('8902','2013-11-16','13:35:00',3.63),('8902','2013-11-16','13:40:00',4.65),('8902','2013-11-16','13:45:00',2.85),('8902','2013-11-16','13:50:00',1.68),('8902','2013-11-16','13:55:00',3.46),('8902','2013-11-16','14:00:00',4.63),('8902','2013-11-16','14:05:00',4.48),('8902','2013-11-16','14:10:00',4.36),('8902','2013-11-16','14:15:00',4.31),('8902','2013-11-16','14:20:00',4.23),('8902','2013-11-16','14:25:00',4.04),('8902','2013-11-16','14:30:00',3.69),('8902','2013-11-16','14:35:00',3.62),('8902','2013-11-16','14:40:00',3.09),('8902','2013-11-16','14:45:00',1.19),('8902','2013-11-16','14:50:00',1.53),('8902','2013-11-16','15:30:00',2.25),('8902','2013-11-16','15:35:00',2.09),('8902','2013-11-16','15:40:00',1.88),('8902','2013-11-16','15:45:00',1.71),('8902','2013-11-16','15:50:00',1.53),('8902','2013-11-16','15:55:00',1.35),('8902','2013-11-16','16:00:00',1.17),('8902','2013-11-15','12:50:00',1.17),('8902','2013-11-15','12:55:00',1.27),('8902','2013-11-15','13:00:00',1.39),('8902','2013-11-15','13:05:00',1.7),('8902','2013-11-15','13:10:00',1.53),('8902','2013-11-15','13:15:00',1.24),('8902','2013-11-15','13:20:00',1.1),('8902','2013-11-15','13:25:00',1.11),('8902','2013-11-15','13:30:00',1.03),('8902','2013-11-15','13:50:00',1.02),('8902','2013-11-15','13:55:00',1.05),('8902','2013-11-14','08:10:00',1.17),('8902','2013-11-14','08:15:00',1.48),('8902','2013-11-14','08:20:00',1.54),('8902','2013-11-14','08:45:00',1.12),('8902','2013-11-14','08:50:00',1.23),('8902','2013-11-14','08:55:00',1.37),('8902','2013-11-14','09:00:00',1.51),('8902','2013-11-14','09:05:00',1.75),('8902','2013-11-14','09:10:00',2.05),('8902','2013-11-14','09:15:00',2.12),('8902','2013-11-14','09:20:00',1.67),('8902','2013-11-14','09:25:00',1.65),('8902','2013-11-14','09:30:00',2.11),('8902','2013-11-14','09:35:00',2.16),('8902','2013-11-14','09:40:00',1.81),('8902','2013-11-14','09:45:00',1.27),('8902','2013-11-14','10:00:00',1.12),('8902','2013-11-14','10:05:00',1.32),('8902','2013-11-14','10:10:00',1.82),('8902','2013-11-14','10:15:00',2.47),('8902','2013-11-14','10:20:00',2.41),('8902','2013-11-14','10:25:00',1.89),('8902','2013-11-14','10:30:00',1.67),('8902','2013-11-14','10:35:00',1.59),('8902','2013-11-14','10:40:00',1.42),('8902','2013-11-14','10:45:00',1.53),('8902','2013-11-14','10:50:00',2.75),('8902','2013-11-14','10:55:00',4.04),('8902','2013-11-14','11:00:00',2.8),('8902','2013-11-14','11:05:00',2.47),('8902','2013-11-14','11:10:00',2.35),('8902','2013-11-14','11:15:00',2.81),('8902','2013-11-14','11:20:00',3.69),('8902','2013-11-14','11:25:00',5.82),('8902','2013-11-14','11:30:00',3.26),('8902','2013-11-14','11:35:00',3.58),('8902','2013-11-14','11:40:00',3.87),('8902','2013-11-14','11:45:00',3.33),('8902','2013-11-14','11:50:00',2.72),('8902','2013-11-14','11:55:00',2.5),('8902','2013-11-14','12:00:00',2.75),('8902','2013-11-14','12:05:00',2.46),('8902','2013-11-14','12:10:00',2.52),('8902','2013-11-14','12:15:00',2.41),('8902','2013-11-14','12:20:00',2.93),('8902','2013-11-14','12:25:00',4.02),('8902','2013-11-14','12:30:00',3.2),('8902','2013-11-14','12:35:00',2.69),('8902','2013-11-14','12:40:00',2.44),('8902','2013-11-14','12:45:00',2.48),('8902','2013-11-14','12:50:00',3.4),('8902','2013-11-14','12:55:00',3.13),('8902','2013-11-14','13:00:00',2.89),('8902','2013-11-14','13:05:00',2.58),('8902','2013-11-14','13:10:00',2.63),('8902','2013-11-14','13:15:00',1.86),('8902','2013-11-14','13:20:00',1.77),('8902','2013-11-14','13:25:00',1.99),('8902','2013-11-14','13:30:00',2.29),('8902','2013-11-14','13:35:00',2.47),('8902','2013-11-14','13:40:00',2.65),('8902','2013-11-14','13:45:00',3.78),('8902','2013-11-14','13:50:00',3.95),('8902','2013-11-14','13:55:00',2.31),('8902','2013-11-14','14:00:00',2.58),('8902','2013-11-14','14:05:00',2.16),('8902','2013-11-14','14:10:00',1.71),('8902','2013-11-14','14:15:00',1.37),('8902','2013-11-13','08:15:00',1.34),('8902','2013-11-13','08:20:00',1.96),('8902','2013-11-13','08:25:00',2.09),('8902','2013-11-13','08:30:00',2.03),('8902','2013-11-13','08:35:00',2.18),('8902','2013-11-13','08:40:00',1.87),('8902','2013-11-13','08:45:00',1.03),('8902','2013-11-13','08:50:00',1.59),('8902','2013-11-13','08:55:00',2.22),('8902','2013-11-13','09:00:00',1.98),('8902','2013-11-13','09:05:00',3.53),('8902','2013-11-13','09:10:00',2.99),('8902','2013-11-13','09:15:00',3.58),('8902','2013-11-13','09:20:00',3.94),('8902','2013-11-13','09:25:00',3.97),('8902','2013-11-13','09:30:00',4.1),('8902','2013-11-13','09:35:00',4.18),('8902','2013-11-13','09:40:00',4.27),('8902','2013-11-13','09:45:00',4.08),('8902','2013-11-13','09:50:00',1.03),('8902','2013-11-13','09:55:00',1.27),('8902','2013-11-13','10:00:00',1.6),('8902','2013-11-13','10:05:00',3.5),('8902','2013-11-13','10:10:00',1.34),('8902','2013-11-13','10:15:00',5.09),('8902','2013-11-13','10:20:00',5.17),('8902','2013-11-13','10:25:00',5.16),('8902','2013-11-13','10:30:00',5.17),('8902','2013-11-13','10:35:00',5.16),('8902','2013-11-13','10:40:00',5.21),('8902','2013-11-13','10:45:00',5.32),('8902','2013-11-13','10:50:00',5.35),('8902','2013-11-13','10:55:00',5.4),('8902','2013-11-13','11:00:00',5.39),('8902','2013-11-13','11:05:00',5.59),('8902','2013-11-13','11:10:00',5.69),('8902','2013-11-13','11:15:00',5.87),('8902','2013-11-13','11:20:00',5.92),('8902','2013-11-13','11:25:00',6),('8902','2013-11-13','11:30:00',6.05),('8902','2013-11-13','11:35:00',5.97),('8902','2013-11-13','11:40:00',5.16),('8902','2013-11-13','11:45:00',3.39),('8902','2013-11-13','11:50:00',3.78),('8902','2013-11-13','11:55:00',2.95),('8902','2013-11-13','12:00:00',6.4),('8902','2013-11-13','12:05:00',3.72),('8902','2013-11-13','12:10:00',2.61),('8902','2013-11-13','12:15:00',2.86),('8902','2013-11-13','12:20:00',2.59),('8902','2013-11-13','12:25:00',2.28),('8902','2013-11-13','12:30:00',2.16),('8902','2013-11-13','12:35:00',2.24),('8902','2013-11-13','12:40:00',2.15),('8902','2013-11-13','12:45:00',2.2),('8902','2013-11-13','12:50:00',2.33),('8902','2013-11-13','12:55:00',2.24),('8902','2013-11-13','13:00:00',2.21),('8902','2013-11-13','13:05:00',1.98),('8902','2013-11-13','13:10:00',1.81),('8902','2013-11-13','13:15:00',1.84),('8902','2013-11-13','13:20:00',1.81),('8902','2013-11-13','13:25:00',1.69),('8902','2013-11-13','13:30:00',1.81),('8902','2013-11-13','13:35:00',1.7),('8902','2013-11-13','13:40:00',1.55),('8902','2013-11-13','13:45:00',1.46),('8902','2013-11-13','13:50:00',1.42),('8902','2013-11-13','13:55:00',1.48),('8902','2013-11-13','14:00:00',1.47),('8902','2013-11-13','14:05:00',1.66),('8902','2013-11-13','14:10:00',1.55),('8902','2013-11-13','14:15:00',1.42),('8902','2013-11-13','14:20:00',1.37),('8902','2013-11-13','14:25:00',1.31),('8902','2013-11-13','14:30:00',1.53),('8902','2013-11-13','14:35:00',1.13),('8902','2013-11-13','14:40:00',1.01),('8902','2013-11-12','08:20:00',1.39),('8902','2013-11-12','08:25:00',1.52),('8902','2013-11-12','08:30:00',1.72),('8902','2013-11-12','08:35:00',1.77),('8902','2013-11-12','09:55:00',1.08),('8902','2013-11-12','10:00:00',2.62),('8902','2013-11-12','10:05:00',1.96),('8902','2013-11-12','10:10:00',2),('8902','2013-11-12','10:15:00',1.91),('8902','2013-11-12','10:20:00',3.62),('8902','2013-11-12','10:25:00',3.29),('8902','2013-11-12','10:30:00',4.77),('8902','2013-11-12','10:35:00',7.23),('8902','2013-11-12','10:40:00',3.97),('8902','2013-11-12','10:45:00',5.73),('8902','2013-11-12','10:50:00',7.21),('8902','2013-11-12','10:55:00',7.08),('8902','2013-11-12','11:00:00',6.44),('8902','2013-11-12','11:05:00',2.08),('8902','2013-11-12','11:10:00',2.04),('8902','2013-11-12','11:15:00',2.14),('8902','2013-11-12','11:20:00',1.99),('8902','2013-11-12','11:25:00',2.17),('8902','2013-11-12','11:30:00',3.22),('8902','2013-11-12','11:35:00',2.96),('8902','2013-11-12','11:40:00',1.89),('8902','2013-11-12','11:45:00',2.22),('8902','2013-11-12','11:50:00',2.47),('8902','2013-11-12','11:55:00',2.14),('8902','2013-11-12','12:00:00',1.52),('8902','2013-11-12','12:05:00',1.44),('8902','2013-11-12','12:10:00',1.57),('8902','2013-11-12','12:15:00',1.71),('8902','2013-11-12','12:20:00',1.53),('8902','2013-11-12','12:25:00',1.41),('8902','2013-11-12','12:30:00',1.18),('8902','2013-11-12','12:35:00',1.29),('8902','2013-11-12','12:40:00',1.44),('8902','2013-11-12','12:45:00',1.29),('8902','2013-11-12','12:50:00',1.31),('8902','2013-11-12','12:55:00',1.9),('8902','2013-11-12','13:00:00',2.24),('8902','2013-11-12','13:05:00',2.8),('8902','2013-11-12','13:10:00',2.45),('8902','2013-11-12','13:15:00',2.3),('8902','2013-11-12','13:20:00',1.71),('8902','2013-11-12','13:25:00',1.45),('8902','2013-11-12','13:30:00',1.52),('8902','2013-11-12','13:35:00',1.72),('8902','2013-11-12','13:40:00',2.03),('8902','2013-11-12','13:45:00',1.88),('8902','2013-11-12','13:50:00',1.9),('8902','2013-11-12','13:55:00',3.91),('8902','2013-11-12','14:00:00',4.19),('8902','2013-11-12','14:05:00',4.15),('8902','2013-11-12','14:10:00',3.61),('8902','2013-11-12','14:15:00',3.92),('8902','2013-11-12','14:20:00',3.47),('8902','2013-11-12','14:25:00',3.63),('8902','2013-11-12','14:30:00',3.34),('8902','2013-11-12','14:35:00',2.43),('8902','2013-11-12','14:40:00',2),('8902','2013-11-12','14:45:00',1.81),('8902','2013-11-12','14:50:00',1.7),('8902','2013-11-12','15:00:00',1.47),('8902','2013-11-12','15:05:00',1.21),('8902','2013-11-11','10:00:00',1.54),('8902','2013-11-11','10:05:00',1.22),('8902','2013-11-11','10:45:00',1),('8902','2013-11-11','10:50:00',1.17),('8902','2013-11-11','10:55:00',1.3),('8902','2013-11-11','11:00:00',1.43),('8902','2013-11-11','11:05:00',1.32),('8902','2013-11-11','11:10:00',1.59),('8902','2013-11-11','11:15:00',1.6),('8902','2013-11-11','11:20:00',1.58),('8902','2013-11-11','11:25:00',2.94),('8902','2013-11-11','11:30:00',1.73),('8902','2013-11-11','11:35:00',2.36),('8902','2013-11-11','11:40:00',5.56),('8902','2013-11-11','11:45:00',3.35),('8902','2013-11-11','11:50:00',3.53),('8902','2013-11-11','11:55:00',2.09),('8902','2013-11-11','12:00:00',5.84),('8902','2013-11-11','12:05:00',2.56),('8902','2013-11-11','12:10:00',1.52),('8902','2013-11-11','12:15:00',1.54),('8902','2013-11-11','12:20:00',1.7),('8902','2013-11-11','12:25:00',2.2),('8902','2013-11-11','12:30:00',7.98),('8902','2013-11-11','12:35:00',6.63),('8902','2013-11-11','12:40:00',3.99),('8902','2013-11-11','12:45:00',3.83),('8902','2013-11-11','12:50:00',3.35),('8902','2013-11-11','12:55:00',3.82),('8902','2013-11-11','13:00:00',3.67),('8902','2013-11-11','13:05:00',4.36),('8902','2013-11-11','13:10:00',6.82),('8902','2013-11-11','13:15:00',7.78),('8902','2013-11-11','13:20:00',5.42),('8902','2013-11-11','13:25:00',4.7),('8902','2013-11-11','13:30:00',3.51),('8902','2013-11-11','13:35:00',4.13),('8902','2013-11-11','13:40:00',6.16),('8902','2013-11-11','13:45:00',3.99),('8902','2013-11-11','13:50:00',2.8),('8902','2013-11-11','13:55:00',2.86),('8902','2013-11-11','14:00:00',2.73),('8902','2013-11-11','14:05:00',2.23),('8902','2013-11-11','14:10:00',3.35),('8902','2013-11-11','14:15:00',6.14),('8902','2013-11-11','14:20:00',6),('8902','2013-11-11','14:25:00',5.81),('8902','2013-11-11','14:30:00',5.21),('8902','2013-11-11','14:35:00',2.45),('8902','2013-11-11','14:40:00',4.39),('8902','2013-11-11','14:45:00',3.66),('8902','2013-11-11','14:50:00',3.7),('8902','2013-11-11','14:55:00',2.54),('8902','2013-11-11','15:00:00',1.75),('8902','2013-11-11','15:05:00',1.1),('8902','2013-11-11','15:10:00',1.05),('8902','2013-11-11','15:15:00',2.14),('8902','2013-11-11','15:20:00',1.17),('8902','2013-11-10','09:45:00',1.39),('8902','2013-11-10','09:50:00',2.61),('8902','2013-11-10','09:55:00',2.46),('8902','2013-11-10','10:00:00',1.71),('8902','2013-11-10','10:05:00',1.71),('8902','2013-11-10','10:10:00',2.47),('8902','2013-11-10','10:15:00',4.43),('8902','2013-11-10','10:20:00',6.3),('8902','2013-11-10','10:25:00',2.59),('8902','2013-11-10','10:30:00',1.35),('8902','2013-11-10','10:35:00',1.75),('8902','2013-11-10','10:40:00',1.18),('8902','2013-11-10','10:55:00',1.08),('8902','2013-11-10','11:00:00',1.56),('8902','2013-11-10','11:05:00',2.52),('8902','2013-11-10','11:10:00',5.31),('8902','2013-11-10','11:15:00',3.98),('8902','2013-11-10','11:20:00',3.45),('8902','2013-11-10','11:25:00',5.96),('8902','2013-11-10','11:30:00',3.09),('8902','2013-11-10','11:35:00',6.85),('8902','2013-11-10','11:40:00',8.17),('8902','2013-11-10','11:45:00',7.44),('8902','2013-11-10','11:50:00',7.66),('8902','2013-11-10','11:55:00',7.05),('8902','2013-11-10','12:00:00',6.74),('8902','2013-11-10','12:05:00',6.57),('8902','2013-11-10','12:10:00',6.25),('8902','2013-11-10','12:15:00',6.34),('8902','2013-11-10','12:20:00',6.76),('8902','2013-11-10','12:25:00',5.78),('8902','2013-11-10','12:30:00',5.61),('8902','2013-11-10','12:35:00',2.68),('8902','2013-11-10','12:40:00',4.92),('8902','2013-11-10','12:45:00',2.27),('8902','2013-11-10','12:50:00',1.74),('8902','2013-11-10','12:55:00',1.65),('8902','2013-11-10','13:00:00',2.56),('8902','2013-11-10','13:05:00',3.24),('8902','2013-11-10','13:10:00',6.56),('8902','2013-11-10','13:15:00',2),('8902','2013-11-10','13:30:00',1.57),('8902','2013-11-10','13:35:00',3.49),('8902','2013-11-10','13:40:00',3.48),('8902','2013-11-10','13:45:00',2),('8902','2013-11-10','13:50:00',1.55),('8902','2013-11-10','13:55:00',1.75),('8902','2013-11-10','14:00:00',1.86),('8902','2013-11-10','14:05:00',1.51),('8902','2013-11-10','14:10:00',1.99),('8902','2013-11-10','14:15:00',3.34),('8902','2013-11-10','14:20:00',5.15),('8902','2013-11-10','14:25:00',5.08),('8902','2013-11-10','14:30:00',4.76),('8902','2013-11-10','14:35:00',4.62),('8902','2013-11-10','14:40:00',3.86),('8902','2013-11-10','14:45:00',2.1),('8902','2013-11-10','14:50:00',1.15),('8902','2013-11-10','14:55:00',1.25),('8902','2013-11-09','07:35:00',1.08),('8902','2013-11-09','07:40:00',1.24),('8902','2013-11-09','07:45:00',1.44),('8902','2013-11-09','07:50:00',1.76),('8902','2013-11-09','07:55:00',1.86),('8902','2013-11-09','08:00:00',1.99),('8902','2013-11-09','08:05:00',1.47),('8902','2013-11-09','08:10:00',1.24),('8902','2013-11-09','08:15:00',1.46),('8902','2013-11-09','08:20:00',1.62),('8902','2013-11-09','08:25:00',1.42),('8902','2013-11-09','08:30:00',1.86),('8902','2013-11-09','08:35:00',1.84),('8902','2013-11-09','08:40:00',2.42),('8902','2013-11-09','08:45:00',3.27),('8902','2013-11-09','08:50:00',3.11),('8902','2013-11-09','08:55:00',3.76),('8902','2013-11-09','09:00:00',3.06),('8902','2013-11-09','09:05:00',2.61),('8902','2013-11-09','09:10:00',1.97),('8902','2013-11-09','09:15:00',2.98),('8902','2013-11-09','09:20:00',3.82),('8902','2013-11-09','09:25:00',4.31),('8902','2013-11-09','09:30:00',3.81),('8902','2013-11-09','09:35:00',3.79),('8902','2013-11-09','09:40:00',4.11),('8902','2013-11-09','09:45:00',4.53),('8902','2013-11-09','09:50:00',4.71),('8902','2013-11-09','09:55:00',4.69),('8902','2013-11-09','10:00:00',4.35),('8902','2013-11-09','10:05:00',5.08),('8902','2013-11-09','10:10:00',5.54),('8902','2013-11-09','10:15:00',5.52),('8902','2013-11-09','10:20:00',5),('8902','2013-11-09','10:25:00',5.76),('8902','2013-11-09','10:30:00',6.35),('8902','2013-11-09','10:35:00',5.54),('8902','2013-11-09','10:40:00',3.97),('8902','2013-11-09','10:45:00',6.1),('8902','2013-11-09','10:50:00',5.62),('8902','2013-11-09','10:55:00',6.31),('8902','2013-11-09','11:00:00',4.98),('8902','2013-11-09','11:05:00',3.07),('8902','2013-11-09','11:10:00',2.1),('8902','2013-11-09','11:15:00',1.3),('8902','2013-11-09','11:20:00',1.58),('8902','2013-11-09','11:25:00',3.3),('8902','2013-11-09','11:30:00',1.84),('8902','2013-11-09','11:35:00',1.97),('8902','2013-11-09','11:40:00',4.1),('8902','2013-11-09','11:45:00',4.59),('8902','2013-11-09','11:50:00',3.05),('8902','2013-11-09','11:55:00',2.71),('8902','2013-11-09','12:00:00',2.4),('8902','2013-11-09','12:05:00',2.6),('8902','2013-11-09','12:10:00',3.12),('8902','2013-11-09','12:15:00',6.47),('8902','2013-11-09','12:20:00',5.29),('8902','2013-11-09','12:25:00',6.28),('8902','2013-11-09','12:30:00',4.43),('8902','2013-11-09','12:35:00',3.73),('8902','2013-11-09','12:40:00',6.59),('8902','2013-11-09','12:45:00',7.04),('8902','2013-11-09','12:50:00',7.15),('8902','2013-11-09','12:55:00',4.72),('8902','2013-11-09','13:00:00',3.02),('8902','2013-11-09','13:05:00',1.46),('8902','2013-11-09','13:10:00',1.63),('8902','2013-11-09','13:15:00',1.07),('8902','2013-11-09','13:35:00',1.71),('8902','2013-11-09','13:40:00',1.4),('8902','2013-11-09','13:45:00',2.63),('8902','2013-11-09','13:50:00',3.95),('8902','2013-11-09','13:55:00',4.46),('8902','2013-11-09','14:20:00',1.18),('8902','2013-11-09','14:25:00',1.2),('8902','2013-11-09','14:30:00',1.75),('8902','2013-11-09','14:35:00',1.28),('8902','2013-11-08','09:10:00',1.47),('8902','2013-11-08','09:15:00',1.67),('8902','2013-11-08','09:20:00',1.64),('8902','2013-11-08','09:30:00',1.54),('8902','2013-11-08','09:35:00',1.4),('8902','2013-11-08','09:40:00',3.92),('8902','2013-11-08','09:45:00',4.43),('8902','2013-11-08','09:50:00',2.98),('8902','2013-11-08','09:55:00',5.59),('8902','2013-11-08','10:00:00',5.41),('8902','2013-11-08','10:05:00',5.32),('8902','2013-11-08','10:10:00',5.01),('8902','2013-11-08','10:15:00',4.69),('8902','2013-11-08','10:20:00',5.1),('8902','2013-11-08','10:25:00',5.34),('8902','2013-11-08','10:30:00',2.17),('8902','2013-11-08','10:35:00',2.59),('8902','2013-11-08','10:40:00',2.58),('8902','2013-11-08','10:45:00',2.82),('8902','2013-11-08','10:50:00',2.96),('8902','2013-11-08','10:55:00',3.73),('8902','2013-11-08','11:00:00',5.07),('8902','2013-11-08','11:05:00',6.73),('8902','2013-11-08','11:10:00',6.02),('8902','2013-11-08','11:15:00',6.45),('8902','2013-11-08','11:20:00',4.94),('8902','2013-11-08','11:25:00',2.44),('8902','2013-11-08','11:30:00',6.15),('8902','2013-11-08','11:35:00',6.09),('8902','2013-11-08','11:40:00',3.16),('8902','2013-11-08','11:45:00',4.36),('8902','2013-11-08','11:50:00',2.48),('8902','2013-11-08','11:55:00',5.4),('8902','2013-11-08','12:00:00',5.29),('8902','2013-11-08','12:05:00',7.41),('8902','2013-11-08','12:10:00',2.52),('8902','2013-11-08','12:15:00',4.24),('8902','2013-11-08','12:20:00',2.38),('8902','2013-11-08','12:25:00',3.63),('8902','2013-11-08','12:30:00',4.37),('8902','2013-11-08','12:35:00',7.06),('8902','2013-11-08','12:40:00',3.8),('8902','2013-11-08','12:45:00',2.54),('8902','2013-11-08','12:50:00',4.4),('8902','2013-11-08','12:55:00',4.12),('8902','2013-11-08','13:00:00',6.59),('8902','2013-11-08','13:05:00',5.71),('8902','2013-11-08','13:10:00',6.59),('8902','2013-11-08','13:15:00',6.51),('8902','2013-11-08','13:20:00',4.48),('8902','2013-11-08','13:25:00',4.69),('8902','2013-11-08','13:30:00',5.78),('8902','2013-11-08','13:35:00',5.65),('8902','2013-11-08','13:40:00',5.37),('8902','2013-11-08','13:45:00',5.29),('8902','2013-11-08','13:50:00',5.33),('8902','2013-11-08','13:55:00',5.26),('8902','2013-11-08','14:00:00',5.14),('8902','2013-11-08','14:05:00',4.54),('8902','2013-11-08','14:10:00',3.23),('8902','2013-11-08','14:15:00',2.65),('8902','2013-11-08','14:20:00',4.94),('8902','2013-11-08','14:25:00',3.69),('8902','2013-11-08','14:30:00',1.08),('8902','2013-11-08','14:35:00',2.33),('8902','2013-11-08','14:40:00',3.27),('8902','2013-11-08','14:45:00',3.31),('8902','2013-11-08','14:50:00',3.56),('8902','2013-11-08','14:55:00',1.78),('8902','2013-11-08','15:30:00',1.67),('8902','2013-11-08','15:35:00',2.83),('8902','2013-11-08','15:40:00',1.17),('8902','2013-11-08','15:45:00',1.86),('8902','2013-11-08','15:50:00',1.62),('8902','2013-11-08','16:00:00',1.09),('8902','2013-11-07','09:00:00',1.1),('8902','2013-11-07','09:05:00',1.81),('8902','2013-11-07','09:10:00',2.61),('8902','2013-11-07','09:15:00',2.17),('8902','2013-11-07','09:20:00',1.82),('8902','2013-11-07','09:25:00',3.17),('8902','2013-11-07','09:30:00',3.21),('8902','2013-11-07','09:35:00',3.3),('8902','2013-11-07','09:40:00',3.54),('8902','2013-11-07','09:45:00',2.54),('8902','2013-11-07','09:50:00',4.41),('8902','2013-11-07','09:55:00',2.39),('8902','2013-11-07','10:00:00',2.65),('8902','2013-11-07','10:05:00',2.09),('8902','2013-11-07','10:10:00',4.7),('8902','2013-11-07','10:15:00',4.6),('8902','2013-11-07','10:25:00',1.06),('8902','2013-11-07','10:30:00',1.11),('8902','2013-11-07','10:45:00',2.06),('8902','2013-11-07','10:50:00',1.47),('8902','2013-11-07','10:55:00',4.4),('8902','2013-11-07','11:00:00',4.05),('8902','2013-11-07','11:05:00',2.34),('8902','2013-11-07','11:10:00',1.32),('8902','2013-11-07','11:15:00',1.26),('8902','2013-11-07','11:20:00',1.39),('8902','2013-11-07','11:25:00',1.35),('8902','2013-11-07','11:30:00',5.05),('8902','2013-11-07','11:35:00',5.45),('8902','2013-11-07','11:40:00',6.78),('8902','2013-11-07','11:45:00',6.66),('8902','2013-11-07','11:50:00',6.59),('8902','2013-11-07','11:55:00',6.76),('8902','2013-11-07','12:00:00',6.39),('8902','2013-11-07','12:05:00',4.08),('8902','2013-11-07','12:10:00',6.13),('8902','2013-11-07','12:15:00',5.09),('8902','2013-11-07','12:25:00',2.44),('8902','2013-11-07','12:30:00',1.12),('8902','2013-11-07','12:35:00',2.1),('8902','2013-11-07','12:40:00',6.59),('8902','2013-11-07','12:45:00',6.44),('8902','2013-11-07','12:50:00',5.07),('8902','2013-11-07','12:55:00',6.63),('8902','2013-11-07','13:00:00',6.25),('8902','2013-11-07','13:05:00',6.01),('8902','2013-11-07','13:10:00',6.11),('8902','2013-11-07','13:15:00',5.86),('8902','2013-11-07','13:20:00',1.92),('8902','2013-11-07','13:25:00',4),('8902','2013-11-07','13:30:00',2.3),('8902','2013-11-07','13:35:00',4.42),('8902','2013-11-07','13:40:00',5.68),('8902','2013-11-07','13:45:00',5.44),('8902','2013-11-07','13:50:00',4.63),('8902','2013-11-07','13:55:00',5.2),('8902','2013-11-07','14:00:00',5.07),('8902','2013-11-07','14:05:00',4.96),('8902','2013-11-07','14:10:00',4.86),('8902','2013-11-07','14:15:00',4.78),('8902','2013-11-07','14:20:00',4.56),('8902','2013-11-07','14:25:00',3.94),('8902','2013-11-07','14:30:00',4.47),('8902','2013-11-07','14:35:00',4.4),('8902','2013-11-07','14:40:00',4.16),('8902','2013-11-07','14:45:00',4.07),('8902','2013-11-07','14:50:00',3.94),('8902','2013-11-07','14:55:00',3.14),('8902','2013-11-07','15:00:00',2.98),('8902','2013-11-07','15:05:00',3.35),('8902','2013-11-07','15:10:00',3.29),('8902','2013-11-07','15:15:00',3.15),('8902','2013-11-07','15:20:00',2.72),('8902','2013-11-07','15:25:00',2.31),('8902','2013-11-07','15:30:00',2.06),('8902','2013-11-07','15:55:00',1.23),('8902','2013-11-07','16:05:00',1.09),('8902','2013-11-07','16:10:00',1.02),('8902','2014-04-17','08:00:00',1.51),('8902','2014-04-17','08:05:00',2.69),('8902','2014-04-17','08:10:00',2.49),('8902','2014-04-17','08:15:00',1.14),('8902','2014-04-17','08:30:00',1.11),('8902','2014-04-17','08:35:00',1.7),('8902','2014-04-17','08:40:00',2.5),('8902','2014-04-17','08:45:00',2.7),('8902','2014-04-17','08:50:00',2.02),('8902','2014-04-17','08:55:00',1.89),('8902','2014-04-17','09:00:00',2.28),('8902','2014-04-17','09:05:00',4.69),('8902','2014-04-17','09:10:00',5.76),('8902','2014-04-17','09:15:00',5.24),('8902','2014-04-17','09:20:00',4.88),('8902','2014-04-17','09:25:00',3.55),('8902','2014-04-17','09:30:00',5.65),('8902','2014-04-17','09:35:00',3.38),('8902','2014-04-17','09:40:00',2.71),('8902','2014-04-17','09:45:00',3.44),('8902','2014-04-17','09:50:00',5.46),('8902','2014-04-17','09:55:00',5.01),('8902','2014-04-17','10:00:00',4.93),('8902','2014-04-17','10:05:00',3.37),('8902','2014-04-17','10:10:00',2.99),('8902','2014-04-17','10:15:00',3.39),('8902','2014-04-17','10:20:00',2.8),('8902','2014-04-17','10:25:00',2.93),('8902','2014-04-17','10:30:00',2.48),('8902','2014-04-17','10:35:00',2.23),('8902','2014-04-17','10:40:00',2.66),('8902','2014-04-17','10:45:00',5.22),('8902','2014-04-17','10:50:00',5.29),('8902','2014-04-17','10:55:00',5.59),('8902','2014-04-17','11:00:00',3.38),('8902','2014-04-17','11:05:00',3.09),('8902','2014-04-17','11:10:00',4.26),('8902','2014-04-17','11:15:00',5.52),('8902','2014-04-17','11:20:00',3.59),('8902','2014-04-17','11:25:00',2.58),('8902','2014-04-17','11:30:00',3.18),('8902','2014-04-17','11:35:00',3.09),('8902','2014-04-17','11:40:00',3.24),('8902','2014-04-17','11:45:00',3.01),('8902','2014-04-17','11:50:00',3.63),('8902','2014-04-17','11:55:00',3.39),('8902','2014-04-17','12:00:00',3.39),('8902','2014-04-17','12:05:00',5.34),('8902','2014-04-17','12:10:00',5.79),('8902','2014-04-17','12:15:00',6.38),('8902','2014-04-17','12:20:00',7.82),('8902','2014-04-17','12:25:00',6.34),('8902','2014-04-17','12:30:00',8.76),('8902','2014-04-17','12:35:00',8.27),('8902','2014-04-17','12:40:00',8.79),('8902','2014-04-17','12:45:00',6.78),('8902','2014-04-17','12:50:00',7.44),('8902','2014-04-17','12:55:00',5.01),('8902','2014-04-17','13:00:00',9.1),('8902','2014-04-17','13:05:00',6.33),('8902','2014-04-17','13:10:00',4.81),('8902','2014-04-17','13:15:00',4.71),('8902','2014-04-17','13:20:00',4.25),('8902','2014-04-17','13:25:00',3.19),('8902','2014-04-17','13:30:00',2.76),('8902','2014-04-17','13:35:00',2.74),('8902','2014-04-17','13:40:00',2.37),('8902','2014-04-17','13:45:00',2.06),('8902','2014-04-17','13:50:00',2.57),('8902','2014-04-17','13:55:00',4.01),('8902','2014-04-17','14:00:00',3.7),('8902','2014-04-17','14:05:00',3.13),('8902','2014-04-17','14:10:00',2.77),('8902','2014-04-17','14:15:00',2.46),('8902','2014-04-17','14:20:00',2.95),('8902','2014-04-17','14:25:00',3.87),('8902','2014-04-17','14:30:00',4.33),('8902','2014-04-17','14:35:00',4.85),('8902','2014-04-17','14:40:00',4.45),('8902','2014-04-17','14:45:00',5.35),('8902','2014-04-17','14:50:00',6.27),('8902','2014-04-17','14:55:00',4.31),('8902','2014-04-17','15:00:00',6.6),('8902','2014-04-17','15:05:00',5.69),('8902','2014-04-17','15:10:00',4.39),('8902','2014-04-17','15:15:00',4.97),('8902','2014-04-17','15:20:00',3.86),('8902','2014-04-17','15:25:00',4.11),('8902','2014-04-17','15:30:00',5.94),('8902','2014-04-17','15:35:00',8.86),('8902','2014-04-17','15:40:00',3.55),('8902','2014-04-17','15:45:00',4.7),('8902','2014-04-17','15:50:00',5.98),('8902','2014-04-17','15:55:00',5),('8902','2014-04-17','16:00:00',4.33),('8902','2014-04-17','16:05:00',3.31),('8902','2014-04-17','16:10:00',2.75),('8902','2014-04-17','16:15:00',2.37),('8902','2014-04-17','16:20:00',2.42),('8902','2014-04-17','16:25:00',4.28),('8902','2014-04-17','16:30:00',4.18),('8902','2014-04-17','16:35:00',6.21),('8902','2014-04-17','16:40:00',6.04),('8902','2014-04-17','16:45:00',5.77),('8902','2014-04-17','16:50:00',4.84),('8902','2014-04-17','16:55:00',2.96),('8902','2014-04-17','17:00:00',4.03),('8902','2014-04-17','17:05:00',5.65),('8902','2014-04-17','17:10:00',3.74),('8902','2014-04-17','17:15:00',4.76),('8902','2014-04-17','17:20:00',4.35),('8902','2014-04-17','17:25:00',4.35),('8902','2014-04-17','17:30:00',3.95),('8902','2014-04-17','17:35:00',3.74),('8902','2014-04-17','17:40:00',3.57),('8902','2014-04-17','17:45:00',3.38),('8902','2014-04-17','17:50:00',3.24),('8902','2014-04-17','17:55:00',3.04),('8902','2014-04-17','18:00:00',2.85),('8902','2014-04-17','18:05:00',2.56),('8902','2014-04-17','18:10:00',2.34),('8902','2014-04-17','18:15:00',2.1),('8902','2014-04-17','18:20:00',1.47),('8902','2014-04-17','18:25:00',1.65),('8902','2014-04-17','18:30:00',1.17),('8902','2014-04-17','18:35:00',1.32),('8902','2014-04-17','18:40:00',1.12),('8902','2014-04-17','18:45:00',1.07),('8902','2013-11-06','07:50:00',1.08),('8902','2013-11-06','07:55:00',1.44),('8902','2013-11-06','08:00:00',1.64),('8902','2013-11-06','08:05:00',1.81),('8902','2013-11-06','08:10:00',1.97),('8902','2013-11-06','08:15:00',2.14),('8902','2013-11-06','08:20:00',2.28),('8902','2013-11-06','08:25:00',2.45),('8902','2013-11-06','08:30:00',2.62),('8902','2013-11-06','08:35:00',2.78),('8902','2013-11-06','08:40:00',2.97),('8902','2013-11-06','08:45:00',3.15),('8902','2013-11-06','08:50:00',3.31),('8902','2013-11-06','08:55:00',3.46),('8902','2013-11-06','09:00:00',3.6),('8902','2013-11-06','09:05:00',3.74),('8902','2013-11-06','09:10:00',3.86),('8902','2013-11-06','09:15:00',3.98),('8902','2013-11-06','09:20:00',4.09),('8902','2013-11-06','09:25:00',4.2),('8902','2013-11-06','09:30:00',4.31),('8902','2013-11-06','09:35:00',4.42),('8902','2013-11-06','09:40:00',4.54),('8902','2013-11-06','09:45:00',4.64),('8902','2013-11-06','09:50:00',4.74),('8902','2013-11-06','09:55:00',4.82),('8902','2013-11-06','10:00:00',4.89),('8902','2013-11-06','10:05:00',4.94),('8902','2013-11-06','10:10:00',5.02),('8902','2013-11-06','10:15:00',5.11),('8902','2013-11-06','10:20:00',5.13),('8902','2013-11-06','10:25:00',5.19),('8902','2013-11-06','10:30:00',5.27),('8902','2013-11-06','10:35:00',5.34),('8902','2013-11-06','10:40:00',5.41),('8902','2013-11-06','10:45:00',5.44),('8902','2013-11-06','10:50:00',5.47),('8902','2013-11-06','10:55:00',5.49),('8902','2013-11-06','11:00:00',5.53),('8902','2013-11-06','11:05:00',5.56),('8902','2013-11-06','11:10:00',5.61),('8902','2013-11-06','11:15:00',5.6),('8902','2013-11-06','11:20:00',5.61),('8902','2013-11-06','11:25:00',5.62),('8902','2013-11-06','11:30:00',5.57),('8902','2013-11-06','11:35:00',5.62),('8902','2013-11-06','11:40:00',5.66),('8902','2013-11-06','11:45:00',5.7),('8902','2013-11-06','11:50:00',5.63),('8902','2013-11-06','11:55:00',5.63),('8902','2013-11-06','12:00:00',5.65),('8902','2013-11-06','12:05:00',5.67),('8902','2013-11-06','12:10:00',5.65),('8902','2013-11-06','12:15:00',5.66),('8902','2013-11-06','12:20:00',5.65),('8902','2013-11-06','12:25:00',5.57),('8902','2013-11-06','12:30:00',5.51),('8902','2013-11-06','12:35:00',5.57),('8902','2013-11-06','12:40:00',5.5),('8902','2013-11-06','12:45:00',5.34),('8902','2013-11-06','12:50:00',5.44),('8902','2013-11-06','12:55:00',5.58),('8902','2013-11-06','13:00:00',5.51),('8902','2013-11-06','13:05:00',5.86),('8902','2013-11-06','13:10:00',5.38),('8902','2013-11-06','13:15:00',5.79),('8902','2013-11-06','13:20:00',4.53),('8902','2013-11-06','13:25:00',1.58),('8902','2013-11-06','13:30:00',1.79),('8902','2013-11-06','13:35:00',3.92),('8902','2013-11-06','13:40:00',5.61),('8902','2013-11-06','13:45:00',2.63),('8902','2013-11-06','13:50:00',4.86),('8902','2013-11-06','13:55:00',4.76),('8902','2013-11-06','14:00:00',2.31),('8902','2013-11-06','14:05:00',3.09),('8902','2013-11-06','14:10:00',2.97),('8902','2013-11-06','14:15:00',2.8),('8902','2013-11-06','14:20:00',2.41),('8902','2013-11-06','14:25:00',2.49),('8902','2013-11-06','14:30:00',3.05),('8902','2013-11-06','14:35:00',3.95),('8902','2013-11-06','14:40:00',4.42),('8902','2013-11-06','14:45:00',4.03),('8902','2013-11-06','14:50:00',3.84),('8902','2013-11-06','14:55:00',3.69),('8902','2013-11-06','15:00:00',3.55),('8902','2013-11-06','15:05:00',3.4),('8902','2013-11-06','15:10:00',3.3),('8902','2013-11-06','15:15:00',3.04),('8902','2013-11-06','15:20:00',2.85),('8902','2013-11-06','15:25:00',2.7),('8902','2013-11-06','15:30:00',2.56),('8902','2013-11-06','15:35:00',2.37),('8902','2013-11-06','15:40:00',2.18),('8902','2013-11-06','15:45:00',1.99),('8902','2013-11-06','15:50:00',1.8),('8902','2013-11-06','15:55:00',1.6),('8902','2013-11-06','16:00:00',1.42),('8902','2013-11-06','16:05:00',1.25),('8902','2013-11-06','16:10:00',1.08),('8902','2013-11-05','08:00:00',1.27),('8902','2013-11-05','08:05:00',1.4),('8902','2013-11-05','08:10:00',2.06),('8902','2013-11-05','08:15:00',2.45),('8902','2013-11-05','08:20:00',2.36),('8902','2013-11-05','08:25:00',1.1),('8902','2013-11-05','08:30:00',1.22),('8902','2013-11-05','08:35:00',2.98),('8902','2013-11-05','08:40:00',3.07),('8902','2013-11-05','08:45:00',3.24),('8902','2013-11-05','08:50:00',3.55),('8902','2013-11-05','08:55:00',3.42),('8902','2013-11-05','09:00:00',2.46),('8902','2013-11-05','09:05:00',2.66),('8902','2013-11-05','09:10:00',2.22),('8902','2013-11-05','09:15:00',3.36),('8902','2013-11-05','09:20:00',4),('8902','2013-11-05','09:25:00',4.22),('8902','2013-11-05','09:30:00',4.54),('8902','2013-11-05','09:35:00',4.63),('8902','2013-11-05','09:40:00',4.74),('8902','2013-11-05','09:45:00',4.82),('8902','2013-11-05','09:50:00',4.89),('8902','2013-11-05','09:55:00',4.96),('8902','2013-11-05','10:00:00',5.06),('8902','2013-11-05','10:05:00',5.14),('8902','2013-11-05','10:10:00',5.23),('8902','2013-11-05','10:15:00',5.29),('8902','2013-11-05','10:20:00',5.37),('8902','2013-11-05','10:25:00',5.46),('8902','2013-11-05','10:30:00',5.59),('8902','2013-11-05','10:35:00',5.65),('8902','2013-11-05','10:40:00',5.71),('8902','2013-11-05','10:45:00',5.74),('8902','2013-11-05','10:50:00',5.84),('8902','2013-11-05','10:55:00',5.89),('8902','2013-11-05','11:00:00',5.88),('8902','2013-11-05','11:05:00',5.91),('8902','2013-11-05','11:10:00',5.95),('8902','2013-11-05','11:15:00',5.95),('8902','2013-11-05','11:20:00',6.01),('8902','2013-11-05','11:25:00',6.06),('8902','2013-11-05','11:30:00',6.1),('8902','2013-11-05','11:35:00',6.07),('8902','2013-11-05','11:40:00',6.07),('8902','2013-11-05','11:45:00',6.12),('8902','2013-11-05','11:50:00',6.17),('8902','2013-11-05','11:55:00',6.15),('8902','2013-11-05','12:00:00',6.15),('8902','2013-11-05','12:05:00',6.16),('8902','2013-11-05','12:10:00',6.16),('8902','2013-11-05','12:15:00',6.16),('8902','2013-11-05','12:20:00',6.15),('8902','2013-11-05','12:25:00',6.14),('8902','2013-11-05','12:30:00',6.12),('8902','2013-11-05','12:35:00',6.08),('8902','2013-11-05','12:40:00',6.02),('8902','2013-11-05','12:45:00',5.99),('8902','2013-11-05','12:50:00',5.97),('8902','2013-11-05','12:55:00',5.93),('8902','2013-11-05','13:00:00',5.87),('8902','2013-11-05','13:05:00',5.83),('8902','2013-11-05','13:10:00',5.78),('8902','2013-11-05','13:15:00',5.7),('8902','2013-11-05','13:20:00',5.67),('8902','2013-11-05','13:25:00',5.59),('8902','2013-11-05','13:30:00',5.55),('8902','2013-11-05','13:35:00',5.49),('8902','2013-11-05','13:40:00',5.4),('8902','2013-11-05','13:45:00',5.29),('8902','2013-11-05','13:50:00',5.21),('8902','2013-11-05','13:55:00',5.19),('8902','2013-11-05','14:00:00',5.13),('8902','2013-11-05','14:05:00',5.03),('8902','2013-11-05','14:10:00',4.94),('8902','2013-11-05','14:15:00',4.84),('8902','2013-11-05','14:20:00',4.74),('8902','2013-11-05','14:25:00',4.64),('8902','2013-11-05','14:30:00',4.52),('8902','2013-11-05','14:35:00',4.4),('8902','2013-11-05','14:40:00',4.29),('8902','2013-11-05','14:45:00',4.15),('8902','2013-11-05','14:50:00',3.99),('8902','2013-11-05','14:55:00',3.77),('8902','2013-11-05','15:00:00',3.64),('8902','2013-11-05','15:05:00',3.5),('8902','2013-11-05','15:10:00',3.36),('8902','2013-11-05','15:15:00',3.22),('8902','2013-11-05','15:20:00',3.02),('8902','2013-11-05','15:25:00',2.85),('8902','2013-11-05','15:30:00',2.66),('8902','2013-11-05','15:35:00',2.47),('8902','2013-11-05','15:40:00',2.27),('8902','2013-11-05','15:45:00',2.06),('8902','2013-11-05','15:50:00',1.88),('8902','2013-11-05','15:55:00',1.69),('8902','2013-11-05','16:00:00',1.53),('8902','2013-11-05','16:05:00',1.35),('8902','2013-11-05','16:10:00',1.19),('8902','2013-11-05','16:15:00',1.02),('8902','2013-11-04','08:15:00',1.02),('8902','2013-11-04','08:20:00',1.3),('8902','2013-11-04','08:25:00',2.3),('8902','2013-11-04','08:30:00',3.08),('8902','2013-11-04','08:35:00',3.53),('8902','2013-11-04','08:40:00',3.64),('8902','2013-11-04','08:45:00',2.56),('8902','2013-11-04','08:50:00',1.25),('8902','2013-11-04','08:55:00',1.01),('8902','2013-11-04','09:50:00',1.09),('8902','2013-11-04','09:55:00',1.23),('8902','2013-11-04','10:00:00',1.43),('8902','2013-11-04','10:05:00',1.28),('8902','2013-11-04','10:10:00',1.22),('8902','2013-11-04','10:15:00',1.86),('8902','2013-11-04','10:20:00',3.38),('8902','2013-11-04','10:25:00',4.27),('8902','2013-11-04','10:30:00',3.84),('8902','2013-11-04','10:35:00',3.83),('8902','2013-11-04','10:40:00',3.45),('8902','2013-11-04','10:45:00',4.64),('8902','2013-11-04','10:50:00',3.08),('8902','2013-11-04','10:55:00',2.86),('8902','2013-11-04','11:00:00',2.23),('8902','2013-11-04','11:05:00',1.67),('8902','2013-11-04','11:10:00',1.32),('8902','2013-11-04','11:15:00',1.08),('8902','2013-11-04','11:20:00',1.18),('8902','2013-11-04','11:25:00',1.38),('8902','2013-11-04','11:30:00',1.58),('8902','2013-11-04','11:35:00',2.14),('8902','2013-11-04','11:40:00',2.85),('8902','2013-11-04','11:45:00',2.92),('8902','2013-11-04','11:50:00',2.6),('8902','2013-11-04','11:55:00',2.18),('8902','2013-11-04','12:00:00',2.04),('8902','2013-11-04','12:05:00',2.4),('8902','2013-11-04','12:10:00',3),('8902','2013-11-04','12:15:00',2.95),('8902','2013-11-04','12:20:00',3.63),('8902','2013-11-04','12:25:00',3.82),('8902','2013-11-04','12:30:00',2.24),('8902','2013-11-04','12:35:00',1.63),('8902','2013-11-04','12:40:00',1.35),('8902','2013-11-04','12:45:00',1.24),('8902','2013-11-04','12:50:00',1.15),('8902','2013-11-04','12:55:00',1.52),('8902','2013-11-04','13:00:00',1.79),('8902','2013-11-04','13:05:00',1.66),('8902','2013-11-04','13:10:00',1.63),('8902','2013-11-04','13:15:00',1.25),('8902','2013-11-04','13:20:00',1.05),('8902','2013-11-04','13:25:00',1.25),('8902','2013-11-04','13:30:00',2.07),('8902','2013-11-04','13:35:00',4.56),('8902','2013-11-04','13:40:00',4.93),('8902','2013-11-04','13:45:00',4.4),('8902','2013-11-04','13:50:00',3.48),('8902','2013-11-04','13:55:00',2.21),('8902','2013-11-04','14:00:00',2.45),('8902','2013-11-04','14:05:00',2.11),('8902','2013-11-04','14:10:00',5.27),('8902','2013-11-04','14:15:00',3.36),('8902','2013-11-04','14:20:00',1.52),('8902','2013-11-04','14:25:00',4.83),('8902','2013-11-04','14:30:00',4.45),('8902','2013-11-04','14:35:00',2.36),('8902','2013-11-04','14:40:00',1.52),('8902','2013-11-04','14:45:00',1.82),('8902','2013-11-04','14:50:00',1.6),('8902','2013-11-04','15:00:00',1.72),('8902','2013-11-04','15:05:00',1.73),('8902','2013-11-04','15:20:00',2.11),('8902','2013-11-04','15:30:00',1.85),('8902','2013-11-04','15:35:00',2.78),('8902','2013-11-04','16:05:00',1.9),('8902','2013-11-04','16:10:00',1.74),('8902','2013-11-03','07:55:00',1.41),('8902','2013-11-03','08:00:00',1.6),('8902','2013-11-03','08:05:00',1.78),('8902','2013-11-03','08:10:00',1.91),('8902','2013-11-03','08:15:00',2.04),('8902','2013-11-03','08:20:00',2.35),('8902','2013-11-03','08:25:00',2.5),('8902','2013-11-03','08:30:00',2.57),('8902','2013-11-03','08:35:00',2.17),('8902','2013-11-03','08:40:00',2.48),('8902','2013-11-03','08:45:00',1.47),('8902','2013-11-03','08:50:00',1.56),('8902','2013-11-03','09:10:00',2.75),('8902','2013-11-03','09:15:00',4.25),('8902','2013-11-03','09:20:00',4.99),('8902','2013-11-03','09:25:00',5.42),('8902','2013-11-03','09:30:00',3),('8902','2013-11-03','10:05:00',4.68),('8902','2013-11-03','10:10:00',5.49),('8902','2013-11-03','10:15:00',5.55),('8902','2013-11-03','10:20:00',5.69),('8902','2013-11-03','10:25:00',6.07),('8902','2013-11-03','10:30:00',4.98),('8902','2013-11-03','10:35:00',4.83),('8902','2013-11-03','10:40:00',6.52),('8902','2013-11-03','10:45:00',4.19),('8902','2013-11-03','10:50:00',2.98),('8902','2013-11-03','10:55:00',3.2),('8902','2013-11-03','11:00:00',5.54),('8902','2013-11-03','11:05:00',7.94),('8902','2013-11-03','11:10:00',6.82),('8902','2013-11-03','11:15:00',7.88),('8902','2013-11-03','11:20:00',6.18),('8902','2013-11-03','11:25:00',3.22),('8902','2013-11-03','11:30:00',4.14),('8902','2013-11-03','11:35:00',5.43),('8902','2013-11-03','11:40:00',4),('8902','2013-11-03','11:45:00',4.6),('8902','2013-11-03','11:50:00',7.67),('8902','2013-11-03','11:55:00',6.95),('8902','2013-11-03','12:00:00',7.03),('8902','2013-11-03','12:05:00',6.69),('8902','2013-11-03','12:10:00',6.16),('8902','2013-11-03','12:15:00',6.68),('8902','2013-11-03','12:20:00',6.63),('8902','2013-11-03','12:25:00',6.63),('8902','2013-11-03','12:30:00',6.42),('8902','2013-11-03','12:35:00',6),('8902','2013-11-03','12:40:00',4.91),('8902','2013-11-03','12:45:00',6.25),('8902','2013-11-03','12:50:00',6.3),('8902','2013-11-03','12:55:00',6.23),('8902','2013-11-03','13:00:00',6.22),('8902','2013-11-03','13:05:00',6.13),('8902','2013-11-03','13:10:00',5.78),('8902','2013-11-03','13:15:00',5.93),('8902','2013-11-03','13:20:00',6.04),('8902','2013-11-03','13:25:00',6.05),('8902','2013-11-03','13:30:00',5.9),('8902','2013-11-03','13:35:00',5.68),('8902','2013-11-03','13:40:00',5.97),('8902','2013-11-03','13:45:00',4.54),('8902','2013-11-03','13:50:00',5.8),('8902','2013-11-03','13:55:00',5.66),('8902','2013-11-03','14:00:00',3.97),('8902','2013-11-03','14:05:00',5.94),('8902','2013-11-03','14:10:00',3.51),('8902','2013-11-03','14:15:00',4.98),('8902','2013-11-03','14:20:00',4.86),('8902','2013-11-03','14:25:00',5.37),('8902','2013-11-03','14:30:00',4.92),('8902','2013-11-03','14:35:00',3.77),('8902','2013-11-03','14:40:00',4.61),('8902','2013-11-03','14:45:00',2.81),('8902','2013-11-03','14:50:00',3.42),('8902','2013-11-03','14:55:00',3.95),('8902','2013-11-03','15:00:00',4.01),('8902','2013-11-03','15:05:00',2.63),('8902','2013-11-03','15:10:00',2),('8902','2013-11-03','15:15:00',3.37),('8902','2013-11-03','15:20:00',2.87),('8902','2013-11-03','15:25:00',3.19),('8902','2013-11-03','15:30:00',2.99),('8902','2013-11-03','15:35:00',2.98),('8902','2013-11-03','15:40:00',2.86),('8902','2013-11-03','15:45:00',2.61),('8902','2013-11-03','15:50:00',2.05),('8902','2013-11-02','07:35:00',1.15),('8902','2013-11-02','07:40:00',1.16),('8902','2013-11-02','07:45:00',1.34),('8902','2013-11-02','07:50:00',1.28),('8902','2013-11-02','07:55:00',1.35),('8902','2013-11-02','08:00:00',1.56),('8902','2013-11-02','08:05:00',1.72),('8902','2013-11-02','08:10:00',1.06),('8902','2013-11-02','08:20:00',2.23),('8902','2013-11-02','08:25:00',1.79),('8902','2013-11-02','08:30:00',1.44),('8902','2013-11-02','08:35:00',2.29),('8902','2013-11-02','08:40:00',2.31),('8902','2013-11-02','08:45:00',2.26),('8902','2013-11-02','08:50:00',2.78),('8902','2013-11-02','08:55:00',2),('8902','2013-11-02','09:00:00',1.12),('8902','2013-11-02','09:05:00',1.14),('8902','2013-11-02','09:10:00',1.04),('8902','2013-11-02','09:35:00',1.43),('8902','2013-11-02','09:40:00',4.17),('8902','2013-11-02','09:45:00',4.03),('8902','2013-11-02','09:50:00',1.75),('8902','2013-11-02','09:55:00',1.13),('8902','2013-11-02','10:05:00',1.21),('8902','2013-11-02','10:10:00',3.74),('8902','2013-11-02','10:15:00',1.16),('8902','2013-11-02','10:20:00',2.62),('8902','2013-11-02','10:25:00',4.93),('8902','2013-11-02','10:30:00',3.18),('8902','2013-11-02','10:35:00',3.67),('8902','2013-11-02','11:10:00',1.16),('8902','2013-11-02','11:15:00',1.85),('8902','2013-11-02','11:20:00',3.21),('8902','2013-11-02','11:25:00',4),('8902','2013-11-02','11:30:00',3.88),('8902','2013-11-02','11:35:00',5.83),('8902','2013-11-02','11:40:00',6.33),('8902','2013-11-02','11:45:00',6.56),('8902','2013-11-02','11:50:00',6.69),('8902','2013-11-02','11:55:00',7.15),('8902','2013-11-02','12:00:00',4.82),('8902','2013-11-02','12:05:00',7.14),('8902','2013-11-02','12:10:00',7.94),('8902','2013-11-02','12:15:00',3.02),('8902','2013-11-02','12:20:00',3),('8902','2013-11-02','12:25:00',3.8),('8902','2013-11-02','12:30:00',3.8),('8902','2013-11-02','12:35:00',3.5),('8902','2013-11-02','12:40:00',2.44),('8902','2013-11-02','12:45:00',2.23),('8902','2013-11-02','12:50:00',1.93),('8902','2013-11-02','12:55:00',1.42),('8902','2013-11-02','13:05:00',1.11),('8902','2013-11-02','13:10:00',1.57),('8902','2013-11-02','13:15:00',1.56),('8902','2013-11-02','13:20:00',1.52),('8902','2013-11-02','13:25:00',1.86),('8902','2013-11-02','13:30:00',1.86),('8902','2013-11-02','13:35:00',1.53),('8902','2013-11-02','13:40:00',2.58),('8902','2013-11-02','13:45:00',3.35),('8902','2013-11-02','13:50:00',4.47),('8902','2013-11-02','13:55:00',1.67),('8902','2013-11-02','14:00:00',2.46),('8902','2013-11-02','14:05:00',4.02),('8902','2013-11-02','14:10:00',3.64),('8902','2013-11-02','14:15:00',2.05),('8902','2013-11-02','14:20:00',2.76),('8902','2013-11-02','14:25:00',3.39),('8902','2013-11-02','14:30:00',2.88),('8902','2013-11-02','14:35:00',1.54),('8902','2013-11-02','14:40:00',4.28),('8902','2013-11-02','14:45:00',2.34),('8902','2013-11-02','14:50:00',1.5),('8902','2013-11-02','14:55:00',1.38),('8902','2013-11-02','15:00:00',1.22),('8902','2013-11-02','15:05:00',1.19),('8902','2013-11-02','15:10:00',1.03),('8902','2013-11-02','15:15:00',1.03),('8902','2013-11-02','15:20:00',1.69),('8902','2013-11-01','07:55:00',1.34),('8902','2013-11-01','08:00:00',1.57),('8902','2013-11-01','08:05:00',1.71),('8902','2013-11-01','08:10:00',1.86),('8902','2013-11-01','08:15:00',2.03),('8902','2013-11-01','08:20:00',2.2),('8902','2013-11-01','08:25:00',2.34),('8902','2013-11-01','08:30:00',2.52),('8902','2013-11-01','08:35:00',2.72),('8902','2013-11-01','08:40:00',2.9),('8902','2013-11-01','08:45:00',3.06),('8902','2013-11-01','08:50:00',3.19),('8902','2013-11-01','08:55:00',3.34),('8902','2013-11-01','09:00:00',3.52),('8902','2013-11-01','09:05:00',3.81),('8902','2013-11-01','09:10:00',4.19),('8902','2013-11-01','09:15:00',2.83),('8902','2013-11-01','09:20:00',3.69),('8902','2013-11-01','09:25:00',3.97),('8902','2013-11-01','09:30:00',4.42),('8902','2013-11-01','09:35:00',4.41),('8902','2013-11-01','09:40:00',4.2),('8902','2013-11-01','09:45:00',3.81),('8902','2013-11-01','09:50:00',5.03),('8902','2013-11-01','09:55:00',5.07),('8902','2013-11-01','10:00:00',5.47),('8902','2013-11-01','10:05:00',6.18),('8902','2013-11-01','10:10:00',3.38),('8902','2013-11-01','10:15:00',2.42),('8902','2013-11-01','10:20:00',1.81),('8902','2013-11-01','10:25:00',1.33),('8902','2013-11-01','10:30:00',1.19),('8902','2013-11-01','10:35:00',1.44),('8902','2013-11-01','10:40:00',1.45),('8902','2013-11-01','10:45:00',1.5),('8902','2013-11-01','10:50:00',1.35),('8902','2013-11-01','10:55:00',1.51),('8902','2013-11-01','11:00:00',2.28),('8902','2013-11-01','11:05:00',2.59),('8902','2013-11-01','11:10:00',2.21),('8902','2013-11-01','11:15:00',1.57),('8902','2013-11-01','11:25:00',1.16),('8902','2013-11-01','11:30:00',1.38),('8902','2013-11-01','11:35:00',1.51),('8902','2013-11-01','11:40:00',1.83),('8902','2013-11-01','11:45:00',1.84),('8902','2013-11-01','11:50:00',2.15),('8902','2013-11-01','11:55:00',3.91),('8902','2013-11-01','12:00:00',6.16),('8902','2013-11-01','12:05:00',6.93),('8902','2013-11-01','12:10:00',6.27),('8902','2013-11-01','12:15:00',5.76),('8902','2013-11-01','12:20:00',7.5),('8902','2013-11-01','12:25:00',7.15),('8902','2013-11-01','12:30:00',7.37),('8902','2013-11-01','12:35:00',7.22),('8902','2013-11-01','12:40:00',6.41),('8902','2013-11-01','12:45:00',5.58),('8902','2013-11-01','12:50:00',5.78),('8902','2013-11-01','12:55:00',6.53),('8902','2013-11-01','13:00:00',6.22),('8902','2013-11-01','13:05:00',6.44),('8902','2013-11-01','13:10:00',6.8),('8902','2013-11-01','13:15:00',6.62),('8902','2013-11-01','13:20:00',1.92),('8902','2013-11-01','13:25:00',1.85),('8902','2013-11-01','13:30:00',4.14),('8902','2013-11-01','13:35:00',6.81),('8902','2013-11-01','13:40:00',6.62),('8902','2013-11-01','13:45:00',5.48),('8902','2013-11-01','13:50:00',6.79),('8902','2013-11-01','13:55:00',6.54),('8902','2013-11-01','14:00:00',6.06),('8902','2013-11-01','14:05:00',5.36),('8902','2013-11-01','14:10:00',5.09),('8902','2013-11-01','14:15:00',4.91),('8902','2013-11-01','14:20:00',4.74),('8902','2013-11-01','14:25:00',4.58),('8902','2013-11-01','14:30:00',4.49),('8902','2013-11-01','14:35:00',4.38),('8902','2013-11-01','14:40:00',4.27),('8902','2013-11-01','14:45:00',4.07),('8902','2013-11-01','14:50:00',3.97),('8902','2013-11-01','14:55:00',3.83),('8902','2013-11-01','15:00:00',3.59),('8902','2013-11-01','15:05:00',3.29),('8902','2013-11-01','15:10:00',3.21),('8902','2013-11-01','15:15:00',2.67),('8902','2013-11-01','15:35:00',1.44),('8902','2013-11-01','15:40:00',1.64),('8902','2013-11-01','15:45:00',2.38),('8902','2013-11-01','15:50:00',1.74),('8902','2013-11-01','15:55:00',1.33),('8902','2013-11-01','16:15:00',1.14),('8902','2013-10-31','07:45:00',1.04),('8902','2013-10-31','07:50:00',1.12),('8902','2013-10-31','07:55:00',1.26),('8902','2013-10-31','08:00:00',1.44),('8902','2013-10-31','08:05:00',1.37),('8902','2013-10-31','08:10:00',1.42),('8902','2013-10-31','08:15:00',1.59),('8902','2013-10-31','08:20:00',1.93),('8902','2013-10-31','08:25:00',2.04),('8902','2013-10-31','08:30:00',2.39),('8902','2013-10-31','08:35:00',2.62),('8902','2013-10-31','08:40:00',2.89),('8902','2013-10-31','08:45:00',3.01),('8902','2013-10-31','08:50:00',2.91),('8902','2013-10-31','08:55:00',3.05),('8902','2013-10-31','09:00:00',3.21),('8902','2013-10-31','09:05:00',3.59),('8902','2013-10-31','09:10:00',3.77),('8902','2013-10-31','09:15:00',3.87),('8902','2013-10-31','09:20:00',4),('8902','2013-10-31','09:25:00',4.13),('8902','2013-10-31','09:30:00',4.23),('8902','2013-10-31','09:35:00',4.34),('8902','2013-10-31','09:40:00',4.47),('8902','2013-10-31','09:45:00',4.59),('8902','2013-10-31','09:50:00',4.73),('8902','2013-10-31','09:55:00',4.82),('8902','2013-10-31','10:00:00',4.89),('8902','2013-10-31','10:05:00',5),('8902','2013-10-31','10:10:00',5.1),('8902','2013-10-31','10:15:00',5.14),('8902','2013-10-31','10:20:00',5.23),('8902','2013-10-31','10:25:00',5.33),('8902','2013-10-31','10:30:00',5.32),('8902','2013-10-31','10:35:00',5.32),('8902','2013-10-31','10:40:00',5.5),('8902','2013-10-31','10:45:00',5.38),('8902','2013-10-31','10:50:00',5.37),('8902','2013-10-31','10:55:00',5.4),('8902','2013-10-31','11:00:00',5.53),('8902','2013-10-31','11:05:00',5.36),('8902','2013-10-31','11:10:00',4.78),('8902','2013-10-31','11:15:00',5.09),('8902','2013-10-31','11:20:00',5.79),('8902','2013-10-31','11:25:00',6.13),('8902','2013-10-31','11:30:00',6.19),('8902','2013-10-31','11:35:00',6.03),('8902','2013-10-31','11:40:00',5.76),('8902','2013-10-31','11:45:00',5.12),('8902','2013-10-31','11:50:00',5.97),('8902','2013-10-31','11:55:00',6.25),('8902','2013-10-31','12:00:00',6.29),('8902','2013-10-31','12:05:00',6.17),('8902','2013-10-31','12:10:00',5.66),('8902','2013-10-31','12:15:00',5.77),('8902','2013-10-31','12:20:00',3.41),('8902','2013-10-31','12:25:00',2.15),('8902','2013-10-31','12:30:00',5.42),('8902','2013-10-31','12:35:00',4.24),('8902','2013-10-31','12:40:00',1.23),('8902','2013-10-31','12:45:00',1.01),('8902','2013-10-31','12:50:00',1.03),('8902','2013-10-31','12:55:00',1.04),('8902','2013-10-31','13:00:00',1.07),('8902','2013-10-31','13:05:00',1.29),('8902','2013-10-31','13:10:00',1.53),('8902','2013-10-31','13:15:00',1.93),('8902','2013-10-31','13:20:00',2.82),('8902','2013-10-31','13:25:00',2.63),('8902','2013-10-31','13:30:00',3.38),('8902','2013-10-31','13:35:00',2.72),('8902','2013-10-31','13:40:00',2.16),('8902','2013-10-31','13:45:00',2.53),('8902','2013-10-31','13:50:00',1.97),('8902','2013-10-31','13:55:00',1.96),('8902','2013-10-31','14:00:00',1.56),('8902','2013-10-31','14:05:00',1.52),('8902','2013-10-31','14:10:00',1.5),('8902','2013-10-31','14:15:00',1.5),('8902','2013-10-31','14:20:00',1.37),('8902','2013-10-31','14:25:00',1.1),('8902','2013-10-30','08:05:00',1.14),('8902','2013-10-30','08:10:00',1.3),('8902','2013-10-30','08:15:00',1.6),('8902','2013-10-30','08:20:00',1.8),('8902','2013-10-30','08:25:00',2.02),('8902','2013-10-30','08:30:00',2.49),('8902','2013-10-30','08:35:00',2.68),('8902','2013-10-30','08:40:00',3.11),('8902','2013-10-30','08:45:00',3.12),('8902','2013-10-30','08:50:00',2.98),('8902','2013-10-30','08:55:00',2.65),('8902','2013-10-30','09:00:00',3.29),('8902','2013-10-30','09:05:00',2.48),('8902','2013-10-30','09:10:00',1.49),('8902','2013-10-30','09:15:00',1.83),('8902','2013-10-30','09:20:00',1.71),('8902','2013-10-30','09:25:00',1.88),('8902','2013-10-30','09:30:00',2.8),('8902','2013-10-30','09:35:00',3.47),('8902','2013-10-30','09:40:00',3.16),('8902','2013-10-30','09:45:00',2.23),('8902','2013-10-30','09:50:00',3.17),('8902','2013-10-30','09:55:00',3.81),('8902','2013-10-30','10:00:00',3.62),('8902','2013-10-30','10:05:00',3.13),('8902','2013-10-30','10:10:00',2.58),('8902','2013-10-30','10:15:00',2.43),('8902','2013-10-30','10:20:00',3.53),('8902','2013-10-30','10:25:00',3.49),('8902','2013-10-30','10:30:00',3.36),('8902','2013-10-30','10:35:00',3.52),('8902','2013-10-30','10:40:00',3.55),('8902','2013-10-30','10:45:00',3.48),('8902','2013-10-30','10:50:00',3.68),('8902','2013-10-30','10:55:00',4.44),('8902','2013-10-30','11:00:00',5.49),('8902','2013-10-30','11:05:00',5.79),('8902','2013-10-30','11:10:00',5.61),('8902','2013-10-30','11:15:00',4.67),('8902','2013-10-30','11:20:00',5.17),('8902','2013-10-30','11:25:00',5.04),('8902','2013-10-30','11:30:00',5.25),('8902','2013-10-30','11:35:00',5.05),('8902','2013-10-30','11:40:00',5.38),('8902','2013-10-30','11:45:00',5.76),('8902','2013-10-30','11:50:00',5.81),('8902','2013-10-30','11:55:00',5.84),('8902','2013-10-30','12:00:00',5.77),('8902','2013-10-30','12:05:00',5.64),('8902','2013-10-30','12:10:00',5.58),('8902','2013-10-30','12:15:00',5.64),('8902','2013-10-30','12:20:00',5.6),('8902','2013-10-30','12:25:00',5.65),('8902','2013-10-30','12:30:00',5.49),('8902','2013-10-30','12:35:00',5.51),('8902','2013-10-30','12:40:00',5.56),('8902','2013-10-30','12:45:00',5.79),('8902','2013-10-30','12:50:00',5.83),('8902','2013-10-30','12:55:00',5.91),('8902','2013-10-30','13:00:00',5.72),('8902','2013-10-30','13:05:00',5.66),('8902','2013-10-30','13:10:00',5.62),('8902','2013-10-30','13:15:00',5.54),('8902','2013-10-30','13:20:00',5.53),('8902','2013-10-30','13:25:00',5.42),('8902','2013-10-30','13:30:00',5.33),('8902','2013-10-30','13:35:00',5.02),('8902','2013-10-30','13:40:00',4.25),('8902','2013-10-30','13:45:00',4.59),('8902','2013-10-30','13:50:00',3.38),('8902','2013-10-30','13:55:00',3.88),('8902','2013-10-30','14:00:00',4.85),('8902','2013-10-30','14:05:00',4.81),('8902','2013-10-30','14:10:00',4.51),('8902','2013-10-30','14:15:00',4.03),('8902','2013-10-30','14:20:00',2.72),('8902','2013-10-30','14:25:00',4.13),('8902','2013-10-30','14:30:00',2.68),('8902','2013-10-30','14:35:00',2.48),('8902','2013-10-30','14:40:00',2.98),('8902','2013-10-30','14:45:00',3.11),('8902','2013-10-30','14:50:00',2.94),('8902','2013-10-30','14:55:00',2.33),('8902','2013-10-30','15:00:00',2.55),('8902','2013-10-30','15:05:00',2.4),('8902','2013-10-30','15:10:00',2.33),('8902','2013-10-30','15:15:00',2.15),('8902','2013-10-30','15:20:00',2.01),('8902','2013-10-30','15:25:00',1.92),('8902','2013-10-30','15:30:00',1.76),('8902','2013-10-30','15:35:00',1.75),('8902','2013-10-30','15:40:00',1.74),('8902','2013-10-30','15:45:00',1.51),('8902','2013-10-30','15:50:00',1.38),('8902','2013-10-30','15:55:00',1.31),('8902','2013-10-30','16:00:00',1.12),('8902','2013-10-29','07:45:00',1.03),('8902','2013-10-29','07:50:00',1.15),('8902','2013-10-29','07:55:00',1.24),('8902','2013-10-29','08:00:00',1.32),('8902','2013-10-29','08:05:00',1.48),('8902','2013-10-29','08:10:00',1.84),('8902','2013-10-29','08:15:00',1.98),('8902','2013-10-29','08:20:00',2.12),('8902','2013-10-29','08:25:00',2.27),('8902','2013-10-29','08:30:00',2.41),('8902','2013-10-29','08:35:00',2.6),('8902','2013-10-29','08:40:00',2.81),('8902','2013-10-29','08:45:00',3),('8902','2013-10-29','08:50:00',3.06),('8902','2013-10-29','08:55:00',3.07),('8902','2013-10-29','09:00:00',3.2),('8902','2013-10-29','09:05:00',3.45),('8902','2013-10-29','09:10:00',3.73),('8902','2013-10-29','09:15:00',3.83),('8902','2013-10-29','09:20:00',3.95),('8902','2013-10-29','09:25:00',4.06),('8902','2013-10-29','09:30:00',4.15),('8902','2013-10-29','09:35:00',4.32),('8902','2013-10-29','09:40:00',4.43),('8902','2013-10-29','09:45:00',4.53),('8902','2013-10-29','09:50:00',4.64),('8902','2013-10-29','09:55:00',4.62),('8902','2013-10-29','10:00:00',4.41),('8902','2013-10-29','10:05:00',4.66),('8902','2013-10-29','10:10:00',4.57),('8902','2013-10-29','10:15:00',4.94),('8902','2013-10-29','10:20:00',4.83),('8902','2013-10-29','10:25:00',4.7),('8902','2013-10-29','10:30:00',4.99),('8902','2013-10-29','10:35:00',4.87),('8902','2013-10-29','10:40:00',4.33),('8902','2013-10-29','10:45:00',4.78),('8902','2013-10-29','10:50:00',2.32),('8902','2013-10-29','10:55:00',1.88),('8902','2013-10-29','11:00:00',2.69),('8902','2013-10-29','11:05:00',4.27),('8902','2013-10-29','11:10:00',4.65),('8902','2013-10-29','11:15:00',5.11),('8902','2013-10-29','11:20:00',5.46),('8902','2013-10-29','11:25:00',3.02),('8902','2013-10-29','11:30:00',2.45),('8902','2013-10-29','11:35:00',3.14),('8902','2013-10-29','11:40:00',2.55),('8902','2013-10-29','11:45:00',2.47),('8902','2013-10-29','11:50:00',3.86),('8902','2013-10-29','11:55:00',2.82),('8902','2013-10-29','12:00:00',1.76),('8902','2013-10-29','12:05:00',1.98),('8902','2013-10-29','12:10:00',2.09),('8902','2013-10-29','12:15:00',1.94),('8902','2013-10-29','12:20:00',2.07),('8902','2013-10-29','12:25:00',3.33),('8902','2013-10-29','12:30:00',5.16),('8902','2013-10-29','12:35:00',3.3),('8902','2013-10-29','12:40:00',2.62),('8902','2013-10-29','12:45:00',4.24),('8902','2013-10-29','12:50:00',4.9),('8902','2013-10-29','12:55:00',4.15),('8902','2013-10-29','13:00:00',4.65),('8902','2013-10-29','13:05:00',4.44),('8902','2013-10-29','13:10:00',3.41),('8902','2013-10-29','13:15:00',3.02),('8902','2013-10-29','13:20:00',4.51),('8902','2013-10-29','13:25:00',3.51),('8902','2013-10-29','13:30:00',3.55),('8902','2013-10-29','13:35:00',4.52),('8902','2013-10-29','13:40:00',4.72),('8902','2013-10-29','13:45:00',4.78),('8902','2013-10-29','13:50:00',4.97),('8902','2013-10-29','13:55:00',4.18),('8902','2013-10-29','14:00:00',3.27),('8902','2013-10-29','14:05:00',5.04),('8902','2013-10-29','14:10:00',5.37),('8902','2013-10-29','14:15:00',3.02),('8902','2013-10-29','14:20:00',1.67),('8902','2013-10-29','14:25:00',1.65),('8902','2013-10-29','14:30:00',1.4),('8902','2013-10-29','14:35:00',1.51),('8902','2013-10-29','14:40:00',3.18),('8902','2013-10-29','14:45:00',3.84),('8902','2013-10-29','14:50:00',3.66),('8902','2013-10-29','14:55:00',2.58),('8902','2013-10-29','15:20:00',2.12),('8902','2013-10-29','15:25:00',2.38),('8902','2013-10-29','15:30:00',1.7),('8902','2013-10-29','16:00:00',1.18),('8902','2013-10-28','08:00:00',1.02),('8902','2013-10-28','08:05:00',1.06),('8902','2013-10-28','08:10:00',1.19),('8902','2013-10-28','08:15:00',1.28),('8902','2013-10-28','08:20:00',1.44),('8902','2013-10-28','08:25:00',1.51),('8902','2013-10-28','08:30:00',1.92),('8902','2013-10-28','08:35:00',1.76),('8902','2013-10-28','08:40:00',2.39),('8902','2013-10-28','08:45:00',2.53),('8902','2013-10-28','08:50:00',3.23),('8902','2013-10-28','08:55:00',3.47),('8902','2013-10-28','09:00:00',3.57),('8902','2013-10-28','09:05:00',3.7),('8902','2013-10-28','09:10:00',3.78),('8902','2013-10-28','09:15:00',3.78),('8902','2013-10-28','09:20:00',4.05),('8902','2013-10-28','09:25:00',4.12),('8902','2013-10-28','09:30:00',4.29),('8902','2013-10-28','09:35:00',4.49),('8902','2013-10-28','09:40:00',4.71),('8902','2013-10-28','09:45:00',4.76),('8902','2013-10-28','09:50:00',4.89),('8902','2013-10-28','09:55:00',4.89),('8902','2013-10-28','10:00:00',4.23),('8902','2013-10-28','10:05:00',3.81),('8902','2013-10-28','10:10:00',4.37),('8902','2013-10-28','10:15:00',4.37),('8902','2013-10-28','10:20:00',4.95),('8902','2013-10-28','10:25:00',4.03),('8902','2013-10-28','10:30:00',4.58),('8902','2013-10-28','10:35:00',6.08),('8902','2013-10-28','10:40:00',5.99),('8902','2013-10-28','10:45:00',5.9),('8902','2013-10-28','10:50:00',6.02),('8902','2013-10-28','10:55:00',6.25),('8902','2013-10-28','11:00:00',6.26),('8902','2013-10-28','11:05:00',6.26),('8902','2013-10-28','11:10:00',5.3),('8902','2013-10-28','11:15:00',5.65),('8902','2013-10-28','11:20:00',3.59),('8902','2013-10-28','11:25:00',2.88),('8902','2013-10-28','11:30:00',4.06),('8902','2013-10-28','11:35:00',6.18),('8902','2013-10-28','11:40:00',5.97),('8902','2013-10-28','11:45:00',6.16),('8902','2013-10-28','11:50:00',6.04),('8902','2013-10-28','11:55:00',5.9),('8902','2013-10-28','12:00:00',5.7),('8902','2013-10-28','12:05:00',5.87),('8902','2013-10-28','12:10:00',5.86),('8902','2013-10-28','12:15:00',5.86),('8902','2013-10-28','12:20:00',5.85),('8902','2013-10-28','12:25:00',5.82),('8902','2013-10-28','12:30:00',5.75),('8902','2013-10-28','12:35:00',5.53),('8902','2013-10-28','12:40:00',5.6),('8902','2013-10-28','12:45:00',5.73),('8902','2013-10-28','12:50:00',5.75),('8902','2013-10-28','12:55:00',5.54),('8902','2013-10-28','13:00:00',5.5),('8902','2013-10-28','13:05:00',5.26),('8902','2013-10-28','13:10:00',5.32),('8902','2013-10-28','13:15:00',5.35),('8902','2013-10-28','13:20:00',5.25),('8902','2013-10-28','13:25:00',5.23),('8902','2013-10-28','13:30:00',5.1),('8902','2013-10-28','13:35:00',4.97),('8902','2013-10-28','13:40:00',5.12),('8902','2013-10-28','13:45:00',5.08),('8902','2013-10-28','13:50:00',4.97),('8902','2013-10-28','13:55:00',4.75),('8902','2013-10-28','14:00:00',4.64),('8902','2013-10-28','14:05:00',4.43),('8902','2013-10-28','14:10:00',4.59),('8902','2013-10-28','14:15:00',4.49),('8902','2013-10-28','14:20:00',4.39),('8902','2013-10-28','14:25:00',4.22),('8902','2013-10-28','14:30:00',4.08),('8902','2013-10-28','14:35:00',3.92),('8902','2013-10-28','14:40:00',3.79),('8902','2013-10-28','14:45:00',3.75),('8902','2013-10-28','14:50:00',3.58),('8902','2013-10-28','14:55:00',3.37),('8902','2013-10-28','15:00:00',3.17),('8902','2013-10-28','15:05:00',3.04),('8902','2013-10-28','15:10:00',2.95),('8902','2013-10-28','15:15:00',2.85),('8902','2013-10-28','15:20:00',2.66),('8902','2013-10-28','15:25:00',2.46),('8902','2013-10-28','15:30:00',2.33),('8902','2013-10-28','15:35:00',2.17),('8902','2013-10-28','15:40:00',1.99),('8902','2013-10-28','15:45:00',1.82),('8902','2013-10-28','15:50:00',1.63),('8902','2013-10-28','15:55:00',1.47),('8902','2013-10-28','16:00:00',1.32),('8902','2013-10-28','16:05:00',1.15),('8902','2013-10-28','16:10:00',1),('8902','2014-04-16','07:55:00',1.15),('8902','2014-04-16','08:00:00',1.6),('8902','2014-04-16','08:05:00',1.83),('8902','2014-04-16','08:10:00',2.04),('8902','2014-04-16','08:15:00',2.24),('8902','2014-04-16','08:20:00',2.31),('8902','2014-04-16','08:25:00',2.59),('8902','2014-04-16','08:30:00',2.77),('8902','2014-04-16','08:35:00',2.95),('8902','2014-04-16','08:40:00',3.14),('8902','2014-04-16','08:45:00',3.33),('8902','2014-04-16','08:50:00',3.54),('8902','2014-04-16','08:55:00',3.24),('8902','2014-04-16','09:00:00',3.14),('8902','2014-04-16','09:05:00',3.73),('8902','2014-04-16','09:10:00',4.23),('8902','2014-04-16','09:15:00',4.23),('8902','2014-04-16','09:20:00',4.56),('8902','2014-04-16','09:25:00',4.84),('8902','2014-04-16','09:30:00',5.02),('8902','2014-04-16','09:35:00',5.17),('8902','2014-04-16','09:40:00',5.35),('8902','2014-04-16','09:45:00',5.54),('8902','2014-04-16','09:50:00',5.7),('8902','2014-04-16','09:55:00',5.9),('8902','2014-04-16','10:00:00',6.16),('8902','2014-04-16','10:05:00',6.68),('8902','2014-04-16','10:10:00',6.4),('8902','2014-04-16','10:15:00',5.4),('8902','2014-04-16','10:20:00',6.5),('8902','2014-04-16','10:25:00',7.38),('8902','2014-04-16','10:30:00',7.81),('8902','2014-04-16','10:35:00',8.01),('8902','2014-04-16','10:40:00',7.65),('8902','2014-04-16','10:45:00',6.28),('8902','2014-04-16','10:50:00',4.94),('8902','2014-04-16','10:55:00',4.84),('8902','2014-04-16','11:00:00',4.82),('8902','2014-04-16','11:05:00',7.48),('8902','2014-04-16','11:10:00',6.49),('8902','2014-04-16','11:15:00',5.92),('8902','2014-04-16','11:20:00',6.22),('8902','2014-04-16','11:25:00',6.93),('8902','2014-04-16','11:30:00',4.85),('8902','2014-04-16','11:35:00',5.86),('8902','2014-04-16','11:40:00',5.27),('8902','2014-04-16','11:45:00',6.34),('8902','2014-04-16','11:50:00',4.79),('8902','2014-04-16','11:55:00',3.88),('8902','2014-04-16','12:00:00',4.06),('8902','2014-04-16','12:05:00',5.53),('8902','2014-04-16','12:10:00',5.47),('8902','2014-04-16','12:15:00',4.81),('8902','2014-04-16','12:20:00',4.62),('8902','2014-04-16','12:25:00',4.97),('8902','2014-04-16','12:30:00',6.15),('8902','2014-04-16','12:35:00',7.62),('8902','2014-04-16','12:40:00',8.74),('8902','2014-04-16','12:45:00',8.33),('8902','2014-04-16','12:50:00',8.62),('8902','2014-04-16','12:55:00',8.84),('8902','2014-04-16','13:00:00',8.87),('8902','2014-04-16','13:05:00',4.61),('8902','2014-04-16','13:10:00',1.87),('8902','2014-04-16','13:15:00',3.45),('8902','2014-04-16','13:20:00',3.87),('8902','2014-04-16','13:25:00',9.99),('8902','2014-04-16','13:30:00',8.38),('8902','2014-04-16','13:35:00',2.03),('8902','2014-04-16','13:40:00',1.82),('8902','2014-04-16','13:45:00',1.73),('8902','2014-04-16','13:50:00',1.95),('8902','2014-04-16','13:55:00',2.21),('8902','2014-04-16','14:00:00',2.17),('8902','2014-04-16','14:05:00',2.24),('8902','2014-04-16','14:10:00',4.3),('8902','2014-04-16','14:15:00',2.64),('8902','2014-04-16','14:20:00',2.63),('8902','2014-04-16','14:25:00',2.8),('8902','2014-04-16','14:30:00',2.99),('8902','2014-04-16','14:35:00',3.53),('8902','2014-04-16','14:40:00',5.94),('8902','2014-04-16','14:45:00',2.71),('8902','2014-04-16','14:50:00',1.78),('8902','2014-04-16','14:55:00',1.51),('8902','2014-04-16','15:00:00',1.65),('8902','2014-04-16','15:05:00',1.89),('8902','2014-04-16','15:10:00',1.85),('8902','2014-04-16','15:15:00',1.68),('8902','2014-04-16','15:20:00',1.67),('8902','2014-04-16','15:25:00',2.08),('8902','2014-04-16','15:30:00',3.35),('8902','2014-04-16','15:35:00',4.21),('8902','2014-04-16','15:40:00',3.27),('8902','2014-04-16','15:45:00',2.38),('8902','2014-04-16','15:50:00',2.21),('8902','2014-04-16','15:55:00',2.53),('8902','2014-04-16','16:00:00',2.29),('8902','2014-04-16','16:05:00',1.82),('8902','2014-04-16','16:10:00',2.02),('8902','2014-04-16','16:15:00',2.14),('8902','2014-04-16','16:20:00',2.09),('8902','2014-04-16','16:25:00',2.22),('8902','2014-04-16','16:30:00',2.35),('8902','2014-04-16','16:35:00',2.12),('8902','2014-04-16','16:40:00',2.38),('8902','2014-04-16','16:45:00',2.98),('8902','2014-04-16','16:50:00',3.03),('8902','2014-04-16','16:55:00',2.31),('8902','2014-04-16','17:00:00',1.93),('8902','2014-04-16','17:05:00',1.61),('8902','2014-04-16','17:10:00',1.59),('8902','2014-04-16','17:15:00',1.74),('8902','2014-04-16','17:20:00',2.1),('8902','2014-04-16','17:25:00',1.84),('8902','2014-04-16','17:30:00',1.85),('8902','2014-04-16','17:35:00',1.84),('8902','2014-04-16','17:40:00',1.79),('8902','2014-04-16','17:45:00',1.62),('8902','2014-04-16','17:50:00',1.34),('8902','2014-04-16','17:55:00',1.28),('8902','2014-04-16','18:00:00',1.06),('8902','2013-10-27','07:30:00',1.15),('8902','2013-10-27','07:35:00',1.36),('8902','2013-10-27','07:40:00',1.33),('8902','2013-10-27','08:10:00',1.31),('8902','2013-10-27','08:15:00',1.13),('8902','2013-10-27','08:20:00',1.23),('8902','2013-10-27','08:25:00',1.09),('8902','2013-10-27','08:30:00',1.12),('8902','2013-10-27','08:35:00',1.21),('8902','2013-10-27','08:40:00',1.23),('8902','2013-10-27','08:45:00',1.61),('8902','2013-10-27','08:50:00',2.51),('8902','2013-10-27','08:55:00',3.29),('8902','2013-10-27','09:00:00',3.71),('8902','2013-10-27','09:05:00',4.07),('8902','2013-10-27','09:10:00',4.41),('8902','2013-10-27','09:15:00',4.41),('8902','2013-10-27','09:20:00',4.16),('8902','2013-10-27','09:25:00',3.97),('8902','2013-10-27','09:30:00',4.69),('8902','2013-10-27','09:35:00',4.29),('8902','2013-10-27','09:40:00',2.53),('8902','2013-10-27','09:45:00',2.48),('8902','2013-10-27','09:50:00',4.73),('8902','2013-10-27','09:55:00',2.99),('8902','2013-10-27','10:00:00',1.99),('8902','2013-10-27','10:05:00',1.6),('8902','2013-10-27','10:10:00',1.63),('8902','2013-10-27','10:15:00',1.56),('8902','2013-10-27','10:20:00',1.68),('8902','2013-10-27','10:25:00',1.69),('8902','2013-10-27','10:30:00',1.71),('8902','2013-10-27','10:35:00',1.69),('8902','2013-10-27','10:40:00',1.35),('8902','2013-10-27','10:50:00',5.99),('8902','2013-10-27','10:55:00',5.91),('8902','2013-10-27','11:00:00',5.83),('8902','2013-10-27','11:05:00',5.99),('8902','2013-10-27','11:10:00',5.98),('8902','2013-10-27','11:15:00',6.02),('8902','2013-10-27','11:20:00',6.04),('8902','2013-10-27','11:25:00',6.08),('8902','2013-10-27','11:30:00',6.07),('8902','2013-10-27','11:35:00',6.05),('8902','2013-10-27','11:40:00',6.02),('8902','2013-10-27','11:45:00',6.03),('8902','2013-10-27','11:50:00',6.12),('8902','2013-10-27','11:55:00',5.79),('8902','2013-10-27','12:00:00',3.67),('8902','2013-10-27','12:05:00',5.55),('8902','2013-10-27','12:10:00',6.11),('8902','2013-10-27','12:15:00',6.44),('8902','2013-10-27','12:20:00',6.6),('8902','2013-10-27','12:25:00',5.32),('8902','2013-10-27','12:30:00',5.49),('8902','2013-10-27','12:35:00',7.1),('8902','2013-10-27','12:40:00',6.67),('8902','2013-10-27','12:45:00',6.59),('8902','2013-10-27','12:50:00',6.76),('8902','2013-10-27','12:55:00',6.49),('8902','2013-10-27','13:00:00',6.05),('8902','2013-10-27','13:05:00',5.96),('8902','2013-10-27','13:10:00',6.01),('8902','2013-10-27','13:15:00',5.68),('8902','2013-10-27','13:20:00',5.82),('8902','2013-10-27','13:25:00',4.92),('8902','2013-10-27','13:30:00',5.67),('8902','2013-10-27','13:35:00',5.57),('8902','2013-10-27','13:40:00',5.51),('8902','2013-10-27','13:45:00',5.52),('8902','2013-10-27','13:50:00',4.86),('8902','2013-10-27','13:55:00',5.16),('8902','2013-10-27','14:00:00',5.24),('8902','2013-10-27','14:05:00',5.27),('8902','2013-10-27','14:10:00',5.41),('8902','2013-10-27','14:15:00',5.14),('8902','2013-10-27','14:20:00',5.01),('8902','2013-10-27','14:25:00',5.18),('8902','2013-10-27','14:30:00',4.04),('8902','2013-10-27','14:35:00',3.98),('8902','2013-10-27','14:40:00',2.58),('8902','2013-10-27','14:45:00',3.08),('8902','2013-10-27','14:50:00',4.12),('8902','2013-10-27','14:55:00',3.81),('8902','2013-10-27','15:00:00',3.82),('8902','2013-10-27','15:05:00',3.66),('8902','2013-10-27','15:10:00',3.46),('8902','2013-10-27','15:15:00',2.74),('8902','2013-10-27','15:20:00',1.13),('8902','2013-10-27','15:25:00',2.5),('8902','2013-10-27','15:30:00',2.4),('8902','2013-10-27','15:40:00',1.4),('8902','2013-10-27','15:45:00',1.67),('8902','2013-10-27','15:50:00',2.36),('8902','2013-10-27','15:55:00',1.89),('8902','2013-10-27','16:00:00',1.63),('8902','2013-10-27','16:05:00',1.09),('8902','2013-10-27','16:15:00',1.01),('8902','2013-10-26','08:45:00',1.06),('8902','2013-10-26','08:50:00',1.09),('8902','2013-10-26','08:55:00',1.22),('8902','2013-10-26','09:00:00',1.38),('8902','2013-10-26','09:05:00',1.28),('8902','2013-10-26','09:10:00',1.03),('8902','2013-10-26','09:25:00',1.06),('8902','2013-10-26','09:30:00',1.18),('8902','2013-10-26','09:35:00',1.32),('8902','2013-10-26','09:40:00',1.45),('8902','2013-10-26','09:45:00',1.64),('8902','2013-10-26','09:50:00',1.76),('8902','2013-10-26','09:55:00',1.86),('8902','2013-10-26','10:00:00',2),('8902','2013-10-26','10:05:00',2.15),('8902','2013-10-26','10:10:00',2.26),('8902','2013-10-26','10:15:00',2.3),('8902','2013-10-26','10:20:00',2.56),('8902','2013-10-26','10:25:00',2.52),('8902','2013-10-26','10:30:00',2.5),('8902','2013-10-26','10:35:00',2.46),('8902','2013-10-26','10:40:00',2.4),('8902','2013-10-26','10:45:00',2.75),('8902','2013-10-26','10:50:00',2.73),('8902','2013-10-26','10:55:00',2.49),('8902','2013-10-26','11:00:00',2.33),('8902','2013-10-26','11:05:00',2.02),('8902','2013-10-26','11:10:00',1.62),('8902','2013-10-26','11:15:00',1.3),('8902','2013-10-26','11:20:00',1.19),('8902','2013-10-26','11:25:00',1.33),('8902','2013-10-26','11:30:00',1.74),('8902','2013-10-26','11:35:00',2.36),('8902','2013-10-26','11:40:00',3.27),('8902','2013-10-26','11:45:00',3.91),('8902','2013-10-26','11:50:00',5.24),('8902','2013-10-26','11:55:00',2.4),('8902','2013-10-26','12:00:00',2.13),('8902','2013-10-26','12:05:00',2.25),('8902','2013-10-26','12:10:00',2.51),('8902','2013-10-26','12:15:00',3.4),('8902','2013-10-26','12:20:00',4.56),('8902','2013-10-26','12:25:00',6.23),('8902','2013-10-26','12:30:00',4.38),('8902','2013-10-26','12:35:00',5.62),('8902','2013-10-26','12:40:00',5.74),('8902','2013-10-26','12:45:00',5.18),('8902','2013-10-26','12:50:00',5.33),('8902','2013-10-26','12:55:00',6.08),('8902','2013-10-26','13:00:00',5.53),('8902','2013-10-26','13:05:00',2.68),('8902','2013-10-26','13:10:00',3.55),('8902','2013-10-26','13:15:00',2.66),('8902','2013-10-26','13:20:00',2.13),('8902','2013-10-26','13:25:00',2.93),('8902','2013-10-26','13:30:00',5.03),('8902','2013-10-26','13:35:00',5.2),('8902','2013-10-26','13:40:00',3.11),('8902','2013-10-26','13:45:00',1.82),('8902','2013-10-26','13:50:00',1.4),('8902','2013-10-26','13:55:00',1.3),('8902','2013-10-26','14:00:00',1.71),('8902','2013-10-26','14:05:00',2.35),('8902','2013-10-26','14:10:00',2.18),('8902','2013-10-26','14:15:00',1.96),('8902','2013-10-26','14:20:00',2.04),('8902','2013-10-26','14:25:00',2.1),('8902','2013-10-26','14:30:00',1.77),('8902','2013-10-26','14:35:00',2.7),('8902','2013-10-26','14:40:00',4.26),('8902','2013-10-26','14:45:00',4.11),('8902','2013-10-26','14:50:00',3.57),('8902','2013-10-26','14:55:00',3.85),('8902','2013-10-26','15:00:00',3.8),('8902','2013-10-26','15:05:00',3.13),('8902','2013-10-26','15:10:00',2.99),('8902','2013-10-26','15:15:00',3.14),('8902','2013-10-26','15:20:00',3.06),('8902','2013-10-26','15:25:00',2.88),('8902','2013-10-26','15:30:00',2.56),('8902','2013-10-26','15:35:00',1.74),('8902','2013-10-26','15:50:00',1.77),('8902','2013-10-26','15:55:00',1.47),('8902','2013-10-26','16:00:00',1.38),('8902','2013-10-26','16:05:00',1.38),('8902','2013-10-26','16:10:00',1.19),('8902','2013-10-26','16:15:00',1.03),('8902','2013-10-25','08:40:00',1.04),('8902','2013-10-25','08:45:00',1.16),('8902','2013-10-25','08:50:00',1.29),('8902','2013-10-25','08:55:00',1.57),('8902','2013-10-25','09:00:00',1.75),('8902','2013-10-25','09:05:00',1.89),('8902','2013-10-25','09:10:00',2.04),('8902','2013-10-25','09:15:00',2.2),('8902','2013-10-25','09:20:00',2.36),('8902','2013-10-25','09:25:00',2.54),('8902','2013-10-25','09:30:00',2.72),('8902','2013-10-25','09:35:00',2.9),('8902','2013-10-25','09:40:00',3.05),('8902','2013-10-25','09:45:00',3.22),('8902','2013-10-25','09:50:00',3.38),('8902','2013-10-25','09:55:00',3.5),('8902','2013-10-25','10:00:00',3.63),('8902','2013-10-25','10:05:00',3.77),('8902','2013-10-25','10:10:00',3.9),('8902','2013-10-25','10:15:00',4.03),('8902','2013-10-25','10:20:00',4.13),('8902','2013-10-25','10:25:00',4.26),('8902','2013-10-25','10:30:00',4.36),('8902','2013-10-25','10:35:00',4.47),('8902','2013-10-25','10:40:00',4.58),('8902','2013-10-25','10:45:00',4.67),('8902','2013-10-25','10:50:00',4.8),('8902','2013-10-25','10:55:00',4.91),('8902','2013-10-25','11:00:00',5),('8902','2013-10-25','11:05:00',5.1),('8902','2013-10-25','11:10:00',5.15),('8902','2013-10-25','11:15:00',5.26),('8902','2013-10-25','11:20:00',5.33),('8902','2013-10-25','11:25:00',5.36),('8902','2013-10-25','11:30:00',5.45),('8902','2013-10-25','11:35:00',5.49),('8902','2013-10-25','11:40:00',5.56),('8902','2013-10-25','11:45:00',5.61),('8902','2013-10-25','11:50:00',5.65),('8902','2013-10-25','11:55:00',5.69),('8902','2013-10-25','12:00:00',5.76),('8902','2013-10-25','12:05:00',5.73),('8902','2013-10-25','12:10:00',5.72),('8902','2013-10-25','12:15:00',5.7),('8902','2013-10-25','12:20:00',5.88),('8902','2013-10-25','12:25:00',5.89),('8902','2013-10-25','12:30:00',5.96),('8902','2013-10-25','12:35:00',5.7),('8902','2013-10-25','12:40:00',5.86),('8902','2013-10-25','12:45:00',5.83),('8902','2013-10-25','12:50:00',5.98),('8902','2013-10-25','12:55:00',4.17),('8902','2013-10-25','13:00:00',5.59),('8902','2013-10-25','13:05:00',5.81),('8902','2013-10-25','13:10:00',5.96),('8902','2013-10-25','13:15:00',5.69),('8902','2013-10-25','13:20:00',5.57),('8902','2013-10-25','13:25:00',5.78),('8902','2013-10-25','13:30:00',4.65),('8902','2013-10-25','13:35:00',5.39),('8902','2013-10-25','13:40:00',5.82),('8902','2013-10-25','13:45:00',5.71),('8902','2013-10-25','13:50:00',5.7),('8902','2013-10-25','13:55:00',5.68),('8902','2013-10-25','14:00:00',5.45),('8902','2013-10-25','14:05:00',5.13),('8902','2013-10-25','14:10:00',5.35),('8902','2013-10-25','14:15:00',4.98),('8902','2013-10-25','14:20:00',2.99),('8902','2013-10-25','14:25:00',3.41),('8902','2013-10-25','14:30:00',3.34),('8902','2013-10-25','14:35:00',4.03),('8902','2013-10-25','14:40:00',4.92),('8902','2013-10-25','14:45:00',4.64),('8902','2013-10-25','14:50:00',4.69),('8902','2013-10-25','14:55:00',4.47),('8902','2013-10-25','15:00:00',4.55),('8902','2013-10-25','15:05:00',4.62),('8902','2013-10-25','15:10:00',4.48),('8902','2013-10-25','15:15:00',4.22),('8902','2013-10-25','15:20:00',4.17),('8902','2013-10-25','15:25:00',4.05),('8902','2013-10-25','15:30:00',3.84),('8902','2013-10-25','15:35:00',3.8),('8902','2013-10-25','15:40:00',3.83),('8902','2013-10-25','15:45:00',3.6),('8902','2013-10-25','15:50:00',3.7),('8902','2013-10-25','15:55:00',3.4),('8902','2013-10-25','16:00:00',2.88),('8902','2013-10-25','16:05:00',2.72),('8902','2013-10-25','16:10:00',2.86),('8902','2013-10-25','16:15:00',2.63),('8902','2013-10-25','16:20:00',2.62),('8902','2013-10-25','16:25:00',2.42),('8902','2013-10-25','16:30:00',2.3),('8902','2013-10-25','16:35:00',2.11),('8902','2013-10-25','16:40:00',2),('8902','2013-10-25','16:45:00',1.88),('8902','2013-10-25','16:50:00',1.67),('8902','2013-10-25','16:55:00',1.51),('8902','2013-10-25','17:00:00',1.34),('8902','2013-10-25','17:05:00',1.2),('8902','2013-10-25','17:10:00',1.06),('8902','2013-10-24','08:40:00',1.05),('8902','2013-10-24','08:45:00',1.31),('8902','2013-10-24','08:50:00',1.5),('8902','2013-10-24','08:55:00',1.66),('8902','2013-10-24','09:00:00',1.84),('8902','2013-10-24','09:05:00',2),('8902','2013-10-24','09:10:00',2.14),('8902','2013-10-24','09:15:00',2.28),('8902','2013-10-24','09:20:00',2.44),('8902','2013-10-24','09:25:00',2.61),('8902','2013-10-24','09:30:00',2.79),('8902','2013-10-24','09:35:00',2.95),('8902','2013-10-24','09:40:00',3.11),('8902','2013-10-24','09:45:00',3.27),('8902','2013-10-24','09:50:00',3.42),('8902','2013-10-24','09:55:00',3.56),('8902','2013-10-24','10:00:00',3.72),('8902','2013-10-24','10:05:00',3.85),('8902','2013-10-24','10:10:00',3.96),('8902','2013-10-24','10:15:00',4.1),('8902','2013-10-24','10:20:00',4.2),('8902','2013-10-24','10:25:00',4.34),('8902','2013-10-24','10:30:00',4.46),('8902','2013-10-24','10:35:00',4.59),('8902','2013-10-24','10:40:00',4.69),('8902','2013-10-24','10:45:00',4.79),('8902','2013-10-24','10:50:00',4.88),('8902','2013-10-24','10:55:00',4.93),('8902','2013-10-24','11:00:00',5.09),('8902','2013-10-24','11:05:00',5.12),('8902','2013-10-24','11:10:00',5.13),('8902','2013-10-24','11:15:00',5.29),('8902','2013-10-24','11:20:00',5.4),('8902','2013-10-24','11:25:00',5.51),('8902','2013-10-24','11:30:00',5.46),('8902','2013-10-24','11:35:00',5.45),('8902','2013-10-24','11:40:00',5.66),('8902','2013-10-24','11:45:00',5.68),('8902','2013-10-24','11:50:00',5.73),('8902','2013-10-24','11:55:00',5.8),('8902','2013-10-24','12:00:00',5.94),('8902','2013-10-24','12:05:00',6.01),('8902','2013-10-24','12:10:00',6),('8902','2013-10-24','12:15:00',6.01),('8902','2013-10-24','12:20:00',6.05),('8902','2013-10-24','12:25:00',6.11),('8902','2013-10-24','12:30:00',6.12),('8902','2013-10-24','12:35:00',6.13),('8902','2013-10-24','12:40:00',6.14),('8902','2013-10-24','12:45:00',6.13),('8902','2013-10-24','12:50:00',6.11),('8902','2013-10-24','12:55:00',6.07),('8902','2013-10-24','13:00:00',6.08),('8902','2013-10-24','13:05:00',6.07),('8902','2013-10-24','13:10:00',6.1),('8902','2013-10-24','13:15:00',6.07),('8902','2013-10-24','13:20:00',6.1),('8902','2013-10-24','13:25:00',6.07),('8902','2013-10-24','13:30:00',5.96),('8902','2013-10-24','13:35:00',5.9),('8902','2013-10-24','13:40:00',5.94),('8902','2013-10-24','13:45:00',5.93),('8902','2013-10-24','13:50:00',5.81),('8902','2013-10-24','13:55:00',5.84),('8902','2013-10-24','14:00:00',5.82),('8902','2013-10-24','14:05:00',5.72),('8902','2013-10-24','14:10:00',5.72),('8902','2013-10-24','14:15:00',5.7),('8902','2013-10-24','14:20:00',5.67),('8902','2013-10-24','14:25:00',5.6),('8902','2013-10-24','14:30:00',5.5),('8902','2013-10-24','14:35:00',5.46),('8902','2013-10-24','14:40:00',5.33),('8902','2013-10-24','14:45:00',5.27),('8902','2013-10-24','14:50:00',5.25),('8902','2013-10-24','14:55:00',5.17),('8902','2013-10-24','15:00:00',5.07),('8902','2013-10-24','15:05:00',4.99),('8902','2013-10-24','15:10:00',4.89),('8902','2013-10-24','15:15:00',4.79),('8902','2013-10-24','15:20:00',4.6),('8902','2013-10-24','15:25:00',4.51),('8902','2013-10-24','15:30:00',4.37),('8902','2013-10-24','15:35:00',4.22),('8902','2013-10-24','15:40:00',4.13),('8902','2013-10-24','15:45:00',3.96),('8902','2013-10-24','15:50:00',3.86),('8902','2013-10-24','15:55:00',3.68),('8902','2013-10-24','16:00:00',3.58),('8902','2013-10-24','16:05:00',3.47),('8902','2013-10-24','16:10:00',3.33),('8902','2013-10-24','16:15:00',3.21),('8902','2013-10-24','16:20:00',3.07),('8902','2013-10-24','16:25:00',2.93),('8902','2013-10-24','16:30:00',2.78),('8902','2013-10-24','16:35:00',2.6),('8902','2013-10-24','16:40:00',2.44),('8902','2013-10-24','16:45:00',2.29),('8902','2013-10-24','16:50:00',2.11),('8902','2013-10-24','16:55:00',1.94),('8902','2013-10-24','17:00:00',1.77),('8902','2013-10-24','17:05:00',1.59),('8902','2013-10-24','17:10:00',1.41),('8902','2013-10-24','17:15:00',1.22),('8902','2013-10-24','17:20:00',1.04),('8902','2013-10-23','08:30:00',1.23),('8902','2013-10-23','08:50:00',1.11),('8902','2013-10-23','08:55:00',1.46),('8902','2013-10-23','09:00:00',1.34),('8902','2013-10-23','09:05:00',1.36),('8902','2013-10-23','09:10:00',1.9),('8902','2013-10-23','09:15:00',2.63),('8902','2013-10-23','09:20:00',2.72),('8902','2013-10-23','09:25:00',1.71),('8902','2013-10-23','09:30:00',1.78),('8902','2013-10-23','09:35:00',1.97),('8902','2013-10-23','09:40:00',2.1),('8902','2013-10-23','09:45:00',2.16),('8902','2013-10-23','09:50:00',2.27),('8902','2013-10-23','09:55:00',2.14),('8902','2013-10-23','10:00:00',2.08),('8902','2013-10-23','10:05:00',2),('8902','2013-10-23','10:10:00',1.9),('8902','2013-10-23','10:15:00',1.76),('8902','2013-10-23','10:20:00',2.36),('8902','2013-10-23','10:25:00',1.78),('8902','2013-10-23','10:30:00',1.36),('8902','2013-10-23','10:35:00',2.76),('8902','2013-10-23','10:40:00',2.76),('8902','2013-10-23','10:45:00',4.16),('8902','2013-10-23','10:50:00',3.52),('8902','2013-10-23','10:55:00',4.42),('8902','2013-10-23','11:00:00',5.18),('8902','2013-10-23','11:05:00',6.07),('8902','2013-10-23','11:10:00',6.43),('8902','2013-10-23','11:15:00',4.83),('8902','2013-10-23','11:20:00',3.05),('8902','2013-10-23','11:25:00',4.14),('8902','2013-10-23','11:30:00',3.71),('8902','2013-10-23','11:35:00',2.32),('8902','2013-10-23','11:40:00',2.36),('8902','2013-10-23','11:45:00',2.32),('8902','2013-10-23','11:50:00',2.93),('8902','2013-10-23','11:55:00',5.31),('8902','2013-10-23','12:00:00',3.81),('8902','2013-10-23','12:05:00',2.74),('8902','2013-10-23','12:10:00',2.56),('8902','2013-10-23','12:15:00',2.53),('8902','2013-10-23','12:20:00',2.6),('8902','2013-10-23','12:25:00',2.85),('8902','2013-10-23','12:30:00',3.01),('8902','2013-10-23','12:35:00',3.24),('8902','2013-10-23','12:40:00',3.64),('8902','2013-10-23','12:45:00',4.66),('8902','2013-10-23','12:50:00',5.07),('8902','2013-10-23','12:55:00',4.78),('8902','2013-10-23','13:00:00',6.83),('8902','2013-10-23','13:05:00',7.41),('8902','2013-10-23','13:10:00',6.42),('8902','2013-10-23','13:15:00',4.78),('8902','2013-10-23','13:20:00',5.52),('8902','2013-10-23','13:25:00',4.02),('8902','2013-10-23','13:30:00',2.83),('8902','2013-10-23','13:35:00',2.59),('8902','2013-10-23','13:40:00',2.59),('8902','2013-10-23','13:45:00',2.69),('8902','2013-10-23','13:50:00',3.85),('8902','2013-10-23','13:55:00',3.7),('8902','2013-10-23','14:00:00',4.47),('8902','2013-10-23','14:05:00',4.07),('8902','2013-10-23','14:10:00',2.79),('8902','2013-10-23','14:15:00',2.81),('8902','2013-10-23','14:20:00',2.86),('8902','2013-10-23','14:25:00',2.95),('8902','2013-10-23','14:30:00',2.97),('8902','2013-10-23','14:35:00',3.37),('8902','2013-10-23','14:40:00',3.45),('8902','2013-10-23','14:45:00',3.42),('8902','2013-10-23','14:50:00',4.74),('8902','2013-10-23','14:55:00',2.01),('8902','2013-10-23','15:00:00',2.31),('8902','2013-10-23','15:05:00',2.3),('8902','2013-10-23','15:10:00',4.78),('8902','2013-10-23','15:15:00',3.39),('8902','2013-10-23','15:20:00',2.37),('8902','2013-10-23','15:25:00',2.76),('8902','2013-10-23','15:30:00',2.2),('8902','2013-10-23','15:35:00',5.45),('8902','2013-10-23','15:40:00',4.86),('8902','2013-10-23','15:45:00',3.47),('8902','2013-10-23','15:50:00',2.99),('8902','2013-10-23','15:55:00',1.57),('8902','2013-10-23','16:00:00',1.45),('8902','2013-10-23','16:05:00',1.4),('8902','2013-10-23','16:10:00',1.33),('8902','2013-10-23','16:15:00',1.31),('8902','2013-10-23','16:20:00',1.26),('8902','2013-10-23','16:25:00',1.09),('8902','2013-10-22','09:50:00',1.17),('8902','2013-10-22','09:55:00',1.11),('8902','2013-10-22','10:00:00',1.16),('8902','2013-10-22','10:05:00',1.34),('8902','2013-10-22','10:10:00',1.31),('8902','2013-10-22','10:15:00',1.42),('8902','2013-10-22','10:20:00',1.53),('8902','2013-10-22','10:25:00',2.02),('8902','2013-10-22','10:30:00',2.08),('8902','2013-10-22','10:35:00',1.91),('8902','2013-10-22','10:40:00',1.85),('8902','2013-10-22','10:45:00',2.3),('8902','2013-10-22','10:50:00',2.56),('8902','2013-10-22','10:55:00',3.1),('8902','2013-10-22','11:00:00',3.07),('8902','2013-10-22','11:05:00',4.61),('8902','2013-10-22','11:10:00',3.91),('8902','2013-10-22','11:15:00',3.97),('8902','2013-10-22','11:20:00',4),('8902','2013-10-22','11:25:00',5.78),('8902','2013-10-22','11:30:00',5.61),('8902','2013-10-22','11:35:00',5.3),('8902','2013-10-22','11:40:00',4.44),('8902','2013-10-22','11:45:00',5.8),('8902','2013-10-22','11:50:00',5.76),('8902','2013-10-22','11:55:00',5.6),('8902','2013-10-22','12:00:00',5.89),('8902','2013-10-22','12:05:00',5.85),('8902','2013-10-22','12:10:00',5.81),('8902','2013-10-22','12:15:00',5.85),('8902','2013-10-22','12:20:00',5.38),('8902','2013-10-22','12:25:00',5.73),('8902','2013-10-22','12:30:00',5.76),('8902','2013-10-22','12:35:00',5.76),('8902','2013-10-22','12:40:00',5.6),('8902','2013-10-22','12:45:00',5.75),('8902','2013-10-22','12:50:00',5.28),('8902','2013-10-22','12:55:00',3.97),('8902','2013-10-22','13:00:00',5.51),('8902','2013-10-22','13:05:00',5.44),('8902','2013-10-22','13:10:00',5.54),('8902','2013-10-22','13:15:00',5.54),('8902','2013-10-22','13:20:00',5.82),('8902','2013-10-22','13:25:00',5.78),('8902','2013-10-22','13:30:00',5.63),('8902','2013-10-22','13:35:00',5.59),('8902','2013-10-22','13:40:00',5.68),('8902','2013-10-22','13:45:00',5.71),('8902','2013-10-22','13:50:00',4.45),('8902','2013-10-22','13:55:00',4.12),('8902','2013-10-22','14:00:00',3.11),('8902','2013-10-22','14:05:00',4.4),('8902','2013-10-22','14:10:00',5.58),('8902','2013-10-22','14:15:00',5.23),('8902','2013-10-22','14:20:00',5.49),('8902','2013-10-22','14:25:00',5.34),('8902','2013-10-22','14:30:00',5.24),('8902','2013-10-22','14:35:00',4.89),('8902','2013-10-22','14:40:00',4.73),('8902','2013-10-22','14:45:00',4.8),('8902','2013-10-22','14:50:00',4.22),('8902','2013-10-22','14:55:00',5.12),('8902','2013-10-22','15:00:00',4.82),('8902','2013-10-22','15:05:00',4.83),('8902','2013-10-22','15:10:00',4.62),('8902','2013-10-22','15:15:00',4.7),('8902','2013-10-22','15:20:00',4.7),('8902','2013-10-22','15:25:00',4.7),('8902','2013-10-22','15:30:00',4.56),('8902','2013-10-22','15:35:00',4.26),('8902','2013-10-22','15:40:00',4.46),('8902','2013-10-22','15:45:00',4.37),('8902','2013-10-22','15:50:00',3.9),('8902','2013-10-22','15:55:00',2.93),('8902','2013-10-22','16:00:00',2.55),('8902','2013-10-22','16:05:00',2.21),('8902','2013-10-22','16:10:00',2.13),('8902','2013-10-22','16:15:00',2.34),('8902','2013-10-22','16:20:00',2.08),('8902','2013-10-22','16:25:00',1.96),('8902','2013-10-22','16:30:00',1.68),('8902','2013-10-22','16:35:00',2.22),('8902','2013-10-22','16:40:00',2.36),('8902','2013-10-22','16:45:00',1.97),('8902','2013-10-22','16:50:00',1.79),('8902','2013-10-22','16:55:00',1.58),('8902','2013-10-22','17:00:00',1.55),('8902','2013-10-22','17:05:00',1.26),('8902','2013-10-22','17:10:00',1.06),('8902','2013-10-21','08:40:00',1.12),('8902','2013-10-21','08:45:00',1.27),('8902','2013-10-21','08:50:00',1.48),('8902','2013-10-21','08:55:00',1.67),('8902','2013-10-21','09:00:00',1.81),('8902','2013-10-21','09:05:00',1.95),('8902','2013-10-21','09:10:00',2.12),('8902','2013-10-21','09:15:00',2.26),('8902','2013-10-21','09:20:00',2.43),('8902','2013-10-21','09:25:00',2.59),('8902','2013-10-21','09:30:00',2.78),('8902','2013-10-21','09:35:00',2.95),('8902','2013-10-21','09:40:00',3.12),('8902','2013-10-21','09:45:00',3.29),('8902','2013-10-21','09:50:00',3.43),('8902','2013-10-21','09:55:00',3.58),('8902','2013-10-21','10:00:00',3.71),('8902','2013-10-21','10:05:00',3.84),('8902','2013-10-21','10:10:00',3.94),('8902','2013-10-21','10:15:00',4.05),('8902','2013-10-21','10:20:00',4.19),('8902','2013-10-21','10:25:00',4.32),('8902','2013-10-21','10:30:00',4.44),('8902','2013-10-21','10:35:00',4.54),('8902','2013-10-21','10:40:00',4.62),('8902','2013-10-21','10:45:00',4.73),('8902','2013-10-21','10:50:00',4.84),('8902','2013-10-21','10:55:00',4.95),('8902','2013-10-21','11:00:00',5.02),('8902','2013-10-21','11:05:00',5.07),('8902','2013-10-21','11:10:00',5.14),('8902','2013-10-21','11:15:00',5.24),('8902','2013-10-21','11:20:00',5.26),('8902','2013-10-21','11:25:00',5.28),('8902','2013-10-21','11:30:00',5.37),('8902','2013-10-21','11:35:00',5.42),('8902','2013-10-21','11:40:00',5.47),('8902','2013-10-21','11:45:00',5.59),('8902','2013-10-21','11:50:00',5.65),('8902','2013-10-21','11:55:00',5.55),('8902','2013-10-21','12:00:00',5.63),('8902','2013-10-21','12:05:00',5.65),('8902','2013-10-21','12:10:00',5.68),('8902','2013-10-21','12:15:00',5.69),('8902','2013-10-21','12:20:00',5.7),('8902','2013-10-21','12:25:00',5.69),('8902','2013-10-21','12:30:00',5.64),('8902','2013-10-21','12:35:00',5.63),('8902','2013-10-21','12:40:00',5.17),('8902','2013-10-21','12:45:00',5.43),('8902','2013-10-21','12:50:00',5.86),('8902','2013-10-21','12:55:00',5.85),('8902','2013-10-21','13:00:00',5.81),('8902','2013-10-21','13:05:00',6),('8902','2013-10-21','13:10:00',5.9),('8902','2013-10-21','13:15:00',5.82),('8902','2013-10-21','13:20:00',5.47),('8902','2013-10-21','13:25:00',5.91),('8902','2013-10-21','13:30:00',5.5),('8902','2013-10-21','13:35:00',5.21),('8902','2013-10-21','13:40:00',5.63),('8902','2013-10-21','13:45:00',5.4),('8902','2013-10-21','13:50:00',5.84),('8902','2013-10-21','13:55:00',5.42),('8902','2013-10-21','14:00:00',5.3),('8902','2013-10-21','14:05:00',4.59),('8902','2013-10-21','14:10:00',1.9),('8902','2013-10-21','14:15:00',3.82),('8902','2013-10-21','14:20:00',5.64),('8902','2013-10-21','14:25:00',2.87),('8902','2013-10-21','14:30:00',3.14),('8902','2013-10-21','14:35:00',2.07),('8902','2013-10-21','14:40:00',3.6),('8902','2013-10-21','14:45:00',3.79),('8902','2013-10-21','14:50:00',4.59),('8902','2013-10-21','14:55:00',4.73),('8902','2013-10-21','15:00:00',4.69),('8902','2013-10-21','15:05:00',4.69),('8902','2013-10-21','15:10:00',4.64),('8902','2013-10-21','15:15:00',4.44),('8902','2013-10-21','15:20:00',4.25),('8902','2013-10-21','15:25:00',4.26),('8902','2013-10-21','15:30:00',4.12),('8902','2013-10-21','15:35:00',4.12),('8902','2013-10-21','15:40:00',4),('8902','2013-10-21','15:45:00',3.75),('8902','2013-10-21','15:50:00',3.15),('8902','2013-10-21','15:55:00',3.59),('8902','2013-10-21','16:00:00',3.36),('8902','2013-10-21','16:05:00',3.14),('8902','2013-10-21','16:10:00',3.07),('8902','2013-10-21','16:15:00',3),('8902','2013-10-21','16:20:00',2.78),('8902','2013-10-21','16:25:00',2.66),('8902','2013-10-21','16:30:00',2.6),('8902','2013-10-21','16:35:00',2.41),('8902','2013-10-21','16:40:00',2.25),('8902','2013-10-21','16:45:00',2.11),('8902','2013-10-21','16:50:00',1.95),('8902','2013-10-21','16:55:00',1.78),('8902','2013-10-21','17:00:00',1.62),('8902','2013-10-21','17:05:00',1.46),('8902','2013-10-21','17:10:00',1.27),('8902','2013-10-21','17:15:00',1.09),('8902','2013-10-20','08:40:00',1.08),('8902','2013-10-20','08:45:00',1.18),('8902','2013-10-20','08:50:00',1.09),('8902','2013-10-20','08:55:00',1.33),('8902','2013-10-20','09:00:00',1.13),('8902','2013-10-20','09:05:00',1.26),('8902','2013-10-20','09:10:00',1.64),('8902','2013-10-20','09:15:00',1.86),('8902','2013-10-20','09:20:00',2.35),('8902','2013-10-20','09:25:00',2.84),('8902','2013-10-20','09:30:00',2.74),('8902','2013-10-20','09:35:00',2.56),('8902','2013-10-20','09:40:00',3.16),('8902','2013-10-20','09:45:00',2.73),('8902','2013-10-20','09:50:00',3),('8902','2013-10-20','09:55:00',3.45),('8902','2013-10-20','10:00:00',3.45),('8902','2013-10-20','10:05:00',3.8),('8902','2013-10-20','10:10:00',4.15),('8902','2013-10-20','10:15:00',4.27),('8902','2013-10-20','10:20:00',4.3),('8902','2013-10-20','10:25:00',4.48),('8902','2013-10-20','10:30:00',4.45),('8902','2013-10-20','10:35:00',4.52),('8902','2013-10-20','10:40:00',4.42),('8902','2013-10-20','10:45:00',4.52),('8902','2013-10-20','10:50:00',4.81),('8902','2013-10-20','10:55:00',4.82),('8902','2013-10-20','11:00:00',5.17),('8902','2013-10-20','11:05:00',5.05),('8902','2013-10-20','11:10:00',4.33),('8902','2013-10-20','11:15:00',5.57),('8902','2013-10-20','11:20:00',5.43),('8902','2013-10-20','11:25:00',5.54),('8902','2013-10-20','11:30:00',5.67),('8902','2013-10-20','11:35:00',5.7),('8902','2013-10-20','11:40:00',5.64),('8902','2013-10-20','11:45:00',5.88),('8902','2013-10-20','11:50:00',5.89),('8902','2013-10-20','11:55:00',5.89),('8902','2013-10-20','12:00:00',5.98),('8902','2013-10-20','12:05:00',6.05),('8902','2013-10-20','12:10:00',6.13),('8902','2013-10-20','12:15:00',6.11),('8902','2013-10-20','12:20:00',6.09),('8902','2013-10-20','12:25:00',6.17),('8902','2013-10-20','12:30:00',5.94),('8902','2013-10-20','12:35:00',5.96),('8902','2013-10-20','12:40:00',6.18),('8902','2013-10-20','12:45:00',6.23),('8902','2013-10-20','12:50:00',6.21),('8902','2013-10-20','12:55:00',6.18),('8902','2013-10-20','13:00:00',6.15),('8902','2013-10-20','13:05:00',6.09),('8902','2013-10-20','13:10:00',5.77),('8902','2013-10-20','13:15:00',6.03),('8902','2013-10-20','13:20:00',6),('8902','2013-10-20','13:25:00',6.02),('8902','2013-10-20','13:30:00',6.19),('8902','2013-10-20','13:35:00',6.16),('8902','2013-10-20','13:40:00',6.1),('8902','2013-10-20','13:45:00',6.09),('8902','2013-10-20','13:50:00',6.02),('8902','2013-10-20','13:55:00',5.8),('8902','2013-10-20','14:00:00',5.67),('8902','2013-10-20','14:05:00',5.83),('8902','2013-10-20','14:10:00',5.78),('8902','2013-10-20','14:15:00',5.77),('8902','2013-10-20','14:20:00',5.71),('8902','2013-10-20','14:25:00',5.64),('8902','2013-10-20','14:30:00',5.47),('8902','2013-10-20','14:35:00',5.45),('8902','2013-10-20','14:40:00',5.14),('8902','2013-10-20','14:45:00',5.08),('8902','2013-10-20','14:50:00',4.93),('8902','2013-10-20','14:55:00',4.89),('8902','2013-10-20','15:00:00',5.03),('8902','2013-10-20','15:05:00',5.02),('8902','2013-10-20','15:10:00',4.84),('8902','2013-10-20','15:15:00',4.8),('8902','2013-10-20','15:20:00',4.75),('8902','2013-10-20','15:25:00',4.58),('8902','2013-10-20','15:30:00',4.43),('8902','2013-10-20','15:35:00',4.15),('8902','2013-10-20','15:40:00',4.23),('8902','2013-10-20','15:45:00',4.11),('8902','2013-10-20','15:50:00',3.92),('8902','2013-10-20','15:55:00',3.79),('8902','2013-10-20','16:00:00',3.71),('8902','2013-10-20','16:05:00',3.53),('8902','2013-10-20','16:10:00',3.45),('8902','2013-10-20','16:15:00',3.32),('8902','2013-10-20','16:20:00',3.1),('8902','2013-10-20','16:25:00',2.94),('8902','2013-10-20','16:30:00',2.81),('8902','2013-10-20','16:35:00',2.62),('8902','2013-10-20','16:40:00',2.45),('8902','2013-10-20','16:45:00',2.3),('8902','2013-10-20','16:50:00',2.11),('8902','2013-10-20','16:55:00',1.83),('8902','2013-10-20','17:00:00',1.68),('8902','2013-10-20','17:05:00',1.53),('8902','2013-10-20','17:10:00',1.52),('8902','2013-10-20','17:15:00',1.37),('8902','2013-10-20','17:20:00',1.1),('8902','2013-10-19','08:25:00',1.01),('8902','2013-10-19','08:30:00',1.18),('8902','2013-10-19','08:35:00',1.32),('8902','2013-10-19','08:40:00',1.43),('8902','2013-10-19','08:45:00',1.53),('8902','2013-10-19','08:50:00',1.71),('8902','2013-10-19','08:55:00',1.89),('8902','2013-10-19','09:00:00',2.05),('8902','2013-10-19','09:05:00',2.13),('8902','2013-10-19','09:10:00',2.34),('8902','2013-10-19','09:15:00',2.49),('8902','2013-10-19','09:20:00',2.72),('8902','2013-10-19','09:25:00',2.9),('8902','2013-10-19','09:30:00',3.03),('8902','2013-10-19','09:35:00',3.16),('8902','2013-10-19','09:40:00',3.35),('8902','2013-10-19','09:45:00',3.52),('8902','2013-10-19','09:50:00',3.64),('8902','2013-10-19','09:55:00',3.71),('8902','2013-10-19','10:00:00',3.93),('8902','2013-10-19','10:05:00',4.07),('8902','2013-10-19','10:10:00',4.23),('8902','2013-10-19','10:15:00',4.38),('8902','2013-10-19','10:20:00',4.5),('8902','2013-10-19','10:25:00',4.61),('8902','2013-10-19','10:30:00',4.72),('8902','2013-10-19','10:35:00',4.84),('8902','2013-10-19','10:40:00',4.96),('8902','2013-10-19','10:45:00',5.05),('8902','2013-10-19','10:50:00',5.13),('8902','2013-10-19','10:55:00',5.21),('8902','2013-10-19','11:00:00',5.3),('8902','2013-10-19','11:05:00',5.41),('8902','2013-10-19','11:10:00',5.5),('8902','2013-10-19','11:15:00',5.57),('8902','2013-10-19','11:20:00',5.68),('8902','2013-10-19','11:25:00',5.78),('8902','2013-10-19','11:30:00',5.78),('8902','2013-10-19','11:35:00',5.89),('8902','2013-10-19','11:40:00',5.97),('8902','2013-10-19','11:45:00',5.93),('8902','2013-10-19','11:50:00',6.01),('8902','2013-10-19','11:55:00',5.99),('8902','2013-10-19','12:00:00',6.05),('8902','2013-10-19','12:05:00',6.17),('8902','2013-10-19','12:10:00',6.24),('8902','2013-10-19','12:15:00',3.16),('8902','2013-10-19','12:20:00',1.89),('8902','2013-10-19','12:25:00',4.65),('8902','2013-10-19','12:30:00',2.82),('8902','2013-10-19','12:35:00',7.36),('8902','2013-10-19','12:40:00',5.71),('8902','2013-10-19','12:45:00',5.27),('8902','2013-10-19','12:50:00',5.19),('8902','2013-10-19','12:55:00',5.52),('8902','2013-10-19','13:00:00',4.92),('8902','2013-10-19','13:05:00',4.73),('8902','2013-10-19','13:10:00',6.91),('8902','2013-10-19','13:15:00',3.4),('8902','2013-10-19','13:20:00',2.51),('8902','2013-10-19','13:25:00',3.56),('8902','2013-10-19','13:30:00',5.57),('8902','2013-10-19','13:35:00',3.66),('8902','2013-10-19','13:40:00',3.61),('8902','2013-10-19','13:45:00',4.61),('8902','2013-10-19','13:50:00',2.36),('8902','2013-10-19','13:55:00',2.34),('8902','2013-10-19','14:00:00',3.3),('8902','2013-10-19','14:05:00',1.88),('8902','2013-10-19','14:10:00',2.63),('8902','2013-10-19','14:15:00',2.15),('8902','2013-10-19','14:20:00',1.37),('8902','2013-10-19','14:25:00',1.09),('8902','2013-10-19','14:40:00',1.2),('8902','2013-10-19','14:45:00',1.4),('8902','2013-10-19','14:50:00',1.43),('8902','2013-10-19','14:55:00',1.28),('8902','2013-10-19','15:00:00',1.18),('8902','2013-10-19','15:05:00',1.06),('8902','2013-10-19','15:10:00',1.04),('8902','2013-10-19','15:15:00',1.05),('8902','2013-10-19','16:35:00',1.17),('8902','2013-10-19','16:40:00',2.05),('8902','2013-10-19','16:45:00',1.98),('8902','2013-10-19','16:50:00',2.74),('8902','2013-10-19','16:55:00',2.72),('8902','2013-10-19','17:00:00',2.6),('8902','2013-10-19','17:05:00',2.48),('8902','2013-10-19','17:10:00',2.07),('8902','2013-10-19','17:15:00',1.74),('8902','2013-10-19','17:20:00',1.45),('8902','2013-10-19','17:25:00',1.17),('8902','2013-10-18','08:35:00',1.29),('8902','2013-10-18','08:40:00',1.57),('8902','2013-10-18','08:45:00',1.77),('8902','2013-10-18','08:50:00',2.01),('8902','2013-10-18','08:55:00',1.68),('8902','2013-10-18','09:00:00',1.46),('8902','2013-10-18','09:05:00',1.99),('8902','2013-10-18','09:10:00',2.54),('8902','2013-10-18','09:15:00',3.05),('8902','2013-10-18','09:20:00',3.23),('8902','2013-10-18','09:25:00',3.32),('8902','2013-10-18','09:30:00',3.45),('8902','2013-10-18','09:35:00',3.59),('8902','2013-10-18','09:40:00',3.79),('8902','2013-10-18','09:45:00',4),('8902','2013-10-18','09:50:00',4.16),('8902','2013-10-18','09:55:00',4.44),('8902','2013-10-18','10:00:00',4.23),('8902','2013-10-18','10:05:00',4.26),('8902','2013-10-18','10:10:00',4.69),('8902','2013-10-18','10:15:00',4.48),('8902','2013-10-18','10:20:00',4.89),('8902','2013-10-18','10:25:00',5.31),('8902','2013-10-18','10:30:00',5.41),('8902','2013-10-18','10:35:00',5.42),('8902','2013-10-18','10:40:00',5.47),('8902','2013-10-18','10:45:00',5.4),('8902','2013-10-18','10:50:00',5.55),('8902','2013-10-18','10:55:00',5.73),('8902','2013-10-18','11:00:00',5.88),('8902','2013-10-18','11:05:00',5.42),('8902','2013-10-18','11:10:00',3.01),('8902','2013-10-18','11:15:00',2.32),('8902','2013-10-18','11:20:00',4.43),('8902','2013-10-18','11:25:00',6.33),('8902','2013-10-18','11:30:00',6.46),('8902','2013-10-18','11:35:00',6.59),('8902','2013-10-18','11:40:00',6.26),('8902','2013-10-18','11:45:00',6.56),('8902','2013-10-18','11:50:00',6.49),('8902','2013-10-18','11:55:00',6.34),('8902','2013-10-18','12:00:00',6.7),('8902','2013-10-18','12:05:00',6.66),('8902','2013-10-18','12:10:00',6.57),('8902','2013-10-18','12:15:00',6.6),('8902','2013-10-18','12:20:00',6.72),('8902','2013-10-18','12:25:00',6.08),('8902','2013-10-18','12:30:00',6.57),('8902','2013-10-18','12:35:00',6.81),('8902','2013-10-18','12:40:00',7.04),('8902','2013-10-18','12:45:00',7.11),('8902','2013-10-18','12:50:00',7.29),('8902','2013-10-18','12:55:00',7.18),('8902','2013-10-18','13:00:00',7.79),('8902','2013-10-18','13:05:00',6.65),('8902','2013-10-18','13:10:00',6.19),('8902','2013-10-18','13:15:00',6.27),('8902','2013-10-18','13:20:00',6.53),('8902','2013-10-18','13:25:00',7.02),('8902','2013-10-18','13:30:00',7.65),('8902','2013-10-18','13:35:00',5.79),('8902','2013-10-18','13:40:00',4.65),('8902','2013-10-18','13:45:00',4.48),('8902','2013-10-18','13:50:00',5.31),('8902','2013-10-18','13:55:00',6.77),('8902','2013-10-18','14:00:00',6.06),('8902','2013-10-18','14:05:00',5.13),('8902','2013-10-18','14:10:00',3.8),('8902','2013-10-18','14:15:00',5.05),('8902','2013-10-18','14:20:00',4.7),('8902','2013-10-18','14:25:00',3.93),('8902','2013-10-18','14:30:00',4.32),('8902','2013-10-18','14:35:00',7.13),('8902','2013-10-18','14:40:00',5.41),('8902','2013-10-18','14:45:00',4.25),('8902','2013-10-18','14:50:00',6.34),('8902','2013-10-18','14:55:00',6.19),('8902','2013-10-18','15:00:00',6.05),('8902','2013-10-18','15:05:00',5.82),('8902','2013-10-18','15:10:00',5.77),('8902','2013-10-18','15:15:00',5.7),('8902','2013-10-18','15:20:00',5.29),('8902','2013-10-18','15:25:00',5.08),('8902','2013-10-18','15:30:00',4.88),('8902','2013-10-18','15:35:00',4.77),('8902','2013-10-18','15:40:00',4.52),('8902','2013-10-18','15:45:00',3.95),('8902','2013-10-18','15:50:00',3.95),('8902','2013-10-18','15:55:00',4.53),('8902','2013-10-18','16:00:00',3.8),('8902','2013-10-18','16:05:00',3.98),('8902','2013-10-18','16:10:00',3.89),('8902','2013-10-18','16:15:00',4.01),('8902','2013-10-18','16:20:00',3.97),('8902','2013-10-18','16:25:00',2.7),('8902','2013-10-18','16:30:00',3.5),('8902','2013-10-18','16:35:00',3.6),('8902','2013-10-18','16:40:00',3.45),('8902','2013-10-18','16:45:00',3.27),('8902','2013-10-18','16:50:00',3.06),('8902','2013-10-18','16:55:00',1.39),('8902','2013-10-18','17:00:00',1.11),('8902','2013-10-18','17:05:00',1.18),('8902','2013-10-18','17:10:00',1.42),('8902','2013-10-18','17:20:00',1.68),('8902','2013-10-18','17:25:00',1.16),('8902','2013-10-18','17:30:00',1.06),('8902','2014-05-03','07:40:00',1.33),('8902','2014-05-03','07:45:00',1.57),('8902','2014-05-03','07:50:00',1.79),('8902','2014-05-03','07:55:00',2.02),('8902','2014-05-03','08:00:00',2.2),('8902','2014-05-03','08:05:00',2.41),('8902','2014-05-03','08:10:00',2.54),('8902','2014-05-03','08:15:00',2.76),('8902','2014-05-03','08:20:00',2.99),('8902','2014-05-03','08:25:00',3.17),('8902','2014-05-03','08:30:00',3.6),('8902','2014-05-03','08:35:00',3.08),('8902','2014-05-03','08:40:00',2.74),('8902','2014-05-03','08:45:00',1.79),('8902','2014-05-03','08:50:00',2.56),('8902','2014-05-03','08:55:00',2.55),('8902','2014-05-03','09:00:00',2.71),('8902','2014-05-03','09:05:00',4.86),('8902','2014-05-03','09:10:00',4.36),('8902','2014-05-03','09:15:00',4.56),('8902','2014-05-03','09:20:00',6.82),('8902','2014-05-03','09:25:00',5.24),('8902','2014-05-03','09:30:00',2.4),('8902','2014-05-03','09:35:00',2.41),('8902','2014-05-03','09:40:00',2.88),('8902','2014-05-03','09:45:00',4.1),('8902','2014-05-03','09:50:00',4.86),('8902','2014-05-03','09:55:00',4.9),('8902','2014-05-03','10:00:00',6.98),('8902','2014-05-03','10:05:00',7.36),('8902','2014-05-03','10:10:00',6.47),('8902','2014-05-03','10:15:00',5.37),('8902','2014-05-03','10:20:00',3.79),('8902','2014-05-03','10:25:00',3.74),('8902','2014-05-03','10:30:00',3.88),('8902','2014-05-03','10:35:00',4.05),('8902','2014-05-03','10:40:00',4.35),('8902','2014-05-03','10:45:00',5.27),('8902','2014-05-03','10:50:00',4.92),('8902','2014-05-03','10:55:00',6.32),('8902','2014-05-03','11:00:00',5.87),('8902','2014-05-03','11:05:00',7.46),('8902','2014-05-03','11:10:00',7.24),('8902','2014-05-03','11:15:00',7.62),('8902','2014-05-03','11:20:00',8.36),('8902','2014-05-03','11:25:00',7.17),('8902','2014-05-03','11:30:00',7.91),('8902','2014-05-03','11:35:00',7.62),('8902','2014-05-03','11:40:00',5.83),('8902','2014-05-03','11:45:00',7.65),('8902','2014-05-03','11:50:00',6.41),('8902','2014-05-03','11:55:00',6.99),('8902','2014-05-03','12:00:00',6.67),('8902','2014-05-03','12:05:00',5.11),('8902','2014-05-03','12:10:00',3.63),('8902','2014-05-03','12:15:00',3.19),('8902','2014-05-03','12:20:00',3.64),('8902','2014-05-03','12:25:00',3.6),('8902','2014-05-03','12:30:00',9.54),('8902','2014-05-03','12:35:00',7.72),('8902','2014-05-03','12:40:00',7.5),('8902','2014-05-03','12:45:00',4.76),('8902','2014-05-03','12:50:00',6.59),('8902','2014-05-03','12:55:00',4.99),('8902','2014-05-03','13:00:00',3.97),('8902','2014-05-03','13:05:00',3.89),('8902','2014-05-03','13:10:00',3.93),('8902','2014-05-03','13:15:00',3.77),('8902','2014-05-03','13:20:00',3.55),('8902','2014-05-03','13:25:00',2.96),('8902','2014-05-03','13:30:00',3.13),('8902','2014-05-03','13:35:00',3.3),('8902','2014-05-03','13:40:00',3.14),('8902','2014-05-03','13:45:00',2.76),('8902','2014-05-03','13:50:00',2.63),('8902','2014-05-03','13:55:00',2.68),('8902','2014-05-03','14:00:00',2.63),('8902','2014-05-03','14:05:00',2.7),('8902','2014-05-03','14:10:00',2.72),('8902','2014-05-03','14:15:00',2.58),('8902','2014-05-03','14:20:00',2.1),('8902','2014-05-03','14:25:00',1.57),('8902','2014-05-03','14:30:00',1.34),('8902','2014-05-03','14:35:00',1.33),('8902','2014-05-03','14:40:00',1.46),('8902','2014-05-03','14:45:00',1.66),('8902','2014-05-03','14:50:00',2.18),('8902','2014-05-03','14:55:00',3.09),('8902','2014-05-03','15:00:00',3.55),('8902','2014-05-03','15:05:00',5.62),('8902','2014-05-03','15:10:00',8.06),('8902','2014-05-03','15:15:00',6.06),('8902','2014-05-03','15:20:00',3.14),('8902','2014-05-03','15:25:00',2.66),('8902','2014-05-03','15:30:00',1.96),('8902','2014-05-03','15:35:00',1.47),('8902','2014-05-03','15:40:00',1.43),('8902','2014-05-03','15:45:00',1.82),('8902','2014-05-03','15:50:00',2.37),('8902','2014-05-03','15:55:00',2.44),('8902','2014-05-03','16:00:00',1.95),('8902','2014-05-03','16:05:00',2.08),('8902','2014-05-03','16:10:00',2.65),('8902','2014-05-03','16:15:00',2.57),('8902','2014-05-03','16:20:00',2.14),('8902','2014-05-03','16:25:00',1.71),('8902','2014-05-03','16:30:00',1.3),('8902','2014-05-03','16:35:00',1.07),('8902','2014-05-03','16:55:00',1.02),('8902','2014-05-03','17:15:00',1.08),('8902','2014-05-03','17:20:00',1.29),('8902','2014-05-03','17:25:00',1.89),('8902','2014-05-03','17:30:00',1.82),('8902','2014-05-03','17:35:00',1.75),('8902','2014-05-03','17:40:00',1.72),('8902','2014-05-03','17:45:00',1.48),('8902','2014-05-03','17:50:00',1.2),('8902','2014-05-03','18:00:00',1.03),('8902','2014-05-03','18:05:00',1.31),('8902','2014-05-03','18:10:00',1.11),('8902','2014-04-15','07:50:00',1.18),('8902','2014-04-15','07:55:00',1.37),('8902','2014-04-15','08:00:00',1.55),('8902','2014-04-15','08:05:00',1.73),('8902','2014-04-15','08:10:00',1.93),('8902','2014-04-15','08:15:00',2.14),('8902','2014-04-15','08:20:00',2.37),('8902','2014-04-15','08:25:00',2.62),('8902','2014-04-15','08:30:00',2.05),('8902','2014-04-15','08:35:00',1.68),('8902','2014-04-15','08:40:00',1.9),('8902','2014-04-15','08:45:00',3.11),('8902','2014-04-15','08:50:00',3.52),('8902','2014-04-15','08:55:00',3.74),('8902','2014-04-15','09:00:00',3.92),('8902','2014-04-15','09:05:00',4.11),('8902','2014-04-15','09:10:00',4.28),('8902','2014-04-15','09:15:00',4.41),('8902','2014-04-15','09:20:00',4.6),('8902','2014-04-15','09:25:00',4.86),('8902','2014-04-15','09:30:00',4.65),('8902','2014-04-15','09:35:00',1.59),('8902','2014-04-15','09:40:00',1.52),('8902','2014-04-15','09:45:00',1.71),('8902','2014-04-15','09:50:00',4.26),('8902','2014-04-15','09:55:00',6.32),('8902','2014-04-15','10:00:00',6.13),('8902','2014-04-15','10:05:00',6.21),('8902','2014-04-15','10:10:00',6.37),('8902','2014-04-15','10:15:00',6.54),('8902','2014-04-15','10:20:00',6.69),('8902','2014-04-15','10:25:00',6.83),('8902','2014-04-15','10:30:00',6.94),('8902','2014-04-15','10:35:00',7.07),('8902','2014-04-15','10:40:00',7.18),('8902','2014-04-15','10:45:00',7.32),('8902','2014-04-15','10:50:00',7.61),('8902','2014-04-15','10:55:00',6.96),('8902','2014-04-15','11:00:00',7.35),('8902','2014-04-15','11:05:00',6.56),('8902','2014-04-15','11:10:00',2.99),('8902','2014-04-15','11:15:00',4.22),('8902','2014-04-15','11:20:00',8.33),('8902','2014-04-15','11:25:00',6.82),('8902','2014-04-15','11:30:00',7.45),('8902','2014-04-15','11:35:00',5.86),('8902','2014-04-15','11:40:00',7.26),('8902','2014-04-15','11:45:00',7.93),('8902','2014-04-15','11:50:00',9.02),('8902','2014-04-15','11:55:00',9.12),('8902','2014-04-15','12:00:00',9.39),('8902','2014-04-15','12:05:00',5.46),('8902','2014-04-15','12:10:00',6.65),('8902','2014-04-15','12:15:00',3.63),('8902','2014-04-15','12:20:00',8.55),('8902','2014-04-15','12:25:00',3.85),('8902','2014-04-15','12:30:00',4.78),('8902','2014-04-15','12:35:00',9.33),('8902','2014-04-15','12:40:00',9.49),('8902','2014-04-15','12:45:00',9.21),('8902','2014-04-15','12:50:00',8.61),('8902','2014-04-15','12:55:00',6.76),('8902','2014-04-15','13:00:00',5.5),('8902','2014-04-15','13:05:00',2.01),('8902','2014-04-15','13:10:00',1.42),('8902','2014-04-15','13:15:00',1.6),('8902','2014-04-15','13:20:00',2.95),('8902','2014-04-15','13:25:00',2.12),('8902','2014-04-15','13:30:00',1.73),('8902','2014-04-15','13:35:00',2.77),('8902','2014-04-15','13:40:00',4.52),('8902','2014-04-15','13:45:00',8.22),('8902','2014-04-15','13:50:00',7.94),('8902','2014-04-15','13:55:00',5.43),('8902','2014-04-15','14:00:00',3.48),('8902','2014-04-15','14:05:00',4.68),('8902','2014-04-15','14:10:00',9.47),('8902','2014-04-15','14:15:00',10),('8902','2014-04-15','14:20:00',9.32),('8902','2014-04-15','14:25:00',7.03),('8902','2014-04-15','14:30:00',7.29),('8902','2014-04-15','14:35:00',8.88),('8902','2014-04-15','14:40:00',8.64),('8902','2014-04-15','14:45:00',6.28),('8902','2014-04-15','14:50:00',7),('8902','2014-04-15','14:55:00',2.98),('8902','2014-04-15','15:00:00',4.26),('8902','2014-04-15','15:05:00',6.16),('8902','2014-04-15','15:10:00',9.82),('8902','2014-04-15','15:15:00',5.74),('8902','2014-04-15','15:20:00',1.15),('8902','2014-04-15','15:25:00',2.4),('8902','2014-04-15','15:30:00',6.41),('8902','2014-04-15','15:35:00',8.64),('8902','2014-04-15','15:40:00',8.32),('8902','2014-04-15','15:45:00',7.96),('8902','2014-04-15','15:50:00',7.7),('8902','2014-04-15','15:55:00',7.5),('8902','2014-04-15','16:00:00',7.28),('8902','2014-04-15','16:05:00',7.16),('8902','2014-04-15','16:10:00',6.95),('8902','2014-04-15','16:15:00',6.82),('8902','2014-04-15','16:20:00',6.6),('8902','2014-04-15','16:25:00',6.48),('8902','2014-04-15','16:30:00',6.4),('8902','2014-04-15','16:35:00',6.28),('8902','2014-04-15','16:40:00',6.16),('8902','2014-04-15','16:45:00',5.91),('8902','2014-04-15','16:50:00',5.72),('8902','2014-04-15','16:55:00',5.57),('8902','2014-04-15','17:00:00',5.41),('8902','2014-04-15','17:05:00',5.19),('8902','2014-04-15','17:10:00',5),('8902','2014-04-15','17:15:00',4.9),('8902','2014-04-15','17:20:00',4.65),('8902','2014-04-15','17:25:00',4.4),('8902','2014-04-15','17:30:00',4.2),('8902','2014-04-15','17:35:00',4.1),('8902','2014-04-15','17:40:00',3.83),('8902','2014-04-15','17:45:00',3.72),('8902','2014-04-15','17:50:00',3.72),('8902','2014-04-15','17:55:00',3.64),('8902','2014-04-15','18:00:00',3.31),('8902','2014-04-15','18:05:00',3.09),('8902','2014-04-15','18:10:00',2.85),('8902','2014-04-15','18:15:00',2.47),('8902','2014-04-15','18:20:00',2.36),('8902','2014-04-15','18:25:00',2.05),('8902','2014-04-15','18:30:00',1.68),('8902','2014-04-15','18:35:00',1.63),('8902','2014-04-15','18:40:00',1.59),('8902','2014-04-15','18:45:00',1.59),('8902','2014-04-15','18:50:00',1.5),('8902','2014-04-15','18:55:00',1.22),('8902','2013-10-17','08:25:00',1.01),('8902','2013-10-17','08:30:00',1.04),('8902','2013-10-17','08:35:00',1.23),('8902','2013-10-17','08:40:00',1.46),('8902','2013-10-17','08:45:00',1.68),('8902','2013-10-17','08:50:00',1.77),('8902','2013-10-17','08:55:00',1.89),('8902','2013-10-17','09:00:00',2.17),('8902','2013-10-17','09:05:00',2.46),('8902','2013-10-17','09:10:00',2.66),('8902','2013-10-17','09:15:00',2.75),('8902','2013-10-17','09:20:00',3.06),('8902','2013-10-17','09:25:00',3.18),('8902','2013-10-17','09:30:00',3.42),('8902','2013-10-17','09:35:00',3.62),('8902','2013-10-17','09:40:00',3.79),('8902','2013-10-17','09:45:00',3.97),('8902','2013-10-17','09:50:00',4.14),('8902','2013-10-17','09:55:00',4.29),('8902','2013-10-17','10:00:00',4.41),('8902','2013-10-17','10:05:00',4.58),('8902','2013-10-17','10:10:00',4.7),('8902','2013-10-17','10:15:00',4.8),('8902','2013-10-17','10:20:00',4.88),('8902','2013-10-17','10:25:00',5.07),('8902','2013-10-17','10:30:00',5.19),('8902','2013-10-17','10:35:00',5.31),('8902','2013-10-17','10:40:00',5.41),('8902','2013-10-17','10:45:00',5.51),('8902','2013-10-17','10:50:00',5.6),('8902','2013-10-17','10:55:00',5.69),('8902','2013-10-17','11:00:00',5.71),('8902','2013-10-17','11:05:00',5.65),('8902','2013-10-17','11:10:00',5.59),('8902','2013-10-17','11:15:00',5.52),('8902','2013-10-17','11:20:00',6.05),('8902','2013-10-17','11:25:00',5.77),('8902','2013-10-17','11:30:00',6.14),('8902','2013-10-17','11:35:00',6.24),('8902','2013-10-17','11:40:00',6.43),('8902','2013-10-17','11:45:00',5.34),('8902','2013-10-17','11:50:00',6.27),('8902','2013-10-17','11:55:00',6.54),('8902','2013-10-17','12:00:00',6.33),('8902','2013-10-17','12:05:00',6.53),('8902','2013-10-17','12:10:00',6.55),('8902','2013-10-17','12:15:00',6.46),('8902','2013-10-17','12:20:00',6.43),('8902','2013-10-17','12:25:00',6.55),('8902','2013-10-17','12:30:00',6.65),('8902','2013-10-17','12:35:00',6.52),('8902','2013-10-17','12:40:00',6.59),('8902','2013-10-17','12:45:00',6.43),('8902','2013-10-17','12:50:00',6.47),('8902','2013-10-17','12:55:00',6.66),('8902','2013-10-17','13:00:00',6.6),('8902','2013-10-17','13:05:00',6.41),('8902','2013-10-17','13:10:00',6.16),('8902','2013-10-17','13:15:00',6.47),('8902','2013-10-17','13:20:00',6.44),('8902','2013-10-17','13:25:00',6.68),('8902','2013-10-17','13:30:00',6.65),('8902','2013-10-17','13:35:00',6.59),('8902','2013-10-17','13:40:00',6.57),('8902','2013-10-17','13:45:00',6.44),('8902','2013-10-17','13:50:00',6.42),('8902','2013-10-17','13:55:00',6.42),('8902','2013-10-17','14:00:00',5.98),('8902','2013-10-17','14:05:00',6.09),('8902','2013-10-17','14:10:00',6.03),('8902','2013-10-17','14:15:00',6.16),('8902','2013-10-17','14:20:00',6.13),('8902','2013-10-17','14:25:00',6.08),('8902','2013-10-17','14:30:00',6.06),('8902','2013-10-17','14:35:00',5.84),('8902','2013-10-17','14:40:00',5.9),('8902','2013-10-17','14:45:00',5.75),('8902','2013-10-17','14:50:00',5.54),('8902','2013-10-17','14:55:00',5.65),('8902','2013-10-17','15:00:00',4.94),('8902','2013-10-17','15:05:00',4.49),('8902','2013-10-17','15:10:00',4.95),('8902','2013-10-17','15:15:00',4.99),('8902','2013-10-17','15:20:00',5.2),('8902','2013-10-17','15:25:00',4.95),('8902','2013-10-17','15:30:00',4.67),('8902','2013-10-17','15:35:00',4.69),('8902','2013-10-17','15:40:00',4.5),('8902','2013-10-17','15:45:00',4.16),('8902','2013-10-17','15:50:00',4.09),('8902','2013-10-17','15:55:00',3.72),('8902','2013-10-17','16:00:00',3.96),('8902','2013-10-17','16:05:00',3.74),('8902','2013-10-17','16:10:00',3.63),('8902','2013-10-17','16:15:00',3.28),('8902','2013-10-17','16:20:00',3.09),('8902','2013-10-17','16:25:00',2.74),('8902','2013-10-17','16:30:00',2.47),('8902','2013-10-17','16:35:00',2.38),('8902','2013-10-17','16:40:00',1.87),('8902','2013-10-17','16:45:00',1.77),('8902','2013-10-17','16:50:00',1.51),('8902','2013-10-17','16:55:00',1.92),('8902','2013-10-17','17:00:00',1.5),('8902','2013-10-17','17:05:00',1.35),('8902','2013-10-17','17:10:00',1.48),('8902','2013-10-17','17:15:00',1.25),('8902','2013-10-17','17:20:00',1.2),('8902','2013-10-16','08:30:00',1.28),('8902','2013-10-16','08:35:00',1.45),('8902','2013-10-16','08:40:00',1.63),('8902','2013-10-16','08:45:00',1.81),('8902','2013-10-16','08:50:00',1.98),('8902','2013-10-16','08:55:00',2.17),('8902','2013-10-16','09:00:00',2.36),('8902','2013-10-16','09:05:00',2.56),('8902','2013-10-16','09:10:00',2.71),('8902','2013-10-16','09:15:00',2.87),('8902','2013-10-16','09:20:00',3.05),('8902','2013-10-16','09:25:00',3.25),('8902','2013-10-16','09:30:00',3.42),('8902','2013-10-16','09:35:00',3.61),('8902','2013-10-16','09:40:00',3.77),('8902','2013-10-16','09:45:00',3.93),('8902','2013-10-16','09:50:00',4.11),('8902','2013-10-16','09:55:00',4.25),('8902','2013-10-16','10:00:00',4.38),('8902','2013-10-16','10:05:00',4.51),('8902','2013-10-16','10:10:00',4.66),('8902','2013-10-16','10:15:00',4.8),('8902','2013-10-16','10:20:00',4.94),('8902','2013-10-16','10:25:00',5.08),('8902','2013-10-16','10:30:00',5.21),('8902','2013-10-16','10:35:00',5.34),('8902','2013-10-16','10:40:00',5.46),('8902','2013-10-16','10:45:00',5.57),('8902','2013-10-16','10:50:00',5.64),('8902','2013-10-16','10:55:00',5.76),('8902','2013-10-16','11:00:00',5.89),('8902','2013-10-16','11:05:00',5.95),('8902','2013-10-16','11:10:00',6.03),('8902','2013-10-16','11:15:00',6.09),('8902','2013-10-16','11:20:00',6.17),('8902','2013-10-16','11:25:00',6.24),('8902','2013-10-16','11:30:00',6.31),('8902','2013-10-16','11:35:00',6.42),('8902','2013-10-16','11:40:00',6.47),('8902','2013-10-16','11:45:00',6.49),('8902','2013-10-16','11:50:00',6.52),('8902','2013-10-16','11:55:00',6.61),('8902','2013-10-16','12:00:00',6.61),('8902','2013-10-16','12:05:00',6.65),('8902','2013-10-16','12:10:00',6.73),('8902','2013-10-16','12:15:00',6.74),('8902','2013-10-16','12:20:00',6.79),('8902','2013-10-16','12:25:00',6.85),('8902','2013-10-16','12:30:00',6.81),('8902','2013-10-16','12:35:00',6.81),('8902','2013-10-16','12:40:00',6.86),('8902','2013-10-16','12:45:00',6.91),('8902','2013-10-16','12:50:00',6.92),('8902','2013-10-16','12:55:00',6.94),('8902','2013-10-16','13:00:00',6.97),('8902','2013-10-16','13:05:00',6.94),('8902','2013-10-16','13:10:00',6.91),('8902','2013-10-16','13:15:00',6.86),('8902','2013-10-16','13:20:00',6.9),('8902','2013-10-16','13:25:00',6.89),('8902','2013-10-16','13:30:00',6.84),('8902','2013-10-16','13:35:00',6.8),('8902','2013-10-16','13:40:00',6.76),('8902','2013-10-16','13:45:00',6.74),('8902','2013-10-16','13:50:00',6.72),('8902','2013-10-16','13:55:00',6.69),('8902','2013-10-16','14:00:00',6.67),('8902','2013-10-16','14:05:00',6.64),('8902','2013-10-16','14:10:00',6.57),('8902','2013-10-16','14:15:00',6.54),('8902','2013-10-16','14:20:00',6.48),('8902','2013-10-16','14:25:00',6.44),('8902','2013-10-16','14:30:00',6.35),('8902','2013-10-16','14:35:00',6.25),('8902','2013-10-16','14:40:00',6.17),('8902','2013-10-16','14:45:00',6.16),('8902','2013-10-16','14:50:00',6.08),('8902','2013-10-16','14:55:00',5.97),('8902','2013-10-16','15:00:00',5.88),('8902','2013-10-16','15:05:00',5.76),('8902','2013-10-16','15:10:00',5.71),('8902','2013-10-16','15:15:00',5.62),('8902','2013-10-16','15:20:00',5.51),('8902','2013-10-16','15:25:00',5.4),('8902','2013-10-16','15:30:00',5.3),('8902','2013-10-16','15:35:00',5.14),('8902','2013-10-16','15:40:00',5),('8902','2013-10-16','15:45:00',4.88),('8902','2013-10-16','15:50:00',4.75),('8902','2013-10-16','15:55:00',4.59),('8902','2013-10-16','16:00:00',4.42),('8902','2013-10-16','16:05:00',4.25),('8902','2013-10-16','16:10:00',4.14),('8902','2013-10-16','16:15:00',4.01),('8902','2013-10-16','16:20:00',3.87),('8902','2013-10-16','16:25:00',3.71),('8902','2013-10-16','16:30:00',3.55),('8902','2013-10-16','16:35:00',3.34),('8902','2013-10-16','16:40:00',3.19),('8902','2013-10-16','16:45:00',3.01),('8902','2013-10-16','16:50:00',2.84),('8902','2013-10-16','16:55:00',2.63),('8902','2013-10-16','17:00:00',2.43),('8902','2013-10-16','17:05:00',2.27),('8902','2013-10-16','17:10:00',2.11),('8902','2013-10-16','17:15:00',1.91),('8902','2013-10-16','17:20:00',1.71),('8902','2013-10-16','17:25:00',1.5),('8902','2013-10-16','17:30:00',1.26),('8902','2013-10-16','17:35:00',1.12),('8902','2013-10-15','09:40:00',1.25),('8902','2013-10-15','09:45:00',2.5),('8902','2013-10-15','09:50:00',3.86),('8902','2013-10-15','09:55:00',1.61),('8902','2013-10-15','10:00:00',1.57),('8902','2013-10-15','10:05:00',1.02),('8902','2013-10-15','11:05:00',1.37),('8902','2013-10-15','11:10:00',1.63),('8902','2013-10-15','11:15:00',2.65),('8902','2013-10-15','11:20:00',2.03),('8902','2013-10-15','11:25:00',1.22),('8902','2013-10-15','11:30:00',1.1),('8902','2013-10-15','11:55:00',2.17),('8902','2013-10-15','12:00:00',1.96),('8902','2013-10-15','12:10:00',1.65),('8902','2013-10-15','12:15:00',3.76),('8902','2013-10-15','12:20:00',7.15),('8902','2013-10-15','12:25:00',2.14),('8902','2013-10-15','12:30:00',2.79),('8902','2013-10-15','12:35:00',4.28),('8902','2013-10-15','12:40:00',6.92),('8902','2013-10-15','12:45:00',7.19),('8902','2013-10-15','12:50:00',5.96),('8902','2013-10-15','12:55:00',6.16),('8902','2013-10-15','13:00:00',6.12),('8902','2013-10-15','13:05:00',6.35),('8902','2013-10-15','13:10:00',5.92),('8902','2013-10-15','13:15:00',6.54),('8902','2013-10-15','13:20:00',6.36),('8902','2013-10-15','13:25:00',6.51),('8902','2013-10-15','13:30:00',7.4),('8902','2013-10-15','13:35:00',6.95),('8902','2013-10-15','13:40:00',6.88),('8902','2013-10-15','13:45:00',6.85),('8902','2013-10-15','13:50:00',6.79),('8902','2013-10-15','13:55:00',7.12),('8902','2013-10-15','14:00:00',6.1),('8902','2013-10-15','14:05:00',4.45),('8902','2013-10-15','14:10:00',7.42),('8902','2013-10-15','14:15:00',7.02),('8902','2013-10-15','14:20:00',5.6),('8902','2013-10-15','14:25:00',7.05),('8902','2013-10-15','14:30:00',6.81),('8902','2013-10-15','14:35:00',6.27),('8902','2013-10-15','14:40:00',5.28),('8902','2013-10-15','14:45:00',6.54),('8902','2013-10-15','14:50:00',5.38),('8902','2013-10-15','14:55:00',5.66),('8902','2013-10-15','15:00:00',5.52),('8902','2013-10-15','15:05:00',5.88),('8902','2013-10-15','15:10:00',5.49),('8902','2013-10-15','15:15:00',5.81),('8902','2013-10-15','15:20:00',5.47),('8902','2013-10-15','15:25:00',5.15),('8902','2013-10-15','15:30:00',1.5),('8902','2013-10-15','15:35:00',2.38),('8902','2013-10-15','15:40:00',5.48),('8902','2013-10-15','15:45:00',5.03),('8902','2013-10-15','15:50:00',4.75),('8902','2013-10-15','15:55:00',4.64),('8902','2013-10-15','16:00:00',4.45),('8902','2013-10-15','16:05:00',4.34),('8902','2013-10-15','16:10:00',3.68),('8902','2013-10-15','16:15:00',4.01),('8902','2013-10-15','16:20:00',3.84),('8902','2013-10-15','16:25:00',3.61),('8902','2013-10-15','16:30:00',3.42),('8902','2013-10-15','16:35:00',2.9),('8902','2013-10-15','16:40:00',3.19),('8902','2013-10-15','16:45:00',2.96),('8902','2013-10-15','16:50:00',2.82),('8902','2013-10-15','16:55:00',2.63),('8902','2013-10-15','17:00:00',2.4),('8902','2013-10-15','17:05:00',2.21),('8902','2013-10-15','17:10:00',2.02),('8902','2013-10-15','17:15:00',1.85),('8902','2013-10-15','17:20:00',1.68),('8902','2013-10-15','17:25:00',1.52),('8902','2013-10-15','17:30:00',1.31),('8902','2013-10-15','17:35:00',1.17),('8902','2013-10-15','17:40:00',1.39),('8902','2013-10-15','17:45:00',1.32),('8902','2013-10-14','08:30:00',1.05),('8902','2013-10-14','08:35:00',1.06),('8902','2013-10-14','08:40:00',1.05),('8902','2013-10-14','08:45:00',1.03),('8902','2013-10-14','08:55:00',1.08),('8902','2013-10-14','09:00:00',1.32),('8902','2013-10-14','09:05:00',1.64),('8902','2013-10-14','09:10:00',1.75),('8902','2013-10-14','09:15:00',1.71),('8902','2013-10-14','09:20:00',1.91),('8902','2013-10-14','09:25:00',2),('8902','2013-10-14','09:30:00',2.96),('8902','2013-10-14','09:35:00',1.85),('8902','2013-10-14','09:40:00',2.73),('8902','2013-10-14','09:45:00',3.51),('8902','2013-10-14','09:50:00',4.02),('8902','2013-10-14','09:55:00',4.24),('8902','2013-10-14','10:00:00',4.3),('8902','2013-10-14','10:05:00',4.67),('8902','2013-10-14','10:10:00',3.73),('8902','2013-10-14','10:15:00',2.33),('8902','2013-10-14','10:20:00',2.3),('8902','2013-10-14','10:25:00',2.55),('8902','2013-10-14','10:30:00',3.89),('8902','2013-10-14','10:35:00',3.22),('8902','2013-10-14','10:40:00',3.72),('8902','2013-10-14','10:45:00',4.31),('8902','2013-10-14','10:50:00',4.39),('8902','2013-10-14','10:55:00',3.68),('8902','2013-10-14','11:00:00',3.65),('8902','2013-10-14','11:05:00',3.8),('8902','2013-10-14','11:10:00',5.05),('8902','2013-10-14','11:15:00',5.55),('8902','2013-10-14','11:20:00',5.6),('8902','2013-10-14','11:25:00',5.28),('8902','2013-10-14','11:30:00',5.5),('8902','2013-10-14','11:35:00',4.74),('8902','2013-10-14','11:40:00',3.73),('8902','2013-10-14','11:45:00',2.94),('8902','2013-10-14','11:50:00',2.8),('8902','2013-10-14','11:55:00',2.76),('8902','2013-10-14','12:00:00',2.87),('8902','2013-10-14','12:05:00',2.9),('8902','2013-10-14','12:10:00',2.99),('8902','2013-10-14','12:15:00',2.95),('8902','2013-10-14','12:20:00',3.09),('8902','2013-10-14','12:25:00',2.86),('8902','2013-10-14','12:30:00',2.58),('8902','2013-10-14','12:35:00',2.51),('8902','2013-10-14','12:40:00',2.5),('8902','2013-10-14','12:45:00',2.66),('8902','2013-10-14','12:50:00',2.5),('8902','2013-10-14','12:55:00',2.26),('8902','2013-10-14','13:00:00',2.26),('8902','2013-10-14','13:05:00',2.96),('8902','2013-10-14','13:10:00',3.62),('8902','2013-10-14','13:15:00',3.61),('8902','2013-10-14','13:20:00',5.22),('8902','2013-10-14','13:25:00',6.24),('8902','2013-10-14','13:30:00',4.03),('8902','2013-10-14','13:35:00',3.34),('8902','2013-10-14','13:40:00',3.07),('8902','2013-10-14','13:45:00',3.14),('8902','2013-10-14','13:50:00',2.81),('8902','2013-10-14','13:55:00',2.5),('8902','2013-10-14','14:00:00',2.23),('8902','2013-10-14','14:05:00',2.2),('8902','2013-10-14','14:10:00',2.43),('8902','2013-10-14','14:15:00',3.35),('8902','2013-10-14','14:20:00',4),('8902','2013-10-14','14:25:00',4.36),('8902','2013-10-14','14:30:00',4.55),('8902','2013-10-14','14:35:00',2.83),('8902','2013-10-14','14:40:00',3.45),('8902','2013-10-14','14:45:00',3.82),('8902','2013-10-14','14:50:00',4.83),('8902','2013-10-14','14:55:00',4.29),('8902','2013-10-14','15:00:00',2.66),('8902','2013-10-14','15:05:00',2.62),('8902','2013-10-14','15:10:00',2.79),('8902','2013-10-14','15:15:00',2.54),('8902','2013-10-14','15:20:00',2.29),('8902','2013-10-14','15:25:00',1.99),('8902','2013-10-14','15:30:00',1.89),('8902','2013-10-14','15:35:00',1.97),('8902','2013-10-14','15:40:00',2.07),('8902','2013-10-14','15:45:00',2),('8902','2013-10-14','15:50:00',1.76),('8902','2013-10-14','15:55:00',1.53),('8902','2013-10-14','16:00:00',1.39),('8902','2013-10-14','16:05:00',1.4),('8902','2013-10-14','16:10:00',1.46),('8902','2013-10-14','16:15:00',1.38),('8902','2013-10-14','16:20:00',1.25),('8902','2013-10-14','16:25:00',1.68),('8902','2013-10-14','16:30:00',2.23),('8902','2013-10-14','16:35:00',2.37),('8902','2013-10-14','16:40:00',1.86),('8902','2013-10-14','16:45:00',1.68),('8902','2013-10-14','16:50:00',1.29),('8902','2013-10-14','16:55:00',1.27),('8902','2013-10-14','17:00:00',1.25),('8902','2013-10-14','17:05:00',1.14),('8902','2013-10-14','17:10:00',1.01),('8902','2013-10-13','08:25:00',1.17),('8902','2013-10-13','08:30:00',1.28),('8902','2013-10-13','08:35:00',1.43),('8902','2013-10-13','08:40:00',1.37),('8902','2013-10-13','08:45:00',1.68),('8902','2013-10-13','08:50:00',1.81),('8902','2013-10-13','08:55:00',2.13),('8902','2013-10-13','09:00:00',1.97),('8902','2013-10-13','09:05:00',2.03),('8902','2013-10-13','09:10:00',1.96),('8902','2013-10-13','09:15:00',1.45),('8902','2013-10-13','09:20:00',1.93),('8902','2013-10-13','09:25:00',2.96),('8902','2013-10-13','09:30:00',3.41),('8902','2013-10-13','09:35:00',3.51),('8902','2013-10-13','09:40:00',2.92),('8902','2013-10-13','09:45:00',2.64),('8902','2013-10-13','09:50:00',3.11),('8902','2013-10-13','09:55:00',3.79),('8902','2013-10-13','10:00:00',3.72),('8902','2013-10-13','10:05:00',4.13),('8902','2013-10-13','10:10:00',4.27),('8902','2013-10-13','10:15:00',4.63),('8902','2013-10-13','10:20:00',4.71),('8902','2013-10-13','10:25:00',4.81),('8902','2013-10-13','10:30:00',4.9),('8902','2013-10-13','10:35:00',4.96),('8902','2013-10-13','10:40:00',4.94),('8902','2013-10-13','10:45:00',5.07),('8902','2013-10-13','10:50:00',5.3),('8902','2013-10-13','10:55:00',5.41),('8902','2013-10-13','11:00:00',5.54),('8902','2013-10-13','11:05:00',5.53),('8902','2013-10-13','11:10:00',5.76),('8902','2013-10-13','11:15:00',5.78),('8902','2013-10-13','11:20:00',5.77),('8902','2013-10-13','11:25:00',5.89),('8902','2013-10-13','11:30:00',6.06),('8902','2013-10-13','11:35:00',5.9),('8902','2013-10-13','11:40:00',6),('8902','2013-10-13','11:45:00',6.03),('8902','2013-10-13','11:50:00',6.05),('8902','2013-10-13','11:55:00',6.1),('8902','2013-10-13','12:00:00',6.18),('8902','2013-10-13','12:05:00',6.2),('8902','2013-10-13','12:10:00',6.33),('8902','2013-10-13','12:15:00',6.31),('8902','2013-10-13','12:20:00',5.9),('8902','2013-10-13','12:25:00',6.15),('8902','2013-10-13','12:30:00',6.51),('8902','2013-10-13','12:35:00',6.44),('8902','2013-10-13','12:40:00',6.44),('8902','2013-10-13','12:45:00',6.47),('8902','2013-10-13','12:50:00',6.44),('8902','2013-10-13','12:55:00',6.49),('8902','2013-10-13','13:00:00',6.49),('8902','2013-10-13','13:05:00',6.5),('8902','2013-10-13','13:10:00',6.45),('8902','2013-10-13','13:15:00',6.44),('8902','2013-10-13','13:20:00',6.46),('8902','2013-10-13','13:25:00',6.41),('8902','2013-10-13','13:30:00',6.37),('8902','2013-10-13','13:35:00',6.35),('8902','2013-10-13','13:40:00',6.34),('8902','2013-10-13','13:45:00',6.3),('8902','2013-10-13','13:50:00',6.28),('8902','2013-10-13','13:55:00',6.26),('8902','2013-10-13','14:00:00',6.21),('8902','2013-10-13','14:05:00',6.17),('8902','2013-10-13','14:10:00',6.11),('8902','2013-10-13','14:15:00',6.08),('8902','2013-10-13','14:20:00',6.06),('8902','2013-10-13','14:25:00',6),('8902','2013-10-13','14:30:00',5.96),('8902','2013-10-13','14:35:00',5.89),('8902','2013-10-13','14:40:00',5.78),('8902','2013-10-13','14:45:00',5.71),('8902','2013-10-13','14:50:00',5.66),('8902','2013-10-13','14:55:00',5.59),('8902','2013-10-13','15:00:00',5.54),('8902','2013-10-13','15:05:00',5.45),('8902','2013-10-13','15:10:00',5.3),('8902','2013-10-13','15:15:00',5.16),('8902','2013-10-13','15:20:00',5.07),('8902','2013-10-13','15:25:00',4.96),('8902','2013-10-13','15:30:00',4.8),('8902','2013-10-13','15:35:00',4.62),('8902','2013-10-13','15:40:00',4.29),('8902','2013-10-13','15:45:00',3.66),('8902','2013-10-13','15:50:00',3.49),('8902','2013-10-13','15:55:00',2.52),('8902','2013-10-13','16:00:00',2.91),('8902','2013-10-13','16:05:00',2.34),('8902','2013-10-13','16:10:00',1.91),('8902','2013-10-13','16:15:00',1.94),('8902','2013-10-13','16:20:00',1.7),('8902','2013-10-13','16:25:00',2.29),('8902','2013-10-13','16:30:00',1.72),('8902','2013-10-13','16:35:00',1.11),('8902','2013-10-13','16:45:00',1.59),('8902','2013-10-13','16:50:00',1.47),('8902','2013-10-12','08:35:00',1.19),('8902','2013-10-12','08:40:00',1.22),('8902','2013-10-12','08:45:00',1.24),('8902','2013-10-12','08:50:00',1.37),('8902','2013-10-12','08:55:00',1.63),('8902','2013-10-12','09:00:00',1.87),('8902','2013-10-12','09:05:00',1.98),('8902','2013-10-12','09:10:00',1.87),('8902','2013-10-12','09:15:00',2.92),('8902','2013-10-12','09:20:00',3.23),('8902','2013-10-12','09:25:00',3.13),('8902','2013-10-12','09:30:00',2.27),('8902','2013-10-12','09:35:00',2.7),('8902','2013-10-12','09:40:00',3.98),('8902','2013-10-12','09:45:00',4.99),('8902','2013-10-12','09:50:00',4.94),('8902','2013-10-12','09:55:00',5.13),('8902','2013-10-12','10:00:00',4.11),('8902','2013-10-12','10:05:00',2.87),('8902','2013-10-12','10:10:00',3.78),('8902','2013-10-12','10:15:00',4.48),('8902','2013-10-12','10:20:00',3.72),('8902','2013-10-12','10:25:00',4.12),('8902','2013-10-12','10:30:00',5.08),('8902','2013-10-12','10:35:00',5.93),('8902','2013-10-12','10:40:00',6.18),('8902','2013-10-12','10:45:00',6.29),('8902','2013-10-12','10:50:00',5.19),('8902','2013-10-12','10:55:00',4.22),('8902','2013-10-12','11:00:00',5.47),('8902','2013-10-12','11:05:00',5.86),('8902','2013-10-12','11:10:00',5.68),('8902','2013-10-12','11:15:00',6.22),('8902','2013-10-12','11:20:00',5.98),('8902','2013-10-12','11:25:00',5.89),('8902','2013-10-12','11:30:00',6.06),('8902','2013-10-12','11:35:00',6.08),('8902','2013-10-12','11:40:00',6.11),('8902','2013-10-12','11:45:00',6.14),('8902','2013-10-12','11:50:00',6.23),('8902','2013-10-12','11:55:00',6.22),('8902','2013-10-12','12:00:00',6.3),('8902','2013-10-12','12:05:00',6.31),('8902','2013-10-12','12:10:00',6.33),('8902','2013-10-12','12:15:00',6.4),('8902','2013-10-12','12:20:00',6.27),('8902','2013-10-12','12:25:00',6.05),('8902','2013-10-12','12:30:00',6.46),('8902','2013-10-12','12:35:00',6.56),('8902','2013-10-12','12:40:00',6.56),('8902','2013-10-12','12:45:00',6.47),('8902','2013-10-12','12:50:00',6.41),('8902','2013-10-12','12:55:00',6.42),('8902','2013-10-12','13:00:00',6.5),('8902','2013-10-12','13:05:00',6.48),('8902','2013-10-12','13:10:00',6.51),('8902','2013-10-12','13:15:00',6.62),('8902','2013-10-12','13:20:00',6.67),('8902','2013-10-12','13:25:00',5.81),('8902','2013-10-12','13:30:00',4.84),('8902','2013-10-12','13:35:00',5.51),('8902','2013-10-12','13:40:00',3.63),('8902','2013-10-12','13:45:00',3.88),('8902','2013-10-12','13:50:00',4.35),('8902','2013-10-12','13:55:00',4.98),('8902','2013-10-12','14:00:00',6.49),('8902','2013-10-12','14:05:00',6.41),('8902','2013-10-12','14:10:00',6.26),('8902','2013-10-12','14:15:00',5.82),('8902','2013-10-12','14:20:00',6.35),('8902','2013-10-12','14:25:00',6.41),('8902','2013-10-12','14:30:00',5.81),('8902','2013-10-12','14:35:00',4.8),('8902','2013-10-12','14:40:00',5.65),('8902','2013-10-12','14:45:00',4.49),('8902','2013-10-12','14:50:00',3.55),('8902','2013-10-12','14:55:00',4.32),('8902','2013-10-12','15:00:00',5.12),('8902','2013-10-12','15:05:00',4.73),('8902','2013-10-12','15:10:00',3.18),('8902','2013-10-12','15:15:00',3.82),('8902','2013-10-12','15:20:00',4.33),('8902','2013-10-12','15:25:00',4.92),('8902','2013-10-12','15:30:00',3.53),('8902','2013-10-12','15:35:00',3.14),('8902','2013-10-12','15:40:00',2.99),('8902','2013-10-12','15:45:00',2.99),('8902','2013-10-12','15:50:00',2.68),('8902','2013-10-12','15:55:00',2.53),('8902','2013-10-12','16:00:00',2.59),('8902','2013-10-12','16:05:00',3.63),('8902','2013-10-12','16:10:00',3.19),('8902','2013-10-12','16:15:00',2.59),('8902','2013-10-12','16:20:00',3),('8902','2013-10-12','16:25:00',3.84),('8902','2013-10-12','16:30:00',3.82),('8902','2013-10-12','16:35:00',3.28),('8902','2013-10-12','16:40:00',2.53),('8902','2013-10-12','16:45:00',1.9),('8902','2013-10-12','16:50:00',2.14),('8902','2013-10-12','16:55:00',1.74),('8902','2013-10-12','17:00:00',1.19),('8902','2013-10-12','17:05:00',1.11),('8902','2013-10-12','17:20:00',1.33),('8902','2013-10-12','17:25:00',1.86),('8902','2013-10-12','17:30:00',1.2),('8902','2013-10-12','17:35:00',1.39),('8902','2013-10-12','17:40:00',1.1),('8902','2013-10-11','10:50:00',1.08),('8902','2013-10-11','10:55:00',1.18),('8902','2013-10-11','11:00:00',1.33),('8902','2013-10-11','11:05:00',1.44),('8902','2013-10-11','11:10:00',1.52),('8902','2013-10-11','11:15:00',1.71),('8902','2013-10-11','11:20:00',1.99),('8902','2013-10-11','11:25:00',2.19),('8902','2013-10-11','11:30:00',2.55),('8902','2013-10-11','11:35:00',3.26),('8902','2013-10-11','11:40:00',5.74),('8902','2013-10-11','11:45:00',3.29),('8902','2013-10-11','11:50:00',2.81),('8902','2013-10-11','11:55:00',2.46),('8902','2013-10-11','12:00:00',1.64),('8902','2013-10-11','12:05:00',1.16),('8902','2013-10-11','12:10:00',1.45),('8902','2013-10-11','12:15:00',2.12),('8902','2013-10-11','12:20:00',3.49),('8902','2013-10-11','12:25:00',7.31),('8902','2013-10-11','12:30:00',5.55),('8902','2013-10-11','12:35:00',6.41),('8902','2013-10-11','12:40:00',6.42),('8902','2013-10-11','12:45:00',5.99),('8902','2013-10-11','12:50:00',5.71),('8902','2013-10-11','12:55:00',4.85),('8902','2013-10-11','13:00:00',3.65),('8902','2013-10-11','13:05:00',2.96),('8902','2013-10-11','13:10:00',1.65),('8902','2013-10-11','13:15:00',2.12),('8902','2013-10-11','13:20:00',2.7),('8902','2013-10-11','13:25:00',2.86),('8902','2013-10-11','13:30:00',8.03),('8902','2013-10-11','13:35:00',3.48),('8902','2013-10-11','13:40:00',1.31),('8902','2013-10-11','14:00:00',1.29),('8902','2013-10-11','15:10:00',1.09),('8902','2013-10-11','15:15:00',1.17),('8902','2013-10-11','15:20:00',1.24),('8902','2013-10-11','15:25:00',1.44),('8902','2013-10-11','15:30:00',1.54),('8902','2013-10-11','15:35:00',1.44),('8902','2013-10-11','15:40:00',1.3),('8902','2013-10-11','15:45:00',1.23),('8902','2013-10-11','15:50:00',1.39),('8902','2013-10-11','15:55:00',1.83),('8902','2013-10-11','16:00:00',2.26),('8902','2013-10-11','16:05:00',2.12),('8902','2013-10-11','16:10:00',2.18),('8902','2013-10-11','16:15:00',3.27),('8902','2013-10-11','16:20:00',3.04),('8902','2013-10-11','16:25:00',1.77),('8902','2013-10-11','16:30:00',1.12),('8902','2013-10-11','16:55:00',1.04),('8902','2013-10-11','17:00:00',2.18),('8902','2013-10-11','17:05:00',1.1),('8902','2013-10-11','17:10:00',1.09),('8902','2013-10-11','17:20:00',1.05),('8902','2013-10-11','17:25:00',1.33),('8902','2013-10-10','09:15:00',1.14),('8902','2013-10-10','09:35:00',1.74),('8902','2013-10-10','09:45:00',4.12),('8902','2013-10-10','09:50:00',3.53),('8902','2013-10-10','09:55:00',3.73),('8902','2013-10-10','10:00:00',4.49),('8902','2013-10-10','10:05:00',4.63),('8902','2013-10-10','10:10:00',4.77),('8902','2013-10-10','10:15:00',3.63),('8902','2013-10-10','10:20:00',3.93),('8902','2013-10-10','10:25:00',2.51),('8902','2013-10-10','10:30:00',3.24),('8902','2013-10-10','10:35:00',4.73),('8902','2013-10-10','10:40:00',3.19),('8902','2013-10-10','10:45:00',1.38),('8902','2013-10-10','11:00:00',1.57),('8902','2013-10-10','11:05:00',5.28),('8902','2013-10-10','11:10:00',4.98),('8902','2013-10-10','11:15:00',2.23),('8902','2013-10-10','11:20:00',2.13),('8902','2013-10-10','11:25:00',2.17),('8902','2013-10-10','11:30:00',1.79),('8902','2013-10-10','11:35:00',2.4),('8902','2013-10-10','11:40:00',2.95),('8902','2013-10-10','11:45:00',3.14),('8902','2013-10-10','11:50:00',4.97),('8902','2013-10-10','11:55:00',3.48),('8902','2013-10-10','12:00:00',5.75),('8902','2013-10-10','12:05:00',8.4),('8902','2013-10-10','12:10:00',4.23),('8902','2013-10-10','12:15:00',2.12),('8902','2013-10-10','12:20:00',1.98),('8902','2013-10-10','12:25:00',1.98),('8902','2013-10-10','12:30:00',2.53),('8902','2013-10-10','12:35:00',1.26),('8902','2013-10-10','13:00:00',1.43),('8902','2013-10-10','13:05:00',4.88),('8902','2013-10-10','13:10:00',4.26),('8902','2013-10-10','13:15:00',3.25),('8902','2013-10-10','13:20:00',5.21),('8902','2013-10-10','13:25:00',8.58),('8902','2013-10-10','13:30:00',2.53),('8902','2013-10-10','13:35:00',1.1),('8902','2013-10-10','13:40:00',3.71),('8902','2013-10-10','13:45:00',6.79),('8902','2013-10-10','13:50:00',1.5),('8902','2013-10-10','15:10:00',1.48),('8902','2013-10-10','15:15:00',1.29),('8902','2013-10-10','15:25:00',1.28),('8902','2013-10-10','15:30:00',2.32),('8902','2013-10-10','15:35:00',2.09),('8902','2013-10-10','15:40:00',2.38),('8902','2013-10-10','15:45:00',1.99),('8902','2013-10-10','15:50:00',1.29),('8902','2013-10-10','15:55:00',1.55),('8902','2013-10-10','16:00:00',3.59),('8902','2013-10-10','16:05:00',2.17),('8902','2013-10-10','16:10:00',2.01),('8902','2013-10-10','16:15:00',1),('8902','2013-10-10','16:25:00',1.79),('8902','2013-10-10','16:30:00',1.59),('8902','2013-10-10','16:35:00',3.65),('8902','2013-10-10','16:40:00',1.38),('8902','2013-10-10','16:55:00',1.6),('8902','2013-10-10','17:00:00',1.02),('8902','2013-10-09','08:40:00',1.9),('8902','2013-10-09','08:45:00',1.8),('8902','2013-10-09','08:50:00',1.95),('8902','2013-10-09','08:55:00',2.59),('8902','2013-10-09','09:00:00',1.63),('8902','2013-10-09','09:10:00',1.54),('8902','2013-10-09','09:15:00',3.01),('8902','2013-10-09','09:20:00',3.17),('8902','2013-10-09','09:25:00',3.3),('8902','2013-10-09','09:30:00',3.42),('8902','2013-10-09','09:35:00',3.67),('8902','2013-10-09','09:40:00',3.22),('8902','2013-10-09','09:45:00',2.75),('8902','2013-10-09','09:50:00',1.04),('8902','2013-10-09','09:55:00',1.45),('8902','2013-10-09','10:00:00',1.35),('8902','2013-10-09','10:15:00',2.13),('8902','2013-10-09','10:20:00',5.1),('8902','2013-10-09','10:25:00',4.88),('8902','2013-10-09','10:30:00',4.4),('8902','2013-10-09','10:35:00',1.41),('8902','2013-10-09','10:45:00',4.72),('8902','2013-10-09','10:50:00',2.37),('8902','2013-10-09','10:55:00',1.56),('8902','2013-10-09','11:00:00',1.03),('8902','2013-10-09','11:05:00',1.57),('8902','2013-10-09','11:10:00',1.47),('8902','2013-10-09','11:15:00',3.61),('8902','2013-10-09','11:20:00',3.95),('8902','2013-10-09','11:25:00',7.63),('8902','2013-10-09','11:30:00',4.05),('8902','2013-10-09','11:35:00',1.41),('8902','2013-10-09','11:40:00',4.38),('8902','2013-10-09','11:45:00',6.43),('8902','2013-10-09','11:50:00',3.57),('8902','2013-10-09','11:55:00',6.95),('8902','2013-10-09','12:00:00',1.45),('8902','2013-10-09','12:05:00',2.3),('8902','2013-10-09','12:10:00',1.48),('8902','2013-10-09','12:15:00',1.14),('8902','2013-10-09','12:20:00',1.66),('8902','2013-10-09','12:25:00',4.95),('8902','2013-10-09','12:30:00',5.42),('8902','2013-10-09','12:35:00',8.44),('8902','2013-10-09','12:40:00',7.38),('8902','2013-10-09','12:45:00',7.29),('8902','2013-10-09','12:50:00',4.9),('8902','2013-10-09','12:55:00',2.47),('8902','2013-10-09','13:00:00',5.06),('8902','2013-10-09','13:05:00',7.36),('8902','2013-10-09','13:10:00',2.92),('8902','2013-10-09','13:15:00',2.24),('8902','2013-10-09','13:20:00',4.47),('8902','2013-10-09','13:25:00',3.56),('8902','2013-10-09','13:30:00',3.52),('8902','2013-10-09','13:35:00',3.29),('8902','2013-10-09','13:40:00',6.02),('8902','2013-10-09','13:45:00',5.88),('8902','2013-10-09','13:50:00',7.23),('8902','2013-10-09','13:55:00',7.35),('8902','2013-10-09','14:00:00',6.99),('8902','2013-10-09','14:05:00',3.72),('8902','2013-10-09','14:10:00',5.91),('8902','2013-10-09','14:15:00',4.9),('8902','2013-10-09','14:20:00',7.77),('8902','2013-10-09','14:25:00',5.23),('8902','2013-10-09','14:30:00',5.28),('8902','2013-10-09','14:35:00',5.33),('8902','2013-10-09','14:40:00',7.31),('8902','2013-10-09','14:45:00',5.16),('8902','2013-10-09','14:50:00',5.88),('8902','2013-10-09','14:55:00',6.8),('8902','2013-10-09','15:00:00',6.65),('8902','2013-10-09','15:05:00',6.74),('8902','2013-10-09','15:10:00',6.41),('8902','2013-10-09','15:15:00',5.01),('8902','2013-10-09','15:20:00',4.9),('8902','2013-10-09','15:25:00',2.47),('8902','2013-10-09','15:30:00',4.61),('8902','2013-10-09','15:35:00',2.69),('8902','2013-10-09','15:40:00',1.89),('8902','2013-10-09','15:45:00',2.35),('8902','2013-10-09','15:50:00',1.33),('8902','2013-10-09','15:55:00',1.46),('8902','2013-10-09','16:00:00',2.17),('8902','2013-10-09','16:05:00',1.43),('8902','2013-10-09','16:10:00',1.76),('8902','2013-10-09','16:15:00',5.04),('8902','2013-10-09','16:20:00',3.53),('8902','2013-10-09','16:25:00',3.86),('8902','2013-10-09','16:30:00',3.21),('8902','2013-10-09','16:40:00',2.43),('8902','2013-10-09','16:45:00',3.52),('8902','2013-10-09','16:50:00',3.35),('8902','2013-10-09','16:55:00',3.12),('8902','2013-10-09','17:00:00',2.9),('8902','2013-10-09','17:05:00',2.54),('8902','2013-10-09','17:15:00',1.3),('8902','2013-10-09','17:20:00',2.21),('8902','2013-10-09','17:25:00',1.22),('8902','2013-10-09','17:45:00',1.01),('8902','2013-10-08','08:25:00',1.21),('8902','2013-10-08','08:30:00',1.54),('8902','2013-10-08','08:35:00',1.53),('8902','2013-10-08','08:40:00',1.81),('8902','2013-10-08','08:45:00',2.02),('8902','2013-10-08','08:50:00',2.18),('8902','2013-10-08','08:55:00',2.35),('8902','2013-10-08','09:00:00',2.53),('8902','2013-10-08','09:05:00',2.74),('8902','2013-10-08','09:10:00',2.91),('8902','2013-10-08','09:15:00',2.92),('8902','2013-10-08','09:20:00',2.71),('8902','2013-10-08','09:25:00',3.46),('8902','2013-10-08','09:30:00',3.64),('8902','2013-10-08','09:35:00',3.79),('8902','2013-10-08','09:40:00',4.03),('8902','2013-10-08','09:45:00',4.27),('8902','2013-10-08','09:50:00',4.43),('8902','2013-10-08','09:55:00',4.64),('8902','2013-10-08','10:00:00',4.93),('8902','2013-10-08','10:05:00',5.32),('8902','2013-10-08','10:10:00',5.63),('8902','2013-10-08','10:15:00',3.79),('8902','2013-10-08','10:20:00',1.92),('8902','2013-10-08','10:25:00',2.44),('8902','2013-10-08','10:30:00',3.46),('8902','2013-10-08','10:35:00',3.16),('8902','2013-10-08','10:40:00',4.57),('8902','2013-10-08','10:45:00',4.79),('8902','2013-10-08','10:50:00',4.72),('8902','2013-10-08','10:55:00',3.97),('8902','2013-10-08','11:00:00',4.89),('8902','2013-10-08','11:05:00',6.91),('8902','2013-10-08','11:10:00',7.52),('8902','2013-10-08','11:15:00',7.47),('8902','2013-10-08','11:20:00',6.81),('8902','2013-10-08','11:25:00',6.43),('8902','2013-10-08','11:30:00',7.19),('8902','2013-10-08','11:35:00',7.71),('8902','2013-10-08','11:40:00',5.15),('8902','2013-10-08','11:45:00',5.63),('8902','2013-10-08','11:50:00',6.51),('8902','2013-10-08','11:55:00',6.5),('8902','2013-10-08','12:00:00',5.81),('8902','2013-10-08','12:05:00',3.11),('8902','2013-10-08','12:10:00',4.6),('8902','2013-10-08','12:15:00',2.86),('8902','2013-10-08','12:20:00',4.46),('8902','2013-10-08','12:25:00',7.11),('8902','2013-10-08','12:30:00',6.05),('8902','2013-10-08','12:35:00',4.86),('8902','2013-10-08','12:40:00',3.19),('8902','2013-10-08','12:45:00',2.36),('8902','2013-10-08','12:50:00',1.35),('8902','2013-10-08','12:55:00',2.2),('8902','2013-10-08','13:00:00',2.13),('8902','2013-10-08','13:05:00',1.67),('8902','2013-10-08','13:10:00',2.51),('8902','2013-10-08','13:15:00',4.06),('8902','2013-10-08','13:20:00',4.37),('8902','2013-10-08','13:25:00',4.56),('8902','2013-10-08','13:30:00',4.12),('8902','2013-10-08','13:35:00',3.38),('8902','2013-10-08','13:40:00',5.94),('8902','2013-10-08','13:45:00',6.38),('8902','2013-10-08','13:50:00',5.31),('8902','2013-10-08','13:55:00',8.58),('8902','2013-10-08','14:00:00',6.11),('8902','2013-10-08','14:05:00',2.09),('8902','2013-10-08','14:10:00',2.88),('8902','2013-10-08','14:15:00',1.44),('8902','2013-10-08','14:20:00',1.18),('8902','2013-10-08','14:25:00',1.24),('8902','2013-10-08','14:30:00',1.15),('8902','2013-10-08','14:50:00',1.53),('8902','2013-10-08','14:55:00',3.08),('8902','2013-10-08','15:00:00',3.39),('8902','2013-10-08','15:05:00',6.32),('8902','2013-10-08','15:10:00',6.4),('8902','2013-10-08','15:15:00',6.66),('8902','2013-10-08','15:20:00',5.77),('8902','2013-10-08','15:25:00',3.18),('8902','2013-10-08','15:30:00',4.96),('8902','2013-10-08','15:35:00',2.92),('8902','2013-10-08','15:40:00',5.61),('8902','2013-10-08','15:45:00',2.22),('8902','2013-10-08','15:50:00',4.73),('8902','2013-10-08','16:05:00',1.04),('8902','2013-10-08','16:10:00',1.62),('8902','2013-10-08','16:15:00',2.81),('8902','2013-10-08','16:20:00',3.34),('8902','2013-10-08','16:25:00',2.75),('8902','2013-10-08','16:30:00',3.03),('8902','2013-10-08','16:35:00',1.89),('8902','2013-10-08','16:40:00',4.35),('8902','2013-10-08','16:45:00',1.66),('8902','2013-10-08','17:20:00',1.06),('8902','2013-10-08','17:25:00',1.64),('8902','2013-10-08','17:30:00',1.7),('8902','2013-10-08','17:35:00',2.16),('8902','2013-10-08','17:40:00',1.46),('8902','2013-10-08','17:45:00',1.42),('8902','2013-10-08','17:50:00',1.08),('8902','2014-04-14','08:00:00',1.15),('8902','2014-04-14','08:05:00',1.09),('8902','2014-04-14','08:55:00',1.32),('8902','2014-04-14','09:00:00',2),('8902','2014-04-14','09:05:00',2.73),('8902','2014-04-14','09:10:00',3.2),('8902','2014-04-14','09:15:00',2.31),('8902','2014-04-14','09:20:00',2.77),('8902','2014-04-14','09:25:00',3.83),('8902','2014-04-14','09:30:00',3.08),('8902','2014-04-14','09:35:00',1.79),('8902','2014-04-14','09:40:00',1.18),('8902','2014-04-14','09:45:00',2.01),('8902','2014-04-14','09:50:00',4.93),('8902','2014-04-14','09:55:00',2.68),('8902','2014-04-14','10:00:00',3.31),('8902','2014-04-14','10:05:00',2.53),('8902','2014-04-14','10:10:00',2.68),('8902','2014-04-14','10:15:00',3.44),('8902','2014-04-14','10:20:00',2.76),('8902','2014-04-14','10:25:00',2.57),('8902','2014-04-14','10:30:00',6.29),('8902','2014-04-14','10:35:00',5.98),('8902','2014-04-14','10:40:00',4.44),('8902','2014-04-14','10:45:00',6.64),('8902','2014-04-14','10:50:00',5.27),('8902','2014-04-14','10:55:00',2.21),('8902','2014-04-14','11:00:00',3.55),('8902','2014-04-14','11:05:00',7.08),('8902','2014-04-14','11:10:00',5.98),('8902','2014-04-14','11:15:00',3.75),('8902','2014-04-14','11:20:00',2.37),('8902','2014-04-14','11:25:00',2.84),('8902','2014-04-14','11:30:00',2.09),('8902','2014-04-14','11:35:00',1.81),('8902','2014-04-14','11:40:00',1.25),('8902','2014-04-14','11:45:00',2.11),('8902','2014-04-14','11:50:00',2.77),('8902','2014-04-14','11:55:00',2.09),('8902','2014-04-14','12:00:00',1.4),('8902','2014-04-14','12:05:00',1.39),('8902','2014-04-14','12:10:00',2.08),('8902','2014-04-14','12:15:00',2.81),('8902','2014-04-14','12:20:00',4.3),('8902','2014-04-14','12:25:00',1.84),('8902','2014-04-14','12:30:00',1.2),('8902','2014-04-14','12:35:00',1.4),('8902','2014-04-14','12:40:00',1.23),('8902','2014-04-14','13:00:00',1.08),('8902','2014-04-14','13:05:00',1.9),('8902','2014-04-14','13:10:00',3.24),('8902','2014-04-14','13:15:00',3.21),('8902','2014-04-14','13:20:00',6.12),('8902','2014-04-14','13:25:00',3.79),('8902','2014-04-14','13:30:00',4.59),('8902','2014-04-14','13:35:00',5.01),('8902','2014-04-14','13:40:00',6.54),('8902','2014-04-14','13:45:00',2.9),('8902','2014-04-14','13:50:00',2.13),('8902','2014-04-14','13:55:00',1.99),('8902','2014-04-14','14:00:00',2.62),('8902','2014-04-14','14:05:00',7.2),('8902','2014-04-14','14:10:00',7.12),('8902','2014-04-14','14:15:00',7.71),('8902','2014-04-14','14:20:00',4.61),('8902','2014-04-14','14:25:00',8.08),('8902','2014-04-14','14:30:00',3.96),('8902','2014-04-14','14:35:00',4.92),('8902','2014-04-14','14:40:00',2.84),('8902','2014-04-14','14:45:00',2.12),('8902','2014-04-14','14:50:00',1.75),('8902','2014-04-14','14:55:00',1.58),('8902','2014-04-14','15:00:00',1.46),('8902','2014-04-14','15:05:00',1.32),('8902','2014-04-14','15:10:00',1.76),('8902','2014-04-14','15:15:00',2.51),('8902','2014-04-14','15:20:00',3.47),('8902','2014-04-14','15:25:00',3.59),('8902','2014-04-14','15:30:00',2.73),('8902','2014-04-14','15:35:00',2.6),('8902','2014-04-14','15:40:00',2.69),('8902','2014-04-14','15:45:00',2.57),('8902','2014-04-14','15:50:00',2.49),('8902','2014-04-14','15:55:00',2.67),('8902','2014-04-14','16:00:00',2.83),('8902','2014-04-14','16:05:00',2.7),('8902','2014-04-14','16:10:00',1.72),('8902','2014-04-14','16:15:00',1.28),('8902','2013-10-07','08:15:00',1.42),('8902','2013-10-07','08:20:00',1.6),('8902','2013-10-07','08:25:00',1.23),('8902','2013-10-07','08:30:00',1.27),('8902','2013-10-07','09:50:00',1.08),('8902','2013-10-07','09:55:00',1.36),('8902','2013-10-07','10:00:00',1.89),('8902','2013-10-07','10:05:00',1.84),('8902','2013-10-07','10:10:00',1.78),('8902','2013-10-07','10:15:00',1.41),('8902','2013-10-07','10:20:00',1.03),('8902','2013-10-07','10:55:00',1.38),('8902','2013-10-07','11:00:00',2.98),('8902','2013-10-07','11:05:00',3.05),('8902','2013-10-07','11:10:00',5.56),('8902','2013-10-07','11:15:00',8.23),('8902','2013-10-07','11:20:00',6.86),('8902','2013-10-07','11:25:00',4.06),('8902','2013-10-07','11:30:00',6),('8902','2013-10-07','11:35:00',5.05),('8902','2013-10-07','11:40:00',3.3),('8902','2013-10-07','11:45:00',2.84),('8902','2013-10-07','11:50:00',2.2),('8902','2013-10-07','11:55:00',1.86),('8902','2013-10-07','12:00:00',1.28),('8902','2013-10-07','12:05:00',1.45),('8902','2013-10-07','12:10:00',2.03),('8902','2013-10-07','12:15:00',2.11),('8902','2013-10-07','12:20:00',2.21),('8902','2013-10-07','12:25:00',2.71),('8902','2013-10-07','12:30:00',6.23),('8902','2013-10-07','12:35:00',3.66),('8902','2013-10-07','12:40:00',8.08),('8902','2013-10-07','12:45:00',6.56),('8902','2013-10-07','12:50:00',8.19),('8902','2013-10-07','12:55:00',7.87),('8902','2013-10-07','13:00:00',6.71),('8902','2013-10-07','13:05:00',7.78),('8902','2013-10-07','13:10:00',4.95),('8902','2013-10-07','13:15:00',6.63),('8902','2013-10-07','13:20:00',3.63),('8902','2013-10-07','13:25:00',8.23),('8902','2013-10-07','13:30:00',4.54),('8902','2013-10-07','13:35:00',2.27),('8902','2013-10-07','13:40:00',2.36),('8902','2013-10-07','13:45:00',1.63),('8902','2013-10-07','13:50:00',1.46),('8902','2013-10-07','13:55:00',1.92),('8902','2013-10-07','14:00:00',1.67),('8902','2013-10-07','14:05:00',2.89),('8902','2013-10-07','14:10:00',4.71),('8902','2013-10-07','14:15:00',5.03),('8902','2013-10-07','14:20:00',5.71),('8902','2013-10-07','14:25:00',5.72),('8902','2013-10-07','14:30:00',5.79),('8902','2013-10-07','14:35:00',2.22),('8902','2013-10-07','14:40:00',2.58),('8902','2013-10-07','14:45:00',6.45),('8902','2013-10-07','14:50:00',6.96),('8902','2013-10-07','14:55:00',6.57),('8902','2013-10-07','15:00:00',6.48),('8902','2013-10-07','15:05:00',6.69),('8902','2013-10-07','15:10:00',6.47),('8902','2013-10-07','15:15:00',6.28),('8902','2013-10-07','15:20:00',5.63),('8902','2013-10-07','15:25:00',4.19),('8902','2013-10-07','15:30:00',7.2),('8902','2013-10-07','15:35:00',6.45),('8902','2013-10-07','15:40:00',5.23),('8902','2013-10-07','15:45:00',3.72),('8902','2013-10-07','15:50:00',5.6),('8902','2013-10-07','15:55:00',2.82),('8902','2013-10-07','16:00:00',2.7),('8902','2013-10-07','16:05:00',3.87),('8902','2013-10-07','16:10:00',2.1),('8902','2013-10-07','16:15:00',1.53),('8902','2013-10-07','16:30:00',1.37),('8902','2013-10-07','16:35:00',1.26),('8902','2013-10-07','16:40:00',1.21),('8902','2013-10-07','16:45:00',1.52),('8902','2013-10-07','16:50:00',1.24),('8902','2013-10-06','08:25:00',1.34),('8902','2013-10-06','08:30:00',1.51),('8902','2013-10-06','08:35:00',1.97),('8902','2013-10-06','08:40:00',2.51),('8902','2013-10-06','08:45:00',1.33),('8902','2013-10-06','08:50:00',1.15),('8902','2013-10-06','08:55:00',2.07),('8902','2013-10-06','09:00:00',2.26),('8902','2013-10-06','09:05:00',2.85),('8902','2013-10-06','09:10:00',2.95),('8902','2013-10-06','09:15:00',3.12),('8902','2013-10-06','09:20:00',3.28),('8902','2013-10-06','09:25:00',3.44),('8902','2013-10-06','09:30:00',3.62),('8902','2013-10-06','09:35:00',3.8),('8902','2013-10-06','09:40:00',3.94),('8902','2013-10-06','09:45:00',4.12),('8902','2013-10-06','09:50:00',4.27),('8902','2013-10-06','09:55:00',4.39),('8902','2013-10-06','10:00:00',4.55),('8902','2013-10-06','10:05:00',4.7),('8902','2013-10-06','10:10:00',4.81),('8902','2013-10-06','10:15:00',4.95),('8902','2013-10-06','10:20:00',5.07),('8902','2013-10-06','10:25:00',5.26),('8902','2013-10-06','10:30:00',5.4),('8902','2013-10-06','10:35:00',5.59),('8902','2013-10-06','10:40:00',5.61),('8902','2013-10-06','10:45:00',5.61),('8902','2013-10-06','10:50:00',5.59),('8902','2013-10-06','10:55:00',5.72),('8902','2013-10-06','11:00:00',4.57),('8902','2013-10-06','11:05:00',6.06),('8902','2013-10-06','11:10:00',5.01),('8902','2013-10-06','11:15:00',5.87),('8902','2013-10-06','11:20:00',6.29),('8902','2013-10-06','11:25:00',6.37),('8902','2013-10-06','11:30:00',6.4),('8902','2013-10-06','11:35:00',6.46),('8902','2013-10-06','11:40:00',6.53),('8902','2013-10-06','11:45:00',6.58),('8902','2013-10-06','11:50:00',6.65),('8902','2013-10-06','11:55:00',6.79),('8902','2013-10-06','12:00:00',6.75),('8902','2013-10-06','12:05:00',7.04),('8902','2013-10-06','12:10:00',7.25),('8902','2013-10-06','12:15:00',7.73),('8902','2013-10-06','12:20:00',4.21),('8902','2013-10-06','12:25:00',7.94),('8902','2013-10-06','12:30:00',7.56),('8902','2013-10-06','12:35:00',6.82),('8902','2013-10-06','12:40:00',7.54),('8902','2013-10-06','12:45:00',7.53),('8902','2013-10-06','12:50:00',7.45),('8902','2013-10-06','12:55:00',7.59),('8902','2013-10-06','13:00:00',7.64),('8902','2013-10-06','13:05:00',7.48),('8902','2013-10-06','13:10:00',7.53),('8902','2013-10-06','13:15:00',7.47),('8902','2013-10-06','13:20:00',7.22),('8902','2013-10-06','13:25:00',4.71),('8902','2013-10-06','13:30:00',5.79),('8902','2013-10-06','13:35:00',7.17),('8902','2013-10-06','13:40:00',2.66),('8902','2013-10-06','13:45:00',2.78),('8902','2013-10-06','13:50:00',4.34),('8902','2013-10-06','13:55:00',8.83),('8902','2013-10-06','14:00:00',8.42),('8902','2013-10-06','14:05:00',2.33),('8902','2013-10-06','14:10:00',3.83),('8902','2013-10-06','14:15:00',2.06),('8902','2013-10-06','14:20:00',3.37),('8902','2013-10-06','14:25:00',7.39),('8902','2013-10-06','14:30:00',4.36),('8902','2013-10-06','14:35:00',3.54),('8902','2013-10-06','14:40:00',5.03),('8902','2013-10-06','14:45:00',7.54),('8902','2013-10-06','14:50:00',7.5),('8902','2013-10-06','14:55:00',7.33),('8902','2013-10-06','15:00:00',4.18),('8902','2013-10-06','15:05:00',2.54),('8902','2013-10-06','15:10:00',6.39),('8902','2013-10-06','15:15:00',1.69),('8902','2013-10-06','15:20:00',3.54),('8902','2013-10-06','15:25:00',2.26),('8902','2013-10-06','15:30:00',6.2),('8902','2013-10-06','15:35:00',6.84),('8902','2013-10-06','15:40:00',3.4),('8902','2013-10-06','15:45:00',3.59),('8902','2013-10-06','15:50:00',4.39),('8902','2013-10-06','15:55:00',5.03),('8902','2013-10-06','16:00:00',1.48),('8902','2013-10-06','16:05:00',1.12),('8902','2013-10-06','16:10:00',3.71),('8902','2013-10-06','16:15:00',4.97),('8902','2013-10-06','16:20:00',4.81),('8902','2013-10-06','16:25:00',4.63),('8902','2013-10-06','16:30:00',4.35),('8902','2013-10-06','16:35:00',4.22),('8902','2013-10-06','16:40:00',4.04),('8902','2013-10-06','16:45:00',3.91),('8902','2013-10-06','16:50:00',3.67),('8902','2013-10-06','16:55:00',3.37),('8902','2013-10-06','17:00:00',3.11),('8902','2013-10-06','17:05:00',2.81),('8902','2013-10-06','17:10:00',2.46),('8902','2013-10-06','17:15:00',2.39),('8902','2013-10-06','17:20:00',2.2),('8902','2013-10-06','17:25:00',2.05),('8902','2013-10-06','17:30:00',1.83),('8902','2013-10-06','17:35:00',1.65),('8902','2013-10-06','17:40:00',1.42),('8902','2013-10-06','17:45:00',1.27),('8902','2013-10-06','17:50:00',1.07),('8902','2013-10-05','09:00:00',1.11),('8902','2013-10-05','09:05:00',1.72),('8902','2013-10-05','09:10:00',1.56),('8902','2013-10-05','09:15:00',1.02),('8902','2013-10-05','09:25:00',1.17),('8902','2013-10-05','09:30:00',1.93),('8902','2013-10-05','09:35:00',2.66),('8902','2013-10-05','09:40:00',2.54),('8902','2013-10-05','09:45:00',2.04),('8902','2013-10-05','09:50:00',3.85),('8902','2013-10-05','09:55:00',4.61),('8902','2013-10-05','10:00:00',5.44),('8902','2013-10-05','10:05:00',5.6),('8902','2013-10-05','10:10:00',5.52),('8902','2013-10-05','10:15:00',5.09),('8902','2013-10-05','10:20:00',5.07),('8902','2013-10-05','10:25:00',5.71),('8902','2013-10-05','10:30:00',5.62),('8902','2013-10-05','10:35:00',5.64),('8902','2013-10-05','10:40:00',4.86),('8902','2013-10-05','10:45:00',4.03),('8902','2013-10-05','10:50:00',4.31),('8902','2013-10-05','10:55:00',4.9),('8902','2013-10-05','11:00:00',5.01),('8902','2013-10-05','11:05:00',5.35),('8902','2013-10-05','11:10:00',5.5),('8902','2013-10-05','11:15:00',5.07),('8902','2013-10-05','11:20:00',5.3),('8902','2013-10-05','11:25:00',5.8),('8902','2013-10-05','11:30:00',5.68),('8902','2013-10-05','11:35:00',5.58),('8902','2013-10-05','11:40:00',5.56),('8902','2013-10-05','11:45:00',4.15),('8902','2013-10-05','11:50:00',4.37),('8902','2013-10-05','11:55:00',5),('8902','2013-10-05','12:00:00',5.15),('8902','2013-10-05','12:05:00',5.2),('8902','2013-10-05','12:10:00',6.62),('8902','2013-10-05','12:15:00',6.38),('8902','2013-10-05','12:20:00',5.12),('8902','2013-10-05','12:25:00',5.26),('8902','2013-10-05','12:30:00',5.29),('8902','2013-10-05','12:35:00',5.44),('8902','2013-10-05','12:40:00',4.88),('8902','2013-10-05','12:45:00',4.99),('8902','2013-10-05','12:50:00',5.66),('8902','2013-10-05','12:55:00',6.5),('8902','2013-10-05','13:00:00',6.64),('8902','2013-10-05','13:05:00',6.48),('8902','2013-10-05','13:10:00',5.24),('8902','2013-10-05','13:15:00',4.37),('8902','2013-10-05','13:20:00',6.73),('8902','2013-10-05','13:25:00',2.3),('8902','2013-10-05','13:30:00',1.61),('8902','2013-10-05','13:35:00',1.1),('8902','2013-10-05','13:40:00',1.31),('8902','2013-10-05','13:45:00',3.27),('8902','2013-10-05','13:50:00',7.46),('8902','2013-10-05','13:55:00',4.5),('8902','2013-10-05','14:00:00',3.49),('8902','2013-10-05','14:05:00',3.71),('8902','2013-10-05','14:10:00',4.31),('8902','2013-10-05','14:15:00',4.11),('8902','2013-10-05','14:20:00',3.36),('8902','2013-10-05','14:25:00',3.21),('8902','2013-10-05','14:30:00',3.45),('8902','2013-10-05','14:35:00',3.81),('8902','2013-10-05','14:40:00',3.69),('8902','2013-10-05','14:45:00',3.53),('8902','2013-10-05','14:50:00',3.94),('8902','2013-10-05','14:55:00',4.85),('8902','2013-10-05','15:00:00',3.79),('8902','2013-10-05','15:05:00',2.84),('8902','2013-10-05','15:10:00',2.41),('8902','2013-10-05','15:15:00',2.13),('8902','2013-10-05','15:20:00',1.89),('8902','2013-10-05','15:25:00',1.48),('8902','2013-10-05','15:30:00',1.39),('8902','2013-10-05','15:35:00',1.39),('8902','2013-10-05','15:40:00',1.52),('8902','2013-10-05','15:45:00',1.7),('8902','2013-10-05','15:50:00',1.67),('8902','2013-10-05','15:55:00',2.28),('8902','2013-10-05','16:00:00',2.21),('8902','2013-10-05','16:05:00',1.57),('8902','2013-10-05','16:10:00',1.17),('8902','2013-10-05','16:20:00',1.11),('8902','2013-10-05','17:00:00',1.1),('8902','2013-10-05','17:05:00',1.26),('8902','2013-10-05','17:10:00',1.79),('8902','2013-10-05','17:15:00',2.06),('8902','2013-10-05','17:20:00',1.82),('8902','2013-10-05','17:25:00',1.21),('8902','2013-10-05','17:30:00',1.06),('8902','2013-10-05','17:35:00',1.06),('8902','2013-10-04','08:40:00',1.09),('8902','2013-10-04','14:45:00',1.04),('8902','2013-10-04','14:50:00',1.18),('8902','2013-10-04','14:55:00',1.22),('8902','2013-10-04','15:00:00',1.11),('8902','2013-10-04','15:05:00',1.15),('8902','2013-10-04','15:10:00',1.11),('8902','2013-10-04','15:15:00',1.07),('8902','2013-10-04','15:20:00',1.1),('8902','2013-10-04','15:25:00',1.14),('8902','2013-10-04','15:30:00',1.14),('8902','2013-10-04','15:35:00',1.22),('8902','2013-10-04','15:40:00',1.41),('8902','2013-10-04','15:45:00',1.47),('8902','2013-10-04','15:50:00',1.53),('8902','2013-10-04','15:55:00',1.68),('8902','2013-10-04','16:00:00',1.9),('8902','2013-10-04','16:05:00',2.38),('8902','2013-10-04','16:10:00',2.37),('8902','2013-10-04','16:15:00',2.08),('8902','2013-10-04','16:20:00',2.19),('8902','2013-10-04','16:25:00',2.25),('8902','2013-10-04','16:30:00',1.87),('8902','2013-10-04','16:35:00',1.73),('8902','2013-10-04','16:40:00',1.86),('8902','2013-10-04','16:45:00',1.85),('8902','2013-10-04','16:50:00',1.8),('8902','2013-10-04','16:55:00',1.68),('8902','2013-10-04','17:00:00',1.55),('8902','2013-10-04','17:05:00',1.55),('8902','2013-10-04','17:10:00',1.39),('8902','2013-10-04','17:15:00',1.45),('8902','2013-10-04','17:20:00',1.24),('8902','2013-10-03','08:30:00',1.14),('8902','2013-10-03','08:35:00',1.05),('8902','2013-10-03','08:40:00',1.04),('8902','2013-10-03','08:45:00',1.44),('8902','2013-10-03','08:50:00',1.32),('8902','2013-10-03','08:55:00',1.4),('8902','2013-10-03','09:00:00',1.31),('8902','2013-10-03','09:05:00',1.2),('8902','2013-10-03','09:10:00',1.3),('8902','2013-10-03','09:15:00',1.23),('8902','2013-10-03','09:20:00',1.37),('8902','2013-10-03','09:25:00',1.87),('8902','2013-10-03','09:30:00',2.1),('8902','2013-10-03','09:35:00',2.07),('8902','2013-10-03','09:40:00',2.13),('8902','2013-10-03','09:45:00',2.12),('8902','2013-10-03','09:50:00',2.54),('8902','2013-10-03','09:55:00',5.08),('8902','2013-10-03','10:00:00',3.94),('8902','2013-10-03','10:05:00',2.94),('8902','2013-10-03','10:10:00',2.86),('8902','2013-10-03','10:15:00',3.48),('8902','2013-10-03','10:20:00',2.91),('8902','2013-10-03','10:25:00',3.94),('8902','2013-10-03','10:30:00',3.88),('8902','2013-10-03','10:35:00',3.53),('8902','2013-10-03','10:40:00',5.14),('8902','2013-10-03','10:45:00',4.02),('8902','2013-10-03','10:50:00',3.32),('8902','2013-10-03','10:55:00',5.46),('8902','2013-10-03','11:00:00',4.61),('8902','2013-10-03','11:05:00',3.4),('8902','2013-10-03','11:10:00',3.29),('8902','2013-10-03','11:15:00',6.27),('8902','2013-10-03','11:20:00',5.69),('8902','2013-10-03','11:25:00',5.95),('8902','2013-10-03','11:30:00',7.42),('8902','2013-10-03','11:35:00',7.07),('8902','2013-10-03','11:40:00',7.14),('8902','2013-10-03','11:45:00',7.03),('8902','2013-10-03','11:50:00',6.97),('8902','2013-10-03','11:55:00',6.95),('8902','2013-10-03','12:00:00',7.01),('8902','2013-10-03','12:05:00',7.08),('8902','2013-10-03','12:10:00',7.15),('8902','2013-10-03','12:15:00',6.92),('8902','2013-10-03','12:20:00',6.67),('8902','2013-10-03','12:25:00',7.28),('8902','2013-10-03','12:30:00',7.26),('8902','2013-10-03','12:35:00',6.37),('8902','2013-10-03','12:40:00',7.2),('8902','2013-10-03','12:45:00',7.2),('8902','2013-10-03','12:50:00',6.91),('8902','2013-10-03','12:55:00',6.99),('8902','2013-10-03','13:00:00',7.08),('8902','2013-10-03','13:05:00',7.19),('8902','2013-10-03','13:10:00',7.19),('8902','2013-10-03','13:15:00',7.64),('8902','2013-10-03','13:20:00',7.44),('8902','2013-10-03','13:25:00',6.96),('8902','2013-10-03','13:30:00',7.39),('8902','2013-10-03','13:35:00',6.15),('8902','2013-10-03','13:40:00',7.15),('8902','2013-10-03','13:45:00',6.96),('8902','2013-10-03','13:50:00',6.9),('8902','2013-10-03','13:55:00',6.94),('8902','2013-10-03','14:00:00',6.92),('8902','2013-10-03','14:05:00',6.88),('8902','2013-10-03','14:10:00',6.34),('8902','2013-10-03','14:15:00',5.76),('8902','2013-10-03','14:20:00',6.09),('8902','2013-10-03','14:25:00',6.65),('8902','2013-10-03','14:30:00',5.91),('8902','2013-10-03','14:35:00',4.26),('8902','2013-10-03','14:40:00',3.37),('8902','2013-10-03','14:45:00',3.75),('8902','2013-10-03','14:50:00',5.04),('8902','2013-10-03','14:55:00',5.27),('8902','2013-10-03','15:00:00',4.51),('8902','2013-10-03','15:05:00',5.14),('8902','2013-10-03','15:10:00',4.47),('8902','2013-10-03','15:15:00',3.51),('8902','2013-10-03','15:20:00',3.02),('8902','2013-10-03','15:25:00',4.32),('8902','2013-10-03','15:30:00',5.71),('8902','2013-10-03','15:35:00',3.52),('8902','2013-10-03','15:40:00',1.75),('8902','2013-10-03','15:45:00',1.44),('8902','2013-10-03','15:50:00',1.36),('8902','2013-10-03','15:55:00',1.51),('8902','2013-10-03','16:00:00',1.85),('8902','2013-10-03','16:05:00',2.09),('8902','2013-10-03','16:10:00',2),('8902','2013-10-03','16:15:00',1.8),('8902','2013-10-03','16:20:00',1.53),('8902','2013-10-03','16:25:00',1.27),('8902','2013-10-03','16:30:00',1.17),('8902','2013-10-03','16:35:00',1.16),('8902','2013-10-03','16:40:00',1.11),('8902','2013-10-03','16:45:00',1.06),('8902','2013-10-03','16:50:00',1.05),('8902','2013-10-03','16:55:00',1.03),('8902','2013-10-02','08:15:00',1.11),('8902','2013-10-02','08:20:00',1.28),('8902','2013-10-02','08:25:00',1.45),('8902','2013-10-02','08:30:00',1.64),('8902','2013-10-02','08:35:00',1.82),('8902','2013-10-02','08:40:00',1.99),('8902','2013-10-02','08:45:00',2.2),('8902','2013-10-02','08:50:00',2.42),('8902','2013-10-02','08:55:00',2.61),('8902','2013-10-02','09:00:00',2.79),('8902','2013-10-02','09:05:00',2.97),('8902','2013-10-02','09:10:00',3.17),('8902','2013-10-02','09:15:00',3.38),('8902','2013-10-02','09:20:00',3.56),('8902','2013-10-02','09:25:00',3.76),('8902','2013-10-02','09:30:00',3.94),('8902','2013-10-02','09:35:00',4.13),('8902','2013-10-02','09:40:00',4.32),('8902','2013-10-02','09:45:00',4.51),('8902','2013-10-02','09:50:00',4.67),('8902','2013-10-02','09:55:00',4.83),('8902','2013-10-02','10:00:00',4.99),('8902','2013-10-02','10:05:00',5.15),('8902','2013-10-02','10:10:00',5.28),('8902','2013-10-02','10:15:00',5.44),('8902','2013-10-02','10:20:00',5.57),('8902','2013-10-02','10:25:00',5.7),('8902','2013-10-02','10:30:00',5.81),('8902','2013-10-02','10:35:00',5.93),('8902','2013-10-02','10:40:00',6.08),('8902','2013-10-02','10:45:00',6.2),('8902','2013-10-02','10:50:00',6.3),('8902','2013-10-02','10:55:00',6.4),('8902','2013-10-02','11:00:00',6.48),('8902','2013-10-02','11:05:00',6.55),('8902','2013-10-02','11:10:00',6.66),('8902','2013-10-02','11:15:00',6.76),('8902','2013-10-02','11:20:00',6.85),('8902','2013-10-02','11:25:00',6.92),('8902','2013-10-02','11:30:00',6.97),('8902','2013-10-02','11:35:00',7.09),('8902','2013-10-02','11:40:00',7.15),('8902','2013-10-02','11:45:00',7.2),('8902','2013-10-02','11:50:00',7.3),('8902','2013-10-02','11:55:00',7.36),('8902','2013-10-02','12:00:00',7.37),('8902','2013-10-02','12:05:00',7.42),('8902','2013-10-02','12:10:00',7.46),('8902','2013-10-02','12:15:00',7.43),('8902','2013-10-02','12:20:00',7.48),('8902','2013-10-02','12:25:00',7.52),('8902','2013-10-02','12:30:00',7.55),('8902','2013-10-02','12:35:00',7.57),('8902','2013-10-02','12:40:00',7.55),('8902','2013-10-02','12:45:00',7.58),('8902','2013-10-02','12:50:00',7.59),('8902','2013-10-02','12:55:00',7.59),('8902','2013-10-02','13:00:00',7.53),('8902','2013-10-02','13:05:00',7.42),('8902','2013-10-02','13:10:00',7.59),('8902','2013-10-02','13:15:00',7.58),('8902','2013-10-02','13:20:00',7.56),('8902','2013-10-02','13:25:00',7.53),('8902','2013-10-02','13:30:00',7.58),('8902','2013-10-02','13:35:00',7.58),('8902','2013-10-02','13:40:00',7.54),('8902','2013-10-02','13:45:00',7.45),('8902','2013-10-02','13:50:00',7.45),('8902','2013-10-02','13:55:00',7.48),('8902','2013-10-02','14:00:00',7.46),('8902','2013-10-02','14:05:00',7.43),('8902','2013-10-02','14:10:00',7.36),('8902','2013-10-02','14:15:00',7.29),('8902','2013-10-02','14:20:00',7.25),('8902','2013-10-02','14:25:00',7.19),('8902','2013-10-02','14:30:00',7.15),('8902','2013-10-02','14:35:00',7.1),('8902','2013-10-02','14:40:00',7.02),('8902','2013-10-02','14:45:00',6.94),('8902','2013-10-02','14:50:00',6.87),('8902','2013-10-02','14:55:00',6.79),('8902','2013-10-02','15:00:00',6.71),('8902','2013-10-02','15:05:00',6.59),('8902','2013-10-02','15:10:00',6.47),('8902','2013-10-02','15:15:00',6.39),('8902','2013-10-02','15:20:00',6.3),('8902','2013-10-02','15:25:00',6.18),('8902','2013-10-02','15:30:00',6.1),('8902','2013-10-02','15:35:00',5.97),('8902','2013-10-02','15:40:00',5.83),('8902','2013-10-02','15:45:00',5.71),('8902','2013-10-02','15:50:00',5.58),('8902','2013-10-02','15:55:00',5.46),('8902','2013-10-02','16:00:00',5.31),('8902','2013-10-02','16:05:00',5.11),('8902','2013-10-02','16:10:00',4.99),('8902','2013-10-02','16:15:00',4.83),('8902','2013-10-02','16:20:00',4.69),('8902','2013-10-02','16:25:00',4.51),('8902','2013-10-02','16:30:00',4.31),('8902','2013-10-02','16:35:00',4.17),('8902','2013-10-02','16:40:00',3.97),('8902','2013-10-02','16:45:00',3.8),('8902','2013-10-02','16:50:00',3.62),('8902','2013-10-02','16:55:00',3.44),('8902','2013-10-02','17:00:00',3.27),('8902','2013-10-02','17:05:00',3.09),('8902','2013-10-02','17:10:00',2.75),('8902','2013-10-02','17:15:00',2.61),('8902','2013-10-02','17:20:00',2.45),('8902','2013-10-02','17:25:00',2.27),('8902','2013-10-02','17:30:00',2.05),('8902','2013-10-02','17:35:00',1.82),('8902','2013-10-02','17:40:00',1.63),('8902','2013-10-02','17:45:00',1.44),('8902','2013-10-02','17:50:00',1.27),('8902','2013-10-02','17:55:00',1.09),('8902','2013-10-01','08:15:00',1.29),('8902','2013-10-01','08:20:00',1.58),('8902','2013-10-01','08:25:00',1.6),('8902','2013-10-01','08:30:00',1.42),('8902','2013-10-01','08:35:00',1.7),('8902','2013-10-01','08:40:00',1.87),('8902','2013-10-01','08:45:00',2.08),('8902','2013-10-01','08:50:00',2.28),('8902','2013-10-01','08:55:00',2.45),('8902','2013-10-01','09:00:00',2.63),('8902','2013-10-01','09:05:00',2.81),('8902','2013-10-01','09:10:00',3),('8902','2013-10-01','09:15:00',3.19),('8902','2013-10-01','09:20:00',3.37),('8902','2013-10-01','09:25:00',3.56),('8902','2013-10-01','09:30:00',3.73),('8902','2013-10-01','09:35:00',3.92),('8902','2013-10-01','09:40:00',4.09),('8902','2013-10-01','09:45:00',4.25),('8902','2013-10-01','09:50:00',4.41),('8902','2013-10-01','09:55:00',4.54),('8902','2013-10-01','10:00:00',4.67),('8902','2013-10-01','10:05:00',4.78),('8902','2013-10-01','10:10:00',4.92),('8902','2013-10-01','10:15:00',5.05),('8902','2013-10-01','10:20:00',5.2),('8902','2013-10-01','10:25:00',5.34),('8902','2013-10-01','10:30:00',5.47),('8902','2013-10-01','10:35:00',5.6),('8902','2013-10-01','10:40:00',5.75),('8902','2013-10-01','10:45:00',5.89),('8902','2013-10-01','10:50:00',6.01),('8902','2013-10-01','10:55:00',6.1),('8902','2013-10-01','11:00:00',6.21),('8902','2013-10-01','11:05:00',6.32),('8902','2013-10-01','11:10:00',6.39),('8902','2013-10-01','11:15:00',6.48),('8902','2013-10-01','11:20:00',6.55),('8902','2013-10-01','11:25:00',6.61),('8902','2013-10-01','11:30:00',6.7),('8902','2013-10-01','11:35:00',6.77),('8902','2013-10-01','11:40:00',6.83),('8902','2013-10-01','11:45:00',6.89),('8902','2013-10-01','11:50:00',6.95),('8902','2013-10-01','11:55:00',6.99),('8902','2013-10-01','12:00:00',7.02),('8902','2013-10-01','12:05:00',7.06),('8902','2013-10-01','12:10:00',7.12),('8902','2013-10-01','12:15:00',7.18),('8902','2013-10-01','12:20:00',7.19),('8902','2013-10-01','12:25:00',7.22),('8902','2013-10-01','12:30:00',7.24),('8902','2013-10-01','12:35:00',7.26),('8902','2013-10-01','12:40:00',7.3),('8902','2013-10-01','12:45:00',7.34),('8902','2013-10-01','12:50:00',7.39),('8902','2013-10-01','12:55:00',7.4),('8902','2013-10-01','13:00:00',7.41),('8902','2013-10-01','13:05:00',7.4),('8902','2013-10-01','13:10:00',7.39),('8902','2013-10-01','13:15:00',7.4),('8902','2013-10-01','13:20:00',7.43),('8902','2013-10-01','13:25:00',7.43),('8902','2013-10-01','13:30:00',7.41),('8902','2013-10-01','13:35:00',7.37),('8902','2013-10-01','13:40:00',7.3),('8902','2013-10-01','13:45:00',7.26),('8902','2013-10-01','13:50:00',7.25),('8902','2013-10-01','13:55:00',7.24),('8902','2013-10-01','14:00:00',7.22),('8902','2013-10-01','14:05:00',7.21),('8902','2013-10-01','14:10:00',7.13),('8902','2013-10-01','14:15:00',7.09),('8902','2013-10-01','14:20:00',7.04),('8902','2013-10-01','14:25:00',6.99),('8902','2013-10-01','14:30:00',6.95),('8902','2013-10-01','14:35:00',6.89),('8902','2013-10-01','14:40:00',6.79),('8902','2013-10-01','14:45:00',6.72),('8902','2013-10-01','14:50:00',6.68),('8902','2013-10-01','14:55:00',6.6),('8902','2013-10-01','15:00:00',6.53),('8902','2013-10-01','15:05:00',6.42),('8902','2013-10-01','15:10:00',6.32),('8902','2013-10-01','15:15:00',6.22),('8902','2013-10-01','15:20:00',6.12),('8902','2013-10-01','15:25:00',5.98),('8902','2013-10-01','15:30:00',5.87),('8902','2013-10-01','15:35:00',5.78),('8902','2013-10-01','15:40:00',5.68),('8902','2013-10-01','15:45:00',5.58),('8902','2013-10-01','15:50:00',5.44),('8902','2013-10-01','15:55:00',5.29),('8902','2013-10-01','16:00:00',5.19),('8902','2013-10-01','16:05:00',4.96),('8902','2013-10-01','16:10:00',4.82),('8902','2013-10-01','16:15:00',4.69),('8902','2013-10-01','16:20:00',4.53),('8902','2013-10-01','16:25:00',4.41),('8902','2013-10-01','16:30:00',4.22),('8902','2013-10-01','16:35:00',4.08),('8902','2013-10-01','16:40:00',3.87),('8902','2013-10-01','16:45:00',3.68),('8902','2013-10-01','16:50:00',3.51),('8902','2013-10-01','16:55:00',3.35),('8902','2013-10-01','17:00:00',3.18),('8902','2013-10-01','17:05:00',3),('8902','2013-10-01','17:10:00',2.73),('8902','2013-10-01','17:15:00',2.55),('8902','2013-10-01','17:20:00',2.38),('8902','2013-10-01','17:25:00',2.18),('8902','2013-10-01','17:30:00',1.92),('8902','2013-10-01','17:35:00',1.7),('8902','2013-10-01','17:40:00',1.44),('8902','2013-10-01','17:45:00',1.23),('8902','2013-10-01','17:50:00',1.2),('8902','2013-10-01','17:55:00',1.03),('8902','2013-09-30','08:25:00',1.14),('8902','2013-09-30','08:40:00',1.9),('8902','2013-09-30','08:45:00',2.16),('8902','2013-09-30','08:50:00',2.34),('8902','2013-09-30','08:55:00',2.53),('8902','2013-09-30','09:00:00',2.7),('8902','2013-09-30','09:05:00',2.89),('8902','2013-09-30','09:10:00',3.05),('8902','2013-09-30','09:15:00',3.23),('8902','2013-09-30','09:20:00',3.38),('8902','2013-09-30','09:25:00',3.56),('8902','2013-09-30','09:30:00',3.71),('8902','2013-09-30','09:35:00',3.85),('8902','2013-09-30','09:40:00',4.02),('8902','2013-09-30','09:45:00',4.2),('8902','2013-09-30','09:50:00',4.34),('8902','2013-09-30','09:55:00',4.47),('8902','2013-09-30','10:00:00',4.59),('8902','2013-09-30','10:05:00',4.74),('8902','2013-09-30','10:10:00',4.88),('8902','2013-09-30','10:15:00',5.03),('8902','2013-09-30','10:20:00',5.14),('8902','2013-09-30','10:25:00',5.26),('8902','2013-09-30','10:30:00',5.47),('8902','2013-09-30','10:35:00',5.54),('8902','2013-09-30','10:40:00',5.65),('8902','2013-09-30','10:45:00',5.76),('8902','2013-09-30','10:50:00',5.87),('8902','2013-09-30','10:55:00',5.98),('8902','2013-09-30','11:00:00',6.03),('8902','2013-09-30','11:05:00',6.32),('8902','2013-09-30','11:10:00',6.81),('8902','2013-09-30','11:15:00',5.51),('8902','2013-09-30','11:20:00',3.04),('8902','2013-09-30','11:25:00',1.85),('8902','2013-09-30','11:30:00',7.15),('8902','2013-09-30','11:35:00',5.16),('8902','2013-09-30','11:40:00',5.73),('8902','2013-09-30','11:45:00',7.24),('8902','2013-09-30','11:50:00',7.24),('8902','2013-09-30','11:55:00',7.29),('8902','2013-09-30','12:00:00',7.11),('8902','2013-09-30','12:05:00',7.06),('8902','2013-09-30','12:10:00',6.9),('8902','2013-09-30','12:15:00',7.08),('8902','2013-09-30','12:20:00',7.33),('8902','2013-09-30','12:25:00',7.56),('8902','2013-09-30','12:30:00',7.66),('8902','2013-09-30','12:35:00',7.72),('8902','2013-09-30','12:40:00',3.94),('8902','2013-09-30','12:45:00',5.97),('8902','2013-09-30','12:50:00',7.6),('8902','2013-09-30','12:55:00',7.52),('8902','2013-09-30','13:00:00',7.51),('8902','2013-09-30','13:05:00',7.51),('8902','2013-09-30','13:10:00',2.27),('8902','2013-09-30','13:15:00',1.29),('8902','2013-09-30','13:20:00',5.41),('8902','2013-09-30','13:25:00',8.13),('8902','2013-09-30','13:30:00',8.22),('8902','2013-09-30','13:35:00',7.61),('8902','2013-09-30','13:40:00',7.62),('8902','2013-09-30','13:45:00',4.86),('8902','2013-09-30','13:50:00',5.07),('8902','2013-09-30','13:55:00',5.96),('8902','2013-09-30','14:00:00',7.33),('8902','2013-09-30','14:05:00',7.12),('8902','2013-09-30','14:10:00',7.04),('8902','2013-09-30','14:15:00',6.94),('8902','2013-09-30','14:20:00',6.83),('8902','2013-09-30','14:25:00',6.77),('8902','2013-09-30','14:30:00',6.75),('8902','2013-09-30','14:35:00',6.64),('8902','2013-09-30','14:40:00',6.73),('8902','2013-09-30','14:45:00',6.31),('8902','2013-09-30','14:50:00',6.72),('8902','2013-09-30','14:55:00',6.63),('8902','2013-09-30','15:00:00',6.5),('8902','2013-09-30','15:05:00',6.32),('8902','2013-09-30','15:10:00',6.24),('8902','2013-09-30','15:15:00',6.11),('8902','2013-09-30','15:20:00',6.07),('8902','2013-09-30','15:25:00',5.99),('8902','2013-09-30','15:30:00',5.88),('8902','2013-09-30','15:35:00',5.76),('8902','2013-09-30','15:40:00',5.68),('8902','2013-09-30','15:45:00',5.53),('8902','2013-09-30','15:50:00',5.4),('8902','2013-09-30','15:55:00',5.29),('8902','2013-09-30','16:00:00',5.11),('8902','2013-09-30','16:05:00',4.97),('8902','2013-09-30','16:10:00',4.84),('8902','2013-09-30','16:15:00',4.7),('8902','2013-09-30','16:20:00',4.56),('8902','2013-09-30','16:25:00',4.39),('8902','2013-09-30','16:30:00',4.19),('8902','2013-09-30','16:35:00',4.04),('8902','2013-09-30','16:40:00',3.87),('8902','2013-09-30','16:45:00',3.64),('8902','2013-09-30','16:50:00',3.5),('8902','2013-09-30','16:55:00',3.37),('8902','2013-09-30','17:00:00',3.23),('8902','2013-09-30','17:05:00',3.04),('8902','2013-09-30','17:10:00',2.75),('8902','2013-09-30','17:15:00',2.43),('8902','2013-09-30','17:20:00',2.41),('8902','2013-09-30','17:25:00',2.27),('8902','2013-09-30','17:30:00',2.06),('8902','2013-09-30','17:35:00',1.85),('8902','2013-09-30','17:40:00',1.66),('8902','2013-09-30','17:45:00',1.43),('8902','2013-09-30','17:50:00',1.24),('8902','2013-09-30','17:55:00',1.1),('8902','2013-09-29','09:25:00',1.02),('8902','2013-09-29','09:35:00',1.22),('8902','2013-09-29','09:40:00',1.35),('8902','2013-09-29','09:45:00',1.75),('8902','2013-09-29','09:50:00',2.32),('8902','2013-09-29','09:55:00',2.01),('8902','2013-09-29','10:00:00',1.93),('8902','2013-09-29','10:05:00',1.86),('8902','2013-09-29','10:10:00',2.01),('8902','2013-09-29','10:15:00',2.05),('8902','2013-09-29','10:20:00',2.05),('8902','2013-09-29','10:25:00',2.39),('8902','2013-09-29','10:30:00',2.69),('8902','2013-09-29','10:35:00',3.12),('8902','2013-09-29','10:40:00',4.01),('8902','2013-09-29','10:45:00',6.09),('8902','2013-09-29','10:50:00',6.4),('8902','2013-09-29','10:55:00',5.87),('8902','2013-09-29','11:00:00',3.87),('8902','2013-09-29','11:05:00',5.76),('8902','2013-09-29','11:10:00',4.17),('8902','2013-09-29','11:15:00',5.93),('8902','2013-09-29','11:20:00',4.89),('8902','2013-09-29','11:25:00',5.34),('8902','2013-09-29','11:30:00',2.63),('8902','2013-09-29','11:35:00',3.53),('8902','2013-09-29','11:40:00',4.81),('8902','2013-09-29','11:45:00',4.15),('8902','2013-09-29','11:50:00',3.09),('8902','2013-09-29','11:55:00',3.59),('8902','2013-09-29','12:00:00',2.74),('8902','2013-09-29','12:05:00',3.53),('8902','2013-09-29','12:10:00',3.36),('8902','2013-09-29','12:15:00',7.39),('8902','2013-09-29','12:20:00',7.76),('8902','2013-09-29','12:25:00',7.73),('8902','2013-09-29','12:30:00',7.52),('8902','2013-09-29','12:35:00',7.54),('8902','2013-09-29','12:40:00',7.84),('8902','2013-09-29','12:45:00',5.97),('8902','2013-09-29','12:50:00',7.9),('8902','2013-09-29','12:55:00',7.68),('8902','2013-09-29','13:00:00',7.67),('8902','2013-09-29','13:05:00',7.83),('8902','2013-09-29','13:10:00',7.95),('8902','2013-09-29','13:15:00',7.81),('8902','2013-09-29','13:20:00',8.25),('8902','2013-09-29','13:25:00',8.51),('8902','2013-09-29','13:30:00',8.58),('8902','2013-09-29','13:35:00',7.17),('8902','2013-09-29','13:40:00',7.43),('8902','2013-09-29','13:45:00',7.34),('8902','2013-09-29','13:50:00',5.48),('8902','2013-09-29','13:55:00',4.13),('8902','2013-09-29','14:00:00',4.03),('8902','2013-09-29','14:05:00',2.76),('8902','2013-09-29','14:10:00',2.51),('8902','2013-09-29','14:15:00',2.4),('8902','2013-09-29','14:20:00',2.02),('8902','2013-09-29','14:25:00',2.25),('8902','2013-09-29','14:30:00',4.8),('8902','2013-09-29','14:35:00',5.52),('8902','2013-09-29','14:40:00',7.66),('8902','2013-09-29','14:45:00',7.3),('8902','2013-09-29','14:50:00',5.86),('8902','2013-09-29','14:55:00',5.77),('8902','2013-09-29','15:00:00',2.88),('8902','2013-09-29','15:05:00',3.61),('8902','2013-09-29','15:10:00',7.83),('8902','2013-09-29','15:15:00',5.78),('8902','2013-09-29','15:20:00',2.59),('8902','2013-09-29','15:25:00',4.95),('8902','2013-09-29','15:30:00',5.43),('8902','2013-09-29','15:35:00',5.02),('8902','2013-09-29','15:40:00',6.73),('8902','2013-09-29','15:45:00',5.1),('8902','2013-09-29','15:55:00',1.03),('8902','2013-09-29','16:00:00',1.03),('8902','2013-09-29','16:10:00',1.74),('8902','2013-09-29','16:15:00',3.25),('8902','2013-09-29','16:20:00',4.65),('8902','2013-09-29','16:25:00',2.05),('8902','2013-09-29','16:30:00',1.31),('8902','2013-09-29','16:35:00',1.12),('8902','2013-09-29','16:40:00',3.65),('8902','2013-09-29','16:45:00',3.84),('8902','2013-09-29','16:50:00',2.41),('8902','2013-09-29','16:55:00',1.14),('8902','2013-09-29','17:00:00',1.83),('8902','2013-09-29','17:05:00',1.55),('8902','2013-09-29','17:10:00',1.11),('8902','2013-09-29','17:15:00',1.7),('8902','2013-09-29','17:20:00',2.62),('8902','2013-09-29','17:25:00',1.62),('8902','2013-09-29','17:30:00',1.84),('8902','2013-09-28','08:40:00',1.3),('8902','2013-09-28','08:45:00',1.72),('8902','2013-09-28','08:50:00',2.15),('8902','2013-09-28','08:55:00',1.97),('8902','2013-09-28','09:00:00',1.79),('8902','2013-09-28','09:05:00',1.63),('8902','2013-09-28','09:10:00',1.76),('8902','2013-09-28','09:15:00',2.34),('8902','2013-09-28','09:20:00',1.65),('8902','2013-09-28','09:25:00',1.67),('8902','2013-09-28','09:30:00',1.63),('8902','2013-09-28','09:35:00',1.57),('8902','2013-09-28','09:40:00',1.53),('8902','2013-09-28','09:45:00',1.74),('8902','2013-09-28','09:50:00',1.9),('8902','2013-09-28','09:55:00',1.93),('8902','2013-09-28','10:00:00',2.23),('8902','2013-09-28','10:05:00',3.06),('8902','2013-09-28','10:10:00',3.63),('8902','2013-09-28','10:15:00',4.63),('8902','2013-09-28','10:20:00',4.22),('8902','2013-09-28','10:25:00',3.77),('8902','2013-09-28','10:30:00',4.21),('8902','2013-09-28','10:35:00',4.68),('8902','2013-09-28','10:40:00',4.95),('8902','2013-09-28','10:45:00',5.16),('8902','2013-09-28','10:50:00',5.4),('8902','2013-09-28','10:55:00',5.32),('8902','2013-09-28','11:00:00',5.41),('8902','2013-09-28','11:05:00',5.29),('8902','2013-09-28','11:10:00',5.27),('8902','2013-09-28','11:15:00',5.7),('8902','2013-09-28','11:20:00',5.72),('8902','2013-09-28','11:25:00',5.29),('8902','2013-09-28','11:30:00',5.77),('8902','2013-09-28','11:35:00',5.72),('8902','2013-09-28','11:40:00',5.9),('8902','2013-09-28','11:45:00',6.06),('8902','2013-09-28','11:50:00',6.39),('8902','2013-09-28','11:55:00',6.33),('8902','2013-09-28','12:00:00',6.24),('8902','2013-09-28','12:05:00',6.52),('8902','2013-09-28','12:10:00',6.19),('8902','2013-09-28','12:15:00',7.13),('8902','2013-09-28','12:20:00',5.97),('8902','2013-09-28','12:25:00',3.55),('8902','2013-09-28','12:30:00',3.76),('8902','2013-09-28','12:35:00',3.87),('8902','2013-09-28','12:40:00',3.17),('8902','2013-09-28','12:45:00',2.85),('8902','2013-09-28','12:50:00',2.91),('8902','2013-09-28','12:55:00',2.48),('8902','2013-09-28','13:00:00',2.65),('8902','2013-09-28','13:05:00',2.08),('8902','2013-09-28','13:10:00',2.19),('8902','2013-09-28','13:15:00',1.74),('8902','2013-09-28','13:20:00',1.75),('8902','2013-09-28','13:25:00',2.71),('8902','2013-09-28','13:30:00',4.61),('8902','2013-09-28','13:35:00',3.08),('8902','2013-09-28','13:40:00',3.05),('8902','2013-09-28','13:45:00',2.96),('8902','2013-09-28','13:50:00',3.09),('8902','2013-09-28','13:55:00',4.43),('8902','2013-09-28','14:00:00',4.33),('8902','2013-09-28','14:05:00',5.57),('8902','2013-09-28','14:10:00',2.88),('8902','2013-09-28','14:15:00',3.31),('8902','2013-09-28','14:20:00',4.08),('8902','2013-09-28','14:25:00',3.2),('8902','2013-09-28','14:30:00',2.42),('8902','2013-09-28','14:35:00',2.36),('8902','2013-09-28','14:40:00',2.22),('8902','2013-09-28','14:45:00',1.59),('8902','2013-09-28','14:50:00',1.83),('8902','2013-09-28','14:55:00',2.02),('8902','2013-09-28','15:00:00',2.71),('8902','2013-09-28','15:05:00',1.18),('8902','2013-09-28','15:15:00',1.17),('8902','2013-09-28','15:20:00',1.89),('8902','2013-09-28','15:25:00',1.56),('8902','2013-09-28','15:30:00',1.43),('8902','2013-09-28','15:35:00',1.29),('8902','2013-09-28','15:40:00',1.56),('8902','2013-09-28','15:45:00',1.27),('8902','2013-09-28','15:50:00',1.19),('8902','2013-09-28','15:55:00',1.71),('8902','2013-09-28','16:00:00',2.26),('8902','2013-09-28','16:05:00',1.8),('8902','2013-09-28','16:10:00',1.21),('8902','2013-09-28','16:20:00',1.15),('8902','2013-09-28','16:25:00',1.47),('8902','2013-09-28','16:30:00',2.03),('8902','2013-09-28','16:35:00',1.9),('8902','2013-09-28','16:40:00',1.65),('8902','2013-09-28','16:45:00',1.5),('8902','2013-09-28','17:05:00',1.21),('8902','2013-09-28','17:20:00',1.01),('8902','2014-04-13','07:55:00',1.29),('8902','2014-04-13','08:00:00',1.46),('8902','2014-04-13','08:05:00',1.63),('8902','2014-04-13','08:10:00',1.81),('8902','2014-04-13','08:15:00',1.99),('8902','2014-04-13','08:20:00',2.18),('8902','2014-04-13','08:25:00',2.37),('8902','2014-04-13','08:30:00',2.56),('8902','2014-04-13','08:35:00',2.74),('8902','2014-04-13','08:40:00',2.93),('8902','2014-04-13','08:45:00',3.12),('8902','2014-04-13','08:50:00',3.29),('8902','2014-04-13','08:55:00',3.46),('8902','2014-04-13','09:00:00',3.65),('8902','2014-04-13','09:05:00',3.83),('8902','2014-04-13','09:10:00',4.02),('8902','2014-04-13','09:15:00',4.18),('8902','2014-04-13','09:20:00',4.35),('8902','2014-04-13','09:25:00',4.49),('8902','2014-04-13','09:30:00',4.66),('8902','2014-04-13','09:35:00',4.8),('8902','2014-04-13','09:40:00',4.97),('8902','2014-04-13','09:45:00',5.1),('8902','2014-04-13','09:50:00',5.25),('8902','2014-04-13','09:55:00',5.39),('8902','2014-04-13','10:00:00',5.52),('8902','2014-04-13','10:05:00',5.71),('8902','2014-04-13','10:10:00',5.87),('8902','2014-04-13','10:15:00',6),('8902','2014-04-13','10:20:00',6.14),('8902','2014-04-13','10:25:00',6.24),('8902','2014-04-13','10:30:00',6.36),('8902','2014-04-13','10:35:00',6.47),('8902','2014-04-13','10:40:00',6.59),('8902','2014-04-13','10:45:00',6.69),('8902','2014-04-13','10:50:00',6.79),('8902','2014-04-13','10:55:00',6.91),('8902','2014-04-13','11:00:00',6.98),('8902','2014-04-13','11:05:00',7.08),('8902','2014-04-13','11:10:00',7.12),('8902','2014-04-13','11:15:00',7.21),('8902','2014-04-13','11:20:00',7.32),('8902','2014-04-13','11:25:00',7.36),('8902','2014-04-13','11:30:00',7.41),('8902','2014-04-13','11:35:00',7.53),('8902','2014-04-13','11:40:00',7.61),('8902','2014-04-13','11:45:00',7.63),('8902','2014-04-13','11:50:00',7.69),('8902','2014-04-13','11:55:00',7.73),('8902','2014-04-13','12:00:00',7.79),('8902','2014-04-13','12:05:00',7.83),('8902','2014-04-13','12:10:00',7.85),('8902','2014-04-13','12:15:00',7.94),('8902','2014-04-13','12:20:00',8.02),('8902','2014-04-13','12:25:00',8.02),('8902','2014-04-13','12:30:00',8.09),('8902','2014-04-13','12:35:00',8.09),('8902','2014-04-13','12:40:00',8.12),('8902','2014-04-13','12:45:00',8.2),('8902','2014-04-13','12:50:00',8.2),('8902','2014-04-13','12:55:00',8.21),('8902','2014-04-13','13:00:00',8.24),('8902','2014-04-13','13:05:00',8.28),('8902','2014-04-13','13:10:00',8.29),('8902','2014-04-13','13:15:00',8.21),('8902','2014-04-13','13:20:00',8.27),('8902','2014-04-13','13:25:00',8.27),('8902','2014-04-13','13:30:00',8.3),('8902','2014-04-13','13:35:00',8.31),('8902','2014-04-13','13:40:00',8.31),('8902','2014-04-13','13:45:00',8.28),('8902','2014-04-13','13:50:00',8.28),('8902','2014-04-13','13:55:00',8.27),('8902','2014-04-13','14:00:00',8.23),('8902','2014-04-13','14:05:00',8.22),('8902','2014-04-13','14:10:00',8.19),('8902','2014-04-13','14:15:00',8.19),('8902','2014-04-13','14:20:00',8.2),('8902','2014-04-13','14:25:00',8.19),('8902','2014-04-13','14:30:00',8.14),('8902','2014-04-13','14:35:00',8.05),('8902','2014-04-13','14:40:00',8),('8902','2014-04-13','14:45:00',7.95),('8902','2014-04-13','14:50:00',7.94),('8902','2014-04-13','14:55:00',7.89),('8902','2014-04-13','15:00:00',7.83),('8902','2014-04-13','15:05:00',7.77),('8902','2014-04-13','15:10:00',7.65),('8902','2014-04-13','15:15:00',7.58),('8902','2014-04-13','15:20:00',7.51),('8902','2014-04-13','15:25:00',7.43),('8902','2014-04-13','15:30:00',7.37),('8902','2014-04-13','15:35:00',7.26),('8902','2014-04-13','15:40:00',7.18),('8902','2014-04-13','15:45:00',7.09),('8902','2014-04-13','15:50:00',6.97),('8902','2014-04-13','15:55:00',6.87),('8902','2014-04-13','16:00:00',6.77),('8902','2014-04-13','16:05:00',6.64),('8902','2014-04-13','16:10:00',6.51),('8902','2014-04-13','16:15:00',6.38),('8902','2014-04-13','16:20:00',6.26),('8902','2014-04-13','16:25:00',6.06),('8902','2014-04-13','16:30:00',5.93),('8902','2014-04-13','16:35:00',5.8),('8902','2014-04-13','16:40:00',5.65),('8902','2014-04-13','16:45:00',5.43),('8902','2014-04-13','16:50:00',5.31),('8902','2014-04-13','16:55:00',5.18),('8902','2014-04-13','17:00:00',5),('8902','2014-04-13','17:05:00',4.8),('8902','2014-04-13','17:10:00',4.61),('8902','2014-04-13','17:15:00',4.45),('8902','2014-04-13','17:20:00',4.29),('8902','2014-04-13','17:25:00',4.12),('8902','2014-04-13','17:30:00',3.9),('8902','2014-04-13','17:35:00',3.68),('8902','2014-04-13','17:40:00',3.43),('8902','2014-04-13','17:45:00',3.26),('8902','2014-04-13','17:50:00',3.1),('8902','2014-04-13','17:55:00',2.87),('8902','2014-04-13','18:00:00',2.66),('8902','2014-04-13','18:05:00',2.42),('8902','2014-04-13','18:10:00',2.25),('8902','2014-04-13','18:15:00',2.04),('8902','2014-04-13','18:20:00',1.85),('8902','2014-04-13','18:25:00',1.68),('8902','2014-04-13','18:30:00',1.52),('8902','2014-04-13','18:35:00',1.33),('8902','2014-04-13','18:40:00',1.13),('8902','2013-09-27','08:10:00',1.02),('8902','2013-09-27','08:15:00',1.24),('8902','2013-09-27','08:20:00',1.22),('8902','2013-09-27','08:25:00',1.32),('8902','2013-09-27','08:30:00',1.63),('8902','2013-09-27','08:35:00',1.73),('8902','2013-09-27','08:40:00',1.87),('8902','2013-09-27','08:45:00',2.03),('8902','2013-09-27','08:50:00',2.18),('8902','2013-09-27','08:55:00',2.33),('8902','2013-09-27','09:00:00',2.48),('8902','2013-09-27','09:05:00',2.7),('8902','2013-09-27','09:10:00',2.88),('8902','2013-09-27','09:15:00',3.09),('8902','2013-09-27','09:20:00',3.27),('8902','2013-09-27','09:25:00',3.51),('8902','2013-09-27','09:30:00',3.64),('8902','2013-09-27','09:35:00',3.35),('8902','2013-09-27','09:40:00',3.97),('8902','2013-09-27','09:45:00',4.01),('8902','2013-09-27','09:50:00',3.56),('8902','2013-09-27','09:55:00',3.75),('8902','2013-09-27','10:00:00',4.91),('8902','2013-09-27','10:05:00',4.31),('8902','2013-09-27','10:10:00',3.69),('8902','2013-09-27','10:15:00',2.07),('8902','2013-09-27','10:20:00',2.16),('8902','2013-09-27','10:25:00',3.32),('8902','2013-09-27','10:30:00',2.18),('8902','2013-09-27','10:35:00',4.2),('8902','2013-09-27','10:40:00',5.55),('8902','2013-09-27','10:45:00',4.49),('8902','2013-09-27','10:50:00',4.55),('8902','2013-09-27','10:55:00',3.39),('8902','2013-09-27','11:00:00',6.94),('8902','2013-09-27','11:05:00',5.2),('8902','2013-09-27','11:10:00',4.23),('8902','2013-09-27','11:15:00',6.53),('8902','2013-09-27','11:20:00',2.8),('8902','2013-09-27','11:25:00',6.25),('8902','2013-09-27','11:30:00',6.87),('8902','2013-09-27','11:35:00',7.07),('8902','2013-09-27','11:40:00',6.94),('8902','2013-09-27','11:45:00',3.36),('8902','2013-09-27','11:50:00',3.09),('8902','2013-09-27','11:55:00',2.53),('8902','2013-09-27','12:00:00',5.72),('8902','2013-09-27','12:05:00',7.47),('8902','2013-09-27','12:10:00',6.2),('8902','2013-09-27','12:15:00',3.96),('8902','2013-09-27','12:20:00',5.65),('8902','2013-09-27','12:25:00',4.55),('8902','2013-09-27','12:30:00',1.78),('8902','2013-09-27','12:35:00',4.76),('8902','2013-09-27','12:40:00',3.31),('8902','2013-09-27','12:45:00',2.36),('8902','2013-09-27','12:50:00',6.9),('8902','2013-09-27','12:55:00',8.24),('8902','2013-09-27','13:00:00',8),('8902','2013-09-27','13:05:00',7.56),('8902','2013-09-27','13:10:00',4.08),('8902','2013-09-27','13:15:00',3),('8902','2013-09-27','13:20:00',3.12),('8902','2013-09-27','13:25:00',6.26),('8902','2013-09-27','13:30:00',7.33),('8902','2013-09-27','13:35:00',3.53),('8902','2013-09-27','13:40:00',3.52),('8902','2013-09-27','13:45:00',3.82),('8902','2013-09-27','13:50:00',4.3),('8902','2013-09-27','13:55:00',2.88),('8902','2013-09-27','14:00:00',4.36),('8902','2013-09-27','14:05:00',4.61),('8902','2013-09-27','14:10:00',3.33),('8902','2013-09-27','14:15:00',3.47),('8902','2013-09-27','14:20:00',6.06),('8902','2013-09-27','14:25:00',7.83),('8902','2013-09-27','14:30:00',7.17),('8902','2013-09-27','14:35:00',7.25),('8902','2013-09-27','14:40:00',7.49),('8902','2013-09-27','14:45:00',7.41),('8902','2013-09-27','14:50:00',6.96),('8902','2013-09-27','14:55:00',6.56),('8902','2013-09-27','15:00:00',6.91),('8902','2013-09-27','15:05:00',7.11),('8902','2013-09-27','15:10:00',6.72),('8902','2013-09-27','15:15:00',6.57),('8902','2013-09-27','15:20:00',6.77),('8902','2013-09-27','15:25:00',6.65),('8902','2013-09-27','15:30:00',6.42),('8902','2013-09-27','15:35:00',5.95),('8902','2013-09-27','15:40:00',6.03),('8902','2013-09-27','15:45:00',5.25),('8902','2013-09-27','15:50:00',3.57),('8902','2013-09-27','15:55:00',3.98),('8902','2013-09-27','16:00:00',5.33),('8902','2013-09-27','16:05:00',5.13),('8902','2013-09-27','16:10:00',5.29),('8902','2013-09-27','16:15:00',5.21),('8902','2013-09-27','16:20:00',4.78),('8902','2013-09-27','16:25:00',4.25),('8902','2013-09-27','16:30:00',3.92),('8902','2013-09-27','16:35:00',3.92),('8902','2013-09-27','16:40:00',3.81),('8902','2013-09-27','16:45:00',3.57),('8902','2013-09-27','16:50:00',3.4),('8902','2013-09-27','16:55:00',3.22),('8902','2013-09-27','17:00:00',3.07),('8902','2013-09-27','17:05:00',2.9),('8902','2013-09-27','17:10:00',2.69),('8902','2013-09-27','17:15:00',2.43),('8902','2013-09-27','17:20:00',2.33),('8902','2013-09-27','17:25:00',2.18),('8902','2013-09-27','17:30:00',2.02),('8902','2013-09-27','17:35:00',1.83),('8902','2013-09-27','17:40:00',1.65),('8902','2013-09-26','08:20:00',1.07),('8902','2013-09-26','08:25:00',1.65),('8902','2013-09-26','08:30:00',1.59),('8902','2013-09-26','08:35:00',1.84),('8902','2013-09-26','08:40:00',2.12),('8902','2013-09-26','08:45:00',1.87),('8902','2013-09-26','08:50:00',2),('8902','2013-09-26','08:55:00',2.64),('8902','2013-09-26','09:00:00',2.67),('8902','2013-09-26','09:05:00',2.42),('8902','2013-09-26','09:10:00',1.89),('8902','2013-09-26','09:15:00',1.86),('8902','2013-09-26','09:20:00',1.47),('8902','2013-09-26','09:25:00',1.81),('8902','2013-09-26','09:30:00',1.4),('8902','2013-09-26','09:35:00',1.46),('8902','2013-09-26','09:40:00',1.6),('8902','2013-09-26','09:45:00',1.54),('8902','2013-09-26','09:50:00',2.28),('8902','2013-09-26','09:55:00',4.59),('8902','2013-09-26','10:00:00',3.39),('8902','2013-09-26','10:05:00',4.24),('8902','2013-09-26','10:10:00',3.45),('8902','2013-09-26','10:15:00',3.53),('8902','2013-09-26','10:20:00',4.93),('8902','2013-09-26','10:25:00',3.94),('8902','2013-09-26','10:30:00',3.32),('8902','2013-09-26','10:35:00',3.2),('8902','2013-09-26','10:40:00',2.79),('8902','2013-09-26','10:45:00',3.16),('8902','2013-09-26','10:50:00',2.24),('8902','2013-09-26','10:55:00',4.26),('8902','2013-09-26','11:00:00',5.74),('8902','2013-09-26','11:05:00',5.06),('8902','2013-09-26','11:10:00',5.38),('8902','2013-09-26','11:15:00',3.35),('8902','2013-09-26','11:20:00',3.55),('8902','2013-09-26','11:25:00',2.94),('8902','2013-09-26','11:30:00',2.39),('8902','2013-09-26','11:35:00',2.01),('8902','2013-09-26','11:40:00',2.1),('8902','2013-09-26','11:45:00',2.79),('8902','2013-09-26','11:50:00',2.07),('8902','2013-09-26','11:55:00',2.01),('8902','2013-09-26','12:00:00',6.1),('8902','2013-09-26','12:05:00',5.52),('8902','2013-09-26','12:10:00',7.04),('8902','2013-09-26','12:15:00',5.69),('8902','2013-09-26','12:20:00',2.98),('8902','2013-09-26','12:25:00',2.35),('8902','2013-09-26','12:30:00',2.07),('8902','2013-09-26','12:35:00',2.15),('8902','2013-09-26','12:40:00',1.75),('8902','2013-09-26','12:45:00',1.88),('8902','2013-09-26','12:50:00',3.7),('8902','2013-09-26','12:55:00',7.2),('8902','2013-09-26','13:00:00',7.11),('8902','2013-09-26','13:05:00',7.01),('8902','2013-09-26','13:10:00',7.5),('8902','2013-09-26','13:15:00',6.3),('8902','2013-09-26','13:20:00',6.27),('8902','2013-09-26','13:25:00',5.22),('8902','2013-09-26','13:30:00',1.7),('8902','2013-09-26','13:35:00',1.72),('8902','2013-09-26','13:40:00',1.74),('8902','2013-09-26','13:45:00',2.55),('8902','2013-09-26','13:50:00',1.87),('8902','2013-09-26','13:55:00',1.97),('8902','2013-09-26','14:00:00',5.28),('8902','2013-09-26','14:05:00',3.59),('8902','2013-09-26','14:10:00',5.09),('8902','2013-09-26','14:15:00',7.27),('8902','2013-09-26','14:20:00',4.93),('8902','2013-09-26','14:25:00',7.03),('8902','2013-09-26','14:30:00',6.66),('8902','2013-09-26','14:35:00',6.6),('8902','2013-09-26','14:40:00',6.66),('8902','2013-09-26','14:45:00',6.61),('8902','2013-09-26','14:50:00',6.55),('8902','2013-09-26','14:55:00',5.39),('8902','2013-09-26','15:00:00',6.52),('8902','2013-09-26','15:05:00',5.33),('8902','2013-09-26','15:10:00',4.24),('8902','2013-09-26','15:15:00',6.18),('8902','2013-09-26','15:20:00',5.67),('8902','2013-09-26','15:25:00',5.72),('8902','2013-09-26','15:30:00',5.86),('8902','2013-09-26','15:35:00',5.71),('8902','2013-09-26','15:40:00',5.64),('8902','2013-09-26','15:45:00',5.19),('8902','2013-09-26','15:50:00',5.52),('8902','2013-09-26','15:55:00',5.35),('8902','2013-09-26','16:00:00',4.84),('8902','2013-09-26','16:05:00',4.29),('8902','2013-09-26','16:10:00',1.85),('8902','2013-09-26','16:15:00',4.4),('8902','2013-09-26','16:20:00',3.92),('8902','2013-09-26','16:25:00',4.37),('8902','2013-09-26','16:30:00',4.16),('8902','2013-09-26','16:35:00',3.8),('8902','2013-09-26','16:40:00',3.92),('8902','2013-09-26','16:45:00',3.76),('8902','2013-09-26','16:50:00',3.49),('8902','2013-09-26','16:55:00',2.32),('8902','2013-09-26','17:00:00',2),('8902','2013-09-26','17:05:00',1.31),('8902','2013-09-26','17:10:00',1.82),('8902','2013-09-26','17:15:00',2.79),('8902','2013-09-26','17:20:00',2.56),('8902','2013-09-26','17:25:00',2.39),('8902','2013-09-26','17:30:00',2.24),('8902','2013-09-26','17:35:00',1.97),('8902','2013-09-26','17:40:00',1.66),('8902','2013-09-26','17:45:00',1.49),('8902','2013-09-26','17:50:00',1.4),('8902','2013-09-26','17:55:00',1.23),('8902','2013-09-26','18:00:00',1.05),('8902','2013-09-25','08:10:00',1.12),('8902','2013-09-25','08:15:00',1.3),('8902','2013-09-25','08:25:00',1.54),('8902','2013-09-25','08:30:00',1.55),('8902','2013-09-25','08:35:00',1.41),('8902','2013-09-25','08:40:00',2.06),('8902','2013-09-25','08:45:00',2.17),('8902','2013-09-25','08:50:00',2.37),('8902','2013-09-25','08:55:00',2.53),('8902','2013-09-25','09:00:00',2.73),('8902','2013-09-25','09:05:00',2.87),('8902','2013-09-25','09:10:00',3.07),('8902','2013-09-25','09:15:00',3.26),('8902','2013-09-25','09:20:00',3.45),('8902','2013-09-25','09:25:00',3.6),('8902','2013-09-25','09:30:00',3.76),('8902','2013-09-25','09:35:00',3.91),('8902','2013-09-25','09:40:00',4.09),('8902','2013-09-25','09:45:00',4.27),('8902','2013-09-25','09:50:00',3.84),('8902','2013-09-25','09:55:00',4.48),('8902','2013-09-25','10:00:00',4.65),('8902','2013-09-25','10:05:00',4.8),('8902','2013-09-25','10:10:00',4.92),('8902','2013-09-25','10:15:00',4.98),('8902','2013-09-25','10:20:00',5.16),('8902','2013-09-25','10:25:00',5.1),('8902','2013-09-25','10:30:00',5.25),('8902','2013-09-25','10:35:00',5.35),('8902','2013-09-25','10:40:00',5.43),('8902','2013-09-25','10:45:00',5.75),('8902','2013-09-25','10:50:00',5.73),('8902','2013-09-25','10:55:00',5.82),('8902','2013-09-25','11:00:00',5.83),('8902','2013-09-25','11:05:00',5.85),('8902','2013-09-25','11:10:00',5.99),('8902','2013-09-25','11:15:00',5.56),('8902','2013-09-25','11:20:00',5.79),('8902','2013-09-25','11:25:00',6.29),('8902','2013-09-25','11:30:00',6.38),('8902','2013-09-25','11:35:00',6.53),('8902','2013-09-25','11:40:00',5.68),('8902','2013-09-25','11:45:00',6.4),('8902','2013-09-25','11:50:00',6.62),('8902','2013-09-25','11:55:00',5.39),('8902','2013-09-25','12:00:00',6.21),('8902','2013-09-25','12:05:00',5.6),('8902','2013-09-25','12:10:00',3.47),('8902','2013-09-25','12:15:00',2.72),('8902','2013-09-25','12:20:00',3.28),('8902','2013-09-25','12:25:00',2.79),('8902','2013-09-25','12:30:00',2.51),('8902','2013-09-25','12:35:00',2.49),('8902','2013-09-25','12:40:00',2.72),('8902','2013-09-25','12:45:00',3.24),('8902','2013-09-25','12:50:00',3.16),('8902','2013-09-25','12:55:00',4.12),('8902','2013-09-25','13:00:00',6.02),('8902','2013-09-25','13:05:00',5.36),('8902','2013-09-25','13:10:00',3.32),('8902','2013-09-25','13:15:00',5.15),('8902','2013-09-25','13:20:00',6.96),('8902','2013-09-25','13:25:00',8),('8902','2013-09-25','13:30:00',3.77),('8902','2013-09-25','13:35:00',3.57),('8902','2013-09-25','13:40:00',3.18),('8902','2013-09-25','13:45:00',2.63),('8902','2013-09-25','13:50:00',2.71),('8902','2013-09-25','13:55:00',4.37),('8902','2013-09-25','14:00:00',4.58),('8902','2013-09-25','14:05:00',5.55),('8902','2013-09-25','14:10:00',6.6),('8902','2013-09-25','14:15:00',7.3),('8902','2013-09-25','14:20:00',5.82),('8902','2013-09-25','14:25:00',1.84),('8902','2013-09-25','14:30:00',1.85),('8902','2013-09-25','14:35:00',5.31),('8902','2013-09-25','14:40:00',3.59),('8902','2013-09-25','14:45:00',5.1),('8902','2013-09-25','14:50:00',7.83),('8902','2013-09-25','14:55:00',7.13),('8902','2013-09-25','15:00:00',3.15),('8902','2013-09-25','15:05:00',3.33),('8902','2013-09-25','15:10:00',4.37),('8902','2013-09-25','15:15:00',2.7),('8902','2013-09-25','15:20:00',3.62),('8902','2013-09-25','15:25:00',6),('8902','2013-09-25','15:30:00',1.53),('8902','2013-09-25','15:35:00',3.15),('8902','2013-09-25','15:40:00',4.37),('8902','2013-09-25','15:45:00',3.18),('8902','2013-09-25','15:50:00',4.46),('8902','2013-09-25','15:55:00',5.63),('8902','2013-09-25','16:00:00',5.23),('8902','2013-09-25','16:05:00',5.05),('8902','2013-09-25','16:10:00',4.96),('8902','2013-09-25','16:15:00',4.77),('8902','2013-09-25','16:20:00',4.63),('8902','2013-09-25','16:25:00',4.39),('8902','2013-09-25','16:30:00',4.3),('8902','2013-09-25','16:35:00',4.1),('8902','2013-09-25','16:40:00',3.97),('8902','2013-09-25','16:45:00',3.74),('8902','2013-09-25','16:50:00',3.56),('8902','2013-09-25','16:55:00',3.41),('8902','2013-09-25','17:00:00',3.2),('8902','2013-09-25','17:05:00',3.16),('8902','2013-09-25','17:10:00',3.01),('8902','2013-09-25','17:15:00',2.71),('8902','2013-09-25','17:20:00',2.59),('8902','2013-09-25','17:25:00',2.43),('8902','2013-09-25','17:30:00',2.04),('8902','2013-09-25','17:35:00',2.01),('8902','2013-09-25','17:40:00',1.91),('8902','2013-09-25','17:45:00',1.71),('8902','2013-09-25','17:50:00',1.5),('8902','2013-09-25','17:55:00',1.22),('8902','2013-09-25','18:00:00',1.02),('8902','2013-09-24','08:10:00',1.04),('8902','2013-09-24','08:15:00',1.11),('8902','2013-09-24','08:20:00',1.05),('8902','2013-09-24','08:25:00',1.26),('8902','2013-09-24','08:30:00',1.27),('8902','2013-09-24','08:35:00',1.13),('8902','2013-09-24','08:45:00',2.32),('8902','2013-09-24','08:50:00',2.48),('8902','2013-09-24','08:55:00',1.25),('8902','2013-09-24','09:00:00',1.24),('8902','2013-09-24','09:05:00',1.56),('8902','2013-09-24','09:10:00',2.25),('8902','2013-09-24','09:15:00',2.42),('8902','2013-09-24','09:20:00',1.72),('8902','2013-09-24','09:25:00',2.44),('8902','2013-09-24','09:30:00',2.93),('8902','2013-09-24','09:35:00',3.67),('8902','2013-09-24','09:40:00',3.83),('8902','2013-09-24','09:45:00',3.35),('8902','2013-09-24','09:50:00',4.25),('8902','2013-09-24','09:55:00',4.14),('8902','2013-09-24','10:00:00',4.77),('8902','2013-09-24','10:05:00',3.52),('8902','2013-09-24','10:10:00',1.76),('8902','2013-09-24','10:15:00',1.45),('8902','2013-09-24','10:20:00',2.19),('8902','2013-09-24','10:25:00',2.43),('8902','2013-09-24','10:30:00',1.8),('8902','2013-09-24','10:35:00',1.39),('8902','2013-09-24','10:40:00',1.32),('8902','2013-09-24','10:45:00',2.99),('8902','2013-09-24','10:50:00',5.12),('8902','2013-09-24','10:55:00',7.06),('8902','2013-09-24','11:00:00',6.77),('8902','2013-09-24','11:05:00',6.5),('8902','2013-09-24','11:10:00',5.98),('8902','2013-09-24','11:15:00',2.65),('8902','2013-09-24','11:20:00',1.73),('8902','2013-09-24','11:25:00',3.04),('8902','2013-09-24','11:30:00',7.08),('8902','2013-09-24','11:35:00',6.98),('8902','2013-09-24','11:40:00',6.84),('8902','2013-09-24','11:45:00',6.83),('8902','2013-09-24','11:50:00',4.24),('8902','2013-09-24','11:55:00',2.17),('8902','2013-09-24','12:00:00',1.83),('8902','2013-09-24','12:05:00',1.6),('8902','2013-09-24','12:10:00',1.92),('8902','2013-09-24','12:15:00',2.18),('8902','2013-09-24','12:20:00',4.72),('8902','2013-09-24','12:25:00',3.14),('8902','2013-09-24','12:30:00',2.22),('8902','2013-09-24','12:35:00',3.7),('8902','2013-09-24','12:40:00',5.9),('8902','2013-09-24','12:45:00',3.71),('8902','2013-09-24','12:50:00',2.03),('8902','2013-09-24','12:55:00',1.49),('8902','2013-09-24','13:00:00',1.66),('8902','2013-09-24','13:05:00',1.82),('8902','2013-09-24','13:10:00',1.84),('8902','2013-09-24','13:15:00',1.77),('8902','2013-09-24','13:20:00',1.99),('8902','2013-09-24','13:25:00',2.01),('8902','2013-09-24','13:30:00',3),('8902','2013-09-24','13:35:00',4.11),('8902','2013-09-24','13:40:00',7.89),('8902','2013-09-24','13:45:00',8.27),('8902','2013-09-24','13:50:00',8.5),('8902','2013-09-24','13:55:00',8.39),('8902','2013-09-24','14:00:00',2.2),('8902','2013-09-24','14:05:00',1.79),('8902','2013-09-24','14:10:00',1.97),('8902','2013-09-24','14:15:00',2.58),('8902','2013-09-24','14:20:00',1.76),('8902','2013-09-24','14:25:00',1.8),('8902','2013-09-24','14:30:00',5.97),('8902','2013-09-24','14:35:00',8.04),('8902','2013-09-24','14:40:00',8.17),('8902','2013-09-24','14:45:00',4.49),('8902','2013-09-24','14:50:00',5.76),('8902','2013-09-24','14:55:00',7.87),('8902','2013-09-24','15:00:00',6.71),('8902','2013-09-24','15:05:00',6.38),('8902','2013-09-24','15:10:00',6.87),('8902','2013-09-24','15:15:00',6.8),('8902','2013-09-24','15:20:00',6.6),('8902','2013-09-24','15:25:00',5.97),('8902','2013-09-24','15:30:00',6.43),('8902','2013-09-24','15:35:00',5.98),('8902','2013-09-24','15:40:00',6.5),('8902','2013-09-24','15:45:00',5.79),('8902','2013-09-24','15:50:00',5.81),('8902','2013-09-24','15:55:00',5.79),('8902','2013-09-24','16:00:00',5.59),('8902','2013-09-24','16:05:00',5.43),('8902','2013-09-24','16:10:00',5.23),('8902','2013-09-24','16:15:00',4.9),('8902','2013-09-24','16:20:00',4.93),('8902','2013-09-24','16:25:00',4.65),('8902','2013-09-24','16:30:00',4.59),('8902','2013-09-24','16:35:00',4.39),('8902','2013-09-24','16:40:00',4.25),('8902','2013-09-24','16:45:00',4.07),('8902','2013-09-24','16:50:00',3.85),('8902','2013-09-24','16:55:00',3.66),('8902','2013-09-24','17:00:00',3.55),('8902','2013-09-24','17:05:00',3.38),('8902','2013-09-24','17:10:00',3.23),('8902','2013-09-24','17:15:00',2.97),('8902','2013-09-24','17:20:00',2.76),('8902','2013-09-24','17:25:00',2.59),('8902','2013-09-24','17:30:00',2.43),('8902','2013-09-24','17:35:00',2.22),('8902','2013-09-24','17:40:00',2),('8902','2013-09-24','17:45:00',1.82),('8902','2013-09-24','17:50:00',1.62),('8902','2013-09-24','17:55:00',1.44),('8902','2013-09-24','18:00:00',1.27),('8902','2013-09-24','18:05:00',1.09),('8902','2013-09-23','08:10:00',1.13),('8902','2013-09-23','08:15:00',1.3),('8902','2013-09-23','08:20:00',1.46),('8902','2013-09-23','08:25:00',1.6),('8902','2013-09-23','08:30:00',1.78),('8902','2013-09-23','08:35:00',1.96),('8902','2013-09-23','08:40:00',2.14),('8902','2013-09-23','08:45:00',2.34),('8902','2013-09-23','08:50:00',2.51),('8902','2013-09-23','08:55:00',2.67),('8902','2013-09-23','09:00:00',2.87),('8902','2013-09-23','09:05:00',3.07),('8902','2013-09-23','09:10:00',3.25),('8902','2013-09-23','09:15:00',3.43),('8902','2013-09-23','09:20:00',3.62),('8902','2013-09-23','09:25:00',3.79),('8902','2013-09-23','09:30:00',3.98),('8902','2013-09-23','09:35:00',4.16),('8902','2013-09-23','09:40:00',4.31),('8902','2013-09-23','09:45:00',4.44),('8902','2013-09-23','09:50:00',4.58),('8902','2013-09-23','09:55:00',4.72),('8902','2013-09-23','10:00:00',4.87),('8902','2013-09-23','10:05:00',4.95),('8902','2013-09-23','10:10:00',5.1),('8902','2013-09-23','10:15:00',5.26),('8902','2013-09-23','10:20:00',5.4),('8902','2013-09-23','10:25:00',5.52),('8902','2013-09-23','10:30:00',5.64),('8902','2013-09-23','10:35:00',5.73),('8902','2013-09-23','10:40:00',5.84),('8902','2013-09-23','10:45:00',5.94),('8902','2013-09-23','10:50:00',6.04),('8902','2013-09-23','10:55:00',6.14),('8902','2013-09-23','11:00:00',6.21),('8902','2013-09-23','11:05:00',6.29),('8902','2013-09-23','11:10:00',6.36),('8902','2013-09-23','11:15:00',6.4),('8902','2013-09-23','11:20:00',6.47),('8902','2013-09-23','11:25:00',6.57),('8902','2013-09-23','11:30:00',6.64),('8902','2013-09-23','11:35:00',6.69),('8902','2013-09-23','11:40:00',6.72),('8902','2013-09-23','11:45:00',6.8),('8902','2013-09-23','11:50:00',6.87),('8902','2013-09-23','11:55:00',6.94),('8902','2013-09-23','12:00:00',6.96),('8902','2013-09-23','12:05:00',6.97),('8902','2013-09-23','12:10:00',7.01),('8902','2013-09-23','12:15:00',7.05),('8902','2013-09-23','12:20:00',7.02),('8902','2013-09-23','12:25:00',7.05),('8902','2013-09-23','12:30:00',7.02),('8902','2013-09-23','12:35:00',6.97),('8902','2013-09-23','12:40:00',7.2),('8902','2013-09-23','12:45:00',7.21),('8902','2013-09-23','12:50:00',7.26),('8902','2013-09-23','12:55:00',7.29),('8902','2013-09-23','13:00:00',7.25),('8902','2013-09-23','13:05:00',7.26),('8902','2013-09-23','13:10:00',7.27),('8902','2013-09-23','13:15:00',7.26),('8902','2013-09-23','13:20:00',7.26),('8902','2013-09-23','13:25:00',7.24),('8902','2013-09-23','13:30:00',7.22),('8902','2013-09-23','13:35:00',7.16),('8902','2013-09-23','13:40:00',7.3),('8902','2013-09-23','13:45:00',7.3),('8902','2013-09-23','13:50:00',7.22),('8902','2013-09-23','13:55:00',7.19),('8902','2013-09-23','14:00:00',7.14),('8902','2013-09-23','14:05:00',7.11),('8902','2013-09-23','14:10:00',7.05),('8902','2013-09-23','14:15:00',7.01),('8902','2013-09-23','14:20:00',7),('8902','2013-09-23','14:25:00',6.99),('8902','2013-09-23','14:30:00',6.88),('8902','2013-09-23','14:35:00',6.77),('8902','2013-09-23','14:40:00',6.76),('8902','2013-09-23','14:45:00',6.69),('8902','2013-09-23','14:50:00',6.63),('8902','2013-09-23','14:55:00',6.63),('8902','2013-09-23','15:00:00',6.45),('8902','2013-09-23','15:05:00',6.44),('8902','2013-09-23','15:10:00',6.35),('8902','2013-09-23','15:15:00',6.21),('8902','2013-09-23','15:20:00',6.23),('8902','2013-09-23','15:25:00',6.2),('8902','2013-09-23','15:30:00',6.11),('8902','2013-09-23','15:35:00',6.01),('8902','2013-09-23','15:40:00',5.88),('8902','2013-09-23','15:45:00',5.8),('8902','2013-09-23','15:50:00',5.69),('8902','2013-09-23','15:55:00',5.56),('8902','2013-09-23','16:00:00',5.43),('8902','2013-09-23','16:05:00',5.31),('8902','2013-09-23','16:10:00',5.08),('8902','2013-09-23','16:15:00',4.99),('8902','2013-09-23','16:20:00',4.91),('8902','2013-09-23','16:25:00',4.7),('8902','2013-09-23','16:30:00',4.58),('8902','2013-09-23','16:35:00',4.35),('8902','2013-09-23','16:40:00',4.21),('8902','2013-09-23','16:45:00',4.08),('8902','2013-09-23','16:50:00',3.9),('8902','2013-09-23','16:55:00',3.81),('8902','2013-09-23','17:00:00',3.65),('8902','2013-09-23','17:05:00',3.46),('8902','2013-09-23','17:10:00',3.3),('8902','2013-09-23','17:15:00',3.03),('8902','2013-09-23','17:20:00',2.85),('8902','2013-09-23','17:25:00',2.67),('8902','2013-09-23','17:30:00',2.45),('8902','2013-09-23','17:35:00',2.2),('8902','2013-09-23','17:40:00',1.93),('8902','2013-09-23','17:45:00',1.79),('8902','2013-09-23','17:50:00',1.59),('8902','2013-09-23','17:55:00',1.4),('8902','2013-09-23','18:00:00',1.23),('8902','2013-09-23','18:05:00',1.09),('8902','2013-09-22','08:05:00',1.03),('8902','2013-09-22','08:10:00',1.19),('8902','2013-09-22','08:15:00',1.35),('8902','2013-09-22','08:20:00',1.52),('8902','2013-09-22','08:25:00',1.68),('8902','2013-09-22','08:30:00',1.84),('8902','2013-09-22','08:35:00',2.04),('8902','2013-09-22','08:40:00',2.23),('8902','2013-09-22','08:45:00',2.41),('8902','2013-09-22','08:50:00',2.61),('8902','2013-09-22','08:55:00',2.77),('8902','2013-09-22','09:00:00',2.95),('8902','2013-09-22','09:05:00',3.15),('8902','2013-09-22','09:10:00',3.35),('8902','2013-09-22','09:15:00',3.53),('8902','2013-09-22','09:20:00',3.72),('8902','2013-09-22','09:25:00',3.9),('8902','2013-09-22','09:30:00',4.08),('8902','2013-09-22','09:35:00',4.24),('8902','2013-09-22','09:40:00',4.4),('8902','2013-09-22','09:45:00',4.53),('8902','2013-09-22','09:50:00',4.67),('8902','2013-09-22','09:55:00',4.83),('8902','2013-09-22','10:00:00',4.96),('8902','2013-09-22','10:05:00',4.58),('8902','2013-09-22','10:10:00',5.22),('8902','2013-09-22','10:15:00',5.34),('8902','2013-09-22','10:20:00',5.46),('8902','2013-09-22','10:25:00',5.57),('8902','2013-09-22','10:30:00',5.68),('8902','2013-09-22','10:35:00',5.81),('8902','2013-09-22','10:40:00',5.91),('8902','2013-09-22','10:45:00',6.01),('8902','2013-09-22','10:50:00',6.11),('8902','2013-09-22','10:55:00',6.21),('8902','2013-09-22','11:00:00',6.31),('8902','2013-09-22','11:05:00',6.43),('8902','2013-09-22','11:10:00',6.53),('8902','2013-09-22','11:15:00',6.65),('8902','2013-09-22','11:20:00',6.7),('8902','2013-09-22','11:25:00',6.78),('8902','2013-09-22','11:30:00',6.87),('8902','2013-09-22','11:35:00',6.93),('8902','2013-09-22','11:40:00',7.02),('8902','2013-09-22','11:45:00',7.07),('8902','2013-09-22','11:50:00',7.08),('8902','2013-09-22','11:55:00',7.14),('8902','2013-09-22','12:00:00',7.24),('8902','2013-09-22','12:05:00',7.35),('8902','2013-09-22','12:10:00',7.43),('8902','2013-09-22','12:15:00',7.45),('8902','2013-09-22','12:20:00',7.44),('8902','2013-09-22','12:25:00',7.43),('8902','2013-09-22','12:30:00',7.38),('8902','2013-09-22','12:35:00',7.39),('8902','2013-09-22','12:40:00',7.43),('8902','2013-09-22','12:45:00',7.44),('8902','2013-09-22','12:50:00',7.43),('8902','2013-09-22','12:55:00',7.51),('8902','2013-09-22','13:00:00',7.51),('8902','2013-09-22','13:05:00',7.47),('8902','2013-09-22','13:10:00',7.45),('8902','2013-09-22','13:15:00',7.43),('8902','2013-09-22','13:20:00',7.38),('8902','2013-09-22','13:25:00',7.45),('8902','2013-09-22','13:30:00',7.46),('8902','2013-09-22','13:35:00',7.46),('8902','2013-09-22','13:40:00',7.46),('8902','2013-09-22','13:45:00',7.4),('8902','2013-09-22','13:50:00',7.36),('8902','2013-09-22','13:55:00',7.33),('8902','2013-09-22','14:00:00',7.22),('8902','2013-09-22','14:05:00',7.13),('8902','2013-09-22','14:10:00',7.16),('8902','2013-09-22','14:15:00',7.17),('8902','2013-09-22','14:20:00',7),('8902','2013-09-22','14:25:00',7.05),('8902','2013-09-22','14:30:00',7.25),('8902','2013-09-22','14:35:00',6.7),('8902','2013-09-22','14:40:00',6.96),('8902','2013-09-22','14:45:00',6.82),('8902','2013-09-22','14:50:00',6.76),('8902','2013-09-22','14:55:00',6.71),('8902','2013-09-22','15:00:00',6.47),('8902','2013-09-22','15:05:00',6.63),('8902','2013-09-22','15:10:00',5.86),('8902','2013-09-22','15:15:00',6.43),('8902','2013-09-22','15:20:00',6.24),('8902','2013-09-22','15:25:00',6.12),('8902','2013-09-22','15:30:00',6.05),('8902','2013-09-22','15:35:00',5.9),('8902','2013-09-22','15:40:00',5.79),('8902','2013-09-22','15:45:00',5.63),('8902','2013-09-22','15:50:00',5.64),('8902','2013-09-22','15:55:00',5.28),('8902','2013-09-22','16:00:00',4.71),('8902','2013-09-22','16:05:00',5.26),('8902','2013-09-22','16:10:00',1.65),('8902','2013-09-22','16:15:00',5.05),('8902','2013-09-22','16:20:00',3.21),('8902','2013-09-22','16:25:00',4.88),('8902','2013-09-22','16:30:00',2.61),('8902','2013-09-22','16:35:00',4.01),('8902','2013-09-22','16:40:00',4.15),('8902','2013-09-22','16:45:00',4.02),('8902','2013-09-22','16:50:00',3.73),('8902','2013-09-22','16:55:00',3.63),('8902','2013-09-22','17:00:00',3.5),('8902','2013-09-22','17:05:00',3.35),('8902','2013-09-22','17:10:00',3.19),('8902','2013-09-22','17:15:00',2.96),('8902','2013-09-22','17:20:00',2.77),('8902','2013-09-22','17:25:00',2.6),('8902','2013-09-22','17:30:00',2.44),('8902','2013-09-22','17:35:00',2.28),('8902','2013-09-22','17:40:00',2.05),('8902','2013-09-22','17:45:00',1.85),('8902','2013-09-22','17:50:00',1.6),('8902','2013-09-22','17:55:00',1.39),('8902','2013-09-22','18:00:00',1.24),('8902','2013-09-22','18:05:00',1.09),('8902','2013-09-21','08:05:00',1.13),('8902','2013-09-21','08:10:00',1.32),('8902','2013-09-21','08:15:00',1.15),('8902','2013-09-21','08:20:00',1.54),('8902','2013-09-21','08:25:00',1.73),('8902','2013-09-21','08:30:00',1.85),('8902','2013-09-21','08:35:00',2),('8902','2013-09-21','08:40:00',2.16),('8902','2013-09-21','08:45:00',2.35),('8902','2013-09-21','08:50:00',2.51),('8902','2013-09-21','08:55:00',2.71),('8902','2013-09-21','09:00:00',2.9),('8902','2013-09-21','09:05:00',3.07),('8902','2013-09-21','09:10:00',3.29),('8902','2013-09-21','09:15:00',3.48),('8902','2013-09-21','09:20:00',3.66),('8902','2013-09-21','09:25:00',3.86),('8902','2013-09-21','09:30:00',4.04),('8902','2013-09-21','09:35:00',4.21),('8902','2013-09-21','09:40:00',4.34),('8902','2013-09-21','09:45:00',4.51),('8902','2013-09-21','09:50:00',4.68),('8902','2013-09-21','09:55:00',4.83),('8902','2013-09-21','10:00:00',4.96),('8902','2013-09-21','10:05:00',5.11),('8902','2013-09-21','10:10:00',5.24),('8902','2013-09-21','10:15:00',5.38),('8902','2013-09-21','10:20:00',5.51),('8902','2013-09-21','10:25:00',5.64),('8902','2013-09-21','10:30:00',5.78),('8902','2013-09-21','10:35:00',5.9),('8902','2013-09-21','10:40:00',6.01),('8902','2013-09-21','10:45:00',6.11),('8902','2013-09-21','10:50:00',6.22),('8902','2013-09-21','10:55:00',6.29),('8902','2013-09-21','11:00:00',6.38),('8902','2013-09-21','11:05:00',6.48),('8902','2013-09-21','11:10:00',6.56),('8902','2013-09-21','11:15:00',6.67),('8902','2013-09-21','11:20:00',6.72),('8902','2013-09-21','11:25:00',6.79),('8902','2013-09-21','11:30:00',6.91),('8902','2013-09-21','11:35:00',7.03),('8902','2013-09-21','11:40:00',7.15),('8902','2013-09-21','11:45:00',7.22),('8902','2013-09-21','11:50:00',7.26),('8902','2013-09-21','11:55:00',7.36),('8902','2013-09-21','12:00:00',7.43),('8902','2013-09-21','12:05:00',7.47),('8902','2013-09-21','12:10:00',7.51),('8902','2013-09-21','12:15:00',7.52),('8902','2013-09-21','12:20:00',7.55),('8902','2013-09-21','12:25:00',7.61),('8902','2013-09-21','12:30:00',7.61),('8902','2013-09-21','12:35:00',7.63),('8902','2013-09-21','12:40:00',7.7),('8902','2013-09-21','12:45:00',7.62),('8902','2013-09-21','12:50:00',7.75),('8902','2013-09-21','12:55:00',7.84),('8902','2013-09-21','13:00:00',7.79),('8902','2013-09-21','13:05:00',7.76),('8902','2013-09-21','13:10:00',7.55),('8902','2013-09-21','13:15:00',7.17),('8902','2013-09-21','13:20:00',7.67),('8902','2013-09-21','13:25:00',7.63),('8902','2013-09-21','13:30:00',7.59),('8902','2013-09-21','13:35:00',7.61),('8902','2013-09-21','13:40:00',7.61),('8902','2013-09-21','13:45:00',7.59),('8902','2013-09-21','13:50:00',7.61),('8902','2013-09-21','13:55:00',7.4),('8902','2013-09-21','14:00:00',7.45),('8902','2013-09-21','14:05:00',7.53),('8902','2013-09-21','14:10:00',7.55),('8902','2013-09-21','14:15:00',7.52),('8902','2013-09-21','14:20:00',6.24),('8902','2013-09-21','14:25:00',7.3),('8902','2013-09-21','14:30:00',7.77),('8902','2013-09-21','14:35:00',7.3),('8902','2013-09-21','14:40:00',5.02),('8902','2013-09-21','14:45:00',6.66),('8902','2013-09-21','14:50:00',7.16),('8902','2013-09-21','14:55:00',7.09),('8902','2013-09-21','15:00:00',7.1),('8902','2013-09-21','15:05:00',7.22),('8902','2013-09-21','15:10:00',7.07),('8902','2013-09-21','15:15:00',7.23),('8902','2013-09-21','15:20:00',7.49),('8902','2013-09-21','15:25:00',4.67),('8902','2013-09-21','15:30:00',1.93),('8902','2013-09-21','15:35:00',1.95),('8902','2013-09-21','15:40:00',5.15),('8902','2013-09-21','15:45:00',6.32),('8902','2013-09-21','15:50:00',6.11),('8902','2013-09-21','15:55:00',6),('8902','2013-09-21','16:00:00',6.41),('8902','2013-09-21','16:05:00',6.4),('8902','2013-09-21','16:10:00',6.32),('8902','2013-09-21','16:15:00',6.23),('8902','2013-09-21','16:20:00',4.07),('8902','2013-09-21','16:25:00',3.01),('8902','2013-09-21','16:30:00',2.65),('8902','2013-09-21','16:35:00',1.85),('8902','2013-09-21','16:40:00',2.11),('8902','2013-09-21','16:45:00',4.1),('8902','2013-09-21','16:50:00',3.45),('8902','2013-09-21','16:55:00',3.39),('8902','2013-09-21','17:00:00',2.31),('8902','2013-09-21','17:05:00',3.8),('8902','2013-09-21','17:10:00',2.99),('8902','2013-09-21','17:15:00',2.48),('8902','2013-09-21','17:30:00',1.13),('8902','2013-09-21','17:35:00',1.94),('8902','2013-09-21','17:40:00',1.45),('8902','2013-09-21','18:00:00',1.12),('8902','2013-09-20','08:05:00',1.05),('8902','2013-09-20','08:10:00',1.21),('8902','2013-09-20','08:15:00',1.35),('8902','2013-09-20','08:20:00',1.51),('8902','2013-09-20','08:25:00',1.66),('8902','2013-09-20','08:30:00',1.83),('8902','2013-09-20','08:35:00',1.99),('8902','2013-09-20','08:40:00',2.18),('8902','2013-09-20','08:45:00',2.35),('8902','2013-09-20','08:50:00',2.52),('8902','2013-09-20','08:55:00',2.71),('8902','2013-09-20','09:00:00',2.89),('8902','2013-09-20','09:05:00',3.06),('8902','2013-09-20','09:10:00',3.23),('8902','2013-09-20','09:15:00',3.4),('8902','2013-09-20','09:20:00',3.57),('8902','2013-09-20','09:25:00',3.76),('8902','2013-09-20','09:30:00',3.93),('8902','2013-09-20','09:35:00',4.12),('8902','2013-09-20','09:40:00',4.28),('8902','2013-09-20','09:45:00',4.44),('8902','2013-09-20','09:50:00',4.59),('8902','2013-09-20','09:55:00',4.7),('8902','2013-09-20','10:00:00',4.85),('8902','2013-09-20','10:05:00',5),('8902','2013-09-20','10:10:00',5.15),('8902','2013-09-20','10:15:00',5.28),('8902','2013-09-20','10:20:00',5.4),('8902','2013-09-20','10:25:00',5.51),('8902','2013-09-20','10:30:00',5.6),('8902','2013-09-20','10:35:00',5.69),('8902','2013-09-20','10:40:00',5.82),('8902','2013-09-20','10:45:00',5.93),('8902','2013-09-20','10:50:00',6.03),('8902','2013-09-20','10:55:00',6.16),('8902','2013-09-20','11:00:00',6.26),('8902','2013-09-20','11:05:00',6.31),('8902','2013-09-20','11:10:00',6.42),('8902','2013-09-20','11:15:00',6.52),('8902','2013-09-20','11:20:00',6.62),('8902','2013-09-20','11:25:00',6.69),('8902','2013-09-20','11:30:00',6.77),('8902','2013-09-20','11:35:00',6.79),('8902','2013-09-20','11:40:00',6.86),('8902','2013-09-20','11:45:00',6.95),('8902','2013-09-20','11:50:00',7),('8902','2013-09-20','11:55:00',6.93),('8902','2013-09-20','12:00:00',7.07),('8902','2013-09-20','12:05:00',7.19),('8902','2013-09-20','12:10:00',7.21),('8902','2013-09-20','12:15:00',7.21),('8902','2013-09-20','12:20:00',7.26),('8902','2013-09-20','12:25:00',6.49),('8902','2013-09-20','12:30:00',7.49),('8902','2013-09-20','12:35:00',7.4),('8902','2013-09-20','12:40:00',6.88),('8902','2013-09-20','12:45:00',7.15),('8902','2013-09-20','12:50:00',7.32),('8902','2013-09-20','12:55:00',7.44),('8902','2013-09-20','13:00:00',7.45),('8902','2013-09-20','13:05:00',7.26),('8902','2013-09-20','13:10:00',7.47),('8902','2013-09-20','13:15:00',7.61),('8902','2013-09-20','13:20:00',6.35),('8902','2013-09-20','13:25:00',7.1),('8902','2013-09-20','13:30:00',7.22),('8902','2013-09-20','13:35:00',7.29),('8902','2013-09-20','13:40:00',6.47),('8902','2013-09-20','13:45:00',6.4),('8902','2013-09-20','13:50:00',6.69),('8902','2013-09-20','13:55:00',6.78),('8902','2013-09-20','14:00:00',6.84),('8902','2013-09-20','14:05:00',7.26),('8902','2013-09-20','14:10:00',6.93),('8902','2013-09-20','14:15:00',7.27),('8902','2013-09-20','14:20:00',7.25),('8902','2013-09-20','14:25:00',7.14),('8902','2013-09-20','14:30:00',7.06),('8902','2013-09-20','14:35:00',6.98),('8902','2013-09-20','14:40:00',6.91),('8902','2013-09-20','14:45:00',6.82),('8902','2013-09-20','14:50:00',6.77),('8902','2013-09-20','14:55:00',6.69),('8902','2013-09-20','15:00:00',6.61),('8902','2013-09-20','15:05:00',6.54),('8902','2013-09-20','15:10:00',6.36),('8902','2013-09-20','15:15:00',6.35),('8902','2013-09-20','15:20:00',6.32),('8902','2013-09-20','15:25:00',6.21),('8902','2013-09-20','15:30:00',6.1),('8902','2013-09-20','15:35:00',6),('8902','2013-09-20','15:40:00',5.56),('8902','2013-09-20','15:45:00',4.09),('8902','2013-09-20','15:50:00',5.44),('8902','2013-09-20','15:55:00',5.6),('8902','2013-09-20','16:00:00',4.39),('8902','2013-09-20','16:05:00',2.89),('8902','2013-09-20','16:10:00',3.39),('8902','2013-09-20','16:15:00',2.83),('8902','2013-09-20','16:20:00',3.71),('8902','2013-09-20','16:25:00',1.68),('8902','2013-09-20','16:30:00',2.33),('8902','2013-09-20','16:35:00',2.97),('8902','2013-09-20','16:40:00',2.17),('8902','2013-09-20','16:45:00',1.7),('8902','2013-09-20','16:50:00',1.76),('8902','2013-09-20','16:55:00',2.15),('8902','2013-09-20','17:00:00',1.78),('8902','2013-09-20','17:05:00',2.1),('8902','2013-09-20','17:10:00',2.01),('8902','2013-09-20','17:15:00',2.41),('8902','2013-09-20','17:20:00',1.46),('8902','2013-09-20','17:30:00',1.67),('8902','2013-09-20','17:35:00',2.23),('8902','2013-09-20','17:40:00',1.94),('8902','2013-09-20','17:45:00',2.09),('8902','2013-09-20','17:50:00',1.68),('8902','2013-09-20','17:55:00',1.53),('8902','2013-09-20','18:00:00',1.34),('8902','2013-09-20','18:05:00',1.14),('8902','2013-09-19','08:25:00',1.04),('8902','2013-09-19','08:30:00',1.16),('8902','2013-09-19','08:35:00',2.49),('8902','2013-09-19','08:40:00',2.83),('8902','2013-09-19','08:45:00',2.5),('8902','2013-09-19','08:50:00',1.79),('8902','2013-09-19','08:55:00',1.88),('8902','2013-09-19','09:00:00',2.1),('8902','2013-09-19','09:05:00',2.2),('8902','2013-09-19','09:10:00',2.12),('8902','2013-09-19','09:15:00',2.58),('8902','2013-09-19','09:20:00',2.56),('8902','2013-09-19','09:25:00',2.7),('8902','2013-09-19','09:30:00',2.4),('8902','2013-09-19','09:35:00',2.5),('8902','2013-09-19','09:40:00',2.31),('8902','2013-09-19','09:45:00',2.35),('8902','2013-09-19','09:50:00',2.46),('8902','2013-09-19','09:55:00',2.77),('8902','2013-09-19','10:00:00',3.1),('8902','2013-09-19','10:05:00',4.56),('8902','2013-09-19','10:10:00',4.25),('8902','2013-09-19','10:15:00',5.12),('8902','2013-09-19','10:20:00',6.56),('8902','2013-09-19','10:25:00',5.03),('8902','2013-09-19','10:30:00',5.07),('8902','2013-09-19','10:35:00',6.67),('8902','2013-09-19','10:40:00',6.31),('8902','2013-09-19','10:45:00',7.54),('8902','2013-09-19','10:50:00',6.49),('8902','2013-09-19','10:55:00',5.17),('8902','2013-09-19','11:00:00',3.71),('8902','2013-09-19','11:05:00',3.62),('8902','2013-09-19','11:10:00',3.74),('8902','2013-09-19','11:15:00',5.94),('8902','2013-09-19','11:20:00',4.68),('8902','2013-09-19','11:25:00',4.74),('8902','2013-09-19','11:30:00',4.14),('8902','2013-09-19','11:35:00',6.5),('8902','2013-09-19','11:40:00',5.16),('8902','2013-09-19','11:45:00',7.75),('8902','2013-09-19','11:50:00',7.67),('8902','2013-09-19','11:55:00',7.34),('8902','2013-09-19','12:00:00',7.27),('8902','2013-09-19','12:05:00',7.31),('8902','2013-09-19','12:10:00',7.39),('8902','2013-09-19','12:15:00',7.55),('8902','2013-09-19','12:20:00',7.76),('8902','2013-09-19','12:25:00',7.45),('8902','2013-09-19','12:30:00',8.1),('8902','2013-09-19','12:35:00',5.92),('8902','2013-09-19','12:40:00',6.47),('8902','2013-09-19','12:45:00',4.51),('8902','2013-09-19','12:50:00',6.31),('8902','2013-09-19','12:55:00',7.89),('8902','2013-09-19','13:00:00',7.34),('8902','2013-09-19','13:05:00',6.91),('8902','2013-09-19','13:10:00',7.58),('8902','2013-09-19','13:15:00',5.58),('8902','2013-09-19','13:20:00',4.75),('8902','2013-09-19','13:25:00',7.26),('8902','2013-09-19','13:30:00',7.97),('8902','2013-09-19','13:35:00',5.32),('8902','2013-09-19','13:40:00',7.02),('8902','2013-09-19','13:45:00',7.71),('8902','2013-09-19','13:50:00',7.44),('8902','2013-09-19','13:55:00',6.81),('8902','2013-09-19','14:00:00',7.38),('8902','2013-09-19','14:05:00',7.52),('8902','2013-09-19','14:10:00',7.2),('8902','2013-09-19','14:15:00',4.17),('8902','2013-09-19','14:20:00',2.45),('8902','2013-09-19','14:25:00',6.38),('8902','2013-09-19','14:30:00',7.86),('8902','2013-09-19','14:35:00',7.74),('8902','2013-09-19','14:40:00',7.5),('8902','2013-09-19','14:45:00',7.48),('8902','2013-09-19','14:50:00',7.54),('8902','2013-09-19','14:55:00',7.41),('8902','2013-09-19','15:00:00',5.3),('8902','2013-09-19','15:05:00',3.74),('8902','2013-09-19','15:10:00',6.09),('8902','2013-09-19','15:15:00',6.99),('8902','2013-09-19','15:20:00',5.56),('8902','2013-09-19','15:25:00',4.44),('8902','2013-09-19','15:30:00',6),('8902','2013-09-19','15:35:00',4.04),('8902','2013-09-19','15:40:00',5.08),('8902','2013-09-19','15:45:00',6.41),('8902','2013-09-19','15:50:00',6.23),('8902','2013-09-19','15:55:00',6.36),('8902','2013-09-19','16:00:00',3.94),('8902','2013-09-19','16:05:00',2.92),('8902','2013-09-19','16:10:00',4.13),('8902','2013-09-19','16:15:00',5.3),('8902','2013-09-19','16:20:00',2.88),('8902','2013-09-19','16:25:00',2.47),('8902','2013-09-19','16:30:00',1.55),('8902','2013-09-19','16:35:00',1.62),('8902','2013-09-19','16:40:00',1.85),('8902','2013-09-19','16:45:00',3.13),('8902','2013-09-19','16:50:00',4.63),('8902','2013-09-19','16:55:00',4.72),('8902','2013-09-19','17:00:00',4.3),('8902','2013-09-19','17:05:00',4.69),('8902','2013-09-19','17:10:00',4.57),('8902','2013-09-19','17:15:00',4.3),('8902','2013-09-19','17:20:00',4.06),('8902','2013-09-19','17:25:00',3.43),('8902','2013-09-19','17:30:00',3.01),('8902','2013-09-19','17:35:00',2.65),('8902','2013-09-19','17:40:00',2.34),('8902','2013-09-19','17:45:00',2.27),('8902','2013-09-19','17:50:00',1.99),('8902','2013-09-19','17:55:00',1.43),('8902','2013-09-19','18:00:00',1.83),('8902','2013-09-19','18:05:00',1.49),('8902','2013-09-19','18:10:00',1.69),('8902','2013-09-19','18:15:00',1.61),('8902','2013-09-19','18:20:00',1.14),('8902','2013-09-18','08:10:00',1.13),('8902','2013-09-18','08:15:00',1.49),('8902','2013-09-18','08:20:00',1.54),('8902','2013-09-18','08:25:00',1.51),('8902','2013-09-18','08:30:00',1.91),('8902','2013-09-18','08:35:00',2.18),('8902','2013-09-18','08:40:00',1.79),('8902','2013-09-18','08:45:00',2.25),('8902','2013-09-18','08:50:00',1.7),('8902','2013-09-18','08:55:00',2.2),('8902','2013-09-18','09:00:00',2.56),('8902','2013-09-18','09:05:00',1.86),('8902','2013-09-18','09:10:00',2.41),('8902','2013-09-18','09:15:00',2.86),('8902','2013-09-18','09:20:00',2.23),('8902','2013-09-18','09:25:00',2.11),('8902','2013-09-18','09:30:00',1.6),('8902','2013-09-18','09:35:00',1.65),('8902','2013-09-18','09:40:00',1.71),('8902','2013-09-18','09:45:00',1.44),('8902','2013-09-18','09:50:00',1.26),('8902','2013-09-18','09:55:00',1.3),('8902','2013-09-18','10:00:00',1.48),('8902','2013-09-18','10:05:00',3.2),('8902','2013-09-18','10:10:00',4.17),('8902','2013-09-18','10:15:00',4.09),('8902','2013-09-18','10:20:00',2),('8902','2013-09-18','10:25:00',2.26),('8902','2013-09-18','10:30:00',1.8),('8902','2013-09-18','10:35:00',4.5),('8902','2013-09-18','10:40:00',4.66),('8902','2013-09-18','10:45:00',5.59),('8902','2013-09-18','10:50:00',3.69),('8902','2013-09-18','10:55:00',4.96),('8902','2013-09-18','11:00:00',7.5),('8902','2013-09-18','11:05:00',7.98),('8902','2013-09-18','11:10:00',4.86),('8902','2013-09-18','11:15:00',3.43),('8902','2013-09-18','11:20:00',4.65),('8902','2013-09-18','11:25:00',3.63),('8902','2013-09-18','11:30:00',5.99),('8902','2013-09-18','11:35:00',4.14),('8902','2013-09-18','11:40:00',4.93),('8902','2013-09-18','11:45:00',5.34),('8902','2013-09-18','11:50:00',7.36),('8902','2013-09-18','11:55:00',7.85),('8902','2013-09-18','12:00:00',3.67),('8902','2013-09-18','12:05:00',2.88),('8902','2013-09-18','12:10:00',4.45),('8902','2013-09-18','12:15:00',4.89),('8902','2013-09-18','12:20:00',6.77),('8902','2013-09-18','12:25:00',8.69),('8902','2013-09-18','12:30:00',7.92),('8902','2013-09-18','12:35:00',7.84),('8902','2013-09-18','12:40:00',7.9),('8902','2013-09-18','12:45:00',6.26),('8902','2013-09-18','12:50:00',8.33),('8902','2013-09-18','12:55:00',8.12),('8902','2013-09-18','13:00:00',8.12),('8902','2013-09-18','13:05:00',8.09),('8902','2013-09-18','13:10:00',8.46),('8902','2013-09-18','13:15:00',8.55),('8902','2013-09-18','13:20:00',8.23),('8902','2013-09-18','13:25:00',6.06),('8902','2013-09-18','13:30:00',7.91),('8902','2013-09-18','13:35:00',8.2),('8902','2013-09-18','13:40:00',8.59),('8902','2013-09-18','13:45:00',8.82),('8902','2013-09-18','13:50:00',8.46),('8902','2013-09-18','13:55:00',4.2),('8902','2013-09-18','14:00:00',1.76),('8902','2013-09-18','14:05:00',5.5),('8902','2013-09-18','14:10:00',8.07),('8902','2013-09-18','14:15:00',7.69),('8902','2013-09-18','14:20:00',7.56),('8902','2013-09-18','14:25:00',7.43),('8902','2013-09-18','14:30:00',7.37),('8902','2013-09-18','14:35:00',7.3),('8902','2013-09-18','14:40:00',7.11),('8902','2013-09-18','14:45:00',6.99),('8902','2013-09-18','14:50:00',7.05),('8902','2013-09-18','14:55:00',6.86),('8902','2013-09-18','15:00:00',7.18),('8902','2013-09-18','15:05:00',6.61),('8902','2013-09-18','15:10:00',5.73),('8902','2013-09-18','15:15:00',6.44),('8902','2013-09-18','15:20:00',6.46),('8902','2013-09-18','15:25:00',6.45),('8902','2013-09-18','15:30:00',6.31),('8902','2013-09-18','15:35:00',4.27),('8902','2013-09-18','15:40:00',5.47),('8902','2013-09-18','15:45:00',6.52),('8902','2013-09-18','15:50:00',6.12),('8902','2013-09-18','15:55:00',5.54),('8902','2013-09-18','16:00:00',5.69),('8902','2013-09-18','16:05:00',5.61),('8902','2013-09-18','16:10:00',4.52),('8902','2013-09-18','16:15:00',4.95),('8902','2013-09-18','16:20:00',5.43),('8902','2013-09-18','16:25:00',5.3),('8902','2013-09-18','16:30:00',4.18),('8902','2013-09-18','16:35:00',3.7),('8902','2013-09-18','16:40:00',3.25),('8902','2013-09-18','16:45:00',2.47),('8902','2013-09-18','16:50:00',4.12),('8902','2013-09-18','16:55:00',4.29),('8902','2013-09-18','17:00:00',3.74),('8902','2013-09-18','17:05:00',3.51),('8902','2013-09-18','17:10:00',3.49),('8902','2013-09-18','17:15:00',3.24),('8902','2013-09-18','17:20:00',3.13),('8902','2013-09-18','17:25:00',2.55),('8902','2013-09-18','17:30:00',2.55),('8902','2013-09-18','17:35:00',2.18),('8902','2013-09-18','17:40:00',1.99),('8902','2013-09-18','17:45:00',1.79),('8902','2013-09-18','17:50:00',1.83),('8902','2013-09-18','17:55:00',1.71),('8902','2013-09-18','18:00:00',1.49),('8902','2013-09-18','18:05:00',1.37),('8902','2013-09-18','18:10:00',1.18),('8902','2013-09-18','18:15:00',1.13),('8902','2014-04-12','08:30:00',1.2),('8902','2014-04-12','08:35:00',1.2),('8902','2014-04-12','08:40:00',1.14),('8902','2014-04-12','08:45:00',1.24),('8902','2014-04-12','08:50:00',1.24),('8902','2014-04-12','08:55:00',1.37),('8902','2014-04-12','09:00:00',1.72),('8902','2014-04-12','09:05:00',2.21),('8902','2014-04-12','09:10:00',2.79),('8902','2014-04-12','09:15:00',2.48),('8902','2014-04-12','09:20:00',2.69),('8902','2014-04-12','09:25:00',3.15),('8902','2014-04-12','09:30:00',3.65),('8902','2014-04-12','09:35:00',2.71),('8902','2014-04-12','09:40:00',3.55),('8902','2014-04-12','09:45:00',3.31),('8902','2014-04-12','09:50:00',2.88),('8902','2014-04-12','09:55:00',2.9),('8902','2014-04-12','10:00:00',4.87),('8902','2014-04-12','10:05:00',6.81),('8902','2014-04-12','10:10:00',3.88),('8902','2014-04-12','10:15:00',4.23),('8902','2014-04-12','10:20:00',5.37),('8902','2014-04-12','10:25:00',3.43),('8902','2014-04-12','10:30:00',6.06),('8902','2014-04-12','10:35:00',6.7),('8902','2014-04-12','10:40:00',6.49),('8902','2014-04-12','10:45:00',6.82),('8902','2014-04-12','10:50:00',6.81),('8902','2014-04-12','10:55:00',6.91),('8902','2014-04-12','11:00:00',6.97),('8902','2014-04-12','11:05:00',7.08),('8902','2014-04-12','11:10:00',6.9),('8902','2014-04-12','11:15:00',6.14),('8902','2014-04-12','11:20:00',8.7),('8902','2014-04-12','11:25:00',5.36),('8902','2014-04-12','11:30:00',3.56),('8902','2014-04-12','11:35:00',4.8),('8902','2014-04-12','11:40:00',6.76),('8902','2014-04-12','11:45:00',6.43),('8902','2014-04-12','11:50:00',7.2),('8902','2014-04-12','11:55:00',5.62),('8902','2014-04-12','12:00:00',4.36),('8902','2014-04-12','12:05:00',3.26),('8902','2014-04-12','12:10:00',2.91),('8902','2014-04-12','12:15:00',2.68),('8902','2014-04-12','12:20:00',2.33),('8902','2014-04-12','12:25:00',1.72),('8902','2014-04-12','12:30:00',1.23),('8902','2014-04-12','12:45:00',1.06),('8902','2014-04-12','12:50:00',1.24),('8902','2014-04-12','12:55:00',1.4),('8902','2014-04-12','13:00:00',1.48),('8902','2014-04-12','13:05:00',2.44),('8902','2014-04-12','13:10:00',3.96),('8902','2014-04-12','13:15:00',3.65),('8902','2014-04-12','13:20:00',4.42),('8902','2014-04-12','13:25:00',5.8),('8902','2014-04-12','13:30:00',7.66),('8902','2014-04-12','13:35:00',7.97),('8902','2014-04-12','13:40:00',8.6),('8902','2014-04-12','13:45:00',4.37),('8902','2014-04-12','13:50:00',6.55),('8902','2014-04-12','13:55:00',6.32),('8902','2014-04-12','14:00:00',7.83),('8902','2014-04-12','14:05:00',6.27),('8902','2014-04-12','14:10:00',6.92),('8902','2014-04-12','14:15:00',7.4),('8902','2014-04-12','14:20:00',3.3),('8902','2014-04-12','14:25:00',3.02),('8902','2014-04-12','14:30:00',3.36),('8902','2014-04-12','14:35:00',3.11),('8902','2014-04-12','14:40:00',2.37),('8902','2014-04-12','14:45:00',3.68),('8902','2014-04-12','14:50:00',8.06),('8902','2014-04-12','14:55:00',3.08),('8902','2014-04-12','15:00:00',6.51),('8902','2014-04-12','15:05:00',7.43),('8902','2014-04-12','15:10:00',7.63),('8902','2014-04-12','15:15:00',6.94),('8902','2014-04-12','15:20:00',6.74),('8902','2014-04-12','15:25:00',7.03),('8902','2014-04-12','15:30:00',7.04),('8902','2014-04-12','15:35:00',4.64),('8902','2014-04-12','15:40:00',2.59),('8902','2014-04-12','15:45:00',2.59),('8902','2014-04-12','15:50:00',3.96),('8902','2014-04-12','15:55:00',4.35),('8902','2014-04-12','16:00:00',7.25),('8902','2014-04-12','16:05:00',5.95),('8902','2014-04-12','16:10:00',2.78),('8902','2014-04-12','16:15:00',2.66),('8902','2014-04-12','16:20:00',3.08),('8902','2014-04-12','16:25:00',3.37),('8902','2014-04-12','16:30:00',2.55),('8902','2014-04-12','16:35:00',3.36),('8902','2014-04-12','16:40:00',5.78),('8902','2014-04-12','16:45:00',6.5),('8902','2014-04-12','16:50:00',4.75),('8902','2014-04-12','16:55:00',5.19),('8902','2014-04-12','17:00:00',5.02),('8902','2014-04-12','17:05:00',3.58),('8902','2014-04-12','17:10:00',1.78),('8902','2014-04-12','17:15:00',1.85),('8902','2014-04-12','17:20:00',3.09),('8902','2014-04-12','17:25:00',2.34),('8902','2014-04-12','17:30:00',1.53),('8902','2014-04-12','17:35:00',1.28),('8902','2014-04-12','17:40:00',1.06),('8902','2014-04-12','17:45:00',1.43),('8902','2014-04-12','17:50:00',2.03),('8902','2014-04-12','17:55:00',2.07),('8902','2014-04-12','18:00:00',2.2),('8902','2014-04-12','18:05:00',1.45),('8902','2013-09-17','08:05:00',1.16),('8902','2013-09-17','08:10:00',1.32),('8902','2013-09-17','08:15:00',1.33),('8902','2013-09-17','08:25:00',1.46),('8902','2013-09-17','08:30:00',1.7),('8902','2013-09-17','08:35:00',1.53),('8902','2013-09-17','08:40:00',1.34),('8902','2013-09-17','08:45:00',2.76),('8902','2013-09-17','08:50:00',1.45),('8902','2013-09-17','08:55:00',1.55),('8902','2013-09-17','09:00:00',1.77),('8902','2013-09-17','09:05:00',2.5),('8902','2013-09-17','09:10:00',1.77),('8902','2013-09-17','09:15:00',1.76),('8902','2013-09-17','09:20:00',3.91),('8902','2013-09-17','09:25:00',2.87),('8902','2013-09-17','09:30:00',2.24),('8902','2013-09-17','09:35:00',3.88),('8902','2013-09-17','09:40:00',3.03),('8902','2013-09-17','09:45:00',2.44),('8902','2013-09-17','09:50:00',2.86),('8902','2013-09-17','09:55:00',4.45),('8902','2013-09-17','10:00:00',4.98),('8902','2013-09-17','10:05:00',5.86),('8902','2013-09-17','10:10:00',5.52),('8902','2013-09-17','10:15:00',5.44),('8902','2013-09-17','10:20:00',5.42),('8902','2013-09-17','10:25:00',5.52),('8902','2013-09-17','10:30:00',5.63),('8902','2013-09-17','10:35:00',5.7),('8902','2013-09-17','10:40:00',5.81),('8902','2013-09-17','10:45:00',5.91),('8902','2013-09-17','10:50:00',4.93),('8902','2013-09-17','10:55:00',5.66),('8902','2013-09-17','11:00:00',6.22),('8902','2013-09-17','11:05:00',5.67),('8902','2013-09-17','11:10:00',6.45),('8902','2013-09-17','11:15:00',4),('8902','2013-09-17','11:20:00',1.52),('8902','2013-09-17','11:25:00',4.55),('8902','2013-09-17','11:30:00',7.59),('8902','2013-09-17','11:35:00',7.2),('8902','2013-09-17','11:40:00',5.33),('8902','2013-09-17','11:45:00',5),('8902','2013-09-17','11:50:00',7.4),('8902','2013-09-17','11:55:00',7.43),('8902','2013-09-17','12:00:00',7.48),('8902','2013-09-17','12:05:00',7.61),('8902','2013-09-17','12:10:00',7.78),('8902','2013-09-17','12:15:00',7.76),('8902','2013-09-17','12:20:00',7.76),('8902','2013-09-17','12:25:00',7.95),('8902','2013-09-17','12:30:00',5.32),('8902','2013-09-17','12:35:00',6.53),('8902','2013-09-17','12:40:00',8.41),('8902','2013-09-17','12:45:00',5.85),('8902','2013-09-17','12:50:00',4.57),('8902','2013-09-17','12:55:00',7.95),('8902','2013-09-17','13:00:00',5.9),('8902','2013-09-17','13:05:00',6.16),('8902','2013-09-17','13:10:00',8.1),('8902','2013-09-17','13:15:00',8.09),('8902','2013-09-17','13:20:00',8.07),('8902','2013-09-17','13:25:00',7.65),('8902','2013-09-17','13:30:00',8.03),('8902','2013-09-17','13:35:00',7.86),('8902','2013-09-17','13:40:00',7.84),('8902','2013-09-17','13:45:00',7.89),('8902','2013-09-17','13:50:00',7.98),('8902','2013-09-17','13:55:00',7.26),('8902','2013-09-17','14:00:00',7.06),('8902','2013-09-17','14:05:00',7.26),('8902','2013-09-17','14:10:00',6.66),('8902','2013-09-17','14:15:00',7.64),('8902','2013-09-17','14:20:00',7.62),('8902','2013-09-17','14:25:00',7.48),('8902','2013-09-17','14:30:00',7.37),('8902','2013-09-17','14:35:00',7.33),('8902','2013-09-17','14:40:00',7.26),('8902','2013-09-17','14:45:00',7.16),('8902','2013-09-17','14:50:00',4.49),('8902','2013-09-17','14:55:00',7.09),('8902','2013-09-17','15:00:00',7.09),('8902','2013-09-17','15:05:00',7.12),('8902','2013-09-17','15:10:00',2.86),('8902','2013-09-17','15:15:00',4.18),('8902','2013-09-17','15:20:00',5.68),('8902','2013-09-17','15:25:00',4.9),('8902','2013-09-17','15:30:00',6.91),('8902','2013-09-17','15:35:00',6.68),('8902','2013-09-17','15:40:00',6.58),('8902','2013-09-17','15:45:00',6.2),('8902','2013-09-17','15:50:00',5.49),('8902','2013-09-17','15:55:00',3.84),('8902','2013-09-17','16:00:00',6.28),('8902','2013-09-17','16:05:00',6.28),('8902','2013-09-17','16:10:00',5.97),('8902','2013-09-17','16:15:00',5.53),('8902','2013-09-17','16:20:00',5.36),('8902','2013-09-17','16:25:00',4.73),('8902','2013-09-17','16:30:00',4.59),('8902','2013-09-17','16:35:00',4.25),('8902','2013-09-17','16:40:00',4.22),('8902','2013-09-17','16:45:00',4.33),('8902','2013-09-17','16:50:00',3.89),('8902','2013-09-17','16:55:00',3.64),('8902','2013-09-17','17:00:00',3.94),('8902','2013-09-17','17:05:00',3.47),('8902','2013-09-17','17:10:00',3.52),('8902','2013-09-17','17:15:00',3.35),('8902','2013-09-17','17:20:00',3.22),('8902','2013-09-17','17:25:00',2.53),('8902','2013-09-17','17:30:00',2.65),('8902','2013-09-17','17:35:00',2.66),('8902','2013-09-17','17:40:00',2.43),('8902','2013-09-17','17:45:00',2.18),('8902','2013-09-17','17:50:00',2.02),('8902','2013-09-17','17:55:00',1.82),('8902','2013-09-17','18:00:00',1.51),('8902','2013-09-17','18:05:00',1.24),('8902','2013-09-17','18:10:00',1.18),('8902','2013-09-17','18:15:00',1.03),('8902','2013-09-16','08:20:00',1),('8902','2013-09-16','08:40:00',1.25),('8902','2013-09-16','08:45:00',1.12),('8902','2013-09-16','08:50:00',1.22),('8902','2013-09-16','08:55:00',1.22),('8902','2013-09-16','09:00:00',1.35),('8902','2013-09-16','09:05:00',1.35),('8902','2013-09-16','09:10:00',1.33),('8902','2013-09-16','09:15:00',1.47),('8902','2013-09-16','09:20:00',2.33),('8902','2013-09-16','09:25:00',1.7),('8902','2013-09-16','09:30:00',2.11),('8902','2013-09-16','09:35:00',1.6),('8902','2013-09-16','09:40:00',2.41),('8902','2013-09-16','09:45:00',4.27),('8902','2013-09-16','09:50:00',2.91),('8902','2013-09-16','09:55:00',2.52),('8902','2013-09-16','10:00:00',4.29),('8902','2013-09-16','10:05:00',3.07),('8902','2013-09-16','10:10:00',3.5),('8902','2013-09-16','10:15:00',1.54),('8902','2013-09-16','10:20:00',1.46),('8902','2013-09-16','10:25:00',5.03),('8902','2013-09-16','10:30:00',6.53),('8902','2013-09-16','10:35:00',3.9),('8902','2013-09-16','10:40:00',4.04),('8902','2013-09-16','10:45:00',3.37),('8902','2013-09-16','10:50:00',7.26),('8902','2013-09-16','10:55:00',5.53),('8902','2013-09-16','11:00:00',4.27),('8902','2013-09-16','11:05:00',4.45),('8902','2013-09-16','11:10:00',6.23),('8902','2013-09-16','11:15:00',5.54),('8902','2013-09-16','11:20:00',4.64),('8902','2013-09-16','11:25:00',3.54),('8902','2013-09-16','11:30:00',3.52),('8902','2013-09-16','11:35:00',6.15),('8902','2013-09-16','11:40:00',6.91),('8902','2013-09-16','11:45:00',6.46),('8902','2013-09-16','11:50:00',6.27),('8902','2013-09-16','11:55:00',5.2),('8902','2013-09-16','12:00:00',7.27),('8902','2013-09-16','12:05:00',5.11),('8902','2013-09-16','12:10:00',3.6),('8902','2013-09-16','12:15:00',4.43),('8902','2013-09-16','12:20:00',3.74),('8902','2013-09-16','12:25:00',7.21),('8902','2013-09-16','12:30:00',6.48),('8902','2013-09-16','12:35:00',4.7),('8902','2013-09-16','12:40:00',6.18),('8902','2013-09-16','12:45:00',6.74),('8902','2013-09-16','12:50:00',6.47),('8902','2013-09-16','12:55:00',4.78),('8902','2013-09-16','13:00:00',4.88),('8902','2013-09-16','13:05:00',2.95),('8902','2013-09-16','13:10:00',4.8),('8902','2013-09-16','13:15:00',6.68),('8902','2013-09-16','13:20:00',4.7),('8902','2013-09-16','13:25:00',4.45),('8902','2013-09-16','13:30:00',3.76),('8902','2013-09-16','13:35:00',3.39),('8902','2013-09-16','13:40:00',4.75),('8902','2013-09-16','13:45:00',3.31),('8902','2013-09-16','13:50:00',1.84),('8902','2013-09-16','13:55:00',2.44),('8902','2013-09-16','14:00:00',4),('8902','2013-09-16','14:05:00',2.78),('8902','2013-09-16','14:10:00',1.89),('8902','2013-09-16','14:15:00',2.76),('8902','2013-09-16','14:20:00',1.88),('8902','2013-09-16','14:25:00',3.79),('8902','2013-09-16','14:30:00',2.29),('8902','2013-09-16','14:35:00',2.21),('8902','2013-09-16','14:40:00',1.76),('8902','2013-09-16','14:45:00',1.62),('8902','2013-09-16','14:50:00',2.39),('8902','2013-09-16','14:55:00',6.62),('8902','2013-09-16','15:00:00',7.05),('8902','2013-09-16','15:05:00',5.48),('8902','2013-09-16','15:10:00',5.42),('8902','2013-09-16','15:15:00',5.67),('8902','2013-09-16','15:20:00',6.13),('8902','2013-09-16','15:25:00',5.74),('8902','2013-09-16','15:30:00',5.1),('8902','2013-09-16','15:35:00',2.4),('8902','2013-09-16','15:40:00',1.75),('8902','2013-09-16','15:45:00',2.03),('8902','2013-09-16','15:50:00',3.73),('8902','2013-09-16','15:55:00',4.57),('8902','2013-09-16','16:00:00',2.44),('8902','2013-09-16','16:05:00',3.92),('8902','2013-09-16','16:10:00',3.23),('8902','2013-09-16','16:15:00',3.49),('8902','2013-09-16','16:20:00',2.22),('8902','2013-09-16','16:25:00',1.39),('8902','2013-09-16','16:35:00',1.34),('8902','2013-09-16','16:40:00',2.42),('8902','2013-09-16','16:45:00',2.85),('8902','2013-09-16','16:50:00',2.53),('8902','2013-09-16','16:55:00',1.87),('8902','2013-09-16','17:00:00',3.08),('8902','2013-09-16','17:05:00',3.46),('8902','2013-09-16','17:10:00',3.2),('8902','2013-09-16','17:15:00',3.37),('8902','2013-09-16','17:20:00',2.76),('8902','2013-09-16','17:25:00',2.46),('8902','2013-09-16','17:30:00',2.76),('8902','2013-09-16','17:35:00',1.91),('8902','2013-09-16','17:40:00',1.99),('8902','2013-09-16','17:45:00',1.35),('8902','2013-09-16','17:50:00',1.47),('8902','2013-09-16','17:55:00',1.48),('8902','2013-09-16','18:00:00',1.09),('8902','2013-09-16','18:05:00',1.29),('8902','2013-09-15','08:10:00',1.41),('8902','2013-09-15','08:15:00',1.62),('8902','2013-09-15','08:20:00',1.67),('8902','2013-09-15','08:25:00',1.79),('8902','2013-09-15','08:30:00',1.94),('8902','2013-09-15','08:35:00',2.15),('8902','2013-09-15','08:40:00',2.46),('8902','2013-09-15','08:45:00',2.33),('8902','2013-09-15','08:50:00',2.5),('8902','2013-09-15','08:55:00',1.54),('8902','2013-09-15','09:00:00',1.35),('8902','2013-09-15','09:05:00',2.65),('8902','2013-09-15','09:10:00',2.97),('8902','2013-09-15','09:15:00',3.89),('8902','2013-09-15','09:20:00',3.13),('8902','2013-09-15','09:25:00',3.87),('8902','2013-09-15','09:30:00',3.61),('8902','2013-09-15','09:35:00',3.56),('8902','2013-09-15','09:40:00',4.49),('8902','2013-09-15','09:45:00',4.61),('8902','2013-09-15','09:50:00',4.68),('8902','2013-09-15','09:55:00',4.95),('8902','2013-09-15','10:00:00',5.05),('8902','2013-09-15','10:05:00',5.26),('8902','2013-09-15','10:10:00',5.72),('8902','2013-09-15','10:15:00',2.34),('8902','2013-09-15','10:20:00',1.8),('8902','2013-09-15','10:25:00',3.81),('8902','2013-09-15','10:30:00',5.32),('8902','2013-09-15','10:35:00',6.53),('8902','2013-09-15','10:40:00',6.97),('8902','2013-09-15','10:45:00',7.4),('8902','2013-09-15','10:50:00',5.58),('8902','2013-09-15','10:55:00',1.27),('8902','2013-09-15','11:00:00',1.26),('8902','2013-09-15','11:05:00',3.36),('8902','2013-09-15','11:10:00',2.56),('8902','2013-09-15','11:15:00',1.56),('8902','2013-09-15','11:20:00',6.07),('8902','2013-09-15','11:25:00',4.81),('8902','2013-09-15','11:30:00',7.49),('8902','2013-09-15','11:35:00',7.35),('8902','2013-09-15','11:40:00',7.38),('8902','2013-09-15','11:45:00',6.87),('8902','2013-09-15','11:50:00',4.83),('8902','2013-09-15','11:55:00',7.81),('8902','2013-09-15','12:00:00',7.96),('8902','2013-09-15','12:05:00',8.22),('8902','2013-09-15','12:10:00',8.76),('8902','2013-09-15','12:15:00',7.66),('8902','2013-09-15','12:20:00',7.73),('8902','2013-09-15','12:25:00',7.68),('8902','2013-09-15','12:30:00',7.66),('8902','2013-09-15','12:35:00',7.75),('8902','2013-09-15','12:40:00',7.94),('8902','2013-09-15','12:45:00',8.42),('8902','2013-09-15','12:50:00',4.33),('8902','2013-09-15','12:55:00',7.05),('8902','2013-09-15','13:00:00',7.03),('8902','2013-09-15','13:05:00',6.62),('8902','2013-09-15','13:10:00',7.96),('8902','2013-09-15','13:15:00',7),('8902','2013-09-15','13:20:00',7.92),('8902','2013-09-15','13:25:00',7.83),('8902','2013-09-15','13:30:00',7.74),('8902','2013-09-15','13:35:00',7.79),('8902','2013-09-15','13:40:00',7.77),('8902','2013-09-15','13:45:00',7.72),('8902','2013-09-15','13:50:00',7.8),('8902','2013-09-15','13:55:00',7.99),('8902','2013-09-15','14:00:00',7.9),('8902','2013-09-15','14:05:00',7.41),('8902','2013-09-15','14:10:00',7.6),('8902','2013-09-15','14:15:00',7.51),('8902','2013-09-15','14:20:00',7.44),('8902','2013-09-15','14:25:00',7.36),('8902','2013-09-15','14:30:00',7.36),('8902','2013-09-15','14:35:00',7.29),('8902','2013-09-15','14:40:00',7.2),('8902','2013-09-15','14:45:00',7.15),('8902','2013-09-15','14:50:00',6.92),('8902','2013-09-15','14:55:00',6.82),('8902','2013-09-15','15:00:00',6.96),('8902','2013-09-15','15:05:00',6.96),('8902','2013-09-15','15:10:00',6.9),('8902','2013-09-15','15:15:00',6.82),('8902','2013-09-15','15:20:00',6.74),('8902','2013-09-15','15:25:00',6.66),('8902','2013-09-15','15:30:00',6.57),('8902','2013-09-15','15:35:00',6.44),('8902','2013-09-15','15:40:00',6.39),('8902','2013-09-15','15:45:00',6.3),('8902','2013-09-15','15:50:00',6.17),('8902','2013-09-15','15:55:00',6.04),('8902','2013-09-15','16:00:00',6.02),('8902','2013-09-15','16:05:00',4.88),('8902','2013-09-15','16:10:00',5.88),('8902','2013-09-15','16:15:00',5.54),('8902','2013-09-15','16:20:00',5.43),('8902','2013-09-15','16:25:00',5.26),('8902','2013-09-15','16:30:00',5.11),('8902','2013-09-15','16:35:00',4.93),('8902','2013-09-15','16:40:00',4.8),('8902','2013-09-15','16:45:00',4.66),('8902','2013-09-15','16:50:00',4.51),('8902','2013-09-15','16:55:00',4.25),('8902','2013-09-15','17:00:00',4.13),('8902','2013-09-15','17:05:00',3.97),('8902','2013-09-15','17:10:00',3.8),('8902','2013-09-15','17:15:00',3.6),('8902','2013-09-15','17:20:00',3.38),('8902','2013-09-15','17:25:00',3.19),('8902','2013-09-15','17:30:00',3.04),('8902','2013-09-15','17:35:00',2.74),('8902','2013-09-15','17:40:00',1.89),('8902','2013-09-15','17:45:00',2.12),('8902','2013-09-15','17:50:00',2.18),('8902','2013-09-15','17:55:00',1.9),('8902','2013-09-15','18:00:00',1.75),('8902','2013-09-15','18:05:00',1.58),('8902','2013-09-15','18:10:00',1.42),('8902','2013-09-15','18:15:00',1.23),('8902','2013-09-15','18:20:00',1.03),('8902','2013-09-14','08:00:00',1.06),('8902','2013-09-14','08:05:00',1.24),('8902','2013-09-14','08:10:00',1.42),('8902','2013-09-14','08:15:00',1.58),('8902','2013-09-14','08:20:00',1.74),('8902','2013-09-14','08:25:00',1.89),('8902','2013-09-14','08:30:00',2.05),('8902','2013-09-14','08:35:00',2.26),('8902','2013-09-14','08:40:00',2.48),('8902','2013-09-14','08:45:00',2.65),('8902','2013-09-14','08:50:00',2.73),('8902','2013-09-14','08:55:00',2.69),('8902','2013-09-14','09:00:00',2.93),('8902','2013-09-14','09:05:00',3.05),('8902','2013-09-14','09:10:00',3.35),('8902','2013-09-14','09:15:00',3.68),('8902','2013-09-14','09:20:00',3.65),('8902','2013-09-14','09:25:00',3.86),('8902','2013-09-14','09:30:00',3.98),('8902','2013-09-14','09:35:00',4.29),('8902','2013-09-14','09:40:00',4.42),('8902','2013-09-14','09:45:00',4.49),('8902','2013-09-14','09:50:00',4.67),('8902','2013-09-14','09:55:00',4.82),('8902','2013-09-14','10:00:00',5.05),('8902','2013-09-14','10:05:00',5.19),('8902','2013-09-14','10:10:00',5.24),('8902','2013-09-14','10:15:00',5.11),('8902','2013-09-14','10:20:00',5.27),('8902','2013-09-14','10:25:00',5.52),('8902','2013-09-14','10:30:00',5.21),('8902','2013-09-14','10:35:00',4.43),('8902','2013-09-14','10:40:00',2.68),('8902','2013-09-14','10:45:00',2.3),('8902','2013-09-14','10:50:00',1.85),('8902','2013-09-14','10:55:00',1.44),('8902','2013-09-14','11:00:00',3.5),('8902','2013-09-14','11:05:00',7.26),('8902','2013-09-14','11:10:00',7.19),('8902','2013-09-14','11:15:00',3.56),('8902','2013-09-14','11:20:00',2.78),('8902','2013-09-14','11:25:00',2.14),('8902','2013-09-14','11:30:00',2.1),('8902','2013-09-14','11:35:00',6.62),('8902','2013-09-14','11:40:00',3.74),('8902','2013-09-14','11:45:00',2.26),('8902','2013-09-14','11:50:00',4.14),('8902','2013-09-14','11:55:00',2.98),('8902','2013-09-14','12:00:00',2.46),('8902','2013-09-14','12:05:00',2.32),('8902','2013-09-14','12:10:00',2.18),('8902','2013-09-14','12:15:00',2.18),('8902','2013-09-14','12:20:00',2.54),('8902','2013-09-14','12:25:00',3.03),('8902','2013-09-14','12:30:00',3.24),('8902','2013-09-14','12:35:00',3.28),('8902','2013-09-14','12:40:00',3.26),('8902','2013-09-14','12:45:00',2.47),('8902','2013-09-14','12:50:00',2.46),('8902','2013-09-14','12:55:00',2.53),('8902','2013-09-14','13:00:00',2.39),('8902','2013-09-14','13:05:00',2.22),('8902','2013-09-14','13:10:00',1.74),('8902','2013-09-14','13:15:00',1.3),('8902','2013-09-14','13:20:00',1.22),('8902','2013-09-14','13:25:00',1.7),('8902','2013-09-14','13:30:00',1.87),('8902','2013-09-14','13:35:00',2.41),('8902','2013-09-14','13:40:00',2.73),('8902','2013-09-14','13:45:00',3.46),('8902','2013-09-14','13:50:00',3.8),('8902','2013-09-14','13:55:00',2.62),('8902','2013-09-14','14:00:00',3.48),('8902','2013-09-14','14:05:00',3.27),('8902','2013-09-14','14:10:00',2.84),('8902','2013-09-14','14:15:00',2.55),('8902','2013-09-14','14:20:00',2.37),('8902','2013-09-14','14:25:00',2.38),('8902','2013-09-14','14:30:00',2.4),('8902','2013-09-14','14:35:00',2.06),('8902','2013-09-14','14:40:00',2.07),('8902','2013-09-14','14:45:00',1.78),('8902','2013-09-14','14:50:00',1.84),('8902','2013-09-14','14:55:00',2.01),('8902','2013-09-14','15:00:00',2.06),('8902','2013-09-14','15:05:00',2.21),('8902','2013-09-14','15:10:00',2.53),('8902','2013-09-14','15:15:00',5.45),('8902','2013-09-14','15:20:00',4.39),('8902','2013-09-14','15:25:00',2.94),('8902','2013-09-14','15:30:00',2.17),('8902','2013-09-14','15:35:00',2.06),('8902','2013-09-14','15:40:00',1.91),('8902','2013-09-14','15:45:00',1.84),('8902','2013-09-14','15:50:00',1.85),('8902','2013-09-14','15:55:00',1.86),('8902','2013-09-14','16:00:00',1.58),('8902','2013-09-14','16:05:00',1.83),('8902','2013-09-14','16:10:00',1.51),('8902','2013-09-14','16:15:00',1.04),('8902','2013-09-14','16:25:00',1.02),('8902','2013-09-14','16:30:00',1.3),('8902','2013-09-14','16:35:00',1.28),('8902','2013-09-14','16:40:00',1.53),('8902','2013-09-14','16:45:00',1.31),('8902','2013-09-14','17:00:00',1.09),('8902','2013-09-14','17:05:00',1.11),('8902','2013-09-14','17:15:00',1.13),('8902','2013-09-14','17:20:00',1.46),('8902','2013-09-14','17:25:00',1.14),('8902','2013-09-14','17:30:00',1.1),('8902','2013-09-14','18:00:00',1.15),('8902','2013-09-13','08:00:00',1.01),('8902','2013-09-13','08:05:00',1.17),('8902','2013-09-13','08:10:00',1.35),('8902','2013-09-13','08:15:00',1.5),('8902','2013-09-13','08:20:00',1.67),('8902','2013-09-13','08:25:00',1.82),('8902','2013-09-13','08:30:00',1.98),('8902','2013-09-13','08:35:00',2.16),('8902','2013-09-13','08:40:00',2.34),('8902','2013-09-13','08:45:00',2.52),('8902','2013-09-13','08:50:00',2.67),('8902','2013-09-13','08:55:00',2.84),('8902','2013-09-13','09:00:00',3.03),('8902','2013-09-13','09:05:00',3.21),('8902','2013-09-13','09:10:00',3.39),('8902','2013-09-13','09:15:00',3.58),('8902','2013-09-13','09:20:00',3.74),('8902','2013-09-13','09:25:00',3.91),('8902','2013-09-13','09:30:00',4.12),('8902','2013-09-13','09:35:00',4.25),('8902','2013-09-13','09:40:00',4.39),('8902','2013-09-13','09:45:00',4.55),('8902','2013-09-13','09:50:00',4.53),('8902','2013-09-13','09:55:00',4.76),('8902','2013-09-13','10:00:00',4.85),('8902','2013-09-13','10:05:00',5.09),('8902','2013-09-13','10:10:00',4.78),('8902','2013-09-13','10:15:00',5.01),('8902','2013-09-13','10:20:00',5.36),('8902','2013-09-13','10:25:00',5.59),('8902','2013-09-13','10:30:00',5.58),('8902','2013-09-13','10:35:00',5.65),('8902','2013-09-13','10:40:00',6.14),('8902','2013-09-13','10:45:00',6.7),('8902','2013-09-13','10:50:00',6.41),('8902','2013-09-13','10:55:00',7.01),('8902','2013-09-13','11:00:00',7.27),('8902','2013-09-13','11:05:00',5.49),('8902','2013-09-13','11:10:00',3.09),('8902','2013-09-13','11:15:00',1.56),('8902','2013-09-13','11:20:00',1.19),('8902','2013-09-13','11:25:00',3.7),('8902','2013-09-13','11:30:00',7.34),('8902','2013-09-13','11:35:00',6.64),('8902','2013-09-13','11:40:00',4.23),('8902','2013-09-13','11:45:00',6.76),('8902','2013-09-13','11:50:00',6.48),('8902','2013-09-13','11:55:00',7.97),('8902','2013-09-13','12:00:00',7.02),('8902','2013-09-13','12:05:00',7.71),('8902','2013-09-13','12:10:00',4.74),('8902','2013-09-13','12:15:00',6.74),('8902','2013-09-13','12:20:00',2.37),('8902','2013-09-13','12:25:00',1.25),('8902','2013-09-13','12:30:00',1.4),('8902','2013-09-13','12:35:00',2.64),('8902','2013-09-13','12:40:00',7.46),('8902','2013-09-13','12:45:00',3.7),('8902','2013-09-13','12:50:00',1.98),('8902','2013-09-13','12:55:00',1.75),('8902','2013-09-13','13:00:00',1.95),('8902','2013-09-13','13:05:00',1.44),('8902','2013-09-13','13:10:00',1.52),('8902','2013-09-13','13:15:00',4.67),('8902','2013-09-13','13:20:00',8.35),('8902','2013-09-13','13:25:00',5.13),('8902','2013-09-13','13:30:00',8.8),('8902','2013-09-13','13:35:00',4.41),('8902','2013-09-13','13:40:00',2.74),('8902','2013-09-13','13:45:00',3.68),('8902','2013-09-13','13:50:00',4.57),('8902','2013-09-13','13:55:00',8.66),('8902','2013-09-13','14:00:00',8.61),('8902','2013-09-13','14:05:00',7.93),('8902','2013-09-13','14:10:00',7.82),('8902','2013-09-13','14:15:00',7.74),('8902','2013-09-13','14:20:00',7.2),('8902','2013-09-13','14:25:00',7.44),('8902','2013-09-13','14:30:00',7.65),('8902','2013-09-13','14:35:00',7.17),('8902','2013-09-13','14:40:00',7.38),('8902','2013-09-13','14:45:00',7.18),('8902','2013-09-13','14:50:00',7.24),('8902','2013-09-13','14:55:00',7.15),('8902','2013-09-13','15:00:00',7.08),('8902','2013-09-13','15:05:00',6.91),('8902','2013-09-13','15:10:00',6.81),('8902','2013-09-13','15:15:00',6.72),('8902','2013-09-13','15:20:00',6.69),('8902','2013-09-13','15:25:00',6.73),('8902','2013-09-13','15:30:00',5.69),('8902','2013-09-13','15:35:00',6.44),('8902','2013-09-13','15:40:00',6.31),('8902','2013-09-13','15:45:00',6.23),('8902','2013-09-13','15:50:00',6.12),('8902','2013-09-13','15:55:00',5.99),('8902','2013-09-13','16:00:00',5.86),('8902','2013-09-13','16:05:00',5.69),('8902','2013-09-13','16:10:00',5.57),('8902','2013-09-13','16:15:00',5.4),('8902','2013-09-13','16:20:00',5.31),('8902','2013-09-13','16:25:00',5.11),('8902','2013-09-13','16:30:00',5.08),('8902','2013-09-13','16:35:00',4.91),('8902','2013-09-13','16:40:00',4.7),('8902','2013-09-13','16:45:00',4.58),('8902','2013-09-13','16:50:00',4.42),('8902','2013-09-13','16:55:00',4.24),('8902','2013-09-13','17:00:00',3.8),('8902','2013-09-13','17:05:00',3.97),('8902','2013-09-13','17:10:00',3.61),('8902','2013-09-13','17:15:00',3.47),('8902','2013-09-13','17:20:00',3.26),('8902','2013-09-13','17:25:00',3.21),('8902','2013-09-13','17:30:00',2.95),('8902','2013-09-13','17:35:00',2.75),('8902','2013-09-13','17:40:00',2.45),('8902','2013-09-13','17:45:00',2.43),('8902','2013-09-13','17:50:00',2.25),('8902','2013-09-13','17:55:00',2.05),('8902','2013-09-13','18:00:00',1.56),('8902','2013-09-13','18:05:00',1.26),('8902','2013-09-13','18:10:00',1.47),('8902','2013-09-13','18:15:00',1.31),('8902','2013-09-13','18:20:00',1.11),('8902','2013-09-12','08:15:00',1.09),('8902','2013-09-12','08:20:00',1.33),('8902','2013-09-12','08:25:00',1.5),('8902','2013-09-12','08:30:00',1.73),('8902','2013-09-12','08:35:00',1.31),('8902','2013-09-12','08:40:00',1.35),('8902','2013-09-12','08:45:00',1.58),('8902','2013-09-12','08:50:00',1.77),('8902','2013-09-12','08:55:00',1.95),('8902','2013-09-12','09:00:00',1.87),('8902','2013-09-12','09:05:00',1.82),('8902','2013-09-12','09:10:00',1.81),('8902','2013-09-12','09:15:00',1.9),('8902','2013-09-12','09:20:00',1.93),('8902','2013-09-12','09:25:00',2.1),('8902','2013-09-12','09:30:00',2.28),('8902','2013-09-12','09:35:00',2.49),('8902','2013-09-12','09:40:00',2.71),('8902','2013-09-12','09:45:00',2.62),('8902','2013-09-12','09:50:00',2.71),('8902','2013-09-12','09:55:00',5.14),('8902','2013-09-12','10:00:00',5.02),('8902','2013-09-12','10:05:00',2.7),('8902','2013-09-12','10:10:00',2.92),('8902','2013-09-12','10:15:00',6.39),('8902','2013-09-12','10:20:00',6.79),('8902','2013-09-12','10:25:00',4.23),('8902','2013-09-12','10:30:00',3.53),('8902','2013-09-12','10:35:00',6.26),('8902','2013-09-12','10:40:00',6.1),('8902','2013-09-12','10:45:00',6.17),('8902','2013-09-12','10:50:00',6.25),('8902','2013-09-12','10:55:00',6.34),('8902','2013-09-12','11:00:00',6.45),('8902','2013-09-12','11:05:00',6.54),('8902','2013-09-12','11:10:00',6.6),('8902','2013-09-12','11:15:00',6.72),('8902','2013-09-12','11:20:00',6.81),('8902','2013-09-12','11:25:00',6.85),('8902','2013-09-12','11:30:00',6.94),('8902','2013-09-12','11:35:00',7),('8902','2013-09-12','11:40:00',7.06),('8902','2013-09-12','11:45:00',7.17),('8902','2013-09-12','11:50:00',7.23),('8902','2013-09-12','11:55:00',7.28),('8902','2013-09-12','12:00:00',7.31),('8902','2013-09-12','12:05:00',7.44),('8902','2013-09-12','12:10:00',7.51),('8902','2013-09-12','12:15:00',7.48),('8902','2013-09-12','12:20:00',7.55),('8902','2013-09-12','12:25:00',7.7),('8902','2013-09-12','12:30:00',7.82),('8902','2013-09-12','12:35:00',7.69),('8902','2013-09-12','12:40:00',7.75),('8902','2013-09-12','12:45:00',7.71),('8902','2013-09-12','12:50:00',7.79),('8902','2013-09-12','12:55:00',7.78),('8902','2013-09-12','13:00:00',7.71),('8902','2013-09-12','13:05:00',7.67),('8902','2013-09-12','13:10:00',7.66),('8902','2013-09-12','13:15:00',7.64),('8902','2013-09-12','13:20:00',7.62),('8902','2013-09-12','13:25:00',7.64),('8902','2013-09-12','13:30:00',7.64),('8902','2013-09-12','13:35:00',7.6),('8902','2013-09-12','13:40:00',7.6),('8902','2013-09-12','13:45:00',7.58),('8902','2013-09-12','13:50:00',7.56),('8902','2013-09-12','13:55:00',7.53),('8902','2013-09-12','14:00:00',7.52),('8902','2013-09-12','14:05:00',7.51),('8902','2013-09-12','14:10:00',7.43),('8902','2013-09-12','14:15:00',7.33),('8902','2013-09-12','14:20:00',7.27),('8902','2013-09-12','14:25:00',7.31),('8902','2013-09-12','14:30:00',7.34),('8902','2013-09-12','14:35:00',7.25),('8902','2013-09-12','14:40:00',7.22),('8902','2013-09-12','14:45:00',7.15),('8902','2013-09-12','14:50:00',7.26),('8902','2013-09-12','14:55:00',6.09),('8902','2013-09-12','15:00:00',6.89),('8902','2013-09-12','15:05:00',6.8),('8902','2013-09-12','15:10:00',6.83),('8902','2013-09-12','15:15:00',6.84),('8902','2013-09-12','15:20:00',6.71),('8902','2013-09-12','15:25:00',6.58),('8902','2013-09-12','15:30:00',6.54),('8902','2013-09-12','15:35:00',6.44),('8902','2013-09-12','15:40:00',6.35),('8902','2013-09-12','15:45:00',6.27),('8902','2013-09-12','15:50:00',6.15),('8902','2013-09-12','15:55:00',6.03),('8902','2013-09-12','16:00:00',5.91),('8902','2013-09-12','16:05:00',5.81),('8902','2013-09-12','16:10:00',5.7),('8902','2013-09-12','16:15:00',5.53),('8902','2013-09-12','16:20:00',5.4),('8902','2013-09-12','16:25:00',5.27),('8902','2013-09-12','16:30:00',5.12),('8902','2013-09-12','16:35:00',5.01),('8902','2013-09-12','16:40:00',4.75),('8902','2013-09-12','16:45:00',4.59),('8902','2013-09-12','16:50:00',4.47),('8902','2013-09-12','16:55:00',4.28),('8902','2013-09-12','17:00:00',4.07),('8902','2013-09-12','17:05:00',3.95),('8902','2013-09-12','17:10:00',3.78),('8902','2013-09-12','17:15:00',3.59),('8902','2013-09-12','17:20:00',3.37),('8902','2013-09-12','17:25:00',3.2),('8902','2013-09-12','17:30:00',2.97),('8902','2013-09-12','17:35:00',2.82),('8902','2013-09-12','17:40:00',2.64),('8902','2013-09-12','17:45:00',2.44),('8902','2013-09-12','17:50:00',2.23),('8902','2013-09-12','17:55:00',2.04),('8902','2013-09-12','18:00:00',1.86),('8902','2013-09-12','18:05:00',1.66),('8902','2013-09-12','18:10:00',1.47),('8902','2013-09-12','18:15:00',1.3),('8902','2013-09-12','18:20:00',1.13),('8902','2013-09-11','07:55:00',1.16),('8902','2013-09-11','08:00:00',1.54),('8902','2013-09-11','08:05:00',1.31),('8902','2013-09-11','08:10:00',1),('8902','2013-09-11','08:15:00',1.89),('8902','2013-09-11','08:20:00',1.96),('8902','2013-09-11','08:25:00',2.39),('8902','2013-09-11','08:30:00',2.73),('8902','2013-09-11','08:35:00',2.58),('8902','2013-09-11','08:40:00',1.99),('8902','2013-09-11','08:45:00',1.37),('8902','2013-09-11','08:50:00',1.21),('8902','2013-09-11','08:55:00',2.69),('8902','2013-09-11','09:00:00',3.08),('8902','2013-09-11','09:05:00',3.04),('8902','2013-09-11','09:10:00',2.55),('8902','2013-09-11','09:15:00',3.62),('8902','2013-09-11','09:20:00',3.66),('8902','2013-09-11','09:25:00',4.01),('8902','2013-09-11','09:30:00',4.36),('8902','2013-09-11','09:35:00',3.74),('8902','2013-09-11','09:40:00',3.58),('8902','2013-09-11','09:45:00',3.83),('8902','2013-09-11','09:50:00',4.73),('8902','2013-09-11','09:55:00',3.32),('8902','2013-09-11','10:00:00',2.14),('8902','2013-09-11','10:05:00',2.67),('8902','2013-09-11','10:10:00',3.2),('8902','2013-09-11','10:15:00',3.03),('8902','2013-09-11','10:20:00',2.41),('8902','2013-09-11','10:25:00',1.71),('8902','2013-09-11','10:30:00',2.78),('8902','2013-09-11','10:35:00',3.51),('8902','2013-09-11','10:40:00',1.63),('8902','2013-09-11','10:50:00',1.09),('8902','2013-09-11','10:55:00',3.79),('8902','2013-09-11','11:00:00',4.39),('8902','2013-09-11','11:05:00',4.94),('8902','2013-09-11','11:10:00',4.62),('8902','2013-09-11','11:15:00',5.36),('8902','2013-09-11','11:20:00',2.52),('8902','2013-09-11','11:40:00',1.83),('8902','2013-09-11','11:45:00',4.95),('8902','2013-09-11','11:50:00',3.12),('8902','2013-09-11','11:55:00',4.65),('8902','2013-09-11','12:00:00',6.39),('8902','2013-09-11','12:05:00',7.46),('8902','2013-09-11','12:10:00',6.36),('8902','2013-09-11','12:15:00',5.37),('8902','2013-09-11','12:20:00',2.81),('8902','2013-09-11','12:25:00',3.56),('8902','2013-09-11','12:30:00',3.04),('8902','2013-09-11','12:35:00',5.34),('8902','2013-09-11','12:40:00',7.14),('8902','2013-09-11','12:45:00',2.29),('8902','2013-09-11','12:50:00',3.83),('8902','2013-09-11','12:55:00',3.97),('8902','2013-09-11','13:00:00',8.15),('8902','2013-09-11','13:05:00',5.3),('8902','2013-09-11','13:10:00',6.53),('8902','2013-09-11','13:15:00',8.51),('8902','2013-09-11','13:20:00',8.96),('8902','2013-09-11','13:25:00',9.02),('8902','2013-09-11','13:30:00',7.3),('8902','2013-09-11','13:35:00',6.52),('8902','2013-09-11','13:40:00',5.28),('8902','2013-09-11','13:45:00',6.82),('8902','2013-09-11','13:50:00',8.07),('8902','2013-09-11','13:55:00',7.98),('8902','2013-09-11','14:00:00',8.08),('8902','2013-09-11','14:05:00',7.69),('8902','2013-09-11','14:10:00',6.3),('8902','2013-09-11','14:15:00',7.83),('8902','2013-09-11','14:20:00',7.71),('8902','2013-09-11','14:25:00',8.05),('8902','2013-09-11','14:30:00',7.79),('8902','2013-09-11','14:35:00',6.35),('8902','2013-09-11','14:40:00',5.39),('8902','2013-09-11','14:45:00',7.64),('8902','2013-09-11','14:50:00',7.44),('8902','2013-09-11','14:55:00',7.29),('8902','2013-09-11','15:00:00',7.28),('8902','2013-09-11','15:05:00',5.57),('8902','2013-09-11','15:10:00',6.42),('8902','2013-09-11','15:15:00',6.1),('8902','2013-09-11','15:20:00',6.89),('8902','2013-09-11','15:25:00',6.62),('8902','2013-09-11','15:30:00',6.75),('8902','2013-09-11','15:35:00',6.6),('8902','2013-09-11','15:40:00',6.51),('8902','2013-09-11','15:45:00',6.51),('8902','2013-09-11','15:50:00',6.37),('8902','2013-09-11','15:55:00',6.22),('8902','2013-09-11','16:00:00',6.23),('8902','2013-09-11','16:05:00',5.51),('8902','2013-09-11','16:10:00',4.97),('8902','2013-09-11','16:15:00',4.23),('8902','2013-09-11','16:20:00',4.33),('8902','2013-09-11','16:25:00',4.43),('8902','2013-09-11','16:30:00',3.03),('8902','2013-09-11','16:35:00',2.83),('8902','2013-09-11','16:40:00',3.79),('8902','2013-09-11','16:45:00',5.35),('8902','2013-09-11','16:50:00',1.88),('8902','2013-09-11','16:55:00',3.69),('8902','2013-09-11','17:00:00',2.47),('8902','2013-09-11','17:05:00',4.01),('8902','2013-09-11','17:10:00',3.02),('8902','2013-09-11','17:15:00',4.03),('8902','2013-09-11','17:20:00',2.49),('8902','2013-09-11','17:25:00',1.48),('8902','2013-09-11','17:30:00',2.99),('8902','2013-09-11','17:35:00',3.24),('8902','2013-09-11','17:40:00',2.91),('8902','2013-09-11','17:45:00',2.8),('8902','2013-09-11','17:50:00',2.4),('8902','2013-09-11','17:55:00',2.21),('8902','2013-09-11','18:00:00',1.7),('8902','2013-09-11','18:10:00',1.03),('8902','2013-09-11','18:15:00',1.48),('8902','2013-09-11','18:20:00',1.25),('8902','2013-09-10','08:05:00',1.62),('8902','2013-09-10','08:10:00',1.82),('8902','2013-09-10','08:15:00',1.8),('8902','2013-09-10','08:20:00',1.24),('8902','2013-09-10','08:25:00',1.08),('8902','2013-09-10','08:30:00',1.54),('8902','2013-09-10','08:35:00',1.38),('8902','2013-09-10','08:40:00',1.35),('8902','2013-09-10','08:45:00',1.21),('8902','2013-09-10','08:50:00',1.67),('8902','2013-09-10','08:55:00',1.8),('8902','2013-09-10','09:00:00',3.51),('8902','2013-09-10','09:05:00',3.18),('8902','2013-09-10','09:10:00',3.51),('8902','2013-09-10','09:15:00',3.65),('8902','2013-09-10','09:20:00',3.79),('8902','2013-09-10','09:25:00',3.92),('8902','2013-09-10','09:30:00',2.82),('8902','2013-09-10','09:35:00',3.39),('8902','2013-09-10','09:40:00',3.32),('8902','2013-09-10','09:45:00',1.46),('8902','2013-09-10','09:50:00',1.63),('8902','2013-09-10','09:55:00',1.64),('8902','2013-09-10','10:00:00',2.01),('8902','2013-09-10','10:05:00',5.39),('8902','2013-09-10','10:15:00',2.54),('8902','2013-09-10','10:20:00',5.8),('8902','2013-09-10','10:25:00',4.45),('8902','2013-09-10','10:30:00',4.29),('8902','2013-09-10','10:35:00',5.8),('8902','2013-09-10','10:40:00',6.9),('8902','2013-09-10','10:45:00',5.26),('8902','2013-09-10','10:50:00',5.88),('8902','2013-09-10','10:55:00',3.48),('8902','2013-09-10','11:00:00',2.92),('8902','2013-09-10','11:05:00',5.49),('8902','2013-09-10','11:10:00',7.53),('8902','2013-09-10','11:15:00',5.48),('8902','2013-09-10','11:20:00',7.58),('8902','2013-09-10','11:25:00',6.44),('8902','2013-09-10','11:30:00',1.27),('8902','2013-09-10','11:35:00',5.85),('8902','2013-09-10','11:40:00',4.55),('8902','2013-09-10','11:45:00',7.6),('8902','2013-09-10','11:50:00',7.6),('8902','2013-09-10','11:55:00',7.08),('8902','2013-09-10','12:00:00',5.72),('8902','2013-09-10','12:05:00',7.36),('8902','2013-09-10','12:10:00',4.13),('8902','2013-09-10','12:15:00',4.75),('8902','2013-09-10','12:20:00',5.24),('8902','2013-09-10','12:25:00',4.31),('8902','2013-09-10','12:30:00',8.08),('8902','2013-09-10','12:35:00',4.39),('8902','2013-09-10','12:40:00',3.33),('8902','2013-09-10','12:45:00',6),('8902','2013-09-10','12:50:00',7.99),('8902','2013-09-10','12:55:00',8.03),('8902','2013-09-10','13:00:00',7.22),('8902','2013-09-10','13:05:00',8.12),('8902','2013-09-10','13:10:00',8.08),('8902','2013-09-10','13:15:00',8.36),('8902','2013-09-10','13:20:00',8.54),('8902','2013-09-10','13:25:00',8.01),('8902','2013-09-10','13:30:00',7.35),('8902','2013-09-10','13:35:00',4.24),('8902','2013-09-10','13:40:00',7.65),('8902','2013-09-10','13:45:00',4.7),('8902','2013-09-10','13:50:00',8.66),('8902','2013-09-10','13:55:00',5.23),('8902','2013-09-10','14:00:00',6.74),('8902','2013-09-10','14:05:00',8.08),('8902','2013-09-10','14:10:00',4.56),('8902','2013-09-10','14:15:00',7.52),('8902','2013-09-10','14:20:00',6.08),('8902','2013-09-10','14:25:00',7.8),('8902','2013-09-10','14:30:00',7.75),('8902','2013-09-10','14:35:00',7.11),('8902','2013-09-10','14:40:00',3.95),('8902','2013-09-10','14:45:00',6.89),('8902','2013-09-10','14:50:00',6.56),('8902','2013-09-10','14:55:00',5.41),('8902','2013-09-10','15:00:00',6.68),('8902','2013-09-10','15:05:00',7.09),('8902','2013-09-10','15:10:00',5.37),('8902','2013-09-10','15:15:00',6.75),('8902','2013-09-10','15:20:00',7.82),('8902','2013-09-10','15:25:00',3.98),('8902','2013-09-10','15:30:00',5.23),('8902','2013-09-10','15:35:00',1.83),('8902','2013-09-10','15:40:00',2.39),('8902','2013-09-10','15:45:00',5.01),('8902','2013-09-10','15:50:00',6.04),('8902','2013-09-10','15:55:00',6.24),('8902','2013-09-10','16:00:00',6.07),('8902','2013-09-10','16:05:00',4.94),('8902','2013-09-10','16:10:00',6.13),('8902','2013-09-10','16:15:00',5.97),('8902','2013-09-10','16:20:00',5.51),('8902','2013-09-10','16:25:00',4.17),('8902','2013-09-10','16:30:00',5.07),('8902','2013-09-10','16:35:00',4.03),('8902','2013-09-10','16:40:00',3.11),('8902','2013-09-10','16:45:00',5.05),('8902','2013-09-10','16:50:00',4.2),('8902','2013-09-10','16:55:00',4.09),('8902','2013-09-10','17:00:00',3.14),('8902','2013-09-10','17:05:00',4.15),('8902','2013-09-10','17:10:00',3.95),('8902','2013-09-10','17:15:00',3.73),('8902','2013-09-10','17:20:00',3.54),('8902','2013-09-10','17:25:00',3.35),('8902','2013-09-10','17:30:00',3.11),('8902','2013-09-10','17:35:00',2.96),('8902','2013-09-10','17:40:00',2.8),('8902','2013-09-10','17:45:00',2.4),('8902','2013-09-10','17:50:00',2.44),('8902','2013-09-10','17:55:00',1.76),('8902','2013-09-10','18:00:00',2.12),('8902','2013-09-10','18:05:00',1.83),('8902','2013-09-10','18:10:00',1.59),('8902','2013-09-10','18:15:00',1.44),('8902','2013-09-10','18:20:00',1.01),('8902','2013-09-10','18:25:00',1.07),('8902','2013-09-09','07:55:00',1.16),('8902','2013-09-09','08:00:00',1.28),('8902','2013-09-09','08:05:00',1.11),('8902','2013-09-09','08:10:00',1.29),('8902','2013-09-09','08:15:00',1.52),('8902','2013-09-09','08:20:00',1.27),('8902','2013-09-09','08:25:00',1.05),('8902','2013-09-09','08:40:00',1.15),('8902','2013-09-09','08:45:00',1.42),('8902','2013-09-09','08:50:00',1.48),('8902','2013-09-09','08:55:00',2.79),('8902','2013-09-09','09:00:00',3.04),('8902','2013-09-09','09:05:00',3.53),('8902','2013-09-09','09:10:00',4.14),('8902','2013-09-09','09:15:00',3.58),('8902','2013-09-09','09:20:00',2.62),('8902','2013-09-09','09:25:00',2.74),('8902','2013-09-09','09:30:00',4.58),('8902','2013-09-09','09:35:00',5.33),('8902','2013-09-09','09:40:00',3.15),('8902','2013-09-09','09:45:00',2.59),('8902','2013-09-09','09:50:00',2.36),('8902','2013-09-09','09:55:00',2.19),('8902','2013-09-09','10:00:00',1.63),('8902','2013-09-09','10:05:00',1.44),('8902','2013-09-09','10:10:00',1.26),('8902','2013-09-09','10:15:00',1.19),('8902','2013-09-09','10:20:00',1.73),('8902','2013-09-09','10:25:00',1.88),('8902','2013-09-09','10:30:00',1.92),('8902','2013-09-09','10:35:00',2.2),('8902','2013-09-09','10:40:00',2.85),('8902','2013-09-09','10:45:00',3.78),('8902','2013-09-09','10:50:00',2.4),('8902','2013-09-09','10:55:00',2.46),('8902','2013-09-09','11:00:00',2.91),('8902','2013-09-09','11:05:00',2.42),('8902','2013-09-09','11:10:00',2.59),('8902','2013-09-09','11:15:00',2.29),('8902','2013-09-09','11:20:00',2.46),('8902','2013-09-09','11:25:00',2.85),('8902','2013-09-09','11:30:00',2.13),('8902','2013-09-09','11:35:00',1.49),('8902','2013-09-09','11:40:00',1.59),('8902','2013-09-09','11:45:00',2.41),('8902','2013-09-09','11:50:00',2.45),('8902','2013-09-09','11:55:00',3.11),('8902','2013-09-09','12:00:00',2.47),('8902','2013-09-09','12:05:00',2.03),('8902','2013-09-09','12:10:00',1.89),('8902','2013-09-09','12:15:00',1.9),('8902','2013-09-09','12:20:00',2.09),('8902','2013-09-09','12:25:00',2.06),('8902','2013-09-09','12:30:00',1.71),('8902','2013-09-09','12:35:00',1.66),('8902','2013-09-09','12:40:00',1.35),('8902','2013-09-09','12:45:00',1.21),('8902','2013-09-09','12:50:00',1.14),('8902','2013-09-09','12:55:00',1.04),('8902','2013-09-09','13:00:00',1.22),('8902','2013-09-09','13:05:00',1.12),('8902','2013-09-09','13:10:00',1.08),('8902','2013-09-09','13:15:00',1.59),('8902','2013-09-09','13:20:00',1.7),('8902','2013-09-09','13:25:00',2),('8902','2013-09-09','13:30:00',1.87),('8902','2013-09-09','13:35:00',1.99),('8902','2013-09-09','13:40:00',3.37),('8902','2013-09-09','13:45:00',5.48),('8902','2013-09-09','13:50:00',3.56),('8902','2013-09-09','13:55:00',2.93),('8902','2013-09-09','14:00:00',2.08),('8902','2013-09-09','14:05:00',2.23),('8902','2013-09-09','14:10:00',2.52),('8902','2013-09-09','14:15:00',3.07),('8902','2013-09-09','14:20:00',2.76),('8902','2013-09-09','14:25:00',4.18),('8902','2013-09-09','14:30:00',3.85),('8902','2013-09-09','14:35:00',2.87),('8902','2013-09-09','14:40:00',3.52),('8902','2013-09-09','14:45:00',3.61),('8902','2013-09-09','14:50:00',4.15),('8902','2013-09-09','14:55:00',3.85),('8902','2013-09-09','15:00:00',4.75),('8902','2013-09-09','15:05:00',4.58),('8902','2013-09-09','15:10:00',3.23),('8902','2013-09-09','15:15:00',3.13),('8902','2013-09-09','15:20:00',4),('8902','2013-09-09','15:25:00',3.51),('8902','2013-09-09','15:30:00',4.03),('8902','2013-09-09','15:35:00',3.63),('8902','2013-09-09','15:40:00',2.3),('8902','2013-09-09','15:45:00',2.02),('8902','2013-09-09','15:50:00',1.97),('8902','2013-09-09','15:55:00',1.92),('8902','2013-09-09','16:00:00',1.97),('8902','2013-09-09','16:05:00',2.24),('8902','2013-09-09','16:10:00',2.5),('8902','2013-09-09','16:15:00',2.83),('8902','2013-09-09','16:20:00',2.06),('8902','2013-09-09','16:25:00',1.87),('8902','2013-09-09','16:30:00',1.51),('8902','2013-09-09','16:45:00',1.08),('8902','2013-09-09','16:50:00',1.44),('8902','2013-09-09','16:55:00',1.47),('8902','2013-09-09','17:00:00',1.29),('8902','2013-09-09','17:05:00',1.18),('8902','2013-09-09','17:10:00',1.31),('8902','2013-09-09','17:15:00',1.53),('8902','2013-09-09','17:20:00',1.57),('8902','2013-09-09','17:25:00',1.51),('8902','2013-09-09','17:30:00',1.33),('8902','2013-09-09','17:35:00',1.09),('8902','2013-09-09','17:40:00',1.01),('8902','2013-09-09','17:45:00',1.27),('8902','2013-09-09','17:50:00',1.44),('8902','2013-09-09','17:55:00',1.22),('8902','2013-09-09','18:00:00',1.04),('8902','2013-09-08','07:35:00',1.08),('8902','2013-09-08','07:40:00',1.36),('8902','2013-09-08','07:45:00',1.54),('8902','2013-09-08','07:50:00',1.61),('8902','2013-09-08','07:55:00',1.55),('8902','2013-09-08','08:00:00',1.45),('8902','2013-09-08','08:05:00',1.13),('8902','2013-09-08','08:10:00',1.05),('8902','2013-09-08','08:15:00',1.02),('8902','2013-09-08','08:20:00',1.06),('8902','2013-09-08','08:25:00',1.12),('8902','2013-09-08','08:30:00',1.11),('8902','2013-09-08','08:35:00',1.07),('8902','2013-09-08','08:40:00',1.25),('8902','2013-09-08','08:45:00',1.62),('8902','2013-09-08','08:50:00',1.83),('8902','2013-09-08','08:55:00',2.11),('8902','2013-09-08','09:00:00',2.24),('8902','2013-09-08','09:05:00',2.08),('8902','2013-09-08','09:10:00',1.72),('8902','2013-09-08','09:15:00',1.15),('8902','2013-09-08','09:20:00',1.37),('8902','2013-09-08','09:25:00',1.31),('8902','2013-09-08','09:30:00',1.34),('8902','2013-09-08','09:35:00',1.97),('8902','2013-09-08','09:40:00',1.94),('8902','2013-09-08','09:45:00',1.56),('8902','2013-09-08','09:50:00',1.51),('8902','2013-09-08','09:55:00',1.55),('8902','2013-09-08','10:00:00',2.53),('8902','2013-09-08','10:05:00',2.94),('8902','2013-09-08','10:10:00',3.42),('8902','2013-09-08','10:15:00',3.37),('8902','2013-09-08','10:20:00',2.54),('8902','2013-09-08','10:25:00',2.31),('8902','2013-09-08','10:30:00',2.87),('8902','2013-09-08','10:35:00',3.31),('8902','2013-09-08','10:40:00',3.35),('8902','2013-09-08','10:45:00',3.59),('8902','2013-09-08','10:50:00',4.69),('8902','2013-09-08','10:55:00',4.64),('8902','2013-09-08','11:00:00',5.12),('8902','2013-09-08','11:05:00',4.15),('8902','2013-09-08','11:10:00',3.31),('8902','2013-09-08','11:15:00',3.66),('8902','2013-09-08','11:20:00',4.01),('8902','2013-09-08','11:25:00',5.18),('8902','2013-09-08','11:30:00',4.17),('8902','2013-09-08','11:35:00',3.87),('8902','2013-09-08','11:40:00',4.9),('8902','2013-09-08','11:45:00',6.67),('8902','2013-09-08','11:50:00',6.8),('8902','2013-09-08','11:55:00',4.9),('8902','2013-09-08','12:00:00',5.35),('8902','2013-09-08','12:05:00',6.36),('8902','2013-09-08','12:10:00',4.97),('8902','2013-09-08','12:15:00',3.54),('8902','2013-09-08','12:20:00',3.52),('8902','2013-09-08','12:25:00',2.69),('8902','2013-09-08','12:30:00',2.42),('8902','2013-09-08','12:35:00',2.18),('8902','2013-09-08','12:40:00',2.69),('8902','2013-09-08','12:45:00',3.62),('8902','2013-09-08','12:50:00',2.56),('8902','2013-09-08','12:55:00',3.01),('8902','2013-09-08','13:00:00',3.03),('8902','2013-09-08','13:05:00',4.55),('8902','2013-09-08','13:10:00',6.16),('8902','2013-09-08','13:15:00',6),('8902','2013-09-08','13:20:00',3.21),('8902','2013-09-08','13:25:00',4.38),('8902','2013-09-08','13:30:00',4.54),('8902','2013-09-08','13:35:00',7.77),('8902','2013-09-08','13:40:00',7.44),('8902','2013-09-08','13:45:00',7.51),('8902','2013-09-08','13:50:00',7.41),('8902','2013-09-08','13:55:00',7.82),('8902','2013-09-08','14:00:00',7.26),('8902','2013-09-08','14:05:00',6.78),('8902','2013-09-08','14:10:00',6.1),('8902','2013-09-08','14:15:00',5.25),('8902','2013-09-08','14:20:00',4.53),('8902','2013-09-08','14:25:00',3.44),('8902','2013-09-08','14:30:00',3.41),('8902','2013-09-08','14:35:00',7.42),('8902','2013-09-08','14:40:00',5.74),('8902','2013-09-08','14:45:00',3.51),('8902','2013-09-08','14:50:00',5.8),('8902','2013-09-08','14:55:00',6.4),('8902','2013-09-08','15:00:00',5.49),('8902','2013-09-08','15:05:00',4.94),('8902','2013-09-08','15:10:00',6.52),('8902','2013-09-08','15:15:00',3.4),('8902','2013-09-08','15:20:00',3.96),('8902','2013-09-08','15:25:00',2.3),('8902','2013-09-08','15:30:00',5.54),('8902','2013-09-08','15:35:00',4.63),('8902','2013-09-08','15:40:00',4.47),('8902','2013-09-08','15:45:00',2.19),('8902','2013-09-08','15:50:00',2.14),('8902','2013-09-08','15:55:00',2.54),('8902','2013-09-08','16:00:00',3.12),('8902','2013-09-08','16:05:00',2.47),('8902','2013-09-08','16:10:00',3.13),('8902','2013-09-08','16:15:00',4.44),('8902','2013-09-08','16:20:00',3.78),('8902','2013-09-08','16:25:00',2.01),('8902','2013-09-08','16:30:00',2.05),('8902','2013-09-08','16:35:00',2.22),('8902','2013-09-08','16:40:00',2.42),('8902','2013-09-08','16:45:00',4.37),('8902','2013-09-08','16:50:00',1.71),('8902','2013-09-08','16:55:00',1.32),('8902','2013-09-08','17:00:00',1.82),('8902','2013-09-08','17:05:00',1.65),('8902','2013-09-08','17:10:00',1.57),('8902','2013-09-08','17:15:00',1.11),('8902','2013-09-08','17:35:00',1.15),('8902','2013-09-08','17:40:00',1.22),('8902','2013-09-08','18:10:00',1.3),('8902','2013-09-08','18:15:00',1.77),('8902','2013-09-08','18:20:00',1.5),('8902','2013-09-08','18:25:00',1.1),('8902','2013-09-08','18:30:00',1.04),('8902','2014-04-11','08:10:00',1.2),('8902','2014-04-11','08:15:00',1.43),('8902','2014-04-11','08:20:00',1.45),('8902','2014-04-11','08:25:00',1.79),('8902','2014-04-11','08:30:00',1.35),('8902','2014-04-11','08:35:00',1.07),('8902','2014-04-11','08:40:00',1.15),('8902','2014-04-11','08:45:00',1.13),('8902','2014-04-11','08:50:00',1.22),('8902','2014-04-11','08:55:00',1.25),('8902','2014-04-11','09:00:00',1.26),('8902','2014-04-11','09:05:00',1.49),('8902','2014-04-11','09:10:00',1.88),('8902','2014-04-11','09:15:00',2.44),('8902','2014-04-11','09:20:00',2.91),('8902','2014-04-11','09:25:00',4.32),('8902','2014-04-11','09:30:00',2.83),('8902','2014-04-11','09:35:00',2.66),('8902','2014-04-11','09:40:00',2.28),('8902','2014-04-11','09:45:00',2.13),('8902','2014-04-11','09:50:00',2.01),('8902','2014-04-11','09:55:00',1.97),('8902','2014-04-11','10:00:00',1.99),('8902','2014-04-11','10:05:00',2.15),('8902','2014-04-11','10:10:00',2.36),('8902','2014-04-11','10:15:00',2.64),('8902','2014-04-11','10:20:00',2.9),('8902','2014-04-11','10:25:00',3.3),('8902','2014-04-11','10:30:00',3.75),('8902','2014-04-11','10:35:00',4.16),('8902','2014-04-11','10:40:00',4.84),('8902','2014-04-11','10:45:00',4.99),('8902','2014-04-11','10:50:00',4.73),('8902','2014-04-11','10:55:00',3.67),('8902','2014-04-11','11:00:00',5.21),('8902','2014-04-11','11:05:00',6.03),('8902','2014-04-11','11:10:00',7.41),('8902','2014-04-11','11:15:00',7.9),('8902','2014-04-11','11:20:00',7.51),('8902','2014-04-11','11:25:00',7.05),('8902','2014-04-11','11:30:00',6.15),('8902','2014-04-11','11:35:00',6.66),('8902','2014-04-11','11:40:00',7.2),('8902','2014-04-11','11:45:00',7.35),('8902','2014-04-11','11:50:00',6.19),('8902','2014-04-11','11:55:00',3.74),('8902','2014-04-11','12:00:00',3.72),('8902','2014-04-11','12:05:00',4.07),('8902','2014-04-11','12:10:00',3.2),('8902','2014-04-11','12:15:00',3.19),('8902','2014-04-11','12:20:00',3.23),('8902','2014-04-11','12:25:00',3.38),('8902','2014-04-11','12:30:00',5.16),('8902','2014-04-11','12:35:00',4.9),('8902','2014-04-11','12:40:00',5.53),('8902','2014-04-11','12:45:00',6.11),('8902','2014-04-11','12:50:00',6.16),('8902','2014-04-11','12:55:00',3.84),('8902','2014-04-11','13:00:00',2.57),('8902','2014-04-11','13:05:00',2.94),('8902','2014-04-11','13:10:00',5.32),('8902','2014-04-11','13:15:00',7.73),('8902','2014-04-11','13:20:00',8.39),('8902','2014-04-11','13:25:00',8.41),('8902','2014-04-11','13:30:00',6.62),('8902','2014-04-11','13:35:00',3.55),('8902','2014-04-11','13:40:00',3.5),('8902','2014-04-11','13:45:00',2.76),('8902','2014-04-11','13:50:00',3.22),('8902','2014-04-11','13:55:00',2.94),('8902','2014-04-11','14:00:00',2.66),('8902','2014-04-11','14:05:00',3.9),('8902','2014-04-11','14:10:00',6.08),('8902','2014-04-11','14:15:00',8.25),('8902','2014-04-11','14:20:00',5.77),('8902','2014-04-11','14:25:00',8.2),('8902','2014-04-11','14:30:00',6.75),('8902','2014-04-11','14:35:00',5.48),('8902','2014-04-11','14:40:00',5.35),('8902','2014-04-11','14:45:00',5.83),('8902','2014-04-11','14:50:00',7.76),('8902','2014-04-11','14:55:00',7.53),('8902','2014-04-11','15:00:00',6.96),('8902','2014-04-11','15:05:00',7.2),('8902','2014-04-11','15:10:00',7.23),('8902','2014-04-11','15:15:00',7.3),('8902','2014-04-11','15:20:00',6.18),('8902','2014-04-11','15:25:00',5.74),('8902','2014-04-11','15:30:00',4.04),('8902','2014-04-11','15:35:00',5.21),('8902','2014-04-11','15:40:00',6.04),('8902','2014-04-11','15:45:00',6.27),('8902','2014-04-11','15:50:00',7.16),('8902','2014-04-11','15:55:00',6.89),('8902','2014-04-11','16:00:00',6.86),('8902','2014-04-11','16:05:00',6.82),('8902','2014-04-11','16:10:00',6.75),('8902','2014-04-11','16:15:00',6.21),('8902','2014-04-11','16:20:00',6.67),('8902','2014-04-11','16:25:00',5.99),('8902','2014-04-11','16:30:00',5.8),('8902','2014-04-11','16:35:00',5.64),('8902','2014-04-11','16:40:00',3.83),('8902','2014-04-11','16:45:00',3.55),('8902','2014-04-11','16:50:00',2.7),('8902','2014-04-11','16:55:00',3.82),('8902','2014-04-11','17:00:00',4.94),('8902','2014-04-11','17:05:00',4.54),('8902','2014-04-11','17:10:00',4.43),('8902','2014-04-11','17:15:00',4.18),('8902','2014-04-11','17:20:00',3.45),('8902','2014-04-11','17:25:00',3.53),('8902','2014-04-11','17:30:00',2.38),('8902','2014-04-11','17:35:00',2.17),('8902','2014-04-11','17:40:00',2.14),('8902','2014-04-11','17:45:00',2.96),('8902','2014-04-11','17:50:00',3.39),('8902','2014-04-11','17:55:00',2.4),('8902','2014-04-11','18:00:00',2.91),('8902','2014-04-11','18:05:00',2.35),('8902','2014-04-11','18:10:00',1.02),('8902','2014-04-11','18:15:00',1.55),('8902','2014-04-11','18:20:00',1.18),('8902','2013-09-07','08:00:00',1.17),('8902','2013-09-07','08:20:00',1.04),('8902','2013-09-07','08:25:00',1.21),('8902','2013-09-07','08:30:00',1.31),('8902','2013-09-07','08:35:00',1.22),('8902','2013-09-07','08:40:00',1.47),('8902','2013-09-07','08:45:00',1.53),('8902','2013-09-07','08:50:00',1.71),('8902','2013-09-07','08:55:00',1.68),('8902','2013-09-07','09:00:00',1.95),('8902','2013-09-07','09:05:00',2.07),('8902','2013-09-07','09:10:00',2.06),('8902','2013-09-07','09:15:00',2.62),('8902','2013-09-07','09:20:00',2.09),('8902','2013-09-07','09:25:00',2.66),('8902','2013-09-07','09:30:00',3.24),('8902','2013-09-07','09:35:00',4.2),('8902','2013-09-07','09:40:00',3.24),('8902','2013-09-07','09:45:00',3.89),('8902','2013-09-07','09:50:00',4.36),('8902','2013-09-07','09:55:00',4.48),('8902','2013-09-07','10:00:00',4.65),('8902','2013-09-07','10:05:00',4.8),('8902','2013-09-07','10:10:00',4.77),('8902','2013-09-07','10:15:00',4.97),('8902','2013-09-07','10:20:00',5.09),('8902','2013-09-07','10:25:00',5.19),('8902','2013-09-07','10:30:00',5.19),('8902','2013-09-07','10:35:00',5.39),('8902','2013-09-07','10:40:00',5.54),('8902','2013-09-07','10:45:00',5.64),('8902','2013-09-07','10:50:00',5.8),('8902','2013-09-07','10:55:00',5.91),('8902','2013-09-07','11:00:00',6),('8902','2013-09-07','11:05:00',5.99),('8902','2013-09-07','11:10:00',5.95),('8902','2013-09-07','11:15:00',6.08),('8902','2013-09-07','11:20:00',5.3),('8902','2013-09-07','11:25:00',5.99),('8902','2013-09-07','11:30:00',6.32),('8902','2013-09-07','11:35:00',6.42),('8902','2013-09-07','11:40:00',6.44),('8902','2013-09-07','11:45:00',6.51),('8902','2013-09-07','11:50:00',6.45),('8902','2013-09-07','11:55:00',6.5),('8902','2013-09-07','12:00:00',6.4),('8902','2013-09-07','12:05:00',6.36),('8902','2013-09-07','12:10:00',6.42),('8902','2013-09-07','12:15:00',6.62),('8902','2013-09-07','12:20:00',6.67),('8902','2013-09-07','12:25:00',6.71),('8902','2013-09-07','12:30:00',6.74),('8902','2013-09-07','12:35:00',6.92),('8902','2013-09-07','12:40:00',6.53),('8902','2013-09-07','12:45:00',6.36),('8902','2013-09-07','12:50:00',6.74),('8902','2013-09-07','12:55:00',6.88),('8902','2013-09-07','13:00:00',6.87),('8902','2013-09-07','13:05:00',6.95),('8902','2013-09-07','13:10:00',6.95),('8902','2013-09-07','13:15:00',6.82),('8902','2013-09-07','13:20:00',6.75),('8902','2013-09-07','13:25:00',6.61),('8902','2013-09-07','13:30:00',6.25),('8902','2013-09-07','13:35:00',6.1),('8902','2013-09-07','13:40:00',4.83),('8902','2013-09-07','13:45:00',3.97),('8902','2013-09-07','13:50:00',4.93),('8902','2013-09-07','13:55:00',5.29),('8902','2013-09-07','14:00:00',6.35),('8902','2013-09-07','14:05:00',6.49),('8902','2013-09-07','14:10:00',6.95),('8902','2013-09-07','14:15:00',6.34),('8902','2013-09-07','14:20:00',6.43),('8902','2013-09-07','14:25:00',7.59),('8902','2013-09-07','14:30:00',6.7),('8902','2013-09-07','14:35:00',7.09),('8902','2013-09-07','14:40:00',6.89),('8902','2013-09-07','14:45:00',6.85),('8902','2013-09-07','14:50:00',6.82),('8902','2013-09-07','14:55:00',6.67),('8902','2013-09-07','15:00:00',6.7),('8902','2013-09-07','15:05:00',5.82),('8902','2013-09-07','15:10:00',3.64),('8902','2013-09-07','15:15:00',4.88),('8902','2013-09-07','15:20:00',6.35),('8902','2013-09-07','15:25:00',6.41),('8902','2013-09-07','15:30:00',6.55),('8902','2013-09-07','15:35:00',6.32),('8902','2013-09-07','15:40:00',5.9),('8902','2013-09-07','15:45:00',5.92),('8902','2013-09-07','15:50:00',6),('8902','2013-09-07','15:55:00',4.85),('8902','2013-09-07','16:00:00',4.95),('8902','2013-09-07','16:05:00',5.03),('8902','2013-09-07','16:10:00',4.79),('8902','2013-09-07','16:15:00',4.88),('8902','2013-09-07','16:20:00',4.76),('8902','2013-09-07','16:25:00',4.75),('8902','2013-09-07','16:30:00',4.48),('8902','2013-09-07','16:35:00',4.51),('8902','2013-09-07','16:40:00',3.9),('8902','2013-09-07','16:45:00',2.45),('8902','2013-09-07','16:50:00',2.59),('8902','2013-09-07','16:55:00',2.36),('8902','2013-09-07','17:00:00',2.57),('8902','2013-09-07','17:05:00',4.02),('8902','2013-09-07','17:10:00',3.93),('8902','2013-09-07','17:15:00',3.59),('8902','2013-09-07','17:20:00',3.11),('8902','2013-09-07','17:25:00',3.07),('8902','2013-09-07','17:30:00',2.82),('8902','2013-09-07','17:35:00',1.63),('8902','2013-09-07','17:40:00',1.48),('8902','2013-09-07','17:45:00',2.16),('8902','2013-09-07','17:50:00',2.14),('8902','2013-09-07','17:55:00',1.99),('8902','2013-09-07','18:00:00',1.76),('8902','2013-09-07','18:05:00',1.47),('8902','2013-09-07','18:10:00',1.29),('8902','2013-09-07','18:15:00',1.08),('8902','2013-09-06','08:00:00',1.07),('8902','2013-09-06','08:05:00',1.22),('8902','2013-09-06','08:10:00',1.38),('8902','2013-09-06','08:15:00',1.53),('8902','2013-09-06','08:20:00',1.68),('8902','2013-09-06','08:25:00',1.84),('8902','2013-09-06','08:30:00',2.01),('8902','2013-09-06','08:35:00',2.14),('8902','2013-09-06','08:40:00',2.08),('8902','2013-09-06','08:45:00',2.41),('8902','2013-09-06','08:50:00',2.58),('8902','2013-09-06','08:55:00',2.75),('8902','2013-09-06','09:00:00',2.9),('8902','2013-09-06','09:05:00',3.06),('8902','2013-09-06','09:10:00',3.26),('8902','2013-09-06','09:15:00',3.45),('8902','2013-09-06','09:20:00',3.59),('8902','2013-09-06','09:25:00',3.76),('8902','2013-09-06','09:30:00',3.95),('8902','2013-09-06','09:35:00',4.05),('8902','2013-09-06','09:40:00',4.19),('8902','2013-09-06','09:45:00',4.33),('8902','2013-09-06','09:50:00',4.49),('8902','2013-09-06','09:55:00',4.63),('8902','2013-09-06','10:00:00',4.76),('8902','2013-09-06','10:05:00',4.89),('8902','2013-09-06','10:10:00',5.01),('8902','2013-09-06','10:15:00',5.12),('8902','2013-09-06','10:20:00',5.24),('8902','2013-09-06','10:25:00',5.37),('8902','2013-09-06','10:30:00',5.51),('8902','2013-09-06','10:35:00',5.53),('8902','2013-09-06','10:40:00',5.55),('8902','2013-09-06','10:45:00',5.64),('8902','2013-09-06','10:50:00',5.77),('8902','2013-09-06','10:55:00',5.85),('8902','2013-09-06','11:00:00',5.99),('8902','2013-09-06','11:05:00',6.06),('8902','2013-09-06','11:10:00',6.12),('8902','2013-09-06','11:15:00',6.27),('8902','2013-09-06','11:20:00',6.38),('8902','2013-09-06','11:25:00',6.44),('8902','2013-09-06','11:30:00',6.48),('8902','2013-09-06','11:35:00',6.6),('8902','2013-09-06','11:40:00',6.7),('8902','2013-09-06','11:45:00',6.73),('8902','2013-09-06','11:50:00',6.78),('8902','2013-09-06','11:55:00',6.81),('8902','2013-09-06','12:00:00',6.87),('8902','2013-09-06','12:05:00',6.87),('8902','2013-09-06','12:10:00',6.91),('8902','2013-09-06','12:15:00',6.95),('8902','2013-09-06','12:20:00',6.99),('8902','2013-09-06','12:25:00',7.01),('8902','2013-09-06','12:30:00',7.02),('8902','2013-09-06','12:35:00',7.12),('8902','2013-09-06','12:40:00',7),('8902','2013-09-06','12:45:00',6.98),('8902','2013-09-06','12:50:00',7.12),('8902','2013-09-06','12:55:00',7.21),('8902','2013-09-06','13:00:00',7.2),('8902','2013-09-06','13:05:00',7.12),('8902','2013-09-06','13:10:00',7.14),('8902','2013-09-06','13:15:00',6.84),('8902','2013-09-06','13:20:00',7.09),('8902','2013-09-06','13:25:00',7.16),('8902','2013-09-06','13:30:00',7.26),('8902','2013-09-06','13:35:00',7.33),('8902','2013-09-06','13:40:00',7.37),('8902','2013-09-06','13:45:00',6.24),('8902','2013-09-06','13:50:00',3.17),('8902','2013-09-06','13:55:00',7.07),('8902','2013-09-06','14:00:00',7.39),('8902','2013-09-06','14:05:00',6.76),('8902','2013-09-06','14:10:00',7.26),('8902','2013-09-06','14:15:00',7.22),('8902','2013-09-06','14:20:00',7.17),('8902','2013-09-06','14:25:00',6.96),('8902','2013-09-06','14:30:00',6.72),('8902','2013-09-06','14:35:00',6.93),('8902','2013-09-06','14:40:00',6.91),('8902','2013-09-06','14:45:00',6.95),('8902','2013-09-06','14:50:00',6.88),('8902','2013-09-06','14:55:00',6.79),('8902','2013-09-06','15:00:00',6.78),('8902','2013-09-06','15:05:00',6.67),('8902','2013-09-06','15:10:00',6.56),('8902','2013-09-06','15:15:00',6.58),('8902','2013-09-06','15:20:00',6.42),('8902','2013-09-06','15:25:00',6.38),('8902','2013-09-06','15:30:00',6.31),('8902','2013-09-06','15:35:00',6.2),('8902','2013-09-06','15:40:00',6.05),('8902','2013-09-06','15:45:00',5.96),('8902','2013-09-06','15:50:00',5.87),('8902','2013-09-06','15:55:00',5.76),('8902','2013-09-06','16:00:00',5.65),('8902','2013-09-06','16:05:00',5.54),('8902','2013-09-06','16:10:00',5.4),('8902','2013-09-06','16:15:00',5.26),('8902','2013-09-06','16:20:00',5.07),('8902','2013-09-06','16:25:00',4.94),('8902','2013-09-06','16:30:00',4.79),('8902','2013-09-06','16:35:00',4.68),('8902','2013-09-06','16:40:00',4.52),('8902','2013-09-06','16:45:00',4.4),('8902','2013-09-06','16:50:00',4.24),('8902','2013-09-06','16:55:00',4.1),('8902','2013-09-06','17:00:00',3.91),('8902','2013-09-06','17:05:00',3.77),('8902','2013-09-06','17:10:00',3.6),('8902','2013-09-06','17:15:00',3.46),('8902','2013-09-06','17:20:00',3.29),('8902','2013-09-06','17:25:00',3.08),('8902','2013-09-06','17:30:00',2.88),('8902','2013-09-06','17:35:00',2.71),('8902','2013-09-06','17:40:00',2.59),('8902','2013-09-06','17:45:00',2.46),('8902','2013-09-06','17:50:00',2.24),('8902','2013-09-06','17:55:00',2.06),('8902','2013-09-06','18:00:00',1.88),('8902','2013-09-06','18:05:00',1.71),('8902','2013-09-06','18:10:00',1.48),('8902','2013-09-06','18:15:00',1.36),('8902','2013-09-06','18:20:00',1.22),('8902','2013-09-06','18:25:00',1.07),('8902','2013-09-05','08:00:00',1.08),('8902','2013-09-05','08:05:00',1.24),('8902','2013-09-05','08:10:00',1.4),('8902','2013-09-05','08:15:00',1.55),('8902','2013-09-05','08:20:00',1.72),('8902','2013-09-05','08:25:00',1.88),('8902','2013-09-05','08:30:00',2.05),('8902','2013-09-05','08:35:00',2.2),('8902','2013-09-05','08:40:00',2.36),('8902','2013-09-05','08:45:00',2.55),('8902','2013-09-05','08:50:00',2.69),('8902','2013-09-05','08:55:00',2.86),('8902','2013-09-05','09:00:00',3.02),('8902','2013-09-05','09:05:00',3.17),('8902','2013-09-05','09:10:00',3.35),('8902','2013-09-05','09:15:00',3.51),('8902','2013-09-05','09:20:00',3.69),('8902','2013-09-05','09:25:00',3.85),('8902','2013-09-05','09:30:00',3.98),('8902','2013-09-05','09:35:00',4.12),('8902','2013-09-05','09:40:00',4.28),('8902','2013-09-05','09:45:00',4.44),('8902','2013-09-05','09:50:00',4.57),('8902','2013-09-05','09:55:00',4.7),('8902','2013-09-05','10:00:00',4.84),('8902','2013-09-05','10:05:00',4.93),('8902','2013-09-05','10:10:00',5.03),('8902','2013-09-05','10:15:00',5.18),('8902','2013-09-05','10:20:00',5.27),('8902','2013-09-05','10:25:00',5.43),('8902','2013-09-05','10:30:00',5.58),('8902','2013-09-05','10:35:00',5.65),('8902','2013-09-05','10:40:00',5.79),('8902','2013-09-05','10:45:00',5.86),('8902','2013-09-05','10:50:00',5.93),('8902','2013-09-05','10:55:00',6.08),('8902','2013-09-05','11:00:00',6.14),('8902','2013-09-05','11:05:00',6.23),('8902','2013-09-05','11:10:00',6.31),('8902','2013-09-05','11:15:00',6.4),('8902','2013-09-05','11:20:00',6.52),('8902','2013-09-05','11:25:00',6.56),('8902','2013-09-05','11:30:00',6.62),('8902','2013-09-05','11:35:00',6.63),('8902','2013-09-05','11:40:00',6.71),('8902','2013-09-05','11:45:00',6.75),('8902','2013-09-05','11:50:00',6.8),('8902','2013-09-05','11:55:00',6.84),('8902','2013-09-05','12:00:00',6.9),('8902','2013-09-05','12:05:00',6.95),('8902','2013-09-05','12:10:00',6.99),('8902','2013-09-05','12:15:00',7.06),('8902','2013-09-05','12:20:00',7.22),('8902','2013-09-05','12:25:00',7.24),('8902','2013-09-05','12:30:00',7.26),('8902','2013-09-05','12:35:00',7.19),('8902','2013-09-05','12:40:00',7.11),('8902','2013-09-05','12:45:00',7.15),('8902','2013-09-05','12:50:00',7.17),('8902','2013-09-05','12:55:00',7.2),('8902','2013-09-05','13:00:00',7.27),('8902','2013-09-05','13:05:00',7.29),('8902','2013-09-05','13:10:00',7.28),('8902','2013-09-05','13:15:00',7.23),('8902','2013-09-05','13:20:00',7.26),('8902','2013-09-05','13:25:00',7.24),('8902','2013-09-05','13:30:00',7.11),('8902','2013-09-05','16:20:00',5.01),('8902','2013-09-05','16:25:00',4.98),('8902','2013-09-05','16:30:00',4.91),('8902','2013-09-05','16:35:00',4.79),('8902','2013-09-05','16:40:00',4.61),('8902','2013-09-05','16:45:00',4.41),('8902','2013-09-05','16:50:00',4.23),('8902','2013-09-05','16:55:00',4.14),('8902','2013-09-05','17:00:00',3.94),('8902','2013-09-05','17:05:00',3.74),('8902','2013-09-05','17:10:00',3.65),('8902','2013-09-05','17:15:00',3.48),('8902','2013-09-05','17:20:00',3.34),('8902','2013-09-05','17:25:00',3.08),('8902','2013-09-05','17:30:00',2.89),('8902','2013-09-05','17:35:00',2.73),('8902','2013-09-05','17:40:00',2.58),('8902','2013-09-05','17:45:00',2.39),('8902','2013-09-05','17:50:00',2.14),('8902','2013-09-05','17:55:00',2.03),('8902','2013-09-05','18:00:00',1.9),('8902','2013-09-05','18:05:00',1.76),('8902','2013-09-05','18:10:00',1.57),('8902','2013-09-05','18:15:00',1.33),('8902','2013-09-05','18:20:00',1.19),('8902','2013-09-05','18:25:00',1.05),('8902','2013-09-04','08:00:00',1.18),('8902','2013-09-04','08:05:00',1.35),('8902','2013-09-04','08:10:00',1.52),('8902','2013-09-04','08:15:00',1.7),('8902','2013-09-04','08:20:00',1.89),('8902','2013-09-04','08:25:00',2.07),('8902','2013-09-04','08:30:00',2.25),('8902','2013-09-04','08:35:00',2.41),('8902','2013-09-04','08:40:00',2.58),('8902','2013-09-04','08:45:00',2.7),('8902','2013-09-04','08:50:00',2.91),('8902','2013-09-04','08:55:00',3.09),('8902','2013-09-04','09:00:00',3.26),('8902','2013-09-04','09:05:00',3.42),('8902','2013-09-04','09:10:00',3.59),('8902','2013-09-04','09:15:00',3.76),('8902','2013-09-04','09:20:00',3.94),('8902','2013-09-04','09:25:00',4.12),('8902','2013-09-04','09:30:00',4.26),('8902','2013-09-04','09:35:00',4.4),('8902','2013-09-04','09:40:00',4.54),('8902','2013-09-04','09:45:00',4.68),('8902','2013-09-04','09:50:00',4.83),('8902','2013-09-04','09:55:00',4.97),('8902','2013-09-04','10:00:00',5.1),('8902','2013-09-04','10:05:00',5.22),('8902','2013-09-04','10:10:00',5.34),('8902','2013-09-04','10:15:00',5.44),('8902','2013-09-04','10:20:00',5.56),('8902','2013-09-04','10:25:00',5.65),('8902','2013-09-04','10:30:00',5.78),('8902','2013-09-04','10:35:00',5.86),('8902','2013-09-04','10:40:00',5.93),('8902','2013-09-04','10:45:00',6.03),('8902','2013-09-04','10:50:00',6.12),('8902','2013-09-04','10:55:00',6.22),('8902','2013-09-04','11:00:00',6.31),('8902','2013-09-04','11:05:00',6.42),('8902','2013-09-04','11:10:00',6.48),('8902','2013-09-04','11:15:00',6.56),('8902','2013-09-04','11:20:00',6.6),('8902','2013-09-04','11:25:00',6.69),('8902','2013-09-04','11:30:00',6.76),('8902','2013-09-04','11:35:00',6.77),('8902','2013-09-04','11:40:00',6.74),('8902','2013-09-04','11:45:00',6.76),('8902','2013-09-04','11:50:00',6.98),('8902','2013-09-04','11:55:00',7.05),('8902','2013-09-04','12:00:00',7.05),('8902','2013-09-04','12:05:00',7.13),('8902','2013-09-04','12:10:00',7.19),('8902','2013-09-04','12:15:00',7.26),('8902','2013-09-04','12:20:00',7.29),('8902','2013-09-04','12:25:00',7.28),('8902','2013-09-04','12:30:00',7.29),('8902','2013-09-04','12:35:00',7.32),('8902','2013-09-04','12:40:00',7.27),('8902','2013-09-04','12:45:00',7.31),('8902','2013-09-04','12:50:00',7.32),('8902','2013-09-04','12:55:00',7.36),('8902','2013-09-04','13:00:00',7.39),('8902','2013-09-04','13:05:00',7.4),('8902','2013-09-04','13:10:00',7.42),('8902','2013-09-04','13:15:00',7.39),('8902','2013-09-04','13:20:00',7.4),('8902','2013-09-04','13:25:00',7.44),('8902','2013-09-04','13:30:00',7.43),('8902','2013-09-04','13:35:00',7.43),('8902','2013-09-04','13:40:00',7.46),('8902','2013-09-04','13:45:00',7.43),('8902','2013-09-04','13:50:00',7.4),('8902','2013-09-04','13:55:00',7.33),('8902','2013-09-04','14:00:00',7.27),('8902','2013-09-04','14:05:00',7.28),('8902','2013-09-04','14:10:00',7.28),('8902','2013-09-04','14:15:00',7.16),('8902','2013-09-04','14:20:00',7.15),('8902','2013-09-04','14:25:00',7.1),('8902','2013-09-04','14:30:00',7.04),('8902','2013-09-04','14:35:00',6.94),('8902','2013-09-04','14:40:00',6.85),('8902','2013-09-04','14:45:00',6.79),('8902','2013-09-04','14:50:00',6.81),('8902','2013-09-04','14:55:00',6.79),('8902','2013-09-04','15:00:00',6.83),('8902','2013-09-04','15:05:00',6.8),('8902','2013-09-04','15:10:00',6.73),('8902','2013-09-04','15:15:00',6.6),('8902','2013-09-04','15:20:00',6.57),('8902','2013-09-04','15:25:00',6.49),('8902','2013-09-04','15:30:00',6.39),('8902','2013-09-04','15:35:00',6.29),('8902','2013-09-04','15:40:00',6.18),('8902','2013-09-04','15:45:00',6.06),('8902','2013-09-04','15:50:00',6),('8902','2013-09-04','15:55:00',5.97),('8902','2013-09-04','16:00:00',5.92),('8902','2013-09-04','16:05:00',5.78),('8902','2013-09-04','16:10:00',5.67),('8902','2013-09-04','16:15:00',5.61),('8902','2013-09-04','16:20:00',5.47),('8902','2013-09-04','16:25:00',5.3),('8902','2013-09-04','16:30:00',5.25),('8902','2013-09-04','16:35:00',5.21),('8902','2013-09-04','16:40:00',5.12),('8902','2013-09-04','16:45:00',4.99),('8902','2013-09-04','16:50:00',4.33),('8902','2013-09-04','16:55:00',3.45),('8902','2013-09-04','17:00:00',2.72),('8902','2013-09-04','17:05:00',2.93),('8902','2013-09-04','17:10:00',2.96),('8902','2013-09-04','17:15:00',2.63),('8902','2013-09-04','17:20:00',2.94),('8902','2013-09-04','17:25:00',2.88),('8902','2013-09-04','17:30:00',2.92),('8902','2013-09-04','17:35:00',2.92),('8902','2013-09-04','17:40:00',3.16),('8902','2013-09-04','17:45:00',2.86),('8902','2013-09-04','17:50:00',2.47),('8902','2013-09-04','17:55:00',2.12),('8902','2013-09-04','18:00:00',1.69),('8902','2013-09-04','18:05:00',1.4),('8902','2013-09-04','18:10:00',1.31),('8902','2013-09-04','18:15:00',1.18),('8902','2013-09-04','18:20:00',1.5),('8902','2013-09-04','18:25:00',1.23),('8902','2013-09-03','08:00:00',1.18),('8902','2013-09-03','08:05:00',1.35),('8902','2013-09-03','08:10:00',1.52),('8902','2013-09-03','08:15:00',1.7),('8902','2013-09-03','08:20:00',1.87),('8902','2013-09-03','08:25:00',2.06),('8902','2013-09-03','08:30:00',2.23),('8902','2013-09-03','08:35:00',2.41),('8902','2013-09-03','08:40:00',2.57),('8902','2013-09-03','08:45:00',2.75),('8902','2013-09-03','08:50:00',2.93),('8902','2013-09-03','08:55:00',3.07),('8902','2013-09-03','09:00:00',3.27),('8902','2013-09-03','09:05:00',3.42),('8902','2013-09-03','09:10:00',3.6),('8902','2013-09-03','09:15:00',3.81),('8902','2013-09-03','09:20:00',3.99),('8902','2013-09-03','09:25:00',4.18),('8902','2013-09-03','09:30:00',4.33),('8902','2013-09-03','09:35:00',4.49),('8902','2013-09-03','09:40:00',4.67),('8902','2013-09-03','09:45:00',4.83),('8902','2013-09-03','09:50:00',4.97),('8902','2013-09-03','09:55:00',5.11),('8902','2013-09-03','10:00:00',5.23),('8902','2013-09-03','10:05:00',5.35),('8902','2013-09-03','10:10:00',5.49),('8902','2013-09-03','10:15:00',5.59),('8902','2013-09-03','10:20:00',5.71),('8902','2013-09-03','10:25:00',5.82),('8902','2013-09-03','10:30:00',5.94),('8902','2013-09-03','10:35:00',6.04),('8902','2013-09-03','10:40:00',6.11),('8902','2013-09-03','10:45:00',6.22),('8902','2013-09-03','10:50:00',6.34),('8902','2013-09-03','10:55:00',6.44),('8902','2013-09-03','11:00:00',6.53),('8902','2013-09-03','11:05:00',6.64),('8902','2013-09-03','11:10:00',6.69),('8902','2013-09-03','11:15:00',6.76),('8902','2013-09-03','11:20:00',6.83),('8902','2013-09-03','11:25:00',6.9),('8902','2013-09-03','11:30:00',6.95),('8902','2013-09-03','11:35:00',7.05),('8902','2013-09-03','11:40:00',7.11),('8902','2013-09-03','11:45:00',7.19),('8902','2013-09-03','11:50:00',7.28),('8902','2013-09-03','11:55:00',7.37),('8902','2013-09-03','12:00:00',7.4),('8902','2013-09-03','12:05:00',7.41),('8902','2013-09-03','12:10:00',7.44),('8902','2013-09-03','12:15:00',7.47),('8902','2013-09-03','12:20:00',7.55),('8902','2013-09-03','12:25:00',7.55),('8902','2013-09-03','12:30:00',7.62),('8902','2013-09-03','12:35:00',7.68),('8902','2013-09-03','12:40:00',7.69),('8902','2013-09-03','12:45:00',7.7),('8902','2013-09-03','12:50:00',7.68),('8902','2013-09-03','12:55:00',7.73),('8902','2013-09-03','13:00:00',7.68),('8902','2013-09-03','13:05:00',7.7),('8902','2013-09-03','13:10:00',7.69),('8902','2013-09-03','13:15:00',7.67),('8902','2013-09-03','13:20:00',7.68),('8902','2013-09-03','13:25:00',7.71),('8902','2013-09-03','13:30:00',7.68),('8902','2013-09-03','13:35:00',7.72),('8902','2013-09-03','13:40:00',7.69),('8902','2013-09-03','13:45:00',7.65),('8902','2013-09-03','13:50:00',7.63),('8902','2013-09-03','13:55:00',7.58),('8902','2013-09-03','14:00:00',7.58),('8902','2013-09-03','14:05:00',7.57),('8902','2013-09-03','14:10:00',7.56),('8902','2013-09-03','14:15:00',7.52),('8902','2013-09-03','14:20:00',7.42),('8902','2013-09-03','14:25:00',7.43),('8902','2013-09-03','14:30:00',7.4),('8902','2013-09-03','14:35:00',7.34),('8902','2013-09-03','14:40:00',7.3),('8902','2013-09-03','14:45:00',7.28),('8902','2013-09-03','14:50:00',7.23),('8902','2013-09-03','14:55:00',7.14),('8902','2013-09-03','15:00:00',7.06),('8902','2013-09-03','15:05:00',7.01),('8902','2013-09-03','15:10:00',6.91),('8902','2013-09-03','15:15:00',6.87),('8902','2013-09-03','15:20:00',6.82),('8902','2013-09-03','15:25:00',6.71),('8902','2013-09-03','15:30:00',6.63),('8902','2013-09-03','15:35:00',6.49),('8902','2013-09-03','15:40:00',6.41),('8902','2013-09-03','15:45:00',6.32),('8902','2013-09-03','15:50:00',6.21),('8902','2013-09-03','15:55:00',6.09),('8902','2013-09-03','16:00:00',5.95),('8902','2013-09-03','16:05:00',5.83),('8902','2013-09-03','16:10:00',5.72),('8902','2013-09-03','16:15:00',5.63),('8902','2013-09-03','16:20:00',5.5),('8902','2013-09-03','16:25:00',5.33),('8902','2013-09-03','16:30:00',5.23),('8902','2013-09-03','16:35:00',5.09),('8902','2013-09-03','16:40:00',4.92),('8902','2013-09-03','16:45:00',4.77),('8902','2013-09-03','16:50:00',4.66),('8902','2013-09-03','16:55:00',4.51),('8902','2013-09-03','17:00:00',4.33),('8902','2013-09-03','17:05:00',4.15),('8902','2013-09-03','17:10:00',4.02),('8902','2013-09-03','17:15:00',3.86),('8902','2013-09-03','17:20:00',3.7),('8902','2013-09-03','17:25:00',3.51),('8902','2013-09-03','17:30:00',3.32),('8902','2013-09-03','17:35:00',3.13),('8902','2013-09-03','17:40:00',2.93),('8902','2013-09-03','17:45:00',2.76),('8902','2013-09-03','17:50:00',2.55),('8902','2013-09-03','17:55:00',2.37),('8902','2013-09-03','18:00:00',2.18),('8902','2013-09-03','18:05:00',1.99),('8902','2013-09-03','18:10:00',1.79),('8902','2013-09-03','18:15:00',1.54),('8902','2013-09-03','18:20:00',1.37),('8902','2013-09-03','18:25:00',1.19),('8902','2013-09-03','18:30:00',1.04),('8902','2013-09-02','08:00:00',1.15),('8902','2013-09-02','08:05:00',1.29),('8902','2013-09-02','08:10:00',1.44),('8902','2013-09-02','08:15:00',1.59),('8902','2013-09-02','08:20:00',1.75),('8902','2013-09-02','08:25:00',1.91),('8902','2013-09-02','08:30:00',2.08),('8902','2013-09-02','08:35:00',2.24),('8902','2013-09-02','08:40:00',2.38),('8902','2013-09-02','08:45:00',2.54),('8902','2013-09-02','08:50:00',2.72),('8902','2013-09-02','08:55:00',2.88),('8902','2013-09-02','09:00:00',3.05),('8902','2013-09-02','09:05:00',3.22),('8902','2013-09-02','09:10:00',3.39),('8902','2013-09-02','09:15:00',3.55),('8902','2013-09-02','09:20:00',3.74),('8902','2013-09-02','09:25:00',3.91),('8902','2013-09-02','09:30:00',4.06),('8902','2013-09-02','09:35:00',4.2),('8902','2013-09-02','09:40:00',4.33),('8902','2013-09-02','09:45:00',4.49),('8902','2013-09-02','09:50:00',4.62),('8902','2013-09-02','09:55:00',4.74),('8902','2013-09-02','10:00:00',4.84),('8902','2013-09-02','10:05:00',4.96),('8902','2013-09-02','10:10:00',5.09),('8902','2013-09-02','10:15:00',5.23),('8902','2013-09-02','10:20:00',5.38),('8902','2013-09-02','10:25:00',5.5),('8902','2013-09-02','10:30:00',5.6),('8902','2013-09-02','10:35:00',5.77),('8902','2013-09-02','10:40:00',5.94),('8902','2013-09-02','10:45:00',6.07),('8902','2013-09-02','10:50:00',6.14),('8902','2013-09-02','10:55:00',6.21),('8902','2013-09-02','11:00:00',6.29),('8902','2013-09-02','11:05:00',6.35),('8902','2013-09-02','11:10:00',6.43),('8902','2013-09-02','11:15:00',6.52),('8902','2013-09-02','11:20:00',6.58),('8902','2013-09-02','11:25:00',6.68),('8902','2013-09-02','11:30:00',6.72),('8902','2013-09-02','11:35:00',6.78),('8902','2013-09-02','11:40:00',6.84),('8902','2013-09-02','11:45:00',6.89),('8902','2013-09-02','11:50:00',6.95),('8902','2013-09-02','11:55:00',7.04),('8902','2013-09-02','12:00:00',7.09),('8902','2013-09-02','12:05:00',7.17),('8902','2013-09-02','12:10:00',7.25),('8902','2013-09-02','12:15:00',7.32),('8902','2013-09-02','12:20:00',7.35),('8902','2013-09-02','12:25:00',7.41),('8902','2013-09-02','12:30:00',7.43),('8902','2013-09-02','12:35:00',7.45),('8902','2013-09-02','12:40:00',7.5),('8902','2013-09-02','12:45:00',7.52),('8902','2013-09-02','12:50:00',7.51),('8902','2013-09-02','12:55:00',7.55),('8902','2013-09-02','13:00:00',7.52),('8902','2013-09-02','13:05:00',7.54),('8902','2013-09-02','13:10:00',7.51),('8902','2013-09-02','13:15:00',7.52),('8902','2013-09-02','13:20:00',7.53),('8902','2013-09-02','13:25:00',7.47),('8902','2013-09-02','13:30:00',7.53),('8902','2013-09-02','13:35:00',7.51),('8902','2013-09-02','13:40:00',7.45),('8902','2013-09-02','13:45:00',7.52),('8902','2013-09-02','13:50:00',7.55),('8902','2013-09-02','13:55:00',7.48),('8902','2013-09-02','14:00:00',7.31),('8902','2013-09-02','14:05:00',7.29),('8902','2013-09-02','14:10:00',7.28),('8902','2013-09-02','14:15:00',7.3),('8902','2013-09-02','14:20:00',7.26),('8902','2013-09-02','14:25:00',7.23),('8902','2013-09-02','14:30:00',7.22),('8902','2013-09-02','14:35:00',7.24),('8902','2013-09-02','14:40:00',7.21),('8902','2013-09-02','14:45:00',7.18),('8902','2013-09-02','14:50:00',7.16),('8902','2013-09-02','14:55:00',7.06),('8902','2013-09-02','15:00:00',6.94),('8902','2013-09-02','15:05:00',6.81),('8902','2013-09-02','15:10:00',6.79),('8902','2013-09-02','15:15:00',6.73),('8902','2013-09-02','15:20:00',6.6),('8902','2013-09-02','15:25:00',6.54),('8902','2013-09-02','15:30:00',6.39),('8902','2013-09-02','15:35:00',6.28),('8902','2013-09-02','15:40:00',6.21),('8902','2013-09-02','15:45:00',6.15),('8902','2013-09-02','15:50:00',6.1),('8902','2013-09-02','15:55:00',6.03),('8902','2013-09-02','16:00:00',5.92),('8902','2013-09-02','16:05:00',5.8),('8902','2013-09-02','16:10:00',5.67),('8902','2013-09-02','16:15:00',5.54),('8902','2013-09-02','16:20:00',5.45),('8902','2013-09-02','16:25:00',5.25),('8902','2013-09-02','16:30:00',5.16),('8902','2013-09-02','16:35:00',5.03),('8902','2013-09-02','16:40:00',4.88),('8902','2013-09-02','16:45:00',4.69),('8902','2013-09-02','16:50:00',4.6),('8902','2013-09-02','16:55:00',4.5),('8902','2013-09-02','17:00:00',4.34),('8902','2013-09-02','17:05:00',4.13),('8902','2013-09-02','17:10:00',4),('8902','2013-09-02','17:15:00',3.84),('8902','2013-09-02','17:20:00',3.71),('8902','2013-09-02','17:25:00',3.46),('8902','2013-09-02','17:30:00',3.32),('8902','2013-09-02','17:35:00',3.14),('8902','2013-09-02','17:40:00',2.95),('8902','2013-09-02','17:45:00',2.8),('8902','2013-09-02','17:50:00',2.64),('8902','2013-09-02','17:55:00',2.42),('8902','2013-09-02','18:00:00',2.24),('8902','2013-09-02','18:05:00',1.89),('8902','2013-09-02','18:10:00',1.62),('8902','2013-09-02','18:15:00',1.43),('8902','2013-09-02','18:20:00',1.31),('8902','2013-09-02','18:25:00',1.19),('8902','2013-09-02','18:30:00',1.04),('8902','2013-09-01','07:55:00',1.01),('8902','2013-09-01','08:00:00',1.18),('8902','2013-09-01','08:05:00',1.34),('8902','2013-09-01','08:10:00',1.49),('8902','2013-09-01','08:15:00',1.65),('8902','2013-09-01','08:20:00',1.81),('8902','2013-09-01','08:25:00',1.97),('8902','2013-09-01','08:30:00',2.12),('8902','2013-09-01','08:35:00',2.3),('8902','2013-09-01','08:40:00',2.49),('8902','2013-09-01','08:45:00',2.65),('8902','2013-09-01','08:50:00',2.81),('8902','2013-09-01','08:55:00',2.99),('8902','2013-09-01','09:00:00',3.17),('8902','2013-09-01','09:05:00',3.34),('8902','2013-09-01','09:10:00',3.51),('8902','2013-09-01','09:15:00',3.68),('8902','2013-09-01','09:20:00',3.85),('8902','2013-09-01','09:25:00',4.01),('8902','2013-09-01','09:30:00',4.16),('8902','2013-09-01','09:35:00',4.32),('8902','2013-09-01','09:40:00',4.45),('8902','2013-09-01','09:45:00',4.59),('8902','2013-09-01','09:50:00',4.73),('8902','2013-09-01','09:55:00',4.85),('8902','2013-09-01','10:00:00',5),('8902','2013-09-01','10:05:00',5.14),('8902','2013-09-01','10:10:00',5.27),('8902','2013-09-01','10:15:00',5.42),('8902','2013-09-01','10:20:00',5.54),('8902','2013-09-01','10:25:00',5.64),('8902','2013-09-01','10:30:00',5.74),('8902','2013-09-01','10:35:00',5.84),('8902','2013-09-01','10:40:00',5.93),('8902','2013-09-01','10:45:00',6.03),('8902','2013-09-01','10:50:00',6.09),('8902','2013-09-01','10:55:00',6.23),('8902','2013-09-01','11:00:00',6.32),('8902','2013-09-01','11:05:00',6.4),('8902','2013-09-01','11:10:00',6.46),('8902','2013-09-01','11:15:00',6.54),('8902','2013-09-01','11:20:00',6.63),('8902','2013-09-01','11:25:00',6.72),('8902','2013-09-01','11:30:00',6.77),('8902','2013-09-01','11:35:00',6.84),('8902','2013-09-01','11:40:00',6.89),('8902','2013-09-01','11:45:00',6.95),('8902','2013-09-01','11:50:00',7.07),('8902','2013-09-01','11:55:00',7.07),('8902','2013-09-01','12:00:00',7.09),('8902','2013-09-01','12:05:00',7.2),('8902','2013-09-01','12:10:00',7.23),('8902','2013-09-01','12:15:00',7.29),('8902','2013-09-01','12:20:00',7.31),('8902','2013-09-01','12:25:00',7.28),('8902','2013-09-01','12:30:00',7.27),('8902','2013-09-01','12:35:00',7.29),('8902','2013-09-01','12:40:00',7.34),('8902','2013-09-01','12:45:00',7.31),('8902','2013-09-01','12:50:00',7.35),('8902','2013-09-01','12:55:00',7.35),('8902','2013-09-01','13:00:00',7.44),('8902','2013-09-01','13:05:00',7.46),('8902','2013-09-01','13:10:00',7.43),('8902','2013-09-01','13:15:00',7.49),('8902','2013-09-01','13:20:00',7.53),('8902','2013-09-01','13:25:00',7.51),('8902','2013-09-01','13:30:00',7.48),('8902','2013-09-01','13:35:00',7.4),('8902','2013-09-01','13:40:00',7.37),('8902','2013-09-01','13:45:00',6.72),('8902','2013-09-01','13:50:00',1.16),('8902','2013-09-01','13:55:00',3.31),('8902','2013-09-01','14:00:00',7.98),('8902','2013-09-01','14:05:00',7.61),('8902','2013-09-01','14:10:00',6.94),('8902','2013-09-01','14:15:00',7.4),('8902','2013-09-01','14:20:00',7.34),('8902','2013-09-01','14:25:00',7.31),('8902','2013-09-01','14:30:00',7.42),('8902','2013-09-01','14:35:00',7.27),('8902','2013-09-01','14:40:00',7.27),('8902','2013-09-01','14:45:00',7.35),('8902','2013-09-01','14:50:00',7.38),('8902','2013-09-01','14:55:00',7.04),('8902','2013-09-01','15:00:00',6.23),('8902','2013-09-01','15:05:00',6.34),('8902','2013-09-01','15:10:00',4.81),('8902','2013-09-01','15:15:00',6.94),('8902','2013-09-01','15:20:00',6.69),('8902','2013-09-01','15:25:00',5.37),('8902','2013-09-01','15:30:00',3.37),('8902','2013-09-01','15:35:00',6.29),('8902','2013-09-01','15:40:00',6.49),('8902','2013-09-01','15:45:00',6.42),('8902','2013-09-01','15:50:00',6.25),('8902','2013-09-01','15:55:00',6.16),('8902','2013-09-01','16:00:00',5.97),('8902','2013-09-01','16:05:00',5.76),('8902','2013-09-01','16:10:00',5.7),('8902','2013-09-01','16:15:00',5.73),('8902','2013-09-01','16:20:00',5.65),('8902','2013-09-01','16:25:00',5.36),('8902','2013-09-01','16:30:00',5.22),('8902','2013-09-01','16:35:00',5.02),('8902','2013-09-01','16:40:00',4.77),('8902','2013-09-01','16:45:00',4.59),('8902','2013-09-01','16:50:00',4.46),('8902','2013-09-01','16:55:00',4.24),('8902','2013-09-01','17:00:00',4.06),('8902','2013-09-01','17:05:00',3.93),('8902','2013-09-01','17:10:00',3.81),('8902','2013-09-01','17:15:00',3.68),('8902','2013-09-01','17:20:00',3.5),('8902','2013-09-01','17:25:00',3.34),('8902','2013-09-01','17:30:00',3.18),('8902','2013-09-01','17:35:00',2.97),('8902','2013-09-01','17:40:00',2.78),('8902','2013-09-01','17:45:00',2.65),('8902','2013-09-01','17:50:00',2.49),('8902','2013-09-01','17:55:00',2.32),('8902','2013-09-01','18:00:00',2.16),('8902','2013-09-01','18:05:00',1.96),('8902','2013-09-01','18:10:00',1.77),('8902','2013-09-01','18:15:00',1.57),('8902','2013-09-01','18:20:00',1.41),('8902','2013-09-01','18:25:00',1.25),('8902','2013-09-01','18:30:00',1.1),('8902','2013-08-31','07:55:00',1.07),('8902','2013-08-31','08:00:00',1.26),('8902','2013-08-31','08:05:00',1.42),('8902','2013-08-31','08:10:00',1.59),('8902','2013-08-31','08:15:00',1.75),('8902','2013-08-31','08:20:00',1.91),('8902','2013-08-31','08:25:00',2.06),('8902','2013-08-31','08:30:00',2.09),('8902','2013-08-31','08:35:00',2.4),('8902','2013-08-31','08:40:00',2.59),('8902','2013-08-31','08:45:00',2.75),('8902','2013-08-31','08:50:00',2.88),('8902','2013-08-31','08:55:00',3.05),('8902','2013-08-31','09:00:00',3.23),('8902','2013-08-31','09:05:00',3.37),('8902','2013-08-31','09:10:00',3.56),('8902','2013-08-31','09:15:00',3.73),('8902','2013-08-31','09:20:00',3.9),('8902','2013-08-31','09:25:00',4.07),('8902','2013-08-31','09:30:00',4.25),('8902','2013-08-31','09:35:00',4.4),('8902','2013-08-31','09:40:00',4.55),('8902','2013-08-31','09:45:00',4.68),('8902','2013-08-31','09:50:00',4.82),('8902','2013-08-31','09:55:00',4.94),('8902','2013-08-31','10:00:00',5.08),('8902','2013-08-31','10:05:00',5.19),('8902','2013-08-31','10:10:00',5.32),('8902','2013-08-31','10:15:00',5.44),('8902','2013-08-31','10:20:00',5.54),('8902','2013-08-31','10:25:00',5.66),('8902','2013-08-31','10:30:00',5.78),('8902','2013-08-31','10:35:00',5.9),('8902','2013-08-31','10:40:00',6),('8902','2013-08-31','10:45:00',6.06),('8902','2013-08-31','10:50:00',6.12),('8902','2013-08-31','10:55:00',6.22),('8902','2013-08-31','11:00:00',6.37),('8902','2013-08-31','11:05:00',6.5),('8902','2013-08-31','11:10:00',6.56),('8902','2013-08-31','11:15:00',6.57),('8902','2013-08-31','11:20:00',6.61),('8902','2013-08-31','11:25:00',6.71),('8902','2013-08-31','11:30:00',6.76),('8902','2013-08-31','11:35:00',6.91),('8902','2013-08-31','11:40:00',7.02),('8902','2013-08-31','11:45:00',7.06),('8902','2013-08-31','11:50:00',7.09),('8902','2013-08-31','11:55:00',7.18),('8902','2013-08-31','12:00:00',7.18),('8902','2013-08-31','12:05:00',6.9),('8902','2013-08-31','12:10:00',7.21),('8902','2013-08-31','12:15:00',7.24),('8902','2013-08-31','12:20:00',7.37),('8902','2013-08-31','12:25:00',7.21),('8902','2013-08-31','12:30:00',7.37),('8902','2013-08-31','12:35:00',7.43),('8902','2013-08-31','12:40:00',7.45),('8902','2013-08-31','12:45:00',7.42),('8902','2013-08-31','12:50:00',7.47),('8902','2013-08-31','12:55:00',7.46),('8902','2013-08-31','13:00:00',7.55),('8902','2013-08-31','13:05:00',7.58),('8902','2013-08-31','13:10:00',7.62),('8902','2013-08-31','13:15:00',6.47),('8902','2013-08-31','13:20:00',7.66),('8902','2013-08-31','13:25:00',7.71),('8902','2013-08-31','13:30:00',7.65),('8902','2013-08-31','13:35:00',7.57),('8902','2013-08-31','13:40:00',7.56),('8902','2013-08-31','13:45:00',7.57),('8902','2013-08-31','13:50:00',6.68),('8902','2013-08-31','13:55:00',6.72),('8902','2013-08-31','14:00:00',6.1),('8902','2013-08-31','14:05:00',5.79),('8902','2013-08-31','14:10:00',6.84),('8902','2013-08-31','14:15:00',6.98),('8902','2013-08-31','14:20:00',6.59),('8902','2013-08-31','14:25:00',6.34),('8902','2013-08-31','14:30:00',6.62),('8902','2013-08-31','14:35:00',6.43),('8902','2013-08-31','14:40:00',6.46),('8902','2013-08-31','14:45:00',6.58),('8902','2013-08-31','14:50:00',6.64),('8902','2013-08-31','14:55:00',6.41),('8902','2013-08-31','15:00:00',6.4),('8902','2013-08-31','15:05:00',6.37),('8902','2013-08-31','15:10:00',6.17),('8902','2013-08-31','15:15:00',5.95),('8902','2013-08-31','15:20:00',5.73),('8902','2013-08-31','15:25:00',5.21),('8902','2013-08-31','15:30:00',4.16),('8902','2013-08-31','15:35:00',4.83),('8902','2013-08-31','15:40:00',5.57),('8902','2013-08-31','15:45:00',4.71),('8902','2013-08-31','15:50:00',3.63),('8902','2013-08-31','15:55:00',4.6),('8902','2013-08-31','16:00:00',4.89),('8902','2013-08-31','16:05:00',5.4),('8902','2013-08-31','16:10:00',5.79),('8902','2013-08-31','16:15:00',5.44),('8902','2013-08-31','16:20:00',5.24),('8902','2013-08-31','16:25:00',4.89),('8902','2013-08-31','16:30:00',5.54),('8902','2013-08-31','16:35:00',5.19),('8902','2013-08-31','16:40:00',5.07),('8902','2013-08-31','16:45:00',4.73),('8902','2013-08-31','16:50:00',4.42),('8902','2013-08-31','16:55:00',4.14),('8902','2013-08-31','17:00:00',3.4),('8902','2013-08-31','17:05:00',3.27),('8902','2013-08-31','17:10:00',3),('8902','2013-08-31','17:15:00',2.73),('8902','2013-08-31','17:20:00',3.01),('8902','2013-08-31','17:25:00',2.89),('8902','2013-08-31','17:30:00',2.66),('8902','2013-08-31','17:35:00',2.52),('8902','2013-08-31','17:40:00',2.59),('8902','2013-08-31','17:45:00',2.21),('8902','2013-08-31','17:50:00',2.01),('8902','2013-08-31','17:55:00',1.89),('8902','2013-08-31','18:00:00',1.85),('8902','2013-08-31','18:05:00',1.87),('8902','2013-08-31','18:10:00',1.91),('8902','2013-08-31','18:15:00',1.84),('8902','2013-08-31','18:20:00',1.55),('8902','2013-08-31','18:25:00',1.54),('8902','2013-08-31','18:30:00',1.43),('8902','2013-08-31','18:35:00',1.18),('8902','2013-08-31','18:40:00',1.24),('8902','2013-08-31','18:45:00',1.13),('8902','2013-08-30','08:15:00',1.05),('8902','2013-08-30','08:20:00',1.57),('8902','2013-08-30','08:25:00',1.88),('8902','2013-08-30','08:30:00',2.28),('8902','2013-08-30','08:35:00',2.43),('8902','2013-08-30','08:40:00',2.65),('8902','2013-08-30','08:45:00',2.88),('8902','2013-08-30','08:50:00',3.17),('8902','2013-08-30','08:55:00',3.46),('8902','2013-08-30','09:00:00',3.69),('8902','2013-08-30','09:05:00',3.38),('8902','2013-08-30','09:10:00',2.83),('8902','2013-08-30','09:15:00',3.39),('8902','2013-08-30','09:20:00',3.9),('8902','2013-08-30','09:25:00',4.33),('8902','2013-08-30','09:30:00',4.43),('8902','2013-08-30','09:35:00',4.65),('8902','2013-08-30','09:40:00',4.8),('8902','2013-08-30','09:45:00',4.53),('8902','2013-08-30','09:50:00',4.6),('8902','2013-08-30','09:55:00',4.93),('8902','2013-08-30','10:00:00',5.27),('8902','2013-08-30','10:05:00',5.29),('8902','2013-08-30','10:10:00',5.54),('8902','2013-08-30','10:15:00',5.56),('8902','2013-08-30','10:20:00',5.68),('8902','2013-08-30','10:25:00',5.75),('8902','2013-08-30','10:30:00',5.91),('8902','2013-08-30','10:35:00',6.1),('8902','2013-08-30','10:40:00',6.13),('8902','2013-08-30','10:45:00',6.27),('8902','2013-08-30','10:50:00',6.44),('8902','2013-08-30','10:55:00',6.52),('8902','2013-08-30','11:00:00',6.67),('8902','2013-08-30','11:05:00',6.74),('8902','2013-08-30','11:10:00',6.83),('8902','2013-08-30','11:15:00',6.92),('8902','2013-08-30','11:20:00',6.99),('8902','2013-08-30','11:25:00',7.05),('8902','2013-08-30','11:30:00',7.12),('8902','2013-08-30','11:35:00',7.22),('8902','2013-08-30','11:40:00',7.32),('8902','2013-08-30','11:45:00',7.42),('8902','2013-08-30','11:50:00',7.45),('8902','2013-08-30','11:55:00',7.46),('8902','2013-08-30','12:00:00',6.25),('8902','2013-08-30','12:05:00',5.22),('8902','2013-08-30','12:10:00',6.36),('8902','2013-08-30','12:15:00',7.53),('8902','2013-08-30','12:20:00',7.48),('8902','2013-08-30','12:25:00',7.48),('8902','2013-08-30','12:30:00',7.56),('8902','2013-08-30','12:35:00',7.53),('8902','2013-08-30','12:40:00',7.61),('8902','2013-08-30','12:45:00',7.53),('8902','2013-08-30','12:50:00',7.57),('8902','2013-08-30','12:55:00',7.64),('8902','2013-08-30','13:00:00',7.7),('8902','2013-08-30','13:05:00',7.73),('8902','2013-08-30','13:10:00',7.67),('8902','2013-08-30','13:15:00',7.68),('8902','2013-08-30','13:20:00',7.72),('8902','2013-08-30','13:25:00',7.68),('8902','2013-08-30','13:30:00',7.67),('8902','2013-08-30','13:35:00',7.62),('8902','2013-08-30','13:40:00',7.58),('8902','2013-08-30','13:45:00',7.55),('8902','2013-08-30','13:50:00',7.6),('8902','2013-08-30','13:55:00',7.53),('8902','2013-08-30','14:00:00',7.53),('8902','2013-08-30','14:05:00',7.49),('8902','2013-08-30','14:10:00',7.41),('8902','2013-08-30','14:15:00',7.37),('8902','2013-08-30','14:20:00',7.29),('8902','2013-08-30','14:25:00',7.22),('8902','2013-08-30','14:30:00',7.21),('8902','2013-08-30','14:35:00',6.9),('8902','2013-08-30','14:40:00',6.96),('8902','2013-08-30','14:45:00',6.96),('8902','2013-08-30','14:50:00',6.96),('8902','2013-08-30','14:55:00',6.8),('8902','2013-08-30','15:00:00',6.77),('8902','2013-08-30','15:05:00',6.79),('8902','2013-08-30','15:10:00',6.71),('8902','2013-08-30','15:15:00',6.6),('8902','2013-08-30','15:20:00',6.5),('8902','2013-08-30','15:25:00',6.38),('8902','2013-08-30','15:30:00',6.35),('8902','2013-08-30','15:35:00',6.19),('8902','2013-08-30','15:40:00',6.23),('8902','2013-08-30','15:45:00',6.12),('8902','2013-08-30','15:50:00',5.96),('8902','2013-08-30','15:55:00',5.87),('8902','2013-08-30','16:00:00',5.82),('8902','2013-08-30','16:05:00',5.67),('8902','2013-08-30','16:10:00',5.64),('8902','2013-08-30','16:15:00',5.52),('8902','2013-08-30','16:20:00',5.4),('8902','2013-08-30','16:25:00',5.18),('8902','2013-08-30','16:30:00',5),('8902','2013-08-30','16:35:00',5.04),('8902','2013-08-30','16:40:00',4.89),('8902','2013-08-30','16:45:00',4.59),('8902','2013-08-30','16:50:00',4.47),('8902','2013-08-30','16:55:00',4.37),('8902','2013-08-30','17:00:00',4.19),('8902','2013-08-30','17:05:00',4.14),('8902','2013-08-30','17:10:00',4.04),('8902','2013-08-30','17:15:00',3.84),('8902','2013-08-30','17:20:00',3.63),('8902','2013-08-30','17:25:00',3.43),('8902','2013-08-30','17:30:00',3.25),('8902','2013-08-30','17:35:00',2.97),('8902','2013-08-30','17:40:00',2.84),('8902','2013-08-30','17:45:00',2.64),('8902','2013-08-30','17:50:00',2.43),('8902','2013-08-30','17:55:00',2.17),('8902','2013-08-30','18:00:00',1.3),('8902','2013-08-30','18:05:00',1.45),('8902','2013-08-30','18:10:00',1.36),('8902','2013-08-30','18:15:00',1.23),('8902','2013-08-30','18:20:00',1.25),('8902','2013-08-30','18:25:00',1.08),('8902','2013-08-29','07:55:00',1.17),('8902','2013-08-29','08:00:00',1.39),('8902','2013-08-29','08:05:00',1.74),('8902','2013-08-29','08:10:00',1.99),('8902','2013-08-29','08:15:00',1.99),('8902','2013-08-29','08:20:00',2.17),('8902','2013-08-29','08:25:00',2.28),('8902','2013-08-29','08:30:00',2.41),('8902','2013-08-29','08:35:00',2.58),('8902','2013-08-29','08:40:00',2.68),('8902','2013-08-29','08:45:00',2.46),('8902','2013-08-29','08:50:00',2.26),('8902','2013-08-29','08:55:00',2.27),('8902','2013-08-29','09:00:00',2.61),('8902','2013-08-29','09:05:00',2.89),('8902','2013-08-29','09:10:00',2.6),('8902','2013-08-29','09:15:00',2.44),('8902','2013-08-29','09:20:00',2.2),('8902','2013-08-29','09:25:00',2.31),('8902','2013-08-29','09:30:00',2.97),('8902','2013-08-29','09:35:00',3.3),('8902','2013-08-29','09:40:00',3.24),('8902','2013-08-29','09:45:00',3.33),('8902','2013-08-29','09:50:00',3.35),('8902','2013-08-29','09:55:00',3.53),('8902','2013-08-29','10:00:00',3.55),('8902','2013-08-29','10:05:00',3.6),('8902','2013-08-29','10:10:00',3.59),('8902','2013-08-29','10:15:00',3.78),('8902','2013-08-29','10:20:00',4.04),('8902','2013-08-29','10:25:00',3.7),('8902','2013-08-29','10:30:00',4.12),('8902','2013-08-29','10:35:00',3.94),('8902','2013-08-29','10:40:00',3.76),('8902','2013-08-29','10:45:00',3.65),('8902','2013-08-29','10:50:00',3.87),('8902','2013-08-29','10:55:00',3.7),('8902','2013-08-29','11:00:00',3.87),('8902','2013-08-29','11:05:00',4.12),('8902','2013-08-29','11:10:00',4.3),('8902','2013-08-29','11:15:00',4.4),('8902','2013-08-29','11:20:00',4.37),('8902','2013-08-29','11:25:00',4.53),('8902','2013-08-29','11:30:00',4.83),('8902','2013-08-29','11:35:00',4.61),('8902','2013-08-29','11:40:00',4.99),('8902','2013-08-29','11:45:00',4.88),('8902','2013-08-29','11:50:00',5.7),('8902','2013-08-29','11:55:00',5.02),('8902','2013-08-29','12:00:00',4.53),('8902','2013-08-29','12:05:00',3.84),('8902','2013-08-29','12:10:00',4.18),('8902','2013-08-29','12:15:00',4.59),('8902','2013-08-29','12:20:00',4.97),('8902','2013-08-29','12:25:00',5.6),('8902','2013-08-29','12:30:00',6.16),('8902','2013-08-29','12:35:00',5.98),('8902','2013-08-29','12:40:00',5.79),('8902','2013-08-29','12:45:00',6.01),('8902','2013-08-29','12:50:00',5.93),('8902','2013-08-29','12:55:00',5.55),('8902','2013-08-29','13:00:00',5.37),('8902','2013-08-29','13:05:00',5.33),('8902','2013-08-29','13:10:00',5.41),('8902','2013-08-29','13:15:00',5.18),('8902','2013-08-29','13:20:00',6.13),('8902','2013-08-29','13:25:00',7.06),('8902','2013-08-29','13:30:00',7.56),('8902','2013-08-29','13:35:00',7.04),('8902','2013-08-29','13:40:00',7.49),('8902','2013-08-29','13:45:00',6.75),('8902','2013-08-29','13:50:00',6.77),('8902','2013-08-29','13:55:00',7.41),('8902','2013-08-29','14:00:00',7.69),('8902','2013-08-29','14:05:00',7.43),('8902','2013-08-29','14:10:00',7.49),('8902','2013-08-29','14:15:00',7.51),('8902','2013-08-29','14:20:00',7.37),('8902','2013-08-29','14:25:00',7.52),('8902','2013-08-29','14:30:00',7.39),('8902','2013-08-29','14:35:00',7.49),('8902','2013-08-29','14:40:00',7.28),('8902','2013-08-29','14:45:00',5.91),('8902','2013-08-29','14:50:00',4.84),('8902','2013-08-29','14:55:00',5.63),('8902','2013-08-29','15:00:00',4.93),('8902','2013-08-29','15:05:00',4.5),('8902','2013-08-29','15:10:00',4.5),('8902','2013-08-29','15:15:00',5.51),('8902','2013-08-29','15:20:00',4.81),('8902','2013-08-29','15:25:00',4.24),('8902','2013-08-29','15:30:00',4.1),('8902','2013-08-29','15:35:00',3.39),('8902','2013-08-29','15:40:00',3.6),('8902','2013-08-29','15:45:00',4.21),('8902','2013-08-29','15:50:00',4.63),('8902','2013-08-29','15:55:00',4.65),('8902','2013-08-29','16:00:00',4.36),('8902','2013-08-29','16:05:00',3.84),('8902','2013-08-29','16:11:00',3.17),('8902','2013-08-29','16:15:00',2.78),('8902','2013-08-29','16:20:00',3.16),('8902','2013-08-29','16:25:00',3.23),('8902','2013-08-29','16:30:00',3.29),('8902','2013-08-29','16:35:00',3.3),('8902','2013-08-29','16:40:00',4.84),('8902','2013-08-29','16:45:00',4.88),('8902','2013-08-29','16:50:00',4.58),('8902','2013-08-29','16:55:00',3.12),('8902','2013-08-29','17:00:00',3.51),('8902','2013-08-29','17:05:00',2.65),('8902','2013-08-29','17:10:00',3.11),('8902','2013-08-29','17:15:00',2.83),('8902','2013-08-29','17:20:00',2.44),('8902','2013-08-29','17:25:00',2.36),('8902','2013-08-29','17:30:00',2.59),('8902','2013-08-29','17:35:00',2.87),('8902','2013-08-29','17:40:00',3.01),('8902','2013-08-29','17:45:00',2.81),('8902','2013-08-29','17:50:00',2.17),('8902','2013-08-29','17:55:00',2.77),('8902','2013-08-29','18:00:00',2.12),('8902','2013-08-29','18:05:00',1.23),('8902','2014-04-10','07:50:00',1.19),('8902','2014-04-10','07:55:00',1.39),('8902','2014-04-10','08:00:00',1.09),('8902','2014-04-10','08:30:00',2.07),('8902','2014-04-10','08:35:00',2.71),('8902','2014-04-10','08:40:00',2.91),('8902','2014-04-10','08:45:00',3.15),('8902','2014-04-10','08:50:00',3.24),('8902','2014-04-10','08:55:00',3.38),('8902','2014-04-10','09:00:00',3.51),('8902','2014-04-10','09:05:00',3.64),('8902','2014-04-10','09:10:00',3.79),('8902','2014-04-10','09:15:00',3.94),('8902','2014-04-10','09:20:00',4.13),('8902','2014-04-10','09:25:00',4.34),('8902','2014-04-10','09:30:00',4.5),('8902','2014-04-10','09:35:00',4.66),('8902','2014-04-10','09:40:00',4.83),('8902','2014-04-10','09:45:00',4.96),('8902','2014-04-10','09:50:00',5.11),('8902','2014-04-10','09:55:00',5.23),('8902','2014-04-10','10:00:00',5.39),('8902','2014-04-10','10:05:00',5.53),('8902','2014-04-10','10:10:00',5.75),('8902','2014-04-10','10:15:00',5.93),('8902','2014-04-10','10:20:00',6),('8902','2014-04-10','10:25:00',6.12),('8902','2014-04-10','10:30:00',6.23),('8902','2014-04-10','10:35:00',6.34),('8902','2014-04-10','10:40:00',6.44),('8902','2014-04-10','10:45:00',6.55),('8902','2014-04-10','10:50:00',6.76),('8902','2014-04-10','10:55:00',6.9),('8902','2014-04-10','11:00:00',7.02),('8902','2014-04-10','11:05:00',7.1),('8902','2014-04-10','11:10:00',7.22),('8902','2014-04-10','11:15:00',7.23),('8902','2014-04-10','11:20:00',7.24),('8902','2014-04-10','11:25:00',7.52),('8902','2014-04-10','11:30:00',7.58),('8902','2014-04-10','11:35:00',7.66),('8902','2014-04-10','11:40:00',7.47),('8902','2014-04-10','11:45:00',7.78),('8902','2014-04-10','11:50:00',7.86),('8902','2014-04-10','11:55:00',8.08),('8902','2014-04-10','12:00:00',8.31),('8902','2014-04-10','12:05:00',7.95),('8902','2014-04-10','12:10:00',8.46),('8902','2014-04-10','12:15:00',8.33),('8902','2014-04-10','12:20:00',7.98),('8902','2014-04-10','12:25:00',5.77),('8902','2014-04-10','12:30:00',8.39),('8902','2014-04-10','12:35:00',8.47),('8902','2014-04-10','12:40:00',8.67),('8902','2014-04-10','12:45:00',9.05),('8902','2014-04-10','12:50:00',7.87),('8902','2014-04-10','12:55:00',8.62),('8902','2014-04-10','13:00:00',8.61),('8902','2014-04-10','13:05:00',5.76),('8902','2014-04-10','13:10:00',8.63),('8902','2014-04-10','13:15:00',7.45),('8902','2014-04-10','13:20:00',4.78),('8902','2014-04-10','13:25:00',7.27),('8902','2014-04-10','13:30:00',8.09),('8902','2014-04-10','13:35:00',4.53),('8902','2014-04-10','13:40:00',6.82),('8902','2014-04-10','13:45:00',6.05),('8902','2014-04-10','13:50:00',8.13),('8902','2014-04-10','13:55:00',6.64),('8902','2014-04-10','14:00:00',7.39),('8902','2014-04-10','14:05:00',6.41),('8902','2014-04-10','14:10:00',5.91),('8902','2014-04-10','14:15:00',5.84),('8902','2014-04-10','14:20:00',3.78),('8902','2014-04-10','14:25:00',5.6),('8902','2014-04-10','14:30:00',8.63),('8902','2014-04-10','14:35:00',8.97),('8902','2014-04-10','14:40:00',8.9),('8902','2014-04-10','14:45:00',7.67),('8902','2014-04-10','14:50:00',7.56),('8902','2014-04-10','14:55:00',5.53),('8902','2014-04-10','15:00:00',4.35),('8902','2014-04-10','15:05:00',4.97),('8902','2014-04-10','15:10:00',6.83),('8902','2014-04-10','15:15:00',7.78),('8902','2014-04-10','15:20:00',7.14),('8902','2014-04-10','15:25:00',6.87),('8902','2014-04-10','15:30:00',7.39),('8902','2014-04-10','15:35:00',7.29),('8902','2014-04-10','15:40:00',7.11),('8902','2014-04-10','15:45:00',6.93),('8902','2014-04-10','15:50:00',6.85),('8902','2014-04-10','15:55:00',5.88),('8902','2014-04-10','16:00:00',6.68),('8902','2014-04-10','16:05:00',6.53),('8902','2014-04-10','16:10:00',6.41),('8902','2014-04-10','16:15:00',6.21),('8902','2014-04-10','16:20:00',6.03),('8902','2014-04-10','16:25:00',5.82),('8902','2014-04-10','16:30:00',5.76),('8902','2014-04-10','16:35:00',5.58),('8902','2014-04-10','16:40:00',4.96),('8902','2014-04-10','16:45:00',5.34),('8902','2014-04-10','16:50:00',5.33),('8902','2014-04-10','16:55:00',3.2),('8902','2014-04-10','17:00:00',4.91),('8902','2014-04-10','17:05:00',3.37),('8902','2014-04-10','17:10:00',4.53),('8902','2014-04-10','17:15:00',3.06),('8902','2014-04-10','17:20:00',3.19),('8902','2014-04-10','17:25:00',3.98),('8902','2014-04-10','17:30:00',3.95),('8902','2014-04-10','17:35:00',3.86),('8902','2014-04-10','17:40:00',3.61),('8902','2014-04-10','17:45:00',3.28),('8902','2014-04-10','17:50:00',3.04),('8902','2014-04-10','17:55:00',2.8),('8902','2014-04-10','18:00:00',2.55),('8902','2014-04-10','18:05:00',2.23),('8902','2014-04-10','18:10:00',2.12),('8902','2014-04-10','18:15:00',2.01),('8902','2014-04-10','18:20:00',1.88),('8902','2014-04-10','18:25:00',1.71),('8902','2014-04-10','18:30:00',1.7),('8902','2014-04-10','18:35:00',1.58),('8902','2014-04-10','18:40:00',1.38),('8902','2014-04-10','18:45:00',1.15),('8902','2014-04-10','18:50:00',1.01),('8902','2013-08-28','07:55:00',1.19),('8902','2013-08-28','08:00:00',1.38),('8902','2013-08-28','08:05:00',1.54),('8902','2013-08-28','08:10:00',1.75),('8902','2013-08-28','08:15:00',1.98),('8902','2013-08-28','08:20:00',2.28),('8902','2013-08-28','08:25:00',2.65),('8902','2013-08-28','08:30:00',3.08),('8902','2013-08-28','08:35:00',3.11),('8902','2013-08-28','08:40:00',2.51),('8902','2013-08-28','08:45:00',1.98),('8902','2013-08-28','08:50:00',2.26),('8902','2013-08-28','08:55:00',2.98),('8902','2013-08-28','09:00:00',2.94),('8902','2013-08-28','09:05:00',2.89),('8902','2013-08-28','09:10:00',2.85),('8902','2013-08-28','09:15:00',3.04),('8902','2013-08-28','09:20:00',3.03),('8902','2013-08-28','09:25:00',2.8),('8902','2013-08-28','09:30:00',2.88),('8902','2013-08-28','09:35:00',3.14),('8902','2013-08-28','09:40:00',3.2),('8902','2013-08-28','09:45:00',2.85),('8902','2013-08-28','09:50:00',2.76),('8902','2013-08-28','09:55:00',2.88),('8902','2013-08-28','10:00:00',3.07),('8902','2013-08-28','10:05:00',2.91),('8902','2013-08-28','10:10:00',2.85),('8902','2013-08-28','10:15:00',2.83),('8902','2013-08-28','10:20:00',2.87),('8902','2013-08-28','10:25:00',2.89),('8902','2013-08-28','10:30:00',2.96),('8902','2013-08-28','10:35:00',2.79),('8902','2013-08-28','10:40:00',2.6),('8902','2013-08-28','10:45:00',2.41),('8902','2013-08-28','10:50:00',2.37),('8902','2013-08-28','10:55:00',2.6),('8902','2013-08-28','11:00:00',2.79),('8902','2013-08-28','11:05:00',2.8),('8902','2013-08-28','11:10:00',4.08),('8902','2013-08-28','11:15:00',5.24),('8902','2013-08-28','11:20:00',4.82),('8902','2013-08-28','11:25:00',3.52),('8902','2013-08-28','11:30:00',3.03),('8902','2013-08-28','11:35:00',2.66),('8902','2013-08-28','11:40:00',2.94),('8902','2013-08-28','11:45:00',3.48),('8902','2013-08-28','11:50:00',3.65),('8902','2013-08-28','11:55:00',3.52),('8902','2013-08-28','12:00:00',3.5),('8902','2013-08-28','12:05:00',4.04),('8902','2013-08-28','12:10:00',4.77),('8902','2013-08-28','12:15:00',5.9),('8902','2013-08-28','12:20:00',4.97),('8902','2013-08-28','12:25:00',5.2),('8902','2013-08-28','12:30:00',5.2),('8902','2013-08-28','12:35:00',6.37),('8902','2013-08-28','12:40:00',8.41),('8902','2013-08-28','12:45:00',8.66),('8902','2013-08-28','12:50:00',5.51),('8902','2013-08-28','12:55:00',7.37),('8902','2013-08-28','13:00:00',5.47),('8902','2013-08-28','13:05:00',4.73),('8902','2013-08-28','13:10:00',4.75),('8902','2013-08-28','13:15:00',4.61),('8902','2013-08-28','13:20:00',4.55),('8902','2013-08-28','13:25:00',3.91),('8902','2013-08-28','13:30:00',3.52),('8902','2013-08-28','13:35:00',3.28),('8902','2013-08-28','13:40:00',3.1),('8902','2013-08-28','13:45:00',2.93),('8902','2013-08-28','13:50:00',2.88),('8902','2013-08-28','13:55:00',3.28),('8902','2013-08-28','14:00:00',4.48),('8902','2013-08-28','14:05:00',3.35),('8902','2013-08-28','14:10:00',2.98),('8902','2013-08-28','14:15:00',2.52),('8902','2013-08-28','14:20:00',2.01),('8902','2013-08-28','14:25:00',1.77),('8902','2013-08-28','14:30:00',1.63),('8902','2013-08-28','14:35:00',1.64),('8902','2013-08-28','14:40:00',1.67),('8902','2013-08-28','14:45:00',1.84),('8902','2013-08-28','14:50:00',2.15),('8902','2013-08-28','14:55:00',2.55),('8902','2013-08-28','15:00:00',2.86),('8902','2013-08-28','15:05:00',3.25),('8902','2013-08-28','15:10:00',2.71),('8902','2013-08-28','15:15:00',2.25),('8902','2013-08-28','15:20:00',2.39),('8902','2013-08-28','15:25:00',2.76),('8902','2013-08-28','15:30:00',4.3),('8902','2013-08-28','15:35:00',4.88),('8902','2013-08-28','15:40:00',4.13),('8902','2013-08-28','15:45:00',4.98),('8902','2013-08-28','15:50:00',5.89),('8902','2013-08-28','15:55:00',6.05),('8902','2013-08-28','16:00:00',6.93),('8902','2013-08-28','16:05:00',6.65),('8902','2013-08-28','16:10:00',6.64),('8902','2013-08-28','16:15:00',6.14),('8902','2013-08-28','16:20:00',5.86),('8902','2013-08-28','16:25:00',5.58),('8902','2013-08-28','16:30:00',5.41),('8902','2013-08-28','16:35:00',5.32),('8902','2013-08-28','16:40:00',5.18),('8902','2013-08-28','16:45:00',4.97),('8902','2013-08-28','16:50:00',4.87),('8902','2013-08-28','16:55:00',4.69),('8902','2013-08-28','17:00:00',4.58),('8902','2013-08-28','17:05:00',4.4),('8902','2013-08-28','17:10:00',4.23),('8902','2013-08-28','17:15:00',4.06),('8902','2013-08-28','17:20:00',3.9),('8902','2013-08-28','17:25:00',3.74),('8902','2013-08-28','17:30:00',3.52),('8902','2013-08-28','17:35:00',3.34),('8902','2013-08-28','17:40:00',3.13),('8902','2013-08-28','17:45:00',2.94),('8902','2013-08-28','17:50:00',2.77),('8902','2013-08-28','17:55:00',2.58),('8902','2013-08-28','18:00:00',2.4),('8902','2013-08-28','18:05:00',2.21),('8902','2013-08-28','18:10:00',2.03),('8902','2013-08-28','18:15:00',1.87),('8902','2013-08-28','18:20:00',1.7),('8902','2013-08-28','18:25:00',1.53),('8902','2013-08-28','18:30:00',1.36),('8902','2013-08-28','18:35:00',1.19),('8902','2013-08-28','18:40:00',1.03),('8902','2013-08-27','07:50:00',1.07),('8902','2013-08-27','07:55:00',1.24),('8902','2013-08-27','08:00:00',1.41),('8902','2013-08-27','08:05:00',1.52),('8902','2013-08-27','08:10:00',1.66),('8902','2013-08-27','08:15:00',1.84),('8902','2013-08-27','08:20:00',1.99),('8902','2013-08-27','08:25:00',2.12),('8902','2013-08-27','08:30:00',2.26),('8902','2013-08-27','08:35:00',2.59),('8902','2013-08-27','08:40:00',1.79),('8902','2013-08-27','08:45:00',2.3),('8902','2013-08-27','08:50:00',2.57),('8902','2013-08-27','08:55:00',1.65),('8902','2013-08-27','09:00:00',3.25),('8902','2013-08-27','09:05:00',2.78),('8902','2013-08-27','09:10:00',2.18),('8902','2013-08-27','09:15:00',2.94),('8902','2013-08-27','09:20:00',2.32),('8902','2013-08-27','09:25:00',1.46),('8902','2013-08-27','09:30:00',1.61),('8902','2013-08-27','09:35:00',3.99),('8902','2013-08-27','09:40:00',4.53),('8902','2013-08-27','09:45:00',4.84),('8902','2013-08-27','09:50:00',4.97),('8902','2013-08-27','09:55:00',5.02),('8902','2013-08-27','10:00:00',5.1),('8902','2013-08-27','10:05:00',5.26),('8902','2013-08-27','10:10:00',5.54),('8902','2013-08-27','10:15:00',4.78),('8902','2013-08-27','10:20:00',5.49),('8902','2013-08-27','10:25:00',5.81),('8902','2013-08-27','10:30:00',2.7),('8902','2013-08-27','10:35:00',2.36),('8902','2013-08-27','10:40:00',4.17),('8902','2013-08-27','10:45:00',3.74),('8902','2013-08-27','10:50:00',6.72),('8902','2013-08-27','10:55:00',6.87),('8902','2013-08-27','11:00:00',4.92),('8902','2013-08-27','11:05:00',3.75),('8902','2013-08-27','11:10:00',7.06),('8902','2013-08-27','11:15:00',4.39),('8902','2013-08-27','11:20:00',7.57),('8902','2013-08-27','11:25:00',7.32),('8902','2013-08-27','11:30:00',7.39),('8902','2013-08-27','11:35:00',7.48),('8902','2013-08-27','11:40:00',7.81),('8902','2013-08-27','11:45:00',7.52),('8902','2013-08-27','11:50:00',4.98),('8902','2013-08-27','11:55:00',6.55),('8902','2013-08-27','12:00:00',2.17),('8902','2013-08-27','12:05:00',8.02),('8902','2013-08-27','12:10:00',8.11),('8902','2013-08-27','12:15:00',4.09),('8902','2013-08-27','12:20:00',8.08),('8902','2013-08-27','12:25:00',7.98),('8902','2013-08-27','12:30:00',7.92),('8902','2013-08-27','12:35:00',7.83),('8902','2013-08-27','12:40:00',7.89),('8902','2013-08-27','12:45:00',8.18),('8902','2013-08-27','12:50:00',8.1),('8902','2013-08-27','12:55:00',8.05),('8902','2013-08-27','13:00:00',8.15),('8902','2013-08-27','13:05:00',7.7),('8902','2013-08-27','13:10:00',8.31),('8902','2013-08-27','13:15:00',8.33),('8902','2013-08-27','13:20:00',8.1),('8902','2013-08-27','13:25:00',8.1),('8902','2013-08-27','13:30:00',7.61),('8902','2013-08-27','13:35:00',8.13),('8902','2013-08-27','13:40:00',8.26),('8902','2013-08-27','13:45:00',8.22),('8902','2013-08-27','13:50:00',8.2),('8902','2013-08-27','13:55:00',7.37),('8902','2013-08-27','14:00:00',7.35),('8902','2013-08-27','14:05:00',8.06),('8902','2013-08-27','14:10:00',7),('8902','2013-08-27','14:15:00',8.12),('8902','2013-08-27','14:20:00',7.9),('8902','2013-08-27','14:25:00',7.61),('8902','2013-08-27','14:30:00',7.11),('8902','2013-08-27','14:35:00',6.62),('8902','2013-08-27','14:40:00',8.08),('8902','2013-08-27','14:45:00',7.79),('8902','2013-08-27','14:50:00',7.62),('8902','2013-08-27','14:55:00',7.57),('8902','2013-08-27','15:00:00',7.53),('8902','2013-08-27','15:05:00',6.89),('8902','2013-08-27','15:10:00',6.82),('8902','2013-08-27','15:15:00',7.53),('8902','2013-08-27','15:20:00',7.4),('8902','2013-08-27','15:25:00',7.26),('8902','2013-08-27','15:30:00',4.86),('8902','2013-08-27','15:35:00',7.63),('8902','2013-08-27','15:40:00',5.09),('8902','2013-08-27','15:45:00',2.03),('8902','2013-08-27','15:50:00',3.49),('8902','2013-08-27','15:55:00',3.78),('8902','2013-08-27','16:00:00',6.88),('8902','2013-08-27','16:05:00',6.04),('8902','2013-08-27','16:10:00',6.26),('8902','2013-08-27','16:15:00',5.78),('8902','2013-08-27','16:20:00',2.67),('8902','2013-08-27','16:25:00',6.39),('8902','2013-08-27','16:30:00',5.86),('8902','2013-08-27','16:35:00',5.74),('8902','2013-08-27','16:40:00',5.62),('8902','2013-08-27','16:45:00',5.32),('8902','2013-08-27','16:50:00',5.05),('8902','2013-08-27','16:55:00',4.49),('8902','2013-08-27','17:00:00',4.85),('8902','2013-08-27','17:05:00',4.57),('8902','2013-08-27','17:10:00',3.89),('8902','2013-08-27','17:15:00',3.75),('8902','2013-08-27','17:20:00',2.78),('8902','2013-08-27','17:25:00',3.36),('8902','2013-08-27','17:30:00',2.66),('8902','2013-08-27','17:35:00',3.02),('8902','2013-08-27','17:40:00',3.15),('8902','2013-08-27','17:45:00',2.65),('8902','2013-08-27','17:55:00',1.1),('8902','2013-08-27','18:00:00',1.39),('8902','2013-08-27','18:05:00',1.02),('8902','2013-08-27','18:10:00',1.07),('8902','2013-08-27','18:15:00',2.13),('8902','2013-08-27','18:20:00',1.14),('8902','2013-08-27','18:25:00',1.57),('8902','2013-08-26','08:05:00',1.01),('8902','2013-08-26','08:10:00',1.21),('8902','2013-08-26','08:15:00',1.47),('8902','2013-08-26','08:20:00',1.98),('8902','2013-08-26','08:25:00',2.57),('8902','2013-08-26','08:30:00',2.62),('8902','2013-08-26','08:35:00',1.89),('8902','2013-08-26','08:40:00',1.72),('8902','2013-08-26','08:45:00',2.12),('8902','2013-08-26','08:50:00',1.56),('8902','2013-08-26','08:55:00',1.42),('8902','2013-08-26','09:00:00',1.67),('8902','2013-08-26','09:05:00',1.76),('8902','2013-08-26','09:10:00',2.33),('8902','2013-08-26','09:15:00',2.35),('8902','2013-08-26','09:20:00',2.67),('8902','2013-08-26','09:25:00',3.56),('8902','2013-08-26','09:30:00',3.96),('8902','2013-08-26','09:35:00',2.47),('8902','2013-08-26','09:40:00',1.87),('8902','2013-08-26','09:45:00',1.91),('8902','2013-08-26','09:50:00',1.99),('8902','2013-08-26','09:55:00',2.55),('8902','2013-08-26','10:00:00',3.41),('8902','2013-08-26','10:05:00',4.28),('8902','2013-08-26','10:10:00',5.2),('8902','2013-08-26','10:15:00',5.41),('8902','2013-08-26','10:20:00',5.63),('8902','2013-08-26','10:25:00',5.65),('8902','2013-08-26','10:30:00',5.77),('8902','2013-08-26','10:35:00',5.87),('8902','2013-08-26','10:40:00',5.77),('8902','2013-08-26','10:45:00',6.02),('8902','2013-08-26','10:50:00',6.01),('8902','2013-08-26','10:55:00',6.29),('8902','2013-08-26','11:00:00',6.25),('8902','2013-08-26','11:05:00',6.37),('8902','2013-08-26','11:10:00',6.47),('8902','2013-08-26','11:15:00',6.44),('8902','2013-08-26','11:20:00',6.38),('8902','2013-08-26','11:25:00',6.34),('8902','2013-08-26','11:30:00',6.57),('8902','2013-08-26','11:35:00',6.76),('8902','2013-08-26','11:40:00',6.43),('8902','2013-08-26','11:45:00',7.94),('8902','2013-08-26','11:50:00',6.18),('8902','2013-08-26','11:55:00',7.08),('8902','2013-08-26','12:00:00',7.62),('8902','2013-08-26','12:05:00',7.16),('8902','2013-08-26','12:10:00',6.64),('8902','2013-08-26','12:15:00',6.53),('8902','2013-08-26','12:20:00',7.19),('8902','2013-08-26','12:25:00',5.43),('8902','2013-08-26','12:30:00',6.86),('8902','2013-08-26','12:35:00',5.36),('8902','2013-08-26','12:40:00',8.11),('8902','2013-08-26','12:45:00',6.06),('8902','2013-08-26','12:50:00',4.55),('8902','2013-08-26','12:55:00',4.61),('8902','2013-08-26','13:00:00',2.8),('8902','2013-08-26','13:05:00',3.53),('8902','2013-08-26','13:10:00',4.93),('8902','2013-08-26','13:15:00',5.06),('8902','2013-08-26','13:20:00',4.13),('8902','2013-08-26','13:25:00',3.45),('8902','2013-08-26','13:30:00',3.73),('8902','2013-08-26','13:35:00',3.54),('8902','2013-08-26','13:40:00',4.33),('8902','2013-08-26','13:45:00',5.34),('8902','2013-08-26','13:50:00',7.93),('8902','2013-08-26','13:55:00',6.3),('8902','2013-08-26','14:00:00',8.45),('8902','2013-08-26','14:05:00',5.77),('8902','2013-08-26','14:10:00',3.45),('8902','2013-08-26','14:15:00',4.73),('8902','2013-08-26','14:20:00',5.23),('8902','2013-08-26','14:25:00',2.81),('8902','2013-08-26','14:30:00',1.96),('8902','2013-08-26','14:35:00',2.16),('8902','2013-08-26','14:40:00',2.3),('8902','2013-08-26','14:45:00',2.42),('8902','2013-08-26','14:50:00',1.89),('8902','2013-08-26','14:55:00',1.41),('8902','2013-08-26','15:00:00',1.45),('8902','2013-08-26','15:05:00',1.34),('8902','2013-08-26','15:10:00',1.15),('8902','2013-08-26','15:15:00',1.22),('8902','2013-08-26','15:20:00',1.25),('8902','2013-08-26','15:25:00',1.06),('8902','2013-08-26','15:30:00',1.08),('8902','2013-08-26','15:35:00',1.1),('8902','2013-08-26','15:55:00',1.91),('8902','2013-08-26','16:00:00',2.6),('8902','2013-08-26','16:05:00',2.64),('8902','2013-08-26','16:10:00',5.93),('8902','2013-08-26','16:15:00',6.22),('8902','2013-08-26','16:20:00',3.82),('8902','2013-08-26','16:25:00',3.5),('8902','2013-08-26','16:30:00',2.35),('8902','2013-08-26','16:35:00',2.15),('8902','2013-08-26','16:40:00',1.96),('8902','2013-08-26','16:45:00',1.78),('8902','2013-08-26','16:50:00',2.27),('8902','2013-08-26','16:55:00',2),('8902','2013-08-26','17:00:00',1.27),('8902','2013-08-26','17:05:00',1.96),('8902','2013-08-26','17:10:00',4.9),('8902','2013-08-26','17:15:00',2.64),('8902','2013-08-26','17:20:00',1.74),('8902','2013-08-26','17:25:00',1.62),('8902','2013-08-26','17:30:00',1.3),('8902','2013-08-26','17:35:00',1.61),('8902','2013-08-26','17:40:00',1.69),('8902','2013-08-26','17:45:00',2.41),('8902','2013-08-26','17:50:00',2.59),('8902','2013-08-26','17:55:00',2.62),('8902','2013-08-26','18:00:00',2.23),('8902','2013-08-26','18:05:00',1.75),('8902','2013-08-25','07:55:00',1.3),('8902','2013-08-25','08:00:00',1.14),('8902','2013-08-25','08:05:00',2.05),('8902','2013-08-25','08:10:00',2.2),('8902','2013-08-25','08:15:00',1.42),('8902','2013-08-25','08:20:00',2.31),('8902','2013-08-25','08:25:00',2.15),('8902','2013-08-25','08:30:00',2.57),('8902','2013-08-25','08:35:00',1.95),('8902','2013-08-25','08:40:00',2.64),('8902','2013-08-25','08:45:00',2.82),('8902','2013-08-25','08:50:00',2.96),('8902','2013-08-25','08:55:00',3.14),('8902','2013-08-25','09:00:00',3.35),('8902','2013-08-25','09:05:00',3.47),('8902','2013-08-25','09:10:00',3.59),('8902','2013-08-25','09:15:00',3.74),('8902','2013-08-25','09:20:00',3.88),('8902','2013-08-25','09:25:00',3.55),('8902','2013-08-25','09:30:00',4.16),('8902','2013-08-25','09:35:00',4.31),('8902','2013-08-25','09:40:00',4.51),('8902','2013-08-25','09:45:00',4.65),('8902','2013-08-25','09:50:00',4.76),('8902','2013-08-25','09:55:00',4.95),('8902','2013-08-25','10:00:00',5.01),('8902','2013-08-25','10:05:00',5.13),('8902','2013-08-25','10:10:00',5.27),('8902','2013-08-25','10:15:00',5.39),('8902','2013-08-25','10:20:00',5.48),('8902','2013-08-25','10:25:00',5.61),('8902','2013-08-25','10:30:00',5.76),('8902','2013-08-25','10:35:00',5.81),('8902','2013-08-25','10:40:00',5.88),('8902','2013-08-25','10:45:00',6.08),('8902','2013-08-25','10:50:00',6.16),('8902','2013-08-25','10:55:00',5.66),('8902','2013-08-25','11:00:00',6.11),('8902','2013-08-25','11:05:00',6.44),('8902','2013-08-25','11:10:00',6.46),('8902','2013-08-25','11:15:00',6.59),('8902','2013-08-25','11:20:00',6.65),('8902','2013-08-25','11:25:00',6.68),('8902','2013-08-25','11:30:00',6.73),('8902','2013-08-25','11:35:00',6.95),('8902','2013-08-25','11:40:00',6.95),('8902','2013-08-25','11:45:00',6.97),('8902','2013-08-25','11:50:00',7.04),('8902','2013-08-25','11:55:00',7.13),('8902','2013-08-25','12:00:00',7.14),('8902','2013-08-25','12:05:00',7.18),('8902','2013-08-25','12:10:00',7.26),('8902','2013-08-25','12:15:00',7.28),('8902','2013-08-25','12:20:00',7.27),('8902','2013-08-25','12:25:00',7.3),('8902','2013-08-25','12:30:00',7.28),('8902','2013-08-25','12:35:00',7.31),('8902','2013-08-25','12:40:00',7.41),('8902','2013-08-25','12:45:00',7.49),('8902','2013-08-25','12:50:00',7.52),('8902','2013-08-25','12:55:00',7.53),('8902','2013-08-25','13:00:00',7.83),('8902','2013-08-25','13:05:00',8.29),('8902','2013-08-25','13:10:00',8.14),('8902','2013-08-25','13:15:00',4.18),('8902','2013-08-25','13:20:00',4.9),('8902','2013-08-25','13:25:00',5.84),('8902','2013-08-25','13:30:00',5.41),('8902','2013-08-25','13:35:00',7.86),('8902','2013-08-25','13:40:00',7.67),('8902','2013-08-25','13:45:00',7.7),('8902','2013-08-25','13:50:00',7.83),('8902','2013-08-25','13:55:00',6.24),('8902','2013-08-25','14:00:00',5.03),('8902','2013-08-25','14:05:00',6.99),('8902','2013-08-25','14:10:00',5.11),('8902','2013-08-25','14:15:00',7.51),('8902','2013-08-25','14:20:00',7.45),('8902','2013-08-25','14:25:00',7.34),('8902','2013-08-25','14:30:00',7.42),('8902','2013-08-25','14:35:00',7.06),('8902','2013-08-25','14:40:00',6.41),('8902','2013-08-25','14:45:00',5.02),('8902','2013-08-25','14:50:00',4.36),('8902','2013-08-25','14:55:00',3.95),('8902','2013-08-25','15:00:00',3.78),('8902','2013-08-25','15:05:00',2.76),('8902','2013-08-25','15:10:00',2.08),('8902','2013-08-25','15:15:00',1.8),('8902','2013-08-25','15:20:00',1.49),('8902','2013-08-25','15:25:00',1.37),('8902','2013-08-25','15:30:00',1.48),('8902','2013-08-25','15:35:00',1.88),('8902','2013-08-25','15:40:00',3.06),('8902','2013-08-25','15:45:00',3.34),('8902','2013-08-25','15:50:00',3.24),('8902','2013-08-25','15:55:00',3.04),('8902','2013-08-25','16:00:00',4.91),('8902','2013-08-25','16:05:00',6.62),('8902','2013-08-25','16:10:00',5.92),('8902','2013-08-25','16:15:00',5.59),('8902','2013-08-25','16:20:00',5.51),('8902','2013-08-25','16:25:00',5.3),('8902','2013-08-25','16:30:00',5.12),('8902','2013-08-25','16:35:00',5.04),('8902','2013-08-25','16:40:00',4.93),('8902','2013-08-25','16:45:00',4.83),('8902','2013-08-25','16:50:00',4.46),('8902','2013-08-25','16:55:00',4.35),('8902','2013-08-25','17:00:00',4.33),('8902','2013-08-25','17:05:00',3.92),('8902','2013-08-25','17:10:00',3.95),('8902','2013-08-25','17:15:00',3.79),('8902','2013-08-25','17:20:00',2.83),('8902','2013-08-25','17:25:00',1.17),('8902','2013-08-25','17:30:00',2.5),('8902','2013-08-25','17:35:00',2.11),('8902','2013-08-25','17:40:00',2.04),('8902','2013-08-25','17:45:00',2.51),('8902','2013-08-25','17:50:00',2.71),('8902','2013-08-25','17:55:00',2.77),('8902','2013-08-25','18:00:00',2.41),('8902','2013-08-25','18:05:00',2.11),('8902','2013-08-25','18:10:00',1.91),('8902','2013-08-25','18:15:00',1.7),('8902','2013-08-25','18:20:00',1.5),('8902','2013-08-25','18:25:00',1.38),('8902','2013-08-25','18:30:00',1.21),('8902','2013-08-25','18:35:00',1.09),('8902','2013-08-24','07:55:00',1.24),('8902','2013-08-24','08:00:00',1.4),('8902','2013-08-24','08:05:00',1.6),('8902','2013-08-24','08:10:00',1.91),('8902','2013-08-24','08:15:00',1.88),('8902','2013-08-24','08:20:00',1.88),('8902','2013-08-24','08:25:00',1.96),('8902','2013-08-24','08:30:00',1.56),('8902','2013-08-24','08:35:00',1.44),('8902','2013-08-24','08:40:00',2),('8902','2013-08-24','08:45:00',2.83),('8902','2013-08-24','08:50:00',1.28),('8902','2013-08-24','08:55:00',1.94),('8902','2013-08-24','09:05:00',1.18),('8902','2013-08-24','09:10:00',2.01),('8902','2013-08-24','09:15:00',1.96),('8902','2013-08-24','09:20:00',3.66),('8902','2013-08-24','09:25:00',3.8),('8902','2013-08-24','09:30:00',3.24),('8902','2013-08-24','09:35:00',4.08),('8902','2013-08-24','09:40:00',5.44),('8902','2013-08-24','09:45:00',5.77),('8902','2013-08-24','09:50:00',5.38),('8902','2013-08-24','09:55:00',5.86),('8902','2013-08-24','10:00:00',4.63),('8902','2013-08-24','10:05:00',3.25),('8902','2013-08-24','10:10:00',1.87),('8902','2013-08-24','10:15:00',1.37),('8902','2013-08-24','10:20:00',1.38),('8902','2013-08-24','10:25:00',1.05),('8902','2013-08-24','15:00:00',1.32),('8902','2013-08-24','15:05:00',1.68),('8902','2013-08-24','15:10:00',1.85),('8902','2013-08-24','15:15:00',2.18),('8902','2013-08-24','15:20:00',2.65),('8902','2013-08-24','15:25:00',2.95),('8902','2013-08-24','15:30:00',4.12),('8902','2013-08-24','15:35:00',6.08),('8902','2013-08-24','15:40:00',6.83),('8902','2013-08-24','15:45:00',7.47),('8902','2013-08-24','15:50:00',5.63),('8902','2013-08-24','15:55:00',4.82),('8902','2013-08-24','16:00:00',6.82),('8902','2013-08-24','16:05:00',6.5),('8902','2013-08-24','16:10:00',6.23),('8902','2013-08-24','16:15:00',6.07),('8902','2013-08-24','16:20:00',5.88),('8902','2013-08-24','16:25:00',5.72),('8902','2013-08-24','16:30:00',5.59),('8902','2013-08-24','16:35:00',4.69),('8902','2013-08-24','16:40:00',4.18),('8902','2013-08-24','16:45:00',2.72),('8902','2013-08-24','16:50:00',3.83),('8902','2013-08-24','16:55:00',5.46),('8902','2013-08-24','17:00:00',5.02),('8902','2013-08-24','17:05:00',4.72),('8902','2013-08-24','17:10:00',4.45),('8902','2013-08-24','17:15:00',4.11),('8902','2013-08-24','17:20:00',3.94),('8902','2013-08-24','17:25:00',3.73),('8902','2013-08-24','17:30:00',3.49),('8902','2013-08-24','17:35:00',3.09),('8902','2013-08-24','17:40:00',2.57),('8902','2013-08-24','17:45:00',3.05),('8902','2013-08-24','17:50:00',2.74),('8902','2013-08-24','17:55:00',2.38),('8902','2013-08-24','18:00:00',1.76),('8902','2013-08-24','18:05:00',1.65),('8902','2013-08-24','18:10:00',1.85),('8902','2013-08-24','18:15:00',1.97),('8902','2013-08-24','18:20:00',1.81),('8902','2013-08-24','18:25:00',1.63),('8902','2013-08-24','18:30:00',1.24),('8902','2013-08-24','18:35:00',1.02),('8902','2013-08-23','08:05:00',1.29),('8902','2013-08-23','08:10:00',1.19),('8902','2013-08-23','08:15:00',1.23),('8902','2013-08-23','08:25:00',1.87),('8902','2013-08-23','08:30:00',2.22),('8902','2013-08-23','08:35:00',2.31),('8902','2013-08-23','08:40:00',2.54),('8902','2013-08-23','08:45:00',2.71),('8902','2013-08-23','08:50:00',2.64),('8902','2013-08-23','08:55:00',3.06),('8902','2013-08-23','09:00:00',3.26),('8902','2013-08-23','09:05:00',3.43),('8902','2013-08-23','09:10:00',3.22),('8902','2013-08-23','09:15:00',3.19),('8902','2013-08-23','09:20:00',4.15),('8902','2013-08-23','09:25:00',3.78),('8902','2013-08-23','09:30:00',3.54),('8902','2013-08-23','09:35:00',4.59),('8902','2013-08-23','09:40:00',4.73),('8902','2013-08-23','09:45:00',4.76),('8902','2013-08-23','09:50:00',4.87),('8902','2013-08-23','09:55:00',2.08),('8902','2013-08-23','10:00:00',1.82),('8902','2013-08-23','10:05:00',3.35),('8902','2013-08-23','10:10:00',5.21),('8902','2013-08-23','10:15:00',5.46),('8902','2013-08-23','10:20:00',5.56),('8902','2013-08-23','10:25:00',5.66),('8902','2013-08-23','10:30:00',5.75),('8902','2013-08-23','10:35:00',5.87),('8902','2013-08-23','10:40:00',5.99),('8902','2013-08-23','10:45:00',6.06),('8902','2013-08-23','10:50:00',5.99),('8902','2013-08-23','10:55:00',6.35),('8902','2013-08-23','11:00:00',6.31),('8902','2013-08-23','11:05:00',6.24),('8902','2013-08-23','11:10:00',6.6),('8902','2013-08-23','11:15:00',6.61),('8902','2013-08-23','11:20:00',6.59),('8902','2013-08-23','11:25:00',6.71),('8902','2013-08-23','11:30:00',6.73),('8902','2013-08-23','11:35:00',6.89),('8902','2013-08-23','11:40:00',6.92),('8902','2013-08-23','11:45:00',6.97),('8902','2013-08-23','11:50:00',7.03),('8902','2013-08-23','11:55:00',6.97),('8902','2013-08-23','12:00:00',7.14),('8902','2013-08-23','12:05:00',7.23),('8902','2013-08-23','12:10:00',7.32),('8902','2013-08-23','12:15:00',7.38),('8902','2013-08-23','12:20:00',7.33),('8902','2013-08-23','12:25:00',7.43),('8902','2013-08-23','12:30:00',7.33),('8902','2013-08-23','12:35:00',7.4),('8902','2013-08-23','12:40:00',7.41),('8902','2013-08-23','12:45:00',7.34),('8902','2013-08-23','12:50:00',7.39),('8902','2013-08-23','12:55:00',7.46),('8902','2013-08-23','13:00:00',7.4),('8902','2013-08-23','13:05:00',7.45),('8902','2013-08-23','13:10:00',7.49),('8902','2013-08-23','13:15:00',7.54),('8902','2013-08-23','13:20:00',7.62),('8902','2013-08-23','13:25:00',7.64),('8902','2013-08-23','13:30:00',7.65),('8902','2013-08-23','13:35:00',7.67),('8902','2013-08-23','13:40:00',7.66),('8902','2013-08-23','13:45:00',7.63),('8902','2013-08-23','13:50:00',7.6),('8902','2013-08-23','13:55:00',7.49),('8902','2013-08-23','14:00:00',7.49),('8902','2013-08-23','14:05:00',7.51),('8902','2013-08-23','14:10:00',7.5),('8902','2013-08-23','14:15:00',7.41),('8902','2013-08-23','14:20:00',7.4),('8902','2013-08-23','14:25:00',7.33),('8902','2013-08-23','14:30:00',7.3),('8902','2013-08-23','14:35:00',7.35),('8902','2013-08-23','14:40:00',7.28),('8902','2013-08-23','14:45:00',7.2),('8902','2013-08-23','14:50:00',7.13),('8902','2013-08-23','14:55:00',7.09),('8902','2013-08-23','15:00:00',7.02),('8902','2013-08-23','15:05:00',6.95),('8902','2013-08-23','15:10:00',6.83),('8902','2013-08-23','15:15:00',6.74),('8902','2013-08-23','15:20:00',6.67),('8902','2013-08-23','15:25:00',6.64),('8902','2013-08-23','15:30:00',6.58),('8902','2013-08-23','15:35:00',6.46),('8902','2013-08-23','15:40:00',6.38),('8902','2013-08-23','15:45:00',6.24),('8902','2013-08-23','15:50:00',6.19),('8902','2013-08-23','15:55:00',6.1),('8902','2013-08-23','16:00:00',5.99),('8902','2013-08-23','16:05:00',5.92),('8902','2013-08-23','16:10:00',5.81),('8902','2013-08-23','16:15:00',5.69),('8902','2013-08-23','16:20:00',5.59),('8902','2013-08-23','16:25:00',5.46),('8902','2013-08-23','16:30:00',5.3),('8902','2013-08-23','16:35:00',5.16),('8902','2013-08-23','16:40:00',5.02),('8902','2013-08-23','16:45:00',4.86),('8902','2013-08-23','16:50:00',4.69),('8902','2013-08-23','16:55:00',4.59),('8902','2013-08-23','17:00:00',4.49),('8902','2013-08-23','17:05:00',4.34),('8902','2013-08-23','17:10:00',4.17),('8902','2013-08-23','17:15:00',4.04),('8902','2013-08-23','17:20:00',3.9),('8902','2013-08-23','17:25:00',3.74),('8902','2013-08-23','17:30:00',3.52),('8902','2013-08-23','17:35:00',3.38),('8902','2013-08-23','17:40:00',3.18),('8902','2013-08-23','17:45:00',3),('8902','2013-08-23','17:50:00',2.86),('8902','2013-08-23','17:55:00',2.68),('8902','2013-08-23','18:00:00',2.48),('8902','2013-08-23','18:05:00',2.28),('8902','2013-08-23','18:10:00',2.13),('8902','2013-08-23','18:15:00',1.96),('8902','2013-08-23','18:20:00',1.76),('8902','2013-08-23','18:25:00',1.6),('8902','2013-08-23','18:30:00',1.43),('8902','2013-08-23','18:35:00',1.27),('8902','2013-08-23','18:40:00',1.1),('8902','2013-08-22','07:55:00',1.14),('8902','2013-08-22','08:00:00',1.26),('8902','2013-08-22','08:05:00',1.39),('8902','2013-08-22','08:10:00',1.52),('8902','2013-08-22','08:15:00',1.65),('8902','2013-08-22','08:20:00',1.81),('8902','2013-08-22','08:25:00',1.97),('8902','2013-08-22','08:30:00',2.15),('8902','2013-08-22','08:35:00',2.27),('8902','2013-08-22','08:40:00',2.37),('8902','2013-08-22','08:45:00',2.54),('8902','2013-08-22','08:50:00',2.69),('8902','2013-08-22','08:55:00',2.82),('8902','2013-08-22','09:00:00',2.88),('8902','2013-08-22','09:05:00',3.03),('8902','2013-08-22','09:10:00',3.25),('8902','2013-08-22','09:15:00',3.4),('8902','2013-08-22','09:20:00',3.58),('8902','2013-08-22','09:25:00',3.71),('8902','2013-08-22','09:30:00',3.83),('8902','2013-08-22','09:35:00',3.95),('8902','2013-08-22','09:40:00',4.04),('8902','2013-08-22','09:45:00',4.18),('8902','2013-08-22','09:50:00',4.3),('8902','2013-08-22','09:55:00',4.47),('8902','2013-08-22','10:00:00',4.59),('8902','2013-08-22','10:05:00',4.68),('8902','2013-08-22','10:10:00',4.82),('8902','2013-08-22','10:15:00',4.92),('8902','2013-08-22','10:20:00',5.03),('8902','2013-08-22','10:25:00',5.15),('8902','2013-08-22','10:30:00',5.21),('8902','2013-08-22','10:35:00',5.24),('8902','2013-08-22','10:40:00',5.21),('8902','2013-08-22','10:45:00',5.52),('8902','2013-08-22','10:50:00',5.62),('8902','2013-08-22','10:55:00',5.54),('8902','2013-08-22','11:00:00',5.75),('8902','2013-08-22','11:05:00',5.98),('8902','2013-08-22','11:10:00',5.93),('8902','2013-08-22','11:15:00',5.77),('8902','2013-08-22','11:20:00',5.04),('8902','2013-08-22','11:25:00',6.41),('8902','2013-08-22','11:30:00',4.14),('8902','2013-08-22','11:35:00',4.9),('8902','2013-08-22','11:40:00',5.98),('8902','2013-08-22','11:45:00',4.31),('8902','2013-08-22','11:50:00',7.08),('8902','2013-08-22','11:55:00',6.99),('8902','2013-08-22','12:00:00',7.25),('8902','2013-08-22','12:05:00',6.09),('8902','2013-08-22','12:10:00',2.77),('8902','2013-08-22','12:15:00',3.44),('8902','2013-08-22','12:20:00',2.13),('8902','2013-08-22','12:25:00',1.83),('8902','2013-08-22','12:30:00',1.66),('8902','2013-08-22','12:35:00',1.81),('8902','2013-08-22','12:40:00',2.55),('8902','2013-08-22','12:45:00',1.87),('8902','2013-08-22','12:50:00',1.7),('8902','2013-08-22','12:55:00',1.54),('8902','2013-08-22','13:00:00',1.65),('8902','2013-08-22','13:05:00',2.02),('8902','2013-08-22','13:10:00',2.94),('8902','2013-08-22','13:15:00',5.95),('8902','2013-08-22','13:20:00',3.33),('8902','2013-08-22','13:25:00',6.56),('8902','2013-08-22','13:30:00',7.93),('8902','2013-08-22','13:35:00',7.93),('8902','2013-08-22','13:40:00',7.89),('8902','2013-08-22','13:45:00',7.71),('8902','2013-08-22','13:50:00',7.71),('8902','2013-08-22','13:55:00',7.35),('8902','2013-08-22','14:00:00',5.11),('8902','2013-08-22','14:05:00',7.52),('8902','2013-08-22','14:10:00',7.89),('8902','2013-08-22','14:15:00',7.74),('8902','2013-08-22','14:20:00',6.8),('8902','2013-08-22','14:25:00',7.07),('8902','2013-08-22','14:30:00',7.43),('8902','2013-08-22','14:35:00',7.3),('8902','2013-08-22','14:40:00',7.23),('8902','2013-08-22','14:45:00',7.15),('8902','2013-08-22','14:50:00',7.06),('8902','2013-08-22','14:55:00',6.98),('8902','2013-08-22','15:00:00',6.83),('8902','2013-08-22','15:05:00',6.45),('8902','2013-08-22','15:10:00',6.74),('8902','2013-08-22','15:15:00',6.62),('8902','2013-08-22','15:20:00',6.58),('8902','2013-08-22','15:25:00',6.58),('8902','2013-08-22','15:30:00',6.74),('8902','2013-08-22','15:35:00',6.32),('8902','2013-08-22','15:40:00',6.23),('8902','2013-08-22','15:45:00',6.29),('8902','2013-08-22','15:50:00',5.81),('8902','2013-08-22','15:55:00',6.09),('8902','2013-08-22','16:00:00',5.84),('8902','2013-08-22','16:05:00',5.53),('8902','2013-08-22','16:10:00',5.13),('8902','2013-08-22','16:15:00',5.05),('8902','2013-08-22','16:20:00',5.78),('8902','2013-08-22','16:25:00',5.58),('8902','2013-08-22','16:30:00',5.37),('8902','2013-08-22','16:35:00',5.33),('8902','2013-08-22','16:40:00',5.22),('8902','2013-08-22','16:45:00',5.07),('8902','2013-08-22','16:50:00',4.82),('8902','2013-08-22','16:55:00',4.7),('8902','2013-08-22','17:00:00',4.49),('8902','2013-08-22','17:05:00',4.32),('8902','2013-08-22','17:10:00',4.1),('8902','2013-08-22','17:15:00',3.92),('8902','2013-08-22','17:20:00',3.76),('8902','2013-08-22','17:25:00',3.65),('8902','2013-08-22','17:30:00',3.39),('8902','2013-08-22','17:35:00',3.23),('8902','2013-08-22','17:40:00',3.03),('8902','2013-08-22','17:45:00',2.82),('8902','2013-08-22','17:50:00',2.69),('8902','2013-08-22','17:55:00',2.58),('8902','2013-08-22','18:00:00',2.39),('8902','2013-08-22','18:05:00',2.2),('8902','2013-08-22','18:10:00',1.86),('8902','2013-08-22','18:15:00',1.61),('8902','2013-08-22','18:20:00',1.72),('8902','2013-08-22','18:25:00',1.63),('8902','2013-08-22','18:30:00',1.49),('8902','2013-08-22','18:35:00',1.33),('8902','2013-08-22','18:40:00',1.16),('8902','2013-08-22','18:45:00',1),('8902','2013-08-21','07:50:00',1.01),('8902','2013-08-21','07:55:00',1.21),('8902','2013-08-21','08:00:00',1.33),('8902','2013-08-21','08:05:00',1.45),('8902','2013-08-21','08:10:00',1.61),('8902','2013-08-21','08:15:00',1.73),('8902','2013-08-21','08:20:00',1.89),('8902','2013-08-21','08:25:00',2.02),('8902','2013-08-21','08:30:00',2.19),('8902','2013-08-21','08:35:00',2.37),('8902','2013-08-21','08:40:00',2.48),('8902','2013-08-21','08:45:00',2.69),('8902','2013-08-21','08:50:00',2.85),('8902','2013-08-21','08:55:00',3.04),('8902','2013-08-21','09:00:00',3.17),('8902','2013-08-21','09:05:00',3.51),('8902','2013-08-21','09:10:00',3.73),('8902','2013-08-21','09:15:00',3.95),('8902','2013-08-21','09:20:00',4.2),('8902','2013-08-21','09:25:00',4.1),('8902','2013-08-21','09:30:00',3.07),('8902','2013-08-21','09:35:00',2.32),('8902','2013-08-21','09:40:00',2.46),('8902','2013-08-21','09:45:00',3.62),('8902','2013-08-21','09:50:00',3.9),('8902','2013-08-21','09:55:00',4.85),('8902','2013-08-21','10:00:00',5.29),('8902','2013-08-21','10:05:00',5.3),('8902','2013-08-21','10:10:00',5.35),('8902','2013-08-21','10:15:00',5.33),('8902','2013-08-21','10:20:00',5.36),('8902','2013-08-21','10:25:00',5.47),('8902','2013-08-21','10:30:00',5.6),('8902','2013-08-21','10:35:00',5.66),('8902','2013-08-21','10:40:00',5.76),('8902','2013-08-21','10:45:00',5.85),('8902','2013-08-21','10:50:00',5.93),('8902','2013-08-21','10:55:00',6.03),('8902','2013-08-21','11:00:00',6.13),('8902','2013-08-21','11:05:00',6.21),('8902','2013-08-21','11:10:00',6.23),('8902','2013-08-21','11:15:00',6.31),('8902','2013-08-21','11:20:00',6.36),('8902','2013-08-21','11:25:00',6.42),('8902','2013-08-21','11:30:00',6.55),('8902','2013-08-21','11:35:00',6.61),('8902','2013-08-21','11:40:00',6.66),('8902','2013-08-21','11:45:00',6.71),('8902','2013-08-21','11:50:00',6.78),('8902','2013-08-21','11:55:00',6.82),('8902','2013-08-21','12:00:00',6.9),('8902','2013-08-21','12:05:00',6.96),('8902','2013-08-21','12:10:00',7),('8902','2013-08-21','12:15:00',7.01),('8902','2013-08-21','12:20:00',7.03),('8902','2013-08-21','12:25:00',7.05),('8902','2013-08-21','12:30:00',7.1),('8902','2013-08-21','12:35:00',7.14),('8902','2013-08-21','12:40:00',7.14),('8902','2013-08-21','12:45:00',7.17),('8902','2013-08-21','12:50:00',7.19),('8902','2013-08-21','12:55:00',7.2),('8902','2013-08-21','13:00:00',7.18),('8902','2013-08-21','13:05:00',6.95),('8902','2013-08-21','13:10:00',6.97),('8902','2013-08-21','13:15:00',7.04),('8902','2013-08-21','13:20:00',7.14),('8902','2013-08-21','13:25:00',6.99),('8902','2013-08-21','13:30:00',7.1),('8902','2013-08-21','13:35:00',7.09),('8902','2013-08-21','13:40:00',7.12),('8902','2013-08-21','13:45:00',7.22),('8902','2013-08-21','13:50:00',7.18),('8902','2013-08-21','13:55:00',7.12),('8902','2013-08-21','14:00:00',7.07),('8902','2013-08-21','14:05:00',7.05),('8902','2013-08-21','14:10:00',7.05),('8902','2013-08-21','14:15:00',7.06),('8902','2013-08-21','14:20:00',7.04),('8902','2013-08-21','14:25:00',7.12),('8902','2013-08-21','14:30:00',7.14),('8902','2013-08-21','14:35:00',7.04),('8902','2013-08-21','14:40:00',6.97),('8902','2013-08-21','14:45:00',6.83),('8902','2013-08-21','14:50:00',6.77),('8902','2013-08-21','14:55:00',4.46),('8902','2013-08-21','15:00:00',6.81),('8902','2013-08-21','15:05:00',6.8),('8902','2013-08-21','15:10:00',6.65),('8902','2013-08-21','15:15:00',6.62),('8902','2013-08-21','15:20:00',6.51),('8902','2013-08-21','15:25:00',6.4),('8902','2013-08-21','15:30:00',6.33),('8902','2013-08-21','15:35:00',6.25),('8902','2013-08-21','15:40:00',6.19),('8902','2013-08-21','15:45:00',6.1),('8902','2013-08-21','15:50:00',6.02),('8902','2013-08-21','15:55:00',5.92),('8902','2013-08-21','16:00:00',5.79),('8902','2013-08-21','16:05:00',5.62),('8902','2013-08-21','16:10:00',5.51),('8902','2013-08-21','16:15:00',5.44),('8902','2013-08-21','16:20:00',5.33),('8902','2013-08-21','16:25:00',5.22),('8902','2013-08-21','16:30:00',5.06),('8902','2013-08-21','16:35:00',4.94),('8902','2013-08-21','16:40:00',4.79),('8902','2013-08-21','16:45:00',4.61),('8902','2013-08-21','16:50:00',4.39),('8902','2013-08-21','16:55:00',4.37),('8902','2013-08-21','17:00:00',4.17),('8902','2013-08-21','17:05:00',4.07),('8902','2013-08-21','17:10:00',3.86),('8902','2013-08-21','17:15:00',3.69),('8902','2013-08-21','17:20:00',3.57),('8902','2013-08-21','17:25:00',3.43),('8902','2013-08-21','17:30:00',3.26),('8902','2013-08-21','17:35:00',3.11),('8902','2013-08-21','17:40:00',2.92),('8902','2013-08-21','17:45:00',2.72),('8902','2013-08-21','17:50:00',2.55),('8902','2013-08-21','17:55:00',2.45),('8902','2013-08-21','18:00:00',2.29),('8902','2013-08-21','18:05:00',2.13),('8902','2013-08-21','18:10:00',2),('8902','2013-08-21','18:15:00',2),('8902','2013-08-21','18:20:00',1.69),('8902','2013-08-21','18:25:00',1.2),('8902','2013-08-21','18:30:00',1.05),('8902','2013-08-20','08:15:00',1.03),('8902','2013-08-20','08:20:00',1.21),('8902','2013-08-20','08:25:00',1.47),('8902','2013-08-20','08:30:00',1.55),('8902','2013-08-20','08:35:00',1.57),('8902','2013-08-20','08:40:00',1.52),('8902','2013-08-20','08:45:00',1.43),('8902','2013-08-20','08:50:00',1.32),('8902','2013-08-20','08:55:00',1.42),('8902','2013-08-20','09:00:00',1.73),('8902','2013-08-20','09:05:00',2.57),('8902','2013-08-20','09:10:00',2.49),('8902','2013-08-20','09:15:00',4.45),('8902','2013-08-20','09:20:00',4.31),('8902','2013-08-20','09:25:00',2.28),('8902','2013-08-20','09:30:00',1.48),('8902','2013-08-20','09:35:00',1.88),('8902','2013-08-20','09:40:00',2.15),('8902','2013-08-20','09:45:00',2.45),('8902','2013-08-20','09:50:00',5.82),('8902','2013-08-20','09:55:00',6.31),('8902','2013-08-20','10:00:00',5.88),('8902','2013-08-20','10:05:00',4.98),('8902','2013-08-20','10:10:00',3.87),('8902','2013-08-20','10:15:00',3.93),('8902','2013-08-20','10:20:00',3.25),('8902','2013-08-20','10:25:00',3.06),('8902','2013-08-20','10:30:00',3.96),('8902','2013-08-20','10:35:00',6.22),('8902','2013-08-20','10:40:00',5.28),('8902','2013-08-20','10:45:00',4.42),('8902','2013-08-20','10:50:00',3.93),('8902','2013-08-20','10:55:00',3.24),('8902','2013-08-20','11:00:00',4.08),('8902','2013-08-20','11:05:00',3.52),('8902','2013-08-20','11:10:00',3.28),('8902','2013-08-20','11:15:00',4.39),('8902','2013-08-20','11:20:00',7.52),('8902','2013-08-20','11:25:00',4.74),('8902','2013-08-20','11:30:00',5.18),('8902','2013-08-20','11:35:00',7.44),('8902','2013-08-20','11:40:00',7.51),('8902','2013-08-20','11:45:00',7.4),('8902','2013-08-20','11:50:00',5.72),('8902','2013-08-20','11:55:00',7.18),('8902','2013-08-20','12:00:00',7.58),('8902','2013-08-20','12:05:00',7.55),('8902','2013-08-20','12:10:00',7.59),('8902','2013-08-20','12:15:00',7.62),('8902','2013-08-20','12:20:00',6.97),('8902','2013-08-20','12:25:00',5.62),('8902','2013-08-20','12:30:00',6.83),('8902','2013-08-20','12:35:00',6.2),('8902','2013-08-20','12:40:00',6.73),('8902','2013-08-20','12:45:00',7.31),('8902','2013-08-20','12:50:00',7.17),('8902','2013-08-20','12:55:00',6.85),('8902','2013-08-20','13:00:00',7.18),('8902','2013-08-20','13:05:00',7.37),('8902','2013-08-20','13:10:00',7.49),('8902','2013-08-20','13:15:00',7.6),('8902','2013-08-20','13:20:00',7.57),('8902','2013-08-20','13:25:00',7.61),('8902','2013-08-20','13:30:00',7.63),('8902','2013-08-20','13:35:00',7.49),('8902','2013-08-20','13:40:00',7.32),('8902','2013-08-20','13:45:00',7),('8902','2013-08-20','13:50:00',7.11),('8902','2013-08-20','13:55:00',7.08),('8902','2013-08-20','14:00:00',7.06),('8902','2013-08-20','14:05:00',7.36),('8902','2013-08-20','14:10:00',7.37),('8902','2013-08-20','14:15:00',7.42),('8902','2013-08-20','14:20:00',6.33),('8902','2013-08-20','14:25:00',5.64),('8902','2013-08-20','14:30:00',6.66),('8902','2013-08-20','14:35:00',6.5),('8902','2013-08-20','14:40:00',6.67),('8902','2013-08-20','14:45:00',6.69),('8902','2013-08-20','14:50:00',6.31),('8902','2013-08-20','14:55:00',6.37),('8902','2013-08-20','15:00:00',6.62),('8902','2013-08-20','15:05:00',6.67),('8902','2013-08-20','15:10:00',6.43),('8902','2013-08-20','15:15:00',6.39),('8902','2013-08-20','15:20:00',6.2),('8902','2013-08-20','15:25:00',6.18),('8902','2013-08-20','15:30:00',6),('8902','2013-08-20','15:35:00',5.79),('8902','2013-08-20','15:40:00',5.55),('8902','2013-08-20','15:45:00',5.56),('8902','2013-08-20','15:50:00',5.68),('8902','2013-08-20','15:55:00',5.4),('8902','2013-08-20','16:00:00',5),('8902','2013-08-20','16:05:00',4.82),('8902','2013-08-20','16:10:00',4.79),('8902','2013-08-20','16:15:00',4.9),('8902','2013-08-20','16:20:00',5.28),('8902','2013-08-20','16:25:00',5.02),('8902','2013-08-20','16:30:00',5.18),('8902','2013-08-20','16:35:00',5.16),('8902','2013-08-20','16:40:00',4.99),('8902','2013-08-20','16:45:00',4.81),('8902','2013-08-20','16:50:00',4.64),('8902','2013-08-20','16:55:00',4.57),('8902','2013-08-20','17:00:00',4.46),('8902','2013-08-20','17:05:00',4.38),('8902','2013-08-20','17:10:00',4.26),('8902','2013-08-20','17:15:00',4.18),('8902','2013-08-20','17:20:00',4.12),('8902','2013-08-20','17:25:00',4),('8902','2013-08-20','17:30:00',3.74),('8902','2013-08-20','17:35:00',3.6),('8902','2013-08-20','17:40:00',3.46),('8902','2013-08-20','17:45:00',3.31),('8902','2013-08-20','17:50:00',3.21),('8902','2013-08-20','17:55:00',3.07),('8902','2013-08-20','18:00:00',2.9),('8902','2013-08-20','18:05:00',2.73),('8902','2013-08-20','18:10:00',2.5),('8902','2013-08-20','18:15:00',2.3),('8902','2013-08-20','18:20:00',2.09),('8902','2013-08-20','18:25:00',1.83),('8902','2013-08-20','18:30:00',1.63),('8902','2013-08-20','18:35:00',1.33),('8902','2013-08-20','18:40:00',1.16),('8902','2013-08-20','18:45:00',1.06),('8902','2013-08-19','07:40:00',1.15),('8902','2013-08-19','07:45:00',1.19),('8902','2013-08-19','07:50:00',1.39),('8902','2013-08-19','07:55:00',1.68),('8902','2013-08-19','08:00:00',1.61),('8902','2013-08-19','08:05:00',1.45),('8902','2013-08-19','08:10:00',1.2),('8902','2013-08-19','08:15:00',1.22),('8902','2013-08-19','08:20:00',1.3),('8902','2013-08-19','08:25:00',1.36),('8902','2013-08-19','08:30:00',1.29),('8902','2013-08-19','08:35:00',1.24),('8902','2013-08-19','08:40:00',1.32),('8902','2013-08-19','08:45:00',1.5),('8902','2013-08-19','08:50:00',1.77),('8902','2013-08-19','08:55:00',1.98),('8902','2013-08-19','09:00:00',1.95),('8902','2013-08-19','09:05:00',2.23),('8902','2013-08-19','09:10:00',2.13),('8902','2013-08-19','09:15:00',1.92),('8902','2013-08-19','09:20:00',1.86),('8902','2013-08-19','09:25:00',2.81),('8902','2013-08-19','09:30:00',4.09),('8902','2013-08-19','09:35:00',3.98),('8902','2013-08-19','09:40:00',5.01),('8902','2013-08-19','09:45:00',5.3),('8902','2013-08-19','09:50:00',4.33),('8902','2013-08-19','09:55:00',4.49),('8902','2013-08-19','10:00:00',3.33),('8902','2013-08-19','10:05:00',2.39),('8902','2013-08-19','10:10:00',5.72),('8902','2013-08-19','10:15:00',3.44),('8902','2013-08-19','10:20:00',3.87),('8902','2013-08-19','10:25:00',3.17),('8902','2013-08-19','10:30:00',1.9),('8902','2013-08-19','10:35:00',1.79),('8902','2013-08-19','10:40:00',1.76),('8902','2013-08-19','10:45:00',1.66),('8902','2013-08-19','10:50:00',4.94),('8902','2013-08-19','10:55:00',5.18),('8902','2013-08-19','11:00:00',1.72),('8902','2013-08-19','11:05:00',1.09),('8902','2013-08-19','11:10:00',1.33),('8902','2013-08-19','11:15:00',1.86),('8902','2013-08-19','11:20:00',7.62),('8902','2013-08-19','11:25:00',7.13),('8902','2013-08-19','11:30:00',1.73),('8902','2013-08-19','11:35:00',2.08),('8902','2013-08-19','11:40:00',7.83),('8902','2013-08-19','11:45:00',7.46),('8902','2013-08-19','11:50:00',8.65),('8902','2013-08-19','11:55:00',8.22),('8902','2013-08-19','12:00:00',2.98),('8902','2013-08-19','12:05:00',2.63),('8902','2013-08-19','12:10:00',2.35),('8902','2013-08-19','12:15:00',1.69),('8902','2013-08-19','12:20:00',1.83),('8902','2013-08-19','12:25:00',2.08),('8902','2013-08-19','12:30:00',2.33),('8902','2013-08-19','12:35:00',2.56),('8902','2013-08-19','12:40:00',3.2),('8902','2013-08-19','12:45:00',3.26),('8902','2013-08-19','12:50:00',3.35),('8902','2013-08-19','12:55:00',3.52),('8902','2013-08-19','13:00:00',3.36),('8902','2013-08-19','13:05:00',3.13),('8902','2013-08-19','13:10:00',3.03),('8902','2013-08-19','13:15:00',3.18),('8902','2013-08-19','13:20:00',3.27),('8902','2013-08-19','13:25:00',3.43),('8902','2013-08-19','13:30:00',3.69),('8902','2013-08-19','13:35:00',4.63),('8902','2013-08-19','13:40:00',7.7),('8902','2013-08-19','13:45:00',8.44),('8902','2013-08-19','13:50:00',8.26),('8902','2013-08-19','13:55:00',7.99),('8902','2013-08-19','14:00:00',7.79),('8902','2013-08-19','14:05:00',7.8),('8902','2013-08-19','14:10:00',7.88),('8902','2013-08-19','14:15:00',7.77),('8902','2013-08-19','14:20:00',7.64),('8902','2013-08-19','14:25:00',7.4),('8902','2013-08-19','14:30:00',5.64),('8902','2013-08-19','14:35:00',8.19),('8902','2013-08-19','14:40:00',8.16),('8902','2013-08-19','14:45:00',7.58),('8902','2013-08-19','14:50:00',7.66),('8902','2013-08-19','14:55:00',5.82),('8902','2013-08-19','15:00:00',6.08),('8902','2013-08-19','15:05:00',7.16),('8902','2013-08-19','15:10:00',7.67),('8902','2013-08-19','15:15:00',7.52),('8902','2013-08-19','15:20:00',7.3),('8902','2013-08-19','15:25:00',7.09),('8902','2013-08-19','15:30:00',7.27),('8902','2013-08-19','15:35:00',7.26),('8902','2013-08-19','15:40:00',7.3),('8902','2013-08-19','15:45:00',7.63),('8902','2013-08-19','15:50:00',6.58),('8902','2013-08-19','15:55:00',7.8),('8902','2013-08-19','16:00:00',6.7),('8902','2013-08-19','16:05:00',6.93),('8902','2013-08-19','16:10:00',7.24),('8902','2013-08-19','16:15:00',7.12),('8902','2013-08-19','16:20:00',6.99),('8902','2013-08-19','16:25:00',6.66),('8902','2013-08-19','16:30:00',6.05),('8902','2013-08-19','16:35:00',6.26),('8902','2013-08-19','16:40:00',6.42),('8902','2013-08-19','16:45:00',6.13),('8902','2013-08-19','16:50:00',5.5),('8902','2013-08-19','16:55:00',5.29),('8902','2013-08-19','17:00:00',4.96),('8902','2013-08-19','17:05:00',4.72),('8902','2013-08-19','17:10:00',4.47),('8902','2013-08-19','17:15:00',4.21),('8902','2013-08-19','17:20:00',4.15),('8902','2013-08-19','17:25:00',4),('8902','2013-08-19','17:30:00',3.79),('8902','2013-08-19','17:35:00',3.65),('8902','2013-08-19','17:40:00',3.32),('8902','2013-08-19','17:45:00',3.31),('8902','2013-08-19','17:50:00',3.05),('8902','2013-08-19','17:55:00',2.85),('8902','2013-08-19','18:00:00',2),('8902','2013-08-19','18:05:00',2.6),('8902','2013-08-19','18:10:00',2.55),('8902','2013-08-19','18:15:00',2.51),('8902','2013-08-19','18:20:00',2.4),('8902','2013-08-19','18:25:00',2.2),('8902','2013-08-19','18:30:00',2.16),('8902','2013-08-19','18:35:00',1.99),('8902','2013-08-19','18:40:00',1.79),('8902','2013-08-19','18:45:00',1.69),('8902','2013-08-19','18:50:00',1.48),('8902','2013-08-19','18:55:00',1.43),('8902','2013-08-19','19:00:00',1.3),('8902','2013-08-19','19:05:00',1.02),('8902','2014-04-09','07:55:00',1.08),('8902','2014-04-09','08:00:00',1.3),('8902','2014-04-09','08:05:00',1.5),('8902','2014-04-09','08:10:00',1.7),('8902','2014-04-09','08:15:00',1.89),('8902','2014-04-09','08:20:00',2.08),('8902','2014-04-09','08:25:00',2.29),('8902','2014-04-09','08:30:00',2.49),('8902','2014-04-09','08:35:00',2.69),('8902','2014-04-09','08:40:00',2.9),('8902','2014-04-09','08:45:00',3.08),('8902','2014-04-09','08:50:00',3.27),('8902','2014-04-09','08:55:00',3.44),('8902','2014-04-09','09:00:00',3.58),('8902','2014-04-09','09:05:00',3.82),('8902','2014-04-09','09:10:00',3.99),('8902','2014-04-09','09:15:00',4.11),('8902','2014-04-09','09:20:00',4.15),('8902','2014-04-09','09:25:00',4.53),('8902','2014-04-09','09:30:00',4.72),('8902','2014-04-09','09:35:00',4.9),('8902','2014-04-09','09:40:00',5.03),('8902','2014-04-09','09:45:00',5.15),('8902','2014-04-09','09:50:00',5.34),('8902','2014-04-09','09:55:00',5.49),('8902','2014-04-09','10:00:00',5.63),('8902','2014-04-09','10:05:00',5.76),('8902','2014-04-09','10:10:00',5.93),('8902','2014-04-09','10:15:00',5.94),('8902','2014-04-09','10:20:00',6.11),('8902','2014-04-09','10:25:00',6.22),('8902','2014-04-09','10:30:00',6.29),('8902','2014-04-09','10:35:00',6.54),('8902','2014-04-09','10:40:00',6.64),('8902','2014-04-09','10:45:00',6.71),('8902','2014-04-09','10:50:00',6.64),('8902','2014-04-09','10:55:00',6.78),('8902','2014-04-09','11:00:00',6.9),('8902','2014-04-09','11:05:00',7.13),('8902','2014-04-09','11:10:00',6.99),('8902','2014-04-09','11:15:00',7.27),('8902','2014-04-09','11:20:00',7.47),('8902','2014-04-09','11:25:00',7.6),('8902','2014-04-09','11:30:00',7.63),('8902','2014-04-09','11:35:00',7.75),('8902','2014-04-09','11:40:00',7.55),('8902','2014-04-09','11:45:00',7.77),('8902','2014-04-09','11:50:00',7.49),('8902','2014-04-09','11:55:00',7.88),('8902','2014-04-09','12:00:00',7.79),('8902','2014-04-09','12:05:00',7.38),('8902','2014-04-09','12:10:00',7.68),('8902','2014-04-09','12:15:00',7.76),('8902','2014-04-09','12:20:00',7.83),('8902','2014-04-09','12:25:00',7.69),('8902','2014-04-09','12:30:00',7.83),('8902','2014-04-09','12:35:00',8.14),('8902','2014-04-09','12:40:00',8.1),('8902','2014-04-09','12:45:00',8.11),('8902','2014-04-09','12:50:00',7.99),('8902','2014-04-09','12:55:00',7.88),('8902','2014-04-09','13:00:00',7.89),('8902','2014-04-09','13:05:00',7.56),('8902','2014-04-09','13:10:00',7.67),('8902','2014-04-09','13:15:00',7.9),('8902','2014-04-09','13:20:00',7.78),('8902','2014-04-09','13:25:00',8.4),('8902','2014-04-09','13:30:00',8.13),('8902','2014-04-09','13:35:00',8.34),('8902','2014-04-09','13:40:00',8.06),('8902','2014-04-09','13:45:00',8.36),('8902','2014-04-09','13:50:00',8.28),('8902','2014-04-09','13:55:00',8.2),('8902','2014-04-09','14:00:00',8.16),('8902','2014-04-09','14:05:00',8.14),('8902','2014-04-09','14:10:00',8.13),('8902','2014-04-09','14:15:00',8.08),('8902','2014-04-09','14:20:00',8.08),('8902','2014-04-09','14:25:00',8.07),('8902','2014-04-09','14:30:00',8.03),('8902','2014-04-09','14:35:00',8.03),('8902','2014-04-09','14:40:00',7.97),('8902','2014-04-09','14:45:00',7.25),('8902','2014-04-09','14:50:00',7.98),('8902','2014-04-09','14:55:00',7.8),('8902','2014-04-09','15:00:00',7.7),('8902','2014-04-09','15:05:00',7.6),('8902','2014-04-09','15:10:00',7.49),('8902','2014-04-09','15:15:00',7.49),('8902','2014-04-09','15:20:00',7.43),('8902','2014-04-09','15:25:00',7.3),('8902','2014-04-09','15:30:00',6.68),('8902','2014-04-09','15:35:00',6.57),('8902','2014-04-09','15:40:00',6.8),('8902','2014-04-09','15:45:00',6.6),('8902','2014-04-09','15:50:00',6.69),('8902','2014-04-09','15:55:00',6.54),('8902','2014-04-09','16:00:00',6.3),('8902','2014-04-09','16:05:00',6.43),('8902','2014-04-09','16:10:00',6.37),('8902','2014-04-09','16:15:00',6.57),('8902','2014-04-09','16:20:00',6.18),('8902','2014-04-09','16:25:00',6.25),('8902','2014-04-09','16:30:00',5.96),('8902','2014-04-09','16:35:00',5.97),('8902','2014-04-09','16:40:00',5.84),('8902','2014-04-09','16:45:00',5.75),('8902','2014-04-09','16:50:00',5.43),('8902','2014-04-09','16:55:00',5.31),('8902','2014-04-09','17:00:00',5.09),('8902','2014-04-09','17:05:00',4.91),('8902','2014-04-09','17:10:00',4.63),('8902','2014-04-09','17:15:00',4.42),('8902','2014-04-09','17:20:00',4.37),('8902','2014-04-09','17:25:00',4.13),('8902','2014-04-09','17:30:00',3.89),('8902','2014-04-09','17:35:00',3.68),('8902','2014-04-09','17:40:00',3.42),('8902','2014-04-09','17:45:00',3.24),('8902','2014-04-09','17:50:00',3.07),('8902','2014-04-09','17:55:00',2.81),('8902','2014-04-09','18:00:00',2.62),('8902','2014-04-09','18:05:00',2.42),('8902','2014-04-09','18:10:00',2.22),('8902','2014-04-09','18:15:00',2.01),('8902','2014-04-09','18:20:00',1.83),('8902','2014-04-09','18:25:00',1.63),('8902','2014-04-09','18:30:00',1.44),('8902','2014-04-09','18:35:00',1.22),('8902','2014-04-09','18:40:00',1.06),('8902','2013-08-18','07:40:00',1.04),('8902','2013-08-18','07:50:00',1.06),('8902','2013-08-18','07:55:00',1.26),('8902','2013-08-18','08:00:00',1.41),('8902','2013-08-18','08:05:00',1.56),('8902','2013-08-18','08:10:00',1.71),('8902','2013-08-18','08:15:00',1.85),('8902','2013-08-18','08:20:00',2),('8902','2013-08-18','08:25:00',2.18),('8902','2013-08-18','08:30:00',2.33),('8902','2013-08-18','08:35:00',2.48),('8902','2013-08-18','08:40:00',2.58),('8902','2013-08-18','08:45:00',2.8),('8902','2013-08-18','08:50:00',2.99),('8902','2013-08-18','08:55:00',3.17),('8902','2013-08-18','09:00:00',3.34),('8902','2013-08-18','09:05:00',3.48),('8902','2013-08-18','09:10:00',3.64),('8902','2013-08-18','09:15:00',3.79),('8902','2013-08-18','09:20:00',3.96),('8902','2013-08-18','09:25:00',4.07),('8902','2013-08-18','09:30:00',4.21),('8902','2013-08-18','09:35:00',4.36),('8902','2013-08-18','09:40:00',4.5),('8902','2013-08-18','09:45:00',4.64),('8902','2013-08-18','09:50:00',4.75),('8902','2013-08-18','09:55:00',4.9),('8902','2013-08-18','10:00:00',5.04),('8902','2013-08-18','10:05:00',5.14),('8902','2013-08-18','10:10:00',5.28),('8902','2013-08-18','10:15:00',5.4),('8902','2013-08-18','10:20:00',5.5),('8902','2013-08-18','10:25:00',5.6),('8902','2013-08-18','10:30:00',5.69),('8902','2013-08-18','10:35:00',5.81),('8902','2013-08-18','10:40:00',5.91),('8902','2013-08-18','10:45:00',5.99),('8902','2013-08-18','10:50:00',6.06),('8902','2013-08-18','10:55:00',6.16),('8902','2013-08-18','11:00:00',6.28),('8902','2013-08-18','11:05:00',6.32),('8902','2013-08-18','11:10:00',6.33),('8902','2013-08-18','11:15:00',6.4),('8902','2013-08-18','11:20:00',6.5),('8902','2013-08-18','11:25:00',6.5),('8902','2013-08-18','11:30:00',6.63),('8902','2013-08-18','11:35:00',6.55),('8902','2013-08-18','11:40:00',6.75),('8902','2013-08-18','11:45:00',6.86),('8902','2013-08-18','11:50:00',6.87),('8902','2013-08-18','11:55:00',6.91),('8902','2013-08-18','12:00:00',6.96),('8902','2013-08-18','12:05:00',6.93),('8902','2013-08-18','12:10:00',7.06),('8902','2013-08-18','12:15:00',7.1),('8902','2013-08-18','12:20:00',7.21),('8902','2013-08-18','12:25:00',7.21),('8902','2013-08-18','12:30:00',7.15),('8902','2013-08-18','12:35:00',7.28),('8902','2013-08-18','12:40:00',7.29),('8902','2013-08-18','12:45:00',7.29),('8902','2013-08-18','12:50:00',7.44),('8902','2013-08-18','12:55:00',7.41),('8902','2013-08-18','13:00:00',7.42),('8902','2013-08-18','13:05:00',7.49),('8902','2013-08-18','13:10:00',7.53),('8902','2013-08-18','13:15:00',7.53),('8902','2013-08-18','13:20:00',7.58),('8902','2013-08-18','13:25:00',7.55),('8902','2013-08-18','13:30:00',7.56),('8902','2013-08-18','13:35:00',7.56),('8902','2013-08-18','13:40:00',7.56),('8902','2013-08-18','13:45:00',7.55),('8902','2013-08-18','13:50:00',7.52),('8902','2013-08-18','13:55:00',7.56),('8902','2013-08-18','14:00:00',7.55),('8902','2013-08-18','14:05:00',7.47),('8902','2013-08-18','14:10:00',7.5),('8902','2013-08-18','14:15:00',7.46),('8902','2013-08-18','14:20:00',7.47),('8902','2013-08-18','14:25:00',7.44),('8902','2013-08-18','14:30:00',7.38),('8902','2013-08-18','14:35:00',7.4),('8902','2013-08-18','14:40:00',7.38),('8902','2013-08-18','14:45:00',7.35),('8902','2013-08-18','14:50:00',7.28),('8902','2013-08-18','14:55:00',7.23),('8902','2013-08-18','15:00:00',7.12),('8902','2013-08-18','15:05:00',7.06),('8902','2013-08-18','15:10:00',6.97),('8902','2013-08-18','15:15:00',6.95),('8902','2013-08-18','15:20:00',6.91),('8902','2013-08-18','15:25:00',6.89),('8902','2013-08-18','15:30:00',6.77),('8902','2013-08-18','15:35:00',6.67),('8902','2013-08-18','15:40:00',6.61),('8902','2013-08-18','15:45:00',6.51),('8902','2013-08-18','15:50:00',6.41),('8902','2013-08-18','15:55:00',6.32),('8902','2013-08-18','16:00:00',6.19),('8902','2013-08-18','16:05:00',6.1),('8902','2013-08-18','16:10:00',6.05),('8902','2013-08-18','16:15:00',5.92),('8902','2013-08-18','16:20:00',5.78),('8902','2013-08-18','16:25:00',5.6),('8902','2013-08-18','16:30:00',5.45),('8902','2013-08-18','16:35:00',5.4),('8902','2013-08-18','16:40:00',5.29),('8902','2013-08-18','16:45:00',5.16),('8902','2013-08-18','16:50:00',4.98),('8902','2013-08-18','16:55:00',4.87),('8902','2013-08-18','17:00:00',4.71),('8902','2013-08-18','17:05:00',4.57),('8902','2013-08-18','17:10:00',4.41),('8902','2013-08-18','17:15:00',4.23),('8902','2013-08-18','17:20:00',4.09),('8902','2013-08-18','17:25:00',3.93),('8902','2013-08-18','17:30:00',3.79),('8902','2013-08-18','17:35:00',3.61),('8902','2013-08-18','17:40:00',3.45),('8902','2013-08-18','17:45:00',3.25),('8902','2013-08-18','17:50:00',3.09),('8902','2013-08-18','17:55:00',2.94),('8902','2013-08-18','18:00:00',2.74),('8902','2013-08-18','18:05:00',2.59),('8902','2013-08-18','18:10:00',2.39),('8902','2013-08-18','18:15:00',2.19),('8902','2013-08-18','18:20:00',2.03),('8902','2013-08-18','18:25:00',1.81),('8902','2013-08-18','18:30:00',1.65),('8902','2013-08-18','18:35:00',1.5),('8902','2013-08-18','18:40:00',1.35),('8902','2013-08-18','18:45:00',1.18),('8902','2013-08-18','18:50:00',1.03),('8902','2013-08-17','07:50:00',1.05),('8902','2013-08-17','07:55:00',1.28),('8902','2013-08-17','08:00:00',1.43),('8902','2013-08-17','08:05:00',1.59),('8902','2013-08-17','08:10:00',1.76),('8902','2013-08-17','08:15:00',1.93),('8902','2013-08-17','08:20:00',2.09),('8902','2013-08-17','08:25:00',2.26),('8902','2013-08-17','08:30:00',2.43),('8902','2013-08-17','08:35:00',2.59),('8902','2013-08-17','08:40:00',2.76),('8902','2013-08-17','08:45:00',2.93),('8902','2013-08-17','08:50:00',3.08),('8902','2013-08-17','08:55:00',3.22),('8902','2013-08-17','09:00:00',3.38),('8902','2013-08-17','09:05:00',3.54),('8902','2013-08-17','09:10:00',3.72),('8902','2013-08-17','09:15:00',3.89),('8902','2013-08-17','09:20:00',4.03),('8902','2013-08-17','09:25:00',4.18),('8902','2013-08-17','09:30:00',4.34),('8902','2013-08-17','09:35:00',4.47),('8902','2013-08-17','09:40:00',4.7),('8902','2013-08-17','09:45:00',4.57),('8902','2013-08-17','09:50:00',4.76),('8902','2013-08-17','09:55:00',3.7),('8902','2013-08-17','10:00:00',5.16),('8902','2013-08-17','10:05:00',4.58),('8902','2013-08-17','10:10:00',4.78),('8902','2013-08-17','10:15:00',5.48),('8902','2013-08-17','10:20:00',5.54),('8902','2013-08-17','10:25:00',5.64),('8902','2013-08-17','10:30:00',5.7),('8902','2013-08-17','10:35:00',5.78),('8902','2013-08-17','10:40:00',5.87),('8902','2013-08-17','10:45:00',5.93),('8902','2013-08-17','10:50:00',5.98),('8902','2013-08-17','10:55:00',6.09),('8902','2013-08-17','11:00:00',6.19),('8902','2013-08-17','11:05:00',6.25),('8902','2013-08-17','11:10:00',6.29),('8902','2013-08-17','11:15:00',6.34),('8902','2013-08-17','11:20:00',6.48),('8902','2013-08-17','11:25:00',6.53),('8902','2013-08-17','11:30:00',6.54),('8902','2013-08-17','11:35:00',6.69),('8902','2013-08-17','11:40:00',6.83),('8902','2013-08-17','11:45:00',6.86),('8902','2013-08-17','11:50:00',6.88),('8902','2013-08-17','11:55:00',6.95),('8902','2013-08-17','12:00:00',7),('8902','2013-08-17','12:05:00',7.16),('8902','2013-08-17','12:10:00',7.2),('8902','2013-08-17','12:15:00',7.01),('8902','2013-08-17','12:20:00',7.26),('8902','2013-08-17','12:25:00',7.41),('8902','2013-08-17','12:30:00',7.57),('8902','2013-08-17','12:35:00',6.99),('8902','2013-08-17','12:40:00',2.54),('8902','2013-08-17','12:45:00',2.47),('8902','2013-08-17','12:50:00',2.23),('8902','2013-08-17','12:55:00',2.39),('8902','2013-08-17','13:00:00',4.13),('8902','2013-08-17','13:05:00',7.41),('8902','2013-08-17','13:10:00',6.9),('8902','2013-08-17','13:15:00',6.92),('8902','2013-08-17','13:20:00',7.52),('8902','2013-08-17','13:25:00',7.52),('8902','2013-08-17','13:30:00',7.6),('8902','2013-08-17','13:35:00',7.61),('8902','2013-08-17','13:40:00',7.65),('8902','2013-08-17','13:45:00',7.56),('8902','2013-08-17','13:50:00',7.55),('8902','2013-08-17','13:55:00',7.47),('8902','2013-08-17','14:00:00',7.49),('8902','2013-08-17','14:05:00',7.58),('8902','2013-08-17','14:10:00',7.42),('8902','2013-08-17','14:15:00',7.37),('8902','2013-08-17','14:20:00',7.39),('8902','2013-08-17','14:25:00',7.37),('8902','2013-08-17','14:30:00',7.4),('8902','2013-08-17','14:35:00',7.39),('8902','2013-08-17','14:40:00',7.31),('8902','2013-08-17','14:45:00',7.28),('8902','2013-08-17','14:50:00',7.22),('8902','2013-08-17','14:55:00',7.16),('8902','2013-08-17','15:00:00',7.09),('8902','2013-08-17','15:05:00',7),('8902','2013-08-17','15:10:00',6.94),('8902','2013-08-17','15:15:00',6.94),('8902','2013-08-17','15:20:00',6.85),('8902','2013-08-17','15:25:00',6.75),('8902','2013-08-17','15:30:00',6.68),('8902','2013-08-17','15:35:00',6.63),('8902','2013-08-17','15:40:00',6.55),('8902','2013-08-17','15:45:00',6.49),('8902','2013-08-17','15:50:00',6.38),('8902','2013-08-17','15:55:00',6.29),('8902','2013-08-17','16:00:00',6.18),('8902','2013-08-17','16:05:00',6.08),('8902','2013-08-17','16:10:00',5.99),('8902','2013-08-17','16:15:00',5.89),('8902','2013-08-17','16:20:00',5.76),('8902','2013-08-17','16:25:00',5.64),('8902','2013-08-17','16:30:00',5.47),('8902','2013-08-17','16:35:00',5.4),('8902','2013-08-17','16:40:00',5.25),('8902','2013-08-17','16:45:00',5.12),('8902','2013-08-17','16:50:00',4.94),('8902','2013-08-17','16:55:00',4.78),('8902','2013-08-17','17:00:00',4.7),('8902','2013-08-17','17:05:00',4.59),('8902','2013-08-17','17:10:00',4.42),('8902','2013-08-17','17:15:00',4.24),('8902','2013-08-17','17:20:00',4.13),('8902','2013-08-17','17:25:00',4),('8902','2013-08-17','17:30:00',3.84),('8902','2013-08-17','17:35:00',3.62),('8902','2013-08-17','17:40:00',3.47),('8902','2013-08-17','17:45:00',3.26),('8902','2013-08-17','17:50:00',3.08),('8902','2013-08-17','17:55:00',2.93),('8902','2013-08-17','18:00:00',2.74),('8902','2013-08-17','18:05:00',2.58),('8902','2013-08-17','18:10:00',2.39),('8902','2013-08-17','18:15:00',2.24),('8902','2013-08-17','18:20:00',2.05),('8902','2013-08-17','18:25:00',1.83),('8902','2013-08-17','18:30:00',1.68),('8902','2013-08-17','18:35:00',1.52),('8902','2013-08-17','18:40:00',1.37),('8902','2013-08-17','18:45:00',1.19),('8902','2013-08-17','18:50:00',1.07),('8902','2013-08-16','07:50:00',1.06),('8902','2013-08-16','07:55:00',1.28),('8902','2013-08-16','08:00:00',1.41),('8902','2013-08-16','08:05:00',1.55),('8902','2013-08-16','08:10:00',1.71),('8902','2013-08-16','08:15:00',1.86),('8902','2013-08-16','08:20:00',2.02),('8902','2013-08-16','08:25:00',2.17),('8902','2013-08-16','08:30:00',2.33),('8902','2013-08-16','08:35:00',2.5),('8902','2013-08-16','08:40:00',2.69),('8902','2013-08-16','08:45:00',2.86),('8902','2013-08-16','08:50:00',3.03),('8902','2013-08-16','08:55:00',3.19),('8902','2013-08-16','09:00:00',3.36),('8902','2013-08-16','09:05:00',3.52),('8902','2013-08-16','09:10:00',3.68),('8902','2013-08-16','09:15:00',3.82),('8902','2013-08-16','09:20:00',3.97),('8902','2013-08-16','09:25:00',4.14),('8902','2013-08-16','09:30:00',4.29),('8902','2013-08-16','09:35:00',4.45),('8902','2013-08-16','09:40:00',4.58),('8902','2013-08-16','09:45:00',4.71),('8902','2013-08-16','09:50:00',4.85),('8902','2013-08-16','09:55:00',4.98),('8902','2013-08-16','10:00:00',5.08),('8902','2013-08-16','10:05:00',5.19),('8902','2013-08-16','10:10:00',5.31),('8902','2013-08-16','10:15:00',5.44),('8902','2013-08-16','10:20:00',5.55),('8902','2013-08-16','10:25:00',5.63),('8902','2013-08-16','10:30:00',5.7),('8902','2013-08-16','10:35:00',5.87),('8902','2013-08-16','10:40:00',5.94),('8902','2013-08-16','10:45:00',6.02),('8902','2013-08-16','10:50:00',6.1),('8902','2013-08-16','10:55:00',6.23),('8902','2013-08-16','11:00:00',6.29),('8902','2013-08-16','11:05:00',6.35),('8902','2013-08-16','11:10:00',6.44),('8902','2013-08-16','11:15:00',6.53),('8902','2013-08-16','11:20:00',6.58),('8902','2013-08-16','11:25:00',6.62),('8902','2013-08-16','11:30:00',6.68),('8902','2013-08-16','11:35:00',6.75),('8902','2013-08-16','11:40:00',6.77),('8902','2013-08-16','11:45:00',6.87),('8902','2013-08-16','11:50:00',7.01),('8902','2013-08-16','11:55:00',7.11),('8902','2013-08-16','12:00:00',6.97),('8902','2013-08-16','12:05:00',7),('8902','2013-08-16','12:10:00',6.98),('8902','2013-08-16','12:15:00',7.16),('8902','2013-08-16','12:20:00',7.32),('8902','2013-08-16','12:25:00',6.18),('8902','2013-08-16','12:30:00',5.97),('8902','2013-08-16','12:35:00',3.7),('8902','2013-08-16','12:40:00',7.37),('8902','2013-08-16','12:45:00',7.47),('8902','2013-08-16','12:50:00',7.45),('8902','2013-08-16','12:55:00',7.51),('8902','2013-08-16','13:00:00',7.61),('8902','2013-08-16','13:05:00',7.5),('8902','2013-08-16','13:10:00',7.57),('8902','2013-08-16','13:15:00',7.66),('8902','2013-08-16','13:20:00',7.66),('8902','2013-08-16','13:25:00',7.74),('8902','2013-08-16','13:30:00',7.79),('8902','2013-08-16','13:35:00',7.61),('8902','2013-08-16','13:40:00',5.39),('8902','2013-08-16','13:45:00',1.85),('8902','2013-08-16','13:50:00',7.58),('8902','2013-08-16','13:55:00',2.68),('8902','2013-08-16','14:00:00',2.67),('8902','2013-08-16','14:05:00',7.47),('8902','2013-08-16','14:10:00',7.68),('8902','2013-08-16','14:15:00',2.36),('8902','2013-08-16','14:20:00',6.4),('8902','2013-08-16','14:25:00',7.79),('8902','2013-08-16','14:30:00',7.56),('8902','2013-08-16','14:35:00',7.35),('8902','2013-08-16','14:40:00',7.4),('8902','2013-08-16','14:45:00',7.25),('8902','2013-08-16','14:50:00',7.19),('8902','2013-08-16','14:55:00',7.09),('8902','2013-08-16','15:00:00',7.13),('8902','2013-08-16','15:05:00',7.02),('8902','2013-08-16','15:10:00',6.97),('8902','2013-08-16','15:15:00',6.87),('8902','2013-08-16','15:20:00',6.84),('8902','2013-08-16','15:25:00',6.78),('8902','2013-08-16','15:30:00',6.69),('8902','2013-08-16','15:35:00',6.61),('8902','2013-08-16','15:40:00',6.55),('8902','2013-08-16','15:45:00',6.48),('8902','2013-08-16','15:50:00',6.4),('8902','2013-08-16','15:55:00',6.32),('8902','2013-08-16','16:00:00',6.21),('8902','2013-08-16','16:05:00',6.1),('8902','2013-08-16','16:10:00',6.05),('8902','2013-08-16','16:15:00',5.99),('8902','2013-08-16','16:20:00',5.82),('8902','2013-08-16','16:25:00',5.74),('8902','2013-08-16','16:30:00',5.45),('8902','2013-08-16','16:35:00',5.43),('8902','2013-08-16','16:40:00',5.4),('8902','2013-08-16','16:45:00',5.26),('8902','2013-08-16','16:50:00',4.92),('8902','2013-08-16','16:55:00',4.86),('8902','2013-08-16','17:00:00',4.83),('8902','2013-08-16','17:05:00',4.61),('8902','2013-08-16','17:10:00',4.49),('8902','2013-08-16','17:15:00',3.79),('8902','2013-08-16','17:20:00',4.09),('8902','2013-08-16','17:25:00',4.04),('8902','2013-08-16','17:30:00',4.03),('8902','2013-08-16','17:35:00',3.86),('8902','2013-08-16','17:40:00',3.7),('8902','2013-08-16','17:45:00',3.5),('8902','2013-08-16','17:50:00',3.27),('8902','2013-08-16','17:55:00',3.13),('8902','2013-08-16','18:00:00',2.93),('8902','2013-08-16','18:05:00',2.73),('8902','2013-08-16','18:10:00',2.49),('8902','2013-08-16','18:15:00',2.37),('8902','2013-08-16','18:20:00',2.16),('8902','2013-08-16','18:25:00',1.93),('8902','2013-08-16','18:30:00',1.77),('8902','2013-08-16','18:35:00',1.6),('8902','2013-08-16','18:40:00',1.44),('8902','2013-08-16','18:45:00',1.26),('8902','2013-08-16','18:50:00',1.12),('8902','2013-08-15','07:50:00',1.06),('8902','2013-08-15','07:55:00',1.29),('8902','2013-08-15','08:00:00',1.44),('8902','2013-08-15','08:05:00',1.59),('8902','2013-08-15','08:10:00',1.75),('8902','2013-08-15','08:15:00',1.92),('8902','2013-08-15','08:20:00',2.09),('8902','2013-08-15','08:25:00',2.26),('8902','2013-08-15','08:30:00',2.43),('8902','2013-08-15','08:35:00',2.6),('8902','2013-08-15','08:40:00',2.76),('8902','2013-08-15','08:45:00',2.93),('8902','2013-08-15','08:50:00',3.1),('8902','2013-08-15','08:55:00',3.27),('8902','2013-08-15','09:00:00',3.44),('8902','2013-08-15','09:05:00',3.61),('8902','2013-08-15','09:10:00',3.78),('8902','2013-08-15','09:15:00',3.94),('8902','2013-08-15','09:20:00',4.11),('8902','2013-08-15','09:25:00',4.26),('8902','2013-08-15','09:30:00',4.41),('8902','2013-08-15','09:35:00',4.56),('8902','2013-08-15','09:40:00',4.71),('8902','2013-08-15','09:45:00',4.85),('8902','2013-08-15','09:50:00',4.99),('8902','2013-08-15','09:55:00',5.13),('8902','2013-08-15','10:00:00',5.26),('8902','2013-08-15','10:05:00',5.4),('8902','2013-08-15','10:10:00',5.51),('8902','2013-08-15','10:15:00',5.62),('8902','2013-08-15','10:20:00',5.72),('8902','2013-08-15','10:25:00',5.83),('8902','2013-08-15','10:30:00',5.94),('8902','2013-08-15','10:35:00',6.05),('8902','2013-08-15','10:40:00',6.14),('8902','2013-08-15','10:45:00',6.23),('8902','2013-08-15','10:50:00',6.32),('8902','2013-08-15','10:55:00',6.41),('8902','2013-08-15','11:00:00',6.48),('8902','2013-08-15','11:05:00',6.56),('8902','2013-08-15','11:10:00',6.64),('8902','2013-08-15','11:15:00',6.72),('8902','2013-08-15','11:20:00',6.76),('8902','2013-08-15','11:25:00',6.8),('8902','2013-08-15','11:30:00',6.89),('8902','2013-08-15','11:35:00',6.99),('8902','2013-08-15','11:40:00',7.07),('8902','2013-08-15','11:45:00',7.08),('8902','2013-08-15','11:50:00',7.1),('8902','2013-08-15','11:55:00',7.16),('8902','2013-08-15','12:00:00',7.22),('8902','2013-08-15','12:05:00',7.22),('8902','2013-08-15','12:10:00',7.27),('8902','2013-08-15','12:15:00',7.3),('8902','2013-08-15','12:20:00',7.36),('8902','2013-08-15','12:25:00',7.42),('8902','2013-08-15','12:30:00',7.45),('8902','2013-08-15','12:35:00',7.45),('8902','2013-08-15','12:40:00',7.47),('8902','2013-08-15','12:45:00',7.5),('8902','2013-08-15','12:50:00',7.52),('8902','2013-08-15','12:55:00',7.54),('8902','2013-08-15','13:00:00',7.53),('8902','2013-08-15','13:05:00',7.53),('8902','2013-08-15','13:10:00',7.61),('8902','2013-08-15','13:15:00',7.59),('8902','2013-08-15','13:20:00',7.57),('8902','2013-08-15','13:25:00',7.53),('8902','2013-08-15','13:30:00',7.48),('8902','2013-08-15','13:35:00',7.48),('8902','2013-08-15','13:40:00',7.48),('8902','2013-08-15','13:45:00',7.46),('8902','2013-08-15','13:50:00',7.5),('8902','2013-08-15','13:55:00',7.44),('8902','2013-08-15','14:00:00',7.42),('8902','2013-08-15','14:05:00',7.42),('8902','2013-08-15','14:10:00',7.38),('8902','2013-08-15','14:15:00',7.35),('8902','2013-08-15','14:20:00',7.36),('8902','2013-08-15','14:25:00',7.32),('8902','2013-08-15','14:30:00',7.28),('8902','2013-08-15','14:35:00',7.29),('8902','2013-08-15','14:40:00',7.19),('8902','2013-08-15','14:45:00',7.12),('8902','2013-08-15','14:50:00',7.05),('8902','2013-08-15','14:55:00',7),('8902','2013-08-15','15:00:00',6.93),('8902','2013-08-15','15:05:00',6.84),('8902','2013-08-15','15:10:00',6.83),('8902','2013-08-15','15:15:00',6.85),('8902','2013-08-15','15:20:00',6.72),('8902','2013-08-15','15:25:00',6.72),('8902','2013-08-15','15:30:00',6.66),('8902','2013-08-15','15:35:00',6.57),('8902','2013-08-15','15:40:00',6.51),('8902','2013-08-15','15:45:00',6.42),('8902','2013-08-15','15:50:00',6.38),('8902','2013-08-15','15:55:00',6.3),('8902','2013-08-15','16:00:00',6.19),('8902','2013-08-15','16:05:00',6.1),('8902','2013-08-15','16:10:00',5.99),('8902','2013-08-15','16:15:00',5.91),('8902','2013-08-15','16:20:00',5.8),('8902','2013-08-15','16:25:00',5.72),('8902','2013-08-15','16:30:00',5.58),('8902','2013-08-15','16:35:00',5.37),('8902','2013-08-15','16:40:00',5.33),('8902','2013-08-15','16:45:00',5.21),('8902','2013-08-15','16:50:00',5),('8902','2013-08-15','16:55:00',4.82),('8902','2013-08-15','17:00:00',4.73),('8902','2013-08-15','17:05:00',4.64),('8902','2013-08-15','17:10:00',4.48),('8902','2013-08-15','17:15:00',4.26),('8902','2013-08-15','17:20:00',4.12),('8902','2013-08-15','17:25:00',3.96),('8902','2013-08-15','17:30:00',3.82),('8902','2013-08-15','17:35:00',3.62),('8902','2013-08-15','17:40:00',3.46),('8902','2013-08-15','17:45:00',3.27),('8902','2013-08-15','17:50:00',3.09),('8902','2013-08-15','17:55:00',2.93),('8902','2013-08-15','18:00:00',2.76),('8902','2013-08-15','18:05:00',2.58),('8902','2013-08-15','18:10:00',2.39),('8902','2013-08-15','18:15:00',2.26),('8902','2013-08-15','18:20:00',2.08),('8902','2013-08-15','18:25:00',1.86),('8902','2013-08-15','18:30:00',1.67),('8902','2013-08-15','18:35:00',1.15),('8902','2013-08-14','07:50:00',1.1),('8902','2013-08-14','07:55:00',1.19),('8902','2013-08-14','08:00:00',1.91),('8902','2013-08-14','08:05:00',1.94),('8902','2013-08-14','08:10:00',1.98),('8902','2013-08-14','08:15:00',1.94),('8902','2013-08-14','08:20:00',2.18),('8902','2013-08-14','08:25:00',2.32),('8902','2013-08-14','08:30:00',2.47),('8902','2013-08-14','08:35:00',2.63),('8902','2013-08-14','08:40:00',2.8),('8902','2013-08-14','08:45:00',2.99),('8902','2013-08-14','08:50:00',3.2),('8902','2013-08-14','08:55:00',3.33),('8902','2013-08-14','09:00:00',3.43),('8902','2013-08-14','09:05:00',3.3),('8902','2013-08-14','09:10:00',2.01),('8902','2013-08-14','09:15:00',2.93),('8902','2013-08-14','09:20:00',4.37),('8902','2013-08-14','09:25:00',4.31),('8902','2013-08-14','09:30:00',4.41),('8902','2013-08-14','09:35:00',4.55),('8902','2013-08-14','09:40:00',4.7),('8902','2013-08-14','09:45:00',4.84),('8902','2013-08-14','09:50:00',5),('8902','2013-08-14','09:55:00',5.15),('8902','2013-08-14','10:00:00',5.28),('8902','2013-08-14','10:05:00',5.39),('8902','2013-08-14','10:10:00',5.5),('8902','2013-08-14','10:15:00',5.65),('8902','2013-08-14','10:20:00',5.77),('8902','2013-08-14','10:25:00',5.9),('8902','2013-08-14','10:30:00',6.03),('8902','2013-08-14','10:35:00',6.09),('8902','2013-08-14','10:40:00',6.2),('8902','2013-08-14','10:45:00',6.18),('8902','2013-08-14','10:50:00',6.07),('8902','2013-08-14','10:55:00',6.01),('8902','2013-08-14','11:00:00',5.52),('8902','2013-08-14','11:05:00',4.6),('8902','2013-08-14','11:10:00',4.83),('8902','2013-08-14','11:15:00',5.38),('8902','2013-08-14','11:20:00',5.89),('8902','2013-08-14','11:25:00',6.52),('8902','2013-08-14','11:30:00',6.95),('8902','2013-08-14','11:35:00',7.23),('8902','2013-08-14','11:40:00',7.43),('8902','2013-08-14','11:45:00',7.7),('8902','2013-08-14','11:50:00',7.79),('8902','2013-08-14','11:55:00',7.73),('8902','2013-08-14','12:00:00',7.8),('8902','2013-08-14','12:05:00',7.77),('8902','2013-08-14','12:10:00',7.69),('8902','2013-08-14','12:15:00',7.73),('8902','2013-08-14','12:20:00',7.73),('8902','2013-08-14','12:25:00',7.74),('8902','2013-08-14','12:30:00',7.69),('8902','2013-08-14','12:35:00',7.76),('8902','2013-08-14','12:40:00',7.73),('8902','2013-08-14','12:45:00',7.78),('8902','2013-08-14','12:50:00',7.65),('8902','2013-08-14','12:55:00',7.42),('8902','2013-08-14','13:00:00',7.6),('8902','2013-08-14','13:05:00',7.36),('8902','2013-08-14','13:10:00',7.35),('8902','2013-08-14','13:15:00',7.2),('8902','2013-08-14','13:20:00',7.57),('8902','2013-08-14','13:25:00',7.74),('8902','2013-08-14','13:30:00',7.77),('8902','2013-08-14','13:35:00',7.77),('8902','2013-08-14','13:40:00',7.68),('8902','2013-08-14','13:45:00',7.61),('8902','2013-08-14','13:50:00',7.55),('8902','2013-08-14','13:55:00',7.62),('8902','2013-08-14','14:00:00',7.67),('8902','2013-08-14','14:05:00',7.6),('8902','2013-08-14','14:10:00',7.53),('8902','2013-08-14','14:15:00',7.57),('8902','2013-08-14','14:20:00',7.47),('8902','2013-08-14','14:25:00',7.19),('8902','2013-08-14','14:30:00',7.19),('8902','2013-08-14','14:35:00',7.35),('8902','2013-08-14','14:40:00',7.23),('8902','2013-08-14','14:45:00',7.15),('8902','2013-08-14','14:50:00',7.13),('8902','2013-08-14','14:55:00',7.12),('8902','2013-08-14','15:00:00',7.03),('8902','2013-08-14','15:05:00',6.92),('8902','2013-08-14','15:10:00',6.85),('8902','2013-08-14','15:15:00',6.76),('8902','2013-08-14','15:20:00',6.69),('8902','2013-08-14','15:25:00',6.57),('8902','2013-08-14','15:30:00',6.54),('8902','2013-08-14','15:35:00',6.53),('8902','2013-08-14','15:40:00',6.41),('8902','2013-08-14','15:45:00',6.27),('8902','2013-08-14','15:50:00',6.17),('8902','2013-08-14','15:55:00',6.18),('8902','2013-08-14','16:00:00',6.03),('8902','2013-08-14','16:05:00',5.9),('8902','2013-08-14','16:10:00',5.76),('8902','2013-08-14','16:15:00',5.7),('8902','2013-08-14','16:20:00',5.66),('8902','2013-08-14','16:25:00',5.44),('8902','2013-08-14','16:30:00',5.11),('8902','2013-08-14','16:35:00',5.07),('8902','2013-08-14','16:40:00',5.1),('8902','2013-08-14','16:45:00',4.94),('8902','2013-08-14','16:50:00',4.79),('8902','2013-08-14','16:55:00',4.56),('8902','2013-08-14','17:00:00',4.54),('8902','2013-08-14','17:05:00',4.39),('8902','2013-08-14','17:10:00',4.23),('8902','2013-08-14','17:15:00',4.19),('8902','2013-08-14','17:20:00',3.99),('8902','2013-08-14','17:25:00',3.77),('8902','2013-08-14','17:30:00',3.72),('8902','2013-08-14','17:35:00',3.5),('8902','2013-08-14','17:40:00',3.38),('8902','2013-08-14','17:45:00',3.21),('8902','2013-08-14','17:50:00',3.02),('8902','2013-08-14','17:55:00',2.85),('8902','2013-08-14','18:00:00',2.71),('8902','2013-08-14','18:05:00',2.54),('8902','2013-08-14','18:10:00',2.31),('8902','2013-08-14','18:15:00',2.18),('8902','2013-08-14','18:20:00',2.04),('8902','2013-08-14','18:25:00',1.83),('8902','2013-08-14','18:30:00',1.65),('8902','2013-08-14','18:35:00',1.56),('8902','2013-08-14','18:40:00',1.44),('8902','2013-08-14','18:45:00',1.17),('8902','2013-08-13','07:50:00',1.11),('8902','2013-08-13','07:55:00',1.33),('8902','2013-08-13','08:00:00',1.47),('8902','2013-08-13','08:05:00',1.6),('8902','2013-08-13','08:10:00',1.76),('8902','2013-08-13','08:15:00',1.92),('8902','2013-08-13','08:20:00',2.04),('8902','2013-08-13','08:25:00',2.19),('8902','2013-08-13','08:30:00',2.38),('8902','2013-08-13','08:35:00',2.55),('8902','2013-08-13','08:40:00',2.8),('8902','2013-08-13','08:45:00',2.91),('8902','2013-08-13','08:50:00',2.74),('8902','2013-08-13','08:55:00',3.24),('8902','2013-08-13','09:00:00',3.41),('8902','2013-08-13','09:05:00',3.61),('8902','2013-08-13','09:10:00',3.8),('8902','2013-08-13','09:15:00',3.94),('8902','2013-08-13','09:20:00',4.16),('8902','2013-08-13','09:25:00',4.02),('8902','2013-08-13','09:30:00',4.49),('8902','2013-08-13','09:35:00',4.53),('8902','2013-08-13','09:40:00',3.64),('8902','2013-08-13','09:45:00',3.23),('8902','2013-08-13','09:50:00',1.84),('8902','2013-08-13','09:55:00',2.68),('8902','2013-08-13','10:00:00',2.27),('8902','2013-08-13','10:05:00',4.2),('8902','2013-08-13','10:10:00',5.2),('8902','2013-08-13','10:15:00',4.3),('8902','2013-08-13','10:20:00',2.46),('8902','2013-08-13','10:25:00',1.98),('8902','2013-08-13','10:30:00',4.71),('8902','2013-08-13','10:35:00',6.51),('8902','2013-08-13','10:40:00',6.67),('8902','2013-08-13','10:45:00',6.42),('8902','2013-08-13','10:50:00',5.31),('8902','2013-08-13','10:55:00',5.64),('8902','2013-08-13','11:00:00',6.28),('8902','2013-08-13','11:05:00',6.86),('8902','2013-08-13','11:10:00',5.58),('8902','2013-08-13','11:15:00',6.6),('8902','2013-08-13','11:20:00',6.14),('8902','2013-08-13','11:25:00',4.51),('8902','2013-08-13','11:30:00',6.86),('8902','2013-08-13','11:35:00',7.08),('8902','2013-08-13','11:40:00',7.1),('8902','2013-08-13','11:45:00',6.64),('8902','2013-08-13','11:50:00',6.89),('8902','2013-08-13','11:55:00',3.67),('8902','2013-08-13','12:00:00',3.08),('8902','2013-08-13','12:05:00',5.04),('8902','2013-08-13','12:10:00',6.95),('8902','2013-08-13','12:15:00',6.21),('8902','2013-08-13','12:20:00',2.22),('8902','2013-08-13','12:25:00',2.19),('8902','2013-08-13','12:30:00',2.11),('8902','2013-08-13','12:35:00',2.52),('8902','2013-08-13','12:40:00',2.39),('8902','2013-08-13','12:45:00',3.46),('8902','2013-08-13','12:50:00',3.21),('8902','2013-08-13','12:55:00',4.28),('8902','2013-08-13','13:00:00',3.29),('8902','2013-08-13','13:05:00',2.08),('8902','2013-08-13','13:10:00',1.95),('8902','2013-08-13','13:15:00',1.63),('8902','2013-08-13','13:20:00',1.57),('8902','2013-08-13','13:25:00',3.26),('8902','2013-08-13','13:30:00',5.61),('8902','2013-08-13','13:35:00',4),('8902','2013-08-13','13:40:00',4.91),('8902','2013-08-13','13:45:00',8.64),('8902','2013-08-13','13:50:00',7.29),('8902','2013-08-13','13:55:00',7.71),('8902','2013-08-13','14:00:00',3.85),('8902','2013-08-13','14:05:00',8.75),('8902','2013-08-13','14:10:00',8.13),('8902','2013-08-13','14:15:00',7.89),('8902','2013-08-13','14:20:00',7.82),('8902','2013-08-13','14:25:00',7.91),('8902','2013-08-13','14:30:00',7.35),('8902','2013-08-13','14:35:00',7.75),('8902','2013-08-13','14:40:00',7.57),('8902','2013-08-13','14:45:00',7.44),('8902','2013-08-13','14:50:00',7.28),('8902','2013-08-13','14:55:00',7.27),('8902','2013-08-13','15:00:00',7.28),('8902','2013-08-13','15:05:00',7.17),('8902','2013-08-13','15:10:00',7.16),('8902','2013-08-13','15:15:00',7.27),('8902','2013-08-13','15:20:00',7.12),('8902','2013-08-13','15:25:00',6.88),('8902','2013-08-13','15:30:00',6.77),('8902','2013-08-13','15:35:00',6.67),('8902','2013-08-13','15:40:00',6.66),('8902','2013-08-13','15:45:00',6.58),('8902','2013-08-13','15:50:00',6.51),('8902','2013-08-13','15:55:00',6.36),('8902','2013-08-13','16:00:00',6.23),('8902','2013-08-13','16:05:00',6.18),('8902','2013-08-13','16:10:00',6.17),('8902','2013-08-13','16:15:00',6.05),('8902','2013-08-13','16:20:00',6.04),('8902','2013-08-13','16:25:00',5.8),('8902','2013-08-13','16:30:00',5.71),('8902','2013-08-13','16:35:00',5.49),('8902','2013-08-13','16:40:00',5.44),('8902','2013-08-13','16:45:00',5.28),('8902','2013-08-13','16:50:00',5.15),('8902','2013-08-13','16:55:00',4.95),('8902','2013-08-13','17:00:00',4.86),('8902','2013-08-13','17:05:00',4.7),('8902','2013-08-13','17:10:00',4.56),('8902','2013-08-13','17:15:00',4.38),('8902','2013-08-13','17:20:00',4.22),('8902','2013-08-13','17:25:00',4.06),('8902','2013-08-13','17:30:00',3.93),('8902','2013-08-13','17:35:00',3.72),('8902','2013-08-13','17:40:00',3.59),('8902','2013-08-13','17:45:00',3.39),('8902','2013-08-13','17:50:00',3.15),('8902','2013-08-13','17:55:00',3.04),('8902','2013-08-13','18:00:00',2.9),('8902','2013-08-13','18:05:00',2.66),('8902','2013-08-13','18:10:00',2.43),('8902','2013-08-13','18:15:00',2.32),('8902','2013-08-13','18:20:00',2.24),('8902','2013-08-13','18:25:00',2.16),('8902','2013-08-13','18:30:00',1.9),('8902','2013-08-13','18:35:00',1.7),('8902','2013-08-13','18:40:00',1.57),('8902','2013-08-13','18:45:00',1.56),('8902','2013-08-13','18:50:00',1.44),('8902','2013-08-13','18:55:00',1.35),('8902','2013-08-13','19:00:00',1.21),('8902','2013-08-12','07:50:00',1.17),('8902','2013-08-12','07:55:00',1.36),('8902','2013-08-12','08:00:00',1.5),('8902','2013-08-12','08:05:00',1.7),('8902','2013-08-12','08:10:00',1.81),('8902','2013-08-12','08:15:00',1.94),('8902','2013-08-12','08:20:00',2.09),('8902','2013-08-12','08:25:00',2.28),('8902','2013-08-12','08:30:00',2.47),('8902','2013-08-12','08:35:00',2.64),('8902','2013-08-12','08:40:00',2.8),('8902','2013-08-12','08:45:00',2.94),('8902','2013-08-12','08:50:00',3.11),('8902','2013-08-12','08:55:00',3.3),('8902','2013-08-12','09:00:00',3.48),('8902','2013-08-12','09:05:00',3.62),('8902','2013-08-12','09:10:00',3.76),('8902','2013-08-12','09:15:00',3.88),('8902','2013-08-12','09:20:00',4.01),('8902','2013-08-12','09:25:00',4.26),('8902','2013-08-12','09:30:00',4.42),('8902','2013-08-12','09:35:00',4.4),('8902','2013-08-12','09:40:00',4.42),('8902','2013-08-12','09:45:00',4.67),('8902','2013-08-12','09:50:00',4.85),('8902','2013-08-12','09:55:00',4.96),('8902','2013-08-12','10:00:00',5.07),('8902','2013-08-12','10:05:00',5.18),('8902','2013-08-12','10:10:00',4.6),('8902','2013-08-12','10:15:00',5.29),('8902','2013-08-12','10:20:00',5.57),('8902','2013-08-12','10:25:00',5.69),('8902','2013-08-12','10:30:00',5.72),('8902','2013-08-12','10:35:00',5.77),('8902','2013-08-12','10:40:00',6.04),('8902','2013-08-12','10:45:00',6.14),('8902','2013-08-12','10:50:00',6.19),('8902','2013-08-12','10:55:00',6.32),('8902','2013-08-12','11:00:00',6.39),('8902','2013-08-12','11:05:00',6.48),('8902','2013-08-12','11:10:00',6.56),('8902','2013-08-12','11:15:00',6.51),('8902','2013-08-12','11:20:00',6.59),('8902','2013-08-12','11:25:00',6.74),('8902','2013-08-12','11:30:00',6.79),('8902','2013-08-12','11:35:00',6.76),('8902','2013-08-12','11:40:00',6.88),('8902','2013-08-12','11:45:00',6.84),('8902','2013-08-12','11:50:00',7.02),('8902','2013-08-12','11:55:00',7.24),('8902','2013-08-12','12:00:00',7.19),('8902','2013-08-12','12:05:00',7.33),('8902','2013-08-12','12:10:00',7.52),('8902','2013-08-12','12:15:00',7.34),('8902','2013-08-12','12:20:00',7.4),('8902','2013-08-12','12:25:00',7.84),('8902','2013-08-12','12:30:00',7.81),('8902','2013-08-12','12:35:00',7.72),('8902','2013-08-12','12:40:00',7.95),('8902','2013-08-12','12:45:00',6.26),('8902','2013-08-12','12:50:00',3),('8902','2013-08-12','12:55:00',6.76),('8902','2013-08-12','13:00:00',6.17),('8902','2013-08-12','13:05:00',2.51),('8902','2013-08-12','13:10:00',2.18),('8902','2013-08-12','13:15:00',4.77),('8902','2013-08-12','13:20:00',8.9),('8902','2013-08-12','13:25:00',8.57),('8902','2013-08-12','13:30:00',8.17),('8902','2013-08-12','13:35:00',8.13),('8902','2013-08-12','13:40:00',6.14),('8902','2013-08-12','13:45:00',2.98),('8902','2013-08-12','13:50:00',4.29),('8902','2013-08-12','13:55:00',7.79),('8902','2013-08-12','14:00:00',7.05),('8902','2013-08-12','14:05:00',4.54),('8902','2013-08-12','14:10:00',8.64),('8902','2013-08-12','14:15:00',8.59),('8902','2013-08-12','14:20:00',7.97),('8902','2013-08-12','14:25:00',4.18),('8902','2013-08-12','14:30:00',3.51),('8902','2013-08-12','14:35:00',8.42),('8902','2013-08-12','14:40:00',3.16),('8902','2013-08-12','14:45:00',2.65),('8902','2013-08-12','14:50:00',7.17),('8902','2013-08-12','14:55:00',8.4),('8902','2013-08-12','15:00:00',7.44),('8902','2013-08-12','15:05:00',6.83),('8902','2013-08-12','15:10:00',6.59),('8902','2013-08-12','15:15:00',5.72),('8902','2013-08-12','15:20:00',7.28),('8902','2013-08-12','15:25:00',7.11),('8902','2013-08-12','15:30:00',6.71),('8902','2013-08-12','15:35:00',6.91),('8902','2013-08-12','15:40:00',6.98),('8902','2013-08-12','15:45:00',6.66),('8902','2013-08-12','15:50:00',6.52),('8902','2013-08-12','15:55:00',6.37),('8902','2013-08-12','16:00:00',6.26),('8902','2013-08-12','16:05:00',6.2),('8902','2013-08-12','16:10:00',6.09),('8902','2013-08-12','16:15:00',6),('8902','2013-08-12','16:20:00',5.9),('8902','2013-08-12','16:25:00',5.76),('8902','2013-08-12','16:30:00',5.64),('8902','2013-08-12','16:35:00',5.48),('8902','2013-08-12','16:40:00',5.38),('8902','2013-08-12','16:45:00',5.25),('8902','2013-08-12','16:50:00',5.08),('8902','2013-08-12','16:55:00',4.93),('8902','2013-08-12','17:00:00',4.83),('8902','2013-08-12','17:05:00',4.71),('8902','2013-08-12','17:10:00',4.58),('8902','2013-08-12','17:15:00',4.39),('8902','2013-08-12','17:20:00',4.24),('8902','2013-08-12','17:25:00',4.11),('8902','2013-08-12','17:30:00',3.95),('8902','2013-08-12','17:35:00',3.73),('8902','2013-08-12','17:40:00',3.58),('8902','2013-08-12','17:45:00',3.41),('8902','2013-08-12','17:50:00',3.2),('8902','2013-08-12','17:55:00',3.04),('8902','2013-08-12','18:00:00',2.88),('8902','2013-08-12','18:05:00',2.68),('8902','2013-08-12','18:10:00',2.5),('8902','2013-08-12','18:15:00',2.34),('8902','2013-08-12','18:20:00',2.18),('8902','2013-08-12','18:25:00',1.98),('8902','2013-08-12','18:30:00',1.8),('8902','2013-08-12','18:35:00',1.63),('8902','2013-08-12','18:40:00',1.47),('8902','2013-08-12','18:45:00',1.31),('8902','2013-08-12','18:50:00',1.14),('8902','2013-08-12','18:55:00',1.02),('8902','2013-08-11','07:50:00',1.18),('8902','2013-08-11','07:55:00',1.35),('8902','2013-08-11','08:00:00',1.49),('8902','2013-08-11','08:05:00',1.64),('8902','2013-08-11','08:10:00',1.8),('8902','2013-08-11','08:15:00',1.96),('8902','2013-08-11','08:20:00',2.11),('8902','2013-08-11','08:25:00',2.28),('8902','2013-08-11','08:30:00',2.44),('8902','2013-08-11','08:35:00',2.6),('8902','2013-08-11','08:40:00',2.76),('8902','2013-08-11','08:45:00',2.91),('8902','2013-08-11','08:50:00',3.07),('8902','2013-08-11','08:55:00',3.24),('8902','2013-08-11','09:00:00',3.39),('8902','2013-08-11','09:05:00',3.54),('8902','2013-08-11','09:10:00',3.7),('8902','2013-08-11','09:15:00',3.86),('8902','2013-08-11','09:20:00',4.02),('8902','2013-08-11','09:25:00',4.17),('8902','2013-08-11','09:30:00',4.29),('8902','2013-08-11','09:35:00',4.42),('8902','2013-08-11','09:40:00',4.56),('8902','2013-08-11','09:45:00',4.69),('8902','2013-08-11','09:50:00',4.81),('8902','2013-08-11','09:55:00',4.94),('8902','2013-08-11','10:00:00',5.07),('8902','2013-08-11','10:05:00',5.17),('8902','2013-08-11','10:10:00',5.28),('8902','2013-08-11','10:15:00',5.41),('8902','2013-08-11','10:20:00',5.52),('8902','2013-08-11','10:25:00',5.62),('8902','2013-08-11','10:30:00',5.74),('8902','2013-08-11','10:35:00',5.87),('8902','2013-08-11','10:40:00',5.96),('8902','2013-08-11','10:45:00',6.05),('8902','2013-08-11','10:50:00',6.1),('8902','2013-08-11','10:55:00',6.19),('8902','2013-08-11','11:00:00',6.24),('8902','2013-08-11','11:05:00',6.31),('8902','2013-08-11','11:10:00',6.39),('8902','2013-08-11','11:15:00',6.54),('8902','2013-08-11','11:20:00',6.48),('8902','2013-08-11','11:25:00',6.51),('8902','2013-08-11','11:30:00',6.5),('8902','2013-08-11','11:35:00',6.75),('8902','2013-08-11','11:40:00',6.92),('8902','2013-08-11','11:45:00',6.94),('8902','2013-08-11','11:50:00',7.06),('8902','2013-08-11','11:55:00',6.99),('8902','2013-08-11','12:00:00',7.32),('8902','2013-08-11','12:05:00',7.38),('8902','2013-08-11','12:10:00',7.47),('8902','2013-08-11','12:15:00',7.09),('8902','2013-08-11','12:20:00',6.28),('8902','2013-08-11','12:25:00',4.44),('8902','2013-08-11','12:30:00',1.66),('8902','2013-08-11','12:35:00',1.71),('8902','2013-08-11','12:40:00',2.1),('8902','2013-08-11','12:45:00',2.96),('8902','2013-08-11','12:50:00',5.46),('8902','2013-08-11','12:55:00',3.95),('8902','2013-08-11','13:00:00',2.53),('8902','2013-08-11','13:05:00',1.74),('8902','2013-08-11','13:10:00',1.4),('8902','2013-08-11','13:15:00',1.4),('8902','2013-08-11','13:20:00',1.69),('8902','2013-08-11','13:25:00',2.75),('8902','2013-08-11','13:30:00',2.29),('8902','2013-08-11','13:35:00',2.48),('8902','2013-08-11','13:40:00',2.05),('8902','2013-08-11','13:45:00',1.84),('8902','2013-08-11','13:50:00',5.36),('8902','2013-08-11','13:55:00',4.94),('8902','2013-08-11','14:00:00',2.43),('8902','2013-08-11','14:05:00',1.7),('8902','2013-08-11','14:10:00',4.12),('8902','2013-08-11','14:15:00',3.43),('8902','2013-08-11','14:20:00',2.14),('8902','2013-08-11','14:25:00',1.64),('8902','2013-08-11','14:30:00',1.61),('8902','2013-08-11','14:35:00',2.04),('8902','2013-08-11','14:40:00',2.61),('8902','2013-08-11','14:45:00',2.65),('8902','2013-08-11','14:50:00',4.33),('8902','2013-08-11','14:55:00',8.51),('8902','2013-08-11','15:00:00',8.1),('8902','2013-08-11','15:05:00',7.78),('8902','2013-08-11','15:10:00',7.56),('8902','2013-08-11','15:15:00',7.32),('8902','2013-08-11','15:20:00',7.03),('8902','2013-08-11','15:25:00',7.17),('8902','2013-08-11','15:30:00',6.94),('8902','2013-08-11','15:35:00',6.76),('8902','2013-08-11','15:40:00',6.76),('8902','2013-08-11','15:45:00',6.56),('8902','2013-08-11','15:50:00',6.57),('8902','2013-08-11','15:55:00',6.48),('8902','2013-08-11','16:00:00',6.33),('8902','2013-08-11','16:05:00',6.24),('8902','2013-08-11','16:10:00',6.16),('8902','2013-08-11','16:15:00',6.03),('8902','2013-08-11','16:20:00',5.81),('8902','2013-08-11','16:25:00',5.7),('8902','2013-08-11','16:30:00',5.6),('8902','2013-08-11','16:35:00',5.4),('8902','2013-08-11','16:40:00',5.34),('8902','2013-08-11','16:45:00',5.16),('8902','2013-08-11','16:50:00',5.07),('8902','2013-08-11','16:55:00',4.67),('8902','2013-08-11','17:00:00',4.71),('8902','2013-08-11','17:05:00',4.63),('8902','2013-08-11','17:10:00',4.49),('8902','2013-08-11','17:15:00',4.29),('8902','2013-08-11','17:20:00',4.1),('8902','2013-08-11','17:25:00',3.99),('8902','2013-08-11','17:30:00',3.89),('8902','2013-08-11','17:35:00',3.69),('8902','2013-08-11','17:40:00',3.56),('8902','2013-08-11','17:45:00',3.35),('8902','2013-08-11','17:50:00',3.14),('8902','2013-08-11','17:55:00',2.98),('8902','2013-08-11','18:00:00',2.85),('8902','2013-08-11','18:05:00',2.68),('8902','2013-08-11','18:10:00',2.5),('8902','2013-08-11','18:15:00',2.33),('8902','2013-08-11','18:20:00',2.19),('8902','2013-08-11','18:25:00',2.05),('8902','2013-08-11','18:30:00',1.82),('8902','2013-08-11','18:35:00',1.7),('8902','2013-08-11','18:40:00',1.54),('8902','2013-08-11','18:45:00',1.41),('8902','2013-08-11','18:50:00',1.23),('8902','2013-08-11','18:55:00',1.11),('8902','2013-08-10','07:50:00',1.22),('8902','2013-08-10','07:55:00',1.4),('8902','2013-08-10','08:00:00',1.55),('8902','2013-08-10','08:05:00',1.7),('8902','2013-08-10','08:10:00',1.85),('8902','2013-08-10','08:15:00',2.02),('8902','2013-08-10','08:20:00',2.19),('8902','2013-08-10','08:25:00',2.33),('8902','2013-08-10','08:30:00',2.5),('8902','2013-08-10','08:35:00',2.65),('8902','2013-08-10','08:40:00',2.82),('8902','2013-08-10','08:45:00',3),('8902','2013-08-10','08:50:00',3.16),('8902','2013-08-10','08:55:00',3.31),('8902','2013-08-10','09:00:00',3.49),('8902','2013-08-10','09:05:00',3.64),('8902','2013-08-10','09:10:00',3.78),('8902','2013-08-10','09:15:00',3.93),('8902','2013-08-10','09:20:00',4.09),('8902','2013-08-10','09:25:00',4.25),('8902','2013-08-10','09:30:00',4.4),('8902','2013-08-10','09:35:00',4.54),('8902','2013-08-10','09:40:00',4.69),('8902','2013-08-10','09:45:00',4.83),('8902','2013-08-10','09:50:00',4.96),('8902','2013-08-10','09:55:00',5.1),('8902','2013-08-10','10:00:00',5.23),('8902','2013-08-10','10:05:00',5.37),('8902','2013-08-10','10:10:00',5.51),('8902','2013-08-10','10:15:00',5.66),('8902','2013-08-10','10:20:00',5.76),('8902','2013-08-10','10:25:00',5.86),('8902','2013-08-10','10:30:00',5.99),('8902','2013-08-10','10:35:00',6.06),('8902','2013-08-10','10:40:00',6.16),('8902','2013-08-10','10:45:00',6.25),('8902','2013-08-10','10:50:00',6.34),('8902','2013-08-10','10:55:00',6.41),('8902','2013-08-10','11:00:00',6.5),('8902','2013-08-10','11:05:00',6.59),('8902','2013-08-10','11:10:00',6.71),('8902','2013-08-10','11:15:00',6.74),('8902','2013-08-10','11:20:00',6.85),('8902','2013-08-10','11:25:00',6.92),('8902','2013-08-10','11:30:00',6.95),('8902','2013-08-10','11:35:00',7.02),('8902','2013-08-10','11:40:00',7.09),('8902','2013-08-10','11:45:00',7.11),('8902','2013-08-10','11:50:00',7.21),('8902','2013-08-10','11:55:00',7.22),('8902','2013-08-10','12:00:00',7.25),('8902','2013-08-10','12:05:00',7.32),('8902','2013-08-10','12:10:00',7.37),('8902','2013-08-10','12:15:00',7.35),('8902','2013-08-10','12:20:00',7.34),('8902','2013-08-10','12:25:00',7.43),('8902','2013-08-10','12:30:00',7.46),('8902','2013-08-10','12:35:00',7.51),('8902','2013-08-10','12:40:00',7.48),('8902','2013-08-10','12:45:00',7.45),('8902','2013-08-10','12:50:00',7.49),('8902','2013-08-10','12:55:00',7.57),('8902','2013-08-10','13:00:00',7.62),('8902','2013-08-10','13:05:00',7.57),('8902','2013-08-10','13:10:00',7.55),('8902','2013-08-10','13:15:00',7.6),('8902','2013-08-10','13:20:00',7.58),('8902','2013-08-10','13:25:00',7.66),('8902','2013-08-10','13:30:00',7.67),('8902','2013-08-10','13:35:00',7.58),('8902','2013-08-10','13:40:00',7.53),('8902','2013-08-10','13:45:00',7.55),('8902','2013-08-10','13:50:00',7.53),('8902','2013-08-10','13:55:00',7.52),('8902','2013-08-10','14:00:00',7.52),('8902','2013-08-10','14:05:00',7.51),('8902','2013-08-10','14:10:00',7.49),('8902','2013-08-10','14:15:00',7.27),('8902','2013-08-10','14:20:00',7.23),('8902','2013-08-10','14:25:00',7.23),('8902','2013-08-10','14:30:00',7.25),('8902','2013-08-10','14:35:00',7.27),('8902','2013-08-10','14:40:00',7.3),('8902','2013-08-10','14:45:00',7.23),('8902','2013-08-10','14:50:00',7.08),('8902','2013-08-10','14:55:00',7),('8902','2013-08-10','15:00:00',7.14),('8902','2013-08-10','15:05:00',7.07),('8902','2013-08-10','15:10:00',6.97),('8902','2013-08-10','15:15:00',6.81),('8902','2013-08-10','15:20:00',6.79),('8902','2013-08-10','15:25:00',6.73),('8902','2013-08-10','15:30:00',6.67),('8902','2013-08-10','15:35:00',6.47),('8902','2013-08-10','15:40:00',6.51),('8902','2013-08-10','15:45:00',6.4),('8902','2013-08-10','15:50:00',6.4),('8902','2013-08-10','15:55:00',6.33),('8902','2013-08-10','16:00:00',6.23),('8902','2013-08-10','16:05:00',6.13),('8902','2013-08-10','16:10:00',6.01),('8902','2013-08-10','16:15:00',5.9),('8902','2013-08-10','16:20:00',5.78),('8902','2013-08-10','16:25:00',5.65),('8902','2013-08-10','16:30:00',5.55),('8902','2013-08-10','16:35:00',5.37),('8902','2013-08-10','16:40:00',5.23),('8902','2013-08-10','16:45:00',5.15),('8902','2013-08-10','16:50:00',4.99),('8902','2013-08-10','16:55:00',4.77),('8902','2013-08-10','17:00:00',4.74),('8902','2013-08-10','17:05:00',4.61),('8902','2013-08-10','17:10:00',4.46),('8902','2013-08-10','17:15:00',4.3),('8902','2013-08-10','17:20:00',4.14),('8902','2013-08-10','17:25:00',4.01),('8902','2013-08-10','17:30:00',3.88),('8902','2013-08-10','17:35:00',3.71),('8902','2013-08-10','17:40:00',3.54),('8902','2013-08-10','17:45:00',3.38),('8902','2013-08-10','17:50:00',3.15),('8902','2013-08-10','17:55:00',3),('8902','2013-08-10','18:00:00',2.84),('8902','2013-08-10','18:05:00',2.67),('8902','2013-08-10','18:10:00',2.44),('8902','2013-08-10','18:15:00',2.22),('8902','2013-08-10','18:20:00',2.15),('8902','2013-08-10','18:25:00',2),('8902','2013-08-10','18:30:00',1.82),('8902','2013-08-10','18:35:00',1.64),('8902','2013-08-10','18:40:00',1.49),('8902','2013-08-10','18:45:00',1.33),('8902','2013-08-10','18:50:00',1.15),('8902','2013-08-10','18:55:00',1.03),('8902','2013-08-09','07:50:00',1.2),('8902','2013-08-09','07:55:00',1.37),('8902','2013-08-09','08:00:00',1.53),('8902','2013-08-09','08:05:00',1.69),('8902','2013-08-09','08:10:00',1.84),('8902','2013-08-09','08:15:00',2.03),('8902','2013-08-09','08:20:00',2.21),('8902','2013-08-09','08:25:00',2.39),('8902','2013-08-09','08:30:00',2.56),('8902','2013-08-09','08:35:00',2.73),('8902','2013-08-09','08:40:00',2.89),('8902','2013-08-09','08:45:00',3.05),('8902','2013-08-09','08:50:00',3.22),('8902','2013-08-09','08:55:00',3.38),('8902','2013-08-09','09:00:00',3.54),('8902','2013-08-09','09:05:00',3.69),('8902','2013-08-09','09:10:00',3.85),('8902','2013-08-09','09:15:00',4.03),('8902','2013-08-09','09:20:00',4.17),('8902','2013-08-09','09:25:00',4.34),('8902','2013-08-09','09:30:00',3.76),('8902','2013-08-09','09:35:00',4.61),('8902','2013-08-09','09:40:00',4.75),('8902','2013-08-09','09:45:00',4.89),('8902','2013-08-09','09:50:00',4.33),('8902','2013-08-09','09:55:00',5.1),('8902','2013-08-09','10:00:00',5.23),('8902','2013-08-09','10:05:00',5.35),('8902','2013-08-09','10:10:00',5.47),('8902','2013-08-09','10:15:00',5.6),('8902','2013-08-09','10:20:00',5.72),('8902','2013-08-09','10:25:00',5.82),('8902','2013-08-09','10:30:00',5.91),('8902','2013-08-09','10:35:00',6.02),('8902','2013-08-09','10:40:00',6.13),('8902','2013-08-09','10:45:00',6.21),('8902','2013-08-09','10:50:00',6.31),('8902','2013-08-09','10:55:00',6.43),('8902','2013-08-09','11:00:00',6.6),('8902','2013-08-09','11:05:00',6.67),('8902','2013-08-09','11:10:00',6.84),('8902','2013-08-09','11:15:00',4.12),('8902','2013-08-09','11:20:00',6.03),('8902','2013-08-09','11:25:00',3.81),('8902','2013-08-09','11:30:00',5.65),('8902','2013-08-09','11:35:00',7.25),('8902','2013-08-09','11:40:00',7.17),('8902','2013-08-09','11:45:00',7.17),('8902','2013-08-09','11:50:00',7.22),('8902','2013-08-09','11:55:00',7.23),('8902','2013-08-09','12:00:00',7.31),('8902','2013-08-09','12:05:00',7.31),('8902','2013-08-09','12:10:00',7.36),('8902','2013-08-09','12:15:00',7.36),('8902','2013-08-09','12:20:00',7.43),('8902','2013-08-09','12:25:00',7.54),('8902','2013-08-09','12:30:00',7.54),('8902','2013-08-09','12:35:00',7.57),('8902','2013-08-09','12:40:00',7.64),('8902','2013-08-09','12:45:00',7.74),('8902','2013-08-09','12:50:00',7.88),('8902','2013-08-09','12:55:00',7.86),('8902','2013-08-09','13:00:00',7.82),('8902','2013-08-09','13:05:00',7.77),('8902','2013-08-09','13:10:00',7.85),('8902','2013-08-09','13:15:00',7.96),('8902','2013-08-09','13:20:00',8.05),('8902','2013-08-09','13:25:00',8.04),('8902','2013-08-09','13:30:00',7.56),('8902','2013-08-09','13:35:00',7.67),('8902','2013-08-09','13:40:00',2.12),('8902','2013-08-09','13:45:00',1.69),('8902','2013-08-09','13:50:00',8.45),('8902','2013-08-09','13:55:00',8.15),('8902','2013-08-09','14:00:00',6.29),('8902','2013-08-09','14:05:00',4.8),('8902','2013-08-09','14:10:00',8.92),('8902','2013-08-09','14:15:00',7.8),('8902','2013-08-09','14:20:00',3.69),('8902','2013-08-09','14:25:00',2.43),('8902','2013-08-09','14:30:00',2.49),('8902','2013-08-09','14:35:00',2.16),('8902','2013-08-09','14:40:00',1.99),('8902','2013-08-09','14:45:00',1.85),('8902','2013-08-09','14:50:00',1.7),('8902','2013-08-09','14:55:00',1.62),('8902','2013-08-09','15:00:00',1.8),('8902','2013-08-09','15:05:00',1.99),('8902','2013-08-09','15:10:00',2.12),('8902','2013-08-09','15:15:00',2.45),('8902','2013-08-09','15:20:00',2.49),('8902','2013-08-09','15:25:00',2.25),('8902','2013-08-09','15:30:00',2.15),('8902','2013-08-09','15:35:00',2.65),('8902','2013-08-09','15:40:00',2.57),('8902','2013-08-09','15:45:00',2.7),('8902','2013-08-09','15:50:00',3.16),('8902','2013-08-09','15:55:00',3.75),('8902','2013-08-09','16:00:00',3.7),('8902','2013-08-09','16:05:00',6.98),('8902','2013-08-09','16:10:00',3.81),('8902','2013-08-09','16:15:00',3.69),('8902','2013-08-09','16:20:00',4.53),('8902','2013-08-09','16:25:00',2.67),('8902','2013-08-09','16:30:00',3.71),('8902','2013-08-09','16:35:00',6.54),('8902','2013-08-09','16:40:00',5.95),('8902','2013-08-09','16:45:00',5.83),('8902','2013-08-09','16:50:00',5.51),('8902','2013-08-09','16:55:00',5.04),('8902','2013-08-09','17:00:00',4.87),('8902','2013-08-09','17:05:00',3.48),('8902','2013-08-09','17:10:00',1.74),('8902','2013-08-09','17:15:00',2.23),('8902','2013-08-09','17:20:00',1.95),('8902','2013-08-09','17:25:00',2.17),('8902','2013-08-09','17:30:00',1.31),('8902','2013-08-09','17:45:00',1.01),('8902','2013-08-09','17:50:00',1.64),('8902','2013-08-09','17:55:00',2.22),('8902','2013-08-09','18:00:00',1.46),('8902','2014-04-08','08:00:00',1.32),('8902','2014-04-08','08:05:00',1.67),('8902','2014-04-08','08:10:00',1.66),('8902','2014-04-08','08:15:00',1.33),('8902','2014-04-08','08:20:00',1.92),('8902','2014-04-08','08:25:00',1.44),('8902','2014-04-08','08:30:00',1.43),('8902','2014-04-08','08:35:00',1.02),('8902','2014-04-08','08:55:00',1.41),('8902','2014-04-08','09:00:00',1.62),('8902','2014-04-08','09:05:00',1.6),('8902','2014-04-08','09:10:00',1.53),('8902','2014-04-08','09:15:00',1.5),('8902','2014-04-08','09:20:00',1.55),('8902','2014-04-08','09:25:00',1.73),('8902','2014-04-08','09:30:00',1.87),('8902','2014-04-08','09:35:00',1.71),('8902','2014-04-08','09:40:00',1.74),('8902','2014-04-08','09:45:00',2.06),('8902','2014-04-08','09:50:00',3.01),('8902','2014-04-08','09:55:00',5.39),('8902','2014-04-08','10:00:00',5.38),('8902','2014-04-08','10:05:00',5.45),('8902','2014-04-08','10:10:00',5.66),('8902','2014-04-08','10:15:00',5.94),('8902','2014-04-08','10:20:00',6.02),('8902','2014-04-08','10:25:00',6.33),('8902','2014-04-08','10:30:00',6.6),('8902','2014-04-08','10:35:00',7.23),('8902','2014-04-08','10:40:00',4.3),('8902','2014-04-08','10:45:00',2.63),('8902','2014-04-08','10:50:00',1.91),('8902','2014-04-08','10:55:00',2.54),('8902','2014-04-08','11:00:00',6.93),('8902','2014-04-08','11:05:00',7.74),('8902','2014-04-08','11:10:00',7.83),('8902','2014-04-08','11:15:00',8.16),('8902','2014-04-08','11:20:00',7.65),('8902','2014-04-08','11:25:00',3.75),('8902','2014-04-08','11:30:00',2.15),('8902','2014-04-08','11:35:00',2.74),('8902','2014-04-08','11:40:00',6.47),('8902','2014-04-08','11:45:00',9),('8902','2014-04-08','11:50:00',8.64),('8902','2014-04-08','11:55:00',8.92),('8902','2014-04-08','12:00:00',8.89),('8902','2014-04-08','12:05:00',8.56),('8902','2014-04-08','12:10:00',3.61),('8902','2014-04-08','12:15:00',3.67),('8902','2014-04-08','12:20:00',2.96),('8902','2014-04-08','12:25:00',1.97),('8902','2014-04-08','12:30:00',1.55),('8902','2014-04-08','12:35:00',1.37),('8902','2014-04-08','12:40:00',1.26),('8902','2014-04-08','12:45:00',1.09),('8902','2014-04-08','12:50:00',1.04),('8902','2014-04-08','12:55:00',1.22),('8902','2014-04-08','13:00:00',1.2),('8902','2014-04-08','13:05:00',1.18),('8902','2014-04-08','13:10:00',1.28),('8902','2014-04-08','13:15:00',1.57),('8902','2014-04-08','13:20:00',2.33),('8902','2014-04-08','13:25:00',3.01),('8902','2014-04-08','13:30:00',2.63),('8902','2014-04-08','13:35:00',2.41),('8902','2014-04-08','13:40:00',2.32),('8902','2014-04-08','13:45:00',2.18),('8902','2014-04-08','13:50:00',1.84),('8902','2014-04-08','13:55:00',1.47),('8902','2014-04-08','14:00:00',1.64),('8902','2014-04-08','14:05:00',2.44),('8902','2014-04-08','14:10:00',5.45),('8902','2014-04-08','14:15:00',3.32),('8902','2014-04-08','14:20:00',4.96),('8902','2014-04-08','14:25:00',3.18),('8902','2014-04-08','14:30:00',3.87),('8902','2014-04-08','14:35:00',8.36),('8902','2014-04-08','14:40:00',5.22),('8902','2014-04-08','14:45:00',3.29),('8902','2014-04-08','14:50:00',3.83),('8902','2014-04-08','14:55:00',4.73),('8902','2014-04-08','15:00:00',4.37),('8902','2014-04-08','15:05:00',8.03),('8902','2014-04-08','15:10:00',7.37),('8902','2014-04-08','15:15:00',7.02),('8902','2014-04-08','15:20:00',6.38),('8902','2014-04-08','15:25:00',4.74),('8902','2014-04-08','15:30:00',7.49),('8902','2014-04-08','15:35:00',5.05),('8902','2014-04-08','15:40:00',3.11),('8902','2014-04-08','15:45:00',4.28),('8902','2014-04-08','15:50:00',4.61),('8902','2014-04-08','15:55:00',2.72),('8902','2014-04-08','16:00:00',3.01),('8902','2014-04-08','16:05:00',3.82),('8902','2014-04-08','16:10:00',3.57),('8902','2014-04-08','16:15:00',6.45),('8902','2014-04-08','16:20:00',6.51),('8902','2014-04-08','16:25:00',6.08),('8902','2014-04-08','16:30:00',5.17),('8902','2014-04-08','16:35:00',3.41),('8902','2014-04-08','16:40:00',2.65),('8902','2014-04-08','16:45:00',3.2),('8902','2014-04-08','16:50:00',4.47),('8902','2014-04-08','16:55:00',3.33),('8902','2014-04-08','17:00:00',3.49),('8902','2014-04-08','17:05:00',5.04),('8902','2014-04-08','17:10:00',4.81),('8902','2014-04-08','17:15:00',4.17),('8902','2014-04-08','17:20:00',4.16),('8902','2014-04-08','17:25:00',4.22),('8902','2014-04-08','17:30:00',2.68),('8902','2014-04-08','17:35:00',1.27),('8902','2014-04-08','17:40:00',1.38),('8902','2014-04-08','17:45:00',2.11),('8902','2014-04-08','17:50:00',2.16),('8902','2014-04-08','17:55:00',2.26),('8902','2014-04-08','18:00:00',1.93),('8902','2014-04-08','18:05:00',1.35),('8902','2014-04-08','18:10:00',1.27),('8902','2014-04-08','18:15:00',1.1),('8902','2013-08-08','07:40:00',1.01),('8902','2013-08-08','08:00:00',1.24),('8902','2013-08-08','08:05:00',1.98),('8902','2013-08-08','08:10:00',1.63),('8902','2013-08-08','08:15:00',1.51),('8902','2013-08-08','08:20:00',1.42),('8902','2013-08-08','08:25:00',1.35),('8902','2013-08-08','08:30:00',1.63),('8902','2013-08-08','08:35:00',1.84),('8902','2013-08-08','08:40:00',2.21),('8902','2013-08-08','08:45:00',2.69),('8902','2013-08-08','08:50:00',2.95),('8902','2013-08-08','08:55:00',2.65),('8902','2013-08-08','09:00:00',3.03),('8902','2013-08-08','09:05:00',3.48),('8902','2013-08-08','09:10:00',3.84),('8902','2013-08-08','09:15:00',3.44),('8902','2013-08-08','09:20:00',3.22),('8902','2013-08-08','09:25:00',2.52),('8902','2013-08-08','09:30:00',4.34),('8902','2013-08-08','09:35:00',4.51),('8902','2013-08-08','09:40:00',3.13),('8902','2013-08-08','09:45:00',3.98),('8902','2013-08-08','09:50:00',4.69),('8902','2013-08-08','09:55:00',3.63),('8902','2013-08-08','10:00:00',3.76),('8902','2013-08-08','10:05:00',4.05),('8902','2013-08-08','10:10:00',4.82),('8902','2013-08-08','10:15:00',4.91),('8902','2013-08-08','10:20:00',5),('8902','2013-08-08','10:25:00',4.52),('8902','2013-08-08','10:30:00',5.04),('8902','2013-08-08','10:35:00',5.53),('8902','2013-08-08','10:40:00',5.64),('8902','2013-08-08','10:45:00',5.51),('8902','2013-08-08','10:50:00',5.64),('8902','2013-08-08','10:55:00',5.84),('8902','2013-08-08','11:00:00',5.93),('8902','2013-08-08','11:05:00',5.99),('8902','2013-08-08','11:10:00',6.09),('8902','2013-08-08','11:15:00',6.17),('8902','2013-08-08','11:20:00',6.2),('8902','2013-08-08','11:25:00',6.26),('8902','2013-08-08','11:30:00',6.41),('8902','2013-08-08','11:35:00',6.44),('8902','2013-08-08','11:40:00',6.42),('8902','2013-08-08','11:45:00',6.48),('8902','2013-08-08','11:50:00',6.55),('8902','2013-08-08','11:55:00',6.67),('8902','2013-08-08','12:00:00',6.67),('8902','2013-08-08','12:05:00',6.64),('8902','2013-08-08','12:10:00',6.74),('8902','2013-08-08','12:15:00',6.86),('8902','2013-08-08','12:20:00',7.11),('8902','2013-08-08','12:25:00',6.86),('8902','2013-08-08','12:30:00',4.7),('8902','2013-08-08','12:35:00',6.34),('8902','2013-08-08','12:40:00',7.27),('8902','2013-08-08','12:45:00',5.41),('8902','2013-08-08','12:50:00',4.85),('8902','2013-08-08','12:55:00',5.44),('8902','2013-08-08','13:00:00',2.62),('8902','2013-08-08','13:05:00',1.72),('8902','2013-08-08','13:10:00',1.61),('8902','2013-08-08','13:15:00',1.88),('8902','2013-08-08','13:20:00',2.6),('8902','2013-08-08','13:25:00',4.29),('8902','2013-08-08','13:30:00',3.51),('8902','2013-08-08','13:35:00',2.9),('8902','2013-08-08','13:40:00',2.88),('8902','2013-08-08','13:45:00',2.69),('8902','2013-08-08','13:50:00',2.78),('8902','2013-08-08','13:55:00',2.42),('8902','2013-08-08','14:00:00',2.23),('8902','2013-08-08','14:05:00',2.66),('8902','2013-08-08','14:10:00',2.64),('8902','2013-08-08','14:15:00',1.85),('8902','2013-08-08','14:20:00',1.73),('8902','2013-08-08','14:25:00',2.08),('8902','2013-08-08','14:30:00',2.03),('8902','2013-08-08','14:35:00',1.53),('8902','2013-08-08','14:40:00',1.09),('8902','2013-08-08','15:00:00',1.04),('8902','2013-08-08','15:05:00',2.82),('8902','2013-08-08','15:10:00',5.5),('8902','2013-08-08','15:15:00',4.87),('8902','2013-08-08','15:20:00',2.98),('8902','2013-08-08','15:25:00',2.38),('8902','2013-08-08','15:30:00',2.21),('8902','2013-08-08','15:35:00',4.15),('8902','2013-08-08','15:40:00',2.99),('8902','2013-08-08','15:45:00',6.46),('8902','2013-08-08','15:50:00',4.32),('8902','2013-08-08','15:55:00',4.52),('8902','2013-08-08','16:00:00',2.27),('8902','2013-08-08','16:05:00',1.41),('8902','2013-08-08','16:10:00',1.23),('8902','2013-08-08','16:15:00',1.42),('8902','2013-08-08','16:20:00',1.43),('8902','2013-08-08','16:25:00',1.57),('8902','2013-08-08','16:30:00',1.12),('8902','2013-08-08','16:35:00',1.16),('8902','2013-08-08','16:40:00',1.28),('8902','2013-08-08','16:45:00',1.61),('8902','2013-08-08','16:50:00',2.39),('8902','2013-08-08','16:55:00',3.71),('8902','2013-08-08','17:00:00',3),('8902','2013-08-08','17:05:00',3.73),('8902','2013-08-08','17:10:00',1.94),('8902','2013-08-08','17:15:00',1.41),('8902','2013-08-08','17:20:00',1.24),('8902','2013-08-08','17:25:00',1.4),('8902','2013-08-08','17:30:00',1.66),('8902','2013-08-08','17:35:00',1.67),('8902','2013-08-08','17:40:00',1.58),('8902','2013-08-08','17:45:00',1.5),('8902','2013-08-08','17:50:00',1.13),('8902','2013-08-08','19:00:00',1.04),('8902','2013-08-08','19:05:00',1.5),('8902','2013-08-08','19:10:00',1.58),('8902','2013-08-08','19:15:00',1.68),('8902','2013-08-08','19:20:00',1.98),('8902','2013-08-08','19:25:00',1.81),('8902','2013-08-07','07:50:00',1.15),('8902','2013-08-07','07:55:00',1.28),('8902','2013-08-07','08:00:00',1.42),('8902','2013-08-07','08:05:00',1.55),('8902','2013-08-07','08:10:00',1.7),('8902','2013-08-07','08:15:00',1.83),('8902','2013-08-07','08:20:00',1.96),('8902','2013-08-07','08:25:00',2.12),('8902','2013-08-07','08:30:00',2.28),('8902','2013-08-07','08:35:00',2.43),('8902','2013-08-07','08:40:00',2.57),('8902','2013-08-07','08:45:00',2.69),('8902','2013-08-07','08:50:00',2.82),('8902','2013-08-07','08:55:00',2.98),('8902','2013-08-07','09:00:00',3.13),('8902','2013-08-07','09:05:00',3.29),('8902','2013-08-07','09:10:00',3.42),('8902','2013-08-07','09:15:00',3.56),('8902','2013-08-07','09:20:00',3.76),('8902','2013-08-07','09:25:00',3.92),('8902','2013-08-07','09:30:00',4.05),('8902','2013-08-07','09:35:00',4.19),('8902','2013-08-07','09:40:00',4.3),('8902','2013-08-07','09:45:00',4.45),('8902','2013-08-07','09:50:00',4.6),('8902','2013-08-07','09:55:00',4.71),('8902','2013-08-07','10:00:00',4.81),('8902','2013-08-07','10:05:00',4.93),('8902','2013-08-07','10:10:00',5.03),('8902','2013-08-07','10:15:00',5.14),('8902','2013-08-07','10:20:00',5.22),('8902','2013-08-07','10:25:00',5.32),('8902','2013-08-07','10:30:00',5.44),('8902','2013-08-07','10:35:00',5.54),('8902','2013-08-07','10:40:00',5.63),('8902','2013-08-07','10:45:00',5.71),('8902','2013-08-07','10:50:00',5.78),('8902','2013-08-07','10:55:00',5.87),('8902','2013-08-07','11:00:00',5.96),('8902','2013-08-07','11:05:00',6.03),('8902','2013-08-07','11:10:00',6.09),('8902','2013-08-07','11:15:00',6.18),('8902','2013-08-07','11:20:00',6.24),('8902','2013-08-07','11:25:00',6.24),('8902','2013-08-07','11:30:00',6.32),('8902','2013-08-07','11:35:00',6.34),('8902','2013-08-07','11:40:00',6.41),('8902','2013-08-07','11:45:00',6.51),('8902','2013-08-07','11:50:00',6.53),('8902','2013-08-07','11:55:00',6.55),('8902','2013-08-07','12:00:00',6.64),('8902','2013-08-07','12:05:00',6.65),('8902','2013-08-07','12:10:00',6.69),('8902','2013-08-07','12:15:00',6.7),('8902','2013-08-07','12:20:00',6.8),('8902','2013-08-07','12:25:00',6.84),('8902','2013-08-07','12:30:00',6.88),('8902','2013-08-07','12:35:00',6.8),('8902','2013-08-07','12:40:00',6.93),('8902','2013-08-07','12:45:00',6.98),('8902','2013-08-07','12:50:00',7.07),('8902','2013-08-07','12:55:00',7.1),('8902','2013-08-07','13:00:00',7.08),('8902','2013-08-07','13:05:00',6.94),('8902','2013-08-07','13:10:00',7.09),('8902','2013-08-07','13:15:00',7.14),('8902','2013-08-07','13:20:00',7.08),('8902','2013-08-07','13:25:00',7.18),('8902','2013-08-07','13:30:00',7.19),('8902','2013-08-07','13:35:00',7.1),('8902','2013-08-07','13:40:00',7.07),('8902','2013-08-07','13:45:00',7.13),('8902','2013-08-07','13:50:00',7.13),('8902','2013-08-07','13:55:00',7.05),('8902','2013-08-07','14:00:00',7.06),('8902','2013-08-07','14:05:00',7.09),('8902','2013-08-07','14:10:00',7.06),('8902','2013-08-07','14:15:00',7.03),('8902','2013-08-07','14:20:00',6.88),('8902','2013-08-07','14:25:00',6.86),('8902','2013-08-07','14:30:00',6.87),('8902','2013-08-07','14:35:00',6.82),('8902','2013-08-07','14:40:00',6.76),('8902','2013-08-07','14:45:00',6.72),('8902','2013-08-07','14:50:00',6.7),('8902','2013-08-07','14:55:00',6.56),('8902','2013-08-07','15:00:00',6.51),('8902','2013-08-07','15:05:00',6.47),('8902','2013-08-07','15:10:00',6.4),('8902','2013-08-07','15:15:00',6.3),('8902','2013-08-07','15:20:00',6.3),('8902','2013-08-07','15:25:00',6.23),('8902','2013-08-07','15:30:00',6.15),('8902','2013-08-07','15:35:00',6.08),('8902','2013-08-07','15:40:00',6.04),('8902','2013-08-07','15:45:00',6),('8902','2013-08-07','15:50:00',5.9),('8902','2013-08-07','15:55:00',5.8),('8902','2013-08-07','16:00:00',5.74),('8902','2013-08-07','16:05:00',5.7),('8902','2013-08-07','16:10:00',5.63),('8902','2013-08-07','16:15:00',5.54),('8902','2013-08-07','16:20:00',5.52),('8902','2013-08-07','16:25:00',5.41),('8902','2013-08-07','16:30:00',5.28),('8902','2013-08-07','16:35:00',5.1),('8902','2013-08-07','16:40:00',5.02),('8902','2013-08-07','16:45:00',4.89),('8902','2013-08-07','16:50:00',4.77),('8902','2013-08-07','16:55:00',4.52),('8902','2013-08-07','17:00:00',4.46),('8902','2013-08-07','17:05:00',4.33),('8902','2013-08-07','17:10:00',4.18),('8902','2013-08-07','17:15:00',4.05),('8902','2013-08-07','17:20:00',3.83),('8902','2013-08-07','17:25:00',3.73),('8902','2013-08-07','17:30:00',3.62),('8902','2013-08-07','17:35:00',3.45),('8902','2013-08-07','17:40:00',3.27),('8902','2013-08-07','17:45:00',3.16),('8902','2013-08-07','17:50:00',2.96),('8902','2013-08-07','17:55:00',2.82),('8902','2013-08-07','18:00:00',2.69),('8902','2013-08-07','18:05:00',2.52),('8902','2013-08-07','18:10:00',2.36),('8902','2013-08-07','18:15:00',2.2),('8902','2013-08-07','18:20:00',2.05),('8902','2013-08-07','18:25:00',1.88),('8902','2013-08-07','18:30:00',1.69),('8902','2013-08-07','18:35:00',1.55),('8902','2013-08-07','18:40:00',1.4),('8902','2013-08-07','18:45:00',1.26),('8902','2013-08-07','18:50:00',1.1),('8902','2013-08-06','07:50:00',1.19),('8902','2013-08-06','07:55:00',1.34),('8902','2013-08-06','08:00:00',1.47),('8902','2013-08-06','08:05:00',1.61),('8902','2013-08-06','08:10:00',1.76),('8902','2013-08-06','08:15:00',1.9),('8902','2013-08-06','08:20:00',2.05),('8902','2013-08-06','08:25:00',2.21),('8902','2013-08-06','08:30:00',2.36),('8902','2013-08-06','08:35:00',2.5),('8902','2013-08-06','08:40:00',2.67),('8902','2013-08-06','08:45:00',2.82),('8902','2013-08-06','08:50:00',2.98),('8902','2013-08-06','08:55:00',3.14),('8902','2013-08-06','09:00:00',3.29),('8902','2013-08-06','09:05:00',3.43),('8902','2013-08-06','09:10:00',3.56),('8902','2013-08-06','09:15:00',3.67),('8902','2013-08-06','09:20:00',3.85),('8902','2013-08-06','09:25:00',4),('8902','2013-08-06','09:30:00',4.14),('8902','2013-08-06','09:35:00',4.31),('8902','2013-08-06','09:40:00',4.43),('8902','2013-08-06','09:45:00',4.53),('8902','2013-08-06','09:50:00',4.59),('8902','2013-08-06','09:55:00',4.74),('8902','2013-08-06','10:00:00',4.83),('8902','2013-08-06','10:05:00',4.99),('8902','2013-08-06','10:10:00',5.12),('8902','2013-08-06','10:15:00',5.23),('8902','2013-08-06','10:20:00',5.27),('8902','2013-08-06','10:25:00',5.4),('8902','2013-08-06','10:30:00',5.55),('8902','2013-08-06','10:35:00',5.62),('8902','2013-08-06','10:40:00',5.69),('8902','2013-08-06','10:45:00',5.77),('8902','2013-08-06','10:50:00',5.9),('8902','2013-08-06','10:55:00',5.98),('8902','2013-08-06','11:00:00',6.06),('8902','2013-08-06','11:05:00',6.1),('8902','2013-08-06','11:10:00',6.19),('8902','2013-08-06','11:15:00',6.25),('8902','2013-08-06','11:20:00',6.3),('8902','2013-08-06','11:25:00',6.36),('8902','2013-08-06','11:30:00',6.43),('8902','2013-08-06','11:35:00',6.47),('8902','2013-08-06','11:40:00',6.5),('8902','2013-08-06','11:45:00',6.57),('8902','2013-08-06','11:50:00',6.61),('8902','2013-08-06','11:55:00',6.61),('8902','2013-08-06','12:00:00',6.66),('8902','2013-08-06','12:05:00',6.74),('8902','2013-08-06','12:10:00',6.8),('8902','2013-08-06','12:15:00',6.89),('8902','2013-08-06','12:20:00',6.82),('8902','2013-08-06','12:25:00',6.88),('8902','2013-08-06','12:30:00',6.88),('8902','2013-08-06','12:35:00',6.93),('8902','2013-08-06','12:40:00',6.83),('8902','2013-08-06','12:45:00',6.83),('8902','2013-08-06','12:50:00',6.97),('8902','2013-08-06','12:55:00',7.03),('8902','2013-08-06','13:00:00',7),('8902','2013-08-06','13:05:00',6.92),('8902','2013-08-06','13:10:00',6.95),('8902','2013-08-06','13:15:00',6.9),('8902','2013-08-06','13:20:00',7.1),('8902','2013-08-06','13:25:00',6.98),('8902','2013-08-06','13:30:00',7.14),('8902','2013-08-06','13:35:00',7.12),('8902','2013-08-06','13:40:00',7.11),('8902','2013-08-06','13:45:00',7.22),('8902','2013-08-06','13:50:00',7.1),('8902','2013-08-06','13:55:00',7.18),('8902','2013-08-06','14:00:00',7.15),('8902','2013-08-06','14:05:00',7.07),('8902','2013-08-06','14:10:00',7.04),('8902','2013-08-06','14:15:00',6.96),('8902','2013-08-06','14:20:00',6.84),('8902','2013-08-06','14:25:00',6.86),('8902','2013-08-06','14:30:00',6.75),('8902','2013-08-06','14:35:00',6.69),('8902','2013-08-06','14:40:00',6.61),('8902','2013-08-06','14:45:00',6.8),('8902','2013-08-06','14:50:00',6.78),('8902','2013-08-06','14:55:00',6.71),('8902','2013-08-06','15:00:00',6.6),('8902','2013-08-06','15:05:00',6.58),('8902','2013-08-06','15:10:00',6.51),('8902','2013-08-06','15:15:00',6.47),('8902','2013-08-06','15:20:00',6.43),('8902','2013-08-06','15:25:00',6.42),('8902','2013-08-06','15:30:00',6.2),('8902','2013-08-06','15:35:00',6.21),('8902','2013-08-06','15:40:00',6.16),('8902','2013-08-06','15:45:00',6.12),('8902','2013-08-06','15:50:00',6),('8902','2013-08-06','15:55:00',5.92),('8902','2013-08-06','16:00:00',5.85),('8902','2013-08-06','16:05:00',5.74),('8902','2013-08-06','16:10:00',5.56),('8902','2013-08-06','16:15:00',5.46),('8902','2013-08-06','16:20:00',5.42),('8902','2013-08-06','16:25:00',5.36),('8902','2013-08-06','16:30:00',5.25),('8902','2013-08-06','16:35:00',5.11),('8902','2013-08-06','16:40:00',4.99),('8902','2013-08-06','16:45:00',4.95),('8902','2013-08-06','16:50:00',4.84),('8902','2013-08-06','16:55:00',4.63),('8902','2013-08-06','17:00:00',4.56),('8902','2013-08-06','17:05:00',4.45),('8902','2013-08-06','17:10:00',4.32),('8902','2013-08-06','17:15:00',4.16),('8902','2013-08-06','17:20:00',4.01),('8902','2013-08-06','17:25:00',3.91),('8902','2013-08-06','17:30:00',3.72),('8902','2013-08-06','17:35:00',3.51),('8902','2013-08-06','17:40:00',3.32),('8902','2013-08-06','17:45:00',3.19),('8902','2013-08-06','17:50:00',3.02),('8902','2013-08-06','17:55:00',2.87),('8902','2013-08-06','18:00:00',2.71),('8902','2013-08-06','18:05:00',2.57),('8902','2013-08-06','18:10:00',2.37),('8902','2013-08-06','18:15:00',2.19),('8902','2013-08-06','18:20:00',2.02),('8902','2013-08-06','18:25:00',1.89),('8902','2013-08-06','18:30:00',1.75),('8902','2013-08-06','18:35:00',1.62),('8902','2013-08-06','18:40:00',1.47),('8902','2013-08-06','18:45:00',1.34),('8902','2013-08-06','18:50:00',1.19),('8902','2013-08-06','18:55:00',1.05),('8902','2013-08-05','07:45:00',1.01),('8902','2013-08-05','07:50:00',1.18),('8902','2013-08-05','07:55:00',1.31),('8902','2013-08-05','08:00:00',1.44),('8902','2013-08-05','08:05:00',1.58),('8902','2013-08-05','08:10:00',1.73),('8902','2013-08-05','08:15:00',1.88),('8902','2013-08-05','08:20:00',2.02),('8902','2013-08-05','08:25:00',2.17),('8902','2013-08-05','08:30:00',2.32),('8902','2013-08-05','08:35:00',2.47),('8902','2013-08-05','08:40:00',2.61),('8902','2013-08-05','08:45:00',2.77),('8902','2013-08-05','08:50:00',2.93),('8902','2013-08-05','08:55:00',3.08),('8902','2013-08-05','09:00:00',3.21),('8902','2013-08-05','09:05:00',3.35),('8902','2013-08-05','09:10:00',3.48),('8902','2013-08-05','09:15:00',3.65),('8902','2013-08-05','09:20:00',3.8),('8902','2013-08-05','09:25:00',3.92),('8902','2013-08-05','09:30:00',4.04),('8902','2013-08-05','09:35:00',4.2),('8902','2013-08-05','09:40:00',4.32),('8902','2013-08-05','09:45:00',4.42),('8902','2013-08-05','09:50:00',4.57),('8902','2013-08-05','09:55:00',4.73),('8902','2013-08-05','10:00:00',4.83),('8902','2013-08-05','10:05:00',4.94),('8902','2013-08-05','10:10:00',5.05),('8902','2013-08-05','10:15:00',5.17),('8902','2013-08-05','10:20:00',5.27),('8902','2013-08-05','10:25:00',5.39),('8902','2013-08-05','10:30:00',5.52),('8902','2013-08-05','10:35:00',5.58),('8902','2013-08-05','10:40:00',5.64),('8902','2013-08-05','10:45:00',5.72),('8902','2013-08-05','10:50:00',5.78),('8902','2013-08-05','10:55:00',5.85),('8902','2013-08-05','11:00:00',6),('8902','2013-08-05','11:05:00',6.04),('8902','2013-08-05','11:10:00',6.11),('8902','2013-08-05','11:15:00',6.22),('8902','2013-08-05','11:20:00',6.3),('8902','2013-08-05','11:25:00',6.3),('8902','2013-08-05','11:30:00',6.36),('8902','2013-08-05','11:35:00',6.49),('8902','2013-08-05','11:40:00',6.56),('8902','2013-08-05','11:45:00',6.53),('8902','2013-08-05','11:50:00',6.53),('8902','2013-08-05','11:55:00',6.58),('8902','2013-08-05','12:00:00',6.68),('8902','2013-08-05','12:05:00',6.7),('8902','2013-08-05','12:10:00',6.79),('8902','2013-08-05','12:15:00',6.76),('8902','2013-08-05','12:20:00',6.79),('8902','2013-08-05','12:25:00',6.83),('8902','2013-08-05','12:30:00',6.83),('8902','2013-08-05','12:35:00',6.88),('8902','2013-08-05','12:40:00',6.91),('8902','2013-08-05','12:45:00',6.86),('8902','2013-08-05','12:50:00',6.96),('8902','2013-08-05','12:55:00',7),('8902','2013-08-05','13:00:00',6.99),('8902','2013-08-05','13:05:00',7),('8902','2013-08-05','13:10:00',7.01),('8902','2013-08-05','13:15:00',7.07),('8902','2013-08-05','13:20:00',7.09),('8902','2013-08-05','13:25:00',7.17),('8902','2013-08-05','13:30:00',7.19),('8902','2013-08-05','13:35:00',7.23),('8902','2013-08-05','13:40:00',7.25),('8902','2013-08-05','13:45:00',7.24),('8902','2013-08-05','13:50:00',7.3),('8902','2013-08-05','13:55:00',7.33),('8902','2013-08-05','14:00:00',7.33),('8902','2013-08-05','14:05:00',7.32),('8902','2013-08-05','14:10:00',7.3),('8902','2013-08-05','14:15:00',7.31),('8902','2013-08-05','14:20:00',7.27),('8902','2013-08-05','14:25:00',7.21),('8902','2013-08-05','14:30:00',7.18),('8902','2013-08-05','14:35:00',7.14),('8902','2013-08-05','14:40:00',7.11),('8902','2013-08-05','14:45:00',7.06),('8902','2013-08-05','14:50:00',7.06),('8902','2013-08-05','14:55:00',7.01),('8902','2013-08-05','15:00:00',6.96),('8902','2013-08-05','15:05:00',6.9),('8902','2013-08-05','15:10:00',6.88),('8902','2013-08-05','15:15:00',6.78),('8902','2013-08-05','15:20:00',6.76),('8902','2013-08-05','15:25:00',6.73),('8902','2013-08-05','15:30:00',6.64),('8902','2013-08-05','15:35:00',6.57),('8902','2013-08-05','15:40:00',6.46),('8902','2013-08-05','15:45:00',6.38),('8902','2013-08-05','15:50:00',6.3),('8902','2013-08-05','15:55:00',6.17),('8902','2013-08-05','16:00:00',6.1),('8902','2013-08-05','16:05:00',6.01),('8902','2013-08-05','16:10:00',5.89),('8902','2013-08-05','16:15:00',5.78),('8902','2013-08-05','16:20:00',5.7),('8902','2013-08-05','16:25:00',5.56),('8902','2013-08-05','16:30:00',5.45),('8902','2013-08-05','16:35:00',5.27),('8902','2013-08-05','16:40:00',5.13),('8902','2013-08-05','16:45:00',5.07),('8902','2013-08-05','16:50:00',4.93),('8902','2013-08-05','16:55:00',4.72),('8902','2013-08-05','17:00:00',4.65),('8902','2013-08-05','17:05:00',4.57),('8902','2013-08-05','17:10:00',4.41),('8902','2013-08-05','17:15:00',4.25),('8902','2013-08-05','17:20:00',4.07),('8902','2013-08-05','17:25:00',3.95),('8902','2013-08-05','17:30:00',3.82),('8902','2013-08-05','17:35:00',3.67),('8902','2013-08-05','17:40:00',3.46),('8902','2013-08-05','17:45:00',3.33),('8902','2013-08-05','17:50:00',3.12),('8902','2013-08-05','17:55:00',2.94),('8902','2013-08-05','18:00:00',2.81),('8902','2013-08-05','18:05:00',2.66),('8902','2013-08-05','18:10:00',2.49),('8902','2013-08-05','18:15:00',2.33),('8902','2013-08-05','18:20:00',2.17),('8902','2013-08-05','18:25:00',2.01),('8902','2013-08-05','18:30:00',1.86),('8902','2013-08-05','18:35:00',1.7),('8902','2013-08-05','18:40:00',1.51),('8902','2013-08-05','18:45:00',1.36),('8902','2013-08-05','18:50:00',1.19),('8902','2013-08-05','18:55:00',1.05),('8902','2013-08-04','07:45:00',1.08),('8902','2013-08-04','07:50:00',1.27),('8902','2013-08-04','07:55:00',1.4),('8902','2013-08-04','08:00:00',1.54),('8902','2013-08-04','08:05:00',1.69),('8902','2013-08-04','08:10:00',1.84),('8902','2013-08-04','08:15:00',1.98),('8902','2013-08-04','08:20:00',2.12),('8902','2013-08-04','08:25:00',2.27),('8902','2013-08-04','08:30:00',2.42),('8902','2013-08-04','08:35:00',2.57),('8902','2013-08-04','08:40:00',2.72),('8902','2013-08-04','08:45:00',2.88),('8902','2013-08-04','08:50:00',3.03),('8902','2013-08-04','08:55:00',3.18),('8902','2013-08-04','09:00:00',3.33),('8902','2013-08-04','09:05:00',3.47),('8902','2013-08-04','09:10:00',3.61),('8902','2013-08-04','09:15:00',3.74),('8902','2013-08-04','09:20:00',3.86),('8902','2013-08-04','09:25:00',3.99),('8902','2013-08-04','09:30:00',4.11),('8902','2013-08-04','09:35:00',4.25),('8902','2013-08-04','09:40:00',4.38),('8902','2013-08-04','09:45:00',4.51),('8902','2013-08-04','09:50:00',4.61),('8902','2013-08-04','09:55:00',4.73),('8902','2013-08-04','10:00:00',4.85),('8902','2013-08-04','10:05:00',4.99),('8902','2013-08-04','10:10:00',5.12),('8902','2013-08-04','10:15:00',5.24),('8902','2013-08-04','10:20:00',5.33),('8902','2013-08-04','10:25:00',5.45),('8902','2013-08-04','10:30:00',5.56),('8902','2013-08-04','10:35:00',5.62),('8902','2013-08-04','10:40:00',5.74),('8902','2013-08-04','10:45:00',5.83),('8902','2013-08-04','10:50:00',5.91),('8902','2013-08-04','10:55:00',5.97),('8902','2013-08-04','11:00:00',6.12),('8902','2013-08-04','11:05:00',6.17),('8902','2013-08-04','11:10:00',6.31),('8902','2013-08-04','11:15:00',6.32),('8902','2013-08-04','11:20:00',6.44),('8902','2013-08-04','11:25:00',6.53),('8902','2013-08-04','11:30:00',6.55),('8902','2013-08-04','11:35:00',6.59),('8902','2013-08-04','11:40:00',6.67),('8902','2013-08-04','11:45:00',6.71),('8902','2013-08-04','11:50:00',6.8),('8902','2013-08-04','11:55:00',6.79),('8902','2013-08-04','12:00:00',6.82),('8902','2013-08-04','12:05:00',6.86),('8902','2013-08-04','12:10:00',6.89),('8902','2013-08-04','12:15:00',7.01),('8902','2013-08-04','12:20:00',7.03),('8902','2013-08-04','12:25:00',7.06),('8902','2013-08-04','12:30:00',7.06),('8902','2013-08-04','12:35:00',7.09),('8902','2013-08-04','12:40:00',7.14),('8902','2013-08-04','12:45:00',7.13),('8902','2013-08-04','12:50:00',7.15),('8902','2013-08-04','12:55:00',7.12),('8902','2013-08-04','13:00:00',7.14),('8902','2013-08-04','13:05:00',7.18),('8902','2013-08-04','13:10:00',7.21),('8902','2013-08-04','13:15:00',7.25),('8902','2013-08-04','13:20:00',7.22),('8902','2013-08-04','13:25:00',7.22),('8902','2013-08-04','13:30:00',7.22),('8902','2013-08-04','13:35:00',7.25),('8902','2013-08-04','13:40:00',7.22),('8902','2013-08-04','13:45:00',7.2),('8902','2013-08-04','13:50:00',7.06),('8902','2013-08-04','13:55:00',7.07),('8902','2013-08-04','14:00:00',7.12),('8902','2013-08-04','14:05:00',7.14),('8902','2013-08-04','14:10:00',7.09),('8902','2013-08-04','14:15:00',7.05),('8902','2013-08-04','14:20:00',7.03),('8902','2013-08-04','14:25:00',6.97),('8902','2013-08-04','14:30:00',6.93),('8902','2013-08-04','14:35:00',6.95),('8902','2013-08-04','14:40:00',6.93),('8902','2013-08-04','14:45:00',6.89),('8902','2013-08-04','14:50:00',6.84),('8902','2013-08-04','14:55:00',6.78),('8902','2013-08-04','15:00:00',6.73),('8902','2013-08-04','15:05:00',6.73),('8902','2013-08-04','15:10:00',6.7),('8902','2013-08-04','15:15:00',6.67),('8902','2013-08-04','15:20:00',6.57),('8902','2013-08-04','15:25:00',6.52),('8902','2013-08-04','15:30:00',6.49),('8902','2013-08-04','15:35:00',6.44),('8902','2013-08-04','15:40:00',6.37),('8902','2013-08-04','15:45:00',6.28),('8902','2013-08-04','15:50:00',6.21),('8902','2013-08-04','15:55:00',6.13),('8902','2013-08-04','16:00:00',6.11),('8902','2013-08-04','16:05:00',6.01),('8902','2013-08-04','16:10:00',5.89),('8902','2013-08-04','16:15:00',5.79),('8902','2013-08-04','16:20:00',5.64),('8902','2013-08-04','16:25:00',5.53),('8902','2013-08-04','16:30:00',5.45),('8902','2013-08-04','16:35:00',5.28),('8902','2013-08-04','16:40:00',5.15),('8902','2013-08-04','16:45:00',5.03),('8902','2013-08-04','16:50:00',4.91),('8902','2013-08-04','16:55:00',4.73),('8902','2013-08-04','17:00:00',4.64),('8902','2013-08-04','17:05:00',4.52),('8902','2013-08-04','17:10:00',4.37),('8902','2013-08-04','17:15:00',4.23),('8902','2013-08-04','17:20:00',4.02),('8902','2013-08-04','17:25:00',3.88),('8902','2013-08-04','17:30:00',3.75),('8902','2013-08-04','17:35:00',3.6),('8902','2013-08-04','17:40:00',3.44),('8902','2013-08-04','17:45:00',3.3),('8902','2013-08-04','17:50:00',3.09),('8902','2013-08-04','17:55:00',2.92),('8902','2013-08-04','18:00:00',2.77),('8902','2013-08-04','18:05:00',2.59),('8902','2013-08-04','18:10:00',2.41),('8902','2013-08-04','18:15:00',2.25),('8902','2013-08-04','18:20:00',2.1),('8902','2013-08-04','18:25:00',1.95),('8902','2013-08-04','18:30:00',1.76),('8902','2013-08-04','18:35:00',1.64),('8902','2013-08-04','18:40:00',1.49),('8902','2013-08-04','18:45:00',1.34),('8902','2013-08-04','18:50:00',1.2),('8902','2013-08-04','18:55:00',1.06),('8902','2013-08-03','07:45:00',1.07),('8902','2013-08-03','07:50:00',1.26),('8902','2013-08-03','07:55:00',1.42),('8902','2013-08-03','08:00:00',1.57),('8902','2013-08-03','08:05:00',1.72),('8902','2013-08-03','08:10:00',1.88),('8902','2013-08-03','08:15:00',2.05),('8902','2013-08-03','08:20:00',2.23),('8902','2013-08-03','08:25:00',2.39),('8902','2013-08-03','08:30:00',2.54),('8902','2013-08-03','08:35:00',2.71),('8902','2013-08-03','08:40:00',2.87),('8902','2013-08-03','08:45:00',3.03),('8902','2013-08-03','08:50:00',3.19),('8902','2013-08-03','08:55:00',3.34),('8902','2013-08-03','09:00:00',3.51),('8902','2013-08-03','09:05:00',3.66),('8902','2013-08-03','09:10:00',3.8),('8902','2013-08-03','09:15:00',3.93),('8902','2013-08-03','09:20:00',4.07),('8902','2013-08-03','09:25:00',4.22),('8902','2013-08-03','09:30:00',4.36),('8902','2013-08-03','09:35:00',4.51),('8902','2013-08-03','09:40:00',4.64),('8902','2013-08-03','09:45:00',4.76),('8902','2013-08-03','09:50:00',4.9),('8902','2013-08-03','09:55:00',5.02),('8902','2013-08-03','10:00:00',5.13),('8902','2013-08-03','10:05:00',5.24),('8902','2013-08-03','10:10:00',5.34),('8902','2013-08-03','10:15:00',5.46),('8902','2013-08-03','10:20:00',5.57),('8902','2013-08-03','10:25:00',5.69),('8902','2013-08-03','10:30:00',5.78),('8902','2013-08-03','10:35:00',5.9),('8902','2013-08-03','10:40:00',5.99),('8902','2013-08-03','10:45:00',6.05),('8902','2013-08-03','10:50:00',5.44),('8902','2013-08-03','10:55:00',6.23),('8902','2013-08-03','11:00:00',6.29),('8902','2013-08-03','11:05:00',6.35),('8902','2013-08-03','11:10:00',6.4),('8902','2013-08-03','11:15:00',6.45),('8902','2013-08-03','11:20:00',6.51),('8902','2013-08-03','11:25:00',6.59),('8902','2013-08-03','11:30:00',6.71),('8902','2013-08-03','11:35:00',6.79),('8902','2013-08-03','11:40:00',6.86),('8902','2013-08-03','11:45:00',6.9),('8902','2013-08-03','11:50:00',6.92),('8902','2013-08-03','11:55:00',7.03),('8902','2013-08-03','12:00:00',7.07),('8902','2013-08-03','12:05:00',7.11),('8902','2013-08-03','12:10:00',7.11),('8902','2013-08-03','12:15:00',7.15),('8902','2013-08-03','12:20:00',7.24),('8902','2013-08-03','12:25:00',7.2),('8902','2013-08-03','12:30:00',7.16),('8902','2013-08-03','12:35:00',7.19),('8902','2013-08-03','12:40:00',7.27),('8902','2013-08-03','12:45:00',7.33),('8902','2013-08-03','12:50:00',7.38),('8902','2013-08-03','12:55:00',7.37),('8902','2013-08-03','13:00:00',7.36),('8902','2013-08-03','13:05:00',7.34),('8902','2013-08-03','13:10:00',7.25),('8902','2013-08-03','13:15:00',7.31),('8902','2013-08-03','13:20:00',7.33),('8902','2013-08-03','13:25:00',7.3),('8902','2013-08-03','13:30:00',7.36),('8902','2013-08-03','13:35:00',7.41),('8902','2013-08-03','13:40:00',7.52),('8902','2013-08-03','13:45:00',7.5),('8902','2013-08-03','13:50:00',7.49),('8902','2013-08-03','13:55:00',7.54),('8902','2013-08-03','14:00:00',7.54),('8902','2013-08-03','14:05:00',7.54),('8902','2013-08-03','14:10:00',7.46),('8902','2013-08-03','14:15:00',7.47),('8902','2013-08-03','14:20:00',7.35),('8902','2013-08-03','14:25:00',7.35),('8902','2013-08-03','14:30:00',7.36),('8902','2013-08-03','14:35:00',7.3),('8902','2013-08-03','14:40:00',7.21),('8902','2013-08-03','14:45:00',7.23),('8902','2013-08-03','14:50:00',7.17),('8902','2013-08-03','14:55:00',6.05),('8902','2013-08-03','15:00:00',7.01),('8902','2013-08-03','15:05:00',7),('8902','2013-08-03','15:10:00',6.95),('8902','2013-08-03','15:15:00',6.9),('8902','2013-08-03','15:20:00',6.82),('8902','2013-08-03','15:25:00',6.73),('8902','2013-08-03','15:30:00',6.59),('8902','2013-08-03','15:35:00',6.68),('8902','2013-08-03','15:40:00',6.54),('8902','2013-08-03','15:45:00',6.46),('8902','2013-08-03','15:50:00',6.31),('8902','2013-08-03','15:55:00',6.25),('8902','2013-08-03','16:00:00',6.2),('8902','2013-08-03','16:05:00',6.09),('8902','2013-08-03','16:10:00',6.01),('8902','2013-08-03','16:15:00',5.97),('8902','2013-08-03','16:20:00',5.88),('8902','2013-08-03','16:25:00',5.75),('8902','2013-08-03','16:30:00',5.64),('8902','2013-08-03','16:35:00',5.44),('8902','2013-08-03','16:40:00',5.28),('8902','2013-08-03','16:45:00',5.25),('8902','2013-08-03','16:50:00',5.1),('8902','2013-08-03','16:55:00',4.9),('8902','2013-08-03','17:00:00',4.74),('8902','2013-08-03','17:05:00',4.7),('8902','2013-08-03','17:10:00',4.58),('8902','2013-08-03','17:15:00',4.42),('8902','2013-08-03','17:20:00',4.24),('8902','2013-08-03','17:25:00',4.07),('8902','2013-08-03','17:30:00',3.92),('8902','2013-08-03','17:35:00',3.77),('8902','2013-08-03','17:40:00',3.57),('8902','2013-08-03','17:45:00',3.43),('8902','2013-08-03','17:50:00',3.26),('8902','2013-08-03','17:55:00',3.05),('8902','2013-08-03','18:00:00',2.91),('8902','2013-08-03','18:05:00',2.72),('8902','2013-08-03','18:10:00',2.51),('8902','2013-08-03','18:15:00',2.38),('8902','2013-08-03','18:20:00',2.24),('8902','2013-08-03','18:25:00',2.07),('8902','2013-08-03','18:30:00',1.87),('8902','2013-08-03','18:35:00',1.69),('8902','2013-08-03','18:40:00',1.53),('8902','2013-08-03','18:45:00',1.31),('8902','2013-08-03','18:50:00',1.22),('8902','2013-08-03','18:55:00',1.08),('8902','2013-08-02','07:45:00',1.1),('8902','2013-08-02','07:50:00',1.27),('8902','2013-08-02','07:55:00',1.42),('8902','2013-08-02','08:00:00',1.57),('8902','2013-08-02','08:05:00',1.73),('8902','2013-08-02','08:10:00',1.88),('8902','2013-08-02','08:15:00',2.04),('8902','2013-08-02','08:20:00',2.21),('8902','2013-08-02','08:25:00',2.37),('8902','2013-08-02','08:30:00',2.51),('8902','2013-08-02','08:35:00',2.68),('8902','2013-08-02','08:40:00',2.83),('8902','2013-08-02','08:45:00',3),('8902','2013-08-02','08:50:00',3.16),('8902','2013-08-02','08:55:00',3.32),('8902','2013-08-02','09:00:00',3.47),('8902','2013-08-02','09:05:00',3.61),('8902','2013-08-02','09:10:00',3.76),('8902','2013-08-02','09:15:00',3.91),('8902','2013-08-02','09:20:00',4.06),('8902','2013-08-02','09:25:00',4.22),('8902','2013-08-02','09:30:00',4.37),('8902','2013-08-02','09:35:00',4.51),('8902','2013-08-02','09:40:00',4.63),('8902','2013-08-02','09:45:00',4.74),('8902','2013-08-02','09:50:00',4.88),('8902','2013-08-02','09:55:00',5),('8902','2013-08-02','10:00:00',5.09),('8902','2013-08-02','10:05:00',5.22),('8902','2013-08-02','10:10:00',5.33),('8902','2013-08-02','10:15:00',5.45),('8902','2013-08-02','10:20:00',5.54),('8902','2013-08-02','10:25:00',5.67),('8902','2013-08-02','10:30:00',5.78),('8902','2013-08-02','10:35:00',5.88),('8902','2013-08-02','10:40:00',5.95),('8902','2013-08-02','10:45:00',6.03),('8902','2013-08-02','10:50:00',6.11),('8902','2013-08-02','10:55:00',6.19),('8902','2013-08-02','11:00:00',6.31),('8902','2013-08-02','11:05:00',6.4),('8902','2013-08-02','11:10:00',6.39),('8902','2013-08-02','11:15:00',6.45),('8902','2013-08-02','11:20:00',6.54),('8902','2013-08-02','11:25:00',6.56),('8902','2013-08-02','11:30:00',6.57),('8902','2013-08-02','11:35:00',6.74),('8902','2013-08-02','11:40:00',6.82),('8902','2013-08-02','11:45:00',6.85),('8902','2013-08-02','11:50:00',6.92),('8902','2013-08-02','11:55:00',7.03),('8902','2013-08-02','12:00:00',7.02),('8902','2013-08-02','12:05:00',7.02),('8902','2013-08-02','12:10:00',7.09),('8902','2013-08-02','12:15:00',7.15),('8902','2013-08-02','12:20:00',7.17),('8902','2013-08-02','12:25:00',7.15),('8902','2013-08-02','12:30:00',7.24),('8902','2013-08-02','12:35:00',7.22),('8902','2013-08-02','12:40:00',7.19),('8902','2013-08-02','12:45:00',7.28),('8902','2013-08-02','12:50:00',7.25),('8902','2013-08-02','12:55:00',7.2),('8902','2013-08-02','13:00:00',7.27),('8902','2013-08-02','13:05:00',7.16),('8902','2013-08-02','13:10:00',7.18),('8902','2013-08-02','13:15:00',7.24),('8902','2013-08-02','13:20:00',7.15),('8902','2013-08-02','13:25:00',7.15),('8902','2013-08-02','13:30:00',7.08),('8902','2013-08-02','13:35:00',7),('8902','2013-08-02','13:40:00',7.14),('8902','2013-08-02','13:45:00',7.27),('8902','2013-08-02','13:50:00',7.28),('8902','2013-08-02','13:55:00',7.28),('8902','2013-08-02','14:00:00',7.24),('8902','2013-08-02','14:05:00',7.21),('8902','2013-08-02','14:10:00',7),('8902','2013-08-02','14:15:00',6.94),('8902','2013-08-02','14:20:00',7.05),('8902','2013-08-02','14:25:00',6.97),('8902','2013-08-02','14:30:00',6.99),('8902','2013-08-02','14:35:00',7.12),('8902','2013-08-02','14:40:00',7.05),('8902','2013-08-02','14:45:00',7.13),('8902','2013-08-02','14:50:00',7.05),('8902','2013-08-02','14:55:00',7.05),('8902','2013-08-02','15:00:00',7),('8902','2013-08-02','15:05:00',6.88),('8902','2013-08-02','15:10:00',6.85),('8902','2013-08-02','15:15:00',6.75),('8902','2013-08-02','15:20:00',6.73),('8902','2013-08-02','15:25:00',6.71),('8902','2013-08-02','15:30:00',6.67),('8902','2013-08-02','15:35:00',6.58),('8902','2013-08-02','15:40:00',6.51),('8902','2013-08-02','15:45:00',6.44),('8902','2013-08-02','15:50:00',6.36),('8902','2013-08-02','15:55:00',6.28),('8902','2013-08-02','16:00:00',6.14),('8902','2013-08-02','16:05:00',6.04),('8902','2013-08-02','16:10:00',5.91),('8902','2013-08-02','16:15:00',5.8),('8902','2013-08-02','16:20:00',5.68),('8902','2013-08-02','16:25:00',5.57),('8902','2013-08-02','16:30:00',5.49),('8902','2013-08-02','16:35:00',5.34),('8902','2013-08-02','16:40:00',5.25),('8902','2013-08-02','16:45:00',5.14),('8902','2013-08-02','16:50:00',5.05),('8902','2013-08-02','16:55:00',4.88),('8902','2013-08-02','17:00:00',4.59),('8902','2013-08-02','17:05:00',4.59),('8902','2013-08-02','17:10:00',4.47),('8902','2013-08-02','17:15:00',4.32),('8902','2013-08-02','17:20:00',4.16),('8902','2013-08-02','17:25:00',4.01),('8902','2013-08-02','17:30:00',3.9),('8902','2013-08-02','17:35:00',3.77),('8902','2013-08-02','17:40:00',3.55),('8902','2013-08-02','17:45:00',3.42),('8902','2013-08-02','17:50:00',3.23),('8902','2013-08-02','17:55:00',3.03),('8902','2013-08-02','18:00:00',2.91),('8902','2013-08-02','18:05:00',2.77),('8902','2013-08-02','18:10:00',2.57),('8902','2013-08-02','18:15:00',2.43),('8902','2013-08-02','18:20:00',2.27),('8902','2013-08-02','18:25:00',2.12),('8902','2013-08-02','18:30:00',1.95),('8902','2013-08-02','18:35:00',1.79),('8902','2013-08-02','18:40:00',1.64),('8902','2013-08-02','18:45:00',1.48),('8902','2013-08-02','18:50:00',1.32),('8902','2013-08-02','18:55:00',1.18),('8902','2013-08-02','19:00:00',1.04),('8902','2013-08-01','07:45:00',1.17),('8902','2013-08-01','07:50:00',1.33),('8902','2013-08-01','07:55:00',1.49),('8902','2013-08-01','08:00:00',1.66),('8902','2013-08-01','08:05:00',1.82),('8902','2013-08-01','08:10:00',1.98),('8902','2013-08-01','08:15:00',2.15),('8902','2013-08-01','08:20:00',2.32),('8902','2013-08-01','08:25:00',2.49),('8902','2013-08-01','08:30:00',2.66),('8902','2013-08-01','08:35:00',2.82),('8902','2013-08-01','08:40:00',2.98),('8902','2013-08-01','08:45:00',3.13),('8902','2013-08-01','08:50:00',3.29),('8902','2013-08-01','08:55:00',3.43),('8902','2013-08-01','09:00:00',3.6),('8902','2013-08-01','09:05:00',3.75),('8902','2013-08-01','09:10:00',3.9),('8902','2013-08-01','09:15:00',4.05),('8902','2013-08-01','09:20:00',4.19),('8902','2013-08-01','09:25:00',4.35),('8902','2013-08-01','09:30:00',4.49),('8902','2013-08-01','09:35:00',4.62),('8902','2013-08-01','09:40:00',4.74),('8902','2013-08-01','09:45:00',4.86),('8902','2013-08-01','09:50:00',4.99),('8902','2013-08-01','09:55:00',5.11),('8902','2013-08-01','10:00:00',5.2),('8902','2013-08-01','10:05:00',5.31),('8902','2013-08-01','10:10:00',5.43),('8902','2013-08-01','10:15:00',5.56),('8902','2013-08-01','10:20:00',5.66),('8902','2013-08-01','10:25:00',5.74),('8902','2013-08-01','10:30:00',5.86),('8902','2013-08-01','10:35:00',5.96),('8902','2013-08-01','10:40:00',6.04),('8902','2013-08-01','10:45:00',6.14),('8902','2013-08-01','10:50:00',6.2),('8902','2013-08-01','10:55:00',6.31),('8902','2013-08-01','11:00:00',6.39),('8902','2013-08-01','11:05:00',6.48),('8902','2013-08-01','11:10:00',6.52),('8902','2013-08-01','11:15:00',6.63),('8902','2013-08-01','11:20:00',6.72),('8902','2013-08-01','11:25:00',6.81),('8902','2013-08-01','11:30:00',6.83),('8902','2013-08-01','11:35:00',6.86),('8902','2013-08-01','11:40:00',6.9),('8902','2013-08-01','11:45:00',6.95),('8902','2013-08-01','11:50:00',7.01),('8902','2013-08-01','11:55:00',7.07),('8902','2013-08-01','12:00:00',7.16),('8902','2013-08-01','12:05:00',7.18),('8902','2013-08-01','12:10:00',7.23),('8902','2013-08-01','12:15:00',7.27),('8902','2013-08-01','12:20:00',7.28),('8902','2013-08-01','12:25:00',7.3),('8902','2013-08-01','12:30:00',7.31),('8902','2013-08-01','12:35:00',7.36),('8902','2013-08-01','12:40:00',7.36),('8902','2013-08-01','12:45:00',7.37),('8902','2013-08-01','12:50:00',7.34),('8902','2013-08-01','12:55:00',7.38),('8902','2013-08-01','13:00:00',7.37),('8902','2013-08-01','13:05:00',7.48),('8902','2013-08-01','13:10:00',7.55),('8902','2013-08-01','13:15:00',7.57),('8902','2013-08-01','13:20:00',7.43),('8902','2013-08-01','13:25:00',7.52),('8902','2013-08-01','13:30:00',7.51),('8902','2013-08-01','13:35:00',7.52),('8902','2013-08-01','13:40:00',7.49),('8902','2013-08-01','13:45:00',7.51),('8902','2013-08-01','13:50:00',7.49),('8902','2013-08-01','13:55:00',7.45),('8902','2013-08-01','14:00:00',7.47),('8902','2013-08-01','14:05:00',7.45),('8902','2013-08-01','14:10:00',7.39),('8902','2013-08-01','14:15:00',7.28),('8902','2013-08-01','14:20:00',7.23),('8902','2013-08-01','14:25:00',7.12),('8902','2013-08-01','14:30:00',7.17),('8902','2013-08-01','14:35:00',7.23),('8902','2013-08-01','14:40:00',7.27),('8902','2013-08-01','14:45:00',7.2),('8902','2013-08-01','14:50:00',7.2),('8902','2013-08-01','14:55:00',7.17),('8902','2013-08-01','15:00:00',7.14),('8902','2013-08-01','15:05:00',7.11),('8902','2013-08-01','15:10:00',6.99),('8902','2013-08-01','15:15:00',6.88),('8902','2013-08-01','15:20:00',6.95),('8902','2013-08-01','15:25:00',6.94),('8902','2013-08-01','15:30:00',6.84),('8902','2013-08-01','15:35:00',6.75),('8902','2013-08-01','15:40:00',6.69),('8902','2013-08-01','15:45:00',6.6),('8902','2013-08-01','15:50:00',6.49),('8902','2013-08-01','15:55:00',6.37),('8902','2013-08-01','16:00:00',6.32),('8902','2013-08-01','16:05:00',6.25),('8902','2013-08-01','16:10:00',6.17),('8902','2013-08-01','16:15:00',6.04),('8902','2013-08-01','16:20:00',5.91),('8902','2013-08-01','16:25:00',4.87),('8902','2013-08-01','16:30:00',5.69),('8902','2013-08-01','16:35:00',5.54),('8902','2013-08-01','16:40:00',5.32),('8902','2013-08-01','16:45:00',5.34),('8902','2013-08-01','16:50:00',5.25),('8902','2013-08-01','16:55:00',5.04),('8902','2013-08-01','17:00:00',4.93),('8902','2013-08-01','17:05:00',4.74),('8902','2013-08-01','17:10:00',4.59),('8902','2013-08-01','17:15:00',4.49),('8902','2013-08-01','17:20:00',4.35),('8902','2013-08-01','17:25:00',4.24),('8902','2013-08-01','17:30:00',4.07),('8902','2013-08-01','17:35:00',3.89),('8902','2013-08-01','17:40:00',3.68),('8902','2013-08-01','17:45:00',3.54),('8902','2013-08-01','17:50:00',3.33),('8902','2013-08-01','17:55:00',3.15),('8902','2013-08-01','18:00:00',3.03),('8902','2013-08-01','18:05:00',2.89),('8902','2013-08-01','18:10:00',2.69),('8902','2013-08-01','18:15:00',2.53),('8902','2013-08-01','18:20:00',2.37),('8902','2013-08-01','18:25:00',2.21),('8902','2013-08-01','18:30:00',2.02),('8902','2013-08-01','18:35:00',1.85),('8902','2013-08-01','18:40:00',1.7),('8902','2013-08-01','18:45:00',1.52),('8902','2013-08-01','18:50:00',1.36),('8902','2013-08-01','18:55:00',1.2),('8902','2013-08-01','19:00:00',1.09),('8902','2013-07-31','07:45:00',1.19),('8902','2013-07-31','07:50:00',1.35),('8902','2013-07-31','07:55:00',1.5),('8902','2013-07-31','08:00:00',1.66),('8902','2013-07-31','08:05:00',1.83),('8902','2013-07-31','08:10:00',1.99),('8902','2013-07-31','08:15:00',2.15),('8902','2013-07-31','08:20:00',2.33),('8902','2013-07-31','08:25:00',2.51),('8902','2013-07-31','08:30:00',2.68),('8902','2013-07-31','08:35:00',2.85),('8902','2013-07-31','08:40:00',3.03),('8902','2013-07-31','08:45:00',3.19),('8902','2013-07-31','08:50:00',3.36),('8902','2013-07-31','08:55:00',3.51),('8902','2013-07-31','09:00:00',3.66),('8902','2013-07-31','09:05:00',3.83),('8902','2013-07-31','09:10:00',3.99),('8902','2013-07-31','09:15:00',4.17),('8902','2013-07-31','09:20:00',4.32),('8902','2013-07-31','09:25:00',4.46),('8902','2013-07-31','09:30:00',4.6),('8902','2013-07-31','09:35:00',4.76),('8902','2013-07-31','09:40:00',4.89),('8902','2013-07-31','09:45:00',5.04),('8902','2013-07-31','09:50:00',5.19),('8902','2013-07-31','09:55:00',5.29),('8902','2013-07-31','10:00:00',5.39),('8902','2013-07-31','10:05:00',5.53),('8902','2013-07-31','10:10:00',5.67),('8902','2013-07-31','10:15:00',5.78),('8902','2013-07-31','10:20:00',5.88),('8902','2013-07-31','10:25:00',5.99),('8902','2013-07-31','10:30:00',6.1),('8902','2013-07-31','10:35:00',6.17),('8902','2013-07-31','10:40:00',6.27),('8902','2013-07-31','10:45:00',6.37),('8902','2013-07-31','10:50:00',6.45),('8902','2013-07-31','10:55:00',6.55),('8902','2013-07-31','11:00:00',6.65),('8902','2013-07-31','11:05:00',6.75),('8902','2013-07-31','11:10:00',6.85),('8902','2013-07-31','11:15:00',6.98),('8902','2013-07-31','11:20:00',7.05),('8902','2013-07-31','11:25:00',7.12),('8902','2013-07-31','11:30:00',7.17),('8902','2013-07-31','11:35:00',7.25),('8902','2013-07-31','11:40:00',7.34),('8902','2013-07-31','11:45:00',7.45),('8902','2013-07-31','11:50:00',7.5),('8902','2013-07-31','11:55:00',7.54),('8902','2013-07-31','12:00:00',7.58),('8902','2013-07-31','12:05:00',7.58),('8902','2013-07-31','12:10:00',7.59),('8902','2013-07-31','12:15:00',7.62),('8902','2013-07-31','12:20:00',7.64),('8902','2013-07-31','12:25:00',7.7),('8902','2013-07-31','12:30:00',7.74),('8902','2013-07-31','12:35:00',7.84),('8902','2013-07-31','12:40:00',7.89),('8902','2013-07-31','12:45:00',7.83),('8902','2013-07-31','12:50:00',7.92),('8902','2013-07-31','12:55:00',7.89),('8902','2013-07-31','13:00:00',7.88),('8902','2013-07-31','13:05:00',7.93),('8902','2013-07-31','13:10:00',7.93),('8902','2013-07-31','13:15:00',7.55),('8902','2013-07-31','13:20:00',8),('8902','2013-07-31','13:25:00',7.99),('8902','2013-07-31','13:30:00',8),('8902','2013-07-31','13:35:00',7.68),('8902','2013-07-31','13:40:00',8.01),('8902','2013-07-31','13:45:00',7.59),('8902','2013-07-31','13:50:00',8.07),('8902','2013-07-31','13:55:00',7.84),('8902','2013-07-31','14:00:00',7.66),('8902','2013-07-31','14:05:00',7.85),('8902','2013-07-31','14:10:00',7.55),('8902','2013-07-31','14:15:00',7.19),('8902','2013-07-31','14:20:00',7.54),('8902','2013-07-31','14:25:00',7.52),('8902','2013-07-31','14:30:00',7.57),('8902','2013-07-31','14:35:00',6),('8902','2013-07-31','14:40:00',7.62),('8902','2013-07-31','14:45:00',7.57),('8902','2013-07-31','14:50:00',7.43),('8902','2013-07-31','14:55:00',7.34),('8902','2013-07-31','15:00:00',7.22),('8902','2013-07-31','15:05:00',7.16),('8902','2013-07-31','15:10:00',7.33),('8902','2013-07-31','15:15:00',5.8),('8902','2013-07-31','15:20:00',4.7),('8902','2013-07-31','15:25:00',7.25),('8902','2013-07-31','15:30:00',7.03),('8902','2013-07-31','15:35:00',7.06),('8902','2013-07-31','15:40:00',4.23),('8902','2013-07-31','15:45:00',6.79),('8902','2013-07-31','15:50:00',6.68),('8902','2013-07-31','15:55:00',6.68),('8902','2013-07-31','16:00:00',6.63),('8902','2013-07-31','16:05:00',6.44),('8902','2013-07-31','16:10:00',6.29),('8902','2013-07-31','16:15:00',6.22),('8902','2013-07-31','16:20:00',6.14),('8902','2013-07-31','16:25:00',6.01),('8902','2013-07-31','16:30:00',5.87),('8902','2013-07-31','16:35:00',5.72),('8902','2013-07-31','16:40:00',5.58),('8902','2013-07-31','16:45:00',5.47),('8902','2013-07-31','16:50:00',5.35),('8902','2013-07-31','16:55:00',5.16),('8902','2013-07-31','17:00:00',4.91),('8902','2013-07-31','17:05:00',4.89),('8902','2013-07-31','17:10:00',4.76),('8902','2013-07-31','17:15:00',4.64),('8902','2013-07-31','17:20:00',4.43),('8902','2013-07-31','17:25:00',4.29),('8902','2013-07-31','17:30:00',4.16),('8902','2013-07-31','17:35:00',4.03),('8902','2013-07-31','17:40:00',3.8),('8902','2013-07-31','17:45:00',3.68),('8902','2013-07-31','17:50:00',3.51),('8902','2013-07-31','17:55:00',3.3),('8902','2013-07-31','18:00:00',3.17),('8902','2013-07-31','18:05:00',3.01),('8902','2013-07-31','18:10:00',2.77),('8902','2013-07-31','18:15:00',2.66),('8902','2013-07-31','18:20:00',2.5),('8902','2013-07-31','18:25:00',2.32),('8902','2013-07-31','18:30:00',2.14),('8902','2013-07-31','18:35:00',1.96),('8902','2013-07-31','18:40:00',1.79),('8902','2013-07-31','18:45:00',1.63),('8902','2013-07-31','18:50:00',1.46),('8902','2013-07-31','18:55:00',1.27),('8902','2013-07-31','19:00:00',1.15),('8902','2013-07-31','19:05:00',1.01),('8902','2013-07-30','07:40:00',1.09),('8902','2013-07-30','07:45:00',1.24),('8902','2013-07-30','07:50:00',1.39),('8902','2013-07-30','07:55:00',1.54),('8902','2013-07-30','08:00:00',1.7),('8902','2013-07-30','08:05:00',1.87),('8902','2013-07-30','08:10:00',2.04),('8902','2013-07-30','08:15:00',2.21),('8902','2013-07-30','08:20:00',2.39),('8902','2013-07-30','08:25:00',2.56),('8902','2013-07-30','08:30:00',2.73),('8902','2013-07-30','08:35:00',2.9),('8902','2013-07-30','08:40:00',3.07),('8902','2013-07-30','08:45:00',3.22),('8902','2013-07-30','08:50:00',3.39),('8902','2013-07-30','08:55:00',3.57),('8902','2013-07-30','09:00:00',3.73),('8902','2013-07-30','09:05:00',3.89),('8902','2013-07-30','09:10:00',4.05),('8902','2013-07-30','09:15:00',4.19),('8902','2013-07-30','09:20:00',4.35),('8902','2013-07-30','09:25:00',4.49),('8902','2013-07-30','09:30:00',4.64),('8902','2013-07-30','09:35:00',4.77),('8902','2013-07-30','09:40:00',4.9),('8902','2013-07-30','09:45:00',5.06),('8902','2013-07-30','09:50:00',5.19),('8902','2013-07-30','09:55:00',5.32),('8902','2013-07-30','10:00:00',5.48),('8902','2013-07-30','10:05:00',5.6),('8902','2013-07-30','10:10:00',5.65),('8902','2013-07-30','10:15:00',5.75),('8902','2013-07-30','10:20:00',5.89),('8902','2013-07-30','10:25:00',6.02),('8902','2013-07-30','10:30:00',6.15),('8902','2013-07-30','10:35:00',6.26),('8902','2013-07-30','10:40:00',6.37),('8902','2013-07-30','10:45:00',6.48),('8902','2013-07-30','10:50:00',6.6),('8902','2013-07-30','10:55:00',6.69),('8902','2013-07-30','11:00:00',6.8),('8902','2013-07-30','11:05:00',6.87),('8902','2013-07-30','11:10:00',6.95),('8902','2013-07-30','11:15:00',7.02),('8902','2013-07-30','11:20:00',7.06),('8902','2013-07-30','11:25:00',7.12),('8902','2013-07-30','11:30:00',7.18),('8902','2013-07-30','11:35:00',7.26),('8902','2013-07-30','11:40:00',7.32),('8902','2013-07-30','11:45:00',7.43),('8902','2013-07-30','11:50:00',7.47),('8902','2013-07-30','11:55:00',7.55),('8902','2013-07-30','12:00:00',7.58),('8902','2013-07-30','12:05:00',7.57),('8902','2013-07-30','12:10:00',7.63),('8902','2013-07-30','12:15:00',7.74),('8902','2013-07-30','12:20:00',7.78),('8902','2013-07-30','12:25:00',7.85),('8902','2013-07-30','12:30:00',7.8),('8902','2013-07-30','12:35:00',7.78),('8902','2013-07-30','12:40:00',7.85),('8902','2013-07-30','12:45:00',7.36),('8902','2013-07-30','12:50:00',6.6),('8902','2013-07-30','12:55:00',8.05),('8902','2013-07-30','13:00:00',2.61),('8902','2013-07-30','13:05:00',8.45),('8902','2013-07-30','13:10:00',8.13),('8902','2013-07-30','13:15:00',8.05),('8902','2013-07-30','13:20:00',7.65),('8902','2013-07-30','13:25:00',6.93),('8902','2013-07-30','13:30:00',7.13),('8902','2013-07-30','13:35:00',7.67),('8902','2013-07-30','13:40:00',7.51),('8902','2013-07-30','13:45:00',7.95),('8902','2013-07-30','13:50:00',6.64),('8902','2013-07-30','13:55:00',5.11),('8902','2013-07-30','14:00:00',5.88),('8902','2013-07-30','14:05:00',8.32),('8902','2013-07-30','14:10:00',8.17),('8902','2013-07-30','14:15:00',8.14),('8902','2013-07-30','14:20:00',8.16),('8902','2013-07-30','14:25:00',7.95),('8902','2013-07-30','14:30:00',7.8),('8902','2013-07-30','14:35:00',7.69),('8902','2013-07-30','14:40:00',7.76),('8902','2013-07-30','14:45:00',7.72),('8902','2013-07-30','14:50:00',4.48),('8902','2013-07-30','14:55:00',2.75),('8902','2013-07-30','15:00:00',3.46),('8902','2013-07-30','15:05:00',7.94),('8902','2013-07-30','15:10:00',7.66),('8902','2013-07-30','15:15:00',5.79),('8902','2013-07-30','15:20:00',7.66),('8902','2013-07-30','15:25:00',6.7),('8902','2013-07-30','15:30:00',7.28),('8902','2013-07-30','15:35:00',6.73),('8902','2013-07-30','15:40:00',4.81),('8902','2013-07-30','15:45:00',6.95),('8902','2013-07-30','15:50:00',6.79),('8902','2013-07-30','15:55:00',6.65),('8902','2013-07-30','16:00:00',6.52),('8902','2013-07-30','16:05:00',6.51),('8902','2013-07-30','16:10:00',6.44),('8902','2013-07-30','16:15:00',6.35),('8902','2013-07-30','16:20:00',6.33),('8902','2013-07-30','16:25:00',5.47),('8902','2013-07-30','16:30:00',4.34),('8902','2013-07-30','16:35:00',2.15),('8902','2013-07-30','16:40:00',5.68),('8902','2013-07-30','16:45:00',5.5),('8902','2013-07-30','16:50:00',5.42),('8902','2013-07-30','16:55:00',5.18),('8902','2013-07-30','17:00:00',5.08),('8902','2013-07-30','17:05:00',4.95),('8902','2013-07-30','17:10:00',4.69),('8902','2013-07-30','17:15:00',3.61),('8902','2013-07-30','17:20:00',4.41),('8902','2013-07-30','17:25:00',4.3),('8902','2013-07-30','17:30:00',4.12),('8902','2013-07-30','17:35:00',3.92),('8902','2013-07-30','17:40:00',3.79),('8902','2013-07-30','17:45:00',3.56),('8902','2013-07-30','17:50:00',3.5),('8902','2013-07-30','17:55:00',3.26),('8902','2013-07-30','18:00:00',3.14),('8902','2013-07-30','18:05:00',3.02),('8902','2013-07-30','18:10:00',2.77),('8902','2013-07-30','18:15:00',2.69),('8902','2013-07-30','18:20:00',2.52),('8902','2013-07-30','18:25:00',2.37),('8902','2013-07-30','18:30:00',2.2),('8902','2013-07-30','18:35:00',2.03),('8902','2013-07-30','18:40:00',1.85),('8902','2013-07-30','18:45:00',1.69),('8902','2013-07-30','18:50:00',1.53),('8902','2013-07-30','18:55:00',1.33),('8902','2013-07-30','19:00:00',1.2),('8902','2013-07-30','19:05:00',1.07),('8902','2014-04-07','07:50:00',1.1),('8902','2014-04-07','07:55:00',1.08),('8902','2014-04-07','08:00:00',1.16),('8902','2014-04-07','08:05:00',1.12),('8902','2014-04-07','08:10:00',1.29),('8902','2014-04-07','08:15:00',2.05),('8902','2014-04-07','08:20:00',2.07),('8902','2014-04-07','08:25:00',1.81),('8902','2014-04-07','08:30:00',1.86),('8902','2014-04-07','08:35:00',2.24),('8902','2014-04-07','08:40:00',2.42),('8902','2014-04-07','08:45:00',2.53),('8902','2014-04-07','08:50:00',2.78),('8902','2014-04-07','08:55:00',2.99),('8902','2014-04-07','09:00:00',3.13),('8902','2014-04-07','09:05:00',3.32),('8902','2014-04-07','09:10:00',3.48),('8902','2014-04-07','09:15:00',3.67),('8902','2014-04-07','09:20:00',3.85),('8902','2014-04-07','09:25:00',4.05),('8902','2014-04-07','09:30:00',4.24),('8902','2014-04-07','09:35:00',4.37),('8902','2014-04-07','09:40:00',4.48),('8902','2014-04-07','09:45:00',4.62),('8902','2014-04-07','09:50:00',4.77),('8902','2014-04-07','09:55:00',4.82),('8902','2014-04-07','10:00:00',4.95),('8902','2014-04-07','10:05:00',5.02),('8902','2014-04-07','10:10:00',5.1),('8902','2014-04-07','10:15:00',5.45),('8902','2014-04-07','10:20:00',5.6),('8902','2014-04-07','10:25:00',5.69),('8902','2014-04-07','10:30:00',5.72),('8902','2014-04-07','10:35:00',5.85),('8902','2014-04-07','10:40:00',6.06),('8902','2014-04-07','10:45:00',6.19),('8902','2014-04-07','10:50:00',6.3),('8902','2014-04-07','10:55:00',6.45),('8902','2014-04-07','11:00:00',6.48),('8902','2014-04-07','11:05:00',6.6),('8902','2014-04-07','11:10:00',6.62),('8902','2014-04-07','11:15:00',6.7),('8902','2014-04-07','11:20:00',6.83),('8902','2014-04-07','11:25:00',6.15),('8902','2014-04-07','11:30:00',6.84),('8902','2014-04-07','11:35:00',6.73),('8902','2014-04-07','11:40:00',6.92),('8902','2014-04-07','11:45:00',7.09),('8902','2014-04-07','11:50:00',7.08),('8902','2014-04-07','11:55:00',7.04),('8902','2014-04-07','12:00:00',7.39),('8902','2014-04-07','12:05:00',7.12),('8902','2014-04-07','12:10:00',6.96),('8902','2014-04-07','12:15:00',6.8),('8902','2014-04-07','12:20:00',6.82),('8902','2014-04-07','12:25:00',6.83),('8902','2014-04-07','12:30:00',7.33),('8902','2014-04-07','12:35:00',7.97),('8902','2014-04-07','12:40:00',6.96),('8902','2014-04-07','12:45:00',6.36),('8902','2014-04-07','12:50:00',7.15),('8902','2014-04-07','12:55:00',7.73),('8902','2014-04-07','13:00:00',7.45),('8902','2014-04-07','13:05:00',7.84),('8902','2014-04-07','13:10:00',8.04),('8902','2014-04-07','13:15:00',8.12),('8902','2014-04-07','13:20:00',8.04),('8902','2014-04-07','13:25:00',7.96),('8902','2014-04-07','13:30:00',8.09),('8902','2014-04-07','13:35:00',8.07),('8902','2014-04-07','13:40:00',8.06),('8902','2014-04-07','13:45:00',7.96),('8902','2014-04-07','13:50:00',8.01),('8902','2014-04-07','13:55:00',8.01),('8902','2014-04-07','14:00:00',8.03),('8902','2014-04-07','14:05:00',8),('8902','2014-04-07','14:10:00',7.96),('8902','2014-04-07','14:15:00',7.97),('8902','2014-04-07','14:20:00',7.6),('8902','2014-04-07','14:25:00',7.75),('8902','2014-04-07','14:30:00',7.85),('8902','2014-04-07','14:35:00',7.43),('8902','2014-04-07','14:40:00',7.04),('8902','2014-04-07','14:45:00',6.48),('8902','2014-04-07','14:50:00',7.55),('8902','2014-04-07','14:55:00',7.63),('8902','2014-04-07','15:00:00',7.5),('8902','2014-04-07','15:05:00',7.28),('8902','2014-04-07','15:10:00',7.28),('8902','2014-04-07','15:15:00',7.23),('8902','2014-04-07','15:20:00',7.08),('8902','2014-04-07','15:25:00',7.04),('8902','2014-04-07','15:30:00',6.93),('8902','2014-04-07','15:35:00',6.78),('8902','2014-04-07','15:40:00',6.74),('8902','2014-04-07','15:45:00',6.32),('8902','2014-04-07','15:50:00',6.43),('8902','2014-04-07','15:55:00',6.38),('8902','2014-04-07','16:00:00',6.18),('8902','2014-04-07','16:05:00',6.06),('8902','2014-04-07','16:10:00',5.82),('8902','2014-04-07','16:15:00',5.46),('8902','2014-04-07','16:20:00',5.08),('8902','2014-04-07','16:25:00',5.42),('8902','2014-04-07','16:30:00',5.53),('8902','2014-04-07','16:35:00',5.55),('8902','2014-04-07','16:40:00',5.16),('8902','2014-04-07','16:45:00',4.78),('8902','2014-04-07','16:50:00',4.94),('8902','2014-04-07','16:55:00',4.56),('8902','2014-04-07','17:00:00',4.18),('8902','2014-04-07','17:05:00',4.37),('8902','2014-04-07','17:10:00',4.13),('8902','2014-04-07','17:15:00',4.05),('8902','2014-04-07','17:20:00',3.91),('8902','2014-04-07','17:25:00',3.61),('8902','2014-04-07','17:30:00',3.37),('8902','2014-04-07','17:35:00',2.9),('8902','2014-04-07','17:40:00',2.91),('8902','2014-04-07','17:45:00',2.74),('8902','2014-04-07','17:50:00',2.64),('8902','2014-04-07','17:55:00',2.32),('8902','2014-04-07','18:00:00',2.24),('8902','2014-04-07','18:05:00',2.15),('8902','2014-04-07','18:10:00',1.9),('8902','2014-04-07','18:15:00',1.81),('8902','2014-04-07','18:20:00',1.56),('8902','2014-04-07','18:25:00',1.27),('8902','2013-07-29','07:30:00',1.21),('8902','2013-07-29','07:35:00',1.2),('8902','2013-07-29','07:40:00',1.19),('8902','2013-07-29','07:55:00',1.4),('8902','2013-07-29','08:00:00',1.73),('8902','2013-07-29','08:05:00',1.94),('8902','2013-07-29','08:10:00',2.08),('8902','2013-07-29','08:15:00',2.25),('8902','2013-07-29','08:20:00',2.57),('8902','2013-07-29','08:25:00',2.76),('8902','2013-07-29','08:30:00',2.79),('8902','2013-07-29','08:35:00',2.87),('8902','2013-07-29','08:40:00',3.01),('8902','2013-07-29','08:45:00',3.16),('8902','2013-07-29','08:50:00',3.32),('8902','2013-07-29','08:55:00',3.47),('8902','2013-07-29','09:00:00',3.74),('8902','2013-07-29','09:05:00',3.93),('8902','2013-07-29','09:10:00',3.92),('8902','2013-07-29','09:15:00',4.12),('8902','2013-07-29','09:20:00',4.48),('8902','2013-07-29','09:25:00',4.71),('8902','2013-07-29','09:30:00',4.82),('8902','2013-07-29','09:35:00',5.08),('8902','2013-07-29','09:40:00',5.31),('8902','2013-07-29','09:45:00',5.42),('8902','2013-07-29','09:50:00',5.58),('8902','2013-07-29','09:55:00',5.63),('8902','2013-07-29','10:00:00',5.63),('8902','2013-07-29','10:05:00',5.75),('8902','2013-07-29','10:10:00',5.93),('8902','2013-07-29','10:15:00',5.95),('8902','2013-07-29','10:20:00',6.12),('8902','2013-07-29','10:25:00',6.06),('8902','2013-07-29','10:30:00',6.13),('8902','2013-07-29','10:35:00',5.12),('8902','2013-07-29','10:40:00',6.26),('8902','2013-07-29','10:45:00',6.45),('8902','2013-07-29','10:50:00',6.48),('8902','2013-07-29','10:55:00',6.48),('8902','2013-07-29','11:00:00',6.64),('8902','2013-07-29','11:05:00',6.81),('8902','2013-07-29','11:10:00',7.02),('8902','2013-07-29','11:15:00',7.12),('8902','2013-07-29','11:20:00',6.48),('8902','2013-07-29','11:25:00',2.09),('8902','2013-07-29','11:30:00',1.63),('8902','2013-07-29','11:35:00',2.64),('8902','2013-07-29','11:40:00',7.54),('8902','2013-07-29','11:45:00',7.48),('8902','2013-07-29','11:50:00',7.37),('8902','2013-07-29','11:55:00',7.28),('8902','2013-07-29','12:00:00',7.41),('8902','2013-07-29','12:05:00',7.44),('8902','2013-07-29','12:10:00',7.45),('8902','2013-07-29','12:15:00',7.45),('8902','2013-07-29','12:20:00',7.32),('8902','2013-07-29','12:25:00',7.36),('8902','2013-07-29','12:30:00',7.61),('8902','2013-07-29','12:35:00',7.76),('8902','2013-07-29','12:40:00',7.8),('8902','2013-07-29','12:45:00',3.02),('8902','2013-07-29','12:50:00',8.07),('8902','2013-07-29','12:55:00',8.27),('8902','2013-07-29','13:00:00',8.22),('8902','2013-07-29','13:05:00',5.19),('8902','2013-07-29','13:10:00',5.34),('8902','2013-07-29','13:15:00',5.25),('8902','2013-07-29','13:20:00',8.22),('8902','2013-07-29','13:25:00',8.19),('8902','2013-07-29','13:30:00',8.25),('8902','2013-07-29','13:35:00',7.91),('8902','2013-07-29','13:40:00',7.13),('8902','2013-07-29','13:45:00',8.02),('8902','2013-07-29','13:50:00',8.11),('8902','2013-07-29','13:55:00',8.33),('8902','2013-07-29','14:00:00',8.06),('8902','2013-07-29','14:05:00',8.19),('8902','2013-07-29','14:10:00',6.92),('8902','2013-07-29','14:15:00',8.16),('8902','2013-07-29','14:20:00',7.69),('8902','2013-07-29','14:25:00',7.7),('8902','2013-07-29','14:30:00',7.74),('8902','2013-07-29','14:35:00',7.64),('8902','2013-07-29','14:40:00',7.41),('8902','2013-07-29','14:45:00',7.41),('8902','2013-07-29','14:50:00',7.49),('8902','2013-07-29','14:55:00',7.45),('8902','2013-07-29','15:00:00',7.24),('8902','2013-07-29','15:05:00',7.07),('8902','2013-07-29','15:10:00',7.04),('8902','2013-07-29','15:15:00',7.05),('8902','2013-07-29','15:20:00',6.82),('8902','2013-07-29','15:25:00',6.67),('8902','2013-07-29','15:30:00',6.76),('8902','2013-07-29','15:35:00',6.72),('8902','2013-07-29','15:40:00',6.65),('8902','2013-07-29','15:45:00',6.56),('8902','2013-07-29','15:50:00',6.51),('8902','2013-07-29','15:55:00',6.42),('8902','2013-07-29','16:00:00',6.31),('8902','2013-07-29','16:05:00',6.18),('8902','2013-07-29','16:10:00',6.09),('8902','2013-07-29','16:15:00',5.99),('8902','2013-07-29','16:20:00',5.97),('8902','2013-07-29','16:25:00',5.83),('8902','2013-07-29','16:30:00',5.68),('8902','2013-07-29','16:35:00',5.58),('8902','2013-07-29','16:40:00',5.45),('8902','2013-07-29','16:45:00',5.34),('8902','2013-07-29','16:50:00',5.24),('8902','2013-07-29','16:55:00',5.03),('8902','2013-07-29','17:00:00',4.91),('8902','2013-07-29','17:05:00',4.81),('8902','2013-07-29','17:10:00',4.63),('8902','2013-07-29','17:15:00',4.49),('8902','2013-07-29','17:20:00',4.36),('8902','2013-07-29','17:25:00',4.22),('8902','2013-07-29','17:30:00',4.05),('8902','2013-07-29','17:35:00',3.93),('8902','2013-07-29','17:40:00',3.75),('8902','2013-07-29','17:45:00',3.59),('8902','2013-07-29','17:50:00',3.39),('8902','2013-07-29','17:55:00',3.13),('8902','2013-07-29','18:00:00',3.02),('8902','2013-07-29','18:05:00',2.86),('8902','2013-07-29','18:10:00',2.69),('8902','2013-07-29','18:15:00',2.53),('8902','2013-07-29','18:20:00',2.4),('8902','2013-07-29','18:25:00',2.24),('8902','2013-07-29','18:30:00',2.03),('8902','2013-07-29','18:35:00',1.82),('8902','2013-07-29','18:40:00',1.71),('8902','2013-07-29','18:45:00',1.56),('8902','2013-07-29','18:50:00',1.39),('8902','2013-07-29','18:55:00',1.21),('8902','2013-07-29','19:00:00',1.11),('8902','2013-07-28','07:40:00',1.02),('8902','2013-07-28','07:45:00',1.23),('8902','2013-07-28','07:50:00',1.36),('8902','2013-07-28','07:55:00',1.5),('8902','2013-07-28','08:00:00',1.64),('8902','2013-07-28','08:05:00',1.79),('8902','2013-07-28','08:10:00',1.92),('8902','2013-07-28','08:15:00',2.05),('8902','2013-07-28','08:20:00',2.19),('8902','2013-07-28','08:25:00',2.34),('8902','2013-07-28','08:30:00',2.46),('8902','2013-07-28','08:35:00',2.59),('8902','2013-07-28','08:40:00',2.74),('8902','2013-07-28','08:45:00',2.87),('8902','2013-07-28','08:50:00',3.01),('8902','2013-07-28','08:55:00',3.17),('8902','2013-07-28','09:00:00',3.3),('8902','2013-07-28','09:05:00',3.48),('8902','2013-07-28','09:10:00',3.63),('8902','2013-07-28','09:15:00',3.75),('8902','2013-07-28','09:20:00',3.91),('8902','2013-07-28','09:25:00',4.02),('8902','2013-07-28','09:30:00',4.16),('8902','2013-07-28','09:35:00',4.33),('8902','2013-07-28','09:40:00',4.5),('8902','2013-07-28','09:45:00',4.63),('8902','2013-07-28','09:50:00',4.72),('8902','2013-07-28','09:55:00',4.88),('8902','2013-07-28','10:00:00',5),('8902','2013-07-28','10:05:00',5.14),('8902','2013-07-28','10:10:00',5.26),('8902','2013-07-28','10:15:00',5.33),('8902','2013-07-28','10:20:00',5.5),('8902','2013-07-28','10:25:00',5.6),('8902','2013-07-28','10:30:00',5.7),('8902','2013-07-28','10:35:00',5.83),('8902','2013-07-28','10:40:00',5.95),('8902','2013-07-28','10:45:00',6.03),('8902','2013-07-28','10:50:00',6.04),('8902','2013-07-28','10:55:00',6.2),('8902','2013-07-28','11:00:00',6.3),('8902','2013-07-28','11:05:00',6.27),('8902','2013-07-28','11:10:00',6.23),('8902','2013-07-28','11:15:00',6.37),('8902','2013-07-28','11:20:00',6.54),('8902','2013-07-28','11:25:00',6.57),('8902','2013-07-28','11:30:00',6.61),('8902','2013-07-28','11:35:00',6.7),('8902','2013-07-28','11:40:00',6.72),('8902','2013-07-28','11:45:00',6.77),('8902','2013-07-28','11:50:00',6.85),('8902','2013-07-28','11:55:00',6.88),('8902','2013-07-28','12:00:00',6.92),('8902','2013-07-28','12:05:00',6.91),('8902','2013-07-28','12:10:00',6.93),('8902','2013-07-28','12:15:00',7),('8902','2013-07-28','12:20:00',7.1),('8902','2013-07-28','12:25:00',7.06),('8902','2013-07-28','12:30:00',7.14),('8902','2013-07-28','12:35:00',7.22),('8902','2013-07-28','12:40:00',7.24),('8902','2013-07-28','12:45:00',7.25),('8902','2013-07-28','12:50:00',7.25),('8902','2013-07-28','12:55:00',7.19),('8902','2013-07-28','13:00:00',7.14),('8902','2013-07-28','13:05:00',7.29),('8902','2013-07-28','13:10:00',7.32),('8902','2013-07-28','13:15:00',7.34),('8902','2013-07-28','13:20:00',7.4),('8902','2013-07-28','13:25:00',7.51),('8902','2013-07-28','13:30:00',7.59),('8902','2013-07-28','13:35:00',7.59),('8902','2013-07-28','13:40:00',7.58),('8902','2013-07-28','13:45:00',7.62),('8902','2013-07-28','13:50:00',7.63),('8902','2013-07-28','13:55:00',7.62),('8902','2013-07-28','14:00:00',7.56),('8902','2013-07-28','14:05:00',7.55),('8902','2013-07-28','14:10:00',7.52),('8902','2013-07-28','14:15:00',7.52),('8902','2013-07-28','14:20:00',7.52),('8902','2013-07-28','14:25:00',7.42),('8902','2013-07-28','14:30:00',7.38),('8902','2013-07-28','14:35:00',7.37),('8902','2013-07-28','14:40:00',7.33),('8902','2013-07-28','14:45:00',7.28),('8902','2013-07-28','14:50:00',7.22),('8902','2013-07-28','14:55:00',7.18),('8902','2013-07-28','15:00:00',7.16),('8902','2013-07-28','15:05:00',7.1),('8902','2013-07-28','15:10:00',7.04),('8902','2013-07-28','15:15:00',7),('8902','2013-07-28','15:20:00',6.85),('8902','2013-07-28','15:25:00',6.81),('8902','2013-07-28','15:30:00',6.77),('8902','2013-07-28','15:35:00',6.69),('8902','2013-07-28','15:40:00',6.72),('8902','2013-07-28','15:45:00',6.82),('8902','2013-07-28','15:50:00',5.84),('8902','2013-07-28','15:55:00',3.93),('8902','2013-07-28','16:00:00',3.31),('8902','2013-07-28','16:05:00',5.25),('8902','2013-07-28','16:10:00',5.7),('8902','2013-07-28','16:15:00',4.92),('8902','2013-07-28','16:20:00',5.07),('8902','2013-07-28','16:25:00',4.44),('8902','2013-07-28','16:30:00',6.13),('8902','2013-07-28','16:35:00',5.54),('8902','2013-07-28','16:40:00',4.12),('8902','2013-07-28','16:45:00',5.83),('8902','2013-07-28','16:50:00',5.48),('8902','2013-07-28','16:55:00',3.58),('8902','2013-07-28','17:00:00',2.62),('8902','2013-07-28','17:05:00',3.41),('8902','2013-07-28','17:10:00',2.87),('8902','2013-07-28','17:15:00',1.8),('8902','2013-07-28','17:20:00',3.95),('8902','2013-07-28','17:25:00',4.22),('8902','2013-07-28','17:30:00',2.73),('8902','2013-07-28','17:35:00',1.67),('8902','2013-07-28','17:40:00',2.2),('8902','2013-07-28','17:45:00',3.71),('8902','2013-07-28','17:50:00',3.45),('8902','2013-07-28','17:55:00',3.06),('8902','2013-07-28','18:00:00',2.44),('8902','2013-07-28','18:05:00',1.65),('8902','2013-07-28','18:10:00',2.23),('8902','2013-07-28','18:15:00',2.03),('8902','2013-07-28','18:20:00',2.42),('8902','2013-07-28','18:25:00',2.19),('8902','2013-07-28','18:30:00',2.09),('8902','2013-07-28','18:35:00',1.78),('8902','2013-07-28','18:40:00',1.31),('8902','2013-07-28','18:55:00',1.02),('8902','2013-07-28','19:00:00',1.34),('8902','2013-07-28','19:05:00',1.3),('8902','2013-07-28','19:10:00',1.06),('8902','2013-07-27','07:40:00',1.01),('8902','2013-07-27','07:45:00',1.2),('8902','2013-07-27','07:50:00',1.33),('8902','2013-07-27','07:55:00',1.46),('8902','2013-07-27','08:00:00',1.6),('8902','2013-07-27','08:05:00',1.75),('8902','2013-07-27','08:10:00',1.91),('8902','2013-07-27','08:15:00',2.05),('8902','2013-07-27','08:20:00',2.21),('8902','2013-07-27','08:25:00',2.35),('8902','2013-07-27','08:30:00',2.53),('8902','2013-07-27','08:35:00',2.68),('8902','2013-07-27','08:40:00',2.83),('8902','2013-07-27','08:45:00',2.98),('8902','2013-07-27','08:50:00',3.11),('8902','2013-07-27','08:55:00',3.28),('8902','2013-07-27','09:00:00',3.43),('8902','2013-07-27','09:05:00',3.6),('8902','2013-07-27','09:10:00',3.74),('8902','2013-07-27','09:15:00',3.88),('8902','2013-07-27','09:20:00',4.02),('8902','2013-07-27','09:25:00',4.15),('8902','2013-07-27','09:30:00',4.33),('8902','2013-07-27','09:35:00',4.48),('8902','2013-07-27','09:40:00',4.5),('8902','2013-07-27','09:45:00',4.65),('8902','2013-07-27','09:50:00',4.75),('8902','2013-07-27','09:55:00',4.91),('8902','2013-07-27','10:00:00',5.04),('8902','2013-07-27','10:05:00',5.12),('8902','2013-07-27','10:10:00',5.29),('8902','2013-07-27','10:15:00',5.34),('8902','2013-07-27','10:20:00',5.43),('8902','2013-07-27','10:25:00',5.5),('8902','2013-07-27','10:30:00',5.59),('8902','2013-07-27','10:35:00',5.78),('8902','2013-07-27','10:40:00',5.87),('8902','2013-07-27','10:45:00',5.96),('8902','2013-07-27','10:50:00',6.03),('8902','2013-07-27','10:55:00',6.16),('8902','2013-07-27','11:00:00',6.3),('8902','2013-07-27','11:05:00',6.35),('8902','2013-07-27','11:10:00',6.41),('8902','2013-07-27','11:15:00',6.43),('8902','2013-07-27','11:20:00',6.46),('8902','2013-07-27','11:25:00',6.53),('8902','2013-07-27','11:30:00',6.6),('8902','2013-07-27','11:35:00',6.6),('8902','2013-07-27','11:40:00',6.69),('8902','2013-07-27','11:45:00',6.75),('8902','2013-07-27','11:50:00',6.74),('8902','2013-07-27','11:55:00',6.87),('8902','2013-07-27','12:00:00',6.95),('8902','2013-07-27','12:05:00',7.08),('8902','2013-07-27','12:10:00',7.04),('8902','2013-07-27','12:15:00',6.96),('8902','2013-07-27','12:20:00',7),('8902','2013-07-27','12:25:00',7.03),('8902','2013-07-27','12:30:00',7.13),('8902','2013-07-27','12:35:00',7.33),('8902','2013-07-27','12:40:00',7.36),('8902','2013-07-27','12:45:00',7.34),('8902','2013-07-27','12:50:00',7.19),('8902','2013-07-27','12:55:00',7.17),('8902','2013-07-27','13:00:00',7.25),('8902','2013-07-27','13:05:00',7.11),('8902','2013-07-27','13:10:00',7.23),('8902','2013-07-27','13:15:00',7.54),('8902','2013-07-27','13:20:00',7.59),('8902','2013-07-27','13:25:00',7.41),('8902','2013-07-27','13:30:00',7.47),('8902','2013-07-27','13:35:00',7.6),('8902','2013-07-27','13:40:00',7.59),('8902','2013-07-27','13:45:00',7.49),('8902','2013-07-27','13:50:00',7.56),('8902','2013-07-27','13:55:00',7.48),('8902','2013-07-27','14:00:00',7.43),('8902','2013-07-27','14:05:00',7.42),('8902','2013-07-27','14:10:00',7.38),('8902','2013-07-27','14:15:00',7.37),('8902','2013-07-27','14:20:00',7.35),('8902','2013-07-27','14:25:00',7.3),('8902','2013-07-27','14:30:00',7.25),('8902','2013-07-27','14:35:00',7.2),('8902','2013-07-27','14:40:00',7.2),('8902','2013-07-27','14:45:00',7.16),('8902','2013-07-27','14:50:00',7.1),('8902','2013-07-27','14:55:00',7.04),('8902','2013-07-27','15:00:00',6.91),('8902','2013-07-27','15:05:00',6.87),('8902','2013-07-27','15:10:00',6.88),('8902','2013-07-27','15:15:00',6.85),('8902','2013-07-27','15:20:00',6.7),('8902','2013-07-27','15:25:00',6.63),('8902','2013-07-27','15:30:00',6.59),('8902','2013-07-27','15:35:00',6.46),('8902','2013-07-27','15:40:00',6.42),('8902','2013-07-27','15:45:00',6.43),('8902','2013-07-27','15:50:00',6.33),('8902','2013-07-27','15:55:00',6.22),('8902','2013-07-27','16:00:00',6.19),('8902','2013-07-27','16:05:00',6.15),('8902','2013-07-27','16:10:00',6.09),('8902','2013-07-27','16:15:00',6),('8902','2013-07-27','16:20:00',5.92),('8902','2013-07-27','16:25:00',5.83),('8902','2013-07-27','16:30:00',5.73),('8902','2013-07-27','16:35:00',5.59),('8902','2013-07-27','16:40:00',5.38),('8902','2013-07-27','16:45:00',5.33),('8902','2013-07-27','16:50:00',5.24),('8902','2013-07-27','16:55:00',5.05),('8902','2013-07-27','17:00:00',4.88),('8902','2013-07-27','17:05:00',4.83),('8902','2013-07-27','17:10:00',4.69),('8902','2013-07-27','17:15:00',4.58),('8902','2013-07-27','17:20:00',4.42),('8902','2013-07-27','17:25:00',4.25),('8902','2013-07-27','17:30:00',4.1),('8902','2013-07-27','17:35:00',3.95),('8902','2013-07-27','17:40:00',3.77),('8902','2013-07-27','17:45:00',3.65),('8902','2013-07-27','17:50:00',3.49),('8902','2013-07-27','17:55:00',3.27),('8902','2013-07-27','18:00:00',3.12),('8902','2013-07-27','18:05:00',2.96),('8902','2013-07-27','18:10:00',2.75),('8902','2013-07-27','18:15:00',2.61),('8902','2013-07-27','18:20:00',2.44),('8902','2013-07-27','18:25:00',2.28),('8902','2013-07-27','18:30:00',2.11),('8902','2013-07-27','18:35:00',1.88),('8902','2013-07-27','18:40:00',1.75),('8902','2013-07-27','18:45:00',1.59),('8902','2013-07-27','18:50:00',1.44),('8902','2013-07-27','18:55:00',1.28),('8902','2013-07-27','19:00:00',1.14),('8902','2013-07-27','19:05:00',1.01),('8902','2013-07-26','07:40:00',1.1),('8902','2013-07-26','07:45:00',1.24),('8902','2013-07-26','07:50:00',1.38),('8902','2013-07-26','07:55:00',1.53),('8902','2013-07-26','08:00:00',1.67),('8902','2013-07-26','08:05:00',1.82),('8902','2013-07-26','08:10:00',1.98),('8902','2013-07-26','08:15:00',2.14),('8902','2013-07-26','08:20:00',2.28),('8902','2013-07-26','08:25:00',2.46),('8902','2013-07-26','08:30:00',2.61),('8902','2013-07-26','08:35:00',2.76),('8902','2013-07-26','08:40:00',2.9),('8902','2013-07-26','08:45:00',3.03),('8902','2013-07-26','08:50:00',3.19),('8902','2013-07-26','08:55:00',3.34),('8902','2013-07-26','09:00:00',3.5),('8902','2013-07-26','09:05:00',3.65),('8902','2013-07-26','09:10:00',3.83),('8902','2013-07-26','09:15:00',3.99),('8902','2013-07-26','09:20:00',4.1),('8902','2013-07-26','09:25:00',4.27),('8902','2013-07-26','09:30:00',4.41),('8902','2013-07-26','09:35:00',4.54),('8902','2013-07-26','09:40:00',4.66),('8902','2013-07-26','09:45:00',4.78),('8902','2013-07-26','09:50:00',4.92),('8902','2013-07-26','09:55:00',5.09),('8902','2013-07-26','10:00:00',5.22),('8902','2013-07-26','10:05:00',5.32),('8902','2013-07-26','10:10:00',5.41),('8902','2013-07-26','10:15:00',5.51),('8902','2013-07-26','10:20:00',5.63),('8902','2013-07-26','10:25:00',5.72),('8902','2013-07-26','10:30:00',5.82),('8902','2013-07-26','10:35:00',5.9),('8902','2013-07-26','10:40:00',6.02),('8902','2013-07-26','10:45:00',6.1),('8902','2013-07-26','10:50:00',6.19),('8902','2013-07-26','10:55:00',6.24),('8902','2013-07-26','11:00:00',6.31),('8902','2013-07-26','11:05:00',6.36),('8902','2013-07-26','11:10:00',6.41),('8902','2013-07-26','11:15:00',6.46),('8902','2013-07-26','11:20:00',6.64),('8902','2013-07-26','11:25:00',6.75),('8902','2013-07-26','11:30:00',6.82),('8902','2013-07-26','11:35:00',6.86),('8902','2013-07-26','11:40:00',6.88),('8902','2013-07-26','11:45:00',6.92),('8902','2013-07-26','11:50:00',6.99),('8902','2013-07-26','11:55:00',7.02),('8902','2013-07-26','12:00:00',7.09),('8902','2013-07-26','12:05:00',7.16),('8902','2013-07-26','12:10:00',7.2),('8902','2013-07-26','12:15:00',7.28),('8902','2013-07-26','12:20:00',7.32),('8902','2013-07-26','12:25:00',7.25),('8902','2013-07-26','12:30:00',7.11),('8902','2013-07-26','12:35:00',7.09),('8902','2013-07-26','12:40:00',7.13),('8902','2013-07-26','12:45:00',7.24),('8902','2013-07-26','12:50:00',7.13),('8902','2013-07-26','12:55:00',7.31),('8902','2013-07-26','13:00:00',7.44),('8902','2013-07-26','13:05:00',7.53),('8902','2013-07-26','13:10:00',7.62),('8902','2013-07-26','13:15:00',7.52),('8902','2013-07-26','13:20:00',7.36),('8902','2013-07-26','13:25:00',7.63),('8902','2013-07-26','13:30:00',7.53),('8902','2013-07-26','13:35:00',7.44),('8902','2013-07-26','13:40:00',7.71),('8902','2013-07-26','13:45:00',7.84),('8902','2013-07-26','13:50:00',7.75),('8902','2013-07-26','13:55:00',7.65),('8902','2013-07-26','14:00:00',6.95),('8902','2013-07-26','14:05:00',7.51),('8902','2013-07-26','14:10:00',7.65),('8902','2013-07-26','14:15:00',7.27),('8902','2013-07-26','14:20:00',7.46),('8902','2013-07-26','14:25:00',7.32),('8902','2013-07-26','14:30:00',7.26),('8902','2013-07-26','14:35:00',7.27),('8902','2013-07-26','14:40:00',7.36),('8902','2013-07-26','14:45:00',7.28),('8902','2013-07-26','14:50:00',7.19),('8902','2013-07-26','14:55:00',7.13),('8902','2013-07-26','15:00:00',7.04),('8902','2013-07-26','15:05:00',6.97),('8902','2013-07-26','15:10:00',6.97),('8902','2013-07-26','15:15:00',6.89),('8902','2013-07-26','15:20:00',6.89),('8902','2013-07-26','15:25:00',6.78),('8902','2013-07-26','15:30:00',6.75),('8902','2013-07-26','15:35:00',6.71),('8902','2013-07-26','15:40:00',6.65),('8902','2013-07-26','15:45:00',6.56),('8902','2013-07-26','15:50:00',6.47),('8902','2013-07-26','15:55:00',6.37),('8902','2013-07-26','16:00:00',6.24),('8902','2013-07-26','16:05:00',6.18),('8902','2013-07-26','16:10:00',6.11),('8902','2013-07-26','16:15:00',6.01),('8902','2013-07-26','16:20:00',5.91),('8902','2013-07-26','16:25:00',5.83),('8902','2013-07-26','16:30:00',5.74),('8902','2013-07-26','16:35:00',5.63),('8902','2013-07-26','16:40:00',5.48),('8902','2013-07-26','16:45:00',5.41),('8902','2013-07-26','16:50:00',5.26),('8902','2013-07-26','16:55:00',5.07),('8902','2013-07-26','17:00:00',4.89),('8902','2013-07-26','17:05:00',4.76),('8902','2013-07-26','17:10:00',4.65),('8902','2013-07-26','17:15:00',4.51),('8902','2013-07-26','17:20:00',4.4),('8902','2013-07-26','17:25:00',4.24),('8902','2013-07-26','17:30:00',4.1),('8902','2013-07-26','17:35:00',3.95),('8902','2013-07-26','17:40:00',3.73),('8902','2013-07-26','17:45:00',3.59),('8902','2013-07-26','17:50:00',3.46),('8902','2013-07-26','17:55:00',3.26),('8902','2013-07-26','18:00:00',3.14),('8902','2013-07-26','18:05:00',3.01),('8902','2013-07-26','18:10:00',2.79),('8902','2013-07-26','18:15:00',2.64),('8902','2013-07-26','18:20:00',2.48),('8902','2013-07-26','18:25:00',2.31),('8902','2013-07-26','18:30:00',2.17),('8902','2013-07-26','18:35:00',1.99),('8902','2013-07-26','18:40:00',1.83),('8902','2013-07-26','18:45:00',1.67),('8902','2013-07-26','18:50:00',1.53),('8902','2013-07-26','18:55:00',1.33),('8902','2013-07-26','19:00:00',1.21),('8902','2013-07-26','19:05:00',1.08),('8902','2013-07-25','07:40:00',1.14),('8902','2013-07-25','07:45:00',1.3),('8902','2013-07-25','07:50:00',1.45),('8902','2013-07-25','07:55:00',1.51),('8902','2013-07-25','08:00:00',1.62),('8902','2013-07-25','08:05:00',1.79),('8902','2013-07-25','08:10:00',1.96),('8902','2013-07-25','08:15:00',2.11),('8902','2013-07-25','08:20:00',2.24),('8902','2013-07-25','08:25:00',2.37),('8902','2013-07-25','08:30:00',2.55),('8902','2013-07-25','08:35:00',2.7),('8902','2013-07-25','08:40:00',2.85),('8902','2013-07-25','08:45:00',3),('8902','2013-07-25','08:50:00',3.15),('8902','2013-07-25','08:55:00',3.29),('8902','2013-07-25','09:00:00',3.46),('8902','2013-07-25','09:05:00',3.61),('8902','2013-07-25','09:10:00',3.75),('8902','2013-07-25','09:15:00',3.91),('8902','2013-07-25','09:20:00',3.98),('8902','2013-07-25','09:25:00',4.19),('8902','2013-07-25','09:30:00',4.36),('8902','2013-07-25','09:35:00',4.49),('8902','2013-07-25','09:40:00',4.59),('8902','2013-07-25','09:45:00',4.73),('8902','2013-07-25','09:50:00',4.85),('8902','2013-07-25','09:55:00',4.84),('8902','2013-07-25','10:00:00',5.04),('8902','2013-07-25','10:05:00',5.21),('8902','2013-07-25','10:10:00',5.23),('8902','2013-07-25','10:15:00',5.24),('8902','2013-07-25','10:20:00',5.47),('8902','2013-07-25','10:25:00',5.54),('8902','2013-07-25','10:30:00',5.72),('8902','2013-07-25','10:35:00',5.82),('8902','2013-07-25','10:40:00',5.94),('8902','2013-07-25','10:45:00',6.1),('8902','2013-07-25','10:50:00',6.12),('8902','2013-07-25','10:55:00',6.25),('8902','2013-07-25','11:00:00',6.28),('8902','2013-07-25','11:05:00',6.16),('8902','2013-07-25','11:10:00',5.74),('8902','2013-07-25','11:15:00',6.42),('8902','2013-07-25','11:20:00',6.52),('8902','2013-07-25','11:25:00',6.68),('8902','2013-07-25','11:30:00',6.76),('8902','2013-07-25','11:35:00',6.62),('8902','2013-07-25','11:40:00',4.66),('8902','2013-07-25','11:45:00',6.58),('8902','2013-07-25','11:50:00',7.07),('8902','2013-07-25','11:55:00',7.22),('8902','2013-07-25','12:00:00',7.07),('8902','2013-07-25','12:05:00',5.97),('8902','2013-07-25','12:10:00',3.34),('8902','2013-07-25','12:15:00',6.88),('8902','2013-07-25','12:20:00',3.19),('8902','2013-07-25','12:25:00',7.45),('8902','2013-07-25','12:30:00',6.67),('8902','2013-07-25','12:35:00',3.78),('8902','2013-07-25','12:40:00',7.88),('8902','2013-07-25','12:45:00',4.48),('8902','2013-07-25','12:50:00',4.98),('8902','2013-07-25','12:55:00',8.14),('8902','2013-07-25','13:00:00',4.64),('8902','2013-07-25','13:05:00',2.15),('8902','2013-07-25','13:10:00',2.08),('8902','2013-07-25','13:15:00',2.17),('8902','2013-07-25','13:20:00',3.57),('8902','2013-07-25','13:25:00',7.92),('8902','2013-07-25','13:30:00',8.34),('8902','2013-07-25','13:35:00',7.78),('8902','2013-07-25','13:40:00',7.66),('8902','2013-07-25','13:45:00',7.99),('8902','2013-07-25','13:50:00',7.81),('8902','2013-07-25','13:55:00',6.87),('8902','2013-07-25','14:00:00',7.8),('8902','2013-07-25','14:05:00',7.71),('8902','2013-07-25','14:10:00',7.71),('8902','2013-07-25','14:15:00',7.92),('8902','2013-07-25','14:20:00',7.82),('8902','2013-07-25','14:25:00',7.76),('8902','2013-07-25','14:30:00',7.46),('8902','2013-07-25','14:35:00',7.43),('8902','2013-07-25','14:40:00',7.54),('8902','2013-07-25','14:45:00',7.33),('8902','2013-07-25','14:50:00',7.34),('8902','2013-07-25','14:55:00',7.17),('8902','2013-07-25','15:00:00',7.22),('8902','2013-07-25','15:05:00',7.14),('8902','2013-07-25','15:10:00',7.07),('8902','2013-07-25','15:15:00',7.05),('8902','2013-07-25','15:20:00',6.91),('8902','2013-07-25','15:25:00',6.76),('8902','2013-07-25','15:30:00',6.74),('8902','2013-07-25','15:35:00',6.75),('8902','2013-07-25','15:40:00',6.71),('8902','2013-07-25','15:45:00',6.69),('8902','2013-07-25','15:50:00',6.6),('8902','2013-07-25','15:55:00',6.44),('8902','2013-07-25','16:00:00',6.37),('8902','2013-07-25','16:05:00',6.28),('8902','2013-07-25','16:10:00',6.15),('8902','2013-07-25','16:15:00',6.03),('8902','2013-07-25','16:20:00',5.98),('8902','2013-07-25','16:25:00',5.9),('8902','2013-07-25','16:30:00',5.79),('8902','2013-07-25','16:35:00',5.62),('8902','2013-07-25','16:40:00',5.41),('8902','2013-07-25','16:45:00',5.4),('8902','2013-07-25','16:50:00',5.22),('8902','2013-07-25','16:55:00',5.02),('8902','2013-07-25','17:00:00',4.83),('8902','2013-07-25','17:05:00',4.8),('8902','2013-07-25','17:10:00',4.68),('8902','2013-07-25','17:15:00',4.49),('8902','2013-07-25','17:20:00',4.33),('8902','2013-07-25','17:25:00',4.21),('8902','2013-07-25','17:30:00',3.97),('8902','2013-07-25','17:35:00',3.87),('8902','2013-07-25','17:40:00',3.72),('8902','2013-07-25','17:45:00',3.55),('8902','2013-07-25','17:50:00',3.34),('8902','2013-07-25','17:55:00',3.11),('8902','2013-07-25','18:00:00',2.94),('8902','2013-07-25','18:05:00',2.83),('8902','2013-07-25','18:10:00',2.68),('8902','2013-07-25','18:15:00',2.55),('8902','2013-07-25','18:20:00',2.3),('8902','2013-07-25','18:25:00',2.19),('8902','2013-07-25','18:30:00',2.06),('8902','2013-07-25','18:35:00',1.83),('8902','2013-07-25','18:40:00',1.71),('8902','2013-07-25','18:45:00',1.55),('8902','2013-07-25','18:50:00',1.44),('8902','2013-07-25','18:55:00',1.27),('8902','2013-07-25','19:00:00',1.14),('8902','2013-07-25','19:05:00',1.01),('8902','2013-07-24','07:40:00',1.12),('8902','2013-07-24','07:45:00',1.28),('8902','2013-07-24','07:50:00',1.42),('8902','2013-07-24','07:55:00',1.56),('8902','2013-07-24','08:00:00',1.7),('8902','2013-07-24','08:05:00',1.82),('8902','2013-07-24','08:10:00',1.96),('8902','2013-07-24','08:15:00',2.12),('8902','2013-07-24','08:20:00',2.24),('8902','2013-07-24','08:25:00',2.4),('8902','2013-07-24','08:30:00',2.59),('8902','2013-07-24','08:35:00',2.73),('8902','2013-07-24','08:40:00',2.89),('8902','2013-07-24','08:45:00',3.05),('8902','2013-07-24','08:50:00',3.16),('8902','2013-07-24','08:55:00',3.27),('8902','2013-07-24','09:00:00',3.48),('8902','2013-07-24','09:05:00',3.73),('8902','2013-07-24','09:10:00',3.87),('8902','2013-07-24','09:15:00',4.1),('8902','2013-07-24','09:20:00',4.38),('8902','2013-07-24','09:25:00',3.2),('8902','2013-07-24','09:30:00',2.64),('8902','2013-07-24','09:35:00',2.72),('8902','2013-07-24','09:40:00',4.38),('8902','2013-07-24','09:45:00',5.59),('8902','2013-07-24','09:50:00',3.76),('8902','2013-07-24','09:55:00',1.94),('8902','2013-07-24','10:00:00',1.61),('8902','2013-07-24','10:05:00',1.53),('8902','2013-07-24','10:10:00',1.79),('8902','2013-07-24','10:15:00',2.29),('8902','2013-07-24','10:20:00',6.13),('8902','2013-07-24','10:25:00',6.26),('8902','2013-07-24','10:30:00',6.32),('8902','2013-07-24','10:35:00',6.15),('8902','2013-07-24','10:40:00',5.41),('8902','2013-07-24','10:45:00',5.8),('8902','2013-07-24','10:50:00',4.35),('8902','2013-07-24','10:55:00',5.11),('8902','2013-07-24','11:00:00',3.91),('8902','2013-07-24','11:05:00',3.35),('8902','2013-07-24','11:10:00',4.61),('8902','2013-07-24','11:15:00',7.05),('8902','2013-07-24','11:20:00',6.94),('8902','2013-07-24','11:25:00',7.04),('8902','2013-07-24','11:30:00',6.76),('8902','2013-07-24','11:35:00',6.91),('8902','2013-07-24','11:40:00',6.89),('8902','2013-07-24','11:45:00',6.83),('8902','2013-07-24','11:50:00',6.39),('8902','2013-07-24','11:55:00',2.97),('8902','2013-07-24','12:00:00',6.46),('8902','2013-07-24','12:05:00',7.66),('8902','2013-07-24','12:10:00',3.02),('8902','2013-07-24','12:15:00',4.83),('8902','2013-07-24','12:20:00',4.73),('8902','2013-07-24','12:25:00',3.83),('8902','2013-07-24','12:30:00',2.57),('8902','2013-07-24','12:35:00',5.73),('8902','2013-07-24','12:40:00',2.7),('8902','2013-07-24','12:45:00',2.15),('8902','2013-07-24','12:50:00',2.42),('8902','2013-07-24','12:55:00',2.68),('8902','2013-07-24','13:00:00',2.28),('8902','2013-07-24','13:05:00',5.94),('8902','2013-07-24','13:10:00',5.18),('8902','2013-07-24','13:15:00',5.99),('8902','2013-07-24','13:20:00',8.05),('8902','2013-07-24','13:25:00',8.02),('8902','2013-07-24','13:30:00',8.16),('8902','2013-07-24','13:35:00',7.91),('8902','2013-07-24','13:40:00',7.83),('8902','2013-07-24','13:45:00',7.72),('8902','2013-07-24','13:50:00',7.82),('8902','2013-07-24','13:55:00',7.74),('8902','2013-07-24','14:00:00',7.72),('8902','2013-07-24','14:05:00',7.73),('8902','2013-07-24','14:10:00',7.84),('8902','2013-07-24','14:15:00',7.85),('8902','2013-07-24','14:20:00',7.87),('8902','2013-07-24','14:25:00',7.85),('8902','2013-07-24','14:30:00',7.76),('8902','2013-07-24','14:35:00',7.72),('8902','2013-07-24','14:40:00',7.63),('8902','2013-07-24','14:45:00',7.62),('8902','2013-07-24','14:50:00',7.6),('8902','2013-07-24','14:55:00',7.6),('8902','2013-07-24','15:00:00',7.52),('8902','2013-07-24','15:05:00',7.46),('8902','2013-07-24','15:10:00',7.36),('8902','2013-07-24','15:15:00',7.24),('8902','2013-07-24','15:20:00',7.18),('8902','2013-07-24','15:25:00',7.13),('8902','2013-07-24','15:30:00',7.1),('8902','2013-07-24','15:35:00',7.02),('8902','2013-07-24','15:40:00',6.96),('8902','2013-07-24','15:45:00',6.92),('8902','2013-07-24','15:50:00',6.78),('8902','2013-07-24','15:55:00',6.65),('8902','2013-07-24','16:00:00',6.61),('8902','2013-07-24','16:05:00',6.54),('8902','2013-07-24','16:10:00',6.43),('8902','2013-07-24','16:15:00',6.33),('8902','2013-07-24','16:20:00',6.22),('8902','2013-07-24','16:25:00',6.09),('8902','2013-07-24','16:30:00',5.96),('8902','2013-07-24','16:35:00',5.77),('8902','2013-07-24','16:40:00',5.62),('8902','2013-07-24','16:45:00',5.61),('8902','2013-07-24','16:50:00',5.49),('8902','2013-07-24','16:55:00',5.3),('8902','2013-07-24','17:00:00',5.1),('8902','2013-07-24','17:05:00',5.08),('8902','2013-07-24','17:10:00',4.87),('8902','2013-07-24','17:15:00',4.78),('8902','2013-07-24','17:20:00',4.62),('8902','2013-07-24','17:25:00',4.41),('8902','2013-07-24','17:30:00',4.33),('8902','2013-07-24','17:35:00',4.19),('8902','2013-07-24','17:40:00',3.99),('8902','2013-07-24','17:45:00',3.86),('8902','2013-07-24','17:50:00',3.64),('8902','2013-07-24','17:55:00',3.42),('8902','2013-07-24','18:00:00',3.29),('8902','2013-07-24','18:05:00',3.16),('8902','2013-07-24','18:10:00',2.96),('8902','2013-07-24','18:15:00',2.72),('8902','2013-07-24','18:20:00',2.55),('8902','2013-07-24','18:25:00',2.38),('8902','2013-07-24','18:30:00',2.22),('8902','2013-07-24','18:35:00',1.98),('8902','2013-07-24','18:40:00',1.89),('8902','2013-07-24','18:45:00',1.7),('8902','2013-07-24','18:50:00',1.55),('8902','2013-07-24','18:55:00',1.34),('8902','2013-07-24','19:00:00',1.23),('8902','2013-07-24','19:05:00',1.04),('8902','2013-07-23','07:45:00',1.07),('8902','2013-07-23','07:50:00',1.31),('8902','2013-07-23','07:55:00',1.64),('8902','2013-07-23','08:00:00',1.68),('8902','2013-07-23','08:05:00',1.57),('8902','2013-07-23','08:10:00',1.6),('8902','2013-07-23','08:15:00',1.46),('8902','2013-07-23','08:20:00',2.4),('8902','2013-07-23','08:25:00',2.24),('8902','2013-07-23','08:30:00',3.09),('8902','2013-07-23','08:35:00',1.92),('8902','2013-07-23','08:40:00',2.2),('8902','2013-07-23','08:45:00',2.59),('8902','2013-07-23','08:50:00',3.2),('8902','2013-07-23','08:55:00',2.98),('8902','2013-07-23','09:00:00',2.62),('8902','2013-07-23','09:30:00',2.29),('8902','2013-07-23','09:35:00',4.7),('8902','2013-07-23','09:40:00',4.22),('8902','2013-07-23','09:45:00',3.56),('8902','2013-07-23','09:50:00',2.73),('8902','2013-07-23','09:55:00',2.4),('8902','2013-07-23','10:00:00',2.11),('8902','2013-07-23','10:05:00',2.67),('8902','2013-07-23','10:10:00',2.1),('8902','2013-07-23','10:15:00',2.27),('8902','2013-07-23','10:20:00',2.05),('8902','2013-07-23','10:25:00',3.51),('8902','2013-07-23','10:30:00',5.87),('8902','2013-07-23','10:35:00',6.11),('8902','2013-07-23','10:40:00',6.66),('8902','2013-07-23','10:45:00',7.07),('8902','2013-07-23','10:50:00',3.29),('8902','2013-07-23','10:55:00',4.91),('8902','2013-07-23','11:00:00',5.64),('8902','2013-07-23','11:05:00',4.26),('8902','2013-07-23','11:10:00',7.04),('8902','2013-07-23','11:15:00',6.11),('8902','2013-07-23','11:20:00',4.56),('8902','2013-07-23','11:25:00',6.51),('8902','2013-07-23','11:30:00',7.28),('8902','2013-07-23','11:35:00',7.41),('8902','2013-07-23','11:40:00',7.29),('8902','2013-07-23','11:45:00',7.22),('8902','2013-07-23','11:50:00',7.11),('8902','2013-07-23','11:55:00',7.37),('8902','2013-07-23','12:00:00',7.65),('8902','2013-07-23','12:05:00',6.58),('8902','2013-07-23','12:10:00',3.11),('8902','2013-07-23','12:15:00',4.11),('8902','2013-07-23','12:20:00',6.66),('8902','2013-07-23','12:25:00',4.47),('8902','2013-07-23','12:30:00',2.35),('8902','2013-07-23','12:35:00',1.99),('8902','2013-07-23','12:40:00',2.08),('8902','2013-07-23','12:45:00',3.88),('8902','2013-07-23','12:50:00',4.48),('8902','2013-07-23','12:55:00',2.39),('8902','2013-07-23','13:00:00',3.8),('8902','2013-07-23','13:05:00',8.67),('8902','2013-07-23','13:10:00',8.34),('8902','2013-07-23','13:15:00',8.05),('8902','2013-07-23','13:20:00',4.41),('8902','2013-07-23','13:25:00',1.54),('8902','2013-07-23','13:30:00',1.42),('8902','2013-07-23','13:35:00',5.11),('8902','2013-07-23','13:40:00',2.25),('8902','2013-07-23','13:45:00',2.3),('8902','2013-07-23','13:50:00',2.34),('8902','2013-07-23','13:55:00',8.01),('8902','2013-07-23','14:00:00',4.54),('8902','2013-07-23','14:05:00',8.09),('8902','2013-07-23','14:10:00',4.72),('8902','2013-07-23','14:15:00',8.55),('8902','2013-07-23','14:20:00',7.44),('8902','2013-07-23','14:25:00',6.52),('8902','2013-07-23','14:30:00',7.27),('8902','2013-07-23','14:35:00',5.9),('8902','2013-07-23','14:40:00',7.87),('8902','2013-07-23','14:45:00',8.1),('8902','2013-07-23','14:50:00',8),('8902','2013-07-23','14:55:00',7.87),('8902','2013-07-23','15:00:00',7.71),('8902','2013-07-23','15:05:00',7.69),('8902','2013-07-23','15:10:00',7.51),('8902','2013-07-23','15:15:00',7.48),('8902','2013-07-23','15:20:00',7.45),('8902','2013-07-23','15:25:00',7.38),('8902','2013-07-23','15:30:00',6.94),('8902','2013-07-23','15:35:00',6.75),('8902','2013-07-23','15:40:00',7.04),('8902','2013-07-23','15:45:00',6.83),('8902','2013-07-23','15:50:00',6.67),('8902','2013-07-23','15:55:00',6.65),('8902','2013-07-23','16:00:00',6.66),('8902','2013-07-23','16:05:00',6.49),('8902','2013-07-23','16:10:00',6.3),('8902','2013-07-23','16:15:00',6.36),('8902','2013-07-23','16:20:00',6.47),('8902','2013-07-23','16:25:00',6.35),('8902','2013-07-23','16:30:00',6.21),('8902','2013-07-23','16:35:00',6.03),('8902','2013-07-23','16:40:00',5.8),('8902','2013-07-23','16:45:00',5.71),('8902','2013-07-23','16:50:00',5.53),('8902','2013-07-23','16:55:00',5.67),('8902','2013-07-23','17:00:00',5.56),('8902','2013-07-23','17:05:00',5.21),('8902','2013-07-23','17:10:00',3.54),('8902','2013-07-23','17:15:00',4.61),('8902','2013-07-23','17:20:00',4.83),('8902','2013-07-23','17:25:00',4.55),('8902','2013-07-23','17:30:00',4.39),('8902','2013-07-23','17:35:00',4.2),('8902','2013-07-23','17:40:00',3.97),('8902','2013-07-23','17:45:00',3.81),('8902','2013-07-23','17:50:00',3.59),('8902','2013-07-23','17:55:00',3.39),('8902','2013-07-23','18:00:00',3.2),('8902','2013-07-23','18:05:00',3.01),('8902','2013-07-23','18:10:00',2.83),('8902','2013-07-23','18:15:00',2.65),('8902','2013-07-23','18:20:00',2.34),('8902','2013-07-23','18:25:00',2.36),('8902','2013-07-23','18:30:00',2.26),('8902','2013-07-23','18:35:00',2.06),('8902','2013-07-23','18:40:00',1.91),('8902','2013-07-23','18:45:00',1.72),('8902','2013-07-23','18:50:00',1.48),('8902','2013-07-23','18:55:00',1.25),('8902','2013-07-23','19:05:00',1.06),('8902','2013-07-22','07:40:00',1.22),('8902','2013-07-22','07:45:00',1.33),('8902','2013-07-22','07:50:00',1.46),('8902','2013-07-22','07:55:00',1.69),('8902','2013-07-22','08:00:00',1.85),('8902','2013-07-22','08:05:00',2.03),('8902','2013-07-22','08:10:00',2.18),('8902','2013-07-22','08:15:00',2.34),('8902','2013-07-22','08:20:00',2.49),('8902','2013-07-22','08:25:00',2.65),('8902','2013-07-22','08:30:00',2.8),('8902','2013-07-22','08:35:00',2.95),('8902','2013-07-22','08:40:00',3.12),('8902','2013-07-22','08:45:00',3.3),('8902','2013-07-22','08:50:00',3.46),('8902','2013-07-22','08:55:00',3.62),('8902','2013-07-22','09:00:00',3.77),('8902','2013-07-22','09:05:00',3.96),('8902','2013-07-22','09:10:00',4.08),('8902','2013-07-22','09:15:00',4.21),('8902','2013-07-22','09:20:00',4.31),('8902','2013-07-22','09:25:00',4.42),('8902','2013-07-22','09:30:00',4.53),('8902','2013-07-22','09:35:00',4.68),('8902','2013-07-22','09:40:00',4.77),('8902','2013-07-22','09:45:00',4.88),('8902','2013-07-22','09:50:00',5.01),('8902','2013-07-22','09:55:00',5.08),('8902','2013-07-22','10:00:00',5.25),('8902','2013-07-22','10:05:00',5.39),('8902','2013-07-22','10:10:00',5.48),('8902','2013-07-22','10:15:00',5.6),('8902','2013-07-22','10:20:00',5.66),('8902','2013-07-22','10:25:00',5.84),('8902','2013-07-22','10:30:00',6.13),('8902','2013-07-22','10:35:00',6.18),('8902','2013-07-22','10:40:00',6.33),('8902','2013-07-22','10:45:00',6.32),('8902','2013-07-22','10:50:00',6.38),('8902','2013-07-22','10:55:00',6.49),('8902','2013-07-22','11:00:00',6.61),('8902','2013-07-22','11:05:00',6.67),('8902','2013-07-22','11:10:00',6.78),('8902','2013-07-22','11:15:00',6.9),('8902','2013-07-22','11:20:00',6.99),('8902','2013-07-22','11:25:00',6.99),('8902','2013-07-22','11:30:00',7.06),('8902','2013-07-22','11:35:00',7.1),('8902','2013-07-22','11:40:00',7.13),('8902','2013-07-22','11:45:00',7.12),('8902','2013-07-22','11:50:00',7.2),('8902','2013-07-22','11:55:00',7.29),('8902','2013-07-22','12:00:00',7.4),('8902','2013-07-22','12:05:00',7.4),('8902','2013-07-22','12:10:00',7.51),('8902','2013-07-22','12:15:00',7.58),('8902','2013-07-22','12:20:00',7.59),('8902','2013-07-22','12:25:00',7.66),('8902','2013-07-22','12:30:00',7.74),('8902','2013-07-22','12:35:00',7.63),('8902','2013-07-22','12:40:00',7.66),('8902','2013-07-22','12:45:00',7.73),('8902','2013-07-22','12:50:00',5.49),('8902','2013-07-22','12:55:00',5.79),('8902','2013-07-22','13:00:00',5.91),('8902','2013-07-22','13:05:00',2.59),('8902','2013-07-22','13:10:00',3.98),('8902','2013-07-22','13:15:00',3.68),('8902','2013-07-22','13:20:00',2.28),('8902','2013-07-22','13:25:00',1.9),('8902','2013-07-22','13:30:00',5.51),('8902','2013-07-22','13:35:00',8.41),('8902','2013-07-22','13:40:00',8.01),('8902','2013-07-22','13:45:00',7.55),('8902','2013-07-22','13:50:00',7.69),('8902','2013-07-22','13:55:00',6.67),('8902','2013-07-22','14:00:00',8.37),('8902','2013-07-22','14:05:00',4.57),('8902','2013-07-22','14:10:00',1.13),('8902','2013-07-22','14:35:00',1.49),('8902','2013-07-22','14:40:00',6.32),('8902','2013-07-22','14:45:00',6.51),('8902','2013-07-22','14:50:00',6.75),('8902','2013-07-22','14:55:00',7.33),('8902','2013-07-22','15:00:00',8.6),('8902','2013-07-22','15:05:00',8.46),('8902','2013-07-22','15:10:00',7.63),('8902','2013-07-22','15:15:00',6.95),('8902','2013-07-22','15:20:00',7.48),('8902','2013-07-22','15:25:00',7.11),('8902','2013-07-22','15:30:00',7.03),('8902','2013-07-22','15:35:00',6.86),('8902','2013-07-22','15:40:00',7.04),('8902','2013-07-22','15:45:00',6.81),('8902','2013-07-22','15:50:00',6.78),('8902','2013-07-22','15:55:00',6.74),('8902','2013-07-22','16:00:00',6.54),('8902','2013-07-22','16:05:00',6.38),('8902','2013-07-22','16:10:00',6.34),('8902','2013-07-22','16:15:00',6.17),('8902','2013-07-22','16:20:00',6.17),('8902','2013-07-22','16:25:00',6.09),('8902','2013-07-22','16:30:00',5.96),('8902','2013-07-22','16:35:00',5.76),('8902','2013-07-22','16:40:00',5.56),('8902','2013-07-22','16:45:00',5.46),('8902','2013-07-22','16:50:00',5.33),('8902','2013-07-22','16:55:00',5.15),('8902','2013-07-22','17:00:00',5.01),('8902','2013-07-22','17:05:00',4.92),('8902','2013-07-22','17:10:00',4.86),('8902','2013-07-22','17:15:00',4.74),('8902','2013-07-22','17:20:00',4.62),('8902','2013-07-22','17:25:00',4.47),('8902','2013-07-22','17:30:00',4.33),('8902','2013-07-22','17:35:00',4.19),('8902','2013-07-22','17:40:00',4.01),('8902','2013-07-22','17:45:00',3.84),('8902','2013-07-22','17:50:00',3.72),('8902','2013-07-22','17:55:00',3.53),('8902','2013-07-22','18:00:00',3.37),('8902','2013-07-22','18:05:00',3.2),('8902','2013-07-22','18:10:00',3.04),('8902','2013-07-22','18:15:00',2.9),('8902','2013-07-22','18:20:00',2.73),('8902','2013-07-22','18:25:00',2.52),('8902','2013-07-22','18:30:00',2.37),('8902','2013-07-22','18:35:00',2.05),('8902','2013-07-22','18:40:00',1.6),('8902','2013-07-22','18:45:00',1.43),('8902','2013-07-22','18:50:00',1.19),('8902','2013-07-22','18:55:00',1.33),('8902','2013-07-22','19:00:00',1.26),('8902','2013-07-22','19:05:00',1.1),('8902','2013-07-21','07:35:00',1.05),('8902','2013-07-21','07:40:00',1.25),('8902','2013-07-21','07:45:00',1.39),('8902','2013-07-21','07:50:00',1.53),('8902','2013-07-21','07:55:00',1.68),('8902','2013-07-21','08:00:00',1.83),('8902','2013-07-21','08:05:00',1.99),('8902','2013-07-21','08:10:00',2.14),('8902','2013-07-21','08:15:00',2.3),('8902','2013-07-21','08:20:00',2.47),('8902','2013-07-21','08:25:00',2.62),('8902','2013-07-21','08:30:00',2.78),('8902','2013-07-21','08:35:00',2.94),('8902','2013-07-21','08:40:00',3.11),('8902','2013-07-21','08:45:00',3.28),('8902','2013-07-21','08:50:00',3.43),('8902','2013-07-21','08:55:00',3.59),('8902','2013-07-21','09:00:00',3.76),('8902','2013-07-21','09:05:00',3.9),('8902','2013-07-21','09:10:00',4.05),('8902','2013-07-21','09:15:00',4.18),('8902','2013-07-21','09:20:00',4.34),('8902','2013-07-21','09:25:00',4.45),('8902','2013-07-21','09:30:00',4.58),('8902','2013-07-21','09:35:00',4.72),('8902','2013-07-21','09:40:00',4.86),('8902','2013-07-21','09:45:00',5.02),('8902','2013-07-21','09:50:00',5.15),('8902','2013-07-21','09:55:00',5.29),('8902','2013-07-21','10:00:00',5.39),('8902','2013-07-21','10:05:00',5.5),('8902','2013-07-21','10:10:00',5.62),('8902','2013-07-21','10:15:00',5.73),('8902','2013-07-21','10:20:00',5.84),('8902','2013-07-21','10:25:00',5.92),('8902','2013-07-21','10:30:00',6.02),('8902','2013-07-21','10:35:00',6.12),('8902','2013-07-21','10:40:00',6.21),('8902','2013-07-21','10:45:00',6.28),('8902','2013-07-21','10:50:00',6.36),('8902','2013-07-21','10:55:00',6.48),('8902','2013-07-21','11:00:00',6.58),('8902','2013-07-21','11:05:00',6.65),('8902','2013-07-21','11:10:00',6.73),('8902','2013-07-21','11:15:00',6.71),('8902','2013-07-21','11:20:00',6.74),('8902','2013-07-21','11:25:00',6.86),('8902','2013-07-21','11:30:00',6.96),('8902','2013-07-21','11:35:00',7.01),('8902','2013-07-21','11:40:00',7.09),('8902','2013-07-21','11:45:00',7.13),('8902','2013-07-21','11:50:00',7.18),('8902','2013-07-21','11:55:00',7.17),('8902','2013-07-21','12:00:00',7.25),('8902','2013-07-21','12:05:00',7.28),('8902','2013-07-21','12:10:00',7.35),('8902','2013-07-21','12:15:00',7.38),('8902','2013-07-21','12:20:00',7.39),('8902','2013-07-21','12:25:00',7.43),('8902','2013-07-21','12:30:00',7.52),('8902','2013-07-21','12:35:00',7.56),('8902','2013-07-21','12:40:00',7.51),('8902','2013-07-21','12:45:00',7.53),('8902','2013-07-21','12:50:00',7.61),('8902','2013-07-21','12:55:00',7.7),('8902','2013-07-21','13:00:00',7.71),('8902','2013-07-21','13:05:00',7.75),('8902','2013-07-21','13:10:00',7.72),('8902','2013-07-21','13:15:00',7.66),('8902','2013-07-21','13:20:00',7.71),('8902','2013-07-21','13:25:00',7.65),('8902','2013-07-21','13:30:00',7.62),('8902','2013-07-21','13:35:00',7.59),('8902','2013-07-21','13:40:00',7.78),('8902','2013-07-21','13:45:00',7.7),('8902','2013-07-21','13:50:00',7.68),('8902','2013-07-21','13:55:00',7.6),('8902','2013-07-21','14:00:00',7.57),('8902','2013-07-21','14:05:00',7.6),('8902','2013-07-21','14:10:00',7.53),('8902','2013-07-21','14:15:00',7.56),('8902','2013-07-21','14:20:00',7.55),('8902','2013-07-21','14:25:00',7.5),('8902','2013-07-21','14:30:00',7.49),('8902','2013-07-21','14:35:00',7.5),('8902','2013-07-21','14:45:00',7.35),('8902','2013-07-21','14:50:00',7.31),('8902','2013-07-21','14:55:00',7.23),('8902','2013-07-21','15:00:00',6.55),('8902','2013-07-21','15:05:00',7.28),('8902','2013-07-21','15:10:00',7.18),('8902','2013-07-21','15:15:00',7.12),('8902','2013-07-21','15:20:00',6.91),('8902','2013-07-21','15:25:00',7.04),('8902','2013-07-21','15:30:00',6.99),('8902','2013-07-21','15:35:00',4.52),('8902','2013-07-21','15:40:00',5.77),('8902','2013-07-21','15:45:00',7.09),('8902','2013-07-21','15:50:00',6.96),('8902','2013-07-21','15:55:00',6.61),('8902','2013-07-21','16:00:00',5.69),('8902','2013-07-21','16:05:00',4.25),('8902','2013-07-21','16:10:00',3.53),('8902','2013-07-21','16:15:00',2.34),('8902','2013-07-21','16:20:00',6.19),('8902','2013-07-21','16:25:00',6.71),('8902','2013-07-21','16:30:00',6.24),('8902','2013-07-21','16:35:00',5.88),('8902','2013-07-21','16:40:00',5.5),('8902','2013-07-21','16:45:00',5.46),('8902','2013-07-21','16:50:00',5.32),('8902','2013-07-21','16:55:00',5.21),('8902','2013-07-21','17:00:00',4.97),('8902','2013-07-21','17:05:00',4.98),('8902','2013-07-21','17:10:00',4.85),('8902','2013-07-21','17:15:00',4.71),('8902','2013-07-21','17:20:00',4.52),('8902','2013-07-21','17:25:00',4.19),('8902','2013-07-21','17:30:00',4.12),('8902','2013-07-21','17:35:00',4.14),('8902','2013-07-21','17:40:00',3.73),('8902','2013-07-21','17:45:00',3.46),('8902','2013-07-21','17:50:00',3.44),('8902','2013-07-21','17:55:00',3.26),('8902','2013-07-21','18:00:00',3.19),('8902','2013-07-21','18:05:00',3),('8902','2013-07-21','18:10:00',2.76),('8902','2013-07-21','18:15:00',2.56),('8902','2013-07-21','18:20:00',2.45),('8902','2013-07-21','18:25:00',2.25),('8902','2013-07-21','18:30:00',2.14),('8902','2013-07-21','18:35:00',1.92),('8902','2013-07-21','18:40:00',1.73),('8902','2013-07-21','18:45:00',1.63),('8902','2013-07-21','18:50:00',1.48),('8902','2013-07-21','18:55:00',1.28),('8902','2013-07-21','19:05:00',1.08),('8902','2013-07-20','07:35:00',1.09),('8902','2013-07-20','07:40:00',1.24),('8902','2013-07-20','07:45:00',1.42),('8902','2013-07-20','07:50:00',1.51),('8902','2013-07-20','07:55:00',1.58),('8902','2013-07-20','08:00:00',1.73),('8902','2013-07-20','08:05:00',1.84),('8902','2013-07-20','08:10:00',2.04),('8902','2013-07-20','08:15:00',2.2),('8902','2013-07-20','08:20:00',2.33),('8902','2013-07-20','08:25:00',2.5),('8902','2013-07-20','08:30:00',2.67),('8902','2013-07-20','08:35:00',2.82),('8902','2013-07-20','08:40:00',2.95),('8902','2013-07-20','08:45:00',3.08),('8902','2013-07-20','08:50:00',3.23),('8902','2013-07-20','08:55:00',3.41),('8902','2013-07-20','09:00:00',3.59),('8902','2013-07-20','09:05:00',3.72),('8902','2013-07-20','09:10:00',3.88),('8902','2013-07-20','09:15:00',4.03),('8902','2013-07-20','09:20:00',4.16),('8902','2013-07-20','09:25:00',4.29),('8902','2013-07-20','09:30:00',4.41),('8902','2013-07-20','09:35:00',4.55),('8902','2013-07-20','09:40:00',4.69),('8902','2013-07-20','09:45:00',4.8),('8902','2013-07-20','09:50:00',4.92),('8902','2013-07-20','09:55:00',5.04),('8902','2013-07-20','10:00:00',5.19),('8902','2013-07-20','10:05:00',5.33),('8902','2013-07-20','10:10:00',5.42),('8902','2013-07-20','10:15:00',5.51),('8902','2013-07-20','10:20:00',5.6),('8902','2013-07-20','10:25:00',5.7),('8902','2013-07-20','10:30:00',5.79),('8902','2013-07-20','10:35:00',5.93),('8902','2013-07-20','10:40:00',6.06),('8902','2013-07-20','10:45:00',6.14),('8902','2013-07-20','10:50:00',6.24),('8902','2013-07-20','10:55:00',6.33),('8902','2013-07-20','11:00:00',6.42),('8902','2013-07-20','11:05:00',6.47),('8902','2013-07-20','11:10:00',6.51),('8902','2013-07-20','11:15:00',6.63),('8902','2013-07-20','11:20:00',6.69),('8902','2013-07-20','11:25:00',6.76),('8902','2013-07-20','11:30:00',6.91),('8902','2013-07-20','11:35:00',6.96),('8902','2013-07-20','11:40:00',7.25),('8902','2013-07-20','11:45:00',7.28),('8902','2013-07-20','11:50:00',7.11),('8902','2013-07-20','11:55:00',7.15),('8902','2013-07-20','12:00:00',7.21),('8902','2013-07-20','12:05:00',7.29),('8902','2013-07-20','12:10:00',7.45),('8902','2013-07-20','12:15:00',7.7),('8902','2013-07-20','12:20:00',7.92),('8902','2013-07-20','12:25:00',8.02),('8902','2013-07-20','12:30:00',8.27),('8902','2013-07-20','12:35:00',8.55),('8902','2013-07-20','12:40:00',8.78),('8902','2013-07-20','12:45:00',7.62),('8902','2013-07-20','12:50:00',7.34),('8902','2013-07-20','12:55:00',7.42),('8902','2013-07-20','13:00:00',8.04),('8902','2013-07-20','13:05:00',8.28),('8902','2013-07-20','13:10:00',8.96),('8902','2013-07-20','13:15:00',8.8),('8902','2013-07-20','13:20:00',7.9),('8902','2013-07-20','13:25:00',8.41),('8902','2013-07-20','13:30:00',8.04),('8902','2013-07-20','13:35:00',6.7),('8902','2013-07-20','13:40:00',5.55),('8902','2013-07-20','13:45:00',1.85),('8902','2013-07-20','13:50:00',1.72),('8902','2013-07-20','13:55:00',1.51),('8902','2013-07-20','14:00:00',1.57),('8902','2013-07-20','14:05:00',1.64),('8902','2013-07-20','14:10:00',1.51),('8902','2013-07-20','14:15:00',1.54),('8902','2013-07-20','14:20:00',2.02),('8902','2013-07-20','14:25:00',2.21),('8902','2013-07-20','14:30:00',2.17),('8902','2013-07-20','14:35:00',2.43),('8902','2013-07-20','14:40:00',2.42),('8902','2013-07-20','14:45:00',4.34),('8902','2013-07-20','14:50:00',5.96),('8902','2013-07-20','14:55:00',3.02),('8902','2013-07-20','15:00:00',3.55),('8902','2013-07-20','15:05:00',3.13),('8902','2013-07-20','15:10:00',2.96),('8902','2013-07-20','15:15:00',8.4),('8902','2013-07-20','15:20:00',9.33),('8902','2013-07-20','15:25:00',3.35),('8902','2013-07-20','15:30:00',2.66),('8902','2013-07-20','15:35:00',3.02),('8902','2013-07-20','15:40:00',6.97),('8902','2013-07-20','15:45:00',5.94),('8902','2013-07-20','15:50:00',5.87),('8902','2013-07-20','15:55:00',4.17),('8902','2013-07-20','16:00:00',2.64),('8902','2013-07-20','16:05:00',2.05),('8902','2013-07-20','16:10:00',1.74),('8902','2013-07-20','16:15:00',1.52),('8902','2013-07-20','16:20:00',1.41),('8902','2013-07-20','16:25:00',1.46),('8902','2013-07-20','16:30:00',1.52),('8902','2013-07-20','16:35:00',1.62),('8902','2013-07-20','16:40:00',1.66),('8902','2013-07-20','16:45:00',1.65),('8902','2013-07-20','16:50:00',1.72),('8902','2013-07-20','16:55:00',1.95),('8902','2013-07-20','17:00:00',2.22),('8902','2013-07-20','17:05:00',2.44),('8902','2013-07-20','17:10:00',2.44),('8902','2013-07-20','17:15:00',2.05),('8902','2013-07-20','17:20:00',1.86),('8902','2013-07-20','17:25:00',1.73),('8902','2013-07-20','17:30:00',1.61),('8902','2013-07-20','17:35:00',1.54),('8902','2013-07-20','17:40:00',1.52),('8902','2013-07-20','17:45:00',1.5),('8902','2013-07-20','17:50:00',1.54),('8902','2013-07-20','17:55:00',1.58),('8902','2013-07-20','18:00:00',1.58),('8902','2013-07-20','18:05:00',1.49),('8902','2013-07-20','18:10:00',1.28),('8902','2013-07-20','18:15:00',1.1),('8902','2014-04-06','08:10:00',1.22),('8902','2014-04-06','08:15:00',1.46),('8902','2014-04-06','08:20:00',1.81),('8902','2014-04-06','08:25:00',1.81),('8902','2014-04-06','08:30:00',1.99),('8902','2014-04-06','08:35:00',2.67),('8902','2014-04-06','08:40:00',3),('8902','2014-04-06','08:45:00',3.11),('8902','2014-04-06','08:50:00',2.58),('8902','2014-04-06','08:55:00',2.28),('8902','2014-04-06','09:00:00',2.21),('8902','2014-04-06','09:05:00',2.3),('8902','2014-04-06','09:10:00',2.54),('8902','2014-04-06','09:15:00',2.79),('8902','2014-04-06','09:20:00',2.59),('8902','2014-04-06','09:25:00',2.42),('8902','2014-04-06','09:30:00',2.39),('8902','2014-04-06','09:35:00',2.19),('8902','2014-04-06','09:40:00',2.24),('8902','2014-04-06','09:45:00',2.35),('8902','2014-04-06','09:50:00',2.47),('8902','2014-04-06','09:55:00',2.81),('8902','2014-04-06','10:00:00',2.64),('8902','2014-04-06','10:05:00',2.6),('8902','2014-04-06','10:10:00',2.76),('8902','2014-04-06','10:15:00',2.54),('8902','2014-04-06','10:20:00',2.51),('8902','2014-04-06','10:25:00',2.57),('8902','2014-04-06','10:30:00',2.65),('8902','2014-04-06','10:35:00',2.84),('8902','2014-04-06','10:40:00',2.92),('8902','2014-04-06','10:45:00',3.02),('8902','2014-04-06','10:50:00',3.1),('8902','2014-04-06','10:55:00',3.26),('8902','2014-04-06','11:00:00',3.46),('8902','2014-04-06','11:05:00',3.65),('8902','2014-04-06','11:10:00',4.2),('8902','2014-04-06','11:15:00',4.61),('8902','2014-04-06','11:20:00',4.14),('8902','2014-04-06','11:25:00',4.02),('8902','2014-04-06','11:30:00',4.01),('8902','2014-04-06','11:35:00',3.91),('8902','2014-04-06','11:40:00',3.77),('8902','2014-04-06','11:45:00',3.57),('8902','2014-04-06','11:50:00',3.47),('8902','2014-04-06','11:55:00',3.44),('8902','2014-04-06','12:00:00',3.69),('8902','2014-04-06','12:05:00',4.51),('8902','2014-04-06','12:10:00',5.17),('8902','2014-04-06','12:15:00',6.7),('8902','2014-04-06','12:20:00',8.29),('8902','2014-04-06','12:25:00',7.95),('8902','2014-04-06','12:30:00',5.11),('8902','2014-04-06','12:35:00',4.68),('8902','2014-04-06','12:40:00',5.66),('8902','2014-04-06','12:45:00',7.77),('8902','2014-04-06','12:50:00',7.88),('8902','2014-04-06','12:55:00',7.8),('8902','2014-04-06','13:00:00',7.83),('8902','2014-04-06','13:05:00',7.77),('8902','2014-04-06','13:10:00',7.75),('8902','2014-04-06','13:15:00',7.78),('8902','2014-04-06','13:20:00',7.82),('8902','2014-04-06','13:25:00',7.77),('8902','2014-04-06','13:30:00',7.71),('8902','2014-04-06','13:35:00',7.71),('8902','2014-04-06','13:40:00',7.73),('8902','2014-04-06','13:45:00',7.8),('8902','2014-04-06','13:50:00',7.74),('8902','2014-04-06','13:55:00',7.7),('8902','2014-04-06','14:00:00',7.63),('8902','2014-04-06','14:05:00',7.63),('8902','2014-04-06','14:10:00',7.56),('8902','2014-04-06','14:15:00',7.54),('8902','2014-04-06','14:20:00',7.51),('8902','2014-04-06','14:25:00',7.81),('8902','2014-04-06','14:30:00',7.75),('8902','2014-04-06','14:35:00',7.53),('8902','2014-04-06','14:40:00',7.5),('8902','2014-04-06','14:45:00',7.33),('8902','2014-04-06','14:50:00',7.02),('8902','2014-04-06','14:55:00',6.06),('8902','2014-04-06','15:00:00',7.26),('8902','2014-04-06','15:05:00',7.41),('8902','2014-04-06','15:10:00',7.25),('8902','2014-04-06','15:15:00',4.91),('8902','2014-04-06','15:20:00',7.3),('8902','2014-04-06','15:25:00',7.23),('8902','2014-04-06','15:30:00',6.89),('8902','2014-04-06','15:35:00',7.07),('8902','2014-04-06','15:40:00',6.91),('8902','2014-04-06','15:45:00',7.06),('8902','2014-04-06','15:50:00',7.35),('8902','2014-04-06','15:55:00',6.79),('8902','2014-04-06','16:00:00',4.34),('8902','2014-04-06','16:05:00',3.41),('8902','2014-04-06','16:10:00',6.41),('8902','2014-04-06','16:15:00',6.01),('8902','2014-04-06','16:20:00',5.57),('8902','2014-04-06','16:25:00',5.4),('8902','2014-04-06','16:30:00',5.26),('8902','2014-04-06','16:35:00',4.35),('8902','2014-04-06','16:40:00',2.3),('8902','2014-04-06','16:45:00',4.27),('8902','2014-04-06','16:50:00',4.23),('8902','2014-04-06','16:55:00',5.12),('8902','2014-04-06','17:00:00',5.15),('8902','2014-04-06','17:05:00',4.45),('8902','2014-04-06','17:10:00',2.63),('8902','2014-04-06','17:15:00',3.74),('8902','2014-04-06','17:20:00',1.61),('8902','2014-04-06','17:25:00',1.35),('8902','2014-04-06','17:30:00',1.39),('8902','2014-04-06','17:35:00',1.03),('8902','2014-04-06','17:50:00',1.09),('8902','2014-04-06','17:55:00',2.27),('8902','2014-04-06','18:00:00',2.11),('8902','2014-04-06','18:05:00',1.94),('8902','2014-04-06','18:10:00',1.92),('8902','2014-04-06','18:15:00',1.77),('8902','2014-04-06','18:20:00',1.44),('8902','2014-04-06','18:25:00',1.27),('8902','2014-04-06','18:30:00',1.16),('8902','2013-07-19','07:35:00',1.02),('8902','2013-07-19','07:40:00',1.25),('8902','2013-07-19','07:45:00',1.39),('8902','2013-07-19','07:50:00',1.5),('8902','2013-07-19','07:55:00',1.66),('8902','2013-07-19','08:00:00',1.8),('8902','2013-07-19','08:05:00',1.96),('8902','2013-07-19','08:10:00',2.12),('8902','2013-07-19','08:15:00',2.27),('8902','2013-07-19','08:20:00',2.45),('8902','2013-07-19','08:25:00',2.61),('8902','2013-07-19','08:30:00',2.76),('8902','2013-07-19','08:35:00',2.94),('8902','2013-07-19','08:40:00',3.11),('8902','2013-07-19','08:45:00',3.31),('8902','2013-07-19','08:50:00',3.48),('8902','2013-07-19','08:55:00',3.64),('8902','2013-07-19','09:00:00',3.82),('8902','2013-07-19','09:05:00',4.01),('8902','2013-07-19','09:10:00',4.24),('8902','2013-07-19','09:15:00',4.42),('8902','2013-07-19','09:20:00',4.53),('8902','2013-07-19','09:25:00',4.48),('8902','2013-07-19','09:30:00',4.48),('8902','2013-07-19','09:35:00',4.58),('8902','2013-07-19','09:40:00',4.53),('8902','2013-07-19','09:45:00',5.01),('8902','2013-07-19','09:50:00',4.94),('8902','2013-07-19','09:55:00',5.03),('8902','2013-07-19','10:00:00',5.3),('8902','2013-07-19','10:05:00',5.34),('8902','2013-07-19','10:10:00',5.5),('8902','2013-07-19','10:15:00',5.62),('8902','2013-07-19','10:20:00',5.74),('8902','2013-07-19','10:25:00',5.85),('8902','2013-07-19','10:30:00',5.99),('8902','2013-07-19','10:35:00',6.08),('8902','2013-07-19','10:40:00',6.15),('8902','2013-07-19','10:45:00',6.25),('8902','2013-07-19','10:50:00',6.36),('8902','2013-07-19','10:55:00',6.44),('8902','2013-07-19','11:00:00',6.53),('8902','2013-07-19','11:05:00',6.54),('8902','2013-07-19','11:10:00',6.76),('8902','2013-07-19','11:15:00',6.78),('8902','2013-07-19','11:20:00',6.8),('8902','2013-07-19','11:25:00',6.79),('8902','2013-07-19','11:30:00',6.78),('8902','2013-07-19','11:35:00',6.96),('8902','2013-07-19','11:40:00',7.13),('8902','2013-07-19','11:45:00',7.14),('8902','2013-07-19','11:50:00',7.29),('8902','2013-07-19','11:55:00',7.37),('8902','2013-07-19','12:00:00',7.27),('8902','2013-07-19','12:05:00',7.36),('8902','2013-07-19','12:10:00',7.49),('8902','2013-07-19','12:15:00',7.59),('8902','2013-07-19','12:20:00',7.33),('8902','2013-07-19','12:25:00',2.94),('8902','2013-07-19','12:30:00',6.79),('8902','2013-07-19','12:35:00',7.72),('8902','2013-07-19','12:40:00',7.76),('8902','2013-07-19','12:45:00',7.83),('8902','2013-07-19','12:50:00',7.76),('8902','2013-07-19','12:55:00',7.94),('8902','2013-07-19','13:00:00',8.08),('8902','2013-07-19','13:05:00',8.07),('8902','2013-07-19','13:10:00',8.01),('8902','2013-07-19','13:15:00',8.08),('8902','2013-07-19','13:20:00',3.51),('8902','2013-07-19','13:25:00',3.98),('8902','2013-07-19','13:30:00',8.39),('8902','2013-07-19','13:35:00',8.24),('8902','2013-07-19','13:40:00',8.29),('8902','2013-07-19','13:45:00',8.17),('8902','2013-07-19','13:50:00',8.12),('8902','2013-07-19','13:55:00',2.76),('8902','2013-07-19','14:00:00',1.93),('8902','2013-07-19','14:05:00',7.96),('8902','2013-07-19','14:10:00',8.31),('8902','2013-07-19','14:15:00',5.63),('8902','2013-07-19','14:20:00',5.98),('8902','2013-07-19','14:25:00',8.13),('8902','2013-07-19','14:30:00',7.94),('8902','2013-07-19','14:35:00',7.24),('8902','2013-07-19','14:40:00',7.67),('8902','2013-07-19','14:45:00',2.87),('8902','2013-07-19','14:50:00',6.79),('8902','2013-07-19','14:55:00',4.28),('8902','2013-07-19','15:00:00',2.41),('8902','2013-07-19','15:05:00',6.6),('8902','2013-07-19','15:10:00',7.86),('8902','2013-07-19','15:15:00',7.5),('8902','2013-07-19','15:20:00',7.35),('8902','2013-07-19','15:25:00',7.15),('8902','2013-07-19','15:30:00',7.05),('8902','2013-07-19','15:35:00',6.92),('8902','2013-07-19','15:40:00',6.8),('8902','2013-07-19','15:45:00',6.73),('8902','2013-07-19','15:50:00',6.62),('8902','2013-07-19','15:55:00',6.55),('8902','2013-07-19','16:00:00',6.48),('8902','2013-07-19','16:05:00',6.29),('8902','2013-07-19','16:10:00',6.27),('8902','2013-07-19','16:15:00',6.22),('8902','2013-07-19','16:20:00',6.18),('8902','2013-07-19','16:25:00',6.06),('8902','2013-07-19','16:30:00',5.96),('8902','2013-07-19','16:35:00',5.77),('8902','2013-07-19','16:40:00',5.53),('8902','2013-07-19','16:45:00',5.43),('8902','2013-07-19','16:50:00',5.28),('8902','2013-07-19','16:55:00',5.13),('8902','2013-07-19','17:00:00',4.92),('8902','2013-07-19','17:05:00',4.92),('8902','2013-07-19','17:10:00',4.77),('8902','2013-07-19','17:15:00',4.64),('8902','2013-07-19','17:20:00',4.54),('8902','2013-07-19','17:25:00',4.36),('8902','2013-07-19','17:30:00',4.24),('8902','2013-07-19','17:35:00',4.11),('8902','2013-07-19','17:40:00',3.97),('8902','2013-07-19','17:45:00',3.79),('8902','2013-07-19','17:50:00',3.62),('8902','2013-07-19','17:55:00',3.41),('8902','2013-07-19','18:00:00',3.21),('8902','2013-07-19','18:05:00',3.1),('8902','2013-07-19','18:10:00',2.91),('8902','2013-07-19','18:15:00',2.76),('8902','2013-07-19','18:20:00',2.61),('8902','2013-07-19','18:25:00',2.41),('8902','2013-07-19','18:30:00',2.28),('8902','2013-07-19','18:35:00',2.05),('8902','2013-07-19','18:40:00',1.9),('8902','2013-07-19','18:45:00',1.74),('8902','2013-07-19','18:50:00',1.58),('8902','2013-07-19','18:55:00',1.41),('8902','2013-07-19','19:00:00',1.25),('8902','2013-07-19','19:05:00',1.1),('8902','2013-07-18','07:35:00',1.07),('8902','2013-07-18','07:40:00',1.27),('8902','2013-07-18','07:45:00',1.4),('8902','2013-07-18','07:50:00',1.53),('8902','2013-07-18','07:55:00',1.65),('8902','2013-07-18','08:00:00',1.8),('8902','2013-07-18','08:05:00',1.95),('8902','2013-07-18','08:10:00',2.09),('8902','2013-07-18','08:15:00',2.24),('8902','2013-07-18','08:20:00',2.39),('8902','2013-07-18','08:25:00',2.53),('8902','2013-07-18','08:30:00',2.66),('8902','2013-07-18','08:35:00',2.83),('8902','2013-07-18','08:40:00',3),('8902','2013-07-18','08:45:00',3.17),('8902','2013-07-18','08:50:00',3.32),('8902','2013-07-18','08:55:00',3.48),('8902','2013-07-18','09:00:00',3.6),('8902','2013-07-18','09:05:00',3.74),('8902','2013-07-18','09:10:00',3.89),('8902','2013-07-18','09:15:00',4.03),('8902','2013-07-18','09:20:00',4.15),('8902','2013-07-18','09:25:00',4.26),('8902','2013-07-18','09:30:00',4.4),('8902','2013-07-18','09:35:00',4.58),('8902','2013-07-18','09:40:00',4.65),('8902','2013-07-18','09:45:00',4.7),('8902','2013-07-18','09:50:00',4.87),('8902','2013-07-18','09:55:00',5.01),('8902','2013-07-18','10:00:00',5.12),('8902','2013-07-18','10:05:00',5.19),('8902','2013-07-18','10:10:00',5.27),('8902','2013-07-18','10:15:00',5.39),('8902','2013-07-18','10:20:00',5.45),('8902','2013-07-18','10:25:00',5.64),('8902','2013-07-18','10:30:00',5.66),('8902','2013-07-18','10:35:00',5.84),('8902','2013-07-18','10:40:00',5.9),('8902','2013-07-18','10:45:00',6.01),('8902','2013-07-18','10:50:00',6.06),('8902','2013-07-18','10:55:00',6.19),('8902','2013-07-18','11:00:00',6.36),('8902','2013-07-18','11:05:00',6.36),('8902','2013-07-18','11:10:00',6.39),('8902','2013-07-18','11:15:00',6.41),('8902','2013-07-18','11:20:00',6.58),('8902','2013-07-18','11:25:00',6.61),('8902','2013-07-18','11:30:00',6.6),('8902','2013-07-18','11:35:00',6.64),('8902','2013-07-18','11:40:00',6.75),('8902','2013-07-18','11:45:00',6.97),('8902','2013-07-18','11:50:00',7.17),('8902','2013-07-18','11:55:00',7.14),('8902','2013-07-18','12:00:00',5.84),('8902','2013-07-18','12:05:00',3.86),('8902','2013-07-18','12:10:00',7.11),('8902','2013-07-18','12:15:00',7.45),('8902','2013-07-18','12:20:00',7.48),('8902','2013-07-18','12:25:00',6.1),('8902','2013-07-18','12:30:00',6.86),('8902','2013-07-18','12:35:00',7.2),('8902','2013-07-18','12:40:00',6.68),('8902','2013-07-18','12:45:00',7.46),('8902','2013-07-18','12:50:00',7.55),('8902','2013-07-18','12:55:00',5.13),('8902','2013-07-18','13:00:00',4.59),('8902','2013-07-18','13:05:00',6.74),('8902','2013-07-18','13:10:00',7.71),('8902','2013-07-18','13:15:00',5.72),('8902','2013-07-18','13:20:00',2.81),('8902','2013-07-18','13:25:00',5.01),('8902','2013-07-18','13:30:00',8.58),('8902','2013-07-18','13:35:00',8.19),('8902','2013-07-18','13:40:00',8.11),('8902','2013-07-18','13:45:00',8.11),('8902','2013-07-18','13:50:00',7.9),('8902','2013-07-18','13:55:00',7.4),('8902','2013-07-18','14:00:00',6.32),('8902','2013-07-18','14:05:00',8.21),('8902','2013-07-18','14:10:00',6.27),('8902','2013-07-18','14:15:00',7.8),('8902','2013-07-18','14:20:00',8.21),('8902','2013-07-18','14:25:00',7.84),('8902','2013-07-18','14:30:00',8.18),('8902','2013-07-18','14:35:00',8.17),('8902','2013-07-18','14:40:00',6.82),('8902','2013-07-18','14:45:00',6.27),('8902','2013-07-18','14:50:00',7.7),('8902','2013-07-18','14:55:00',6.46),('8902','2013-07-18','15:00:00',7.85),('8902','2013-07-18','15:05:00',7.59),('8902','2013-07-18','15:10:00',7.62),('8902','2013-07-18','15:15:00',4.17),('8902','2013-07-18','15:20:00',6.5),('8902','2013-07-18','15:25:00',5.44),('8902','2013-07-18','15:30:00',7.52),('8902','2013-07-18','15:35:00',6.98),('8902','2013-07-18','15:40:00',7.36),('8902','2013-07-18','15:45:00',7.17),('8902','2013-07-18','15:50:00',6.97),('8902','2013-07-18','15:55:00',6.86),('8902','2013-07-18','16:00:00',6.76),('8902','2013-07-18','16:05:00',6.67),('8902','2013-07-18','16:10:00',6.62),('8902','2013-07-18','16:15:00',6.53),('8902','2013-07-18','16:20:00',6.43),('8902','2013-07-18','16:25:00',6.29),('8902','2013-07-18','16:30:00',6.19),('8902','2013-07-18','16:35:00',6.1),('8902','2013-07-18','16:40:00',5.94),('8902','2013-07-18','16:45:00',5.88),('8902','2013-07-18','16:50:00',5.75),('8902','2013-07-18','16:55:00',5.75),('8902','2013-07-18','17:00:00',4.74),('8902','2013-07-18','17:05:00',4.93),('8902','2013-07-18','17:10:00',5.36),('8902','2013-07-18','17:15:00',4.87),('8902','2013-07-18','17:20:00',4.35),('8902','2013-07-18','17:25:00',3.83),('8902','2013-07-18','17:30:00',4.14),('8902','2013-07-18','17:35:00',3.99),('8902','2013-07-18','17:40:00',3.3),('8902','2013-07-18','17:45:00',2.59),('8902','2013-07-18','17:50:00',1.82),('8902','2013-07-18','17:55:00',1.61),('8902','2013-07-18','18:00:00',1.47),('8902','2013-07-18','18:05:00',1.28),('8902','2013-07-18','18:10:00',1.08),('8902','2013-07-18','18:40:00',1.01),('8902','2013-07-18','18:45:00',1.01),('8902','2013-07-17','07:35:00',1.11),('8902','2013-07-17','07:40:00',1.29),('8902','2013-07-17','07:45:00',1.44),('8902','2013-07-17','07:50:00',1.59),('8902','2013-07-17','07:55:00',1.74),('8902','2013-07-17','08:00:00',1.89),('8902','2013-07-17','08:05:00',2.05),('8902','2013-07-17','08:10:00',2.21),('8902','2013-07-17','08:15:00',2.37),('8902','2013-07-17','08:20:00',2.53),('8902','2013-07-17','08:25:00',2.67),('8902','2013-07-17','08:30:00',2.83),('8902','2013-07-17','08:35:00',3),('8902','2013-07-17','08:40:00',3.16),('8902','2013-07-17','08:45:00',3.32),('8902','2013-07-17','08:50:00',3.46),('8902','2013-07-17','08:55:00',3.61),('8902','2013-07-17','09:00:00',3.76),('8902','2013-07-17','09:05:00',3.91),('8902','2013-07-17','09:10:00',4.05),('8902','2013-07-17','09:15:00',4.18),('8902','2013-07-17','09:20:00',4.32),('8902','2013-07-17','09:25:00',4.46),('8902','2013-07-17','09:30:00',4.61),('8902','2013-07-17','09:35:00',4.75),('8902','2013-07-17','09:40:00',4.87),('8902','2013-07-17','09:45:00',4.97),('8902','2013-07-17','09:50:00',5.09),('8902','2013-07-17','09:55:00',5.19),('8902','2013-07-17','10:00:00',5.32),('8902','2013-07-17','10:05:00',5.4),('8902','2013-07-17','10:10:00',5.58),('8902','2013-07-17','10:15:00',5.69),('8902','2013-07-17','10:20:00',5.78),('8902','2013-07-17','10:25:00',5.87),('8902','2013-07-17','10:30:00',6.03),('8902','2013-07-17','10:35:00',6.14),('8902','2013-07-17','10:40:00',6.24),('8902','2013-07-17','10:45:00',6.27),('8902','2013-07-17','10:50:00',6.37),('8902','2013-07-17','10:55:00',6.45),('8902','2013-07-17','11:00:00',6.5),('8902','2013-07-17','11:05:00',6.58),('8902','2013-07-17','11:10:00',6.68),('8902','2013-07-17','11:15:00',6.72),('8902','2013-07-17','11:20:00',6.84),('8902','2013-07-17','11:25:00',6.9),('8902','2013-07-17','11:30:00',6.94),('8902','2013-07-17','11:35:00',7),('8902','2013-07-17','11:40:00',7.02),('8902','2013-07-17','11:45:00',7.06),('8902','2013-07-17','11:50:00',7.11),('8902','2013-07-17','11:55:00',7.19),('8902','2013-07-17','12:00:00',7.26),('8902','2013-07-17','12:05:00',7.26),('8902','2013-07-17','12:10:00',7.27),('8902','2013-07-17','12:15:00',7.29),('8902','2013-07-17','12:20:00',7.4),('8902','2013-07-17','12:25:00',7.21),('8902','2013-07-17','12:30:00',4.06),('8902','2013-07-17','12:35:00',5.09),('8902','2013-07-17','12:40:00',6.69),('8902','2013-07-17','12:45:00',6.88),('8902','2013-07-17','12:50:00',3.84),('8902','2013-07-17','12:55:00',6.08),('8902','2013-07-17','13:00:00',8.14),('8902','2013-07-17','13:05:00',7.92),('8902','2013-07-17','13:10:00',7.8),('8902','2013-07-17','13:15:00',7.64),('8902','2013-07-17','13:20:00',6.84),('8902','2013-07-17','13:25:00',7.13),('8902','2013-07-17','13:30:00',8.14),('8902','2013-07-17','13:35:00',7.71),('8902','2013-07-17','13:40:00',7.77),('8902','2013-07-17','13:45:00',8.12),('8902','2013-07-17','13:50:00',8.01),('8902','2013-07-17','13:55:00',7.74),('8902','2013-07-17','14:00:00',7.79),('8902','2013-07-17','14:05:00',7.83),('8902','2013-07-17','14:10:00',7.66),('8902','2013-07-17','14:15:00',7.68),('8902','2013-07-17','14:20:00',7.85),('8902','2013-07-17','14:25:00',7.66),('8902','2013-07-17','14:30:00',7.54),('8902','2013-07-17','14:35:00',7.68),('8902','2013-07-17','14:40:00',7.68),('8902','2013-07-17','14:45:00',7.47),('8902','2013-07-17','14:50:00',7.42),('8902','2013-07-17','14:55:00',7.31),('8902','2013-07-17','15:00:00',7.28),('8902','2013-07-17','15:05:00',7.36),('8902','2013-07-17','15:10:00',7.32),('8902','2013-07-17','15:15:00',7.19),('8902','2013-07-17','15:20:00',7.18),('8902','2013-07-17','15:25:00',7.18),('8902','2013-07-17','15:30:00',7.09),('8902','2013-07-17','15:35:00',6.96),('8902','2013-07-17','15:40:00',6.92),('8902','2013-07-17','15:45:00',6.83),('8902','2013-07-17','15:50:00',6.74),('8902','2013-07-17','15:55:00',6.63),('8902','2013-07-17','16:00:00',6.53),('8902','2013-07-17','16:05:00',6.4),('8902','2013-07-17','16:10:00',6.28),('8902','2013-07-17','16:15:00',6.21),('8902','2013-07-17','16:20:00',6.11),('8902','2013-07-17','16:25:00',6.03),('8902','2013-07-17','16:30:00',5.9),('8902','2013-07-17','16:35:00',5.75),('8902','2013-07-17','16:40:00',5.52),('8902','2013-07-17','16:45:00',5.44),('8902','2013-07-17','16:50:00',5.33),('8902','2013-07-17','16:55:00',5.16),('8902','2013-07-17','17:00:00',4.95),('8902','2013-07-17','17:05:00',4.89),('8902','2013-07-17','17:10:00',4.74),('8902','2013-07-17','17:15:00',4.54),('8902','2013-07-17','17:20:00',4.41),('8902','2013-07-17','17:35:00',3.9),('8902','2013-07-17','17:40:00',3.74),('8902','2013-07-17','17:50:00',3.32),('8902','2013-07-17','17:55:00',3.22),('8902','2013-07-17','18:00:00',2.88),('8902','2013-07-17','18:05:00',2.85),('8902','2013-07-17','18:10:00',2.66),('8902','2013-07-17','18:15:00',2.59),('8902','2013-07-17','18:20:00',2.34),('8902','2013-07-17','18:25:00',2.21),('8902','2013-07-17','18:30:00',1.32),('8902','2013-07-17','19:00:00',1.13),('8902','2013-07-16','07:35:00',1.14),('8902','2013-07-16','07:40:00',1.3),('8902','2013-07-16','07:45:00',1.46),('8902','2013-07-16','07:50:00',1.61),('8902','2013-07-16','07:55:00',1.77),('8902','2013-07-16','08:00:00',1.92),('8902','2013-07-16','08:05:00',2.12),('8902','2013-07-16','08:10:00',2.3),('8902','2013-07-16','08:15:00',2.45),('8902','2013-07-16','08:20:00',2.63),('8902','2013-07-16','08:25:00',2.79),('8902','2013-07-16','08:30:00',2.93),('8902','2013-07-16','08:35:00',3.12),('8902','2013-07-16','08:40:00',3.3),('8902','2013-07-16','08:45:00',3.45),('8902','2013-07-16','08:50:00',3.61),('8902','2013-07-16','08:55:00',3.76),('8902','2013-07-16','09:00:00',3.92),('8902','2013-07-16','09:05:00',4.1),('8902','2013-07-16','09:10:00',4.27),('8902','2013-07-16','09:15:00',4.42),('8902','2013-07-16','09:20:00',4.58),('8902','2013-07-16','09:25:00',4.74),('8902','2013-07-16','09:30:00',4.85),('8902','2013-07-16','09:35:00',4.95),('8902','2013-07-16','09:40:00',5.11),('8902','2013-07-16','09:45:00',5.26),('8902','2013-07-16','09:50:00',5.38),('8902','2013-07-16','09:55:00',5.46),('8902','2013-07-16','10:00:00',5.58),('8902','2013-07-16','10:05:00',5.7),('8902','2013-07-16','10:10:00',5.81),('8902','2013-07-16','10:15:00',5.92),('8902','2013-07-16','10:20:00',6.03),('8902','2013-07-16','10:25:00',6.16),('8902','2013-07-16','10:30:00',6.26),('8902','2013-07-16','10:35:00',6.31),('8902','2013-07-16','10:40:00',6.37),('8902','2013-07-16','10:45:00',6.53),('8902','2013-07-16','10:50:00',6.63),('8902','2013-07-16','10:55:00',6.69),('8902','2013-07-16','11:00:00',6.78),('8902','2013-07-16','11:05:00',6.85),('8902','2013-07-16','11:10:00',6.94),('8902','2013-07-16','11:15:00',6.99),('8902','2013-07-16','11:20:00',7.09),('8902','2013-07-16','11:25:00',7.16),('8902','2013-07-16','11:30:00',7.21),('8902','2013-07-16','11:35:00',7.31),('8902','2013-07-16','11:40:00',7.3),('8902','2013-07-16','11:45:00',7.35),('8902','2013-07-16','11:50:00',7.41),('8902','2013-07-16','11:55:00',7.51),('8902','2013-07-16','12:00:00',7.56),('8902','2013-07-16','12:05:00',7.59),('8902','2013-07-16','12:10:00',7.64),('8902','2013-07-16','12:15:00',7.63),('8902','2013-07-16','12:20:00',7.72),('8902','2013-07-16','12:25:00',7.81),('8902','2013-07-16','12:30:00',7.82),('8902','2013-07-16','12:35:00',7.83),('8902','2013-07-16','12:40:00',7.82),('8902','2013-07-16','12:45:00',7.85),('8902','2013-07-16','12:50:00',7.89),('8902','2013-07-16','12:55:00',7.93),('8902','2013-07-16','13:00:00',7.87),('8902','2013-07-16','13:05:00',7.85),('8902','2013-07-16','13:10:00',7.93),('8902','2013-07-16','13:15:00',7.88),('8902','2013-07-16','13:20:00',7.81),('8902','2013-07-16','13:25:00',7.75),('8902','2013-07-16','13:30:00',7.81),('8902','2013-07-16','13:35:00',7.73),('8902','2013-07-16','13:40:00',7.74),('8902','2013-07-16','13:45:00',7.81),('8902','2013-07-16','13:50:00',7.85),('8902','2013-07-16','13:55:00',7.85),('8902','2013-07-16','14:00:00',7.87),('8902','2013-07-16','14:05:00',7.82),('8902','2013-07-16','14:10:00',7.74),('8902','2013-07-16','14:15:00',7.72),('8902','2013-07-16','14:20:00',7.68),('8902','2013-07-16','14:25:00',7.54),('8902','2013-07-16','14:30:00',7.54),('8902','2013-07-16','14:35:00',7.53),('8902','2013-07-16','14:40:00',7.9),('8902','2013-07-16','14:45:00',7.84),('8902','2013-07-16','14:50:00',7.57),('8902','2013-07-16','14:55:00',7.41),('8902','2013-07-16','15:00:00',7.32),('8902','2013-07-16','15:05:00',7.39),('8902','2013-07-16','15:10:00',7.46),('8902','2013-07-16','15:15:00',7.34),('8902','2013-07-16','15:20:00',7.36),('8902','2013-07-16','15:25:00',7.16),('8902','2013-07-16','15:30:00',7.1),('8902','2013-07-16','15:35:00',7.03),('8902','2013-07-16','15:40:00',6.04),('8902','2013-07-16','15:45:00',6.89),('8902','2013-07-16','15:50:00',6.76),('8902','2013-07-16','15:55:00',6.83),('8902','2013-07-16','16:00:00',6.7),('8902','2013-07-16','16:05:00',6.6),('8902','2013-07-16','16:10:00',6.53),('8902','2013-07-16','16:15:00',6.41),('8902','2013-07-16','16:20:00',6.26),('8902','2013-07-16','16:25:00',6.07),('8902','2013-07-16','16:30:00',5.99),('8902','2013-07-16','16:35:00',5.77),('8902','2013-07-16','16:40:00',5.72),('8902','2013-07-16','16:45:00',5.64),('8902','2013-07-16','16:50:00',5.36),('8902','2013-07-16','16:55:00',5.1),('8902','2013-07-16','17:00:00',5.11),('8902','2013-07-16','17:05:00',5.2),('8902','2013-07-16','17:10:00',5.11),('8902','2013-07-16','17:15:00',4.81),('8902','2013-07-16','17:20:00',4.66),('8902','2013-07-16','17:25:00',4.3),('8902','2013-07-16','17:30:00',4.29),('8902','2013-07-16','17:35:00',4.1),('8902','2013-07-16','17:40:00',3.93),('8902','2013-07-16','17:45:00',3.8),('8902','2013-07-16','17:50:00',3.72),('8902','2013-07-16','17:55:00',3.45),('8902','2013-07-16','18:00:00',3.21),('8902','2013-07-16','18:05:00',3.02),('8902','2013-07-16','18:10:00',3.01),('8902','2013-07-16','18:15:00',2.84),('8902','2013-07-16','18:20:00',2.66),('8902','2013-07-16','18:25:00',2.46),('8902','2013-07-16','18:30:00',2.3),('8902','2013-07-16','18:35:00',2.12),('8902','2013-07-16','18:40:00',1.96),('8902','2013-07-16','18:45:00',1.79),('8902','2013-07-16','18:50:00',1.62),('8902','2013-07-16','18:55:00',1.43),('8902','2013-07-16','19:00:00',1.29),('8902','2013-07-16','19:05:00',1.16),('8902','2013-07-16','19:10:00',1.01),('8902','2013-07-15','07:35:00',1.2),('8902','2013-07-15','07:40:00',1.36),('8902','2013-07-15','07:45:00',1.51),('8902','2013-07-15','07:50:00',1.65),('8902','2013-07-15','07:55:00',1.78),('8902','2013-07-15','08:00:00',1.92),('8902','2013-07-15','08:05:00',2.07),('8902','2013-07-15','08:10:00',2.23),('8902','2013-07-15','08:15:00',2.4),('8902','2013-07-15','08:20:00',2.55),('8902','2013-07-15','08:25:00',2.71),('8902','2013-07-15','08:30:00',2.88),('8902','2013-07-15','08:35:00',3.04),('8902','2013-07-15','08:40:00',3.16),('8902','2013-07-15','08:45:00',3.3),('8902','2013-07-15','08:50:00',3.47),('8902','2013-07-15','08:55:00',3.65),('8902','2013-07-15','09:00:00',3.79),('8902','2013-07-15','09:05:00',3.91),('8902','2013-07-15','09:10:00',4.05),('8902','2013-07-15','09:15:00',4.19),('8902','2013-07-15','09:20:00',4.32),('8902','2013-07-15','09:25:00',4.48),('8902','2013-07-15','09:30:00',4.61),('8902','2013-07-15','09:35:00',4.74),('8902','2013-07-15','09:40:00',4.89),('8902','2013-07-15','09:45:00',5.04),('8902','2013-07-15','09:50:00',5.2),('8902','2013-07-15','09:55:00',5.32),('8902','2013-07-15','10:00:00',5.44),('8902','2013-07-15','10:05:00',5.6),('8902','2013-07-15','10:10:00',5.73),('8902','2013-07-15','10:15:00',5.83),('8902','2013-07-15','10:20:00',5.9),('8902','2013-07-15','10:25:00',6.01),('8902','2013-07-15','10:30:00',6.15),('8902','2013-07-15','10:35:00',5.36),('8902','2013-07-15','10:40:00',6.33),('8902','2013-07-15','10:45:00',6.4),('8902','2013-07-15','10:50:00',6.51),('8902','2013-07-15','10:55:00',6.59),('8902','2013-07-15','11:00:00',6.67),('8902','2013-07-15','11:05:00',6.75),('8902','2013-07-15','11:10:00',6.87),('8902','2013-07-15','11:15:00',6.92),('8902','2013-07-15','11:20:00',6.97),('8902','2013-07-15','11:25:00',7.06),('8902','2013-07-15','11:30:00',7.16),('8902','2013-07-15','11:35:00',7.19),('8902','2013-07-15','11:40:00',7.27),('8902','2013-07-15','11:45:00',7.36),('8902','2013-07-15','11:50:00',7.47),('8902','2013-07-15','11:55:00',7.55),('8902','2013-07-15','12:00:00',7.56),('8902','2013-07-15','12:05:00',7.58),('8902','2013-07-15','12:10:00',7.6),('8902','2013-07-15','12:15:00',7.65),('8902','2013-07-15','12:20:00',7.7),('8902','2013-07-15','12:25:00',7.73),('8902','2013-07-15','12:30:00',7.73),('8902','2013-07-15','12:35:00',7.74),('8902','2013-07-15','12:40:00',7.71),('8902','2013-07-15','12:45:00',7.68),('8902','2013-07-15','12:50:00',7.69),('8902','2013-07-15','12:55:00',7.66),('8902','2013-07-15','13:00:00',7.6),('8902','2013-07-15','13:05:00',7.7),('8902','2013-07-15','13:10:00',7.75),('8902','2013-07-15','13:15:00',7.79),('8902','2013-07-15','13:20:00',7.73),('8902','2013-07-15','13:25:00',7.7),('8902','2013-07-15','13:30:00',7.69),('8902','2013-07-15','13:35:00',7.72),('8902','2013-07-15','13:40:00',7.75),('8902','2013-07-15','13:45:00',7.89),('8902','2013-07-15','13:50:00',8.06),('8902','2013-07-15','13:55:00',7.9),('8902','2013-07-15','14:00:00',7.67),('8902','2013-07-15','14:05:00',7.66),('8902','2013-07-15','14:10:00',7.74),('8902','2013-07-15','14:15:00',7.54),('8902','2013-07-15','14:20:00',2.18),('8902','2013-07-15','14:25:00',6.84),('8902','2013-07-15','14:30:00',7.94),('8902','2013-07-15','14:35:00',7.8),('8902','2013-07-15','14:40:00',7.75),('8902','2013-07-15','14:45:00',7.65),('8902','2013-07-15','14:50:00',7.67),('8902','2013-07-15','14:55:00',7.64),('8902','2013-07-15','15:00:00',7.59),('8902','2013-07-15','15:05:00',7.43),('8902','2013-07-15','15:10:00',7.31),('8902','2013-07-15','15:15:00',7.23),('8902','2013-07-15','15:20:00',7.23),('8902','2013-07-15','15:25:00',7.11),('8902','2013-07-15','15:30:00',7.13),('8902','2013-07-15','15:35:00',7.17),('8902','2013-07-15','15:40:00',7.04),('8902','2013-07-15','15:45:00',4.66),('8902','2013-07-15','15:50:00',6.75),('8902','2013-07-15','15:55:00',4.74),('8902','2013-07-15','16:00:00',4.95),('8902','2013-07-15','16:05:00',1.45),('8902','2013-07-15','16:10:00',6.17),('8902','2013-07-15','16:15:00',5.99),('8902','2013-07-15','16:20:00',4.63),('8902','2013-07-15','16:25:00',4.35),('8902','2013-07-15','16:30:00',2.72),('8902','2013-07-15','16:35:00',1.6),('8902','2013-07-15','16:40:00',1.53),('8902','2013-07-15','16:45:00',2.62),('8902','2013-07-15','16:50:00',2.03),('8902','2013-07-15','16:55:00',2.53),('8902','2013-07-15','17:00:00',5.13),('8902','2013-07-15','17:05:00',5.39),('8902','2013-07-15','17:10:00',5.43),('8902','2013-07-15','17:15:00',5.23),('8902','2013-07-15','17:20:00',4.09),('8902','2013-07-15','17:25:00',2.78),('8902','2013-07-15','17:30:00',2.9),('8902','2013-07-15','17:35:00',2.22),('8902','2013-07-15','17:40:00',3.41),('8902','2013-07-15','17:45:00',4.07),('8902','2013-07-15','17:50:00',3.86),('8902','2013-07-15','17:55:00',3.33),('8902','2013-07-15','18:00:00',2.95),('8902','2013-07-15','18:05:00',1.89),('8902','2013-07-15','18:10:00',2.24),('8902','2013-07-15','18:15:00',2.77),('8902','2013-07-15','18:20:00',2.53),('8902','2013-07-15','18:25:00',2.42),('8902','2013-07-15','18:30:00',2.26),('8902','2013-07-15','18:35:00',2.02),('8902','2013-07-15','18:40:00',1.8),('8902','2013-07-15','18:45:00',1.68),('8902','2013-07-15','18:50:00',1.53),('8902','2013-07-15','18:55:00',1.35),('8902','2013-07-15','19:00:00',1.18),('8902','2013-07-15','19:05:00',1.05),('8902','2013-07-14','07:35:00',1.22),('8902','2013-07-14','07:40:00',1.37),('8902','2013-07-14','07:45:00',1.52),('8902','2013-07-14','07:50:00',1.67),('8902','2013-07-14','07:55:00',1.82),('8902','2013-07-14','08:00:00',1.99),('8902','2013-07-14','08:05:00',2.14),('8902','2013-07-14','08:10:00',2.31),('8902','2013-07-14','08:15:00',2.48),('8902','2013-07-14','08:20:00',2.65),('8902','2013-07-14','08:25:00',2.81),('8902','2013-07-14','08:30:00',2.97),('8902','2013-07-14','08:35:00',3.14),('8902','2013-07-14','08:40:00',3.31),('8902','2013-07-14','08:45:00',3.46),('8902','2013-07-14','08:50:00',3.62),('8902','2013-07-14','08:55:00',3.79),('8902','2013-07-14','09:00:00',3.94),('8902','2013-07-14','09:05:00',4.08),('8902','2013-07-14','09:10:00',4.24),('8902','2013-07-14','09:15:00',4.39),('8902','2013-07-14','09:20:00',4.53),('8902','2013-07-14','09:25:00',4.68),('8902','2013-07-14','09:30:00',4.82),('8902','2013-07-14','09:35:00',4.94),('8902','2013-07-14','09:40:00',5.08),('8902','2013-07-14','09:45:00',5.2),('8902','2013-07-14','09:50:00',5.34),('8902','2013-07-14','09:55:00',5.44),('8902','2013-07-14','10:00:00',5.53),('8902','2013-07-14','10:05:00',5.63),('8902','2013-07-14','10:10:00',5.75),('8902','2013-07-14','10:15:00',5.86),('8902','2013-07-14','10:20:00',5.95),('8902','2013-07-14','10:25:00',6.06),('8902','2013-07-14','10:30:00',6.15),('8902','2013-07-14','10:35:00',6.21),('8902','2013-07-14','10:40:00',6.3),('8902','2013-07-14','10:45:00',6.38),('8902','2013-07-14','10:50:00',6.51),('8902','2013-07-14','10:55:00',6.58),('8902','2013-07-14','11:00:00',6.68),('8902','2013-07-14','11:05:00',6.78),('8902','2013-07-14','11:10:00',6.85),('8902','2013-07-14','11:15:00',6.91),('8902','2013-07-14','11:20:00',7),('8902','2013-07-14','11:25:00',7.06),('8902','2013-07-14','11:30:00',7.08),('8902','2013-07-14','11:35:00',7.13),('8902','2013-07-14','11:40:00',7.17),('8902','2013-07-14','11:45:00',7.17),('8902','2013-07-14','11:50:00',7.27),('8902','2013-07-14','11:55:00',7.34),('8902','2013-07-14','12:00:00',7.49),('8902','2013-07-14','12:05:00',7.47),('8902','2013-07-14','12:10:00',7.49),('8902','2013-07-14','12:15:00',7.57),('8902','2013-07-14','12:20:00',7.63),('8902','2013-07-14','12:25:00',7.63),('8902','2013-07-14','12:30:00',7.7),('8902','2013-07-14','12:35:00',7.66),('8902','2013-07-14','12:40:00',7.69),('8902','2013-07-14','12:45:00',7.66),('8902','2013-07-14','12:50:00',7.73),('8902','2013-07-14','12:55:00',7.77),('8902','2013-07-14','13:00:00',7.81),('8902','2013-07-14','13:05:00',7.24),('8902','2013-07-14','13:10:00',7.98),('8902','2013-07-14','13:15:00',7.84),('8902','2013-07-14','13:20:00',7.83),('8902','2013-07-14','13:25:00',8.11),('8902','2013-07-14','13:30:00',8.28),('8902','2013-07-14','13:35:00',6.71),('8902','2013-07-14','13:40:00',2.18),('8902','2013-07-14','13:45:00',3.34),('8902','2013-07-14','13:50:00',8.82),('8902','2013-07-14','13:55:00',8.6),('8902','2013-07-14','14:00:00',8.52),('8902','2013-07-14','14:05:00',5.19),('8902','2013-07-14','14:10:00',1.91),('8902','2013-07-14','14:15:00',3.11),('8902','2013-07-14','14:20:00',5.83),('8902','2013-07-14','14:25:00',8.36),('8902','2013-07-14','14:30:00',5.46),('8902','2013-07-14','14:35:00',6.34),('8902','2013-07-14','14:40:00',8.08),('8902','2013-07-14','14:45:00',7.96),('8902','2013-07-14','14:50:00',7.94),('8902','2013-07-14','14:55:00',7.92),('8902','2013-07-14','15:00:00',7.78),('8902','2013-07-14','15:05:00',7.65),('8902','2013-07-14','15:10:00',7.58),('8902','2013-07-14','15:15:00',6.61),('8902','2013-07-14','15:20:00',6.93),('8902','2013-07-14','15:25:00',6.84),('8902','2013-07-14','15:30:00',6.36),('8902','2013-07-14','15:35:00',4.29),('8902','2013-07-14','15:40:00',7.29),('8902','2013-07-14','15:45:00',6.94),('8902','2013-07-14','15:50:00',6.99),('8902','2013-07-14','15:55:00',6.78),('8902','2013-07-14','16:00:00',6.62),('8902','2013-07-14','16:05:00',6.56),('8902','2013-07-14','16:10:00',6.39),('8902','2013-07-14','16:15:00',6.3),('8902','2013-07-14','16:20:00',6.08),('8902','2013-07-14','16:25:00',5.93),('8902','2013-07-14','16:30:00',5.82),('8902','2013-07-14','16:35:00',5.8),('8902','2013-07-14','16:40:00',5.53),('8902','2013-07-14','16:45:00',5.5),('8902','2013-07-14','16:50:00',5.38),('8902','2013-07-14','16:55:00',5.25),('8902','2013-07-14','17:00:00',5.04),('8902','2013-07-14','17:05:00',5.01),('8902','2013-07-14','17:10:00',4.83),('8902','2013-07-14','17:15:00',4.72),('8902','2013-07-14','17:20:00',4.59),('8902','2013-07-14','17:25:00',4.4),('8902','2013-07-14','17:30:00',4.25),('8902','2013-07-14','17:35:00',4.13),('8902','2013-07-14','17:40:00',3.93),('8902','2013-07-14','17:45:00',3.72),('8902','2013-07-14','17:50:00',3.59),('8902','2013-07-14','17:55:00',3.39),('8902','2013-07-14','18:00:00',3.18),('8902','2013-07-14','18:05:00',3.04),('8902','2013-07-14','18:10:00',2.89),('8902','2013-07-14','18:15:00',2.72),('8902','2013-07-14','18:20:00',2.56),('8902','2013-07-14','18:25:00',2.38),('8902','2013-07-14','18:30:00',2.22),('8902','2013-07-14','18:35:00',2.01),('8902','2013-07-14','18:40:00',1.9),('8902','2013-07-14','18:45:00',1.75),('8902','2013-07-14','18:50:00',1.6),('8902','2013-07-14','18:55:00',1.44),('8902','2013-07-14','19:00:00',1.3),('8902','2013-07-14','19:05:00',1.17),('8902','2013-07-14','19:10:00',1.03),('8902','2013-07-13','07:40:00',1.15),('8902','2013-07-13','07:45:00',1.36),('8902','2013-07-13','07:50:00',1.73),('8902','2013-07-13','07:55:00',2.05),('8902','2013-07-13','08:00:00',1.86),('8902','2013-07-13','08:05:00',2.84),('8902','2013-07-13','08:10:00',2.97),('8902','2013-07-13','08:15:00',2.83),('8902','2013-07-13','08:20:00',3.52),('8902','2013-07-13','08:25:00',2.73),('8902','2013-07-13','08:30:00',1.73),('8902','2013-07-13','08:35:00',2.08),('8902','2013-07-13','08:40:00',2.13),('8902','2013-07-13','08:45:00',1.77),('8902','2013-07-13','08:50:00',2.02),('8902','2013-07-13','08:55:00',2.26),('8902','2013-07-13','09:00:00',1.94),('8902','2013-07-13','09:05:00',2.14),('8902','2013-07-13','09:10:00',2.25),('8902','2013-07-13','09:15:00',3.04),('8902','2013-07-13','09:20:00',3.17),('8902','2013-07-13','09:25:00',3.89),('8902','2013-07-13','09:30:00',3.99),('8902','2013-07-13','09:35:00',3.49),('8902','2013-07-13','09:40:00',3.16),('8902','2013-07-13','09:45:00',3.19),('8902','2013-07-13','09:50:00',3.04),('8902','2013-07-13','09:55:00',3.19),('8902','2013-07-13','10:00:00',3.16),('8902','2013-07-13','10:05:00',3.33),('8902','2013-07-13','10:10:00',3.33),('8902','2013-07-13','10:15:00',3.61),('8902','2013-07-13','10:20:00',4.4),('8902','2013-07-13','10:25:00',4.75),('8902','2013-07-13','10:30:00',4.85),('8902','2013-07-13','10:35:00',6.68),('8902','2013-07-13','10:40:00',6.99),('8902','2013-07-13','10:45:00',5.75),('8902','2013-07-13','10:50:00',7.15),('8902','2013-07-13','10:55:00',6.53),('8902','2013-07-13','11:00:00',7.24),('8902','2013-07-13','11:05:00',5.47),('8902','2013-07-13','11:10:00',6.53),('8902','2013-07-13','11:15:00',6.84),('8902','2013-07-13','11:20:00',8.05),('8902','2013-07-13','11:25:00',7.58),('8902','2013-07-13','11:30:00',8.03),('8902','2013-07-13','11:35:00',7.92),('8902','2013-07-13','11:40:00',7.69),('8902','2013-07-13','11:45:00',6.49),('8902','2013-07-13','11:50:00',3.62),('8902','2013-07-13','11:55:00',2.86),('8902','2013-07-13','12:00:00',2.91),('8902','2013-07-13','12:05:00',3.21),('8902','2013-07-13','12:10:00',4.33),('8902','2013-07-13','12:15:00',7.39),('8902','2013-07-13','12:20:00',8.4),('8902','2013-07-13','12:25:00',5.75),('8902','2013-07-13','12:30:00',3.18),('8902','2013-07-13','12:35:00',6.18),('8902','2013-07-13','12:40:00',8.33),('8902','2013-07-13','12:45:00',8.45),('8902','2013-07-13','12:50:00',8.27),('8902','2013-07-13','12:55:00',2.99),('8902','2013-07-13','13:00:00',3.66),('8902','2013-07-13','13:05:00',8.88),('8902','2013-07-13','13:10:00',8.55),('8902','2013-07-13','13:15:00',8.3),('8902','2013-07-13','13:20:00',5.1),('8902','2013-07-13','13:25:00',8.64),('8902','2013-07-13','13:30:00',7.88),('8902','2013-07-13','13:35:00',8.21),('8902','2013-07-13','13:40:00',8.23),('8902','2013-07-13','13:45:00',8.15),('8902','2013-07-13','13:50:00',8.19),('8902','2013-07-13','13:55:00',8.14),('8902','2013-07-13','14:00:00',8.15),('8902','2013-07-13','14:05:00',8.25),('8902','2013-07-13','14:10:00',8.18),('8902','2013-07-13','14:15:00',8.1),('8902','2013-07-13','14:20:00',8.01),('8902','2013-07-13','14:25:00',8.01),('8902','2013-07-13','14:30:00',7.98),('8902','2013-07-13','14:35:00',7.86),('8902','2013-07-13','14:40:00',7.81),('8902','2013-07-13','14:45:00',7.67),('8902','2013-07-13','14:50:00',7.64),('8902','2013-07-13','14:55:00',7.7),('8902','2013-07-13','15:00:00',7.54),('8902','2013-07-13','15:05:00',7.52),('8902','2013-07-13','15:10:00',7.41),('8902','2013-07-13','15:15:00',7.33),('8902','2013-07-13','15:20:00',7.3),('8902','2013-07-13','15:25:00',7.2),('8902','2013-07-13','15:30:00',7.12),('8902','2013-07-13','15:35:00',7.02),('8902','2013-07-13','15:40:00',6.97),('8902','2013-07-13','15:45:00',6.87),('8902','2013-07-13','15:50:00',6.42),('8902','2013-07-13','15:55:00',6.81),('8902','2013-07-13','16:00:00',6.57),('8902','2013-07-13','16:05:00',6.62),('8902','2013-07-13','16:10:00',6.54),('8902','2013-07-13','16:15:00',6.44),('8902','2013-07-13','16:20:00',6.35),('8902','2013-07-13','16:25:00',5.69),('8902','2013-07-13','16:30:00',4.6),('8902','2013-07-13','16:35:00',5.95),('8902','2013-07-13','16:40:00',5.87),('8902','2013-07-13','16:45:00',5.57),('8902','2013-07-13','16:50:00',5.71),('8902','2013-07-13','16:55:00',5.18),('8902','2013-07-13','17:00:00',3.91),('8902','2013-07-13','17:05:00',4.66),('8902','2013-07-13','17:10:00',3.61),('8902','2013-07-13','17:15:00',4.85),('8902','2013-07-13','17:20:00',2.47),('8902','2013-07-13','17:25:00',4.15),('8902','2013-07-13','17:30:00',4.91),('8902','2013-07-13','17:35:00',4.29),('8902','2013-07-13','17:40:00',2.31),('8902','2013-07-13','17:45:00',1.94),('8902','2013-07-13','17:50:00',2.33),('8902','2013-07-13','17:55:00',3.04),('8902','2013-07-13','18:00:00',2.15),('8902','2013-07-13','18:05:00',1.42),('8902','2013-07-13','18:10:00',1.6),('8902','2013-07-13','18:40:00',1.21),('8902','2013-07-13','18:45:00',1.43),('8902','2013-07-13','18:50:00',1.36),('8902','2013-07-13','18:55:00',1.12),('8902','2013-07-13','19:10:00',1.21),('8902','2013-07-13','19:15:00',1.42),('8902','2013-07-13','19:20:00',1.47),('8902','2013-07-13','19:25:00',1.06),('8902','2013-07-12','07:25:00',1.09),('8902','2013-07-12','07:30:00',1.3),('8902','2013-07-12','07:35:00',1.29),('8902','2013-07-12','07:40:00',1.36),('8902','2013-07-12','07:45:00',1.47),('8902','2013-07-12','07:50:00',1.59),('8902','2013-07-12','07:55:00',1.74),('8902','2013-07-12','08:00:00',1.86),('8902','2013-07-12','08:05:00',2.02),('8902','2013-07-12','08:10:00',2.18),('8902','2013-07-12','08:15:00',2.35),('8902','2013-07-12','08:20:00',2.48),('8902','2013-07-12','08:25:00',2.64),('8902','2013-07-12','08:30:00',2.8),('8902','2013-07-12','08:35:00',2.94),('8902','2013-07-12','08:40:00',3.08),('8902','2013-07-12','08:45:00',3.23),('8902','2013-07-12','08:50:00',3.43),('8902','2013-07-12','08:55:00',3.59),('8902','2013-07-12','09:00:00',3.74),('8902','2013-07-12','09:05:00',3.89),('8902','2013-07-12','09:10:00',4),('8902','2013-07-12','09:15:00',4.15),('8902','2013-07-12','09:20:00',4.29),('8902','2013-07-12','09:25:00',4.52),('8902','2013-07-12','09:30:00',4.62),('8902','2013-07-12','09:35:00',4.69),('8902','2013-07-12','09:40:00',4.87),('8902','2013-07-12','09:45:00',4.8),('8902','2013-07-12','09:50:00',5.04),('8902','2013-07-12','09:55:00',5.21),('8902','2013-07-12','10:00:00',5.41),('8902','2013-07-12','10:05:00',5.56),('8902','2013-07-12','10:10:00',5.6),('8902','2013-07-12','10:15:00',5.77),('8902','2013-07-12','10:20:00',5.91),('8902','2013-07-12','10:25:00',6.1),('8902','2013-07-12','10:30:00',6.13),('8902','2013-07-12','10:35:00',5.98),('8902','2013-07-12','10:40:00',5.93),('8902','2013-07-12','10:45:00',5.05),('8902','2013-07-12','10:50:00',2.35),('8902','2013-07-12','10:55:00',5.32),('8902','2013-07-12','11:00:00',7.12),('8902','2013-07-12','11:05:00',7.12),('8902','2013-07-12','11:10:00',5.94),('8902','2013-07-12','11:15:00',7.48),('8902','2013-07-12','11:20:00',6.12),('8902','2013-07-12','11:25:00',4.07),('8902','2013-07-12','11:30:00',7.46),('8902','2013-07-12','11:35:00',7.45),('8902','2013-07-12','11:40:00',7.32),('8902','2013-07-12','11:45:00',4.79),('8902','2013-07-12','11:50:00',2.61),('8902','2013-07-12','11:55:00',5.88),('8902','2013-07-12','12:00:00',7.43),('8902','2013-07-12','12:05:00',2.47),('8902','2013-07-12','12:10:00',6.65),('8902','2013-07-12','12:15:00',7.4),('8902','2013-07-12','12:20:00',2.58),('8902','2013-07-12','12:25:00',7.36),('8902','2013-07-12','12:30:00',6.97),('8902','2013-07-12','12:35:00',6.4),('8902','2013-07-12','12:40:00',8.07),('8902','2013-07-12','12:45:00',8.3),('8902','2013-07-12','12:50:00',7.89),('8902','2013-07-12','12:55:00',7.84),('8902','2013-07-12','13:00:00',2.92),('8902','2013-07-12','13:05:00',7.66),('8902','2013-07-12','13:10:00',8.56),('8902','2013-07-12','13:15:00',6.81),('8902','2013-07-12','13:20:00',8.32),('8902','2013-07-12','13:25:00',8.16),('8902','2013-07-12','13:30:00',7.91),('8902','2013-07-12','13:35:00',8.07),('8902','2013-07-12','13:40:00',8.07),('8902','2013-07-12','13:45:00',7.99),('8902','2013-07-12','13:50:00',8.02),('8902','2013-07-12','13:55:00',7.99),('8902','2013-07-12','14:00:00',8),('8902','2013-07-12','14:05:00',8.02),('8902','2013-07-12','14:10:00',7.99),('8902','2013-07-12','14:15:00',7.96),('8902','2013-07-12','14:20:00',7.91),('8902','2013-07-12','14:25:00',7.87),('8902','2013-07-12','14:30:00',7.85),('8902','2013-07-12','14:35:00',7.8),('8902','2013-07-12','14:40:00',7.77),('8902','2013-07-12','14:45:00',7.78),('8902','2013-07-12','14:50:00',7.78),('8902','2013-07-12','14:55:00',7.67),('8902','2013-07-12','15:00:00',7.65),('8902','2013-07-12','15:05:00',7.67),('8902','2013-07-12','15:10:00',7.59),('8902','2013-07-12','15:15:00',7.54),('8902','2013-07-12','15:20:00',7.21),('8902','2013-07-12','15:25:00',7.43),('8902','2013-07-12','15:30:00',7.28),('8902','2013-07-12','15:35:00',7.39),('8902','2013-07-12','15:40:00',7.27),('8902','2013-07-12','15:45:00',7.16),('8902','2013-07-12','15:50:00',7.05),('8902','2013-07-12','15:55:00',6.98),('8902','2013-07-12','16:00:00',6.9),('8902','2013-07-12','16:05:00',6.76),('8902','2013-07-12','16:10:00',6.65),('8902','2013-07-12','16:15:00',6.5),('8902','2013-07-12','16:20:00',6.37),('8902','2013-07-12','16:25:00',6.39),('8902','2013-07-12','16:30:00',6.27),('8902','2013-07-12','16:35:00',6.1),('8902','2013-07-12','16:40:00',5.86),('8902','2013-07-12','16:45:00',5.78),('8902','2013-07-12','16:50:00',5.65),('8902','2013-07-12','16:55:00',5.51),('8902','2013-07-12','17:00:00',5.26),('8902','2013-07-12','17:05:00',5.12),('8902','2013-07-12','17:10:00',5.11),('8902','2013-07-12','17:15:00',4.91),('8902','2013-07-12','17:20:00',4.65),('8902','2013-07-12','17:25:00',4.64),('8902','2013-07-12','17:30:00',4.42),('8902','2013-07-12','17:35:00',4.24),('8902','2013-07-12','17:40:00',4.16),('8902','2013-07-12','17:45:00',3.98),('8902','2013-07-12','17:50:00',3.82),('8902','2013-07-12','17:55:00',3.74),('8902','2013-07-12','18:00:00',3.42),('8902','2013-07-12','18:05:00',3.19),('8902','2013-07-12','18:10:00',3.13),('8902','2013-07-12','18:15:00',2.95),('8902','2013-07-12','18:20:00',2.85),('8902','2013-07-12','18:25:00',2.66),('8902','2013-07-12','18:30:00',2.41),('8902','2013-07-12','18:35:00',2.22),('8902','2013-07-12','18:40:00',1.5),('8902','2013-07-12','18:45:00',1.01),('8902','2013-07-12','18:50:00',1.46),('8902','2013-07-12','18:55:00',1.66),('8902','2013-07-12','19:00:00',1.53),('8902','2013-07-12','19:05:00',1.35),('8902','2013-07-12','19:10:00',1.14),('8902','2013-07-11','07:20:00',1.02),('8902','2013-07-11','07:25:00',1.15),('8902','2013-07-11','07:30:00',1.22),('8902','2013-07-11','07:35:00',1.28),('8902','2013-07-11','07:40:00',1.06),('8902','2013-07-11','07:45:00',1.19),('8902','2013-07-11','07:50:00',1.35),('8902','2013-07-11','07:55:00',1.04),('8902','2013-07-11','08:05:00',1.21),('8902','2013-07-11','08:10:00',2.02),('8902','2013-07-11','08:15:00',2.64),('8902','2013-07-11','08:20:00',3.18),('8902','2013-07-11','08:25:00',1.71),('8902','2013-07-11','08:30:00',1.31),('8902','2013-07-11','08:35:00',1.7),('8902','2013-07-11','08:40:00',2.14),('8902','2013-07-11','08:45:00',2.44),('8902','2013-07-11','08:50:00',1.89),('8902','2013-07-11','08:55:00',1.43),('8902','2013-07-11','09:00:00',1.39),('8902','2013-07-11','09:05:00',1.7),('8902','2013-07-11','09:10:00',2.24),('8902','2013-07-11','09:15:00',2.87),('8902','2013-07-11','09:20:00',3.24),('8902','2013-07-11','09:25:00',4.57),('8902','2013-07-11','09:30:00',2.98),('8902','2013-07-11','09:35:00',3.74),('8902','2013-07-11','09:40:00',3.51),('8902','2013-07-11','09:45:00',4.8),('8902','2013-07-11','09:50:00',5.12),('8902','2013-07-11','09:55:00',5.13),('8902','2013-07-11','10:00:00',4.48),('8902','2013-07-11','10:05:00',5.26),('8902','2013-07-11','10:10:00',5.46),('8902','2013-07-11','10:15:00',4.7),('8902','2013-07-11','10:20:00',2.15),('8902','2013-07-11','10:25:00',3.81),('8902','2013-07-11','10:30:00',3.97),('8902','2013-07-11','10:35:00',4.88),('8902','2013-07-11','10:40:00',2.16),('8902','2013-07-11','10:45:00',1.65),('8902','2013-07-11','10:50:00',2.17),('8902','2013-07-11','10:55:00',5.47),('8902','2013-07-11','11:00:00',7.77),('8902','2013-07-11','11:05:00',3.97),('8902','2013-07-11','11:10:00',2.26),('8902','2013-07-11','11:15:00',6.24),('8902','2013-07-11','11:20:00',2.99),('8902','2013-07-11','11:25:00',5.95),('8902','2013-07-11','11:30:00',7.35),('8902','2013-07-11','11:35:00',6.97),('8902','2013-07-11','11:40:00',2.53),('8902','2013-07-11','11:45:00',4.22),('8902','2013-07-11','11:50:00',3.31),('8902','2013-07-11','11:55:00',8.17),('8902','2013-07-11','12:00:00',8.09),('8902','2013-07-11','12:05:00',8.16),('8902','2013-07-11','12:10:00',5.16),('8902','2013-07-11','12:15:00',4.62),('8902','2013-07-11','12:20:00',8.33),('8902','2013-07-11','12:25:00',8.54),('8902','2013-07-11','12:30:00',6.36),('8902','2013-07-11','12:35:00',8.89),('8902','2013-07-11','12:40:00',3.8),('8902','2013-07-11','12:45:00',8.29),('8902','2013-07-11','12:50:00',4.54),('8902','2013-07-11','12:55:00',8.08),('8902','2013-07-11','13:00:00',7.93),('8902','2013-07-11','13:05:00',8.34),('8902','2013-07-11','13:10:00',8.18),('8902','2013-07-11','13:15:00',7.75),('8902','2013-07-11','13:20:00',8.18),('8902','2013-07-11','13:25:00',8.14),('8902','2013-07-11','13:30:00',8.17),('8902','2013-07-11','13:35:00',8.14),('8902','2013-07-11','13:40:00',8.12),('8902','2013-07-11','13:45:00',8.06),('8902','2013-07-11','13:50:00',4.97),('8902','2013-07-11','13:55:00',8.35),('8902','2013-07-11','14:00:00',8.38),('8902','2013-07-11','14:05:00',7.93),('8902','2013-07-11','14:10:00',6.58),('8902','2013-07-11','14:15:00',5.83),('8902','2013-07-11','14:20:00',8.73),('8902','2013-07-11','14:25:00',8.23),('8902','2013-07-11','14:30:00',7.97),('8902','2013-07-11','14:35:00',7.53),('8902','2013-07-11','14:40:00',7.64),('8902','2013-07-11','14:45:00',7.54),('8902','2013-07-11','14:50:00',7.54),('8902','2013-07-11','14:55:00',7.6),('8902','2013-07-11','15:00:00',7.46),('8902','2013-07-11','15:05:00',7.41),('8902','2013-07-11','15:10:00',7.48),('8902','2013-07-11','15:15:00',7.36),('8902','2013-07-11','15:20:00',7.26),('8902','2013-07-11','15:25:00',7.2),('8902','2013-07-11','15:30:00',7.11),('8902','2013-07-11','15:35:00',7.04),('8902','2013-07-11','15:40:00',7.1),('8902','2013-07-11','15:45:00',6.92),('8902','2013-07-11','15:50:00',6.81),('8902','2013-07-11','15:55:00',6.6),('8902','2013-07-11','16:00:00',6.61),('8902','2013-07-11','16:05:00',6.47),('8902','2013-07-11','16:10:00',6.39),('8902','2013-07-11','16:15:00',6.29),('8902','2013-07-11','16:20:00',6.17),('8902','2013-07-11','16:25:00',6.11),('8902','2013-07-11','16:30:00',5.96),('8902','2013-07-11','16:35:00',5.87),('8902','2013-07-11','16:40:00',5.7),('8902','2013-07-11','16:45:00',5.67),('8902','2013-07-11','16:50:00',5.51),('8902','2013-07-11','16:55:00',5.26),('8902','2013-07-11','17:00:00',5.04),('8902','2013-07-11','17:05:00',5.04),('8902','2013-07-11','17:10:00',4.9),('8902','2013-07-11','17:15:00',4.78),('8902','2013-07-11','17:20:00',4.6),('8902','2013-07-11','17:25:00',4.36),('8902','2013-07-11','17:30:00',4.27),('8902','2013-07-11','17:35:00',4.11),('8902','2013-07-11','17:40:00',3.99),('8902','2013-07-11','17:45:00',3.75),('8902','2013-07-11','17:50:00',3.6),('8902','2013-07-11','17:55:00',3.48),('8902','2013-07-11','18:00:00',3.26),('8902','2013-07-11','18:05:00',3.16),('8902','2013-07-11','18:10:00',2.97),('8902','2013-07-11','18:15:00',2.77),('8902','2013-07-11','18:20:00',2.61),('8902','2013-07-11','18:25:00',2.46),('8902','2013-07-11','18:30:00',2.29),('8902','2013-07-11','18:35:00',2.11),('8902','2013-07-11','18:40:00',1.93),('8902','2013-07-11','18:45:00',1.75),('8902','2013-07-11','18:50:00',1.58),('8902','2013-07-11','18:55:00',1.44),('8902','2013-07-11','19:00:00',1.3),('8902','2013-07-11','19:05:00',1.18),('8902','2013-07-11','19:10:00',1.04),('8902','2013-07-10','07:30:00',1.08),('8902','2013-07-10','07:35:00',1.27),('8902','2013-07-10','07:40:00',1.41),('8902','2013-07-10','07:45:00',1.51),('8902','2013-07-10','07:50:00',1.64),('8902','2013-07-10','07:55:00',1.8),('8902','2013-07-10','08:00:00',1.94),('8902','2013-07-10','08:05:00',2.09),('8902','2013-07-10','08:10:00',2.22),('8902','2013-07-10','08:15:00',2.37),('8902','2013-07-10','08:20:00',2.56),('8902','2013-07-10','08:25:00',2.72),('8902','2013-07-10','08:30:00',2.85),('8902','2013-07-10','08:35:00',3),('8902','2013-07-10','08:40:00',3.09),('8902','2013-07-10','08:45:00',3.34),('8902','2013-07-10','08:50:00',3.46),('8902','2013-07-10','08:55:00',3.54),('8902','2013-07-10','09:00:00',3.8),('8902','2013-07-10','09:05:00',3.95),('8902','2013-07-10','09:10:00',4.05),('8902','2013-07-10','09:15:00',4.27),('8902','2013-07-10','09:20:00',4.6),('8902','2013-07-10','09:25:00',4.6),('8902','2013-07-10','09:30:00',4.42),('8902','2013-07-10','09:35:00',2.93),('8902','2013-07-10','09:40:00',5.15),('8902','2013-07-10','09:45:00',5.28),('8902','2013-07-10','09:50:00',3.83),('8902','2013-07-10','09:55:00',2.7),('8902','2013-07-10','10:00:00',2.72),('8902','2013-07-10','10:05:00',4.58),('8902','2013-07-10','10:10:00',4.58),('8902','2013-07-10','10:15:00',5.97),('8902','2013-07-10','10:20:00',6.14),('8902','2013-07-10','10:25:00',5.95),('8902','2013-07-10','10:30:00',5.48),('8902','2013-07-10','10:35:00',2.58),('8902','2013-07-10','10:40:00',2.05),('8902','2013-07-10','10:45:00',3.14),('8902','2013-07-10','10:50:00',5.91),('8902','2013-07-10','10:55:00',7.18),('8902','2013-07-10','11:00:00',6.71),('8902','2013-07-10','11:05:00',2.7),('8902','2013-07-10','11:10:00',6.7),('8902','2013-07-10','11:15:00',6.56),('8902','2013-07-10','11:20:00',6.14),('8902','2013-07-10','11:25:00',6.66),('8902','2013-07-10','11:30:00',7.68),('8902','2013-07-10','11:35:00',7.33),('8902','2013-07-10','11:40:00',6.23),('8902','2013-07-10','11:45:00',6.88),('8902','2013-07-10','11:50:00',6.73),('8902','2013-07-10','11:55:00',6.06),('8902','2013-07-10','12:00:00',3.58),('8902','2013-07-10','12:05:00',5.67),('8902','2013-07-10','12:10:00',2.38),('8902','2013-07-10','12:15:00',3.87),('8902','2013-07-10','12:20:00',8.54),('8902','2013-07-10','12:25:00',8.26),('8902','2013-07-10','12:30:00',8.27),('8902','2013-07-10','12:35:00',8.6),('8902','2013-07-10','12:40:00',8.42),('8902','2013-07-10','12:45:00',8.14),('8902','2013-07-10','12:50:00',6.17),('8902','2013-07-10','12:55:00',8.2),('8902','2013-07-10','13:00:00',6.79),('8902','2013-07-10','13:05:00',2.92),('8902','2013-07-10','13:10:00',6.8),('8902','2013-07-10','13:15:00',8.68),('8902','2013-07-10','13:20:00',8.4),('8902','2013-07-10','13:25:00',8.34),('8902','2013-07-10','13:30:00',8.44),('8902','2013-07-10','13:35:00',8.65),('8902','2013-07-10','13:40:00',8.33),('8902','2013-07-10','13:45:00',8.38),('8902','2013-07-10','13:50:00',5.55),('8902','2013-07-10','13:55:00',2.7),('8902','2013-07-10','14:00:00',5.44),('8902','2013-07-10','14:05:00',8.05),('8902','2013-07-10','14:10:00',7.77),('8902','2013-07-10','14:15:00',8.45),('8902','2013-07-10','14:20:00',7.6),('8902','2013-07-10','14:25:00',8.1),('8902','2013-07-10','14:30:00',6.63),('8902','2013-07-10','14:35:00',8.08),('8902','2013-07-10','14:40:00',7.92),('8902','2013-07-10','14:45:00',8.06),('8902','2013-07-10','14:50:00',7.84),('8902','2013-07-10','14:55:00',4.55),('8902','2013-07-10','15:00:00',7.45),('8902','2013-07-10','15:05:00',6.57),('8902','2013-07-10','15:10:00',4.59),('8902','2013-07-10','15:15:00',5.37),('8902','2013-07-10','15:20:00',5.49),('8902','2013-07-10','15:25:00',4.89),('8902','2013-07-10','15:30:00',5.96),('8902','2013-07-10','15:35:00',7.34),('8902','2013-07-10','15:40:00',5.59),('8902','2013-07-10','15:45:00',4.82),('8902','2013-07-10','15:50:00',5.86),('8902','2013-07-10','15:55:00',3.49),('8902','2013-07-10','16:00:00',4.89),('8902','2013-07-10','16:05:00',5.65),('8902','2013-07-10','16:10:00',6.51),('8902','2013-07-10','16:15:00',6.11),('8902','2013-07-10','16:20:00',6.97),('8902','2013-07-10','16:25:00',6.28),('8902','2013-07-10','16:30:00',6.87),('8902','2013-07-10','16:35:00',5.37),('8902','2013-07-10','16:40:00',6.24),('8902','2013-07-10','16:45:00',5.06),('8902','2013-07-10','16:50:00',6.22),('8902','2013-07-10','16:55:00',5.07),('8902','2013-07-10','17:00:00',4.72),('8902','2013-07-10','17:05:00',5.61),('8902','2013-07-10','17:10:00',5.42),('8902','2013-07-10','17:15:00',4.49),('8902','2013-07-10','17:20:00',4.78),('8902','2013-07-10','17:25:00',2.63),('8902','2013-07-10','17:30:00',4.36),('8902','2013-07-10','17:35:00',4.48),('8902','2013-07-10','17:40:00',3.46),('8902','2013-07-10','17:45:00',4.19),('8902','2013-07-10','17:50:00',2.86),('8902','2013-07-10','17:55:00',3.67),('8902','2013-07-10','18:00:00',2.74),('8902','2013-07-10','18:05:00',2.95),('8902','2013-07-10','18:10:00',2.96),('8902','2013-07-10','18:15:00',3.08),('8902','2013-07-10','18:20:00',2.38),('8902','2013-07-10','18:25:00',2.51),('8902','2013-07-10','18:30:00',2.57),('8902','2013-07-10','18:35:00',2.17),('8902','2013-07-10','18:40:00',1.26),('8902','2013-07-10','18:45:00',1.34),('8902','2013-07-10','18:50:00',1.02),('8902','2013-07-10','19:05:00',1.01),('8902','2014-05-02','07:35:00',1.18),('8902','2014-05-02','07:40:00',1.38),('8902','2014-05-02','07:45:00',1.58),('8902','2014-05-02','07:50:00',1.78),('8902','2014-05-02','07:55:00',2.01),('8902','2014-05-02','08:00:00',1.99),('8902','2014-05-02','08:05:00',2.54),('8902','2014-05-02','08:10:00',2.72),('8902','2014-05-02','08:15:00',2.82),('8902','2014-05-02','08:20:00',2.22),('8902','2014-05-02','08:25:00',1.84),('8902','2014-05-02','08:30:00',1.87),('8902','2014-05-02','08:35:00',1.84),('8902','2014-05-02','08:40:00',2.49),('8902','2014-05-02','08:45:00',3.82),('8902','2014-05-02','08:50:00',4.33),('8902','2014-05-02','08:55:00',4.56),('8902','2014-05-02','09:00:00',5.19),('8902','2014-05-02','09:05:00',5.25),('8902','2014-05-02','09:10:00',2.98),('8902','2014-05-02','09:15:00',2.94),('8902','2014-05-02','09:20:00',5.25),('8902','2014-05-02','09:25:00',5.74),('8902','2014-05-02','09:30:00',5.32),('8902','2014-05-02','09:35:00',4.13),('8902','2014-05-02','09:40:00',2.9),('8902','2014-05-02','09:45:00',4.51),('8902','2014-05-02','09:50:00',3.35),('8902','2014-05-02','09:55:00',6.61),('8902','2014-05-02','10:00:00',6.58),('8902','2014-05-02','10:05:00',6.64),('8902','2014-05-02','10:10:00',6.88),('8902','2014-05-02','10:15:00',6.88),('8902','2014-05-02','10:20:00',5.97),('8902','2014-05-02','10:25:00',4.02),('8902','2014-05-02','10:30:00',3.54),('8902','2014-05-02','10:35:00',1.86),('8902','2014-05-02','10:40:00',2.53),('8902','2014-05-02','10:45:00',4.72),('8902','2014-05-02','10:50:00',2.86),('8902','2014-05-02','10:55:00',4.77),('8902','2014-05-02','11:00:00',3.71),('8902','2014-05-02','11:05:00',6.77),('8902','2014-05-02','11:10:00',8.53),('8902','2014-05-02','11:15:00',3.37),('8902','2014-05-02','11:20:00',5.2),('8902','2014-05-02','11:25:00',7.05),('8902','2014-05-02','11:30:00',8.22),('8902','2014-05-02','11:35:00',4.95),('8902','2014-05-02','11:40:00',5.54),('8902','2014-05-02','11:45:00',4.41),('8902','2014-05-02','11:50:00',4.2),('8902','2014-05-02','11:55:00',4.49),('8902','2014-05-02','12:00:00',3.76),('8902','2014-05-02','12:05:00',3.31),('8902','2014-05-02','12:10:00',3.07),('8902','2014-05-02','12:15:00',2.67),('8902','2014-05-02','12:20:00',2.38),('8902','2014-05-02','12:25:00',2.56),('8902','2014-05-02','12:30:00',3.48),('8902','2014-05-02','12:35:00',4.11),('8902','2014-05-02','12:40:00',3.65),('8902','2014-05-02','12:45:00',3.77),('8902','2014-05-02','12:50:00',3.8),('8902','2014-05-02','12:55:00',3.89),('8902','2014-05-02','13:00:00',3.89),('8902','2014-05-02','13:05:00',3.78),('8902','2014-05-02','13:10:00',5.84),('8902','2014-05-02','13:15:00',4.93),('8902','2014-05-02','13:20:00',5.46),('8902','2014-05-02','13:25:00',5.77),('8902','2014-05-02','13:30:00',5.76),('8902','2014-05-02','13:35:00',3.96),('8902','2014-05-02','13:40:00',3.44),('8902','2014-05-02','13:45:00',3.43),('8902','2014-05-02','13:50:00',3.48),('8902','2014-05-02','13:55:00',3.53),('8902','2014-05-02','14:00:00',3.45),('8902','2014-05-02','14:05:00',3.47),('8902','2014-05-02','14:10:00',3.81),('8902','2014-05-02','14:15:00',4.49),('8902','2014-05-02','14:20:00',5.4),('8902','2014-05-02','14:25:00',7.4),('8902','2014-05-02','14:30:00',3.74),('8902','2014-05-02','14:35:00',3.25),('8902','2014-05-02','14:40:00',2.73),('8902','2014-05-02','14:45:00',1.56),('8902','2014-05-02','14:50:00',1.26),('8902','2014-05-02','14:55:00',2.52),('8902','2014-05-02','15:00:00',2.24),('8902','2014-05-02','15:05:00',2.3),('8902','2014-05-02','15:10:00',1.77),('8902','2014-05-02','15:15:00',1.29),('8902','2014-05-02','15:20:00',1.07),('8902','2014-05-02','15:25:00',1.06),('8902','2014-05-02','15:30:00',1.07),('8902','2014-05-02','15:35:00',1.07),('8902','2014-05-02','15:40:00',1.06),('8902','2014-05-02','16:25:00',1.19),('8902','2014-05-02','16:30:00',1.37),('8902','2014-05-02','16:35:00',1.53),('8902','2014-05-02','16:40:00',1.69),('8902','2014-05-02','16:45:00',1.82),('8902','2014-05-02','16:50:00',1.88),('8902','2014-05-02','16:55:00',1.89),('8902','2014-05-02','17:00:00',1.9),('8902','2014-05-02','17:05:00',1.88),('8902','2014-05-02','17:10:00',1.87),('8902','2014-05-02','17:15:00',1.84),('8902','2014-05-02','17:20:00',1.8),('8902','2014-05-02','17:25:00',1.81),('8902','2014-05-02','17:30:00',1.76),('8902','2014-05-02','17:35:00',1.66),('8902','2014-05-02','17:40:00',1.68),('8902','2014-05-02','17:45:00',1.8),('8902','2014-05-02','17:50:00',2.08),('8902','2014-05-02','17:55:00',2.03),('8902','2014-05-02','18:00:00',1.77),('8902','2014-05-02','18:05:00',1.5),('8902','2014-05-02','18:10:00',1.71),('8902','2014-05-02','18:15:00',1.11),('8902','2014-05-02','18:45:00',1.15),('8902','2014-04-05','08:15:00',1.68),('8902','2014-04-05','08:20:00',1.86),('8902','2014-04-05','08:25:00',2.09),('8902','2014-04-05','08:30:00',2.25),('8902','2014-04-05','08:35:00',2.48),('8902','2014-04-05','08:40:00',2.69),('8902','2014-04-05','08:45:00',2.75),('8902','2014-04-05','08:50:00',2.67),('8902','2014-04-05','08:55:00',1.97),('8902','2014-04-05','09:00:00',3.24),('8902','2014-04-05','09:05:00',3.67),('8902','2014-04-05','09:10:00',3.81),('8902','2014-04-05','09:15:00',4.09),('8902','2014-04-05','09:20:00',3.53),('8902','2014-04-05','09:25:00',3.63),('8902','2014-04-05','09:30:00',3.22),('8902','2014-04-05','09:35:00',4.34),('8902','2014-04-05','09:40:00',4.74),('8902','2014-04-05','09:45:00',6.3),('8902','2014-04-05','09:50:00',6.57),('8902','2014-04-05','09:55:00',6.28),('8902','2014-04-05','10:00:00',6.24),('8902','2014-04-05','10:05:00',5.33),('8902','2014-04-05','10:10:00',5.83),('8902','2014-04-05','10:15:00',4.94),('8902','2014-04-05','10:20:00',3.4),('8902','2014-04-05','10:25:00',2.35),('8902','2014-04-05','10:30:00',2.6),('8902','2014-04-05','10:35:00',2.89),('8902','2014-04-05','10:40:00',3.08),('8902','2014-04-05','10:45:00',6.25),('8902','2014-04-05','10:50:00',6.01),('8902','2014-04-05','10:55:00',2.87),('8902','2014-04-05','11:00:00',4.69),('8902','2014-04-05','11:05:00',3.76),('8902','2014-04-05','11:10:00',6.24),('8902','2014-04-05','11:15:00',6.37),('8902','2014-04-05','11:20:00',7.81),('8902','2014-04-05','11:25:00',7.75),('8902','2014-04-05','11:30:00',8),('8902','2014-04-05','11:35:00',8.45),('8902','2014-04-05','11:40:00',8.3),('8902','2014-04-05','11:45:00',8.15),('8902','2014-04-05','11:50:00',8.29),('8902','2014-04-05','11:55:00',8.54),('8902','2014-04-05','12:00:00',8.17),('8902','2014-04-05','12:05:00',8.13),('8902','2014-04-05','12:10:00',8.14),('8902','2014-04-05','12:15:00',8.42),('8902','2014-04-05','12:20:00',6.76),('8902','2014-04-05','12:25:00',7.57),('8902','2014-04-05','12:30:00',6.63),('8902','2014-04-05','12:35:00',6.95),('8902','2014-04-05','12:40:00',7.09),('8902','2014-04-05','12:45:00',5.97),('8902','2014-04-05','12:50:00',2.7),('8902','2014-04-05','12:55:00',7.16),('8902','2014-04-05','13:00:00',8.8),('8902','2014-04-05','13:05:00',7.35),('8902','2014-04-05','13:10:00',9.49),('8902','2014-04-05','13:15:00',8.11),('8902','2014-04-05','13:20:00',3.53),('8902','2014-04-05','13:25:00',3.09),('8902','2014-04-05','13:30:00',8.2),('8902','2014-04-05','13:35:00',3.24),('8902','2014-04-05','13:40:00',6.51),('8902','2014-04-05','13:45:00',9.18),('8902','2014-04-05','13:50:00',8.12),('8902','2014-04-05','13:55:00',8.57),('8902','2014-04-05','14:00:00',8.39),('8902','2014-04-05','14:05:00',8.36),('8902','2014-04-05','14:10:00',8.43),('8902','2014-04-05','14:15:00',8.56),('8902','2014-04-05','14:20:00',7.62),('8902','2014-04-05','14:25:00',5.09),('8902','2014-04-05','14:30:00',2.13),('8902','2014-04-05','14:35:00',5.93),('8902','2014-04-05','14:40:00',7.69),('8902','2014-04-05','14:45:00',9.29),('8902','2014-04-05','14:50:00',7.09),('8902','2014-04-05','14:55:00',4.56),('8902','2014-04-05','15:00:00',5.1),('8902','2014-04-05','15:05:00',2.75),('8902','2014-04-05','15:10:00',6.15),('8902','2014-04-05','15:15:00',5.95),('8902','2014-04-05','15:20:00',2.87),('8902','2014-04-05','15:25:00',2.01),('8902','2014-04-05','15:30:00',1.53),('8902','2014-04-05','15:35:00',1.33),('8902','2014-04-05','15:40:00',1.43),('8902','2014-04-05','15:45:00',1.89),('8902','2014-04-05','15:50:00',3.38),('8902','2014-04-05','15:55:00',8.35),('8902','2014-04-05','16:00:00',5.74),('8902','2014-04-05','16:05:00',1.95),('8902','2014-04-05','16:10:00',2.98),('8902','2014-04-05','16:15:00',1.21),('8902','2014-04-05','16:20:00',1.06),('8902','2014-04-05','16:25:00',1.61),('8902','2014-04-05','16:30:00',1.79),('8902','2014-04-05','16:35:00',4.57),('8902','2014-04-05','16:40:00',4.17),('8902','2014-04-05','16:45:00',6.36),('8902','2014-04-05','16:50:00',6),('8902','2014-04-05','16:55:00',3.15),('8902','2014-04-05','17:00:00',1.68),('8902','2014-04-05','17:05:00',1.52),('8902','2014-04-05','17:10:00',1.27),('8902','2014-04-05','17:15:00',1.08),('8902','2014-04-05','17:20:00',1.89),('8902','2014-04-05','17:25:00',4.16),('8902','2014-04-05','17:30:00',3.73),('8902','2014-04-05','17:35:00',3.43),('8902','2014-04-05','17:40:00',2.5),('8902','2014-04-05','17:45:00',3.08),('8902','2014-04-05','17:50:00',3.15),('8902','2014-04-05','17:55:00',2.86),('8902','2014-04-05','18:00:00',2.6),('8902','2014-04-05','18:05:00',2.39),('8902','2014-04-05','18:10:00',2.22),('8902','2014-04-05','18:15:00',2.1),('8902','2014-04-05','18:20:00',2.03),('8902','2014-04-05','18:25:00',1.65),('8902','2013-07-09','07:20:00',1.1),('8902','2013-07-09','07:25:00',1.41),('8902','2013-07-09','07:30:00',1.71),('8902','2013-07-09','07:35:00',2.04),('8902','2013-07-09','07:40:00',2.33),('8902','2013-07-09','07:45:00',2.54),('8902','2013-07-09','07:50:00',2.77),('8902','2013-07-09','07:55:00',3.03),('8902','2013-07-09','08:00:00',3.29),('8902','2013-07-09','08:05:00',2.6),('8902','2013-07-09','08:10:00',2.72),('8902','2013-07-09','08:15:00',3.01),('8902','2013-07-09','08:20:00',3.04),('8902','2013-07-09','08:25:00',3.96),('8902','2013-07-09','08:30:00',3.92),('8902','2013-07-09','08:35:00',4.43),('8902','2013-07-09','08:40:00',3.99),('8902','2013-07-09','08:45:00',3.93),('8902','2013-07-09','08:50:00',3.97),('8902','2013-07-09','08:55:00',3.91),('8902','2013-07-09','09:00:00',3.99),('8902','2013-07-09','09:05:00',4.22),('8902','2013-07-09','09:10:00',4.43),('8902','2013-07-09','09:15:00',4.62),('8902','2013-07-09','09:20:00',4.7),('8902','2013-07-09','09:25:00',4.77),('8902','2013-07-09','09:30:00',4.86),('8902','2013-07-09','09:35:00',4.9),('8902','2013-07-09','09:40:00',5.01),('8902','2013-07-09','09:45:00',5.13),('8902','2013-07-09','09:50:00',5.21),('8902','2013-07-09','09:55:00',5.18),('8902','2013-07-09','10:00:00',5.14),('8902','2013-07-09','10:05:00',5.53),('8902','2013-07-09','10:10:00',5.66),('8902','2013-07-09','10:15:00',5.77),('8902','2013-07-09','10:20:00',5.91),('8902','2013-07-09','10:25:00',5.95),('8902','2013-07-09','10:30:00',6.04),('8902','2013-07-09','10:35:00',6.17),('8902','2013-07-09','10:40:00',6.36),('8902','2013-07-09','10:45:00',6.42),('8902','2013-07-09','10:50:00',6.56),('8902','2013-07-09','10:55:00',6.59),('8902','2013-07-09','11:00:00',6.63),('8902','2013-07-09','11:05:00',6.68),('8902','2013-07-09','11:10:00',6.76),('8902','2013-07-09','11:15:00',6.86),('8902','2013-07-09','11:20:00',6.86),('8902','2013-07-09','11:25:00',6.8),('8902','2013-07-09','11:30:00',6.98),('8902','2013-07-09','11:35:00',7.02),('8902','2013-07-09','11:40:00',7.1),('8902','2013-07-09','11:45:00',7.18),('8902','2013-07-09','11:50:00',7.22),('8902','2013-07-09','11:55:00',7.31),('8902','2013-07-09','12:00:00',7.39),('8902','2013-07-09','12:05:00',7.52),('8902','2013-07-09','12:10:00',7.52),('8902','2013-07-09','12:15:00',7.46),('8902','2013-07-09','12:20:00',7.56),('8902','2013-07-09','12:25:00',7.6),('8902','2013-07-09','12:30:00',7.67),('8902','2013-07-09','12:35:00',7.84),('8902','2013-07-09','12:40:00',7.76),('8902','2013-07-09','12:45:00',7.74),('8902','2013-07-09','12:50:00',7.78),('8902','2013-07-09','12:55:00',7.75),('8902','2013-07-09','13:00:00',7.77),('8902','2013-07-09','13:05:00',7.83),('8902','2013-07-09','13:10:00',7.92),('8902','2013-07-09','13:15:00',7.94),('8902','2013-07-09','13:20:00',7.87),('8902','2013-07-09','13:25:00',7.91),('8902','2013-07-09','13:30:00',7.97),('8902','2013-07-09','13:35:00',7.94),('8902','2013-07-09','13:40:00',7.96),('8902','2013-07-09','13:45:00',8.03),('8902','2013-07-09','13:50:00',8.06),('8902','2013-07-09','13:55:00',8.01),('8902','2013-07-09','14:00:00',8.08),('8902','2013-07-09','14:05:00',8.08),('8902','2013-07-09','14:10:00',8.05),('8902','2013-07-09','14:15:00',8.01),('8902','2013-07-09','14:20:00',7.93),('8902','2013-07-09','14:25:00',7.91),('8902','2013-07-09','14:30:00',7.89),('8902','2013-07-09','14:35:00',7.84),('8902','2013-07-09','14:40:00',7.81),('8902','2013-07-09','14:45:00',7.76),('8902','2013-07-09','14:50:00',7.69),('8902','2013-07-09','14:55:00',7.67),('8902','2013-07-09','15:00:00',7.66),('8902','2013-07-09','15:05:00',7.59),('8902','2013-07-09','15:10:00',7.5),('8902','2013-07-09','15:15:00',7.45),('8902','2013-07-09','15:20:00',7.37),('8902','2013-07-09','15:25:00',7.29),('8902','2013-07-09','15:30:00',7.27),('8902','2013-07-09','15:35:00',7.23),('8902','2013-07-09','15:40:00',7.09),('8902','2013-07-09','15:45:00',6.99),('8902','2013-07-09','15:50:00',6.9),('8902','2013-07-09','15:55:00',6.85),('8902','2013-07-09','16:00:00',6.77),('8902','2013-07-09','16:05:00',6.64),('8902','2013-07-09','16:10:00',6.54),('8902','2013-07-09','16:15:00',6.45),('8902','2013-07-09','16:20:00',6.32),('8902','2013-07-09','16:25:00',6.21),('8902','2013-07-09','16:30:00',6.05),('8902','2013-07-09','16:35:00',5.92),('8902','2013-07-09','16:40:00',5.71),('8902','2013-07-09','16:45:00',5.67),('8902','2013-07-09','16:50:00',5.55),('8902','2013-07-09','16:55:00',5.48),('8902','2013-07-09','17:00:00',5.39),('8902','2013-07-09','17:05:00',5.11),('8902','2013-07-09','17:10:00',4.8),('8902','2013-07-09','17:15:00',2.82),('8902','2013-07-09','17:20:00',3.01),('8902','2013-07-09','17:25:00',2.31),('8902','2013-07-09','17:30:00',1.71),('8902','2013-07-09','17:35:00',4.65),('8902','2013-07-09','17:40:00',3.78),('8902','2013-07-09','17:45:00',3.98),('8902','2013-07-09','17:50:00',3.72),('8902','2013-07-09','17:55:00',3.48),('8902','2013-07-09','18:00:00',2.94),('8902','2013-07-09','18:05:00',1.82),('8902','2013-07-09','18:10:00',2.77),('8902','2013-07-09','18:15:00',1.22),('8902','2013-07-09','18:20:00',1.38),('8902','2013-07-09','18:25:00',2.19),('8902','2013-07-09','18:30:00',1.06),('8902','2013-07-09','19:05:00',1.12),('8902','2013-07-09','19:10:00',1.15),('8902','2013-07-09','19:15:00',1.03),('8902','2013-07-08','07:35:00',1.32),('8902','2013-07-08','07:40:00',1.46),('8902','2013-07-08','07:45:00',1.58),('8902','2013-07-08','07:50:00',1.72),('8902','2013-07-08','07:55:00',1.88),('8902','2013-07-08','08:00:00',2.01),('8902','2013-07-08','08:05:00',2.16),('8902','2013-07-08','08:10:00',2.32),('8902','2013-07-08','08:15:00',2.49),('8902','2013-07-08','08:20:00',2.63),('8902','2013-07-08','08:25:00',2.79),('8902','2013-07-08','08:30:00',2.95),('8902','2013-07-08','08:35:00',3.11),('8902','2013-07-08','08:40:00',3.25),('8902','2013-07-08','08:45:00',3.4),('8902','2013-07-08','08:50:00',3.54),('8902','2013-07-08','08:55:00',3.7),('8902','2013-07-08','09:00:00',3.85),('8902','2013-07-08','09:05:00',4),('8902','2013-07-08','09:10:00',4.14),('8902','2013-07-08','09:15:00',4.29),('8902','2013-07-08','09:20:00',4.42),('8902','2013-07-08','09:25:00',4.56),('8902','2013-07-08','09:30:00',4.7),('8902','2013-07-08','09:35:00',4.87),('8902','2013-07-08','09:40:00',4.98),('8902','2013-07-08','09:45:00',5.13),('8902','2013-07-08','09:50:00',5.26),('8902','2013-07-08','09:55:00',5.35),('8902','2013-07-08','10:00:00',5.42),('8902','2013-07-08','10:05:00',5.54),('8902','2013-07-08','10:10:00',5.63),('8902','2013-07-08','10:15:00',5.74),('8902','2013-07-08','10:20:00',5.87),('8902','2013-07-08','10:25:00',5.98),('8902','2013-07-08','10:30:00',6.05),('8902','2013-07-08','10:35:00',6.16),('8902','2013-07-08','10:40:00',6.22),('8902','2013-07-08','10:45:00',6.33),('8902','2013-07-08','10:50:00',6.47),('8902','2013-07-08','10:55:00',6.62),('8902','2013-07-08','11:00:00',6.69),('8902','2013-07-08','11:05:00',6.52),('8902','2013-07-08','11:10:00',5.96),('8902','2013-07-08','11:15:00',6.13),('8902','2013-07-08','11:20:00',6),('8902','2013-07-08','11:25:00',5.57),('8902','2013-07-08','11:30:00',3.32),('8902','2013-07-08','11:35:00',4.15),('8902','2013-07-08','11:40:00',5.87),('8902','2013-07-08','11:45:00',7.14),('8902','2013-07-08','11:50:00',8.22),('8902','2013-07-08','11:55:00',8.23),('8902','2013-07-08','12:00:00',8.24),('8902','2013-07-08','12:05:00',8.1),('8902','2013-07-08','12:10:00',7.9),('8902','2013-07-08','12:15:00',7.49),('8902','2013-07-08','12:20:00',7.46),('8902','2013-07-08','12:25:00',7.46),('8902','2013-07-08','12:30:00',7.51),('8902','2013-07-08','12:35:00',7.55),('8902','2013-07-08','12:40:00',7.65),('8902','2013-07-08','12:45:00',7.69),('8902','2013-07-08','12:50:00',7.84),('8902','2013-07-08','12:55:00',7.83),('8902','2013-07-08','13:00:00',7.8),('8902','2013-07-08','13:05:00',7.86),('8902','2013-07-08','13:10:00',8.06),('8902','2013-07-08','13:15:00',8.18),('8902','2013-07-08','13:20:00',8.15),('8902','2013-07-08','13:25:00',8.03),('8902','2013-07-08','13:30:00',8.2),('8902','2013-07-08','13:35:00',7.64),('8902','2013-07-08','13:40:00',7.44),('8902','2013-07-08','13:45:00',6.4),('8902','2013-07-08','13:50:00',5.89),('8902','2013-07-08','13:55:00',5.68),('8902','2013-07-08','14:00:00',5.89),('8902','2013-07-08','14:05:00',5.71),('8902','2013-07-08','14:10:00',6.46),('8902','2013-07-08','14:15:00',6.75),('8902','2013-07-08','14:20:00',5.68),('8902','2013-07-08','14:25:00',4.3),('8902','2013-07-08','14:30:00',2.71),('8902','2013-07-08','14:35:00',2),('8902','2013-07-08','14:40:00',1.85),('8902','2013-07-08','14:45:00',1.51),('8902','2013-07-08','17:25:00',1.03),('8902','2013-07-08','17:30:00',1.11),('8902','2013-07-08','17:35:00',1.15),('8902','2013-07-08','17:40:00',1.1),('8902','2013-07-07','07:35:00',1.35),('8902','2013-07-07','07:40:00',1.99),('8902','2013-07-07','07:45:00',1.85),('8902','2013-07-07','07:50:00',1.52),('8902','2013-07-07','07:55:00',1.62),('8902','2013-07-07','08:00:00',1.75),('8902','2013-07-07','08:05:00',1.85),('8902','2013-07-07','08:10:00',2.14),('8902','2013-07-07','08:15:00',2.44),('8902','2013-07-07','08:20:00',2.64),('8902','2013-07-07','08:25:00',2.81),('8902','2013-07-07','08:30:00',2.99),('8902','2013-07-07','08:35:00',3.13),('8902','2013-07-07','08:40:00',3.28),('8902','2013-07-07','08:45:00',3.41),('8902','2013-07-07','08:50:00',3.57),('8902','2013-07-07','08:55:00',3.69),('8902','2013-07-07','09:00:00',3.84),('8902','2013-07-07','09:05:00',3.97),('8902','2013-07-07','09:10:00',4.08),('8902','2013-07-07','09:15:00',4.17),('8902','2013-07-07','09:20:00',4.26),('8902','2013-07-07','09:25:00',4.33),('8902','2013-07-07','09:30:00',4.57),('8902','2013-07-07','09:35:00',4.88),('8902','2013-07-07','09:40:00',5),('8902','2013-07-07','09:45:00',5.1),('8902','2013-07-07','09:50:00',5.11),('8902','2013-07-07','09:55:00',5.32),('8902','2013-07-07','10:00:00',5.48),('8902','2013-07-07','10:05:00',5.59),('8902','2013-07-07','10:10:00',5.64),('8902','2013-07-07','10:15:00',5.8),('8902','2013-07-07','10:20:00',5.89),('8902','2013-07-07','10:25:00',6),('8902','2013-07-07','10:30:00',6.13),('8902','2013-07-07','10:35:00',6.2),('8902','2013-07-07','10:40:00',6.27),('8902','2013-07-07','10:45:00',6.33),('8902','2013-07-07','10:50:00',6.4),('8902','2013-07-07','10:55:00',6.47),('8902','2013-07-07','11:00:00',6.55),('8902','2013-07-07','11:05:00',6.69),('8902','2013-07-07','11:10:00',6.8),('8902','2013-07-07','11:15:00',6.92),('8902','2013-07-07','11:20:00',7.04),('8902','2013-07-07','11:25:00',7.11),('8902','2013-07-07','11:30:00',7.24),('8902','2013-07-07','11:35:00',7.33),('8902','2013-07-07','11:40:00',6.92),('8902','2013-07-07','11:45:00',7.38),('8902','2013-07-07','11:50:00',7.45),('8902','2013-07-07','11:55:00',7.31),('8902','2013-07-07','12:00:00',7.47),('8902','2013-07-07','12:05:00',7.66),('8902','2013-07-07','12:10:00',7.76),('8902','2013-07-07','12:15:00',7.88),('8902','2013-07-07','12:20:00',8.12),('8902','2013-07-07','12:25:00',7.93),('8902','2013-07-07','12:30:00',7.42),('8902','2013-07-07','12:35:00',7.96),('8902','2013-07-07','12:40:00',7.82),('8902','2013-07-07','12:45:00',7.82),('8902','2013-07-07','12:50:00',7.86),('8902','2013-07-07','12:55:00',8.01),('8902','2013-07-07','13:00:00',8.21),('8902','2013-07-07','13:05:00',8.3),('8902','2013-07-07','13:10:00',8.67),('8902','2013-07-07','13:15:00',8.58),('8902','2013-07-07','13:20:00',6.08),('8902','2013-07-07','13:25:00',2.5),('8902','2013-07-07','13:30:00',1.34),('8902','2013-07-07','14:00:00',1.17),('8902','2013-07-07','14:05:00',1.42),('8902','2013-07-07','14:10:00',1.49),('8902','2013-07-07','14:15:00',1.5),('8902','2013-07-07','14:20:00',1.52),('8902','2013-07-07','14:25:00',1.63),('8902','2013-07-07','14:30:00',1.82),('8902','2013-07-07','14:35:00',2.09),('8902','2013-07-07','14:40:00',2.13),('8902','2013-07-07','14:45:00',2.02),('8902','2013-07-07','14:50:00',1.95),('8902','2013-07-07','14:55:00',1.91),('8902','2013-07-07','15:00:00',1.77),('8902','2013-07-07','15:05:00',1.6),('8902','2013-07-07','15:10:00',1.46),('8902','2013-07-07','15:15:00',1.31),('8902','2013-07-07','15:20:00',1),('8902','2013-07-07','17:20:00',1.26),('8902','2013-07-07','17:25:00',1.55),('8902','2013-07-07','17:30:00',1.79),('8902','2013-07-07','17:35:00',1.93),('8902','2013-07-07','17:40:00',1.99),('8902','2013-07-07','17:45:00',2),('8902','2013-07-07','17:50:00',2.01),('8902','2013-07-07','17:55:00',1.92),('8902','2013-07-07','18:00:00',1.8),('8902','2013-07-07','18:05:00',1.59),('8902','2013-07-07','18:10:00',1.51),('8902','2013-07-07','18:15:00',1.61),('8902','2013-07-07','18:20:00',1.69),('8902','2013-07-07','18:25:00',1.52),('8902','2013-07-07','18:30:00',1.53),('8902','2013-07-07','18:35:00',1.86),('8902','2013-07-07','18:40:00',2.29),('8902','2013-07-07','18:45:00',2.06),('8902','2013-07-07','18:50:00',1.79),('8902','2013-07-07','18:55:00',1.58),('8902','2013-07-07','19:00:00',1.41),('8902','2013-07-07','19:05:00',1.1),('8902','2013-07-06','07:30:00',1.09),('8902','2013-07-06','07:35:00',1.3),('8902','2013-07-06','07:40:00',1.46),('8902','2013-07-06','07:45:00',1.61),('8902','2013-07-06','07:50:00',1.77),('8902','2013-07-06','07:55:00',1.93),('8902','2013-07-06','08:00:00',2.11),('8902','2013-07-06','08:05:00',2.27),('8902','2013-07-06','08:10:00',2.44),('8902','2013-07-06','08:15:00',2.25),('8902','2013-07-06','08:20:00',2.06),('8902','2013-07-06','08:25:00',2.29),('8902','2013-07-06','08:30:00',2.93),('8902','2013-07-06','08:35:00',3.41),('8902','2013-07-06','08:40:00',2.2),('8902','2013-07-06','08:45:00',1.51),('8902','2013-07-06','08:50:00',3.3),('8902','2013-07-06','08:55:00',3.88),('8902','2013-07-06','09:00:00',3.95),('8902','2013-07-06','09:05:00',3.81),('8902','2013-07-06','09:10:00',3.91),('8902','2013-07-06','09:15:00',3.86),('8902','2013-07-06','09:20:00',2.59),('8902','2013-07-06','09:25:00',3.98),('8902','2013-07-06','09:30:00',4.87),('8902','2013-07-06','09:35:00',5.02),('8902','2013-07-06','09:40:00',4.66),('8902','2013-07-06','09:45:00',5.62),('8902','2013-07-06','09:50:00',5.59),('8902','2013-07-06','09:55:00',5.66),('8902','2013-07-06','10:00:00',5.7),('8902','2013-07-06','10:05:00',5.47),('8902','2013-07-06','10:10:00',5.79),('8902','2013-07-06','10:15:00',5.57),('8902','2013-07-06','10:20:00',5.66),('8902','2013-07-06','10:25:00',5.23),('8902','2013-07-06','10:30:00',5.75),('8902','2013-07-06','10:35:00',6.64),('8902','2013-07-06','10:40:00',5.96),('8902','2013-07-06','10:45:00',6.49),('8902','2013-07-06','10:50:00',6.68),('8902','2013-07-06','10:55:00',6.68),('8902','2013-07-06','11:00:00',6.78),('8902','2013-07-06','11:05:00',6.91),('8902','2013-07-06','11:10:00',7),('8902','2013-07-06','11:15:00',6.94),('8902','2013-07-06','11:20:00',6.58),('8902','2013-07-06','11:25:00',5.91),('8902','2013-07-06','11:30:00',6.28),('8902','2013-07-06','11:35:00',6.14),('8902','2013-07-06','11:40:00',6.4),('8902','2013-07-06','11:45:00',4.83),('8902','2013-07-06','11:50:00',5.19),('8902','2013-07-06','11:55:00',3.55),('8902','2013-07-06','12:00:00',5.31),('8902','2013-07-06','12:05:00',7.3),('8902','2013-07-06','12:10:00',7.51),('8902','2013-07-06','12:15:00',8),('8902','2013-07-06','12:20:00',7.73),('8902','2013-07-06','12:25:00',7.23),('8902','2013-07-06','12:30:00',7.3),('8902','2013-07-06','12:35:00',7.8),('8902','2013-07-06','12:40:00',7.96),('8902','2013-07-06','12:45:00',7.99),('8902','2013-07-06','12:50:00',7.78),('8902','2013-07-06','12:55:00',8.14),('8902','2013-07-06','13:00:00',7.87),('8902','2013-07-06','13:05:00',8.01),('8902','2013-07-06','13:10:00',8.08),('8902','2013-07-06','13:15:00',7.88),('8902','2013-07-06','13:20:00',7.89),('8902','2013-07-06','13:25:00',5.18),('8902','2013-07-06','13:30:00',7.78),('8902','2013-07-06','13:35:00',8.22),('8902','2013-07-06','13:40:00',8.26),('8902','2013-07-06','13:45:00',8.51),('8902','2013-07-06','13:50:00',8.27),('8902','2013-07-06','13:55:00',4.67),('8902','2013-07-06','14:00:00',6.69),('8902','2013-07-06','14:05:00',7.8),('8902','2013-07-06','14:10:00',3.68),('8902','2013-07-06','14:15:00',4.23),('8902','2013-07-06','14:20:00',2.03),('8902','2013-07-06','14:25:00',1.81),('8902','2013-07-06','14:30:00',1.67),('8902','2013-07-06','14:35:00',1.58),('8902','2013-07-06','14:40:00',1.47),('8902','2013-07-06','14:45:00',1.37),('8902','2013-07-06','14:50:00',1.33),('8902','2013-07-06','14:55:00',1.48),('8902','2013-07-06','15:00:00',1.79),('8902','2013-07-06','15:05:00',2.05),('8902','2013-07-06','15:10:00',1.76),('8902','2013-07-06','15:15:00',1.26),('8902','2013-07-06','15:20:00',1.32),('8902','2013-07-06','15:25:00',1.16),('8902','2013-07-06','16:40:00',1),('8902','2013-07-06','16:45:00',1.12),('8902','2013-07-06','16:50:00',1.33),('8902','2013-07-06','16:55:00',1.56),('8902','2013-07-06','17:00:00',1.73),('8902','2013-07-06','17:05:00',1.83),('8902','2013-07-06','17:10:00',1.91),('8902','2013-07-06','17:15:00',1.95),('8902','2013-07-06','17:20:00',1.96),('8902','2013-07-06','17:25:00',1.92),('8902','2013-07-06','17:30:00',1.84),('8902','2013-07-06','17:35:00',1.73),('8902','2013-07-06','17:40:00',1.66),('8902','2013-07-06','17:45:00',1.63),('8902','2013-07-06','17:50:00',1.6),('8902','2013-07-06','17:55:00',1.55),('8902','2013-07-06','18:00:00',1.5),('8902','2013-07-06','18:05:00',1.49),('8902','2013-07-06','18:10:00',1.46),('8902','2013-07-06','18:15:00',1.46),('8902','2013-07-06','18:20:00',1.47),('8902','2013-07-06','18:25:00',1.42),('8902','2013-07-06','18:30:00',1.34),('8902','2013-07-06','18:35:00',1.24),('8902','2013-07-06','18:40:00',1.14),('8902','2013-07-06','18:45:00',1.07),('8902','2013-07-06','18:50:00',1.04),('8902','2013-07-06','18:55:00',1.03),('8902','2013-07-05','07:30:00',1.1),('8902','2013-07-05','07:35:00',1.28),('8902','2013-07-05','07:40:00',1.42),('8902','2013-07-05','07:45:00',1.58),('8902','2013-07-05','07:50:00',1.73),('8902','2013-07-05','07:55:00',1.89),('8902','2013-07-05','08:00:00',2.05),('8902','2013-07-05','08:05:00',2.21),('8902','2013-07-05','08:10:00',2.38),('8902','2013-07-05','08:15:00',2.53),('8902','2013-07-05','08:20:00',2.69),('8902','2013-07-05','08:25:00',2.85),('8902','2013-07-05','08:30:00',3),('8902','2013-07-05','08:35:00',3.16),('8902','2013-07-05','08:40:00',3.33),('8902','2013-07-05','08:45:00',3.47),('8902','2013-07-05','08:50:00',3.61),('8902','2013-07-05','08:55:00',3.76),('8902','2013-07-05','09:00:00',3.91),('8902','2013-07-05','09:05:00',4.09),('8902','2013-07-05','09:10:00',4.23),('8902','2013-07-05','09:15:00',4.37),('8902','2013-07-05','09:20:00',4.53),('8902','2013-07-05','09:25:00',4.65),('8902','2013-07-05','09:30:00',4.75),('8902','2013-07-05','09:35:00',4.87),('8902','2013-07-05','09:40:00',4.99),('8902','2013-07-05','09:45:00',5.13),('8902','2013-07-05','09:50:00',5.28),('8902','2013-07-05','09:55:00',5.39),('8902','2013-07-05','10:00:00',5.53),('8902','2013-07-05','10:05:00',5.68),('8902','2013-07-05','10:10:00',5.83),('8902','2013-07-05','10:15:00',5.95),('8902','2013-07-05','10:20:00',6.05),('8902','2013-07-05','10:25:00',6.15),('8902','2013-07-05','10:30:00',6.23),('8902','2013-07-05','10:35:00',6.33),('8902','2013-07-05','10:40:00',6.4),('8902','2013-07-05','10:45:00',6.51),('8902','2013-07-05','10:50:00',6.65),('8902','2013-07-05','10:55:00',6.76),('8902','2013-07-05','11:00:00',6.83),('8902','2013-07-05','11:05:00',6.91),('8902','2013-07-05','11:10:00',6.95),('8902','2013-07-05','11:15:00',6.98),('8902','2013-07-05','11:20:00',7.08),('8902','2013-07-05','11:25:00',7.18),('8902','2013-07-05','11:30:00',7.14),('8902','2013-07-05','11:35:00',7.21),('8902','2013-07-05','11:40:00',7.28),('8902','2013-07-05','11:45:00',7.37),('8902','2013-07-05','11:50:00',7.42),('8902','2013-07-05','11:55:00',7.49),('8902','2013-07-05','12:00:00',7.52),('8902','2013-07-05','12:05:00',7.63),('8902','2013-07-05','12:10:00',7.73),('8902','2013-07-05','12:15:00',7.71),('8902','2013-07-05','12:20:00',7.8),('8902','2013-07-05','12:25:00',7.85),('8902','2013-07-05','12:30:00',7.92),('8902','2013-07-05','12:35:00',7.87),('8902','2013-07-05','12:40:00',7.88),('8902','2013-07-05','12:45:00',7.94),('8902','2013-07-05','12:50:00',7.94),('8902','2013-07-05','12:55:00',7.99),('8902','2013-07-05','13:00:00',8.02),('8902','2013-07-05','13:05:00',8.07),('8902','2013-07-05','13:10:00',8.11),('8902','2013-07-05','13:15:00',8.11),('8902','2013-07-05','13:20:00',8.08),('8902','2013-07-05','13:25:00',8.04),('8902','2013-07-05','13:30:00',8.13),('8902','2013-07-05','13:35:00',8.02),('8902','2013-07-05','13:40:00',8.07),('8902','2013-07-05','13:45:00',8.04),('8902','2013-07-05','13:50:00',7.97),('8902','2013-07-05','13:55:00',7.99),('8902','2013-07-05','14:00:00',8.02),('8902','2013-07-05','14:05:00',8.04),('8902','2013-07-05','14:10:00',7.99),('8902','2013-07-05','14:15:00',5.6),('8902','2013-07-05','14:20:00',7.31),('8902','2013-07-05','14:25:00',8.08),('8902','2013-07-05','14:30:00',7.86),('8902','2013-07-05','14:35:00',7.87),('8902','2013-07-05','14:40:00',7.8),('8902','2013-07-05','14:45:00',7.76),('8902','2013-07-05','14:50:00',7.51),('8902','2013-07-05','14:55:00',7.94),('8902','2013-07-05','15:00:00',7.32),('8902','2013-07-05','15:05:00',5.84),('8902','2013-07-05','15:10:00',7.87),('8902','2013-07-05','15:15:00',7.59),('8902','2013-07-05','15:20:00',7.48),('8902','2013-07-05','15:25:00',7.54),('8902','2013-07-05','15:30:00',7.49),('8902','2013-07-05','15:35:00',3.96),('8902','2013-07-05','15:40:00',1.6),('8902','2013-07-05','15:45:00',1.17),('8902','2013-07-05','16:45:00',1.23),('8902','2013-07-05','16:50:00',1.83),('8902','2013-07-05','16:55:00',2.27),('8902','2013-07-05','17:00:00',1.75),('8902','2013-07-05','17:05:00',1.97),('8902','2013-07-05','17:10:00',1.69),('8902','2013-07-05','17:15:00',1.96),('8902','2013-07-05','17:20:00',1.79),('8902','2013-07-05','17:25:00',2.02),('8902','2013-07-05','17:30:00',2.12),('8902','2013-07-05','17:35:00',2.07),('8902','2013-07-05','17:40:00',1.77),('8902','2013-07-05','17:45:00',1.63),('8902','2013-07-05','17:50:00',1.43),('8902','2013-07-05','17:55:00',1.39),('8902','2013-07-05','18:00:00',1.31),('8902','2013-07-05','18:05:00',1.23),('8902','2013-07-05','18:10:00',1.18),('8902','2013-07-05','18:15:00',1.05),('8902','2013-07-04','07:30:00',1.22),('8902','2013-07-04','07:35:00',1.36),('8902','2013-07-04','07:40:00',1.49),('8902','2013-07-04','07:45:00',1.62),('8902','2013-07-04','07:50:00',1.75),('8902','2013-07-04','07:55:00',1.9),('8902','2013-07-04','08:00:00',2.08),('8902','2013-07-04','08:05:00',2.24),('8902','2013-07-04','08:10:00',2.38),('8902','2013-07-04','08:15:00',2.53),('8902','2013-07-04','08:20:00',2.66),('8902','2013-07-04','08:25:00',2.81),('8902','2013-07-04','08:30:00',2.97),('8902','2013-07-04','08:35:00',3.13),('8902','2013-07-04','08:40:00',3.26),('8902','2013-07-04','08:45:00',3.41),('8902','2013-07-04','08:50:00',3.57),('8902','2013-07-04','08:55:00',3.69),('8902','2013-07-04','09:00:00',3.84),('8902','2013-07-04','09:05:00',3.99),('8902','2013-07-04','09:10:00',4.12),('8902','2013-07-04','09:15:00',4.28),('8902','2013-07-04','09:20:00',4.41),('8902','2013-07-04','09:25:00',4.57),('8902','2013-07-04','09:30:00',4.71),('8902','2013-07-04','09:35:00',4.83),('8902','2013-07-04','09:40:00',4.88),('8902','2013-07-04','09:45:00',5.09),('8902','2013-07-04','09:50:00',5.17),('8902','2013-07-04','09:55:00',5.2),('8902','2013-07-04','10:00:00',5.33),('8902','2013-07-04','10:05:00',5.46),('8902','2013-07-04','10:10:00',5.62),('8902','2013-07-04','10:15:00',5.67),('8902','2013-07-04','10:20:00',5.76),('8902','2013-07-04','10:25:00',5.85),('8902','2013-07-04','10:30:00',6),('8902','2013-07-04','10:35:00',5.97),('8902','2013-07-04','10:40:00',6),('8902','2013-07-04','10:45:00',6.1),('8902','2013-07-04','10:50:00',6.21),('8902','2013-07-04','10:55:00',6.39),('8902','2013-07-04','11:00:00',6.45),('8902','2013-07-04','11:05:00',6.44),('8902','2013-07-04','11:10:00',6.46),('8902','2013-07-04','11:15:00',6.58),('8902','2013-07-04','11:20:00',6.62),('8902','2013-07-04','11:25:00',6.79),('8902','2013-07-04','11:30:00',6.9),('8902','2013-07-04','11:35:00',6.96),('8902','2013-07-04','11:40:00',7.04),('8902','2013-07-04','11:45:00',7.09),('8902','2013-07-04','11:50:00',7.15),('8902','2013-07-04','11:55:00',6.95),('8902','2013-07-04','12:00:00',7.08),('8902','2013-07-04','12:05:00',7.3),('8902','2013-07-04','12:10:00',7.27),('8902','2013-07-04','12:15:00',7.33),('8902','2013-07-04','12:20:00',7.51),('8902','2013-07-04','12:25:00',3.69),('8902','2013-07-04','12:30:00',7.65),('8902','2013-07-04','12:35:00',7.19),('8902','2013-07-04','12:40:00',4.97),('8902','2013-07-04','12:45:00',4.95),('8902','2013-07-04','12:50:00',5.13),('8902','2013-07-04','12:55:00',1.99),('8902','2013-07-04','13:00:00',5.7),('8902','2013-07-04','13:05:00',3.65),('8902','2013-07-04','13:10:00',8.04),('8902','2013-07-04','13:15:00',7.92),('8902','2013-07-04','13:20:00',7.25),('8902','2013-07-04','13:25:00',6.59),('8902','2013-07-04','13:30:00',7.99),('8902','2013-07-04','13:35:00',8.09),('8902','2013-07-04','13:40:00',7.94),('8902','2013-07-04','13:45:00',8.16),('8902','2013-07-04','13:50:00',8),('8902','2013-07-04','13:55:00',8.1),('8902','2013-07-04','14:00:00',8.2),('8902','2013-07-04','14:05:00',8.09),('8902','2013-07-04','14:10:00',7.93),('8902','2013-07-04','14:15:00',7.92),('8902','2013-07-04','14:20:00',7.81),('8902','2013-07-04','14:25:00',7.98),('8902','2013-07-04','14:30:00',7.52),('8902','2013-07-04','14:35:00',7.83),('8902','2013-07-04','14:40:00',7.81),('8902','2013-07-04','14:45:00',6.1),('8902','2013-07-04','14:50:00',7.82),('8902','2013-07-04','14:55:00',7.57),('8902','2013-07-04','15:00:00',6.39),('8902','2013-07-04','15:05:00',5.9),('8902','2013-07-04','15:10:00',7.8),('8902','2013-07-04','15:15:00',6.58),('8902','2013-07-04','15:20:00',7.13),('8902','2013-07-04','15:25:00',4.64),('8902','2013-07-04','15:30:00',6.06),('8902','2013-07-04','15:35:00',7.41),('8902','2013-07-04','15:40:00',7.21),('8902','2013-07-04','15:45:00',7.26),('8902','2013-07-04','15:50:00',7.11),('8902','2013-07-04','15:55:00',6.87),('8902','2013-07-04','16:00:00',6.74),('8902','2013-07-04','16:05:00',6.7),('8902','2013-07-04','16:10:00',6.48),('8902','2013-07-04','16:15:00',6.43),('8902','2013-07-04','16:20:00',6.37),('8902','2013-07-04','16:25:00',6.24),('8902','2013-07-04','16:30:00',6.16),('8902','2013-07-04','16:35:00',6.05),('8902','2013-07-04','16:40:00',5.78),('8902','2013-07-04','16:45:00',5.8),('8902','2013-07-04','16:50:00',5.57),('8902','2013-07-04','16:55:00',5.25),('8902','2013-07-04','17:00:00',4.63),('8902','2013-07-04','17:05:00',5.12),('8902','2013-07-04','17:10:00',5.12),('8902','2013-07-04','17:15:00',5.07),('8902','2013-07-04','17:20:00',4.97),('8902','2013-07-04','17:25:00',4.72),('8902','2013-07-04','17:30:00',4.4),('8902','2013-07-04','17:35:00',4.24),('8902','2013-07-04','17:40:00',3.97),('8902','2013-07-04','17:45:00',3.76),('8902','2013-07-04','17:50:00',3.67),('8902','2013-07-04','17:55:00',3.59),('8902','2013-07-04','18:00:00',3.36),('8902','2013-07-04','18:05:00',3.29),('8902','2013-07-04','18:10:00',2.52),('8902','2013-07-04','18:20:00',1.66),('8902','2013-07-04','18:35:00',1.91),('8902','2013-07-04','18:40:00',1.89),('8902','2013-07-04','18:45:00',1.82),('8902','2013-07-04','18:50:00',1.66),('8902','2013-07-04','18:55:00',1.5),('8902','2013-07-04','19:00:00',1.32),('8902','2013-07-04','19:05:00',1.19),('8902','2013-07-04','19:10:00',1.05),('8902','2013-07-03','08:45:00',1.05),('8902','2013-07-03','08:50:00',1.38),('8902','2013-07-03','08:55:00',1.73),('8902','2013-07-03','09:00:00',1.71),('8902','2013-07-03','09:05:00',1.41),('8902','2013-07-03','09:10:00',1.25),('8902','2013-07-03','09:15:00',1.29),('8902','2013-07-03','09:20:00',1.25),('8902','2013-07-03','09:25:00',1.34),('8902','2013-07-03','09:30:00',1.42),('8902','2013-07-03','09:35:00',1.4),('8902','2013-07-03','09:40:00',1.18),('8902','2013-07-03','10:15:00',1.16),('8902','2013-07-03','10:20:00',1.3),('8902','2013-07-03','10:25:00',1.34),('8902','2013-07-03','10:30:00',1.35),('8902','2013-07-03','10:35:00',1.4),('8902','2013-07-03','10:40:00',1.37),('8902','2013-07-03','10:45:00',1.19),('8902','2013-07-03','10:50:00',1.06),('8902','2013-07-03','10:55:00',1.13),('8902','2013-07-03','11:00:00',1.34),('8902','2013-07-03','11:05:00',1.56),('8902','2013-07-03','11:10:00',1.9),('8902','2013-07-03','11:15:00',2.06),('8902','2013-07-03','11:20:00',1.95),('8902','2013-07-03','11:25:00',2.01);
INSERT INTO `solarlog` VALUES ('8902','2013-07-03','11:30:00',2.14),('8902','2013-07-03','11:35:00',2.44),('8902','2013-07-03','11:40:00',2.76),('8902','2013-07-03','11:45:00',3.05),('8902','2013-07-03','11:50:00',3.18),('8902','2013-07-03','11:55:00',2.88),('8902','2013-07-03','12:00:00',2.61),('8902','2013-07-03','12:05:00',2.83),('8902','2013-07-03','12:10:00',3.8),('8902','2013-07-03','12:15:00',4.8),('8902','2013-07-03','12:20:00',4.88),('8902','2013-07-03','12:25:00',7.35),('8902','2013-07-03','12:30:00',5.56),('8902','2013-07-03','12:35:00',5.17),('8902','2013-07-03','12:40:00',3.32),('8902','2013-07-03','12:45:00',2.65),('8902','2013-07-03','12:50:00',2.08),('8902','2013-07-03','12:55:00',1.87),('8902','2013-07-03','13:00:00',1.93),('8902','2013-07-03','13:05:00',2.19),('8902','2013-07-03','13:10:00',2.71),('8902','2013-07-03','13:15:00',3.17),('8902','2013-07-03','13:20:00',3.59),('8902','2013-07-03','13:25:00',5.04),('8902','2013-07-03','13:30:00',3.91),('8902','2013-07-03','13:35:00',3.96),('8902','2013-07-03','13:40:00',5.95),('8902','2013-07-03','13:45:00',4.15),('8902','2013-07-03','13:50:00',6.92),('8902','2013-07-03','13:55:00',5.52),('8902','2013-07-03','14:00:00',4.11),('8902','2013-07-03','14:05:00',3.93),('8902','2013-07-03','14:10:00',3.92),('8902','2013-07-03','14:15:00',3.94),('8902','2013-07-03','14:20:00',4.63),('8902','2013-07-03','14:25:00',3.53),('8902','2013-07-03','14:30:00',3.48),('8902','2013-07-03','14:35:00',3.77),('8902','2013-07-03','14:40:00',5.96),('8902','2013-07-03','14:45:00',8.33),('8902','2013-07-03','14:50:00',5.83),('8902','2013-07-03','14:55:00',5.21),('8902','2013-07-03','15:00:00',8.09),('8902','2013-07-03','15:05:00',6.96),('8902','2013-07-03','15:10:00',6.45),('8902','2013-07-03','15:15:00',8.34),('8902','2013-07-03','15:20:00',7.97),('8902','2013-07-03','15:25:00',7.78),('8902','2013-07-03','15:30:00',4.93),('8902','2013-07-03','15:35:00',5.52),('8902','2013-07-03','15:40:00',5.13),('8902','2013-07-03','15:45:00',5.85),('8902','2013-07-03','15:50:00',4.89),('8902','2013-07-03','15:55:00',4.17),('8902','2013-07-03','16:00:00',4.29),('8902','2013-07-03','16:05:00',4.31),('8902','2013-07-03','16:10:00',3.8),('8902','2013-07-03','16:15:00',3.14),('8902','2013-07-03','16:20:00',3.45),('8902','2013-07-03','16:25:00',3.62),('8902','2013-07-03','16:30:00',3.8),('8902','2013-07-03','16:35:00',3.98),('8902','2013-07-03','16:40:00',3.11),('8902','2013-07-03','16:45:00',2.83),('8902','2013-07-03','16:50:00',2.87),('8902','2013-07-03','16:55:00',2.81),('8902','2013-07-03','17:00:00',2.47),('8902','2013-07-03','17:05:00',2.32),('8902','2013-07-03','17:10:00',3.06),('8902','2013-07-03','17:15:00',4.93),('8902','2013-07-03','17:20:00',4.78),('8902','2013-07-03','17:25:00',4.63),('8902','2013-07-03','17:30:00',4.1),('8902','2013-07-03','17:35:00',4.47),('8902','2013-07-03','17:40:00',4.51),('8902','2013-07-03','17:45:00',4.2),('8902','2013-07-03','17:50:00',4.13),('8902','2013-07-03','17:55:00',4.01),('8902','2013-07-03','18:00:00',3.78),('8902','2013-07-03','18:05:00',3.74),('8902','2013-07-03','18:10:00',3.62),('8902','2013-07-03','18:15:00',3.33),('8902','2013-07-03','18:20:00',2.74),('8902','2013-07-03','18:25:00',2.73),('8902','2013-07-03','18:30:00',1.84),('8902','2013-07-03','18:35:00',1.27),('8902','2013-07-02','07:25:00',1.04),('8902','2013-07-02','07:30:00',1.18),('8902','2013-07-02','07:35:00',1.33),('8902','2013-07-02','07:40:00',1.48),('8902','2013-07-02','07:45:00',1.64),('8902','2013-07-02','07:50:00',1.8),('8902','2013-07-02','07:55:00',1.95),('8902','2013-07-02','08:00:00',2.12),('8902','2013-07-02','08:05:00',2.29),('8902','2013-07-02','08:10:00',2.45),('8902','2013-07-02','08:15:00',2.61),('8902','2013-07-02','08:20:00',2.76),('8902','2013-07-02','08:25:00',2.92),('8902','2013-07-02','08:30:00',3.08),('8902','2013-07-02','08:35:00',3.25),('8902','2013-07-02','08:40:00',3.41),('8902','2013-07-02','08:45:00',3.56),('8902','2013-07-02','08:50:00',3.69),('8902','2013-07-02','08:55:00',3.81),('8902','2013-07-02','09:00:00',3.96),('8902','2013-07-02','09:05:00',4.11),('8902','2013-07-02','09:10:00',4.24),('8902','2013-07-02','09:15:00',4.38),('8902','2013-07-02','09:20:00',4.56),('8902','2013-07-02','09:25:00',4.66),('8902','2013-07-02','09:30:00',4.72),('8902','2013-07-02','09:35:00',4.87),('8902','2013-07-02','09:40:00',5.06),('8902','2013-07-02','09:45:00',5.14),('8902','2013-07-02','09:50:00',5.22),('8902','2013-07-02','09:55:00',5.36),('8902','2013-07-02','10:00:00',5.5),('8902','2013-07-02','10:05:00',5.55),('8902','2013-07-02','10:10:00',5.63),('8902','2013-07-02','10:15:00',5.71),('8902','2013-07-02','10:20:00',5.83),('8902','2013-07-02','10:25:00',6.01),('8902','2013-07-02','10:30:00',6.08),('8902','2013-07-02','10:35:00',6.08),('8902','2013-07-02','10:40:00',6.22),('8902','2013-07-02','10:45:00',6.32),('8902','2013-07-02','10:50:00',6.41),('8902','2013-07-02','10:55:00',6.44),('8902','2013-07-02','11:00:00',6.55),('8902','2013-07-02','11:05:00',6.62),('8902','2013-07-02','11:10:00',6.62),('8902','2013-07-02','11:15:00',6.83),('8902','2013-07-02','11:20:00',6.98),('8902','2013-07-02','11:25:00',7.05),('8902','2013-07-02','11:30:00',7.08),('8902','2013-07-02','11:35:00',7.03),('8902','2013-07-02','11:45:00',7.11),('8902','2013-07-02','11:50:00',7.4),('8902','2013-07-02','11:55:00',7.28),('8902','2013-07-02','12:00:00',7.34),('8902','2013-07-02','12:05:00',7.48),('8902','2013-07-02','12:10:00',7.55),('8902','2013-07-02','12:15:00',7.62),('8902','2013-07-02','12:20:00',7.58),('8902','2013-07-02','12:25:00',7.6),('8902','2013-07-02','12:30:00',7.6),('8902','2013-07-02','12:35:00',7.71),('8902','2013-07-02','12:40:00',7.75),('8902','2013-07-02','12:45:00',7.8),('8902','2013-07-02','12:50:00',7.82),('8902','2013-07-02','12:55:00',7.87),('8902','2013-07-02','13:00:00',7.9),('8902','2013-07-02','13:05:00',7.95),('8902','2013-07-02','13:10:00',7.95),('8902','2013-07-02','13:15:00',7.99),('8902','2013-07-02','13:20:00',7.97),('8902','2013-07-02','13:25:00',7.88),('8902','2013-07-02','13:30:00',7.92),('8902','2013-07-02','13:35:00',7.93),('8902','2013-07-02','13:40:00',7.94),('8902','2013-07-02','13:45:00',7.93),('8902','2013-07-02','13:50:00',7.92),('8902','2013-07-02','13:55:00',7.86),('8902','2013-07-02','14:00:00',7.87),('8902','2013-07-02','14:05:00',7.89),('8902','2013-07-02','14:10:00',7.89),('8902','2013-07-02','14:15:00',7.87),('8902','2013-07-02','14:20:00',7.85),('8902','2013-07-02','14:25:00',7.86),('8902','2013-07-02','14:30:00',7.87),('8902','2013-07-02','14:35:00',7.79),('8902','2013-07-02','14:40:00',7.79),('8902','2013-07-02','14:45:00',7.74),('8902','2013-07-02','14:50:00',7.68),('8902','2013-07-02','14:55:00',7.63),('8902','2013-07-02','15:00:00',7.61),('8902','2013-07-02','15:05:00',7.53),('8902','2013-07-02','15:10:00',7.47),('8902','2013-07-02','15:15:00',7.43),('8902','2013-07-02','15:20:00',7.4),('8902','2013-07-02','15:25:00',7.29),('8902','2013-07-02','15:30:00',7.23),('8902','2013-07-02','15:35:00',7.14),('8902','2013-07-02','15:40:00',7.08),('8902','2013-07-02','15:45:00',6.94),('8902','2013-07-02','15:50:00',6.89),('8902','2013-07-02','15:55:00',6.83),('8902','2013-07-02','16:00:00',6.71),('8902','2013-07-02','16:05:00',6.64),('8902','2013-07-02','16:10:00',6.57),('8902','2013-07-02','16:15:00',6.46),('8902','2013-07-02','16:20:00',6.34),('8902','2013-07-02','16:25:00',6.24),('8902','2013-07-02','16:30:00',6.14),('8902','2013-07-02','16:35:00',6.07),('8902','2013-07-02','16:40:00',5.81),('8902','2013-07-02','16:45:00',5.73),('8902','2013-07-02','16:50:00',5.62),('8902','2013-07-02','16:55:00',5.44),('8902','2013-07-02','17:00:00',5.29),('8902','2013-07-02','17:05:00',5.24),('8902','2013-07-02','17:10:00',5.08),('8902','2013-07-02','17:15:00',4.95),('8902','2013-07-02','17:20:00',4.84),('8902','2013-07-02','17:25:00',4.66),('8902','2013-07-02','17:30:00',4.51),('8902','2013-07-02','17:35:00',4.39),('8902','2013-07-02','17:40:00',4.22),('8902','2013-07-02','17:45:00',4.06),('8902','2013-07-02','17:50:00',3.92),('8902','2013-07-02','17:55:00',3.71),('8902','2013-07-02','18:00:00',3.44),('8902','2013-07-02','18:05:00',3.35),('8902','2013-07-02','18:10:00',3.13),('8902','2013-07-02','18:15:00',3.04),('8902','2013-07-02','18:20:00',2.89),('8902','2013-07-02','18:25:00',2.69),('8902','2013-07-02','18:30:00',2.51),('8902','2013-07-02','18:35:00',2.33),('8902','2013-07-02','18:40:00',2.15),('8902','2013-07-02','18:45:00',1.97),('8902','2013-07-02','18:50:00',1.8),('8902','2013-07-02','18:55:00',1.63),('8902','2013-07-02','19:00:00',1.48),('8902','2013-07-02','19:05:00',1.31),('8902','2013-07-02','19:10:00',1.13),('8902','2013-07-01','07:25:00',1.05),('8902','2013-07-01','07:30:00',1.18),('8902','2013-07-01','07:35:00',1.32),('8902','2013-07-01','07:40:00',1.47),('8902','2013-07-01','07:45:00',1.62),('8902','2013-07-01','07:50:00',1.77),('8902','2013-07-01','07:55:00',1.92),('8902','2013-07-01','08:00:00',2.08),('8902','2013-07-01','08:05:00',2.24),('8902','2013-07-01','08:10:00',2.41),('8902','2013-07-01','08:15:00',2.57),('8902','2013-07-01','08:20:00',2.74),('8902','2013-07-01','08:25:00',2.89),('8902','2013-07-01','08:30:00',3.04),('8902','2013-07-01','08:35:00',3.21),('8902','2013-07-01','08:40:00',3.37),('8902','2013-07-01','08:45:00',3.53),('8902','2013-07-01','08:50:00',3.68),('8902','2013-07-01','08:55:00',3.79),('8902','2013-07-01','09:00:00',3.92),('8902','2013-07-01','09:05:00',4.09),('8902','2013-07-01','09:10:00',4.26),('8902','2013-07-01','09:15:00',4.37),('8902','2013-07-01','09:20:00',4.51),('8902','2013-07-01','09:25:00',4.65),('8902','2013-07-01','09:30:00',4.75),('8902','2013-07-01','09:35:00',4.88),('8902','2013-07-01','09:40:00',5.02),('8902','2013-07-01','09:45:00',5.14),('8902','2013-07-01','09:50:00',5.24),('8902','2013-07-01','09:55:00',5.36),('8902','2013-07-01','10:00:00',5.5),('8902','2013-07-01','10:05:00',5.57),('8902','2013-07-01','10:10:00',5.65),('8902','2013-07-01','10:15:00',5.75),('8902','2013-07-01','10:20:00',5.82),('8902','2013-07-01','10:25:00',5.95),('8902','2013-07-01','10:30:00',6.06),('8902','2013-07-01','10:35:00',6.16),('8902','2013-07-01','10:40:00',6.21),('8902','2013-07-01','10:45:00',6.28),('8902','2013-07-01','10:50:00',6.35),('8902','2013-07-01','10:55:00',6.43),('8902','2013-07-01','11:00:00',6.44),('8902','2013-07-01','11:05:00',6.48),('8902','2013-07-01','11:10:00',6.61),('8902','2013-07-01','11:15:00',6.65),('8902','2013-07-01','11:20:00',6.69),('8902','2013-07-01','11:25:00',6.79),('8902','2013-07-01','11:30:00',6.94),('8902','2013-07-01','11:35:00',7.07),('8902','2013-07-01','11:40:00',7.02),('8902','2013-07-01','11:45:00',7.05),('8902','2013-07-01','11:50:00',7.15),('8902','2013-07-01','11:55:00',7.24),('8902','2013-07-01','12:00:00',7.15),('8902','2013-07-01','12:05:00',7.11),('8902','2013-07-01','12:10:00',7.22),('8902','2013-07-01','12:15:00',7.31),('8902','2013-07-01','12:20:00',7.29),('8902','2013-07-01','12:25:00',7.34),('8902','2013-07-01','12:30:00',7.42),('8902','2013-07-01','12:35:00',7.53),('8902','2013-07-01','12:40:00',7.68),('8902','2013-07-01','12:45:00',7.89),('8902','2013-07-01','12:50:00',7.95),('8902','2013-07-01','12:55:00',6.41),('8902','2013-07-01','13:00:00',4.57),('8902','2013-07-01','13:05:00',7.14),('8902','2013-07-01','13:10:00',5.95),('8902','2013-07-01','13:15:00',7.93),('8902','2013-07-01','13:20:00',8.16),('8902','2013-07-01','13:25:00',8.17),('8902','2013-07-01','13:30:00',8.01),('8902','2013-07-01','13:35:00',7.76),('8902','2013-07-01','13:40:00',8.05),('8902','2013-07-01','13:45:00',7.78),('8902','2013-07-01','13:50:00',7.38),('8902','2013-07-01','13:55:00',7.51),('8902','2013-07-01','14:00:00',7.66),('8902','2013-07-01','14:05:00',7.62),('8902','2013-07-01','14:10:00',7.65),('8902','2013-07-01','14:15:00',7.57),('8902','2013-07-01','14:20:00',7.59),('8902','2013-07-01','14:25:00',7.59),('8902','2013-07-01','14:30:00',7.57),('8902','2013-07-01','14:35:00',7.51),('8902','2013-07-01','14:40:00',7.45),('8902','2013-07-01','14:45:00',7.41),('8902','2013-07-01','14:50:00',7.43),('8902','2013-07-01','14:55:00',7.36),('8902','2013-07-01','15:00:00',7.29),('8902','2013-07-01','15:05:00',7.32),('8902','2013-07-01','15:10:00',7.3),('8902','2013-07-01','15:15:00',7.21),('8902','2013-07-01','15:20:00',7.17),('8902','2013-07-01','15:25:00',7.12),('8902','2013-07-01','15:30:00',7.01),('8902','2013-07-01','15:35:00',7),('8902','2013-07-01','15:40:00',6.95),('8902','2013-07-01','15:45:00',6.82),('8902','2013-07-01','15:50:00',6.73),('8902','2013-07-01','15:55:00',6.66),('8902','2013-07-01','16:00:00',6.57),('8902','2013-07-01','16:05:00',6.51),('8902','2013-07-01','16:10:00',6.41),('8902','2013-07-01','16:15:00',6.32),('8902','2013-07-01','16:20:00',6.19),('8902','2013-07-01','16:25:00',6.08),('8902','2013-07-01','16:30:00',5.95),('8902','2013-07-01','16:35:00',5.83),('8902','2013-07-01','16:40:00',5.61),('8902','2013-07-01','16:45:00',5.52),('8902','2013-07-01','16:50:00',5.41),('8902','2013-07-01','16:55:00',5.21),('8902','2013-07-01','17:00:00',5.1),('8902','2013-07-01','17:05:00',5.06),('8902','2013-07-01','17:10:00',4.89),('8902','2013-07-01','17:15:00',4.79),('8902','2013-07-01','17:20:00',4.64),('8902','2013-07-01','17:25:00',4.46),('8902','2013-07-01','17:30:00',4.26),('8902','2013-07-01','17:35:00',4.18),('8902','2013-07-01','17:40:00',4.01),('8902','2013-07-01','17:45:00',3.85),('8902','2013-07-01','17:50:00',3.7),('8902','2013-07-01','17:55:00',3.51),('8902','2013-07-01','18:00:00',3.25),('8902','2013-07-01','18:05:00',3.18),('8902','2013-07-01','18:10:00',3.04),('8902','2013-07-01','18:15:00',2.89),('8902','2013-07-01','18:20:00',2.75),('8902','2013-07-01','18:25:00',2.54),('8902','2013-07-01','18:30:00',2.35),('8902','2013-07-01','18:35:00',2.17),('8902','2013-07-01','18:40:00',2.01),('8902','2013-07-01','18:45:00',1.84),('8902','2013-07-01','18:50:00',1.68),('8902','2013-07-01','18:55:00',1.54),('8902','2013-07-01','19:00:00',1.38),('8902','2013-07-01','19:05:00',1.23),('8902','2013-07-01','19:10:00',1.07),('8902','2013-06-30','07:25:00',1.1),('8902','2013-06-30','07:30:00',1.24),('8902','2013-06-30','07:35:00',1.38),('8902','2013-06-30','07:40:00',1.51),('8902','2013-06-30','07:45:00',1.66),('8902','2013-06-30','07:50:00',1.82),('8902','2013-06-30','07:55:00',1.97),('8902','2013-06-30','08:00:00',2.14),('8902','2013-06-30','08:05:00',2.32),('8902','2013-06-30','08:10:00',2.48),('8902','2013-06-30','08:15:00',2.64),('8902','2013-06-30','08:20:00',2.8),('8902','2013-06-30','08:25:00',2.96),('8902','2013-06-30','08:30:00',3.13),('8902','2013-06-30','08:35:00',3.28),('8902','2013-06-30','08:40:00',3.44),('8902','2013-06-30','08:45:00',3.6),('8902','2013-06-30','08:50:00',3.75),('8902','2013-06-30','08:55:00',3.91),('8902','2013-06-30','09:00:00',4.05),('8902','2013-06-30','09:05:00',4.18),('8902','2013-06-30','09:10:00',4.34),('8902','2013-06-30','09:15:00',4.51),('8902','2013-06-30','09:20:00',4.65),('8902','2013-06-30','09:25:00',4.77),('8902','2013-06-30','09:30:00',4.93),('8902','2013-06-30','09:35:00',5.08),('8902','2013-06-30','09:40:00',5.17),('8902','2013-06-30','09:45:00',5.29),('8902','2013-06-30','09:50:00',5.42),('8902','2013-06-30','09:55:00',5.51),('8902','2013-06-30','10:00:00',5.6),('8902','2013-06-30','10:05:00',5.68),('8902','2013-06-30','10:10:00',5.82),('8902','2013-06-30','10:15:00',5.92),('8902','2013-06-30','10:20:00',6.05),('8902','2013-06-30','10:25:00',6.17),('8902','2013-06-30','10:30:00',6.26),('8902','2013-06-30','10:35:00',6.38),('8902','2013-06-30','10:40:00',6.52),('8902','2013-06-30','10:45:00',6.62),('8902','2013-06-30','10:50:00',6.63),('8902','2013-06-30','10:55:00',6.7),('8902','2013-06-30','11:00:00',6.77),('8902','2013-06-30','11:05:00',6.93),('8902','2013-06-30','11:10:00',7.02),('8902','2013-06-30','11:15:00',7.12),('8902','2013-06-30','11:20:00',7.1),('8902','2013-06-30','11:25:00',7.18),('8902','2013-06-30','11:30:00',7.29),('8902','2013-06-30','11:35:00',7.37),('8902','2013-06-30','11:40:00',7.41),('8902','2013-06-30','11:45:00',7.44),('8902','2013-06-30','11:50:00',7.48),('8902','2013-06-30','11:55:00',7.51),('8902','2013-06-30','12:00:00',7.57),('8902','2013-06-30','12:05:00',7.58),('8902','2013-06-30','12:10:00',7.54),('8902','2013-06-30','12:15:00',7.55),('8902','2013-06-30','12:20:00',7.63),('8902','2013-06-30','12:25:00',7.68),('8902','2013-06-30','12:30:00',7.68),('8902','2013-06-30','12:35:00',7.75),('8902','2013-06-30','12:40:00',7.73),('8902','2013-06-30','12:45:00',7.76),('8902','2013-06-30','12:50:00',7.76),('8902','2013-06-30','12:55:00',7.79),('8902','2013-06-30','13:00:00',7.83),('8902','2013-06-30','13:05:00',7.85),('8902','2013-06-30','13:10:00',7.9),('8902','2013-06-30','13:15:00',7.86),('8902','2013-06-30','13:20:00',7.85),('8902','2013-06-30','13:25:00',7.92),('8902','2013-06-30','13:30:00',7.91),('8902','2013-06-30','13:35:00',7.86),('8902','2013-06-30','13:40:00',7.85),('8902','2013-06-30','13:45:00',7.73),('8902','2013-06-30','13:50:00',7.69),('8902','2013-06-30','13:55:00',7.78),('8902','2013-06-30','14:00:00',7.76),('8902','2013-06-30','14:05:00',7.84),('8902','2013-06-30','14:10:00',7.8),('8902','2013-06-30','14:15:00',7.85),('8902','2013-06-30','14:20:00',7.75),('8902','2013-06-30','14:25:00',7.68),('8902','2013-06-30','14:30:00',7.58),('8902','2013-06-30','14:35:00',7.63),('8902','2013-06-30','14:40:00',7.6),('8902','2013-06-30','14:45:00',7.55),('8902','2013-06-30','14:50:00',7.42),('8902','2013-06-30','14:55:00',7.39),('8902','2013-06-30','15:00:00',7.38),('8902','2013-06-30','15:05:00',7.26),('8902','2013-06-30','15:10:00',7.25),('8902','2013-06-30','15:15:00',7.19),('8902','2013-06-30','15:20:00',7.14),('8902','2013-06-30','15:25:00',7.08),('8902','2013-06-30','15:30:00',7),('8902','2013-06-30','15:35:00',6.84),('8902','2013-06-30','15:40:00',6.75),('8902','2013-06-30','15:45:00',6.78),('8902','2013-06-30','15:50:00',6.67),('8902','2013-06-30','15:55:00',6.6),('8902','2013-06-30','16:00:00',6.48),('8902','2013-06-30','16:05:00',6.4),('8902','2013-06-30','16:10:00',6.31),('8902','2013-06-30','16:15:00',6.16),('8902','2013-06-30','16:20:00',6.02),('8902','2013-06-30','16:25:00',5.9),('8902','2013-06-30','16:30:00',5.8),('8902','2013-06-30','16:35:00',5.7),('8902','2013-06-30','16:40:00',5.54),('8902','2013-06-30','16:45:00',5.46),('8902','2013-06-30','16:50:00',5.41),('8902','2013-06-30','16:55:00',5.23),('8902','2013-06-30','17:00:00',5.14),('8902','2013-06-30','17:05:00',5.03),('8902','2013-06-30','17:10:00',4.91),('8902','2013-06-30','17:15:00',4.77),('8902','2013-06-30','17:20:00',4.6),('8902','2013-06-30','17:25:00',4.4),('8902','2013-06-30','17:30:00',4.24),('8902','2013-06-30','17:35:00',4.1),('8902','2013-06-30','17:40:00',3.95),('8902','2013-06-30','17:45:00',3.83),('8902','2013-06-30','17:50:00',3.7),('8902','2013-06-30','17:55:00',3.51),('8902','2013-06-30','18:00:00',3.03),('8902','2013-06-30','18:05:00',3.12),('8902','2013-06-30','18:10:00',3),('8902','2013-06-30','18:15:00',2.43),('8902','2013-06-30','18:20:00',2.43),('8902','2013-06-30','18:25:00',2.61),('8902','2013-06-30','18:30:00',2.42),('8902','2013-06-30','18:35:00',2.21),('8902','2013-06-30','18:40:00',1.95),('8902','2013-06-30','18:45:00',1.82),('8902','2013-06-30','18:50:00',1.64),('8902','2013-06-30','18:55:00',1.42),('8902','2013-06-30','19:00:00',1.31),('8902','2013-06-30','19:05:00',1.2),('8902','2013-06-30','19:10:00',1.05),('8902','2014-04-04','08:35:00',1.16),('8902','2014-04-04','08:40:00',1.07),('8902','2014-04-04','09:00:00',1.25),('8902','2014-04-04','09:05:00',1.64),('8902','2014-04-04','09:10:00',1.74),('8902','2014-04-04','09:15:00',2.35),('8902','2014-04-04','09:20:00',3.14),('8902','2014-04-04','09:25:00',4.85),('8902','2014-04-04','09:30:00',6.17),('8902','2014-04-04','09:35:00',5.93),('8902','2014-04-04','09:40:00',5.77),('8902','2014-04-04','09:45:00',3.55),('8902','2014-04-04','09:50:00',2.72),('8902','2014-04-04','09:55:00',4.29),('8902','2014-04-04','10:00:00',4.38),('8902','2014-04-04','10:05:00',4.67),('8902','2014-04-04','10:10:00',3.96),('8902','2014-04-04','10:15:00',3.11),('8902','2014-04-04','10:20:00',4.2),('8902','2014-04-04','10:25:00',4.98),('8902','2014-04-04','10:30:00',5.04),('8902','2014-04-04','10:35:00',6.04),('8902','2014-04-04','10:40:00',6.26),('8902','2014-04-04','10:45:00',5.49),('8902','2014-04-04','10:50:00',4.65),('8902','2014-04-04','10:55:00',5.76),('8902','2014-04-04','11:00:00',6.77),('8902','2014-04-04','11:05:00',7.32),('8902','2014-04-04','11:10:00',7.49),('8902','2014-04-04','11:15:00',7.94),('8902','2014-04-04','11:20:00',7.69),('8902','2014-04-04','11:25:00',4.7),('8902','2014-04-04','11:30:00',3.94),('8902','2014-04-04','11:35:00',5.71),('8902','2014-04-04','11:40:00',7.3),('8902','2014-04-04','11:45:00',8.07),('8902','2014-04-04','11:50:00',8.54),('8902','2014-04-04','11:55:00',7.69),('8902','2014-04-04','12:00:00',5.61),('8902','2014-04-04','12:05:00',5.87),('8902','2014-04-04','12:10:00',6.59),('8902','2014-04-04','12:15:00',6.93),('8902','2014-04-04','12:20:00',6.42),('8902','2014-04-04','12:25:00',4.9),('8902','2014-04-04','12:30:00',5.4),('8902','2014-04-04','12:35:00',5.82),('8902','2014-04-04','12:40:00',8.73),('8902','2014-04-04','12:45:00',9.68),('8902','2014-04-04','12:50:00',9.18),('8902','2014-04-04','12:55:00',7.04),('8902','2014-04-04','13:00:00',7.84),('8902','2014-04-04','13:05:00',7.22),('8902','2014-04-04','13:10:00',7.79),('8902','2014-04-04','13:15:00',4.1),('8902','2014-04-04','13:20:00',7.89),('8902','2014-04-04','13:25:00',7.77),('8902','2014-04-04','13:30:00',7.98),('8902','2014-04-04','13:35:00',9.44),('8902','2014-04-04','13:40:00',6.9),('8902','2014-04-04','13:45:00',4.42),('8902','2014-04-04','13:50:00',7.13),('8902','2014-04-04','13:55:00',8.11),('8902','2014-04-04','14:00:00',6.42),('8902','2014-04-04','14:05:00',9.91),('8902','2014-04-04','14:10:00',4.32),('8902','2014-04-04','14:15:00',1.72),('8902','2014-04-04','14:20:00',1.97),('8902','2014-04-04','14:25:00',5.3),('8902','2014-04-04','14:30:00',3.07),('8902','2014-04-04','14:35:00',1.86),('8902','2014-04-04','14:40:00',1.65),('8902','2014-04-04','14:45:00',1.44),('8902','2014-04-04','14:50:00',3.18),('8902','2014-04-04','14:55:00',8.42),('8902','2014-04-04','15:00:00',5),('8902','2014-04-04','15:05:00',7.58),('8902','2014-04-04','15:10:00',3.26),('8902','2014-04-04','15:15:00',5.51),('8902','2014-04-04','15:20:00',8.7),('8902','2014-04-04','15:25:00',5.76),('8902','2014-04-04','15:30:00',2.8),('8902','2014-04-04','15:35:00',3.03),('8902','2014-04-04','15:40:00',6.76),('8902','2014-04-04','15:45:00',2.95),('8902','2014-04-04','15:50:00',3.26),('8902','2014-04-04','15:55:00',2.44),('8902','2014-04-04','16:00:00',2.54),('8902','2014-04-04','16:05:00',2.97),('8902','2014-04-04','16:10:00',2.52),('8902','2014-04-04','16:15:00',6.22),('8902','2014-04-04','16:20:00',6.65),('8902','2014-04-04','16:25:00',6.25),('8902','2014-04-04','16:30:00',4.21),('8902','2014-04-04','16:35:00',5.62),('8902','2014-04-04','16:40:00',3.06),('8902','2014-04-04','16:45:00',4.41),('8902','2014-04-04','16:50:00',3.39),('8902','2014-04-04','16:55:00',3.85),('8902','2014-04-04','17:00:00',4.51),('8902','2014-04-04','17:05:00',4.3),('8902','2014-04-04','17:10:00',3.73),('8902','2014-04-04','17:15:00',2.92),('8902','2014-04-04','17:20:00',3.06),('8902','2014-04-04','17:25:00',2.9),('8902','2014-04-04','17:30:00',2.72),('8902','2014-04-04','17:35:00',2.42),('8902','2014-04-04','17:40:00',2.3),('8902','2014-04-04','17:45:00',1.85),('8902','2014-04-04','17:50:00',2.56),('8902','2014-04-04','17:55:00',2.61),('8902','2014-04-04','18:00:00',2.51),('8902','2014-04-04','18:05:00',2.28),('8902','2014-04-04','18:10:00',2.17),('8902','2014-04-04','18:15:00',2.2),('8902','2014-04-04','18:20:00',2.03),('8902','2014-04-04','18:25:00',1.52),('8902','2013-06-29','07:20:00',1.03),('8902','2013-06-29','07:25:00',1.16),('8902','2013-06-29','07:30:00',1.31),('8902','2013-06-29','07:35:00',1.46),('8902','2013-06-29','07:40:00',1.6),('8902','2013-06-29','07:45:00',1.75),('8902','2013-06-29','07:50:00',1.91),('8902','2013-06-29','07:55:00',2.07),('8902','2013-06-29','08:00:00',2.23),('8902','2013-06-29','08:05:00',2.39),('8902','2013-06-29','08:10:00',2.56),('8902','2013-06-29','08:15:00',2.73),('8902','2013-06-29','08:20:00',2.9),('8902','2013-06-29','08:25:00',3.07),('8902','2013-06-29','08:30:00',3.24),('8902','2013-06-29','08:35:00',3.4),('8902','2013-06-29','08:40:00',3.56),('8902','2013-06-29','08:45:00',3.72),('8902','2013-06-29','08:50:00',3.88),('8902','2013-06-29','08:55:00',4.03),('8902','2013-06-29','09:00:00',4.18),('8902','2013-06-29','09:05:00',4.34),('8902','2013-06-29','09:10:00',4.48),('8902','2013-06-29','09:15:00',4.62),('8902','2013-06-29','09:20:00',4.76),('8902','2013-06-29','09:25:00',4.88),('8902','2013-06-29','09:30:00',5.03),('8902','2013-06-29','09:35:00',5.16),('8902','2013-06-29','09:40:00',5.28),('8902','2013-06-29','09:45:00',5.42),('8902','2013-06-29','09:50:00',5.56),('8902','2013-06-29','09:55:00',5.66),('8902','2013-06-29','10:00:00',5.76),('8902','2013-06-29','10:05:00',5.89),('8902','2013-06-29','10:10:00',6),('8902','2013-06-29','10:15:00',6.09),('8902','2013-06-29','10:20:00',6.21),('8902','2013-06-29','10:25:00',6.31),('8902','2013-06-29','10:30:00',6.39),('8902','2013-06-29','10:35:00',6.51),('8902','2013-06-29','10:40:00',6.6),('8902','2013-06-29','10:45:00',6.71),('8902','2013-06-29','10:50:00',6.76),('8902','2013-06-29','10:55:00',6.85),('8902','2013-06-29','11:00:00',6.97),('8902','2013-06-29','11:05:00',7.02),('8902','2013-06-29','11:10:00',7.07),('8902','2013-06-29','11:15:00',7.09),('8902','2013-06-29','11:20:00',7.12),('8902','2013-06-29','11:25:00',7.21),('8902','2013-06-29','11:30:00',7.31),('8902','2013-06-29','11:35:00',7.36),('8902','2013-06-29','11:40:00',7.39),('8902','2013-06-29','11:45:00',7.42),('8902','2013-06-29','11:50:00',7.51),('8902','2013-06-29','11:55:00',7.57),('8902','2013-06-29','12:00:00',7.6),('8902','2013-06-29','12:05:00',7.63),('8902','2013-06-29','12:10:00',7.66),('8902','2013-06-29','12:15:00',7.71),('8902','2013-06-29','12:20:00',7.75),('8902','2013-06-29','12:25:00',7.79),('8902','2013-06-29','12:30:00',7.83),('8902','2013-06-29','12:35:00',7.8),('8902','2013-06-29','12:40:00',7.87),('8902','2013-06-29','12:45:00',7.99),('8902','2013-06-29','12:50:00',8.06),('8902','2013-06-29','12:55:00',8.05),('8902','2013-06-29','13:00:00',7.98),('8902','2013-06-29','13:05:00',8.05),('8902','2013-06-29','13:10:00',8.1),('8902','2013-06-29','13:15:00',8.03),('8902','2013-06-29','13:20:00',8.02),('8902','2013-06-29','13:25:00',8.1),('8902','2013-06-29','13:30:00',8.09),('8902','2013-06-29','13:35:00',7.96),('8902','2013-06-29','13:40:00',8.03),('8902','2013-06-29','13:45:00',8.08),('8902','2013-06-29','13:50:00',8.11),('8902','2013-06-29','13:55:00',7.92),('8902','2013-06-29','14:00:00',7.9),('8902','2013-06-29','14:05:00',8.01),('8902','2013-06-29','14:10:00',7.94),('8902','2013-06-29','14:15:00',7.81),('8902','2013-06-29','14:20:00',7.78),('8902','2013-06-29','14:25:00',7.74),('8902','2013-06-29','14:30:00',7.69),('8902','2013-06-29','14:35:00',7.68),('8902','2013-06-29','14:40:00',7.69),('8902','2013-06-29','14:45:00',7.66),('8902','2013-06-29','14:50:00',7.63),('8902','2013-06-29','14:55:00',7.61),('8902','2013-06-29','15:00:00',7.54),('8902','2013-06-29','15:05:00',7.41),('8902','2013-06-29','15:10:00',7.44),('8902','2013-06-29','15:15:00',7.39),('8902','2013-06-29','15:20:00',7.36),('8902','2013-06-29','15:25:00',7.24),('8902','2013-06-29','15:30:00',7.17),('8902','2013-06-29','15:35:00',7.17),('8902','2013-06-29','15:40:00',7.12),('8902','2013-06-29','15:45:00',7.03),('8902','2013-06-29','15:50:00',6.96),('8902','2013-06-29','15:55:00',6.84),('8902','2013-06-29','16:00:00',6.76),('8902','2013-06-29','16:05:00',6.64),('8902','2013-06-29','16:10:00',6.63),('8902','2013-06-29','16:15:00',6.57),('8902','2013-06-29','16:20:00',6.59),('8902','2013-06-29','16:25:00',6.69),('8902','2013-06-29','16:30:00',6.7),('8902','2013-06-29','16:35:00',5.78),('8902','2013-06-29','16:40:00',5.74),('8902','2013-06-29','16:45:00',5.72),('8902','2013-06-29','16:50:00',5.61),('8902','2013-06-29','16:55:00',5.33),('8902','2013-06-29','17:00:00',5.15),('8902','2013-06-29','17:05:00',5.11),('8902','2013-06-29','17:10:00',5.02),('8902','2013-06-29','17:15:00',4.86),('8902','2013-06-29','17:20:00',4.7),('8902','2013-06-29','17:25:00',4.46),('8902','2013-06-29','17:30:00',4.26),('8902','2013-06-29','17:35:00',4.1),('8902','2013-06-29','17:40:00',3.99),('8902','2013-06-29','17:45:00',3.8),('8902','2013-06-29','17:50:00',3.71),('8902','2013-06-29','17:55:00',3.5),('8902','2013-06-29','18:00:00',3.27),('8902','2013-06-29','18:05:00',3.13),('8902','2013-06-29','18:10:00',3.01),('8902','2013-06-29','18:15:00',2.87),('8902','2013-06-29','18:20:00',2.75),('8902','2013-06-29','18:25:00',2.53),('8902','2013-06-29','18:30:00',2.35),('8902','2013-06-29','18:35:00',2.14),('8902','2013-06-29','18:40:00',2.01),('8902','2013-06-29','18:45:00',1.84),('8902','2013-06-29','18:50:00',1.67),('8902','2013-06-29','18:55:00',1.56),('8902','2013-06-29','19:00:00',1.4),('8902','2013-06-29','19:05:00',1.26),('8902','2013-06-29','19:10:00',1.11),('8902','2013-06-28','07:25:00',1.12),('8902','2013-06-28','07:30:00',1.66),('8902','2013-06-28','07:35:00',2.07),('8902','2013-06-28','07:40:00',2.19),('8902','2013-06-28','07:45:00',2.21),('8902','2013-06-28','07:50:00',2.34),('8902','2013-06-28','07:55:00',2.53),('8902','2013-06-28','08:00:00',3.03),('8902','2013-06-28','08:05:00',3.32),('8902','2013-06-28','08:10:00',3.48),('8902','2013-06-28','08:15:00',3.17),('8902','2013-06-28','08:20:00',2.09),('8902','2013-06-28','08:25:00',3.2),('8902','2013-06-28','08:30:00',3.45),('8902','2013-06-28','08:35:00',3.57),('8902','2013-06-28','08:40:00',2.52),('8902','2013-06-28','08:45:00',3.16),('8902','2013-06-28','08:50:00',3.91),('8902','2013-06-28','08:55:00',4.02),('8902','2013-06-28','09:00:00',4.11),('8902','2013-06-28','09:05:00',4.25),('8902','2013-06-28','09:10:00',4.4),('8902','2013-06-28','09:15:00',4.55),('8902','2013-06-28','09:20:00',4.68),('8902','2013-06-28','09:25:00',4.8),('8902','2013-06-28','09:30:00',4.86),('8902','2013-06-28','09:35:00',5.08),('8902','2013-06-28','09:40:00',5.22),('8902','2013-06-28','09:45:00',5.31),('8902','2013-06-28','09:50:00',5.47),('8902','2013-06-28','09:55:00',5.59),('8902','2013-06-28','10:00:00',5.7),('8902','2013-06-28','10:05:00',5.82),('8902','2013-06-28','10:10:00',5.92),('8902','2013-06-28','10:15:00',6.03),('8902','2013-06-28','10:20:00',6.11),('8902','2013-06-28','10:25:00',6.27),('8902','2013-06-28','10:30:00',6.38),('8902','2013-06-28','10:35:00',6.47),('8902','2013-06-28','10:40:00',6.56),('8902','2013-06-28','10:45:00',6.72),('8902','2013-06-28','10:50:00',6.81),('8902','2013-06-28','10:55:00',6.85),('8902','2013-06-28','11:00:00',6.99),('8902','2013-06-28','11:05:00',7.14),('8902','2013-06-28','11:10:00',7.31),('8902','2013-06-28','11:15:00',7.45),('8902','2013-06-28','11:20:00',5.47),('8902','2013-06-28','11:25:00',7.27),('8902','2013-06-28','11:30:00',8.05),('8902','2013-06-28','11:35:00',7.93),('8902','2013-06-28','11:40:00',8.33),('8902','2013-06-28','11:45:00',3.36),('8902','2013-06-28','11:50:00',3.29),('8902','2013-06-28','11:55:00',8.86),('8902','2013-06-28','12:00:00',6.72),('8902','2013-06-28','12:05:00',8.1),('8902','2013-06-28','12:10:00',8.22),('8902','2013-06-28','12:15:00',8.38),('8902','2013-06-28','12:20:00',2.88),('8902','2013-06-28','12:25:00',7.51),('8902','2013-06-28','12:30:00',8.51),('8902','2013-06-28','12:35:00',8.45),('8902','2013-06-28','12:40:00',8.44),('8902','2013-06-28','12:45:00',8.78),('8902','2013-06-28','12:50:00',6.12),('8902','2013-06-28','12:55:00',4.68),('8902','2013-06-28','13:00:00',6.37),('8902','2013-06-28','13:05:00',4.91),('8902','2013-06-28','13:10:00',8.01),('8902','2013-06-28','13:15:00',9.26),('8902','2013-06-28','13:20:00',6.02),('8902','2013-06-28','13:25:00',9.37),('8902','2013-06-28','13:30:00',4.52),('8902','2013-06-28','13:35:00',1.66),('8902','2013-06-28','13:40:00',1.66),('8902','2013-06-28','13:45:00',4.16),('8902','2013-06-28','13:50:00',8.09),('8902','2013-06-28','13:55:00',4.67),('8902','2013-06-28','14:00:00',8.85),('8902','2013-06-28','14:05:00',6.71),('8902','2013-06-28','14:10:00',7.53),('8902','2013-06-28','14:15:00',9.26),('8902','2013-06-28','14:20:00',9.35),('8902','2013-06-28','14:25:00',5.31),('8902','2013-06-28','14:30:00',9.37),('8902','2013-06-28','14:35:00',8.69),('8902','2013-06-28','14:40:00',8.66),('8902','2013-06-28','14:45:00',8.82),('8902','2013-06-28','14:50:00',8.25),('8902','2013-06-28','14:55:00',2.21),('8902','2013-06-28','15:00:00',4.27),('8902','2013-06-28','15:05:00',5.42),('8902','2013-06-28','15:10:00',2.89),('8902','2013-06-28','15:15:00',3.01),('8902','2013-06-28','15:20:00',1.71),('8902','2013-06-28','15:25:00',1.18),('8902','2013-06-28','15:30:00',1.02),('8902','2013-06-28','15:35:00',1.03),('8902','2013-06-28','15:40:00',1.04),('8902','2013-06-28','16:30:00',1.11),('8902','2013-06-28','16:35:00',1.55),('8902','2013-06-28','16:40:00',2.22),('8902','2013-06-28','16:45:00',3.07),('8902','2013-06-28','16:50:00',4.83),('8902','2013-06-28','16:55:00',3.18),('8902','2013-06-28','17:00:00',1.99),('8902','2013-06-28','17:05:00',2.33),('8902','2013-06-28','17:10:00',2.2),('8902','2013-06-28','17:15:00',1.93),('8902','2013-06-28','17:20:00',2.21),('8902','2013-06-28','17:25:00',2.7),('8902','2013-06-28','17:30:00',5.12),('8902','2013-06-28','17:35:00',4.97),('8902','2013-06-28','17:40:00',1.74),('8902','2013-06-28','17:45:00',3.78),('8902','2013-06-28','17:50:00',3.99),('8902','2013-06-28','17:55:00',3.71),('8902','2013-06-28','18:00:00',3.38),('8902','2013-06-28','18:05:00',3.34),('8902','2013-06-28','18:10:00',3.14),('8902','2013-06-28','18:15:00',2.96),('8902','2013-06-28','18:20:00',2.76),('8902','2013-06-28','18:25:00',2.51),('8902','2013-06-28','18:30:00',2.35),('8902','2013-06-28','18:35:00',2.43),('8902','2013-06-28','18:40:00',2.27),('8902','2013-06-28','18:45:00',1.59),('8902','2013-06-28','19:05:00',1.02),('8902','2013-06-28','19:10:00',1.14),('8902','2013-06-27','07:10:00',1.02),('8902','2013-06-27','07:15:00',1),('8902','2013-06-27','07:20:00',1.1),('8902','2013-06-27','07:25:00',1.22),('8902','2013-06-27','07:30:00',1.41),('8902','2013-06-27','07:35:00',1.52),('8902','2013-06-27','07:40:00',1.58),('8902','2013-06-27','07:45:00',1.86),('8902','2013-06-27','07:50:00',1.97),('8902','2013-06-27','07:55:00',2.13),('8902','2013-06-27','08:00:00',2.26),('8902','2013-06-27','08:05:00',2.27),('8902','2013-06-27','08:10:00',2.36),('8902','2013-06-27','08:15:00',2.66),('8902','2013-06-27','08:20:00',2.83),('8902','2013-06-27','08:25:00',2.81),('8902','2013-06-27','08:30:00',3.08),('8902','2013-06-27','08:35:00',3.32),('8902','2013-06-27','08:40:00',3.49),('8902','2013-06-27','08:45:00',3.59),('8902','2013-06-27','08:50:00',3.77),('8902','2013-06-27','08:55:00',3.9),('8902','2013-06-27','09:00:00',4.02),('8902','2013-06-27','09:05:00',4.25),('8902','2013-06-27','09:10:00',4.64),('8902','2013-06-27','09:15:00',3.31),('8902','2013-06-27','09:20:00',2.21),('8902','2013-06-27','09:25:00',1.68),('8902','2013-06-27','09:30:00',3.5),('8902','2013-06-27','09:35:00',5.45),('8902','2013-06-27','09:40:00',4.79),('8902','2013-06-27','09:45:00',3.81),('8902','2013-06-27','09:50:00',1.92),('8902','2013-06-27','09:55:00',6.34),('8902','2013-06-27','10:00:00',6.29),('8902','2013-06-27','10:05:00',5.97),('8902','2013-06-27','10:10:00',5.13),('8902','2013-06-27','10:15:00',6.06),('8902','2013-06-27','10:20:00',7.29),('8902','2013-06-27','10:25:00',2.87),('8902','2013-06-27','10:30:00',2.43),('8902','2013-06-27','10:35:00',6.31),('8902','2013-06-27','10:40:00',7.36),('8902','2013-06-27','10:45:00',3.51),('8902','2013-06-27','10:50:00',8.05),('8902','2013-06-27','10:55:00',3.57),('8902','2013-06-27','11:00:00',3.55),('8902','2013-06-27','11:05:00',7.36),('8902','2013-06-27','11:10:00',5.49),('8902','2013-06-27','11:15:00',3.46),('8902','2013-06-27','11:20:00',2.27),('8902','2013-06-27','11:25:00',5.38),('8902','2013-06-27','11:30:00',6.16),('8902','2013-06-27','11:35:00',6.69),('8902','2013-06-27','11:40:00',4.09),('8902','2013-06-27','11:45:00',7.02),('8902','2013-06-27','11:50:00',8.2),('8902','2013-06-27','11:55:00',8.36),('8902','2013-06-27','12:00:00',7.06),('8902','2013-06-27','12:05:00',8.49),('8902','2013-06-27','12:10:00',7.18),('8902','2013-06-27','12:15:00',8.75),('8902','2013-06-27','12:20:00',8.31),('8902','2013-06-27','12:25:00',8.01),('8902','2013-06-27','12:30:00',7.12),('8902','2013-06-27','12:35:00',7.88),('8902','2013-06-27','12:40:00',8.78),('8902','2013-06-27','12:45:00',8.3),('8902','2013-06-27','12:50:00',5.56),('8902','2013-06-27','12:55:00',8.48),('8902','2013-06-27','13:00:00',5.13),('8902','2013-06-27','13:05:00',7.5),('8902','2013-06-27','13:10:00',8.12),('8902','2013-06-27','13:15:00',8.63),('8902','2013-06-27','13:20:00',8.37),('8902','2013-06-27','13:25:00',8.34),('8902','2013-06-27','13:30:00',6.67),('8902','2013-06-27','13:35:00',7.29),('8902','2013-06-27','13:40:00',7.88),('8902','2013-06-27','13:45:00',7.66),('8902','2013-06-27','13:50:00',7.55),('8902','2013-06-27','13:55:00',8.6),('8902','2013-06-27','14:00:00',7.64),('8902','2013-06-27','14:05:00',7.62),('8902','2013-06-27','14:10:00',7.69),('8902','2013-06-27','14:15:00',7.96),('8902','2013-06-27','14:20:00',7.6),('8902','2013-06-27','14:25:00',9.04),('8902','2013-06-27','14:30:00',7.9),('8902','2013-06-27','14:35:00',7.39),('8902','2013-06-27','14:40:00',6.38),('8902','2013-06-27','14:45:00',5.77),('8902','2013-06-27','14:50:00',8.2),('8902','2013-06-27','14:55:00',7.23),('8902','2013-06-27','15:00:00',6.91),('8902','2013-06-27','15:05:00',7.95),('8902','2013-06-27','15:10:00',5.1),('8902','2013-06-27','15:15:00',4.03),('8902','2013-06-27','15:20:00',2.23),('8902','2013-06-27','15:25:00',6.02),('8902','2013-06-27','15:30:00',6.74),('8902','2013-06-27','15:35:00',8.38),('8902','2013-06-27','15:40:00',5.96),('8902','2013-06-27','15:45:00',4.1),('8902','2013-06-27','15:50:00',7),('8902','2013-06-27','15:55:00',4.84),('8902','2013-06-27','16:00:00',6.01),('8902','2013-06-27','16:05:00',6.7),('8902','2013-06-27','16:10:00',6.34),('8902','2013-06-27','16:15:00',6.34),('8902','2013-06-27','16:20:00',3.62),('8902','2013-06-27','16:25:00',3.41),('8902','2013-06-27','16:30:00',2.59),('8902','2013-06-27','16:35:00',4.79),('8902','2013-06-27','16:40:00',3.59),('8902','2013-06-27','16:45:00',1.53),('8902','2013-06-27','16:50:00',1.97),('8902','2013-06-27','16:55:00',3.52),('8902','2013-06-27','17:00:00',5.24),('8902','2013-06-27','17:05:00',5.38),('8902','2013-06-27','17:10:00',5.2),('8902','2013-06-27','17:15:00',4.67),('8902','2013-06-27','17:20:00',4.75),('8902','2013-06-27','17:25:00',4.67),('8902','2013-06-27','17:30:00',4.08),('8902','2013-06-27','17:35:00',4.33),('8902','2013-06-27','17:40:00',4.1),('8902','2013-06-27','17:45:00',4.01),('8902','2013-06-27','17:50:00',3.9),('8902','2013-06-27','17:55:00',3.63),('8902','2013-06-27','18:00:00',3.39),('8902','2013-06-27','18:05:00',3.33),('8902','2013-06-27','18:10:00',3.14),('8902','2013-06-27','18:15:00',3.09),('8902','2013-06-27','18:20:00',2.97),('8902','2013-06-27','18:25:00',2.76),('8902','2013-06-27','18:30:00',2.52),('8902','2013-06-27','18:35:00',2.26),('8902','2013-06-27','18:40:00',2.13),('8902','2013-06-27','18:45:00',1.98),('8902','2013-06-27','18:50:00',1.77),('8902','2013-06-27','18:55:00',1.59),('8902','2013-06-27','19:00:00',1.42),('8902','2013-06-27','19:05:00',1.29),('8902','2013-06-27','19:10:00',1.12),('8902','2013-06-26','07:30:00',1.28),('8902','2013-06-26','07:35:00',1.43),('8902','2013-06-26','07:40:00',1.57),('8902','2013-06-26','07:45:00',1.73),('8902','2013-06-26','07:50:00',1.92),('8902','2013-06-26','07:55:00',2.08),('8902','2013-06-26','08:00:00',2.24),('8902','2013-06-26','08:05:00',2.4),('8902','2013-06-26','08:10:00',2.6),('8902','2013-06-26','08:15:00',2.73),('8902','2013-06-26','08:20:00',2.88),('8902','2013-06-26','08:25:00',3.03),('8902','2013-06-26','08:30:00',3.17),('8902','2013-06-26','08:35:00',3.3),('8902','2013-06-26','08:40:00',3.44),('8902','2013-06-26','08:45:00',3.63),('8902','2013-06-26','08:50:00',3.76),('8902','2013-06-26','08:55:00',3.95),('8902','2013-06-26','09:00:00',4.15),('8902','2013-06-26','09:05:00',4.27),('8902','2013-06-26','09:10:00',4.41),('8902','2013-06-26','09:15:00',4.58),('8902','2013-06-26','09:20:00',4.75),('8902','2013-06-26','09:25:00',4.85),('8902','2013-06-26','09:30:00',5.02),('8902','2013-06-26','09:35:00',5.18),('8902','2013-06-26','09:40:00',5.26),('8902','2013-06-26','09:45:00',5.39),('8902','2013-06-26','09:50:00',5.56),('8902','2013-06-26','09:55:00',5.71),('8902','2013-06-26','10:00:00',5.88),('8902','2013-06-26','10:05:00',6.18),('8902','2013-06-26','10:10:00',6.06),('8902','2013-06-26','10:15:00',6.4),('8902','2013-06-26','10:20:00',6.23),('8902','2013-06-26','10:25:00',6.27),('8902','2013-06-26','10:30:00',6.47),('8902','2013-06-26','10:35:00',6.68),('8902','2013-06-26','10:40:00',6.95),('8902','2013-06-26','10:45:00',7.16),('8902','2013-06-26','10:50:00',7.12),('8902','2013-06-26','10:55:00',7.14),('8902','2013-06-26','11:00:00',7.08),('8902','2013-06-26','11:05:00',6.62),('8902','2013-06-26','11:10:00',4.91),('8902','2013-06-26','11:15:00',7.58),('8902','2013-06-26','11:20:00',7.53),('8902','2013-06-26','11:25:00',7.47),('8902','2013-06-26','11:30:00',7.61),('8902','2013-06-26','11:35:00',7.23),('8902','2013-06-26','11:40:00',7.37),('8902','2013-06-26','11:45:00',5.6),('8902','2013-06-26','11:50:00',2.38),('8902','2013-06-26','11:55:00',2.73),('8902','2013-06-26','12:00:00',3.64),('8902','2013-06-26','12:05:00',2.54),('8902','2013-06-26','12:10:00',3.1),('8902','2013-06-26','12:15:00',3.02),('8902','2013-06-26','12:20:00',2.31),('8902','2013-06-26','12:25:00',3.13),('8902','2013-06-26','12:30:00',2.73),('8902','2013-06-26','12:35:00',3.41),('8902','2013-06-26','12:40:00',4.28),('8902','2013-06-26','12:45:00',3.36),('8902','2013-06-26','12:50:00',3.5),('8902','2013-06-26','12:55:00',2.61),('8902','2013-06-26','13:00:00',1.82),('8902','2013-06-26','13:05:00',1.95),('8902','2013-06-26','13:10:00',2.47),('8902','2013-06-26','13:15:00',2.8),('8902','2013-06-26','13:20:00',2.83),('8902','2013-06-26','13:25:00',3.04),('8902','2013-06-26','13:30:00',2.7),('8902','2013-06-26','13:35:00',2.72),('8902','2013-06-26','13:40:00',2.32),('8902','2013-06-26','13:45:00',2.12),('8902','2013-06-26','13:50:00',2.23),('8902','2013-06-26','13:55:00',2.25),('8902','2013-06-26','14:00:00',2.5),('8902','2013-06-26','14:05:00',2.51),('8902','2013-06-26','14:10:00',2.84),('8902','2013-06-26','14:15:00',3.13),('8902','2013-06-26','14:20:00',7.04),('8902','2013-06-26','14:25:00',7.88),('8902','2013-06-26','14:30:00',6.61),('8902','2013-06-26','14:35:00',6.51),('8902','2013-06-26','14:40:00',6),('8902','2013-06-26','14:45:00',3.21),('8902','2013-06-26','14:50:00',4.68),('8902','2013-06-26','14:55:00',7.88),('8902','2013-06-26','15:00:00',7.57),('8902','2013-06-26','15:05:00',7.38),('8902','2013-06-26','15:10:00',7.26),('8902','2013-06-26','15:15:00',7.25),('8902','2013-06-26','15:20:00',7.18),('8902','2013-06-26','15:25:00',7.23),('8902','2013-06-26','15:30:00',7.11),('8902','2013-06-26','15:35:00',6.99),('8902','2013-06-26','15:40:00',6.92),('8902','2013-06-26','15:45:00',6.87),('8902','2013-06-26','15:50:00',6.79),('8902','2013-06-26','15:55:00',6.7),('8902','2013-06-26','16:00:00',6.49),('8902','2013-06-26','16:05:00',6.35),('8902','2013-06-26','16:10:00',6.27),('8902','2013-06-26','16:15:00',6.21),('8902','2013-06-26','16:20:00',6.14),('8902','2013-06-26','16:25:00',6.08),('8902','2013-06-26','16:30:00',5.99),('8902','2013-06-26','16:35:00',5.53),('8902','2013-06-26','16:40:00',5.46),('8902','2013-06-26','16:45:00',5.53),('8902','2013-06-26','16:50:00',5.4),('8902','2013-06-26','16:55:00',5.2),('8902','2013-06-26','17:00:00',5.11),('8902','2013-06-26','17:05:00',4.98),('8902','2013-06-26','17:10:00',4.75),('8902','2013-06-26','17:15:00',4.54),('8902','2013-06-26','17:20:00',4.64),('8902','2013-06-26','17:25:00',4.51),('8902','2013-06-26','17:30:00',4.38),('8902','2013-06-26','17:35:00',4.24),('8902','2013-06-26','17:40:00',3.16),('8902','2013-06-26','17:45:00',1.72),('8902','2013-06-26','17:50:00',3.52),('8902','2013-06-26','17:55:00',3.47),('8902','2013-06-26','18:00:00',3.2),('8902','2013-06-26','18:05:00',3.13),('8902','2013-06-26','18:10:00',2.91),('8902','2013-06-26','18:15:00',2.72),('8902','2013-06-26','18:20:00',2.59),('8902','2013-06-26','18:25:00',2.53),('8902','2013-06-26','18:30:00',2.34),('8902','2013-06-26','18:35:00',2.14),('8902','2013-06-26','18:40:00',1.85),('8902','2013-06-26','18:45:00',1.72),('8902','2013-06-26','18:50:00',1.62),('8902','2013-06-26','18:55:00',1.5),('8902','2013-06-26','19:00:00',1.33),('8902','2013-06-26','19:05:00',1.19),('8902','2013-06-26','19:10:00',1.04),('8902','2013-06-25','07:20:00',1.03),('8902','2013-06-25','07:25:00',1.16),('8902','2013-06-25','07:30:00',1.31),('8902','2013-06-25','07:35:00',1.47),('8902','2013-06-25','07:40:00',1.62),('8902','2013-06-25','07:45:00',1.79),('8902','2013-06-25','07:50:00',1.96),('8902','2013-06-25','07:55:00',2.1),('8902','2013-06-25','08:00:00',2.23),('8902','2013-06-25','08:05:00',2.39),('8902','2013-06-25','08:10:00',2.58),('8902','2013-06-25','08:15:00',2.73),('8902','2013-06-25','08:20:00',2.87),('8902','2013-06-25','08:25:00',3.02),('8902','2013-06-25','08:30:00',3.17),('8902','2013-06-25','08:35:00',3.33),('8902','2013-06-25','08:40:00',3.45),('8902','2013-06-25','08:45:00',3.61),('8902','2013-06-25','08:50:00',3.76),('8902','2013-06-25','08:55:00',3.88),('8902','2013-06-25','09:00:00',4.01),('8902','2013-06-25','09:05:00',4.18),('8902','2013-06-25','09:10:00',4.31),('8902','2013-06-25','09:15:00',4.46),('8902','2013-06-25','09:20:00',4.58),('8902','2013-06-25','09:25:00',4.76),('8902','2013-06-25','09:30:00',4.89),('8902','2013-06-25','09:35:00',5.03),('8902','2013-06-25','09:40:00',5.16),('8902','2013-06-25','09:45:00',5.23),('8902','2013-06-25','09:50:00',5.33),('8902','2013-06-25','09:55:00',5.43),('8902','2013-06-25','10:00:00',5.58),('8902','2013-06-25','10:05:00',5.71),('8902','2013-06-25','10:10:00',5.77),('8902','2013-06-25','10:15:00',5.93),('8902','2013-06-25','10:20:00',6.02),('8902','2013-06-25','10:25:00',6.07),('8902','2013-06-25','10:30:00',6.17),('8902','2013-06-25','10:35:00',6.32),('8902','2013-06-25','10:40:00',6.42),('8902','2013-06-25','10:45:00',6.53),('8902','2013-06-25','10:50:00',6.62),('8902','2013-06-25','10:55:00',6.66),('8902','2013-06-25','11:00:00',6.75),('8902','2013-06-25','11:05:00',6.85),('8902','2013-06-25','11:10:00',6.94),('8902','2013-06-25','11:15:00',6.96),('8902','2013-06-25','11:20:00',6.99),('8902','2013-06-25','11:25:00',7.01),('8902','2013-06-25','11:30:00',7.06),('8902','2013-06-25','11:35:00',7.17),('8902','2013-06-25','11:40:00',7.3),('8902','2013-06-25','11:45:00',7.4),('8902','2013-06-25','11:50:00',7.41),('8902','2013-06-25','11:55:00',7.5),('8902','2013-06-25','12:00:00',7.38),('8902','2013-06-25','12:30:00',7.34),('8902','2013-06-25','12:40:00',7.72),('8902','2013-06-25','12:45:00',7.77),('8902','2013-06-25','12:50:00',7.77),('8902','2013-06-25','12:55:00',5.29),('8902','2013-06-25','13:00:00',1.87),('8902','2013-06-25','13:05:00',3.54),('8902','2013-06-25','13:10:00',7.52),('8902','2013-06-25','13:15:00',8.71),('8902','2013-06-25','13:20:00',8.48),('8902','2013-06-25','13:25:00',6.56),('8902','2013-06-25','13:30:00',2.1),('8902','2013-06-25','13:35:00',1.82),('8902','2013-06-25','13:40:00',1.83),('8902','2013-06-25','13:45:00',2.06),('8902','2013-06-25','13:50:00',2.37),('8902','2013-06-25','13:55:00',2.72),('8902','2013-06-25','14:00:00',5.65),('8902','2013-06-25','14:05:00',4.87),('8902','2013-06-25','14:10:00',2.96),('8902','2013-06-25','14:15:00',5.38),('8902','2013-06-25','14:20:00',7.81),('8902','2013-06-25','14:25:00',4.24),('8902','2013-06-25','14:30:00',4.44),('8902','2013-06-25','14:35:00',2.03),('8902','2013-06-25','14:40:00',1.95),('8902','2013-06-25','14:45:00',6.12),('8902','2013-06-25','14:50:00',3.72),('8902','2013-06-25','14:55:00',5.55),('8902','2013-06-25','15:00:00',7.98),('8902','2013-06-25','15:05:00',7.7),('8902','2013-06-25','15:10:00',7.49),('8902','2013-06-25','15:15:00',7.35),('8902','2013-06-25','15:20:00',7.22),('8902','2013-06-25','15:25:00',7.16),('8902','2013-06-25','15:30:00',7.09),('8902','2013-06-25','15:35:00',7.16),('8902','2013-06-25','15:40:00',6.97),('8902','2013-06-25','15:45:00',6.88),('8902','2013-06-25','15:50:00',5.24),('8902','2013-06-25','15:55:00',5.64),('8902','2013-06-25','16:00:00',6.75),('8902','2013-06-25','16:05:00',6.56),('8902','2013-06-25','16:10:00',6.49),('8902','2013-06-25','16:15:00',6.46),('8902','2013-06-25','16:20:00',6.3),('8902','2013-06-25','16:25:00',6.18),('8902','2013-06-25','16:30:00',6.13),('8902','2013-06-25','16:35:00',5.9),('8902','2013-06-25','16:40:00',5.61),('8902','2013-06-25','16:45:00',5.6),('8902','2013-06-25','16:50:00',5.49),('8902','2013-06-25','16:55:00',5.31),('8902','2013-06-25','17:00:00',5.25),('8902','2013-06-25','17:05:00',5.15),('8902','2013-06-25','17:10:00',4.99),('8902','2013-06-25','17:15:00',4.77),('8902','2013-06-25','17:20:00',4.62),('8902','2013-06-25','17:25:00',4.4),('8902','2013-06-25','17:30:00',4.31),('8902','2013-06-25','17:35:00',4.21),('8902','2013-06-25','17:40:00',4.02),('8902','2013-06-25','17:45:00',3.85),('8902','2013-06-25','17:50:00',3.71),('8902','2013-06-25','17:55:00',3.5),('8902','2013-06-25','18:00:00',3.34),('8902','2013-06-25','18:05:00',3.5),('8902','2013-06-25','18:10:00',3.31),('8902','2013-06-25','18:15:00',1.52),('8902','2013-06-25','18:20:00',1.6),('8902','2013-06-25','18:25:00',1.29),('8902','2013-06-25','19:00:00',1.05),('8902','2013-06-25','19:15:00',1.06),('8902','2013-06-25','19:20:00',1.08),('8902','2013-06-24','07:20:00',1.07),('8902','2013-06-24','07:25:00',1.07),('8902','2013-06-24','07:30:00',1.35),('8902','2013-06-24','07:35:00',1.5),('8902','2013-06-24','07:45:00',1.85),('8902','2013-06-24','07:50:00',2.09),('8902','2013-06-24','07:55:00',2.27),('8902','2013-06-24','08:00:00',2.32),('8902','2013-06-24','08:05:00',3),('8902','2013-06-24','08:10:00',2.77),('8902','2013-06-24','08:15:00',2.03),('8902','2013-06-24','08:20:00',2.01),('8902','2013-06-24','08:25:00',2.2),('8902','2013-06-24','08:30:00',3.28),('8902','2013-06-24','08:35:00',3.4),('8902','2013-06-24','08:40:00',3.54),('8902','2013-06-24','08:45:00',3.72),('8902','2013-06-24','08:50:00',3.8),('8902','2013-06-24','08:55:00',3.97),('8902','2013-06-24','09:00:00',4.16),('8902','2013-06-24','09:05:00',4.31),('8902','2013-06-24','09:10:00',4.45),('8902','2013-06-24','09:15:00',4.61),('8902','2013-06-24','09:20:00',4.7),('8902','2013-06-24','09:25:00',4.95),('8902','2013-06-24','09:30:00',5.08),('8902','2013-06-24','09:35:00',4.64),('8902','2013-06-24','09:40:00',2.59),('8902','2013-06-24','09:45:00',2.29),('8902','2013-06-24','09:50:00',6.33),('8902','2013-06-24','09:55:00',6.45),('8902','2013-06-24','10:00:00',6.48),('8902','2013-06-24','10:05:00',2.54),('8902','2013-06-24','10:10:00',4.28),('8902','2013-06-24','10:15:00',6.98),('8902','2013-06-24','10:20:00',4.84),('8902','2013-06-24','10:25:00',3.43),('8902','2013-06-24','10:30:00',6.78),('8902','2013-06-24','10:35:00',2.98),('8902','2013-06-24','10:40:00',6.67),('8902','2013-06-24','10:45:00',7.33),('8902','2013-06-24','10:50:00',7.26),('8902','2013-06-24','10:55:00',7.37),('8902','2013-06-24','11:00:00',7.32),('8902','2013-06-24','11:05:00',7.7),('8902','2013-06-24','11:10:00',7.9),('8902','2013-06-24','11:15:00',7.36),('8902','2013-06-24','11:20:00',8.04),('8902','2013-06-24','11:25:00',4.81),('8902','2013-06-24','11:30:00',5.53),('8902','2013-06-24','11:35:00',7.74),('8902','2013-06-24','11:40:00',8.48),('8902','2013-06-24','11:45:00',8.4),('8902','2013-06-24','11:50:00',8.29),('8902','2013-06-24','11:55:00',7.61),('8902','2013-06-24','12:00:00',6.2),('8902','2013-06-24','12:05:00',5.28),('8902','2013-06-24','12:10:00',2.98),('8902','2013-06-24','12:15:00',2.66),('8902','2013-06-24','12:20:00',2.24),('8902','2013-06-24','12:25:00',1.95),('8902','2013-06-24','12:30:00',1.79),('8902','2013-06-24','12:35:00',1.94),('8902','2013-06-24','12:40:00',2.54),('8902','2013-06-24','12:45:00',2.48),('8902','2013-06-24','12:50:00',2.46),('8902','2013-06-24','12:55:00',3.75),('8902','2013-06-24','13:00:00',7.84),('8902','2013-06-24','13:05:00',8.98),('8902','2013-06-24','13:10:00',6.27),('8902','2013-06-24','13:15:00',6.4),('8902','2013-06-24','13:20:00',8.68),('8902','2013-06-24','13:25:00',8.51),('8902','2013-06-24','13:30:00',7.43),('8902','2013-06-24','13:35:00',6.34),('8902','2013-06-24','13:40:00',7.68),('8902','2013-06-24','13:45:00',8.52),('8902','2013-06-24','13:50:00',6.38),('8902','2013-06-24','13:55:00',6.51),('8902','2013-06-24','14:00:00',6.43),('8902','2013-06-24','14:05:00',8.61),('8902','2013-06-24','14:10:00',6.21),('8902','2013-06-24','14:15:00',4.85),('8902','2013-06-24','14:20:00',8.62),('8902','2013-06-24','14:25:00',8.15),('8902','2013-06-24','14:30:00',7.92),('8902','2013-06-24','14:35:00',7.86),('8902','2013-06-24','14:40:00',6.59),('8902','2013-06-24','14:45:00',7.95),('8902','2013-06-24','14:50:00',7.84),('8902','2013-06-24','14:55:00',7.72),('8902','2013-06-24','15:00:00',7.61),('8902','2013-06-24','15:05:00',7.53),('8902','2013-06-24','15:10:00',7.48),('8902','2013-06-24','15:15:00',7.5),('8902','2013-06-24','15:20:00',7.33),('8902','2013-06-24','15:25:00',7.21),('8902','2013-06-24','15:30:00',7.11),('8902','2013-06-24','15:35:00',6.99),('8902','2013-06-24','15:40:00',6.9),('8902','2013-06-24','15:45:00',6.83),('8902','2013-06-24','15:50:00',6.75),('8902','2013-06-24','15:55:00',6.64),('8902','2013-06-24','16:00:00',6.58),('8902','2013-06-24','16:05:00',6.5),('8902','2013-06-24','16:10:00',6.42),('8902','2013-06-24','16:15:00',6.33),('8902','2013-06-24','16:20:00',6.2),('8902','2013-06-24','16:25:00',6.1),('8902','2013-06-24','16:30:00',5.99),('8902','2013-06-24','16:35:00',5.83),('8902','2013-06-24','16:40:00',5.61),('8902','2013-06-24','16:45:00',5.59),('8902','2013-06-24','16:50:00',5.49),('8902','2013-06-24','16:55:00',5.25),('8902','2013-06-24','17:00:00',5.18),('8902','2013-06-24','17:05:00',5.06),('8902','2013-06-24','17:10:00',4.9),('8902','2013-06-24','17:15:00',4.79),('8902','2013-06-24','17:20:00',4.65),('8902','2013-06-24','17:25:00',4.45),('8902','2013-06-24','17:30:00',4.33),('8902','2013-06-24','17:35:00',4.18),('8902','2013-06-24','17:40:00',4),('8902','2013-06-24','17:45:00',3.84),('8902','2013-06-24','17:50:00',3.7),('8902','2013-06-24','17:55:00',3.51),('8902','2013-06-24','18:00:00',3.3),('8902','2013-06-24','18:05:00',3.21),('8902','2013-06-24','18:10:00',3),('8902','2013-06-24','18:15:00',2.83),('8902','2013-06-24','18:20:00',2.69),('8902','2013-06-24','18:25:00',2.47),('8902','2013-06-24','18:30:00',2.34),('8902','2013-06-24','18:35:00',2.16),('8902','2013-06-24','18:40:00',1.99),('8902','2013-06-24','18:45:00',1.82),('8902','2013-06-24','18:50:00',1.66),('8902','2013-06-24','18:55:00',1.49),('8902','2013-06-24','19:00:00',1.38),('8902','2013-06-24','19:05:00',1.22),('8902','2013-06-24','19:10:00',1.07),('8902','2013-06-23','07:10:00',1.23),('8902','2013-06-23','07:25:00',1.32),('8902','2013-06-23','07:30:00',1.13),('8902','2013-06-23','07:50:00',1.37),('8902','2013-06-23','07:55:00',1.29),('8902','2013-06-23','08:35:00',1.58),('8902','2013-06-23','08:40:00',1.66),('8902','2013-06-23','08:45:00',3.92),('8902','2013-06-23','08:50:00',4.08),('8902','2013-06-23','08:55:00',4.32),('8902','2013-06-23','09:00:00',4.62),('8902','2013-06-23','09:05:00',5.02),('8902','2013-06-23','09:10:00',3.16),('8902','2013-06-23','09:15:00',4.8),('8902','2013-06-23','09:20:00',5.28),('8902','2013-06-23','09:25:00',4.88),('8902','2013-06-23','09:30:00',6.16),('8902','2013-06-23','09:35:00',4.15),('8902','2013-06-23','09:40:00',2.49),('8902','2013-06-23','09:45:00',3.9),('8902','2013-06-23','09:50:00',6.14),('8902','2013-06-23','09:55:00',5.87),('8902','2013-06-23','10:00:00',6.02),('8902','2013-06-23','10:05:00',6.12),('8902','2013-06-23','10:10:00',6.37),('8902','2013-06-23','10:15:00',5.57),('8902','2013-06-23','10:20:00',5.88),('8902','2013-06-23','10:25:00',7.18),('8902','2013-06-23','10:30:00',5.39),('8902','2013-06-23','10:35:00',7.45),('8902','2013-06-23','10:40:00',4.28),('8902','2013-06-23','10:45:00',2.95),('8902','2013-06-23','10:50:00',6.41),('8902','2013-06-23','10:55:00',4.54),('8902','2013-06-23','11:00:00',7.71),('8902','2013-06-23','11:05:00',8.11),('8902','2013-06-23','11:10:00',4.11),('8902','2013-06-23','11:15:00',3.44),('8902','2013-06-23','11:20:00',8.92),('8902','2013-06-23','11:25:00',2.7),('8902','2013-06-23','11:30:00',4.52),('8902','2013-06-23','11:35:00',2.81),('8902','2013-06-23','11:40:00',2.54),('8902','2013-06-23','11:45:00',3.22),('8902','2013-06-23','11:50:00',6.7),('8902','2013-06-23','11:55:00',3.99),('8902','2013-06-23','12:00:00',7.14),('8902','2013-06-23','12:05:00',7.77),('8902','2013-06-23','12:10:00',5.98),('8902','2013-06-23','12:15:00',6.82),('8902','2013-06-23','12:20:00',7.31),('8902','2013-06-23','12:25:00',9.02),('8902','2013-06-23','12:30:00',5.99),('8902','2013-06-23','12:35:00',8.65),('8902','2013-06-23','12:40:00',9),('8902','2013-06-23','12:45:00',4.74),('8902','2013-06-23','12:50:00',7.44),('8902','2013-06-23','12:55:00',9.34),('8902','2013-06-23','13:00:00',6.2),('8902','2013-06-23','13:05:00',8.05),('8902','2013-06-23','13:10:00',8.49),('8902','2013-06-23','13:15:00',6.23),('8902','2013-06-23','13:20:00',4.68),('8902','2013-06-23','13:25:00',7.38),('8902','2013-06-23','13:30:00',9.63),('8902','2013-06-23','13:35:00',7.65),('8902','2013-06-23','13:40:00',7.67),('8902','2013-06-23','13:45:00',8.06),('8902','2013-06-23','13:50:00',8.54),('8902','2013-06-23','13:55:00',8.43),('8902','2013-06-23','14:00:00',8.23),('8902','2013-06-23','14:05:00',8.39),('8902','2013-06-23','14:10:00',8.38),('8902','2013-06-23','14:15:00',8.3),('8902','2013-06-23','14:20:00',8.27),('8902','2013-06-23','14:25:00',8.26),('8902','2013-06-23','14:30:00',8.02),('8902','2013-06-23','14:35:00',8.23),('8902','2013-06-23','14:40:00',8.17),('8902','2013-06-23','14:45:00',8.35),('8902','2013-06-23','14:50:00',6.23),('8902','2013-06-23','14:55:00',7.64),('8902','2013-06-23','15:00:00',6.44),('8902','2013-06-23','15:05:00',5.99),('8902','2013-06-23','15:10:00',7),('8902','2013-06-23','15:15:00',8.73),('8902','2013-06-23','15:20:00',6.64),('8902','2013-06-23','15:25:00',5.84),('8902','2013-06-23','15:30:00',5.72),('8902','2013-06-23','15:35:00',6.83),('8902','2013-06-23','15:40:00',3.46),('8902','2013-06-23','15:45:00',7.8),('8902','2013-06-23','15:50:00',5.89),('8902','2013-06-23','15:55:00',6.75),('8902','2013-06-23','16:00:00',8.04),('8902','2013-06-23','16:05:00',7.21),('8902','2013-06-23','16:10:00',6.73),('8902','2013-06-23','16:15:00',7.45),('8902','2013-06-23','16:20:00',4.39),('8902','2013-06-23','16:25:00',5.08),('8902','2013-06-23','16:30:00',4.34),('8902','2013-06-23','16:35:00',6),('8902','2013-06-23','16:40:00',4.12),('8902','2013-06-23','16:45:00',3.82),('8902','2013-06-23','16:50:00',3.07),('8902','2013-06-23','16:55:00',2.53),('8902','2013-06-23','17:00:00',2.1),('8902','2013-06-23','17:05:00',4.17),('8902','2013-06-23','17:10:00',3.05),('8902','2013-06-23','17:15:00',5.79),('8902','2013-06-23','17:20:00',3.7),('8902','2013-06-23','17:25:00',4.19),('8902','2013-06-23','17:30:00',3.79),('8902','2013-06-23','17:35:00',1.88),('8902','2013-06-23','17:40:00',1.59),('8902','2013-06-23','17:45:00',1.6),('8902','2013-06-23','17:50:00',2.48),('8902','2013-06-23','17:55:00',1.72),('8902','2013-06-23','18:00:00',3.87),('8902','2013-06-23','18:05:00',3.84),('8902','2013-06-23','18:10:00',3.15),('8902','2013-06-23','18:15:00',2.87),('8902','2013-06-23','18:20:00',2.96),('8902','2013-06-23','18:25:00',2.5),('8902','2013-06-23','18:30:00',2.22),('8902','2013-06-23','18:35:00',2.37),('8902','2013-06-23','18:40:00',1.65),('8902','2013-06-23','18:45:00',1.87),('8902','2013-06-23','18:50:00',1.82),('8902','2013-06-23','18:55:00',1.55),('8902','2013-06-23','19:00:00',1.49),('8902','2013-06-23','19:05:00',1.35),('8902','2013-06-23','19:10:00',1.23),('8902','2013-06-23','19:15:00',1.03),('8902','2013-06-22','08:35:00',1.16),('8902','2013-06-22','08:40:00',1.36),('8902','2013-06-22','08:45:00',1.78),('8902','2013-06-22','08:50:00',2.64),('8902','2013-06-22','08:55:00',1.79),('8902','2013-06-22','09:00:00',2.87),('8902','2013-06-22','09:05:00',2.95),('8902','2013-06-22','09:10:00',1.03),('8902','2013-06-22','09:15:00',1.24),('8902','2013-06-22','09:20:00',2.79),('8902','2013-06-22','09:25:00',4.29),('8902','2013-06-22','09:30:00',4.92),('8902','2013-06-22','09:35:00',5.2),('8902','2013-06-22','09:40:00',5.76),('8902','2013-06-22','09:45:00',4.32),('8902','2013-06-22','09:50:00',2.27),('8902','2013-06-22','09:55:00',2.96),('8902','2013-06-22','10:00:00',6.27),('8902','2013-06-22','10:05:00',6.27),('8902','2013-06-22','10:10:00',6.71),('8902','2013-06-22','10:15:00',6.14),('8902','2013-06-22','10:20:00',4.15),('8902','2013-06-22','10:25:00',5.93),('8902','2013-06-22','10:30:00',3.01),('8902','2013-06-22','10:35:00',3.58),('8902','2013-06-22','10:40:00',6.94),('8902','2013-06-22','10:45:00',6.65),('8902','2013-06-22','10:50:00',6.6),('8902','2013-06-22','10:55:00',6.54),('8902','2013-06-22','11:00:00',6.68),('8902','2013-06-22','11:05:00',6.82),('8902','2013-06-22','11:10:00',6.91),('8902','2013-06-22','11:15:00',6.88),('8902','2013-06-22','11:20:00',7.03),('8902','2013-06-22','11:25:00',7.14),('8902','2013-06-22','11:30:00',7.12),('8902','2013-06-22','11:35:00',7.01),('8902','2013-06-22','11:40:00',7.03),('8902','2013-06-22','11:45:00',7.13),('8902','2013-06-22','11:50:00',7.35),('8902','2013-06-22','11:55:00',7.39),('8902','2013-06-22','12:00:00',6.56),('8902','2013-06-22','12:05:00',7.78),('8902','2013-06-22','12:10:00',7.75),('8902','2013-06-22','12:15:00',7.59),('8902','2013-06-22','12:20:00',7.73),('8902','2013-06-22','12:25:00',7.86),('8902','2013-06-22','12:30:00',7.8),('8902','2013-06-22','12:35:00',7.8),('8902','2013-06-22','12:40:00',7.8),('8902','2013-06-22','12:45:00',7.87),('8902','2013-06-22','12:50:00',7.85),('8902','2013-06-22','12:55:00',7.9),('8902','2013-06-22','13:00:00',7.9),('8902','2013-06-22','13:05:00',7.9),('8902','2013-06-22','13:10:00',7.93),('8902','2013-06-22','13:15:00',7.97),('8902','2013-06-22','13:20:00',7.95),('8902','2013-06-22','13:25:00',7.97),('8902','2013-06-22','13:30:00',7.95),('8902','2013-06-22','13:35:00',7.99),('8902','2013-06-22','13:40:00',8.01),('8902','2013-06-22','13:45:00',8.01),('8902','2013-06-22','13:50:00',7.99),('8902','2013-06-22','13:55:00',8.01),('8902','2013-06-22','14:00:00',8),('8902','2013-06-22','14:05:00',7.92),('8902','2013-06-22','14:10:00',7.94),('8902','2013-06-22','14:15:00',7.95),('8902','2013-06-22','14:20:00',7.91),('8902','2013-06-22','14:25:00',7.89),('8902','2013-06-22','14:30:00',7.91),('8902','2013-06-22','14:35:00',7.83),('8902','2013-06-22','14:40:00',7.85),('8902','2013-06-22','14:45:00',7.78),('8902','2013-06-22','14:50:00',7.73),('8902','2013-06-22','14:55:00',7.67),('8902','2013-06-22','15:00:00',7.67),('8902','2013-06-22','15:05:00',7.59),('8902','2013-06-22','15:10:00',7.5),('8902','2013-06-22','15:15:00',7.43),('8902','2013-06-22','15:20:00',7.32),('8902','2013-06-22','15:25:00',7.34),('8902','2013-06-22','15:30:00',7.24),('8902','2013-06-22','15:35:00',7.18),('8902','2013-06-22','15:40:00',7.08),('8902','2013-06-22','15:45:00',7),('8902','2013-06-22','15:50:00',6.9),('8902','2013-06-22','15:55:00',6.82),('8902','2013-06-22','16:00:00',6.71),('8902','2013-06-22','16:05:00',6.58),('8902','2013-06-22','16:10:00',6.48),('8902','2013-06-22','16:15:00',6.35),('8902','2013-06-22','16:20:00',6.28),('8902','2013-06-22','16:25:00',6.17),('8902','2013-06-22','16:30:00',6.08),('8902','2013-06-22','16:35:00',5.93),('8902','2013-06-22','16:40:00',5.73),('8902','2013-06-22','16:45:00',5.7),('8902','2013-06-22','16:50:00',5.58),('8902','2013-06-22','16:55:00',5.29),('8902','2013-06-22','17:00:00',5.27),('8902','2013-06-22','17:05:00',5.17),('8902','2013-06-22','17:10:00',5.02),('8902','2013-06-22','17:15:00',4.92),('8902','2013-06-22','17:20:00',4.69),('8902','2013-06-22','17:25:00',4.6),('8902','2013-06-22','17:30:00',4.44),('8902','2013-06-22','17:35:00',4.31),('8902','2013-06-22','17:40:00',4.09),('8902','2013-06-22','17:45:00',4.04),('8902','2013-06-22','17:50:00',3.86),('8902','2013-06-22','17:55:00',3.61),('8902','2013-06-22','18:00:00',3.4),('8902','2013-06-22','18:05:00',3.32),('8902','2013-06-22','18:10:00',3.13),('8902','2013-06-22','18:15:00',2.92),('8902','2013-06-22','18:20:00',2.79),('8902','2013-06-22','18:25:00',2.56),('8902','2013-06-22','18:30:00',2.42),('8902','2013-06-22','18:35:00',2.18),('8902','2013-06-22','18:40:00',1.76),('8902','2013-06-22','18:45:00',1.89),('8902','2013-06-22','18:50:00',1.78),('8902','2013-06-22','18:55:00',1.58),('8902','2013-06-22','19:00:00',1.4),('8902','2013-06-22','19:05:00',1.1),('8902','2013-06-22','19:10:00',1.11),('8902','2013-06-21','07:25:00',1.11),('8902','2013-06-21','07:30:00',1.23),('8902','2013-06-21','07:35:00',1.36),('8902','2013-06-21','07:40:00',1.49),('8902','2013-06-21','07:45:00',1.61),('8902','2013-06-21','07:50:00',1.76),('8902','2013-06-21','07:55:00',1.91),('8902','2013-06-21','08:00:00',2.06),('8902','2013-06-21','08:05:00',2.19),('8902','2013-06-21','08:10:00',2.32),('8902','2013-06-21','08:15:00',2.45),('8902','2013-06-21','08:20:00',2.63),('8902','2013-06-21','08:25:00',2.78),('8902','2013-06-21','08:30:00',2.97),('8902','2013-06-21','08:35:00',3.11),('8902','2013-06-21','08:40:00',3.27),('8902','2013-06-21','08:45:00',3.46),('8902','2013-06-21','08:50:00',3.61),('8902','2013-06-21','08:55:00',3.73),('8902','2013-06-21','09:00:00',3.85),('8902','2013-06-21','09:05:00',3.95),('8902','2013-06-21','09:10:00',4.08),('8902','2013-06-21','09:15:00',4.21),('8902','2013-06-21','09:20:00',4.35),('8902','2013-06-21','09:25:00',4.46),('8902','2013-06-21','09:30:00',4.57),('8902','2013-06-21','09:35:00',4.73),('8902','2013-06-21','09:40:00',4.87),('8902','2013-06-21','09:45:00',4.98),('8902','2013-06-21','09:50:00',5.08),('8902','2013-06-21','09:55:00',5.21),('8902','2013-06-21','10:00:00',5.27),('8902','2013-06-21','10:05:00',5.46),('8902','2013-06-21','10:10:00',5.59),('8902','2013-06-21','10:15:00',5.67),('8902','2013-06-21','10:20:00',5.79),('8902','2013-06-21','10:25:00',5.93),('8902','2013-06-21','10:30:00',5.95),('8902','2013-06-21','10:35:00',6.04),('8902','2013-06-21','10:40:00',6.15),('8902','2013-06-21','10:45:00',6.27),('8902','2013-06-21','10:50:00',6.36),('8902','2013-06-21','10:55:00',6.48),('8902','2013-06-21','11:00:00',6.54),('8902','2013-06-21','11:05:00',6.62),('8902','2013-06-21','11:10:00',6.68),('8902','2013-06-21','11:15:00',6.75),('8902','2013-06-21','11:20:00',6.82),('8902','2013-06-21','11:25:00',6.88),('8902','2013-06-21','11:30:00',6.9),('8902','2013-06-21','11:35:00',7),('8902','2013-06-21','11:40:00',7.09),('8902','2013-06-21','11:45:00',7.13),('8902','2013-06-21','11:50:00',7.19),('8902','2013-06-21','11:55:00',7.23),('8902','2013-06-21','12:00:00',7.27),('8902','2013-06-21','12:05:00',7.2),('8902','2013-06-21','12:10:00',7.06),('8902','2013-06-21','12:15:00',7.37),('8902','2013-06-21','12:20:00',7.4),('8902','2013-06-21','12:25:00',7.3),('8902','2013-06-21','12:30:00',7.46),('8902','2013-06-21','12:35:00',7.52),('8902','2013-06-21','12:40:00',7.59),('8902','2013-06-21','12:45:00',7.51),('8902','2013-06-21','12:50:00',7.41),('8902','2013-06-21','12:55:00',7.38),('8902','2013-06-21','13:00:00',7.33),('8902','2013-06-21','13:05:00',7.35),('8902','2013-06-21','13:10:00',7.22),('8902','2013-06-21','13:15:00',7.13),('8902','2013-06-21','13:20:00',6.97),('8902','2013-06-21','13:25:00',7.07),('8902','2013-06-21','13:30:00',7.84),('8902','2013-06-21','13:35:00',7.98),('8902','2013-06-21','13:40:00',7.43),('8902','2013-06-21','13:45:00',7.35),('8902','2013-06-21','13:50:00',7.84),('8902','2013-06-21','13:55:00',6.72),('8902','2013-06-21','14:00:00',4.18),('8902','2013-06-21','14:05:00',8.57),('8902','2013-06-21','14:10:00',8.13),('8902','2013-06-21','14:15:00',8.05),('8902','2013-06-21','14:20:00',6.65),('8902','2013-06-21','14:25:00',7.99),('8902','2013-06-21','14:30:00',6.16),('8902','2013-06-21','14:35:00',4.35),('8902','2013-06-21','14:40:00',3.34),('8902','2013-06-21','14:45:00',3.57),('8902','2013-06-21','14:50:00',6.61),('8902','2013-06-21','14:55:00',6.94),('8902','2013-06-21','15:00:00',7.19),('8902','2013-06-21','15:05:00',6.34),('8902','2013-06-21','15:10:00',6.88),('8902','2013-06-21','15:15:00',7.68),('8902','2013-06-21','15:20:00',7.1),('8902','2013-06-21','15:25:00',6.58),('8902','2013-06-21','15:30:00',4.36),('8902','2013-06-21','15:35:00',3.92),('8902','2013-06-21','15:40:00',3.42),('8902','2013-06-21','15:45:00',4.69),('8902','2013-06-21','15:50:00',4.93),('8902','2013-06-21','15:55:00',4.58),('8902','2013-06-21','16:00:00',3.9),('8902','2013-06-21','16:05:00',2.4),('8902','2013-06-21','16:10:00',2.27),('8902','2013-06-21','16:15:00',2.92),('8902','2013-06-21','16:20:00',3.62),('8902','2013-06-21','16:25:00',2.52),('8902','2013-06-21','16:30:00',1.9),('8902','2013-06-21','16:35:00',1.6),('8902','2013-06-21','16:40:00',1.45),('8902','2013-06-21','16:45:00',1.39),('8902','2013-06-21','16:50:00',1.51),('8902','2013-06-21','16:55:00',2.07),('8902','2013-06-21','17:00:00',2.77),('8902','2013-06-21','17:05:00',2.63),('8902','2013-06-21','17:10:00',3.52),('8902','2013-06-21','17:15:00',5.39),('8902','2013-06-21','17:20:00',5.19),('8902','2013-06-21','17:25:00',5.17),('8902','2013-06-21','17:30:00',4.08),('8902','2013-06-21','17:35:00',3.72),('8902','2013-06-21','17:40:00',4.1),('8902','2013-06-21','17:45:00',4.03),('8902','2013-06-21','17:50:00',3.75),('8902','2013-06-21','17:55:00',3.57),('8902','2013-06-21','18:00:00',3.27),('8902','2013-06-21','18:05:00',2.73),('8902','2013-06-21','18:10:00',1.9),('8902','2013-06-21','18:15:00',1.77),('8902','2013-06-21','18:20:00',1.83),('8902','2013-06-21','18:25:00',1.16),('8902','2013-06-21','18:35:00',1.01),('8902','2013-06-21','18:40:00',1.06),('8902','2013-06-20','07:20:00',1.01),('8902','2013-06-20','07:25:00',1.12),('8902','2013-06-20','07:30:00',1.24),('8902','2013-06-20','07:35:00',1.37),('8902','2013-06-20','07:40:00',1.5),('8902','2013-06-20','07:45:00',1.63),('8902','2013-06-20','07:50:00',1.78),('8902','2013-06-20','07:55:00',1.93),('8902','2013-06-20','08:00:00',2.07),('8902','2013-06-20','08:05:00',2.21),('8902','2013-06-20','08:10:00',2.35),('8902','2013-06-20','08:15:00',2.49),('8902','2013-06-20','08:20:00',2.63),('8902','2013-06-20','08:25:00',2.77),('8902','2013-06-20','08:30:00',2.92),('8902','2013-06-20','08:35:00',3.07),('8902','2013-06-20','08:40:00',3.21),('8902','2013-06-20','08:45:00',3.35),('8902','2013-06-20','08:50:00',3.5),('8902','2013-06-20','08:55:00',3.61),('8902','2013-06-20','09:00:00',3.73),('8902','2013-06-20','09:05:00',3.86),('8902','2013-06-20','09:10:00',3.98),('8902','2013-06-20','09:15:00',4.09),('8902','2013-06-20','09:20:00',4.23),('8902','2013-06-20','09:25:00',4.3),('8902','2013-06-20','09:30:00',4.42),('8902','2013-06-20','09:35:00',4.55),('8902','2013-06-20','09:40:00',4.65),('8902','2013-06-20','09:45:00',4.76),('8902','2013-06-20','09:50:00',4.83),('8902','2013-06-20','09:55:00',4.94),('8902','2013-06-20','10:00:00',5.1),('8902','2013-06-20','10:05:00',5.21),('8902','2013-06-20','10:10:00',5.29),('8902','2013-06-20','10:15:00',5.3),('8902','2013-06-20','10:20:00',5.38),('8902','2013-06-20','10:25:00',5.47),('8902','2013-06-20','10:30:00',5.64),('8902','2013-06-20','10:35:00',5.72),('8902','2013-06-20','10:40:00',5.79),('8902','2013-06-20','10:45:00',5.88),('8902','2013-06-20','10:50:00',5.98),('8902','2013-06-20','10:55:00',6.05),('8902','2013-06-20','11:00:00',6.15),('8902','2013-06-20','11:05:00',6.2),('8902','2013-06-20','11:10:00',6.19),('8902','2013-06-20','11:15:00',6.29),('8902','2013-06-20','11:20:00',6.46),('8902','2013-06-20','11:25:00',6.58),('8902','2013-06-20','11:30:00',6.67),('8902','2013-06-20','11:35:00',6.65),('8902','2013-06-20','11:40:00',6.66),('8902','2013-06-20','11:45:00',6.72),('8902','2013-06-20','11:50:00',6.89),('8902','2013-06-20','11:55:00',6.92),('8902','2013-06-20','12:00:00',6.86),('8902','2013-06-20','12:05:00',6.98),('8902','2013-06-20','12:10:00',6.99),('8902','2013-06-20','12:15:00',6.97),('8902','2013-06-20','12:20:00',6.96),('8902','2013-06-20','12:25:00',6.97),('8902','2013-06-20','12:30:00',7.1),('8902','2013-06-20','12:35:00',7.1),('8902','2013-06-20','12:40:00',7.13),('8902','2013-06-20','12:45:00',7.07),('8902','2013-06-20','12:50:00',7.05),('8902','2013-06-20','12:55:00',7.01),('8902','2013-06-20','13:00:00',7.05),('8902','2013-06-20','13:05:00',7.13),('8902','2013-06-20','13:10:00',7.07),('8902','2013-06-20','13:15:00',7.17),('8902','2013-06-20','13:20:00',7.23),('8902','2013-06-20','13:25:00',7.18),('8902','2013-06-20','13:30:00',7.28),('8902','2013-06-20','13:35:00',7.43),('8902','2013-06-20','13:40:00',7.34),('8902','2013-06-20','13:45:00',7.36),('8902','2013-06-20','13:50:00',7.39),('8902','2013-06-20','13:55:00',7.32),('8902','2013-06-20','14:00:00',7.36),('8902','2013-06-20','14:05:00',7.37),('8902','2013-06-20','14:10:00',7.38),('8902','2013-06-20','14:15:00',7.3),('8902','2013-06-20','14:20:00',7.29),('8902','2013-06-20','14:25:00',7.31),('8902','2013-06-20','14:30:00',7.29),('8902','2013-06-20','14:35:00',7.31),('8902','2013-06-20','14:40:00',7.22),('8902','2013-06-20','14:45:00',7.19),('8902','2013-06-20','14:50:00',7.14),('8902','2013-06-20','14:55:00',7.14),('8902','2013-06-20','15:00:00',7.1),('8902','2013-06-20','15:05:00',7.06),('8902','2013-06-20','15:10:00',6.95),('8902','2013-06-20','15:15:00',6.91),('8902','2013-06-20','15:20:00',6.88),('8902','2013-06-20','15:25:00',6.81),('8902','2013-06-20','15:30:00',6.74),('8902','2013-06-20','15:35:00',6.71),('8902','2013-06-20','15:40:00',6.65),('8902','2013-06-20','15:45:00',6.57),('8902','2013-06-20','15:50:00',6.47),('8902','2013-06-20','15:55:00',6.38),('8902','2013-06-20','16:00:00',6.34),('8902','2013-06-20','16:05:00',6.25),('8902','2013-06-20','16:10:00',6.15),('8902','2013-06-20','16:15:00',6.04),('8902','2013-06-20','16:20:00',5.95),('8902','2013-06-20','16:25:00',5.84),('8902','2013-06-20','16:30:00',5.75),('8902','2013-06-20','16:35:00',5.62),('8902','2013-06-20','16:40:00',5.42),('8902','2013-06-20','16:45:00',5.38),('8902','2013-06-20','16:50:00',5.25),('8902','2013-06-20','16:55:00',5.01),('8902','2013-06-20','17:00:00',4.99),('8902','2013-06-20','17:05:00',4.87),('8902','2013-06-20','17:10:00',4.75),('8902','2013-06-20','17:15:00',4.64),('8902','2013-06-20','17:20:00',4.48),('8902','2013-06-20','17:25:00',4.26),('8902','2013-06-20','17:30:00',4.18),('8902','2013-06-20','17:35:00',4.04),('8902','2013-06-20','17:40:00',3.86),('8902','2013-06-20','17:45:00',3.74),('8902','2013-06-20','17:50:00',3.56),('8902','2013-06-20','17:55:00',3.33),('8902','2013-06-20','18:00:00',3.17),('8902','2013-06-20','18:05:00',3.08),('8902','2013-06-20','18:10:00',2.9),('8902','2013-06-20','18:15:00',2.76),('8902','2013-06-20','18:20:00',2.55),('8902','2013-06-20','18:25:00',2.39),('8902','2013-06-20','18:30:00',2.24),('8902','2013-06-20','18:35:00',2.04),('8902','2013-06-20','18:40:00',1.86),('8902','2013-06-20','18:45:00',1.71),('8902','2013-06-20','18:50:00',1.57),('8902','2013-06-20','18:55:00',1.39),('8902','2013-06-20','19:00:00',1.27),('8902','2013-06-20','19:05:00',1.11),('8902','2014-04-03','08:35:00',1.03),('8902','2014-04-03','08:40:00',1.39),('8902','2014-04-03','08:45:00',1.43),('8902','2014-04-03','08:50:00',1.54),('8902','2014-04-03','08:55:00',1.54),('8902','2014-04-03','09:00:00',1.54),('8902','2014-04-03','09:05:00',2.14),('8902','2014-04-03','09:10:00',2.87),('8902','2014-04-03','09:15:00',2.62),('8902','2014-04-03','09:20:00',2.01),('8902','2014-04-03','09:25:00',1.74),('8902','2014-04-03','09:30:00',1.66),('8902','2014-04-03','09:35:00',1.7),('8902','2014-04-03','09:40:00',1.63),('8902','2014-04-03','09:45:00',1.65),('8902','2014-04-03','09:50:00',1.5),('8902','2014-04-03','09:55:00',1.04),('8902','2014-04-03','11:15:00',1.03),('8902','2014-04-03','11:20:00',1.13),('8902','2014-04-03','12:45:00',1.04),('8902','2014-04-03','12:50:00',1.26),('8902','2014-04-03','12:55:00',1.28),('8902','2014-04-03','13:00:00',1.44),('8902','2014-04-03','13:05:00',1.16),('8902','2014-04-03','13:10:00',1.31),('8902','2014-04-03','13:15:00',1.41),('8902','2014-04-03','13:20:00',2.87),('8902','2014-04-03','13:25:00',5.82),('8902','2014-04-03','13:30:00',4.49),('8902','2014-04-03','13:35:00',6.65),('8902','2014-04-03','13:40:00',7.91),('8902','2014-04-03','13:45:00',7.02),('8902','2014-04-03','13:50:00',6.76),('8902','2014-04-03','13:55:00',5.12),('8902','2014-04-03','14:00:00',4.03),('8902','2014-04-03','14:05:00',8.14),('8902','2014-04-03','14:10:00',4.58),('8902','2014-04-03','14:15:00',8.46),('8902','2014-04-03','14:20:00',6.05),('8902','2014-04-03','14:25:00',6.38),('8902','2014-04-03','14:30:00',3.07),('8902','2014-04-03','14:35:00',6.46),('8902','2014-04-03','14:40:00',3.53),('8902','2014-04-03','14:45:00',6.94),('8902','2014-04-03','14:50:00',6.88),('8902','2014-04-03','14:55:00',6.88),('8902','2014-04-03','15:00:00',8.12),('8902','2014-04-03','15:05:00',8.07),('8902','2014-04-03','15:10:00',8.13),('8902','2014-04-03','15:15:00',6.82),('8902','2014-04-03','15:20:00',4.37),('8902','2014-04-03','15:25:00',3.76),('8902','2014-04-03','15:30:00',3.59),('8902','2014-04-03','15:35:00',3.54),('8902','2014-04-03','15:40:00',5.28),('8902','2014-04-03','15:45:00',4.45),('8902','2014-04-03','15:50:00',3.88),('8902','2014-04-03','15:55:00',5.89),('8902','2014-04-03','16:00:00',5.54),('8902','2014-04-03','16:05:00',3.12),('8902','2014-04-03','16:10:00',3.59),('8902','2014-04-03','16:15:00',3.23),('8902','2014-04-03','16:20:00',2.02),('8902','2014-04-03','16:25:00',1.82),('8902','2014-04-03','16:30:00',4.45),('8902','2014-04-03','16:35:00',3.52),('8902','2014-04-03','16:40:00',2.63),('8902','2014-04-03','16:45:00',5.68),('8902','2014-04-03','16:50:00',6.34),('8902','2014-04-03','16:55:00',4.37),('8902','2014-04-03','17:00:00',3.81),('8902','2014-04-03','17:05:00',4.24),('8902','2014-04-03','17:10:00',4.37),('8902','2014-04-03','17:15:00',4.71),('8902','2014-04-03','17:20:00',4.24),('8902','2014-04-03','17:25:00',3.59),('8902','2014-04-03','17:30:00',4.23),('8902','2014-04-03','17:35:00',2.74),('8902','2014-04-03','17:40:00',3.13),('8902','2014-04-03','17:45:00',3.4),('8902','2014-04-03','17:50:00',3.05),('8902','2014-04-03','17:55:00',2.91),('8902','2014-04-03','18:00:00',2.58),('8902','2014-04-03','18:05:00',2.36),('8902','2014-04-03','18:10:00',2.14),('8902','2014-04-03','18:15:00',1.89),('8902','2014-04-03','18:20:00',1.66),('8902','2014-04-03','18:25:00',1.45),('8902','2014-04-03','18:30:00',1.25),('8902','2014-04-03','18:35:00',1.17),('8902','2013-06-19','07:25:00',1.03),('8902','2013-06-19','07:30:00',1.14),('8902','2013-06-19','07:35:00',1.19),('8902','2013-06-19','07:40:00',1.3),('8902','2013-06-19','07:45:00',1.46),('8902','2013-06-19','07:50:00',1.67),('8902','2013-06-19','07:55:00',1.82),('8902','2013-06-19','08:00:00',2.02),('8902','2013-06-19','08:05:00',2.17),('8902','2013-06-19','08:10:00',2.34),('8902','2013-06-19','08:15:00',2.49),('8902','2013-06-19','08:20:00',2.65),('8902','2013-06-19','08:25:00',2.8),('8902','2013-06-19','08:30:00',2.95),('8902','2013-06-19','08:35:00',3.09),('8902','2013-06-19','08:40:00',3.25),('8902','2013-06-19','08:45:00',3.39),('8902','2013-06-19','08:50:00',3.54),('8902','2013-06-19','08:55:00',3.67),('8902','2013-06-19','09:00:00',3.8),('8902','2013-06-19','09:05:00',3.94),('8902','2013-06-19','09:10:00',4.08),('8902','2013-06-19','09:15:00',4.18),('8902','2013-06-19','09:20:00',4.33),('8902','2013-06-19','09:25:00',4.44),('8902','2013-06-19','09:30:00',4.55),('8902','2013-06-19','09:35:00',4.65),('8902','2013-06-19','09:40:00',4.81),('8902','2013-06-19','09:45:00',4.9),('8902','2013-06-19','09:50:00',5.04),('8902','2013-06-19','09:55:00',5.14),('8902','2013-06-19','10:00:00',5.25),('8902','2013-06-19','10:05:00',5.35),('8902','2013-06-19','10:10:00',5.44),('8902','2013-06-19','10:15:00',5.56),('8902','2013-06-19','10:20:00',5.67),('8902','2013-06-19','10:25:00',5.78),('8902','2013-06-19','10:30:00',5.88),('8902','2013-06-19','10:35:00',5.95),('8902','2013-06-19','10:40:00',6.04),('8902','2013-06-19','10:45:00',6.07),('8902','2013-06-19','10:50:00',6.11),('8902','2013-06-19','10:55:00',6.17),('8902','2013-06-19','11:00:00',6.34),('8902','2013-06-19','11:05:00',6.35),('8902','2013-06-19','11:10:00',6.46),('8902','2013-06-19','11:15:00',6.52),('8902','2013-06-19','11:20:00',6.38),('8902','2013-06-19','11:25:00',6.38),('8902','2013-06-19','11:30:00',6.57),('8902','2013-06-19','11:35:00',6.7),('8902','2013-06-19','11:40:00',6.79),('8902','2013-06-19','11:45:00',6.87),('8902','2013-06-19','11:50:00',6.93),('8902','2013-06-19','11:55:00',6.82),('8902','2013-06-19','12:00:00',6.81),('8902','2013-06-19','12:05:00',6.82),('8902','2013-06-19','12:10:00',6.84),('8902','2013-06-19','12:15:00',6.68),('8902','2013-06-19','12:20:00',6.63),('8902','2013-06-19','12:25:00',6.83),('8902','2013-06-19','12:30:00',6.85),('8902','2013-06-19','12:35:00',7.3),('8902','2013-06-19','12:40:00',5.36),('8902','2013-06-19','12:45:00',5.92),('8902','2013-06-19','12:50:00',7.22),('8902','2013-06-19','12:55:00',4.53),('8902','2013-06-19','13:00:00',5.99),('8902','2013-06-19','13:05:00',7.19),('8902','2013-06-19','13:10:00',7.53),('8902','2013-06-19','13:15:00',7.46),('8902','2013-06-19','13:20:00',7.33),('8902','2013-06-19','13:25:00',5.84),('8902','2013-06-19','13:30:00',6.92),('8902','2013-06-19','13:35:00',7.28),('8902','2013-06-19','13:40:00',7.34),('8902','2013-06-19','13:45:00',7.37),('8902','2013-06-19','13:50:00',7.44),('8902','2013-06-19','13:55:00',7.31),('8902','2013-06-19','14:00:00',7.37),('8902','2013-06-19','14:05:00',7.54),('8902','2013-06-19','14:10:00',7.49),('8902','2013-06-19','14:15:00',7.48),('8902','2013-06-19','14:20:00',7.51),('8902','2013-06-19','14:25:00',7.45),('8902','2013-06-19','14:30:00',7.42),('8902','2013-06-19','14:35:00',7.48),('8902','2013-06-19','14:40:00',7.48),('8902','2013-06-19','14:45:00',7.45),('8902','2013-06-19','14:50:00',7.47),('8902','2013-06-19','14:55:00',7.44),('8902','2013-06-19','15:00:00',7.38),('8902','2013-06-19','15:05:00',7.27),('8902','2013-06-19','15:10:00',7.2),('8902','2013-06-19','15:15:00',7.16),('8902','2013-06-19','15:20:00',7.07),('8902','2013-06-19','15:25:00',6.95),('8902','2013-06-19','15:30:00',6.88),('8902','2013-06-19','15:35:00',6.8),('8902','2013-06-19','15:40:00',6.78),('8902','2013-06-19','15:45:00',6.69),('8902','2013-06-19','15:50:00',6.57),('8902','2013-06-19','15:55:00',6.5),('8902','2013-06-19','16:00:00',6.4),('8902','2013-06-19','16:05:00',6.32),('8902','2013-06-19','16:10:00',6.26),('8902','2013-06-19','16:15:00',6.17),('8902','2013-06-19','16:20:00',6.06),('8902','2013-06-19','16:25:00',5.93),('8902','2013-06-19','16:30:00',5.86),('8902','2013-06-19','16:35:00',5.69),('8902','2013-06-19','16:40:00',5.47),('8902','2013-06-19','16:45:00',5.44),('8902','2013-06-19','16:50:00',5.3),('8902','2013-06-19','16:55:00',5.08),('8902','2013-06-19','17:00:00',5.02),('8902','2013-06-19','17:05:00',4.87),('8902','2013-06-19','17:10:00',4.76),('8902','2013-06-19','17:15:00',4.63),('8902','2013-06-19','17:20:00',4.51),('8902','2013-06-19','17:25:00',4.3),('8902','2013-06-19','17:30:00',4.2),('8902','2013-06-19','17:35:00',4.07),('8902','2013-06-19','17:40:00',3.9),('8902','2013-06-19','17:45:00',3.78),('8902','2013-06-19','17:50:00',3.64),('8902','2013-06-19','17:55:00',3.38),('8902','2013-06-19','18:00:00',3.25),('8902','2013-06-19','18:05:00',3.16),('8902','2013-06-19','18:10:00',2.95),('8902','2013-06-19','18:15:00',2.83),('8902','2013-06-19','18:20:00',2.64),('8902','2013-06-19','18:25:00',2.42),('8902','2013-06-19','18:30:00',2.3),('8902','2013-06-19','18:35:00',2.09),('8902','2013-06-19','18:40:00',1.92),('8902','2013-06-19','18:45:00',1.75),('8902','2013-06-19','18:50:00',1.59),('8902','2013-06-19','18:55:00',1.4),('8902','2013-06-19','19:00:00',1.27),('8902','2013-06-19','19:05:00',1.09),('8902','2013-06-18','07:25:00',1.08),('8902','2013-06-18','07:30:00',1.2),('8902','2013-06-18','07:35:00',1.31),('8902','2013-06-18','07:40:00',1.44),('8902','2013-06-18','07:45:00',1.57),('8902','2013-06-18','07:50:00',1.7),('8902','2013-06-18','07:55:00',1.85),('8902','2013-06-18','08:00:00',2.01),('8902','2013-06-18','08:05:00',2.17),('8902','2013-06-18','08:10:00',2.32),('8902','2013-06-18','08:15:00',2.44),('8902','2013-06-18','08:20:00',2.59),('8902','2013-06-18','08:25:00',2.72),('8902','2013-06-18','08:30:00',2.86),('8902','2013-06-18','08:35:00',3.01),('8902','2013-06-18','08:40:00',3.16),('8902','2013-06-18','08:45:00',3.31),('8902','2013-06-18','08:50:00',3.46),('8902','2013-06-18','08:55:00',3.59),('8902','2013-06-18','09:00:00',3.73),('8902','2013-06-18','09:05:00',3.87),('8902','2013-06-18','09:10:00',4.01),('8902','2013-06-18','09:15:00',4.15),('8902','2013-06-18','09:20:00',4.26),('8902','2013-06-18','09:25:00',4.38),('8902','2013-06-18','09:30:00',4.5),('8902','2013-06-18','09:35:00',4.61),('8902','2013-06-18','09:40:00',4.72),('8902','2013-06-18','09:45:00',4.82),('8902','2013-06-18','09:50:00',4.95),('8902','2013-06-18','09:55:00',5.08),('8902','2013-06-18','10:00:00',5.18),('8902','2013-06-18','10:05:00',5.23),('8902','2013-06-18','10:10:00',5.34),('8902','2013-06-18','10:15:00',5.44),('8902','2013-06-18','10:20:00',5.48),('8902','2013-06-18','10:25:00',5.55),('8902','2013-06-18','10:30:00',5.68),('8902','2013-06-18','10:35:00',5.74),('8902','2013-06-18','10:40:00',5.8),('8902','2013-06-18','10:45:00',5.93),('8902','2013-06-18','10:50:00',6.01),('8902','2013-06-18','10:55:00',6.06),('8902','2013-06-18','11:00:00',6.14),('8902','2013-06-18','11:05:00',6.16),('8902','2013-06-18','11:10:00',6.22),('8902','2013-06-18','11:15:00',6.32),('8902','2013-06-18','11:20:00',6.35),('8902','2013-06-18','11:25:00',6.43),('8902','2013-06-18','11:30:00',6.52),('8902','2013-06-18','11:35:00',6.53),('8902','2013-06-18','11:40:00',6.52),('8902','2013-06-18','11:45:00',6.48),('8902','2013-06-18','11:50:00',6.65),('8902','2013-06-18','11:55:00',6.63),('8902','2013-06-18','12:00:00',6.75),('8902','2013-06-18','12:05:00',6.72),('8902','2013-06-18','12:10:00',6.82),('8902','2013-06-18','12:15:00',6.78),('8902','2013-06-18','12:20:00',6.71),('8902','2013-06-18','12:25:00',6.67),('8902','2013-06-18','12:30:00',6.61),('8902','2013-06-18','12:35:00',7.1),('8902','2013-06-18','12:40:00',7.19),('8902','2013-06-18','12:45:00',7.21),('8902','2013-06-18','12:50:00',7.12),('8902','2013-06-18','12:55:00',7.22),('8902','2013-06-18','13:00:00',7.2),('8902','2013-06-18','13:05:00',7.22),('8902','2013-06-18','13:10:00',7.18),('8902','2013-06-18','13:15:00',7.26),('8902','2013-06-18','13:20:00',7.23),('8902','2013-06-18','13:25:00',7.31),('8902','2013-06-18','13:30:00',7.38),('8902','2013-06-18','13:35:00',7.29),('8902','2013-06-18','13:40:00',7.34),('8902','2013-06-18','13:45:00',7.36),('8902','2013-06-18','13:50:00',7.32),('8902','2013-06-18','13:55:00',7.42),('8902','2013-06-18','14:00:00',7.41),('8902','2013-06-18','14:05:00',7.43),('8902','2013-06-18','14:10:00',7.35),('8902','2013-06-18','14:15:00',7.3),('8902','2013-06-18','14:20:00',7.28),('8902','2013-06-18','14:25:00',7.3),('8902','2013-06-18','14:30:00',7.22),('8902','2013-06-18','14:35:00',7.2),('8902','2013-06-18','14:40:00',7.09),('8902','2013-06-18','14:45:00',7.04),('8902','2013-06-18','14:50:00',6.99),('8902','2013-06-18','14:55:00',6.95),('8902','2013-06-18','15:00:00',6.95),('8902','2013-06-18','15:05:00',6.91),('8902','2013-06-18','15:10:00',6.82),('8902','2013-06-18','15:15:00',6.75),('8902','2013-06-18','15:20:00',6.69),('8902','2013-06-18','15:25:00',6.64),('8902','2013-06-18','15:30:00',6.58),('8902','2013-06-18','15:35:00',6.48),('8902','2013-06-18','15:40:00',6.42),('8902','2013-06-18','15:45:00',6.32),('8902','2013-06-18','15:50:00',6.23),('8902','2013-06-18','15:55:00',6.12),('8902','2013-06-18','16:00:00',6.03),('8902','2013-06-18','16:05:00',5.95),('8902','2013-06-18','16:10:00',5.86),('8902','2013-06-18','16:15:00',5.78),('8902','2013-06-18','16:20:00',5.67),('8902','2013-06-18','16:25:00',5.57),('8902','2013-06-18','16:30:00',5.47),('8902','2013-06-18','16:35:00',5.35),('8902','2013-06-18','16:40:00',5.14),('8902','2013-06-18','16:45:00',5.13),('8902','2013-06-18','16:50:00',4.98),('8902','2013-06-18','16:55:00',4.81),('8902','2013-06-18','17:00:00',4.78),('8902','2013-06-18','17:05:00',4.64),('8902','2013-06-18','17:10:00',4.55),('8902','2013-06-18','17:15:00',4.44),('8902','2013-06-18','17:20:00',4.38),('8902','2013-06-18','17:25:00',4.18),('8902','2013-06-18','17:30:00',4.09),('8902','2013-06-18','17:35:00',3.94),('8902','2013-06-18','17:40:00',3.79),('8902','2013-06-18','17:45:00',3.65),('8902','2013-06-18','17:50:00',3.48),('8902','2013-06-18','17:55:00',3.24),('8902','2013-06-18','18:00:00',3.12),('8902','2013-06-18','18:05:00',3),('8902','2013-06-18','18:10:00',2.77),('8902','2013-06-18','18:15:00',2.63),('8902','2013-06-18','18:20:00',2.46),('8902','2013-06-18','18:25:00',2.31),('8902','2013-06-18','18:30:00',2.13),('8902','2013-06-18','18:35:00',1.85),('8902','2013-06-18','18:40:00',1.65),('8902','2013-06-18','18:45:00',1.5),('8902','2013-06-18','18:50:00',1.41),('8902','2013-06-18','18:55:00',1.28),('8902','2013-06-18','19:00:00',1.2),('8902','2013-06-18','19:05:00',1.05),('8902','2013-06-17','07:25:00',1.07),('8902','2013-06-17','07:30:00',1.2),('8902','2013-06-17','07:35:00',1.33),('8902','2013-06-17','07:40:00',1.45),('8902','2013-06-17','07:45:00',1.58),('8902','2013-06-17','07:50:00',1.71),('8902','2013-06-17','07:55:00',1.85),('8902','2013-06-17','08:00:00',1.98),('8902','2013-06-17','08:05:00',2.13),('8902','2013-06-17','08:10:00',2.28),('8902','2013-06-17','08:15:00',2.41),('8902','2013-06-17','08:20:00',2.57),('8902','2013-06-17','08:25:00',2.72),('8902','2013-06-17','08:30:00',2.86),('8902','2013-06-17','08:35:00',3),('8902','2013-06-17','08:40:00',3.14),('8902','2013-06-17','08:45:00',3.27),('8902','2013-06-17','08:50:00',3.4),('8902','2013-06-17','08:55:00',3.53),('8902','2013-06-17','09:00:00',3.67),('8902','2013-06-17','09:05:00',3.81),('8902','2013-06-17','09:10:00',3.93),('8902','2013-06-17','09:15:00',4.04),('8902','2013-06-17','09:20:00',4.18),('8902','2013-06-17','09:25:00',4.33),('8902','2013-06-17','09:30:00',4.42),('8902','2013-06-17','09:35:00',4.57),('8902','2013-06-17','09:40:00',4.69),('8902','2013-06-17','09:45:00',4.8),('8902','2013-06-17','09:50:00',4.91),('8902','2013-06-17','09:55:00',4.96),('8902','2013-06-17','10:00:00',5.05),('8902','2013-06-17','10:05:00',5.07),('8902','2013-06-17','10:10:00',5.27),('8902','2013-06-17','10:15:00',5.37),('8902','2013-06-17','10:20:00',5.49),('8902','2013-06-17','10:25:00',5.58),('8902','2013-06-17','10:30:00',5.65),('8902','2013-06-17','10:35:00',5.75),('8902','2013-06-17','10:40:00',5.82),('8902','2013-06-17','10:45:00',5.85),('8902','2013-06-17','10:50:00',5.9),('8902','2013-06-17','10:55:00',6),('8902','2013-06-17','11:00:00',6.07),('8902','2013-06-17','11:05:00',6.2),('8902','2013-06-17','11:10:00',6.36),('8902','2013-06-17','11:15:00',6.4),('8902','2013-06-17','11:20:00',6.43),('8902','2013-06-17','11:25:00',6.44),('8902','2013-06-17','11:30:00',6.46),('8902','2013-06-17','11:35:00',6.48),('8902','2013-06-17','11:40:00',6.51),('8902','2013-06-17','11:45:00',6.57),('8902','2013-06-17','11:50:00',6.57),('8902','2013-06-17','11:55:00',6.53),('8902','2013-06-17','12:00:00',6.52),('8902','2013-06-17','12:05:00',6.71),('8902','2013-06-17','12:10:00',6.69),('8902','2013-06-17','12:15:00',6.6),('8902','2013-06-17','12:20:00',6.61),('8902','2013-06-17','12:25:00',6.79),('8902','2013-06-17','12:30:00',6.78),('8902','2013-06-17','12:35:00',6.42),('8902','2013-06-17','12:40:00',5.85),('8902','2013-06-17','12:45:00',5.36),('8902','2013-06-17','12:50:00',6.24),('8902','2013-06-17','12:55:00',7.23),('8902','2013-06-17','13:00:00',7.04),('8902','2013-06-17','13:05:00',6.4),('8902','2013-06-17','13:10:00',7.56),('8902','2013-06-17','13:15:00',7.27),('8902','2013-06-17','13:20:00',7.68),('8902','2013-06-17','13:25:00',7.09),('8902','2013-06-17','13:30:00',7.61),('8902','2013-06-17','13:35:00',7.31),('8902','2013-06-17','13:40:00',7.12),('8902','2013-06-17','13:45:00',7.28),('8902','2013-06-17','13:50:00',7.35),('8902','2013-06-17','13:55:00',7.58),('8902','2013-06-17','14:00:00',7.58),('8902','2013-06-17','14:05:00',7.6),('8902','2013-06-17','14:10:00',7.55),('8902','2013-06-17','14:15:00',7.42),('8902','2013-06-17','14:20:00',7.29),('8902','2013-06-17','14:25:00',7.38),('8902','2013-06-17','14:30:00',7.28),('8902','2013-06-17','14:35:00',7.33),('8902','2013-06-17','14:40:00',7.31),('8902','2013-06-17','14:45:00',7.2),('8902','2013-06-17','14:50:00',7.1),('8902','2013-06-17','14:55:00',7.06),('8902','2013-06-17','15:00:00',7.05),('8902','2013-06-17','15:05:00',6.96),('8902','2013-06-17','15:10:00',6.92),('8902','2013-06-17','15:15:00',6.83),('8902','2013-06-17','15:20:00',6.73),('8902','2013-06-17','15:25:00',6.7),('8902','2013-06-17','15:30:00',6.59),('8902','2013-06-17','15:35:00',6.59),('8902','2013-06-17','15:40:00',6.56),('8902','2013-06-17','15:45:00',6.49),('8902','2013-06-17','15:50:00',6.47),('8902','2013-06-17','15:55:00',6.39),('8902','2013-06-17','16:00:00',6.37),('8902','2013-06-17','16:05:00',6.32),('8902','2013-06-17','16:10:00',6.24),('8902','2013-06-17','16:15:00',6.18),('8902','2013-06-17','16:20:00',6.12),('8902','2013-06-17','16:25:00',5.78),('8902','2013-06-17','16:30:00',5.66),('8902','2013-06-17','16:35:00',5.35),('8902','2013-06-17','16:40:00',5.35),('8902','2013-06-17','16:45:00',5.21),('8902','2013-06-17','16:50:00',5.11),('8902','2013-06-17','16:55:00',4.9),('8902','2013-06-17','17:00:00',4.83),('8902','2013-06-17','17:05:00',4.73),('8902','2013-06-17','17:10:00',4.62),('8902','2013-06-17','17:15:00',4.51),('8902','2013-06-17','17:20:00',4.38),('8902','2013-06-17','17:25:00',4.2),('8902','2013-06-17','17:30:00',4.07),('8902','2013-06-17','17:35:00',3.94),('8902','2013-06-17','17:40:00',3.73),('8902','2013-06-17','17:45:00',3.62),('8902','2013-06-17','17:50:00',3.47),('8902','2013-06-17','17:55:00',3.24),('8902','2013-06-17','18:00:00',3.08),('8902','2013-06-17','18:05:00',3),('8902','2013-06-17','18:10:00',2.82),('8902','2013-06-17','18:15:00',2.72),('8902','2013-06-17','18:20:00',2.55),('8902','2013-06-17','18:25:00',2.37),('8902','2013-06-17','18:30:00',2.22),('8902','2013-06-17','18:35:00',1.99),('8902','2013-06-17','18:40:00',1.85),('8902','2013-06-17','18:45:00',1.7),('8902','2013-06-17','18:50:00',1.55),('8902','2013-06-17','18:55:00',1.37),('8902','2013-06-17','19:00:00',1.26),('8902','2013-06-17','19:05:00',1.1),('8902','2013-06-16','07:25:00',1.11),('8902','2013-06-16','07:30:00',1.24),('8902','2013-06-16','07:35:00',1.37),('8902','2013-06-16','07:40:00',1.51),('8902','2013-06-16','07:45:00',1.65),('8902','2013-06-16','07:50:00',1.79),('8902','2013-06-16','07:55:00',1.94),('8902','2013-06-16','08:00:00',2.1),('8902','2013-06-16','08:05:00',2.25),('8902','2013-06-16','08:10:00',2.4),('8902','2013-06-16','08:15:00',2.55),('8902','2013-06-16','08:20:00',2.7),('8902','2013-06-16','08:25:00',2.85),('8902','2013-06-16','08:30:00',3),('8902','2013-06-16','08:35:00',3.15),('8902','2013-06-16','08:40:00',3.31),('8902','2013-06-16','08:45:00',3.45),('8902','2013-06-16','08:50:00',3.59),('8902','2013-06-16','08:55:00',3.74),('8902','2013-06-16','09:00:00',3.89),('8902','2013-06-16','09:05:00',4.02),('8902','2013-06-16','09:10:00',4.17),('8902','2013-06-16','09:15:00',4.28),('8902','2013-06-16','09:20:00',4.42),('8902','2013-06-16','09:25:00',4.55),('8902','2013-06-16','09:30:00',4.67),('8902','2013-06-16','09:35:00',4.78),('8902','2013-06-16','09:40:00',4.9),('8902','2013-06-16','09:45:00',5.02),('8902','2013-06-16','09:50:00',5.12),('8902','2013-06-16','09:55:00',5.22),('8902','2013-06-16','10:00:00',5.3),('8902','2013-06-16','10:05:00',5.42),('8902','2013-06-16','10:10:00',5.53),('8902','2013-06-16','10:15:00',5.59),('8902','2013-06-16','10:20:00',5.68),('8902','2013-06-16','10:25:00',5.77),('8902','2013-06-16','10:30:00',5.89),('8902','2013-06-16','10:35:00',5.99),('8902','2013-06-16','10:40:00',6.06),('8902','2013-06-16','10:45:00',6.13),('8902','2013-06-16','10:50:00',6.18),('8902','2013-06-16','10:55:00',6.27),('8902','2013-06-16','11:00:00',6.37),('8902','2013-06-16','11:05:00',6.39),('8902','2013-06-16','11:10:00',6.42),('8902','2013-06-16','11:15:00',6.46),('8902','2013-06-16','11:20:00',6.54),('8902','2013-06-16','11:25:00',6.59),('8902','2013-06-16','11:30:00',6.61),('8902','2013-06-16','11:35:00',6.65),('8902','2013-06-16','11:40:00',6.61),('8902','2013-06-16','11:45:00',6.72),('8902','2013-06-16','11:50:00',6.79),('8902','2013-06-16','11:55:00',6.83),('8902','2013-06-16','12:00:00',6.84),('8902','2013-06-16','12:05:00',6.86),('8902','2013-06-16','12:10:00',6.97),('8902','2013-06-16','12:15:00',7.07),('8902','2013-06-16','12:20:00',7.1),('8902','2013-06-16','12:25:00',7.05),('8902','2013-06-16','12:30:00',7.03),('8902','2013-06-16','12:35:00',7.06),('8902','2013-06-16','12:40:00',7.08),('8902','2013-06-16','12:45:00',7.09),('8902','2013-06-16','12:50:00',7.14),('8902','2013-06-16','12:55:00',7.21),('8902','2013-06-16','13:00:00',7.28),('8902','2013-06-16','13:05:00',7.32),('8902','2013-06-16','13:10:00',7.36),('8902','2013-06-16','13:15:00',7.43),('8902','2013-06-16','13:20:00',7.4),('8902','2013-06-16','13:25:00',7.37),('8902','2013-06-16','13:30:00',7.39),('8902','2013-06-16','13:35:00',7.35),('8902','2013-06-16','13:40:00',7.33),('8902','2013-06-16','13:45:00',7.39),('8902','2013-06-16','13:50:00',7.34),('8902','2013-06-16','13:55:00',7.34),('8902','2013-06-16','14:00:00',7.34),('8902','2013-06-16','14:05:00',7.34),('8902','2013-06-16','14:10:00',7.3),('8902','2013-06-16','14:15:00',7.29),('8902','2013-06-16','14:20:00',7.22),('8902','2013-06-16','14:25:00',7.2),('8902','2013-06-16','14:30:00',7.16),('8902','2013-06-16','14:35:00',7.15),('8902','2013-06-16','14:40:00',7.15),('8902','2013-06-16','14:45:00',7.12),('8902','2013-06-16','14:50:00',7.05),('8902','2013-06-16','14:55:00',7.05),('8902','2013-06-16','15:00:00',6.98),('8902','2013-06-16','15:05:00',6.94),('8902','2013-06-16','15:10:00',6.84),('8902','2013-06-16','15:15:00',6.76),('8902','2013-06-16','15:20:00',6.72),('8902','2013-06-16','15:25:00',6.68),('8902','2013-06-16','15:30:00',6.6),('8902','2013-06-16','15:35:00',6.55),('8902','2013-06-16','15:40:00',6.47),('8902','2013-06-16','15:45:00',6.4),('8902','2013-06-16','15:50:00',6.29),('8902','2013-06-16','15:55:00',6.21),('8902','2013-06-16','16:00:00',6.16),('8902','2013-06-16','16:05:00',6.06),('8902','2013-06-16','16:10:00',5.98),('8902','2013-06-16','16:15:00',5.9),('8902','2013-06-16','16:20:00',5.82),('8902','2013-06-16','16:25:00',5.73),('8902','2013-06-16','16:30:00',5.57),('8902','2013-06-16','16:35:00',5.41),('8902','2013-06-16','16:40:00',5.29),('8902','2013-06-16','16:45:00',5.21),('8902','2013-06-16','16:50:00',5.11),('8902','2013-06-16','16:55:00',4.91),('8902','2013-06-16','17:00:00',4.9),('8902','2013-06-16','17:05:00',4.79),('8902','2013-06-16','17:10:00',4.65),('8902','2013-06-16','17:15:00',4.52),('8902','2013-06-16','17:20:00',4.4),('8902','2013-06-16','17:25:00',4.24),('8902','2013-06-16','17:30:00',4.18),('8902','2013-06-16','17:35:00',4.04),('8902','2013-06-16','17:40:00',3.85),('8902','2013-06-16','17:45:00',3.72),('8902','2013-06-16','17:50:00',3.58),('8902','2013-06-16','17:55:00',3.37),('8902','2013-06-16','18:00:00',3.24),('8902','2013-06-16','18:05:00',3.1),('8902','2013-06-16','18:10:00',2.92),('8902','2013-06-16','18:15:00',2.8),('8902','2013-06-16','18:20:00',2.6),('8902','2013-06-16','18:25:00',2.29),('8902','2013-06-16','18:30:00',2.3),('8902','2013-06-16','18:35:00',1.96),('8902','2013-06-16','18:40:00',1.92),('8902','2013-06-16','18:45:00',1.82),('8902','2013-06-16','18:50:00',1.74),('8902','2013-06-16','18:55:00',1.59),('8902','2013-06-16','19:00:00',1.47),('8902','2013-06-16','19:05:00',1.28),('8902','2013-06-16','19:10:00',1.11),('8902','2013-06-15','07:20:00',1.01),('8902','2013-06-15','07:25:00',1.13),('8902','2013-06-15','07:30:00',1.26),('8902','2013-06-15','07:35:00',1.4),('8902','2013-06-15','07:40:00',1.54),('8902','2013-06-15','07:45:00',1.68),('8902','2013-06-15','07:50:00',1.83),('8902','2013-06-15','07:55:00',1.98),('8902','2013-06-15','08:00:00',2.13),('8902','2013-06-15','08:05:00',2.27),('8902','2013-06-15','08:10:00',2.43),('8902','2013-06-15','08:15:00',2.6),('8902','2013-06-15','08:20:00',2.75),('8902','2013-06-15','08:25:00',2.91),('8902','2013-06-15','08:30:00',3.05),('8902','2013-06-15','08:35:00',3.22),('8902','2013-06-15','08:40:00',3.33),('8902','2013-06-15','08:45:00',3.49),('8902','2013-06-15','08:50:00',3.62),('8902','2013-06-15','08:55:00',3.8),('8902','2013-06-15','09:00:00',3.96),('8902','2013-06-15','09:05:00',4.1),('8902','2013-06-15','09:10:00',4.26),('8902','2013-06-15','09:15:00',4.42),('8902','2013-06-15','09:20:00',4.53),('8902','2013-06-15','09:25:00',4.63),('8902','2013-06-15','09:30:00',4.73),('8902','2013-06-15','09:35:00',4.83),('8902','2013-06-15','09:40:00',4.96),('8902','2013-06-15','09:45:00',5.07),('8902','2013-06-15','09:50:00',5.19),('8902','2013-06-15','09:55:00',5.28),('8902','2013-06-15','10:00:00',5.38),('8902','2013-06-15','10:05:00',5.49),('8902','2013-06-15','10:10:00',5.56),('8902','2013-06-15','10:15:00',5.63),('8902','2013-06-15','10:20:00',5.73),('8902','2013-06-15','10:25:00',5.93),('8902','2013-06-15','10:30:00',6.02),('8902','2013-06-15','10:35:00',6.15),('8902','2013-06-15','10:40:00',6.2),('8902','2013-06-15','10:45:00',6.26),('8902','2013-06-15','10:50:00',6.3),('8902','2013-06-15','10:55:00',6.39),('8902','2013-06-15','11:00:00',6.5),('8902','2013-06-15','11:05:00',6.48),('8902','2013-06-15','11:10:00',6.59),('8902','2013-06-15','11:15:00',6.7),('8902','2013-06-15','11:20:00',6.77),('8902','2013-06-15','11:25:00',6.85),('8902','2013-06-15','11:30:00',6.88),('8902','2013-06-15','11:35:00',6.95),('8902','2013-06-15','11:40:00',7.03),('8902','2013-06-15','11:45:00',6.99),('8902','2013-06-15','11:50:00',7.05),('8902','2013-06-15','11:55:00',7.12),('8902','2013-06-15','12:00:00',7.14),('8902','2013-06-15','12:05:00',7.24),('8902','2013-06-15','12:10:00',7.27),('8902','2013-06-15','12:15:00',7.3),('8902','2013-06-15','12:20:00',7.41),('8902','2013-06-15','12:25:00',7.44),('8902','2013-06-15','12:30:00',7.46),('8902','2013-06-15','12:35:00',7.48),('8902','2013-06-15','12:40:00',7.44),('8902','2013-06-15','12:45:00',7.46),('8902','2013-06-15','12:50:00',7.46),('8902','2013-06-15','12:55:00',7.41),('8902','2013-06-15','13:00:00',7.44),('8902','2013-06-15','13:05:00',7.48),('8902','2013-06-15','13:10:00',7.63),('8902','2013-06-15','13:15:00',7.66),('8902','2013-06-15','13:20:00',7.67),('8902','2013-06-15','13:25:00',7.7),('8902','2013-06-15','13:30:00',7.67),('8902','2013-06-15','13:35:00',7.74),('8902','2013-06-15','13:40:00',7.75),('8902','2013-06-15','13:45:00',7.71),('8902','2013-06-15','13:50:00',7.68),('8902','2013-06-15','13:55:00',7.68),('8902','2013-06-15','14:00:00',7.64),('8902','2013-06-15','14:05:00',7.56),('8902','2013-06-15','14:10:00',7.57),('8902','2013-06-15','14:15:00',7.59),('8902','2013-06-15','14:20:00',7.57),('8902','2013-06-15','14:25:00',7.52),('8902','2013-06-15','14:30:00',7.48),('8902','2013-06-15','14:35:00',7.45),('8902','2013-06-15','14:40:00',7.37),('8902','2013-06-15','14:45:00',7.29),('8902','2013-06-15','14:50:00',7.24),('8902','2013-06-15','14:55:00',7.2),('8902','2013-06-15','15:00:00',7.17),('8902','2013-06-15','15:05:00',7.14),('8902','2013-06-15','15:10:00',7.11),('8902','2013-06-15','15:15:00',7.09),('8902','2013-06-15','15:20:00',7.02),('8902','2013-06-15','15:25:00',6.95),('8902','2013-06-15','15:30:00',6.88),('8902','2013-06-15','15:35:00',6.77),('8902','2013-06-15','15:40:00',6.71),('8902','2013-06-15','15:45:00',6.63),('8902','2013-06-15','15:50:00',6.58),('8902','2013-06-15','15:55:00',6.48),('8902','2013-06-15','16:00:00',6.38),('8902','2013-06-15','16:05:00',6.29),('8902','2013-06-15','16:10:00',6.2),('8902','2013-06-15','16:15:00',6.13),('8902','2013-06-15','16:20:00',5.99),('8902','2013-06-15','16:25:00',5.88),('8902','2013-06-15','16:30:00',5.77),('8902','2013-06-15','16:35:00',5.61),('8902','2013-06-15','16:40:00',5.46),('8902','2013-06-15','16:45:00',5.4),('8902','2013-06-15','16:50:00',5.26),('8902','2013-06-15','16:55:00',5.09),('8902','2013-06-15','17:00:00',4.99),('8902','2013-06-15','17:05:00',4.85),('8902','2013-06-15','17:10:00',4.71),('8902','2013-06-15','17:15:00',4.58),('8902','2013-06-15','17:20:00',4.44),('8902','2013-06-15','17:25:00',4.23),('8902','2013-06-15','17:30:00',4.14),('8902','2013-06-15','17:35:00',4),('8902','2013-06-15','17:40:00',3.81),('8902','2013-06-15','17:45:00',3.68),('8902','2013-06-15','17:50:00',3.52),('8902','2013-06-15','17:55:00',3.24),('8902','2013-06-15','18:00:00',3.16),('8902','2013-06-15','18:05:00',3.04),('8902','2013-06-15','18:10:00',2.84),('8902','2013-06-15','18:15:00',2.71),('8902','2013-06-15','18:20:00',2.51),('8902','2013-06-15','18:25:00',2.34),('8902','2013-06-15','18:30:00',2.2),('8902','2013-06-15','18:35:00',1.96),('8902','2013-06-15','18:40:00',1.85),('8902','2013-06-15','18:45:00',1.7),('8902','2013-06-15','18:50:00',1.58),('8902','2013-06-15','18:55:00',1.39),('8902','2013-06-15','19:00:00',1.26),('8902','2013-06-15','19:05:00',1.1),('8902','2013-06-14','07:20:00',1.02),('8902','2013-06-14','07:25:00',1.13),('8902','2013-06-14','07:30:00',1.25),('8902','2013-06-14','07:35:00',1.38),('8902','2013-06-14','07:40:00',1.52),('8902','2013-06-14','07:45:00',1.67),('8902','2013-06-14','07:50:00',1.81),('8902','2013-06-14','07:55:00',1.95),('8902','2013-06-14','08:00:00',2.09),('8902','2013-06-14','08:05:00',2.25),('8902','2013-06-14','08:10:00',2.4),('8902','2013-06-14','08:15:00',2.56),('8902','2013-06-14','08:20:00',2.75),('8902','2013-06-14','08:25:00',2.85),('8902','2013-06-14','08:30:00',3),('8902','2013-06-14','08:35:00',3.03),('8902','2013-06-14','08:40:00',3.25),('8902','2013-06-14','08:45:00',3.45),('8902','2013-06-14','08:50:00',3.21),('8902','2013-06-14','08:55:00',3.7),('8902','2013-06-14','09:00:00',3.74),('8902','2013-06-14','09:05:00',3.34),('8902','2013-06-14','09:10:00',4.24),('8902','2013-06-14','09:15:00',4.32),('8902','2013-06-14','09:20:00',4.47),('8902','2013-06-14','09:25:00',4.48),('8902','2013-06-14','09:30:00',4.77),('8902','2013-06-14','09:35:00',4.92),('8902','2013-06-14','09:40:00',4.12),('8902','2013-06-14','09:45:00',5),('8902','2013-06-14','09:50:00',4.96),('8902','2013-06-14','09:55:00',5.28),('8902','2013-06-14','10:00:00',5.54),('8902','2013-06-14','10:05:00',5.7),('8902','2013-06-14','10:10:00',5.74),('8902','2013-06-14','10:15:00',2.66),('8902','2013-06-14','10:20:00',3.97),('8902','2013-06-14','10:25:00',3.91),('8902','2013-06-14','10:30:00',4.51),('8902','2013-06-14','10:35:00',6.5),('8902','2013-06-14','10:40:00',4.27),('8902','2013-06-14','10:45:00',5.4),('8902','2013-06-14','10:50:00',5.58),('8902','2013-06-14','10:55:00',5.4),('8902','2013-06-14','11:00:00',5.69),('8902','2013-06-14','11:05:00',4.72),('8902','2013-06-14','11:10:00',5.26),('8902','2013-06-14','11:15:00',7.4),('8902','2013-06-14','11:20:00',7.36),('8902','2013-06-14','11:25:00',5.32),('8902','2013-06-14','11:30:00',4.98),('8902','2013-06-14','11:35:00',7.68),('8902','2013-06-14','11:40:00',7.24),('8902','2013-06-14','11:45:00',7.64),('8902','2013-06-14','11:50:00',4),('8902','2013-06-14','11:55:00',7.74),('8902','2013-06-14','12:00:00',7.67),('8902','2013-06-14','12:05:00',7.65),('8902','2013-06-14','12:10:00',7.21),('8902','2013-06-14','12:15:00',7.84),('8902','2013-06-14','12:20:00',7.76),('8902','2013-06-14','12:25:00',7.58),('8902','2013-06-14','12:30:00',7.65),('8902','2013-06-14','12:35:00',7.69),('8902','2013-06-14','12:40:00',7.58),('8902','2013-06-14','12:45:00',7.65),('8902','2013-06-14','12:50:00',7.65),('8902','2013-06-14','12:55:00',7.68),('8902','2013-06-14','13:00:00',7.68),('8902','2013-06-14','13:05:00',7.64),('8902','2013-06-14','13:10:00',7.77),('8902','2013-06-14','13:15:00',7.75),('8902','2013-06-14','13:20:00',7.7),('8902','2013-06-14','13:25:00',7.71),('8902','2013-06-14','13:30:00',7.73),('8902','2013-06-14','13:35:00',7.59),('8902','2013-06-14','13:40:00',7.66),('8902','2013-06-14','13:45:00',7.66),('8902','2013-06-14','13:50:00',7.64),('8902','2013-06-14','13:55:00',7.57),('8902','2013-06-14','14:00:00',7.58),('8902','2013-06-14','14:05:00',7.56),('8902','2013-06-14','14:10:00',7.56),('8902','2013-06-14','14:15:00',7.5),('8902','2013-06-14','14:20:00',7.48),('8902','2013-06-14','14:25:00',7.53),('8902','2013-06-14','14:30:00',7.46),('8902','2013-06-14','14:35:00',7.45),('8902','2013-06-14','14:40:00',7.44),('8902','2013-06-14','14:45:00',7.35),('8902','2013-06-14','14:50:00',7.31),('8902','2013-06-14','14:55:00',7.32),('8902','2013-06-14','15:00:00',7.14),('8902','2013-06-14','15:05:00',7.12),('8902','2013-06-14','15:10:00',7.06),('8902','2013-06-14','15:15:00',7.01),('8902','2013-06-14','15:20:00',7.05),('8902','2013-06-14','15:25:00',7.02),('8902','2013-06-14','15:30:00',6.93),('8902','2013-06-14','15:35:00',6.81),('8902','2013-06-14','15:40:00',6.71),('8902','2013-06-14','15:45:00',6.67),('8902','2013-06-14','15:50:00',6.56),('8902','2013-06-14','15:55:00',6.49),('8902','2013-06-14','16:00:00',6.41),('8902','2013-06-14','16:05:00',6.29),('8902','2013-06-14','16:10:00',6.17),('8902','2013-06-14','16:15:00',6.11),('8902','2013-06-14','16:20:00',5.98),('8902','2013-06-14','16:25:00',5.85),('8902','2013-06-14','16:30:00',5.77),('8902','2013-06-14','16:35:00',5.55),('8902','2013-06-14','16:40:00',5.47),('8902','2013-06-14','16:45:00',5.38),('8902','2013-06-14','16:50:00',5.21),('8902','2013-06-14','16:55:00',4.97),('8902','2013-06-14','17:00:00',4.98),('8902','2013-06-14','17:05:00',4.83),('8902','2013-06-14','17:10:00',4.72),('8902','2013-06-14','17:15:00',4.59),('8902','2013-06-14','17:20:00',4.44),('8902','2013-06-14','17:25:00',4.21),('8902','2013-06-14','17:30:00',4.11),('8902','2013-06-14','17:35:00',3.97),('8902','2013-06-14','17:40:00',3.81),('8902','2013-06-14','17:45:00',3.64),('8902','2013-06-14','17:50:00',3.46),('8902','2013-06-14','17:55:00',3.18),('8902','2013-06-14','18:00:00',3.07),('8902','2013-06-14','18:05:00',2.95),('8902','2013-06-14','18:10:00',2.76),('8902','2013-06-14','18:15:00',2.67),('8902','2013-06-14','18:20:00',2.44),('8902','2013-06-14','18:25:00',2.32),('8902','2013-06-14','18:30:00',2.14),('8902','2013-06-14','18:35:00',1.92),('8902','2013-06-14','18:40:00',1.81),('8902','2013-06-14','18:45:00',1.64),('8902','2013-06-14','18:50:00',1.51),('8902','2013-06-14','18:55:00',1.34),('8902','2013-06-14','19:00:00',1.22),('8902','2013-06-14','19:05:00',1.08),('8902','2013-06-13','07:20:00',1.02),('8902','2013-06-13','07:25:00',1.17),('8902','2013-06-13','07:30:00',1.31),('8902','2013-06-13','07:35:00',1.46),('8902','2013-06-13','07:40:00',1.62),('8902','2013-06-13','07:45:00',1.78),('8902','2013-06-13','07:50:00',1.94),('8902','2013-06-13','07:55:00',2.1),('8902','2013-06-13','08:00:00',2.26),('8902','2013-06-13','08:05:00',2.42),('8902','2013-06-13','08:10:00',2.58),('8902','2013-06-13','08:15:00',2.75),('8902','2013-06-13','08:20:00',2.91),('8902','2013-06-13','08:25:00',3.07),('8902','2013-06-13','08:30:00',3.23),('8902','2013-06-13','08:35:00',3.39),('8902','2013-06-13','08:40:00',3.54),('8902','2013-06-13','08:45:00',3.71),('8902','2013-06-13','08:50:00',3.86),('8902','2013-06-13','08:55:00',4),('8902','2013-06-13','09:00:00',4.15),('8902','2013-06-13','09:05:00',4.29),('8902','2013-06-13','09:10:00',4.43),('8902','2013-06-13','09:15:00',4.56),('8902','2013-06-13','09:20:00',4.68),('8902','2013-06-13','09:25:00',4.78),('8902','2013-06-13','09:30:00',4.87),('8902','2013-06-13','09:35:00',5.07),('8902','2013-06-13','09:40:00',5.21),('8902','2013-06-13','09:45:00',5.33),('8902','2013-06-13','09:50:00',5.45),('8902','2013-06-13','09:55:00',5.57),('8902','2013-06-13','10:00:00',5.68),('8902','2013-06-13','10:05:00',5.77),('8902','2013-06-13','10:10:00',5.82),('8902','2013-06-13','10:15:00',5.91),('8902','2013-06-13','10:20:00',6.04),('8902','2013-06-13','10:25:00',6.04),('8902','2013-06-13','10:30:00',6.21),('8902','2013-06-13','10:35:00',6.44),('8902','2013-06-13','10:40:00',6.53),('8902','2013-06-13','10:45:00',6.57),('8902','2013-06-13','10:50:00',6.55),('8902','2013-06-13','10:55:00',6.56),('8902','2013-06-13','11:00:00',6.54),('8902','2013-06-13','11:05:00',6.63),('8902','2013-06-13','11:10:00',6.81),('8902','2013-06-13','11:15:00',6.88),('8902','2013-06-13','11:20:00',6.89),('8902','2013-06-13','11:25:00',6.77),('8902','2013-06-13','11:30:00',7.17),('8902','2013-06-13','11:35:00',7.22),('8902','2013-06-13','11:40:00',7.2),('8902','2013-06-13','11:45:00',7.23),('8902','2013-06-13','11:50:00',7.3),('8902','2013-06-13','11:55:00',7.32),('8902','2013-06-13','12:00:00',7.35),('8902','2013-06-13','12:05:00',7.36),('8902','2013-06-13','12:10:00',7.38),('8902','2013-06-13','12:15:00',7.36),('8902','2013-06-13','12:20:00',7.43),('8902','2013-06-13','12:25:00',7.49),('8902','2013-06-13','12:30:00',7.48),('8902','2013-06-13','12:35:00',7.5),('8902','2013-06-13','12:40:00',7.52),('8902','2013-06-13','12:45:00',7.62),('8902','2013-06-13','12:50:00',7.57),('8902','2013-06-13','12:55:00',7.55),('8902','2013-06-13','13:00:00',7.55),('8902','2013-06-13','13:05:00',7.65),('8902','2013-06-13','13:10:00',7.66),('8902','2013-06-13','13:15:00',4.78),('8902','2013-06-13','13:20:00',7.88),('8902','2013-06-13','13:25:00',8.09),('8902','2013-06-13','13:30:00',7.92),('8902','2013-06-13','13:35:00',7.75),('8902','2013-06-13','13:40:00',7.76),('8902','2013-06-13','13:45:00',7.9),('8902','2013-06-13','13:50:00',7.94),('8902','2013-06-13','13:55:00',7.91),('8902','2013-06-13','14:00:00',7.86),('8902','2013-06-13','14:05:00',7.87),('8902','2013-06-13','14:10:00',7.92),('8902','2013-06-13','14:15:00',7.82),('8902','2013-06-13','14:20:00',7.75),('8902','2013-06-13','14:25:00',7.74),('8902','2013-06-13','14:30:00',7.8),('8902','2013-06-13','14:35:00',7.66),('8902','2013-06-13','14:40:00',7.59),('8902','2013-06-13','14:45:00',7.55),('8902','2013-06-13','14:50:00',7.4),('8902','2013-06-13','14:55:00',7.4),('8902','2013-06-13','15:00:00',7.36),('8902','2013-06-13','15:05:00',7.32),('8902','2013-06-13','15:10:00',7.25),('8902','2013-06-13','15:15:00',7.18),('8902','2013-06-13','15:20:00',7.15),('8902','2013-06-13','15:25:00',7.06),('8902','2013-06-13','15:30:00',7),('8902','2013-06-13','15:35:00',6.92),('8902','2013-06-13','15:40:00',6.84),('8902','2013-06-13','15:45:00',6.76),('8902','2013-06-13','15:50:00',6.69),('8902','2013-06-13','15:55:00',6.6),('8902','2013-06-13','16:00:00',6.54),('8902','2013-06-13','16:05:00',6.45),('8902','2013-06-13','16:10:00',6.33),('8902','2013-06-13','16:15:00',6.19),('8902','2013-06-13','16:20:00',6.11),('8902','2013-06-13','16:25:00',6.01),('8902','2013-06-13','16:30:00',5.83),('8902','2013-06-13','16:35:00',5.64),('8902','2013-06-13','16:40:00',5.47),('8902','2013-06-13','16:45:00',5.44),('8902','2013-06-13','16:50:00',5.31),('8902','2013-06-13','16:55:00',5.07),('8902','2013-06-13','17:00:00',5.07),('8902','2013-06-13','17:05:00',4.79),('8902','2013-06-13','17:10:00',4.71),('8902','2013-06-13','17:15:00',4.68),('8902','2013-06-13','17:20:00',4.47),('8902','2013-06-13','17:25:00',4.3),('8902','2013-06-13','17:30:00',4.11),('8902','2013-06-13','17:35:00',4.03),('8902','2013-06-13','17:40:00',3.91),('8902','2013-06-13','17:45:00',3.77),('8902','2013-06-13','17:50:00',3.61),('8902','2013-06-13','17:55:00',3.33),('8902','2013-06-13','18:00:00',3.26),('8902','2013-06-13','18:05:00',3.15),('8902','2013-06-13','18:10:00',2.93),('8902','2013-06-13','18:15:00',2.82),('8902','2013-06-13','18:20:00',2.61),('8902','2013-06-13','18:25:00',2.46),('8902','2013-06-13','18:30:00',2.29),('8902','2013-06-13','18:35:00',2.09),('8902','2013-06-13','18:40:00',1.94),('8902','2013-06-13','18:45:00',1.79),('8902','2013-06-13','18:50:00',1.64),('8902','2013-06-13','18:55:00',1.43),('8902','2013-06-13','19:00:00',1.31),('8902','2013-06-13','19:05:00',1.15),('8902','2013-06-12','07:20:00',1.05),('8902','2013-06-12','07:25:00',1.19),('8902','2013-06-12','07:30:00',1.34),('8902','2013-06-12','07:35:00',1.5),('8902','2013-06-12','07:40:00',1.65),('8902','2013-06-12','07:45:00',1.81),('8902','2013-06-12','07:50:00',1.97),('8902','2013-06-12','07:55:00',2.13),('8902','2013-06-12','08:00:00',2.29),('8902','2013-06-12','08:05:00',2.47),('8902','2013-06-12','08:10:00',2.63),('8902','2013-06-12','08:15:00',2.78),('8902','2013-06-12','08:20:00',2.93),('8902','2013-06-12','08:25:00',3.08),('8902','2013-06-12','08:30:00',3.25),('8902','2013-06-12','08:35:00',3.42),('8902','2013-06-12','08:40:00',3.57),('8902','2013-06-12','08:45:00',3.74),('8902','2013-06-12','08:50:00',3.89),('8902','2013-06-12','08:55:00',4.04),('8902','2013-06-12','09:00:00',4.17),('8902','2013-06-12','09:05:00',4.34),('8902','2013-06-12','09:10:00',4.48),('8902','2013-06-12','09:15:00',4.65),('8902','2013-06-12','09:20:00',4.79),('8902','2013-06-12','09:25:00',4.95),('8902','2013-06-12','09:30:00',5.09),('8902','2013-06-12','09:35:00',5.2),('8902','2013-06-12','09:40:00',5.32),('8902','2013-06-12','09:45:00',5.44),('8902','2013-06-12','09:50:00',5.55),('8902','2013-06-12','09:55:00',5.68),('8902','2013-06-12','10:00:00',5.82),('8902','2013-06-12','10:05:00',5.95),('8902','2013-06-12','10:10:00',6.02),('8902','2013-06-12','10:15:00',6.11),('8902','2013-06-12','10:20:00',6.2),('8902','2013-06-12','10:25:00',6.3),('8902','2013-06-12','10:30:00',6.43),('8902','2013-06-12','10:35:00',6.5),('8902','2013-06-12','10:40:00',6.58),('8902','2013-06-12','10:45:00',6.71),('8902','2013-06-12','10:50:00',6.8),('8902','2013-06-12','10:55:00',6.87),('8902','2013-06-12','11:00:00',6.93),('8902','2013-06-12','11:05:00',7.03),('8902','2013-06-12','11:10:00',7.12),('8902','2013-06-12','11:15:00',7.16),('8902','2013-06-12','11:20:00',7.23),('8902','2013-06-12','11:25:00',7.28),('8902','2013-06-12','11:30:00',7.33),('8902','2013-06-12','11:35:00',7.45),('8902','2013-06-12','11:40:00',7.51),('8902','2013-06-12','11:45:00',7.58),('8902','2013-06-12','11:50:00',7.6),('8902','2013-06-12','11:55:00',7.64),('8902','2013-06-12','12:00:00',7.71),('8902','2013-06-12','12:05:00',7.8),('8902','2013-06-12','12:10:00',7.77),('8902','2013-06-12','12:15:00',7.78),('8902','2013-06-12','12:20:00',7.82),('8902','2013-06-12','12:25:00',7.91),('8902','2013-06-12','12:30:00',7.94),('8902','2013-06-12','12:35:00',7.93),('8902','2013-06-12','12:40:00',7.97),('8902','2013-06-12','12:45:00',7.98),('8902','2013-06-12','12:50:00',7.99),('8902','2013-06-12','12:55:00',7.99),('8902','2013-06-12','13:00:00',8.01),('8902','2013-06-12','13:05:00',8.02),('8902','2013-06-12','13:10:00',7.97),('8902','2013-06-12','13:15:00',8),('8902','2013-06-12','13:20:00',7.61),('8902','2013-06-12','13:25:00',7.98),('8902','2013-06-12','13:30:00',7.95),('8902','2013-06-12','13:35:00',7.97),('8902','2013-06-12','13:40:00',8),('8902','2013-06-12','13:45:00',7.99),('8902','2013-06-12','13:50:00',7.95),('8902','2013-06-12','13:55:00',7.92),('8902','2013-06-12','14:00:00',7.89),('8902','2013-06-12','14:05:00',7.89),('8902','2013-06-12','14:10:00',7.84),('8902','2013-06-12','14:15:00',7.85),('8902','2013-06-12','14:20:00',7.76),('8902','2013-06-12','14:25:00',7.86),('8902','2013-06-12','14:30:00',6.3),('8902','2013-06-12','14:35:00',6.78),('8902','2013-06-12','14:40:00',7.81),('8902','2013-06-12','14:45:00',7.67),('8902','2013-06-12','14:50:00',7.48),('8902','2013-06-12','14:55:00',7.41),('8902','2013-06-12','15:00:00',7.38),('8902','2013-06-12','15:05:00',7.31),('8902','2013-06-12','15:10:00',7.25),('8902','2013-06-12','15:15:00',7.16),('8902','2013-06-12','15:20:00',7.09),('8902','2013-06-12','15:25:00',7.02),('8902','2013-06-12','15:30:00',6.94),('8902','2013-06-12','15:35:00',6.92),('8902','2013-06-12','15:40:00',6.88),('8902','2013-06-12','15:45:00',6.79),('8902','2013-06-12','15:50:00',6.69),('8902','2013-06-12','15:55:00',6.62),('8902','2013-06-12','16:00:00',6.5),('8902','2013-06-12','16:05:00',6.39),('8902','2013-06-12','16:10:00',6.28),('8902','2013-06-12','16:15:00',6.22),('8902','2013-06-12','16:20:00',6.08),('8902','2013-06-12','16:25:00',5.95),('8902','2013-06-12','16:30:00',5.83),('8902','2013-06-12','16:35:00',5.63),('8902','2013-06-12','16:40:00',5.48),('8902','2013-06-12','16:45:00',5.45),('8902','2013-06-12','16:50:00',5.24),('8902','2013-06-12','16:55:00',4.99),('8902','2013-06-12','17:00:00',5),('8902','2013-06-12','17:05:00',4.86),('8902','2013-06-12','17:10:00',4.74),('8902','2013-06-12','17:15:00',4.64),('8902','2013-06-12','17:20:00',4.48),('8902','2013-06-12','17:25:00',4.31),('8902','2013-06-12','17:30:00',4.22),('8902','2013-06-12','17:35:00',4.07),('8902','2013-06-12','17:40:00',3.85),('8902','2013-06-12','17:45:00',3.76),('8902','2013-06-12','17:50:00',3.61),('8902','2013-06-12','17:55:00',3.32),('8902','2013-06-12','18:00:00',3.22),('8902','2013-06-12','18:05:00',3.07),('8902','2013-06-12','18:10:00',2.85),('8902','2013-06-12','18:15:00',2.76),('8902','2013-06-12','18:20:00',2.58),('8902','2013-06-12','18:25:00',2.44),('8902','2013-06-12','18:30:00',2.26),('8902','2013-06-12','18:35:00',2.06),('8902','2013-06-12','18:40:00',1.87),('8902','2013-06-12','18:45:00',1.72),('8902','2013-06-12','18:50:00',1.59),('8902','2013-06-12','18:55:00',1.4),('8902','2013-06-12','19:00:00',1.26),('8902','2013-06-12','19:05:00',1.1),('8902','2013-06-11','07:20:00',1.11),('8902','2013-06-11','07:25:00',1.26),('8902','2013-06-11','07:30:00',1.4),('8902','2013-06-11','07:35:00',1.54),('8902','2013-06-11','07:40:00',1.69),('8902','2013-06-11','07:45:00',1.84),('8902','2013-06-11','07:50:00',1.99),('8902','2013-06-11','07:55:00',2.16),('8902','2013-06-11','08:00:00',2.34),('8902','2013-06-11','08:05:00',2.51),('8902','2013-06-11','08:10:00',2.68),('8902','2013-06-11','08:15:00',2.84),('8902','2013-06-11','08:20:00',3),('8902','2013-06-11','08:25:00',3.17),('8902','2013-06-11','08:30:00',3.33),('8902','2013-06-11','08:35:00',3.5),('8902','2013-06-11','08:40:00',3.66),('8902','2013-06-11','08:45:00',3.83),('8902','2013-06-11','08:50:00',3.98),('8902','2013-06-11','08:55:00',4.13),('8902','2013-06-11','09:00:00',4.27),('8902','2013-06-11','09:05:00',4.44),('8902','2013-06-11','09:10:00',4.59),('8902','2013-06-11','09:15:00',4.73),('8902','2013-06-11','09:20:00',4.88),('8902','2013-06-11','09:25:00',5.01),('8902','2013-06-11','09:30:00',5.13),('8902','2013-06-11','09:35:00',5.26),('8902','2013-06-11','09:40:00',5.39),('8902','2013-06-11','09:45:00',5.52),('8902','2013-06-11','09:50:00',5.65),('8902','2013-06-11','09:55:00',5.77),('8902','2013-06-11','10:00:00',5.84),('8902','2013-06-11','10:05:00',5.95),('8902','2013-06-11','10:10:00',6.06),('8902','2013-06-11','10:15:00',6.15),('8902','2013-06-11','10:20:00',6.28),('8902','2013-06-11','10:25:00',6.38),('8902','2013-06-11','10:30:00',6.44),('8902','2013-06-11','10:35:00',6.47),('8902','2013-06-11','10:40:00',6.59),('8902','2013-06-11','10:45:00',6.72),('8902','2013-06-11','10:50:00',6.84),('8902','2013-06-11','10:55:00',6.97),('8902','2013-06-11','11:00:00',7.12),('8902','2013-06-11','11:05:00',7.15),('8902','2013-06-11','11:10:00',7.23),('8902','2013-06-11','11:15:00',7.31),('8902','2013-06-11','11:20:00',7.35),('8902','2013-06-11','11:25:00',7.4),('8902','2013-06-11','11:30:00',7.46),('8902','2013-06-11','11:35:00',7.49),('8902','2013-06-11','11:40:00',7.58),('8902','2013-06-11','11:45:00',7.57),('8902','2013-06-11','11:50:00',7.63),('8902','2013-06-11','11:55:00',7.8),('8902','2013-06-11','12:00:00',7.78),('8902','2013-06-11','12:05:00',7.9),('8902','2013-06-11','12:10:00',7.83),('8902','2013-06-11','12:15:00',7.91),('8902','2013-06-11','12:20:00',7.98),('8902','2013-06-11','12:25:00',7.8),('8902','2013-06-11','12:30:00',8.53),('8902','2013-06-11','12:35:00',8.43),('8902','2013-06-11','12:40:00',2.77),('8902','2013-06-11','12:45:00',6.08),('8902','2013-06-11','12:50:00',8.71),('8902','2013-06-11','12:55:00',8.25),('8902','2013-06-11','13:00:00',7.72),('8902','2013-06-11','13:05:00',7.47),('8902','2013-06-11','13:10:00',8.21),('8902','2013-06-11','13:15:00',8.07),('8902','2013-06-11','13:20:00',7.98),('8902','2013-06-11','13:25:00',7.96),('8902','2013-06-11','13:30:00',8.01),('8902','2013-06-11','13:35:00',8.06),('8902','2013-06-11','13:40:00',8.07),('8902','2013-06-11','13:45:00',8.17),('8902','2013-06-11','13:50:00',8.13),('8902','2013-06-11','13:55:00',8.23),('8902','2013-06-11','14:00:00',8.32),('8902','2013-06-11','14:05:00',6.26),('8902','2013-06-11','14:10:00',7.69),('8902','2013-06-11','14:15:00',7.77),('8902','2013-06-11','14:20:00',4.36),('8902','2013-06-11','14:25:00',2.13),('8902','2013-06-11','14:30:00',8.67),('8902','2013-06-11','14:35:00',8.21),('8902','2013-06-11','14:40:00',7.78),('8902','2013-06-11','14:45:00',8),('8902','2013-06-11','14:50:00',8.15),('8902','2013-06-11','14:55:00',8.29),('8902','2013-06-11','15:00:00',8.22),('8902','2013-06-11','15:05:00',7.89),('8902','2013-06-11','15:10:00',7.83),('8902','2013-06-11','15:15:00',6.84),('8902','2013-06-11','15:20:00',7.67),('8902','2013-06-11','15:25:00',7.32),('8902','2013-06-11','15:30:00',7.32),('8902','2013-06-11','15:35:00',7.25),('8902','2013-06-11','15:40:00',7.17),('8902','2013-06-11','15:45:00',7.13),('8902','2013-06-11','15:50:00',6.94),('8902','2013-06-11','15:55:00',6.95),('8902','2013-06-11','16:00:00',6.72),('8902','2013-06-11','16:05:00',6.11),('8902','2013-06-11','16:10:00',6.61),('8902','2013-06-11','16:15:00',6.47),('8902','2013-06-11','16:20:00',6.26),('8902','2013-06-11','16:25:00',6.2),('8902','2013-06-11','16:30:00',6.07),('8902','2013-06-11','16:35:00',5.87),('8902','2013-06-11','16:40:00',5.72),('8902','2013-06-11','16:45:00',4.91),('8902','2013-06-11','16:50:00',5.5),('8902','2013-06-11','16:55:00',5.29),('8902','2013-06-11','17:00:00',5.15),('8902','2013-06-11','17:05:00',5.08),('8902','2013-06-11','17:10:00',4.98),('8902','2013-06-11','17:15:00',4.85),('8902','2013-06-11','17:20:00',4.65),('8902','2013-06-11','17:25:00',4.42),('8902','2013-06-11','17:30:00',4.33),('8902','2013-06-11','17:35:00',4.23),('8902','2013-06-11','17:40:00',4.09),('8902','2013-06-11','17:45:00',3.89),('8902','2013-06-11','17:50:00',2.46),('8902','2013-06-11','17:55:00',1.2),('8902','2013-06-11','18:00:00',1.54),('8902','2013-06-11','18:05:00',3.33),('8902','2013-06-11','18:10:00',3.05),('8902','2013-06-11','18:15:00',2.92),('8902','2013-06-11','18:20:00',2.7),('8902','2013-06-11','18:25:00',2.42),('8902','2013-06-11','18:30:00',2.26),('8902','2013-06-11','18:35:00',2.09),('8902','2013-06-11','18:40:00',1.92),('8902','2013-06-11','18:45:00',1.75),('8902','2013-06-11','18:50:00',1.61),('8902','2013-06-11','18:55:00',1.45),('8902','2013-06-11','19:00:00',1.33),('8902','2013-06-11','19:05:00',1.17),('8902','2013-06-10','07:20:00',1.21),('8902','2013-06-10','07:25:00',1.52),('8902','2013-06-10','07:30:00',1.34),('8902','2013-06-10','07:35:00',1.53),('8902','2013-06-10','07:40:00',1.67),('8902','2013-06-10','07:45:00',1.64),('8902','2013-06-10','07:50:00',1.73),('8902','2013-06-10','07:55:00',1.12),('8902','2013-06-10','08:00:00',1.73),('8902','2013-06-10','08:05:00',2.84),('8902','2013-06-10','08:10:00',3.03),('8902','2013-06-10','08:15:00',3.36),('8902','2013-06-10','08:20:00',1.66),('8902','2013-06-10','08:25:00',1.28),('8902','2013-06-10','08:30:00',2.28),('8902','2013-06-10','08:40:00',2.44),('8902','2013-06-10','08:45:00',3.49),('8902','2013-06-10','08:50:00',4.42),('8902','2013-06-10','08:55:00',4.7),('8902','2013-06-10','09:00:00',3.37),('8902','2013-06-10','09:05:00',2.59),('8902','2013-06-10','09:10:00',2.78),('8902','2013-06-10','09:15:00',4.2),('8902','2013-06-10','09:20:00',5.18),('8902','2013-06-10','09:25:00',5.65),('8902','2013-06-10','09:30:00',5.05),('8902','2013-06-10','09:35:00',5.67),('8902','2013-06-10','09:40:00',1.86),('8902','2013-06-10','09:45:00',1.36),('8902','2013-06-10','09:50:00',3.25),('8902','2013-06-10','09:55:00',6.34),('8902','2013-06-10','10:00:00',6.4),('8902','2013-06-10','10:05:00',5.59),('8902','2013-06-10','10:10:00',6.07),('8902','2013-06-10','10:15:00',6.35),('8902','2013-06-10','10:20:00',6.6),('8902','2013-06-10','10:25:00',6.7),('8902','2013-06-10','10:30:00',5.41),('8902','2013-06-10','10:35:00',6.83),('8902','2013-06-10','10:40:00',6.94),('8902','2013-06-10','10:45:00',6.32),('8902','2013-06-10','10:50:00',7.11),('8902','2013-06-10','10:55:00',5),('8902','2013-06-10','11:00:00',4.09),('8902','2013-06-10','11:05:00',7.8),('8902','2013-06-10','11:10:00',3.74),('8902','2013-06-10','11:15:00',5.22),('8902','2013-06-10','11:20:00',7.67),('8902','2013-06-10','11:25:00',7.66),('8902','2013-06-10','11:30:00',7.76),('8902','2013-06-10','11:35:00',7.6),('8902','2013-06-10','11:40:00',7.68),('8902','2013-06-10','11:45:00',7.73),('8902','2013-06-10','11:50:00',7.87),('8902','2013-06-10','11:55:00',7.93),('8902','2013-06-10','12:00:00',8.06),('8902','2013-06-10','12:05:00',8.26),('8902','2013-06-10','12:10:00',8.11),('8902','2013-06-10','12:15:00',8.02),('8902','2013-06-10','12:20:00',8.1),('8902','2013-06-10','12:25:00',8.12),('8902','2013-06-10','12:30:00',8.13),('8902','2013-06-10','12:35:00',8.11),('8902','2013-06-10','12:40:00',8.2),('8902','2013-06-10','12:45:00',8.24),('8902','2013-06-10','12:50:00',8.31),('8902','2013-06-10','12:55:00',8.38),('8902','2013-06-10','13:00:00',8.32),('8902','2013-06-10','13:05:00',8.35),('8902','2013-06-10','13:10:00',8.35),('8902','2013-06-10','13:15:00',7.84),('8902','2013-06-10','13:20:00',8.39),('8902','2013-06-10','13:25:00',8.35),('8902','2013-06-10','13:30:00',8.37),('8902','2013-06-10','13:35:00',8.41),('8902','2013-06-10','13:40:00',8.47),('8902','2013-06-10','13:45:00',8.43),('8902','2013-06-10','13:50:00',6.18),('8902','2013-06-10','13:55:00',8.13),('8902','2013-06-10','14:00:00',8.49),('8902','2013-06-10','14:05:00',8.38),('8902','2013-06-10','14:10:00',8.24),('8902','2013-06-10','14:15:00',8.17),('8902','2013-06-10','14:20:00',8.11),('8902','2013-06-10','14:25:00',8.13),('8902','2013-06-10','14:30:00',8.12),('8902','2013-06-10','14:35:00',8.07),('8902','2013-06-10','14:40:00',7.98),('8902','2013-06-10','14:45:00',7.93),('8902','2013-06-10','14:50:00',7.82),('8902','2013-06-10','14:55:00',7.77),('8902','2013-06-10','15:00:00',7.77),('8902','2013-06-10','15:05:00',7.72),('8902','2013-06-10','15:10:00',7.65),('8902','2013-06-10','15:15:00',7.55),('8902','2013-06-10','15:20:00',7.54),('8902','2013-06-10','15:25:00',7.4),('8902','2013-06-10','15:30:00',7.35),('8902','2013-06-10','15:35:00',7.38),('8902','2013-06-10','15:40:00',7.31),('8902','2013-06-10','15:45:00',7.2),('8902','2013-06-10','15:50:00',7.06),('8902','2013-06-10','15:55:00',6.88),('8902','2013-06-10','16:00:00',6.94),('8902','2013-06-10','16:05:00',6.83),('8902','2013-06-10','16:10:00',6.72),('8902','2013-06-10','16:15:00',6.59),('8902','2013-06-10','16:20:00',6.45),('8902','2013-06-10','16:25:00',6.29),('8902','2013-06-10','16:30:00',6.19),('8902','2013-06-10','16:35:00',6.01),('8902','2013-06-10','16:40:00',6.1),('8902','2013-06-10','16:45:00',6.33),('8902','2013-06-10','16:50:00',6.36),('8902','2013-06-10','16:55:00',6.03),('8902','2013-06-10','17:00:00',5.72),('8902','2013-06-10','17:05:00',4.32),('8902','2013-06-10','17:10:00',1.86),('8902','2013-06-10','17:15:00',1.25),('8902','2013-06-10','19:30:00',1.06),('8902','2014-04-02','08:10:00',1.02),('8902','2014-04-02','08:15:00',1.07),('8902','2014-04-02','08:20:00',1.13),('8902','2014-04-02','08:25:00',1.19),('8902','2014-04-02','08:30:00',1.28),('8902','2014-04-02','08:35:00',1.36),('8902','2014-04-02','08:40:00',1.49),('8902','2014-04-02','08:45:00',1.72),('8902','2014-04-02','08:50:00',1.78),('8902','2014-04-02','08:55:00',2.02),('8902','2014-04-02','09:00:00',2.23),('8902','2014-04-02','09:05:00',2.44),('8902','2014-04-02','09:10:00',2.39),('8902','2014-04-02','09:15:00',2.21),('8902','2014-04-02','09:20:00',2.22),('8902','2014-04-02','09:25:00',2.38),('8902','2014-04-02','09:30:00',2.74),('8902','2014-04-02','09:35:00',3.31),('8902','2014-04-02','09:40:00',3.56),('8902','2014-04-02','09:45:00',3.48),('8902','2014-04-02','09:50:00',3.32),('8902','2014-04-02','09:55:00',3.41),('8902','2014-04-02','10:00:00',4.06),('8902','2014-04-02','10:05:00',4.77),('8902','2014-04-02','10:10:00',5.11),('8902','2014-04-02','10:15:00',5.78),('8902','2014-04-02','10:20:00',6),('8902','2014-04-02','10:25:00',5.34),('8902','2014-04-02','10:30:00',4.94),('8902','2014-04-02','10:35:00',5.42),('8902','2014-04-02','10:40:00',4.39),('8902','2014-04-02','10:45:00',4.6),('8902','2014-04-02','10:50:00',3.89),('8902','2014-04-02','10:55:00',4.09),('8902','2014-04-02','11:00:00',3.9),('8902','2014-04-02','11:05:00',3.21),('8902','2014-04-02','11:10:00',3.03),('8902','2014-04-02','11:15:00',2.81),('8902','2014-04-02','11:20:00',2.68),('8902','2014-04-02','11:25:00',2.5),('8902','2014-04-02','11:30:00',2.49),('8902','2014-04-02','11:35:00',2.66),('8902','2014-04-02','11:40:00',2.94),('8902','2014-04-02','11:45:00',3.38),('8902','2014-04-02','11:50:00',4.16),('8902','2014-04-02','11:55:00',4.66),('8902','2014-04-02','12:00:00',4.39),('8902','2014-04-02','12:05:00',4.39),('8902','2014-04-02','12:10:00',4.24),('8902','2014-04-02','12:15:00',4.14),('8902','2014-04-02','12:20:00',4.6),('8902','2014-04-02','12:25:00',5.46),('8902','2014-04-02','12:30:00',7.53),('8902','2014-04-02','12:35:00',7.16),('8902','2014-04-02','12:40:00',8.15),('8902','2014-04-02','12:45:00',4.67),('8902','2014-04-02','12:50:00',5.16),('8902','2014-04-02','12:55:00',5.21),('8902','2014-04-02','13:00:00',5.06),('8902','2014-04-02','13:05:00',6.72),('8902','2014-04-02','13:10:00',4.47),('8902','2014-04-02','13:15:00',9.03),('8902','2014-04-02','13:20:00',6.07),('8902','2014-04-02','13:25:00',5.46),('8902','2014-04-02','13:30:00',5.5),('8902','2014-04-02','13:35:00',8.69),('8902','2014-04-02','13:40:00',8.03),('8902','2014-04-02','13:45:00',4.62),('8902','2014-04-02','13:50:00',4.03),('8902','2014-04-02','13:55:00',5.03),('8902','2014-04-02','14:00:00',7.42),('8902','2014-04-02','14:05:00',7.04),('8902','2014-04-02','14:10:00',5.29),('8902','2014-04-02','14:15:00',7.02),('8902','2014-04-02','14:20:00',7.58),('8902','2014-04-02','14:25:00',7.64),('8902','2014-04-02','14:30:00',7.71),('8902','2014-04-02','14:35:00',7.92),('8902','2014-04-02','14:40:00',7.72),('8902','2014-04-02','14:45:00',7.51),('8902','2014-04-02','14:50:00',7.36),('8902','2014-04-02','14:55:00',7.24),('8902','2014-04-02','15:00:00',7.18),('8902','2014-04-02','15:05:00',7.09),('8902','2014-04-02','15:10:00',7.08),('8902','2014-04-02','15:15:00',7.05),('8902','2014-04-02','15:20:00',7.04),('8902','2014-04-02','15:25:00',7.02),('8902','2014-04-02','15:30:00',6.93),('8902','2014-04-02','15:35:00',6.81),('8902','2014-04-02','15:40:00',6.72),('8902','2014-04-02','15:45:00',6.72),('8902','2014-04-02','15:50:00',6.63),('8902','2014-04-02','15:55:00',6.58),('8902','2014-04-02','16:00:00',6.52),('8902','2014-04-02','16:05:00',6.39),('8902','2014-04-02','16:10:00',6.37),('8902','2014-04-02','16:15:00',6.15),('8902','2014-04-02','16:20:00',6.07),('8902','2014-04-02','16:25:00',5.81),('8902','2014-04-02','16:30:00',5.71),('8902','2014-04-02','16:35:00',5.6),('8902','2014-04-02','16:40:00',5.46),('8902','2014-04-02','16:45:00',5.11),('8902','2014-04-02','16:50:00',3.96),('8902','2014-04-02','16:55:00',3.23),('8902','2014-04-02','17:00:00',2.27),('8902','2014-04-02','17:05:00',2.11),('8902','2014-04-02','17:10:00',1.85),('8902','2014-04-02','17:15:00',1.72),('8902','2014-04-02','17:20:00',1.74),('8902','2014-04-02','17:25:00',1.88),('8902','2014-04-02','17:30:00',1.91),('8902','2014-04-02','17:35:00',1.17),('8902','2014-04-02','17:45:00',1.95),('8902','2014-04-02','17:50:00',3.04),('8902','2014-04-02','17:55:00',2.64),('8902','2014-04-02','18:00:00',2.42),('8902','2014-04-02','18:05:00',2.18),('8902','2014-04-02','18:10:00',1.98),('8902','2014-04-02','18:15:00',1.76),('8902','2014-04-02','18:20:00',1.54),('8902','2014-04-02','18:25:00',1.2),('8902','2013-06-09','07:10:00',1.06),('8902','2013-06-09','07:20:00',1.17),('8902','2013-06-09','07:25:00',1.17),('8902','2013-06-09','07:30:00',1.66),('8902','2013-06-09','07:35:00',2.41),('8902','2013-06-09','07:40:00',1.87),('8902','2013-06-09','07:45:00',1.37),('8902','2013-06-09','07:50:00',1.36),('8902','2013-06-09','07:55:00',1.29),('8902','2013-06-09','08:00:00',1.96),('8902','2013-06-09','08:05:00',2.37),('8902','2013-06-09','08:10:00',3.25),('8902','2013-06-09','08:15:00',2.99),('8902','2013-06-09','08:20:00',3.54),('8902','2013-06-09','08:25:00',2.44),('8902','2013-06-09','08:30:00',2.26),('8902','2013-06-09','08:35:00',1.95),('8902','2013-06-09','08:40:00',1.73),('8902','2013-06-09','08:45:00',1.79),('8902','2013-06-09','08:50:00',2.07),('8902','2013-06-09','08:55:00',1.85),('8902','2013-06-09','09:00:00',2.31),('8902','2013-06-09','09:05:00',2.15),('8902','2013-06-09','09:10:00',3.49),('8902','2013-06-09','09:15:00',1.77),('8902','2013-06-09','09:20:00',3.15),('8902','2013-06-09','09:25:00',2.78),('8902','2013-06-09','09:30:00',2.15),('8902','2013-06-09','09:35:00',6.07),('8902','2013-06-09','09:40:00',4.1),('8902','2013-06-09','09:45:00',6.04),('8902','2013-06-09','09:50:00',4.19),('8902','2013-06-09','09:55:00',3.44),('8902','2013-06-09','10:00:00',4.54),('8902','2013-06-09','10:05:00',5.3),('8902','2013-06-09','10:10:00',5.84),('8902','2013-06-09','10:15:00',6.21),('8902','2013-06-09','10:20:00',5.51),('8902','2013-06-09','10:25:00',5.74),('8902','2013-06-09','10:30:00',3.35),('8902','2013-06-09','10:35:00',3.34),('8902','2013-06-09','10:40:00',2.82),('8902','2013-06-09','10:45:00',2.39),('8902','2013-06-09','10:50:00',3.55),('8902','2013-06-09','10:55:00',4.59),('8902','2013-06-09','11:00:00',5.42),('8902','2013-06-09','11:05:00',3.53),('8902','2013-06-09','11:10:00',4.09),('8902','2013-06-09','11:15:00',7.3),('8902','2013-06-09','11:20:00',5.29),('8902','2013-06-09','11:25:00',8.11),('8902','2013-06-09','11:30:00',7.98),('8902','2013-06-09','11:35:00',8.66),('8902','2013-06-09','11:40:00',6.01),('8902','2013-06-09','11:45:00',7.55),('8902','2013-06-09','11:50:00',4.11),('8902','2013-06-09','11:55:00',4.48),('8902','2013-06-09','12:00:00',9.05),('8902','2013-06-09','12:05:00',5.06),('8902','2013-06-09','12:10:00',8.15),('8902','2013-06-09','12:15:00',8.51),('8902','2013-06-09','12:20:00',8.22),('8902','2013-06-09','12:25:00',8.23),('8902','2013-06-09','12:30:00',7.83),('8902','2013-06-09','12:35:00',6.56),('8902','2013-06-09','12:40:00',6.05),('8902','2013-06-09','12:45:00',6.85),('8902','2013-06-09','12:50:00',6.31),('8902','2013-06-09','12:55:00',3.93),('8902','2013-06-09','13:00:00',4.54),('8902','2013-06-09','13:05:00',9.14),('8902','2013-06-09','13:10:00',6.1),('8902','2013-06-09','13:15:00',5.68),('8902','2013-06-09','13:20:00',6.49),('8902','2013-06-09','13:25:00',4.99),('8902','2013-06-09','13:30:00',5.47),('8902','2013-06-09','13:35:00',8.18),('8902','2013-06-09','13:40:00',6.9),('8902','2013-06-09','13:45:00',5.36),('8902','2013-06-09','13:50:00',4.87),('8902','2013-06-09','13:55:00',6.16),('8902','2013-06-09','14:00:00',9.07),('8902','2013-06-09','14:05:00',8.51),('8902','2013-06-09','14:10:00',8.52),('8902','2013-06-09','14:15:00',8.2),('8902','2013-06-09','14:20:00',8.16),('8902','2013-06-09','14:25:00',8.27),('8902','2013-06-09','14:30:00',8.12),('8902','2013-06-09','14:35:00',8.11),('8902','2013-06-09','14:40:00',7.01),('8902','2013-06-09','14:45:00',8.2),('8902','2013-06-09','14:50:00',7.97),('8902','2013-06-09','14:55:00',7.89),('8902','2013-06-09','15:00:00',7.81),('8902','2013-06-09','15:05:00',7.73),('8902','2013-06-09','15:10:00',7.63),('8902','2013-06-09','15:15:00',7.6),('8902','2013-06-09','15:20:00',7.58),('8902','2013-06-09','15:25:00',7.49),('8902','2013-06-09','15:30:00',7.47),('8902','2013-06-09','15:35:00',7.41),('8902','2013-06-09','15:40:00',7.35),('8902','2013-06-09','15:45:00',7.26),('8902','2013-06-09','15:50:00',7.13),('8902','2013-06-09','15:55:00',7.05),('8902','2013-06-09','16:00:00',6.92),('8902','2013-06-09','16:05:00',6.82),('8902','2013-06-09','16:10:00',6.73),('8902','2013-06-09','16:15:00',6.63),('8902','2013-06-09','16:20:00',6.48),('8902','2013-06-09','16:25:00',6.38),('8902','2013-06-09','16:30:00',6.26),('8902','2013-06-09','16:35:00',6.07),('8902','2013-06-09','16:40:00',5.96),('8902','2013-06-09','16:45:00',5.89),('8902','2013-06-09','16:50:00',5.69),('8902','2013-06-09','16:55:00',5.54),('8902','2013-06-09','17:00:00',5.45),('8902','2013-06-09','17:05:00',5.33),('8902','2013-06-09','17:10:00',5.2),('8902','2013-06-09','17:15:00',5.07),('8902','2013-06-09','17:20:00',4.89),('8902','2013-06-09','17:25:00',4.7),('8902','2013-06-09','17:30:00',4.56),('8902','2013-06-09','17:35:00',4.43),('8902','2013-06-09','17:40:00',4.23),('8902','2013-06-09','17:45:00',4.08),('8902','2013-06-09','17:50:00',3.87),('8902','2013-06-09','17:55:00',3.6),('8902','2013-06-09','18:00:00',3.56),('8902','2013-06-09','18:05:00',3.35),('8902','2013-06-09','18:10:00',3.13),('8902','2013-06-09','18:15:00',3),('8902','2013-06-09','18:20:00',2.82),('8902','2013-06-09','18:25:00',2.63),('8902','2013-06-09','18:30:00',2.43),('8902','2013-06-09','18:35:00',2.24),('8902','2013-06-09','18:40:00',2.05),('8902','2013-06-09','18:45:00',1.87),('8902','2013-06-09','18:50:00',1.71),('8902','2013-06-09','18:55:00',1.52),('8902','2013-06-09','19:00:00',1.38),('8902','2013-06-09','19:05:00',1.2),('8902','2013-06-09','19:10:00',1.01),('8902','2013-06-08','07:10:00',1.09),('8902','2013-06-08','07:25:00',1.21),('8902','2013-06-08','07:30:00',1.35),('8902','2013-06-08','07:35:00',2.3),('8902','2013-06-08','07:40:00',1.9),('8902','2013-06-08','07:50:00',1.31),('8902','2013-06-08','07:55:00',2.16),('8902','2013-06-08','08:00:00',2.23),('8902','2013-06-08','08:05:00',2.46),('8902','2013-06-08','08:10:00',2.68),('8902','2013-06-08','08:15:00',2.97),('8902','2013-06-08','08:20:00',2.93),('8902','2013-06-08','08:25:00',3),('8902','2013-06-08','08:30:00',3.14),('8902','2013-06-08','08:35:00',3.26),('8902','2013-06-08','08:40:00',3.45),('8902','2013-06-08','08:45:00',3.55),('8902','2013-06-08','08:50:00',3.72),('8902','2013-06-08','08:55:00',3.91),('8902','2013-06-08','09:00:00',4.06),('8902','2013-06-08','09:05:00',4.18),('8902','2013-06-08','09:10:00',4.39),('8902','2013-06-08','09:15:00',4.52),('8902','2013-06-08','09:20:00',4.59),('8902','2013-06-08','09:25:00',4.75),('8902','2013-06-08','09:30:00',4.83),('8902','2013-06-08','09:35:00',5),('8902','2013-06-08','09:40:00',5.16),('8902','2013-06-08','09:45:00',5.26),('8902','2013-06-08','09:50:00',5.38),('8902','2013-06-08','09:55:00',5.52),('8902','2013-06-08','10:00:00',5.64),('8902','2013-06-08','10:05:00',5.73),('8902','2013-06-08','10:10:00',5.85),('8902','2013-06-08','10:15:00',5.94),('8902','2013-06-08','10:20:00',5.98),('8902','2013-06-08','10:25:00',6.05),('8902','2013-06-08','10:30:00',6.23),('8902','2013-06-08','10:35:00',6.34),('8902','2013-06-08','10:40:00',6.39),('8902','2013-06-08','10:45:00',6.46),('8902','2013-06-08','10:50:00',6.55),('8902','2013-06-08','10:55:00',6.66),('8902','2013-06-08','11:00:00',6.73),('8902','2013-06-08','11:05:00',6.77),('8902','2013-06-08','11:10:00',6.74),('8902','2013-06-08','11:15:00',6.85),('8902','2013-06-08','11:20:00',7.03),('8902','2013-06-08','11:25:00',6.99),('8902','2013-06-08','11:30:00',7.06),('8902','2013-06-08','11:35:00',7.06),('8902','2013-06-08','11:40:00',7.1),('8902','2013-06-08','11:45:00',7.28),('8902','2013-06-08','11:50:00',7.39),('8902','2013-06-08','11:55:00',7.36),('8902','2013-06-08','12:00:00',7.38),('8902','2013-06-08','12:05:00',7.46),('8902','2013-06-08','12:10:00',7.24),('8902','2013-06-08','12:15:00',7.22),('8902','2013-06-08','12:20:00',7.52),('8902','2013-06-08','12:25:00',7.48),('8902','2013-06-08','12:30:00',7.5),('8902','2013-06-08','12:35:00',7.55),('8902','2013-06-08','12:40:00',7.7),('8902','2013-06-08','12:45:00',7.66),('8902','2013-06-08','12:50:00',7.87),('8902','2013-06-08','12:55:00',7.53),('8902','2013-06-08','13:00:00',7.3),('8902','2013-06-08','13:05:00',8.24),('8902','2013-06-08','13:10:00',5.96),('8902','2013-06-08','13:15:00',4.22),('8902','2013-06-08','13:20:00',7.96),('8902','2013-06-08','13:25:00',7.6),('8902','2013-06-08','13:30:00',8.01),('8902','2013-06-08','13:35:00',8.05),('8902','2013-06-08','13:40:00',8.26),('8902','2013-06-08','13:45:00',8.34),('8902','2013-06-08','13:50:00',8.68),('8902','2013-06-08','13:55:00',8.97),('8902','2013-06-08','14:00:00',5.76),('8902','2013-06-08','14:05:00',8.47),('8902','2013-06-08','14:10:00',8.48),('8902','2013-06-08','14:15:00',5.7),('8902','2013-06-08','14:20:00',3.92),('8902','2013-06-08','14:25:00',2.25),('8902','2013-06-08','14:30:00',2.76),('8902','2013-06-08','14:35:00',6.96),('8902','2013-06-08','14:40:00',6.25),('8902','2013-06-08','14:45:00',7.59),('8902','2013-06-08','14:50:00',7.51),('8902','2013-06-08','14:55:00',7.63),('8902','2013-06-08','15:00:00',7.58),('8902','2013-06-08','15:05:00',7.24),('8902','2013-06-08','15:10:00',7.31),('8902','2013-06-08','15:15:00',7.01),('8902','2013-06-08','15:20:00',7.08),('8902','2013-06-08','15:25:00',7.16),('8902','2013-06-08','15:30:00',6.61),('8902','2013-06-08','15:35:00',6.88),('8902','2013-06-08','15:40:00',5.65),('8902','2013-06-08','15:45:00',5.83),('8902','2013-06-08','15:50:00',6.27),('8902','2013-06-08','15:55:00',6.98),('8902','2013-06-08','16:00:00',5.04),('8902','2013-06-08','16:05:00',6.27),('8902','2013-06-08','16:10:00',5.98),('8902','2013-06-08','16:15:00',3.71),('8902','2013-06-08','16:20:00',2.8),('8902','2013-06-08','16:25:00',4.1),('8902','2013-06-08','16:30:00',2.7),('8902','2013-06-08','16:35:00',1.84),('8902','2013-06-08','16:40:00',1.73),('8902','2013-06-08','16:45:00',1.71),('8902','2013-06-08','16:50:00',1.68),('8902','2013-06-08','16:55:00',1.55),('8902','2013-06-08','17:00:00',1.63),('8902','2013-06-08','17:05:00',1.88),('8902','2013-06-08','17:10:00',1.81),('8902','2013-06-08','17:15:00',1.46),('8902','2013-06-08','17:20:00',1.62),('8902','2013-06-08','17:25:00',1.24),('8902','2013-06-08','17:30:00',1.02),('8902','2013-06-08','17:35:00',1.17),('8902','2013-06-08','17:40:00',1.39),('8902','2013-06-08','17:45:00',1.26),('8902','2013-06-08','17:55:00',1.02),('8902','2013-06-08','18:00:00',1.78),('8902','2013-06-08','18:05:00',1.56),('8902','2013-06-08','18:10:00',1.91),('8902','2013-06-08','18:15:00',1.93),('8902','2013-06-08','18:20:00',2.07),('8902','2013-06-08','18:30:00',1.73),('8902','2013-06-08','18:35:00',1.13),('8902','2013-06-08','18:45:00',1.01),('8902','2013-06-08','18:50:00',1.16),('8902','2013-06-07','07:20:00',1.07),('8902','2013-06-07','07:25:00',1.2),('8902','2013-06-07','07:30:00',1.34),('8902','2013-06-07','07:35:00',1.48),('8902','2013-06-07','07:40:00',1.63),('8902','2013-06-07','07:45:00',1.78),('8902','2013-06-07','07:50:00',1.93),('8902','2013-06-07','07:55:00',2.08),('8902','2013-06-07','08:00:00',2.23),('8902','2013-06-07','08:05:00',2.38),('8902','2013-06-07','08:10:00',2.54),('8902','2013-06-07','08:15:00',2.7),('8902','2013-06-07','08:20:00',2.86),('8902','2013-06-07','08:25:00',3.03),('8902','2013-06-07','08:30:00',3.19),('8902','2013-06-07','08:35:00',3.33),('8902','2013-06-07','08:40:00',3.5),('8902','2013-06-07','08:45:00',3.65),('8902','2013-06-07','08:50:00',3.81),('8902','2013-06-07','08:55:00',3.95),('8902','2013-06-07','09:00:00',4.12),('8902','2013-06-07','09:05:00',4.25),('8902','2013-06-07','09:10:00',4.34),('8902','2013-06-07','09:15:00',4.45),('8902','2013-06-07','09:20:00',4.65),('8902','2013-06-07','09:25:00',4.85),('8902','2013-06-07','09:30:00',4.96),('8902','2013-06-07','09:35:00',5.02),('8902','2013-06-07','09:40:00',5.11),('8902','2013-06-07','09:45:00',5.24),('8902','2013-06-07','09:50:00',5.23),('8902','2013-06-07','09:55:00',5.44),('8902','2013-06-07','10:00:00',5.7),('8902','2013-06-07','10:05:00',5.78),('8902','2013-06-07','10:10:00',4.21),('8902','2013-06-07','10:15:00',5.55),('8902','2013-06-07','10:20:00',6.07),('8902','2013-06-07','10:25:00',6.23),('8902','2013-06-07','10:30:00',6.44),('8902','2013-06-07','10:35:00',6.43),('8902','2013-06-07','10:40:00',6.58),('8902','2013-06-07','10:45:00',6.7),('8902','2013-06-07','10:50:00',6.7),('8902','2013-06-07','10:55:00',2.94),('8902','2013-06-07','11:00:00',3.91),('8902','2013-06-07','11:05:00',2.73),('8902','2013-06-07','11:10:00',7.66),('8902','2013-06-07','11:15:00',6.59),('8902','2013-06-07','11:20:00',7.84),('8902','2013-06-07','11:25:00',7.94),('8902','2013-06-07','11:30:00',7.83),('8902','2013-06-07','11:35:00',7.41),('8902','2013-06-07','11:40:00',7.89),('8902','2013-06-07','11:45:00',7.55),('8902','2013-06-07','11:50:00',7.82),('8902','2013-06-07','11:55:00',8),('8902','2013-06-07','12:00:00',5.07),('8902','2013-06-07','12:05:00',4.17),('8902','2013-06-07','12:10:00',1.78),('8902','2013-06-07','12:15:00',4.63),('8902','2013-06-07','12:20:00',8.17),('8902','2013-06-07','12:25:00',1.85),('8902','2013-06-07','12:30:00',2.75),('8902','2013-06-07','12:35:00',5.72),('8902','2013-06-07','12:40:00',8.37),('8902','2013-06-07','12:45:00',8.32),('8902','2013-06-07','12:50:00',2.32),('8902','2013-06-07','12:55:00',6.54),('8902','2013-06-07','13:00:00',8.54),('8902','2013-06-07','13:05:00',8.47),('8902','2013-06-07','13:10:00',7.91),('8902','2013-06-07','13:15:00',8.47),('8902','2013-06-07','13:20:00',5.62),('8902','2013-06-07','13:25:00',8.51),('8902','2013-06-07','13:30:00',8.54),('8902','2013-06-07','13:35:00',8.38),('8902','2013-06-07','13:40:00',8.3),('8902','2013-06-07','13:45:00',8.22),('8902','2013-06-07','13:50:00',8.15),('8902','2013-06-07','13:55:00',8.15),('8902','2013-06-07','14:00:00',8.04),('8902','2013-06-07','14:05:00',8.04),('8902','2013-06-07','14:10:00',8.05),('8902','2013-06-07','14:15:00',8.06),('8902','2013-06-07','14:20:00',7.97),('8902','2013-06-07','14:25:00',7.93),('8902','2013-06-07','14:30:00',7.9),('8902','2013-06-07','14:35:00',7.82),('8902','2013-06-07','14:40:00',7.84),('8902','2013-06-07','14:45:00',7.83),('8902','2013-06-07','14:50:00',7.82),('8902','2013-06-07','14:55:00',7.76),('8902','2013-06-07','15:00:00',7.73),('8902','2013-06-07','15:05:00',7.42),('8902','2013-06-07','15:10:00',7.01),('8902','2013-06-07','15:15:00',7.19),('8902','2013-06-07','15:20:00',7.53),('8902','2013-06-07','15:25:00',7.1),('8902','2013-06-07','15:30:00',7.1),('8902','2013-06-07','15:35:00',7.53),('8902','2013-06-07','15:40:00',7.29),('8902','2013-06-07','15:45:00',7.48),('8902','2013-06-07','15:50:00',7.36),('8902','2013-06-07','15:55:00',6.94),('8902','2013-06-07','16:00:00',6.93),('8902','2013-06-07','16:05:00',6.83),('8902','2013-06-07','16:10:00',6.68),('8902','2013-06-07','16:15:00',6.74),('8902','2013-06-07','16:20:00',6.63),('8902','2013-06-07','16:25:00',6.33),('8902','2013-06-07','16:30:00',6.01),('8902','2013-06-07','16:35:00',5.81),('8902','2013-06-07','16:40:00',5.76),('8902','2013-06-07','16:45:00',5.66),('8902','2013-06-07','16:50:00',4.8),('8902','2013-06-07','16:55:00',4.77),('8902','2013-06-07','17:00:00',5.24),('8902','2013-06-07','17:05:00',4.41),('8902','2013-06-07','17:10:00',5.38),('8902','2013-06-07','17:15:00',5.36),('8902','2013-06-07','17:20:00',4.96),('8902','2013-06-07','17:25:00',4.62),('8902','2013-06-07','17:30:00',3.34),('8902','2013-06-07','17:35:00',2.31),('8902','2013-06-07','17:40:00',3.58),('8902','2013-06-07','17:45:00',4.09),('8902','2013-06-07','17:50:00',3.57),('8902','2013-06-07','17:55:00',3.68),('8902','2013-06-07','18:00:00',2.99),('8902','2013-06-07','18:05:00',2.81),('8902','2013-06-07','18:10:00',2.22),('8902','2013-06-07','18:15:00',2.21),('8902','2013-06-07','18:20:00',2.21),('8902','2013-06-07','18:25:00',1.79),('8902','2013-06-07','18:30:00',1.23),('8902','2013-06-07','18:35:00',1.07),('8902','2013-06-06','07:20:00',1.04),('8902','2013-06-06','07:25:00',1.19),('8902','2013-06-06','07:30:00',1.34),('8902','2013-06-06','07:35:00',1.5),('8902','2013-06-06','07:40:00',1.66),('8902','2013-06-06','07:45:00',1.83),('8902','2013-06-06','07:50:00',1.99),('8902','2013-06-06','07:55:00',2.16),('8902','2013-06-06','08:00:00',2.33),('8902','2013-06-06','08:05:00',2.51),('8902','2013-06-06','08:10:00',2.68),('8902','2013-06-06','08:15:00',2.84),('8902','2013-06-06','08:20:00',3.02),('8902','2013-06-06','08:25:00',3.2),('8902','2013-06-06','08:30:00',3.36),('8902','2013-06-06','08:35:00',3.53),('8902','2013-06-06','08:40:00',3.7),('8902','2013-06-06','08:45:00',3.88),('8902','2013-06-06','08:50:00',4.03),('8902','2013-06-06','08:55:00',4.2),('8902','2013-06-06','09:00:00',4.35),('8902','2013-06-06','09:05:00',4.49),('8902','2013-06-06','09:10:00',4.63),('8902','2013-06-06','09:15:00',4.79),('8902','2013-06-06','09:20:00',4.94),('8902','2013-06-06','09:25:00',5.09),('8902','2013-06-06','09:30:00',5.24),('8902','2013-06-06','09:35:00',5.36),('8902','2013-06-06','09:40:00',5.51),('8902','2013-06-06','09:45:00',5.68),('8902','2013-06-06','09:50:00',5.79),('8902','2013-06-06','09:55:00',5.9),('8902','2013-06-06','10:00:00',6.01),('8902','2013-06-06','10:05:00',6.11),('8902','2013-06-06','10:10:00',6.21),('8902','2013-06-06','10:15:00',6.33),('8902','2013-06-06','10:20:00',6.44),('8902','2013-06-06','10:25:00',6.55),('8902','2013-06-06','10:30:00',6.64),('8902','2013-06-06','10:35:00',6.72),('8902','2013-06-06','10:40:00',6.84),('8902','2013-06-06','10:45:00',6.92),('8902','2013-06-06','10:50:00',6.99),('8902','2013-06-06','10:55:00',7.05),('8902','2013-06-06','11:00:00',7.13),('8902','2013-06-06','11:05:00',7.23),('8902','2013-06-06','11:10:00',7.33),('8902','2013-06-06','11:15:00',7.36),('8902','2013-06-06','11:20:00',7.39),('8902','2013-06-06','11:25:00',7.45),('8902','2013-06-06','11:30:00',7.56),('8902','2013-06-06','11:35:00',7.62),('8902','2013-06-06','11:40:00',7.67),('8902','2013-06-06','11:45:00',7.69),('8902','2013-06-06','11:50:00',7.75),('8902','2013-06-06','11:55:00',7.8),('8902','2013-06-06','12:00:00',7.83),('8902','2013-06-06','12:05:00',7.87),('8902','2013-06-06','12:10:00',7.94),('8902','2013-06-06','12:15:00',8),('8902','2013-06-06','12:20:00',8.02),('8902','2013-06-06','12:25:00',7.99),('8902','2013-06-06','12:30:00',7.99),('8902','2013-06-06','12:35:00',7.95),('8902','2013-06-06','12:40:00',8.02),('8902','2013-06-06','12:45:00',8.07),('8902','2013-06-06','12:50:00',8.08),('8902','2013-06-06','12:55:00',8.13),('8902','2013-06-06','13:00:00',8.19),('8902','2013-06-06','13:05:00',8.14),('8902','2013-06-06','13:10:00',8.14),('8902','2013-06-06','13:15:00',8.16),('8902','2013-06-06','13:20:00',8.12),('8902','2013-06-06','13:25:00',8.13),('8902','2013-06-06','13:30:00',8.1),('8902','2013-06-06','13:35:00',8.05),('8902','2013-06-06','13:40:00',8.03),('8902','2013-06-06','13:45:00',7.96),('8902','2013-06-06','13:50:00',7.95),('8902','2013-06-06','13:55:00',7.95),('8902','2013-06-06','14:00:00',7.88),('8902','2013-06-06','14:05:00',7.85),('8902','2013-06-06','14:10:00',7.81),('8902','2013-06-06','14:15:00',7.8),('8902','2013-06-06','14:20:00',7.71),('8902','2013-06-06','14:25:00',7.63),('8902','2013-06-06','14:30:00',7.59),('8902','2013-06-06','14:35:00',7.56),('8902','2013-06-06','14:40:00',7.56),('8902','2013-06-06','14:45:00',7.53),('8902','2013-06-06','14:50:00',7.52),('8902','2013-06-06','14:55:00',7.48),('8902','2013-06-06','15:00:00',7.46),('8902','2013-06-06','15:05:00',7.46),('8902','2013-06-06','15:10:00',7.44),('8902','2013-06-06','15:15:00',7.31),('8902','2013-06-06','15:20:00',7.21),('8902','2013-06-06','15:25:00',7.25),('8902','2013-06-06','15:30:00',7.24),('8902','2013-06-06','15:35:00',7.12),('8902','2013-06-06','15:40:00',7.01),('8902','2013-06-06','15:45:00',6.92),('8902','2013-06-06','15:50:00',6.82),('8902','2013-06-06','15:55:00',6.72),('8902','2013-06-06','16:00:00',6.69),('8902','2013-06-06','16:05:00',6.54),('8902','2013-06-06','16:10:00',6.3),('8902','2013-06-06','16:15:00',5.97),('8902','2013-06-06','16:20:00',5.96),('8902','2013-06-06','16:25:00',5.99),('8902','2013-06-06','16:30:00',5.99),('8902','2013-06-06','16:35:00',5.73),('8902','2013-06-06','16:40:00',5.72),('8902','2013-06-06','16:45:00',5.62),('8902','2013-06-06','16:50:00',5.43),('8902','2013-06-06','16:55:00',5.35),('8902','2013-06-06','17:00:00',5.23),('8902','2013-06-06','17:05:00',5.05),('8902','2013-06-06','17:10:00',4.88),('8902','2013-06-06','17:15:00',4.71),('8902','2013-06-06','17:20:00',4.41),('8902','2013-06-06','17:25:00',4.36),('8902','2013-06-06','17:30:00',4.21),('8902','2013-06-06','17:35:00',4.08),('8902','2013-06-06','17:40:00',3.96),('8902','2013-06-06','17:45:00',3.95),('8902','2013-06-06','17:50:00',3.75),('8902','2013-06-06','17:55:00',3.4),('8902','2013-06-06','18:00:00',3.32),('8902','2013-06-06','18:05:00',3.19),('8902','2013-06-06','18:10:00',3.01),('8902','2013-06-06','18:15:00',2.81),('8902','2013-06-06','18:20:00',2.57),('8902','2013-06-06','18:25:00',2.34),('8902','2013-06-06','18:30:00',2.14),('8902','2013-06-06','18:35:00',1.96),('8902','2013-06-06','18:40:00',1.82),('8902','2013-06-06','18:45:00',1.64),('8902','2013-06-06','18:50:00',1.49),('8902','2013-06-06','18:55:00',1.37),('8902','2013-06-06','19:00:00',1.22),('8902','2013-06-05','07:00:00',1.27),('8902','2013-06-05','07:05:00',1.48),('8902','2013-06-05','07:10:00',1.43),('8902','2013-06-05','07:15:00',1.59),('8902','2013-06-05','07:20:00',1.16),('8902','2013-06-05','07:25:00',1.18),('8902','2013-06-05','07:30:00',1.07),('8902','2013-06-05','07:40:00',1.09),('8902','2013-06-05','07:45:00',1.15),('8902','2013-06-05','07:50:00',1.75),('8902','2013-06-05','07:55:00',2.42),('8902','2013-06-05','08:00:00',2.68),('8902','2013-06-05','08:05:00',2.03),('8902','2013-06-05','08:10:00',2.58),('8902','2013-06-05','08:15:00',2.34),('8902','2013-06-05','08:20:00',2.56),('8902','2013-06-05','08:25:00',3.21),('8902','2013-06-05','08:30:00',3.34),('8902','2013-06-05','08:35:00',3.51),('8902','2013-06-05','08:40:00',3.64),('8902','2013-06-05','08:45:00',3.77),('8902','2013-06-05','08:50:00',3.96),('8902','2013-06-05','08:55:00',4.14),('8902','2013-06-05','09:00:00',4.29),('8902','2013-06-05','09:05:00',4.4),('8902','2013-06-05','09:10:00',4.54),('8902','2013-06-05','09:15:00',4.72),('8902','2013-06-05','09:20:00',4.87),('8902','2013-06-05','09:25:00',4.93),('8902','2013-06-05','09:30:00',5.07),('8902','2013-06-05','09:35:00',5.21),('8902','2013-06-05','09:40:00',4.11),('8902','2013-06-05','09:45:00',5.4),('8902','2013-06-05','09:50:00',5.63),('8902','2013-06-05','09:55:00',5.82),('8902','2013-06-05','10:00:00',5.82),('8902','2013-06-05','10:05:00',5.95),('8902','2013-06-05','10:10:00',6.08),('8902','2013-06-05','10:15:00',6.18),('8902','2013-06-05','10:20:00',6.3),('8902','2013-06-05','10:25:00',6.43),('8902','2013-06-05','10:30:00',6.47),('8902','2013-06-05','10:35:00',6.43),('8902','2013-06-05','10:40:00',6.63),('8902','2013-06-05','10:45:00',6.77),('8902','2013-06-05','10:50:00',6.87),('8902','2013-06-05','10:55:00',6.98),('8902','2013-06-05','11:00:00',7.09),('8902','2013-06-05','11:05:00',7.15),('8902','2013-06-05','11:10:00',7.15),('8902','2013-06-05','11:15:00',7.25),('8902','2013-06-05','11:20:00',7.24),('8902','2013-06-05','11:25:00',7.35),('8902','2013-06-05','11:30:00',7.46),('8902','2013-06-05','11:35:00',7.45),('8902','2013-06-05','11:40:00',7.56),('8902','2013-06-05','11:45:00',7.46),('8902','2013-06-05','11:50:00',7.45),('8902','2013-06-05','11:55:00',7.32),('8902','2013-06-05','12:00:00',7.55),('8902','2013-06-05','12:05:00',6.2),('8902','2013-06-05','12:10:00',7.67),('8902','2013-06-05','12:15:00',7.77),('8902','2013-06-05','12:20:00',7.66),('8902','2013-06-05','12:25:00',7.84),('8902','2013-06-05','12:30:00',7.82),('8902','2013-06-05','12:35:00',7.78),('8902','2013-06-05','12:40:00',7.73),('8902','2013-06-05','12:45:00',7.7),('8902','2013-06-05','12:50:00',7.71),('8902','2013-06-05','12:55:00',7.98),('8902','2013-06-05','13:00:00',8.1),('8902','2013-06-05','13:05:00',7.93),('8902','2013-06-05','13:10:00',8.09),('8902','2013-06-05','13:15:00',8.16),('8902','2013-06-05','13:20:00',8.27),('8902','2013-06-05','13:25:00',8.23),('8902','2013-06-05','13:30:00',8.17),('8902','2013-06-05','13:35:00',8.1),('8902','2013-06-05','13:40:00',8.1),('8902','2013-06-05','13:45:00',7.38),('8902','2013-06-05','13:50:00',8.14),('8902','2013-06-05','13:55:00',8.07),('8902','2013-06-05','14:00:00',8.03),('8902','2013-06-05','14:05:00',8),('8902','2013-06-05','14:10:00',7.7),('8902','2013-06-05','14:15:00',8.07),('8902','2013-06-05','14:20:00',6.81),('8902','2013-06-05','14:25:00',3.66),('8902','2013-06-05','14:30:00',8.07),('8902','2013-06-05','14:35:00',3.97),('8902','2013-06-05','14:40:00',5.27),('8902','2013-06-05','14:45:00',6.2),('8902','2013-06-05','14:50:00',6.13),('8902','2013-06-05','14:55:00',7.98),('8902','2013-06-05','15:00:00',7.73),('8902','2013-06-05','15:05:00',7.82),('8902','2013-06-05','15:10:00',6.9),('8902','2013-06-05','15:15:00',7.7),('8902','2013-06-05','15:20:00',7.64),('8902','2013-06-05','15:25:00',7.31),('8902','2013-06-05','15:30:00',6.76),('8902','2013-06-05','15:35:00',7.13),('8902','2013-06-05','15:40:00',7.08),('8902','2013-06-05','15:45:00',7.08),('8902','2013-06-05','15:50:00',6.65),('8902','2013-06-05','15:55:00',6.62),('8902','2013-06-05','16:00:00',5.89),('8902','2013-06-05','16:05:00',5.15),('8902','2013-06-05','16:10:00',6.29),('8902','2013-06-05','16:15:00',6.17),('8902','2013-06-05','16:20:00',5.96),('8902','2013-06-05','16:25:00',5.98),('8902','2013-06-05','16:30:00',5.99),('8902','2013-06-05','16:35:00',5.86),('8902','2013-06-05','16:40:00',5.74),('8902','2013-06-05','16:45:00',5.39),('8902','2013-06-05','16:50:00',5.19),('8902','2013-06-05','16:55:00',5.19),('8902','2013-06-05','17:00:00',4.99),('8902','2013-06-05','17:05:00',4.86),('8902','2013-06-05','17:10:00',4.74),('8902','2013-06-05','17:15:00',4.65),('8902','2013-06-05','17:20:00',4.41),('8902','2013-06-05','17:25:00',4.27),('8902','2013-06-05','17:30:00',4.17),('8902','2013-06-05','17:35:00',3.97),('8902','2013-06-05','17:40:00',3.82),('8902','2013-06-05','17:45:00',3.67),('8902','2013-06-05','17:50:00',3.45),('8902','2013-06-05','17:55:00',3.17),('8902','2013-06-05','18:00:00',3.17),('8902','2013-06-05','18:05:00',3),('8902','2013-06-05','18:10:00',2.81),('8902','2013-06-05','18:15:00',2.63),('8902','2013-06-05','18:20:00',2.44),('8902','2013-06-05','18:25:00',2.26),('8902','2013-06-05','18:30:00',2.05),('8902','2013-06-05','18:35:00',1.92),('8902','2013-06-05','18:40:00',1.81),('8902','2013-06-05','18:45:00',1.63),('8902','2013-06-05','18:50:00',1.47),('8902','2013-06-05','18:55:00',1.34),('8902','2013-06-05','19:00:00',1.16),('8902','2013-06-05','19:05:00',1.02),('8902','2013-06-04','06:55:00',1.07),('8902','2013-06-04','07:00:00',1.08),('8902','2013-06-04','07:05:00',1.02),('8902','2013-06-04','07:20:00',1.06),('8902','2013-06-04','07:35:00',1.28),('8902','2013-06-04','07:40:00',1.06),('8902','2013-06-04','07:50:00',1.29),('8902','2013-06-04','07:55:00',2.55),('8902','2013-06-04','08:00:00',2.35),('8902','2013-06-04','08:05:00',1.63),('8902','2013-06-04','08:10:00',2.4),('8902','2013-06-04','08:15:00',2.68),('8902','2013-06-04','08:20:00',2.91),('8902','2013-06-04','08:25:00',3.16),('8902','2013-06-04','08:30:00',3.32),('8902','2013-06-04','08:35:00',3.49),('8902','2013-06-04','08:40:00',3.61),('8902','2013-06-04','08:45:00',3.82),('8902','2013-06-04','08:50:00',3.95),('8902','2013-06-04','08:55:00',4.1),('8902','2013-06-04','09:00:00',4.28),('8902','2013-06-04','09:05:00',4.52),('8902','2013-06-04','09:10:00',4.79),('8902','2013-06-04','09:15:00',4.89),('8902','2013-06-04','09:20:00',5.14),('8902','2013-06-04','09:25:00',5.48),('8902','2013-06-04','09:30:00',5.53),('8902','2013-06-04','09:35:00',6.11),('8902','2013-06-04','09:40:00',6.49),('8902','2013-06-04','09:45:00',6.52),('8902','2013-06-04','09:50:00',3.55),('8902','2013-06-04','09:55:00',3.77),('8902','2013-06-04','10:00:00',3.89),('8902','2013-06-04','10:05:00',7.12),('8902','2013-06-04','10:10:00',7.14),('8902','2013-06-04','10:15:00',7.1),('8902','2013-06-04','10:20:00',3.83),('8902','2013-06-04','10:25:00',2.38),('8902','2013-06-04','10:30:00',2.35),('8902','2013-06-04','10:35:00',2.31),('8902','2013-06-04','10:40:00',2.37),('8902','2013-06-04','10:45:00',7.06),('8902','2013-06-04','10:50:00',2.33),('8902','2013-06-04','10:55:00',3.76),('8902','2013-06-04','11:00:00',7.8),('8902','2013-06-04','11:05:00',4.38),('8902','2013-06-04','11:10:00',3.44),('8902','2013-06-04','11:15:00',3.32),('8902','2013-06-04','11:20:00',2.52),('8902','2013-06-04','11:25:00',2),('8902','2013-06-04','11:30:00',1.99),('8902','2013-06-04','11:35:00',2.21),('8902','2013-06-04','11:40:00',4.87),('8902','2013-06-04','11:45:00',4.75),('8902','2013-06-04','11:50:00',4.69),('8902','2013-06-04','11:55:00',7.98),('8902','2013-06-04','12:00:00',8.57),('8902','2013-06-04','12:05:00',6.81),('8902','2013-06-04','12:10:00',8.86),('8902','2013-06-04','12:15:00',8.96),('8902','2013-06-04','12:20:00',9.31),('8902','2013-06-04','12:25:00',9.08),('8902','2013-06-04','12:30:00',7.47),('8902','2013-06-04','12:35:00',5.16),('8902','2013-06-04','12:40:00',7.05),('8902','2013-06-04','12:45:00',9.42),('8902','2013-06-04','12:50:00',6.49),('8902','2013-06-04','12:55:00',3.15),('8902','2013-06-04','13:00:00',6.05),('8902','2013-06-04','13:05:00',9.76),('8902','2013-06-04','13:10:00',5.9),('8902','2013-06-04','13:15:00',3.77),('8902','2013-06-04','13:20:00',4.51),('8902','2013-06-04','13:25:00',7.36),('8902','2013-06-04','13:30:00',8.31),('8902','2013-06-04','13:35:00',9.69),('8902','2013-06-04','13:40:00',9.16),('8902','2013-06-04','13:45:00',9.05),('8902','2013-06-04','13:50:00',8.68),('8902','2013-06-04','13:55:00',8.6),('8902','2013-06-04','14:00:00',8.45),('8902','2013-06-04','14:05:00',8.17),('8902','2013-06-04','14:10:00',8.22),('8902','2013-06-04','14:15:00',8.21),('8902','2013-06-04','14:20:00',8.23),('8902','2013-06-04','14:25:00',8.03),('8902','2013-06-04','14:30:00',8.07),('8902','2013-06-04','14:35:00',8.07),('8902','2013-06-04','14:40:00',8.02),('8902','2013-06-04','14:45:00',8.05),('8902','2013-06-04','14:50:00',8.04),('8902','2013-06-04','14:55:00',7.97),('8902','2013-06-04','15:00:00',7.8),('8902','2013-06-04','15:05:00',7.64),('8902','2013-06-04','15:10:00',7.6),('8902','2013-06-04','15:15:00',7.59),('8902','2013-06-04','15:20:00',7.57),('8902','2013-06-04','15:25:00',7.5),('8902','2013-06-04','15:30:00',7.51),('8902','2013-06-04','15:35:00',7.61),('8902','2013-06-04','15:40:00',7.52),('8902','2013-06-04','15:45:00',7.06),('8902','2013-06-04','15:50:00',7.15),('8902','2013-06-04','15:55:00',7.05),('8902','2013-06-04','16:00:00',7),('8902','2013-06-04','16:05:00',6.9),('8902','2013-06-04','16:10:00',6.7),('8902','2013-06-04','16:15:00',6.64),('8902','2013-06-04','16:20:00',6.53),('8902','2013-06-04','16:25:00',6.37),('8902','2013-06-04','16:30:00',6.26),('8902','2013-06-04','16:35:00',5.95),('8902','2013-06-04','16:40:00',5.93),('8902','2013-06-04','16:45:00',5.8),('8902','2013-06-04','16:50:00',5.61),('8902','2013-06-04','16:55:00',5.49),('8902','2013-06-04','17:00:00',5.37),('8902','2013-06-04','17:05:00',4.47),('8902','2013-06-04','17:10:00',5.23),('8902','2013-06-04','17:15:00',3.29),('8902','2013-06-04','17:20:00',3.3),('8902','2013-06-04','17:25:00',3.52),('8902','2013-06-04','17:30:00',4.2),('8902','2013-06-04','17:35:00',4.37),('8902','2013-06-04','17:40:00',3.28),('8902','2013-06-04','17:45:00',3.86),('8902','2013-06-04','17:50:00',3.62),('8902','2013-06-04','17:55:00',3.33),('8902','2013-06-04','18:00:00',3.24),('8902','2013-06-04','18:05:00',3.11),('8902','2013-06-04','18:10:00',1.78),('8902','2013-06-04','18:15:00',1.73),('8902','2013-06-04','18:20:00',1.9),('8902','2013-06-04','18:25:00',1.72),('8902','2013-06-04','18:30:00',1.88),('8902','2013-06-04','18:35:00',1.73),('8902','2013-06-04','18:40:00',1.38),('8902','2013-06-04','18:45:00',1.03),('8902','2013-06-04','18:55:00',1.2),('8902','2013-06-03','07:15:00',1.11),('8902','2013-06-03','07:20:00',1.23),('8902','2013-06-03','07:25:00',1.34),('8902','2013-06-03','07:30:00',1.47),('8902','2013-06-03','07:35:00',1.65),('8902','2013-06-03','07:40:00',1.88),('8902','2013-06-03','07:45:00',2.23),('8902','2013-06-03','07:50:00',2.5),('8902','2013-06-03','07:55:00',2.73),('8902','2013-06-03','08:00:00',3.09),('8902','2013-06-03','08:05:00',3.39),('8902','2013-06-03','08:10:00',3.53),('8902','2013-06-03','08:15:00',3.63),('8902','2013-06-03','08:20:00',3.73),('8902','2013-06-03','08:25:00',3.74),('8902','2013-06-03','08:30:00',3.3),('8902','2013-06-03','08:35:00',4.47),('8902','2013-06-03','08:40:00',3.67),('8902','2013-06-03','08:45:00',3.64),('8902','2013-06-03','08:50:00',2.56),('8902','2013-06-03','08:55:00',2.5),('8902','2013-06-03','09:00:00',2.93),('8902','2013-06-03','09:05:00',3.08),('8902','2013-06-03','09:10:00',4),('8902','2013-06-03','09:15:00',4.61),('8902','2013-06-03','09:20:00',5.81),('8902','2013-06-03','09:25:00',5.7),('8902','2013-06-03','09:30:00',5.27),('8902','2013-06-03','09:35:00',4.7),('8902','2013-06-03','09:40:00',3.12),('8902','2013-06-03','09:45:00',3.14),('8902','2013-06-03','09:50:00',3.23),('8902','2013-06-03','09:55:00',3.27),('8902','2013-06-03','10:00:00',3.56),('8902','2013-06-03','10:05:00',4.47),('8902','2013-06-03','10:10:00',5.09),('8902','2013-06-03','10:15:00',5.15),('8902','2013-06-03','10:20:00',3.52),('8902','2013-06-03','10:25:00',3.38),('8902','2013-06-03','10:30:00',3.13),('8902','2013-06-03','10:35:00',3.18),('8902','2013-06-03','10:40:00',3.37),('8902','2013-06-03','10:45:00',3.82),('8902','2013-06-03','10:50:00',5.11),('8902','2013-06-03','10:55:00',6.26),('8902','2013-06-03','11:00:00',4.17),('8902','2013-06-03','11:05:00',4.85),('8902','2013-06-03','11:10:00',5.77),('8902','2013-06-03','11:15:00',6.09),('8902','2013-06-03','11:20:00',4.01),('8902','2013-06-03','11:25:00',5.07),('8902','2013-06-03','11:30:00',6.43),('8902','2013-06-03','11:35:00',5.65),('8902','2013-06-03','11:40:00',5.41),('8902','2013-06-03','11:45:00',7.24),('8902','2013-06-03','11:50:00',8.58),('8902','2013-06-03','11:55:00',8.24),('8902','2013-06-03','12:00:00',7.19),('8902','2013-06-03','12:05:00',6.38),('8902','2013-06-03','12:10:00',4.85),('8902','2013-06-03','12:15:00',5.19),('8902','2013-06-03','12:20:00',4.22),('8902','2013-06-03','12:25:00',3.97),('8902','2013-06-03','12:30:00',4.26),('8902','2013-06-03','12:35:00',7.52),('8902','2013-06-03','12:40:00',4.69),('8902','2013-06-03','12:45:00',5.67),('8902','2013-06-03','12:50:00',6.01),('8902','2013-06-03','12:55:00',3.88),('8902','2013-06-03','13:00:00',4.38),('8902','2013-06-03','13:05:00',4.31),('8902','2013-06-03','13:10:00',2.47),('8902','2013-06-03','13:15:00',2.62),('8902','2013-06-03','13:20:00',2.09),('8902','2013-06-03','13:25:00',2.31),('8902','2013-06-03','13:30:00',3.09),('8902','2013-06-03','13:35:00',6.41),('8902','2013-06-03','13:40:00',5.59),('8902','2013-06-03','13:45:00',6.91),('8902','2013-06-03','13:50:00',9.52),('8902','2013-06-03','13:55:00',6.88),('8902','2013-06-03','14:00:00',3.13),('8902','2013-06-03','14:05:00',5.66),('8902','2013-06-03','14:10:00',9.64),('8902','2013-06-03','14:15:00',8.74),('8902','2013-06-03','14:20:00',6.88),('8902','2013-06-03','14:25:00',5.28),('8902','2013-06-03','14:30:00',2.76),('8902','2013-06-03','14:35:00',3.18),('8902','2013-06-03','14:40:00',5.22),('8902','2013-06-03','14:45:00',2.28),('8902','2013-06-03','14:50:00',1.89),('8902','2013-06-03','14:55:00',5.79),('8902','2013-06-03','15:00:00',9.97),('8902','2013-06-03','15:05:00',9.63),('8902','2013-06-03','15:10:00',4.03),('8902','2013-06-03','15:15:00',2.1),('8902','2013-06-03','15:20:00',1.9),('8902','2013-06-03','15:25:00',1.5),('8902','2013-06-03','17:15:00',1.49),('8902','2013-06-03','17:20:00',1.55),('8902','2013-06-03','17:25:00',1.29),('8902','2013-06-03','17:40:00',1.62),('8902','2013-06-03','17:45:00',1.04),('8902','2013-06-03','17:50:00',1.1),('8902','2013-06-03','17:55:00',1.26),('8902','2013-06-03','18:00:00',1.45),('8902','2013-06-03','18:05:00',1.66),('8902','2013-06-03','18:10:00',1.78),('8902','2013-06-03','18:15:00',1.59),('8902','2013-06-03','18:20:00',1.42),('8902','2013-06-03','18:25:00',1.33),('8902','2013-06-03','18:30:00',1.08),('8902','2013-06-03','18:40:00',1.1),('8902','2013-06-03','18:45:00',1.38),('8902','2013-06-03','18:50:00',1.37),('8902','2013-06-03','18:55:00',1.11),('8902','2013-06-02','07:25:00',1.15),('8902','2013-06-02','07:40:00',1.47),('8902','2013-06-02','07:45:00',1.89),('8902','2013-06-02','07:50:00',1.98),('8902','2013-06-02','07:55:00',2.25),('8902','2013-06-02','08:00:00',2.42),('8902','2013-06-02','08:05:00',2.54),('8902','2013-06-02','08:10:00',2.68),('8902','2013-06-02','08:15:00',2.84),('8902','2013-06-02','08:20:00',3.02),('8902','2013-06-02','08:25:00',3.21),('8902','2013-06-02','08:30:00',3.34),('8902','2013-06-02','08:35:00',3.53),('8902','2013-06-02','08:40:00',3.7),('8902','2013-06-02','08:45:00',3.81),('8902','2013-06-02','08:50:00',4.01),('8902','2013-06-02','08:55:00',4.14),('8902','2013-06-02','09:00:00',4.28),('8902','2013-06-02','09:05:00',4.28),('8902','2013-06-02','09:10:00',4.6),('8902','2013-06-02','09:15:00',5.22),('8902','2013-06-02','09:20:00',4.87),('8902','2013-06-02','09:25:00',4.57),('8902','2013-06-02','09:30:00',3.97),('8902','2013-06-02','09:35:00',3.3),('8902','2013-06-02','09:40:00',4.28),('8902','2013-06-02','09:45:00',4.88),('8902','2013-06-02','09:50:00',5.68),('8902','2013-06-02','09:55:00',5.79),('8902','2013-06-02','10:00:00',6.36),('8902','2013-06-02','10:05:00',7.37),('8902','2013-06-02','10:10:00',5.35),('8902','2013-06-02','10:15:00',3.94),('8902','2013-06-02','10:20:00',5.34),('8902','2013-06-02','10:25:00',3.84),('8902','2013-06-02','10:30:00',2.33),('8902','2013-06-02','10:35:00',2.36),('8902','2013-06-02','10:40:00',2.79),('8902','2013-06-02','10:45:00',2.95),('8902','2013-06-02','10:50:00',3.51),('8902','2013-06-02','10:55:00',3.72),('8902','2013-06-02','11:00:00',3.59),('8902','2013-06-02','11:05:00',3.83),('8902','2013-06-02','11:10:00',2.38),('8902','2013-06-02','11:15:00',2.48),('8902','2013-06-02','11:20:00',3.18),('8902','2013-06-02','11:25:00',3.23),('8902','2013-06-02','11:30:00',2.83),('8902','2013-06-02','11:35:00',2.78),('8902','2013-06-02','11:40:00',3.22),('8902','2013-06-02','11:45:00',3.38),('8902','2013-06-02','11:50:00',2.97),('8902','2013-06-02','11:55:00',4.07),('8902','2013-06-02','12:00:00',4.99),('8902','2013-06-02','12:05:00',6.47),('8902','2013-06-02','12:10:00',3.54),('8902','2013-06-02','12:15:00',2.65),('8902','2013-06-02','12:20:00',2.83),('8902','2013-06-02','12:25:00',2.8),('8902','2013-06-02','12:30:00',3.74),('8902','2013-06-02','12:35:00',7.99),('8902','2013-06-02','12:40:00',6.43),('8902','2013-06-02','12:45:00',4.41),('8902','2013-06-02','12:50:00',4.3),('8902','2013-06-02','12:55:00',5.12),('8902','2013-06-02','13:00:00',3.75),('8902','2013-06-02','13:05:00',3.5),('8902','2013-06-02','13:10:00',3.8),('8902','2013-06-02','13:15:00',7.45),('8902','2013-06-02','13:20:00',9.52),('8902','2013-06-02','13:25:00',6.01),('8902','2013-06-02','13:30:00',7.83),('8902','2013-06-02','13:35:00',9.11),('8902','2013-06-02','13:40:00',6.88),('8902','2013-06-02','13:45:00',4.43),('8902','2013-06-02','13:50:00',7.42),('8902','2013-06-02','13:55:00',6.01),('8902','2013-06-02','14:00:00',8.75),('8902','2013-06-02','14:05:00',5.92),('8902','2013-06-02','14:10:00',4.08),('8902','2013-06-02','14:15:00',5.78),('8902','2013-06-02','14:20:00',3.74),('8902','2013-06-02','14:25:00',7.29),('8902','2013-06-02','14:30:00',9.12),('8902','2013-06-02','14:35:00',9.09),('8902','2013-06-02','14:40:00',5.77),('8902','2013-06-02','14:45:00',6.64),('8902','2013-06-02','14:50:00',5.68),('8902','2013-06-02','14:55:00',7.93),('8902','2013-06-02','15:00:00',7.26),('8902','2013-06-02','15:05:00',5.95),('8902','2013-06-02','15:10:00',8.04),('8902','2013-06-02','15:15:00',6.92),('8902','2013-06-02','15:20:00',6.34),('8902','2013-06-02','15:25:00',7.86),('8902','2013-06-02','15:30:00',7.7),('8902','2013-06-02','15:35:00',7.53),('8902','2013-06-02','15:40:00',7.39),('8902','2013-06-02','15:45:00',7.31),('8902','2013-06-02','15:50:00',7.28),('8902','2013-06-02','15:55:00',7.13),('8902','2013-06-02','16:00:00',6.98),('8902','2013-06-02','16:05:00',6.94),('8902','2013-06-02','16:10:00',6.89),('8902','2013-06-02','16:15:00',6.73),('8902','2013-06-02','16:20:00',6.38),('8902','2013-06-02','16:25:00',6.57),('8902','2013-06-02','16:30:00',6.6),('8902','2013-06-02','16:35:00',6.03),('8902','2013-06-02','16:40:00',6.18),('8902','2013-06-02','16:45:00',5.34),('8902','2013-06-02','16:50:00',4.08),('8902','2013-06-02','16:55:00',3.51),('8902','2013-06-02','17:00:00',4.08),('8902','2013-06-02','17:05:00',5.14),('8902','2013-06-02','17:10:00',4.91),('8902','2013-06-02','17:15:00',4.94),('8902','2013-06-02','17:20:00',4.25),('8902','2013-06-02','17:25:00',2.65),('8902','2013-06-02','17:30:00',1.55),('8902','2013-06-02','17:35:00',1.19),('8902','2013-06-02','17:40:00',1.2),('8902','2013-06-02','17:45:00',1.09),('8902','2013-06-02','17:50:00',1.31),('8902','2013-06-02','17:55:00',1.29),('8902','2013-06-02','18:00:00',1.09),('8902','2013-06-01','06:55:00',1.3),('8902','2013-06-01','07:00:00',1.38),('8902','2013-06-01','07:05:00',1.05),('8902','2013-06-01','08:25:00',1.44),('8902','2013-06-01','08:30:00',1.53),('8902','2013-06-01','08:35:00',1.63),('8902','2013-06-01','08:40:00',1.63),('8902','2013-06-01','08:45:00',1.8),('8902','2013-06-01','08:50:00',2),('8902','2013-06-01','08:55:00',1.78),('8902','2013-06-01','09:00:00',1.74),('8902','2013-06-01','09:05:00',1.87),('8902','2013-06-01','09:10:00',2.08),('8902','2013-06-01','09:15:00',2.14),('8902','2013-06-01','09:20:00',3.04),('8902','2013-06-01','09:25:00',5.93),('8902','2013-06-01','09:30:00',5.68),('8902','2013-06-01','09:35:00',5.65),('8902','2013-06-01','09:40:00',5.65),('8902','2013-06-01','09:45:00',5.73),('8902','2013-06-01','09:50:00',5.86),('8902','2013-06-01','09:55:00',5.94),('8902','2013-06-01','10:00:00',6.08),('8902','2013-06-01','10:05:00',6.18),('8902','2013-06-01','10:10:00',6.32),('8902','2013-06-01','10:15:00',6.44),('8902','2013-06-01','10:20:00',6.54),('8902','2013-06-01','10:25:00',6.62),('8902','2013-06-01','10:30:00',6.88),('8902','2013-06-01','10:35:00',7.34),('8902','2013-06-01','10:40:00',7.45),('8902','2013-06-01','10:45:00',6.81),('8902','2013-06-01','10:50:00',6.85),('8902','2013-06-01','10:55:00',4.93),('8902','2013-06-01','11:00:00',7.92),('8902','2013-06-01','11:05:00',7.78),('8902','2013-06-01','11:10:00',8.45),('8902','2013-06-01','11:15:00',4.48),('8902','2013-06-01','11:20:00',8.36),('8902','2013-06-01','11:25:00',5.55),('8902','2013-06-01','11:30:00',6.01),('8902','2013-06-01','11:35:00',3.98),('8902','2013-06-01','11:40:00',3.07),('8902','2013-06-01','11:45:00',2.51),('8902','2013-06-01','11:50:00',3.46),('8902','2013-06-01','11:55:00',6.17),('8902','2013-06-01','12:00:00',8.63),('8902','2013-06-01','12:05:00',4.49),('8902','2013-06-01','12:10:00',4.24),('8902','2013-06-01','12:15:00',8.63),('8902','2013-06-01','12:20:00',4.9),('8902','2013-06-01','12:25:00',3.02),('8902','2013-06-01','12:30:00',3.88),('8902','2013-06-01','12:35:00',5.5),('8902','2013-06-01','12:40:00',8.55),('8902','2013-06-01','12:45:00',7.07),('8902','2013-06-01','12:50:00',4.38),('8902','2013-06-01','12:55:00',4.3),('8902','2013-06-01','13:00:00',5.26),('8902','2013-06-01','13:05:00',2.86),('8902','2013-06-01','13:10:00',2.55),('8902','2013-06-01','13:15:00',8.58),('8902','2013-06-01','13:20:00',9.08),('8902','2013-06-01','13:25:00',8.68),('8902','2013-06-01','13:30:00',8.51),('8902','2013-06-01','13:35:00',8.52),('8902','2013-06-01','13:40:00',8.42),('8902','2013-06-01','13:45:00',8.32),('8902','2013-06-01','13:50:00',8.32),('8902','2013-06-01','13:55:00',8.29),('8902','2013-06-01','14:00:00',8.25),('8902','2013-06-01','14:05:00',8.16),('8902','2013-06-01','14:10:00',8.3),('8902','2013-06-01','14:15:00',8.1),('8902','2013-06-01','14:20:00',8.21),('8902','2013-06-01','14:25:00',8.21),('8902','2013-06-01','14:30:00',8.13),('8902','2013-06-01','14:35:00',8.02),('8902','2013-06-01','14:40:00',7.96),('8902','2013-06-01','14:45:00',7.89),('8902','2013-06-01','14:50:00',7.87),('8902','2013-06-01','14:55:00',7.87),('8902','2013-06-01','15:00:00',7.81),('8902','2013-06-01','15:05:00',7.76),('8902','2013-06-01','15:10:00',7.58),('8902','2013-06-01','15:15:00',7.61),('8902','2013-06-01','15:20:00',7.55),('8902','2013-06-01','15:25:00',6.7),('8902','2013-06-01','15:30:00',7.61),('8902','2013-06-01','15:35:00',5.89),('8902','2013-06-01','15:40:00',5.47),('8902','2013-06-01','15:45:00',6.82),('8902','2013-06-01','15:50:00',7.23),('8902','2013-06-01','15:55:00',5.34),('8902','2013-06-01','16:00:00',7.33),('8902','2013-06-01','16:05:00',6.97),('8902','2013-06-01','16:10:00',6.25),('8902','2013-06-01','16:15:00',5.77),('8902','2013-06-01','16:20:00',6.67),('8902','2013-06-01','16:25:00',6.29),('8902','2013-06-01','16:30:00',6.28),('8902','2013-06-01','16:35:00',5.84),('8902','2013-06-01','16:40:00',6.04),('8902','2013-06-01','16:45:00',6.16),('8902','2013-06-01','16:50:00',5.45),('8902','2013-06-01','16:55:00',5.65),('8902','2013-06-01','17:00:00',5.54),('8902','2013-06-01','17:05:00',5.2),('8902','2013-06-01','17:10:00',5.1),('8902','2013-06-01','17:15:00',4.98),('8902','2013-06-01','17:20:00',4.74),('8902','2013-06-01','17:25:00',4.63),('8902','2013-06-01','17:30:00',3.12),('8902','2013-06-01','17:35:00',3.82),('8902','2013-06-01','17:40:00',1.96),('8902','2013-06-01','17:45:00',2.09),('8902','2013-06-01','17:50:00',3.39),('8902','2013-06-01','17:55:00',1.33),('8902','2013-06-01','18:00:00',2.46),('8902','2013-06-01','18:05:00',1.57),('8902','2013-06-01','18:10:00',1.22),('8902','2013-06-01','18:15:00',1.29),('8902','2013-06-01','18:20:00',1.29),('8902','2013-06-01','18:25:00',1.12),('8902','2013-06-01','18:30:00',1.15),('8902','2013-06-01','18:35:00',1.16),('8902','2013-06-01','18:40:00',1.06),('8902','2013-06-01','18:45:00',1.05),('8902','2013-06-01','18:50:00',1.04),('8902','2013-05-31','07:20:00',1.14),('8902','2013-05-31','07:25:00',1.28),('8902','2013-05-31','07:30:00',1.44),('8902','2013-05-31','07:35:00',1.63),('8902','2013-05-31','07:40:00',1.82),('8902','2013-05-31','07:45:00',2.25),('8902','2013-05-31','07:50:00',1.69),('8902','2013-05-31','07:55:00',2.28),('8902','2013-05-31','08:00:00',1.26),('8902','2013-05-31','08:05:00',1.11),('8902','2013-05-31','08:10:00',1.2),('8902','2013-05-31','08:15:00',2.32),('8902','2013-05-31','08:20:00',2.43),('8902','2013-05-31','08:25:00',1.56),('8902','2013-05-31','08:30:00',2.17),('8902','2013-05-31','08:35:00',3.2),('8902','2013-05-31','08:40:00',1.6),('8902','2013-05-31','08:45:00',1.08),('8902','2013-05-31','08:50:00',1.25),('8902','2013-05-31','08:55:00',1.3),('8902','2013-05-31','09:00:00',1.38),('8902','2013-05-31','09:05:00',1.06),('8902','2013-05-31','09:40:00',1.1),('8902','2013-05-31','09:45:00',1.64),('8902','2013-05-31','09:50:00',1.95),('8902','2013-05-31','09:55:00',1.43),('8902','2013-05-31','10:00:00',1.31),('8902','2013-05-31','10:05:00',1.49),('8902','2013-05-31','10:10:00',1.45),('8902','2013-05-31','10:15:00',1.25),('8902','2013-05-31','10:20:00',1.02),('8902','2013-05-31','10:30:00',1.06),('8902','2013-05-31','10:35:00',2.09),('8902','2013-05-31','10:40:00',2.23),('8902','2013-05-31','10:45:00',1.41),('8902','2013-05-31','10:50:00',2.54),('8902','2013-05-31','10:55:00',5.25),('8902','2013-05-31','11:00:00',1.28),('8902','2013-05-31','11:30:00',1.06),('8902','2013-05-31','11:45:00',1.32),('8902','2013-05-31','11:50:00',2.74),('8902','2013-05-31','11:55:00',3.65),('8902','2013-05-31','12:00:00',4.74),('8902','2013-05-31','12:05:00',6.81),('8902','2013-05-31','12:10:00',6.69),('8902','2013-05-31','12:15:00',3.1),('8902','2013-05-31','12:20:00',2.21),('8902','2013-05-31','12:25:00',2.32),('8902','2013-05-31','12:30:00',2.31),('8902','2013-05-31','12:35:00',1.78),('8902','2013-05-31','12:40:00',1.95),('8902','2013-05-31','12:45:00',3.16),('8902','2013-05-31','12:50:00',3.47),('8902','2013-05-31','12:55:00',3.34),('8902','2013-05-31','13:00:00',4.21),('8902','2013-05-31','13:05:00',4.52),('8902','2013-05-31','13:10:00',4.66),('8902','2013-05-31','13:15:00',5.36),('8902','2013-05-31','13:20:00',4.43),('8902','2013-05-31','13:25:00',3.37),('8902','2013-05-31','13:30:00',2.95),('8902','2013-05-31','13:35:00',2.34),('8902','2013-05-31','13:40:00',2.1),('8902','2013-05-31','13:45:00',2.4),('8902','2013-05-31','13:50:00',2.58),('8902','2013-05-31','13:55:00',2.9),('8902','2013-05-31','14:00:00',3.71),('8902','2013-05-31','14:05:00',4.66),('8902','2013-05-31','14:10:00',4.54),('8902','2013-05-31','14:15:00',4.74),('8902','2013-05-31','14:20:00',4.92),('8902','2013-05-31','14:25:00',3.11),('8902','2013-05-31','14:30:00',2.47),('8902','2013-05-31','14:35:00',2.56),('8902','2013-05-31','14:40:00',2.48),('8902','2013-05-31','14:45:00',2.4),('8902','2013-05-31','14:50:00',2.14),('8902','2013-05-31','14:55:00',1.71),('8902','2013-05-31','15:00:00',1.65),('8902','2013-05-31','15:05:00',1.67),('8902','2013-05-31','15:10:00',1.27),('8902','2013-05-31','15:15:00',1.21),('8902','2013-05-31','15:20:00',1.05),('8902','2013-05-31','16:05:00',1.13),('8902','2013-05-31','16:10:00',1.09),('8902','2013-05-31','16:15:00',1.2),('8902','2013-05-31','16:20:00',1.38),('8902','2013-05-31','16:25:00',1.08),('8902','2013-05-31','16:30:00',1.24),('8902','2013-05-31','16:35:00',1.39),('8902','2013-05-31','16:40:00',1.57),('8902','2013-05-31','16:45:00',1.36),('8902','2013-05-31','16:50:00',1.28),('8902','2013-05-31','16:55:00',1.28),('8902','2013-05-31','18:30:00',1.67),('8902','2013-05-31','18:35:00',2.05),('8902','2013-05-31','18:40:00',1.52),('8902','2013-05-31','18:45:00',1.14),('8902','2013-05-31','18:50:00',1.01),('8902','2013-05-31','18:55:00',1.1),('8902','2013-05-31','19:00:00',2.06),('8902','2013-05-31','19:05:00',1.84),('8902','2013-05-31','19:10:00',1.02),('8902','2014-04-01','08:00:00',1.42),('8902','2014-04-01','08:05:00',1.74),('8902','2014-04-01','08:10:00',1.67),('8902','2014-04-01','08:15:00',1.31),('8902','2014-04-01','08:20:00',1.89),('8902','2014-04-01','08:25:00',1.55),('8902','2014-04-01','08:35:00',1.02),('8902','2014-04-01','08:40:00',1.41),('8902','2014-04-01','08:45:00',1.56),('8902','2014-04-01','08:50:00',1.84),('8902','2014-04-01','08:55:00',3.42),('8902','2014-04-01','09:00:00',2.35),('8902','2014-04-01','09:05:00',1.86),('8902','2014-04-01','09:10:00',1.7),('8902','2014-04-01','09:15:00',1.7),('8902','2014-04-01','09:20:00',1.75),('8902','2014-04-01','09:25:00',1.56),('8902','2014-04-01','09:30:00',1.2),('8902','2014-04-01','09:35:00',1.42),('8902','2014-04-01','09:40:00',1.79),('8902','2014-04-01','09:45:00',1.63),('8902','2014-04-01','09:50:00',1.25),('8902','2014-04-01','09:55:00',1.38),('8902','2014-04-01','10:00:00',3.63),('8902','2014-04-01','10:05:00',3.51),('8902','2014-04-01','10:10:00',3.38),('8902','2014-04-01','10:15:00',2.38),('8902','2014-04-01','10:20:00',3.12),('8902','2014-04-01','10:25:00',6.37),('8902','2014-04-01','10:30:00',6.09),('8902','2014-04-01','10:35:00',1.66),('8902','2014-04-01','10:40:00',1.6),('8902','2014-04-01','10:45:00',1.65),('8902','2014-04-01','10:50:00',1.84),('8902','2014-04-01','10:55:00',5.65),('8902','2014-04-01','11:00:00',6.99),('8902','2014-04-01','11:05:00',6.78),('8902','2014-04-01','11:10:00',5.62),('8902','2014-04-01','11:15:00',2.45),('8902','2014-04-01','11:20:00',6.83),('8902','2014-04-01','11:25:00',7.85),('8902','2014-04-01','11:30:00',7.9),('8902','2014-04-01','11:35:00',6.27),('8902','2014-04-01','11:40:00',5.84),('8902','2014-04-01','11:45:00',4.02),('8902','2014-04-01','11:50:00',6.12),('8902','2014-04-01','11:55:00',4.36),('8902','2014-04-01','12:00:00',6.9),('8902','2014-04-01','12:05:00',9.06),('8902','2014-04-01','12:10:00',3.33),('8902','2014-04-01','12:15:00',2.54),('8902','2014-04-01','12:20:00',4.9),('8902','2014-04-01','12:25:00',8.83),('8902','2014-04-01','12:30:00',2.51),('8902','2014-04-01','12:35:00',6.92),('8902','2014-04-01','12:40:00',8.94),('8902','2014-04-01','12:45:00',8.87),('8902','2014-04-01','12:50:00',8.31),('8902','2014-04-01','12:55:00',9.05),('8902','2014-04-01','13:00:00',6.22),('8902','2014-04-01','13:05:00',3.78),('8902','2014-04-01','13:10:00',6.71),('8902','2014-04-01','13:15:00',7.92),('8902','2014-04-01','13:20:00',6.36),('8902','2014-04-01','13:25:00',8.59),('8902','2014-04-01','13:30:00',8.67),('8902','2014-04-01','13:35:00',8.73),('8902','2014-04-01','13:40:00',9.08),('8902','2014-04-01','13:45:00',8.69),('8902','2014-04-01','13:50:00',8.35),('8902','2014-04-01','13:55:00',8.29),('8902','2014-04-01','14:00:00',8.29),('8902','2014-04-01','14:05:00',8.11),('8902','2014-04-01','14:10:00',8.25),('8902','2014-04-01','14:15:00',8.18),('8902','2014-04-01','14:20:00',8.05),('8902','2014-04-01','14:25:00',8.04),('8902','2014-04-01','14:30:00',8.01),('8902','2014-04-01','14:35:00',7.86),('8902','2014-04-01','14:40:00',7.94),('8902','2014-04-01','14:45:00',7.97),('8902','2014-04-01','14:50:00',4.61),('8902','2014-04-01','14:55:00',6.97),('8902','2014-04-01','15:00:00',6.93),('8902','2014-04-01','15:05:00',7.6),('8902','2014-04-01','15:10:00',7.03),('8902','2014-04-01','15:15:00',7.06),('8902','2014-04-01','15:20:00',7.07),('8902','2014-04-01','15:25:00',6.94),('8902','2014-04-01','15:30:00',6.58),('8902','2014-04-01','15:35:00',6.39),('8902','2014-04-01','15:40:00',6.72),('8902','2014-04-01','15:45:00',6.81),('8902','2014-04-01','15:50:00',6.73),('8902','2014-04-01','15:55:00',5.95),('8902','2014-04-01','16:00:00',6.15),('8902','2014-04-01','16:05:00',6.17),('8902','2014-04-01','16:10:00',6.03),('8902','2014-04-01','16:15:00',5.93),('8902','2014-04-01','16:20:00',5.73),('8902','2014-04-01','16:25:00',5.6),('8902','2014-04-01','16:30:00',5.59),('8902','2014-04-01','16:35:00',5.38),('8902','2014-04-01','16:40:00',5.27),('8902','2014-04-01','16:45:00',5.03),('8902','2014-04-01','16:50:00',4.56),('8902','2014-04-01','16:55:00',4.57),('8902','2014-04-01','17:00:00',4.77),('8902','2014-04-01','17:05:00',4.23),('8902','2014-04-01','17:10:00',4.07),('8902','2014-04-01','17:15:00',3.69),('8902','2014-04-01','17:20:00',3.68),('8902','2014-04-01','17:25:00',3.49),('8902','2014-04-01','17:30:00',3.17),('8902','2014-04-01','17:35:00',3.05),('8902','2014-04-01','17:40:00',2.27),('8902','2014-04-01','17:45:00',2.32),('8902','2014-04-01','17:50:00',2.8),('8902','2014-04-01','17:55:00',2.34),('8902','2014-04-01','18:00:00',2.17),('8902','2014-04-01','18:05:00',1.38),('8902','2014-04-01','18:10:00',1.19),('8902','2014-04-01','18:15:00',1.15),('8902','2014-04-01','18:20:00',1.17),('8902','2014-04-01','18:25:00',1.05),('8902','2013-05-30','07:15:00',1.02),('8902','2013-05-30','07:20:00',1.17),('8902','2013-05-30','07:25:00',1.32),('8902','2013-05-30','07:30:00',1.49),('8902','2013-05-30','07:35:00',1.64),('8902','2013-05-30','07:40:00',1.8),('8902','2013-05-30','07:45:00',1.95),('8902','2013-05-30','07:50:00',2.11),('8902','2013-05-30','07:55:00',2.34),('8902','2013-05-30','08:00:00',2.55),('8902','2013-05-30','08:05:00',2.68),('8902','2013-05-30','08:10:00',2.84),('8902','2013-05-30','08:15:00',2.99),('8902','2013-05-30','08:20:00',3.16),('8902','2013-05-30','08:25:00',3.37),('8902','2013-05-30','08:30:00',3.76),('8902','2013-05-30','08:35:00',3.35),('8902','2013-05-30','08:40:00',4.45),('8902','2013-05-30','08:45:00',2.26),('8902','2013-05-30','08:50:00',4.35),('8902','2013-05-30','08:55:00',3.09),('8902','2013-05-30','09:00:00',1.95),('8902','2013-05-30','09:05:00',1.15),('8902','2013-05-30','09:10:00',2.12),('8902','2013-05-30','09:15:00',1.97),('8902','2013-05-30','09:20:00',1.52),('8902','2013-05-30','09:25:00',1.62),('8902','2013-05-30','09:30:00',3.03),('8902','2013-05-30','09:35:00',4.97),('8902','2013-05-30','09:40:00',4.72),('8902','2013-05-30','09:45:00',5.92),('8902','2013-05-30','09:50:00',6.28),('8902','2013-05-30','09:55:00',6.68),('8902','2013-05-30','10:00:00',6.79),('8902','2013-05-30','10:05:00',3.85),('8902','2013-05-30','10:10:00',3.82),('8902','2013-05-30','10:15:00',5.12),('8902','2013-05-30','10:20:00',6.58),('8902','2013-05-30','10:25:00',2.75),('8902','2013-05-30','10:30:00',4.09),('8902','2013-05-30','10:35:00',5.53),('8902','2013-05-30','10:40:00',5.93),('8902','2013-05-30','10:45:00',6.94),('8902','2013-05-30','10:50:00',5.53),('8902','2013-05-30','10:55:00',7.62),('8902','2013-05-30','11:00:00',2.74),('8902','2013-05-30','11:05:00',2.47),('8902','2013-05-30','11:10:00',9.58),('8902','2013-05-30','11:15:00',8.49),('8902','2013-05-30','11:20:00',3.16),('8902','2013-05-30','11:25:00',3.52),('8902','2013-05-30','11:30:00',6.97),('8902','2013-05-30','11:35:00',4.91),('8902','2013-05-30','11:40:00',1.91),('8902','2013-05-30','11:45:00',6.12),('8902','2013-05-30','11:50:00',8.33),('8902','2013-05-30','11:55:00',4.54),('8902','2013-05-30','12:00:00',5.27),('8902','2013-05-30','12:05:00',8.38),('8902','2013-05-30','12:10:00',8.17),('8902','2013-05-30','12:15:00',3.25),('8902','2013-05-30','12:20:00',2.82),('8902','2013-05-30','12:25:00',6.5),('8902','2013-05-30','12:30:00',3.25),('8902','2013-05-30','12:35:00',2.81),('8902','2013-05-30','12:40:00',7.18),('8902','2013-05-30','12:45:00',5.21),('8902','2013-05-30','12:50:00',1.67),('8902','2013-05-30','12:55:00',2.51),('8902','2013-05-30','13:00:00',7.26),('8902','2013-05-30','13:05:00',4.38),('8902','2013-05-30','13:10:00',1.34),('8902','2013-05-30','13:15:00',1.2),('8902','2013-05-30','13:20:00',1.97),('8902','2013-05-30','13:25:00',3.37),('8902','2013-05-30','13:30:00',6.45),('8902','2013-05-30','13:35:00',9.44),('8902','2013-05-30','13:40:00',3.81),('8902','2013-05-30','13:45:00',2.56),('8902','2013-05-30','13:50:00',1.36),('8902','2013-05-30','13:55:00',1.51),('8902','2013-05-30','14:00:00',4.21),('8902','2013-05-30','14:05:00',1.63),('8902','2013-05-30','14:10:00',1.2),('8902','2013-05-30','14:20:00',1.37),('8902','2013-05-30','14:25:00',1.5),('8902','2013-05-30','14:45:00',1.09),('8902','2013-05-30','14:50:00',1.55),('8902','2013-05-30','14:55:00',1.27),('8902','2013-05-30','15:00:00',1.48),('8902','2013-05-30','15:05:00',2.8),('8902','2013-05-30','15:10:00',3.46),('8902','2013-05-30','15:15:00',4.55),('8902','2013-05-30','15:20:00',9.88),('8902','2013-05-30','15:25:00',6.65),('8902','2013-05-30','15:30:00',5.51),('8902','2013-05-30','15:35:00',4.06),('8902','2013-05-30','15:40:00',3.41),('8902','2013-05-30','15:45:00',3),('8902','2013-05-30','15:50:00',4.34),('8902','2013-05-30','15:55:00',4.15),('8902','2013-05-30','16:00:00',3.18),('8902','2013-05-30','16:05:00',2.46),('8902','2013-05-30','16:10:00',1.91),('8902','2013-05-30','16:15:00',1.68),('8902','2013-05-30','16:20:00',1.91),('8902','2013-05-30','16:25:00',2.49),('8902','2013-05-30','16:30:00',2.37),('8902','2013-05-30','16:35:00',1.99),('8902','2013-05-30','16:40:00',2.2),('8902','2013-05-30','16:45:00',2.32),('8902','2013-05-30','16:50:00',1.63),('8902','2013-05-30','16:55:00',1.2),('8902','2013-05-30','17:00:00',1.13),('8902','2013-05-30','17:05:00',1.14),('8902','2013-05-30','17:10:00',1.09),('8902','2013-05-30','17:15:00',1.14),('8902','2013-05-30','17:20:00',1.28),('8902','2013-05-30','17:25:00',1.39),('8902','2013-05-30','17:30:00',1.37),('8902','2013-05-30','17:35:00',1.17),('8902','2013-05-30','17:40:00',1),('8902','2013-05-30','17:45:00',1.06),('8902','2013-05-30','17:50:00',1),('8902','2013-05-29','07:40:00',1.15),('8902','2013-05-29','07:45:00',1.39),('8902','2013-05-29','07:50:00',1.74),('8902','2013-05-29','07:55:00',1.46),('8902','2013-05-29','08:00:00',1.27),('8902','2013-05-29','08:10:00',1.12),('8902','2013-05-29','08:15:00',1.33),('8902','2013-05-29','08:20:00',1.51),('8902','2013-05-29','08:25:00',2.39),('8902','2013-05-29','08:30:00',1.85),('8902','2013-05-29','08:35:00',1.27),('8902','2013-05-29','08:40:00',3.95),('8902','2013-05-29','08:45:00',4.14),('8902','2013-05-29','08:50:00',4.28),('8902','2013-05-29','08:55:00',4.43),('8902','2013-05-29','09:00:00',4.58),('8902','2013-05-29','09:05:00',4.48),('8902','2013-05-29','09:10:00',4.38),('8902','2013-05-29','09:15:00',5.1),('8902','2013-05-29','09:20:00',5.26),('8902','2013-05-29','09:25:00',5.29),('8902','2013-05-29','09:30:00',5.15),('8902','2013-05-29','09:35:00',5.49),('8902','2013-05-29','09:40:00',5.9),('8902','2013-05-29','09:45:00',5.97),('8902','2013-05-29','09:50:00',5.69),('8902','2013-05-29','09:55:00',5.18),('8902','2013-05-29','10:00:00',2.69),('8902','2013-05-29','10:05:00',2.11),('8902','2013-05-29','10:10:00',6.38),('8902','2013-05-29','10:15:00',3.69),('8902','2013-05-29','10:20:00',7.73),('8902','2013-05-29','10:25:00',2.72),('8902','2013-05-29','10:30:00',2.14),('8902','2013-05-29','10:35:00',2.6),('8902','2013-05-29','10:40:00',6.14),('8902','2013-05-29','10:45:00',6.02),('8902','2013-05-29','10:50:00',7.77),('8902','2013-05-29','10:55:00',6.51),('8902','2013-05-29','11:00:00',8.02),('8902','2013-05-29','11:05:00',8.87),('8902','2013-05-29','11:10:00',4.67),('8902','2013-05-29','11:15:00',3.23),('8902','2013-05-29','11:20:00',7.87),('8902','2013-05-29','11:25:00',4.21),('8902','2013-05-29','11:30:00',6.4),('8902','2013-05-29','11:35:00',9.51),('8902','2013-05-29','11:40:00',9.3),('8902','2013-05-29','11:45:00',7.7),('8902','2013-05-29','11:50:00',9.21),('8902','2013-05-29','11:55:00',2.58),('8902','2013-05-29','12:00:00',7.2),('8902','2013-05-29','12:05:00',9.65),('8902','2013-05-29','12:10:00',5.25),('8902','2013-05-29','12:15:00',6.86),('8902','2013-05-29','12:20:00',8.9),('8902','2013-05-29','12:25:00',6.28),('8902','2013-05-29','12:30:00',7.4),('8902','2013-05-29','12:35:00',5.66),('8902','2013-05-29','12:40:00',8.03),('8902','2013-05-29','12:45:00',3.68),('8902','2013-05-29','12:50:00',9.4),('8902','2013-05-29','13:15:00',5.1),('8902','2013-05-29','13:20:00',3.3),('8902','2013-05-29','13:25:00',3.96),('8902','2013-05-29','13:30:00',5.35),('8902','2013-05-29','13:35:00',3.26),('8902','2013-05-29','13:40:00',8.59),('8902','2013-05-29','13:45:00',7.69),('8902','2013-05-29','13:50:00',3.79),('8902','2013-05-29','13:55:00',3.78),('8902','2013-05-29','14:00:00',7),('8902','2013-05-29','14:05:00',9.48),('8902','2013-05-29','14:10:00',6.3),('8902','2013-05-29','14:15:00',9.23),('8902','2013-05-29','14:20:00',7.23),('8902','2013-05-29','14:25:00',7.1),('8902','2013-05-29','14:30:00',8.66),('8902','2013-05-29','14:35:00',7.24),('8902','2013-05-29','14:40:00',9.01),('8902','2013-05-29','14:45:00',8.91),('8902','2013-05-29','14:50:00',8.92),('8902','2013-05-29','14:55:00',8.49),('8902','2013-05-29','15:00:00',8.33),('8902','2013-05-29','15:05:00',7.81),('8902','2013-05-29','15:10:00',3.7),('8902','2013-05-29','15:15:00',8.73),('8902','2013-05-29','15:20:00',8.64),('8902','2013-05-29','15:25:00',8.38),('8902','2013-05-29','15:30:00',7.71),('8902','2013-05-29','15:35:00',6.49),('8902','2013-05-29','15:40:00',8.83),('8902','2013-05-29','15:45:00',8.67),('8902','2013-05-29','15:50:00',4.85),('8902','2013-05-29','15:55:00',5.92),('8902','2013-05-29','16:00:00',8.49),('8902','2013-05-29','16:05:00',7.27),('8902','2013-05-29','16:10:00',7.78),('8902','2013-05-29','16:15:00',7.36),('8902','2013-05-29','16:20:00',6.77),('8902','2013-05-29','16:25:00',4.79),('8902','2013-05-29','16:30:00',4.21),('8902','2013-05-29','16:35:00',4.23),('8902','2013-05-29','16:40:00',2.87),('8902','2013-05-29','16:45:00',4.72),('8902','2013-05-29','16:50:00',5.12),('8902','2013-05-29','16:55:00',4.89),('8902','2013-05-29','17:00:00',4.08),('8902','2013-05-29','17:05:00',3.9),('8902','2013-05-29','17:10:00',1.5),('8902','2013-05-29','17:15:00',1.83),('8902','2013-05-29','17:20:00',2),('8902','2013-05-29','17:25:00',2.07),('8902','2013-05-29','17:30:00',1.96),('8902','2013-05-29','17:35:00',1.29),('8902','2013-05-29','17:55:00',1.02),('8902','2013-05-29','18:00:00',1.68),('8902','2013-05-29','18:05:00',1.93),('8902','2013-05-29','18:10:00',1.77),('8902','2013-05-29','18:15:00',1.4),('8902','2013-05-29','18:20:00',1.26),('8902','2013-05-29','18:25:00',1.37),('8902','2013-05-29','18:30:00',1.54),('8902','2013-05-29','18:35:00',2.2),('8902','2013-05-29','18:40:00',2.27),('8902','2013-05-29','18:45:00',2.37),('8902','2013-05-29','18:50:00',2.41),('8902','2013-05-29','18:55:00',1.22),('8902','2013-05-29','19:00:00',1.07),('8902','2013-05-28','07:20:00',1.04),('8902','2013-05-28','07:25:00',1.19),('8902','2013-05-28','07:30:00',1.34),('8902','2013-05-28','07:35:00',1.52),('8902','2013-05-28','07:40:00',1.68),('8902','2013-05-28','07:45:00',1.84),('8902','2013-05-28','07:50:00',2.01),('8902','2013-05-28','07:55:00',2.18),('8902','2013-05-28','08:00:00',2.36),('8902','2013-05-28','08:05:00',2.53),('8902','2013-05-28','08:10:00',2.72),('8902','2013-05-28','08:15:00',2.9),('8902','2013-05-28','08:20:00',3.05),('8902','2013-05-28','08:25:00',3.22),('8902','2013-05-28','08:30:00',3.4),('8902','2013-05-28','08:35:00',3.58),('8902','2013-05-28','08:40:00',3.76),('8902','2013-05-28','08:45:00',3.93),('8902','2013-05-28','08:50:00',4.09),('8902','2013-05-28','08:55:00',4.26),('8902','2013-05-28','09:00:00',4.43),('8902','2013-05-28','09:05:00',4.58),('8902','2013-05-28','09:10:00',4.74),('8902','2013-05-28','09:15:00',4.88),('8902','2013-05-28','09:20:00',5.01),('8902','2013-05-28','09:25:00',5.15),('8902','2013-05-28','09:30:00',5.28),('8902','2013-05-28','09:35:00',5.41),('8902','2013-05-28','09:40:00',5.61),('8902','2013-05-28','09:45:00',5.75),('8902','2013-05-28','09:50:00',5.9),('8902','2013-05-28','09:55:00',6.03),('8902','2013-05-28','10:00:00',6.12),('8902','2013-05-28','10:05:00',6.25),('8902','2013-05-28','10:10:00',6.35),('8902','2013-05-28','10:15:00',6.47),('8902','2013-05-28','10:20:00',6.61),('8902','2013-05-28','10:25:00',6.73),('8902','2013-05-28','10:30:00',6.85),('8902','2013-05-28','10:35:00',6.98),('8902','2013-05-28','10:40:00',7.1),('8902','2013-05-28','10:45:00',7.19),('8902','2013-05-28','10:50:00',7.3),('8902','2013-05-28','10:55:00',7.39),('8902','2013-05-28','11:00:00',7.5),('8902','2013-05-28','11:05:00',6.69),('8902','2013-05-28','11:10:00',7.82),('8902','2013-05-28','11:15:00',5.29),('8902','2013-05-28','11:20:00',8.25),('8902','2013-05-28','11:25:00',8.73),('8902','2013-05-28','11:30:00',7.45),('8902','2013-05-28','11:35:00',8.76),('8902','2013-05-28','11:40:00',8.1),('8902','2013-05-28','11:45:00',7.54),('8902','2013-05-28','11:50:00',5.6),('8902','2013-05-28','11:55:00',7.34),('8902','2013-05-28','12:00:00',7.33),('8902','2013-05-28','12:05:00',5.19),('8902','2013-05-28','12:10:00',6.59),('8902','2013-05-28','12:15:00',7.72),('8902','2013-05-28','12:20:00',6.46),('8902','2013-05-28','12:25:00',8.89),('8902','2013-05-28','12:30:00',8.73),('8902','2013-05-28','12:35:00',8.53),('8902','2013-05-28','12:40:00',8.71),('8902','2013-05-28','12:45:00',7.55),('8902','2013-05-28','12:50:00',8.15),('8902','2013-05-28','12:55:00',8.41),('8902','2013-05-28','13:00:00',8.72),('8902','2013-05-28','13:05:00',8.24),('8902','2013-05-28','13:10:00',7.75),('8902','2013-05-28','13:15:00',8.28),('8902','2013-05-28','13:20:00',7.38),('8902','2013-05-28','13:25:00',9.3),('8902','2013-05-28','13:30:00',9.1),('8902','2013-05-28','13:35:00',8.45),('8902','2013-05-28','13:40:00',9.33),('8902','2013-05-28','13:45:00',8.27),('8902','2013-05-28','13:50:00',7.38),('8902','2013-05-28','13:55:00',7.4),('8902','2013-05-28','14:00:00',8.66),('8902','2013-05-28','14:05:00',8.62),('8902','2013-05-28','14:10:00',8.3),('8902','2013-05-28','14:15:00',8.61),('8902','2013-05-28','14:20:00',8.61),('8902','2013-05-28','14:25:00',8.5),('8902','2013-05-28','14:30:00',8.63),('8902','2013-05-28','14:35:00',5.53),('8902','2013-05-28','14:40:00',7.89),('8902','2013-05-28','14:45:00',8.74),('8902','2013-05-28','14:50:00',8.79),('8902','2013-05-28','14:55:00',8.4),('8902','2013-05-28','15:00:00',7.29),('8902','2013-05-28','15:05:00',8.63),('8902','2013-05-28','15:10:00',7.52),('8902','2013-05-28','15:15:00',4.45),('8902','2013-05-28','15:20:00',5.91),('8902','2013-05-28','15:25:00',5.93),('8902','2013-05-28','15:30:00',5.32),('8902','2013-05-28','15:35:00',5.68),('8902','2013-05-28','15:40:00',4.92),('8902','2013-05-28','15:45:00',6),('8902','2013-05-28','15:50:00',6.01),('8902','2013-05-28','15:55:00',5.81),('8902','2013-05-28','16:00:00',5.01),('8902','2013-05-28','16:05:00',5.18),('8902','2013-05-28','16:10:00',4.26),('8902','2013-05-28','16:15:00',3.95),('8902','2013-05-28','16:20:00',3.92),('8902','2013-05-28','16:25:00',3.8),('8902','2013-05-28','16:30:00',3.6),('8902','2013-05-28','16:35:00',3.44),('8902','2013-05-28','16:40:00',3.83),('8902','2013-05-28','16:45:00',3.56),('8902','2013-05-28','16:50:00',2.77),('8902','2013-05-28','16:55:00',2.73),('8902','2013-05-28','17:00:00',2.63),('8902','2013-05-28','17:05:00',1.31),('8902','2013-05-28','17:25:00',1.09),('8902','2013-05-28','17:30:00',1.31),('8902','2013-05-28','17:35:00',1.94),('8902','2013-05-28','17:40:00',2.76),('8902','2013-05-28','17:45:00',2.12),('8902','2013-05-28','17:50:00',1.6),('8902','2013-05-28','17:55:00',1.25),('8902','2013-05-28','18:00:00',1.5),('8902','2013-05-28','18:05:00',1.75),('8902','2013-05-28','18:10:00',1.91),('8902','2013-05-28','18:15:00',3.26),('8902','2013-05-28','18:20:00',2.91),('8902','2013-05-28','19:05:00',1.04),('8902','2013-05-28','19:10:00',1.05),('8902','2013-05-28','19:15:00',1.09),('8902','2013-05-27','07:10:00',1.01),('8902','2013-05-27','07:15:00',1.34),('8902','2013-05-27','07:20:00',1.61),('8902','2013-05-27','07:25:00',1.71),('8902','2013-05-27','07:30:00',1.47),('8902','2013-05-27','07:35:00',1.41),('8902','2013-05-27','07:40:00',1.74),('8902','2013-05-27','07:45:00',1.92),('8902','2013-05-27','07:50:00',1.9),('8902','2013-05-27','07:55:00',1.98),('8902','2013-05-27','08:00:00',2.01),('8902','2013-05-27','08:05:00',2.15),('8902','2013-05-27','08:10:00',2.44),('8902','2013-05-27','08:15:00',2.81),('8902','2013-05-27','08:20:00',3.1),('8902','2013-05-27','08:25:00',2.89),('8902','2013-05-27','08:30:00',3.1),('8902','2013-05-27','08:35:00',2.96),('8902','2013-05-27','08:40:00',2.68),('8902','2013-05-27','08:45:00',2.52),('8902','2013-05-27','08:50:00',2.85),('8902','2013-05-27','08:55:00',2.76),('8902','2013-05-27','09:00:00',3.11),('8902','2013-05-27','09:05:00',3.24),('8902','2013-05-27','09:10:00',3.01),('8902','2013-05-27','09:15:00',2.84),('8902','2013-05-27','09:20:00',3.29),('8902','2013-05-27','09:25:00',3.83),('8902','2013-05-27','09:30:00',4.09),('8902','2013-05-27','09:35:00',4.27),('8902','2013-05-27','09:40:00',4.1),('8902','2013-05-27','09:45:00',3.76),('8902','2013-05-27','09:50:00',3.84),('8902','2013-05-27','09:55:00',4.26),('8902','2013-05-27','10:00:00',3.94),('8902','2013-05-27','10:05:00',4.17),('8902','2013-05-27','10:10:00',4.64),('8902','2013-05-27','10:15:00',4.79),('8902','2013-05-27','10:20:00',5.12),('8902','2013-05-27','10:25:00',4.94),('8902','2013-05-27','10:30:00',5.51),('8902','2013-05-27','10:35:00',5.63),('8902','2013-05-27','10:40:00',5.01),('8902','2013-05-27','10:45:00',4.84),('8902','2013-05-27','10:50:00',5.29),('8902','2013-05-27','10:55:00',4.48),('8902','2013-05-27','11:00:00',4.47),('8902','2013-05-27','11:05:00',4.4),('8902','2013-05-27','11:10:00',4.93),('8902','2013-05-27','11:15:00',3.62),('8902','2013-05-27','11:20:00',4.38),('8902','2013-05-27','11:25:00',3.6),('8902','2013-05-27','11:30:00',6.65),('8902','2013-05-27','11:35:00',5.45),('8902','2013-05-27','11:40:00',7.29),('8902','2013-05-27','11:45:00',6.82),('8902','2013-05-27','11:50:00',2.19),('8902','2013-05-27','11:55:00',2.84),('8902','2013-05-27','12:00:00',2.99),('8902','2013-05-27','12:05:00',3.46),('8902','2013-05-27','12:10:00',5.72),('8902','2013-05-27','12:15:00',5.3),('8902','2013-05-27','12:20:00',4.39),('8902','2013-05-27','12:25:00',4.53),('8902','2013-05-27','12:30:00',5.09),('8902','2013-05-27','12:35:00',4.88),('8902','2013-05-27','12:40:00',4.96),('8902','2013-05-27','12:45:00',5.68),('8902','2013-05-27','12:50:00',5.06),('8902','2013-05-27','12:55:00',5.03),('8902','2013-05-27','13:00:00',5.22),('8902','2013-05-27','13:05:00',5.53),('8902','2013-05-27','13:10:00',5.77),('8902','2013-05-27','13:15:00',5.56),('8902','2013-05-27','13:20:00',6.44),('8902','2013-05-27','13:25:00',3.59),('8902','2013-05-27','13:30:00',4.09),('8902','2013-05-27','13:35:00',3.41),('8902','2013-05-27','13:40:00',3.69),('8902','2013-05-27','13:45:00',3.63),('8902','2013-05-27','13:50:00',5.61),('8902','2013-05-27','13:55:00',5.55),('8902','2013-05-27','14:00:00',4.96),('8902','2013-05-27','14:05:00',5.21),('8902','2013-05-27','14:10:00',7.3),('8902','2013-05-27','14:15:00',7.55),('8902','2013-05-27','14:20:00',4.87),('8902','2013-05-27','14:25:00',5.5),('8902','2013-05-27','14:30:00',6.38),('8902','2013-05-27','14:35:00',5.94),('8902','2013-05-27','14:40:00',6.52),('8902','2013-05-27','14:45:00',7.27),('8902','2013-05-27','14:50:00',5.3),('8902','2013-05-27','14:55:00',4.6),('8902','2013-05-27','15:00:00',4.35),('8902','2013-05-27','15:05:00',7.42),('8902','2013-05-27','15:10:00',3.21),('8902','2013-05-27','15:15:00',5.39),('8902','2013-05-27','15:20:00',6.25),('8902','2013-05-27','15:25:00',3.96),('8902','2013-05-27','15:30:00',2.9),('8902','2013-05-27','15:35:00',2.96),('8902','2013-05-27','15:40:00',5.38),('8902','2013-05-27','15:45:00',7.38),('8902','2013-05-27','15:50:00',6.05),('8902','2013-05-27','15:55:00',4.63),('8902','2013-05-27','16:00:00',3.41),('8902','2013-05-27','16:05:00',2.59),('8902','2013-05-27','16:10:00',2.91),('8902','2013-05-27','16:15:00',2.82),('8902','2013-05-27','16:20:00',4.36),('8902','2013-05-27','16:25:00',4.47),('8902','2013-05-27','16:30:00',4.71),('8902','2013-05-27','16:35:00',6.01),('8902','2013-05-27','16:40:00',5.62),('8902','2013-05-27','16:45:00',5.37),('8902','2013-05-27','16:50:00',5.11),('8902','2013-05-27','16:55:00',5.07),('8902','2013-05-27','17:00:00',5.01),('8902','2013-05-27','17:05:00',4.89),('8902','2013-05-27','17:10:00',4.71),('8902','2013-05-27','17:15:00',4.57),('8902','2013-05-27','17:20:00',4.4),('8902','2013-05-27','17:25:00',4.21),('8902','2013-05-27','17:30:00',4.08),('8902','2013-05-27','17:35:00',3.86),('8902','2013-05-27','17:40:00',2.86),('8902','2013-05-27','17:45:00',3.54),('8902','2013-05-27','17:50:00',3.33),('8902','2013-05-27','17:55:00',3.18),('8902','2013-05-27','18:00:00',3.2),('8902','2013-05-27','18:05:00',2.91),('8902','2013-05-27','18:10:00',2.79),('8902','2013-05-27','18:15:00',1.29),('8902','2013-05-27','18:30:00',1.2),('8902','2013-05-27','18:35:00',1.9),('8902','2013-05-27','18:40:00',1.75),('8902','2013-05-27','18:45:00',1.58),('8902','2013-05-27','18:50:00',1.4),('8902','2013-05-27','18:55:00',1.28),('8902','2013-05-27','19:00:00',1.12),('8902','2013-05-26','07:25:00',1.26),('8902','2013-05-26','07:30:00',1.42),('8902','2013-05-26','07:35:00',1.63),('8902','2013-05-26','07:40:00',1.8),('8902','2013-05-26','07:45:00',1.85),('8902','2013-05-26','07:50:00',1.97),('8902','2013-05-26','07:55:00',1.33),('8902','2013-05-26','08:00:00',1.96),('8902','2013-05-26','08:05:00',2.5),('8902','2013-05-26','08:10:00',3.07),('8902','2013-05-26','08:15:00',2.74),('8902','2013-05-26','08:20:00',2.87),('8902','2013-05-26','08:25:00',2.7),('8902','2013-05-26','08:30:00',3.53),('8902','2013-05-26','08:35:00',3.69),('8902','2013-05-26','08:40:00',3.88),('8902','2013-05-26','08:45:00',4.1),('8902','2013-05-26','08:50:00',4.84),('8902','2013-05-26','08:55:00',4.89),('8902','2013-05-26','09:00:00',5.02),('8902','2013-05-26','09:05:00',5.34),('8902','2013-05-26','09:10:00',4.86),('8902','2013-05-26','09:15:00',4.44),('8902','2013-05-26','09:20:00',5.29),('8902','2013-05-26','09:25:00',2.14),('8902','2013-05-26','09:30:00',5.47),('8902','2013-05-26','09:35:00',5.77),('8902','2013-05-26','09:40:00',5.88),('8902','2013-05-26','09:45:00',6.03),('8902','2013-05-26','09:50:00',5.89),('8902','2013-05-26','09:55:00',6.62),('8902','2013-05-26','10:00:00',6.66),('8902','2013-05-26','10:05:00',6.68),('8902','2013-05-26','10:10:00',6.75),('8902','2013-05-26','10:15:00',6.93),('8902','2013-05-26','10:20:00',6.5),('8902','2013-05-26','10:25:00',3.41),('8902','2013-05-26','10:30:00',6.52),('8902','2013-05-26','10:35:00',3.27),('8902','2013-05-26','10:40:00',2.92),('8902','2013-05-26','10:45:00',5.45),('8902','2013-05-26','10:50:00',5.32),('8902','2013-05-26','10:55:00',4.08),('8902','2013-05-26','11:00:00',5.23),('8902','2013-05-26','11:05:00',8.97),('8902','2013-05-26','11:10:00',7.79),('8902','2013-05-26','11:15:00',5.3),('8902','2013-05-26','11:20:00',4.81),('8902','2013-05-26','11:25:00',9.59),('8902','2013-05-26','11:30:00',4),('8902','2013-05-26','11:35:00',5.51),('8902','2013-05-26','11:40:00',5.34),('8902','2013-05-26','11:45:00',6.98),('8902','2013-05-26','11:50:00',4.47),('8902','2013-05-26','11:55:00',5.11),('8902','2013-05-26','12:00:00',8.12),('8902','2013-05-26','12:05:00',6.36),('8902','2013-05-26','12:10:00',6.66),('8902','2013-05-26','12:15:00',8.82),('8902','2013-05-26','12:20:00',8.08),('8902','2013-05-26','12:25:00',9.43),('8902','2013-05-26','12:30:00',8.79),('8902','2013-05-26','12:35:00',7.29),('8902','2013-05-26','12:40:00',7.87),('8902','2013-05-26','12:45:00',9.7),('8902','2013-05-26','12:50:00',9.18),('8902','2013-05-26','12:55:00',9.28),('8902','2013-05-26','13:00:00',9.35),('8902','2013-05-26','13:05:00',3.04),('8902','2013-05-26','13:10:00',6.98),('8902','2013-05-26','13:15:00',6.22),('8902','2013-05-26','13:20:00',5.43),('8902','2013-05-26','13:25:00',9.18),('8902','2013-05-26','13:30:00',8.96),('8902','2013-05-26','13:35:00',7.34),('8902','2013-05-26','13:40:00',9.12),('8902','2013-05-26','13:45:00',9.26),('8902','2013-05-26','13:50:00',6.75),('8902','2013-05-26','13:55:00',6.32),('8902','2013-05-26','14:00:00',8.59),('8902','2013-05-26','14:05:00',8.8),('8902','2013-05-26','14:10:00',8),('8902','2013-05-26','14:15:00',7.38),('8902','2013-05-26','14:20:00',6.1),('8902','2013-05-26','14:25:00',8.23),('8902','2013-05-26','14:30:00',5.8),('8902','2013-05-26','14:35:00',8.41),('8902','2013-05-26','14:40:00',3.32),('8902','2013-05-26','14:45:00',8.38),('8902','2013-05-26','14:50:00',8.91),('8902','2013-05-26','14:55:00',7.35),('8902','2013-05-26','15:00:00',5.62),('8902','2013-05-26','15:05:00',4.95),('8902','2013-05-26','15:10:00',8.3),('8902','2013-05-26','15:15:00',5.75),('8902','2013-05-26','15:20:00',6.91),('8902','2013-05-26','15:25:00',6.52),('8902','2013-05-26','15:30:00',6.96),('8902','2013-05-26','15:35:00',8.08),('8902','2013-05-26','15:40:00',6.59),('8902','2013-05-26','15:45:00',5.94),('8902','2013-05-26','15:50:00',7.55),('8902','2013-05-26','15:55:00',4.96),('8902','2013-05-26','16:00:00',5.92),('8902','2013-05-26','16:05:00',4.34),('8902','2013-05-26','16:10:00',5.22),('8902','2013-05-26','16:15:00',4.52),('8902','2013-05-26','16:20:00',7.36),('8902','2013-05-26','16:25:00',7.16),('8902','2013-05-26','16:30:00',6.43),('8902','2013-05-26','16:35:00',5.94),('8902','2013-05-26','16:40:00',2.71),('8902','2013-05-26','16:45:00',2.37),('8902','2013-05-26','16:50:00',2.4),('8902','2013-05-26','16:55:00',2.57),('8902','2013-05-26','17:00:00',2.69),('8902','2013-05-26','17:05:00',2.73),('8902','2013-05-26','17:10:00',3.36),('8902','2013-05-26','17:15:00',2.8),('8902','2013-05-26','17:20:00',2.39),('8902','2013-05-26','17:25:00',2.18),('8902','2013-05-26','17:30:00',2.13),('8902','2013-05-26','17:35:00',1.99),('8902','2013-05-26','17:40:00',1.84),('8902','2013-05-26','17:45:00',1.73),('8902','2013-05-26','17:50:00',1.66),('8902','2013-05-26','17:55:00',1.69),('8902','2013-05-26','18:00:00',1.69),('8902','2013-05-26','18:05:00',1.52),('8902','2013-05-26','18:10:00',1.56),('8902','2013-05-26','18:15:00',1.74),('8902','2013-05-26','18:20:00',2.19),('8902','2013-05-26','18:25:00',2.98),('8902','2013-05-26','18:30:00',2.41),('8902','2013-05-26','18:35:00',1.76),('8902','2013-05-26','18:40:00',1.1),('8902','2013-05-26','18:45:00',1.51),('8902','2013-05-26','18:50:00',1.23),('8902','2013-05-26','18:55:00',1.63),('8902','2013-05-26','19:00:00',1.72),('8902','2013-05-26','19:05:00',1.62),('8902','2013-05-26','19:10:00',1.36),('8902','2013-05-26','19:15:00',1.03),('8902','2013-05-25','07:20:00',1.55),('8902','2013-05-25','07:25:00',1.19),('8902','2013-05-25','07:35:00',1.49),('8902','2013-05-25','07:40:00',1.82),('8902','2013-05-25','07:45:00',2.12),('8902','2013-05-25','07:50:00',3.2),('8902','2013-05-25','07:55:00',1.52),('8902','2013-05-25','08:05:00',3.31),('8902','2013-05-25','08:10:00',3.3),('8902','2013-05-25','08:15:00',1.33),('8902','2013-05-25','08:20:00',1.57),('8902','2013-05-25','08:25:00',1.92),('8902','2013-05-25','08:30:00',3.81),('8902','2013-05-25','08:35:00',3.26),('8902','2013-05-25','08:40:00',3.69),('8902','2013-05-25','08:45:00',4.32),('8902','2013-05-25','08:50:00',5.14),('8902','2013-05-25','08:55:00',1.95),('8902','2013-05-25','09:00:00',3.32),('8902','2013-05-25','09:05:00',1.54),('8902','2013-05-25','09:10:00',3.5),('8902','2013-05-25','09:15:00',3.49),('8902','2013-05-25','09:20:00',1.53),('8902','2013-05-25','09:25:00',2.72),('8902','2013-05-25','09:30:00',1.55),('8902','2013-05-25','09:35:00',1.35),('8902','2013-05-25','09:40:00',1.69),('8902','2013-05-25','09:45:00',4.32),('8902','2013-05-25','09:50:00',1.37),('8902','2013-05-25','09:55:00',1.81),('8902','2013-05-25','10:00:00',3.17),('8902','2013-05-25','10:05:00',4.76),('8902','2013-05-25','10:10:00',7.34),('8902','2013-05-25','10:15:00',5.34),('8902','2013-05-25','10:20:00',5.49),('8902','2013-05-25','10:25:00',5.02),('8902','2013-05-25','10:30:00',6.77),('8902','2013-05-25','10:35:00',6.96),('8902','2013-05-25','10:40:00',7.44),('8902','2013-05-25','10:45:00',7.57),('8902','2013-05-25','10:50:00',7.72),('8902','2013-05-25','10:55:00',7.44),('8902','2013-05-25','11:00:00',7.7),('8902','2013-05-25','11:05:00',7.98),('8902','2013-05-25','11:10:00',8.04),('8902','2013-05-25','11:15:00',8.07),('8902','2013-05-25','11:20:00',8.15),('8902','2013-05-25','11:25:00',8.24),('8902','2013-05-25','11:30:00',8.32),('8902','2013-05-25','11:35:00',8.21),('8902','2013-05-25','11:40:00',8.31),('8902','2013-05-25','11:45:00',8.71),('8902','2013-05-25','11:50:00',8.53),('8902','2013-05-25','11:55:00',8.88),('8902','2013-05-25','12:00:00',8.65),('8902','2013-05-25','12:05:00',8.74),('8902','2013-05-25','12:10:00',8.09),('8902','2013-05-25','12:15:00',7.86),('8902','2013-05-25','12:20:00',6.17),('8902','2013-05-25','12:25:00',8.15),('8902','2013-05-25','12:30:00',9.26),('8902','2013-05-25','12:35:00',9.15),('8902','2013-05-25','12:40:00',8.56),('8902','2013-05-25','12:45:00',6.98),('8902','2013-05-25','12:50:00',9.2),('8902','2013-05-25','12:55:00',9.1),('8902','2013-05-25','13:00:00',8.93),('8902','2013-05-25','13:05:00',8.05),('8902','2013-05-25','13:10:00',9.03),('8902','2013-05-25','13:15:00',8.89),('8902','2013-05-25','13:20:00',9.37),('8902','2013-05-25','13:25:00',9.12),('8902','2013-05-25','13:30:00',9.23),('8902','2013-05-25','13:35:00',9.2),('8902','2013-05-25','13:40:00',9.01),('8902','2013-05-25','13:45:00',9.08),('8902','2013-05-25','13:50:00',8.94),('8902','2013-05-25','13:55:00',8.76),('8902','2013-05-25','14:00:00',8.89),('8902','2013-05-25','14:05:00',8.87),('8902','2013-05-25','14:10:00',8.77),('8902','2013-05-25','14:15:00',8.73),('8902','2013-05-25','14:20:00',8.74),('8902','2013-05-25','14:25:00',8.64),('8902','2013-05-25','14:30:00',8.66),('8902','2013-05-25','14:35:00',8.57),('8902','2013-05-25','14:40:00',8.51),('8902','2013-05-25','14:45:00',8.44),('8902','2013-05-25','14:50:00',8.39),('8902','2013-05-25','14:55:00',8.31),('8902','2013-05-25','15:00:00',8.24),('8902','2013-05-25','15:05:00',8.26),('8902','2013-05-25','15:10:00',8.17),('8902','2013-05-25','15:15:00',8.13),('8902','2013-05-25','15:20:00',8.04),('8902','2013-05-25','15:25:00',7.95),('8902','2013-05-25','15:30:00',7.9),('8902','2013-05-25','15:35:00',7.8),('8902','2013-05-25','15:40:00',7.72),('8902','2013-05-25','15:45:00',7.58),('8902','2013-05-25','15:50:00',7.46),('8902','2013-05-25','15:55:00',7.36),('8902','2013-05-25','16:00:00',7.28),('8902','2013-05-25','16:05:00',7.16),('8902','2013-05-25','16:10:00',7.07),('8902','2013-05-25','16:15:00',6.93),('8902','2013-05-25','16:20:00',6.8),('8902','2013-05-25','16:25:00',6.68),('8902','2013-05-25','16:30:00',6.45),('8902','2013-05-25','16:35:00',6.36),('8902','2013-05-25','16:40:00',6.22),('8902','2013-05-25','16:45:00',6.1),('8902','2013-05-25','16:50:00',5.87),('8902','2013-05-25','16:55:00',5.8),('8902','2013-05-25','17:00:00',5.65),('8902','2013-05-25','17:05:00',5.51),('8902','2013-05-25','17:10:00',5.32),('8902','2013-05-25','17:15:00',5.1),('8902','2013-05-25','17:20:00',4.96),('8902','2013-05-25','17:25:00',4.81),('8902','2013-05-25','17:30:00',4.65),('8902','2013-05-25','17:35:00',4.4),('8902','2013-05-25','17:40:00',4.28),('8902','2013-05-25','17:45:00',4.1),('8902','2013-05-25','17:50:00',3.78),('8902','2013-05-25','17:55:00',3.52),('8902','2013-05-25','18:00:00',3.53),('8902','2013-05-25','18:05:00',3.31),('8902','2013-05-25','18:10:00',3.15),('8902','2013-05-25','18:15:00',2.95),('8902','2013-05-25','18:20:00',2.77),('8902','2013-05-25','18:25:00',2.55),('8902','2013-05-25','18:30:00',2.37),('8902','2013-05-25','18:35:00',2.18),('8902','2013-05-25','18:40:00',1.95),('8902','2013-05-25','18:45:00',1.75),('8902','2013-05-25','18:50:00',1.59),('8902','2013-05-25','18:55:00',1.44),('8902','2013-05-25','19:00:00',1.27),('8902','2013-05-25','19:05:00',1.08),('8902','2013-05-24','07:15:00',1.5),('8902','2013-05-24','07:20:00',1.46),('8902','2013-05-24','07:30:00',1.5),('8902','2013-05-24','07:35:00',2.31),('8902','2013-05-24','07:40:00',2.28),('8902','2013-05-24','07:45:00',1.07),('8902','2013-05-24','07:50:00',1.06),('8902','2013-05-24','07:55:00',2.46),('8902','2013-05-24','08:00:00',3.13),('8902','2013-05-24','08:05:00',3.61),('8902','2013-05-24','08:10:00',2.86),('8902','2013-05-24','08:15:00',1.23),('8902','2013-05-24','08:20:00',2.3),('8902','2013-05-24','08:25:00',3.9),('8902','2013-05-24','08:30:00',4.87),('8902','2013-05-24','08:35:00',2.86),('8902','2013-05-24','08:40:00',3.08),('8902','2013-05-24','08:45:00',2.45),('8902','2013-05-24','08:50:00',3.22),('8902','2013-05-24','08:55:00',3.27),('8902','2013-05-24','09:00:00',2.49),('8902','2013-05-24','09:05:00',5.71),('8902','2013-05-24','09:10:00',5.43),('8902','2013-05-24','09:15:00',6.53),('8902','2013-05-24','09:20:00',3.35),('8902','2013-05-24','09:25:00',2.98),('8902','2013-05-24','09:30:00',2.03),('8902','2013-05-24','09:35:00',4.24),('8902','2013-05-24','09:40:00',7.17),('8902','2013-05-24','09:45:00',5.19),('8902','2013-05-24','09:50:00',6.15),('8902','2013-05-24','09:55:00',4.61),('8902','2013-05-24','10:00:00',1.93),('8902','2013-05-24','10:05:00',1.35),('8902','2013-05-24','10:10:00',1.89),('8902','2013-05-24','10:15:00',2.1),('8902','2013-05-24','10:25:00',1.64),('8902','2013-05-24','10:30:00',1.92),('8902','2013-05-24','10:35:00',1.63),('8902','2013-05-24','10:40:00',2.74),('8902','2013-05-24','10:45:00',2.8),('8902','2013-05-24','10:50:00',2.68),('8902','2013-05-24','10:55:00',1.8),('8902','2013-05-24','11:00:00',2.03),('8902','2013-05-24','11:05:00',4.04),('8902','2013-05-24','11:10:00',8.37),('8902','2013-05-24','11:15:00',7.35),('8902','2013-05-24','11:20:00',5.49),('8902','2013-05-24','11:25:00',1.95),('8902','2013-05-24','11:35:00',1.84),('8902','2013-05-24','11:40:00',3.27),('8902','2013-05-24','11:45:00',4.4),('8902','2013-05-24','11:50:00',3.4),('8902','2013-05-24','11:55:00',3.49),('8902','2013-05-24','12:00:00',2.37),('8902','2013-05-24','12:05:00',2.28),('8902','2013-05-24','12:10:00',3.08),('8902','2013-05-24','12:15:00',1.98),('8902','2013-05-24','12:20:00',2.33),('8902','2013-05-24','12:25:00',3.46),('8902','2013-05-24','12:30:00',3.08),('8902','2013-05-24','12:35:00',2.29),('8902','2013-05-24','12:40:00',3.01),('8902','2013-05-24','12:45:00',3.67),('8902','2013-05-24','12:50:00',2.74),('8902','2013-05-24','12:55:00',4.04),('8902','2013-05-24','13:00:00',2.19),('8902','2013-05-24','13:05:00',2.84),('8902','2013-05-24','13:10:00',2.83),('8902','2013-05-24','13:15:00',3.25),('8902','2013-05-24','13:20:00',3.95),('8902','2013-05-24','13:25:00',5.09),('8902','2013-05-24','13:30:00',4.06),('8902','2013-05-24','13:35:00',2.46),('8902','2013-05-24','13:40:00',3.8),('8902','2013-05-24','13:45:00',3.6),('8902','2013-05-24','13:50:00',4.84),('8902','2013-05-24','13:55:00',5.59),('8902','2013-05-24','14:00:00',8.13),('8902','2013-05-24','14:05:00',9.28),('8902','2013-05-24','14:10:00',8.89),('8902','2013-05-24','14:15:00',8.77),('8902','2013-05-24','14:20:00',6.72),('8902','2013-05-24','14:25:00',7.61),('8902','2013-05-24','14:30:00',7.18),('8902','2013-05-24','14:35:00',4.08),('8902','2013-05-24','14:40:00',2.8),('8902','2013-05-24','14:45:00',3.62),('8902','2013-05-24','14:50:00',3.7),('8902','2013-05-24','14:55:00',3.47),('8902','2013-05-24','15:00:00',5.79),('8902','2013-05-24','15:05:00',5.9),('8902','2013-05-24','15:10:00',3.62),('8902','2013-05-24','15:15:00',5.68),('8902','2013-05-24','15:20:00',2.48),('8902','2013-05-24','15:25:00',4.97),('8902','2013-05-24','15:30:00',5.31),('8902','2013-05-24','15:35:00',8.55),('8902','2013-05-24','15:40:00',7.36),('8902','2013-05-24','15:45:00',7.28),('8902','2013-05-24','15:50:00',8.31),('8902','2013-05-24','15:55:00',8.47),('8902','2013-05-24','16:00:00',6.16),('8902','2013-05-24','16:05:00',2.88),('8902','2013-05-24','16:10:00',5.65),('8902','2013-05-24','16:15:00',3.96),('8902','2013-05-24','16:20:00',3.05),('8902','2013-05-24','16:25:00',3.33),('8902','2013-05-24','16:30:00',4.89),('8902','2013-05-24','16:35:00',4.93),('8902','2013-05-24','16:40:00',5.47),('8902','2013-05-24','16:45:00',5.79),('8902','2013-05-24','16:50:00',4.55),('8902','2013-05-24','16:55:00',2.13),('8902','2013-05-24','17:00:00',2.39),('8902','2013-05-24','17:05:00',2.28),('8902','2013-05-24','17:10:00',5.95),('8902','2013-05-24','17:15:00',3.7),('8902','2013-05-24','17:20:00',3.49),('8902','2013-05-24','17:25:00',3.97),('8902','2013-05-24','17:30:00',1.17),('8902','2013-05-24','17:35:00',2.9),('8902','2013-05-24','17:40:00',1.91),('8902','2013-05-24','17:45:00',2.43),('8902','2013-05-24','17:50:00',3.22),('8902','2013-05-24','17:55:00',1.34),('8902','2013-05-24','18:00:00',1.63),('8902','2013-05-24','18:05:00',1.59),('8902','2013-05-24','18:10:00',1.72),('8902','2013-05-24','18:15:00',1.39),('8902','2013-05-24','18:20:00',1.63),('8902','2013-05-23','07:00:00',1.06),('8902','2013-05-23','07:05:00',1.1),('8902','2013-05-23','07:40:00',1.09),('8902','2013-05-23','07:50:00',1.01),('8902','2013-05-23','08:00:00',1.31),('8902','2013-05-23','08:05:00',2.81),('8902','2013-05-23','08:10:00',3.39),('8902','2013-05-23','08:15:00',3.23),('8902','2013-05-23','08:20:00',1.82),('8902','2013-05-23','08:25:00',1.41),('8902','2013-05-23','08:30:00',3.48),('8902','2013-05-23','08:35:00',2.76),('8902','2013-05-23','08:40:00',1.01),('8902','2013-05-23','08:45:00',3.15),('8902','2013-05-23','08:50:00',3.84),('8902','2013-05-23','08:55:00',4.45),('8902','2013-05-23','09:00:00',4.79),('8902','2013-05-23','09:05:00',5.54),('8902','2013-05-23','09:10:00',2.35),('8902','2013-05-23','09:15:00',1.18),('8902','2013-05-23','09:20:00',4.15),('8902','2013-05-23','09:25:00',3.25),('8902','2013-05-23','09:30:00',3.33),('8902','2013-05-23','09:35:00',1.42),('8902','2013-05-23','09:40:00',2.73),('8902','2013-05-23','09:45:00',2.19),('8902','2013-05-23','09:50:00',2.88),('8902','2013-05-23','09:55:00',4.4),('8902','2013-05-23','10:00:00',4.96),('8902','2013-05-23','10:05:00',1.57),('8902','2013-05-23','10:10:00',1.28),('8902','2013-05-23','10:20:00',1.74),('8902','2013-05-23','10:25:00',4.2),('8902','2013-05-23','10:30:00',7.73),('8902','2013-05-23','10:35:00',7.24),('8902','2013-05-23','10:40:00',6.07),('8902','2013-05-23','10:45:00',6.68),('8902','2013-05-23','10:50:00',5.01),('8902','2013-05-23','10:55:00',8.17),('8902','2013-05-23','11:00:00',5.88),('8902','2013-05-23','11:05:00',5.87),('8902','2013-05-23','11:10:00',7.58),('8902','2013-05-23','11:15:00',7.03),('8902','2013-05-23','11:20:00',7.97),('8902','2013-05-23','11:25:00',7.79),('8902','2013-05-23','11:30:00',6.02),('8902','2013-05-23','11:35:00',2.41),('8902','2013-05-23','11:40:00',2.18),('8902','2013-05-23','11:45:00',3.03),('8902','2013-05-23','11:50:00',9.43),('8902','2013-05-23','11:55:00',6.22),('8902','2013-05-23','12:00:00',3.43),('8902','2013-05-23','12:05:00',6),('8902','2013-05-23','12:10:00',6.69),('8902','2013-05-23','12:15:00',4.31),('8902','2013-05-23','12:20:00',4),('8902','2013-05-23','12:25:00',5.54),('8902','2013-05-23','12:30:00',7.78),('8902','2013-05-23','12:35:00',3.97),('8902','2013-05-23','12:40:00',5.21),('8902','2013-05-23','12:45:00',7.25),('8902','2013-05-23','12:50:00',5.7),('8902','2013-05-23','12:55:00',4.51),('8902','2013-05-23','13:00:00',4.31),('8902','2013-05-23','13:05:00',3.87),('8902','2013-05-23','13:10:00',4.91),('8902','2013-05-23','13:15:00',5.61),('8902','2013-05-23','13:20:00',6.65),('8902','2013-05-23','13:25:00',5.09),('8902','2013-05-23','13:30:00',3.88),('8902','2013-05-23','13:35:00',5.58),('8902','2013-05-23','13:40:00',5.25),('8902','2013-05-23','13:45:00',2.68),('8902','2013-05-23','13:50:00',2.4),('8902','2013-05-23','13:55:00',7.05),('8902','2013-05-23','14:00:00',4.7),('8902','2013-05-23','14:05:00',4.5),('8902','2013-05-23','14:10:00',2.24),('8902','2013-05-23','14:15:00',6.93),('8902','2013-05-23','14:20:00',6.67),('8902','2013-05-23','14:25:00',7.46),('8902','2013-05-23','14:30:00',5.64),('8902','2013-05-23','14:35:00',6.03),('8902','2013-05-23','14:40:00',5.08),('8902','2013-05-23','14:45:00',5.31),('8902','2013-05-23','14:50:00',2.62),('8902','2013-05-23','14:55:00',3.19),('8902','2013-05-23','15:00:00',4.31),('8902','2013-05-23','15:05:00',7.63),('8902','2013-05-23','15:10:00',5.98),('8902','2013-05-23','15:15:00',6.34),('8902','2013-05-23','15:20:00',7.96),('8902','2013-05-23','15:25:00',6.78),('8902','2013-05-23','15:30:00',6.3),('8902','2013-05-23','15:35:00',5.33),('8902','2013-05-23','15:40:00',5.4),('8902','2013-05-23','15:45:00',7.5),('8902','2013-05-23','15:50:00',7.69),('8902','2013-05-23','15:55:00',9.24),('8902','2013-05-23','16:00:00',4.58),('8902','2013-05-23','16:05:00',3.85),('8902','2013-05-23','16:10:00',3.99),('8902','2013-05-23','16:15:00',5.16),('8902','2013-05-23','16:20:00',3.66),('8902','2013-05-23','16:25:00',4.74),('8902','2013-05-23','16:30:00',6.35),('8902','2013-05-23','16:35:00',2.58),('8902','2013-05-23','16:40:00',1.42),('8902','2013-05-23','16:50:00',2.49),('8902','2013-05-23','16:55:00',4.16),('8902','2013-05-23','17:00:00',2.55),('8902','2013-05-23','17:05:00',1.7),('8902','2013-05-23','17:10:00',1.36),('8902','2013-05-23','17:15:00',1.38),('8902','2013-05-23','17:20:00',1.8),('8902','2013-05-23','17:25:00',1.95),('8902','2013-05-23','17:30:00',2.1),('8902','2013-05-23','17:35:00',2.12),('8902','2013-05-23','17:40:00',1.76),('8902','2013-05-23','17:45:00',1.43),('8902','2013-05-23','17:50:00',1.06),('8902','2013-05-23','18:05:00',1.07),('8902','2013-05-23','18:10:00',1.11),('8902','2013-05-22','07:10:00',1.56),('8902','2013-05-22','07:15:00',1.29),('8902','2013-05-22','07:45:00',1.18),('8902','2013-05-22','07:50:00',1.52),('8902','2013-05-22','07:55:00',1.73),('8902','2013-05-22','08:00:00',2.06),('8902','2013-05-22','08:05:00',2.76),('8902','2013-05-22','08:10:00',2.31),('8902','2013-05-22','08:25:00',1.25),('8902','2013-05-22','08:30:00',2.43),('8902','2013-05-22','08:35:00',4.08),('8902','2013-05-22','08:40:00',3.6),('8902','2013-05-22','08:45:00',3.25),('8902','2013-05-22','08:50:00',2.69),('8902','2013-05-22','08:55:00',1.01),('8902','2013-05-22','09:00:00',4.44),('8902','2013-05-22','09:05:00',3.32),('8902','2013-05-22','09:15:00',1.42),('8902','2013-05-22','09:20:00',2.63),('8902','2013-05-22','09:25:00',5.81),('8902','2013-05-22','09:30:00',6.52),('8902','2013-05-22','09:35:00',4.89),('8902','2013-05-22','09:40:00',4.67),('8902','2013-05-22','09:45:00',4.03),('8902','2013-05-22','09:50:00',6.21),('8902','2013-05-22','09:55:00',3.6),('8902','2013-05-22','10:00:00',2.75),('8902','2013-05-22','10:05:00',5.12),('8902','2013-05-22','10:10:00',6.82),('8902','2013-05-22','10:15:00',5.93),('8902','2013-05-22','10:20:00',5.09),('8902','2013-05-22','10:25:00',6.81),('8902','2013-05-22','10:30:00',7.27),('8902','2013-05-22','10:35:00',6.27),('8902','2013-05-22','10:40:00',6.98),('8902','2013-05-22','10:45:00',7.85),('8902','2013-05-22','10:50:00',7.55),('8902','2013-05-22','10:55:00',8.21),('8902','2013-05-22','11:00:00',6.87),('8902','2013-05-22','11:05:00',6.25),('8902','2013-05-22','11:10:00',4.51),('8902','2013-05-22','11:15:00',3.36),('8902','2013-05-22','11:20:00',3.66),('8902','2013-05-22','11:25:00',4.34),('8902','2013-05-22','11:30:00',6.72),('8902','2013-05-22','11:35:00',7.34),('8902','2013-05-22','11:40:00',8.12),('8902','2013-05-22','11:45:00',3.97),('8902','2013-05-22','11:50:00',8.69),('8902','2013-05-22','11:55:00',9.71),('8902','2013-05-22','12:00:00',8.26),('8902','2013-05-22','12:05:00',8.9),('8902','2013-05-22','12:10:00',9),('8902','2013-05-22','12:15:00',7.94),('8902','2013-05-22','12:20:00',5.42),('8902','2013-05-22','12:25:00',7.91),('8902','2013-05-22','12:30:00',6.24),('8902','2013-05-22','12:35:00',2.92),('8902','2013-05-22','12:40:00',7.11),('8902','2013-05-22','12:45:00',8.09),('8902','2013-05-22','12:50:00',5.97),('8902','2013-05-22','12:55:00',8.23),('8902','2013-05-22','13:00:00',9.61),('8902','2013-05-22','13:05:00',5.35),('8902','2013-05-22','13:10:00',7.73),('8902','2013-05-22','13:15:00',7.2),('8902','2013-05-22','13:20:00',6.93),('8902','2013-05-22','13:25:00',4.15),('8902','2013-05-22','13:30:00',5.13),('8902','2013-05-22','13:35:00',3.95),('8902','2013-05-22','13:40:00',3.55),('8902','2013-05-22','13:45:00',8.41),('8902','2013-05-22','13:50:00',5.31),('8902','2013-05-22','13:55:00',7.27),('8902','2013-05-22','14:00:00',8.34),('8902','2013-05-22','14:05:00',8.49),('8902','2013-05-22','14:10:00',9.8),('8902','2013-05-22','14:15:00',5.62),('8902','2013-05-22','14:20:00',9.51),('8902','2013-05-22','14:25:00',8.83),('8902','2013-05-22','14:30:00',2.89),('8902','2013-05-22','14:35:00',9.25),('8902','2013-05-22','14:40:00',8.12),('8902','2013-05-22','14:45:00',4.82),('8902','2013-05-22','14:50:00',4.59),('8902','2013-05-22','14:55:00',6.01),('8902','2013-05-22','15:00:00',6.61),('8902','2013-05-22','15:05:00',5.22),('8902','2013-05-22','15:10:00',2.78),('8902','2013-05-22','15:15:00',2.62),('8902','2013-05-22','15:20:00',6.45),('8902','2013-05-22','15:25:00',2.55),('8902','2013-05-22','15:30:00',5.09),('8902','2013-05-22','15:35:00',6.12),('8902','2013-05-22','15:40:00',3.9),('8902','2013-05-22','15:45:00',4.94),('8902','2013-05-22','15:50:00',2.31),('8902','2013-05-22','15:55:00',2.61),('8902','2013-05-22','16:00:00',7.3),('8902','2013-05-22','16:05:00',6.88),('8902','2013-05-22','16:10:00',5.28),('8902','2013-05-22','16:15:00',4.76),('8902','2013-05-22','16:20:00',6.4),('8902','2013-05-22','16:25:00',5.82),('8902','2013-05-22','16:30:00',6.48),('8902','2013-05-22','16:35:00',3.75),('8902','2013-05-22','16:40:00',3.55),('8902','2013-05-22','16:45:00',3.11),('8902','2013-05-22','16:50:00',3.4),('8902','2013-05-22','16:55:00',1.37),('8902','2013-05-22','17:05:00',1.64),('8902','2013-05-22','17:10:00',4.43),('8902','2013-05-22','17:15:00',3.61),('8902','2013-05-22','17:20:00',2.77),('8902','2013-05-22','17:25:00',2.01),('8902','2013-05-22','17:30:00',1.98),('8902','2013-05-22','17:35:00',2.42),('8902','2013-05-22','17:40:00',2.09),('8902','2013-05-22','17:45:00',1.94),('8902','2013-05-22','17:50:00',1.66),('8902','2013-05-22','17:55:00',2.12),('8902','2013-05-22','18:00:00',2.47),('8902','2013-05-22','18:05:00',3.92),('8902','2013-05-22','18:10:00',2.2),('8902','2013-05-22','18:45:00',1.54),('8902','2013-05-22','18:50:00',2.04),('8902','2013-05-22','18:55:00',1.69),('8902','2013-05-22','19:00:00',1.29),('8902','2013-05-21','07:25:00',1.15),('8902','2013-05-21','07:30:00',1.13),('8902','2013-05-21','07:35:00',1.08),('8902','2013-05-21','07:40:00',1.25),('8902','2013-05-21','07:45:00',1.37),('8902','2013-05-21','07:50:00',1.66),('8902','2013-05-21','07:55:00',1.85),('8902','2013-05-21','08:00:00',2.11),('8902','2013-05-21','08:05:00',2.58),('8902','2013-05-21','08:10:00',2),('8902','2013-05-21','08:15:00',3.45),('8902','2013-05-21','08:20:00',3.42),('8902','2013-05-21','08:25:00',3.31),('8902','2013-05-21','08:30:00',3.74),('8902','2013-05-21','08:35:00',4.45),('8902','2013-05-21','08:40:00',2.69),('8902','2013-05-21','08:45:00',3.22),('8902','2013-05-21','08:50:00',2.19),('8902','2013-05-21','09:10:00',1.24),('8902','2013-05-21','09:15:00',1.67),('8902','2013-05-21','09:20:00',1.62),('8902','2013-05-21','09:25:00',1.86),('8902','2013-05-21','09:30:00',4.94),('8902','2013-05-21','09:35:00',5.3),('8902','2013-05-21','09:40:00',5.28),('8902','2013-05-21','09:45:00',5.33),('8902','2013-05-21','09:50:00',5.45),('8902','2013-05-21','09:55:00',5.56),('8902','2013-05-21','10:00:00',5.69),('8902','2013-05-21','10:05:00',5.82),('8902','2013-05-21','10:10:00',5.94),('8902','2013-05-21','10:15:00',6.04),('8902','2013-05-21','10:20:00',6.04),('8902','2013-05-21','10:25:00',6.43),('8902','2013-05-21','10:30:00',6.41),('8902','2013-05-21','10:35:00',6.52),('8902','2013-05-21','10:40:00',6.73),('8902','2013-05-21','10:45:00',6.75),('8902','2013-05-21','10:50:00',6.71),('8902','2013-05-21','10:55:00',6.78),('8902','2013-05-21','11:00:00',6.98),('8902','2013-05-21','11:05:00',7.21),('8902','2013-05-21','11:10:00',6.8),('8902','2013-05-21','11:15:00',6.73),('8902','2013-05-21','11:20:00',7.4),('8902','2013-05-21','11:25:00',7.61),('8902','2013-05-21','11:30:00',6.49),('8902','2013-05-21','11:35:00',6.31),('8902','2013-05-21','11:40:00',6.74),('8902','2013-05-21','11:45:00',7.59),('8902','2013-05-21','11:50:00',4.61),('8902','2013-05-21','11:55:00',3.98),('8902','2013-05-21','12:00:00',5.67),('8902','2013-05-21','12:05:00',4.4),('8902','2013-05-21','12:10:00',4.19),('8902','2013-05-21','12:15:00',6.1),('8902','2013-05-21','12:20:00',8.74),('8902','2013-05-21','12:25:00',5.53),('8902','2013-05-21','12:30:00',4.26),('8902','2013-05-21','12:35:00',4.55),('8902','2013-05-21','12:40:00',3.04),('8902','2013-05-21','12:45:00',1.29),('8902','2013-05-21','13:00:00',2.4),('8902','2013-05-21','13:05:00',9.49),('8902','2013-05-21','13:10:00',4.3),('8902','2013-05-21','13:15:00',4.38),('8902','2013-05-21','13:20:00',4.18),('8902','2013-05-21','13:25:00',2.22),('8902','2013-05-21','13:30:00',3.48),('8902','2013-05-21','13:35:00',6.35),('8902','2013-05-21','13:40:00',6.03),('8902','2013-05-21','13:45:00',4.93),('8902','2013-05-21','13:50:00',4.95),('8902','2013-05-21','13:55:00',4.58),('8902','2013-05-21','14:00:00',5.17),('8902','2013-05-21','14:05:00',7.17),('8902','2013-05-21','14:10:00',7.46),('8902','2013-05-21','14:15:00',8.21),('8902','2013-05-21','14:20:00',7.99),('8902','2013-05-21','14:25:00',7.89),('8902','2013-05-21','14:30:00',7.83),('8902','2013-05-21','14:35:00',7.79),('8902','2013-05-21','14:40:00',7.7),('8902','2013-05-21','14:45:00',7.64),('8902','2013-05-21','14:50:00',7.59),('8902','2013-05-21','14:55:00',7.46),('8902','2013-05-21','15:00:00',7.43),('8902','2013-05-21','15:05:00',7.38),('8902','2013-05-21','15:10:00',7.3),('8902','2013-05-21','15:15:00',7.27),('8902','2013-05-21','15:20:00',7.1),('8902','2013-05-21','15:25:00',3.76),('8902','2013-05-21','15:30:00',3.93),('8902','2013-05-21','15:35:00',4.13),('8902','2013-05-21','15:40:00',3.49),('8902','2013-05-21','15:45:00',5.24),('8902','2013-05-21','15:50:00',6.81),('8902','2013-05-21','15:55:00',6.6),('8902','2013-05-21','16:00:00',6.47),('8902','2013-05-21','16:05:00',6.31),('8902','2013-05-21','16:10:00',6.11),('8902','2013-05-21','16:15:00',5.98),('8902','2013-05-21','16:20:00',5.98),('8902','2013-05-21','16:25:00',5.82),('8902','2013-05-21','16:30:00',5.54),('8902','2013-05-21','16:35:00',5.46),('8902','2013-05-21','16:40:00',5.34),('8902','2013-05-21','16:45:00',4.47),('8902','2013-05-21','16:50:00',3.77),('8902','2013-05-21','17:00:00',1.46),('8902','2013-05-21','17:05:00',1.56),('8902','2013-05-21','17:10:00',1.31),('8902','2013-05-21','17:15:00',2.02),('8902','2013-05-21','17:20:00',2.48),('8902','2013-05-21','17:25:00',3.96),('8902','2013-05-21','17:30:00',2.38),('8902','2013-05-21','17:35:00',2.71),('8902','2013-05-21','17:40:00',1.45),('8902','2013-05-21','17:50:00',1.17),('8902','2013-05-21','17:55:00',2.42),('8902','2013-05-21','18:00:00',2.49),('8902','2013-05-21','18:05:00',1.6),('8902','2013-05-21','18:25:00',1.18),('8902','2014-03-31','08:05:00',1.07),('8902','2014-03-31','08:10:00',1.27),('8902','2014-03-31','08:15:00',1.46),('8902','2014-03-31','08:20:00',1.63),('8902','2014-03-31','08:25:00',1.82),('8902','2014-03-31','08:30:00',1.99),('8902','2014-03-31','08:35:00',2.14),('8902','2014-03-31','08:40:00',2.26),('8902','2014-03-31','08:45:00',2.44),('8902','2014-03-31','08:50:00',2.62),('8902','2014-03-31','08:55:00',2.8),('8902','2014-03-31','09:00:00',2.98),('8902','2014-03-31','09:05:00',3.18),('8902','2014-03-31','09:10:00',3.39),('8902','2014-03-31','09:15:00',3.58),('8902','2014-03-31','09:20:00',3.74),('8902','2014-03-31','09:25:00',3.9),('8902','2014-03-31','09:30:00',4.11),('8902','2014-03-31','09:35:00',4.3),('8902','2014-03-31','09:40:00',4.38),('8902','2014-03-31','09:45:00',4.65),('8902','2014-03-31','09:50:00',4.87),('8902','2014-03-31','09:55:00',5.01),('8902','2014-03-31','10:00:00',4.34),('8902','2014-03-31','10:05:00',4.58),('8902','2014-03-31','10:10:00',5.43),('8902','2014-03-31','10:15:00',5.41),('8902','2014-03-31','10:20:00',5.79),('8902','2014-03-31','10:25:00',6.08),('8902','2014-03-31','10:30:00',6.39),('8902','2014-03-31','10:35:00',6.34),('8902','2014-03-31','10:40:00',6.21),('8902','2014-03-31','10:45:00',6.7),('8902','2014-03-31','10:50:00',6.46),('8902','2014-03-31','10:55:00',6.73),('8902','2014-03-31','11:00:00',6.69),('8902','2014-03-31','11:05:00',6.84),('8902','2014-03-31','11:10:00',6.88),('8902','2014-03-31','11:15:00',6.96),('8902','2014-03-31','11:20:00',7.04),('8902','2014-03-31','11:25:00',7.07),('8902','2014-03-31','11:30:00',7.24),('8902','2014-03-31','11:35:00',7.37),('8902','2014-03-31','11:40:00',7.5),('8902','2014-03-31','11:45:00',7.54),('8902','2014-03-31','11:50:00',7.63),('8902','2014-03-31','11:55:00',7.65),('8902','2014-03-31','12:00:00',7.58),('8902','2014-03-31','12:05:00',7.86),('8902','2014-03-31','12:10:00',7.91),('8902','2014-03-31','12:15:00',7.99),('8902','2014-03-31','12:20:00',8.05),('8902','2014-03-31','12:25:00',8.14),('8902','2014-03-31','12:30:00',8.18),('8902','2014-03-31','12:35:00',8.25),('8902','2014-03-31','12:40:00',8.29),('8902','2014-03-31','12:45:00',8.33),('8902','2014-03-31','12:50:00',8.43),('8902','2014-03-31','12:55:00',8.27),('8902','2014-03-31','13:00:00',8.45),('8902','2014-03-31','13:05:00',8.49),('8902','2014-03-31','13:10:00',6.96),('8902','2014-03-31','13:15:00',8.61),('8902','2014-03-31','13:20:00',7.45),('8902','2014-03-31','13:25:00',8.44),('8902','2014-03-31','13:30:00',8.42),('8902','2014-03-31','13:35:00',8.44),('8902','2014-03-31','13:40:00',8.55),('8902','2014-03-31','13:45:00',8.53),('8902','2014-03-31','13:50:00',8.39),('8902','2014-03-31','13:55:00',8.41),('8902','2014-03-31','14:00:00',8.31),('8902','2014-03-31','14:05:00',8.37),('8902','2014-03-31','14:10:00',8.32),('8902','2014-03-31','14:15:00',5.64),('8902','2014-03-31','14:20:00',8.32),('8902','2014-03-31','14:25:00',8.21),('8902','2014-03-31','14:30:00',6.51),('8902','2014-03-31','14:35:00',8.44),('8902','2014-03-31','14:40:00',6.69),('8902','2014-03-31','14:45:00',8.24),('8902','2014-03-31','14:50:00',8.48),('8902','2014-03-31','14:55:00',6.86),('8902','2014-03-31','15:00:00',8.25),('8902','2014-03-31','15:05:00',7.62),('8902','2014-03-31','15:10:00',6.7),('8902','2014-03-31','15:15:00',8.23),('8902','2014-03-31','15:20:00',7.85),('8902','2014-03-31','15:25:00',6.56),('8902','2014-03-31','15:30:00',6.46),('8902','2014-03-31','15:35:00',6.21),('8902','2014-03-31','15:40:00',6.11),('8902','2014-03-31','15:45:00',5.34),('8902','2014-03-31','15:50:00',7.55),('8902','2014-03-31','15:55:00',6.44),('8902','2014-03-31','16:00:00',4.45),('8902','2014-03-31','16:05:00',5.58),('8902','2014-03-31','16:10:00',5.56),('8902','2014-03-31','16:15:00',5.33),('8902','2014-03-31','16:20:00',3.45),('8902','2014-03-31','16:25:00',4.49),('8902','2014-03-31','16:30:00',5.07),('8902','2014-03-31','16:35:00',6.01),('8902','2014-03-31','16:40:00',5.87),('8902','2014-03-31','16:45:00',4.17),('8902','2014-03-31','16:50:00',2.03),('8902','2014-03-31','16:55:00',4.47),('8902','2014-03-31','17:00:00',4.86),('8902','2014-03-31','17:05:00',4.38),('8902','2014-03-31','17:10:00',3.87),('8902','2014-03-31','17:15:00',4.37),('8902','2014-03-31','17:20:00',4.08),('8902','2014-03-31','17:25:00',3.95),('8902','2014-03-31','17:30:00',3.68),('8902','2014-03-31','17:35:00',3.38),('8902','2014-03-31','17:40:00',3.22),('8902','2014-03-31','17:45:00',3.07),('8902','2014-03-31','17:50:00',2.87),('8902','2014-03-31','17:55:00',2.55),('8902','2014-03-31','18:00:00',2.34),('8902','2014-03-31','18:05:00',2.17),('8902','2014-03-31','18:10:00',1.92),('8902','2014-03-31','18:15:00',1.71),('8902','2014-03-31','18:20:00',1.43),('8902','2014-03-31','18:25:00',1.29),('8902','2013-05-20','07:20:00',1.09),('8902','2013-05-20','07:25:00',1.27),('8902','2013-05-20','07:30:00',1.55),('8902','2013-05-20','07:35:00',2),('8902','2013-05-20','07:40:00',2.34),('8902','2013-05-20','07:45:00',2.1),('8902','2013-05-20','07:50:00',1.77),('8902','2013-05-20','07:55:00',1.62),('8902','2013-05-20','08:00:00',2.09),('8902','2013-05-20','08:05:00',1.54),('8902','2013-05-20','08:10:00',2.22),('8902','2013-05-20','08:15:00',3.21),('8902','2013-05-20','08:20:00',2.7),('8902','2013-05-20','08:25:00',3.36),('8902','2013-05-20','08:30:00',2.54),('8902','2013-05-20','08:35:00',2.3),('8902','2013-05-20','08:40:00',2.72),('8902','2013-05-20','08:45:00',2.36),('8902','2013-05-20','08:50:00',2.53),('8902','2013-05-20','08:55:00',3.32),('8902','2013-05-20','09:00:00',2.93),('8902','2013-05-20','09:05:00',2.53),('8902','2013-05-20','09:10:00',2.71),('8902','2013-05-20','09:15:00',2.96),('8902','2013-05-20','09:20:00',4.05),('8902','2013-05-20','09:25:00',4.57),('8902','2013-05-20','09:30:00',3.59),('8902','2013-05-20','09:35:00',3.83),('8902','2013-05-20','09:40:00',3.68),('8902','2013-05-20','09:45:00',3.2),('8902','2013-05-20','09:50:00',3.04),('8902','2013-05-20','09:55:00',3.47),('8902','2013-05-20','10:00:00',3.68),('8902','2013-05-20','10:05:00',4.19),('8902','2013-05-20','10:10:00',4.47),('8902','2013-05-20','10:15:00',4.15),('8902','2013-05-20','10:20:00',4.01),('8902','2013-05-20','10:25:00',3.54),('8902','2013-05-20','10:30:00',3.35),('8902','2013-05-20','10:35:00',3.52),('8902','2013-05-20','10:40:00',3.99),('8902','2013-05-20','10:45:00',5.68),('8902','2013-05-20','10:50:00',3.97),('8902','2013-05-20','10:55:00',3.07),('8902','2013-05-20','11:00:00',3.73),('8902','2013-05-20','11:05:00',3.42),('8902','2013-05-20','11:10:00',5.76),('8902','2013-05-20','11:15:00',7.48),('8902','2013-05-20','11:20:00',5.52),('8902','2013-05-20','11:25:00',6.87),('8902','2013-05-20','11:30:00',4.99),('8902','2013-05-20','11:35:00',5.92),('8902','2013-05-20','11:40:00',5.4),('8902','2013-05-20','11:45:00',6.4),('8902','2013-05-20','11:50:00',4.51),('8902','2013-05-20','11:55:00',6.83),('8902','2013-05-20','12:00:00',6.34),('8902','2013-05-20','12:05:00',6.6),('8902','2013-05-20','12:10:00',5.28),('8902','2013-05-20','12:15:00',6.47),('8902','2013-05-20','12:20:00',4.47),('8902','2013-05-20','12:25:00',5.93),('8902','2013-05-20','12:30:00',7.51),('8902','2013-05-20','12:35:00',4.74),('8902','2013-05-20','12:40:00',7.64),('8902','2013-05-20','12:45:00',7.61),('8902','2013-05-20','12:50:00',4.8),('8902','2013-05-20','12:55:00',7.79),('8902','2013-05-20','13:00:00',7.65),('8902','2013-05-20','13:05:00',8.21),('8902','2013-05-20','13:10:00',5.1),('8902','2013-05-20','13:15:00',7.79),('8902','2013-05-20','13:20:00',6.39),('8902','2013-05-20','13:25:00',6.23),('8902','2013-05-20','13:30:00',6.01),('8902','2013-05-20','13:35:00',2.83),('8902','2013-05-20','13:40:00',1.69),('8902','2013-05-20','13:45:00',1.14),('8902','2013-05-20','14:00:00',1.24),('8902','2013-05-20','14:05:00',2.11),('8902','2013-05-20','14:10:00',3.23),('8902','2013-05-20','14:15:00',3.77),('8902','2013-05-20','14:20:00',3.39),('8902','2013-05-20','14:25:00',4.91),('8902','2013-05-20','14:30:00',4.15),('8902','2013-05-20','14:35:00',3.71),('8902','2013-05-20','14:40:00',3.62),('8902','2013-05-20','14:45:00',2.99),('8902','2013-05-20','14:50:00',1.92),('8902','2013-05-20','14:55:00',1.48),('8902','2013-05-20','15:05:00',1.06),('8902','2013-05-20','15:10:00',1.22),('8902','2013-05-20','15:15:00',2.01),('8902','2013-05-20','15:20:00',2.8),('8902','2013-05-20','15:25:00',2.93),('8902','2013-05-20','15:30:00',4.13),('8902','2013-05-20','15:35:00',3.12),('8902','2013-05-20','15:40:00',2.44),('8902','2013-05-20','15:45:00',2.55),('8902','2013-05-20','15:50:00',2.32),('8902','2013-05-20','15:55:00',2.32),('8902','2013-05-20','16:00:00',2.32),('8902','2013-05-20','16:05:00',2.26),('8902','2013-05-20','16:10:00',2.46),('8902','2013-05-20','16:15:00',2.18),('8902','2013-05-20','16:20:00',1.8),('8902','2013-05-20','16:25:00',2.42),('8902','2013-05-20','16:30:00',3.27),('8902','2013-05-20','16:35:00',3.55),('8902','2013-05-20','16:40:00',3.94),('8902','2013-05-20','16:45:00',3.49),('8902','2013-05-20','16:50:00',2.14),('8902','2013-05-20','16:55:00',1.13),('8902','2013-05-20','17:00:00',1.29),('8902','2013-05-20','17:05:00',1.42),('8902','2013-05-20','17:10:00',1.18),('8902','2013-05-19','07:20:00',1.07),('8902','2013-05-19','07:25:00',1.13),('8902','2013-05-19','07:30:00',1.38),('8902','2013-05-19','07:35:00',1.56),('8902','2013-05-19','07:40:00',1.71),('8902','2013-05-19','07:45:00',1.86),('8902','2013-05-19','07:50:00',2),('8902','2013-05-19','07:55:00',2.17),('8902','2013-05-19','08:00:00',2.46),('8902','2013-05-19','08:05:00',1.85),('8902','2013-05-19','08:10:00',2.03),('8902','2013-05-19','08:15:00',1.91),('8902','2013-05-19','08:20:00',1.91),('8902','2013-05-19','08:25:00',1.91),('8902','2013-05-19','08:30:00',1.63),('8902','2013-05-19','08:35:00',1.3),('8902','2013-05-19','08:40:00',1.15),('8902','2013-05-19','08:45:00',2.17),('8902','2013-05-19','08:50:00',3.73),('8902','2013-05-19','08:55:00',4.69),('8902','2013-05-19','09:00:00',5.19),('8902','2013-05-19','09:05:00',5.42),('8902','2013-05-19','09:10:00',5.74),('8902','2013-05-19','09:15:00',4.17),('8902','2013-05-19','09:20:00',4.84),('8902','2013-05-19','09:25:00',2.82),('8902','2013-05-19','09:30:00',1.44),('8902','2013-05-19','09:35:00',3.96),('8902','2013-05-19','09:40:00',1.65),('8902','2013-05-19','09:45:00',1.11),('8902','2013-05-19','09:50:00',4.2),('8902','2013-05-19','09:55:00',1.68),('8902','2013-05-19','10:00:00',1.53),('8902','2013-05-19','10:05:00',2.61),('8902','2013-05-19','10:10:00',2.88),('8902','2013-05-19','10:15:00',2.66),('8902','2013-05-19','10:20:00',1.47),('8902','2013-05-19','10:25:00',1.51),('8902','2013-05-19','10:30:00',3.45),('8902','2013-05-19','10:35:00',3.72),('8902','2013-05-19','10:40:00',2.13),('8902','2013-05-19','10:45:00',2.35),('8902','2013-05-19','10:50:00',4.47),('8902','2013-05-19','10:55:00',5.53),('8902','2013-05-19','11:00:00',5.06),('8902','2013-05-19','11:05:00',7.38),('8902','2013-05-19','11:10:00',9.01),('8902','2013-05-19','11:15:00',8.85),('8902','2013-05-19','11:20:00',7.78),('8902','2013-05-19','11:25:00',7.01),('8902','2013-05-19','11:30:00',4.47),('8902','2013-05-19','11:35:00',6.21),('8902','2013-05-19','11:40:00',1.82),('8902','2013-05-19','11:45:00',3.36),('8902','2013-05-19','11:50:00',1.83),('8902','2013-05-19','11:55:00',5.7),('8902','2013-05-19','12:00:00',5.54),('8902','2013-05-19','12:05:00',4.55),('8902','2013-05-19','12:10:00',9.15),('8902','2013-05-19','12:15:00',4.45),('8902','2013-05-19','12:20:00',5.33),('8902','2013-05-19','12:25:00',5.58),('8902','2013-05-19','12:30:00',5.61),('8902','2013-05-19','12:35:00',2.77),('8902','2013-05-19','12:40:00',9.23),('8902','2013-05-19','12:45:00',9.97),('8902','2013-05-19','12:50:00',4.15),('8902','2013-05-19','12:55:00',2.86),('8902','2013-05-19','13:00:00',4.93),('8902','2013-05-19','13:05:00',6.74),('8902','2013-05-19','13:10:00',3.3),('8902','2013-05-19','13:15:00',1.98),('8902','2013-05-19','13:20:00',4.73),('8902','2013-05-19','13:25:00',6.14),('8902','2013-05-19','13:30:00',6.43),('8902','2013-05-19','13:35:00',4.95),('8902','2013-05-19','13:40:00',6.31),('8902','2013-05-19','13:45:00',3.06),('8902','2013-05-19','13:50:00',9.84),('8902','2013-05-19','13:55:00',5.51),('8902','2013-05-19','14:00:00',9.47),('8902','2013-05-19','14:05:00',4.98),('8902','2013-05-19','14:10:00',2.13),('8902','2013-05-19','14:15:00',9.54),('8902','2013-05-19','14:20:00',5.7),('8902','2013-05-19','14:25:00',4.15),('8902','2013-05-19','14:30:00',5.8),('8902','2013-05-19','14:35:00',2.91),('8902','2013-05-19','14:40:00',3.22),('8902','2013-05-19','14:45:00',3.33),('8902','2013-05-19','14:50:00',9.32),('8902','2013-05-19','14:55:00',4.67),('8902','2013-05-19','15:00:00',7.08),('8902','2013-05-19','15:05:00',2.32),('8902','2013-05-19','15:10:00',7.72),('8902','2013-05-19','15:15:00',6.67),('8902','2013-05-19','15:20:00',4.51),('8902','2013-05-19','15:25:00',6.4),('8902','2013-05-19','15:30:00',3.46),('8902','2013-05-19','15:35:00',7.23),('8902','2013-05-19','15:40:00',5.76),('8902','2013-05-19','15:45:00',3.45),('8902','2013-05-19','15:50:00',6.55),('8902','2013-05-19','15:55:00',2.31),('8902','2013-05-19','16:00:00',5.39),('8902','2013-05-19','16:05:00',5.76),('8902','2013-05-19','16:10:00',4.66),('8902','2013-05-19','16:15:00',5.89),('8902','2013-05-19','16:20:00',7.16),('8902','2013-05-19','16:25:00',6.84),('8902','2013-05-19','16:30:00',6.46),('8902','2013-05-19','16:35:00',6.25),('8902','2013-05-19','16:40:00',6.21),('8902','2013-05-19','16:45:00',5.74),('8902','2013-05-19','16:50:00',5.54),('8902','2013-05-19','16:55:00',5.46),('8902','2013-05-19','17:00:00',5.3),('8902','2013-05-19','17:05:00',5.45),('8902','2013-05-19','17:10:00',3.66),('8902','2013-05-19','17:15:00',2.5),('8902','2013-05-19','17:20:00',3.79),('8902','2013-05-19','17:25:00',5.01),('8902','2013-05-19','17:30:00',5.16),('8902','2013-05-19','17:35:00',4.28),('8902','2013-05-19','17:40:00',3.95),('8902','2013-05-19','17:45:00',3.73),('8902','2013-05-19','17:50:00',3.55),('8902','2013-05-19','17:55:00',3.41),('8902','2013-05-19','18:00:00',3.27),('8902','2013-05-19','18:05:00',3.41),('8902','2013-05-19','18:10:00',2.52),('8902','2013-05-19','18:15:00',3.09),('8902','2013-05-19','18:20:00',2.61),('8902','2013-05-19','18:25:00',2.27),('8902','2013-05-19','18:30:00',2.1),('8902','2013-05-19','18:35:00',1.93),('8902','2013-05-19','18:40:00',1.69),('8902','2013-05-19','18:45:00',1.57),('8902','2013-05-19','18:50:00',1.37),('8902','2013-05-19','18:55:00',1.23),('8902','2013-05-19','19:00:00',1.07),('8902','2013-05-18','08:00:00',1.02),('8902','2013-05-18','08:05:00',1.03),('8902','2013-05-18','08:10:00',1.05),('8902','2013-05-18','08:15:00',1.29),('8902','2013-05-18','08:20:00',1.29),('8902','2013-05-18','08:25:00',1.14),('8902','2013-05-18','08:30:00',1.64),('8902','2013-05-18','08:35:00',2.2),('8902','2013-05-18','08:40:00',1.83),('8902','2013-05-18','08:45:00',1.87),('8902','2013-05-18','08:50:00',2.14),('8902','2013-05-18','08:55:00',3.25),('8902','2013-05-18','09:00:00',2.96),('8902','2013-05-18','09:05:00',2.12),('8902','2013-05-18','09:10:00',2.32),('8902','2013-05-18','09:15:00',2.56),('8902','2013-05-18','09:20:00',2.11),('8902','2013-05-18','09:25:00',1.14),('8902','2013-05-18','09:30:00',1.19),('8902','2013-05-18','09:35:00',1.41),('8902','2013-05-18','09:40:00',1.83),('8902','2013-05-18','09:45:00',2.29),('8902','2013-05-18','09:50:00',1.62),('8902','2013-05-18','09:55:00',1.69),('8902','2013-05-18','10:00:00',2.89),('8902','2013-05-18','10:05:00',3.08),('8902','2013-05-18','10:10:00',3.67),('8902','2013-05-18','10:15:00',6.17),('8902','2013-05-18','10:20:00',4.55),('8902','2013-05-18','10:25:00',4.93),('8902','2013-05-18','10:30:00',5.39),('8902','2013-05-18','10:35:00',3.49),('8902','2013-05-18','10:40:00',3.75),('8902','2013-05-18','10:45:00',4.11),('8902','2013-05-18','10:50:00',3.13),('8902','2013-05-18','10:55:00',3.43),('8902','2013-05-18','11:00:00',3.56),('8902','2013-05-18','11:05:00',6.45),('8902','2013-05-18','11:10:00',5.26),('8902','2013-05-18','11:15:00',5.92),('8902','2013-05-18','11:20:00',8.16),('8902','2013-05-18','11:25:00',8.33),('8902','2013-05-18','11:30:00',8.19),('8902','2013-05-18','11:35:00',8.21),('8902','2013-05-18','11:40:00',8.54),('8902','2013-05-18','11:45:00',8.61),('8902','2013-05-18','11:50:00',8.55),('8902','2013-05-18','11:55:00',8.58),('8902','2013-05-18','12:00:00',8.6),('8902','2013-05-18','12:05:00',8.61),('8902','2013-05-18','12:10:00',8.64),('8902','2013-05-18','12:15:00',8.68),('8902','2013-05-18','12:20:00',9.12),('8902','2013-05-18','12:25:00',9.93),('8902','2013-05-18','12:30:00',8.74),('8902','2013-05-18','12:35:00',9.65),('8902','2013-05-18','12:40:00',9.58),('8902','2013-05-18','12:45:00',9.23),('8902','2013-05-18','12:50:00',6.79),('8902','2013-05-18','12:55:00',5.46),('8902','2013-05-18','13:00:00',7.83),('8902','2013-05-18','13:05:00',7.94),('8902','2013-05-18','13:10:00',6.94),('8902','2013-05-18','13:15:00',7.35),('8902','2013-05-18','13:20:00',7.96),('8902','2013-05-18','13:25:00',8.2),('8902','2013-05-18','13:30:00',8.78),('8902','2013-05-18','13:35:00',8.68),('8902','2013-05-18','13:40:00',8.57),('8902','2013-05-18','13:45:00',8.62),('8902','2013-05-18','13:50:00',8.64),('8902','2013-05-18','13:55:00',8.63),('8902','2013-05-18','14:00:00',8.59),('8902','2013-05-18','14:05:00',8.52),('8902','2013-05-18','14:10:00',8.48),('8902','2013-05-18','14:15:00',8.49),('8902','2013-05-18','14:20:00',8.45),('8902','2013-05-18','14:25:00',8.46),('8902','2013-05-18','14:30:00',8.42),('8902','2013-05-18','14:35:00',8.34),('8902','2013-05-18','14:40:00',8.31),('8902','2013-05-18','14:45:00',8.24),('8902','2013-05-18','14:50:00',8.21),('8902','2013-05-18','14:55:00',8.16),('8902','2013-05-18','15:00:00',8.16),('8902','2013-05-18','15:05:00',8.1),('8902','2013-05-18','15:10:00',7.98),('8902','2013-05-18','15:15:00',7.87),('8902','2013-05-18','15:20:00',7.77),('8902','2013-05-18','15:25:00',7.75),('8902','2013-05-18','15:30:00',7.67),('8902','2013-05-18','15:35:00',7.59),('8902','2013-05-18','15:40:00',7.39),('8902','2013-05-18','15:45:00',7.28),('8902','2013-05-18','15:50:00',7.22),('8902','2013-05-18','15:55:00',7.19),('8902','2013-05-18','16:00:00',7.04),('8902','2013-05-18','16:05:00',6.98),('8902','2013-05-18','16:10:00',6.84),('8902','2013-05-18','16:15:00',6.76),('8902','2013-05-18','16:20:00',6.65),('8902','2013-05-18','16:25:00',6.56),('8902','2013-05-18','16:30:00',6.2),('8902','2013-05-18','16:35:00',6.2),('8902','2013-05-18','16:40:00',6.11),('8902','2013-05-18','16:45:00',5.94),('8902','2013-05-18','16:50:00',5.72),('8902','2013-05-18','16:55:00',5.66),('8902','2013-05-18','17:00:00',5.52),('8902','2013-05-18','17:05:00',5.41),('8902','2013-05-18','17:10:00',5.22),('8902','2013-05-18','17:15:00',5.01),('8902','2013-05-18','17:20:00',4.9),('8902','2013-05-18','17:25:00',4.7),('8902','2013-05-18','17:30:00',4.52),('8902','2013-05-18','17:35:00',4.38),('8902','2013-05-18','17:40:00',4.2),('8902','2013-05-18','17:45:00',3.95),('8902','2013-05-18','17:50:00',3.8),('8902','2013-05-18','17:55:00',3.62),('8902','2013-05-18','18:00:00',3.41),('8902','2013-05-18','18:05:00',3.22),('8902','2013-05-18','18:10:00',3.06),('8902','2013-05-18','18:15:00',2.85),('8902','2013-05-18','18:20:00',2.67),('8902','2013-05-18','18:25:00',2.47),('8902','2013-05-18','18:30:00',2.28),('8902','2013-05-18','18:35:00',2.1),('8902','2013-05-18','18:40:00',1.93),('8902','2013-05-18','18:45:00',1.71),('8902','2013-05-18','18:50:00',1.54),('8902','2013-05-18','18:55:00',1.33),('8902','2013-05-18','19:00:00',1.15),('8902','2013-05-17','07:20:00',1.01),('8902','2013-05-17','07:25:00',1.16),('8902','2013-05-17','07:30:00',1.32),('8902','2013-05-17','07:35:00',1.48),('8902','2013-05-17','07:40:00',1.73),('8902','2013-05-17','07:45:00',1.99),('8902','2013-05-17','07:50:00',1.93),('8902','2013-05-17','07:55:00',2.92),('8902','2013-05-17','08:00:00',3.24),('8902','2013-05-17','08:05:00',3.32),('8902','2013-05-17','08:10:00',1.82),('8902','2013-05-17','08:15:00',1.76),('8902','2013-05-17','08:20:00',2.06),('8902','2013-05-17','08:25:00',4.27),('8902','2013-05-17','08:30:00',3.83),('8902','2013-05-17','08:35:00',3.19),('8902','2013-05-17','08:40:00',3.77),('8902','2013-05-17','08:45:00',3.8),('8902','2013-05-17','08:50:00',3.96),('8902','2013-05-17','08:55:00',4.13),('8902','2013-05-17','09:00:00',4.3),('8902','2013-05-17','09:05:00',4.4),('8902','2013-05-17','09:10:00',4.65),('8902','2013-05-17','09:15:00',4.79),('8902','2013-05-17','09:20:00',4.88),('8902','2013-05-17','09:25:00',5.01),('8902','2013-05-17','09:30:00',5.17),('8902','2013-05-17','09:35:00',5.3),('8902','2013-05-17','09:40:00',5.4),('8902','2013-05-17','09:45:00',5.53),('8902','2013-05-17','09:50:00',5.65),('8902','2013-05-17','09:55:00',5.8),('8902','2013-05-17','10:00:00',5.91),('8902','2013-05-17','10:05:00',6.01),('8902','2013-05-17','10:10:00',6.16),('8902','2013-05-17','10:15:00',6.24),('8902','2013-05-17','10:20:00',6.33),('8902','2013-05-17','10:25:00',6.41),('8902','2013-05-17','10:30:00',6.51),('8902','2013-05-17','10:35:00',6.56),('8902','2013-05-17','10:40:00',6.66),('8902','2013-05-17','10:45:00',6.79),('8902','2013-05-17','10:50:00',6.88),('8902','2013-05-17','10:55:00',7.1),('8902','2013-05-17','11:00:00',7.42),('8902','2013-05-17','11:05:00',7.55),('8902','2013-05-17','11:10:00',6.03),('8902','2013-05-17','11:15:00',7.66),('8902','2013-05-17','11:20:00',7.73),('8902','2013-05-17','11:25:00',7.35),('8902','2013-05-17','11:30:00',7.73),('8902','2013-05-17','11:35:00',7.18),('8902','2013-05-17','11:40:00',7.5),('8902','2013-05-17','11:45:00',7.43),('8902','2013-05-17','11:50:00',7.32),('8902','2013-05-17','11:55:00',7.42),('8902','2013-05-17','12:00:00',7.98),('8902','2013-05-17','12:05:00',7.5),('8902','2013-05-17','12:10:00',7.59),('8902','2013-05-17','12:15:00',7.63),('8902','2013-05-17','12:20:00',7.68),('8902','2013-05-17','12:25:00',7.76),('8902','2013-05-17','12:30:00',6.09),('8902','2013-05-17','12:35:00',7.93),('8902','2013-05-17','12:40:00',7.83),('8902','2013-05-17','12:45:00',7.56),('8902','2013-05-17','12:50:00',7.82),('8902','2013-05-17','12:55:00',7.76),('8902','2013-05-17','13:00:00',7.72),('8902','2013-05-17','13:05:00',7.76),('8902','2013-05-17','13:10:00',7.84),('8902','2013-05-17','13:15:00',7.82),('8902','2013-05-17','13:20:00',7.83),('8902','2013-05-17','13:25:00',7.82),('8902','2013-05-17','13:30:00',7.94),('8902','2013-05-17','13:35:00',7.4),('8902','2013-05-17','13:40:00',8.18),('8902','2013-05-17','13:45:00',8.4),('8902','2013-05-17','13:50:00',7),('8902','2013-05-17','13:55:00',6.61),('8902','2013-05-17','14:00:00',7.02),('8902','2013-05-17','14:05:00',6.4),('8902','2013-05-17','14:10:00',8.29),('8902','2013-05-17','14:15:00',8.16),('8902','2013-05-17','14:20:00',7.94),('8902','2013-05-17','14:25:00',7.71),('8902','2013-05-17','14:30:00',7.91),('8902','2013-05-17','14:35:00',7.09),('8902','2013-05-17','14:40:00',8.1),('8902','2013-05-17','14:45:00',7.66),('8902','2013-05-17','14:50:00',6.25),('8902','2013-05-17','14:55:00',6.63),('8902','2013-05-17','15:00:00',6.83),('8902','2013-05-17','15:05:00',6.99),('8902','2013-05-17','15:10:00',6.85),('8902','2013-05-17','15:15:00',6.76),('8902','2013-05-17','15:20:00',6.65),('8902','2013-05-17','15:25:00',6.56),('8902','2013-05-17','15:30:00',6.53),('8902','2013-05-17','15:35:00',6.44),('8902','2013-05-17','15:40:00',6.32),('8902','2013-05-17','15:45:00',6.19),('8902','2013-05-17','15:50:00',6.07),('8902','2013-05-17','15:55:00',5.97),('8902','2013-05-17','16:00:00',5.89),('8902','2013-05-17','16:05:00',5.81),('8902','2013-05-17','16:10:00',5.68),('8902','2013-05-17','16:15:00',5.55),('8902','2013-05-17','16:20:00',5.45),('8902','2013-05-17','16:25:00',5.28),('8902','2013-05-17','16:30:00',5.14),('8902','2013-05-17','16:35:00',5.06),('8902','2013-05-17','16:40:00',4.97),('8902','2013-05-17','16:45:00',4.77),('8902','2013-05-17','16:50:00',4.63),('8902','2013-05-17','16:55:00',4.54),('8902','2013-05-17','17:00:00',4.45),('8902','2013-05-17','17:05:00',4.3),('8902','2013-05-17','17:10:00',4.18),('8902','2013-05-17','17:15:00',4.01),('8902','2013-05-17','17:20:00',3.9),('8902','2013-05-17','17:25:00',3.73),('8902','2013-05-17','17:30:00',3.54),('8902','2013-05-17','17:35:00',3.36),('8902','2013-05-17','17:40:00',3.26),('8902','2013-05-17','17:45:00',3.07),('8902','2013-05-17','17:50:00',2.93),('8902','2013-05-17','17:55:00',2.82),('8902','2013-05-17','18:00:00',2.63),('8902','2013-05-17','18:05:00',2.46),('8902','2013-05-17','18:10:00',2.33),('8902','2013-05-17','18:15:00',2.15),('8902','2013-05-17','18:20:00',1.99),('8902','2013-05-17','18:25:00',1.8),('8902','2013-05-17','18:30:00',1.63),('8902','2013-05-17','18:35:00',1.5),('8902','2013-05-17','18:40:00',1.38),('8902','2013-05-17','18:45:00',1.26),('8902','2013-05-17','18:50:00',1.14),('8902','2013-05-17','18:55:00',1.03),('8902','2013-05-16','07:10:00',1.11),('8902','2013-05-16','07:20:00',1.29),('8902','2013-05-16','07:25:00',1.38),('8902','2013-05-16','07:30:00',1.16),('8902','2013-05-16','07:40:00',1.59),('8902','2013-05-16','07:45:00',1.64),('8902','2013-05-16','07:50:00',1.42),('8902','2013-05-16','07:55:00',1.59),('8902','2013-05-16','08:00:00',2.29),('8902','2013-05-16','08:05:00',1.64),('8902','2013-05-16','08:10:00',1.44),('8902','2013-05-16','08:15:00',2.49),('8902','2013-05-16','08:20:00',3.73),('8902','2013-05-16','08:25:00',2.82),('8902','2013-05-16','08:30:00',1.96),('8902','2013-05-16','08:35:00',1.13),('8902','2013-05-16','09:05:00',1.21),('8902','2013-05-16','09:10:00',1.4),('8902','2013-05-16','09:15:00',1.2),('8902','2013-05-16','09:20:00',1.47),('8902','2013-05-16','09:25:00',2.2),('8902','2013-05-16','10:15:00',1.31),('8902','2013-05-16','10:20:00',1.7),('8902','2013-05-16','10:25:00',2.42),('8902','2013-05-16','10:30:00',3.01),('8902','2013-05-16','10:35:00',2.48),('8902','2013-05-16','10:40:00',2.72),('8902','2013-05-16','10:45:00',2.93),('8902','2013-05-16','10:50:00',4.74),('8902','2013-05-16','10:55:00',5.73),('8902','2013-05-16','11:00:00',4.21),('8902','2013-05-16','11:05:00',4.13),('8902','2013-05-16','11:10:00',2.73),('8902','2013-05-16','11:15:00',3.58),('8902','2013-05-16','11:20:00',3.77),('8902','2013-05-16','11:25:00',3.23),('8902','2013-05-16','11:30:00',4.5),('8902','2013-05-16','11:35:00',6.94),('8902','2013-05-16','11:40:00',3.31),('8902','2013-05-16','11:45:00',3.07),('8902','2013-05-16','11:50:00',3.51),('8902','2013-05-16','11:55:00',3.94),('8902','2013-05-16','12:00:00',3.47),('8902','2013-05-16','12:05:00',5.24),('8902','2013-05-16','12:10:00',4.23),('8902','2013-05-16','12:15:00',5.89),('8902','2013-05-16','12:20:00',3.75),('8902','2013-05-16','12:25:00',6.25),('8902','2013-05-16','12:30:00',5.2),('8902','2013-05-16','12:35:00',5.29),('8902','2013-05-16','12:40:00',9.08),('8902','2013-05-16','12:45:00',7.44),('8902','2013-05-16','12:50:00',8.55),('8902','2013-05-16','12:55:00',9.01),('8902','2013-05-16','13:00:00',7.01),('8902','2013-05-16','13:05:00',6.88),('8902','2013-05-16','13:10:00',5.58),('8902','2013-05-16','13:15:00',8.35),('8902','2013-05-16','13:20:00',8.55),('8902','2013-05-16','13:25:00',8.51),('8902','2013-05-16','13:30:00',5.59),('8902','2013-05-16','13:35:00',7.91),('8902','2013-05-16','13:40:00',7.11),('8902','2013-05-16','13:45:00',8.58),('8902','2013-05-16','13:50:00',8.79),('8902','2013-05-16','13:55:00',8.23),('8902','2013-05-16','14:00:00',7.7),('8902','2013-05-16','14:05:00',5.14),('8902','2013-05-16','14:10:00',7.52),('8902','2013-05-16','14:15:00',8.21),('8902','2013-05-16','14:20:00',9.13),('8902','2013-05-16','14:25:00',7.27),('8902','2013-05-16','14:30:00',7.5),('8902','2013-05-16','14:35:00',7.45),('8902','2013-05-16','14:40:00',4.84),('8902','2013-05-16','14:45:00',8.35),('8902','2013-05-16','14:50:00',4.9),('8902','2013-05-16','14:55:00',6.74),('8902','2013-05-16','15:00:00',7.02),('8902','2013-05-16','15:05:00',5.59),('8902','2013-05-16','15:10:00',3.66),('8902','2013-05-16','15:15:00',5.79),('8902','2013-05-16','15:20:00',4.92),('8902','2013-05-16','15:25:00',7.11),('8902','2013-05-16','15:30:00',5.91),('8902','2013-05-16','15:35:00',7.14),('8902','2013-05-16','15:40:00',6.99),('8902','2013-05-16','15:45:00',3.59),('8902','2013-05-16','15:50:00',4.91),('8902','2013-05-16','15:55:00',5.81),('8902','2013-05-16','16:00:00',3.29),('8902','2013-05-16','16:05:00',3.26),('8902','2013-05-16','16:10:00',3.44),('8902','2013-05-16','16:15:00',6.65),('8902','2013-05-16','16:20:00',6.71),('8902','2013-05-16','16:25:00',6.52),('8902','2013-05-16','16:30:00',6.03),('8902','2013-05-16','16:35:00',6.09),('8902','2013-05-16','16:40:00',6.76),('8902','2013-05-16','16:45:00',6.04),('8902','2013-05-16','16:50:00',5.75),('8902','2013-05-16','16:55:00',5.48),('8902','2013-05-16','17:00:00',5.34),('8902','2013-05-16','17:05:00',5.19),('8902','2013-05-16','17:10:00',5.05),('8902','2013-05-16','17:15:00',4.86),('8902','2013-05-16','17:20:00',4.73),('8902','2013-05-16','17:25:00',4.54),('8902','2013-05-16','17:30:00',4.36),('8902','2013-05-16','17:35:00',4.2),('8902','2013-05-16','17:40:00',4.05),('8902','2013-05-16','17:45:00',3.8),('8902','2013-05-16','17:50:00',3.67),('8902','2013-05-16','17:55:00',3.52),('8902','2013-05-16','18:00:00',3.34),('8902','2013-05-16','18:05:00',3.15),('8902','2013-05-16','18:10:00',2.94),('8902','2013-05-16','18:15:00',2.71),('8902','2013-05-16','18:20:00',2.55),('8902','2013-05-16','18:25:00',2.31),('8902','2013-05-16','18:30:00',2.16),('8902','2013-05-16','18:35:00',2),('8902','2013-05-16','18:40:00',1.81),('8902','2013-05-16','18:45:00',1.59),('8902','2013-05-16','18:50:00',1.46),('8902','2013-05-16','18:55:00',1.28),('8902','2013-05-15','09:15:00',1.73),('8902','2013-05-15','09:20:00',2.15),('8902','2013-05-15','09:25:00',3.04),('8902','2013-05-15','09:30:00',2.9),('8902','2013-05-15','09:35:00',3.35),('8902','2013-05-15','09:40:00',3.79),('8902','2013-05-15','09:45:00',4.62),('8902','2013-05-15','09:50:00',2.32),('8902','2013-05-15','09:55:00',2.22),('8902','2013-05-15','10:00:00',2.96),('8902','2013-05-15','10:05:00',2.46),('8902','2013-05-15','10:10:00',2.26),('8902','2013-05-15','10:15:00',2.96),('8902','2013-05-15','10:20:00',4.11),('8902','2013-05-15','10:25:00',4.92),('8902','2013-05-15','10:30:00',3.63),('8902','2013-05-15','10:35:00',2.69),('8902','2013-05-15','10:40:00',2.7),('8902','2013-05-15','10:45:00',2.48),('8902','2013-05-15','10:50:00',2.93),('8902','2013-05-15','10:55:00',3.58),('8902','2013-05-15','11:00:00',7.53),('8902','2013-05-15','11:05:00',6.42),('8902','2013-05-15','11:10:00',5.07),('8902','2013-05-15','11:15:00',3.08),('8902','2013-05-15','11:20:00',2.08),('8902','2013-05-15','11:25:00',2.42),('8902','2013-05-15','11:30:00',2.87),('8902','2013-05-15','11:35:00',4.58),('8902','2013-05-15','11:40:00',7.7),('8902','2013-05-15','11:45:00',7.4),('8902','2013-05-15','11:50:00',6.61),('8902','2013-05-15','11:55:00',4.19),('8902','2013-05-15','12:00:00',3.32),('8902','2013-05-15','12:05:00',3.11),('8902','2013-05-15','12:10:00',3.3),('8902','2013-05-15','12:15:00',5.44),('8902','2013-05-15','12:20:00',3.72),('8902','2013-05-15','12:25:00',4.43),('8902','2013-05-15','12:30:00',6.2),('8902','2013-05-15','12:35:00',6.54),('8902','2013-05-15','12:40:00',6.22),('8902','2013-05-15','12:45:00',6.14),('8902','2013-05-15','12:50:00',5.22),('8902','2013-05-15','12:55:00',8.52),('8902','2013-05-15','13:00:00',7.85),('8902','2013-05-15','13:05:00',6.99),('8902','2013-05-15','13:10:00',7.88),('8902','2013-05-15','13:15:00',7.51),('8902','2013-05-15','13:20:00',8.07),('8902','2013-05-15','13:25:00',7.84),('8902','2013-05-15','13:30:00',7.73),('8902','2013-05-15','13:35:00',7.71),('8902','2013-05-15','13:40:00',7.61),('8902','2013-05-15','13:45:00',7.6),('8902','2013-05-15','13:50:00',7.52),('8902','2013-05-15','13:55:00',7.6),('8902','2013-05-15','14:00:00',7.54),('8902','2013-05-15','14:05:00',7.52),('8902','2013-05-15','14:10:00',7.45),('8902','2013-05-15','14:15:00',7.34),('8902','2013-05-15','14:20:00',7.39),('8902','2013-05-15','14:25:00',7.2),('8902','2013-05-15','14:30:00',7.2),('8902','2013-05-15','14:35:00',7.09),('8902','2013-05-15','14:40:00',7.04),('8902','2013-05-15','14:45:00',7.01),('8902','2013-05-15','14:50:00',6.75),('8902','2013-05-15','14:55:00',6.16),('8902','2013-05-15','15:00:00',6.79),('8902','2013-05-15','15:05:00',6.84),('8902','2013-05-15','15:10:00',6.82),('8902','2013-05-15','15:15:00',6.09),('8902','2013-05-15','15:20:00',6.56),('8902','2013-05-15','15:25:00',6.52),('8902','2013-05-15','15:30:00',6.36),('8902','2013-05-15','15:35:00',6.14),('8902','2013-05-15','15:40:00',6.31),('8902','2013-05-15','15:45:00',6.1),('8902','2013-05-15','15:50:00',6.07),('8902','2013-05-15','15:55:00',6.03),('8902','2013-05-15','16:00:00',5.96),('8902','2013-05-15','16:05:00',5.72),('8902','2013-05-15','16:10:00',5.68),('8902','2013-05-15','16:15:00',5.32),('8902','2013-05-15','16:20:00',5.55),('8902','2013-05-15','16:25:00',5.29),('8902','2013-05-15','16:30:00',5.17),('8902','2013-05-15','16:35:00',5.03),('8902','2013-05-15','16:40:00',2.92),('8902','2013-05-15','16:45:00',2.68),('8902','2013-05-15','16:50:00',4.03),('8902','2013-05-15','16:55:00',2.84),('8902','2013-05-15','17:00:00',2.76),('8902','2013-05-15','17:05:00',1.71),('8902','2013-05-15','17:10:00',1.59),('8902','2013-05-15','17:15:00',2.18),('8902','2013-05-15','17:20:00',2.64),('8902','2013-05-15','17:25:00',2.48),('8902','2013-05-15','17:30:00',3.35),('8902','2013-05-15','17:35:00',3.59),('8902','2013-05-15','17:40:00',2.83),('8902','2013-05-15','17:45:00',1.9),('8902','2013-05-15','17:50:00',1.2),('8902','2013-05-15','18:25:00',1.06),('8902','2013-05-15','18:30:00',1.24),('8902','2013-05-15','18:35:00',1.38),('8902','2013-05-15','18:40:00',1.39),('8902','2013-05-15','18:45:00',1.57),('8902','2013-05-15','18:50:00',1.7),('8902','2013-05-15','18:55:00',1.75),('8902','2013-05-15','19:00:00',1.85),('8902','2013-05-15','19:05:00',1.79),('8902','2013-05-15','19:10:00',1.48),('8902','2013-05-15','19:15:00',1.24),('8902','2013-05-15','19:20:00',1.05),('8902','2013-05-14','07:25:00',1.12),('8902','2013-05-14','07:30:00',1.32),('8902','2013-05-14','07:35:00',1.49),('8902','2013-05-14','07:40:00',1.7),('8902','2013-05-14','07:45:00',1.99),('8902','2013-05-14','07:50:00',2.12),('8902','2013-05-14','07:55:00',2.04),('8902','2013-05-14','08:00:00',2.16),('8902','2013-05-14','08:05:00',2.1),('8902','2013-05-14','08:10:00',2.5),('8902','2013-05-14','08:15:00',2.74),('8902','2013-05-14','08:20:00',2.85),('8902','2013-05-14','08:25:00',2.96),('8902','2013-05-14','08:30:00',3.05),('8902','2013-05-14','08:35:00',3.34),('8902','2013-05-14','08:40:00',3.56),('8902','2013-05-14','08:45:00',3.73),('8902','2013-05-14','08:50:00',3.92),('8902','2013-05-14','08:55:00',4.08),('8902','2013-05-14','09:00:00',3.97),('8902','2013-05-14','09:05:00',4.33),('8902','2013-05-14','09:10:00',4.31),('8902','2013-05-14','09:15:00',4.49),('8902','2013-05-14','09:20:00',4.52),('8902','2013-05-14','09:25:00',4.03),('8902','2013-05-14','09:30:00',4.98),('8902','2013-05-14','09:35:00',5.14),('8902','2013-05-14','09:40:00',5.14),('8902','2013-05-14','09:45:00',5.3),('8902','2013-05-14','09:50:00',5.49),('8902','2013-05-14','09:55:00',5.54),('8902','2013-05-14','10:00:00',5.68),('8902','2013-05-14','10:05:00',5.83),('8902','2013-05-14','10:10:00',5.99),('8902','2013-05-14','10:15:00',5.85),('8902','2013-05-14','10:20:00',6.14),('8902','2013-05-14','10:25:00',6.34),('8902','2013-05-14','10:30:00',6.17),('8902','2013-05-14','10:35:00',6.33),('8902','2013-05-14','10:40:00',6.56),('8902','2013-05-14','10:45:00',6.67),('8902','2013-05-14','10:50:00',6.71),('8902','2013-05-14','10:55:00',6.55),('8902','2013-05-14','11:00:00',6.61),('8902','2013-05-14','11:05:00',6.98),('8902','2013-05-14','11:10:00',6.96),('8902','2013-05-14','11:15:00',7.12),('8902','2013-05-14','11:20:00',6.77),('8902','2013-05-14','11:25:00',7.08),('8902','2013-05-14','11:30:00',7.56),('8902','2013-05-14','11:35:00',7.04),('8902','2013-05-14','11:40:00',6.19),('8902','2013-05-14','11:45:00',5.49),('8902','2013-05-14','11:50:00',5.14),('8902','2013-05-14','11:55:00',3.62),('8902','2013-05-14','12:00:00',3.91),('8902','2013-05-14','12:05:00',6.57),('8902','2013-05-14','12:10:00',8.62),('8902','2013-05-14','12:15:00',8.38),('8902','2013-05-14','12:20:00',5.07),('8902','2013-05-14','12:25:00',6.41),('8902','2013-05-14','12:30:00',5.36),('8902','2013-05-14','12:35:00',5.19),('8902','2013-05-14','12:40:00',8.95),('8902','2013-05-14','12:45:00',4.71),('8902','2013-05-14','12:50:00',4.66),('8902','2013-05-14','12:55:00',5.29),('8902','2013-05-14','13:00:00',5.44),('8902','2013-05-14','13:05:00',5.97),('8902','2013-05-14','13:10:00',5.88),('8902','2013-05-14','13:15:00',4.36),('8902','2013-05-14','13:20:00',5.33),('8902','2013-05-14','13:25:00',5.04),('8902','2013-05-14','13:30:00',5.32),('8902','2013-05-14','13:35:00',4.67),('8902','2013-05-14','13:40:00',4.84),('8902','2013-05-14','13:45:00',4.85),('8902','2013-05-14','13:50:00',4.05),('8902','2013-05-14','13:55:00',3.89),('8902','2013-05-14','14:00:00',3.39),('8902','2013-05-14','14:05:00',2.98),('8902','2013-05-14','14:10:00',3.06),('8902','2013-05-14','14:15:00',3.07),('8902','2013-05-14','14:20:00',3.16),('8902','2013-05-14','14:25:00',3.07),('8902','2013-05-14','14:30:00',2.72),('8902','2013-05-14','14:35:00',2.66),('8902','2013-05-14','14:40:00',2.89),('8902','2013-05-14','14:45:00',2.74),('8902','2013-05-14','14:50:00',2.76),('8902','2013-05-14','14:55:00',2.77),('8902','2013-05-14','15:00:00',2.7),('8902','2013-05-14','15:05:00',2.12),('8902','2013-05-14','15:10:00',1.65),('8902','2013-05-14','15:15:00',1.58),('8902','2013-05-14','15:20:00',1.5),('8902','2013-05-14','15:25:00',1.36),('8902','2013-05-14','15:30:00',1.45),('8902','2013-05-14','15:35:00',1.44),('8902','2013-05-14','15:40:00',1.56),('8902','2013-05-14','15:45:00',2.01),('8902','2013-05-14','15:50:00',2.76),('8902','2013-05-14','15:55:00',3.58),('8902','2013-05-14','16:00:00',3.59),('8902','2013-05-14','16:05:00',3.34),('8902','2013-05-14','16:10:00',3.01),('8902','2013-05-14','16:15:00',2.65),('8902','2013-05-14','16:20:00',2.91),('8902','2013-05-14','16:25:00',3.02),('8902','2013-05-14','16:30:00',2.74),('8902','2013-05-14','16:35:00',2.5),('8902','2013-05-14','16:40:00',2.3),('8902','2013-05-14','16:45:00',2.21),('8902','2013-05-14','16:50:00',2.21),('8902','2013-05-14','16:55:00',2.55),('8902','2013-05-14','17:00:00',3.03),('8902','2013-05-14','17:05:00',3.71),('8902','2013-05-14','17:10:00',3.49),('8902','2013-05-14','17:15:00',5.02),('8902','2013-05-14','17:20:00',4.28),('8902','2013-05-14','17:25:00',1.68),('8902','2013-05-14','17:30:00',1.78),('8902','2013-05-14','17:35:00',1.6),('8902','2013-05-14','17:40:00',1.45),('8902','2013-05-14','17:45:00',1.54),('8902','2013-05-14','17:50:00',1.6),('8902','2013-05-14','17:55:00',1.57),('8902','2013-05-14','18:00:00',1.43),('8902','2013-05-14','18:05:00',1.15),('8902','2013-05-13','07:25:00',1.07),('8902','2013-05-13','07:30:00',1.25),('8902','2013-05-13','07:35:00',1.41),('8902','2013-05-13','07:40:00',1.59),('8902','2013-05-13','07:45:00',1.76),('8902','2013-05-13','07:50:00',1.94),('8902','2013-05-13','07:55:00',2.13),('8902','2013-05-13','08:00:00',2.32),('8902','2013-05-13','08:05:00',2.49),('8902','2013-05-13','08:10:00',2.68),('8902','2013-05-13','08:15:00',2.86),('8902','2013-05-13','08:20:00',3.04),('8902','2013-05-13','08:25:00',3.22),('8902','2013-05-13','08:30:00',3.4),('8902','2013-05-13','08:35:00',3.59),('8902','2013-05-13','08:40:00',3.76),('8902','2013-05-13','08:45:00',3.92),('8902','2013-05-13','08:50:00',4.09),('8902','2013-05-13','08:55:00',4.25),('8902','2013-05-13','09:00:00',4.4),('8902','2013-05-13','09:05:00',4.57),('8902','2013-05-13','09:10:00',4.72),('8902','2013-05-13','09:15:00',4.86),('8902','2013-05-13','09:20:00',5.02),('8902','2013-05-13','09:25:00',5.15),('8902','2013-05-13','09:30:00',5.29),('8902','2013-05-13','09:35:00',5.41),('8902','2013-05-13','09:40:00',5.54),('8902','2013-05-13','09:45:00',5.67),('8902','2013-05-13','09:50:00',5.82),('8902','2013-05-13','09:55:00',5.96),('8902','2013-05-13','10:00:00',6.04),('8902','2013-05-13','10:05:00',6.2),('8902','2013-05-13','10:10:00',6.27),('8902','2013-05-13','10:15:00',6.37),('8902','2013-05-13','10:20:00',6.53),('8902','2013-05-13','10:25:00',6.58),('8902','2013-05-13','10:30:00',6.68),('8902','2013-05-13','10:35:00',6.76),('8902','2013-05-13','10:40:00',6.85),('8902','2013-05-13','10:45:00',6.93),('8902','2013-05-13','10:50:00',7.06),('8902','2013-05-13','10:55:00',7.14),('8902','2013-05-13','11:00:00',7.2),('8902','2013-05-13','11:05:00',7.27),('8902','2013-05-13','11:10:00',7.35),('8902','2013-05-13','11:15:00',7.36),('8902','2013-05-13','11:20:00',7.37),('8902','2013-05-13','11:25:00',7.42),('8902','2013-05-13','11:30:00',7.56),('8902','2013-05-13','11:35:00',7.61),('8902','2013-05-13','11:40:00',7.61),('8902','2013-05-13','11:45:00',7.7),('8902','2013-05-13','11:50:00',7.79),('8902','2013-05-13','11:55:00',7.82),('8902','2013-05-13','12:00:00',7.85),('8902','2013-05-13','12:05:00',7.84),('8902','2013-05-13','12:10:00',7.86),('8902','2013-05-13','12:15:00',7.89),('8902','2013-05-13','12:20:00',7.94),('8902','2013-05-13','12:25:00',8.1),('8902','2013-05-13','12:30:00',8.18),('8902','2013-05-13','12:35:00',8.17),('8902','2013-05-13','12:40:00',8.13),('8902','2013-05-13','12:45:00',8.15),('8902','2013-05-13','12:50:00',8.18),('8902','2013-05-13','12:55:00',8.2),('8902','2013-05-13','13:00:00',8.17),('8902','2013-05-13','13:05:00',8.13),('8902','2013-05-13','13:10:00',8.26),('8902','2013-05-13','13:15:00',8.24),('8902','2013-05-13','13:20:00',8.17),('8902','2013-05-13','13:25:00',8.09),('8902','2013-05-13','13:30:00',8.08),('8902','2013-05-13','13:35:00',8.06),('8902','2013-05-13','13:40:00',8.08),('8902','2013-05-13','13:45:00',8.03),('8902','2013-05-13','13:50:00',7.98),('8902','2013-05-13','13:55:00',7.95),('8902','2013-05-13','14:00:00',7.98),('8902','2013-05-13','14:05:00',7.96),('8902','2013-05-13','14:10:00',7.94),('8902','2013-05-13','14:15:00',7.91),('8902','2013-05-13','14:20:00',7.81),('8902','2013-05-13','14:25:00',7.78),('8902','2013-05-13','14:30:00',7.77),('8902','2013-05-13','14:35:00',7.74),('8902','2013-05-13','14:40:00',7.72),('8902','2013-05-13','14:45:00',7.72),('8902','2013-05-13','14:50:00',7.76),('8902','2013-05-13','14:55:00',7.73),('8902','2013-05-13','15:00:00',7.73),('8902','2013-05-13','15:05:00',7.7),('8902','2013-05-13','15:10:00',7.65),('8902','2013-05-13','15:15:00',7.6),('8902','2013-05-13','15:20:00',7.54),('8902','2013-05-13','15:25:00',7.49),('8902','2013-05-13','15:30:00',7.4),('8902','2013-05-13','15:35:00',7.25),('8902','2013-05-13','15:40:00',7.18),('8902','2013-05-13','15:45:00',7.1),('8902','2013-05-13','15:50:00',7),('8902','2013-05-13','15:55:00',6.88),('8902','2013-05-13','16:00:00',6.76),('8902','2013-05-13','16:05:00',6.67),('8902','2013-05-13','16:10:00',6.59),('8902','2013-05-13','16:15:00',6.47),('8902','2013-05-13','16:20:00',6.34),('8902','2013-05-13','16:25:00',6.18),('8902','2013-05-13','16:30:00',5.99),('8902','2013-05-13','16:35:00',5.91),('8902','2013-05-13','16:40:00',5.8),('8902','2013-05-13','16:45:00',5.6),('8902','2013-05-13','16:50:00',5.42),('8902','2013-05-13','16:55:00',5.35),('8902','2013-05-13','17:00:00',5.21),('8902','2013-05-13','17:05:00',5.04),('8902','2013-05-13','17:10:00',4.85),('8902','2013-05-13','17:15:00',4.7),('8902','2013-05-13','17:20:00',4.56),('8902','2013-05-13','17:25:00',4.38),('8902','2013-05-13','17:30:00',4.19),('8902','2013-05-13','17:35:00',4.03),('8902','2013-05-13','17:40:00',3.86),('8902','2013-05-13','17:45:00',3.58),('8902','2013-05-13','17:50:00',3.49),('8902','2013-05-13','17:55:00',3.3),('8902','2013-05-13','18:00:00',3.11),('8902','2013-05-13','18:05:00',2.95),('8902','2013-05-13','18:10:00',2.74),('8902','2013-05-13','18:15:00',2.56),('8902','2013-05-13','18:20:00',2.37),('8902','2013-05-13','18:25:00',2.13),('8902','2013-05-13','18:30:00',2.02),('8902','2013-05-13','18:35:00',1.86),('8902','2013-05-13','18:40:00',1.7),('8902','2013-05-13','18:45:00',1.49),('8902','2013-05-13','18:50:00',1.32),('8902','2013-05-13','18:55:00',1.15),('8902','2013-05-12','07:30:00',1.2),('8902','2013-05-12','07:35:00',1.36),('8902','2013-05-12','07:40:00',1.5),('8902','2013-05-12','07:45:00',1.62),('8902','2013-05-12','07:50:00',1.67),('8902','2013-05-12','07:55:00',1.3),('8902','2013-05-12','08:00:00',1.93),('8902','2013-05-12','08:05:00',2.27),('8902','2013-05-12','08:10:00',2.48),('8902','2013-05-12','08:15:00',2.66),('8902','2013-05-12','08:20:00',2.84),('8902','2013-05-12','08:25:00',2.96),('8902','2013-05-12','08:30:00',3.1),('8902','2013-05-12','08:35:00',3.28),('8902','2013-05-12','08:40:00',3.47),('8902','2013-05-12','08:45:00',3.61),('8902','2013-05-12','08:50:00',3.8),('8902','2013-05-12','08:55:00',3.95),('8902','2013-05-12','09:00:00',4.1),('8902','2013-05-12','09:05:00',4.22),('8902','2013-05-12','09:10:00',4.42),('8902','2013-05-12','09:15:00',4.55),('8902','2013-05-12','09:20:00',4.76),('8902','2013-05-12','09:25:00',4.87),('8902','2013-05-12','09:30:00',5.06),('8902','2013-05-12','09:35:00',5.16),('8902','2013-05-12','09:40:00',5.33),('8902','2013-05-12','09:45:00',5.42),('8902','2013-05-12','09:50:00',5.73),('8902','2013-05-12','09:55:00',5.94),('8902','2013-05-12','10:00:00',6.06),('8902','2013-05-12','10:05:00',6.14),('8902','2013-05-12','10:10:00',6.28),('8902','2013-05-12','10:15:00',6.65),('8902','2013-05-12','10:20:00',6.78),('8902','2013-05-12','10:25:00',5.03),('8902','2013-05-12','10:30:00',6.85),('8902','2013-05-12','10:35:00',2.61),('8902','2013-05-12','10:40:00',1.95),('8902','2013-05-12','10:45:00',6.48),('8902','2013-05-12','10:50:00',6.48),('8902','2013-05-12','10:55:00',3.88),('8902','2013-05-12','11:00:00',5.79),('8902','2013-05-12','11:05:00',4.49),('8902','2013-05-12','11:10:00',3.18),('8902','2013-05-12','11:15:00',5.18),('8902','2013-05-12','11:20:00',2.96),('8902','2013-05-12','11:25:00',3.94),('8902','2013-05-12','11:30:00',5.64),('8902','2013-05-12','11:35:00',4.76),('8902','2013-05-12','11:40:00',4.11),('8902','2013-05-12','11:45:00',5.1),('8902','2013-05-12','11:50:00',3.09),('8902','2013-05-12','11:55:00',3.47),('8902','2013-05-12','12:00:00',3.09),('8902','2013-05-12','12:05:00',3.01),('8902','2013-05-12','12:10:00',5.3),('8902','2013-05-12','12:15:00',5.84),('8902','2013-05-12','12:20:00',2.78),('8902','2013-05-12','12:25:00',3.57),('8902','2013-05-12','12:30:00',6.23),('8902','2013-05-12','12:35:00',7.02),('8902','2013-05-12','12:40:00',4.27),('8902','2013-05-12','12:45:00',5.12),('8902','2013-05-12','12:50:00',5.21),('8902','2013-05-12','12:55:00',9.33),('8902','2013-05-12','13:00:00',9.24),('8902','2013-05-12','13:05:00',5.44),('8902','2013-05-12','13:10:00',8.04),('8902','2013-05-12','13:15:00',9.19),('8902','2013-05-12','13:20:00',7.55),('8902','2013-05-12','13:25:00',9.22),('8902','2013-05-12','13:30:00',9.19),('8902','2013-05-12','13:35:00',7.58),('8902','2013-05-12','13:40:00',5.3),('8902','2013-05-12','13:45:00',2.77),('8902','2013-05-12','13:50:00',2.48),('8902','2013-05-12','13:55:00',2.18),('8902','2013-05-12','14:00:00',2.15),('8902','2013-05-12','14:05:00',5.06),('8902','2013-05-12','14:10:00',9.54),('8902','2013-05-12','14:15:00',9.01),('8902','2013-05-12','14:20:00',8.35),('8902','2013-05-12','14:25:00',3.98),('8902','2013-05-12','14:30:00',1.5),('8902','2013-05-12','14:35:00',7.59),('8902','2013-05-12','14:40:00',8.78),('8902','2013-05-12','14:45:00',6.04),('8902','2013-05-12','14:50:00',2.01),('8902','2013-05-12','14:55:00',8.91),('8902','2013-05-12','15:00:00',8.45),('8902','2013-05-12','15:05:00',4.81),('8902','2013-05-12','15:10:00',2.16),('8902','2013-05-12','15:15:00',1.82),('8902','2013-05-12','15:20:00',2.17),('8902','2013-05-12','15:25:00',1.7),('8902','2013-05-12','15:30:00',1.59),('8902','2013-05-12','15:35:00',1.14),('8902','2013-05-12','15:40:00',1.35),('8902','2013-05-12','15:45:00',1.33),('8902','2013-05-12','15:50:00',1.3),('8902','2013-05-12','15:55:00',1.22),('8902','2013-05-12','16:00:00',2.09),('8902','2013-05-12','16:05:00',2.05),('8902','2013-05-12','16:10:00',4.01),('8902','2013-05-12','16:15:00',2.18),('8902','2013-05-12','16:20:00',3.14),('8902','2013-05-12','16:25:00',2.83),('8902','2013-05-12','16:30:00',3.49),('8902','2013-05-12','16:35:00',2.67),('8902','2013-05-12','16:40:00',3.81),('8902','2013-05-12','16:45:00',5.19),('8902','2013-05-12','16:50:00',6.83),('8902','2013-05-12','16:55:00',6.28),('8902','2013-05-12','17:00:00',5.84),('8902','2013-05-12','17:05:00',5.1),('8902','2013-05-12','17:10:00',4.18),('8902','2013-05-12','17:15:00',5.64),('8902','2013-05-12','17:20:00',5.91),('8902','2013-05-12','17:25:00',5.36),('8902','2013-05-12','17:30:00',4.13),('8902','2013-05-12','17:35:00',4.64),('8902','2013-05-12','17:40:00',4.23),('8902','2013-05-12','17:45:00',3.69),('8902','2013-05-12','17:50:00',3.37),('8902','2013-05-12','17:55:00',2.13),('8902','2013-05-12','18:00:00',1.32),('8902','2013-05-12','18:05:00',1.18),('8902','2013-05-12','18:10:00',1.17),('8902','2013-05-12','18:15:00',1.16),('8902','2013-05-11','07:55:00',1.16),('8902','2013-05-11','08:00:00',1.35),('8902','2013-05-11','08:05:00',1.86),('8902','2013-05-11','08:10:00',3.12),('8902','2013-05-11','08:15:00',2.42),('8902','2013-05-11','08:20:00',2.3),('8902','2013-05-11','08:25:00',2.07),('8902','2013-05-11','08:30:00',1.62),('8902','2013-05-11','08:35:00',1.52),('8902','2013-05-11','08:40:00',1.67),('8902','2013-05-11','08:45:00',2.03),('8902','2013-05-11','08:50:00',2.6),('8902','2013-05-11','08:55:00',1.92),('8902','2013-05-11','09:00:00',2.2),('8902','2013-05-11','09:05:00',2.54),('8902','2013-05-11','09:10:00',2.04),('8902','2013-05-11','09:15:00',2.33),('8902','2013-05-11','09:20:00',2.35),('8902','2013-05-11','09:25:00',4.12),('8902','2013-05-11','09:30:00',5.65),('8902','2013-05-11','09:35:00',2.29),('8902','2013-05-11','09:40:00',3.99),('8902','2013-05-11','09:45:00',6.83),('8902','2013-05-11','09:50:00',6.38),('8902','2013-05-11','09:55:00',6.38),('8902','2013-05-11','10:00:00',5.97),('8902','2013-05-11','10:05:00',3.93),('8902','2013-05-11','10:10:00',3.18),('8902','2013-05-11','10:15:00',2.29),('8902','2013-05-11','10:20:00',1.59),('8902','2013-05-11','10:25:00',1.79),('8902','2013-05-11','10:30:00',2.39),('8902','2013-05-11','10:35:00',2.22),('8902','2013-05-11','10:40:00',1.77),('8902','2013-05-11','10:45:00',1.83),('8902','2013-05-11','10:50:00',3.23),('8902','2013-05-11','10:55:00',8.46),('8902','2013-05-11','11:00:00',3.9),('8902','2013-05-11','11:05:00',1.64),('8902','2013-05-11','11:10:00',2.02),('8902','2013-05-11','11:15:00',3.88),('8902','2013-05-11','11:20:00',4.51),('8902','2013-05-11','11:25:00',5.09),('8902','2013-05-11','11:30:00',8.79),('8902','2013-05-11','11:35:00',6.72),('8902','2013-05-11','11:40:00',8.5),('8902','2013-05-11','11:45:00',8.77),('8902','2013-05-11','11:50:00',8.16),('8902','2013-05-11','11:55:00',6.19),('8902','2013-05-11','12:00:00',4.13),('8902','2013-05-11','12:05:00',5.52),('8902','2013-05-11','12:10:00',9.6),('8902','2013-05-11','12:15:00',5.23),('8902','2013-05-11','12:20:00',2.16),('8902','2013-05-11','12:25:00',1.91),('8902','2013-05-11','12:30:00',1.92),('8902','2013-05-11','12:35:00',2.62),('8902','2013-05-11','12:40:00',3.2),('8902','2013-05-11','12:45:00',5.1),('8902','2013-05-11','12:50:00',9.76),('8902','2013-05-11','12:55:00',3.66),('8902','2013-05-11','13:00:00',2.68),('8902','2013-05-11','13:05:00',2.71),('8902','2013-05-11','13:10:00',4.47),('8902','2013-05-11','13:15:00',4.89),('8902','2013-05-11','13:20:00',3.26),('8902','2013-05-11','13:25:00',4.53),('8902','2013-05-11','13:30:00',8.2),('8902','2013-05-11','13:35:00',8.51),('8902','2013-05-11','13:40:00',7.04),('8902','2013-05-11','13:45:00',9.69),('8902','2013-05-11','13:50:00',5.4),('8902','2013-05-11','13:55:00',7.5),('8902','2013-05-11','14:00:00',4.64),('8902','2013-05-11','14:05:00',9.7),('8902','2013-05-11','14:10:00',5.76),('8902','2013-05-11','14:15:00',8.41),('8902','2013-05-11','14:20:00',8.8),('8902','2013-05-11','14:25:00',8.76),('8902','2013-05-11','14:30:00',8.58),('8902','2013-05-11','14:35:00',8.12),('8902','2013-05-11','14:40:00',7.32),('8902','2013-05-11','14:45:00',8.31),('8902','2013-05-11','14:50:00',7.72),('8902','2013-05-11','14:55:00',8.19),('8902','2013-05-11','15:00:00',8.12),('8902','2013-05-11','15:05:00',8.07),('8902','2013-05-11','15:10:00',8.11),('8902','2013-05-11','15:15:00',8.06),('8902','2013-05-11','15:20:00',6.75),('8902','2013-05-11','15:25:00',6.15),('8902','2013-05-11','15:30:00',6.47),('8902','2013-05-11','15:35:00',7.36),('8902','2013-05-11','15:40:00',7.21),('8902','2013-05-11','15:45:00',7.07),('8902','2013-05-11','15:50:00',6.94),('8902','2013-05-11','15:55:00',6.84),('8902','2013-05-11','16:00:00',6.71),('8902','2013-05-11','16:05:00',6.59),('8902','2013-05-11','16:10:00',6.48),('8902','2013-05-11','16:15:00',6.38),('8902','2013-05-11','16:20:00',6.3),('8902','2013-05-11','16:25:00',6.06),('8902','2013-05-11','16:30:00',5.95),('8902','2013-05-11','16:35:00',5.89),('8902','2013-05-11','16:40:00',5.91),('8902','2013-05-11','16:45:00',6.09),('8902','2013-05-11','16:50:00',5.79),('8902','2013-05-11','16:55:00',6.32),('8902','2013-05-11','17:00:00',6.57),('8902','2013-05-11','17:05:00',5.77),('8902','2013-05-11','17:10:00',5.88),('8902','2013-05-11','17:15:00',5.75),('8902','2013-05-11','17:20:00',5.53),('8902','2013-05-11','17:25:00',4.38),('8902','2013-05-11','17:30:00',4.27),('8902','2013-05-11','17:35:00',2.87),('8902','2013-05-11','17:40:00',3.99),('8902','2013-05-11','17:45:00',1.98),('8902','2013-05-11','17:50:00',2.02),('8902','2013-05-11','17:55:00',1.88),('8902','2013-05-11','18:00:00',2.07),('8902','2013-05-11','18:05:00',2.99),('8902','2013-05-11','18:10:00',3.07),('8902','2013-05-11','18:15:00',2.76),('8902','2013-05-11','18:20:00',1.94),('8902','2013-05-11','18:25:00',2.45),('8902','2013-05-11','18:30:00',2.02),('8902','2013-05-11','18:35:00',2.28),('8902','2013-05-11','18:40:00',1.9),('8902','2013-05-11','18:45:00',1.31),('8902','2013-05-11','18:50:00',1.17),('8902','2013-05-11','18:55:00',1.36),('8902','2013-05-11','19:00:00',1.42),('8902','2013-05-11','19:05:00',1.26),('8902','2013-05-11','19:10:00',1.08),('8902','2013-05-11','19:15:00',1.13),('8902','2013-05-11','19:20:00',1.06),('8902','2014-03-30','08:05:00',1.08),('8902','2014-03-30','08:10:00',1.29),('8902','2014-03-30','08:15:00',1.47),('8902','2014-03-30','08:20:00',1.64),('8902','2014-03-30','08:25:00',1.81),('8902','2014-03-30','08:30:00',1.98),('8902','2014-03-30','08:35:00',2.15),('8902','2014-03-30','08:40:00',2.27),('8902','2014-03-30','08:45:00',2.45),('8902','2014-03-30','08:50:00',2.63),('8902','2014-03-30','08:55:00',2.83),('8902','2014-03-30','09:00:00',3.02),('8902','2014-03-30','09:05:00',3.22),('8902','2014-03-30','09:10:00',3.4),('8902','2014-03-30','09:15:00',3.6),('8902','2014-03-30','09:20:00',3.77),('8902','2014-03-30','09:25:00',3.97),('8902','2014-03-30','09:30:00',4.17),('8902','2014-03-30','09:35:00',4.35),('8902','2014-03-30','09:40:00',4.48),('8902','2014-03-30','09:45:00',4.63),('8902','2014-03-30','09:50:00',4.76),('8902','2014-03-30','09:55:00',4.91),('8902','2014-03-30','10:00:00',5.04),('8902','2014-03-30','10:05:00',5.19),('8902','2014-03-30','10:10:00',5.34),('8902','2014-03-30','10:15:00',5.48),('8902','2014-03-30','10:20:00',5.58),('8902','2014-03-30','10:25:00',5.7),('8902','2014-03-30','10:30:00',5.79),('8902','2014-03-30','10:35:00',5.9),('8902','2014-03-30','10:40:00',6.02),('8902','2014-03-30','10:45:00',6.17),('8902','2014-03-30','10:50:00',6.28),('8902','2014-03-30','10:55:00',6.44),('8902','2014-03-30','11:00:00',6.52),('8902','2014-03-30','11:05:00',6.62),('8902','2014-03-30','11:10:00',6.71),('8902','2014-03-30','11:15:00',6.82),('8902','2014-03-30','11:20:00',6.91),('8902','2014-03-30','11:25:00',6.96),('8902','2014-03-30','11:30:00',6.97),('8902','2014-03-30','11:35:00',7.04),('8902','2014-03-30','11:40:00',7.15),('8902','2014-03-30','11:45:00',7.16),('8902','2014-03-30','11:50:00',7.23),('8902','2014-03-30','11:55:00',7.33),('8902','2014-03-30','12:00:00',7.51),('8902','2014-03-30','12:05:00',7.49),('8902','2014-03-30','12:10:00',7.46),('8902','2014-03-30','12:15:00',7.49),('8902','2014-03-30','12:20:00',7.58),('8902','2014-03-30','12:25:00',7.63),('8902','2014-03-30','12:30:00',7.68),('8902','2014-03-30','12:35:00',7.75),('8902','2014-03-30','12:40:00',7.84),('8902','2014-03-30','12:45:00',7.85),('8902','2014-03-30','12:50:00',7.79),('8902','2014-03-30','12:55:00',7.74),('8902','2014-03-30','13:00:00',7.8),('8902','2014-03-30','13:05:00',7.9),('8902','2014-03-30','13:10:00',7.9),('8902','2014-03-30','13:15:00',7.88),('8902','2014-03-30','13:20:00',7.92),('8902','2014-03-30','13:25:00',7.91),('8902','2014-03-30','13:30:00',7.96),('8902','2014-03-30','13:35:00',8.01),('8902','2014-03-30','13:40:00',7.98),('8902','2014-03-30','13:45:00',7.98),('8902','2014-03-30','13:50:00',7.96),('8902','2014-03-30','13:55:00',7.94),('8902','2014-03-30','14:00:00',7.92),('8902','2014-03-30','14:05:00',7.91),('8902','2014-03-30','14:10:00',7.86),('8902','2014-03-30','14:15:00',7.84),('8902','2014-03-30','14:20:00',7.83),('8902','2014-03-30','14:25:00',7.8),('8902','2014-03-30','14:30:00',7.8),('8902','2014-03-30','14:35:00',7.73),('8902','2014-03-30','14:40:00',7.67),('8902','2014-03-30','14:45:00',7.67),('8902','2014-03-30','14:50:00',7.61),('8902','2014-03-30','14:55:00',7.51),('8902','2014-03-30','15:00:00',7.49),('8902','2014-03-30','15:05:00',7.43),('8902','2014-03-30','15:10:00',7.4),('8902','2014-03-30','15:15:00',7.32),('8902','2014-03-30','15:20:00',7.2),('8902','2014-03-30','15:25:00',7.06),('8902','2014-03-30','15:30:00',6.97),('8902','2014-03-30','15:35:00',6.87),('8902','2014-03-30','15:40:00',6.8),('8902','2014-03-30','15:45:00',6.71),('8902','2014-03-30','15:50:00',6.57),('8902','2014-03-30','15:55:00',6.42),('8902','2014-03-30','16:00:00',6.29),('8902','2014-03-30','16:05:00',6.17),('8902','2014-03-30','16:10:00',6.04),('8902','2014-03-30','16:15:00',5.93),('8902','2014-03-30','16:20:00',5.79),('8902','2014-03-30','16:25:00',5.57),('8902','2014-03-30','16:30:00',5.46),('8902','2014-03-30','16:35:00',5.3),('8902','2014-03-30','16:40:00',5.17),('8902','2014-03-30','16:45:00',5),('8902','2014-03-30','16:50:00',4.86),('8902','2014-03-30','16:55:00',4.68),('8902','2014-03-30','17:00:00',4.54),('8902','2014-03-30','17:05:00',4.32),('8902','2014-03-30','17:10:00',4.19),('8902','2014-03-30','17:15:00',4.01),('8902','2014-03-30','17:20:00',3.81),('8902','2014-03-30','17:25:00',3.61),('8902','2014-03-30','17:30:00',3.4),('8902','2014-03-30','17:35:00',3.21),('8902','2014-03-30','17:40:00',2.98),('8902','2014-03-30','17:45:00',2.86),('8902','2014-03-30','17:50:00',2.66),('8902','2014-03-30','17:55:00',2.42),('8902','2014-03-30','18:00:00',2.24),('8902','2014-03-30','18:05:00',2),('8902','2014-03-30','18:10:00',1.78),('8902','2014-03-30','18:15:00',1.61),('8902','2014-03-30','18:20:00',1.42),('8902','2014-03-30','18:25:00',1.25),('8902','2014-03-30','18:30:00',1.08),('8902','2013-05-10','07:25:00',1.05),('8902','2013-05-10','07:30:00',1.18),('8902','2013-05-10','07:35:00',1.23),('8902','2013-05-10','07:40:00',1.32),('8902','2013-05-10','07:45:00',1.62),('8902','2013-05-10','07:50:00',1.94),('8902','2013-05-10','07:55:00',2.24),('8902','2013-05-10','08:00:00',2.25),('8902','2013-05-10','08:05:00',2.01),('8902','2013-05-10','08:10:00',1.25),('8902','2013-05-10','08:15:00',2.63),('8902','2013-05-10','08:20:00',2.21),('8902','2013-05-10','08:25:00',1.61),('8902','2013-05-10','08:30:00',1.67),('8902','2013-05-10','08:35:00',2.22),('8902','2013-05-10','08:40:00',1.36),('8902','2013-05-10','08:55:00',1.09),('8902','2013-05-10','09:00:00',1.19),('8902','2013-05-10','09:05:00',1.71),('8902','2013-05-10','09:10:00',1.69),('8902','2013-05-10','09:15:00',1.92),('8902','2013-05-10','09:20:00',2.66),('8902','2013-05-10','09:25:00',2.78),('8902','2013-05-10','09:30:00',3.18),('8902','2013-05-10','09:35:00',5.63),('8902','2013-05-10','09:40:00',4.27),('8902','2013-05-10','09:45:00',5.27),('8902','2013-05-10','09:50:00',2.49),('8902','2013-05-10','09:55:00',2.27),('8902','2013-05-10','10:00:00',2.65),('8902','2013-05-10','10:05:00',2.64),('8902','2013-05-10','10:10:00',1.97),('8902','2013-05-10','10:15:00',1.5),('8902','2013-05-10','10:20:00',1.88),('8902','2013-05-10','10:25:00',1.86),('8902','2013-05-10','10:30:00',2.1),('8902','2013-05-10','10:35:00',2.32),('8902','2013-05-10','10:40:00',1.91),('8902','2013-05-10','10:45:00',1.55),('8902','2013-05-10','10:50:00',1.84),('8902','2013-05-10','10:55:00',6.55),('8902','2013-05-10','11:00:00',4.8),('8902','2013-05-10','11:05:00',5.01),('8902','2013-05-10','11:10:00',2.36),('8902','2013-05-10','11:15:00',1.8),('8902','2013-05-10','11:20:00',1.51),('8902','2013-05-10','11:25:00',1.63),('8902','2013-05-10','11:30:00',2.49),('8902','2013-05-10','11:35:00',5.16),('8902','2013-05-10','11:40:00',4.2),('8902','2013-05-10','11:45:00',7.38),('8902','2013-05-10','11:50:00',5.1),('8902','2013-05-10','11:55:00',2.03),('8902','2013-05-10','12:00:00',2.27),('8902','2013-05-10','12:05:00',3.5),('8902','2013-05-10','12:10:00',2.81),('8902','2013-05-10','12:15:00',2.73),('8902','2013-05-10','12:20:00',3.07),('8902','2013-05-10','12:25:00',8.26),('8902','2013-05-10','12:30:00',6.45),('8902','2013-05-10','12:35:00',3.17),('8902','2013-05-10','12:40:00',3.72),('8902','2013-05-10','12:45:00',4.24),('8902','2013-05-10','12:50:00',4.43),('8902','2013-05-10','12:55:00',3.18),('8902','2013-05-10','13:00:00',2.98),('8902','2013-05-10','13:05:00',3.24),('8902','2013-05-10','13:10:00',2.4),('8902','2013-05-10','13:15:00',1.44),('8902','2013-05-10','13:20:00',1.55),('8902','2013-05-10','13:25:00',1.93),('8902','2013-05-10','13:30:00',2.13),('8902','2013-05-10','13:35:00',1.97),('8902','2013-05-10','13:40:00',1.58),('8902','2013-05-10','13:50:00',1.25),('8902','2013-05-10','13:55:00',1.46),('8902','2013-05-10','14:00:00',3.27),('8902','2013-05-10','14:05:00',4.97),('8902','2013-05-10','14:10:00',6.4),('8902','2013-05-10','14:15:00',5.69),('8902','2013-05-10','14:20:00',8.88),('8902','2013-05-10','14:25:00',9),('8902','2013-05-10','14:30:00',6.45),('8902','2013-05-10','14:35:00',5.56),('8902','2013-05-10','14:40:00',9.15),('8902','2013-05-10','14:45:00',8.02),('8902','2013-05-10','14:50:00',8.65),('8902','2013-05-10','14:55:00',8.34),('8902','2013-05-10','15:00:00',8.08),('8902','2013-05-10','15:05:00',7.91),('8902','2013-05-10','15:10:00',7.2),('8902','2013-05-10','15:15:00',7.95),('8902','2013-05-10','15:20:00',7.02),('8902','2013-05-10','15:25:00',7.68),('8902','2013-05-10','15:30:00',7.58),('8902','2013-05-10','15:35:00',7.48),('8902','2013-05-10','15:40:00',7.44),('8902','2013-05-10','15:45:00',7.15),('8902','2013-05-10','15:50:00',7.61),('8902','2013-05-10','15:55:00',7.22),('8902','2013-05-10','16:00:00',4.32),('8902','2013-05-10','16:05:00',6.32),('8902','2013-05-10','16:10:00',6.29),('8902','2013-05-10','16:15:00',5.93),('8902','2013-05-10','16:20:00',5.62),('8902','2013-05-10','16:25:00',6.41),('8902','2013-05-10','16:30:00',6.31),('8902','2013-05-10','16:35:00',6.25),('8902','2013-05-10','16:40:00',5.51),('8902','2013-05-10','16:45:00',5.72),('8902','2013-05-10','16:50:00',5.32),('8902','2013-05-10','16:55:00',5.19),('8902','2013-05-10','17:00:00',4.91),('8902','2013-05-10','17:05:00',5.27),('8902','2013-05-10','17:10:00',4.94),('8902','2013-05-10','17:15:00',3.67),('8902','2013-05-10','17:20:00',4.64),('8902','2013-05-10','17:25:00',3.45),('8902','2013-05-10','17:30:00',3.33),('8902','2013-05-10','17:35:00',4.21),('8902','2013-05-10','17:40:00',3.44),('8902','2013-05-10','17:45:00',4.25),('8902','2013-05-10','17:50:00',2.55),('8902','2013-05-10','17:55:00',3.57),('8902','2013-05-10','18:00:00',1.34),('8902','2013-05-10','18:05:00',2.3),('8902','2013-05-10','18:10:00',3.58),('8902','2013-05-10','18:15:00',2.91),('8902','2013-05-10','18:20:00',1.4),('8902','2013-05-10','18:25:00',2.26),('8902','2013-05-10','18:30:00',1.69),('8902','2013-05-10','18:35:00',1.62),('8902','2013-05-10','18:40:00',1.28),('8902','2013-05-10','18:45:00',1.61),('8902','2013-05-10','18:50:00',1.27),('8902','2013-05-10','18:55:00',1.44),('8902','2013-05-10','19:00:00',1.13),('8902','2013-05-09','07:15:00',1.11),('8902','2013-05-09','07:20:00',1.03),('8902','2013-05-09','07:30:00',1.19),('8902','2013-05-09','07:35:00',1.22),('8902','2013-05-09','07:40:00',1.34),('8902','2013-05-09','07:45:00',1.59),('8902','2013-05-09','07:50:00',1.39),('8902','2013-05-09','07:55:00',1.59),('8902','2013-05-09','08:00:00',2.23),('8902','2013-05-09','08:05:00',2.82),('8902','2013-05-09','08:10:00',3.13),('8902','2013-05-09','08:15:00',3.58),('8902','2013-05-09','08:20:00',3.4),('8902','2013-05-09','08:25:00',3.29),('8902','2013-05-09','08:30:00',3.13),('8902','2013-05-09','08:35:00',3.43),('8902','2013-05-09','08:40:00',1.99),('8902','2013-05-09','08:45:00',1.17),('8902','2013-05-09','08:50:00',1.11),('8902','2013-05-09','08:55:00',1.07),('8902','2013-05-09','09:00:00',2.36),('8902','2013-05-09','09:05:00',3.84),('8902','2013-05-09','09:10:00',4.61),('8902','2013-05-09','09:15:00',4.79),('8902','2013-05-09','09:20:00',4.62),('8902','2013-05-09','09:25:00',4.38),('8902','2013-05-09','09:30:00',4.01),('8902','2013-05-09','09:35:00',5.06),('8902','2013-05-09','09:40:00',4.78),('8902','2013-05-09','09:45:00',4.66),('8902','2013-05-09','09:50:00',5.78),('8902','2013-05-09','09:55:00',5.83),('8902','2013-05-09','10:00:00',5.09),('8902','2013-05-09','10:05:00',6.16),('8902','2013-05-09','10:10:00',4.87),('8902','2013-05-09','10:15:00',4.6),('8902','2013-05-09','10:20:00',6.56),('8902','2013-05-09','10:25:00',3.01),('8902','2013-05-09','10:30:00',3.7),('8902','2013-05-09','10:35:00',5.76),('8902','2013-05-09','10:40:00',7.13),('8902','2013-05-09','10:45:00',7.14),('8902','2013-05-09','10:50:00',7.36),('8902','2013-05-09','10:55:00',7.27),('8902','2013-05-09','11:00:00',7.45),('8902','2013-05-09','11:05:00',7.38),('8902','2013-05-09','11:10:00',7.21),('8902','2013-05-09','11:15:00',6.83),('8902','2013-05-09','11:20:00',7.94),('8902','2013-05-09','11:25:00',7.1),('8902','2013-05-09','11:30:00',6.15),('8902','2013-05-09','11:35:00',7.42),('8902','2013-05-09','11:40:00',5.81),('8902','2013-05-09','11:45:00',3.98),('8902','2013-05-09','11:50:00',5.43),('8902','2013-05-09','11:55:00',7),('8902','2013-05-09','12:00:00',7.91),('8902','2013-05-09','12:05:00',6.44),('8902','2013-05-09','12:10:00',5.5),('8902','2013-05-09','12:15:00',4.47),('8902','2013-05-09','12:20:00',5.33),('8902','2013-05-09','12:25:00',4.24),('8902','2013-05-09','12:30:00',3.9),('8902','2013-05-09','12:35:00',3.93),('8902','2013-05-09','12:40:00',6.91),('8902','2013-05-09','12:45:00',8.69),('8902','2013-05-09','12:50:00',6.79),('8902','2013-05-09','12:55:00',5.6),('8902','2013-05-09','13:00:00',7.85),('8902','2013-05-09','13:05:00',6.74),('8902','2013-05-09','13:10:00',7.41),('8902','2013-05-09','13:15:00',9.03),('8902','2013-05-09','13:20:00',6.26),('8902','2013-05-09','13:25:00',5.73),('8902','2013-05-09','13:30:00',6.25),('8902','2013-05-09','13:35:00',8.38),('8902','2013-05-09','13:40:00',8.12),('8902','2013-05-09','13:45:00',7.46),('8902','2013-05-09','13:50:00',4.76),('8902','2013-05-09','13:55:00',4.03),('8902','2013-05-09','14:00:00',3.68),('8902','2013-05-09','14:05:00',3.74),('8902','2013-05-09','14:10:00',4.41),('8902','2013-05-09','14:15:00',4.88),('8902','2013-05-09','14:20:00',4.9),('8902','2013-05-09','14:25:00',4.77),('8902','2013-05-09','14:30:00',4.85),('8902','2013-05-09','14:35:00',5.99),('8902','2013-05-09','14:40:00',5.4),('8902','2013-05-09','14:45:00',4.11),('8902','2013-05-09','14:50:00',2.89),('8902','2013-05-09','14:55:00',2.44),('8902','2013-05-09','15:00:00',2.28),('8902','2013-05-09','15:05:00',2.4),('8902','2013-05-09','15:10:00',3.21),('8902','2013-05-09','15:15:00',5.16),('8902','2013-05-09','15:20:00',5.78),('8902','2013-05-09','15:25:00',3.93),('8902','2013-05-09','15:30:00',3.58),('8902','2013-05-09','15:35:00',3.75),('8902','2013-05-09','15:40:00',3.91),('8902','2013-05-09','15:45:00',3.79),('8902','2013-05-09','15:50:00',3.46),('8902','2013-05-09','15:55:00',3.22),('8902','2013-05-09','16:00:00',3.07),('8902','2013-05-09','16:05:00',2.98),('8902','2013-05-09','16:10:00',2.92),('8902','2013-05-09','16:15:00',2.76),('8902','2013-05-09','16:20:00',2.47),('8902','2013-05-09','16:25:00',2.42),('8902','2013-05-09','16:30:00',2.53),('8902','2013-05-09','16:35:00',2.68),('8902','2013-05-09','16:40:00',2.59),('8902','2013-05-09','16:45:00',2.55),('8902','2013-05-09','16:50:00',2.63),('8902','2013-05-09','16:55:00',2.24),('8902','2013-05-09','17:00:00',1.77),('8902','2013-05-09','17:05:00',1.68),('8902','2013-05-09','17:10:00',2.12),('8902','2013-05-09','17:15:00',2.55),('8902','2013-05-09','17:20:00',3.92),('8902','2013-05-09','17:25:00',3.96),('8902','2013-05-09','17:30:00',3.32),('8902','2013-05-09','17:35:00',4.22),('8902','2013-05-09','17:40:00',2.71),('8902','2013-05-09','17:45:00',2.48),('8902','2013-05-09','17:50:00',2.12),('8902','2013-05-09','17:55:00',1.88),('8902','2013-05-09','18:00:00',1.75),('8902','2013-05-09','18:05:00',1.72),('8902','2013-05-09','18:10:00',1.55),('8902','2013-05-09','18:15:00',1.31),('8902','2013-05-09','18:20:00',1.33),('8902','2013-05-09','18:25:00',1.26),('8902','2013-05-09','18:30:00',1),('8902','2013-05-08','07:30:00',1.14),('8902','2013-05-08','07:35:00',1.3),('8902','2013-05-08','07:40:00',1.46),('8902','2013-05-08','07:45:00',1.63),('8902','2013-05-08','07:50:00',1.78),('8902','2013-05-08','07:55:00',1.94),('8902','2013-05-08','08:00:00',2.11),('8902','2013-05-08','08:05:00',2.29),('8902','2013-05-08','08:10:00',2.45),('8902','2013-05-08','08:15:00',2.63),('8902','2013-05-08','08:20:00',2.79),('8902','2013-05-08','08:25:00',2.97),('8902','2013-05-08','08:30:00',3.14),('8902','2013-05-08','08:35:00',3.31),('8902','2013-05-08','08:40:00',3.49),('8902','2013-05-08','08:45:00',3.67),('8902','2013-05-08','08:50:00',3.82),('8902','2013-05-08','08:55:00',3.98),('8902','2013-05-08','09:00:00',4.15),('8902','2013-05-08','09:05:00',4.3),('8902','2013-05-08','09:10:00',4.47),('8902','2013-05-08','09:15:00',4.64),('8902','2013-05-08','09:20:00',4.77),('8902','2013-05-08','09:25:00',4.94),('8902','2013-05-08','09:30:00',5.1),('8902','2013-05-08','09:35:00',5.24),('8902','2013-05-08','09:40:00',5.37),('8902','2013-05-08','09:45:00',5.49),('8902','2013-05-08','09:50:00',5.63),('8902','2013-05-08','09:55:00',5.76),('8902','2013-05-08','10:00:00',5.88),('8902','2013-05-08','10:05:00',5.98),('8902','2013-05-08','10:10:00',6.08),('8902','2013-05-08','10:15:00',6.22),('8902','2013-05-08','10:20:00',6.33),('8902','2013-05-08','10:25:00',6.44),('8902','2013-05-08','10:30:00',6.52),('8902','2013-05-08','10:35:00',6.61),('8902','2013-05-08','10:40:00',6.71),('8902','2013-05-08','10:45:00',6.75),('8902','2013-05-08','10:50:00',6.85),('8902','2013-05-08','10:55:00',6.95),('8902','2013-05-08','11:00:00',7),('8902','2013-05-08','11:05:00',7.11),('8902','2013-05-08','11:10:00',7.22),('8902','2013-05-08','11:15:00',7.28),('8902','2013-05-08','11:20:00',7.34),('8902','2013-05-08','11:25:00',7.37),('8902','2013-05-08','11:30:00',7.38),('8902','2013-05-08','11:35:00',7.41),('8902','2013-05-08','11:40:00',7.51),('8902','2013-05-08','11:45:00',7.55),('8902','2013-05-08','11:50:00',7.58),('8902','2013-05-08','11:55:00',7.62),('8902','2013-05-08','12:00:00',7.71),('8902','2013-05-08','12:05:00',7.82),('8902','2013-05-08','12:10:00',7.84),('8902','2013-05-08','12:15:00',7.91),('8902','2013-05-08','12:20:00',7.82),('8902','2013-05-08','12:25:00',5),('8902','2013-05-08','12:30:00',7.18),('8902','2013-05-08','12:35:00',8.1),('8902','2013-05-08','12:40:00',5.91),('8902','2013-05-08','12:45:00',4.77),('8902','2013-05-08','12:50:00',7.73),('8902','2013-05-08','12:55:00',8.22),('8902','2013-05-08','13:00:00',8.1),('8902','2013-05-08','13:05:00',8.05),('8902','2013-05-08','13:10:00',8.13),('8902','2013-05-08','13:15:00',8.08),('8902','2013-05-08','13:20:00',8.15),('8902','2013-05-08','13:25:00',8.12),('8902','2013-05-08','13:30:00',8.17),('8902','2013-05-08','13:35:00',8.13),('8902','2013-05-08','13:40:00',8.2),('8902','2013-05-08','13:45:00',8.23),('8902','2013-05-08','13:50:00',8.1),('8902','2013-05-08','13:55:00',7.82),('8902','2013-05-08','14:00:00',8.03),('8902','2013-05-08','14:05:00',8.11),('8902','2013-05-08','14:10:00',6.6),('8902','2013-05-08','14:15:00',6.09),('8902','2013-05-08','14:20:00',7.92),('8902','2013-05-08','14:25:00',6.77),('8902','2013-05-08','14:30:00',7.42),('8902','2013-05-08','14:35:00',7.87),('8902','2013-05-08','14:40:00',7.89),('8902','2013-05-08','14:45:00',7.81),('8902','2013-05-08','14:50:00',7.73),('8902','2013-05-08','14:55:00',7.77),('8902','2013-05-08','15:00:00',7.68),('8902','2013-05-08','15:05:00',7.51),('8902','2013-05-08','15:10:00',7.43),('8902','2013-05-08','15:15:00',7.36),('8902','2013-05-08','15:20:00',7.24),('8902','2013-05-08','15:25:00',7.18),('8902','2013-05-08','15:30:00',7.22),('8902','2013-05-08','15:35:00',7.13),('8902','2013-05-08','15:40:00',7.04),('8902','2013-05-08','15:45:00',6.94),('8902','2013-05-08','15:50:00',6.88),('8902','2013-05-08','15:55:00',6.75),('8902','2013-05-08','16:00:00',6.61),('8902','2013-05-08','16:05:00',6.57),('8902','2013-05-08','16:10:00',6.42),('8902','2013-05-08','16:15:00',6.28),('8902','2013-05-08','16:20:00',6.17),('8902','2013-05-08','16:25:00',5.99),('8902','2013-05-08','16:30:00',5.81),('8902','2013-05-08','16:35:00',5.77),('8902','2013-05-08','16:40:00',5.59),('8902','2013-05-08','16:45:00',5.32),('8902','2013-05-08','16:50:00',5.16),('8902','2013-05-08','16:55:00',5.09),('8902','2013-05-08','17:00:00',4.97),('8902','2013-05-08','17:05:00',4.83),('8902','2013-05-08','17:10:00',4.64),('8902','2013-05-08','17:15:00',4.49),('8902','2013-05-08','17:20:00',4.35),('8902','2013-05-08','17:25:00',4.22),('8902','2013-05-08','17:30:00',4.02),('8902','2013-05-08','17:35:00',3.88),('8902','2013-05-08','17:40:00',3.68),('8902','2013-05-08','17:45:00',3.44),('8902','2013-05-08','17:50:00',3.32),('8902','2013-05-08','17:55:00',3.13),('8902','2013-05-08','18:00:00',2.94),('8902','2013-05-08','18:05:00',2.77),('8902','2013-05-08','18:10:00',2.56),('8902','2013-05-08','18:15:00',2.39),('8902','2013-05-08','18:20:00',2.21),('8902','2013-05-08','18:25:00',1.99),('8902','2013-05-08','18:30:00',1.86),('8902','2013-05-08','18:35:00',1.7),('8902','2013-05-08','18:40:00',1.49),('8902','2013-05-08','18:45:00',1.32),('8902','2013-05-08','18:50:00',1.19),('8902','2013-05-08','18:55:00',1.02),('8902','2013-05-07','07:55:00',1.35),('8902','2013-05-07','08:05:00',1.76),('8902','2013-05-07','08:10:00',2.72),('8902','2013-05-07','08:15:00',2.85),('8902','2013-05-07','08:20:00',2.9),('8902','2013-05-07','08:25:00',2.95),('8902','2013-05-07','08:30:00',3.16),('8902','2013-05-07','08:35:00',3.3),('8902','2013-05-07','08:40:00',3.51),('8902','2013-05-07','08:45:00',3.8),('8902','2013-05-07','08:50:00',4.54),('8902','2013-05-07','08:55:00',5.18),('8902','2013-05-07','09:00:00',5.46),('8902','2013-05-07','09:05:00',5.71),('8902','2013-05-07','09:10:00',5.22),('8902','2013-05-07','09:15:00',5.15),('8902','2013-05-07','09:20:00',3.26),('8902','2013-05-07','09:25:00',1.29),('8902','2013-05-07','09:30:00',1.15),('8902','2013-05-07','09:35:00',1.35),('8902','2013-05-07','09:40:00',1.83),('8902','2013-05-07','09:45:00',4.54),('8902','2013-05-07','09:50:00',2.03),('8902','2013-05-07','09:55:00',1.73),('8902','2013-05-07','10:00:00',3.47),('8902','2013-05-07','10:05:00',5.68),('8902','2013-05-07','10:10:00',5.49),('8902','2013-05-07','10:15:00',3.68),('8902','2013-05-07','10:20:00',3.79),('8902','2013-05-07','10:25:00',3.96),('8902','2013-05-07','10:30:00',3.88),('8902','2013-05-07','10:35:00',1.66),('8902','2013-05-07','10:40:00',1.63),('8902','2013-05-07','10:45:00',1.63),('8902','2013-05-07','10:50:00',1.56),('8902','2013-05-07','10:55:00',1.93),('8902','2013-05-07','11:00:00',2.72),('8902','2013-05-07','11:05:00',4.5),('8902','2013-05-07','11:10:00',7.07),('8902','2013-05-07','11:15:00',8.2),('8902','2013-05-07','11:20:00',7.74),('8902','2013-05-07','11:25:00',7.47),('8902','2013-05-07','11:30:00',8.12),('8902','2013-05-07','11:35:00',8.38),('8902','2013-05-07','11:40:00',8.47),('8902','2013-05-07','11:45:00',5.77),('8902','2013-05-07','11:50:00',4.02),('8902','2013-05-07','11:55:00',3.13),('8902','2013-05-07','12:00:00',7.86),('8902','2013-05-07','12:05:00',6.02),('8902','2013-05-07','12:10:00',1.4),('8902','2013-05-07','12:15:00',1.49),('8902','2013-05-07','12:20:00',1.82),('8902','2013-05-07','12:25:00',3),('8902','2013-05-07','12:30:00',3.01),('8902','2013-05-07','12:35:00',2.21),('8902','2013-05-07','12:40:00',2.55),('8902','2013-05-07','12:45:00',3.17),('8902','2013-05-07','12:50:00',6.69),('8902','2013-05-07','12:55:00',3.37),('8902','2013-05-07','13:00:00',8.69),('8902','2013-05-07','13:05:00',7.19),('8902','2013-05-07','13:10:00',6.73),('8902','2013-05-07','13:15:00',6.02),('8902','2013-05-07','13:20:00',2.17),('8902','2013-05-07','13:25:00',2.17),('8902','2013-05-07','13:30:00',1.81),('8902','2013-05-07','13:35:00',1.72),('8902','2013-05-07','13:40:00',1.91),('8902','2013-05-07','13:45:00',8.13),('8902','2013-05-07','13:50:00',8.5),('8902','2013-05-07','13:55:00',7.76),('8902','2013-05-07','14:00:00',8.16),('8902','2013-05-07','14:05:00',3.17),('8902','2013-05-07','14:10:00',3.59),('8902','2013-05-07','14:15:00',2.71),('8902','2013-05-07','14:20:00',5.38),('8902','2013-05-07','14:25:00',3.34),('8902','2013-05-07','14:30:00',5.97),('8902','2013-05-07','14:35:00',5.78),('8902','2013-05-07','14:40:00',3.77),('8902','2013-05-07','14:45:00',3.69),('8902','2013-05-07','14:50:00',4.85),('8902','2013-05-07','14:55:00',7.18),('8902','2013-05-07','15:00:00',7.5),('8902','2013-05-07','15:05:00',7.93),('8902','2013-05-07','15:10:00',6.29),('8902','2013-05-07','15:15:00',6.51),('8902','2013-05-07','15:20:00',7.72),('8902','2013-05-07','15:25:00',7.53),('8902','2013-05-07','15:30:00',7.42),('8902','2013-05-07','15:35:00',7.21),('8902','2013-05-07','15:40:00',7.1),('8902','2013-05-07','15:45:00',6.97),('8902','2013-05-07','15:50:00',6.91),('8902','2013-05-07','15:55:00',6.77),('8902','2013-05-07','16:00:00',6.74),('8902','2013-05-07','16:05:00',6.6),('8902','2013-05-07','16:10:00',6.54),('8902','2013-05-07','16:15:00',6.39),('8902','2013-05-07','16:20:00',6.23),('8902','2013-05-07','16:25:00',6.04),('8902','2013-05-07','16:30:00',6.09),('8902','2013-05-07','16:35:00',5.97),('8902','2013-05-07','16:40:00',5.82),('8902','2013-05-07','16:45:00',5.16),('8902','2013-05-07','16:50:00',5.74),('8902','2013-05-07','16:55:00',5.06),('8902','2013-05-07','17:00:00',4.92),('8902','2013-05-07','17:05:00',5.89),('8902','2013-05-07','17:10:00',5.46),('8902','2013-05-07','17:15:00',5),('8902','2013-05-07','17:20:00',4.79),('8902','2013-05-07','17:25:00',3.75),('8902','2013-05-07','17:30:00',4.69),('8902','2013-05-07','17:35:00',4.63),('8902','2013-05-07','17:40:00',4.46),('8902','2013-05-07','17:45:00',4.38),('8902','2013-05-07','17:50:00',4.4),('8902','2013-05-07','17:55:00',3.5),('8902','2013-05-07','18:00:00',1.61),('8902','2013-05-07','18:05:00',1.53),('8902','2013-05-07','18:10:00',1.9),('8902','2013-05-07','18:15:00',2.72),('8902','2013-05-07','18:20:00',2.58),('8902','2013-05-07','18:25:00',2.39),('8902','2013-05-07','18:30:00',2.05),('8902','2013-05-07','18:35:00',1.87),('8902','2013-05-07','18:40:00',1.23),('8902','2013-05-06','07:30:00',1.11),('8902','2013-05-06','07:35:00',1.29),('8902','2013-05-06','07:40:00',1.44),('8902','2013-05-06','07:45:00',1.59),('8902','2013-05-06','07:50:00',1.75),('8902','2013-05-06','07:55:00',1.91),('8902','2013-05-06','08:00:00',2.11),('8902','2013-05-06','08:05:00',2.26),('8902','2013-05-06','08:10:00',2.45),('8902','2013-05-06','08:15:00',2.63),('8902','2013-05-06','08:20:00',2.8),('8902','2013-05-06','08:25:00',2.97),('8902','2013-05-06','08:30:00',3.17),('8902','2013-05-06','08:35:00',3.33),('8902','2013-05-06','08:40:00',3.47),('8902','2013-05-06','08:45:00',3.75),('8902','2013-05-06','08:50:00',4.03),('8902','2013-05-06','08:55:00',4.3),('8902','2013-05-06','09:00:00',4.52),('8902','2013-05-06','09:05:00',5.06),('8902','2013-05-06','09:10:00',5.23),('8902','2013-05-06','09:15:00',5.71),('8902','2013-05-06','09:20:00',2.49),('8902','2013-05-06','09:25:00',1.47),('8902','2013-05-06','09:30:00',1.86),('8902','2013-05-06','09:35:00',5.86),('8902','2013-05-06','09:40:00',4.3),('8902','2013-05-06','09:45:00',2.33),('8902','2013-05-06','09:50:00',3.28),('8902','2013-05-06','09:55:00',4.01),('8902','2013-05-06','10:00:00',3.78),('8902','2013-05-06','10:05:00',1.82),('8902','2013-05-06','10:10:00',1.44),('8902','2013-05-06','10:15:00',1.31),('8902','2013-05-06','10:20:00',1.2),('8902','2013-05-06','10:25:00',1.21),('8902','2013-05-06','10:30:00',1.2),('8902','2013-05-06','10:35:00',1.06),('8902','2013-05-06','10:40:00',1.07),('8902','2013-05-06','10:50:00',1),('8902','2013-05-06','10:55:00',1.29),('8902','2013-05-06','11:00:00',1.7),('8902','2013-05-06','11:05:00',2.04),('8902','2013-05-06','11:10:00',2.23),('8902','2013-05-06','11:15:00',2.53),('8902','2013-05-06','11:20:00',4.16),('8902','2013-05-06','11:25:00',6.02),('8902','2013-05-06','11:30:00',1.96),('8902','2013-05-06','11:35:00',1.31),('8902','2013-05-06','11:55:00',1.14),('8902','2013-05-06','12:00:00',1.25),('8902','2013-05-06','12:05:00',1.37),('8902','2013-05-06','12:10:00',2.09),('8902','2013-05-06','12:15:00',3.04),('8902','2013-05-06','12:20:00',1.88),('8902','2013-05-06','12:25:00',3.26),('8902','2013-05-06','12:30:00',6.96),('8902','2013-05-06','12:35:00',2.17),('8902','2013-05-06','12:40:00',1.84),('8902','2013-05-06','12:45:00',1.34),('8902','2013-05-06','13:05:00',1.03),('8902','2013-05-06','13:10:00',1.28),('8902','2013-05-06','13:15:00',1.88),('8902','2013-05-06','13:20:00',2.59),('8902','2013-05-06','13:25:00',3.11),('8902','2013-05-06','13:30:00',5.8),('8902','2013-05-06','13:35:00',7.1),('8902','2013-05-06','13:40:00',7.45),('8902','2013-05-06','13:45:00',7.35),('8902','2013-05-06','13:50:00',9.34),('8902','2013-05-06','13:55:00',9.06),('8902','2013-05-06','14:00:00',8.13),('8902','2013-05-06','14:05:00',8.73),('8902','2013-05-06','14:10:00',8.75),('8902','2013-05-06','14:15:00',8.8),('8902','2013-05-06','14:20:00',8.76),('8902','2013-05-06','14:25:00',8.86),('8902','2013-05-06','14:30:00',8.51),('8902','2013-05-06','14:35:00',9.25),('8902','2013-05-06','14:40:00',8.13),('8902','2013-05-06','14:45:00',8.23),('8902','2013-05-06','14:50:00',7.89),('8902','2013-05-06','14:55:00',6.55),('8902','2013-05-06','15:00:00',9.29),('8902','2013-05-06','15:05:00',8.44),('8902','2013-05-06','15:10:00',7.08),('8902','2013-05-06','15:15:00',7.04),('8902','2013-05-06','15:20:00',7.24),('8902','2013-05-06','15:25:00',5.52),('8902','2013-05-06','15:30:00',6.02),('8902','2013-05-06','15:35:00',6.78),('8902','2013-05-06','15:40:00',3.34),('8902','2013-05-06','15:45:00',3.21),('8902','2013-05-06','15:50:00',2.59),('8902','2013-05-06','15:55:00',3.39),('8902','2013-05-06','16:00:00',6.35),('8902','2013-05-06','16:05:00',6.13),('8902','2013-05-06','16:10:00',2.32),('8902','2013-05-06','16:15:00',5.75),('8902','2013-05-06','16:20:00',8.08),('8902','2013-05-06','16:25:00',7.88),('8902','2013-05-06','16:30:00',7.42),('8902','2013-05-06','16:35:00',7.34),('8902','2013-05-06','16:40:00',7.4),('8902','2013-05-06','16:45:00',5.36),('8902','2013-05-06','16:50:00',6.47),('8902','2013-05-06','16:55:00',5.58),('8902','2013-05-06','17:00:00',5.79),('8902','2013-05-06','17:05:00',5.98),('8902','2013-05-06','17:10:00',4.27),('8902','2013-05-06','17:15:00',2.37),('8902','2013-05-06','17:20:00',2.18),('8902','2013-05-06','17:25:00',2.27),('8902','2013-05-06','17:30:00',1.97),('8902','2013-05-06','17:35:00',1.87),('8902','2013-05-06','17:40:00',1.78),('8902','2013-05-06','17:45:00',1.64),('8902','2013-05-06','17:50:00',1.42),('8902','2013-05-06','17:55:00',1.1),('8902','2013-05-06','18:40:00',1.1),('8902','2013-05-06','18:45:00',1.31),('8902','2013-05-06','18:50:00',1.2),('8902','2013-05-05','08:15:00',1.12),('8902','2013-05-05','08:20:00',1.25),('8902','2013-05-05','08:25:00',2.07),('8902','2013-05-05','08:30:00',2.37),('8902','2013-05-05','08:35:00',1.97),('8902','2013-05-05','08:40:00',1.61),('8902','2013-05-05','08:45:00',1.29),('8902','2013-05-05','08:50:00',1.82),('8902','2013-05-05','08:55:00',3.03),('8902','2013-05-05','09:00:00',3.34),('8902','2013-05-05','09:05:00',2.45),('8902','2013-05-05','09:10:00',2.88),('8902','2013-05-05','09:15:00',2.27),('8902','2013-05-05','09:20:00',2.18),('8902','2013-05-05','09:25:00',1.97),('8902','2013-05-05','09:30:00',1.81),('8902','2013-05-05','09:35:00',1.27),('8902','2013-05-05','09:55:00',1.9),('8902','2013-05-05','10:00:00',3.15),('8902','2013-05-05','10:05:00',2.38),('8902','2013-05-05','10:10:00',2.22),('8902','2013-05-05','10:15:00',2.83),('8902','2013-05-05','10:20:00',3.39),('8902','2013-05-05','10:25:00',2.99),('8902','2013-05-05','10:30:00',3.48),('8902','2013-05-05','10:35:00',3.18),('8902','2013-05-05','10:40:00',3.22),('8902','2013-05-05','10:45:00',5.44),('8902','2013-05-05','10:50:00',4.52),('8902','2013-05-05','10:55:00',3.82),('8902','2013-05-05','11:00:00',3.95),('8902','2013-05-05','11:05:00',3.82),('8902','2013-05-05','11:10:00',3.64),('8902','2013-05-05','11:15:00',3.41),('8902','2013-05-05','11:20:00',4.06),('8902','2013-05-05','11:25:00',4.06),('8902','2013-05-05','11:30:00',4.2),('8902','2013-05-05','11:35:00',2.81),('8902','2013-05-05','11:40:00',7.31),('8902','2013-05-05','11:45:00',7.03),('8902','2013-05-05','11:50:00',5.36),('8902','2013-05-05','11:55:00',2.85),('8902','2013-05-05','12:00:00',4.14),('8902','2013-05-05','12:05:00',3.7),('8902','2013-05-05','12:10:00',6.94),('8902','2013-05-05','12:15:00',4.43),('8902','2013-05-05','12:20:00',4.73),('8902','2013-05-05','12:25:00',6.24),('8902','2013-05-05','12:30:00',7.9),('8902','2013-05-05','12:35:00',6.9),('8902','2013-05-05','12:40:00',6.86),('8902','2013-05-05','12:45:00',4.32),('8902','2013-05-05','12:50:00',5.37),('8902','2013-05-05','12:55:00',7.7),('8902','2013-05-05','13:00:00',3.78),('8902','2013-05-05','13:05:00',4.68),('8902','2013-05-05','13:10:00',8.55),('8902','2013-05-05','13:15:00',7.68),('8902','2013-05-05','13:20:00',8.46),('8902','2013-05-05','13:25:00',6.2),('8902','2013-05-05','13:30:00',7.11),('8902','2013-05-05','13:35:00',4.46),('8902','2013-05-05','13:40:00',9.86),('8902','2013-05-05','13:45:00',6.53),('8902','2013-05-05','13:50:00',8.22),('8902','2013-05-05','13:55:00',8.79),('8902','2013-05-05','14:00:00',9.24),('8902','2013-05-05','14:05:00',8.02),('8902','2013-05-05','14:10:00',5.58),('8902','2013-05-05','14:15:00',6.39),('8902','2013-05-05','14:20:00',8.04),('8902','2013-05-05','14:25:00',6.38),('8902','2013-05-05','14:30:00',6.23),('8902','2013-05-05','14:35:00',9.3),('8902','2013-05-05','14:40:00',8.63),('8902','2013-05-05','14:45:00',5.82),('8902','2013-05-05','14:50:00',6.58),('8902','2013-05-05','14:55:00',8.31),('8902','2013-05-05','15:00:00',5.16),('8902','2013-05-05','15:05:00',3.96),('8902','2013-05-05','15:10:00',4.78),('8902','2013-05-05','15:15:00',4.67),('8902','2013-05-05','15:20:00',5.86),('8902','2013-05-05','15:25:00',2.84),('8902','2013-05-05','15:30:00',6.06),('8902','2013-05-05','15:35:00',4.01),('8902','2013-05-05','15:40:00',5.94),('8902','2013-05-05','15:45:00',2.94),('8902','2013-05-05','15:50:00',2.92),('8902','2013-05-05','15:55:00',4.6),('8902','2013-05-05','16:00:00',3.16),('8902','2013-05-05','16:05:00',3.02),('8902','2013-05-05','16:10:00',2.42),('8902','2013-05-05','16:15:00',2.4),('8902','2013-05-05','16:20:00',3.44),('8902','2013-05-05','16:25:00',5.09),('8902','2013-05-05','16:30:00',5.84),('8902','2013-05-05','16:35:00',3.78),('8902','2013-05-05','16:40:00',5.89),('8902','2013-05-05','16:45:00',5.02),('8902','2013-05-05','16:50:00',4.16),('8902','2013-05-05','16:55:00',4.83),('8902','2013-05-05','17:00:00',2.69),('8902','2013-05-05','17:05:00',1.25),('8902','2013-05-05','17:10:00',1.06),('8902','2013-05-05','17:15:00',2.36),('8902','2013-05-05','17:20:00',2.04),('8902','2013-05-05','17:25:00',1.28),('8902','2013-05-05','17:30:00',1.23),('8902','2013-05-05','17:35:00',3.69),('8902','2013-05-05','17:40:00',3.24),('8902','2013-05-05','17:45:00',2.16),('8902','2013-05-05','17:50:00',2.05),('8902','2013-05-05','17:55:00',1.5),('8902','2013-05-05','18:00:00',2.29),('8902','2013-05-05','18:05:00',2.88),('8902','2013-05-05','18:10:00',2.28),('8902','2013-05-05','18:20:00',2.3),('8902','2013-05-05','18:25:00',2.39),('8902','2013-05-05','18:30:00',2.13),('8902','2013-05-05','18:35:00',1.52),('8902','2013-05-04','07:40:00',1.1),('8902','2013-05-04','07:45:00',1.53),('8902','2013-05-04','07:50:00',1.64),('8902','2013-05-04','07:55:00',1.72),('8902','2013-05-04','08:00:00',1.87),('8902','2013-05-04','08:05:00',2.09),('8902','2013-05-04','08:10:00',2.3),('8902','2013-05-04','08:15:00',2.51),('8902','2013-05-04','08:20:00',2.95),('8902','2013-05-04','08:25:00',3.69),('8902','2013-05-04','08:30:00',3.73),('8902','2013-05-04','08:35:00',3.58),('8902','2013-05-04','08:40:00',3.66),('8902','2013-05-04','08:45:00',2.88),('8902','2013-05-04','08:50:00',2.47),('8902','2013-05-04','08:55:00',2.3),('8902','2013-05-04','09:00:00',2.48),('8902','2013-05-04','09:05:00',2.86),('8902','2013-05-04','09:10:00',2.97),('8902','2013-05-04','09:15:00',3.61),('8902','2013-05-04','09:20:00',3.1),('8902','2013-05-04','09:25:00',3.75),('8902','2013-05-04','09:30:00',3.28),('8902','2013-05-04','09:35:00',2.88),('8902','2013-05-04','09:40:00',4.47),('8902','2013-05-04','09:45:00',4.61),('8902','2013-05-04','09:50:00',3.43),('8902','2013-05-04','09:55:00',6.12),('8902','2013-05-04','10:00:00',4.08),('8902','2013-05-04','10:05:00',3.82),('8902','2013-05-04','10:10:00',4.01),('8902','2013-05-04','10:15:00',3.29),('8902','2013-05-04','10:20:00',4.65),('8902','2013-05-04','10:25:00',4.39),('8902','2013-05-04','10:30:00',4.71),('8902','2013-05-04','10:35:00',4.47),('8902','2013-05-04','10:40:00',4.64),('8902','2013-05-04','10:45:00',4.7),('8902','2013-05-04','10:50:00',3.79),('8902','2013-05-04','10:55:00',3.2),('8902','2013-05-04','11:00:00',2.95),('8902','2013-05-04','11:05:00',3.72),('8902','2013-05-04','11:10:00',3.4),('8902','2013-05-04','11:15:00',3.28),('8902','2013-05-04','11:20:00',4.4),('8902','2013-05-04','11:25:00',6.16),('8902','2013-05-04','11:30:00',5.41),('8902','2013-05-04','11:35:00',7.01),('8902','2013-05-04','11:40:00',6.73),('8902','2013-05-04','11:45:00',5.89),('8902','2013-05-04','11:50:00',5.25),('8902','2013-05-04','11:55:00',5.65),('8902','2013-05-04','12:00:00',4.49),('8902','2013-05-04','12:05:00',4.97),('8902','2013-05-04','12:10:00',5.08),('8902','2013-05-04','12:15:00',5.04),('8902','2013-05-04','12:20:00',6.12),('8902','2013-05-04','12:25:00',6.68),('8902','2013-05-04','12:30:00',6.8),('8902','2013-05-04','12:35:00',8.32),('8902','2013-05-04','12:40:00',6.63),('8902','2013-05-04','12:45:00',6.47),('8902','2013-05-04','12:50:00',6.29),('8902','2013-05-04','12:55:00',7.77),('8902','2013-05-04','13:00:00',6.86),('8902','2013-05-04','13:05:00',8.04),('8902','2013-05-04','13:10:00',7.18),('8902','2013-05-04','13:15:00',8.63),('8902','2013-05-04','13:20:00',7.05),('8902','2013-05-04','13:25:00',4.42),('8902','2013-05-04','13:30:00',3.07),('8902','2013-05-04','13:35:00',6.3),('8902','2013-05-04','13:40:00',8.64),('8902','2013-05-04','13:45:00',8.26),('8902','2013-05-04','13:50:00',8.23),('8902','2013-05-04','13:55:00',8.24),('8902','2013-05-04','14:00:00',8.38),('8902','2013-05-04','14:05:00',8.61),('8902','2013-05-04','14:10:00',6.51),('8902','2013-05-04','14:15:00',6.07),('8902','2013-05-04','14:20:00',7.48),('8902','2013-05-04','14:25:00',7.67),('8902','2013-05-04','14:30:00',7.42),('8902','2013-05-04','14:35:00',7.35),('8902','2013-05-04','14:40:00',7.29),('8902','2013-05-04','14:45:00',7.28),('8902','2013-05-04','14:50:00',7.21),('8902','2013-05-04','14:55:00',7.13),('8902','2013-05-04','15:00:00',7.08),('8902','2013-05-04','15:05:00',7.04),('8902','2013-05-04','15:10:00',6.98),('8902','2013-05-04','15:15:00',6.92),('8902','2013-05-04','15:20:00',6.81),('8902','2013-05-04','15:25:00',6.78),('8902','2013-05-04','15:30:00',6.78),('8902','2013-05-04','15:35:00',6.69),('8902','2013-05-04','15:40:00',6.61),('8902','2013-05-04','15:45:00',6.52),('8902','2013-05-04','15:50:00',6.45),('8902','2013-05-04','15:55:00',6.37),('8902','2013-05-04','16:00:00',6.26),('8902','2013-05-04','16:05:00',6.16),('8902','2013-05-04','16:10:00',6.06),('8902','2013-05-04','16:15:00',5.98),('8902','2013-05-04','16:20:00',5.85),('8902','2013-05-04','16:25:00',5.64),('8902','2013-05-04','16:30:00',5.5),('8902','2013-05-04','16:35:00',5.42),('8902','2013-05-04','16:40:00',5.31),('8902','2013-05-04','16:45:00',5.08),('8902','2013-05-04','16:50:00',5),('8902','2013-05-04','16:55:00',4.84),('8902','2013-05-04','17:00:00',4.68),('8902','2013-05-04','17:05:00',4.51),('8902','2013-05-04','17:10:00',4.34),('8902','2013-05-04','17:15:00',4.24),('8902','2013-05-04','17:20:00',4.07),('8902','2013-05-04','17:25:00',3.9),('8902','2013-05-04','17:30:00',3.69),('8902','2013-05-04','17:35:00',3.54),('8902','2013-05-04','17:40:00',3.37),('8902','2013-05-04','17:45:00',3.19),('8902','2013-05-04','17:50:00',3.02),('8902','2013-05-04','17:55:00',2.84),('8902','2013-05-04','18:00:00',2.64),('8902','2013-05-04','18:05:00',2.47),('8902','2013-05-04','18:10:00',2.3),('8902','2013-05-04','18:15:00',2.14),('8902','2013-05-04','18:20:00',1.96),('8902','2013-05-04','18:25:00',1.77),('8902','2013-05-04','18:30:00',1.63),('8902','2013-05-04','18:35:00',1.5),('8902','2013-05-04','18:40:00',1.35),('8902','2013-05-04','18:45:00',1.17),('8902','2013-05-04','18:50:00',1.03),('8902','2013-05-03','07:40:00',1.29),('8902','2013-05-03','07:45:00',1.36),('8902','2013-05-03','07:50:00',1.5),('8902','2013-05-03','07:55:00',1.77),('8902','2013-05-03','08:00:00',1.95),('8902','2013-05-03','08:05:00',2.09),('8902','2013-05-03','08:10:00',2.22),('8902','2013-05-03','08:15:00',2.35),('8902','2013-05-03','08:20:00',2.5),('8902','2013-05-03','08:25:00',2.63),('8902','2013-05-03','08:30:00',2.79),('8902','2013-05-03','08:35:00',2.93),('8902','2013-05-03','08:40:00',3.09),('8902','2013-05-03','08:45:00',3.28),('8902','2013-05-03','08:50:00',3.44),('8902','2013-05-03','08:55:00',3.57),('8902','2013-05-03','09:00:00',3.71),('8902','2013-05-03','09:05:00',3.89),('8902','2013-05-03','09:10:00',4.06),('8902','2013-05-03','09:15:00',4.14),('8902','2013-05-03','09:20:00',4.38),('8902','2013-05-03','09:25:00',4.45),('8902','2013-05-03','09:30:00',4.55),('8902','2013-05-03','09:35:00',4.73),('8902','2013-05-03','09:40:00',4.91),('8902','2013-05-03','09:45:00',5.05),('8902','2013-05-03','09:50:00',5.19),('8902','2013-05-03','09:55:00',5.33),('8902','2013-05-03','10:00:00',5.48),('8902','2013-05-03','10:05:00',5.57),('8902','2013-05-03','10:10:00',5.75),('8902','2013-05-03','10:15:00',5.84),('8902','2013-05-03','10:20:00',5.93),('8902','2013-05-03','10:25:00',6.06),('8902','2013-05-03','10:30:00',6.17),('8902','2013-05-03','10:35:00',6.28),('8902','2013-05-03','10:40:00',6.26),('8902','2013-05-03','10:45:00',6.28),('8902','2013-05-03','10:50:00',6.28),('8902','2013-05-03','10:55:00',6.18),('8902','2013-05-03','11:00:00',6.26),('8902','2013-05-03','11:05:00',6.31),('8902','2013-05-03','11:10:00',6.07),('8902','2013-05-03','11:15:00',5.82),('8902','2013-05-03','11:20:00',6.23),('8902','2013-05-03','11:25:00',6.45),('8902','2013-05-03','11:30:00',6.17),('8902','2013-05-03','11:35:00',6.37),('8902','2013-05-03','11:40:00',6.15),('8902','2013-05-03','11:45:00',6.38),('8902','2013-05-03','11:50:00',6.39),('8902','2013-05-03','11:55:00',6.42),('8902','2013-05-03','12:00:00',6.21),('8902','2013-05-03','12:05:00',6.47),('8902','2013-05-03','12:10:00',6.63),('8902','2013-05-03','12:15:00',6.77),('8902','2013-05-03','12:20:00',6.98),('8902','2013-05-03','12:25:00',7.08),('8902','2013-05-03','12:30:00',7.07),('8902','2013-05-03','12:35:00',7.2),('8902','2013-05-03','12:40:00',7.17),('8902','2013-05-03','12:45:00',7.24),('8902','2013-05-03','12:50:00',7.02),('8902','2013-05-03','12:55:00',6.82),('8902','2013-05-03','13:00:00',6.73),('8902','2013-05-03','13:05:00',6.11),('8902','2013-05-03','13:10:00',6.65),('8902','2013-05-03','13:15:00',7.54),('8902','2013-05-03','13:20:00',7.65),('8902','2013-05-03','13:25:00',7.16),('8902','2013-05-03','13:30:00',7.29),('8902','2013-05-03','13:35:00',7.11),('8902','2013-05-03','13:40:00',7.15),('8902','2013-05-03','13:45:00',7.08),('8902','2013-05-03','13:50:00',6.28),('8902','2013-05-03','13:55:00',6.78),('8902','2013-05-03','14:00:00',6.64),('8902','2013-05-03','14:05:00',7),('8902','2013-05-03','14:10:00',6.64),('8902','2013-05-03','14:15:00',6.82),('8902','2013-05-03','14:20:00',6.93),('8902','2013-05-03','14:25:00',6.38),('8902','2013-05-03','14:30:00',6.66),('8902','2013-05-03','14:35:00',6.3),('8902','2013-05-03','14:40:00',6.57),('8902','2013-05-03','14:45:00',6.47),('8902','2013-05-03','14:50:00',6.14),('8902','2013-05-03','14:55:00',6.35),('8902','2013-05-03','15:00:00',6.45),('8902','2013-05-03','15:05:00',6.59),('8902','2013-05-03','15:10:00',6.16),('8902','2013-05-03','15:15:00',6.31),('8902','2013-05-03','15:20:00',6.48),('8902','2013-05-03','15:25:00',6.59),('8902','2013-05-03','15:30:00',6.48),('8902','2013-05-03','15:35:00',6.21),('8902','2013-05-03','15:40:00',6.11),('8902','2013-05-03','15:45:00',6.17),('8902','2013-05-03','15:50:00',6.14),('8902','2013-05-03','15:55:00',6.05),('8902','2013-05-03','16:00:00',5.88),('8902','2013-05-03','16:05:00',5.8),('8902','2013-05-03','16:10:00',5.73),('8902','2013-05-03','16:15:00',5.59),('8902','2013-05-03','16:20:00',5.48),('8902','2013-05-03','16:25:00',5.34),('8902','2013-05-03','16:30:00',5.22),('8902','2013-05-03','16:35:00',5.11),('8902','2013-05-03','16:40:00',4.98),('8902','2013-05-03','16:45:00',4.73),('8902','2013-05-03','16:50:00',4.59),('8902','2013-05-03','16:55:00',4.5),('8902','2013-05-03','17:00:00',4.39),('8902','2013-05-03','17:05:00',4.11),('8902','2013-05-03','17:10:00',3.27),('8902','2013-05-03','17:15:00',3.74),('8902','2013-05-03','17:20:00',3.87),('8902','2013-05-03','17:25:00',3.69),('8902','2013-05-03','17:30:00',3.45),('8902','2013-05-03','17:35:00',3.22),('8902','2013-05-03','17:40:00',2.98),('8902','2013-05-03','17:45:00',2.9),('8902','2013-05-03','17:50:00',2.88),('8902','2013-05-03','17:55:00',2.77),('8902','2013-05-03','18:00:00',2.59),('8902','2013-05-03','18:05:00',2.45),('8902','2013-05-03','18:10:00',2.13),('8902','2013-05-03','18:15:00',1.63),('8902','2013-05-03','18:20:00',1.39),('8902','2013-05-03','18:25:00',1.15),('8902','2013-05-02','07:50:00',1.07),('8902','2013-05-02','07:55:00',1.21),('8902','2013-05-02','08:00:00',1.47),('8902','2013-05-02','08:05:00',2.01),('8902','2013-05-02','08:10:00',2.48),('8902','2013-05-02','08:15:00',2.82),('8902','2013-05-02','08:20:00',2.8),('8902','2013-05-02','08:25:00',3.02),('8902','2013-05-02','08:30:00',3.16),('8902','2013-05-02','08:35:00',3.28),('8902','2013-05-02','08:40:00',3.39),('8902','2013-05-02','08:45:00',3.53),('8902','2013-05-02','08:50:00',3.5),('8902','2013-05-02','08:55:00',3.57),('8902','2013-05-02','09:00:00',3.8),('8902','2013-05-02','09:05:00',4.08),('8902','2013-05-02','09:10:00',4.16),('8902','2013-05-02','09:15:00',4.28),('8902','2013-05-02','09:20:00',4.41),('8902','2013-05-02','09:25:00',4.6),('8902','2013-05-02','09:30:00',4.71),('8902','2013-05-02','09:35:00',4.87),('8902','2013-05-02','09:40:00',5.04),('8902','2013-05-02','09:45:00',5.18),('8902','2013-05-02','09:50:00',5.29),('8902','2013-05-02','09:55:00',5.43),('8902','2013-05-02','10:00:00',5.56),('8902','2013-05-02','10:05:00',5.68),('8902','2013-05-02','10:10:00',5.81),('8902','2013-05-02','10:15:00',5.92),('8902','2013-05-02','10:20:00',6.03),('8902','2013-05-02','10:25:00',6.13),('8902','2013-05-02','10:30:00',6.25),('8902','2013-05-02','10:35:00',6.3),('8902','2013-05-02','10:40:00',6.37),('8902','2013-05-02','10:45:00',6.42),('8902','2013-05-02','10:50:00',6.48),('8902','2013-05-02','10:55:00',6.6),('8902','2013-05-02','11:00:00',6.68),('8902','2013-05-02','11:05:00',6.76),('8902','2013-05-02','11:10:00',6.82),('8902','2013-05-02','11:15:00',6.87),('8902','2013-05-02','11:20:00',6.94),('8902','2013-05-02','11:25:00',7.12),('8902','2013-05-02','11:30:00',7.2),('8902','2013-05-02','11:35:00',7.21),('8902','2013-05-02','11:40:00',7.25),('8902','2013-05-02','11:45:00',7.25),('8902','2013-05-02','11:50:00',7.3),('8902','2013-05-02','11:55:00',7.37),('8902','2013-05-02','12:00:00',7.42),('8902','2013-05-02','12:05:00',7.45),('8902','2013-05-02','12:10:00',7.52),('8902','2013-05-02','12:15:00',7.55),('8902','2013-05-02','12:20:00',7.55),('8902','2013-05-02','12:25:00',7.56),('8902','2013-05-02','12:30:00',7.61),('8902','2013-05-02','12:35:00',7.57),('8902','2013-05-02','12:40:00',7.63),('8902','2013-05-02','12:45:00',7.63),('8902','2013-05-02','12:50:00',7.79),('8902','2013-05-02','12:55:00',7.75),('8902','2013-05-02','13:00:00',7.67),('8902','2013-05-02','13:05:00',7.66),('8902','2013-05-02','13:10:00',7.69),('8902','2013-05-02','13:15:00',7.71),('8902','2013-05-02','13:20:00',7.67),('8902','2013-05-02','13:25:00',7.72),('8902','2013-05-02','13:30:00',7.61),('8902','2013-05-02','13:35:00',7.49),('8902','2013-05-02','13:40:00',7.29),('8902','2013-05-02','13:45:00',7.25),('8902','2013-05-02','13:50:00',7.32),('8902','2013-05-02','13:55:00',7.37),('8902','2013-05-02','14:00:00',7.35),('8902','2013-05-02','14:05:00',7.09),('8902','2013-05-02','14:10:00',7.23),('8902','2013-05-02','14:15:00',6.97),('8902','2013-05-02','14:20:00',7.14),('8902','2013-05-02','14:25:00',7.19),('8902','2013-05-02','14:30:00',7.06),('8902','2013-05-02','14:35:00',7.19),('8902','2013-05-02','14:40:00',7.09),('8902','2013-05-02','14:45:00',7.02),('8902','2013-05-02','14:50:00',6.99),('8902','2013-05-02','14:55:00',7.03),('8902','2013-05-02','15:00:00',7.04),('8902','2013-05-02','15:05:00',6.98),('8902','2013-05-02','15:10:00',7.01),('8902','2013-05-02','15:15:00',6.88),('8902','2013-05-02','15:20:00',6.85),('8902','2013-05-02','15:25:00',6.78),('8902','2013-05-02','15:30:00',6.71),('8902','2013-05-02','15:35:00',6.65),('8902','2013-05-02','15:40:00',6.57),('8902','2013-05-02','15:45:00',6.49),('8902','2013-05-02','15:50:00',6.31),('8902','2013-05-02','15:55:00',6.24),('8902','2013-05-02','16:00:00',6.24),('8902','2013-05-02','16:05:00',6.16),('8902','2013-05-02','16:10:00',5.99),('8902','2013-05-02','16:15:00',5.87),('8902','2013-05-02','16:20:00',5.65),('8902','2013-05-02','16:25:00',5.43),('8902','2013-05-02','16:30:00',5.41),('8902','2013-05-02','16:35:00',5.38),('8902','2013-05-02','16:40:00',5.22),('8902','2013-05-02','16:45:00',4.96),('8902','2013-05-02','16:50:00',4.87),('8902','2013-05-02','16:55:00',4.74),('8902','2013-05-02','17:00:00',4.6),('8902','2013-05-02','17:05:00',4.42),('8902','2013-05-02','17:10:00',4.23),('8902','2013-05-02','17:15:00',4.05),('8902','2013-05-02','17:20:00',3.86),('8902','2013-05-02','17:25:00',3.65),('8902','2013-05-02','17:30:00',3.45),('8902','2013-05-02','17:35:00',3.3),('8902','2013-05-02','17:40:00',3.03),('8902','2013-05-02','17:45:00',2.85),('8902','2013-05-02','17:50:00',2.74),('8902','2013-05-02','17:55:00',2.59),('8902','2013-05-02','18:00:00',2.49),('8902','2013-05-02','18:05:00',2.32),('8902','2013-05-02','18:10:00',2.18),('8902','2013-05-02','18:15:00',2.02),('8902','2013-05-02','18:20:00',1.82),('8902','2013-05-02','18:25:00',1.67),('8902','2013-05-02','18:30:00',1.51),('8902','2013-05-02','18:35:00',1.36),('8902','2013-05-02','18:40:00',1.22),('8902','2013-05-02','18:45:00',1.08),('8902','2013-05-01','08:35:00',1.04),('8902','2013-05-01','08:40:00',1.49),('8902','2013-05-01','08:45:00',1.39),('8902','2013-05-01','08:50:00',1.47),('8902','2013-05-01','08:55:00',2.18),('8902','2013-05-01','09:00:00',3.45),('8902','2013-05-01','09:05:00',3.14),('8902','2013-05-01','09:10:00',1.72),('8902','2013-05-01','09:15:00',1.56),('8902','2013-05-01','09:20:00',1.78),('8902','2013-05-01','09:25:00',2.72),('8902','2013-05-01','09:30:00',3.01),('8902','2013-05-01','09:35:00',4.14),('8902','2013-05-01','09:40:00',2.67),('8902','2013-05-01','09:45:00',4.46),('8902','2013-05-01','09:50:00',2.4),('8902','2013-05-01','09:55:00',1.83),('8902','2013-05-01','10:00:00',1.98),('8902','2013-05-01','10:05:00',2.85),('8902','2013-05-01','10:10:00',2.74),('8902','2013-05-01','10:15:00',2.8),('8902','2013-05-01','10:20:00',2.85),('8902','2013-05-01','10:25:00',3.84),('8902','2013-05-01','10:30:00',6.16),('8902','2013-05-01','10:35:00',4.61),('8902','2013-05-01','10:40:00',6.68),('8902','2013-05-01','10:45:00',4.95),('8902','2013-05-01','10:50:00',5.96),('8902','2013-05-01','10:55:00',7.07),('8902','2013-05-01','11:00:00',7.3),('8902','2013-05-01','11:05:00',7.24),('8902','2013-05-01','11:10:00',5.31),('8902','2013-05-01','11:15:00',5.45),('8902','2013-05-01','11:20:00',5.2),('8902','2013-05-01','11:25:00',7.22),('8902','2013-05-01','11:30:00',7.28),('8902','2013-05-01','11:35:00',7.21),('8902','2013-05-01','11:40:00',7.12),('8902','2013-05-01','11:45:00',7.15),('8902','2013-05-01','11:50:00',7.16),('8902','2013-05-01','11:55:00',7.18),('8902','2013-05-01','12:00:00',7.22),('8902','2013-05-01','12:05:00',7.21),('8902','2013-05-01','12:10:00',7.2),('8902','2013-05-01','12:15:00',7.29),('8902','2013-05-01','12:20:00',7.31),('8902','2013-05-01','12:25:00',7.38),('8902','2013-05-01','12:30:00',7.5),('8902','2013-05-01','12:35:00',7.6),('8902','2013-05-01','12:40:00',7.73),('8902','2013-05-01','12:45:00',7.74),('8902','2013-05-01','12:50:00',7.78),('8902','2013-05-01','12:55:00',7.85),('8902','2013-05-01','13:00:00',7.91),('8902','2013-05-01','13:05:00',7.95),('8902','2013-05-01','13:10:00',8.03),('8902','2013-05-01','13:15:00',8.07),('8902','2013-05-01','13:20:00',8.07),('8902','2013-05-01','13:25:00',8.06),('8902','2013-05-01','13:30:00',8.07),('8902','2013-05-01','13:35:00',8.03),('8902','2013-05-01','13:40:00',8),('8902','2013-05-01','13:45:00',8.04),('8902','2013-05-01','13:50:00',8.05),('8902','2013-05-01','13:55:00',8.03),('8902','2013-05-01','14:00:00',7.94),('8902','2013-05-01','14:05:00',7.85),('8902','2013-05-01','14:10:00',7.81),('8902','2013-05-01','14:15:00',7.83),('8902','2013-05-01','14:20:00',7.72),('8902','2013-05-01','14:25:00',7.64),('8902','2013-05-01','14:30:00',7.6),('8902','2013-05-01','14:35:00',7.59),('8902','2013-05-01','14:40:00',7.57),('8902','2013-05-01','14:45:00',7.48),('8902','2013-05-01','14:50:00',7.4),('8902','2013-05-01','14:55:00',7.35),('8902','2013-05-01','15:00:00',7.3),('8902','2013-05-01','15:05:00',7.22),('8902','2013-05-01','15:10:00',6.31),('8902','2013-05-01','15:15:00',7.09),('8902','2013-05-01','15:20:00',7.03),('8902','2013-05-01','15:25:00',6.93),('8902','2013-05-01','15:30:00',6.77),('8902','2013-05-01','15:35:00',6.6),('8902','2013-05-01','15:40:00',6.52),('8902','2013-05-01','15:45:00',6.43),('8902','2013-05-01','15:50:00',6.37),('8902','2013-05-01','15:55:00',6.23),('8902','2013-05-01','16:00:00',6.07),('8902','2013-05-01','16:05:00',6.06),('8902','2013-05-01','16:10:00',5.99),('8902','2013-05-01','16:15:00',5.84),('8902','2013-05-01','16:20:00',5.72),('8902','2013-05-01','16:25:00',5.57),('8902','2013-05-01','16:30:00',5.4),('8902','2013-05-01','16:35:00',5.28),('8902','2013-05-01','16:40:00',5.15),('8902','2013-05-01','16:45:00',4.95),('8902','2013-05-01','16:50:00',4.86),('8902','2013-05-01','16:55:00',4.73),('8902','2013-05-01','17:00:00',4.58),('8902','2013-05-01','17:05:00',4.46),('8902','2013-05-01','17:10:00',4.27),('8902','2013-05-01','17:15:00',4.17),('8902','2013-05-01','17:20:00',4.02),('8902','2013-05-01','17:25:00',3.87),('8902','2013-05-01','17:30:00',3.68),('8902','2013-05-01','17:35:00',3.53),('8902','2013-05-01','17:40:00',3.34),('8902','2013-05-01','17:45:00',3.15),('8902','2013-05-01','17:50:00',3.01),('8902','2013-05-01','17:55:00',2.82),('8902','2013-05-01','18:00:00',2.65),('8902','2013-05-01','18:05:00',2.48),('8902','2013-05-01','18:10:00',2.32),('8902','2013-05-01','18:15:00',2.14),('8902','2013-05-01','18:20:00',1.94),('8902','2013-05-01','18:25:00',1.76),('8902','2013-05-01','18:30:00',1.62),('8902','2013-05-01','18:35:00',1.47),('8902','2013-05-01','18:40:00',1.31),('8902','2013-05-01','18:45:00',1.16),('8902','2013-05-01','18:50:00',1.01),('8902','2014-03-29','08:00:00',1.05),('8902','2014-03-29','08:05:00',1.18),('8902','2014-03-29','08:10:00',1.37),('8902','2014-03-29','08:15:00',1.55),('8902','2014-03-29','08:20:00',1.79),('8902','2014-03-29','08:25:00',2),('8902','2014-03-29','08:30:00',2.14),('8902','2014-03-29','08:35:00',2.28),('8902','2014-03-29','08:40:00',2.26),('8902','2014-03-29','08:45:00',2.2),('8902','2014-03-29','08:50:00',2.32),('8902','2014-03-29','08:55:00',2.46),('8902','2014-03-29','09:00:00',2.56),('8902','2014-03-29','09:05:00',2.62),('8902','2014-03-29','09:10:00',2.62),('8902','2014-03-29','09:15:00',2.52),('8902','2014-03-29','09:20:00',2.82),('8902','2014-03-29','09:25:00',3.05),('8902','2014-03-29','09:30:00',3.51),('8902','2014-03-29','09:35:00',3.99),('8902','2014-03-29','09:40:00',4.16),('8902','2014-03-29','09:45:00',4.3),('8902','2014-03-29','09:50:00',4.36),('8902','2014-03-29','09:55:00',4.3),('8902','2014-03-29','10:00:00',4.34),('8902','2014-03-29','10:05:00',5.01),('8902','2014-03-29','10:10:00',5.13),('8902','2014-03-29','10:15:00',5.03),('8902','2014-03-29','10:20:00',5.23),('8902','2014-03-29','10:25:00',5.37),('8902','2014-03-29','10:30:00',5.57),('8902','2014-03-29','10:35:00',5.73),('8902','2014-03-29','10:40:00',5.89),('8902','2014-03-29','10:45:00',5.9),('8902','2014-03-29','10:50:00',5.98),('8902','2014-03-29','10:55:00',6.12),('8902','2014-03-29','11:00:00',6.14),('8902','2014-03-29','11:05:00',5.85),('8902','2014-03-29','11:10:00',6.06),('8902','2014-03-29','11:15:00',6.02),('8902','2014-03-29','11:20:00',6.03),('8902','2014-03-29','11:25:00',6.19),('8902','2014-03-29','11:30:00',6.63),('8902','2014-03-29','11:35:00',6.53),('8902','2014-03-29','11:40:00',6.82),('8902','2014-03-29','11:45:00',7.05),('8902','2014-03-29','11:50:00',7.2),('8902','2014-03-29','11:55:00',7.38),('8902','2014-03-29','12:00:00',7.43),('8902','2014-03-29','12:05:00',7.67),('8902','2014-03-29','12:10:00',7.88),('8902','2014-03-29','12:15:00',7.88),('8902','2014-03-29','12:20:00',7.82),('8902','2014-03-29','12:25:00',7.85),('8902','2014-03-29','12:30:00',7.28),('8902','2014-03-29','12:35:00',7.28),('8902','2014-03-29','12:40:00',7.83),('8902','2014-03-29','12:45:00',7.58),('8902','2014-03-29','12:50:00',7.77),('8902','2014-03-29','12:55:00',7.83),('8902','2014-03-29','13:00:00',8.05),('8902','2014-03-29','13:05:00',8.06),('8902','2014-03-29','13:10:00',8.07),('8902','2014-03-29','13:15:00',8.07),('8902','2014-03-29','13:20:00',8.08),('8902','2014-03-29','13:25:00',8.1),('8902','2014-03-29','13:30:00',8.09),('8902','2014-03-29','13:35:00',8.17),('8902','2014-03-29','13:40:00',8.14),('8902','2014-03-29','13:45:00',8.16),('8902','2014-03-29','13:50:00',8.15),('8902','2014-03-29','13:55:00',7.96),('8902','2014-03-29','14:00:00',7.95),('8902','2014-03-29','14:05:00',8.03),('8902','2014-03-29','14:10:00',7.85),('8902','2014-03-29','14:15:00',7.84),('8902','2014-03-29','14:20:00',7.95),('8902','2014-03-29','14:25:00',8.06),('8902','2014-03-29','14:30:00',8.18),('8902','2014-03-29','14:35:00',8.05),('8902','2014-03-29','14:40:00',7.63),('8902','2014-03-29','14:45:00',7.04),('8902','2014-03-29','14:50:00',6.35),('8902','2014-03-29','14:55:00',5.33),('8902','2014-03-29','15:00:00',4.3),('8902','2014-03-29','15:05:00',3.44),('8902','2014-03-29','15:10:00',2.6),('8902','2014-03-29','15:15:00',2.31),('8902','2014-03-29','15:20:00',3.85),('8902','2014-03-29','15:25:00',6.22),('8902','2014-03-29','15:30:00',6.61),('8902','2014-03-29','15:35:00',6.52),('8902','2014-03-29','15:40:00',6.64),('8902','2014-03-29','15:45:00',6.55),('8902','2014-03-29','15:50:00',6.56),('8902','2014-03-29','15:55:00',6.39),('8902','2014-03-29','16:00:00',6.16),('8902','2014-03-29','16:05:00',5.65),('8902','2014-03-29','16:10:00',5.62),('8902','2014-03-29','16:15:00',5.46),('8902','2014-03-29','16:20:00',5.84),('8902','2014-03-29','16:25:00',5.75),('8902','2014-03-29','16:30:00',5.64),('8902','2014-03-29','16:35:00',5.65),('8902','2014-03-29','16:40:00',5.37),('8902','2014-03-29','16:45:00',4.74),('8902','2014-03-29','16:50:00',4.37),('8902','2014-03-29','16:55:00',3.6),('8902','2014-03-29','17:00:00',3.68),('8902','2014-03-29','17:05:00',4.11),('8902','2014-03-29','17:10:00',4.33),('8902','2014-03-29','17:15:00',4.38),('8902','2014-03-29','17:20:00',4.21),('8902','2014-03-29','17:25:00',3.79),('8902','2014-03-29','17:30:00',3.64),('8902','2014-03-29','17:35:00',3.47),('8902','2014-03-29','17:40:00',3.05),('8902','2014-03-29','17:45:00',3.07),('8902','2014-03-29','17:50:00',2.54),('8902','2014-03-29','17:55:00',2.02),('8902','2014-03-29','18:00:00',1.59),('8902','2014-03-29','18:05:00',1.49),('8902','2014-03-29','18:10:00',1.75),('8902','2014-03-29','18:15:00',1.33),('8902','2014-03-29','18:20:00',1.05),('8902','2013-04-30','07:35:00',1.08),('8902','2013-04-30','07:40:00',1.2),('8902','2013-04-30','07:45:00',1.33),('8902','2013-04-30','07:50:00',1.47),('8902','2013-04-30','07:55:00',1.59),('8902','2013-04-30','08:00:00',1.72),('8902','2013-04-30','08:05:00',1.84),('8902','2013-04-30','08:10:00',1.94),('8902','2013-04-30','08:15:00',2.1),('8902','2013-04-30','08:20:00',2.28),('8902','2013-04-30','08:25:00',2.46),('8902','2013-04-30','08:30:00',2.63),('8902','2013-04-30','08:35:00',2.79),('8902','2013-04-30','08:40:00',2.94),('8902','2013-04-30','08:45:00',3.07),('8902','2013-04-30','08:50:00',3.27),('8902','2013-04-30','08:55:00',3.43),('8902','2013-04-30','09:00:00',3.62),('8902','2013-04-30','09:05:00',3.76),('8902','2013-04-30','09:10:00',3.88),('8902','2013-04-30','09:15:00',4.01),('8902','2013-04-30','09:20:00',4.12),('8902','2013-04-30','09:25:00',4.22),('8902','2013-04-30','09:30:00',4.33),('8902','2013-04-30','09:35:00',4.4),('8902','2013-04-30','09:40:00',4.58),('8902','2013-04-30','09:45:00',4.7),('8902','2013-04-30','09:50:00',4.82),('8902','2013-04-30','09:55:00',4.94),('8902','2013-04-30','10:00:00',5.06),('8902','2013-04-30','10:05:00',5.12),('8902','2013-04-30','10:10:00',5.29),('8902','2013-04-30','10:15:00',5.46),('8902','2013-04-30','10:20:00',5.55),('8902','2013-04-30','10:25:00',5.65),('8902','2013-04-30','10:30:00',5.74),('8902','2013-04-30','10:35:00',5.8),('8902','2013-04-30','10:40:00',6.04),('8902','2013-04-30','10:45:00',6.36),('8902','2013-04-30','10:50:00',6.42),('8902','2013-04-30','10:55:00',6.5),('8902','2013-04-30','11:00:00',6.57),('8902','2013-04-30','11:05:00',6.63),('8902','2013-04-30','11:10:00',6.71),('8902','2013-04-30','11:15:00',6.35),('8902','2013-04-30','11:20:00',6.04),('8902','2013-04-30','11:25:00',5.96),('8902','2013-04-30','11:30:00',5.85),('8902','2013-04-30','11:35:00',6.2),('8902','2013-04-30','11:40:00',5.55),('8902','2013-04-30','11:45:00',5.28),('8902','2013-04-30','11:50:00',6.06),('8902','2013-04-30','11:55:00',7.26),('8902','2013-04-30','12:00:00',7.16),('8902','2013-04-30','12:05:00',7.09),('8902','2013-04-30','12:10:00',7.09),('8902','2013-04-30','12:15:00',7.11),('8902','2013-04-30','12:20:00',7.21),('8902','2013-04-30','12:25:00',7.25),('8902','2013-04-30','12:30:00',7.36),('8902','2013-04-30','12:35:00',7.49),('8902','2013-04-30','12:40:00',7.64),('8902','2013-04-30','12:45:00',6.86),('8902','2013-04-30','12:50:00',6.8),('8902','2013-04-30','12:55:00',2.79),('8902','2013-04-30','13:00:00',3.66),('8902','2013-04-30','13:05:00',3.35),('8902','2013-04-30','13:10:00',4.63),('8902','2013-04-30','13:15:00',8.38),('8902','2013-04-30','13:20:00',8.58),('8902','2013-04-30','13:25:00',7.27),('8902','2013-04-30','13:30:00',4.98),('8902','2013-04-30','13:35:00',5.52),('8902','2013-04-30','13:40:00',8.21),('8902','2013-04-30','13:45:00',8.2),('8902','2013-04-30','13:50:00',7.85),('8902','2013-04-30','13:55:00',7.66),('8902','2013-04-30','14:00:00',7.49),('8902','2013-04-30','14:05:00',7.25),('8902','2013-04-30','14:10:00',7.21),('8902','2013-04-30','14:15:00',6.16),('8902','2013-04-30','14:20:00',7.56),('8902','2013-04-30','14:25:00',7.6),('8902','2013-04-30','14:30:00',7.67),('8902','2013-04-30','14:35:00',7.45),('8902','2013-04-30','14:40:00',6.61),('8902','2013-04-30','14:45:00',7.05),('8902','2013-04-30','14:50:00',5.8),('8902','2013-04-30','14:55:00',5.49),('8902','2013-04-30','15:00:00',5.99),('8902','2013-04-30','15:05:00',6.46),('8902','2013-04-30','15:10:00',6.66),('8902','2013-04-30','15:15:00',6.49),('8902','2013-04-30','15:20:00',6.19),('8902','2013-04-30','15:25:00',6.54),('8902','2013-04-30','15:30:00',5.38),('8902','2013-04-30','15:35:00',4.62),('8902','2013-04-30','15:40:00',4.57),('8902','2013-04-30','15:45:00',4.5),('8902','2013-04-30','15:50:00',3.37),('8902','2013-04-30','15:55:00',3.18),('8902','2013-04-30','16:00:00',3.93),('8902','2013-04-30','16:05:00',3.83),('8902','2013-04-30','16:10:00',3.39),('8902','2013-04-30','16:15:00',3.08),('8902','2013-04-30','16:20:00',2.66),('8902','2013-04-30','16:25:00',2.09),('8902','2013-04-30','16:30:00',1.96),('8902','2013-04-30','16:35:00',2.06),('8902','2013-04-30','16:40:00',2.22),('8902','2013-04-30','16:45:00',2.07),('8902','2013-04-30','16:50:00',1.8),('8902','2013-04-30','16:55:00',1.64),('8902','2013-04-30','17:00:00',1.66),('8902','2013-04-30','17:05:00',1.68),('8902','2013-04-30','17:10:00',1.7),('8902','2013-04-30','17:15:00',1.69),('8902','2013-04-30','17:20:00',1.53),('8902','2013-04-30','17:25:00',1.29),('8902','2013-04-30','17:30:00',1.09),('8902','2013-04-30','17:35:00',1.01),('8902','2013-04-29','08:20:00',1.01),('8902','2013-04-29','08:25:00',1.11),('8902','2013-04-29','08:30:00',1.41),('8902','2013-04-29','08:35:00',1.63),('8902','2013-04-29','08:40:00',1.56),('8902','2013-04-29','08:45:00',1.62),('8902','2013-04-29','08:50:00',1.93),('8902','2013-04-29','08:55:00',2.62),('8902','2013-04-29','09:00:00',3.03),('8902','2013-04-29','09:05:00',2.74),('8902','2013-04-29','09:10:00',3.9),('8902','2013-04-29','09:15:00',4.49),('8902','2013-04-29','09:20:00',4.51),('8902','2013-04-29','09:25:00',4.82),('8902','2013-04-29','09:30:00',4.78),('8902','2013-04-29','09:35:00',3.98),('8902','2013-04-29','09:40:00',2.87),('8902','2013-04-29','09:45:00',3.53),('8902','2013-04-29','09:50:00',4.58),('8902','2013-04-29','09:55:00',5.05),('8902','2013-04-29','10:00:00',5.91),('8902','2013-04-29','10:05:00',5.86),('8902','2013-04-29','10:10:00',5.05),('8902','2013-04-29','10:15:00',4.6),('8902','2013-04-29','10:20:00',4.35),('8902','2013-04-29','10:25:00',4.1),('8902','2013-04-29','10:30:00',3.7),('8902','2013-04-29','10:35:00',3.59),('8902','2013-04-29','10:40:00',2.99),('8902','2013-04-29','10:45:00',2.42),('8902','2013-04-29','10:50:00',2.65),('8902','2013-04-29','10:55:00',2.8),('8902','2013-04-29','11:00:00',2.86),('8902','2013-04-29','11:05:00',3.21),('8902','2013-04-29','11:10:00',3.29),('8902','2013-04-29','11:15:00',3.46),('8902','2013-04-29','11:20:00',3.92),('8902','2013-04-29','11:25:00',3.63),('8902','2013-04-29','11:30:00',3.52),('8902','2013-04-29','11:35:00',3.67),('8902','2013-04-29','11:40:00',3.59),('8902','2013-04-29','11:45:00',3.13),('8902','2013-04-29','11:50:00',3.24),('8902','2013-04-29','11:55:00',3.31),('8902','2013-04-29','12:00:00',3.27),('8902','2013-04-29','12:05:00',3.3),('8902','2013-04-29','12:10:00',3.24),('8902','2013-04-29','12:15:00',3.01),('8902','2013-04-29','12:20:00',2.65),('8902','2013-04-29','12:25:00',2.44),('8902','2013-04-29','12:30:00',2.49),('8902','2013-04-29','12:35:00',4.41),('8902','2013-04-29','12:40:00',7.82),('8902','2013-04-29','12:45:00',8.49),('8902','2013-04-29','12:50:00',8.15),('8902','2013-04-29','12:55:00',7.06),('8902','2013-04-29','13:00:00',7.61),('8902','2013-04-29','13:05:00',7.51),('8902','2013-04-29','13:10:00',7.69),('8902','2013-04-29','13:15:00',7.62),('8902','2013-04-29','13:20:00',7.54),('8902','2013-04-29','13:25:00',7.53),('8902','2013-04-29','13:30:00',7.46),('8902','2013-04-29','13:35:00',7.47),('8902','2013-04-29','13:40:00',7.41),('8902','2013-04-29','13:45:00',7.36),('8902','2013-04-29','13:50:00',7.31),('8902','2013-04-29','13:55:00',7.27),('8902','2013-04-29','14:00:00',7.23),('8902','2013-04-29','14:05:00',7.17),('8902','2013-04-29','14:10:00',7.17),('8902','2013-04-29','14:15:00',7.15),('8902','2013-04-29','14:20:00',7.16),('8902','2013-04-29','14:25:00',7.13),('8902','2013-04-29','14:30:00',7.09),('8902','2013-04-29','14:35:00',7),('8902','2013-04-29','14:40:00',6.91),('8902','2013-04-29','14:45:00',6.8),('8902','2013-04-29','14:50:00',6.71),('8902','2013-04-29','14:55:00',6.61),('8902','2013-04-29','15:00:00',6.56),('8902','2013-04-29','15:05:00',6.5),('8902','2013-04-29','15:10:00',6.43),('8902','2013-04-29','15:15:00',6.35),('8902','2013-04-29','15:20:00',6.25),('8902','2013-04-29','15:25:00',6.16),('8902','2013-04-29','15:30:00',6.05),('8902','2013-04-29','15:35:00',6.02),('8902','2013-04-29','15:40:00',5.92),('8902','2013-04-29','15:45:00',5.81),('8902','2013-04-29','15:50:00',5.7),('8902','2013-04-29','15:55:00',5.56),('8902','2013-04-29','16:00:00',5.46),('8902','2013-04-29','16:05:00',5.35),('8902','2013-04-29','16:10:00',5.25),('8902','2013-04-29','16:15:00',5.17),('8902','2013-04-29','16:20:00',5.08),('8902','2013-04-29','16:25:00',4.91),('8902','2013-04-29','16:30:00',4.81),('8902','2013-04-29','16:35:00',4.59),('8902','2013-04-29','16:40:00',3.77),('8902','2013-04-29','16:45:00',3.96),('8902','2013-04-29','16:50:00',3.59),('8902','2013-04-29','16:55:00',4.07),('8902','2013-04-29','17:00:00',3.76),('8902','2013-04-29','17:05:00',3.76),('8902','2013-04-29','17:10:00',3.27),('8902','2013-04-29','17:15:00',1.71),('8902','2013-04-29','17:20:00',2.51),('8902','2013-04-29','17:25:00',3.07),('8902','2013-04-29','17:30:00',2.97),('8902','2013-04-29','17:35:00',2.89),('8902','2013-04-29','17:40:00',2.72),('8902','2013-04-29','17:45:00',2.55),('8902','2013-04-29','17:50:00',2.39),('8902','2013-04-29','17:55:00',2.2),('8902','2013-04-29','18:00:00',2.06),('8902','2013-04-29','18:05:00',1.91),('8902','2013-04-29','18:10:00',1.78),('8902','2013-04-29','18:15:00',1.63),('8902','2013-04-29','18:20:00',1.48),('8902','2013-04-29','18:25:00',1.34),('8902','2013-04-29','18:30:00',1.22),('8902','2013-04-29','18:35:00',1.1),('8902','2013-04-28','07:20:00',1.13),('8902','2013-04-28','07:25:00',1.27),('8902','2013-04-28','07:30:00',1.32),('8902','2013-04-28','07:35:00',1.3),('8902','2013-04-28','07:40:00',1.23),('8902','2013-04-28','07:45:00',1.37),('8902','2013-04-28','07:50:00',1.49),('8902','2013-04-28','07:55:00',1.72),('8902','2013-04-28','08:00:00',1.98),('8902','2013-04-28','08:05:00',2.11),('8902','2013-04-28','08:10:00',2.05),('8902','2013-04-28','08:15:00',2.13),('8902','2013-04-28','08:20:00',2.3),('8902','2013-04-28','08:25:00',2.61),('8902','2013-04-28','08:30:00',2.98),('8902','2013-04-28','08:35:00',3.36),('8902','2013-04-28','08:40:00',3.44),('8902','2013-04-28','08:45:00',3.34),('8902','2013-04-28','08:50:00',3.61),('8902','2013-04-28','08:55:00',3.66),('8902','2013-04-28','09:00:00',2.83),('8902','2013-04-28','09:05:00',3.91),('8902','2013-04-28','09:10:00',4.33),('8902','2013-04-28','09:15:00',4.59),('8902','2013-04-28','09:20:00',4.35),('8902','2013-04-28','09:25:00',4.27),('8902','2013-04-28','09:30:00',4.23),('8902','2013-04-28','09:35:00',4.56),('8902','2013-04-28','09:40:00',4.64),('8902','2013-04-28','09:45:00',4.84),('8902','2013-04-28','09:50:00',5.18),('8902','2013-04-28','09:55:00',4.83),('8902','2013-04-28','10:00:00',5.03),('8902','2013-04-28','10:05:00',4.96),('8902','2013-04-28','10:10:00',4.92),('8902','2013-04-28','10:15:00',4.25),('8902','2013-04-28','10:20:00',4.02),('8902','2013-04-28','10:25:00',4.95),('8902','2013-04-28','10:30:00',4.88),('8902','2013-04-28','10:35:00',5.89),('8902','2013-04-28','10:40:00',5.97),('8902','2013-04-28','10:45:00',6.1),('8902','2013-04-28','10:50:00',5.84),('8902','2013-04-28','10:55:00',5.47),('8902','2013-04-28','11:00:00',6.11),('8902','2013-04-28','11:05:00',5.91),('8902','2013-04-28','11:10:00',5.85),('8902','2013-04-28','11:15:00',5.39),('8902','2013-04-28','11:20:00',6.19),('8902','2013-04-28','11:25:00',6.46),('8902','2013-04-28','11:30:00',6.81),('8902','2013-04-28','11:35:00',6.52),('8902','2013-04-28','11:40:00',6.57),('8902','2013-04-28','11:45:00',6.49),('8902','2013-04-28','11:50:00',7.09),('8902','2013-04-28','11:55:00',7.02),('8902','2013-04-28','12:00:00',7.36),('8902','2013-04-28','12:05:00',7.36),('8902','2013-04-28','12:10:00',7.05),('8902','2013-04-28','12:15:00',7.07),('8902','2013-04-28','12:20:00',7.17),('8902','2013-04-28','12:25:00',7.14),('8902','2013-04-28','12:30:00',7.28),('8902','2013-04-28','12:35:00',7.4),('8902','2013-04-28','12:40:00',7.57),('8902','2013-04-28','12:45:00',7.62),('8902','2013-04-28','12:50:00',7.6),('8902','2013-04-28','12:55:00',7.34),('8902','2013-04-28','13:00:00',7.51),('8902','2013-04-28','13:05:00',7.44),('8902','2013-04-28','13:10:00',7.39),('8902','2013-04-28','13:15:00',6.91),('8902','2013-04-28','13:20:00',7.37),('8902','2013-04-28','13:25:00',7.81),('8902','2013-04-28','13:30:00',7.66),('8902','2013-04-28','13:35:00',7.63),('8902','2013-04-28','13:40:00',7.55),('8902','2013-04-28','13:45:00',7.46),('8902','2013-04-28','13:50:00',7.3),('8902','2013-04-28','13:55:00',7.7),('8902','2013-04-28','14:00:00',7.23),('8902','2013-04-28','14:05:00',7.43),('8902','2013-04-28','14:10:00',7.38),('8902','2013-04-28','14:15:00',7.54),('8902','2013-04-28','14:20:00',7.52),('8902','2013-04-28','14:25:00',7.37),('8902','2013-04-28','14:30:00',7.04),('8902','2013-04-28','14:35:00',6.84),('8902','2013-04-28','14:40:00',6.49),('8902','2013-04-28','14:45:00',7.05),('8902','2013-04-28','14:50:00',6.81),('8902','2013-04-28','14:55:00',7.05),('8902','2013-04-28','15:00:00',6.77),('8902','2013-04-28','15:05:00',7.15),('8902','2013-04-28','15:10:00',6.75),('8902','2013-04-28','15:15:00',6.2),('8902','2013-04-28','15:20:00',6.5),('8902','2013-04-28','15:25:00',6.83),('8902','2013-04-28','15:30:00',6.69),('8902','2013-04-28','15:35:00',5.96),('8902','2013-04-28','15:40:00',5.4),('8902','2013-04-28','15:45:00',5.17),('8902','2013-04-28','15:50:00',5.32),('8902','2013-04-28','15:55:00',5.68),('8902','2013-04-28','16:00:00',5.51),('8902','2013-04-28','16:05:00',5.94),('8902','2013-04-28','16:10:00',5.48),('8902','2013-04-28','16:15:00',6.46),('8902','2013-04-28','16:20:00',6.35),('8902','2013-04-28','16:25:00',4.84),('8902','2013-04-28','16:30:00',5.02),('8902','2013-04-28','16:35:00',5.11),('8902','2013-04-28','16:40:00',5.39),('8902','2013-04-28','16:45:00',5.19),('8902','2013-04-28','16:50:00',5.36),('8902','2013-04-28','16:55:00',5.63),('8902','2013-04-28','17:00:00',5.18),('8902','2013-04-28','17:05:00',4.47),('8902','2013-04-28','17:10:00',4.57),('8902','2013-04-28','17:15:00',4.07),('8902','2013-04-28','17:20:00',3.36),('8902','2013-04-28','17:25:00',3.22),('8902','2013-04-28','17:30:00',3.01),('8902','2013-04-28','17:35:00',2.63),('8902','2013-04-28','17:40:00',2.14),('8902','2013-04-28','17:45:00',2.07),('8902','2013-04-28','17:50:00',2.5),('8902','2013-04-28','17:55:00',2.83),('8902','2013-04-28','18:00:00',2.77),('8902','2013-04-28','18:05:00',3.04),('8902','2013-04-28','18:10:00',2.74),('8902','2013-04-28','18:15:00',2.61),('8902','2013-04-28','18:20:00',2.13),('8902','2013-04-28','18:25:00',2.02),('8902','2013-04-28','18:30:00',1.91),('8902','2013-04-28','18:35:00',1.38),('8902','2013-04-28','18:40:00',1.19),('8902','2013-04-27','07:35:00',1.04),('8902','2013-04-27','07:40:00',1.22),('8902','2013-04-27','07:45:00',1.38),('8902','2013-04-27','07:50:00',1.53),('8902','2013-04-27','07:55:00',1.67),('8902','2013-04-27','08:00:00',1.8),('8902','2013-04-27','08:05:00',1.99),('8902','2013-04-27','08:10:00',2.18),('8902','2013-04-27','08:15:00',2.35),('8902','2013-04-27','08:20:00',2.53),('8902','2013-04-27','08:25:00',2.72),('8902','2013-04-27','08:30:00',2.85),('8902','2013-04-27','08:35:00',3),('8902','2013-04-27','08:40:00',3.17),('8902','2013-04-27','08:45:00',3.34),('8902','2013-04-27','08:50:00',3.5),('8902','2013-04-27','08:55:00',3.64),('8902','2013-04-27','09:00:00',3.79),('8902','2013-04-27','09:05:00',3.95),('8902','2013-04-27','09:10:00',4.12),('8902','2013-04-27','09:15:00',4.28),('8902','2013-04-27','09:20:00',4.46),('8902','2013-04-27','09:25:00',4.59),('8902','2013-04-27','09:30:00',4.74),('8902','2013-04-27','09:35:00',4.9),('8902','2013-04-27','09:40:00',5.04),('8902','2013-04-27','09:45:00',5.2),('8902','2013-04-27','09:50:00',5.33),('8902','2013-04-27','09:55:00',5.46),('8902','2013-04-27','10:00:00',5.59),('8902','2013-04-27','10:05:00',5.64),('8902','2013-04-27','10:10:00',5.76),('8902','2013-04-27','10:15:00',5.73),('8902','2013-04-27','10:20:00',5.95),('8902','2013-04-27','10:25:00',6.2),('8902','2013-04-27','10:30:00',6.13),('8902','2013-04-27','10:35:00',6.31),('8902','2013-04-27','10:40:00',5.78),('8902','2013-04-27','10:45:00',6.57),('8902','2013-04-27','10:50:00',6.61),('8902','2013-04-27','10:55:00',6.66),('8902','2013-04-27','11:00:00',6.75),('8902','2013-04-27','11:05:00',6.84),('8902','2013-04-27','11:10:00',6.99),('8902','2013-04-27','11:15:00',7.02),('8902','2013-04-27','11:20:00',7.02),('8902','2013-04-27','11:25:00',7.15),('8902','2013-04-27','11:30:00',7.23),('8902','2013-04-27','11:35:00',7.04),('8902','2013-04-27','11:40:00',7.16),('8902','2013-04-27','11:45:00',6.84),('8902','2013-04-27','11:50:00',7),('8902','2013-04-27','11:55:00',7.25),('8902','2013-04-27','12:00:00',6.47),('8902','2013-04-27','12:05:00',6.41),('8902','2013-04-27','12:10:00',7.09),('8902','2013-04-27','12:15:00',7.29),('8902','2013-04-27','12:20:00',7.15),('8902','2013-04-27','12:25:00',6.46),('8902','2013-04-27','12:30:00',6.12),('8902','2013-04-27','12:35:00',5.32),('8902','2013-04-27','12:40:00',5.59),('8902','2013-04-27','12:45:00',7.33),('8902','2013-04-27','12:50:00',7.61),('8902','2013-04-27','12:55:00',7),('8902','2013-04-27','13:00:00',7.25),('8902','2013-04-27','13:05:00',7.89),('8902','2013-04-27','13:10:00',7.67),('8902','2013-04-27','13:15:00',6.98),('8902','2013-04-27','13:20:00',7.27),('8902','2013-04-27','13:25:00',7.09),('8902','2013-04-27','13:30:00',7.56),('8902','2013-04-27','13:35:00',7.59),('8902','2013-04-27','13:40:00',8.1),('8902','2013-04-27','13:45:00',6.52),('8902','2013-04-27','13:50:00',7.09),('8902','2013-04-27','13:55:00',7.9),('8902','2013-04-27','14:00:00',7.74),('8902','2013-04-27','14:05:00',7.64),('8902','2013-04-27','14:10:00',7.36),('8902','2013-04-27','14:15:00',7.31),('8902','2013-04-27','14:20:00',7.61),('8902','2013-04-27','14:25:00',7.46),('8902','2013-04-27','14:30:00',7.36),('8902','2013-04-27','14:35:00',7.4),('8902','2013-04-27','14:40:00',7.34),('8902','2013-04-27','14:45:00',7.24),('8902','2013-04-27','14:50:00',7.18),('8902','2013-04-27','14:55:00',7.11),('8902','2013-04-27','15:00:00',7.02),('8902','2013-04-27','15:05:00',6.99),('8902','2013-04-27','15:10:00',6.98),('8902','2013-04-27','15:15:00',6.92),('8902','2013-04-27','15:20:00',6.79),('8902','2013-04-27','15:25:00',6.69),('8902','2013-04-27','15:30:00',6.6),('8902','2013-04-27','15:35:00',6.53),('8902','2013-04-27','15:40:00',6.5),('8902','2013-04-27','15:45:00',6.41),('8902','2013-04-27','15:50:00',6.32),('8902','2013-04-27','15:55:00',6.19),('8902','2013-04-27','16:00:00',6.09),('8902','2013-04-27','16:05:00',6.01),('8902','2013-04-27','16:10:00',5.87),('8902','2013-04-27','16:15:00',5.74),('8902','2013-04-27','16:20:00',5.64),('8902','2013-04-27','16:25:00',5.47),('8902','2013-04-27','16:30:00',5.36),('8902','2013-04-27','16:35:00',5.24),('8902','2013-04-27','16:40:00',5.1),('8902','2013-04-27','16:45:00',4.9),('8902','2013-04-27','16:50:00',4.82),('8902','2013-04-27','16:55:00',4.66),('8902','2013-04-27','17:00:00',4.53),('8902','2013-04-27','17:05:00',4.22),('8902','2013-04-27','17:10:00',3.94),('8902','2013-04-27','17:15:00',4.13),('8902','2013-04-27','17:20:00',3.94),('8902','2013-04-27','17:25:00',3.82),('8902','2013-04-27','17:30:00',3.27),('8902','2013-04-27','17:35:00',3.23),('8902','2013-04-27','17:40:00',2.95),('8902','2013-04-27','17:45:00',3.03),('8902','2013-04-27','17:50:00',2.9),('8902','2013-04-27','17:55:00',2.5),('8902','2013-04-27','18:00:00',2.46),('8902','2013-04-27','18:05:00',2.29),('8902','2013-04-27','18:10:00',1.59),('8902','2013-04-27','18:15:00',1.51),('8902','2013-04-27','18:20:00',1.79),('8902','2013-04-27','18:25:00',1.7),('8902','2013-04-27','18:30:00',1.4),('8902','2013-04-27','18:35:00',1.25),('8902','2013-04-27','18:40:00',1.15),('8902','2013-04-26','11:50:00',1.12),('8902','2013-04-26','11:55:00',1.18),('8902','2013-04-26','12:00:00',1.27),('8902','2013-04-26','12:05:00',1.25),('8902','2013-04-26','12:10:00',1.17),('8902','2013-04-26','12:15:00',1.1),('8902','2013-04-26','12:20:00',1),('8902','2013-04-26','12:30:00',1.08),('8902','2013-04-26','12:35:00',1.2),('8902','2013-04-26','12:40:00',1.5),('8902','2013-04-26','12:45:00',1.63),('8902','2013-04-26','12:50:00',1.85),('8902','2013-04-26','12:55:00',2.43),('8902','2013-04-26','13:00:00',2.67),('8902','2013-04-26','13:05:00',2.05),('8902','2013-04-26','13:10:00',2.06),('8902','2013-04-26','13:15:00',2.6),('8902','2013-04-26','13:20:00',2.64),('8902','2013-04-26','13:25:00',2.1),('8902','2013-04-26','13:30:00',2.22),('8902','2013-04-26','13:35:00',2.7),('8902','2013-04-26','13:40:00',3.59),('8902','2013-04-26','13:45:00',2.18),('8902','2013-04-26','13:50:00',2),('8902','2013-04-26','13:55:00',1.59),('8902','2013-04-26','14:00:00',1.23),('8902','2013-04-26','14:05:00',1.48),('8902','2013-04-26','14:10:00',1.08),('8902','2013-04-26','14:15:00',1.01),('8902','2013-04-26','14:20:00',1.22),('8902','2013-04-26','14:25:00',2.54),('8902','2013-04-26','14:30:00',4.12),('8902','2013-04-26','14:35:00',3.44),('8902','2013-04-26','14:40:00',2.37),('8902','2013-04-26','14:45:00',2.36),('8902','2013-04-26','14:50:00',1.42),('8902','2013-04-26','14:55:00',1.72),('8902','2013-04-26','15:00:00',2.13),('8902','2013-04-26','15:05:00',3.49),('8902','2013-04-26','15:10:00',2.63),('8902','2013-04-26','15:15:00',2.31),('8902','2013-04-26','15:20:00',1.33),('8902','2013-04-26','15:25:00',1.24),('8902','2013-04-26','15:50:00',1.33),('8902','2013-04-26','16:30:00',1.01),('8902','2013-04-26','16:35:00',1.21),('8902','2013-04-26','16:40:00',1.64),('8902','2013-04-26','16:45:00',2.35),('8902','2013-04-26','16:50:00',3.2),('8902','2013-04-26','16:55:00',4.39),('8902','2013-04-26','17:00:00',5.4),('8902','2013-04-26','17:05:00',3.17),('8902','2013-04-26','17:10:00',1.46),('8902','2013-04-26','17:20:00',1.83),('8902','2013-04-26','17:25:00',1.27),('8902','2013-04-26','17:35:00',1.28),('8902','2013-04-26','17:40:00',2.2),('8902','2013-04-26','17:45:00',2.01),('8902','2013-04-26','17:50:00',1.19),('8902','2013-04-26','18:00:00',1.01),('8902','2013-04-26','18:05:00',1.17),('8902','2013-04-26','18:15:00',1.05),('8902','2013-04-25','07:30:00',1),('8902','2013-04-25','07:50:00',1.06),('8902','2013-04-25','07:55:00',1.2),('8902','2013-04-25','08:00:00',1.32),('8902','2013-04-25','08:05:00',1.51),('8902','2013-04-25','08:10:00',1.94),('8902','2013-04-25','08:15:00',2.14),('8902','2013-04-25','08:20:00',2.26),('8902','2013-04-25','08:25:00',2.38),('8902','2013-04-25','08:30:00',2.5),('8902','2013-04-25','08:35:00',2.7),('8902','2013-04-25','08:40:00',2.85),('8902','2013-04-25','08:45:00',3.03),('8902','2013-04-25','08:50:00',3.16),('8902','2013-04-25','08:55:00',2.52),('8902','2013-04-25','09:00:00',2.49),('8902','2013-04-25','09:05:00',3.49),('8902','2013-04-25','09:10:00',3.32),('8902','2013-04-25','09:15:00',2.08),('8902','2013-04-25','09:20:00',2.05),('8902','2013-04-25','09:25:00',2.28),('8902','2013-04-25','09:30:00',2.69),('8902','2013-04-25','09:35:00',3.39),('8902','2013-04-25','09:40:00',3.89),('8902','2013-04-25','09:45:00',4.86),('8902','2013-04-25','09:50:00',4.54),('8902','2013-04-25','09:55:00',3.21),('8902','2013-04-25','10:00:00',3.06),('8902','2013-04-25','10:05:00',4.48),('8902','2013-04-25','10:10:00',5.46),('8902','2013-04-25','10:15:00',5.5),('8902','2013-04-25','10:20:00',5.55),('8902','2013-04-25','10:25:00',4.39),('8902','2013-04-25','10:30:00',6.1),('8902','2013-04-25','10:35:00',6.3),('8902','2013-04-25','10:40:00',5.89),('8902','2013-04-25','10:45:00',5.24),('8902','2013-04-25','10:50:00',3.62),('8902','2013-04-25','10:55:00',5.02),('8902','2013-04-25','11:00:00',5.43),('8902','2013-04-25','11:05:00',6.35),('8902','2013-04-25','11:10:00',5.55),('8902','2013-04-25','11:15:00',6.8),('8902','2013-04-25','11:20:00',5.18),('8902','2013-04-25','11:25:00',5.74),('8902','2013-04-25','11:30:00',5.75),('8902','2013-04-25','11:35:00',6.44),('8902','2013-04-25','11:40:00',6.25),('8902','2013-04-25','11:45:00',6.11),('8902','2013-04-25','11:50:00',5.01),('8902','2013-04-25','11:55:00',4.63),('8902','2013-04-25','12:00:00',5.54),('8902','2013-04-25','12:05:00',4.61),('8902','2013-04-25','12:10:00',4.24),('8902','2013-04-25','12:15:00',5.01),('8902','2013-04-25','12:20:00',4.6),('8902','2013-04-25','12:25:00',3.61),('8902','2013-04-25','12:30:00',3.31),('8902','2013-04-25','12:35:00',4.58),('8902','2013-04-25','12:40:00',6.11),('8902','2013-04-25','12:45:00',6.72),('8902','2013-04-25','12:50:00',3.91),('8902','2013-04-25','12:55:00',3.65),('8902','2013-04-25','13:00:00',2.66),('8902','2013-04-25','13:05:00',2.53),('8902','2013-04-25','13:10:00',3.05),('8902','2013-04-25','13:15:00',4.13),('8902','2013-04-25','13:20:00',3.09),('8902','2013-04-25','13:25:00',3.74),('8902','2013-04-25','13:30:00',4.84),('8902','2013-04-25','13:35:00',4.22),('8902','2013-04-25','13:40:00',5.24),('8902','2013-04-25','13:45:00',4.34),('8902','2013-04-25','13:50:00',5.16),('8902','2013-04-25','13:55:00',5.14),('8902','2013-04-25','14:00:00',5.5),('8902','2013-04-25','14:05:00',6.46),('8902','2013-04-25','14:10:00',7.37),('8902','2013-04-25','14:15:00',6.73),('8902','2013-04-25','14:20:00',6.5),('8902','2013-04-25','14:25:00',6.11),('8902','2013-04-25','14:30:00',7.57),('8902','2013-04-25','14:35:00',5.82),('8902','2013-04-25','14:40:00',3.33),('8902','2013-04-25','14:45:00',3.64),('8902','2013-04-25','14:50:00',7.33),('8902','2013-04-25','14:55:00',7.86),('8902','2013-04-25','15:00:00',7.43),('8902','2013-04-25','15:05:00',5.43),('8902','2013-04-25','15:10:00',2.48),('8902','2013-04-25','15:15:00',3.01),('8902','2013-04-25','15:20:00',2.74),('8902','2013-04-25','15:25:00',2.97),('8902','2013-04-25','15:30:00',3.89),('8902','2013-04-25','15:35:00',3.55),('8902','2013-04-25','15:40:00',3.71),('8902','2013-04-25','15:45:00',3.81),('8902','2013-04-25','15:50:00',3.52),('8902','2013-04-25','15:55:00',2.09),('8902','2013-04-25','16:00:00',1.07),('8902','2013-04-25','16:35:00',1.09),('8902','2013-04-25','16:40:00',1.06),('8902','2013-04-24','07:40:00',1.06),('8902','2013-04-24','07:45:00',1.21),('8902','2013-04-24','07:50:00',1.25),('8902','2013-04-24','07:55:00',1.26),('8902','2013-04-24','08:00:00',1.42),('8902','2013-04-24','08:05:00',1.74),('8902','2013-04-24','08:10:00',1.88),('8902','2013-04-24','08:15:00',2.3),('8902','2013-04-24','08:20:00',2),('8902','2013-04-24','08:25:00',1.71),('8902','2013-04-24','08:30:00',1.77),('8902','2013-04-24','08:35:00',1.86),('8902','2013-04-24','08:40:00',1.96),('8902','2013-04-24','08:45:00',2.31),('8902','2013-04-24','08:50:00',3.51),('8902','2013-04-24','08:55:00',4.12),('8902','2013-04-24','09:00:00',3.59),('8902','2013-04-24','09:05:00',2.64),('8902','2013-04-24','09:10:00',2.39),('8902','2013-04-24','09:15:00',2.26),('8902','2013-04-24','09:20:00',2.29),('8902','2013-04-24','09:25:00',2.79),('8902','2013-04-24','09:30:00',2.5),('8902','2013-04-24','09:35:00',2.74),('8902','2013-04-24','09:40:00',3.76),('8902','2013-04-24','09:45:00',4.62),('8902','2013-04-24','09:50:00',5.43),('8902','2013-04-24','09:55:00',5.46),('8902','2013-04-24','10:00:00',5.56),('8902','2013-04-24','10:05:00',5.35),('8902','2013-04-24','10:10:00',4.83),('8902','2013-04-24','10:15:00',4.92),('8902','2013-04-24','10:20:00',5.75),('8902','2013-04-24','10:25:00',5.92),('8902','2013-04-24','10:30:00',6.19),('8902','2013-04-24','10:35:00',6.26),('8902','2013-04-24','10:40:00',6.3),('8902','2013-04-24','10:45:00',6.06),('8902','2013-04-24','10:50:00',6.12),('8902','2013-04-24','10:55:00',6.59),('8902','2013-04-24','11:00:00',6.68),('8902','2013-04-24','11:05:00',6.76),('8902','2013-04-24','11:10:00',6.82),('8902','2013-04-24','11:15:00',6.89),('8902','2013-04-24','11:20:00',6.96),('8902','2013-04-24','11:25:00',7.06),('8902','2013-04-24','11:30:00',7.14),('8902','2013-04-24','11:35:00',7.24),('8902','2013-04-24','11:40:00',7.31),('8902','2013-04-24','11:45:00',7.39),('8902','2013-04-24','11:50:00',7.45),('8902','2013-04-24','11:55:00',7.33),('8902','2013-04-24','12:00:00',7.24),('8902','2013-04-24','12:05:00',7.25),('8902','2013-04-24','12:10:00',7.39),('8902','2013-04-24','12:15:00',7.5),('8902','2013-04-24','12:20:00',7.52),('8902','2013-04-24','12:25:00',7.54),('8902','2013-04-24','12:30:00',7.58),('8902','2013-04-24','12:35:00',7.63),('8902','2013-04-24','12:40:00',7.61),('8902','2013-04-24','12:45:00',7.65),('8902','2013-04-24','12:50:00',7.62),('8902','2013-04-24','12:55:00',7.73),('8902','2013-04-24','13:00:00',7.81),('8902','2013-04-24','13:05:00',7.95),('8902','2013-04-24','13:10:00',7.92),('8902','2013-04-24','13:15:00',7.16),('8902','2013-04-24','13:20:00',6.84),('8902','2013-04-24','13:25:00',6.5),('8902','2013-04-24','13:30:00',5.34),('8902','2013-04-24','13:35:00',5.38),('8902','2013-04-24','13:40:00',4.47),('8902','2013-04-24','13:45:00',4.1),('8902','2013-04-24','13:50:00',3.82),('8902','2013-04-24','13:55:00',4.04),('8902','2013-04-24','14:00:00',4.26),('8902','2013-04-24','14:05:00',3.9),('8902','2013-04-24','14:10:00',4.32),('8902','2013-04-24','14:15:00',4.44),('8902','2013-04-24','14:20:00',4.55),('8902','2013-04-24','14:25:00',4.59),('8902','2013-04-24','14:30:00',5.43),('8902','2013-04-24','14:35:00',6.47),('8902','2013-04-24','14:40:00',6.64),('8902','2013-04-24','14:45:00',6.52),('8902','2013-04-24','14:50:00',6.03),('8902','2013-04-24','14:55:00',6.15),('8902','2013-04-24','15:00:00',6.08),('8902','2013-04-24','15:05:00',5.5),('8902','2013-04-24','15:10:00',5.49),('8902','2013-04-24','15:15:00',6.14),('8902','2013-04-24','15:20:00',6.44),('8902','2013-04-24','15:25:00',6.79),('8902','2013-04-24','15:30:00',6.67),('8902','2013-04-24','15:35:00',6.25),('8902','2013-04-24','15:40:00',5.95),('8902','2013-04-24','15:45:00',5.44),('8902','2013-04-24','15:50:00',5.16),('8902','2013-04-24','15:55:00',5.04),('8902','2013-04-24','16:00:00',5.13),('8902','2013-04-24','16:05:00',4.16),('8902','2013-04-24','16:10:00',4.41),('8902','2013-04-24','16:15:00',4.15),('8902','2013-04-24','16:20:00',4.24),('8902','2013-04-24','16:25:00',3.79),('8902','2013-04-24','16:30:00',3.54),('8902','2013-04-24','16:35:00',4.5),('8902','2013-04-24','16:40:00',3.97),('8902','2013-04-24','16:45:00',3.74),('8902','2013-04-24','16:50:00',3.33),('8902','2013-04-24','16:55:00',3.69),('8902','2013-04-24','17:00:00',3.36),('8902','2013-04-24','17:05:00',4.24),('8902','2013-04-24','17:10:00',4.53),('8902','2013-04-24','17:15:00',4.2),('8902','2013-04-24','17:20:00',4.05),('8902','2013-04-24','17:25:00',3.45),('8902','2013-04-24','17:30:00',2.63),('8902','2013-04-24','17:35:00',2.51),('8902','2013-04-24','17:40:00',2.64),('8902','2013-04-24','17:45:00',2.13),('8902','2013-04-24','17:50:00',1.82),('8902','2013-04-24','17:55:00',1.57),('8902','2013-04-24','18:00:00',1.52),('8902','2013-04-24','18:05:00',1.42),('8902','2013-04-24','18:10:00',1.32),('8902','2013-04-24','18:15:00',1.2),('8902','2013-04-24','18:20:00',1.08),('8902','2013-04-23','07:45:00',1.18),('8902','2013-04-23','07:50:00',1.35),('8902','2013-04-23','07:55:00',1.51),('8902','2013-04-23','08:00:00',1.64),('8902','2013-04-23','08:05:00',1.74),('8902','2013-04-23','08:10:00',2),('8902','2013-04-23','08:15:00',2.31),('8902','2013-04-23','08:20:00',2.47),('8902','2013-04-23','08:25:00',2.7),('8902','2013-04-23','08:30:00',2.74),('8902','2013-04-23','08:35:00',2.65),('8902','2013-04-23','08:40:00',2.8),('8902','2013-04-23','08:45:00',2.91),('8902','2013-04-23','08:50:00',3.08),('8902','2013-04-23','08:55:00',3.24),('8902','2013-04-23','09:00:00',3.63),('8902','2013-04-23','09:05:00',4),('8902','2013-04-23','09:10:00',3.79),('8902','2013-04-23','09:15:00',4.05),('8902','2013-04-23','09:20:00',3.66),('8902','2013-04-23','09:25:00',4.37),('8902','2013-04-23','09:30:00',5.35),('8902','2013-04-23','09:35:00',4.89),('8902','2013-04-23','09:40:00',4.62),('8902','2013-04-23','09:45:00',4.46),('8902','2013-04-23','09:50:00',4.78),('8902','2013-04-23','09:55:00',5.47),('8902','2013-04-23','10:00:00',5.72),('8902','2013-04-23','10:05:00',5.88),('8902','2013-04-23','10:10:00',5.97),('8902','2013-04-23','10:15:00',5.99),('8902','2013-04-23','10:20:00',5.91),('8902','2013-04-23','10:25:00',5.86),('8902','2013-04-23','10:30:00',5.83),('8902','2013-04-23','10:35:00',5.86),('8902','2013-04-23','10:40:00',6.47),('8902','2013-04-23','10:45:00',6.63),('8902','2013-04-23','10:50:00',6.69),('8902','2013-04-23','10:55:00',6.9),('8902','2013-04-23','11:00:00',6.98),('8902','2013-04-23','11:05:00',6.79),('8902','2013-04-23','11:10:00',7.28),('8902','2013-04-23','11:15:00',7.48),('8902','2013-04-23','11:20:00',7.63),('8902','2013-04-23','11:25:00',7.66),('8902','2013-04-23','11:30:00',7.49),('8902','2013-04-23','11:35:00',6.6),('8902','2013-04-23','11:40:00',4.73),('8902','2013-04-23','11:45:00',5.57),('8902','2013-04-23','11:50:00',3.86),('8902','2013-04-23','11:55:00',5.44),('8902','2013-04-23','12:00:00',6.77),('8902','2013-04-23','12:05:00',4.3),('8902','2013-04-23','12:10:00',4.99),('8902','2013-04-23','12:15:00',7.32),('8902','2013-04-23','12:20:00',8.53),('8902','2013-04-23','12:25:00',7.46),('8902','2013-04-23','12:30:00',7.22),('8902','2013-04-23','12:35:00',7.39),('8902','2013-04-23','12:40:00',6.96),('8902','2013-04-23','12:45:00',7.17),('8902','2013-04-23','12:50:00',7.73),('8902','2013-04-23','12:55:00',7.51),('8902','2013-04-23','13:00:00',7.36),('8902','2013-04-23','13:05:00',6.35),('8902','2013-04-23','13:10:00',8.29),('8902','2013-04-23','13:15:00',7.69),('8902','2013-04-23','13:20:00',7.37),('8902','2013-04-23','13:25:00',7.52),('8902','2013-04-23','13:30:00',7.2),('8902','2013-04-23','13:35:00',7.29),('8902','2013-04-23','13:40:00',8.13),('8902','2013-04-23','13:45:00',7.19),('8902','2013-04-23','13:50:00',4.88),('8902','2013-04-23','13:55:00',7.8),('8902','2013-04-23','14:00:00',7.9),('8902','2013-04-23','14:05:00',5.52),('8902','2013-04-23','14:10:00',5.27),('8902','2013-04-23','14:15:00',7.91),('8902','2013-04-23','14:20:00',7.1),('8902','2013-04-23','14:25:00',7.36),('8902','2013-04-23','14:30:00',6.97),('8902','2013-04-23','14:35:00',6.12),('8902','2013-04-23','14:40:00',5.91),('8902','2013-04-23','14:45:00',5.68),('8902','2013-04-23','14:50:00',5.1),('8902','2013-04-23','14:55:00',4.5),('8902','2013-04-23','15:00:00',4.96),('8902','2013-04-23','15:05:00',4.51),('8902','2013-04-23','15:10:00',4.26),('8902','2013-04-23','15:15:00',4.5),('8902','2013-04-23','15:20:00',4.7),('8902','2013-04-23','15:25:00',4.04),('8902','2013-04-23','15:30:00',3.36),('8902','2013-04-23','15:35:00',3.27),('8902','2013-04-23','15:40:00',3.2),('8902','2013-04-23','15:45:00',3.23),('8902','2013-04-23','15:50:00',3.29),('8902','2013-04-23','15:55:00',4.04),('8902','2013-04-23','16:00:00',5.26),('8902','2013-04-23','16:05:00',5.41),('8902','2013-04-23','16:10:00',5.39),('8902','2013-04-23','16:15:00',4.93),('8902','2013-04-23','16:20:00',6.43),('8902','2013-04-23','16:25:00',4.94),('8902','2013-04-23','16:30:00',4.25),('8902','2013-04-23','16:35:00',3.46),('8902','2013-04-23','16:40:00',4.87),('8902','2013-04-23','16:45:00',4.97),('8902','2013-04-23','16:50:00',4.34),('8902','2013-04-23','16:55:00',5.29),('8902','2013-04-23','17:00:00',5.41),('8902','2013-04-23','17:05:00',5.02),('8902','2013-04-23','17:10:00',4.79),('8902','2013-04-23','17:15:00',3.7),('8902','2013-04-23','17:20:00',3.2),('8902','2013-04-23','17:25:00',3.24),('8902','2013-04-23','17:30:00',1.83),('8902','2013-04-23','17:35:00',1.66),('8902','2013-04-23','17:40:00',1.3),('8902','2013-04-23','17:45:00',1.68),('8902','2013-04-23','17:50:00',2.03),('8902','2013-04-23','17:55:00',2.7),('8902','2013-04-23','18:00:00',2.16),('8902','2013-04-23','18:05:00',2.09),('8902','2013-04-23','18:10:00',1.88),('8902','2013-04-23','18:15:00',1.17),('8902','2013-04-23','18:20:00',1.71),('8902','2013-04-23','18:25:00',1.53),('8902','2013-04-23','18:30:00',1.09),('8902','2013-04-22','07:40:00',1.12),('8902','2013-04-22','07:45:00',1.31),('8902','2013-04-22','07:50:00',1.48),('8902','2013-04-22','07:55:00',1.66),('8902','2013-04-22','08:00:00',1.83),('8902','2013-04-22','08:05:00',2.01),('8902','2013-04-22','08:10:00',2.19),('8902','2013-04-22','08:15:00',2.38),('8902','2013-04-22','08:20:00',2.57),('8902','2013-04-22','08:25:00',2.74),('8902','2013-04-22','08:30:00',2.92),('8902','2013-04-22','08:35:00',3.11),('8902','2013-04-22','08:40:00',3.28),('8902','2013-04-22','08:45:00',3.44),('8902','2013-04-22','08:50:00',3.63),('8902','2013-04-22','08:55:00',3.8),('8902','2013-04-22','09:00:00',3.97),('8902','2013-04-22','09:05:00',4.15),('8902','2013-04-22','09:10:00',4.34),('8902','2013-04-22','09:15:00',4.52),('8902','2013-04-22','09:20:00',4.68),('8902','2013-04-22','09:25:00',4.83),('8902','2013-04-22','09:30:00',4.97),('8902','2013-04-22','09:35:00',5.15),('8902','2013-04-22','09:40:00',4.85),('8902','2013-04-22','09:45:00',4.73),('8902','2013-04-22','09:50:00',5.72),('8902','2013-04-22','09:55:00',5.79),('8902','2013-04-22','10:00:00',5.85),('8902','2013-04-22','10:05:00',5.94),('8902','2013-04-22','10:10:00',6.07),('8902','2013-04-22','10:15:00',6.19),('8902','2013-04-22','10:20:00',6.34),('8902','2013-04-22','10:25:00',6.41),('8902','2013-04-22','10:30:00',6.52),('8902','2013-04-22','10:35:00',6.64),('8902','2013-04-22','10:40:00',6.76),('8902','2013-04-22','10:45:00',6.71),('8902','2013-04-22','10:50:00',6.78),('8902','2013-04-22','10:55:00',6.98),('8902','2013-04-22','11:00:00',7.08),('8902','2013-04-22','11:05:00',7.13),('8902','2013-04-22','11:10:00',7.19),('8902','2013-04-22','11:15:00',7.23),('8902','2013-04-22','11:20:00',7.33),('8902','2013-04-22','11:25:00',7.44),('8902','2013-04-22','11:30:00',7.52),('8902','2013-04-22','11:35:00',7.52),('8902','2013-04-22','11:40:00',7.56),('8902','2013-04-22','11:45:00',7.63),('8902','2013-04-22','11:50:00',7.68),('8902','2013-04-22','11:55:00',7.72),('8902','2013-04-22','12:00:00',7.72),('8902','2013-04-22','12:05:00',7.63),('8902','2013-04-22','12:10:00',7.79),('8902','2013-04-22','12:15:00',7.78),('8902','2013-04-22','12:20:00',7.83),('8902','2013-04-22','12:25:00',7.78),('8902','2013-04-22','12:30:00',3.35),('8902','2013-04-22','12:35:00',6.79),('8902','2013-04-22','12:40:00',4.5),('8902','2013-04-22','12:45:00',3.7),('8902','2013-04-22','12:50:00',6.59),('8902','2013-04-22','12:55:00',3.6),('8902','2013-04-22','13:00:00',7.08),('8902','2013-04-22','13:05:00',4.53),('8902','2013-04-22','13:10:00',2.78),('8902','2013-04-22','13:15:00',8.74),('8902','2013-04-22','13:20:00',8.13),('8902','2013-04-22','13:25:00',8.74),('8902','2013-04-22','13:30:00',8.33),('8902','2013-04-22','13:35:00',8.51),('8902','2013-04-22','13:40:00',8.4),('8902','2013-04-22','13:45:00',5.92),('8902','2013-04-22','13:50:00',7.45),('8902','2013-04-22','13:55:00',7.77),('8902','2013-04-22','14:00:00',4.04),('8902','2013-04-22','14:05:00',8.89),('8902','2013-04-22','14:10:00',5.81),('8902','2013-04-22','14:15:00',7.63),('8902','2013-04-22','14:20:00',7.51),('8902','2013-04-22','14:25:00',6.95),('8902','2013-04-22','14:30:00',7.95),('8902','2013-04-22','14:35:00',8.02),('8902','2013-04-22','14:40:00',7.93),('8902','2013-04-22','14:45:00',6.38),('8902','2013-04-22','14:50:00',4.03),('8902','2013-04-22','14:55:00',4.5),('8902','2013-04-22','15:00:00',4.33),('8902','2013-04-22','15:05:00',4.7),('8902','2013-04-22','15:10:00',5.65),('8902','2013-04-22','15:15:00',5.76),('8902','2013-04-22','15:20:00',5.24),('8902','2013-04-22','15:25:00',4.84),('8902','2013-04-22','15:30:00',4.69),('8902','2013-04-22','15:35:00',4.56),('8902','2013-04-22','15:40:00',4.06),('8902','2013-04-22','15:45:00',4.19),('8902','2013-04-22','15:50:00',3.55),('8902','2013-04-22','15:55:00',3.05),('8902','2013-04-22','16:00:00',3.28),('8902','2013-04-22','16:05:00',3.24),('8902','2013-04-22','16:10:00',3.09),('8902','2013-04-22','16:15:00',2.86),('8902','2013-04-22','16:20:00',2.34),('8902','2013-04-22','16:25:00',2.33),('8902','2013-04-22','16:30:00',2.1),('8902','2013-04-22','16:35:00',2.32),('8902','2013-04-22','16:40:00',2.28),('8902','2013-04-22','16:45:00',2.37),('8902','2013-04-22','16:50:00',1.99),('8902','2013-04-22','16:55:00',2.17),('8902','2013-04-22','17:00:00',2),('8902','2013-04-22','17:05:00',2.11),('8902','2013-04-22','17:10:00',2.66),('8902','2013-04-22','17:15:00',4.29),('8902','2013-04-22','17:20:00',4.29),('8902','2013-04-22','17:25:00',3.58),('8902','2013-04-22','17:30:00',2.95),('8902','2013-04-22','17:35:00',2.66),('8902','2013-04-22','17:40:00',2.74),('8902','2013-04-22','17:45:00',2.93),('8902','2013-04-22','17:50:00',2.34),('8902','2013-04-22','17:55:00',1.43),('8902','2013-04-22','18:00:00',1.67),('8902','2013-04-22','18:05:00',1.43),('8902','2013-04-22','18:10:00',1.01),('8902','2013-04-21','08:45:00',1.08),('8902','2013-04-21','09:00:00',1.2),('8902','2013-04-21','09:05:00',1.24),('8902','2013-04-21','09:10:00',1.33),('8902','2013-04-21','09:15:00',1.25),('8902','2013-04-21','09:20:00',1.26),('8902','2013-04-21','09:25:00',1.46),('8902','2013-04-21','09:30:00',2.05),('8902','2013-04-21','09:35:00',1.9),('8902','2013-04-21','09:40:00',1.45),('8902','2013-04-21','09:45:00',1.06),('8902','2013-04-21','10:35:00',4.07),('8902','2013-04-21','10:40:00',7.07),('8902','2013-04-21','10:45:00',8.97),('8902','2013-04-21','10:50:00',4.31),('8902','2013-04-21','10:55:00',4.1),('8902','2013-04-21','11:00:00',3.76),('8902','2013-04-21','11:05:00',3.58),('8902','2013-04-21','11:10:00',4.23),('8902','2013-04-21','11:15:00',2.72),('8902','2013-04-21','11:20:00',2.72),('8902','2013-04-21','11:25:00',3.51),('8902','2013-04-21','11:30:00',5.68),('8902','2013-04-21','11:35:00',6.69),('8902','2013-04-21','11:40:00',7.04),('8902','2013-04-21','11:45:00',3.4),('8902','2013-04-21','11:50:00',3.32),('8902','2013-04-21','11:55:00',7.94),('8902','2013-04-21','12:00:00',5.48),('8902','2013-04-21','12:05:00',6.13),('8902','2013-04-21','12:10:00',8.95),('8902','2013-04-21','12:15:00',6.64),('8902','2013-04-21','12:20:00',7.74),('8902','2013-04-21','12:25:00',4.48),('8902','2013-04-21','12:30:00',5.47),('8902','2013-04-21','12:35:00',5.75),('8902','2013-04-21','12:40:00',8.5),('8902','2013-04-21','12:45:00',8.2),('8902','2013-04-21','12:50:00',8.68),('8902','2013-04-21','12:55:00',8.75),('8902','2013-04-21','13:00:00',8.74),('8902','2013-04-21','13:05:00',8.97),('8902','2013-04-21','13:10:00',9.27),('8902','2013-04-21','13:15:00',8.75),('8902','2013-04-21','13:20:00',7.89),('8902','2013-04-21','13:25:00',4.52),('8902','2013-04-21','13:30:00',5.78),('8902','2013-04-21','13:35:00',5.02),('8902','2013-04-21','13:40:00',5.44),('8902','2013-04-21','13:45:00',8.44),('8902','2013-04-21','13:50:00',2.13),('8902','2013-04-21','13:55:00',3.34),('8902','2013-04-21','14:00:00',2.33),('8902','2013-04-21','14:05:00',2.62),('8902','2013-04-21','14:10:00',2.37),('8902','2013-04-21','14:15:00',2.08),('8902','2013-04-21','14:20:00',8.57),('8902','2013-04-21','14:25:00',7.92),('8902','2013-04-21','14:30:00',9.26),('8902','2013-04-21','14:35:00',7.08),('8902','2013-04-21','14:40:00',9.03),('8902','2013-04-21','14:45:00',8.77),('8902','2013-04-21','14:50:00',8.88),('8902','2013-04-21','14:55:00',7.9),('8902','2013-04-21','15:00:00',6.5),('8902','2013-04-21','15:05:00',8.96),('8902','2013-04-21','15:10:00',4.07),('8902','2013-04-21','15:15:00',1.64),('8902','2013-04-21','15:20:00',1.78),('8902','2013-04-21','15:25:00',3.7),('8902','2013-04-21','15:30:00',4.31),('8902','2013-04-21','15:35:00',2.04),('8902','2013-04-21','15:40:00',4.45),('8902','2013-04-21','15:45:00',6.6),('8902','2013-04-21','15:50:00',4.95),('8902','2013-04-21','15:55:00',2.48),('8902','2013-04-21','16:00:00',1.56),('8902','2013-04-21','16:05:00',1.44),('8902','2013-04-21','16:10:00',1.38),('8902','2013-04-21','16:15:00',1.43),('8902','2013-04-21','16:20:00',1.29),('8902','2013-04-21','16:35:00',1.28),('8902','2013-04-21','16:40:00',1.95),('8902','2013-04-21','16:45:00',2.97),('8902','2013-04-21','16:50:00',1.52),('8902','2013-04-21','17:25:00',1.03),('8902','2013-04-21','17:30:00',1.61),('8902','2013-04-21','17:35:00',1.78),('8902','2013-04-21','17:40:00',1.28),('8902','2013-04-21','18:10:00',1.24),('8902','2013-04-21','18:20:00',1.18),('8902','2013-04-21','18:25:00',1.22),('8902','2013-04-21','18:50:00',1.09),('8902','2014-03-28','07:10:00',1.14),('8902','2014-03-28','07:15:00',1.33),('8902','2014-03-28','07:20:00',1.49),('8902','2014-03-28','07:25:00',1.65),('8902','2014-03-28','07:30:00',1.82),('8902','2014-03-28','07:35:00',1.98),('8902','2014-03-28','07:40:00',2.15),('8902','2014-03-28','07:45:00',2.35),('8902','2014-03-28','07:50:00',2.54),('8902','2014-03-28','07:55:00',2.7),('8902','2014-03-28','08:00:00',2.89),('8902','2014-03-28','08:05:00',3.08),('8902','2014-03-28','08:10:00',3.29),('8902','2014-03-28','08:15:00',3.45),('8902','2014-03-28','08:20:00',3.65),('8902','2014-03-28','08:25:00',3.84),('8902','2014-03-28','08:30:00',4),('8902','2014-03-28','08:35:00',4.19),('8902','2014-03-28','08:40:00',4.34),('8902','2014-03-28','08:45:00',4.52),('8902','2014-03-28','08:50:00',4.66),('8902','2014-03-28','08:55:00',4.74),('8902','2014-03-28','09:00:00',4.91),('8902','2014-03-28','09:05:00',5.06),('8902','2014-03-28','09:10:00',5.22),('8902','2014-03-28','09:15:00',5.37),('8902','2014-03-28','09:20:00',5.52),('8902','2014-03-28','09:25:00',5.66),('8902','2014-03-28','09:30:00',5.76),('8902','2014-03-28','09:35:00',5.92),('8902','2014-03-28','09:40:00',6.06),('8902','2014-03-28','09:45:00',6.18),('8902','2014-03-28','09:50:00',6.33),('8902','2014-03-28','09:55:00',6.52),('8902','2014-03-28','10:00:00',6.62),('8902','2014-03-28','10:05:00',6.72),('8902','2014-03-28','10:10:00',6.83),('8902','2014-03-28','10:15:00',6.92),('8902','2014-03-28','10:20:00',7.04),('8902','2014-03-28','10:25:00',7.11),('8902','2014-03-28','10:30:00',7.14),('8902','2014-03-28','10:35:00',7.24),('8902','2014-03-28','10:40:00',7.26),('8902','2014-03-28','10:45:00',7.38),('8902','2014-03-28','10:50:00',7.47),('8902','2014-03-28','10:55:00',7.57),('8902','2014-03-28','11:00:00',7.61),('8902','2014-03-28','11:05:00',7.64),('8902','2014-03-28','11:10:00',7.71),('8902','2014-03-28','11:15:00',7.79),('8902','2014-03-28','11:20:00',7.78),('8902','2014-03-28','11:25:00',7.8),('8902','2014-03-28','11:30:00',7.77),('8902','2014-03-28','11:35:00',7.8),('8902','2014-03-28','11:40:00',7.68),('8902','2014-03-28','11:45:00',7.99),('8902','2014-03-28','11:50:00',7.92),('8902','2014-03-28','11:55:00',7.88),('8902','2014-03-28','12:00:00',7.89),('8902','2014-03-28','12:05:00',7.9),('8902','2014-03-28','12:10:00',7.93),('8902','2014-03-28','12:15:00',7.99),('8902','2014-03-28','12:20:00',8.07),('8902','2014-03-28','12:25:00',8.07),('8902','2014-03-28','12:30:00',8.1),('8902','2014-03-28','12:35:00',8.06),('8902','2014-03-28','12:40:00',7.96),('8902','2014-03-28','12:45:00',8.01),('8902','2014-03-28','12:50:00',7.99),('8902','2014-03-28','12:55:00',8.01),('8902','2014-03-28','13:00:00',8),('8902','2014-03-28','13:05:00',7.96),('8902','2014-03-28','13:10:00',7.91),('8902','2014-03-28','13:15:00',7.83),('8902','2014-03-28','13:20:00',7.82),('8902','2014-03-28','13:25:00',7.67),('8902','2014-03-28','13:30:00',7.6),('8902','2014-03-28','13:35:00',7.53),('8902','2014-03-28','13:40:00',7.4),('8902','2014-03-28','13:45:00',7.29),('8902','2014-03-28','13:50:00',7.3),('8902','2014-03-28','13:55:00',7.23),('8902','2014-03-28','14:00:00',7.16),('8902','2014-03-28','14:05:00',7.14),('8902','2014-03-28','14:10:00',7.08),('8902','2014-03-28','14:15:00',6.94),('8902','2014-03-28','14:20:00',6.43),('8902','2014-03-28','14:25:00',6.83),('8902','2014-03-28','14:30:00',6.6),('8902','2014-03-28','14:35:00',6.42),('8902','2014-03-28','14:40:00',6.44),('8902','2014-03-28','14:45:00',6.27),('8902','2014-03-28','14:50:00',6.19),('8902','2014-03-28','14:55:00',6.33),('8902','2014-03-28','15:00:00',6.15),('8902','2014-03-28','15:05:00',6.01),('8902','2014-03-28','15:10:00',5.63),('8902','2014-03-28','15:15:00',5.72),('8902','2014-03-28','15:20:00',5.66),('8902','2014-03-28','15:25:00',5.42),('8902','2014-03-28','15:30:00',5.17),('8902','2014-03-28','15:35:00',4.95),('8902','2014-03-28','15:40:00',4.9),('8902','2014-03-28','15:45:00',4.76),('8902','2014-03-28','15:50:00',4.55),('8902','2014-03-28','15:55:00',4.49),('8902','2014-03-28','16:00:00',4.33),('8902','2014-03-28','16:05:00',4.1),('8902','2014-03-28','16:10:00',3.93),('8902','2014-03-28','16:15:00',3.8),('8902','2014-03-28','16:20:00',3.46),('8902','2014-03-28','16:25:00',3.38),('8902','2014-03-28','16:30:00',3.21),('8902','2014-03-28','16:35:00',2.88),('8902','2014-03-28','16:40:00',2.51),('8902','2014-03-28','16:45:00',1.99),('8902','2014-03-28','16:50:00',2.19),('8902','2014-03-28','16:55:00',2.24),('8902','2014-03-28','17:00:00',2.08),('8902','2014-03-28','17:05:00',1.87),('8902','2014-03-28','17:10:00',1.71),('8902','2014-03-28','17:15:00',1.52),('8902','2014-03-28','17:20:00',1.31),('8902','2014-03-28','17:25:00',1.13),('8902','2013-04-20','07:55:00',1.3),('8902','2013-04-20','08:00:00',1.39),('8902','2013-04-20','08:05:00',1.62),('8902','2013-04-20','08:10:00',1.65),('8902','2013-04-20','08:15:00',2.02),('8902','2013-04-20','08:20:00',1.76),('8902','2013-04-20','08:25:00',1.96),('8902','2013-04-20','08:30:00',1.73),('8902','2013-04-20','08:35:00',2.2),('8902','2013-04-20','08:40:00',2.35),('8902','2013-04-20','08:45:00',2.68),('8902','2013-04-20','08:50:00',2.93),('8902','2013-04-20','08:55:00',3.29),('8902','2013-04-20','09:00:00',2.5),('8902','2013-04-20','09:05:00',2.89),('8902','2013-04-20','09:10:00',4.25),('8902','2013-04-20','09:15:00',4.61),('8902','2013-04-20','09:20:00',2.97),('8902','2013-04-20','09:25:00',2.97),('8902','2013-04-20','09:30:00',5.26),('8902','2013-04-20','09:35:00',5.42),('8902','2013-04-20','09:40:00',5.38),('8902','2013-04-20','09:45:00',5.86),('8902','2013-04-20','09:50:00',6.46),('8902','2013-04-20','09:55:00',5.63),('8902','2013-04-20','10:00:00',5.45),('8902','2013-04-20','10:05:00',4.8),('8902','2013-04-20','10:10:00',3.67),('8902','2013-04-20','10:15:00',3.33),('8902','2013-04-20','10:20:00',5.13),('8902','2013-04-20','10:25:00',6.12),('8902','2013-04-20','10:30:00',5.79),('8902','2013-04-20','10:35:00',4.57),('8902','2013-04-20','10:40:00',6),('8902','2013-04-20','10:45:00',5.32),('8902','2013-04-20','10:50:00',6.98),('8902','2013-04-20','10:55:00',6.48),('8902','2013-04-20','11:00:00',7.02),('8902','2013-04-20','11:05:00',6.87),('8902','2013-04-20','11:10:00',8.24),('8902','2013-04-20','11:15:00',5.66),('8902','2013-04-20','11:20:00',6.02),('8902','2013-04-20','11:25:00',6.17),('8902','2013-04-20','11:30:00',5.57),('8902','2013-04-20','11:35:00',6.03),('8902','2013-04-20','11:40:00',7.2),('8902','2013-04-20','11:45:00',7.12),('8902','2013-04-20','11:50:00',6.5),('8902','2013-04-20','11:55:00',6.17),('8902','2013-04-20','12:00:00',4.72),('8902','2013-04-20','12:05:00',4.6),('8902','2013-04-20','12:10:00',4.47),('8902','2013-04-20','12:15:00',4.19),('8902','2013-04-20','12:20:00',3.88),('8902','2013-04-20','12:25:00',3.72),('8902','2013-04-20','12:30:00',4.08),('8902','2013-04-20','12:35:00',4.16),('8902','2013-04-20','12:40:00',4.23),('8902','2013-04-20','12:45:00',4.23),('8902','2013-04-20','12:50:00',3.91),('8902','2013-04-20','12:55:00',3.86),('8902','2013-04-20','13:00:00',4.39),('8902','2013-04-20','13:05:00',5.06),('8902','2013-04-20','13:10:00',5.15),('8902','2013-04-20','13:15:00',4.91),('8902','2013-04-20','13:20:00',4.56),('8902','2013-04-20','13:25:00',4.32),('8902','2013-04-20','13:30:00',6.7),('8902','2013-04-20','13:35:00',7.31),('8902','2013-04-20','13:40:00',5.71),('8902','2013-04-20','13:45:00',5.87),('8902','2013-04-20','13:50:00',4.67),('8902','2013-04-20','13:55:00',8.64),('8902','2013-04-20','14:00:00',8.86),('8902','2013-04-20','14:05:00',7.87),('8902','2013-04-20','14:10:00',8.45),('8902','2013-04-20','14:15:00',7.47),('8902','2013-04-20','14:20:00',9.39),('8902','2013-04-20','14:25:00',7.92),('8902','2013-04-20','14:30:00',7.62),('8902','2013-04-20','14:35:00',7.51),('8902','2013-04-20','14:40:00',8.69),('8902','2013-04-20','14:45:00',7.38),('8902','2013-04-20','14:50:00',4.41),('8902','2013-04-20','14:55:00',4.33),('8902','2013-04-20','15:00:00',6.38),('8902','2013-04-20','15:05:00',8.64),('8902','2013-04-20','15:10:00',8.34),('8902','2013-04-20','15:15:00',6.73),('8902','2013-04-20','15:20:00',4.63),('8902','2013-04-20','15:25:00',3.75),('8902','2013-04-20','15:30:00',3.25),('8902','2013-04-20','15:35:00',2.71),('8902','2013-04-20','15:40:00',2.83),('8902','2013-04-20','15:45:00',2.36),('8902','2013-04-20','15:50:00',2.03),('8902','2013-04-20','15:55:00',1.85),('8902','2013-04-20','16:00:00',1.64),('8902','2013-04-20','16:05:00',1.45),('8902','2013-04-20','16:10:00',1.37),('8902','2013-04-20','16:15:00',1.44),('8902','2013-04-20','16:20:00',1.18),('8902','2013-04-20','16:35:00',1.14),('8902','2013-04-20','16:40:00',1.12),('8902','2013-04-20','16:55:00',1.38),('8902','2013-04-20','17:00:00',1.71),('8902','2013-04-20','17:05:00',1.74),('8902','2013-04-20','17:10:00',1.47),('8902','2013-04-20','17:15:00',1.44),('8902','2013-04-20','17:20:00',1.26),('8902','2013-04-20','17:25:00',1.12),('8902','2013-04-20','17:45:00',1.09),('8902','2013-04-19','10:15:00',1),('8902','2013-04-19','10:20:00',1.04),('8902','2013-04-19','10:25:00',1.04),('8902','2013-04-19','10:30:00',1.15),('8902','2013-04-19','10:35:00',1.45),('8902','2013-04-19','10:40:00',2.35),('8902','2013-04-19','10:45:00',3.43),('8902','2013-04-19','10:50:00',4.5),('8902','2013-04-19','10:55:00',4.04),('8902','2013-04-19','11:00:00',4.67),('8902','2013-04-19','11:05:00',2.39),('8902','2013-04-19','11:10:00',4.29),('8902','2013-04-19','11:15:00',8.52),('8902','2013-04-19','11:20:00',4.46),('8902','2013-04-19','11:25:00',5.47),('8902','2013-04-19','11:30:00',8.35),('8902','2013-04-19','11:35:00',6.13),('8902','2013-04-19','11:40:00',4.59),('8902','2013-04-19','11:45:00',5.14),('8902','2013-04-19','11:50:00',2.95),('8902','2013-04-19','11:55:00',7.96),('8902','2013-04-19','12:00:00',8.31),('8902','2013-04-19','12:05:00',2.69),('8902','2013-04-19','12:10:00',7.62),('8902','2013-04-19','14:40:00',7.81),('8902','2013-04-19','14:45:00',7.87),('8902','2013-04-19','14:50:00',7.9),('8902','2013-04-19','14:55:00',7.89),('8902','2013-04-19','15:00:00',7.8),('8902','2013-04-19','15:05:00',7.65),('8902','2013-04-19','15:10:00',4.51),('8902','2013-04-19','15:15:00',5.88),('8902','2013-04-19','15:20:00',5.38),('8902','2013-04-19','15:25:00',6.83),('8902','2013-04-19','15:30:00',4.34),('8902','2013-04-19','15:35:00',1.83),('8902','2013-04-19','15:40:00',1.56),('8902','2013-04-19','15:45:00',1.56),('8902','2013-04-19','15:50:00',1.5),('8902','2013-04-19','15:55:00',1.42),('8902','2013-04-19','16:00:00',1.54),('8902','2013-04-19','16:05:00',1.94),('8902','2013-04-19','16:10:00',2.67),('8902','2013-04-19','16:15:00',4.12),('8902','2013-04-19','16:20:00',4.13),('8902','2013-04-19','16:25:00',5.1),('8902','2013-04-19','16:30:00',5.76),('8902','2013-04-19','16:35:00',5.37),('8902','2013-04-19','16:40:00',5.89),('8902','2013-04-19','16:45:00',6.01),('8902','2013-04-19','16:50:00',5.42),('8902','2013-04-19','16:55:00',5.27),('8902','2013-04-19','17:00:00',4.99),('8902','2013-04-19','17:05:00',4.77),('8902','2013-04-19','17:10:00',4.64),('8902','2013-04-19','17:15:00',4.28),('8902','2013-04-19','17:20:00',3.93),('8902','2013-04-19','17:25:00',3.79),('8902','2013-04-19','17:30:00',3.96),('8902','2013-04-19','17:35:00',4.2),('8902','2013-04-19','17:40:00',3.82),('8902','2013-04-19','17:45:00',1.65),('8902','2013-04-19','17:50:00',1.79),('8902','2013-04-19','17:55:00',3.39),('8902','2013-04-19','18:00:00',2.8),('8902','2013-04-19','18:05:00',2.79),('8902','2013-04-19','18:10:00',2.8),('8902','2013-04-19','18:15:00',2.31),('8902','2013-04-19','18:20:00',1.64),('8902','2013-04-18','14:25:00',7.27),('8902','2013-04-18','14:30:00',7.35),('8902','2013-04-18','14:35:00',7.1),('8902','2013-04-18','14:40:00',7.11),('8902','2013-04-18','14:45:00',7.13),('8902','2013-04-18','14:50:00',7.15),('8902','2013-04-18','14:55:00',7.06),('8902','2013-04-18','15:00:00',7.05),('8902','2013-04-18','15:05:00',6.91),('8902','2013-04-18','15:10:00',6.78),('8902','2013-04-18','15:15:00',6.79),('8902','2013-04-18','15:20:00',6.66),('8902','2013-04-18','15:25:00',6.62),('8902','2013-04-18','15:30:00',6.56),('8902','2013-04-18','15:35:00',6.49),('8902','2013-04-18','15:40:00',6.41),('8902','2013-04-18','15:45:00',6.34),('8902','2013-04-18','15:50:00',6.31),('8902','2013-04-18','15:55:00',6.2),('8902','2013-04-18','16:00:00',6.09),('8902','2013-04-18','16:05:00',6.01),('8902','2013-04-18','16:10:00',5.84),('8902','2013-04-18','16:15:00',5.72),('8902','2013-04-18','16:20:00',5.6),('8902','2013-04-18','16:25:00',5.41),('8902','2013-04-18','16:30:00',5.31),('8902','2013-04-18','16:35:00',5.17),('8902','2013-04-18','16:40:00',5.03),('8902','2013-04-18','16:45:00',4.77),('8902','2013-04-18','16:50:00',4.69),('8902','2013-04-18','16:55:00',4.56),('8902','2013-04-18','17:00:00',4.38),('8902','2013-04-18','17:05:00',4.18),('8902','2013-04-18','17:10:00',3.98),('8902','2013-04-18','17:15:00',3.83),('8902','2013-04-18','17:20:00',3.68),('8902','2013-04-18','17:25:00',3.5),('8902','2013-04-18','17:30:00',3.33),('8902','2013-04-18','17:35:00',3.15),('8902','2013-04-18','17:40:00',2.95),('8902','2013-04-18','17:45:00',2.79),('8902','2013-04-18','17:50:00',2.56),('8902','2013-04-18','17:55:00',2.4),('8902','2013-04-18','18:00:00',2.28),('8902','2013-04-18','18:05:00',2.08),('8902','2013-04-18','18:10:00',1.91),('8902','2013-04-18','18:15:00',1.74),('8902','2013-04-18','18:20:00',1.57),('8902','2013-04-18','18:25:00',1.45),('8902','2013-04-18','18:30:00',1.3),('8902','2013-04-18','18:35:00',1.17),('8902','2013-04-18','18:40:00',1.01),('8902','2013-04-17','09:45:00',4.65),('8902','2013-04-17','09:50:00',4.2),('8902','2013-04-17','09:55:00',4.4),('8902','2013-04-17','10:00:00',5.25),('8902','2013-04-17','10:05:00',5.63),('8902','2013-04-17','10:10:00',5.88),('8902','2013-04-17','10:15:00',6.04),('8902','2013-04-17','10:20:00',6.14),('8902','2013-04-17','10:25:00',6.06),('8902','2013-04-17','10:30:00',6.26),('8902','2013-04-17','10:35:00',6.36),('8902','2013-04-17','10:40:00',6.47),('8902','2013-04-17','10:45:00',6.57),('8902','2013-04-17','10:50:00',6.66),('8902','2013-04-17','10:55:00',6.73),('8902','2013-04-17','11:00:00',6.84),('8902','2013-04-17','11:05:00',6.93),('8902','2013-04-17','11:10:00',6.95),('8902','2013-04-17','11:15:00',7.08),('8902','2013-04-17','11:20:00',7.15),('8902','2013-04-17','11:25:00',7.18),('8902','2013-04-17','11:30:00',7.26),('8902','2013-04-17','11:35:00',7.33),('8902','2013-04-17','11:40:00',7.33),('8902','2013-04-17','11:45:00',7.33),('8902','2013-04-17','11:50:00',7.35),('8902','2013-04-17','11:55:00',7.49),('8902','2013-04-17','12:00:00',7.46),('8902','2013-04-17','12:05:00',7.61),('8902','2013-04-17','12:10:00',7.67),('8902','2013-04-17','12:15:00',7.73),('8902','2013-04-17','12:20:00',7.81),('8902','2013-04-17','12:25:00',7.86),('8902','2013-04-17','12:30:00',7.85),('8902','2013-04-17','12:35:00',7.92),('8902','2013-04-17','12:40:00',7.91),('8902','2013-04-17','12:45:00',7.93),('8902','2013-04-17','12:50:00',7.99),('8902','2013-04-17','12:55:00',7.96),('8902','2013-04-17','13:00:00',7.97),('8902','2013-04-17','13:05:00',8),('8902','2013-04-17','13:10:00',8.02),('8902','2013-04-17','13:15:00',8.02),('8902','2013-04-17','13:20:00',7.98),('8902','2013-04-17','13:25:00',8.02),('8902','2013-04-17','13:30:00',8.06),('8902','2013-04-17','13:35:00',8.02),('8902','2013-04-17','13:40:00',8.02),('8902','2013-04-17','13:45:00',8),('8902','2013-04-17','13:50:00',7.98),('8902','2013-04-17','13:55:00',8.01),('8902','2013-04-17','14:00:00',7.97),('8902','2013-04-17','14:05:00',7.9),('8902','2013-04-17','14:10:00',7.92),('8902','2013-04-17','14:15:00',7.91),('8902','2013-04-17','14:20:00',7.89),('8902','2013-04-17','14:25:00',7.83),('8902','2013-04-17','14:30:00',7.78),('8902','2013-04-17','14:35:00',7.77),('8902','2013-04-17','14:40:00',7.71),('8902','2013-04-17','14:45:00',7.61),('8902','2013-04-17','14:50:00',7.53),('8902','2013-04-17','14:55:00',7.5),('8902','2013-04-17','15:00:00',7.47),('8902','2013-04-17','15:05:00',7.42),('8902','2013-04-17','15:10:00',7.29),('8902','2013-04-17','15:15:00',7.22),('8902','2013-04-17','15:20:00',7.13),('8902','2013-04-17','15:25:00',7.02),('8902','2013-04-17','15:30:00',6.91),('8902','2013-04-17','15:35:00',6.88),('8902','2013-04-17','15:40:00',6.81),('8902','2013-04-17','15:45:00',6.73),('8902','2013-04-17','15:50:00',6.65),('8902','2013-04-17','15:55:00',6.54),('8902','2013-04-17','16:00:00',6.39),('8902','2013-04-17','16:05:00',6.29),('8902','2013-04-17','16:10:00',6.13),('8902','2013-04-17','16:15:00',6.01),('8902','2013-04-17','16:20:00',5.86),('8902','2013-04-17','16:25:00',5.61),('8902','2013-04-17','16:30:00',5.54),('8902','2013-04-17','16:35:00',5.42),('8902','2013-04-17','16:40:00',5.24),('8902','2013-04-17','16:45:00',5.09),('8902','2013-04-17','16:50:00',5),('8902','2013-04-17','16:55:00',4.87),('8902','2013-04-17','17:00:00',4.67),('8902','2013-04-17','17:05:00',4.43),('8902','2013-04-17','17:10:00',4.28),('8902','2013-04-17','17:15:00',4.18),('8902','2013-04-17','17:20:00',4.01),('8902','2013-04-17','17:25:00',3.82),('8902','2013-04-17','17:30:00',3.64),('8902','2013-04-17','17:35:00',3.46),('8902','2013-04-17','17:40:00',3.22),('8902','2013-04-17','17:45:00',3.08),('8902','2013-04-17','17:50:00',2.93),('8902','2013-04-17','17:55:00',2.73),('8902','2013-04-17','18:00:00',2.55),('8902','2013-04-17','18:05:00',2.25),('8902','2013-04-17','18:10:00',2.13),('8902','2013-04-17','18:15:00',1.94),('8902','2013-04-17','18:20:00',1.72),('8902','2013-04-17','18:25:00',1.54),('8902','2013-04-17','18:30:00',1.35),('8902','2013-04-17','18:35:00',1.18),('8902','2013-04-17','18:40:00',1.01),('8902','2013-04-16','07:50:00',1.19),('8902','2013-04-16','07:55:00',1.37),('8902','2013-04-16','08:00:00',1.55),('8902','2013-04-16','08:05:00',1.73),('8902','2013-04-16','08:10:00',1.92),('8902','2013-04-16','08:15:00',2.1),('8902','2013-04-16','08:20:00',2.29),('8902','2013-04-16','08:25:00',2.48),('8902','2013-04-16','08:30:00',2.66),('8902','2013-04-16','08:35:00',2.84),('8902','2013-04-16','08:40:00',3.03),('8902','2013-04-16','08:45:00',3.21),('8902','2013-04-16','08:50:00',3.38),('8902','2013-04-16','08:55:00',3.55),('8902','2013-04-16','09:00:00',3.73),('8902','2013-04-16','09:05:00',3.9),('8902','2013-04-16','09:10:00',4.08),('8902','2013-04-16','09:15:00',4.26),('8902','2013-04-16','09:20:00',4.43),('8902','2013-04-16','09:25:00',4.6),('8902','2013-04-16','09:30:00',4.72),('8902','2013-04-16','09:35:00',4.9),('8902','2013-04-16','09:40:00',5.07),('8902','2013-04-16','09:45:00',5.22),('8902','2013-04-16','09:50:00',5.35),('8902','2013-04-16','09:55:00',5.48),('8902','2013-04-16','10:00:00',5.62),('8902','2013-04-16','10:05:00',5.76),('8902','2013-04-16','10:10:00',5.88),('8902','2013-04-16','10:15:00',5.99),('8902','2013-04-16','10:20:00',6.1),('8902','2013-04-16','10:25:00',6.23),('8902','2013-04-16','10:30:00',6.32),('8902','2013-04-16','10:35:00',6.43),('8902','2013-04-16','10:40:00',6.55),('8902','2013-04-16','10:45:00',6.65),('8902','2013-04-16','10:50:00',6.74),('8902','2013-04-16','10:55:00',6.81),('8902','2013-04-16','11:00:00',6.9),('8902','2013-04-16','11:05:00',7.01),('8902','2013-04-16','11:10:00',7.09),('8902','2013-04-16','11:15:00',7.17),('8902','2013-04-16','11:20:00',7.22),('8902','2013-04-16','11:25:00',7.33),('8902','2013-04-16','11:30:00',7.38),('8902','2013-04-16','11:35:00',7.37),('8902','2013-04-16','11:40:00',7.4),('8902','2013-04-16','11:50:00',7.55),('8902','2013-04-16','11:55:00',7.65),('8902','2013-04-16','12:00:00',7.66),('8902','2013-04-16','12:05:00',7.68),('8902','2013-04-16','12:10:00',7.72),('8902','2013-04-16','12:15:00',7.82),('8902','2013-04-16','12:20:00',7.85),('8902','2013-04-16','12:25:00',7.89),('8902','2013-04-16','12:30:00',7.98),('8902','2013-04-16','12:35:00',7.97),('8902','2013-04-16','12:40:00',7.97),('8902','2013-04-16','12:45:00',7.97),('8902','2013-04-16','12:50:00',7.99),('8902','2013-04-16','12:55:00',8.02),('8902','2013-04-16','13:00:00',8.04),('8902','2013-04-16','13:05:00',7.99),('8902','2013-04-16','13:10:00',7.98),('8902','2013-04-16','13:15:00',8.09),('8902','2013-04-16','13:20:00',8.08),('8902','2013-04-16','13:25:00',8.1),('8902','2013-04-16','13:30:00',8.12),('8902','2013-04-16','13:35:00',7.97),('8902','2013-04-16','13:40:00',8.13),('8902','2013-04-16','13:45:00',7.59),('8902','2013-04-16','13:50:00',7.62),('8902','2013-04-16','13:55:00',8.29),('8902','2013-04-16','14:00:00',7.98),('8902','2013-04-16','14:05:00',8.54),('8902','2013-04-16','14:10:00',8.42),('8902','2013-04-16','14:15:00',7.4),('8902','2013-04-16','14:20:00',7.18),('8902','2013-04-16','14:25:00',7.43),('8902','2013-04-16','14:30:00',6.99),('8902','2013-04-16','14:35:00',8.27),('8902','2013-04-16','14:40:00',8.01),('8902','2013-04-16','14:45:00',6.79),('8902','2013-04-16','14:50:00',7.96),('8902','2013-04-16','14:55:00',8.3),('8902','2013-04-16','15:00:00',8.16),('8902','2013-04-16','15:05:00',8.32),('8902','2013-04-16','15:10:00',8.58),('8902','2013-04-16','15:15:00',7.64),('8902','2013-04-16','15:20:00',4.16),('8902','2013-04-16','15:25:00',4.57),('8902','2013-04-16','15:30:00',7),('8902','2013-04-16','15:35:00',7.44),('8902','2013-04-16','15:40:00',7.37),('8902','2013-04-16','15:45:00',7.33),('8902','2013-04-16','15:50:00',7.3),('8902','2013-04-16','15:55:00',7.32),('8902','2013-04-16','16:00:00',7.17),('8902','2013-04-16','16:05:00',5.33),('8902','2013-04-16','16:10:00',6.75),('8902','2013-04-16','16:15:00',6.54),('8902','2013-04-16','16:20:00',6.3),('8902','2013-04-16','16:25:00',6.02),('8902','2013-04-16','16:30:00',5.92),('8902','2013-04-16','16:35:00',5.91),('8902','2013-04-16','16:40:00',5.5),('8902','2013-04-16','16:45:00',5.54),('8902','2013-04-16','16:50:00',5.22),('8902','2013-04-16','16:55:00',5.05),('8902','2013-04-16','17:00:00',4.86),('8902','2013-04-16','17:05:00',4.63),('8902','2013-04-16','17:10:00',4.44),('8902','2013-04-16','17:15:00',4.29),('8902','2013-04-16','17:20:00',4.12),('8902','2013-04-16','17:25:00',3.93),('8902','2013-04-16','17:30:00',3.72),('8902','2013-04-16','17:35:00',3.52),('8902','2013-04-16','17:40:00',3.3),('8902','2013-04-16','17:45:00',3.14),('8902','2013-04-16','17:50:00',2.97),('8902','2013-04-16','17:55:00',2.74),('8902','2013-04-16','18:00:00',2.59),('8902','2013-04-16','18:05:00',2.38),('8902','2013-04-16','18:10:00',2.2),('8902','2013-04-16','18:15:00',2),('8902','2013-04-16','18:20:00',1.79),('8902','2013-04-16','18:25:00',1.61),('8902','2013-04-16','18:30:00',1.45),('8902','2013-04-16','18:35:00',1.29),('8902','2013-04-16','18:40:00',1.1),('8902','2013-04-15','07:50:00',1.05),('8902','2013-04-15','07:55:00',1.2),('8902','2013-04-15','08:00:00',1.15),('8902','2013-04-15','08:05:00',1.52),('8902','2013-04-15','08:10:00',1.71),('8902','2013-04-15','08:15:00',1.29),('8902','2013-04-15','08:20:00',1.21),('8902','2013-04-15','08:25:00',1.43),('8902','2013-04-15','08:30:00',1.58),('8902','2013-04-15','08:35:00',1.5),('8902','2013-04-15','08:40:00',1.61),('8902','2013-04-15','08:45:00',1.65),('8902','2013-04-15','08:50:00',1.79),('8902','2013-04-15','08:55:00',1.87),('8902','2013-04-15','09:00:00',2.07),('8902','2013-04-15','09:05:00',1.45),('8902','2013-04-15','09:10:00',2.07),('8902','2013-04-15','09:15:00',2.79),('8902','2013-04-15','09:20:00',2.25),('8902','2013-04-15','09:25:00',2.64),('8902','2013-04-15','09:30:00',3.06),('8902','2013-04-15','09:35:00',2.63),('8902','2013-04-15','09:40:00',2.44),('8902','2013-04-15','09:45:00',2.52),('8902','2013-04-15','09:50:00',2.51),('8902','2013-04-15','09:55:00',2.52),('8902','2013-04-15','10:00:00',2.45),('8902','2013-04-15','10:05:00',2.39),('8902','2013-04-15','10:10:00',2.53),('8902','2013-04-15','10:15:00',2.76),('8902','2013-04-15','10:20:00',2.93),('8902','2013-04-15','10:25:00',3.01),('8902','2013-04-15','10:30:00',3.18),('8902','2013-04-15','10:35:00',3.2),('8902','2013-04-15','10:40:00',3.07),('8902','2013-04-15','10:45:00',2.91),('8902','2013-04-15','10:50:00',2.93),('8902','2013-04-15','10:55:00',3.12),('8902','2013-04-15','11:00:00',3.38),('8902','2013-04-15','11:05:00',3.48),('8902','2013-04-15','11:10:00',3.49),('8902','2013-04-15','11:15:00',3.61),('8902','2013-04-15','11:20:00',3.69),('8902','2013-04-15','11:25:00',3.63),('8902','2013-04-15','11:30:00',3.59),('8902','2013-04-15','11:35:00',3.51),('8902','2013-04-15','11:40:00',3.88),('8902','2013-04-15','11:45:00',4.73),('8902','2013-04-15','11:50:00',5.04),('8902','2013-04-15','11:55:00',5.26),('8902','2013-04-15','12:00:00',5.91),('8902','2013-04-15','12:05:00',8.09),('8902','2013-04-15','12:10:00',7.99),('8902','2013-04-15','12:15:00',9.29),('8902','2013-04-15','12:20:00',7.68),('8902','2013-04-15','12:25:00',6.46),('8902','2013-04-15','12:30:00',7.12),('8902','2013-04-15','12:35:00',8.14),('8902','2013-04-15','12:40:00',8.77),('8902','2013-04-15','12:45:00',7.07),('8902','2013-04-15','12:50:00',6.37),('8902','2013-04-15','12:55:00',7.71),('8902','2013-04-15','13:00:00',8.07),('8902','2013-04-15','13:05:00',7.72),('8902','2013-04-15','13:10:00',7.84),('8902','2013-04-15','13:15:00',7.87),('8902','2013-04-15','13:20:00',7.98),('8902','2013-04-15','13:25:00',8.01),('8902','2013-04-15','13:30:00',7.93),('8902','2013-04-15','13:35:00',7.93),('8902','2013-04-15','13:40:00',7.84),('8902','2013-04-15','13:45:00',7.72),('8902','2013-04-15','13:50:00',7.72),('8902','2013-04-15','13:55:00',7.58),('8902','2013-04-15','14:00:00',7.58),('8902','2013-04-15','14:05:00',7.78),('8902','2013-04-15','14:10:00',7.83),('8902','2013-04-15','14:15:00',7.62),('8902','2013-04-15','14:20:00',7.62),('8902','2013-04-15','14:25:00',5.97),('8902','2013-04-15','14:30:00',6.48),('8902','2013-04-15','14:35:00',6.3),('8902','2013-04-15','14:40:00',7.39),('8902','2013-04-15','14:45:00',7.49),('8902','2013-04-15','14:50:00',7.3),('8902','2013-04-15','14:55:00',7.15),('8902','2013-04-15','15:00:00',7.33),('8902','2013-04-15','15:05:00',7.26),('8902','2013-04-15','15:10:00',7.23),('8902','2013-04-15','15:15:00',7.17),('8902','2013-04-15','15:20:00',7.12),('8902','2013-04-15','15:25:00',6.85),('8902','2013-04-15','15:30:00',6.68),('8902','2013-04-15','15:35:00',6.71),('8902','2013-04-15','15:40:00',6.7),('8902','2013-04-15','15:45:00',6.6),('8902','2013-04-15','15:50:00',6.57),('8902','2013-04-15','15:55:00',6.42),('8902','2013-04-15','16:00:00',6.1),('8902','2013-04-15','16:05:00',6.16),('8902','2013-04-15','16:10:00',6.03),('8902','2013-04-15','16:15:00',5.72),('8902','2013-04-15','16:20:00',5.85),('8902','2013-04-15','16:25:00',5.64),('8902','2013-04-15','16:30:00',5.6),('8902','2013-04-15','16:35:00',5.48),('8902','2013-04-15','16:40:00',5.72),('8902','2013-04-15','16:45:00',4.86),('8902','2013-04-15','16:50:00',4.99),('8902','2013-04-15','16:55:00',4.62),('8902','2013-04-15','17:00:00',4.71),('8902','2013-04-15','17:05:00',4.75),('8902','2013-04-15','17:10:00',4.72),('8902','2013-04-15','17:15:00',4.56),('8902','2013-04-15','17:20:00',4.41),('8902','2013-04-15','17:25:00',4.3),('8902','2013-04-15','17:30:00',3.89),('8902','2013-04-15','17:35:00',4.11),('8902','2013-04-15','17:40:00',3.83),('8902','2013-04-15','17:45:00',3.49),('8902','2013-04-15','17:50:00',3.24),('8902','2013-04-15','17:55:00',2.76),('8902','2013-04-15','18:00:00',1.65),('8902','2013-04-15','18:05:00',1.54),('8902','2013-04-15','18:10:00',1.43),('8902','2013-04-15','18:15:00',1.75),('8902','2013-04-15','18:20:00',1.43),('8902','2013-04-15','18:25:00',1.28),('8902','2013-04-15','18:30:00',1.19),('8902','2013-04-15','18:35:00',1.09),('8902','2013-04-14','07:50:00',1.11),('8902','2013-04-14','07:55:00',1.28),('8902','2013-04-14','08:00:00',1.45),('8902','2013-04-14','08:05:00',1.62),('8902','2013-04-14','08:10:00',1.79),('8902','2013-04-14','08:15:00',1.95),('8902','2013-04-14','08:20:00',2.12),('8902','2013-04-14','08:25:00',2.3),('8902','2013-04-14','08:30:00',2.49),('8902','2013-04-14','08:35:00',2.65),('8902','2013-04-14','08:40:00',2.82),('8902','2013-04-14','08:45:00',2.98),('8902','2013-04-14','08:50:00',3.17),('8902','2013-04-14','08:55:00',3.36),('8902','2013-04-14','09:00:00',3.52),('8902','2013-04-14','09:05:00',3.68),('8902','2013-04-14','09:10:00',3.86),('8902','2013-04-14','09:15:00',4.02),('8902','2013-04-14','09:20:00',4.17),('8902','2013-04-14','09:25:00',4.33),('8902','2013-04-14','09:30:00',4.48),('8902','2013-04-14','09:35:00',4.62),('8902','2013-04-14','09:40:00',4.75),('8902','2013-04-14','09:45:00',4.89),('8902','2013-04-14','09:50:00',5.03),('8902','2013-04-14','09:55:00',5.17),('8902','2013-04-14','10:00:00',5.3),('8902','2013-04-14','10:05:00',5.45),('8902','2013-04-14','10:10:00',5.58),('8902','2013-04-14','10:15:00',5.71),('8902','2013-04-14','10:20:00',5.82),('8902','2013-04-14','10:25:00',5.94),('8902','2013-04-14','10:30:00',6.02),('8902','2013-04-14','10:35:00',6.11),('8902','2013-04-14','10:40:00',6.23),('8902','2013-04-14','10:45:00',6.34),('8902','2013-04-14','10:50:00',6.44),('8902','2013-04-14','10:55:00',6.53),('8902','2013-04-14','11:00:00',6.62),('8902','2013-04-14','11:05:00',6.7),('8902','2013-04-14','11:10:00',6.78),('8902','2013-04-14','11:15:00',6.85),('8902','2013-04-14','11:20:00',6.93),('8902','2013-04-14','11:25:00',7.01),('8902','2013-04-14','11:30:00',7.08),('8902','2013-04-14','11:35:00',7.1),('8902','2013-04-14','11:40:00',7.15),('8902','2013-04-14','11:45:00',7.24),('8902','2013-04-14','11:50:00',7.31),('8902','2013-04-14','11:55:00',7.38),('8902','2013-04-14','12:00:00',7.38),('8902','2013-04-14','12:05:00',7.46),('8902','2013-04-14','12:10:00',7.46),('8902','2013-04-14','12:15:00',7.51),('8902','2013-04-14','12:20:00',7.55),('8902','2013-04-14','12:25:00',7.54),('8902','2013-04-14','12:30:00',7.55),('8902','2013-04-14','12:35:00',7.61),('8902','2013-04-14','12:40:00',7.64),('8902','2013-04-14','12:45:00',7.65),('8902','2013-04-14','12:50:00',7.66),('8902','2013-04-14','12:55:00',7.63),('8902','2013-04-14','13:00:00',7.64),('8902','2013-04-14','13:05:00',7.65),('8902','2013-04-14','13:10:00',7.69),('8902','2013-04-14','13:15:00',7.82),('8902','2013-04-14','13:20:00',7.82),('8902','2013-04-14','13:25:00',7.75),('8902','2013-04-14','13:30:00',7.71),('8902','2013-04-14','13:35:00',7.66),('8902','2013-04-14','13:40:00',7.71),('8902','2013-04-14','13:45:00',7.66),('8902','2013-04-14','13:50:00',7.58),('8902','2013-04-14','13:55:00',7.68),('8902','2013-04-14','14:00:00',7.73),('8902','2013-04-14','14:05:00',7.71),('8902','2013-04-14','14:10:00',7.69),('8902','2013-04-14','14:15:00',7.7),('8902','2013-04-14','14:20:00',7.71),('8902','2013-04-14','14:25:00',7.67),('8902','2013-04-14','14:30:00',7.57),('8902','2013-04-14','14:35:00',7.57),('8902','2013-04-14','14:40:00',7.52),('8902','2013-04-14','14:45:00',7.46),('8902','2013-04-14','14:50:00',7.39),('8902','2013-04-14','14:55:00',7.35),('8902','2013-04-14','15:00:00',7.3),('8902','2013-04-14','15:05:00',7.24),('8902','2013-04-14','15:10:00',7.15),('8902','2013-04-14','15:15:00',7.05),('8902','2013-04-14','15:20:00',6.97),('8902','2013-04-14','15:25:00',6.9),('8902','2013-04-14','15:30:00',6.81),('8902','2013-04-14','15:35:00',6.71),('8902','2013-04-14','15:40:00',6.59),('8902','2013-04-14','15:45:00',6.49),('8902','2013-04-14','15:50:00',6.41),('8902','2013-04-14','15:55:00',6.34),('8902','2013-04-14','16:00:00',6.22),('8902','2013-04-14','16:05:00',6.09),('8902','2013-04-14','16:10:00',5.99),('8902','2013-04-14','16:15:00',5.85),('8902','2013-04-14','16:20:00',5.7),('8902','2013-04-14','16:25:00',5.49),('8902','2013-04-14','16:30:00',5.37),('8902','2013-04-14','16:35:00',5.25),('8902','2013-04-14','16:40:00',5.13),('8902','2013-04-14','16:45:00',4.91),('8902','2013-04-14','16:50:00',4.76),('8902','2013-04-14','16:55:00',4.59),('8902','2013-04-14','17:00:00',4.45),('8902','2013-04-14','17:05:00',4.31),('8902','2013-04-14','17:10:00',4.13),('8902','2013-04-14','17:15:00',3.98),('8902','2013-04-14','17:20:00',3.83),('8902','2013-04-14','17:25:00',3.66),('8902','2013-04-14','17:30:00',3.47),('8902','2013-04-14','17:35:00',3.3),('8902','2013-04-14','17:40:00',3.09),('8902','2013-04-14','17:45:00',2.92),('8902','2013-04-14','17:50:00',2.76),('8902','2013-04-14','17:55:00',2.59),('8902','2013-04-14','18:00:00',2.4),('8902','2013-04-14','18:05:00',2.2),('8902','2013-04-14','18:10:00',2.04),('8902','2013-04-14','18:15:00',1.85),('8902','2013-04-14','18:20:00',1.68),('8902','2013-04-14','18:25:00',1.51),('8902','2013-04-14','18:30:00',1.36),('8902','2013-04-14','18:35:00',1.19),('8902','2013-04-14','18:40:00',1.02),('8902','2013-04-13','07:50:00',1.14),('8902','2013-04-13','07:55:00',1.34),('8902','2013-04-13','08:00:00',1.49),('8902','2013-04-13','08:05:00',1.5),('8902','2013-04-13','08:10:00',1.73),('8902','2013-04-13','08:15:00',1.92),('8902','2013-04-13','08:20:00',2.03),('8902','2013-04-13','08:25:00',2.17),('8902','2013-04-13','08:30:00',2.35),('8902','2013-04-13','08:35:00',2.51),('8902','2013-04-13','08:40:00',2.67),('8902','2013-04-13','08:45:00',2.81),('8902','2013-04-13','08:50:00',3),('8902','2013-04-13','08:55:00',3.15),('8902','2013-04-13','09:00:00',3.32),('8902','2013-04-13','09:05:00',3.48),('8902','2013-04-13','09:10:00',3.69),('8902','2013-04-13','09:15:00',3.84),('8902','2013-04-13','09:20:00',3.99),('8902','2013-04-13','09:25:00',4.11),('8902','2013-04-13','09:30:00',4.29),('8902','2013-04-13','09:35:00',4.43),('8902','2013-04-13','09:40:00',4.54),('8902','2013-04-13','09:45:00',4.7),('8902','2013-04-13','09:50:00',4.84),('8902','2013-04-13','09:55:00',4.98),('8902','2013-04-13','10:00:00',5.14),('8902','2013-04-13','10:05:00',5.26),('8902','2013-04-13','10:10:00',5.39),('8902','2013-04-13','10:15:00',5.51),('8902','2013-04-13','10:20:00',5.62),('8902','2013-04-13','10:25:00',5.72),('8902','2013-04-13','10:30:00',5.86),('8902','2013-04-13','10:35:00',5.96),('8902','2013-04-13','10:40:00',6.1),('8902','2013-04-13','10:45:00',6.16),('8902','2013-04-13','10:50:00',6.29),('8902','2013-04-13','10:55:00',6.39),('8902','2013-04-13','11:00:00',6.49),('8902','2013-04-13','11:05:00',6.57),('8902','2013-04-13','11:10:00',6.68),('8902','2013-04-13','11:15:00',6.78),('8902','2013-04-13','11:20:00',6.81),('8902','2013-04-13','11:25:00',6.85),('8902','2013-04-13','11:30:00',6.9),('8902','2013-04-13','11:35:00',6.98),('8902','2013-04-13','11:40:00',7.07),('8902','2013-04-13','11:45:00',7.15),('8902','2013-04-13','11:50:00',7.17),('8902','2013-04-13','11:55:00',7.24),('8902','2013-04-13','12:00:00',7.28),('8902','2013-04-13','12:05:00',7.3),('8902','2013-04-13','12:10:00',7.34),('8902','2013-04-13','12:15:00',7.36),('8902','2013-04-13','12:20:00',7.42),('8902','2013-04-13','12:25:00',7.45),('8902','2013-04-13','12:30:00',7.46),('8902','2013-04-13','12:35:00',7.57),('8902','2013-04-13','12:40:00',7.49),('8902','2013-04-13','12:45:00',7.78),('8902','2013-04-13','12:50:00',7.46),('8902','2013-04-13','12:55:00',5.66),('8902','2013-04-13','13:00:00',3.2),('8902','2013-04-13','13:05:00',2.6),('8902','2013-04-13','13:10:00',3.86),('8902','2013-04-13','13:15:00',8.45),('8902','2013-04-13','13:20:00',8.17),('8902','2013-04-13','13:25:00',7.9),('8902','2013-04-13','13:30:00',7.78),('8902','2013-04-13','13:35:00',7.75),('8902','2013-04-13','13:40:00',7.68),('8902','2013-04-13','13:45:00',7.67),('8902','2013-04-13','13:50:00',7.6),('8902','2013-04-13','13:55:00',7.53),('8902','2013-04-13','14:00:00',7.49),('8902','2013-04-13','14:05:00',7.5),('8902','2013-04-13','14:10:00',7.51),('8902','2013-04-13','14:15:00',7.55),('8902','2013-04-13','14:20:00',7.53),('8902','2013-04-13','14:25:00',7.4),('8902','2013-04-13','14:30:00',7.44),('8902','2013-04-13','14:35:00',7.55),('8902','2013-04-13','14:40:00',7.58),('8902','2013-04-13','14:45:00',7.64),('8902','2013-04-13','14:50:00',7.64),('8902','2013-04-13','14:55:00',7.38),('8902','2013-04-13','15:00:00',7.28),('8902','2013-04-13','15:05:00',7.23),('8902','2013-04-13','15:10:00',5.23),('8902','2013-04-13','15:15:00',5.47),('8902','2013-04-13','15:20:00',6.62),('8902','2013-04-13','15:25:00',5.31),('8902','2013-04-13','15:30:00',6.05),('8902','2013-04-13','15:35:00',6.86),('8902','2013-04-13','15:40:00',6.49),('8902','2013-04-13','15:45:00',6.8),('8902','2013-04-13','15:50:00',6.5),('8902','2013-04-13','15:55:00',4.27),('8902','2013-04-13','16:00:00',6.02),('8902','2013-04-13','16:05:00',5.82),('8902','2013-04-13','16:10:00',5.84),('8902','2013-04-13','16:15:00',5.51),('8902','2013-04-13','16:20:00',5.44),('8902','2013-04-13','16:25:00',5.4),('8902','2013-04-13','16:30:00',5.24),('8902','2013-04-13','16:35:00',5.04),('8902','2013-04-13','16:40:00',4.85),('8902','2013-04-13','16:45:00',4.68),('8902','2013-04-13','16:50:00',4.59),('8902','2013-04-13','16:55:00',4.43),('8902','2013-04-13','17:00:00',4.26),('8902','2013-04-13','17:05:00',4.11),('8902','2013-04-13','17:10:00',3.98),('8902','2013-04-13','17:15:00',3.8),('8902','2013-04-13','17:20:00',3.61),('8902','2013-04-13','17:25:00',3.42),('8902','2013-04-13','17:30:00',3.29),('8902','2013-04-13','17:35:00',3.13),('8902','2013-04-13','17:40:00',2.93),('8902','2013-04-13','17:45:00',2.8),('8902','2013-04-13','17:50:00',2.63),('8902','2013-04-13','17:55:00',2.41),('8902','2013-04-13','18:00:00',2.23),('8902','2013-04-13','18:05:00',2.09),('8902','2013-04-13','18:10:00',1.92),('8902','2013-04-13','18:15:00',1.76),('8902','2013-04-13','18:20:00',1.59),('8902','2013-04-13','18:25:00',1.42),('8902','2013-04-13','18:30:00',1.26),('8902','2013-04-13','18:35:00',1.1),('8902','2013-04-12','07:50:00',1.01),('8902','2013-04-12','07:55:00',1.18),('8902','2013-04-12','08:00:00',1.36),('8902','2013-04-12','08:05:00',1.48),('8902','2013-04-12','08:10:00',1.62),('8902','2013-04-12','08:15:00',1.52),('8902','2013-04-12','08:20:00',1.31),('8902','2013-04-12','08:25:00',1.1),('8902','2013-04-12','08:30:00',1.11),('8902','2013-04-12','08:35:00',1.08),('8902','2013-04-12','08:40:00',1.1),('8902','2013-04-12','08:45:00',1.27),('8902','2013-04-12','08:50:00',1.42),('8902','2013-04-12','08:55:00',1.92),('8902','2013-04-12','09:00:00',1.91),('8902','2013-04-12','09:05:00',3.32),('8902','2013-04-12','09:10:00',2.17),('8902','2013-04-12','09:15:00',2.51),('8902','2013-04-12','09:20:00',2.7),('8902','2013-04-12','09:25:00',3.18),('8902','2013-04-12','09:30:00',4.37),('8902','2013-04-12','09:35:00',4.36),('8902','2013-04-12','09:40:00',4),('8902','2013-04-12','09:45:00',4.74),('8902','2013-04-12','09:50:00',4.88),('8902','2013-04-12','09:55:00',5.06),('8902','2013-04-12','10:00:00',5.22),('8902','2013-04-12','10:05:00',5.34),('8902','2013-04-12','10:10:00',5.76),('8902','2013-04-12','10:15:00',5.94),('8902','2013-04-12','10:20:00',4.37),('8902','2013-04-12','10:25:00',4.36),('8902','2013-04-12','10:30:00',6.35),('8902','2013-04-12','10:35:00',4.29),('8902','2013-04-12','10:40:00',5.04),('8902','2013-04-12','10:45:00',6.52),('8902','2013-04-12','10:50:00',4.07),('8902','2013-04-12','10:55:00',4.7),('8902','2013-04-12','11:00:00',3.72),('8902','2013-04-12','11:05:00',4),('8902','2013-04-12','11:10:00',6.35),('8902','2013-04-12','11:15:00',4.71),('8902','2013-04-12','11:20:00',7.56),('8902','2013-04-12','11:25:00',6.94),('8902','2013-04-12','11:30:00',3.64),('8902','2013-04-12','11:35:00',7.9),('8902','2013-04-12','11:40:00',7.72),('8902','2013-04-12','11:45:00',7.08),('8902','2013-04-12','11:50:00',7.67),('8902','2013-04-12','11:55:00',7.94),('8902','2013-04-12','12:00:00',7.9),('8902','2013-04-12','12:05:00',6.26),('8902','2013-04-12','12:10:00',6.9),('8902','2013-04-12','12:15:00',8.06),('8902','2013-04-12','12:20:00',7.73),('8902','2013-04-12','12:25:00',5.67),('8902','2013-04-12','12:30:00',7.72),('8902','2013-04-12','12:35:00',7.99),('8902','2013-04-12','12:40:00',8.08),('8902','2013-04-12','12:45:00',7.96),('8902','2013-04-12','12:50:00',7.77),('8902','2013-04-12','12:55:00',7.92),('8902','2013-04-12','13:00:00',7.8),('8902','2013-04-12','13:05:00',8.01),('8902','2013-04-12','13:10:00',8.21),('8902','2013-04-12','13:15:00',8.03),('8902','2013-04-12','13:20:00',7.54),('8902','2013-04-12','13:25:00',8.1),('8902','2013-04-12','13:30:00',5.73),('8902','2013-04-12','13:35:00',3.11),('8902','2013-04-12','13:40:00',3.23),('8902','2013-04-12','13:45:00',4.71),('8902','2013-04-12','13:50:00',4.16),('8902','2013-04-12','13:55:00',3.02),('8902','2013-04-12','14:00:00',3.09),('8902','2013-04-12','14:05:00',4.99),('8902','2013-04-12','14:10:00',2.96),('8902','2013-04-12','14:15:00',3.46),('8902','2013-04-12','14:20:00',5.58),('8902','2013-04-12','14:25:00',4.76),('8902','2013-04-12','14:30:00',7.07),('8902','2013-04-12','14:35:00',7.44),('8902','2013-04-12','14:40:00',7.1),('8902','2013-04-12','14:45:00',7.18),('8902','2013-04-12','14:50:00',6.84),('8902','2013-04-12','14:55:00',6.91),('8902','2013-04-12','15:00:00',6.35),('8902','2013-04-12','15:05:00',6.19),('8902','2013-04-12','15:10:00',6.07),('8902','2013-04-12','15:15:00',5.67),('8902','2013-04-12','15:20:00',5.47),('8902','2013-04-12','15:25:00',5.12),('8902','2013-04-12','15:30:00',5.24),('8902','2013-04-12','15:35:00',5.06),('8902','2013-04-12','15:40:00',5.27),('8902','2013-04-12','15:45:00',5.35),('8902','2013-04-12','15:50:00',5.17),('8902','2013-04-12','15:55:00',5.23),('8902','2013-04-12','16:00:00',5.11),('8902','2013-04-12','16:05:00',4.89),('8902','2013-04-12','16:10:00',4.57),('8902','2013-04-12','16:15:00',4.74),('8902','2013-04-12','16:20:00',4.5),('8902','2013-04-12','16:25:00',4.19),('8902','2013-04-12','16:30:00',4),('8902','2013-04-12','16:35:00',3.75),('8902','2013-04-12','16:40:00',3.57),('8902','2013-04-12','16:45:00',3.36),('8902','2013-04-12','16:50:00',3.43),('8902','2013-04-12','16:55:00',2.87),('8902','2013-04-12','17:00:00',2.41),('8902','2013-04-12','17:05:00',2.25),('8902','2013-04-12','17:10:00',3.32),('8902','2013-04-12','17:15:00',3.91),('8902','2013-04-12','17:20:00',3.26),('8902','2013-04-12','17:25:00',3.69),('8902','2013-04-12','17:30:00',3.16),('8902','2013-04-12','17:35:00',3.24),('8902','2013-04-12','17:40:00',3.06),('8902','2013-04-12','17:45:00',2.75),('8902','2013-04-12','17:50:00',2.44),('8902','2013-04-12','17:55:00',2.6),('8902','2013-04-12','18:00:00',2.02),('8902','2013-04-12','18:05:00',1.98),('8902','2013-04-12','18:10:00',1.8),('8902','2013-04-12','18:15:00',1.79),('8902','2013-04-12','18:20:00',1.67),('8902','2013-04-12','18:25:00',1.53),('8902','2013-04-12','18:30:00',1.4),('8902','2013-04-12','18:35:00',1.21),('8902','2013-04-12','18:40:00',1.01),('8902','2013-04-11','14:05:00',7.98),('8902','2013-04-11','14:10:00',7.93),('8902','2013-04-11','14:15:00',7.86),('8902','2013-04-11','14:20:00',7.83),('8902','2013-04-11','14:25:00',7.8),('8902','2013-04-11','14:30:00',7.7),('8902','2013-04-11','14:35:00',7.64),('8902','2013-04-11','14:40:00',7.6),('8902','2013-04-11','14:45:00',7.54),('8902','2013-04-11','14:50:00',7.48),('8902','2013-04-11','14:55:00',7.44),('8902','2013-04-11','15:00:00',7.37),('8902','2013-04-11','15:05:00',7.3),('8902','2013-04-11','15:10:00',7.18),('8902','2013-04-11','15:15:00',7.1),('8902','2013-04-11','15:20:00',6.99),('8902','2013-04-11','15:25:00',6.89),('8902','2013-04-11','15:30:00',6.8),('8902','2013-04-11','15:35:00',6.72),('8902','2013-04-11','15:40:00',6.62),('8902','2013-04-11','15:45:00',6.5),('8902','2013-04-11','15:50:00',6.4),('8902','2013-04-11','15:55:00',6.25),('8902','2013-04-11','16:00:00',6.15),('8902','2013-04-11','16:05:00',6.11),('8902','2013-04-11','16:10:00',5.99),('8902','2013-04-11','16:15:00',5.46),('8902','2013-04-11','16:20:00',5.66),('8902','2013-04-11','16:25:00',5.53),('8902','2013-04-11','16:30:00',3.67),('8902','2013-04-11','16:35:00',2.4),('8902','2013-04-11','16:40:00',3.36),('8902','2013-04-11','16:45:00',5.12),('8902','2013-04-11','16:50:00',4.76),('8902','2013-04-11','16:55:00',4.62),('8902','2013-04-11','17:00:00',4.46),('8902','2013-04-11','17:05:00',4.29),('8902','2013-04-11','17:10:00',4.12),('8902','2013-04-11','17:15:00',3.92),('8902','2013-04-11','17:20:00',3.76),('8902','2013-04-11','17:25:00',3.59),('8902','2013-04-11','17:30:00',3.42),('8902','2013-04-11','17:35:00',3.26),('8902','2013-04-11','17:40:00',3.06),('8902','2013-04-11','17:45:00',2.87),('8902','2013-04-11','17:50:00',2.69),('8902','2013-04-11','17:55:00',2.48),('8902','2013-04-11','18:00:00',2.28),('8902','2013-04-11','18:05:00',2.1),('8902','2013-04-11','18:10:00',1.86),('8902','2013-04-11','18:15:00',1.68),('8902','2013-04-11','18:20:00',1.53),('8902','2013-04-11','18:25:00',1.37),('8902','2014-03-27','07:10:00',1.23),('8902','2014-03-27','07:15:00',1.4),('8902','2014-03-27','07:20:00',1.54),('8902','2014-03-27','07:25:00',1.64),('8902','2014-03-27','07:30:00',1.7),('8902','2014-03-27','07:35:00',2.02),('8902','2014-03-27','07:40:00',2.11),('8902','2014-03-27','07:45:00',2.41),('8902','2014-03-27','07:50:00',2.61),('8902','2014-03-27','07:55:00',2.78),('8902','2014-03-27','08:00:00',2.94),('8902','2014-03-27','08:05:00',3.14),('8902','2014-03-27','08:10:00',3.35),('8902','2014-03-27','08:15:00',3.57),('8902','2014-03-27','08:20:00',3.76),('8902','2014-03-27','08:25:00',3.95),('8902','2014-03-27','08:30:00',4.12),('8902','2014-03-27','08:35:00',4.33),('8902','2014-03-27','08:40:00',4.54),('8902','2014-03-27','08:45:00',4.68),('8902','2014-03-27','08:50:00',4.85),('8902','2014-03-27','08:55:00',5.07),('8902','2014-03-27','09:00:00',5.14),('8902','2014-03-27','09:05:00',5.44),('8902','2014-03-27','09:10:00',5.81),('8902','2014-03-27','09:15:00',5.83),('8902','2014-03-27','09:20:00',5.05),('8902','2014-03-27','09:25:00',6.01),('8902','2014-03-27','09:30:00',6.48),('8902','2014-03-27','09:35:00',5.97),('8902','2014-03-27','09:40:00',4.05),('8902','2014-03-27','09:45:00',3.44),('8902','2014-03-27','09:50:00',4.04),('8902','2014-03-27','09:55:00',6.22),('8902','2014-03-27','10:00:00',7.21),('8902','2014-03-27','10:05:00',6.95),('8902','2014-03-27','10:10:00',5.58),('8902','2014-03-27','10:15:00',5.45),('8902','2014-03-27','10:20:00',5.15),('8902','2014-03-27','10:25:00',6.83),('8902','2014-03-27','10:30:00',7.26),('8902','2014-03-27','10:35:00',6.59),('8902','2014-03-27','10:40:00',6.85),('8902','2014-03-27','10:45:00',5.51),('8902','2014-03-27','10:50:00',7.23),('8902','2014-03-27','10:55:00',7.81),('8902','2014-03-27','11:00:00',7.9),('8902','2014-03-27','11:05:00',7.84),('8902','2014-03-27','11:10:00',6.13),('8902','2014-03-27','11:15:00',8.08),('8902','2014-03-27','11:20:00',8),('8902','2014-03-27','11:25:00',5.69),('8902','2014-03-27','11:30:00',5.32),('8902','2014-03-27','11:35:00',9.21),('8902','2014-03-27','11:40:00',4.16),('8902','2014-03-27','11:45:00',2.69),('8902','2014-03-27','11:50:00',2.44),('8902','2014-03-27','11:55:00',2.43),('8902','2014-03-27','12:00:00',1.67),('8902','2014-03-27','12:05:00',3.5),('8902','2014-03-27','12:10:00',9.3),('8902','2014-03-27','12:15:00',9.43),('8902','2014-03-27','12:20:00',8.87),('8902','2014-03-27','12:25:00',3.68),('8902','2014-03-27','12:30:00',4.48),('8902','2014-03-27','12:35:00',7.36),('8902','2014-03-27','12:40:00',6.64),('8902','2014-03-27','12:45:00',8.7),('8902','2014-03-27','12:50:00',8.56),('8902','2014-03-27','12:55:00',9.01),('8902','2014-03-27','13:00:00',7.51),('8902','2014-03-27','13:05:00',5.45),('8902','2014-03-27','13:10:00',2.65),('8902','2014-03-27','13:15:00',3.04),('8902','2014-03-27','13:20:00',9.12),('8902','2014-03-27','13:25:00',5.7),('8902','2014-03-27','13:30:00',2.81),('8902','2014-03-27','13:35:00',8.52),('8902','2014-03-27','13:40:00',7.65),('8902','2014-03-27','13:45:00',8.12),('8902','2014-03-27','13:50:00',7.94),('8902','2014-03-27','13:55:00',7.6),('8902','2014-03-27','14:00:00',7.77),('8902','2014-03-27','14:05:00',7.64),('8902','2014-03-27','14:10:00',7.39),('8902','2014-03-27','14:15:00',7.44),('8902','2014-03-27','14:20:00',7.4),('8902','2014-03-27','14:25:00',7.29),('8902','2014-03-27','14:30:00',7.17),('8902','2014-03-27','14:35:00',7.12),('8902','2014-03-27','14:40:00',7.04),('8902','2014-03-27','14:45:00',6.94),('8902','2014-03-27','14:50:00',6.85),('8902','2014-03-27','14:55:00',6.71),('8902','2014-03-27','15:00:00',6.69),('8902','2014-03-27','15:05:00',6.54),('8902','2014-03-27','15:10:00',6.38),('8902','2014-03-27','15:15:00',6.23),('8902','2014-03-27','15:20:00',6.08),('8902','2014-03-27','15:25:00',5.87),('8902','2014-03-27','15:30:00',5.77),('8902','2014-03-27','15:35:00',5.62),('8902','2014-03-27','15:40:00',5.5),('8902','2014-03-27','15:45:00',5.46),('8902','2014-03-27','15:50:00',5.31),('8902','2014-03-27','15:55:00',5.19),('8902','2014-03-27','16:00:00',5.25),('8902','2014-03-27','16:05:00',5.29),('8902','2014-03-27','16:10:00',5.14),('8902','2014-03-27','16:15:00',5.04),('8902','2014-03-27','16:20:00',4.45),('8902','2014-03-27','16:25:00',3.92),('8902','2014-03-27','16:30:00',3.27),('8902','2014-03-27','16:35:00',2.37),('8902','2014-03-27','16:40:00',3.16),('8902','2014-03-27','16:45:00',2.79),('8902','2014-03-27','16:50:00',2.71),('8902','2014-03-27','17:00:00',1.48),('8902','2014-03-27','17:05:00',1.87),('8902','2014-03-27','17:10:00',1.87),('8902','2014-03-27','17:15:00',1.88),('8902','2014-03-27','17:20:00',1.94),('8902','2014-03-27','17:25:00',1.09),('8902','2013-04-06','08:15:00',1.04),('8902','2013-04-06','08:20:00',1.25),('8902','2013-04-06','08:25:00',1.52),('8902','2013-04-06','08:30:00',1.68),('8902','2013-04-06','08:35:00',1.89),('8902','2013-04-06','08:40:00',2.04),('8902','2013-04-06','08:45:00',2.13),('8902','2013-04-06','08:50:00',2.2),('8902','2013-04-06','08:55:00',2.28),('8902','2013-04-06','09:00:00',2.24),('8902','2013-04-06','09:05:00',2.39),('8902','2013-04-06','09:10:00',2.53),('8902','2013-04-06','09:15:00',2.57),('8902','2013-04-06','09:20:00',2.71),('8902','2013-04-06','09:25:00',2.67),('8902','2013-04-06','09:30:00',2.64),('8902','2013-04-06','09:35:00',2.5),('8902','2013-04-06','09:40:00',2.61),('8902','2013-04-06','09:45:00',3.37),('8902','2013-04-06','09:50:00',3.64),('8902','2013-04-06','09:55:00',4.1),('8902','2013-04-06','10:00:00',4.72),('8902','2013-04-06','10:05:00',4.89),('8902','2013-04-06','10:10:00',4.91),('8902','2013-04-06','10:15:00',5.08),('8902','2013-04-06','10:20:00',5.13),('8902','2013-04-06','10:25:00',5),('8902','2013-04-06','10:30:00',4.48),('8902','2013-04-06','10:35:00',5.06),('8902','2013-04-06','10:40:00',4.95),('8902','2013-04-06','10:45:00',4.89),('8902','2013-04-06','10:50:00',4.62),('8902','2013-04-06','10:55:00',4.1),('8902','2013-04-06','11:00:00',3.78),('8902','2013-04-06','11:05:00',3.34),('8902','2013-04-06','11:10:00',4.15),('8902','2013-04-06','11:15:00',5.76),('8902','2013-04-06','11:20:00',6.41),('8902','2013-04-06','11:25:00',6.95),('8902','2013-04-06','11:30:00',6.56),('8902','2013-04-06','11:35:00',6.2),('8902','2013-04-06','11:40:00',5.37),('8902','2013-04-06','11:45:00',4.43),('8902','2013-04-06','11:50:00',4.31),('8902','2013-04-06','11:55:00',4.45),('8902','2013-04-06','12:00:00',4.7),('8902','2013-04-06','12:05:00',4.53),('8902','2013-04-06','12:10:00',4.97),('8902','2013-04-06','12:15:00',4.75),('8902','2013-04-06','12:20:00',5.38),('8902','2013-04-06','12:25:00',5.76),('8902','2013-04-06','12:30:00',4.88),('8902','2013-04-06','12:35:00',5.46),('8902','2013-04-06','12:40:00',5.09),('8902','2013-04-06','12:45:00',4.5),('8902','2013-04-06','12:50:00',4.92),('8902','2013-04-06','12:55:00',5.28),('8902','2013-04-06','13:00:00',6.24),('8902','2013-04-06','13:05:00',6.63),('8902','2013-04-06','13:10:00',6.32),('8902','2013-04-06','13:15:00',5.7),('8902','2013-04-06','13:20:00',5.45),('8902','2013-04-06','13:25:00',6.3),('8902','2013-04-06','13:30:00',6.29),('8902','2013-04-06','13:35:00',5.69),('8902','2013-04-06','13:40:00',6.41),('8902','2013-04-06','13:45:00',6.7),('8902','2013-04-06','13:50:00',6.2),('8902','2013-04-06','13:55:00',6.04),('8902','2013-04-06','14:00:00',7.11),('8902','2013-04-06','14:05:00',5.9),('8902','2013-04-06','14:10:00',4.91),('8902','2013-04-06','14:15:00',4.48),('8902','2013-04-06','14:20:00',4.17),('8902','2013-04-06','14:25:00',4.28),('8902','2013-04-06','14:30:00',4.96),('8902','2013-04-06','14:35:00',4.77),('8902','2013-04-06','14:40:00',4.07),('8902','2013-04-06','14:45:00',3.86),('8902','2013-04-06','14:50:00',4.15),('8902','2013-04-06','14:55:00',3.87),('8902','2013-04-06','15:00:00',3.5),('8902','2013-04-06','15:05:00',5.98),('8902','2013-04-06','15:10:00',5.85),('8902','2013-04-06','15:15:00',5.38),('8902','2013-04-06','15:20:00',5.79),('8902','2013-04-06','15:25:00',6.06),('8902','2013-04-06','15:30:00',6.01),('8902','2013-04-06','15:35:00',5.07),('8902','2013-04-06','15:40:00',5.69),('8902','2013-04-06','15:45:00',5.27),('8902','2013-04-06','15:50:00',4.98),('8902','2013-04-06','15:55:00',5.11),('8902','2013-04-06','16:00:00',4.86),('8902','2013-04-06','16:05:00',4.25),('8902','2013-04-06','16:10:00',3.58),('8902','2013-04-06','16:15:00',3.13),('8902','2013-04-06','16:20:00',2.99),('8902','2013-04-06','16:25:00',2.66),('8902','2013-04-06','16:30:00',2.66),('8902','2013-04-06','16:35:00',3.11),('8902','2013-04-06','16:40:00',3.25),('8902','2013-04-06','16:45:00',4.23),('8902','2013-04-06','16:50:00',4.48),('8902','2013-04-06','16:55:00',4.37),('8902','2013-04-06','17:00:00',3.96),('8902','2013-04-06','17:05:00',3.33),('8902','2013-04-06','17:10:00',1.81),('8902','2013-04-06','17:15:00',1.68),('8902','2013-04-06','17:20:00',3.32),('8902','2013-04-06','17:25:00',3.79),('8902','2013-04-06','17:30:00',3.63),('8902','2013-04-06','17:35:00',3.43),('8902','2013-04-06','17:40:00',3.34),('8902','2013-04-06','17:45:00',3.08),('8902','2013-04-06','17:50:00',2.95),('8902','2013-04-06','17:55:00',2.51),('8902','2013-04-06','18:00:00',1.76),('8902','2013-04-06','18:05:00',1.32),('8902','2013-04-06','18:10:00',1.28),('8902','2013-04-05','08:00:00',1.17),('8902','2013-04-05','08:05:00',1.36),('8902','2013-04-05','08:10:00',1.53),('8902','2013-04-05','08:15:00',1.7),('8902','2013-04-05','08:20:00',1.85),('8902','2013-04-05','08:25:00',2),('8902','2013-04-05','08:30:00',2.16),('8902','2013-04-05','08:35:00',2.31),('8902','2013-04-05','08:40:00',2.49),('8902','2013-04-05','08:45:00',2.65),('8902','2013-04-05','08:50:00',2.83),('8902','2013-04-05','08:55:00',3.01),('8902','2013-04-05','09:00:00',3.21),('8902','2013-04-05','09:05:00',3.4),('8902','2013-04-05','09:10:00',3.56),('8902','2013-04-05','09:15:00',3.73),('8902','2013-04-05','09:20:00',3.89),('8902','2013-04-05','09:25:00',4.06),('8902','2013-04-05','09:30:00',4.23),('8902','2013-04-05','09:35:00',4.29),('8902','2013-04-05','09:40:00',4.49),('8902','2013-04-05','09:45:00',4.61),('8902','2013-04-05','09:50:00',4.79),('8902','2013-04-05','09:55:00',4.92),('8902','2013-04-05','10:00:00',5.06),('8902','2013-04-05','10:05:00',5.24),('8902','2013-04-05','10:10:00',5.31),('8902','2013-04-05','10:15:00',5.48),('8902','2013-04-05','10:20:00',5.72),('8902','2013-04-05','10:25:00',5.78),('8902','2013-04-05','10:30:00',5.84),('8902','2013-04-05','10:35:00',5.98),('8902','2013-04-05','10:40:00',6.1),('8902','2013-04-05','10:45:00',6.2),('8902','2013-04-05','10:50:00',6.28),('8902','2013-04-05','10:55:00',6.4),('8902','2013-04-05','11:00:00',6.48),('8902','2013-04-05','11:05:00',6.65),('8902','2013-04-05','11:10:00',6.67),('8902','2013-04-05','11:15:00',6.71),('8902','2013-04-05','11:20:00',6.84),('8902','2013-04-05','11:25:00',6.98),('8902','2013-04-05','11:30:00',7.02),('8902','2013-04-05','11:35:00',7.04),('8902','2013-04-05','11:40:00',7.16),('8902','2013-04-05','11:45:00',7.26),('8902','2013-04-05','11:50:00',7.31),('8902','2013-04-05','11:55:00',7.41),('8902','2013-04-05','12:00:00',7.37),('8902','2013-04-05','12:05:00',7.43),('8902','2013-04-05','12:10:00',7.45),('8902','2013-04-05','12:15:00',7.47),('8902','2013-04-05','12:20:00',7.55),('8902','2013-04-05','12:25:00',4.8),('8902','2013-04-05','12:30:00',7.46),('8902','2013-04-05','12:35:00',7.83),('8902','2013-04-05','12:40:00',7.8),('8902','2013-04-05','12:45:00',7.91),('8902','2013-04-05','12:50:00',7.93),('8902','2013-04-05','12:55:00',7.99),('8902','2013-04-05','13:00:00',7.95),('8902','2013-04-05','13:05:00',7.96),('8902','2013-04-05','13:10:00',4.94),('8902','2013-04-05','13:15:00',3.6),('8902','2013-04-05','13:20:00',2.4),('8902','2013-04-05','13:25:00',2.2),('8902','2013-04-05','13:30:00',2.96),('8902','2013-04-05','13:35:00',3.58),('8902','2013-04-05','13:40:00',7.71),('8902','2013-04-05','13:45:00',9.13),('8902','2013-04-05','13:50:00',8.49),('8902','2013-04-05','13:55:00',8.47),('8902','2013-04-05','14:00:00',7.66),('8902','2013-04-05','14:05:00',7.55),('8902','2013-04-05','14:10:00',8.27),('8902','2013-04-05','14:15:00',4.83),('8902','2013-04-05','14:20:00',2.26),('8902','2013-04-05','14:25:00',3.44),('8902','2013-04-05','14:30:00',5.48),('8902','2013-04-05','14:35:00',6.35),('8902','2013-04-05','14:40:00',3.71),('8902','2013-04-05','14:45:00',6.37),('8902','2013-04-05','14:50:00',7.71),('8902','2013-04-05','14:55:00',7.76),('8902','2013-04-05','15:00:00',7.6),('8902','2013-04-05','15:05:00',7.4),('8902','2013-04-05','15:10:00',7.02),('8902','2013-04-05','15:15:00',6.89),('8902','2013-04-05','15:20:00',6.82),('8902','2013-04-05','15:25:00',6.8),('8902','2013-04-05','15:30:00',6.47),('8902','2013-04-05','15:35:00',6.31),('8902','2013-04-05','15:40:00',6.37),('8902','2013-04-05','15:45:00',5.92),('8902','2013-04-05','15:50:00',5.53),('8902','2013-04-05','15:55:00',6.09),('8902','2013-04-05','16:00:00',5.71),('8902','2013-04-05','16:05:00',5.91),('8902','2013-04-05','16:10:00',6.04),('8902','2013-04-05','16:15:00',5.37),('8902','2013-04-05','16:20:00',4.64),('8902','2013-04-05','16:25:00',3.96),('8902','2013-04-05','16:30:00',4.82),('8902','2013-04-05','16:35:00',4.45),('8902','2013-04-05','16:40:00',3.53),('8902','2013-04-05','16:45:00',4.69),('8902','2013-04-05','16:50:00',4.44),('8902','2013-04-05','16:55:00',3.88),('8902','2013-04-05','17:00:00',3.83),('8902','2013-04-05','17:05:00',3.4),('8902','2013-04-05','17:10:00',3.05),('8902','2013-04-05','17:15:00',2.39),('8902','2013-04-05','17:20:00',1.82),('8902','2013-04-05','17:25:00',1.95),('8902','2013-04-05','17:30:00',1.86),('8902','2013-04-05','17:35:00',1.53),('8902','2013-04-05','17:40:00',1.49),('8902','2013-04-05','17:45:00',1.39),('8902','2013-04-05','17:50:00',1.36),('8902','2013-04-05','17:55:00',1.25),('8902','2013-04-05','18:00:00',1.1),('8902','2013-04-04','08:05:00',1.17),('8902','2013-04-04','08:10:00',1.29),('8902','2013-04-04','08:15:00',2.12),('8902','2013-04-04','08:20:00',2.41),('8902','2013-04-04','08:25:00',1.58),('8902','2013-04-04','08:30:00',1.1),('8902','2013-04-04','08:40:00',1.27),('8902','2013-04-04','08:45:00',1.6),('8902','2013-04-04','08:50:00',1.12),('8902','2013-04-04','08:55:00',3.29),('8902','2013-04-04','09:00:00',2.1),('8902','2013-04-04','09:05:00',4.21),('8902','2013-04-04','09:10:00',3.08),('8902','2013-04-04','09:15:00',4.12),('8902','2013-04-04','09:20:00',3.75),('8902','2013-04-04','09:25:00',1.94),('8902','2013-04-04','09:30:00',1.42),('8902','2013-04-04','09:35:00',1.95),('8902','2013-04-04','09:40:00',3.1),('8902','2013-04-04','09:45:00',3.96),('8902','2013-04-04','09:50:00',2.13),('8902','2013-04-04','09:55:00',2),('8902','2013-04-04','10:00:00',2.74),('8902','2013-04-04','10:05:00',1.6),('8902','2013-04-04','10:10:00',5.05),('8902','2013-04-04','10:15:00',4.83),('8902','2013-04-04','10:20:00',2.41),('8902','2013-04-04','10:25:00',3.69),('8902','2013-04-04','10:30:00',3.73),('8902','2013-04-04','10:35:00',2.66),('8902','2013-04-04','10:40:00',5.31),('8902','2013-04-04','10:45:00',3.73),('8902','2013-04-04','10:50:00',4.41),('8902','2013-04-04','10:55:00',4.1),('8902','2013-04-04','11:00:00',2.92),('8902','2013-04-04','11:05:00',4.72),('8902','2013-04-04','11:10:00',6.87),('8902','2013-04-04','11:15:00',7.04),('8902','2013-04-04','11:20:00',6.04),('8902','2013-04-04','11:25:00',7.59),('8902','2013-04-04','11:30:00',7.51),('8902','2013-04-04','11:35:00',7.38),('8902','2013-04-04','11:40:00',7.54),('8902','2013-04-04','11:45:00',7.75),('8902','2013-04-04','11:50:00',8.11),('8902','2013-04-04','11:55:00',7.99),('8902','2013-04-04','12:00:00',8.87),('8902','2013-04-04','12:05:00',6.23),('8902','2013-04-04','12:10:00',4),('8902','2013-04-04','12:15:00',5.8),('8902','2013-04-04','12:20:00',2.76),('8902','2013-04-04','12:25:00',4.29),('8902','2013-04-04','12:30:00',2.43),('8902','2013-04-04','12:35:00',2.52),('8902','2013-04-04','12:40:00',3.07),('8902','2013-04-04','12:45:00',6.35),('8902','2013-04-04','12:50:00',8.55),('8902','2013-04-04','12:55:00',8.25),('8902','2013-04-04','13:00:00',5.62),('8902','2013-04-04','13:05:00',7.03),('8902','2013-04-04','13:10:00',6.05),('8902','2013-04-04','13:15:00',8.48),('8902','2013-04-04','13:20:00',7.21),('8902','2013-04-04','13:25:00',8.67),('8902','2013-04-04','13:30:00',6.19),('8902','2013-04-04','13:35:00',7.91),('8902','2013-04-04','13:40:00',7.21),('8902','2013-04-04','13:45:00',5.56),('8902','2013-04-04','13:50:00',9.1),('8902','2013-04-04','13:55:00',8.87),('8902','2013-04-04','14:00:00',5.46),('8902','2013-04-04','14:05:00',9.22),('8902','2013-04-04','14:10:00',8.45),('8902','2013-04-04','14:15:00',7.76),('8902','2013-04-04','14:20:00',7.76),('8902','2013-04-04','14:25:00',7.7),('8902','2013-04-04','14:30:00',8.37),('8902','2013-04-04','14:35:00',6.68),('8902','2013-04-04','14:40:00',6.91),('8902','2013-04-04','14:45:00',7.71),('8902','2013-04-04','14:50:00',4.53),('8902','2013-04-04','14:55:00',9.19),('8902','2013-04-04','15:00:00',8.85),('8902','2013-04-04','15:05:00',7.21),('8902','2013-04-04','15:10:00',6.74),('8902','2013-04-04','15:15:00',3.22),('8902','2013-04-04','15:20:00',3.22),('8902','2013-04-04','15:25:00',5.1),('8902','2013-04-04','15:30:00',4.17),('8902','2013-04-04','15:35:00',2.87),('8902','2013-04-04','15:40:00',2.34),('8902','2013-04-04','15:45:00',2.89),('8902','2013-04-04','15:50:00',4.13),('8902','2013-04-04','15:55:00',3.24),('8902','2013-04-04','16:00:00',3.44),('8902','2013-04-04','16:05:00',3.13),('8902','2013-04-04','16:10:00',3.07),('8902','2013-04-04','16:15:00',4.33),('8902','2013-04-04','16:20:00',4.94),('8902','2013-04-04','16:25:00',4.24),('8902','2013-04-04','16:30:00',3.1),('8902','2013-04-04','16:35:00',4.84),('8902','2013-04-04','16:40:00',3.06),('8902','2013-04-04','16:45:00',3.36),('8902','2013-04-04','16:50:00',5.85),('8902','2013-04-04','16:55:00',3.77),('8902','2013-04-04','17:00:00',2.84),('8902','2013-04-04','17:05:00',2.07),('8902','2013-04-04','17:10:00',3.72),('8902','2013-04-04','17:15:00',4.8),('8902','2013-04-04','17:20:00',4.75),('8902','2013-04-04','17:25:00',4.26),('8902','2013-04-04','17:30:00',3.95),('8902','2013-04-04','17:35:00',2.66),('8902','2013-04-04','17:40:00',3.29),('8902','2013-04-04','17:45:00',1.52),('8902','2013-04-04','17:50:00',1.47),('8902','2013-04-04','17:55:00',3.13),('8902','2013-04-04','18:00:00',2.49),('8902','2013-04-04','18:15:00',1.09),('8902','2013-04-04','18:20:00',1.45),('8902','2013-04-04','18:25:00',1.48),('8902','2013-04-04','18:30:00',1.21),('8902','2013-04-04','18:35:00',1.03),('8902','2013-04-03','08:00:00',1.02),('8902','2013-04-03','08:05:00',1.2),('8902','2013-04-03','08:10:00',1.05),('8902','2013-04-03','08:15:00',1.1),('8902','2013-04-03','08:20:00',1.12),('8902','2013-04-03','08:25:00',1.21),('8902','2013-04-03','08:30:00',1.26),('8902','2013-04-03','08:35:00',1.64),('8902','2013-04-03','08:40:00',1.53),('8902','2013-04-03','08:45:00',1.45),('8902','2013-04-03','08:50:00',1.45),('8902','2013-04-03','08:55:00',2.38),('8902','2013-04-03','09:00:00',3.46),('8902','2013-04-03','09:05:00',2.68),('8902','2013-04-03','09:10:00',2.38),('8902','2013-04-03','09:15:00',2.44),('8902','2013-04-03','09:20:00',2.46),('8902','2013-04-03','09:25:00',1.85),('8902','2013-04-03','09:30:00',2.63),('8902','2013-04-03','09:35:00',4.45),('8902','2013-04-03','09:40:00',4.42),('8902','2013-04-03','09:45:00',3.86),('8902','2013-04-03','09:50:00',2.11),('8902','2013-04-03','09:55:00',2.25),('8902','2013-04-03','10:00:00',3.34),('8902','2013-04-03','10:05:00',4.43),('8902','2013-04-03','10:10:00',4.03),('8902','2013-04-03','10:15:00',2.86),('8902','2013-04-03','10:20:00',3.2),('8902','2013-04-03','10:25:00',6.06),('8902','2013-04-03','10:30:00',5.78),('8902','2013-04-03','10:35:00',3.53),('8902','2013-04-03','10:40:00',7.01),('8902','2013-04-03','10:45:00',4.06),('8902','2013-04-03','10:50:00',4.08),('8902','2013-04-03','10:55:00',6.79),('8902','2013-04-03','11:00:00',4.42),('8902','2013-04-03','11:05:00',2.33),('8902','2013-04-03','11:10:00',1.97),('8902','2013-04-03','11:15:00',2.6),('8902','2013-04-03','11:20:00',2.6),('8902','2013-04-03','11:25:00',1.96),('8902','2013-04-03','11:30:00',2.16),('8902','2013-04-03','11:35:00',3.1),('8902','2013-04-03','11:40:00',5.31),('8902','2013-04-03','11:45:00',6.42),('8902','2013-04-03','11:50:00',7.22),('8902','2013-04-03','11:55:00',7.48),('8902','2013-04-03','12:00:00',7.55),('8902','2013-04-03','12:05:00',7.28),('8902','2013-04-03','12:10:00',7.45),('8902','2013-04-03','12:15:00',7.31),('8902','2013-04-03','12:20:00',6.24),('8902','2013-04-03','12:25:00',5.15),('8902','2013-04-03','12:30:00',6.53),('8902','2013-04-03','12:35:00',7.68),('8902','2013-04-03','12:40:00',5.72),('8902','2013-04-03','12:45:00',6.1),('8902','2013-04-03','12:50:00',7.95),('8902','2013-04-03','12:55:00',7.33),('8902','2013-04-03','13:00:00',7.18),('8902','2013-04-03','13:05:00',7.29),('8902','2013-04-03','13:10:00',7.44),('8902','2013-04-03','13:15:00',7.92),('8902','2013-04-03','13:20:00',7.67),('8902','2013-04-03','13:25:00',7.85),('8902','2013-04-03','13:30:00',7.7),('8902','2013-04-03','13:35:00',6.97),('8902','2013-04-03','13:40:00',5.93),('8902','2013-04-03','13:45:00',6.26),('8902','2013-04-03','13:50:00',6.2),('8902','2013-04-03','13:55:00',4.74),('8902','2013-04-03','14:00:00',4.91),('8902','2013-04-03','14:05:00',6.49),('8902','2013-04-03','14:10:00',7.41),('8902','2013-04-03','14:15:00',7.42),('8902','2013-04-03','14:20:00',7.32),('8902','2013-04-03','14:25:00',7.08),('8902','2013-04-03','14:30:00',7.14),('8902','2013-04-03','14:35:00',7.12),('8902','2013-04-03','14:40:00',7.17),('8902','2013-04-03','14:45:00',7.01),('8902','2013-04-03','14:50:00',6.92),('8902','2013-04-03','14:55:00',6.97),('8902','2013-04-03','15:00:00',6.86),('8902','2013-04-03','15:05:00',6.71),('8902','2013-04-03','15:10:00',6.34),('8902','2013-04-03','15:15:00',6.3),('8902','2013-04-03','15:20:00',6.39),('8902','2013-04-03','15:25:00',6.53),('8902','2013-04-03','15:30:00',6.37),('8902','2013-04-03','15:35:00',6.26),('8902','2013-04-03','15:40:00',6.1),('8902','2013-04-03','15:45:00',6.01),('8902','2013-04-03','15:50:00',5.77),('8902','2013-04-03','15:55:00',5.78),('8902','2013-04-03','16:00:00',5.67),('8902','2013-04-03','16:05:00',5.48),('8902','2013-04-03','16:10:00',5.22),('8902','2013-04-03','16:15:00',4.9),('8902','2013-04-03','16:20:00',4.52),('8902','2013-04-03','16:25:00',4.15),('8902','2013-04-03','16:30:00',3.72),('8902','2013-04-03','16:35:00',3.69),('8902','2013-04-03','16:40:00',3.67),('8902','2013-04-03','16:45:00',3.67),('8902','2013-04-03','16:50:00',2.98),('8902','2013-04-03','16:55:00',3.6),('8902','2013-04-03','17:00:00',3.31),('8902','2013-04-03','17:05:00',3.44),('8902','2013-04-03','17:10:00',3.08),('8902','2013-04-03','17:15:00',2.79),('8902','2013-04-03','17:20:00',2.04),('8902','2013-04-03','17:25:00',1.97),('8902','2013-04-03','17:30:00',1.47),('8902','2013-04-03','17:35:00',1.27),('8902','2013-04-03','17:40:00',1.51),('8902','2013-04-03','17:45:00',1.44),('8902','2013-04-03','17:50:00',1.75),('8902','2013-04-03','17:55:00',2.05),('8902','2013-04-03','18:00:00',1.66),('8902','2013-04-03','18:05:00',1.46),('8902','2013-04-02','08:00:00',1.01),('8902','2013-04-02','08:05:00',1.24),('8902','2013-04-02','08:10:00',1.43),('8902','2013-04-02','08:15:00',1.66),('8902','2013-04-02','08:20:00',1.9),('8902','2013-04-02','08:25:00',1.82),('8902','2013-04-02','08:30:00',2.28),('8902','2013-04-02','08:35:00',2.63),('8902','2013-04-02','08:40:00',2.04),('8902','2013-04-02','08:45:00',2.31),('8902','2013-04-02','08:50:00',1.36),('8902','2013-04-02','08:55:00',2.73),('8902','2013-04-02','09:00:00',3.42),('8902','2013-04-02','09:05:00',3.22),('8902','2013-04-02','09:10:00',3.62),('8902','2013-04-02','09:15:00',4.16),('8902','2013-04-02','09:20:00',4.49),('8902','2013-04-02','09:25:00',2.66),('8902','2013-04-02','09:30:00',2.41),('8902','2013-04-02','09:35:00',5.37),('8902','2013-04-02','09:40:00',5.38),('8902','2013-04-02','09:45:00',3.85),('8902','2013-04-02','09:50:00',4.36),('8902','2013-04-02','09:55:00',5.1),('8902','2013-04-02','10:00:00',5.42),('8902','2013-04-02','10:05:00',2.42),('8902','2013-04-02','10:10:00',2.02),('8902','2013-04-02','10:15:00',2.6),('8902','2013-04-02','10:20:00',5.56),('8902','2013-04-02','10:25:00',6.64),('8902','2013-04-02','10:30:00',5.74),('8902','2013-04-02','10:35:00',3.79),('8902','2013-04-02','10:40:00',3.42),('8902','2013-04-02','10:45:00',2.55),('8902','2013-04-02','10:50:00',3.92),('8902','2013-04-02','10:55:00',2.63),('8902','2013-04-02','11:00:00',5.43),('8902','2013-04-02','11:05:00',5.96),('8902','2013-04-02','11:10:00',6.64),('8902','2013-04-02','11:15:00',4.54),('8902','2013-04-02','11:20:00',6.32),('8902','2013-04-02','11:25:00',4.63),('8902','2013-04-02','11:30:00',3.18),('8902','2013-04-02','11:35:00',3.36),('8902','2013-04-02','11:40:00',4.5),('8902','2013-04-02','11:45:00',2.66),('8902','2013-04-02','11:50:00',5.71),('8902','2013-04-02','11:55:00',6.3),('8902','2013-04-02','12:00:00',4.97),('8902','2013-04-02','12:05:00',8.23),('8902','2013-04-02','12:10:00',7.91),('8902','2013-04-02','12:15:00',2.81),('8902','2013-04-02','12:20:00',6.9),('8902','2013-04-02','12:25:00',8.14),('8902','2013-04-02','12:30:00',8.53),('8902','2013-04-02','12:35:00',5.99),('8902','2013-04-02','12:40:00',8.66),('8902','2013-04-02','12:45:00',9.3),('8902','2013-04-02','12:50:00',7.93),('8902','2013-04-02','12:55:00',8.61),('8902','2013-04-02','13:00:00',7.95),('8902','2013-04-02','13:05:00',6.81),('8902','2013-04-02','13:10:00',6.03),('8902','2013-04-02','13:15:00',8.92),('8902','2013-04-02','13:20:00',7.59),('8902','2013-04-02','13:25:00',6.65),('8902','2013-04-02','13:30:00',5.09),('8902','2013-04-02','13:35:00',6.83),('8902','2013-04-02','13:40:00',6.3),('8902','2013-04-02','13:45:00',7.16),('8902','2013-04-02','13:50:00',6.93),('8902','2013-04-02','13:55:00',5.2),('8902','2013-04-02','14:00:00',7.64),('8902','2013-04-02','14:05:00',8.37),('8902','2013-04-02','14:10:00',7.78),('8902','2013-04-02','14:15:00',7.37),('8902','2013-04-02','14:20:00',6.43),('8902','2013-04-02','14:25:00',5.63),('8902','2013-04-02','14:30:00',7.13),('8902','2013-04-02','14:35:00',7.29),('8902','2013-04-02','14:40:00',6.75),('8902','2013-04-02','14:45:00',5.75),('8902','2013-04-02','14:50:00',4.68),('8902','2013-04-02','14:55:00',4.71),('8902','2013-04-02','15:00:00',7.31),('8902','2013-04-02','15:05:00',6.45),('8902','2013-04-02','15:10:00',6.97),('8902','2013-04-02','15:15:00',8.75),('8902','2013-04-02','15:20:00',7.19),('8902','2013-04-02','15:25:00',7.64),('8902','2013-04-02','15:30:00',5.47),('8902','2013-04-02','15:35:00',4.45),('8902','2013-04-02','15:40:00',6.83),('8902','2013-04-02','15:45:00',6.69),('8902','2013-04-02','15:50:00',7.59),('8902','2013-04-02','15:55:00',7.31),('8902','2013-04-02','16:00:00',7.11),('8902','2013-04-02','16:05:00',6.85),('8902','2013-04-02','16:10:00',6.75),('8902','2013-04-02','16:15:00',6.44),('8902','2013-04-02','16:20:00',6.3),('8902','2013-04-02','16:25:00',6.07),('8902','2013-04-02','16:30:00',5.97),('8902','2013-04-02','16:35:00',5.96),('8902','2013-04-02','16:40:00',5.59),('8902','2013-04-02','16:45:00',5.37),('8902','2013-04-02','16:50:00',5.24),('8902','2013-04-02','16:55:00',5.08),('8902','2013-04-02','17:00:00',4.91),('8902','2013-04-02','17:05:00',4.65),('8902','2013-04-02','17:10:00',4.53),('8902','2013-04-02','17:15:00',4.36),('8902','2013-04-02','17:20:00',4.15),('8902','2013-04-02','17:25:00',3.77),('8902','2013-04-02','17:30:00',3.71),('8902','2013-04-02','17:35:00',3.54),('8902','2013-04-02','17:40:00',3.28),('8902','2013-04-02','17:45:00',3.12),('8902','2013-04-02','17:50:00',2.94),('8902','2013-04-02','17:55:00',2.7),('8902','2013-04-02','18:00:00',2.52),('8902','2013-04-02','18:05:00',2.31),('8902','2013-04-02','18:10:00',2.06),('8902','2013-04-02','18:15:00',1.85),('8902','2013-04-02','18:20:00',1.64),('8902','2013-04-02','18:25:00',1.45),('8902','2013-04-02','18:30:00',1.3),('8902','2013-04-02','18:35:00',1.11),('8902','2013-04-01','08:35:00',1.16),('8902','2013-04-01','08:40:00',2.61),('8902','2013-04-01','08:45:00',3.08),('8902','2013-04-01','08:50:00',2.36),('8902','2013-04-01','08:55:00',1.87),('8902','2013-04-01','09:00:00',3.16),('8902','2013-04-01','09:05:00',3.36),('8902','2013-04-01','09:10:00',3.67),('8902','2013-04-01','09:15:00',3.7),('8902','2013-04-01','09:20:00',2.65),('8902','2013-04-01','09:25:00',2.01),('8902','2013-04-01','09:30:00',4.85),('8902','2013-04-01','09:35:00',4.2),('8902','2013-04-01','09:40:00',4.4),('8902','2013-04-01','09:45:00',4.78),('8902','2013-04-01','09:50:00',3.03),('8902','2013-04-01','09:55:00',2.99),('8902','2013-04-01','10:00:00',2.99),('8902','2013-04-01','10:05:00',5.02),('8902','2013-04-01','10:10:00',3.19),('8902','2013-04-01','10:15:00',3),('8902','2013-04-01','10:20:00',4.13),('8902','2013-04-01','10:25:00',3.26),('8902','2013-04-01','10:30:00',1.26),('8902','2013-04-01','10:35:00',2.31),('8902','2013-04-01','10:40:00',2.16),('8902','2013-04-01','10:45:00',5.8),('8902','2013-04-01','10:50:00',7.29),('8902','2013-04-01','10:55:00',4.13),('8902','2013-04-01','11:00:00',1.78),('8902','2013-04-01','11:05:00',4.67),('8902','2013-04-01','11:10:00',4.69),('8902','2013-04-01','11:15:00',2.29),('8902','2013-04-01','11:20:00',1.39),('8902','2013-04-01','11:25:00',2.19),('8902','2013-04-01','11:30:00',1.89),('8902','2013-04-01','11:35:00',3.18),('8902','2013-04-01','11:40:00',1.2),('8902','2013-04-01','11:45:00',2.85),('8902','2013-04-01','11:50:00',4.1),('8902','2013-04-01','11:55:00',2.78),('8902','2013-04-01','12:00:00',2.11),('8902','2013-04-01','12:05:00',4.17),('8902','2013-04-01','12:10:00',6.65),('8902','2013-04-01','12:15:00',4.99),('8902','2013-04-01','12:30:00',1.49),('8902','2013-04-01','12:35:00',3.14),('8902','2013-04-01','12:40:00',4.92),('8902','2013-04-01','12:45:00',4.73),('8902','2013-04-01','12:50:00',4.22),('8902','2013-04-01','12:55:00',4.18),('8902','2013-04-01','13:00:00',3.87),('8902','2013-04-01','13:05:00',4.69),('8902','2013-04-01','13:10:00',6.57),('8902','2013-04-01','13:15:00',4.24),('8902','2013-04-01','13:20:00',3.46),('8902','2013-04-01','13:25:00',6.25),('8902','2013-04-01','13:30:00',5.15),('8902','2013-04-01','13:35:00',3.54),('8902','2013-04-01','13:40:00',4.44),('8902','2013-04-01','13:45:00',4.8),('8902','2013-04-01','13:50:00',3.8),('8902','2013-04-01','13:55:00',3.26),('8902','2013-04-01','14:00:00',4.78),('8902','2013-04-01','14:05:00',4.83),('8902','2013-04-01','14:10:00',6.88),('8902','2013-04-01','14:15:00',4.98),('8902','2013-04-01','14:20:00',7.53),('8902','2013-04-01','14:25:00',9.38),('8902','2013-04-01','14:30:00',7.42),('8902','2013-04-01','14:35:00',3.58),('8902','2013-04-01','14:40:00',4.33),('8902','2013-04-01','14:45:00',4.28),('8902','2013-04-01','14:50:00',4.04),('8902','2013-04-01','14:55:00',3.1),('8902','2013-04-01','15:00:00',3.14),('8902','2013-04-01','15:05:00',1.47),('8902','2013-04-01','15:15:00',1.02),('8902','2013-04-01','15:20:00',1.6),('8902','2013-04-01','15:25:00',1.04),('8902','2013-04-01','15:30:00',1),('8902','2013-04-01','15:35:00',1.32),('8902','2013-04-01','15:40:00',1.6),('8902','2013-04-01','15:45:00',2.23),('8902','2013-04-01','15:50:00',1.04),('8902','2013-04-01','16:00:00',1.75),('8902','2013-04-01','16:05:00',2.16),('8902','2013-04-01','16:10:00',1.68),('8902','2013-04-01','16:15:00',1.92),('8902','2013-04-01','16:20:00',2.06),('8902','2013-04-01','16:25:00',1.72),('8902','2013-04-01','16:30:00',1.7),('8902','2013-04-01','16:35:00',1.93),('8902','2013-04-01','16:40:00',1.65),('8902','2013-04-01','16:45:00',1.6),('8902','2013-04-01','16:50:00',1.11),('8902','2013-04-01','16:55:00',1.29),('8902','2013-04-01','17:00:00',1.43),('8902','2013-04-01','17:05:00',1.37),('8902','2013-04-01','17:35:00',1.06),('8902','2013-04-01','17:40:00',2.14),('8902','2013-04-01','17:45:00',2.37),('8902','2014-05-01','07:15:00',1.09),('8902','2014-05-01','07:30:00',1.23),('8902','2014-05-01','07:35:00',1.21),('8902','2014-05-01','07:40:00',1.38),('8902','2014-05-01','07:45:00',1.56),('8902','2014-05-01','07:50:00',1.55),('8902','2014-05-01','08:00:00',1.45),('8902','2014-05-01','08:05:00',2.22),('8902','2014-05-01','08:10:00',1.55),('8902','2014-05-01','08:15:00',2.39),('8902','2014-05-01','08:20:00',3.33),('8902','2014-05-01','08:25:00',2.81),('8902','2014-05-01','08:30:00',2.43),('8902','2014-05-01','08:40:00',1.12),('8902','2014-05-01','08:45:00',1.84),('8902','2014-05-01','08:50:00',2.25),('8902','2014-05-01','08:55:00',1.35),('8902','2014-05-01','09:10:00',1.22),('8902','2014-05-01','09:15:00',1.88),('8902','2014-05-01','09:20:00',2.38),('8902','2014-05-01','09:25:00',2.63),('8902','2014-05-01','09:30:00',2.97),('8902','2014-05-01','09:35:00',3),('8902','2014-05-01','09:40:00',2.45),('8902','2014-05-01','09:45:00',2.6),('8902','2014-05-01','09:50:00',2.72),('8902','2014-05-01','09:55:00',2.7),('8902','2014-05-01','10:00:00',3.22),('8902','2014-05-01','10:05:00',3.11),('8902','2014-05-01','10:10:00',3.68),('8902','2014-05-01','10:15:00',3.44),('8902','2014-05-01','10:20:00',3.12),('8902','2014-05-01','10:25:00',2.16),('8902','2014-05-01','10:30:00',1.71),('8902','2014-05-01','10:35:00',1.62),('8902','2014-05-01','10:40:00',1.75),('8902','2014-05-01','10:45:00',2.13),('8902','2014-05-01','10:50:00',2.06),('8902','2014-05-01','10:55:00',1.68),('8902','2014-05-01','11:00:00',1.09),('8902','2014-05-01','11:25:00',1),('8902','2014-05-01','12:25:00',1.54),('8902','2014-05-01','12:30:00',1.95),('8902','2014-05-01','12:35:00',2.26),('8902','2014-05-01','12:40:00',1.96),('8902','2014-05-01','12:45:00',2.06),('8902','2014-05-01','12:50:00',3.13),('8902','2014-05-01','12:55:00',3.21),('8902','2014-05-01','13:00:00',2.94),('8902','2014-05-01','13:05:00',3.62),('8902','2014-05-01','13:10:00',3.92),('8902','2014-05-01','13:15:00',4.16),('8902','2014-05-01','13:20:00',6.18),('8902','2014-05-01','13:25:00',5.7),('8902','2014-05-01','13:30:00',4.95),('8902','2014-05-01','13:35:00',4.33),('8902','2014-05-01','13:40:00',4.47),('8902','2014-05-01','13:45:00',4.4),('8902','2014-05-01','13:50:00',2.72),('8902','2014-05-01','13:55:00',2.6),('8902','2014-05-01','14:00:00',2.58),('8902','2014-05-01','14:05:00',3.29),('8902','2014-05-01','14:10:00',2.73),('8902','2014-05-01','14:15:00',1.28),('8902','2014-05-01','14:25:00',1.39),('8902','2014-05-01','14:30:00',2.59),('8902','2014-05-01','14:35:00',3.71),('8902','2014-05-01','14:40:00',5.07),('8902','2014-05-01','14:45:00',4.51),('8902','2014-05-01','14:50:00',2.92),('8902','2014-05-01','14:55:00',3.65),('8902','2014-05-01','15:00:00',6.44),('8902','2014-05-01','15:05:00',4.73),('8902','2014-05-01','15:10:00',5.97),('8902','2014-05-01','15:15:00',7.98),('8902','2014-05-01','15:20:00',3.2),('8902','2014-05-01','15:25:00',2.42),('8902','2014-05-01','15:30:00',2.34),('8902','2014-05-01','15:35:00',4.93),('8902','2014-05-01','15:40:00',8.05),('8902','2014-05-01','15:45:00',3.19),('8902','2014-05-01','15:50:00',1.45),('8902','2014-05-01','15:55:00',1.57),('8902','2014-05-01','16:00:00',2.08),('8902','2014-05-01','16:05:00',3.39),('8902','2014-05-01','16:10:00',2.44),('8902','2014-05-01','16:15:00',1.42),('8902','2014-05-01','16:20:00',5.29),('8902','2014-05-01','16:25:00',1.37),('8902','2014-05-01','17:05:00',1.47),('8902','2014-05-01','17:10:00',1.33),('8902','2014-05-01','17:15:00',1.68),('8902','2014-05-01','17:20:00',2.07),('8902','2014-05-01','17:25:00',2.44),('8902','2014-05-01','17:30:00',1.88),('8902','2014-05-01','17:35:00',1.4),('8902','2014-05-01','17:40:00',1.18),('8902','2014-03-26','07:40:00',1.12),('8902','2014-03-26','07:45:00',1.37),('8902','2014-03-26','07:50:00',1.52),('8902','2014-03-26','07:55:00',2.1),('8902','2014-03-26','08:00:00',2.58),('8902','2014-03-26','08:05:00',2.6),('8902','2014-03-26','08:10:00',1.29),('8902','2014-03-26','09:10:00',1.26),('8902','2014-03-26','09:15:00',1.6),('8902','2014-03-26','09:20:00',1.57),('8902','2014-03-26','09:25:00',1.47),('8902','2014-03-26','09:30:00',1.25),('8902','2014-03-26','09:50:00',1.08),('8902','2014-03-26','09:55:00',1.55),('8902','2014-03-26','10:00:00',1.79),('8902','2014-03-26','10:05:00',1.9),('8902','2014-03-26','10:10:00',2.6),('8902','2014-03-26','10:15:00',2.02),('8902','2014-03-26','10:20:00',2.9),('8902','2014-03-26','10:25:00',3.48),('8902','2014-03-26','10:30:00',4.3),('8902','2014-03-26','10:35:00',3.76),('8902','2014-03-26','10:40:00',4.74),('8902','2014-03-26','10:45:00',2.8),('8902','2014-03-26','10:50:00',1.42),('8902','2014-03-26','10:55:00',1.32),('8902','2014-03-26','11:00:00',1.61),('8902','2014-03-26','11:05:00',1.2),('8902','2014-03-26','11:10:00',4.86),('8902','2014-03-26','11:15:00',9.05),('8902','2014-03-26','11:20:00',4.53),('8902','2014-03-26','11:25:00',1.63),('8902','2014-03-26','11:30:00',1.36),('8902','2014-03-26','11:50:00',1.68),('8902','2014-03-26','11:55:00',2.7),('8902','2014-03-26','12:00:00',2.89),('8902','2014-03-26','12:05:00',1.8),('8902','2014-03-26','12:10:00',3.2),('8902','2014-03-26','12:15:00',2.37),('8902','2014-03-26','12:20:00',2.06),('8902','2014-03-26','12:25:00',1.1),('8902','2014-03-26','12:50:00',1.31),('8902','2014-03-26','12:55:00',1.67),('8902','2014-03-26','13:00:00',1.78),('8902','2014-03-26','13:05:00',1.91),('8902','2014-03-26','13:10:00',2.81),('8902','2014-03-26','13:15:00',3.88),('8902','2014-03-26','13:20:00',4.31),('8902','2014-03-26','13:25:00',4.7),('8902','2014-03-26','13:30:00',4.06),('8902','2014-03-26','13:35:00',3.77),('8902','2014-03-26','13:40:00',3.54),('8902','2014-03-26','13:45:00',3.3),('8902','2014-03-26','13:50:00',4.11),('8902','2014-03-26','13:55:00',5.33),('8902','2014-03-26','14:00:00',5.14),('8902','2014-03-26','14:05:00',2.35),('8902','2014-03-26','14:10:00',1.74),('8902','2014-03-26','14:15:00',4.23),('8902','2014-03-26','14:20:00',6.66),('8902','2014-03-26','14:25:00',7.33),('8902','2014-03-26','14:30:00',6.33),('8902','2014-03-26','14:35:00',5.23),('8902','2014-03-26','14:40:00',3.37),('8902','2014-03-26','14:45:00',3.19),('8902','2014-03-26','14:50:00',4.07),('8902','2014-03-26','14:55:00',5.42),('8902','2014-03-26','15:00:00',3.67),('8902','2014-03-26','15:05:00',3.47),('8902','2014-03-26','15:10:00',1.09),('8902','2014-03-26','15:20:00',2.09),('8902','2014-03-26','15:25:00',4.61),('8902','2014-03-26','15:30:00',4.9),('8902','2014-03-26','15:35:00',2.45),('8902','2014-03-26','15:40:00',1.6),('8902','2014-03-26','15:45:00',1.21),('8902','2014-03-26','15:50:00',1.94),('8902','2014-03-26','15:55:00',1.91),('8902','2014-03-26','16:00:00',1.55),('8902','2014-03-26','16:05:00',1.87),('8902','2014-03-26','16:10:00',2.47),('8902','2014-03-26','16:15:00',2.5),('8902','2014-03-26','16:20:00',1.78),('8902','2014-03-26','16:25:00',2.09),('8902','2014-03-26','16:30:00',2.22),('8902','2014-03-26','16:35:00',1.68),('8902','2014-03-26','16:40:00',1.87),('8902','2014-03-26','16:45:00',1.88),('8902','2014-03-26','16:50:00',1.14),('8902','2014-03-26','16:55:00',1.29),('8902','2014-03-26','17:00:00',1.46),('8902','2014-03-26','17:05:00',1.36),('8902','2014-03-26','17:10:00',1.07),('8902','2014-03-26','17:15:00',1.08),('8902','2013-03-31','08:20:00',1.36),('8902','2013-03-31','08:25:00',1.9),('8902','2013-03-31','08:30:00',2),('8902','2013-03-31','08:35:00',2.28),('8902','2013-03-31','08:40:00',2.99),('8902','2013-03-31','08:45:00',2.05),('8902','2013-03-31','08:50:00',2.99),('8902','2013-03-31','08:55:00',3.26),('8902','2013-03-31','09:00:00',3.2),('8902','2013-03-31','09:05:00',3.42),('8902','2013-03-31','09:10:00',3.76),('8902','2013-03-31','09:15:00',4.04),('8902','2013-03-31','09:20:00',3.87),('8902','2013-03-31','09:25:00',4.18),('8902','2013-03-31','09:30:00',4.6),('8902','2013-03-31','09:35:00',2.24),('8902','2013-03-31','09:40:00',4.57),('8902','2013-03-31','09:45:00',5.09),('8902','2013-03-31','09:50:00',5),('8902','2013-03-31','09:55:00',4.7),('8902','2013-03-31','10:00:00',5.22),('8902','2013-03-31','10:05:00',5.46),('8902','2013-03-31','10:10:00',5.17),('8902','2013-03-31','10:15:00',5.17),('8902','2013-03-31','10:20:00',6.14),('8902','2013-03-31','10:25:00',5.35),('8902','2013-03-31','10:30:00',5.1),('8902','2013-03-31','10:35:00',2.34),('8902','2013-03-31','10:40:00',4.24),('8902','2013-03-31','10:45:00',6.93),('8902','2013-03-31','10:50:00',1.98),('8902','2013-03-31','10:55:00',1.74),('8902','2013-03-31','11:00:00',2.07),('8902','2013-03-31','11:05:00',2.52),('8902','2013-03-31','11:10:00',4.43),('8902','2013-03-31','11:15:00',4.47),('8902','2013-03-31','11:20:00',5.37),('8902','2013-03-31','11:25:00',6.06),('8902','2013-03-31','11:30:00',4.38),('8902','2013-03-31','11:35:00',3.52),('8902','2013-03-31','11:40:00',6.02),('8902','2013-03-31','11:45:00',6.07),('8902','2013-03-31','11:50:00',4.96),('8902','2013-03-31','11:55:00',4.15),('8902','2013-03-31','12:00:00',5.63),('8902','2013-03-31','12:05:00',3.82),('8902','2013-03-31','12:10:00',4.51),('8902','2013-03-31','12:15:00',3.82),('8902','2013-03-31','12:20:00',3.34),('8902','2013-03-31','12:25:00',3.5),('8902','2013-03-31','12:30:00',4.77),('8902','2013-03-31','12:35:00',4.55),('8902','2013-03-31','12:40:00',4.4),('8902','2013-03-31','12:45:00',5.03),('8902','2013-03-31','12:50:00',5.33),('8902','2013-03-31','12:55:00',5.91),('8902','2013-03-31','13:00:00',5.55),('8902','2013-03-31','13:05:00',6.14),('8902','2013-03-31','13:10:00',5.41),('8902','2013-03-31','13:15:00',5.61),('8902','2013-03-31','13:20:00',5.39),('8902','2013-03-31','13:25:00',5.07),('8902','2013-03-31','13:30:00',5.82),('8902','2013-03-31','13:35:00',5.06),('8902','2013-03-31','13:40:00',6.45),('8902','2013-03-31','13:45:00',7.15),('8902','2013-03-31','13:50:00',8.06),('8902','2013-03-31','13:55:00',7.81),('8902','2013-03-31','14:00:00',4.63),('8902','2013-03-31','14:05:00',3.43),('8902','2013-03-31','14:10:00',4.37),('8902','2013-03-31','14:15:00',4.95),('8902','2013-03-31','14:20:00',5.06),('8902','2013-03-31','14:25:00',8.23),('8902','2013-03-31','14:30:00',5.35),('8902','2013-03-31','14:35:00',4.25),('8902','2013-03-31','14:40:00',3.81),('8902','2013-03-31','14:45:00',3.6),('8902','2013-03-31','14:50:00',3.92),('8902','2013-03-31','14:55:00',4.29),('8902','2013-03-31','15:00:00',3.77),('8902','2013-03-31','15:05:00',3.76),('8902','2013-03-31','15:10:00',3.81),('8902','2013-03-31','15:15:00',4.11),('8902','2013-03-31','15:20:00',4.31),('8902','2013-03-31','15:25:00',4.35),('8902','2013-03-31','15:30:00',3.85),('8902','2013-03-31','15:35:00',5.07),('8902','2013-03-31','15:40:00',4.73),('8902','2013-03-31','15:45:00',4.83),('8902','2013-03-31','15:50:00',5.53),('8902','2013-03-31','15:55:00',4.2),('8902','2013-03-31','16:00:00',3.77),('8902','2013-03-31','16:05:00',3.03),('8902','2013-03-31','16:10:00',2.49),('8902','2013-03-31','16:15:00',2.01),('8902','2013-03-31','16:20:00',1.87),('8902','2013-03-31','16:25:00',1.71),('8902','2013-03-31','16:30:00',1.46),('8902','2013-03-31','16:35:00',1.51),('8902','2013-03-31','16:40:00',1.41),('8902','2013-03-31','16:45:00',1.19),('8902','2013-03-30','08:20:00',1.49),('8902','2013-03-30','08:25:00',1.16),('8902','2013-03-30','08:30:00',1.69),('8902','2013-03-30','08:35:00',2.07),('8902','2013-03-30','08:40:00',1.87),('8902','2013-03-30','08:45:00',2.16),('8902','2013-03-30','08:50:00',1.77),('8902','2013-03-30','08:55:00',1.9),('8902','2013-03-30','09:00:00',2.21),('8902','2013-03-30','09:05:00',2),('8902','2013-03-30','09:10:00',2.07),('8902','2013-03-30','09:15:00',2.02),('8902','2013-03-30','09:20:00',3.94),('8902','2013-03-30','09:25:00',4.94),('8902','2013-03-30','09:30:00',3.82),('8902','2013-03-30','09:35:00',3.35),('8902','2013-03-30','09:40:00',2.19),('8902','2013-03-30','09:45:00',4.62),('8902','2013-03-30','09:50:00',2.51),('8902','2013-03-30','09:55:00',3.44),('8902','2013-03-30','10:00:00',4.33),('8902','2013-03-30','10:05:00',1.46),('8902','2013-03-30','10:15:00',1.63),('8902','2013-03-30','10:20:00',3.53),('8902','2013-03-30','10:25:00',4.8),('8902','2013-03-30','10:30:00',5.49),('8902','2013-03-30','10:35:00',5.5),('8902','2013-03-30','10:40:00',1.42),('8902','2013-03-30','10:45:00',2.02),('8902','2013-03-30','10:50:00',3.57),('8902','2013-03-30','10:55:00',2.17),('8902','2013-03-30','11:00:00',1.37),('8902','2013-03-30','11:05:00',1.36),('8902','2013-03-30','11:10:00',2.74),('8902','2013-03-30','11:15:00',2.66),('8902','2013-03-30','11:20:00',2.2),('8902','2013-03-30','11:25:00',2.64),('8902','2013-03-30','11:30:00',1.88),('8902','2013-03-30','11:35:00',2.49),('8902','2013-03-30','11:40:00',3.05),('8902','2013-03-30','11:45:00',2.38),('8902','2013-03-30','11:50:00',2.66),('8902','2013-03-30','11:55:00',3.1),('8902','2013-03-30','12:00:00',2.8),('8902','2013-03-30','12:05:00',2.59),('8902','2013-03-30','12:10:00',2.48),('8902','2013-03-30','12:15:00',2.55),('8902','2013-03-30','12:20:00',2.49),('8902','2013-03-30','12:25:00',2.79),('8902','2013-03-30','12:30:00',3.33),('8902','2013-03-30','12:35:00',5.73),('8902','2013-03-30','12:40:00',4.59),('8902','2013-03-30','12:45:00',2.85),('8902','2013-03-30','12:50:00',2.94),('8902','2013-03-30','12:55:00',3.66),('8902','2013-03-30','13:00:00',4.49),('8902','2013-03-30','13:05:00',4.52),('8902','2013-03-30','13:10:00',5.19),('8902','2013-03-30','13:15:00',4.07),('8902','2013-03-30','13:20:00',6.51),('8902','2013-03-30','13:25:00',6.07),('8902','2013-03-30','13:30:00',1.53),('8902','2013-03-30','13:35:00',1.47),('8902','2013-03-30','13:40:00',2.54),('8902','2013-03-30','13:45:00',3.57),('8902','2013-03-30','13:50:00',3.91),('8902','2013-03-30','13:55:00',4),('8902','2013-03-30','14:00:00',3.11),('8902','2013-03-30','14:05:00',6.29),('8902','2013-03-30','14:10:00',3.88),('8902','2013-03-30','14:15:00',7.09),('8902','2013-03-30','14:20:00',2.96),('8902','2013-03-30','14:25:00',3.1),('8902','2013-03-30','14:30:00',6.8),('8902','2013-03-30','14:35:00',8.59),('8902','2013-03-30','14:40:00',8.95),('8902','2013-03-30','14:45:00',6.29),('8902','2013-03-30','14:50:00',7.01),('8902','2013-03-30','14:55:00',5.99),('8902','2013-03-30','15:00:00',5.07),('8902','2013-03-30','15:05:00',3.67),('8902','2013-03-30','15:10:00',5.84),('8902','2013-03-30','15:15:00',5.3),('8902','2013-03-30','15:20:00',8.65),('8902','2013-03-30','15:25:00',5.35),('8902','2013-03-30','15:30:00',4.35),('8902','2013-03-30','15:35:00',6.53),('8902','2013-03-30','15:40:00',8.16),('8902','2013-03-30','15:45:00',5.8),('8902','2013-03-30','15:50:00',2.07),('8902','2013-03-30','15:55:00',1.45),('8902','2013-03-30','16:00:00',5.36),('8902','2013-03-30','16:05:00',2.81),('8902','2013-03-30','16:10:00',2.59),('8902','2013-03-30','16:15:00',3.52),('8902','2013-03-30','16:20:00',3.36),('8902','2013-03-30','16:25:00',2.45),('8902','2013-03-30','16:30:00',1.96),('8902','2013-03-30','16:35:00',2.06),('8902','2013-03-30','16:40:00',2.23),('8902','2013-03-30','16:45:00',1.86),('8902','2013-03-30','16:50:00',1.71),('8902','2013-03-30','16:55:00',1.48),('8902','2013-03-30','17:00:00',2.36),('8902','2013-03-30','17:05:00',4.67),('8902','2013-03-30','17:10:00',3.74),('8902','2013-03-30','17:15:00',2.26),('8902','2013-03-30','17:20:00',2.06),('8902','2013-03-30','17:25:00',2.3),('8902','2013-03-30','17:30:00',2.45),('8902','2013-03-30','17:35:00',2.38),('8902','2013-03-30','17:40:00',1.6),('8902','2013-03-30','17:45:00',1.58),('8902','2013-03-30','17:50:00',1.71),('8902','2013-03-30','17:55:00',2.71),('8902','2013-03-30','18:00:00',1.65),('8902','2013-03-30','18:15:00',2.24),('8902','2013-03-30','18:20:00',1.51),('8902','2013-03-29','07:30:00',1.04),('8902','2013-03-29','07:50:00',1.23),('8902','2013-03-29','07:55:00',1.7),('8902','2013-03-29','08:00:00',1.35),('8902','2013-03-29','08:05:00',1.17),('8902','2013-03-29','08:10:00',1.19),('8902','2013-03-29','08:15:00',1.56),('8902','2013-03-29','08:20:00',1.57),('8902','2013-03-29','08:25:00',1.63),('8902','2013-03-29','08:30:00',1.66),('8902','2013-03-29','08:35:00',2.02),('8902','2013-03-29','08:40:00',2.03),('8902','2013-03-29','08:45:00',1.71),('8902','2013-03-29','08:50:00',1.67),('8902','2013-03-29','08:55:00',1.43),('8902','2013-03-29','09:00:00',1.49),('8902','2013-03-29','09:05:00',3.23),('8902','2013-03-29','09:10:00',3.01),('8902','2013-03-29','09:15:00',3.34),('8902','2013-03-29','09:20:00',7.19),('8902','2013-03-29','09:25:00',5.39),('8902','2013-03-29','09:30:00',2.48),('8902','2013-03-29','09:35:00',2.97),('8902','2013-03-29','09:40:00',2.55),('8902','2013-03-29','09:45:00',2.28),('8902','2013-03-29','09:50:00',1.8),('8902','2013-03-29','09:55:00',2.23),('8902','2013-03-29','10:00:00',2.89),('8902','2013-03-29','10:05:00',3.09),('8902','2013-03-29','10:10:00',3.43),('8902','2013-03-29','10:15:00',3.19),('8902','2013-03-29','10:20:00',2.72),('8902','2013-03-29','10:25:00',2.62),('8902','2013-03-29','10:30:00',3.03),('8902','2013-03-29','10:35:00',3.66),('8902','2013-03-29','10:40:00',4.75),('8902','2013-03-29','10:45:00',5.99),('8902','2013-03-29','10:50:00',6.84),('8902','2013-03-29','10:55:00',4.28),('8902','2013-03-29','11:00:00',5.51),('8902','2013-03-29','11:05:00',7.19),('8902','2013-03-29','11:10:00',8.96),('8902','2013-03-29','11:15:00',5.51),('8902','2013-03-29','11:20:00',9.34),('8902','2013-03-29','11:25:00',9.4),('8902','2013-03-29','11:30:00',6.43),('8902','2013-03-29','11:35:00',5.77),('8902','2013-03-29','11:40:00',4.13),('8902','2013-03-29','11:45:00',6.67),('8902','2013-03-29','11:50:00',7.43),('8902','2013-03-29','11:55:00',6.2),('8902','2013-03-29','12:00:00',8.77),('8902','2013-03-29','12:05:00',4.84),('8902','2013-03-29','12:10:00',3.72),('8902','2013-03-29','12:15:00',3.64),('8902','2013-03-29','12:20:00',3.56),('8902','2013-03-29','12:25:00',2.32),('8902','2013-03-29','12:30:00',2.18),('8902','2013-03-29','12:35:00',1.96),('8902','2013-03-29','12:40:00',1.12),('8902','2013-03-29','12:45:00',1.57),('8902','2013-03-29','12:50:00',1.74),('8902','2013-03-29','13:05:00',1.19),('8902','2013-03-29','13:10:00',1.77),('8902','2013-03-29','13:15:00',4.3),('8902','2013-03-29','13:20:00',4.37),('8902','2013-03-29','13:25:00',2.66),('8902','2013-03-29','13:30:00',1.54),('8902','2013-03-29','13:35:00',1.24),('8902','2013-03-29','13:40:00',1.22),('8902','2013-03-29','13:45:00',2.05),('8902','2013-03-29','13:50:00',4.04),('8902','2013-03-29','13:55:00',6.41),('8902','2013-03-29','14:00:00',4.64),('8902','2013-03-29','14:05:00',4.93),('8902','2013-03-29','14:10:00',2.25),('8902','2013-03-29','14:15:00',2.96),('8902','2013-03-29','14:20:00',3.95),('8902','2013-03-29','14:25:00',2.69),('8902','2013-03-29','14:30:00',2.8),('8902','2013-03-29','14:35:00',3.24),('8902','2013-03-29','14:40:00',2.13),('8902','2013-03-29','14:45:00',2.27),('8902','2013-03-29','14:50:00',3.04),('8902','2013-03-29','14:55:00',1.94),('8902','2013-03-29','15:00:00',1.65),('8902','2013-03-29','15:05:00',1.31),('8902','2013-03-29','15:10:00',1.22),('8902','2013-03-29','15:15:00',1.26),('8902','2013-03-29','15:20:00',1.66),('8902','2013-03-29','15:25:00',1.66),('8902','2013-03-29','15:30:00',1.3),('8902','2013-03-29','15:35:00',1.15),('8902','2013-03-29','15:40:00',1.52),('8902','2013-03-29','15:45:00',1.32),('8902','2013-03-29','15:50:00',1.34),('8902','2013-03-29','15:55:00',1.16),('8902','2013-03-28','07:10:00',1.14),('8902','2013-03-28','07:15:00',1.32),('8902','2013-03-28','07:20:00',1.51),('8902','2013-03-28','07:25:00',1.75),('8902','2013-03-28','07:30:00',2),('8902','2013-03-28','07:35:00',1.76),('8902','2013-03-28','07:40:00',2.2),('8902','2013-03-28','07:45:00',2.38),('8902','2013-03-28','07:50:00',2.83),('8902','2013-03-28','07:55:00',1.88),('8902','2013-03-28','08:00:00',2.55),('8902','2013-03-28','08:05:00',2.93),('8902','2013-03-28','08:10:00',3.51),('8902','2013-03-28','08:15:00',3.51),('8902','2013-03-28','08:20:00',3.68),('8902','2013-03-28','08:25:00',3.87),('8902','2013-03-28','08:30:00',4.08),('8902','2013-03-28','08:35:00',4.23),('8902','2013-03-28','08:40:00',4.37),('8902','2013-03-28','08:45:00',4.4),('8902','2013-03-28','08:50:00',4.24),('8902','2013-03-28','08:55:00',4.36),('8902','2013-03-28','09:00:00',4.31),('8902','2013-03-28','09:05:00',4.72),('8902','2013-03-28','09:10:00',4.92),('8902','2013-03-28','09:15:00',5.47),('8902','2013-03-28','09:20:00',5.86),('8902','2013-03-28','09:25:00',5.46),('8902','2013-03-28','09:30:00',6.07),('8902','2013-03-28','09:35:00',6.23),('8902','2013-03-28','09:40:00',6),('8902','2013-03-28','09:45:00',5.72),('8902','2013-03-28','09:50:00',5.98),('8902','2013-03-28','09:55:00',6.14),('8902','2013-03-28','10:00:00',6.28),('8902','2013-03-28','10:05:00',5.69),('8902','2013-03-28','10:10:00',5.05),('8902','2013-03-28','10:15:00',6.28),('8902','2013-03-28','10:20:00',5.86),('8902','2013-03-28','10:25:00',5.75),('8902','2013-03-28','10:30:00',5.89),('8902','2013-03-28','10:35:00',6.49),('8902','2013-03-28','10:40:00',5.46),('8902','2013-03-28','10:45:00',4.58),('8902','2013-03-28','10:50:00',6.52),('8902','2013-03-28','10:55:00',6.71),('8902','2013-03-28','11:00:00',7.73),('8902','2013-03-28','11:05:00',7.54),('8902','2013-03-28','11:10:00',8.28),('8902','2013-03-28','11:15:00',7.98),('8902','2013-03-28','11:20:00',4.87),('8902','2013-03-28','11:26:00',4.11),('8902','2013-03-28','11:30:00',7.65),('8902','2013-03-28','11:35:00',6.49),('8902','2013-03-28','11:40:00',8.2),('8902','2013-03-28','11:45:00',8.15),('8902','2013-03-28','11:50:00',8.18),('8902','2013-03-28','11:55:00',8.21),('8902','2013-03-28','12:00:00',8.26),('8902','2013-03-28','12:05:00',8.4),('8902','2013-03-28','12:10:00',8.34),('8902','2013-03-28','12:15:00',7.71),('8902','2013-03-28','12:20:00',8.26),('8902','2013-03-28','12:25:00',8.05),('8902','2013-03-28','12:30:00',7.43),('8902','2013-03-28','12:35:00',7.76),('8902','2013-03-28','12:40:00',7.74),('8902','2013-03-28','12:45:00',6.34),('8902','2013-03-28','12:50:00',6.52),('8902','2013-03-28','12:55:00',6.01),('8902','2013-03-28','13:00:00',6.15),('8902','2013-03-28','13:05:00',4.87),('8902','2013-03-28','13:10:00',7.77),('8902','2013-03-28','13:15:00',6.65),('8902','2013-03-28','13:20:00',6.6),('8902','2013-03-28','13:25:00',8.3),('8902','2013-03-28','13:30:00',7.44),('8902','2013-03-28','13:35:00',6.34),('8902','2013-03-28','13:40:00',6.41),('8902','2013-03-28','13:45:00',6.77),('8902','2013-03-28','13:50:00',6.5),('8902','2013-03-28','13:55:00',6.68),('8902','2013-03-28','14:00:00',6.52),('8902','2013-03-28','14:05:00',5.93),('8902','2013-03-28','14:10:00',4.45),('8902','2013-03-28','14:15:00',4.71),('8902','2013-03-28','14:20:00',4.78),('8902','2013-03-28','14:25:00',4.85),('8902','2013-03-28','14:30:00',4.1),('8902','2013-03-28','14:35:00',4.09),('8902','2013-03-28','14:40:00',3.86),('8902','2013-03-28','14:45:00',3.59),('8902','2013-03-28','14:50:00',3.4),('8902','2013-03-28','14:55:00',3.29),('8902','2013-03-28','15:00:00',2.92),('8902','2013-03-28','15:05:00',2.99),('8902','2013-03-28','15:10:00',2.83),('8902','2013-03-28','15:15:00',2.74),('8902','2013-03-28','15:20:00',2.63),('8902','2013-03-28','15:25:00',2.34),('8902','2013-03-28','15:30:00',2.14),('8902','2013-03-28','15:35:00',2.04),('8902','2013-03-28','15:40:00',1.96),('8902','2013-03-28','15:45:00',1.9),('8902','2013-03-28','15:50:00',2.01),('8902','2013-03-28','15:55:00',2.34),('8902','2013-03-28','16:00:00',3.1),('8902','2013-03-28','16:05:00',2.84),('8902','2013-03-28','16:10:00',2.25),('8902','2013-03-28','16:15:00',1.86),('8902','2013-03-28','16:20:00',1.7),('8902','2013-03-28','16:25:00',1.86),('8902','2013-03-28','16:30:00',2.2),('8902','2013-03-28','16:35:00',1.96),('8902','2013-03-28','16:40:00',3.95),('8902','2013-03-28','16:45:00',3.27),('8902','2013-03-28','16:50:00',2.38),('8902','2013-03-28','16:55:00',1.8),('8902','2013-03-28','17:00:00',2.13),('8902','2013-03-28','17:05:00',1.77),('8902','2013-03-28','17:10:00',1.04),('8902','2013-03-28','17:15:00',1.04),('8902','2013-03-28','17:20:00',1.58),('8902','2013-03-28','17:25:00',1.63),('8902','2013-03-28','17:30:00',1.42),('8902','2013-03-28','17:35:00',1.14),('8902','2013-03-27','07:40:00',1.03),('8902','2013-03-27','07:45:00',1.05),('8902','2013-03-27','08:45:00',1.01),('8902','2013-03-27','08:50:00',1.11),('8902','2013-03-27','08:55:00',1.32),('8902','2013-03-27','09:00:00',1.42),('8902','2013-03-27','09:05:00',1.97),('8902','2013-03-27','09:10:00',3.18),('8902','2013-03-27','09:15:00',6.25),('8902','2013-03-27','09:20:00',2.96),('8902','2013-03-27','09:25:00',2.83),('8902','2013-03-27','09:30:00',2.09),('8902','2013-03-27','09:35:00',1.82),('8902','2013-03-27','09:40:00',1.54),('8902','2013-03-27','09:45:00',1.81),('8902','2013-03-27','09:50:00',1.95),('8902','2013-03-27','09:55:00',2.06),('8902','2013-03-27','10:00:00',2.22),('8902','2013-03-27','10:05:00',1.65),('8902','2013-03-27','10:10:00',1.16),('8902','2013-03-27','10:15:00',1.2),('8902','2013-03-27','10:25:00',1.02),('8902','2013-03-27','10:30:00',1.07),('8902','2013-03-27','10:35:00',1.02),('8902','2013-03-27','10:55:00',1.4),('8902','2013-03-27','11:00:00',2.08),('8902','2013-03-27','11:05:00',1.58),('8902','2013-03-27','11:10:00',1.12),('8902','2013-03-27','11:20:00',1.07),('8902','2013-03-27','11:25:00',1.37),('8902','2013-03-27','11:30:00',1.7),('8902','2013-03-27','11:35:00',2.63),('8902','2013-03-27','11:40:00',3.5),('8902','2013-03-27','11:45:00',2.53),('8902','2013-03-27','11:50:00',2.49),('8902','2013-03-27','11:55:00',4.11),('8902','2013-03-27','12:00:00',3.41),('8902','2013-03-27','12:05:00',2.39),('8902','2013-03-27','12:10:00',2.36),('8902','2013-03-27','12:15:00',2.32),('8902','2013-03-27','12:20:00',2.4),('8902','2013-03-27','12:25:00',2.19),('8902','2013-03-27','12:30:00',2.03),('8902','2013-03-27','12:35:00',1.75),('8902','2013-03-27','12:40:00',2.36),('8902','2013-03-27','12:45:00',3.1),('8902','2013-03-27','12:50:00',6.03),('8902','2013-03-27','12:55:00',6.22),('8902','2013-03-27','13:00:00',6.15),('8902','2013-03-27','13:05:00',6.86),('8902','2013-03-27','13:10:00',6.79),('8902','2013-03-27','13:15:00',7.54),('8902','2013-03-27','13:20:00',7.11),('8902','2013-03-27','13:25:00',7.17),('8902','2013-03-27','13:30:00',6.25),('8902','2013-03-27','13:35:00',5.29),('8902','2013-03-27','13:40:00',4.6),('8902','2013-03-27','13:45:00',3.68),('8902','2013-03-27','13:50:00',5.56),('8902','2013-03-27','13:55:00',3.56),('8902','2013-03-27','14:00:00',3.75),('8902','2013-03-27','14:05:00',4.32),('8902','2013-03-27','14:10:00',3.22),('8902','2013-03-27','14:15:00',2.93),('8902','2013-03-27','14:20:00',2.83),('8902','2013-03-27','14:25:00',3.7),('8902','2013-03-27','14:30:00',3.79),('8902','2013-03-27','14:35:00',3.32),('8902','2013-03-27','14:40:00',2.52),('8902','2013-03-27','14:45:00',2.42),('8902','2013-03-27','14:50:00',2.14),('8902','2013-03-27','14:55:00',1.71),('8902','2013-03-27','15:00:00',2.2),('8902','2013-03-27','15:05:00',2.51),('8902','2013-03-27','15:10:00',4.04),('8902','2013-03-27','15:15:00',4.03),('8902','2013-03-27','15:20:00',4.42),('8902','2013-03-27','15:25:00',4.23),('8902','2013-03-27','15:30:00',2.89),('8902','2013-03-27','15:35:00',4.98),('8902','2013-03-27','15:40:00',3.66),('8902','2013-03-27','15:45:00',3.85),('8902','2013-03-27','15:50:00',2.56),('8902','2013-03-27','15:55:00',5.03),('8902','2013-03-27','16:00:00',2.98),('8902','2013-03-27','16:05:00',1.58),('8902','2013-03-27','16:10:00',3.88),('8902','2013-03-27','16:15:00',1.57),('8902','2013-03-27','16:25:00',1.29),('8902','2013-03-27','16:30:00',1.57),('8902','2013-03-27','16:35:00',3.34),('8902','2013-03-27','16:40:00',1.86),('8902','2013-03-27','16:45:00',2.25),('8902','2013-03-27','16:50:00',1.21),('8902','2013-03-27','16:55:00',1.26),('8902','2013-03-27','17:00:00',2.76),('8902','2013-03-27','17:05:00',2.44),('8902','2013-03-27','17:10:00',2.06),('8902','2013-03-27','17:15:00',1.75),('8902','2013-03-27','17:20:00',1.45),('8902','2013-03-27','17:25:00',1.18),('8902','2013-03-26','07:10:00',1.11),('8902','2013-03-26','07:15:00',1.27),('8902','2013-03-26','07:20:00',1.46),('8902','2013-03-26','07:25:00',1.62),('8902','2013-03-26','07:30:00',1.78),('8902','2013-03-26','07:35:00',1.87),('8902','2013-03-26','07:40:00',1.99),('8902','2013-03-26','07:45:00',1.26),('8902','2013-03-26','07:50:00',1.15),('8902','2013-03-26','07:55:00',2.23),('8902','2013-03-26','08:00:00',2.34),('8902','2013-03-26','08:05:00',2.74),('8902','2013-03-26','08:10:00',2.37),('8902','2013-03-26','08:15:00',2.66),('8902','2013-03-26','08:20:00',2.36),('8902','2013-03-26','08:25:00',2.6),('8902','2013-03-26','08:30:00',3.58),('8902','2013-03-26','08:35:00',3.21),('8902','2013-03-26','08:40:00',2.51),('8902','2013-03-26','08:45:00',2.3),('8902','2013-03-26','08:50:00',2.47),('8902','2013-03-26','08:55:00',2.62),('8902','2013-03-26','09:00:00',2.5),('8902','2013-03-26','09:05:00',2.17),('8902','2013-03-26','09:10:00',1.71),('8902','2013-03-26','09:15:00',3.49),('8902','2013-03-26','09:20:00',4.02),('8902','2013-03-26','09:25:00',2.75),('8902','2013-03-26','09:30:00',2.04),('8902','2013-03-26','09:35:00',1.64),('8902','2013-03-26','09:40:00',1.88),('8902','2013-03-26','09:45:00',3.36),('8902','2013-03-26','09:50:00',5.05),('8902','2013-03-26','09:55:00',3.38),('8902','2013-03-26','10:00:00',3.43),('8902','2013-03-26','10:05:00',2.25),('8902','2013-03-26','10:10:00',2.85),('8902','2013-03-26','10:15:00',3.37),('8902','2013-03-26','10:20:00',3.03),('8902','2013-03-26','10:25:00',3.45),('8902','2013-03-26','10:30:00',4.01),('8902','2013-03-26','10:35:00',3.05),('8902','2013-03-26','10:40:00',3.31),('8902','2013-03-26','10:45:00',4.04),('8902','2013-03-26','10:50:00',3.52),('8902','2013-03-26','10:55:00',3.61),('8902','2013-03-26','11:00:00',2.87),('8902','2013-03-26','11:05:00',3),('8902','2013-03-26','11:10:00',3.31),('8902','2013-03-26','11:15:00',3.46),('8902','2013-03-26','11:20:00',3.56),('8902','2013-03-26','11:25:00',3.32),('8902','2013-03-26','11:30:00',3.72),('8902','2013-03-26','11:35:00',3.52),('8902','2013-03-26','11:40:00',3.46),('8902','2013-03-26','11:45:00',3.35),('8902','2013-03-26','11:50:00',3.28),('8902','2013-03-26','11:55:00',4.81),('8902','2013-03-26','12:00:00',5.82),('8902','2013-03-26','12:05:00',5.76),('8902','2013-03-26','12:10:00',5.26),('8902','2013-03-26','12:15:00',3.62),('8902','2013-03-26','12:20:00',3.91),('8902','2013-03-26','12:25:00',3.17),('8902','2013-03-26','12:30:00',5.64),('8902','2013-03-26','12:35:00',8.21),('8902','2013-03-26','12:40:00',9.2),('8902','2013-03-26','12:45:00',8.57),('8902','2013-03-26','12:50:00',6.54),('8902','2013-03-26','12:55:00',5.25),('8902','2013-03-26','13:00:00',3.01),('8902','2013-03-26','13:05:00',5.19),('8902','2013-03-26','13:10:00',5.24),('8902','2013-03-26','13:15:00',3.64),('8902','2013-03-26','13:20:00',2.82),('8902','2013-03-26','13:25:00',2.64),('8902','2013-03-26','13:30:00',4.33),('8902','2013-03-26','13:35:00',4.62),('8902','2013-03-26','13:40:00',3.79),('8902','2013-03-26','13:45:00',4.42),('8902','2013-03-26','13:50:00',5.3),('8902','2013-03-26','13:55:00',5.08),('8902','2013-03-26','14:00:00',3.66),('8902','2013-03-26','14:05:00',2.91),('8902','2013-03-26','14:10:00',3.09),('8902','2013-03-26','14:15:00',3.49),('8902','2013-03-26','14:20:00',4.06),('8902','2013-03-26','14:25:00',3.5),('8902','2013-03-26','14:30:00',2.87),('8902','2013-03-26','14:35:00',3.13),('8902','2013-03-26','14:40:00',4.46),('8902','2013-03-26','14:45:00',4.59),('8902','2013-03-26','14:50:00',3.05),('8902','2013-03-26','14:55:00',2.51),('8902','2013-03-26','15:00:00',2.15),('8902','2013-03-26','15:05:00',2.66),('8902','2013-03-26','15:10:00',3.05),('8902','2013-03-26','15:15:00',2.01),('8902','2013-03-26','15:20:00',1.97),('8902','2013-03-26','15:25:00',2.04),('8902','2013-03-26','15:30:00',1.48),('8902','2013-03-26','15:35:00',1.34),('8902','2013-03-26','15:40:00',1.09),('8902','2013-03-26','15:55:00',1.13),('8902','2013-03-26','16:00:00',1.16),('8902','2013-03-26','16:05:00',1.25),('8902','2013-03-26','16:10:00',1.43),('8902','2013-03-26','16:15:00',1.46),('8902','2013-03-26','16:20:00',1.37),('8902','2013-03-26','16:25:00',1.46),('8902','2013-03-26','16:30:00',1.49),('8902','2013-03-26','16:35:00',1.5),('8902','2013-03-26','16:40:00',1.77),('8902','2013-03-26','16:45:00',2.12),('8902','2013-03-26','16:50:00',1.87),('8902','2013-03-26','16:55:00',2.16),('8902','2013-03-26','17:00:00',2.19),('8902','2013-03-26','17:05:00',2.57),('8902','2013-03-26','17:10:00',2.31),('8902','2013-03-26','17:15:00',1.39),('8902','2013-03-25','07:15:00',1.02),('8902','2013-03-25','07:20:00',1.04),('8902','2013-03-25','07:35:00',1.05),('8902','2013-03-25','07:40:00',1.32),('8902','2013-03-25','07:45:00',1.8),('8902','2013-03-25','07:50:00',3.1),('8902','2013-03-25','07:55:00',3.41),('8902','2013-03-25','08:00:00',1.25),('8902','2013-03-25','08:05:00',1.03),('8902','2013-03-25','08:10:00',1.23),('8902','2013-03-25','08:15:00',1.22),('8902','2013-03-25','08:20:00',1.18),('8902','2013-03-25','08:25:00',1.25),('8902','2013-03-25','08:30:00',1.61),('8902','2013-03-25','08:35:00',2.49),('8902','2013-03-25','08:40:00',2.75),('8902','2013-03-25','08:45:00',1.65),('8902','2013-03-25','08:50:00',1.09),('8902','2013-03-25','08:55:00',1.05),('8902','2013-03-25','09:05:00',1.26),('8902','2013-03-25','09:10:00',1.83),('8902','2013-03-25','09:15:00',2.96),('8902','2013-03-25','09:20:00',2.05),('8902','2013-03-25','09:25:00',1.16),('8902','2013-03-25','09:50:00',1.32),('8902','2013-03-25','09:55:00',4.31),('8902','2013-03-25','10:00:00',2.66),('8902','2013-03-25','10:05:00',1.01),('8902','2013-03-25','10:10:00',1.33),('8902','2013-03-25','10:25:00',1.28),('8902','2013-03-25','10:40:00',1.09),('8902','2013-03-25','10:45:00',1.07),('8902','2013-03-25','10:50:00',1.62),('8902','2013-03-25','10:55:00',1.56),('8902','2013-03-25','11:00:00',1.97),('8902','2013-03-25','11:05:00',2.05),('8902','2013-03-25','11:10:00',4.39),('8902','2013-03-25','11:15:00',4.26),('8902','2013-03-25','11:20:00',3.65),('8902','2013-03-25','11:25:00',1.97),('8902','2013-03-25','11:30:00',1.4),('8902','2013-03-25','11:45:00',1.51),('8902','2013-03-25','11:50:00',3.43),('8902','2013-03-25','11:55:00',1.99),('8902','2013-03-25','12:00:00',1.81),('8902','2013-03-25','12:05:00',2.18),('8902','2013-03-25','12:10:00',2.35),('8902','2013-03-25','12:15:00',2.61),('8902','2013-03-25','12:20:00',2.75),('8902','2013-03-25','12:25:00',4.06),('8902','2013-03-25','12:30:00',3.59),('8902','2013-03-25','12:35:00',5.68),('8902','2013-03-25','12:40:00',4.21),('8902','2013-03-25','12:45:00',5.17),('8902','2013-03-25','12:50:00',3.7),('8902','2013-03-25','12:55:00',2.01),('8902','2013-03-25','13:00:00',2.87),('8902','2013-03-25','13:05:00',4.62),('8902','2013-03-25','13:10:00',4.82),('8902','2013-03-25','13:15:00',3.78),('8902','2013-03-25','13:20:00',2.53),('8902','2013-03-25','13:25:00',3.91),('8902','2013-03-25','13:30:00',3.17),('8902','2013-03-25','13:35:00',3.29),('8902','2013-03-25','13:40:00',4.06),('8902','2013-03-25','13:45:00',3.65),('8902','2013-03-25','13:50:00',3.21),('8902','2013-03-25','13:55:00',3.01),('8902','2013-03-25','14:00:00',2.91),('8902','2013-03-25','14:05:00',2.74),('8902','2013-03-25','14:10:00',2.77),('8902','2013-03-25','14:15:00',2.57),('8902','2013-03-25','14:20:00',2.26),('8902','2013-03-25','14:25:00',1.96),('8902','2013-03-25','14:30:00',1.68),('8902','2013-03-25','14:35:00',1.53),('8902','2013-03-25','14:40:00',1.61),('8902','2013-03-25','14:45:00',1.68),('8902','2013-03-25','14:50:00',1.5),('8902','2013-03-25','14:55:00',1.49),('8902','2013-03-25','15:00:00',1.46),('8902','2013-03-25','15:05:00',1.53),('8902','2013-03-25','15:10:00',1.53),('8902','2013-03-25','15:15:00',1.34),('8902','2013-03-25','15:20:00',1.47),('8902','2013-03-25','15:25:00',1.46),('8902','2013-03-25','15:30:00',1.59),('8902','2013-03-25','15:35:00',1.75),('8902','2013-03-25','15:40:00',1.54),('8902','2013-03-25','15:45:00',1.03),('8902','2013-03-25','15:50:00',1.07),('8902','2013-03-24','08:10:00',1.02),('8902','2013-03-24','08:15:00',1.59),('8902','2013-03-24','08:20:00',2.67),('8902','2013-03-24','08:25:00',2.85),('8902','2013-03-24','08:30:00',2.86),('8902','2013-03-24','08:35:00',1.03),('8902','2013-03-24','08:40:00',1.16),('8902','2013-03-24','08:45:00',1.9),('8902','2013-03-24','08:50:00',1.67),('8902','2013-03-24','08:55:00',2.03),('8902','2013-03-24','09:00:00',2.12),('8902','2013-03-24','09:05:00',2.01),('8902','2013-03-24','09:10:00',1.98),('8902','2013-03-24','09:15:00',1.92),('8902','2013-03-24','09:20:00',4.62),('8902','2013-03-24','09:25:00',5.84),('8902','2013-03-24','09:30:00',2.56),('8902','2013-03-24','09:35:00',1.75),('8902','2013-03-24','09:40:00',1.26),('8902','2013-03-24','09:45:00',1.38),('8902','2013-03-24','09:50:00',5.47),('8902','2013-03-24','09:55:00',6.6),('8902','2013-03-24','10:00:00',7.19),('8902','2013-03-24','10:05:00',3.55),('8902','2013-03-24','10:10:00',1.64),('8902','2013-03-24','10:15:00',1.87),('8902','2013-03-24','10:20:00',2.91),('8902','2013-03-24','10:25:00',4.45),('8902','2013-03-24','10:30:00',4.49),('8902','2013-03-24','10:35:00',2.91),('8902','2013-03-24','10:40:00',3.11),('8902','2013-03-24','10:45:00',4.45),('8902','2013-03-24','10:50:00',4.59),('8902','2013-03-24','10:55:00',4.16),('8902','2013-03-24','11:00:00',4.19),('8902','2013-03-24','11:05:00',3.41),('8902','2013-03-24','11:10:00',3.89),('8902','2013-03-24','11:15:00',5.32),('8902','2013-03-24','11:20:00',8.23),('8902','2013-03-24','11:25:00',6.76),('8902','2013-03-24','11:30:00',5.34),('8902','2013-03-24','11:35:00',6.62),('8902','2013-03-24','11:40:00',3.09),('8902','2013-03-24','11:45:00',3.26),('8902','2013-03-24','11:50:00',4),('8902','2013-03-24','11:55:00',6.42),('8902','2013-03-24','12:00:00',7.15),('8902','2013-03-24','12:05:00',6.16),('8902','2013-03-24','12:10:00',9.97),('8902','2013-03-24','12:15:00',7.22),('8902','2013-03-24','12:20:00',4.61),('8902','2013-03-24','12:25:00',6.69),('8902','2013-03-24','12:30:00',8.06),('8902','2013-03-24','12:35:00',6),('8902','2013-03-24','12:40:00',4.77),('8902','2013-03-24','12:45:00',4.88),('8902','2013-03-24','12:50:00',6.16),('8902','2013-03-24','12:55:00',4.8),('8902','2013-03-24','13:00:00',4.68),('8902','2013-03-24','13:05:00',9.1),('8902','2013-03-24','13:10:00',8.69),('8902','2013-03-24','13:15:00',5.36),('8902','2013-03-24','13:20:00',8.43),('8902','2013-03-24','13:25:00',4.28),('8902','2013-03-24','13:30:00',5.46),('8902','2013-03-24','13:35:00',2.31),('8902','2013-03-24','13:40:00',2.28),('8902','2013-03-24','13:45:00',3.19),('8902','2013-03-24','13:50:00',4.28),('8902','2013-03-24','13:55:00',3.71),('8902','2013-03-24','14:00:00',2.08),('8902','2013-03-24','14:05:00',2.01),('8902','2013-03-24','14:10:00',4.15),('8902','2013-03-24','14:15:00',4.01),('8902','2013-03-24','14:20:00',4.55),('8902','2013-03-24','14:25:00',9.24),('8902','2013-03-24','14:30:00',6.62),('8902','2013-03-24','14:35:00',4.79),('8902','2013-03-24','14:40:00',3.2),('8902','2013-03-24','14:45:00',3.18),('8902','2013-03-24','14:50:00',3.09),('8902','2013-03-24','14:55:00',4.34),('8902','2013-03-24','15:00:00',4.34),('8902','2013-03-24','15:05:00',4.82),('8902','2013-03-24','15:10:00',5.23),('8902','2013-03-24','15:15:00',4.73),('8902','2013-03-24','15:20:00',3.91),('8902','2013-03-24','15:25:00',5.93),('8902','2013-03-24','15:30:00',4.25),('8902','2013-03-24','15:35:00',4.81),('8902','2013-03-24','15:40:00',6.39),('8902','2013-03-24','15:45:00',4.63),('8902','2013-03-24','15:50:00',2.38),('8902','2013-03-24','15:55:00',1.91),('8902','2013-03-24','16:00:00',4.6),('8902','2013-03-24','16:05:00',2.47),('8902','2013-03-24','16:10:00',2.33),('8902','2013-03-24','16:15:00',2.56),('8902','2013-03-24','16:20:00',1.54),('8902','2013-03-24','16:25:00',1.12),('8902','2013-03-24','16:30:00',1.94),('8902','2013-03-24','16:35:00',3.47),('8902','2013-03-24','16:40:00',3.95),('8902','2013-03-24','16:45:00',2.22),('8902','2013-03-24','16:50:00',1.34),('8902','2013-03-24','16:55:00',1.08),('8902','2013-03-23','07:20:00',1.27),('8902','2013-03-23','07:25:00',1.35),('8902','2013-03-23','07:30:00',1.34),('8902','2013-03-23','07:35:00',1.49),('8902','2013-03-23','07:40:00',1.57),('8902','2013-03-23','07:45:00',1.74),('8902','2013-03-23','07:50:00',2),('8902','2013-03-23','07:55:00',2.32),('8902','2013-03-23','08:00:00',2.74),('8902','2013-03-23','08:05:00',2.92),('8902','2013-03-23','08:10:00',3.04),('8902','2013-03-23','08:15:00',3.28),('8902','2013-03-23','08:20:00',3.47),('8902','2013-03-23','08:25:00',3.66),('8902','2013-03-23','08:30:00',3.82),('8902','2013-03-23','08:35:00',3.95),('8902','2013-03-23','08:40:00',4.11),('8902','2013-03-23','08:45:00',4.25),('8902','2013-03-23','08:50:00',4.34),('8902','2013-03-23','08:55:00',4.48),('8902','2013-03-23','09:00:00',4.62),('8902','2013-03-23','09:05:00',4.81),('8902','2013-03-23','09:10:00',4.96),('8902','2013-03-23','09:15:00',5.06),('8902','2013-03-23','09:20:00',5.19),('8902','2013-03-23','09:25:00',5.34),('8902','2013-03-23','09:30:00',5.44),('8902','2013-03-23','09:35:00',5.56),('8902','2013-03-23','09:40:00',5.63),('8902','2013-03-23','09:45:00',5.76),('8902','2013-03-23','09:50:00',5.92),('8902','2013-03-23','09:55:00',6.02),('8902','2013-03-23','10:00:00',6.14),('8902','2013-03-23','10:05:00',6.28),('8902','2013-03-23','10:10:00',6.4),('8902','2013-03-23','10:15:00',6.49),('8902','2013-03-23','10:20:00',6.54),('8902','2013-03-23','10:25:00',6.61),('8902','2013-03-23','10:30:00',6.68),('8902','2013-03-23','10:35:00',6.73),('8902','2013-03-23','10:40:00',6.81),('8902','2013-03-23','10:45:00',6.86),('8902','2013-03-23','10:50:00',6.89),('8902','2013-03-23','10:55:00',6.95),('8902','2013-03-23','11:00:00',6.98),('8902','2013-03-23','11:05:00',7.05),('8902','2013-03-23','11:10:00',7.11),('8902','2013-03-23','11:15:00',7.15),('8902','2013-03-23','11:20:00',7.15),('8902','2013-03-23','11:25:00',7.19),('8902','2013-03-23','11:30:00',7.22),('8902','2013-03-23','11:35:00',7.24),('8902','2013-03-23','11:40:00',7.29),('8902','2013-03-23','11:45:00',7.35),('8902','2013-03-23','11:50:00',7.39),('8902','2013-03-23','11:55:00',7.44),('8902','2013-03-23','12:00:00',7.49),('8902','2013-03-23','12:05:00',7.48),('8902','2013-03-23','12:10:00',7.59),('8902','2013-03-23','12:15:00',7.7),('8902','2013-03-23','12:20:00',7.85),('8902','2013-03-23','12:25:00',7.92),('8902','2013-03-23','12:30:00',7.92),('8902','2013-03-23','12:35:00',8.01),('8902','2013-03-23','12:40:00',7.97),('8902','2013-03-23','12:45:00',7.96),('8902','2013-03-23','12:50:00',7.98),('8902','2013-03-23','12:55:00',7.86),('8902','2013-03-23','13:00:00',7.82),('8902','2013-03-23','13:05:00',7.86),('8902','2013-03-23','13:10:00',7.83),('8902','2013-03-23','13:15:00',7.82),('8902','2013-03-23','13:20:00',7.78),('8902','2013-03-23','13:25:00',7.62),('8902','2013-03-23','13:30:00',7.53),('8902','2013-03-23','13:35:00',7.55),('8902','2013-03-23','13:40:00',7.55),('8902','2013-03-23','13:45:00',7.52),('8902','2013-03-23','13:50:00',7.46),('8902','2013-03-23','13:55:00',7.36),('8902','2013-03-23','14:00:00',7.28),('8902','2013-03-23','14:05:00',7.2),('8902','2013-03-23','14:10:00',7.07),('8902','2013-03-23','14:15:00',7),('8902','2013-03-23','14:20:00',6.9),('8902','2013-03-23','14:25:00',6.79),('8902','2013-03-23','14:30:00',6.62),('8902','2013-03-23','14:35:00',6.39),('8902','2013-03-23','14:40:00',6.32),('8902','2013-03-23','14:45:00',6.27),('8902','2013-03-23','14:50:00',6.01),('8902','2013-03-23','14:55:00',5.91),('8902','2013-03-23','15:00:00',5.78),('8902','2013-03-23','15:05:00',5.68),('8902','2013-03-23','15:10:00',5.42),('8902','2013-03-23','15:15:00',5.78),('8902','2013-03-23','15:20:00',5.6),('8902','2013-03-23','15:25:00',5.2),('8902','2013-03-23','15:30:00',4.64),('8902','2013-03-23','15:35:00',4.68),('8902','2013-03-23','15:40:00',4.65),('8902','2013-03-23','15:45:00',3.78),('8902','2013-03-23','15:50:00',2.76),('8902','2013-03-23','15:55:00',2.57),('8902','2013-03-23','16:00:00',2.42),('8902','2013-03-23','16:05:00',2.89),('8902','2013-03-23','16:10:00',2.02),('8902','2013-03-23','16:15:00',2.81),('8902','2013-03-23','16:20:00',2.19),('8902','2013-03-23','16:25:00',2.04),('8902','2013-03-23','16:30:00',2.27),('8902','2013-03-23','16:35:00',2.06),('8902','2013-03-23','16:40:00',1.6),('8902','2013-03-23','16:45:00',1.5),('8902','2013-03-23','16:50:00',1.23),('8902','2013-03-22','07:15:00',1.17),('8902','2013-03-22','07:20:00',1.34),('8902','2013-03-22','07:25:00',1.43),('8902','2013-03-22','07:30:00',1.52),('8902','2013-03-22','07:35:00',1.62),('8902','2013-03-22','07:40:00',1.85),('8902','2013-03-22','07:45:00',1.89),('8902','2013-03-22','07:50:00',2.09),('8902','2013-03-22','07:55:00',2.38),('8902','2013-03-22','08:00:00',2.65),('8902','2013-03-22','08:05:00',2.94),('8902','2013-03-22','08:10:00',3.11),('8902','2013-03-22','08:15:00',3.29),('8902','2013-03-22','08:20:00',3.48),('8902','2013-03-22','08:25:00',3.64),('8902','2013-03-22','08:30:00',3.75),('8902','2013-03-22','08:35:00',3.93),('8902','2013-03-22','08:40:00',4.13),('8902','2013-03-22','08:45:00',4.33),('8902','2013-03-22','08:50:00',4.49),('8902','2013-03-22','08:55:00',4.75),('8902','2013-03-22','09:00:00',4.87),('8902','2013-03-22','09:05:00',5.06),('8902','2013-03-22','09:10:00',5.13),('8902','2013-03-22','09:15:00',5.26),('8902','2013-03-22','09:20:00',5.4),('8902','2013-03-22','09:25:00',5.6),('8902','2013-03-22','09:30:00',5.67),('8902','2013-03-22','09:35:00',5.73),('8902','2013-03-22','09:40:00',5.65),('8902','2013-03-22','09:45:00',5.88),('8902','2013-03-22','09:50:00',5.84),('8902','2013-03-22','09:55:00',6.04),('8902','2013-03-22','10:00:00',5.97),('8902','2013-03-22','10:05:00',6.22),('8902','2013-03-22','10:10:00',6.6),('8902','2013-03-22','10:15:00',6.6),('8902','2013-03-22','10:20:00',6.47),('8902','2013-03-22','10:25:00',6.49),('8902','2013-03-22','10:30:00',6.91),('8902','2013-03-22','10:35:00',6.9),('8902','2013-03-22','10:40:00',6.94),('8902','2013-03-22','10:45:00',6.93),('8902','2013-03-22','10:50:00',7),('8902','2013-03-22','10:55:00',6.75),('8902','2013-03-22','11:00:00',6.62),('8902','2013-03-22','11:05:00',6.53),('8902','2013-03-22','11:10:00',5.24),('8902','2013-03-22','11:15:00',5.52),('8902','2013-03-22','11:20:00',7.12),('8902','2013-03-22','11:25:00',7),('8902','2013-03-22','11:30:00',6.95),('8902','2013-03-22','11:35:00',7.34),('8902','2013-03-22','11:40:00',7.46),('8902','2013-03-22','11:45:00',7.42),('8902','2013-03-22','11:50:00',7.19),('8902','2013-03-22','11:55:00',7.53),('8902','2013-03-22','12:00:00',7.57),('8902','2013-03-22','12:05:00',7.53),('8902','2013-03-22','12:10:00',7.46),('8902','2013-03-22','12:15:00',7.62),('8902','2013-03-22','12:20:00',7.71),('8902','2013-03-22','12:25:00',7.6),('8902','2013-03-22','12:30:00',7.8),('8902','2013-03-22','12:35:00',7.83),('8902','2013-03-22','12:40:00',7.48),('8902','2013-03-22','12:45:00',7.55),('8902','2013-03-22','12:50:00',7.74),('8902','2013-03-22','12:55:00',7.62),('8902','2013-03-22','13:00:00',6.01),('8902','2013-03-22','13:05:00',7.68),('8902','2013-03-22','13:10:00',7.64),('8902','2013-03-22','13:15:00',7.28),('8902','2013-03-22','13:20:00',7.37),('8902','2013-03-22','13:25:00',7.46),('8902','2013-03-22','13:30:00',7.11),('8902','2013-03-22','13:35:00',5.99),('8902','2013-03-22','13:40:00',6.05),('8902','2013-03-22','13:45:00',7.17),('8902','2013-03-22','13:50:00',7.06),('8902','2013-03-22','13:55:00',7.1),('8902','2013-03-22','14:00:00',6.96),('8902','2013-03-22','14:05:00',7.04),('8902','2013-03-22','14:10:00',6.82),('8902','2013-03-22','14:15:00',6.63),('8902','2013-03-22','14:20:00',6.81),('8902','2013-03-22','14:25:00',6.74),('8902','2013-03-22','14:30:00',6.74),('8902','2013-03-22','14:35:00',6.56),('8902','2013-03-22','14:40:00',6.41),('8902','2013-03-22','14:45:00',6.02),('8902','2013-03-22','14:50:00',5.94),('8902','2013-03-22','14:55:00',6),('8902','2013-03-22','15:00:00',5.78),('8902','2013-03-22','15:05:00',5.43),('8902','2013-03-22','15:10:00',5.7),('8902','2013-03-22','15:15:00',5.32),('8902','2013-03-22','15:20:00',5.35),('8902','2013-03-22','15:25:00',5.31),('8902','2013-03-22','15:30:00',4.86),('8902','2013-03-22','15:35:00',4.84),('8902','2013-03-22','15:40:00',4.49),('8902','2013-03-22','15:45:00',4.21),('8902','2013-03-22','15:50:00',3.92),('8902','2013-03-22','15:55:00',3.86),('8902','2013-03-22','16:00:00',3.6),('8902','2013-03-22','16:05:00',3.12),('8902','2013-03-22','16:10:00',4.07),('8902','2013-03-22','16:15:00',3.65),('8902','2013-03-22','16:20:00',3.13),('8902','2013-03-22','16:25:00',3.21),('8902','2013-03-22','16:30:00',2.41),('8902','2013-03-22','16:35:00',2.58),('8902','2013-03-22','16:40:00',2.25),('8902','2013-03-22','16:45:00',2.28),('8902','2013-03-22','16:50:00',1.88),('8902','2013-03-22','16:55:00',1.84),('8902','2013-03-22','17:00:00',2.11),('8902','2013-03-22','17:05:00',2.19),('8902','2013-03-22','17:10:00',1.85),('8902','2013-03-22','17:15:00',1.48),('8902','2013-03-22','17:20:00',1.31),('8902','2013-03-22','17:25:00',1.18),('8902','2014-03-25','07:10:00',1.04),('8902','2014-03-25','07:15:00',1.24),('8902','2014-03-25','07:20:00',1.42),('8902','2014-03-25','07:25:00',1.63),('8902','2014-03-25','07:30:00',1.8),('8902','2014-03-25','07:35:00',1.98),('8902','2014-03-25','07:40:00',2.16),('8902','2014-03-25','07:45:00',2.31),('8902','2014-03-25','07:50:00',2.5),('8902','2014-03-25','07:55:00',2.66),('8902','2014-03-25','08:00:00',2.88),('8902','2014-03-25','08:05:00',3.09),('8902','2014-03-25','08:10:00',3.37),('8902','2014-03-25','08:15:00',3.77),('8902','2014-03-25','08:20:00',4.12),('8902','2014-03-25','08:25:00',2.4),('8902','2014-03-25','08:30:00',2.13),('8902','2014-03-25','08:35:00',1.76),('8902','2014-03-25','08:40:00',2.02),('8902','2014-03-25','08:45:00',2.27),('8902','2014-03-25','08:50:00',2.71),('8902','2014-03-25','08:55:00',2.45),('8902','2014-03-25','09:00:00',2.61),('8902','2014-03-25','09:05:00',2.57),('8902','2014-03-25','09:10:00',2.98),('8902','2014-03-25','09:15:00',2.5),('8902','2014-03-25','09:20:00',2.15),('8902','2014-03-25','09:25:00',2.54),('8902','2014-03-25','09:30:00',6.4),('8902','2014-03-25','09:35:00',6.23),('8902','2014-03-25','09:40:00',6.28),('8902','2014-03-25','09:45:00',6.38),('8902','2014-03-25','09:50:00',6.51),('8902','2014-03-25','09:55:00',6.74),('8902','2014-03-25','10:00:00',5.88),('8902','2014-03-25','10:05:00',6.78),('8902','2014-03-25','10:10:00',7.01),('8902','2014-03-25','10:15:00',7.57),('8902','2014-03-25','10:20:00',7.8),('8902','2014-03-25','10:25:00',7.79),('8902','2014-03-25','10:30:00',7.18),('8902','2014-03-25','10:35:00',6.52),('8902','2014-03-25','10:40:00',2.24),('8902','2014-03-25','10:45:00',6.21),('8902','2014-03-25','10:50:00',6.19),('8902','2014-03-25','10:55:00',6.43),('8902','2014-03-25','11:00:00',8.32),('8902','2014-03-25','11:05:00',7.72),('8902','2014-03-25','11:10:00',8.75),('8902','2014-03-25','11:15:00',9.05),('8902','2014-03-25','11:20:00',5.09),('8902','2014-03-25','11:25:00',2.43),('8902','2014-03-25','11:30:00',3.09),('8902','2014-03-25','11:35:00',3.7),('8902','2014-03-25','11:40:00',3.62),('8902','2014-03-25','11:45:00',4.57),('8902','2014-03-25','11:50:00',6.53),('8902','2014-03-25','11:55:00',7.19),('8902','2014-03-25','12:00:00',9.58),('8902','2014-03-25','12:05:00',8.47),('8902','2014-03-25','12:10:00',6.65),('8902','2014-03-25','12:15:00',2.95),('8902','2014-03-25','12:20:00',3.46),('8902','2014-03-25','12:25:00',3.44),('8902','2014-03-25','12:30:00',3.34),('8902','2014-03-25','12:35:00',3.31),('8902','2014-03-25','12:40:00',3.5),('8902','2014-03-25','12:45:00',4.21),('8902','2014-03-25','12:50:00',2.97),('8902','2014-03-25','12:55:00',2.51),('8902','2014-03-25','13:00:00',2.33),('8902','2014-03-25','13:05:00',2.38),('8902','2014-03-25','13:10:00',1.93),('8902','2014-03-25','13:15:00',1.41),('8902','2014-03-25','13:20:00',1.9),('8902','2014-03-25','13:25:00',8.45),('8902','2014-03-25','13:30:00',8.5),('8902','2014-03-25','13:35:00',5.1),('8902','2014-03-25','13:40:00',4.68),('8902','2014-03-25','13:45:00',1.67),('8902','2014-03-25','13:50:00',1.51),('8902','2014-03-25','13:55:00',3.35),('8902','2014-03-25','14:00:00',3.96),('8902','2014-03-25','14:05:00',7.18),('8902','2014-03-25','14:10:00',7.57),('8902','2014-03-25','14:15:00',2.75),('8902','2014-03-25','14:20:00',2),('8902','2014-03-25','14:25:00',1.54),('8902','2014-03-25','14:30:00',1.33),('8902','2014-03-25','14:35:00',1.2),('8902','2014-03-25','14:40:00',1.22),('8902','2014-03-25','14:45:00',3.42),('8902','2014-03-25','14:50:00',6.81),('8902','2014-03-25','14:55:00',7.15),('8902','2014-03-25','15:00:00',6.07),('8902','2014-03-25','15:05:00',6.58),('8902','2014-03-25','15:10:00',6.74),('8902','2014-03-25','15:15:00',6.99),('8902','2014-03-25','15:20:00',6.48),('8902','2014-03-25','15:25:00',6.66),('8902','2014-03-25','15:30:00',6.65),('8902','2014-03-25','15:35:00',6.51),('8902','2014-03-25','15:40:00',4.86),('8902','2014-03-25','15:45:00',5.32),('8902','2014-03-25','15:50:00',3.97),('8902','2014-03-25','15:55:00',3.97),('8902','2014-03-25','16:00:00',2.66),('8902','2014-03-25','16:05:00',2.26),('8902','2014-03-25','16:10:00',2.36),('8902','2014-03-25','16:15:00',2.23),('8902','2014-03-25','16:20:00',1.99),('8902','2014-03-25','16:25:00',1.44),('8902','2014-03-25','16:30:00',1.15),('8902','2014-03-25','16:35:00',1.15),('8902','2013-03-21','07:20:00',1.24),('8902','2013-03-21','07:25:00',1.41),('8902','2013-03-21','07:30:00',1.58),('8902','2013-03-21','07:35:00',1.77),('8902','2013-03-21','07:40:00',1.94),('8902','2013-03-21','07:45:00',2.11),('8902','2013-03-21','07:50:00',2.28),('8902','2013-03-21','07:55:00',2.48),('8902','2013-03-21','08:00:00',2.66),('8902','2013-03-21','08:05:00',2.87),('8902','2013-03-21','08:10:00',3.06),('8902','2013-03-21','08:15:00',3.25),('8902','2013-03-21','08:20:00',3.46),('8902','2013-03-21','08:25:00',3.64),('8902','2013-03-21','08:30:00',3.84),('8902','2013-03-21','08:35:00',4.02),('8902','2013-03-21','08:40:00',4.17),('8902','2013-03-21','08:45:00',4.34),('8902','2013-03-21','08:50:00',4.5),('8902','2013-03-21','08:55:00',4.66),('8902','2013-03-21','09:00:00',4.79),('8902','2013-03-21','09:05:00',4.92),('8902','2013-03-21','09:10:00',5.08),('8902','2013-03-21','09:15:00',5.25),('8902','2013-03-21','09:20:00',5.35),('8902','2013-03-21','09:25:00',5.52),('8902','2013-03-21','09:30:00',5.64),('8902','2013-03-21','09:35:00',5.78),('8902','2013-03-21','09:40:00',5.89),('8902','2013-03-21','09:45:00',6.01),('8902','2013-03-21','09:50:00',6.17),('8902','2013-03-21','09:55:00',6.21),('8902','2013-03-21','10:00:00',6.32),('8902','2013-03-21','10:05:00',6.42),('8902','2013-03-21','10:10:00',6.53),('8902','2013-03-21','10:15:00',6.58),('8902','2013-03-21','10:20:00',6.68),('8902','2013-03-21','10:25:00',6.87),('8902','2013-03-21','10:30:00',7.05),('8902','2013-03-21','10:35:00',7.2),('8902','2013-03-21','10:40:00',7.21),('8902','2013-03-21','10:45:00',7.28),('8902','2013-03-21','10:50:00',6.62),('8902','2013-03-21','10:55:00',7.43),('8902','2013-03-21','11:00:00',7.46),('8902','2013-03-21','11:05:00',7.47),('8902','2013-03-21','11:10:00',7.5),('8902','2013-03-21','11:15:00',7.66),('8902','2013-03-21','11:20:00',7.66),('8902','2013-03-21','11:25:00',7.71),('8902','2013-03-21','11:30:00',7.82),('8902','2013-03-21','11:35:00',7.89),('8902','2013-03-21','11:40:00',7.88),('8902','2013-03-21','11:45:00',7.99),('8902','2013-03-21','11:50:00',8),('8902','2013-03-21','11:55:00',8),('8902','2013-03-21','12:00:00',8.07),('8902','2013-03-21','12:05:00',8.07),('8902','2013-03-21','12:10:00',8.1),('8902','2013-03-21','12:15:00',8.12),('8902','2013-03-21','12:20:00',8.08),('8902','2013-03-21','12:25:00',8.1),('8902','2013-03-21','12:30:00',8.11),('8902','2013-03-21','12:35:00',8.13),('8902','2013-03-21','12:40:00',8.14),('8902','2013-03-21','12:45:00',8.09),('8902','2013-03-21','12:50:00',7.93),('8902','2013-03-21','12:55:00',7.53),('8902','2013-03-21','13:00:00',8.1),('8902','2013-03-21','13:05:00',7.8),('8902','2013-03-21','13:10:00',8.05),('8902','2013-03-21','13:15:00',8.06),('8902','2013-03-21','13:20:00',8),('8902','2013-03-21','13:25:00',7.59),('8902','2013-03-21','13:30:00',7.47),('8902','2013-03-21','13:35:00',7.71),('8902','2013-03-21','13:40:00',6.54),('8902','2013-03-21','13:45:00',6.64),('8902','2013-03-21','13:50:00',7.86),('8902','2013-03-21','13:55:00',7.67),('8902','2013-03-21','14:00:00',7.52),('8902','2013-03-21','14:05:00',7.47),('8902','2013-03-21','14:10:00',7.42),('8902','2013-03-21','14:15:00',7.29),('8902','2013-03-21','14:20:00',7.18),('8902','2013-03-21','14:25:00',7.12),('8902','2013-03-21','14:30:00',7.06),('8902','2013-03-21','14:35:00',6.92),('8902','2013-03-21','14:40:00',6.78),('8902','2013-03-21','14:45:00',6.68),('8902','2013-03-21','14:50:00',6.66),('8902','2013-03-21','14:55:00',6.51),('8902','2013-03-21','15:00:00',6.42),('8902','2013-03-21','15:05:00',6.3),('8902','2013-03-21','15:10:00',5.69),('8902','2013-03-21','15:15:00',4.73),('8902','2013-03-21','15:20:00',4.64),('8902','2013-03-21','15:25:00',4.88),('8902','2013-03-21','15:30:00',4.5),('8902','2013-03-21','15:35:00',5.07),('8902','2013-03-21','15:40:00',4.85),('8902','2013-03-21','15:45:00',4.27),('8902','2013-03-21','15:50:00',4.53),('8902','2013-03-21','15:55:00',4.1),('8902','2013-03-21','16:00:00',2.94),('8902','2013-03-21','16:05:00',2.91),('8902','2013-03-21','16:10:00',3.41),('8902','2013-03-21','16:15:00',4.07),('8902','2013-03-21','16:20:00',3.33),('8902','2013-03-21','16:25:00',3.27),('8902','2013-03-21','16:30:00',3.53),('8902','2013-03-21','16:35:00',3.5),('8902','2013-03-21','16:40:00',3.36),('8902','2013-03-21','16:45:00',3.19),('8902','2013-03-21','16:50:00',2.97),('8902','2013-03-21','16:55:00',2.72),('8902','2013-03-21','17:00:00',2.42),('8902','2013-03-21','17:05:00',2.16),('8902','2013-03-21','17:10:00',1.9),('8902','2013-03-21','17:15:00',1.7),('8902','2013-03-21','17:20:00',1.54),('8902','2013-03-21','17:25:00',1.14),('8902','2013-03-20','07:30:00',1.01),('8902','2013-03-20','07:35:00',1.1),('8902','2013-03-20','07:40:00',1.3),('8902','2013-03-20','07:45:00',1.87),('8902','2013-03-20','07:50:00',2.52),('8902','2013-03-20','07:55:00',1.67),('8902','2013-03-20','08:00:00',1.01),('8902','2013-03-20','08:10:00',2.13),('8902','2013-03-20','08:15:00',3.53),('8902','2013-03-20','08:20:00',3.68),('8902','2013-03-20','08:25:00',3.82),('8902','2013-03-20','08:30:00',3.98),('8902','2013-03-20','08:35:00',4.16),('8902','2013-03-20','08:40:00',4.54),('8902','2013-03-20','08:45:00',4.62),('8902','2013-03-20','08:50:00',4.66),('8902','2013-03-20','08:55:00',3.89),('8902','2013-03-20','09:00:00',5.12),('8902','2013-03-20','09:05:00',5.43),('8902','2013-03-20','09:10:00',6.13),('8902','2013-03-20','09:15:00',5.13),('8902','2013-03-20','09:20:00',5.89),('8902','2013-03-20','09:25:00',5.91),('8902','2013-03-20','09:30:00',6.16),('8902','2013-03-20','09:35:00',6.12),('8902','2013-03-20','09:40:00',5.96),('8902','2013-03-20','09:45:00',6.35),('8902','2013-03-20','09:50:00',5.99),('8902','2013-03-20','09:55:00',6.73),('8902','2013-03-20','10:00:00',6.84),('8902','2013-03-20','10:05:00',6.9),('8902','2013-03-20','10:10:00',6.98),('8902','2013-03-20','10:15:00',7.06),('8902','2013-03-20','10:20:00',7.13),('8902','2013-03-20','10:25:00',7.18),('8902','2013-03-20','10:30:00',7.25),('8902','2013-03-20','10:35:00',7.35),('8902','2013-03-20','10:40:00',7.44),('8902','2013-03-20','10:45:00',7.48),('8902','2013-03-20','10:50:00',7.48),('8902','2013-03-20','10:55:00',4.82),('8902','2013-03-20','11:00:00',7.82),('8902','2013-03-20','11:05:00',7.81),('8902','2013-03-20','11:10:00',7.88),('8902','2013-03-20','11:15:00',8),('8902','2013-03-20','11:20:00',8.08),('8902','2013-03-20','11:25:00',8.16),('8902','2013-03-20','11:30:00',8.19),('8902','2013-03-20','11:35:00',8.27),('8902','2013-03-20','11:40:00',8.28),('8902','2013-03-20','11:45:00',8.34),('8902','2013-03-20','11:50:00',8.39),('8902','2013-03-20','11:55:00',8.42),('8902','2013-03-20','12:00:00',8.4),('8902','2013-03-20','12:05:00',8.44),('8902','2013-03-20','12:10:00',8.43),('8902','2013-03-20','12:15:00',8.43),('8902','2013-03-20','12:20:00',8.44),('8902','2013-03-20','12:25:00',8.44),('8902','2013-03-20','12:30:00',8.47),('8902','2013-03-20','12:35:00',8.47),('8902','2013-03-20','12:40:00',8.43),('8902','2013-03-20','12:45:00',8.41),('8902','2013-03-20','12:50:00',8.4),('8902','2013-03-20','12:55:00',8.4),('8902','2013-03-20','13:00:00',8.37),('8902','2013-03-20','13:05:00',8.32),('8902','2013-03-20','13:10:00',8.29),('8902','2013-03-20','13:15:00',8.26),('8902','2013-03-20','13:20:00',8.23),('8902','2013-03-20','13:25:00',8.17),('8902','2013-03-20','13:30:00',8.1),('8902','2013-03-20','13:35:00',8.05),('8902','2013-03-20','13:40:00',8.02),('8902','2013-03-20','13:45:00',7.95),('8902','2013-03-20','13:50:00',7.84),('8902','2013-03-20','13:55:00',7.78),('8902','2013-03-20','14:00:00',7.7),('8902','2013-03-20','14:05:00',7.55),('8902','2013-03-20','14:10:00',7.46),('8902','2013-03-20','14:15:00',7.4),('8902','2013-03-20','14:20:00',7.3),('8902','2013-03-20','14:25:00',7.24),('8902','2013-03-20','14:30:00',7.12),('8902','2013-03-20','14:35:00',6.98),('8902','2013-03-20','14:40:00',6.88),('8902','2013-03-20','14:45:00',6.8),('8902','2013-03-20','14:50:00',6.7),('8902','2013-03-20','14:55:00',6.58),('8902','2013-03-20','15:00:00',6.45),('8902','2013-03-20','15:05:00',6.35),('8902','2013-03-20','15:10:00',6.22),('8902','2013-03-20','15:15:00',6.08),('8902','2013-03-20','15:20:00',5.95),('8902','2013-03-20','15:25:00',5.81),('8902','2013-03-20','15:30:00',5.61),('8902','2013-03-20','15:35:00',5.51),('8902','2013-03-20','15:40:00',5.34),('8902','2013-03-20','15:45:00',5.16),('8902','2013-03-20','15:50:00',4.88),('8902','2013-03-20','15:55:00',4.8),('8902','2013-03-20','16:00:00',4.63),('8902','2013-03-20','16:05:00',4.43),('8902','2013-03-20','16:10:00',4.25),('8902','2013-03-20','16:15:00',4.07),('8902','2013-03-20','16:20:00',3.9),('8902','2013-03-20','16:25:00',3.69),('8902','2013-03-20','16:30:00',3.42),('8902','2013-03-20','16:35:00',3.16),('8902','2013-03-20','16:40:00',2.95),('8902','2013-03-20','16:45:00',2.83),('8902','2013-03-20','16:50:00',2.63),('8902','2013-03-20','16:55:00',2.4),('8902','2013-03-20','17:00:00',2.18),('8902','2013-03-20','17:05:00',1.97),('8902','2013-03-20','17:10:00',1.74),('8902','2013-03-20','17:15:00',1.57),('8902','2013-03-20','17:20:00',1.39),('8902','2013-03-20','17:25:00',1.19),('8902','2013-03-19','07:20:00',1.2),('8902','2013-03-19','07:25:00',1.39),('8902','2013-03-19','07:30:00',1.62),('8902','2013-03-19','07:35:00',1.89),('8902','2013-03-19','07:40:00',2.01),('8902','2013-03-19','07:45:00',2.08),('8902','2013-03-19','07:50:00',2.17),('8902','2013-03-19','07:55:00',2.63),('8902','2013-03-19','08:00:00',2.43),('8902','2013-03-19','08:05:00',2.45),('8902','2013-03-19','08:10:00',2.97),('8902','2013-03-19','08:15:00',3.2),('8902','2013-03-19','08:20:00',3.39),('8902','2013-03-19','08:25:00',3.6),('8902','2013-03-19','08:30:00',3.84),('8902','2013-03-19','08:35:00',3.83),('8902','2013-03-19','08:40:00',3.93),('8902','2013-03-19','08:45:00',4.1),('8902','2013-03-19','08:50:00',4.35),('8902','2013-03-19','08:55:00',4.31),('8902','2013-03-19','09:00:00',4.67),('8902','2013-03-19','09:05:00',5.74),('8902','2013-03-19','09:10:00',5.29),('8902','2013-03-19','09:15:00',4.98),('8902','2013-03-19','09:20:00',5.23),('8902','2013-03-19','09:25:00',5.56),('8902','2013-03-19','09:30:00',5.62),('8902','2013-03-19','09:35:00',5.48),('8902','2013-03-19','09:40:00',5.8),('8902','2013-03-19','09:45:00',6.03),('8902','2013-03-19','09:50:00',6.08),('8902','2013-03-19','09:55:00',6.11),('8902','2013-03-19','10:00:00',6.35),('8902','2013-03-19','10:05:00',6.16),('8902','2013-03-19','10:10:00',5.79),('8902','2013-03-19','10:15:00',4.81),('8902','2013-03-19','10:20:00',5.63),('8902','2013-03-19','10:25:00',4.82),('8902','2013-03-19','10:30:00',5.78),('8902','2013-03-19','10:35:00',6.64),('8902','2013-03-19','10:40:00',6.16),('8902','2013-03-19','10:45:00',4.46),('8902','2013-03-19','10:50:00',6),('8902','2013-03-19','10:55:00',5.5),('8902','2013-03-19','11:00:00',5.52),('8902','2013-03-19','11:05:00',6.26),('8902','2013-03-19','11:10:00',5.23),('8902','2013-03-19','11:15:00',4.57),('8902','2013-03-19','11:20:00',5.21),('8902','2013-03-19','11:25:00',5.02),('8902','2013-03-19','11:30:00',4.59),('8902','2013-03-19','11:35:00',5.11),('8902','2013-03-19','11:40:00',4.21),('8902','2013-03-19','11:45:00',3.97),('8902','2013-03-19','11:50:00',3.75),('8902','2013-03-19','11:55:00',4.27),('8902','2013-03-19','12:00:00',4.08),('8902','2013-03-19','12:05:00',4.55),('8902','2013-03-19','12:10:00',3.68),('8902','2013-03-19','12:15:00',3.19),('8902','2013-03-19','12:20:00',2.96),('8902','2013-03-19','12:25:00',2.47),('8902','2013-03-19','12:30:00',1.99),('8902','2013-03-19','12:35:00',2.51),('8902','2013-03-19','12:40:00',1.82),('8902','2013-03-19','12:45:00',1.92),('8902','2013-03-19','12:50:00',2.76),('8902','2013-03-19','12:55:00',3.2),('8902','2013-03-19','13:00:00',3.51),('8902','2013-03-19','13:05:00',2.7),('8902','2013-03-19','13:10:00',2.77),('8902','2013-03-19','13:15:00',2.2),('8902','2013-03-19','13:20:00',2.38),('8902','2013-03-19','13:25:00',2.52),('8902','2013-03-19','13:30:00',2.74),('8902','2013-03-19','13:35:00',2.59),('8902','2013-03-19','13:40:00',3.28),('8902','2013-03-19','13:45:00',3.88),('8902','2013-03-19','13:50:00',3.23),('8902','2013-03-19','13:55:00',3.01),('8902','2013-03-19','14:00:00',2.98),('8902','2013-03-19','14:05:00',2.54),('8902','2013-03-19','14:10:00',2.4),('8902','2013-03-19','14:15:00',3.16),('8902','2013-03-19','14:20:00',4.07),('8902','2013-03-19','14:25:00',3.68),('8902','2013-03-19','14:30:00',3.13),('8902','2013-03-19','14:35:00',2.58),('8902','2013-03-19','14:40:00',2.05),('8902','2013-03-19','14:45:00',2.01),('8902','2013-03-19','14:50:00',1.63),('8902','2013-03-19','14:55:00',1.32),('8902','2013-03-19','15:00:00',1.48),('8902','2013-03-19','15:05:00',1.29),('8902','2013-03-19','15:10:00',1.16),('8902','2013-03-19','15:15:00',1),('8902','2013-03-19','15:30:00',1.08),('8902','2013-03-19','15:35:00',1),('8902','2013-03-18','07:05:00',1.08),('8902','2013-03-18','07:10:00',1.26),('8902','2013-03-18','07:15:00',1.3),('8902','2013-03-18','07:20:00',1.11),('8902','2013-03-18','07:25:00',1.29),('8902','2013-03-18','07:30:00',1.45),('8902','2013-03-18','07:35:00',1.61),('8902','2013-03-18','07:40:00',1.78),('8902','2013-03-18','07:45:00',1.99),('8902','2013-03-18','07:50:00',2.21),('8902','2013-03-18','07:55:00',2.27),('8902','2013-03-18','08:00:00',1.47),('8902','2013-03-18','08:05:00',2.24),('8902','2013-03-18','08:10:00',2.83),('8902','2013-03-18','08:15:00',3.18),('8902','2013-03-18','08:20:00',3.32),('8902','2013-03-18','08:25:00',3.48),('8902','2013-03-18','08:30:00',3.72),('8902','2013-03-18','08:35:00',3.8),('8902','2013-03-18','08:40:00',3.54),('8902','2013-03-18','08:45:00',4.13),('8902','2013-03-18','08:50:00',4.48),('8902','2013-03-18','08:55:00',4.62),('8902','2013-03-18','09:00:00',4.76),('8902','2013-03-18','09:05:00',4.96),('8902','2013-03-18','09:10:00',5.11),('8902','2013-03-18','09:15:00',5.01),('8902','2013-03-18','09:20:00',4.61),('8902','2013-03-18','09:25:00',4.25),('8902','2013-03-18','09:30:00',5.55),('8902','2013-03-18','09:35:00',5.93),('8902','2013-03-18','09:40:00',6.09),('8902','2013-03-18','09:45:00',6.37),('8902','2013-03-18','09:50:00',5.67),('8902','2013-03-18','09:55:00',5.41),('8902','2013-03-18','10:00:00',5.52),('8902','2013-03-18','10:05:00',5.63),('8902','2013-03-18','10:10:00',6.54),('8902','2013-03-18','10:15:00',6.92),('8902','2013-03-18','10:20:00',7.03),('8902','2013-03-18','10:25:00',6.89),('8902','2013-03-18','10:30:00',7.25),('8902','2013-03-18','10:35:00',7.34),('8902','2013-03-18','10:40:00',7.39),('8902','2013-03-18','10:45:00',7.53),('8902','2013-03-18','10:50:00',7.48),('8902','2013-03-18','10:55:00',7.79),('8902','2013-03-18','11:00:00',7.85),('8902','2013-03-18','11:05:00',7.81),('8902','2013-03-18','11:10:00',7.68),('8902','2013-03-18','11:15:00',7.95),('8902','2013-03-18','11:20:00',8.03),('8902','2013-03-18','11:25:00',7.95),('8902','2013-03-18','11:30:00',7.98),('8902','2013-03-18','11:35:00',5.01),('8902','2013-03-18','11:40:00',7.2),('8902','2013-03-18','11:45:00',7.62),('8902','2013-03-18','11:50:00',8.23),('8902','2013-03-18','11:55:00',8.38),('8902','2013-03-18','12:00:00',8.25),('8902','2013-03-18','12:05:00',8.2),('8902','2013-03-18','12:10:00',8.22),('8902','2013-03-18','12:15:00',7.83),('8902','2013-03-18','12:20:00',8.31),('8902','2013-03-18','12:25:00',8.2),('8902','2013-03-18','12:30:00',8.11),('8902','2013-03-18','12:35:00',8.21),('8902','2013-03-18','12:40:00',8.24),('8902','2013-03-18','12:45:00',8.29),('8902','2013-03-18','12:50:00',8.24),('8902','2013-03-18','12:55:00',8.14),('8902','2013-03-18','13:00:00',8.2),('8902','2013-03-18','13:05:00',8.14),('8902','2013-03-18','13:10:00',8.05),('8902','2013-03-18','13:15:00',8.01),('8902','2013-03-18','13:20:00',7.99),('8902','2013-03-18','13:25:00',8.01),('8902','2013-03-18','13:30:00',7.91),('8902','2013-03-18','13:35:00',7.84),('8902','2013-03-18','13:40:00',7.67),('8902','2013-03-18','13:45:00',7.68),('8902','2013-03-18','13:50:00',7.71),('8902','2013-03-18','13:55:00',7.61),('8902','2013-03-18','14:00:00',7.54),('8902','2013-03-18','14:05:00',7.45),('8902','2013-03-18','14:10:00',7.37),('8902','2013-03-18','14:15:00',7.29),('8902','2013-03-18','14:20:00',7.19),('8902','2013-03-18','14:25:00',7.14),('8902','2013-03-18','14:30:00',7.06),('8902','2013-03-18','14:35:00',6.91),('8902','2013-03-18','14:40:00',6.81),('8902','2013-03-18','14:45:00',6.68),('8902','2013-03-18','14:50:00',6.58),('8902','2013-03-18','14:55:00',6.47),('8902','2013-03-18','15:00:00',6.38),('8902','2013-03-18','15:05:00',6.24),('8902','2013-03-18','15:10:00',6.09),('8902','2013-03-18','15:15:00',5.97),('8902','2013-03-18','15:20:00',5.86),('8902','2013-03-18','15:25:00',5.65),('8902','2013-03-18','15:30:00',5.47),('8902','2013-03-18','15:35:00',5.4),('8902','2013-03-18','15:40:00',5.25),('8902','2013-03-18','15:45:00',5.07),('8902','2013-03-18','15:50:00',4.83),('8902','2013-03-18','15:55:00',4.73),('8902','2013-03-18','16:00:00',4.56),('8902','2013-03-18','16:05:00',4.31),('8902','2013-03-18','16:10:00',4.17),('8902','2013-03-18','16:15:00',3.97),('8902','2013-03-18','16:20:00',3.77),('8902','2013-03-18','16:25:00',3.61),('8902','2013-03-18','16:30:00',3.4),('8902','2013-03-18','16:35:00',3.19),('8902','2013-03-18','16:40:00',3.03),('8902','2013-03-18','16:45:00',2.46),('8902','2013-03-18','16:50:00',1.9),('8902','2013-03-18','16:55:00',2.01),('8902','2013-03-18','17:00:00',1.64),('8902','2013-03-18','17:05:00',1.46),('8902','2013-03-18','17:10:00',1.42),('8902','2013-03-18','17:15:00',1.69),('8902','2013-03-18','17:20:00',1.48),('8902','2013-03-18','17:25:00',1.2),('8902','2013-03-17','08:25:00',1.19),('8902','2013-03-17','08:30:00',1.39),('8902','2013-03-17','08:35:00',1.27),('8902','2013-03-17','08:40:00',1.21),('8902','2013-03-17','08:45:00',1.7),('8902','2013-03-17','08:50:00',1.49),('8902','2013-03-17','08:55:00',1.3),('8902','2013-03-17','09:35:00',1.05),('8902','2013-03-17','09:40:00',1.18),('8902','2013-03-17','09:45:00',1.27),('8902','2013-03-17','09:50:00',1.31),('8902','2013-03-17','09:55:00',1.79),('8902','2013-03-17','10:00:00',2.05),('8902','2013-03-17','10:05:00',2.85),('8902','2013-03-17','10:10:00',2.79),('8902','2013-03-17','10:15:00',2.43),('8902','2013-03-17','10:20:00',3.02),('8902','2013-03-17','10:25:00',4.03),('8902','2013-03-17','10:30:00',3.77),('8902','2013-03-17','10:35:00',2.93),('8902','2013-03-17','10:40:00',2.66),('8902','2013-03-17','10:45:00',2.71),('8902','2013-03-17','10:50:00',2.66),('8902','2013-03-17','10:55:00',2.22),('8902','2013-03-17','11:00:00',2.38),('8902','2013-03-17','11:05:00',2.61),('8902','2013-03-17','11:10:00',3),('8902','2013-03-17','11:15:00',3.26),('8902','2013-03-17','11:20:00',3.37),('8902','2013-03-17','11:25:00',3.58),('8902','2013-03-17','11:30:00',4.33),('8902','2013-03-17','11:35:00',3.7),('8902','2013-03-17','11:40:00',3.43),('8902','2013-03-17','11:45:00',2.88),('8902','2013-03-17','11:50:00',2.35),('8902','2013-03-17','11:55:00',2.76),('8902','2013-03-17','12:00:00',2.94),('8902','2013-03-17','12:05:00',4.95),('8902','2013-03-17','12:10:00',4.61),('8902','2013-03-17','12:15:00',5.33),('8902','2013-03-17','12:20:00',4.99),('8902','2013-03-17','12:25:00',3.55),('8902','2013-03-17','12:30:00',6.76),('8902','2013-03-17','12:35:00',6.8),('8902','2013-03-17','12:40:00',6.19),('8902','2013-03-17','12:45:00',5.02),('8902','2013-03-17','12:50:00',7.2),('8902','2013-03-17','12:55:00',7.93),('8902','2013-03-17','13:00:00',6.16),('8902','2013-03-17','13:05:00',3.27),('8902','2013-03-17','13:10:00',2.21),('8902','2013-03-17','13:15:00',1.68),('8902','2013-03-17','13:20:00',1.9),('8902','2013-03-17','13:25:00',3.48),('8902','2013-03-17','13:30:00',2.7),('8902','2013-03-17','13:35:00',2.22),('8902','2013-03-17','13:40:00',3.68),('8902','2013-03-17','13:45:00',3.39),('8902','2013-03-17','13:50:00',3.17),('8902','2013-03-17','13:55:00',2.99),('8902','2013-03-17','14:00:00',3.22),('8902','2013-03-17','14:05:00',5.26),('8902','2013-03-17','14:10:00',4.93),('8902','2013-03-17','14:15:00',2.44),('8902','2013-03-17','14:20:00',2.33),('8902','2013-03-17','14:25:00',3.48),('8902','2013-03-17','14:30:00',1.58),('8902','2013-03-17','14:35:00',2.09),('8902','2013-03-17','14:40:00',2.38),('8902','2013-03-17','14:45:00',2.25),('8902','2013-03-17','14:50:00',1.27),('8902','2013-03-17','14:55:00',1.75),('8902','2013-03-17','15:00:00',2.07),('8902','2013-03-17','15:05:00',1.73),('8902','2013-03-17','15:10:00',1.27),('8902','2013-03-17','15:15:00',1.65),('8902','2013-03-17','15:20:00',1.3),('8902','2013-03-17','15:25:00',1.14),('8902','2013-03-17','15:30:00',1.08),('8902','2013-03-16','07:50:00',1.12),('8902','2013-03-16','07:55:00',1.19),('8902','2013-03-16','08:00:00',1.3),('8902','2013-03-16','08:05:00',1.45),('8902','2013-03-16','08:10:00',1.72),('8902','2013-03-16','08:15:00',2.04),('8902','2013-03-16','08:20:00',2.36),('8902','2013-03-16','08:25:00',2.76),('8902','2013-03-16','08:30:00',2.53),('8902','2013-03-16','08:35:00',2.18),('8902','2013-03-16','08:40:00',2.23),('8902','2013-03-16','08:45:00',2.66),('8902','2013-03-16','08:50:00',2.63),('8902','2013-03-16','08:55:00',2.49),('8902','2013-03-16','09:00:00',2.44),('8902','2013-03-16','09:05:00',2.8),('8902','2013-03-16','09:10:00',3.18),('8902','2013-03-16','09:15:00',3.48),('8902','2013-03-16','09:20:00',2.92),('8902','2013-03-16','09:25:00',2.44),('8902','2013-03-16','09:30:00',2.65),('8902','2013-03-16','09:35:00',3.05),('8902','2013-03-16','09:40:00',2.87),('8902','2013-03-16','09:45:00',2.92),('8902','2013-03-16','09:50:00',3.27),('8902','2013-03-16','09:55:00',3.56),('8902','2013-03-16','10:00:00',3.91),('8902','2013-03-16','10:05:00',3.29),('8902','2013-03-16','10:10:00',3.19),('8902','2013-03-16','10:15:00',3.5),('8902','2013-03-16','10:20:00',3.55),('8902','2013-03-16','10:25:00',3.71),('8902','2013-03-16','10:30:00',3.61),('8902','2013-03-16','10:35:00',3.44),('8902','2013-03-16','10:40:00',3.25),('8902','2013-03-16','10:45:00',3.43),('8902','2013-03-16','10:50:00',3.38),('8902','2013-03-16','10:55:00',3.07),('8902','2013-03-16','11:00:00',3.11),('8902','2013-03-16','11:05:00',2.68),('8902','2013-03-16','11:10:00',2.53),('8902','2013-03-16','11:15:00',2.65),('8902','2013-03-16','11:20:00',3.05),('8902','2013-03-16','11:25:00',3.23),('8902','2013-03-16','11:30:00',2.9),('8902','2013-03-16','11:35:00',2.84),('8902','2013-03-16','11:40:00',2.65),('8902','2013-03-16','11:45:00',2.5),('8902','2013-03-16','11:50:00',2.3),('8902','2013-03-16','11:55:00',2.06),('8902','2013-03-16','12:00:00',2.04),('8902','2013-03-16','12:05:00',2.1),('8902','2013-03-16','12:10:00',2.65),('8902','2013-03-16','12:15:00',3.58),('8902','2013-03-16','12:20:00',4.39),('8902','2013-03-16','12:25:00',6.61),('8902','2013-03-16','12:30:00',7.15),('8902','2013-03-16','12:35:00',5),('8902','2013-03-16','12:40:00',5.36),('8902','2013-03-16','12:45:00',4.76),('8902','2013-03-16','12:50:00',4.18),('8902','2013-03-16','12:55:00',3.26),('8902','2013-03-16','13:00:00',3.89),('8902','2013-03-16','13:05:00',4.36),('8902','2013-03-16','13:10:00',4.79),('8902','2013-03-16','13:15:00',4.81),('8902','2013-03-16','13:20:00',3.95),('8902','2013-03-16','13:25:00',3.41),('8902','2013-03-16','13:30:00',5.18),('8902','2013-03-16','13:35:00',6.09),('8902','2013-03-16','13:40:00',3.93),('8902','2013-03-16','13:45:00',3.55),('8902','2013-03-16','13:50:00',2.72),('8902','2013-03-16','13:55:00',4.09),('8902','2013-03-16','14:00:00',4.23),('8902','2013-03-16','14:05:00',4.04),('8902','2013-03-16','14:10:00',4.81),('8902','2013-03-16','14:15:00',5.4),('8902','2013-03-16','14:20:00',5.13),('8902','2013-03-16','14:25:00',4.92),('8902','2013-03-16','14:30:00',4.63),('8902','2013-03-16','14:35:00',3.7),('8902','2013-03-16','14:40:00',2.91),('8902','2013-03-16','14:45:00',2.53),('8902','2013-03-16','14:50:00',2.19),('8902','2013-03-16','14:55:00',2.24),('8902','2013-03-16','15:00:00',2.94),('8902','2013-03-16','15:05:00',3.24),('8902','2013-03-16','15:10:00',4.18),('8902','2013-03-16','15:15:00',3.97),('8902','2013-03-16','15:20:00',4.59),('8902','2013-03-16','15:25:00',3.35),('8902','2013-03-16','15:30:00',2.46),('8902','2013-03-16','15:35:00',2.64),('8902','2013-03-16','15:40:00',2.68),('8902','2013-03-16','15:45:00',2.64),('8902','2013-03-16','15:50:00',1.81),('8902','2013-03-16','15:55:00',1.7),('8902','2013-03-16','16:00:00',1.18),('8902','2013-03-16','16:20:00',1.06),('8902','2013-03-16','16:40:00',1.38),('8902','2013-03-16','16:45:00',2.19),('8902','2013-03-15','07:45:00',1.14),('8902','2013-03-15','07:50:00',1.63),('8902','2013-03-15','07:55:00',1.36),('8902','2013-03-15','08:00:00',1.7),('8902','2013-03-15','08:05:00',1.82),('8902','2013-03-15','08:10:00',1.87),('8902','2013-03-15','08:15:00',3.21),('8902','2013-03-15','08:20:00',3.88),('8902','2013-03-15','08:25:00',3.89),('8902','2013-03-15','08:30:00',3.84),('8902','2013-03-15','08:35:00',4.03),('8902','2013-03-15','08:40:00',4.26),('8902','2013-03-15','08:45:00',4.2),('8902','2013-03-15','08:50:00',4.66),('8902','2013-03-15','08:55:00',4.99),('8902','2013-03-15','09:00:00',4.92),('8902','2013-03-15','09:05:00',3.55),('8902','2013-03-15','09:15:00',5.62),('8902','2013-03-15','09:20:00',5.52),('8902','2013-03-15','09:29:00',5.71),('8902','2013-03-15','09:30:00',6.05),('8902','2013-03-15','09:35:00',6.27),('8902','2013-03-15','09:43:00',6.56),('8902','2013-03-15','09:46:00',6.06),('8902','2013-03-15','09:55:00',6.47),('8902','2013-03-15','10:00:00',4.99),('8902','2013-03-15','10:08:00',4.13),('8902','2013-03-15','10:10:00',5.01),('8902','2013-03-15','10:21:00',4.56),('8902','2013-03-15','10:25:00',4.69),('8902','2013-03-15','10:33:00',5.85),('8902','2013-03-15','10:35:00',5.3),('8902','2013-03-15','10:43:00',6.14),('8902','2013-03-15','10:45:00',7.61),('8902','2013-03-15','10:56:00',7.62),('8902','2013-03-15','11:00:00',7.69),('8902','2013-03-15','11:05:00',7.68),('8902','2013-03-15','11:10:00',7.77),('8902','2013-03-15','11:16:00',7.85),('8902','2013-03-15','11:20:00',7.84),('8902','2013-03-15','11:25:00',7.89),('8902','2013-03-15','11:30:00',7.94),('8902','2013-03-15','11:35:00',7.96),('8902','2013-03-15','11:40:00',7.98),('8902','2013-03-15','11:45:00',7.96),('8902','2013-03-15','11:50:00',8.03),('8902','2013-03-15','11:55:00',8.06),('8902','2013-03-15','12:00:00',8.05),('8902','2013-03-15','12:05:00',8.04),('8902','2013-03-15','12:10:00',8.12),('8902','2013-03-15','12:15:00',8.11),('8902','2013-03-15','12:20:00',8.13),('8902','2013-03-15','12:25:00',8.11),('8902','2013-03-15','12:30:00',8.11),('8902','2013-03-15','12:35:00',8.09),('8902','2013-03-15','12:40:00',8.08),('8902','2013-03-15','12:45:00',8.06),('8902','2013-03-15','12:50:00',8.02),('8902','2013-03-15','12:55:00',8),('8902','2013-03-15','13:00:00',7.94),('8902','2013-03-15','13:05:00',7.86),('8902','2013-03-15','13:10:00',7.81),('8902','2013-03-15','13:15:00',7.84),('8902','2013-03-15','13:20:00',6.72),('8902','2013-03-15','13:25:00',2.94),('8902','2013-03-15','13:30:00',3.45),('8902','2013-03-15','13:35:00',6.79),('8902','2013-03-15','13:40:00',8.04),('8902','2013-03-15','13:45:00',7.9),('8902','2013-03-15','13:50:00',6.75),('8902','2013-03-15','13:55:00',2.74),('8902','2013-03-15','14:00:00',7.19),('8902','2013-03-15','14:05:00',7.85),('8902','2013-03-15','14:10:00',6.69),('8902','2013-03-15','14:15:00',4.42),('8902','2013-03-15','14:20:00',5.31),('8902','2013-03-15','14:25:00',1.96),('8902','2013-03-15','14:30:00',2.12),('8902','2013-03-15','14:35:00',7.55),('8902','2013-03-15','14:40:00',3.54),('8902','2013-03-15','14:45:00',3.97),('8902','2013-03-15','14:50:00',1.44),('8902','2013-03-15','14:55:00',1.26),('8902','2013-03-15','15:00:00',1.2),('8902','2013-03-15','15:05:00',1.17),('8902','2013-03-15','15:10:00',1.08),('8902','2013-03-15','15:15:00',1.04),('8902','2013-03-15','15:20:00',1.04),('8902','2013-03-15','15:25:00',1.16),('8902','2013-03-15','15:30:00',1.09),('8902','2013-03-15','15:35:00',1.25),('8902','2013-03-15','15:40:00',1.48),('8902','2013-03-15','15:45:00',2.27),('8902','2013-03-15','15:50:00',1.09),('8902','2013-03-15','16:00:00',1.04),('8902','2013-03-15','16:05:00',2.25),('8902','2013-03-15','16:10:00',3.25),('8902','2013-03-15','16:15:00',2.98),('8902','2013-03-15','16:20:00',1.86),('8902','2013-03-15','16:25:00',1.11),('8902','2013-03-15','16:30:00',1.19),('8902','2013-03-15','16:35:00',1.14),('8902','2013-03-15','16:40:00',1.01),('8902','2013-03-15','16:55:00',1.78),('8902','2013-03-15','17:00:00',2.05),('8902','2013-03-15','17:05:00',1.9),('8902','2013-03-15','17:10:00',1.67),('8902','2013-03-15','17:15:00',1.51),('8902','2013-03-15','17:20:00',1.38),('8902','2013-03-15','17:25:00',1.16),('8902','2013-03-14','10:00:00',1.09),('8902','2013-03-14','10:05:00',1.05),('8902','2013-03-14','10:10:00',1.13),('8902','2013-03-14','10:15:00',1.28),('8902','2013-03-14','10:20:00',1.15),('8902','2013-03-14','10:25:00',1.25),('8902','2013-03-14','10:30:00',1.61),('8902','2013-03-14','10:35:00',1.83),('8902','2013-03-14','10:40:00',2.16),('8902','2013-03-14','10:45:00',2.59),('8902','2013-03-14','10:50:00',2.54),('8902','2013-03-14','10:55:00',2.75),('8902','2013-03-14','11:00:00',2.68),('8902','2013-03-14','11:05:00',2.45),('8902','2013-03-14','11:10:00',2.28),('8902','2013-03-14','11:15:00',2.02),('8902','2013-03-14','11:20:00',2.41),('8902','2013-03-14','11:25:00',2.86),('8902','2013-03-14','11:30:00',3.17),('8902','2013-03-14','11:35:00',3.77),('8902','2013-03-14','11:40:00',4.53),('8902','2013-03-14','11:45:00',4.4),('8902','2013-03-14','11:50:00',3.76),('8902','2013-03-14','11:55:00',3.86),('8902','2013-03-14','12:00:00',3.46),('8902','2013-03-14','12:05:00',3.42),('8902','2013-03-14','12:10:00',3.52),('8902','2013-03-14','12:15:00',3.13),('8902','2013-03-14','12:20:00',3.18),('8902','2013-03-14','12:25:00',3.19),('8902','2013-03-14','12:30:00',3.32),('8902','2013-03-14','12:35:00',3.74),('8902','2013-03-14','12:40:00',3.42),('8902','2013-03-14','12:45:00',3),('8902','2013-03-14','12:50:00',2.82),('8902','2013-03-14','12:55:00',2.63),('8902','2013-03-14','13:00:00',2.43),('8902','2013-03-14','13:05:00',2.28),('8902','2013-03-14','13:10:00',2.31),('8902','2013-03-14','13:15:00',2.49),('8902','2013-03-14','13:20:00',2.65),('8902','2013-03-14','13:25:00',2.9),('8902','2013-03-14','13:30:00',2.87),('8902','2013-03-14','13:35:00',2.64),('8902','2013-03-14','13:40:00',2.76),('8902','2013-03-14','13:45:00',2.99),('8902','2013-03-14','13:50:00',2.51),('8902','2013-03-14','13:55:00',2.17),('8902','2013-03-14','14:00:00',1.95),('8902','2013-03-14','14:05:00',1.75),('8902','2013-03-14','14:10:00',1.47),('8902','2013-03-14','14:15:00',1.26),('8902','2013-03-14','14:20:00',1.11),('8902','2013-03-14','14:40:00',1.02),('8902','2013-03-14','14:45:00',1.27),('8902','2013-03-14','14:50:00',1.75),('8902','2013-03-14','14:55:00',2.08),('8902','2013-03-14','15:00:00',2.22),('8902','2013-03-14','15:05:00',2.18),('8902','2013-03-14','15:10:00',2.16),('8902','2013-03-14','15:15:00',2.35),('8902','2013-03-14','15:20:00',2.36),('8902','2013-03-14','15:25:00',2.54),('8902','2013-03-14','15:30:00',2.37),('8902','2013-03-14','15:35:00',2),('8902','2013-03-14','15:40:00',1.64),('8902','2013-03-14','15:45:00',1.65),('8902','2013-03-14','15:50:00',1.63),('8902','2013-03-14','15:55:00',1.54),('8902','2013-03-14','16:00:00',1.78),('8902','2013-03-14','16:05:00',1.49),('8902','2013-03-14','16:10:00',1.29),('8902','2013-03-14','16:15:00',1.32),('8902','2013-03-14','16:20:00',1.15),('8902','2013-03-14','17:15:00',1.4),('8902','2013-03-14','17:20:00',1.35),('8902','2013-03-14','17:25:00',1.08),('8902','2013-03-13','08:20:00',1.42),('8902','2013-03-13','08:25:00',1.56),('8902','2013-03-13','08:30:00',1.37),('8902','2013-03-13','10:20:00',1.13),('8902','2013-03-13','10:25:00',1.22),('8902','2013-03-13','10:30:00',1.25),('8902','2013-03-13','10:35:00',1.28),('8902','2013-03-13','10:40:00',1.18),('8902','2013-03-13','11:25:00',1.13),('8902','2013-03-13','11:30:00',1.45),('8902','2013-03-13','11:35:00',1.65),('8902','2013-03-13','11:40:00',1.66),('8902','2013-03-13','11:45:00',1.68),('8902','2013-03-13','11:50:00',1.61),('8902','2013-03-13','11:55:00',1.47),('8902','2013-03-13','12:00:00',1.33),('8902','2013-03-13','12:05:00',1.17),('8902','2013-03-13','12:10:00',1.07),('8902','2013-03-13','12:15:00',1.11),('8902','2013-03-13','12:20:00',1.18),('8902','2013-03-13','12:25:00',1.25),('8902','2013-03-13','12:30:00',1.33),('8902','2013-03-13','12:35:00',1.3),('8902','2013-03-13','12:40:00',1.21),('8902','2013-03-13','12:45:00',1.36),('8902','2013-03-13','12:50:00',1.62),('8902','2013-03-13','12:55:00',1.95),('8902','2013-03-13','13:00:00',1.96),('8902','2013-03-13','13:05:00',2.07),('8902','2013-03-13','13:10:00',1.97),('8902','2013-03-13','13:15:00',1.99),('8902','2013-03-13','13:20:00',2.24),('8902','2013-03-13','13:25:00',2.25),('8902','2013-03-13','13:30:00',2.18),('8902','2013-03-13','13:35:00',2.12),('8902','2013-03-13','13:40:00',2.13),('8902','2013-03-13','13:45:00',2.9),('8902','2013-03-13','13:50:00',3.52),('8902','2013-03-13','13:55:00',4.47),('8902','2013-03-13','14:00:00',3.79),('8902','2013-03-13','14:05:00',3.6),('8902','2013-03-13','14:10:00',2.9),('8902','2013-03-13','14:15:00',2.36),('8902','2013-03-13','14:20:00',2.05),('8902','2013-03-13','14:25:00',2.02),('8902','2013-03-13','14:30:00',2.01),('8902','2013-03-13','14:35:00',1.63),('8902','2013-03-13','14:40:00',1.25),('8902','2013-03-13','14:45:00',1.06),('8902','2013-03-13','14:50:00',1.06),('8902','2013-03-13','14:55:00',1.14),('8902','2013-03-13','15:00:00',1.22),('8902','2013-03-13','15:05:00',1.68),('8902','2013-03-13','15:10:00',2.43),('8902','2013-03-13','15:15:00',2.54),('8902','2013-03-13','15:20:00',2.32),('8902','2013-03-13','15:25:00',2.35),('8902','2013-03-13','15:30:00',2.29),('8902','2013-03-13','15:35:00',1.91),('8902','2013-03-13','15:40:00',1.44),('8902','2013-03-13','15:45:00',1.21),('8902','2013-03-13','16:30:00',1.03),('8902','2013-03-12','07:20:00',1.17),('8902','2013-03-12','07:25:00',1.06),('8902','2013-03-12','07:40:00',1.11),('8902','2013-03-12','08:10:00',1.12),('8902','2013-03-12','08:25:00',1.24),('8902','2013-03-12','08:40:00',1.29),('8902','2013-03-12','08:45:00',1.54),('8902','2013-03-12','08:50:00',2.18),('8902','2013-03-12','08:55:00',2.17),('8902','2013-03-12','09:00:00',1.56),('8902','2013-03-12','09:05:00',1.46),('8902','2013-03-12','09:10:00',2.34),('8902','2013-03-12','09:15:00',2.09),('8902','2013-03-12','09:20:00',2.1),('8902','2013-03-12','09:25:00',1.71),('8902','2013-03-12','09:30:00',1.56),('8902','2013-03-12','09:35:00',1.37),('8902','2013-03-12','09:40:00',1.3),('8902','2013-03-12','09:45:00',1.98),('8902','2013-03-12','09:50:00',1.4),('8902','2013-03-12','10:00:00',1.18),('8902','2013-03-12','10:05:00',1.98),('8902','2013-03-12','10:10:00',2.5),('8902','2013-03-12','10:15:00',4.77),('8902','2013-03-12','10:20:00',3.81),('8902','2013-03-12','10:25:00',3.38),('8902','2013-03-12','10:30:00',6.62),('8902','2013-03-12','10:35:00',6.8),('8902','2013-03-12','10:40:00',5.11),('8902','2013-03-12','10:45:00',2.55),('8902','2013-03-12','10:50:00',2.42),('8902','2013-03-12','10:55:00',2.35),('8902','2013-03-12','11:00:00',2.22),('8902','2013-03-12','11:05:00',1.47),('8902','2013-03-12','11:10:00',1.7),('8902','2013-03-12','11:15:00',1.82),('8902','2013-03-12','11:20:00',1.64),('8902','2013-03-12','11:25:00',1.49),('8902','2013-03-12','11:30:00',2.32),('8902','2013-03-12','11:35:00',2.27),('8902','2013-03-12','11:40:00',2.18),('8902','2013-03-12','11:45:00',2.34),('8902','2013-03-12','11:50:00',2.18),('8902','2013-03-12','11:55:00',1.77),('8902','2013-03-12','12:00:00',1.14),('8902','2013-03-12','12:30:00',1.28),('8902','2013-03-12','12:35:00',1.49),('8902','2013-03-12','12:40:00',1.58),('8902','2013-03-12','12:45:00',2.06),('8902','2013-03-12','12:50:00',2.5),('8902','2013-03-12','12:55:00',2.2),('8902','2013-03-12','13:00:00',2.11),('8902','2013-03-12','13:05:00',2.06),('8902','2013-03-12','13:10:00',1.87),('8902','2013-03-12','13:15:00',1.64),('8902','2013-03-12','13:20:00',1.38),('8902','2013-03-12','13:25:00',1.25),('8902','2013-03-12','13:30:00',1.41),('8902','2013-03-12','13:35:00',1.85),('8902','2013-03-12','13:40:00',1.62),('8902','2013-03-12','13:45:00',1.43),('8902','2013-03-12','13:50:00',1.35),('8902','2013-03-12','13:55:00',1.26),('8902','2013-03-12','14:00:00',1.07),('8902','2013-03-12','14:05:00',1.08),('8902','2013-03-12','14:10:00',1.02),('8902','2013-03-12','14:25:00',1.12),('8902','2013-03-12','14:30:00',1.23),('8902','2013-03-12','14:35:00',1.13),('8902','2013-03-12','14:40:00',1.12),('8902','2013-03-12','14:45:00',1.37),('8902','2013-03-12','14:50:00',1.5),('8902','2013-03-12','14:55:00',1.26),('8902','2013-03-12','15:00:00',1.34),('8902','2013-03-12','15:05:00',1.54),('8902','2013-03-12','15:10:00',1.6),('8902','2013-03-12','15:15:00',1.17),('8902','2014-03-24','07:10:00',1.22),('8902','2014-03-24','07:15:00',1.68),('8902','2014-03-24','07:20:00',2.07),('8902','2014-03-24','07:25:00',2.34),('8902','2014-03-24','07:30:00',2.49),('8902','2014-03-24','07:35:00',2.03),('8902','2014-03-24','07:40:00',1.84),('8902','2014-03-24','07:45:00',2),('8902','2014-03-24','07:50:00',2.18),('8902','2014-03-24','07:55:00',2.24),('8902','2014-03-24','08:00:00',2.2),('8902','2014-03-24','08:05:00',2.29),('8902','2014-03-24','08:10:00',2.46),('8902','2014-03-24','08:15:00',2.63),('8902','2014-03-24','08:20:00',2.46),('8902','2014-03-24','08:25:00',2.25),('8902','2014-03-24','08:30:00',2.05),('8902','2014-03-24','08:35:00',2.08),('8902','2014-03-24','08:40:00',2.46),('8902','2014-03-24','08:45:00',3.4),('8902','2014-03-24','08:50:00',3.59),('8902','2014-03-24','08:55:00',3.79),('8902','2014-03-24','09:00:00',3.46),('8902','2014-03-24','09:05:00',3.36),('8902','2014-03-24','09:10:00',3.4),('8902','2014-03-24','09:15:00',4.4),('8902','2014-03-24','09:20:00',4.81),('8902','2014-03-24','09:25:00',4.24),('8902','2014-03-24','09:30:00',3.79),('8902','2014-03-24','09:35:00',3.5),('8902','2014-03-24','09:40:00',3.57),('8902','2014-03-24','09:45:00',3.34),('8902','2014-03-24','09:50:00',3.45),('8902','2014-03-24','09:55:00',3.91),('8902','2014-03-24','10:00:00',4.58),('8902','2014-03-24','10:05:00',4.86),('8902','2014-03-24','10:10:00',5.21),('8902','2014-03-24','10:15:00',5.65),('8902','2014-03-24','10:20:00',5.73),('8902','2014-03-24','10:25:00',5.35),('8902','2014-03-24','10:30:00',5.89),('8902','2014-03-24','10:35:00',4.94),('8902','2014-03-24','10:40:00',4.08),('8902','2014-03-24','10:45:00',3.72),('8902','2014-03-24','10:50:00',3.62),('8902','2014-03-24','10:55:00',3.62),('8902','2014-03-24','11:00:00',3.88),('8902','2014-03-24','11:05:00',4.43),('8902','2014-03-24','11:10:00',4.98),('8902','2014-03-24','11:15:00',5.74),('8902','2014-03-24','11:20:00',6.02),('8902','2014-03-24','11:25:00',5.89),('8902','2014-03-24','11:30:00',4.26),('8902','2014-03-24','11:35:00',6.09),('8902','2014-03-24','11:40:00',4.3),('8902','2014-03-24','11:45:00',4.35),('8902','2014-03-24','11:50:00',3.74),('8902','2014-03-24','11:55:00',3.52),('8902','2014-03-24','12:00:00',2.48),('8902','2014-03-24','12:05:00',1.58),('8902','2014-03-24','12:10:00',1.56),('8902','2014-03-24','12:15:00',1.79),('8902','2014-03-24','12:20:00',2.39),('8902','2014-03-24','12:25:00',2.65),('8902','2014-03-24','12:30:00',1.93),('8902','2014-03-24','12:35:00',1.34),('8902','2014-03-24','12:40:00',1.2),('8902','2014-03-24','13:30:00',1.4),('8902','2014-03-24','13:35:00',1.9),('8902','2014-03-24','13:40:00',1.81),('8902','2014-03-24','13:45:00',1.59),('8902','2014-03-24','13:50:00',1.57),('8902','2014-03-24','13:55:00',1.52),('8902','2014-03-24','14:00:00',1.29),('8902','2014-03-24','14:05:00',1.38),('8902','2014-03-24','14:10:00',1.67),('8902','2014-03-24','14:15:00',1.8),('8902','2014-03-24','14:20:00',1.35),('8902','2014-03-24','14:25:00',1.04),('8902','2014-03-24','14:30:00',1.04),('8902','2014-03-24','14:35:00',1.23),('8902','2014-03-24','14:40:00',1.13),('8902','2014-03-24','14:45:00',1.18),('8902','2014-03-24','15:15:00',1.15),('8902','2014-03-24','15:20:00',1.12),('8902','2013-03-11','08:20:00',2.87),('8902','2013-03-11','08:25:00',3.22),('8902','2013-03-11','08:30:00',3.36),('8902','2013-03-11','08:35:00',3.25),('8902','2013-03-11','08:40:00',3.26),('8902','2013-03-11','08:45:00',4.31),('8902','2013-03-11','08:50:00',3.14),('8902','2013-03-11','08:55:00',1.15),('8902','2013-03-11','09:00:00',1.99),('8902','2013-03-11','09:05:00',4.65),('8902','2013-03-11','09:10:00',4.77),('8902','2013-03-11','09:15:00',4.89),('8902','2013-03-11','09:20:00',5.02),('8902','2013-03-11','09:25:00',5.19),('8902','2013-03-11','09:30:00',4.99),('8902','2013-03-11','09:35:00',5.49),('8902','2013-03-11','09:40:00',5.61),('8902','2013-03-11','09:45:00',6),('8902','2013-03-11','09:50:00',2.32),('8902','2013-03-11','09:55:00',6.49),('8902','2013-03-11','10:00:00',5.95),('8902','2013-03-11','10:05:00',6.47),('8902','2013-03-11','10:10:00',5.67),('8902','2013-03-11','10:15:00',5.61),('8902','2013-03-11','10:20:00',3.57),('8902','2013-03-11','10:25:00',5.13),('8902','2013-03-11','10:30:00',3.46),('8902','2013-03-11','10:35:00',4.71),('8902','2013-03-11','10:40:00',4.04),('8902','2013-03-11','10:45:00',3.53),('8902','2013-03-11','10:50:00',5.56),('8902','2013-03-11','10:55:00',6.35),('8902','2013-03-11','11:00:00',7.95),('8902','2013-03-11','11:05:00',8.32),('8902','2013-03-11','11:10:00',6.37),('8902','2013-03-11','11:15:00',6.98),('8902','2013-03-11','11:20:00',7.17),('8902','2013-03-11','11:25:00',3.27),('8902','2013-03-11','11:30:00',2.84),('8902','2013-03-11','11:35:00',3.6),('8902','2013-03-11','11:40:00',4.18),('8902','2013-03-11','11:45:00',4.15),('8902','2013-03-11','11:50:00',4.8),('8902','2013-03-11','11:55:00',6.47),('8902','2013-03-11','12:00:00',1.75),('8902','2013-03-11','12:05:00',1.19),('8902','2013-03-11','12:10:00',5.51),('8902','2013-03-11','12:15:00',5.45),('8902','2013-03-11','12:20:00',4.3),('8902','2013-03-11','12:25:00',3.88),('8902','2013-03-11','12:30:00',8.29),('8902','2013-03-11','12:35:00',5.41),('8902','2013-03-11','12:40:00',7.92),('8902','2013-03-11','12:45:00',2.24),('8902','2013-03-11','12:50:00',3.17),('8902','2013-03-11','12:55:00',6.35),('8902','2013-03-11','13:00:00',6.22),('8902','2013-03-11','13:05:00',8.22),('8902','2013-03-11','13:10:00',5.14),('8902','2013-03-11','13:15:00',3.68),('8902','2013-03-11','13:20:00',5.65),('8902','2013-03-11','13:25:00',4.28),('8902','2013-03-11','13:30:00',2.65),('8902','2013-03-11','13:35:00',3.1),('8902','2013-03-11','13:40:00',2.31),('8902','2013-03-11','13:45:00',1.65),('8902','2013-03-11','13:50:00',1.71),('8902','2013-03-11','13:55:00',2.82),('8902','2013-03-11','14:00:00',3.23),('8902','2013-03-11','14:05:00',7.21),('8902','2013-03-11','14:10:00',4.75),('8902','2013-03-11','14:15:00',1.9),('8902','2013-03-11','14:20:00',2.37),('8902','2013-03-11','14:35:00',1.44),('8902','2013-03-11','15:00:00',1.17),('8902','2013-03-11','15:10:00',1.43),('8902','2013-03-11','15:15:00',1.15),('8902','2013-03-11','15:20:00',1.45),('8902','2013-03-11','15:25:00',1.36),('8902','2013-03-11','15:30:00',1.11),('8902','2013-03-10','07:40:00',1.26),('8902','2013-03-10','07:45:00',1.03),('8902','2013-03-10','08:10:00',2.24),('8902','2013-03-10','08:15:00',2.65),('8902','2013-03-10','08:20:00',2.85),('8902','2013-03-10','08:25:00',3.06),('8902','2013-03-10','08:30:00',3.26),('8902','2013-03-10','08:35:00',3.47),('8902','2013-03-10','08:40:00',3.63),('8902','2013-03-10','08:45:00',3.79),('8902','2013-03-10','08:50:00',3.99),('8902','2013-03-10','08:55:00',4.14),('8902','2013-03-10','09:00:00',4.27),('8902','2013-03-10','09:05:00',4.47),('8902','2013-03-10','09:10:00',4.59),('8902','2013-03-10','09:15:00',4.84),('8902','2013-03-10','09:20:00',4.58),('8902','2013-03-10','09:25:00',2.86),('8902','2013-03-10','09:30:00',2.19),('8902','2013-03-10','09:35:00',5.62),('8902','2013-03-10','09:40:00',6.33),('8902','2013-03-10','09:45:00',5.04),('8902','2013-03-10','09:50:00',3.09),('8902','2013-03-10','09:55:00',1.67),('8902','2013-03-10','10:00:00',1.5),('8902','2013-03-10','10:05:00',1.65),('8902','2013-03-10','10:10:00',1.99),('8902','2013-03-10','10:15:00',2.07),('8902','2013-03-10','10:20:00',2.3),('8902','2013-03-10','10:25:00',2.67),('8902','2013-03-10','10:30:00',2.47),('8902','2013-03-10','10:35:00',2.86),('8902','2013-03-10','10:40:00',5.11),('8902','2013-03-10','10:45:00',5.23),('8902','2013-03-10','10:50:00',5.92),('8902','2013-03-10','10:55:00',3.5),('8902','2013-03-10','11:00:00',2.88),('8902','2013-03-10','11:05:00',2.49),('8902','2013-03-10','11:10:00',2.95),('8902','2013-03-10','11:15:00',2.98),('8902','2013-03-10','11:20:00',2.54),('8902','2013-03-10','11:25:00',2.41),('8902','2013-03-10','11:30:00',3.51),('8902','2013-03-10','11:35:00',8.6),('8902','2013-03-10','11:40:00',4.83),('8902','2013-03-10','11:45:00',6.77),('8902','2013-03-10','11:50:00',4.7),('8902','2013-03-10','11:55:00',3.59),('8902','2013-03-10','12:00:00',3.25),('8902','2013-03-10','12:05:00',3.08),('8902','2013-03-10','12:10:00',2.67),('8902','2013-03-10','12:15:00',1.29),('8902','2013-03-10','12:20:00',1.58),('8902','2013-03-10','12:25:00',1.73),('8902','2013-03-10','12:30:00',1.88),('8902','2013-03-10','12:35:00',2.25),('8902','2013-03-10','12:40:00',2.36),('8902','2013-03-10','12:45:00',2.41),('8902','2013-03-10','12:50:00',4.9),('8902','2013-03-10','12:55:00',8.84),('8902','2013-03-10','13:00:00',4.92),('8902','2013-03-10','13:05:00',4.08),('8902','2013-03-10','13:10:00',7.39),('8902','2013-03-10','13:15:00',6.42),('8902','2013-03-10','13:20:00',6.58),('8902','2013-03-10','13:25:00',7.34),('8902','2013-03-10','13:30:00',7.24),('8902','2013-03-10','13:35:00',6.96),('8902','2013-03-10','13:40:00',5.74),('8902','2013-03-10','13:45:00',4.28),('8902','2013-03-10','13:50:00',8.07),('8902','2013-03-10','13:55:00',4.49),('8902','2013-03-10','14:00:00',1.93),('8902','2013-03-10','14:05:00',1.72),('8902','2013-03-10','14:10:00',1.5),('8902','2013-03-10','14:15:00',1.09),('8902','2013-03-10','14:20:00',1.01),('8902','2013-03-10','14:25:00',2.89),('8902','2013-03-10','14:30:00',2.24),('8902','2013-03-10','14:35:00',1.86),('8902','2013-03-10','14:40:00',2.12),('8902','2013-03-10','14:45:00',1.86),('8902','2013-03-10','14:50:00',1.15),('8902','2013-03-10','14:55:00',1.07),('8902','2013-03-10','15:00:00',1.02),('8902','2013-03-10','15:05:00',1.04),('8902','2013-03-10','15:15:00',1.05),('8902','2013-03-10','15:20:00',1.06),('8902','2013-03-10','15:25:00',1.17),('8902','2013-03-10','15:30:00',1.41),('8902','2013-03-10','15:35:00',1.74),('8902','2013-03-10','15:40:00',1.94),('8902','2013-03-10','15:45:00',4.76),('8902','2013-03-10','15:50:00',4.88),('8902','2013-03-10','15:55:00',4.56),('8902','2013-03-10','16:00:00',4.44),('8902','2013-03-10','16:05:00',2.78),('8902','2013-03-10','16:10:00',3.41),('8902','2013-03-10','16:15:00',2.53),('8902','2013-03-10','16:20:00',3.25),('8902','2013-03-10','16:25:00',3.23),('8902','2013-03-10','16:30:00',3.17),('8902','2013-03-10','16:35:00',2.59),('8902','2013-03-10','16:40:00',1.53),('8902','2013-03-10','16:45:00',2.95),('8902','2013-03-10','16:50:00',2.36),('8902','2013-03-10','17:05:00',1.06),('8902','2013-03-10','17:15:00',1.01),('8902','2013-03-10','17:20:00',1.07),('8902','2013-03-09','07:35:00',1.16),('8902','2013-03-09','07:40:00',1.08),('8902','2013-03-09','07:45:00',1.48),('8902','2013-03-09','07:50:00',1.66),('8902','2013-03-09','07:55:00',1.94),('8902','2013-03-09','08:00:00',2.09),('8902','2013-03-09','08:05:00',2.3),('8902','2013-03-09','08:10:00',2.43),('8902','2013-03-09','08:15:00',2.6),('8902','2013-03-09','08:20:00',2.87),('8902','2013-03-09','08:25:00',3.07),('8902','2013-03-09','08:30:00',3.24),('8902','2013-03-09','08:35:00',3.43),('8902','2013-03-09','08:40:00',3.62),('8902','2013-03-09','08:45:00',3.8),('8902','2013-03-09','08:50:00',3.95),('8902','2013-03-09','08:55:00',4.15),('8902','2013-03-09','09:00:00',4.32),('8902','2013-03-09','09:05:00',4.48),('8902','2013-03-09','09:10:00',4.61),('8902','2013-03-09','09:15:00',4.79),('8902','2013-03-09','09:20:00',4.91),('8902','2013-03-09','09:25:00',5.06),('8902','2013-03-09','09:30:00',5.22),('8902','2013-03-09','09:35:00',5.38),('8902','2013-03-09','09:40:00',5.64),('8902','2013-03-09','09:45:00',6.02),('8902','2013-03-09','09:50:00',5.49),('8902','2013-03-09','09:55:00',6.61),('8902','2013-03-09','10:00:00',6.62),('8902','2013-03-09','10:05:00',2.92),('8902','2013-03-09','10:10:00',3.56),('8902','2013-03-09','10:15:00',2.68),('8902','2013-03-09','10:20:00',6.77),('8902','2013-03-09','10:25:00',1.51),('8902','2013-03-09','10:30:00',5.41),('8902','2013-03-09','10:35:00',5.96),('8902','2013-03-09','10:40:00',6.59),('8902','2013-03-09','10:45:00',5.77),('8902','2013-03-09','10:50:00',4.84),('8902','2013-03-09','10:55:00',4.32),('8902','2013-03-09','11:00:00',6.31),('8902','2013-03-09','11:05:00',5.68),('8902','2013-03-09','11:10:00',7.05),('8902','2013-03-09','11:15:00',3.65),('8902','2013-03-09','11:20:00',4.77),('8902','2013-03-09','11:25:00',7.46),('8902','2013-03-09','11:30:00',3.45),('8902','2013-03-09','11:35:00',5.75),('8902','2013-03-09','11:40:00',3.72),('8902','2013-03-09','11:45:00',4.49),('8902','2013-03-09','11:50:00',6.84),('8902','2013-03-09','11:55:00',8),('8902','2013-03-09','12:00:00',7.89),('8902','2013-03-09','12:05:00',7.35),('8902','2013-03-09','12:10:00',6.02),('8902','2013-03-09','12:15:00',7.53),('8902','2013-03-09','12:20:00',4.57),('8902','2013-03-09','12:25:00',8.22),('8902','2013-03-09','12:30:00',2.79),('8902','2013-03-09','12:35:00',2.43),('8902','2013-03-09','12:40:00',5.99),('8902','2013-03-09','12:45:00',8.71),('8902','2013-03-09','12:50:00',5.82),('8902','2013-03-09','12:55:00',8.21),('8902','2013-03-09','13:00:00',7.75),('8902','2013-03-09','13:05:00',7.65),('8902','2013-03-09','13:10:00',7.37),('8902','2013-03-09','13:15:00',7.6),('8902','2013-03-09','13:20:00',7.45),('8902','2013-03-09','13:25:00',6.85),('8902','2013-03-09','13:30:00',6.85),('8902','2013-03-09','13:35:00',6.82),('8902','2013-03-09','13:40:00',3.92),('8902','2013-03-09','13:45:00',4.41),('8902','2013-03-09','13:50:00',3.49),('8902','2013-03-09','13:55:00',3.31),('8902','2013-03-09','14:00:00',2.91),('8902','2013-03-09','14:05:00',3.63),('8902','2013-03-09','14:10:00',4.24),('8902','2013-03-09','14:15:00',5.05),('8902','2013-03-09','14:20:00',5.38),('8902','2013-03-09','14:25:00',3.35),('8902','2013-03-09','14:30:00',4.35),('8902','2013-03-09','14:35:00',6.99),('8902','2013-03-09','14:40:00',5.79),('8902','2013-03-09','14:45:00',3.1),('8902','2013-03-09','14:50:00',3.38),('8902','2013-03-09','14:55:00',3.17),('8902','2013-03-09','15:00:00',2.39),('8902','2013-03-09','15:05:00',2.61),('8902','2013-03-09','15:10:00',2.62),('8902','2013-03-09','15:15:00',1.69),('8902','2013-03-09','15:20:00',1.7),('8902','2013-03-09','15:25:00',1.08),('8902','2013-03-09','15:35:00',1.05),('8902','2013-03-09','15:40:00',1.1),('8902','2013-03-09','15:45:00',1.08),('8902','2013-03-09','15:50:00',1.7),('8902','2013-03-09','15:55:00',1.37),('8902','2013-03-08','07:55:00',1.08),('8902','2013-03-08','08:00:00',1.51),('8902','2013-03-08','08:05:00',2.57),('8902','2013-03-08','08:10:00',2.48),('8902','2013-03-08','08:15:00',2.57),('8902','2013-03-08','08:20:00',2.13),('8902','2013-03-08','08:25:00',2.98),('8902','2013-03-08','08:30:00',3.17),('8902','2013-03-08','08:35:00',3.02),('8902','2013-03-08','08:40:00',2.95),('8902','2013-03-08','08:45:00',1.43),('8902','2013-03-08','08:50:00',1.77),('8902','2013-03-08','08:55:00',2.14),('8902','2013-03-08','09:00:00',2.1),('8902','2013-03-08','09:05:00',1.59),('8902','2013-03-08','09:10:00',1.18),('8902','2013-03-08','09:15:00',1.71),('8902','2013-03-08','09:20:00',1.31),('8902','2013-03-08','09:25:00',1.46),('8902','2013-03-08','09:30:00',3.87),('8902','2013-03-08','09:35:00',3),('8902','2013-03-08','09:40:00',5.56),('8902','2013-03-08','09:45:00',5.79),('8902','2013-03-08','09:50:00',5.04),('8902','2013-03-08','09:55:00',6),('8902','2013-03-08','10:00:00',3.6),('8902','2013-03-08','10:05:00',2.27),('8902','2013-03-08','10:10:00',2.51),('8902','2013-03-08','10:15:00',2.23),('8902','2013-03-08','10:20:00',3.9),('8902','2013-03-08','10:25:00',2.42),('8902','2013-03-08','10:30:00',2.87),('8902','2013-03-08','10:35:00',2.11),('8902','2013-03-08','10:40:00',4.03),('8902','2013-03-08','10:45:00',2.69),('8902','2013-03-08','10:50:00',5.56),('8902','2013-03-08','10:55:00',4.7),('8902','2013-03-08','11:00:00',4.48),('8902','2013-03-08','11:05:00',4.19),('8902','2013-03-08','11:10:00',5.19),('8902','2013-03-08','11:15:00',7.97),('8902','2013-03-08','11:20:00',7.68),('8902','2013-03-08','11:25:00',5.97),('8902','2013-03-08','11:30:00',3.57),('8902','2013-03-08','11:35:00',7.56),('8902','2013-03-08','11:40:00',6.25),('8902','2013-03-08','11:45:00',3.74),('8902','2013-03-08','11:50:00',7.99),('8902','2013-03-08','11:55:00',8),('8902','2013-03-08','12:00:00',6.13),('8902','2013-03-08','12:05:00',4.04),('8902','2013-03-08','12:10:00',3.89),('8902','2013-03-08','12:15:00',2.48),('8902','2013-03-08','12:20:00',2.47),('8902','2013-03-08','12:25:00',3.83),('8902','2013-03-08','12:30:00',2.62),('8902','2013-03-08','12:35:00',3.31),('8902','2013-03-08','12:40:00',2.72),('8902','2013-03-08','12:45:00',3.8),('8902','2013-03-08','12:50:00',4.64),('8902','2013-03-08','12:55:00',5.23),('8902','2013-03-08','13:00:00',7.95),('8902','2013-03-08','13:05:00',7.38),('8902','2013-03-08','13:10:00',7.17),('8902','2013-03-08','13:15:00',8.5),('8902','2013-03-08','13:20:00',7.51),('8902','2013-03-08','13:25:00',3.83),('8902','2013-03-08','13:30:00',7.25),('8902','2013-03-08','13:35:00',3.78),('8902','2013-03-08','13:40:00',2.77),('8902','2013-03-08','13:45:00',4.52),('8902','2013-03-08','13:50:00',5.93),('8902','2013-03-08','13:55:00',1.77),('8902','2013-03-08','14:00:00',2.45),('8902','2013-03-08','14:05:00',7.78),('8902','2013-03-08','14:10:00',7.65),('8902','2013-03-08','14:15:00',7.07),('8902','2013-03-08','14:20:00',6.82),('8902','2013-03-08','14:25:00',6.66),('8902','2013-03-08','14:30:00',6.59),('8902','2013-03-08','14:35:00',6.47),('8902','2013-03-08','14:40:00',6.37),('8902','2013-03-08','14:45:00',6.26),('8902','2013-03-08','14:50:00',6.14),('8902','2013-03-08','14:55:00',6.04),('8902','2013-03-08','15:00:00',5.94),('8902','2013-03-08','15:05:00',5.82),('8902','2013-03-08','15:10:00',5.7),('8902','2013-03-08','15:15:00',5.55),('8902','2013-03-08','15:20:00',5.42),('8902','2013-03-08','15:25:00',5.2),('8902','2013-03-08','15:30:00',5.09),('8902','2013-03-08','15:35:00',4.91),('8902','2013-03-08','15:40:00',4.88),('8902','2013-03-08','15:45:00',4.71),('8902','2013-03-08','15:50:00',4.42),('8902','2013-03-08','15:55:00',4.12),('8902','2013-03-08','16:00:00',3.71),('8902','2013-03-08','16:05:00',3.8),('8902','2013-03-08','16:10:00',3.16),('8902','2013-03-08','16:15:00',3.51),('8902','2013-03-08','16:20:00',2.91),('8902','2013-03-08','16:25:00',3.34),('8902','2013-03-08','16:30:00',2.91),('8902','2013-03-08','16:35:00',2.38),('8902','2013-03-08','16:40:00',2.13),('8902','2013-03-08','16:45:00',1.57),('8902','2013-03-08','16:50:00',1.42),('8902','2013-03-07','08:10:00',2.1),('8902','2013-03-07','08:15:00',1.91),('8902','2013-03-07','08:20:00',1.04),('8902','2013-03-07','08:25:00',1.24),('8902','2013-03-07','08:30:00',2.23),('8902','2013-03-07','08:35:00',2.92),('8902','2013-03-07','08:40:00',1.62),('8902','2013-03-07','08:45:00',1.23),('8902','2013-03-07','08:50:00',2.14),('8902','2013-03-07','08:55:00',2),('8902','2013-03-07','09:00:00',1.2),('8902','2013-03-07','09:05:00',1.02),('8902','2013-03-07','09:10:00',1.27),('8902','2013-03-07','09:15:00',1.73),('8902','2013-03-07','09:20:00',1.68),('8902','2013-03-07','09:25:00',1.61),('8902','2013-03-07','09:30:00',2.67),('8902','2013-03-07','09:35:00',3.8),('8902','2013-03-07','09:40:00',2.59),('8902','2013-03-07','09:45:00',4.02),('8902','2013-03-07','09:50:00',5.39),('8902','2013-03-07','09:55:00',3.71),('8902','2013-03-07','10:00:00',1.89),('8902','2013-03-07','10:05:00',2.34),('8902','2013-03-07','10:10:00',2.88),('8902','2013-03-07','10:15:00',2.6),('8902','2013-03-07','10:20:00',3.7),('8902','2013-03-07','10:25:00',3.31),('8902','2013-03-07','10:30:00',2.84),('8902','2013-03-07','10:35:00',5.44),('8902','2013-03-07','10:40:00',4.08),('8902','2013-03-07','10:45:00',2.24),('8902','2013-03-07','10:50:00',2.58),('8902','2013-03-07','10:55:00',2.34),('8902','2013-03-07','11:00:00',2.18),('8902','2013-03-07','11:05:00',1.71),('8902','2013-03-07','11:10:00',1.06),('8902','2013-03-07','11:25:00',1),('8902','2013-03-07','11:30:00',1.29),('8902','2013-03-07','11:35:00',3.42),('8902','2013-03-07','11:40:00',4.63),('8902','2013-03-07','11:45:00',3.65),('8902','2013-03-07','11:50:00',3.16),('8902','2013-03-07','11:55:00',3.37),('8902','2013-03-07','12:00:00',3.79),('8902','2013-03-07','12:05:00',2.27),('8902','2013-03-07','12:10:00',1.71),('8902','2013-03-07','12:15:00',1.57),('8902','2013-03-07','12:20:00',2.71),('8902','2013-03-07','12:25:00',2.19),('8902','2013-03-07','12:30:00',1.99),('8902','2013-03-07','12:35:00',2.9),('8902','2013-03-07','12:40:00',4.3),('8902','2013-03-07','12:45:00',4.87),('8902','2013-03-07','12:50:00',4.74),('8902','2013-03-07','12:55:00',3.85),('8902','2013-03-07','13:00:00',4.31),('8902','2013-03-07','13:05:00',4.61),('8902','2013-03-07','13:10:00',2.85),('8902','2013-03-07','13:15:00',2.31),('8902','2013-03-07','13:20:00',2.18),('8902','2013-03-07','13:25:00',2.79),('8902','2013-03-07','13:30:00',3.48),('8902','2013-03-07','13:35:00',2.54),('8902','2013-03-07','13:40:00',2.29),('8902','2013-03-07','13:45:00',1.41),('8902','2013-03-07','13:50:00',1.17),('8902','2013-03-07','13:55:00',1.78),('8902','2013-03-07','14:00:00',1.18),('8902','2013-03-07','16:55:00',1.18),('8902','2013-03-07','17:00:00',1.05),('8902','2013-03-07','17:05:00',1.02),('8902','2013-03-07','17:10:00',2.13),('8902','2013-03-07','17:15:00',2.33),('8902','2013-03-07','17:20:00',1.26),('8902','2013-03-06','08:35:00',1.1),('8902','2013-03-06','08:40:00',1.57),('8902','2013-03-06','08:45:00',1.55),('8902','2013-03-06','08:50:00',1.86),('8902','2013-03-06','08:55:00',1.54),('8902','2013-03-06','09:00:00',1.47),('8902','2013-03-06','09:05:00',1.52),('8902','2013-03-06','09:10:00',1.25),('8902','2013-03-06','09:15:00',1.28),('8902','2013-03-06','09:20:00',1.92),('8902','2013-03-06','09:55:00',1),('8902','2013-03-06','10:25:00',1.02),('8902','2013-03-06','10:30:00',1.78),('8902','2013-03-06','10:35:00',1.05),('8902','2013-03-06','10:50:00',1.75),('8902','2013-03-06','10:55:00',2.31),('8902','2013-03-06','11:00:00',1.98),('8902','2013-03-06','11:05:00',2.84),('8902','2013-03-06','11:10:00',2.16),('8902','2013-03-06','11:15:00',1.26),('8902','2013-03-06','11:25:00',1.34),('8902','2013-03-06','11:30:00',2.72),('8902','2013-03-06','11:35:00',3.32),('8902','2013-03-06','11:40:00',3.01),('8902','2013-03-06','11:45:00',3.23),('8902','2013-03-06','11:50:00',3.24),('8902','2013-03-06','11:55:00',2.69),('8902','2013-03-06','12:00:00',2.09),('8902','2013-03-06','12:05:00',1.87),('8902','2013-03-06','12:10:00',1.08),('8902','2013-03-06','12:25:00',1.53),('8902','2013-03-06','12:30:00',1.93),('8902','2013-03-06','12:35:00',1.78),('8902','2013-03-06','12:40:00',2.82),('8902','2013-03-06','12:45:00',3.92),('8902','2013-03-06','12:50:00',3.27),('8902','2013-03-06','12:55:00',2.94),('8902','2013-03-06','13:00:00',3.1),('8902','2013-03-06','13:05:00',2.93),('8902','2013-03-06','13:10:00',2.39),('8902','2013-03-06','13:15:00',3.01),('8902','2013-03-06','13:20:00',3.94),('8902','2013-03-06','13:25:00',3.4),('8902','2013-03-06','13:30:00',2.98),('8902','2013-03-06','13:35:00',2.63),('8902','2013-03-06','13:40:00',1.57),('8902','2013-03-06','13:45:00',1.23),('8902','2013-03-06','13:50:00',1.24),('8902','2013-03-06','13:55:00',1.44),('8902','2013-03-06','14:00:00',1.12),('8902','2013-03-06','14:05:00',1.68),('8902','2013-03-06','14:10:00',1.84),('8902','2013-03-06','14:15:00',1.38),('8902','2013-03-06','14:20:00',1.34),('8902','2013-03-06','14:25:00',1.38),('8902','2013-03-06','14:30:00',1.3),('8902','2013-03-06','14:45:00',1.15),('8902','2013-03-06','14:50:00',1.25),('8902','2013-03-06','14:55:00',1.06),('8902','2013-03-06','15:20:00',1.05),('8902','2013-03-06','15:25:00',1.37),('8902','2013-03-06','15:35:00',1.07),('8902','2013-03-06','15:40:00',1.3),('8902','2013-03-06','15:45:00',1.08),('8902','2013-03-06','16:05:00',1.31),('8902','2013-03-06','16:10:00',1.29),('8902','2013-03-06','16:15:00',1.16),('8902','2013-03-06','16:20:00',1.12),('8902','2013-03-06','16:25:00',1.01),('8902','2013-03-06','16:35:00',1.1),('8902','2013-03-06','16:40:00',2.04),('8902','2013-03-06','16:45:00',1.41),('8902','2013-03-05','09:10:00',1.05),('8902','2013-03-05','09:25:00',1.03),('8902','2013-03-05','16:00:00',1.03),('8902','2013-03-05','16:05:00',1.03),('8902','2013-03-04','08:00:00',1.05),('8902','2013-03-04','08:05:00',1.35),('8902','2013-03-04','08:10:00',1.63),('8902','2013-03-04','08:15:00',2.23),('8902','2013-03-04','08:20:00',1.96),('8902','2013-03-04','08:25:00',2.33),('8902','2013-03-04','08:30:00',3.56),('8902','2013-03-04','08:35:00',3.04),('8902','2013-03-04','08:40:00',3.26),('8902','2013-03-04','08:45:00',2.7),('8902','2013-03-04','08:50:00',2.87),('8902','2013-03-04','08:55:00',2.74),('8902','2013-03-04','09:00:00',3.13),('8902','2013-03-04','09:05:00',3.08),('8902','2013-03-04','09:10:00',2.92),('8902','2013-03-04','09:15:00',2.76),('8902','2013-03-04','09:20:00',2.76),('8902','2013-03-04','09:25:00',2.7),('8902','2013-03-04','09:30:00',2.85),('8902','2013-03-04','09:35:00',3.1),('8902','2013-03-04','09:40:00',3.28),('8902','2013-03-04','09:45:00',3.33),('8902','2013-03-04','09:50:00',3.39),('8902','2013-03-04','09:55:00',3.16),('8902','2013-03-04','10:00:00',3.02),('8902','2013-03-04','10:05:00',3.36),('8902','2013-03-04','10:10:00',3.59),('8902','2013-03-04','10:15:00',3.63),('8902','2013-03-04','10:20:00',3.98),('8902','2013-03-04','10:25:00',3.74),('8902','2013-03-04','10:30:00',3.54),('8902','2013-03-04','10:35:00',4.26),('8902','2013-03-04','10:40:00',4.43),('8902','2013-03-04','10:45:00',4.59),('8902','2013-03-04','10:50:00',4.91),('8902','2013-03-04','10:55:00',5.05),('8902','2013-03-04','11:00:00',4.77),('8902','2013-03-04','11:05:00',5.03),('8902','2013-03-04','11:10:00',5.24),('8902','2013-03-04','11:15:00',5.15),('8902','2013-03-04','11:20:00',5.01),('8902','2013-03-04','11:25:00',4.8),('8902','2013-03-04','11:30:00',4.88),('8902','2013-03-04','11:35:00',5.32),('8902','2013-03-04','11:40:00',5.92),('8902','2013-03-04','11:45:00',5.73),('8902','2013-03-04','11:50:00',5.82),('8902','2013-03-04','11:55:00',5.94),('8902','2013-03-04','12:00:00',6.14),('8902','2013-03-04','12:05:00',6.34),('8902','2013-03-04','12:10:00',6.58),('8902','2013-03-04','12:15:00',5.39),('8902','2013-03-04','12:20:00',6.02),('8902','2013-03-04','12:25:00',6.14),('8902','2013-03-04','12:30:00',5.2),('8902','2013-03-04','12:35:00',5.38),('8902','2013-03-04','12:40:00',4.89),('8902','2013-03-04','12:45:00',5.12),('8902','2013-03-04','12:50:00',4.44),('8902','2013-03-04','12:55:00',4.02),('8902','2013-03-04','13:00:00',3.24),('8902','2013-03-04','13:05:00',3.07),('8902','2013-03-04','13:10:00',3.29),('8902','2013-03-04','13:15:00',3.52),('8902','2013-03-04','13:20:00',3.41),('8902','2013-03-04','13:25:00',3.03),('8902','2013-03-04','13:30:00',2.77),('8902','2013-03-04','13:35:00',2.59),('8902','2013-03-04','13:40:00',2.46),('8902','2013-03-04','13:45:00',2.23),('8902','2013-03-04','13:50:00',2.03),('8902','2013-03-04','13:55:00',1.9),('8902','2013-03-04','14:00:00',1.88),('8902','2013-03-04','14:05:00',1.92),('8902','2013-03-04','14:10:00',2.01),('8902','2013-03-04','14:15:00',1.89),('8902','2013-03-04','14:20:00',1.76),('8902','2013-03-04','14:25:00',1.79),('8902','2013-03-04','14:30:00',1.74),('8902','2013-03-04','14:35:00',1.75),('8902','2013-03-04','14:40:00',1.82),('8902','2013-03-04','14:45:00',1.86),('8902','2013-03-04','14:50:00',1.81),('8902','2013-03-04','14:55:00',1.64),('8902','2013-03-04','15:00:00',1.47),('8902','2013-03-04','15:05:00',1.37),('8902','2013-03-04','15:10:00',1.15),('8902','2013-03-04','15:20:00',1.09),('8902','2013-03-04','15:25:00',1.29),('8902','2013-03-04','15:30:00',1.53),('8902','2013-03-04','15:35:00',1.62),('8902','2013-03-04','15:40:00',1.68),('8902','2013-03-04','15:45:00',2.13),('8902','2013-03-04','15:50:00',2.18),('8902','2013-03-04','15:55:00',1.8),('8902','2013-03-04','16:00:00',1.57),('8902','2013-03-04','16:05:00',1.36),('8902','2013-03-04','16:10:00',1.1),('8902','2013-03-03','07:45:00',1.14),('8902','2013-03-03','07:50:00',1.39),('8902','2013-03-03','07:55:00',1.58),('8902','2013-03-03','08:00:00',1.78),('8902','2013-03-03','08:05:00',1.97),('8902','2013-03-03','08:10:00',2.16),('8902','2013-03-03','08:15:00',2.36),('8902','2013-03-03','08:20:00',2.54),('8902','2013-03-03','08:25:00',2.69),('8902','2013-03-03','08:30:00',2.86),('8902','2013-03-03','08:35:00',3.03),('8902','2013-03-03','08:40:00',3.22),('8902','2013-03-03','08:45:00',3.43),('8902','2013-03-03','08:50:00',3.6),('8902','2013-03-03','08:55:00',3.79),('8902','2013-03-03','09:00:00',3.95),('8902','2013-03-03','09:05:00',4.1),('8902','2013-03-03','09:10:00',4.25),('8902','2013-03-03','09:15:00',4.42),('8902','2013-03-03','09:20:00',4.57),('8902','2013-03-03','09:25:00',4.7),('8902','2013-03-03','09:30:00',4.86),('8902','2013-03-03','09:35:00',4.97),('8902','2013-03-03','09:40:00',5.13),('8902','2013-03-03','09:45:00',5.26),('8902','2013-03-03','09:50:00',5.38),('8902','2013-03-03','09:55:00',5.52),('8902','2013-03-03','10:00:00',5.62),('8902','2013-03-03','10:05:00',5.77),('8902','2013-03-03','10:10:00',5.87),('8902','2013-03-03','10:15:00',5.98),('8902','2013-03-03','10:20:00',6.09),('8902','2013-03-03','10:25:00',6.17),('8902','2013-03-03','10:30:00',6.28),('8902','2013-03-03','10:35:00',6.35),('8902','2013-03-03','10:40:00',6.4),('8902','2013-03-03','10:45:00',6.49),('8902','2013-03-03','10:50:00',6.58),('8902','2013-03-03','10:55:00',6.57),('8902','2013-03-03','11:00:00',6.58),('8902','2013-03-03','11:05:00',6.64),('8902','2013-03-03','11:10:00',6.65),('8902','2013-03-03','11:15:00',6.87),('8902','2013-03-03','11:20:00',6.97),('8902','2013-03-03','11:25:00',6.95),('8902','2013-03-03','11:30:00',6.96),('8902','2013-03-03','11:35:00',6.99),('8902','2013-03-03','11:40:00',6.97),('8902','2013-03-03','11:45:00',7.13),('8902','2013-03-03','11:50:00',7.17),('8902','2013-03-03','11:55:00',7.1),('8902','2013-03-03','12:00:00',7.16),('8902','2013-03-03','12:05:00',7.08),('8902','2013-03-03','12:10:00',7.1),('8902','2013-03-03','12:15:00',7.24),('8902','2013-03-03','12:20:00',7.28),('8902','2013-03-03','12:25:00',7.29),('8902','2013-03-03','12:30:00',7.28),('8902','2013-03-03','12:35:00',7.25),('8902','2013-03-03','12:40:00',7.23),('8902','2013-03-03','12:45:00',7.22),('8902','2013-03-03','12:50:00',7.15),('8902','2013-03-03','12:55:00',7.16),('8902','2013-03-03','13:00:00',6.96),('8902','2013-03-03','13:05:00',6.93),('8902','2013-03-03','13:10:00',6.97),('8902','2013-03-03','13:15:00',7.03),('8902','2013-03-03','13:20:00',6.95),('8902','2013-03-03','13:25:00',6.83),('8902','2013-03-03','13:30:00',6.48),('8902','2013-03-03','13:35:00',6.93),('8902','2013-03-03','13:40:00',6.57),('8902','2013-03-03','13:45:00',6.07),('8902','2013-03-03','13:50:00',6.59),('8902','2013-03-03','13:55:00',6.55),('8902','2013-03-03','14:00:00',6.56),('8902','2013-03-03','14:05:00',6.43),('8902','2013-03-03','14:10:00',6.32),('8902','2013-03-03','14:15:00',6.21),('8902','2013-03-03','14:20:00',6.05),('8902','2013-03-03','14:25:00',5.41),('8902','2013-03-03','14:30:00',3.84),('8902','2013-03-03','14:35:00',5.15),('8902','2013-03-03','14:40:00',5.68),('8902','2013-03-03','14:45:00',5.61),('8902','2013-03-03','14:50:00',5.44),('8902','2013-03-03','14:55:00',5.53),('8902','2013-03-03','15:00:00',5.31),('8902','2013-03-03','15:05:00',5.12),('8902','2013-03-03','15:10:00',4.99),('8902','2013-03-03','15:15:00',4.86),('8902','2013-03-03','15:20:00',4.69),('8902','2013-03-03','15:25:00',4.51),('8902','2013-03-03','15:30:00',4.45),('8902','2013-03-03','15:35:00',4.34),('8902','2013-03-03','15:40:00',4.13),('8902','2013-03-03','15:45:00',4),('8902','2013-03-03','15:50:00',3.74),('8902','2013-03-03','15:55:00',3.59),('8902','2013-03-03','16:00:00',3.51),('8902','2013-03-03','16:05:00',3.35),('8902','2013-03-03','16:10:00',3.16),('8902','2013-03-03','16:15:00',3),('8902','2013-03-03','16:20:00',2.85),('8902','2013-03-03','16:25:00',2.73),('8902','2013-03-03','16:30:00',2.5),('8902','2013-03-03','16:35:00',2.2),('8902','2013-03-03','16:40:00',2.16),('8902','2013-03-03','16:45:00',1.98),('8902','2013-03-03','16:50:00',1.8),('8902','2013-03-03','16:55:00',1.6),('8902','2013-03-03','17:00:00',1.39),('8902','2013-03-03','17:05:00',1.18),('8902','2013-03-03','17:10:00',1.03),('8902','2013-03-02','07:40:00',1),('8902','2013-03-02','07:45:00',1.21),('8902','2013-03-02','07:50:00',1.37),('8902','2013-03-02','07:55:00',1.57),('8902','2013-03-02','08:00:00',1.77),('8902','2013-03-02','08:05:00',1.97),('8902','2013-03-02','08:10:00',2.16),('8902','2013-03-02','08:15:00',2.42),('8902','2013-03-02','08:20:00',2.63),('8902','2013-03-02','08:25:00',2.83),('8902','2013-03-02','08:30:00',3.01),('8902','2013-03-02','08:35:00',3.23),('8902','2013-03-02','08:40:00',3.43),('8902','2013-03-02','08:45:00',3.61),('8902','2013-03-02','08:50:00',3.8),('8902','2013-03-02','08:55:00',3.97),('8902','2013-03-02','09:00:00',4.12),('8902','2013-03-02','09:05:00',4.29),('8902','2013-03-02','09:10:00',4.44),('8902','2013-03-02','09:15:00',4.61),('8902','2013-03-02','09:20:00',4.76),('8902','2013-03-02','09:25:00',4.91),('8902','2013-03-02','09:30:00',5.08),('8902','2013-03-02','09:35:00',5.22),('8902','2013-03-02','09:40:00',5.35),('8902','2013-03-02','09:45:00',5.54),('8902','2013-03-02','09:50:00',5.72),('8902','2013-03-02','09:55:00',5.86),('8902','2013-03-02','10:00:00',5.98),('8902','2013-03-02','10:05:00',6.11),('8902','2013-03-02','10:10:00',6.21),('8902','2013-03-02','10:15:00',6.31),('8902','2013-03-02','10:20:00',6.42),('8902','2013-03-02','10:25:00',6.54),('8902','2013-03-02','10:30:00',6.62),('8902','2013-03-02','10:35:00',6.72),('8902','2013-03-02','10:40:00',6.78),('8902','2013-03-02','10:45:00',6.84),('8902','2013-03-02','10:50:00',6.92),('8902','2013-03-02','10:55:00',6.97),('8902','2013-03-02','11:00:00',7),('8902','2013-03-02','11:05:00',7.05),('8902','2013-03-02','11:10:00',7.07),('8902','2013-03-02','11:15:00',7.12),('8902','2013-03-02','11:20:00',7.19),('8902','2013-03-02','11:25:00',7.23),('8902','2013-03-02','11:30:00',7.26),('8902','2013-03-02','11:35:00',7.28),('8902','2013-03-02','11:40:00',7.36),('8902','2013-03-02','11:45:00',7.41),('8902','2013-03-02','11:50:00',7.42),('8902','2013-03-02','11:55:00',7.42),('8902','2013-03-02','12:00:00',7.44),('8902','2013-03-02','12:05:00',7.46),('8902','2013-03-02','12:10:00',7.49),('8902','2013-03-02','12:15:00',7.48),('8902','2013-03-02','12:20:00',7.5),('8902','2013-03-02','12:25:00',7.49),('8902','2013-03-02','12:30:00',7.52),('8902','2013-03-02','12:35:00',7.51),('8902','2013-03-02','12:40:00',7.49),('8902','2013-03-02','12:45:00',7.48),('8902','2013-03-02','12:50:00',7.46),('8902','2013-03-02','12:55:00',7.45),('8902','2013-03-02','13:00:00',7.42),('8902','2013-03-02','13:05:00',7.4),('8902','2013-03-02','13:10:00',7.4),('8902','2013-03-02','13:15:00',7.39),('8902','2013-03-02','13:20:00',7.31),('8902','2013-03-02','13:25:00',7.27),('8902','2013-03-02','13:30:00',7.24),('8902','2013-03-02','13:35:00',7.17),('8902','2013-03-02','13:40:00',7.1),('8902','2013-03-02','13:45:00',7.05),('8902','2013-03-02','13:50:00',6.94),('8902','2013-03-02','13:55:00',6.9),('8902','2013-03-02','14:00:00',6.85),('8902','2013-03-02','14:05:00',6.75),('8902','2013-03-02','14:10:00',6.72),('8902','2013-03-02','14:15:00',6.66),('8902','2013-03-02','14:20:00',6.61),('8902','2013-03-02','14:25:00',6.49),('8902','2013-03-02','14:30:00',6.38),('8902','2013-03-02','14:35:00',6.28),('8902','2013-03-02','14:40:00',6.2),('8902','2013-03-02','14:45:00',6.06),('8902','2013-03-02','14:50:00',5.98),('8902','2013-03-02','14:55:00',5.84),('8902','2013-03-02','15:00:00',5.71),('8902','2013-03-02','15:05:00',5.6),('8902','2013-03-02','15:10:00',5.43),('8902','2013-03-02','15:15:00',5.36),('8902','2013-03-02','15:20:00',5.26),('8902','2013-03-02','15:25:00',5.1),('8902','2013-03-02','15:30:00',4.93),('8902','2013-03-02','15:35:00',4.81),('8902','2013-03-02','15:40:00',4.62),('8902','2013-03-02','15:45:00',4.48),('8902','2013-03-02','15:50:00',4.27),('8902','2013-03-02','15:55:00',4.12),('8902','2013-03-02','16:00:00',3.94),('8902','2013-03-02','16:05:00',3.75),('8902','2013-03-02','16:10:00',3.62),('8902','2013-03-02','16:15:00',3.39),('8902','2013-03-02','16:23:00',3.23),('8902','2013-03-02','16:25:00',2.94),('8902','2013-03-02','16:33:00',2.81),('8902','2013-03-02','16:35:00',2.53),('8902','2013-03-02','16:46:00',2.42),('8902','2013-03-02','16:50:00',1.99),('8902','2013-03-02','16:58:00',1.8),('8902','2013-03-02','17:00:00',1.48),('8902','2013-03-02','17:08:00',1.37),('8902','2013-03-02','17:10:00',1.1),('8902','2014-03-23','07:35:00',1.11),('8902','2014-03-23','07:45:00',2.05),('8902','2014-03-23','07:50:00',1.57),('8902','2014-03-23','07:55:00',1.52),('8902','2014-03-23','08:30:00',1.02),('8902','2014-03-23','08:35:00',1.57),('8902','2014-03-23','08:40:00',1.69),('8902','2014-03-23','08:45:00',1.38),('8902','2014-03-23','08:50:00',1.45),('8902','2014-03-23','08:55:00',2.93),('8902','2014-03-23','09:00:00',3.31),('8902','2014-03-23','09:05:00',2.92),('8902','2014-03-23','09:10:00',1.3),('8902','2014-03-23','09:15:00',1.32),('8902','2014-03-23','09:20:00',4.02),('8902','2014-03-23','09:25:00',1.58),('8902','2014-03-23','09:30:00',2.89),('8902','2014-03-23','09:35:00',1.65),('8902','2014-03-23','09:40:00',2.87),('8902','2014-03-23','09:45:00',2.33),('8902','2014-03-23','09:50:00',2),('8902','2014-03-23','09:55:00',1.25),('8902','2014-03-23','10:00:00',3.53),('8902','2014-03-23','10:05:00',4.31),('8902','2014-03-23','10:10:00',6.55),('8902','2014-03-23','10:15:00',5.94),('8902','2014-03-23','10:20:00',1.79),('8902','2014-03-23','10:25:00',1.5),('8902','2014-03-23','10:30:00',1.42),('8902','2014-03-23','10:35:00',2.57),('8902','2014-03-23','10:40:00',2.33),('8902','2014-03-23','10:45:00',3.01),('8902','2014-03-23','10:50:00',9.11),('8902','2014-03-23','10:55:00',7.96),('8902','2014-03-23','11:00:00',2.95),('8902','2014-03-23','11:05:00',5.21),('8902','2014-03-23','11:10:00',5.18),('8902','2014-03-23','11:15:00',5.79),('8902','2014-03-23','11:20:00',4.1),('8902','2014-03-23','11:25:00',5.06),('8902','2014-03-23','11:30:00',6.58),('8902','2014-03-23','11:35:00',3.82),('8902','2014-03-23','11:40:00',1.5),('8902','2014-03-23','11:45:00',1.18),('8902','2014-03-23','11:50:00',1.15),('8902','2014-03-23','11:55:00',1.46),('8902','2014-03-23','12:00:00',1.37),('8902','2014-03-23','12:20:00',1.17),('8902','2014-03-23','12:25:00',1.34),('8902','2014-03-23','12:30:00',2.07),('8902','2014-03-23','12:35:00',3.54),('8902','2014-03-23','12:40:00',3.89),('8902','2014-03-23','12:45:00',3.44),('8902','2014-03-23','12:50:00',2.86),('8902','2014-03-23','12:55:00',2.66),('8902','2014-03-23','13:00:00',2.71),('8902','2014-03-23','13:05:00',2.71),('8902','2014-03-23','13:10:00',2.43),('8902','2014-03-23','13:15:00',1.93),('8902','2014-03-23','13:20:00',1.84),('8902','2014-03-23','13:25:00',2.29),('8902','2014-03-23','13:30:00',2.71),('8902','2014-03-23','13:35:00',2.46),('8902','2014-03-23','13:40:00',1.33),('8902','2014-03-23','13:45:00',1.55),('8902','2014-03-23','13:50:00',2.6),('8902','2014-03-23','13:55:00',2.52),('8902','2014-03-23','14:00:00',2.35),('8902','2014-03-23','14:05:00',2.03),('8902','2014-03-23','14:10:00',2.37),('8902','2014-03-23','14:15:00',3.09),('8902','2014-03-23','14:20:00',4.11),('8902','2014-03-23','14:25:00',4.04),('8902','2014-03-23','14:30:00',3.51),('8902','2014-03-23','14:35:00',4.52),('8902','2014-03-23','14:40:00',5.85),('8902','2014-03-23','14:45:00',6.86),('8902','2014-03-23','14:50:00',7.27),('8902','2014-03-23','14:55:00',6.4),('8902','2014-03-23','15:00:00',5.7),('8902','2014-03-23','15:05:00',5.08),('8902','2014-03-23','15:10:00',4.47),('8902','2014-03-23','15:15:00',2.79),('8902','2014-03-23','15:20:00',3.34),('8902','2014-03-23','15:25:00',2.71),('8902','2014-03-23','15:30:00',3.68),('8902','2014-03-23','15:35:00',2.86),('8902','2014-03-23','15:40:00',2.49),('8902','2014-03-23','15:45:00',2.21),('8902','2014-03-23','15:50:00',2.75),('8902','2014-03-23','15:55:00',2.96),('8902','2014-03-23','16:00:00',5.95),('8902','2014-03-23','16:05:00',2.78),('8902','2014-03-23','16:10:00',2.22),('8902','2014-03-23','16:15:00',1.73),('8902','2014-03-23','16:20:00',1.12),('8902','2013-03-01','09:00:00',1.03),('8902','2013-03-01','09:40:00',1.1),('8902','2013-03-01','09:45:00',1.22),('8902','2013-03-01','09:50:00',1.28),('8902','2013-03-01','09:55:00',1.11),('8902','2013-03-01','10:00:00',1.11),('8902','2013-03-01','10:05:00',1.11),('8902','2013-03-01','10:10:00',1.01),('8902','2013-03-01','10:15:00',1.1),('8902','2013-03-01','10:20:00',1.28),('8902','2013-03-01','10:25:00',1.31),('8902','2013-03-01','10:30:00',1.39),('8902','2013-03-01','10:35:00',1.57),('8902','2013-03-01','10:40:00',1.71),('8902','2013-03-01','10:45:00',1.71),('8902','2013-03-01','10:50:00',1.89),('8902','2013-03-01','10:55:00',1.99),('8902','2013-03-01','11:00:00',2.09),('8902','2013-03-01','11:05:00',2.07),('8902','2013-03-01','11:10:00',2.3),('8902','2013-03-01','11:15:00',2.55),('8902','2013-03-01','11:20:00',2.29),('8902','2013-03-01','11:25:00',1.99),('8902','2013-03-01','11:30:00',1.88),('8902','2013-03-01','11:35:00',1.98),('8902','2013-03-01','11:40:00',2.2),('8902','2013-03-01','11:45:00',1.99),('8902','2013-03-01','11:50:00',2.01),('8902','2013-03-01','11:55:00',1.86),('8902','2013-03-01','12:00:00',1.85),('8902','2013-03-01','12:05:00',2.15),('8902','2013-03-01','12:10:00',2.2),('8902','2013-03-01','12:15:00',2.21),('8902','2013-03-01','12:20:00',2.05),('8902','2013-03-01','12:25:00',2.22),('8902','2013-03-01','12:30:00',2.25),('8902','2013-03-01','12:35:00',2.51),('8902','2013-03-01','12:40:00',2.58),('8902','2013-03-01','12:45:00',2.4),('8902','2013-03-01','12:50:00',2.33),('8902','2013-03-01','12:55:00',2.69),('8902','2013-03-01','13:00:00',2.68),('8902','2013-03-01','13:05:00',2.38),('8902','2013-03-01','13:10:00',1.99),('8902','2013-03-01','13:15:00',1.73),('8902','2013-03-01','13:20:00',1.63),('8902','2013-03-01','13:25:00',1.6),('8902','2013-03-01','13:30:00',1.72),('8902','2013-03-01','13:35:00',1.72),('8902','2013-03-01','13:40:00',1.86),('8902','2013-03-01','13:45:00',2.07),('8902','2013-03-01','13:50:00',2),('8902','2013-03-01','13:55:00',2.15),('8902','2013-03-01','14:00:00',2.5),('8902','2013-03-01','14:05:00',2.49),('8902','2013-03-01','14:10:00',2.1),('8902','2013-03-01','14:15:00',1.83),('8902','2013-03-01','14:20:00',1.74),('8902','2013-03-01','14:25:00',1.48),('8902','2013-03-01','14:30:00',1.02),('8902','2013-03-01','14:50:00',1.19),('8902','2013-03-01','14:55:00',1.29),('8902','2013-03-01','15:00:00',1.33),('8902','2013-03-01','15:05:00',1.49),('8902','2013-03-01','15:10:00',1.44),('8902','2013-03-01','15:15:00',1.45),('8902','2013-03-01','15:20:00',1.38),('8902','2013-03-01','15:25:00',1.33),('8902','2013-03-01','15:30:00',1.5),('8902','2013-03-01','15:35:00',1.46),('8902','2013-03-01','15:40:00',1.45),('8902','2013-03-01','15:45:00',1.57),('8902','2013-03-01','15:50:00',1.34),('8902','2013-03-01','15:55:00',1.28),('8902','2013-03-01','16:00:00',1.15),('8902','2013-03-01','16:05:00',1.02),('8902','2013-02-28','07:45:00',1.03),('8902','2013-02-28','07:50:00',1.17),('8902','2013-02-28','07:55:00',1.46),('8902','2013-02-28','08:00:00',1.64),('8902','2013-02-28','08:05:00',1.74),('8902','2013-02-28','08:10:00',1.8),('8902','2013-02-28','08:15:00',1.92),('8902','2013-02-28','08:20:00',2.06),('8902','2013-02-28','08:25:00',2.08),('8902','2013-02-28','08:30:00',2.24),('8902','2013-02-28','08:35:00',2.41),('8902','2013-02-28','08:40:00',2.61),('8902','2013-02-28','08:45:00',2.8),('8902','2013-02-28','08:50:00',2.92),('8902','2013-02-28','08:55:00',3.16),('8902','2013-02-28','09:00:00',3.35),('8902','2013-02-28','09:05:00',3.71),('8902','2013-02-28','09:10:00',3.73),('8902','2013-02-28','09:15:00',3.76),('8902','2013-02-28','09:20:00',3.91),('8902','2013-02-28','09:25:00',3.83),('8902','2013-02-28','09:30:00',4.28),('8902','2013-02-28','09:35:00',4.18),('8902','2013-02-28','09:40:00',4.51),('8902','2013-02-28','09:45:00',4.77),('8902','2013-02-28','09:50:00',4.81),('8902','2013-02-28','09:55:00',4.75),('8902','2013-02-28','10:00:00',4.96),('8902','2013-02-28','10:05:00',5.01),('8902','2013-02-28','10:10:00',4.95),('8902','2013-02-28','10:15:00',4.23),('8902','2013-02-28','10:20:00',4.09),('8902','2013-02-28','10:25:00',4.35),('8902','2013-02-28','10:30:00',4.78),('8902','2013-02-28','10:35:00',5.16),('8902','2013-02-28','10:40:00',4.65),('8902','2013-02-28','10:45:00',4.38),('8902','2013-02-28','10:50:00',4.12),('8902','2013-02-28','10:55:00',3.87),('8902','2013-02-28','11:00:00',3.39),('8902','2013-02-28','11:05:00',2.94),('8902','2013-02-28','11:10:00',2.81),('8902','2013-02-28','11:15:00',3.13),('8902','2013-02-28','11:20:00',3.32),('8902','2013-02-28','11:25:00',3.31),('8902','2013-02-28','11:30:00',3.36),('8902','2013-02-28','11:35:00',3.41),('8902','2013-02-28','11:40:00',3.22),('8902','2013-02-28','11:45:00',3.07),('8902','2013-02-28','11:50:00',3.04),('8902','2013-02-28','11:55:00',2.89),('8902','2013-02-28','12:00:00',2.76),('8902','2013-02-28','12:05:00',2.63),('8902','2013-02-28','12:10:00',2.45),('8902','2013-02-28','12:15:00',2.22),('8902','2013-02-28','12:20:00',2.09),('8902','2013-02-28','12:25:00',2.06),('8902','2013-02-28','12:30:00',2.13),('8902','2013-02-28','12:35:00',2.12),('8902','2013-02-28','12:40:00',2.05),('8902','2013-02-28','12:45:00',2.05),('8902','2013-02-28','12:50:00',2.09),('8902','2013-02-28','12:55:00',2.21),('8902','2013-02-28','13:00:00',2.35),('8902','2013-02-28','13:05:00',2.39),('8902','2013-02-28','13:10:00',2.47),('8902','2013-02-28','13:15:00',2.65),('8902','2013-02-28','13:20:00',2.86),('8902','2013-02-28','13:25:00',3.14),('8902','2013-02-28','13:30:00',3.08),('8902','2013-02-28','13:35:00',2.85),('8902','2013-02-28','13:40:00',2.7),('8902','2013-02-28','13:45:00',2.68),('8902','2013-02-28','13:50:00',2.68),('8902','2013-02-28','13:55:00',2.56),('8902','2013-02-28','14:00:00',2.48),('8902','2013-02-28','14:05:00',2.37),('8902','2013-02-28','14:10:00',2.22),('8902','2013-02-28','14:15:00',2.1),('8902','2013-02-28','14:20:00',2.02),('8902','2013-02-28','14:25:00',2.03),('8902','2013-02-28','14:30:00',2.09),('8902','2013-02-28','14:35:00',2.1),('8902','2013-02-28','14:40:00',2),('8902','2013-02-28','14:45:00',1.87),('8902','2013-02-28','14:50:00',1.77),('8902','2013-02-28','14:55:00',1.75),('8902','2013-02-28','15:00:00',1.75),('8902','2013-02-28','15:05:00',1.69),('8902','2013-02-28','15:10:00',1.55),('8902','2013-02-28','15:15:00',1.42),('8902','2013-02-28','15:20:00',1.33),('8902','2013-02-28','15:25:00',1.18),('8902','2013-02-28','15:30:00',1.06),('8902','2013-02-28','15:35:00',1.07),('8902','2013-02-28','15:40:00',1.19),('8902','2013-02-28','15:45:00',1.18),('8902','2013-02-28','15:50:00',1.11),('8902','2013-02-28','15:55:00',1.08),('8902','2013-02-28','16:00:00',1.1),('8902','2013-02-28','16:05:00',1.09),('8902','2013-02-28','16:10:00',1.04),('8902','2013-02-27','07:50:00',1.06),('8902','2013-02-27','07:55:00',1.32),('8902','2013-02-27','08:00:00',1.49),('8902','2013-02-27','08:05:00',1.65),('8902','2013-02-27','08:10:00',1.82),('8902','2013-02-27','08:15:00',2.01),('8902','2013-02-27','08:20:00',2.22),('8902','2013-02-27','08:25:00',2.39),('8902','2013-02-27','08:30:00',2.55),('8902','2013-02-27','08:35:00',2.73),('8902','2013-02-27','08:40:00',2.94),('8902','2013-02-27','08:45:00',3.12),('8902','2013-02-27','08:50:00',3.35),('8902','2013-02-27','08:55:00',3.53),('8902','2013-02-27','09:00:00',3.68),('8902','2013-02-27','09:05:00',3.83),('8902','2013-02-27','09:10:00',3.97),('8902','2013-02-27','09:15:00',4.05),('8902','2013-02-27','09:20:00',4.3),('8902','2013-02-27','09:25:00',4.43),('8902','2013-02-27','09:30:00',4.6),('8902','2013-02-27','09:35:00',4.73),('8902','2013-02-27','09:40:00',4.88),('8902','2013-02-27','09:45:00',5.01),('8902','2013-02-27','09:50:00',4.76),('8902','2013-02-27','09:55:00',5.21),('8902','2013-02-27','10:00:00',5.31),('8902','2013-02-27','10:05:00',5.44),('8902','2013-02-27','10:10:00',5.51),('8902','2013-02-27','10:15:00',5.57),('8902','2013-02-27','10:20:00',5.68),('8902','2013-02-27','10:25:00',5.74),('8902','2013-02-27','10:30:00',5.84),('8902','2013-02-27','10:35:00',6.02),('8902','2013-02-27','10:40:00',6.14),('8902','2013-02-27','10:45:00',6.15),('8902','2013-02-27','10:50:00',6.2),('8902','2013-02-27','10:55:00',6.28),('8902','2013-02-27','11:00:00',6.42),('8902','2013-02-27','11:05:00',6.51),('8902','2013-02-27','11:10:00',6.53),('8902','2013-02-27','11:15:00',6.63),('8902','2013-02-27','11:20:00',6.74),('8902','2013-02-27','11:25:00',6.84),('8902','2013-02-27','11:30:00',6.86),('8902','2013-02-27','11:35:00',6.88),('8902','2013-02-27','11:40:00',6.92),('8902','2013-02-27','11:45:00',6.94),('8902','2013-02-27','11:50:00',6.92),('8902','2013-02-27','11:55:00',6.71),('8902','2013-02-27','12:00:00',6.59),('8902','2013-02-27','12:05:00',6.94),('8902','2013-02-27','12:10:00',7.09),('8902','2013-02-27','12:15:00',7.05),('8902','2013-02-27','12:20:00',6.97),('8902','2013-02-27','12:25:00',6.82),('8902','2013-02-27','12:30:00',6.85),('8902','2013-02-27','12:35:00',6.84),('8902','2013-02-27','12:40:00',7.01),('8902','2013-02-27','12:45:00',6.93),('8902','2013-02-27','12:50:00',6.92),('8902','2013-02-27','12:55:00',7.1),('8902','2013-02-27','13:00:00',6.81),('8902','2013-02-27','13:05:00',6.92),('8902','2013-02-27','13:10:00',6.92),('8902','2013-02-27','13:15:00',6.97),('8902','2013-02-27','13:20:00',7),('8902','2013-02-27','13:25:00',6.96),('8902','2013-02-27','13:30:00',6.87),('8902','2013-02-27','13:35:00',6.77),('8902','2013-02-27','13:40:00',6.79),('8902','2013-02-27','13:45:00',6.88),('8902','2013-02-27','13:50:00',6.91),('8902','2013-02-27','13:55:00',6.86),('8902','2013-02-27','14:00:00',6.83),('8902','2013-02-27','14:05:00',6.75),('8902','2013-02-27','14:10:00',6.72),('8902','2013-02-27','14:15:00',6.44),('8902','2013-02-27','14:20:00',5.73),('8902','2013-02-27','14:25:00',5.53),('8902','2013-02-27','14:30:00',5.69),('8902','2013-02-27','14:35:00',5.47),('8902','2013-02-27','14:40:00',5.62),('8902','2013-02-27','14:45:00',5.58),('8902','2013-02-27','14:50:00',5.43),('8902','2013-02-27','14:55:00',5.28),('8902','2013-02-27','15:00:00',5.19),('8902','2013-02-27','15:05:00',4.9),('8902','2013-02-27','15:10:00',4.81),('8902','2013-02-27','15:15:00',4.73),('8902','2013-02-27','15:20:00',4.62),('8902','2013-02-27','15:25:00',4.26),('8902','2013-02-27','15:30:00',4.01),('8902','2013-02-27','15:35:00',3.87),('8902','2013-02-27','15:40:00',3.76),('8902','2013-02-27','15:45:00',3.66),('8902','2013-02-27','15:50:00',3.54),('8902','2013-02-27','15:55:00',3.4),('8902','2013-02-27','16:00:00',3.21),('8902','2013-02-27','16:05:00',3),('8902','2013-02-27','16:10:00',2.84),('8902','2013-02-27','16:15:00',2.68),('8902','2013-02-27','16:20:00',2.49),('8902','2013-02-27','16:25:00',2.32),('8902','2013-02-27','16:30:00',2.05),('8902','2013-02-27','16:35:00',2.02),('8902','2013-02-27','16:40:00',1.88),('8902','2013-02-27','16:45:00',1.74),('8902','2013-02-27','16:50:00',1.59),('8902','2013-02-27','16:55:00',1.39),('8902','2013-02-27','17:00:00',1.2),('8902','2013-02-26','07:50:00',1.04),('8902','2013-02-26','07:55:00',1.25),('8902','2013-02-26','08:00:00',1.43),('8902','2013-02-26','08:05:00',1.6),('8902','2013-02-26','08:10:00',1.76),('8902','2013-02-26','08:15:00',1.94),('8902','2013-02-26','08:20:00',2.13),('8902','2013-02-26','08:25:00',2.31),('8902','2013-02-26','08:30:00',2.48),('8902','2013-02-26','08:35:00',2.66),('8902','2013-02-26','08:40:00',2.81),('8902','2013-02-26','08:45:00',2.99),('8902','2013-02-26','08:50:00',3.17),('8902','2013-02-26','08:55:00',3.36),('8902','2013-02-26','09:00:00',3.53),('8902','2013-02-26','09:05:00',3.72),('8902','2013-02-26','09:10:00',3.89),('8902','2013-02-26','09:15:00',4.03),('8902','2013-02-26','09:20:00',4.17),('8902','2013-02-26','09:25:00',4.3),('8902','2013-02-26','09:30:00',4.44),('8902','2013-02-26','09:35:00',4.58),('8902','2013-02-26','09:40:00',4.76),('8902','2013-02-26','09:45:00',4.86),('8902','2013-02-26','09:50:00',5),('8902','2013-02-26','09:55:00',5.1),('8902','2013-02-26','10:00:00',5.24),('8902','2013-02-26','10:05:00',5.36),('8902','2013-02-26','10:10:00',5.45),('8902','2013-02-26','10:15:00',5.59),('8902','2013-02-26','10:20:00',5.64),('8902','2013-02-26','10:25:00',5.69),('8902','2013-02-26','10:30:00',5.86),('8902','2013-02-26','10:35:00',6.01),('8902','2013-02-26','10:40:00',6.02),('8902','2013-02-26','10:45:00',6.09),('8902','2013-02-26','10:50:00',6.18),('8902','2013-02-26','10:55:00',6.31),('8902','2013-02-26','11:00:00',6.32),('8902','2013-02-26','11:05:00',6.31),('8902','2013-02-26','11:10:00',6.46),('8902','2013-02-26','11:15:00',6.55),('8902','2013-02-26','11:20:00',6.51),('8902','2013-02-26','11:25:00',6.77),('8902','2013-02-26','11:30:00',7.05),('8902','2013-02-26','11:35:00',6.05),('8902','2013-02-26','11:40:00',3.72),('8902','2013-02-26','11:45:00',3.02),('8902','2013-02-26','11:50:00',6.3),('8902','2013-02-26','11:55:00',3.53),('8902','2013-02-26','12:00:00',6.37),('8902','2013-02-26','12:05:00',7.43),('8902','2013-02-26','12:10:00',7.34),('8902','2013-02-26','12:15:00',7.34),('8902','2013-02-26','12:20:00',7.57),('8902','2013-02-26','12:25:00',7.49),('8902','2013-02-26','12:30:00',7.14),('8902','2013-02-26','12:35:00',7.17),('8902','2013-02-26','12:40:00',7.27),('8902','2013-02-26','12:45:00',7.25),('8902','2013-02-26','12:50:00',7.15),('8902','2013-02-26','12:55:00',7.03),('8902','2013-02-26','13:00:00',7.09),('8902','2013-02-26','13:05:00',7.26),('8902','2013-02-26','13:10:00',7.22),('8902','2013-02-26','13:15:00',6.92),('8902','2013-02-26','13:20:00',4.61),('8902','2013-02-26','13:25:00',2.26),('8902','2013-02-26','13:30:00',4.14),('8902','2013-02-26','13:35:00',7.24),('8902','2013-02-26','13:40:00',7.17),('8902','2013-02-26','13:45:00',7.14),('8902','2013-02-26','13:50:00',6.23),('8902','2013-02-26','13:55:00',5.66),('8902','2013-02-26','14:00:00',5.95),('8902','2013-02-26','14:05:00',5.97),('8902','2013-02-26','14:10:00',6.31),('8902','2013-02-26','14:15:00',4.98),('8902','2013-02-26','14:20:00',4.22),('8902','2013-02-26','14:25:00',5.45),('8902','2013-02-26','14:30:00',5.7),('8902','2013-02-26','14:35:00',5.86),('8902','2013-02-26','14:40:00',5.72),('8902','2013-02-26','14:45:00',5.82),('8902','2013-02-26','14:50:00',5.72),('8902','2013-02-26','14:55:00',5.1),('8902','2013-02-26','15:00:00',5.38),('8902','2013-02-26','15:05:00',5.28),('8902','2013-02-26','15:10:00',5.18),('8902','2013-02-26','15:15:00',4.9),('8902','2013-02-26','15:20:00',4.69),('8902','2013-02-26','15:25:00',4.58),('8902','2013-02-26','15:30:00',4.53),('8902','2013-02-26','15:35:00',4.32),('8902','2013-02-26','15:40:00',4.14),('8902','2013-02-26','15:45:00',4.01),('8902','2013-02-26','15:50:00',3.84),('8902','2013-02-26','15:55:00',3.68),('8902','2013-02-26','16:00:00',3.55),('8902','2013-02-26','16:05:00',3.37),('8902','2013-02-26','16:10:00',3.19),('8902','2013-02-26','16:15:00',2.98),('8902','2013-02-26','16:20:00',2.84),('8902','2013-02-26','16:25:00',2.66),('8902','2013-02-26','16:30:00',2.38),('8902','2013-02-26','16:35:00',2.21),('8902','2013-02-26','16:40:00',2.05),('8902','2013-02-26','16:45:00',1.85),('8902','2013-02-26','16:50:00',1.65),('8902','2013-02-26','16:55:00',1.45),('8902','2013-02-26','17:00:00',1.22),('8902','2013-02-26','17:05:00',1.02),('8902','2013-02-25','08:50:00',1.13),('8902','2013-02-25','08:55:00',1.3),('8902','2013-02-25','09:00:00',1.43),('8902','2013-02-25','09:05:00',1.53),('8902','2013-02-25','09:10:00',1.66),('8902','2013-02-25','09:15:00',1.77),('8902','2013-02-25','09:20:00',1.91),('8902','2013-02-25','09:25:00',2.11),('8902','2013-02-25','09:30:00',2.58),('8902','2013-02-25','09:35:00',3.15),('8902','2013-02-25','09:40:00',3.43),('8902','2013-02-25','09:45:00',3.39),('8902','2013-02-25','09:50:00',3.55),('8902','2013-02-25','09:55:00',3.87),('8902','2013-02-25','10:00:00',3.66),('8902','2013-02-25','10:05:00',3.66),('8902','2013-02-25','10:10:00',4.43),('8902','2013-02-25','10:15:00',5.16),('8902','2013-02-25','10:20:00',6),('8902','2013-02-25','10:25:00',6.53),('8902','2013-02-25','10:30:00',6.33),('8902','2013-02-25','10:35:00',5.85),('8902','2013-02-25','10:40:00',3.35),('8902','2013-02-25','10:45:00',2.69),('8902','2013-02-25','10:50:00',3.15),('8902','2013-02-25','10:55:00',3.22),('8902','2013-02-25','11:00:00',3.56),('8902','2013-02-25','11:05:00',4.53),('8902','2013-02-25','11:10:00',3.67),('8902','2013-02-25','11:15:00',3.32),('8902','2013-02-25','11:20:00',3.15),('8902','2013-02-25','11:25:00',2.97),('8902','2013-02-25','11:30:00',2.85),('8902','2013-02-25','11:35:00',2.78),('8902','2013-02-25','11:40:00',3.01),('8902','2013-02-25','11:45:00',2.92),('8902','2013-02-25','11:50:00',3.2),('8902','2013-02-25','11:55:00',3.23),('8902','2013-02-25','12:00:00',3.14),('8902','2013-02-25','12:05:00',3.02),('8902','2013-02-25','12:10:00',3.1),('8902','2013-02-25','12:15:00',2.75),('8902','2013-02-25','12:20:00',2.72),('8902','2013-02-25','12:25:00',2.47),('8902','2013-02-25','12:30:00',2.45),('8902','2013-02-25','12:35:00',2.25),('8902','2013-02-25','12:40:00',2.08),('8902','2013-02-25','12:45:00',1.85),('8902','2013-02-25','12:50:00',1.71),('8902','2013-02-25','12:55:00',1.85),('8902','2013-02-25','13:00:00',1.81),('8902','2013-02-25','13:05:00',1.57),('8902','2013-02-25','13:10:00',1.45),('8902','2013-02-25','13:15:00',1.62),('8902','2013-02-25','13:20:00',1.76),('8902','2013-02-25','13:25:00',1.84),('8902','2013-02-25','13:30:00',1.93),('8902','2013-02-25','13:35:00',1.92),('8902','2013-02-25','13:40:00',1.86),('8902','2013-02-25','13:45:00',1.62),('8902','2013-02-25','13:50:00',1.57),('8902','2013-02-25','13:55:00',1.55),('8902','2013-02-25','14:00:00',1.38),('8902','2013-02-25','14:05:00',1.27),('8902','2013-02-25','14:10:00',1.3),('8902','2013-02-25','14:15:00',1.29),('8902','2013-02-24','08:35:00',1.21),('8902','2013-02-24','08:40:00',2.07),('8902','2013-02-24','08:45:00',1.93),('8902','2013-02-24','08:50:00',2.26),('8902','2013-02-24','08:55:00',1.72),('8902','2013-02-24','09:00:00',2.49),('8902','2013-02-24','09:05:00',1.53),('8902','2013-02-24','09:10:00',1.6),('8902','2013-02-24','09:15:00',1.65),('8902','2013-02-24','09:20:00',1.83),('8902','2013-02-24','09:25:00',2.51),('8902','2013-02-24','09:30:00',2.73),('8902','2013-02-24','09:35:00',2.69),('8902','2013-02-24','09:40:00',2.1),('8902','2013-02-24','09:45:00',1.44),('8902','2013-02-24','09:50:00',1.26),('8902','2013-02-24','10:40:00',1.53),('8902','2013-02-24','10:45:00',3.21),('8902','2013-02-24','10:50:00',5.69),('8902','2013-02-24','10:55:00',8.41),('8902','2013-02-24','11:00:00',8.48),('8902','2013-02-24','11:05:00',5.15),('8902','2013-02-24','11:10:00',3.86),('8902','2013-02-24','11:15:00',3.18),('8902','2013-02-24','11:20:00',2.04),('8902','2013-02-24','11:25:00',1.94),('8902','2013-02-24','11:30:00',2.6),('8902','2013-02-24','11:35:00',2.24),('8902','2013-02-24','11:40:00',2.45),('8902','2013-02-24','11:45:00',3.18),('8902','2013-02-24','11:50:00',4.91),('8902','2013-02-24','11:55:00',8.78),('8902','2013-02-24','12:00:00',4.07),('8902','2013-02-24','12:05:00',4.08),('8902','2013-02-24','12:10:00',3.67),('8902','2013-02-24','12:15:00',5.64),('8902','2013-02-24','12:20:00',8.69),('8902','2013-02-24','12:25:00',7.73),('8902','2013-02-24','12:30:00',7),('8902','2013-02-24','12:35:00',6.55),('8902','2013-02-24','12:40:00',7.81),('8902','2013-02-24','12:45:00',7.56),('8902','2013-02-24','12:50:00',7.38),('8902','2013-02-24','12:55:00',7.32),('8902','2013-02-24','13:00:00',7.69),('8902','2013-02-24','13:05:00',5.36),('8902','2013-02-24','13:10:00',5.54),('8902','2013-02-24','13:15:00',5.85),('8902','2013-02-24','13:20:00',4.54),('8902','2013-02-24','13:25:00',3.09),('8902','2013-02-24','13:30:00',3.15),('8902','2013-02-24','13:35:00',2.2),('8902','2013-02-24','13:40:00',1.85),('8902','2013-02-24','13:45:00',1.69),('8902','2013-02-24','13:50:00',1.82),('8902','2013-02-24','13:55:00',1.51),('8902','2013-02-24','14:00:00',1.23),('8902','2013-02-24','14:30:00',1.11),('8902','2013-02-24','14:35:00',1.53),('8902','2013-02-24','14:40:00',1.72),('8902','2013-02-24','14:45:00',1.55),('8902','2013-02-24','14:50:00',1.48),('8902','2013-02-24','14:55:00',1.46),('8902','2013-02-24','15:00:00',1.44),('8902','2013-02-24','15:05:00',1.46),('8902','2013-02-24','15:10:00',1.38),('8902','2013-02-24','15:15:00',1.31),('8902','2013-02-24','15:20:00',1.2),('8902','2013-02-24','15:50:00',1.02),('8902','2013-02-24','15:55:00',1.2),('8902','2013-02-24','16:00:00',1.23),('8902','2013-02-24','16:05:00',1.14),('8902','2013-02-24','16:30:00',1.08),('8902','2013-02-24','16:35:00',1.37),('8902','2013-02-24','16:40:00',1.26),('8902','2013-02-24','16:45:00',1.19),('8902','2013-02-24','16:50:00',1.07),('8902','2013-02-24','16:55:00',1.58),('8902','2013-02-24','17:00:00',1.39),('8902','2013-02-24','17:05:00',1.13),('8902','2013-02-23','08:00:00',1.38),('8902','2013-02-23','08:05:00',1.46),('8902','2013-02-23','08:20:00',1.04),('8902','2013-02-23','08:25:00',1.21),('8902','2013-02-23','08:45:00',1.22),('8902','2013-02-23','08:50:00',1.33),('8902','2013-02-23','08:55:00',1.47),('8902','2013-02-23','09:00:00',1.09),('8902','2013-02-23','10:00:00',1.02),('8902','2013-02-23','10:30:00',1.07),('8902','2013-02-23','10:35:00',1.21),('8902','2013-02-23','10:40:00',1.47),('8902','2013-02-23','10:45:00',1.71),('8902','2013-02-23','10:50:00',2.36),('8902','2013-02-23','10:55:00',2.22),('8902','2013-02-23','11:00:00',1.72),('8902','2013-02-23','11:05:00',1.71),('8902','2013-02-23','11:10:00',1.52),('8902','2013-02-23','11:15:00',1.57),('8902','2013-02-23','11:20:00',1.57),('8902','2013-02-23','11:25:00',1.6),('8902','2013-02-23','11:30:00',1.82),('8902','2013-02-23','11:35:00',1.42),('8902','2013-02-23','11:40:00',1.55),('8902','2013-02-23','11:45:00',1.67),('8902','2013-02-23','11:50:00',1.7),('8902','2013-02-23','11:55:00',1.68),('8902','2013-02-23','12:00:00',1.48),('8902','2013-02-23','12:05:00',1.44),('8902','2013-02-23','12:10:00',1.23),('8902','2013-02-23','12:30:00',1.07),('8902','2013-02-23','12:35:00',1.7),('8902','2013-02-23','12:40:00',2.09),('8902','2013-02-23','12:45:00',2.48),('8902','2013-02-23','12:50:00',2.35),('8902','2013-02-23','12:55:00',1.91),('8902','2013-02-23','13:00:00',2.07),('8902','2013-02-23','13:05:00',3.26),('8902','2013-02-23','13:10:00',3.13),('8902','2013-02-23','13:15:00',2.69),('8902','2013-02-23','13:20:00',2.8),('8902','2013-02-23','13:25:00',2.19),('8902','2013-02-23','13:30:00',1.68),('8902','2013-02-23','13:35:00',2.28),('8902','2013-02-23','13:40:00',2.84),('8902','2013-02-23','13:45:00',3.13),('8902','2013-02-23','13:50:00',2.22),('8902','2013-02-23','13:55:00',1.82),('8902','2013-02-23','14:00:00',2.07),('8902','2013-02-23','14:05:00',3.4),('8902','2013-02-23','14:10:00',3.83),('8902','2013-02-23','14:15:00',2.14),('8902','2013-02-23','14:20:00',2.01),('8902','2013-02-23','14:25:00',1.74),('8902','2013-02-23','14:30:00',2.16),('8902','2013-02-23','14:35:00',2.36),('8902','2013-02-23','14:40:00',1.55),('8902','2013-02-23','14:45:00',1.61),('8902','2013-02-23','14:50:00',1.32),('8902','2013-02-23','14:55:00',1.19),('8902','2013-02-23','15:00:00',1.16),('8902','2013-02-23','15:05:00',1.63),('8902','2013-02-23','15:10:00',4.44),('8902','2013-02-23','15:15:00',3.74),('8902','2013-02-23','15:20:00',1.8),('8902','2013-02-23','15:25:00',4.35),('8902','2013-02-23','15:30:00',2.08),('8902','2013-02-23','15:35:00',3.7),('8902','2013-02-23','15:40:00',2.99),('8902','2013-02-23','15:45:00',2.83),('8902','2013-02-23','15:50:00',2.88),('8902','2013-02-23','15:55:00',2.38),('8902','2013-02-23','16:00:00',4.26),('8902','2013-02-23','16:05:00',2.93),('8902','2013-02-23','16:10:00',1.43),('8902','2013-02-23','16:20:00',1.4),('8902','2013-02-23','16:25:00',1.1),('8902','2013-02-23','16:40:00',1.88),('8902','2013-02-23','16:45:00',1.58),('8902','2013-02-22','07:55:00',1.17),('8902','2013-02-22','08:00:00',1.33),('8902','2013-02-22','08:05:00',1.57),('8902','2013-02-22','08:10:00',2.09),('8902','2013-02-22','08:15:00',2.67),('8902','2013-02-22','08:20:00',1.9),('8902','2013-02-22','08:25:00',1.26),('8902','2013-02-22','08:30:00',1.18),('8902','2013-02-22','08:35:00',1.08),('8902','2013-02-22','08:45:00',1.14),('8902','2013-02-22','08:50:00',1.59),('8902','2013-02-22','08:55:00',1.96),('8902','2013-02-22','09:00:00',2.33),('8902','2013-02-22','09:05:00',2.56),('8902','2013-02-22','09:10:00',1.81),('8902','2013-02-22','09:15:00',1.47),('8902','2013-02-22','09:20:00',1.07),('8902','2013-02-22','09:30:00',1.13),('8902','2013-02-22','09:35:00',1.38),('8902','2013-02-22','09:40:00',1.82),('8902','2013-02-22','09:45:00',2.54),('8902','2013-02-22','09:50:00',2.58),('8902','2013-02-22','09:55:00',2.5),('8902','2013-02-22','10:00:00',2.02),('8902','2013-02-22','10:05:00',1.91),('8902','2013-02-22','10:10:00',1.67),('8902','2013-02-22','10:15:00',1.27),('8902','2013-02-22','10:20:00',1.33),('8902','2013-02-22','10:25:00',1.91),('8902','2013-02-22','10:30:00',1.67),('8902','2013-02-22','10:35:00',1.64),('8902','2013-02-22','10:40:00',1.5),('8902','2013-02-22','10:45:00',1.57),('8902','2013-02-22','10:50:00',1.5),('8902','2013-02-22','10:55:00',1.21),('8902','2013-02-22','11:05:00',1.1),('8902','2013-02-22','11:20:00',1.29),('8902','2013-02-22','11:25:00',1.13),('8902','2013-02-22','11:30:00',1.18),('8902','2013-02-22','11:35:00',1.65),('8902','2013-02-22','11:40:00',1.69),('8902','2013-02-22','11:45:00',1.51),('8902','2013-02-22','11:50:00',1.21),('8902','2013-02-22','11:55:00',1.08),('8902','2013-02-22','12:05:00',1.37),('8902','2013-02-22','12:10:00',1.35),('8902','2013-02-22','12:15:00',1.19),('8902','2013-02-22','12:20:00',1.24),('8902','2013-02-22','12:25:00',1.07),('8902','2013-02-22','12:30:00',1.15),('8902','2013-02-22','13:10:00',1),('8902','2013-02-22','13:15:00',1.03),('8902','2013-02-22','13:50:00',1.01),('8902','2013-02-22','13:55:00',1.8),('8902','2013-02-22','14:00:00',1.93),('8902','2013-02-22','14:05:00',3.41),('8902','2013-02-22','14:10:00',3),('8902','2013-02-22','14:45:00',1.36),('8902','2013-02-22','14:50:00',1.43),('8902','2013-02-22','15:05:00',1.02),('8902','2013-02-22','15:10:00',1.2),('8902','2013-02-21','09:35:00',1.64),('8902','2013-02-21','09:40:00',1.85),('8902','2013-02-21','09:45:00',1.25),('8902','2013-02-21','09:50:00',1.28),('8902','2013-02-21','09:55:00',1.09),('8902','2013-02-21','10:05:00',1.01),('8902','2013-02-21','10:15:00',1.34),('8902','2013-02-21','10:20:00',1.26),('8902','2013-02-21','11:30:00',1.01),('8902','2013-02-21','11:35:00',1.14),('8902','2013-02-21','11:40:00',1.11),('8902','2013-02-21','11:55:00',1.04),('8902','2013-02-21','12:00:00',1.09),('8902','2013-02-21','12:45:00',1.05),('8902','2013-02-21','12:50:00',1.38),('8902','2013-02-21','12:55:00',1.57),('8902','2013-02-21','13:00:00',1.36),('8902','2013-02-21','14:10:00',1.17),('8902','2013-02-21','14:15:00',1.43),('8902','2013-02-21','14:20:00',1.65),('8902','2013-02-21','14:25:00',1.07),('8902','2013-02-21','14:30:00',1.72),('8902','2013-02-21','14:35:00',2.32),('8902','2013-02-21','14:40:00',2.43),('8902','2013-02-21','14:45:00',2.13),('8902','2013-02-21','14:50:00',1.63),('8902','2013-02-21','14:55:00',2.92),('8902','2013-02-21','15:00:00',1.6),('8902','2013-02-21','15:50:00',1.55),('8902','2013-02-21','15:55:00',1.15),('8902','2013-02-21','16:10:00',1.12),('8902','2013-02-21','16:20:00',2.3),('8902','2013-02-21','16:25:00',2.69),('8902','2013-02-21','16:30:00',2.51),('8902','2013-02-21','16:35:00',1.1),('8902','2013-02-20','09:40:00',1.07),('8902','2013-02-20','09:45:00',1.37),('8902','2013-02-20','09:50:00',1.51),('8902','2013-02-20','09:55:00',1.52),('8902','2013-02-20','10:00:00',1.45),('8902','2013-02-20','10:05:00',1.42),('8902','2013-02-20','10:10:00',1.45),('8902','2013-02-20','10:15:00',1.4),('8902','2013-02-20','10:20:00',1.4),('8902','2013-02-20','10:25:00',1.38),('8902','2013-02-20','10:30:00',1.39),('8902','2013-02-20','10:35:00',1.44),('8902','2013-02-20','10:40:00',1.49),('8902','2013-02-20','10:45:00',1.43),('8902','2013-02-20','10:50:00',1.4),('8902','2013-02-20','10:55:00',1.45),('8902','2013-02-20','11:00:00',1.3),('8902','2013-02-20','11:05:00',1.2),('8902','2013-02-20','11:10:00',1.16),('8902','2013-02-20','11:15:00',1.22),('8902','2013-02-20','11:20:00',1.43),('8902','2013-02-20','11:25:00',1.62),('8902','2013-02-20','11:30:00',1.74),('8902','2013-02-20','11:35:00',1.83),('8902','2013-02-20','11:40:00',1.82),('8902','2013-02-20','11:45:00',1.89),('8902','2013-02-20','11:50:00',2.1),('8902','2013-02-20','11:55:00',2.17),('8902','2013-02-20','12:00:00',2.15),('8902','2013-02-20','12:05:00',2.15),('8902','2013-02-20','12:10:00',2.25),('8902','2013-02-20','12:15:00',2.38),('8902','2013-02-20','12:20:00',2.57),('8902','2013-02-20','12:25:00',2.54),('8902','2013-02-20','12:30:00',2.37),('8902','2013-02-20','12:35:00',2.24),('8902','2013-02-20','12:40:00',2.16),('8902','2013-02-20','12:45:00',2.18),('8902','2013-02-20','12:50:00',2.2),('8902','2013-02-20','12:55:00',2.37),('8902','2013-02-20','13:00:00',2.43),('8902','2013-02-20','13:05:00',2.27),('8902','2013-02-20','13:10:00',2.12),('8902','2013-02-20','13:15:00',2.15),('8902','2013-02-20','13:20:00',2.23),('8902','2013-02-20','13:25:00',2.29),('8902','2013-02-20','13:30:00',2.32),('8902','2013-02-20','13:35:00',2.34),('8902','2013-02-20','13:40:00',2.29),('8902','2013-02-20','13:45:00',2.18),('8902','2013-02-20','13:50:00',2.2),('8902','2013-02-20','13:55:00',2.22),('8902','2013-02-20','14:00:00',2.24),('8902','2013-02-20','14:05:00',2.16),('8902','2013-02-20','14:10:00',2.01),('8902','2013-02-20','14:15:00',1.79),('8902','2013-02-20','14:20:00',1.57),('8902','2013-02-20','14:25:00',1.44),('8902','2013-02-20','14:30:00',1.47),('8902','2013-02-20','14:35:00',1.51),('8902','2013-02-20','14:40:00',1.47),('8902','2013-02-20','14:45:00',1.42),('8902','2013-02-20','14:50:00',1.37),('8902','2013-02-20','14:55:00',1.23),('8902','2013-02-20','15:00:00',1.07),('8902','2013-02-20','15:10:00',1),('8902','2013-02-20','15:40:00',1),('8902','2013-02-20','15:45:00',1.09),('8902','2013-02-20','15:50:00',1.25),('8902','2013-02-20','15:55:00',1.45),('8902','2013-02-20','16:00:00',1.75),('8902','2013-02-20','16:05:00',1.9),('8902','2013-02-20','16:10:00',1.61),('8902','2013-02-20','16:15:00',1.65),('8902','2013-02-20','16:20:00',2.66),('8902','2013-02-20','16:25:00',3.36),('8902','2013-02-20','16:30:00',3.03),('8902','2013-02-20','16:35:00',2.64),('8902','2013-02-20','16:40:00',2.22),('8902','2013-02-20','16:45:00',1.83),('8902','2013-02-20','16:50:00',1.52),('8902','2013-02-20','16:55:00',1.25),('8902','2013-02-20','17:00:00',1.08),('8902','2014-03-22','08:05:00',1.21),('8902','2014-03-22','08:10:00',1.31),('8902','2014-03-22','08:15:00',1.34),('8902','2014-03-22','08:20:00',1.46),('8902','2014-03-22','08:25:00',1.66),('8902','2014-03-22','08:30:00',1.89),('8902','2014-03-22','08:35:00',2.18),('8902','2014-03-22','08:40:00',1.52),('8902','2014-03-22','08:45:00',1.6),('8902','2014-03-22','08:50:00',2.2),('8902','2014-03-22','08:55:00',2.91),('8902','2014-03-22','09:00:00',1.83),('8902','2014-03-22','09:05:00',2.93),('8902','2014-03-22','09:10:00',4.81),('8902','2014-03-22','09:15:00',4.91),('8902','2014-03-22','09:20:00',3.52),('8902','2014-03-22','09:25:00',2.01),('8902','2014-03-22','09:30:00',2.62),('8902','2014-03-22','09:35:00',2.63),('8902','2014-03-22','09:40:00',2.34),('8902','2014-03-22','09:45:00',1.85),('8902','2014-03-22','09:50:00',1.59),('8902','2014-03-22','09:55:00',1.43),('8902','2014-03-22','10:00:00',1.32),('8902','2014-03-22','10:05:00',1.27),('8902','2014-03-22','10:10:00',1.55),('8902','2014-03-22','10:15:00',1.22),('8902','2014-03-22','10:20:00',1.43),('8902','2014-03-22','10:25:00',2.19),('8902','2014-03-22','10:30:00',1.9),('8902','2014-03-22','10:35:00',1.44),('8902','2014-03-22','10:40:00',2.22),('8902','2014-03-22','10:45:00',1.99),('8902','2014-03-22','10:50:00',2.13),('8902','2014-03-22','10:55:00',3.09),('8902','2014-03-22','11:00:00',2.47),('8902','2014-03-22','11:05:00',1.99),('8902','2014-03-22','11:10:00',2.57),('8902','2014-03-22','11:15:00',1.62),('8902','2014-03-22','11:20:00',1.41),('8902','2014-03-22','11:25:00',1.99),('8902','2014-03-22','11:30:00',1.65),('8902','2014-03-22','11:35:00',2.45),('8902','2014-03-22','11:40:00',5.49),('8902','2014-03-22','11:45:00',1.95),('8902','2014-03-22','11:55:00',1.75),('8902','2014-03-22','12:00:00',1.84),('8902','2014-03-22','12:05:00',1.04),('8902','2014-03-22','12:30:00',1.07),('8902','2014-03-22','12:35:00',1.34),('8902','2014-03-22','12:40:00',1.07),('8902','2014-03-22','13:40:00',1.56),('8902','2014-03-22','13:45:00',4.38),('8902','2014-03-22','13:50:00',3.92),('8902','2014-03-22','13:55:00',2.07),('8902','2014-03-22','14:00:00',1.97),('8902','2014-03-22','14:05:00',1.32),('8902','2014-03-22','14:50:00',1.88),('8902','2014-03-22','14:55:00',2.01),('8902','2014-03-22','15:00:00',1.15),('8902','2014-03-22','15:05:00',1.8),('8902','2014-03-22','15:10:00',2.62),('8902','2014-03-22','15:15:00',3.97),('8902','2014-03-22','15:20:00',3.07),('8902','2014-03-22','15:25:00',3.71),('8902','2014-03-22','15:30:00',1.73),('8902','2014-03-22','15:35:00',1.96),('8902','2014-03-22','15:40:00',1.72),('8902','2014-03-22','15:45:00',1.32),('8902','2013-02-19','08:15:00',1.17),('8902','2013-02-19','08:20:00',2.02),('8902','2013-02-19','08:25:00',2.21),('8902','2013-02-19','08:30:00',2.4),('8902','2013-02-19','08:35:00',2.62),('8902','2013-02-19','08:40:00',2.79),('8902','2013-02-19','08:45:00',3),('8902','2013-02-19','08:50:00',3.2),('8902','2013-02-19','08:55:00',3.38),('8902','2013-02-19','09:00:00',3.66),('8902','2013-02-19','09:05:00',2.27),('8902','2013-02-19','09:10:00',2.3),('8902','2013-02-19','09:15:00',2.85),('8902','2013-02-19','09:20:00',2.12),('8902','2013-02-19','09:25:00',2.64),('8902','2013-02-19','09:30:00',3.91),('8902','2013-02-19','09:35:00',2.92),('8902','2013-02-19','09:40:00',2.06),('8902','2013-02-19','09:45:00',2.75),('8902','2013-02-19','09:50:00',2.46),('8902','2013-02-19','09:55:00',3.23),('8902','2013-02-19','10:00:00',2.26),('8902','2013-02-19','10:05:00',3.15),('8902','2013-02-19','10:10:00',2.01),('8902','2013-02-19','10:15:00',2.73),('8902','2013-02-19','10:20:00',1.61),('8902','2013-02-19','10:25:00',1.43),('8902','2013-02-19','10:30:00',1.67),('8902','2013-02-19','10:35:00',1.3),('8902','2013-02-19','10:40:00',1.67),('8902','2013-02-19','10:45:00',2.18),('8902','2013-02-19','10:50:00',5.94),('8902','2013-02-19','10:55:00',6.52),('8902','2013-02-19','11:00:00',1.43),('8902','2013-02-19','11:05:00',4.22),('8902','2013-02-19','11:10:00',5.15),('8902','2013-02-19','11:15:00',7.11),('8902','2013-02-19','11:20:00',2.09),('8902','2013-02-19','11:25:00',7.36),('8902','2013-02-19','11:30:00',8.41),('8902','2013-02-19','11:35:00',8.02),('8902','2013-02-19','11:40:00',8.4),('8902','2013-02-19','11:45:00',8),('8902','2013-02-19','11:50:00',7.92),('8902','2013-02-19','11:55:00',7.52),('8902','2013-02-19','12:00:00',7.75),('8902','2013-02-19','12:05:00',8.14),('8902','2013-02-19','12:10:00',7.97),('8902','2013-02-19','12:15:00',2.88),('8902','2013-02-19','12:20:00',2.86),('8902','2013-02-19','12:25:00',6.17),('8902','2013-02-19','12:30:00',8.99),('8902','2013-02-19','12:35:00',7.23),('8902','2013-02-19','12:40:00',4.7),('8902','2013-02-19','12:45:00',2.72),('8902','2013-02-19','12:50:00',2.11),('8902','2013-02-19','12:55:00',2.77),('8902','2013-02-19','13:00:00',4.48),('8902','2013-02-19','13:05:00',8.16),('8902','2013-02-19','13:10:00',8.07),('8902','2013-02-19','13:15:00',4.78),('8902','2013-02-19','13:20:00',2.11),('8902','2013-02-19','13:25:00',2.73),('8902','2013-02-19','13:30:00',5.85),('8902','2013-02-19','13:35:00',3.15),('8902','2013-02-19','13:40:00',3.23),('8902','2013-02-19','13:45:00',2.43),('8902','2013-02-19','13:50:00',2.57),('8902','2013-02-19','13:55:00',2.18),('8902','2013-02-19','14:00:00',3.53),('8902','2013-02-19','14:05:00',2.14),('8902','2013-02-19','14:10:00',1.95),('8902','2013-02-19','14:15:00',1.84),('8902','2013-02-19','14:20:00',1.5),('8902','2013-02-19','14:25:00',1.22),('8902','2013-02-19','14:30:00',1.53),('8902','2013-02-19','14:35:00',1.75),('8902','2013-02-19','14:40:00',1.94),('8902','2013-02-19','14:45:00',1.86),('8902','2013-02-19','14:50:00',1.73),('8902','2013-02-19','14:55:00',1.73),('8902','2013-02-19','15:00:00',1.64),('8902','2013-02-19','15:05:00',1.83),('8902','2013-02-19','15:10:00',1.91),('8902','2013-02-19','15:15:00',3.08),('8902','2013-02-19','15:20:00',3.13),('8902','2013-02-19','15:25:00',4.83),('8902','2013-02-19','15:30:00',2.8),('8902','2013-02-19','15:35:00',1.49),('8902','2013-02-19','15:40:00',1.2),('8902','2013-02-19','15:45:00',1.28),('8902','2013-02-19','15:50:00',1.46),('8902','2013-02-19','15:55:00',1.74),('8902','2013-02-19','16:00:00',2.56),('8902','2013-02-19','16:05:00',4.05),('8902','2013-02-19','16:10:00',3.84),('8902','2013-02-19','16:15:00',3.56),('8902','2013-02-19','16:20:00',3.25),('8902','2013-02-19','16:25:00',2.75),('8902','2013-02-19','16:30:00',2.6),('8902','2013-02-19','16:35:00',1.99),('8902','2013-02-19','16:40:00',1.4),('8902','2013-02-19','16:45:00',1.35),('8902','2013-02-19','16:50:00',1.18),('8902','2013-02-19','16:55:00',1.08),('8902','2013-02-19','17:00:00',1.04),('8902','2013-02-18','08:00:00',1.03),('8902','2013-02-18','08:05:00',1.18),('8902','2013-02-18','08:10:00',1.39),('8902','2013-02-18','08:15:00',1.72),('8902','2013-02-18','08:20:00',1.92),('8902','2013-02-18','08:25:00',2.14),('8902','2013-02-18','08:30:00',2.34),('8902','2013-02-18','08:35:00',2.53),('8902','2013-02-18','08:40:00',2.69),('8902','2013-02-18','08:45:00',2.89),('8902','2013-02-18','08:50:00',3.09),('8902','2013-02-18','08:55:00',3.26),('8902','2013-02-18','09:00:00',3.43),('8902','2013-02-18','09:05:00',3.59),('8902','2013-02-18','09:10:00',3.75),('8902','2013-02-18','09:15:00',3.9),('8902','2013-02-18','09:20:00',4.08),('8902','2013-02-18','09:25:00',4.23),('8902','2013-02-18','09:30:00',4.37),('8902','2013-02-18','09:35:00',4.5),('8902','2013-02-18','09:40:00',4.61),('8902','2013-02-18','09:45:00',4.77),('8902','2013-02-18','09:50:00',4.9),('8902','2013-02-18','09:55:00',5.03),('8902','2013-02-18','10:00:00',5.15),('8902','2013-02-18','10:05:00',5.3),('8902','2013-02-18','10:10:00',5.44),('8902','2013-02-18','10:15:00',5.56),('8902','2013-02-18','10:20:00',5.69),('8902','2013-02-18','10:25:00',5.75),('8902','2013-02-18','10:30:00',5.85),('8902','2013-02-18','10:35:00',5.95),('8902','2013-02-18','10:40:00',6.05),('8902','2013-02-18','10:45:00',6.12),('8902','2013-02-18','10:50:00',6.16),('8902','2013-02-18','10:55:00',6.22),('8902','2013-02-18','11:00:00',6.34),('8902','2013-02-18','11:05:00',6.47),('8902','2013-02-18','11:10:00',6.53),('8902','2013-02-18','11:15:00',6.53),('8902','2013-02-18','11:20:00',6.63),('8902','2013-02-18','11:25:00',6.69),('8902','2013-02-18','11:30:00',6.74),('8902','2013-02-18','11:35:00',6.82),('8902','2013-02-18','11:40:00',6.87),('8902','2013-02-18','11:45:00',6.82),('8902','2013-02-18','11:50:00',6.88),('8902','2013-02-18','11:55:00',6.95),('8902','2013-02-18','12:00:00',6.96),('8902','2013-02-18','12:05:00',6.97),('8902','2013-02-18','12:10:00',6.9),('8902','2013-02-18','12:15:00',6.88),('8902','2013-02-18','12:20:00',6.84),('8902','2013-02-18','12:25:00',6.89),('8902','2013-02-18','12:30:00',6.84),('8902','2013-02-18','12:35:00',6.88),('8902','2013-02-18','12:40:00',6.91),('8902','2013-02-18','12:45:00',6.93),('8902','2013-02-18','12:50:00',6.98),('8902','2013-02-18','12:55:00',6.92),('8902','2013-02-18','13:00:00',6.9),('8902','2013-02-18','13:05:00',6.9),('8902','2013-02-18','13:10:00',6.93),('8902','2013-02-18','13:15:00',6.82),('8902','2013-02-18','13:20:00',6.74),('8902','2013-02-18','13:25:00',6.74),('8902','2013-02-18','13:30:00',6.75),('8902','2013-02-18','13:35:00',6.7),('8902','2013-02-18','13:40:00',6.67),('8902','2013-02-18','13:45:00',6.64),('8902','2013-02-18','13:50:00',6.57),('8902','2013-02-18','13:55:00',6.53),('8902','2013-02-18','14:00:00',6.33),('8902','2013-02-18','14:05:00',6.17),('8902','2013-02-18','14:10:00',6.15),('8902','2013-02-18','14:15:00',6.1),('8902','2013-02-18','14:20:00',5.75),('8902','2013-02-18','14:25:00',3.63),('8902','2013-02-18','14:30:00',2.25),('8902','2013-02-18','14:35:00',5.66),('8902','2013-02-18','14:40:00',5.45),('8902','2013-02-18','14:45:00',5.28),('8902','2013-02-18','14:50:00',5.37),('8902','2013-02-18','14:55:00',5.2),('8902','2013-02-18','15:00:00',5.09),('8902','2013-02-18','15:05:00',4.99),('8902','2013-02-18','15:10:00',4.93),('8902','2013-02-18','15:15:00',4.84),('8902','2013-02-18','15:20:00',4.6),('8902','2013-02-18','15:25:00',4.43),('8902','2013-02-18','15:30:00',4.21),('8902','2013-02-18','15:35:00',4.03),('8902','2013-02-18','15:40:00',3.93),('8902','2013-02-18','15:45:00',3.85),('8902','2013-02-18','15:50:00',3.6),('8902','2013-02-18','15:55:00',3.42),('8902','2013-02-18','16:00:00',3.27),('8902','2013-02-18','16:05:00',3.09),('8902','2013-02-18','16:10:00',2.95),('8902','2013-02-18','16:15:00',2.77),('8902','2013-02-18','16:20:00',2.54),('8902','2013-02-18','16:25:00',2.34),('8902','2013-02-18','16:30:00',2.16),('8902','2013-02-18','16:35:00',1.98),('8902','2013-02-18','16:40:00',1.75),('8902','2013-02-18','16:45:00',1.53),('8902','2013-02-18','16:50:00',1.4),('8902','2013-02-18','16:55:00',1.18),('8902','2013-02-18','17:00:00',1.01),('8902','2013-02-17','08:05:00',1.14),('8902','2013-02-17','08:10:00',1.31),('8902','2013-02-17','08:15:00',1.58),('8902','2013-02-17','08:20:00',1.81),('8902','2013-02-17','08:25:00',1.99),('8902','2013-02-17','08:30:00',2.18),('8902','2013-02-17','08:35:00',2.38),('8902','2013-02-17','08:40:00',2.57),('8902','2013-02-17','08:45:00',2.74),('8902','2013-02-17','08:50:00',2.86),('8902','2013-02-17','08:55:00',3.03),('8902','2013-02-17','09:00:00',3.22),('8902','2013-02-17','09:05:00',3.39),('8902','2013-02-17','09:10:00',3.58),('8902','2013-02-17','09:15:00',3.76),('8902','2013-02-17','09:20:00',4.06),('8902','2013-02-17','09:25:00',4.44),('8902','2013-02-17','09:30:00',4.68),('8902','2013-02-17','09:35:00',2.33),('8902','2013-02-17','09:40:00',1.82),('8902','2013-02-17','09:45:00',2.12),('8902','2013-02-17','09:50:00',3.25),('8902','2013-02-17','09:55:00',1.47),('8902','2013-02-17','10:00:00',1.5),('8902','2013-02-17','10:05:00',2.03),('8902','2013-02-17','10:10:00',3.37),('8902','2013-02-17','10:20:00',1.09),('8902','2013-02-17','10:25:00',1.01),('8902','2013-02-17','10:30:00',1.16),('8902','2013-02-17','10:35:00',1.34),('8902','2013-02-17','10:40:00',1.54),('8902','2013-02-17','10:45:00',1.51),('8902','2013-02-17','10:50:00',1.29),('8902','2013-02-17','10:55:00',1.81),('8902','2013-02-17','11:00:00',2.36),('8902','2013-02-17','11:05:00',2.39),('8902','2013-02-17','11:10:00',2.49),('8902','2013-02-17','11:15:00',2.28),('8902','2013-02-17','11:20:00',2.57),('8902','2013-02-17','11:25:00',3.01),('8902','2013-02-17','11:30:00',2.58),('8902','2013-02-17','11:35:00',2.63),('8902','2013-02-17','11:40:00',2.59),('8902','2013-02-17','11:45:00',2.45),('8902','2013-02-17','11:50:00',2.63),('8902','2013-02-17','11:55:00',3.05),('8902','2013-02-17','12:00:00',3.28),('8902','2013-02-17','12:05:00',2.95),('8902','2013-02-17','12:10:00',2.72),('8902','2013-02-17','12:15:00',2.65),('8902','2013-02-17','12:20:00',2.55),('8902','2013-02-17','12:25:00',2.62),('8902','2013-02-17','12:30:00',2.47),('8902','2013-02-17','12:35:00',2.31),('8902','2013-02-17','12:40:00',2.47),('8902','2013-02-17','12:45:00',2.97),('8902','2013-02-17','12:50:00',2.96),('8902','2013-02-17','12:55:00',2.73),('8902','2013-02-17','13:00:00',2.71),('8902','2013-02-17','13:05:00',2.76),('8902','2013-02-17','13:10:00',2.74),('8902','2013-02-17','13:15:00',3.34),('8902','2013-02-17','13:20:00',2.86),('8902','2013-02-17','13:25:00',3.3),('8902','2013-02-17','13:30:00',3.17),('8902','2013-02-17','13:35:00',2.67),('8902','2013-02-17','13:40:00',2.49),('8902','2013-02-17','13:45:00',2.23),('8902','2013-02-17','13:50:00',2.36),('8902','2013-02-17','13:55:00',2.94),('8902','2013-02-17','14:00:00',2.95),('8902','2013-02-17','14:05:00',2.55),('8902','2013-02-17','14:10:00',2.44),('8902','2013-02-17','14:15:00',2.01),('8902','2013-02-17','14:20:00',2.28),('8902','2013-02-17','14:25:00',1.53),('8902','2013-02-17','14:30:00',1.12),('8902','2013-02-17','14:35:00',1.03),('8902','2013-02-17','15:35:00',1.23),('8902','2013-02-17','15:40:00',1.21),('8902','2013-02-16','08:05:00',1.09),('8902','2013-02-16','08:10:00',1.22),('8902','2013-02-16','08:15:00',1.37),('8902','2013-02-16','08:20:00',1.53),('8902','2013-02-16','08:25:00',1.79),('8902','2013-02-16','08:30:00',2.19),('8902','2013-02-16','08:35:00',2.49),('8902','2013-02-16','08:40:00',2.75),('8902','2013-02-16','08:45:00',2.74),('8902','2013-02-16','08:50:00',2.4),('8902','2013-02-16','08:55:00',2.79),('8902','2013-02-16','09:00:00',3.13),('8902','2013-02-16','09:05:00',3.16),('8902','2013-02-16','09:10:00',3.44),('8902','2013-02-16','09:15:00',3.62),('8902','2013-02-16','09:20:00',3.85),('8902','2013-02-16','09:25:00',3.99),('8902','2013-02-16','09:30:00',4.08),('8902','2013-02-16','09:35:00',4.21),('8902','2013-02-16','09:40:00',4.33),('8902','2013-02-16','09:45:00',4.48),('8902','2013-02-16','09:50:00',4.65),('8902','2013-02-16','09:55:00',4.81),('8902','2013-02-16','10:00:00',4.94),('8902','2013-02-16','10:05:00',5.06),('8902','2013-02-16','10:10:00',5.17),('8902','2013-02-16','10:15:00',5.27),('8902','2013-02-16','10:20:00',5.37),('8902','2013-02-16','10:25:00',5.47),('8902','2013-02-16','10:30:00',5.59),('8902','2013-02-16','10:35:00',5.68),('8902','2013-02-16','10:40:00',5.77),('8902','2013-02-16','10:45:00',5.88),('8902','2013-02-16','10:50:00',5.95),('8902','2013-02-16','10:55:00',6.05),('8902','2013-02-16','11:00:00',6.12),('8902','2013-02-16','11:05:00',6.19),('8902','2013-02-16','11:10:00',6.1),('8902','2013-02-16','11:15:00',6.17),('8902','2013-02-16','11:20:00',6.3),('8902','2013-02-16','11:25:00',6.37),('8902','2013-02-16','11:30:00',6.42),('8902','2013-02-16','11:35:00',6.52),('8902','2013-02-16','11:40:00',6.59),('8902','2013-02-16','11:45:00',6.58),('8902','2013-02-16','11:50:00',6.63),('8902','2013-02-16','11:55:00',6.67),('8902','2013-02-16','12:00:00',6.69),('8902','2013-02-16','12:05:00',6.72),('8902','2013-02-16','12:10:00',6.78),('8902','2013-02-16','12:15:00',6.8),('8902','2013-02-16','12:20:00',6.82),('8902','2013-02-16','12:25:00',6.78),('8902','2013-02-16','12:30:00',6.76),('8902','2013-02-16','12:35:00',6.71),('8902','2013-02-16','12:40:00',6.66),('8902','2013-02-16','12:45:00',6.65),('8902','2013-02-16','12:50:00',6.6),('8902','2013-02-16','12:55:00',6.64),('8902','2013-02-16','13:00:00',6.6),('8902','2013-02-16','13:05:00',6.59),('8902','2013-02-16','13:10:00',6.42),('8902','2013-02-16','13:15:00',6.43),('8902','2013-02-16','13:20:00',6.34),('8902','2013-02-16','13:25:00',2.37),('8902','2013-02-16','13:30:00',3.22),('8902','2013-02-16','13:35:00',6.48),('8902','2013-02-16','13:40:00',6.29),('8902','2013-02-16','13:45:00',5.97),('8902','2013-02-16','13:50:00',5.56),('8902','2013-02-16','13:55:00',5.51),('8902','2013-02-16','14:00:00',1.44),('8902','2013-02-16','14:05:00',1.05),('8902','2013-02-16','14:10:00',2.69),('8902','2013-02-16','14:15:00',4.25),('8902','2013-02-16','14:20:00',2.32),('8902','2013-02-16','14:25:00',1.22),('8902','2013-02-16','14:30:00',2.99),('8902','2013-02-16','14:35:00',1.35),('8902','2013-02-16','14:40:00',1.46),('8902','2013-02-16','14:45:00',1.06),('8902','2013-02-16','14:50:00',1.4),('8902','2013-02-16','14:55:00',1.29),('8902','2013-02-16','15:00:00',1.72),('8902','2013-02-16','15:05:00',4.66),('8902','2013-02-16','15:10:00',3.77),('8902','2013-02-16','15:15:00',5.38),('8902','2013-02-16','15:20:00',5.31),('8902','2013-02-16','15:25:00',4.3),('8902','2013-02-16','15:30:00',4.11),('8902','2013-02-16','15:35:00',4.42),('8902','2013-02-16','15:40:00',4.41),('8902','2013-02-16','15:45:00',4.19),('8902','2013-02-16','15:50:00',3.9),('8902','2013-02-16','15:55:00',3.71),('8902','2013-02-16','16:00:00',3.42),('8902','2013-02-16','16:05:00',3.19),('8902','2013-02-16','16:10:00',1.52),('8902','2013-02-16','16:15:00',1.02),('8902','2013-02-16','16:20:00',2.28),('8902','2013-02-16','16:25:00',2.5),('8902','2013-02-16','16:30:00',2.57),('8902','2013-02-16','16:35:00',1.91),('8902','2013-02-16','16:40:00',1.1),('8902','2013-02-15','08:05:00',1.16),('8902','2013-02-15','08:10:00',1.31),('8902','2013-02-15','08:15:00',1.47),('8902','2013-02-15','08:20:00',1.63),('8902','2013-02-15','08:25:00',1.84),('8902','2013-02-15','08:30:00',2.04),('8902','2013-02-15','08:35:00',2.26),('8902','2013-02-15','08:40:00',2.45),('8902','2013-02-15','08:45:00',2.62),('8902','2013-02-15','08:50:00',1.4),('8902','2013-02-15','09:00:00',1.09),('8902','2013-02-15','09:05:00',1.08),('8902','2013-02-15','09:10:00',1.4),('8902','2013-02-15','09:15:00',3.85),('8902','2013-02-15','09:20:00',3.9),('8902','2013-02-15','09:25:00',4.12),('8902','2013-02-15','09:30:00',4.2),('8902','2013-02-15','09:35:00',4.34),('8902','2013-02-15','09:40:00',4.46),('8902','2013-02-15','09:45:00',4.59),('8902','2013-02-15','09:50:00',4.79),('8902','2013-02-15','09:55:00',4.85),('8902','2013-02-15','10:00:00',4.93),('8902','2013-02-15','10:05:00',5.02),('8902','2013-02-15','10:10:00',5.23),('8902','2013-02-15','10:15:00',5.32),('8902','2013-02-15','10:20:00',5.47),('8902','2013-02-15','10:25:00',5.59),('8902','2013-02-15','10:30:00',5.68),('8902','2013-02-15','10:35:00',5.84),('8902','2013-02-15','10:40:00',5.23),('8902','2013-02-15','10:45:00',6.19),('8902','2013-02-15','10:50:00',6.03),('8902','2013-02-15','10:55:00',5.53),('8902','2013-02-15','11:00:00',6.36),('8902','2013-02-15','11:05:00',6.19),('8902','2013-02-15','11:10:00',5.9),('8902','2013-02-15','11:15:00',6.35),('8902','2013-02-15','11:20:00',5.98),('8902','2013-02-15','11:25:00',6.56),('8902','2013-02-15','11:30:00',6.6),('8902','2013-02-15','11:35:00',6.7),('8902','2013-02-15','11:40:00',6.7),('8902','2013-02-15','11:45:00',6.79),('8902','2013-02-15','11:50:00',6.86),('8902','2013-02-15','11:55:00',6.87),('8902','2013-02-15','12:00:00',6.87),('8902','2013-02-15','12:05:00',6.84),('8902','2013-02-15','12:10:00',6.85),('8902','2013-02-15','12:15:00',6.9),('8902','2013-02-15','12:20:00',6.89),('8902','2013-02-15','12:25:00',6.9),('8902','2013-02-15','12:30:00',6.89),('8902','2013-02-15','12:35:00',6.91),('8902','2013-02-15','12:40:00',6.92),('8902','2013-02-15','12:45:00',6.99),('8902','2013-02-15','12:50:00',6.99),('8902','2013-02-15','12:55:00',6.89),('8902','2013-02-15','13:00:00',6.93),('8902','2013-02-15','13:05:00',6.9),('8902','2013-02-15','13:10:00',6.84),('8902','2013-02-15','13:15:00',6.85),('8902','2013-02-15','13:20:00',6.83),('8902','2013-02-15','13:25:00',6.76),('8902','2013-02-15','13:30:00',6.75),('8902','2013-02-15','13:35:00',6.7),('8902','2013-02-15','13:40:00',6.71),('8902','2013-02-15','13:45:00',6.74),('8902','2013-02-15','13:50:00',6.67),('8902','2013-02-15','13:55:00',6.52),('8902','2013-02-15','14:00:00',6.44),('8902','2013-02-15','14:05:00',6.39),('8902','2013-02-15','14:10:00',6.32),('8902','2013-02-15','14:15:00',6.28),('8902','2013-02-15','14:20:00',2.38),('8902','2013-02-15','14:25:00',1.89),('8902','2013-02-15','14:30:00',2.12),('8902','2013-02-15','14:35:00',1.87),('8902','2013-02-15','14:40:00',1.93),('8902','2013-02-15','14:45:00',2.06),('8902','2013-02-15','14:50:00',1.99),('8902','2013-02-15','14:55:00',1.77),('8902','2013-02-15','15:00:00',1.64),('8902','2013-02-15','15:05:00',1.65),('8902','2013-02-15','15:10:00',1.65),('8902','2013-02-15','15:15:00',1.9),('8902','2013-02-15','15:20:00',3),('8902','2013-02-15','15:25:00',2.12),('8902','2013-02-15','15:30:00',3.5),('8902','2013-02-15','15:35:00',3.17),('8902','2013-02-15','15:40:00',4.76),('8902','2013-02-15','15:45:00',4.88),('8902','2013-02-15','15:50:00',4.55),('8902','2013-02-15','15:55:00',2.96),('8902','2013-02-15','16:00:00',3.2),('8902','2013-02-15','16:05:00',3.52),('8902','2013-02-15','16:10:00',2.91),('8902','2013-02-15','16:15:00',1.75),('8902','2013-02-15','16:20:00',1.13),('8902','2013-02-15','16:25:00',1.75),('8902','2013-02-15','16:30:00',1.28),('8902','2013-02-14','08:00:00',1.17),('8902','2013-02-14','08:05:00',1.18),('8902','2013-02-14','08:10:00',1.18),('8902','2013-02-14','08:15:00',1.43),('8902','2013-02-14','08:20:00',1.15),('8902','2013-02-14','08:25:00',1.11),('8902','2013-02-14','08:50:00',1),('8902','2013-02-14','08:55:00',1.25),('8902','2013-02-14','09:00:00',1.15),('8902','2013-02-14','09:05:00',1.44),('8902','2013-02-14','09:10:00',1.24),('8902','2013-02-14','09:15:00',1.5),('8902','2013-02-14','09:20:00',1.8),('8902','2013-02-14','09:25:00',2.4),('8902','2013-02-14','09:30:00',2.05),('8902','2013-02-14','09:35:00',1.85),('8902','2013-02-14','09:40:00',1.94),('8902','2013-02-14','09:45:00',1.81),('8902','2013-02-14','09:50:00',1.96),('8902','2013-02-14','09:55:00',2.23),('8902','2013-02-14','10:00:00',3.02),('8902','2013-02-14','10:05:00',3.53),('8902','2013-02-14','10:10:00',2.73),('8902','2013-02-14','10:15:00',2.23),('8902','2013-02-14','10:20:00',2.96),('8902','2013-02-14','10:25:00',4.28),('8902','2013-02-14','10:30:00',3.49),('8902','2013-02-14','10:35:00',5.28),('8902','2013-02-14','10:40:00',5.76),('8902','2013-02-14','10:45:00',5.55),('8902','2013-02-14','10:50:00',5.14),('8902','2013-02-14','10:55:00',3.62),('8902','2013-02-14','11:00:00',3.43),('8902','2013-02-14','11:05:00',3.49),('8902','2013-02-14','11:10:00',3.92),('8902','2013-02-14','11:15:00',4.91),('8902','2013-02-14','11:20:00',6.71),('8902','2013-02-14','11:25:00',6.67),('8902','2013-02-14','11:30:00',6.66),('8902','2013-02-14','11:35:00',5.54),('8902','2013-02-14','11:40:00',3.89),('8902','2013-02-14','11:45:00',3.93),('8902','2013-02-14','11:50:00',6.85),('8902','2013-02-14','11:55:00',7.06),('8902','2013-02-14','12:00:00',5.61),('8902','2013-02-14','12:05:00',5.99),('8902','2013-02-14','12:10:00',5.24),('8902','2013-02-14','12:15:00',5.77),('8902','2013-02-14','12:20:00',7.7),('8902','2013-02-14','12:25:00',6.84),('8902','2013-02-14','12:30:00',6.94),('8902','2013-02-14','12:35:00',7.04),('8902','2013-02-14','12:40:00',6.92),('8902','2013-02-14','12:45:00',6.89),('8902','2013-02-14','12:50:00',6.92),('8902','2013-02-14','12:55:00',6.74),('8902','2013-02-14','13:00:00',6.93),('8902','2013-02-14','13:05:00',6.93),('8902','2013-02-14','13:10:00',6.84),('8902','2013-02-14','13:15:00',7.02),('8902','2013-02-14','13:20:00',6.62),('8902','2013-02-14','13:25:00',6.39),('8902','2013-02-14','13:30:00',4.88),('8902','2013-02-14','13:35:00',4.9),('8902','2013-02-14','13:40:00',6.28),('8902','2013-02-14','13:45:00',5.44),('8902','2013-02-14','13:50:00',4.98),('8902','2013-02-14','13:55:00',6.57),('8902','2013-02-14','14:00:00',4.18),('8902','2013-02-14','14:05:00',6.02),('8902','2013-02-14','14:10:00',7.46),('8902','2013-02-14','14:15:00',5.28),('8902','2013-02-14','14:20:00',5.38),('8902','2013-02-14','14:25:00',3.84),('8902','2013-02-14','14:30:00',4.02),('8902','2013-02-14','14:35:00',5.54),('8902','2013-02-14','14:40:00',5.84),('8902','2013-02-14','14:45:00',5.24),('8902','2013-02-14','14:50:00',2.9),('8902','2013-02-14','14:55:00',2.41),('8902','2013-02-14','15:00:00',3.55),('8902','2013-02-14','15:05:00',2.75),('8902','2013-02-14','15:10:00',2.7),('8902','2013-02-14','15:15:00',3.59),('8902','2013-02-14','15:20:00',2.83),('8902','2013-02-14','15:25:00',3.12),('8902','2013-02-14','15:30:00',3.59),('8902','2013-02-14','15:35:00',2.9),('8902','2013-02-14','15:40:00',2.65),('8902','2013-02-14','15:45:00',2.53),('8902','2013-02-14','15:50:00',1.7),('8902','2013-02-14','15:55:00',1.57),('8902','2013-02-14','16:00:00',1.39),('8902','2013-02-14','16:05:00',1.31),('8902','2013-02-14','16:10:00',1.2),('8902','2013-02-14','16:15:00',1.07),('8902','2013-02-14','16:45:00',1.02),('8902','2013-02-13','08:05:00',1.01),('8902','2013-02-13','08:10:00',1.25),('8902','2013-02-13','08:15:00',1.54),('8902','2013-02-13','08:20:00',1.67),('8902','2013-02-13','08:25:00',1.87),('8902','2013-02-13','08:30:00',2.07),('8902','2013-02-13','08:35:00',2.35),('8902','2013-02-13','08:40:00',2.57),('8902','2013-02-13','08:45:00',2.75),('8902','2013-02-13','08:50:00',2.93),('8902','2013-02-13','08:55:00',3.12),('8902','2013-02-13','09:00:00',3.31),('8902','2013-02-13','09:05:00',3.5),('8902','2013-02-13','09:10:00',3.68),('8902','2013-02-13','09:15:00',3.86),('8902','2013-02-13','09:20:00',4.02),('8902','2013-02-13','09:25:00',4.19),('8902','2013-02-13','09:30:00',4.33),('8902','2013-02-13','09:35:00',4.49),('8902','2013-02-13','09:40:00',4.65),('8902','2013-02-13','09:45:00',4.8),('8902','2013-02-13','09:50:00',4.95),('8902','2013-02-13','09:55:00',5.08),('8902','2013-02-13','10:00:00',5.21),('8902','2013-02-13','10:05:00',5.34),('8902','2013-02-13','10:10:00',5.47),('8902','2013-02-13','10:15:00',5.6),('8902','2013-02-13','10:20:00',5.72),('8902','2013-02-13','10:25:00',5.81),('8902','2013-02-13','10:30:00',5.9),('8902','2013-02-13','10:35:00',6),('8902','2013-02-13','10:40:00',6.1),('8902','2013-02-13','10:45:00',6.18),('8902','2013-02-13','10:50:00',6.29),('8902','2013-02-13','10:55:00',6.39),('8902','2013-02-13','11:00:00',6.46),('8902','2013-02-13','11:05:00',6.52),('8902','2013-02-13','11:10:00',6.58),('8902','2013-02-13','11:15:00',6.64),('8902','2013-02-13','11:20:00',6.72),('8902','2013-02-13','11:25:00',6.78),('8902','2013-02-13','11:30:00',6.82),('8902','2013-02-13','11:35:00',6.85),('8902','2013-02-13','11:40:00',6.9),('8902','2013-02-13','11:45:00',6.93),('8902','2013-02-13','11:50:00',6.95),('8902','2013-02-13','11:55:00',6.97),('8902','2013-02-13','12:00:00',7.02),('8902','2013-02-13','12:05:00',7.07),('8902','2013-02-13','12:10:00',7.08),('8902','2013-02-13','12:15:00',7.11),('8902','2013-02-13','12:20:00',7.09),('8902','2013-02-13','12:25:00',7.08),('8902','2013-02-13','12:30:00',7.05),('8902','2013-02-13','12:35:00',7.06),('8902','2013-02-13','12:40:00',7.08),('8902','2013-02-13','12:45:00',7.03),('8902','2013-02-13','12:50:00',7.04),('8902','2013-02-13','12:55:00',7.05),('8902','2013-02-13','13:00:00',6.98),('8902','2013-02-13','13:05:00',6.95),('8902','2013-02-13','13:10:00',6.96),('8902','2013-02-13','13:15:00',6.96),('8902','2013-02-13','13:20:00',6.9),('8902','2013-02-13','13:25:00',6.84),('8902','2013-02-13','13:30:00',6.78),('8902','2013-02-13','13:35:00',6.74),('8902','2013-02-13','13:40:00',6.71),('8902','2013-02-13','13:45:00',6.62),('8902','2013-02-13','13:50:00',6.56),('8902','2013-02-13','13:55:00',6.47),('8902','2013-02-13','14:00:00',6.42),('8902','2013-02-13','14:05:00',6.35),('8902','2013-02-13','14:10:00',6.25),('8902','2013-02-13','14:15:00',6.16),('8902','2013-02-13','14:20:00',6.1),('8902','2013-02-13','14:25:00',5.99),('8902','2013-02-13','14:30:00',5.88),('8902','2013-02-13','14:35:00',5.77),('8902','2013-02-13','14:40:00',5.67),('8902','2013-02-13','14:45:00',5.56),('8902','2013-02-13','14:50:00',5.45),('8902','2013-02-13','14:55:00',5.31),('8902','2013-02-13','15:00:00',5.21),('8902','2013-02-13','15:05:00',5.05),('8902','2013-02-13','15:10:00',4.91),('8902','2013-02-13','15:15:00',4.83),('8902','2013-02-13','15:20:00',4.64),('8902','2013-02-13','15:25:00',4.42),('8902','2013-02-13','15:30:00',4.3),('8902','2013-02-13','15:35:00',4.11),('8902','2013-02-13','15:40:00',3.93),('8902','2013-02-13','15:45:00',3.81),('8902','2013-02-13','15:50:00',3.6),('8902','2013-02-13','15:55:00',3.42),('8902','2013-02-13','16:00:00',3.23),('8902','2013-02-13','16:05:00',3.06),('8902','2013-02-13','16:10:00',2.88),('8902','2013-02-13','16:15:00',2.69),('8902','2013-02-13','16:20:00',2.44),('8902','2013-02-13','16:25:00',2.26),('8902','2013-02-13','16:30:00',2.06),('8902','2013-02-13','16:35:00',1.85),('8902','2013-02-13','16:40:00',1.66),('8902','2013-02-13','16:45:00',1.46),('8902','2013-02-13','16:50:00',1.25),('8902','2013-02-13','16:55:00',1.05),('8902','2013-02-12','08:35:00',1.02),('8902','2013-02-12','08:40:00',1.15),('8902','2013-02-12','08:45:00',1.28),('8902','2013-02-12','08:50:00',1.43),('8902','2013-02-12','08:55:00',1.68),('8902','2013-02-12','09:00:00',2),('8902','2013-02-12','09:05:00',2.32),('8902','2013-02-12','09:10:00',2.48),('8902','2013-02-12','09:15:00',2.52),('8902','2013-02-12','09:20:00',2.45),('8902','2013-02-12','09:25:00',2.48),('8902','2013-02-12','09:30:00',2.88),('8902','2013-02-12','09:35:00',3.17),('8902','2013-02-12','09:40:00',4.11),('8902','2013-02-12','09:45:00',4.5),('8902','2013-02-12','09:50:00',4.66),('8902','2013-02-12','09:55:00',4.58),('8902','2013-02-12','10:00:00',4.44),('8902','2013-02-12','10:05:00',4.85),('8902','2013-02-12','10:10:00',5.06),('8902','2013-02-12','10:15:00',5.39),('8902','2013-02-12','10:20:00',5.57),('8902','2013-02-12','10:25:00',5.81),('8902','2013-02-12','10:30:00',5.92),('8902','2013-02-12','10:35:00',6.1),('8902','2013-02-12','10:40:00',6.16),('8902','2013-02-12','10:45:00',6.5),('8902','2013-02-12','10:50:00',6.52),('8902','2013-02-12','10:55:00',6.5),('8902','2013-02-12','11:00:00',6.54),('8902','2013-02-12','11:05:00',6.18),('8902','2013-02-12','11:10:00',6.52),('8902','2013-02-12','11:15:00',6.61),('8902','2013-02-12','11:20:00',6.55),('8902','2013-02-12','11:25:00',5.73),('8902','2013-02-12','11:30:00',5.36),('8902','2013-02-12','11:35:00',4.99),('8902','2013-02-12','11:40:00',3.64),('8902','2013-02-12','11:45:00',3.06),('8902','2013-02-12','11:50:00',5.3),('8902','2013-02-12','11:55:00',2.96),('8902','2013-02-12','12:00:00',1.97),('8902','2013-02-12','12:05:00',2.41),('8902','2013-02-12','12:10:00',4.4),('8902','2013-02-12','12:15:00',4.95),('8902','2013-02-12','12:20:00',3.52),('8902','2013-02-12','12:25:00',2.66),('8902','2013-02-12','12:30:00',1.94),('8902','2013-02-12','12:35:00',2.23),('8902','2013-02-12','12:40:00',1.94),('8902','2013-02-12','12:45:00',3.06),('8902','2013-02-12','12:50:00',4.62),('8902','2013-02-12','12:55:00',5.73),('8902','2013-02-12','13:00:00',5.01),('8902','2013-02-12','13:05:00',5.72),('8902','2013-02-12','13:10:00',4.97),('8902','2013-02-12','13:15:00',2.86),('8902','2013-02-12','13:20:00',6.37),('8902','2013-02-12','13:25:00',6.83),('8902','2013-02-12','13:30:00',7.28),('8902','2013-02-12','13:35:00',7),('8902','2013-02-12','13:40:00',6.17),('8902','2013-02-12','13:45:00',5.67),('8902','2013-02-12','13:50:00',5.41),('8902','2013-02-12','13:55:00',5.54),('8902','2013-02-12','14:00:00',6.36),('8902','2013-02-12','14:05:00',6.6),('8902','2013-02-12','14:10:00',5.72),('8902','2013-02-12','14:15:00',5.84),('8902','2013-02-12','14:20:00',5.3),('8902','2013-02-12','14:25:00',5.43),('8902','2013-02-12','14:30:00',5.73),('8902','2013-02-12','14:35:00',5.93),('8902','2013-02-12','14:40:00',5.69),('8902','2013-02-12','14:45:00',5.43),('8902','2013-02-12','14:50:00',5.49),('8902','2013-02-12','14:55:00',5.35),('8902','2013-02-12','15:00:00',5.2),('8902','2013-02-12','15:05:00',5.04),('8902','2013-02-12','15:10:00',4.9),('8902','2013-02-12','15:15:00',4.71),('8902','2013-02-12','15:20:00',4.62),('8902','2013-02-12','15:25:00',4.46),('8902','2013-02-12','15:30:00',4.33),('8902','2013-02-12','15:35:00',4.2),('8902','2013-02-12','15:40:00',4.05),('8902','2013-02-12','15:45:00',3.91),('8902','2013-02-12','15:50:00',3.65),('8902','2013-02-12','15:55:00',3.45),('8902','2013-02-12','16:00:00',3.25),('8902','2013-02-12','16:05:00',3.14),('8902','2013-02-12','16:10:00',2.97),('8902','2013-02-12','16:15:00',2.82),('8902','2013-02-12','16:20:00',2.51),('8902','2013-02-12','16:25:00',2.21),('8902','2013-02-12','16:30:00',2.06),('8902','2013-02-12','16:35:00',1.91),('8902','2013-02-12','16:40:00',1.75),('8902','2013-02-12','16:45:00',1.56),('8902','2013-02-12','16:50:00',1.2),('8902','2013-02-11','12:10:00',1.06),('8902','2013-02-11','12:15:00',1.08),('8902','2013-02-11','12:20:00',1.07),('8902','2013-02-11','12:25:00',1.08),('8902','2013-02-11','12:30:00',1.08),('8902','2013-02-10','09:15:00',1.02),('8902','2013-02-10','09:30:00',1.23),('8902','2013-02-10','09:35:00',1.19),('8902','2013-02-10','09:40:00',1.06),('8902','2013-02-10','10:00:00',1.05),('8902','2013-02-10','10:05:00',1.07),('8902','2013-02-10','10:10:00',1.18),('8902','2013-02-10','10:15:00',1.44),('8902','2013-02-10','10:20:00',1.8),('8902','2013-02-10','10:25:00',1.88),('8902','2013-02-10','10:30:00',2.02),('8902','2013-02-10','10:35:00',2.37),('8902','2013-02-10','10:40:00',2.06),('8902','2013-02-10','10:45:00',1.55),('8902','2013-02-10','10:50:00',1.35),('8902','2013-02-10','10:55:00',1.3),('8902','2013-02-10','11:00:00',1.95),('8902','2013-02-10','11:05:00',2.52),('8902','2013-02-10','11:10:00',2.57),('8902','2013-02-10','11:15:00',2.63),('8902','2013-02-10','11:20:00',2.13),('8902','2013-02-10','11:25:00',1.54),('8902','2013-02-10','11:35:00',1.03),('8902','2013-02-10','11:40:00',1.27),('8902','2013-02-10','11:45:00',1.79),('8902','2013-02-10','11:50:00',1.28),('8902','2013-02-10','11:55:00',1.08),('8902','2013-02-10','12:40:00',1.33),('8902','2013-02-10','12:45:00',2.29),('8902','2013-02-10','12:50:00',1.27),('8902','2013-02-10','12:55:00',1.06),('8902','2013-02-10','13:55:00',1.54),('8902','2013-02-10','14:00:00',1.82),('8902','2013-02-10','14:05:00',1.96),('8902','2013-02-10','14:10:00',2.14),('8902','2013-02-10','14:15:00',1.78),('8902','2013-02-10','14:20:00',1.86),('8902','2013-02-10','14:25:00',2.79),('8902','2013-02-10','14:30:00',3.64),('8902','2013-02-10','14:35:00',1.95),('8902','2013-02-10','14:40:00',2.77),('8902','2013-02-10','14:45:00',2.34),('8902','2013-02-10','14:50:00',1.58),('8902','2013-02-10','14:55:00',1.32),('8902','2013-02-10','15:05:00',1.55),('8902','2013-02-10','15:10:00',2.23),('8902','2013-02-10','15:15:00',1.24),('8902','2013-02-10','15:20:00',1.25),('8902','2013-02-10','15:25:00',1.3),('8902','2013-02-10','15:30:00',1.14),('8902','2013-02-10','15:35:00',1.26),('8902','2013-02-10','15:40:00',1.34),('8902','2013-02-10','15:45:00',1.43),('8902','2013-02-10','15:50:00',1.25),('8902','2014-03-21','07:35:00',1.44),('8902','2014-03-21','07:40:00',2.13),('8902','2014-03-21','07:45:00',2.06),('8902','2014-03-21','07:50:00',1.97),('8902','2014-03-21','07:55:00',1.21),('8902','2014-03-21','08:05:00',1.04),('8902','2014-03-21','08:10:00',1.71),('8902','2014-03-21','08:15:00',2.43),('8902','2014-03-21','08:20:00',2.96),('8902','2014-03-21','08:25:00',2.96),('8902','2014-03-21','08:30:00',3.37),('8902','2014-03-21','08:35:00',1.7),('8902','2014-03-21','08:40:00',2.96),('8902','2014-03-21','08:45:00',4.3),('8902','2014-03-21','08:50:00',3.15),('8902','2014-03-21','08:55:00',3.11),('8902','2014-03-21','09:00:00',4.04),('8902','2014-03-21','09:05:00',2.36),('8902','2014-03-21','09:10:00',2.7),('8902','2014-03-21','09:15:00',2.33),('8902','2014-03-21','09:20:00',2.48),('8902','2014-03-21','09:25:00',2.92),('8902','2014-03-21','09:30:00',4.19),('8902','2014-03-21','09:35:00',3.22),('8902','2014-03-21','09:40:00',3.11),('8902','2014-03-21','09:45:00',5.71),('8902','2014-03-21','09:50:00',5.81),('8902','2014-03-21','09:55:00',5.99),('8902','2014-03-21','10:00:00',6.13),('8902','2014-03-21','10:05:00',6.33),('8902','2014-03-21','10:10:00',7.27),('8902','2014-03-21','10:15:00',3.9),('8902','2014-03-21','10:20:00',2.4),('8902','2014-03-21','10:25:00',2.11),('8902','2014-03-21','10:30:00',2.23),('8902','2014-03-21','10:35:00',3.12),('8902','2014-03-21','10:40:00',4.18),('8902','2014-03-21','10:45:00',5.37),('8902','2014-03-21','10:50:00',6.83),('8902','2014-03-21','10:55:00',3.53),('8902','2014-03-21','11:00:00',2.41),('8902','2014-03-21','11:05:00',2.57),('8902','2014-03-21','11:10:00',2.15),('8902','2014-03-21','11:15:00',2.94),('8902','2014-03-21','11:20:00',5.06),('8902','2014-03-21','11:25:00',7.71),('8902','2014-03-21','11:30:00',6.04),('8902','2014-03-21','11:35:00',3.01),('8902','2014-03-21','11:40:00',4.57),('8902','2014-03-21','11:45:00',4.25),('8902','2014-03-21','11:50:00',4.26),('8902','2014-03-21','11:55:00',5.95),('8902','2014-03-21','12:00:00',5.6),('8902','2014-03-21','12:05:00',3.88),('8902','2014-03-21','12:10:00',2.58),('8902','2014-03-21','12:15:00',5.73),('8902','2014-03-21','12:20:00',9.26),('8902','2014-03-21','12:25:00',6.95),('8902','2014-03-21','12:30:00',3.19),('8902','2014-03-21','12:35:00',5.27),('8902','2014-03-21','12:40:00',4.59),('8902','2014-03-21','12:45:00',5.89),('8902','2014-03-21','12:50:00',7.47),('8902','2014-03-21','12:55:00',4.76),('8902','2014-03-21','13:00:00',5.78),('8902','2014-03-21','13:05:00',3.67),('8902','2014-03-21','13:10:00',7.36),('8902','2014-03-21','13:15:00',6.82),('8902','2014-03-21','13:20:00',6.83),('8902','2014-03-21','13:25:00',5.54),('8902','2014-03-21','13:30:00',6.4),('8902','2014-03-21','13:35:00',6.57),('8902','2014-03-21','13:40:00',6.64),('8902','2014-03-21','13:45:00',7.14),('8902','2014-03-21','13:50:00',3.84),('8902','2014-03-21','13:55:00',3.2),('8902','2014-03-21','14:00:00',7.65),('8902','2014-03-21','14:05:00',5.75),('8902','2014-03-21','14:10:00',7.45),('8902','2014-03-21','14:15:00',6.89),('8902','2014-03-21','14:20:00',6.9),('8902','2014-03-21','14:25:00',6.7),('8902','2014-03-21','14:30:00',6.55),('8902','2014-03-21','14:35:00',6.5),('8902','2014-03-21','14:40:00',6.35),('8902','2014-03-21','14:45:00',6.27),('8902','2014-03-21','14:50:00',6.18),('8902','2014-03-21','14:55:00',6.03),('8902','2014-03-21','15:00:00',5.88),('8902','2014-03-21','15:05:00',5.82),('8902','2014-03-21','15:10:00',5.61),('8902','2014-03-21','15:15:00',5.37),('8902','2014-03-21','15:20:00',5.42),('8902','2014-03-21','15:25:00',4.55),('8902','2014-03-21','15:30:00',2.97),('8902','2014-03-21','15:35:00',3.24),('8902','2014-03-21','15:40:00',3.61),('8902','2014-03-21','15:45:00',3.36),('8902','2014-03-21','15:50:00',4.92),('8902','2014-03-21','15:55:00',5.39),('8902','2014-03-21','16:00:00',4.24),('8902','2014-03-21','16:05:00',4.22),('8902','2014-03-21','16:10:00',3.97),('8902','2014-03-21','16:15:00',3.23),('8902','2014-03-21','16:20:00',3.1),('8902','2014-03-21','16:25:00',1.78),('8902','2014-03-21','16:30:00',1.35),('8902','2014-03-21','16:35:00',1.05),('8902','2014-03-21','16:40:00',1.02),('8902','2014-03-21','16:55:00',1.12),('8902','2014-03-21','17:00:00',1.28),('8902','2014-03-21','17:05:00',1.04),('8902','2013-02-09','09:05:00',1.02),('8902','2013-02-09','09:10:00',1.09),('8902','2013-02-09','09:15:00',1.22),('8902','2013-02-09','09:20:00',1.09),('8902','2013-02-09','09:35:00',1.08),('8902','2013-02-09','09:40:00',1.78),('8902','2013-02-09','09:45:00',1.8),('8902','2013-02-09','09:50:00',3.4),('8902','2013-02-09','09:55:00',3.24),('8902','2013-02-09','10:00:00',3.86),('8902','2013-02-09','10:05:00',5.34),('8902','2013-02-09','10:10:00',5.16),('8902','2013-02-09','10:15:00',5.51),('8902','2013-02-09','10:20:00',5.6),('8902','2013-02-09','10:25:00',5.73),('8902','2013-02-09','10:30:00',5.85),('8902','2013-02-09','10:35:00',5.95),('8902','2013-02-09','10:40:00',6.03),('8902','2013-02-09','10:45:00',6.11),('8902','2013-02-09','10:50:00',6.2),('8902','2013-02-09','10:55:00',6.27),('8902','2013-02-09','11:00:00',6.36),('8902','2013-02-09','11:05:00',6.41),('8902','2013-02-09','11:10:00',6.47),('8902','2013-02-09','11:15:00',6.54),('8902','2013-02-09','11:20:00',6.58),('8902','2013-02-09','11:25:00',6.63),('8902','2013-02-09','11:30:00',6.7),('8902','2013-02-09','11:35:00',6.74),('8902','2013-02-09','11:40:00',6.81),('8902','2013-02-09','11:45:00',6.87),('8902','2013-02-09','11:50:00',6.89),('8902','2013-02-09','11:55:00',6.96),('8902','2013-02-09','12:00:00',7.01),('8902','2013-02-09','12:05:00',7),('8902','2013-02-09','12:10:00',7.05),('8902','2013-02-09','12:15:00',7.09),('8902','2013-02-09','12:20:00',7.1),('8902','2013-02-09','12:25:00',7.11),('8902','2013-02-09','12:30:00',7.07),('8902','2013-02-09','12:35:00',7.05),('8902','2013-02-09','12:40:00',7.03),('8902','2013-02-09','12:45:00',7),('8902','2013-02-09','12:50:00',7),('8902','2013-02-09','12:55:00',6.97),('8902','2013-02-09','13:00:00',6.9),('8902','2013-02-09','13:05:00',6.77),('8902','2013-02-09','13:10:00',6.78),('8902','2013-02-09','13:15:00',6.8),('8902','2013-02-09','13:20:00',6.73),('8902','2013-02-09','13:25:00',6.7),('8902','2013-02-09','13:30:00',6.7),('8902','2013-02-09','13:35:00',6.58),('8902','2013-02-09','13:40:00',6.45),('8902','2013-02-09','13:45:00',6.39),('8902','2013-02-09','13:50:00',6.33),('8902','2013-02-09','13:55:00',6.28),('8902','2013-02-09','14:00:00',6.16),('8902','2013-02-09','14:05:00',6.03),('8902','2013-02-09','14:10:00',5.93),('8902','2013-02-09','14:15:00',5.86),('8902','2013-02-09','14:20:00',5.8),('8902','2013-02-09','14:25:00',5.67),('8902','2013-02-09','14:30:00',5.59),('8902','2013-02-09','14:35:00',5.58),('8902','2013-02-09','14:40:00',5.05),('8902','2013-02-09','14:45:00',5.35),('8902','2013-02-09','14:50:00',5.25),('8902','2013-02-09','14:55:00',5.04),('8902','2013-02-09','15:00:00',4.08),('8902','2013-02-09','15:05:00',2.81),('8902','2013-02-09','15:10:00',2.68),('8902','2013-02-09','15:15:00',3.52),('8902','2013-02-09','15:20:00',1.07),('8902','2013-02-09','15:25:00',3.61),('8902','2013-02-09','15:30:00',3.28),('8902','2013-02-09','15:35:00',3.24),('8902','2013-02-09','15:40:00',2.26),('8902','2013-02-09','15:45:00',1.33),('8902','2013-02-09','16:20:00',1.06),('8902','2013-02-09','16:25:00',1.86),('8902','2013-02-09','16:30:00',1.75),('8902','2013-02-09','16:35:00',2.11),('8902','2013-02-09','16:40:00',1.68),('8902','2013-02-08','09:10:00',1.04),('8902','2013-02-08','09:15:00',1.13),('8902','2013-02-08','09:20:00',1.17),('8902','2013-02-08','09:25:00',1.35),('8902','2013-02-08','09:30:00',1.61),('8902','2013-02-08','09:35:00',1.72),('8902','2013-02-08','09:40:00',1.48),('8902','2013-02-08','09:45:00',1.3),('8902','2013-02-08','09:50:00',1.34),('8902','2013-02-08','09:55:00',1.31),('8902','2013-02-08','10:00:00',1.2),('8902','2013-02-08','10:05:00',1.12),('8902','2013-02-08','10:10:00',1.03),('8902','2013-02-08','10:30:00',1.01),('8902','2013-02-08','10:35:00',1.09),('8902','2013-02-08','10:40:00',1.23),('8902','2013-02-08','10:45:00',1.43),('8902','2013-02-08','10:50:00',1.62),('8902','2013-02-08','10:55:00',1.74),('8902','2013-02-08','11:00:00',1.86),('8902','2013-02-08','11:05:00',1.93),('8902','2013-02-08','11:10:00',1.99),('8902','2013-02-08','11:15:00',2.09),('8902','2013-02-08','11:20:00',2.15),('8902','2013-02-08','11:25:00',2.19),('8902','2013-02-08','11:30:00',2.23),('8902','2013-02-08','11:35:00',2.17),('8902','2013-02-08','11:40:00',2.11),('8902','2013-02-08','11:45:00',2.16),('8902','2013-02-08','11:50:00',2.15),('8902','2013-02-08','11:55:00',2.07),('8902','2013-02-08','12:00:00',2.1),('8902','2013-02-08','12:05:00',2.09),('8902','2013-02-08','12:10:00',2.07),('8902','2013-02-08','12:15:00',2.08),('8902','2013-02-08','12:20:00',2.12),('8902','2013-02-08','12:25:00',2.13),('8902','2013-02-08','12:30:00',2.17),('8902','2013-02-08','12:35:00',2.29),('8902','2013-02-08','12:40:00',2.35),('8902','2013-02-08','12:45:00',2.36),('8902','2013-02-08','12:50:00',2.41),('8902','2013-02-08','12:55:00',2.38),('8902','2013-02-08','13:00:00',2.51),('8902','2013-02-08','13:05:00',2.91),('8902','2013-02-08','13:10:00',3.24),('8902','2013-02-08','13:15:00',3.61),('8902','2013-02-08','13:20:00',3.97),('8902','2013-02-08','13:25:00',4.24),('8902','2013-02-08','13:30:00',5.06),('8902','2013-02-08','13:35:00',5.04),('8902','2013-02-08','13:40:00',5.4),('8902','2013-02-08','13:45:00',5.77),('8902','2013-02-08','13:50:00',6.38),('8902','2013-02-08','13:55:00',5.9),('8902','2013-02-08','14:00:00',6.43),('8902','2013-02-08','14:05:00',5.9),('8902','2013-02-08','14:10:00',4.82),('8902','2013-02-08','14:15:00',5.32),('8902','2013-02-08','14:20:00',6.73),('8902','2013-02-08','14:25:00',7.05),('8902','2013-02-08','14:30:00',6.48),('8902','2013-02-08','14:35:00',5.98),('8902','2013-02-08','14:40:00',5.47),('8902','2013-02-08','14:45:00',5.17),('8902','2013-02-08','14:50:00',5.01),('8902','2013-02-08','14:55:00',5.11),('8902','2013-02-08','15:00:00',4.95),('8902','2013-02-08','15:05:00',4.7),('8902','2013-02-08','15:10:00',4.59),('8902','2013-02-08','15:15:00',4.42),('8902','2013-02-08','15:20:00',4.18),('8902','2013-02-08','15:25:00',4.01),('8902','2013-02-08','15:30:00',3.62),('8902','2013-02-08','15:35:00',3.72),('8902','2013-02-08','15:40:00',2.93),('8902','2013-02-08','15:45:00',1.86),('8902','2013-02-08','15:50:00',3.17),('8902','2013-02-08','15:55:00',3.03),('8902','2013-02-08','16:25:00',1.68),('8902','2013-02-08','16:30:00',1.66),('8902','2013-02-08','16:35:00',1.5),('8902','2013-02-08','16:40:00',1.47),('8902','2013-02-08','16:45:00',1.14),('8902','2013-02-07','08:55:00',1.1),('8902','2013-02-07','09:00:00',1.07),('8902','2013-02-07','09:05:00',1.01),('8902','2013-02-07','09:20:00',1.13),('8902','2013-02-07','09:25:00',1.28),('8902','2013-02-07','09:30:00',1.52),('8902','2013-02-07','09:35:00',3.45),('8902','2013-02-07','09:40:00',5.45),('8902','2013-02-07','09:45:00',5.05),('8902','2013-02-07','09:50:00',5.58),('8902','2013-02-07','09:55:00',5.54),('8902','2013-02-07','10:00:00',5.84),('8902','2013-02-07','10:05:00',6.18),('8902','2013-02-07','10:10:00',6.15),('8902','2013-02-07','10:15:00',4.96),('8902','2013-02-07','10:20:00',4.97),('8902','2013-02-07','10:25:00',5.77),('8902','2013-02-07','10:30:00',6.85),('8902','2013-02-07','10:35:00',3.13),('8902','2013-02-07','10:40:00',4.57),('8902','2013-02-07','10:45:00',7),('8902','2013-02-07','10:50:00',6.85),('8902','2013-02-07','10:55:00',6.73),('8902','2013-02-07','11:00:00',6.58),('8902','2013-02-07','11:05:00',6.51),('8902','2013-02-07','11:10:00',6.56),('8902','2013-02-07','11:15:00',6.59),('8902','2013-02-07','11:20:00',6.64),('8902','2013-02-07','11:25:00',6.66),('8902','2013-02-07','11:30:00',6.67),('8902','2013-02-07','11:35:00',6.71),('8902','2013-02-07','11:40:00',6.75),('8902','2013-02-07','11:45:00',6.78),('8902','2013-02-07','11:50:00',6.83),('8902','2013-02-07','11:55:00',6.84),('8902','2013-02-07','12:00:00',6.87),('8902','2013-02-07','12:05:00',6.94),('8902','2013-02-07','12:10:00',6.94),('8902','2013-02-07','12:15:00',6.95),('8902','2013-02-07','12:20:00',6.98),('8902','2013-02-07','12:25:00',6.96),('8902','2013-02-07','12:30:00',7),('8902','2013-02-07','12:35:00',7.03),('8902','2013-02-07','12:40:00',7.17),('8902','2013-02-07','12:45:00',7.37),('8902','2013-02-07','12:50:00',5.82),('8902','2013-02-07','12:55:00',3.87),('8902','2013-02-07','13:00:00',3.81),('8902','2013-02-07','13:05:00',3.43),('8902','2013-02-07','13:10:00',3.82),('8902','2013-02-07','13:15:00',3.73),('8902','2013-02-07','13:20:00',3.74),('8902','2013-02-07','13:25:00',3.68),('8902','2013-02-07','13:30:00',3.54),('8902','2013-02-07','13:35:00',4.57),('8902','2013-02-07','13:40:00',3.93),('8902','2013-02-07','13:45:00',3.1),('8902','2013-02-07','13:50:00',3.18),('8902','2013-02-07','13:55:00',3.17),('8902','2013-02-07','14:00:00',2.96),('8902','2013-02-07','14:05:00',2.95),('8902','2013-02-07','14:10:00',2.64),('8902','2013-02-07','14:15:00',2.36),('8902','2013-02-07','14:20:00',2.33),('8902','2013-02-07','14:25:00',2.5),('8902','2013-02-07','14:30:00',3.48),('8902','2013-02-07','14:35:00',3.7),('8902','2013-02-07','14:40:00',6.91),('8902','2013-02-07','14:45:00',6.91),('8902','2013-02-07','14:50:00',4.09),('8902','2013-02-07','14:55:00',4.63),('8902','2013-02-07','15:00:00',4.52),('8902','2013-02-07','15:05:00',6.38),('8902','2013-02-07','15:10:00',6.29),('8902','2013-02-07','15:15:00',5.63),('8902','2013-02-07','15:20:00',4.67),('8902','2013-02-07','15:25:00',4.66),('8902','2013-02-07','15:30:00',4.32),('8902','2013-02-07','15:35:00',4.12),('8902','2013-02-07','15:40:00',3.93),('8902','2013-02-07','15:45:00',3.78),('8902','2013-02-07','15:50:00',3.56),('8902','2013-02-07','15:55:00',3.32),('8902','2013-02-07','16:00:00',3.12),('8902','2013-02-07','16:05:00',2.91),('8902','2013-02-07','16:10:00',2.75),('8902','2013-02-07','16:15:00',2.21),('8902','2013-02-06','09:15:00',1.01),('8902','2013-02-06','09:20:00',1.18),('8902','2013-02-06','09:30:00',1.01),('8902','2013-02-06','09:35:00',1),('8902','2013-02-06','09:40:00',1.03),('8902','2013-02-06','09:45:00',1.12),('8902','2013-02-06','09:50:00',1.2),('8902','2013-02-06','10:25:00',1.2),('8902','2013-02-06','10:30:00',1.28),('8902','2013-02-06','10:35:00',1.6),('8902','2013-02-06','10:40:00',2.04),('8902','2013-02-06','10:45:00',2.89),('8902','2013-02-06','10:50:00',1.41),('8902','2013-02-06','10:55:00',2.35),('8902','2013-02-06','11:00:00',2.84),('8902','2013-02-06','11:05:00',2.52),('8902','2013-02-06','11:10:00',1.68),('8902','2013-02-06','11:15:00',1.05),('8902','2013-02-06','11:30:00',1.03),('8902','2013-02-06','12:20:00',1.16),('8902','2013-02-06','12:25:00',5.77),('8902','2013-02-06','12:30:00',4.52),('8902','2013-02-06','12:35:00',1.99),('8902','2013-02-06','12:40:00',1.13),('8902','2013-02-06','12:45:00',1.28),('8902','2013-02-06','12:50:00',1.42),('8902','2013-02-06','12:55:00',1.1),('8902','2013-02-06','13:05:00',1.08),('8902','2013-02-06','13:10:00',1.38),('8902','2013-02-06','13:15:00',2.15),('8902','2013-02-06','13:20:00',2.66),('8902','2013-02-06','13:25:00',2.78),('8902','2013-02-06','13:30:00',2.06),('8902','2013-02-06','13:35:00',1.47),('8902','2013-02-06','13:40:00',1.67),('8902','2013-02-06','13:45:00',1.69),('8902','2013-02-06','13:50:00',1.73),('8902','2013-02-06','13:55:00',2.02),('8902','2013-02-06','14:00:00',2.5),('8902','2013-02-06','14:05:00',3.64),('8902','2013-02-06','14:10:00',5.97),('8902','2013-02-06','14:15:00',5.47),('8902','2013-02-06','14:20:00',4.29),('8902','2013-02-06','14:25:00',2.24),('8902','2013-02-06','14:30:00',1.69),('8902','2013-02-06','14:35:00',2.71),('8902','2013-02-06','14:40:00',2.89),('8902','2013-02-06','14:45:00',4.17),('8902','2013-02-06','14:50:00',3.18),('8902','2013-02-06','14:55:00',2.12),('8902','2013-02-06','15:00:00',3.89),('8902','2013-02-06','15:05:00',5.03),('8902','2013-02-06','15:10:00',5.37),('8902','2013-02-06','15:15:00',4.99),('8902','2013-02-06','15:20:00',2.47),('8902','2013-02-06','15:25:00',3.81),('8902','2013-02-06','15:30:00',2.21),('8902','2013-02-06','15:35:00',2.04),('8902','2013-02-06','15:40:00',1.4),('8902','2013-02-06','15:50:00',1.03),('8902','2013-02-06','15:55:00',1.05),('8902','2013-02-05','08:30:00',1.05),('8902','2013-02-05','08:35:00',1.3),('8902','2013-02-05','08:40:00',1.55),('8902','2013-02-05','08:45:00',1.94),('8902','2013-02-05','08:50:00',2.49),('8902','2013-02-05','08:55:00',1.93),('8902','2013-02-05','09:00:00',2.11),('8902','2013-02-05','09:05:00',2.29),('8902','2013-02-05','09:10:00',2.95),('8902','2013-02-05','09:15:00',1.87),('8902','2013-02-05','09:20:00',1.92),('8902','2013-02-05','09:25:00',2.12),('8902','2013-02-05','09:30:00',2.93),('8902','2013-02-05','09:35:00',2.19),('8902','2013-02-05','09:40:00',3.18),('8902','2013-02-05','09:45:00',2.28),('8902','2013-02-05','09:50:00',2.43),('8902','2013-02-05','09:55:00',3.08),('8902','2013-02-05','10:00:00',2.53),('8902','2013-02-05','10:05:00',3.45),('8902','2013-02-05','10:10:00',2.95),('8902','2013-02-05','10:15:00',2.59),('8902','2013-02-05','10:20:00',2.37),('8902','2013-02-05','10:25:00',3.32),('8902','2013-02-05','10:30:00',2.85),('8902','2013-02-05','10:35:00',3.71),('8902','2013-02-05','10:40:00',2.87),('8902','2013-02-05','10:45:00',2.06),('8902','2013-02-05','10:50:00',3.49),('8902','2013-02-05','10:55:00',4.42),('8902','2013-02-05','11:00:00',3.46),('8902','2013-02-05','11:05:00',2.61),('8902','2013-02-05','11:10:00',3.06),('8902','2013-02-05','11:15:00',2.68),('8902','2013-02-05','11:20:00',3.99),('8902','2013-02-05','11:25:00',5.84),('8902','2013-02-05','11:30:00',3.42),('8902','2013-02-05','11:35:00',2.82),('8902','2013-02-05','11:40:00',3.05),('8902','2013-02-05','11:45:00',3.12),('8902','2013-02-05','11:50:00',3.19),('8902','2013-02-05','11:55:00',2.9),('8902','2013-02-05','12:00:00',2.56),('8902','2013-02-05','12:05:00',2.15),('8902','2013-02-05','12:10:00',1.65),('8902','2013-02-05','12:15:00',1.91),('8902','2013-02-05','12:20:00',1.94),('8902','2013-02-05','12:25:00',1.87),('8902','2013-02-05','12:30:00',1.59),('8902','2013-02-05','12:35:00',1.4),('8902','2013-02-05','12:40:00',1.22),('8902','2013-02-05','12:45:00',1.17),('8902','2013-02-05','12:50:00',1.17),('8902','2013-02-05','12:55:00',1.17),('8902','2013-02-05','13:00:00',1.09),('8902','2013-02-05','13:05:00',1.05),('8902','2013-02-05','13:10:00',1.22),('8902','2013-02-05','13:15:00',1.46),('8902','2013-02-05','13:20:00',1.63),('8902','2013-02-05','13:25:00',1.8),('8902','2013-02-05','13:30:00',2.17),('8902','2013-02-05','13:35:00',2.36),('8902','2013-02-05','13:40:00',2.11),('8902','2013-02-05','13:45:00',1.79),('8902','2013-02-05','13:50:00',3.17),('8902','2013-02-05','13:55:00',2.53),('8902','2013-02-05','14:00:00',2.91),('8902','2013-02-05','14:05:00',2.46),('8902','2013-02-05','14:10:00',1.45),('8902','2013-02-05','14:30:00',3.11),('8902','2013-02-05','14:35:00',5.02),('8902','2013-02-05','14:40:00',2.89),('8902','2013-02-05','14:45:00',1.22),('8902','2013-02-05','15:15:00',1.02),('8902','2013-02-05','15:20:00',1.19),('8902','2013-02-05','15:25:00',1.85),('8902','2013-02-05','15:30:00',1.15),('8902','2013-02-05','15:45:00',1.12),('8902','2013-02-05','15:50:00',1.61),('8902','2013-02-04','08:15:00',1.06),('8902','2013-02-04','08:20:00',1.19),('8902','2013-02-04','08:25:00',1.47),('8902','2013-02-04','08:30:00',1.76),('8902','2013-02-04','08:35:00',1.98),('8902','2013-02-04','08:40:00',2.15),('8902','2013-02-04','08:45:00',2.33),('8902','2013-02-04','08:50:00',2.49),('8902','2013-02-04','08:55:00',2.65),('8902','2013-02-04','09:00:00',2.79),('8902','2013-02-04','09:05:00',2.95),('8902','2013-02-04','09:10:00',3.17),('8902','2013-02-04','09:15:00',3.34),('8902','2013-02-04','09:20:00',3.52),('8902','2013-02-04','09:25:00',3.7),('8902','2013-02-04','09:30:00',3.84),('8902','2013-02-04','09:35:00',3.95),('8902','2013-02-04','09:40:00',4.14),('8902','2013-02-04','09:45:00',4.27),('8902','2013-02-04','09:50:00',4.44),('8902','2013-02-04','09:55:00',4.58),('8902','2013-02-04','10:00:00',4.63),('8902','2013-02-04','10:05:00',4.77),('8902','2013-02-04','10:10:00',4.51),('8902','2013-02-04','10:15:00',4.59),('8902','2013-02-04','10:20:00',5.04),('8902','2013-02-04','10:25:00',5.21),('8902','2013-02-04','10:30:00',5.29),('8902','2013-02-04','10:35:00',5.37),('8902','2013-02-04','10:40:00',5.44),('8902','2013-02-04','10:45:00',5.48),('8902','2013-02-04','10:50:00',5.52),('8902','2013-02-04','10:55:00',5.6),('8902','2013-02-04','11:00:00',5.64),('8902','2013-02-04','11:05:00',5.72),('8902','2013-02-04','11:10:00',5.83),('8902','2013-02-04','11:15:00',5.88),('8902','2013-02-04','11:20:00',5.91),('8902','2013-02-04','11:25:00',5.89),('8902','2013-02-04','11:30:00',6.04),('8902','2013-02-04','11:35:00',5.73),('8902','2013-02-04','11:40:00',5.1),('8902','2013-02-04','11:45:00',4.02),('8902','2013-02-04','11:50:00',3.33),('8902','2013-02-04','11:55:00',2.8),('8902','2013-02-04','12:00:00',2.32),('8902','2013-02-04','12:05:00',1.99),('8902','2013-02-04','12:10:00',4.79),('8902','2013-02-04','12:15:00',2.98),('8902','2013-02-04','12:20:00',2.28),('8902','2013-02-04','12:25:00',2.15),('8902','2013-02-04','12:30:00',2.09),('8902','2013-02-04','12:35:00',2.37),('8902','2013-02-04','12:40:00',3.45),('8902','2013-02-04','12:45:00',3.52),('8902','2013-02-04','12:50:00',5.51),('8902','2013-02-04','12:55:00',1.85),('8902','2013-02-04','13:00:00',1.26),('8902','2013-02-04','13:05:00',1.44),('8902','2013-02-04','13:10:00',1.76),('8902','2013-02-04','13:15:00',2.38),('8902','2013-02-04','13:20:00',2.4),('8902','2013-02-04','13:25:00',2.21),('8902','2013-02-04','13:30:00',2.35),('8902','2013-02-04','13:35:00',1.79),('8902','2013-02-04','13:40:00',1.64),('8902','2013-02-04','13:45:00',2.26),('8902','2013-02-04','13:50:00',2.49),('8902','2013-02-04','13:55:00',2.14),('8902','2013-02-04','14:00:00',2),('8902','2013-02-04','14:05:00',2.16),('8902','2013-02-04','14:10:00',1.77),('8902','2013-02-04','14:15:00',1.87),('8902','2013-02-04','14:20:00',2.02),('8902','2013-02-04','14:25:00',2.93),('8902','2013-02-04','14:30:00',3.71),('8902','2013-02-04','14:35:00',2.7),('8902','2013-02-04','14:40:00',4.48),('8902','2013-02-04','14:45:00',3.79),('8902','2013-02-04','14:50:00',1.81),('8902','2013-02-04','14:55:00',1.92),('8902','2013-02-04','15:00:00',1.47),('8902','2013-02-04','15:05:00',2.06),('8902','2013-02-04','15:10:00',1.58),('8902','2013-02-04','15:15:00',1.18),('8902','2013-02-03','08:15:00',1.01),('8902','2013-02-03','08:20:00',1.16),('8902','2013-02-03','08:25:00',1.49),('8902','2013-02-03','08:30:00',1.79),('8902','2013-02-03','08:35:00',2),('8902','2013-02-03','08:40:00',2.19),('8902','2013-02-03','08:45:00',2.39),('8902','2013-02-03','08:50:00',2.57),('8902','2013-02-03','08:55:00',2.4),('8902','2013-02-03','09:00:00',3.01),('8902','2013-02-03','09:05:00',3.27),('8902','2013-02-03','09:10:00',3.5),('8902','2013-02-03','09:15:00',3.64),('8902','2013-02-03','09:20:00',3.67),('8902','2013-02-03','09:25:00',3.63),('8902','2013-02-03','09:30:00',3.98),('8902','2013-02-03','09:35:00',4.04),('8902','2013-02-03','09:40:00',4.18),('8902','2013-02-03','09:45:00',3.86),('8902','2013-02-03','09:50:00',4.41),('8902','2013-02-03','09:55:00',4.88),('8902','2013-02-03','10:00:00',5.01),('8902','2013-02-03','10:05:00',5.13),('8902','2013-02-03','10:10:00',5.34),('8902','2013-02-03','10:15:00',5.52),('8902','2013-02-03','10:20:00',5.31),('8902','2013-02-03','10:25:00',5.49),('8902','2013-02-03','10:30:00',5.31),('8902','2013-02-03','10:35:00',5.04),('8902','2013-02-03','10:40:00',5.35),('8902','2013-02-03','10:45:00',5.84),('8902','2013-02-03','10:50:00',5.94),('8902','2013-02-03','10:55:00',5.96),('8902','2013-02-03','11:00:00',6.03),('8902','2013-02-03','11:05:00',6.18),('8902','2013-02-03','11:10:00',6.23),('8902','2013-02-03','11:15:00',6.29),('8902','2013-02-03','11:20:00',6.31),('8902','2013-02-03','11:25:00',6.36),('8902','2013-02-03','11:30:00',6.4),('8902','2013-02-03','11:35:00',6.44),('8902','2013-02-03','11:40:00',6.47),('8902','2013-02-03','11:45:00',6.51),('8902','2013-02-03','11:50:00',6.54),('8902','2013-02-03','11:55:00',6.6),('8902','2013-02-03','12:00:00',6.61),('8902','2013-02-03','12:05:00',6.67),('8902','2013-02-03','12:10:00',6.71),('8902','2013-02-03','12:15:00',6.68),('8902','2013-02-03','12:20:00',6.71),('8902','2013-02-03','12:25:00',6.7),('8902','2013-02-03','12:30:00',6.69),('8902','2013-02-03','12:35:00',6.67),('8902','2013-02-03','12:40:00',6.68),('8902','2013-02-03','12:45:00',6.67),('8902','2013-02-03','12:50:00',6.62),('8902','2013-02-03','12:55:00',6.58),('8902','2013-02-03','13:00:00',6.6),('8902','2013-02-03','13:05:00',6.62),('8902','2013-02-03','13:10:00',6.59),('8902','2013-02-03','13:15:00',6.55),('8902','2013-02-03','13:20:00',6.49),('8902','2013-02-03','13:25:00',6.43),('8902','2013-02-03','13:30:00',6.39),('8902','2013-02-03','13:35:00',6.37),('8902','2013-02-03','13:40:00',6.31),('8902','2013-02-03','13:45:00',6.26),('8902','2013-02-03','13:50:00',6.22),('8902','2013-02-03','13:55:00',6.19),('8902','2013-02-03','14:00:00',6.09),('8902','2013-02-03','14:05:00',6.02),('8902','2013-02-03','14:10:00',5.94),('8902','2013-02-03','14:15:00',5.83),('8902','2013-02-03','14:20:00',5.76),('8902','2013-02-03','14:25:00',5.66),('8902','2013-02-03','14:30:00',5.57),('8902','2013-02-03','14:35:00',5.44),('8902','2013-02-03','14:40:00',5.33),('8902','2013-02-03','14:45:00',5.25),('8902','2013-02-03','14:50:00',5.14),('8902','2013-02-03','14:55:00',4.98),('8902','2013-02-03','15:00:00',4.87),('8902','2013-02-03','15:05:00',4.74),('8902','2013-02-03','15:10:00',4.59),('8902','2013-02-03','15:15:00',4.43),('8902','2013-02-03','15:20:00',4.28),('8902','2013-02-03','15:25:00',4.12),('8902','2013-02-03','15:30:00',3.98),('8902','2013-02-03','15:35:00',3.82),('8902','2013-02-03','15:40:00',3.65),('8902','2013-02-03','15:45:00',3.48),('8902','2013-02-03','15:50:00',3.27),('8902','2013-02-03','15:55:00',3.1),('8902','2013-02-03','16:00:00',2.92),('8902','2013-02-03','16:05:00',2.75),('8902','2013-02-03','16:10:00',2.57),('8902','2013-02-03','16:15:00',2.36),('8902','2013-02-03','16:20:00',2.17),('8902','2013-02-03','16:25:00',1.96),('8902','2013-02-03','16:30:00',1.76),('8902','2013-02-03','16:35:00',1.52),('8902','2013-02-03','16:40:00',1.31),('8902','2013-02-03','16:45:00',1.11),('8902','2013-02-02','08:05:00',1),('8902','2013-02-02','08:40:00',1.08),('8902','2013-02-02','08:45:00',1.21),('8902','2013-02-02','08:50:00',1.18),('8902','2013-02-02','09:00:00',1.18),('8902','2013-02-02','09:05:00',1.2),('8902','2013-02-02','09:10:00',1.04),('8902','2013-02-02','09:15:00',1.44),('8902','2013-02-02','09:20:00',1.82),('8902','2013-02-02','09:25:00',2.29),('8902','2013-02-02','09:30:00',1.83),('8902','2013-02-02','09:35:00',1.53),('8902','2013-02-02','09:40:00',2.78),('8902','2013-02-02','09:45:00',3.25),('8902','2013-02-02','09:50:00',3.72),('8902','2013-02-02','09:55:00',3.08),('8902','2013-02-02','10:00:00',4.18),('8902','2013-02-02','10:05:00',2.13),('8902','2013-02-02','10:10:00',1.01),('8902','2013-02-02','10:20:00',1.84),('8902','2013-02-02','10:25:00',1.07),('8902','2013-02-02','10:30:00',1.09),('8902','2013-02-02','10:40:00',1.1),('8902','2013-02-02','11:15:00',1.16),('8902','2013-02-02','11:20:00',2.45),('8902','2013-02-02','11:25:00',1.43),('8902','2013-02-02','11:45:00',1.29),('8902','2013-02-02','11:50:00',1.74),('8902','2013-02-02','11:55:00',1.93),('8902','2013-02-02','12:00:00',2.16),('8902','2013-02-02','12:05:00',2.12),('8902','2013-02-02','12:10:00',1.96),('8902','2013-02-02','12:15:00',1.57),('8902','2013-02-02','12:20:00',1.27),('8902','2013-02-01','10:10:00',1.19),('8902','2013-02-01','10:15:00',1.73),('8902','2013-02-01','10:20:00',2.08),('8902','2013-02-01','10:25:00',1.86),('8902','2013-02-01','10:30:00',2.1),('8902','2013-02-01','10:35:00',2.44),('8902','2013-02-01','10:40:00',2.68),('8902','2013-02-01','10:45:00',2.98),('8902','2013-02-01','10:50:00',2.59),('8902','2013-02-01','10:55:00',3.24),('8902','2013-02-01','11:00:00',3.95),('8902','2013-02-01','11:05:00',3.49),('8902','2013-02-01','11:10:00',3.7),('8902','2013-02-01','11:15:00',3.82),('8902','2013-02-01','11:20:00',3.73),('8902','2013-02-01','11:25:00',4.34),('8902','2013-02-01','11:30:00',4.05),('8902','2013-02-01','11:35:00',3.35),('8902','2013-02-01','11:40:00',3.35),('8902','2013-02-01','11:45:00',2.18),('8902','2013-02-01','11:50:00',1.92),('8902','2013-02-01','11:55:00',2.16),('8902','2013-02-01','12:00:00',1.65),('8902','2013-02-01','12:05:00',1.11),('8902','2013-02-01','12:50:00',1.41),('8902','2013-02-01','12:55:00',4.49),('8902','2013-02-01','13:00:00',3.21),('8902','2013-02-01','13:05:00',3.51),('8902','2013-02-01','13:10:00',3.08),('8902','2013-02-01','13:15:00',4),('8902','2013-02-01','13:20:00',3.9),('8902','2013-02-01','13:25:00',3.12),('8902','2013-02-01','13:30:00',2.35),('8902','2013-02-01','13:35:00',4.2),('8902','2013-02-01','13:40:00',5.28),('8902','2013-02-01','13:45:00',4.09),('8902','2013-02-01','13:50:00',3.96),('8902','2013-02-01','13:55:00',2.33),('8902','2013-02-01','14:00:00',1.16),('8902','2013-01-31','08:20:00',1.2),('8902','2013-01-31','08:25:00',1.49),('8902','2013-01-31','08:30:00',1.4),('8902','2013-01-31','08:35:00',1.57),('8902','2013-01-31','08:40:00',1.78),('8902','2013-01-31','08:45:00',2.05),('8902','2013-01-31','08:55:00',1.61),('8902','2013-01-31','09:00:00',2.18),('8902','2013-01-31','09:05:00',2.85),('8902','2013-01-31','09:10:00',2.97),('8902','2013-01-31','09:15:00',1.46),('8902','2013-01-31','09:25:00',3.08),('8902','2013-01-31','09:30:00',1.43),('8902','2013-01-31','09:35:00',2.2),('8902','2013-01-31','09:40:00',2.62),('8902','2013-01-31','09:45:00',1.71),('8902','2013-01-31','09:50:00',1.73),('8902','2013-01-31','09:55:00',1.52),('8902','2013-01-31','10:00:00',2.18),('8902','2013-01-31','10:05:00',1.47),('8902','2013-01-31','10:10:00',1.71),('8902','2013-01-31','10:15:00',1.81),('8902','2013-01-31','10:20:00',3.88),('8902','2013-01-31','10:25:00',3.8),('8902','2013-01-31','10:30:00',3.94),('8902','2013-01-31','10:35:00',3.91),('8902','2013-01-31','10:40:00',1.87),('8902','2013-01-31','10:45:00',2.16),('8902','2013-01-31','10:50:00',4.92),('8902','2013-01-31','10:55:00',3.35),('8902','2013-01-31','11:00:00',5.93),('8902','2013-01-31','11:05:00',4.28),('8902','2013-01-31','11:10:00',6.26),('8902','2013-01-31','11:15:00',5.37),('8902','2013-01-31','11:20:00',6.47),('8902','2013-01-31','11:25:00',5.33),('8902','2013-01-31','11:30:00',3.13),('8902','2013-01-31','11:35:00',4.26),('8902','2013-01-31','11:40:00',7.77),('8902','2013-01-31','11:45:00',4.53),('8902','2013-01-31','11:50:00',3.4),('8902','2013-01-31','11:55:00',2.39),('8902','2013-01-31','12:00:00',2.64),('8902','2013-01-31','12:05:00',3.27),('8902','2013-01-31','12:10:00',3.73),('8902','2013-01-31','12:15:00',4.05),('8902','2013-01-31','12:20:00',7.32),('8902','2013-01-31','12:25:00',6.59),('8902','2013-01-31','12:30:00',3.31),('8902','2013-01-31','12:35:00',3.83),('8902','2013-01-31','12:40:00',5.28),('8902','2013-01-31','12:45:00',1.81),('8902','2013-01-31','12:50:00',5.52),('8902','2013-01-31','12:55:00',4.5),('8902','2013-01-31','13:00:00',6.95),('8902','2013-01-31','13:05:00',6.66),('8902','2013-01-31','13:10:00',5.99),('8902','2013-01-31','13:15:00',6.18),('8902','2013-01-31','13:20:00',6.42),('8902','2013-01-31','13:25:00',3.72),('8902','2013-01-31','13:30:00',5.37),('8902','2013-01-31','13:35:00',4.17),('8902','2013-01-31','13:40:00',2.69),('8902','2013-01-31','13:45:00',5.03),('8902','2013-01-31','13:50:00',4.81),('8902','2013-01-31','13:55:00',2.18),('8902','2013-01-31','14:00:00',1.59),('8902','2013-01-31','14:05:00',1.57),('8902','2013-01-31','14:10:00',2.11),('8902','2013-01-31','14:15:00',4.71),('8902','2013-01-31','14:20:00',6),('8902','2013-01-31','14:25:00',5.37),('8902','2013-01-31','14:30:00',5.31),('8902','2013-01-31','14:35:00',5.19),('8902','2013-01-31','14:40:00',4.57),('8902','2013-01-31','14:45:00',2.77),('8902','2013-01-31','14:50:00',1.82),('8902','2013-01-31','14:55:00',2.61),('8902','2013-01-31','15:00:00',3.42),('8902','2013-01-31','15:05:00',4.94),('8902','2013-01-31','15:10:00',2.92),('8902','2013-01-31','15:15:00',3.57),('8902','2013-01-31','15:20:00',4.05),('8902','2013-01-31','15:25:00',3.7),('8902','2013-01-31','15:30:00',1.25),('8902','2013-01-31','15:35:00',3.02),('8902','2013-01-31','15:40:00',2.84),('8902','2013-01-31','15:45:00',2.63),('8902','2013-01-31','15:50:00',1.47),('8902','2013-01-31','15:55:00',2.75),('8902','2013-01-31','16:00:00',1.35),('8902','2014-03-20','07:20:00',1.11),('8902','2014-03-20','07:25:00',1.19),('8902','2014-03-20','07:30:00',1.15),('8902','2014-03-20','07:35:00',1.4),('8902','2014-03-20','07:40:00',1.58),('8902','2014-03-20','07:45:00',1.79),('8902','2014-03-20','07:50:00',1.99),('8902','2014-03-20','07:55:00',2.19),('8902','2014-03-20','08:00:00',2.35),('8902','2014-03-20','08:05:00',2.48),('8902','2014-03-20','08:10:00',2.64),('8902','2014-03-20','08:15:00',2.84),('8902','2014-03-20','08:20:00',2.97),('8902','2014-03-20','08:25:00',3.17),('8902','2014-03-20','08:30:00',3.38),('8902','2014-03-20','08:35:00',3.54),('8902','2014-03-20','08:40:00',3.73),('8902','2014-03-20','08:45:00',3.85),('8902','2014-03-20','08:50:00',4.06),('8902','2014-03-20','08:55:00',4.26),('8902','2014-03-20','09:00:00',4.42),('8902','2014-03-20','09:05:00',4.52),('8902','2014-03-20','09:10:00',4.73),('8902','2014-03-20','09:15:00',4.89),('8902','2014-03-20','09:20:00',5.09),('8902','2014-03-20','09:25:00',4.93),('8902','2014-03-20','09:30:00',5.25),('8902','2014-03-20','09:35:00',5.36),('8902','2014-03-20','09:40:00',5.49),('8902','2014-03-20','09:45:00',5.61),('8902','2014-03-20','09:50:00',5.75),('8902','2014-03-20','09:55:00',5.87),('8902','2014-03-20','10:00:00',5.88),('8902','2014-03-20','10:05:00',5.95),('8902','2014-03-20','10:10:00',6.07),('8902','2014-03-20','10:15:00',6.21),('8902','2014-03-20','10:20:00',6.25),('8902','2014-03-20','10:25:00',6.37),('8902','2014-03-20','10:30:00',6.58),('8902','2014-03-20','10:35:00',6.55),('8902','2014-03-20','10:40:00',6.72),('8902','2014-03-20','10:45:00',6.67),('8902','2014-03-20','10:50:00',6.65),('8902','2014-03-20','10:55:00',6.78),('8902','2014-03-20','11:00:00',6.91),('8902','2014-03-20','11:05:00',6.81),('8902','2014-03-20','11:10:00',6.75),('8902','2014-03-20','11:15:00',6.71),('8902','2014-03-20','11:20:00',6.67),('8902','2014-03-20','11:25:00',6.17),('8902','2014-03-20','11:30:00',3.98),('8902','2014-03-20','11:35:00',4.89),('8902','2014-03-20','11:40:00',3.54),('8902','2014-03-20','11:45:00',2.65),('8902','2014-03-20','11:50:00',6.02),('8902','2014-03-20','11:55:00',7.9),('8902','2014-03-20','12:00:00',5.33),('8902','2014-03-20','12:05:00',7.32),('8902','2014-03-20','12:10:00',7.47),('8902','2014-03-20','12:15:00',7.83),('8902','2014-03-20','12:20:00',7.73),('8902','2014-03-20','12:25:00',7.5),('8902','2014-03-20','12:30:00',7.39),('8902','2014-03-20','12:35:00',7.41),('8902','2014-03-20','12:40:00',7.49),('8902','2014-03-20','12:45:00',7.52),('8902','2014-03-20','12:50:00',7.46),('8902','2014-03-20','12:55:00',7.5),('8902','2014-03-20','13:00:00',7.44),('8902','2014-03-20','13:05:00',7.49),('8902','2014-03-20','13:10:00',7.44),('8902','2014-03-20','13:15:00',7.48),('8902','2014-03-20','13:20:00',7.45),('8902','2014-03-20','13:25:00',7.4),('8902','2014-03-20','13:30:00',7.34),('8902','2014-03-20','13:35:00',7.25),('8902','2014-03-20','13:40:00',7.25),('8902','2014-03-20','13:45:00',7.2),('8902','2014-03-20','13:50:00',7.19),('8902','2014-03-20','13:55:00',7.11),('8902','2014-03-20','14:00:00',7.1),('8902','2014-03-20','14:05:00',7.03),('8902','2014-03-20','14:10:00',6.97),('8902','2014-03-20','14:15:00',6.92),('8902','2014-03-20','14:20:00',6.81),('8902','2014-03-20','14:25:00',6.72),('8902','2014-03-20','14:30:00',6.52),('8902','2014-03-20','14:35:00',6.19),('8902','2014-03-20','14:40:00',6.25),('8902','2014-03-20','14:45:00',6.12),('8902','2014-03-20','14:50:00',4.94),('8902','2014-03-20','14:55:00',2.93),('8902','2014-03-20','15:00:00',1.43),('8902','2014-03-20','15:05:00',3.35),('8902','2014-03-20','15:10:00',6.34),('8902','2014-03-20','15:15:00',6.63),('8902','2014-03-20','15:20:00',6.24),('8902','2014-03-20','15:25:00',6.04),('8902','2014-03-20','15:30:00',6.1),('8902','2014-03-20','15:35:00',5.73),('8902','2014-03-20','15:40:00',5.73),('8902','2014-03-20','15:45:00',5.55),('8902','2014-03-20','15:50:00',5.35),('8902','2014-03-20','15:55:00',5.02),('8902','2014-03-20','16:00:00',4.87),('8902','2014-03-20','16:05:00',4.44),('8902','2014-03-20','16:10:00',4.23),('8902','2014-03-20','16:15:00',3.88),('8902','2014-03-20','16:20:00',3.62),('8902','2014-03-20','16:25:00',3.38),('8902','2014-03-20','16:30:00',3.11),('8902','2014-03-20','16:35:00',2.91),('8902','2014-03-20','16:40:00',2.74),('8902','2014-03-20','16:45:00',2.59),('8902','2014-03-20','16:50:00',2.41),('8902','2014-03-20','16:55:00',2.15),('8902','2014-03-20','17:00:00',1.8),('8902','2014-03-20','17:05:00',1.67),('8902','2014-03-20','17:10:00',1.45),('8902','2014-03-20','17:15:00',1.22),('8902','2014-03-20','17:20:00',1.05),('8902','2013-01-30','09:00:00',1.04),('8902','2013-01-30','09:05:00',1.65),('8902','2013-01-30','09:10:00',1.91),('8902','2013-01-30','09:15:00',1.05),('8902','2013-01-30','09:20:00',1.82),('8902','2013-01-30','09:25:00',3.21),('8902','2013-01-30','09:30:00',3.98),('8902','2013-01-30','09:35:00',3.65),('8902','2013-01-30','09:40:00',3.8),('8902','2013-01-30','09:45:00',3.73),('8902','2013-01-30','09:50:00',3.76),('8902','2013-01-30','09:55:00',4.31),('8902','2013-01-30','10:00:00',4.32),('8902','2013-01-30','10:05:00',4.4),('8902','2013-01-30','10:10:00',4.5),('8902','2013-01-30','10:15:00',4.68),('8902','2013-01-30','10:20:00',4.77),('8902','2013-01-30','10:25:00',4.92),('8902','2013-01-30','10:30:00',5.25),('8902','2013-01-30','10:35:00',3.44),('8902','2013-01-30','10:40:00',1.06),('8902','2013-01-30','10:45:00',2.59),('8902','2013-01-30','10:50:00',5.58),('8902','2013-01-30','10:55:00',5.5),('8902','2013-01-30','11:00:00',4.86),('8902','2013-01-30','11:05:00',5.69),('8902','2013-01-30','11:10:00',6.12),('8902','2013-01-30','11:15:00',6.14),('8902','2013-01-30','11:20:00',6.33),('8902','2013-01-30','11:25:00',6.08),('8902','2013-01-30','11:30:00',5.94),('8902','2013-01-30','11:35:00',4.65),('8902','2013-01-30','11:40:00',6.08),('8902','2013-01-30','11:45:00',6.06),('8902','2013-01-30','11:50:00',6.02),('8902','2013-01-30','11:55:00',5.98),('8902','2013-01-30','12:00:00',6.01),('8902','2013-01-30','12:05:00',6.08),('8902','2013-01-30','12:10:00',6.13),('8902','2013-01-30','12:15:00',6.09),('8902','2013-01-30','12:20:00',6.03),('8902','2013-01-30','12:25:00',6.07),('8902','2013-01-30','12:30:00',6.15),('8902','2013-01-30','12:35:00',6.15),('8902','2013-01-30','12:40:00',6.08),('8902','2013-01-30','12:45:00',6.09),('8902','2013-01-30','12:50:00',6.06),('8902','2013-01-30','12:55:00',6.01),('8902','2013-01-30','13:00:00',5.98),('8902','2013-01-30','13:05:00',5.98),('8902','2013-01-30','13:10:00',5.74),('8902','2013-01-30','13:15:00',5.86),('8902','2013-01-30','13:20:00',5.74),('8902','2013-01-30','13:25:00',5.71),('8902','2013-01-30','13:30:00',5.71),('8902','2013-01-30','13:35:00',5.58),('8902','2013-01-30','13:40:00',5.49),('8902','2013-01-30','13:45:00',5.47),('8902','2013-01-30','13:50:00',5.74),('8902','2013-01-30','13:55:00',5.58),('8902','2013-01-30','14:00:00',5.51),('8902','2013-01-30','14:05:00',5.29),('8902','2013-01-30','14:10:00',5.09),('8902','2013-01-30','14:15:00',4.96),('8902','2013-01-30','14:20:00',4.96),('8902','2013-01-30','14:25:00',4.92),('8902','2013-01-30','14:30:00',4.79),('8902','2013-01-30','14:35:00',4.75),('8902','2013-01-30','14:40:00',4.62),('8902','2013-01-30','14:45:00',4.51),('8902','2013-01-30','14:50:00',4.3),('8902','2013-01-30','14:55:00',4.07),('8902','2013-01-30','15:00:00',4.01),('8902','2013-01-30','15:05:00',4.01),('8902','2013-01-30','15:10:00',3.87),('8902','2013-01-30','15:15:00',3.85),('8902','2013-01-30','15:20:00',3.67),('8902','2013-01-30','15:25:00',3.49),('8902','2013-01-30','15:30:00',3.36),('8902','2013-01-30','15:35:00',3.29),('8902','2013-01-30','15:40:00',3.14),('8902','2013-01-30','15:45:00',2.85),('8902','2013-01-30','15:50:00',2.61),('8902','2013-01-30','15:55:00',2.48),('8902','2013-01-30','16:00:00',2.14),('8902','2013-01-30','16:05:00',1.72),('8902','2013-01-30','16:10:00',1.94),('8902','2013-01-30','16:15:00',1.73),('8902','2013-01-30','16:20:00',1.57),('8902','2013-01-30','16:25:00',1.3),('8902','2013-01-30','16:30:00',1.36),('8902','2013-01-30','16:35:00',1.15),('8902','2013-01-29','09:10:00',1),('8902','2013-01-29','09:15:00',1.44),('8902','2013-01-29','09:25:00',1.07),('8902','2013-01-29','09:30:00',1.41),('8902','2013-01-29','09:35:00',1.57),('8902','2013-01-29','09:40:00',1.39),('8902','2013-01-29','09:45:00',1.12),('8902','2013-01-29','10:00:00',1.62),('8902','2013-01-29','10:05:00',1.56),('8902','2013-01-29','10:10:00',3.04),('8902','2013-01-29','10:15:00',2.29),('8902','2013-01-29','10:20:00',3.46),('8902','2013-01-29','10:25:00',3.39),('8902','2013-01-29','10:30:00',2.93),('8902','2013-01-29','10:35:00',2.69),('8902','2013-01-29','10:40:00',2.53),('8902','2013-01-29','10:45:00',2.86),('8902','2013-01-29','10:50:00',5.38),('8902','2013-01-29','10:55:00',3.77),('8902','2013-01-29','11:00:00',5.47),('8902','2013-01-29','11:05:00',5.32),('8902','2013-01-29','11:10:00',5.29),('8902','2013-01-29','11:15:00',5.52),('8902','2013-01-29','11:20:00',5.58),('8902','2013-01-29','11:25:00',5.69),('8902','2013-01-29','11:30:00',5.7),('8902','2013-01-29','11:35:00',5.75),('8902','2013-01-29','11:40:00',5.46),('8902','2013-01-29','11:45:00',5.49),('8902','2013-01-29','11:50:00',5.44),('8902','2013-01-29','11:55:00',5.15),('8902','2013-01-29','12:00:00',3.18),('8902','2013-01-29','12:05:00',5.52),('8902','2013-01-29','12:10:00',5.21),('8902','2013-01-29','12:15:00',6.74),('8902','2013-01-29','12:20:00',3.36),('8902','2013-01-29','12:25:00',1.96),('8902','2013-01-29','12:30:00',1.56),('8902','2013-01-29','12:35:00',1.76),('8902','2013-01-29','12:40:00',3.71),('8902','2013-01-29','12:45:00',1.82),('8902','2013-01-29','12:50:00',6.25),('8902','2013-01-29','12:55:00',6.97),('8902','2013-01-29','13:00:00',6.56),('8902','2013-01-29','13:05:00',6.85),('8902','2013-01-29','13:10:00',5.68),('8902','2013-01-29','13:15:00',6.24),('8902','2013-01-29','13:20:00',6.57),('8902','2013-01-29','13:25:00',6.45),('8902','2013-01-29','13:30:00',6.09),('8902','2013-01-29','13:35:00',4.71),('8902','2013-01-29','13:40:00',4.8),('8902','2013-01-29','13:45:00',5.64),('8902','2013-01-29','13:50:00',6.03),('8902','2013-01-29','13:55:00',4.5),('8902','2013-01-29','14:00:00',5.15),('8902','2013-01-29','14:05:00',4.79),('8902','2013-01-29','14:10:00',4.72),('8902','2013-01-29','14:15:00',2.07),('8902','2013-01-29','14:20:00',2.04),('8902','2013-01-29','14:25:00',4),('8902','2013-01-29','14:30:00',3.41),('8902','2013-01-29','14:35:00',4.55),('8902','2013-01-29','14:40:00',4.96),('8902','2013-01-29','14:45:00',3.91),('8902','2013-01-29','14:50:00',2.06),('8902','2013-01-29','14:55:00',1.86),('8902','2013-01-29','15:00:00',2.98),('8902','2013-01-29','15:05:00',3),('8902','2013-01-29','15:10:00',1.84),('8902','2013-01-29','15:15:00',1.55),('8902','2013-01-29','15:20:00',1.35),('8902','2013-01-29','15:25:00',1.17),('8902','2013-01-29','15:30:00',1.16),('8902','2013-01-29','15:35:00',1.02),('8902','2013-01-28','08:25:00',1.17),('8902','2013-01-28','08:30:00',1.34),('8902','2013-01-28','08:35:00',1.61),('8902','2013-01-28','08:40:00',1.82),('8902','2013-01-28','08:45:00',2),('8902','2013-01-28','08:50:00',2.17),('8902','2013-01-28','08:55:00',2.37),('8902','2013-01-28','09:00:00',2.57),('8902','2013-01-28','09:05:00',2.75),('8902','2013-01-28','09:10:00',2.91),('8902','2013-01-28','09:15:00',3.05),('8902','2013-01-28','09:20:00',3.21),('8902','2013-01-28','09:25:00',3.35),('8902','2013-01-28','09:30:00',3.51),('8902','2013-01-28','09:35:00',3.64),('8902','2013-01-28','09:45:00',3.97),('8902','2013-01-28','09:50:00',4.12),('8902','2013-01-28','09:55:00',4.23),('8902','2013-01-28','10:00:00',4.38),('8902','2013-01-28','10:05:00',4.54),('8902','2013-01-28','10:10:00',4.68),('8902','2013-01-28','10:15:00',4.8),('8902','2013-01-28','10:20:00',4.95),('8902','2013-01-28','10:25:00',5.08),('8902','2013-01-28','10:30:00',5.18),('8902','2013-01-28','10:35:00',5.27),('8902','2013-01-28','10:40:00',5.37),('8902','2013-01-28','10:45:00',5.45),('8902','2013-01-28','10:50:00',5.55),('8902','2013-01-28','10:55:00',5.59),('8902','2013-01-28','11:00:00',5.62),('8902','2013-01-28','11:05:00',5.65),('8902','2013-01-28','11:10:00',5.69),('8902','2013-01-28','11:15:00',5.8),('8902','2013-01-28','11:20:00',5.86),('8902','2013-01-28','11:25:00',5.84),('8902','2013-01-28','11:30:00',5.81),('8902','2013-01-28','11:35:00',6.05),('8902','2013-01-28','11:40:00',6.17),('8902','2013-01-28','11:45:00',6.16),('8902','2013-01-28','11:50:00',6.18),('8902','2013-01-28','11:55:00',6.15),('8902','2013-01-28','12:00:00',6.14),('8902','2013-01-28','12:05:00',6.19),('8902','2013-01-28','12:10:00',6.3),('8902','2013-01-28','12:15:00',6.22),('8902','2013-01-28','12:20:00',6.2),('8902','2013-01-28','12:25:00',6.31),('8902','2013-01-28','12:30:00',6.22),('8902','2013-01-28','12:35:00',6.13),('8902','2013-01-28','12:40:00',6.19),('8902','2013-01-28','12:45:00',6.12),('8902','2013-01-28','12:50:00',6.1),('8902','2013-01-28','12:55:00',6.23),('8902','2013-01-28','13:00:00',6.15),('8902','2013-01-28','13:05:00',6.05),('8902','2013-01-28','13:10:00',6.07),('8902','2013-01-28','13:15:00',6.02),('8902','2013-01-28','13:20:00',6),('8902','2013-01-28','13:25:00',6.03),('8902','2013-01-28','13:30:00',5.94),('8902','2013-01-28','13:35:00',5.88),('8902','2013-01-28','13:40:00',5.81),('8902','2013-01-28','13:45:00',5.74),('8902','2013-01-28','13:50:00',5.63),('8902','2013-01-28','13:55:00',5.54),('8902','2013-01-28','14:00:00',5.48),('8902','2013-01-28','14:05:00',5.32),('8902','2013-01-28','14:10:00',5.15),('8902','2013-01-28','14:15:00',5.28),('8902','2013-01-28','14:20:00',5.29),('8902','2013-01-28','14:25:00',5.19),('8902','2013-01-28','14:30:00',5.05),('8902','2013-01-28','14:35:00',4.91),('8902','2013-01-28','14:40:00',4.82),('8902','2013-01-28','14:45:00',4.75),('8902','2013-01-28','14:50:00',4.63),('8902','2013-01-28','14:55:00',4.48),('8902','2013-01-28','15:00:00',4.31),('8902','2013-01-28','15:05:00',4.19),('8902','2013-01-28','15:10:00',4.03),('8902','2013-01-28','15:15:00',3.87),('8902','2013-01-28','15:20:00',3.7),('8902','2013-01-28','15:25:00',3.51),('8902','2013-01-28','15:30:00',3.34),('8902','2013-01-28','15:35:00',3.21),('8902','2013-01-28','15:40:00',3.07),('8902','2013-01-28','15:45:00',2.93),('8902','2013-01-28','15:50:00',2.66),('8902','2013-01-28','15:55:00',2.57),('8902','2013-01-28','16:00:00',2.46),('8902','2013-01-28','16:05:00',2.3),('8902','2013-01-28','16:10:00',2.19),('8902','2013-01-28','16:15:00',2.05),('8902','2013-01-28','16:20:00',1.87),('8902','2013-01-28','16:25:00',1.67),('8902','2013-01-28','16:30:00',1.49),('8902','2013-01-28','16:35:00',1.3),('8902','2013-01-28','16:40:00',1.09),('8902','2013-01-27','10:50:00',1.04),('8902','2013-01-27','10:55:00',1.17),('8902','2013-01-27','11:00:00',1.37),('8902','2013-01-27','11:05:00',1.54),('8902','2013-01-27','11:10:00',1.61),('8902','2013-01-27','11:15:00',1.37),('8902','2013-01-27','11:20:00',1.35),('8902','2013-01-27','11:25:00',1.29),('8902','2013-01-27','11:30:00',1.19),('8902','2013-01-27','11:35:00',1.12),('8902','2013-01-27','11:40:00',1.07),('8902','2013-01-27','11:45:00',1.06),('8902','2013-01-27','11:50:00',1.03),('8902','2013-01-27','12:25:00',1.01),('8902','2013-01-27','12:30:00',1.08),('8902','2013-01-27','12:35:00',1.25),('8902','2013-01-27','12:40:00',1.52),('8902','2013-01-27','12:45:00',1.93),('8902','2013-01-27','12:50:00',2.36),('8902','2013-01-27','12:55:00',2.24),('8902','2013-01-27','13:00:00',2.07),('8902','2013-01-27','13:05:00',2),('8902','2013-01-27','13:10:00',1.84),('8902','2013-01-27','13:15:00',1.75),('8902','2013-01-27','13:20:00',1.78),('8902','2013-01-27','13:25:00',1.81),('8902','2013-01-27','13:30:00',1.76),('8902','2013-01-27','13:35:00',1.6),('8902','2013-01-27','13:40:00',1.42),('8902','2013-01-27','13:45:00',1.31),('8902','2013-01-27','13:50:00',1.21),('8902','2013-01-27','13:55:00',1.18),('8902','2013-01-27','14:00:00',1.25),('8902','2013-01-27','14:05:00',1.32),('8902','2013-01-27','14:10:00',1.28),('8902','2013-01-27','14:15:00',1.18),('8902','2013-01-27','14:20:00',1.08),('8902','2013-01-26','08:25:00',1.15),('8902','2013-01-26','08:30:00',1.55),('8902','2013-01-26','08:35:00',1.86),('8902','2013-01-26','08:40:00',2.09),('8902','2013-01-26','08:45:00',2.17),('8902','2013-01-26','08:50:00',2.19),('8902','2013-01-26','08:55:00',2.32),('8902','2013-01-26','09:00:00',2.48),('8902','2013-01-26','09:05:00',2.64),('8902','2013-01-26','09:10:00',2.79),('8902','2013-01-26','09:15:00',2.96),('8902','2013-01-26','09:20:00',3.13),('8902','2013-01-26','09:25:00',3.3),('8902','2013-01-26','09:30:00',3.45),('8902','2013-01-26','09:35:00',3.6),('8902','2013-01-26','09:40:00',3.75),('8902','2013-01-26','09:45:00',3.9),('8902','2013-01-26','09:50:00',4.05),('8902','2013-01-26','09:55:00',4.19),('8902','2013-01-26','10:00:00',4.31),('8902','2013-01-26','10:05:00',4.43),('8902','2013-01-26','10:10:00',4.54),('8902','2013-01-26','10:15:00',4.68),('8902','2013-01-26','10:20:00',4.78),('8902','2013-01-26','10:25:00',4.88),('8902','2013-01-26','10:30:00',4.98),('8902','2013-01-26','10:35:00',5.09),('8902','2013-01-26','10:40:00',5.15),('8902','2013-01-26','10:45:00',5.24),('8902','2013-01-26','10:50:00',5.32),('8902','2013-01-26','10:55:00',5.44),('8902','2013-01-26','11:00:00',5.51),('8902','2013-01-26','11:05:00',5.58),('8902','2013-01-26','11:10:00',5.62),('8902','2013-01-26','11:15:00',5.68),('8902','2013-01-26','11:20:00',5.76),('8902','2013-01-26','11:25:00',5.8),('8902','2013-01-26','11:30:00',5.81),('8902','2013-01-26','11:35:00',5.88),('8902','2013-01-26','11:40:00',5.94),('8902','2013-01-26','11:45:00',5.99),('8902','2013-01-26','11:50:00',6.02),('8902','2013-01-26','11:55:00',6.02),('8902','2013-01-26','12:00:00',6.1),('8902','2013-01-26','12:05:00',6.11),('8902','2013-01-26','12:10:00',6.1),('8902','2013-01-26','12:15:00',6.17),('8902','2013-01-26','12:20:00',6.24),('8902','2013-01-26','12:25:00',6.15),('8902','2013-01-26','12:30:00',6.17),('8902','2013-01-26','12:35:00',6.11),('8902','2013-01-26','12:40:00',6.12),('8902','2013-01-26','12:45:00',6.15),('8902','2013-01-26','12:50:00',6.2),('8902','2013-01-26','12:55:00',6.15),('8902','2013-01-26','13:00:00',6.17),('8902','2013-01-26','13:05:00',6.22),('8902','2013-01-26','13:10:00',6.12),('8902','2013-01-26','13:15:00',6.03),('8902','2013-01-26','13:20:00',5.86),('8902','2013-01-26','13:25:00',5.87),('8902','2013-01-26','13:30:00',5.71),('8902','2013-01-26','13:35:00',5.69),('8902','2013-01-26','13:40:00',5.59),('8902','2013-01-26','13:45:00',5.52),('8902','2013-01-26','13:50:00',5.47),('8902','2013-01-26','13:55:00',5.41),('8902','2013-01-26','14:00:00',5.33),('8902','2013-01-26','14:05:00',5.23),('8902','2013-01-26','14:10:00',5.1),('8902','2013-01-26','14:15:00',5.02),('8902','2013-01-26','14:20:00',4.97),('8902','2013-01-26','14:25:00',4.84),('8902','2013-01-26','14:30:00',4.72),('8902','2013-01-26','14:35:00',4.55),('8902','2013-01-26','14:40:00',4.45),('8902','2013-01-26','14:45:00',4.39),('8902','2013-01-26','14:50:00',4.37),('8902','2013-01-26','14:55:00',4.3),('8902','2013-01-26','15:00:00',4.13),('8902','2013-01-26','15:05:00',3.98),('8902','2013-01-26','15:10:00',3.78),('8902','2013-01-26','15:15:00',3.63),('8902','2013-01-26','15:20:00',3.43),('8902','2013-01-26','15:25:00',3.3),('8902','2013-01-26','15:30:00',3.16),('8902','2013-01-26','15:35:00',2.98),('8902','2013-01-26','15:40:00',2.83),('8902','2013-01-26','15:45:00',2.67),('8902','2013-01-26','15:50:00',2.56),('8902','2013-01-26','15:55:00',2.39),('8902','2013-01-26','16:00:00',2.23),('8902','2013-01-26','16:05:00',2.14),('8902','2013-01-26','16:10:00',1.91),('8902','2013-01-26','16:15:00',1.65),('8902','2013-01-26','16:20:00',1.43),('8902','2013-01-26','16:25:00',1.25),('8902','2013-01-26','16:30:00',1.09),('8902','2013-01-25','08:50:00',1.03),('8902','2013-01-25','08:55:00',1.42),('8902','2013-01-25','09:00:00',2.16),('8902','2013-01-25','09:05:00',2.33),('8902','2013-01-25','09:10:00',2.13),('8902','2013-01-25','09:15:00',1.91),('8902','2013-01-25','09:20:00',2.14),('8902','2013-01-25','09:25:00',1.75),('8902','2013-01-25','09:30:00',1.43),('8902','2013-01-25','09:35:00',1.67),('8902','2013-01-25','09:40:00',1.31),('8902','2013-01-25','09:45:00',1.34),('8902','2013-01-25','09:50:00',2.01),('8902','2013-01-25','09:55:00',2.5),('8902','2013-01-25','10:00:00',1.8),('8902','2013-01-25','10:05:00',1.91),('8902','2013-01-25','10:10:00',1.66),('8902','2013-01-25','10:15:00',1.81),('8902','2013-01-25','10:20:00',2.47),('8902','2013-01-25','10:25:00',2.63),('8902','2013-01-25','10:30:00',1.6),('8902','2013-01-25','10:35:00',1.45),('8902','2013-01-25','10:40:00',1.67),('8902','2013-01-25','10:45:00',1.72),('8902','2013-01-25','10:50:00',2.09),('8902','2013-01-25','10:55:00',2.09),('8902','2013-01-25','11:00:00',1.67),('8902','2013-01-25','11:05:00',1.95),('8902','2013-01-25','11:10:00',1.76),('8902','2013-01-25','11:15:00',1.68),('8902','2013-01-25','11:20:00',1.6),('8902','2013-01-25','11:25:00',1.82),('8902','2013-01-25','11:30:00',1.8),('8902','2013-01-25','11:35:00',1.75),('8902','2013-01-25','11:40:00',1.74),('8902','2013-01-25','11:45:00',1.59),('8902','2013-01-25','11:50:00',1.63),('8902','2013-01-25','11:55:00',1.69),('8902','2013-01-25','12:00:00',1.45),('8902','2013-01-25','12:05:00',1.37),('8902','2013-01-25','12:10:00',1.36),('8902','2013-01-25','12:15:00',1.38),('8902','2013-01-25','12:20:00',1.39),('8902','2013-01-25','12:25:00',1.82),('8902','2013-01-25','12:30:00',1.76),('8902','2013-01-25','12:35:00',1.72),('8902','2013-01-25','12:40:00',1.6),('8902','2013-01-25','12:45:00',1.54),('8902','2013-01-25','12:50:00',1.66),('8902','2013-01-25','12:55:00',1.2),('8902','2013-01-25','13:05:00',1.18),('8902','2013-01-25','13:10:00',1.14),('8902','2013-01-25','13:35:00',1.2),('8902','2013-01-25','13:40:00',1.28),('8902','2013-01-25','13:45:00',1.21),('8902','2013-01-25','13:50:00',1.09),('8902','2013-01-25','13:55:00',1.07),('8902','2013-01-25','14:25:00',1.05),('8902','2013-01-25','14:30:00',1.06),('8902','2013-01-24','08:25:00',1.12),('8902','2013-01-24','08:30:00',1.23),('8902','2013-01-24','08:35:00',1.5),('8902','2013-01-24','08:40:00',1.89),('8902','2013-01-24','08:45:00',2.15),('8902','2013-01-24','08:50:00',2.21),('8902','2013-01-24','08:55:00',2.31),('8902','2013-01-24','09:00:00',2.77),('8902','2013-01-24','09:05:00',2.39),('8902','2013-01-24','09:10:00',2.49),('8902','2013-01-24','09:15:00',3.09),('8902','2013-01-24','09:20:00',3.39),('8902','2013-01-24','09:25:00',3.65),('8902','2013-01-24','09:30:00',3.88),('8902','2013-01-24','09:35:00',3.74),('8902','2013-01-24','09:40:00',3.68),('8902','2013-01-24','09:45:00',3.72),('8902','2013-01-24','09:50:00',4.6),('8902','2013-01-24','09:55:00',4.75),('8902','2013-01-24','10:00:00',4.84),('8902','2013-01-24','10:05:00',4.93),('8902','2013-01-24','10:10:00',4.98),('8902','2013-01-24','10:15:00',5.04),('8902','2013-01-24','10:20:00',5.13),('8902','2013-01-24','10:25:00',5.15),('8902','2013-01-24','10:30:00',5.1),('8902','2013-01-24','10:35:00',3.25),('8902','2013-01-24','10:40:00',4.32),('8902','2013-01-24','10:45:00',5.33),('8902','2013-01-24','10:50:00',4.23),('8902','2013-01-24','10:55:00',5.75),('8902','2013-01-24','11:00:00',3.72),('8902','2013-01-24','11:05:00',4.64),('8902','2013-01-24','11:10:00',5.47),('8902','2013-01-24','11:15:00',6.02),('8902','2013-01-24','11:20:00',5.98),('8902','2013-01-24','11:25:00',6),('8902','2013-01-24','11:30:00',6.03),('8902','2013-01-24','11:35:00',6.16),('8902','2013-01-24','11:40:00',6.16),('8902','2013-01-24','11:45:00',6.22),('8902','2013-01-24','11:50:00',6.3),('8902','2013-01-24','11:55:00',6.3),('8902','2013-01-24','12:00:00',6.25),('8902','2013-01-24','12:05:00',6.28),('8902','2013-01-24','12:10:00',6.39),('8902','2013-01-24','12:15:00',6.44),('8902','2013-01-24','12:20:00',6.49),('8902','2013-01-24','12:25:00',6.51),('8902','2013-01-24','12:30:00',6.48),('8902','2013-01-24','12:35:00',5.59),('8902','2013-01-24','12:40:00',5.74),('8902','2013-01-24','12:45:00',6.22),('8902','2013-01-24','12:50:00',6.32),('8902','2013-01-24','12:55:00',6.13),('8902','2013-01-24','13:00:00',6.23),('8902','2013-01-24','13:05:00',6.18),('8902','2013-01-24','13:10:00',6.07),('8902','2013-01-24','13:15:00',6.09),('8902','2013-01-24','13:20:00',6.07),('8902','2013-01-24','13:25:00',6.15),('8902','2013-01-24','13:30:00',6.3),('8902','2013-01-24','13:35:00',6.22),('8902','2013-01-24','13:40:00',6.1),('8902','2013-01-24','13:45:00',5.99),('8902','2013-01-24','13:50:00',5.8),('8902','2013-01-24','13:55:00',5.69),('8902','2013-01-24','14:00:00',5.49),('8902','2013-01-24','14:05:00',5.35),('8902','2013-01-24','14:10:00',4.88),('8902','2013-01-24','14:15:00',4.78),('8902','2013-01-24','14:20:00',4.28),('8902','2013-01-24','14:25:00',4.46),('8902','2013-01-24','14:30:00',4.16),('8902','2013-01-24','14:35:00',3.94),('8902','2013-01-24','14:40:00',3.84),('8902','2013-01-24','14:45:00',3.73),('8902','2013-01-24','14:50:00',3.81),('8902','2013-01-24','14:55:00',3.66),('8902','2013-01-24','15:00:00',3.34),('8902','2013-01-24','15:05:00',3.17),('8902','2013-01-24','15:10:00',3.18),('8902','2013-01-24','15:15:00',3.08),('8902','2013-01-24','15:20:00',2.97),('8902','2013-01-24','15:25:00',3),('8902','2013-01-24','15:30:00',2.99),('8902','2013-01-24','15:35:00',3.11),('8902','2013-01-24','15:40:00',2.95),('8902','2013-01-24','15:45:00',2.53),('8902','2013-01-24','15:50:00',2.83),('8902','2013-01-24','15:55:00',2.55),('8902','2013-01-24','16:00:00',1.77),('8902','2013-01-24','16:05:00',1.07),('8902','2013-01-24','16:15:00',1.26),('8902','2013-01-24','16:20:00',1.22),('8902','2013-01-23','08:50:00',1.13),('8902','2013-01-23','08:55:00',1.3),('8902','2013-01-23','09:00:00',1.59),('8902','2013-01-23','09:05:00',1.11),('8902','2013-01-23','09:10:00',1.08),('8902','2013-01-23','09:15:00',1.19),('8902','2013-01-23','09:20:00',1.54),('8902','2013-01-23','09:25:00',1.72),('8902','2013-01-23','09:30:00',1.63),('8902','2013-01-23','09:35:00',1.39),('8902','2013-01-23','09:40:00',1.45),('8902','2013-01-23','09:45:00',2.6),('8902','2013-01-23','09:50:00',1.73),('8902','2013-01-23','09:55:00',3.12),('8902','2013-01-23','10:00:00',4.4),('8902','2013-01-23','10:05:00',4.57),('8902','2013-01-23','10:10:00',5.03),('8902','2013-01-23','10:15:00',4.84),('8902','2013-01-23','10:20:00',5.13),('8902','2013-01-23','10:25:00',5.15),('8902','2013-01-23','10:30:00',5.22),('8902','2013-01-23','10:35:00',5.3),('8902','2013-01-23','10:40:00',5.42),('8902','2013-01-23','10:45:00',5.56),('8902','2013-01-23','10:50:00',5.54),('8902','2013-01-23','10:55:00',4.39),('8902','2013-01-23','11:00:00',2.88),('8902','2013-01-23','11:05:00',1.94),('8902','2013-01-23','11:10:00',1.23),('8902','2013-01-23','12:35:00',1.07),('8902','2013-01-23','12:40:00',1.3),('8902','2013-01-23','12:45:00',1.56),('8902','2013-01-23','12:50:00',1.71),('8902','2013-01-23','12:55:00',1.79),('8902','2013-01-23','13:00:00',1.78),('8902','2013-01-23','13:05:00',1.72),('8902','2013-01-23','13:10:00',1.58),('8902','2013-01-23','13:15:00',1.51),('8902','2013-01-23','13:20:00',1.51),('8902','2013-01-23','13:25:00',1.57),('8902','2013-01-23','13:30:00',1.63),('8902','2013-01-23','13:35:00',1.6),('8902','2013-01-23','13:40:00',1.6),('8902','2013-01-23','13:45:00',1.65),('8902','2013-01-23','13:50:00',1.7),('8902','2013-01-23','13:55:00',1.79),('8902','2013-01-23','14:00:00',2.37),('8902','2013-01-23','14:05:00',2.34),('8902','2013-01-23','14:10:00',2.22),('8902','2013-01-23','14:15:00',2.6),('8902','2013-01-23','14:20:00',3.72),('8902','2013-01-23','14:25:00',6.86),('8902','2013-01-23','14:30:00',6.16),('8902','2013-01-23','14:35:00',4.52),('8902','2013-01-23','14:40:00',2.82),('8902','2013-01-23','14:45:00',4.11),('8902','2013-01-23','14:50:00',4.5),('8902','2013-01-23','14:55:00',4.69),('8902','2013-01-23','15:00:00',3.66),('8902','2013-01-23','15:05:00',2.54),('8902','2013-01-23','15:10:00',1.61),('8902','2013-01-23','15:15:00',1.51),('8902','2013-01-23','15:20:00',3.04),('8902','2013-01-23','15:25:00',3.3),('8902','2013-01-23','15:30:00',3.35),('8902','2013-01-23','15:35:00',2.89),('8902','2013-01-23','15:40:00',1.45),('8902','2013-01-23','15:45:00',2.65),('8902','2013-01-23','15:50:00',2.8),('8902','2013-01-23','15:55:00',2.45),('8902','2013-01-23','16:00:00',2.28),('8902','2013-01-23','16:05:00',1.93),('8902','2013-01-23','16:10:00',1.48),('8902','2013-01-23','16:15:00',1.72),('8902','2013-01-23','16:20:00',1.53),('8902','2013-01-22','09:45:00',1.15),('8902','2013-01-22','09:50:00',1.49),('8902','2013-01-22','09:55:00',3.05),('8902','2013-01-22','10:00:00',2.08),('8902','2013-01-22','10:05:00',1.46),('8902','2013-01-22','10:10:00',1.01),('8902','2013-01-22','10:15:00',1.53),('8902','2013-01-22','10:20:00',1.51),('8902','2013-01-22','10:25:00',2.85),('8902','2013-01-22','10:30:00',4.88),('8902','2013-01-22','10:35:00',5.17),('8902','2013-01-22','10:40:00',2.48),('8902','2013-01-22','10:45:00',3.56),('8902','2013-01-22','10:50:00',4.84),('8902','2013-01-22','10:55:00',3.9),('8902','2013-01-22','11:00:00',1.39),('8902','2013-01-22','11:10:00',1.02),('8902','2013-01-21','08:05:00',1.04),('8902','2013-01-21','08:10:00',1.04),('8902','2013-01-21','08:25:00',1.02),('8902','2013-01-21','08:35:00',1.32),('8902','2013-01-21','08:45:00',1.79),('8902','2013-01-21','08:50:00',2.04),('8902','2013-01-21','08:55:00',1.27),('8902','2013-01-21','09:00:00',1.98),('8902','2013-01-21','09:05:00',2.76),('8902','2013-01-21','09:15:00',1.03),('8902','2013-01-21','09:25:00',1.38),('8902','2013-01-21','09:30:00',3.43),('8902','2013-01-21','09:35:00',3.93),('8902','2013-01-21','09:40:00',3.12),('8902','2013-01-21','09:45:00',4.92),('8902','2013-01-21','09:50:00',3.22),('8902','2013-01-21','09:55:00',3.61),('8902','2013-01-21','10:00:00',2.73),('8902','2013-01-21','10:05:00',4.61),('8902','2013-01-21','10:10:00',4.86),('8902','2013-01-21','10:15:00',4.51),('8902','2013-01-21','10:20:00',4.75),('8902','2013-01-21','10:25:00',4.92),('8902','2013-01-21','10:30:00',5.31),('8902','2013-01-21','10:35:00',5.53),('8902','2013-01-21','10:40:00',5.41),('8902','2013-01-21','10:45:00',5.48),('8902','2013-01-21','10:50:00',4.57),('8902','2013-01-21','10:55:00',2.75),('8902','2013-01-21','11:00:00',1.82),('8902','2013-01-21','11:05:00',1.28),('8902','2013-01-21','11:10:00',2.21),('8902','2013-01-21','11:15:00',3.57),('8902','2013-01-21','11:20:00',3.56),('8902','2013-01-21','11:25:00',2.64),('8902','2013-01-21','11:30:00',1.58),('8902','2013-01-21','11:35:00',1.34),('8902','2013-01-21','11:40:00',1.06),('8902','2013-01-21','11:45:00',2.61),('8902','2013-01-21','11:50:00',4.76),('8902','2013-01-21','11:55:00',2),('8902','2013-01-21','12:00:00',1.61),('8902','2013-01-21','12:05:00',1.83),('8902','2013-01-21','12:10:00',4.94),('8902','2013-01-21','12:15:00',5.83),('8902','2013-01-21','12:20:00',3.16),('8902','2013-01-21','12:25:00',4.98),('8902','2013-01-21','12:30:00',2.54),('8902','2013-01-21','12:35:00',1.89),('8902','2013-01-21','12:40:00',6.78),('8902','2013-01-21','12:45:00',2.42),('8902','2013-01-21','12:50:00',1.73),('8902','2013-01-21','12:55:00',2.45),('8902','2013-01-21','13:00:00',4.08),('8902','2013-01-21','13:05:00',6.93),('8902','2013-01-21','13:10:00',4.99),('8902','2013-01-21','13:15:00',2),('8902','2013-01-21','13:20:00',6.19),('8902','2013-01-21','13:25:00',1.53),('8902','2013-01-21','13:30:00',2.42),('8902','2013-01-21','13:35:00',1.04),('8902','2013-01-21','13:40:00',1.74),('8902','2013-01-21','13:45:00',1.95),('8902','2013-01-21','13:50:00',2.68),('8902','2013-01-21','13:55:00',1.09),('8902','2013-01-21','14:00:00',1.22),('8902','2013-01-21','14:05:00',1.41),('8902','2013-01-21','14:10:00',2.27),('8902','2013-01-21','14:15:00',2.54),('8902','2013-01-21','14:20:00',2.1),('8902','2013-01-21','14:25:00',4.32),('8902','2013-01-21','14:30:00',1.44),('8902','2013-01-21','14:35:00',3.27),('8902','2013-01-21','14:40:00',2.22),('8902','2013-01-21','14:45:00',3.78),('8902','2013-01-21','14:50:00',2.97),('8902','2013-01-21','14:55:00',1.04),('8902','2013-01-21','15:00:00',1.08),('8902','2013-01-21','15:05:00',1.53),('8902','2014-03-19','07:15:00',1.04),('8902','2014-03-19','07:20:00',1.22),('8902','2014-03-19','07:25:00',1.34),('8902','2014-03-19','07:30:00',1.36),('8902','2014-03-19','07:35:00',1.61),('8902','2014-03-19','07:40:00',1.8),('8902','2014-03-19','07:45:00',1.97),('8902','2014-03-19','07:50:00',2.11),('8902','2014-03-19','07:55:00',2.28),('8902','2014-03-19','08:00:00',2.46),('8902','2014-03-19','08:05:00',2.63),('8902','2014-03-19','08:10:00',2.74),('8902','2014-03-19','08:15:00',2.84),('8902','2014-03-19','08:20:00',2.95),('8902','2014-03-19','08:25:00',3.12),('8902','2014-03-19','08:30:00',3.32),('8902','2014-03-19','08:35:00',3.55),('8902','2014-03-19','08:40:00',3.79),('8902','2014-03-19','08:45:00',4.01),('8902','2014-03-19','08:50:00',4.2),('8902','2014-03-19','08:55:00',4.3),('8902','2014-03-19','09:00:00',4.4),('8902','2014-03-19','09:05:00',4.56),('8902','2014-03-19','09:10:00',4.81),('8902','2014-03-19','09:15:00',4.89),('8902','2014-03-19','09:20:00',5.05),('8902','2014-03-19','09:25:00',5.14),('8902','2014-03-19','09:30:00',5.22),('8902','2014-03-19','09:35:00',5.43),('8902','2014-03-19','09:40:00',5.43),('8902','2014-03-19','09:45:00',5.56),('8902','2014-03-19','09:50:00',5.54),('8902','2014-03-19','09:55:00',5.64),('8902','2014-03-19','10:00:00',5.92),('8902','2014-03-19','10:05:00',6.17),('8902','2014-03-19','10:10:00',6.29),('8902','2014-03-19','10:15:00',6.17),('8902','2014-03-19','10:20:00',6.33),('8902','2014-03-19','10:25:00',6.4),('8902','2014-03-19','10:30:00',6.46),('8902','2014-03-19','10:35:00',6.39),('8902','2014-03-19','10:40:00',6.25),('8902','2014-03-19','10:45:00',6.18),('8902','2014-03-19','10:50:00',6.65),('8902','2014-03-19','10:55:00',7.02),('8902','2014-03-19','11:00:00',7.11),('8902','2014-03-19','11:05:00',7.09),('8902','2014-03-19','11:10:00',7.03),('8902','2014-03-19','11:15:00',6.7),('8902','2014-03-19','11:20:00',6.96),('8902','2014-03-19','11:25:00',7.04),('8902','2014-03-19','11:30:00',7.25),('8902','2014-03-19','11:35:00',7.53),('8902','2014-03-19','11:40:00',7.35),('8902','2014-03-19','11:45:00',7.45),('8902','2014-03-19','11:50:00',7.36),('8902','2014-03-19','11:55:00',7.06),('8902','2014-03-19','12:00:00',6.54),('8902','2014-03-19','12:05:00',7.11),('8902','2014-03-19','12:10:00',7.41),('8902','2014-03-19','12:15:00',7.46),('8902','2014-03-19','12:20:00',7.24),('8902','2014-03-19','12:25:00',6.87),('8902','2014-03-19','12:30:00',7.2),('8902','2014-03-19','12:35:00',7.35),('8902','2014-03-19','12:40:00',7.34),('8902','2014-03-19','12:45:00',7.62),('8902','2014-03-19','12:50:00',7.53),('8902','2014-03-19','12:55:00',7.37),('8902','2014-03-19','13:00:00',7.4),('8902','2014-03-19','13:05:00',7.31),('8902','2014-03-19','13:10:00',7.19),('8902','2014-03-19','13:15:00',7.26),('8902','2014-03-19','13:20:00',7.3),('8902','2014-03-19','13:25:00',7.12),('8902','2014-03-19','13:30:00',7.23),('8902','2014-03-19','13:35:00',7.07),('8902','2014-03-19','13:40:00',6.57),('8902','2014-03-19','13:45:00',6.41),('8902','2014-03-19','13:50:00',6.25),('8902','2014-03-19','13:55:00',5.94),('8902','2014-03-19','14:00:00',5.91),('8902','2014-03-19','14:05:00',6.46),('8902','2014-03-19','14:10:00',6.24),('8902','2014-03-19','14:15:00',6.01),('8902','2014-03-19','14:20:00',5.99),('8902','2014-03-19','14:25:00',6.03),('8902','2014-03-19','14:30:00',5.19),('8902','2014-03-19','14:35:00',4.77),('8902','2014-03-19','14:40:00',5.33),('8902','2014-03-19','14:45:00',5.27),('8902','2014-03-19','14:50:00',5.02),('8902','2014-03-19','14:55:00',4.82),('8902','2014-03-19','15:00:00',4.4),('8902','2014-03-19','15:05:00',4.34),('8902','2014-03-19','15:10:00',4.45),('8902','2014-03-19','15:15:00',4.11),('8902','2014-03-19','15:20:00',4.37),('8902','2014-03-19','15:25:00',4.06),('8902','2014-03-19','15:30:00',3.81),('8902','2014-03-19','15:35:00',3.76),('8902','2014-03-19','15:40:00',3.41),('8902','2014-03-19','15:45:00',3.34),('8902','2014-03-19','15:50:00',3.05),('8902','2014-03-19','15:55:00',2.74),('8902','2014-03-19','16:00:00',2.29),('8902','2014-03-19','16:05:00',2.06),('8902','2014-03-19','16:10:00',2.23),('8902','2014-03-19','16:15:00',2.15),('8902','2014-03-19','16:20:00',2.27),('8902','2014-03-19','16:25:00',2.33),('8902','2014-03-19','16:30:00',2.06),('8902','2014-03-19','16:35:00',1.88),('8902','2014-03-19','16:40:00',1.76),('8902','2014-03-19','16:45:00',1.31),('8902','2014-03-19','16:50:00',1.07),('8902','2013-01-20','10:10:00',1.08),('8902','2013-01-20','10:15:00',1.26),('8902','2013-01-20','10:20:00',1.1),('8902','2013-01-20','10:25:00',1.09),('8902','2013-01-20','10:30:00',1.11),('8902','2013-01-20','10:55:00',1.05),('8902','2013-01-20','11:00:00',1.62),('8902','2013-01-20','11:05:00',1.47),('8902','2013-01-20','11:10:00',1.98),('8902','2013-01-20','11:15:00',2.22),('8902','2013-01-20','11:20:00',1.77),('8902','2013-01-20','11:25:00',1.74),('8902','2013-01-20','11:30:00',1.22),('8902','2013-01-20','11:40:00',1.35),('8902','2013-01-20','11:45:00',1.64),('8902','2013-01-20','11:50:00',1.89),('8902','2013-01-20','11:55:00',6.86),('8902','2013-01-20','12:00:00',6.07),('8902','2013-01-20','12:05:00',5.94),('8902','2013-01-20','12:10:00',5.73),('8902','2013-01-20','12:15:00',5.36),('8902','2013-01-20','12:20:00',1.92),('8902','2013-01-20','12:25:00',3.27),('8902','2013-01-20','12:30:00',1.3),('8902','2013-01-20','12:35:00',1.36),('8902','2013-01-20','12:40:00',2.23),('8902','2013-01-20','12:45:00',1.3),('8902','2013-01-20','12:50:00',2.18),('8902','2013-01-20','12:55:00',1.48),('8902','2013-01-20','13:00:00',1.66),('8902','2013-01-20','13:05:00',3.78),('8902','2013-01-20','13:10:00',2.85),('8902','2013-01-20','13:15:00',1.78),('8902','2013-01-20','13:20:00',1.69),('8902','2013-01-20','13:25:00',1.54),('8902','2013-01-20','13:30:00',5.98),('8902','2013-01-20','13:35:00',6.67),('8902','2013-01-20','13:40:00',6.11),('8902','2013-01-20','13:45:00',1.98),('8902','2013-01-20','13:50:00',4.11),('8902','2013-01-20','13:55:00',5.79),('8902','2013-01-20','14:00:00',5.58),('8902','2013-01-20','14:05:00',5.06),('8902','2013-01-20','14:10:00',5.38),('8902','2013-01-20','14:15:00',4.46),('8902','2013-01-20','14:20:00',4.17),('8902','2013-01-20','14:25:00',4.64),('8902','2013-01-20','14:30:00',2.67),('8902','2013-01-20','14:35:00',1.65),('8902','2013-01-20','14:40:00',1.15),('8902','2013-01-19','08:30:00',1.08),('8902','2013-01-19','08:35:00',1.21),('8902','2013-01-19','08:40:00',1.18),('8902','2013-01-19','10:00:00',1.03),('8902','2013-01-19','10:05:00',1.05),('8902','2013-01-19','10:25:00',1.14),('8902','2013-01-19','10:30:00',1.36),('8902','2013-01-19','10:35:00',1.11),('8902','2013-01-19','10:40:00',1.33),('8902','2013-01-19','10:45:00',1.55),('8902','2013-01-19','10:50:00',1.87),('8902','2013-01-19','10:55:00',2.1),('8902','2013-01-19','11:00:00',2.28),('8902','2013-01-19','11:05:00',2.24),('8902','2013-01-19','11:10:00',2.32),('8902','2013-01-19','11:15:00',3.23),('8902','2013-01-19','11:20:00',2.54),('8902','2013-01-19','11:25:00',3.48),('8902','2013-01-19','11:30:00',4.64),('8902','2013-01-19','11:35:00',3.48),('8902','2013-01-19','11:40:00',1.95),('8902','2013-01-19','11:45:00',1.85),('8902','2013-01-19','11:50:00',1.33),('8902','2013-01-19','12:00:00',1.12),('8902','2013-01-19','12:05:00',1.06),('8902','2013-01-19','12:10:00',1.23),('8902','2013-01-19','12:15:00',1.52),('8902','2013-01-19','12:20:00',1.72),('8902','2013-01-19','12:25:00',1.79),('8902','2013-01-19','12:30:00',1.65),('8902','2013-01-19','12:35:00',1.51),('8902','2013-01-19','12:40:00',1.41),('8902','2013-01-19','12:45:00',1.38),('8902','2013-01-19','12:50:00',1.34),('8902','2013-01-19','12:55:00',1.32),('8902','2013-01-19','13:00:00',1.26),('8902','2013-01-19','13:05:00',1.2),('8902','2013-01-19','13:10:00',1.21),('8902','2013-01-19','13:15:00',1.34),('8902','2013-01-19','13:20:00',1.36),('8902','2013-01-19','13:25:00',1.4),('8902','2013-01-19','13:30:00',1.28),('8902','2013-01-19','13:35:00',1.41),('8902','2013-01-19','13:40:00',1.68),('8902','2013-01-19','13:45:00',1.63),('8902','2013-01-19','13:50:00',1.56),('8902','2013-01-19','13:55:00',1.38),('8902','2013-01-19','14:00:00',1.19),('8902','2013-01-19','14:05:00',1.04),('8902','2013-01-19','14:15:00',1.03),('8902','2013-01-19','14:20:00',1.29),('8902','2013-01-19','14:25:00',1.11),('8902','2013-01-18','08:55:00',1.04),('8902','2013-01-18','09:00:00',1.13),('8902','2013-01-18','09:05:00',1.26),('8902','2013-01-18','09:10:00',1.65),('8902','2013-01-18','09:15:00',2.6),('8902','2013-01-18','09:20:00',2.51),('8902','2013-01-18','09:25:00',2.01),('8902','2013-01-18','09:30:00',1.35),('8902','2013-01-18','09:35:00',1.22),('8902','2013-01-18','09:40:00',1.08),('8902','2013-01-18','09:45:00',1.44),('8902','2013-01-18','09:50:00',1.99),('8902','2013-01-18','09:55:00',2.87),('8902','2013-01-18','10:00:00',2.57),('8902','2013-01-18','10:05:00',1.99),('8902','2013-01-18','10:10:00',1.36),('8902','2013-01-18','10:25:00',1.08),('8902','2013-01-18','10:30:00',1.03),('8902','2013-01-18','10:35:00',1.67),('8902','2013-01-18','10:40:00',2.1),('8902','2013-01-18','10:45:00',2.41),('8902','2013-01-18','10:50:00',2.69),('8902','2013-01-18','10:55:00',1.32),('8902','2013-01-18','11:00:00',1.39),('8902','2013-01-18','11:05:00',1.52),('8902','2013-01-18','11:10:00',1.61),('8902','2013-01-18','11:15:00',1.72),('8902','2013-01-18','11:20:00',2.09),('8902','2013-01-18','11:25:00',2.16),('8902','2013-01-18','11:30:00',1.78),('8902','2013-01-18','11:35:00',1.2),('8902','2013-01-18','11:40:00',1.08),('8902','2013-01-18','11:45:00',1.22),('8902','2013-01-18','11:50:00',1.38),('8902','2013-01-18','11:55:00',1.31),('8902','2013-01-18','12:00:00',1.1),('8902','2013-01-18','12:05:00',1.08),('8902','2013-01-18','12:10:00',1.19),('8902','2013-01-18','12:15:00',1.29),('8902','2013-01-18','12:20:00',1.18),('8902','2013-01-18','14:35:00',1.18),('8902','2013-01-17','08:45:00',1.2),('8902','2013-01-17','08:50:00',1.23),('8902','2013-01-17','08:55:00',1.33),('8902','2013-01-17','09:00:00',1.07),('8902','2013-01-17','09:55:00',1.03),('8902','2013-01-17','10:00:00',1.09),('8902','2013-01-17','10:05:00',1.12),('8902','2013-01-17','10:10:00',1.51),('8902','2013-01-17','10:15:00',4.44),('8902','2013-01-17','10:20:00',4.32),('8902','2013-01-17','10:25:00',3.12),('8902','2013-01-17','10:30:00',2.58),('8902','2013-01-17','10:35:00',1.97),('8902','2013-01-17','10:40:00',1.59),('8902','2013-01-17','10:45:00',1.45),('8902','2013-01-17','10:50:00',1.49),('8902','2013-01-17','10:55:00',1.5),('8902','2013-01-17','11:00:00',1.59),('8902','2013-01-17','11:05:00',1.68),('8902','2013-01-17','11:10:00',1.7),('8902','2013-01-17','11:15:00',1.63),('8902','2013-01-17','11:20:00',1.44),('8902','2013-01-17','11:25:00',1.46),('8902','2013-01-17','11:30:00',1.86),('8902','2013-01-17','11:35:00',2.25),('8902','2013-01-17','11:40:00',2.21),('8902','2013-01-17','11:45:00',1.82),('8902','2013-01-17','11:50:00',1.49),('8902','2013-01-17','11:55:00',1.52),('8902','2013-01-17','12:00:00',1.67),('8902','2013-01-17','12:05:00',1.66),('8902','2013-01-17','12:10:00',1.87),('8902','2013-01-17','12:15:00',1.9),('8902','2013-01-17','12:20:00',1.85),('8902','2013-01-17','12:25:00',1.92),('8902','2013-01-17','12:30:00',1.96),('8902','2013-01-17','12:35:00',2.33),('8902','2013-01-17','12:40:00',2.76),('8902','2013-01-17','12:45:00',2.86),('8902','2013-01-17','12:50:00',4.2),('8902','2013-01-17','12:55:00',3.85),('8902','2013-01-17','13:00:00',4.66),('8902','2013-01-17','13:05:00',4.24),('8902','2013-01-17','13:10:00',4.04),('8902','2013-01-17','13:15:00',4.5),('8902','2013-01-17','13:20:00',3.69),('8902','2013-01-17','13:25:00',2.99),('8902','2013-01-17','13:30:00',2.83),('8902','2013-01-17','13:35:00',3.27),('8902','2013-01-17','13:40:00',4.85),('8902','2013-01-17','13:45:00',4.54),('8902','2013-01-17','13:50:00',6.03),('8902','2013-01-17','13:55:00',4.57),('8902','2013-01-17','14:00:00',6.25),('8902','2013-01-17','14:05:00',4.03),('8902','2013-01-17','14:10:00',5.49),('8902','2013-01-17','14:15:00',3.81),('8902','2013-01-17','14:20:00',3.16),('8902','2013-01-17','14:25:00',2.56),('8902','2013-01-17','14:30:00',2.23),('8902','2013-01-17','14:35:00',1.88),('8902','2013-01-17','14:40:00',1.69),('8902','2013-01-17','14:45:00',1.87),('8902','2013-01-17','14:50:00',2.09),('8902','2013-01-17','14:55:00',1.76),('8902','2013-01-17','15:00:00',1.48),('8902','2013-01-17','15:05:00',1.6),('8902','2013-01-17','15:10:00',1.52),('8902','2013-01-17','15:15:00',1.76),('8902','2013-01-17','15:20:00',2.07),('8902','2013-01-17','15:25:00',2.57),('8902','2013-01-17','15:30:00',2.21),('8902','2013-01-17','15:35:00',1.55),('8902','2013-01-17','15:45:00',1.56),('8902','2013-01-17','15:50:00',2.03),('8902','2013-01-17','15:55:00',2.08),('8902','2013-01-17','16:00:00',1.88),('8902','2013-01-17','16:05:00',1.77),('8902','2013-01-17','16:10:00',1.65),('8902','2013-01-17','16:15:00',1.54),('8902','2013-01-17','16:20:00',1.3),('8902','2013-01-17','16:25:00',1.12),('8902','2013-01-16','09:10:00',1.28),('8902','2013-01-16','09:15:00',1.37),('8902','2013-01-16','09:20:00',1.32),('8902','2013-01-16','09:25:00',1.19),('8902','2013-01-16','09:30:00',1.3),('8902','2013-01-16','09:35:00',1.45),('8902','2013-01-16','09:40:00',1.58),('8902','2013-01-16','09:45:00',1.94),('8902','2013-01-16','09:50:00',2.45),('8902','2013-01-16','09:55:00',2.28),('8902','2013-01-16','10:00:00',1.64),('8902','2013-01-16','10:05:00',1.74),('8902','2013-01-16','10:10:00',2.08),('8902','2013-01-16','10:15:00',2.44),('8902','2013-01-16','10:20:00',2.45),('8902','2013-01-16','10:25:00',3.1),('8902','2013-01-16','10:30:00',3.3),('8902','2013-01-16','10:35:00',3.05),('8902','2013-01-16','10:40:00',2.86),('8902','2013-01-16','10:45:00',3.12),('8902','2013-01-16','10:50:00',2.93),('8902','2013-01-16','10:55:00',3.55),('8902','2013-01-16','11:00:00',3.15),('8902','2013-01-16','11:05:00',3.05),('8902','2013-01-16','11:10:00',3.66),('8902','2013-01-16','11:15:00',3.72),('8902','2013-01-16','11:20:00',3.48),('8902','2013-01-16','11:25:00',3.02),('8902','2013-01-16','11:30:00',2.66),('8902','2013-01-16','11:35:00',2.96),('8902','2013-01-16','11:40:00',3.15),('8902','2013-01-16','11:45:00',2.77),('8902','2013-01-16','11:50:00',2.97),('8902','2013-01-16','11:55:00',3.22),('8902','2013-01-16','12:00:00',3.64),('8902','2013-01-16','12:05:00',3.57),('8902','2013-01-16','12:10:00',3.69),('8902','2013-01-16','12:15:00',4.24),('8902','2013-01-16','12:20:00',3.56),('8902','2013-01-16','12:25:00',3.13),('8902','2013-01-16','12:30:00',2.43),('8902','2013-01-16','12:35:00',2.91),('8902','2013-01-16','12:40:00',3.02),('8902','2013-01-16','12:45:00',2.33),('8902','2013-01-16','12:50:00',1.58),('8902','2013-01-16','12:55:00',1.55),('8902','2013-01-16','13:00:00',3.38),('8902','2013-01-16','13:05:00',2.82),('8902','2013-01-16','13:10:00',2.14),('8902','2013-01-16','13:15:00',2.85),('8902','2013-01-16','13:20:00',3.16),('8902','2013-01-16','13:25:00',2.81),('8902','2013-01-16','13:30:00',2.44),('8902','2013-01-16','13:35:00',2.99),('8902','2013-01-16','13:40:00',4.21),('8902','2013-01-16','13:45:00',4.12),('8902','2013-01-16','13:50:00',3.08),('8902','2013-01-16','13:55:00',2.09),('8902','2013-01-16','14:00:00',1.84),('8902','2013-01-16','14:05:00',1.92),('8902','2013-01-16','14:10:00',1.7),('8902','2013-01-16','14:15:00',1.08),('8902','2013-01-16','14:20:00',1.17),('8902','2013-01-16','14:25:00',1.63),('8902','2013-01-16','14:30:00',2.18),('8902','2013-01-16','14:35:00',2.85),('8902','2013-01-16','14:40:00',1.93),('8902','2013-01-16','14:55:00',1.38),('8902','2013-01-16','15:00:00',1.5),('8902','2013-01-15','09:15:00',2.15),('8902','2013-01-15','09:20:00',1.92),('8902','2013-01-15','09:25:00',2.99),('8902','2013-01-15','09:30:00',3.36),('8902','2013-01-15','09:35:00',3.54),('8902','2013-01-15','09:40:00',3.85),('8902','2013-01-15','09:45:00',2.56),('8902','2013-01-15','09:50:00',1.44),('8902','2013-01-15','09:55:00',1.66),('8902','2013-01-15','10:00:00',1.96),('8902','2013-01-15','10:05:00',1.16),('8902','2013-01-15','10:25:00',1.07),('8902','2013-01-15','10:30:00',1.38),('8902','2013-01-15','10:35:00',3.39),('8902','2013-01-15','10:40:00',3.94),('8902','2013-01-15','10:45:00',4.72),('8902','2013-01-15','10:50:00',1.31),('8902','2013-01-15','10:55:00',3.73),('8902','2013-01-15','11:00:00',1.56),('8902','2013-01-15','11:05:00',1.35),('8902','2013-01-15','11:25:00',2.98),('8902','2013-01-15','12:00:00',2.61),('8902','2013-01-15','12:05:00',2.48),('8902','2013-01-15','12:10:00',2.77),('8902','2013-01-15','12:15:00',6.52),('8902','2013-01-15','12:20:00',6.67),('8902','2013-01-15','12:25:00',3.05),('8902','2013-01-15','13:00:00',1.1),('8902','2013-01-15','13:05:00',3.93),('8902','2013-01-15','13:10:00',7.78),('8902','2013-01-15','13:15:00',8.02),('8902','2013-01-15','13:20:00',6.02),('8902','2013-01-15','13:25:00',3.64),('8902','2013-01-15','13:30:00',1.36),('8902','2013-01-15','13:55:00',5.08),('8902','2013-01-15','14:00:00',3.55),('8902','2013-01-15','14:05:00',2.54),('8902','2013-01-15','14:10:00',1.29),('8902','2013-01-15','15:05:00',1.68),('8902','2013-01-15','15:10:00',1.73),('8902','2013-01-15','15:15:00',1.54),('8902','2013-01-15','16:05:00',1.75),('8902','2013-01-15','16:10:00',1.57),('8902','2013-01-15','16:15:00',1.37),('8902','2013-01-14','08:55:00',1.17),('8902','2013-01-14','09:00:00',1.18),('8902','2013-01-14','09:15:00',1.07),('8902','2013-01-14','09:50:00',1.2),('8902','2013-01-14','09:55:00',1.78),('8902','2013-01-14','10:00:00',1.9),('8902','2013-01-14','10:05:00',1.43),('8902','2013-01-14','10:10:00',1.82),('8902','2013-01-14','10:15:00',1.57),('8902','2013-01-14','10:20:00',1.84),('8902','2013-01-14','10:25:00',1.87),('8902','2013-01-14','10:30:00',1.39),('8902','2013-01-14','10:35:00',1.55),('8902','2013-01-14','10:40:00',1.75),('8902','2013-01-14','10:45:00',2.07),('8902','2013-01-14','10:50:00',2.61),('8902','2013-01-14','10:55:00',2.83),('8902','2013-01-14','11:00:00',2.6),('8902','2013-01-14','11:05:00',2.75),('8902','2013-01-14','11:10:00',2.96),('8902','2013-01-14','11:15:00',2.81),('8902','2013-01-14','11:20:00',2.99),('8902','2013-01-14','11:25:00',2.92),('8902','2013-01-14','11:30:00',2.77),('8902','2013-01-14','11:35:00',2.52),('8902','2013-01-14','11:40:00',2.35),('8902','2013-01-14','11:45:00',1.98),('8902','2013-01-14','11:50:00',1.83),('8902','2013-01-14','11:55:00',2.01),('8902','2013-01-14','12:00:00',1.94),('8902','2013-01-14','12:05:00',1.85),('8902','2013-01-14','12:10:00',1.78),('8902','2013-01-14','12:15:00',2.11),('8902','2013-01-14','12:20:00',2.44),('8902','2013-01-14','12:25:00',2.37),('8902','2013-01-14','12:30:00',2.15),('8902','2013-01-14','12:35:00',2.14),('8902','2013-01-14','12:40:00',2.41),('8902','2013-01-14','12:45:00',2.51),('8902','2013-01-14','12:50:00',2.33),('8902','2013-01-14','12:55:00',2.07),('8902','2013-01-14','13:00:00',1.71),('8902','2013-01-14','13:05:00',1.8),('8902','2013-01-14','13:10:00',1.79),('8902','2013-01-14','13:15:00',1.85),('8902','2013-01-14','13:20:00',1.88),('8902','2013-01-14','13:25:00',1.82),('8902','2013-01-14','13:30:00',2.02),('8902','2013-01-14','13:35:00',2.06),('8902','2013-01-14','13:40:00',2.35),('8902','2013-01-14','13:45:00',2.2),('8902','2013-01-14','13:50:00',2.16),('8902','2013-01-14','13:55:00',2.49),('8902','2013-01-14','14:00:00',4.45),('8902','2013-01-14','14:05:00',5.8),('8902','2013-01-14','14:10:00',5.47),('8902','2013-01-14','14:15:00',5.84),('8902','2013-01-14','14:20:00',5.99),('8902','2013-01-14','14:25:00',5.81),('8902','2013-01-14','14:30:00',4.2),('8902','2013-01-14','14:35:00',3.35),('8902','2013-01-14','14:40:00',4.43),('8902','2013-01-14','14:45:00',4.26),('8902','2013-01-14','14:50:00',3.82),('8902','2013-01-14','14:55:00',3.49),('8902','2013-01-14','15:00:00',4.13),('8902','2013-01-14','15:05:00',4.04),('8902','2013-01-14','15:10:00',3.75),('8902','2013-01-14','15:15:00',2.12),('8902','2013-01-14','15:20:00',1.41),('8902','2013-01-14','15:25:00',2.32),('8902','2013-01-14','15:30:00',2.19),('8902','2013-01-14','15:35:00',1.9),('8902','2013-01-14','15:40:00',1.59),('8902','2013-01-14','15:45:00',1.48),('8902','2013-01-14','15:50:00',1.44),('8902','2013-01-14','15:55:00',1.41),('8902','2013-01-14','16:00:00',1.74),('8902','2013-01-14','16:05:00',2.07),('8902','2013-01-14','16:10:00',1.91),('8902','2013-01-14','16:15:00',1.68),('8902','2013-01-14','16:20:00',1.43),('8902','2013-01-14','16:25:00',1.19),('8902','2013-01-13','09:45:00',1.01),('8902','2013-01-13','09:50:00',1.11),('8902','2013-01-13','10:25:00',1.01),('8902','2013-01-13','11:20:00',1.27),('8902','2013-01-13','11:25:00',1.3),('8902','2013-01-13','11:50:00',1.11),('8902','2013-01-13','12:20:00',1.13),('8902','2013-01-13','12:25:00',1.56),('8902','2013-01-13','12:30:00',1.62),('8902','2013-01-13','12:35:00',1.43),('8902','2013-01-13','12:40:00',1.65),('8902','2013-01-13','12:45:00',1.8),('8902','2013-01-13','12:50:00',2.26),('8902','2013-01-13','12:55:00',2.12),('8902','2013-01-13','13:00:00',2.21),('8902','2013-01-13','13:05:00',2.12),('8902','2013-01-13','13:10:00',1.98),('8902','2013-01-13','13:15:00',1.66),('8902','2013-01-13','13:20:00',1.18),('8902','2013-01-13','13:35:00',1.28),('8902','2013-01-13','13:40:00',1.1),('8902','2013-01-13','15:15:00',3.03),('8902','2013-01-13','15:20:00',1.73),('8902','2013-01-13','15:25:00',1.7),('8902','2013-01-13','15:30:00',1.14),('8902','2013-01-12','09:10:00',1.17),('8902','2013-01-12','09:15:00',3.2),('8902','2013-01-12','09:20:00',3.32),('8902','2013-01-12','09:25:00',3.24),('8902','2013-01-12','09:30:00',3.43),('8902','2013-01-12','09:35:00',3.59),('8902','2013-01-12','09:40:00',2.32),('8902','2013-01-12','09:45:00',1.37),('8902','2013-01-12','09:50:00',2.63),('8902','2013-01-12','09:55:00',3.47),('8902','2013-01-12','10:00:00',3.52),('8902','2013-01-12','10:05:00',3.68),('8902','2013-01-12','10:10:00',2.57),('8902','2013-01-12','10:15:00',1.49),('8902','2013-01-12','10:20:00',1.97),('8902','2013-01-12','10:25:00',3.29),('8902','2013-01-12','10:30:00',3.95),('8902','2013-01-12','10:35:00',1.8),('8902','2013-01-11','08:30:00',1.01),('8902','2013-01-11','08:35:00',1.13),('8902','2013-01-11','08:40:00',1.26),('8902','2013-01-11','08:45:00',1.59),('8902','2013-01-11','08:50:00',1.87),('8902','2013-01-11','08:55:00',2.02),('8902','2013-01-11','09:00:00',2.19),('8902','2013-01-11','09:05:00',2.36),('8902','2013-01-11','09:10:00',2.49),('8902','2013-01-11','09:15:00',2.6),('8902','2013-01-11','09:20:00',2.74),('8902','2013-01-11','09:25:00',2.9),('8902','2013-01-11','09:30:00',3.04),('8902','2013-01-11','09:35:00',3.16),('8902','2013-01-11','09:40:00',3.23),('8902','2013-01-11','09:45:00',3.38),('8902','2013-01-11','09:50:00',3.58),('8902','2013-01-11','09:55:00',3.73),('8902','2013-01-11','10:00:00',3.82),('8902','2013-01-11','10:05:00',3.96),('8902','2013-01-11','10:10:00',4.11),('8902','2013-01-11','10:15:00',4.23),('8902','2013-01-11','10:20:00',4.31),('8902','2013-01-11','10:25:00',4.41),('8902','2013-01-11','10:30:00',4.54),('8902','2013-01-11','10:35:00',4.6),('8902','2013-01-11','10:40:00',4.71),('8902','2013-01-11','10:45:00',4.8),('8902','2013-01-11','10:50:00',4.88),('8902','2013-01-11','10:55:00',4.91),('8902','2013-01-11','11:00:00',4.95),('8902','2013-01-11','11:05:00',4.95),('8902','2013-01-11','11:10:00',5.07),('8902','2013-01-11','11:15:00',5.11),('8902','2013-01-11','11:20:00',5.16),('8902','2013-01-11','11:25:00',5.15),('8902','2013-01-11','11:30:00',5.23),('8902','2013-01-11','11:35:00',5.29),('8902','2013-01-11','11:40:00',5.31),('8902','2013-01-11','11:45:00',5.38),('8902','2013-01-11','11:50:00',5.42),('8902','2013-01-11','11:55:00',5.44),('8902','2013-01-11','12:00:00',5.39),('8902','2013-01-11','12:05:00',5.39),('8902','2013-01-11','12:10:00',5.35),('8902','2013-01-11','12:15:00',5.42),('8902','2013-01-11','12:20:00',5.33),('8902','2013-01-11','12:25:00',5.3),('8902','2013-01-11','12:30:00',5.38),('8902','2013-01-11','12:35:00',5.13),('8902','2013-01-11','12:40:00',3.67),('8902','2013-01-11','12:50:00',3.21),('8902','2013-01-11','12:55:00',3.39),('8902','2013-01-11','13:00:00',5.5),('8902','2013-01-11','13:05:00',5.22),('8902','2013-01-11','13:10:00',4.6),('8902','2013-01-11','13:15:00',4.3),('8902','2013-01-11','13:20:00',2.69),('8902','2013-01-11','13:25:00',5.28),('8902','2013-01-11','13:30:00',4.53),('8902','2013-01-11','13:35:00',4.99),('8902','2013-01-11','13:40:00',2.04),('8902','2013-01-11','13:45:00',3.08),('8902','2013-01-11','13:50:00',4.5),('8902','2013-01-11','13:55:00',5.21),('8902','2013-01-11','14:00:00',3.54),('8902','2013-01-11','14:05:00',5.01),('8902','2013-01-11','14:10:00',5.04),('8902','2013-01-11','14:15:00',4.77),('8902','2013-01-11','14:20:00',4.44),('8902','2013-01-11','14:25:00',4.27),('8902','2013-01-11','14:30:00',4.04),('8902','2013-01-11','14:35:00',3.95),('8902','2013-01-11','14:40:00',3.85),('8902','2013-01-11','14:45:00',3.66),('8902','2013-01-11','14:50:00',3.56),('8902','2013-01-11','14:55:00',3.51),('8902','2013-01-11','15:00:00',3.36),('8902','2013-01-11','15:05:00',3.13),('8902','2013-01-11','15:10:00',2.88),('8902','2013-01-11','15:15:00',2.22),('8902','2013-01-11','15:20:00',2.5),('8902','2013-01-11','15:25:00',2.45),('8902','2013-01-11','15:30:00',1.32),('8902','2013-01-11','15:35:00',2.18),('8902','2013-01-11','15:40:00',1.79),('8902','2013-01-11','15:45:00',1.81),('8902','2013-01-11','15:50:00',1.73),('8902','2013-01-11','15:55:00',1.62),('8902','2013-01-11','16:00:00',1.47),('8902','2013-01-11','16:05:00',1.32),('8902','2013-01-11','16:10:00',1.16),('8902','2014-03-18','08:30:00',1.08),('8902','2014-03-18','08:35:00',1.23),('8902','2014-03-18','08:40:00',1.45),('8902','2014-03-18','08:45:00',1.51),('8902','2014-03-18','08:50:00',1.63),('8902','2014-03-18','08:55:00',1.82),('8902','2014-03-18','09:00:00',2.05),('8902','2014-03-18','09:05:00',2.28),('8902','2014-03-18','09:10:00',2.56),('8902','2014-03-18','09:15:00',2.9),('8902','2014-03-18','09:20:00',3.09),('8902','2014-03-18','09:25:00',4.29),('8902','2014-03-18','09:30:00',3.05),('8902','2014-03-18','09:35:00',4.77),('8902','2014-03-18','09:40:00',5.07),('8902','2014-03-18','09:45:00',5.58),('8902','2014-03-18','09:50:00',6.58),('8902','2014-03-18','09:55:00',5.56),('8902','2014-03-18','10:00:00',3.14),('8902','2014-03-18','10:05:00',2.39),('8902','2014-03-18','10:10:00',2.01),('8902','2014-03-18','10:15:00',1.63),('8902','2014-03-18','10:20:00',1.75),('8902','2014-03-18','10:25:00',1.87),('8902','2014-03-18','10:30:00',2.13),('8902','2014-03-18','10:35:00',2.99),('8902','2014-03-18','10:40:00',4.21),('8902','2014-03-18','10:45:00',5.94),('8902','2014-03-18','10:50:00',5.45),('8902','2014-03-18','10:55:00',2.87),('8902','2014-03-18','11:00:00',2.35),('8902','2014-03-18','11:05:00',4.25),('8902','2014-03-18','11:10:00',7.79),('8902','2014-03-18','11:15:00',4.06),('8902','2014-03-18','11:20:00',3.62),('8902','2014-03-18','11:25:00',4.02),('8902','2014-03-18','11:30:00',4.19),('8902','2014-03-18','11:35:00',4.99),('8902','2014-03-18','11:40:00',3.82),('8902','2014-03-18','11:45:00',3.84),('8902','2014-03-18','11:50:00',3.23),('8902','2014-03-18','11:55:00',2.98),('8902','2014-03-18','12:00:00',3.09),('8902','2014-03-18','12:05:00',6.87),('8902','2014-03-18','12:10:00',8.35),('8902','2014-03-18','12:15:00',8.44),('8902','2014-03-18','12:20:00',8.45),('8902','2014-03-18','12:25:00',8.04),('8902','2014-03-18','12:30:00',8.24),('8902','2014-03-18','12:35:00',8),('8902','2014-03-18','12:40:00',8.07),('8902','2014-03-18','12:45:00',7.81),('8902','2014-03-18','12:50:00',7.34),('8902','2014-03-18','12:55:00',5.43),('8902','2014-03-18','13:00:00',6.64),('8902','2014-03-18','13:05:00',6.82),('8902','2014-03-18','13:10:00',7.76),('8902','2014-03-18','13:15:00',7.57),('8902','2014-03-18','13:20:00',5.56),('8902','2014-03-18','13:25:00',5.07),('8902','2014-03-18','13:30:00',7.25),('8902','2014-03-18','13:35:00',7.37),('8902','2014-03-18','13:40:00',7.09),('8902','2014-03-18','13:45:00',7.34),('8902','2014-03-18','13:50:00',7.2),('8902','2014-03-18','13:55:00',7.06),('8902','2014-03-18','14:00:00',6.92),('8902','2014-03-18','14:05:00',6.93),('8902','2014-03-18','14:10:00',6.87),('8902','2014-03-18','14:15:00',6.66),('8902','2014-03-18','14:20:00',6.59),('8902','2014-03-18','14:25:00',6.54),('8902','2014-03-18','14:30:00',6.35),('8902','2014-03-18','14:35:00',6.41),('8902','2014-03-18','14:40:00',6.28),('8902','2014-03-18','14:45:00',6.17),('8902','2014-03-18','14:50:00',6.06),('8902','2014-03-18','14:55:00',5.93),('8902','2014-03-18','15:00:00',5.79),('8902','2014-03-18','15:05:00',5.66),('8902','2014-03-18','15:10:00',5.55),('8902','2014-03-18','15:15:00',5.54),('8902','2014-03-18','15:20:00',5.31),('8902','2014-03-18','15:25:00',5.21),('8902','2014-03-18','15:30:00',5.03),('8902','2014-03-18','15:35:00',4.79),('8902','2014-03-18','15:40:00',4.8),('8902','2014-03-18','15:45:00',4.65),('8902','2014-03-18','15:50:00',4.37),('8902','2014-03-18','15:55:00',4.31),('8902','2014-03-18','16:00:00',4.1),('8902','2014-03-18','16:05:00',3.9),('8902','2014-03-18','16:10:00',3.83),('8902','2014-03-18','16:15:00',3.62),('8902','2014-03-18','16:20:00',3.43),('8902','2014-03-18','16:25:00',3.13),('8902','2014-03-18','16:30:00',2.92),('8902','2014-03-18','16:35:00',2.59),('8902','2014-03-18','16:40:00',2.43),('8902','2014-03-18','16:45:00',2.35),('8902','2014-03-18','16:50:00',1.97),('8902','2014-03-18','16:55:00',1.8),('8902','2014-03-18','17:00:00',1.4),('8902','2014-03-18','17:05:00',1.16),('8902','2014-03-18','17:15:00',1.08),('8902','2013-01-10','09:35:00',1.01),('8902','2013-01-10','09:40:00',1.03),('8902','2013-01-10','09:45:00',1.7),('8902','2013-01-10','09:50:00',2.04),('8902','2013-01-10','09:55:00',1.25),('8902','2013-01-10','10:00:00',2.44),('8902','2013-01-10','10:05:00',2.37),('8902','2013-01-10','10:10:00',2.82),('8902','2013-01-10','10:15:00',2.68),('8902','2013-01-10','10:20:00',2.27),('8902','2013-01-10','10:25:00',4.14),('8902','2013-01-10','10:30:00',4.4),('8902','2013-01-10','10:35:00',4.51),('8902','2013-01-10','10:40:00',4.59),('8902','2013-01-10','10:45:00',4.68),('8902','2013-01-10','10:50:00',4.7),('8902','2013-01-10','10:55:00',4.83),('8902','2013-01-10','11:00:00',4.9),('8902','2013-01-10','11:05:00',4.95),('8902','2013-01-10','11:10:00',4.94),('8902','2013-01-10','11:15:00',4.95),('8902','2013-01-10','11:20:00',4.91),('8902','2013-01-10','11:25:00',3.75),('8902','2013-01-10','11:30:00',1.82),('8902','2013-01-10','11:35:00',3.27),('8902','2013-01-10','11:40:00',2.08),('8902','2013-01-10','11:45:00',3.01),('8902','2013-01-10','11:50:00',2.84),('8902','2013-01-10','11:55:00',2.15),('8902','2013-01-10','12:00:00',1.75),('8902','2013-01-10','12:05:00',1.35),('8902','2013-01-10','12:10:00',1.06),('8902','2013-01-10','12:15:00',1.2),('8902','2013-01-10','12:20:00',1.41),('8902','2013-01-10','12:25:00',1.06),('8902','2013-01-10','12:50:00',1.39),('8902','2013-01-10','12:55:00',3.64),('8902','2013-01-10','13:00:00',3.24),('8902','2013-01-10','13:05:00',2.57),('8902','2013-01-10','13:10:00',3.28),('8902','2013-01-10','13:15:00',2.71),('8902','2013-01-10','13:20:00',1.67),('8902','2013-01-10','13:25:00',1.18),('8902','2013-01-10','13:30:00',2.18),('8902','2013-01-10','13:35:00',4.86),('8902','2013-01-10','13:40:00',3.86),('8902','2013-01-10','13:45:00',3.34),('8902','2013-01-10','13:50:00',1.21),('8902','2013-01-10','14:20:00',2.64),('8902','2013-01-10','14:25:00',2.6),('8902','2013-01-10','14:30:00',1.51),('8902','2013-01-10','14:35:00',1.53),('8902','2013-01-10','14:40:00',1.32),('8902','2013-01-10','14:45:00',2.35),('8902','2013-01-10','14:50:00',3.75),('8902','2013-01-10','14:55:00',2.37),('8902','2013-01-10','15:00:00',3.28),('8902','2013-01-10','15:05:00',3.52),('8902','2013-01-10','15:10:00',1.96),('8902','2013-01-10','15:45:00',1.14),('8902','2013-01-09','10:05:00',1.01),('8902','2013-01-09','11:20:00',1.12),('8902','2013-01-09','11:25:00',1.46),('8902','2013-01-09','11:30:00',1.86),('8902','2013-01-09','11:35:00',1.49),('8902','2013-01-09','11:50:00',1.51),('8902','2013-01-09','11:55:00',2.25),('8902','2013-01-09','12:00:00',2.36),('8902','2013-01-09','12:05:00',2.28),('8902','2013-01-09','12:10:00',2.04),('8902','2013-01-09','12:15:00',1.62),('8902','2013-01-09','12:20:00',1.1),('8902','2013-01-09','13:15:00',1.03),('8902','2013-01-09','13:45:00',1.11),('8902','2013-01-09','13:50:00',1.06),('8902','2013-01-09','13:55:00',1.13),('8902','2013-01-09','14:00:00',1.26),('8902','2013-01-09','14:05:00',1.01),('8902','2013-01-08','09:35:00',1.31),('8902','2013-01-08','09:40:00',1.67),('8902','2013-01-08','09:45:00',1.2),('8902','2013-01-08','09:50:00',1.14),('8902','2013-01-08','09:55:00',1.08),('8902','2013-01-08','10:00:00',1.06),('8902','2013-01-08','10:05:00',1.11),('8902','2013-01-08','10:10:00',1.15),('8902','2013-01-08','10:15:00',1.26),('8902','2013-01-08','10:20:00',1.45),('8902','2013-01-08','10:25:00',1.36),('8902','2013-01-08','10:30:00',1.62),('8902','2013-01-08','10:35:00',1.69),('8902','2013-01-08','10:40:00',1.69),('8902','2013-01-08','10:45:00',2.44),('8902','2013-01-08','10:50:00',2.04),('8902','2013-01-08','10:55:00',3.32),('8902','2013-01-08','11:00:00',1.89),('8902','2013-01-08','11:05:00',1.98),('8902','2013-01-08','11:10:00',2.37),('8902','2013-01-08','11:15:00',5.18),('8902','2013-01-08','11:20:00',4.27),('8902','2013-01-08','11:25:00',2.25),('8902','2013-01-08','11:30:00',2.44),('8902','2013-01-08','11:35:00',2.89),('8902','2013-01-08','11:40:00',2.23),('8902','2013-01-08','11:45:00',2.05),('8902','2013-01-08','11:50:00',2.42),('8902','2013-01-08','11:55:00',3.04),('8902','2013-01-08','12:00:00',3.1),('8902','2013-01-08','12:05:00',2.28),('8902','2013-01-08','12:10:00',2.1),('8902','2013-01-08','12:15:00',2.06),('8902','2013-01-08','12:20:00',2.05),('8902','2013-01-08','12:25:00',1.92),('8902','2013-01-08','12:30:00',1.76),('8902','2013-01-08','12:35:00',1.89),('8902','2013-01-08','12:40:00',1.86),('8902','2013-01-08','12:45:00',1.77),('8902','2013-01-08','12:50:00',1.82),('8902','2013-01-08','12:55:00',2.06),('8902','2013-01-08','13:00:00',2.53),('8902','2013-01-08','13:05:00',3.1),('8902','2013-01-08','13:10:00',4.26),('8902','2013-01-08','13:15:00',2.34),('8902','2013-01-08','13:20:00',2.33),('8902','2013-01-08','13:25:00',1.84),('8902','2013-01-08','13:30:00',1.67),('8902','2013-01-08','13:35:00',1.64),('8902','2013-01-08','13:40:00',1.6),('8902','2013-01-08','13:45:00',1.63),('8902','2013-01-08','13:50:00',1.42),('8902','2013-01-08','13:55:00',1.32),('8902','2013-01-08','14:00:00',1.39),('8902','2013-01-08','14:05:00',1.29),('8902','2013-01-08','14:10:00',1.22),('8902','2013-01-08','14:15:00',1.11),('8902','2013-01-08','14:20:00',1.01),('8902','2013-01-07','08:30:00',1.17),('8902','2013-01-07','08:35:00',1.69),('8902','2013-01-07','08:40:00',1.8),('8902','2013-01-07','08:45:00',2.14),('8902','2013-01-07','08:50:00',2.39),('8902','2013-01-07','08:55:00',2.67),('8902','2013-01-07','09:00:00',2.84),('8902','2013-01-07','09:05:00',2.85),('8902','2013-01-07','09:10:00',1.86),('8902','2013-01-07','09:15:00',2.37),('8902','2013-01-07','09:20:00',2.94),('8902','2013-01-07','09:25:00',3.14),('8902','2013-01-07','09:30:00',2.9),('8902','2013-01-07','09:35:00',2.22),('8902','2013-01-07','09:40:00',3.4),('8902','2013-01-07','09:45:00',3.95),('8902','2013-01-07','09:50:00',4.17),('8902','2013-01-07','09:55:00',4.09),('8902','2013-01-07','10:00:00',3.75),('8902','2013-01-07','10:05:00',3.71),('8902','2013-01-07','10:10:00',3.81),('8902','2013-01-07','10:15:00',3.95),('8902','2013-01-07','10:20:00',3.71),('8902','2013-01-07','10:25:00',4.05),('8902','2013-01-07','10:30:00',4.05),('8902','2013-01-07','10:35:00',4.36),('8902','2013-01-07','10:40:00',4.68),('8902','2013-01-07','10:45:00',4.58),('8902','2013-01-07','10:50:00',4.75),('8902','2013-01-07','10:55:00',4.81),('8902','2013-01-07','11:00:00',4.75),('8902','2013-01-07','11:05:00',4.94),('8902','2013-01-07','11:10:00',5.01),('8902','2013-01-07','11:15:00',5.04),('8902','2013-01-07','11:20:00',5.07),('8902','2013-01-07','11:25:00',5.1),('8902','2013-01-07','11:30:00',5.19),('8902','2013-01-07','11:35:00',5.22),('8902','2013-01-07','11:40:00',5.07),('8902','2013-01-07','11:45:00',6.1),('8902','2013-01-07','11:50:00',4.74),('8902','2013-01-07','11:55:00',3.41),('8902','2013-01-07','12:00:00',3),('8902','2013-01-07','12:05:00',2.89),('8902','2013-01-07','12:10:00',3.03),('8902','2013-01-07','12:15:00',2.79),('8902','2013-01-07','12:20:00',2.48),('8902','2013-01-07','12:25:00',2.43),('8902','2013-01-07','12:30:00',2.34),('8902','2013-01-07','12:35:00',2.29),('8902','2013-01-07','12:40:00',2.91),('8902','2013-01-07','12:45:00',3.43),('8902','2013-01-07','12:50:00',4.57),('8902','2013-01-07','12:55:00',3.99),('8902','2013-01-07','13:00:00',1.74),('8902','2013-01-07','13:05:00',1.54),('8902','2013-01-07','13:10:00',1.7),('8902','2013-01-07','13:15:00',1.72),('8902','2013-01-07','13:20:00',2.81),('8902','2013-01-07','13:25:00',1.91),('8902','2013-01-07','13:30:00',1.62),('8902','2013-01-07','13:35:00',1.41),('8902','2013-01-07','13:40:00',1.77),('8902','2013-01-07','13:45:00',1.91),('8902','2013-01-07','13:50:00',2.49),('8902','2013-01-07','13:55:00',2.51),('8902','2013-01-07','14:00:00',2.02),('8902','2013-01-07','14:05:00',2.32),('8902','2013-01-07','14:10:00',1.52),('8902','2013-01-07','14:15:00',1.52),('8902','2013-01-07','14:20:00',1.44),('8902','2013-01-07','14:25:00',1.53),('8902','2013-01-07','14:30:00',1.68),('8902','2013-01-07','14:35:00',1.66),('8902','2013-01-07','14:40:00',1.86),('8902','2013-01-07','14:45:00',1.42),('8902','2013-01-07','14:50:00',1.13),('8902','2013-01-07','14:55:00',1.12),('8902','2013-01-07','15:05:00',1.07),('8902','2013-01-07','15:10:00',1.54),('8902','2013-01-07','15:15:00',1.74),('8902','2013-01-07','15:20:00',1.81),('8902','2013-01-07','15:25:00',1.09),('8902','2013-01-07','15:30:00',1.06),('8902','2013-01-07','15:35:00',1.23),('8902','2013-01-07','15:40:00',1.23),('8902','2013-01-07','15:45:00',1.41),('8902','2013-01-06','08:35:00',1.06),('8902','2013-01-06','08:40:00',1.18),('8902','2013-01-06','08:45:00',1.39),('8902','2013-01-06','08:50:00',1.73),('8902','2013-01-06','08:55:00',1.98),('8902','2013-01-06','09:00:00',2.06),('8902','2013-01-06','09:05:00',1.88),('8902','2013-01-06','09:10:00',2.12),('8902','2013-01-06','09:15:00',1.67),('8902','2013-01-06','09:20:00',2.55),('8902','2013-01-06','09:25:00',2.87),('8902','2013-01-06','09:30:00',2.95),('8902','2013-01-06','09:35:00',3.06),('8902','2013-01-06','09:40:00',3.2),('8902','2013-01-06','09:45:00',3.37),('8902','2013-01-06','09:50:00',3.55),('8902','2013-01-06','09:55:00',3.62),('8902','2013-01-06','10:00:00',3.71),('8902','2013-01-06','10:05:00',3.97),('8902','2013-01-06','10:10:00',4.11),('8902','2013-01-06','10:15:00',4.24),('8902','2013-01-06','10:20:00',4.27),('8902','2013-01-06','10:25:00',4.32),('8902','2013-01-06','10:30:00',4.42),('8902','2013-01-06','10:35:00',4.5),('8902','2013-01-06','10:40:00',4.57),('8902','2013-01-06','10:45:00',4.64),('8902','2013-01-06','10:50:00',4.66),('8902','2013-01-06','10:55:00',4.58),('8902','2013-01-06','11:00:00',4.65),('8902','2013-01-06','11:05:00',4.75),('8902','2013-01-06','11:10:00',4.81),('8902','2013-01-06','11:15:00',4.94),('8902','2013-01-06','11:20:00',5.02),('8902','2013-01-06','11:25:00',5.07),('8902','2013-01-06','11:30:00',5.13),('8902','2013-01-06','11:35:00',5.18),('8902','2013-01-06','11:40:00',5.19),('8902','2013-01-06','11:45:00',5.21),('8902','2013-01-06','11:50:00',5.26),('8902','2013-01-06','11:55:00',5.27),('8902','2013-01-06','12:00:00',5.32),('8902','2013-01-06','12:05:00',5.4),('8902','2013-01-06','12:10:00',5.37),('8902','2013-01-06','12:15:00',5.38),('8902','2013-01-06','12:20:00',5.38),('8902','2013-01-06','12:25:00',5.37),('8902','2013-01-06','12:30:00',5.37),('8902','2013-01-06','12:35:00',5.34),('8902','2013-01-06','12:40:00',5.27),('8902','2013-01-06','12:45:00',5.26),('8902','2013-01-06','12:50:00',5.25),('8902','2013-01-06','12:55:00',5.23),('8902','2013-01-06','13:00:00',5.21),('8902','2013-01-06','13:05:00',5.16),('8902','2013-01-06','13:10:00',5.08),('8902','2013-01-06','13:15:00',5.03),('8902','2013-01-06','13:20:00',4.96),('8902','2013-01-06','13:25:00',4.92),('8902','2013-01-06','13:30:00',4.92),('8902','2013-01-06','13:35:00',4.87),('8902','2013-01-06','13:40:00',4.77),('8902','2013-01-06','13:45:00',4.74),('8902','2013-01-06','13:50:00',4.63),('8902','2013-01-06','13:55:00',4.59),('8902','2013-01-06','14:00:00',4.53),('8902','2013-01-06','14:05:00',4.44),('8902','2013-01-06','14:10:00',4.37),('8902','2013-01-06','14:15:00',4.29),('8902','2013-01-06','14:20:00',4.25),('8902','2013-01-06','14:25:00',4.13),('8902','2013-01-06','14:30:00',3.98),('8902','2013-01-06','14:35:00',3.92),('8902','2013-01-06','14:40:00',3.82),('8902','2013-01-06','14:45:00',3.64),('8902','2013-01-06','14:50:00',3.56),('8902','2013-01-06','14:55:00',3.4),('8902','2013-01-06','15:00:00',3.2),('8902','2013-01-06','15:05:00',3.11),('8902','2013-01-06','15:10:00',2.92),('8902','2013-01-06','15:15:00',2.87),('8902','2013-01-06','15:20:00',2.86),('8902','2013-01-06','15:25:00',2.75),('8902','2013-01-06','15:30:00',2.64),('8902','2013-01-06','15:35:00',2.5),('8902','2013-01-06','15:40:00',2.31),('8902','2013-01-06','15:45:00',2.13),('8902','2013-01-06','15:50:00',1.94),('8902','2013-01-06','15:55:00',1.75),('8902','2013-01-06','16:00:00',1.58),('8902','2013-01-06','16:05:00',1.4),('8902','2013-01-06','16:10:00',1.22),('8902','2013-01-06','16:15:00',1.04),('8902','2013-01-05','08:35:00',1.17),('8902','2013-01-05','08:40:00',1.47),('8902','2013-01-05','08:45:00',1.67),('8902','2013-01-05','08:50:00',1.88),('8902','2013-01-05','08:55:00',2.06),('8902','2013-01-05','09:00:00',2.21),('8902','2013-01-05','09:05:00',2.36),('8902','2013-01-05','09:10:00',2.51),('8902','2013-01-05','09:15:00',2.64),('8902','2013-01-05','09:20:00',2.8),('8902','2013-01-05','09:25:00',2.95),('8902','2013-01-05','09:30:00',3.08),('8902','2013-01-05','09:35:00',3.21),('8902','2013-01-05','09:40:00',3.35),('8902','2013-01-05','09:45:00',3.47),('8902','2013-01-05','09:50:00',3.63),('8902','2013-01-05','09:55:00',3.73),('8902','2013-01-05','10:00:00',3.87),('8902','2013-01-05','10:05:00',3.99),('8902','2013-01-05','10:10:00',4.12),('8902','2013-01-05','10:15:00',4.23),('8902','2013-01-05','10:20:00',4.31),('8902','2013-01-05','10:25:00',4.45),('8902','2013-01-05','10:30:00',4.49),('8902','2013-01-05','10:35:00',4.59),('8902','2013-01-05','10:40:00',4.69),('8902','2013-01-05','10:45:00',4.76),('8902','2013-01-05','10:50:00',4.8),('8902','2013-01-05','10:55:00',4.89),('8902','2013-01-05','11:00:00',4.93),('8902','2013-01-05','11:05:00',4.98),('8902','2013-01-05','11:10:00',5.03),('8902','2013-01-05','11:15:00',5.09),('8902','2013-01-05','11:20:00',5.14),('8902','2013-01-05','11:25:00',5.18),('8902','2013-01-05','11:30:00',5.24),('8902','2013-01-05','11:35:00',5.25),('8902','2013-01-05','11:40:00',5.27),('8902','2013-01-05','11:45:00',5.3),('8902','2013-01-05','11:50:00',5.33),('8902','2013-01-05','11:55:00',5.36),('8902','2013-01-05','12:00:00',5.38),('8902','2013-01-05','12:05:00',5.4),('8902','2013-01-05','12:10:00',5.41),('8902','2013-01-05','12:15:00',5.39),('8902','2013-01-05','12:20:00',5.36),('8902','2013-01-05','12:25:00',5.27),('8902','2013-01-05','12:30:00',5.29),('8902','2013-01-05','12:35:00',5.3),('8902','2013-01-05','12:40:00',5.14),('8902','2013-01-05','12:45:00',5.28),('8902','2013-01-05','12:50:00',5.28),('8902','2013-01-05','12:55:00',5.32),('8902','2013-01-05','13:00:00',5.33),('8902','2013-01-05','13:05:00',5.27),('8902','2013-01-05','13:10:00',5.24),('8902','2013-01-05','13:15:00',5.2),('8902','2013-01-05','13:20:00',5.17),('8902','2013-01-05','13:25:00',5.1),('8902','2013-01-05','13:30:00',5.06),('8902','2013-01-05','13:35:00',5.05),('8902','2013-01-05','13:40:00',4.99),('8902','2013-01-05','13:45:00',4.94),('8902','2013-01-05','13:50:00',4.81),('8902','2013-01-05','13:55:00',4.72),('8902','2013-01-05','14:00:00',4.71),('8902','2013-01-05','14:05:00',4.22),('8902','2013-01-05','14:10:00',3.76),('8902','2013-01-05','14:15:00',3.16),('8902','2013-01-05','14:20:00',3.74),('8902','2013-01-05','14:25:00',3.93),('8902','2013-01-05','14:30:00',3.98),('8902','2013-01-05','14:35:00',3.87),('8902','2013-01-05','14:40:00',3.68),('8902','2013-01-05','14:45:00',3.53),('8902','2013-01-05','14:50:00',3.38),('8902','2013-01-05','14:55:00',3.24),('8902','2013-01-05','15:00:00',3.1),('8902','2013-01-05','15:05:00',2.91),('8902','2013-01-05','15:10:00',2.74),('8902','2013-01-05','15:15:00',2.68),('8902','2013-01-05','15:20:00',2.53),('8902','2013-01-05','15:25:00',2.39),('8902','2013-01-05','15:30:00',2.28),('8902','2013-01-05','15:35:00',2.1),('8902','2013-01-05','15:40:00',1.91),('8902','2013-01-05','15:45:00',1.77),('8902','2013-01-05','15:50:00',1.62),('8902','2013-01-05','15:55:00',1.47),('8902','2013-01-05','16:00:00',1.33),('8902','2013-01-05','16:05:00',1.16),('8902','2013-01-05','16:10:00',1.01),('8902','2013-01-04','08:45:00',1.06),('8902','2013-01-04','09:00:00',1),('8902','2013-01-04','09:05:00',1.15),('8902','2013-01-04','09:10:00',1.22),('8902','2013-01-04','09:15:00',1.19),('8902','2013-01-04','09:20:00',1.14),('8902','2013-01-04','09:25:00',1.24),('8902','2013-01-04','09:30:00',1.23),('8902','2013-01-04','09:35:00',1.35),('8902','2013-01-04','09:40:00',1.39),('8902','2013-01-04','09:45:00',1.37),('8902','2013-01-04','09:50:00',1.33),('8902','2013-01-04','09:55:00',1.4),('8902','2013-01-04','10:00:00',1.56),('8902','2013-01-04','10:05:00',1.85),('8902','2013-01-04','10:10:00',2.14),('8902','2013-01-04','10:15:00',2.23),('8902','2013-01-04','10:20:00',2.11),('8902','2013-01-04','10:25:00',1.74),('8902','2013-01-04','10:30:00',1.8),('8902','2013-01-04','10:35:00',2.05),('8902','2013-01-04','10:40:00',2.2),('8902','2013-01-04','10:45:00',2.15),('8902','2013-01-04','10:50:00',2.34),('8902','2013-01-04','10:55:00',3.94),('8902','2013-01-04','11:00:00',3.38),('8902','2013-01-04','11:05:00',3.89),('8902','2013-01-04','11:10:00',3.94),('8902','2013-01-04','11:15:00',3.15),('8902','2013-01-04','11:20:00',3.24),('8902','2013-01-04','11:25:00',3.28),('8902','2013-01-04','11:30:00',3.28),('8902','2013-01-04','11:35:00',3.08),('8902','2013-01-04','11:40:00',2.73),('8902','2013-01-04','11:45:00',2.76),('8902','2013-01-04','11:50:00',2.39),('8902','2013-01-04','11:55:00',2.17),('8902','2013-01-04','12:00:00',2.02),('8902','2013-01-04','12:05:00',1.97),('8902','2013-01-04','12:10:00',1.93),('8902','2013-01-04','12:15:00',1.99),('8902','2013-01-04','12:20:00',1.74),('8902','2013-01-04','12:25:00',1.46),('8902','2013-01-04','12:30:00',1.56),('8902','2013-01-04','12:35:00',2.18),('8902','2013-01-04','12:40:00',2.61),('8902','2013-01-04','12:45:00',3),('8902','2013-01-04','12:50:00',1.9),('8902','2013-01-04','12:55:00',2.15),('8902','2013-01-04','13:00:00',2.51),('8902','2013-01-04','13:05:00',2.27),('8902','2013-01-04','13:10:00',2.22),('8902','2013-01-04','13:15:00',2.07),('8902','2013-01-04','13:20:00',2.1),('8902','2013-01-04','13:25:00',2),('8902','2013-01-04','13:30:00',3.58),('8902','2013-01-04','13:35:00',3.38),('8902','2013-01-04','13:40:00',2.29),('8902','2013-01-04','13:45:00',1.84),('8902','2013-01-04','13:50:00',1.99),('8902','2013-01-04','13:55:00',2.26),('8902','2013-01-04','14:00:00',2.13),('8902','2013-01-04','14:05:00',3.29),('8902','2013-01-04','14:10:00',2.97),('8902','2013-01-04','14:15:00',2.32),('8902','2013-01-04','14:20:00',2.14),('8902','2013-01-04','14:25:00',1.46),('8902','2013-01-04','14:30:00',2.44),('8902','2013-01-04','14:35:00',2.39),('8902','2013-01-04','14:40:00',2.65),('8902','2013-01-04','14:45:00',2.74),('8902','2013-01-04','14:50:00',1.9),('8902','2013-01-04','14:55:00',1.25),('8902','2013-01-04','15:00:00',2.34),('8902','2013-01-04','15:05:00',1.94),('8902','2013-01-04','15:40:00',1.02),('8902','2013-01-03','08:40:00',1.15),('8902','2013-01-03','08:45:00',1.57),('8902','2013-01-03','08:50:00',1.92),('8902','2013-01-03','08:55:00',2),('8902','2013-01-03','09:00:00',2.08),('8902','2013-01-03','09:05:00',2.23),('8902','2013-01-03','09:10:00',2.4),('8902','2013-01-03','09:15:00',1.9),('8902','2013-01-03','09:20:00',2.46),('8902','2013-01-03','09:25:00',2.31),('8902','2013-01-03','09:30:00',2.24),('8902','2013-01-03','09:35:00',2.12),('8902','2013-01-03','09:40:00',2.28),('8902','2013-01-03','09:45:00',2.43),('8902','2013-01-03','09:50:00',2.55),('8902','2013-01-03','09:55:00',3.4),('8902','2013-01-03','10:00:00',4.07),('8902','2013-01-03','10:05:00',4.18),('8902','2013-01-03','10:10:00',3.58),('8902','2013-01-03','10:15:00',4.25),('8902','2013-01-03','10:20:00',3.54),('8902','2013-01-03','10:25:00',4.27),('8902','2013-01-03','10:30:00',4.53),('8902','2013-01-03','10:35:00',4.58),('8902','2013-01-03','10:40:00',4.74),('8902','2013-01-03','10:45:00',4.98),('8902','2013-01-03','10:50:00',5.2),('8902','2013-01-03','10:55:00',5.3),('8902','2013-01-03','11:00:00',4.69),('8902','2013-01-03','11:05:00',2.83),('8902','2013-01-03','11:10:00',1.76),('8902','2013-01-03','11:15:00',1.89),('8902','2013-01-03','11:20:00',2.47),('8902','2013-01-03','11:25:00',1.76),('8902','2013-01-03','11:30:00',1.89),('8902','2013-01-03','11:35:00',2.97),('8902','2013-01-03','11:40:00',2.26),('8902','2013-01-03','11:45:00',3.42),('8902','2013-01-03','11:50:00',5.17),('8902','2013-01-03','11:55:00',5.92),('8902','2013-01-03','12:00:00',6.05),('8902','2013-01-03','12:05:00',5.21),('8902','2013-01-03','12:10:00',4.22),('8902','2013-01-03','12:15:00',2.69),('8902','2013-01-03','12:20:00',2.24),('8902','2013-01-03','12:25:00',2.87),('8902','2013-01-03','12:30:00',3.8),('8902','2013-01-03','12:35:00',3.71),('8902','2013-01-03','12:40:00',5.11),('8902','2013-01-03','12:45:00',5.58),('8902','2013-01-03','12:50:00',5.61),('8902','2013-01-03','12:55:00',5.56),('8902','2013-01-03','13:00:00',5.41),('8902','2013-01-03','13:05:00',5.17),('8902','2013-01-03','13:10:00',5.14),('8902','2013-01-03','13:15:00',4.37),('8902','2013-01-03','13:20:00',5.01),('8902','2013-01-03','13:25:00',4.89),('8902','2013-01-03','13:30:00',4.84),('8902','2013-01-03','13:35:00',4.69),('8902','2013-01-03','13:40:00',4.61),('8902','2013-01-03','13:45:00',4.48),('8902','2013-01-03','13:50:00',4.39),('8902','2013-01-03','13:55:00',4.35),('8902','2013-01-03','14:00:00',4.21),('8902','2013-01-03','14:05:00',4.2),('8902','2013-01-03','14:10:00',4.1),('8902','2013-01-03','14:15:00',4),('8902','2013-01-03','14:20:00',3.91),('8902','2013-01-03','14:25:00',3.81),('8902','2013-01-03','14:30:00',3.73),('8902','2013-01-03','14:35:00',3.63),('8902','2013-01-03','14:40:00',3.57),('8902','2013-01-03','14:45:00',3.42),('8902','2013-01-03','14:50:00',3.16),('8902','2013-01-03','14:55:00',3.08),('8902','2013-01-03','15:00:00',3.01),('8902','2013-01-03','15:05:00',2.74),('8902','2013-01-03','15:10:00',2.47),('8902','2013-01-03','15:15:00',2.5),('8902','2013-01-03','15:20:00',2.37),('8902','2013-01-03','15:25:00',2.27),('8902','2013-01-03','15:30:00',2.1),('8902','2013-01-03','15:35:00',1.95),('8902','2013-01-03','15:40:00',1.83),('8902','2013-01-03','15:45:00',1.73),('8902','2013-01-02','08:35:00',1.08),('8902','2013-01-02','08:40:00',1.39),('8902','2013-01-02','08:45:00',1.6),('8902','2013-01-02','08:50:00',1.77),('8902','2013-01-02','08:55:00',1.93),('8902','2013-01-02','09:00:00',2.14),('8902','2013-01-02','09:05:00',2.32),('8902','2013-01-02','09:10:00',2.49),('8902','2013-01-02','09:15:00',2.65),('8902','2013-01-02','09:20:00',2.82),('8902','2013-01-02','09:25:00',2.97),('8902','2013-01-02','09:30:00',3.11),('8902','2013-01-02','09:35:00',3.26),('8902','2013-01-02','09:40:00',3.51),('8902','2013-01-02','09:45:00',3.79),('8902','2013-01-02','09:50:00',4.11),('8902','2013-01-02','09:55:00',4.41),('8902','2013-01-02','10:00:00',4.65),('8902','2013-01-02','10:05:00',4.59),('8902','2013-01-02','10:10:00',4.56),('8902','2013-01-02','10:15:00',4.98),('8902','2013-01-02','10:20:00',4.09),('8902','2013-01-02','10:25:00',4.49),('8902','2013-01-02','10:30:00',3.81),('8902','2013-01-02','10:35:00',3.64),('8902','2013-01-02','10:40:00',3.52),('8902','2013-01-02','10:45:00',3.13),('8902','2013-01-02','10:50:00',3.26),('8902','2013-01-02','10:55:00',2.94),('8902','2013-01-02','11:00:00',3.23),('8902','2013-01-02','11:05:00',3.1),('8902','2013-01-02','11:10:00',2.94),('8902','2013-01-02','11:15:00',2.76),('8902','2013-01-02','11:20:00',2.59),('8902','2013-01-02','11:25:00',2.55),('8902','2013-01-02','11:30:00',2.42),('8902','2013-01-02','11:35:00',2.98),('8902','2013-01-02','11:40:00',5.77),('8902','2013-01-02','11:45:00',5.66),('8902','2013-01-02','11:50:00',5.56),('8902','2013-01-02','11:55:00',5.48),('8902','2013-01-02','12:00:00',5.44),('8902','2013-01-02','12:05:00',5.43),('8902','2013-01-02','12:10:00',5.43),('8902','2013-01-02','12:15:00',5.43),('8902','2013-01-02','12:20:00',5.44),('8902','2013-01-02','12:25:00',5.43),('8902','2013-01-02','12:30:00',5.42),('8902','2013-01-02','12:35:00',5.44),('8902','2013-01-02','12:40:00',5.41),('8902','2013-01-02','12:45:00',5.39),('8902','2013-01-02','12:50:00',5.34),('8902','2013-01-02','12:55:00',5.3),('8902','2013-01-02','13:00:00',5.29),('8902','2013-01-02','13:05:00',5.24),('8902','2013-01-02','13:10:00',5.2),('8902','2013-01-02','13:15:00',5.13),('8902','2013-01-02','13:20:00',5.11),('8902','2013-01-02','13:25:00',5.06),('8902','2013-01-02','13:30:00',4.98),('8902','2013-01-02','13:35:00',4.96),('8902','2013-01-02','13:40:00',4.89),('8902','2013-01-02','13:45:00',4.8),('8902','2013-01-02','13:50:00',4.72),('8902','2013-01-02','13:55:00',4.67),('8902','2013-01-02','14:00:00',4.6),('8902','2013-01-02','14:05:00',4.51),('8902','2013-01-02','14:10:00',4.45),('8902','2013-01-02','14:15:00',4.37),('8902','2013-01-02','14:20:00',4.27),('8902','2013-01-02','14:25:00',4.18),('8902','2013-01-02','14:30:00',4.07),('8902','2013-01-02','14:35:00',3.96),('8902','2013-01-02','14:40:00',3.85),('8902','2013-01-02','14:45:00',3.72),('8902','2013-01-02','14:50:00',3.59),('8902','2013-01-02','14:55:00',3.46),('8902','2013-01-02','15:00:00',3.31),('8902','2013-01-02','15:05:00',3.11),('8902','2013-01-02','15:10:00',2.93),('8902','2013-01-02','15:15:00',2.73),('8902','2013-01-02','15:20:00',2.44),('8902','2013-01-02','15:25:00',2.41),('8902','2013-01-02','15:30:00',2.34),('8902','2013-01-02','15:35:00',2.18),('8902','2013-01-02','15:40:00',1.95),('8902','2013-01-02','15:45:00',1.87),('8902','2013-01-02','15:50:00',1.69),('8902','2013-01-02','15:55:00',1.52),('8902','2013-01-02','16:00:00',1.3),('8902','2013-01-02','16:05:00',1.15),('8902','2013-01-01','09:40:00',1.14),('8902','2013-01-01','09:45:00',1.26),('8902','2013-01-01','09:50:00',1.13),('8902','2013-01-01','09:55:00',1.08),('8902','2013-01-01','10:00:00',1.23),('8902','2013-01-01','10:05:00',1.19),('8902','2013-01-01','11:10:00',1.05),('8902','2013-01-01','13:40:00',1.53),('8902','2013-01-01','13:45:00',1.71),('8902','2013-01-01','13:50:00',1.74),('8902','2013-01-01','13:55:00',1.41),('8902','2013-01-01','14:00:00',1.24),('8902','2014-03-17','07:40:00',1.01),('8902','2014-03-17','07:45:00',1.14),('8902','2014-03-17','07:50:00',1.6),('8902','2014-03-17','07:55:00',2.43),('8902','2014-03-17','08:00:00',2.04),('8902','2014-03-17','08:05:00',1.73),('8902','2014-03-17','08:10:00',1.54),('8902','2014-03-17','08:15:00',1.69),('8902','2014-03-17','08:20:00',2.06),('8902','2014-03-17','08:25:00',1.84),('8902','2014-03-17','08:30:00',1.66),('8902','2014-03-17','08:35:00',1.5),('8902','2014-03-17','08:40:00',1.5),('8902','2014-03-17','08:45:00',1.61),('8902','2014-03-17','08:50:00',2.56),('8902','2014-03-17','08:55:00',4.35),('8902','2014-03-17','09:00:00',4.62),('8902','2014-03-17','09:05:00',2.54),('8902','2014-03-17','09:10:00',2.67),('8902','2014-03-17','09:15:00',4.43),('8902','2014-03-17','09:20:00',6.03),('8902','2014-03-17','09:25:00',5.85),('8902','2014-03-17','09:30:00',2.72),('8902','2014-03-17','09:35:00',2.48),('8902','2014-03-17','09:40:00',2.76),('8902','2014-03-17','09:45:00',2.79),('8902','2014-03-17','09:50:00',3.58),('8902','2014-03-17','09:55:00',4.01),('8902','2014-03-17','10:00:00',4.61),('8902','2014-03-17','10:05:00',5.62),('8902','2014-03-17','10:10:00',6.81),('8902','2014-03-17','10:15:00',6.48),('8902','2014-03-17','10:20:00',6.18),('8902','2014-03-17','10:25:00',8.1),('8902','2014-03-17','10:30:00',6.5),('8902','2014-03-17','10:35:00',6.46),('8902','2014-03-17','10:40:00',8.24),('8902','2014-03-17','10:45:00',5.75),('8902','2014-03-17','10:50:00',6.95),('8902','2014-03-17','10:55:00',4.14),('8902','2014-03-17','11:00:00',6.74),('8902','2014-03-17','11:05:00',5.85),('8902','2014-03-17','11:10:00',6.06),('8902','2014-03-17','11:15:00',3.27),('8902','2014-03-17','11:20:00',3.21),('8902','2014-03-17','11:25:00',3.3),('8902','2014-03-17','11:30:00',4.18),('8902','2014-03-17','11:35:00',7.45),('8902','2014-03-17','11:40:00',5.77),('8902','2014-03-17','11:45:00',4.62),('8902','2014-03-17','11:50:00',4.18),('8902','2014-03-17','11:55:00',3.51),('8902','2014-03-17','12:00:00',3.33),('8902','2014-03-17','12:05:00',3.08),('8902','2014-03-17','12:10:00',3.41),('8902','2014-03-17','12:15:00',3.64),('8902','2014-03-17','12:20:00',5.28),('8902','2014-03-17','12:25:00',4.85),('8902','2014-03-17','12:30:00',3.12),('8902','2014-03-17','12:35:00',6.51),('8902','2014-03-17','12:40:00',7.36),('8902','2014-03-17','12:45:00',5.16),('8902','2014-03-17','12:50:00',5.31),('8902','2014-03-17','12:55:00',5.78),('8902','2014-03-17','13:00:00',7.64),('8902','2014-03-17','13:05:00',8.07),('8902','2014-03-17','13:10:00',7.79),('8902','2014-03-17','13:15:00',7.69),('8902','2014-03-17','13:20:00',7.61),('8902','2014-03-17','13:25:00',7.38),('8902','2014-03-17','13:30:00',7.02),('8902','2014-03-17','13:35:00',7.17),('8902','2014-03-17','13:40:00',7.24),('8902','2014-03-17','13:45:00',7.26),('8902','2014-03-17','13:50:00',7.11),('8902','2014-03-17','13:55:00',7.07),('8902','2014-03-17','14:00:00',7.03),('8902','2014-03-17','14:05:00',6.9),('8902','2014-03-17','14:10:00',6.94),('8902','2014-03-17','14:15:00',6.85),('8902','2014-03-17','14:20:00',6.78),('8902','2014-03-17','14:25:00',6.71),('8902','2014-03-17','14:30:00',6.63),('8902','2014-03-17','14:35:00',6.53),('8902','2014-03-17','14:40:00',6.4),('8902','2014-03-17','14:45:00',6.27),('8902','2014-03-17','14:50:00',6.22),('8902','2014-03-17','14:55:00',6.14),('8902','2014-03-17','15:00:00',5.98),('8902','2014-03-17','15:05:00',5.78),('8902','2014-03-17','15:10:00',5.68),('8902','2014-03-17','15:15:00',5.58),('8902','2014-03-17','15:20:00',5.49),('8902','2014-03-17','15:25:00',5.3),('8902','2014-03-17','15:30:00',5.11),('8902','2014-03-17','15:35:00',4.99),('8902','2014-03-17','15:40:00',4.83),('8902','2014-03-17','15:45:00',4.62),('8902','2014-03-17','15:50:00',4.41),('8902','2014-03-17','15:55:00',4.24),('8902','2014-03-17','16:00:00',4.16),('8902','2014-03-17','16:05:00',3.99),('8902','2014-03-17','16:10:00',3.83),('8902','2014-03-17','16:15:00',3.67),('8902','2014-03-17','16:20:00',3.48),('8902','2014-03-17','16:25:00',3.26),('8902','2014-03-17','16:30:00',3.1),('8902','2014-03-17','16:35:00',2.88),('8902','2014-03-17','16:40:00',2.67),('8902','2014-03-17','16:45:00',2.47),('8902','2014-03-17','16:50:00',2.26),('8902','2014-03-17','16:55:00',2.02),('8902','2014-03-17','17:00:00',1.87),('8902','2014-03-17','17:05:00',1.71),('8902','2014-03-17','17:10:00',1.5),('8902','2014-03-17','17:15:00',1.28),('8902','2014-03-17','17:20:00',1.09),('8902','2012-12-31','08:35:00',1.1),('8902','2012-12-31','08:40:00',1.23),('8902','2012-12-31','08:45:00',1.51),('8902','2012-12-31','08:50:00',1.77),('8902','2012-12-31','08:55:00',1.93),('8902','2012-12-31','09:00:00',2.1),('8902','2012-12-31','09:05:00',2.27),('8902','2012-12-31','09:10:00',2.41),('8902','2012-12-31','09:15:00',2.55),('8902','2012-12-31','09:20:00',2.72),('8902','2012-12-31','09:25:00',2.84),('8902','2012-12-31','09:30:00',2.94),('8902','2012-12-31','09:35:00',3.06),('8902','2012-12-31','09:40:00',3.19),('8902','2012-12-31','09:45:00',3.34),('8902','2012-12-31','09:50:00',3.46),('8902','2012-12-31','09:55:00',3.55),('8902','2012-12-31','10:00:00',3.63),('8902','2012-12-31','10:05:00',3.75),('8902','2012-12-31','10:10:00',3.86),('8902','2012-12-31','10:15:00',3.95),('8902','2012-12-31','10:20:00',4.05),('8902','2012-12-31','10:25:00',4.15),('8902','2012-12-31','10:30:00',4.29),('8902','2012-12-31','10:35:00',4.36),('8902','2012-12-31','10:40:00',4.5),('8902','2012-12-31','10:45:00',4.37),('8902','2012-12-31','10:50:00',4.53),('8902','2012-12-31','10:55:00',3.31),('8902','2012-12-31','11:00:00',1.53),('8902','2012-12-31','11:05:00',4.45),('8902','2012-12-31','11:10:00',5.21),('8902','2012-12-31','11:15:00',4.81),('8902','2012-12-31','11:20:00',3.47),('8902','2012-12-31','11:25:00',4.75),('8902','2012-12-31','11:30:00',5.18),('8902','2012-12-31','11:35:00',2.79),('8902','2012-12-31','11:40:00',3.69),('8902','2012-12-31','11:45:00',4.86),('8902','2012-12-31','11:50:00',4.83),('8902','2012-12-31','11:55:00',3.89),('8902','2012-12-31','12:00:00',3.14),('8902','2012-12-31','12:05:00',2.28),('8902','2012-12-31','12:10:00',2.45),('8902','2012-12-31','12:15:00',2.67),('8902','2012-12-31','12:20:00',2.37),('8902','2012-12-31','12:25:00',2.28),('8902','2012-12-31','12:30:00',1.98),('8902','2012-12-31','12:35:00',2.01),('8902','2012-12-31','12:40:00',2.22),('8902','2012-12-31','12:45:00',2.49),('8902','2012-12-31','12:50:00',2.17),('8902','2012-12-31','12:55:00',2.3),('8902','2012-12-31','13:00:00',1.8),('8902','2012-12-31','13:05:00',1.91),('8902','2012-12-31','13:10:00',1.5),('8902','2012-12-31','13:15:00',1.39),('8902','2012-12-31','13:20:00',1.56),('8902','2012-12-31','13:25:00',1.37),('8902','2012-12-31','13:30:00',1.17),('8902','2012-12-30','08:25:00',1.03),('8902','2012-12-30','08:30:00',1.18),('8902','2012-12-30','08:35:00',1.3),('8902','2012-12-30','08:45:00',1.16),('8902','2012-12-30','08:50:00',1.21),('8902','2012-12-30','08:55:00',1.32),('8902','2012-12-30','09:00:00',1.51),('8902','2012-12-30','09:05:00',1.97),('8902','2012-12-30','09:10:00',1.91),('8902','2012-12-30','09:15:00',2.43),('8902','2012-12-30','09:20:00',2.9),('8902','2012-12-30','09:25:00',3.21),('8902','2012-12-30','09:30:00',3.18),('8902','2012-12-30','09:35:00',1.11),('8902','2012-12-30','09:40:00',1.2),('8902','2012-12-30','09:55:00',1.25),('8902','2012-12-30','10:00:00',2.42),('8902','2012-12-30','10:05:00',1.64),('8902','2012-12-30','10:10:00',3.13),('8902','2012-12-30','10:15:00',4.27),('8902','2012-12-30','10:20:00',4.62),('8902','2012-12-30','10:25:00',4.63),('8902','2012-12-30','10:30:00',4.69),('8902','2012-12-30','10:35:00',4.77),('8902','2012-12-30','10:40:00',4.85),('8902','2012-12-30','10:45:00',4.82),('8902','2012-12-30','10:50:00',4.8),('8902','2012-12-30','10:55:00',4.93),('8902','2012-12-30','11:00:00',4.98),('8902','2012-12-30','11:05:00',4.99),('8902','2012-12-30','11:10:00',4.85),('8902','2012-12-30','11:15:00',4.93),('8902','2012-12-30','11:20:00',5.15),('8902','2012-12-30','11:25:00',5.21),('8902','2012-12-30','11:30:00',5.31),('8902','2012-12-30','11:35:00',5.37),('8902','2012-12-30','11:40:00',5.41),('8902','2012-12-30','11:45:00',5.41),('8902','2012-12-30','11:50:00',5.43),('8902','2012-12-30','11:55:00',5.49),('8902','2012-12-30','12:00:00',5.55),('8902','2012-12-30','12:05:00',5.6),('8902','2012-12-30','12:10:00',5.61),('8902','2012-12-30','12:15:00',5.62),('8902','2012-12-30','12:20:00',5.63),('8902','2012-12-30','12:25:00',5.61),('8902','2012-12-30','12:30:00',5.57),('8902','2012-12-30','12:35:00',5.57),('8902','2012-12-30','12:40:00',5.54),('8902','2012-12-30','12:45:00',5.52),('8902','2012-12-30','12:50:00',5.49),('8902','2012-12-30','12:55:00',5.48),('8902','2012-12-30','13:00:00',5.44),('8902','2012-12-30','13:05:00',5.41),('8902','2012-12-30','13:10:00',5.37),('8902','2012-12-30','13:15:00',5.29),('8902','2012-12-30','13:20:00',5.25),('8902','2012-12-30','13:25:00',5.21),('8902','2012-12-30','13:30:00',5.15),('8902','2012-12-30','13:35:00',5.04),('8902','2012-12-30','13:40:00',4.98),('8902','2012-12-30','13:45:00',4.94),('8902','2012-12-30','13:50:00',4.83),('8902','2012-12-30','13:55:00',4.74),('8902','2012-12-30','14:00:00',4.59),('8902','2012-12-30','14:05:00',4.5),('8902','2012-12-30','14:10:00',4.46),('8902','2012-12-30','14:15:00',4.39),('8902','2012-12-30','14:20:00',4.26),('8902','2012-12-30','14:25:00',4.13),('8902','2012-12-30','14:30:00',4.02),('8902','2012-12-30','14:35:00',3.95),('8902','2012-12-30','14:40:00',3.83),('8902','2012-12-30','14:45:00',3.7),('8902','2012-12-30','14:50:00',3.56),('8902','2012-12-30','14:55:00',3.4),('8902','2012-12-30','15:00:00',3.26),('8902','2012-12-30','15:05:00',3.12),('8902','2012-12-30','15:10:00',2.87),('8902','2012-12-30','15:15:00',2.72),('8902','2012-12-30','15:20:00',2.61),('8902','2012-12-30','15:25:00',2.48),('8902','2012-12-30','15:30:00',2.33),('8902','2012-12-30','15:35:00',2.17),('8902','2012-12-30','15:40:00',2.03),('8902','2012-12-30','15:45:00',1.84),('8902','2012-12-30','15:50:00',1.62),('8902','2012-12-30','15:55:00',1.4),('8902','2012-12-30','16:00:00',1.22),('8902','2012-12-30','16:05:00',1.05),('8902','2012-12-29','08:30:00',1.06),('8902','2012-12-29','08:35:00',1.21),('8902','2012-12-29','08:40:00',1.56),('8902','2012-12-29','08:45:00',1.77),('8902','2012-12-29','08:50:00',1.92),('8902','2012-12-29','08:55:00',2.07),('8902','2012-12-29','09:00:00',2.23),('8902','2012-12-29','09:05:00',2.4),('8902','2012-12-29','09:10:00',2.56),('8902','2012-12-29','09:15:00',2.7),('8902','2012-12-29','09:20:00',2.83),('8902','2012-12-29','09:25:00',2.95),('8902','2012-12-29','09:30:00',3.1),('8902','2012-12-29','09:35:00',3.25),('8902','2012-12-29','09:40:00',3.4),('8902','2012-12-29','09:45:00',3.5),('8902','2012-12-29','09:50:00',3.61),('8902','2012-12-29','09:55:00',3.75),('8902','2012-12-29','10:00:00',3.89),('8902','2012-12-29','10:05:00',4.03),('8902','2012-12-29','10:10:00',4.16),('8902','2012-12-29','10:15:00',4.24),('8902','2012-12-29','10:20:00',4.33),('8902','2012-12-29','10:25:00',4.44),('8902','2012-12-29','10:30:00',4.53),('8902','2012-12-29','10:35:00',4.63),('8902','2012-12-29','10:40:00',4.69),('8902','2012-12-29','10:45:00',4.8),('8902','2012-12-29','10:50:00',4.87),('8902','2012-12-29','10:55:00',4.92),('8902','2012-12-29','11:00:00',4.98),('8902','2012-12-29','11:05:00',5.04),('8902','2012-12-29','11:10:00',5.08),('8902','2012-12-29','11:15:00',5.15),('8902','2012-12-29','11:20:00',5.16),('8902','2012-12-29','11:25:00',5.21),('8902','2012-12-29','11:30:00',5.29),('8902','2012-12-29','11:35:00',5.31),('8902','2012-12-29','11:40:00',5.34),('8902','2012-12-29','11:45:00',5.37),('8902','2012-12-29','11:50:00',5.39),('8902','2012-12-29','11:55:00',5.4),('8902','2012-12-29','12:00:00',5.43),('8902','2012-12-29','12:05:00',5.42),('8902','2012-12-29','12:10:00',5.42),('8902','2012-12-29','12:15:00',5.44),('8902','2012-12-29','12:20:00',5.42),('8902','2012-12-29','12:25:00',5.41),('8902','2012-12-29','12:30:00',5.43),('8902','2012-12-29','12:35:00',5.39),('8902','2012-12-29','12:40:00',5.33),('8902','2012-12-29','12:45:00',5.3),('8902','2012-12-29','12:50:00',5.23),('8902','2012-12-29','12:55:00',5.22),('8902','2012-12-29','13:00:00',5.29),('8902','2012-12-29','13:05:00',5.32),('8902','2012-12-29','13:10:00',5.27),('8902','2012-12-29','13:15:00',5.26),('8902','2012-12-29','13:20:00',5.2),('8902','2012-12-29','13:25:00',5.13),('8902','2012-12-29','13:30:00',5.1),('8902','2012-12-29','13:35:00',5.05),('8902','2012-12-29','13:40:00',5.01),('8902','2012-12-29','13:45:00',4.93),('8902','2012-12-29','13:50:00',4.87),('8902','2012-12-29','13:55:00',4.78),('8902','2012-12-29','14:00:00',4.72),('8902','2012-12-29','14:05:00',4.65),('8902','2012-12-29','14:10:00',4.52),('8902','2012-12-29','14:15:00',4.44),('8902','2012-12-29','14:20:00',4.34),('8902','2012-12-29','14:25:00',4.22),('8902','2012-12-29','14:30:00',4.1),('8902','2012-12-29','14:35:00',3.97),('8902','2012-12-29','14:40:00',3.86),('8902','2012-12-29','14:45:00',3.72),('8902','2012-12-29','14:50:00',3.58),('8902','2012-12-29','14:55:00',3.44),('8902','2012-12-29','15:00:00',3.28),('8902','2012-12-29','15:05:00',3.1),('8902','2012-12-29','15:10:00',2.91),('8902','2012-12-29','15:15:00',2.77),('8902','2012-12-29','15:20:00',2.61),('8902','2012-12-29','15:25:00',2.47),('8902','2012-12-29','15:30:00',2.32),('8902','2012-12-29','15:35:00',2.16),('8902','2012-12-29','15:40:00',1.96),('8902','2012-12-29','15:45:00',1.5),('8902','2012-12-29','15:50:00',1.6),('8902','2012-12-29','15:55:00',1.45),('8902','2012-12-29','16:00:00',1.29),('8902','2012-12-29','16:05:00',1.11),('8902','2012-12-28','08:30:00',1.02),('8902','2012-12-28','08:35:00',1.22),('8902','2012-12-28','08:40:00',1.57),('8902','2012-12-28','08:45:00',1.78),('8902','2012-12-28','08:50:00',1.95),('8902','2012-12-28','08:55:00',2.1),('8902','2012-12-28','09:00:00',2.21),('8902','2012-12-28','09:05:00',2.37),('8902','2012-12-28','09:10:00',2.55),('8902','2012-12-28','09:15:00',2.7),('8902','2012-12-28','09:20:00',2.88),('8902','2012-12-28','09:25:00',3),('8902','2012-12-28','09:30:00',3.13),('8902','2012-12-28','09:35:00',3.27),('8902','2012-12-28','09:40:00',3.42),('8902','2012-12-28','09:45:00',3.58),('8902','2012-12-28','09:50:00',3.74),('8902','2012-12-28','09:55:00',3.86),('8902','2012-12-28','10:00:00',3.98),('8902','2012-12-28','10:05:00',4.12),('8902','2012-12-28','10:10:00',4.23),('8902','2012-12-28','10:15:00',4.34),('8902','2012-12-28','10:20:00',4.43),('8902','2012-12-28','10:25:00',4.54),('8902','2012-12-28','10:30:00',4.63),('8902','2012-12-28','10:35:00',4.71),('8902','2012-12-28','10:40:00',4.81),('8902','2012-12-28','10:45:00',4.89),('8902','2012-12-28','10:50:00',5),('8902','2012-12-28','10:55:00',5.08),('8902','2012-12-28','11:00:00',5.11),('8902','2012-12-28','11:05:00',5.18),('8902','2012-12-28','11:10:00',5.22),('8902','2012-12-28','11:15:00',5.28),('8902','2012-12-28','11:20:00',5.36),('8902','2012-12-28','11:25:00',5.39),('8902','2012-12-28','11:30:00',5.42),('8902','2012-12-28','11:35:00',5.44),('8902','2012-12-28','11:40:00',5.45),('8902','2012-12-28','11:45:00',5.49),('8902','2012-12-28','11:50:00',5.54),('8902','2012-12-28','11:55:00',5.56),('8902','2012-12-28','12:00:00',5.56),('8902','2012-12-28','12:05:00',5.61),('8902','2012-12-28','12:10:00',5.65),('8902','2012-12-28','12:15:00',5.63),('8902','2012-12-28','12:20:00',5.58),('8902','2012-12-28','12:25:00',5.58),('8902','2012-12-28','12:30:00',5.59),('8902','2012-12-28','12:35:00',5.6),('8902','2012-12-28','12:40:00',5.58),('8902','2012-12-28','12:45:00',5.47),('8902','2012-12-28','12:50:00',5.42),('8902','2012-12-28','12:55:00',5.45),('8902','2012-12-28','13:00:00',5.44),('8902','2012-12-28','13:05:00',5.44),('8902','2012-12-28','13:10:00',5.41),('8902','2012-12-28','13:15:00',5.4),('8902','2012-12-28','13:20:00',5.35),('8902','2012-12-28','13:25:00',5.27),('8902','2012-12-28','13:30:00',5.2),('8902','2012-12-28','13:35:00',5.16),('8902','2012-12-28','13:40:00',5.1),('8902','2012-12-28','13:45:00',5.04),('8902','2012-12-28','13:50:00',4.97),('8902','2012-12-28','13:55:00',4.9),('8902','2012-12-28','14:00:00',4.83),('8902','2012-12-28','14:05:00',4.7),('8902','2012-12-28','14:10:00',4.62),('8902','2012-12-28','14:15:00',4.54),('8902','2012-12-28','14:20:00',4.44),('8902','2012-12-28','14:25:00',4.32),('8902','2012-12-28','14:30:00',4.2),('8902','2012-12-28','14:35:00',4.07),('8902','2012-12-28','14:40:00',3.95),('8902','2012-12-28','14:45:00',3.84),('8902','2012-12-28','14:50:00',3.72),('8902','2012-12-28','14:55:00',3.59),('8902','2012-12-28','15:00:00',3.45),('8902','2012-12-28','15:05:00',3.29),('8902','2012-12-28','15:10:00',3.08),('8902','2012-12-28','15:15:00',2.95),('8902','2012-12-28','15:20:00',2.78),('8902','2012-12-28','15:25:00',2.62),('8902','2012-12-28','15:30:00',2.45),('8902','2012-12-28','15:35:00',2.26),('8902','2012-12-28','15:40:00',2.07),('8902','2012-12-28','15:45:00',1.85),('8902','2012-12-28','15:50:00',1.7),('8902','2012-12-28','15:55:00',1.51),('8902','2012-12-28','16:00:00',1.34),('8902','2012-12-28','16:05:00',1.16),('8902','2012-12-27','08:40:00',1.22),('8902','2012-12-27','08:45:00',1.5),('8902','2012-12-27','08:50:00',1.68),('8902','2012-12-27','08:55:00',1.86),('8902','2012-12-27','09:00:00',2.05),('8902','2012-12-27','09:05:00',2.23),('8902','2012-12-27','09:10:00',2.38),('8902','2012-12-27','09:15:00',2.55),('8902','2012-12-27','09:20:00',2.65),('8902','2012-12-27','09:25:00',2.74),('8902','2012-12-27','09:30:00',2.88),('8902','2012-12-27','09:35:00',3.02),('8902','2012-12-27','09:40:00',3.13),('8902','2012-12-27','09:45:00',3.26),('8902','2012-12-27','09:50:00',3.29),('8902','2012-12-27','09:55:00',3.49),('8902','2012-12-27','10:00:00',3.57),('8902','2012-12-27','10:05:00',3.73),('8902','2012-12-27','10:10:00',3.89),('8902','2012-12-27','10:15:00',4.05),('8902','2012-12-27','10:20:00',4.14),('8902','2012-12-27','10:25:00',4.25),('8902','2012-12-27','10:30:00',4.33),('8902','2012-12-27','10:35:00',4.49),('8902','2012-12-27','10:40:00',4.51),('8902','2012-12-27','10:45:00',4.6),('8902','2012-12-27','10:50:00',4.66),('8902','2012-12-27','10:55:00',4.71),('8902','2012-12-27','11:00:00',4.67),('8902','2012-12-27','11:05:00',4.91),('8902','2012-12-27','11:10:00',5.02),('8902','2012-12-27','11:15:00',4.94),('8902','2012-12-27','11:20:00',5.1),('8902','2012-12-27','11:25:00',5.11),('8902','2012-12-27','11:30:00',5.17),('8902','2012-12-27','11:35:00',5.27),('8902','2012-12-27','11:40:00',5.3),('8902','2012-12-27','11:45:00',5.3),('8902','2012-12-27','11:50:00',5.37),('8902','2012-12-27','11:55:00',4.88),('8902','2012-12-27','12:00:00',4.76),('8902','2012-12-27','12:05:00',4.31),('8902','2012-12-27','12:10:00',4.99),('8902','2012-12-27','12:15:00',5.41),('8902','2012-12-27','12:20:00',5.35),('8902','2012-12-27','12:25:00',5.27),('8902','2012-12-27','12:30:00',5.16),('8902','2012-12-27','12:35:00',5.23),('8902','2012-12-27','12:40:00',4.91),('8902','2012-12-27','12:45:00',3.92),('8902','2012-12-27','12:50:00',5.33),('8902','2012-12-27','12:55:00',5.22),('8902','2012-12-27','13:00:00',5.15),('8902','2012-12-27','13:05:00',5.08),('8902','2012-12-27','13:10:00',5),('8902','2012-12-27','13:15:00',4.91),('8902','2012-12-27','13:20:00',4.95),('8902','2012-12-27','13:25:00',4.9),('8902','2012-12-27','13:30:00',4.83),('8902','2012-12-27','13:35:00',4.72),('8902','2012-12-27','13:40:00',4.66),('8902','2012-12-27','13:45:00',4.63),('8902','2012-12-27','13:50:00',4.58),('8902','2012-12-27','13:55:00',4.47),('8902','2012-12-27','14:00:00',4.38),('8902','2012-12-27','14:05:00',4.22),('8902','2012-12-27','14:10:00',3.98),('8902','2012-12-27','14:15:00',3.53),('8902','2012-12-27','14:20:00',3.75),('8902','2012-12-27','14:25:00',3.86),('8902','2012-12-27','14:30:00',3.7),('8902','2012-12-27','14:35:00',3.48),('8902','2012-12-27','14:40:00',1.83),('8902','2012-12-27','14:45:00',2.68),('8902','2012-12-27','14:50:00',3.21),('8902','2012-12-27','14:55:00',3.08),('8902','2012-12-27','15:00:00',2.96),('8902','2012-12-27','15:05:00',2.83),('8902','2012-12-27','15:10:00',2.64),('8902','2012-12-27','15:15:00',2.5),('8902','2012-12-27','15:20:00',2.34),('8902','2012-12-27','15:25:00',2.18),('8902','2012-12-27','15:30:00',2.06),('8902','2012-12-27','15:35:00',1.88),('8902','2012-12-27','15:40:00',1.7),('8902','2012-12-27','15:45:00',1.51),('8902','2012-12-27','15:50:00',1.31),('8902','2012-12-27','15:55:00',1.16),('8902','2012-12-27','16:00:00',1.04),('8902','2012-12-26','09:15:00',1.03),('8902','2012-12-26','09:20:00',1.51),('8902','2012-12-26','09:25:00',1.62),('8902','2012-12-26','09:30:00',2.23),('8902','2012-12-26','09:35:00',2.79),('8902','2012-12-26','09:40:00',3.14),('8902','2012-12-26','09:45:00',3.3),('8902','2012-12-26','09:50:00',3.45),('8902','2012-12-26','09:55:00',3.48),('8902','2012-12-26','10:00:00',2.93),('8902','2012-12-26','10:05:00',2.25),('8902','2012-12-26','10:10:00',2.92),('8902','2012-12-26','10:15:00',3.57),('8902','2012-12-26','10:20:00',3.96),('8902','2012-12-26','10:25:00',3.91),('8902','2012-12-26','10:30:00',3.94),('8902','2012-12-26','10:35:00',4.02),('8902','2012-12-26','10:40:00',4.14),('8902','2012-12-26','10:45:00',4.43),('8902','2012-12-26','10:50:00',4.15),('8902','2012-12-26','10:55:00',4.31),('8902','2012-12-26','11:00:00',4.48),('8902','2012-12-26','11:05:00',4.72),('8902','2012-12-26','11:10:00',4.95),('8902','2012-12-26','11:15:00',4.45),('8902','2012-12-26','11:20:00',1.43),('8902','2012-12-26','11:25:00',2.55),('8902','2012-12-26','11:50:00',1.02),('8902','2012-12-26','11:55:00',5.03),('8902','2012-12-26','12:00:00',5.17),('8902','2012-12-26','12:05:00',5.2),('8902','2012-12-26','12:10:00',5.52),('8902','2012-12-26','12:15:00',5.45),('8902','2012-12-26','12:20:00',2.77),('8902','2012-12-26','12:25:00',5.09),('8902','2012-12-26','12:30:00',4.92),('8902','2012-12-26','12:35:00',5.28),('8902','2012-12-26','12:40:00',5.13),('8902','2012-12-26','12:45:00',5.63),('8902','2012-12-26','12:50:00',5.53),('8902','2012-12-26','12:55:00',5.32),('8902','2012-12-26','13:00:00',5.25),('8902','2012-12-26','13:05:00',5.36),('8902','2012-12-26','13:10:00',4.78),('8902','2012-12-26','13:15:00',5.21),('8902','2012-12-26','13:20:00',4.91),('8902','2012-12-26','13:25:00',5.05),('8902','2012-12-26','13:30:00',4.98),('8902','2012-12-26','13:35:00',2.29),('8902','2012-12-26','13:40:00',1.1),('8902','2012-12-26','13:45:00',1.62),('8902','2012-12-26','14:00:00',1.84),('8902','2012-12-26','14:05:00',3.48),('8902','2012-12-26','14:10:00',3.94),('8902','2012-12-26','14:15:00',4.29),('8902','2012-12-26','14:20:00',4.02),('8902','2012-12-26','14:25:00',3.83),('8902','2012-12-26','14:30:00',3.79),('8902','2012-12-26','14:35:00',3.71),('8902','2012-12-26','14:40:00',3.55),('8902','2012-12-26','14:45:00',3.33),('8902','2012-12-26','14:50:00',1.55),('8902','2012-12-26','14:55:00',1.95),('8902','2012-12-26','15:00:00',3.17),('8902','2012-12-26','15:05:00',2.94),('8902','2012-12-26','15:10:00',1.37),('8902','2012-12-26','15:30:00',1.65),('8902','2012-12-26','15:35:00',1.36),('8902','2012-12-26','15:40:00',1.77),('8902','2012-12-26','15:45:00',1.59),('8902','2012-12-26','15:50:00',1.18),('8902','2012-12-26','15:55:00',1.09),('8902','2012-12-25','09:10:00',1.28),('8902','2012-12-25','09:15:00',2.05),('8902','2012-12-25','09:20:00',2.81),('8902','2012-12-25','09:25:00',2.9),('8902','2012-12-25','09:30:00',2.98),('8902','2012-12-25','09:35:00',3.05),('8902','2012-12-25','09:40:00',3.2),('8902','2012-12-25','09:45:00',3.31),('8902','2012-12-25','09:50:00',3.43),('8902','2012-12-25','09:55:00',3.56),('8902','2012-12-25','10:00:00',3.67),('8902','2012-12-25','10:05:00',3.76),('8902','2012-12-25','10:10:00',3.86),('8902','2012-12-25','10:15:00',3.97),('8902','2012-12-25','10:20:00',4.03),('8902','2012-12-25','10:25:00',4.09),('8902','2012-12-25','10:30:00',4.2),('8902','2012-12-25','10:35:00',4.29),('8902','2012-12-25','10:40:00',4.38),('8902','2012-12-25','10:45:00',4.4),('8902','2012-12-25','10:50:00',4.46),('8902','2012-12-25','10:55:00',4.52),('8902','2012-12-25','11:00:00',4.58),('8902','2012-12-25','11:05:00',4.63),('8902','2012-12-25','11:10:00',4.67),('8902','2012-12-25','11:15:00',4.73),('8902','2012-12-25','11:20:00',4.75),('8902','2012-12-25','11:25:00',4.79),('8902','2012-12-25','11:30:00',4.8),('8902','2012-12-25','11:35:00',4.83),('8902','2012-12-25','11:40:00',4.91),('8902','2012-12-25','11:45:00',4.94),('8902','2012-12-25','11:50:00',5.04),('8902','2012-12-25','11:55:00',5.13),('8902','2012-12-25','12:00:00',5.21),('8902','2012-12-25','12:05:00',5.24),('8902','2012-12-25','12:10:00',5.25),('8902','2012-12-25','12:15:00',5.29),('8902','2012-12-25','12:20:00',5.33),('8902','2012-12-25','12:25:00',5.34),('8902','2012-12-25','12:30:00',5.32),('8902','2012-12-25','12:35:00',5.35),('8902','2012-12-25','12:40:00',4.91),('8902','2012-12-25','12:45:00',5.32),('8902','2012-12-25','12:50:00',5),('8902','2012-12-25','12:55:00',5.22),('8902','2012-12-25','13:00:00',5.3),('8902','2012-12-25','13:05:00',5.23),('8902','2012-12-25','13:10:00',5.24),('8902','2012-12-25','13:15:00',5.25),('8902','2012-12-25','13:20:00',5.28),('8902','2012-12-25','13:25:00',5.4),('8902','2012-12-25','13:30:00',5.62),('8902','2012-12-25','13:35:00',5.6),('8902','2012-12-25','13:40:00',5.5),('8902','2012-12-25','13:45:00',5.55),('8902','2012-12-25','13:50:00',4.84),('8902','2012-12-25','13:55:00',5.32),('8902','2012-12-25','14:00:00',5.19),('8902','2012-12-25','14:05:00',4.49),('8902','2012-12-25','14:10:00',1.31),('8902','2012-12-25','14:15:00',1.54),('8902','2012-12-24','10:05:00',1.12),('8902','2012-12-24','10:10:00',1.26),('8902','2012-12-24','10:15:00',1.33),('8902','2012-12-24','10:20:00',1.38),('8902','2012-12-24','10:25:00',1.47),('8902','2012-12-24','10:30:00',1.41),('8902','2012-12-24','10:35:00',1.38),('8902','2012-12-24','10:40:00',1.35),('8902','2012-12-24','10:45:00',1.33),('8902','2012-12-24','10:50:00',1.31),('8902','2012-12-24','10:55:00',1.37),('8902','2012-12-24','11:00:00',1.37),('8902','2012-12-24','11:05:00',1.44),('8902','2012-12-24','11:10:00',1.46),('8902','2012-12-24','11:15:00',1.48),('8902','2012-12-24','11:20:00',1.59),('8902','2012-12-24','11:25:00',1.72),('8902','2012-12-24','11:30:00',1.64),('8902','2012-12-24','11:35:00',1.57),('8902','2012-12-24','11:40:00',1.44),('8902','2012-12-24','11:45:00',1.48),('8902','2012-12-24','11:50:00',1.61),('8902','2012-12-24','11:55:00',1.76),('8902','2012-12-24','12:00:00',1.72),('8902','2012-12-24','12:05:00',1.61),('8902','2012-12-24','12:10:00',1.57),('8902','2012-12-24','12:15:00',1.54),('8902','2012-12-24','12:20:00',1.52),('8902','2012-12-24','12:25:00',1.65),('8902','2012-12-24','12:30:00',1.44),('8902','2012-12-24','12:35:00',1.39),('8902','2012-12-24','12:40:00',1.35),('8902','2012-12-24','12:45:00',1.33),('8902','2012-12-24','12:50:00',1.38),('8902','2012-12-24','12:55:00',1.53),('8902','2012-12-24','13:00:00',1.46),('8902','2012-12-24','13:05:00',1.59),('8902','2012-12-24','13:10:00',1.58),('8902','2012-12-24','13:15:00',1.62),('8902','2012-12-24','13:20:00',1.62),('8902','2012-12-24','13:25:00',1.42),('8902','2012-12-24','13:30:00',1.26),('8902','2012-12-24','13:35:00',1.11),('8902','2012-12-24','13:40:00',1.19),('8902','2012-12-24','13:45:00',1.06),('8902','2012-12-24','13:50:00',1),('8902','2012-12-24','14:35:00',1.14),('8902','2012-12-24','14:40:00',2.1),('8902','2012-12-24','14:45:00',2.46),('8902','2012-12-24','14:50:00',2.25),('8902','2012-12-24','14:55:00',2.21),('8902','2012-12-24','15:00:00',2.17),('8902','2012-12-24','15:05:00',1.53),('8902','2012-12-24','15:10:00',1.77),('8902','2012-12-24','15:15:00',1.72),('8902','2012-12-24','15:20:00',1.51),('8902','2012-12-24','15:25:00',1.32),('8902','2012-12-24','15:30:00',1.09),('8902','2012-12-24','15:35:00',1.12),('8902','2012-12-24','15:40:00',1.15),('8902','2012-12-23','11:20:00',1.08),('8902','2012-12-23','11:30:00',1.14),('8902','2012-12-23','11:35:00',1.2),('8902','2012-12-23','11:40:00',1.18),('8902','2012-12-23','11:45:00',1.14),('8902','2012-12-23','11:50:00',1.09),('8902','2012-12-23','11:55:00',1.08),('8902','2012-12-23','12:00:00',1.19),('8902','2012-12-23','12:05:00',1.36),('8902','2012-12-23','12:10:00',1.51),('8902','2012-12-23','12:15:00',1.45),('8902','2012-12-23','12:20:00',1.38),('8902','2012-12-23','12:25:00',1.39),('8902','2012-12-23','12:30:00',1.36),('8902','2012-12-23','12:35:00',1.34),('8902','2012-12-23','12:40:00',1.35),('8902','2012-12-23','12:45:00',1.26),('8902','2012-12-23','12:50:00',1.16),('8902','2012-12-23','12:55:00',1.13),('8902','2012-12-23','13:00:00',1.11),('8902','2012-12-23','13:05:00',1.01),('8902','2012-12-22','08:30:00',1.06),('8902','2012-12-22','08:35:00',1.38),('8902','2012-12-22','08:40:00',1.59),('8902','2012-12-22','08:45:00',1.79),('8902','2012-12-22','08:50:00',1.98),('8902','2012-12-22','08:55:00',2.16),('8902','2012-12-22','09:00:00',2.31),('8902','2012-12-22','09:05:00',2.49),('8902','2012-12-22','09:10:00',2.66),('8902','2012-12-22','09:15:00',2.72),('8902','2012-12-22','09:20:00',2.84),('8902','2012-12-22','09:25:00',3.03),('8902','2012-12-22','09:30:00',3.1),('8902','2012-12-22','09:35:00',3.27),('8902','2012-12-22','09:40:00',3.38),('8902','2012-12-22','09:45:00',3.5),('8902','2012-12-22','09:50:00',3.6),('8902','2012-12-22','09:55:00',3.7),('8902','2012-12-22','10:00:00',3.78),('8902','2012-12-22','10:05:00',3.91),('8902','2012-12-22','10:10:00',3.98),('8902','2012-12-22','10:15:00',4.04),('8902','2012-12-22','10:20:00',4.18),('8902','2012-12-22','10:25:00',4.22),('8902','2012-12-22','10:30:00',4.24),('8902','2012-12-22','10:35:00',4.38),('8902','2012-12-22','10:40:00',4.47),('8902','2012-12-22','10:45:00',4.59),('8902','2012-12-22','10:50:00',4.59),('8902','2012-12-22','10:55:00',4.41),('8902','2012-12-22','11:00:00',4.74),('8902','2012-12-22','11:05:00',4.8),('8902','2012-12-22','11:10:00',4.84),('8902','2012-12-22','11:15:00',4.89),('8902','2012-12-22','11:20:00',5.04),('8902','2012-12-22','11:25:00',4.63),('8902','2012-12-22','11:30:00',4.92),('8902','2012-12-22','11:35:00',5.18),('8902','2012-12-22','11:40:00',5.18),('8902','2012-12-22','11:45:00',5.11),('8902','2012-12-22','11:50:00',5.22),('8902','2012-12-22','11:55:00',4.93),('8902','2012-12-22','12:00:00',4.58),('8902','2012-12-22','12:05:00',4.67),('8902','2012-12-22','12:10:00',4.69),('8902','2012-12-22','12:15:00',3.84),('8902','2012-12-22','12:20:00',3.73),('8902','2012-12-22','12:25:00',2.38),('8902','2012-12-22','12:30:00',2.59),('8902','2012-12-22','12:35:00',2.25),('8902','2012-12-22','12:40:00',2.43),('8902','2012-12-22','12:45:00',2.4),('8902','2012-12-22','12:50:00',3.09),('8902','2012-12-22','12:55:00',4.6),('8902','2012-12-22','13:00:00',4.95),('8902','2012-12-22','13:05:00',4.39),('8902','2012-12-22','13:10:00',4.69),('8902','2012-12-22','13:15:00',3.41),('8902','2012-12-22','13:20:00',2.56),('8902','2012-12-22','13:25:00',2.8),('8902','2012-12-22','13:30:00',2.27),('8902','2012-12-22','13:35:00',1.88),('8902','2012-12-22','13:40:00',3.35),('8902','2012-12-22','13:45:00',3.5),('8902','2012-12-22','13:50:00',3.2),('8902','2012-12-22','13:55:00',2.78),('8902','2012-12-22','14:00:00',4.15),('8902','2012-12-22','14:05:00',3.67),('8902','2012-12-22','14:10:00',3.48),('8902','2012-12-22','14:15:00',3.63),('8902','2012-12-22','14:20:00',2.96),('8902','2012-12-22','14:25:00',2.31),('8902','2012-12-22','14:30:00',2.31),('8902','2012-12-22','14:35:00',2.61),('8902','2012-12-22','14:40:00',3.11),('8902','2012-12-22','14:45:00',3.3),('8902','2012-12-22','14:50:00',2.4),('8902','2012-12-22','14:55:00',1.7),('8902','2012-12-22','15:00:00',1.35),('8902','2012-12-22','15:05:00',1.39),('8902','2012-12-22','15:10:00',1.56),('8902','2012-12-22','15:15:00',1.16),('8902','2014-04-30','07:40:00',1.06),('8902','2014-04-30','07:45:00',1.26),('8902','2014-04-30','07:50:00',1.62),('8902','2014-04-30','07:55:00',1.86),('8902','2014-04-30','08:00:00',2.08),('8902','2014-04-30','08:05:00',2.22),('8902','2014-04-30','08:10:00',2.35),('8902','2014-04-30','08:15:00',2.56),('8902','2014-04-30','08:20:00',2.74),('8902','2014-04-30','08:25:00',2.94),('8902','2014-04-30','08:30:00',3.12),('8902','2014-04-30','08:35:00',3.31),('8902','2014-04-30','08:40:00',3.47),('8902','2014-04-30','08:45:00',3.66),('8902','2014-04-30','08:50:00',3.94),('8902','2014-04-30','08:55:00',4.61),('8902','2014-04-30','09:00:00',2.87),('8902','2014-04-30','09:05:00',2.86),('8902','2014-04-30','09:10:00',2.75),('8902','2014-04-30','09:15:00',3.05),('8902','2014-04-30','09:20:00',2.29),('8902','2014-04-30','09:25:00',3.64),('8902','2014-04-30','09:30:00',5.27),('8902','2014-04-30','09:35:00',5.45),('8902','2014-04-30','09:40:00',5.14),('8902','2014-04-30','09:45:00',3.35),('8902','2014-04-30','09:50:00',3.38),('8902','2014-04-30','09:55:00',3.16),('8902','2014-04-30','10:00:00',3.4),('8902','2014-04-30','10:05:00',4.61),('8902','2014-04-30','10:10:00',8.18),('8902','2014-04-30','10:15:00',5.05),('8902','2014-04-30','10:20:00',5.18),('8902','2014-04-30','10:25:00',7),('8902','2014-04-30','10:30:00',6.47),('8902','2014-04-30','10:35:00',2.51),('8902','2014-04-30','10:40:00',3.86),('8902','2014-04-30','10:45:00',4.05),('8902','2014-04-30','10:50:00',8.02),('8902','2014-04-30','10:55:00',8.31),('8902','2014-04-30','11:00:00',8.78),('8902','2014-04-30','11:05:00',6.74),('8902','2014-04-30','11:10:00',4.6),('8902','2014-04-30','11:15:00',4.35),('8902','2014-04-30','11:20:00',6.82),('8902','2014-04-30','11:25:00',8.48),('8902','2014-04-30','11:30:00',5.9),('8902','2014-04-30','11:35:00',8.05),('8902','2014-04-30','11:40:00',8.88),('8902','2014-04-30','11:45:00',8.54),('8902','2014-04-30','11:50:00',7.26),('8902','2014-04-30','11:55:00',8.09),('8902','2014-04-30','12:00:00',8.94),('8902','2014-04-30','12:05:00',9.06),('8902','2014-04-30','12:10:00',8.88),('8902','2014-04-30','12:15:00',8.28),('8902','2014-04-30','12:20:00',6.93),('8902','2014-04-30','12:25:00',1.57),('8902','2014-04-30','12:30:00',4.57),('8902','2014-04-30','12:35:00',9.65),('8902','2014-04-30','12:40:00',9.45),('8902','2014-04-30','12:45:00',9.16),('8902','2014-04-30','12:50:00',7.34),('8902','2014-04-30','12:55:00',2.27),('8902','2014-04-30','13:00:00',9.39),('8902','2014-04-30','13:05:00',9.23),('8902','2014-04-30','13:10:00',9.23),('8902','2014-04-30','13:15:00',9.01),('8902','2014-04-30','13:20:00',9),('8902','2014-04-30','13:25:00',7.28),('8902','2014-04-30','13:30:00',5.01),('8902','2014-04-30','13:35:00',9.7),('8902','2014-04-30','13:40:00',8.3),('8902','2014-04-30','13:45:00',9.52),('8902','2014-04-30','13:50:00',9.72),('8902','2014-04-30','13:55:00',8.29),('8902','2014-04-30','14:00:00',4.06),('8902','2014-04-30','14:05:00',9.72),('8902','2014-04-30','14:10:00',9.18),('8902','2014-04-30','14:15:00',9.11),('8902','2014-04-30','14:20:00',8.8),('8902','2014-04-30','14:25:00',9.06),('8902','2014-04-30','14:30:00',8.5),('8902','2014-04-30','14:35:00',8.03),('8902','2014-04-30','14:40:00',8.67),('8902','2014-04-30','14:45:00',8.95),('8902','2014-04-30','14:50:00',8.81),('8902','2014-04-30','14:55:00',8.57),('8902','2014-04-30','15:00:00',8.83),('8902','2014-04-30','15:05:00',8.48),('8902','2014-04-30','15:10:00',4.69),('8902','2014-04-30','15:15:00',7.56),('8902','2014-04-30','15:20:00',8.04),('8902','2014-04-30','15:25:00',7.92),('8902','2014-04-30','15:30:00',7.66),('8902','2014-04-30','15:35:00',7.57),('8902','2014-04-30','15:40:00',7.46),('8902','2014-04-30','15:45:00',7.38),('8902','2014-04-30','15:50:00',7.17),('8902','2014-04-30','15:55:00',7.07),('8902','2014-04-30','16:00:00',6.99),('8902','2014-04-30','16:05:00',7.01),('8902','2014-04-30','16:10:00',6.66),('8902','2014-04-30','16:15:00',6.61),('8902','2014-04-30','16:20:00',6.41),('8902','2014-04-30','16:25:00',5.72),('8902','2014-04-30','16:30:00',5.95),('8902','2014-04-30','16:35:00',6.02),('8902','2014-04-30','16:40:00',5.74),('8902','2014-04-30','16:45:00',4.76),('8902','2014-04-30','16:50:00',4.64),('8902','2014-04-30','16:55:00',4.66),('8902','2014-04-30','17:00:00',4.75),('8902','2014-04-30','17:05:00',4.77),('8902','2014-04-30','17:10:00',5.05),('8902','2014-04-30','17:15:00',4.79),('8902','2014-04-30','17:20:00',4.63),('8902','2014-04-30','17:25:00',4.39),('8902','2014-04-30','17:30:00',4.17),('8902','2014-04-30','17:35:00',4.06),('8902','2014-04-30','17:40:00',3.81),('8902','2014-04-30','17:45:00',3.63),('8902','2014-04-30','17:50:00',3.48),('8902','2014-04-30','17:55:00',3.35),('8902','2014-04-30','18:00:00',3.33),('8902','2014-04-30','18:05:00',2.94),('8902','2014-04-30','18:10:00',2.69),('8902','2014-04-30','18:15:00',2.42),('8902','2014-04-30','18:20:00',2.27),('8902','2014-04-30','18:25:00',2.08),('8902','2014-04-30','18:30:00',1.91),('8902','2014-04-30','18:35:00',1.64),('8902','2014-04-30','18:40:00',1.46),('8902','2014-04-30','18:45:00',1.34),('8902','2014-04-30','18:50:00',1.16),('8902','2014-04-30','18:55:00',1),('8902','2014-03-16','08:30:00',1.11),('8902','2014-03-16','08:35:00',1.18),('8902','2014-03-16','08:40:00',1.32),('8902','2014-03-16','08:45:00',1.37),('8902','2014-03-16','08:50:00',1.39),('8902','2014-03-16','08:55:00',1.58),('8902','2014-03-16','09:00:00',1.57),('8902','2014-03-16','09:05:00',1.72),('8902','2014-03-16','09:10:00',1.81),('8902','2014-03-16','09:15:00',2.14),('8902','2014-03-16','09:20:00',2.41),('8902','2014-03-16','09:25:00',2.56),('8902','2014-03-16','09:30:00',3.2),('8902','2014-03-16','09:35:00',3.54),('8902','2014-03-16','09:40:00',2.66),('8902','2014-03-16','09:45:00',2.4),('8902','2014-03-16','09:50:00',3.15),('8902','2014-03-16','09:55:00',3.55),('8902','2014-03-16','10:00:00',3.72),('8902','2014-03-16','10:05:00',3.09),('8902','2014-03-16','10:10:00',3.64),('8902','2014-03-16','10:15:00',3.21),('8902','2014-03-16','10:20:00',4),('8902','2014-03-16','10:25:00',3.28),('8902','2014-03-16','10:30:00',2.59),('8902','2014-03-16','10:35:00',2.88),('8902','2014-03-16','10:40:00',2.74),('8902','2014-03-16','10:45:00',3.11),('8902','2014-03-16','10:50:00',2.78),('8902','2014-03-16','10:55:00',2.81),('8902','2014-03-16','11:00:00',2.81),('8902','2014-03-16','11:05:00',2.62),('8902','2014-03-16','11:10:00',3.29),('8902','2014-03-16','11:15:00',3.41),('8902','2014-03-16','11:20:00',2.52),('8902','2014-03-16','11:25:00',2.46),('8902','2014-03-16','11:30:00',3.08),('8902','2014-03-16','11:35:00',2.53),('8902','2014-03-16','11:40:00',2.34),('8902','2014-03-16','11:45:00',2.16),('8902','2014-03-16','11:50:00',3.73),('8902','2014-03-16','11:55:00',3.43),('8902','2014-03-16','12:00:00',3.32),('8902','2014-03-16','12:05:00',5.16),('8902','2014-03-16','12:10:00',3.26),('8902','2014-03-16','12:15:00',4.23),('8902','2014-03-16','12:20:00',3.04),('8902','2014-03-16','12:25:00',6.61),('8902','2014-03-16','12:30:00',3.85),('8902','2014-03-16','12:35:00',4.62),('8902','2014-03-16','12:40:00',4.33),('8902','2014-03-16','12:45:00',4.95),('8902','2014-03-16','12:50:00',3.31),('8902','2014-03-16','12:55:00',7.13),('8902','2014-03-16','13:00:00',8.04),('8902','2014-03-16','13:05:00',6.69),('8902','2014-03-16','13:10:00',6.16),('8902','2014-03-16','13:15:00',7.56),('8902','2014-03-16','13:20:00',7.66),('8902','2014-03-16','13:25:00',7.64),('8902','2014-03-16','13:30:00',5.07),('8902','2014-03-16','13:35:00',6.11),('8902','2014-03-16','13:40:00',7.4),('8902','2014-03-16','13:45:00',7.54),('8902','2014-03-16','13:50:00',6.25),('8902','2014-03-16','13:55:00',6.12),('8902','2014-03-16','14:00:00',5.82),('8902','2014-03-16','14:05:00',5.22),('8902','2014-03-16','14:10:00',4.67),('8902','2014-03-16','14:15:00',2.07),('8902','2014-03-16','14:20:00',4.3),('8902','2014-03-16','14:25:00',3.62),('8902','2014-03-16','14:30:00',5.67),('8902','2014-03-16','14:35:00',6.77),('8902','2014-03-16','14:40:00',5.7),('8902','2014-03-16','14:45:00',5.98),('8902','2014-03-16','14:50:00',6.3),('8902','2014-03-16','14:55:00',6.1),('8902','2014-03-16','15:00:00',5.96),('8902','2014-03-16','15:05:00',5.63),('8902','2014-03-16','15:10:00',5.56),('8902','2014-03-16','15:15:00',5.55),('8902','2014-03-16','15:20:00',3.1),('8902','2014-03-16','15:25:00',4.59),('8902','2014-03-16','15:30:00',4.97),('8902','2014-03-16','15:35:00',4.78),('8902','2014-03-16','15:40:00',4.49),('8902','2014-03-16','15:45:00',3.95),('8902','2014-03-16','15:50:00',4.23),('8902','2014-03-16','15:55:00',4.01),('8902','2014-03-16','16:00:00',3.99),('8902','2014-03-16','16:05:00',3.71),('8902','2014-03-16','16:10:00',3.23),('8902','2014-03-16','16:15:00',2.87),('8902','2014-03-16','16:20:00',3.37),('8902','2014-03-16','16:25:00',3.32),('8902','2014-03-16','16:30:00',2.78),('8902','2014-03-16','16:35:00',2.57),('8902','2014-03-16','16:40:00',2.41),('8902','2014-03-16','16:45:00',2.12),('8902','2014-03-16','16:50:00',1.91),('8902','2014-03-16','16:55:00',1.22),('8902','2014-03-16','17:00:00',1.02),('8902','2014-03-16','17:05:00',1.27),('8902','2014-03-16','17:10:00',1.08),('8902','2012-12-21','09:25:00',1.03),('8902','2012-12-21','09:30:00',1.3),('8902','2012-12-21','09:35:00',1.68),('8902','2012-12-21','09:40:00',1.36),('8902','2012-12-21','09:45:00',1.15),('8902','2012-12-21','09:50:00',1.2),('8902','2012-12-21','09:55:00',1.35),('8902','2012-12-21','10:00:00',1.34),('8902','2012-12-21','10:05:00',1.39),('8902','2012-12-21','10:10:00',1.49),('8902','2012-12-21','10:15:00',1.54),('8902','2012-12-21','10:20:00',2.1),('8902','2012-12-21','10:25:00',4.26),('8902','2012-12-21','10:30:00',5.14),('8902','2012-12-21','10:35:00',5.53),('8902','2012-12-21','10:40:00',5.43),('8902','2012-12-21','10:45:00',5.35),('8902','2012-12-21','10:50:00',5.33),('8902','2012-12-21','10:55:00',5.31),('8902','2012-12-21','11:00:00',3.23),('8902','2012-12-21','11:05:00',1.03),('8902','2012-12-21','11:20:00',1.15),('8902','2012-12-21','11:30:00',1.26),('8902','2012-12-21','11:35:00',1.58),('8902','2012-12-21','11:40:00',1.8),('8902','2012-12-21','11:45:00',3.1),('8902','2012-12-21','11:50:00',5.18),('8902','2012-12-21','11:55:00',2.66),('8902','2012-12-21','12:00:00',4.54),('8902','2012-12-21','12:05:00',3.47),('8902','2012-12-21','12:10:00',1.57),('8902','2012-12-21','12:15:00',1.52),('8902','2012-12-21','12:20:00',1.28),('8902','2012-12-21','12:25:00',1.24),('8902','2012-12-21','12:30:00',1.29),('8902','2012-12-21','12:35:00',1.37),('8902','2012-12-21','12:40:00',1.54),('8902','2012-12-21','12:45:00',2.86),('8902','2012-12-21','12:50:00',4.78),('8902','2012-12-21','12:55:00',4.41),('8902','2012-12-21','13:00:00',4.95),('8902','2012-12-21','13:05:00',5.78),('8902','2012-12-21','13:10:00',6.13),('8902','2012-12-21','13:15:00',6.21),('8902','2012-12-21','13:20:00',6.28),('8902','2012-12-21','13:25:00',6.18),('8902','2012-12-21','13:30:00',5.79),('8902','2012-12-21','13:35:00',5.27),('8902','2012-12-21','13:40:00',5.73),('8902','2012-12-21','13:45:00',1.65),('8902','2012-12-21','13:50:00',1.49),('8902','2012-12-21','13:55:00',2.02),('8902','2012-12-21','14:00:00',1.91),('8902','2012-12-21','14:05:00',3),('8902','2012-12-21','14:10:00',2.59),('8902','2012-12-21','14:15:00',3.33),('8902','2012-12-21','14:20:00',3.98),('8902','2012-12-21','14:55:00',1.23),('8902','2012-12-21','15:00:00',1.85),('8902','2012-12-21','15:55:00',1.18),('8902','2014-03-15','07:30:00',1.12),('8902','2014-03-15','07:35:00',1.22),('8902','2014-03-15','07:40:00',1.28),('8902','2014-03-15','07:45:00',1.43),('8902','2014-03-15','07:50:00',1.59),('8902','2014-03-15','07:55:00',1.84),('8902','2014-03-15','08:00:00',2.08),('8902','2014-03-15','08:05:00',2.23),('8902','2014-03-15','08:10:00',2.27),('8902','2014-03-15','08:15:00',2.36),('8902','2014-03-15','08:20:00',2.55),('8902','2014-03-15','08:25:00',2.71),('8902','2014-03-15','08:30:00',2.9),('8902','2014-03-15','08:35:00',3.05),('8902','2014-03-15','08:40:00',3.17),('8902','2014-03-15','08:45:00',3.38),('8902','2014-03-15','08:50:00',3.56),('8902','2014-03-15','08:55:00',3.64),('8902','2014-03-15','09:00:00',3.66),('8902','2014-03-15','09:05:00',3.84),('8902','2014-03-15','09:10:00',4.08),('8902','2014-03-15','09:15:00',4.43),('8902','2014-03-15','09:20:00',4.5),('8902','2014-03-15','09:25:00',4.5),('8902','2014-03-15','09:30:00',4.62),('8902','2014-03-15','09:35:00',4.63),('8902','2014-03-15','09:40:00',4.67),('8902','2014-03-15','09:45:00',4.99),('8902','2014-03-15','09:50:00',5.39),('8902','2014-03-15','09:55:00',5.44),('8902','2014-03-15','10:00:00',5.53),('8902','2014-03-15','10:05:00',5.54),('8902','2014-03-15','10:10:00',5.72),('8902','2014-03-15','10:15:00',5.85),('8902','2014-03-15','10:20:00',5.77),('8902','2014-03-15','10:25:00',5.78),('8902','2014-03-15','10:30:00',5.98),('8902','2014-03-15','10:35:00',6.14),('8902','2014-03-15','10:40:00',6.32),('8902','2014-03-15','10:45:00',6.39),('8902','2014-03-15','10:50:00',6.41),('8902','2014-03-15','10:55:00',6.43),('8902','2014-03-15','11:00:00',6.24),('8902','2014-03-15','11:05:00',6.12),('8902','2014-03-15','11:10:00',6.3),('8902','2014-03-15','11:15:00',6.47),('8902','2014-03-15','11:20:00',6.75),('8902','2014-03-15','11:25:00',6.88),('8902','2014-03-15','11:30:00',6.95),('8902','2014-03-15','11:35:00',7.06),('8902','2014-03-15','11:40:00',7.05),('8902','2014-03-15','11:45:00',7.01),('8902','2014-03-15','11:50:00',7.06),('8902','2014-03-15','11:55:00',6.98),('8902','2014-03-15','12:00:00',7.06),('8902','2014-03-15','12:05:00',6.94),('8902','2014-03-15','12:10:00',7.03),('8902','2014-03-15','12:15:00',6.95),('8902','2014-03-15','12:20:00',7.07),('8902','2014-03-15','12:25:00',6.96),('8902','2014-03-15','12:30:00',6.96),('8902','2014-03-15','12:35:00',7),('8902','2014-03-15','12:40:00',7.09),('8902','2014-03-15','12:45:00',7.11),('8902','2014-03-15','12:50:00',6.95),('8902','2014-03-15','12:55:00',6.84),('8902','2014-03-15','13:00:00',6.79),('8902','2014-03-15','13:05:00',6.89),('8902','2014-03-15','13:10:00',6.86),('8902','2014-03-15','13:15:00',6.86),('8902','2014-03-15','13:20:00',6.7),('8902','2014-03-15','13:25:00',6.78),('8902','2014-03-15','13:30:00',6.82),('8902','2014-03-15','13:35:00',6.63),('8902','2014-03-15','13:40:00',6.82),('8902','2014-03-15','13:45:00',6.67),('8902','2014-03-15','13:50:00',6.51),('8902','2014-03-15','13:55:00',6.63),('8902','2014-03-15','14:00:00',6.53),('8902','2014-03-15','14:05:00',6.42),('8902','2014-03-15','14:10:00',6.34),('8902','2014-03-15','14:15:00',6.2),('8902','2014-03-15','14:20:00',6.23),('8902','2014-03-15','14:25:00',6.15),('8902','2014-03-15','14:30:00',6.1),('8902','2014-03-15','14:35:00',5.92),('8902','2014-03-15','14:40:00',5.85),('8902','2014-03-15','14:45:00',5.66),('8902','2014-03-15','14:50:00',5.31),('8902','2014-03-15','14:55:00',5.28),('8902','2014-03-15','15:00:00',5.64),('8902','2014-03-15','15:05:00',5.29),('8902','2014-03-15','15:10:00',4.91),('8902','2014-03-15','15:15:00',4.5),('8902','2014-03-15','15:20:00',3.9),('8902','2014-03-15','15:25:00',4.28),('8902','2014-03-15','15:30:00',4.1),('8902','2014-03-15','15:35:00',3.71),('8902','2014-03-15','15:40:00',2.9),('8902','2014-03-15','15:45:00',2.94),('8902','2014-03-15','15:50:00',3.4),('8902','2014-03-15','15:55:00',3.23),('8902','2014-03-15','16:00:00',2.78),('8902','2014-03-15','16:05:00',3.22),('8902','2014-03-15','16:10:00',3.39),('8902','2014-03-15','16:15:00',3.3),('8902','2014-03-15','16:20:00',2.9),('8902','2014-03-15','16:25:00',3.01),('8902','2014-03-15','16:30:00',2.89),('8902','2014-03-15','16:35:00',2.59),('8902','2014-03-15','16:40:00',2.27),('8902','2014-03-15','16:45:00',2.05),('8902','2014-03-15','16:50:00',1.85),('8902','2014-03-15','16:55:00',1.53),('8902','2014-03-15','17:00:00',1.2),('8902','2014-03-15','17:05:00',1.14),('8902','2014-03-14','07:35:00',1.08),('8902','2014-03-14','07:40:00',1.19),('8902','2014-03-14','07:45:00',1.32),('8902','2014-03-14','07:50:00',1.42),('8902','2014-03-14','07:55:00',1.56),('8902','2014-03-14','08:00:00',1.71),('8902','2014-03-14','08:05:00',1.83),('8902','2014-03-14','08:10:00',1.92),('8902','2014-03-14','08:15:00',2.06),('8902','2014-03-14','08:20:00',2.18),('8902','2014-03-14','08:25:00',2.34),('8902','2014-03-14','08:30:00',2.74),('8902','2014-03-14','08:35:00',2.97),('8902','2014-03-14','08:40:00',3.14),('8902','2014-03-14','08:45:00',3.31),('8902','2014-03-14','08:50:00',3.48),('8902','2014-03-14','08:55:00',3.61),('8902','2014-03-14','09:00:00',3.73),('8902','2014-03-14','09:05:00',3.87),('8902','2014-03-14','09:10:00',4.06),('8902','2014-03-14','09:15:00',4.24),('8902','2014-03-14','09:20:00',4.4),('8902','2014-03-14','09:25:00',4.54),('8902','2014-03-14','09:30:00',4.64),('8902','2014-03-14','09:35:00',4.74),('8902','2014-03-14','09:40:00',4.88),('8902','2014-03-14','09:45:00',5),('8902','2014-03-14','09:50:00',5.06),('8902','2014-03-14','09:55:00',5.16),('8902','2014-03-14','10:00:00',5.3),('8902','2014-03-14','10:05:00',5.38),('8902','2014-03-14','10:10:00',5.45),('8902','2014-03-14','10:15:00',5.55),('8902','2014-03-14','10:20:00',5.57),('8902','2014-03-14','10:25:00',5.73),('8902','2014-03-14','10:30:00',5.86),('8902','2014-03-14','10:35:00',5.9),('8902','2014-03-14','10:40:00',5.97),('8902','2014-03-14','10:45:00',6.15),('8902','2014-03-14','10:50:00',6.32),('8902','2014-03-14','10:55:00',6.21),('8902','2014-03-14','11:00:00',6.22),('8902','2014-03-14','11:05:00',6.26),('8902','2014-03-14','11:10:00',6.38),('8902','2014-03-14','11:15:00',6.34),('8902','2014-03-14','11:20:00',6.54),('8902','2014-03-14','11:25:00',6.67),('8902','2014-03-14','11:30:00',6.85),('8902','2014-03-14','11:35:00',6.82),('8902','2014-03-14','11:40:00',6.9),('8902','2014-03-14','11:45:00',6.88),('8902','2014-03-14','11:50:00',6.96),('8902','2014-03-14','11:55:00',6.87),('8902','2014-03-14','12:00:00',6.96),('8902','2014-03-14','12:05:00',6.92),('8902','2014-03-14','12:10:00',6.87),('8902','2014-03-14','12:15:00',7.02),('8902','2014-03-14','12:20:00',7.09),('8902','2014-03-14','12:25:00',7.09),('8902','2014-03-14','12:30:00',7.13),('8902','2014-03-14','12:35:00',7.26),('8902','2014-03-14','12:40:00',7.23),('8902','2014-03-14','12:45:00',7.21),('8902','2014-03-14','12:50:00',7.22),('8902','2014-03-14','12:55:00',7.22),('8902','2014-03-14','13:00:00',7.09),('8902','2014-03-14','13:05:00',7.19),('8902','2014-03-14','13:10:00',7.19),('8902','2014-03-14','13:15:00',7.13),('8902','2014-03-14','13:20:00',7.09),('8902','2014-03-14','13:25:00',7.03),('8902','2014-03-14','13:30:00',6.99),('8902','2014-03-14','13:35:00',7.02),('8902','2014-03-14','13:40:00',6.99),('8902','2014-03-14','13:45:00',6.96),('8902','2014-03-14','13:50:00',6.89),('8902','2014-03-14','13:55:00',6.9),('8902','2014-03-14','14:00:00',6.85),('8902','2014-03-14','14:05:00',6.78),('8902','2014-03-14','14:10:00',6.72),('8902','2014-03-14','14:15:00',6.63),('8902','2014-03-14','14:20:00',6.53),('8902','2014-03-14','14:25:00',6.42),('8902','2014-03-14','14:30:00',6.32),('8902','2014-03-14','14:35:00',6.2),('8902','2014-03-14','14:40:00',6.08),('8902','2014-03-14','14:45:00',5.95),('8902','2014-03-14','14:50:00',5.81),('8902','2014-03-14','14:55:00',5.72),('8902','2014-03-14','15:00:00',5.64),('8902','2014-03-14','15:05:00',5.54),('8902','2014-03-14','15:10:00',5.4),('8902','2014-03-14','15:15:00',5.26),('8902','2014-03-14','15:20:00',5.09),('8902','2014-03-14','15:25:00',4.87),('8902','2014-03-14','15:30:00',4.74),('8902','2014-03-14','15:35:00',4.6),('8902','2014-03-14','15:40:00',4.4),('8902','2014-03-14','15:45:00',4.26),('8902','2014-03-14','15:50:00',4.01),('8902','2014-03-14','15:55:00',3.9),('8902','2014-03-14','16:00:00',3.73),('8902','2014-03-14','16:05:00',3.4),('8902','2014-03-14','16:10:00',3.31),('8902','2014-03-14','16:15:00',3.04),('8902','2014-03-14','16:20:00',2.89),('8902','2014-03-14','16:25:00',2.69),('8902','2014-03-14','16:30:00',2.48),('8902','2014-03-14','16:35:00',2.24),('8902','2014-03-14','16:40:00',2.04),('8902','2014-03-14','16:45:00',1.9),('8902','2014-03-14','16:50:00',1.7),('8902','2014-03-14','16:55:00',1.54),('8902','2014-03-14','17:00:00',1.41),('8902','2014-03-14','17:05:00',1.22),('8902','2014-03-14','17:10:00',1.07),('8902','2014-03-13','07:40:00',1.07),('8902','2014-03-13','07:45:00',1.17),('8902','2014-03-13','07:50:00',1.28),('8902','2014-03-13','07:55:00',1.38),('8902','2014-03-13','08:00:00',1.48),('8902','2014-03-13','08:05:00',1.58),('8902','2014-03-13','08:10:00',1.71),('8902','2014-03-13','08:15:00',1.92),('8902','2014-03-13','08:20:00',2.11),('8902','2014-03-13','08:25:00',2.2),('8902','2014-03-13','08:30:00',2.37),('8902','2014-03-13','08:35:00',2.41),('8902','2014-03-13','08:40:00',2.33),('8902','2014-03-13','08:45:00',2.03),('8902','2014-03-13','08:50:00',1.95),('8902','2014-03-13','08:55:00',2.04),('8902','2014-03-13','09:00:00',2.21),('8902','2014-03-13','09:05:00',2.51),('8902','2014-03-13','09:10:00',2.79),('8902','2014-03-13','09:15:00',2.81),('8902','2014-03-13','09:20:00',2.78),('8902','2014-03-13','09:25:00',2.99),('8902','2014-03-13','09:30:00',2.97),('8902','2014-03-13','09:35:00',3.56),('8902','2014-03-13','09:40:00',4.44),('8902','2014-03-13','09:45:00',5.14),('8902','2014-03-13','09:50:00',5.98),('8902','2014-03-13','09:55:00',6.19),('8902','2014-03-13','10:00:00',6.61),('8902','2014-03-13','10:05:00',6.55),('8902','2014-03-13','10:10:00',6.42),('8902','2014-03-13','10:15:00',6.29),('8902','2014-03-13','10:20:00',6.13),('8902','2014-03-13','10:25:00',6.09),('8902','2014-03-13','10:30:00',5.91),('8902','2014-03-13','10:35:00',6.27),('8902','2014-03-13','10:40:00',6.39),('8902','2014-03-13','10:45:00',5.83),('8902','2014-03-13','10:50:00',3.53),('8902','2014-03-13','10:55:00',5.16),('8902','2014-03-13','11:00:00',6.35),('8902','2014-03-13','11:05:00',6.59),('8902','2014-03-13','11:10:00',7.15),('8902','2014-03-13','11:15:00',7.22),('8902','2014-03-13','11:20:00',7.01),('8902','2014-03-13','11:25:00',6.89),('8902','2014-03-13','11:30:00',6.96),('8902','2014-03-13','11:35:00',7.09),('8902','2014-03-13','11:40:00',7.11),('8902','2014-03-13','11:45:00',7.25),('8902','2014-03-13','11:50:00',7.3),('8902','2014-03-13','11:55:00',7.31),('8902','2014-03-13','12:00:00',7.42),('8902','2014-03-13','12:05:00',7.44),('8902','2014-03-13','12:10:00',7.04),('8902','2014-03-13','12:15:00',6.64),('8902','2014-03-13','12:20:00',5.52),('8902','2014-03-13','12:25:00',4.71),('8902','2014-03-13','12:30:00',4.38),('8902','2014-03-13','12:35:00',3.8),('8902','2014-03-13','12:40:00',4.58),('8902','2014-03-13','12:45:00',5.1),('8902','2014-03-13','12:50:00',6.11),('8902','2014-03-13','12:55:00',5.95),('8902','2014-03-13','13:00:00',4.3),('8902','2014-03-13','13:05:00',3.85),('8902','2014-03-13','13:10:00',4.64),('8902','2014-03-13','13:15:00',5.56),('8902','2014-03-13','13:20:00',5.58),('8902','2014-03-13','13:25:00',5.19),('8902','2014-03-13','13:30:00',4.78),('8902','2014-03-13','13:35:00',4.34),('8902','2014-03-13','13:40:00',3.96),('8902','2014-03-13','13:45:00',4.08),('8902','2014-03-13','13:50:00',3.81),('8902','2014-03-13','13:55:00',4.04),('8902','2014-03-13','14:00:00',4.7),('8902','2014-03-13','14:05:00',5.25),('8902','2014-03-13','14:10:00',5.24),('8902','2014-03-13','14:15:00',5.48),('8902','2014-03-13','14:20:00',5.73),('8902','2014-03-13','14:25:00',5.64),('8902','2014-03-13','14:30:00',5.23),('8902','2014-03-13','14:35:00',4.83),('8902','2014-03-13','14:40:00',4.02),('8902','2014-03-13','14:45:00',3.25),('8902','2014-03-13','14:50:00',2.82),('8902','2014-03-13','14:55:00',2.6),('8902','2014-03-13','15:00:00',2.39),('8902','2014-03-13','15:05:00',2.37),('8902','2014-03-13','15:10:00',2.28),('8902','2014-03-13','15:15:00',2.35),('8902','2014-03-13','15:20:00',2.61),('8902','2014-03-13','15:25:00',2.7),('8902','2014-03-13','15:30:00',2.9),('8902','2014-03-13','15:35:00',3.07),('8902','2014-03-13','15:40:00',2.75),('8902','2014-03-13','15:45:00',2.38),('8902','2014-03-13','15:50:00',2.21),('8902','2014-03-13','15:55:00',2.25),('8902','2014-03-13','16:00:00',2.07),('8902','2014-03-13','16:05:00',2.01),('8902','2014-03-13','16:10:00',1.81),('8902','2014-03-13','16:15:00',1.48),('8902','2014-03-13','16:20:00',1.28),('8902','2014-03-13','16:25:00',1.18),('8902','2014-03-13','16:30:00',1.13),('8902','2014-03-13','16:35:00',1.05),('8902','2014-03-12','07:30:00',1.12),('8902','2014-03-12','07:35:00',1.31),('8902','2014-03-12','07:40:00',1.48),('8902','2014-03-12','07:45:00',1.65),('8902','2014-03-12','07:50:00',1.82),('8902','2014-03-12','07:55:00',2.03),('8902','2014-03-12','08:00:00',2.22),('8902','2014-03-12','08:05:00',2.41),('8902','2014-03-12','08:10:00',2.6),('8902','2014-03-12','08:15:00',2.78),('8902','2014-03-12','08:20:00',2.94),('8902','2014-03-12','08:25:00',3.13),('8902','2014-03-12','08:30:00',3.3),('8902','2014-03-12','08:35:00',3.49),('8902','2014-03-12','08:40:00',3.68),('8902','2014-03-12','08:45:00',3.87),('8902','2014-03-12','08:50:00',4.06),('8902','2014-03-12','08:55:00',4.23),('8902','2014-03-12','09:00:00',4.42),('8902','2014-03-12','09:05:00',4.56),('8902','2014-03-12','09:10:00',4.7),('8902','2014-03-12','09:15:00',4.86),('8902','2014-03-12','09:20:00',5),('8902','2014-03-12','09:25:00',5.15),('8902','2014-03-12','09:30:00',5.29),('8902','2014-03-12','09:35:00',5.44),('8902','2014-03-12','09:40:00',5.57),('8902','2014-03-12','09:45:00',5.71),('8902','2014-03-12','09:50:00',5.85),('8902','2014-03-12','09:55:00',5.96),('8902','2014-03-12','10:00:00',6.06),('8902','2014-03-12','10:05:00',6.17),('8902','2014-03-12','10:10:00',6.28),('8902','2014-03-12','10:15:00',6.39),('8902','2014-03-12','10:20:00',6.45),('8902','2014-03-12','10:25:00',6.54),('8902','2014-03-12','10:30:00',6.64),('8902','2014-03-12','10:35:00',6.69),('8902','2014-03-12','10:40:00',6.74),('8902','2014-03-12','10:45:00',6.82),('8902','2014-03-12','10:50:00',6.88),('8902','2014-03-12','10:55:00',6.95),('8902','2014-03-12','11:00:00',7),('8902','2014-03-12','11:05:00',7.04),('8902','2014-03-12','11:10:00',7.13),('8902','2014-03-12','11:15:00',7.16),('8902','2014-03-12','11:20:00',7.22),('8902','2014-03-12','11:25:00',7.25),('8902','2014-03-12','11:30:00',7.3),('8902','2014-03-12','11:35:00',7.34),('8902','2014-03-12','11:40:00',7.37),('8902','2014-03-12','11:45:00',7.46),('8902','2014-03-12','11:50:00',7.44),('8902','2014-03-12','11:55:00',7.51),('8902','2014-03-12','12:00:00',7.5),('8902','2014-03-12','12:05:00',7.45),('8902','2014-03-12','12:10:00',7.45),('8902','2014-03-12','12:15:00',7.43),('8902','2014-03-12','12:20:00',7.47),('8902','2014-03-12','12:25:00',7.5),('8902','2014-03-12','12:30:00',7.54),('8902','2014-03-12','12:35:00',7.52),('8902','2014-03-12','12:40:00',7.44),('8902','2014-03-12','12:45:00',7.43),('8902','2014-03-12','12:50:00',7.4),('8902','2014-03-12','12:55:00',7.37),('8902','2014-03-12','13:00:00',7.33),('8902','2014-03-12','13:05:00',7.3),('8902','2014-03-12','13:10:00',7.22),('8902','2014-03-12','13:15:00',7.08),('8902','2014-03-12','13:20:00',7.16),('8902','2014-03-12','13:25:00',7.18),('8902','2014-03-12','13:30:00',7.22),('8902','2014-03-12','13:35:00',7.19),('8902','2014-03-12','13:40:00',7.12),('8902','2014-03-12','13:45:00',6.99),('8902','2014-03-12','13:50:00',6.9),('8902','2014-03-12','13:55:00',6.8),('8902','2014-03-12','14:00:00',6.73),('8902','2014-03-12','14:05:00',6.67),('8902','2014-03-12','14:10:00',6.63),('8902','2014-03-12','14:15:00',6.6),('8902','2014-03-12','14:20:00',6.51),('8902','2014-03-12','14:25:00',6.39),('8902','2014-03-12','14:30:00',6.29),('8902','2014-03-12','14:35:00',6.21),('8902','2014-03-12','14:40:00',6.14),('8902','2014-03-12','14:45:00',6.01),('8902','2014-03-12','14:50:00',5.9),('8902','2014-03-12','14:55:00',5.78),('8902','2014-03-12','15:00:00',5.66),('8902','2014-03-12','15:05:00',5.56),('8902','2014-03-12','15:10:00',5.42),('8902','2014-03-12','15:15:00',5.3),('8902','2014-03-12','15:20:00',5.15),('8902','2014-03-12','15:25:00',4.97),('8902','2014-03-12','15:30:00',4.86),('8902','2014-03-12','15:35:00',4.71),('8902','2014-03-12','15:40:00',4.53),('8902','2014-03-12','15:45:00',4.4),('8902','2014-03-12','15:50:00',4.18),('8902','2014-03-12','15:55:00',4.04),('8902','2014-03-12','16:00:00',3.86),('8902','2014-03-12','16:05:00',3.64),('8902','2014-03-12','16:10:00',3.48),('8902','2014-03-12','16:15:00',3.28),('8902','2014-03-12','16:20:00',3.11),('8902','2014-03-12','16:25:00',2.99),('8902','2014-03-12','16:30:00',2.72),('8902','2014-03-12','16:35:00',2.44),('8902','2014-03-12','16:40:00',2.38),('8902','2014-03-12','16:45:00',2.17),('8902','2014-03-12','16:50:00',2),('8902','2014-03-12','16:55:00',1.83),('8902','2014-03-12','17:00:00',1.63),('8902','2014-03-12','17:05:00',1.42),('8902','2014-03-12','17:10:00',1.23),('8902','2014-03-12','17:15:00',1.04),('8902','2014-03-11','07:35:00',1.16),('8902','2014-03-11','07:40:00',1.32),('8902','2014-03-11','07:45:00',1.47),('8902','2014-03-11','07:50:00',1.67),('8902','2014-03-11','07:55:00',1.85),('8902','2014-03-11','08:00:00',2.04),('8902','2014-03-11','08:05:00',2.24),('8902','2014-03-11','08:10:00',2.45),('8902','2014-03-11','08:15:00',2.64),('8902','2014-03-11','08:20:00',2.82),('8902','2014-03-11','08:25:00',3.01),('8902','2014-03-11','08:30:00',3.2),('8902','2014-03-11','08:35:00',3.41),('8902','2014-03-11','08:40:00',3.59),('8902','2014-03-11','08:45:00',3.8),('8902','2014-03-11','08:50:00',3.98),('8902','2014-03-11','08:55:00',4.16),('8902','2014-03-11','09:00:00',4.34),('8902','2014-03-11','09:05:00',4.5),('8902','2014-03-11','09:10:00',4.67),('8902','2014-03-11','09:15:00',4.83),('8902','2014-03-11','09:20:00',4.98),('8902','2014-03-11','09:25:00',5.11),('8902','2014-03-11','09:30:00',5.25),('8902','2014-03-11','09:35:00',5.39),('8902','2014-03-11','09:40:00',5.52),('8902','2014-03-11','09:45:00',5.66),('8902','2014-03-11','09:50:00',5.79),('8902','2014-03-11','09:55:00',5.92),('8902','2014-03-11','10:00:00',6.06),('8902','2014-03-11','10:05:00',6.17),('8902','2014-03-11','10:10:00',6.27),('8902','2014-03-11','10:15:00',6.37),('8902','2014-03-11','10:20:00',6.44),('8902','2014-03-11','10:25:00',6.53),('8902','2014-03-11','10:30:00',6.62),('8902','2014-03-11','10:35:00',6.72),('8902','2014-03-11','10:40:00',6.83),('8902','2014-03-11','10:45:00',6.97),('8902','2014-03-11','10:50:00',7.06),('8902','2014-03-11','10:55:00',7.1),('8902','2014-03-11','11:00:00',7.17),('8902','2014-03-11','11:05:00',7.26),('8902','2014-03-11','11:10:00',7.31),('8902','2014-03-11','11:15:00',7.38),('8902','2014-03-11','11:20:00',7.46),('8902','2014-03-11','11:25:00',7.53),('8902','2014-03-11','11:30:00',7.56),('8902','2014-03-11','11:35:00',7.61),('8902','2014-03-11','11:40:00',7.67),('8902','2014-03-11','11:45:00',7.67),('8902','2014-03-11','11:50:00',7.7),('8902','2014-03-11','11:55:00',7.73),('8902','2014-03-11','12:00:00',7.71),('8902','2014-03-11','12:05:00',7.74),('8902','2014-03-11','12:10:00',7.75),('8902','2014-03-11','12:15:00',7.76),('8902','2014-03-11','12:20:00',7.72),('8902','2014-03-11','12:25:00',7.69),('8902','2014-03-11','12:30:00',7.68),('8902','2014-03-11','12:35:00',7.67),('8902','2014-03-11','12:40:00',7.62),('8902','2014-03-11','12:45:00',7.65),('8902','2014-03-11','12:50:00',7.63),('8902','2014-03-11','12:55:00',7.59),('8902','2014-03-11','13:00:00',7.6),('8902','2014-03-11','13:05:00',7.55),('8902','2014-03-11','13:10:00',7.48),('8902','2014-03-11','13:15:00',7.48),('8902','2014-03-11','13:20:00',7.43),('8902','2014-03-11','13:25:00',7.39),('8902','2014-03-11','13:30:00',7.3),('8902','2014-03-11','13:35:00',7.29),('8902','2014-03-11','13:40:00',7.22),('8902','2014-03-11','13:45:00',7.15),('8902','2014-03-11','13:50:00',7.14),('8902','2014-03-11','13:55:00',7.06),('8902','2014-03-11','14:00:00',7.02),('8902','2014-03-11','14:05:00',7.01),('8902','2014-03-11','14:10:00',6.84),('8902','2014-03-11','14:15:00',6.79),('8902','2014-03-11','14:20:00',6.66),('8902','2014-03-11','14:25:00',6.57),('8902','2014-03-11','14:30:00',6.49),('8902','2014-03-11','14:35:00',6.29),('8902','2014-03-11','14:40:00',6.15),('8902','2014-03-11','14:45:00',5.99),('8902','2014-03-11','14:50:00',5.89),('8902','2014-03-11','14:55:00',5.61),('8902','2014-03-11','15:00:00',5.58),('8902','2014-03-11','15:05:00',5.5),('8902','2014-03-11','15:10:00',5.36),('8902','2014-03-11','15:15:00',5.2),('8902','2014-03-11','15:20:00',5.13),('8902','2014-03-11','15:25:00',4.92),('8902','2014-03-11','15:30:00',4.73),('8902','2014-03-11','15:35:00',4.58),('8902','2014-03-11','15:40:00',4.46),('8902','2014-03-11','15:45:00',4.34),('8902','2014-03-11','15:50:00',4.15),('8902','2014-03-11','15:55:00',4.06),('8902','2014-03-11','16:00:00',3.95),('8902','2014-03-11','16:05:00',3.67),('8902','2014-03-11','16:10:00',3.49),('8902','2014-03-11','16:15:00',3.34),('8902','2014-03-11','16:20:00',3.19),('8902','2014-03-11','16:25:00',2.96),('8902','2014-03-11','16:30:00',2.69),('8902','2014-03-11','16:35:00',2.39),('8902','2014-03-11','16:40:00',2.37),('8902','2014-03-11','16:45:00',2.19),('8902','2014-03-11','16:50:00',1.97),('8902','2014-03-11','16:55:00',1.75),('8902','2014-03-11','17:00:00',1.54),('8902','2014-03-11','17:05:00',1.32),('8902','2014-03-11','17:10:00',1.15),('8902','2014-03-11','17:15:00',1),('8902','2014-03-10','07:45:00',1.05),('8902','2014-03-10','07:50:00',1.05),('8902','2014-03-10','07:55:00',1.09),('8902','2014-03-10','08:00:00',1.11),('8902','2014-03-10','10:10:00',1.09),('8902','2014-03-10','10:15:00',1.34),('8902','2014-03-10','10:20:00',1.63),('8902','2014-03-10','10:25:00',1.66),('8902','2014-03-10','10:30:00',1.71),('8902','2014-03-10','10:35:00',1.74),('8902','2014-03-10','10:40:00',1.7),('8902','2014-03-10','10:45:00',1.58),('8902','2014-03-10','10:50:00',1.41),('8902','2014-03-10','10:55:00',1.5),('8902','2014-03-10','11:00:00',1.74),('8902','2014-03-10','11:05:00',1.79),('8902','2014-03-10','11:10:00',1.84),('8902','2014-03-10','11:15:00',1.89),('8902','2014-03-10','11:20:00',1.69),('8902','2014-03-10','11:25:00',1.7),('8902','2014-03-10','11:30:00',1.71),('8902','2014-03-10','11:35:00',1.9),('8902','2014-03-10','11:40:00',2.02),('8902','2014-03-10','11:45:00',2.05),('8902','2014-03-10','11:50:00',1.77),('8902','2014-03-10','11:55:00',1.92),('8902','2014-03-10','12:00:00',2),('8902','2014-03-10','12:05:00',2.03),('8902','2014-03-10','12:10:00',2.14),('8902','2014-03-10','12:15:00',2.37),('8902','2014-03-10','12:20:00',2.53),('8902','2014-03-10','12:25:00',2.3),('8902','2014-03-10','12:30:00',2.2),('8902','2014-03-10','12:35:00',2.33),('8902','2014-03-10','12:40:00',2.52),('8902','2014-03-10','12:45:00',2.41),('8902','2014-03-10','12:50:00',2.37),('8902','2014-03-10','12:55:00',2.21),('8902','2014-03-10','13:00:00',1.99),('8902','2014-03-10','13:05:00',2.33),('8902','2014-03-10','13:10:00',2.42),('8902','2014-03-10','13:15:00',2.4),('8902','2014-03-10','13:20:00',2.42),('8902','2014-03-10','13:25:00',2.06),('8902','2014-03-10','13:30:00',2),('8902','2014-03-10','13:35:00',1.9),('8902','2014-03-10','13:40:00',1.99),('8902','2014-03-10','13:45:00',2.57),('8902','2014-03-10','13:50:00',3.09),('8902','2014-03-10','13:55:00',3.65),('8902','2014-03-10','14:00:00',3.72),('8902','2014-03-10','14:05:00',4.02),('8902','2014-03-10','14:10:00',5.26),('8902','2014-03-10','14:15:00',4.76),('8902','2014-03-10','14:20:00',3.97),('8902','2014-03-10','14:25:00',3.75),('8902','2014-03-10','14:30:00',2.57),('8902','2014-03-10','14:35:00',2.66),('8902','2014-03-10','14:40:00',2.63),('8902','2014-03-10','14:45:00',2.72),('8902','2014-03-10','14:50:00',2.5),('8902','2014-03-10','14:55:00',2.59),('8902','2014-03-10','15:00:00',3.05),('8902','2014-03-10','15:05:00',3.45),('8902','2014-03-10','15:10:00',3.69),('8902','2014-03-10','15:15:00',2.92),('8902','2014-03-10','15:20:00',2.73),('8902','2014-03-10','15:25:00',2.48),('8902','2014-03-10','15:30:00',2.41),('8902','2014-03-10','15:35:00',2.14),('8902','2014-03-10','15:40:00',2.13),('8902','2014-03-10','15:45:00',1.99),('8902','2014-03-10','15:50:00',1.99),('8902','2014-03-10','15:55:00',1.65),('8902','2014-03-10','16:00:00',1.51),('8902','2014-03-10','16:05:00',1.51),('8902','2014-03-10','16:10:00',1.55),('8902','2014-03-10','16:15:00',1.5),('8902','2014-03-10','16:20:00',1.48),('8902','2014-03-10','16:25:00',1.3),('8902','2014-03-10','16:30:00',1.18),('8902','2014-03-10','16:35:00',1.05),('8902','2014-03-09','08:15:00',1.07),('8902','2014-03-09','08:20:00',1.15),('8902','2014-03-09','08:25:00',1.25),('8902','2014-03-09','08:30:00',1.38),('8902','2014-03-09','08:35:00',1.59),('8902','2014-03-09','08:40:00',1.71),('8902','2014-03-09','08:45:00',1.69),('8902','2014-03-09','08:50:00',1.75),('8902','2014-03-09','08:55:00',1.76),('8902','2014-03-09','09:00:00',1.82),('8902','2014-03-09','09:05:00',1.97),('8902','2014-03-09','09:10:00',2.05),('8902','2014-03-09','09:15:00',1.93),('8902','2014-03-09','09:20:00',1.89),('8902','2014-03-09','09:25:00',1.87),('8902','2014-03-09','09:30:00',1.96),('8902','2014-03-09','09:35:00',1.87),('8902','2014-03-09','09:40:00',1.9),('8902','2014-03-09','09:45:00',1.73),('8902','2014-03-09','09:50:00',1.51),('8902','2014-03-09','09:55:00',1.43),('8902','2014-03-09','10:00:00',1.28),('8902','2014-03-09','10:05:00',1.42),('8902','2014-03-09','10:10:00',1.83),('8902','2014-03-09','10:15:00',2.14),('8902','2014-03-09','10:20:00',1.78),('8902','2014-03-09','10:25:00',1.75),('8902','2014-03-09','10:30:00',2.15),('8902','2014-03-09','10:35:00',2.36),('8902','2014-03-09','10:40:00',1.61),('8902','2014-03-09','10:45:00',1.02),('8902','2014-03-09','11:05:00',1.08),('8902','2014-03-09','11:10:00',1.41),('8902','2014-03-09','11:15:00',1.69),('8902','2014-03-09','11:20:00',1.87),('8902','2014-03-09','11:25:00',1.73),('8902','2014-03-09','11:30:00',1.51),('8902','2014-03-09','11:35:00',1.01),('8902','2014-03-09','12:15:00',1.01),('8902','2014-03-09','12:20:00',1.09),('8902','2014-03-09','12:25:00',1.17),('8902','2014-03-09','12:30:00',1.32),('8902','2014-03-09','12:35:00',1.51),('8902','2014-03-09','12:40:00',1.71),('8902','2014-03-09','12:45:00',1.96),('8902','2014-03-09','12:50:00',2.16),('8902','2014-03-09','12:55:00',2.32),('8902','2014-03-09','13:00:00',2.44),('8902','2014-03-09','13:05:00',2.52),('8902','2014-03-09','13:10:00',3),('8902','2014-03-09','13:15:00',3.41),('8902','2014-03-09','13:20:00',3.09),('8902','2014-03-09','13:25:00',2.77),('8902','2014-03-09','13:30:00',2.28),('8902','2014-03-09','13:35:00',1.92),('8902','2014-03-09','13:40:00',1.73),('8902','2014-03-09','13:45:00',1.64),('8902','2014-03-09','13:50:00',2.32),('8902','2014-03-09','13:55:00',1.99),('8902','2014-03-09','14:00:00',2.07),('8902','2014-03-09','14:05:00',2.93),('8902','2014-03-09','14:10:00',3.64),('8902','2014-03-09','14:15:00',5.25),('8902','2014-03-09','14:20:00',3.36),('8902','2014-03-09','14:25:00',3.06),('8902','2014-03-09','14:30:00',2.57),('8902','2014-03-09','14:35:00',4.88),('8902','2014-03-09','14:40:00',5.9),('8902','2014-03-09','14:45:00',3.73),('8902','2014-03-09','14:50:00',4.43),('8902','2014-03-09','14:55:00',3.14),('8902','2014-03-09','15:00:00',2.98),('8902','2014-03-09','15:05:00',2.24),('8902','2014-03-09','15:10:00',1.96),('8902','2014-03-09','15:15:00',2.26),('8902','2014-03-09','15:20:00',5.03),('8902','2014-03-09','15:25:00',4.45),('8902','2014-03-09','15:30:00',2.73),('8902','2014-03-09','15:35:00',2.37),('8902','2014-03-09','15:40:00',2.47),('8902','2014-03-09','15:45:00',2.01),('8902','2014-03-09','15:50:00',1.89),('8902','2014-03-09','15:55:00',1.81),('8902','2014-03-09','16:00:00',1.93),('8902','2014-03-09','16:05:00',2.13),('8902','2014-03-09','16:10:00',1.68),('8902','2014-03-09','16:15:00',1.53),('8902','2014-03-09','16:20:00',1.69),('8902','2014-03-09','16:25:00',2.21),('8902','2014-03-09','16:30:00',2.21),('8902','2014-03-09','16:35:00',1.15),('8902','2014-03-09','16:50:00',1.01),('8902','2014-03-09','16:55:00',1.52),('8902','2014-03-09','17:00:00',1.25),('8902','2014-03-08','07:50:00',1.49),('8902','2014-03-08','07:55:00',1.69),('8902','2014-03-08','08:00:00',1.86),('8902','2014-03-08','08:05:00',2.05),('8902','2014-03-08','08:10:00',2.2),('8902','2014-03-08','08:15:00',2.32),('8902','2014-03-08','08:20:00',2.08),('8902','2014-03-08','08:25:00',1.43),('8902','2014-03-08','08:30:00',1.92),('8902','2014-03-08','08:35:00',1.99),('8902','2014-03-08','08:40:00',2.31),('8902','2014-03-08','08:45:00',1.47),('8902','2014-03-08','08:50:00',2.29),('8902','2014-03-08','08:55:00',2.79),('8902','2014-03-08','09:00:00',3.45),('8902','2014-03-08','09:05:00',2.47),('8902','2014-03-08','09:15:00',2.55),('8902','2014-03-08','09:20:00',5.02),('8902','2014-03-08','09:25:00',5.29),('8902','2014-03-08','09:30:00',3.46),('8902','2014-03-08','09:35:00',4.31),('8902','2014-03-08','09:40:00',5.99),('8902','2014-03-08','09:45:00',6.08),('8902','2014-03-08','09:50:00',6.15),('8902','2014-03-08','09:55:00',6.15),('8902','2014-03-08','10:00:00',6.23),('8902','2014-03-08','10:05:00',6.35),('8902','2014-03-08','10:10:00',6.55),('8902','2014-03-08','10:15:00',6.56),('8902','2014-03-08','10:20:00',6.58),('8902','2014-03-08','10:25:00',6.11),('8902','2014-03-08','10:30:00',6.85),('8902','2014-03-08','10:35:00',6.93),('8902','2014-03-08','10:40:00',7.02),('8902','2014-03-08','10:45:00',7.08),('8902','2014-03-08','10:50:00',7.22),('8902','2014-03-08','10:55:00',7.5),('8902','2014-03-08','11:00:00',7.21),('8902','2014-03-08','11:05:00',8.14),('8902','2014-03-08','11:10:00',7.53),('8902','2014-03-08','11:15:00',8.69),('8902','2014-03-08','11:20:00',8.39),('8902','2014-03-08','11:25:00',8.03),('8902','2014-03-08','11:30:00',5.13),('8902','2014-03-08','11:35:00',7.71),('8902','2014-03-08','11:40:00',4.64),('8902','2014-03-08','11:45:00',4.69),('8902','2014-03-08','11:50:00',6.58),('8902','2014-03-08','11:55:00',8.79),('8902','2014-03-08','12:00:00',8.22),('8902','2014-03-08','12:05:00',9.1),('8902','2014-03-08','12:10:00',8.98),('8902','2014-03-08','12:15:00',8.82),('8902','2014-03-08','12:20:00',8.74),('8902','2014-03-08','12:25:00',8.62),('8902','2014-03-08','12:30:00',8.69),('8902','2014-03-08','12:35:00',8.87),('8902','2014-03-08','12:40:00',8.57),('8902','2014-03-08','12:45:00',8.46),('8902','2014-03-08','12:50:00',8.49),('8902','2014-03-08','12:55:00',8.5),('8902','2014-03-08','13:00:00',8.64),('8902','2014-03-08','13:05:00',8.64),('8902','2014-03-08','13:10:00',8.58),('8902','2014-03-08','13:15:00',8.04),('8902','2014-03-08','13:20:00',7.91),('8902','2014-03-08','13:25:00',8.03),('8902','2014-03-08','13:30:00',7.96),('8902','2014-03-08','13:35:00',5.46),('8902','2014-03-08','13:40:00',1.61),('8902','2014-03-08','13:45:00',2.72),('8902','2014-03-08','13:50:00',3.31),('8902','2014-03-08','13:55:00',7.39),('8902','2014-03-08','14:00:00',7.82),('8902','2014-03-08','14:05:00',7.47),('8902','2014-03-08','14:10:00',7.36),('8902','2014-03-08','14:15:00',6.74),('8902','2014-03-08','14:20:00',7.36),('8902','2014-03-08','14:25:00',3.12),('8902','2014-03-08','14:30:00',2.05),('8902','2014-03-08','14:35:00',2.87),('8902','2014-03-08','14:40:00',6.39),('8902','2014-03-08','14:45:00',7.01),('8902','2014-03-08','14:50:00',6.56),('8902','2014-03-08','14:55:00',6.38),('8902','2014-03-08','15:00:00',6.18),('8902','2014-03-08','15:05:00',4.22),('8902','2014-03-08','15:10:00',5.96),('8902','2014-03-08','15:15:00',5.72),('8902','2014-03-08','15:20:00',5.57),('8902','2014-03-08','15:25:00',5.48),('8902','2014-03-08','15:30:00',5.41),('8902','2014-03-08','15:35:00',5.11),('8902','2014-03-08','15:40:00',4.9),('8902','2014-03-08','15:45:00',3.22),('8902','2014-03-08','15:50:00',2.29),('8902','2014-03-08','15:55:00',4.46),('8902','2014-03-08','16:00:00',4.19),('8902','2014-03-08','16:05:00',3.81),('8902','2014-03-08','16:10:00',2.84),('8902','2014-03-08','16:15:00',1.9),('8902','2014-03-08','16:20:00',3.04),('8902','2014-03-08','16:25:00',2.99),('8902','2014-03-08','16:30:00',2.76),('8902','2014-03-08','16:35:00',2.65),('8902','2014-03-08','16:40:00',2.57),('8902','2014-03-08','16:45:00',2.27),('8902','2014-03-08','16:50:00',2.03),('8902','2014-03-08','16:55:00',1.8),('8902','2014-03-08','17:00:00',1.45),('8902','2014-03-08','17:10:00',1.14),('8902','2014-03-07','07:40:00',1.13),('8902','2014-03-07','07:45:00',1.31),('8902','2014-03-07','07:50:00',1.48),('8902','2014-03-07','07:55:00',1.65),('8902','2014-03-07','08:00:00',1.83),('8902','2014-03-07','08:05:00',2.03),('8902','2014-03-07','08:10:00',2.24),('8902','2014-03-07','08:15:00',2.44),('8902','2014-03-07','08:20:00',2.63),('8902','2014-03-07','08:25:00',2.83),('8902','2014-03-07','08:30:00',3.03),('8902','2014-03-07','08:35:00',3.2),('8902','2014-03-07','08:40:00',3.42),('8902','2014-03-07','08:45:00',3.59),('8902','2014-03-07','08:50:00',3.79),('8902','2014-03-07','08:55:00',3.99),('8902','2014-03-07','09:00:00',4.18),('8902','2014-03-07','09:05:00',4.36),('8902','2014-03-07','09:10:00',4.54),('8902','2014-03-07','09:15:00',4.7),('8902','2014-03-07','09:20:00',4.87),('8902','2014-03-07','09:25:00',5),('8902','2014-03-07','09:30:00',5.15),('8902','2014-03-07','09:35:00',5.32),('8902','2014-03-07','09:40:00',5.45),('8902','2014-03-07','09:45:00',5.57),('8902','2014-03-07','09:50:00',5.72),('8902','2014-03-07','09:55:00',5.83),('8902','2014-03-07','10:00:00',5.95),('8902','2014-03-07','10:05:00',6.07),('8902','2014-03-07','10:10:00',6.18),('8902','2014-03-07','10:15:00',6.29),('8902','2014-03-07','10:20:00',6.38),('8902','2014-03-07','10:25:00',6.52),('8902','2014-03-07','10:30:00',6.65),('8902','2014-03-07','10:35:00',6.79),('8902','2014-03-07','10:40:00',6.86),('8902','2014-03-07','10:45:00',6.92),('8902','2014-03-07','10:50:00',6.99),('8902','2014-03-07','10:55:00',7.06),('8902','2014-03-07','11:00:00',7.13),('8902','2014-03-07','11:05:00',7.17),('8902','2014-03-07','11:10:00',7.24),('8902','2014-03-07','11:15:00',7.36),('8902','2014-03-07','11:20:00',7.51),('8902','2014-03-07','11:25:00',7.77),('8902','2014-03-07','11:30:00',8.1),('8902','2014-03-07','11:35:00',5.35),('8902','2014-03-07','11:40:00',3.9),('8902','2014-03-07','11:45:00',2.91),('8902','2014-03-07','11:50:00',3.44),('8902','2014-03-07','11:55:00',7.04),('8902','2014-03-07','12:00:00',2.46),('8902','2014-03-07','12:05:00',2.04),('8902','2014-03-07','12:10:00',2.08),('8902','2014-03-07','12:15:00',2.26),('8902','2014-03-07','12:20:00',2.62),('8902','2014-03-07','12:25:00',2.86),('8902','2014-03-07','12:30:00',4.73),('8902','2014-03-07','12:35:00',7),('8902','2014-03-07','12:40:00',3.84),('8902','2014-03-07','12:45:00',4.03),('8902','2014-03-07','12:50:00',5.68),('8902','2014-03-07','12:55:00',8.03),('8902','2014-03-07','13:00:00',3.27),('8902','2014-03-07','13:05:00',3.06),('8902','2014-03-07','13:10:00',2.62),('8902','2014-03-07','13:15:00',2.05),('8902','2014-03-07','13:20:00',1.82),('8902','2014-03-07','13:25:00',2.18),('8902','2014-03-07','13:30:00',4.7),('8902','2014-03-07','13:35:00',3.31),('8902','2014-03-07','13:40:00',6.13),('8902','2014-03-07','13:45:00',5.56),('8902','2014-03-07','13:50:00',3.42),('8902','2014-03-07','13:55:00',2.51),('8902','2014-03-07','14:00:00',2.01),('8902','2014-03-07','14:05:00',1.9),('8902','2014-03-07','14:10:00',1.72),('8902','2014-03-07','14:15:00',1.45),('8902','2014-03-07','14:20:00',1.41),('8902','2014-03-07','14:25:00',1.38),('8902','2014-03-07','14:30:00',1.55),('8902','2014-03-07','14:35:00',1.83),('8902','2014-03-07','14:40:00',1.97),('8902','2014-03-07','14:45:00',1.81),('8902','2014-03-07','14:50:00',1.88),('8902','2014-03-07','14:55:00',1.95),('8902','2014-03-07','15:00:00',1.66),('8902','2014-03-07','15:05:00',1.51),('8902','2014-03-07','15:10:00',1.65),('8902','2014-03-07','15:15:00',2.21),('8902','2014-03-07','15:20:00',3.87),('8902','2014-03-07','15:25:00',4.32),('8902','2014-03-07','15:30:00',2.62),('8902','2014-03-07','15:35:00',1.31),('8902','2014-03-07','15:40:00',1.25),('8902','2014-03-07','15:45:00',1.3),('8902','2014-03-07','15:50:00',1.57),('8902','2014-03-07','15:55:00',1.77),('8902','2014-03-07','16:00:00',2.93),('8902','2014-03-07','16:05:00',2.61),('8902','2014-03-07','16:10:00',1.35),('8902','2014-03-07','16:15:00',1.38),('8902','2014-03-07','16:20:00',1.44),('8902','2014-03-07','16:25:00',1.39),('8902','2014-03-07','16:30:00',2.91),('8902','2014-03-07','16:35:00',2.95),('8902','2014-03-07','16:40:00',2.59),('8902','2014-03-07','16:45:00',2.37),('8902','2014-03-07','16:50:00',2.15),('8902','2014-03-07','16:55:00',1.81),('8902','2014-03-07','17:00:00',1.7),('8902','2014-03-07','17:05:00',1.48),('8902','2014-03-07','17:10:00',1.3),('8902','2014-03-07','17:15:00',1.14),('8902','2014-04-29','07:40:00',1.15),('8902','2014-04-29','07:45:00',1.47),('8902','2014-04-29','07:50:00',1.64),('8902','2014-04-29','07:55:00',1.81),('8902','2014-04-29','08:00:00',1.98),('8902','2014-04-29','08:05:00',2.1),('8902','2014-04-29','08:10:00',2.33),('8902','2014-04-29','08:15:00',2.5),('8902','2014-04-29','08:20:00',2.67),('8902','2014-04-29','08:25:00',2.84),('8902','2014-04-29','08:30:00',3.01),('8902','2014-04-29','08:35:00',3.19),('8902','2014-04-29','08:40:00',3.39),('8902','2014-04-29','08:45:00',3.54),('8902','2014-04-29','08:50:00',3.76),('8902','2014-04-29','08:55:00',3.98),('8902','2014-04-29','09:00:00',4.1),('8902','2014-04-29','09:05:00',4.36),('8902','2014-04-29','09:10:00',4.81),('8902','2014-04-29','09:15:00',5.43),('8902','2014-04-29','09:20:00',3.88),('8902','2014-04-29','09:25:00',2.96),('8902','2014-04-29','09:30:00',2.29),('8902','2014-04-29','09:35:00',3.4),('8902','2014-04-29','09:40:00',5.46),('8902','2014-04-29','09:45:00',5.34),('8902','2014-04-29','09:50:00',3.86),('8902','2014-04-29','09:55:00',4.73),('8902','2014-04-29','10:00:00',6.23),('8902','2014-04-29','10:05:00',6.54),('8902','2014-04-29','10:10:00',2.93),('8902','2014-04-29','10:15:00',5.55),('8902','2014-04-29','10:20:00',3.75),('8902','2014-04-29','10:25:00',3.58),('8902','2014-04-29','10:30:00',3.39),('8902','2014-04-29','10:35:00',4.08),('8902','2014-04-29','10:40:00',4.18),('8902','2014-04-29','10:45:00',3.46),('8902','2014-04-29','10:50:00',2.86),('8902','2014-04-29','10:55:00',6.47),('8902','2014-04-29','11:00:00',8.9),('8902','2014-04-29','11:05:00',6.33),('8902','2014-04-29','11:10:00',5.77),('8902','2014-04-29','11:15:00',5.13),('8902','2014-04-29','11:20:00',3.19),('8902','2014-04-29','11:25:00',4.43),('8902','2014-04-29','11:30:00',4.5),('8902','2014-04-29','11:35:00',3.92),('8902','2014-04-29','11:40:00',5.55),('8902','2014-04-29','11:45:00',3.5),('8902','2014-04-29','11:50:00',5.74),('8902','2014-04-29','11:55:00',4.85),('8902','2014-04-29','12:00:00',7.74),('8902','2014-04-29','12:05:00',3.1),('8902','2014-04-29','12:10:00',2.7),('8902','2014-04-29','12:15:00',3.64),('8902','2014-04-29','12:20:00',3.71),('8902','2014-04-29','12:25:00',3.14),('8902','2014-04-29','12:30:00',3.52),('8902','2014-04-29','12:35:00',3.01),('8902','2014-04-29','12:40:00',2.93),('8902','2014-04-29','12:45:00',3.1),('8902','2014-04-29','12:50:00',3.42),('8902','2014-04-29','12:55:00',7.58),('8902','2014-04-29','13:00:00',9.28),('8902','2014-04-29','13:05:00',6.55),('8902','2014-04-29','13:10:00',6.03),('8902','2014-04-29','13:15:00',5.23),('8902','2014-04-29','13:20:00',4.27),('8902','2014-04-29','13:25:00',4.75),('8902','2014-04-29','13:30:00',4.38),('8902','2014-04-29','13:35:00',3.82),('8902','2014-04-29','13:40:00',5.89),('8902','2014-04-29','13:45:00',6.17),('8902','2014-04-29','13:50:00',4.97),('8902','2014-04-29','13:55:00',8.75),('8902','2014-04-29','14:00:00',5.12),('8902','2014-04-29','14:05:00',4.63),('8902','2014-04-29','14:10:00',3.19),('8902','2014-04-29','14:15:00',3.53),('8902','2014-04-29','14:20:00',5.43),('8902','2014-04-29','14:25:00',6.66),('8902','2014-04-29','14:30:00',8.86),('8902','2014-04-29','14:35:00',8.27),('8902','2014-04-29','14:40:00',4.86),('8902','2014-04-29','14:45:00',3.01),('8902','2014-04-29','14:50:00',3.15),('8902','2014-04-29','14:55:00',3.53),('8902','2014-04-29','15:00:00',2.97),('8902','2014-04-29','15:05:00',2.88),('8902','2014-04-29','15:10:00',2.71),('8902','2014-04-29','15:15:00',2.56),('8902','2014-04-29','15:20:00',2.28),('8902','2014-04-29','15:25:00',2.39),('8902','2014-04-29','15:30:00',3.49),('8902','2014-04-29','15:35:00',5.12),('8902','2014-04-29','15:40:00',6.33),('8902','2014-04-29','15:45:00',8.13),('8902','2014-04-29','15:50:00',8.83),('8902','2014-04-29','15:55:00',6.48),('8902','2014-04-29','16:00:00',2.44),('8902','2014-04-29','16:05:00',4.87),('8902','2014-04-29','16:10:00',3.41),('8902','2014-04-29','16:15:00',5.85),('8902','2014-04-29','16:20:00',4.93),('8902','2014-04-29','16:25:00',3.32),('8902','2014-04-29','16:30:00',6.14),('8902','2014-04-29','16:35:00',3.05),('8902','2014-04-29','16:40:00',4.35),('8902','2014-04-29','16:45:00',3.21),('8902','2014-04-29','16:50:00',3.58),('8902','2014-04-29','16:55:00',4.94),('8902','2014-04-29','17:00:00',4.1),('8902','2014-04-29','17:05:00',5.73),('8902','2014-04-29','17:10:00',3.2),('8902','2014-04-29','17:15:00',4.54),('8902','2014-04-29','17:20:00',2.11),('8902','2014-04-29','17:25:00',1.25),('8902','2014-04-29','17:30:00',1.5),('8902','2014-04-29','17:35:00',2.01),('8902','2014-04-29','17:40:00',2.37),('8902','2014-04-29','17:45:00',1.62),('8902','2014-04-29','17:50:00',1.26),('8902','2014-04-29','17:55:00',1.28),('8902','2014-04-29','18:00:00',1.22),('8902','2014-04-29','18:10:00',1),('8902','2014-04-29','18:35:00',1.05),('8902','2014-04-29','18:45:00',1.08),('8902','2014-04-29','18:50:00',1),('8902','2014-03-06','09:25:00',1.04),('8902','2014-03-06','09:30:00',1.09),('8902','2014-03-06','09:35:00',1.32),('8902','2014-03-06','09:40:00',1.09),('8902','2014-03-06','09:50:00',1.03),('8902','2014-03-06','09:55:00',1.28),('8902','2014-03-06','10:00:00',1.1),('8902','2014-03-06','10:05:00',1.18),('8902','2014-03-06','10:10:00',1.21),('8902','2014-03-06','10:15:00',1.19),('8902','2014-03-06','10:20:00',1.27),('8902','2014-03-06','10:25:00',1.06),('8902','2014-03-06','10:30:00',1.34),('8902','2014-03-06','10:35:00',1.51),('8902','2014-03-06','10:40:00',1.27),('8902','2014-03-06','10:45:00',1.19),('8902','2014-03-06','10:50:00',1.23),('8902','2014-03-06','10:55:00',1.33),('8902','2014-03-06','11:00:00',1.5),('8902','2014-03-06','11:05:00',1.26),('8902','2014-03-06','11:10:00',1.11),('8902','2014-03-06','11:15:00',1.21),('8902','2014-03-06','11:20:00',1.5),('8902','2014-03-06','11:25:00',1.51),('8902','2014-03-06','11:30:00',1.8),('8902','2014-03-06','11:35:00',1.64),('8902','2014-03-06','11:40:00',1.61),('8902','2014-03-06','11:45:00',4.33),('8902','2014-03-06','11:50:00',6.13),('8902','2014-03-06','11:55:00',7.58),('8902','2014-03-06','12:00:00',9.22),('8902','2014-03-06','12:05:00',7.92),('8902','2014-03-06','12:10:00',8.88),('8902','2014-03-06','12:15:00',8.47),('8902','2014-03-06','12:20:00',8.63),('8902','2014-03-06','12:25:00',8.59),('8902','2014-03-06','12:30:00',8.73),('8902','2014-03-06','12:35:00',8.4),('8902','2014-03-06','12:40:00',6.86),('8902','2014-03-06','12:45:00',7.8),('8902','2014-03-06','12:50:00',4.29),('8902','2014-03-06','12:55:00',1.5),('8902','2014-03-06','13:00:00',2.04),('8902','2014-03-06','13:05:00',5.4),('8902','2014-03-06','13:10:00',2.15),('8902','2014-03-06','13:15:00',3.42),('8902','2014-03-06','13:20:00',5.76),('8902','2014-03-06','13:25:00',5.77),('8902','2014-03-06','13:30:00',3.7),('8902','2014-03-06','13:35:00',6.35),('8902','2014-03-06','13:40:00',6.45),('8902','2014-03-06','13:45:00',4.81),('8902','2014-03-06','13:50:00',2.7),('8902','2014-03-06','13:55:00',2.24),('8902','2014-03-06','14:00:00',2.17),('8902','2014-03-06','14:05:00',2.1),('8902','2014-03-06','14:10:00',2.11),('8902','2014-03-06','14:15:00',2.05),('8902','2014-03-06','14:20:00',1.93),('8902','2014-03-06','14:25:00',1.9),('8902','2014-03-06','14:30:00',2),('8902','2014-03-06','14:35:00',2.1),('8902','2014-03-06','14:40:00',2.17),('8902','2014-03-06','14:45:00',2.08),('8902','2014-03-06','14:50:00',2.7),('8902','2014-03-06','14:55:00',4.24),('8902','2014-03-06','15:00:00',5.47),('8902','2014-03-06','15:05:00',6.38),('8902','2014-03-06','15:10:00',6.45),('8902','2014-03-06','15:15:00',6.61),('8902','2014-03-06','15:20:00',6.92),('8902','2014-03-06','15:25:00',6.7),('8902','2014-03-06','15:30:00',6.4),('8902','2014-03-06','15:35:00',6.08),('8902','2014-03-06','15:40:00',5.74),('8902','2014-03-06','15:45:00',3.42),('8902','2014-03-06','15:50:00',1.58),('8902','2014-03-06','15:55:00',1.41),('8902','2014-03-06','16:00:00',3.29),('8902','2014-03-06','16:05:00',4.22),('8902','2014-03-06','16:10:00',4.15),('8902','2014-03-06','16:15:00',4.14),('8902','2014-03-06','16:20:00',3.84),('8902','2014-03-06','16:25:00',3.62),('8902','2014-03-06','16:30:00',3.21),('8902','2014-03-06','16:35:00',3.02),('8902','2014-03-06','16:40:00',3.03),('8902','2014-03-06','16:45:00',2.82),('8902','2014-03-06','16:50:00',2.62),('8902','2014-03-06','16:55:00',2.44),('8902','2014-03-06','17:00:00',2.22),('8902','2014-03-06','17:05:00',1.99),('8902','2014-03-06','17:10:00',1.72),('8902','2014-03-06','17:15:00',1.45),('8902','2014-03-06','17:20:00',1.17),('8902','2014-03-05','07:55:00',1.2),('8902','2014-03-05','08:00:00',1.62),('8902','2014-03-05','08:05:00',1.8),('8902','2014-03-05','08:10:00',2.84),('8902','2014-03-05','08:15:00',2.94),('8902','2014-03-05','08:20:00',2.59),('8902','2014-03-05','08:25:00',2.14),('8902','2014-03-05','08:30:00',1.24),('8902','2014-03-05','08:35:00',1.89),('8902','2014-03-05','08:40:00',1.81),('8902','2014-03-05','08:45:00',1.67),('8902','2014-03-05','08:50:00',1.97),('8902','2014-03-05','08:55:00',1.69),('8902','2014-03-05','09:00:00',1.69),('8902','2014-03-05','09:05:00',1.51),('8902','2014-03-05','09:10:00',1.48),('8902','2014-03-05','09:15:00',1.8),('8902','2014-03-05','09:20:00',1.94),('8902','2014-03-05','09:25:00',1.72),('8902','2014-03-05','09:30:00',2.01),('8902','2014-03-05','09:35:00',2.47),('8902','2014-03-05','09:40:00',3.07),('8902','2014-03-05','09:45:00',3.46),('8902','2014-03-05','09:50:00',3.55),('8902','2014-03-05','09:55:00',3.52),('8902','2014-03-05','10:00:00',3.37),('8902','2014-03-05','10:05:00',4.38),('8902','2014-03-05','10:10:00',5.95),('8902','2014-03-05','10:15:00',6.58),('8902','2014-03-05','10:20:00',5.53),('8902','2014-03-05','10:25:00',4.47),('8902','2014-03-05','10:30:00',2.68),('8902','2014-03-05','10:35:00',2.99),('8902','2014-03-05','10:40:00',3.37),('8902','2014-03-05','10:45:00',4.66),('8902','2014-03-05','10:50:00',2.42),('8902','2014-03-05','10:55:00',3.62),('8902','2014-03-05','11:00:00',3.73),('8902','2014-03-05','11:05:00',5.55),('8902','2014-03-05','11:10:00',3.2),('8902','2014-03-05','11:15:00',5.75),('8902','2014-03-05','11:20:00',2.63),('8902','2014-03-05','11:25:00',2.98),('8902','2014-03-05','11:30:00',3.94),('8902','2014-03-05','11:35:00',2.55),('8902','2014-03-05','11:40:00',3.82),('8902','2014-03-05','11:45:00',6.58),('8902','2014-03-05','11:50:00',6.52),('8902','2014-03-05','11:55:00',7.4),('8902','2014-03-05','12:00:00',3.08),('8902','2014-03-05','12:05:00',6.92),('8902','2014-03-05','12:10:00',9.22),('8902','2014-03-05','12:15:00',7.76),('8902','2014-03-05','12:20:00',5.95),('8902','2014-03-05','12:25:00',9.06),('8902','2014-03-05','12:30:00',9.1),('8902','2014-03-05','12:35:00',4.71),('8902','2014-03-05','12:40:00',2.97),('8902','2014-03-05','12:45:00',2.21),('8902','2014-03-05','12:50:00',2),('8902','2014-03-05','12:55:00',2.36),('8902','2014-03-05','13:00:00',2.5),('8902','2014-03-05','13:05:00',2.58),('8902','2014-03-05','13:10:00',2.46),('8902','2014-03-05','13:15:00',3.55),('8902','2014-03-05','13:20:00',2.4),('8902','2014-03-05','13:25:00',2.17),('8902','2014-03-05','13:30:00',2.34),('8902','2014-03-05','13:35:00',2.35),('8902','2014-03-05','13:40:00',2.5),('8902','2014-03-05','13:45:00',2.05),('8902','2014-03-05','13:50:00',1.87),('8902','2014-03-05','13:55:00',1.72),('8902','2014-03-05','14:00:00',1.76),('8902','2014-03-05','14:05:00',2.03),('8902','2014-03-05','14:10:00',2.02),('8902','2014-03-05','14:15:00',1.99),('8902','2014-03-05','14:20:00',2.27),('8902','2014-03-05','14:25:00',2.28),('8902','2014-03-05','14:30:00',2.3),('8902','2014-03-05','14:35:00',2.19),('8902','2014-03-05','14:40:00',1.93),('8902','2014-03-05','14:45:00',1.61),('8902','2014-03-05','14:50:00',1.83),('8902','2014-03-05','14:55:00',1.69),('8902','2014-03-05','15:00:00',1.72),('8902','2014-03-05','15:05:00',2.01),('8902','2014-03-05','15:10:00',2.23),('8902','2014-03-05','15:15:00',1.72),('8902','2014-03-05','15:20:00',1.12),('8902','2014-03-05','15:25:00',1.09),('8902','2014-03-05','15:30:00',1.19),('8902','2014-03-05','15:35:00',1.24),('8902','2014-03-05','15:40:00',1.06),('8902','2014-03-05','15:55:00',1.06),('8902','2014-03-05','16:00:00',1.32),('8902','2014-03-05','16:05:00',1.32),('8902','2014-03-05','16:10:00',1.23),('8902','2014-03-05','16:15:00',1.76),('8902','2014-03-05','16:20:00',2.32),('8902','2014-03-05','16:25:00',3.53),('8902','2014-03-05','16:30:00',1.48),('8902','2014-03-05','16:35:00',1.03),('8902','2014-03-05','16:45:00',1.01),('8902','2014-03-05','16:50:00',1.83),('8902','2014-03-05','16:55:00',2.05),('8902','2014-03-05','17:00:00',1.69),('8902','2014-03-05','17:05:00',1.31),('8902','2014-03-05','17:10:00',1.36),('8902','2014-03-05','17:15:00',1.29),('8902','2014-03-04','07:40:00',1.09),('8902','2014-03-04','07:45:00',1.42),('8902','2014-03-04','07:50:00',1.55),('8902','2014-03-04','07:55:00',1.66),('8902','2014-03-04','08:00:00',1.69),('8902','2014-03-04','08:05:00',1.78),('8902','2014-03-04','08:10:00',1.74),('8902','2014-03-04','08:15:00',1.9),('8902','2014-03-04','08:20:00',1.09),('8902','2014-03-04','08:25:00',1.47),('8902','2014-03-04','08:30:00',3.53),('8902','2014-03-04','08:35:00',3.55),('8902','2014-03-04','08:40:00',4.2),('8902','2014-03-04','08:45:00',3.45),('8902','2014-03-04','08:50:00',1.27),('8902','2014-03-04','08:55:00',2.14),('8902','2014-03-04','09:00:00',4.99),('8902','2014-03-04','09:05:00',1.97),('8902','2014-03-04','09:10:00',1.31),('8902','2014-03-04','09:15:00',3.77),('8902','2014-03-04','09:20:00',5.06),('8902','2014-03-04','09:25:00',5.16),('8902','2014-03-04','09:30:00',5.27),('8902','2014-03-04','09:35:00',5.43),('8902','2014-03-04','09:40:00',5.55),('8902','2014-03-04','09:45:00',5.66),('8902','2014-03-04','09:50:00',5.77),('8902','2014-03-04','09:55:00',5.91),('8902','2014-03-04','10:00:00',6.04),('8902','2014-03-04','10:05:00',6.17),('8902','2014-03-04','10:10:00',6.33),('8902','2014-03-04','10:15:00',6.38),('8902','2014-03-04','10:20:00',6.44),('8902','2014-03-04','10:25:00',6.54),('8902','2014-03-04','10:30:00',6.62),('8902','2014-03-04','10:35:00',6.71),('8902','2014-03-04','10:40:00',6.76),('8902','2014-03-04','10:45:00',6.85),('8902','2014-03-04','10:50:00',6.93),('8902','2014-03-04','10:55:00',7.02),('8902','2014-03-04','11:00:00',7.1),('8902','2014-03-04','11:05:00',7.26),('8902','2014-03-04','11:10:00',7.32),('8902','2014-03-04','11:15:00',7.4),('8902','2014-03-04','11:20:00',7.44),('8902','2014-03-04','11:25:00',7.51),('8902','2014-03-04','11:30:00',7.68),('8902','2014-03-04','11:35:00',8.02),('8902','2014-03-04','11:40:00',8.03),('8902','2014-03-04','11:45:00',7.84),('8902','2014-03-04','11:50:00',7.75),('8902','2014-03-04','11:55:00',6.63),('8902','2014-03-04','12:00:00',6.76),('8902','2014-03-04','12:05:00',6.36),('8902','2014-03-04','12:10:00',2.27),('8902','2014-03-04','12:15:00',2.8),('8902','2014-03-04','12:20:00',1.48),('8902','2014-03-04','12:25:00',1.71),('8902','2014-03-04','12:30:00',2.01),('8902','2014-03-04','12:35:00',3.79),('8902','2014-03-04','12:40:00',2.52),('8902','2014-03-04','12:45:00',2.54),('8902','2014-03-04','12:50:00',3.48),('8902','2014-03-04','12:55:00',3.46),('8902','2014-03-04','13:00:00',3.89),('8902','2014-03-04','13:05:00',5.26),('8902','2014-03-04','13:10:00',6.51),('8902','2014-03-04','13:15:00',5.99),('8902','2014-03-04','13:20:00',4.08),('8902','2014-03-04','13:25:00',2.94),('8902','2014-03-04','13:30:00',2.42),('8902','2014-03-04','13:35:00',2.68),('8902','2014-03-04','13:40:00',3.1),('8902','2014-03-04','13:45:00',2.85),('8902','2014-03-04','13:50:00',2.42),('8902','2014-03-04','13:55:00',2.18),('8902','2014-03-04','14:00:00',1.99),('8902','2014-03-04','14:05:00',1.97),('8902','2014-03-04','14:10:00',2.07),('8902','2014-03-04','14:15:00',2.36),('8902','2014-03-04','14:20:00',2.47),('8902','2014-03-04','14:25:00',2.68),('8902','2014-03-04','14:30:00',2.91),('8902','2014-03-04','14:35:00',2.47),('8902','2014-03-04','14:40:00',3.08),('8902','2014-03-04','14:45:00',3.01),('8902','2014-03-04','14:50:00',4.25),('8902','2014-03-04','14:55:00',2.73),('8902','2014-03-04','15:00:00',1.89),('8902','2014-03-04','15:05:00',1.65),('8902','2014-03-04','15:10:00',1.66),('8902','2014-03-04','15:15:00',1.61),('8902','2014-03-04','15:20:00',1.47),('8902','2014-03-04','15:25:00',1.53),('8902','2014-03-04','15:30:00',1.99),('8902','2014-03-04','15:35:00',2.37),('8902','2014-03-04','15:40:00',4.61),('8902','2014-03-04','15:45:00',3.86),('8902','2014-03-04','15:50:00',2.83),('8902','2014-03-04','15:55:00',4.98),('8902','2014-03-04','16:00:00',6.08),('8902','2014-03-04','16:05:00',5.51),('8902','2014-03-04','16:10:00',4.75),('8902','2014-03-04','16:15:00',3.09),('8902','2014-03-04','16:20:00',1.06),('8902','2014-03-03','08:50:00',1.2),('8902','2014-03-03','09:05:00',2.06),('8902','2014-03-03','09:10:00',1.97),('8902','2014-03-03','09:15:00',3.43),('8902','2014-03-03','09:20:00',5.46),('8902','2014-03-03','09:25:00',2.03),('8902','2014-03-03','09:30:00',1.98),('8902','2014-03-03','09:35:00',2.02),('8902','2014-03-03','09:40:00',3.4),('8902','2014-03-03','09:45:00',4.22),('8902','2014-03-03','09:50:00',1.36),('8902','2014-03-03','09:55:00',3.86),('8902','2014-03-03','10:00:00',3.45),('8902','2014-03-03','10:05:00',2.23),('8902','2014-03-03','10:10:00',1.14),('8902','2014-03-03','10:15:00',1.06),('8902','2014-03-03','10:20:00',1.7),('8902','2014-03-03','10:25:00',7.01),('8902','2014-03-03','10:30:00',5.88),('8902','2014-03-03','10:35:00',5.97),('8902','2014-03-03','10:40:00',7.91),('8902','2014-03-03','10:45:00',7.81),('8902','2014-03-03','10:50:00',2.83),('8902','2014-03-03','10:55:00',4.71),('8902','2014-03-03','11:00:00',4.94),('8902','2014-03-03','11:05:00',3.06),('8902','2014-03-03','11:10:00',5.77),('8902','2014-03-03','11:15:00',9.15),('8902','2014-03-03','11:20:00',7.04),('8902','2014-03-03','11:25:00',2.34),('8902','2014-03-03','11:30:00',1.84),('8902','2014-03-03','11:35:00',1.33),('8902','2014-03-03','11:40:00',1.71),('8902','2014-03-03','11:45:00',4.15),('8902','2014-03-03','11:50:00',9.69),('8902','2014-03-03','11:55:00',8.39),('8902','2014-03-03','12:00:00',8.04),('8902','2014-03-03','12:05:00',7.9),('8902','2014-03-03','12:10:00',7.9),('8902','2014-03-03','12:15:00',7.87),('8902','2014-03-03','12:20:00',7.89),('8902','2014-03-03','12:25:00',7.89),('8902','2014-03-03','12:30:00',7.79),('8902','2014-03-03','12:35:00',7.81),('8902','2014-03-03','12:40:00',7.85),('8902','2014-03-03','12:45:00',8.02),('8902','2014-03-03','12:50:00',6.1),('8902','2014-03-03','12:55:00',6.84),('8902','2014-03-03','13:00:00',6.81),('8902','2014-03-03','13:05:00',7.73),('8902','2014-03-03','13:10:00',8.56),('8902','2014-03-03','13:15:00',7.25),('8902','2014-03-03','13:20:00',2.6),('8902','2014-03-03','13:25:00',1.96),('8902','2014-03-03','13:30:00',2.05),('8902','2014-03-03','13:35:00',1.68),('8902','2014-03-03','13:40:00',1.07),('8902','2014-03-03','13:45:00',1.46),('8902','2014-03-03','13:50:00',2.27),('8902','2014-03-03','13:55:00',2.23),('8902','2014-03-03','14:00:00',1.44),('8902','2014-03-03','14:05:00',2.66),('8902','2014-03-03','14:10:00',6.17),('8902','2014-03-03','14:15:00',5.08),('8902','2014-03-03','14:20:00',4.48),('8902','2014-03-03','14:25:00',7.87),('8902','2014-03-03','14:30:00',7.11),('8902','2014-03-03','14:35:00',6.8),('8902','2014-03-03','14:40:00',6.7),('8902','2014-03-03','14:45:00',6.65),('8902','2014-03-03','14:50:00',6.45),('8902','2014-03-03','14:55:00',2.39),('8902','2014-03-03','15:00:00',3.67),('8902','2014-03-03','15:05:00',6.1),('8902','2014-03-03','15:10:00',5.99),('8902','2014-03-03','15:15:00',5.79),('8902','2014-03-03','15:20:00',3.68),('8902','2014-03-03','15:25:00',5.09),('8902','2014-03-03','15:30:00',2.89),('8902','2014-03-03','15:35:00',5.58),('8902','2014-03-03','15:40:00',5.48),('8902','2014-03-03','15:45:00',4.04),('8902','2014-03-03','15:50:00',3.96),('8902','2014-03-03','15:55:00',1.87),('8902','2014-03-03','16:00:00',1.36),('8902','2014-03-03','16:05:00',1.91),('8902','2014-03-03','16:10:00',2.02),('8902','2014-03-03','16:15:00',1.66),('8902','2014-03-03','16:20:00',2.07),('8902','2014-03-03','16:25:00',2.9),('8902','2014-03-03','16:30:00',2.19),('8902','2014-03-03','16:35:00',2),('8902','2014-03-03','16:40:00',2.33),('8902','2014-03-03','16:45:00',2.49),('8902','2014-03-03','16:50:00',2.31),('8902','2014-03-03','16:55:00',1.84),('8902','2014-03-03','17:00:00',1.38),('8902','2014-03-03','17:05:00',1.19),('8902','2014-03-02','07:45:00',1.24),('8902','2014-03-02','07:50:00',1.4),('8902','2014-03-02','07:55:00',1.32),('8902','2014-03-02','08:00:00',1.4),('8902','2014-03-02','08:05:00',1.51),('8902','2014-03-02','08:10:00',2.16),('8902','2014-03-02','08:15:00',2.47),('8902','2014-03-02','08:20:00',2.66),('8902','2014-03-02','08:25:00',2.8),('8902','2014-03-02','08:30:00',2.98),('8902','2014-03-02','08:35:00',3.14),('8902','2014-03-02','08:40:00',3.41),('8902','2014-03-02','08:45:00',3.57),('8902','2014-03-02','08:50:00',3.6),('8902','2014-03-02','08:55:00',4.07),('8902','2014-03-02','09:00:00',4.27),('8902','2014-03-02','09:05:00',4.37),('8902','2014-03-02','09:10:00',4.35),('8902','2014-03-02','09:15:00',4.33),('8902','2014-03-02','09:20:00',4.7),('8902','2014-03-02','09:25:00',4.96),('8902','2014-03-02','09:30:00',4.92),('8902','2014-03-02','09:35:00',4.5),('8902','2014-03-02','09:40:00',4.17),('8902','2014-03-02','09:45:00',4.17),('8902','2014-03-02','09:50:00',4.31),('8902','2014-03-02','09:55:00',5),('8902','2014-03-02','10:00:00',5.59),('8902','2014-03-02','10:05:00',5.95),('8902','2014-03-02','10:10:00',6.08),('8902','2014-03-02','10:15:00',6.14),('8902','2014-03-02','10:20:00',6.26),('8902','2014-03-02','10:25:00',6.39),('8902','2014-03-02','10:30:00',6.46),('8902','2014-03-02','10:35:00',6.55),('8902','2014-03-02','10:40:00',6.59),('8902','2014-03-02','10:45:00',6.65),('8902','2014-03-02','10:50:00',6.71),('8902','2014-03-02','10:55:00',6.8),('8902','2014-03-02','11:00:00',6.93),('8902','2014-03-02','11:05:00',6.97),('8902','2014-03-02','11:10:00',6.98),('8902','2014-03-02','11:15:00',7.06),('8902','2014-03-02','11:20:00',7.1),('8902','2014-03-02','11:25:00',7.22),('8902','2014-03-02','11:30:00',7.22),('8902','2014-03-02','11:35:00',6.11),('8902','2014-03-02','11:40:00',5.07),('8902','2014-03-02','11:45:00',7.69),('8902','2014-03-02','11:50:00',7.68),('8902','2014-03-02','11:55:00',7.75),('8902','2014-03-02','12:00:00',7.71),('8902','2014-03-02','12:05:00',7.74),('8902','2014-03-02','12:10:00',7.81),('8902','2014-03-02','12:15:00',7.78),('8902','2014-03-02','12:20:00',7.8),('8902','2014-03-02','12:25:00',7.82),('8902','2014-03-02','12:30:00',7.8),('8902','2014-03-02','12:35:00',7.82),('8902','2014-03-02','12:40:00',7.81),('8902','2014-03-02','12:45:00',7.75),('8902','2014-03-02','12:50:00',7.74),('8902','2014-03-02','12:55:00',7.7),('8902','2014-03-02','13:00:00',7.7),('8902','2014-03-02','13:05:00',7.66),('8902','2014-03-02','13:10:00',7.64),('8902','2014-03-02','13:15:00',7.55),('8902','2014-03-02','13:20:00',7.54),('8902','2014-03-02','13:25:00',7.53),('8902','2014-03-02','13:30:00',7.5),('8902','2014-03-02','13:35:00',7.49),('8902','2014-03-02','13:40:00',7.43),('8902','2014-03-02','13:45:00',7.38),('8902','2014-03-02','13:50:00',7.33),('8902','2014-03-02','13:55:00',7.28),('8902','2014-03-02','14:00:00',7.21),('8902','2014-03-02','14:05:00',7.14),('8902','2014-03-02','14:10:00',7.16),('8902','2014-03-02','14:15:00',7.18),('8902','2014-03-02','14:20:00',7.04),('8902','2014-03-02','14:25:00',6.54),('8902','2014-03-02','14:30:00',6.61),('8902','2014-03-02','14:35:00',6.75),('8902','2014-03-02','14:40:00',6.57),('8902','2014-03-02','14:45:00',6.46),('8902','2014-03-02','14:50:00',6.31),('8902','2014-03-02','14:55:00',6.18),('8902','2014-03-02','15:00:00',6.04),('8902','2014-03-02','15:05:00',5.89),('8902','2014-03-02','15:10:00',5.8),('8902','2014-03-02','15:15:00',5.68),('8902','2014-03-02','15:20:00',5.56),('8902','2014-03-02','15:25:00',5.43),('8902','2014-03-02','15:30:00',5.21),('8902','2014-03-02','15:35:00',5.06),('8902','2014-03-02','15:40:00',4.9),('8902','2014-03-02','15:45:00',4.75),('8902','2014-03-02','15:50:00',4.49),('8902','2014-03-02','15:55:00',4.3),('8902','2014-03-02','16:00:00',4.12),('8902','2014-03-02','16:05:00',3.94),('8902','2014-03-02','16:10:00',3.76),('8902','2014-03-02','16:15:00',3.62),('8902','2014-03-02','16:20:00',3.46),('8902','2014-03-02','16:25:00',3.22),('8902','2014-03-02','16:30:00',2.94),('8902','2014-03-02','16:35:00',2.74),('8902','2014-03-02','16:40:00',2.55),('8902','2014-03-02','16:45:00',2.43),('8902','2014-03-02','16:50:00',1.49),('8902','2014-03-02','16:55:00',1.61),('8902','2014-03-02','17:00:00',1.89),('8902','2014-03-02','17:05:00',1.66),('8902','2014-03-02','17:10:00',1.02),('8902','2014-03-01','08:00:00',1.5),('8902','2014-03-01','08:05:00',2.07),('8902','2014-03-01','08:10:00',2.69),('8902','2014-03-01','08:15:00',3.07),('8902','2014-03-01','08:20:00',3.18),('8902','2014-03-01','08:25:00',2.85),('8902','2014-03-01','08:30:00',2.84),('8902','2014-03-01','08:35:00',3.08),('8902','2014-03-01','08:40:00',3.33),('8902','2014-03-01','08:45:00',3.57),('8902','2014-03-01','08:50:00',3.78),('8902','2014-03-01','08:55:00',3.99),('8902','2014-03-01','09:00:00',4.17),('8902','2014-03-01','09:05:00',4.42),('8902','2014-03-01','09:10:00',4.68),('8902','2014-03-01','09:15:00',4.84),('8902','2014-03-01','09:20:00',3.98),('8902','2014-03-01','09:25:00',4.74),('8902','2014-03-01','09:30:00',5.6),('8902','2014-03-01','09:35:00',5.69),('8902','2014-03-01','09:40:00',5.52),('8902','2014-03-01','09:45:00',3.14),('8902','2014-03-01','09:50:00',1.27),('8902','2014-03-01','09:55:00',1.69),('8902','2014-03-01','10:00:00',4.09),('8902','2014-03-01','10:05:00',2.97),('8902','2014-03-01','10:10:00',3.08),('8902','2014-03-01','10:15:00',2.29),('8902','2014-03-01','10:20:00',2.28),('8902','2014-03-01','10:25:00',2.46),('8902','2014-03-01','10:30:00',2.72),('8902','2014-03-01','10:35:00',2.79),('8902','2014-03-01','10:40:00',4.58),('8902','2014-03-01','10:45:00',2.36),('8902','2014-03-01','10:50:00',2.25),('8902','2014-03-01','10:55:00',2.32),('8902','2014-03-01','11:00:00',4.17),('8902','2014-03-01','11:05:00',5.9),('8902','2014-03-01','11:10:00',2.97),('8902','2014-03-01','11:15:00',2.42),('8902','2014-03-01','11:20:00',2.8),('8902','2014-03-01','11:25:00',3.76),('8902','2014-03-01','11:30:00',3.78),('8902','2014-03-01','11:35:00',5.47),('8902','2014-03-01','11:40:00',7.65),('8902','2014-03-01','11:45:00',7.02),('8902','2014-03-01','11:50:00',9.32),('8902','2014-03-01','11:55:00',8.86),('8902','2014-03-01','12:00:00',5.16),('8902','2014-03-01','12:05:00',3.56),('8902','2014-03-01','12:10:00',4.01),('8902','2014-03-01','12:15:00',6.8),('8902','2014-03-01','12:20:00',5.05),('8902','2014-03-01','12:25:00',3.63),('8902','2014-03-01','12:30:00',2.73),('8902','2014-03-01','12:35:00',2.23),('8902','2014-03-01','12:40:00',1.94),('8902','2014-03-01','12:45:00',1.92),('8902','2014-03-01','12:50:00',2.12),('8902','2014-03-01','12:55:00',2.46),('8902','2014-03-01','13:00:00',2.82),('8902','2014-03-01','13:05:00',2.91),('8902','2014-03-01','13:10:00',2.93),('8902','2014-03-01','13:15:00',2.93),('8902','2014-03-01','13:20:00',2.78),('8902','2014-03-01','13:25:00',2.43),('8902','2014-03-01','13:30:00',2.13),('8902','2014-03-01','13:35:00',1.76),('8902','2014-03-01','13:40:00',1.62),('8902','2014-03-01','13:45:00',1.5),('8902','2014-03-01','13:50:00',1.58),('8902','2014-03-01','13:55:00',1.85),('8902','2014-03-01','14:00:00',2.38),('8902','2014-03-01','14:05:00',2.62),('8902','2014-03-01','14:10:00',2.54),('8902','2014-03-01','14:15:00',2.44),('8902','2014-03-01','14:20:00',2.32),('8902','2014-03-01','14:25:00',2.34),('8902','2014-03-01','14:30:00',2.47),('8902','2014-03-01','14:35:00',2.46),('8902','2014-03-01','14:40:00',2.52),('8902','2014-03-01','14:45:00',2.61),('8902','2014-03-01','14:50:00',2.57),('8902','2014-03-01','14:55:00',2.53),('8902','2014-03-01','15:00:00',2.66),('8902','2014-03-01','15:05:00',2.9),('8902','2014-03-01','15:10:00',2.86),('8902','2014-03-01','15:15:00',2.76),('8902','2014-03-01','15:20:00',2.93),('8902','2014-03-01','15:25:00',2.98),('8902','2014-03-01','15:30:00',2.77),('8902','2014-03-01','15:35:00',2.99),('8902','2014-03-01','15:40:00',2.72),('8902','2014-03-01','15:45:00',2.48),('8902','2014-03-01','15:50:00',2.22),('8902','2014-03-01','15:55:00',1.88),('8902','2014-03-01','16:00:00',1.66),('8902','2014-03-01','16:05:00',1.51),('8902','2014-03-01','16:10:00',1.31),('8902','2014-03-01','16:15:00',1.13),('8902','2014-03-01','16:20:00',1.06),('8902','2014-02-28','12:40:00',1.03),('8902','2014-02-28','14:40:00',1.04),('8902','2014-02-28','14:45:00',1.28),('8902','2014-02-28','14:50:00',1.32),('8902','2014-02-28','14:55:00',1.16),('8902','2014-02-28','15:00:00',1.07),('8902','2014-02-27','07:45:00',1.02),('8902','2014-02-27','07:50:00',1.24),('8902','2014-02-27','07:55:00',1.55),('8902','2014-02-27','08:00:00',2.08),('8902','2014-02-27','08:05:00',1.7),('8902','2014-02-27','08:10:00',1.54),('8902','2014-02-27','08:15:00',2.01),('8902','2014-02-27','08:20:00',3.13),('8902','2014-02-27','08:25:00',2.76),('8902','2014-02-27','08:30:00',1.11),('8902','2014-02-27','08:35:00',3.48),('8902','2014-02-27','08:40:00',1.99),('8902','2014-02-27','09:10:00',1.36),('8902','2014-02-27','09:15:00',2.23),('8902','2014-02-27','09:20:00',2.33),('8902','2014-02-27','09:25:00',2.53),('8902','2014-02-27','09:30:00',3.51),('8902','2014-02-27','09:35:00',2.35),('8902','2014-02-27','09:40:00',3.68),('8902','2014-02-27','09:45:00',5.84),('8902','2014-02-27','09:50:00',6.64),('8902','2014-02-27','09:55:00',6.29),('8902','2014-02-27','10:00:00',2.83),('8902','2014-02-27','10:05:00',2.22),('8902','2014-02-27','10:10:00',3.7),('8902','2014-02-27','10:15:00',2.47),('8902','2014-02-27','10:20:00',2.77),('8902','2014-02-27','10:25:00',7.13),('8902','2014-02-27','10:30:00',7.45),('8902','2014-02-27','10:35:00',5.94),('8902','2014-02-27','10:40:00',2.91),('8902','2014-02-27','10:45:00',1.54),('8902','2014-02-27','11:00:00',1.06),('8902','2014-02-27','11:05:00',1.34),('8902','2014-02-27','11:10:00',1.24),('8902','2014-02-27','11:15:00',1.62),('8902','2014-02-27','11:20:00',2.37),('8902','2014-02-27','11:25:00',2.45),('8902','2014-02-27','11:30:00',2.08),('8902','2014-02-27','11:35:00',1.54),('8902','2014-02-27','11:40:00',1.29),('8902','2014-02-27','11:45:00',1.64),('8902','2014-02-27','11:50:00',2.21),('8902','2014-02-27','11:55:00',2.27),('8902','2014-02-27','12:00:00',2.78),('8902','2014-02-27','12:05:00',3.97),('8902','2014-02-27','12:10:00',4.37),('8902','2014-02-27','12:15:00',2.59),('8902','2014-02-27','12:20:00',1.99),('8902','2014-02-27','12:25:00',2.43),('8902','2014-02-27','12:30:00',4.35),('8902','2014-02-27','12:35:00',5.27),('8902','2014-02-27','12:40:00',6.53),('8902','2014-02-27','12:45:00',2.25),('8902','2014-02-27','12:50:00',4.75),('8902','2014-02-27','12:55:00',3.67),('8902','2014-02-27','13:00:00',4.82),('8902','2014-02-27','13:05:00',3.82),('8902','2014-02-27','13:10:00',3.18),('8902','2014-02-27','13:15:00',2.18),('8902','2014-02-27','13:20:00',1.15),('8902','2014-02-27','13:45:00',1.62),('8902','2014-02-27','13:50:00',6.72),('8902','2014-02-27','13:55:00',8.78),('8902','2014-02-27','14:00:00',3.79),('8902','2014-02-27','14:05:00',2.16),('8902','2014-02-27','14:10:00',1.7),('8902','2014-02-27','14:15:00',2.51),('8902','2014-02-27','14:20:00',3.74),('8902','2014-02-27','14:25:00',4.3),('8902','2014-02-27','14:30:00',3.41),('8902','2014-02-27','14:35:00',2.85),('8902','2014-02-27','14:40:00',2.48),('8902','2014-02-27','14:45:00',2.49),('8902','2014-02-27','14:50:00',2.65),('8902','2014-02-27','14:55:00',2.93),('8902','2014-02-27','15:00:00',4.39),('8902','2014-02-27','15:05:00',2.36),('8902','2014-02-27','15:10:00',1.22),('8902','2014-02-27','15:20:00',1.05),('8902','2014-02-27','15:25:00',3.77),('8902','2014-02-27','15:30:00',4.58),('8902','2014-02-27','15:35:00',5.47),('8902','2014-02-27','15:40:00',4.59),('8902','2014-02-27','15:45:00',1.4),('8902','2014-02-27','16:10:00',1.86),('8902','2014-02-27','16:15:00',4.36),('8902','2014-02-27','16:20:00',4),('8902','2014-02-27','16:25:00',1.96),('8902','2014-02-27','16:30:00',1.28),('8902','2014-02-27','16:35:00',2.21),('8902','2014-02-27','16:40:00',2.68),('8902','2014-02-27','16:45:00',3.36),('8902','2014-02-27','16:50:00',2.84),('8902','2014-02-27','16:55:00',1.02),('8902','2014-02-26','10:25:00',1.04),('8902','2014-02-26','10:30:00',1.49),('8902','2014-02-26','10:35:00',1.87),('8902','2014-02-26','10:40:00',2.12),('8902','2014-02-26','10:45:00',2.34),('8902','2014-02-26','10:50:00',2.46),('8902','2014-02-26','10:55:00',2.66),('8902','2014-02-26','11:00:00',2.98),('8902','2014-02-26','11:05:00',3.36),('8902','2014-02-26','11:10:00',3.12),('8902','2014-02-26','11:15:00',3.03),('8902','2014-02-26','11:20:00',2.84),('8902','2014-02-26','11:25:00',3.03),('8902','2014-02-26','11:30:00',3.77),('8902','2014-02-26','11:35:00',3.62),('8902','2014-02-26','11:40:00',2.95),('8902','2014-02-26','11:45:00',2.57),('8902','2014-02-26','11:50:00',2.42),('8902','2014-02-26','11:55:00',2.45),('8902','2014-02-26','12:00:00',2.39),('8902','2014-02-26','12:05:00',2.41),('8902','2014-02-26','12:10:00',2.05),('8902','2014-02-26','12:15:00',2.23),('8902','2014-02-26','12:20:00',2.44),('8902','2014-02-26','12:25:00',2.51),('8902','2014-02-26','12:30:00',2.34),('8902','2014-02-26','12:35:00',2.27),('8902','2014-02-26','12:40:00',2.21),('8902','2014-02-26','12:45:00',2.16),('8902','2014-02-26','12:50:00',2.11),('8902','2014-02-26','12:55:00',2.15),('8902','2014-02-26','13:00:00',2.27),('8902','2014-02-26','13:05:00',2.08),('8902','2014-02-26','13:10:00',2.14),('8902','2014-02-26','13:15:00',2.43),('8902','2014-02-26','13:20:00',2.44),('8902','2014-02-26','13:25:00',2.6),('8902','2014-02-26','13:30:00',2.96),('8902','2014-02-26','13:35:00',3.25),('8902','2014-02-26','13:40:00',3.29),('8902','2014-02-26','13:45:00',3.3),('8902','2014-02-26','13:50:00',3.4),('8902','2014-02-26','13:55:00',3.95),('8902','2014-02-26','14:00:00',3.85),('8902','2014-02-26','14:05:00',3.47),('8902','2014-02-26','14:10:00',3.02),('8902','2014-02-26','14:15:00',2.75),('8902','2014-02-26','14:20:00',2.79),('8902','2014-02-26','14:25:00',2.85),('8902','2014-02-26','14:30:00',3.12),('8902','2014-02-26','14:35:00',3.05),('8902','2014-02-26','14:40:00',2.68),('8902','2014-02-26','14:45:00',2.65),('8902','2014-02-26','14:50:00',2.45),('8902','2014-02-26','14:55:00',2.25),('8902','2014-02-26','15:00:00',2.34),('8902','2014-02-26','15:05:00',2.14),('8902','2014-02-26','15:10:00',2.26),('8902','2014-02-26','15:15:00',2.7),('8902','2014-02-26','15:20:00',3.02),('8902','2014-02-26','15:25:00',2.67),('8902','2014-02-26','15:30:00',2.63),('8902','2014-02-26','15:35:00',2.77),('8902','2014-02-26','15:40:00',2.44),('8902','2014-02-26','15:45:00',1.77),('8902','2014-02-26','15:50:00',1.59),('8902','2014-02-26','15:55:00',1.3),('8902','2014-02-26','16:00:00',1.29),('8902','2014-02-26','16:05:00',1.31),('8902','2014-02-26','16:10:00',1.16),('8902','2014-02-26','16:30:00',1.01),('8902','2014-02-26','16:35:00',1.39),('8902','2014-02-26','16:40:00',2.26),('8902','2014-02-26','16:45:00',1.71),('8902','2014-02-26','16:50:00',2.14),('8902','2014-02-26','16:55:00',2.19),('8902','2014-02-26','17:00:00',1.93),('8902','2014-02-26','17:05:00',1.5),('8902','2014-02-26','17:10:00',1.08),('8902','2014-02-25','08:00:00',1.19),('8902','2014-02-25','08:05:00',1.33),('8902','2014-02-25','08:10:00',1.75),('8902','2014-02-25','08:15:00',2.17),('8902','2014-02-25','08:20:00',2.36),('8902','2014-02-25','08:25:00',2.55),('8902','2014-02-25','08:30:00',2.68),('8902','2014-02-25','08:35:00',2.94),('8902','2014-02-25','08:40:00',3.14),('8902','2014-02-25','08:45:00',3.55),('8902','2014-02-25','08:50:00',3.6),('8902','2014-02-25','08:55:00',3.6),('8902','2014-02-25','09:00:00',3.79),('8902','2014-02-25','09:05:00',3.89),('8902','2014-02-25','09:10:00',3.9),('8902','2014-02-25','09:15:00',4.35),('8902','2014-02-25','09:20:00',4.5),('8902','2014-02-25','09:25:00',4.81),('8902','2014-02-25','09:30:00',4.58),('8902','2014-02-25','09:35:00',4.78),('8902','2014-02-25','09:40:00',3.28),('8902','2014-02-25','09:45:00',4.75),('8902','2014-02-25','09:50:00',5.02),('8902','2014-02-25','09:55:00',2.68),('8902','2014-02-25','10:00:00',2.69),('8902','2014-02-25','10:05:00',2.22),('8902','2014-02-25','10:10:00',1.68),('8902','2014-02-25','10:15:00',1.57),('8902','2014-02-25','10:20:00',1.98),('8902','2014-02-25','10:25:00',2),('8902','2014-02-25','10:30:00',2.01),('8902','2014-02-25','10:35:00',1.84),('8902','2014-02-25','10:40:00',1.53),('8902','2014-02-25','10:45:00',1.29),('8902','2014-02-25','10:50:00',1.17),('8902','2014-02-25','10:55:00',1.43),('8902','2014-02-25','11:00:00',1.75),('8902','2014-02-25','11:05:00',2),('8902','2014-02-25','11:10:00',1.99),('8902','2014-02-25','11:15:00',1.96),('8902','2014-02-25','11:20:00',1.48),('8902','2014-02-25','11:25:00',1.12),('8902','2014-02-25','11:30:00',1.15),('8902','2014-02-25','11:35:00',1.34),('8902','2014-02-25','11:40:00',1.35),('8902','2014-02-25','11:45:00',1.25),('8902','2014-02-25','11:50:00',1.56),('8902','2014-02-25','11:55:00',1.67),('8902','2014-02-25','12:00:00',2.12),('8902','2014-02-25','12:05:00',3.18),('8902','2014-02-25','12:10:00',5.43),('8902','2014-02-25','12:15:00',2.54),('8902','2014-02-25','12:20:00',2.16),('8902','2014-02-25','12:25:00',2.25),('8902','2014-02-25','12:30:00',4.16),('8902','2014-02-25','12:35:00',3.42),('8902','2014-02-25','12:40:00',3.45),('8902','2014-02-25','12:45:00',5.54),('8902','2014-02-25','12:50:00',5.55),('8902','2014-02-25','12:55:00',3.77),('8902','2014-02-25','13:00:00',4.08),('8902','2014-02-25','13:05:00',6.72),('8902','2014-02-25','13:10:00',6.36),('8902','2014-02-25','13:15:00',6.14),('8902','2014-02-25','13:20:00',6.56),('8902','2014-02-25','13:25:00',6.44),('8902','2014-02-25','13:30:00',7.8),('8902','2014-02-25','13:35:00',7.39),('8902','2014-02-25','13:40:00',6.96),('8902','2014-02-25','13:45:00',7.1),('8902','2014-02-25','13:50:00',4.77),('8902','2014-02-25','13:55:00',2.76),('8902','2014-02-25','14:00:00',7.02),('8902','2014-02-25','14:05:00',7.33),('8902','2014-02-25','14:10:00',2.97),('8902','2014-02-25','14:15:00',4.71),('8902','2014-02-25','14:20:00',6.42),('8902','2014-02-25','14:25:00',7.27),('8902','2014-02-25','14:30:00',4.13),('8902','2014-02-25','14:35:00',2.92),('8902','2014-02-25','14:40:00',6.41),('8902','2014-02-25','14:45:00',6.59),('8902','2014-02-25','14:50:00',4.01),('8902','2014-02-25','14:55:00',5.96),('8902','2014-02-25','15:00:00',6.18),('8902','2014-02-25','15:05:00',5.65),('8902','2014-02-25','15:10:00',5.57),('8902','2014-02-25','15:15:00',4.78),('8902','2014-02-25','15:20:00',4.16),('8902','2014-02-25','15:25:00',2.5),('8902','2014-02-25','15:30:00',2.65),('8902','2014-02-25','15:35:00',3.73),('8902','2014-02-25','15:40:00',3.56),('8902','2014-02-25','15:45:00',2.98),('8902','2014-02-25','15:50:00',2.57),('8902','2014-02-25','15:55:00',3.39),('8902','2014-02-25','16:00:00',3.89),('8902','2014-02-25','16:05:00',3.7),('8902','2014-02-25','16:10:00',2.61),('8902','2014-02-25','16:15:00',1.56),('8902','2014-02-25','16:20:00',1.88),('8902','2014-02-25','16:25:00',1.35),('8902','2014-04-28','09:40:00',1.03),('8902','2014-04-28','09:45:00',1.42),('8902','2014-04-28','09:50:00',1.9),('8902','2014-04-28','09:55:00',2.12),('8902','2014-04-28','10:00:00',2.11),('8902','2014-04-28','10:05:00',3.24),('8902','2014-04-28','10:10:00',5.21),('8902','2014-04-28','10:15:00',5.85),('8902','2014-04-28','10:20:00',6.16),('8902','2014-04-28','10:25:00',6.45),('8902','2014-04-28','10:30:00',7.44),('8902','2014-04-28','10:35:00',7.3),('8902','2014-04-28','10:40:00',7.35),('8902','2014-04-28','10:45:00',7.41),('8902','2014-04-28','10:50:00',7.57),('8902','2014-04-28','10:55:00',7.33),('8902','2014-04-28','11:00:00',7.46),('8902','2014-04-28','11:05:00',7.47),('8902','2014-04-28','11:10:00',7.87),('8902','2014-04-28','11:15:00',7.13),('8902','2014-04-28','11:20:00',7.24),('8902','2014-04-28','11:25:00',6.23),('8902','2014-04-28','11:30:00',7.87),('8902','2014-04-28','11:35:00',7.33),('8902','2014-04-28','11:40:00',7.34),('8902','2014-04-28','11:45:00',7.67),('8902','2014-04-28','11:50:00',2.96),('8902','2014-04-28','11:55:00',2.42),('8902','2014-04-28','12:00:00',2.5),('8902','2014-04-28','12:05:00',4.02),('8902','2014-04-28','12:10:00',4.67),('8902','2014-04-28','12:15:00',8.59),('8902','2014-04-28','12:20:00',3.73),('8902','2014-04-28','12:25:00',5.57),('8902','2014-04-28','12:30:00',6.24),('8902','2014-04-28','12:35:00',5.6),('8902','2014-04-28','12:40:00',7.39),('8902','2014-04-28','12:45:00',5.96),('8902','2014-04-28','12:50:00',10),('8902','2014-04-28','12:55:00',6.29),('8902','2014-04-28','13:00:00',4.02),('8902','2014-04-28','13:05:00',3.51),('8902','2014-04-28','13:10:00',3.31),('8902','2014-04-28','13:15:00',4.15),('8902','2014-04-28','13:20:00',8.41),('8902','2014-04-28','13:25:00',8.23),('8902','2014-04-28','13:30:00',4.81),('8902','2014-04-28','13:35:00',4.29),('8902','2014-04-28','13:40:00',2.68),('8902','2014-04-28','13:45:00',2.65),('8902','2014-04-28','13:50:00',2.81),('8902','2014-04-28','13:55:00',2.83),('8902','2014-04-28','14:00:00',1.29),('8902','2014-04-28','14:25:00',1.19),('8902','2014-04-28','14:30:00',1.21),('8902','2014-04-28','14:35:00',1.32),('8902','2014-04-28','14:40:00',1.44),('8902','2014-04-28','14:45:00',1.23),('8902','2014-04-28','15:00:00',1.53),('8902','2014-04-28','15:05:00',2.4),('8902','2014-04-28','15:10:00',1.67),('8902','2014-04-28','15:30:00',1.16),('8902','2014-04-28','15:35:00',1.15),('8902','2014-04-28','16:05:00',1.13),('8902','2014-04-28','16:10:00',1.37),('8902','2014-04-28','16:15:00',1.75),('8902','2014-04-28','16:20:00',2.06),('8902','2014-04-28','16:25:00',2.36),('8902','2014-04-28','16:30:00',2.05),('8902','2014-04-28','16:35:00',1.71),('8902','2014-04-28','16:40:00',1.42),('8902','2014-04-28','16:45:00',1.29),('8902','2014-04-28','16:50:00',1.39),('8902','2014-04-28','16:55:00',1.6),('8902','2014-04-28','17:00:00',1.83),('8902','2014-04-28','17:05:00',2.35),('8902','2014-04-28','17:10:00',2.38),('8902','2014-04-28','17:15:00',1.82),('8902','2014-04-28','17:20:00',1.72),('8902','2014-04-28','17:25:00',3.51),('8902','2014-04-28','17:30:00',3.25),('8902','2014-04-28','17:35:00',3.77),('8902','2014-04-28','17:40:00',3.63),('8902','2014-04-28','17:45:00',3.83),('8902','2014-04-28','17:50:00',2.19),('8902','2014-04-28','18:00:00',1.19),('8902','2014-04-28','18:05:00',1.45),('8902','2014-04-28','18:10:00',1.05),('8902','2014-02-24','07:55:00',1.1),('8902','2014-02-24','08:00:00',1.42),('8902','2014-02-24','08:05:00',1.6),('8902','2014-02-24','08:10:00',1.79),('8902','2014-02-24','08:15:00',2.01),('8902','2014-02-24','08:20:00',2.2),('8902','2014-02-24','08:25:00',2.39),('8902','2014-02-24','08:30:00',2.6),('8902','2014-02-24','08:35:00',2.79),('8902','2014-02-24','08:40:00',2.95),('8902','2014-02-24','08:45:00',3.12),('8902','2014-02-24','08:50:00',3.31),('8902','2014-02-24','08:55:00',3.49),('8902','2014-02-24','09:00:00',3.68),('8902','2014-02-24','09:05:00',3.86),('8902','2014-02-24','09:10:00',4.04),('8902','2014-02-24','09:15:00',4.21),('8902','2014-02-24','09:20:00',4.37),('8902','2014-02-24','09:25:00',4.51),('8902','2014-02-24','09:30:00',4.65),('8902','2014-02-24','09:35:00',4.78),('8902','2014-02-24','09:40:00',4.93),('8902','2014-02-24','09:45:00',5.05),('8902','2014-02-24','09:50:00',5.19),('8902','2014-02-24','09:55:00',5.32),('8902','2014-02-24','10:00:00',5.41),('8902','2014-02-24','10:05:00',5.52),('8902','2014-02-24','10:10:00',5.64),('8902','2014-02-24','10:15:00',5.76),('8902','2014-02-24','10:20:00',5.89),('8902','2014-02-24','10:25:00',5.96),('8902','2014-02-24','10:30:00',6.04),('8902','2014-02-24','10:35:00',6.1),('8902','2014-02-24','10:40:00',6.22),('8902','2014-02-24','10:45:00',6.27),('8902','2014-02-24','10:50:00',6.32),('8902','2014-02-24','10:55:00',6.38),('8902','2014-02-24','11:00:00',6.47),('8902','2014-02-24','11:05:00',6.51),('8902','2014-02-24','11:10:00',6.59),('8902','2014-02-24','11:15:00',6.67),('8902','2014-02-24','11:20:00',6.75),('8902','2014-02-24','11:25:00',6.78),('8902','2014-02-24','11:30:00',6.78),('8902','2014-02-24','11:35:00',6.81),('8902','2014-02-24','11:40:00',6.92),('8902','2014-02-24','11:45:00',6.85),('8902','2014-02-24','11:50:00',6.96),('8902','2014-02-24','11:55:00',7.01),('8902','2014-02-24','12:00:00',7),('8902','2014-02-24','12:05:00',7.09),('8902','2014-02-24','12:10:00',7.09),('8902','2014-02-24','12:15:00',7.14),('8902','2014-02-24','12:20:00',7.09),('8902','2014-02-24','12:25:00',6.98),('8902','2014-02-24','12:30:00',6.94),('8902','2014-02-24','12:35:00',7.02),('8902','2014-02-24','12:40:00',7.07),('8902','2014-02-24','12:45:00',7.16),('8902','2014-02-24','12:50:00',7.31),('8902','2014-02-24','12:55:00',7.24),('8902','2014-02-24','13:00:00',7.01),('8902','2014-02-24','13:05:00',7.04),('8902','2014-02-24','13:10:00',7.15),('8902','2014-02-24','13:15:00',6.24),('8902','2014-02-24','13:20:00',3.8),('8902','2014-02-24','13:25:00',2.37),('8902','2014-02-24','13:30:00',1.72),('8902','2014-02-24','13:35:00',2.05),('8902','2014-02-24','13:40:00',3.01),('8902','2014-02-24','13:45:00',2.14),('8902','2014-02-24','13:50:00',1.96),('8902','2014-02-24','13:55:00',2.36),('8902','2014-02-24','14:00:00',2.61),('8902','2014-02-24','14:05:00',2.44),('8902','2014-02-24','14:10:00',1.99),('8902','2014-02-24','14:15:00',2.21),('8902','2014-02-24','14:20:00',2.32),('8902','2014-02-24','14:25:00',2.66),('8902','2014-02-24','14:30:00',2.92),('8902','2014-02-24','14:35:00',5.19),('8902','2014-02-24','14:40:00',5.51),('8902','2014-02-24','14:45:00',4.83),('8902','2014-02-24','14:50:00',6.08),('8902','2014-02-24','14:55:00',4.82),('8902','2014-02-24','15:00:00',5.4),('8902','2014-02-24','15:05:00',5.17),('8902','2014-02-24','15:10:00',5.21),('8902','2014-02-24','15:15:00',5.03),('8902','2014-02-24','15:20:00',4.87),('8902','2014-02-24','15:25:00',4.26),('8902','2014-02-24','15:30:00',3.78),('8902','2014-02-24','15:35:00',3.47),('8902','2014-02-24','15:40:00',3.89),('8902','2014-02-24','15:45:00',2.77),('8902','2014-02-24','15:50:00',2),('8902','2014-02-24','15:55:00',2.37),('8902','2014-02-24','16:00:00',2.11),('8902','2014-02-24','16:05:00',2.3),('8902','2014-02-24','16:10:00',2.21),('8902','2014-02-24','16:15:00',2.41),('8902','2014-02-24','16:20:00',2.6),('8902','2014-02-24','16:25:00',2.09),('8902','2014-02-24','16:30:00',1.09),('8902','2014-02-23','07:55:00',1.2),('8902','2014-02-23','08:00:00',1.46),('8902','2014-02-23','08:05:00',1.82),('8902','2014-02-23','08:10:00',2.15),('8902','2014-02-23','08:15:00',2.44),('8902','2014-02-23','08:20:00',2.66),('8902','2014-02-23','08:25:00',2.94),('8902','2014-02-23','08:30:00',3.22),('8902','2014-02-23','08:35:00',3.43),('8902','2014-02-23','08:40:00',3.68),('8902','2014-02-23','08:45:00',3.75),('8902','2014-02-23','08:50:00',3.62),('8902','2014-02-23','08:55:00',3.57),('8902','2014-02-23','09:00:00',3.65),('8902','2014-02-23','09:05:00',3.8),('8902','2014-02-23','09:10:00',4),('8902','2014-02-23','09:15:00',4.2),('8902','2014-02-23','09:20:00',4.35),('8902','2014-02-23','09:25:00',4.55),('8902','2014-02-23','09:30:00',4.7),('8902','2014-02-23','09:35:00',4.81),('8902','2014-02-23','09:40:00',4.96),('8902','2014-02-23','09:45:00',5.12),('8902','2014-02-23','09:50:00',5.25),('8902','2014-02-23','09:55:00',5.37),('8902','2014-02-23','10:00:00',5.49),('8902','2014-02-23','10:05:00',5.63),('8902','2014-02-23','10:10:00',5.74),('8902','2014-02-23','10:15:00',5.87),('8902','2014-02-23','10:20:00',5.97),('8902','2014-02-23','10:25:00',6.07),('8902','2014-02-23','10:30:00',6.18),('8902','2014-02-23','10:35:00',6.25),('8902','2014-02-23','10:40:00',6.34),('8902','2014-02-23','10:45:00',6.45),('8902','2014-02-23','10:50:00',6.53),('8902','2014-02-23','10:55:00',6.59),('8902','2014-02-23','11:00:00',6.65),('8902','2014-02-23','11:05:00',6.77),('8902','2014-02-23','11:10:00',6.86),('8902','2014-02-23','11:15:00',6.86),('8902','2014-02-23','11:20:00',6.91),('8902','2014-02-23','11:25:00',7.2),('8902','2014-02-23','11:30:00',7.71),('8902','2014-02-23','11:35:00',5.77),('8902','2014-02-23','11:40:00',7.53),('8902','2014-02-23','11:45:00',8.23),('8902','2014-02-23','11:50:00',6.29),('8902','2014-02-23','11:55:00',5.79),('8902','2014-02-23','12:00:00',6.45),('8902','2014-02-23','12:05:00',4.91),('8902','2014-02-23','12:10:00',6.62),('8902','2014-02-23','12:15:00',6.58),('8902','2014-02-23','12:20:00',6.54),('8902','2014-02-23','12:25:00',7.75),('8902','2014-02-23','12:30:00',7.15),('8902','2014-02-23','12:35:00',2.95),('8902','2014-02-23','12:40:00',6.4),('8902','2014-02-23','12:45:00',6.76),('8902','2014-02-23','12:50:00',7.77),('8902','2014-02-23','12:55:00',7.61),('8902','2014-02-23','13:00:00',7.61),('8902','2014-02-23','13:05:00',7.84),('8902','2014-02-23','13:10:00',8.16),('8902','2014-02-23','13:15:00',8.96),('8902','2014-02-23','13:20:00',3.75),('8902','2014-02-23','13:25:00',2.1),('8902','2014-02-23','13:30:00',1.89),('8902','2014-02-23','13:35:00',1.72),('8902','2014-02-23','13:40:00',1.62),('8902','2014-02-23','13:45:00',1.51),('8902','2014-02-23','13:50:00',1.44),('8902','2014-02-23','13:55:00',1.53),('8902','2014-02-23','14:00:00',1.66),('8902','2014-02-23','14:05:00',1.74),('8902','2014-02-23','14:10:00',1.84),('8902','2014-02-23','14:15:00',1.85),('8902','2014-02-23','14:20:00',1.82),('8902','2014-02-23','14:25:00',1.88),('8902','2014-02-23','14:30:00',2),('8902','2014-02-23','14:35:00',1.98),('8902','2014-02-23','14:40:00',2.01),('8902','2014-02-23','14:45:00',2.17),('8902','2014-02-23','14:50:00',1.97),('8902','2014-02-23','14:55:00',1.63),('8902','2014-02-23','15:00:00',1.57),('8902','2014-02-23','15:05:00',1.7),('8902','2014-02-23','15:10:00',1.86),('8902','2014-02-23','15:15:00',1.93),('8902','2014-02-23','15:20:00',2.27),('8902','2014-02-23','15:25:00',2.9),('8902','2014-02-23','15:30:00',3.41),('8902','2014-02-23','15:35:00',5.36),('8902','2014-02-23','15:40:00',5.73),('8902','2014-02-23','15:45:00',5.44),('8902','2014-02-23','15:50:00',5.09),('8902','2014-02-23','15:55:00',3.91),('8902','2014-02-23','16:00:00',4.5),('8902','2014-02-23','16:05:00',4.63),('8902','2014-02-23','16:10:00',4.27),('8902','2014-02-23','16:15:00',3.99),('8902','2014-02-23','16:20:00',3.42),('8902','2014-02-23','16:25:00',2.57),('8902','2014-02-23','16:30:00',1.48),('8902','2014-02-23','16:35:00',1.1),('8902','2014-02-23','16:45:00',1.63),('8902','2014-02-23','16:50:00',1.73),('8902','2014-02-23','16:55:00',1.51),('8902','2014-02-23','17:00:00',1.23),('8902','2014-02-23','17:05:00',1.1),('8902','2014-02-22','07:55:00',1.03),('8902','2014-02-22','08:00:00',1.29),('8902','2014-02-22','08:05:00',1.52),('8902','2014-02-22','08:10:00',1.72),('8902','2014-02-22','08:15:00',1.93),('8902','2014-02-22','08:20:00',2.12),('8902','2014-02-22','08:25:00',2.27),('8902','2014-02-22','08:30:00',2.49),('8902','2014-02-22','08:35:00',2.66),('8902','2014-02-22','08:40:00',2.83),('8902','2014-02-22','08:45:00',3.01),('8902','2014-02-22','08:50:00',3.19),('8902','2014-02-22','08:55:00',3.39),('8902','2014-02-22','09:00:00',3.59),('8902','2014-02-22','09:05:00',3.81),('8902','2014-02-22','09:10:00',4.02),('8902','2014-02-22','09:15:00',4.24),('8902','2014-02-22','09:20:00',4.42),('8902','2014-02-22','09:25:00',4.44),('8902','2014-02-22','09:30:00',4.2),('8902','2014-02-22','09:35:00',4.8),('8902','2014-02-22','09:40:00',4.92),('8902','2014-02-22','09:45:00',5.05),('8902','2014-02-22','09:50:00',5.13),('8902','2014-02-22','09:55:00',5.25),('8902','2014-02-22','10:00:00',5.33),('8902','2014-02-22','10:05:00',5.47),('8902','2014-02-22','10:10:00',5.56),('8902','2014-02-22','10:15:00',5.64),('8902','2014-02-22','10:20:00',5.81),('8902','2014-02-22','10:25:00',5.94),('8902','2014-02-22','10:30:00',6.04),('8902','2014-02-22','10:35:00',6.12),('8902','2014-02-22','10:40:00',6.26),('8902','2014-02-22','10:45:00',6.38),('8902','2014-02-22','10:50:00',6.38),('8902','2014-02-22','10:55:00',5.62),('8902','2014-02-22','11:00:00',6.14),('8902','2014-02-22','11:05:00',6.57),('8902','2014-02-22','11:10:00',6.83),('8902','2014-02-22','11:15:00',6.87),('8902','2014-02-22','11:20:00',6.84),('8902','2014-02-22','11:25:00',6.88),('8902','2014-02-22','11:30:00',7.21),('8902','2014-02-22','11:35:00',7.21),('8902','2014-02-22','11:40:00',7.39),('8902','2014-02-22','11:45:00',7.36),('8902','2014-02-22','11:50:00',6.83),('8902','2014-02-22','11:55:00',6.61),('8902','2014-02-22','12:00:00',6.07),('8902','2014-02-22','12:05:00',7.65),('8902','2014-02-22','12:10:00',6.78),('8902','2014-02-22','12:15:00',7.93),('8902','2014-02-22','12:20:00',7.52),('8902','2014-02-22','12:25:00',4.81),('8902','2014-02-22','12:30:00',5.19),('8902','2014-02-22','12:35:00',8.23),('8902','2014-02-22','12:40:00',4.99),('8902','2014-02-22','12:45:00',4.56),('8902','2014-02-22','12:50:00',3.55),('8902','2014-02-22','12:55:00',4.32),('8902','2014-02-22','13:00:00',4.72),('8902','2014-02-22','13:05:00',7.42),('8902','2014-02-22','13:10:00',7.52),('8902','2014-02-22','13:15:00',7.34),('8902','2014-02-22','13:20:00',7.3),('8902','2014-02-22','13:25:00',7.32),('8902','2014-02-22','13:30:00',7.14),('8902','2014-02-22','13:35:00',3.03),('8902','2014-02-22','13:40:00',6.86),('8902','2014-02-22','13:45:00',6.47),('8902','2014-02-22','13:50:00',5.85),('8902','2014-02-22','13:55:00',2.73),('8902','2014-02-22','14:00:00',6.24),('8902','2014-02-22','14:05:00',6.49),('8902','2014-02-22','14:10:00',6.99),('8902','2014-02-22','14:15:00',5.54),('8902','2014-02-22','14:20:00',3.71),('8902','2014-02-22','14:25:00',5.09),('8902','2014-02-22','14:30:00',6.04),('8902','2014-02-22','14:35:00',4.39),('8902','2014-02-22','14:40:00',2.39),('8902','2014-02-22','14:45:00',2.91),('8902','2014-02-22','14:50:00',1.95),('8902','2014-02-22','14:55:00',1.37),('8902','2014-02-22','15:00:00',1.2),('8902','2014-02-21','08:40:00',1.26),('8902','2014-02-21','08:45:00',1.01),('8902','2014-02-21','09:05:00',1.61),('8902','2014-02-21','09:10:00',2.16),('8902','2014-02-21','09:15:00',1.07),('8902','2014-02-21','09:20:00',1.16),('8902','2014-02-21','09:25:00',1.52),('8902','2014-02-21','09:30:00',1.48),('8902','2014-02-21','09:35:00',1.58),('8902','2014-02-21','09:40:00',1.64),('8902','2014-02-21','09:45:00',1.61),('8902','2014-02-21','09:50:00',1.84),('8902','2014-02-21','09:55:00',1.87),('8902','2014-02-21','10:00:00',2.58),('8902','2014-02-21','10:05:00',4.87),('8902','2014-02-21','10:10:00',3.65),('8902','2014-02-21','10:15:00',4.46),('8902','2014-02-21','10:20:00',2.52),('8902','2014-02-21','10:25:00',3.33),('8902','2014-02-21','10:30:00',6.05),('8902','2014-02-21','10:35:00',3.26),('8902','2014-02-21','10:40:00',3.19),('8902','2014-02-21','10:45:00',5.44),('8902','2014-02-21','10:50:00',7.35),('8902','2014-02-21','10:55:00',2.71),('8902','2014-02-21','11:00:00',1.54),('8902','2014-02-21','11:05:00',1.13),('8902','2014-02-21','11:10:00',1.62),('8902','2014-02-21','11:15:00',1.53),('8902','2014-02-21','11:20:00',1.02),('8902','2014-02-21','11:50:00',1.06),('8902','2014-02-21','11:55:00',1.48),('8902','2014-02-21','12:00:00',1.98),('8902','2014-02-21','12:05:00',2.32),('8902','2014-02-21','12:10:00',2.82),('8902','2014-02-21','12:15:00',4.45),('8902','2014-02-21','12:20:00',3.46),('8902','2014-02-21','12:25:00',3.74),('8902','2014-02-21','12:30:00',2.12),('8902','2014-02-21','12:35:00',2.14),('8902','2014-02-21','12:40:00',2.45),('8902','2014-02-21','12:45:00',7.13),('8902','2014-02-21','12:50:00',6.36),('8902','2014-02-21','12:55:00',2.96),('8902','2014-02-21','13:00:00',2.77),('8902','2014-02-21','13:05:00',3.36),('8902','2014-02-21','13:10:00',7.91),('8902','2014-02-21','13:15:00',5.52),('8902','2014-02-21','13:20:00',3.03),('8902','2014-02-21','13:25:00',2.16),('8902','2014-02-21','13:30:00',2.23),('8902','2014-02-21','13:35:00',2.85),('8902','2014-02-21','13:40:00',4.76),('8902','2014-02-21','13:45:00',3.29),('8902','2014-02-21','13:50:00',2.53),('8902','2014-02-21','13:55:00',6.87),('8902','2014-02-21','14:00:00',7.48),('8902','2014-02-21','14:05:00',5.81),('8902','2014-02-21','14:10:00',6.42),('8902','2014-02-21','14:15:00',5.08),('8902','2014-02-21','14:20:00',6.81),('8902','2014-02-21','14:25:00',6.12),('8902','2014-02-21','14:30:00',5.95),('8902','2014-02-21','14:35:00',2.05),('8902','2014-02-21','14:40:00',5.28),('8902','2014-02-21','14:45:00',6.57),('8902','2014-02-21','14:50:00',6.52),('8902','2014-02-21','14:55:00',1.75),('8902','2014-02-21','15:00:00',3.15),('8902','2014-02-21','15:05:00',4.17),('8902','2014-02-21','15:10:00',3.44),('8902','2014-02-21','15:15:00',2.65),('8902','2014-02-21','15:20:00',3.35),('8902','2014-02-21','15:25:00',3.48),('8902','2014-02-21','15:30:00',4.45),('8902','2014-02-21','15:35:00',4.99),('8902','2014-02-21','15:40:00',1.27),('8902','2014-02-21','15:45:00',3.99),('8902','2014-02-21','15:50:00',4.2),('8902','2014-02-21','15:55:00',3.68),('8902','2014-02-21','16:00:00',3.82),('8902','2014-02-21','16:05:00',2.53),('8902','2014-02-21','16:10:00',2.3),('8902','2014-02-21','16:15:00',3.23),('8902','2014-02-21','16:20:00',2.97),('8902','2014-02-21','16:25:00',2.72),('8902','2014-02-21','16:30:00',2.42),('8902','2014-02-21','16:35:00',2.27),('8902','2014-02-21','16:40:00',2.01),('8902','2014-02-21','16:45:00',1.9),('8902','2014-02-21','16:50:00',1.63),('8902','2014-02-21','16:55:00',1.15),('8902','2014-02-21','17:00:00',1.12),('8902','2014-02-20','08:30:00',1.09),('8902','2014-02-20','08:35:00',1.17),('8902','2014-02-20','08:40:00',1.26),('8902','2014-02-20','08:45:00',1.36),('8902','2014-02-20','08:50:00',1.4),('8902','2014-02-20','08:55:00',1.46),('8902','2014-02-20','09:00:00',1.41),('8902','2014-02-20','09:05:00',1.38),('8902','2014-02-20','09:10:00',1.44),('8902','2014-02-20','09:15:00',1.45),('8902','2014-02-20','09:20:00',1.6),('8902','2014-02-20','09:25:00',1.7),('8902','2014-02-20','09:30:00',1.71),('8902','2014-02-20','09:35:00',1.94),('8902','2014-02-20','09:40:00',1.95),('8902','2014-02-20','09:45:00',2.1),('8902','2014-02-20','09:50:00',2.38),('8902','2014-02-20','09:55:00',2.39),('8902','2014-02-20','10:00:00',2.38),('8902','2014-02-20','10:05:00',2.7),('8902','2014-02-20','10:10:00',2.71),('8902','2014-02-20','10:15:00',2.85),('8902','2014-02-20','10:20:00',3.8),('8902','2014-02-20','10:25:00',4.75),('8902','2014-02-20','10:30:00',5.51),('8902','2014-02-20','10:35:00',4.4),('8902','2014-02-20','10:40:00',3.7),('8902','2014-02-20','10:45:00',3.56),('8902','2014-02-20','10:50:00',2.89),('8902','2014-02-20','10:55:00',4.18),('8902','2014-02-20','11:00:00',3.73),('8902','2014-02-20','11:05:00',2.88),('8902','2014-02-20','11:10:00',2.84),('8902','2014-02-20','11:15:00',3.22),('8902','2014-02-20','11:20:00',3.27),('8902','2014-02-20','11:25:00',4.56),('8902','2014-02-20','11:30:00',7.58),('8902','2014-02-20','11:35:00',5.45),('8902','2014-02-20','11:40:00',5.79),('8902','2014-02-20','11:45:00',6.94),('8902','2014-02-20','11:50:00',3.44),('8902','2014-02-20','11:55:00',7.87),('8902','2014-02-20','12:00:00',8.51),('8902','2014-02-20','12:05:00',8.21),('8902','2014-02-20','12:10:00',6.66),('8902','2014-02-20','12:15:00',2.89),('8902','2014-02-20','12:20:00',2.59),('8902','2014-02-20','12:25:00',2.82),('8902','2014-02-20','12:30:00',2.71),('8902','2014-02-20','12:35:00',2.36),('8902','2014-02-20','12:40:00',2.07),('8902','2014-02-20','12:45:00',1.65),('8902','2014-02-20','12:50:00',1.57),('8902','2014-02-20','12:55:00',1.45),('8902','2014-02-20','13:00:00',1.13),('8902','2014-02-20','13:50:00',1.02),('8902','2014-02-20','13:55:00',1.04),('8902','2014-02-20','14:05:00',1.02),('8902','2014-02-20','14:10:00',1.12),('8902','2014-02-20','14:15:00',1.25),('8902','2014-02-20','14:20:00',1.37),('8902','2014-02-20','14:25:00',1.38),('8902','2014-02-20','14:30:00',1.37),('8902','2014-02-20','14:35:00',1.3),('8902','2014-02-20','14:40:00',1.43),('8902','2014-02-20','14:45:00',1.61),('8902','2014-02-20','14:50:00',1.56),('8902','2014-02-20','14:55:00',1.74),('8902','2014-02-20','15:00:00',1.77),('8902','2014-02-20','15:05:00',3.7),('8902','2014-02-20','15:10:00',1.56),('8902','2014-02-20','15:15:00',1.2),('8902','2014-02-20','15:20:00',1.93),('8902','2014-02-20','15:25:00',2.69),('8902','2014-02-20','15:30:00',4.63),('8902','2014-02-20','15:35:00',4.35),('8902','2014-02-20','15:40:00',4.11),('8902','2014-02-20','15:45:00',4.02),('8902','2014-02-20','15:50:00',3.76),('8902','2014-02-20','15:55:00',3.5),('8902','2014-02-20','16:00:00',3.34),('8902','2014-02-20','16:05:00',3.14),('8902','2014-02-20','16:10:00',2.94),('8902','2014-02-20','16:15:00',2.74),('8902','2014-02-20','16:20:00',2.55),('8902','2014-02-20','16:25:00',2.31),('8902','2014-02-20','16:30:00',2.11),('8902','2014-02-20','16:35:00',1.93),('8902','2014-02-20','16:40:00',1.74),('8902','2014-02-20','16:45:00',1.53),('8902','2014-02-20','16:50:00',1.36),('8902','2014-02-20','16:55:00',1.16),('8902','2014-02-20','17:00:00',1.03),('8902','2014-02-19','10:10:00',1.02),('8902','2014-02-19','10:45:00',1.05),('8902','2014-02-19','10:50:00',1.1),('8902','2014-02-19','10:55:00',1.33),('8902','2014-02-19','11:20:00',1.66),('8902','2014-02-19','11:25:00',2.04),('8902','2014-02-19','11:30:00',1.97),('8902','2014-02-19','11:35:00',1.65),('8902','2014-02-19','11:40:00',1.09),('8902','2014-02-19','11:45:00',1.2),('8902','2014-02-19','11:50:00',1.2),('8902','2014-02-19','11:55:00',1.46),('8902','2014-02-19','12:00:00',1.81),('8902','2014-02-19','12:05:00',1.26),('8902','2014-02-19','12:10:00',1.11),('8902','2014-02-19','12:15:00',1.02),('8902','2014-02-19','12:20:00',1.26),('8902','2014-02-19','12:25:00',1.65),('8902','2014-02-19','12:30:00',1.9),('8902','2014-02-19','12:35:00',1.84),('8902','2014-02-19','12:40:00',1.83),('8902','2014-02-19','12:45:00',1.57),('8902','2014-02-19','12:50:00',1.61),('8902','2014-02-19','12:55:00',2.14),('8902','2014-02-19','13:00:00',2.56),('8902','2014-02-19','13:05:00',1.55),('8902','2014-02-19','13:10:00',1.26),('8902','2014-02-19','13:15:00',2.33),('8902','2014-02-19','13:20:00',2.12),('8902','2014-02-19','13:25:00',1.61),('8902','2014-02-19','13:30:00',2.17),('8902','2014-02-19','13:35:00',2.03),('8902','2014-02-19','13:40:00',1.26),('8902','2014-02-19','13:45:00',1),('8902','2014-02-19','13:50:00',1.03),('8902','2014-02-19','13:55:00',1.13),('8902','2014-02-19','14:00:00',1.72),('8902','2014-02-19','14:05:00',1.19),('8902','2014-02-19','14:15:00',1.18),('8902','2014-02-19','14:20:00',1.06),('8902','2014-02-19','14:25:00',1.02),('8902','2014-02-19','14:30:00',1),('8902','2014-02-18','08:35:00',1.18),('8902','2014-02-18','08:40:00',1.27),('8902','2014-02-18','08:45:00',1.39),('8902','2014-02-18','08:50:00',1.27),('8902','2014-02-18','08:55:00',1.25),('8902','2014-02-18','09:00:00',1.35),('8902','2014-02-18','09:05:00',1.36),('8902','2014-02-18','09:10:00',1.31),('8902','2014-02-18','09:15:00',1.48),('8902','2014-02-18','09:20:00',1.69),('8902','2014-02-18','09:25:00',1.92),('8902','2014-02-18','09:30:00',1.99),('8902','2014-02-18','09:35:00',2.3),('8902','2014-02-18','09:40:00',2.44),('8902','2014-02-18','09:45:00',2.9),('8902','2014-02-18','09:50:00',2.74),('8902','2014-02-18','09:55:00',2.53),('8902','2014-02-18','10:00:00',2.45),('8902','2014-02-18','10:05:00',2.44),('8902','2014-02-18','10:10:00',2.62),('8902','2014-02-18','10:15:00',2.75),('8902','2014-02-18','10:20:00',2.48),('8902','2014-02-18','10:25:00',2.54),('8902','2014-02-18','10:30:00',2.78),('8902','2014-02-18','10:35:00',2.89),('8902','2014-02-18','10:40:00',3.38),('8902','2014-02-18','10:45:00',3.76),('8902','2014-02-18','10:50:00',3.39),('8902','2014-02-18','10:55:00',3.01),('8902','2014-02-18','11:00:00',2.74),('8902','2014-02-18','11:05:00',2.92),('8902','2014-02-18','11:10:00',3.41),('8902','2014-02-18','11:15:00',3.28),('8902','2014-02-18','11:20:00',3.54),('8902','2014-02-18','11:25:00',3.39),('8902','2014-02-18','11:30:00',3.29),('8902','2014-02-18','11:35:00',3.09),('8902','2014-02-18','11:40:00',2.87),('8902','2014-02-18','11:45:00',2.83),('8902','2014-02-18','11:50:00',2.67),('8902','2014-02-18','11:55:00',2.32),('8902','2014-02-18','12:00:00',2.62),('8902','2014-02-18','12:05:00',2.99),('8902','2014-02-18','12:10:00',2.94),('8902','2014-02-18','12:15:00',2.79),('8902','2014-02-18','12:20:00',2.35),('8902','2014-02-18','12:25:00',2.65),('8902','2014-02-18','12:30:00',3.27),('8902','2014-02-18','12:35:00',2.69),('8902','2014-02-18','12:40:00',2.67),('8902','2014-02-18','12:45:00',2.63),('8902','2014-02-18','12:50:00',2.02),('8902','2014-02-18','12:55:00',1.61),('8902','2014-02-18','13:00:00',1.92),('8902','2014-02-18','13:05:00',2.27),('8902','2014-02-18','13:10:00',2.09),('8902','2014-02-18','13:15:00',2.26),('8902','2014-02-18','13:20:00',2.56),('8902','2014-02-18','13:25:00',2.65),('8902','2014-02-18','13:30:00',2.66),('8902','2014-02-18','13:35:00',3.32),('8902','2014-02-18','13:40:00',3.14),('8902','2014-02-18','13:45:00',3.45),('8902','2014-02-18','13:50:00',3.84),('8902','2014-02-18','13:55:00',3.74),('8902','2014-02-18','14:00:00',3.36),('8902','2014-02-18','14:05:00',3.82),('8902','2014-02-18','14:10:00',3.17),('8902','2014-02-18','14:15:00',2.78),('8902','2014-02-18','14:20:00',4.29),('8902','2014-02-18','14:25:00',3.41),('8902','2014-02-18','14:30:00',3.13),('8902','2014-02-18','14:35:00',3.39),('8902','2014-02-18','14:40:00',2.79),('8902','2014-02-18','14:45:00',2.68),('8902','2014-02-18','14:50:00',3.36),('8902','2014-02-18','14:55:00',3.17),('8902','2014-02-18','15:00:00',2.54),('8902','2014-02-18','15:05:00',2.49),('8902','2014-02-18','15:10:00',2.26),('8902','2014-02-18','15:15:00',2.83),('8902','2014-02-18','15:20:00',2.13),('8902','2014-02-18','15:25:00',2.42),('8902','2014-02-18','15:30:00',2.06),('8902','2014-02-18','15:35:00',1.82),('8902','2014-02-18','15:40:00',1.89),('8902','2014-02-18','15:45:00',1.88),('8902','2014-02-18','15:50:00',2.35),('8902','2014-02-18','15:55:00',1.96),('8902','2014-02-18','16:00:00',1.72),('8902','2014-02-18','16:05:00',1.6),('8902','2014-02-18','16:10:00',1.46),('8902','2014-02-18','16:15:00',1.44),('8902','2014-02-18','16:20:00',1.11),('8902','2014-02-17','08:00:00',1.12),('8902','2014-02-17','08:05:00',1.34),('8902','2014-02-17','08:10:00',1.5),('8902','2014-02-17','08:15:00',1.68),('8902','2014-02-17','08:20:00',1.86),('8902','2014-02-17','08:25:00',2.05),('8902','2014-02-17','08:30:00',2.26),('8902','2014-02-17','08:35:00',2.43),('8902','2014-02-17','08:40:00',2.61),('8902','2014-02-17','08:45:00',2.77),('8902','2014-02-17','08:50:00',2.85),('8902','2014-02-17','08:55:00',3.15),('8902','2014-02-17','09:00:00',3.3),('8902','2014-02-17','09:05:00',3.46),('8902','2014-02-17','09:10:00',3.64),('8902','2014-02-17','09:15:00',3.8),('8902','2014-02-17','09:20:00',3.94),('8902','2014-02-17','09:25:00',4.1),('8902','2014-02-17','09:30:00',4.27),('8902','2014-02-17','09:35:00',4.39),('8902','2014-02-17','09:40:00',4.53),('8902','2014-02-17','09:45:00',4.65),('8902','2014-02-17','09:50:00',4.79),('8902','2014-02-17','09:55:00',4.94),('8902','2014-02-17','10:00:00',5.08),('8902','2014-02-17','10:05:00',5.18),('8902','2014-02-17','10:10:00',5.28),('8902','2014-02-17','10:15:00',5.38),('8902','2014-02-17','10:20:00',5.49),('8902','2014-02-17','10:25:00',5.57),('8902','2014-02-17','10:30:00',5.64),('8902','2014-02-17','10:35:00',5.7),('8902','2014-02-17','10:40:00',5.8),('8902','2014-02-17','10:45:00',5.89),('8902','2014-02-17','10:50:00',6),('8902','2014-02-17','10:55:00',6.11),('8902','2014-02-17','11:00:00',6.2),('8902','2014-02-17','11:05:00',5.32),('8902','2014-02-17','11:10:00',5.16),('8902','2014-02-17','11:15:00',4.95),('8902','2014-02-17','11:20:00',5.73),('8902','2014-02-17','11:25:00',6.43),('8902','2014-02-17','11:30:00',6),('8902','2014-02-17','11:35:00',5.4),('8902','2014-02-17','11:40:00',4.45),('8902','2014-02-17','11:45:00',4.49),('8902','2014-02-17','11:50:00',3.79),('8902','2014-02-17','11:55:00',3.06),('8902','2014-02-17','12:00:00',2.91),('8902','2014-02-17','12:05:00',2.95),('8902','2014-02-17','12:10:00',3.4),('8902','2014-02-17','12:15:00',3.69),('8902','2014-02-17','12:20:00',3.55),('8902','2014-02-17','12:25:00',4.16),('8902','2014-02-17','12:30:00',4.73),('8902','2014-02-17','12:35:00',3.56),('8902','2014-02-17','12:40:00',3.17),('8902','2014-02-17','12:45:00',3.06),('8902','2014-02-17','12:50:00',3.25),('8902','2014-02-17','12:55:00',3.62),('8902','2014-02-17','13:00:00',2.74),('8902','2014-02-17','13:05:00',2.58),('8902','2014-02-17','13:10:00',2.8),('8902','2014-02-17','13:15:00',3.73),('8902','2014-02-17','13:20:00',4.02),('8902','2014-02-17','13:25:00',4.8),('8902','2014-02-17','13:30:00',3.5),('8902','2014-02-17','13:35:00',2.86),('8902','2014-02-17','13:40:00',3.7),('8902','2014-02-17','13:45:00',4.46),('8902','2014-02-17','13:50:00',3.35),('8902','2014-02-17','13:55:00',3.39),('8902','2014-02-17','14:00:00',3.94),('8902','2014-02-17','14:05:00',5.67),('8902','2014-02-17','14:10:00',3.27),('8902','2014-02-17','14:15:00',2.48),('8902','2014-02-17','14:20:00',2.18),('8902','2014-02-17','14:25:00',2.25),('8902','2014-02-17','14:30:00',2.88),('8902','2014-02-17','14:35:00',2.74),('8902','2014-02-17','14:40:00',2.25),('8902','2014-02-17','14:45:00',2.09),('8902','2014-02-17','14:50:00',1.95),('8902','2014-02-17','14:55:00',1.85),('8902','2014-02-17','15:00:00',1.72),('8902','2014-02-17','15:05:00',1.64),('8902','2014-02-17','15:10:00',1.63),('8902','2014-02-17','15:15:00',1.52),('8902','2014-02-17','15:20:00',1.36),('8902','2014-02-17','15:25:00',1.42),('8902','2014-02-17','15:30:00',1.61),('8902','2014-02-17','15:35:00',2.1),('8902','2014-02-17','15:40:00',2.76),('8902','2014-02-17','15:45:00',2.93),('8902','2014-02-17','15:50:00',2.25),('8902','2014-02-17','15:55:00',2.06),('8902','2014-02-17','16:00:00',2.12),('8902','2014-02-17','16:05:00',2.43),('8902','2014-02-17','16:10:00',2.07),('8902','2014-02-17','16:15:00',1.41),('8902','2014-02-17','16:20:00',1.21),('8902','2014-02-17','16:30:00',1.28),('8902','2014-02-17','16:35:00',1.47),('8902','2014-02-17','16:40:00',1.21),('8902','2014-02-16','08:05:00',1.12),('8902','2014-02-16','08:10:00',1.26),('8902','2014-02-16','08:15:00',1.4),('8902','2014-02-16','08:20:00',1.53),('8902','2014-02-16','08:25:00',1.68),('8902','2014-02-16','08:30:00',1.99),('8902','2014-02-16','08:35:00',2.18),('8902','2014-02-16','08:40:00',2.34),('8902','2014-02-16','08:45:00',2.5),('8902','2014-02-16','08:50:00',2.62),('8902','2014-02-16','08:55:00',2.78),('8902','2014-02-16','09:00:00',2.94),('8902','2014-02-16','09:05:00',3.09),('8902','2014-02-16','09:10:00',3.32),('8902','2014-02-16','09:15:00',3.51),('8902','2014-02-16','09:20:00',3.67),('8902','2014-02-16','09:25:00',3.83),('8902','2014-02-16','09:30:00',4.01),('8902','2014-02-16','09:35:00',4.14),('8902','2014-02-16','09:40:00',4.26),('8902','2014-02-16','09:45:00',4.37),('8902','2014-02-16','09:50:00',4.46),('8902','2014-02-16','09:55:00',4.58),('8902','2014-02-16','10:00:00',4.7),('8902','2014-02-16','10:05:00',4.84),('8902','2014-02-16','10:10:00',4.94),('8902','2014-02-16','10:15:00',5.01),('8902','2014-02-16','10:20:00',5.05),('8902','2014-02-16','10:25:00',5.12),('8902','2014-02-16','10:30:00',5.21),('8902','2014-02-16','10:35:00',5.25),('8902','2014-02-16','10:40:00',5.29),('8902','2014-02-16','10:45:00',5.33),('8902','2014-02-16','10:50:00',5.38),('8902','2014-02-16','10:55:00',5.49),('8902','2014-02-16','11:00:00',5.52),('8902','2014-02-16','11:05:00',5.6),('8902','2014-02-16','11:10:00',5.69),('8902','2014-02-16','11:15:00',5.78),('8902','2014-02-16','11:20:00',5.9),('8902','2014-02-16','11:25:00',6.04),('8902','2014-02-16','11:30:00',6.19),('8902','2014-02-16','11:35:00',6.33),('8902','2014-02-16','11:40:00',6.41),('8902','2014-02-16','11:45:00',6.43),('8902','2014-02-16','11:50:00',6.48),('8902','2014-02-16','11:55:00',6.5),('8902','2014-02-16','12:00:00',6.51),('8902','2014-02-16','12:05:00',6.55),('8902','2014-02-16','12:10:00',6.55),('8902','2014-02-16','12:15:00',6.56),('8902','2014-02-16','12:20:00',6.55),('8902','2014-02-16','12:25:00',6.57),('8902','2014-02-16','12:30:00',6.54),('8902','2014-02-16','12:35:00',6.55),('8902','2014-02-16','12:40:00',6.54),('8902','2014-02-16','12:45:00',6.47),('8902','2014-02-16','12:50:00',6.45),('8902','2014-02-16','12:55:00',6.42),('8902','2014-02-16','13:00:00',6.43),('8902','2014-02-16','13:05:00',6.37),('8902','2014-02-16','13:10:00',6.35),('8902','2014-02-16','13:15:00',6.31),('8902','2014-02-16','13:20:00',6.27),('8902','2014-02-16','13:25:00',6.26),('8902','2014-02-16','13:30:00',6.26),('8902','2014-02-16','13:35:00',6.24),('8902','2014-02-16','13:40:00',6.19),('8902','2014-02-16','13:45:00',6.05),('8902','2014-02-16','13:50:00',6.05),('8902','2014-02-16','13:55:00',5.98),('8902','2014-02-16','14:00:00',5.86),('8902','2014-02-16','14:05:00',5.84),('8902','2014-02-16','14:10:00',5.6),('8902','2014-02-16','14:15:00',5.45),('8902','2014-02-16','14:20:00',5.62),('8902','2014-02-16','14:25:00',5.41),('8902','2014-02-16','14:30:00',5.29),('8902','2014-02-16','14:35:00',5.14),('8902','2014-02-16','14:40:00',4.72),('8902','2014-02-16','14:45:00',5.13),('8902','2014-02-16','14:50:00',4.82),('8902','2014-02-16','14:55:00',4.83),('8902','2014-02-16','15:00:00',4.54),('8902','2014-02-16','15:05:00',4.49),('8902','2014-02-16','15:10:00',4.38),('8902','2014-02-16','15:15:00',4.42),('8902','2014-02-16','15:20:00',4.34),('8902','2014-02-16','15:25:00',4),('8902','2014-02-16','15:30:00',3.95),('8902','2014-02-16','15:35:00',3.77),('8902','2014-02-16','15:40:00',3.51),('8902','2014-02-16','15:45:00',3.49),('8902','2014-02-16','15:50:00',3.26),('8902','2014-02-16','15:55:00',3.1),('8902','2014-02-16','16:00:00',2.84),('8902','2014-02-16','16:05:00',2.75),('8902','2014-02-16','16:10:00',2.57),('8902','2014-02-16','16:15:00',2.35),('8902','2014-02-16','16:20:00',2.14),('8902','2014-02-16','16:25:00',1.99),('8902','2014-02-16','16:30:00',1.76),('8902','2014-02-16','16:35:00',1.53),('8902','2014-02-16','16:40:00',1.37),('8902','2014-02-16','16:45:00',1.17),('8902','2014-02-16','16:50:00',1.01),('8902','2014-02-15','08:05:00',1.04),('8902','2014-02-15','08:10:00',1.19),('8902','2014-02-15','08:15:00',1.36),('8902','2014-02-15','08:20:00',1.51),('8902','2014-02-15','08:25:00',1.69),('8902','2014-02-15','08:30:00',2.21),('8902','2014-02-15','08:35:00',2.44),('8902','2014-02-15','08:40:00',2.46),('8902','2014-02-15','08:45:00',2.83),('8902','2014-02-15','08:50:00',2.68),('8902','2014-02-15','08:55:00',3.11),('8902','2014-02-15','09:00:00',3.38),('8902','2014-02-15','09:05:00',3.55),('8902','2014-02-15','09:10:00',3.47),('8902','2014-02-15','09:15:00',2.93),('8902','2014-02-15','09:20:00',3.74),('8902','2014-02-15','09:25:00',3.92),('8902','2014-02-15','09:30:00',4.09),('8902','2014-02-15','09:35:00',3.46),('8902','2014-02-15','09:40:00',4.32),('8902','2014-02-15','09:45:00',4.64),('8902','2014-02-15','09:50:00',4.79),('8902','2014-02-15','09:55:00',4.7),('8902','2014-02-15','10:00:00',4.59),('8902','2014-02-15','10:05:00',5.16),('8902','2014-02-15','10:10:00',5.32),('8902','2014-02-15','10:15:00',5.41),('8902','2014-02-15','10:20:00',5.53),('8902','2014-02-15','10:25:00',5.66),('8902','2014-02-15','10:30:00',5.75),('8902','2014-02-15','10:35:00',5.97),('8902','2014-02-15','10:40:00',6.14),('8902','2014-02-15','10:45:00',6.09),('8902','2014-02-15','10:50:00',5.54),('8902','2014-02-15','10:55:00',5.16),('8902','2014-02-15','11:00:00',6.16),('8902','2014-02-15','11:05:00',6.32),('8902','2014-02-15','11:10:00',6.08),('8902','2014-02-15','11:15:00',6.26),('8902','2014-02-15','11:20:00',6.17),('8902','2014-02-15','11:25:00',5.95),('8902','2014-02-15','11:30:00',6.17),('8902','2014-02-15','11:35:00',6.51),('8902','2014-02-15','11:40:00',6.54),('8902','2014-02-15','11:45:00',5.83),('8902','2014-02-15','11:50:00',6.59),('8902','2014-02-15','11:55:00',5.66),('8902','2014-02-15','12:00:00',6.72),('8902','2014-02-15','12:05:00',6.67),('8902','2014-02-15','12:10:00',6.7),('8902','2014-02-15','12:15:00',6.7),('8902','2014-02-15','12:20:00',6.73),('8902','2014-02-15','12:25:00',6.61),('8902','2014-02-15','12:30:00',6.72),('8902','2014-02-15','12:35:00',6.68),('8902','2014-02-15','12:40:00',6.64),('8902','2014-02-15','12:45:00',6.6),('8902','2014-02-15','12:50:00',6.64),('8902','2014-02-15','12:55:00',6.7),('8902','2014-02-15','13:00:00',6.63),('8902','2014-02-15','13:05:00',6.63),('8902','2014-02-15','13:10:00',6.45),('8902','2014-02-15','13:15:00',6.54),('8902','2014-02-15','13:20:00',6.59),('8902','2014-02-15','13:25:00',6.5),('8902','2014-02-15','13:30:00',6.35),('8902','2014-02-15','13:35:00',6.35),('8902','2014-02-15','13:40:00',6.27),('8902','2014-02-15','13:45:00',6.33),('8902','2014-02-15','13:50:00',6.25),('8902','2014-02-15','13:55:00',6.27),('8902','2014-02-15','14:00:00',6.28),('8902','2014-02-15','14:05:00',6.26),('8902','2014-02-15','14:10:00',6.2),('8902','2014-02-15','14:15:00',6.11),('8902','2014-02-15','14:20:00',6.06),('8902','2014-02-15','14:25:00',6.03),('8902','2014-02-15','14:30:00',5.91),('8902','2014-02-15','14:35:00',5.78),('8902','2014-02-15','14:40:00',5.6),('8902','2014-02-15','14:45:00',5.58),('8902','2014-02-15','14:50:00',5.46),('8902','2014-02-15','14:55:00',5.4),('8902','2014-02-15','15:00:00',5.21),('8902','2014-02-15','15:05:00',5.17),('8902','2014-02-15','15:10:00',4.97),('8902','2014-02-15','15:15:00',4.84),('8902','2014-02-15','15:20:00',4.67),('8902','2014-02-15','15:25:00',4.43),('8902','2014-02-15','15:30:00',4.33),('8902','2014-02-15','15:35:00',3.85),('8902','2014-02-15','15:40:00',3.4),('8902','2014-02-15','15:45:00',3.98),('8902','2014-02-15','15:50:00',3.29),('8902','2014-02-15','15:55:00',1.25),('8902','2014-02-15','16:10:00',1.43),('8902','2014-02-15','16:15:00',2.25),('8902','2014-02-15','16:20:00',2.41),('8902','2014-02-15','16:25:00',2.79),('8902','2014-02-15','16:30:00',2.85),('8902','2014-02-15','16:35:00',2.39),('8902','2014-02-15','16:40:00',1.74),('8902','2014-02-15','16:45:00',1.29),('8902','2014-04-27','07:40:00',1.02),('8902','2014-04-27','07:45:00',1.13),('8902','2014-04-27','07:50:00',1.17),('8902','2014-04-27','07:55:00',1.27),('8902','2014-04-27','08:00:00',1.42),('8902','2014-04-27','08:05:00',1.08),('8902','2014-04-27','08:15:00',2.39),('8902','2014-04-27','08:20:00',2.67),('8902','2014-04-27','08:25:00',2.68),('8902','2014-04-27','08:30:00',2.46),('8902','2014-04-27','08:35:00',2.28),('8902','2014-04-27','08:40:00',2.09),('8902','2014-04-27','08:45:00',2.11),('8902','2014-04-27','08:50:00',2.39),('8902','2014-04-27','08:55:00',2.52),('8902','2014-04-27','09:00:00',1.95),('8902','2014-04-27','09:05:00',1.58),('8902','2014-04-27','09:10:00',3.53),('8902','2014-04-27','09:15:00',5.27),('8902','2014-04-27','09:20:00',5.29),('8902','2014-04-27','09:25:00',4.42),('8902','2014-04-27','09:30:00',4.19),('8902','2014-04-27','09:35:00',3.5),('8902','2014-04-27','09:40:00',3.92),('8902','2014-04-27','09:45:00',3.72),('8902','2014-04-27','09:50:00',4.48),('8902','2014-04-27','09:55:00',2.98),('8902','2014-04-27','10:00:00',2.99),('8902','2014-04-27','10:05:00',4.2),('8902','2014-04-27','10:10:00',4.45),('8902','2014-04-27','10:15:00',4.3),('8902','2014-04-27','10:20:00',3.63),('8902','2014-04-27','10:25:00',2.91),('8902','2014-04-27','10:30:00',1.2),('8902','2014-04-27','10:40:00',1.47),('8902','2014-04-27','10:45:00',2.74),('8902','2014-04-27','10:50:00',3.84),('8902','2014-04-27','11:00:00',3.56),('8902','2014-04-27','11:05:00',4.38),('8902','2014-04-27','11:10:00',4.2),('8902','2014-04-27','11:15:00',4.72),('8902','2014-04-27','11:20:00',4.63),('8902','2014-04-27','11:25:00',3.55),('8902','2014-04-27','11:30:00',3.82),('8902','2014-04-27','11:35:00',3.7),('8902','2014-04-27','11:40:00',3.02),('8902','2014-04-27','11:45:00',3.08),('8902','2014-04-27','11:50:00',3.48),('8902','2014-04-27','11:55:00',3.83),('8902','2014-04-27','12:00:00',3.51),('8902','2014-04-27','12:05:00',2.56),('8902','2014-04-27','12:10:00',3.51),('8902','2014-04-27','12:15:00',5.17),('8902','2014-04-27','12:20:00',5.92),('8902','2014-04-27','12:25:00',5.45),('8902','2014-04-27','12:30:00',5.16),('8902','2014-04-27','12:35:00',4.78),('8902','2014-04-27','12:40:00',4.32),('8902','2014-04-27','12:45:00',3.72),('8902','2014-04-27','12:50:00',4.57),('8902','2014-04-27','12:55:00',4.28),('8902','2014-04-27','13:00:00',4.35),('8902','2014-04-27','13:05:00',4.93),('8902','2014-04-27','13:10:00',7.87),('8902','2014-04-27','13:15:00',4.67),('8902','2014-04-27','13:20:00',4.21),('8902','2014-04-27','13:25:00',4.78),('8902','2014-04-27','13:30:00',8.55),('8902','2014-04-27','13:35:00',7.55),('8902','2014-04-27','13:40:00',7.36),('8902','2014-04-27','13:45:00',4.07),('8902','2014-04-27','13:50:00',8.2),('8902','2014-04-27','13:55:00',7.04),('8902','2014-04-27','14:00:00',3.47),('8902','2014-04-27','14:05:00',4.6),('8902','2014-04-27','14:10:00',6.09),('8902','2014-04-27','14:15:00',7.43),('8902','2014-04-27','14:20:00',8.07),('8902','2014-04-27','14:25:00',5.41),('8902','2014-04-27','14:30:00',4.77),('8902','2014-04-27','14:35:00',8.32),('8902','2014-04-27','14:40:00',7.65),('8902','2014-04-27','14:45:00',5.76),('8902','2014-04-27','14:50:00',4.73),('8902','2014-04-27','14:55:00',7.65),('8902','2014-04-27','15:00:00',5.23),('8902','2014-04-27','15:05:00',6.05),('8902','2014-04-27','15:10:00',6.51),('8902','2014-04-27','15:15:00',5.33),('8902','2014-04-27','15:20:00',3.79),('8902','2014-04-27','15:25:00',4.39),('8902','2014-04-27','15:30:00',3.97),('8902','2014-04-27','15:35:00',5.96),('8902','2014-04-27','15:40:00',5.53),('8902','2014-04-27','15:45:00',3.62),('8902','2014-04-27','15:50:00',6.99),('8902','2014-04-27','15:55:00',2.78),('8902','2014-04-27','16:00:00',4.88),('8902','2014-04-27','16:05:00',7.19),('8902','2014-04-27','16:10:00',7.63),('8902','2014-04-27','16:15:00',6.14),('8902','2014-04-27','16:20:00',4.28),('8902','2014-04-27','16:25:00',3.13),('8902','2014-04-27','16:30:00',6.95),('8902','2014-04-27','16:35:00',6.67),('8902','2014-04-27','16:40:00',1.66),('8902','2014-04-27','16:45:00',1.28),('8902','2014-04-27','16:50:00',1.19),('8902','2014-04-27','16:55:00',2.35),('8902','2014-04-27','17:00:00',2.3),('8902','2014-04-27','17:05:00',1.08),('8902','2014-04-27','17:20:00',1.38),('8902','2014-04-27','17:25:00',1.91),('8902','2014-04-27','17:30:00',1.73),('8902','2014-04-27','17:35:00',1.78),('8902','2014-04-27','17:40:00',2.8),('8902','2014-04-27','17:45:00',1.88),('8902','2014-04-27','17:50:00',1.38),('8902','2014-04-27','17:55:00',1.36),('8902','2014-04-27','18:00:00',1.16),('8902','2014-04-27','18:10:00',1.01),('8902','2014-04-27','18:15:00',1.04),('8902','2014-02-14','08:05:00',1.01),('8902','2014-02-14','08:10:00',1.31),('8902','2014-02-14','08:15:00',1.53),('8902','2014-02-14','08:20:00',1.72),('8902','2014-02-14','08:25:00',1.88),('8902','2014-02-14','08:30:00',2.04),('8902','2014-02-14','08:35:00',2.22),('8902','2014-02-14','08:40:00',2.38),('8902','2014-02-14','08:45:00',2.5),('8902','2014-02-14','08:50:00',2.63),('8902','2014-02-14','08:55:00',2.79),('8902','2014-02-14','09:00:00',3.06),('8902','2014-02-14','09:05:00',3.24),('8902','2014-02-14','09:10:00',3.4),('8902','2014-02-14','09:15:00',3.56),('8902','2014-02-14','09:20:00',3.79),('8902','2014-02-14','09:25:00',3.94),('8902','2014-02-14','09:30:00',4.09),('8902','2014-02-14','09:35:00',4.26),('8902','2014-02-14','09:40:00',4.41),('8902','2014-02-14','09:45:00',4.53),('8902','2014-02-14','09:50:00',4.64),('8902','2014-02-14','09:55:00',4.79),('8902','2014-02-14','10:00:00',4.91),('8902','2014-02-14','10:05:00',5.02),('8902','2014-02-14','10:10:00',5.11),('8902','2014-02-14','10:15:00',5.22),('8902','2014-02-14','10:20:00',5.31),('8902','2014-02-14','10:25:00',5.39),('8902','2014-02-14','10:30:00',5.45),('8902','2014-02-14','10:35:00',5.53),('8902','2014-02-14','10:40:00',5.64),('8902','2014-02-14','10:45:00',5.68),('8902','2014-02-14','10:50:00',5.79),('8902','2014-02-14','10:55:00',5.97),('8902','2014-02-14','11:00:00',6.16),('8902','2014-02-14','11:05:00',6.37),('8902','2014-02-14','11:10:00',6.14),('8902','2014-02-14','11:15:00',6.1),('8902','2014-02-14','11:20:00',6.54),('8902','2014-02-14','11:25:00',3.24),('8902','2014-02-14','11:30:00',2.57),('8902','2014-02-14','11:35:00',6.59),('8902','2014-02-14','11:40:00',6),('8902','2014-02-14','11:45:00',7.06),('8902','2014-02-14','11:50:00',5.5),('8902','2014-02-14','11:55:00',6.95),('8902','2014-02-14','12:00:00',3.78),('8902','2014-02-14','12:05:00',5.95),('8902','2014-02-14','12:10:00',6),('8902','2014-02-14','12:15:00',7.23),('8902','2014-02-14','12:20:00',7.65),('8902','2014-02-14','12:25:00',7.37),('8902','2014-02-14','12:30:00',7.36),('8902','2014-02-14','12:35:00',7.08),('8902','2014-02-14','12:40:00',7.73),('8902','2014-02-14','12:45:00',8.01),('8902','2014-02-14','12:50:00',7.85),('8902','2014-02-14','12:55:00',6.62),('8902','2014-02-14','13:00:00',7.38),('8902','2014-02-14','13:05:00',7.3),('8902','2014-02-14','13:10:00',7.22),('8902','2014-02-14','13:15:00',7.1),('8902','2014-02-14','13:20:00',6.96),('8902','2014-02-14','13:25:00',6.69),('8902','2014-02-14','13:30:00',6.63),('8902','2014-02-14','13:35:00',6.58),('8902','2014-02-14','13:40:00',6.52),('8902','2014-02-14','13:45:00',6.44),('8902','2014-02-14','13:50:00',6.44),('8902','2014-02-14','13:55:00',6.27),('8902','2014-02-14','14:00:00',6.24),('8902','2014-02-14','14:05:00',6.19),('8902','2014-02-14','14:10:00',6.05),('8902','2014-02-14','14:15:00',6),('8902','2014-02-14','14:20:00',5.93),('8902','2014-02-14','14:25:00',5.78),('8902','2014-02-14','14:30:00',5.71),('8902','2014-02-14','14:35:00',5.64),('8902','2014-02-14','14:40:00',5.56),('8902','2014-02-14','14:45:00',5.42),('8902','2014-02-14','14:50:00',5.3),('8902','2014-02-14','14:55:00',5.15),('8902','2014-02-14','15:00:00',4.9),('8902','2014-02-14','15:05:00',4.82),('8902','2014-02-14','15:10:00',4.62),('8902','2014-02-14','15:15:00',4.62),('8902','2014-02-14','15:20:00',4.49),('8902','2014-02-14','15:25:00',4.32),('8902','2014-02-14','15:30:00',4.18),('8902','2014-02-14','15:35:00',4.08),('8902','2014-02-14','15:40:00',3.97),('8902','2014-02-14','15:45:00',3.83),('8902','2014-02-14','15:50:00',3.64),('8902','2014-02-14','15:55:00',3.45),('8902','2014-02-14','16:00:00',3.26),('8902','2014-02-14','16:05:00',3.08),('8902','2014-02-14','16:10:00',2.89),('8902','2014-02-14','16:15:00',2.72),('8902','2014-02-14','16:20:00',2.48),('8902','2014-02-14','16:25:00',2.26),('8902','2014-02-14','16:30:00',2.08),('8902','2014-02-14','16:35:00',1.89),('8902','2014-02-14','16:40:00',1.69),('8902','2014-02-14','16:45:00',1.47),('8902','2014-02-14','16:50:00',1.27),('8902','2014-02-14','16:55:00',1.07),('8902','2014-02-13','08:40:00',1.88),('8902','2014-02-13','08:45:00',1.83),('8902','2014-02-13','08:50:00',2.68),('8902','2014-02-13','08:55:00',2.85),('8902','2014-02-13','09:00:00',3.03),('8902','2014-02-13','09:05:00',3.27),('8902','2014-02-13','09:10:00',2.37),('8902','2014-02-13','09:15:00',2.19),('8902','2014-02-13','09:20:00',3.01),('8902','2014-02-13','09:25:00',3),('8902','2014-02-13','09:30:00',3.56),('8902','2014-02-13','09:35:00',3.48),('8902','2014-02-13','09:40:00',2.33),('8902','2014-02-13','09:45:00',2.98),('8902','2014-02-13','09:50:00',3.95),('8902','2014-02-13','09:55:00',5.09),('8902','2014-02-13','10:00:00',4.61),('8902','2014-02-13','10:05:00',5.28),('8902','2014-02-13','10:10:00',5.55),('8902','2014-02-13','10:15:00',4.19),('8902','2014-02-13','10:20:00',5.36),('8902','2014-02-13','10:25:00',5.22),('8902','2014-02-13','10:30:00',5.86),('8902','2014-02-13','10:35:00',5.77),('8902','2014-02-13','10:40:00',5.81),('8902','2014-02-13','10:45:00',6.07),('8902','2014-02-13','10:50:00',6.17),('8902','2014-02-13','10:55:00',6.28),('8902','2014-02-13','11:00:00',6.38),('8902','2014-02-13','11:05:00',6.44),('8902','2014-02-13','11:10:00',6.5),('8902','2014-02-13','11:15:00',6.54),('8902','2014-02-13','11:20:00',6.62),('8902','2014-02-13','11:25:00',6.7),('8902','2014-02-13','11:30:00',6.77),('8902','2014-02-13','11:35:00',6.87),('8902','2014-02-13','11:40:00',6.72),('8902','2014-02-13','11:45:00',6.89),('8902','2014-02-13','11:50:00',6.57),('8902','2014-02-13','11:55:00',6.89),('8902','2014-02-13','12:00:00',6.97),('8902','2014-02-13','12:05:00',6.95),('8902','2014-02-13','12:10:00',6.92),('8902','2014-02-13','12:15:00',7.01),('8902','2014-02-13','12:20:00',6.99),('8902','2014-02-13','12:25:00',7.04),('8902','2014-02-13','12:30:00',7.03),('8902','2014-02-13','12:35:00',7.02),('8902','2014-02-13','12:40:00',6.98),('8902','2014-02-13','12:45:00',6.93),('8902','2014-02-13','12:50:00',6.96),('8902','2014-02-13','12:55:00',6.97),('8902','2014-02-13','13:00:00',6.95),('8902','2014-02-13','13:05:00',6.91),('8902','2014-02-13','13:10:00',6.88),('8902','2014-02-13','13:15:00',6.85),('8902','2014-02-13','13:20:00',6.83),('8902','2014-02-13','13:25:00',6.73),('8902','2014-02-13','13:30:00',6.65),('8902','2014-02-13','13:35:00',6.62),('8902','2014-02-13','13:40:00',6.63),('8902','2014-02-13','13:45:00',6.51),('8902','2014-02-13','13:50:00',6.48),('8902','2014-02-13','13:55:00',6.42),('8902','2014-02-13','14:00:00',6.34),('8902','2014-02-13','14:05:00',6.26),('8902','2014-02-13','14:10:00',6.17),('8902','2014-02-13','14:15:00',6.04),('8902','2014-02-13','14:20:00',5.98),('8902','2014-02-13','14:25:00',5.93),('8902','2014-02-13','14:30:00',5.87),('8902','2014-02-13','14:35:00',5.75),('8902','2014-02-13','14:40:00',5.59),('8902','2014-02-13','14:45:00',5.45),('8902','2014-02-13','14:50:00',5.32),('8902','2014-02-13','14:55:00',5.2),('8902','2014-02-13','15:00:00',5.08),('8902','2014-02-13','15:05:00',4.98),('8902','2014-02-13','15:10:00',4.89),('8902','2014-02-13','15:15:00',4.75),('8902','2014-02-13','15:20:00',4.59),('8902','2014-02-13','15:25:00',4.4),('8902','2014-02-13','15:30:00',4.28),('8902','2014-02-13','15:35:00',4.12),('8902','2014-02-13','15:40:00',3.95),('8902','2014-02-13','15:45:00',3.78),('8902','2014-02-13','15:50:00',3.58),('8902','2014-02-13','15:55:00',3.38),('8902','2014-02-13','16:00:00',3.19),('8902','2014-02-13','16:05:00',3.04),('8902','2014-02-13','16:10:00',2.81),('8902','2014-02-13','16:15:00',2.58),('8902','2014-02-13','16:20:00',2.43),('8902','2014-02-13','16:25:00',2.22),('8902','2014-02-13','16:30:00',2),('8902','2014-02-13','16:35:00',1.76),('8902','2014-02-13','16:40:00',1.61),('8902','2014-02-13','16:45:00',1.44),('8902','2014-02-13','16:50:00',1.2),('8902','2014-02-12','08:10:00',1.14),('8902','2014-02-12','08:15:00',1.36),('8902','2014-02-12','08:20:00',1.67),('8902','2014-02-12','08:25:00',1.89),('8902','2014-02-12','08:30:00',2.11),('8902','2014-02-12','08:35:00',2.23),('8902','2014-02-12','08:40:00',2.34),('8902','2014-02-12','08:45:00',2.55),('8902','2014-02-12','08:50:00',2.76),('8902','2014-02-12','08:55:00',2.97),('8902','2014-02-12','09:00:00',3.17),('8902','2014-02-12','09:05:00',3.38),('8902','2014-02-12','09:10:00',3.58),('8902','2014-02-12','09:15:00',3.7),('8902','2014-02-12','09:20:00',3.89),('8902','2014-02-12','09:25:00',4.05),('8902','2014-02-12','09:30:00',4.2),('8902','2014-02-12','09:35:00',4.37),('8902','2014-02-12','09:40:00',4.49),('8902','2014-02-12','09:45:00',4.6),('8902','2014-02-12','09:50:00',4.73),('8902','2014-02-12','09:55:00',4.87),('8902','2014-02-12','10:00:00',5),('8902','2014-02-12','10:05:00',5.12),('8902','2014-02-12','10:10:00',5.22),('8902','2014-02-12','10:15:00',5.32),('8902','2014-02-12','10:20:00',5.4),('8902','2014-02-12','10:25:00',5.45),('8902','2014-02-12','10:30:00',5.6),('8902','2014-02-12','10:35:00',5.69),('8902','2014-02-12','10:40:00',5.74),('8902','2014-02-12','10:45:00',5.73),('8902','2014-02-12','10:50:00',5.83),('8902','2014-02-12','10:55:00',5.95),('8902','2014-02-12','11:00:00',6),('8902','2014-02-12','11:05:00',6.06),('8902','2014-02-12','11:10:00',6.29),('8902','2014-02-12','11:15:00',6.43),('8902','2014-02-12','11:20:00',6.43),('8902','2014-02-12','11:25:00',6.09),('8902','2014-02-12','11:30:00',5.73),('8902','2014-02-12','11:35:00',6.42),('8902','2014-02-12','11:40:00',4.71),('8902','2014-02-12','11:45:00',6.94),('8902','2014-02-12','11:50:00',3.44),('8902','2014-02-12','11:55:00',6.62),('8902','2014-02-12','12:00:00',4.07),('8902','2014-02-12','12:05:00',3.4),('8902','2014-02-12','12:10:00',5.85),('8902','2014-02-12','12:15:00',5.18),('8902','2014-02-12','12:20:00',4.8),('8902','2014-02-12','12:25:00',2.31),('8902','2014-02-12','12:30:00',7.74),('8902','2014-02-12','12:35:00',8.1),('8902','2014-02-12','12:40:00',7.79),('8902','2014-02-12','12:45:00',1.68),('8902','2014-02-12','12:50:00',2.13),('8902','2014-02-12','12:55:00',3.9),('8902','2014-02-12','13:00:00',3.59),('8902','2014-02-12','13:05:00',7.37),('8902','2014-02-12','13:10:00',7.19),('8902','2014-02-12','13:15:00',7.01),('8902','2014-02-12','13:20:00',6.97),('8902','2014-02-12','13:25:00',6.87),('8902','2014-02-12','13:30:00',6.86),('8902','2014-02-12','13:35:00',6.81),('8902','2014-02-12','13:40:00',6.73),('8902','2014-02-12','13:45:00',6.71),('8902','2014-02-12','13:50:00',6.62),('8902','2014-02-12','13:55:00',6.59),('8902','2014-02-12','14:00:00',6.49),('8902','2014-02-12','14:05:00',6.4),('8902','2014-02-12','14:10:00',6.32),('8902','2014-02-12','14:15:00',6.22),('8902','2014-02-12','14:20:00',6.11),('8902','2014-02-12','14:25:00',6.03),('8902','2014-02-12','14:30:00',5.93),('8902','2014-02-12','14:35:00',5.88),('8902','2014-02-12','14:40:00',5.73),('8902','2014-02-12','14:45:00',5.45),('8902','2014-02-12','14:50:00',3.01),('8902','2014-02-12','14:55:00',5.68),('8902','2014-02-12','15:00:00',5.74),('8902','2014-02-12','15:05:00',4.41),('8902','2014-02-12','15:10:00',5.3),('8902','2014-02-12','15:15:00',4.4),('8902','2014-02-12','15:20:00',4.96),('8902','2014-02-12','15:25:00',4.79),('8902','2014-02-12','15:30:00',1.98),('8902','2014-02-12','15:35:00',3.14),('8902','2014-02-12','15:40:00',3.89),('8902','2014-02-12','15:45:00',4.16),('8902','2014-02-12','15:50:00',2.26),('8902','2014-02-12','15:55:00',2.93),('8902','2014-02-12','16:05:00',1.98),('8902','2014-02-12','16:10:00',3.26),('8902','2014-02-12','16:15:00',2.07),('8902','2014-02-12','16:30:00',1.06),('8902','2014-02-12','16:35:00',1.03),('8902','2014-02-11','08:20:00',1.46),('8902','2014-02-11','08:45:00',2.22),('8902','2014-02-11','08:50:00',2.74),('8902','2014-02-11','08:55:00',2.98),('8902','2014-02-11','09:00:00',1.38),('8902','2014-02-11','09:10:00',1.68),('8902','2014-02-11','09:15:00',3.8),('8902','2014-02-11','09:20:00',3.75),('8902','2014-02-11','09:25:00',3.44),('8902','2014-02-11','09:30:00',1.73),('8902','2014-02-11','09:35:00',1.5),('8902','2014-02-11','09:40:00',2.55),('8902','2014-02-11','09:45:00',4.32),('8902','2014-02-11','09:50:00',3.74),('8902','2014-02-11','09:55:00',3.07),('8902','2014-02-11','10:00:00',1.91),('8902','2014-02-11','10:05:00',2.93),('8902','2014-02-11','10:10:00',2.71),('8902','2014-02-11','10:15:00',2.2),('8902','2014-02-11','10:20:00',2.05),('8902','2014-02-11','10:25:00',2.23),('8902','2014-02-11','10:30:00',2.87),('8902','2014-02-11','10:35:00',4.21),('8902','2014-02-11','10:40:00',2.87),('8902','2014-02-11','10:45:00',4.16),('8902','2014-02-11','10:50:00',2.95),('8902','2014-02-11','10:55:00',2.9),('8902','2014-02-11','11:00:00',2.98),('8902','2014-02-11','11:05:00',5.56),('8902','2014-02-11','11:10:00',3.35),('8902','2014-02-11','11:15:00',3.06),('8902','2014-02-11','11:20:00',3.75),('8902','2014-02-11','11:25:00',3.25),('8902','2014-02-11','11:30:00',4.06),('8902','2014-02-11','11:35:00',3.94),('8902','2014-02-11','11:40:00',2.66),('8902','2014-02-11','11:45:00',2.1),('8902','2014-02-11','11:50:00',1.85),('8902','2014-02-11','11:55:00',1.54),('8902','2014-02-11','12:00:00',1.49),('8902','2014-02-11','12:05:00',2),('8902','2014-02-11','12:10:00',2.36),('8902','2014-02-11','12:15:00',2.5),('8902','2014-02-11','12:20:00',2.49),('8902','2014-02-11','12:25:00',2.63),('8902','2014-02-11','12:30:00',2.81),('8902','2014-02-11','12:35:00',2.69),('8902','2014-02-11','12:40:00',2.61),('8902','2014-02-11','12:45:00',2.9),('8902','2014-02-11','12:50:00',3.46),('8902','2014-02-11','12:55:00',3.46),('8902','2014-02-11','13:00:00',3.66),('8902','2014-02-11','13:05:00',2.97),('8902','2014-02-11','13:10:00',3.08),('8902','2014-02-11','13:15:00',2.96),('8902','2014-02-11','13:20:00',2.67),('8902','2014-02-11','13:25:00',3.28),('8902','2014-02-11','13:30:00',4.59),('8902','2014-02-11','13:35:00',7.31),('8902','2014-02-11','13:40:00',6.81),('8902','2014-02-11','13:45:00',5.25),('8902','2014-02-11','13:50:00',6.05),('8902','2014-02-11','13:55:00',5.11),('8902','2014-02-11','14:00:00',6.89),('8902','2014-02-11','14:05:00',6.98),('8902','2014-02-11','14:10:00',6.66),('8902','2014-02-11','14:15:00',6.85),('8902','2014-02-11','14:20:00',6.14),('8902','2014-02-11','14:25:00',6.46),('8902','2014-02-11','14:30:00',3.54),('8902','2014-02-11','14:35:00',5.34),('8902','2014-02-11','14:40:00',4.26),('8902','2014-02-11','14:45:00',4.22),('8902','2014-02-11','14:50:00',6.21),('8902','2014-02-11','14:55:00',5.89),('8902','2014-02-11','15:00:00',3.71),('8902','2014-02-11','15:05:00',2.54),('8902','2014-02-11','15:10:00',2.47),('8902','2014-02-11','15:15:00',2.44),('8902','2014-02-11','15:20:00',4.01),('8902','2014-02-11','15:25:00',3.38),('8902','2014-02-11','15:30:00',1.96),('8902','2014-02-11','15:35:00',4.33),('8902','2014-02-11','15:40:00',4.29),('8902','2014-02-11','15:45:00',3.21),('8902','2014-02-11','15:50:00',3.99),('8902','2014-02-11','15:55:00',1.6),('8902','2014-02-11','16:00:00',1.39),('8902','2014-02-11','16:05:00',1.21),('8902','2014-02-10','09:00:00',1.2),('8902','2014-02-10','09:05:00',1.32),('8902','2014-02-10','09:10:00',1.28),('8902','2014-02-10','09:15:00',1.54),('8902','2014-02-10','09:20:00',2.23),('8902','2014-02-10','09:25:00',2.46),('8902','2014-02-10','09:30:00',2.42),('8902','2014-02-10','09:35:00',2.42),('8902','2014-02-10','09:40:00',2.41),('8902','2014-02-10','09:45:00',2.31),('8902','2014-02-10','09:50:00',2.54),('8902','2014-02-10','09:55:00',2.66),('8902','2014-02-10','10:00:00',2.29),('8902','2014-02-10','10:05:00',2.46),('8902','2014-02-10','10:10:00',2.77),('8902','2014-02-10','10:15:00',3.26),('8902','2014-02-10','10:20:00',3.69),('8902','2014-02-10','10:25:00',3.86),('8902','2014-02-10','10:30:00',4.19),('8902','2014-02-10','10:35:00',4.89),('8902','2014-02-10','10:40:00',5),('8902','2014-02-10','10:45:00',4.39),('8902','2014-02-10','10:50:00',4.55),('8902','2014-02-10','10:55:00',3.97),('8902','2014-02-10','11:00:00',4.41),('8902','2014-02-10','11:05:00',4.51),('8902','2014-02-10','11:10:00',3.87),('8902','2014-02-10','11:15:00',3.18),('8902','2014-02-10','11:20:00',3.38),('8902','2014-02-10','11:25:00',4.28),('8902','2014-02-10','11:30:00',5.08),('8902','2014-02-10','11:35:00',5.14),('8902','2014-02-10','11:40:00',3.63),('8902','2014-02-10','11:45:00',3.04),('8902','2014-02-10','11:50:00',4.4),('8902','2014-02-10','11:55:00',2.93),('8902','2014-02-10','12:00:00',2.63),('8902','2014-02-10','12:05:00',3.19),('8902','2014-02-10','12:10:00',3.17),('8902','2014-02-10','12:15:00',3.05),('8902','2014-02-10','12:20:00',3.45),('8902','2014-02-10','12:25:00',4.61),('8902','2014-02-10','12:30:00',4.45),('8902','2014-02-10','12:35:00',3.77),('8902','2014-02-10','12:40:00',2.86),('8902','2014-02-10','12:45:00',3.4),('8902','2014-02-10','12:50:00',2.68),('8902','2014-02-10','12:55:00',3.35),('8902','2014-02-10','13:00:00',3.58),('8902','2014-02-10','13:05:00',4.43),('8902','2014-02-10','13:10:00',5.44),('8902','2014-02-10','13:15:00',5.34),('8902','2014-02-10','13:20:00',6.5),('8902','2014-02-10','13:25:00',5.95),('8902','2014-02-10','13:30:00',5.28),('8902','2014-02-10','13:35:00',5.03),('8902','2014-02-10','13:40:00',6.07),('8902','2014-02-10','13:45:00',4.65),('8902','2014-02-10','13:50:00',3.39),('8902','2014-02-10','13:55:00',2.72),('8902','2014-02-10','14:00:00',3.83),('8902','2014-02-10','14:05:00',4.03),('8902','2014-02-10','14:10:00',3.5),('8902','2014-02-10','14:15:00',3.85),('8902','2014-02-10','14:20:00',2.7),('8902','2014-02-10','14:25:00',2.44),('8902','2014-02-10','14:30:00',3.1),('8902','2014-02-10','14:35:00',2.85),('8902','2014-02-10','14:40:00',2.18),('8902','2014-02-10','14:45:00',2.05),('8902','2014-02-10','14:50:00',1.7),('8902','2014-02-10','14:55:00',1.77),('8902','2014-02-10','15:00:00',1.73),('8902','2014-02-10','15:05:00',1.78),('8902','2014-02-10','15:10:00',1.91),('8902','2014-02-10','15:15:00',2.45),('8902','2014-02-10','15:20:00',3.15),('8902','2014-02-10','15:25:00',2.13),('8902','2014-02-10','15:30:00',1.75),('8902','2014-02-10','15:35:00',1.84),('8902','2014-02-10','15:40:00',1.68),('8902','2014-02-10','15:45:00',1.36),('8902','2014-02-10','15:50:00',1.22),('8902','2014-02-10','15:55:00',1.25),('8902','2014-02-10','16:00:00',1.47),('8902','2014-02-10','16:05:00',1.93),('8902','2014-02-10','16:10:00',1.72),('8902','2014-02-10','16:15:00',1.66),('8902','2014-02-10','16:20:00',1.68),('8902','2014-02-10','16:25:00',1.79),('8902','2014-02-10','16:30:00',1.68),('8902','2014-02-10','16:35:00',1.47),('8902','2014-02-10','16:40:00',1.29),('8902','2014-02-10','16:45:00',1.02),('8902','2014-02-09','10:25:00',1.09),('8902','2014-02-09','10:30:00',1.09),('8902','2014-02-09','10:35:00',1.02),('8902','2014-02-09','12:25:00',1.7),('8902','2014-02-09','12:30:00',1.42),('8902','2014-02-09','12:35:00',1.02),('8902','2014-02-09','12:50:00',1.2),('8902','2014-02-09','12:55:00',1.8),('8902','2014-02-09','13:00:00',2.41),('8902','2014-02-09','13:05:00',2.04),('8902','2014-02-09','13:10:00',1.5),('8902','2014-02-09','13:15:00',1.47),('8902','2014-02-09','13:20:00',1.38),('8902','2014-02-09','13:25:00',1.28),('8902','2014-02-09','13:30:00',1.47),('8902','2014-02-09','13:35:00',1.64),('8902','2014-02-09','13:40:00',1.63),('8902','2014-02-09','13:45:00',1.63),('8902','2014-02-09','13:50:00',1.55),('8902','2014-02-09','13:55:00',1.83),('8902','2014-02-09','14:00:00',1.9),('8902','2014-02-09','14:05:00',1.64),('8902','2014-02-09','14:10:00',1.57),('8902','2014-02-09','14:15:00',1.63),('8902','2014-02-09','14:20:00',1.67),('8902','2014-02-09','14:25:00',1.77),('8902','2014-02-09','14:30:00',1.95),('8902','2014-02-09','14:35:00',2.09),('8902','2014-02-09','14:40:00',2.16),('8902','2014-02-09','14:45:00',1.91),('8902','2014-02-09','14:50:00',1.57),('8902','2014-02-09','14:55:00',1.39),('8902','2014-02-09','15:00:00',1.36),('8902','2014-02-09','15:05:00',1.49),('8902','2014-02-09','15:10:00',1.42),('8902','2014-02-09','15:15:00',1.4),('8902','2014-02-09','15:20:00',1.43),('8902','2014-02-09','15:25:00',1.51),('8902','2014-02-09','15:30:00',1.4),('8902','2014-02-09','15:35:00',1.14),('8902','2014-02-08','11:00:00',1.4),('8902','2014-02-08','11:05:00',1.35),('8902','2014-02-08','11:10:00',1.09),('8902','2014-02-08','11:15:00',1.13),('8902','2014-02-08','11:20:00',1.14),('8902','2014-02-08','11:25:00',1.8),('8902','2014-02-08','11:30:00',2.19),('8902','2014-02-08','11:35:00',2.6),('8902','2014-02-08','11:40:00',1.61),('8902','2014-02-08','12:15:00',1.55),('8902','2014-02-08','12:20:00',1.39),('8902','2014-02-08','12:25:00',2.74),('8902','2014-02-08','12:30:00',3.2),('8902','2014-02-08','12:35:00',2.21),('8902','2014-02-08','12:40:00',1.41),('8902','2014-02-08','12:45:00',4.41),('8902','2014-02-08','12:50:00',1.45),('8902','2014-02-08','12:55:00',2.87),('8902','2014-02-08','13:00:00',5.58),('8902','2014-02-08','13:05:00',5.01),('8902','2014-02-08','13:10:00',5.09),('8902','2014-02-08','13:15:00',3.57),('8902','2014-02-08','13:20:00',1.47),('8902','2014-02-08','13:25:00',1.98),('8902','2014-02-08','13:30:00',1.61),('8902','2014-02-08','13:35:00',1.55),('8902','2014-02-08','13:40:00',3.52),('8902','2014-02-08','13:45:00',6.57),('8902','2014-02-08','13:50:00',3.79),('8902','2014-02-08','13:55:00',5.7),('8902','2014-02-08','14:00:00',3.94),('8902','2014-02-08','14:05:00',5.59),('8902','2014-02-08','14:10:00',4.9),('8902','2014-02-08','14:15:00',2.52),('8902','2014-02-08','14:20:00',2.73),('8902','2014-02-08','14:25:00',3.31),('8902','2014-02-08','14:30:00',5.37),('8902','2014-02-08','14:35:00',4.49),('8902','2014-02-08','14:40:00',2.98),('8902','2014-02-08','14:45:00',1.86),('8902','2014-02-08','14:50:00',4.04),('8902','2014-02-08','14:55:00',2.21),('8902','2014-02-08','15:00:00',2.33),('8902','2014-02-08','15:05:00',1.12),('8902','2014-02-08','15:10:00',3.43),('8902','2014-02-08','15:15:00',3.71),('8902','2014-02-08','15:20:00',4.2),('8902','2014-02-08','15:25:00',3.94),('8902','2014-02-08','15:30:00',2.66),('8902','2014-02-08','15:35:00',2.13),('8902','2014-02-08','15:40:00',3.08),('8902','2014-02-08','15:45:00',3.07),('8902','2014-02-08','15:50:00',3.17),('8902','2014-02-08','15:55:00',2.94),('8902','2014-02-08','16:00:00',2.57),('8902','2014-02-08','16:05:00',2.38),('8902','2014-02-08','16:10:00',2.36),('8902','2014-02-08','16:15:00',2.11),('8902','2014-02-08','16:20:00',1.75),('8902','2014-02-08','16:25:00',1.51),('8902','2014-02-08','16:40:00',1.13),('8902','2014-02-07','09:40:00',1.02),('8902','2014-02-07','09:45:00',1.56),('8902','2014-02-07','09:50:00',3.08),('8902','2014-02-07','09:55:00',2.98),('8902','2014-02-07','10:00:00',1.62),('8902','2014-02-07','10:05:00',1.59),('8902','2014-02-07','10:10:00',1.6),('8902','2014-02-07','10:15:00',2.82),('8902','2014-02-07','10:20:00',3.54),('8902','2014-02-07','10:25:00',2.33),('8902','2014-02-07','10:30:00',3.42),('8902','2014-02-07','10:35:00',5.45),('8902','2014-02-07','10:40:00',3.52),('8902','2014-02-07','10:45:00',2.7),('8902','2014-02-07','10:50:00',3.88),('8902','2014-02-07','10:55:00',6.21),('8902','2014-02-07','11:00:00',3.95),('8902','2014-02-07','11:05:00',6.52),('8902','2014-02-07','11:10:00',5.33),('8902','2014-02-07','11:15:00',3.27),('8902','2014-02-07','11:20:00',3.66),('8902','2014-02-07','11:25:00',2.45),('8902','2014-02-07','11:30:00',1.82),('8902','2014-02-07','11:35:00',7.01),('8902','2014-02-07','11:40:00',5.69),('8902','2014-02-07','11:45:00',1.33),('8902','2014-02-07','11:50:00',1.53),('8902','2014-02-07','11:55:00',7.53),('8902','2014-02-07','12:00:00',5.13),('8902','2014-02-07','12:05:00',2.05),('8902','2014-02-07','12:10:00',3.04),('8902','2014-02-07','12:15:00',7.94),('8902','2014-02-07','12:20:00',2.95),('8902','2014-02-07','12:25:00',2.29),('8902','2014-02-07','12:30:00',7.85),('8902','2014-02-07','12:35:00',4.9),('8902','2014-02-07','12:40:00',5.48),('8902','2014-02-07','12:45:00',5.1),('8902','2014-02-07','12:50:00',7.16),('8902','2014-02-07','12:55:00',7.12),('8902','2014-02-07','13:00:00',3.67),('8902','2014-02-07','13:05:00',3.08),('8902','2014-02-07','13:10:00',2.43),('8902','2014-02-07','13:15:00',8.21),('8902','2014-02-07','13:20:00',8.18),('8902','2014-02-07','13:25:00',6.94),('8902','2014-02-07','13:30:00',7.02),('8902','2014-02-07','13:35:00',3.87),('8902','2014-02-07','13:40:00',6.16),('8902','2014-02-07','13:45:00',7.21),('8902','2014-02-07','13:50:00',6.62),('8902','2014-02-07','13:55:00',6.31),('8902','2014-02-07','14:00:00',6.54),('8902','2014-02-07','14:05:00',6.51),('8902','2014-02-07','14:10:00',4.48),('8902','2014-02-07','14:15:00',3.44),('8902','2014-02-07','14:20:00',5.27),('8902','2014-02-07','14:25:00',3.66),('8902','2014-02-07','14:30:00',6.61),('8902','2014-02-07','14:35:00',4.04),('8902','2014-02-07','14:40:00',5.47),('8902','2014-02-07','14:45:00',1.97),('8902','2014-02-07','14:50:00',4.59),('8902','2014-02-07','14:55:00',5.54),('8902','2014-02-07','15:00:00',3.19),('8902','2014-02-07','15:05:00',1.93),('8902','2014-02-07','15:10:00',1.73),('8902','2014-02-07','15:15:00',1.65),('8902','2014-02-07','15:20:00',4.84),('8902','2014-02-07','15:25:00',2.41),('8902','2014-02-07','15:35:00',1.07),('8902','2014-02-07','15:40:00',3.45),('8902','2014-02-07','15:45:00',4.12),('8902','2014-02-07','15:50:00',3.64),('8902','2014-02-07','15:55:00',3.38),('8902','2014-02-07','16:00:00',1.55),('8902','2014-02-07','16:05:00',2.23),('8902','2014-02-07','16:10:00',2.66),('8902','2014-02-07','16:15:00',1.5),('8902','2014-02-07','16:20:00',1.17),('8902','2014-02-06','08:25:00',1.56),('8902','2014-02-06','08:30:00',1.55),('8902','2014-02-06','08:35:00',1.25),('8902','2014-02-06','08:40:00',2.16),('8902','2014-02-06','08:45:00',2.37),('8902','2014-02-06','08:50:00',2.52),('8902','2014-02-06','08:55:00',2.69),('8902','2014-02-06','09:00:00',2.86),('8902','2014-02-06','09:05:00',3.04),('8902','2014-02-06','09:10:00',3.23),('8902','2014-02-06','09:15:00',3.39),('8902','2014-02-06','09:20:00',3.55),('8902','2014-02-06','09:25:00',3.73),('8902','2014-02-06','09:30:00',3.87),('8902','2014-02-06','09:35:00',4.03),('8902','2014-02-06','09:40:00',4.18),('8902','2014-02-06','09:45:00',4.3),('8902','2014-02-06','09:50:00',4.43),('8902','2014-02-06','09:55:00',4.53),('8902','2014-02-06','10:00:00',4.65),('8902','2014-02-06','10:05:00',4.74),('8902','2014-02-06','10:10:00',4.84),('8902','2014-02-06','10:15:00',5.01),('8902','2014-02-06','10:20:00',5.16),('8902','2014-02-06','10:25:00',5.23),('8902','2014-02-06','10:30:00',5.44),('8902','2014-02-06','10:35:00',4.96),('8902','2014-02-06','10:40:00',5.72),('8902','2014-02-06','10:45:00',5.96),('8902','2014-02-06','10:50:00',4.97),('8902','2014-02-06','10:55:00',4.94),('8902','2014-02-06','11:00:00',5.55),('8902','2014-02-06','11:05:00',4.34),('8902','2014-02-06','11:10:00',4.44),('8902','2014-02-06','11:15:00',6.49),('8902','2014-02-06','11:20:00',6.82),('8902','2014-02-06','11:25:00',6.85),('8902','2014-02-06','11:30:00',6.6),('8902','2014-02-06','11:35:00',6.53),('8902','2014-02-06','11:40:00',6.71),('8902','2014-02-06','11:45:00',7.03),('8902','2014-02-06','11:50:00',7.13),('8902','2014-02-06','11:55:00',6.96),('8902','2014-02-06','12:00:00',7.67),('8902','2014-02-06','12:05:00',7.13),('8902','2014-02-06','12:10:00',7.32),('8902','2014-02-06','12:15:00',4.23),('8902','2014-02-06','12:20:00',3.23),('8902','2014-02-06','12:25:00',7.96),('8902','2014-02-06','12:30:00',5.74),('8902','2014-02-06','12:35:00',1.91),('8902','2014-02-06','12:40:00',3.48),('8902','2014-02-06','12:45:00',2.48),('8902','2014-02-06','12:50:00',4.01),('8902','2014-02-06','12:55:00',6.1),('8902','2014-02-06','13:00:00',4.93),('8902','2014-02-06','13:05:00',5.96),('8902','2014-02-06','13:10:00',8.21),('8902','2014-02-06','13:15:00',7.58),('8902','2014-02-06','13:20:00',2.57),('8902','2014-02-06','13:25:00',3.89),('8902','2014-02-06','13:30:00',4.91),('8902','2014-02-06','13:35:00',4.67),('8902','2014-02-06','13:40:00',2.62),('8902','2014-02-06','13:45:00',5.36),('8902','2014-02-06','13:50:00',5.92),('8902','2014-02-06','13:55:00',6.14),('8902','2014-02-06','14:00:00',6.12),('8902','2014-02-06','14:05:00',6.75),('8902','2014-02-06','14:10:00',5.64),('8902','2014-02-06','14:15:00',4.43),('8902','2014-02-06','14:20:00',2.59),('8902','2014-02-06','14:25:00',1.44),('8902','2014-02-06','14:30:00',3.15),('8902','2014-02-06','14:35:00',2.38),('8902','2014-02-06','14:40:00',4.37),('8902','2014-02-06','14:45:00',5.29),('8902','2014-02-06','14:50:00',5.31),('8902','2014-02-06','14:55:00',5.23),('8902','2014-02-06','15:00:00',5.04),('8902','2014-02-06','15:05:00',4.97),('8902','2014-02-06','15:10:00',4.87),('8902','2014-02-06','15:15:00',4.59),('8902','2014-02-06','15:20:00',3.45),('8902','2014-02-06','15:25:00',4.29),('8902','2014-02-06','15:30:00',4.13),('8902','2014-02-06','15:35:00',3.97),('8902','2014-02-06','15:40:00',3.81),('8902','2014-02-06','15:45:00',3.61),('8902','2014-02-06','15:50:00',3.4),('8902','2014-02-06','15:55:00',3.25),('8902','2014-02-06','16:00:00',3.05),('8902','2014-02-06','16:05:00',2.89),('8902','2014-02-06','16:10:00',2.72),('8902','2014-02-06','16:15:00',2.5),('8902','2014-02-06','16:20:00',2.21),('8902','2014-02-06','16:25:00',2.06),('8902','2014-02-06','16:30:00',1.86),('8902','2014-02-06','16:35:00',1.66),('8902','2014-02-06','16:40:00',1.45),('8902','2014-02-06','16:45:00',1.23),('8902','2014-02-06','16:50:00',1.02),('8902','2014-02-05','08:20:00',1.22),('8902','2014-02-05','08:25:00',1.39),('8902','2014-02-05','08:30:00',1.08),('8902','2014-02-05','08:35:00',1.02),('8902','2014-02-05','08:40:00',2.05),('8902','2014-02-05','08:45:00',2.23),('8902','2014-02-05','08:50:00',2.51),('8902','2014-02-05','08:55:00',2.88),('8902','2014-02-05','09:00:00',3.52),('8902','2014-02-05','09:05:00',3.95),('8902','2014-02-05','09:10:00',3.04),('8902','2014-02-05','09:15:00',3.05),('8902','2014-02-05','09:20:00',1.26),('8902','2014-02-05','09:25:00',1.21),('8902','2014-02-05','09:30:00',3.62),('8902','2014-02-05','09:35:00',4.16),('8902','2014-02-05','09:40:00',4.3),('8902','2014-02-05','09:45:00',4.4),('8902','2014-02-05','09:50:00',4.54),('8902','2014-02-05','09:55:00',4.62),('8902','2014-02-05','10:00:00',4.75),('8902','2014-02-05','10:05:00',4.88),('8902','2014-02-05','10:10:00',5.01),('8902','2014-02-05','10:15:00',5.12),('8902','2014-02-05','10:20:00',5.24),('8902','2014-02-05','10:25:00',5.34),('8902','2014-02-05','10:30:00',5.52),('8902','2014-02-05','10:35:00',5.85),('8902','2014-02-05','10:40:00',4.55),('8902','2014-02-05','10:45:00',5.21),('8902','2014-02-05','10:50:00',2.84),('8902','2014-02-05','10:55:00',3.85),('8902','2014-02-05','11:00:00',4.75),('8902','2014-02-05','11:05:00',2.48),('8902','2014-02-05','11:10:00',3.22),('8902','2014-02-05','11:15:00',2.61),('8902','2014-02-05','11:20:00',3.61),('8902','2014-02-05','11:25:00',6.86),('8902','2014-02-05','11:30:00',6.47),('8902','2014-02-05','11:35:00',6.68),('8902','2014-02-05','11:40:00',6.64),('8902','2014-02-05','11:45:00',6.69),('8902','2014-02-05','11:50:00',6.75),('8902','2014-02-05','11:55:00',6.73),('8902','2014-02-05','12:00:00',6.85),('8902','2014-02-05','12:05:00',7.03),('8902','2014-02-05','12:10:00',7.02),('8902','2014-02-05','12:15:00',6.82),('8902','2014-02-05','12:20:00',6.86),('8902','2014-02-05','12:25:00',6.86),('8902','2014-02-05','12:30:00',6.92),('8902','2014-02-05','12:35:00',6.29),('8902','2014-02-05','12:40:00',6.82),('8902','2014-02-05','12:45:00',6.4),('8902','2014-02-05','12:50:00',6.79),('8902','2014-02-05','12:55:00',6.81),('8902','2014-02-05','13:00:00',6.82),('8902','2014-02-05','13:05:00',5.15),('8902','2014-02-05','13:10:00',7.03),('8902','2014-02-05','13:15:00',7),('8902','2014-02-05','13:20:00',7.12),('8902','2014-02-05','13:25:00',6.5),('8902','2014-02-05','13:30:00',4.9),('8902','2014-02-05','13:35:00',6.46),('8902','2014-02-05','13:40:00',6.6),('8902','2014-02-05','13:45:00',6.5),('8902','2014-02-05','13:50:00',6.54),('8902','2014-02-05','13:55:00',5.65),('8902','2014-02-05','14:00:00',6.32),('8902','2014-02-05','14:05:00',5.9),('8902','2014-02-05','14:10:00',6.02),('8902','2014-02-05','14:15:00',6),('8902','2014-02-05','14:20:00',5.89),('8902','2014-02-05','14:25:00',5.86),('8902','2014-02-05','14:30:00',3.96),('8902','2014-02-05','14:35:00',2.16),('8902','2014-02-05','14:40:00',5.2),('8902','2014-02-05','14:45:00',4.11),('8902','2014-02-05','14:50:00',3.64),('8902','2014-02-05','14:55:00',5.34),('8902','2014-02-05','15:00:00',5.07),('8902','2014-02-05','15:05:00',4.86),('8902','2014-02-05','15:10:00',4.73),('8902','2014-02-05','15:15:00',4.67),('8902','2014-02-05','15:20:00',4.61),('8902','2014-02-05','15:25:00',4.19),('8902','2014-02-05','15:30:00',3.99),('8902','2014-02-05','15:35:00',3.83),('8902','2014-02-05','15:40:00',3.66),('8902','2014-02-05','15:45:00',3.51),('8902','2014-02-05','15:50:00',3.29),('8902','2014-02-05','15:55:00',3.08),('8902','2014-02-05','16:00:00',2.85),('8902','2014-02-05','16:05:00',2.71),('8902','2014-02-05','16:10:00',2.55),('8902','2014-02-05','16:15:00',2.34),('8902','2014-02-05','16:20:00',2.11),('8902','2014-02-05','16:25:00',1.93),('8902','2014-02-05','16:30:00',1.76),('8902','2014-02-05','16:35:00',1.57),('8902','2014-02-05','16:40:00',1.36),('8902','2014-02-05','16:45:00',1.15),('8902','2014-04-26','08:50:00',1.28),('8902','2014-04-26','08:55:00',1.73),('8902','2014-04-26','09:00:00',1.61),('8902','2014-04-26','09:15:00',1.25),('8902','2014-04-26','09:20:00',1.65),('8902','2014-04-26','09:25:00',1.63),('8902','2014-04-26','09:30:00',1.27),('8902','2014-04-26','09:35:00',1.02),('8902','2014-04-26','09:40:00',1.26),('8902','2014-04-26','09:45:00',1.74),('8902','2014-04-26','09:50:00',1.54),('8902','2014-04-26','09:55:00',1.46),('8902','2014-04-26','10:00:00',2.03),('8902','2014-04-26','10:05:00',1.99),('8902','2014-04-26','10:10:00',2.12),('8902','2014-04-26','10:15:00',1.73),('8902','2014-04-26','10:20:00',1.61),('8902','2014-04-26','10:25:00',1.3),('8902','2014-04-26','10:55:00',1.41),('8902','2014-04-26','11:00:00',2.21),('8902','2014-04-26','11:05:00',2.6),('8902','2014-04-26','11:10:00',3.3),('8902','2014-04-26','11:15:00',3.12),('8902','2014-04-26','11:20:00',2.4),('8902','2014-04-26','11:25:00',1.66),('8902','2014-04-26','11:30:00',1.93),('8902','2014-04-26','11:35:00',3.25),('8902','2014-04-26','11:40:00',3.58),('8902','2014-04-26','11:45:00',6.28),('8902','2014-04-26','11:50:00',5.17),('8902','2014-04-26','11:55:00',4.74),('8902','2014-04-26','12:00:00',4.94),('8902','2014-04-26','12:05:00',5.25),('8902','2014-04-26','12:10:00',6.3),('8902','2014-04-26','12:15:00',5.9),('8902','2014-04-26','12:20:00',5.03),('8902','2014-04-26','12:25:00',5.48),('8902','2014-04-26','12:30:00',5.03),('8902','2014-04-26','12:35:00',5.15),('8902','2014-04-26','12:40:00',4.59),('8902','2014-04-26','12:45:00',5.2),('8902','2014-04-26','12:50:00',4.2),('8902','2014-04-26','12:55:00',3.14),('8902','2014-04-26','13:00:00',3.84),('8902','2014-04-26','13:05:00',4.01),('8902','2014-04-26','13:10:00',3.32),('8902','2014-04-26','13:15:00',3.39),('8902','2014-04-26','13:20:00',4.74),('8902','2014-04-26','13:25:00',4.49),('8902','2014-04-26','13:30:00',4),('8902','2014-04-26','13:35:00',3.4),('8902','2014-04-26','13:40:00',3.25),('8902','2014-04-26','13:45:00',3.07),('8902','2014-04-26','13:50:00',2.97),('8902','2014-04-26','13:55:00',2.77),('8902','2014-04-26','14:00:00',3.53),('8902','2014-04-26','14:05:00',4.74),('8902','2014-04-26','14:10:00',3.34),('8902','2014-04-26','14:15:00',3.04),('8902','2014-04-26','14:20:00',3.49),('8902','2014-04-26','14:25:00',4.34),('8902','2014-04-26','14:30:00',4.63),('8902','2014-04-26','14:35:00',4.4),('8902','2014-04-26','14:40:00',4.46),('8902','2014-04-26','14:45:00',3.9),('8902','2014-04-26','14:50:00',3.67),('8902','2014-04-26','14:55:00',3.98),('8902','2014-04-26','15:00:00',4.21),('8902','2014-04-26','15:05:00',6.02),('8902','2014-04-26','15:10:00',8.42),('8902','2014-04-26','15:15:00',6.25),('8902','2014-04-26','15:20:00',3.8),('8902','2014-04-26','15:25:00',2.37),('8902','2014-04-26','15:30:00',1.83),('8902','2014-04-26','15:35:00',2),('8902','2014-04-26','15:40:00',2),('8902','2014-04-26','15:45:00',1.79),('8902','2014-04-26','15:50:00',1.72),('8902','2014-04-26','15:55:00',1.16),('8902','2014-02-04','10:10:00',1.56),('8902','2014-02-04','10:15:00',3.08),('8902','2014-02-04','10:20:00',5.57),('8902','2014-02-04','10:25:00',5.72),('8902','2014-02-04','10:30:00',1.91),('8902','2014-02-04','10:35:00',2.53),('8902','2014-02-04','10:40:00',1.88),('8902','2014-02-04','10:50:00',1.7),('8902','2014-02-04','10:55:00',1.74),('8902','2014-02-04','11:00:00',1.31),('8902','2014-02-04','11:10:00',1.73),('8902','2014-02-04','11:15:00',5.14),('8902','2014-02-04','11:20:00',6.08),('8902','2014-02-04','11:25:00',5.37),('8902','2014-02-04','11:30:00',2.59),('8902','2014-02-04','11:35:00',1.22),('8902','2014-02-04','12:55:00',2.3),('8902','2014-02-04','13:00:00',1.96),('8902','2014-02-04','13:05:00',1.91),('8902','2014-02-04','13:10:00',2.34),('8902','2014-02-04','13:15:00',2.03),('8902','2014-02-04','13:20:00',2.34),('8902','2014-02-04','13:25:00',3.56),('8902','2014-02-04','13:30:00',3.56),('8902','2014-02-04','13:35:00',4.21),('8902','2014-02-04','13:40:00',4.03),('8902','2014-02-04','13:45:00',4.19),('8902','2014-02-04','13:50:00',3.37),('8902','2014-02-04','13:55:00',2.38),('8902','2014-02-04','14:00:00',1.79),('8902','2014-02-04','14:05:00',1.23),('8902','2014-02-04','14:15:00',1.02),('8902','2014-02-04','14:30:00',2.56),('8902','2014-02-04','14:35:00',3.73),('8902','2014-02-04','14:40:00',1.53),('8902','2014-02-04','14:45:00',1.06),('8902','2014-02-04','14:50:00',1.06),('8902','2014-02-04','15:00:00',1),('8902','2014-02-04','15:05:00',1.01),('8902','2014-02-03','08:35:00',1.01),('8902','2014-02-03','08:40:00',1.05),('8902','2014-02-03','08:45:00',1.1),('8902','2014-02-03','08:50:00',1.13),('8902','2014-02-03','08:55:00',1.23),('8902','2014-02-03','09:00:00',1.32),('8902','2014-02-03','09:05:00',1.42),('8902','2014-02-03','09:10:00',1.57),('8902','2014-02-03','09:15:00',1.9),('8902','2014-02-03','09:20:00',2.43),('8902','2014-02-03','09:25:00',4.73),('8902','2014-02-03','09:30:00',4.53),('8902','2014-02-03','09:35:00',5.04),('8902','2014-02-03','09:40:00',4.55),('8902','2014-02-03','09:45:00',4.38),('8902','2014-02-03','09:50:00',3.68),('8902','2014-02-03','09:55:00',4.45),('8902','2014-02-03','10:00:00',5.02),('8902','2014-02-03','10:05:00',4.19),('8902','2014-02-03','10:10:00',3.03),('8902','2014-02-03','10:15:00',4.15),('8902','2014-02-03','10:20:00',2.4),('8902','2014-02-03','10:25:00',1.79),('8902','2014-02-03','10:30:00',1.33),('8902','2014-02-03','10:35:00',1.76),('8902','2014-02-03','10:40:00',2.64),('8902','2014-02-03','10:45:00',3.33),('8902','2014-02-03','10:50:00',4.77),('8902','2014-02-03','10:55:00',5.44),('8902','2014-02-03','11:00:00',2.77),('8902','2014-02-03','11:05:00',2.12),('8902','2014-02-03','11:10:00',2.11),('8902','2014-02-03','11:15:00',1.77),('8902','2014-02-03','11:20:00',1.61),('8902','2014-02-03','11:25:00',1.75),('8902','2014-02-03','11:30:00',1.97),('8902','2014-02-03','11:35:00',2.11),('8902','2014-02-03','11:40:00',2.52),('8902','2014-02-03','11:45:00',1.33),('8902','2014-02-03','11:50:00',2.54),('8902','2014-02-03','11:55:00',7.05),('8902','2014-02-03','12:00:00',7.74),('8902','2014-02-03','12:05:00',3.18),('8902','2014-02-03','12:10:00',3.17),('8902','2014-02-03','12:15:00',3.22),('8902','2014-02-03','12:20:00',2.88),('8902','2014-02-03','12:25:00',2.82),('8902','2014-02-03','12:30:00',2.54),('8902','2014-02-03','12:35:00',1.82),('8902','2014-02-03','12:40:00',1.64),('8902','2014-02-03','12:45:00',2.14),('8902','2014-02-03','12:50:00',2.68),('8902','2014-02-03','12:55:00',1.86),('8902','2014-02-03','13:00:00',2.24),('8902','2014-02-03','13:05:00',2.47),('8902','2014-02-03','13:10:00',1.96),('8902','2014-02-03','13:15:00',2.22),('8902','2014-02-03','13:20:00',2.61),('8902','2014-02-03','13:25:00',2.19),('8902','2014-02-03','13:30:00',1.61),('8902','2014-02-03','13:35:00',1.51),('8902','2014-02-03','13:40:00',1.48),('8902','2014-02-03','13:45:00',1.61),('8902','2014-02-03','13:50:00',1.96),('8902','2014-02-03','13:55:00',1.76),('8902','2014-02-03','14:00:00',1.32),('8902','2014-02-03','14:05:00',1.15),('8902','2014-02-03','14:10:00',1.44),('8902','2014-02-03','14:15:00',1.67),('8902','2014-02-03','14:20:00',1.66),('8902','2014-02-03','14:25:00',1.24),('8902','2014-02-03','15:10:00',1.02),('8902','2014-02-02','09:05:00',1.01),('8902','2014-02-02','09:20:00',1.06),('8902','2014-02-02','09:25:00',1.15),('8902','2014-02-02','09:30:00',1.2),('8902','2014-02-02','09:35:00',1.27),('8902','2014-02-02','09:40:00',1.42),('8902','2014-02-02','09:45:00',1.6),('8902','2014-02-02','09:50:00',1.83),('8902','2014-02-02','09:55:00',1.64),('8902','2014-02-02','10:00:00',1.49),('8902','2014-02-02','10:05:00',1.52),('8902','2014-02-02','10:10:00',1.79),('8902','2014-02-02','10:15:00',2.1),('8902','2014-02-02','10:20:00',2.03),('8902','2014-02-02','10:25:00',2.08),('8902','2014-02-02','10:30:00',2.12),('8902','2014-02-02','10:35:00',2.11),('8902','2014-02-02','10:40:00',2.2),('8902','2014-02-02','10:45:00',2.17),('8902','2014-02-02','10:50:00',2.2),('8902','2014-02-02','10:55:00',2.18),('8902','2014-02-02','11:00:00',2.03),('8902','2014-02-02','11:05:00',1.91),('8902','2014-02-02','11:10:00',1.98),('8902','2014-02-02','11:15:00',2.03),('8902','2014-02-02','11:20:00',2.13),('8902','2014-02-02','11:25:00',2.27),('8902','2014-02-02','11:30:00',2.49),('8902','2014-02-02','11:35:00',2.53),('8902','2014-02-02','11:40:00',2.47),('8902','2014-02-02','11:45:00',2.41),('8902','2014-02-02','11:50:00',2.34),('8902','2014-02-02','11:55:00',1.96),('8902','2014-02-02','12:00:00',1.67),('8902','2014-02-02','12:05:00',1.7),('8902','2014-02-02','12:10:00',1.78),('8902','2014-02-02','12:15:00',1.91),('8902','2014-02-02','12:20:00',1.77),('8902','2014-02-02','12:25:00',1.54),('8902','2014-02-02','12:30:00',1.19),('8902','2014-02-02','12:35:00',1.06),('8902','2014-02-02','12:40:00',1.19),('8902','2014-02-02','12:55:00',1.23),('8902','2014-02-02','13:00:00',1.32),('8902','2014-02-02','13:05:00',1.26),('8902','2014-02-02','13:10:00',1.35),('8902','2014-02-02','13:15:00',1.5),('8902','2014-02-02','13:20:00',1.55),('8902','2014-02-02','13:25:00',1.66),('8902','2014-02-02','13:30:00',1.73),('8902','2014-02-02','13:35:00',1.64),('8902','2014-02-02','13:40:00',1.5),('8902','2014-02-02','13:45:00',1.46),('8902','2014-02-02','13:50:00',1.54),('8902','2014-02-02','13:55:00',1.57),('8902','2014-02-02','14:00:00',1.67),('8902','2014-02-02','14:05:00',1.75),('8902','2014-02-02','14:10:00',1.78),('8902','2014-02-02','14:15:00',1.7),('8902','2014-02-02','14:20:00',1.55),('8902','2014-02-02','14:25:00',1.74),('8902','2014-02-02','14:30:00',1.86),('8902','2014-02-02','14:35:00',1.87),('8902','2014-02-02','14:40:00',1.86),('8902','2014-02-02','14:45:00',1.76),('8902','2014-02-02','14:50:00',1.59),('8902','2014-02-02','14:55:00',1.3),('8902','2014-02-02','15:20:00',1.02),('8902','2014-02-02','15:25:00',1.06),('8902','2014-02-01','11:20:00',1.05),('8902','2014-02-01','11:25:00',1.23),('8902','2014-02-01','11:30:00',1.35),('8902','2014-02-01','11:35:00',1.26),('8902','2014-02-01','11:40:00',1.31),('8902','2014-02-01','11:45:00',1.44),('8902','2014-02-01','11:50:00',1.57),('8902','2014-02-01','11:55:00',1.77),('8902','2014-02-01','12:00:00',1.95),('8902','2014-02-01','12:05:00',2.01),('8902','2014-02-01','12:10:00',1.92),('8902','2014-02-01','12:15:00',1.68),('8902','2014-02-01','12:20:00',1.45),('8902','2014-02-01','12:25:00',1.3),('8902','2014-02-01','12:30:00',1.3),('8902','2014-02-01','12:35:00',1.26),('8902','2014-02-01','12:40:00',1.15),('8902','2014-02-01','12:45:00',1),('8902','2014-02-01','13:15:00',1.17),('8902','2014-02-01','13:20:00',1.32),('8902','2014-02-01','13:25:00',1.28),('8902','2014-02-01','13:30:00',1.07),('8902','2014-02-01','13:55:00',1.05),('8902','2014-02-01','14:00:00',1.03),('8902','2014-02-01','14:05:00',1.05),('8902','2014-02-01','14:20:00',1.07),('8902','2014-02-01','14:25:00',1.08),('8902','2014-02-01','15:00:00',1.05),('8902','2014-02-01','15:05:00',1.09),('8902','2014-02-01','15:10:00',1.09),('8902','2014-02-01','15:15:00',1.02),('8902','2014-01-31','08:45:00',1.03),('8902','2014-01-31','08:50:00',1.18),('8902','2014-01-31','08:55:00',1.01),('8902','2014-01-31','09:05:00',1.01),('8902','2014-01-31','09:10:00',1.03),('8902','2014-01-31','09:15:00',1.2),('8902','2014-01-31','09:20:00',1.18),('8902','2014-01-31','09:25:00',1.22),('8902','2014-01-31','09:30:00',1.02),('8902','2014-01-31','09:55:00',1.04),('8902','2014-01-31','10:15:00',1.27),('8902','2014-01-31','10:20:00',1.46),('8902','2014-01-31','10:25:00',1.33),('8902','2014-01-31','10:30:00',1.26),('8902','2014-01-31','10:35:00',1.25),('8902','2014-01-31','10:40:00',1.33),('8902','2014-01-31','10:45:00',1.45),('8902','2014-01-31','10:50:00',1.55),('8902','2014-01-31','10:55:00',1.76),('8902','2014-01-31','11:00:00',2.39),('8902','2014-01-31','11:05:00',2.36),('8902','2014-01-31','11:10:00',1.77),('8902','2014-01-31','11:15:00',2.21),('8902','2014-01-31','11:20:00',3.73),('8902','2014-01-31','11:25:00',2.36),('8902','2014-01-31','11:30:00',4.51),('8902','2014-01-31','11:35:00',4.06),('8902','2014-01-31','11:40:00',2.68),('8902','2014-01-31','11:45:00',1.51),('8902','2014-01-31','11:50:00',1.66),('8902','2014-01-31','11:55:00',3.89),('8902','2014-01-31','12:00:00',3.43),('8902','2014-01-31','12:05:00',3.31),('8902','2014-01-31','12:10:00',4.21),('8902','2014-01-31','12:15:00',2.82),('8902','2014-01-31','12:20:00',4.67),('8902','2014-01-31','12:25:00',2.77),('8902','2014-01-31','12:30:00',1.47),('8902','2014-01-31','12:35:00',2.13),('8902','2014-01-31','12:40:00',3.94),('8902','2014-01-31','12:45:00',4.85),('8902','2014-01-31','12:50:00',4.15),('8902','2014-01-31','12:55:00',2.46),('8902','2014-01-31','13:00:00',2.53),('8902','2014-01-31','13:05:00',2.11),('8902','2014-01-31','13:10:00',1.51),('8902','2014-01-31','13:15:00',1.28),('8902','2014-01-31','13:20:00',1.18),('8902','2014-01-31','13:25:00',1.26),('8902','2014-01-31','13:30:00',1.34),('8902','2014-01-31','13:35:00',1.26),('8902','2014-01-31','13:40:00',1.19),('8902','2014-01-31','13:45:00',1.22),('8902','2014-01-31','13:50:00',1.2),('8902','2014-01-30','10:15:00',1.06),('8902','2014-01-30','10:20:00',1.2),('8902','2014-01-30','10:25:00',1.25),('8902','2014-01-30','10:30:00',1.56),('8902','2014-01-30','10:35:00',1.28),('8902','2014-01-30','11:35:00',1.16),('8902','2014-01-30','11:40:00',1.31),('8902','2014-01-30','11:45:00',1.38),('8902','2014-01-30','11:50:00',1.45),('8902','2014-01-30','11:55:00',1.28),('8902','2014-01-30','12:00:00',1.06),('8902','2014-01-30','12:05:00',1.04),('8902','2014-01-30','12:10:00',1.19),('8902','2014-01-30','12:15:00',1.33),('8902','2014-01-30','12:20:00',1.28),('8902','2014-01-30','12:25:00',1.36),('8902','2014-01-30','12:30:00',1.39),('8902','2014-01-30','12:35:00',1.54),('8902','2014-01-30','12:40:00',1.23),('8902','2014-01-30','13:40:00',1.04),('8902','2014-01-30','13:45:00',1.41),('8902','2014-01-30','13:50:00',1.73),('8902','2014-01-30','13:55:00',1.4),('8902','2014-01-30','14:00:00',1),('8902','2014-01-30','14:05:00',1.04),('8902','2014-01-30','14:10:00',1.14),('8902','2014-01-30','14:15:00',1.3),('8902','2014-01-30','14:20:00',1.25),('8902','2014-01-30','14:40:00',1.07),('8902','2014-01-30','14:45:00',1.47),('8902','2014-01-29','08:55:00',1.06),('8902','2014-01-29','09:00:00',1.16),('8902','2014-01-29','09:05:00',1.24),('8902','2014-01-29','09:10:00',1.33),('8902','2014-01-29','09:15:00',1.5),('8902','2014-01-29','09:20:00',1.65),('8902','2014-01-29','09:25:00',1.72),('8902','2014-01-29','09:30:00',1.62),('8902','2014-01-29','09:35:00',1.62),('8902','2014-01-29','09:40:00',2.08),('8902','2014-01-29','09:45:00',1.72),('8902','2014-01-29','09:50:00',2.59),('8902','2014-01-29','09:55:00',4.12),('8902','2014-01-29','10:00:00',3.89),('8902','2014-01-29','10:05:00',3.14),('8902','2014-01-29','10:10:00',3.77),('8902','2014-01-29','10:15:00',4.62),('8902','2014-01-29','10:20:00',4.09),('8902','2014-01-29','10:25:00',4.65),('8902','2014-01-29','10:30:00',4.99),('8902','2014-01-29','10:35:00',5.02),('8902','2014-01-29','10:40:00',5),('8902','2014-01-29','10:45:00',4.59),('8902','2014-01-29','10:50:00',5.58),('8902','2014-01-29','10:55:00',6.55),('8902','2014-01-29','11:00:00',6.34),('8902','2014-01-29','11:05:00',6.04),('8902','2014-01-29','11:10:00',5.97),('8902','2014-01-29','11:15:00',5.81),('8902','2014-01-29','11:20:00',5.38),('8902','2014-01-29','11:25:00',5.8),('8902','2014-01-29','11:30:00',4.98),('8902','2014-01-29','11:35:00',4.72),('8902','2014-01-29','11:40:00',3.03),('8902','2014-01-29','11:45:00',5.43),('8902','2014-01-29','11:50:00',3.3),('8902','2014-01-29','11:55:00',6.77),('8902','2014-01-29','12:00:00',3.54),('8902','2014-01-29','12:05:00',5.41),('8902','2014-01-29','12:10:00',3.64),('8902','2014-01-29','12:15:00',3.25),('8902','2014-01-29','12:20:00',5.88),('8902','2014-01-29','12:25:00',5.61),('8902','2014-01-29','12:30:00',4.23),('8902','2014-01-29','12:35:00',5.05),('8902','2014-01-29','12:40:00',4.53),('8902','2014-01-29','12:45:00',6.27),('8902','2014-01-29','12:50:00',5.22),('8902','2014-01-29','12:55:00',5.5),('8902','2014-01-29','13:00:00',2.56),('8902','2014-01-29','13:05:00',5.61),('8902','2014-01-29','13:10:00',3.99),('8902','2014-01-29','13:15:00',5.65),('8902','2014-01-29','13:20:00',4.55),('8902','2014-01-29','13:25:00',6.3),('8902','2014-01-29','13:30:00',5.32),('8902','2014-01-29','13:35:00',4.72),('8902','2014-01-29','13:40:00',5.44),('8902','2014-01-29','13:45:00',6.22),('8902','2014-01-29','13:50:00',5.71),('8902','2014-01-29','13:55:00',5.4),('8902','2014-01-29','14:00:00',5.28),('8902','2014-01-29','14:05:00',5.08),('8902','2014-01-29','14:10:00',4.98),('8902','2014-01-29','14:15:00',4.28),('8902','2014-01-29','14:20:00',3.8),('8902','2014-01-29','14:25:00',4.07),('8902','2014-01-29','14:30:00',4.37),('8902','2014-01-29','14:35:00',4.25),('8902','2014-01-29','14:40:00',4.81),('8902','2014-01-29','14:45:00',4.59),('8902','2014-01-29','14:50:00',4.77),('8902','2014-01-29','14:55:00',4.61),('8902','2014-01-29','15:00:00',4.52),('8902','2014-01-29','15:05:00',4.43),('8902','2014-01-29','15:10:00',4.23),('8902','2014-01-29','15:15:00',3.88),('8902','2014-01-29','15:20:00',4.05),('8902','2014-01-29','15:25:00',4.04),('8902','2014-01-29','15:30:00',3.69),('8902','2014-01-29','15:35:00',3.64),('8902','2014-01-29','15:40:00',3.29),('8902','2014-01-29','15:45:00',1.96),('8902','2014-01-29','15:50:00',1.51),('8902','2014-01-28','09:05:00',1.1),('8902','2014-01-28','09:10:00',1.38),('8902','2014-01-28','09:15:00',1.83),('8902','2014-01-28','09:20:00',2.92),('8902','2014-01-28','09:25:00',1.9),('8902','2014-01-28','09:30:00',2.55),('8902','2014-01-28','09:35:00',3.67),('8902','2014-01-28','09:40:00',3.49),('8902','2014-01-28','09:45:00',3.85),('8902','2014-01-28','09:50:00',3.35),('8902','2014-01-28','09:55:00',3.44),('8902','2014-01-28','10:00:00',2.76),('8902','2014-01-28','10:05:00',2.66),('8902','2014-01-28','10:10:00',3.08),('8902','2014-01-28','10:15:00',3.33),('8902','2014-01-28','10:20:00',2.48),('8902','2014-01-28','10:25:00',5.08),('8902','2014-01-28','10:30:00',5.36),('8902','2014-01-28','10:35:00',4.35),('8902','2014-01-28','10:40:00',3.98),('8902','2014-01-28','10:45:00',3.88),('8902','2014-01-28','10:50:00',3.66),('8902','2014-01-28','10:55:00',3.45),('8902','2014-01-28','11:00:00',3.54),('8902','2014-01-28','11:05:00',4.04),('8902','2014-01-28','11:10:00',3.65),('8902','2014-01-28','11:15:00',3.69),('8902','2014-01-28','11:20:00',3.86),('8902','2014-01-28','11:25:00',3.64),('8902','2014-01-28','11:30:00',5.31),('8902','2014-01-28','11:35:00',5.27),('8902','2014-01-28','11:40:00',4.97),('8902','2014-01-28','11:45:00',2.38),('8902','2014-01-28','11:50:00',2.08),('8902','2014-01-28','11:55:00',1.01),('8902','2014-01-28','12:45:00',1.8),('8902','2014-01-28','12:50:00',5.44),('8902','2014-01-28','12:55:00',6.85),('8902','2014-01-28','13:00:00',5.91),('8902','2014-01-28','13:05:00',1.99),('8902','2014-01-28','13:25:00',1.02),('8902','2014-01-28','13:30:00',1.72),('8902','2014-01-28','13:35:00',3.52),('8902','2014-01-28','13:40:00',4.69),('8902','2014-01-28','13:45:00',1.98),('8902','2014-01-28','13:50:00',4.16),('8902','2014-01-28','13:55:00',4.83),('8902','2014-01-28','14:00:00',1.92),('8902','2014-01-28','14:05:00',1.4),('8902','2014-01-28','14:10:00',1.12),('8902','2014-01-28','14:20:00',1),('8902','2014-01-28','14:25:00',1.03),('8902','2014-01-28','14:30:00',1.67),('8902','2014-01-28','14:35:00',1.53),('8902','2014-01-28','14:40:00',1.87),('8902','2014-01-28','14:45:00',1.43),('8902','2014-01-28','15:05:00',1.4),('8902','2014-01-28','15:10:00',2.43),('8902','2014-01-28','15:15:00',3.22),('8902','2014-01-28','15:20:00',2.31),('8902','2014-01-28','15:25:00',1.11),('8902','2014-01-27','09:00:00',1.24),('8902','2014-01-27','09:05:00',2.01),('8902','2014-01-27','09:10:00',2.46),('8902','2014-01-27','09:15:00',2.62),('8902','2014-01-27','09:20:00',2.48),('8902','2014-01-27','09:25:00',2.79),('8902','2014-01-27','09:30:00',2.7),('8902','2014-01-27','09:35:00',3.13),('8902','2014-01-27','09:40:00',2.75),('8902','2014-01-27','09:45:00',3.06),('8902','2014-01-27','09:50:00',3.8),('8902','2014-01-27','09:55:00',4.04),('8902','2014-01-27','10:00:00',4.42),('8902','2014-01-27','10:05:00',4.41),('8902','2014-01-27','10:10:00',4.39),('8902','2014-01-27','10:15:00',4.46),('8902','2014-01-27','10:20:00',4.62),('8902','2014-01-27','10:25:00',4.97),('8902','2014-01-27','10:30:00',5.02),('8902','2014-01-27','10:35:00',5.21),('8902','2014-01-27','10:40:00',5.34),('8902','2014-01-27','10:45:00',4.62),('8902','2014-01-27','10:50:00',5.4),('8902','2014-01-27','10:55:00',5.26),('8902','2014-01-27','11:00:00',4.99),('8902','2014-01-27','11:05:00',5.99),('8902','2014-01-27','11:10:00',2.78),('8902','2014-01-27','11:15:00',4.15),('8902','2014-01-27','11:20:00',1.94),('8902','2014-01-27','11:25:00',1.89),('8902','2014-01-27','11:30:00',4.5),('8902','2014-01-27','11:35:00',4.4),('8902','2014-01-27','11:40:00',6.58),('8902','2014-01-27','11:45:00',5.25),('8902','2014-01-27','11:50:00',2.31),('8902','2014-01-27','11:55:00',1.14),('8902','2014-01-27','12:00:00',2.94),('8902','2014-01-27','12:05:00',6.64),('8902','2014-01-27','12:10:00',4.73),('8902','2014-01-27','12:15:00',5.86),('8902','2014-01-27','12:20:00',4.15),('8902','2014-01-27','12:25:00',2.4),('8902','2014-01-27','12:30:00',2.27),('8902','2014-01-27','12:35:00',2.83),('8902','2014-01-27','12:40:00',3.74),('8902','2014-01-27','12:45:00',3.39),('8902','2014-01-27','12:50:00',6.34),('8902','2014-01-27','12:55:00',5.94),('8902','2014-01-27','13:00:00',6.19),('8902','2014-01-27','13:05:00',7.43),('8902','2014-01-27','13:10:00',5.12),('8902','2014-01-27','13:15:00',5.34),('8902','2014-01-27','13:20:00',5.56),('8902','2014-01-27','13:25:00',6.05),('8902','2014-01-27','13:30:00',6.1),('8902','2014-01-27','13:35:00',6.69),('8902','2014-01-27','13:40:00',6.46),('8902','2014-01-27','13:45:00',6.27),('8902','2014-01-27','13:50:00',6.12),('8902','2014-01-27','13:55:00',6.03),('8902','2014-01-27','14:00:00',5.97),('8902','2014-01-27','14:05:00',5.82),('8902','2014-01-27','14:10:00',5.74),('8902','2014-01-27','14:15:00',5.67),('8902','2014-01-27','14:20:00',5.54),('8902','2014-01-27','14:25:00',5.64),('8902','2014-01-27','14:30:00',5.41),('8902','2014-01-27','14:35:00',4.98),('8902','2014-01-27','14:40:00',4.79),('8902','2014-01-27','14:45:00',5.1),('8902','2014-01-27','14:50:00',4.08),('8902','2014-01-27','14:55:00',4.76),('8902','2014-01-27','15:00:00',4.64),('8902','2014-01-27','15:05:00',4.5),('8902','2014-01-27','15:10:00',4.33),('8902','2014-01-27','15:15:00',4.17),('8902','2014-01-27','15:20:00',3.97),('8902','2014-01-27','15:25:00',3.79),('8902','2014-01-27','15:30:00',3.62),('8902','2014-01-27','15:35:00',3.43),('8902','2014-01-27','15:40:00',3.25),('8902','2014-01-27','15:45:00',3.09),('8902','2014-01-27','15:50:00',2.88),('8902','2014-01-27','15:55:00',2.7),('8902','2014-01-27','16:00:00',2.51),('8902','2014-01-27','16:05:00',2.32),('8902','2014-01-27','16:10:00',2.03),('8902','2014-01-27','16:15:00',1.9),('8902','2014-01-27','16:20:00',1.71),('8902','2014-01-27','16:25:00',1.51),('8902','2014-01-26','09:40:00',1.23),('8902','2014-01-26','09:45:00',1.31),('8902','2014-01-26','09:50:00',1.43),('8902','2014-01-26','09:55:00',1.47),('8902','2014-01-26','10:00:00',1.49),('8902','2014-01-26','10:05:00',1.53),('8902','2014-01-26','10:10:00',1.45),('8902','2014-01-26','10:15:00',1.5),('8902','2014-01-26','10:20:00',1.47),('8902','2014-01-26','10:25:00',1.75),('8902','2014-01-26','10:30:00',1.74),('8902','2014-01-26','10:35:00',1.72),('8902','2014-01-26','10:40:00',1.54),('8902','2014-01-26','10:45:00',1.7),('8902','2014-01-26','10:50:00',1.71),('8902','2014-01-26','10:55:00',1.56),('8902','2014-01-26','11:00:00',1.7),('8902','2014-01-26','11:05:00',1.87),('8902','2014-01-26','11:10:00',1.6),('8902','2014-01-26','11:15:00',1.58),('8902','2014-01-26','11:20:00',1.99),('8902','2014-01-26','11:25:00',2),('8902','2014-01-26','11:30:00',1.72),('8902','2014-01-26','11:35:00',1.4),('8902','2014-01-26','11:40:00',1.51),('8902','2014-01-26','11:45:00',1.1),('8902','2014-01-26','11:50:00',1.09),('8902','2014-01-26','11:55:00',1.04),('8902','2014-01-26','12:00:00',1.2),('8902','2014-01-26','12:05:00',1.41),('8902','2014-01-26','12:10:00',1.32),('8902','2014-01-26','12:15:00',1.11),('8902','2014-01-26','12:35:00',1),('8902','2014-01-26','12:45:00',1.2),('8902','2014-01-26','12:50:00',1.6),('8902','2014-01-26','12:55:00',1.59),('8902','2014-01-26','13:00:00',1.43),('8902','2014-01-26','13:05:00',1.43),('8902','2014-01-26','13:10:00',1.46),('8902','2014-01-26','13:15:00',1.26),('8902','2014-01-26','13:20:00',1.18),('8902','2014-01-26','13:25:00',1.26),('8902','2014-01-26','13:30:00',1.47),('8902','2014-01-26','13:35:00',1.23),('8975','2014-05-04','06:35:00',1.09),('8975','2014-05-04','06:40:00',1.41),('8975','2014-05-04','06:45:00',1.59),('8975','2014-05-04','07:15:00',2.58),('8975','2014-05-04','07:20:00',2.54),('8975','2014-05-04','07:25:00',1.47),('8975','2014-05-04','07:30:00',2.48),('8975','2014-05-04','07:35:00',2.15),('8975','2014-05-04','07:40:00',3.21),('8975','2014-05-04','07:45:00',3.29),('8975','2014-05-04','07:50:00',3.38),('8975','2014-05-04','07:55:00',3.46),('8975','2014-05-04','08:00:00',3.6),('8975','2014-05-04','08:05:00',3.71),('8975','2014-05-04','08:10:00',3.83),('8975','2014-05-04','08:15:00',4.02),('8975','2014-05-04','08:20:00',4.13),('8975','2014-05-04','08:25:00',4.24),('8975','2014-05-04','08:30:00',4.38),('8975','2014-05-04','08:35:00',4.48),('8975','2014-05-04','08:40:00',4.57),('8975','2014-05-04','08:45:00',4.67),('8975','2014-05-04','08:50:00',4.74),('8975','2014-05-04','08:55:00',4.8),('8975','2014-05-04','09:00:00',4.9),('8975','2014-05-04','09:05:00',5.04),('8975','2014-05-04','09:10:00',5.16),('8975','2014-05-04','09:15:00',5.25),('8975','2014-05-04','09:20:00',5.36),('8975','2014-05-04','09:25:00',5.45),('8975','2014-05-04','09:30:00',5.53),('8975','2014-05-04','09:35:00',5.63),('8975','2014-05-04','09:40:00',5.73),('8975','2014-05-04','09:45:00',5.84),('8975','2014-05-04','09:50:00',5.93),('8975','2014-05-04','09:55:00',5.95),('8975','2014-05-04','10:00:00',6.07),('8975','2014-05-04','10:05:00',6.14),('8975','2014-05-04','10:10:00',6.18),('8975','2014-05-04','10:15:00',6.27),('8975','2014-05-04','10:20:00',6.27),('8975','2014-05-04','10:25:00',6.45),('8975','2014-05-04','10:30:00',6.4),('8975','2014-05-04','10:35:00',6.47),('8975','2014-05-04','10:40:00',6.55),('8975','2014-05-04','10:45:00',6.53),('8975','2014-05-04','10:50:00',6.59),('8975','2014-05-04','10:55:00',6.62),('8975','2014-05-04','11:00:00',6.73),('8975','2014-05-04','11:05:00',6.73),('8975','2014-05-04','11:10:00',6.77),('8975','2014-05-04','11:15:00',6.84),('8975','2014-05-04','11:20:00',6.86),('8975','2014-05-04','11:25:00',6.9),('8975','2014-05-04','11:30:00',6.89),('8975','2014-05-04','11:35:00',6.89),('8975','2014-05-04','11:40:00',6.95),('8975','2014-05-04','11:45:00',7.02),('8975','2014-05-04','11:50:00',7.14),('8975','2014-05-04','11:55:00',7.25),('8975','2014-05-04','12:00:00',7.11),('8975','2014-05-04','12:05:00',5.91),('8975','2014-05-04','12:10:00',2.88),('8975','2014-05-04','12:15:00',5.22),('8975','2014-05-04','12:20:00',4.86),('8975','2014-05-04','12:25:00',2.41),('8975','2014-05-04','12:30:00',4.96),('8975','2014-05-04','12:35:00',4.21),('8975','2014-05-04','12:40:00',6.2),('8975','2014-05-04','12:45:00',5.81),('8975','2014-05-04','12:50:00',6.47),('8975','2014-05-04','12:55:00',4.91),('8975','2014-05-04','13:00:00',2.29),('8975','2014-05-04','13:05:00',2.45),('8975','2014-05-04','13:10:00',1.78),('8975','2014-05-04','13:15:00',2.04),('8975','2014-05-04','13:20:00',7.53),('8975','2014-05-04','13:25:00',6.92),('8975','2014-05-04','13:30:00',6.79),('8975','2014-05-04','13:35:00',6.79),('8975','2014-05-04','13:40:00',5.29),('8975','2014-05-04','13:45:00',4.82),('8975','2014-05-04','13:50:00',1.15),('8975','2014-05-04','13:55:00',2.34),('8975','2014-05-04','14:00:00',7.12),('8975','2014-05-04','14:05:00',5.6),('8975','2014-05-04','14:10:00',4.91),('8975','2014-05-04','14:15:00',4.47),('8975','2014-05-04','14:20:00',3.51),('8975','2014-05-04','14:25:00',5.32),('8975','2014-05-04','14:30:00',4.3),('8975','2014-05-04','14:35:00',3.19),('8975','2014-05-04','14:40:00',2.43),('8975','2014-05-04','14:45:00',2.29),('8975','2014-05-04','14:50:00',2.06),('8975','2014-05-04','14:55:00',2.27),('8975','2014-05-04','15:00:00',2.37),('8975','2014-05-04','15:05:00',2.45),('8975','2014-05-04','15:10:00',4.82),('8975','2014-05-04','15:15:00',4.67),('8975','2014-05-04','15:20:00',3.8),('8975','2014-05-04','15:25:00',3.6),('8975','2014-05-04','15:30:00',1.9),('8975','2014-05-04','15:35:00',2.73),('8975','2014-05-04','15:40:00',1.63),('8975','2014-05-04','15:45:00',4.08),('8975','2014-05-04','15:50:00',5.33),('8975','2014-05-04','15:55:00',3.56),('8975','2014-05-04','16:00:00',1.92),('8975','2014-05-04','16:05:00',3.07),('8975','2014-05-04','16:10:00',4.63),('8975','2014-05-04','16:15:00',3.14),('8975','2014-05-04','16:20:00',3.77),('8975','2014-05-04','16:25:00',3.79),('8975','2014-05-04','16:30:00',4.57),('8975','2014-05-04','16:35:00',4.21),('8975','2014-05-04','16:40:00',3.79),('8975','2014-05-04','16:45:00',3.55),('8975','2014-05-04','16:50:00',3.27),('8975','2014-05-04','16:55:00',3.06),('8975','2014-05-04','17:00:00',2.93),('8975','2014-05-04','17:05:00',2.82),('8975','2014-05-04','17:10:00',2.65),('8975','2014-05-04','17:15:00',2.7),('8975','2014-05-04','17:20:00',2.5),('8975','2014-05-04','17:25:00',2.33),('8975','2014-05-04','17:30:00',2.18),('8975','2014-05-04','17:35:00',2.03),('8975','2014-05-04','17:40:00',1.91),('8975','2014-05-04','17:45:00',1.82),('8975','2014-05-04','17:50:00',1.74),('8975','2014-05-04','17:55:00',1.65),('8975','2014-05-04','18:00:00',1.57),('8975','2014-05-04','18:05:00',1.5),('8975','2014-05-04','18:10:00',1.45),('8975','2014-05-04','18:15:00',1.38),('8975','2014-05-04','18:20:00',1.34),('8975','2014-05-04','18:25:00',1.28),('8975','2014-05-04','18:30:00',1.22),('8975','2014-05-04','18:35:00',1.18),('8975','2014-05-04','18:40:00',1.1),('8975','2014-05-04','18:45:00',1.03),('8975','2014-04-25','08:05:00',1.02),('8975','2014-04-25','08:10:00',1.09),('8975','2014-04-25','08:15:00',1.05),('8975','2014-04-25','08:20:00',1.02),('8975','2014-04-25','08:25:00',1.06),('8975','2014-04-25','08:30:00',1.13),('8975','2014-04-25','08:35:00',1.18),('8975','2014-04-25','08:40:00',1.34),('8975','2014-04-25','08:45:00',1.39),('8975','2014-04-25','08:50:00',1.37),('8975','2014-04-25','08:55:00',1.37),('8975','2014-04-25','09:00:00',1.35),('8975','2014-04-25','09:05:00',1.36),('8975','2014-04-25','09:10:00',1.33),('8975','2014-04-25','09:15:00',1.19),('8975','2014-04-25','09:20:00',1.25),('8975','2014-04-25','09:25:00',1.27),('8975','2014-04-25','09:30:00',1.29),('8975','2014-04-25','09:35:00',1.36),('8975','2014-04-25','09:40:00',1.5),('8975','2014-04-25','09:45:00',1.36),('8975','2014-04-25','09:50:00',1.38),('8975','2014-04-25','09:55:00',1.88),('8975','2014-04-25','10:00:00',2.14),('8975','2014-04-25','10:05:00',2.05),('8975','2014-04-25','10:10:00',2.01),('8975','2014-04-25','10:15:00',2.05),('8975','2014-04-25','10:20:00',2.25),('8975','2014-04-25','10:25:00',2.58),('8975','2014-04-25','10:30:00',2.89),('8975','2014-04-25','10:35:00',3.87),('8975','2014-04-25','10:40:00',3.4),('8975','2014-04-25','10:45:00',4.9),('8975','2014-04-25','10:50:00',3.56),('8975','2014-04-25','10:55:00',5.4),('8975','2014-04-25','11:00:00',6.31),('8975','2014-04-25','11:05:00',5.44),('8975','2014-04-25','11:10:00',5.9),('8975','2014-04-25','11:15:00',5.5),('8975','2014-04-25','11:20:00',5.17),('8975','2014-04-25','11:25:00',4.9),('8975','2014-04-25','11:30:00',5.1),('8975','2014-04-25','11:35:00',5.16),('8975','2014-04-25','11:40:00',5.39),('8975','2014-04-25','11:45:00',5.14),('8975','2014-04-25','11:50:00',5.3),('8975','2014-04-25','11:55:00',5.26),('8975','2014-04-25','12:00:00',6.03),('8975','2014-04-25','12:05:00',5.4),('8975','2014-04-25','12:10:00',6.32),('8975','2014-04-25','12:15:00',4.48),('8975','2014-04-25','12:20:00',2.52),('8975','2014-04-25','12:25:00',4.82),('8975','2014-04-25','12:30:00',4.53),('8975','2014-04-25','12:35:00',4.79),('8975','2014-04-25','12:40:00',5.68),('8975','2014-04-25','12:45:00',6.55),('8975','2014-04-25','12:50:00',4.35),('8975','2014-04-25','12:55:00',2.78),('8975','2014-04-25','13:00:00',2.18),('8975','2014-04-25','13:05:00',5.5),('8975','2014-04-25','13:10:00',5.05),('8975','2014-04-25','13:15:00',4.39),('8975','2014-04-25','13:20:00',6.49),('8975','2014-04-25','13:25:00',6.86),('8975','2014-04-25','13:30:00',5.84),('8975','2014-04-25','13:35:00',2.15),('8975','2014-04-25','13:40:00',1.97),('8975','2014-04-25','13:45:00',4.81),('8975','2014-04-25','13:50:00',5.03),('8975','2014-04-25','13:55:00',5.44),('8975','2014-04-25','14:00:00',6.48),('8975','2014-04-25','14:05:00',3.87),('8975','2014-04-25','14:10:00',1.78),('8975','2014-04-25','14:15:00',3.56),('8975','2014-04-25','14:20:00',3.45),('8975','2014-04-25','14:35:00',1.44),('8975','2014-04-25','14:40:00',2.85),('8975','2014-04-25','14:45:00',3.03),('8975','2014-04-25','15:20:00',1.2),('8975','2014-04-25','17:40:00',1.01),('8975','2014-04-25','17:45:00',1.36),('8975','2014-04-25','17:50:00',1.43),('8975','2014-04-25','17:55:00',1.45),('8975','2014-04-25','18:00:00',1.01),('8975','2014-04-25','18:35:00',1.05),('8975','2014-04-25','18:40:00',1.15),('8975','2014-04-25','18:45:00',1.41),('8975','2014-04-25','18:50:00',1.2),('8975','2014-04-25','18:55:00',1.04),('8975','2014-01-25','08:10:00',1.18),('8975','2014-01-25','09:00:00',1.07),('8975','2014-01-25','09:05:00',1.93),('8975','2014-01-25','09:30:00',1.73),('8975','2014-01-25','09:35:00',1.68),('8975','2014-01-25','09:45:00',1.26),('8975','2014-01-25','09:50:00',1.72),('8975','2014-01-25','09:55:00',1.21),('8975','2014-01-25','10:10:00',1.89),('8975','2014-01-25','10:15:00',1.99),('8975','2014-01-25','10:20:00',1.39),('8975','2014-01-25','10:25:00',1.22),('8975','2014-01-25','10:30:00',1.13),('8975','2014-01-25','10:55:00',1.07),('8975','2014-01-25','11:05:00',1.02),('8975','2014-01-25','11:25:00',1.22),('8975','2014-01-25','11:30:00',1.06),('8975','2014-01-25','12:15:00',1.36),('8975','2014-01-25','12:20:00',1.41),('8975','2014-01-25','12:25:00',1.53),('8975','2014-01-25','12:30:00',2.28),('8975','2014-01-25','12:35:00',1.86);
INSERT INTO `solarlog` VALUES ('8975','2014-01-25','12:40:00',1.43),('8975','2014-01-25','12:45:00',1.28),('8975','2014-01-25','12:50:00',1.14),('8975','2014-01-25','12:55:00',1.07),('8975','2014-01-25','13:00:00',1.13),('8975','2014-01-25','13:05:00',1.29),('8975','2014-01-25','13:10:00',1.45),('8975','2014-01-25','13:15:00',1.47),('8975','2014-01-25','13:20:00',1.58),('8975','2014-01-25','13:25:00',1.36),('8975','2014-01-25','13:30:00',1.11),('8975','2014-01-25','15:45:00',1.07),('8975','2014-01-24','09:00:00',1.11),('8975','2014-01-24','09:05:00',1.9),('8975','2014-01-24','09:10:00',2.13),('8975','2014-01-24','09:15:00',1.32),('8975','2014-01-24','09:20:00',1.38),('8975','2014-01-24','09:25:00',1.46),('8975','2014-01-24','09:45:00',1.1),('8975','2014-01-24','09:50:00',1.64),('8975','2014-01-24','09:55:00',2.18),('8975','2014-01-24','10:00:00',2.53),('8975','2014-01-24','10:05:00',2.84),('8975','2014-01-24','10:10:00',2.73),('8975','2014-01-24','10:15:00',2.99),('8975','2014-01-24','10:20:00',2.88),('8975','2014-01-24','10:25:00',2.13),('8975','2014-01-24','10:30:00',2),('8975','2014-01-24','10:35:00',1.7),('8975','2014-01-24','10:40:00',2.06),('8975','2014-01-24','10:45:00',1.68),('8975','2014-01-24','10:50:00',1.68),('8975','2014-01-24','10:55:00',1.78),('8975','2014-01-24','11:00:00',1.58),('8975','2014-01-24','11:05:00',1.39),('8975','2014-01-24','11:10:00',1.41),('8975','2014-01-24','11:15:00',2.15),('8975','2014-01-24','11:20:00',1.9),('8975','2014-01-24','11:25:00',1.19),('8975','2014-01-24','11:30:00',2.61),('8975','2014-01-24','11:35:00',3.51),('8975','2014-01-24','11:40:00',2.69),('8975','2014-01-24','11:45:00',1.54),('8975','2014-01-24','11:50:00',2.09),('8975','2014-01-24','11:55:00',1.94),('8975','2014-01-24','12:00:00',1.84),('8975','2014-01-24','12:05:00',1.82),('8975','2014-01-24','12:10:00',1.98),('8975','2014-01-24','12:15:00',1.97),('8975','2014-01-24','12:20:00',2.05),('8975','2014-01-24','12:25:00',2.17),('8975','2014-01-24','12:30:00',2.25),('8975','2014-01-24','12:35:00',2.13),('8975','2014-01-24','12:40:00',2.18),('8975','2014-01-24','12:45:00',2.34),('8975','2014-01-24','12:50:00',2.41),('8975','2014-01-24','12:55:00',2.39),('8975','2014-01-24','13:00:00',2.29),('8975','2014-01-24','13:05:00',2.25),('8975','2014-01-24','13:10:00',2.27),('8975','2014-01-24','13:15:00',2.14),('8975','2014-01-24','13:20:00',1.35),('8975','2014-01-24','13:25:00',1.24),('8975','2014-01-24','13:30:00',1.33),('8975','2014-01-24','13:35:00',1.58),('8975','2014-01-24','13:40:00',1.06),('8975','2014-01-24','13:45:00',1.18),('8975','2014-01-24','13:50:00',1.36),('8975','2014-01-24','14:05:00',1.07),('8975','2014-01-24','14:10:00',1.72),('8975','2014-01-24','14:20:00',1.13),('8975','2014-01-24','14:25:00',1.58),('8975','2014-01-24','14:30:00',1.71),('8975','2014-01-24','14:35:00',1.88),('8975','2014-01-24','14:40:00',1.89),('8975','2014-01-24','14:45:00',1.93),('8975','2014-01-24','14:50:00',1.46),('8975','2014-01-24','14:55:00',1.59),('8975','2014-01-24','15:00:00',1.47),('8975','2014-01-24','15:05:00',1.37),('8975','2014-01-24','15:10:00',1.32),('8975','2014-01-24','15:15:00',1.26),('8975','2014-01-24','15:20:00',1.21),('8975','2014-01-24','15:25:00',1.17),('8975','2014-01-24','15:30:00',1.13),('8975','2014-01-24','15:35:00',1.09),('8975','2014-01-24','15:40:00',1.05),('8975','2014-01-24','15:45:00',1.01),('8975','2014-01-23','10:10:00',1.13),('8975','2014-01-23','10:15:00',1.13),('8975','2014-01-23','10:25:00',1.59),('8975','2014-01-23','10:30:00',1.21),('8975','2014-01-23','10:35:00',1.38),('8975','2014-01-23','10:40:00',2.06),('8975','2014-01-23','10:45:00',1.75),('8975','2014-01-23','10:50:00',1.4),('8975','2014-01-23','10:55:00',1.39),('8975','2014-01-23','11:00:00',1.12),('8975','2014-01-23','11:25:00',1.23),('8975','2014-01-23','11:30:00',1.46),('8975','2014-01-23','11:35:00',1.37),('8975','2014-01-23','11:45:00',1.92),('8975','2014-01-23','11:50:00',1.33),('8975','2014-01-23','11:55:00',2.86),('8975','2014-01-23','12:00:00',3.2),('8975','2014-01-23','12:05:00',2.15),('8975','2014-01-23','12:20:00',1.89),('8975','2014-01-23','12:25:00',1.8),('8975','2014-01-23','12:30:00',1.07),('8975','2014-01-23','12:35:00',2.14),('8975','2014-01-23','12:40:00',1.67),('8975','2014-01-23','12:45:00',1.37),('8975','2014-01-23','12:50:00',1.19),('8975','2014-01-23','12:55:00',1.29),('8975','2014-01-23','13:00:00',1.81),('8975','2014-01-23','13:05:00',1.81),('8975','2014-01-23','13:10:00',1.8),('8975','2014-01-23','13:15:00',2.12),('8975','2014-01-23','13:20:00',1.92),('8975','2014-01-23','13:25:00',1.32),('8975','2014-01-23','13:30:00',1.69),('8975','2014-01-23','13:35:00',1.69),('8975','2014-01-23','13:40:00',1.74),('8975','2014-01-23','13:45:00',1.88),('8975','2014-01-23','13:50:00',1.38),('8975','2014-01-23','13:55:00',1.22),('8975','2014-01-23','14:10:00',2.02),('8975','2014-01-23','14:15:00',1.31),('8975','2014-01-23','14:20:00',1.49),('8975','2014-01-23','14:25:00',1.41),('8975','2014-01-23','14:30:00',1.46),('8975','2014-01-23','14:35:00',1.63),('8975','2014-01-22','10:55:00',1.04),('8975','2014-01-22','11:00:00',1.15),('8975','2014-01-22','11:05:00',1.11),('8975','2014-01-22','11:10:00',1.15),('8975','2014-01-22','11:15:00',1.07),('8975','2014-01-22','12:20:00',1.02),('8975','2014-01-22','12:25:00',1.14),('8975','2014-01-22','12:30:00',1.05),('8975','2014-01-21','10:55:00',1.06),('8975','2014-01-21','11:00:00',1.24),('8975','2014-01-21','11:05:00',1.25),('8975','2014-01-21','11:10:00',1.15),('8975','2014-01-21','11:15:00',1.09),('8975','2014-01-21','12:55:00',1.02),('8975','2014-01-21','13:05:00',1.24),('8975','2014-01-21','13:10:00',2.41),('8975','2014-01-21','13:15:00',2.03),('8975','2014-01-21','13:20:00',1.34),('8975','2014-01-20','10:00:00',1.41),('8975','2014-01-20','10:05:00',1.76),('8975','2014-01-20','10:55:00',1.71),('8975','2014-01-20','11:00:00',1.83),('8975','2014-01-20','11:15:00',1.04),('8975','2014-01-20','11:25:00',1.25),('8975','2014-01-20','12:00:00',1.48),('8975','2014-01-20','12:05:00',1.69),('8975','2014-01-20','12:10:00',1.28),('8975','2014-01-20','12:15:00',1.14),('8975','2014-01-20','12:20:00',1.33),('8975','2014-01-20','12:25:00',1.62),('8975','2014-01-20','12:30:00',1.2),('8975','2014-01-20','12:35:00',1.12),('8975','2014-01-20','12:40:00',1.27),('8975','2014-01-20','12:45:00',1.61),('8975','2014-01-20','12:50:00',1.91),('8975','2014-01-20','14:00:00',1.28),('8975','2014-01-20','14:05:00',1.65),('8975','2014-01-20','14:10:00',1.47),('8975','2014-01-20','14:15:00',1.12),('8975','2014-01-19','11:15:00',1.33),('8975','2014-01-19','11:20:00',1.76),('8975','2014-01-19','11:25:00',2.05),('8975','2014-01-19','11:30:00',1.93),('8975','2014-01-19','11:35:00',2.33),('8975','2014-01-19','11:40:00',2.52),('8975','2014-01-19','11:45:00',2.12),('8975','2014-01-19','11:50:00',1.9),('8975','2014-01-19','11:55:00',2.07),('8975','2014-01-19','12:00:00',1.87),('8975','2014-01-19','12:20:00',1.17),('8975','2014-01-19','12:25:00',2),('8975','2014-01-19','12:30:00',1.55),('8975','2014-01-19','13:15:00',1.61),('8975','2014-01-19','13:20:00',2.56),('8975','2014-01-19','13:25:00',1.95),('8975','2014-01-19','13:30:00',2.19),('8975','2014-01-19','13:35:00',1.95),('8975','2014-01-19','13:40:00',1.82),('8975','2014-01-19','13:45:00',1.57),('8975','2014-01-19','13:55:00',1.67),('8975','2014-01-19','14:00:00',1.97),('8975','2014-01-19','14:05:00',1.84),('8975','2014-01-19','14:10:00',1.69),('8975','2014-01-18','11:50:00',1.01),('8975','2014-01-18','11:55:00',1.16),('8975','2014-01-18','12:00:00',1.19),('8975','2014-01-18','12:05:00',1.26),('8975','2014-01-18','12:10:00',1.18),('8975','2014-01-18','12:15:00',1),('8975','2014-01-18','12:20:00',1.09),('8975','2014-01-18','12:25:00',1.12),('8975','2014-01-18','13:05:00',1.19),('8975','2014-01-18','13:10:00',1.29),('8975','2014-01-18','13:15:00',1.12),('8975','2014-01-18','14:20:00',1.39),('8975','2014-01-18','14:25:00',1.51),('8975','2014-01-18','14:30:00',1.49),('8975','2014-01-18','14:35:00',1.18),('8975','2014-01-18','14:40:00',1.08),('8975','2014-01-17','09:40:00',1.01),('8975','2014-01-17','09:45:00',1.01),('8975','2014-01-17','09:55:00',1.08),('8975','2014-01-17','10:00:00',1.42),('8975','2014-01-17','10:05:00',1.93),('8975','2014-01-17','10:10:00',2.59),('8975','2014-01-17','10:15:00',2.58),('8975','2014-01-17','10:20:00',2.22),('8975','2014-01-17','10:25:00',1.51),('8975','2014-01-17','10:30:00',1.56),('8975','2014-01-17','10:35:00',1.19),('8975','2014-01-17','10:40:00',1.08),('8975','2014-01-17','10:45:00',1.2),('8975','2014-01-17','10:50:00',1.39),('8975','2014-01-17','10:55:00',1.29),('8975','2014-01-17','11:05:00',1.38),('8975','2014-01-17','11:10:00',2.44),('8975','2014-01-17','11:15:00',2.68),('8975','2014-01-17','11:20:00',2.5),('8975','2014-01-17','11:25:00',2.39),('8975','2014-01-17','11:30:00',2.44),('8975','2014-01-17','11:35:00',2.47),('8975','2014-01-17','11:40:00',2.53),('8975','2014-01-17','11:45:00',2.55),('8975','2014-01-17','11:50:00',2.28),('8975','2014-01-17','11:55:00',2.19),('8975','2014-01-17','12:00:00',2.68),('8975','2014-01-17','12:05:00',1.53),('8975','2014-01-17','12:10:00',2.31),('8975','2014-01-17','12:15:00',2.12),('8975','2014-01-17','12:20:00',2.09),('8975','2014-01-17','12:25:00',2.15),('8975','2014-01-17','12:30:00',2.11),('8975','2014-01-17','12:35:00',2.08),('8975','2014-01-17','12:40:00',2.07),('8975','2014-01-17','12:45:00',1.93),('8975','2014-01-17','12:50:00',1.97),('8975','2014-01-17','12:55:00',2),('8975','2014-01-17','13:00:00',1.26),('8975','2014-01-17','13:05:00',1.48),('8975','2014-01-17','13:10:00',1.94),('8975','2014-01-17','13:15:00',2),('8975','2014-01-17','13:20:00',1.3),('8975','2014-01-17','13:25:00',1.29),('8975','2014-01-17','13:30:00',1.56),('8975','2014-01-17','13:35:00',1.05),('8975','2014-01-17','13:40:00',1.62),('8975','2014-01-17','13:45:00',1.64),('8975','2014-01-17','13:50:00',1.14),('8975','2014-01-17','13:55:00',1.61),('8975','2014-01-17','14:00:00',1.59),('8975','2014-01-17','14:05:00',1.44),('8975','2014-01-17','14:10:00',1.35),('8975','2014-01-17','14:15:00',1.26),('8975','2014-01-17','14:20:00',1.33),('8975','2014-01-17','14:25:00',1.3),('8975','2014-01-17','14:30:00',1.24),('8975','2014-01-17','14:35:00',1.2),('8975','2014-01-17','14:40:00',1.14),('8975','2014-01-17','14:45:00',1.14),('8975','2014-01-17','14:50:00',1.12),('8975','2014-01-16','08:50:00',1.17),('8975','2014-01-16','08:55:00',1.1),('8975','2014-01-16','09:00:00',1.51),('8975','2014-01-16','09:05:00',1.35),('8975','2014-01-16','09:15:00',1.26),('8975','2014-01-16','09:20:00',1.33),('8975','2014-01-16','09:25:00',1.78),('8975','2014-01-16','09:30:00',1.79),('8975','2014-01-16','09:35:00',1.35),('8975','2014-01-16','09:40:00',1.49),('8975','2014-01-16','09:45:00',1.55),('8975','2014-01-16','11:20:00',1.13),('8975','2014-01-16','11:25:00',1.77),('8975','2014-01-16','11:30:00',1.61),('8975','2014-01-16','11:35:00',1.86),('8975','2014-01-16','11:40:00',1.36),('8975','2014-01-16','11:50:00',1.14),('8975','2014-01-16','11:55:00',1.22),('8975','2014-01-16','12:00:00',1.02),('8975','2014-01-16','12:05:00',1.19),('8975','2014-01-16','12:10:00',1.03),('8975','2014-04-24','07:00:00',1.06),('8975','2014-04-24','07:05:00',1.18),('8975','2014-04-24','07:10:00',1.39),('8975','2014-04-24','07:15:00',1.55),('8975','2014-04-24','07:20:00',1.66),('8975','2014-04-24','07:25:00',1.87),('8975','2014-04-24','07:30:00',2.04),('8975','2014-04-24','07:35:00',2.2),('8975','2014-04-24','07:40:00',2.35),('8975','2014-04-24','07:45:00',2.48),('8975','2014-04-24','07:50:00',2.58),('8975','2014-04-24','07:55:00',2.68),('8975','2014-04-24','08:00:00',2.84),('8975','2014-04-24','08:05:00',2.95),('8975','2014-04-24','08:10:00',3.02),('8975','2014-04-24','08:15:00',3.19),('8975','2014-04-24','08:20:00',3.36),('8975','2014-04-24','08:25:00',3.5),('8975','2014-04-24','08:30:00',3.55),('8975','2014-04-24','08:35:00',3.67),('8975','2014-04-24','08:40:00',3.75),('8975','2014-04-24','08:45:00',3.84),('8975','2014-04-24','08:50:00',3.86),('8975','2014-04-24','08:55:00',4.01),('8975','2014-04-24','09:00:00',4.18),('8975','2014-04-24','09:05:00',2.44),('8975','2014-04-24','09:10:00',4.44),('8975','2014-04-24','09:15:00',5.2),('8975','2014-04-24','09:20:00',3.86),('8975','2014-04-24','09:25:00',3.69),('8975','2014-04-24','09:30:00',5.02),('8975','2014-04-24','09:35:00',3.36),('8975','2014-04-24','09:40:00',4.33),('8975','2014-04-24','09:45:00',4.98),('8975','2014-04-24','09:50:00',3.64),('8975','2014-04-24','09:55:00',2.86),('8975','2014-04-24','10:00:00',2.55),('8975','2014-04-24','10:05:00',2.39),('8975','2014-04-24','10:10:00',2.31),('8975','2014-04-24','10:15:00',2.04),('8975','2014-04-24','10:20:00',2.56),('8975','2014-04-24','10:25:00',1.71),('8975','2014-04-24','10:30:00',1.67),('8975','2014-04-24','10:35:00',2.13),('8975','2014-04-24','10:40:00',3.44),('8975','2014-04-24','10:45:00',3.31),('8975','2014-04-24','10:50:00',3.65),('8975','2014-04-24','10:55:00',2.35),('8975','2014-04-24','11:00:00',2.25),('8975','2014-04-24','11:05:00',2.16),('8975','2014-04-24','11:10:00',1.8),('8975','2014-04-24','11:15:00',4.23),('8975','2014-04-24','11:20:00',6.61),('8975','2014-04-24','11:25:00',6.03),('8975','2014-04-24','11:30:00',3.67),('8975','2014-04-24','11:35:00',6.06),('8975','2014-04-24','11:40:00',5.37),('8975','2014-04-24','11:45:00',5.73),('8975','2014-04-24','11:50:00',3.75),('8975','2014-04-24','11:55:00',4.08),('8975','2014-04-24','12:00:00',4.76),('8975','2014-04-24','12:05:00',6.33),('8975','2014-04-24','12:10:00',7.49),('8975','2014-04-24','12:15:00',7.13),('8975','2014-04-24','12:20:00',6.69),('8975','2014-04-24','12:25:00',4.05),('8975','2014-04-24','12:30:00',2.47),('8975','2014-04-24','12:35:00',4.83),('8975','2014-04-24','12:40:00',4.99),('8975','2014-04-24','12:45:00',4.01),('8975','2014-04-24','12:50:00',4.33),('8975','2014-04-24','12:55:00',5.15),('8975','2014-04-24','13:00:00',2.59),('8975','2014-04-24','13:05:00',3.77),('8975','2014-04-24','13:10:00',4.19),('8975','2014-04-24','13:15:00',5.66),('8975','2014-04-24','13:20:00',2.12),('8975','2014-04-24','13:25:00',2.53),('8975','2014-04-24','13:30:00',3.74),('8975','2014-04-24','13:35:00',6.92),('8975','2014-04-24','13:40:00',5.31),('8975','2014-04-24','13:45:00',2.74),('8975','2014-04-24','13:50:00',2.33),('8975','2014-04-24','13:55:00',2.41),('8975','2014-04-24','14:00:00',5.48),('8975','2014-04-24','14:05:00',7.09),('8975','2014-04-24','14:10:00',6.98),('8975','2014-04-24','14:15:00',6.89),('8975','2014-04-24','14:20:00',5.94),('8975','2014-04-24','14:25:00',2.71),('8975','2014-04-24','14:30:00',5.9),('8975','2014-04-24','14:35:00',5.45),('8975','2014-04-24','14:40:00',5.28),('8975','2014-04-24','14:45:00',5.04),('8975','2014-04-24','14:50:00',5.04),('8975','2014-04-24','14:55:00',5.01),('8975','2014-04-24','15:00:00',4.92),('8975','2014-04-24','15:05:00',4.81),('8975','2014-04-24','15:10:00',4.78),('8975','2014-04-24','15:15:00',4.54),('8975','2014-04-24','15:20:00',4.55),('8975','2014-04-24','15:25:00',4.45),('8975','2014-04-24','15:30:00',4.38),('8975','2014-04-24','15:35:00',4.31),('8975','2014-04-24','15:40:00',4.05),('8975','2014-04-24','15:45:00',4.04),('8975','2014-04-24','15:50:00',3.97),('8975','2014-04-24','15:55:00',3.87),('8975','2014-04-24','16:00:00',3.82),('8975','2014-04-24','16:05:00',3.65),('8975','2014-04-24','16:10:00',3.32),('8975','2014-04-24','16:15:00',2.97),('8975','2014-04-24','16:20:00',3.05),('8975','2014-04-24','16:25:00',2.81),('8975','2014-04-24','16:30:00',2.79),('8975','2014-04-24','16:35:00',2.92),('8975','2014-04-24','16:40:00',2.8),('8975','2014-04-24','16:45:00',2.85),('8975','2014-04-24','16:50:00',2.27),('8975','2014-04-24','16:55:00',1.72),('8975','2014-04-24','17:00:00',1.85),('8975','2014-04-24','17:05:00',2.02),('8975','2014-04-24','17:10:00',2.09),('8975','2014-04-24','17:15:00',1.63),('8975','2014-04-24','17:20:00',1.13),('8975','2014-04-24','17:25:00',1.15),('8975','2014-04-24','17:30:00',1.36),('8975','2014-04-24','17:35:00',1.33),('8975','2014-04-24','17:40:00',1.21),('8975','2014-04-24','17:45:00',1.16),('8975','2014-04-24','17:50:00',1.09),('8975','2014-04-24','17:55:00',1.07),('8975','2014-04-24','18:00:00',1.07),('8975','2014-04-24','18:05:00',1.03),('8975','2014-01-15','08:20:00',1.15),('8975','2014-01-15','08:25:00',1.18),('8975','2014-01-15','08:30:00',1.01),('8975','2014-01-15','08:35:00',1.1),('8975','2014-01-15','08:40:00',1.11),('8975','2014-01-15','08:45:00',1.03),('8975','2014-01-15','09:00:00',1.13),('8975','2014-01-15','09:05:00',1.16),('8975','2014-01-15','09:10:00',1.26),('8975','2014-01-15','09:15:00',1.28),('8975','2014-01-15','09:20:00',1.83),('8975','2014-01-15','09:25:00',1.93),('8975','2014-01-15','09:30:00',1.97),('8975','2014-01-15','09:35:00',1.99),('8975','2014-01-15','09:40:00',2.16),('8975','2014-01-15','09:45:00',1.98),('8975','2014-01-15','09:50:00',1.52),('8975','2014-01-15','09:55:00',1.2),('8975','2014-01-15','10:00:00',1.08),('8975','2014-01-15','10:05:00',1.13),('8975','2014-01-15','10:10:00',1.26),('8975','2014-01-15','10:15:00',1.5),('8975','2014-01-15','10:20:00',1.52),('8975','2014-01-15','10:25:00',1.71),('8975','2014-01-15','10:30:00',2.32),('8975','2014-01-15','10:35:00',2.84),('8975','2014-01-15','10:40:00',2.47),('8975','2014-01-15','10:45:00',1.77),('8975','2014-01-15','10:50:00',1.95),('8975','2014-01-15','10:55:00',2.04),('8975','2014-01-15','11:00:00',2.11),('8975','2014-01-15','11:05:00',2.04),('8975','2014-01-15','11:10:00',2.11),('8975','2014-01-15','11:15:00',1.94),('8975','2014-01-15','11:20:00',1.78),('8975','2014-01-15','11:25:00',1.85),('8975','2014-01-15','11:30:00',1.72),('8975','2014-01-15','11:35:00',1.77),('8975','2014-01-15','11:40:00',1.49),('8975','2014-01-15','11:45:00',1.2),('8975','2014-01-15','11:50:00',1.41),('8975','2014-01-15','11:55:00',1.59),('8975','2014-01-15','12:00:00',1.17),('8975','2014-01-15','12:05:00',1.18),('8975','2014-01-15','12:10:00',1),('8975','2014-01-15','12:15:00',1.01),('8975','2014-01-15','12:20:00',1.11),('8975','2014-01-15','12:25:00',1.07),('8975','2014-01-15','12:30:00',1.16),('8975','2014-01-15','12:35:00',1.2),('8975','2014-01-15','12:40:00',1.5),('8975','2014-01-15','12:45:00',1.63),('8975','2014-01-15','12:50:00',1.81),('8975','2014-01-15','12:55:00',1.75),('8975','2014-01-15','13:00:00',1.95),('8975','2014-01-15','13:05:00',1.49),('8975','2014-01-15','13:10:00',1.61),('8975','2014-01-15','13:15:00',1.45),('8975','2014-01-15','13:20:00',1.55),('8975','2014-01-15','13:25:00',1.5),('8975','2014-01-15','13:30:00',1.66),('8975','2014-01-15','13:35:00',1.34),('8975','2014-01-15','13:40:00',1.27),('8975','2014-01-15','13:45:00',1.09),('8975','2014-01-15','13:50:00',1.12),('8975','2014-01-15','13:55:00',1.43),('8975','2014-01-15','14:00:00',1.09),('8975','2014-01-15','14:05:00',1.05),('8975','2014-01-15','14:10:00',1.03),('8975','2014-01-15','14:15:00',1.03),('8975','2014-01-15','14:25:00',1.01),('8975','2014-01-15','14:30:00',1.06),('8975','2014-01-14','10:10:00',1.06),('8975','2014-01-14','10:15:00',1.62),('8975','2014-01-14','10:20:00',1.83),('8975','2014-01-14','10:25:00',1.96),('8975','2014-01-14','10:30:00',2.14),('8975','2014-01-14','10:35:00',1.62),('8975','2014-01-14','10:40:00',1.8),('8975','2014-01-14','10:45:00',1.43),('8975','2014-01-14','10:50:00',1.05),('8975','2014-01-14','10:55:00',1.13),('8975','2014-01-14','11:00:00',1.37),('8975','2014-01-14','11:05:00',2.57),('8975','2014-01-14','11:10:00',2.56),('8975','2014-01-14','11:15:00',2.42),('8975','2014-01-14','11:20:00',2.04),('8975','2014-01-14','11:25:00',2.22),('8975','2014-01-14','11:30:00',2.31),('8975','2014-01-14','11:35:00',1.77),('8975','2014-01-14','11:40:00',1.82),('8975','2014-01-14','11:45:00',2.11),('8975','2014-01-14','11:50:00',1.9),('8975','2014-01-14','11:55:00',1.7),('8975','2014-01-14','12:00:00',1.5),('8975','2014-01-14','12:05:00',1.39),('8975','2014-01-14','12:10:00',1.45),('8975','2014-01-14','12:15:00',1.95),('8975','2014-01-14','12:20:00',2.2),('8975','2014-01-14','12:25:00',1.7),('8975','2014-01-14','12:30:00',1.22),('8975','2014-01-14','12:35:00',1.06),('8975','2014-01-14','12:40:00',1.21),('8975','2014-01-14','12:45:00',1.24),('8975','2014-01-14','12:50:00',1.4),('8975','2014-01-14','12:55:00',1.2),('8975','2014-01-14','13:00:00',1.27),('8975','2014-01-14','13:05:00',1.3),('8975','2014-01-14','13:10:00',1.58),('8975','2014-01-14','13:15:00',2.18),('8975','2014-01-14','13:20:00',1.99),('8975','2014-01-14','13:25:00',1.79),('8975','2014-01-14','13:30:00',1.78),('8975','2014-01-14','13:35:00',1.64),('8975','2014-01-14','13:40:00',1.48),('8975','2014-01-14','13:45:00',1.44),('8975','2014-01-14','13:50:00',1.08),('8975','2014-01-14','14:25:00',1.15),('8975','2014-01-14','14:30:00',1.16),('8975','2014-01-14','14:35:00',1.14),('8975','2014-01-14','14:40:00',1.1),('8975','2014-01-14','14:45:00',1.02),('8975','2014-01-14','14:55:00',1.13),('8975','2014-01-14','15:00:00',1.16),('8975','2014-01-14','15:05:00',1.14),('8975','2014-01-14','15:10:00',1.11),('8975','2014-01-13','10:20:00',1.23),('8975','2014-01-13','10:25:00',2.21),('8975','2014-01-13','10:30:00',2.78),('8975','2014-01-13','10:35:00',2.74),('8975','2014-01-13','10:40:00',2.52),('8975','2014-01-13','10:45:00',2.36),('8975','2014-01-13','10:50:00',1.52),('8975','2014-01-13','10:55:00',1.35),('8975','2014-01-13','11:00:00',1.44),('8975','2014-01-13','11:05:00',1.26),('8975','2014-01-13','11:15:00',1.14),('8975','2014-01-13','11:30:00',1.97),('8975','2014-01-13','11:35:00',2.2),('8975','2014-01-13','11:40:00',1.54),('8975','2014-01-13','11:45:00',1.21),('8975','2014-01-13','11:50:00',1.07),('8975','2014-01-12','08:55:00',1.11),('8975','2014-01-12','09:00:00',1.28),('8975','2014-01-12','09:05:00',1.63),('8975','2014-01-12','09:10:00',1.62),('8975','2014-01-12','09:15:00',1.6),('8975','2014-01-12','09:20:00',1.61),('8975','2014-01-12','09:25:00',1.61),('8975','2014-01-12','09:30:00',1.65),('8975','2014-01-12','09:35:00',1.7),('8975','2014-01-12','09:40:00',1.73),('8975','2014-01-12','09:45:00',1.78),('8975','2014-01-12','09:50:00',1.8),('8975','2014-01-12','09:55:00',1.84),('8975','2014-01-12','10:00:00',1.83),('8975','2014-01-12','10:05:00',1.85),('8975','2014-01-12','10:10:00',1.87),('8975','2014-01-12','10:15:00',1.91),('8975','2014-01-12','10:20:00',1.99),('8975','2014-01-12','10:25:00',1.94),('8975','2014-01-12','10:30:00',1.98),('8975','2014-01-12','10:35:00',2.04),('8975','2014-01-12','10:40:00',2.08),('8975','2014-01-12','10:45:00',2.09),('8975','2014-01-12','10:50:00',2.12),('8975','2014-01-12','10:55:00',2.12),('8975','2014-01-12','11:00:00',2.12),('8975','2014-01-12','11:05:00',2.12),('8975','2014-01-12','11:10:00',2.17),('8975','2014-01-12','11:15:00',2.17),('8975','2014-01-12','11:20:00',2.19),('8975','2014-01-12','11:25:00',2.21),('8975','2014-01-12','11:30:00',2.2),('8975','2014-01-12','11:35:00',2.17),('8975','2014-01-12','11:40:00',1.95),('8975','2014-01-12','11:45:00',2.01),('8975','2014-01-12','11:50:00',2.02),('8975','2014-01-12','11:55:00',2),('8975','2014-01-12','12:00:00',1.96),('8975','2014-01-12','12:05:00',1.89),('8975','2014-01-12','12:10:00',1.89),('8975','2014-01-12','12:15:00',1.81),('8975','2014-01-12','12:20:00',1.81),('8975','2014-01-12','12:25:00',1.79),('8975','2014-01-12','12:30:00',1.78),('8975','2014-01-12','12:35:00',1.75),('8975','2014-01-12','12:40:00',1.72),('8975','2014-01-12','12:45:00',1.66),('8975','2014-01-12','12:50:00',1.65),('8975','2014-01-12','12:55:00',1.62),('8975','2014-01-12','13:00:00',1.54),('8975','2014-01-12','13:05:00',1.57),('8975','2014-01-12','13:10:00',1.57),('8975','2014-01-12','13:15:00',1.5),('8975','2014-01-12','13:20:00',1.39),('8975','2014-01-12','13:25:00',1.43),('8975','2014-01-12','13:30:00',1.41),('8975','2014-01-12','13:35:00',1.31),('8975','2014-01-12','13:40:00',1.34),('8975','2014-01-12','13:45:00',1.38),('8975','2014-01-12','13:50:00',1.35),('8975','2014-01-12','13:55:00',1.31),('8975','2014-01-12','14:00:00',1.31),('8975','2014-01-12','14:05:00',1.26),('8975','2014-01-12','14:10:00',1.23),('8975','2014-01-12','14:15:00',1.17),('8975','2014-01-12','14:20:00',1.17),('8975','2014-01-12','14:25:00',1.12),('8975','2014-01-12','14:30:00',1.11),('8975','2014-01-12','14:35:00',1.09),('8975','2014-01-12','14:40:00',1.08),('8975','2014-01-12','14:45:00',1.06),('8975','2014-01-12','14:50:00',1.05),('8975','2014-01-12','14:55:00',1.06),('8975','2014-01-12','15:00:00',1.05),('8975','2014-01-12','15:05:00',1.02),('8975','2014-01-11','09:45:00',1),('8975','2014-01-11','09:50:00',1.12),('8975','2014-01-11','09:55:00',1.12),('8975','2014-01-11','10:00:00',1.08),('8975','2014-01-11','10:05:00',1.04),('8975','2014-01-11','10:10:00',1.06),('8975','2014-01-11','10:15:00',1.22),('8975','2014-01-11','10:20:00',1.36),('8975','2014-01-11','10:25:00',1.22),('8975','2014-01-11','10:30:00',1.29),('8975','2014-01-11','10:35:00',1.48),('8975','2014-01-11','10:40:00',1.63),('8975','2014-01-11','10:45:00',1.63),('8975','2014-01-11','10:50:00',1.82),('8975','2014-01-11','10:55:00',1.76),('8975','2014-01-11','11:00:00',1.72),('8975','2014-01-11','11:05:00',1.72),('8975','2014-01-11','11:10:00',1.89),('8975','2014-01-11','11:15:00',1.61),('8975','2014-01-11','11:20:00',1.5),('8975','2014-01-11','11:25:00',1.89),('8975','2014-01-11','11:30:00',1.51),('8975','2014-01-11','11:35:00',1.51),('8975','2014-01-11','11:40:00',1.6),('8975','2014-01-11','11:45:00',1.57),('8975','2014-01-11','11:50:00',2.03),('8975','2014-01-11','11:55:00',1.74),('8975','2014-01-11','12:00:00',1.55),('8975','2014-01-11','12:05:00',1.43),('8975','2014-01-11','12:10:00',1.31),('8975','2014-01-11','12:15:00',1.26),('8975','2014-01-11','12:20:00',1.26),('8975','2014-01-11','12:25:00',1.28),('8975','2014-01-11','12:30:00',1.33),('8975','2014-01-11','12:35:00',1.35),('8975','2014-01-11','12:40:00',1.38),('8975','2014-01-11','12:45:00',1.39),('8975','2014-01-11','12:50:00',1.41),('8975','2014-01-11','12:55:00',1.38),('8975','2014-01-11','13:00:00',1.36),('8975','2014-01-11','13:05:00',1.27),('8975','2014-01-11','13:10:00',1.24),('8975','2014-01-11','13:15:00',1.23),('8975','2014-01-11','13:20:00',1.19),('8975','2014-01-11','13:25:00',1.28),('8975','2014-01-11','13:30:00',1.31),('8975','2014-01-11','13:35:00',1.23),('8975','2014-01-11','13:40:00',1.14),('8975','2014-01-11','13:45:00',1.04),('8975','2014-01-10','09:55:00',1.53),('8975','2014-01-10','10:00:00',1.69),('8975','2014-01-10','10:05:00',1.36),('8975','2014-01-10','10:10:00',1.29),('8975','2014-01-10','10:15:00',1.37),('8975','2014-01-10','10:20:00',1.48),('8975','2014-01-10','10:25:00',1.61),('8975','2014-01-10','10:30:00',1.59),('8975','2014-01-10','10:35:00',1.68),('8975','2014-01-10','10:40:00',2.15),('8975','2014-01-10','10:45:00',2.24),('8975','2014-01-10','10:50:00',2.27),('8975','2014-01-10','10:55:00',2.24),('8975','2014-01-10','11:00:00',2.14),('8975','2014-01-10','11:05:00',2.07),('8975','2014-01-10','11:10:00',2.17),('8975','2014-01-10','11:15:00',1.97),('8975','2014-01-10','11:20:00',1.98),('8975','2014-01-10','11:25:00',1.98),('8975','2014-01-10','11:30:00',1.85),('8975','2014-01-10','11:35:00',1.52),('8975','2014-01-10','11:40:00',1.38),('8975','2014-01-10','11:45:00',1.49),('8975','2014-01-10','11:50:00',1.63),('8975','2014-01-10','11:55:00',1.72),('8975','2014-01-10','12:00:00',1.83),('8975','2014-01-10','12:05:00',2.03),('8975','2014-01-10','12:10:00',1.74),('8975','2014-01-10','12:15:00',1.57),('8975','2014-01-10','12:20:00',1.55),('8975','2014-01-10','12:25:00',1.39),('8975','2014-01-10','12:30:00',1.33),('8975','2014-01-10','12:35:00',1.25),('8975','2014-01-10','12:40:00',1.25),('8975','2014-01-10','12:45:00',1.28),('8975','2014-01-10','12:50:00',1.37),('8975','2014-01-10','12:55:00',1.48),('8975','2014-01-10','13:00:00',1.6),('8975','2014-01-10','13:05:00',1.29),('8975','2014-01-10','13:10:00',1.32),('8975','2014-01-10','13:15:00',1.68),('8975','2014-01-10','13:20:00',1.31),('8975','2014-01-10','13:25:00',1.16),('8975','2014-01-10','13:30:00',1.03),('8975','2014-01-10','13:35:00',1.02),('8975','2014-01-10','13:45:00',1.13),('8975','2014-01-10','13:55:00',1.04),('8975','2014-01-10','14:00:00',1.32),('8975','2014-01-10','14:05:00',1.33),('8975','2014-01-10','14:10:00',1.17),('8975','2014-01-09','13:00:00',1.01),('8975','2014-01-09','13:05:00',1.02),('8975','2014-01-08','09:05:00',1.09),('8975','2014-01-08','09:10:00',1.09),('8975','2014-01-08','09:15:00',1.05),('8975','2014-01-08','09:20:00',1.4),('8975','2014-01-08','09:25:00',1.59),('8975','2014-01-08','09:30:00',1.51),('8975','2014-01-08','09:35:00',1.86),('8975','2014-01-08','09:40:00',1.92),('8975','2014-01-08','09:45:00',1.92),('8975','2014-01-08','09:50:00',1.96),('8975','2014-01-08','09:55:00',1.96),('8975','2014-01-08','10:00:00',1.72),('8975','2014-01-08','10:05:00',1.9),('8975','2014-01-08','10:10:00',1.74),('8975','2014-01-08','10:15:00',1.71),('8975','2014-01-08','10:20:00',1.86),('8975','2014-01-08','10:25:00',1.86),('8975','2014-01-08','10:30:00',1.89),('8975','2014-01-08','10:35:00',1.96),('8975','2014-01-08','10:40:00',2.04),('8975','2014-01-08','10:45:00',1.99),('8975','2014-01-08','10:50:00',1.45),('8975','2014-01-08','10:55:00',1.33),('8975','2014-01-08','11:00:00',1.23),('8975','2014-01-08','11:05:00',1.24),('8975','2014-01-08','11:10:00',1.26),('8975','2014-01-08','11:15:00',1.33),('8975','2014-01-08','11:20:00',1.31),('8975','2014-01-08','11:25:00',1.26),('8975','2014-01-08','11:30:00',1.28),('8975','2014-01-08','11:35:00',1.8),('8975','2014-01-08','11:40:00',1.45),('8975','2014-01-08','11:45:00',1.27),('8975','2014-01-08','11:50:00',1.13),('8975','2014-01-08','11:55:00',1.06),('8975','2014-01-08','12:00:00',1.02),('8975','2014-01-08','12:10:00',1.12),('8975','2014-01-08','13:05:00',1.01),('8975','2014-01-08','13:10:00',1.09),('8975','2014-01-08','13:15:00',1.06),('8975','2014-01-08','13:20:00',1.02),('8975','2014-01-08','13:25:00',1.06),('8975','2014-01-07','08:35:00',1.02),('8975','2014-01-07','08:40:00',1.08),('8975','2014-01-07','08:45:00',1.04),('8975','2014-01-07','08:55:00',1.21),('8975','2014-01-07','09:00:00',1.29),('8975','2014-01-07','09:05:00',1.35),('8975','2014-01-07','09:10:00',1.43),('8975','2014-01-07','09:15:00',1.49),('8975','2014-01-07','09:20:00',1.5),('8975','2014-01-07','09:25:00',1.58),('8975','2014-01-07','09:30:00',1.6),('8975','2014-01-07','09:35:00',1.52),('8975','2014-01-07','09:40:00',1.7),('8975','2014-01-07','09:45:00',1.75),('8975','2014-01-07','09:50:00',1.79),('8975','2014-01-07','09:55:00',1.85),('8975','2014-01-07','10:00:00',1.84),('8975','2014-01-07','10:05:00',1.65),('8975','2014-01-07','10:10:00',1.81),('8975','2014-01-07','10:15:00',1.87),('8975','2014-01-07','10:20:00',1.96),('8975','2014-01-07','10:25:00',1.97),('8975','2014-01-07','10:30:00',2),('8975','2014-01-07','10:35:00',2),('8975','2014-01-07','10:40:00',1.95),('8975','2014-01-07','10:45:00',2.07),('8975','2014-01-07','10:50:00',2.12),('8975','2014-01-07','10:55:00',2.15),('8975','2014-01-07','11:00:00',2.14),('8975','2014-01-07','11:05:00',2.17),('8975','2014-01-07','11:10:00',2.19),('8975','2014-01-07','11:15:00',2.22),('8975','2014-01-07','11:20:00',2.22),('8975','2014-01-07','11:25:00',2.2),('8975','2014-01-07','11:30:00',2.15),('8975','2014-01-07','11:35:00',2.17),('8975','2014-01-07','11:40:00',2.24),('8975','2014-01-07','11:45:00',2.21),('8975','2014-01-07','11:50:00',2.1),('8975','2014-01-07','11:55:00',2.06),('8975','2014-01-07','12:00:00',1.96),('8975','2014-01-07','12:05:00',1.8),('8975','2014-01-07','12:10:00',1.8),('8975','2014-01-07','12:15:00',1.92),('8975','2014-01-07','12:20:00',1.86),('8975','2014-01-07','12:25:00',1.8),('8975','2014-01-07','12:30:00',1.83),('8975','2014-01-07','12:35:00',1.79),('8975','2014-01-07','12:40:00',1.72),('8975','2014-01-07','12:45:00',1.61),('8975','2014-01-07','12:50:00',1.6),('8975','2014-01-07','12:55:00',1.66),('8975','2014-01-07','13:00:00',1.66),('8975','2014-01-07','13:05:00',1.6),('8975','2014-01-07','13:10:00',1.51),('8975','2014-01-07','13:15:00',1.4),('8975','2014-01-07','13:20:00',1.47),('8975','2014-01-07','13:25:00',1.37),('8975','2014-01-07','13:30:00',1.3),('8975','2014-01-07','13:35:00',1.31),('8975','2014-01-07','13:40:00',1.24),('8975','2014-01-07','13:45:00',1.24),('8975','2014-01-07','13:50:00',1.26),('8975','2014-01-07','13:55:00',1.26),('8975','2014-01-07','14:00:00',1.18),('8975','2014-01-07','14:05:00',1.15),('8975','2014-01-07','14:10:00',1.19),('8975','2014-01-07','14:15:00',1.16),('8975','2014-01-07','14:20:00',1.18),('8975','2014-01-07','14:25:00',1.18),('8975','2014-01-07','14:30:00',1.19),('8975','2014-01-07','14:35:00',1.17),('8975','2014-01-07','14:40:00',1.07),('8975','2014-01-07','14:45:00',1.01),('8975','2014-01-07','14:50:00',1.05),('8975','2014-01-06','08:30:00',1.03),('8975','2014-01-06','08:35:00',1.12),('8975','2014-01-06','08:40:00',1.19),('8975','2014-01-06','08:45:00',1.25),('8975','2014-01-06','08:50:00',1.31),('8975','2014-01-06','08:55:00',1.36),('8975','2014-01-06','09:00:00',1.42),('8975','2014-01-06','09:05:00',1.47),('8975','2014-01-06','09:10:00',1.51),('8975','2014-01-06','09:15:00',1.56),('8975','2014-01-06','09:20:00',1.6),('8975','2014-01-06','09:25:00',1.65),('8975','2014-01-06','09:30:00',1.69),('8975','2014-01-06','09:35:00',1.72),('8975','2014-01-06','09:40:00',1.75),('8975','2014-01-06','09:45:00',1.81),('8975','2014-01-06','09:50:00',1.85),('8975','2014-01-06','09:55:00',1.88),('8975','2014-01-06','10:00:00',1.9),('8975','2014-01-06','10:05:00',1.93),('8975','2014-01-06','10:10:00',1.96),('8975','2014-01-06','10:15:00',1.96),('8975','2014-01-06','10:20:00',2),('8975','2014-01-06','10:25:00',2.01),('8975','2014-01-06','10:30:00',2.07),('8975','2014-01-06','10:35:00',2.1),('8975','2014-01-06','10:40:00',2.14),('8975','2014-01-06','10:45:00',2.16),('8975','2014-01-06','10:50:00',2.18),('8975','2014-01-06','10:55:00',2.21),('8975','2014-01-06','11:00:00',2.22),('8975','2014-01-06','11:05:00',2.22),('8975','2014-01-06','11:10:00',2.23),('8975','2014-01-06','11:15:00',2.23),('8975','2014-01-06','11:20:00',2.24),('8975','2014-01-06','11:25:00',2.24),('8975','2014-01-06','11:30:00',2.22),('8975','2014-01-06','11:35:00',2.12),('8975','2014-01-06','11:40:00',2.18),('8975','2014-01-06','11:45:00',2.15),('8975','2014-01-06','11:50:00',2.04),('8975','2014-01-06','11:55:00',2.02),('8975','2014-01-06','12:00:00',1.98),('8975','2014-01-06','12:05:00',1.8),('8975','2014-01-06','12:10:00',1.88),('8975','2014-01-06','12:15:00',1.9),('8975','2014-01-06','12:20:00',1.9),('8975','2014-01-06','12:25:00',1.85),('8975','2014-01-06','12:30:00',1.81),('8975','2014-01-06','12:35:00',1.79),('8975','2014-01-06','12:40:00',1.73),('8975','2014-01-06','12:45:00',1.65),('8975','2014-01-06','12:50:00',1.63),('8975','2014-01-06','12:55:00',1.68),('8975','2014-01-06','13:00:00',1.66),('8975','2014-01-06','13:05:00',1.56),('8975','2014-01-06','13:10:00',1.47),('8975','2014-01-06','13:15:00',1.45),('8975','2014-01-06','13:20:00',1.43),('8975','2014-01-06','13:25:00',1.3),('8975','2014-01-06','13:30:00',1.23),('8975','2014-01-06','13:35:00',1.24),('8975','2014-01-06','13:40:00',1.24),('8975','2014-01-06','13:45:00',1.3),('8975','2014-01-06','13:50:00',1.26),('8975','2014-01-06','13:55:00',1.23),('8975','2014-01-06','14:00:00',1.2),('8975','2014-01-06','14:05:00',1.15),('8975','2014-01-06','14:10:00',1.1),('8975','2014-01-06','14:15:00',1.12),('8975','2014-01-06','14:20:00',1.11),('8975','2014-01-06','14:25:00',1.06),('8975','2014-01-06','14:30:00',1.05),('8975','2014-01-06','14:35:00',1),('8975','2014-01-06','14:45:00',1.01),('8975','2014-01-06','14:50:00',1.07),('8975','2014-01-06','14:55:00',1.06),('8975','2014-01-06','15:00:00',1.05),('8975','2014-01-06','15:05:00',1.05),('8975','2014-01-06','15:10:00',1.01),('8975','2014-04-23','06:55:00',1.1),('8975','2014-04-23','07:00:00',1.29),('8975','2014-04-23','07:05:00',1.4),('8975','2014-04-23','07:10:00',1.56),('8975','2014-04-23','07:15:00',1.87),('8975','2014-04-23','07:20:00',1.83),('8975','2014-04-23','07:25:00',2.13),('8975','2014-04-23','07:30:00',2.28),('8975','2014-04-23','07:35:00',2.42),('8975','2014-04-23','07:40:00',2.56),('8975','2014-04-23','07:45:00',2.73),('8975','2014-04-23','07:50:00',2.87),('8975','2014-04-23','07:55:00',3),('8975','2014-04-23','08:00:00',3.1),('8975','2014-04-23','08:05:00',3.22),('8975','2014-04-23','08:10:00',3.32),('8975','2014-04-23','08:15:00',3.42),('8975','2014-04-23','08:20:00',3.52),('8975','2014-04-23','08:25:00',3.63),('8975','2014-04-23','08:30:00',3.72),('8975','2014-04-23','08:35:00',3.8),('8975','2014-04-23','08:40:00',3.91),('8975','2014-04-23','08:45:00',4.01),('8975','2014-04-23','08:50:00',4.1),('8975','2014-04-23','08:55:00',4.21),('8975','2014-04-23','09:00:00',4.31),('8975','2014-04-23','09:05:00',4.39),('8975','2014-04-23','09:10:00',4.48),('8975','2014-04-23','09:15:00',4.58),('8975','2014-04-23','09:20:00',4.66),('8975','2014-04-23','09:25:00',4.74),('8975','2014-04-23','09:30:00',4.84),('8975','2014-04-23','09:35:00',4.95),('8975','2014-04-23','09:40:00',5.04),('8975','2014-04-23','09:45:00',5.12),('8975','2014-04-23','09:50:00',5.2),('8975','2014-04-23','09:55:00',5.23),('8975','2014-04-23','10:00:00',5.33),('8975','2014-04-23','10:05:00',5.42),('8975','2014-04-23','10:10:00',5.4),('8975','2014-04-23','10:15:00',5.49),('8975','2014-04-23','10:20:00',5.52),('8975','2014-04-23','10:25:00',5.58),('8975','2014-04-23','10:30:00',5.66),('8975','2014-04-23','10:35:00',5.69),('8975','2014-04-23','10:40:00',5.7),('8975','2014-04-23','10:45:00',5.81),('8975','2014-04-23','10:50:00',5.78),('8975','2014-04-23','10:55:00',5.84),('8975','2014-04-23','11:00:00',5.86),('8975','2014-04-23','11:05:00',5.89),('8975','2014-04-23','11:10:00',5.95),('8975','2014-04-23','11:15:00',6.01),('8975','2014-04-23','11:20:00',6.08),('8975','2014-04-23','11:25:00',6.17),('8975','2014-04-23','11:30:00',6.16),('8975','2014-04-23','11:35:00',6.02),('8975','2014-04-23','11:40:00',6.17),('8975','2014-04-23','11:45:00',6.11),('8975','2014-04-23','11:50:00',6.06),('8975','2014-04-23','11:55:00',6.19),('8975','2014-04-23','12:00:00',6.2),('8975','2014-04-23','12:05:00',6.35),('8975','2014-04-23','12:10:00',4.77),('8975','2014-04-23','12:15:00',6.46),('8975','2014-04-23','12:20:00',6.4),('8975','2014-04-23','12:25:00',6.47),('8975','2014-04-23','12:30:00',6.61),('8975','2014-04-23','12:35:00',6.66),('8975','2014-04-23','12:40:00',6.61),('8975','2014-04-23','12:45:00',6.47),('8975','2014-04-23','12:50:00',6.51),('8975','2014-04-23','12:55:00',2.69),('8975','2014-04-23','13:00:00',1.15),('8975','2014-04-23','13:10:00',1.08),('8975','2014-04-23','13:15:00',5.54),('8975','2014-04-23','13:20:00',4.54),('8975','2014-04-23','13:25:00',2.63),('8975','2014-04-23','13:30:00',1.38),('8975','2014-04-23','13:35:00',1.25),('8975','2014-04-23','13:40:00',2.95),('8975','2014-04-23','13:45:00',7.24),('8975','2014-04-23','13:50:00',6.81),('8975','2014-04-23','13:55:00',6.32),('8975','2014-04-23','14:00:00',6.4),('8975','2014-04-23','14:05:00',6.46),('8975','2014-04-23','14:10:00',6.62),('8975','2014-04-23','14:15:00',6.58),('8975','2014-04-23','14:20:00',6.53),('8975','2014-04-23','14:25:00',6.2),('8975','2014-04-23','14:30:00',5.59),('8975','2014-04-23','14:35:00',5.17),('8975','2014-04-23','14:40:00',4.69),('8975','2014-04-23','14:45:00',4.63),('8975','2014-04-23','14:50:00',3.12),('8975','2014-04-23','14:55:00',6.42),('8975','2014-04-23','15:00:00',6),('8975','2014-04-23','15:05:00',5.72),('8975','2014-04-23','15:10:00',5.8),('8975','2014-04-23','15:15:00',5.51),('8975','2014-04-23','15:20:00',4.56),('8975','2014-04-23','15:25:00',3.51),('8975','2014-04-23','15:30:00',3.9),('8975','2014-04-23','15:35:00',5.25),('8975','2014-04-23','15:40:00',3.92),('8975','2014-04-23','15:45:00',3.89),('8975','2014-04-23','15:50:00',4.38),('8975','2014-04-23','15:55:00',3.81),('8975','2014-04-23','16:00:00',4.92),('8975','2014-04-23','16:05:00',4.35),('8975','2014-04-23','16:10:00',4.17),('8975','2014-04-23','16:15:00',4.41),('8975','2014-04-23','16:20:00',4.76),('8975','2014-04-23','16:25:00',3.66),('8975','2014-04-23','16:30:00',3.31),('8975','2014-04-23','16:35:00',2.82),('8975','2014-04-23','16:40:00',2.64),('8975','2014-04-23','16:45:00',2.66),('8975','2014-04-23','16:50:00',1.64),('8975','2014-04-23','16:55:00',1.78),('8975','2014-04-23','17:00:00',1.87),('8975','2014-04-23','17:05:00',1.79),('8975','2014-04-23','17:10:00',1.68),('8975','2014-04-23','17:15:00',1.55),('8975','2014-04-23','17:20:00',1.54),('8975','2014-04-23','17:25:00',1.56),('8975','2014-04-23','17:30:00',1.9),('8975','2014-04-23','17:35:00',1.49),('8975','2014-04-23','17:40:00',1.23),('8975','2014-01-05','11:10:00',1.04),('8975','2014-01-05','11:15:00',1.25),('8975','2014-01-05','11:20:00',1.29),('8975','2014-01-05','11:25:00',1.4),('8975','2014-01-05','11:30:00',1.04),('8975','2014-01-05','11:40:00',1.14),('8975','2014-01-05','11:45:00',1.88),('8975','2014-01-05','11:50:00',2.17),('8975','2014-01-05','11:55:00',2.29),('8975','2014-01-05','12:00:00',1.85),('8975','2014-01-05','12:05:00',1.05),('8975','2014-01-05','12:10:00',2.04),('8975','2014-01-05','12:15:00',1.97),('8975','2014-01-05','12:20:00',1.93),('8975','2014-01-05','12:25:00',1.86),('8975','2014-01-05','12:30:00',1.78),('8975','2014-01-05','12:35:00',1.75),('8975','2014-01-05','12:40:00',1.68),('8975','2014-01-05','12:45:00',1.67),('8975','2014-01-05','12:50:00',1.72),('8975','2014-01-05','12:55:00',1.7),('8975','2014-01-05','13:00:00',1.62),('8975','2014-01-05','13:05:00',1.61),('8975','2014-01-05','13:10:00',1.54),('8975','2014-01-05','13:15:00',1.54),('8975','2014-01-05','13:20:00',1.5),('8975','2014-01-05','13:25:00',1.32),('8975','2014-01-05','13:30:00',1.26),('8975','2014-01-05','13:35:00',1.19),('8975','2014-01-05','13:40:00',1.28),('8975','2014-01-05','13:45:00',1.27),('8975','2014-01-05','13:50:00',1.23),('8975','2014-01-05','13:55:00',1.2),('8975','2014-01-05','14:00:00',1.12),('8975','2014-01-05','14:10:00',1.14),('8975','2014-01-05','14:15:00',1.41),('8975','2014-01-05','14:30:00',1.27),('8975','2014-01-05','14:35:00',1.32),('8975','2014-01-05','14:40:00',1.2),('8975','2014-01-05','14:45:00',1.19),('8975','2014-01-05','14:50:00',1.14),('8975','2014-01-05','14:55:00',1.11),('8975','2014-01-05','15:05:00',1.04),('8975','2014-01-03','15:00:00',1.05),('8975','2014-01-02','08:50:00',1.04),('8975','2014-01-02','09:10:00',1.2),('8975','2014-01-02','09:15:00',1.53),('8975','2014-01-02','09:25:00',1.36),('8975','2014-01-02','09:30:00',2.37),('8975','2014-01-02','09:35:00',2.51),('8975','2014-01-02','09:40:00',1.07),('8975','2014-01-02','09:45:00',2.8),('8975','2014-01-02','09:50:00',1.65),('8975','2014-01-02','09:55:00',2.49),('8975','2014-01-02','10:00:00',2.62),('8975','2014-01-02','10:05:00',1.77),('8975','2014-01-02','10:10:00',1.34),('8975','2014-01-02','10:15:00',1.92),('8975','2014-01-02','10:20:00',1.52),('8975','2014-01-02','10:25:00',1.35),('8975','2014-01-02','10:30:00',1.4),('8975','2014-01-02','10:35:00',1.98),('8975','2014-01-02','10:40:00',1.9),('8975','2014-01-02','10:45:00',2.09),('8975','2014-01-02','10:50:00',1.91),('8975','2014-01-02','10:55:00',1.53),('8975','2014-01-02','11:00:00',1.4),('8975','2014-01-02','11:05:00',1.34),('8975','2014-01-02','11:10:00',1.19),('8975','2014-01-02','11:15:00',1.28),('8975','2014-01-02','11:20:00',1.5),('8975','2014-01-02','11:25:00',1.83),('8975','2014-01-02','11:30:00',1.75),('8975','2014-01-02','11:35:00',1.8),('8975','2014-01-02','11:40:00',2.05),('8975','2014-01-02','11:45:00',1.92),('8975','2014-01-02','11:50:00',1.91),('8975','2014-01-02','11:55:00',1.9),('8975','2014-01-02','12:00:00',2.18),('8975','2014-01-02','12:05:00',2.48),('8975','2014-01-02','12:10:00',2.12),('8975','2014-01-02','12:15:00',1.88),('8975','2014-01-02','12:20:00',1.47),('8975','2014-01-02','12:25:00',1.89),('8975','2014-01-02','12:30:00',2.16),('8975','2014-01-02','12:35:00',2.09),('8975','2014-01-02','12:40:00',1.84),('8975','2014-01-02','12:45:00',1.74),('8975','2014-01-02','12:50:00',1.63),('8975','2014-01-02','12:55:00',1.39),('8975','2014-01-02','13:00:00',1.52),('8975','2014-01-02','13:05:00',1.52),('8975','2014-01-02','13:10:00',1.59),('8975','2014-01-02','13:15:00',1.46),('8975','2014-01-02','13:20:00',1.39),('8975','2014-01-02','13:25:00',1.51),('8975','2014-01-02','13:30:00',1.8),('8975','2014-01-02','13:35:00',1.55),('8975','2014-01-02','13:40:00',1.31),('8975','2014-01-02','13:45:00',1.39),('8975','2014-01-02','13:50:00',1.19),('8975','2014-01-01','08:40:00',1.66),('8975','2014-01-01','08:45:00',1.75),('8975','2014-01-01','08:50:00',1.83),('8975','2014-01-01','08:55:00',1.89),('8975','2014-01-01','09:00:00',1.99),('8975','2014-01-01','09:05:00',2.06),('8975','2014-01-01','09:10:00',2.12),('8975','2014-01-01','09:15:00',2.18),('8975','2014-01-01','09:20:00',2.24),('8975','2014-01-01','09:25:00',2.29),('8975','2014-01-01','09:30:00',2.34),('8975','2014-01-01','09:35:00',2.4),('8975','2014-01-01','09:40:00',2.44),('8975','2014-01-01','09:45:00',2.47),('8975','2014-01-01','09:50:00',2.5),('8975','2014-01-01','09:55:00',2.55),('8975','2014-01-01','10:00:00',2.64),('8975','2014-01-01','10:05:00',2.67),('8975','2014-01-01','10:10:00',2.71),('8975','2014-01-01','10:15:00',2.72),('8975','2014-01-01','10:20:00',2.73),('8975','2014-01-01','10:25:00',2.69),('8975','2014-01-01','10:30:00',2.74),('8975','2014-01-01','10:35:00',2.76),('8975','2014-01-01','10:40:00',2.8),('8975','2014-01-01','10:45:00',2.82),('8975','2014-01-01','10:50:00',2.81),('8975','2014-01-01','10:55:00',2.68),('8975','2014-01-01','11:00:00',3.04),('8975','2014-01-01','11:05:00',1.97),('8975','2014-01-01','11:10:00',1.38),('8975','2014-01-01','11:15:00',1.32),('8975','2014-01-01','11:20:00',1.74),('8975','2014-01-01','11:25:00',2.2),('8975','2014-01-01','11:30:00',2.64),('8975','2014-01-01','11:35:00',2.38),('8975','2014-01-01','11:40:00',3.17),('8975','2014-01-01','11:45:00',2.24),('8975','2014-01-01','11:50:00',1.8),('8975','2014-01-01','11:55:00',1.88),('8975','2014-01-01','12:00:00',1.71),('8975','2014-01-01','12:05:00',1.63),('8975','2014-01-01','12:10:00',1.46),('8975','2014-01-01','12:15:00',1.5),('8975','2014-01-01','12:20:00',1.28),('8975','2014-01-01','12:25:00',1.26),('8975','2014-01-01','12:30:00',1.28),('8975','2014-01-01','12:35:00',1.21),('8975','2014-01-01','12:40:00',1.25),('8975','2014-01-01','12:45:00',1.54),('8975','2014-01-01','12:50:00',2.23),('8975','2014-01-01','12:55:00',1.98),('8975','2014-01-01','13:00:00',1.59),('8975','2014-01-01','13:05:00',1.45),('8975','2014-01-01','13:10:00',1.34),('8975','2014-01-01','13:15:00',1.49),('8975','2014-01-01','13:20:00',1.13),('8975','2014-01-01','13:30:00',1.5),('8975','2014-01-01','13:35:00',1.38),('8975','2014-01-01','13:40:00',1.4),('8975','2014-01-01','13:45:00',1.67),('8975','2014-01-01','13:50:00',1.09),('8975','2014-01-01','14:20:00',1.05),('8975','2014-01-01','14:25:00',1.05),('8975','2013-12-31','08:10:00',1),('8975','2013-12-31','08:15:00',1.1),('8975','2013-12-31','08:20:00',1.2),('8975','2013-12-31','08:25:00',1.41),('8975','2013-12-31','08:30:00',1.09),('8975','2013-12-31','08:50:00',1.93),('8975','2013-12-31','08:55:00',2.27),('8975','2013-12-31','09:00:00',2.45),('8975','2013-12-31','09:05:00',2.64),('8975','2013-12-31','09:10:00',2.37),('8975','2013-12-31','09:15:00',1.8),('8975','2013-12-31','09:20:00',1.33),('8975','2013-12-31','09:25:00',1.36),('8975','2013-12-31','09:30:00',2.14),('8975','2013-12-31','09:35:00',2.25),('8975','2013-12-31','09:40:00',2.09),('8975','2013-12-31','09:45:00',2.58),('8975','2013-12-31','09:50:00',2.94),('8975','2013-12-31','09:55:00',2.81),('8975','2013-12-31','10:00:00',2.15),('8975','2013-12-31','10:05:00',1.77),('8975','2013-12-31','10:10:00',1.47),('8975','2013-12-31','10:15:00',1.29),('8975','2013-12-31','10:20:00',1.18),('8975','2013-12-31','10:25:00',1.15),('8975','2013-12-31','10:30:00',1.15),('8975','2013-12-31','10:35:00',1.11),('8975','2013-12-31','10:40:00',1.12),('8975','2013-12-31','10:45:00',1.17),('8975','2013-12-31','10:50:00',1.27),('8975','2013-12-31','10:55:00',1.38),('8975','2013-12-31','11:00:00',1.41),('8975','2013-12-31','11:05:00',1.36),('8975','2013-12-31','11:10:00',1.32),('8975','2013-12-31','11:15:00',1.4),('8975','2013-12-31','11:20:00',1.46),('8975','2013-12-31','11:25:00',1.5),('8975','2013-12-31','11:30:00',1.51),('8975','2013-12-31','11:35:00',1.47),('8975','2013-12-31','11:40:00',1.44),('8975','2013-12-31','11:45:00',1.43),('8975','2013-12-31','11:50:00',1.42),('8975','2013-12-31','11:55:00',1.5),('8975','2013-12-31','12:00:00',1.63),('8975','2013-12-31','12:05:00',1.72),('8975','2013-12-31','12:10:00',1.79),('8975','2013-12-31','12:15:00',1.89),('8975','2013-12-31','12:20:00',1.87),('8975','2013-12-31','12:25:00',1.88),('8975','2013-12-31','12:30:00',1.91),('8975','2013-12-31','12:35:00',1.91),('8975','2013-12-31','12:40:00',1.87),('8975','2013-12-31','12:45:00',1.82),('8975','2013-12-31','12:50:00',1.8),('8975','2013-12-31','12:55:00',1.77),('8975','2013-12-31','13:00:00',1.77),('8975','2013-12-31','13:05:00',1.65),('8975','2013-12-31','13:10:00',1.62),('8975','2013-12-31','13:15:00',1.58),('8975','2013-12-31','13:20:00',1.66),('8975','2013-12-31','13:25:00',1.88),('8975','2013-12-31','13:30:00',2.07),('8975','2013-12-31','13:35:00',2.23),('8975','2013-12-31','13:40:00',1.94),('8975','2013-12-31','13:45:00',1.87),('8975','2013-12-31','13:50:00',1.51),('8975','2013-12-31','13:55:00',1.52),('8975','2013-12-31','14:00:00',1.76),('8975','2013-12-31','14:05:00',1.78),('8975','2013-12-31','14:10:00',1.64),('8975','2013-12-31','14:15:00',1.48),('8975','2013-12-31','14:20:00',1.26),('8975','2013-12-31','14:25:00',1.13),('8975','2013-12-31','14:30:00',1.13),('8975','2013-12-31','14:35:00',1.04),('8975','2013-12-31','14:40:00',1.05),('8975','2013-12-31','14:55:00',1.05),('8975','2013-12-31','15:00:00',1.04),('8975','2013-12-31','15:05:00',1.3),('8975','2013-12-31','15:10:00',1.42),('8975','2013-12-31','15:15:00',1.2),('8975','2013-12-31','15:20:00',1.08),('8975','2013-12-30','09:20:00',1.39),('8975','2013-12-30','09:25:00',2.5),('8975','2013-12-30','09:30:00',1.91),('8975','2013-12-30','09:35:00',2.21),('8975','2013-12-30','09:40:00',1.96),('8975','2013-12-30','09:45:00',2.84),('8975','2013-12-30','09:50:00',3.18),('8975','2013-12-30','09:55:00',3.49),('8975','2013-12-30','10:00:00',3.15),('8975','2013-12-30','10:05:00',2.35),('8975','2013-12-30','10:10:00',1.24),('8975','2013-12-30','10:15:00',1.29),('8975','2013-12-30','10:20:00',1.18),('8975','2013-12-30','10:25:00',1.23),('8975','2013-12-30','10:30:00',1.44),('8975','2013-12-30','10:35:00',1.43),('8975','2013-12-30','10:40:00',1.47),('8975','2013-12-30','10:45:00',1.64),('8975','2013-12-30','10:50:00',1.87),('8975','2013-12-30','10:55:00',1.97),('8975','2013-12-30','11:00:00',1.95),('8975','2013-12-30','11:05:00',1.81),('8975','2013-12-30','11:10:00',1.69),('8975','2013-12-30','11:15:00',1.5),('8975','2013-12-30','11:20:00',1.69),('8975','2013-12-30','11:25:00',1.14),('8975','2013-12-30','11:30:00',1.3),('8975','2013-12-30','11:35:00',1.74),('8975','2013-12-30','11:40:00',2.23),('8975','2013-12-30','11:45:00',1.51),('8975','2013-12-30','11:50:00',1.45),('8975','2013-12-30','11:55:00',1.84),('8975','2013-12-30','12:00:00',1.34),('8975','2013-12-30','12:05:00',1.75),('8975','2013-12-30','12:10:00',2.54),('8975','2013-12-30','12:15:00',2.64),('8975','2013-12-30','12:20:00',2.59),('8975','2013-12-30','12:25:00',2.54),('8975','2013-12-30','12:30:00',2.42),('8975','2013-12-30','12:35:00',2.32),('8975','2013-12-30','12:40:00',2.3),('8975','2013-12-30','12:45:00',2.27),('8975','2013-12-30','12:50:00',2.21),('8975','2013-12-30','12:55:00',2.16),('8975','2013-12-30','13:00:00',2.08),('8975','2013-12-30','13:05:00',2.01),('8975','2013-12-30','13:10:00',1.87),('8975','2013-12-30','13:15:00',1.87),('8975','2013-12-30','13:20:00',1.8),('8975','2013-12-30','13:25:00',1.71),('8975','2013-12-30','13:30:00',1.64),('8975','2013-12-30','13:35:00',1.52),('8975','2013-12-30','13:40:00',1.47),('8975','2013-12-30','13:45:00',1.46),('8975','2013-12-30','13:50:00',1.43),('8975','2013-12-30','13:55:00',1.38),('8975','2013-12-30','14:00:00',1.32),('8975','2013-12-30','14:05:00',1.28),('8975','2013-12-30','14:10:00',1.2),('8975','2013-12-30','14:15:00',1.15),('8975','2013-12-30','14:20:00',1.14),('8975','2013-12-30','14:25:00',1.13),('8975','2013-12-30','14:30:00',1.11),('8975','2013-12-30','14:35:00',1.1),('8975','2013-12-30','14:40:00',1.11),('8975','2013-12-30','14:45:00',1.15),('8975','2013-12-30','14:50:00',1.12),('8975','2013-12-30','14:55:00',1.08),('8975','2013-12-30','15:00:00',1.05),('8975','2013-12-30','15:05:00',1.03),('8975','2013-12-29','09:25:00',1.09),('8975','2013-12-29','09:30:00',1.03),('8975','2013-12-29','11:10:00',1.02),('8975','2013-12-29','11:15:00',1.28),('8975','2013-12-29','11:20:00',1.55),('8975','2013-12-29','11:25:00',1.66),('8975','2013-12-29','11:30:00',1.62),('8975','2013-12-29','11:35:00',1.55),('8975','2013-12-29','11:40:00',1.49),('8975','2013-12-29','11:45:00',1.47),('8975','2013-12-29','11:50:00',1.41),('8975','2013-12-29','11:55:00',1.27),('8975','2013-12-29','12:00:00',1.15),('8975','2013-12-29','12:05:00',1.13),('8975','2013-12-29','12:10:00',1.16),('8975','2013-12-29','12:15:00',1.15),('8975','2013-12-29','12:20:00',1.12),('8975','2013-12-29','12:25:00',1.17),('8975','2013-12-29','12:30:00',1.15),('8975','2013-12-29','12:35:00',1.17),('8975','2013-12-29','12:40:00',1.25),('8975','2013-12-29','12:45:00',1.29),('8975','2013-12-29','12:50:00',1.21),('8975','2013-12-29','12:55:00',1.09),('8975','2013-12-29','13:05:00',1.04),('8975','2013-12-29','13:10:00',1.1),('8975','2013-12-29','13:15:00',1.04),('8975','2013-12-29','13:20:00',1.02),('8975','2013-12-29','13:25:00',1.07),('8975','2013-12-29','13:30:00',1.08),('8975','2013-12-29','13:35:00',1.06),('8975','2013-12-28','08:20:00',1.23),('8975','2013-12-28','08:25:00',1.07),('8975','2013-12-28','08:40:00',1.02),('8975','2013-12-28','08:45:00',1.97),('8975','2013-12-28','09:00:00',1.49),('8975','2013-12-28','09:05:00',1.94),('8975','2013-12-28','09:10:00',2.09),('8975','2013-12-28','09:15:00',2.15),('8975','2013-12-28','09:20:00',2.33),('8975','2013-12-28','09:25:00',2.4),('8975','2013-12-28','09:30:00',2.45),('8975','2013-12-28','09:35:00',2.42),('8975','2013-12-28','09:40:00',2.4),('8975','2013-12-28','09:45:00',2.53),('8975','2013-12-28','09:50:00',2.25),('8975','2013-12-28','09:55:00',2.2),('8975','2013-12-28','10:00:00',2.14),('8975','2013-12-28','10:05:00',2.51),('8975','2013-12-28','10:10:00',2.33),('8975','2013-12-28','10:15:00',2.11),('8975','2013-12-28','10:20:00',1.25),('8975','2013-12-28','10:25:00',1.05),('8975','2013-12-28','10:30:00',1.13),('8975','2013-12-28','10:35:00',1.31),('8975','2013-12-28','10:40:00',1.55),('8975','2013-12-28','10:45:00',1.39),('8975','2013-12-28','10:50:00',2.19),('8975','2013-12-28','10:55:00',1.92),('8975','2013-12-28','11:00:00',1.54),('8975','2013-12-28','11:05:00',2.14),('8975','2013-12-28','11:10:00',1.33),('8975','2013-12-28','11:15:00',1.19),('8975','2013-12-28','11:20:00',1.07),('8975','2013-12-28','11:25:00',1.13),('8975','2013-12-28','11:30:00',1.18),('8975','2013-12-28','11:50:00',1.12),('8975','2013-12-28','11:55:00',1.3),('8975','2013-12-28','12:00:00',1.21),('8975','2013-12-28','12:05:00',1.08),('8975','2013-12-28','12:10:00',1.04),('8975','2013-12-28','13:40:00',1.06),('8975','2013-12-27','08:10:00',1.06),('8975','2013-12-27','08:15:00',1.19),('8975','2013-12-27','08:20:00',1.29),('8975','2013-12-27','08:25:00',1.41),('8975','2013-12-27','08:30:00',1.55),('8975','2013-12-27','08:35:00',1.66),('8975','2013-12-27','08:40:00',1.74),('8975','2013-12-27','08:45:00',1.83),('8975','2013-12-27','08:50:00',1.9),('8975','2013-12-27','08:55:00',1.97),('8975','2013-12-27','09:00:00',2.05),('8975','2013-12-27','09:05:00',2.12),('8975','2013-12-27','09:10:00',2.19),('8975','2013-12-27','09:15:00',2.25),('8975','2013-12-27','09:20:00',2.3),('8975','2013-12-27','09:25:00',2.35),('8975','2013-12-27','09:30:00',2.42),('8975','2013-12-27','09:35:00',2.48),('8975','2013-12-27','09:40:00',2.52),('8975','2013-12-27','09:45:00',2.56),('8975','2013-12-27','09:50:00',2.62),('8975','2013-12-27','09:55:00',2.65),('8975','2013-12-27','10:00:00',2.67),('8975','2013-12-27','10:05:00',2.7),('8975','2013-12-27','10:10:00',2.74),('8975','2013-12-27','10:15:00',2.79),('8975','2013-12-27','10:20:00',2.73),('8975','2013-12-27','10:25:00',2.76),('8975','2013-12-27','10:30:00',2.82),('8975','2013-12-27','10:35:00',2.86),('8975','2013-12-27','10:40:00',2.91),('8975','2013-12-27','10:45:00',2.87),('8975','2013-12-27','10:50:00',2.8),('8975','2013-12-27','10:55:00',2.91),('8975','2013-12-27','11:00:00',2.92),('8975','2013-12-27','11:05:00',2.92),('8975','2013-12-27','11:10:00',2.93),('8975','2013-12-27','11:15:00',2.96),('8975','2013-12-27','11:20:00',2.95),('8975','2013-12-27','11:25:00',2.94),('8975','2013-12-27','11:30:00',2.91),('8975','2013-12-27','11:35:00',2.88),('8975','2013-12-27','11:40:00',2.78),('8975','2013-12-27','11:45:00',2.72),('8975','2013-12-27','11:50:00',2.67),('8975','2013-12-27','11:55:00',2.58),('8975','2013-12-27','12:00:00',2.53),('8975','2013-12-27','12:05:00',2.45),('8975','2013-12-27','12:10:00',2.43),('8975','2013-12-27','12:15:00',2.4),('8975','2013-12-27','12:20:00',2.37),('8975','2013-12-27','12:25:00',2.34),('8975','2013-12-27','12:30:00',2.24),('8975','2013-12-27','12:35:00',2.15),('8975','2013-12-27','12:40:00',2.14),('8975','2013-12-27','12:45:00',2.12),('8975','2013-12-27','12:50:00',1.98),('8975','2013-12-27','12:55:00',1.97),('8975','2013-12-27','13:00:00',1.94),('8975','2013-12-27','13:05:00',1.77),('8975','2013-12-27','13:10:00',1.76),('8975','2013-12-27','13:15:00',1.61),('8975','2013-12-27','13:20:00',1.6),('8975','2013-12-27','13:25:00',1.55),('8975','2013-12-27','13:30:00',1.49),('8975','2013-12-27','13:35:00',1.37),('8975','2013-12-27','13:40:00',1.32),('8975','2013-12-27','13:45:00',1.33),('8975','2013-12-27','13:50:00',1.31),('8975','2013-12-27','13:55:00',1.25),('8975','2013-12-27','14:00:00',1.19),('8975','2013-12-27','14:05:00',1.17),('8975','2013-12-27','14:10:00',1.1),('8975','2013-12-27','14:15:00',1.07),('8975','2013-12-27','14:20:00',1.07),('8975','2013-12-27','14:25:00',1.09),('8975','2013-12-27','14:30:00',1.09),('8975','2013-12-27','14:35:00',1.09),('8975','2013-12-27','14:40:00',1.14),('8975','2013-12-27','14:45:00',1.05),('8975','2013-12-27','15:05:00',1.05),('8975','2014-04-22','11:40:00',1.1),('8975','2014-04-22','11:45:00',1.01),('8975','2014-04-22','13:00:00',1.13),('8975','2014-04-22','13:05:00',1.49),('8975','2014-04-22','13:10:00',1.92),('8975','2014-04-22','13:15:00',2.16),('8975','2014-04-22','13:20:00',2.35),('8975','2014-04-22','13:25:00',2.35),('8975','2014-04-22','13:30:00',2.49),('8975','2014-04-22','13:35:00',2.54),('8975','2014-04-22','13:40:00',2.56),('8975','2014-04-22','13:45:00',2.46),('8975','2014-04-22','13:50:00',2.45),('8975','2014-04-22','13:55:00',2.47),('8975','2014-04-22','14:00:00',2.4),('8975','2014-04-22','14:05:00',2.39),('8975','2014-04-22','14:10:00',2.17),('8975','2014-04-22','14:15:00',1.7),('8975','2014-04-22','14:20:00',1.49),('8975','2014-04-22','14:25:00',1.38),('8975','2014-04-22','14:30:00',1.33),('8975','2014-04-22','14:35:00',1.37),('8975','2014-04-22','14:40:00',1.56),('8975','2014-04-22','14:45:00',1.9),('8975','2014-04-22','14:50:00',2.23),('8975','2014-04-22','14:55:00',2.55),('8975','2014-04-22','15:00:00',2.7),('8975','2014-04-22','15:05:00',2.73),('8975','2014-04-22','15:10:00',2.72),('8975','2014-04-22','15:15:00',2.72),('8975','2014-04-22','15:20:00',2.44),('8975','2014-04-22','15:25:00',2.27),('8975','2014-04-22','15:30:00',2),('8975','2014-04-22','15:35:00',1.9),('8975','2014-04-22','15:40:00',1.8),('8975','2014-04-22','15:45:00',1.85),('8975','2014-04-22','15:50:00',1.73),('8975','2014-04-22','15:55:00',1.64),('8975','2014-04-22','16:00:00',1.44),('8975','2014-04-22','16:05:00',1.34),('8975','2014-04-22','16:10:00',1.2),('8975','2014-04-22','16:15:00',1.07),('8975','2013-12-26','10:30:00',1.17),('8975','2013-12-26','10:35:00',1.2),('8975','2013-12-26','10:40:00',1.18),('8975','2013-12-26','10:45:00',1.09),('8975','2013-12-26','11:30:00',1.07),('8975','2013-12-26','11:35:00',1.15),('8975','2013-12-26','11:40:00',1.26),('8975','2013-12-26','11:45:00',1.31),('8975','2013-12-26','11:50:00',1.31),('8975','2013-12-26','11:55:00',1.11),('8975','2013-12-26','12:00:00',1.02),('8975','2013-12-26','12:05:00',1.37),('8975','2013-12-26','12:10:00',2.17),('8975','2013-12-26','12:15:00',2.22),('8975','2013-12-26','12:20:00',2.24),('8975','2013-12-26','12:25:00',1.9),('8975','2013-12-26','12:30:00',1.56),('8975','2013-12-26','12:35:00',1.5),('8975','2013-12-26','12:40:00',1.45),('8975','2013-12-26','12:45:00',1.68),('8975','2013-12-26','12:50:00',2.08),('8975','2013-12-26','12:55:00',2.02),('8975','2013-12-26','13:00:00',1.84),('8975','2013-12-26','13:05:00',1.48),('8975','2013-12-26','13:10:00',1.42),('8975','2013-12-26','13:15:00',1.45),('8975','2013-12-26','13:20:00',1.62),('8975','2013-12-26','13:25:00',2.03),('8975','2013-12-26','13:30:00',1.97),('8975','2013-12-26','13:35:00',2.38),('8975','2013-12-26','13:40:00',1.81),('8975','2013-12-26','13:45:00',1.52),('8975','2013-12-26','13:50:00',1.36),('8975','2013-12-26','13:55:00',1.04),('8975','2013-12-26','14:05:00',1.35),('8975','2013-12-26','14:10:00',1.32),('8975','2013-12-26','14:15:00',1.28),('8975','2013-12-26','14:20:00',1.25),('8975','2013-12-26','14:25:00',1.26),('8975','2013-12-26','14:30:00',1.35),('8975','2013-12-26','14:35:00',1.42),('8975','2013-12-26','14:40:00',1.48),('8975','2013-12-26','14:45:00',1.13),('8975','2013-12-25','11:05:00',1.03),('8975','2013-12-24','09:10:00',1.28),('8975','2013-12-24','09:15:00',2.29),('8975','2013-12-24','09:20:00',2.72),('8975','2013-12-24','09:25:00',2.14),('8975','2013-12-24','09:30:00',1.34),('8975','2013-12-24','09:35:00',1.35),('8975','2013-12-24','09:40:00',1.15),('8975','2013-12-24','09:45:00',1.21),('8975','2013-12-24','10:25:00',1.69),('8975','2013-12-24','10:30:00',2.1),('8975','2013-12-24','10:35:00',1.93),('8975','2013-12-24','10:40:00',1.85),('8975','2013-12-24','10:45:00',2.01),('8975','2013-12-24','10:50:00',1.57),('8975','2013-12-24','10:55:00',1.25),('8975','2013-12-24','11:00:00',1.25),('8975','2013-12-24','11:05:00',1.42),('8975','2013-12-24','11:10:00',1.25),('8975','2013-12-24','11:15:00',1.61),('8975','2013-12-24','11:20:00',1.87),('8975','2013-12-24','11:25:00',2.39),('8975','2013-12-24','11:30:00',2.55),('8975','2013-12-24','11:35:00',2.14),('8975','2013-12-24','11:40:00',2.25),('8975','2013-12-24','11:45:00',2.45),('8975','2013-12-24','11:50:00',2.06),('8975','2013-12-24','11:55:00',1.53),('8975','2013-12-24','12:00:00',1.96),('8975','2013-12-24','12:05:00',2.28),('8975','2013-12-24','12:10:00',1.6),('8975','2013-12-24','12:15:00',2.05),('8975','2013-12-24','12:20:00',2.51),('8975','2013-12-24','12:25:00',2.05),('8975','2013-12-24','12:30:00',1.75),('8975','2013-12-24','12:35:00',1.52),('8975','2013-12-24','12:40:00',1.23),('8975','2013-12-24','12:45:00',1.33),('8975','2013-12-24','12:50:00',1.19),('8975','2013-12-24','13:05:00',1.17),('8975','2013-12-24','13:10:00',1.2),('8975','2013-12-24','13:25:00',1.33),('8975','2013-12-24','13:30:00',1.45),('8975','2013-12-24','13:35:00',1.41),('8975','2013-12-24','13:40:00',1.52),('8975','2013-12-24','13:45:00',1.52),('8975','2013-12-24','13:50:00',1.65),('8975','2013-12-24','13:55:00',1.54),('8975','2013-12-24','14:00:00',1.35),('8975','2013-12-24','14:05:00',1.19),('8975','2013-12-24','14:10:00',1.11),('8975','2013-12-24','14:15:00',1.05),('8975','2013-12-23','08:20:00',1.12),('8975','2013-12-23','08:50:00',1.13),('8975','2013-12-23','08:55:00',1.35),('8975','2013-12-23','09:00:00',1.53),('8975','2013-12-23','09:05:00',1.71),('8975','2013-12-23','09:10:00',1.88),('8975','2013-12-23','09:15:00',2.03),('8975','2013-12-23','09:20:00',2.12),('8975','2013-12-23','09:25:00',2.13),('8975','2013-12-23','09:30:00',2.08),('8975','2013-12-23','09:35:00',1.99),('8975','2013-12-23','09:40:00',1.93),('8975','2013-12-23','09:45:00',1.96),('8975','2013-12-23','09:50:00',2.27),('8975','2013-12-23','09:55:00',2.41),('8975','2013-12-23','10:00:00',2.51),('8975','2013-12-23','10:05:00',2.5),('8975','2013-12-23','10:10:00',2.55),('8975','2013-12-23','10:15:00',2.6),('8975','2013-12-23','10:20:00',2.54),('8975','2013-12-23','10:25:00',2.52),('8975','2013-12-23','10:30:00',2.63),('8975','2013-12-23','10:35:00',2.65),('8975','2013-12-23','10:40:00',2.68),('8975','2013-12-23','10:45:00',2.72),('8975','2013-12-23','10:50:00',2.73),('8975','2013-12-23','10:55:00',2.71),('8975','2013-12-23','11:00:00',2.73),('8975','2013-12-23','11:05:00',2.71),('8975','2013-12-23','11:10:00',2.71),('8975','2013-12-23','11:15:00',2.72),('8975','2013-12-23','11:20:00',2.7),('8975','2013-12-23','11:25:00',2.68),('8975','2013-12-23','11:30:00',2.5),('8975','2013-12-23','11:35:00',2.57),('8975','2013-12-23','11:40:00',2.48),('8975','2013-12-23','11:45:00',2.56),('8975','2013-12-23','11:50:00',2.52),('8975','2013-12-23','11:55:00',2.34),('8975','2013-12-23','12:00:00',2.29),('8975','2013-12-23','12:05:00',2.18),('8975','2013-12-23','12:10:00',2.15),('8975','2013-12-23','12:15:00',2.18),('8975','2013-12-23','12:20:00',2.16),('8975','2013-12-23','12:25:00',2.08),('8975','2013-12-23','12:30:00',2.06),('8975','2013-12-23','12:35:00',1.96),('8975','2013-12-23','12:40:00',1.92),('8975','2013-12-23','12:45:00',1.91),('8975','2013-12-23','12:50:00',1.81),('8975','2013-12-23','12:55:00',1.79),('8975','2013-12-23','13:00:00',1.8),('8975','2013-12-23','13:05:00',1.67),('8975','2013-12-23','13:10:00',1.63),('8975','2013-12-23','13:15:00',1.6),('8975','2013-12-23','13:20:00',1.56),('8975','2013-12-23','13:25:00',1.49),('8975','2013-12-23','13:30:00',1.37),('8975','2013-12-23','13:35:00',1.3),('8975','2013-12-23','13:40:00',1.27),('8975','2013-12-23','13:45:00',1.28),('8975','2013-12-23','13:50:00',1.21),('8975','2013-12-23','13:55:00',1.21),('8975','2013-12-23','14:00:00',1.17),('8975','2013-12-23','14:05:00',1.12),('8975','2013-12-23','14:10:00',1.04),('8975','2013-12-23','14:15:00',1.08),('8975','2013-12-23','14:20:00',1.05),('8975','2013-12-23','14:25:00',1.03),('8975','2013-12-23','14:30:00',1),('8975','2013-12-22','09:15:00',1.01),('8975','2013-12-22','09:20:00',1.14),('8975','2013-12-22','09:25:00',1.3),('8975','2013-12-22','09:30:00',1.42),('8975','2013-12-22','09:35:00',1.51),('8975','2013-12-22','09:40:00',1.56),('8975','2013-12-22','09:45:00',1.79),('8975','2013-12-22','09:50:00',2.21),('8975','2013-12-22','09:55:00',2.37),('8975','2013-12-22','10:00:00',2.54),('8975','2013-12-22','10:05:00',2.36),('8975','2013-12-22','10:10:00',2.53),('8975','2013-12-22','10:15:00',2.89),('8975','2013-12-22','10:20:00',2.67),('8975','2013-12-22','10:25:00',2.38),('8975','2013-12-22','10:30:00',2.45),('8975','2013-12-22','10:35:00',2.7),('8975','2013-12-22','10:40:00',2.8),('8975','2013-12-22','10:45:00',2.36),('8975','2013-12-22','10:50:00',2.78),('8975','2013-12-22','10:55:00',3.12),('8975','2013-12-22','11:00:00',3.09),('8975','2013-12-22','11:05:00',3.04),('8975','2013-12-22','11:10:00',3),('8975','2013-12-22','11:15:00',3.02),('8975','2013-12-22','11:20:00',3.06),('8975','2013-12-22','11:25:00',2.98),('8975','2013-12-22','11:30:00',2.72),('8975','2013-12-22','11:35:00',2.6),('8975','2013-12-22','11:40:00',2.53),('8975','2013-12-22','11:45:00',2.39),('8975','2013-12-22','11:50:00',2.31),('8975','2013-12-22','11:55:00',2.54),('8975','2013-12-22','12:00:00',2.38),('8975','2013-12-22','12:05:00',2.3),('8975','2013-12-22','12:10:00',2.37),('8975','2013-12-22','12:15:00',2.27),('8975','2013-12-22','12:20:00',2.24),('8975','2013-12-22','12:25:00',2.18),('8975','2013-12-22','12:30:00',2.11),('8975','2013-12-22','12:35:00',2.07),('8975','2013-12-22','12:40:00',2.07),('8975','2013-12-22','12:45:00',2),('8975','2013-12-22','12:50:00',1.91),('8975','2013-12-22','12:55:00',1.92),('8975','2013-12-22','13:00:00',1.86),('8975','2013-12-22','13:05:00',1.68),('8975','2013-12-22','13:10:00',1.62),('8975','2013-12-22','13:20:00',1.14),('8975','2013-12-22','13:25:00',1.53),('8975','2013-12-22','13:30:00',1.01),('8975','2013-12-22','13:40:00',1.22),('8975','2013-12-22','13:45:00',1.26),('8975','2013-12-22','13:50:00',1.2),('8975','2013-12-22','13:55:00',1.27),('8975','2013-12-22','14:00:00',1.25),('8975','2013-12-22','14:05:00',1.17),('8975','2013-12-22','14:10:00',1.12),('8975','2013-12-22','14:15:00',1.12),('8975','2013-12-22','14:20:00',1.11),('8975','2013-12-22','14:25:00',1.04),('8975','2013-12-22','14:30:00',1.07),('8975','2013-12-22','14:35:00',1.1),('8975','2013-12-22','14:40:00',1.1),('8975','2013-12-22','14:45:00',1.07),('8975','2013-12-22','14:50:00',1.04),('8975','2013-12-22','14:55:00',1),('8975','2013-12-21','08:30:00',1.07),('8975','2013-12-21','08:35:00',1.1),('8975','2013-12-21','08:40:00',1.19),('8975','2013-12-21','08:45:00',1.2),('8975','2013-12-21','08:50:00',1.29),('8975','2013-12-21','08:55:00',1.32),('8975','2013-12-21','09:00:00',1.71),('8975','2013-12-21','09:05:00',1.82),('8975','2013-12-21','09:10:00',1.67),('8975','2013-12-21','09:15:00',1.97),('8975','2013-12-21','09:20:00',2.19),('8975','2013-12-21','09:25:00',2.02),('8975','2013-12-21','09:30:00',2.4),('8975','2013-12-21','09:35:00',3.06),('8975','2013-12-21','09:40:00',3.07),('8975','2013-12-21','09:45:00',3.27),('8975','2013-12-21','09:50:00',3.3),('8975','2013-12-21','09:55:00',3.24),('8975','2013-12-21','10:00:00',3.16),('8975','2013-12-21','10:05:00',3.17),('8975','2013-12-21','10:10:00',3.15),('8975','2013-12-21','10:15:00',3),('8975','2013-12-21','10:20:00',2.88),('8975','2013-12-21','10:25:00',2.87),('8975','2013-12-21','10:30:00',2.82),('8975','2013-12-21','10:35:00',2.63),('8975','2013-12-21','10:40:00',2.44),('8975','2013-12-21','10:45:00',2.49),('8975','2013-12-21','10:50:00',2.45),('8975','2013-12-21','10:55:00',2.31),('8975','2013-12-21','11:00:00',2.71),('8975','2013-12-21','11:05:00',3.03),('8975','2013-12-21','11:10:00',3),('8975','2013-12-21','11:15:00',2.89),('8975','2013-12-21','11:20:00',2.58),('8975','2013-12-21','11:25:00',2.64),('8975','2013-12-21','11:30:00',2.34),('8975','2013-12-21','11:35:00',2.36),('8975','2013-12-21','11:40:00',2.49),('8975','2013-12-21','11:45:00',2.22),('8975','2013-12-21','11:50:00',1.51),('8975','2013-12-21','11:55:00',1.24),('8975','2013-12-21','12:00:00',1.07),('8975','2013-12-21','12:05:00',1.04),('8975','2013-12-21','12:10:00',1.13),('8975','2013-12-21','12:15:00',1.29),('8975','2013-12-21','12:20:00',1.58),('8975','2013-12-21','12:25:00',1.75),('8975','2013-12-21','12:30:00',2.06),('8975','2013-12-21','12:35:00',2.09),('8975','2013-12-21','12:40:00',2),('8975','2013-12-21','12:45:00',2.17),('8975','2013-12-21','12:50:00',2.47),('8975','2013-12-21','12:55:00',2.75),('8975','2013-12-21','13:00:00',2.64),('8975','2013-12-21','13:05:00',2.7),('8975','2013-12-21','13:10:00',2.46),('8975','2013-12-21','13:15:00',2.03),('8975','2013-12-21','13:20:00',1.79),('8975','2013-12-21','13:25:00',1.77),('8975','2013-12-21','13:30:00',1.71),('8975','2013-12-21','13:35:00',1.52),('8975','2013-12-21','13:40:00',1.3),('8975','2013-12-21','13:45:00',1.48),('8975','2013-12-21','13:50:00',1.22),('8975','2013-12-21','13:55:00',1.25),('8975','2013-12-21','14:00:00',1.02),('8975','2013-12-21','14:05:00',1.34),('8975','2013-12-21','14:10:00',1.3),('8975','2013-12-21','14:15:00',1.15),('8975','2013-12-21','14:20:00',1.14),('8975','2013-12-21','14:25:00',1.09),('8975','2013-12-21','14:30:00',1.08),('8975','2013-12-21','14:35:00',1.17),('8975','2013-12-21','14:40:00',1.25),('8975','2013-12-21','14:45:00',1.17),('8975','2013-12-20','08:15:00',1.03),('8975','2013-12-20','08:20:00',1.17),('8975','2013-12-20','08:25:00',1.29),('8975','2013-12-20','08:30:00',1.41),('8975','2013-12-20','08:35:00',1.52),('8975','2013-12-20','08:40:00',1.62),('8975','2013-12-20','08:45:00',1.71),('8975','2013-12-20','08:50:00',1.77),('8975','2013-12-20','08:55:00',1.84),('8975','2013-12-20','09:00:00',1.9),('8975','2013-12-20','09:05:00',1.94),('8975','2013-12-20','09:10:00',2.01),('8975','2013-12-20','09:15:00',2.08),('8975','2013-12-20','09:20:00',2.15),('8975','2013-12-20','09:25:00',2.21),('8975','2013-12-20','09:30:00',2.26),('8975','2013-12-20','09:35:00',2.3),('8975','2013-12-20','09:40:00',2.37),('8975','2013-12-20','09:45:00',2.43),('8975','2013-12-20','09:50:00',2.48),('8975','2013-12-20','09:55:00',2.52),('8975','2013-12-20','10:00:00',2.55),('8975','2013-12-20','10:05:00',2.58),('8975','2013-12-20','10:10:00',2.59),('8975','2013-12-20','10:15:00',2.6),('8975','2013-12-20','10:20:00',2.57),('8975','2013-12-20','10:25:00',2.62),('8975','2013-12-20','10:30:00',2.66),('8975','2013-12-20','10:35:00',2.69),('8975','2013-12-20','10:40:00',2.74),('8975','2013-12-20','10:45:00',2.77),('8975','2013-12-20','10:50:00',2.78),('8975','2013-12-20','10:55:00',2.8),('8975','2013-12-20','11:00:00',2.81),('8975','2013-12-20','11:05:00',2.81),('8975','2013-12-20','11:10:00',2.82),('8975','2013-12-20','11:15:00',2.85),('8975','2013-12-20','11:20:00',2.86),('8975','2013-12-20','11:25:00',2.8),('8975','2013-12-20','11:30:00',2.59),('8975','2013-12-20','11:35:00',2.65),('8975','2013-12-20','11:40:00',2.62),('8975','2013-12-20','11:45:00',2.57),('8975','2013-12-20','11:50:00',2.49),('8975','2013-12-20','11:55:00',2.49),('8975','2013-12-20','12:00:00',2.46),('8975','2013-12-20','12:05:00',2.42),('8975','2013-12-20','12:10:00',2.39),('8975','2013-12-20','12:15:00',2.36),('8975','2013-12-20','12:20:00',2.32),('8975','2013-12-20','12:25:00',2.25),('8975','2013-12-20','12:30:00',2.2),('8975','2013-12-20','12:35:00',2.13),('8975','2013-12-20','12:40:00',2.14),('8975','2013-12-20','12:45:00',2.07),('8975','2013-12-20','12:50:00',2.02),('8975','2013-12-20','12:55:00',1.98),('8975','2013-12-20','13:00:00',1.83),('8975','2013-12-20','13:05:00',1.76),('8975','2013-12-20','13:10:00',1.71),('8975','2013-12-20','13:15:00',1.68),('8975','2013-12-20','13:20:00',1.61),('8975','2013-12-20','13:25:00',1.51),('8975','2013-12-20','13:30:00',1.41),('8975','2013-12-20','13:35:00',1.38),('8975','2013-12-20','13:40:00',1.32),('8975','2013-12-20','13:45:00',1.33),('8975','2013-12-20','13:50:00',1.31),('8975','2013-12-20','13:55:00',1.25),('8975','2013-12-20','14:00:00',1.18),('8975','2013-12-20','14:05:00',1.09),('8975','2013-12-20','14:10:00',1.09),('8975','2013-12-20','14:15:00',1.07),('8975','2013-12-20','14:20:00',1.03),('8975','2013-12-20','14:25:00',1.05),('8975','2013-12-20','14:30:00',1.04),('8975','2013-12-20','14:35:00',1.07),('8975','2013-12-20','14:40:00',1.09),('8975','2013-12-20','14:45:00',1.06),('8975','2013-12-20','14:50:00',1.03),('8975','2013-12-20','14:55:00',1.01),('8975','2013-12-19','08:15:00',1.13),('8975','2013-12-19','08:20:00',1.32),('8975','2013-12-19','08:25:00',1.44),('8975','2013-12-19','08:30:00',1.45),('8975','2013-12-19','08:35:00',1.57),('8975','2013-12-19','08:40:00',1.59),('8975','2013-12-19','08:45:00',1.6),('8975','2013-12-19','08:50:00',1.63),('8975','2013-12-19','08:55:00',1.74),('8975','2013-12-19','09:00:00',1.81),('8975','2013-12-19','09:05:00',1.87),('8975','2013-12-19','09:10:00',1.89),('8975','2013-12-19','09:15:00',1.99),('8975','2013-12-19','09:20:00',2.06),('8975','2013-12-19','09:25:00',2.13),('8975','2013-12-19','09:30:00',2.2),('8975','2013-12-19','09:35:00',2.23),('8975','2013-12-19','09:40:00',2.29),('8975','2013-12-19','09:45:00',2.35),('8975','2013-12-19','09:50:00',2.38),('8975','2013-12-19','09:55:00',2.43),('8975','2013-12-19','10:00:00',2.48),('8975','2013-12-19','10:05:00',2.51),('8975','2013-12-19','10:10:00',2.49),('8975','2013-12-19','10:15:00',2.53),('8975','2013-12-19','10:20:00',2.46),('8975','2013-12-19','10:25:00',2.41),('8975','2013-12-19','10:30:00',2.56),('8975','2013-12-19','10:35:00',2.63),('8975','2013-12-19','10:40:00',2.63),('8975','2013-12-19','10:45:00',2.68),('8975','2013-12-19','10:50:00',2.69),('8975','2013-12-19','10:55:00',2.7),('8975','2013-12-19','11:00:00',2.73),('8975','2013-12-19','11:05:00',2.74),('8975','2013-12-19','11:10:00',2.73),('8975','2013-12-19','11:15:00',2.75),('8975','2013-12-19','11:20:00',2.76),('8975','2013-12-19','11:25:00',2.7),('8975','2013-12-19','11:30:00',2.63),('8975','2013-12-19','11:35:00',2.48),('8975','2013-12-19','11:40:00',2.52),('8975','2013-12-19','11:45:00',2.54),('8975','2013-12-19','11:50:00',2.5),('8975','2013-12-19','11:55:00',2.32),('8975','2013-12-19','12:00:00',2.33),('8975','2013-12-19','12:05:00',2.28),('8975','2013-12-19','12:10:00',2.17),('8975','2013-12-19','12:15:00',2.25),('8975','2013-12-19','12:20:00',2.22),('8975','2013-12-19','12:25:00',2.15),('8975','2013-12-19','12:30:00',2.1),('8975','2013-12-19','12:35:00',2.02),('8975','2013-12-19','12:40:00',2.04),('8975','2013-12-19','12:45:00',1.99),('8975','2013-12-19','12:50:00',1.91),('8975','2013-12-19','12:55:00',1.83),('8975','2013-12-19','13:00:00',1.76),('8975','2013-12-19','13:05:00',1.69),('8975','2013-12-19','13:10:00',1.58),('8975','2013-12-19','13:15:00',1.57),('8975','2013-12-19','13:20:00',1.54),('8975','2013-12-19','13:25:00',1.43),('8975','2013-12-19','13:30:00',1.38),('8975','2013-12-19','13:35:00',1.33),('8975','2013-12-19','13:40:00',1.33),('8975','2013-12-19','13:45:00',1.3),('8975','2013-12-19','13:50:00',1.1),('8975','2013-12-19','13:55:00',1.17),('8975','2013-12-19','14:00:00',1.19),('8975','2013-12-19','14:05:00',1.15),('8975','2013-12-19','14:10:00',1.04),('8975','2013-12-19','14:15:00',1.13),('8975','2013-12-19','14:20:00',1.11),('8975','2013-12-19','14:35:00',1.15),('8975','2013-12-19','14:40:00',1.23),('8975','2013-12-18','08:40:00',1),('8975','2013-12-18','08:45:00',1.27),('8975','2013-12-18','08:50:00',1.67),('8975','2013-12-18','08:55:00',1.82),('8975','2013-12-18','09:00:00',2.01),('8975','2013-12-18','09:05:00',2),('8975','2013-12-18','09:10:00',1.9),('8975','2013-12-18','09:15:00',2.51),('8975','2013-12-18','09:20:00',2.33),('8975','2013-12-18','09:25:00',1.94),('8975','2013-12-18','09:30:00',2.61),('8975','2013-12-18','09:35:00',2.23),('8975','2013-12-18','09:40:00',1.49),('8975','2013-12-18','09:45:00',2.49),('8975','2013-12-18','09:50:00',3.22),('8975','2013-12-18','09:55:00',3.02),('8975','2013-12-18','10:00:00',2.61),('8975','2013-12-18','10:05:00',2.58),('8975','2013-12-18','10:10:00',2.64),('8975','2013-12-18','10:15:00',2.2),('8975','2013-12-18','10:20:00',1.28),('8975','2013-12-18','10:25:00',1.49),('8975','2013-12-18','10:30:00',1.34),('8975','2013-12-18','10:35:00',1.55),('8975','2013-12-18','10:40:00',1.8),('8975','2013-12-18','10:45:00',2.83),('8975','2013-12-18','10:50:00',1.81),('8975','2013-12-18','10:55:00',1.01),('8975','2013-12-18','11:10:00',2.24),('8975','2013-12-18','11:15:00',1.47),('8975','2013-12-18','11:20:00',1.27),('8975','2013-12-18','12:20:00',1.26),('8975','2013-12-18','12:25:00',1.16),('8975','2013-12-18','12:30:00',1.05),('8975','2013-12-18','12:35:00',1.01),('8975','2013-12-18','12:40:00',1.03),('8975','2013-12-18','14:00:00',1.1),('8975','2013-12-18','14:05:00',1.09),('8975','2013-12-18','14:15:00',1.08),('8975','2013-12-18','14:20:00',1.27),('8975','2013-12-18','14:25:00',1.59),('8975','2013-12-18','14:30:00',1.22),('8975','2013-12-18','14:35:00',1.12),('8975','2013-12-18','14:40:00',1.06),('8975','2013-12-17','08:05:00',1),('8975','2013-12-17','08:10:00',1.12),('8975','2013-12-17','08:15:00',1.24),('8975','2013-12-17','08:20:00',1.37),('8975','2013-12-17','08:25:00',1.47),('8975','2013-12-17','08:30:00',1.55),('8975','2013-12-17','08:35:00',1.65),('8975','2013-12-17','08:40:00',1.73),('8975','2013-12-17','08:45:00',1.81),('8975','2013-12-17','08:50:00',1.88),('8975','2013-12-17','08:55:00',1.95),('8975','2013-12-17','09:00:00',2.01),('8975','2013-12-17','09:05:00',2.08),('8975','2013-12-17','09:10:00',2.14),('8975','2013-12-17','09:15:00',2.21),('8975','2013-12-17','09:20:00',2.25),('8975','2013-12-17','09:25:00',2.3),('8975','2013-12-17','09:30:00',2.34),('8975','2013-12-17','09:35:00',2.38),('8975','2013-12-17','09:40:00',2.42),('8975','2013-12-17','09:45:00',2.48),('8975','2013-12-17','09:50:00',2.53),('8975','2013-12-17','09:55:00',2.56),('8975','2013-12-17','10:00:00',2.59),('8975','2013-12-17','10:05:00',2.63),('8975','2013-12-17','10:10:00',2.64),('8975','2013-12-17','10:15:00',2.6),('8975','2013-12-17','10:20:00',2.65),('8975','2013-12-17','10:25:00',2.7),('8975','2013-12-17','10:30:00',2.76),('8975','2013-12-17','10:35:00',2.79),('8975','2013-12-17','10:40:00',2.77),('8975','2013-12-17','10:45:00',2.71),('8975','2013-12-17','10:50:00',2.85),('8975','2013-12-17','10:55:00',2.86),('8975','2013-12-17','11:00:00',2.85),('8975','2013-12-17','11:05:00',2.87),('8975','2013-12-17','11:10:00',2.88),('8975','2013-12-17','11:15:00',2.89),('8975','2013-12-17','11:20:00',2.88),('8975','2013-12-17','11:25:00',2.75),('8975','2013-12-17','11:30:00',2.64),('8975','2013-12-17','11:35:00',2.66),('8975','2013-12-17','11:40:00',2.59),('8975','2013-12-17','11:45:00',2.55),('8975','2013-12-17','11:50:00',2.51),('8975','2013-12-17','11:55:00',2.4),('8975','2013-12-17','12:00:00',2.31),('8975','2013-12-17','12:05:00',2.39),('8975','2013-12-17','12:10:00',2.34),('8975','2013-12-17','12:15:00',2.24),('8975','2013-12-17','12:20:00',2.26),('8975','2013-12-17','12:25:00',2.18),('8975','2013-12-17','12:30:00',2.08),('8975','2013-12-17','12:35:00',2.1),('8975','2013-12-17','12:40:00',2.08),('8975','2013-12-17','12:45:00',1.95),('8975','2013-12-17','12:50:00',1.98),('8975','2013-12-17','12:55:00',1.92),('8975','2013-12-17','13:00:00',1.76),('8975','2013-12-17','13:05:00',1.74),('8975','2013-12-17','13:10:00',1.67),('8975','2013-12-17','13:15:00',1.62),('8975','2013-12-17','13:20:00',1.56),('8975','2013-12-17','13:25:00',1.48),('8975','2013-12-17','13:30:00',1.36),('8975','2013-12-17','13:35:00',1.39),('8975','2013-12-17','13:40:00',1.36),('8975','2013-12-17','13:45:00',1.33),('8975','2013-12-17','13:50:00',1.28),('8975','2013-12-17','13:55:00',1.22),('8975','2013-12-17','14:00:00',1.14),('8975','2013-12-17','14:05:00',1.09),('8975','2013-12-17','14:10:00',1.09),('8975','2013-12-17','14:15:00',1.08),('8975','2013-12-17','14:20:00',1.06),('8975','2013-12-17','14:25:00',1.07),('8975','2013-12-17','14:30:00',1.07),('8975','2013-12-17','14:35:00',1.1),('8975','2013-12-17','14:40:00',1.09),('8975','2013-12-17','14:45:00',1.07),('8975','2013-12-17','14:50:00',1.05),('8975','2013-12-17','14:55:00',1.02),('8975','2014-04-21','07:05:00',1.07),('8975','2014-04-21','07:10:00',1.29),('8975','2014-04-21','07:15:00',1.48),('8975','2014-04-21','07:20:00',1.69),('8975','2014-04-21','07:25:00',1.84),('8975','2014-04-21','07:30:00',2.02),('8975','2014-04-21','07:35:00',2.2),('8975','2014-04-21','07:40:00',2.34),('8975','2014-04-21','07:45:00',2.46),('8975','2014-04-21','07:50:00',2.58),('8975','2014-04-21','07:55:00',2.71),('8975','2014-04-21','08:00:00',2.85),('8975','2014-04-21','08:05:00',2.97),('8975','2014-04-21','08:10:00',3.15),('8975','2014-04-21','08:15:00',3.26),('8975','2014-04-21','08:20:00',3.34),('8975','2014-04-21','08:25:00',3.44),('8975','2014-04-21','08:30:00',3.6),('8975','2014-04-21','08:35:00',3.69),('8975','2014-04-21','08:40:00',3.8),('8975','2014-04-21','08:45:00',3.8),('8975','2014-04-21','08:50:00',3.97),('8975','2014-04-21','08:55:00',3.96),('8975','2014-04-21','09:00:00',4.06),('8975','2014-04-21','09:05:00',4.45),('8975','2014-04-21','09:10:00',4.21),('8975','2014-04-21','09:15:00',4.04),('8975','2014-04-21','09:20:00',4.28),('8975','2014-04-21','09:25:00',4.94),('8975','2014-04-21','09:30:00',4.49),('8975','2014-04-21','09:35:00',4.79),('8975','2014-04-21','09:40:00',4.84),('8975','2014-04-21','09:45:00',5.15),('8975','2014-04-21','09:50:00',3.71),('8975','2014-04-21','09:55:00',2.28),('8975','2014-04-21','10:00:00',2.23),('8975','2014-04-21','10:05:00',2.32),('8975','2014-04-21','10:10:00',3.13),('8975','2014-04-21','10:15:00',4.63),('8975','2014-04-21','10:20:00',4.79),('8975','2014-04-21','10:25:00',3.24),('8975','2014-04-21','10:30:00',6.57),('8975','2014-04-21','10:35:00',6.27),('8975','2014-04-21','10:40:00',6.11),('8975','2014-04-21','10:45:00',5.6),('8975','2014-04-21','10:50:00',6.2),('8975','2014-04-21','10:55:00',3.89),('8975','2014-04-21','11:00:00',4.5),('8975','2014-04-21','11:05:00',3.96),('8975','2014-04-21','11:10:00',2.65),('8975','2014-04-21','11:15:00',2.26),('8975','2014-04-21','11:20:00',1.96),('8975','2014-04-21','11:25:00',2.13),('8975','2014-04-21','11:30:00',1.94),('8975','2014-04-21','11:35:00',1.95),('8975','2014-04-21','11:40:00',1.66),('8975','2014-04-21','11:45:00',1.44),('8975','2014-04-21','11:50:00',1.45),('8975','2014-04-21','11:55:00',1.34),('8975','2014-04-21','12:00:00',1.54),('8975','2014-04-21','12:05:00',1.81),('8975','2014-04-21','12:10:00',1.86),('8975','2014-04-21','12:15:00',1.65),('8975','2014-04-21','12:20:00',2.03),('8975','2014-04-21','12:25:00',1.86),('8975','2014-04-21','12:30:00',2.51),('8975','2014-04-21','12:35:00',1.93),('8975','2014-04-21','12:40:00',1.47),('8975','2014-04-21','12:45:00',1.25),('8975','2014-04-21','12:50:00',1.18),('8975','2014-04-21','13:00:00',1),('8975','2014-04-21','13:05:00',1.03),('8975','2014-04-21','13:10:00',1.24),('8975','2014-04-21','13:15:00',2.38),('8975','2014-04-21','13:20:00',3.48),('8975','2014-04-21','13:25:00',3.9),('8975','2014-04-21','13:30:00',4.22),('8975','2014-04-21','13:35:00',4.17),('8975','2014-04-21','13:40:00',5.1),('8975','2014-04-21','13:45:00',5.26),('8975','2014-04-21','13:50:00',3.7),('8975','2014-04-21','13:55:00',2.46),('8975','2014-04-21','14:00:00',2.17),('8975','2014-04-21','14:05:00',2.72),('8975','2014-04-21','14:10:00',4.8),('8975','2014-04-21','14:15:00',4.36),('8975','2014-04-21','14:20:00',6.07),('8975','2014-04-21','14:25:00',3.65),('8975','2014-04-21','14:30:00',3.7),('8975','2014-04-21','14:35:00',4.61),('8975','2014-04-21','14:40:00',5.35),('8975','2014-04-21','14:45:00',5.54),('8975','2014-04-21','14:50:00',3.77),('8975','2014-04-21','14:55:00',3.04),('8975','2014-04-21','15:00:00',2.01),('8975','2014-04-21','15:05:00',2),('8975','2014-04-21','15:10:00',1.78),('8975','2014-04-21','15:15:00',1.74),('8975','2014-04-21','15:20:00',1.89),('8975','2014-04-21','15:25:00',2.29),('8975','2014-04-21','15:30:00',2.94),('8975','2014-04-21','15:35:00',3.93),('8975','2014-04-21','15:40:00',2.98),('8975','2014-04-21','15:45:00',2.5),('8975','2014-04-21','15:50:00',3.03),('8975','2014-04-21','15:55:00',2.59),('8975','2014-04-21','16:00:00',2.89),('8975','2014-04-21','16:05:00',2.28),('8975','2014-04-21','16:10:00',2.12),('8975','2014-04-21','16:15:00',2.11),('8975','2014-04-21','16:20:00',2.38),('8975','2014-04-21','16:25:00',2.25),('8975','2014-04-21','16:30:00',1.92),('8975','2014-04-21','16:35:00',1.82),('8975','2014-04-21','16:40:00',2.15),('8975','2014-04-21','16:45:00',2.59),('8975','2014-04-21','16:50:00',1.98),('8975','2014-04-21','16:55:00',1.69),('8975','2014-04-21','17:00:00',1.85),('8975','2014-04-21','17:05:00',2.15),('8975','2014-04-21','17:10:00',1.67),('8975','2014-04-21','17:15:00',1.49),('8975','2014-04-21','17:20:00',1.15),('8975','2014-04-21','17:25:00',1),('8975','2014-04-21','17:35:00',1.03),('8975','2014-04-21','17:40:00',1.08),('8975','2014-04-21','17:45:00',1),('8975','2013-12-16','08:05:00',1.12),('8975','2013-12-16','08:10:00',1.23),('8975','2013-12-16','08:15:00',1.35),('8975','2013-12-16','08:20:00',1.47),('8975','2013-12-16','08:25:00',1.57),('8975','2013-12-16','08:30:00',1.67),('8975','2013-12-16','08:35:00',1.77),('8975','2013-12-16','08:40:00',1.86),('8975','2013-12-16','08:45:00',1.93),('8975','2013-12-16','08:50:00',2.02),('8975','2013-12-16','08:55:00',2.07),('8975','2013-12-16','09:00:00',2.13),('8975','2013-12-16','09:05:00',2.2),('8975','2013-12-16','09:10:00',2.24),('8975','2013-12-16','09:15:00',2.32),('8975','2013-12-16','09:20:00',2.38),('8975','2013-12-16','09:25:00',2.42),('8975','2013-12-16','09:30:00',2.44),('8975','2013-12-16','09:35:00',2.49),('8975','2013-12-16','09:40:00',2.55),('8975','2013-12-16','09:45:00',2.59),('8975','2013-12-16','09:50:00',2.64),('8975','2013-12-16','09:55:00',2.67),('8975','2013-12-16','10:00:00',2.68),('8975','2013-12-16','10:05:00',2.73),('8975','2013-12-16','10:10:00',2.74),('8975','2013-12-16','10:15:00',2.69),('8975','2013-12-16','10:20:00',2.76),('8975','2013-12-16','10:25:00',2.77),('8975','2013-12-16','10:30:00',2.81),('8975','2013-12-16','10:35:00',2.85),('8975','2013-12-16','10:40:00',2.83),('8975','2013-12-16','10:45:00',2.8),('8975','2013-12-16','10:50:00',2.92),('8975','2013-12-16','10:55:00',2.94),('8975','2013-12-16','11:00:00',2.92),('8975','2013-12-16','11:05:00',2.91),('8975','2013-12-16','11:10:00',2.92),('8975','2013-12-16','11:15:00',2.92),('8975','2013-12-16','11:20:00',2.91),('8975','2013-12-16','11:25:00',2.76),('8975','2013-12-16','11:30:00',2.76),('8975','2013-12-16','11:35:00',2.72),('8975','2013-12-16','11:40:00',2.63),('8975','2013-12-16','11:45:00',2.55),('8975','2013-12-16','11:50:00',2.55),('8975','2013-12-16','11:55:00',2.46),('8975','2013-12-16','12:00:00',2.46),('8975','2013-12-16','12:05:00',2.46),('8975','2013-12-16','12:10:00',2.43),('8975','2013-12-16','12:15:00',2.38),('8975','2013-12-16','12:20:00',2.36),('8975','2013-12-16','12:25:00',2.26),('8975','2013-12-16','12:30:00',2.2),('8975','2013-12-16','12:35:00',2.2),('8975','2013-12-16','12:40:00',2.16),('8975','2013-12-16','12:45:00',2.03),('8975','2013-12-16','12:50:00',2.07),('8975','2013-12-16','12:55:00',1.97),('8975','2013-12-16','13:00:00',1.8),('8975','2013-12-16','13:05:00',1.8),('8975','2013-12-16','13:10:00',1.73),('8975','2013-12-16','13:15:00',1.7),('8975','2013-12-16','13:20:00',1.62),('8975','2013-12-16','13:25:00',1.52),('8975','2013-12-16','13:30:00',1.43),('8975','2013-12-16','13:35:00',1.41),('8975','2013-12-16','13:40:00',1.37),('8975','2013-12-16','13:45:00',1.33),('8975','2013-12-16','13:50:00',1.3),('8975','2013-12-16','13:55:00',1.23),('8975','2013-12-16','14:00:00',1.17),('8975','2013-12-16','14:05:00',1.13),('8975','2013-12-16','14:10:00',1.11),('8975','2013-12-16','14:15:00',1.08),('8975','2013-12-16','14:20:00',1.08),('8975','2013-12-16','14:25:00',1.07),('8975','2013-12-16','14:30:00',1.07),('8975','2013-12-16','14:35:00',1.12),('8975','2013-12-16','14:40:00',1.1),('8975','2013-12-16','14:45:00',1.08),('8975','2013-12-16','14:50:00',1.07),('8975','2013-12-16','14:55:00',1.04),('8975','2013-12-16','15:00:00',1.02),('8975','2013-12-15','08:05:00',1.11),('8975','2013-12-15','08:10:00',1.22),('8975','2013-12-15','08:15:00',1.34),('8975','2013-12-15','08:20:00',1.46),('8975','2013-12-15','08:25:00',1.57),('8975','2013-12-15','08:30:00',1.67),('8975','2013-12-15','08:35:00',1.76),('8975','2013-12-15','08:40:00',1.84),('8975','2013-12-15','08:45:00',1.91),('8975','2013-12-15','08:50:00',1.97),('8975','2013-12-15','08:55:00',2.04),('8975','2013-12-15','09:00:00',2.11),('8975','2013-12-15','09:05:00',2.17),('8975','2013-12-15','09:10:00',2.22),('8975','2013-12-15','09:15:00',2.27),('8975','2013-12-15','09:20:00',2.31),('8975','2013-12-15','09:25:00',2.35),('8975','2013-12-15','09:30:00',2.38),('8975','2013-12-15','09:35:00',2.43),('8975','2013-12-15','09:40:00',2.49),('8975','2013-12-15','09:45:00',2.53),('8975','2013-12-15','09:50:00',2.55),('8975','2013-12-15','09:55:00',2.58),('8975','2013-12-15','10:00:00',2.6),('8975','2013-12-15','10:05:00',2.64),('8975','2013-12-15','10:10:00',2.66),('8975','2013-12-15','10:15:00',2.59),('8975','2013-12-15','10:20:00',2.68),('8975','2013-12-15','10:25:00',2.71),('8975','2013-12-15','10:30:00',2.74),('8975','2013-12-15','10:35:00',2.81),('8975','2013-12-15','10:40:00',2.76),('8975','2013-12-15','10:45:00',2.77),('8975','2013-12-15','10:50:00',2.88),('8975','2013-12-15','10:55:00',2.88),('8975','2013-12-15','11:00:00',2.89),('8975','2013-12-15','11:05:00',2.88),('8975','2013-12-15','11:10:00',2.9),('8975','2013-12-15','11:15:00',2.89),('8975','2013-12-15','11:20:00',2.87),('8975','2013-12-15','11:25:00',2.7),('8975','2013-12-15','11:30:00',2.75),('8975','2013-12-15','11:35:00',2.75),('8975','2013-12-15','11:40:00',2.67),('8975','2013-12-15','11:45:00',2.61),('8975','2013-12-15','11:50:00',2.59),('8975','2013-12-15','11:55:00',2.4),('8975','2013-12-15','12:00:00',2.39),('8975','2013-12-15','12:05:00',2.47),('8975','2013-12-15','12:10:00',2.43),('8975','2013-12-15','12:15:00',2.37),('8975','2013-12-15','12:20:00',2.34),('8975','2013-12-15','12:25:00',2.23),('8975','2013-12-15','12:30:00',2.18),('8975','2013-12-15','12:35:00',2.18),('8975','2013-12-15','12:40:00',2.14),('8975','2013-12-15','12:45:00',2),('8975','2013-12-15','12:50:00',2.03),('8975','2013-12-15','12:55:00',1.95),('8975','2013-12-15','13:00:00',1.78),('8975','2013-12-15','13:05:00',1.76),('8975','2013-12-15','13:10:00',1.73),('8975','2013-12-15','13:15:00',1.67),('8975','2013-12-15','13:20:00',1.63),('8975','2013-12-15','13:25:00',1.51),('8975','2013-12-15','13:30:00',1.42),('8975','2013-12-15','13:35:00',1.42),('8975','2013-12-15','13:40:00',1.39),('8975','2013-12-15','13:45:00',1.37),('8975','2013-12-15','13:50:00',1.31),('8975','2013-12-15','13:55:00',1.26),('8975','2013-12-15','14:00:00',1.21),('8975','2013-12-15','14:05:00',1.14),('8975','2013-12-15','14:10:00',1.12),('8975','2013-12-15','14:15:00',1.08),('8975','2013-12-15','14:20:00',1.09),('8975','2013-12-15','14:25:00',1.08),('8975','2013-12-15','14:30:00',1.09),('8975','2013-12-15','14:35:00',1.14),('8975','2013-12-15','14:40:00',1.11),('8975','2013-12-15','14:45:00',1.08),('8975','2013-12-15','14:50:00',1.04),('8975','2013-12-15','14:55:00',1),('8975','2013-12-14','09:50:00',1.07),('8975','2013-12-14','09:55:00',1.13),('8975','2013-12-14','10:00:00',1.13),('8975','2013-12-14','10:05:00',1.18),('8975','2013-12-14','10:10:00',1.28),('8975','2013-12-14','10:15:00',1.36),('8975','2013-12-14','10:20:00',1.7),('8975','2013-12-14','10:25:00',1.83),('8975','2013-12-14','10:30:00',1.56),('8975','2013-12-14','10:35:00',1.56),('8975','2013-12-14','10:40:00',1.59),('8975','2013-12-14','10:45:00',1.74),('8975','2013-12-14','10:50:00',1.62),('8975','2013-12-14','10:55:00',1.45),('8975','2013-12-14','11:00:00',1.36),('8975','2013-12-14','11:05:00',1.29),('8975','2013-12-14','11:10:00',1.18),('8975','2013-12-14','11:15:00',1.19),('8975','2013-12-14','11:20:00',1.3),('8975','2013-12-14','11:25:00',1.28),('8975','2013-12-14','11:30:00',1.28),('8975','2013-12-14','11:35:00',1.33),('8975','2013-12-14','11:40:00',1.36),('8975','2013-12-14','11:45:00',1.37),('8975','2013-12-14','11:50:00',1.43),('8975','2013-12-14','11:55:00',1.46),('8975','2013-12-14','12:00:00',1.37),('8975','2013-12-14','12:05:00',1.43),('8975','2013-12-14','12:10:00',1.37),('8975','2013-12-14','12:15:00',1.3),('8975','2013-12-14','12:20:00',1.33),('8975','2013-12-14','12:25:00',1.09),('8975','2013-12-14','12:45:00',1.05),('8975','2013-12-14','12:50:00',1.11),('8975','2013-12-13','08:10:00',1.08),('8975','2013-12-13','08:15:00',1.19),('8975','2013-12-13','08:20:00',1.31),('8975','2013-12-13','08:25:00',1.42),('8975','2013-12-13','08:30:00',1.52),('8975','2013-12-13','08:35:00',1.62),('8975','2013-12-13','08:40:00',1.72),('8975','2013-12-13','08:45:00',1.79),('8975','2013-12-13','08:50:00',1.85),('8975','2013-12-13','08:55:00',1.9),('8975','2013-12-13','09:00:00',1.99),('8975','2013-12-13','09:05:00',2.07),('8975','2013-12-13','09:10:00',2.15),('8975','2013-12-13','09:15:00',2.21),('8975','2013-12-13','09:20:00',2.29),('8975','2013-12-13','09:25:00',2.33),('8975','2013-12-13','09:30:00',2.38),('8975','2013-12-13','09:35:00',2.44),('8975','2013-12-13','09:40:00',2.5),('8975','2013-12-13','09:45:00',2.55),('8975','2013-12-13','09:50:00',2.56),('8975','2013-12-13','09:55:00',2.58),('8975','2013-12-13','10:00:00',2.61),('8975','2013-12-13','10:05:00',2.66),('8975','2013-12-13','10:10:00',2.71),('8975','2013-12-13','10:15:00',2.25),('8975','2013-12-13','10:20:00',2.73),('8975','2013-12-13','10:25:00',2.76),('8975','2013-12-13','10:30:00',2.81),('8975','2013-12-13','10:35:00',2.83),('8975','2013-12-13','10:40:00',2.77),('8975','2013-12-13','10:45:00',2.75),('8975','2013-12-13','10:50:00',2.84),('8975','2013-12-13','10:55:00',2.85),('8975','2013-12-13','11:00:00',2.85),('8975','2013-12-13','11:05:00',2.87),('8975','2013-12-13','11:10:00',2.88),('8975','2013-12-13','11:15:00',2.86),('8975','2013-12-13','11:20:00',2.88),('8975','2013-12-13','11:25:00',2.83),('8975','2013-12-13','11:30:00',2.73),('8975','2013-12-13','11:35:00',2.66),('8975','2013-12-13','11:40:00',2.61),('8975','2013-12-13','11:45:00',2.55),('8975','2013-12-13','11:50:00',2.46),('8975','2013-12-13','11:55:00',2.3),('8975','2013-12-13','12:00:00',2.31),('8975','2013-12-13','12:05:00',2.31),('8975','2013-12-13','12:10:00',2.31),('8975','2013-12-13','12:15:00',2.24),('8975','2013-12-13','12:20:00',2.24),('8975','2013-12-13','12:25:00',2.18),('8975','2013-12-13','12:30:00',2.17),('8975','2013-12-13','12:35:00',2.21),('8975','2013-12-13','12:40:00',2.15),('8975','2013-12-13','12:45:00',2.01),('8975','2013-12-13','12:50:00',2.02),('8975','2013-12-13','12:55:00',1.96),('8975','2013-12-13','13:00:00',1.78),('8975','2013-12-13','13:05:00',1.8),('8975','2013-12-13','13:10:00',1.65),('8975','2013-12-13','13:15:00',1.63),('8975','2013-12-13','13:20:00',1.62),('8975','2013-12-13','13:25:00',1.51),('8975','2013-12-13','13:30:00',1.42),('8975','2013-12-13','13:35:00',1.43),('8975','2013-12-13','13:40:00',1.4),('8975','2013-12-13','13:45:00',1.37),('8975','2013-12-13','13:50:00',1.3),('8975','2013-12-13','13:55:00',1.24),('8975','2013-12-13','14:00:00',1.18),('8975','2013-12-13','14:05:00',1.11),('8975','2013-12-13','14:20:00',1.12),('8975','2013-12-13','14:25:00',1.09),('8975','2013-12-13','14:30:00',1.07),('8975','2013-12-13','14:35:00',1.11),('8975','2013-12-13','14:40:00',1.09),('8975','2013-12-13','14:45:00',1.07),('8975','2013-12-13','14:50:00',1.05),('8975','2013-12-13','14:55:00',1.05),('8975','2013-12-13','15:00:00',1.02),('8975','2013-12-12','08:15:00',1.03),('8975','2013-12-12','08:20:00',1.14),('8975','2013-12-12','08:25:00',1.26),('8975','2013-12-12','08:30:00',1.36),('8975','2013-12-12','08:35:00',1.47),('8975','2013-12-12','08:40:00',1.57),('8975','2013-12-12','08:45:00',1.66),('8975','2013-12-12','08:50:00',1.73),('8975','2013-12-12','08:55:00',1.8),('8975','2013-12-12','09:00:00',1.86),('8975','2013-12-12','09:05:00',1.95),('8975','2013-12-12','09:10:00',2.03),('8975','2013-12-12','09:15:00',2.07),('8975','2013-12-12','09:20:00',2.12),('8975','2013-12-12','09:25:00',2.18),('8975','2013-12-12','09:30:00',2.22),('8975','2013-12-12','09:35:00',2.27),('8975','2013-12-12','09:40:00',2.34),('8975','2013-12-12','09:45:00',2.4),('8975','2013-12-12','09:50:00',2.43),('8975','2013-12-12','09:55:00',2.45),('8975','2013-12-12','10:00:00',2.49),('8975','2013-12-12','10:05:00',2.54),('8975','2013-12-12','10:10:00',2.54),('8975','2013-12-12','10:15:00',2.48),('8975','2013-12-12','10:20:00',2.51),('8975','2013-12-12','10:25:00',2.54),('8975','2013-12-12','10:30:00',2.58),('8975','2013-12-12','10:35:00',2.62),('8975','2013-12-12','10:40:00',2.62),('8975','2013-12-12','10:45:00',2.58),('8975','2013-12-12','10:50:00',2.66),('8975','2013-12-12','10:55:00',2.71),('8975','2013-12-12','11:00:00',2.7),('8975','2013-12-12','11:05:00',2.73),('8975','2013-12-12','11:10:00',2.73),('8975','2013-12-12','11:15:00',2.74),('8975','2013-12-12','11:20:00',2.71),('8975','2013-12-12','11:25:00',2.66),('8975','2013-12-12','11:30:00',2.64),('8975','2013-12-12','11:35:00',2.65),('8975','2013-12-12','11:40:00',2.61),('8975','2013-12-12','11:45:00',2.55),('8975','2013-12-12','11:50:00',2.5),('8975','2013-12-12','11:55:00',2.33),('8975','2013-12-12','12:00:00',2.32),('8975','2013-12-12','12:05:00',2.37),('8975','2013-12-12','12:10:00',2.27),('8975','2013-12-12','12:15:00',2.14),('8975','2013-12-12','12:20:00',2.29),('8975','2013-12-12','12:25:00',2.03),('8975','2013-12-12','12:30:00',1.96),('8975','2013-12-12','12:35:00',2.07),('8975','2013-12-12','12:40:00',2.09),('8975','2013-12-12','12:45:00',2.02),('8975','2013-12-12','12:50:00',2),('8975','2013-12-12','12:55:00',1.88),('8975','2013-12-12','13:00:00',1.79),('8975','2013-12-12','13:05:00',1.77),('8975','2013-12-12','13:10:00',1.71),('8975','2013-12-12','13:15:00',1.64),('8975','2013-12-12','13:20:00',1.64),('8975','2013-12-12','13:25:00',1.48),('8975','2013-12-12','13:30:00',1.42),('8975','2013-12-12','13:35:00',1.41),('8975','2013-12-12','13:40:00',1.4),('8975','2013-12-12','13:45:00',1.41),('8975','2013-12-12','13:50:00',1.35),('8975','2013-12-12','13:55:00',1.3),('8975','2013-12-12','14:00:00',1.22),('8975','2013-12-12','14:05:00',1.17),('8975','2013-12-12','14:10:00',1.04),('8975','2013-12-12','14:20:00',1.13),('8975','2013-12-12','14:25:00',1.12),('8975','2013-12-12','14:30:00',1.13),('8975','2013-12-12','14:35:00',1.17),('8975','2013-12-12','14:40:00',1.09),('8975','2013-12-12','14:45:00',1.04),('8975','2013-12-12','14:50:00',1.02),('8975','2013-12-11','08:10:00',1.06),('8975','2013-12-11','08:15:00',1.16),('8975','2013-12-11','08:20:00',1.3),('8975','2013-12-11','08:25:00',1.42),('8975','2013-12-11','08:30:00',1.51),('8975','2013-12-11','08:35:00',1.61),('8975','2013-12-11','08:40:00',1.7),('8975','2013-12-11','08:45:00',1.79),('8975','2013-12-11','08:50:00',1.88),('8975','2013-12-11','08:55:00',1.96),('8975','2013-12-11','09:00:00',2.02),('8975','2013-12-11','09:05:00',2.09),('8975','2013-12-11','09:10:00',2.15),('8975','2013-12-11','09:15:00',2.21),('8975','2013-12-11','09:20:00',2.26),('8975','2013-12-11','09:25:00',2.32),('8975','2013-12-11','09:30:00',2.35),('8975','2013-12-11','09:35:00',2.42),('8975','2013-12-11','09:40:00',2.5),('8975','2013-12-11','09:45:00',2.53),('8975','2013-12-11','09:50:00',2.57),('8975','2013-12-11','09:55:00',2.58),('8975','2013-12-11','10:00:00',2.61),('8975','2013-12-11','10:05:00',2.65),('8975','2013-12-11','10:10:00',2.66),('8975','2013-12-11','10:15:00',2.61),('8975','2013-12-11','10:20:00',2.72),('8975','2013-12-11','10:25:00',2.75),('8975','2013-12-11','10:30:00',2.8),('8975','2013-12-11','10:35:00',2.82),('8975','2013-12-11','10:40:00',2.78),('8975','2013-12-11','10:45:00',2.78),('8975','2013-12-11','10:50:00',2.84),('8975','2013-12-11','10:55:00',2.83),('8975','2013-12-11','11:00:00',2.85),('8975','2013-12-11','11:05:00',2.85),('8975','2013-12-11','11:10:00',2.84),('8975','2013-12-11','11:15:00',2.81),('8975','2013-12-11','11:20:00',2.78),('8975','2013-12-11','11:25:00',2.78),('8975','2013-12-11','11:30:00',2.75),('8975','2013-12-11','11:35:00',2.7),('8975','2013-12-11','11:40:00',2.62),('8975','2013-12-11','11:45:00',2.55),('8975','2013-12-11','11:50:00',2.5),('8975','2013-12-11','11:55:00',2.32),('8975','2013-12-11','12:00:00',2.31),('8975','2013-12-11','12:05:00',2.39),('8975','2013-12-11','12:10:00',2.37),('8975','2013-12-11','12:15:00',2.33),('8975','2013-12-11','12:20:00',2.3),('8975','2013-12-11','12:25:00',2.23),('8975','2013-12-11','12:30:00',2.13),('8975','2013-12-11','12:35:00',2.15),('8975','2013-12-11','12:40:00',2.08),('8975','2013-12-11','12:45:00',1.98),('8975','2013-12-11','12:50:00',1.96),('8975','2013-12-11','12:55:00',1.85),('8975','2013-12-11','13:00:00',1.71),('8975','2013-12-11','13:05:00',1.73),('8975','2013-12-11','13:10:00',1.62),('8975','2013-12-11','13:15:00',1.65),('8975','2013-12-11','13:20:00',1.59),('8975','2013-12-11','13:25:00',1.49),('8975','2013-12-11','13:30:00',1.39),('8975','2013-12-11','13:35:00',1.41),('8975','2013-12-11','13:40:00',1.38),('8975','2013-12-11','13:45:00',1.36),('8975','2013-12-11','13:50:00',1.29),('8975','2013-12-11','13:55:00',1.25),('8975','2013-12-11','14:00:00',1.2),('8975','2013-12-11','14:05:00',1.14),('8975','2013-12-11','14:10:00',1.05),('8975','2013-12-11','14:20:00',1.1),('8975','2013-12-11','14:25:00',1.08),('8975','2013-12-11','14:30:00',1.09),('8975','2013-12-11','14:35:00',1.11),('8975','2013-12-11','14:40:00',1.1),('8975','2013-12-11','14:45:00',1.07),('8975','2013-12-11','14:50:00',1.04),('8975','2013-12-11','14:55:00',1.01),('8975','2013-12-10','08:10:00',1.1),('8975','2013-12-10','08:15:00',1.09),('8975','2013-12-10','08:20:00',1.31),('8975','2013-12-10','08:25:00',1.44),('8975','2013-12-10','08:30:00',1.53),('8975','2013-12-10','08:35:00',1.65),('8975','2013-12-10','08:40:00',1.75),('8975','2013-12-10','08:45:00',1.8),('8975','2013-12-10','08:50:00',1.88),('8975','2013-12-10','08:55:00',1.91),('8975','2013-12-10','09:00:00',2.02),('8975','2013-12-10','09:05:00',2.12),('8975','2013-12-10','09:10:00',2.19),('8975','2013-12-10','09:15:00',2.23),('8975','2013-12-10','09:20:00',2.3),('8975','2013-12-10','09:25:00',2.37),('8975','2013-12-10','09:30:00',2.42),('8975','2013-12-10','09:35:00',2.48),('8975','2013-12-10','09:40:00',2.54),('8975','2013-12-10','09:45:00',2.59),('8975','2013-12-10','09:50:00',2.63),('8975','2013-12-10','09:55:00',2.62),('8975','2013-12-10','10:00:00',2.67),('8975','2013-12-10','10:05:00',2.68),('8975','2013-12-10','10:10:00',2.69),('8975','2013-12-10','10:15:00',2.67),('8975','2013-12-10','10:20:00',2.78),('8975','2013-12-10','10:25:00',2.8),('8975','2013-12-10','10:30:00',2.85),('8975','2013-12-10','10:35:00',2.84),('8975','2013-12-10','10:40:00',2.8),('8975','2013-12-10','10:45:00',2.84),('8975','2013-12-10','10:50:00',2.85),('8975','2013-12-10','10:55:00',2.86),('8975','2013-12-10','11:00:00',2.9),('8975','2013-12-10','11:05:00',2.89),('8975','2013-12-10','11:10:00',2.96),('8975','2013-12-10','11:15:00',2.94),('8975','2013-12-10','11:20:00',2.92),('8975','2013-12-10','11:25:00',2.84),('8975','2013-12-10','11:30:00',2.81),('8975','2013-12-10','11:35:00',2.74),('8975','2013-12-10','11:40:00',2.69),('8975','2013-12-10','11:45:00',2.64),('8975','2013-12-10','11:50:00',2.56),('8975','2013-12-10','11:55:00',2.47),('8975','2013-12-10','12:00:00',2.46),('8975','2013-12-10','12:05:00',2.42),('8975','2013-12-10','12:10:00',2.4),('8975','2013-12-10','12:15:00',2.37),('8975','2013-12-10','12:20:00',2.33),('8975','2013-12-10','12:25:00',2.25),('8975','2013-12-10','12:30:00',2.23),('8975','2013-12-10','12:35:00',2.2),('8975','2013-12-10','12:40:00',2.19),('8975','2013-12-10','12:45:00',2.09),('8975','2013-12-10','12:50:00',2.05),('8975','2013-12-10','12:55:00',1.93),('8975','2013-12-10','13:00:00',1.89),('8975','2013-12-10','13:05:00',1.82),('8975','2013-12-10','13:10:00',1.76),('8975','2013-12-10','13:15:00',1.69),('8975','2013-12-10','13:20:00',1.65),('8975','2013-12-10','13:25:00',1.53),('8975','2013-12-10','13:30:00',1.47),('8975','2013-12-10','13:35:00',1.42),('8975','2013-12-10','13:40:00',1.38),('8975','2013-12-10','13:45:00',1.36),('8975','2013-12-10','13:50:00',1.29),('8975','2013-12-10','13:55:00',1.24),('8975','2013-12-10','14:00:00',1.2),('8975','2013-12-10','14:05:00',1.15),('8975','2013-12-10','14:10:00',1.05),('8975','2013-12-10','14:20:00',1.1),('8975','2013-12-10','14:25:00',1.1),('8975','2013-12-10','14:30:00',1.1),('8975','2013-12-10','14:35:00',1.13),('8975','2013-12-10','14:40:00',1.1),('8975','2013-12-10','14:45:00',1.06),('8975','2013-12-10','14:50:00',1.06),('8975','2013-12-10','14:55:00',1.03),('8975','2013-12-09','08:05:00',1.11),('8975','2013-12-09','08:10:00',1.22),('8975','2013-12-09','08:15:00',1.34),('8975','2013-12-09','08:20:00',1.47),('8975','2013-12-09','08:25:00',1.58),('8975','2013-12-09','08:30:00',1.66),('8975','2013-12-09','08:35:00',1.75),('8975','2013-12-09','08:40:00',1.81),('8975','2013-12-09','08:45:00',1.89),('8975','2013-12-09','08:50:00',1.96),('8975','2013-12-09','08:55:00',2.04),('8975','2013-12-09','09:00:00',2.12),('8975','2013-12-09','09:05:00',2.19),('8975','2013-12-09','09:10:00',2.26),('8975','2013-12-09','09:15:00',2.32),('8975','2013-12-09','09:20:00',2.36),('8975','2013-12-09','09:25:00',2.39),('8975','2013-12-09','09:30:00',2.43),('8975','2013-12-09','09:35:00',2.47),('8975','2013-12-09','09:40:00',2.58),('8975','2013-12-09','09:45:00',2.61),('8975','2013-12-09','09:50:00',2.63),('8975','2013-12-09','09:55:00',2.66),('8975','2013-12-09','10:00:00',2.71),('8975','2013-12-09','10:05:00',2.75),('8975','2013-12-09','10:10:00',2.7),('8975','2013-12-09','10:15:00',2.71),('8975','2013-12-09','10:20:00',2.81),('8975','2013-12-09','10:25:00',2.87),('8975','2013-12-09','10:30:00',2.92),('8975','2013-12-09','10:35:00',2.92),('8975','2013-12-09','10:40:00',2.89),('8975','2013-12-09','10:45:00',2.93),('8975','2013-12-09','10:50:00',2.94),('8975','2013-12-09','10:55:00',2.97),('8975','2013-12-09','11:00:00',2.97),('8975','2013-12-09','11:05:00',2.98),('8975','2013-12-09','11:10:00',2.97),('8975','2013-12-09','11:15:00',2.96),('8975','2013-12-09','11:20:00',2.94),('8975','2013-12-09','11:25:00',2.89),('8975','2013-12-09','11:30:00',2.88),('8975','2013-12-09','11:35:00',2.69),('8975','2013-12-09','11:40:00',2.75),('8975','2013-12-09','11:45:00',2.71),('8975','2013-12-09','11:50:00',2.57),('8975','2013-12-09','11:55:00',2.43),('8975','2013-12-09','12:00:00',2.53),('8975','2013-12-09','12:05:00',2.54),('8975','2013-12-09','12:10:00',2.48),('8975','2013-12-09','12:15:00',2.44),('8975','2013-12-09','12:20:00',2.39),('8975','2013-12-09','12:25:00',2.26),('8975','2013-12-09','12:30:00',2.22),('8975','2013-12-09','12:35:00',2.19),('8975','2013-12-09','12:40:00',2.16),('8975','2013-12-09','12:45:00',2.08),('8975','2013-12-09','12:50:00',2.05),('8975','2013-12-09','12:55:00',1.91),('8975','2013-12-09','13:00:00',1.88),('8975','2013-12-09','13:05:00',1.74),('8975','2013-12-09','13:10:00',1.68),('8975','2013-12-09','13:15:00',1.65),('8975','2013-12-09','13:20:00',1.6),('8975','2013-12-09','13:25:00',1.43),('8975','2013-12-09','13:30:00',1.47),('8975','2013-12-09','13:35:00',1.42),('8975','2013-12-09','13:40:00',1.36),('8975','2013-12-09','13:45:00',1.37),('8975','2013-12-09','13:50:00',1.3),('8975','2013-12-09','13:55:00',1.26),('8975','2013-12-09','14:00:00',1.21),('8975','2013-12-09','14:05:00',1.17),('8975','2013-12-09','14:10:00',1.09),('8975','2013-12-09','14:15:00',1.04),('8975','2013-12-09','14:20:00',1.1),('8975','2013-12-09','14:25:00',1.09),('8975','2013-12-09','14:30:00',1.1),('8975','2013-12-09','14:35:00',1.15),('8975','2013-12-09','14:40:00',1.12),('8975','2013-12-09','14:45:00',1.08),('8975','2013-12-09','14:50:00',1.07),('8975','2013-12-09','14:55:00',1.05),('8975','2013-12-09','15:00:00',1.02),('8975','2013-12-09','15:05:00',1),('8975','2013-12-08','09:30:00',1.58),('8975','2013-12-08','09:35:00',2.45),('8975','2013-12-08','09:40:00',2.52),('8975','2013-12-08','09:45:00',2.57),('8975','2013-12-08','09:50:00',2.59),('8975','2013-12-08','09:55:00',2.65),('8975','2013-12-08','10:00:00',2.74),('8975','2013-12-08','10:05:00',2.84),('8975','2013-12-08','10:10:00',3.13),('8975','2013-12-08','10:15:00',3.5),('8975','2013-12-08','10:20:00',3.82),('8975','2013-12-08','10:25:00',2.73),('8975','2013-12-08','10:30:00',1.27),('8975','2013-12-08','10:35:00',1.09),('8975','2013-12-08','12:00:00',1.07),('8975','2013-12-08','12:05:00',1.04),('8975','2013-12-08','12:10:00',1.06),('8975','2013-12-08','12:15:00',1.09),('8975','2013-12-08','12:20:00',1.23),('8975','2013-12-08','12:25:00',1.65),('8975','2013-12-08','12:30:00',1.85),('8975','2013-12-08','12:35:00',1.39),('8975','2013-12-08','12:40:00',1.53),('8975','2013-12-08','12:45:00',1.89),('8975','2013-12-08','12:50:00',1.7),('8975','2013-12-08','12:55:00',2.06),('8975','2013-12-08','13:00:00',1.39),('8975','2013-12-08','13:05:00',1.4),('8975','2013-12-08','13:10:00',1.37),('8975','2013-12-08','13:15:00',1.92),('8975','2013-12-08','13:20:00',2.11),('8975','2013-12-08','13:25:00',1.81),('8975','2013-12-08','13:30:00',1.11),('8975','2013-12-08','13:40:00',1.01),('8975','2013-12-08','13:45:00',1.21),('8975','2013-12-08','13:50:00',1.45),('8975','2013-12-08','13:55:00',1.54),('8975','2013-12-08','14:00:00',1.38),('8975','2013-12-08','14:05:00',1.08),('8975','2013-12-07','09:15:00',1),('8975','2013-12-07','09:20:00',1.03),('8975','2013-12-07','09:25:00',1.02),('8975','2013-12-07','09:30:00',1.1),('8975','2013-12-07','09:35:00',1.28),('8975','2013-12-07','09:40:00',1.35),('8975','2013-12-07','09:45:00',1.41),('8975','2013-12-07','09:50:00',1.7),('8975','2013-12-07','09:55:00',1.59),('8975','2013-12-07','10:00:00',1.55),('8975','2013-12-07','10:05:00',1.57),('8975','2013-12-07','10:10:00',1.56),('8975','2013-12-07','10:15:00',1.6),('8975','2013-12-07','10:20:00',1.52),('8975','2013-12-07','10:25:00',1.58),('8975','2013-12-07','10:30:00',1.61),('8975','2013-12-07','10:35:00',1.78),('8975','2013-12-07','10:40:00',2.03),('8975','2013-12-07','10:45:00',1.95),('8975','2013-12-07','10:50:00',1.9),('8975','2013-12-07','10:55:00',2.35),('8975','2013-12-07','11:00:00',2.05),('8975','2013-12-07','11:05:00',2.1),('8975','2013-12-07','11:10:00',2.35),('8975','2013-12-07','11:15:00',3.25),('8975','2013-12-07','11:20:00',2.62),('8975','2013-12-07','11:25:00',1.78),('8975','2013-12-07','11:30:00',1.36),('8975','2013-12-07','11:35:00',1.2),('8975','2013-12-07','11:40:00',1.19),('8975','2013-12-07','11:45:00',1.17),('8975','2013-12-07','11:50:00',1.14),('8975','2013-12-07','11:55:00',1.11),('8975','2013-12-07','12:00:00',1.12),('8975','2013-12-07','12:05:00',1.08),('8975','2013-12-07','12:55:00',1.26),('8975','2013-12-07','13:00:00',1.39),('8975','2013-12-07','13:05:00',1.41),('8975','2013-12-07','13:10:00',1.31),('8975','2013-12-07','13:15:00',1.32),('8975','2013-12-07','13:20:00',1.15),('8975','2013-12-07','13:25:00',1.07),('8975','2013-12-07','15:25:00',1.04),('8975','2013-12-07','15:30:00',1.07),('8975','2014-04-20','08:25:00',1.01),('8975','2014-04-20','08:30:00',1.31),('8975','2014-04-20','08:35:00',1.31),('8975','2014-04-20','08:40:00',1.37),('8975','2014-04-20','08:45:00',1.3),('8975','2014-04-20','08:50:00',1.27),('8975','2014-04-20','08:55:00',1.24),('8975','2014-04-20','09:00:00',1.4),('8975','2014-04-20','09:05:00',1.45),('8975','2014-04-20','09:10:00',1.51),('8975','2014-04-20','09:15:00',1.53),('8975','2014-04-20','09:20:00',2.18),('8975','2014-04-20','09:25:00',1.44),('8975','2014-04-20','09:40:00',1.15),('8975','2014-04-20','09:45:00',1.34),('8975','2014-04-20','09:50:00',1.55),('8975','2014-04-20','09:55:00',1.93),('8975','2014-04-20','10:00:00',4.03),('8975','2014-04-20','10:05:00',6.35),('8975','2014-04-20','10:10:00',6.41),('8975','2014-04-20','10:15:00',5.69),('8975','2014-04-20','10:20:00',5.64),('8975','2014-04-20','10:25:00',5.66),('8975','2014-04-20','10:30:00',5.66),('8975','2014-04-20','10:35:00',5.65),('8975','2014-04-20','10:40:00',5.71),('8975','2014-04-20','10:45:00',5.77),('8975','2014-04-20','10:50:00',5.83),('8975','2014-04-20','10:55:00',5.86),('8975','2014-04-20','11:00:00',5.91),('8975','2014-04-20','11:05:00',5.94),('8975','2014-04-20','11:10:00',5.92),('8975','2014-04-20','11:15:00',6.01),('8975','2014-04-20','11:20:00',6.04),('8975','2014-04-20','11:25:00',6.05),('8975','2014-04-20','11:30:00',6.1),('8975','2014-04-20','11:35:00',6.11),('8975','2014-04-20','11:40:00',6.19),('8975','2014-04-20','11:45:00',6.2),('8975','2014-04-20','11:50:00',6.22),('8975','2014-04-20','11:55:00',6.21),('8975','2014-04-20','12:00:00',6.26),('8975','2014-04-20','12:05:00',6.29),('8975','2014-04-20','12:10:00',6.31),('8975','2014-04-20','12:15:00',6.32),('8975','2014-04-20','12:20:00',6.34),('8975','2014-04-20','12:25:00',6.34),('8975','2014-04-20','12:30:00',6.36),('8975','2014-04-20','12:35:00',6.34),('8975','2014-04-20','12:40:00',6.34),('8975','2014-04-20','12:45:00',6.32),('8975','2014-04-20','12:50:00',6.31),('8975','2014-04-20','12:55:00',6.28),('8975','2014-04-20','13:00:00',6.25),('8975','2014-04-20','13:05:00',6.25),('8975','2014-04-20','13:10:00',6.21),('8975','2014-04-20','13:15:00',6.19),('8975','2014-04-20','13:20:00',6.18),('8975','2014-04-20','13:25:00',6.12),('8975','2014-04-20','13:30:00',6.08),('8975','2014-04-20','13:35:00',6.07),('8975','2014-04-20','13:40:00',6.04),('8975','2014-04-20','13:45:00',6.01),('8975','2014-04-20','13:50:00',5.99),('8975','2014-04-20','13:55:00',5.96),('8975','2014-04-20','14:00:00',5.91),('8975','2014-04-20','14:05:00',5.85),('8975','2014-04-20','14:10:00',5.8),('8975','2014-04-20','14:15:00',5.72),('8975','2014-04-20','14:20:00',5.66),('8975','2014-04-20','14:25:00',5.59),('8975','2014-04-20','14:30:00',5.53),('8975','2014-04-20','14:35:00',5.48),('8975','2014-04-20','14:40:00',5.33),('8975','2014-04-20','14:45:00',5.28),('8975','2014-04-20','14:50:00',5.21),('8975','2014-04-20','14:55:00',5.12),('8975','2014-04-20','15:00:00',5.02),('8975','2014-04-20','15:05:00',4.93),('8975','2014-04-20','15:10:00',4.81),('8975','2014-04-20','15:15:00',4.73),('8975','2014-04-20','15:20:00',4.64),('8975','2014-04-20','15:25:00',4.54),('8975','2014-04-20','15:30:00',4.43),('8975','2014-04-20','15:35:00',4.22),('8975','2014-04-20','15:40:00',4.18),('8975','2014-04-20','15:45:00',4.1),('8975','2014-04-20','15:50:00',3.99),('8975','2014-04-20','15:55:00',3.9),('8975','2014-04-20','16:00:00',3.8),('8975','2014-04-20','16:05:00',3.7),('8975','2014-04-20','16:10:00',3.6),('8975','2014-04-20','16:15:00',3.71),('8975','2014-04-20','16:20:00',3.42),('8975','2014-04-20','16:25:00',3.24),('8975','2014-04-20','16:30:00',3.15),('8975','2014-04-20','16:35:00',3.03),('8975','2014-04-20','16:40:00',2.91),('8975','2014-04-20','16:45:00',2.81),('8975','2014-04-20','16:50:00',2.65),('8975','2014-04-20','16:55:00',2.26),('8975','2014-04-20','17:00:00',1.91),('8975','2014-04-20','17:05:00',1.76),('8975','2014-04-20','17:10:00',2.16),('8975','2014-04-20','17:15:00',1.93),('8975','2014-04-20','17:20:00',1.97),('8975','2014-04-20','17:25:00',1.79),('8975','2014-04-20','17:30:00',1.8),('8975','2014-04-20','17:35:00',1.44),('8975','2014-04-20','17:40:00',1.64),('8975','2014-04-20','17:45:00',1.48),('8975','2014-04-20','17:50:00',1.28),('8975','2014-04-20','17:55:00',1.34),('8975','2014-04-20','18:00:00',1.44),('8975','2014-04-20','18:05:00',1.31),('8975','2014-04-20','18:10:00',1.35),('8975','2014-04-20','18:15:00',1.3),('8975','2014-04-20','18:20:00',1.25),('8975','2014-04-20','18:25:00',1.2),('8975','2014-04-20','18:30:00',1.13),('8975','2014-04-20','18:35:00',1.06),('8975','2014-04-20','18:40:00',1),('8975','2013-12-06','08:00:00',1.08),('8975','2013-12-06','08:05:00',1.2),('8975','2013-12-06','08:10:00',1.31),('8975','2013-12-06','08:15:00',1.42),('8975','2013-12-06','08:20:00',1.54),('8975','2013-12-06','08:25:00',1.64),('8975','2013-12-06','08:30:00',1.74),('8975','2013-12-06','08:35:00',1.84),('8975','2013-12-06','08:40:00',1.89),('8975','2013-12-06','08:45:00',1.96),('8975','2013-12-06','08:50:00',2),('8975','2013-12-06','08:55:00',2.08),('8975','2013-12-06','09:00:00',2.17),('8975','2013-12-06','09:05:00',2.24),('8975','2013-12-06','09:10:00',2.31),('8975','2013-12-06','09:15:00',2.38),('8975','2013-12-06','09:20:00',2.41),('8975','2013-12-06','09:25:00',2.45),('8975','2013-12-06','09:30:00',2.49),('8975','2013-12-06','09:35:00',2.53),('8975','2013-12-06','09:40:00',2.59),('8975','2013-12-06','09:45:00',2.62),('8975','2013-12-06','09:50:00',2.65),('8975','2013-12-06','09:55:00',2.66),('8975','2013-12-06','10:00:00',2.69),('8975','2013-12-06','10:05:00',2.72),('8975','2013-12-06','10:10:00',2.71),('8975','2013-12-06','10:15:00',2.76),('8975','2013-12-06','10:20:00',2.8),('8975','2013-12-06','10:25:00',2.82),('8975','2013-12-06','10:30:00',2.86),('8975','2013-12-06','10:35:00',2.9),('8975','2013-12-06','10:40:00',2.87),('8975','2013-12-06','10:45:00',2.92),('8975','2013-12-06','10:50:00',2.95),('8975','2013-12-06','10:55:00',2.93),('8975','2013-12-06','11:00:00',2.94),('8975','2013-12-06','11:05:00',2.93),('8975','2013-12-06','11:10:00',2.92),('8975','2013-12-06','11:15:00',2.9),('8975','2013-12-06','11:20:00',2.84),('8975','2013-12-06','11:25:00',2.73),('8975','2013-12-06','11:30:00',2.78),('8975','2013-12-06','11:35:00',2.62),('8975','2013-12-06','11:40:00',2.52),('8975','2013-12-06','11:45:00',2.61),('8975','2013-12-06','11:50:00',2.45),('8975','2013-12-06','11:55:00',2.42),('8975','2013-12-06','12:00:00',2.48),('8975','2013-12-06','12:05:00',2.42),('8975','2013-12-06','12:10:00',2.39),('8975','2013-12-06','12:15:00',2.39),('8975','2013-12-06','12:20:00',2.31),('8975','2013-12-06','12:25:00',2.22),('8975','2013-12-06','12:30:00',2.2),('8975','2013-12-06','12:35:00',2.17),('8975','2013-12-06','12:40:00',2.14),('8975','2013-12-06','12:45:00',2.1),('8975','2013-12-06','12:50:00',2.02),('8975','2013-12-06','12:55:00',1.93),('8975','2013-12-06','13:00:00',1.9),('8975','2013-12-06','13:05:00',1.78),('8975','2013-12-06','13:10:00',1.74),('8975','2013-12-06','13:15:00',1.73),('8975','2013-12-06','13:20:00',1.62),('8975','2013-12-06','13:25:00',1.53),('8975','2013-12-06','13:30:00',1.53),('8975','2013-12-06','13:35:00',1.48),('8975','2013-12-06','13:40:00',1.43),('8975','2013-12-06','13:45:00',1.41),('8975','2013-12-06','13:50:00',1.33),('8975','2013-12-06','13:55:00',1.28),('8975','2013-12-06','14:00:00',1.24),('8975','2013-12-06','14:05:00',1.24),('8975','2013-12-06','14:10:00',1.2),('8975','2013-12-06','14:15:00',1.12),('8975','2013-12-06','14:30:00',1.13),('8975','2013-12-06','14:35:00',1.14),('8975','2013-12-06','14:40:00',1.11),('8975','2013-12-06','14:45:00',1.11),('8975','2013-12-06','14:50:00',1.06),('8975','2013-12-06','14:55:00',1.03),('8975','2013-12-06','15:00:00',1.01),('8975','2013-12-05','09:45:00',1.08),('8975','2013-12-05','09:50:00',1.04),('8975','2013-12-05','09:55:00',1.04),('8975','2013-12-05','10:00:00',1.14),('8975','2013-12-05','10:05:00',1.38),('8975','2013-12-05','10:10:00',1.53),('8975','2013-12-05','10:15:00',1.73),('8975','2013-12-05','10:20:00',1.41),('8975','2013-12-05','10:25:00',1.23),('8975','2013-12-05','10:30:00',1.09),('8975','2013-12-05','10:50:00',1.09),('8975','2013-12-05','10:55:00',1.11),('8975','2013-12-05','11:00:00',1.32),('8975','2013-12-05','11:05:00',1.4),('8975','2013-12-05','11:10:00',1.35),('8975','2013-12-05','11:15:00',1.3),('8975','2013-12-05','11:20:00',1.37),('8975','2013-12-05','11:25:00',1.47),('8975','2013-12-05','11:30:00',1.49),('8975','2013-12-05','11:35:00',1.71),('8975','2013-12-05','11:40:00',1.95),('8975','2013-12-05','11:45:00',2.16),('8975','2013-12-05','11:50:00',2.36),('8975','2013-12-05','11:55:00',2.29),('8975','2013-12-05','12:00:00',2.42),('8975','2013-12-05','12:05:00',2.2),('8975','2013-12-05','12:10:00',2.06),('8975','2013-12-05','12:15:00',2.32),('8975','2013-12-05','12:20:00',2.19),('8975','2013-12-05','12:25:00',2.07),('8975','2013-12-05','12:30:00',1.78),('8975','2013-12-05','12:35:00',1.76),('8975','2013-12-05','12:40:00',2.47),('8975','2013-12-05','12:45:00',2.48),('8975','2013-12-05','12:50:00',1.57),('8975','2013-12-05','12:55:00',1.34),('8975','2013-12-05','13:00:00',1.3),('8975','2013-12-05','13:05:00',1.19),('8975','2013-12-05','13:10:00',1.07),('8975','2013-12-05','13:25:00',1.11),('8975','2013-12-05','13:30:00',1.23),('8975','2013-12-05','13:35:00',1.31),('8975','2013-12-05','13:40:00',1.42),('8975','2013-12-05','13:45:00',1.39),('8975','2013-12-05','13:50:00',1.38),('8975','2013-12-05','13:55:00',1.27),('8975','2013-12-05','14:00:00',1.15),('8975','2013-12-05','14:05:00',1.05),('8975','2013-12-05','14:10:00',1.07),('8975','2013-12-05','14:15:00',1.04),('8975','2013-12-05','14:20:00',1.01),('8975','2013-12-05','14:25:00',1.12),('8975','2013-12-05','14:30:00',1.05),('8975','2013-12-05','14:35:00',1.04),('8975','2013-12-05','14:40:00',1.05),('8975','2013-12-05','14:45:00',1.06),('8975','2013-12-04','08:00:00',1.13),('8975','2013-12-04','08:05:00',1.26),('8975','2013-12-04','08:10:00',1.36),('8975','2013-12-04','08:15:00',1.48),('8975','2013-12-04','08:20:00',1.59),('8975','2013-12-04','08:25:00',1.68),('8975','2013-12-04','08:30:00',1.78),('8975','2013-12-04','08:35:00',1.88),('8975','2013-12-04','08:40:00',1.97),('8975','2013-12-04','08:45:00',2.05),('8975','2013-12-04','08:50:00',2.13),('8975','2013-12-04','08:55:00',2.21),('8975','2013-12-04','09:00:00',2.27),('8975','2013-12-04','09:05:00',2.32),('8975','2013-12-04','09:10:00',2.4),('8975','2013-12-04','09:15:00',2.44),('8975','2013-12-04','09:20:00',2.5),('8975','2013-12-04','09:25:00',2.56),('8975','2013-12-04','09:30:00',2.61),('8975','2013-12-04','09:35:00',2.65),('8975','2013-12-04','09:40:00',2.69),('8975','2013-12-04','09:45:00',2.71),('8975','2013-12-04','09:50:00',2.73),('8975','2013-12-04','09:55:00',2.8),('8975','2013-12-04','10:00:00',2.83),('8975','2013-12-04','10:05:00',2.87),('8975','2013-12-04','10:10:00',2.85),('8975','2013-12-04','10:15:00',2.9),('8975','2013-12-04','10:20:00',2.92),('8975','2013-12-04','10:25:00',3.01),('8975','2013-12-04','10:30:00',3),('8975','2013-12-04','10:35:00',3.05),('8975','2013-12-04','10:40:00',3.02),('8975','2013-12-04','10:45:00',3.04),('8975','2013-12-04','10:50:00',3.04),('8975','2013-12-04','10:55:00',3.03),('8975','2013-12-04','11:00:00',3.03),('8975','2013-12-04','11:05:00',3.05),('8975','2013-12-04','11:10:00',3),('8975','2013-12-04','11:15:00',3.07),('8975','2013-12-04','11:20:00',2.97),('8975','2013-12-04','11:25:00',2.98),('8975','2013-12-04','11:30:00',2.91),('8975','2013-12-04','11:35:00',2.76),('8975','2013-12-04','11:40:00',2.72),('8975','2013-12-04','11:45:00',2.64),('8975','2013-12-04','11:50:00',2.63),('8975','2013-12-04','11:55:00',2.56),('8975','2013-12-04','12:00:00',2.59),('8975','2013-12-04','12:05:00',2.53),('8975','2013-12-04','12:10:00',2.51),('8975','2013-12-04','12:15:00',2.49),('8975','2013-12-04','12:20:00',2.42),('8975','2013-12-04','12:25:00',2.31),('8975','2013-12-04','12:30:00',2.22),('8975','2013-12-04','12:35:00',1.31),('8975','2013-12-04','12:40:00',1.51),('8975','2013-12-04','12:45:00',1.91),('8975','2013-12-04','12:50:00',1.89),('8975','2013-12-04','12:55:00',2.04),('8975','2013-12-04','13:00:00',1.19),('8975','2013-12-04','13:05:00',1.07),('8975','2013-12-04','13:10:00',1.4),('8975','2013-12-04','13:25:00',1.34),('8975','2013-12-04','13:30:00',1.63),('8975','2013-12-04','13:35:00',1.53),('8975','2013-12-04','13:40:00',1.34),('8975','2013-12-04','13:45:00',1.45),('8975','2013-12-04','13:50:00',1.41),('8975','2013-12-04','13:55:00',1.33),('8975','2013-12-04','14:00:00',1.3),('8975','2013-12-04','14:05:00',1.27),('8975','2013-12-04','14:10:00',1.23),('8975','2013-12-04','14:15:00',1.21),('8975','2013-12-04','14:20:00',1.11),('8975','2013-12-04','14:25:00',1.06),('8975','2013-12-04','14:30:00',1.16),('8975','2013-12-04','14:35:00',1.13),('8975','2013-12-04','14:40:00',1.14),('8975','2013-12-04','14:45:00',1.13),('8975','2013-12-04','14:50:00',1.1),('8975','2013-12-04','14:55:00',1.07),('8975','2013-12-04','15:00:00',1.03),('8975','2013-12-03','08:00:00',1.39),('8975','2013-12-03','08:05:00',1.5),('8975','2013-12-03','08:10:00',1.59),('8975','2013-12-03','08:15:00',1.69),('8975','2013-12-03','08:20:00',1.8),('8975','2013-12-03','08:25:00',1.89),('8975','2013-12-03','08:30:00',1.98),('8975','2013-12-03','08:35:00',2.06),('8975','2013-12-03','08:40:00',2.14),('8975','2013-12-03','08:45:00',2.21),('8975','2013-12-03','08:50:00',2.27),('8975','2013-12-03','08:55:00',2.34),('8975','2013-12-03','09:00:00',2.4),('8975','2013-12-03','09:05:00',2.46),('8975','2013-12-03','09:10:00',2.52),('8975','2013-12-03','09:15:00',2.58),('8975','2013-12-03','09:20:00',2.63),('8975','2013-12-03','09:25:00',2.71),('8975','2013-12-03','09:30:00',2.77),('8975','2013-12-03','09:35:00',2.8),('8975','2013-12-03','09:40:00',2.82),('8975','2013-12-03','09:45:00',2.84),('8975','2013-12-03','09:50:00',2.87),('8975','2013-12-03','09:55:00',2.9),('8975','2013-12-03','10:00:00',2.92),('8975','2013-12-03','10:05:00',2.97),('8975','2013-12-03','10:10:00',3),('8975','2013-12-03','10:15:00',3.05),('8975','2013-12-03','10:20:00',3.11),('8975','2013-12-03','10:25:00',3.14),('8975','2013-12-03','10:30:00',3.14),('8975','2013-12-03','10:35:00',3.15),('8975','2013-12-03','10:40:00',3.16),('8975','2013-12-03','10:45:00',3.2),('8975','2013-12-03','10:50:00',3.18),('8975','2013-12-03','10:55:00',3.16),('8975','2013-12-03','11:00:00',3.17),('8975','2013-12-03','11:05:00',3.19),('8975','2013-12-03','11:10:00',3.18),('8975','2013-12-03','11:15:00',3.17),('8975','2013-12-03','11:20:00',3.1),('8975','2013-12-03','11:25:00',3.11),('8975','2013-12-03','11:30:00',3.03),('8975','2013-12-03','11:35:00',2.88),('8975','2013-12-03','11:40:00',2.96),('8975','2013-12-03','11:45:00',2.9),('8975','2013-12-03','11:50:00',2.79),('8975','2013-12-03','11:55:00',2.81),('8975','2013-12-03','12:00:00',2.75),('8975','2013-12-03','12:05:00',2.68),('8975','2013-12-03','12:10:00',2.69),('8975','2013-12-03','12:15:00',2.66),('8975','2013-12-03','12:20:00',2.54),('8975','2013-12-03','12:25:00',2.51),('8975','2013-12-03','12:30:00',2.41),('8975','2013-12-03','12:35:00',2.45),('8975','2013-12-03','12:40:00',2.43),('8975','2013-12-03','12:45:00',2.32),('8975','2013-12-03','12:50:00',2.21),('8975','2013-12-03','12:55:00',2.19),('8975','2013-12-03','13:00:00',2.13),('8975','2013-12-03','13:05:00',2.06),('8975','2013-12-03','13:10:00',1.99),('8975','2013-12-03','13:15:00',1.92),('8975','2013-12-03','13:20:00',1.82),('8975','2013-12-03','13:25:00',1.72),('8975','2013-12-03','13:30:00',1.7),('8975','2013-12-03','13:35:00',1.65),('8975','2013-12-03','13:40:00',1.6),('8975','2013-12-03','13:45:00',1.56),('8975','2013-12-03','13:50:00',1.49),('8975','2013-12-03','13:55:00',1.46),('8975','2013-12-03','14:00:00',1.4),('8975','2013-12-03','14:05:00',1.32),('8975','2013-12-03','14:10:00',1.24),('8975','2013-12-03','14:15:00',1.18),('8975','2013-12-03','14:20:00',1.11),('8975','2013-12-03','14:25:00',1.14),('8975','2013-12-03','14:30:00',1.17),('8975','2013-12-03','14:35:00',1.2),('8975','2013-12-03','14:40:00',1.19),('8975','2013-12-03','14:45:00',1.17),('8975','2013-12-03','14:50:00',1.14),('8975','2013-12-03','14:55:00',1.11),('8975','2013-12-03','15:00:00',1.08),('8975','2013-12-03','15:05:00',1.05),('8975','2013-12-03','15:10:00',1.01),('8975','2013-12-02','09:25:00',1.33),('8975','2013-12-02','09:30:00',1.36),('8975','2013-12-02','09:35:00',1.36),('8975','2013-12-02','09:45:00',1.61),('8975','2013-12-02','09:50:00',1.7),('8975','2013-12-02','09:55:00',1.77),('8975','2013-12-02','10:00:00',2),('8975','2013-12-02','10:05:00',2.1),('8975','2013-12-02','10:10:00',2.11),('8975','2013-12-02','10:15:00',2.15),('8975','2013-12-02','10:20:00',2.2),('8975','2013-12-02','10:25:00',2.23),('8975','2013-12-02','10:30:00',2.27),('8975','2013-12-02','10:35:00',2.3),('8975','2013-12-02','10:40:00',2.31),('8975','2013-12-02','10:45:00',2.33),('8975','2013-12-02','10:50:00',2.35),('8975','2013-12-02','10:55:00',2.37),('8975','2013-12-02','11:00:00',2.38),('8975','2013-12-02','11:05:00',2.4),('8975','2013-12-02','11:10:00',2.42),('8975','2013-12-02','11:15:00',2.43),('8975','2013-12-02','11:20:00',2.36),('8975','2013-12-02','11:25:00',2.34),('8975','2013-12-02','11:30:00',2.27),('8975','2013-12-02','11:35:00',2.27),('8975','2013-12-02','11:40:00',2.26),('8975','2013-12-02','11:45:00',2.2),('8975','2013-12-02','11:50:00',2.21),('8975','2013-12-02','11:55:00',2.18),('8975','2013-12-02','12:00:00',2.15),('8975','2013-12-02','12:05:00',2.13),('8975','2013-12-02','12:10:00',2.16),('8975','2013-12-02','12:15:00',2.16),('8975','2013-12-02','12:20:00',2.13),('8975','2013-12-02','12:25:00',2.1),('8975','2013-12-02','12:30:00',2.08),('8975','2013-12-02','12:35:00',2.17),('8975','2013-12-02','12:40:00',2.21),('8975','2013-12-02','12:45:00',2.24),('8975','2013-12-02','12:50:00',2.31),('8975','2013-12-02','12:55:00',2.29),('8975','2013-12-02','13:00:00',2.21),('8975','2013-12-02','13:05:00',2.26),('8975','2013-12-02','13:10:00',2.22),('8975','2013-12-02','13:15:00',2.16),('8975','2013-12-02','13:20:00',2.13),('8975','2013-12-02','13:25:00',2.03),('8975','2013-12-02','13:30:00',1.94),('8975','2013-12-02','13:35:00',1.89),('8975','2013-12-02','13:40:00',1.73),('8975','2013-12-02','13:45:00',1.58),('8975','2013-12-02','13:50:00',1.51),('8975','2013-12-02','13:55:00',1.46),('8975','2013-12-02','14:00:00',1.37),('8975','2013-12-02','14:05:00',1.26),('8975','2013-12-02','14:10:00',1.2),('8975','2013-12-02','14:15:00',1.14),('8975','2013-12-02','14:20:00',1.08),('8975','2013-12-02','14:30:00',1.02),('8975','2013-12-02','14:35:00',1.13),('8975','2013-12-02','14:40:00',1.11),('8975','2013-12-02','14:45:00',1.09),('8975','2013-12-02','14:50:00',1.05),('8975','2013-12-02','14:55:00',1.03),('8975','2013-12-01','13:45:00',1.04),('8975','2013-12-01','13:50:00',1.08),('8975','2013-12-01','13:55:00',1.14),('8975','2013-12-01','14:00:00',1.13),('8975','2013-12-01','14:05:00',1.04),('8975','2013-11-30','11:25:00',1.28),('8975','2013-11-30','11:30:00',1.61),('8975','2013-11-30','11:35:00',1.87),('8975','2013-11-30','11:40:00',1.64),('8975','2013-11-30','11:45:00',1.27),('8975','2013-11-30','11:50:00',1.37),('8975','2013-11-30','11:55:00',1.86),('8975','2013-11-30','12:00:00',1.57),('8975','2013-11-30','12:05:00',1.92),('8975','2013-11-30','12:10:00',2.12),('8975','2013-11-30','12:15:00',1.54),('8975','2013-11-30','12:45:00',1.32),('8975','2013-11-30','12:50:00',1.14),('8975','2013-11-30','12:55:00',1.11),('8975','2013-11-30','13:00:00',1.12),('8975','2013-11-29','08:55:00',1.39),('8975','2013-11-29','09:00:00',1.56),('8975','2013-11-29','09:05:00',1.61),('8975','2013-11-29','09:10:00',2.44),('8975','2013-11-29','09:15:00',2.74),('8975','2013-11-29','09:20:00',2.74),('8975','2013-11-29','09:25:00',2.76),('8975','2013-11-29','09:30:00',2.23),('8975','2013-11-29','09:35:00',3.04),('8975','2013-11-29','09:40:00',2.78),('8975','2013-11-29','09:45:00',2.44),('8975','2013-11-29','09:50:00',2.07),('8975','2013-11-29','09:55:00',1.88),('8975','2013-11-29','10:00:00',1.78),('8975','2013-11-29','10:05:00',1.59),('8975','2013-11-29','10:10:00',1.57),('8975','2013-11-29','10:15:00',1.74),('8975','2013-11-29','10:20:00',1.85),('8975','2013-11-29','10:25:00',1.8),('8975','2013-11-29','10:30:00',1.88),('8975','2013-11-29','10:35:00',1.99),('8975','2013-11-29','10:40:00',2.06),('8975','2013-11-29','10:45:00',2.02),('8975','2013-11-29','10:50:00',1.95),('8975','2013-11-29','10:55:00',1.82),('8975','2013-11-29','11:00:00',1.76),('8975','2013-11-29','11:05:00',2.1),('8975','2013-11-29','11:10:00',2.06),('8975','2013-11-29','11:15:00',1.98),('8975','2013-11-29','11:20:00',1.88),('8975','2013-11-29','11:25:00',1.83),('8975','2013-11-29','11:30:00',1.66),('8975','2013-11-29','11:35:00',1.63),('8975','2013-11-29','11:40:00',1.53),('8975','2013-11-29','11:45:00',1.4),('8975','2013-11-29','11:50:00',1.37),('8975','2013-11-29','11:55:00',1.2),('8975','2013-11-29','12:00:00',1.15),('8975','2013-11-29','12:05:00',1.13),('8975','2013-11-29','12:10:00',1.05),('8975','2013-11-29','12:15:00',1),('8975','2013-11-29','12:20:00',1.01),('8975','2013-11-29','12:25:00',1.09),('8975','2013-11-29','12:30:00',1),('8975','2013-11-29','13:45:00',1.04),('8975','2013-11-29','13:50:00',1.24),('8975','2013-11-29','13:55:00',1.11),('8975','2013-11-28','07:45:00',1.01),('8975','2013-11-28','07:50:00',1.13),('8975','2013-11-28','07:55:00',1.27),('8975','2013-11-28','08:00:00',1.4),('8975','2013-11-28','08:05:00',1.51),('8975','2013-11-28','08:10:00',1.62),('8975','2013-11-28','08:15:00',1.73),('8975','2013-11-28','08:20:00',1.83),('8975','2013-11-28','08:25:00',1.92),('8975','2013-11-28','08:30:00',2.02),('8975','2013-11-28','08:35:00',2.1),('8975','2013-11-28','08:40:00',2.17),('8975','2013-11-28','08:45:00',2.25),('8975','2013-11-28','08:50:00',2.3),('8975','2013-11-28','08:55:00',2.38),('8975','2013-11-28','09:00:00',2.44),('8975','2013-11-28','09:05:00',2.5),('8975','2013-11-28','09:10:00',2.56),('8975','2013-11-28','09:15:00',2.62),('8975','2013-11-28','09:20:00',2.7),('8975','2013-11-28','09:25:00',2.77),('8975','2013-11-28','09:30:00',2.8),('8975','2013-11-28','09:35:00',2.83),('8975','2013-11-28','09:40:00',2.88),('8975','2013-11-28','09:45:00',2.9),('8975','2013-11-28','09:50:00',2.95),('8975','2013-11-28','09:55:00',3.03),('8975','2013-11-28','10:00:00',3.06),('8975','2013-11-28','10:05:00',3.03),('8975','2013-11-28','10:10:00',3.11),('8975','2013-11-28','10:15:00',3.16),('8975','2013-11-28','10:20:00',3.2),('8975','2013-11-28','10:25:00',3.22),('8975','2013-11-28','10:30:00',3.25),('8975','2013-11-28','10:35:00',3.26),('8975','2013-11-28','10:40:00',3.28),('8975','2013-11-28','10:45:00',3.3),('8975','2013-11-28','10:50:00',3.29),('8975','2013-11-28','10:55:00',3.32),('8975','2013-11-28','11:00:00',3.3),('8975','2013-11-28','11:05:00',3.29),('8975','2013-11-28','11:10:00',3.29),('8975','2013-11-28','11:15:00',3.22),('8975','2013-11-28','11:20:00',3.14),('8975','2013-11-28','11:25:00',3.19),('8975','2013-11-28','11:30:00',3.1),('8975','2013-11-28','11:35:00',3.06),('8975','2013-11-28','11:40:00',3.06),('8975','2013-11-28','11:45:00',2.99),('8975','2013-11-28','11:50:00',2.93),('8975','2013-11-28','11:55:00',2.86),('8975','2013-11-28','12:00:00',2.82),('8975','2013-11-28','12:05:00',2.84),('8975','2013-11-28','12:10:00',2.79),('8975','2013-11-28','12:15:00',2.76),('8975','2013-11-28','12:20:00',2.67),('8975','2013-11-28','12:25:00',2.5),('8975','2013-11-28','12:30:00',2.53),('8975','2013-11-28','12:35:00',2.53),('8975','2013-11-28','12:40:00',2.47),('8975','2013-11-28','12:45:00',2.46),('8975','2013-11-28','12:50:00',2.4),('8975','2013-11-28','12:55:00',2.29),('8975','2013-11-28','13:00:00',2.16),('8975','2013-11-28','13:05:00',2.15),('8975','2013-11-28','13:10:00',2.09),('8975','2013-11-28','13:15:00',1.95),('8975','2013-11-28','13:20:00',1.91),('8975','2013-11-28','13:25:00',1.73),('8975','2013-11-28','13:30:00',1.7),('8975','2013-11-28','13:35:00',1.7),('8975','2013-11-28','13:40:00',1.69),('8975','2013-11-28','13:45:00',1.65),('8975','2013-11-28','13:50:00',1.57),('8975','2013-11-28','13:55:00',1.5),('8975','2013-11-28','14:00:00',1.44),('8975','2013-11-28','14:05:00',1.35),('8975','2013-11-28','14:10:00',1.28),('8975','2013-11-28','14:15:00',1.23),('8975','2013-11-28','14:20:00',1.22),('8975','2013-11-28','14:25:00',1.21),('8975','2013-11-28','14:30:00',1.21),('8975','2013-11-28','14:35:00',1.23),('8975','2013-11-28','14:40:00',1.21),('8975','2013-11-28','14:45:00',1.17),('8975','2013-11-28','14:50:00',1.14),('8975','2013-11-28','14:55:00',1.12),('8975','2013-11-28','15:00:00',1.09),('8975','2013-11-28','15:05:00',1.04),('8975','2013-11-28','15:10:00',1.01),('8975','2013-11-27','09:30:00',1.11),('8975','2013-11-27','09:35:00',1.18),('8975','2013-11-27','09:40:00',1.32),('8975','2013-11-27','09:45:00',1.38),('8975','2013-11-27','09:50:00',1.36),('8975','2013-11-27','09:55:00',1.3),('8975','2013-11-27','10:00:00',1.25),('8975','2013-11-27','11:20:00',1.01),('8975','2013-11-27','11:25:00',1.02),('8975','2013-11-27','12:40:00',1.01),('8975','2013-11-27','12:45:00',1.1),('8975','2013-11-27','12:50:00',1.49),('8975','2013-11-27','12:55:00',1.79),('8975','2013-11-27','13:00:00',1.23),('8975','2013-11-27','13:25:00',1.36),('8975','2013-11-27','13:35:00',1.31),('8975','2013-11-27','13:40:00',1.19),('8975','2013-11-27','13:45:00',1.15),('8975','2013-11-27','14:10:00',1.34),('8975','2014-04-19','07:40:00',2.3),('8975','2014-04-19','07:45:00',2.6),('8975','2014-04-19','07:50:00',2.64),('8975','2014-04-19','07:55:00',2.66),('8975','2014-04-19','08:00:00',3),('8975','2014-04-19','08:05:00',3.06),('8975','2014-04-19','08:10:00',3.26),('8975','2014-04-19','08:15:00',3.45),('8975','2014-04-19','08:20:00',4.18),('8975','2014-04-19','08:25:00',3.71),('8975','2014-04-19','08:30:00',3.82),('8975','2014-04-19','08:35:00',4.39),('8975','2014-04-19','08:40:00',3.51),('8975','2014-04-19','08:45:00',4.69),('8975','2014-04-19','08:50:00',2.42),('8975','2014-04-19','08:55:00',2.65),('8975','2014-04-19','09:00:00',1.03),('8975','2014-04-19','09:05:00',2.08),('8975','2014-04-19','09:10:00',5.22),('8975','2014-04-19','09:15:00',5.03),('8975','2014-04-19','09:20:00',5.31),('8975','2014-04-19','09:25:00',4.54),('8975','2014-04-19','09:30:00',4.28),('8975','2014-04-19','09:35:00',4.67),('8975','2014-04-19','09:40:00',2.72),('8975','2014-04-19','09:45:00',3.23),('8975','2014-04-19','09:50:00',2.82),('8975','2014-04-19','09:55:00',3.43),('8975','2014-04-19','10:00:00',4.05),('8975','2014-04-19','10:05:00',5.2),('8975','2014-04-19','10:10:00',4.25),('8975','2014-04-19','10:15:00',5.52),('8975','2014-04-19','10:20:00',5.13),('8975','2014-04-19','10:25:00',4.29),('8975','2014-04-19','10:30:00',4.89),('8975','2014-04-19','10:35:00',4.65),('8975','2014-04-19','10:40:00',4.33),('8975','2014-04-19','10:45:00',5.12),('8975','2014-04-19','10:50:00',4.72),('8975','2014-04-19','10:55:00',4.92),('8975','2014-04-19','11:00:00',5.58),('8975','2014-04-19','11:05:00',5.01),('8975','2014-04-19','11:10:00',5.55),('8975','2014-04-19','11:15:00',5.79),('8975','2014-04-19','11:20:00',6.31),('8975','2014-04-19','11:25:00',2.9),('8975','2014-04-19','11:30:00',7.01),('8975','2014-04-19','11:35:00',7.36),('8975','2014-04-19','11:40:00',7.33),('8975','2014-04-19','11:45:00',6.11),('8975','2014-04-19','11:50:00',7.14),('8975','2014-04-19','11:55:00',6.54),('8975','2014-04-19','12:00:00',6.12),('8975','2014-04-19','12:05:00',5.05),('8975','2014-04-19','12:10:00',3.57),('8975','2014-04-19','12:15:00',5.06),('8975','2014-04-19','12:20:00',7.72),('8975','2014-04-19','12:25:00',7.2),('8975','2014-04-19','12:30:00',6.83),('8975','2014-04-19','12:35:00',6.8),('8975','2014-04-19','12:40:00',6.7),('8975','2014-04-19','12:45:00',6.66),('8975','2014-04-19','12:50:00',6.69),('8975','2014-04-19','12:55:00',6.67),('8975','2014-04-19','13:00:00',6.66),('8975','2014-04-19','13:05:00',6.49),('8975','2014-04-19','13:10:00',5.85),('8975','2014-04-19','13:15:00',4.93),('8975','2014-04-19','13:20:00',6.49),('8975','2014-04-19','13:25:00',6.47),('8975','2014-04-19','13:30:00',6.43),('8975','2014-04-19','13:35:00',6.39),('8975','2014-04-19','13:40:00',6.34),('8975','2014-04-19','13:45:00',6.27),('8975','2014-04-19','13:50:00',6.21),('8975','2014-04-19','13:55:00',6.14),('8975','2014-04-19','14:00:00',6.05),('8975','2014-04-19','14:05:00',6.01),('8975','2014-04-19','14:10:00',5.96),('8975','2014-04-19','14:15:00',6.07),('8975','2014-04-19','14:20:00',4.4),('8975','2014-04-19','14:25:00',4.58),('8975','2014-04-19','14:30:00',3.97),('8975','2014-04-19','14:35:00',3.93),('8975','2014-04-19','14:40:00',4.02),('8975','2014-04-19','14:45:00',4.01),('8975','2014-04-19','14:50:00',4.13),('8975','2014-04-19','14:55:00',4.57),('8975','2014-04-19','15:00:00',6.2),('8975','2014-04-19','15:05:00',5.2),('8975','2014-04-19','15:10:00',5.43),('8975','2014-04-19','15:15:00',4.88),('8975','2014-04-19','15:20:00',4.82),('8975','2014-04-19','15:25:00',4.66),('8975','2014-04-19','15:30:00',4.53),('8975','2014-04-19','15:35:00',4.14),('8975','2014-04-19','15:40:00',4.3),('8975','2014-04-19','15:45:00',2.16),('8975','2014-04-19','15:50:00',3.87),('8975','2014-04-19','15:55:00',4.11),('8975','2014-04-19','16:00:00',3.89),('8975','2014-04-19','16:05:00',3.76),('8975','2014-04-19','16:10:00',3.66),('8975','2014-04-19','16:15:00',3.59),('8975','2014-04-19','16:20:00',3.2),('8975','2014-04-19','16:25:00',3.35),('8975','2014-04-19','16:30:00',3.18),('8975','2014-04-19','16:35:00',2.91),('8975','2014-04-19','16:40:00',2.91),('8975','2014-04-19','16:45:00',2.23),('8975','2014-04-19','16:50:00',2.72),('8975','2014-04-19','16:55:00',2.77),('8975','2014-04-19','17:00:00',2.59),('8975','2014-04-19','17:05:00',2.42),('8975','2014-04-19','17:10:00',2.26),('8975','2014-04-19','17:15:00',2.13),('8975','2014-04-19','17:20:00',1.99),('8975','2014-04-19','17:25:00',1.91),('8975','2014-04-19','17:30:00',1.8),('8975','2014-04-19','17:35:00',1.72),('8975','2014-04-19','17:40:00',1.65),('8975','2014-04-19','17:45:00',1.57),('8975','2014-04-19','17:50:00',1.52),('8975','2014-04-19','17:55:00',1.46),('8975','2014-04-19','18:00:00',1.43),('8975','2014-04-19','18:05:00',1.38),('8975','2014-04-19','18:10:00',1.33),('8975','2014-04-19','18:15:00',1.17),('8975','2014-04-19','18:30:00',1.06),('8975','2013-11-26','08:45:00',1.04),('8975','2013-11-26','08:50:00',1.09),('8975','2013-11-26','08:55:00',1.08),('8975','2013-11-26','09:00:00',1.07),('8975','2013-11-26','09:15:00',1.17),('8975','2013-11-26','09:20:00',1.34),('8975','2013-11-26','09:25:00',1.72),('8975','2013-11-26','09:30:00',1.49),('8975','2013-11-26','09:35:00',1.97),('8975','2013-11-26','09:40:00',1.63),('8975','2013-11-26','09:45:00',1.51),('8975','2013-11-26','09:50:00',1.76),('8975','2013-11-26','09:55:00',1.92),('8975','2013-11-26','10:00:00',1.98),('8975','2013-11-26','10:05:00',1.92),('8975','2013-11-26','10:10:00',1.83),('8975','2013-11-26','10:15:00',1.73),('8975','2013-11-26','10:20:00',1.65),('8975','2013-11-26','10:25:00',1.61),('8975','2013-11-26','10:30:00',1.69),('8975','2013-11-26','10:35:00',1.87),('8975','2013-11-26','10:40:00',2.24),('8975','2013-11-26','10:45:00',2.12),('8975','2013-11-26','10:50:00',1.94),('8975','2013-11-26','10:55:00',1.97),('8975','2013-11-26','11:00:00',2.15),('8975','2013-11-26','11:05:00',2.44),('8975','2013-11-26','11:10:00',2.3),('8975','2013-11-26','11:15:00',2.1),('8975','2013-11-26','11:20:00',2.05),('8975','2013-11-26','11:25:00',2.52),('8975','2013-11-26','11:30:00',3.7),('8975','2013-11-26','11:35:00',2.74),('8975','2013-11-26','11:40:00',2.43),('8975','2013-11-26','11:45:00',2.27),('8975','2013-11-26','11:50:00',2.89),('8975','2013-11-26','11:55:00',2.71),('8975','2013-11-26','12:00:00',3.34),('8975','2013-11-26','12:05:00',3.4),('8975','2013-11-26','12:10:00',2.05),('8975','2013-11-26','12:15:00',2.49),('8975','2013-11-26','12:20:00',1.92),('8975','2013-11-26','12:25:00',1.86),('8975','2013-11-26','12:30:00',2.43),('8975','2013-11-26','12:35:00',1.96),('8975','2013-11-26','12:40:00',1.48),('8975','2013-11-26','12:45:00',1.46),('8975','2013-11-26','12:50:00',1.53),('8975','2013-11-26','12:55:00',1.52),('8975','2013-11-26','13:00:00',1.48),('8975','2013-11-26','13:05:00',1.52),('8975','2013-11-26','13:10:00',1.49),('8975','2013-11-26','13:15:00',1.5),('8975','2013-11-26','13:20:00',1.45),('8975','2013-11-26','13:25:00',1.41),('8975','2013-11-26','13:30:00',1.42),('8975','2013-11-26','13:35:00',1.45),('8975','2013-11-26','13:40:00',1.55),('8975','2013-11-26','13:45:00',1.37),('8975','2013-11-26','13:50:00',1.14),('8975','2013-11-26','13:55:00',1.06),('8975','2013-11-26','14:00:00',1.05),('8975','2013-11-25','08:00:00',1.67),('8975','2013-11-25','08:05:00',1.97),('8975','2013-11-25','08:10:00',2.07),('8975','2013-11-25','08:15:00',2.14),('8975','2013-11-25','08:20:00',1.48),('8975','2013-11-25','08:45:00',1.37),('8975','2013-11-25','08:50:00',1.34),('8975','2013-11-25','08:55:00',1.11),('8975','2013-11-25','09:00:00',1.35),('8975','2013-11-25','09:05:00',1.63),('8975','2013-11-25','09:10:00',2.05),('8975','2013-11-25','09:15:00',2.02),('8975','2013-11-25','09:20:00',1.94),('8975','2013-11-25','09:25:00',1.75),('8975','2013-11-25','09:30:00',1.76),('8975','2013-11-25','09:35:00',1.95),('8975','2013-11-25','09:40:00',2.76),('8975','2013-11-25','09:45:00',1.59),('8975','2013-11-25','09:50:00',1.9),('8975','2013-11-25','09:55:00',2.48),('8975','2013-11-25','10:00:00',3.57),('8975','2013-11-25','10:05:00',2.52),('8975','2013-11-25','10:10:00',2.71),('8975','2013-11-25','10:15:00',1.42),('8975','2013-11-25','10:20:00',1.8),('8975','2013-11-25','10:25:00',2.26),('8975','2013-11-25','10:30:00',2.1),('8975','2013-11-25','10:35:00',3.13),('8975','2013-11-25','10:40:00',3.59),('8975','2013-11-25','10:45:00',3.62),('8975','2013-11-25','10:50:00',3.62),('8975','2013-11-25','10:55:00',3.65),('8975','2013-11-25','11:00:00',3.69),('8975','2013-11-25','11:05:00',4.01),('8975','2013-11-25','11:10:00',3.95),('8975','2013-11-25','11:15:00',4.04),('8975','2013-11-25','11:20:00',3.98),('8975','2013-11-25','11:25:00',3.51),('8975','2013-11-25','11:30:00',3.72),('8975','2013-11-25','11:35:00',3.69),('8975','2013-11-25','11:40:00',2.05),('8975','2013-11-25','11:45:00',3.82),('8975','2013-11-25','11:50:00',3.77),('8975','2013-11-25','11:55:00',3.52),('8975','2013-11-25','12:00:00',2.36),('8975','2013-11-25','12:05:00',2.03),('8975','2013-11-25','12:10:00',1.09),('8975','2013-11-25','12:20:00',2.6),('8975','2013-11-25','12:25:00',2.88),('8975','2013-11-25','12:30:00',2.67),('8975','2013-11-25','12:35:00',2.81),('8975','2013-11-25','12:40:00',2.78),('8975','2013-11-25','12:45:00',2.67),('8975','2013-11-25','12:50:00',2.66),('8975','2013-11-25','12:55:00',2.51),('8975','2013-11-25','13:00:00',2.43),('8975','2013-11-25','13:05:00',2.36),('8975','2013-11-25','13:10:00',2.28),('8975','2013-11-25','13:15:00',2.17),('8975','2013-11-25','13:20:00',2.07),('8975','2013-11-25','13:25:00',1.99),('8975','2013-11-25','13:30:00',1.95),('8975','2013-11-25','13:35:00',1.93),('8975','2013-11-25','13:40:00',1.89),('8975','2013-11-25','13:45:00',1.86),('8975','2013-11-25','13:50:00',1.87),('8975','2013-11-25','13:55:00',1.8),('8975','2013-11-25','14:00:00',2.09),('8975','2013-11-25','14:05:00',2.49),('8975','2013-11-25','14:10:00',2.09),('8975','2013-11-25','14:15:00',2.52),('8975','2013-11-25','14:20:00',2.27),('8975','2013-11-25','14:25:00',1.6),('8975','2013-11-25','14:30:00',1.08),('8975','2013-11-25','14:35:00',1.45),('8975','2013-11-25','14:40:00',1.54),('8975','2013-11-25','14:45:00',1.68),('8975','2013-11-25','14:50:00',1.79),('8975','2013-11-25','14:55:00',2.05),('8975','2013-11-25','15:00:00',1.9),('8975','2013-11-25','15:05:00',1.68),('8975','2013-11-25','15:10:00',1.44),('8975','2013-11-25','15:15:00',1.3),('8975','2013-11-25','15:20:00',1.22),('8975','2013-11-25','15:25:00',1.16),('8975','2013-11-25','15:30:00',1.07),('8975','2013-11-25','15:35:00',1.01),('8975','2013-11-24','07:45:00',1.25),('8975','2013-11-24','07:50:00',1.37),('8975','2013-11-24','07:55:00',1.51),('8975','2013-11-24','08:00:00',1.62),('8975','2013-11-24','08:05:00',1.75),('8975','2013-11-24','08:10:00',1.84),('8975','2013-11-24','08:15:00',1.96),('8975','2013-11-24','08:20:00',2.1),('8975','2013-11-24','08:25:00',2.22),('8975','2013-11-24','08:30:00',2.29),('8975','2013-11-24','08:35:00',2.42),('8975','2013-11-24','08:40:00',2.57),('8975','2013-11-24','08:45:00',2.65),('8975','2013-11-24','08:50:00',2.76),('8975','2013-11-24','08:55:00',2.95),('8975','2013-11-24','09:00:00',3.19),('8975','2013-11-24','09:05:00',3.28),('8975','2013-11-24','09:10:00',3.41),('8975','2013-11-24','09:15:00',3.53),('8975','2013-11-24','09:20:00',3.9),('8975','2013-11-24','09:25:00',2.95),('8975','2013-11-24','09:30:00',2.25),('8975','2013-11-24','09:35:00',3.91),('8975','2013-11-24','09:40:00',3.12),('8975','2013-11-24','09:45:00',1.87),('8975','2013-11-24','09:50:00',2.06),('8975','2013-11-24','09:55:00',2.79),('8975','2013-11-24','10:00:00',2.51),('8975','2013-11-24','10:05:00',3.38),('8975','2013-11-24','10:10:00',2.55),('8975','2013-11-24','10:15:00',1.28),('8975','2013-11-24','10:20:00',2.57),('8975','2013-11-24','10:25:00',3.62),('8975','2013-11-24','10:30:00',4.29),('8975','2013-11-24','10:35:00',3.83),('8975','2013-11-24','10:40:00',3.42),('8975','2013-11-24','10:45:00',2.9),('8975','2013-11-24','10:50:00',1.87),('8975','2013-11-24','10:55:00',2.79),('8975','2013-11-24','11:00:00',3.66),('8975','2013-11-24','11:05:00',3.63),('8975','2013-11-24','11:10:00',4.1),('8975','2013-11-24','11:15:00',4.57),('8975','2013-11-24','11:20:00',2.44),('8975','2013-11-24','11:25:00',2.05),('8975','2013-11-24','11:30:00',2.56),('8975','2013-11-24','11:35:00',3.48),('8975','2013-11-24','11:40:00',3.69),('8975','2013-11-24','11:45:00',3.56),('8975','2013-11-24','11:50:00',3.14),('8975','2013-11-24','11:55:00',2.6),('8975','2013-11-24','12:00:00',2.7),('8975','2013-11-24','12:05:00',2.04),('8975','2013-11-24','12:10:00',1.86),('8975','2013-11-24','12:15:00',2.03),('8975','2013-11-24','12:20:00',1.94),('8975','2013-11-24','12:25:00',2.07),('8975','2013-11-24','12:30:00',1.82),('8975','2013-11-24','12:35:00',1.5),('8975','2013-11-24','12:40:00',1.92),('8975','2013-11-24','12:45:00',2.59),('8975','2013-11-24','12:50:00',2.74),('8975','2013-11-24','12:55:00',2.46),('8975','2013-11-24','13:00:00',2.79),('8975','2013-11-24','13:05:00',3.01),('8975','2013-11-24','13:10:00',3.11),('8975','2013-11-24','13:15:00',3.26),('8975','2013-11-24','13:20:00',3.04),('8975','2013-11-24','13:25:00',3.15),('8975','2013-11-24','13:30:00',2.93),('8975','2013-11-24','13:35:00',2.09),('8975','2013-11-24','13:40:00',1.47),('8975','2013-11-24','13:45:00',1.41),('8975','2013-11-24','13:50:00',1.36),('8975','2013-11-24','13:55:00',1.17),('8975','2013-11-24','14:00:00',1.04),('8975','2013-11-23','09:50:00',1.46),('8975','2013-11-23','09:55:00',1.98),('8975','2013-11-23','10:00:00',2.18),('8975','2013-11-23','10:05:00',2.18),('8975','2013-11-23','10:10:00',2.25),('8975','2013-11-23','10:15:00',2.03),('8975','2013-11-23','10:20:00',2.08),('8975','2013-11-23','10:25:00',2.3),('8975','2013-11-23','10:30:00',1.87),('8975','2013-11-23','10:35:00',1.47),('8975','2013-11-23','10:40:00',1.41),('8975','2013-11-23','10:45:00',1.44),('8975','2013-11-23','10:50:00',1.57),('8975','2013-11-23','10:55:00',1.72),('8975','2013-11-23','11:00:00',1.75),('8975','2013-11-23','11:05:00',1.82),('8975','2013-11-23','11:10:00',1.87),('8975','2013-11-23','11:15:00',1.9),('8975','2013-11-23','11:20:00',2.01),('8975','2013-11-23','11:25:00',2.12),('8975','2013-11-23','11:30:00',2.2),('8975','2013-11-23','11:35:00',1.92),('8975','2013-11-23','11:40:00',2.21),('8975','2013-11-23','11:45:00',2.08),('8975','2013-11-23','11:50:00',2.07),('8975','2013-11-23','11:55:00',1.77),('8975','2013-11-23','12:00:00',1.46),('8975','2013-11-23','12:05:00',1.19),('8975','2013-11-23','12:10:00',1.21),('8975','2013-11-23','12:15:00',1.41),('8975','2013-11-23','12:20:00',1.51),('8975','2013-11-23','12:25:00',1.54),('8975','2013-11-23','12:30:00',1.48),('8975','2013-11-23','12:35:00',1.48),('8975','2013-11-23','12:40:00',1.52),('8975','2013-11-23','12:45:00',1.5),('8975','2013-11-23','12:50:00',1.54),('8975','2013-11-23','12:55:00',1.58),('8975','2013-11-23','13:00:00',1.92),('8975','2013-11-23','13:05:00',2.07),('8975','2013-11-23','13:10:00',2.01),('8975','2013-11-23','13:15:00',1.93),('8975','2013-11-23','13:20:00',1.85),('8975','2013-11-23','13:25:00',1.59),('8975','2013-11-23','13:30:00',1.38),('8975','2013-11-23','13:35:00',1.35),('8975','2013-11-23','13:40:00',1.28),('8975','2013-11-23','13:45:00',1.11),('8975','2013-11-23','13:50:00',1.05),('8975','2013-11-22','08:40:00',1.08),('8975','2013-11-22','10:10:00',1.18),('8975','2013-11-22','10:15:00',1.79),('8975','2013-11-22','10:20:00',1.75),('8975','2013-11-22','10:25:00',2.16),('8975','2013-11-22','10:30:00',3.07),('8975','2013-11-22','10:35:00',2.58),('8975','2013-11-22','10:40:00',3.23),('8975','2013-11-22','11:20:00',1.03),('8975','2013-11-22','11:25:00',1.15),('8975','2013-11-22','11:30:00',1.06),('8975','2013-11-22','11:35:00',1.03),('8975','2013-11-22','11:40:00',1.17),('8975','2013-11-22','11:45:00',1.05),('8975','2013-11-22','13:20:00',1.26),('8975','2013-11-22','13:25:00',1.82),('8975','2013-11-22','13:30:00',1.84),('8975','2013-11-22','13:35:00',2.17),('8975','2013-11-22','13:40:00',1.89),('8975','2013-11-22','13:45:00',1.69),('8975','2013-11-22','13:50:00',1.65),('8975','2013-11-22','13:55:00',1.45),('8975','2013-11-22','14:00:00',1.88),('8975','2013-11-22','14:05:00',1.8),('8975','2013-11-22','14:55:00',1.04),('8975','2013-11-20','08:05:00',1.26),('8975','2013-11-20','08:10:00',2.16),('8975','2013-11-20','08:15:00',2.28),('8975','2013-11-20','08:20:00',1.12),('8975','2013-11-20','09:10:00',1.31),('8975','2013-11-20','09:15:00',1.84),('8975','2013-11-20','09:20:00',1.41),('8975','2013-11-20','09:25:00',1.71),('8975','2013-11-20','09:30:00',1.99),('8975','2013-11-20','09:35:00',1.48),('8975','2013-11-20','09:40:00',2.16),('8975','2013-11-20','09:45:00',3.36),('8975','2013-11-20','09:50:00',2.21),('8975','2013-11-20','09:55:00',3.38),('8975','2013-11-20','10:00:00',3.54),('8975','2013-11-20','10:05:00',3.57),('8975','2013-11-20','10:10:00',2.4),('8975','2013-11-20','10:15:00',3.17),('8975','2013-11-20','10:20:00',2.81),('8975','2013-11-20','10:25:00',3.05),('8975','2013-11-20','10:30:00',3.12),('8975','2013-11-20','10:35:00',3.38),('8975','2013-11-20','10:40:00',3.53),('8975','2013-11-20','10:45:00',3.43),('8975','2013-11-20','10:50:00',1.12),('8975','2013-11-20','11:00:00',1.24),('8975','2013-11-20','11:05:00',1.19),('8975','2013-11-20','11:10:00',1.57),('8975','2013-11-20','11:15:00',1.38),('8975','2013-11-20','11:20:00',1.15),('8975','2013-11-20','11:25:00',2.51),('8975','2013-11-20','11:30:00',2.9),('8975','2013-11-20','11:35:00',2.67),('8975','2013-11-20','11:40:00',3.34),('8975','2013-11-20','11:45:00',1.4),('8975','2013-11-20','11:50:00',2.79),('8975','2013-11-20','11:55:00',2.6),('8975','2013-11-20','12:00:00',2.76),('8975','2013-11-20','12:05:00',2.43),('8975','2013-11-20','12:10:00',2.98),('8975','2013-11-20','12:15:00',2.94),('8975','2013-11-20','12:20:00',2.84),('8975','2013-11-20','12:25:00',2.82),('8975','2013-11-20','12:30:00',2.96),('8975','2013-11-20','12:35:00',2.8),('8975','2013-11-20','12:40:00',3.01),('8975','2013-11-20','12:45:00',2.93),('8975','2013-11-20','12:50:00',2.41),('8975','2013-11-20','12:55:00',2.97),('8975','2013-11-20','13:00:00',2.66),('8975','2013-11-20','13:05:00',2.17),('8975','2013-11-20','13:10:00',1.99),('8975','2013-11-20','13:15:00',2.25),('8975','2013-11-20','13:20:00',2.34),('8975','2013-11-20','13:25:00',2.27),('8975','2013-11-20','13:30:00',2.06),('8975','2013-11-20','13:35:00',1.02),('8975','2013-11-20','13:40:00',1.31),('8975','2013-11-20','13:45:00',1.24),('8975','2013-11-20','13:50:00',1.1),('8975','2013-11-20','13:55:00',1.12),('8975','2013-11-20','14:00:00',1.55),('8975','2013-11-20','14:05:00',1.81),('8975','2013-11-20','14:10:00',1.93),('8975','2013-11-20','14:15:00',1.69),('8975','2013-11-20','14:25:00',1.16),('8975','2013-11-20','14:45:00',1.27),('8975','2013-11-20','14:55:00',1.23),('8975','2013-11-20','15:00:00',1.21),('8975','2013-11-20','15:05:00',1.14),('8975','2013-11-20','15:10:00',1.08),('8975','2013-11-19','08:15:00',1.49),('8975','2013-11-19','09:15:00',2.53),('8975','2013-11-19','09:20:00',2.62),('8975','2013-11-19','09:25:00',2.54),('8975','2013-11-19','09:30:00',3.79),('8975','2013-11-19','09:35:00',2.46),('8975','2013-11-19','10:00:00',2.08),('8975','2013-11-19','10:05:00',1.74),('8975','2013-11-19','10:10:00',3.5),('8975','2013-11-19','10:15:00',3.83),('8975','2013-11-19','10:25:00',1.51),('8975','2013-11-19','10:30:00',1.61),('8975','2013-11-19','10:35:00',1.48),('8975','2013-11-19','10:40:00',1.22),('8975','2013-11-19','10:50:00',1.12),('8975','2013-11-19','10:55:00',1.2),('8975','2013-11-19','11:00:00',1.89),('8975','2013-11-19','11:05:00',1.11),('8975','2013-11-19','11:10:00',1.09),('8975','2013-11-19','11:15:00',1.01),('8975','2013-11-19','11:20:00',1.3),('8975','2013-11-19','11:25:00',1.32),('8975','2013-11-19','11:30:00',1.21),('8975','2013-11-19','11:35:00',1.04),('8975','2013-11-19','11:40:00',1.47),('8975','2013-11-19','11:45:00',3.8),('8975','2013-11-19','11:50:00',2.84),('8975','2013-11-19','11:55:00',2.75),('8975','2013-11-19','12:00:00',1.62),('8975','2013-11-19','12:10:00',1.14),('8975','2013-11-19','12:15:00',1.82),('8975','2013-11-19','12:20:00',2.01),('8975','2013-11-19','12:25:00',1.29),('8975','2013-11-19','12:30:00',1.02),('8975','2013-11-19','12:35:00',1.52),('8975','2013-11-19','12:40:00',2.31),('8975','2013-11-19','12:45:00',2.79),('8975','2013-11-19','12:50:00',3.58),('8975','2013-11-19','12:55:00',3.03),('8975','2013-11-19','13:00:00',2.08),('8975','2013-11-19','13:05:00',1.68),('8975','2013-11-19','13:10:00',1.07),('8975','2013-11-19','13:15:00',1.07),('8975','2013-11-19','13:20:00',1.57),('8975','2013-11-19','13:25:00',1.42),('8975','2013-11-19','13:30:00',1.36),('8975','2013-11-19','13:40:00',1.27),('8975','2013-11-19','13:45:00',1.94),('8975','2013-11-19','13:50:00',1.56),('8975','2013-11-19','13:55:00',1.1),('8975','2013-11-19','14:00:00',1.19),('8975','2013-11-19','14:05:00',1.18),('8975','2013-11-19','14:10:00',1.14),('8975','2013-11-19','14:15:00',1.1),('8975','2013-11-19','14:20:00',1.2),('8975','2013-11-19','14:25:00',1.23),('8975','2013-11-19','14:30:00',1.92),('8975','2013-11-19','14:35:00',1.39),('8975','2013-11-19','14:40:00',1.54),('8975','2013-11-19','14:45:00',1.19),('8975','2013-11-19','15:05:00',1.07),('8975','2013-11-19','15:10:00',1.51),('8975','2013-11-18','09:35:00',2.16),('8975','2013-11-18','09:40:00',3.16),('8975','2013-11-18','09:45:00',2.75),('8975','2013-11-18','09:50:00',1.68),('8975','2013-11-18','09:55:00',2.3),('8975','2013-11-18','10:00:00',1.81),('8975','2013-11-18','10:05:00',1.84),('8975','2013-11-18','10:45:00',1.8),('8975','2013-11-18','10:50:00',2.33),('8975','2013-11-18','10:55:00',1.31),('8975','2013-11-18','11:05:00',1.21),('8975','2013-11-18','11:10:00',1.2),('8975','2013-11-18','11:15:00',2.01),('8975','2013-11-18','11:20:00',2.23),('8975','2013-11-18','11:25:00',2.55),('8975','2013-11-18','11:30:00',2.68),('8975','2013-11-18','11:35:00',2.84),('8975','2013-11-18','11:40:00',2.73),('8975','2013-11-18','11:45:00',3.01),('8975','2013-11-18','11:50:00',2.78),('8975','2013-11-18','11:55:00',2.52),('8975','2013-11-18','12:00:00',2.54),('8975','2013-11-18','12:05:00',2.89),('8975','2013-11-18','12:10:00',2.39),('8975','2013-11-18','12:15:00',2.72),('8975','2013-11-18','12:25:00',1.76),('8975','2013-11-18','12:30:00',1.61),('8975','2013-11-18','12:40:00',1.63),('8975','2013-11-18','12:45:00',1.52),('8975','2013-11-18','12:50:00',2.05),('8975','2013-11-18','12:55:00',2.4),('8975','2013-11-18','13:00:00',1.5),('8975','2013-11-18','13:05:00',1.12),('8975','2013-11-18','13:10:00',2.16),('8975','2013-11-18','13:15:00',2.35),('8975','2013-11-18','13:20:00',1.58),('8975','2013-11-18','13:30:00',1.02),('8975','2013-11-18','14:45:00',1.04),('8975','2013-11-18','14:50:00',1.08),('8975','2013-11-18','15:25:00',1.94),('8975','2013-11-18','15:30:00',1.91),('8975','2013-11-18','15:35:00',1.47),('8975','2013-11-18','15:40:00',1.22),('8975','2013-11-18','15:45:00',1.06),('8975','2013-11-17','07:55:00',1.36),('8975','2013-11-17','08:00:00',1.62),('8975','2013-11-17','08:05:00',2.14),('8975','2013-11-17','08:10:00',1.85),('8975','2013-11-17','08:15:00',1.73),('8975','2013-11-17','08:20:00',1.65),('8975','2013-11-17','08:25:00',2.05),('8975','2013-11-17','08:30:00',2.04),('8975','2013-11-17','08:35:00',1.92),('8975','2013-11-17','08:40:00',1.64),('8975','2013-11-17','08:45:00',1.4),('8975','2013-11-17','08:50:00',1.19),('8975','2013-11-17','08:55:00',1.31),('8975','2013-11-17','09:00:00',1.28),('8975','2013-11-17','09:05:00',1.16),('8975','2013-11-17','09:10:00',1.33),('8975','2013-11-17','09:15:00',2.25),('8975','2013-11-17','09:20:00',2.63),('8975','2013-11-17','09:25:00',2.71),('8975','2013-11-17','09:30:00',2.41),('8975','2013-11-17','09:35:00',2.9),('8975','2013-11-17','09:40:00',2.26),('8975','2013-11-17','09:45:00',1.86),('8975','2013-11-17','09:50:00',1.63),('8975','2013-11-17','09:55:00',1.8),('8975','2013-11-17','10:00:00',2.16),('8975','2013-11-17','10:05:00',2.14),('8975','2013-11-17','10:10:00',2.47),('8975','2013-11-17','10:15:00',2.67),('8975','2013-11-17','10:20:00',1.97),('8975','2013-11-17','10:25:00',1.99),('8975','2013-11-17','10:30:00',1.82),('8975','2013-11-17','10:35:00',1.89),('8975','2013-11-17','10:40:00',1.99),('8975','2013-11-17','10:45:00',2),('8975','2013-11-17','10:50:00',1.88),('8975','2013-11-17','10:55:00',1.69),('8975','2013-11-17','11:00:00',1.55),('8975','2013-11-17','11:05:00',1.43),('8975','2013-11-17','11:10:00',1.3),('8975','2013-11-17','11:15:00',1.21),('8975','2013-11-17','11:20:00',1.33),('8975','2013-11-17','11:25:00',1.54),('8975','2013-11-17','11:30:00',1.69),('8975','2013-11-17','11:35:00',1.76),('8975','2013-11-17','11:40:00',1.81),('8975','2013-11-17','11:45:00',1.86),('8975','2013-11-17','11:50:00',1.93),('8975','2013-11-17','11:55:00',2.05),('8975','2013-11-17','12:00:00',2.13),('8975','2013-11-17','12:05:00',2.18),('8975','2013-11-17','12:10:00',2.16),('8975','2013-11-17','12:15:00',2.18),('8975','2013-11-17','12:20:00',2.31),('8975','2013-11-17','12:25:00',2.26),('8975','2013-11-17','12:30:00',2.03),('8975','2013-11-17','12:35:00',1.84),('8975','2013-11-17','12:40:00',1.65),('8975','2013-11-17','12:45:00',1.52),('8975','2013-11-17','12:50:00',1.44),('8975','2013-11-17','12:55:00',1.4),('8975','2013-11-17','13:00:00',1.39),('8975','2013-11-17','13:05:00',1.49),('8975','2013-11-17','13:10:00',1.58),('8975','2013-11-17','13:15:00',1.57),('8975','2013-11-17','13:20:00',1.49),('8975','2013-11-17','13:25:00',1.39),('8975','2013-11-17','13:30:00',1.52),('8975','2013-11-17','13:35:00',1.69),('8975','2013-11-17','13:40:00',1.7),('8975','2013-11-17','13:45:00',1.57),('8975','2013-11-17','13:50:00',1.52),('8975','2013-11-17','13:55:00',1.33),('8975','2013-11-17','14:00:00',1.16),('8975','2014-04-18','07:15:00',1.61),('8975','2014-04-18','07:20:00',1.99),('8975','2014-04-18','07:25:00',2.15),('8975','2014-04-18','07:30:00',2.53),('8975','2014-04-18','07:35:00',2.82),('8975','2014-04-18','07:40:00',3.18),('8975','2014-04-18','07:45:00',1.47),('8975','2014-04-18','07:50:00',1.76),('8975','2014-04-18','07:55:00',3.61),('8975','2014-04-18','08:00:00',2.99),('8975','2014-04-18','08:05:00',2.09),('8975','2014-04-18','08:10:00',2.23),('8975','2014-04-18','08:15:00',1.91),('8975','2014-04-18','08:20:00',2.26),('8975','2014-04-18','08:25:00',3.79),('8975','2014-04-18','08:30:00',4.54),('8975','2014-04-18','08:35:00',4.22),('8975','2014-04-18','08:40:00',4.87),('8975','2014-04-18','08:45:00',3.29),('8975','2014-04-18','08:50:00',2.45),('8975','2014-04-18','08:55:00',1.66),('8975','2014-04-18','09:00:00',1.13),('8975','2014-04-18','09:05:00',1.04),('8975','2014-04-18','09:10:00',1.17),('8975','2014-04-18','09:15:00',1.28),('8975','2014-04-18','09:20:00',1.76),('8975','2014-04-18','09:25:00',2.51),('8975','2014-04-18','09:30:00',3.07),('8975','2014-04-18','09:35:00',2.75),('8975','2014-04-18','09:40:00',1.8),('8975','2014-04-18','09:45:00',1.4),('8975','2014-04-18','09:50:00',1.42),('8975','2014-04-18','09:55:00',1.39),('8975','2014-04-18','10:00:00',1.33),('8975','2014-04-18','10:05:00',1.01),('8975','2014-04-18','10:15:00',1.18),('8975','2014-04-18','10:20:00',1.39),('8975','2014-04-18','10:25:00',1.13),('8975','2014-04-18','10:30:00',1.2),('8975','2014-04-18','10:35:00',1.59),('8975','2014-04-18','10:40:00',1.96),('8975','2014-04-18','10:45:00',1.79),('8975','2014-04-18','10:50:00',1.85),('8975','2014-04-18','10:55:00',2.34),('8975','2014-04-18','11:00:00',2.51),('8975','2014-04-18','11:05:00',2.04),('8975','2014-04-18','11:10:00',2.06),('8975','2014-04-18','11:15:00',3.29),('8975','2014-04-18','11:20:00',4.09),('8975','2014-04-18','11:25:00',3.18),('8975','2014-04-18','11:30:00',4.23),('8975','2014-04-18','11:35:00',3.53),('8975','2014-04-18','11:40:00',3.01),('8975','2014-04-18','11:45:00',3.49),('8975','2014-04-18','11:50:00',2.66),('8975','2014-04-18','11:55:00',1.62),('8975','2014-04-18','12:00:00',1.29),('8975','2014-04-18','12:05:00',1.05),('8975','2014-04-18','13:10:00',1.17),('8975','2014-04-18','13:15:00',1.97),('8975','2014-04-18','13:45:00',1.02),('8975','2014-04-18','13:50:00',1.26),('8975','2014-04-18','14:25:00',1.07),('8975','2014-04-18','14:30:00',1.78),('8975','2014-04-18','14:35:00',2.6),('8975','2014-04-18','14:40:00',3.43),('8975','2014-04-18','14:45:00',3.43),('8975','2014-04-18','14:50:00',2.3),('8975','2014-04-18','14:55:00',2.42),('8975','2014-04-18','15:00:00',2.68),('8975','2014-04-18','15:05:00',1.61),('8975','2014-04-18','15:20:00',1.43),('8975','2014-04-18','15:25:00',1.85),('8975','2014-04-18','15:30:00',1.74),('8975','2014-04-18','15:35:00',1.16),('8975','2014-04-18','15:45:00',2.09),('8975','2014-04-18','15:50:00',5.91),('8975','2014-04-18','15:55:00',3.38),('8975','2014-04-18','16:00:00',2.81),('8975','2014-04-18','16:05:00',2.54),('8975','2014-04-18','16:10:00',2.31),('8975','2014-04-18','16:15:00',3.16),('8975','2014-04-18','16:20:00',3.4),('8975','2014-04-18','16:25:00',3.34),('8975','2014-04-18','16:30:00',3.22),('8975','2014-04-18','16:35:00',2.17),('8975','2014-04-18','16:40:00',1.62),('8975','2014-04-18','16:45:00',1.47),('8975','2014-04-18','16:50:00',1.25),('8975','2014-04-18','17:00:00',1.01),('8975','2014-04-18','17:05:00',1.62),('8975','2014-04-18','17:10:00',1.55),('8975','2014-04-18','17:15:00',1.79),('8975','2014-04-18','17:20:00',2.74),('8975','2014-04-18','17:25:00',1.95),('8975','2014-04-18','17:30:00',1.56),('8975','2014-04-18','17:35:00',1.42),('8975','2013-11-16','08:35:00',1.16),('8975','2013-11-16','08:40:00',2.45),('8975','2013-11-16','08:45:00',2.57),('8975','2013-11-16','08:50:00',3.41),('8975','2013-11-16','08:55:00',1.8),('8975','2013-11-16','09:00:00',2.78),('8975','2013-11-16','09:05:00',2.85),('8975','2013-11-16','09:10:00',3.05),('8975','2013-11-16','09:15:00',3.21),('8975','2013-11-16','09:20:00',3.17),('8975','2013-11-16','09:25:00',2.76),('8975','2013-11-16','09:30:00',2.65),('8975','2013-11-16','09:35:00',3.05),('8975','2013-11-16','09:40:00',3.13),('8975','2013-11-16','09:45:00',3.13),('8975','2013-11-16','09:50:00',3.17),('8975','2013-11-16','09:55:00',3.16),('8975','2013-11-16','10:00:00',3.2),('8975','2013-11-16','10:05:00',3.24),('8975','2013-11-16','10:10:00',3.26),('8975','2013-11-16','10:15:00',3.29),('8975','2013-11-16','10:20:00',3.32),('8975','2013-11-16','10:25:00',3.33),('8975','2013-11-16','10:30:00',3.36),('8975','2013-11-16','10:35:00',3.35),('8975','2013-11-16','10:40:00',3.36),('8975','2013-11-16','10:45:00',3.37),('8975','2013-11-16','10:50:00',3.37),('8975','2013-11-16','10:55:00',3.37),('8975','2013-11-16','11:00:00',3.36),('8975','2013-11-16','11:05:00',3.38),('8975','2013-11-16','11:10:00',3.37),('8975','2013-11-16','11:15:00',3.27),('8975','2013-11-16','11:20:00',3.2),('8975','2013-11-16','11:25:00',3.23),('8975','2013-11-16','11:30:00',3.03),('8975','2013-11-16','11:35:00',2.85),('8975','2013-11-16','11:40:00',3.05),('8975','2013-11-16','11:45:00',3.06),('8975','2013-11-16','11:50:00',3.02),('8975','2013-11-16','11:55:00',3),('8975','2013-11-16','12:00:00',2.99),('8975','2013-11-16','12:05:00',2.9),('8975','2013-11-16','12:10:00',2.9),('8975','2013-11-16','12:15:00',2.86),('8975','2013-11-16','12:20:00',2.8),('8975','2013-11-16','12:25:00',2.73),('8975','2013-11-16','12:30:00',2.68),('8975','2013-11-16','12:35:00',2.64),('8975','2013-11-16','12:40:00',2.63),('8975','2013-11-16','12:45:00',2.59),('8975','2013-11-16','12:50:00',2.49),('8975','2013-11-16','12:55:00',2.47),('8975','2013-11-16','13:00:00',2.32),('8975','2013-11-16','13:05:00',2.12),('8975','2013-11-16','13:10:00',2.16),('8975','2013-11-16','13:15:00',2.02),('8975','2013-11-16','13:20:00',2.08),('8975','2013-11-16','13:25:00',2.02),('8975','2013-11-16','13:30:00',1.51),('8975','2013-11-16','13:40:00',1.28),('8975','2013-11-16','13:45:00',1.1),('8975','2013-11-16','13:50:00',1.07),('8975','2013-11-16','13:55:00',1.02),('8975','2013-11-16','14:15:00',1.32),('8975','2013-11-16','14:20:00',1.2),('8975','2013-11-16','14:25:00',1.16),('8975','2013-11-16','14:30:00',1.13),('8975','2013-11-15','12:45:00',1),('8975','2013-11-15','12:50:00',1.15),('8975','2013-11-15','12:55:00',1.17),('8975','2013-11-15','13:00:00',1.32),('8975','2013-11-15','13:05:00',1.56),('8975','2013-11-15','13:10:00',1.29),('8975','2013-11-15','13:15:00',1.04),('8975','2013-11-14','08:00:00',1.23),('8975','2013-11-14','08:05:00',1.23),('8975','2013-11-14','08:10:00',1.65),('8975','2013-11-14','08:15:00',1.69),('8975','2013-11-14','08:20:00',1.1),('8975','2013-11-14','08:50:00',1.05),('8975','2013-11-14','08:55:00',1.16),('8975','2013-11-14','09:00:00',1.27),('8975','2013-11-14','09:05:00',1.5),('8975','2013-11-14','09:10:00',1.79),('8975','2013-11-14','09:15:00',1.75),('8975','2013-11-14','09:20:00',1.43),('8975','2013-11-14','09:25:00',1.73),('8975','2013-11-14','09:30:00',1.94),('8975','2013-11-14','09:35:00',1.71),('8975','2013-11-14','09:40:00',1.29),('8975','2013-11-14','10:05:00',1.36),('8975','2013-11-14','10:10:00',1.86),('8975','2013-11-14','10:15:00',2.04),('8975','2013-11-14','10:20:00',1.79),('8975','2013-11-14','10:25:00',1.49),('8975','2013-11-14','10:30:00',1.36),('8975','2013-11-14','10:35:00',1.28),('8975','2013-11-14','10:40:00',1.43),('8975','2013-11-14','10:45:00',2.08),('8975','2013-11-14','10:50:00',2.04),('8975','2013-11-14','10:55:00',2.06),('8975','2013-11-14','11:00:00',1.91),('8975','2013-11-14','11:05:00',1.84),('8975','2013-11-14','11:10:00',1.91),('8975','2013-11-14','11:15:00',2.12),('8975','2013-11-14','11:20:00',2.34),('8975','2013-11-14','11:25:00',2.34),('8975','2013-11-14','11:30:00',2.45),('8975','2013-11-14','11:35:00',2.33),('8975','2013-11-14','11:40:00',2.45),('8975','2013-11-14','11:45:00',2.26),('8975','2013-11-14','11:50:00',1.97),('8975','2013-11-14','11:55:00',1.78),('8975','2013-11-14','12:00:00',1.79),('8975','2013-11-14','12:05:00',1.82),('8975','2013-11-14','12:10:00',1.72),('8975','2013-11-14','12:15:00',1.78),('8975','2013-11-14','12:20:00',2.22),('8975','2013-11-14','12:25:00',1.95),('8975','2013-11-14','12:30:00',1.78),('8975','2013-11-14','12:35:00',1.67),('8975','2013-11-14','12:40:00',1.63),('8975','2013-11-14','12:45:00',1.64),('8975','2013-11-14','12:50:00',1.67),('8975','2013-11-14','12:55:00',1.71),('8975','2013-11-14','13:00:00',1.66),('8975','2013-11-14','13:05:00',1.44),('8975','2013-11-14','13:10:00',1.38),('8975','2013-11-14','13:15:00',1.22),('8975','2013-11-14','13:20:00',1.26),('8975','2013-11-14','13:25:00',1.43),('8975','2013-11-14','13:30:00',1.56),('8975','2013-11-14','13:35:00',1.67),('8975','2013-11-14','13:40:00',1.93),('8975','2013-11-14','13:45:00',1.67),('8975','2013-11-14','13:50:00',1.97),('8975','2013-11-14','13:55:00',1.65),('8975','2013-11-14','14:00:00',1.57),('8975','2013-11-14','14:05:00',1.27),('8975','2013-11-14','14:10:00',1.02),('8975','2013-11-13','08:10:00',1.1),('8975','2013-11-13','08:15:00',1.35),('8975','2013-11-13','08:20:00',1.65),('8975','2013-11-13','08:25:00',1.02),('8975','2013-11-13','08:30:00',1.48),('8975','2013-11-13','08:40:00',1.98),('8975','2013-11-13','08:45:00',1.45),('8975','2013-11-13','08:50:00',1.62),('8975','2013-11-13','08:55:00',2.87),('8975','2013-11-13','09:00:00',2.94),('8975','2013-11-13','09:05:00',3.23),('8975','2013-11-13','09:10:00',3.13),('8975','2013-11-13','09:15:00',2.95),('8975','2013-11-13','09:20:00',3.02),('8975','2013-11-13','09:25:00',3),('8975','2013-11-13','09:30:00',3.05),('8975','2013-11-13','09:35:00',3.11),('8975','2013-11-13','09:40:00',3.17),('8975','2013-11-13','09:45:00',3.23),('8975','2013-11-13','09:50:00',2.79),('8975','2013-11-13','09:55:00',2.42),('8975','2013-11-13','10:00:00',1.26),('8975','2013-11-13','10:15:00',1.63),('8975','2013-11-13','10:20:00',3.11),('8975','2013-11-13','10:25:00',3.32),('8975','2013-11-13','10:30:00',3.45),('8975','2013-11-13','10:35:00',3.45),('8975','2013-11-13','10:40:00',3.45),('8975','2013-11-13','10:45:00',3.37),('8975','2013-11-13','10:50:00',3.38),('8975','2013-11-13','10:55:00',3.4),('8975','2013-11-13','11:00:00',3.48),('8975','2013-11-13','11:05:00',3.43),('8975','2013-11-13','11:10:00',3.41),('8975','2013-11-13','11:15:00',3.32),('8975','2013-11-13','11:20:00',3.21),('8975','2013-11-13','11:25:00',3.44),('8975','2013-11-13','11:30:00',3.46),('8975','2013-11-13','11:35:00',3.2),('8975','2013-11-13','11:40:00',3.02),('8975','2013-11-13','11:45:00',1.16),('8975','2013-11-13','11:50:00',1.62),('8975','2013-11-13','11:55:00',1.15),('8975','2013-11-13','12:00:00',1.55),('8975','2013-11-13','12:05:00',2.14),('8975','2013-11-13','12:10:00',1.98),('8975','2013-11-13','12:15:00',2.03),('8975','2013-11-13','12:20:00',2.02),('8975','2013-11-13','12:25:00',1.86),('8975','2013-11-13','12:30:00',1.77),('8975','2013-11-13','12:35:00',1.77),('8975','2013-11-13','12:40:00',1.73),('8975','2013-11-13','12:45:00',1.77),('8975','2013-11-13','12:50:00',1.75),('8975','2013-11-13','12:55:00',1.67),('8975','2013-11-13','13:00:00',1.61),('8975','2013-11-13','13:05:00',1.41),('8975','2013-11-13','13:10:00',1.25),('8975','2013-11-13','13:15:00',1.28),('8975','2013-11-13','13:20:00',1.32),('8975','2013-11-13','13:25:00',1.31),('8975','2013-11-13','13:30:00',1.39),('8975','2013-11-13','13:35:00',1.38),('8975','2013-11-13','13:40:00',1.32),('8975','2013-11-13','13:45:00',1.29),('8975','2013-11-13','13:50:00',1.38),('8975','2013-11-13','13:55:00',1.25),('8975','2013-11-13','14:00:00',1.48),('8975','2013-11-13','14:05:00',1.55),('8975','2013-11-13','14:10:00',1.24),('8975','2013-11-13','14:15:00',1.13),('8975','2013-11-13','14:20:00',1.12),('8975','2013-11-13','14:25:00',1.04),('8975','2013-11-12','08:15:00',1.11),('8975','2013-11-12','09:55:00',1),('8975','2013-11-12','10:00:00',1.53),('8975','2013-11-12','10:05:00',1.83),('8975','2013-11-12','10:10:00',1.75),('8975','2013-11-12','10:15:00',3.18),('8975','2013-11-12','10:20:00',3.4),('8975','2013-11-12','10:25:00',3.75),('8975','2013-11-12','10:30:00',4.6),('8975','2013-11-12','10:35:00',4.61),('8975','2013-11-12','10:40:00',4.9),('8975','2013-11-12','10:45:00',4.54),('8975','2013-11-12','10:50:00',4.41),('8975','2013-11-12','10:55:00',2.92),('8975','2013-11-12','11:00:00',1.37),('8975','2013-11-12','11:05:00',1.38),('8975','2013-11-12','11:10:00',1.36),('8975','2013-11-12','11:15:00',1.44),('8975','2013-11-12','11:20:00',1.47),('8975','2013-11-12','11:25:00',1.52),('8975','2013-11-12','11:30:00',1.64),('8975','2013-11-12','11:35:00',1.53),('8975','2013-11-12','11:40:00',1.43),('8975','2013-11-12','11:45:00',1.62),('8975','2013-11-12','11:50:00',1.7),('8975','2013-11-12','11:55:00',1.52),('8975','2013-11-12','12:00:00',1.18),('8975','2013-11-12','12:05:00',1.09),('8975','2013-11-12','12:10:00',1.21),('8975','2013-11-12','12:15:00',1.28),('8975','2013-11-12','12:20:00',1.19),('8975','2013-11-12','12:25:00',1.18),('8975','2013-11-12','12:30:00',1),('8975','2013-11-12','12:35:00',1.04),('8975','2013-11-12','12:40:00',1.17),('8975','2013-11-12','12:45:00',1.09),('8975','2013-11-12','12:50:00',1.15),('8975','2013-11-12','12:55:00',1.55),('8975','2013-11-12','13:00:00',1.75),('8975','2013-11-12','13:05:00',1.87),('8975','2013-11-12','13:10:00',1.73),('8975','2013-11-12','13:15:00',1.68),('8975','2013-11-12','13:20:00',1.36),('8975','2013-11-12','13:25:00',1.21),('8975','2013-11-12','13:30:00',1.27),('8975','2013-11-12','13:35:00',1.34),('8975','2013-11-12','13:40:00',1.41),('8975','2013-11-12','13:45:00',1.22),('8975','2013-11-12','13:50:00',1.13),('8975','2013-11-12','13:55:00',1.34),('8975','2013-11-12','14:00:00',1.65),('8975','2013-11-12','14:05:00',1.72),('8975','2013-11-12','14:10:00',1.74),('8975','2013-11-12','14:15:00',1.75),('8975','2013-11-12','14:20:00',1.67),('8975','2013-11-12','14:25:00',1.76),('8975','2013-11-12','14:30:00',1.62),('8975','2013-11-12','14:35:00',1.33),('8975','2013-11-12','14:40:00',1.15),('8975','2013-11-12','14:45:00',1.01),('8975','2013-11-11','10:00:00',1.2),('8975','2013-11-11','10:55:00',1.09),('8975','2013-11-11','11:00:00',1.16),('8975','2013-11-11','11:10:00',1.26),('8975','2013-11-11','11:15:00',1.29),('8975','2013-11-11','11:20:00',1.31),('8975','2013-11-11','11:25:00',2.22),('8975','2013-11-11','11:30:00',1.43),('8975','2013-11-11','11:35:00',1.64),('8975','2013-11-11','11:40:00',2.08),('8975','2013-11-11','11:45:00',1.71),('8975','2013-11-11','11:50:00',1.87),('8975','2013-11-11','11:55:00',1.59),('8975','2013-11-11','12:00:00',3.09),('8975','2013-11-11','12:05:00',2.09),('8975','2013-11-11','12:10:00',1.27),('8975','2013-11-11','12:15:00',1.31),('8975','2013-11-11','12:20:00',1.37),('8975','2013-11-11','12:25:00',1.82),('8975','2013-11-11','12:30:00',2.86),('8975','2013-11-11','12:35:00',4.26),('8975','2013-11-11','12:40:00',3.07),('8975','2013-11-11','12:45:00',3.02),('8975','2013-11-11','12:50:00',2.79),('8975','2013-11-11','12:55:00',2.99),('8975','2013-11-11','13:00:00',2.7),('8975','2013-11-11','13:05:00',2.43),('8975','2013-11-11','13:10:00',2),('8975','2013-11-11','13:15:00',2.23),('8975','2013-11-11','13:20:00',2.52),('8975','2013-11-11','13:25:00',2.38),('8975','2013-11-11','13:30:00',2.59),('8975','2013-11-11','13:35:00',2.84),('8975','2013-11-11','13:40:00',2.93),('8975','2013-11-11','13:45:00',2.42),('8975','2013-11-11','13:50:00',1.93),('8975','2013-11-11','13:55:00',2.52),('8975','2013-11-11','14:00:00',1.86),('8975','2013-11-11','14:05:00',1.53),('8975','2013-11-11','14:10:00',2.25),('8975','2013-11-11','14:15:00',2.43),('8975','2013-11-11','14:20:00',2.38),('8975','2013-11-11','14:25:00',2.11),('8975','2013-11-11','14:30:00',1.45),('8975','2013-11-11','14:35:00',1.85),('8975','2013-11-11','14:40:00',1.17),('8975','2013-11-11','14:55:00',1.19),('8975','2013-11-11','15:00:00',1.06),('8975','2013-11-10','09:45:00',1.56),('8975','2013-11-10','09:50:00',1.78),('8975','2013-11-10','09:55:00',1.57),('8975','2013-11-10','10:00:00',1.14),('8975','2013-11-10','10:05:00',1.56),('8975','2013-11-10','10:10:00',2.51),('8975','2013-11-10','10:15:00',3.01),('8975','2013-11-10','10:20:00',2.35),('8975','2013-11-10','10:25:00',1.25),('8975','2013-11-10','10:30:00',1.05),('8975','2013-11-10','10:35:00',1.1),('8975','2013-11-10','11:00:00',2.31),('8975','2013-11-10','11:05:00',4.3),('8975','2013-11-10','11:10:00',4.43),('8975','2013-11-10','11:15:00',4.2),('8975','2013-11-10','11:20:00',1.67),('8975','2013-11-10','11:25:00',2.15),('8975','2013-11-10','11:30:00',4.71),('8975','2013-11-10','11:35:00',3.45),('8975','2013-11-10','11:40:00',3.71),('8975','2013-11-10','11:45:00',2.47),('8975','2013-11-10','11:50:00',3.59),('8975','2013-11-10','11:55:00',2.34),('8975','2013-11-10','12:00:00',2.49),('8975','2013-11-10','12:05:00',2.62),('8975','2013-11-10','12:10:00',3.45),('8975','2013-11-10','12:15:00',3.27),('8975','2013-11-10','12:20:00',3.03),('8975','2013-11-10','12:25:00',1.73),('8975','2013-11-10','12:30:00',1.2),('8975','2013-11-10','12:35:00',1.27),('8975','2013-11-10','12:40:00',2.74),('8975','2013-11-10','12:45:00',1.88),('8975','2013-11-10','12:50:00',3.12),('8975','2013-11-10','12:55:00',2.44),('8975','2013-11-10','13:00:00',2.32),('8975','2013-11-10','13:05:00',2.14),('8975','2013-11-10','13:10:00',2.08),('8975','2013-11-10','13:15:00',2.1),('8975','2013-11-10','13:30:00',1.23),('8975','2013-11-10','13:35:00',1.14),('8975','2013-11-10','13:40:00',1.29),('8975','2013-11-10','13:55:00',1.22),('8975','2013-11-10','14:00:00',2.32),('8975','2013-11-10','14:05:00',1.43),('8975','2013-11-10','14:10:00',1.4),('8975','2013-11-10','14:15:00',1.23),('8975','2013-11-10','14:20:00',1.08),('8975','2013-11-10','14:25:00',1.16),('8975','2013-11-10','14:30:00',1.49),('8975','2013-11-10','14:35:00',1.51),('8975','2013-11-10','14:40:00',1.1),('8975','2013-11-09','07:35:00',1.46),('8975','2013-11-09','07:40:00',1.6),('8975','2013-11-09','07:45:00',2.17),('8975','2013-11-09','07:50:00',2.18),('8975','2013-11-09','07:55:00',2.06),('8975','2013-11-09','08:00:00',2.41),('8975','2013-11-09','08:05:00',1.23),('8975','2013-11-09','08:10:00',1.04),('8975','2013-11-09','08:15:00',1.23),('8975','2013-11-09','08:20:00',1.35),('8975','2013-11-09','08:25:00',1.3),('8975','2013-11-09','08:30:00',2.04),('8975','2013-11-09','08:35:00',1.57),('8975','2013-11-09','08:40:00',1.64),('8975','2013-11-09','08:45:00',2.93),('8975','2013-11-09','08:50:00',2.95),('8975','2013-11-09','08:55:00',2.37),('8975','2013-11-09','09:00:00',2.37),('8975','2013-11-09','09:05:00',1.89),('8975','2013-11-09','09:10:00',1.62),('8975','2013-11-09','09:15:00',2.34),('8975','2013-11-09','09:20:00',2.92),('8975','2013-11-09','09:25:00',3.35),('8975','2013-11-09','09:30:00',2.71),('8975','2013-11-09','09:35:00',2.7),('8975','2013-11-09','09:40:00',3.14),('8975','2013-11-09','09:45:00',3.24),('8975','2013-11-09','09:50:00',2.89),('8975','2013-11-09','09:55:00',3.52),('8975','2013-11-09','10:00:00',3.4),('8975','2013-11-09','10:05:00',3.09),('8975','2013-11-09','10:10:00',2.33),('8975','2013-11-09','10:15:00',3.27),('8975','2013-11-09','10:20:00',1.94),('8975','2013-11-09','10:25:00',1.98),('8975','2013-11-09','10:30:00',3.14),('8975','2013-11-09','10:35:00',2.07),('8975','2013-11-09','10:40:00',2.31),('8975','2013-11-09','10:45:00',4.02),('8975','2013-11-09','10:50:00',3.75),('8975','2013-11-09','10:55:00',3.87),('8975','2013-11-09','11:00:00',1.69),('8975','2013-11-09','11:05:00',1.44),('8975','2013-11-09','11:10:00',1.44),('8975','2013-11-09','11:15:00',1.18),('8975','2013-11-09','11:20:00',1.52),('8975','2013-11-09','11:25:00',2.34),('8975','2013-11-09','11:30:00',1.57),('8975','2013-11-09','11:35:00',1.67),('8975','2013-11-09','11:40:00',2.99),('8975','2013-11-09','11:45:00',2.83),('8975','2013-11-09','11:50:00',1.82),('8975','2013-11-09','11:55:00',1.46),('8975','2013-11-09','12:00:00',1.28),('8975','2013-11-09','12:05:00',1.39),('8975','2013-11-09','12:15:00',2.28),('8975','2013-11-09','12:20:00',3.28),('8975','2013-11-09','12:25:00',3.27),('8975','2013-11-09','12:30:00',3.37),('8975','2013-11-09','12:35:00',1.11),('8975','2013-11-09','12:40:00',2.63),('8975','2013-11-09','12:45:00',3.27),('8975','2013-11-09','12:50:00',3.48),('8975','2013-11-09','12:55:00',2.91),('8975','2013-11-09','13:00:00',1.69),('8975','2013-11-09','13:05:00',1.09),('8975','2013-11-09','13:10:00',1.15),('8975','2013-11-09','13:35:00',1.12),('8975','2013-11-09','13:40:00',1.13),('8975','2013-11-09','13:45:00',1.3),('8975','2013-11-09','13:50:00',1.62),('8975','2013-11-09','13:55:00',1.5),('8975','2013-11-09','14:20:00',1.17),('8975','2013-11-09','14:25:00',1.03),('8975','2013-11-09','14:30:00',1.39),('8975','2013-11-08','09:10:00',1.31),('8975','2013-11-08','09:15:00',1.36),('8975','2013-11-08','09:20:00',1.02),('8975','2013-11-08','09:30:00',1.01),('8975','2013-11-08','09:40:00',2.09),('8975','2013-11-08','09:45:00',2.99),('8975','2013-11-08','09:50:00',4.43),('8975','2013-11-08','09:55:00',3.84),('8975','2013-11-08','10:00:00',3.95),('8975','2013-11-08','10:05:00',4.13),('8975','2013-11-08','10:10:00',3.28),('8975','2013-11-08','10:15:00',3.1),('8975','2013-11-08','10:20:00',2.8),('8975','2013-11-08','10:25:00',1.57),('8975','2013-11-08','10:30:00',1.78),('8975','2013-11-08','10:35:00',2.31),('8975','2013-11-08','10:40:00',2.23),('8975','2013-11-08','10:45:00',2.63),('8975','2013-11-08','10:50:00',2.6),('8975','2013-11-08','10:55:00',2.73),('8975','2013-11-08','11:00:00',3.77),('8975','2013-11-08','11:05:00',3.01),('8975','2013-11-08','11:10:00',3.74),('8975','2013-11-08','11:15:00',4.27),('8975','2013-11-08','11:20:00',4.34),('8975','2013-11-08','11:25:00',2.76),('8975','2013-11-08','11:30:00',3.43),('8975','2013-11-08','11:35:00',2.83),('8975','2013-11-08','11:40:00',2.11),('8975','2013-11-08','11:45:00',3.92),('8975','2013-11-08','11:50:00',2.52),('8975','2013-11-08','11:55:00',3.07),('8975','2013-11-08','12:00:00',4.2),('8975','2013-11-08','12:05:00',3.26),('8975','2013-11-08','12:10:00',2.23),('8975','2013-11-08','12:15:00',1.8),('8975','2013-11-08','12:20:00',2.1),('8975','2013-11-08','12:25:00',2.9),('8975','2013-11-08','12:30:00',3.74),('8975','2013-11-08','12:35:00',3.93),('8975','2013-11-08','12:40:00',2.54),('8975','2013-11-08','12:45:00',1.25),('8975','2013-11-08','12:50:00',1.68),('8975','2013-11-08','12:55:00',2.68),('8975','2013-11-08','13:00:00',2.42),('8975','2013-11-08','13:05:00',3.15),('8975','2013-11-08','13:10:00',2.38),('8975','2013-11-08','13:15:00',1.87),('8975','2013-11-08','13:20:00',2.27),('8975','2013-11-08','13:25:00',2.17),('8975','2013-11-08','13:30:00',2.12),('8975','2013-11-08','13:35:00',2.02),('8975','2013-11-08','13:40:00',1.9),('8975','2013-11-08','13:45:00',2.04),('8975','2013-11-08','13:50:00',2.06),('8975','2013-11-08','13:55:00',2.07),('8975','2013-11-08','14:00:00',1.85),('8975','2013-11-08','14:05:00',1.27),('8975','2013-11-08','14:15:00',1.28),('8975','2013-11-08','14:20:00',1.69),('8975','2013-11-08','14:25:00',1.24),('8975','2013-11-08','14:35:00',1),('8975','2013-11-08','14:40:00',1.49),('8975','2013-11-08','14:45:00',1.18),('8975','2013-11-08','14:50:00',1.11),('8975','2013-11-08','15:30:00',1.18),('8975','2013-11-08','15:35:00',1.15),('8975','2013-11-07','08:35:00',1.06),('8975','2013-11-07','08:40:00',2.13),('8975','2013-11-07','08:45:00',2.59),('8975','2013-11-07','08:50:00',1.25),('8975','2013-11-07','09:00:00',1.36),('8975','2013-11-07','09:05:00',2.06),('8975','2013-11-07','09:10:00',2.41),('8975','2013-11-07','09:15:00',1.18),('8975','2013-11-07','09:20:00',1.16),('8975','2013-11-07','09:30:00',1.29),('8975','2013-11-07','09:35:00',1.97),('8975','2013-11-07','09:40:00',4.15),('8975','2013-11-07','09:45:00',3.59),('8975','2013-11-07','09:50:00',3.33),('8975','2013-11-07','09:55:00',3.51),('8975','2013-11-07','10:00:00',3.82),('8975','2013-11-07','10:05:00',3.16),('8975','2013-11-07','10:10:00',2.13),('8975','2013-11-07','10:15:00',2.73),('8975','2013-11-07','10:20:00',2.96),('8975','2013-11-07','10:25:00',3.32),('8975','2013-11-07','10:30:00',1.6),('8975','2013-11-07','10:55:00',1.16),('8975','2013-11-07','11:00:00',1.78),('8975','2013-11-07','11:05:00',1.52),('8975','2013-11-07','11:10:00',1.9),('8975','2013-11-07','11:50:00',2.09),('8975','2013-11-07','11:55:00',1.02),('8975','2013-11-07','12:05:00',2.08),('8975','2013-11-07','12:10:00',3.41),('8975','2013-11-07','12:15:00',3.53),('8975','2013-11-07','12:20:00',3.54),('8975','2013-11-07','12:25:00',3.74),('8975','2013-11-07','12:30:00',3.69),('8975','2013-11-07','12:35:00',3.57),('8975','2013-11-07','12:40:00',3.37),('8975','2013-11-07','12:45:00',3.27),('8975','2013-11-07','12:50:00',3.18),('8975','2013-11-07','12:55:00',2.98),('8975','2013-11-07','13:00:00',1.41),('8975','2013-11-07','13:10:00',2.05),('8975','2013-11-07','13:15:00',2.59),('8975','2013-11-07','13:20:00',2.18),('8975','2013-11-07','13:25:00',1.73),('8975','2013-11-07','13:30:00',1.72),('8975','2013-11-07','13:35:00',1.02),('8975','2013-11-07','13:40:00',1.16),('8975','2013-11-07','13:45:00',1.08),('8975','2013-11-07','13:50:00',2.06),('8975','2013-11-07','13:55:00',1.92),('8975','2013-11-07','14:00:00',1.82),('8975','2013-11-07','14:05:00',1.71),('8975','2013-11-07','14:10:00',1.72),('8975','2013-11-07','14:15:00',1.66),('8975','2013-11-07','14:20:00',1.56),('8975','2013-11-07','14:25:00',1.45),('8975','2013-11-07','14:35:00',1.19),('8975','2013-11-07','14:40:00',1.41),('8975','2013-11-07','14:45:00',1.41),('8975','2013-11-07','15:20:00',1.11),('8975','2014-04-17','07:55:00',1.07),('8975','2014-04-17','08:00:00',1.83),('8975','2014-04-17','08:05:00',3.79),('8975','2014-04-17','08:10:00',3.98),('8975','2014-04-17','08:15:00',1.53),('8975','2014-04-17','08:20:00',1.13),('8975','2014-04-17','08:25:00',1.1),('8975','2014-04-17','08:30:00',1.16),('8975','2014-04-17','08:35:00',2.06),('8975','2014-04-17','08:40:00',2.3),('8975','2014-04-17','08:45:00',3.21),('8975','2014-04-17','08:50:00',2.16),('8975','2014-04-17','08:55:00',1.75),('8975','2014-04-17','09:00:00',1.9),('8975','2014-04-17','09:05:00',4.12),('8975','2014-04-17','09:10:00',6.07),('8975','2014-04-17','09:15:00',5.57),('8975','2014-04-17','09:20:00',5.44),('8975','2014-04-17','09:25:00',3.14),('8975','2014-04-17','09:30:00',5.8),('8975','2014-04-17','09:35:00',4.29),('8975','2014-04-17','09:40:00',2.29),('8975','2014-04-17','09:45:00',3.18),('8975','2014-04-17','09:50:00',4.65),('8975','2014-04-17','09:55:00',5.04),('8975','2014-04-17','10:00:00',4.72),('8975','2014-04-17','10:05:00',3.4),('8975','2014-04-17','10:10:00',2.63),('8975','2014-04-17','10:15:00',3.08),('8975','2014-04-17','10:20:00',2.45),('8975','2014-04-17','10:25:00',2.4),('8975','2014-04-17','10:30:00',2.13),('8975','2014-04-17','10:35:00',1.89),('8975','2014-04-17','10:40:00',2.05),('8975','2014-04-17','10:45:00',3.35),('8975','2014-04-17','10:50:00',3.42),('8975','2014-04-17','10:55:00',3.2),('8975','2014-04-17','11:00:00',3),('8975','2014-04-17','11:05:00',2.66),('8975','2014-04-17','11:10:00',2.84),('8975','2014-04-17','11:15:00',5.28),('8975','2014-04-17','11:20:00',3.47),('8975','2014-04-17','11:25:00',2.37),('8975','2014-04-17','11:30:00',2.64),('8975','2014-04-17','11:35:00',2.78),('8975','2014-04-17','11:40:00',2.71),('8975','2014-04-17','11:45:00',2.55),('8975','2014-04-17','11:50:00',2.95),('8975','2014-04-17','11:55:00',2.71),('8975','2014-04-17','12:00:00',2.92),('8975','2014-04-17','12:05:00',5.17),('8975','2014-04-17','12:10:00',7.25),('8975','2014-04-17','12:15:00',6.61),('8975','2014-04-17','12:20:00',4.46),('8975','2014-04-17','12:25:00',5.84),('8975','2014-04-17','12:30:00',6.73),('8975','2014-04-17','12:35:00',6.69),('8975','2014-04-17','12:40:00',7.15),('8975','2014-04-17','12:45:00',5.83),('8975','2014-04-17','12:50:00',6.68),('8975','2014-04-17','12:55:00',4.91),('8975','2014-04-17','13:00:00',4.64),('8975','2014-04-17','13:05:00',3.42),('8975','2014-04-17','13:10:00',3.47),('8975','2014-04-17','13:15:00',3.61),('8975','2014-04-17','13:20:00',3.27),('8975','2014-04-17','13:25:00',2.78),('8975','2014-04-17','13:30:00',2.28),('8975','2014-04-17','13:35:00',2.41),('8975','2014-04-17','13:40:00',2.25),('8975','2014-04-17','13:45:00',1.86),('8975','2014-04-17','13:50:00',1.92),('8975','2014-04-17','13:55:00',3.06),('8975','2014-04-17','14:00:00',3),('8975','2014-04-17','14:05:00',2.93),('8975','2014-04-17','14:10:00',2.46),('8975','2014-04-17','14:15:00',2.14),('8975','2014-04-17','14:20:00',2.44),('8975','2014-04-17','14:25:00',3.1),('8975','2014-04-17','14:30:00',3.42),('8975','2014-04-17','14:35:00',3.62),('8975','2014-04-17','14:40:00',3.14),('8975','2014-04-17','14:45:00',3.57),('8975','2014-04-17','14:50:00',4.21),('8975','2014-04-17','14:55:00',3.82),('8975','2014-04-17','15:00:00',5.01),('8975','2014-04-17','15:05:00',4.53),('8975','2014-04-17','15:10:00',2.89),('8975','2014-04-17','15:15:00',3.17),('8975','2014-04-17','15:20:00',2.76),('8975','2014-04-17','15:25:00',3.54),('8975','2014-04-17','15:30:00',5.53),('8975','2014-04-17','15:35:00',5.03),('8975','2014-04-17','15:40:00',4.61),('8975','2014-04-17','15:45:00',2.18),('8975','2014-04-17','15:50:00',3.13),('8975','2014-04-17','15:55:00',3.15),('8975','2014-04-17','16:00:00',3.18),('8975','2014-04-17','16:05:00',2.68),('8975','2014-04-17','16:10:00',2.33),('8975','2014-04-17','16:15:00',2.08),('8975','2014-04-17','16:20:00',1.98),('8975','2014-04-17','16:25:00',3.37),('8975','2014-04-17','16:30:00',3.36),('8975','2014-04-17','16:35:00',4.09),('8975','2014-04-17','16:40:00',3.37),('8975','2014-04-17','16:45:00',2.22),('8975','2014-04-17','16:50:00',2.44),('8975','2014-04-17','16:55:00',2.54),('8975','2014-04-17','17:00:00',2.31),('8975','2014-04-17','17:05:00',3.19),('8975','2014-04-17','17:10:00',2.51),('8975','2014-04-17','17:15:00',2.23),('8975','2014-04-17','17:20:00',1.97),('8975','2014-04-17','17:25:00',2.02),('8975','2014-04-17','17:30:00',1.83),('8975','2014-04-17','17:35:00',1.77),('8975','2014-04-17','17:40:00',1.7),('8975','2014-04-17','17:45:00',1.62),('8975','2014-04-17','17:50:00',1.57),('8975','2014-04-17','17:55:00',1.52),('8975','2014-04-17','18:00:00',1.47),('8975','2014-04-17','18:05:00',1.41),('8975','2014-04-17','18:10:00',1.36),('8975','2014-04-17','18:15:00',1.3),('8975','2014-04-17','18:20:00',1.22),('8975','2014-04-17','18:25:00',1.11),('8975','2013-11-06','07:20:00',1.04),('8975','2013-11-06','07:25:00',1.24),('8975','2013-11-06','07:30:00',1.41),('8975','2013-11-06','07:35:00',1.59),('8975','2013-11-06','07:40:00',1.74),('8975','2013-11-06','07:45:00',1.85),('8975','2013-11-06','07:50:00',1.95),('8975','2013-11-06','07:55:00',2.05),('8975','2013-11-06','08:00:00',2.14),('8975','2013-11-06','08:05:00',2.24),('8975','2013-11-06','08:10:00',2.32),('8975','2013-11-06','08:15:00',2.4),('8975','2013-11-06','08:20:00',2.46),('8975','2013-11-06','08:25:00',2.53),('8975','2013-11-06','08:30:00',2.59),('8975','2013-11-06','08:35:00',2.65),('8975','2013-11-06','08:40:00',2.72),('8975','2013-11-06','08:45:00',2.8),('8975','2013-11-06','08:50:00',2.85),('8975','2013-11-06','08:55:00',2.92),('8975','2013-11-06','09:00:00',2.99),('8975','2013-11-06','09:05:00',3.04),('8975','2013-11-06','09:10:00',3.06),('8975','2013-11-06','09:15:00',3.09),('8975','2013-11-06','09:20:00',3.11),('8975','2013-11-06','09:25:00',3.18),('8975','2013-11-06','09:30:00',3.25),('8975','2013-11-06','09:35:00',3.3),('8975','2013-11-06','09:40:00',3.37),('8975','2013-11-06','09:45:00',3.42),('8975','2013-11-06','09:50:00',3.33),('8975','2013-11-06','09:55:00',3.41),('8975','2013-11-06','10:00:00',3.43),('8975','2013-11-06','10:05:00',3.41),('8975','2013-11-06','10:10:00',3.44),('8975','2013-11-06','10:15:00',3.43),('8975','2013-11-06','10:20:00',3.44),('8975','2013-11-06','10:25:00',3.5),('8975','2013-11-06','10:30:00',3.53),('8975','2013-11-06','10:35:00',3.5),('8975','2013-11-06','10:40:00',3.54),('8975','2013-11-06','10:45:00',3.51),('8975','2013-11-06','10:50:00',3.48),('8975','2013-11-06','10:55:00',3.47),('8975','2013-11-06','11:00:00',3.48),('8975','2013-11-06','11:05:00',3.48),('8975','2013-11-06','11:10:00',3.46),('8975','2013-11-06','11:15:00',3.24),('8975','2013-11-06','11:20:00',3.07),('8975','2013-11-06','11:25:00',3.3),('8975','2013-11-06','11:30:00',3.24),('8975','2013-11-06','11:35:00',3.17),('8975','2013-11-06','11:40:00',3.25),('8975','2013-11-06','11:45:00',3.2),('8975','2013-11-06','11:50:00',3.14),('8975','2013-11-06','11:55:00',3.08),('8975','2013-11-06','12:00:00',3.1),('8975','2013-11-06','12:05:00',3.06),('8975','2013-11-06','12:10:00',2.99),('8975','2013-11-06','12:15:00',2.96),('8975','2013-11-06','12:20:00',2.89),('8975','2013-11-06','12:25:00',2.8),('8975','2013-11-06','12:30:00',2.71),('8975','2013-11-06','12:35:00',2.75),('8975','2013-11-06','12:40:00',2.47),('8975','2013-11-06','12:45:00',2.79),('8975','2013-11-06','12:50:00',2.63),('8975','2013-11-06','12:55:00',2.7),('8975','2013-11-06','13:00:00',2.17),('8975','2013-11-06','13:05:00',2.98),('8975','2013-11-06','13:10:00',2.64),('8975','2013-11-06','13:15:00',2.14),('8975','2013-11-06','13:20:00',2.77),('8975','2013-11-06','13:25:00',3.16),('8975','2013-11-06','13:30:00',3.09),('8975','2013-11-06','13:35:00',2.61),('8975','2013-11-06','13:40:00',2.54),('8975','2013-11-06','13:45:00',2.14),('8975','2013-11-06','13:50:00',1.63),('8975','2013-11-06','13:55:00',1.66),('8975','2013-11-06','14:00:00',2.08),('8975','2013-11-06','14:05:00',1.55),('8975','2013-11-06','14:10:00',1.21),('8975','2013-11-06','14:15:00',1.22),('8975','2013-11-06','14:20:00',1.27),('8975','2013-11-06','14:25:00',1.56),('8975','2013-11-06','14:30:00',1.87),('8975','2013-11-06','14:35:00',1.63),('8975','2013-11-06','14:40:00',1.36),('8975','2013-11-06','14:45:00',1.34),('8975','2013-11-06','14:50:00',1.3),('8975','2013-11-06','14:55:00',1.25),('8975','2013-11-06','15:00:00',1.2),('8975','2013-11-06','15:05:00',1.18),('8975','2013-11-06','15:10:00',1.12),('8975','2013-11-06','15:15:00',1.09),('8975','2013-11-06','15:20:00',1.08),('8975','2013-11-06','15:25:00',1.02),('8975','2013-11-05','08:00:00',1.64),('8975','2013-11-05','08:05:00',1.89),('8975','2013-11-05','08:10:00',2.39),('8975','2013-11-05','08:15:00',2.69),('8975','2013-11-05','08:20:00',2.25),('8975','2013-11-05','08:25:00',1.16),('8975','2013-11-05','08:35:00',2.82),('8975','2013-11-05','08:40:00',2.87),('8975','2013-11-05','08:45:00',2.93),('8975','2013-11-05','08:50:00',3.1),('8975','2013-11-05','08:55:00',3.06),('8975','2013-11-05','09:00:00',1.92),('8975','2013-11-05','09:05:00',1.94),('8975','2013-11-05','09:10:00',2.05),('8975','2013-11-05','09:15:00',2.64),('8975','2013-11-05','09:20:00',2.73),('8975','2013-11-05','09:25:00',3.3),('8975','2013-11-05','09:30:00',3.42),('8975','2013-11-05','09:35:00',3.47),('8975','2013-11-05','09:40:00',3.53),('8975','2013-11-05','09:45:00',3.52),('8975','2013-11-05','09:50:00',3.5),('8975','2013-11-05','09:55:00',3.57),('8975','2013-11-05','10:00:00',3.6),('8975','2013-11-05','10:05:00',3.64),('8975','2013-11-05','10:10:00',3.68),('8975','2013-11-05','10:15:00',3.71),('8975','2013-11-05','10:20:00',3.74),('8975','2013-11-05','10:25:00',3.79),('8975','2013-11-05','10:30:00',3.79),('8975','2013-11-05','10:35:00',3.79),('8975','2013-11-05','10:40:00',3.78),('8975','2013-11-05','10:45:00',3.78),('8975','2013-11-05','10:50:00',3.78),('8975','2013-11-05','10:55:00',3.79),('8975','2013-11-05','11:00:00',3.79),('8975','2013-11-05','11:05:00',3.74),('8975','2013-11-05','11:10:00',3.72),('8975','2013-11-05','11:15:00',3.44),('8975','2013-11-05','11:20:00',3.31),('8975','2013-11-05','11:25:00',3.59),('8975','2013-11-05','11:30:00',3.49),('8975','2013-11-05','11:35:00',3.44),('8975','2013-11-05','11:40:00',3.51),('8975','2013-11-05','11:45:00',3.49),('8975','2013-11-05','11:50:00',3.43),('8975','2013-11-05','11:55:00',3.37),('8975','2013-11-05','12:00:00',3.37),('8975','2013-11-05','12:05:00',3.31),('8975','2013-11-05','12:10:00',3.31),('8975','2013-11-05','12:15:00',3.2),('8975','2013-11-05','12:20:00',3.18),('8975','2013-11-05','12:25:00',3.02),('8975','2013-11-05','12:30:00',2.87),('8975','2013-11-05','12:35:00',2.98),('8975','2013-11-05','12:40:00',2.98),('8975','2013-11-05','12:45:00',2.95),('8975','2013-11-05','12:50:00',2.87),('8975','2013-11-05','12:55:00',2.81),('8975','2013-11-05','13:00:00',2.75),('8975','2013-11-05','13:05:00',2.57),('8975','2013-11-05','13:10:00',2.5),('8975','2013-11-05','13:15:00',2.42),('8975','2013-11-05','13:20:00',2.36),('8975','2013-11-05','13:25:00',2.33),('8975','2013-11-05','13:30:00',2.15),('8975','2013-11-05','13:35:00',2.05),('8975','2013-11-05','13:40:00',2.08),('8975','2013-11-05','13:45:00',2.02),('8975','2013-11-05','13:50:00',1.92),('8975','2013-11-05','13:55:00',1.91),('8975','2013-11-05','14:00:00',1.84),('8975','2013-11-05','14:05:00',1.76),('8975','2013-11-05','14:10:00',1.67),('8975','2013-11-05','14:15:00',1.61),('8975','2013-11-05','14:20:00',1.54),('8975','2013-11-05','14:25:00',1.48),('8975','2013-11-05','14:30:00',1.43),('8975','2013-11-05','14:35:00',1.36),('8975','2013-11-05','14:40:00',1.31),('8975','2013-11-05','14:45:00',1.29),('8975','2013-11-05','14:50:00',1.26),('8975','2013-11-05','14:55:00',1.24),('8975','2013-11-05','15:00:00',1.2),('8975','2013-11-05','15:05:00',1.18),('8975','2013-11-05','15:10:00',1.16),('8975','2013-11-05','15:15:00',1.13),('8975','2013-11-05','15:20:00',1.09),('8975','2013-11-05','15:25:00',1.05),('8975','2013-11-05','15:30:00',1.01),('8975','2013-11-04','08:15:00',1.17),('8975','2013-11-04','08:20:00',1.02),('8975','2013-11-04','08:25:00',2.56),('8975','2013-11-04','08:30:00',2.81),('8975','2013-11-04','08:35:00',3.28),('8975','2013-11-04','08:40:00',3.33),('8975','2013-11-04','08:45:00',1.93),('8975','2013-11-04','08:50:00',1.13),('8975','2013-11-04','09:55:00',1.13),('8975','2013-11-04','10:00:00',1.24),('8975','2013-11-04','10:05:00',1.02),('8975','2013-11-04','10:10:00',1.04),('8975','2013-11-04','10:15:00',2.06),('8975','2013-11-04','10:20:00',3.69),('8975','2013-11-04','10:25:00',3.76),('8975','2013-11-04','10:30:00',2.4),('8975','2013-11-04','10:35:00',2.5),('8975','2013-11-04','10:40:00',2.11),('8975','2013-11-04','10:45:00',2.29),('8975','2013-11-04','10:50:00',2.06),('8975','2013-11-04','10:55:00',1.89),('8975','2013-11-04','11:00:00',1.6),('8975','2013-11-04','11:05:00',1.24),('8975','2013-11-04','11:20:00',1.02),('8975','2013-11-04','11:25:00',1.19),('8975','2013-11-04','11:30:00',1.38),('8975','2013-11-04','11:35:00',1.88),('8975','2013-11-04','11:40:00',2.28),('8975','2013-11-04','11:45:00',2.15),('8975','2013-11-04','11:50:00',2),('8975','2013-11-04','11:55:00',1.86),('8975','2013-11-04','12:00:00',2),('8975','2013-11-04','12:05:00',2.33),('8975','2013-11-04','12:10:00',2.41),('8975','2013-11-04','12:15:00',2.16),('8975','2013-11-04','12:20:00',2.08),('8975','2013-11-04','12:25:00',2.09),('8975','2013-11-04','12:30:00',1.94),('8975','2013-11-04','12:35:00',1.67),('8975','2013-11-04','12:40:00',1.46),('8975','2013-11-04','12:45:00',1.17),('8975','2013-11-04','12:50:00',1.15),('8975','2013-11-04','12:55:00',1.39),('8975','2013-11-04','13:00:00',1.38),('8975','2013-11-04','13:05:00',1.32),('8975','2013-11-04','13:10:00',1.31),('8975','2013-11-04','13:25:00',1.28),('8975','2013-11-04','13:30:00',1.95),('8975','2013-11-04','13:35:00',2.61),('8975','2013-11-04','13:40:00',2.48),('8975','2013-11-04','13:45:00',2.25),('8975','2013-11-04','13:50:00',2.28),('8975','2013-11-04','13:55:00',3.19),('8975','2013-11-04','14:00:00',2.51),('8975','2013-11-04','14:05:00',1.81),('8975','2013-11-04','14:10:00',1.06),('8975','2013-11-04','14:25:00',1.55),('8975','2013-11-04','14:30:00',2.16),('8975','2013-11-04','14:35:00',1.91),('8975','2013-11-04','14:40:00',1.75),('8975','2013-11-04','14:45:00',1.48),('8975','2013-11-04','15:00:00',1.05),('8975','2013-11-03','07:50:00',1.87),('8975','2013-11-03','07:55:00',2.02),('8975','2013-11-03','08:00:00',2.1),('8975','2013-11-03','08:05:00',2.16),('8975','2013-11-03','08:10:00',2.24),('8975','2013-11-03','08:15:00',2.35),('8975','2013-11-03','08:20:00',2.44),('8975','2013-11-03','08:25:00',2.52),('8975','2013-11-03','08:30:00',2.53),('8975','2013-11-03','08:35:00',2.36),('8975','2013-11-03','08:40:00',2.35),('8975','2013-11-03','08:45:00',1.66),('8975','2013-11-03','08:50:00',1.26),('8975','2013-11-03','09:10:00',1.43),('8975','2013-11-03','09:15:00',1.26),('8975','2013-11-03','09:20:00',3.74),('8975','2013-11-03','09:25:00',3.14),('8975','2013-11-03','10:00:00',2.15),('8975','2013-11-03','10:05:00',3.53),('8975','2013-11-03','10:10:00',3.59),('8975','2013-11-03','10:15:00',3.88),('8975','2013-11-03','10:20:00',3.97),('8975','2013-11-03','10:25:00',3.39),('8975','2013-11-03','10:30:00',2.72),('8975','2013-11-03','10:35:00',2.89),('8975','2013-11-03','10:40:00',2.4),('8975','2013-11-03','10:45:00',1.73),('8975','2013-11-03','10:50:00',2.04),('8975','2013-11-03','10:55:00',3.12),('8975','2013-11-03','11:00:00',4.02),('8975','2013-11-03','11:05:00',4.47),('8975','2013-11-03','11:10:00',4.86),('8975','2013-11-03','11:15:00',3.76),('8975','2013-11-03','11:20:00',2.55),('8975','2013-11-03','11:25:00',2.89),('8975','2013-11-03','11:30:00',2.54),('8975','2013-11-03','11:35:00',2.51),('8975','2013-11-03','11:40:00',2.68),('8975','2013-11-03','11:45:00',2.48),('8975','2013-11-03','11:50:00',4.01),('8975','2013-11-03','11:55:00',3.84),('8975','2013-11-03','12:00:00',3.85),('8975','2013-11-03','12:05:00',3.53),('8975','2013-11-03','12:10:00',3.33),('8975','2013-11-03','12:15:00',3.49),('8975','2013-11-03','12:20:00',3.45),('8975','2013-11-03','12:25:00',3.29),('8975','2013-11-03','12:30:00',3.33),('8975','2013-11-03','12:35:00',2.95),('8975','2013-11-03','12:40:00',3.22),('8975','2013-11-03','12:45:00',2.81),('8975','2013-11-03','12:50:00',3.1),('8975','2013-11-03','12:55:00',2.98),('8975','2013-11-03','13:00:00',2.9),('8975','2013-11-03','13:05:00',2.74),('8975','2013-11-03','13:10:00',2.53),('8975','2013-11-03','13:15:00',2.66),('8975','2013-11-03','13:20:00',2.46),('8975','2013-11-03','13:25:00',2.27),('8975','2013-11-03','13:30:00',1.94),('8975','2013-11-03','13:35:00',2.05),('8975','2013-11-03','13:40:00',1.58),('8975','2013-11-03','13:45:00',2.21),('8975','2013-11-03','13:50:00',2.17),('8975','2013-11-03','13:55:00',1.62),('8975','2013-11-03','14:00:00',1.9),('8975','2013-11-03','14:05:00',2.03),('8975','2013-11-03','14:10:00',1.75),('8975','2013-11-03','14:15:00',2),('8975','2013-11-03','14:20:00',2.1),('8975','2013-11-03','14:25:00',1.61),('8975','2013-11-03','14:30:00',1.29),('8975','2013-11-03','14:35:00',1.49),('8975','2013-11-03','14:40:00',1.42),('8975','2013-11-03','14:45:00',1.55),('8975','2013-11-03','14:50:00',1.02),('8975','2013-11-03','14:55:00',1.58),('8975','2013-11-03','15:00:00',1.33),('8975','2013-11-03','15:10:00',1.31),('8975','2013-11-03','15:15:00',1.05),('8975','2013-11-03','15:20:00',1.16),('8975','2013-11-03','15:25:00',1.44),('8975','2013-11-03','15:30:00',1.4),('8975','2013-11-03','15:35:00',1.11),('8975','2013-11-03','15:40:00',1.41),('8975','2013-11-03','15:45:00',1.34),('8975','2013-11-02','07:30:00',1.62),('8975','2013-11-02','07:35:00',1.63),('8975','2013-11-02','07:40:00',1.57),('8975','2013-11-02','07:45:00',2.07),('8975','2013-11-02','07:50:00',1.34),('8975','2013-11-02','07:55:00',1.47),('8975','2013-11-02','08:00:00',1.8),('8975','2013-11-02','08:05:00',1.68),('8975','2013-11-02','08:10:00',1.48),('8975','2013-11-02','08:15:00',1.57),('8975','2013-11-02','08:20:00',2.25),('8975','2013-11-02','08:25:00',1.95),('8975','2013-11-02','08:30:00',1.73),('8975','2013-11-02','08:35:00',2.16),('8975','2013-11-02','08:40:00',2.46),('8975','2013-11-02','08:45:00',2.46),('8975','2013-11-02','08:50:00',1.65),('8975','2013-11-02','08:55:00',2.03),('8975','2013-11-02','09:00:00',2.12),('8975','2013-11-02','09:05:00',2.95),('8975','2013-11-02','09:10:00',1.2),('8975','2013-11-02','09:35:00',1.42),('8975','2013-11-02','09:40:00',3.61),('8975','2013-11-02','09:45:00',3.32),('8975','2013-11-02','09:50:00',1.25),('8975','2013-11-02','10:05:00',2.72),('8975','2013-11-02','10:10:00',2.53),('8975','2013-11-02','10:15:00',1.43),('8975','2013-11-02','10:20:00',3.22),('8975','2013-11-02','10:25:00',2.99),('8975','2013-11-02','10:30:00',2.48),('8975','2013-11-02','11:10:00',1.11),('8975','2013-11-02','11:15:00',1.3),('8975','2013-11-02','11:20:00',2.04),('8975','2013-11-02','11:25:00',1.2),('8975','2013-11-02','11:30:00',2.18),('8975','2013-11-02','11:35:00',2.68),('8975','2013-11-02','11:40:00',3.49),('8975','2013-11-02','11:45:00',3.64),('8975','2013-11-02','11:50:00',3.87),('8975','2013-11-02','11:55:00',4.35),('8975','2013-11-02','12:00:00',4.29),('8975','2013-11-02','12:05:00',4.06),('8975','2013-11-02','12:10:00',4.13),('8975','2013-11-02','12:15:00',3.85),('8975','2013-11-02','12:20:00',4.14),('8975','2013-11-02','12:25:00',3.91),('8975','2013-11-02','12:30:00',3.68),('8975','2013-11-02','12:35:00',2.57),('8975','2013-11-02','12:40:00',1.72),('8975','2013-11-02','12:45:00',1.44),('8975','2013-11-02','12:50:00',1.26),('8975','2013-11-02','13:10:00',1.13),('8975','2013-11-02','13:15:00',1.21),('8975','2013-11-02','13:20:00',1.29),('8975','2013-11-02','13:25:00',1.62),('8975','2013-11-02','13:30:00',1.55),('8975','2013-11-02','13:35:00',1.23),('8975','2013-11-02','13:40:00',1.39),('8975','2013-11-02','13:45:00',1.65),('8975','2013-11-02','13:50:00',1.9),('8975','2013-11-02','13:55:00',2.07),('8975','2013-11-02','14:00:00',1.88),('8975','2013-11-02','14:05:00',2.01),('8975','2013-11-02','14:10:00',1.54),('8975','2013-11-02','14:15:00',1.4),('8975','2013-11-02','14:20:00',1.5),('8975','2013-11-02','14:25:00',1.29),('8975','2013-11-02','14:30:00',1.29),('8975','2013-11-02','14:35:00',1.02),('8975','2013-11-02','14:40:00',1.1),('8975','2013-11-02','15:10:00',1.01),('8975','2013-11-02','15:15:00',1.31),('8975','2013-11-01','07:50:00',1.78),('8975','2013-11-01','07:55:00',1.91),('8975','2013-11-01','08:00:00',2.08),('8975','2013-11-01','08:05:00',2.14),('8975','2013-11-01','08:10:00',2.21),('8975','2013-11-01','08:15:00',2.28),('8975','2013-11-01','08:20:00',2.35),('8975','2013-11-01','08:25:00',2.45),('8975','2013-11-01','08:30:00',2.53),('8975','2013-11-01','08:35:00',2.59),('8975','2013-11-01','08:40:00',2.67),('8975','2013-11-01','08:45:00',2.77),('8975','2013-11-01','08:50:00',2.83),('8975','2013-11-01','08:55:00',2.92),('8975','2013-11-01','09:00:00',3.02),('8975','2013-11-01','09:05:00',3.32),('8975','2013-11-01','09:10:00',3.42),('8975','2013-11-01','09:15:00',2.79),('8975','2013-11-01','09:20:00',1.19),('8975','2013-11-01','09:25:00',1.27),('8975','2013-11-01','09:30:00',2.45),('8975','2013-11-01','09:35:00',2.24),('8975','2013-11-01','09:40:00',3.03),('8975','2013-11-01','09:45:00',2.58),('8975','2013-11-01','09:50:00',1.38),('8975','2013-11-01','09:55:00',3),('8975','2013-11-01','10:00:00',3.78),('8975','2013-11-01','10:05:00',4.19),('8975','2013-11-01','10:10:00',2.57),('8975','2013-11-01','10:15:00',1.99),('8975','2013-11-01','10:20:00',1.37),('8975','2013-11-01','10:25:00',1.11),('8975','2013-11-01','10:30:00',1.28),('8975','2013-11-01','10:35:00',1.62),('8975','2013-11-01','10:40:00',1.24),('8975','2013-11-01','10:50:00',1.34),('8975','2013-11-01','10:55:00',1.99),('8975','2013-11-01','11:00:00',2.23),('8975','2013-11-01','11:05:00',1.87),('8975','2013-11-01','11:10:00',1.22),('8975','2013-11-01','11:30:00',1.13),('8975','2013-11-01','11:35:00',1.34),('8975','2013-11-01','11:40:00',1.49),('8975','2013-11-01','11:45:00',1.51),('8975','2013-11-01','11:50:00',2.94),('8975','2013-11-01','11:55:00',3.5),('8975','2013-11-01','12:00:00',4.25),('8975','2013-11-01','12:05:00',2.38),('8975','2013-11-01','12:10:00',2.57),('8975','2013-11-01','12:15:00',3.69),('8975','2013-11-01','12:20:00',3.46),('8975','2013-11-01','12:25:00',3.23),('8975','2013-11-01','12:30:00',3.44),('8975','2013-11-01','12:35:00',3.28),('8975','2013-11-01','12:40:00',3.31),('8975','2013-11-01','12:45:00',3.37),('8975','2013-11-01','12:50:00',2.86),('8975','2013-11-01','12:55:00',3.21),('8975','2013-11-01','13:00:00',3.14),('8975','2013-11-01','13:05:00',3.25),('8975','2013-11-01','13:10:00',2.96),('8975','2013-11-01','13:15:00',1.91),('8975','2013-11-01','13:20:00',1.65),('8975','2013-11-01','13:25:00',2.51),('8975','2013-11-01','13:30:00',2.5),('8975','2013-11-01','13:35:00',2.16),('8975','2013-11-01','13:40:00',2.76),('8975','2013-11-01','13:45:00',2.6),('8975','2013-11-01','13:50:00',2.65),('8975','2013-11-01','13:55:00',2.71),('8975','2013-11-01','14:00:00',2.28),('8975','2013-11-01','14:05:00',2.04),('8975','2013-11-01','14:10:00',1.93),('8975','2013-11-01','14:15:00',1.82),('8975','2013-11-01','14:20:00',1.71),('8975','2013-11-01','14:25:00',1.62),('8975','2013-11-01','14:30:00',1.54),('8975','2013-11-01','14:35:00',1.48),('8975','2013-11-01','14:40:00',1.42),('8975','2013-11-01','14:45:00',1.42),('8975','2013-11-01','14:50:00',1.4),('8975','2013-11-01','14:55:00',1.35),('8975','2013-11-01','15:00:00',1.29),('8975','2013-11-01','15:05:00',1.29),('8975','2013-11-01','15:10:00',1.21),('8975','2013-11-01','15:30:00',1.1),('8975','2013-11-01','15:40:00',1.07),('8975','2013-11-01','15:45:00',1.1),('8975','2013-11-01','15:50:00',1.13),('8975','2013-10-31','07:20:00',1.04),('8975','2013-10-31','07:25:00',1.19),('8975','2013-10-31','07:30:00',1.36),('8975','2013-10-31','07:35:00',1.48),('8975','2013-10-31','07:40:00',1.54),('8975','2013-10-31','07:45:00',1.7),('8975','2013-10-31','07:50:00',1.64),('8975','2013-10-31','07:55:00',1.46),('8975','2013-10-31','08:00:00',1.61),('8975','2013-10-31','08:05:00',1.59),('8975','2013-10-31','08:10:00',1.46),('8975','2013-10-31','08:15:00',1.92),('8975','2013-10-31','08:20:00',2.14),('8975','2013-10-31','08:25:00',2.26),('8975','2013-10-31','08:30:00',2.45),('8975','2013-10-31','08:35:00',2.58),('8975','2013-10-31','08:40:00',2.73),('8975','2013-10-31','08:45:00',2.75),('8975','2013-10-31','08:50:00',2.8),('8975','2013-10-31','08:55:00',2.72),('8975','2013-10-31','09:00:00',2.82),('8975','2013-10-31','09:05:00',3.04),('8975','2013-10-31','09:10:00',3.08),('8975','2013-10-31','09:15:00',3.12),('8975','2013-10-31','09:20:00',3.18),('8975','2013-10-31','09:25:00',3.25),('8975','2013-10-31','09:30:00',3.32),('8975','2013-10-31','09:35:00',3.4),('8975','2013-10-31','09:40:00',3.45),('8975','2013-10-31','09:45:00',3.38),('8975','2013-10-31','09:50:00',3.49),('8975','2013-10-31','09:55:00',3.51),('8975','2013-10-31','10:00:00',3.57),('8975','2013-10-31','10:05:00',3.61),('8975','2013-10-31','10:10:00',3.65),('8975','2013-10-31','10:15:00',3.62),('8975','2013-10-31','10:20:00',3.65),('8975','2013-10-31','10:25:00',3.71),('8975','2013-10-31','10:30:00',3.62),('8975','2013-10-31','10:35:00',3.69),('8975','2013-10-31','10:40:00',3.42),('8975','2013-10-31','10:45:00',3.61),('8975','2013-10-31','10:50:00',3.67),('8975','2013-10-31','10:55:00',3.72),('8975','2013-10-31','11:00:00',3.41),('8975','2013-10-31','11:05:00',2.97),('8975','2013-10-31','11:10:00',3.4),('8975','2013-10-31','11:15:00',3.51),('8975','2013-10-31','11:20:00',3.75),('8975','2013-10-31','11:25:00',3.85),('8975','2013-10-31','11:30:00',3.66),('8975','2013-10-31','11:35:00',3.51),('8975','2013-10-31','11:40:00',3.16),('8975','2013-10-31','11:45:00',3.26),('8975','2013-10-31','11:50:00',3.54),('8975','2013-10-31','11:55:00',3.62),('8975','2013-10-31','12:00:00',3.62),('8975','2013-10-31','12:05:00',3.48),('8975','2013-10-31','12:10:00',3.34),('8975','2013-10-31','12:15:00',1.36),('8975','2013-10-31','12:20:00',1.16),('8975','2013-10-31','12:25:00',1.28),('8975','2013-10-31','12:30:00',1.18),('8975','2013-10-31','13:05:00',1.02),('8975','2013-10-31','13:10:00',1.29),('8975','2013-10-31','13:15:00',1.64),('8975','2013-10-31','13:20:00',1.8),('8975','2013-10-31','13:25:00',1.37),('8975','2013-10-31','13:30:00',1.52),('8975','2013-10-31','13:35:00',1.41),('8975','2013-10-31','13:40:00',1.44),('8975','2013-10-31','13:45:00',1.31),('8975','2013-10-31','13:50:00',1.27),('8975','2013-10-31','13:55:00',1.21),('8975','2013-10-31','14:00:00',1.18),('8975','2013-10-31','14:05:00',1.16),('8975','2013-10-31','14:10:00',1.07),('8975','2013-10-31','14:15:00',1.05),('8975','2013-10-30','08:10:00',1.05),('8975','2013-10-30','08:15:00',1.68),('8975','2013-10-30','08:20:00',2.08),('8975','2013-10-30','08:25:00',2.35),('8975','2013-10-30','08:30:00',2.38),('8975','2013-10-30','08:35:00',2.42),('8975','2013-10-30','08:40:00',2.63),('8975','2013-10-30','08:45:00',1.79),('8975','2013-10-30','08:50:00',1.78),('8975','2013-10-30','08:55:00',2.2),('8975','2013-10-30','09:00:00',1.77),('8975','2013-10-30','09:05:00',1.88),('8975','2013-10-30','09:10:00',1.5),('8975','2013-10-30','09:15:00',2.47),('8975','2013-10-30','09:20:00',2.64),('8975','2013-10-30','09:25:00',2.87),('8975','2013-10-30','09:30:00',2.22),('8975','2013-10-30','09:35:00',2.08),('8975','2013-10-30','09:40:00',1.76),('8975','2013-10-30','09:45:00',2.11),('8975','2013-10-30','09:50:00',2.61),('8975','2013-10-30','09:55:00',2.74),('8975','2013-10-30','10:00:00',2.76),('8975','2013-10-30','10:05:00',2.58),('8975','2013-10-30','10:10:00',2.48),('8975','2013-10-30','10:15:00',2.3),('8975','2013-10-30','10:20:00',2.31),('8975','2013-10-30','10:25:00',2.39),('8975','2013-10-30','10:30:00',2.67),('8975','2013-10-30','10:35:00',2.74),('8975','2013-10-30','10:40:00',2.55),('8975','2013-10-30','10:45:00',2.48),('8975','2013-10-30','10:50:00',2.61),('8975','2013-10-30','10:55:00',2.92),('8975','2013-10-30','11:00:00',3.8),('8975','2013-10-30','11:05:00',3.73),('8975','2013-10-30','11:10:00',2.96),('8975','2013-10-30','11:15:00',3.81),('8975','2013-10-30','11:20:00',3.37),('8975','2013-10-30','11:25:00',3.34),('8975','2013-10-30','11:30:00',3.15),('8975','2013-10-30','11:35:00',3.31),('8975','2013-10-30','11:40:00',3.59),('8975','2013-10-30','11:45:00',3.58),('8975','2013-10-30','11:50:00',3.53),('8975','2013-10-30','11:55:00',3.48),('8975','2013-10-30','12:00:00',3.46),('8975','2013-10-30','12:05:00',3.4),('8975','2013-10-30','12:10:00',3.27),('8975','2013-10-30','12:15:00',3.31),('8975','2013-10-30','12:20:00',3.24),('8975','2013-10-30','12:25:00',3.19),('8975','2013-10-30','12:30:00',2.98),('8975','2013-10-30','12:35:00',2.99),('8975','2013-10-30','12:40:00',3.01),('8975','2013-10-30','12:45:00',3.05),('8975','2013-10-30','12:50:00',3.24),('8975','2013-10-30','12:55:00',3.15),('8975','2013-10-30','13:00:00',3.06),('8975','2013-10-30','13:05:00',3),('8975','2013-10-30','13:10:00',2.73),('8975','2013-10-30','13:15:00',2.71),('8975','2013-10-30','13:20:00',2.48),('8975','2013-10-30','13:25:00',2.47),('8975','2013-10-30','13:30:00',2.34),('8975','2013-10-30','13:35:00',2.15),('8975','2013-10-30','13:40:00',1.91),('8975','2013-10-30','13:45:00',1.3),('8975','2013-10-30','13:50:00',1.36),('8975','2013-10-30','13:55:00',1.93),('8975','2013-10-30','14:00:00',1.99),('8975','2013-10-30','14:05:00',1.41),('8975','2013-10-30','14:55:00',1.2),('8975','2013-10-30','15:00:00',1.09),('8975','2013-10-30','15:05:00',1.06),('8975','2013-10-29','07:35:00',1.11),('8975','2013-10-29','07:40:00',1.3),('8975','2013-10-29','07:45:00',1.47),('8975','2013-10-29','07:50:00',1.6),('8975','2013-10-29','07:55:00',1.63),('8975','2013-10-29','08:00:00',1.7),('8975','2013-10-29','08:05:00',1.85),('8975','2013-10-29','08:10:00',1.96),('8975','2013-10-29','08:15:00',2),('8975','2013-10-29','08:20:00',2.1),('8975','2013-10-29','08:25:00',2.22),('8975','2013-10-29','08:30:00',2.31),('8975','2013-10-29','08:35:00',2.44),('8975','2013-10-29','08:40:00',2.55),('8975','2013-10-29','08:45:00',2.64),('8975','2013-10-29','08:50:00',2.68),('8975','2013-10-29','08:55:00',2.7),('8975','2013-10-29','09:00:00',2.81),('8975','2013-10-29','09:05:00',3.02),('8975','2013-10-29','09:10:00',3.08),('8975','2013-10-29','09:15:00',3.1),('8975','2013-10-29','09:20:00',3.2),('8975','2013-10-29','09:25:00',3.27),('8975','2013-10-29','09:30:00',3.27),('8975','2013-10-29','09:35:00',3.28),('8975','2013-10-29','09:40:00',3.36),('8975','2013-10-29','09:45:00',3.31),('8975','2013-10-29','09:50:00',3.26),('8975','2013-10-29','09:55:00',3.19),('8975','2013-10-29','10:00:00',3.31),('8975','2013-10-29','10:05:00',3.15),('8975','2013-10-29','10:10:00',3.35),('8975','2013-10-29','10:15:00',3.01),('8975','2013-10-29','10:20:00',3.43),('8975','2013-10-29','10:25:00',3.17),('8975','2013-10-29','10:30:00',2.68),('8975','2013-10-29','10:35:00',1.43),('8975','2013-10-29','10:40:00',1.67),('8975','2013-10-29','10:45:00',1.18),('8975','2013-10-29','10:50:00',2.94),('8975','2013-10-29','10:55:00',2.16),('8975','2013-10-29','11:00:00',2.12),('8975','2013-10-29','11:05:00',3.83),('8975','2013-10-29','11:10:00',3.88),('8975','2013-10-29','11:15:00',3.8),('8975','2013-10-29','11:20:00',3.08),('8975','2013-10-29','11:25:00',2.55),('8975','2013-10-29','11:30:00',1.78),('8975','2013-10-29','11:35:00',1.56),('8975','2013-10-29','11:40:00',2.34),('8975','2013-10-29','11:45:00',1.86),('8975','2013-10-29','11:50:00',1.28),('8975','2013-10-29','11:55:00',1.51),('8975','2013-10-29','12:00:00',1.72),('8975','2013-10-29','12:05:00',1.61),('8975','2013-10-29','12:10:00',1.82),('8975','2013-10-29','12:15:00',2.95),('8975','2013-10-29','12:20:00',1.59),('8975','2013-10-29','12:25:00',1.74),('8975','2013-10-29','12:30:00',1.32),('8975','2013-10-29','12:35:00',1.24),('8975','2013-10-29','12:40:00',1.35),('8975','2013-10-29','12:45:00',1.17),('8975','2013-10-29','12:50:00',1.23),('8975','2013-10-29','12:55:00',1.86),('8975','2013-10-29','13:00:00',2.97),('8975','2013-10-29','13:05:00',3.24),('8975','2013-10-29','13:10:00',2.87),('8975','2013-10-29','13:15:00',2.86),('8975','2013-10-29','13:20:00',2.71),('8975','2013-10-29','13:25:00',2.09),('8975','2013-10-29','13:30:00',2.51),('8975','2013-10-29','13:35:00',2.89),('8975','2013-10-29','13:40:00',2.37),('8975','2013-10-29','13:45:00',2.27),('8975','2013-10-29','13:50:00',1.28),('8975','2013-10-29','13:55:00',2),('8975','2013-10-29','14:00:00',2.4),('8975','2013-10-29','14:05:00',1.35),('8975','2013-10-29','14:20:00',1.95),('8975','2013-10-29','14:25:00',1.92),('8975','2013-10-29','14:55:00',1.03),('8975','2013-10-29','15:00:00',1.13),('8975','2013-10-29','15:05:00',1.11),('8975','2013-10-29','15:10:00',1.06),('8975','2013-10-29','15:15:00',1.23),('8975','2013-10-29','15:20:00',1.14),('8975','2013-10-28','08:10:00',1.25),('8975','2013-10-28','08:15:00',1.18),('8975','2013-10-28','08:20:00',1.37),('8975','2013-10-28','08:25:00',1.54),('8975','2013-10-28','08:30:00',1.93),('8975','2013-10-28','08:35:00',2.66),('8975','2013-10-28','08:40:00',2.14),('8975','2013-10-28','08:45:00',2.99),('8975','2013-10-28','08:50:00',2.99),('8975','2013-10-28','08:55:00',3.04),('8975','2013-10-28','09:00:00',3.1),('8975','2013-10-28','09:05:00',3.11),('8975','2013-10-28','09:10:00',3.11),('8975','2013-10-28','09:15:00',3.18),('8975','2013-10-28','09:20:00',3.24),('8975','2013-10-28','09:25:00',3.3),('8975','2013-10-28','09:30:00',3.5),('8975','2013-10-28','09:35:00',3.37),('8975','2013-10-28','09:40:00',3.13),('8975','2013-10-28','09:45:00',3.71),('8975','2013-10-28','09:50:00',3.72),('8975','2013-10-28','09:55:00',2.89),('8975','2013-10-28','10:00:00',2.73),('8975','2013-10-28','10:05:00',3.85),('8975','2013-10-28','10:10:00',3.45),('8975','2013-10-28','10:15:00',3.5),('8975','2013-10-28','10:20:00',3.63),('8975','2013-10-28','10:25:00',2.94),('8975','2013-10-28','10:30:00',3.68),('8975','2013-10-28','10:35:00',4.27),('8975','2013-10-28','10:40:00',4.41),('8975','2013-10-28','10:45:00',3.93),('8975','2013-10-28','10:50:00',3.85),('8975','2013-10-28','10:55:00',3.03),('8975','2013-10-28','11:00:00',3.97),('8975','2013-10-28','11:05:00',4.01),('8975','2013-10-28','11:10:00',4.01),('8975','2013-10-28','11:15:00',3.96),('8975','2013-10-28','11:20:00',3.84),('8975','2013-10-28','11:25:00',3.3),('8975','2013-10-28','11:30:00',3.37),('8975','2013-10-28','11:35:00',2.73),('8975','2013-10-28','11:40:00',2.83),('8975','2013-10-28','11:45:00',3.34),('8975','2013-10-28','11:50:00',3.34),('8975','2013-10-28','11:55:00',3.46),('8975','2013-10-28','12:00:00',3.52),('8975','2013-10-28','12:05:00',3.46),('8975','2013-10-28','12:10:00',3.39),('8975','2013-10-28','12:15:00',3.32),('8975','2013-10-28','12:20:00',3.26),('8975','2013-10-28','12:25:00',3.26),('8975','2013-10-28','12:30:00',3.2),('8975','2013-10-28','12:35:00',3.21),('8975','2013-10-28','12:40:00',2.97),('8975','2013-10-28','12:45:00',2.93),('8975','2013-10-28','12:50:00',2.87),('8975','2013-10-28','12:55:00',2.94),('8975','2013-10-28','13:00:00',2.85),('8975','2013-10-28','13:05:00',2.85),('8975','2013-10-28','13:10:00',2.72),('8975','2013-10-28','13:15:00',2.51),('8975','2013-10-28','13:20:00',2.52),('8975','2013-10-28','13:25:00',2.53),('8975','2013-10-28','13:30:00',2.37),('8975','2013-10-28','13:35:00',2.2),('8975','2013-10-28','13:40:00',2.26),('8975','2013-10-28','13:45:00',2.18),('8975','2013-10-28','13:50:00',2.14),('8975','2013-10-28','13:55:00',2.13),('8975','2013-10-28','14:00:00',1.97),('8975','2013-10-28','14:05:00',1.91),('8975','2013-10-28','14:10:00',1.78),('8975','2013-10-28','14:15:00',1.51),('8975','2013-10-28','14:20:00',1.48),('8975','2013-10-28','14:25:00',1.35),('8975','2013-10-28','14:30:00',1.41),('8975','2013-10-28','14:35:00',1.5),('8975','2013-10-28','14:40:00',1.31),('8975','2013-10-28','14:45:00',1.27),('8975','2013-10-28','14:50:00',1.16),('8975','2013-10-28','14:55:00',1.28),('8975','2013-10-28','15:00:00',1.27),('8975','2013-10-28','15:05:00',1),('8975','2013-10-28','15:15:00',1.17),('8975','2013-10-28','15:20:00',1.12),('8975','2013-10-28','15:25:00',1.07),('8975','2013-10-28','15:30:00',1.02),('8975','2014-04-16','07:55:00',2.39),('8975','2014-04-16','08:00:00',3.16),('8975','2014-04-16','08:05:00',3.47),('8975','2014-04-16','08:10:00',3.59),('8975','2014-04-16','08:15:00',3.69),('8975','2014-04-16','08:20:00',3.7),('8975','2014-04-16','08:25:00',3.82),('8975','2014-04-16','08:30:00',3.95),('8975','2014-04-16','08:35:00',4.03),('8975','2014-04-16','08:40:00',4.14),('8975','2014-04-16','08:45:00',4.25),('8975','2014-04-16','08:50:00',4.35),('8975','2014-04-16','08:55:00',4.25),('8975','2014-04-16','09:00:00',3.71),('8975','2014-04-16','09:05:00',4.37),('8975','2014-04-16','09:10:00',4.8),('8975','2014-04-16','09:15:00',4.78),('8975','2014-04-16','09:20:00',5.02),('8975','2014-04-16','09:25:00',5.1),('8975','2014-04-16','09:30:00',5.18),('8975','2014-04-16','09:35:00',5.25),('8975','2014-04-16','09:40:00',5.37),('8975','2014-04-16','09:45:00',5.52),('8975','2014-04-16','09:50:00',5.59),('8975','2014-04-16','09:55:00',5.76),('8975','2014-04-16','10:00:00',5.95),('8975','2014-04-16','10:05:00',6.34),('8975','2014-04-16','10:10:00',6.42),('8975','2014-04-16','10:15:00',4.61),('8975','2014-04-16','10:20:00',4.96),('8975','2014-04-16','10:25:00',6.68),('8975','2014-04-16','10:30:00',7.02),('8975','2014-04-16','10:35:00',7.32),('8975','2014-04-16','10:40:00',6.96),('8975','2014-04-16','10:45:00',6.8),('8975','2014-04-16','10:50:00',4.77),('8975','2014-04-16','10:55:00',4.31),('8975','2014-04-16','11:00:00',4.49),('8975','2014-04-16','11:05:00',5.15),('8975','2014-04-16','11:10:00',5.52),('8975','2014-04-16','11:15:00',3.79),('8975','2014-04-16','11:20:00',3.97),('8975','2014-04-16','11:25:00',7.13),('8975','2014-04-16','11:30:00',4.51),('8975','2014-04-16','11:35:00',3.58),('8975','2014-04-16','11:40:00',3.18),('8975','2014-04-16','11:45:00',6.69),('8975','2014-04-16','11:50:00',5.58),('8975','2014-04-16','11:55:00',4.2),('8975','2014-04-16','12:00:00',3.97),('8975','2014-04-16','12:05:00',4.85),('8975','2014-04-16','12:10:00',4.14),('8975','2014-04-16','12:15:00',3.69),('8975','2014-04-16','12:20:00',3.84),('8975','2014-04-16','12:25:00',4.25),('8975','2014-04-16','12:30:00',4.77),('8975','2014-04-16','12:35:00',4.88),('8975','2014-04-16','12:40:00',6.15),('8975','2014-04-16','12:45:00',6.38),('8975','2014-04-16','12:50:00',6.48),('8975','2014-04-16','12:55:00',6.3),('8975','2014-04-16','13:00:00',2.27),('8975','2014-04-16','13:05:00',5.28),('8975','2014-04-16','13:10:00',7.15),('8975','2014-04-16','13:15:00',7.3),('8975','2014-04-16','13:20:00',6.01),('8975','2014-04-16','13:25:00',1.8),('8975','2014-04-16','13:30:00',2.65),('8975','2014-04-16','13:35:00',6.85),('8975','2014-04-16','13:40:00',4.79),('8975','2014-04-16','13:45:00',1.71),('8975','2014-04-16','13:50:00',1.48),('8975','2014-04-16','13:55:00',1.7),('8975','2014-04-16','14:00:00',2.11),('8975','2014-04-16','14:05:00',1.77),('8975','2014-04-16','14:10:00',1.73),('8975','2014-04-16','14:15:00',2.13),('8975','2014-04-16','14:20:00',3.82),('8975','2014-04-16','14:25:00',2.23),('8975','2014-04-16','14:30:00',2.92),('8975','2014-04-16','14:35:00',2.75),('8975','2014-04-16','14:40:00',2.75),('8975','2014-04-16','14:45:00',2.86),('8975','2014-04-16','14:50:00',1.71),('8975','2014-04-16','14:55:00',1.3),('8975','2014-04-16','15:00:00',1.18),('8975','2014-04-16','15:05:00',1.29),('8975','2014-04-16','15:10:00',1.32),('8975','2014-04-16','15:15:00',1.2),('8975','2014-04-16','15:20:00',1.12),('8975','2014-04-16','15:25:00',1.35),('8975','2014-04-16','15:30:00',2.08),('8975','2014-04-16','15:35:00',2.83),('8975','2014-04-16','15:40:00',3.48),('8975','2014-04-16','15:45:00',2.63),('8975','2014-04-16','15:50:00',1.95),('8975','2014-04-16','15:55:00',1.96),('8975','2014-04-16','16:00:00',1.87),('8975','2014-04-16','16:05:00',1.54),('8975','2014-04-16','16:10:00',1.64),('8975','2014-04-16','16:15:00',1.74),('8975','2014-04-16','16:20:00',1.71),('8975','2014-04-16','16:25:00',1.73),('8975','2014-04-16','16:30:00',1.85),('8975','2014-04-16','16:35:00',1.75),('8975','2014-04-16','16:40:00',1.84),('8975','2014-04-16','16:45:00',2.8),('8975','2014-04-16','16:50:00',2.96),('8975','2014-04-16','16:55:00',2),('8975','2014-04-16','17:00:00',1.57),('8975','2014-04-16','17:05:00',1.35),('8975','2014-04-16','17:10:00',1.26),('8975','2014-04-16','17:15:00',1.42),('8975','2014-04-16','17:20:00',1.61),('8975','2014-04-16','17:25:00',1.47),('8975','2014-04-16','17:30:00',1.45),('8975','2014-04-16','17:35:00',1.47),('8975','2014-04-16','17:40:00',1.46),('8975','2014-04-16','17:45:00',1.35),('8975','2014-04-16','17:50:00',1.09),('8975','2014-04-16','17:55:00',1.06),('8975','2013-10-27','07:25:00',1.23),('8975','2013-10-27','07:30:00',1.45),('8975','2013-10-27','07:35:00',1.75),('8975','2013-10-27','07:40:00',1.31),('8975','2013-10-27','07:45:00',1.41),('8975','2013-10-27','08:10:00',1.24),('8975','2013-10-27','08:15:00',1.55),('8975','2013-10-27','08:20:00',1.21),('8975','2013-10-27','08:25:00',1.17),('8975','2013-10-27','08:30:00',1.13),('8975','2013-10-27','08:35:00',1.19),('8975','2013-10-27','08:40:00',1.2),('8975','2013-10-27','08:45:00',1.28),('8975','2013-10-27','08:50:00',2.99),('8975','2013-10-27','08:55:00',2.79),('8975','2013-10-27','09:00:00',3.16),('8975','2013-10-27','09:05:00',3.2),('8975','2013-10-27','09:10:00',3.14),('8975','2013-10-27','09:15:00',3.28),('8975','2013-10-27','09:20:00',3.3),('8975','2013-10-27','09:25:00',3.28),('8975','2013-10-27','09:30:00',3.3),('8975','2013-10-27','09:35:00',3.38),('8975','2013-10-27','09:40:00',3.51),('8975','2013-10-27','09:45:00',3.76),('8975','2013-10-27','09:50:00',4.01),('8975','2013-10-27','09:55:00',1.86),('8975','2013-10-27','10:00:00',1.5),('8975','2013-10-27','10:05:00',1.39),('8975','2013-10-27','10:10:00',1.36),('8975','2013-10-27','10:15:00',1.38),('8975','2013-10-27','10:20:00',1.4),('8975','2013-10-27','10:25:00',1.44),('8975','2013-10-27','10:30:00',1.46),('8975','2013-10-27','10:35:00',1.5),('8975','2013-10-27','10:40:00',1.46),('8975','2013-10-27','10:50:00',2.68),('8975','2013-10-27','10:55:00',4.07),('8975','2013-10-27','11:00:00',4.01),('8975','2013-10-27','11:05:00',3.99),('8975','2013-10-27','11:10:00',3.95),('8975','2013-10-27','11:15:00',3.84),('8975','2013-10-27','11:20:00',3.85),('8975','2013-10-27','11:25:00',3.66),('8975','2013-10-27','11:30:00',3.63),('8975','2013-10-27','11:35:00',3.75),('8975','2013-10-27','11:40:00',3.71),('8975','2013-10-27','11:45:00',3.67),('8975','2013-10-27','11:50:00',3.69),('8975','2013-10-27','11:55:00',3.75),('8975','2013-10-27','12:00:00',3.64),('8975','2013-10-27','12:05:00',3.26),('8975','2013-10-27','12:10:00',2.47),('8975','2013-10-27','12:15:00',2.38),('8975','2013-10-27','12:20:00',2.31),('8975','2013-10-27','12:25:00',3.61),('8975','2013-10-27','12:30:00',2.63),('8975','2013-10-27','12:35:00',1.65),('8975','2013-10-27','12:40:00',2.09),('8975','2013-10-27','12:45:00',2.72),('8975','2013-10-27','12:50:00',3.45),('8975','2013-10-27','12:55:00',3.29),('8975','2013-10-27','13:00:00',3.15),('8975','2013-10-27','13:05:00',3.03),('8975','2013-10-27','13:10:00',2.88),('8975','2013-10-27','13:15:00',2.7),('8975','2013-10-27','13:20:00',2.56),('8975','2013-10-27','13:25:00',2.44),('8975','2013-10-27','13:30:00',2.28),('8975','2013-10-27','13:35:00',1.4),('8975','2013-10-27','13:40:00',2.36),('8975','2013-10-27','13:45:00',1.72),('8975','2013-10-27','13:50:00',1.17),('8975','2013-10-27','13:55:00',2.22),('8975','2013-10-27','14:00:00',1.82),('8975','2013-10-27','14:05:00',2.15),('8975','2013-10-27','14:10:00',1.78),('8975','2013-10-27','14:15:00',1.54),('8975','2013-10-27','14:20:00',1.65),('8975','2013-10-27','14:25:00',1.8),('8975','2013-10-27','14:30:00',1.54),('8975','2013-10-27','14:35:00',1.41),('8975','2013-10-27','14:40:00',1.69),('8975','2013-10-27','14:45:00',1.25),('8975','2013-10-27','14:50:00',1.06),('8975','2013-10-27','15:00:00',1.31),('8975','2013-10-27','15:10:00',1.37),('8975','2013-10-27','15:15:00',1.33),('8975','2013-10-27','15:20:00',1.23),('8975','2013-10-27','15:25:00',1.28),('8975','2013-10-26','09:00:00',1.04),('8975','2013-10-26','09:05:00',1.17),('8975','2013-10-26','09:10:00',1.05),('8975','2013-10-26','09:30:00',1.06),('8975','2013-10-26','09:35:00',1.08),('8975','2013-10-26','09:40:00',1.2),('8975','2013-10-26','09:45:00',1.3),('8975','2013-10-26','09:50:00',1.48),('8975','2013-10-26','09:55:00',1.68),('8975','2013-10-26','10:00:00',1.69),('8975','2013-10-26','10:05:00',1.9),('8975','2013-10-26','10:10:00',2.49),('8975','2013-10-26','10:15:00',2.76),('8975','2013-10-26','10:20:00',2.55),('8975','2013-10-26','10:25:00',2.51),('8975','2013-10-26','10:30:00',2.38),('8975','2013-10-26','10:35:00',2.22),('8975','2013-10-26','10:40:00',2.09),('8975','2013-10-26','10:45:00',2),('8975','2013-10-26','10:50:00',1.8),('8975','2013-10-26','10:55:00',1.7),('8975','2013-10-26','11:00:00',1.52),('8975','2013-10-26','11:05:00',1.2),('8975','2013-10-26','11:30:00',1.61),('8975','2013-10-26','11:35:00',2.19),('8975','2013-10-26','11:40:00',3.27),('8975','2013-10-26','11:45:00',2.68),('8975','2013-10-26','11:50:00',2.43),('8975','2013-10-26','11:55:00',1.52),('8975','2013-10-26','12:00:00',1.54),('8975','2013-10-26','12:05:00',2.59),('8975','2013-10-26','12:10:00',2.5),('8975','2013-10-26','12:15:00',3.14),('8975','2013-10-26','12:20:00',3.29),('8975','2013-10-26','12:25:00',2.88),('8975','2013-10-26','12:30:00',3.64),('8975','2013-10-26','12:35:00',2.26),('8975','2013-10-26','12:40:00',2.78),('8975','2013-10-26','12:45:00',2.02),('8975','2013-10-26','12:50:00',1.89),('8975','2013-10-26','12:55:00',2.55),('8975','2013-10-26','13:00:00',1.6),('8975','2013-10-26','13:05:00',1.67),('8975','2013-10-26','13:10:00',1.4),('8975','2013-10-26','13:15:00',2),('8975','2013-10-26','13:20:00',1.5),('8975','2013-10-26','13:25:00',1.44),('8975','2013-10-26','13:30:00',1.16),('8975','2013-10-26','13:35:00',1.11),('8975','2013-10-26','13:50:00',1.07),('8975','2013-10-26','13:55:00',1.32),('8975','2013-10-26','14:00:00',1.69),('8975','2013-10-26','14:05:00',2.05),('8975','2013-10-26','14:10:00',1.92),('8975','2013-10-26','14:15:00',1.75),('8975','2013-10-26','14:20:00',1.83),('8975','2013-10-26','14:25:00',2.03),('8975','2013-10-26','14:30:00',1.86),('8975','2013-10-26','14:35:00',1.69),('8975','2013-10-26','14:40:00',1.38),('8975','2013-10-26','14:45:00',1.39),('8975','2013-10-26','14:50:00',1.27),('8975','2013-10-26','14:55:00',1.36),('8975','2013-10-26','15:00:00',1.56),('8975','2013-10-26','15:05:00',1.43),('8975','2013-10-26','15:10:00',1.36),('8975','2013-10-26','15:15:00',1.3),('8975','2013-10-26','15:20:00',1.23),('8975','2013-10-25','08:15:00',1),('8975','2013-10-25','08:20:00',1.15),('8975','2013-10-25','08:25:00',1.32),('8975','2013-10-25','08:30:00',1.48),('8975','2013-10-25','08:35:00',1.6),('8975','2013-10-25','08:40:00',1.73),('8975','2013-10-25','08:45:00',1.86),('8975','2013-10-25','08:50:00',1.96),('8975','2013-10-25','08:55:00',2.06),('8975','2013-10-25','09:00:00',2.16),('8975','2013-10-25','09:05:00',2.24),('8975','2013-10-25','09:10:00',2.34),('8975','2013-10-25','09:15:00',2.4),('8975','2013-10-25','09:20:00',2.53),('8975','2013-10-25','09:25:00',2.64),('8975','2013-10-25','09:30:00',2.72),('8975','2013-10-25','09:35:00',2.78),('8975','2013-10-25','09:40:00',2.82),('8975','2013-10-25','09:45:00',2.93),('8975','2013-10-25','09:50:00',3.01),('8975','2013-10-25','09:55:00',3.07),('8975','2013-10-25','10:00:00',3.13),('8975','2013-10-25','10:05:00',3.16),('8975','2013-10-25','10:10:00',3.21),('8975','2013-10-25','10:15:00',3.29),('8975','2013-10-25','10:20:00',3.37),('8975','2013-10-25','10:25:00',3.45),('8975','2013-10-25','10:30:00',3.5),('8975','2013-10-25','10:35:00',3.55),('8975','2013-10-25','10:40:00',3.56),('8975','2013-10-25','10:45:00',3.59),('8975','2013-10-25','10:50:00',3.65),('8975','2013-10-25','10:55:00',3.68),('8975','2013-10-25','11:00:00',3.7),('8975','2013-10-25','11:05:00',3.77),('8975','2013-10-25','11:10:00',3.78),('8975','2013-10-25','11:15:00',3.82),('8975','2013-10-25','11:20:00',3.84),('8975','2013-10-25','11:25:00',3.86),('8975','2013-10-25','11:30:00',3.9),('8975','2013-10-25','11:35:00',3.89),('8975','2013-10-25','11:40:00',3.87),('8975','2013-10-25','11:45:00',3.89),('8975','2013-10-25','11:50:00',3.88),('8975','2013-10-25','11:55:00',3.83),('8975','2013-10-25','12:00:00',3.81),('8975','2013-10-25','12:05:00',3.85),('8975','2013-10-25','12:10:00',3.85),('8975','2013-10-25','12:15:00',3.77),('8975','2013-10-25','12:20:00',3.73),('8975','2013-10-25','12:25:00',3.71),('8975','2013-10-25','12:30:00',3.73),('8975','2013-10-25','12:35:00',3.54),('8975','2013-10-25','12:40:00',3.59),('8975','2013-10-25','12:45:00',3.62),('8975','2013-10-25','12:50:00',3.62),('8975','2013-10-25','12:55:00',3.56),('8975','2013-10-25','13:00:00',3.36),('8975','2013-10-25','13:05:00',2.78),('8975','2013-10-25','13:10:00',3.16),('8975','2013-10-25','13:15:00',3.35),('8975','2013-10-25','13:20:00',3.3),('8975','2013-10-25','13:25:00',2.95),('8975','2013-10-25','13:30:00',3.18),('8975','2013-10-25','13:35:00',3.02),('8975','2013-10-25','13:40:00',2.98),('8975','2013-10-25','13:45:00',2.95),('8975','2013-10-25','13:50:00',2.85),('8975','2013-10-25','13:55:00',1.29),('8975','2013-10-25','14:00:00',2.53),('8975','2013-10-25','14:05:00',2.21),('8975','2013-10-25','14:10:00',2.28),('8975','2013-10-25','14:15:00',2.82),('8975','2013-10-25','14:20:00',2.87),('8975','2013-10-25','14:25:00',2.51),('8975','2013-10-25','14:30:00',1.92),('8975','2013-10-25','14:35:00',1.94),('8975','2013-10-25','14:40:00',2.32),('8975','2013-10-25','14:45:00',2.34),('8975','2013-10-25','14:50:00',2.19),('8975','2013-10-25','14:55:00',1.13),('8975','2013-10-25','15:10:00',1.34),('8975','2013-10-25','15:15:00',2.06),('8975','2013-10-25','15:20:00',1.96),('8975','2013-10-25','15:25:00',1.88),('8975','2013-10-25','15:30:00',1.89),('8975','2013-10-25','15:35:00',1.75),('8975','2013-10-25','15:40:00',1.7),('8975','2013-10-25','15:45:00',1.62),('8975','2013-10-25','15:50:00',1.55),('8975','2013-10-25','15:55:00',1.46),('8975','2013-10-25','16:00:00',1.47),('8975','2013-10-25','16:05:00',1.41),('8975','2013-10-25','16:10:00',1.29),('8975','2013-10-25','16:15:00',1.21),('8975','2013-10-25','16:20:00',1.16),('8975','2013-10-25','16:25:00',1.07),('8975','2013-10-25','16:30:00',1.05),('8975','2013-10-24','08:15:00',1.09),('8975','2013-10-24','08:20:00',1.26),('8975','2013-10-24','08:25:00',1.42),('8975','2013-10-24','08:30:00',1.56),('8975','2013-10-24','08:35:00',1.7),('8975','2013-10-24','08:40:00',1.8),('8975','2013-10-24','08:45:00',1.91),('8975','2013-10-24','08:50:00',2.02),('8975','2013-10-24','08:55:00',2.12),('8975','2013-10-24','09:00:00',2.24),('8975','2013-10-24','09:05:00',2.31),('8975','2013-10-24','09:10:00',2.42),('8975','2013-10-24','09:15:00',2.51),('8975','2013-10-24','09:20:00',2.59),('8975','2013-10-24','09:25:00',2.65),('8975','2013-10-24','09:30:00',2.75),('8975','2013-10-24','09:35:00',2.82),('8975','2013-10-24','09:40:00',2.9),('8975','2013-10-24','09:45:00',2.95),('8975','2013-10-24','09:50:00',3.01),('8975','2013-10-24','09:55:00',3.02),('8975','2013-10-24','10:00:00',3.1),('8975','2013-10-24','10:05:00',3.13),('8975','2013-10-24','10:10:00',3.19),('8975','2013-10-24','10:15:00',3.29),('8975','2013-10-24','10:20:00',3.39),('8975','2013-10-24','10:25:00',3.51),('8975','2013-10-24','10:30:00',3.58),('8975','2013-10-24','10:35:00',3.67),('8975','2013-10-24','10:40:00',3.66),('8975','2013-10-24','10:45:00',3.72),('8975','2013-10-24','10:50:00',3.78),('8975','2013-10-24','10:55:00',3.7),('8975','2013-10-24','11:00:00',3.75),('8975','2013-10-24','11:05:00',3.78),('8975','2013-10-24','11:10:00',3.82),('8975','2013-10-24','11:15:00',3.84),('8975','2013-10-24','11:20:00',3.83),('8975','2013-10-24','11:25:00',3.86),('8975','2013-10-24','11:30:00',3.85),('8975','2013-10-24','11:35:00',3.93),('8975','2013-10-24','11:40:00',3.97),('8975','2013-10-24','11:45:00',3.97),('8975','2013-10-24','11:50:00',4.04),('8975','2013-10-24','11:55:00',4.03),('8975','2013-10-24','12:00:00',4.05),('8975','2013-10-24','12:05:00',4.05),('8975','2013-10-24','12:10:00',4.08),('8975','2013-10-24','12:15:00',3.97),('8975','2013-10-24','12:20:00',3.98),('8975','2013-10-24','12:25:00',3.96),('8975','2013-10-24','12:30:00',3.73),('8975','2013-10-24','12:35:00',3.46),('8975','2013-10-24','12:40:00',3.6),('8975','2013-10-24','12:45:00',3.85),('8975','2013-10-24','12:50:00',3.79),('8975','2013-10-24','12:55:00',3.72),('8975','2013-10-24','13:00:00',3.7),('8975','2013-10-24','13:05:00',3.67),('8975','2013-10-24','13:10:00',3.6),('8975','2013-10-24','13:15:00',3.56),('8975','2013-10-24','13:20:00',3.52),('8975','2013-10-24','13:25:00',3.43),('8975','2013-10-24','13:30:00',3.29),('8975','2013-10-24','13:35:00',3.1),('8975','2013-10-24','13:40:00',3.11),('8975','2013-10-24','13:45:00',3.15),('8975','2013-10-24','13:50:00',3.12),('8975','2013-10-24','13:55:00',3.11),('8975','2013-10-24','14:00:00',3.06),('8975','2013-10-24','14:05:00',3),('8975','2013-10-24','14:10:00',2.91),('8975','2013-10-24','14:15:00',2.71),('8975','2013-10-24','14:20:00',2.56),('8975','2013-10-24','14:25:00',2.52),('8975','2013-10-24','14:30:00',2.55),('8975','2013-10-24','14:35:00',2.51),('8975','2013-10-24','14:40:00',2.45),('8975','2013-10-24','14:45:00',2.35),('8975','2013-10-24','14:50:00',2.21),('8975','2013-10-24','14:55:00',2.15),('8975','2013-10-24','15:00:00',2.12),('8975','2013-10-24','15:05:00',1.98),('8975','2013-10-24','15:10:00',1.98),('8975','2013-10-24','15:15:00',1.93),('8975','2013-10-24','15:20:00',1.88),('8975','2013-10-24','15:25:00',1.8),('8975','2013-10-24','15:30:00',1.72),('8975','2013-10-24','15:35:00',1.61),('8975','2013-10-24','15:40:00',1.53),('8975','2013-10-24','15:45:00',1.48),('8975','2013-10-24','15:50:00',1.45),('8975','2013-10-24','15:55:00',1.4),('8975','2013-10-24','16:00:00',1.35),('8975','2013-10-24','16:05:00',1.31),('8975','2013-10-24','16:10:00',1.26),('8975','2013-10-24','16:15:00',1.22),('8975','2013-10-24','16:20:00',1.19),('8975','2013-10-24','16:25:00',1.16),('8975','2013-10-24','16:30:00',1.12),('8975','2013-10-24','16:35:00',1.07),('8975','2013-10-24','16:40:00',1.02),('8975','2013-10-23','08:20:00',1.03),('8975','2013-10-23','08:25:00',1.6),('8975','2013-10-23','08:30:00',1.55),('8975','2013-10-23','08:50:00',1.06),('8975','2013-10-23','08:55:00',1.41),('8975','2013-10-23','09:00:00',1.77),('8975','2013-10-23','09:05:00',2.34),('8975','2013-10-23','09:10:00',2.49),('8975','2013-10-23','09:15:00',2.68),('8975','2013-10-23','09:20:00',2.53),('8975','2013-10-23','09:25:00',1.52),('8975','2013-10-23','09:30:00',1.56),('8975','2013-10-23','09:35:00',1.68),('8975','2013-10-23','09:40:00',1.83),('8975','2013-10-23','09:45:00',1.96),('8975','2013-10-23','09:50:00',1.94),('8975','2013-10-23','09:55:00',1.91),('8975','2013-10-23','10:00:00',1.84),('8975','2013-10-23','10:05:00',1.74),('8975','2013-10-23','10:10:00',1.65),('8975','2013-10-23','10:15:00',1.86),('8975','2013-10-23','10:20:00',1.98),('8975','2013-10-23','10:25:00',1.25),('8975','2013-10-23','10:30:00',1.27),('8975','2013-10-23','10:35:00',1.59),('8975','2013-10-23','10:40:00',1.51),('8975','2013-10-23','10:45:00',2.3),('8975','2013-10-23','10:50:00',2.14),('8975','2013-10-23','10:55:00',2.47),('8975','2013-10-23','11:00:00',3.44),('8975','2013-10-23','11:05:00',2.61),('8975','2013-10-23','11:10:00',2.57),('8975','2013-10-23','11:15:00',3.5),('8975','2013-10-23','11:20:00',3.1),('8975','2013-10-23','11:25:00',1.92),('8975','2013-10-23','11:30:00',1.92),('8975','2013-10-23','11:35:00',2.02),('8975','2013-10-23','11:40:00',1.72),('8975','2013-10-23','11:45:00',1.8),('8975','2013-10-23','11:50:00',2.15),('8975','2013-10-23','11:55:00',2.73),('8975','2013-10-23','12:00:00',2.75),('8975','2013-10-23','12:05:00',2.17),('8975','2013-10-23','12:10:00',2.06),('8975','2013-10-23','12:15:00',2.01),('8975','2013-10-23','12:20:00',2.06),('8975','2013-10-23','12:25:00',2.19),('8975','2013-10-23','12:30:00',2.31),('8975','2013-10-23','12:35:00',2.5),('8975','2013-10-23','12:40:00',2.68),('8975','2013-10-23','12:45:00',3.07),('8975','2013-10-23','12:50:00',4.17),('8975','2013-10-23','12:55:00',4.1),('8975','2013-10-23','13:00:00',4.26),('8975','2013-10-23','13:05:00',4.39),('8975','2013-10-23','13:10:00',3.16),('8975','2013-10-23','13:15:00',3.05),('8975','2013-10-23','13:20:00',2.81),('8975','2013-10-23','13:25:00',2.34),('8975','2013-10-23','13:30:00',2.17),('8975','2013-10-23','13:35:00',2.1),('8975','2013-10-23','13:40:00',2.09),('8975','2013-10-23','13:45:00',2.3),('8975','2013-10-23','13:50:00',2.5),('8975','2013-10-23','13:55:00',3.33),('8975','2013-10-23','14:00:00',4.08),('8975','2013-10-23','14:05:00',2.34),('8975','2013-10-23','14:10:00',1.99),('8975','2013-10-23','14:15:00',2.08),('8975','2013-10-23','14:20:00',2.08),('8975','2013-10-23','14:25:00',2.05),('8975','2013-10-23','14:30:00',2.14),('8975','2013-10-23','14:35:00',2.17),('8975','2013-10-23','14:40:00',2.67),('8975','2013-10-23','14:45:00',2.44),('8975','2013-10-23','14:50:00',1.61),('8975','2013-10-23','14:55:00',1.06),('8975','2013-10-23','15:05:00',1.23),('8975','2013-10-23','15:10:00',1.81),('8975','2013-10-23','15:15:00',1.55),('8975','2013-10-23','15:20:00',1.49),('8975','2013-10-23','15:25:00',1.26),('8975','2013-10-23','15:30:00',1.34),('8975','2013-10-23','15:35:00',1.98),('8975','2013-10-23','15:40:00',1.76),('8975','2013-10-23','15:45:00',2.07),('8975','2013-10-23','15:50:00',1.52),('8975','2013-10-23','16:10:00',1),('8975','2013-10-22','09:50:00',1.11),('8975','2013-10-22','09:55:00',1.09),('8975','2013-10-22','10:00:00',1.32),('8975','2013-10-22','10:05:00',1.52),('8975','2013-10-22','10:10:00',1.24),('8975','2013-10-22','10:15:00',1.52),('8975','2013-10-22','10:20:00',1.77),('8975','2013-10-22','10:25:00',1.6),('8975','2013-10-22','10:30:00',2.49),('8975','2013-10-22','10:35:00',2.12),('8975','2013-10-22','10:40:00',2.36),('8975','2013-10-22','10:45:00',2.56),('8975','2013-10-22','10:50:00',3.74),('8975','2013-10-22','10:55:00',3.25),('8975','2013-10-22','11:00:00',2.46),('8975','2013-10-22','11:05:00',3.47),('8975','2013-10-22','11:10:00',3.44),('8975','2013-10-22','11:15:00',3.89),('8975','2013-10-22','11:20:00',3.92),('8975','2013-10-22','11:25:00',3.78),('8975','2013-10-22','11:30:00',4.05),('8975','2013-10-22','11:35:00',4.02),('8975','2013-10-22','11:40:00',4.05),('8975','2013-10-22','11:45:00',3.82),('8975','2013-10-22','11:50:00',3.97),('8975','2013-10-22','11:55:00',4.01),('8975','2013-10-22','12:00:00',3.81),('8975','2013-10-22','12:05:00',3.6),('8975','2013-10-22','12:10:00',3.85),('8975','2013-10-22','12:15:00',3.84),('8975','2013-10-22','12:20:00',3.67),('8975','2013-10-22','12:25:00',3.76),('8975','2013-10-22','12:30:00',3.66),('8975','2013-10-22','12:35:00',3.56),('8975','2013-10-22','12:40:00',3.53),('8975','2013-10-22','12:45:00',3.35),('8975','2013-10-22','12:50:00',2.96),('8975','2013-10-22','12:55:00',1.62),('8975','2013-10-22','13:00:00',2.06),('8975','2013-10-22','13:05:00',3.03),('8975','2013-10-22','13:10:00',3.45),('8975','2013-10-22','13:15:00',3.49),('8975','2013-10-22','13:20:00',3.47),('8975','2013-10-22','13:25:00',3.3),('8975','2013-10-22','13:30:00',3.33),('8975','2013-10-22','13:35:00',3.28),('8975','2013-10-22','13:40:00',3.15),('8975','2013-10-22','13:45:00',2.69),('8975','2013-10-22','13:50:00',2.82),('8975','2013-10-22','13:55:00',3.09),('8975','2013-10-22','14:00:00',3.01),('8975','2013-10-22','14:05:00',2.92),('8975','2013-10-22','14:10:00',2.8),('8975','2013-10-22','14:15:00',2.79),('8975','2013-10-22','14:20:00',2.06),('8975','2013-10-22','14:25:00',2.65),('8975','2013-10-22','14:30:00',2.49),('8975','2013-10-22','14:35:00',2),('8975','2013-10-22','14:40:00',2.47),('8975','2013-10-22','14:45:00',2.45),('8975','2013-10-22','14:50:00',2.4),('8975','2013-10-22','14:55:00',2.29),('8975','2013-10-22','15:00:00',2.18),('8975','2013-10-22','15:05:00',2.17),('8975','2013-10-22','15:10:00',2.01),('8975','2013-10-22','15:15:00',1.92),('8975','2013-10-22','15:20:00',1.93),('8975','2013-10-22','15:25:00',1.93),('8975','2013-10-22','15:30:00',1.72),('8975','2013-10-22','15:35:00',1.54),('8975','2013-10-22','15:40:00',1.65),('8975','2013-10-22','15:45:00',1.7),('8975','2013-10-22','15:50:00',1.59),('8975','2013-10-22','15:55:00',1.42),('8975','2013-10-22','16:00:00',1.07),('8975','2013-10-22','16:25:00',1.12),('8975','2013-10-22','16:30:00',1.05),('8975','2013-10-22','16:35:00',1.13),('8975','2013-10-22','16:40:00',1.17),('8975','2013-10-22','16:45:00',1.05),('8975','2013-10-21','08:15:00',1.05),('8975','2013-10-21','08:20:00',1.22),('8975','2013-10-21','08:25:00',1.36),('8975','2013-10-21','08:30:00',1.48),('8975','2013-10-21','08:35:00',1.61),('8975','2013-10-21','08:40:00',1.74),('8975','2013-10-21','08:45:00',1.86),('8975','2013-10-21','08:50:00',1.97),('8975','2013-10-21','08:55:00',2.08),('8975','2013-10-21','09:00:00',2.19),('8975','2013-10-21','09:05:00',2.27),('8975','2013-10-21','09:10:00',2.38),('8975','2013-10-21','09:15:00',2.49),('8975','2013-10-21','09:20:00',2.58),('8975','2013-10-21','09:25:00',2.67),('8975','2013-10-21','09:30:00',2.76),('8975','2013-10-21','09:35:00',2.86),('8975','2013-10-21','09:40:00',2.92),('8975','2013-10-21','09:45:00',3),('8975','2013-10-21','09:50:00',3.07),('8975','2013-10-21','09:55:00',3.15),('8975','2013-10-21','10:00:00',3.18),('8975','2013-10-21','10:05:00',3.19),('8975','2013-10-21','10:10:00',3.31),('8975','2013-10-21','10:15:00',3.39),('8975','2013-10-21','10:20:00',3.47),('8975','2013-10-21','10:25:00',3.54),('8975','2013-10-21','10:30:00',3.58),('8975','2013-10-21','10:35:00',3.62),('8975','2013-10-21','10:40:00',3.55),('8975','2013-10-21','10:45:00',3.43),('8975','2013-10-21','10:50:00',3.44),('8975','2013-10-21','10:55:00',3.35),('8975','2013-10-21','11:00:00',3.53),('8975','2013-10-21','11:05:00',3.13),('8975','2013-10-21','11:10:00',3.55),('8975','2013-10-21','11:15:00',3.72),('8975','2013-10-21','11:20:00',3.56),('8975','2013-10-21','11:25:00',3.74),('8975','2013-10-21','11:30:00',3.62),('8975','2013-10-21','11:35:00',3.48),('8975','2013-10-21','11:40:00',3.9),('8975','2013-10-21','11:45:00',3.59),('8975','2013-10-21','11:50:00',3.73),('8975','2013-10-21','11:55:00',3.96),('8975','2013-10-21','12:00:00',3.94),('8975','2013-10-21','12:05:00',3.88),('8975','2013-10-21','12:10:00',3.84),('8975','2013-10-21','12:15:00',3.92),('8975','2013-10-21','12:20:00',3.9),('8975','2013-10-21','12:25:00',3.86),('8975','2013-10-21','12:30:00',3.82),('8975','2013-10-21','12:35:00',3.67),('8975','2013-10-21','12:40:00',3.65),('8975','2013-10-21','12:45:00',3.66),('8975','2013-10-21','12:50:00',3.69),('8975','2013-10-21','12:55:00',3.69),('8975','2013-10-21','13:00:00',3.51),('8975','2013-10-21','13:05:00',3.33),('8975','2013-10-21','13:10:00',3.47),('8975','2013-10-21','13:15:00',3.04),('8975','2013-10-21','13:20:00',3.4),('8975','2013-10-21','13:25:00',3.37),('8975','2013-10-21','13:30:00',2.85),('8975','2013-10-21','13:35:00',3),('8975','2013-10-21','13:40:00',3.06),('8975','2013-10-21','13:45:00',3.07),('8975','2013-10-21','13:50:00',3.19),('8975','2013-10-21','13:55:00',3.26),('8975','2013-10-21','14:00:00',3.12),('8975','2013-10-21','14:05:00',3.09),('8975','2013-10-21','14:10:00',2.9),('8975','2013-10-21','14:15:00',3.02),('8975','2013-10-21','14:20:00',2.84),('8975','2013-10-21','14:25:00',2.77),('8975','2013-10-21','14:30:00',2.67),('8975','2013-10-21','14:35:00',2.78),('8975','2013-10-21','14:40:00',2.71),('8975','2013-10-21','14:45:00',2.49),('8975','2013-10-21','14:50:00',2.36),('8975','2013-10-21','14:55:00',2.28),('8975','2013-10-21','15:00:00',2.25),('8975','2013-10-21','15:05:00',2.13),('8975','2013-10-21','15:10:00',2.15),('8975','2013-10-21','15:15:00',2.1),('8975','2013-10-21','15:20:00',1.97),('8975','2013-10-21','15:25:00',1.79),('8975','2013-10-21','15:30:00',1.69),('8975','2013-10-21','15:35:00',1.24),('8975','2013-10-21','15:40:00',1.57),('8975','2013-10-21','15:45:00',1.37),('8975','2013-10-21','15:50:00',1.33),('8975','2013-10-21','15:55:00',1.13),('8975','2013-10-21','16:00:00',1.13),('8975','2013-10-21','16:05:00',1.42),('8975','2013-10-21','16:10:00',1.34),('8975','2013-10-21','16:15:00',1.24),('8975','2013-10-21','16:20:00',1.25),('8975','2013-10-21','16:25:00',1.21),('8975','2013-10-21','16:30:00',1.17),('8975','2013-10-21','16:35:00',1.11),('8975','2013-10-21','16:40:00',1.04),('8975','2013-10-20','08:05:00',1.04),('8975','2013-10-20','08:10:00',1.22),('8975','2013-10-20','08:15:00',1.23),('8975','2013-10-20','08:20:00',1.59),('8975','2013-10-20','08:25:00',1.4),('8975','2013-10-20','08:30:00',1.82),('8975','2013-10-20','08:35:00',1.66),('8975','2013-10-20','08:40:00',1.91),('8975','2013-10-20','08:45:00',1.88),('8975','2013-10-20','08:50:00',1.85),('8975','2013-10-20','08:55:00',1.75),('8975','2013-10-20','09:00:00',1.47),('8975','2013-10-20','09:05:00',1.69),('8975','2013-10-20','09:10:00',2.04),('8975','2013-10-20','09:15:00',2.35),('8975','2013-10-20','09:20:00',2.74),('8975','2013-10-20','09:25:00',2.94),('8975','2013-10-20','09:30:00',2.58),('8975','2013-10-20','09:35:00',2.42),('8975','2013-10-20','09:40:00',2.86),('8975','2013-10-20','09:45:00',2.4),('8975','2013-10-20','09:50:00',2.7),('8975','2013-10-20','09:55:00',3.09),('8975','2013-10-20','10:00:00',3.26),('8975','2013-10-20','10:05:00',3.61),('8975','2013-10-20','10:10:00',3.25),('8975','2013-10-20','10:15:00',3.41),('8975','2013-10-20','10:20:00',3.43),('8975','2013-10-20','10:25:00',3.7),('8975','2013-10-20','10:30:00',3.63),('8975','2013-10-20','10:35:00',3.52),('8975','2013-10-20','10:40:00',3.36),('8975','2013-10-20','10:45:00',3.6),('8975','2013-10-20','10:50:00',3.83),('8975','2013-10-20','10:55:00',3.75),('8975','2013-10-20','11:00:00',3.96),('8975','2013-10-20','11:05:00',3.79),('8975','2013-10-20','11:10:00',3.88),('8975','2013-10-20','11:15:00',4.1),('8975','2013-10-20','11:20:00',4.06),('8975','2013-10-20','11:25:00',3.88),('8975','2013-10-20','11:30:00',4.05),('8975','2013-10-20','11:35:00',3.9),('8975','2013-10-20','11:40:00',4.1),('8975','2013-10-20','11:45:00',4.12),('8975','2013-10-20','11:50:00',4.16),('8975','2013-10-20','11:55:00',4.15),('8975','2013-10-20','12:00:00',4.12),('8975','2013-10-20','12:05:00',4.12),('8975','2013-10-20','12:10:00',4.2),('8975','2013-10-20','12:15:00',4.05),('8975','2013-10-20','12:20:00',4.02),('8975','2013-10-20','12:25:00',3.89),('8975','2013-10-20','12:30:00',3.86),('8975','2013-10-20','12:35:00',3.93),('8975','2013-10-20','12:40:00',3.74),('8975','2013-10-20','12:45:00',3.89),('8975','2013-10-20','12:50:00',3.95),('8975','2013-10-20','12:55:00',3.9),('8975','2013-10-20','13:00:00',3.85),('8975','2013-10-20','13:05:00',3.77),('8975','2013-10-20','13:10:00',3.73),('8975','2013-10-20','13:15:00',3.77),('8975','2013-10-20','13:20:00',3.69),('8975','2013-10-20','13:25:00',3.65),('8975','2013-10-20','13:30:00',3.58),('8975','2013-10-20','13:35:00',3.49),('8975','2013-10-20','13:40:00',3.33),('8975','2013-10-20','13:45:00',3.34),('8975','2013-10-20','13:50:00',3.28),('8975','2013-10-20','13:55:00',2.89),('8975','2013-10-20','14:00:00',3.19),('8975','2013-10-20','14:05:00',3.22),('8975','2013-10-20','14:10:00',3.09),('8975','2013-10-20','14:15:00',3.07),('8975','2013-10-20','14:20:00',2.84),('8975','2013-10-20','14:25:00',2.74),('8975','2013-10-20','14:30:00',2.57),('8975','2013-10-20','14:35:00',2.57),('8975','2013-10-20','14:40:00',2.41),('8975','2013-10-20','14:45:00',2.37),('8975','2013-10-20','14:50:00',2.17),('8975','2013-10-20','14:55:00',2.23),('8975','2013-10-20','15:00:00',2.27),('8975','2013-10-20','15:05:00',2.22),('8975','2013-10-20','15:10:00',2.15),('8975','2013-10-20','15:15:00',2.11),('8975','2013-10-20','15:20:00',1.95),('8975','2013-10-20','15:25:00',1.88),('8975','2013-10-20','15:30:00',1.85),('8975','2013-10-20','15:35:00',1.77),('8975','2013-10-20','15:40:00',1.68),('8975','2013-10-20','15:45:00',1.61),('8975','2013-10-20','15:50:00',1.55),('8975','2013-10-20','15:55:00',1.48),('8975','2013-10-20','16:00:00',1.45),('8975','2013-10-20','16:05:00',1.41),('8975','2013-10-20','16:10:00',1.36),('8975','2013-10-20','16:15:00',1.29),('8975','2013-10-20','16:20:00',1.25),('8975','2013-10-20','16:25:00',1.22),('8975','2013-10-20','16:30:00',1.18),('8975','2013-10-20','16:35:00',1.14),('8975','2013-10-20','16:40:00',1.08),('8975','2013-10-20','16:45:00',1.03),('8975','2013-10-20','16:50:00',1),('8975','2013-10-19','08:15:00',1.41),('8975','2013-10-19','08:20:00',1.6),('8975','2013-10-19','08:25:00',1.77),('8975','2013-10-19','08:30:00',1.92),('8975','2013-10-19','08:35:00',2),('8975','2013-10-19','08:40:00',2.08),('8975','2013-10-19','08:45:00',2.21),('8975','2013-10-19','08:50:00',2.32),('8975','2013-10-19','08:55:00',2.31),('8975','2013-10-19','09:00:00',2.42),('8975','2013-10-19','09:05:00',2.53),('8975','2013-10-19','09:10:00',2.65),('8975','2013-10-19','09:15:00',2.73),('8975','2013-10-19','09:20:00',2.85),('8975','2013-10-19','09:25:00',2.92),('8975','2013-10-19','09:30:00',3),('8975','2013-10-19','09:35:00',3.06),('8975','2013-10-19','09:40:00',3.16),('8975','2013-10-19','09:45:00',3.23),('8975','2013-10-19','09:50:00',3.28),('8975','2013-10-19','09:55:00',3.32),('8975','2013-10-19','10:00:00',3.36),('8975','2013-10-19','10:05:00',3.47),('8975','2013-10-19','10:10:00',3.57),('8975','2013-10-19','10:15:00',3.64),('8975','2013-10-19','10:20:00',3.71),('8975','2013-10-19','10:25:00',3.78),('8975','2013-10-19','10:30:00',3.84),('8975','2013-10-19','10:35:00',3.89),('8975','2013-10-19','10:40:00',3.8),('8975','2013-10-19','10:45:00',3.77),('8975','2013-10-19','10:50:00',3.9),('8975','2013-10-19','10:55:00',4.02),('8975','2013-10-19','11:00:00',4.07),('8975','2013-10-19','11:05:00',4.12),('8975','2013-10-19','11:10:00',4.13),('8975','2013-10-19','11:15:00',4.19),('8975','2013-10-19','11:20:00',4.21),('8975','2013-10-19','11:25:00',4.23),('8975','2013-10-19','11:30:00',4.23),('8975','2013-10-19','11:35:00',4.23),('8975','2013-10-19','11:40:00',4.26),('8975','2013-10-19','11:45:00',4.23),('8975','2013-10-19','11:50:00',4.18),('8975','2013-10-19','11:55:00',4.24),('8975','2013-10-19','12:00:00',4.26),('8975','2013-10-19','12:05:00',3.9),('8975','2013-10-19','12:10:00',4.48),('8975','2013-10-19','12:15:00',3.19),('8975','2013-10-19','12:20:00',1.34),('8975','2013-10-19','12:25:00',3.86),('8975','2013-10-19','12:30:00',2.57),('8975','2013-10-19','12:35:00',2.49),('8975','2013-10-19','12:40:00',3.32),('8975','2013-10-19','12:45:00',3.01),('8975','2013-10-19','12:50:00',3.08),('8975','2013-10-19','12:55:00',2.63),('8975','2013-10-19','13:00:00',2.32),('8975','2013-10-19','13:05:00',2.38),('8975','2013-10-19','13:10:00',1.83),('8975','2013-10-19','13:15:00',3.37),('8975','2013-10-19','13:20:00',2.75),('8975','2013-10-19','13:25:00',3.23),('8975','2013-10-19','13:30:00',1.83),('8975','2013-10-19','13:35:00',2.31),('8975','2013-10-19','13:40:00',3.5),('8975','2013-10-19','13:45:00',2.66),('8975','2013-10-19','13:50:00',2.34),('8975','2013-10-19','13:55:00',2.06),('8975','2013-10-19','14:00:00',1.87),('8975','2013-10-19','14:05:00',1.58),('8975','2013-10-19','14:10:00',1.51),('8975','2013-10-19','14:15:00',1.31),('8975','2013-10-19','14:20:00',1.09),('8975','2013-10-19','14:25:00',1.35),('8975','2013-10-19','14:30:00',1.09),('8975','2013-10-19','14:35:00',1.15),('8975','2013-10-19','14:40:00',1.77),('8975','2013-10-19','14:45:00',1.32),('8975','2013-10-19','14:50:00',1.29),('8975','2013-10-19','14:55:00',1.24),('8975','2013-10-19','15:00:00',1.35),('8975','2013-10-19','15:05:00',1.09),('8975','2013-10-19','15:10:00',1),('8975','2013-10-19','15:15:00',1.09),('8975','2013-10-19','16:25:00',1.18),('8975','2013-10-19','16:30:00',1.49),('8975','2013-10-19','16:35:00',1.5),('8975','2013-10-19','16:40:00',1.59),('8975','2013-10-19','16:45:00',1.7),('8975','2013-10-19','16:50:00',1.7),('8975','2013-10-19','16:55:00',1.47),('8975','2013-10-19','17:00:00',1.18),('8975','2013-10-19','17:05:00',1.04),('8975','2013-10-18','08:20:00',1.63),('8975','2013-10-18','08:25:00',1.61),('8975','2013-10-18','08:30:00',1.84),('8975','2013-10-18','08:35:00',2.17),('8975','2013-10-18','08:40:00',2.17),('8975','2013-10-18','08:45:00',2.34),('8975','2013-10-18','08:50:00',2.86),('8975','2013-10-18','08:55:00',1.16),('8975','2013-10-18','09:00:00',1.83),('8975','2013-10-18','09:05:00',2.7),('8975','2013-10-18','09:10:00',2.47),('8975','2013-10-18','09:15:00',3.37),('8975','2013-10-18','09:20:00',3.4),('8975','2013-10-18','09:25:00',3.38),('8975','2013-10-18','09:30:00',3.44),('8975','2013-10-18','09:35:00',3.53),('8975','2013-10-18','09:40:00',3.61),('8975','2013-10-18','09:45:00',3.69),('8975','2013-10-18','09:50:00',3.77),('8975','2013-10-18','09:55:00',3.88),('8975','2013-10-18','10:00:00',3.72),('8975','2013-10-18','10:05:00',3.9),('8975','2013-10-18','10:10:00',3.29),('8975','2013-10-18','10:15:00',3.57),('8975','2013-10-18','10:20:00',3.29),('8975','2013-10-18','10:25:00',4.42),('8975','2013-10-18','10:30:00',4.46),('8975','2013-10-18','10:35:00',4.39),('8975','2013-10-18','10:40:00',4.28),('8975','2013-10-18','10:45:00',4.24),('8975','2013-10-18','10:50:00',4.37),('8975','2013-10-18','10:55:00',3.95),('8975','2013-10-18','11:00:00',4.18),('8975','2013-10-18','11:05:00',2.98),('8975','2013-10-18','11:10:00',2.83),('8975','2013-10-18','11:15:00',2.85),('8975','2013-10-18','11:20:00',3.92),('8975','2013-10-18','11:25:00',3.71),('8975','2013-10-18','11:30:00',4.82),('8975','2013-10-18','11:35:00',4.81),('8975','2013-10-18','11:40:00',4.81),('8975','2013-10-18','11:45:00',4.79),('8975','2013-10-18','11:50:00',4.57),('8975','2013-10-18','11:55:00',4.82),('8975','2013-10-18','12:00:00',4.77),('8975','2013-10-18','12:05:00',4.73),('8975','2013-10-18','12:10:00',4.62),('8975','2013-10-18','12:15:00',4.56),('8975','2013-10-18','12:20:00',4.25),('8975','2013-10-18','12:25:00',4.33),('8975','2013-10-18','12:30:00',4.4),('8975','2013-10-18','12:35:00',4.39),('8975','2013-10-18','12:40:00',4.57),('8975','2013-10-18','12:45:00',4.64),('8975','2013-10-18','12:50:00',4.49),('8975','2013-10-18','12:55:00',4.71),('8975','2013-10-18','13:00:00',5.08),('8975','2013-10-18','13:05:00',4.87),('8975','2013-10-18','13:10:00',4.27),('8975','2013-10-18','13:15:00',3.94),('8975','2013-10-18','13:20:00',4.6),('8975','2013-10-18','13:25:00',4.8),('8975','2013-10-18','13:30:00',4.62),('8975','2013-10-18','13:35:00',2.87),('8975','2013-10-18','13:40:00',2.37),('8975','2013-10-18','13:45:00',1.7),('8975','2013-10-18','13:50:00',1.97),('8975','2013-10-18','13:55:00',3.39),('8975','2013-10-18','14:00:00',3.7),('8975','2013-10-18','14:05:00',2.75),('8975','2013-10-18','14:10:00',2.03),('8975','2013-10-18','14:15:00',3.38),('8975','2013-10-18','14:20:00',2.78),('8975','2013-10-18','14:25:00',1.69),('8975','2013-10-18','14:30:00',2.53),('8975','2013-10-18','14:35:00',3.4),('8975','2013-10-18','14:40:00',2.55),('8975','2013-10-18','14:45:00',2.33),('8975','2013-10-18','14:50:00',3),('8975','2013-10-18','14:55:00',2.93),('8975','2013-10-18','15:00:00',2.79),('8975','2013-10-18','15:05:00',2.67),('8975','2013-10-18','15:10:00',2.6),('8975','2013-10-18','15:15:00',2.5),('8975','2013-10-18','15:20:00',2.24),('8975','2013-10-18','15:25:00',2.17),('8975','2013-10-18','15:30:00',2.03),('8975','2013-10-18','15:35:00',2),('8975','2013-10-18','15:40:00',1.83),('8975','2013-10-18','15:45:00',1.67),('8975','2013-10-18','15:50:00',1.6),('8975','2013-10-18','15:55:00',1.74),('8975','2013-10-18','16:00:00',1.52),('8975','2013-10-18','16:05:00',1.58),('8975','2013-10-18','16:10:00',1.57),('8975','2013-10-18','16:15:00',1.5),('8975','2013-10-18','16:20:00',1.5),('8975','2013-10-18','16:25:00',1.21),('8975','2013-10-18','16:30:00',1.44),('8975','2013-10-18','16:35:00',1.44),('8975','2013-10-18','16:40:00',1.44),('8975','2013-10-18','16:45:00',1.42),('8975','2013-10-18','16:50:00',1.21),('8975','2014-05-03','06:40:00',1.08),('8975','2014-05-03','07:10:00',1.64),('8975','2014-05-03','07:15:00',2.41),('8975','2014-05-03','07:20:00',2.78),('8975','2014-05-03','07:25:00',2.79),('8975','2014-05-03','07:35:00',1.44),('8975','2014-05-03','07:40:00',1.21),('8975','2014-05-03','07:45:00',2.28),('8975','2014-05-03','07:50:00',3.63),('8975','2014-05-03','07:55:00',3.69),('8975','2014-05-03','08:00:00',3.79),('8975','2014-05-03','08:05:00',3.94),('8975','2014-05-03','08:10:00',3.98),('8975','2014-05-03','08:15:00',4.04),('8975','2014-05-03','08:20:00',4.23),('8975','2014-05-03','08:25:00',4.32),('8975','2014-05-03','08:30:00',4.39),('8975','2014-05-03','08:35:00',4.61),('8975','2014-05-03','08:40:00',5.29),('8975','2014-05-03','08:45:00',4.5),('8975','2014-05-03','08:50:00',2.27),('8975','2014-05-03','08:55:00',5.36),('8975','2014-05-03','09:00:00',2.88),('8975','2014-05-03','09:05:00',3.63),('8975','2014-05-03','09:10:00',4.03),('8975','2014-05-03','09:15:00',3.5),('8975','2014-05-03','09:20:00',3.18),('8975','2014-05-03','09:25:00',6.67),('8975','2014-05-03','09:30:00',5.85),('8975','2014-05-03','09:35:00',3.17),('8975','2014-05-03','09:40:00',2.54),('8975','2014-05-03','09:45:00',2.8),('8975','2014-05-03','09:50:00',4.26),('8975','2014-05-03','09:55:00',5.29),('8975','2014-05-03','10:00:00',6.23),('8975','2014-05-03','10:05:00',6.96),('8975','2014-05-03','10:10:00',7.25),('8975','2014-05-03','10:15:00',6.03),('8975','2014-05-03','10:20:00',4.03),('8975','2014-05-03','10:25:00',4.3),('8975','2014-05-03','10:30:00',3.91),('8975','2014-05-03','10:35:00',3.71),('8975','2014-05-03','10:40:00',3.71),('8975','2014-05-03','10:45:00',4.02),('8975','2014-05-03','10:50:00',3.78),('8975','2014-05-03','10:55:00',4.12),('8975','2014-05-03','11:00:00',5.01),('8975','2014-05-03','11:05:00',5.5),('8975','2014-05-03','11:10:00',6.03),('8975','2014-05-03','11:15:00',6.15),('8975','2014-05-03','11:20:00',7.56),('8975','2014-05-03','11:25:00',7.12),('8975','2014-05-03','11:30:00',6.21),('8975','2014-05-03','11:35:00',7.78),('8975','2014-05-03','11:40:00',7.45),('8975','2014-05-03','11:45:00',6.04),('8975','2014-05-03','11:50:00',6.26),('8975','2014-05-03','11:55:00',7.48),('8975','2014-05-03','12:00:00',8.72),('8975','2014-05-03','12:05:00',8.4),('8975','2014-05-03','12:10:00',3.89),('8975','2014-05-03','12:15:00',3.6),('8975','2014-05-03','12:20:00',2.55),('8975','2014-05-03','12:25:00',2.55),('8975','2014-05-03','12:30:00',2.52),('8975','2014-05-03','12:35:00',2.14),('8975','2014-05-03','12:40:00',2.68),('8975','2014-05-03','12:45:00',2.31),('8975','2014-05-03','12:50:00',2.29),('8975','2014-05-03','12:55:00',2.43),('8975','2014-05-03','13:00:00',2.37),('8975','2014-05-03','13:05:00',2.2),('8975','2014-05-03','13:10:00',2.16),('8975','2014-05-03','13:15:00',2.35),('8975','2014-05-03','13:20:00',2.31),('8975','2014-05-03','13:25:00',2.27),('8975','2014-05-03','13:30:00',2.13),('8975','2014-05-03','13:35:00',2.33),('8975','2014-05-03','13:40:00',2.44),('8975','2014-05-03','13:45:00',2.34),('8975','2014-05-03','13:50:00',2.08),('8975','2014-05-03','13:55:00',2.12),('8975','2014-05-03','14:00:00',2.03),('8975','2014-05-03','14:05:00',1.97),('8975','2014-05-03','14:10:00',2.05),('8975','2014-05-03','14:15:00',2.13),('8975','2014-05-03','14:20:00',1.93),('8975','2014-05-03','14:25:00',1.51),('8975','2014-05-03','14:30:00',1.15),('8975','2014-05-03','14:35:00',1.04),('8975','2014-05-03','14:40:00',1.06),('8975','2014-05-03','14:45:00',1.14),('8975','2014-05-03','14:50:00',1.47),('8975','2014-05-03','14:55:00',2.08),('8975','2014-05-03','15:00:00',2.62),('8975','2014-05-03','15:05:00',3.09),('8975','2014-05-03','15:10:00',4.84),('8975','2014-05-03','15:15:00',6.57),('8975','2014-05-03','15:20:00',3.29),('8975','2014-05-03','15:25:00',4.09),('8975','2014-05-03','15:30:00',2.45),('8975','2014-05-03','15:35:00',1.52),('8975','2014-05-03','15:40:00',1.27),('8975','2014-05-03','15:45:00',1.38),('8975','2014-05-03','15:50:00',1.77),('8975','2014-05-03','15:55:00',2.07),('8975','2014-05-03','16:00:00',2.15),('8975','2014-05-03','16:05:00',2.3),('8975','2014-05-03','16:10:00',2.53),('8975','2014-05-03','16:15:00',2.25),('8975','2014-05-03','16:20:00',2.07),('8975','2014-05-03','16:25:00',1.76),('8975','2014-05-03','16:30:00',1.36),('8975','2014-05-03','16:35:00',1.08),('8975','2014-05-03','16:50:00',1.14),('8975','2014-05-03','16:55:00',1.22),('8975','2014-05-03','17:25:00',1.25),('8975','2014-05-03','17:30:00',1.26),('8975','2014-05-03','17:35:00',1.29),('8975','2014-05-03','17:40:00',1.33),('8975','2014-05-03','17:45:00',1.12),('8975','2014-04-15','07:15:00',1.68),('8975','2014-04-15','07:20:00',1.95),('8975','2014-04-15','07:25:00',2.14),('8975','2014-04-15','07:30:00',2.19),('8975','2014-04-15','07:35:00',2.41),('8975','2014-04-15','07:40:00',2.44),('8975','2014-04-15','07:45:00',2.87),('8975','2014-04-15','07:50:00',3.09),('8975','2014-04-15','07:55:00',3.12),('8975','2014-04-15','08:00:00',3.22),('8975','2014-04-15','08:05:00',3.32),('8975','2014-04-15','08:10:00',3.46),('8975','2014-04-15','08:15:00',3.62),('8975','2014-04-15','08:20:00',3.73),('8975','2014-04-15','08:25:00',3.89),('8975','2014-04-15','08:30:00',3.55),('8975','2014-04-15','08:35:00',2.35),('8975','2014-04-15','08:40:00',2.53),('8975','2014-04-15','08:45:00',3.67),('8975','2014-04-15','08:50:00',4.12),('8975','2014-04-15','08:55:00',4.49),('8975','2014-04-15','09:00:00',4.55),('8975','2014-04-15','09:05:00',4.61),('8975','2014-04-15','09:10:00',4.73),('8975','2014-04-15','09:15:00',4.81),('8975','2014-04-15','09:20:00',4.91),('8975','2014-04-15','09:25:00',5.16),('8975','2014-04-15','09:30:00',4.87),('8975','2014-04-15','09:35:00',3.01),('8975','2014-04-15','09:40:00',1.45),('8975','2014-04-15','09:45:00',1.38),('8975','2014-04-15','09:50:00',1.65),('8975','2014-04-15','09:55:00',4.04),('8975','2014-04-15','10:00:00',6.05),('8975','2014-04-15','10:05:00',5.99),('8975','2014-04-15','10:10:00',6.06),('8975','2014-04-15','10:15:00',6.14),('8975','2014-04-15','10:20:00',6.2),('8975','2014-04-15','10:25:00',6.28),('8975','2014-04-15','10:30:00',6.36),('8975','2014-04-15','10:35:00',6.41),('8975','2014-04-15','10:40:00',6.44),('8975','2014-04-15','10:45:00',6.54),('8975','2014-04-15','10:50:00',6.71),('8975','2014-04-15','10:55:00',6.42),('8975','2014-04-15','11:00:00',4.74),('8975','2014-04-15','11:05:00',4.56),('8975','2014-04-15','11:10:00',3.06),('8975','2014-04-15','11:15:00',3.71),('8975','2014-04-15','11:20:00',4.43),('8975','2014-04-15','11:25:00',8.11),('8975','2014-04-15','11:30:00',5.66),('8975','2014-04-15','11:35:00',5.7),('8975','2014-04-15','11:40:00',5.26),('8975','2014-04-15','11:45:00',6.95),('8975','2014-04-15','11:50:00',7.86),('8975','2014-04-15','11:55:00',7.16),('8975','2014-04-15','12:00:00',7.73),('8975','2014-04-15','12:05:00',7.41),('8975','2014-04-15','12:10:00',2.15),('8975','2014-04-15','12:15:00',6.09),('8975','2014-04-15','12:20:00',2.72),('8975','2014-04-15','12:25:00',2.28),('8975','2014-04-15','12:30:00',1.71),('8975','2014-04-15','12:35:00',4.62),('8975','2014-04-15','12:40:00',7.81),('8975','2014-04-15','12:45:00',7.37),('8975','2014-04-15','12:50:00',5.97),('8975','2014-04-15','12:55:00',2.15),('8975','2014-04-15','13:00:00',2.28),('8975','2014-04-15','13:05:00',2.42),('8975','2014-04-15','13:10:00',1.2),('8975','2014-04-15','13:15:00',1.27),('8975','2014-04-15','13:20:00',2.49),('8975','2014-04-15','13:25:00',1.76),('8975','2014-04-15','13:30:00',1.39),('8975','2014-04-15','13:35:00',1.84),('8975','2014-04-15','13:40:00',3.3),('8975','2014-04-15','13:45:00',7.21),('8975','2014-04-15','13:50:00',5.41),('8975','2014-04-15','13:55:00',7.46),('8975','2014-04-15','14:00:00',3.49),('8975','2014-04-15','14:05:00',2.95),('8975','2014-04-15','14:10:00',3.81),('8975','2014-04-15','14:15:00',4.79),('8975','2014-04-15','14:20:00',6.77),('8975','2014-04-15','14:25:00',5.65),('8975','2014-04-15','14:30:00',6.49),('8975','2014-04-15','14:35:00',6.19),('8975','2014-04-15','14:40:00',5.86),('8975','2014-04-15','14:45:00',6.04),('8975','2014-04-15','14:50:00',6.13),('8975','2014-04-15','14:55:00',4.53),('8975','2014-04-15','15:00:00',2.13),('8975','2014-04-15','15:05:00',3.15),('8975','2014-04-15','15:10:00',6),('8975','2014-04-15','15:15:00',6.39),('8975','2014-04-15','15:20:00',1.19),('8975','2014-04-15','15:25:00',1.4),('8975','2014-04-15','15:30:00',2.11),('8975','2014-04-15','15:35:00',4.86),('8975','2014-04-15','15:40:00',5.17),('8975','2014-04-15','15:45:00',4.72),('8975','2014-04-15','15:50:00',4.19),('8975','2014-04-15','15:55:00',3.65),('8975','2014-04-15','16:00:00',4.09),('8975','2014-04-15','16:05:00',3.89),('8975','2014-04-15','16:10:00',3.75),('8975','2014-04-15','16:15:00',3.64),('8975','2014-04-15','16:20:00',3.67),('8975','2014-04-15','16:25:00',3.45),('8975','2014-04-15','16:30:00',3.32),('8975','2014-04-15','16:35:00',3.22),('8975','2014-04-15','16:40:00',3.11),('8975','2014-04-15','16:45:00',2.98),('8975','2014-04-15','16:50:00',2.83),('8975','2014-04-15','16:55:00',2.67),('8975','2014-04-15','17:00:00',2.56),('8975','2014-04-15','17:05:00',2.42),('8975','2014-04-15','17:10:00',2.3),('8975','2014-04-15','17:15:00',2.23),('8975','2014-04-15','17:20:00',2.09),('8975','2014-04-15','17:25:00',1.97),('8975','2014-04-15','17:30:00',1.89),('8975','2014-04-15','17:35:00',1.83),('8975','2014-04-15','17:40:00',1.77),('8975','2014-04-15','17:45:00',1.78),('8975','2014-04-15','17:50:00',1.93),('8975','2014-04-15','17:55:00',2.06),('8975','2014-04-15','18:00:00',1.84),('8975','2014-04-15','18:05:00',1.81),('8975','2014-04-15','18:10:00',1.75),('8975','2014-04-15','18:15:00',1.5),('8975','2014-04-15','18:20:00',1.55),('8975','2014-04-15','18:25:00',1.44),('8975','2014-04-15','18:30:00',1.29),('8975','2014-04-15','18:35:00',1.31),('8975','2014-04-15','18:40:00',1.11),('8975','2014-04-15','18:45:00',1.33),('8975','2014-04-15','18:50:00',1.36),('8975','2014-04-15','18:55:00',1.24),('8975','2013-10-17','07:55:00',1.13),('8975','2013-10-17','08:00:00',1.51),('8975','2013-10-17','08:05:00',1.68),('8975','2013-10-17','08:10:00',1.88),('8975','2013-10-17','08:15:00',1.83),('8975','2013-10-17','08:20:00',1.92),('8975','2013-10-17','08:25:00',2.03),('8975','2013-10-17','08:30:00',2.05),('8975','2013-10-17','08:35:00',2.28),('8975','2013-10-17','08:40:00',2.42),('8975','2013-10-17','08:45:00',2.55),('8975','2013-10-17','08:50:00',2.54),('8975','2013-10-17','08:55:00',2.57),('8975','2013-10-17','09:00:00',2.69),('8975','2013-10-17','09:05:00',2.92),('8975','2013-10-17','09:10:00',2.99),('8975','2013-10-17','09:15:00',3.03),('8975','2013-10-17','09:20:00',3.24),('8975','2013-10-17','09:25:00',3.33),('8975','2013-10-17','09:30:00',3.37),('8975','2013-10-17','09:35:00',3.48),('8975','2013-10-17','09:40:00',3.57),('8975','2013-10-17','09:45:00',3.63),('8975','2013-10-17','09:50:00',3.7),('8975','2013-10-17','09:55:00',3.75),('8975','2013-10-17','10:00:00',3.82),('8975','2013-10-17','10:05:00',3.89),('8975','2013-10-17','10:10:00',3.91),('8975','2013-10-17','10:15:00',3.99),('8975','2013-10-17','10:20:00',4.03),('8975','2013-10-17','10:25:00',4.13),('8975','2013-10-17','10:30:00',4.22),('8975','2013-10-17','10:35:00',4.26),('8975','2013-10-17','10:40:00',4.23),('8975','2013-10-17','10:45:00',4.31),('8975','2013-10-17','10:50:00',4.26),('8975','2013-10-17','10:55:00',4.2),('8975','2013-10-17','11:00:00',4.37),('8975','2013-10-17','11:05:00',4.4),('8975','2013-10-17','11:10:00',4.35),('8975','2013-10-17','11:15:00',4.29),('8975','2013-10-17','11:20:00',4.52),('8975','2013-10-17','11:25:00',4.52),('8975','2013-10-17','11:30:00',4.49),('8975','2013-10-17','11:35:00',4.56),('8975','2013-10-17','11:40:00',4.64),('8975','2013-10-17','11:45:00',3.1),('8975','2013-10-17','11:50:00',3.85),('8975','2013-10-17','11:55:00',4.53),('8975','2013-10-17','12:00:00',4.48),('8975','2013-10-17','12:05:00',3.06),('8975','2013-10-17','12:10:00',3.92),('8975','2013-10-17','12:15:00',4.24),('8975','2013-10-17','12:20:00',4.21),('8975','2013-10-17','12:25:00',3.9),('8975','2013-10-17','12:30:00',3.81),('8975','2013-10-17','12:35:00',4),('8975','2013-10-17','12:40:00',3.84),('8975','2013-10-17','12:45:00',3.68),('8975','2013-10-17','12:50:00',3.64),('8975','2013-10-17','12:55:00',4.14),('8975','2013-10-17','13:00:00',4.1),('8975','2013-10-17','13:05:00',3.95),('8975','2013-10-17','13:10:00',3.79),('8975','2013-10-17','13:15:00',3.77),('8975','2013-10-17','13:20:00',3.94),('8975','2013-10-17','13:25:00',3.95),('8975','2013-10-17','13:30:00',3.96),('8975','2013-10-17','13:35:00',3.74),('8975','2013-10-17','13:40:00',3.63),('8975','2013-10-17','13:45:00',3.45),('8975','2013-10-17','13:50:00',3.44),('8975','2013-10-17','13:55:00',3.49),('8975','2013-10-17','14:00:00',3.34),('8975','2013-10-17','14:05:00',3.21),('8975','2013-10-17','14:10:00',3.16),('8975','2013-10-17','14:15:00',3.22),('8975','2013-10-17','14:20:00',3.06),('8975','2013-10-17','14:25:00',2.93),('8975','2013-10-17','14:30:00',2.94),('8975','2013-10-17','14:35:00',2.79),('8975','2013-10-17','14:40:00',2.8),('8975','2013-10-17','14:45:00',2.59),('8975','2013-10-17','14:50:00',2.5),('8975','2013-10-17','14:55:00',2.4),('8975','2013-10-17','15:00:00',2.27),('8975','2013-10-17','15:05:00',2.08),('8975','2013-10-17','15:10:00',2.18),('8975','2013-10-17','15:15:00',2.17),('8975','2013-10-17','15:20:00',2.19),('8975','2013-10-17','15:25:00',2.03),('8975','2013-10-17','15:30:00',1.83),('8975','2013-10-17','15:35:00',1.83),('8975','2013-10-17','15:40:00',1.7),('8975','2013-10-17','15:45:00',1.58),('8975','2013-10-17','15:50:00',1.43),('8975','2013-10-17','15:55:00',1.4),('8975','2013-10-17','16:00:00',1.46),('8975','2013-10-17','16:05:00',1.4),('8975','2013-10-17','16:10:00',1.42),('8975','2013-10-17','16:15:00',1.25),('8975','2013-10-17','16:20:00',1.23),('8975','2013-10-17','16:25:00',1.11),('8975','2013-10-17','16:30:00',1.07),('8975','2013-10-17','16:35:00',1.03),('8975','2013-10-16','08:00:00',1.35),('8975','2013-10-16','08:05:00',1.49),('8975','2013-10-16','08:10:00',1.65),('8975','2013-10-16','08:15:00',1.82),('8975','2013-10-16','08:20:00',1.99),('8975','2013-10-16','08:25:00',2.13),('8975','2013-10-16','08:30:00',2.25),('8975','2013-10-16','08:35:00',2.37),('8975','2013-10-16','08:40:00',2.48),('8975','2013-10-16','08:45:00',2.58),('8975','2013-10-16','08:50:00',2.69),('8975','2013-10-16','08:55:00',2.78),('8975','2013-10-16','09:00:00',2.85),('8975','2013-10-16','09:05:00',2.95),('8975','2013-10-16','09:10:00',3.03),('8975','2013-10-16','09:15:00',3.12),('8975','2013-10-16','09:20:00',3.2),('8975','2013-10-16','09:25:00',3.3),('8975','2013-10-16','09:30:00',3.38),('8975','2013-10-16','09:35:00',3.47),('8975','2013-10-16','09:40:00',3.56),('8975','2013-10-16','09:45:00',3.64),('8975','2013-10-16','09:50:00',3.69),('8975','2013-10-16','09:55:00',3.73),('8975','2013-10-16','10:00:00',3.77),('8975','2013-10-16','10:05:00',3.86),('8975','2013-10-16','10:10:00',3.93),('8975','2013-10-16','10:15:00',4.02),('8975','2013-10-16','10:20:00',4.1),('8975','2013-10-16','10:25:00',4.16),('8975','2013-10-16','10:30:00',4.22),('8975','2013-10-16','10:35:00',4.23),('8975','2013-10-16','10:40:00',4.24),('8975','2013-10-16','10:45:00',4.36),('8975','2013-10-16','10:50:00',4.4),('8975','2013-10-16','10:55:00',4.44),('8975','2013-10-16','11:00:00',4.44),('8975','2013-10-16','11:05:00',4.53),('8975','2013-10-16','11:10:00',4.57),('8975','2013-10-16','11:15:00',4.6),('8975','2013-10-16','11:20:00',4.63),('8975','2013-10-16','11:25:00',4.64),('8975','2013-10-16','11:30:00',4.66),('8975','2013-10-16','11:35:00',4.69),('8975','2013-10-16','11:40:00',4.7),('8975','2013-10-16','11:45:00',4.71),('8975','2013-10-16','11:50:00',4.72),('8975','2013-10-16','11:55:00',4.73),('8975','2013-10-16','12:00:00',4.68),('8975','2013-10-16','12:05:00',4.73),('8975','2013-10-16','12:10:00',4.73),('8975','2013-10-16','12:15:00',4.69),('8975','2013-10-16','12:20:00',4.66),('8975','2013-10-16','12:25:00',4.63),('8975','2013-10-16','12:30:00',4.58),('8975','2013-10-16','12:35:00',4.51),('8975','2013-10-16','12:40:00',4.49),('8975','2013-10-16','12:45:00',4.49),('8975','2013-10-16','12:50:00',4.5),('8975','2013-10-16','12:55:00',4.45),('8975','2013-10-16','13:00:00',4.4),('8975','2013-10-16','13:05:00',4.4),('8975','2013-10-16','13:10:00',4.34),('8975','2013-10-16','13:15:00',4.28),('8975','2013-10-16','13:20:00',4.24),('8975','2013-10-16','13:25:00',4.19),('8975','2013-10-16','13:30:00',4.12),('8975','2013-10-16','13:35:00',3.92),('8975','2013-10-16','13:40:00',3.58),('8975','2013-10-16','13:45:00',3.68),('8975','2013-10-16','13:50:00',3.26),('8975','2013-10-16','13:55:00',3.36),('8975','2013-10-16','14:00:00',3.37),('8975','2013-10-16','14:05:00',3.12),('8975','2013-10-16','14:10:00',3.49),('8975','2013-10-16','14:15:00',3.11),('8975','2013-10-16','14:20:00',2.88),('8975','2013-10-16','14:25:00',3.01),('8975','2013-10-16','14:30:00',3.02),('8975','2013-10-16','14:35:00',2.74),('8975','2013-10-16','14:40:00',2.72),('8975','2013-10-16','14:45:00',2.86),('8975','2013-10-16','14:50:00',2.69),('8975','2013-10-16','14:55:00',2.48),('8975','2013-10-16','15:00:00',2.57),('8975','2013-10-16','15:05:00',2.53),('8975','2013-10-16','15:10:00',2.43),('8975','2013-10-16','15:15:00',2.37),('8975','2013-10-16','15:20:00',2.31),('8975','2013-10-16','15:25:00',2.2),('8975','2013-10-16','15:30:00',2.11),('8975','2013-10-16','15:35:00',2.03),('8975','2013-10-16','15:40:00',1.93),('8975','2013-10-16','15:45:00',1.83),('8975','2013-10-16','15:50:00',1.75),('8975','2013-10-16','15:55:00',1.68),('8975','2013-10-16','16:00:00',1.61),('8975','2013-10-16','16:05:00',1.54),('8975','2013-10-16','16:10:00',1.49),('8975','2013-10-16','16:15:00',1.44),('8975','2013-10-16','16:20:00',1.4),('8975','2013-10-16','16:25:00',1.34),('8975','2013-10-16','16:30:00',1.32),('8975','2013-10-16','16:35:00',1.29),('8975','2013-10-16','16:40:00',1.25),('8975','2013-10-16','16:45:00',1.21),('8975','2013-10-16','16:50:00',1.17),('8975','2013-10-16','16:55:00',1.13),('8975','2013-10-16','17:00:00',1.08),('8975','2013-10-16','17:05:00',1.03),('8975','2013-10-15','08:30:00',1.7),('8975','2013-10-15','09:45:00',2.79),('8975','2013-10-15','09:50:00',4.66),('8975','2013-10-15','09:55:00',2.28),('8975','2013-10-15','10:00:00',1.35),('8975','2013-10-15','11:05:00',1.63),('8975','2013-10-15','11:10:00',1.82),('8975','2013-10-15','11:15:00',1.49),('8975','2013-10-15','11:20:00',2.18),('8975','2013-10-15','11:25:00',1.3),('8975','2013-10-15','11:55:00',1.37),('8975','2013-10-15','12:00:00',1.8),('8975','2013-10-15','12:10:00',1.25),('8975','2013-10-15','12:15:00',1.97),('8975','2013-10-15','12:20:00',1.58),('8975','2013-10-15','12:25:00',1.53),('8975','2013-10-15','12:30:00',2.48),('8975','2013-10-15','12:35:00',4.24),('8975','2013-10-15','12:40:00',3.16),('8975','2013-10-15','12:45:00',4.45),('8975','2013-10-15','12:50:00',3.2),('8975','2013-10-15','12:55:00',4.28),('8975','2013-10-15','13:00:00',4.04),('8975','2013-10-15','13:05:00',2.9),('8975','2013-10-15','13:10:00',2.19),('8975','2013-10-15','13:15:00',4.36),('8975','2013-10-15','13:20:00',3.27),('8975','2013-10-15','13:25:00',3.88),('8975','2013-10-15','13:30:00',3.23),('8975','2013-10-15','13:35:00',3.91),('8975','2013-10-15','13:40:00',2.69),('8975','2013-10-15','13:45:00',3.66),('8975','2013-10-15','13:50:00',3.4),('8975','2013-10-15','13:55:00',3.67),('8975','2013-10-15','14:00:00',3.45),('8975','2013-10-15','14:05:00',3.1),('8975','2013-10-15','14:10:00',2.82),('8975','2013-10-15','14:15:00',2.95),('8975','2013-10-15','14:20:00',3.57),('8975','2013-10-15','14:25:00',2.82),('8975','2013-10-15','14:30:00',3.32),('8975','2013-10-15','14:35:00',3.39),('8975','2013-10-15','14:40:00',3.19),('8975','2013-10-15','14:45:00',3.04),('8975','2013-10-15','14:50:00',2.98),('8975','2013-10-15','14:55:00',2.16),('8975','2013-10-15','15:00:00',2.71),('8975','2013-10-15','15:05:00',2.64),('8975','2013-10-15','15:10:00',3.07),('8975','2013-10-15','15:15:00',2.58),('8975','2013-10-15','15:20:00',2.44),('8975','2013-10-15','15:25:00',2.1),('8975','2013-10-15','15:30:00',2.44),('8975','2013-10-15','15:35:00',2.95),('8975','2013-10-15','15:40:00',2.3),('8975','2013-10-15','15:45:00',1.94),('8975','2013-10-15','15:50:00',1.79),('8975','2013-10-15','15:55:00',1.71),('8975','2013-10-15','16:00:00',1.68),('8975','2013-10-15','16:05:00',1.63),('8975','2013-10-15','16:10:00',1.58),('8975','2013-10-15','16:15:00',1.54),('8975','2013-10-15','16:20:00',1.47),('8975','2013-10-15','16:25:00',1.42),('8975','2013-10-15','16:30:00',1.4),('8975','2013-10-15','16:35:00',1.38),('8975','2013-10-15','16:40:00',1.35),('8975','2013-10-15','16:45:00',1.26),('8975','2013-10-15','16:50:00',1.25),('8975','2013-10-15','16:55:00',1.21),('8975','2013-10-15','17:00:00',1.14),('8975','2013-10-15','17:05:00',1.09),('8975','2013-10-15','17:10:00',1.05),('8975','2013-10-14','08:30:00',1.03),('8975','2013-10-14','08:35:00',1.06),('8975','2013-10-14','08:40:00',1.03),('8975','2013-10-14','08:55:00',1.13),('8975','2013-10-14','09:00:00',1.55),('8975','2013-10-14','09:05:00',1.72),('8975','2013-10-14','09:10:00',1.76),('8975','2013-10-14','09:15:00',1.52),('8975','2013-10-14','09:20:00',1.94),('8975','2013-10-14','09:25:00',1.8),('8975','2013-10-14','09:30:00',2.72),('8975','2013-10-14','09:35:00',1.97),('8975','2013-10-14','09:40:00',2.41),('8975','2013-10-14','09:45:00',3.1),('8975','2013-10-14','09:50:00',3.4),('8975','2013-10-14','09:55:00',3.49),('8975','2013-10-14','10:00:00',3.5),('8975','2013-10-14','10:05:00',4.17),('8975','2013-10-14','10:10:00',3.18),('8975','2013-10-14','10:15:00',1.75),('8975','2013-10-14','10:20:00',1.7),('8975','2013-10-14','10:25:00',2.34),('8975','2013-10-14','10:30:00',3.69),('8975','2013-10-14','10:35:00',2.27),('8975','2013-10-14','10:40:00',2.58),('8975','2013-10-14','10:45:00',3.38),('8975','2013-10-14','10:50:00',3.71),('8975','2013-10-14','10:55:00',3.03),('8975','2013-10-14','11:00:00',3.01),('8975','2013-10-14','11:05:00',3.09),('8975','2013-10-14','11:10:00',3.66),('8975','2013-10-14','11:15:00',4.46),('8975','2013-10-14','11:20:00',4.31),('8975','2013-10-14','11:25:00',3.99),('8975','2013-10-14','11:30:00',4.08),('8975','2013-10-14','11:35:00',3.47),('8975','2013-10-14','11:40:00',2.82),('8975','2013-10-14','11:45:00',2.35),('8975','2013-10-14','11:50:00',2.24),('8975','2013-10-14','11:55:00',2.25),('8975','2013-10-14','12:00:00',2.33),('8975','2013-10-14','12:05:00',2.35),('8975','2013-10-14','12:10:00',2.31),('8975','2013-10-14','12:15:00',2.36),('8975','2013-10-14','12:20:00',2.42),('8975','2013-10-14','12:25:00',2.34),('8975','2013-10-14','12:30:00',2.19),('8975','2013-10-14','12:35:00',2.12),('8975','2013-10-14','12:40:00',2.17),('8975','2013-10-14','12:45:00',2.31),('8975','2013-10-14','12:50:00',2.16),('8975','2013-10-14','12:55:00',1.96),('8975','2013-10-14','13:00:00',1.94),('8975','2013-10-14','13:05:00',2.41),('8975','2013-10-14','13:10:00',2.69),('8975','2013-10-14','13:15:00',2.62),('8975','2013-10-14','13:20:00',3.42),('8975','2013-10-14','13:25:00',3.83),('8975','2013-10-14','13:30:00',2.71),('8975','2013-10-14','13:35:00',2.33),('8975','2013-10-14','13:40:00',2.37),('8975','2013-10-14','13:45:00',2.45),('8975','2013-10-14','13:50:00',2.27),('8975','2013-10-14','13:55:00',2.04),('8975','2013-10-14','14:00:00',1.84),('8975','2013-10-14','14:05:00',1.79),('8975','2013-10-14','14:10:00',1.98),('8975','2013-10-14','14:15:00',2.57),('8975','2013-10-14','14:20:00',2.7),('8975','2013-10-14','14:25:00',2.48),('8975','2013-10-14','14:30:00',2.74),('8975','2013-10-14','14:35:00',1.78),('8975','2013-10-14','14:40:00',2.42),('8975','2013-10-14','14:45:00',3.01),('8975','2013-10-14','14:50:00',2.44),('8975','2013-10-14','14:55:00',1.64),('8975','2013-10-14','15:00:00',1.51),('8975','2013-10-14','15:05:00',1.81),('8975','2013-10-14','15:10:00',1.61),('8975','2013-10-14','15:15:00',1.66),('8975','2013-10-14','15:20:00',1.66),('8975','2013-10-14','15:25:00',1.42),('8975','2013-10-14','15:30:00',1.48),('8975','2013-10-14','15:35:00',1.5),('8975','2013-10-14','15:40:00',1.56),('8975','2013-10-14','15:45:00',1.54),('8975','2013-10-14','15:50:00',1.4),('8975','2013-10-14','15:55:00',1.12),('8975','2013-10-14','16:00:00',1.11),('8975','2013-10-14','16:05:00',1.11),('8975','2013-10-14','16:10:00',1.18),('8975','2013-10-14','16:15:00',1.1),('8975','2013-10-14','16:25:00',1.2),('8975','2013-10-14','16:30:00',1.54),('8975','2013-10-14','16:35:00',1.57),('8975','2013-10-14','16:40:00',1.29),('8975','2013-10-14','16:45:00',1.03),('8975','2013-10-13','08:00:00',1.16),('8975','2013-10-13','08:05:00',1.45),('8975','2013-10-13','08:10:00',1.58),('8975','2013-10-13','08:15:00',1.45),('8975','2013-10-13','08:20:00',1.76),('8975','2013-10-13','08:25:00',2.15),('8975','2013-10-13','08:30:00',2.18),('8975','2013-10-13','08:35:00',2.3),('8975','2013-10-13','08:40:00',2.03),('8975','2013-10-13','08:45:00',2.49),('8975','2013-10-13','08:50:00',2.41),('8975','2013-10-13','08:55:00',2.41),('8975','2013-10-13','09:00:00',2.17),('8975','2013-10-13','09:05:00',2.28),('8975','2013-10-13','09:10:00',2.04),('8975','2013-10-13','09:15:00',1.55),('8975','2013-10-13','09:20:00',2.08),('8975','2013-10-13','09:25:00',2.85),('8975','2013-10-13','09:30:00',3.26),('8975','2013-10-13','09:35:00',3.25),('8975','2013-10-13','09:40:00',2.33),('8975','2013-10-13','09:45:00',2.3),('8975','2013-10-13','09:50:00',2.71),('8975','2013-10-13','09:55:00',3.15),('8975','2013-10-13','10:00:00',3),('8975','2013-10-13','10:05:00',3.44),('8975','2013-10-13','10:10:00',3.57),('8975','2013-10-13','10:15:00',3.93),('8975','2013-10-13','10:20:00',3.97),('8975','2013-10-13','10:25:00',4.01),('8975','2013-10-13','10:30:00',4.03),('8975','2013-10-13','10:35:00',3.99),('8975','2013-10-13','10:40:00',3.98),('8975','2013-10-13','10:45:00',4.07),('8975','2013-10-13','10:50:00',4.19),('8975','2013-10-13','10:55:00',4.27),('8975','2013-10-13','11:00:00',4.29),('8975','2013-10-13','11:05:00',4.34),('8975','2013-10-13','11:10:00',4.46),('8975','2013-10-13','11:15:00',4.36),('8975','2013-10-13','11:20:00',4.4),('8975','2013-10-13','11:25:00',4.48),('8975','2013-10-13','11:30:00',4.54),('8975','2013-10-13','11:35:00',4.38),('8975','2013-10-13','11:40:00',4.46),('8975','2013-10-13','11:45:00',4.45),('8975','2013-10-13','11:50:00',4.41),('8975','2013-10-13','11:55:00',4.43),('8975','2013-10-13','12:00:00',4.44),('8975','2013-10-13','12:05:00',4.47),('8975','2013-10-13','12:10:00',4.54),('8975','2013-10-13','12:15:00',4.4),('8975','2013-10-13','12:20:00',4.17),('8975','2013-10-13','12:25:00',4.39),('8975','2013-10-13','12:30:00',4.49),('8975','2013-10-13','12:35:00',4.3),('8975','2013-10-13','12:40:00',4.23),('8975','2013-10-13','12:45:00',4.28),('8975','2013-10-13','12:50:00',4.3),('8975','2013-10-13','12:55:00',4.25),('8975','2013-10-13','13:00:00',4.21),('8975','2013-10-13','13:05:00',4.15),('8975','2013-10-13','13:10:00',4.1),('8975','2013-10-13','13:15:00',4.03),('8975','2013-10-13','13:20:00',4),('8975','2013-10-13','13:25:00',3.97),('8975','2013-10-13','13:30:00',3.92),('8975','2013-10-13','13:35:00',3.82),('8975','2013-10-13','13:40:00',3.63),('8975','2013-10-13','13:45:00',3.55),('8975','2013-10-13','13:50:00',3.63),('8975','2013-10-13','13:55:00',3.48),('8975','2013-10-13','14:00:00',3.23),('8975','2013-10-13','14:05:00',3.07),('8975','2013-10-13','14:10:00',2.96),('8975','2013-10-13','14:15:00',3.32),('8975','2013-10-13','14:20:00',2.94),('8975','2013-10-13','14:25:00',3.02),('8975','2013-10-13','14:30:00',3.04),('8975','2013-10-13','14:35:00',2.8),('8975','2013-10-13','14:40:00',2.92),('8975','2013-10-13','14:45:00',2.82),('8975','2013-10-13','14:50:00',2.71),('8975','2013-10-13','14:55:00',2.5),('8975','2013-10-13','15:00:00',2.27),('8975','2013-10-13','15:05:00',2.51),('8975','2013-10-13','15:10:00',2.42),('8975','2013-10-13','15:15:00',2.34),('8975','2013-10-13','15:20:00',2.28),('8975','2013-10-13','15:25:00',2.19),('8975','2013-10-13','15:30:00',2.11),('8975','2013-10-13','15:35:00',2),('8975','2013-10-13','15:40:00',1.86),('8975','2013-10-13','15:45:00',1.39),('8975','2013-10-13','15:50:00',1.6),('8975','2013-10-13','15:55:00',1.46),('8975','2013-10-13','16:00:00',1.02),('8975','2013-10-13','16:05:00',1.48),('8975','2013-10-13','16:10:00',1.19),('8975','2013-10-13','16:15:00',1.25),('8975','2013-10-13','16:25:00',1.14),('8975','2013-10-13','16:30:00',1.04),('8975','2013-10-12','08:15:00',1.09),('8975','2013-10-12','08:20:00',1.23),('8975','2013-10-12','08:25:00',1.22),('8975','2013-10-12','08:30:00',1.56),('8975','2013-10-12','08:35:00',1.81),('8975','2013-10-12','08:40:00',1.85),('8975','2013-10-12','08:45:00',1.58),('8975','2013-10-12','08:50:00',1.67),('8975','2013-10-12','08:55:00',1.95),('8975','2013-10-12','09:00:00',2.16),('8975','2013-10-12','09:05:00',2.17),('8975','2013-10-12','09:10:00',2.35),('8975','2013-10-12','09:15:00',3.18),('8975','2013-10-12','09:20:00',3.31),('8975','2013-10-12','09:25:00',3.08),('8975','2013-10-12','09:30:00',2.44),('8975','2013-10-12','09:35:00',2.89),('8975','2013-10-12','09:40:00',3.99),('8975','2013-10-12','09:45:00',4.44),('8975','2013-10-12','09:50:00',4.47),('8975','2013-10-12','09:55:00',4.52),('8975','2013-10-12','10:00:00',3.1),('8975','2013-10-12','10:05:00',2.53),('8975','2013-10-12','10:10:00',3.78),('8975','2013-10-12','10:15:00',3.76),('8975','2013-10-12','10:20:00',3.46),('8975','2013-10-12','10:25:00',4.33),('8975','2013-10-12','10:30:00',4.52),('8975','2013-10-12','10:35:00',4.79),('8975','2013-10-12','10:40:00',4.72),('8975','2013-10-12','10:45:00',5.04),('8975','2013-10-12','10:50:00',3.54),('8975','2013-10-12','10:55:00',4.34),('8975','2013-10-12','11:00:00',4.54),('8975','2013-10-12','11:05:00',5.19),('8975','2013-10-12','11:10:00',5.24),('8975','2013-10-12','11:15:00',4.71),('8975','2013-10-12','11:20:00',4.59),('8975','2013-10-12','11:25:00',4.53),('8975','2013-10-12','11:30:00',4.6),('8975','2013-10-12','11:35:00',4.54),('8975','2013-10-12','11:40:00',4.54),('8975','2013-10-12','11:45:00',4.55),('8975','2013-10-12','11:50:00',4.59),('8975','2013-10-12','11:55:00',4.59),('8975','2013-10-12','12:00:00',4.57),('8975','2013-10-12','12:05:00',4.58),('8975','2013-10-12','12:10:00',4.57),('8975','2013-10-12','12:15:00',4.56),('8975','2013-10-12','12:20:00',4.39),('8975','2013-10-12','12:25:00',4.27),('8975','2013-10-12','12:30:00',4.51),('8975','2013-10-12','12:35:00',4.43),('8975','2013-10-12','12:40:00',4.41),('8975','2013-10-12','12:45:00',4.39),('8975','2013-10-12','12:50:00',4.3),('8975','2013-10-12','12:55:00',4.22),('8975','2013-10-12','13:00:00',4.25),('8975','2013-10-12','13:05:00',4.24),('8975','2013-10-12','13:10:00',4.19),('8975','2013-10-12','13:15:00',4.22),('8975','2013-10-12','13:20:00',3.98),('8975','2013-10-12','13:25:00',3.84),('8975','2013-10-12','13:30:00',3.35),('8975','2013-10-12','13:35:00',3.15),('8975','2013-10-12','13:40:00',2.63),('8975','2013-10-12','13:45:00',2.4),('8975','2013-10-12','13:50:00',2.94),('8975','2013-10-12','13:55:00',3.82),('8975','2013-10-12','14:00:00',4.08),('8975','2013-10-12','14:05:00',3.88),('8975','2013-10-12','14:10:00',3.63),('8975','2013-10-12','14:15:00',3.17),('8975','2013-10-12','14:20:00',3.66),('8975','2013-10-12','14:25:00',3.68),('8975','2013-10-12','14:30:00',2.71),('8975','2013-10-12','14:35:00',3.11),('8975','2013-10-12','14:40:00',3.07),('8975','2013-10-12','14:45:00',1.95),('8975','2013-10-12','14:50:00',2.52),('8975','2013-10-12','14:55:00',2.49),('8975','2013-10-12','15:00:00',2.9),('8975','2013-10-12','15:05:00',2.18),('8975','2013-10-12','15:10:00',2.33),('8975','2013-10-12','15:15:00',2.58),('8975','2013-10-12','15:20:00',2.69),('8975','2013-10-12','15:25:00',2.73),('8975','2013-10-12','15:30:00',2.06),('8975','2013-10-12','15:35:00',1.74),('8975','2013-10-12','15:40:00',1.96),('8975','2013-10-12','15:45:00',1.93),('8975','2013-10-12','15:50:00',1.8),('8975','2013-10-12','15:55:00',1.74),('8975','2013-10-12','16:00:00',1.72),('8975','2013-10-12','16:05:00',1.89),('8975','2013-10-12','16:10:00',1.95),('8975','2013-10-12','16:15:00',1.88),('8975','2013-10-12','16:20:00',1.86),('8975','2013-10-12','16:25:00',1.94),('8975','2013-10-12','16:30:00',1.7),('8975','2013-10-12','16:35:00',1.53),('8975','2013-10-12','16:40:00',1.32),('8975','2013-10-12','16:45:00',1.24),('8975','2013-10-12','16:50:00',1.11),('8975','2013-10-12','16:55:00',1),('8975','2013-10-12','17:25:00',1.15),('8975','2013-10-11','11:00:00',1.11),('8975','2013-10-11','11:05:00',1.19),('8975','2013-10-11','11:10:00',1.26),('8975','2013-10-11','11:15:00',1.44),('8975','2013-10-11','11:20:00',1.66),('8975','2013-10-11','11:25:00',1.81),('8975','2013-10-11','11:30:00',2.1),('8975','2013-10-11','11:35:00',2.85),('8975','2013-10-11','11:40:00',4.41),('8975','2013-10-11','11:45:00',2.55),('8975','2013-10-11','11:50:00',2.47),('8975','2013-10-11','11:55:00',2.09),('8975','2013-10-11','12:00:00',1.38),('8975','2013-10-11','12:10:00',1.26),('8975','2013-10-11','12:15:00',1.79),('8975','2013-10-11','12:20:00',3.83),('8975','2013-10-11','12:25:00',5.38),('8975','2013-10-11','12:30:00',4.44),('8975','2013-10-11','12:35:00',4.7),('8975','2013-10-11','12:40:00',4.32),('8975','2013-10-11','12:45:00',2.85),('8975','2013-10-11','12:50:00',2.74),('8975','2013-10-11','12:55:00',2.36),('8975','2013-10-11','13:00:00',2.13),('8975','2013-10-11','13:05:00',1.72),('8975','2013-10-11','13:10:00',1.49),('8975','2013-10-11','13:15:00',2.05),('8975','2013-10-11','13:20:00',1.97),('8975','2013-10-11','13:25:00',2.73),('8975','2013-10-11','13:30:00',5.14),('8975','2013-10-11','13:35:00',2.41),('8975','2013-10-11','13:40:00',1.27),('8975','2013-10-11','13:55:00',1),('8975','2013-10-11','14:00:00',1.1),('8975','2013-10-11','15:20:00',1.03),('8975','2013-10-11','15:25:00',1.22),('8975','2013-10-11','15:30:00',1.29),('8975','2013-10-11','15:35:00',1.22),('8975','2013-10-11','15:40:00',1.1),('8975','2013-10-11','15:45:00',1.04),('8975','2013-10-11','15:50:00',1.16),('8975','2013-10-11','15:55:00',1.47),('8975','2013-10-11','16:00:00',1.65),('8975','2013-10-11','16:05:00',1.59),('8975','2013-10-11','16:10:00',1.68),('8975','2013-10-11','16:15:00',2.11),('8975','2013-10-11','16:20:00',2.43),('8975','2013-10-11','16:25:00',1.51),('8975','2013-10-10','08:15:00',1.35),('8975','2013-10-10','08:35:00',1.52),('8975','2013-10-10','09:30:00',1.47),('8975','2013-10-10','09:40:00',3.33),('8975','2013-10-10','09:45:00',3.89),('8975','2013-10-10','09:50:00',3.49),('8975','2013-10-10','09:55:00',3.91),('8975','2013-10-10','10:00:00',4.02),('8975','2013-10-10','10:05:00',3.97),('8975','2013-10-10','10:10:00',2.87),('8975','2013-10-10','10:15:00',1.25),('8975','2013-10-10','10:20:00',2.58),('8975','2013-10-10','10:25:00',3.29),('8975','2013-10-10','10:30:00',2.73),('8975','2013-10-10','10:35:00',3.03),('8975','2013-10-10','10:40:00',1.34),('8975','2013-10-10','10:45:00',1),('8975','2013-10-10','10:55:00',1.09),('8975','2013-10-10','11:00:00',1.95),('8975','2013-10-10','11:05:00',3.24),('8975','2013-10-10','11:10:00',3.26),('8975','2013-10-10','11:15:00',2.05),('8975','2013-10-10','11:20:00',2.07),('8975','2013-10-10','11:25:00',1.81),('8975','2013-10-10','11:30:00',1.64),('8975','2013-10-10','11:35:00',1.81),('8975','2013-10-10','11:40:00',2.33),('8975','2013-10-10','11:45:00',2.66),('8975','2013-10-10','11:50:00',2.96),('8975','2013-10-10','11:55:00',2.7),('8975','2013-10-10','12:00:00',6.35),('8975','2013-10-10','12:05:00',3.85),('8975','2013-10-10','12:10:00',1.52),('8975','2013-10-10','12:15:00',1.45),('8975','2013-10-10','12:20:00',1.8),('8975','2013-10-10','12:25:00',2),('8975','2013-10-10','12:30:00',1.48),('8975','2013-10-10','12:35:00',1.21),('8975','2013-10-10','12:55:00',1.54),('8975','2013-10-10','13:00:00',2.11),('8975','2013-10-10','13:05:00',4.91),('8975','2013-10-10','13:10:00',5.09),('8975','2013-10-10','13:15:00',4.16),('8975','2013-10-10','13:20:00',6.05),('8975','2013-10-10','13:25:00',4.01),('8975','2013-10-10','13:30:00',1.32),('8975','2013-10-10','13:35:00',1.14),('8975','2013-10-10','13:40:00',3.92),('8975','2013-10-10','13:45:00',2.19),('8975','2013-10-10','14:55:00',1.26),('8975','2013-10-10','15:10:00',1.64),('8975','2013-10-10','15:25:00',1.4),('8975','2013-10-10','15:30:00',1.78),('8975','2013-10-10','15:35:00',1.61),('8975','2013-10-10','15:40:00',1.51),('8975','2013-10-10','15:45:00',1.11),('8975','2013-10-10','15:50:00',1.3),('8975','2013-10-10','15:55:00',2.24),('8975','2013-10-10','16:00:00',1.93),('8975','2013-10-10','16:05:00',1.81),('8975','2013-10-10','16:10:00',1.29),('8975','2013-10-10','16:25:00',1.12),('8975','2013-10-09','07:50:00',1.21),('8975','2013-10-09','07:55:00',1.4),('8975','2013-10-09','08:05:00',1.42),('8975','2013-10-09','08:35:00',1.11),('8975','2013-10-09','08:40:00',2.87),('8975','2013-10-09','08:45:00',2.91),('8975','2013-10-09','08:50:00',2.91),('8975','2013-10-09','08:55:00',1.72),('8975','2013-10-09','09:00:00',2.39),('8975','2013-10-09','09:05:00',3.33),('8975','2013-10-09','09:10:00',2.73),('8975','2013-10-09','09:15:00',3.33),('8975','2013-10-09','09:20:00',3.37),('8975','2013-10-09','09:25:00',3.44),('8975','2013-10-09','09:30:00',3.49),('8975','2013-10-09','09:35:00',3.7),('8975','2013-10-09','09:40:00',1.37),('8975','2013-10-09','09:50:00',1.04),('8975','2013-10-09','10:05:00',1.34),('8975','2013-10-09','10:10:00',4.08),('8975','2013-10-09','10:15:00',4.27),('8975','2013-10-09','10:20:00',1.82),('8975','2013-10-09','10:35:00',1.9),('8975','2013-10-09','10:40:00',1.84),('8975','2013-10-09','10:45:00',3.13),('8975','2013-10-09','10:50:00',1.02),('8975','2013-10-09','10:55:00',1.38),('8975','2013-10-09','11:00:00',1.91),('8975','2013-10-09','11:05:00',4.84),('8975','2013-10-09','11:10:00',3.14),('8975','2013-10-09','11:15:00',5.18),('8975','2013-10-09','11:20:00',4.19),('8975','2013-10-09','11:25:00',1.8),('8975','2013-10-09','11:30:00',1.66),('8975','2013-10-09','11:35:00',4.83),('8975','2013-10-09','11:40:00',2.55),('8975','2013-10-09','11:45:00',4.07),('8975','2013-10-09','11:50:00',2.06),('8975','2013-10-09','12:00:00',1.32),('8975','2013-10-09','12:05:00',4.12),('8975','2013-10-09','12:15:00',2.93),('8975','2013-10-09','12:20:00',5.7),('8975','2013-10-09','12:25:00',3.84),('8975','2013-10-09','12:30:00',5.07),('8975','2013-10-09','12:35:00',5.64),('8975','2013-10-09','12:40:00',5.27),('8975','2013-10-09','12:45:00',1.97),('8975','2013-10-09','12:50:00',4.74),('8975','2013-10-09','12:55:00',2.37),('8975','2013-10-09','13:00:00',4.5),('8975','2013-10-09','13:05:00',3.03),('8975','2013-10-09','13:10:00',2.98),('8975','2013-10-09','13:15:00',4.35),('8975','2013-10-09','13:20:00',4.69),('8975','2013-10-09','13:25:00',3.81),('8975','2013-10-09','13:30:00',1.8),('8975','2013-10-09','13:35:00',3.29),('8975','2013-10-09','13:40:00',5.26),('8975','2013-10-09','13:45:00',4.43),('8975','2013-10-09','13:50:00',4.35),('8975','2013-10-09','13:55:00',4),('8975','2013-10-09','14:00:00',4.24),('8975','2013-10-09','14:05:00',3.67),('8975','2013-10-09','14:10:00',3.52),('8975','2013-10-09','14:15:00',4.37),('8975','2013-10-09','14:20:00',3.75),('8975','2013-10-09','14:25:00',4.51),('8975','2013-10-09','14:30:00',4.11),('8975','2013-10-09','14:35:00',4.12),('8975','2013-10-09','14:40:00',3.32),('8975','2013-10-09','14:45:00',3.58),('8975','2013-10-09','14:50:00',3.35),('8975','2013-10-09','14:55:00',2.92),('8975','2013-10-09','15:00:00',2.27),('8975','2013-10-09','15:05:00',2.75),('8975','2013-10-09','15:10:00',2.38),('8975','2013-10-09','15:15:00',1.92),('8975','2013-10-09','15:20:00',1.58),('8975','2013-10-09','15:25:00',1.99),('8975','2013-10-09','15:30:00',2.17),('8975','2013-10-09','15:35:00',1.8),('8975','2013-10-09','15:40:00',1.62),('8975','2013-10-09','15:45:00',1.22),('8975','2013-10-09','15:50:00',1.21),('8975','2013-10-09','15:55:00',1.58),('8975','2013-10-09','16:00:00',1.45),('8975','2013-10-09','16:05:00',1.27),('8975','2013-10-09','16:10:00',1.58),('8975','2013-10-09','16:15:00',1.5),('8975','2013-10-09','16:20:00',1.27),('8975','2013-10-09','16:25:00',1.29),('8975','2013-10-09','16:40:00',1.5),('8975','2013-10-09','16:45:00',1.4),('8975','2013-10-09','16:50:00',1.28),('8975','2013-10-09','16:55:00',1.26),('8975','2013-10-09','17:20:00',1.07),('8975','2013-10-08','08:00:00',1.31),('8975','2013-10-08','08:05:00',1.06),('8975','2013-10-08','08:10:00',1.17),('8975','2013-10-08','08:25:00',1.71),('8975','2013-10-08','08:30:00',2.52),('8975','2013-10-08','08:35:00',2.69),('8975','2013-10-08','08:40:00',2.44),('8975','2013-10-08','08:45:00',2.85),('8975','2013-10-08','08:50:00',2.95),('8975','2013-10-08','08:55:00',2.99),('8975','2013-10-08','09:00:00',3.11),('8975','2013-10-08','09:05:00',3.22),('8975','2013-10-08','09:10:00',3.32),('8975','2013-10-08','09:15:00',2.89),('8975','2013-10-08','09:20:00',3.2),('8975','2013-10-08','09:25:00',3.55),('8975','2013-10-08','09:30:00',3.6),('8975','2013-10-08','09:35:00',3.65),('8975','2013-10-08','09:40:00',3.75),('8975','2013-10-08','09:45:00',3.86),('8975','2013-10-08','09:50:00',4.03),('8975','2013-10-08','09:55:00',4.16),('8975','2013-10-08','10:00:00',4.41),('8975','2013-10-08','10:05:00',4.85),('8975','2013-10-08','10:10:00',5.46),('8975','2013-10-08','10:15:00',4.06),('8975','2013-10-08','10:20:00',2.55),('8975','2013-10-08','10:25:00',3.93),('8975','2013-10-08','10:30:00',4.01),('8975','2013-10-08','10:35:00',2.4),('8975','2013-10-08','10:40:00',3.83),('8975','2013-10-08','10:45:00',3.6),('8975','2013-10-08','10:50:00',4.51),('8975','2013-10-08','10:55:00',4.28),('8975','2013-10-08','11:00:00',2.83),('8975','2013-10-08','11:05:00',4.92),('8975','2013-10-08','11:10:00',5.6),('8975','2013-10-08','11:15:00',5.51),('8975','2013-10-08','11:20:00',4.67),('8975','2013-10-08','11:25:00',5.4),('8975','2013-10-08','11:30:00',5.18),('8975','2013-10-08','11:35:00',5.9),('8975','2013-10-08','11:40:00',4.32),('8975','2013-10-08','11:45:00',3.84),('8975','2013-10-08','11:50:00',4.15),('8975','2013-10-08','11:55:00',4.81),('8975','2013-10-08','12:00:00',3.02),('8975','2013-10-08','12:05:00',5.13),('8975','2013-10-08','12:10:00',3.15),('8975','2013-10-08','12:15:00',2.46),('8975','2013-10-08','12:20:00',6.11),('8975','2013-10-08','12:25:00',6.5),('8975','2013-10-08','12:30:00',4.69),('8975','2013-10-08','12:35:00',3.1),('8975','2013-10-08','12:40:00',2.17),('8975','2013-10-08','12:45:00',1.7),('8975','2013-10-08','12:50:00',1.87),('8975','2013-10-08','12:55:00',2.21),('8975','2013-10-08','13:00:00',1.94),('8975','2013-10-08','13:05:00',1.77),('8975','2013-10-08','13:10:00',2.32),('8975','2013-10-08','13:15:00',4.01),('8975','2013-10-08','13:20:00',6.04),('8975','2013-10-08','13:25:00',4.23),('8975','2013-10-08','13:30:00',2.5),('8975','2013-10-08','13:35:00',4.06),('8975','2013-10-08','13:40:00',2.23),('8975','2013-10-08','13:45:00',2.81),('8975','2013-10-08','13:50:00',3.13),('8975','2013-10-08','13:55:00',2.33),('8975','2013-10-08','14:00:00',1.51),('8975','2013-10-08','14:05:00',2.24),('8975','2013-10-08','14:10:00',1.29),('8975','2013-10-08','14:15:00',1.05),('8975','2013-10-08','14:20:00',1.11),('8975','2013-10-08','14:25:00',1.17),('8975','2013-10-08','14:30:00',1.03),('8975','2013-10-08','14:50:00',1.29),('8975','2013-10-08','14:55:00',2.19),('8975','2013-10-08','15:00:00',4.04),('8975','2013-10-08','15:05:00',3.44),('8975','2013-10-08','15:10:00',3.14),('8975','2013-10-08','15:15:00',3.04),('8975','2013-10-08','15:20:00',2.8),('8975','2013-10-08','15:25:00',2.83),('8975','2013-10-08','15:30:00',2.23),('8975','2013-10-08','15:35:00',3.02),('8975','2013-10-08','15:40:00',2.25),('8975','2013-10-08','16:05:00',1.57),('8975','2013-10-08','16:10:00',1.34),('8975','2013-10-08','16:15:00',1.66),('8975','2013-10-08','16:20:00',2.1),('8975','2013-10-08','16:25:00',2.22),('8975','2013-10-08','16:30:00',1.54),('8975','2013-10-08','16:35:00',1.73),('8975','2013-10-08','16:40:00',1.17),('8975','2013-10-08','17:25:00',1.1),('8975','2013-10-08','17:30:00',1.44),('8975','2013-10-08','17:35:00',1.15),('8975','2013-10-08','17:40:00',1.17),('8975','2013-10-08','17:45:00',1.07),('8975','2014-04-14','08:00:00',1.27),('8975','2014-04-14','08:05:00',1.94),('8975','2014-04-14','08:50:00',1.3),('8975','2014-04-14','08:55:00',1.94),('8975','2014-04-14','09:00:00',3.25),('8975','2014-04-14','09:05:00',3.73),('8975','2014-04-14','09:10:00',4.16),('8975','2014-04-14','09:15:00',4.06),('8975','2014-04-14','09:20:00',4.17),('8975','2014-04-14','09:25:00',4.02),('8975','2014-04-14','09:30:00',1.46),('8975','2014-04-14','09:35:00',2.1),('8975','2014-04-14','09:40:00',1.81),('8975','2014-04-14','09:45:00',2.33),('8975','2014-04-14','09:50:00',3.04),('8975','2014-04-14','09:55:00',2.61),('8975','2014-04-14','10:00:00',2.82),('8975','2014-04-14','10:05:00',4.59),('8975','2014-04-14','10:10:00',2.91),('8975','2014-04-14','10:15:00',3.28),('8975','2014-04-14','10:20:00',3.69),('8975','2014-04-14','10:25:00',5.88),('8975','2014-04-14','10:30:00',5.48),('8975','2014-04-14','10:35:00',4.72),('8975','2014-04-14','10:40:00',6.57),('8975','2014-04-14','10:45:00',5.15),('8975','2014-04-14','10:50:00',2.68),('8975','2014-04-14','10:55:00',4.34),('8975','2014-04-14','11:00:00',7.35),('8975','2014-04-14','11:05:00',7.54),('8975','2014-04-14','11:10:00',5.41),('8975','2014-04-14','11:15:00',3.09),('8975','2014-04-14','11:20:00',5.91),('8975','2014-04-14','11:25:00',2.56),('8975','2014-04-14','11:30:00',1.78),('8975','2014-04-14','11:35:00',1.25),('8975','2014-04-14','11:40:00',2.09),('8975','2014-04-14','11:45:00',2.49),('8975','2014-04-14','11:50:00',2.13),('8975','2014-04-14','11:55:00',1.53),('8975','2014-04-14','12:00:00',1),('8975','2014-04-14','12:05:00',1.2),('8975','2014-04-14','12:10:00',1.36),('8975','2014-04-14','12:15:00',1.82),('8975','2014-04-14','12:20:00',1.74),('8975','2014-04-14','12:35:00',1.09),('8975','2014-04-14','13:00:00',1.38),('8975','2014-04-14','13:05:00',2.13),('8975','2014-04-14','13:10:00',2.61),('8975','2014-04-14','13:15:00',3.56),('8975','2014-04-14','13:20:00',2.94),('8975','2014-04-14','13:25:00',3.97),('8975','2014-04-14','13:30:00',2.35),('8975','2014-04-14','13:35:00',3.27),('8975','2014-04-14','13:40:00',3.01),('8975','2014-04-14','13:45:00',3.22),('8975','2014-04-14','13:50:00',4.26),('8975','2014-04-14','13:55:00',4.77),('8975','2014-04-14','14:00:00',3),('8975','2014-04-14','14:05:00',3.36),('8975','2014-04-14','14:10:00',4.61),('8975','2014-04-14','14:15:00',3.88),('8975','2014-04-14','14:20:00',4.59),('8975','2014-04-14','14:25:00',2.45),('8975','2014-04-14','14:30:00',2.34),('8975','2014-04-14','14:35:00',1.96),('8975','2014-04-14','14:40:00',1.62),('8975','2014-04-14','14:45:00',1.29),('8975','2014-04-14','15:10:00',1.12),('8975','2014-04-14','15:15:00',1.82),('8975','2014-04-14','15:20:00',2.45),('8975','2014-04-14','15:25:00',1.53),('8975','2014-04-14','15:30:00',1.44),('8975','2014-04-14','15:35:00',1.65),('8975','2014-04-14','15:40:00',1.97),('8975','2014-04-14','15:45:00',1.75),('8975','2014-04-14','15:50:00',1.84),('8975','2014-04-14','15:55:00',2.35),('8975','2014-04-14','16:00:00',2.46),('8975','2014-04-14','16:05:00',2.02),('8975','2014-04-14','16:10:00',1.55),('8975','2014-04-14','16:15:00',1.26),('8975','2013-10-07','07:50:00',1.15),('8975','2013-10-07','07:55:00',1.21),('8975','2013-10-07','08:00:00',1.58),('8975','2013-10-07','08:05:00',2.11),('8975','2013-10-07','08:10:00',2.42),('8975','2013-10-07','08:15:00',2.77),('8975','2013-10-07','08:20:00',1.87),('8975','2013-10-07','08:25:00',1.24),('8975','2013-10-07','08:30:00',1.27),('8975','2013-10-07','09:55:00',1.12),('8975','2013-10-07','10:00:00',1.47),('8975','2013-10-07','10:05:00',1.53),('8975','2013-10-07','10:10:00',1.56),('8975','2013-10-07','10:15:00',1.09),('8975','2013-10-07','10:55:00',1.73),('8975','2013-10-07','11:00:00',2.23),('8975','2013-10-07','11:05:00',2.3),('8975','2013-10-07','11:10:00',4.78),('8975','2013-10-07','11:15:00',6.62),('8975','2013-10-07','11:20:00',4.11),('8975','2013-10-07','11:25:00',3.48),('8975','2013-10-07','11:30:00',4.88),('8975','2013-10-07','11:35:00',2.86),('8975','2013-10-07','11:40:00',2.62),('8975','2013-10-07','11:45:00',1.99),('8975','2013-10-07','11:50:00',1.65),('8975','2013-10-07','11:55:00',1.34),('8975','2013-10-07','12:00:00',1.2),('8975','2013-10-07','12:05:00',1.57),('8975','2013-10-07','12:10:00',1.51),('8975','2013-10-07','12:15:00',1.74),('8975','2013-10-07','12:20:00',1.64),('8975','2013-10-07','12:25:00',2.8),('8975','2013-10-07','12:30:00',2.92),('8975','2013-10-07','12:35:00',4.09),('8975','2013-10-07','12:40:00',4.02),('8975','2013-10-07','12:45:00',3.57),('8975','2013-10-07','12:50:00',6.02),('8975','2013-10-07','12:55:00',2.82),('8975','2013-10-07','13:00:00',4.16),('8975','2013-10-07','13:05:00',3.87),('8975','2013-10-07','13:10:00',2.85),('8975','2013-10-07','13:15:00',2.57),('8975','2013-10-07','13:20:00',4.85),('8975','2013-10-07','13:25:00',4.58),('8975','2013-10-07','13:30:00',2.03),('8975','2013-10-07','13:35:00',1.87),('8975','2013-10-07','13:40:00',1.73),('8975','2013-10-07','13:45:00',1.29),('8975','2013-10-07','13:50:00',1.34),('8975','2013-10-07','13:55:00',1.51),('8975','2013-10-07','14:00:00',1.4),('8975','2013-10-07','14:05:00',3.1),('8975','2013-10-07','14:10:00',3.16),('8975','2013-10-07','14:15:00',3.39),('8975','2013-10-07','14:20:00',3.06),('8975','2013-10-07','14:25:00',3.98),('8975','2013-10-07','14:30:00',2.52),('8975','2013-10-07','14:35:00',1.62),('8975','2013-10-07','14:40:00',2.25),('8975','2013-10-07','14:45:00',3.99),('8975','2013-10-07','14:50:00',3.59),('8975','2013-10-07','14:55:00',3.2),('8975','2013-10-07','15:00:00',3.18),('8975','2013-10-07','15:05:00',3.07),('8975','2013-10-07','15:10:00',2.8),('8975','2013-10-07','15:15:00',2.8),('8975','2013-10-07','15:20:00',2.95),('8975','2013-10-07','15:25:00',3.08),('8975','2013-10-07','15:30:00',3.11),('8975','2013-10-07','15:35:00',2.79),('8975','2013-10-07','15:40:00',2.54),('8975','2013-10-07','15:45:00',2.28),('8975','2013-10-07','15:50:00',2.46),('8975','2013-10-07','15:55:00',1.3),('8975','2013-10-07','16:00:00',1.56),('8975','2013-10-07','16:10:00',1.25),('8975','2013-10-07','16:30:00',1.15),('8975','2013-10-07','16:35:00',1.04),('8975','2013-10-07','16:40:00',1.05),('8975','2013-10-07','16:45:00',1.07),('8975','2013-10-06','07:45:00',1.02),('8975','2013-10-06','07:50:00',1.36),('8975','2013-10-06','07:55:00',1.66),('8975','2013-10-06','08:00:00',1.84),('8975','2013-10-06','08:05:00',1.98),('8975','2013-10-06','08:10:00',2.07),('8975','2013-10-06','08:15:00',2.02),('8975','2013-10-06','08:20:00',2.04),('8975','2013-10-06','08:25:00',1.46),('8975','2013-10-06','08:30:00',2.29),('8975','2013-10-06','08:35:00',3.36),('8975','2013-10-06','08:40:00',1.86),('8975','2013-10-06','08:45:00',2.14),('8975','2013-10-06','08:50:00',2.16),('8975','2013-10-06','08:55:00',2.95),('8975','2013-10-06','09:00:00',3.35),('8975','2013-10-06','09:05:00',3.28),('8975','2013-10-06','09:10:00',3.31),('8975','2013-10-06','09:15:00',3.29),('8975','2013-10-06','09:20:00',3.48),('8975','2013-10-06','09:25:00',3.56),('8975','2013-10-06','09:30:00',3.65),('8975','2013-10-06','09:35:00',3.7),('8975','2013-10-06','09:40:00',3.75),('8975','2013-10-06','09:45:00',3.85),('8975','2013-10-06','09:50:00',3.88),('8975','2013-10-06','09:55:00',4.01),('8975','2013-10-06','10:00:00',4.06),('8975','2013-10-06','10:05:00',4.17),('8975','2013-10-06','10:10:00',4.19),('8975','2013-10-06','10:15:00',4.29),('8975','2013-10-06','10:20:00',4.39),('8975','2013-10-06','10:25:00',4.35),('8975','2013-10-06','10:30:00',4.71),('8975','2013-10-06','10:35:00',4.52),('8975','2013-10-06','10:40:00',4.64),('8975','2013-10-06','10:45:00',4.75),('8975','2013-10-06','10:50:00',4.53),('8975','2013-10-06','10:55:00',3.87),('8975','2013-10-06','11:00:00',5.22),('8975','2013-10-06','11:05:00',4.08),('8975','2013-10-06','11:10:00',4.76),('8975','2013-10-06','11:15:00',5.38),('8975','2013-10-06','11:20:00',5.01),('8975','2013-10-06','11:25:00',4.9),('8975','2013-10-06','11:30:00',4.95),('8975','2013-10-06','11:35:00',4.99),('8975','2013-10-06','11:40:00',5.02),('8975','2013-10-06','11:45:00',5.04),('8975','2013-10-06','11:50:00',5.04),('8975','2013-10-06','11:55:00',5.04),('8975','2013-10-06','12:00:00',5.27),('8975','2013-10-06','12:05:00',5),('8975','2013-10-06','12:10:00',2.15),('8975','2013-10-06','12:15:00',5.91),('8975','2013-10-06','12:20:00',5.58),('8975','2013-10-06','12:25:00',5.49),('8975','2013-10-06','12:30:00',5.22),('8975','2013-10-06','12:35:00',5.14),('8975','2013-10-06','12:40:00',4.93),('8975','2013-10-06','12:45:00',5.2),('8975','2013-10-06','12:50:00',5.23),('8975','2013-10-06','12:55:00',5.12),('8975','2013-10-06','13:00:00',5.25),('8975','2013-10-06','13:05:00',5.19),('8975','2013-10-06','13:10:00',5.06),('8975','2013-10-06','13:15:00',2.97),('8975','2013-10-06','13:20:00',3.3),('8975','2013-10-06','13:25:00',5.41),('8975','2013-10-06','13:30:00',4.2),('8975','2013-10-06','13:35:00',3.21),('8975','2013-10-06','13:40:00',1.78),('8975','2013-10-06','13:45:00',3.2),('8975','2013-10-06','13:50:00',2.05),('8975','2013-10-06','13:55:00',2.5),('8975','2013-10-06','14:00:00',1.34),('8975','2013-10-06','14:05:00',2.99),('8975','2013-10-06','14:10:00',3.17),('8975','2013-10-06','14:15:00',1.17),('8975','2013-10-06','14:20:00',2.14),('8975','2013-10-06','14:25:00',2.95),('8975','2013-10-06','14:30:00',2.01),('8975','2013-10-06','14:35:00',3.92),('8975','2013-10-06','14:40:00',4.26),('8975','2013-10-06','14:45:00',4.05),('8975','2013-10-06','14:50:00',2.76),('8975','2013-10-06','14:55:00',3.39),('8975','2013-10-06','15:00:00',3.54),('8975','2013-10-06','15:05:00',2.1),('8975','2013-10-06','15:10:00',3.24),('8975','2013-10-06','15:20:00',1.25),('8975','2013-10-06','15:25:00',3.38),('8975','2013-10-06','15:30:00',3.49),('8975','2013-10-06','15:35:00',2.14),('8975','2013-10-06','15:40:00',3.05),('8975','2013-10-06','15:45:00',3.02),('8975','2013-10-06','15:50:00',2.55),('8975','2013-10-06','15:55:00',1.39),('8975','2013-10-06','16:00:00',1.77),('8975','2013-10-06','16:05:00',1.73),('8975','2013-10-06','16:10:00',1.79),('8975','2013-10-06','16:15:00',1.89),('8975','2013-10-06','16:20:00',1.27),('8975','2013-10-06','16:25:00',1.64),('8975','2013-10-06','16:30:00',1.77),('8975','2013-10-06','16:35:00',1.85),('8975','2013-10-06','16:40:00',1.47),('8975','2013-10-06','16:45:00',1.67),('8975','2013-10-06','16:50:00',1.66),('8975','2013-10-06','16:55:00',1.54),('8975','2013-10-06','17:00:00',1.47),('8975','2013-10-06','17:15:00',1.12),('8975','2013-10-06','17:25:00',1.17),('8975','2013-10-06','17:30:00',1.15),('8975','2013-10-05','09:00:00',1.03),('8975','2013-10-05','09:05:00',1.85),('8975','2013-10-05','09:25:00',1.07),('8975','2013-10-05','09:30:00',1.87),('8975','2013-10-05','09:35:00',2.28),('8975','2013-10-05','09:40:00',2.14),('8975','2013-10-05','09:45:00',1.87),('8975','2013-10-05','09:50:00',3.64),('8975','2013-10-05','09:55:00',3.96),('8975','2013-10-05','10:00:00',4.88),('8975','2013-10-05','10:05:00',5.01),('8975','2013-10-05','10:10:00',4.94),('8975','2013-10-05','10:15:00',4.37),('8975','2013-10-05','10:20:00',4.4),('8975','2013-10-05','10:25:00',4.95),('8975','2013-10-05','10:30:00',4.83),('8975','2013-10-05','10:35:00',4.63),('8975','2013-10-05','10:40:00',3.65),('8975','2013-10-05','10:45:00',3.35),('8975','2013-10-05','10:50:00',3.71),('8975','2013-10-05','10:55:00',3.93),('8975','2013-10-05','11:00:00',4.23),('8975','2013-10-05','11:05:00',4.28),('8975','2013-10-05','11:10:00',4.37),('8975','2013-10-05','11:15:00',3.53),('8975','2013-10-05','11:20:00',4.22),('8975','2013-10-05','11:25:00',4.33),('8975','2013-10-05','11:30:00',4.42),('8975','2013-10-05','11:35:00',3.93),('8975','2013-10-05','11:40:00',3.31),('8975','2013-10-05','11:45:00',3.05),('8975','2013-10-05','11:50:00',3.26),('8975','2013-10-05','11:55:00',3.99),('8975','2013-10-05','12:00:00',3.83),('8975','2013-10-05','12:05:00',4),('8975','2013-10-05','12:10:00',4.82),('8975','2013-10-05','12:15:00',4),('8975','2013-10-05','12:20:00',4.64),('8975','2013-10-05','12:25:00',3.94),('8975','2013-10-05','12:30:00',3.7),('8975','2013-10-05','12:35:00',3.58),('8975','2013-10-05','12:40:00',3.11),('8975','2013-10-05','12:45:00',3.57),('8975','2013-10-05','12:50:00',4.01),('8975','2013-10-05','12:55:00',4.51),('8975','2013-10-05','13:00:00',4.56),('8975','2013-10-05','13:05:00',4.52),('8975','2013-10-05','13:10:00',3.97),('8975','2013-10-05','13:15:00',4.54),('8975','2013-10-05','13:20:00',5.08),('8975','2013-10-05','13:25:00',1.72),('8975','2013-10-05','13:30:00',1.15),('8975','2013-10-05','13:35:00',1.15),('8975','2013-10-05','13:40:00',3.26),('8975','2013-10-05','13:45:00',4.62),('8975','2013-10-05','13:50:00',4.36),('8975','2013-10-05','13:55:00',4.15),('8975','2013-10-05','14:00:00',3.55),('8975','2013-10-05','14:05:00',3.3),('8975','2013-10-05','14:10:00',2.2),('8975','2013-10-05','14:15:00',1.86),('8975','2013-10-05','14:20:00',1.65),('8975','2013-10-05','14:25:00',1.98),('8975','2013-10-05','14:30:00',2.83),('8975','2013-10-05','14:35:00',2.71),('8975','2013-10-05','14:40:00',2.41),('8975','2013-10-05','14:45:00',3.01),('8975','2013-10-05','14:50:00',2.78),('8975','2013-10-05','14:55:00',2.58),('8975','2013-10-05','15:00:00',2.12),('8975','2013-10-05','15:05:00',2.1),('8975','2013-10-05','15:10:00',1.78),('8975','2013-10-05','15:15:00',1.64),('8975','2013-10-05','15:20:00',1.42),('8975','2013-10-05','15:25:00',1.2),('8975','2013-10-05','15:30:00',1.21),('8975','2013-10-05','15:35:00',1.25),('8975','2013-10-05','15:40:00',1.3),('8975','2013-10-05','15:45:00',1.41),('8975','2013-10-05','15:50:00',1.46),('8975','2013-10-05','15:55:00',1.4),('8975','2013-10-05','16:00:00',1.37),('8975','2013-10-05','16:05:00',1.09),('8975','2013-10-05','17:00:00',1.03),('8975','2013-10-05','17:05:00',1.1),('8975','2013-10-05','17:10:00',1.03),('8975','2013-10-04','15:35:00',1.03),('8975','2013-10-04','15:40:00',1.21),('8975','2013-10-04','15:45:00',1.28),('8975','2013-10-04','15:50:00',1.32),('8975','2013-10-04','15:55:00',1.39),('8975','2013-10-04','16:00:00',1.53),('8975','2013-10-04','16:05:00',1.76),('8975','2013-10-04','16:10:00',1.7),('8975','2013-10-04','16:15:00',1.61),('8975','2013-10-04','16:20:00',1.54),('8975','2013-10-04','16:25:00',1.47),('8975','2013-10-04','16:30:00',1.41),('8975','2013-10-04','16:35:00',1.32),('8975','2013-10-04','16:40:00',1.41),('8975','2013-10-04','16:45:00',1.36),('8975','2013-10-04','16:50:00',1.16),('8975','2013-10-04','16:55:00',1.18),('8975','2013-10-04','17:00:00',1.22),('8975','2013-10-04','17:05:00',1.09),('8975','2013-10-03','07:40:00',1),('8975','2013-10-03','07:45:00',1.1),('8975','2013-10-03','08:15:00',1.02),('8975','2013-10-03','08:30:00',1.01),('8975','2013-10-03','08:35:00',1.12),('8975','2013-10-03','08:40:00',1.38),('8975','2013-10-03','08:45:00',2.16),('8975','2013-10-03','08:50:00',1.22),('8975','2013-10-03','08:55:00',1.12),('8975','2013-10-03','09:00:00',1.2),('8975','2013-10-03','09:05:00',1.01),('8975','2013-10-03','09:10:00',1.38),('8975','2013-10-03','09:15:00',1.18),('8975','2013-10-03','09:20:00',1.27),('8975','2013-10-03','09:25:00',1.83),('8975','2013-10-03','09:30:00',2.07),('8975','2013-10-03','09:35:00',2.17),('8975','2013-10-03','09:40:00',2.08),('8975','2013-10-03','09:45:00',2.02),('8975','2013-10-03','09:50:00',2.32),('8975','2013-10-03','09:55:00',3.56),('8975','2013-10-03','10:00:00',3.45),('8975','2013-10-03','10:05:00',2.42),('8975','2013-10-03','10:10:00',2.36),('8975','2013-10-03','10:15:00',2.67),('8975','2013-10-03','10:20:00',2.63),('8975','2013-10-03','10:25:00',3.31),('8975','2013-10-03','10:30:00',3.6),('8975','2013-10-03','10:35:00',3.75),('8975','2013-10-03','10:40:00',3.85),('8975','2013-10-03','10:45:00',5.22),('8975','2013-10-03','10:50:00',3.89),('8975','2013-10-03','10:55:00',2.7),('8975','2013-10-03','11:00:00',3.74),('8975','2013-10-03','11:05:00',3.03),('8975','2013-10-03','11:10:00',2.5),('8975','2013-10-03','11:15:00',4.75),('8975','2013-10-03','11:20:00',4.62),('8975','2013-10-03','11:25:00',4.01),('8975','2013-10-03','11:30:00',5.58),('8975','2013-10-03','11:35:00',4.53),('8975','2013-10-03','11:40:00',4.29),('8975','2013-10-03','11:45:00',5.13),('8975','2013-10-03','11:50:00',5.44),('8975','2013-10-03','11:55:00',5.35),('8975','2013-10-03','12:00:00',5.32),('8975','2013-10-03','12:05:00',5.35),('8975','2013-10-03','12:10:00',5.32),('8975','2013-10-03','12:15:00',4.56),('8975','2013-10-03','12:20:00',4.41),('8975','2013-10-03','12:25:00',5.27),('8975','2013-10-03','12:30:00',5.5),('8975','2013-10-03','12:35:00',5.31),('8975','2013-10-03','12:40:00',5.13),('8975','2013-10-03','12:45:00',5.1),('8975','2013-10-03','12:50:00',5.02),('8975','2013-10-03','12:55:00',4.83),('8975','2013-10-03','13:00:00',4.93),('8975','2013-10-03','13:05:00',4.98),('8975','2013-10-03','13:10:00',4.92),('8975','2013-10-03','13:15:00',5.13),('8975','2013-10-03','13:20:00',4.93),('8975','2013-10-03','13:25:00',4.63),('8975','2013-10-03','13:30:00',4.87),('8975','2013-10-03','13:35:00',4.93),('8975','2013-10-03','13:40:00',4.59),('8975','2013-10-03','13:45:00',4.23),('8975','2013-10-03','13:50:00',4.36),('8975','2013-10-03','13:55:00',4.06),('8975','2013-10-03','14:00:00',4.15),('8975','2013-10-03','14:05:00',4.11),('8975','2013-10-03','14:10:00',3.65),('8975','2013-10-03','14:15:00',3.32),('8975','2013-10-03','14:20:00',3.74),('8975','2013-10-03','14:25:00',3.74),('8975','2013-10-03','14:30:00',3.28),('8975','2013-10-03','14:35:00',2.5),('8975','2013-10-03','14:40:00',2.1),('8975','2013-10-03','14:45:00',2.5),('8975','2013-10-03','14:50:00',3),('8975','2013-10-03','14:55:00',3.13),('8975','2013-10-03','15:00:00',2.4),('8975','2013-10-03','15:05:00',2.79),('8975','2013-10-03','15:10:00',2.26),('8975','2013-10-03','15:15:00',2.22),('8975','2013-10-03','15:20:00',1.71),('8975','2013-10-03','15:25:00',2.45),('8975','2013-10-03','15:30:00',1.74),('8975','2013-10-03','15:35:00',1.44),('8975','2013-10-03','15:40:00',1.17),('8975','2013-10-03','15:45:00',1.03),('8975','2013-10-03','15:50:00',1.09),('8975','2013-10-03','15:55:00',1.23),('8975','2013-10-03','16:00:00',1.51),('8975','2013-10-03','16:05:00',1.68),('8975','2013-10-03','16:10:00',1.44),('8975','2013-10-03','16:15:00',1.25),('8975','2013-10-03','16:20:00',1.02),('8975','2013-10-02','07:40:00',1.15),('8975','2013-10-02','07:45:00',1.37),('8975','2013-10-02','07:50:00',1.57),('8975','2013-10-02','07:55:00',1.72),('8975','2013-10-02','08:00:00',1.96),('8975','2013-10-02','08:05:00',2.11),('8975','2013-10-02','08:10:00',2.29),('8975','2013-10-02','08:15:00',2.47),('8975','2013-10-02','08:20:00',2.61),('8975','2013-10-02','08:25:00',2.75),('8975','2013-10-02','08:30:00',2.85),('8975','2013-10-02','08:35:00',2.95),('8975','2013-10-02','08:40:00',3.07),('8975','2013-10-02','08:45:00',3.18),('8975','2013-10-02','08:50:00',3.27),('8975','2013-10-02','08:55:00',3.36),('8975','2013-10-02','09:00:00',3.46),('8975','2013-10-02','09:05:00',3.55),('8975','2013-10-02','09:10:00',3.65),('8975','2013-10-02','09:15:00',3.76),('8975','2013-10-02','09:20:00',3.83),('8975','2013-10-02','09:25:00',3.93),('8975','2013-10-02','09:30:00',4.04),('8975','2013-10-02','09:35:00',4.13),('8975','2013-10-02','09:40:00',4.19),('8975','2013-10-02','09:45:00',4.28),('8975','2013-10-02','09:50:00',4.39),('8975','2013-10-02','09:55:00',4.47),('8975','2013-10-02','10:00:00',4.56),('8975','2013-10-02','10:05:00',4.64),('8975','2013-10-02','10:10:00',4.69),('8975','2013-10-02','10:15:00',4.78),('8975','2013-10-02','10:20:00',4.87),('8975','2013-10-02','10:25:00',4.94),('8975','2013-10-02','10:30:00',5),('8975','2013-10-02','10:35:00',5.02),('8975','2013-10-02','10:40:00',4.98),('8975','2013-10-02','10:45:00',5.11),('8975','2013-10-02','10:50:00',5.21),('8975','2013-10-02','10:55:00',5.26),('8975','2013-10-02','11:00:00',5.32),('8975','2013-10-02','11:05:00',5.37),('8975','2013-10-02','11:10:00',5.41),('8975','2013-10-02','11:15:00',5.44),('8975','2013-10-02','11:20:00',5.5),('8975','2013-10-02','11:25:00',5.53),('8975','2013-10-02','11:30:00',5.53),('8975','2013-10-02','11:35:00',5.52),('8975','2013-10-02','11:40:00',5.47),('8975','2013-10-02','11:45:00',5.41),('8975','2013-10-02','11:50:00',5.51),('8975','2013-10-02','11:55:00',5.54),('8975','2013-10-02','12:00:00',5.56),('8975','2013-10-02','12:05:00',5.58),('8975','2013-10-02','12:10:00',5.58),('8975','2013-10-02','12:15:00',5.52),('8975','2013-10-02','12:20:00',5.48),('8975','2013-10-02','12:25:00',5.43),('8975','2013-10-02','12:30:00',5.44),('8975','2013-10-02','12:35:00',5.41),('8975','2013-10-02','12:40:00',5.38),('8975','2013-10-02','12:45:00',5.35),('8975','2013-10-02','12:50:00',5.32),('8975','2013-10-02','12:55:00',5.27),('8975','2013-10-02','13:00:00',5.22),('8975','2013-10-02','13:05:00',5.13),('8975','2013-10-02','13:10:00',5.11),('8975','2013-10-02','13:15:00',5.09),('8975','2013-10-02','13:20:00',5.05),('8975','2013-10-02','13:25:00',4.99),('8975','2013-10-02','13:30:00',4.95),('8975','2013-10-02','13:35:00',4.9),('8975','2013-10-02','13:40:00',4.85),('8975','2013-10-02','13:45:00',4.68),('8975','2013-10-02','13:50:00',4.62),('8975','2013-10-02','13:55:00',4.42),('8975','2013-10-02','14:00:00',4.3),('8975','2013-10-02','14:05:00',4.41),('8975','2013-10-02','14:10:00',4.31),('8975','2013-10-02','14:15:00',4.22),('8975','2013-10-02','14:20:00',4.16),('8975','2013-10-02','14:25:00',4.08),('8975','2013-10-02','14:30:00',3.98),('8975','2013-10-02','14:35:00',3.83),('8975','2013-10-02','14:40:00',3.55),('8975','2013-10-02','14:45:00',3.58),('8975','2013-10-02','14:50:00',3.53),('8975','2013-10-02','14:55:00',3.36),('8975','2013-10-02','15:00:00',3.36),('8975','2013-10-02','15:05:00',3.25),('8975','2013-10-02','15:10:00',3.12),('8975','2013-10-02','15:15:00',2.97),('8975','2013-10-02','15:20:00',2.88),('8975','2013-10-02','15:25:00',2.83),('8975','2013-10-02','15:30:00',2.75),('8975','2013-10-02','15:35:00',2.65),('8975','2013-10-02','15:40:00',2.53),('8975','2013-10-02','15:45:00',2.43),('8975','2013-10-02','15:50:00',2.33),('8975','2013-10-02','15:55:00',2.24),('8975','2013-10-02','16:00:00',2.12),('8975','2013-10-02','16:05:00',2.02),('8975','2013-10-02','16:10:00',1.93),('8975','2013-10-02','16:15:00',1.82),('8975','2013-10-02','16:20:00',1.75),('8975','2013-10-02','16:25:00',1.66),('8975','2013-10-02','16:30:00',1.58),('8975','2013-10-02','16:35:00',1.53),('8975','2013-10-02','16:40:00',1.49),('8975','2013-10-02','16:45:00',1.43),('8975','2013-10-02','16:50:00',1.38),('8975','2013-10-02','16:55:00',1.35),('8975','2013-10-02','17:00:00',1.31),('8975','2013-10-02','17:05:00',1.26),('8975','2013-10-02','17:10:00',1.23),('8975','2013-10-02','17:15:00',1.16),('8975','2013-10-02','17:20:00',1.13),('8975','2013-10-02','17:25:00',1.08),('8975','2013-10-02','17:30:00',1.03),('8975','2013-10-01','07:50:00',1.17),('8975','2013-10-01','07:55:00',1.25),('8975','2013-10-01','08:00:00',1.04),('8975','2013-10-01','08:10:00',1.42),('8975','2013-10-01','08:15:00',1.19),('8975','2013-10-01','08:20:00',2.22),('8975','2013-10-01','08:25:00',2.63),('8975','2013-10-01','08:30:00',2.66),('8975','2013-10-01','08:35:00',2.68),('8975','2013-10-01','08:40:00',2.85),('8975','2013-10-01','08:45:00',2.96),('8975','2013-10-01','08:50:00',3.06),('8975','2013-10-01','08:55:00',3.17),('8975','2013-10-01','09:00:00',3.22),('8975','2013-10-01','09:05:00',3.34),('8975','2013-10-01','09:10:00',3.43),('8975','2013-10-01','09:15:00',3.51),('8975','2013-10-01','09:20:00',3.59),('8975','2013-10-01','09:25:00',3.67),('8975','2013-10-01','09:30:00',3.77),('8975','2013-10-01','09:35:00',3.87),('8975','2013-10-01','09:40:00',3.93),('8975','2013-10-01','09:45:00',4),('8975','2013-10-01','09:50:00',4.08),('8975','2013-10-01','09:55:00',4.16),('8975','2013-10-01','10:00:00',4.22),('8975','2013-10-01','10:05:00',4.31),('8975','2013-10-01','10:10:00',4.36),('8975','2013-10-01','10:15:00',4.41),('8975','2013-10-01','10:20:00',4.5),('8975','2013-10-01','10:25:00',4.55),('8975','2013-10-01','10:30:00',4.62),('8975','2013-10-01','10:35:00',4.71),('8975','2013-10-01','10:40:00',4.78),('8975','2013-10-01','10:45:00',4.87),('8975','2013-10-01','10:50:00',4.97),('8975','2013-10-01','10:55:00',5.02),('8975','2013-10-01','11:00:00',5.04),('8975','2013-10-01','11:05:00',5.12),('8975','2013-10-01','11:10:00',5.2),('8975','2013-10-01','11:15:00',5.23),('8975','2013-10-01','11:20:00',5.25),('8975','2013-10-01','11:25:00',5.29),('8975','2013-10-01','11:30:00',5.3),('8975','2013-10-01','11:35:00',5.34),('8975','2013-10-01','11:40:00',5.36),('8975','2013-10-01','11:45:00',5.37),('8975','2013-10-01','11:50:00',5.36),('8975','2013-10-01','11:55:00',5.37),('8975','2013-10-01','12:00:00',5.35),('8975','2013-10-01','12:05:00',5.36),('8975','2013-10-01','12:10:00',5.18),('8975','2013-10-01','12:15:00',5.29),('8975','2013-10-01','12:20:00',5.27),('8975','2013-10-01','12:25:00',5.16),('8975','2013-10-01','12:30:00',4.83),('8975','2013-10-01','12:35:00',4.61),('8975','2013-10-01','12:40:00',5.01),('8975','2013-10-01','12:45:00',5.14),('8975','2013-10-01','12:50:00',4.61),('8975','2013-10-01','12:55:00',4.72),('8975','2013-10-01','13:00:00',4.75),('8975','2013-10-01','13:05:00',4.39),('8975','2013-10-01','13:10:00',4.87),('8975','2013-10-01','13:15:00',4.97),('8975','2013-10-01','13:20:00',4.94),('8975','2013-10-01','13:25:00',4.91),('8975','2013-10-01','13:30:00',4.87),('8975','2013-10-01','13:35:00',4.82),('8975','2013-10-01','13:40:00',4.78),('8975','2013-10-01','13:45:00',4.65),('8975','2013-10-01','13:50:00',4.33),('8975','2013-10-01','13:55:00',4.22),('8975','2013-10-01','14:00:00',4.24),('8975','2013-10-01','14:05:00',4.33),('8975','2013-10-01','14:10:00',4.26),('8975','2013-10-01','14:15:00',4.19),('8975','2013-10-01','14:20:00',4.11),('8975','2013-10-01','14:25:00',4.03),('8975','2013-10-01','14:30:00',3.95),('8975','2013-10-01','14:35:00',3.86),('8975','2013-10-01','14:40:00',3.57),('8975','2013-10-01','14:45:00',3.58),('8975','2013-10-01','14:50:00',3.45),('8975','2013-10-01','14:55:00',3.39),('8975','2013-10-01','15:00:00',3.34),('8975','2013-10-01','15:05:00',3.23),('8975','2013-10-01','15:10:00',3.09),('8975','2013-10-01','15:15:00',2.93),('8975','2013-10-01','15:20:00',2.83),('8975','2013-10-01','15:25:00',2.77),('8975','2013-10-01','15:30:00',2.71),('8975','2013-10-01','15:35:00',2.61),('8975','2013-10-01','15:40:00',2.53),('8975','2013-10-01','15:45:00',2.42),('8975','2013-10-01','15:50:00',2.32),('8975','2013-10-01','15:55:00',2.23),('8975','2013-10-01','16:00:00',2.14),('8975','2013-10-01','16:05:00',2.05),('8975','2013-10-01','16:10:00',1.94),('8975','2013-10-01','16:15:00',1.83),('8975','2013-10-01','16:20:00',1.76),('8975','2013-10-01','16:25:00',1.67),('8975','2013-10-01','16:30:00',1.6),('8975','2013-10-01','16:35:00',1.53),('8975','2013-10-01','16:40:00',1.48),('8975','2013-10-01','16:45:00',1.43),('8975','2013-10-01','16:50:00',1.38),('8975','2013-10-01','16:55:00',1.33),('8975','2013-10-01','17:00:00',1.3),('8975','2013-10-01','17:05:00',1.26),('8975','2013-10-01','17:10:00',1.22),('8975','2013-10-01','17:15:00',1.16),('8975','2013-10-01','17:20:00',1.12),('8975','2013-10-01','17:25:00',1.08),('8975','2013-10-01','17:30:00',1.03),('8975','2013-09-30','08:05:00',1.34),('8975','2013-09-30','08:10:00',2.05),('8975','2013-09-30','08:15:00',2.3),('8975','2013-09-30','08:20:00',2.46),('8975','2013-09-30','08:25:00',2.56),('8975','2013-09-30','08:30:00',2.7),('8975','2013-09-30','08:35:00',2.82),('8975','2013-09-30','08:40:00',2.93),('8975','2013-09-30','08:45:00',3.03),('8975','2013-09-30','08:50:00',3.11),('8975','2013-09-30','08:55:00',3.19),('8975','2013-09-30','09:00:00',3.26),('8975','2013-09-30','09:05:00',3.34),('8975','2013-09-30','09:10:00',3.43),('8975','2013-09-30','09:15:00',3.5),('8975','2013-09-30','09:20:00',3.61),('8975','2013-09-30','09:25:00',3.67),('8975','2013-09-30','09:30:00',3.72),('8975','2013-09-30','09:35:00',3.83),('8975','2013-09-30','09:40:00',3.9),('8975','2013-09-30','09:45:00',3.96),('8975','2013-09-30','09:50:00',4.08),('8975','2013-09-30','09:55:00',4.14),('8975','2013-09-30','10:00:00',4.21),('8975','2013-09-30','10:05:00',4.27),('8975','2013-09-30','10:10:00',4.31),('8975','2013-09-30','10:15:00',4.31),('8975','2013-09-30','10:20:00',4.29),('8975','2013-09-30','10:25:00',4.46),('8975','2013-09-30','10:30:00',4.75),('8975','2013-09-30','10:35:00',4.68),('8975','2013-09-30','10:40:00',4.75),('8975','2013-09-30','10:45:00',4.83),('8975','2013-09-30','10:50:00',4.89),('8975','2013-09-30','10:55:00',4.87),('8975','2013-09-30','11:00:00',5.06),('8975','2013-09-30','11:05:00',3.63),('8975','2013-09-30','11:10:00',5.51),('8975','2013-09-30','11:15:00',5.89),('8975','2013-09-30','11:20:00',3.21),('8975','2013-09-30','11:25:00',1.22),('8975','2013-09-30','11:30:00',1.04),('8975','2013-09-30','11:35:00',1.05),('8975','2013-09-30','11:40:00',3.18),('8975','2013-09-30','11:45:00',5.63),('8975','2013-09-30','11:50:00',5.7),('8975','2013-09-30','11:55:00',5.69),('8975','2013-09-30','12:00:00',3.88),('8975','2013-09-30','12:05:00',2.03),('8975','2013-09-30','12:10:00',1.15),('8975','2013-09-30','12:15:00',5.38),('8975','2013-09-30','12:20:00',5.81),('8975','2013-09-30','12:25:00',5.64),('8975','2013-09-30','12:30:00',5.69),('8975','2013-09-30','12:35:00',5.85),('8975','2013-09-30','12:40:00',5.97),('8975','2013-09-30','12:45:00',5.94),('8975','2013-09-30','12:50:00',5.94),('8975','2013-09-30','12:55:00',5.68),('8975','2013-09-30','13:00:00',5.44),('8975','2013-09-30','13:05:00',1.69),('8975','2013-09-30','13:10:00',2.81),('8975','2013-09-30','13:15:00',5.89),('8975','2013-09-30','13:20:00',5.1),('8975','2013-09-30','13:25:00',5.19),('8975','2013-09-30','13:30:00',1.46),('8975','2013-09-30','13:35:00',4.6),('8975','2013-09-30','13:40:00',4.92),('8975','2013-09-30','13:45:00',4.87),('8975','2013-09-30','13:50:00',3.8),('8975','2013-09-30','13:55:00',4.57),('8975','2013-09-30','14:00:00',4.27),('8975','2013-09-30','14:05:00',4.32),('8975','2013-09-30','14:10:00',4.24),('8975','2013-09-30','14:15:00',4.15),('8975','2013-09-30','14:20:00',4.04),('8975','2013-09-30','14:25:00',3.92),('8975','2013-09-30','14:30:00',3.86),('8975','2013-09-30','14:35:00',3.76),('8975','2013-09-30','14:40:00',3.68),('8975','2013-09-30','14:45:00',3.4),('8975','2013-09-30','14:50:00',3.54),('8975','2013-09-30','14:55:00',3.45),('8975','2013-09-30','15:00:00',3.39),('8975','2013-09-30','15:05:00',3.29),('8975','2013-09-30','15:10:00',3.11),('8975','2013-09-30','15:15:00',3),('8975','2013-09-30','15:20:00',2.94),('8975','2013-09-30','15:25:00',2.84),('8975','2013-09-30','15:30:00',2.73),('8975','2013-09-30','15:35:00',2.67),('8975','2013-09-30','15:40:00',2.6),('8975','2013-09-30','15:45:00',2.48),('8975','2013-09-30','15:50:00',2.36),('8975','2013-09-30','15:55:00',2.27),('8975','2013-09-30','16:00:00',2.15),('8975','2013-09-30','16:05:00',2.05),('8975','2013-09-30','16:10:00',1.96),('8975','2013-09-30','16:15:00',1.86),('8975','2013-09-30','16:20:00',1.77),('8975','2013-09-30','16:25:00',1.69),('8975','2013-09-30','16:30:00',1.62),('8975','2013-09-30','16:35:00',1.55),('8975','2013-09-30','16:40:00',1.49),('8975','2013-09-30','16:45:00',1.44),('8975','2013-09-30','16:50:00',1.4),('8975','2013-09-30','16:55:00',1.36),('8975','2013-09-30','17:00:00',1.32),('8975','2013-09-30','17:05:00',1.28),('8975','2013-09-30','17:10:00',1.24),('8975','2013-09-30','17:15:00',1.2),('8975','2013-09-30','17:20:00',1.15),('8975','2013-09-30','17:25:00',1.12),('8975','2013-09-30','17:30:00',1.06),('8975','2013-09-29','09:35:00',1.04),('8975','2013-09-29','09:40:00',1.17),('8975','2013-09-29','09:45:00',1.54),('8975','2013-09-29','09:50:00',1.83),('8975','2013-09-29','09:55:00',1.64),('8975','2013-09-29','10:00:00',1.58),('8975','2013-09-29','10:05:00',1.59),('8975','2013-09-29','10:10:00',1.74),('8975','2013-09-29','10:15:00',1.75),('8975','2013-09-29','10:20:00',1.82),('8975','2013-09-29','10:25:00',2.04),('8975','2013-09-29','10:30:00',2.38),('8975','2013-09-29','10:35:00',2.69),('8975','2013-09-29','10:40:00',3.83),('8975','2013-09-29','10:45:00',5.31),('8975','2013-09-29','10:50:00',5.46),('8975','2013-09-29','10:55:00',4.69),('8975','2013-09-29','11:00:00',4.24),('8975','2013-09-29','11:05:00',3.36),('8975','2013-09-29','11:10:00',4.79),('8975','2013-09-29','11:15:00',4.93),('8975','2013-09-29','11:20:00',4.66),('8975','2013-09-29','11:25:00',3.86),('8975','2013-09-29','11:30:00',4.16),('8975','2013-09-29','11:35:00',2.27),('8975','2013-09-29','11:40:00',6.3),('8975','2013-09-29','11:45:00',6.56),('8975','2013-09-29','11:50:00',3.66),('8975','2013-09-29','11:55:00',4.19),('8975','2013-09-29','12:00:00',2.51),('8975','2013-09-29','12:15:00',5.5),('8975','2013-09-29','12:20:00',5.64),('8975','2013-09-29','12:25:00',4.45),('8975','2013-09-29','12:30:00',4.61),('8975','2013-09-29','12:35:00',3.57),('8975','2013-09-29','12:40:00',4.32),('8975','2013-09-29','12:45:00',4.82),('8975','2013-09-29','12:50:00',4.28),('8975','2013-09-29','12:55:00',3.05),('8975','2013-09-29','13:00:00',4.81),('8975','2013-09-29','13:05:00',5.56),('8975','2013-09-29','13:10:00',4.92),('8975','2013-09-29','13:15:00',4.74),('8975','2013-09-29','13:20:00',4.93),('8975','2013-09-29','13:25:00',3.56),('8975','2013-09-29','13:30:00',5.47),('8975','2013-09-29','13:35:00',5.16),('8975','2013-09-29','13:40:00',4.86),('8975','2013-09-29','13:45:00',3.88),('8975','2013-09-29','13:50:00',2.73),('8975','2013-09-29','13:55:00',1.63),('8975','2013-09-29','14:00:00',2.91),('8975','2013-09-29','14:05:00',2.56),('8975','2013-09-29','14:10:00',2),('8975','2013-09-29','14:15:00',1.99),('8975','2013-09-29','14:20:00',1.68),('8975','2013-09-29','14:25:00',1.89),('8975','2013-09-29','14:30:00',4.37),('8975','2013-09-29','14:35:00',3.9),('8975','2013-09-29','14:40:00',4.73),('8975','2013-09-29','14:45:00',3.34),('8975','2013-09-29','14:50:00',2.93),('8975','2013-09-29','14:55:00',4.08),('8975','2013-09-29','15:00:00',2.35),('8975','2013-09-29','15:05:00',1.4),('8975','2013-09-29','15:10:00',1.69),('8975','2013-09-29','15:15:00',2.8),('8975','2013-09-29','15:20:00',2.3),('8975','2013-09-29','15:25:00',3.52),('8975','2013-09-29','15:30:00',3.24),('8975','2013-09-29','15:35:00',3.32),('8975','2013-09-29','15:40:00',3.06),('8975','2013-09-29','15:45:00',2.2),('8975','2013-09-29','16:15:00',1.07),('8975','2013-09-29','16:20:00',1.46),('8975','2013-09-29','16:25:00',1.96),('8975','2013-09-29','16:30:00',2.76),('8975','2013-09-29','16:35:00',2.41),('8975','2013-09-29','16:40:00',2.44),('8975','2013-09-29','16:45:00',1.98),('8975','2013-09-29','16:50:00',1.63),('8975','2013-09-29','16:55:00',1.03),('8975','2013-09-29','17:00:00',1.19),('8975','2013-09-29','17:05:00',1.24),('8975','2013-09-29','17:10:00',1.03),('8975','2013-09-29','17:15:00',1.57),('8975','2013-09-29','17:20:00',1.11),('8975','2013-09-28','08:35:00',1.01),('8975','2013-09-28','08:40:00',1.3),('8975','2013-09-28','08:45:00',1.58),('8975','2013-09-28','08:50:00',2.12),('8975','2013-09-28','08:55:00',1.67),('8975','2013-09-28','09:00:00',1.83),('8975','2013-09-28','09:05:00',1.47),('8975','2013-09-28','09:10:00',2.24),('8975','2013-09-28','09:15:00',1.87),('8975','2013-09-28','09:20:00',1.44),('8975','2013-09-28','09:25:00',1.47),('8975','2013-09-28','09:30:00',1.43),('8975','2013-09-28','09:35:00',1.39),('8975','2013-09-28','09:40:00',1.37),('8975','2013-09-28','09:45:00',1.56),('8975','2013-09-28','09:50:00',1.62),('8975','2013-09-28','09:55:00',1.58),('8975','2013-09-28','10:00:00',1.76),('8975','2013-09-28','10:05:00',2.29),('8975','2013-09-28','10:10:00',2.97),('8975','2013-09-28','10:15:00',3.36),('8975','2013-09-28','10:20:00',3.42),('8975','2013-09-28','10:25:00',3.35),('8975','2013-09-28','10:30:00',3.67),('8975','2013-09-28','10:35:00',3.04),('8975','2013-09-28','10:40:00',2.02),('8975','2013-09-28','10:45:00',3.46),('8975','2013-09-28','10:50:00',3.73),('8975','2013-09-28','10:55:00',3.54),('8975','2013-09-28','11:00:00',4.3),('8975','2013-09-28','11:05:00',4),('8975','2013-09-28','11:10:00',4.35),('8975','2013-09-28','11:15:00',4.58),('8975','2013-09-28','11:20:00',3.91),('8975','2013-09-28','11:25:00',4.28),('8975','2013-09-28','11:30:00',4.62),('8975','2013-09-28','11:35:00',4.49),('8975','2013-09-28','11:40:00',4.64),('8975','2013-09-28','11:45:00',4.64),('8975','2013-09-28','11:50:00',4.65),('8975','2013-09-28','11:55:00',4.63),('8975','2013-09-28','12:00:00',5),('8975','2013-09-28','12:05:00',4.1),('8975','2013-09-28','12:10:00',4.15),('8975','2013-09-28','12:15:00',4.13),('8975','2013-09-28','12:20:00',2.52),('8975','2013-09-28','12:25:00',2.53),('8975','2013-09-28','12:30:00',2.96),('8975','2013-09-28','12:35:00',2.87),('8975','2013-09-28','12:40:00',2.94),('8975','2013-09-28','12:45:00',2.44),('8975','2013-09-28','12:50:00',2.4),('8975','2013-09-28','12:55:00',2.15),('8975','2013-09-28','13:00:00',2.23),('8975','2013-09-28','13:05:00',1.8),('8975','2013-09-28','13:10:00',1.74),('8975','2013-09-28','13:15:00',1.47),('8975','2013-09-28','13:20:00',1.49),('8975','2013-09-28','13:25:00',2.18),('8975','2013-09-28','13:30:00',2.26),('8975','2013-09-28','13:35:00',2.59),('8975','2013-09-28','13:40:00',2.34),('8975','2013-09-28','13:45:00',2.09),('8975','2013-09-28','13:50:00',2.62),('8975','2013-09-28','13:55:00',3.23),('8975','2013-09-28','14:00:00',2.36),('8975','2013-09-28','14:05:00',2.91),('8975','2013-09-28','14:10:00',1.76),('8975','2013-09-28','14:15:00',2.91),('8975','2013-09-28','14:20:00',3.22),('8975','2013-09-28','14:25:00',2.7),('8975','2013-09-28','14:30:00',2.83),('8975','2013-09-28','14:35:00',2.18),('8975','2013-09-28','14:40:00',1.97),('8975','2013-09-28','14:45:00',1.23),('8975','2013-09-28','14:50:00',1.36),('8975','2013-09-28','14:55:00',1.44),('8975','2013-09-28','15:00:00',1.39),('8975','2013-09-28','15:15:00',1.53),('8975','2013-09-28','15:20:00',1.68),('8975','2013-09-28','15:25:00',1.3),('8975','2013-09-28','15:30:00',1.32),('8975','2013-09-28','15:35:00',1.27),('8975','2013-09-28','15:40:00',1.53),('8975','2013-09-28','15:45:00',1.14),('8975','2013-09-28','15:55:00',1.39),('8975','2013-09-28','16:00:00',1.86),('8975','2013-09-28','16:05:00',1.64),('8975','2013-09-28','16:10:00',1.29),('8975','2013-09-28','16:15:00',1.13),('8975','2013-09-28','16:20:00',1.23),('8975','2013-09-28','16:25:00',1.3),('8975','2013-09-28','16:30:00',1.62),('8975','2013-09-28','16:35:00',1.57),('8975','2013-09-28','16:40:00',1.32),('8975','2013-09-28','16:45:00',1.43),('8975','2014-04-13','07:05:00',1.03),('8975','2014-04-13','07:10:00',1.26),('8975','2014-04-13','07:15:00',1.52),('8975','2014-04-13','07:20:00',1.54),('8975','2014-04-13','07:25:00',1.71),('8975','2014-04-13','07:30:00',1.92),('8975','2014-04-13','07:35:00',2.19),('8975','2014-04-13','07:40:00',2.33),('8975','2014-04-13','07:45:00',2.57),('8975','2014-04-13','07:50:00',2.7),('8975','2014-04-13','07:55:00',2.83),('8975','2014-04-13','08:00:00',2.95),('8975','2014-04-13','08:05:00',3.09),('8975','2014-04-13','08:10:00',3.19),('8975','2014-04-13','08:15:00',3.31),('8975','2014-04-13','08:20:00',3.43),('8975','2014-04-13','08:25:00',3.54),('8975','2014-04-13','08:30:00',3.64),('8975','2014-04-13','08:35:00',3.75),('8975','2014-04-13','08:40:00',3.84),('8975','2014-04-13','08:45:00',3.94),('8975','2014-04-13','08:50:00',4.02),('8975','2014-04-13','08:55:00',4.12),('8975','2014-04-13','09:00:00',4.22),('8975','2014-04-13','09:05:00',4.31),('8975','2014-04-13','09:10:00',4.42),('8975','2014-04-13','09:15:00',4.54),('8975','2014-04-13','09:20:00',4.62),('8975','2014-04-13','09:25:00',4.73),('8975','2014-04-13','09:30:00',4.81),('8975','2014-04-13','09:35:00',4.89),('8975','2014-04-13','09:40:00',4.97),('8975','2014-04-13','09:45:00',5.04),('8975','2014-04-13','09:50:00',5.15),('8975','2014-04-13','09:55:00',5.24),('8975','2014-04-13','10:00:00',5.3),('8975','2014-04-13','10:05:00',5.38),('8975','2014-04-13','10:10:00',5.47),('8975','2014-04-13','10:15:00',5.56),('8975','2014-04-13','10:20:00',5.65),('8975','2014-04-13','10:25:00',5.71),('8975','2014-04-13','10:30:00',5.76),('8975','2014-04-13','10:35:00',5.81),('8975','2014-04-13','10:40:00',5.88),('8975','2014-04-13','10:45:00',5.91),('8975','2014-04-13','10:50:00',5.96),('8975','2014-04-13','10:55:00',5.98),('8975','2014-04-13','11:00:00',5.98),('8975','2014-04-13','11:05:00',6.03),('8975','2014-04-13','11:10:00',6.13),('8975','2014-04-13','11:15:00',6.19),('8975','2014-04-13','11:20:00',6.2),('8975','2014-04-13','11:25:00',6.26),('8975','2014-04-13','11:30:00',6.3),('8975','2014-04-13','11:35:00',6.34),('8975','2014-04-13','11:40:00',6.36),('8975','2014-04-13','11:45:00',6.38),('8975','2014-04-13','11:50:00',6.39),('8975','2014-04-13','11:55:00',6.42),('8975','2014-04-13','12:00:00',6.42),('8975','2014-04-13','12:05:00',6.39),('8975','2014-04-13','12:10:00',6.4),('8975','2014-04-13','12:15:00',6.43),('8975','2014-04-13','12:20:00',6.44),('8975','2014-04-13','12:25:00',6.42),('8975','2014-04-13','12:30:00',6.44),('8975','2014-04-13','12:35:00',6.43),('8975','2014-04-13','12:40:00',6.39),('8975','2014-04-13','12:45:00',6.37),('8975','2014-04-13','12:50:00',6.38),('8975','2014-04-13','12:55:00',6.33),('8975','2014-04-13','13:00:00',6.35),('8975','2014-04-13','13:05:00',6.26),('8975','2014-04-13','13:10:00',6.34),('8975','2014-04-13','13:15:00',6.3),('8975','2014-04-13','13:20:00',6.26),('8975','2014-04-13','13:25:00',6.24),('8975','2014-04-13','13:30:00',6.2),('8975','2014-04-13','13:35:00',6.19),('8975','2014-04-13','13:40:00',6.13),('8975','2014-04-13','13:45:00',6.1),('8975','2014-04-13','13:50:00',6.07),('8975','2014-04-13','13:55:00',6.01),('8975','2014-04-13','14:00:00',5.96),('8975','2014-04-13','14:05:00',5.9),('8975','2014-04-13','14:10:00',5.85),('8975','2014-04-13','14:15:00',5.78),('8975','2014-04-13','14:20:00',5.73),('8975','2014-04-13','14:25:00',5.64),('8975','2014-04-13','14:30:00',5.57),('8975','2014-04-13','14:35:00',5.51),('8975','2014-04-13','14:40:00',5.41),('8975','2014-04-13','14:45:00',5.33),('8975','2014-04-13','14:50:00',5.23),('8975','2014-04-13','14:55:00',5.15),('8975','2014-04-13','15:00:00',5.05),('8975','2014-04-13','15:05:00',4.96),('8975','2014-04-13','15:10:00',4.86),('8975','2014-04-13','15:15:00',4.75),('8975','2014-04-13','15:20:00',4.61),('8975','2014-04-13','15:25:00',4.45),('8975','2014-04-13','15:30:00',4.32),('8975','2014-04-13','15:35:00',4.29),('8975','2014-04-13','15:40:00',4.2),('8975','2014-04-13','15:45:00',4.09),('8975','2014-04-13','15:50:00',3.96),('8975','2014-04-13','15:55:00',3.85),('8975','2014-04-13','16:00:00',3.71),('8975','2014-04-13','16:05:00',3.59),('8975','2014-04-13','16:10:00',3.47),('8975','2014-04-13','16:15:00',3.35),('8975','2014-04-13','16:20:00',3.26),('8975','2014-04-13','16:25:00',3.13),('8975','2014-04-13','16:30:00',3.03),('8975','2014-04-13','16:35:00',2.93),('8975','2014-04-13','16:40:00',2.79),('8975','2014-04-13','16:45:00',2.67),('8975','2014-04-13','16:50:00',2.57),('8975','2014-04-13','16:55:00',2.45),('8975','2014-04-13','17:00:00',2.33),('8975','2014-04-13','17:05:00',2.22),('8975','2014-04-13','17:10:00',2.1),('8975','2014-04-13','17:15:00',2),('8975','2014-04-13','17:20:00',1.9),('8975','2014-04-13','17:25:00',1.81),('8975','2014-04-13','17:30:00',1.73),('8975','2014-04-13','17:35:00',1.64),('8975','2014-04-13','17:40:00',1.58),('8975','2014-04-13','17:45:00',1.53),('8975','2014-04-13','17:50:00',1.49),('8975','2014-04-13','17:55:00',1.44),('8975','2014-04-13','18:00:00',1.4),('8975','2014-04-13','18:05:00',1.34),('8975','2014-04-13','18:10:00',1.29),('8975','2014-04-13','18:15:00',1.25),('8975','2014-04-13','18:20:00',1.18),('8975','2014-04-13','18:25:00',1.13),('8975','2014-04-13','18:30:00',1.08),('8975','2014-04-13','18:35:00',1.01),('8975','2013-09-27','07:50:00',1.1),('8975','2013-09-27','07:55:00',1.3),('8975','2013-09-27','08:00:00',1.49),('8975','2013-09-27','08:05:00',1.65),('8975','2013-09-27','08:10:00',1.85),('8975','2013-09-27','08:15:00',2.14),('8975','2013-09-27','08:20:00',2.28),('8975','2013-09-27','08:25:00',2.27),('8975','2013-09-27','08:30:00',2.36),('8975','2013-09-27','08:35:00',2.51),('8975','2013-09-27','08:40:00',2.66),('8975','2013-09-27','08:45:00',2.76),('8975','2013-09-27','08:50:00',2.76),('8975','2013-09-27','08:55:00',2.83),('8975','2013-09-27','09:00:00',2.92),('8975','2013-09-27','09:05:00',3.07),('8975','2013-09-27','09:10:00',3.1),('8975','2013-09-27','09:15:00',3.32),('8975','2013-09-27','09:20:00',3.47),('8975','2013-09-27','09:25:00',3.47),('8975','2013-09-27','09:30:00',3.65),('8975','2013-09-27','09:35:00',3.72),('8975','2013-09-27','09:40:00',3.81),('8975','2013-09-27','09:45:00',4),('8975','2013-09-27','09:50:00',3.51),('8975','2013-09-27','09:55:00',3.87),('8975','2013-09-27','10:00:00',3.64),('8975','2013-09-27','10:05:00',1.54),('8975','2013-09-27','10:10:00',2.89),('8975','2013-09-27','10:15:00',2.47),('8975','2013-09-27','10:20:00',3.43),('8975','2013-09-27','10:25:00',1.96),('8975','2013-09-27','10:30:00',4.04),('8975','2013-09-27','10:35:00',1.72),('8975','2013-09-27','10:40:00',1.34),('8975','2013-09-27','10:45:00',4.05),('8975','2013-09-27','10:50:00',2.15),('8975','2013-09-27','10:55:00',1.66),('8975','2013-09-27','11:00:00',1.85),('8975','2013-09-27','11:05:00',1.53),('8975','2013-09-27','11:10:00',1.82),('8975','2013-09-27','11:15:00',4.18),('8975','2013-09-27','11:20:00',4.17),('8975','2013-09-27','11:25:00',4.39),('8975','2013-09-27','11:30:00',3.58),('8975','2013-09-27','11:35:00',5.69),('8975','2013-09-27','11:40:00',5.96),('8975','2013-09-27','11:45:00',5.73),('8975','2013-09-27','11:50:00',5.56),('8975','2013-09-27','11:55:00',5.52),('8975','2013-09-27','12:00:00',5.46),('8975','2013-09-27','12:05:00',5.26),('8975','2013-09-27','12:10:00',5.45),('8975','2013-09-27','12:15:00',5.53),('8975','2013-09-27','12:20:00',4.72),('8975','2013-09-27','12:25:00',5.08),('8975','2013-09-27','12:30:00',5.52),('8975','2013-09-27','12:35:00',2.04),('8975','2013-09-27','12:40:00',2.12),('8975','2013-09-27','12:45:00',2.98),('8975','2013-09-27','12:50:00',5.45),('8975','2013-09-27','12:55:00',4.87),('8975','2013-09-27','13:00:00',5.08),('8975','2013-09-27','13:05:00',4.4),('8975','2013-09-27','13:10:00',4.7),('8975','2013-09-27','13:15:00',4.9),('8975','2013-09-27','13:20:00',4.02),('8975','2013-09-27','13:25:00',4.91),('8975','2013-09-27','13:30:00',5.15),('8975','2013-09-27','13:35:00',4.27),('8975','2013-09-27','13:40:00',4.71),('8975','2013-09-27','13:45:00',5.14),('8975','2013-09-27','13:50:00',4.83),('8975','2013-09-27','13:55:00',3.75),('8975','2013-09-27','14:00:00',2.96),('8975','2013-09-27','14:05:00',3.99),('8975','2013-09-27','14:10:00',4.57),('8975','2013-09-27','14:15:00',4.25),('8975','2013-09-27','14:20:00',2.92),('8975','2013-09-27','14:25:00',3.99),('8975','2013-09-27','14:30:00',3.5),('8975','2013-09-27','14:35:00',1.51),('8975','2013-09-27','14:40:00',1.6),('8975','2013-09-27','14:45:00',3.01),('8975','2013-09-27','14:50:00',3.72),('8975','2013-09-27','14:55:00',3.13),('8975','2013-09-27','15:00:00',3.46),('8975','2013-09-27','15:05:00',3.17),('8975','2013-09-27','15:10:00',3.62),('8975','2013-09-27','15:15:00',3.48),('8975','2013-09-27','15:20:00',3.44),('8975','2013-09-27','15:25:00',3.11),('8975','2013-09-27','15:30:00',2.95),('8975','2013-09-27','15:35:00',2.26),('8975','2013-09-27','15:40:00',2.01),('8975','2013-09-27','15:45:00',2.82),('8975','2013-09-27','15:50:00',2.82),('8975','2013-09-27','15:55:00',3.14),('8975','2013-09-27','16:00:00',2.28),('8975','2013-09-27','16:05:00',2.6),('8975','2013-09-27','16:10:00',2.45),('8975','2013-09-27','16:15:00',2.22),('8975','2013-09-27','16:20:00',1.89),('8975','2013-09-27','16:25:00',1.8),('8975','2013-09-27','16:30:00',1.73),('8975','2013-09-27','16:35:00',1.67),('8975','2013-09-27','16:40:00',1.57),('8975','2013-09-27','16:45:00',1.49),('8975','2013-09-27','16:50:00',1.43),('8975','2013-09-27','16:55:00',1.38),('8975','2013-09-27','17:00:00',1.33),('8975','2013-09-27','17:05:00',1.28),('8975','2013-09-27','17:10:00',1.24),('8975','2013-09-27','17:15:00',1.2),('8975','2013-09-27','17:20:00',1.15),('8975','2013-09-27','17:25:00',1.1),('8975','2013-09-27','17:30:00',1.04),('8975','2013-09-26','08:05:00',1.14),('8975','2013-09-26','08:10:00',1.39),('8975','2013-09-26','08:15:00',1.54),('8975','2013-09-26','08:20:00',1.95),('8975','2013-09-26','08:25:00',1.86),('8975','2013-09-26','08:30:00',2.28),('8975','2013-09-26','08:35:00',2.56),('8975','2013-09-26','08:40:00',1.89),('8975','2013-09-26','08:45:00',1.3),('8975','2013-09-26','08:50:00',1.55),('8975','2013-09-26','08:55:00',2.4),('8975','2013-09-26','09:00:00',3.31),('8975','2013-09-26','09:05:00',3.37),('8975','2013-09-26','09:10:00',2.42),('8975','2013-09-26','09:15:00',1.84),('8975','2013-09-26','09:20:00',1.78),('8975','2013-09-26','09:25:00',1.26),('8975','2013-09-26','09:30:00',1.16),('8975','2013-09-26','09:35:00',1.6),('8975','2013-09-26','09:40:00',1.9),('8975','2013-09-26','09:45:00',1.59),('8975','2013-09-26','09:50:00',2.55),('8975','2013-09-26','09:55:00',3.74),('8975','2013-09-26','10:00:00',4.19),('8975','2013-09-26','10:05:00',4.01),('8975','2013-09-26','10:10:00',2.58),('8975','2013-09-26','10:15:00',2.32),('8975','2013-09-26','10:20:00',3.86),('8975','2013-09-26','10:25:00',2.23),('8975','2013-09-26','10:30:00',3.86),('8975','2013-09-26','10:35:00',3.14),('8975','2013-09-26','10:40:00',3.25),('8975','2013-09-26','10:45:00',3.36),('8975','2013-09-26','10:50:00',4.21),('8975','2013-09-26','10:55:00',3.03),('8975','2013-09-26','11:00:00',3.58),('8975','2013-09-26','11:05:00',4.52),('8975','2013-09-26','11:10:00',4.7),('8975','2013-09-26','11:15:00',3.41),('8975','2013-09-26','11:20:00',1.32),('8975','2013-09-26','11:25:00',1.28),('8975','2013-09-26','11:30:00',1.85),('8975','2013-09-26','11:35:00',1.61),('8975','2013-09-26','11:40:00',2.04),('8975','2013-09-26','11:45:00',1.35),('8975','2013-09-26','11:50:00',1.31),('8975','2013-09-26','11:55:00',1.6),('8975','2013-09-26','12:00:00',2.18),('8975','2013-09-26','12:05:00',1.78),('8975','2013-09-26','12:10:00',1.52),('8975','2013-09-26','12:15:00',3.72),('8975','2013-09-26','12:20:00',3.38),('8975','2013-09-26','12:25:00',3.13),('8975','2013-09-26','12:30:00',1.97),('8975','2013-09-26','12:35:00',1.32),('8975','2013-09-26','12:40:00',1.05),('8975','2013-09-26','12:55:00',1.76),('8975','2013-09-26','13:00:00',1.71),('8975','2013-09-26','13:05:00',2.58),('8975','2013-09-26','13:10:00',3.53),('8975','2013-09-26','13:15:00',2.83),('8975','2013-09-26','13:20:00',1.84),('8975','2013-09-26','13:25:00',1.5),('8975','2013-09-26','13:30:00',1.93),('8975','2013-09-26','13:35:00',1.48),('8975','2013-09-26','13:40:00',1.26),('8975','2013-09-26','13:45:00',1.37),('8975','2013-09-26','13:50:00',4.5),('8975','2013-09-26','13:55:00',4.36),('8975','2013-09-26','14:00:00',2.23),('8975','2013-09-26','14:05:00',2.45),('8975','2013-09-26','14:10:00',4.88),('8975','2013-09-26','14:15:00',4.26),('8975','2013-09-26','14:20:00',3.77),('8975','2013-09-26','14:25:00',4.34),('8975','2013-09-26','14:30:00',4.18),('8975','2013-09-26','14:35:00',4.17),('8975','2013-09-26','14:40:00',4.05),('8975','2013-09-26','14:45:00',3.74),('8975','2013-09-26','14:50:00',3.52),('8975','2013-09-26','14:55:00',3.58),('8975','2013-09-26','15:00:00',3.49),('8975','2013-09-26','15:05:00',3.5),('8975','2013-09-26','15:10:00',3.27),('8975','2013-09-26','15:15:00',3.2),('8975','2013-09-26','15:20:00',1.54),('8975','2013-09-26','15:25:00',2.61),('8975','2013-09-26','15:30:00',2.24),('8975','2013-09-26','15:35:00',2.88),('8975','2013-09-26','15:45:00',1.92),('8975','2013-09-26','15:50:00',2.72),('8975','2013-09-26','15:55:00',2.02),('8975','2013-09-26','16:00:00',1.27),('8975','2013-09-26','16:05:00',2.28),('8975','2013-09-26','16:10:00',2.21),('8975','2013-09-26','16:15:00',2.14),('8975','2013-09-26','16:20:00',1.5),('8975','2013-09-26','16:25:00',1.93),('8975','2013-09-26','16:30:00',1.63),('8975','2013-09-26','16:35:00',1.05),('8975','2013-09-26','16:40:00',1.32),('8975','2013-09-26','16:45:00',1.65),('8975','2013-09-26','16:50:00',1.57),('8975','2013-09-26','16:55:00',1.45),('8975','2013-09-26','17:00:00',1.41),('8975','2013-09-26','17:05:00',1.33),('8975','2013-09-26','17:10:00',1.3),('8975','2013-09-26','17:15:00',1.09),('8975','2013-09-26','17:25:00',1.15),('8975','2013-09-26','17:30:00',1.08),('8975','2013-09-26','17:35:00',1.03),('8975','2013-09-26','17:40:00',1.05),('8975','2013-09-26','17:45:00',1.06),('8975','2013-09-25','07:40:00',1.27),('8975','2013-09-25','07:45:00',1.22),('8975','2013-09-25','07:55:00',1.42),('8975','2013-09-25','08:00:00',1.57),('8975','2013-09-25','08:05:00',2.09),('8975','2013-09-25','08:10:00',2.25),('8975','2013-09-25','08:15:00',2.32),('8975','2013-09-25','08:20:00',2.27),('8975','2013-09-25','08:25:00',1.62),('8975','2013-09-25','08:30:00',2.22),('8975','2013-09-25','08:35:00',2.65),('8975','2013-09-25','08:40:00',2.93),('8975','2013-09-25','08:45:00',3),('8975','2013-09-25','08:50:00',3.1),('8975','2013-09-25','08:55:00',3.18),('8975','2013-09-25','09:00:00',3.25),('8975','2013-09-25','09:05:00',3.36),('8975','2013-09-25','09:10:00',3.46),('8975','2013-09-25','09:15:00',3.56),('8975','2013-09-25','09:20:00',3.6),('8975','2013-09-25','09:25:00',3.71),('8975','2013-09-25','09:30:00',3.76),('8975','2013-09-25','09:35:00',3.89),('8975','2013-09-25','09:40:00',3.97),('8975','2013-09-25','09:45:00',4.02),('8975','2013-09-25','09:50:00',4.05),('8975','2013-09-25','09:55:00',4.14),('8975','2013-09-25','10:00:00',4.21),('8975','2013-09-25','10:05:00',4.27),('8975','2013-09-25','10:10:00',4.25),('8975','2013-09-25','10:15:00',4.33),('8975','2013-09-25','10:20:00',4.41),('8975','2013-09-25','10:25:00',4.47),('8975','2013-09-25','10:30:00',4.54),('8975','2013-09-25','10:35:00',4.66),('8975','2013-09-25','10:40:00',4.67),('8975','2013-09-25','10:45:00',4.62),('8975','2013-09-25','10:50:00',4.71),('8975','2013-09-25','10:55:00',4.65),('8975','2013-09-25','11:00:00',3.94),('8975','2013-09-25','11:05:00',3.98),('8975','2013-09-25','11:10:00',2.73),('8975','2013-09-25','11:15:00',2.62),('8975','2013-09-25','11:20:00',5.22),('8975','2013-09-25','11:25:00',5.16),('8975','2013-09-25','11:30:00',4.63),('8975','2013-09-25','11:35:00',4.8),('8975','2013-09-25','11:40:00',4.28),('8975','2013-09-25','11:45:00',4.1),('8975','2013-09-25','11:50:00',2.32),('8975','2013-09-25','11:55:00',2.1),('8975','2013-09-25','12:00:00',2.7),('8975','2013-09-25','12:05:00',1.7),('8975','2013-09-25','12:10:00',2.64),('8975','2013-09-25','12:15:00',2.52),('8975','2013-09-25','12:20:00',2.71),('8975','2013-09-25','12:25:00',2.1),('8975','2013-09-25','12:30:00',1.91),('8975','2013-09-25','12:35:00',2.15),('8975','2013-09-25','12:40:00',2.32),('8975','2013-09-25','12:45:00',2.64),('8975','2013-09-25','12:50:00',2.49),('8975','2013-09-25','12:55:00',2.34),('8975','2013-09-25','13:00:00',2.13),('8975','2013-09-25','13:05:00',2.1),('8975','2013-09-25','13:10:00',3.17),('8975','2013-09-25','13:15:00',2.98),('8975','2013-09-25','13:20:00',2.7),('8975','2013-09-25','13:25:00',5.43),('8975','2013-09-25','13:30:00',4.11),('8975','2013-09-25','13:35:00',4.27),('8975','2013-09-25','13:40:00',4.03),('8975','2013-09-25','13:45:00',3.47),('8975','2013-09-25','13:50:00',5.12),('8975','2013-09-25','13:55:00',5.01),('8975','2013-09-25','14:00:00',2.36),('8975','2013-09-25','14:05:00',4.16),('8975','2013-09-25','14:10:00',2),('8975','2013-09-25','14:15:00',1.66),('8975','2013-09-25','14:20:00',1.3),('8975','2013-09-25','14:25:00',1.58),('8975','2013-09-25','14:30:00',3.93),('8975','2013-09-25','14:35:00',3.66),('8975','2013-09-25','14:40:00',1.88),('8975','2013-09-25','14:45:00',3.19),('8975','2013-09-25','14:50:00',3.23),('8975','2013-09-25','14:55:00',4.27),('8975','2013-09-25','15:00:00',3.25),('8975','2013-09-25','15:05:00',3.29),('8975','2013-09-25','15:10:00',2.21),('8975','2013-09-25','15:15:00',1.53),('8975','2013-09-25','15:20:00',1.31),('8975','2013-09-25','15:25:00',1.6),('8975','2013-09-25','15:30:00',2.83),('8975','2013-09-25','15:35:00',1.48),('8975','2013-09-25','15:40:00',1.84),('8975','2013-09-25','15:45:00',2.05),('8975','2013-09-25','15:50:00',2.78),('8975','2013-09-25','15:55:00',1.39),('8975','2013-09-25','16:00:00',1.26),('8975','2013-09-25','16:05:00',1.22),('8975','2013-09-25','16:10:00',1.83),('8975','2013-09-25','16:15:00',1.4),('8975','2013-09-25','16:20:00',1.98),('8975','2013-09-25','16:25:00',1.87),('8975','2013-09-25','16:30:00',1.78),('8975','2013-09-25','16:35:00',1.67),('8975','2013-09-25','16:40:00',1.62),('8975','2013-09-25','16:45:00',1.54),('8975','2013-09-25','16:50:00',1.47),('8975','2013-09-25','16:55:00',1.4),('8975','2013-09-25','17:00:00',1.37),('8975','2013-09-25','17:05:00',1.35),('8975','2013-09-25','17:10:00',1.31),('8975','2013-09-25','17:15:00',1.25),('8975','2013-09-25','17:20:00',1.22),('8975','2013-09-25','17:25:00',1.13),('8975','2013-09-25','17:30:00',1.08),('8975','2013-09-25','17:35:00',1.08),('8975','2013-09-25','17:40:00',1.07),('8975','2013-09-24','08:00:00',1.27),('8975','2013-09-24','08:05:00',1.9),('8975','2013-09-24','08:10:00',1.83),('8975','2013-09-24','08:30:00',1.51),('8975','2013-09-24','08:35:00',2.46),('8975','2013-09-24','08:40:00',3.17),('8975','2013-09-24','08:45:00',3.26),('8975','2013-09-24','08:50:00',3.42),('8975','2013-09-24','08:55:00',2.07),('8975','2013-09-24','09:00:00',1.15),('8975','2013-09-24','09:05:00',1.08),('8975','2013-09-24','09:10:00',1.7),('8975','2013-09-24','09:15:00',2.23),('8975','2013-09-24','09:20:00',1.86),('8975','2013-09-24','09:25:00',1.71),('8975','2013-09-24','09:30:00',1.61),('8975','2013-09-24','09:35:00',3.4),('8975','2013-09-24','09:40:00',4.88),('8975','2013-09-24','09:45:00',4.94),('8975','2013-09-24','09:50:00',4.99),('8975','2013-09-24','09:55:00',2.03),('8975','2013-09-24','10:00:00',1.04),('8975','2013-09-24','10:35:00',1),('8975','2013-09-24','10:40:00',3.76),('8975','2013-09-24','10:45:00',4.83),('8975','2013-09-24','10:50:00',1.76),('8975','2013-09-24','10:55:00',1.77),('8975','2013-09-24','11:00:00',1.86),('8975','2013-09-24','11:05:00',1.52),('8975','2013-09-24','11:10:00',2.46),('8975','2013-09-24','11:15:00',2.37),('8975','2013-09-24','11:20:00',4.86),('8975','2013-09-24','11:25:00',4.91),('8975','2013-09-24','11:30:00',5.12),('8975','2013-09-24','11:35:00',5.78),('8975','2013-09-24','11:40:00',4.34),('8975','2013-09-24','11:45:00',3.56),('8975','2013-09-24','11:50:00',1.5),('8975','2013-09-24','11:55:00',1.41),('8975','2013-09-24','12:00:00',2.03),('8975','2013-09-24','12:05:00',2.15),('8975','2013-09-24','12:10:00',5.05),('8975','2013-09-24','12:15:00',1.42),('8975','2013-09-24','12:20:00',1.11),('8975','2013-09-24','12:25:00',1.26),('8975','2013-09-24','12:30:00',1.94),('8975','2013-09-24','12:35:00',6.26),('8975','2013-09-24','12:40:00',6.41),('8975','2013-09-24','12:45:00',2.96),('8975','2013-09-24','12:50:00',1.4),('8975','2013-09-24','12:55:00',1.47),('8975','2013-09-24','13:00:00',4.38),('8975','2013-09-24','13:05:00',1.95),('8975','2013-09-24','13:10:00',3.64),('8975','2013-09-24','13:15:00',6.3),('8975','2013-09-24','13:20:00',4.74),('8975','2013-09-24','13:25:00',3.36),('8975','2013-09-24','13:30:00',3.31),('8975','2013-09-24','13:35:00',1.39),('8975','2013-09-24','13:40:00',1.36),('8975','2013-09-24','13:45:00',1.61),('8975','2013-09-24','13:50:00',1.33),('8975','2013-09-24','13:55:00',1.25),('8975','2013-09-24','14:00:00',1.31),('8975','2013-09-24','14:05:00',1.41),('8975','2013-09-24','14:10:00',1.6),('8975','2013-09-24','14:15:00',3.77),('8975','2013-09-24','14:20:00',5.58),('8975','2013-09-24','14:25:00',4.91),('8975','2013-09-24','14:30:00',2.95),('8975','2013-09-24','14:35:00',1.66),('8975','2013-09-24','14:40:00',1.38),('8975','2013-09-24','14:45:00',1.91),('8975','2013-09-24','14:50:00',2.84),('8975','2013-09-24','14:55:00',1.99),('8975','2013-09-24','15:00:00',3.29),('8975','2013-09-24','15:05:00',3.36),('8975','2013-09-24','15:10:00',3.62),('8975','2013-09-24','15:15:00',2.44),('8975','2013-09-24','15:20:00',2.4),('8975','2013-09-24','15:25:00',2.14),('8975','2013-09-24','15:30:00',3.42),('8975','2013-09-24','15:35:00',2.79),('8975','2013-09-24','15:40:00',3.11),('8975','2013-09-24','15:45:00',2.93),('8975','2013-09-24','15:50:00',2.87),('8975','2013-09-24','15:55:00',2.31),('8975','2013-09-24','16:00:00',1.61),('8975','2013-09-24','16:05:00',2.37),('8975','2013-09-24','16:10:00',2.31),('8975','2013-09-24','16:15:00',1.96),('8975','2013-09-24','16:20:00',2.04),('8975','2013-09-24','16:25:00',1.95),('8975','2013-09-24','16:30:00',1.89),('8975','2013-09-24','16:35:00',1.53),('8975','2013-09-24','16:40:00',1.69),('8975','2013-09-24','16:45:00',1.59),('8975','2013-09-24','16:50:00',1.43),('8975','2013-09-24','16:55:00',1.5),('8975','2013-09-24','17:00:00',1.46),('8975','2013-09-24','17:05:00',1.41),('8975','2013-09-24','17:10:00',1.36),('8975','2013-09-24','17:15:00',1.32),('8975','2013-09-24','17:20:00',1.28),('8975','2013-09-24','17:25:00',1.22),('8975','2013-09-24','17:30:00',1.16),('8975','2013-09-24','17:35:00',1.11),('8975','2013-09-24','17:40:00',1.07),('8975','2013-09-24','17:45:00',1.02),('8975','2013-09-23','07:35:00',1.21),('8975','2013-09-23','07:40:00',1.39),('8975','2013-09-23','07:45:00',1.53),('8975','2013-09-23','07:50:00',1.73),('8975','2013-09-23','07:55:00',1.97),('8975','2013-09-23','08:00:00',2.12),('8975','2013-09-23','08:05:00',2.27),('8975','2013-09-23','08:10:00',2.43),('8975','2013-09-23','08:15:00',2.56),('8975','2013-09-23','08:20:00',2.68),('8975','2013-09-23','08:25:00',2.81),('8975','2013-09-23','08:30:00',2.94),('8975','2013-09-23','08:35:00',3.04),('8975','2013-09-23','08:40:00',3.15),('8975','2013-09-23','08:45:00',3.24),('8975','2013-09-23','08:50:00',3.34),('8975','2013-09-23','08:55:00',3.43),('8975','2013-09-23','09:00:00',3.51),('8975','2013-09-23','09:05:00',3.61),('8975','2013-09-23','09:10:00',3.69),('8975','2013-09-23','09:15:00',3.78),('8975','2013-09-23','09:20:00',3.86),('8975','2013-09-23','09:25:00',3.98),('8975','2013-09-23','09:30:00',4.06),('8975','2013-09-23','09:35:00',4.13),('8975','2013-09-23','09:40:00',4.2),('8975','2013-09-23','09:45:00',4.25),('8975','2013-09-23','09:50:00',4.32),('8975','2013-09-23','09:55:00',4.37),('8975','2013-09-23','10:00:00',4.46),('8975','2013-09-23','10:05:00',4.53),('8975','2013-09-23','10:10:00',4.59),('8975','2013-09-23','10:15:00',4.69),('8975','2013-09-23','10:20:00',4.78),('8975','2013-09-23','10:25:00',4.82),('8975','2013-09-23','10:30:00',4.86),('8975','2013-09-23','10:35:00',4.9),('8975','2013-09-23','10:40:00',4.98),('8975','2013-09-23','10:45:00',5.05),('8975','2013-09-23','10:50:00',5.11),('8975','2013-09-23','10:55:00',5.11),('8975','2013-09-23','11:00:00',5.17),('8975','2013-09-23','11:05:00',5.17),('8975','2013-09-23','11:10:00',5.2),('8975','2013-09-23','11:15:00',5.24),('8975','2013-09-23','11:20:00',5.28),('8975','2013-09-23','11:25:00',5.28),('8975','2013-09-23','11:30:00',5.34),('8975','2013-09-23','11:35:00',5.34),('8975','2013-09-23','11:40:00',5.37),('8975','2013-09-23','11:45:00',5.39),('8975','2013-09-23','11:50:00',5.41),('8975','2013-09-23','11:55:00',5.4),('8975','2013-09-23','12:00:00',5.36),('8975','2013-09-23','12:05:00',5.39),('8975','2013-09-23','12:10:00',5.39),('8975','2013-09-23','12:15:00',5.33),('8975','2013-09-23','12:20:00',5.34),('8975','2013-09-23','12:25:00',5.34),('8975','2013-09-23','12:30:00',5.35),('8975','2013-09-23','12:35:00',5.33),('8975','2013-09-23','12:40:00',5.35),('8975','2013-09-23','12:45:00',5.32),('8975','2013-09-23','12:50:00',5.25),('8975','2013-09-23','12:55:00',5.23),('8975','2013-09-23','13:00:00',5.27),('8975','2013-09-23','13:05:00',5.23),('8975','2013-09-23','13:10:00',5.19),('8975','2013-09-23','13:15:00',5.12),('8975','2013-09-23','13:20:00',5.07),('8975','2013-09-23','13:25:00',5.06),('8975','2013-09-23','13:30:00',5.07),('8975','2013-09-23','13:35:00',4.95),('8975','2013-09-23','13:40:00',4.91),('8975','2013-09-23','13:45:00',4.9),('8975','2013-09-23','13:50:00',4.84),('8975','2013-09-23','13:55:00',4.8),('8975','2013-09-23','14:00:00',4.72),('8975','2013-09-23','14:05:00',4.56),('8975','2013-09-23','14:10:00',4.53),('8975','2013-09-23','14:15:00',4.44),('8975','2013-09-23','14:20:00',4.39),('8975','2013-09-23','14:25:00',4.27),('8975','2013-09-23','14:30:00',4.16),('8975','2013-09-23','14:35:00',4.07),('8975','2013-09-23','14:40:00',4.02),('8975','2013-09-23','14:45:00',3.96),('8975','2013-09-23','14:50:00',3.83),('8975','2013-09-23','14:55:00',3.59),('8975','2013-09-23','15:00:00',3.36),('8975','2013-09-23','15:05:00',3.42),('8975','2013-09-23','15:10:00',3.41),('8975','2013-09-23','15:15:00',3.36),('8975','2013-09-23','15:20:00',3.21),('8975','2013-09-23','15:25:00',2.96),('8975','2013-09-23','15:30:00',2.89),('8975','2013-09-23','15:35:00',2.95),('8975','2013-09-23','15:40:00',2.88),('8975','2013-09-23','15:45:00',2.77),('8975','2013-09-23','15:50:00',2.65),('8975','2013-09-23','15:55:00',2.57),('8975','2013-09-23','16:00:00',2.46),('8975','2013-09-23','16:05:00',2.35),('8975','2013-09-23','16:10:00',2.26),('8975','2013-09-23','16:15:00',2.11),('8975','2013-09-23','16:20:00',2),('8975','2013-09-23','16:25:00',1.92),('8975','2013-09-23','16:30:00',1.84),('8975','2013-09-23','16:35:00',1.77),('8975','2013-09-23','16:40:00',1.7),('8975','2013-09-23','16:45:00',1.64),('8975','2013-09-23','16:50:00',1.56),('8975','2013-09-23','16:55:00',1.5),('8975','2013-09-23','17:00:00',1.45),('8975','2013-09-23','17:05:00',1.4),('8975','2013-09-23','17:10:00',1.36),('8975','2013-09-23','17:15:00',1.32),('8975','2013-09-23','17:20:00',1.27),('8975','2013-09-23','17:25:00',1.22),('8975','2013-09-23','17:30:00',1.16),('8975','2013-09-23','17:35:00',1.09),('8975','2013-09-23','17:40:00',1.05),('8975','2013-09-22','07:30:00',1.09),('8975','2013-09-22','07:35:00',1.29),('8975','2013-09-22','07:40:00',1.39),('8975','2013-09-22','07:45:00',1.48),('8975','2013-09-22','07:50:00',1.9),('8975','2013-09-22','07:55:00',2.02),('8975','2013-09-22','08:00:00',2.11),('8975','2013-09-22','08:05:00',2.39),('8975','2013-09-22','08:10:00',2.56),('8975','2013-09-22','08:15:00',2.68),('8975','2013-09-22','08:20:00',2.79),('8975','2013-09-22','08:25:00',2.92),('8975','2013-09-22','08:30:00',3.02),('8975','2013-09-22','08:35:00',3.12),('8975','2013-09-22','08:40:00',3.22),('8975','2013-09-22','08:45:00',3.31),('8975','2013-09-22','08:50:00',3.39),('8975','2013-09-22','08:55:00',3.48),('8975','2013-09-22','09:00:00',3.57),('8975','2013-09-22','09:05:00',3.65),('8975','2013-09-22','09:10:00',3.74),('8975','2013-09-22','09:15:00',3.83),('8975','2013-09-22','09:20:00',3.88),('8975','2013-09-22','09:25:00',4.01),('8975','2013-09-22','09:30:00',4.09),('8975','2013-09-22','09:35:00',4.19),('8975','2013-09-22','09:40:00',4.28),('8975','2013-09-22','09:45:00',4.35),('8975','2013-09-22','09:50:00',4.43),('8975','2013-09-22','09:55:00',4.51),('8975','2013-09-22','10:00:00',4.58),('8975','2013-09-22','10:05:00',4.65),('8975','2013-09-22','10:10:00',4.72),('8975','2013-09-22','10:15:00',4.76),('8975','2013-09-22','10:20:00',4.82),('8975','2013-09-22','10:25:00',4.95),('8975','2013-09-22','10:30:00',5.03),('8975','2013-09-22','10:35:00',5.08),('8975','2013-09-22','10:40:00',5.14),('8975','2013-09-22','10:45:00',5.16),('8975','2013-09-22','10:50:00',5.24),('8975','2013-09-22','10:55:00',5.31),('8975','2013-09-22','11:00:00',5.31),('8975','2013-09-22','11:05:00',5.35),('8975','2013-09-22','11:10:00',5.38),('8975','2013-09-22','11:15:00',5.41),('8975','2013-09-22','11:20:00',5.47),('8975','2013-09-22','11:25:00',5.53),('8975','2013-09-22','11:30:00',5.6),('8975','2013-09-22','11:35:00',5.66),('8975','2013-09-22','11:40:00',5.68),('8975','2013-09-22','11:45:00',5.68),('8975','2013-09-22','11:50:00',5.69),('8975','2013-09-22','11:55:00',5.67),('8975','2013-09-22','12:00:00',5.67),('8975','2013-09-22','12:05:00',5.67),('8975','2013-09-22','12:10:00',5.67),('8975','2013-09-22','12:15:00',5.66),('8975','2013-09-22','12:20:00',5.68),('8975','2013-09-22','12:25:00',5.67),('8975','2013-09-22','12:30:00',5.67),('8975','2013-09-22','12:35:00',5.67),('8975','2013-09-22','12:40:00',5.62),('8975','2013-09-22','12:45:00',5.59),('8975','2013-09-22','12:50:00',5.54),('8975','2013-09-22','12:55:00',5.48),('8975','2013-09-22','13:00:00',5.43),('8975','2013-09-22','13:05:00',5.44),('8975','2013-09-22','13:10:00',5.4),('8975','2013-09-22','13:15:00',5.34),('8975','2013-09-22','13:20:00',5.27),('8975','2013-09-22','13:25:00',5.18),('8975','2013-09-22','13:30:00',5.2),('8975','2013-09-22','13:35:00',5.12),('8975','2013-09-22','13:40:00',5.09),('8975','2013-09-22','13:45:00',5.03),('8975','2013-09-22','13:50:00',4.97),('8975','2013-09-22','13:55:00',4.9),('8975','2013-09-22','14:00:00',4.84),('8975','2013-09-22','14:05:00',4.71),('8975','2013-09-22','14:10:00',4.37),('8975','2013-09-22','14:15:00',4.44),('8975','2013-09-22','14:20:00',4.38),('8975','2013-09-22','14:25:00',4.38),('8975','2013-09-22','14:30:00',4.33),('8975','2013-09-22','14:35:00',4.18),('8975','2013-09-22','14:40:00',3.81),('8975','2013-09-22','14:45:00',2.23),('8975','2013-09-22','14:50:00',3.67),('8975','2013-09-22','14:55:00',3.62),('8975','2013-09-22','15:00:00',3.52),('8975','2013-09-22','15:05:00',3.04),('8975','2013-09-22','15:10:00',1.96),('8975','2013-09-22','15:15:00',3.24),('8975','2013-09-22','15:20:00',3.06),('8975','2013-09-22','15:25:00',2.66),('8975','2013-09-22','15:30:00',3.14),('8975','2013-09-22','15:35:00',2.99),('8975','2013-09-22','15:40:00',2.95),('8975','2013-09-22','15:45:00',2.77),('8975','2013-09-22','15:50:00',2.64),('8975','2013-09-22','15:55:00',2.62),('8975','2013-09-22','16:00:00',2.47),('8975','2013-09-22','16:05:00',2.35),('8975','2013-09-22','16:10:00',2.3),('8975','2013-09-22','16:15:00',2.16),('8975','2013-09-22','16:20:00',1.35),('8975','2013-09-22','16:25:00',1.47),('8975','2013-09-22','16:30:00',1.13),('8975','2013-09-22','16:35:00',1.63),('8975','2013-09-22','16:40:00',1.67),('8975','2013-09-22','16:45:00',1.57),('8975','2013-09-22','16:50:00',1.51),('8975','2013-09-22','16:55:00',1.48),('8975','2013-09-22','17:00:00',1.43),('8975','2013-09-22','17:05:00',1.39),('8975','2013-09-22','17:10:00',1.35),('8975','2013-09-22','17:15:00',1.31),('8975','2013-09-22','17:20:00',1.27),('8975','2013-09-22','17:25:00',1.23),('8975','2013-09-22','17:30:00',1.19),('8975','2013-09-22','17:35:00',1.13),('8975','2013-09-22','17:40:00',1.08),('8975','2013-09-22','17:45:00',1.02),('8975','2013-09-21','07:35:00',1.35),('8975','2013-09-21','07:40:00',1.55),('8975','2013-09-21','07:45:00',1.61),('8975','2013-09-21','07:50:00',1.73),('8975','2013-09-21','07:55:00',2.05),('8975','2013-09-21','08:00:00',2.16),('8975','2013-09-21','08:05:00',2.39),('8975','2013-09-21','08:10:00',2.64),('8975','2013-09-21','08:15:00',2.84),('8975','2013-09-21','08:20:00',2.96),('8975','2013-09-21','08:25:00',2.96),('8975','2013-09-21','08:30:00',3.01),('8975','2013-09-21','08:35:00',2.83),('8975','2013-09-21','08:40:00',3.13),('8975','2013-09-21','08:45:00',3.14),('8975','2013-09-21','08:50:00',3.36),('8975','2013-09-21','08:55:00',3.47),('8975','2013-09-21','09:00:00',3.58),('8975','2013-09-21','09:05:00',3.66),('8975','2013-09-21','09:10:00',3.77),('8975','2013-09-21','09:15:00',3.87),('8975','2013-09-21','09:20:00',3.98),('8975','2013-09-21','09:25:00',4.07),('8975','2013-09-21','09:30:00',4.17),('8975','2013-09-21','09:35:00',4.25),('8975','2013-09-21','09:40:00',4.33),('8975','2013-09-21','09:45:00',4.41),('8975','2013-09-21','09:50:00',4.52),('8975','2013-09-21','09:55:00',4.61),('8975','2013-09-21','10:00:00',4.68),('8975','2013-09-21','10:05:00',4.76),('8975','2013-09-21','10:10:00',4.84),('8975','2013-09-21','10:15:00',4.9),('8975','2013-09-21','10:20:00',4.99),('8975','2013-09-21','10:25:00',5.06),('8975','2013-09-21','10:30:00',5.14),('8975','2013-09-21','10:35:00',5.2),('8975','2013-09-21','10:40:00',5.25),('8975','2013-09-21','10:45:00',5.3),('8975','2013-09-21','10:50:00',5.37),('8975','2013-09-21','10:55:00',5.41),('8975','2013-09-21','11:00:00',5.45),('8975','2013-09-21','11:05:00',5.49),('8975','2013-09-21','11:10:00',5.53),('8975','2013-09-21','11:15:00',5.55),('8975','2013-09-21','11:20:00',5.61),('8975','2013-09-21','11:25:00',5.64),('8975','2013-09-21','11:30:00',5.65),('8975','2013-09-21','11:35:00',5.65),('8975','2013-09-21','11:40:00',5.64),('8975','2013-09-21','11:45:00',5.68),('8975','2013-09-21','11:50:00',5.72),('8975','2013-09-21','11:55:00',5.73),('8975','2013-09-21','12:00:00',5.73),('8975','2013-09-21','12:05:00',5.74),('8975','2013-09-21','12:10:00',5.78),('8975','2013-09-21','12:15:00',5.78),('8975','2013-09-21','12:20:00',5.74),('8975','2013-09-21','12:25:00',5.41),('8975','2013-09-21','12:30:00',5.71),('8975','2013-09-21','12:35:00',5.64),('8975','2013-09-21','12:40:00',5.67),('8975','2013-09-21','12:45:00',5.68),('8975','2013-09-21','12:50:00',5.33),('8975','2013-09-21','12:55:00',5.75),('8975','2013-09-21','13:00:00',5.66),('8975','2013-09-21','13:05:00',5.58),('8975','2013-09-21','13:10:00',5.58),('8975','2013-09-21','13:15:00',5.49),('8975','2013-09-21','13:20:00',5.36),('8975','2013-09-21','13:25:00',5.32),('8975','2013-09-21','13:30:00',5.33),('8975','2013-09-21','13:35:00',5.26),('8975','2013-09-21','13:40:00',5.2),('8975','2013-09-21','13:45:00',5.13),('8975','2013-09-21','13:50:00',5.09),('8975','2013-09-21','13:55:00',5.09),('8975','2013-09-21','14:00:00',5.01),('8975','2013-09-21','14:05:00',4.85),('8975','2013-09-21','14:10:00',4.76),('8975','2013-09-21','14:15:00',4.84),('8975','2013-09-21','14:20:00',5.2),('8975','2013-09-21','14:25:00',5.12),('8975','2013-09-21','14:30:00',3.79),('8975','2013-09-21','14:35:00',2.45),('8975','2013-09-21','14:40:00',4.28),('8975','2013-09-21','14:45:00',3.68),('8975','2013-09-21','14:50:00',4.13),('8975','2013-09-21','14:55:00',3.98),('8975','2013-09-21','15:00:00',3.79),('8975','2013-09-21','15:05:00',3.7),('8975','2013-09-21','15:10:00',3.82),('8975','2013-09-21','15:15:00',3.87),('8975','2013-09-21','15:20:00',3.43),('8975','2013-09-21','15:25:00',4.16),('8975','2013-09-21','15:30:00',3.65),('8975','2013-09-21','15:35:00',2.43),('8975','2013-09-21','15:40:00',2.44),('8975','2013-09-21','15:45:00',3.21),('8975','2013-09-21','15:50:00',2.89),('8975','2013-09-21','15:55:00',2.83),('8975','2013-09-21','16:00:00',2.94),('8975','2013-09-21','16:05:00',3.33),('8975','2013-09-21','16:10:00',3.41),('8975','2013-09-21','16:15:00',2.98),('8975','2013-09-21','16:20:00',2.69),('8975','2013-09-21','16:25:00',2.12),('8975','2013-09-21','16:30:00',1.47),('8975','2013-09-21','16:35:00',1.59),('8975','2013-09-21','16:40:00',1.51),('8975','2013-09-21','16:45:00',1.53),('8975','2013-09-21','16:50:00',2.12),('8975','2013-09-21','16:55:00',1.66),('8975','2013-09-21','17:00:00',1.9),('8975','2013-09-21','17:05:00',1.82),('8975','2013-09-21','17:10:00',1.79),('8975','2013-09-21','17:15:00',1.6),('8975','2013-09-21','17:35:00',1.23),('8975','2013-09-21','17:40:00',1.14),('8975','2013-09-20','07:30:00',1.12),('8975','2013-09-20','07:35:00',1.21),('8975','2013-09-20','07:40:00',1.35),('8975','2013-09-20','07:45:00',1.55),('8975','2013-09-20','07:50:00',1.6),('8975','2013-09-20','07:55:00',1.87),('8975','2013-09-20','08:00:00',2.11),('8975','2013-09-20','08:05:00',2.28),('8975','2013-09-20','08:10:00',2.45),('8975','2013-09-20','08:15:00',2.6),('8975','2013-09-20','08:20:00',2.73),('8975','2013-09-20','08:25:00',2.83),('8975','2013-09-20','08:30:00',2.92),('8975','2013-09-20','08:35:00',3.03),('8975','2013-09-20','08:40:00',3.12),('8975','2013-09-20','08:45:00',3.2),('8975','2013-09-20','08:50:00',3.29),('8975','2013-09-20','08:55:00',3.36),('8975','2013-09-20','09:00:00',3.44),('8975','2013-09-20','09:05:00',3.54),('8975','2013-09-20','09:10:00',3.64),('8975','2013-09-20','09:15:00',3.72),('8975','2013-09-20','09:20:00',3.84),('8975','2013-09-20','09:25:00',3.94),('8975','2013-09-20','09:30:00',4.03),('8975','2013-09-20','09:35:00',4.11),('8975','2013-09-20','09:40:00',4.08),('8975','2013-09-20','09:45:00',4.22),('8975','2013-09-20','09:50:00',4.38),('8975','2013-09-20','09:55:00',4.46),('8975','2013-09-20','10:00:00',4.54),('8975','2013-09-20','10:05:00',4.61),('8975','2013-09-20','10:10:00',4.67),('8975','2013-09-20','10:15:00',4.73),('8975','2013-09-20','10:20:00',4.8),('8975','2013-09-20','10:25:00',4.83),('8975','2013-09-20','10:30:00',4.84),('8975','2013-09-20','10:35:00',4.91),('8975','2013-09-20','10:40:00',4.98),('8975','2013-09-20','10:45:00',5.04),('8975','2013-09-20','10:50:00',5.09),('8975','2013-09-20','10:55:00',5.16),('8975','2013-09-20','11:00:00',5.19),('8975','2013-09-20','11:05:00',5.2),('8975','2013-09-20','11:10:00',5.27),('8975','2013-09-20','11:15:00',5.32),('8975','2013-09-20','11:20:00',5.32),('8975','2013-09-20','11:25:00',5.34),('8975','2013-09-20','11:30:00',5.36),('8975','2013-09-20','11:35:00',5.42),('8975','2013-09-20','11:40:00',5.41),('8975','2013-09-20','11:45:00',5.46),('8975','2013-09-20','11:50:00',5.57),('8975','2013-09-20','11:55:00',5.57),('8975','2013-09-20','12:00:00',5.57),('8975','2013-09-20','12:05:00',5.56),('8975','2013-09-20','12:10:00',5.28),('8975','2013-09-20','12:15:00',5.67),('8975','2013-09-20','12:20:00',5.09),('8975','2013-09-20','12:25:00',5.56),('8975','2013-09-20','12:30:00',5.61),('8975','2013-09-20','12:35:00',4.95),('8975','2013-09-20','12:40:00',3.74),('8975','2013-09-20','12:45:00',4.75),('8975','2013-09-20','12:50:00',4.77),('8975','2013-09-20','12:55:00',5.37),('8975','2013-09-20','13:00:00',5.24),('8975','2013-09-20','13:05:00',5.09),('8975','2013-09-20','13:10:00',5.1),('8975','2013-09-20','13:15:00',5.25),('8975','2013-09-20','13:20:00',4.87),('8975','2013-09-20','13:25:00',5.19),('8975','2013-09-20','13:30:00',4.89),('8975','2013-09-20','13:35:00',4.86),('8975','2013-09-20','13:40:00',4.99),('8975','2013-09-20','13:45:00',4.62),('8975','2013-09-20','13:50:00',4.64),('8975','2013-09-20','13:55:00',4.39),('8975','2013-09-20','14:00:00',4.78),('8975','2013-09-20','14:05:00',4.6),('8975','2013-09-20','14:10:00',4.62),('8975','2013-09-20','14:15:00',4.49),('8975','2013-09-20','14:20:00',4.56),('8975','2013-09-20','14:25:00',4.49),('8975','2013-09-20','14:30:00',4.39),('8975','2013-09-20','14:35:00',4.32),('8975','2013-09-20','14:40:00',4.22),('8975','2013-09-20','14:45:00',4.1),('8975','2013-09-20','14:50:00',3.99),('8975','2013-09-20','14:55:00',3.8),('8975','2013-09-20','15:00:00',3.7),('8975','2013-09-20','15:05:00',3.65),('8975','2013-09-20','15:10:00',3.57),('8975','2013-09-20','15:15:00',3.4),('8975','2013-09-20','15:20:00',3.37),('8975','2013-09-20','15:25:00',3.09),('8975','2013-09-20','15:30:00',3.02),('8975','2013-09-20','15:35:00',3.03),('8975','2013-09-20','15:40:00',2.95),('8975','2013-09-20','15:45:00',2.76),('8975','2013-09-20','15:50:00',2.3),('8975','2013-09-20','15:55:00',2.69),('8975','2013-09-20','16:00:00',1.75),('8975','2013-09-20','16:05:00',1.36),('8975','2013-09-20','16:10:00',1.44),('8975','2013-09-20','16:15:00',1.3),('8975','2013-09-20','16:20:00',1.7),('8975','2013-09-20','16:25:00',1.05),('8975','2013-09-20','16:30:00',1.09),('8975','2013-09-20','16:35:00',1.47),('8975','2013-09-20','16:40:00',1.2),('8975','2013-09-20','16:45:00',1.03),('8975','2013-09-20','16:50:00',1),('8975','2013-09-20','16:55:00',1.43),('8975','2013-09-20','17:05:00',1.1),('8975','2013-09-20','17:10:00',1.26),('8975','2013-09-20','17:15:00',1.17),('8975','2013-09-20','17:35:00',1.2),('8975','2013-09-20','17:40:00',1.03),('8975','2013-09-20','17:45:00',1.1),('8975','2013-09-19','08:25:00',1.13),('8975','2013-09-19','08:30:00',1.72),('8975','2013-09-19','08:35:00',1.98),('8975','2013-09-19','08:40:00',2.51),('8975','2013-09-19','08:45:00',1.91),('8975','2013-09-19','08:50:00',2.09),('8975','2013-09-19','08:55:00',1.96),('8975','2013-09-19','09:00:00',2.4),('8975','2013-09-19','09:05:00',3.45),('8975','2013-09-19','09:10:00',2.41),('8975','2013-09-19','09:15:00',1.92),('8975','2013-09-19','09:20:00',1.92),('8975','2013-09-19','09:25:00',1.9),('8975','2013-09-19','09:30:00',1.98),('8975','2013-09-19','09:35:00',2.04),('8975','2013-09-19','09:40:00',2.06),('8975','2013-09-19','09:45:00',1.99),('8975','2013-09-19','09:50:00',2.11),('8975','2013-09-19','09:55:00',2.34),('8975','2013-09-19','10:00:00',2.62),('8975','2013-09-19','10:05:00',3.01),('8975','2013-09-19','10:10:00',3.7),('8975','2013-09-19','10:15:00',3.78),('8975','2013-09-19','10:20:00',3.56),('8975','2013-09-19','10:25:00',3.54),('8975','2013-09-19','10:30:00',3.79),('8975','2013-09-19','10:35:00',5.13),('8975','2013-09-19','10:40:00',5.41),('8975','2013-09-19','10:45:00',5.17),('8975','2013-09-19','10:50:00',4.74),('8975','2013-09-19','10:55:00',4.61),('8975','2013-09-19','11:00:00',3.01),('8975','2013-09-19','11:05:00',3.42),('8975','2013-09-19','11:10:00',4.85),('8975','2013-09-19','11:15:00',3.9),('8975','2013-09-19','11:20:00',4.29),('8975','2013-09-19','11:25:00',5.01),('8975','2013-09-19','11:30:00',4.57),('8975','2013-09-19','11:35:00',6.85),('8975','2013-09-19','11:40:00',5.38),('8975','2013-09-19','11:45:00',6.06),('8975','2013-09-19','11:50:00',5.83),('8975','2013-09-19','11:55:00',5.75),('8975','2013-09-19','12:00:00',5.7),('8975','2013-09-19','12:05:00',5.69),('8975','2013-09-19','12:10:00',5.85),('8975','2013-09-19','12:15:00',5.67),('8975','2013-09-19','12:20:00',4.87),('8975','2013-09-19','12:25:00',3.76),('8975','2013-09-19','12:30:00',3.75),('8975','2013-09-19','12:35:00',5.22),('8975','2013-09-19','12:40:00',5.71),('8975','2013-09-19','12:45:00',5.33),('8975','2013-09-19','12:50:00',4.07),('8975','2013-09-19','12:55:00',5.75),('8975','2013-09-19','13:00:00',5.65),('8975','2013-09-19','13:05:00',5.54),('8975','2013-09-19','13:10:00',5.44),('8975','2013-09-19','13:15:00',3.72),('8975','2013-09-19','13:20:00',4.8),('8975','2013-09-19','13:25:00',5.79),('8975','2013-09-19','13:30:00',5.33),('8975','2013-09-19','13:35:00',5.54),('8975','2013-09-19','13:40:00',5.3),('8975','2013-09-19','13:45:00',3.2),('8975','2013-09-19','13:55:00',2.54),('8975','2013-09-19','14:00:00',4.4),('8975','2013-09-19','14:05:00',5.15),('8975','2013-09-19','14:10:00',5.26),('8975','2013-09-19','14:15:00',4.19),('8975','2013-09-19','14:20:00',1.61),('8975','2013-09-19','14:25:00',1.43),('8975','2013-09-19','14:30:00',1.43),('8975','2013-09-19','14:35:00',1.35),('8975','2013-09-19','14:40:00',3.27),('8975','2013-09-19','14:45:00',4.54),('8975','2013-09-19','14:50:00',4.5),('8975','2013-09-19','14:55:00',3.53),('8975','2013-09-19','15:00:00',1.84),('8975','2013-09-19','15:05:00',3.66),('8975','2013-09-19','15:10:00',4.07),('8975','2013-09-19','15:15:00',3.11),('8975','2013-09-19','15:20:00',2.18),('8975','2013-09-19','15:25:00',1.34),('8975','2013-09-19','15:30:00',1.64),('8975','2013-09-19','15:35:00',2.82),('8975','2013-09-19','15:40:00',3.26),('8975','2013-09-19','15:45:00',3.25),('8975','2013-09-19','15:50:00',3.11),('8975','2013-09-19','15:55:00',3.21),('8975','2013-09-19','16:00:00',2.31),('8975','2013-09-19','16:05:00',1.91),('8975','2013-09-19','16:10:00',1.56),('8975','2013-09-19','16:15:00',1.51),('8975','2013-09-19','16:20:00',1.8),('8975','2013-09-19','16:25:00',1.62),('8975','2013-09-19','16:30:00',1.84),('8975','2013-09-19','16:35:00',2.15),('8975','2013-09-19','16:40:00',2.29),('8975','2013-09-19','16:45:00',2.58),('8975','2013-09-19','16:50:00',1.74),('8975','2013-09-19','16:55:00',1.64),('8975','2013-09-19','17:00:00',1.73),('8975','2013-09-19','17:05:00',2.1),('8975','2013-09-19','17:10:00',1.72),('8975','2013-09-19','17:15:00',2.08),('8975','2013-09-19','17:20:00',2.05),('8975','2013-09-19','17:25:00',1.29),('8975','2013-09-19','17:30:00',1.09),('8975','2013-09-19','17:35:00',1.04),('8975','2013-09-19','17:40:00',1.38),('8975','2013-09-19','17:45:00',1.34),('8975','2013-09-19','17:50:00',1.36),('8975','2013-09-19','17:55:00',1.24),('8975','2013-09-19','18:00:00',1.31),('8975','2013-09-19','18:05:00',1.4),('8975','2013-09-19','18:10:00',1.29),('8975','2013-09-19','18:15:00',1.29),('8975','2013-09-19','18:20:00',1.09),('8975','2013-09-18','07:35:00',1.17),('8975','2013-09-18','07:40:00',1.12),('8975','2013-09-18','07:45:00',1.24),('8975','2013-09-18','08:10:00',1.98),('8975','2013-09-18','08:15:00',1.06),('8975','2013-09-18','08:20:00',1.65),('8975','2013-09-18','08:25:00',2.35),('8975','2013-09-18','08:30:00',2.79),('8975','2013-09-18','08:35:00',2.77),('8975','2013-09-18','08:40:00',2.29),('8975','2013-09-18','08:45:00',2.06),('8975','2013-09-18','08:50:00',2.09),('8975','2013-09-18','08:55:00',2.94),('8975','2013-09-18','09:00:00',2.82),('8975','2013-09-18','09:05:00',2.93),('8975','2013-09-18','09:10:00',2.66),('8975','2013-09-18','09:15:00',2.57),('8975','2013-09-18','09:20:00',3.41),('8975','2013-09-18','09:25:00',1.75),('8975','2013-09-18','09:30:00',1.23),('8975','2013-09-18','09:35:00',1.04),('8975','2013-09-18','09:40:00',1.72),('8975','2013-09-18','09:45:00',1.4),('8975','2013-09-18','09:50:00',1.44),('8975','2013-09-18','09:55:00',2.13),('8975','2013-09-18','10:00:00',1.59),('8975','2013-09-18','10:05:00',2.43),('8975','2013-09-18','10:10:00',3.18),('8975','2013-09-18','10:15:00',1.48),('8975','2013-09-18','10:20:00',2.34),('8975','2013-09-18','10:25:00',1.58),('8975','2013-09-18','10:30:00',1.67),('8975','2013-09-18','10:35:00',2.83),('8975','2013-09-18','10:40:00',2.79),('8975','2013-09-18','10:45:00',6.5),('8975','2013-09-18','10:50:00',4.29),('8975','2013-09-18','10:55:00',4.39),('8975','2013-09-18','11:00:00',5.08),('8975','2013-09-18','11:05:00',5.08),('8975','2013-09-18','11:10:00',3.67),('8975','2013-09-18','11:15:00',4.1),('8975','2013-09-18','11:20:00',5.09),('8975','2013-09-18','11:25:00',2.21),('8975','2013-09-18','11:30:00',5.23),('8975','2013-09-18','11:35:00',5.61),('8975','2013-09-18','11:40:00',5.64),('8975','2013-09-18','11:45:00',4.46),('8975','2013-09-18','11:50:00',4.73),('8975','2013-09-18','11:55:00',3.21),('8975','2013-09-18','12:00:00',2.79),('8975','2013-09-18','12:05:00',2.88),('8975','2013-09-18','12:10:00',1.98),('8975','2013-09-18','12:15:00',5.66),('8975','2013-09-18','12:20:00',2.37),('8975','2013-09-18','12:25:00',5.39),('8975','2013-09-18','12:30:00',6.19),('8975','2013-09-18','12:35:00',5.88),('8975','2013-09-18','12:40:00',4.44),('8975','2013-09-18','12:45:00',1.7),('8975','2013-09-18','12:50:00',2.72),('8975','2013-09-18','12:55:00',3.06),('8975','2013-09-18','13:00:00',3.22),('8975','2013-09-18','13:05:00',5.16),('8975','2013-09-18','13:10:00',3.48),('8975','2013-09-18','13:15:00',4.08),('8975','2013-09-18','13:20:00',4.06),('8975','2013-09-18','13:25:00',5.84),('8975','2013-09-18','13:30:00',4.69),('8975','2013-09-18','13:35:00',3.35),('8975','2013-09-18','13:40:00',5.8),('8975','2013-09-18','13:45:00',2.28),('8975','2013-09-18','13:50:00',5.39),('8975','2013-09-18','13:55:00',6),('8975','2013-09-18','14:00:00',5.23),('8975','2013-09-18','14:05:00',4.81),('8975','2013-09-18','14:10:00',4.04),('8975','2013-09-18','14:15:00',4.86),('8975','2013-09-18','14:20:00',4.56),('8975','2013-09-18','14:25:00',4.14),('8975','2013-09-18','14:30:00',4.51),('8975','2013-09-18','14:35:00',4.26),('8975','2013-09-18','14:40:00',4.34),('8975','2013-09-18','14:45:00',3.72),('8975','2013-09-18','14:50:00',3.6),('8975','2013-09-18','14:55:00',1.44),('8975','2013-09-18','15:00:00',3.39),('8975','2013-09-18','15:05:00',3.62),('8975','2013-09-18','15:10:00',3.27),('8975','2013-09-18','15:15:00',4.15),('8975','2013-09-18','15:20:00',3.86),('8975','2013-09-18','15:25:00',2.69),('8975','2013-09-18','15:30:00',2.33),('8975','2013-09-18','15:35:00',2.44),('8975','2013-09-18','15:40:00',2.54),('8975','2013-09-18','15:45:00',3.32),('8975','2013-09-18','15:50:00',3.05),('8975','2013-09-18','15:55:00',2.9),('8975','2013-09-18','16:00:00',2.39),('8975','2013-09-18','16:05:00',2.7),('8975','2013-09-18','16:10:00',2.31),('8975','2013-09-18','16:15:00',2.29),('8975','2013-09-18','16:20:00',2.39),('8975','2013-09-18','16:25:00',2.29),('8975','2013-09-18','16:30:00',2.11),('8975','2013-09-18','16:35:00',1.74),('8975','2013-09-18','16:40:00',1.91),('8975','2013-09-18','16:45:00',1.84),('8975','2013-09-18','16:50:00',1.67),('8975','2013-09-18','16:55:00',1.7),('8975','2013-09-18','17:00:00',1.37),('8975','2013-09-18','17:05:00',1.01),('8975','2013-09-18','17:10:00',1.48),('8975','2013-09-18','17:15:00',1.41),('8975','2013-09-18','17:20:00',1.38),('8975','2013-09-18','17:25:00',1.31),('8975','2013-09-18','17:30:00',1.31),('8975','2013-09-18','17:35:00',1.29),('8975','2013-09-18','17:40:00',1.16),('8975','2013-09-18','17:45:00',1.01),('8975','2013-09-18','17:50:00',1.1),('8975','2013-09-18','17:55:00',1.03),('8975','2014-04-12','08:35:00',1.08),('8975','2014-04-12','08:40:00',1.07),('8975','2014-04-12','08:45:00',1.03),('8975','2014-04-12','09:00:00',1.45),('8975','2014-04-12','09:05:00',1.87),('8975','2014-04-12','09:10:00',2.74),('8975','2014-04-12','09:15:00',2.46),('8975','2014-04-12','09:20:00',2.08),('8975','2014-04-12','09:25:00',2.28),('8975','2014-04-12','09:30:00',2.31),('8975','2014-04-12','09:35:00',3),('8975','2014-04-12','09:40:00',3.62),('8975','2014-04-12','09:45:00',3.83),('8975','2014-04-12','09:50:00',2.56),('8975','2014-04-12','09:55:00',2.45),('8975','2014-04-12','10:00:00',2.89),('8975','2014-04-12','10:05:00',4),('8975','2014-04-12','10:10:00',5.11),('8975','2014-04-12','10:15:00',3.62),('8975','2014-04-12','10:20:00',3.84),('8975','2014-04-12','10:25:00',3.16),('8975','2014-04-12','10:30:00',3.83),('8975','2014-04-12','10:35:00',6.25),('8975','2014-04-12','10:40:00',4.93),('8975','2014-04-12','10:45:00',6.14),('8975','2014-04-12','10:50:00',6.17),('8975','2014-04-12','10:55:00',6),('8975','2014-04-12','11:00:00',6.09),('8975','2014-04-12','11:05:00',6.25),('8975','2014-04-12','11:10:00',6.04),('8975','2014-04-12','11:15:00',6.23),('8975','2014-04-12','11:20:00',7.23),('8975','2014-04-12','11:25:00',6.68),('8975','2014-04-12','11:30:00',5.31),('8975','2014-04-12','11:35:00',4.67),('8975','2014-04-12','11:40:00',6.2),('8975','2014-04-12','11:45:00',5.95),('8975','2014-04-12','11:50:00',4.61),('8975','2014-04-12','11:55:00',3.54),('8975','2014-04-12','12:00:00',2.99),('8975','2014-04-12','12:05:00',2.82),('8975','2014-04-12','12:10:00',2.4),('8975','2014-04-12','12:15:00',2.45),('8975','2014-04-12','12:20:00',2.6),('8975','2014-04-12','12:25:00',1.97),('8975','2014-04-12','12:30:00',1.38),('8975','2014-04-12','12:50:00',1.09),('8975','2014-04-12','12:55:00',1.28),('8975','2014-04-12','13:00:00',1.41),('8975','2014-04-12','13:05:00',1.7),('8975','2014-04-12','13:10:00',2.69),('8975','2014-04-12','13:15:00',3.27),('8975','2014-04-12','13:20:00',3.32),('8975','2014-04-12','13:25:00',4.73),('8975','2014-04-12','13:30:00',6.74),('8975','2014-04-12','13:35:00',5.96),('8975','2014-04-12','13:40:00',6.56),('8975','2014-04-12','13:45:00',3.85),('8975','2014-04-12','13:50:00',4.48),('8975','2014-04-12','13:55:00',4.21),('8975','2014-04-12','14:00:00',5.25),('8975','2014-04-12','14:05:00',5.83),('8975','2014-04-12','14:10:00',6.17),('8975','2014-04-12','14:15:00',4.67),('8975','2014-04-12','14:20:00',3.62),('8975','2014-04-12','14:25:00',2.71),('8975','2014-04-12','14:30:00',3.49),('8975','2014-04-12','14:35:00',2.5),('8975','2014-04-12','14:40:00',1.92),('8975','2014-04-12','14:45:00',2.54),('8975','2014-04-12','14:50:00',4.97),('8975','2014-04-12','14:55:00',4.56),('8975','2014-04-12','15:00:00',2.49),('8975','2014-04-12','15:05:00',5.09),('8975','2014-04-12','15:10:00',5.18),('8975','2014-04-12','15:15:00',4.44),('8975','2014-04-12','15:20:00',4.04),('8975','2014-04-12','15:25:00',4.19),('8975','2014-04-12','15:30:00',4.16),('8975','2014-04-12','15:35:00',3),('8975','2014-04-12','15:40:00',2.36),('8975','2014-04-12','15:45:00',2.16),('8975','2014-04-12','15:50:00',2.41),('8975','2014-04-12','15:55:00',2.74),('8975','2014-04-12','16:00:00',3.78),('8975','2014-04-12','16:05:00',3.24),('8975','2014-04-12','16:10:00',1.86),('8975','2014-04-12','16:15:00',1.31),('8975','2014-04-12','16:20:00',1.61),('8975','2014-04-12','16:25:00',2.44),('8975','2014-04-12','16:30:00',2.56),('8975','2014-04-12','16:35:00',2.17),('8975','2014-04-12','16:40:00',2.15),('8975','2014-04-12','16:45:00',3.69),('8975','2014-04-12','16:50:00',3.57),('8975','2014-04-12','16:55:00',3.25),('8975','2014-04-12','17:00:00',3.22),('8975','2014-04-12','17:05:00',2.46),('8975','2014-04-12','17:10:00',1.61),('8975','2014-04-12','17:15:00',1.33),('8975','2014-04-12','17:20:00',1.73),('8975','2014-04-12','17:25:00',1.82),('8975','2014-04-12','17:30:00',1.52),('8975','2014-04-12','17:35:00',1.31),('8975','2014-04-12','17:40:00',1.06),('8975','2014-04-12','17:45:00',1.08),('8975','2014-04-12','17:50:00',1.16),('8975','2014-04-12','17:55:00',1.12),('8975','2014-04-12','18:00:00',1.44),('8975','2014-04-12','18:05:00',1.47),('8975','2014-04-12','18:10:00',1.13),('8975','2013-09-17','07:35:00',1.04),('8975','2013-09-17','07:40:00',1.2),('8975','2013-09-17','07:45:00',1.44),('8975','2013-09-17','07:50:00',1.66),('8975','2013-09-17','07:55:00',1.84),('8975','2013-09-17','08:00:00',2.04),('8975','2013-09-17','08:05:00',2.2),('8975','2013-09-17','08:10:00',1.68),('8975','2013-09-17','08:15:00',1.19),('8975','2013-09-17','08:20:00',1.3),('8975','2013-09-17','08:25:00',2.08),('8975','2013-09-17','08:30:00',2.48),('8975','2013-09-17','08:35:00',2.38),('8975','2013-09-17','08:40:00',1.9),('8975','2013-09-17','08:45:00',2.75),('8975','2013-09-17','08:50:00',2.82),('8975','2013-09-17','08:55:00',2.75),('8975','2013-09-17','09:00:00',2.07),('8975','2013-09-17','09:05:00',2.62),('8975','2013-09-17','09:10:00',3.3),('8975','2013-09-17','09:15:00',1.1),('8975','2013-09-17','09:20:00',1.23),('8975','2013-09-17','09:25:00',2.29),('8975','2013-09-17','09:30:00',4.79),('8975','2013-09-17','09:35:00',2.97),('8975','2013-09-17','09:40:00',4.94),('8975','2013-09-17','09:45:00',3.78),('8975','2013-09-17','09:50:00',5.02),('8975','2013-09-17','09:55:00',4.46),('8975','2013-09-17','10:00:00',4.57),('8975','2013-09-17','10:05:00',4.73),('8975','2013-09-17','10:10:00',4.75),('8975','2013-09-17','10:15:00',4.79),('8975','2013-09-17','10:20:00',4.89),('8975','2013-09-17','10:25:00',4.9),('8975','2013-09-17','10:30:00',4.97),('8975','2013-09-17','10:35:00',5),('8975','2013-09-17','10:40:00',5.03),('8975','2013-09-17','10:45:00',5.05),('8975','2013-09-17','10:50:00',5.29),('8975','2013-09-17','10:55:00',5.31),('8975','2013-09-17','11:00:00',5.28),('8975','2013-09-17','11:05:00',4.15),('8975','2013-09-17','11:10:00',1.09),('8975','2013-09-17','11:15:00',1.14),('8975','2013-09-17','11:20:00',4.44),('8975','2013-09-17','11:25:00',6.25),('8975','2013-09-17','11:30:00',5.33),('8975','2013-09-17','11:35:00',2.83),('8975','2013-09-17','11:40:00',2.04),('8975','2013-09-17','11:45:00',6.06),('8975','2013-09-17','11:50:00',5.96),('8975','2013-09-17','11:55:00',5.88),('8975','2013-09-17','12:00:00',5.7),('8975','2013-09-17','12:05:00',5.98),('8975','2013-09-17','12:10:00',5.18),('8975','2013-09-17','12:15:00',2.53),('8975','2013-09-17','12:20:00',5.62),('8975','2013-09-17','12:25:00',5.9),('8975','2013-09-17','12:30:00',6.06),('8975','2013-09-17','12:35:00',4),('8975','2013-09-17','12:40:00',3.07),('8975','2013-09-17','12:45:00',1.51),('8975','2013-09-17','12:50:00',3.7),('8975','2013-09-17','12:55:00',1.84),('8975','2013-09-17','13:00:00',2.04),('8975','2013-09-17','13:05:00',4.3),('8975','2013-09-17','13:10:00',5.99),('8975','2013-09-17','13:15:00',4.12),('8975','2013-09-17','13:20:00',5.75),('8975','2013-09-17','13:25:00',1.66),('8975','2013-09-17','13:30:00',2.73),('8975','2013-09-17','13:35:00',2.3),('8975','2013-09-17','13:40:00',2.8),('8975','2013-09-17','13:45:00',4.37),('8975','2013-09-17','13:50:00',3.69),('8975','2013-09-17','13:55:00',4.79),('8975','2013-09-17','14:00:00',5.59),('8975','2013-09-17','14:05:00',5.5),('8975','2013-09-17','14:10:00',3.41),('8975','2013-09-17','14:15:00',4.61),('8975','2013-09-17','14:20:00',4.99),('8975','2013-09-17','14:25:00',4.7),('8975','2013-09-17','14:30:00',4.69),('8975','2013-09-17','14:35:00',4.65),('8975','2013-09-17','14:40:00',4.41),('8975','2013-09-17','14:45:00',4.56),('8975','2013-09-17','14:50:00',3.91),('8975','2013-09-17','14:55:00',4.27),('8975','2013-09-17','15:00:00',3.06),('8975','2013-09-17','15:05:00',3.16),('8975','2013-09-17','15:10:00',3.4),('8975','2013-09-17','15:15:00',3.96),('8975','2013-09-17','15:20:00',1.64),('8975','2013-09-17','15:25:00',2.95),('8975','2013-09-17','15:30:00',3.65),('8975','2013-09-17','15:35:00',3.28),('8975','2013-09-17','15:40:00',3.12),('8975','2013-09-17','15:45:00',3),('8975','2013-09-17','15:50:00',3.1),('8975','2013-09-17','15:55:00',2.91),('8975','2013-09-17','16:00:00',3),('8975','2013-09-17','16:05:00',2.85),('8975','2013-09-17','16:10:00',2.62),('8975','2013-09-17','16:15:00',2.51),('8975','2013-09-17','16:20:00',2.34),('8975','2013-09-17','16:25:00',2.1),('8975','2013-09-17','16:30:00',2.07),('8975','2013-09-17','16:35:00',1.77),('8975','2013-09-17','16:40:00',1.79),('8975','2013-09-17','16:45:00',1.85),('8975','2013-09-17','16:50:00',1.72),('8975','2013-09-17','16:55:00',1.57),('8975','2013-09-17','17:00:00',1.56),('8975','2013-09-17','17:05:00',1.57),('8975','2013-09-17','17:10:00',1.54),('8975','2013-09-17','17:15:00',1.54),('8975','2013-09-17','17:20:00',1.48),('8975','2013-09-17','17:25:00',1.44),('8975','2013-09-17','17:30:00',1.37),('8975','2013-09-17','17:35:00',1.29),('8975','2013-09-17','17:40:00',1.23),('8975','2013-09-17','17:45:00',1.18),('8975','2013-09-17','17:50:00',1.12),('8975','2013-09-17','17:55:00',1.03),('8975','2013-09-16','08:40:00',1.08),('8975','2013-09-16','08:45:00',1.12),('8975','2013-09-16','08:50:00',1.11),('8975','2013-09-16','08:55:00',1.17),('8975','2013-09-16','09:00:00',1.01),('8975','2013-09-16','09:10:00',1),('8975','2013-09-16','09:15:00',1.7),('8975','2013-09-16','09:20:00',3.07),('8975','2013-09-16','09:25:00',1.85),('8975','2013-09-16','09:30:00',2.14),('8975','2013-09-16','09:35:00',1.52),('8975','2013-09-16','09:40:00',1.62),('8975','2013-09-16','09:45:00',2.6),('8975','2013-09-16','09:50:00',1.36),('8975','2013-09-16','09:55:00',3.13),('8975','2013-09-16','10:00:00',4.31),('8975','2013-09-16','10:05:00',2.21),('8975','2013-09-16','10:10:00',3.08),('8975','2013-09-16','10:15:00',1.59),('8975','2013-09-16','10:20:00',4.35),('8975','2013-09-16','10:25:00',4.67),('8975','2013-09-16','10:30:00',3.43),('8975','2013-09-16','10:35:00',2.05),('8975','2013-09-16','10:40:00',1.62),('8975','2013-09-16','10:45:00',2.86),('8975','2013-09-16','10:50:00',5.47),('8975','2013-09-16','10:55:00',4.71),('8975','2013-09-16','11:00:00',4.41),('8975','2013-09-16','11:05:00',3.62),('8975','2013-09-16','11:10:00',5.79),('8975','2013-09-16','11:15:00',3.93),('8975','2013-09-16','11:20:00',4.08),('8975','2013-09-16','11:25:00',2.6),('8975','2013-09-16','11:30:00',3.23),('8975','2013-09-16','11:35:00',4.52),('8975','2013-09-16','11:40:00',3.99),('8975','2013-09-16','11:45:00',3.14),('8975','2013-09-16','11:50:00',5.18),('8975','2013-09-16','11:55:00',3.83),('8975','2013-09-16','12:00:00',4.06),('8975','2013-09-16','12:05:00',5.9),('8975','2013-09-16','12:10:00',3.12),('8975','2013-09-16','12:15:00',2.99),('8975','2013-09-16','12:20:00',3.25),('8975','2013-09-16','12:25:00',6.04),('8975','2013-09-16','12:30:00',6.3),('8975','2013-09-16','12:35:00',4.91),('8975','2013-09-16','12:40:00',5.27),('8975','2013-09-16','12:45:00',6.02),('8975','2013-09-16','12:50:00',5.37),('8975','2013-09-16','12:55:00',4.13),('8975','2013-09-16','13:00:00',2.16),('8975','2013-09-16','13:05:00',1.8),('8975','2013-09-16','13:10:00',4.62),('8975','2013-09-16','13:15:00',3.84),('8975','2013-09-16','13:20:00',3.27),('8975','2013-09-16','13:25:00',2.9),('8975','2013-09-16','13:30:00',2.45),('8975','2013-09-16','13:35:00',4),('8975','2013-09-16','13:40:00',3.17),('8975','2013-09-16','13:45:00',2.42),('8975','2013-09-16','13:50:00',2.29),('8975','2013-09-16','13:55:00',3.56),('8975','2013-09-16','14:00:00',3.16),('8975','2013-09-16','14:05:00',2.27),('8975','2013-09-16','14:10:00',1.43),('8975','2013-09-16','14:15:00',1.75),('8975','2013-09-16','14:20:00',1.67),('8975','2013-09-16','14:25:00',3.01),('8975','2013-09-16','14:30:00',1.78),('8975','2013-09-16','14:35:00',1.63),('8975','2013-09-16','14:40:00',1.21),('8975','2013-09-16','14:45:00',1.5),('8975','2013-09-16','14:50:00',3.2),('8975','2013-09-16','14:55:00',5.02),('8975','2013-09-16','15:00:00',3.83),('8975','2013-09-16','15:05:00',3.73),('8975','2013-09-16','15:10:00',3.07),('8975','2013-09-16','15:15:00',2.1),('8975','2013-09-16','15:20:00',3.48),('8975','2013-09-16','15:25:00',2.72),('8975','2013-09-16','15:30:00',2.21),('8975','2013-09-16','15:35:00',2.57),('8975','2013-09-16','15:40:00',1.44),('8975','2013-09-16','15:45:00',1.5),('8975','2013-09-16','15:50:00',2),('8975','2013-09-16','15:55:00',2.06),('8975','2013-09-16','16:00:00',1.66),('8975','2013-09-16','16:05:00',2.37),('8975','2013-09-16','16:10:00',2.21),('8975','2013-09-16','16:15:00',2.64),('8975','2013-09-16','16:20:00',1.33),('8975','2013-09-16','16:35:00',1.11),('8975','2013-09-16','16:40:00',1.8),('8975','2013-09-16','16:45:00',1.87),('8975','2013-09-16','16:50:00',1.71),('8975','2013-09-16','16:55:00',1.46),('8975','2013-09-16','17:00:00',1.93),('8975','2013-09-16','17:05:00',2.1),('8975','2013-09-16','17:10:00',1.97),('8975','2013-09-16','17:15:00',1.89),('8975','2013-09-16','17:20:00',1.89),('8975','2013-09-16','17:25:00',1.95),('8975','2013-09-16','17:30:00',1.89),('8975','2013-09-16','17:35:00',1.85),('8975','2013-09-16','17:40:00',1.33),('8975','2013-09-16','17:55:00',1.18),('8975','2013-09-15','08:05:00',2.02),('8975','2013-09-15','08:10:00',2.78),('8975','2013-09-15','08:15:00',2.8),('8975','2013-09-15','08:20:00',2.78),('8975','2013-09-15','08:25:00',2.92),('8975','2013-09-15','08:30:00',3.08),('8975','2013-09-15','08:35:00',3.28),('8975','2013-09-15','08:40:00',3.58),('8975','2013-09-15','08:45:00',2.66),('8975','2013-09-15','08:50:00',3.59),('8975','2013-09-15','08:55:00',3.68),('8975','2013-09-15','09:00:00',3.56),('8975','2013-09-15','09:05:00',2.58),('8975','2013-09-15','09:10:00',3.93),('8975','2013-09-15','09:15:00',3.84),('8975','2013-09-15','09:20:00',3.95),('8975','2013-09-15','09:25:00',3.84),('8975','2013-09-15','09:30:00',4.27),('8975','2013-09-15','09:35:00',3.01),('8975','2013-09-15','09:40:00',4.22),('8975','2013-09-15','09:45:00',2.97),('8975','2013-09-15','09:50:00',4.34),('8975','2013-09-15','09:55:00',4.68),('8975','2013-09-15','10:00:00',4.71),('8975','2013-09-15','10:05:00',4.02),('8975','2013-09-15','10:10:00',5.09),('8975','2013-09-15','10:15:00',1.64),('8975','2013-09-15','10:30:00',2.79),('8975','2013-09-15','10:35:00',5.79),('8975','2013-09-15','10:40:00',4.29),('8975','2013-09-15','10:45:00',2.73),('8975','2013-09-15','10:50:00',6.66),('8975','2013-09-15','10:55:00',6.1),('8975','2013-09-15','11:00:00',4.89),('8975','2013-09-15','11:05:00',6.78),('8975','2013-09-15','11:10:00',6.53),('8975','2013-09-15','11:15:00',2.82),('8975','2013-09-15','11:20:00',2.16),('8975','2013-09-15','11:25:00',1.03),('8975','2013-09-15','11:35:00',4.89),('8975','2013-09-15','11:40:00',6.13),('8975','2013-09-15','11:45:00',4.16),('8975','2013-09-15','11:50:00',6.18),('8975','2013-09-15','11:55:00',3.51),('8975','2013-09-15','12:00:00',2.02),('8975','2013-09-15','12:05:00',5.69),('8975','2013-09-15','12:10:00',6.55),('8975','2013-09-15','12:15:00',6.32),('8975','2013-09-15','12:20:00',6.05),('8975','2013-09-15','12:25:00',6.04),('8975','2013-09-15','12:30:00',5.9),('8975','2013-09-15','12:35:00',5.97),('8975','2013-09-15','12:40:00',6.11),('8975','2013-09-15','12:45:00',4.01),('8975','2013-09-15','12:50:00',1.48),('8975','2013-09-15','12:55:00',2.85),('8975','2013-09-15','13:00:00',1.85),('8975','2013-09-15','13:05:00',4.69),('8975','2013-09-15','13:10:00',5.84),('8975','2013-09-15','13:15:00',5.95),('8975','2013-09-15','13:20:00',5.66),('8975','2013-09-15','13:25:00',5.58),('8975','2013-09-15','13:30:00',5.54),('8975','2013-09-15','13:35:00',5.48),('8975','2013-09-15','13:40:00',5.47),('8975','2013-09-15','13:45:00',5.26),('8975','2013-09-15','13:50:00',5.43),('8975','2013-09-15','13:55:00',3.35),('8975','2013-09-15','14:00:00',5.37),('8975','2013-09-15','14:05:00',5.2),('8975','2013-09-15','14:10:00',5.04),('8975','2013-09-15','14:15:00',4.86),('8975','2013-09-15','14:20:00',4.86),('8975','2013-09-15','14:25:00',4.78),('8975','2013-09-15','14:30:00',4.7),('8975','2013-09-15','14:35:00',4.6),('8975','2013-09-15','14:40:00',4.48),('8975','2013-09-15','14:45:00',4.36),('8975','2013-09-15','14:50:00',3.91),('8975','2013-09-15','14:55:00',3.35),('8975','2013-09-15','15:00:00',4.16),('8975','2013-09-15','15:05:00',3.97),('8975','2013-09-15','15:10:00',3.87),('8975','2013-09-15','15:15:00',3.86),('8975','2013-09-15','15:20:00',3.74),('8975','2013-09-15','15:25:00',3.61),('8975','2013-09-15','15:30:00',3.46),('8975','2013-09-15','15:35:00',3.3),('8975','2013-09-15','15:40:00',3.07),('8975','2013-09-15','15:45:00',3.09),('8975','2013-09-15','15:50:00',3.03),('8975','2013-09-15','15:55:00',2.95),('8975','2013-09-15','16:00:00',2.93),('8975','2013-09-15','16:05:00',2.43),('8975','2013-09-15','16:10:00',2.67),('8975','2013-09-15','16:15:00',2.52),('8975','2013-09-15','16:20:00',2.42),('8975','2013-09-15','16:25:00',2.31),('8975','2013-09-15','16:30:00',2.2),('8975','2013-09-15','16:35:00',2.08),('8975','2013-09-15','16:40:00',2),('8975','2013-09-15','16:45:00',1.9),('8975','2013-09-15','16:50:00',1.81),('8975','2013-09-15','16:55:00',1.74),('8975','2013-09-15','17:00:00',1.66),('8975','2013-09-15','17:05:00',1.6),('8975','2013-09-15','17:10:00',1.53),('8975','2013-09-15','17:15:00',1.48),('8975','2013-09-15','17:20:00',1.4),('8975','2013-09-15','17:30:00',1.46),('8975','2013-09-15','17:35:00',1.38),('8975','2013-09-15','17:40:00',1.35),('8975','2013-09-15','17:45:00',1.27),('8975','2013-09-15','17:50:00',1.12),('8975','2013-09-15','17:55:00',1.12),('8975','2013-09-15','18:00:00',1.06),('8975','2013-09-15','18:05:00',1.01),('8975','2013-09-14','07:25:00',1.16),('8975','2013-09-14','07:35:00',1.68),('8975','2013-09-14','07:40:00',1.72),('8975','2013-09-14','07:45:00',1.84),('8975','2013-09-14','07:50:00',2.03),('8975','2013-09-14','07:55:00',2.26),('8975','2013-09-14','08:00:00',2.42),('8975','2013-09-14','08:05:00',2.56),('8975','2013-09-14','08:10:00',2.7),('8975','2013-09-14','08:15:00',2.85),('8975','2013-09-14','08:20:00',2.96),('8975','2013-09-14','08:25:00',3.08),('8975','2013-09-14','08:30:00',3.18),('8975','2013-09-14','08:35:00',3.31),('8975','2013-09-14','08:40:00',3.44),('8975','2013-09-14','08:45:00',3.55),('8975','2013-09-14','08:50:00',3.5),('8975','2013-09-14','08:55:00',3.25),('8975','2013-09-14','09:00:00',3.48),('8975','2013-09-14','09:05:00',3.49),('8975','2013-09-14','09:10:00',3.8),('8975','2013-09-14','09:15:00',4.07),('8975','2013-09-14','09:20:00',3.96),('8975','2013-09-14','09:25:00',4.16),('8975','2013-09-14','09:30:00',4.08),('8975','2013-09-14','09:35:00',4.36),('8975','2013-09-14','09:40:00',4.45),('8975','2013-09-14','09:45:00',4.45),('8975','2013-09-14','09:50:00',4.39),('8975','2013-09-14','09:55:00',4.7),('8975','2013-09-14','10:00:00',4.74),('8975','2013-09-14','10:05:00',4.81),('8975','2013-09-14','10:10:00',4.84),('8975','2013-09-14','10:15:00',4.89),('8975','2013-09-14','10:20:00',4.89),('8975','2013-09-14','10:25:00',5.06),('8975','2013-09-14','10:30:00',4.99),('8975','2013-09-14','10:35:00',2.13),('8975','2013-09-14','10:40:00',1.61),('8975','2013-09-14','10:45:00',1.53),('8975','2013-09-14','10:50:00',1.02),('8975','2013-09-14','10:55:00',3.9),('8975','2013-09-14','11:00:00',2.62),('8975','2013-09-14','11:05:00',2.11),('8975','2013-09-14','11:10:00',4.16),('8975','2013-09-14','11:15:00',1.74),('8975','2013-09-14','11:20:00',1.38),('8975','2013-09-14','11:25:00',1.36),('8975','2013-09-14','11:30:00',4.08),('8975','2013-09-14','11:35:00',2.31),('8975','2013-09-14','11:40:00',2.04),('8975','2013-09-14','11:45:00',3.46),('8975','2013-09-14','11:50:00',3.87),('8975','2013-09-14','11:55:00',2.99),('8975','2013-09-14','12:00:00',2.34),('8975','2013-09-14','12:05:00',2.02),('8975','2013-09-14','12:10:00',2.09),('8975','2013-09-14','12:15:00',2.35),('8975','2013-09-14','12:20:00',2.61),('8975','2013-09-14','12:25:00',2.69),('8975','2013-09-14','12:30:00',2.85),('8975','2013-09-14','12:35:00',3.44),('8975','2013-09-14','12:40:00',2.99),('8975','2013-09-14','12:45:00',2.83),('8975','2013-09-14','12:50:00',2.02),('8975','2013-09-14','12:55:00',1.9),('8975','2013-09-14','13:00:00',1.76),('8975','2013-09-14','13:05:00',1.37),('8975','2013-09-14','13:10:00',1.01),('8975','2013-09-14','13:20:00',1.35),('8975','2013-09-14','13:25:00',2.36),('8975','2013-09-14','13:30:00',2.01),('8975','2013-09-14','13:35:00',2.02),('8975','2013-09-14','13:40:00',2.01),('8975','2013-09-14','13:45:00',2.84),('8975','2013-09-14','13:50:00',3.18),('8975','2013-09-14','13:55:00',2.28),('8975','2013-09-14','14:00:00',3.04),('8975','2013-09-14','14:05:00',2.62),('8975','2013-09-14','14:10:00',2.17),('8975','2013-09-14','14:15:00',2.41),('8975','2013-09-14','14:20:00',2.32),('8975','2013-09-14','14:25:00',2.17),('8975','2013-09-14','14:30:00',1.99),('8975','2013-09-14','14:35:00',1.63),('8975','2013-09-14','14:40:00',1.53),('8975','2013-09-14','14:45:00',1.62),('8975','2013-09-14','14:50:00',1.67),('8975','2013-09-14','14:55:00',1.69),('8975','2013-09-14','15:00:00',1.73),('8975','2013-09-14','15:05:00',1.85),('8975','2013-09-14','15:10:00',2.07),('8975','2013-09-14','15:15:00',3.76),('8975','2013-09-14','15:20:00',3.16),('8975','2013-09-14','15:25:00',2.41),('8975','2013-09-14','15:30:00',1.87),('8975','2013-09-14','15:35:00',1.79),('8975','2013-09-14','15:40:00',1.62),('8975','2013-09-14','15:45:00',1.59),('8975','2013-09-14','15:50:00',1.59),('8975','2013-09-14','15:55:00',1.6),('8975','2013-09-14','16:00:00',1.43),('8975','2013-09-14','16:05:00',1.57),('8975','2013-09-14','16:10:00',1.21),('8975','2013-09-14','16:35:00',1.06),('8975','2013-09-14','16:40:00',1.26),('8975','2013-09-14','17:15:00',1.09),('8975','2013-09-14','17:20:00',1.29),('8975','2013-09-14','18:00:00',1.14),('8975','2013-09-13','07:25:00',1.08),('8975','2013-09-13','07:30:00',1.19),('8975','2013-09-13','07:35:00',1.41),('8975','2013-09-13','07:40:00',1.58),('8975','2013-09-13','07:45:00',1.66),('8975','2013-09-13','07:50:00',1.84),('8975','2013-09-13','07:55:00',2.1),('8975','2013-09-13','08:00:00',2.31),('8975','2013-09-13','08:05:00',2.42),('8975','2013-09-13','08:10:00',2.57),('8975','2013-09-13','08:15:00',2.71),('8975','2013-09-13','08:20:00',2.82),('8975','2013-09-13','08:25:00',2.94),('8975','2013-09-13','08:30:00',3.06),('8975','2013-09-13','08:35:00',3.16),('8975','2013-09-13','08:40:00',3.27),('8975','2013-09-13','08:45:00',3.36),('8975','2013-09-13','08:50:00',3.46),('8975','2013-09-13','08:55:00',3.55),('8975','2013-09-13','09:00:00',3.66),('8975','2013-09-13','09:05:00',3.75),('8975','2013-09-13','09:10:00',3.83),('8975','2013-09-13','09:15:00',3.93),('8975','2013-09-13','09:20:00',4.03),('8975','2013-09-13','09:25:00',4.13),('8975','2013-09-13','09:30:00',4.16),('8975','2013-09-13','09:35:00',4.27),('8975','2013-09-13','09:40:00',4.32),('8975','2013-09-13','09:45:00',4.36),('8975','2013-09-13','09:50:00',4.49),('8975','2013-09-13','09:55:00',4.49),('8975','2013-09-13','10:00:00',4.57),('8975','2013-09-13','10:05:00',4.55),('8975','2013-09-13','10:10:00',4.02),('8975','2013-09-13','10:15:00',4.57),('8975','2013-09-13','10:20:00',4.35),('8975','2013-09-13','10:25:00',4.88),('8975','2013-09-13','10:30:00',4.85),('8975','2013-09-13','10:35:00',5.32),('8975','2013-09-13','10:40:00',4.42),('8975','2013-09-13','10:45:00',3.9),('8975','2013-09-13','10:50:00',6.32),('8975','2013-09-13','10:55:00',6.31),('8975','2013-09-13','11:00:00',5.97),('8975','2013-09-13','11:05:00',6.02),('8975','2013-09-13','11:10:00',3),('8975','2013-09-13','11:20:00',1.03),('8975','2013-09-13','11:35:00',1.52),('8975','2013-09-13','11:40:00',2.07),('8975','2013-09-13','11:45:00',1.59),('8975','2013-09-13','11:50:00',2.79),('8975','2013-09-13','11:55:00',7.07),('8975','2013-09-13','12:00:00',6.97),('8975','2013-09-13','12:05:00',6.36),('8975','2013-09-13','12:10:00',5.86),('8975','2013-09-13','12:15:00',3.16),('8975','2013-09-13','12:20:00',4.1),('8975','2013-09-13','12:25:00',1.03),('8975','2013-09-13','12:30:00',1.98),('8975','2013-09-13','12:35:00',4.56),('8975','2013-09-13','12:40:00',1.75),('8975','2013-09-13','12:45:00',3.61),('8975','2013-09-13','12:50:00',1.33),('8975','2013-09-13','12:55:00',1.33),('8975','2013-09-13','13:00:00',1.16),('8975','2013-09-13','13:05:00',1.21),('8975','2013-09-13','13:10:00',1.72),('8975','2013-09-13','13:15:00',2.27),('8975','2013-09-13','13:20:00',5.33),('8975','2013-09-13','13:25:00',3.21),('8975','2013-09-13','13:30:00',2.41),('8975','2013-09-13','13:35:00',4.06),('8975','2013-09-13','13:40:00',4.11),('8975','2013-09-13','13:45:00',3.89),('8975','2013-09-13','13:50:00',6.94),('8975','2013-09-13','13:55:00',6.21),('8975','2013-09-13','14:00:00',5.68),('8975','2013-09-13','14:05:00',5),('8975','2013-09-13','14:10:00',5.27),('8975','2013-09-13','14:15:00',5.08),('8975','2013-09-13','14:20:00',5.12),('8975','2013-09-13','14:25:00',4.12),('8975','2013-09-13','14:30:00',1.38),('8975','2013-09-13','14:35:00',4.15),('8975','2013-09-13','14:40:00',4.86),('8975','2013-09-13','14:45:00',4.69),('8975','2013-09-13','14:50:00',4.57),('8975','2013-09-13','14:55:00',4.4),('8975','2013-09-13','15:00:00',4.16),('8975','2013-09-13','15:05:00',4),('8975','2013-09-13','15:10:00',3.93),('8975','2013-09-13','15:15:00',3.84),('8975','2013-09-13','15:20:00',3.76),('8975','2013-09-13','15:25:00',3.92),('8975','2013-09-13','15:30:00',3.7),('8975','2013-09-13','15:35:00',3.44),('8975','2013-09-13','15:40:00',3.27),('8975','2013-09-13','15:45:00',3.26),('8975','2013-09-13','15:50:00',3.13),('8975','2013-09-13','15:55:00',3.03),('8975','2013-09-13','16:00:00',2.91),('8975','2013-09-13','16:05:00',2.81),('8975','2013-09-13','16:10:00',2.67),('8975','2013-09-13','16:15:00',2.58),('8975','2013-09-13','16:20:00',2.25),('8975','2013-09-13','16:25:00',2.27),('8975','2013-09-13','16:30:00',2.29),('8975','2013-09-13','16:35:00',2.14),('8975','2013-09-13','16:40:00',2.05),('8975','2013-09-13','16:45:00',1.99),('8975','2013-09-13','16:50:00',1.66),('8975','2013-09-13','16:55:00',1.86),('8975','2013-09-13','17:00:00',1.73),('8975','2013-09-13','17:05:00',1.33),('8975','2013-09-13','17:10:00',1.5),('8975','2013-09-13','17:15:00',1.43),('8975','2013-09-13','17:20:00',1.34),('8975','2013-09-13','17:25:00',1.14),('8975','2013-09-13','17:30:00',1.39),('8975','2013-09-13','17:35:00',1.29),('8975','2013-09-13','17:40:00',1.29),('8975','2013-09-13','17:50:00',1.15),('8975','2013-09-13','17:55:00',1.1),('8975','2013-09-13','18:00:00',1.07),('8975','2013-09-12','08:15:00',1.23),('8975','2013-09-12','08:20:00',1.28),('8975','2013-09-12','08:25:00',1.62),('8975','2013-09-12','08:30:00',1.58),('8975','2013-09-12','08:35:00',1.29),('8975','2013-09-12','08:40:00',1.32),('8975','2013-09-12','08:45:00',1.5),('8975','2013-09-12','08:50:00',1.59),('8975','2013-09-12','08:55:00',1.72),('8975','2013-09-12','09:00:00',1.86),('8975','2013-09-12','09:05:00',1.89),('8975','2013-09-12','09:10:00',1.85),('8975','2013-09-12','09:15:00',1.96),('8975','2013-09-12','09:20:00',1.87),('8975','2013-09-12','09:25:00',2.1),('8975','2013-09-12','09:30:00',2.19),('8975','2013-09-12','09:35:00',2.29),('8975','2013-09-12','09:40:00',2.86),('8975','2013-09-12','09:45:00',3.4),('8975','2013-09-12','09:50:00',3.45),('8975','2013-09-12','09:55:00',4.67),('8975','2013-09-12','10:00:00',4.39),('8975','2013-09-12','10:05:00',3.81),('8975','2013-09-12','10:10:00',5.8),('8975','2013-09-12','10:15:00',6.05),('8975','2013-09-12','10:20:00',5.76),('8975','2013-09-12','10:25:00',4.87),('8975','2013-09-12','10:30:00',5.05),('8975','2013-09-12','10:35:00',5.07),('8975','2013-09-12','10:40:00',5.29),('8975','2013-09-12','10:45:00',5.28),('8975','2013-09-12','10:50:00',5.4),('8975','2013-09-12','10:55:00',5.4),('8975','2013-09-12','11:00:00',5.48),('8975','2013-09-12','11:05:00',5.52),('8975','2013-09-12','11:10:00',5.57),('8975','2013-09-12','11:15:00',5.57),('8975','2013-09-12','11:20:00',5.62),('8975','2013-09-12','11:25:00',5.71),('8975','2013-09-12','11:30:00',5.73),('8975','2013-09-12','11:35:00',5.79),('8975','2013-09-12','11:40:00',5.71),('8975','2013-09-12','11:45:00',5.76),('8975','2013-09-12','11:50:00',5.88),('8975','2013-09-12','11:55:00',5.81),('8975','2013-09-12','12:00:00',5.82),('8975','2013-09-12','12:05:00',5.86),('8975','2013-09-12','12:10:00',5.87),('8975','2013-09-12','12:15:00',5.91),('8975','2013-09-12','12:20:00',5.97),('8975','2013-09-12','12:25:00',6),('8975','2013-09-12','12:30:00',6.03),('8975','2013-09-12','12:35:00',6.09),('8975','2013-09-12','12:40:00',3.43),('8975','2013-09-12','12:45:00',5.34),('8975','2013-09-12','12:50:00',6.01),('8975','2013-09-12','12:55:00',5.88),('8975','2013-09-12','13:00:00',5.85),('8975','2013-09-12','13:05:00',5.75),('8975','2013-09-12','13:10:00',5.69),('8975','2013-09-12','13:15:00',5.67),('8975','2013-09-12','13:20:00',5.33),('8975','2013-09-12','13:25:00',5.56),('8975','2013-09-12','13:30:00',5.54),('8975','2013-09-12','13:35:00',5.47),('8975','2013-09-12','13:40:00',5.43),('8975','2013-09-12','13:45:00',5.31),('8975','2013-09-12','13:50:00',5.17),('8975','2013-09-12','13:55:00',5.22),('8975','2013-09-12','14:00:00',5.16),('8975','2013-09-12','14:05:00',5.11),('8975','2013-09-12','14:10:00',5.04),('8975','2013-09-12','14:15:00',4.7),('8975','2013-09-12','14:20:00',4.43),('8975','2013-09-12','14:25:00',4.47),('8975','2013-09-12','14:30:00',4.67),('8975','2013-09-12','14:35:00',4.46),('8975','2013-09-12','14:40:00',4.54),('8975','2013-09-12','14:45:00',4.57),('8975','2013-09-12','14:50:00',4.38),('8975','2013-09-12','14:55:00',4.48),('8975','2013-09-12','15:00:00',3.85),('8975','2013-09-12','15:05:00',3.46),('8975','2013-09-12','15:10:00',3.87),('8975','2013-09-12','15:15:00',3.88),('8975','2013-09-12','15:20:00',3.81),('8975','2013-09-12','15:25:00',3.74),('8975','2013-09-12','15:30:00',3.65),('8975','2013-09-12','15:35:00',3.51),('8975','2013-09-12','15:40:00',3.26),('8975','2013-09-12','15:45:00',3.26),('8975','2013-09-12','15:50:00',3.16),('8975','2013-09-12','15:55:00',3.06),('8975','2013-09-12','16:00:00',2.98),('8975','2013-09-12','16:05:00',2.89),('8975','2013-09-12','16:10:00',2.74),('8975','2013-09-12','16:15:00',2.63),('8975','2013-09-12','16:20:00',2.56),('8975','2013-09-12','16:25:00',2.45),('8975','2013-09-12','16:30:00',2.34),('8975','2013-09-12','16:35:00',2.22),('8975','2013-09-12','16:40:00',2.11),('8975','2013-09-12','16:45:00',2.01),('8975','2013-09-12','16:50:00',1.91),('8975','2013-09-12','16:55:00',1.83),('8975','2013-09-12','17:00:00',1.75),('8975','2013-09-12','17:05:00',1.67),('8975','2013-09-12','17:10:00',1.59),('8975','2013-09-12','17:15:00',1.52),('8975','2013-09-12','17:20:00',1.47),('8975','2013-09-12','17:25:00',1.43),('8975','2013-09-12','17:30:00',1.39),('8975','2013-09-12','17:35:00',1.35),('8975','2013-09-12','17:40:00',1.3),('8975','2013-09-12','17:45:00',1.25),('8975','2013-09-12','17:50:00',1.21),('8975','2013-09-12','17:55:00',1.16),('8975','2013-09-12','18:00:00',1.1),('8975','2013-09-12','18:05:00',1.04),('8975','2013-09-11','07:25:00',1.02),('8975','2013-09-11','07:30:00',1.35),('8975','2013-09-11','07:35:00',1.34),('8975','2013-09-11','07:40:00',1.42),('8975','2013-09-11','07:45:00',1.12),('8975','2013-09-11','07:50:00',1.28),('8975','2013-09-11','07:55:00',1.72),('8975','2013-09-11','08:00:00',1.5),('8975','2013-09-11','08:05:00',1.01),('8975','2013-09-11','08:10:00',2.14),('8975','2013-09-11','08:15:00',2.85),('8975','2013-09-11','08:20:00',2.88),('8975','2013-09-11','08:25:00',3.24),('8975','2013-09-11','08:30:00',3.5),('8975','2013-09-11','08:35:00',3.58),('8975','2013-09-11','08:40:00',2.38),('8975','2013-09-11','08:45:00',2.04),('8975','2013-09-11','08:50:00',2.85),('8975','2013-09-11','08:55:00',3.32),('8975','2013-09-11','09:00:00',3.62),('8975','2013-09-11','09:05:00',3.11),('8975','2013-09-11','09:10:00',2.09),('8975','2013-09-11','09:15:00',3.1),('8975','2013-09-11','09:20:00',3.74),('8975','2013-09-11','09:25:00',3.06),('8975','2013-09-11','09:30:00',3.21),('8975','2013-09-11','09:35:00',2.6),('8975','2013-09-11','09:40:00',2.36),('8975','2013-09-11','09:45:00',2.32),('8975','2013-09-11','09:50:00',3.32),('8975','2013-09-11','09:55:00',2.5),('8975','2013-09-11','10:00:00',1.73),('8975','2013-09-11','10:05:00',3.16),('8975','2013-09-11','10:10:00',3.3),('8975','2013-09-11','10:15:00',2.14),('8975','2013-09-11','10:20:00',2.1),('8975','2013-09-11','10:25:00',2.12),('8975','2013-09-11','10:30:00',3.29),('8975','2013-09-11','10:35:00',2.33),('8975','2013-09-11','10:40:00',1.25),('8975','2013-09-11','10:45:00',1.98),('8975','2013-09-11','10:50:00',1.98),('8975','2013-09-11','10:55:00',2.82),('8975','2013-09-11','11:00:00',3.32),('8975','2013-09-11','11:05:00',5.78),('8975','2013-09-11','11:10:00',3.92),('8975','2013-09-11','11:15:00',6.96),('8975','2013-09-11','11:20:00',2.99),('8975','2013-09-11','11:40:00',1.5),('8975','2013-09-11','11:45:00',3.11),('8975','2013-09-11','11:50:00',2.81),('8975','2013-09-11','11:55:00',2.1),('8975','2013-09-11','12:00:00',2.79),('8975','2013-09-11','12:05:00',5.84),('8975','2013-09-11','12:10:00',5.61),('8975','2013-09-11','12:15:00',3.34),('8975','2013-09-11','12:20:00',2.63),('8975','2013-09-11','12:25:00',2.57),('8975','2013-09-11','12:30:00',2.15),('8975','2013-09-11','12:35:00',4.22),('8975','2013-09-11','12:40:00',2.45),('8975','2013-09-11','12:45:00',1.66),('8975','2013-09-11','12:50:00',2.12),('8975','2013-09-11','12:55:00',6.3),('8975','2013-09-11','13:00:00',5.1),('8975','2013-09-11','13:05:00',4.66),('8975','2013-09-11','13:10:00',3.99),('8975','2013-09-11','13:15:00',2.06),('8975','2013-09-11','13:20:00',4.92),('8975','2013-09-11','13:25:00',4.89),('8975','2013-09-11','13:30:00',3.46),('8975','2013-09-11','13:35:00',4.13),('8975','2013-09-11','13:40:00',3.1),('8975','2013-09-11','13:45:00',5.35),('8975','2013-09-11','13:50:00',4.73),('8975','2013-09-11','13:55:00',4.44),('8975','2013-09-11','14:00:00',3.37),('8975','2013-09-11','14:05:00',3.81),('8975','2013-09-11','14:10:00',5.2),('8975','2013-09-11','14:15:00',5.42),('8975','2013-09-11','14:20:00',3.28),('8975','2013-09-11','14:25:00',3.38),('8975','2013-09-11','14:30:00',4.45),('8975','2013-09-11','14:35:00',3.02),('8975','2013-09-11','14:40:00',4.43),('8975','2013-09-11','14:45:00',4.79),('8975','2013-09-11','14:50:00',3.99),('8975','2013-09-11','14:55:00',4.26),('8975','2013-09-11','15:00:00',4.5),('8975','2013-09-11','15:05:00',4.48),('8975','2013-09-11','15:10:00',4.1),('8975','2013-09-11','15:15:00',4.05),('8975','2013-09-11','15:20:00',3.86),('8975','2013-09-11','15:25:00',3.61),('8975','2013-09-11','15:30:00',3.73),('8975','2013-09-11','15:35:00',3.64),('8975','2013-09-11','15:40:00',3.5),('8975','2013-09-11','15:45:00',3.41),('8975','2013-09-11','15:50:00',3.27),('8975','2013-09-11','15:55:00',3.14),('8975','2013-09-11','16:00:00',3.11),('8975','2013-09-11','16:05:00',3.18),('8975','2013-09-11','16:10:00',1.76),('8975','2013-09-11','16:15:00',3.08),('8975','2013-09-11','16:20:00',2.88),('8975','2013-09-11','16:25:00',2.71),('8975','2013-09-11','16:30:00',2.3),('8975','2013-09-11','16:35:00',2.18),('8975','2013-09-11','16:40:00',1.39),('8975','2013-09-11','16:45:00',1.57),('8975','2013-09-11','16:50:00',1.8),('8975','2013-09-11','16:55:00',1.85),('8975','2013-09-11','17:00:00',2.15),('8975','2013-09-11','17:05:00',1.89),('8975','2013-09-11','17:10:00',1.82),('8975','2013-09-11','17:15:00',1.72),('8975','2013-09-11','17:20:00',1.51),('8975','2013-09-11','17:25:00',1.68),('8975','2013-09-11','17:30:00',1.75),('8975','2013-09-11','17:35:00',1.38),('8975','2013-09-11','17:40:00',1.3),('8975','2013-09-11','17:45:00',1.4),('8975','2013-09-11','17:50:00',1.24),('8975','2013-09-10','07:55:00',1.31),('8975','2013-09-10','08:00:00',1.48),('8975','2013-09-10','08:05:00',2.88),('8975','2013-09-10','08:10:00',3.05),('8975','2013-09-10','08:15:00',1.94),('8975','2013-09-10','08:25:00',1.17),('8975','2013-09-10','08:30:00',1.22),('8975','2013-09-10','08:35:00',1.19),('8975','2013-09-10','08:40:00',1.69),('8975','2013-09-10','08:45:00',1.46),('8975','2013-09-10','08:50:00',2.66),('8975','2013-09-10','08:55:00',2.06),('8975','2013-09-10','09:00:00',3.84),('8975','2013-09-10','09:05:00',2.63),('8975','2013-09-10','09:10:00',3.68),('8975','2013-09-10','09:15:00',4.43),('8975','2013-09-10','09:20:00',3.7),('8975','2013-09-10','09:25:00',4.53),('8975','2013-09-10','09:30:00',4.06),('8975','2013-09-10','09:35:00',4.36),('8975','2013-09-10','09:40:00',2.26),('8975','2013-09-10','09:45:00',1.36),('8975','2013-09-10','09:50:00',1.7),('8975','2013-09-10','09:55:00',1.25),('8975','2013-09-10','10:00:00',1.69),('8975','2013-09-10','10:15:00',2.47),('8975','2013-09-10','10:20:00',3.08),('8975','2013-09-10','10:25:00',5.24),('8975','2013-09-10','10:30:00',5.39),('8975','2013-09-10','10:35:00',5.47),('8975','2013-09-10','10:40:00',5.42),('8975','2013-09-10','10:45:00',4.52),('8975','2013-09-10','10:50:00',6.04),('8975','2013-09-10','10:55:00',6.6),('8975','2013-09-10','11:00:00',6.11),('8975','2013-09-10','11:05:00',4.58),('8975','2013-09-10','11:10:00',2.82),('8975','2013-09-10','11:15:00',1.63),('8975','2013-09-10','11:20:00',6.42),('8975','2013-09-10','11:25:00',5.27),('8975','2013-09-10','11:30:00',5.57),('8975','2013-09-10','11:35:00',5.7),('8975','2013-09-10','11:40:00',6.13),('8975','2013-09-10','11:45:00',6.01),('8975','2013-09-10','11:50:00',6.03),('8975','2013-09-10','11:55:00',6.11),('8975','2013-09-10','12:00:00',6.15),('8975','2013-09-10','12:05:00',4.96),('8975','2013-09-10','12:10:00',5.65),('8975','2013-09-10','12:15:00',5.62),('8975','2013-09-10','12:20:00',4.07),('8975','2013-09-10','12:25:00',6.3),('8975','2013-09-10','12:30:00',6.42),('8975','2013-09-10','12:35:00',6.38),('8975','2013-09-10','12:40:00',6.36),('8975','2013-09-10','12:45:00',4.18),('8975','2013-09-10','12:50:00',5.3),('8975','2013-09-10','12:55:00',4.96),('8975','2013-09-10','13:00:00',4.24),('8975','2013-09-10','13:05:00',5.77),('8975','2013-09-10','13:10:00',5.95),('8975','2013-09-10','13:15:00',5.96),('8975','2013-09-10','13:20:00',6.12),('8975','2013-09-10','13:25:00',5.99),('8975','2013-09-10','13:30:00',6.04),('8975','2013-09-10','13:35:00',6.04),('8975','2013-09-10','13:40:00',6.35),('8975','2013-09-10','13:45:00',4.9),('8975','2013-09-10','13:50:00',6.08),('8975','2013-09-10','13:55:00',5.97),('8975','2013-09-10','14:00:00',5.69),('8975','2013-09-10','14:05:00',5.43),('8975','2013-09-10','14:10:00',5.46),('8975','2013-09-10','14:15:00',5.34),('8975','2013-09-10','14:20:00',5.39),('8975','2013-09-10','14:25:00',2.14),('8975','2013-09-10','14:30:00',1.99),('8975','2013-09-10','14:35:00',4.49),('8975','2013-09-10','14:40:00',3.68),('8975','2013-09-10','14:45:00',3.98),('8975','2013-09-10','14:50:00',5.24),('8975','2013-09-10','14:55:00',2.75),('8975','2013-09-10','15:00:00',4.59),('8975','2013-09-10','15:05:00',4.83),('8975','2013-09-10','15:10:00',4.53),('8975','2013-09-10','15:15:00',4.24),('8975','2013-09-10','15:20:00',3.73),('8975','2013-09-10','15:25:00',3.75),('8975','2013-09-10','15:30:00',1.87),('8975','2013-09-10','15:35:00',4.15),('8975','2013-09-10','15:40:00',3.07),('8975','2013-09-10','15:45:00',3.52),('8975','2013-09-10','15:50:00',2.77),('8975','2013-09-10','15:55:00',3.29),('8975','2013-09-10','16:00:00',2.39),('8975','2013-09-10','16:05:00',2.39),('8975','2013-09-10','16:10:00',1.91),('8975','2013-09-10','16:15:00',2.99),('8975','2013-09-10','16:20:00',2.52),('8975','2013-09-10','16:25:00',1.95),('8975','2013-09-10','16:30:00',2.06),('8975','2013-09-10','16:35:00',2.39),('8975','2013-09-10','16:40:00',2.32),('8975','2013-09-10','16:45:00',1.82),('8975','2013-09-10','16:50:00',1.92),('8975','2013-09-10','16:55:00',1.85),('8975','2013-09-10','17:00:00',1.64),('8975','2013-09-10','17:05:00',1.39),('8975','2013-09-10','17:10:00',1.44),('8975','2013-09-10','17:15:00',1.47),('8975','2013-09-10','17:20:00',1.5),('8975','2013-09-10','17:25:00',1.44),('8975','2013-09-10','17:30:00',1.41),('8975','2013-09-10','17:50:00',1.31),('8975','2013-09-10','17:55:00',1.29),('8975','2013-09-10','18:00:00',1.28),('8975','2013-09-10','18:05:00',1.19),('8975','2013-09-10','18:10:00',1.21),('8975','2013-09-09','07:50:00',1.29),('8975','2013-09-09','07:55:00',1.63),('8975','2013-09-09','08:00:00',1.82),('8975','2013-09-09','08:05:00',1.25),('8975','2013-09-09','08:10:00',1.42),('8975','2013-09-09','08:15:00',1.37),('8975','2013-09-09','08:20:00',1.08),('8975','2013-09-09','08:40:00',1),('8975','2013-09-09','08:45:00',1.3),('8975','2013-09-09','08:50:00',1.44),('8975','2013-09-09','08:55:00',2.84),('8975','2013-09-09','09:00:00',3.6),('8975','2013-09-09','09:05:00',4.06),('8975','2013-09-09','09:10:00',4.35),('8975','2013-09-09','09:15:00',3.94),('8975','2013-09-09','09:20:00',2.75),('8975','2013-09-09','09:25:00',2.79),('8975','2013-09-09','09:30:00',4.8),('8975','2013-09-09','09:35:00',4.65),('8975','2013-09-09','09:40:00',2.9),('8975','2013-09-09','09:45:00',2.29),('8975','2013-09-09','09:50:00',2.02),('8975','2013-09-09','09:55:00',1.76),('8975','2013-09-09','10:00:00',1.57),('8975','2013-09-09','10:05:00',1.39),('8975','2013-09-09','10:10:00',1.04),('8975','2013-09-09','10:20:00',1.18),('8975','2013-09-09','10:25:00',1.54),('8975','2013-09-09','10:30:00',1.6),('8975','2013-09-09','10:35:00',1.97),('8975','2013-09-09','10:40:00',2.49),('8975','2013-09-09','10:45:00',2.98),('8975','2013-09-09','10:50:00',1.79),('8975','2013-09-09','10:55:00',2.17),('8975','2013-09-09','11:00:00',2.47),('8975','2013-09-09','11:05:00',2.18),('8975','2013-09-09','11:10:00',2.24),('8975','2013-09-09','11:15:00',1.72),('8975','2013-09-09','11:20:00',1.89),('8975','2013-09-09','11:25:00',2.02),('8975','2013-09-09','11:30:00',1.53),('8975','2013-09-09','11:35:00',1.12),('8975','2013-09-09','11:40:00',1.1),('8975','2013-09-09','11:45:00',1.5),('8975','2013-09-09','11:50:00',1.67),('8975','2013-09-09','11:55:00',1.69),('8975','2013-09-09','12:00:00',2.13),('8975','2013-09-09','12:05:00',1.46),('8975','2013-09-09','12:10:00',1.55),('8975','2013-09-09','12:15:00',1.72),('8975','2013-09-09','12:20:00',2.05),('8975','2013-09-09','12:25:00',1.72),('8975','2013-09-09','12:30:00',1.51),('8975','2013-09-09','12:35:00',1.67),('8975','2013-09-09','12:40:00',1.38),('8975','2013-09-09','12:45:00',1.42),('8975','2013-09-09','12:50:00',1.54),('8975','2013-09-09','12:55:00',1.27),('8975','2013-09-09','13:00:00',1.37),('8975','2013-09-09','13:05:00',1.08),('8975','2013-09-09','13:15:00',1.27),('8975','2013-09-09','13:20:00',1.38),('8975','2013-09-09','13:25:00',1.6),('8975','2013-09-09','13:30:00',1.51),('8975','2013-09-09','13:35:00',1.7),('8975','2013-09-09','13:40:00',2.96),('8975','2013-09-09','13:45:00',3.94),('8975','2013-09-09','13:50:00',2.48),('8975','2013-09-09','13:55:00',2.19),('8975','2013-09-09','14:00:00',1.64),('8975','2013-09-09','14:05:00',2.01),('8975','2013-09-09','14:10:00',2.09),('8975','2013-09-09','14:15:00',2.41),('8975','2013-09-09','14:20:00',2.45),('8975','2013-09-09','14:25:00',3.33),('8975','2013-09-09','14:30:00',3.03),('8975','2013-09-09','14:35:00',2.45),('8975','2013-09-09','14:40:00',2.94),('8975','2013-09-09','14:45:00',2.97),('8975','2013-09-09','14:50:00',3.16),('8975','2013-09-09','14:55:00',2.97),('8975','2013-09-09','15:00:00',3.16),('8975','2013-09-09','15:05:00',2.27),('8975','2013-09-09','15:10:00',2.14),('8975','2013-09-09','15:15:00',2.03),('8975','2013-09-09','15:20:00',2.37),('8975','2013-09-09','15:25:00',2.43),('8975','2013-09-09','15:30:00',2.85),('8975','2013-09-09','15:35:00',2.01),('8975','2013-09-09','15:40:00',1.57),('8975','2013-09-09','15:45:00',1.55),('8975','2013-09-09','15:50:00',1.67),('8975','2013-09-09','15:55:00',1.56),('8975','2013-09-09','16:00:00',1.66),('8975','2013-09-09','16:05:00',1.78),('8975','2013-09-09','16:10:00',1.73),('8975','2013-09-09','16:15:00',2.01),('8975','2013-09-09','16:20:00',1.58),('8975','2013-09-09','16:25:00',1.48),('8975','2013-09-09','16:30:00',1.24),('8975','2013-09-09','16:50:00',1.06),('8975','2013-09-09','16:55:00',1.16),('8975','2013-09-09','17:00:00',1.03),('8975','2013-09-09','17:05:00',1.02),('8975','2013-09-09','17:10:00',1.1),('8975','2013-09-09','17:15:00',1.22),('8975','2013-09-09','17:20:00',1.27),('8975','2013-09-09','17:25:00',1.21),('8975','2013-09-09','17:30:00',1.03),('8975','2013-09-09','17:45:00',1.02),('8975','2013-09-09','17:50:00',1.1),('8975','2013-09-08','07:30:00',1.16),('8975','2013-09-08','07:35:00',1.54),('8975','2013-09-08','07:40:00',1.89),('8975','2013-09-08','07:45:00',1.91),('8975','2013-09-08','07:50:00',2.23),('8975','2013-09-08','07:55:00',1.85),('8975','2013-09-08','08:00:00',1.47),('8975','2013-09-08','08:05:00',1.06),('8975','2013-09-08','08:25:00',1.02),('8975','2013-09-08','08:30:00',1.05),('8975','2013-09-08','08:40:00',1.09),('8975','2013-09-08','08:45:00',1.43),('8975','2013-09-08','08:50:00',1.67),('8975','2013-09-08','08:55:00',2.06),('8975','2013-09-08','09:00:00',1.85),('8975','2013-09-08','09:05:00',1.78),('8975','2013-09-08','09:10:00',1.58),('8975','2013-09-08','09:15:00',1.49),('8975','2013-09-08','09:20:00',1.84),('8975','2013-09-08','09:25:00',1.36),('8975','2013-09-08','09:30:00',1.62),('8975','2013-09-08','09:35:00',2.07),('8975','2013-09-08','09:40:00',1.25),('8975','2013-09-08','09:45:00',1.15),('8975','2013-09-08','09:50:00',1.25),('8975','2013-09-08','09:55:00',2.07),('8975','2013-09-08','10:00:00',3.01),('8975','2013-09-08','10:05:00',3.15),('8975','2013-09-08','10:10:00',2.97),('8975','2013-09-08','10:15:00',3.02),('8975','2013-09-08','10:20:00',3),('8975','2013-09-08','10:25:00',3.01),('8975','2013-09-08','10:30:00',2.79),('8975','2013-09-08','10:35:00',2.84),('8975','2013-09-08','10:40:00',2.93),('8975','2013-09-08','10:45:00',3.22),('8975','2013-09-08','10:50:00',3.38),('8975','2013-09-08','10:55:00',3.75),('8975','2013-09-08','11:00:00',4.27),('8975','2013-09-08','11:05:00',3.29),('8975','2013-09-08','11:10:00',3.2),('8975','2013-09-08','11:15:00',3.64),('8975','2013-09-08','11:20:00',3.83),('8975','2013-09-08','11:25:00',4.22),('8975','2013-09-08','11:30:00',3.44),('8975','2013-09-08','11:35:00',4.14),('8975','2013-09-08','11:40:00',4.97),('8975','2013-09-08','11:45:00',5.51),('8975','2013-09-08','11:50:00',5.42),('8975','2013-09-08','11:55:00',5.15),('8975','2013-09-08','12:00:00',4.68),('8975','2013-09-08','12:05:00',4.3),('8975','2013-09-08','12:10:00',4.08),('8975','2013-09-08','12:15:00',4.09),('8975','2013-09-08','12:20:00',2.92),('8975','2013-09-08','12:25:00',2.33),('8975','2013-09-08','12:30:00',2.33),('8975','2013-09-08','12:35:00',2.49),('8975','2013-09-08','12:40:00',4.03),('8975','2013-09-08','12:45:00',3.7),('8975','2013-09-08','12:50:00',2.92),('8975','2013-09-08','12:55:00',3.49),('8975','2013-09-08','13:00:00',3.3),('8975','2013-09-08','13:05:00',3.91),('8975','2013-09-08','13:10:00',4.22),('8975','2013-09-08','13:15:00',4.97),('8975','2013-09-08','13:20:00',3.71),('8975','2013-09-08','13:25:00',3.31),('8975','2013-09-08','13:30:00',5.45),('8975','2013-09-08','13:35:00',5.52),('8975','2013-09-08','13:40:00',4.99),('8975','2013-09-08','13:45:00',5.59),('8975','2013-09-08','13:50:00',5.42),('8975','2013-09-08','13:55:00',5.2),('8975','2013-09-08','14:00:00',4.79),('8975','2013-09-08','14:05:00',3.12),('8975','2013-09-08','14:10:00',4.34),('8975','2013-09-08','14:15:00',3.07),('8975','2013-09-08','14:20:00',4.43),('8975','2013-09-08','14:25:00',4.28),('8975','2013-09-08','14:30:00',5.19),('8975','2013-09-08','14:35:00',5.14),('8975','2013-09-08','14:40:00',3.92),('8975','2013-09-08','14:45:00',3.54),('8975','2013-09-08','14:50:00',4.28),('8975','2013-09-08','14:55:00',3.76),('8975','2013-09-08','15:00:00',2.12),('8975','2013-09-08','15:05:00',4.27),('8975','2013-09-08','15:10:00',3.01),('8975','2013-09-08','15:15:00',3.26),('8975','2013-09-08','15:20:00',4.03),('8975','2013-09-08','15:25:00',2.21),('8975','2013-09-08','15:30:00',3.45),('8975','2013-09-08','15:35:00',2.79),('8975','2013-09-08','15:40:00',3.2),('8975','2013-09-08','15:45:00',1.92),('8975','2013-09-08','15:50:00',2.42),('8975','2013-09-08','15:55:00',2.91),('8975','2013-09-08','16:00:00',2.75),('8975','2013-09-08','16:05:00',1.98),('8975','2013-09-08','16:10:00',2.65),('8975','2013-09-08','16:15:00',3.02),('8975','2013-09-08','16:20:00',2.52),('8975','2013-09-08','16:25:00',1.67),('8975','2013-09-08','16:30:00',1.44),('8975','2013-09-08','16:35:00',1.86),('8975','2013-09-08','16:40:00',1.81),('8975','2013-09-08','16:45:00',2.23),('8975','2013-09-08','16:50:00',1.06),('8975','2013-09-08','16:55:00',1.07),('8975','2013-09-08','17:00:00',1.2),('8975','2013-09-08','17:05:00',1.12),('8975','2013-09-08','17:10:00',1.04),('8975','2013-09-08','17:35:00',1.03),('8975','2013-09-08','18:15:00',1.2),('8975','2013-09-08','18:20:00',1.18),('8975','2014-04-11','08:10:00',1.19),('8975','2014-04-11','08:15:00',1.24),('8975','2014-04-11','08:20:00',1.49),('8975','2014-04-11','08:25:00',2.06),('8975','2014-04-11','08:30:00',1.3),('8975','2014-04-11','08:35:00',1.15),('8975','2014-04-11','08:40:00',1.12),('8975','2014-04-11','08:45:00',1.17),('8975','2014-04-11','08:50:00',1.32),('8975','2014-04-11','08:55:00',1.54),('8975','2014-04-11','09:00:00',1.47),('8975','2014-04-11','09:05:00',1.72),('8975','2014-04-11','09:10:00',2.28),('8975','2014-04-11','09:15:00',3.37),('8975','2014-04-11','09:20:00',2.9),('8975','2014-04-11','09:25:00',2.2),('8975','2014-04-11','09:30:00',1.71),('8975','2014-04-11','09:35:00',1.3),('8975','2014-04-11','09:40:00',1.06),('8975','2014-04-11','09:45:00',1.1),('8975','2014-04-11','09:50:00',1.22),('8975','2014-04-11','09:55:00',1.24),('8975','2014-04-11','10:00:00',1.38),('8975','2014-04-11','10:05:00',1.7),('8975','2014-04-11','10:10:00',2.21),('8975','2014-04-11','10:15:00',2.59),('8975','2014-04-11','10:20:00',2.79),('8975','2014-04-11','10:25:00',2.88),('8975','2014-04-11','10:30:00',3.3),('8975','2014-04-11','10:35:00',3.91),('8975','2014-04-11','10:40:00',3.75),('8975','2014-04-11','10:45:00',3.43),('8975','2014-04-11','10:50:00',3.79),('8975','2014-04-11','10:55:00',3.96),('8975','2014-04-11','11:00:00',4.13),('8975','2014-04-11','11:05:00',4.65),('8975','2014-04-11','11:10:00',5.84),('8975','2014-04-11','11:15:00',5.39),('8975','2014-04-11','11:20:00',4.16),('8975','2014-04-11','11:25:00',5.66),('8975','2014-04-11','11:30:00',6.07),('8975','2014-04-11','11:35:00',5.93),('8975','2014-04-11','11:40:00',5.85),('8975','2014-04-11','11:45:00',6.39),('8975','2014-04-11','11:50:00',5.99),('8975','2014-04-11','11:55:00',3.19),('8975','2014-04-11','12:00:00',2.27),('8975','2014-04-11','12:05:00',1.98),('8975','2014-04-11','12:10:00',1.81),('8975','2014-04-11','12:15:00',1.84),('8975','2014-04-11','12:20:00',1.94),('8975','2014-04-11','12:25:00',2.02),('8975','2014-04-11','12:30:00',3.28),('8975','2014-04-11','12:35:00',3.89),('8975','2014-04-11','12:40:00',4.22),('8975','2014-04-11','12:45:00',5.09),('8975','2014-04-11','12:50:00',5.56),('8975','2014-04-11','12:55:00',2.85),('8975','2014-04-11','13:00:00',1.87),('8975','2014-04-11','13:05:00',2.94),('8975','2014-04-11','13:10:00',3.8),('8975','2014-04-11','13:15:00',2.91),('8975','2014-04-11','13:20:00',6.39),('8975','2014-04-11','13:25:00',4.01),('8975','2014-04-11','13:30:00',3.52),('8975','2014-04-11','13:35:00',3.63),('8975','2014-04-11','13:40:00',6.39),('8975','2014-04-11','13:45:00',6.51),('8975','2014-04-11','13:50:00',5.99),('8975','2014-04-11','13:55:00',5.38),('8975','2014-04-11','14:00:00',4.13),('8975','2014-04-11','14:05:00',2.05),('8975','2014-04-11','14:10:00',3.26),('8975','2014-04-11','14:15:00',4.29),('8975','2014-04-11','14:20:00',4.81),('8975','2014-04-11','14:25:00',4.12),('8975','2014-04-11','14:30:00',4.81),('8975','2014-04-11','14:35:00',3.63),('8975','2014-04-11','14:40:00',3.83),('8975','2014-04-11','14:45:00',4.81),('8975','2014-04-11','14:50:00',5.05),('8975','2014-04-11','14:55:00',3.91),('8975','2014-04-11','15:00:00',4.43),('8975','2014-04-11','15:05:00',4.65),('8975','2014-04-11','15:10:00',4.79),('8975','2014-04-11','15:15:00',4.46),('8975','2014-04-11','15:20:00',3.65),('8975','2014-04-11','15:25:00',3.77),('8975','2014-04-11','15:30:00',3.74),('8975','2014-04-11','15:35:00',3.69),('8975','2014-04-11','15:40:00',3.02),('8975','2014-04-11','15:45:00',3.05),('8975','2014-04-11','15:50:00',3.85),('8975','2014-04-11','15:55:00',3.95),('8975','2014-04-11','16:00:00',3.83),('8975','2014-04-11','16:05:00',3.68),('8975','2014-04-11','16:10:00',3.52),('8975','2014-04-11','16:15:00',3.67),('8975','2014-04-11','16:20:00',3.68),('8975','2014-04-11','16:25:00',3.36),('8975','2014-04-11','16:30:00',3.01),('8975','2014-04-11','16:35:00',2.39),('8975','2014-04-11','16:40:00',2.32),('8975','2014-04-11','16:45:00',1.98),('8975','2014-04-11','16:50:00',1.97),('8975','2014-04-11','16:55:00',2.64),('8975','2014-04-11','17:00:00',2.49),('8975','2014-04-11','17:05:00',2.25),('8975','2014-04-11','17:10:00',2.11),('8975','2014-04-11','17:15:00',2.06),('8975','2014-04-11','17:20:00',1.96),('8975','2014-04-11','17:25:00',1.72),('8975','2014-04-11','17:30:00',1.98),('8975','2014-04-11','17:35:00',1.99),('8975','2014-04-11','17:40:00',2.02),('8975','2014-04-11','17:45:00',1.98),('8975','2014-04-11','17:50:00',1.8),('8975','2014-04-11','17:55:00',1.42),('8975','2014-04-11','18:00:00',1.37),('8975','2014-04-11','18:05:00',1.19),('8975','2014-04-11','18:15:00',1.03),('8975','2014-04-11','18:20:00',1.17),('8975','2014-04-11','18:25:00',1.01),('8975','2014-04-11','18:30:00',1.07),('8975','2013-09-07','07:30:00',1.01),('8975','2013-09-07','07:35:00',1.11),('8975','2013-09-07','07:40:00',1.22),('8975','2013-09-07','07:45:00',1.41),('8975','2013-09-07','07:50:00',1.8),('8975','2013-09-07','07:55:00',1.67),('8975','2013-09-07','08:15:00',1.08),('8975','2013-09-07','08:20:00',1.11),('8975','2013-09-07','08:25:00',1.07),('8975','2013-09-07','08:30:00',1.64),('8975','2013-09-07','08:35:00',1.32),('8975','2013-09-07','08:40:00',1.33),('8975','2013-09-07','08:45:00',1.5),('8975','2013-09-07','08:50:00',1.86),('8975','2013-09-07','08:55:00',2.4),('8975','2013-09-07','09:00:00',1.92),('8975','2013-09-07','09:05:00',2.86),('8975','2013-09-07','09:10:00',2.98),('8975','2013-09-07','09:15:00',3.11),('8975','2013-09-07','09:20:00',2.95),('8975','2013-09-07','09:25:00',2.74),('8975','2013-09-07','09:30:00',2.96),('8975','2013-09-07','09:35:00',3.42),('8975','2013-09-07','09:40:00',3.98),('8975','2013-09-07','09:45:00',3.95),('8975','2013-09-07','09:50:00',4.24),('8975','2013-09-07','09:55:00',4.32),('8975','2013-09-07','10:00:00',4.41),('8975','2013-09-07','10:05:00',4.52),('8975','2013-09-07','10:10:00',4.58),('8975','2013-09-07','10:15:00',4.57),('8975','2013-09-07','10:20:00',4.68),('8975','2013-09-07','10:25:00',4.72),('8975','2013-09-07','10:30:00',4.83),('8975','2013-09-07','10:35:00',4.76),('8975','2013-09-07','10:40:00',4.74),('8975','2013-09-07','10:45:00',4.99),('8975','2013-09-07','10:50:00',5.07),('8975','2013-09-07','10:55:00',5.04),('8975','2013-09-07','11:00:00',5.08),('8975','2013-09-07','11:05:00',5.12),('8975','2013-09-07','11:10:00',5.18),('8975','2013-09-07','11:15:00',5.15),('8975','2013-09-07','11:20:00',5.16),('8975','2013-09-07','11:25:00',5.17),('8975','2013-09-07','11:30:00',5.12),('8975','2013-09-07','11:35:00',5.22),('8975','2013-09-07','11:40:00',5.11),('8975','2013-09-07','11:45:00',4.87),('8975','2013-09-07','11:50:00',4.89),('8975','2013-09-07','11:55:00',4.95),('8975','2013-09-07','12:00:00',4.3),('8975','2013-09-07','12:05:00',4.56),('8975','2013-09-07','12:10:00',4.78),('8975','2013-09-07','12:15:00',5),('8975','2013-09-07','12:20:00',4.96),('8975','2013-09-07','12:25:00',4.78),('8975','2013-09-07','12:30:00',4.6),('8975','2013-09-07','12:35:00',5.41),('8975','2013-09-07','12:40:00',5.21),('8975','2013-09-07','12:45:00',5.25),('8975','2013-09-07','12:50:00',5.08),('8975','2013-09-07','12:55:00',4.99),('8975','2013-09-07','13:00:00',5.06),('8975','2013-09-07','13:05:00',5.3),('8975','2013-09-07','13:10:00',5.28),('8975','2013-09-07','13:15:00',5.02),('8975','2013-09-07','13:20:00',4.74),('8975','2013-09-07','13:25:00',4.51),('8975','2013-09-07','13:30:00',4.71),('8975','2013-09-07','13:35:00',4.01),('8975','2013-09-07','13:40:00',3.08),('8975','2013-09-07','13:45:00',2.85),('8975','2013-09-07','13:50:00',4.19),('8975','2013-09-07','13:55:00',4.25),('8975','2013-09-07','14:00:00',4.76),('8975','2013-09-07','14:05:00',4.52),('8975','2013-09-07','14:10:00',5.22),('8975','2013-09-07','14:15:00',5.01),('8975','2013-09-07','14:20:00',5.54),('8975','2013-09-07','14:25:00',5.4),('8975','2013-09-07','14:30:00',4.76),('8975','2013-09-07','14:35:00',4.79),('8975','2013-09-07','14:40:00',4.64),('8975','2013-09-07','14:45:00',4.48),('8975','2013-09-07','14:50:00',4.38),('8975','2013-09-07','14:55:00',4.31),('8975','2013-09-07','15:00:00',4.23),('8975','2013-09-07','15:05:00',3.4),('8975','2013-09-07','15:10:00',1.93),('8975','2013-09-07','15:15:00',3.38),('8975','2013-09-07','15:20:00',3.96),('8975','2013-09-07','15:25:00',3.95),('8975','2013-09-07','15:30:00',3.86),('8975','2013-09-07','15:35:00',3.63),('8975','2013-09-07','15:40:00',3.35),('8975','2013-09-07','15:45:00',3.36),('8975','2013-09-07','15:50:00',3.1),('8975','2013-09-07','15:55:00',2.77),('8975','2013-09-07','16:00:00',2.69),('8975','2013-09-07','16:05:00',2.67),('8975','2013-09-07','16:10:00',2.35),('8975','2013-09-07','16:15:00',2.78),('8975','2013-09-07','16:20:00',2.34),('8975','2013-09-07','16:25:00',2.3),('8975','2013-09-07','16:30:00',2.32),('8975','2013-09-07','16:35:00',2.14),('8975','2013-09-07','16:40:00',1.88),('8975','2013-09-07','16:45:00',1.37),('8975','2013-09-07','16:50:00',1.25),('8975','2013-09-07','16:55:00',1.29),('8975','2013-09-07','17:00:00',1.98),('8975','2013-09-07','17:05:00',2.07),('8975','2013-09-07','17:10:00',1.93),('8975','2013-09-07','17:15:00',1.75),('8975','2013-09-07','17:20:00',1.46),('8975','2013-09-07','17:25:00',1.49),('8975','2013-09-07','17:30:00',1.34),('8975','2013-09-07','17:45:00',1.16),('8975','2013-09-07','17:50:00',1.18),('8975','2013-09-07','17:55:00',1.18),('8975','2013-09-07','18:00:00',1.06),('8975','2013-09-06','07:25:00',1.11),('8975','2013-09-06','07:30:00',1.24),('8975','2013-09-06','07:35:00',1.52),('8975','2013-09-06','07:40:00',1.61),('8975','2013-09-06','07:45:00',1.69),('8975','2013-09-06','07:50:00',2.01),('8975','2013-09-06','07:55:00',2.19),('8975','2013-09-06','08:00:00',2.32),('8975','2013-09-06','08:05:00',2.45),('8975','2013-09-06','08:10:00',2.57),('8975','2013-09-06','08:15:00',2.69),('8975','2013-09-06','08:20:00',2.8),('8975','2013-09-06','08:25:00',2.91),('8975','2013-09-06','08:30:00',2.99),('8975','2013-09-06','08:35:00',3.07),('8975','2013-09-06','08:40:00',3.19),('8975','2013-09-06','08:45:00',3.29),('8975','2013-09-06','08:50:00',3.36),('8975','2013-09-06','08:55:00',3.45),('8975','2013-09-06','09:00:00',3.55),('8975','2013-09-06','09:05:00',3.65),('8975','2013-09-06','09:10:00',3.76),('8975','2013-09-06','09:15:00',3.85),('8975','2013-09-06','09:20:00',3.95),('8975','2013-09-06','09:25:00',4.06),('8975','2013-09-06','09:30:00',4.14),('8975','2013-09-06','09:35:00',4.2),('8975','2013-09-06','09:40:00',4.29),('8975','2013-09-06','09:45:00',4.36),('8975','2013-09-06','09:50:00',4.41),('8975','2013-09-06','09:55:00',4.47),('8975','2013-09-06','10:00:00',4.54),('8975','2013-09-06','10:05:00',4.53),('8975','2013-09-06','10:10:00',4.61),('8975','2013-09-06','10:15:00',4.71),('8975','2013-09-06','10:20:00',4.8),('8975','2013-09-06','10:25:00',4.87),('8975','2013-09-06','10:30:00',4.96),('8975','2013-09-06','10:35:00',4.94),('8975','2013-09-06','10:40:00',5.02),('8975','2013-09-06','10:45:00',5.07),('8975','2013-09-06','10:50:00',5.13),('8975','2013-09-06','10:55:00',5.22),('8975','2013-09-06','11:00:00',5.25),('8975','2013-09-06','11:05:00',5.26),('8975','2013-09-06','11:10:00',5.3),('8975','2013-09-06','11:15:00',5.34),('8975','2013-09-06','11:20:00',5.35),('8975','2013-09-06','11:25:00',5.42),('8975','2013-09-06','11:30:00',5.45),('8975','2013-09-06','11:35:00',5.41),('8975','2013-09-06','11:40:00',5.48),('8975','2013-09-06','11:45:00',5.5),('8975','2013-09-06','11:50:00',5.45),('8975','2013-09-06','11:55:00',5.51),('8975','2013-09-06','12:00:00',5.48),('8975','2013-09-06','12:05:00',5.52),('8975','2013-09-06','12:10:00',5.48),('8975','2013-09-06','12:15:00',5.51),('8975','2013-09-06','12:20:00',5.55),('8975','2013-09-06','12:25:00',5.54),('8975','2013-09-06','12:30:00',5.49),('8975','2013-09-06','12:35:00',5.53),('8975','2013-09-06','12:40:00',5.57),('8975','2013-09-06','12:45:00',5.52),('8975','2013-09-06','12:50:00',5.51),('8975','2013-09-06','12:55:00',5.45),('8975','2013-09-06','13:00:00',5.43),('8975','2013-09-06','13:05:00',5.46),('8975','2013-09-06','13:10:00',5.42),('8975','2013-09-06','13:15:00',5.4),('8975','2013-09-06','13:20:00',5.2),('8975','2013-09-06','13:25:00',5.22),('8975','2013-09-06','13:30:00',5.3),('8975','2013-09-06','13:35:00',5.38),('8975','2013-09-06','13:40:00',5.31),('8975','2013-09-06','13:45:00',5.12),('8975','2013-09-06','13:50:00',5.3),('8975','2013-09-06','13:55:00',5.21),('8975','2013-09-06','14:00:00',5.12),('8975','2013-09-06','14:05:00',4.99),('8975','2013-09-06','14:10:00',4.98),('8975','2013-09-06','14:15:00',4.85),('8975','2013-09-06','14:20:00',4.84),('8975','2013-09-06','14:25:00',4.81),('8975','2013-09-06','14:30:00',4.78),('8975','2013-09-06','14:35:00',4.68),('8975','2013-09-06','14:40:00',4.55),('8975','2013-09-06','14:45:00',4.44),('8975','2013-09-06','14:50:00',4.41),('8975','2013-09-06','14:55:00',4.34),('8975','2013-09-06','15:00:00',4.23),('8975','2013-09-06','15:05:00',4.11),('8975','2013-09-06','15:10:00',3.88),('8975','2013-09-06','15:15:00',3.77),('8975','2013-09-06','15:20:00',3.79),('8975','2013-09-06','15:25:00',3.71),('8975','2013-09-06','15:30:00',3.6),('8975','2013-09-06','15:35:00',3.51),('8975','2013-09-06','15:40:00',3.39),('8975','2013-09-06','15:45:00',3.24),('8975','2013-09-06','15:50:00',3.12),('8975','2013-09-06','15:55:00',3.06),('8975','2013-09-06','16:00:00',2.98),('8975','2013-09-06','16:05:00',2.87),('8975','2013-09-06','16:10:00',2.76),('8975','2013-09-06','16:15:00',2.65),('8975','2013-09-06','16:20:00',2.51),('8975','2013-09-06','16:25:00',2.42),('8975','2013-09-06','16:30:00',2.32),('8975','2013-09-06','16:35:00',2.22),('8975','2013-09-06','16:40:00',2.13),('8975','2013-09-06','16:45:00',2.05),('8975','2013-09-06','16:50:00',1.95),('8975','2013-09-06','16:55:00',1.85),('8975','2013-09-06','17:00:00',1.78),('8975','2013-09-06','17:05:00',1.71),('8975','2013-09-06','17:10:00',1.64),('8975','2013-09-06','17:15:00',1.57),('8975','2013-09-06','17:20:00',1.5),('8975','2013-09-06','17:25:00',1.42),('8975','2013-09-06','17:30:00',1.36),('8975','2013-09-06','17:35:00',1.31),('8975','2013-09-06','17:40:00',1.29),('8975','2013-09-06','17:45:00',1.23),('8975','2013-09-06','17:50:00',1.17),('8975','2013-09-06','17:55:00',1.12),('8975','2013-09-06','18:00:00',1.07),('8975','2013-09-06','18:05:00',1.01),('8975','2013-09-05','07:20:00',1.12),('8975','2013-09-05','07:25:00',1.3),('8975','2013-09-05','07:30:00',1.39),('8975','2013-09-05','07:35:00',1.48),('8975','2013-09-05','07:40:00',1.69),('8975','2013-09-05','07:45:00',1.83),('8975','2013-09-05','07:50:00',2.12),('8975','2013-09-05','07:55:00',2.29),('8975','2013-09-05','08:00:00',2.43),('8975','2013-09-05','08:05:00',2.54),('8975','2013-09-05','08:10:00',2.69),('8975','2013-09-05','08:15:00',2.81),('8975','2013-09-05','08:20:00',2.93),('8975','2013-09-05','08:25:00',3.04),('8975','2013-09-05','08:30:00',3.12),('8975','2013-09-05','08:35:00',3.22),('8975','2013-09-05','08:40:00',3.31),('8975','2013-09-05','08:45:00',3.4),('8975','2013-09-05','08:50:00',3.46),('8975','2013-09-05','08:55:00',3.56),('8975','2013-09-05','09:00:00',3.65),('8975','2013-09-05','09:05:00',3.73),('8975','2013-09-05','09:10:00',3.83),('8975','2013-09-05','09:15:00',3.91),('8975','2013-09-05','09:20:00',3.99),('8975','2013-09-05','09:25:00',4.07),('8975','2013-09-05','09:30:00',4.13),('8975','2013-09-05','09:35:00',4.21),('8975','2013-09-05','09:40:00',4.29),('8975','2013-09-05','09:45:00',4.37),('8975','2013-09-05','09:50:00',4.44),('8975','2013-09-05','09:55:00',4.56),('8975','2013-09-05','10:00:00',4.6),('8975','2013-09-05','10:05:00',4.69),('8975','2013-09-05','10:10:00',4.74),('8975','2013-09-05','10:15:00',4.73),('8975','2013-09-05','10:20:00',4.8),('8975','2013-09-05','10:25:00',4.94),('8975','2013-09-05','10:30:00',5.07),('8975','2013-09-05','10:35:00',5.13),('8975','2013-09-05','10:40:00',5.16),('8975','2013-09-05','10:45:00',5.17),('8975','2013-09-05','10:50:00',5.21),('8975','2013-09-05','10:55:00',5.28),('8975','2013-09-05','11:00:00',5.39),('8975','2013-09-05','11:05:00',5.41),('8975','2013-09-05','11:10:00',5.4),('8975','2013-09-05','11:15:00',5.4),('8975','2013-09-05','11:20:00',5.39),('8975','2013-09-05','11:25:00',5.48),('8975','2013-09-05','11:30:00',5.5),('8975','2013-09-05','11:35:00',5.51),('8975','2013-09-05','11:40:00',5.54),('8975','2013-09-05','11:45:00',5.58),('8975','2013-09-05','11:50:00',5.6),('8975','2013-09-05','11:55:00',5.61),('8975','2013-09-05','12:00:00',5.65),('8975','2013-09-05','12:05:00',5.64),('8975','2013-09-05','12:10:00',5.7),('8975','2013-09-05','12:15:00',5.7),('8975','2013-09-05','12:20:00',5.63),('8975','2013-09-05','12:25:00',5.59),('8975','2013-09-05','12:30:00',5.65),('8975','2013-09-05','12:35:00',5.68),('8975','2013-09-05','12:40:00',5.58),('8975','2013-09-05','12:45:00',5.53),('8975','2013-09-05','12:50:00',5.54),('8975','2013-09-05','12:55:00',5.53),('8975','2013-09-05','13:00:00',5.45),('8975','2013-09-05','13:05:00',5.45),('8975','2013-09-05','13:10:00',5.42),('8975','2013-09-05','13:15:00',5.39),('8975','2013-09-05','13:20:00',5.37),('8975','2013-09-05','13:25:00',5.3),('8975','2013-09-05','13:30:00',5.29),('8975','2013-09-05','13:35:00',5.27),('8975','2013-09-05','13:40:00',5.28),('8975','2013-09-05','13:45:00',5.25),('8975','2013-09-05','13:50:00',5.22),('8975','2013-09-05','13:55:00',5.13),('8975','2013-09-05','14:00:00',5.06),('8975','2013-09-05','14:05:00',5.05),('8975','2013-09-05','14:10:00',5.01),('8975','2013-09-05','14:15:00',4.87),('8975','2013-09-05','14:20:00',4.74),('8975','2013-09-05','14:25:00',4.81),('8975','2013-09-05','14:30:00',4.64),('8975','2013-09-05','14:35:00',4.63),('8975','2013-09-05','14:40:00',4.55),('8975','2013-09-05','14:45:00',4.46),('8975','2013-09-05','14:50:00',4.58),('8975','2013-09-05','14:55:00',4.43),('8975','2013-09-05','15:00:00',4.29),('8975','2013-09-05','15:05:00',4.08),('8975','2013-09-05','15:10:00',3.95),('8975','2013-09-05','15:15:00',3.75),('8975','2013-09-05','15:20:00',3.72),('8975','2013-09-05','15:25:00',3.68),('8975','2013-09-05','15:30:00',3.6),('8975','2013-09-05','15:35:00',3.5),('8975','2013-09-05','15:40:00',3.42),('8975','2013-09-05','15:45:00',3.27),('8975','2013-09-05','15:50:00',3.11),('8975','2013-09-05','15:55:00',3.08),('8975','2013-09-05','16:00:00',2.99),('8975','2013-09-05','16:05:00',2.89),('8975','2013-09-05','16:10:00',2.83),('8975','2013-09-05','16:15:00',2.73),('8975','2013-09-05','16:20:00',2.61),('8975','2013-09-05','16:25:00',2.52),('8975','2013-09-05','16:30:00',2.4),('8975','2013-09-05','16:35:00',2.31),('8975','2013-09-05','16:40:00',2.22),('8975','2013-09-05','16:45:00',2.14),('8975','2013-09-05','16:50:00',2.03),('8975','2013-09-05','16:55:00',1.92),('8975','2013-09-05','17:00:00',1.85),('8975','2013-09-05','17:05:00',1.78),('8975','2013-09-05','17:10:00',1.7),('8975','2013-09-05','17:15:00',1.61),('8975','2013-09-05','17:20:00',1.54),('8975','2013-09-05','17:25:00',1.47),('8975','2013-09-05','17:30:00',1.42),('8975','2013-09-05','17:35:00',1.36),('8975','2013-09-05','17:40:00',1.32),('8975','2013-09-05','17:45:00',1.24),('8975','2013-09-05','17:50:00',1.18),('8975','2013-09-05','17:55:00',1.15),('8975','2013-09-05','18:00:00',1.11),('8975','2013-09-05','18:05:00',1.08),('8975','2013-09-05','18:10:00',1.02),('8975','2013-09-04','07:15:00',1.3),('8975','2013-09-04','07:20:00',1.46),('8975','2013-09-04','07:25:00',1.64),('8975','2013-09-04','07:30:00',1.77),('8975','2013-09-04','07:35:00',1.93),('8975','2013-09-04','07:40:00',1.89),('8975','2013-09-04','07:45:00',2.14),('8975','2013-09-04','07:50:00',2.47),('8975','2013-09-04','07:55:00',2.52),('8975','2013-09-04','08:00:00',2.53),('8975','2013-09-04','08:05:00',2.34),('8975','2013-09-04','08:10:00',2.8),('8975','2013-09-04','08:15:00',2.9),('8975','2013-09-04','08:20:00',2.98),('8975','2013-09-04','08:25:00',3.04),('8975','2013-09-04','08:30:00',3.24),('8975','2013-09-04','08:35:00',3.47),('8975','2013-09-04','08:40:00',3.2),('8975','2013-09-04','08:45:00',3.3),('8975','2013-09-04','08:50:00',3.58),('8975','2013-09-04','08:55:00',3.16),('8975','2013-09-04','09:00:00',3.61),('8975','2013-09-04','09:05:00',3.97),('8975','2013-09-04','09:10:00',4.05),('8975','2013-09-04','09:15:00',4.16),('8975','2013-09-04','09:20:00',4.25),('8975','2013-09-04','09:25:00',4.34),('8975','2013-09-04','09:30:00',4.39),('8975','2013-09-04','09:35:00',4.49),('8975','2013-09-04','09:40:00',4.57),('8975','2013-09-04','09:45:00',4.63),('8975','2013-09-04','09:50:00',4.74),('8975','2013-09-04','09:55:00',4.81),('8975','2013-09-04','10:00:00',4.86),('8975','2013-09-04','10:05:00',4.93),('8975','2013-09-04','10:10:00',4.98),('8975','2013-09-04','10:15:00',5.07),('8975','2013-09-04','10:20:00',5.13),('8975','2013-09-04','10:25:00',5.17),('8975','2013-09-04','10:30:00',5.21),('8975','2013-09-04','10:35:00',5.26),('8975','2013-09-04','10:40:00',5.31),('8975','2013-09-04','10:45:00',5.35),('8975','2013-09-04','10:50:00',5.38),('8975','2013-09-04','10:55:00',5.44),('8975','2013-09-04','11:00:00',5.49),('8975','2013-09-04','11:05:00',5.52),('8975','2013-09-04','11:10:00',5.56),('8975','2013-09-04','11:15:00',5.58),('8975','2013-09-04','11:20:00',5.63),('8975','2013-09-04','11:25:00',5.64),('8975','2013-09-04','11:30:00',5.66),('8975','2013-09-04','11:35:00',5.7),('8975','2013-09-04','11:40:00',5.57),('8975','2013-09-04','11:45:00',5.68),('8975','2013-09-04','11:50:00',5.74),('8975','2013-09-04','11:55:00',5.73),('8975','2013-09-04','12:00:00',5.68),('8975','2013-09-04','12:05:00',5.71),('8975','2013-09-04','12:10:00',5.72),('8975','2013-09-04','12:15:00',5.71),('8975','2013-09-04','12:20:00',5.72),('8975','2013-09-04','12:25:00',5.72),('8975','2013-09-04','12:30:00',5.73),('8975','2013-09-04','12:35:00',5.73),('8975','2013-09-04','12:40:00',5.68),('8975','2013-09-04','12:45:00',5.66),('8975','2013-09-04','12:50:00',5.67),('8975','2013-09-04','12:55:00',5.67),('8975','2013-09-04','13:00:00',5.6),('8975','2013-09-04','13:05:00',5.64),('8975','2013-09-04','13:10:00',5.59),('8975','2013-09-04','13:15:00',5.57),('8975','2013-09-04','13:20:00',5.53),('8975','2013-09-04','13:25:00',5.49),('8975','2013-09-04','13:30:00',5.47),('8975','2013-09-04','13:35:00',5.44),('8975','2013-09-04','13:40:00',5.43),('8975','2013-09-04','13:45:00',5.38),('8975','2013-09-04','13:50:00',5.29),('8975','2013-09-04','13:55:00',5.22),('8975','2013-09-04','14:00:00',5.14),('8975','2013-09-04','14:05:00',5.1),('8975','2013-09-04','14:10:00',5.03),('8975','2013-09-04','14:15:00',4.91),('8975','2013-09-04','14:20:00',4.86),('8975','2013-09-04','14:25:00',4.85),('8975','2013-09-04','14:30:00',4.77),('8975','2013-09-04','14:35:00',4.66),('8975','2013-09-04','14:40:00',4.61),('8975','2013-09-04','14:45:00',4.51),('8975','2013-09-04','14:50:00',4.42),('8975','2013-09-04','14:55:00',4.37),('8975','2013-09-04','15:00:00',4.32),('8975','2013-09-04','15:05:00',4.25),('8975','2013-09-04','15:10:00',4.06),('8975','2013-09-04','15:15:00',3.89),('8975','2013-09-04','15:20:00',3.81),('8975','2013-09-04','15:25:00',3.64),('8975','2013-09-04','15:30:00',3.56),('8975','2013-09-04','15:35:00',3.54),('8975','2013-09-04','15:40:00',3.48),('8975','2013-09-04','15:45:00',3.35),('8975','2013-09-04','15:50:00',3.25),('8975','2013-09-04','15:55:00',3.15),('8975','2013-09-04','16:00:00',3.07),('8975','2013-09-04','16:05:00',3.01),('8975','2013-09-04','16:10:00',2.9),('8975','2013-09-04','16:15:00',2.78),('8975','2013-09-04','16:20:00',2.7),('8975','2013-09-04','16:25:00',2.61),('8975','2013-09-04','16:30:00',2.53),('8975','2013-09-04','16:35:00',2.44),('8975','2013-09-04','16:40:00',2.37),('8975','2013-09-04','16:45:00',2.22),('8975','2013-09-04','16:50:00',1.78),('8975','2013-09-04','16:55:00',1.36),('8975','2013-09-04','17:00:00',1.34),('8975','2013-09-04','17:05:00',1.5),('8975','2013-09-04','17:10:00',1.4),('8975','2013-09-04','17:15:00',1.42),('8975','2013-09-04','17:20:00',1.47),('8975','2013-09-04','17:25:00',1.52),('8975','2013-09-04','17:30:00',1.57),('8975','2013-09-04','17:35:00',1.7),('8975','2013-09-04','17:40:00',1.73),('8975','2013-09-04','17:45:00',1.46),('8975','2013-09-04','17:50:00',1.38),('8975','2013-09-04','17:55:00',1.16),('8975','2013-09-04','18:00:00',1),('8975','2013-09-04','18:15:00',1.04),('8975','2013-09-04','18:20:00',1.04),('8975','2013-09-03','07:15:00',1.27),('8975','2013-09-03','07:20:00',1.4),('8975','2013-09-03','07:25:00',1.61),('8975','2013-09-03','07:30:00',1.71),('8975','2013-09-03','07:35:00',1.75),('8975','2013-09-03','07:40:00',2.09),('8975','2013-09-03','07:45:00',2.34),('8975','2013-09-03','07:50:00',2.51),('8975','2013-09-03','07:55:00',2.66),('8975','2013-09-03','08:00:00',2.79),('8975','2013-09-03','08:05:00',2.92),('8975','2013-09-03','08:10:00',3.03),('8975','2013-09-03','08:15:00',3.14),('8975','2013-09-03','08:20:00',3.23),('8975','2013-09-03','08:25:00',3.33),('8975','2013-09-03','08:30:00',3.42),('8975','2013-09-03','08:35:00',3.52),('8975','2013-09-03','08:40:00',3.61),('8975','2013-09-03','08:45:00',3.71),('8975','2013-09-03','08:50:00',3.8),('8975','2013-09-03','08:55:00',3.9),('8975','2013-09-03','09:00:00',4),('8975','2013-09-03','09:05:00',4.12),('8975','2013-09-03','09:10:00',4.22),('8975','2013-09-03','09:15:00',4.34),('8975','2013-09-03','09:20:00',4.43),('8975','2013-09-03','09:25:00',4.53),('8975','2013-09-03','09:30:00',4.63),('8975','2013-09-03','09:35:00',4.72),('8975','2013-09-03','09:40:00',4.8),('8975','2013-09-03','09:45:00',4.9),('8975','2013-09-03','09:50:00',4.99),('8975','2013-09-03','09:55:00',5.09),('8975','2013-09-03','10:00:00',5.14),('8975','2013-09-03','10:05:00',5.25),('8975','2013-09-03','10:10:00',5.29),('8975','2013-09-03','10:15:00',5.36),('8975','2013-09-03','10:20:00',5.43),('8975','2013-09-03','10:25:00',5.47),('8975','2013-09-03','10:30:00',5.52),('8975','2013-09-03','10:35:00',5.56),('8975','2013-09-03','10:40:00',5.64),('8975','2013-09-03','10:45:00',5.7),('8975','2013-09-03','10:50:00',5.74),('8975','2013-09-03','10:55:00',5.78),('8975','2013-09-03','11:00:00',5.82),('8975','2013-09-03','11:05:00',5.86),('8975','2013-09-03','11:10:00',5.88),('8975','2013-09-03','11:15:00',5.93),('8975','2013-09-03','11:20:00',5.98),('8975','2013-09-03','11:25:00',5.98),('8975','2013-09-03','11:30:00',6.03),('8975','2013-09-03','11:35:00',6.04),('8975','2013-09-03','11:40:00',6.02),('8975','2013-09-03','11:45:00',5.96),('8975','2013-09-03','11:50:00',6.02),('8975','2013-09-03','11:55:00',6.1),('8975','2013-09-03','12:00:00',6.09),('8975','2013-09-03','12:05:00',6.12),('8975','2013-09-03','12:10:00',6.11),('8975','2013-09-03','12:15:00',6.06),('8975','2013-09-03','12:20:00',6.05),('8975','2013-09-03','12:25:00',6.07),('8975','2013-09-03','12:30:00',6.07),('8975','2013-09-03','12:35:00',6.05),('8975','2013-09-03','12:40:00',6.06),('8975','2013-09-03','12:45:00',6.06),('8975','2013-09-03','12:50:00',6.03),('8975','2013-09-03','12:55:00',6),('8975','2013-09-03','13:00:00',5.97),('8975','2013-09-03','13:05:00',5.94),('8975','2013-09-03','13:10:00',5.92),('8975','2013-09-03','13:15:00',5.88),('8975','2013-09-03','13:20:00',5.85),('8975','2013-09-03','13:25:00',5.8),('8975','2013-09-03','13:30:00',5.75),('8975','2013-09-03','13:35:00',5.69),('8975','2013-09-03','13:40:00',5.64),('8975','2013-09-03','13:45:00',5.6),('8975','2013-09-03','13:50:00',5.56),('8975','2013-09-03','13:55:00',5.52),('8975','2013-09-03','14:00:00',5.45),('8975','2013-09-03','14:05:00',5.42),('8975','2013-09-03','14:10:00',5.32),('8975','2013-09-03','14:15:00',5.25),('8975','2013-09-03','14:20:00',5.13),('8975','2013-09-03','14:25:00',5.07),('8975','2013-09-03','14:30:00',4.98),('8975','2013-09-03','14:35:00',4.93),('8975','2013-09-03','14:40:00',4.88),('8975','2013-09-03','14:45:00',4.77),('8975','2013-09-03','14:50:00',4.71),('8975','2013-09-03','14:55:00',4.62),('8975','2013-09-03','15:00:00',4.49),('8975','2013-09-03','15:05:00',4.42),('8975','2013-09-03','15:10:00',4.27),('8975','2013-09-03','15:15:00',4.06),('8975','2013-09-03','15:20:00',3.96),('8975','2013-09-03','15:25:00',3.9),('8975','2013-09-03','15:30:00',3.84),('8975','2013-09-03','15:35:00',3.72),('8975','2013-09-03','15:40:00',3.61),('8975','2013-09-03','15:45:00',3.49),('8975','2013-09-03','15:50:00',3.37),('8975','2013-09-03','15:55:00',3.22),('8975','2013-09-03','16:00:00',3.09),('8975','2013-09-03','16:05:00',2.99),('8975','2013-09-03','16:10:00',2.92),('8975','2013-09-03','16:15:00',2.8),('8975','2013-09-03','16:20:00',2.7),('8975','2013-09-03','16:25:00',2.61),('8975','2013-09-03','16:30:00',2.48),('8975','2013-09-03','16:35:00',2.36),('8975','2013-09-03','16:40:00',2.27),('8975','2013-09-03','16:45:00',2.16),('8975','2013-09-03','16:50:00',2.03),('8975','2013-09-03','16:55:00',1.95),('8975','2013-09-03','17:00:00',1.85),('8975','2013-09-03','17:05:00',1.77),('8975','2013-09-03','17:10:00',1.69),('8975','2013-09-03','17:15:00',1.62),('8975','2013-09-03','17:20:00',1.54),('8975','2013-09-03','17:25:00',1.47),('8975','2013-09-03','17:30:00',1.41),('8975','2013-09-03','17:35:00',1.35),('8975','2013-09-03','17:40:00',1.3),('8975','2013-09-03','17:45:00',1.26),('8975','2013-09-03','17:50:00',1.22),('8975','2013-09-03','17:55:00',1.17),('8975','2013-09-03','18:00:00',1.12),('8975','2013-09-03','18:05:00',1.08),('8975','2013-09-03','18:10:00',1.03),('8975','2013-09-02','07:25:00',1.08),('8975','2013-09-02','07:30:00',1.25),('8975','2013-09-02','07:35:00',1.46),('8975','2013-09-02','07:40:00',1.65),('8975','2013-09-02','07:45:00',1.78),('8975','2013-09-02','07:50:00',2.03),('8975','2013-09-02','07:55:00',2.18),('8975','2013-09-02','08:00:00',2.29),('8975','2013-09-02','08:05:00',2.4),('8975','2013-09-02','08:10:00',2.53),('8975','2013-09-02','08:15:00',2.66),('8975','2013-09-02','08:20:00',2.79),('8975','2013-09-02','08:25:00',2.88),('8975','2013-09-02','08:30:00',2.97),('8975','2013-09-02','08:35:00',3.12),('8975','2013-09-02','08:40:00',3.2),('8975','2013-09-02','08:45:00',3.26),('8975','2013-09-02','08:50:00',3.41),('8975','2013-09-02','08:55:00',3.51),('8975','2013-09-02','09:00:00',3.63),('8975','2013-09-02','09:05:00',3.74),('8975','2013-09-02','09:10:00',3.85),('8975','2013-09-02','09:15:00',3.95),('8975','2013-09-02','09:20:00',4.07),('8975','2013-09-02','09:25:00',4.17),('8975','2013-09-02','09:30:00',4.25),('8975','2013-09-02','09:35:00',4.35),('8975','2013-09-02','09:40:00',4.42),('8975','2013-09-02','09:45:00',4.55),('8975','2013-09-02','09:50:00',4.61),('8975','2013-09-02','09:55:00',4.66),('8975','2013-09-02','10:00:00',4.72),('8975','2013-09-02','10:05:00',4.77),('8975','2013-09-02','10:10:00',4.84),('8975','2013-09-02','10:15:00',4.94),('8975','2013-09-02','10:20:00',5),('8975','2013-09-02','10:25:00',5.07),('8975','2013-09-02','10:30:00',5.11),('8975','2013-09-02','10:35:00',5.2),('8975','2013-09-02','10:40:00',5.26),('8975','2013-09-02','10:45:00',5.28),('8975','2013-09-02','10:50:00',5.4),('8975','2013-09-02','10:55:00',5.48),('8975','2013-09-02','11:00:00',5.54),('8975','2013-09-02','11:05:00',5.6),('8975','2013-09-02','11:10:00',5.62),('8975','2013-09-02','11:15:00',5.63),('8975','2013-09-02','11:20:00',5.69),('8975','2013-09-02','11:25:00',5.68),('8975','2013-09-02','11:30:00',5.72),('8975','2013-09-02','11:35:00',5.72),('8975','2013-09-02','11:40:00',5.72),('8975','2013-09-02','11:45:00',5.7),('8975','2013-09-02','11:50:00',5.82),('8975','2013-09-02','11:55:00',5.87),('8975','2013-09-02','12:00:00',5.88),('8975','2013-09-02','12:05:00',5.91),('8975','2013-09-02','12:10:00',5.94),('8975','2013-09-02','12:15:00',5.99),('8975','2013-09-02','12:20:00',5.95),('8975','2013-09-02','12:25:00',5.96),('8975','2013-09-02','12:30:00',5.96),('8975','2013-09-02','12:35:00',5.93),('8975','2013-09-02','12:40:00',5.9),('8975','2013-09-02','12:45:00',5.92),('8975','2013-09-02','12:50:00',5.89),('8975','2013-09-02','12:55:00',5.82),('8975','2013-09-02','13:00:00',5.78),('8975','2013-09-02','13:05:00',5.76),('8975','2013-09-02','13:10:00',5.8),('8975','2013-09-02','13:15:00',5.79),('8975','2013-09-02','13:20:00',5.74),('8975','2013-09-02','13:25:00',5.65),('8975','2013-09-02','13:30:00',5.62),('8975','2013-09-02','13:35:00',5.59),('8975','2013-09-02','13:40:00',5.51),('8975','2013-09-02','13:45:00',5.44),('8975','2013-09-02','13:50:00',5.4),('8975','2013-09-02','13:55:00',5.36),('8975','2013-09-02','14:00:00',5.29),('8975','2013-09-02','14:05:00',5.18),('8975','2013-09-02','14:10:00',5.14),('8975','2013-09-02','14:15:00',5.03),('8975','2013-09-02','14:20:00',4.88),('8975','2013-09-02','14:25:00',4.96),('8975','2013-09-02','14:30:00',4.88),('8975','2013-09-02','14:35:00',4.83),('8975','2013-09-02','14:40:00',4.78),('8975','2013-09-02','14:45:00',4.68),('8975','2013-09-02','14:50:00',4.61),('8975','2013-09-02','14:55:00',4.53),('8975','2013-09-02','15:00:00',4.44),('8975','2013-09-02','15:05:00',4.34),('8975','2013-09-02','15:10:00',4.23),('8975','2013-09-02','15:15:00',3.97),('8975','2013-09-02','15:20:00',3.81),('8975','2013-09-02','15:25:00',3.67),('8975','2013-09-02','15:30:00',3.8),('8975','2013-09-02','15:35:00',3.69),('8975','2013-09-02','15:40:00',3.58),('8975','2013-09-02','15:45:00',3.46),('8975','2013-09-02','15:50:00',3.32),('8975','2013-09-02','15:55:00',3.22),('8975','2013-09-02','16:00:00',3.1),('8975','2013-09-02','16:05:00',2.99),('8975','2013-09-02','16:10:00',2.93),('8975','2013-09-02','16:15:00',2.83),('8975','2013-09-02','16:20:00',2.71),('8975','2013-09-02','16:25:00',2.61),('8975','2013-09-02','16:30:00',2.49),('8975','2013-09-02','16:35:00',2.39),('8975','2013-09-02','16:40:00',2.29),('8975','2013-09-02','16:45:00',2.17),('8975','2013-09-02','16:50:00',2.06),('8975','2013-09-02','16:55:00',1.96),('8975','2013-09-02','17:00:00',1.88),('8975','2013-09-02','17:05:00',1.79),('8975','2013-09-02','17:10:00',1.71),('8975','2013-09-02','17:15:00',1.63),('8975','2013-09-02','17:20:00',1.55),('8975','2013-09-02','17:25:00',1.48),('8975','2013-09-02','17:30:00',1.42),('8975','2013-09-02','17:35:00',1.36),('8975','2013-09-02','17:40:00',1.32),('8975','2013-09-02','17:45:00',1.28),('8975','2013-09-02','17:50:00',1.23),('8975','2013-09-02','17:55:00',1.1),('8975','2013-09-02','18:00:00',1.01),('8975','2013-09-01','07:20:00',1.05),('8975','2013-09-01','07:25:00',1.14),('8975','2013-09-01','07:30:00',1.39),('8975','2013-09-01','07:35:00',1.55),('8975','2013-09-01','07:40:00',1.6),('8975','2013-09-01','07:45:00',1.91),('8975','2013-09-01','07:50:00',2.11),('8975','2013-09-01','07:55:00',2.23),('8975','2013-09-01','08:00:00',2.36),('8975','2013-09-01','08:05:00',2.51),('8975','2013-09-01','08:10:00',2.62),('8975','2013-09-01','08:15:00',2.75),('8975','2013-09-01','08:20:00',2.89),('8975','2013-09-01','08:25:00',3),('8975','2013-09-01','08:30:00',3.09),('8975','2013-09-01','08:35:00',3.22),('8975','2013-09-01','08:40:00',3.34),('8975','2013-09-01','08:45:00',3.41),('8975','2013-09-01','08:50:00',3.53),('8975','2013-09-01','08:55:00',3.64),('8975','2013-09-01','09:00:00',3.73),('8975','2013-09-01','09:05:00',3.86),('8975','2013-09-01','09:10:00',3.97),('8975','2013-09-01','09:15:00',4.07),('8975','2013-09-01','09:20:00',4.16),('8975','2013-09-01','09:25:00',4.24),('8975','2013-09-01','09:30:00',4.34),('8975','2013-09-01','09:35:00',4.43),('8975','2013-09-01','09:40:00',4.52),('8975','2013-09-01','09:45:00',4.63),('8975','2013-09-01','09:50:00',4.73),('8975','2013-09-01','09:55:00',4.79),('8975','2013-09-01','10:00:00',4.85),('8975','2013-09-01','10:05:00',4.95),('8975','2013-09-01','10:10:00',5.04),('8975','2013-09-01','10:15:00',5.09),('8975','2013-09-01','10:20:00',5.17),('8975','2013-09-01','10:25:00',5.21),('8975','2013-09-01','10:30:00',5.3),('8975','2013-09-01','10:35:00',5.35),('8975','2013-09-01','10:40:00',5.39),('8975','2013-09-01','10:45:00',5.45),('8975','2013-09-01','10:50:00',5.47),('8975','2013-09-01','10:55:00',5.52),('8975','2013-09-01','11:00:00',5.52),('8975','2013-09-01','11:05:00',5.56),('8975','2013-09-01','11:10:00',5.61),('8975','2013-09-01','11:15:00',5.65),('8975','2013-09-01','11:20:00',5.7),('8975','2013-09-01','11:25:00',5.71),('8975','2013-09-01','11:30:00',5.73),('8975','2013-09-01','11:35:00',5.73),('8975','2013-09-01','11:40:00',5.74),('8975','2013-09-01','11:45:00',5.7),('8975','2013-09-01','11:50:00',5.74),('8975','2013-09-01','11:55:00',5.8),('8975','2013-09-01','12:00:00',5.84),('8975','2013-09-01','12:05:00',5.82),('8975','2013-09-01','12:10:00',5.82),('8975','2013-09-01','12:15:00',5.78),('8975','2013-09-01','12:20:00',5.84),('8975','2013-09-01','12:25:00',5.84),('8975','2013-09-01','12:30:00',5.84),('8975','2013-09-01','12:35:00',5.86),('8975','2013-09-01','12:40:00',5.82),('8975','2013-09-01','12:45:00',5.76),('8975','2013-09-01','12:50:00',5.75),('8975','2013-09-01','12:55:00',5.73),('8975','2013-09-01','13:00:00',5.68),('8975','2013-09-01','13:05:00',5.64),('8975','2013-09-01','13:10:00',5.61),('8975','2013-09-01','13:15:00',5.58),('8975','2013-09-01','13:20:00',5.5),('8975','2013-09-01','13:25:00',5.57),('8975','2013-09-01','13:30:00',5.59),('8975','2013-09-01','13:35:00',5.54),('8975','2013-09-01','13:40:00',5.44),('8975','2013-09-01','13:45:00',5.41),('8975','2013-09-01','13:50:00',5.61),('8975','2013-09-01','13:55:00',5.51),('8975','2013-09-01','14:00:00',3.9),('8975','2013-09-01','14:10:00',2.59),('8975','2013-09-01','14:15:00',5.39),('8975','2013-09-01','14:20:00',5.33),('8975','2013-09-01','14:25:00',5.08),('8975','2013-09-01','14:30:00',2.67),('8975','2013-09-01','14:35:00',1.97),('8975','2013-09-01','14:40:00',4.09),('8975','2013-09-01','14:45:00',5.05),('8975','2013-09-01','14:50:00',4.94),('8975','2013-09-01','14:55:00',4.99),('8975','2013-09-01','15:00:00',4.69),('8975','2013-09-01','15:05:00',4.65),('8975','2013-09-01','15:10:00',4.48),('8975','2013-09-01','15:15:00',4.01),('8975','2013-09-01','15:20:00',4.24),('8975','2013-09-01','15:25:00',3.25),('8975','2013-09-01','15:30:00',3.91),('8975','2013-09-01','15:35:00',3.95),('8975','2013-09-01','15:40:00',3.78),('8975','2013-09-01','15:45:00',3.74),('8975','2013-09-01','15:50:00',3.59),('8975','2013-09-01','15:55:00',3.48),('8975','2013-09-01','16:00:00',3.36),('8975','2013-09-01','16:05:00',3.25),('8975','2013-09-01','16:10:00',3.09),('8975','2013-09-01','16:15:00',2.99),('8975','2013-09-01','16:20:00',2.93),('8975','2013-09-01','16:25:00',2.76),('8975','2013-09-01','16:30:00',2.66),('8975','2013-09-01','16:35:00',2.58),('8975','2013-09-01','16:40:00',2.43),('8975','2013-09-01','16:45:00',2.28),('8975','2013-09-01','16:50:00',2.18),('8975','2013-09-01','16:55:00',2.04),('8975','2013-09-01','17:00:00',1.92),('8975','2013-09-01','17:05:00',1.84),('8975','2013-09-01','17:10:00',1.76),('8975','2013-09-01','17:15:00',1.68),('8975','2013-09-01','17:20:00',1.62),('8975','2013-09-01','17:25:00',1.55),('8975','2013-09-01','17:30:00',1.48),('8975','2013-09-01','17:35:00',1.4),('8975','2013-09-01','17:40:00',1.33),('8975','2013-09-01','17:45:00',1.3),('8975','2013-09-01','17:50:00',1.27),('8975','2013-09-01','17:55:00',1.22),('8975','2013-09-01','18:00:00',1.16),('8975','2013-09-01','18:05:00',1.11),('8975','2013-09-01','18:10:00',1.06),('8975','2013-09-01','18:15:00',1),('8975','2013-08-31','07:15:00',1.08),('8975','2013-08-31','07:20:00',1.28),('8975','2013-08-31','07:25:00',1.44),('8975','2013-08-31','07:30:00',1.63),('8975','2013-08-31','07:35:00',1.66),('8975','2013-08-31','07:40:00',1.86),('8975','2013-08-31','07:45:00',2.15),('8975','2013-08-31','07:50:00',2.34),('8975','2013-08-31','07:55:00',2.49),('8975','2013-08-31','08:00:00',2.63),('8975','2013-08-31','08:05:00',2.74),('8975','2013-08-31','08:10:00',2.87),('8975','2013-08-31','08:15:00',2.95),('8975','2013-08-31','08:20:00',3.03),('8975','2013-08-31','08:25:00',2.59),('8975','2013-08-31','08:30:00',2.87),('8975','2013-08-31','08:35:00',3.37),('8975','2013-08-31','08:40:00',3.47),('8975','2013-08-31','08:45:00',3.56),('8975','2013-08-31','08:50:00',3.65),('8975','2013-08-31','08:55:00',3.7),('8975','2013-08-31','09:00:00',3.78),('8975','2013-08-31','09:05:00',3.93),('8975','2013-08-31','09:10:00',4.08),('8975','2013-08-31','09:15:00',4.17),('8975','2013-08-31','09:20:00',4.26),('8975','2013-08-31','09:25:00',4.37),('8975','2013-08-31','09:30:00',4.43),('8975','2013-08-31','09:35:00',4.52),('8975','2013-08-31','09:40:00',4.55),('8975','2013-08-31','09:45:00',4.65),('8975','2013-08-31','09:50:00',4.74),('8975','2013-08-31','09:55:00',4.8),('8975','2013-08-31','10:00:00',4.85),('8975','2013-08-31','10:05:00',4.94),('8975','2013-08-31','10:10:00',5.02),('8975','2013-08-31','10:15:00',5.05),('8975','2013-08-31','10:20:00',5.12),('8975','2013-08-31','10:25:00',5.24),('8975','2013-08-31','10:30:00',5.32),('8975','2013-08-31','10:35:00',5.38),('8975','2013-08-31','10:40:00',5.43),('8975','2013-08-31','10:45:00',5.47),('8975','2013-08-31','10:50:00',5.5),('8975','2013-08-31','10:55:00',5.56),('8975','2013-08-31','11:00:00',5.59),('8975','2013-08-31','11:05:00',5.62),('8975','2013-08-31','11:10:00',5.65),('8975','2013-08-31','11:15:00',5.66),('8975','2013-08-31','11:20:00',5.67),('8975','2013-08-31','11:25:00',5.73),('8975','2013-08-31','11:30:00',5.76),('8975','2013-08-31','11:35:00',5.85),('8975','2013-08-31','11:40:00',5.85),('8975','2013-08-31','11:45:00',5.89),('8975','2013-08-31','11:50:00',5.89),('8975','2013-08-31','11:55:00',5.86),('8975','2013-08-31','12:00:00',5.73),('8975','2013-08-31','12:05:00',5.59),('8975','2013-08-31','12:10:00',5.73),('8975','2013-08-31','12:15:00',5.83),('8975','2013-08-31','12:20:00',5.8),('8975','2013-08-31','12:25:00',5.71),('8975','2013-08-31','12:30:00',5.8),('8975','2013-08-31','12:35:00',5.81),('8975','2013-08-31','12:40:00',5.22),('8975','2013-08-31','12:45:00',5.67),('8975','2013-08-31','12:50:00',5.81),('8975','2013-08-31','12:55:00',5.79),('8975','2013-08-31','13:00:00',5.8),('8975','2013-08-31','13:05:00',5.87),('8975','2013-08-31','13:10:00',5.44),('8975','2013-08-31','13:15:00',4.59),('8975','2013-08-31','13:20:00',5.95),('8975','2013-08-31','13:25:00',5.82),('8975','2013-08-31','13:30:00',5.76),('8975','2013-08-31','13:35:00',5.62),('8975','2013-08-31','13:40:00',5.66),('8975','2013-08-31','13:45:00',5.51),('8975','2013-08-31','13:50:00',5.07),('8975','2013-08-31','13:55:00',4.42),('8975','2013-08-31','14:00:00',4.11),('8975','2013-08-31','14:05:00',4.09),('8975','2013-08-31','14:10:00',4.99),('8975','2013-08-31','14:15:00',4.75),('8975','2013-08-31','14:20:00',4.65),('8975','2013-08-31','14:25:00',4.5),('8975','2013-08-31','14:30:00',4.62),('8975','2013-08-31','14:35:00',4.62),('8975','2013-08-31','14:40:00',4.47),('8975','2013-08-31','14:45:00',4.47),('8975','2013-08-31','14:50:00',4.38),('8975','2013-08-31','14:55:00',4.35),('8975','2013-08-31','15:00:00',4.28),('8975','2013-08-31','15:05:00',4.15),('8975','2013-08-31','15:10:00',3.97),('8975','2013-08-31','15:15:00',3.79),('8975','2013-08-31','15:20:00',3.21),('8975','2013-08-31','15:25:00',2.89),('8975','2013-08-31','15:30:00',2.68),('8975','2013-08-31','15:35:00',2.96),('8975','2013-08-31','15:40:00',3.17),('8975','2013-08-31','15:45:00',2.83),('8975','2013-08-31','15:50:00',2.88),('8975','2013-08-31','15:55:00',3.22),('8975','2013-08-31','16:00:00',3.39),('8975','2013-08-31','16:05:00',3.45),('8975','2013-08-31','16:10:00',3.27),('8975','2013-08-31','16:15:00',3.21),('8975','2013-08-31','16:20:00',2.78),('8975','2013-08-31','16:25:00',3.09),('8975','2013-08-31','16:30:00',3.03),('8975','2013-08-31','16:35:00',2.87),('8975','2013-08-31','16:40:00',2.74),('8975','2013-08-31','16:45:00',2.51),('8975','2013-08-31','16:50:00',2.38),('8975','2013-08-31','16:55:00',2.23),('8975','2013-08-31','17:00:00',2.09),('8975','2013-08-31','17:05:00',2.04),('8975','2013-08-31','17:10:00',1.77),('8975','2013-08-31','17:15:00',1.67),('8975','2013-08-31','17:20:00',1.76),('8975','2013-08-31','17:25:00',1.68),('8975','2013-08-31','17:30:00',1.65),('8975','2013-08-31','17:35:00',1.58),('8975','2013-08-31','17:40:00',1.45),('8975','2013-08-31','17:45:00',1.31),('8975','2013-08-31','17:50:00',1.18),('8975','2013-08-31','17:55:00',1.22),('8975','2013-08-31','18:00:00',1.23),('8975','2013-08-31','18:05:00',1.19),('8975','2013-08-31','18:10:00',1.34),('8975','2013-08-31','18:15:00',1.35),('8975','2013-08-31','18:20:00',1.25),('8975','2013-08-31','18:25:00',1.09),('8975','2013-08-31','18:30:00',1.07),('8975','2013-08-31','18:40:00',1.06),('8975','2013-08-30','07:15:00',1.24),('8975','2013-08-30','07:20:00',1.49),('8975','2013-08-30','07:25:00',1.6),('8975','2013-08-30','07:30:00',1.41),('8975','2013-08-30','07:35:00',1.05),('8975','2013-08-30','07:45:00',1.04),('8975','2013-08-30','07:50:00',1.43),('8975','2013-08-30','07:55:00',1.46),('8975','2013-08-30','08:00:00',1.39),('8975','2013-08-30','08:05:00',1.42),('8975','2013-08-30','08:10:00',1.08),('8975','2013-08-30','08:15:00',1.48),('8975','2013-08-30','08:20:00',2.31),('8975','2013-08-30','08:25:00',2.82),('8975','2013-08-30','08:30:00',3.35),('8975','2013-08-30','08:35:00',3.43),('8975','2013-08-30','08:40:00',3.6),('8975','2013-08-30','08:45:00',3.75),('8975','2013-08-30','08:50:00',3.95),('8975','2013-08-30','08:55:00',4.2),('8975','2013-08-30','09:00:00',4.33),('8975','2013-08-30','09:05:00',3.96),('8975','2013-08-30','09:10:00',3.56),('8975','2013-08-30','09:15:00',3.72),('8975','2013-08-30','09:20:00',3.95),('8975','2013-08-30','09:25:00',4.64),('8975','2013-08-30','09:30:00',4.67),('8975','2013-08-30','09:35:00',4.86),('8975','2013-08-30','09:40:00',4.88),('8975','2013-08-30','09:45:00',4.67),('8975','2013-08-30','09:50:00',4.75),('8975','2013-08-30','09:55:00',4.89),('8975','2013-08-30','10:00:00',5.26),('8975','2013-08-30','10:05:00',5.03),('8975','2013-08-30','10:10:00',5.17),('8975','2013-08-30','10:15:00',5.26),('8975','2013-08-30','10:20:00',5.31),('8975','2013-08-30','10:25:00',5.33),('8975','2013-08-30','10:30:00',5.43),('8975','2013-08-30','10:35:00',5.63),('8975','2013-08-30','10:40:00',5.68),('8975','2013-08-30','10:45:00',5.69),('8975','2013-08-30','10:50:00',5.85),('8975','2013-08-30','10:55:00',5.87),('8975','2013-08-30','11:00:00',6),('8975','2013-08-30','11:05:00',6.06),('8975','2013-08-30','11:10:00',6.09),('8975','2013-08-30','11:15:00',6.11),('8975','2013-08-30','11:20:00',5.75),('8975','2013-08-30','11:25:00',4.93),('8975','2013-08-30','11:30:00',5.82),('8975','2013-08-30','11:35:00',5.68),('8975','2013-08-30','11:40:00',6.19),('8975','2013-08-30','11:45:00',5.83),('8975','2013-08-30','11:50:00',5.98),('8975','2013-08-30','11:55:00',5.36),('8975','2013-08-30','12:00:00',5.38),('8975','2013-08-30','12:05:00',5.53),('8975','2013-08-30','12:10:00',5.89),('8975','2013-08-30','12:15:00',5.72),('8975','2013-08-30','12:20:00',6.13),('8975','2013-08-30','12:25:00',6.09),('8975','2013-08-30','12:30:00',6.03),('8975','2013-08-30','12:35:00',5.91),('8975','2013-08-30','12:40:00',5.94),('8975','2013-08-30','12:45:00',6.02),('8975','2013-08-30','12:50:00',5.99),('8975','2013-08-30','12:55:00',6),('8975','2013-08-30','13:00:00',5.98),('8975','2013-08-30','13:05:00',6.02),('8975','2013-08-30','13:10:00',5.92),('8975','2013-08-30','13:15:00',5.9),('8975','2013-08-30','13:20:00',5.86),('8975','2013-08-30','13:25:00',5.83),('8975','2013-08-30','13:30:00',5.8),('8975','2013-08-30','13:35:00',5.64),('8975','2013-08-30','13:40:00',5.63),('8975','2013-08-30','13:45:00',5.55),('8975','2013-08-30','13:50:00',5.56),('8975','2013-08-30','13:55:00',5.51),('8975','2013-08-30','14:00:00',5.46),('8975','2013-08-30','14:05:00',5.43),('8975','2013-08-30','14:10:00',5.33),('8975','2013-08-30','14:15:00',5.27),('8975','2013-08-30','14:20:00',5.21),('8975','2013-08-30','14:25:00',5.14),('8975','2013-08-30','14:30:00',5.04),('8975','2013-08-30','14:35:00',4.8),('8975','2013-08-30','14:40:00',4.8),('8975','2013-08-30','14:45:00',4.75),('8975','2013-08-30','14:50:00',4.69),('8975','2013-08-30','14:55:00',4.54),('8975','2013-08-30','15:00:00',4.54),('8975','2013-08-30','15:05:00',4.43),('8975','2013-08-30','15:10:00',4.27),('8975','2013-08-30','15:15:00',4.17),('8975','2013-08-30','15:20:00',3.99),('8975','2013-08-30','15:25:00',3.9),('8975','2013-08-30','15:30:00',3.67),('8975','2013-08-30','15:35:00',3.6),('8975','2013-08-30','15:40:00',3.7),('8975','2013-08-30','15:45:00',3.59),('8975','2013-08-30','15:50:00',3.47),('8975','2013-08-30','15:55:00',3.3),('8975','2013-08-30','16:00:00',3.17),('8975','2013-08-30','16:05:00',3.11),('8975','2013-08-30','16:10:00',2.99),('8975','2013-08-30','16:15:00',2.91),('8975','2013-08-30','16:20:00',2.85),('8975','2013-08-30','16:25:00',2.71),('8975','2013-08-30','16:30:00',2.61),('8975','2013-08-30','16:35:00',2.55),('8975','2013-08-30','16:40:00',2.45),('8975','2013-08-30','16:45:00',2.3),('8975','2013-08-30','16:50:00',2.14),('8975','2013-08-30','16:55:00',2.05),('8975','2013-08-30','17:00:00',1.91),('8975','2013-08-30','17:05:00',1.87),('8975','2013-08-30','17:10:00',1.83),('8975','2013-08-30','17:15:00',1.73),('8975','2013-08-30','17:20:00',1.67),('8975','2013-08-30','17:25:00',1.6),('8975','2013-08-30','17:30:00',1.53),('8975','2013-08-30','17:35:00',1.43),('8975','2013-08-30','17:40:00',1.38),('8975','2013-08-30','17:45:00',1.36),('8975','2013-08-30','17:50:00',1.25),('8975','2013-08-30','17:55:00',1.15),('8975','2013-08-30','18:10:00',1.12),('8975','2013-08-29','07:15:00',1.07),('8975','2013-08-29','07:20:00',1.43),('8975','2013-08-29','07:25:00',1.47),('8975','2013-08-29','07:30:00',1.71),('8975','2013-08-29','07:35:00',2),('8975','2013-08-29','07:40:00',2.09),('8975','2013-08-29','07:45:00',2.22),('8975','2013-08-29','07:50:00',2.26),('8975','2013-08-29','07:55:00',2.28),('8975','2013-08-29','08:00:00',2.47),('8975','2013-08-29','08:05:00',2.9),('8975','2013-08-29','08:10:00',3.12),('8975','2013-08-29','08:15:00',2.9),('8975','2013-08-29','08:20:00',2.97),('8975','2013-08-29','08:25:00',2.85),('8975','2013-08-29','08:30:00',2.94),('8975','2013-08-29','08:35:00',2.85),('8975','2013-08-29','08:40:00',3.03),('8975','2013-08-29','08:45:00',2.68),('8975','2013-08-29','08:50:00',2.38),('8975','2013-08-29','08:55:00',2.29),('8975','2013-08-29','09:00:00',2.57),('8975','2013-08-29','09:05:00',2.92),('8975','2013-08-29','09:10:00',2.54),('8975','2013-08-29','09:15:00',2.36),('8975','2013-08-29','09:20:00',2.08),('8975','2013-08-29','09:25:00',2.15),('8975','2013-08-29','09:30:00',2.74),('8975','2013-08-29','09:35:00',3.03),('8975','2013-08-29','09:40:00',2.89),('8975','2013-08-29','09:45:00',3.13),('8975','2013-08-29','09:50:00',3.06),('8975','2013-08-29','09:55:00',3.31),('8975','2013-08-29','10:00:00',3.25),('8975','2013-08-29','10:05:00',3.32),('8975','2013-08-29','10:10:00',3.18),('8975','2013-08-29','10:15:00',3.36),('8975','2013-08-29','10:20:00',3.67),('8975','2013-08-29','10:25:00',3.33),('8975','2013-08-29','10:30:00',3.6),('8975','2013-08-29','10:35:00',3.49),('8975','2013-08-29','10:40:00',3.23),('8975','2013-08-29','10:45:00',3.17),('8975','2013-08-29','10:50:00',3.33),('8975','2013-08-29','10:55:00',3.18),('8975','2013-08-29','11:00:00',3.37),('8975','2013-08-29','11:05:00',3.54),('8975','2013-08-29','11:10:00',3.7),('8975','2013-08-29','11:15:00',3.65),('8975','2013-08-29','11:20:00',3.71),('8975','2013-08-29','11:25:00',3.77),('8975','2013-08-29','11:30:00',4.09),('8975','2013-08-29','11:35:00',3.8),('8975','2013-08-29','11:40:00',4.14),('8975','2013-08-29','11:45:00',4.26),('8975','2013-08-29','11:50:00',4.56),('8975','2013-08-29','11:55:00',4.2),('8975','2013-08-29','12:00:00',3.81),('8975','2013-08-29','12:05:00',3.27),('8975','2013-08-29','12:10:00',3.42),('8975','2013-08-29','12:15:00',3.87),('8975','2013-08-29','12:20:00',4.21),('8975','2013-08-29','12:25:00',4.57),('8975','2013-08-29','12:30:00',5.12),('8975','2013-08-29','12:35:00',4.43),('8975','2013-08-29','12:40:00',4.52),('8975','2013-08-29','12:45:00',4.74),('8975','2013-08-29','12:50:00',4.75),('8975','2013-08-29','12:55:00',4.47),('8975','2013-08-29','13:00:00',4.35),('8975','2013-08-29','13:05:00',4.36),('8975','2013-08-29','13:10:00',4.18),('8975','2013-08-29','13:15:00',4),('8975','2013-08-29','13:20:00',4.85),('8975','2013-08-29','13:25:00',5.83),('8975','2013-08-29','13:30:00',5.79),('8975','2013-08-29','13:35:00',5.39),('8975','2013-08-29','13:40:00',5.62),('8975','2013-08-29','13:45:00',4.84),('8975','2013-08-29','13:50:00',4.95),('8975','2013-08-29','13:55:00',5.59),('8975','2013-08-29','14:00:00',5.56),('8975','2013-08-29','14:05:00',5.42),('8975','2013-08-29','14:10:00',5.46),('8975','2013-08-29','14:15:00',5.37),('8975','2013-08-29','14:20:00',5.3),('8975','2013-08-29','14:25:00',5.31),('8975','2013-08-29','14:30:00',5.15),('8975','2013-08-29','14:35:00',5.19),('8975','2013-08-29','14:40:00',4.96),('8975','2013-08-29','14:45:00',3.63),('8975','2013-08-29','14:50:00',3.16),('8975','2013-08-29','14:55:00',3.71),('8975','2013-08-29','15:00:00',3.33),('8975','2013-08-29','15:05:00',3.25),('8975','2013-08-29','15:10:00',3.24),('8975','2013-08-29','15:15:00',3.81),('8975','2013-08-29','15:20:00',3.22),('8975','2013-08-29','15:25:00',2.89),('8975','2013-08-29','15:30:00',2.98),('8975','2013-08-29','15:35:00',2.48),('8975','2013-08-29','15:40:00',2.58),('8975','2013-08-29','15:45:00',2.8),('8975','2013-08-29','15:50:00',3.11),('8975','2013-08-29','15:55:00',3.16),('8975','2013-08-29','16:00:00',2.91),('8975','2013-08-29','16:05:00',2.61),('8975','2013-08-29','16:10:00',2.29),('8975','2013-08-29','16:15:00',2.05),('8975','2013-08-29','16:20:00',2.02),('8975','2013-08-29','16:25:00',1.8),('8975','2013-08-29','16:30:00',1.92),('8975','2013-08-29','16:35:00',2.46),('8975','2013-08-29','16:40:00',2.66),('8975','2013-08-29','16:45:00',2.62),('8975','2013-08-29','16:50:00',2.54),('8975','2013-08-29','16:55:00',2.44),('8975','2013-08-29','17:00:00',2.52),('8975','2013-08-29','17:05:00',2.63),('8975','2013-08-29','17:10:00',1.93),('8975','2013-08-29','17:15:00',1.5),('8975','2013-08-29','17:20:00',1.39),('8975','2013-08-29','17:25:00',1.38),('8975','2013-08-29','17:30:00',1.57),('8975','2013-08-29','17:35:00',1.73),('8975','2013-08-29','17:40:00',1.96),('8975','2013-08-29','17:45:00',1.7),('8975','2013-08-29','17:50:00',1.67),('8975','2013-08-29','17:55:00',1.47),('8975','2014-04-10','07:40:00',1.33),('8975','2014-04-10','07:45:00',2.17),('8975','2014-04-10','07:50:00',2.47),('8975','2014-04-10','07:55:00',2.66),('8975','2014-04-10','08:00:00',1.32),('8975','2014-04-10','08:15:00',1.03),('8975','2014-04-10','08:25:00',1.12),('8975','2014-04-10','08:30:00',1.03),('8975','2014-04-10','08:35:00',3.84),('8975','2014-04-10','08:40:00',3.97),('8975','2014-04-10','08:45:00',4.13),('8975','2014-04-10','08:50:00',4.05),('8975','2014-04-10','08:55:00',3.99),('8975','2014-04-10','09:00:00',3.71),('8975','2014-04-10','09:05:00',4.04),('8975','2014-04-10','09:10:00',4.23),('8975','2014-04-10','09:15:00',4.33),('8975','2014-04-10','09:20:00',4.36),('8975','2014-04-10','09:25:00',4.46),('8975','2014-04-10','09:30:00',4.53),('8975','2014-04-10','09:35:00',4.69),('8975','2014-04-10','09:40:00',4.73),('8975','2014-04-10','09:45:00',4.86),('8975','2014-04-10','09:50:00',4.91),('8975','2014-04-10','09:55:00',4.86),('8975','2014-04-10','10:00:00',5.18),('8975','2014-04-10','10:05:00',5.29),('8975','2014-04-10','10:10:00',5.36),('8975','2014-04-10','10:15:00',5.4),('8975','2014-04-10','10:20:00',5.51),('8975','2014-04-10','10:25:00',5.58),('8975','2014-04-10','10:30:00',5.69),('8975','2014-04-10','10:35:00',5.69),('8975','2014-04-10','10:40:00',5.71),('8975','2014-04-10','10:45:00',5.89),('8975','2014-04-10','10:50:00',4.26),('8975','2014-04-10','10:55:00',6.06),('8975','2014-04-10','11:00:00',6.06),('8975','2014-04-10','11:05:00',6.05),('8975','2014-04-10','11:10:00',6.09),('8975','2014-04-10','11:15:00',5.49),('8975','2014-04-10','11:20:00',6.24),('8975','2014-04-10','11:25:00',6.3),('8975','2014-04-10','11:30:00',6.39),('8975','2014-04-10','11:35:00',6.41),('8975','2014-04-10','11:40:00',6.39),('8975','2014-04-10','11:45:00',6.31),('8975','2014-04-10','11:50:00',6.89),('8975','2014-04-10','11:55:00',6.77),('8975','2014-04-10','12:00:00',6.71),('8975','2014-04-10','12:05:00',2.9),('8975','2014-04-10','12:10:00',6.56),('8975','2014-04-10','12:15:00',5.78),('8975','2014-04-10','12:20:00',6.6),('8975','2014-04-10','12:25:00',5.92),('8975','2014-04-10','12:30:00',3.81),('8975','2014-04-10','12:35:00',6.32),('8975','2014-04-10','12:40:00',6.87),('8975','2014-04-10','12:45:00',7.4),('8975','2014-04-10','12:50:00',6.46),('8975','2014-04-10','12:55:00',3.96),('8975','2014-04-10','13:00:00',6.84),('8975','2014-04-10','13:05:00',5.63),('8975','2014-04-10','13:10:00',6.24),('8975','2014-04-10','13:15:00',6.49),('8975','2014-04-10','13:20:00',6.5),('8975','2014-04-10','13:25:00',4.97),('8975','2014-04-10','13:30:00',5.29),('8975','2014-04-10','13:35:00',5.26),('8975','2014-04-10','13:40:00',5.15),('8975','2014-04-10','13:45:00',3.63),('8975','2014-04-10','13:50:00',3.35),('8975','2014-04-10','13:55:00',5.42),('8975','2014-04-10','14:00:00',5.83),('8975','2014-04-10','14:05:00',4.78),('8975','2014-04-10','14:10:00',6.43),('8975','2014-04-10','14:15:00',6),('8975','2014-04-10','14:20:00',4.93),('8975','2014-04-10','14:25:00',5.82),('8975','2014-04-10','14:30:00',5.13),('8975','2014-04-10','14:35:00',4.64),('8975','2014-04-10','14:40:00',2.36),('8975','2014-04-10','14:45:00',2.43),('8975','2014-04-10','14:50:00',5.42),('8975','2014-04-10','14:55:00',5.87),('8975','2014-04-10','15:00:00',5.77),('8975','2014-04-10','15:05:00',5.36),('8975','2014-04-10','15:10:00',5.14),('8975','2014-04-10','15:15:00',4.76),('8975','2014-04-10','15:20:00',4.59),('8975','2014-04-10','15:25:00',4.44),('8975','2014-04-10','15:30:00',2.2),('8975','2014-04-10','15:35:00',3.05),('8975','2014-04-10','15:40:00',2.74),('8975','2014-04-10','15:45:00',3.22),('8975','2014-04-10','15:50:00',3.45),('8975','2014-04-10','15:55:00',2.22),('8975','2014-04-10','16:00:00',3.81),('8975','2014-04-10','16:05:00',3.58),('8975','2014-04-10','16:10:00',3.11),('8975','2014-04-10','16:15:00',3.01),('8975','2014-04-10','16:20:00',2.94),('8975','2014-04-10','16:25:00',2.85),('8975','2014-04-10','16:30:00',1.8),('8975','2014-04-10','16:35:00',2.51),('8975','2014-04-10','16:40:00',1.68),('8975','2014-04-10','16:45:00',2.22),('8975','2014-04-10','16:50:00',2.31),('8975','2014-04-10','16:55:00',1.92),('8975','2014-04-10','17:00:00',2.06),('8975','2014-04-10','17:05:00',1.96),('8975','2014-04-10','17:10:00',1.11),('8975','2014-04-10','17:15:00',1.9),('8975','2014-04-10','17:20:00',1.87),('8975','2014-04-10','17:25:00',1.88),('8975','2014-04-10','17:30:00',1.87),('8975','2014-04-10','17:35:00',1.87),('8975','2014-04-10','17:40:00',1.82),('8975','2014-04-10','17:45:00',1.69),('8975','2014-04-10','17:50:00',1.56),('8975','2014-04-10','17:55:00',1.49),('8975','2014-04-10','18:00:00',1.42),('8975','2014-04-10','18:05:00',1.35),('8975','2014-04-10','18:10:00',1.34),('8975','2014-04-10','18:15:00',1.42),('8975','2014-04-10','18:20:00',1.42),('8975','2014-04-10','18:25:00',1.36),('8975','2014-04-10','18:30:00',1.35),('8975','2014-04-10','18:35:00',1.28),('8975','2014-04-10','18:40:00',1.1),('8975','2013-08-28','07:10:00',1.07),('8975','2013-08-28','07:15:00',1.15),('8975','2013-08-28','07:20:00',1.25),('8975','2013-08-28','07:25:00',1.51),('8975','2013-08-28','07:30:00',1.77),('8975','2013-08-28','07:35:00',2.06),('8975','2013-08-28','07:40:00',2.28),('8975','2013-08-28','07:45:00',2.43),('8975','2013-08-28','07:50:00',2.54),('8975','2013-08-28','07:55:00',2.73),('8975','2013-08-28','08:00:00',2.87),('8975','2013-08-28','08:05:00',2.94),('8975','2013-08-28','08:10:00',3.21),('8975','2013-08-28','08:15:00',3.38),('8975','2013-08-28','08:20:00',3.55),('8975','2013-08-28','08:25:00',3.81),('8975','2013-08-28','08:30:00',3.92),('8975','2013-08-28','08:35:00',3.66),('8975','2013-08-28','08:40:00',2.41),('8975','2013-08-28','08:45:00',2.03),('8975','2013-08-28','08:50:00',2.53),('8975','2013-08-28','08:55:00',3.18),('8975','2013-08-28','09:00:00',3.2),('8975','2013-08-28','09:05:00',3.14),('8975','2013-08-28','09:10:00',3.01),('8975','2013-08-28','09:15:00',2.98),('8975','2013-08-28','09:20:00',2.76),('8975','2013-08-28','09:25:00',2.56),('8975','2013-08-28','09:30:00',2.69),('8975','2013-08-28','09:35:00',2.9),('8975','2013-08-28','09:40:00',2.71),('8975','2013-08-28','09:45:00',2.58),('8975','2013-08-28','09:50:00',2.46),('8975','2013-08-28','09:55:00',2.58),('8975','2013-08-28','10:00:00',2.67),('8975','2013-08-28','10:05:00',2.53),('8975','2013-08-28','10:10:00',2.48),('8975','2013-08-28','10:15:00',2.45),('8975','2013-08-28','10:20:00',2.48),('8975','2013-08-28','10:25:00',2.55),('8975','2013-08-28','10:30:00',2.59),('8975','2013-08-28','10:35:00',2.43),('8975','2013-08-28','10:40:00',2.28),('8975','2013-08-28','10:45:00',2.1),('8975','2013-08-28','10:50:00',2.05),('8975','2013-08-28','10:55:00',2.27),('8975','2013-08-28','11:00:00',2.41),('8975','2013-08-28','11:05:00',2.44),('8975','2013-08-28','11:10:00',3.58),('8975','2013-08-28','11:15:00',4.51),('8975','2013-08-28','11:20:00',3.97),('8975','2013-08-28','11:25:00',3.04),('8975','2013-08-28','11:30:00',2.6),('8975','2013-08-28','11:35:00',2.29),('8975','2013-08-28','11:40:00',2.51),('8975','2013-08-28','11:45:00',3.03),('8975','2013-08-28','11:50:00',3.15),('8975','2013-08-28','11:55:00',3.19),('8975','2013-08-28','12:00:00',3.25),('8975','2013-08-28','12:05:00',4.05),('8975','2013-08-28','12:10:00',4.01),('8975','2013-08-28','12:15:00',4.46),('8975','2013-08-28','12:20:00',4.33),('8975','2013-08-28','12:25:00',4.86),('8975','2013-08-28','12:30:00',4.97),('8975','2013-08-28','12:35:00',5.77),('8975','2013-08-28','12:40:00',7.26),('8975','2013-08-28','12:45:00',7.08),('8975','2013-08-28','12:50:00',6.33),('8975','2013-08-28','12:55:00',5.7),('8975','2013-08-28','13:00:00',3.98),('8975','2013-08-28','13:05:00',3.93),('8975','2013-08-28','13:10:00',3.87),('8975','2013-08-28','13:15:00',3.69),('8975','2013-08-28','13:20:00',3.53),('8975','2013-08-28','13:25:00',3.13),('8975','2013-08-28','13:30:00',2.95),('8975','2013-08-28','13:35:00',2.67),('8975','2013-08-28','13:40:00',2.56),('8975','2013-08-28','13:45:00',2.47),('8975','2013-08-28','13:50:00',2.47),('8975','2013-08-28','13:55:00',2.82),('8975','2013-08-28','14:00:00',3.31),('8975','2013-08-28','14:05:00',2.72),('8975','2013-08-28','14:10:00',2.55),('8975','2013-08-28','14:15:00',2.14),('8975','2013-08-28','14:20:00',1.7),('8975','2013-08-28','14:25:00',1.5),('8975','2013-08-28','14:30:00',1.34),('8975','2013-08-28','14:35:00',1.31),('8975','2013-08-28','14:40:00',1.32),('8975','2013-08-28','14:45:00',1.45),('8975','2013-08-28','14:50:00',1.74),('8975','2013-08-28','14:55:00',2.12),('8975','2013-08-28','15:00:00',2.36),('8975','2013-08-28','15:05:00',2.6),('8975','2013-08-28','15:10:00',2.06),('8975','2013-08-28','15:15:00',1.83),('8975','2013-08-28','15:20:00',1.96),('8975','2013-08-28','15:25:00',2.15),('8975','2013-08-28','15:30:00',3.25),('8975','2013-08-28','15:35:00',2.97),('8975','2013-08-28','15:40:00',2.91),('8975','2013-08-28','15:45:00',3.6),('8975','2013-08-28','15:50:00',4.6),('8975','2013-08-28','15:55:00',4.66),('8975','2013-08-28','16:00:00',3.4),('8975','2013-08-28','16:05:00',3.68),('8975','2013-08-28','16:10:00',3.71),('8975','2013-08-28','16:15:00',3.38),('8975','2013-08-28','16:20:00',3.22),('8975','2013-08-28','16:25:00',3.01),('8975','2013-08-28','16:30:00',2.88),('8975','2013-08-28','16:35:00',2.77),('8975','2013-08-28','16:40:00',2.62),('8975','2013-08-28','16:45:00',2.49),('8975','2013-08-28','16:50:00',2.37),('8975','2013-08-28','16:55:00',2.26),('8975','2013-08-28','17:00:00',2.15),('8975','2013-08-28','17:05:00',2.06),('8975','2013-08-28','17:10:00',1.96),('8975','2013-08-28','17:15:00',1.84),('8975','2013-08-28','17:20:00',1.75),('8975','2013-08-28','17:25:00',1.65),('8975','2013-08-28','17:30:00',1.57),('8975','2013-08-28','17:35:00',1.5),('8975','2013-08-28','17:40:00',1.44),('8975','2013-08-28','17:45:00',1.4),('8975','2013-08-28','17:50:00',1.35),('8975','2013-08-28','17:55:00',1.31),('8975','2013-08-28','18:00:00',1.27),('8975','2013-08-28','18:05:00',1.22),('8975','2013-08-28','18:10:00',1.18),('8975','2013-08-28','18:15:00',1.14),('8975','2013-08-28','18:20:00',1.06),('8975','2013-08-27','07:30:00',1.21),('8975','2013-08-27','07:35:00',1.79),('8975','2013-08-27','07:40:00',2.13),('8975','2013-08-27','07:45:00',2.22),('8975','2013-08-27','07:50:00',2.37),('8975','2013-08-27','07:55:00',2.55),('8975','2013-08-27','08:00:00',1.8),('8975','2013-08-27','08:05:00',2.8),('8975','2013-08-27','08:10:00',2.95),('8975','2013-08-27','08:15:00',3.1),('8975','2013-08-27','08:20:00',3.13),('8975','2013-08-27','08:25:00',2.29),('8975','2013-08-27','08:30:00',3.4),('8975','2013-08-27','08:35:00',3.54),('8975','2013-08-27','08:40:00',2.82),('8975','2013-08-27','08:45:00',2.92),('8975','2013-08-27','08:50:00',3.34),('8975','2013-08-27','08:55:00',2.6),('8975','2013-08-27','09:00:00',4.09),('8975','2013-08-27','09:05:00',2.71),('8975','2013-08-27','09:10:00',3.71),('8975','2013-08-27','09:15:00',3.12),('8975','2013-08-27','09:20:00',1.93),('8975','2013-08-27','09:25:00',1.44),('8975','2013-08-27','09:30:00',1.66),('8975','2013-08-27','09:35:00',1.26),('8975','2013-08-27','09:40:00',3),('8975','2013-08-27','09:45:00',4.43),('8975','2013-08-27','09:50:00',4.46),('8975','2013-08-27','09:55:00',5.07),('8975','2013-08-27','10:00:00',5.06),('8975','2013-08-27','10:05:00',5.11),('8975','2013-08-27','10:10:00',5.21),('8975','2013-08-27','10:15:00',4.29),('8975','2013-08-27','10:20:00',5.71),('8975','2013-08-27','10:25:00',5.4),('8975','2013-08-27','10:30:00',3.67),('8975','2013-08-27','10:35:00',1.42),('8975','2013-08-27','10:40:00',3.52),('8975','2013-08-27','10:45:00',1.77),('8975','2013-08-27','10:50:00',2.58),('8975','2013-08-27','10:55:00',3.53),('8975','2013-08-27','11:00:00',6.65),('8975','2013-08-27','11:05:00',6.19),('8975','2013-08-27','11:10:00',1.75),('8975','2013-08-27','11:15:00',6.54),('8975','2013-08-27','11:20:00',6.5),('8975','2013-08-27','11:25:00',4.74),('8975','2013-08-27','11:30:00',4.94),('8975','2013-08-27','11:35:00',4.55),('8975','2013-08-27','11:40:00',6.61),('8975','2013-08-27','11:45:00',6.58),('8975','2013-08-27','11:50:00',2.85),('8975','2013-08-27','11:55:00',3.05),('8975','2013-08-27','12:00:00',5.56),('8975','2013-08-27','12:05:00',6.56),('8975','2013-08-27','12:10:00',1.97),('8975','2013-08-27','12:15:00',6.69),('8975','2013-08-27','12:20:00',6.65),('8975','2013-08-27','12:25:00',6.47),('8975','2013-08-27','12:30:00',6.44),('8975','2013-08-27','12:35:00',6.31),('8975','2013-08-27','12:40:00',6.27),('8975','2013-08-27','12:45:00',6.35),('8975','2013-08-27','12:50:00',6.25),('8975','2013-08-27','12:55:00',6.27),('8975','2013-08-27','13:00:00',6.44),('8975','2013-08-27','13:05:00',4.9),('8975','2013-08-27','13:10:00',5.85),('8975','2013-08-27','13:15:00',6.27),('8975','2013-08-27','13:20:00',6.23),('8975','2013-08-27','13:25:00',6.44),('8975','2013-08-27','13:30:00',6.21),('8975','2013-08-27','13:35:00',6.1),('8975','2013-08-27','13:40:00',3.02),('8975','2013-08-27','13:45:00',3.55),('8975','2013-08-27','13:50:00',6.16),('8975','2013-08-27','13:55:00',6.01),('8975','2013-08-27','14:00:00',4.83),('8975','2013-08-27','14:05:00',5.9),('8975','2013-08-27','14:10:00',5.78),('8975','2013-08-27','14:15:00',5.67),('8975','2013-08-27','14:20:00',5.59),('8975','2013-08-27','14:25:00',5.56),('8975','2013-08-27','14:30:00',5.49),('8975','2013-08-27','14:35:00',5.49),('8975','2013-08-27','14:40:00',5.34),('8975','2013-08-27','14:45:00',5.19),('8975','2013-08-27','14:50:00',5.13),('8975','2013-08-27','14:55:00',5.01),('8975','2013-08-27','15:00:00',4.94),('8975','2013-08-27','15:05:00',4.9),('8975','2013-08-27','15:10:00',4.9),('8975','2013-08-27','15:15:00',4.67),('8975','2013-08-27','15:20:00',4.73),('8975','2013-08-27','15:25:00',4.31),('8975','2013-08-27','15:30:00',3.36),('8975','2013-08-27','15:35:00',4.61),('8975','2013-08-27','15:40:00',3.77),('8975','2013-08-27','15:45:00',2.37),('8975','2013-08-27','15:50:00',4.56),('8975','2013-08-27','15:55:00',2.48),('8975','2013-08-27','16:00:00',2.87),('8975','2013-08-27','16:05:00',4),('8975','2013-08-27','16:10:00',2.89),('8975','2013-08-27','16:15:00',3.17),('8975','2013-08-27','16:20:00',3.23),('8975','2013-08-27','16:25:00',3.22),('8975','2013-08-27','16:30:00',2.89),('8975','2013-08-27','16:35:00',2.93),('8975','2013-08-27','16:40:00',2.75),('8975','2013-08-27','16:45:00',2.64),('8975','2013-08-27','16:50:00',2.51),('8975','2013-08-27','16:55:00',2.38),('8975','2013-08-27','17:00:00',2.25),('8975','2013-08-27','17:05:00',2.16),('8975','2013-08-27','17:10:00',1.36),('8975','2013-08-27','17:15:00',1.91),('8975','2013-08-27','17:20:00',1.43),('8975','2013-08-27','17:25:00',1.81),('8975','2013-08-27','17:30:00',1.85),('8975','2013-08-27','17:35:00',1.66),('8975','2013-08-27','17:40:00',1.64),('8975','2013-08-27','17:50:00',1.37),('8975','2013-08-27','17:55:00',1.59),('8975','2013-08-27','18:00:00',1.5),('8975','2013-08-27','18:05:00',1.01),('8975','2013-08-27','18:10:00',1.06),('8975','2013-08-26','08:10:00',1.13),('8975','2013-08-26','08:15:00',1.51),('8975','2013-08-26','08:20:00',2.4),('8975','2013-08-26','08:25:00',3.25),('8975','2013-08-26','08:30:00',3.19),('8975','2013-08-26','08:35:00',2.13),('8975','2013-08-26','08:40:00',2.06),('8975','2013-08-26','08:45:00',2.45),('8975','2013-08-26','08:50:00',1.66),('8975','2013-08-26','08:55:00',1.56),('8975','2013-08-26','09:00:00',1.72),('8975','2013-08-26','09:05:00',1.95),('8975','2013-08-26','09:10:00',2.31),('8975','2013-08-26','09:15:00',2.28),('8975','2013-08-26','09:20:00',2.9),('8975','2013-08-26','09:25:00',3.78),('8975','2013-08-26','09:30:00',3.64),('8975','2013-08-26','09:35:00',2.08),('8975','2013-08-26','09:40:00',1.67),('8975','2013-08-26','09:45:00',1.74),('8975','2013-08-26','09:50:00',1.78),('8975','2013-08-26','09:55:00',2.35),('8975','2013-08-26','10:00:00',3.34),('8975','2013-08-26','10:05:00',4.53),('8975','2013-08-26','10:10:00',5.12),('8975','2013-08-26','10:15:00',5.23),('8975','2013-08-26','10:20:00',5.29),('8975','2013-08-26','10:25:00',5.31),('8975','2013-08-26','10:30:00',5.34),('8975','2013-08-26','10:35:00',5.35),('8975','2013-08-26','10:40:00',5.28),('8975','2013-08-26','10:45:00',5.44),('8975','2013-08-26','10:50:00',5.56),('8975','2013-08-26','10:55:00',5.51),('8975','2013-08-26','11:00:00',5.5),('8975','2013-08-26','11:05:00',5.6),('8975','2013-08-26','11:10:00',5.55),('8975','2013-08-26','11:15:00',5.5),('8975','2013-08-26','11:20:00',5.68),('8975','2013-08-26','11:25:00',5.63),('8975','2013-08-26','11:30:00',5.53),('8975','2013-08-26','11:35:00',4.56),('8975','2013-08-26','11:40:00',5.13),('8975','2013-08-26','11:45:00',5.85),('8975','2013-08-26','11:50:00',4.14),('8975','2013-08-26','11:55:00',5.88),('8975','2013-08-26','12:00:00',5.44),('8975','2013-08-26','12:05:00',5.42),('8975','2013-08-26','12:10:00',2.75),('8975','2013-08-26','12:15:00',1.99),('8975','2013-08-26','12:20:00',2),('8975','2013-08-26','12:25:00',1.82),('8975','2013-08-26','12:30:00',2.11),('8975','2013-08-26','12:35:00',2.14),('8975','2013-08-26','12:40:00',2.44),('8975','2013-08-26','12:45:00',3.15),('8975','2013-08-26','12:50:00',3.86),('8975','2013-08-26','12:55:00',3.3),('8975','2013-08-26','13:00:00',2.13),('8975','2013-08-26','13:05:00',3.1),('8975','2013-08-26','13:10:00',4.7),('8975','2013-08-26','13:15:00',3.8),('8975','2013-08-26','13:20:00',2.81),('8975','2013-08-26','13:25:00',2.68),('8975','2013-08-26','13:30:00',3.57),('8975','2013-08-26','13:35:00',3.94),('8975','2013-08-26','13:40:00',4.22),('8975','2013-08-26','13:45:00',5.11),('8975','2013-08-26','13:50:00',4.58),('8975','2013-08-26','13:55:00',4.52),('8975','2013-08-26','14:00:00',6.38),('8975','2013-08-26','14:05:00',4.44),('8975','2013-08-26','14:10:00',4.55),('8975','2013-08-26','14:15:00',3.1),('8975','2013-08-26','14:20:00',2.51),('8975','2013-08-26','14:25:00',2.19),('8975','2013-08-26','14:30:00',1.85),('8975','2013-08-26','14:35:00',1.74),('8975','2013-08-26','14:40:00',1.85),('8975','2013-08-26','14:45:00',1.8),('8975','2013-08-26','14:50:00',1.49),('8975','2013-08-26','14:55:00',1.12),('8975','2013-08-26','15:05:00',1.12),('8975','2013-08-26','15:10:00',1.32),('8975','2013-08-26','15:15:00',1.34),('8975','2013-08-26','15:20:00',1.16),('8975','2013-08-26','15:30:00',1.02),('8975','2013-08-26','15:35:00',1.06),('8975','2013-08-26','15:55:00',1.96),('8975','2013-08-26','16:00:00',1.76),('8975','2013-08-26','16:05:00',2.7),('8975','2013-08-26','16:10:00',4.8),('8975','2013-08-26','16:15:00',3.68),('8975','2013-08-26','16:20:00',3.13),('8975','2013-08-26','16:25:00',2.57),('8975','2013-08-26','16:30:00',1.81),('8975','2013-08-26','16:35:00',2.56),('8975','2013-08-26','16:40:00',2.09),('8975','2013-08-26','16:45:00',1.47),('8975','2013-08-26','16:50:00',3.05),('8975','2013-08-26','16:55:00',2.4),('8975','2013-08-26','17:05:00',1.92),('8975','2013-08-26','17:10:00',3.02),('8975','2013-08-26','17:15:00',1.75),('8975','2013-08-26','17:20:00',1.32),('8975','2013-08-26','17:25:00',1.24),('8975','2013-08-26','17:30:00',1.09),('8975','2013-08-26','17:35:00',1.25),('8975','2013-08-26','17:40:00',1.16),('8975','2013-08-26','17:45:00',1.61),('8975','2013-08-26','17:50:00',1.63),('8975','2013-08-26','17:55:00',1.8),('8975','2013-08-26','18:00:00',1.43),('8975','2013-08-26','18:05:00',1.09),('8975','2013-08-25','07:10:00',1.01),('8975','2013-08-25','07:15:00',1.23),('8975','2013-08-25','07:20:00',1.47),('8975','2013-08-25','07:25:00',1.78),('8975','2013-08-25','07:30:00',1.5),('8975','2013-08-25','07:40:00',1.49),('8975','2013-08-25','07:45:00',1.49),('8975','2013-08-25','07:50:00',1.15),('8975','2013-08-25','07:55:00',1.66),('8975','2013-08-25','08:00:00',1.84),('8975','2013-08-25','08:05:00',2.64),('8975','2013-08-25','08:10:00',3.44),('8975','2013-08-25','08:15:00',1.45),('8975','2013-08-25','08:20:00',2.03),('8975','2013-08-25','08:25:00',1.92),('8975','2013-08-25','08:30:00',3.08),('8975','2013-08-25','08:35:00',3.25),('8975','2013-08-25','08:40:00',3.61),('8975','2013-08-25','08:45:00',3.7),('8975','2013-08-25','08:50:00',3.78),('8975','2013-08-25','08:55:00',3.86),('8975','2013-08-25','09:00:00',3.97),('8975','2013-08-25','09:05:00',4.04),('8975','2013-08-25','09:10:00',4.13),('8975','2013-08-25','09:15:00',4.2),('8975','2013-08-25','09:20:00',4.31),('8975','2013-08-25','09:25:00',4.42),('8975','2013-08-25','09:30:00',4.5),('8975','2013-08-25','09:35:00',4.52),('8975','2013-08-25','09:40:00',4.63),('8975','2013-08-25','09:45:00',4.73),('8975','2013-08-25','09:50:00',4.79),('8975','2013-08-25','09:55:00',4.93),('8975','2013-08-25','10:00:00',4.93),('8975','2013-08-25','10:05:00',4.85),('8975','2013-08-25','10:10:00',4.91),('8975','2013-08-25','10:15:00',5.08),('8975','2013-08-25','10:20:00',5.27),('8975','2013-08-25','10:25:00',5.35),('8975','2013-08-25','10:30:00',5.35),('8975','2013-08-25','10:35:00',5.41),('8975','2013-08-25','10:40:00',5.5),('8975','2013-08-25','10:45:00',5.55),('8975','2013-08-25','10:50:00',5.58),('8975','2013-08-25','10:55:00',5.6),('8975','2013-08-25','11:00:00',5.66),('8975','2013-08-25','11:05:00',5.68),('8975','2013-08-25','11:10:00',5.69),('8975','2013-08-25','11:15:00',5.75),('8975','2013-08-25','11:20:00',5.73),('8975','2013-08-25','11:25:00',5.78),('8975','2013-08-25','11:30:00',5.83),('8975','2013-08-25','11:35:00',5.86),('8975','2013-08-25','11:40:00',5.91),('8975','2013-08-25','11:45:00',5.96),('8975','2013-08-25','11:50:00',5.97),('8975','2013-08-25','11:55:00',5.95),('8975','2013-08-25','12:00:00',5.91),('8975','2013-08-25','12:05:00',5.91),('8975','2013-08-25','12:10:00',5.91),('8975','2013-08-25','12:15:00',5.94),('8975','2013-08-25','12:20:00',5.9),('8975','2013-08-25','12:25:00',5.9),('8975','2013-08-25','12:30:00',5.88),('8975','2013-08-25','12:35:00',5.87),('8975','2013-08-25','12:40:00',5.96),('8975','2013-08-25','12:45:00',5.91),('8975','2013-08-25','12:50:00',5.93),('8975','2013-08-25','12:55:00',5.91),('8975','2013-08-25','13:00:00',5.84),('8975','2013-08-25','13:05:00',4.86),('8975','2013-08-25','13:10:00',4.57),('8975','2013-08-25','13:15:00',3.16),('8975','2013-08-25','13:20:00',4.26),('8975','2013-08-25','13:25:00',5.31),('8975','2013-08-25','13:30:00',6.28),('8975','2013-08-25','13:35:00',5.97),('8975','2013-08-25','13:40:00',5.65),('8975','2013-08-25','13:45:00',5.68),('8975','2013-08-25','13:50:00',3.76),('8975','2013-08-25','13:55:00',4.07),('8975','2013-08-25','14:00:00',5.06),('8975','2013-08-25','14:05:00',3.77),('8975','2013-08-25','14:10:00',4.06),('8975','2013-08-25','14:15:00',5.01),('8975','2013-08-25','14:20:00',4.7),('8975','2013-08-25','14:25:00',4.51),('8975','2013-08-25','14:30:00',4.56),('8975','2013-08-25','14:35:00',4.43),('8975','2013-08-25','14:40:00',3.19),('8975','2013-08-25','14:45:00',3.16),('8975','2013-08-25','14:50:00',3.17),('8975','2013-08-25','14:55:00',3.12),('8975','2013-08-25','15:00:00',2.67),('8975','2013-08-25','15:05:00',1.81),('8975','2013-08-25','15:10:00',1.56),('8975','2013-08-25','15:15:00',1.38),('8975','2013-08-25','15:20:00',1.17),('8975','2013-08-25','15:25:00',1.07),('8975','2013-08-25','15:30:00',1.17),('8975','2013-08-25','15:35:00',1.57),('8975','2013-08-25','15:40:00',2.39),('8975','2013-08-25','15:45:00',2.7),('8975','2013-08-25','15:50:00',2.5),('8975','2013-08-25','15:55:00',2.78),('8975','2013-08-25','16:00:00',4.2),('8975','2013-08-25','16:05:00',3.78),('8975','2013-08-25','16:10:00',3.37),('8975','2013-08-25','16:15:00',3.11),('8975','2013-08-25','16:20:00',3.02),('8975','2013-08-25','16:25:00',2.9),('8975','2013-08-25','16:30:00',2.78),('8975','2013-08-25','16:35:00',2.73),('8975','2013-08-25','16:40:00',2.43),('8975','2013-08-25','16:45:00',2.59),('8975','2013-08-25','16:50:00',2.42),('8975','2013-08-25','16:55:00',2.21),('8975','2013-08-25','17:00:00',2.23),('8975','2013-08-25','17:05:00',2),('8975','2013-08-25','17:10:00',1.92),('8975','2013-08-25','17:15:00',1.87),('8975','2013-08-25','17:20:00',1.23),('8975','2013-08-25','17:30:00',1.28),('8975','2013-08-25','17:35:00',1.07),('8975','2013-08-25','17:40:00',1.13),('8975','2013-08-25','17:45:00',1.55),('8975','2013-08-25','17:50:00',1.73),('8975','2013-08-25','17:55:00',1.68),('8975','2013-08-25','18:00:00',1.49),('8975','2013-08-25','18:05:00',1.29),('8975','2013-08-25','18:10:00',1.16),('8975','2013-08-25','18:15:00',1.09),('8975','2013-08-25','18:20:00',1.02),('8975','2013-08-24','07:15:00',1.05),('8975','2013-08-24','07:20:00',1.12),('8975','2013-08-24','07:25:00',1.27),('8975','2013-08-24','07:30:00',1.36),('8975','2013-08-24','07:35:00',1.53),('8975','2013-08-24','07:40:00',1.73),('8975','2013-08-24','07:45:00',1.89),('8975','2013-08-24','07:50:00',2.11),('8975','2013-08-24','07:55:00',1.99),('8975','2013-08-24','08:00:00',2.44),('8975','2013-08-24','08:05:00',2.54),('8975','2013-08-24','08:10:00',2.87),('8975','2013-08-24','08:15:00',2.71),('8975','2013-08-24','08:20:00',2.82),('8975','2013-08-24','08:25:00',2.5),('8975','2013-08-24','08:30:00',1.27),('8975','2013-08-24','08:35:00',1.29),('8975','2013-08-24','08:40:00',1.9),('8975','2013-08-24','08:45:00',1.21),('8975','2013-08-24','08:50:00',1.1),('8975','2013-08-24','08:55:00',1.11),('8975','2013-08-24','09:00:00',1.03),('8975','2013-08-24','09:05:00',1.8),('8975','2013-08-24','09:10:00',1.66),('8975','2013-08-24','09:15:00',3.2),('8975','2013-08-24','09:20:00',3.67),('8975','2013-08-24','09:25:00',2.9),('8975','2013-08-24','09:30:00',2.06),('8975','2013-08-24','09:35:00',3.1),('8975','2013-08-24','09:40:00',4.91),('8975','2013-08-24','09:45:00',5.96),('8975','2013-08-24','09:50:00',5.23),('8975','2013-08-24','09:55:00',5.87),('8975','2013-08-24','10:00:00',4.43),('8975','2013-08-24','10:05:00',3.13),('8975','2013-08-24','10:10:00',1.66),('8975','2013-08-24','10:15:00',1.38),('8975','2013-08-24','10:20:00',1.15),('8975','2013-08-24','15:00:00',1.12),('8975','2013-08-24','15:05:00',1.39),('8975','2013-08-24','15:10:00',1.55),('8975','2013-08-24','15:15:00',1.85),('8975','2013-08-24','15:20:00',2.22),('8975','2013-08-24','15:25:00',2.43),('8975','2013-08-24','15:30:00',3.21),('8975','2013-08-24','15:35:00',4.17),('8975','2013-08-24','15:40:00',4.84),('8975','2013-08-24','15:45:00',4.1),('8975','2013-08-24','15:50:00',3.98),('8975','2013-08-24','15:55:00',3.63),('8975','2013-08-24','16:00:00',3.87),('8975','2013-08-24','16:05:00',3.8),('8975','2013-08-24','16:10:00',3.63),('8975','2013-08-24','16:15:00',3.47),('8975','2013-08-24','16:20:00',3.33),('8975','2013-08-24','16:25:00',3.2),('8975','2013-08-24','16:30:00',3.09),('8975','2013-08-24','16:40:00',2.1),('8975','2013-08-24','16:45:00',1.6),('8975','2013-08-24','16:50:00',2.25),('8975','2013-08-24','16:55:00',2.97),('8975','2013-08-24','17:00:00',2.65),('8975','2013-08-24','17:05:00',2.36),('8975','2013-08-24','17:10:00',2.25),('8975','2013-08-24','17:15:00',2.07),('8975','2013-08-24','17:20:00',1.95),('8975','2013-08-24','17:25:00',1.81),('8975','2013-08-24','17:30:00',1.71),('8975','2013-08-24','17:35:00',1.57),('8975','2013-08-24','17:40:00',1.33),('8975','2013-08-24','17:45:00',1.5),('8975','2013-08-24','17:50:00',1.42),('8975','2013-08-24','17:55:00',1.3),('8975','2013-08-24','18:00:00',1.13),('8975','2013-08-24','18:15:00',1.05),('8975','2013-08-24','18:20:00',1.21),('8975','2013-08-24','18:25:00',1.13),('8975','2013-08-24','18:30:00',1),('8975','2013-08-23','07:20:00',1.09),('8975','2013-08-23','07:25:00',1.31),('8975','2013-08-23','07:30:00',1.41),('8975','2013-08-23','07:35:00',1.61),('8975','2013-08-23','07:40:00',1.86),('8975','2013-08-23','07:45:00',1.89),('8975','2013-08-23','07:50:00',1.84),('8975','2013-08-23','07:55:00',1.91),('8975','2013-08-23','08:00:00',1.74),('8975','2013-08-23','08:05:00',2.1),('8975','2013-08-23','08:10:00',2.6),('8975','2013-08-23','08:15:00',2.09),('8975','2013-08-23','08:20:00',2.58),('8975','2013-08-23','08:25:00',2.85),('8975','2013-08-23','08:30:00',3.18),('8975','2013-08-23','08:35:00',3.33),('8975','2013-08-23','08:40:00',3.62),('8975','2013-08-23','08:45:00',2.45),('8975','2013-08-23','08:50:00',1.84),('8975','2013-08-23','08:55:00',1.21),('8975','2013-08-23','09:00:00',1.39),('8975','2013-08-23','09:05:00',2.36),('8975','2013-08-23','09:10:00',3.62),('8975','2013-08-23','09:15:00',3.91),('8975','2013-08-23','09:20:00',4.03),('8975','2013-08-23','09:25:00',3.49),('8975','2013-08-23','09:30:00',4.49),('8975','2013-08-23','09:35:00',4.62),('8975','2013-08-23','09:40:00',4.61),('8975','2013-08-23','09:45:00',4.86),('8975','2013-08-23','09:50:00',5),('8975','2013-08-23','09:55:00',4.96),('8975','2013-08-23','10:00:00',4.88),('8975','2013-08-23','10:05:00',5),('8975','2013-08-23','10:10:00',4.05),('8975','2013-08-23','10:15:00',4.54),('8975','2013-08-23','10:20:00',3.78),('8975','2013-08-23','10:25:00',5.15),('8975','2013-08-23','10:30:00',4.38),('8975','2013-08-23','10:35:00',5.05),('8975','2013-08-23','10:40:00',5.57),('8975','2013-08-23','10:45:00',5.63),('8975','2013-08-23','10:50:00',5.63),('8975','2013-08-23','10:55:00',5.67),('8975','2013-08-23','11:00:00',5.7),('8975','2013-08-23','11:05:00',5.72),('8975','2013-08-23','11:10:00',5.77),('8975','2013-08-23','11:15:00',5.77),('8975','2013-08-23','11:20:00',5.7),('8975','2013-08-23','11:25:00',5.81),('8975','2013-08-23','11:30:00',5.85),('8975','2013-08-23','11:35:00',5.79),('8975','2013-08-23','11:40:00',5.77),('8975','2013-08-23','11:45:00',5.91),('8975','2013-08-23','11:50:00',5.98),('8975','2013-08-23','11:55:00',5.94),('8975','2013-08-23','12:00:00',5.95),('8975','2013-08-23','12:05:00',5.97),('8975','2013-08-23','12:10:00',5.95),('8975','2013-08-23','12:15:00',5.95),('8975','2013-08-23','12:20:00',5.9),('8975','2013-08-23','12:25:00',5.99),('8975','2013-08-23','12:30:00',5.95),('8975','2013-08-23','12:35:00',5.88),('8975','2013-08-23','12:40:00',5.96),('8975','2013-08-23','12:45:00',5.83),('8975','2013-08-23','12:50:00',5.94),('8975','2013-08-23','12:55:00',5.96),('8975','2013-08-23','13:00:00',5.87),('8975','2013-08-23','13:05:00',5.88),('8975','2013-08-23','13:10:00',5.81),('8975','2013-08-23','13:15:00',5.78),('8975','2013-08-23','13:20:00',5.82),('8975','2013-08-23','13:25:00',5.78),('8975','2013-08-23','13:30:00',5.74),('8975','2013-08-23','13:35:00',5.69),('8975','2013-08-23','13:40:00',5.66),('8975','2013-08-23','13:45:00',5.62),('8975','2013-08-23','13:50:00',5.55),('8975','2013-08-23','13:55:00',5.52),('8975','2013-08-23','14:00:00',5.46),('8975','2013-08-23','14:05:00',5.44),('8975','2013-08-23','14:10:00',5.38),('8975','2013-08-23','14:15:00',5.31),('8975','2013-08-23','14:20:00',5.25),('8975','2013-08-23','14:25:00',5.2),('8975','2013-08-23','14:30:00',5.17),('8975','2013-08-23','14:35:00',5.11),('8975','2013-08-23','14:40:00',5.02),('8975','2013-08-23','14:45:00',4.94),('8975','2013-08-23','14:50:00',4.88),('8975','2013-08-23','14:55:00',4.77),('8975','2013-08-23','15:00:00',4.7),('8975','2013-08-23','15:05:00',4.62),('8975','2013-08-23','15:10:00',4.52),('8975','2013-08-23','15:15:00',4.43),('8975','2013-08-23','15:20:00',4.34),('8975','2013-08-23','15:25:00',4.22),('8975','2013-08-23','15:30:00',4.1),('8975','2013-08-23','15:35:00',3.82),('8975','2013-08-23','15:40:00',3.91),('8975','2013-08-23','15:45:00',3.79),('8975','2013-08-23','15:50:00',3.71),('8975','2013-08-23','15:55:00',3.6),('8975','2013-08-23','16:00:00',3.48),('8975','2013-08-23','16:05:00',3.36),('8975','2013-08-23','16:10:00',3.25),('8975','2013-08-23','16:15:00',3.18),('8975','2013-08-23','16:20:00',3.05),('8975','2013-08-23','16:25:00',2.97),('8975','2013-08-23','16:30:00',2.87),('8975','2013-08-23','16:35:00',2.77),('8975','2013-08-23','16:40:00',2.62),('8975','2013-08-23','16:45:00',2.52),('8975','2013-08-23','16:50:00',2.42),('8975','2013-08-23','16:55:00',2.33),('8975','2013-08-23','17:00:00',2.23),('8975','2013-08-23','17:05:00',2.12),('8975','2013-08-23','17:10:00',2.01),('8975','2013-08-23','17:15:00',1.92),('8975','2013-08-23','17:20:00',1.83),('8975','2013-08-23','17:25:00',1.75),('8975','2013-08-23','17:30:00',1.67),('8975','2013-08-23','17:35:00',1.59),('8975','2013-08-23','17:40:00',1.51),('8975','2013-08-23','17:45:00',1.44),('8975','2013-08-23','17:50:00',1.38),('8975','2013-08-23','17:55:00',1.33),('8975','2013-08-23','18:00:00',1.28),('8975','2013-08-23','18:05:00',1.24),('8975','2013-08-23','18:10:00',1.18),('8975','2013-08-23','18:15:00',1.13),('8975','2013-08-23','18:20:00',1.08),('8975','2013-08-23','18:25:00',1.01),('8975','2013-08-22','07:25:00',1.09),('8975','2013-08-22','07:30:00',1.21),('8975','2013-08-22','07:35:00',1.38),('8975','2013-08-22','07:40:00',1.57),('8975','2013-08-22','07:45:00',1.71),('8975','2013-08-22','07:50:00',1.85),('8975','2013-08-22','07:55:00',1.97),('8975','2013-08-22','08:00:00',2.09),('8975','2013-08-22','08:05:00',2.2),('8975','2013-08-22','08:10:00',2.35),('8975','2013-08-22','08:15:00',2.49),('8975','2013-08-22','08:20:00',2.62),('8975','2013-08-22','08:25:00',2.83),('8975','2013-08-22','08:30:00',2.74),('8975','2013-08-22','08:35:00',2.82),('8975','2013-08-22','08:40:00',3.07),('8975','2013-08-22','08:45:00',3.19),('8975','2013-08-22','08:50:00',3.28),('8975','2013-08-22','08:55:00',3.39),('8975','2013-08-22','09:00:00',3.47),('8975','2013-08-22','09:05:00',3.56),('8975','2013-08-22','09:10:00',3.67),('8975','2013-08-22','09:15:00',3.79),('8975','2013-08-22','09:20:00',3.88),('8975','2013-08-22','09:25:00',3.94),('8975','2013-08-22','09:30:00',3.95),('8975','2013-08-22','09:35:00',4.06),('8975','2013-08-22','09:40:00',4.17),('8975','2013-08-22','09:45:00',4.23),('8975','2013-08-22','09:50:00',4.34),('8975','2013-08-22','09:55:00',4.42),('8975','2013-08-22','10:00:00',4.48),('8975','2013-08-22','10:05:00',4.58),('8975','2013-08-22','10:10:00',4.62),('8975','2013-08-22','10:15:00',4.61),('8975','2013-08-22','10:20:00',4.67),('8975','2013-08-22','10:25:00',4.66),('8975','2013-08-22','10:30:00',4.78),('8975','2013-08-22','10:35:00',4.87),('8975','2013-08-22','10:40:00',4.9),('8975','2013-08-22','10:45:00',4.94),('8975','2013-08-22','10:50:00',5.06),('8975','2013-08-22','10:55:00',5.34),('8975','2013-08-22','11:00:00',2.98),('8975','2013-08-22','11:05:00',2.48),('8975','2013-08-22','11:10:00',1.91),('8975','2013-08-22','11:15:00',3.8),('8975','2013-08-22','11:20:00',5.36),('8975','2013-08-22','11:25:00',5.62),('8975','2013-08-22','11:30:00',5.67),('8975','2013-08-22','11:35:00',5.71),('8975','2013-08-22','11:40:00',5.83),('8975','2013-08-22','11:45:00',4.24),('8975','2013-08-22','11:50:00',6.15),('8975','2013-08-22','11:55:00',5.86),('8975','2013-08-22','12:00:00',5.04),('8975','2013-08-22','12:05:00',2.87),('8975','2013-08-22','12:10:00',5.13),('8975','2013-08-22','12:15:00',4.89),('8975','2013-08-22','12:20:00',2.42),('8975','2013-08-22','12:25:00',1.95),('8975','2013-08-22','12:30:00',3.26),('8975','2013-08-22','12:35:00',1.78),('8975','2013-08-22','12:40:00',1.75),('8975','2013-08-22','12:45:00',1.66),('8975','2013-08-22','12:50:00',2.55),('8975','2013-08-22','12:55:00',2.61),('8975','2013-08-22','13:00:00',4.56),('8975','2013-08-22','13:05:00',6.55),('8975','2013-08-22','13:10:00',6.51),('8975','2013-08-22','13:15:00',6.37),('8975','2013-08-22','13:20:00',6.32),('8975','2013-08-22','13:25:00',6.11),('8975','2013-08-22','13:30:00',6.11),('8975','2013-08-22','13:35:00',6.11),('8975','2013-08-22','13:40:00',6.03),('8975','2013-08-22','13:45:00',5.93),('8975','2013-08-22','13:50:00',5.83),('8975','2013-08-22','13:55:00',5.9),('8975','2013-08-22','14:00:00',5.81),('8975','2013-08-22','14:05:00',5.07),('8975','2013-08-22','14:10:00',5.63),('8975','2013-08-22','14:15:00',5.48),('8975','2013-08-22','14:20:00',5.38),('8975','2013-08-22','14:25:00',5.33),('8975','2013-08-22','14:30:00',3.88),('8975','2013-08-22','14:35:00',4.17),('8975','2013-08-22','14:40:00',5.22),('8975','2013-08-22','14:45:00',4.93),('8975','2013-08-22','14:50:00',4.86),('8975','2013-08-22','14:55:00',4.53),('8975','2013-08-22','15:00:00',4.7),('8975','2013-08-22','15:05:00',3.82),('8975','2013-08-22','15:10:00',4.34),('8975','2013-08-22','15:15:00',3.42),('8975','2013-08-22','15:20:00',4.27),('8975','2013-08-22','15:25:00',4.05),('8975','2013-08-22','15:30:00',4.01),('8975','2013-08-22','15:35:00',3.31),('8975','2013-08-22','15:40:00',3.58),('8975','2013-08-22','15:45:00',3.52),('8975','2013-08-22','15:50:00',3.42),('8975','2013-08-22','15:55:00',3.36),('8975','2013-08-22','16:00:00',3.43),('8975','2013-08-22','16:05:00',3.22),('8975','2013-08-22','16:10:00',2.97),('8975','2013-08-22','16:15:00',3.31),('8975','2013-08-22','16:20:00',3.28),('8975','2013-08-22','16:25:00',3.18),('8975','2013-08-22','16:30:00',3.09),('8975','2013-08-22','16:35:00',2.98),('8975','2013-08-22','16:40:00',2.87),('8975','2013-08-22','16:45:00',2.75),('8975','2013-08-22','16:50:00',2.61),('8975','2013-08-22','16:55:00',2.47),('8975','2013-08-22','17:00:00',2.33),('8975','2013-08-22','17:05:00',2.21),('8975','2013-08-22','17:10:00',2.12),('8975','2013-08-22','17:15:00',1.98),('8975','2013-08-22','17:20:00',1.89),('8975','2013-08-22','17:25:00',1.8),('8975','2013-08-22','17:30:00',1.7),('8975','2013-08-22','17:35:00',1.61),('8975','2013-08-22','17:40:00',1.54),('8975','2013-08-22','17:45:00',1.46),('8975','2013-08-22','17:50:00',1.36),('8975','2013-08-22','17:55:00',1.32),('8975','2013-08-22','18:00:00',1.27),('8975','2013-08-22','18:05:00',1.21),('8975','2013-08-22','18:10:00',1.12),('8975','2013-08-22','18:15:00',1.03),('8975','2013-08-22','18:20:00',1.08),('8975','2013-08-22','18:25:00',1.05),('8975','2013-08-22','18:30:00',1.01),('8975','2013-08-21','07:20:00',1.15),('8975','2013-08-21','07:25:00',1.29),('8975','2013-08-21','07:30:00',1.44),('8975','2013-08-21','07:35:00',1.58),('8975','2013-08-21','07:40:00',1.34),('8975','2013-08-21','07:45:00',1.95),('8975','2013-08-21','07:50:00',2.1),('8975','2013-08-21','07:55:00',2.19),('8975','2013-08-21','08:00:00',2.34),('8975','2013-08-21','08:05:00',2.49),('8975','2013-08-21','08:10:00',2.6),('8975','2013-08-21','08:15:00',2.7),('8975','2013-08-21','08:20:00',2.87),('8975','2013-08-21','08:25:00',3.01),('8975','2013-08-21','08:30:00',3.15),('8975','2013-08-21','08:35:00',3.23),('8975','2013-08-21','08:40:00',3.32),('8975','2013-08-21','08:45:00',3.44),('8975','2013-08-21','08:50:00',3.57),('8975','2013-08-21','08:55:00',3.73),('8975','2013-08-21','09:00:00',3.86),('8975','2013-08-21','09:05:00',4.16),('8975','2013-08-21','09:10:00',4.36),('8975','2013-08-21','09:15:00',4.55),('8975','2013-08-21','09:20:00',4.04),('8975','2013-08-21','09:25:00',2.5),('8975','2013-08-21','09:30:00',3.32),('8975','2013-08-21','09:35:00',3.52),('8975','2013-08-21','09:40:00',5),('8975','2013-08-21','09:45:00',4.54),('8975','2013-08-21','09:50:00',4.84),('8975','2013-08-21','09:55:00',4.9),('8975','2013-08-21','10:00:00',4.98),('8975','2013-08-21','10:05:00',5.05),('8975','2013-08-21','10:10:00',5.07),('8975','2013-08-21','10:15:00',5.09),('8975','2013-08-21','10:20:00',5.11),('8975','2013-08-21','10:25:00',5.2),('8975','2013-08-21','10:30:00',5.23),('8975','2013-08-21','10:35:00',5.33),('8975','2013-08-21','10:40:00',5.38),('8975','2013-08-21','10:45:00',5.43),('8975','2013-08-21','10:50:00',5.45),('8975','2013-08-21','10:55:00',5.51),('8975','2013-08-21','11:00:00',5.53),('8975','2013-08-21','11:05:00',5.58),('8975','2013-08-21','11:10:00',5.6),('8975','2013-08-21','11:15:00',5.64),('8975','2013-08-21','11:20:00',5.67),('8975','2013-08-21','11:25:00',5.67),('8975','2013-08-21','11:30:00',5.68),('8975','2013-08-21','11:35:00',5.72),('8975','2013-08-21','11:40:00',5.76),('8975','2013-08-21','11:45:00',5.72),('8975','2013-08-21','11:50:00',5.73),('8975','2013-08-21','11:55:00',5.79),('8975','2013-08-21','12:00:00',5.74),('8975','2013-08-21','12:05:00',5.76),('8975','2013-08-21','12:10:00',5.79),('8975','2013-08-21','12:15:00',5.81),('8975','2013-08-21','12:20:00',5.78),('8975','2013-08-21','12:25:00',5.8),('8975','2013-08-21','12:30:00',5.78),('8975','2013-08-21','12:35:00',5.76),('8975','2013-08-21','12:40:00',5.76),('8975','2013-08-21','12:45:00',5.75),('8975','2013-08-21','12:50:00',5.71),('8975','2013-08-21','12:55:00',5.65),('8975','2013-08-21','13:00:00',5.64),('8975','2013-08-21','13:05:00',5.66),('8975','2013-08-21','13:10:00',5.68),('8975','2013-08-21','13:15:00',5.64),('8975','2013-08-21','13:20:00',5.57),('8975','2013-08-21','13:25:00',5.5),('8975','2013-08-21','13:30:00',5.44),('8975','2013-08-21','13:35:00',5.39),('8975','2013-08-21','13:40:00',5.39),('8975','2013-08-21','13:45:00',5.35),('8975','2013-08-21','13:50:00',5.29),('8975','2013-08-21','13:55:00',5.25),('8975','2013-08-21','14:00:00',5.26),('8975','2013-08-21','14:05:00',5.22),('8975','2013-08-21','14:10:00',5.08),('8975','2013-08-21','14:15:00',5.11),('8975','2013-08-21','14:20:00',5.12),('8975','2013-08-21','14:25:00',5.07),('8975','2013-08-21','14:30:00',5.04),('8975','2013-08-21','14:35:00',4.97),('8975','2013-08-21','14:40:00',4.95),('8975','2013-08-21','14:45:00',4.9),('8975','2013-08-21','14:50:00',4.84),('8975','2013-08-21','14:55:00',4.83),('8975','2013-08-21','15:00:00',4.73),('8975','2013-08-21','15:05:00',4.54),('8975','2013-08-21','15:10:00',4.48),('8975','2013-08-21','15:15:00',4.4),('8975','2013-08-21','15:20:00',4.29),('8975','2013-08-21','15:25:00',4.2),('8975','2013-08-21','15:30:00',4.03),('8975','2013-08-21','15:35:00',3.91),('8975','2013-08-21','15:40:00',3.86),('8975','2013-08-21','15:45:00',3.78),('8975','2013-08-21','15:50:00',3.66),('8975','2013-08-21','15:55:00',3.57),('8975','2013-08-21','16:00:00',3.46),('8975','2013-08-21','16:05:00',3.38),('8975','2013-08-21','16:10:00',3.26),('8975','2013-08-21','16:15:00',3.13),('8975','2013-08-21','16:20:00',3.05),('8975','2013-08-21','16:25:00',2.97),('8975','2013-08-21','16:30:00',2.88),('8975','2013-08-21','16:35:00',2.77),('8975','2013-08-21','16:40:00',2.67),('8975','2013-08-21','16:45:00',2.57),('8975','2013-08-21','16:50:00',2.43),('8975','2013-08-21','16:55:00',2.33),('8975','2013-08-21','17:00:00',2.25),('8975','2013-08-21','17:05:00',2.16),('8975','2013-08-21','17:10:00',2.04),('8975','2013-08-21','17:15:00',1.96),('8975','2013-08-21','17:20:00',1.87),('8975','2013-08-21','17:25:00',1.79),('8975','2013-08-21','17:30:00',1.69),('8975','2013-08-21','17:35:00',1.61),('8975','2013-08-21','17:40:00',1.55),('8975','2013-08-21','17:45:00',1.48),('8975','2013-08-21','17:50:00',1.4),('8975','2013-08-21','17:55:00',1.34),('8975','2013-08-21','18:00:00',1.3),('8975','2013-08-21','18:05:00',1.25),('8975','2013-08-21','18:10:00',1.28),('8975','2013-08-21','18:15:00',1.32),('8975','2013-08-21','18:20:00',1.29),('8975','2013-08-21','18:25:00',1.12),('8975','2013-08-21','18:30:00',1.04),('8975','2013-08-20','08:20:00',1.06),('8975','2013-08-20','08:25:00',1.17),('8975','2013-08-20','08:30:00',1.3),('8975','2013-08-20','08:35:00',1.39),('8975','2013-08-20','08:40:00',1.34),('8975','2013-08-20','08:45:00',1.11),('8975','2013-08-20','08:55:00',1.07),('8975','2013-08-20','09:00:00',1.75),('8975','2013-08-20','09:05:00',2.47),('8975','2013-08-20','09:10:00',3.44),('8975','2013-08-20','09:15:00',3.99),('8975','2013-08-20','09:20:00',2.47),('8975','2013-08-20','09:25:00',1.61),('8975','2013-08-20','09:30:00',1.42),('8975','2013-08-20','09:35:00',1.69),('8975','2013-08-20','09:40:00',1.91),('8975','2013-08-20','09:45:00',3.17),('8975','2013-08-20','09:50:00',4.38),('8975','2013-08-20','09:55:00',5.1),('8975','2013-08-20','10:00:00',4.07),('8975','2013-08-20','10:05:00',3.29),('8975','2013-08-20','10:10:00',2.75),('8975','2013-08-20','10:15:00',3.11),('8975','2013-08-20','10:20:00',3.26),('8975','2013-08-20','10:25:00',4.45),('8975','2013-08-20','10:30:00',5.03),('8975','2013-08-20','10:35:00',3.25),('8975','2013-08-20','10:40:00',3.81),('8975','2013-08-20','10:45:00',5.68),('8975','2013-08-20','10:50:00',3.9),('8975','2013-08-20','10:55:00',4.41),('8975','2013-08-20','11:00:00',4.68),('8975','2013-08-20','11:05:00',4.12),('8975','2013-08-20','11:10:00',4.14),('8975','2013-08-20','11:15:00',3.56),('8975','2013-08-20','11:20:00',4.78),('8975','2013-08-20','11:25:00',7.06),('8975','2013-08-20','11:30:00',7.16),('8975','2013-08-20','11:35:00',6.65),('8975','2013-08-20','11:40:00',6.52),('8975','2013-08-20','11:45:00',6.57),('8975','2013-08-20','11:50:00',6.39),('8975','2013-08-20','11:55:00',6.15),('8975','2013-08-20','12:00:00',6.24),('8975','2013-08-20','12:05:00',6.22),('8975','2013-08-20','12:10:00',6.23),('8975','2013-08-20','12:15:00',6.12),('8975','2013-08-20','12:20:00',4.58),('8975','2013-08-20','12:25:00',4.33),('8975','2013-08-20','12:30:00',4.43),('8975','2013-08-20','12:35:00',4.25),('8975','2013-08-20','12:40:00',6.3),('8975','2013-08-20','12:45:00',5.85),('8975','2013-08-20','12:50:00',5.65),('8975','2013-08-20','12:55:00',5.72),('8975','2013-08-20','13:00:00',5.87),('8975','2013-08-20','13:05:00',5.88),('8975','2013-08-20','13:10:00',5.96),('8975','2013-08-20','13:15:00',6),('8975','2013-08-20','13:20:00',6.07),('8975','2013-08-20','13:25:00',5.87),('8975','2013-08-20','13:30:00',5.61),('8975','2013-08-20','13:35:00',5.51),('8975','2013-08-20','13:40:00',5.81),('8975','2013-08-20','13:45:00',5.58),('8975','2013-08-20','13:50:00',5.46),('8975','2013-08-20','13:55:00',5.51),('8975','2013-08-20','14:00:00',5.44),('8975','2013-08-20','14:05:00',5.39),('8975','2013-08-20','14:10:00',5.24),('8975','2013-08-20','14:15:00',3.88),('8975','2013-08-20','14:20:00',2.26),('8975','2013-08-20','14:25:00',2.42),('8975','2013-08-20','14:30:00',4.71),('8975','2013-08-20','14:35:00',4.84),('8975','2013-08-20','14:40:00',4.64),('8975','2013-08-20','14:45:00',4.69),('8975','2013-08-20','14:50:00',4.63),('8975','2013-08-20','14:55:00',4.58),('8975','2013-08-20','15:00:00',4.54),('8975','2013-08-20','15:05:00',4.41),('8975','2013-08-20','15:10:00',4.34),('8975','2013-08-20','15:15:00',4.29),('8975','2013-08-20','15:20:00',4.12),('8975','2013-08-20','15:25:00',3.87),('8975','2013-08-20','15:30:00',3.58),('8975','2013-08-20','15:35:00',3.45),('8975','2013-08-20','15:40:00',3.47),('8975','2013-08-20','15:45:00',3.5),('8975','2013-08-20','15:50:00',3.47),('8975','2013-08-20','15:55:00',3.43),('8975','2013-08-20','16:00:00',3.54),('8975','2013-08-20','16:05:00',3.2),('8975','2013-08-20','16:10:00',2.88),('8975','2013-08-20','16:15:00',2.83),('8975','2013-08-20','16:20:00',3),('8975','2013-08-20','16:25:00',3.01),('8975','2013-08-20','16:30:00',2.93),('8975','2013-08-20','16:35:00',3.13),('8975','2013-08-20','16:40:00',3),('8975','2013-08-20','16:45:00',2.8),('8975','2013-08-20','16:50:00',2.66),('8975','2013-08-20','16:55:00',2.61),('8975','2013-08-20','17:00:00',2.51),('8975','2013-08-20','17:05:00',2.41),('8975','2013-08-20','17:10:00',2.35),('8975','2013-08-20','17:15:00',2.27),('8975','2013-08-20','17:20:00',2.17),('8975','2013-08-20','17:25:00',2.11),('8975','2013-08-20','17:30:00',2.06),('8975','2013-08-20','17:35:00',2.01),('8975','2013-08-20','17:40:00',1.95),('8975','2013-08-20','17:45:00',1.89),('8975','2013-08-20','17:50:00',1.82),('8975','2013-08-20','17:55:00',1.76),('8975','2013-08-20','18:00:00',1.68),('8975','2013-08-20','18:05:00',1.61),('8975','2013-08-20','18:10:00',1.54),('8975','2013-08-20','18:15:00',1.41),('8975','2013-08-20','18:20:00',1.33),('8975','2013-08-20','18:25:00',1.24),('8975','2013-08-20','18:30:00',1.09),('8975','2013-08-19','07:40:00',1.11),('8975','2013-08-19','07:45:00',1.17),('8975','2013-08-19','07:50:00',1.98),('8975','2013-08-19','07:55:00',2.48),('8975','2013-08-19','08:00:00',1.83),('8975','2013-08-19','08:05:00',1.61),('8975','2013-08-19','08:10:00',1.13),('8975','2013-08-19','08:15:00',1.12),('8975','2013-08-19','08:20:00',1.27),('8975','2013-08-19','08:25:00',1.22),('8975','2013-08-19','08:30:00',1.18),('8975','2013-08-19','08:35:00',1.19),('8975','2013-08-19','08:40:00',1.26),('8975','2013-08-19','08:45:00',1.42),('8975','2013-08-19','08:50:00',1.62),('8975','2013-08-19','08:55:00',1.53),('8975','2013-08-19','09:00:00',1.94),('8975','2013-08-19','09:05:00',1.66),('8975','2013-08-19','09:10:00',1.83),('8975','2013-08-19','09:15:00',1.76),('8975','2013-08-19','09:20:00',1.79),('8975','2013-08-19','09:25:00',3.14),('8975','2013-08-19','09:30:00',3.55),('8975','2013-08-19','09:35:00',5.14),('8975','2013-08-19','09:40:00',5.42),('8975','2013-08-19','09:45:00',5.05),('8975','2013-08-19','09:50:00',3.26),('8975','2013-08-19','09:55:00',3.32),('8975','2013-08-19','10:00:00',5.14),('8975','2013-08-19','10:05:00',4.74),('8975','2013-08-19','10:10:00',4.6),('8975','2013-08-19','10:15:00',4.99),('8975','2013-08-19','10:20:00',3.64),('8975','2013-08-19','10:25:00',2),('8975','2013-08-19','10:30:00',1.78),('8975','2013-08-19','10:35:00',1.82),('8975','2013-08-19','10:40:00',1.89),('8975','2013-08-19','10:45:00',2.27),('8975','2013-08-19','10:50:00',2.18),('8975','2013-08-19','10:55:00',2.47),('8975','2013-08-19','11:00:00',3.28),('8975','2013-08-19','11:05:00',1.6),('8975','2013-08-19','11:10:00',5.62),('8975','2013-08-19','11:15:00',6.4),('8975','2013-08-19','11:20:00',5.56),('8975','2013-08-19','11:25:00',2.05),('8975','2013-08-19','11:30:00',6.31),('8975','2013-08-19','11:35:00',4.84),('8975','2013-08-19','11:40:00',5.82),('8975','2013-08-19','11:45:00',5.72),('8975','2013-08-19','11:50:00',5.17),('8975','2013-08-19','11:55:00',5.19),('8975','2013-08-19','12:00:00',2.59),('8975','2013-08-19','12:05:00',2.76),('8975','2013-08-19','12:10:00',2.38),('8975','2013-08-19','12:15:00',1.77),('8975','2013-08-19','12:20:00',1.94),('8975','2013-08-19','12:25:00',2.44),('8975','2013-08-19','12:30:00',2.57),('8975','2013-08-19','12:35:00',2.66),('8975','2013-08-19','12:40:00',2.73),('8975','2013-08-19','12:45:00',2.61),('8975','2013-08-19','12:50:00',2.62),('8975','2013-08-19','12:55:00',2.73),('8975','2013-08-19','13:00:00',2.68),('8975','2013-08-19','13:05:00',2.67),('8975','2013-08-19','13:10:00',2.8),('8975','2013-08-19','13:15:00',2.87),('8975','2013-08-19','13:20:00',3.05),('8975','2013-08-19','13:25:00',3.09),('8975','2013-08-19','13:30:00',3.31),('8975','2013-08-19','13:35:00',4.26),('8975','2013-08-19','13:40:00',6.9),('8975','2013-08-19','13:45:00',5.76),('8975','2013-08-19','13:50:00',6.24),('8975','2013-08-19','13:55:00',5.96),('8975','2013-08-19','14:00:00',5.81),('8975','2013-08-19','14:05:00',5.8),('8975','2013-08-19','14:10:00',5.76),('8975','2013-08-19','14:15:00',5.63),('8975','2013-08-19','14:20:00',5.62),('8975','2013-08-19','14:25:00',4.5),('8975','2013-08-19','14:30:00',5.88),('8975','2013-08-19','14:35:00',5.78),('8975','2013-08-19','14:40:00',5.58),('8975','2013-08-19','14:45:00',5.69),('8975','2013-08-19','14:50:00',5.44),('8975','2013-08-19','14:55:00',3.82),('8975','2013-08-19','15:00:00',4.07),('8975','2013-08-19','15:05:00',5.35),('8975','2013-08-19','15:10:00',5.18),('8975','2013-08-19','15:15:00',5.14),('8975','2013-08-19','15:20:00',4.97),('8975','2013-08-19','15:25:00',4.87),('8975','2013-08-19','15:30:00',4.81),('8975','2013-08-19','15:35:00',4.69),('8975','2013-08-19','15:40:00',4.64),('8975','2013-08-19','15:45:00',4.92),('8975','2013-08-19','15:50:00',4.72),('8975','2013-08-19','15:55:00',5.43),('8975','2013-08-19','16:00:00',4.55),('8975','2013-08-19','16:05:00',4.75),('8975','2013-08-19','16:10:00',4.53),('8975','2013-08-19','16:15:00',4.39),('8975','2013-08-19','16:20:00',4.29),('8975','2013-08-19','16:25:00',4.16),('8975','2013-08-19','16:30:00',3.79),('8975','2013-08-19','16:35:00',3.85),('8975','2013-08-19','16:40:00',3.84),('8975','2013-08-19','16:45:00',3.72),('8975','2013-08-19','16:50:00',3.42),('8975','2013-08-19','16:55:00',3.16),('8975','2013-08-19','17:00:00',2.86),('8975','2013-08-19','17:05:00',2.45),('8975','2013-08-19','17:10:00',2.24),('8975','2013-08-19','17:15:00',2.2),('8975','2013-08-19','17:20:00',2.06),('8975','2013-08-19','17:25:00',1.79),('8975','2013-08-19','17:30:00',1.86),('8975','2013-08-19','17:35:00',1.81),('8975','2013-08-19','17:40:00',1.81),('8975','2013-08-19','17:45:00',1.74),('8975','2013-08-19','17:50:00',1.61),('8975','2013-08-19','17:55:00',1.44),('8975','2013-08-19','18:00:00',1.29),('8975','2013-08-19','18:05:00',1.29),('8975','2013-08-19','18:10:00',1.46),('8975','2013-08-19','18:15:00',1.57),('8975','2013-08-19','18:20:00',1.5),('8975','2013-08-19','18:25:00',1.48),('8975','2013-08-19','18:30:00',1.51),('8975','2013-08-19','18:35:00',1.42),('8975','2013-08-19','18:40:00',1.44),('8975','2013-08-19','18:45:00',1.4),('8975','2013-08-19','18:50:00',1.05),('8975','2013-08-19','18:55:00',1.24),('8975','2013-08-19','19:00:00',1.13),('8975','2014-04-09','07:10:00',1.14),('8975','2014-04-09','07:15:00',1.45),('8975','2014-04-09','07:20:00',1.51),('8975','2014-04-09','07:25:00',1.85),('8975','2014-04-09','07:30:00',1.97),('8975','2014-04-09','07:35:00',2.2),('8975','2014-04-09','07:40:00',2.21),('8975','2014-04-09','07:45:00',2.51),('8975','2014-04-09','07:50:00',2.57),('8975','2014-04-09','07:55:00',2.87),('8975','2014-04-09','08:00:00',3.05),('8975','2014-04-09','08:05:00',3.21),('8975','2014-04-09','08:10:00',3.33),('8975','2014-04-09','08:15:00',3.43),('8975','2014-04-09','08:20:00',3.56),('8975','2014-04-09','08:25:00',3.67),('8975','2014-04-09','08:30:00',3.77),('8975','2014-04-09','08:35:00',3.86),('8975','2014-04-09','08:40:00',3.97),('8975','2014-04-09','08:45:00',4.08),('8975','2014-04-09','08:50:00',4.16),('8975','2014-04-09','08:55:00',4.25),('8975','2014-04-09','09:00:00',4.32),('8975','2014-04-09','09:05:00',4.47),('8975','2014-04-09','09:10:00',4.55),('8975','2014-04-09','09:15:00',4.61),('8975','2014-04-09','09:20:00',4.67),('8975','2014-04-09','09:25:00',4.83),('8975','2014-04-09','09:30:00',4.95),('8975','2014-04-09','09:35:00',5.04),('8975','2014-04-09','09:40:00',5.11),('8975','2014-04-09','09:45:00',5.18),('8975','2014-04-09','09:50:00',5.29),('8975','2014-04-09','09:55:00',5.38),('8975','2014-04-09','10:00:00',5.43),('8975','2014-04-09','10:05:00',5.52),('8975','2014-04-09','10:10:00',5.67),('8975','2014-04-09','10:15:00',5.65),('8975','2014-04-09','10:20:00',5.69),('8975','2014-04-09','10:25:00',5.74),('8975','2014-04-09','10:30:00',5.79),('8975','2014-04-09','10:35:00',5.95),('8975','2014-04-09','10:40:00',6.05),('8975','2014-04-09','10:45:00',6),('8975','2014-04-09','10:50:00',5.94),('8975','2014-04-09','10:55:00',5.97),('8975','2014-04-09','11:00:00',5.98),('8975','2014-04-09','11:05:00',6.31),('8975','2014-04-09','11:10:00',6.02),('8975','2014-04-09','11:15:00',6.31),('8975','2014-04-09','11:20:00',6.35),('8975','2014-04-09','11:25:00',6.53),('8975','2014-04-09','11:30:00',6.47),('8975','2014-04-09','11:35:00',6.55),('8975','2014-04-09','11:40:00',6.38),('8975','2014-04-09','11:45:00',6.52),('8975','2014-04-09','11:50:00',6.27),('8975','2014-04-09','11:55:00',6.45),('8975','2014-04-09','12:00:00',6.36),('8975','2014-04-09','12:05:00',5.87),('8975','2014-04-09','12:10:00',6.18),('8975','2014-04-09','12:15:00',6.39),('8975','2014-04-09','12:20:00',6.29),('8975','2014-04-09','12:25:00',5.95),('8975','2014-04-09','12:30:00',6.01),('8975','2014-04-09','12:35:00',6.47),('8975','2014-04-09','12:40:00',6.12),('8975','2014-04-09','12:45:00',6.22),('8975','2014-04-09','12:50:00',6.29),('8975','2014-04-09','12:55:00',6.16),('8975','2014-04-09','13:00:00',6.11),('8975','2014-04-09','13:05:00',5.67),('8975','2014-04-09','13:10:00',6.11),('8975','2014-04-09','13:15:00',5.93),('8975','2014-04-09','13:20:00',5.49),('8975','2014-04-09','13:25:00',6.21),('8975','2014-04-09','13:30:00',5.96),('8975','2014-04-09','13:35:00',6.18),('8975','2014-04-09','13:40:00',5.87),('8975','2014-04-09','13:45:00',5.92),('8975','2014-04-09','13:50:00',5.97),('8975','2014-04-09','13:55:00',5.93),('8975','2014-04-09','14:00:00',5.85),('8975','2014-04-09','14:05:00',5.75),('8975','2014-04-09','14:10:00',5.58),('8975','2014-04-09','14:15:00',5.66),('8975','2014-04-09','14:20:00',5.63),('8975','2014-04-09','14:25:00',5.57),('8975','2014-04-09','14:30:00',5.5),('8975','2014-04-09','14:35:00',5.42),('8975','2014-04-09','14:40:00',5.29),('8975','2014-04-09','14:45:00',4.63),('8975','2014-04-09','14:50:00',5.11),('8975','2014-04-09','14:55:00',5.09),('8975','2014-04-09','15:00:00',4.97),('8975','2014-04-09','15:05:00',4.85),('8975','2014-04-09','15:10:00',4.72),('8975','2014-04-09','15:15:00',4.5),('8975','2014-04-09','15:20:00',4.36),('8975','2014-04-09','15:25:00',4.21),('8975','2014-04-09','15:30:00',3.99),('8975','2014-04-09','15:35:00',3.81),('8975','2014-04-09','15:40:00',3.64),('8975','2014-04-09','15:45:00',3.75),('8975','2014-04-09','15:50:00',3.58),('8975','2014-04-09','15:55:00',3.57),('8975','2014-04-09','16:00:00',3.57),('8975','2014-04-09','16:05:00',3.57),('8975','2014-04-09','16:10:00',3.51),('8975','2014-04-09','16:15:00',3.54),('8975','2014-04-09','16:20:00',3.39),('8975','2014-04-09','16:25:00',3.26),('8975','2014-04-09','16:30:00',3.19),('8975','2014-04-09','16:35:00',3.08),('8975','2014-04-09','16:40:00',2.95),('8975','2014-04-09','16:45:00',2.91),('8975','2014-04-09','16:50:00',2.64),('8975','2014-04-09','16:55:00',2.52),('8975','2014-04-09','17:00:00',2.4),('8975','2014-04-09','17:05:00',2.25),('8975','2014-04-09','17:10:00',2.2),('8975','2014-04-09','17:15:00',2.04),('8975','2014-04-09','17:20:00',1.96),('8975','2014-04-09','17:25:00',1.84),('8975','2014-04-09','17:30:00',1.72),('8975','2014-04-09','17:35:00',1.65),('8975','2014-04-09','17:40:00',1.59),('8975','2014-04-09','17:45:00',1.54),('8975','2014-04-09','17:50:00',1.5),('8975','2014-04-09','17:55:00',1.44),('8975','2014-04-09','18:00:00',1.39),('8975','2014-04-09','18:05:00',1.34),('8975','2014-04-09','18:10:00',1.28),('8975','2014-04-09','18:15:00',1.22),('8975','2014-04-09','18:20:00',1.16),('8975','2014-04-09','18:25:00',1.08),('8975','2014-04-09','18:30:00',1.02),('8975','2013-08-18','07:10:00',1.01),('8975','2013-08-18','07:20:00',1.42),('8975','2013-08-18','07:25:00',1.44),('8975','2013-08-18','07:30:00',1.41),('8975','2013-08-18','07:35:00',1.26),('8975','2013-08-18','07:40:00',1.87),('8975','2013-08-18','07:45:00',2.15),('8975','2013-08-18','07:50:00',2.1),('8975','2013-08-18','07:55:00',2.05),('8975','2013-08-18','08:00:00',2.52),('8975','2013-08-18','08:05:00',2.75),('8975','2013-08-18','08:10:00',2.83),('8975','2013-08-18','08:15:00',2.99),('8975','2013-08-18','08:20:00',3.07),('8975','2013-08-18','08:25:00',3.14),('8975','2013-08-18','08:30:00',3.31),('8975','2013-08-18','08:35:00',3.4),('8975','2013-08-18','08:40:00',3.55),('8975','2013-08-18','08:45:00',3.66),('8975','2013-08-18','08:50:00',3.79),('8975','2013-08-18','08:55:00',3.91),('8975','2013-08-18','09:00:00',4),('8975','2013-08-18','09:05:00',4.1),('8975','2013-08-18','09:10:00',4.17),('8975','2013-08-18','09:15:00',4.23),('8975','2013-08-18','09:20:00',4.34),('8975','2013-08-18','09:25:00',4.42),('8975','2013-08-18','09:30:00',4.5),('8975','2013-08-18','09:35:00',4.61),('8975','2013-08-18','09:40:00',4.68),('8975','2013-08-18','09:45:00',4.74),('8975','2013-08-18','09:50:00',4.82),('8975','2013-08-18','09:55:00',4.87),('8975','2013-08-18','10:00:00',4.93),('8975','2013-08-18','10:05:00',4.99),('8975','2013-08-18','10:10:00',5.06),('8975','2013-08-18','10:15:00',5.15),('8975','2013-08-18','10:20:00',5.22),('8975','2013-08-18','10:25:00',5.29),('8975','2013-08-18','10:30:00',5.34),('8975','2013-08-18','10:35:00',5.39),('8975','2013-08-18','10:40:00',5.43),('8975','2013-08-18','10:45:00',5.48),('8975','2013-08-18','10:50:00',5.54),('8975','2013-08-18','10:55:00',5.56),('8975','2013-08-18','11:00:00',5.52),('8975','2013-08-18','11:05:00',5.58),('8975','2013-08-18','11:10:00',5.59),('8975','2013-08-18','11:15:00',5.72),('8975','2013-08-18','11:20:00',5.8),('8975','2013-08-18','11:25:00',5.78),('8975','2013-08-18','11:30:00',5.84),('8975','2013-08-18','11:35:00',5.8),('8975','2013-08-18','11:40:00',5.81),('8975','2013-08-18','11:45:00',5.88),('8975','2013-08-18','11:50:00',5.84),('8975','2013-08-18','11:55:00',5.91),('8975','2013-08-18','12:00:00',5.88),('8975','2013-08-18','12:05:00',5.87),('8975','2013-08-18','12:10:00',5.9),('8975','2013-08-18','12:15:00',5.96),('8975','2013-08-18','12:20:00',5.99),('8975','2013-08-18','12:25:00',6.01),('8975','2013-08-18','12:30:00',6.01),('8975','2013-08-18','12:35:00',5.95),('8975','2013-08-18','12:40:00',5.94),('8975','2013-08-18','12:45:00',6),('8975','2013-08-18','12:50:00',6.01),('8975','2013-08-18','12:55:00',6.06),('8975','2013-08-18','13:00:00',6.02),('8975','2013-08-18','13:05:00',6.04),('8975','2013-08-18','13:10:00',6.01),('8975','2013-08-18','13:15:00',5.93),('8975','2013-08-18','13:20:00',5.91),('8975','2013-08-18','13:25:00',5.92),('8975','2013-08-18','13:30:00',5.87),('8975','2013-08-18','13:35:00',5.86),('8975','2013-08-18','13:40:00',5.82),('8975','2013-08-18','13:45:00',5.78),('8975','2013-08-18','13:50:00',5.74),('8975','2013-08-18','13:55:00',5.71),('8975','2013-08-18','14:00:00',5.62),('8975','2013-08-18','14:05:00',5.58),('8975','2013-08-18','14:10:00',5.52),('8975','2013-08-18','14:15:00',5.45),('8975','2013-08-18','14:20:00',5.43),('8975','2013-08-18','14:25:00',5.35),('8975','2013-08-18','14:30:00',5.3),('8975','2013-08-18','14:35:00',5.25),('8975','2013-08-18','14:40:00',5.17),('8975','2013-08-18','14:45:00',5.12),('8975','2013-08-18','14:50:00',5.04),('8975','2013-08-18','14:55:00',4.98),('8975','2013-08-18','15:00:00',4.89),('8975','2013-08-18','15:05:00',4.79),('8975','2013-08-18','15:10:00',4.72),('8975','2013-08-18','15:15:00',4.64),('8975','2013-08-18','15:20:00',4.56),('8975','2013-08-18','15:25:00',4.47),('8975','2013-08-18','15:30:00',4.38),('8975','2013-08-18','15:35:00',4.22),('8975','2013-08-18','15:40:00',4.06),('8975','2013-08-18','15:45:00',4.06),('8975','2013-08-18','15:50:00',3.95),('8975','2013-08-18','15:55:00',3.86),('8975','2013-08-18','16:00:00',3.76),('8975','2013-08-18','16:05:00',3.63),('8975','2013-08-18','16:10:00',3.52),('8975','2013-08-18','16:15:00',3.42),('8975','2013-08-18','16:20:00',3.32),('8975','2013-08-18','16:25:00',3.22),('8975','2013-08-18','16:30:00',3.1),('8975','2013-08-18','16:35:00',2.99),('8975','2013-08-18','16:40:00',2.87),('8975','2013-08-18','16:45:00',2.77),('8975','2013-08-18','16:50:00',2.64),('8975','2013-08-18','16:55:00',2.51),('8975','2013-08-18','17:00:00',2.41),('8975','2013-08-18','17:05:00',2.3),('8975','2013-08-18','17:10:00',2.19),('8975','2013-08-18','17:15:00',2.09),('8975','2013-08-18','17:20:00',1.99),('8975','2013-08-18','17:25:00',1.91),('8975','2013-08-18','17:30:00',1.81),('8975','2013-08-18','17:35:00',1.72),('8975','2013-08-18','17:40:00',1.65),('8975','2013-08-18','17:45:00',1.57),('8975','2013-08-18','17:50:00',1.5),('8975','2013-08-18','17:55:00',1.45),('8975','2013-08-18','18:00:00',1.38),('8975','2013-08-18','18:05:00',1.34),('8975','2013-08-18','18:10:00',1.29),('8975','2013-08-18','18:15:00',1.25),('8975','2013-08-18','18:20:00',1.18),('8975','2013-08-18','18:25:00',1.12),('8975','2013-08-18','18:30:00',1.07),('8975','2013-08-18','18:35:00',1.03),('8975','2013-08-17','07:05:00',1.1),('8975','2013-08-17','07:10:00',1.2),('8975','2013-08-17','07:15:00',1.34),('8975','2013-08-17','07:20:00',1.5),('8975','2013-08-17','07:25:00',1.67),('8975','2013-08-17','07:30:00',1.93),('8975','2013-08-17','07:35:00',2.14),('8975','2013-08-17','07:40:00',2.3),('8975','2013-08-17','07:45:00',2.44),('8975','2013-08-17','07:50:00',2.57),('8975','2013-08-17','07:55:00',2.68),('8975','2013-08-17','08:00:00',2.8),('8975','2013-08-17','08:05:00',2.93),('8975','2013-08-17','08:10:00',3.05),('8975','2013-08-17','08:15:00',3.18),('8975','2013-08-17','08:20:00',3.29),('8975','2013-08-17','08:25:00',3.37),('8975','2013-08-17','08:30:00',3.43),('8975','2013-08-17','08:35:00',3.53),('8975','2013-08-17','08:40:00',3.61),('8975','2013-08-17','08:45:00',3.73),('8975','2013-08-17','08:50:00',3.82),('8975','2013-08-17','08:55:00',3.91),('8975','2013-08-17','09:00:00',4.04),('8975','2013-08-17','09:05:00',4.14),('8975','2013-08-17','09:10:00',4.24),('8975','2013-08-17','09:15:00',4.36),('8975','2013-08-17','09:20:00',4.47),('8975','2013-08-17','09:25:00',4.55),('8975','2013-08-17','09:30:00',4.64),('8975','2013-08-17','09:35:00',4.71),('8975','2013-08-17','09:40:00',4.83),('8975','2013-08-17','09:45:00',4.76),('8975','2013-08-17','09:50:00',4.2),('8975','2013-08-17','09:55:00',4.51),('8975','2013-08-17','10:00:00',4.97),('8975','2013-08-17','10:05:00',4.41),('8975','2013-08-17','10:10:00',5.08),('8975','2013-08-17','10:15:00',5.2),('8975','2013-08-17','10:20:00',5.22),('8975','2013-08-17','10:25:00',5.26),('8975','2013-08-17','10:30:00',5.29),('8975','2013-08-17','10:35:00',5.36),('8975','2013-08-17','10:40:00',5.41),('8975','2013-08-17','10:45:00',5.47),('8975','2013-08-17','10:50:00',5.56),('8975','2013-08-17','10:55:00',5.57),('8975','2013-08-17','11:00:00',5.53),('8975','2013-08-17','11:05:00',5.44),('8975','2013-08-17','11:10:00',5.51),('8975','2013-08-17','11:15:00',5.6),('8975','2013-08-17','11:20:00',5.66),('8975','2013-08-17','11:25:00',5.69),('8975','2013-08-17','11:30:00',5.76),('8975','2013-08-17','11:35:00',5.83),('8975','2013-08-17','11:40:00',5.82),('8975','2013-08-17','11:45:00',5.81),('8975','2013-08-17','11:50:00',5.75),('8975','2013-08-17','11:55:00',5.75),('8975','2013-08-17','12:00:00',5.85),('8975','2013-08-17','12:05:00',5.76),('8975','2013-08-17','12:10:00',5.97),('8975','2013-08-17','12:15:00',5.94),('8975','2013-08-17','12:20:00',6.05),('8975','2013-08-17','12:25:00',6.15),('8975','2013-08-17','12:30:00',6.25),('8975','2013-08-17','12:35:00',6.3),('8975','2013-08-17','12:40:00',6.15),('8975','2013-08-17','12:45:00',5.4),('8975','2013-08-17','12:50:00',5.37),('8975','2013-08-17','12:55:00',3.31),('8975','2013-08-17','13:00:00',5.9),('8975','2013-08-17','13:05:00',4.31),('8975','2013-08-17','13:10:00',6.29),('8975','2013-08-17','13:15:00',6.31),('8975','2013-08-17','13:20:00',3.97),('8975','2013-08-17','13:25:00',6.15),('8975','2013-08-17','13:30:00',6.03),('8975','2013-08-17','13:35:00',5.85),('8975','2013-08-17','13:40:00',5.12),('8975','2013-08-17','13:45:00',5.63),('8975','2013-08-17','13:50:00',5.83),('8975','2013-08-17','13:55:00',5.72),('8975','2013-08-17','14:00:00',5.67),('8975','2013-08-17','14:05:00',5.55),('8975','2013-08-17','14:10:00',5.5),('8975','2013-08-17','14:15:00',5.42),('8975','2013-08-17','14:20:00',5.32),('8975','2013-08-17','14:25:00',5.27),('8975','2013-08-17','14:30:00',5.28),('8975','2013-08-17','14:35:00',5.22),('8975','2013-08-17','14:40:00',5.17),('8975','2013-08-17','14:45:00',5.03),('8975','2013-08-17','14:50:00',5.03),('8975','2013-08-17','14:55:00',4.96),('8975','2013-08-17','15:00:00',4.86),('8975','2013-08-17','15:05:00',4.82),('8975','2013-08-17','15:10:00',4.77),('8975','2013-08-17','15:15:00',4.64),('8975','2013-08-17','15:20:00',4.57),('8975','2013-08-17','15:25:00',4.48),('8975','2013-08-17','15:30:00',4.35),('8975','2013-08-17','15:35:00',4.23),('8975','2013-08-17','15:40:00',4.1),('8975','2013-08-17','15:45:00',4.01),('8975','2013-08-17','15:50:00',3.97),('8975','2013-08-17','15:55:00',3.87),('8975','2013-08-17','16:00:00',3.77),('8975','2013-08-17','16:05:00',3.64),('8975','2013-08-17','16:10:00',3.52),('8975','2013-08-17','16:15:00',3.42),('8975','2013-08-17','16:20:00',3.33),('8975','2013-08-17','16:25:00',3.23),('8975','2013-08-17','16:30:00',3.11),('8975','2013-08-17','16:35:00',3.03),('8975','2013-08-17','16:40:00',2.92),('8975','2013-08-17','16:45:00',2.81),('8975','2013-08-17','16:50:00',2.7),('8975','2013-08-17','16:55:00',2.59),('8975','2013-08-17','17:00:00',2.46),('8975','2013-08-17','17:05:00',2.35),('8975','2013-08-17','17:10:00',2.25),('8975','2013-08-17','17:15:00',2.14),('8975','2013-08-17','17:20:00',2.05),('8975','2013-08-17','17:25:00',1.94),('8975','2013-08-17','17:30:00',1.85),('8975','2013-08-17','17:35:00',1.77),('8975','2013-08-17','17:40:00',1.68),('8975','2013-08-17','17:45:00',1.58),('8975','2013-08-17','17:50:00',1.52),('8975','2013-08-17','17:55:00',1.46),('8975','2013-08-17','18:00:00',1.39),('8975','2013-08-17','18:05:00',1.34),('8975','2013-08-17','18:10:00',1.3),('8975','2013-08-17','18:15:00',1.26),('8975','2013-08-17','18:20:00',1.21),('8975','2013-08-17','18:25:00',1.14),('8975','2013-08-17','18:30:00',1.08),('8975','2013-08-17','18:35:00',1.03),('8975','2013-08-16','07:00:00',1.03),('8975','2013-08-16','07:05:00',1.16),('8975','2013-08-16','07:10:00',1.28),('8975','2013-08-16','07:15:00',1.32),('8975','2013-08-16','07:20:00',1.62),('8975','2013-08-16','07:25:00',1.72),('8975','2013-08-16','07:30:00',1.89),('8975','2013-08-16','07:35:00',2.07),('8975','2013-08-16','07:40:00',2.21),('8975','2013-08-16','07:45:00',2.35),('8975','2013-08-16','07:50:00',2.49),('8975','2013-08-16','07:55:00',2.62),('8975','2013-08-16','08:00:00',2.72),('8975','2013-08-16','08:05:00',2.8),('8975','2013-08-16','08:10:00',2.9),('8975','2013-08-16','08:15:00',3.02),('8975','2013-08-16','08:20:00',3.13),('8975','2013-08-16','08:25:00',3.22),('8975','2013-08-16','08:30:00',3.34),('8975','2013-08-16','08:35:00',3.47),('8975','2013-08-16','08:40:00',3.58),('8975','2013-08-16','08:45:00',3.72),('8975','2013-08-16','08:50:00',3.84),('8975','2013-08-16','08:55:00',3.95),('8975','2013-08-16','09:00:00',4.03),('8975','2013-08-16','09:05:00',4.13),('8975','2013-08-16','09:10:00',4.22),('8975','2013-08-16','09:15:00',4.31),('8975','2013-08-16','09:20:00',4.4),('8975','2013-08-16','09:25:00',4.49),('8975','2013-08-16','09:30:00',4.59),('8975','2013-08-16','09:35:00',4.67),('8975','2013-08-16','09:40:00',4.75),('8975','2013-08-16','09:45:00',4.82),('8975','2013-08-16','09:50:00',4.89),('8975','2013-08-16','09:55:00',4.98),('8975','2013-08-16','10:00:00',5.04),('8975','2013-08-16','10:05:00',5.12),('8975','2013-08-16','10:10:00',5.19),('8975','2013-08-16','10:15:00',5.27),('8975','2013-08-16','10:20:00',5.33),('8975','2013-08-16','10:25:00',5.36),('8975','2013-08-16','10:30:00',5.4),('8975','2013-08-16','10:35:00',5.46),('8975','2013-08-16','10:40:00',5.5),('8975','2013-08-16','10:45:00',5.56),('8975','2013-08-16','10:50:00',5.57),('8975','2013-08-16','10:55:00',5.61),('8975','2013-08-16','11:00:00',5.64),('8975','2013-08-16','11:05:00',5.65),('8975','2013-08-16','11:10:00',5.68),('8975','2013-08-16','11:15:00',5.8),('8975','2013-08-16','11:20:00',5.78),('8975','2013-08-16','11:25:00',5.81),('8975','2013-08-16','11:30:00',5.82),('8975','2013-08-16','11:35:00',5.88),('8975','2013-08-16','11:40:00',5.92),('8975','2013-08-16','11:45:00',5.93),('8975','2013-08-16','11:50:00',5.95),('8975','2013-08-16','11:55:00',6.01),('8975','2013-08-16','12:00:00',6.03),('8975','2013-08-16','12:05:00',5.9),('8975','2013-08-16','12:10:00',5.25),('8975','2013-08-16','12:15:00',1.13),('8975','2013-08-16','12:20:00',1.35),('8975','2013-08-16','12:25:00',5.24),('8975','2013-08-16','12:30:00',6.46),('8975','2013-08-16','12:35:00',6.42),('8975','2013-08-16','12:40:00',6.31),('8975','2013-08-16','12:45:00',6.09),('8975','2013-08-16','12:50:00',6.12),('8975','2013-08-16','12:55:00',6.01),('8975','2013-08-16','13:00:00',6.08),('8975','2013-08-16','13:05:00',6.05),('8975','2013-08-16','13:10:00',5.97),('8975','2013-08-16','13:15:00',5.84),('8975','2013-08-16','13:20:00',6.08),('8975','2013-08-16','13:25:00',5.96),('8975','2013-08-16','13:30:00',6.12),('8975','2013-08-16','13:35:00',5.54),('8975','2013-08-16','13:40:00',1.37),('8975','2013-08-16','13:45:00',3.78),('8975','2013-08-16','13:50:00',4.13),('8975','2013-08-16','13:55:00',1.44),('8975','2013-08-16','14:00:00',2.28),('8975','2013-08-16','14:05:00',2.66),('8975','2013-08-16','14:10:00',1.35),('8975','2013-08-16','14:15:00',3.96),('8975','2013-08-16','14:20:00',5.37),('8975','2013-08-16','14:25:00',4.42),('8975','2013-08-16','14:30:00',5.57),('8975','2013-08-16','14:35:00',5.34),('8975','2013-08-16','14:40:00',5.32),('8975','2013-08-16','14:45:00',5.2),('8975','2013-08-16','14:50:00',5.11),('8975','2013-08-16','14:55:00',5.03),('8975','2013-08-16','15:00:00',4.95),('8975','2013-08-16','15:05:00',4.84),('8975','2013-08-16','15:10:00',4.76),('8975','2013-08-16','15:15:00',4.68),('8975','2013-08-16','15:20:00',4.61),('8975','2013-08-16','15:25:00',4.51),('8975','2013-08-16','15:30:00',4.43),('8975','2013-08-16','15:35:00',4.28),('8975','2013-08-16','15:40:00',4.19),('8975','2013-08-16','15:45:00',4.09),('8975','2013-08-16','15:50:00',4),('8975','2013-08-16','15:55:00',3.89),('8975','2013-08-16','16:00:00',3.78),('8975','2013-08-16','16:05:00',3.7),('8975','2013-08-16','16:10:00',3.57),('8975','2013-08-16','16:15:00',3.46),('8975','2013-08-16','16:20:00',3.37),('8975','2013-08-16','16:25:00',3.26),('8975','2013-08-16','16:30:00',3.18),('8975','2013-08-16','16:35:00',3.1),('8975','2013-08-16','16:40:00',3),('8975','2013-08-16','16:45:00',2.72),('8975','2013-08-16','16:50:00',2.68),('8975','2013-08-16','16:55:00',2.64),('8975','2013-08-16','17:00:00',2.52),('8975','2013-08-16','17:05:00',2.33),('8975','2013-08-16','17:10:00',2.1),('8975','2013-08-16','17:15:00',2.02),('8975','2013-08-16','17:20:00',1.97),('8975','2013-08-16','17:25:00',2),('8975','2013-08-16','17:30:00',1.95),('8975','2013-08-16','17:35:00',1.89),('8975','2013-08-16','17:40:00',1.82),('8975','2013-08-16','17:45:00',1.74),('8975','2013-08-16','17:50:00',1.66),('8975','2013-08-16','17:55:00',1.58),('8975','2013-08-16','18:00:00',1.51),('8975','2013-08-16','18:05:00',1.46),('8975','2013-08-16','18:10:00',1.4),('8975','2013-08-16','18:15:00',1.36),('8975','2013-08-16','18:20:00',1.3),('8975','2013-08-16','18:25:00',1.23),('8975','2013-08-16','18:30:00',1.16),('8975','2013-08-16','18:35:00',1.09),('8975','2013-08-16','18:40:00',1.05),('8975','2013-08-15','07:00:00',1.06),('8975','2013-08-15','07:05:00',1.25),('8975','2013-08-15','07:10:00',1.38),('8975','2013-08-15','07:15:00',1.42),('8975','2013-08-15','07:20:00',1.69),('8975','2013-08-15','07:25:00',1.85),('8975','2013-08-15','07:30:00',1.96),('8975','2013-08-15','07:35:00',2.21),('8975','2013-08-15','07:40:00',2.35),('8975','2013-08-15','07:45:00',2.5),('8975','2013-08-15','07:50:00',2.62),('8975','2013-08-15','07:55:00',2.74),('8975','2013-08-15','08:00:00',2.86),('8975','2013-08-15','08:05:00',2.97),('8975','2013-08-15','08:10:00',3.09),('8975','2013-08-15','08:15:00',3.2),('8975','2013-08-15','08:20:00',3.33),('8975','2013-08-15','08:25:00',3.44),('8975','2013-08-15','08:30:00',3.54),('8975','2013-08-15','08:35:00',3.65),('8975','2013-08-15','08:40:00',3.71),('8975','2013-08-15','08:45:00',3.84),('8975','2013-08-15','08:50:00',3.95),('8975','2013-08-15','08:55:00',4.05),('8975','2013-08-15','09:00:00',4.16),('8975','2013-08-15','09:05:00',4.28),('8975','2013-08-15','09:10:00',4.39),('8975','2013-08-15','09:15:00',4.49),('8975','2013-08-15','09:20:00',4.62),('8975','2013-08-15','09:25:00',4.71),('8975','2013-08-15','09:30:00',4.8),('8975','2013-08-15','09:35:00',4.88),('8975','2013-08-15','09:40:00',4.96),('8975','2013-08-15','09:45:00',5.05),('8975','2013-08-15','09:50:00',5.13),('8975','2013-08-15','09:55:00',5.21),('8975','2013-08-15','10:00:00',5.27),('8975','2013-08-15','10:05:00',5.32),('8975','2013-08-15','10:10:00',5.4),('8975','2013-08-15','10:15:00',5.46),('8975','2013-08-15','10:20:00',5.52),('8975','2013-08-15','10:25:00',5.59),('8975','2013-08-15','10:30:00',5.65),('8975','2013-08-15','10:35:00',5.67),('8975','2013-08-15','10:40:00',5.72),('8975','2013-08-15','10:45:00',5.75),('8975','2013-08-15','10:50:00',5.82),('8975','2013-08-15','10:55:00',5.88),('8975','2013-08-15','11:00:00',5.92),('8975','2013-08-15','11:05:00',5.96),('8975','2013-08-15','11:10:00',6),('8975','2013-08-15','11:15:00',6.02),('8975','2013-08-15','11:20:00',6.03),('8975','2013-08-15','11:25:00',6.04),('8975','2013-08-15','11:30:00',6.08),('8975','2013-08-15','11:35:00',6.13),('8975','2013-08-15','11:40:00',6.13),('8975','2013-08-15','11:45:00',6.11),('8975','2013-08-15','11:50:00',6.08),('8975','2013-08-15','11:55:00',6.1),('8975','2013-08-15','12:00:00',6.11),('8975','2013-08-15','12:05:00',6.14),('8975','2013-08-15','12:10:00',6.13),('8975','2013-08-15','12:15:00',6.16),('8975','2013-08-15','12:20:00',6.13),('8975','2013-08-15','12:25:00',6.1),('8975','2013-08-15','12:30:00',6.09),('8975','2013-08-15','12:35:00',6.07),('8975','2013-08-15','12:40:00',6.05),('8975','2013-08-15','12:45:00',6.08),('8975','2013-08-15','12:50:00',6.05),('8975','2013-08-15','12:55:00',5.99),('8975','2013-08-15','13:00:00',5.98),('8975','2013-08-15','13:05:00',5.94),('8975','2013-08-15','13:10:00',5.92),('8975','2013-08-15','13:15:00',5.91),('8975','2013-08-15','13:20:00',5.91),('8975','2013-08-15','13:25:00',5.87),('8975','2013-08-15','13:30:00',5.83),('8975','2013-08-15','13:35:00',5.81),('8975','2013-08-15','13:40:00',5.79),('8975','2013-08-15','13:45:00',5.74),('8975','2013-08-15','13:50:00',5.69),('8975','2013-08-15','13:55:00',5.63),('8975','2013-08-15','14:00:00',5.59),('8975','2013-08-15','14:05:00',5.59),('8975','2013-08-15','14:10:00',5.53),('8975','2013-08-15','14:15:00',5.45),('8975','2013-08-15','14:20:00',5.37),('8975','2013-08-15','14:25:00',5.29),('8975','2013-08-15','14:30:00',5.26),('8975','2013-08-15','14:35:00',5.15),('8975','2013-08-15','14:40:00',5.05),('8975','2013-08-15','14:45:00',4.99),('8975','2013-08-15','14:50:00',4.97),('8975','2013-08-15','14:55:00',4.85),('8975','2013-08-15','15:00:00',4.8),('8975','2013-08-15','15:05:00',4.74),('8975','2013-08-15','15:10:00',4.65),('8975','2013-08-15','15:15:00',4.64),('8975','2013-08-15','15:20:00',4.58),('8975','2013-08-15','15:25:00',4.45),('8975','2013-08-15','15:30:00',4.37),('8975','2013-08-15','15:35:00',4.31),('8975','2013-08-15','15:40:00',4.2),('8975','2013-08-15','15:45:00',4.1),('8975','2013-08-15','15:50:00',3.99),('8975','2013-08-15','15:55:00',3.88),('8975','2013-08-15','16:00:00',3.79),('8975','2013-08-15','16:05:00',3.7),('8975','2013-08-15','16:10:00',3.59),('8975','2013-08-15','16:15:00',3.47),('8975','2013-08-15','16:20:00',3.38),('8975','2013-08-15','16:25:00',3.28),('8975','2013-08-15','16:30:00',3.17),('8975','2013-08-15','16:35:00',3.07),('8975','2013-08-15','16:40:00',2.94),('8975','2013-08-15','16:45:00',2.83),('8975','2013-08-15','16:50:00',2.73),('8975','2013-08-15','16:55:00',2.6),('8975','2013-08-15','17:00:00',2.48),('8975','2013-08-15','17:05:00',2.36),('8975','2013-08-15','17:10:00',2.25),('8975','2013-08-15','17:15:00',2.15),('8975','2013-08-15','17:20:00',2.05),('8975','2013-08-15','17:25:00',1.94),('8975','2013-08-15','17:30:00',1.85),('8975','2013-08-15','17:35:00',1.76),('8975','2013-08-15','17:40:00',1.68),('8975','2013-08-15','17:45:00',1.6),('8975','2013-08-15','17:50:00',1.53),('8975','2013-08-15','17:55:00',1.47),('8975','2013-08-15','18:00:00',1.41),('8975','2013-08-15','18:05:00',1.35),('8975','2013-08-15','18:10:00',1.31),('8975','2013-08-15','18:15:00',1.25),('8975','2013-08-15','18:20:00',1.2),('8975','2013-08-15','18:25:00',1.15),('8975','2013-08-15','18:30:00',1.07),('8975','2013-08-14','07:45:00',1.03),('8975','2013-08-14','07:50:00',1.52),('8975','2013-08-14','07:55:00',2.95),('8975','2013-08-14','08:00:00',3.03),('8975','2013-08-14','08:05:00',3.36),('8975','2013-08-14','08:10:00',3.38),('8975','2013-08-14','08:15:00',3.39),('8975','2013-08-14','08:20:00',3.47),('8975','2013-08-14','08:25:00',3.57),('8975','2013-08-14','08:30:00',3.63),('8975','2013-08-14','08:35:00',3.74),('8975','2013-08-14','08:40:00',3.81),('8975','2013-08-14','08:45:00',3.92),('8975','2013-08-14','08:50:00',4.07),('8975','2013-08-14','08:55:00',4.18),('8975','2013-08-14','09:00:00',3.57),('8975','2013-08-14','09:05:00',4),('8975','2013-08-14','09:10:00',3.17),('8975','2013-08-14','09:15:00',4.35),('8975','2013-08-14','09:20:00',4.85),('8975','2013-08-14','09:25:00',4.75),('8975','2013-08-14','09:30:00',4.76),('8975','2013-08-14','09:35:00',4.86),('8975','2013-08-14','09:40:00',4.96),('8975','2013-08-14','09:45:00',5.04),('8975','2013-08-14','09:50:00',5.13),('8975','2013-08-14','09:55:00',5.22),('8975','2013-08-14','10:00:00',5.29),('8975','2013-08-14','10:05:00',5.37),('8975','2013-08-14','10:10:00',5.45),('8975','2013-08-14','10:15:00',5.53),('8975','2013-08-14','10:20:00',5.58),('8975','2013-08-14','10:25:00',5.66),('8975','2013-08-14','10:30:00',5.69),('8975','2013-08-14','10:35:00',5.79),('8975','2013-08-14','10:40:00',5.81),('8975','2013-08-14','10:45:00',5.83),('8975','2013-08-14','10:50:00',5.83),('8975','2013-08-14','10:55:00',5.37),('8975','2013-08-14','11:00:00',5.2),('8975','2013-08-14','11:05:00',4.54),('8975','2013-08-14','11:10:00',3.71),('8975','2013-08-14','11:15:00',3.98),('8975','2013-08-14','11:20:00',4.27),('8975','2013-08-14','11:25:00',4.62),('8975','2013-08-14','11:30:00',5.18),('8975','2013-08-14','11:35:00',5.66),('8975','2013-08-14','11:40:00',6.03),('8975','2013-08-14','11:45:00',6.75),('8975','2013-08-14','11:50:00',6.75),('8975','2013-08-14','11:55:00',6.71),('8975','2013-08-14','12:00:00',6.68),('8975','2013-08-14','12:05:00',6.62),('8975','2013-08-14','12:10:00',6.58),('8975','2013-08-14','12:15:00',6.54),('8975','2013-08-14','12:20:00',6.5),('8975','2013-08-14','12:25:00',6.48),('8975','2013-08-14','12:30:00',6.47),('8975','2013-08-14','12:35:00',6.44),('8975','2013-08-14','12:40:00',6.44),('8975','2013-08-14','12:45:00',6.4),('8975','2013-08-14','12:50:00',6.33),('8975','2013-08-14','12:55:00',6.35),('8975','2013-08-14','13:00:00',6.17),('8975','2013-08-14','13:05:00',6.01),('8975','2013-08-14','13:10:00',5.93),('8975','2013-08-14','13:15:00',5.93),('8975','2013-08-14','13:20:00',5.69),('8975','2013-08-14','13:25:00',5.89),('8975','2013-08-14','13:30:00',6.06),('8975','2013-08-14','13:35:00',5.97),('8975','2013-08-14','13:40:00',5.92),('8975','2013-08-14','13:45:00',5.87),('8975','2013-08-14','13:50:00',5.82),('8975','2013-08-14','13:55:00',5.74),('8975','2013-08-14','14:00:00',5.71),('8975','2013-08-14','14:05:00',5.72),('8975','2013-08-14','14:10:00',5.63),('8975','2013-08-14','14:15:00',5.62),('8975','2013-08-14','14:20:00',5.51),('8975','2013-08-14','14:25:00',5.43),('8975','2013-08-14','14:30:00',5.24),('8975','2013-08-14','14:35:00',5.21),('8975','2013-08-14','14:40:00',5.22),('8975','2013-08-14','14:45:00',5.15),('8975','2013-08-14','14:50:00',5.04),('8975','2013-08-14','14:55:00',4.93),('8975','2013-08-14','15:00:00',4.81),('8975','2013-08-14','15:05:00',4.75),('8975','2013-08-14','15:10:00',4.67),('8975','2013-08-14','15:15:00',4.67),('8975','2013-08-14','15:20:00',4.55),('8975','2013-08-14','15:25:00',4.48),('8975','2013-08-14','15:30:00',4.34),('8975','2013-08-14','15:35:00',4.28),('8975','2013-08-14','15:40:00',4.14),('8975','2013-08-14','15:45:00',3.97),('8975','2013-08-14','15:50:00',3.94),('8975','2013-08-14','15:55:00',3.86),('8975','2013-08-14','16:00:00',3.78),('8975','2013-08-14','16:05:00',3.69),('8975','2013-08-14','16:10:00',3.55),('8975','2013-08-14','16:15:00',3.46),('8975','2013-08-14','16:20:00',3.35),('8975','2013-08-14','16:25:00',3.24),('8975','2013-08-14','16:30:00',2.56),('8975','2013-08-14','16:35:00',3.05),('8975','2013-08-14','16:40:00',2.97),('8975','2013-08-14','16:45:00',2.77),('8975','2013-08-14','16:50:00',2.68),('8975','2013-08-14','16:55:00',2.52),('8975','2013-08-14','17:00:00',2.09),('8975','2013-08-14','17:05:00',2.25),('8975','2013-08-14','17:10:00',2.26),('8975','2013-08-14','17:15:00',2.18),('8975','2013-08-14','17:20:00',2.02),('8975','2013-08-14','17:25:00',1.75),('8975','2013-08-14','17:30:00',1.73),('8975','2013-08-14','17:35:00',1.25),('8975','2013-08-14','17:45:00',1.43),('8975','2013-08-14','17:50:00',1.57),('8975','2013-08-14','17:55:00',1.49),('8975','2013-08-14','18:00:00',1.43),('8975','2013-08-14','18:05:00',1.38),('8975','2013-08-14','18:10:00',1.26),('8975','2013-08-14','18:15:00',1.23),('8975','2013-08-14','18:20:00',1.2),('8975','2013-08-14','18:25:00',1.16),('8975','2013-08-14','18:30:00',1.11),('8975','2013-08-14','18:35:00',1.08),('8975','2013-08-14','18:40:00',1.04),('8975','2013-08-13','07:10:00',1.06),('8975','2013-08-13','07:15:00',1.35),('8975','2013-08-13','07:20:00',1.53),('8975','2013-08-13','07:25:00',1.7),('8975','2013-08-13','07:30:00',1.88),('8975','2013-08-13','07:35:00',2.02),('8975','2013-08-13','07:40:00',2.18),('8975','2013-08-13','07:45:00',2.33),('8975','2013-08-13','07:50:00',2.51),('8975','2013-08-13','07:55:00',2.63),('8975','2013-08-13','08:00:00',2.8),('8975','2013-08-13','08:05:00',2.87),('8975','2013-08-13','08:10:00',2.92),('8975','2013-08-13','08:15:00',2.99),('8975','2013-08-13','08:20:00',3.17),('8975','2013-08-13','08:25:00',3.28),('8975','2013-08-13','08:30:00',3.31),('8975','2013-08-13','08:35:00',3.34),('8975','2013-08-13','08:40:00',3.83),('8975','2013-08-13','08:45:00',2.72),('8975','2013-08-13','08:50:00',3.91),('8975','2013-08-13','08:55:00',2.44),('8975','2013-08-13','09:00:00',3.21),('8975','2013-08-13','09:05:00',4.48),('8975','2013-08-13','09:10:00',4.73),('8975','2013-08-13','09:15:00',4.05),('8975','2013-08-13','09:20:00',3.49),('8975','2013-08-13','09:25:00',4.43),('8975','2013-08-13','09:30:00',4.96),('8975','2013-08-13','09:35:00',4.71),('8975','2013-08-13','09:40:00',4.62),('8975','2013-08-13','09:45:00',5.15),('8975','2013-08-13','09:50:00',4.58),('8975','2013-08-13','09:55:00',4.46),('8975','2013-08-13','10:00:00',3.18),('8975','2013-08-13','10:05:00',1.6),('8975','2013-08-13','10:10:00',1.9),('8975','2013-08-13','10:15:00',4.01),('8975','2013-08-13','10:20:00',4.14),('8975','2013-08-13','10:25:00',4.65),('8975','2013-08-13','10:30:00',2.45),('8975','2013-08-13','10:35:00',6.19),('8975','2013-08-13','10:40:00',5.88),('8975','2013-08-13','10:45:00',5.97),('8975','2013-08-13','10:50:00',6.09),('8975','2013-08-13','10:55:00',5.77),('8975','2013-08-13','11:00:00',1.96),('8975','2013-08-13','11:05:00',1.75),('8975','2013-08-13','11:10:00',2.9),('8975','2013-08-13','11:15:00',5.78),('8975','2013-08-13','11:20:00',3.61),('8975','2013-08-13','11:25:00',5.81),('8975','2013-08-13','11:30:00',6.51),('8975','2013-08-13','11:35:00',5.99),('8975','2013-08-13','11:40:00',5.51),('8975','2013-08-13','11:45:00',2.85),('8975','2013-08-13','11:50:00',1.92),('8975','2013-08-13','11:55:00',1.76),('8975','2013-08-13','12:00:00',2.02),('8975','2013-08-13','12:05:00',1.71),('8975','2013-08-13','12:10:00',1.94),('8975','2013-08-13','12:15:00',1.64),('8975','2013-08-13','12:20:00',1.65),('8975','2013-08-13','12:25:00',1.73),('8975','2013-08-13','12:30:00',2.89),('8975','2013-08-13','12:35:00',4.41),('8975','2013-08-13','12:40:00',2.3),('8975','2013-08-13','12:45:00',1.77),('8975','2013-08-13','12:50:00',1.76),('8975','2013-08-13','12:55:00',2.06),('8975','2013-08-13','13:00:00',2.39),('8975','2013-08-13','13:05:00',4.81),('8975','2013-08-13','13:10:00',5.51),('8975','2013-08-13','13:15:00',4.65),('8975','2013-08-13','13:20:00',2.11),('8975','2013-08-13','13:25:00',1.76),('8975','2013-08-13','13:30:00',1.81),('8975','2013-08-13','13:35:00',1.99),('8975','2013-08-13','13:40:00',2.78),('8975','2013-08-13','13:45:00',3.74),('8975','2013-08-13','13:50:00',6.23),('8975','2013-08-13','13:55:00',5.13),('8975','2013-08-13','14:00:00',5.56),('8975','2013-08-13','14:05:00',6.64),('8975','2013-08-13','14:10:00',6.28),('8975','2013-08-13','14:15:00',6.08),('8975','2013-08-13','14:20:00',6.06),('8975','2013-08-13','14:25:00',5.83),('8975','2013-08-13','14:30:00',5.03),('8975','2013-08-13','14:35:00',5.69),('8975','2013-08-13','14:40:00',5.54),('8975','2013-08-13','14:45:00',5.22),('8975','2013-08-13','14:50:00',5.19),('8975','2013-08-13','14:55:00',5.16),('8975','2013-08-13','15:00:00',5.1),('8975','2013-08-13','15:05:00',5),('8975','2013-08-13','15:10:00',4.91),('8975','2013-08-13','15:15:00',4.8),('8975','2013-08-13','15:20:00',4.8),('8975','2013-08-13','15:25:00',4.65),('8975','2013-08-13','15:30:00',4.48),('8975','2013-08-13','15:35:00',4.46),('8975','2013-08-13','15:40:00',4.35),('8975','2013-08-13','15:45:00',4.24),('8975','2013-08-13','15:50:00',4.18),('8975','2013-08-13','15:55:00',4.09),('8975','2013-08-13','16:00:00',3.93),('8975','2013-08-13','16:05:00',3.91),('8975','2013-08-13','16:10:00',3.83),('8975','2013-08-13','16:15:00',3.69),('8975','2013-08-13','16:20:00',3.6),('8975','2013-08-13','16:25:00',3.47),('8975','2013-08-13','16:30:00',3.34),('8975','2013-08-13','16:35:00',3.24),('8975','2013-08-13','16:40:00',3.12),('8975','2013-08-13','16:45:00',2.99),('8975','2013-08-13','16:50:00',2.84),('8975','2013-08-13','16:55:00',2.73),('8975','2013-08-13','17:00:00',2.61),('8975','2013-08-13','17:05:00',2.5),('8975','2013-08-13','17:10:00',2.36),('8975','2013-08-13','17:15:00',2.27),('8975','2013-08-13','17:20:00',2.17),('8975','2013-08-13','17:25:00',2.07),('8975','2013-08-13','17:30:00',1.97),('8975','2013-08-13','17:35:00',1.87),('8975','2013-08-13','17:40:00',1.81),('8975','2013-08-13','17:45:00',1.7),('8975','2013-08-13','17:50:00',1.65),('8975','2013-08-13','17:55:00',1.58),('8975','2013-08-13','18:00:00',1.52),('8975','2013-08-13','18:05:00',1.48),('8975','2013-08-13','18:10:00',1.47),('8975','2013-08-13','18:15:00',1.44),('8975','2013-08-13','18:20:00',1.44),('8975','2013-08-13','18:25:00',1.42),('8975','2013-08-13','18:30:00',1.32),('8975','2013-08-13','18:35:00',1.2),('8975','2013-08-13','18:40:00',1.11),('8975','2013-08-13','18:45:00',1.12),('8975','2013-08-13','18:50:00',1.14),('8975','2013-08-13','18:55:00',1.07),('8975','2013-08-13','19:00:00',1.09),('8975','2013-08-12','07:05:00',1.12),('8975','2013-08-12','07:10:00',1.27),('8975','2013-08-12','07:15:00',1.39),('8975','2013-08-12','07:20:00',1.52),('8975','2013-08-12','07:25:00',1.76),('8975','2013-08-12','07:30:00',1.96),('8975','2013-08-12','07:35:00',2.13),('8975','2013-08-12','07:40:00',2.3),('8975','2013-08-12','07:45:00',2.46),('8975','2013-08-12','07:50:00',2.58),('8975','2013-08-12','07:55:00',2.72),('8975','2013-08-12','08:00:00',2.81),('8975','2013-08-12','08:05:00',2.82),('8975','2013-08-12','08:10:00',2.96),('8975','2013-08-12','08:15:00',3.1),('8975','2013-08-12','08:20:00',3.26),('8975','2013-08-12','08:25:00',3.41),('8975','2013-08-12','08:30:00',3.53),('8975','2013-08-12','08:35:00',3.58),('8975','2013-08-12','08:40:00',3.68),('8975','2013-08-12','08:45:00',3.8),('8975','2013-08-12','08:50:00',3.92),('8975','2013-08-12','08:55:00',4.02),('8975','2013-08-12','09:00:00',4.11),('8975','2013-08-12','09:05:00',4.24),('8975','2013-08-12','09:10:00',4.37),('8975','2013-08-12','09:15:00',4.44),('8975','2013-08-12','09:20:00',4.53),('8975','2013-08-12','09:25:00',4.61),('8975','2013-08-12','09:30:00',4.71),('8975','2013-08-12','09:35:00',4.81),('8975','2013-08-12','09:40:00',4.83),('8975','2013-08-12','09:45:00',4.94),('8975','2013-08-12','09:50:00',5.02),('8975','2013-08-12','09:55:00',5.11),('8975','2013-08-12','10:00:00',5.15),('8975','2013-08-12','10:05:00',5.25),('8975','2013-08-12','10:10:00',5.3),('8975','2013-08-12','10:15:00',5.4),('8975','2013-08-12','10:20:00',5.47),('8975','2013-08-12','10:25:00',5.56),('8975','2013-08-12','10:30:00',5.56),('8975','2013-08-12','10:35:00',5.55),('8975','2013-08-12','10:40:00',5.61),('8975','2013-08-12','10:45:00',5.6),('8975','2013-08-12','10:50:00',5.67),('8975','2013-08-12','10:55:00',5.68),('8975','2013-08-12','11:00:00',5.78),('8975','2013-08-12','11:05:00',5.76),('8975','2013-08-12','11:10:00',5.74),('8975','2013-08-12','11:15:00',5.83),('8975','2013-08-12','11:20:00',5.34),('8975','2013-08-12','11:25:00',5.84),('8975','2013-08-12','11:30:00',5.94),('8975','2013-08-12','11:35:00',6.04),('8975','2013-08-12','11:40:00',6.07),('8975','2013-08-12','11:45:00',5.99),('8975','2013-08-12','11:50:00',5.86),('8975','2013-08-12','11:55:00',6.08),('8975','2013-08-12','12:00:00',6.17),('8975','2013-08-12','12:05:00',6.11),('8975','2013-08-12','12:10:00',6.34),('8975','2013-08-12','12:15:00',6.41),('8975','2013-08-12','12:20:00',6.43),('8975','2013-08-12','12:25:00',6.58),('8975','2013-08-12','12:30:00',6.56),('8975','2013-08-12','12:35:00',3.72),('8975','2013-08-12','12:40:00',2.28),('8975','2013-08-12','12:45:00',2.13),('8975','2013-08-12','12:50:00',2.08),('8975','2013-08-12','12:55:00',1.59),('8975','2013-08-12','13:00:00',1.46),('8975','2013-08-12','13:05:00',1.5),('8975','2013-08-12','13:10:00',1.31),('8975','2013-08-12','13:15:00',1.68),('8975','2013-08-12','13:20:00',4.48),('8975','2013-08-12','13:25:00',5.62),('8975','2013-08-12','13:30:00',2.05),('8975','2013-08-12','13:35:00',2.7),('8975','2013-08-12','13:40:00',5.36),('8975','2013-08-12','13:45:00',5.5),('8975','2013-08-12','13:50:00',6.68),('8975','2013-08-12','13:55:00',5.23),('8975','2013-08-12','14:00:00',2.79),('8975','2013-08-12','14:05:00',5.83),('8975','2013-08-12','14:10:00',6.46),('8975','2013-08-12','14:15:00',5.71),('8975','2013-08-12','14:20:00',3.69),('8975','2013-08-12','14:25:00',5.22),('8975','2013-08-12','14:30:00',5.47),('8975','2013-08-12','14:35:00',4.17),('8975','2013-08-12','14:40:00',5.76),('8975','2013-08-12','14:45:00',4.49),('8975','2013-08-12','14:50:00',2.94),('8975','2013-08-12','14:55:00',4.43),('8975','2013-08-12','15:00:00',3.89),('8975','2013-08-12','15:05:00',2.84),('8975','2013-08-12','15:10:00',4.16),('8975','2013-08-12','15:15:00',5.26),('8975','2013-08-12','15:20:00',3.9),('8975','2013-08-12','15:25:00',4.66),('8975','2013-08-12','15:30:00',4.7),('8975','2013-08-12','15:35:00',4.57),('8975','2013-08-12','15:40:00',4.46),('8975','2013-08-12','15:45:00',4.14),('8975','2013-08-12','15:50:00',4.2),('8975','2013-08-12','15:55:00',4.1),('8975','2013-08-12','16:00:00',3.99),('8975','2013-08-12','16:05:00',3.87),('8975','2013-08-12','16:10:00',3.76),('8975','2013-08-12','16:15:00',3.65),('8975','2013-08-12','16:20:00',3.54),('8975','2013-08-12','16:25:00',3.43),('8975','2013-08-12','16:30:00',3.31),('8975','2013-08-12','16:35:00',3.23),('8975','2013-08-12','16:40:00',3.11),('8975','2013-08-12','16:45:00',2.97),('8975','2013-08-12','16:50:00',2.87),('8975','2013-08-12','16:55:00',2.73),('8975','2013-08-12','17:00:00',2.62),('8975','2013-08-12','17:05:00',2.52),('8975','2013-08-12','17:10:00',2.42),('8975','2013-08-12','17:15:00',2.29),('8975','2013-08-12','17:20:00',2.18),('8975','2013-08-12','17:25:00',2.09),('8975','2013-08-12','17:30:00',1.98),('8975','2013-08-12','17:35:00',1.87),('8975','2013-08-12','17:40:00',1.77),('8975','2013-08-12','17:45:00',1.68),('8975','2013-08-12','17:50:00',1.61),('8975','2013-08-12','17:55:00',1.53),('8975','2013-08-12','18:00:00',1.46),('8975','2013-08-12','18:05:00',1.39),('8975','2013-08-12','18:10:00',1.35),('8975','2013-08-12','18:15:00',1.3),('8975','2013-08-12','18:20:00',1.25),('8975','2013-08-12','18:25:00',1.19),('8975','2013-08-12','18:30:00',1.14),('8975','2013-08-12','18:35:00',1.07),('8975','2013-08-12','18:40:00',1.03),('8975','2013-08-11','07:05:00',1.12),('8975','2013-08-11','07:10:00',1.22),('8975','2013-08-11','07:15:00',1.39),('8975','2013-08-11','07:20:00',1.52),('8975','2013-08-11','07:25:00',1.78),('8975','2013-08-11','07:30:00',1.96),('8975','2013-08-11','07:35:00',2.12),('8975','2013-08-11','07:40:00',2.25),('8975','2013-08-11','07:45:00',2.39),('8975','2013-08-11','07:50:00',2.53),('8975','2013-08-11','07:55:00',2.66),('8975','2013-08-11','08:00:00',2.77),('8975','2013-08-11','08:05:00',2.87),('8975','2013-08-11','08:10:00',3),('8975','2013-08-11','08:15:00',3.11),('8975','2013-08-11','08:20:00',3.22),('8975','2013-08-11','08:25:00',3.32),('8975','2013-08-11','08:30:00',3.44),('8975','2013-08-11','08:35:00',3.54),('8975','2013-08-11','08:40:00',3.63),('8975','2013-08-11','08:45:00',3.75),('8975','2013-08-11','08:50:00',3.86),('8975','2013-08-11','08:55:00',3.96),('8975','2013-08-11','09:00:00',4.07),('8975','2013-08-11','09:05:00',4.18),('8975','2013-08-11','09:10:00',4.27),('8975','2013-08-11','09:15:00',4.35),('8975','2013-08-11','09:20:00',4.42),('8975','2013-08-11','09:25:00',4.49),('8975','2013-08-11','09:30:00',4.58),('8975','2013-08-11','09:35:00',4.65),('8975','2013-08-11','09:40:00',4.73),('8975','2013-08-11','09:45:00',4.83),('8975','2013-08-11','09:50:00',4.9),('8975','2013-08-11','09:55:00',4.93),('8975','2013-08-11','10:00:00',5.03),('8975','2013-08-11','10:05:00',5.08),('8975','2013-08-11','10:10:00',5.14),('8975','2013-08-11','10:15:00',5.2),('8975','2013-08-11','10:20:00',5.28),('8975','2013-08-11','10:25:00',5.35),('8975','2013-08-11','10:30:00',5.41),('8975','2013-08-11','10:35:00',5.45),('8975','2013-08-11','10:40:00',5.5),('8975','2013-08-11','10:45:00',5.59),('8975','2013-08-11','10:50:00',5.66),('8975','2013-08-11','10:55:00',5.72),('8975','2013-08-11','11:00:00',5.73),('8975','2013-08-11','11:05:00',5.81),('8975','2013-08-11','11:10:00',5.77),('8975','2013-08-11','11:15:00',5.81),('8975','2013-08-11','11:20:00',5.84),('8975','2013-08-11','11:25:00',5.89),('8975','2013-08-11','11:30:00',5.94),('8975','2013-08-11','11:35:00',5.95),('8975','2013-08-11','11:40:00',5.97),('8975','2013-08-11','11:45:00',5.98),('8975','2013-08-11','11:50:00',6.11),('8975','2013-08-11','11:55:00',5.43),('8975','2013-08-11','12:00:00',6.04),('8975','2013-08-11','12:05:00',5.95),('8975','2013-08-11','12:10:00',3.05),('8975','2013-08-11','12:15:00',1.52),('8975','2013-08-11','12:20:00',1.5),('8975','2013-08-11','12:25:00',1.87),('8975','2013-08-11','12:30:00',3.87),('8975','2013-08-11','12:35:00',1.28),('8975','2013-08-11','12:40:00',1.25),('8975','2013-08-11','12:45:00',1.64),('8975','2013-08-11','12:50:00',2.35),('8975','2013-08-11','12:55:00',1.84),('8975','2013-08-11','13:00:00',1.43),('8975','2013-08-11','13:05:00',1.31),('8975','2013-08-11','13:10:00',1.38),('8975','2013-08-11','13:15:00',1.31),('8975','2013-08-11','13:20:00',1.64),('8975','2013-08-11','13:25:00',1.96),('8975','2013-08-11','13:30:00',5.82),('8975','2013-08-11','13:35:00',2.77),('8975','2013-08-11','13:40:00',1.69),('8975','2013-08-11','13:45:00',2.03),('8975','2013-08-11','13:50:00',2.28),('8975','2013-08-11','13:55:00',2.31),('8975','2013-08-11','14:00:00',1.98),('8975','2013-08-11','14:05:00',1.38),('8975','2013-08-11','14:10:00',1.37),('8975','2013-08-11','14:15:00',1.48),('8975','2013-08-11','14:20:00',1.58),('8975','2013-08-11','14:25:00',1.81),('8975','2013-08-11','14:30:00',2.64),('8975','2013-08-11','14:35:00',3.76),('8975','2013-08-11','14:40:00',5.33),('8975','2013-08-11','14:45:00',6.26),('8975','2013-08-11','14:50:00',5.86),('8975','2013-08-11','14:55:00',5.62),('8975','2013-08-11','15:00:00',5.45),('8975','2013-08-11','15:05:00',5.29),('8975','2013-08-11','15:10:00',5.15),('8975','2013-08-11','15:15:00',5.07),('8975','2013-08-11','15:20:00',4.85),('8975','2013-08-11','15:25:00',4.77),('8975','2013-08-11','15:30:00',4.6),('8975','2013-08-11','15:35:00',3.43),('8975','2013-08-11','15:40:00',4.41),('8975','2013-08-11','15:45:00',4.32),('8975','2013-08-11','15:50:00',4.25),('8975','2013-08-11','15:55:00',4.13),('8975','2013-08-11','16:00:00',3.99),('8975','2013-08-11','16:05:00',3.91),('8975','2013-08-11','16:10:00',3.78),('8975','2013-08-11','16:15:00',3.66),('8975','2013-08-11','16:20:00',3.5),('8975','2013-08-11','16:25:00',3.39),('8975','2013-08-11','16:30:00',3.31),('8975','2013-08-11','16:35:00',3.23),('8975','2013-08-11','16:40:00',3.09),('8975','2013-08-11','16:45:00',2.96),('8975','2013-08-11','16:50:00',2.88),('8975','2013-08-11','16:55:00',2.75),('8975','2013-08-11','17:00:00',2.61),('8975','2013-08-11','17:05:00',2.5),('8975','2013-08-11','17:10:00',2.39),('8975','2013-08-11','17:15:00',2.05),('8975','2013-08-11','17:20:00',2.14),('8975','2013-08-11','17:25:00',2.06),('8975','2013-08-11','17:30:00',2.02),('8975','2013-08-11','17:35:00',1.82),('8975','2013-08-11','17:40:00',1.66),('8975','2013-08-11','17:45:00',1.55),('8975','2013-08-11','17:50:00',1.65),('8975','2013-08-11','17:55:00',1.44),('8975','2013-08-11','18:00:00',1.49),('8975','2013-08-11','18:05:00',1.3),('8975','2013-08-11','18:10:00',1.22),('8975','2013-08-11','18:15:00',1.16),('8975','2013-08-11','18:20:00',1.22),('8975','2013-08-11','18:25:00',1.02),('8975','2013-08-11','18:30:00',1.02),('8975','2013-08-11','18:35:00',1.09),('8975','2013-08-11','18:40:00',1.12),('8975','2013-08-11','18:45:00',1.06),('8975','2013-08-11','18:50:00',1.01),('8975','2013-08-10','07:05:00',1.18),('8975','2013-08-10','07:10:00',1.33),('8975','2013-08-10','07:15:00',1.44),('8975','2013-08-10','07:20:00',1.62),('8975','2013-08-10','07:25:00',1.64),('8975','2013-08-10','07:30:00',1.96),('8975','2013-08-10','07:35:00',2.11),('8975','2013-08-10','07:40:00',2.07),('8975','2013-08-10','07:45:00',2.26),('8975','2013-08-10','07:50:00',2.58),('8975','2013-08-10','07:55:00',2.57),('8975','2013-08-10','08:00:00',2.71),('8975','2013-08-10','08:05:00',2.7),('8975','2013-08-10','08:10:00',3.03),('8975','2013-08-10','08:15:00',3.28),('8975','2013-08-10','08:20:00',3.4),('8975','2013-08-10','08:25:00',3.52),('8975','2013-08-10','08:30:00',3.62),('8975','2013-08-10','08:35:00',3.76),('8975','2013-08-10','08:40:00',3.85),('8975','2013-08-10','08:45:00',3.94),('8975','2013-08-10','08:50:00',4.02),('8975','2013-08-10','08:55:00',4.07),('8975','2013-08-10','09:00:00',4.18),('8975','2013-08-10','09:05:00',4.27),('8975','2013-08-10','09:10:00',4.38),('8975','2013-08-10','09:15:00',4.48),('8975','2013-08-10','09:20:00',4.59),('8975','2013-08-10','09:25:00',4.67),('8975','2013-08-10','09:30:00',4.77),('8975','2013-08-10','09:35:00',4.88),('8975','2013-08-10','09:40:00',4.95),('8975','2013-08-10','09:45:00',5.04),('8975','2013-08-10','09:50:00',5.11),('8975','2013-08-10','09:55:00',5.18),('8975','2013-08-10','10:00:00',5.25),('8975','2013-08-10','10:05:00',5.33),('8975','2013-08-10','10:10:00',5.4),('8975','2013-08-10','10:15:00',5.48),('8975','2013-08-10','10:20:00',5.54),('8975','2013-08-10','10:25:00',5.62),('8975','2013-08-10','10:30:00',5.67),('8975','2013-08-10','10:35:00',5.74),('8975','2013-08-10','10:40:00',5.81),('8975','2013-08-10','10:45:00',5.87),('8975','2013-08-10','10:50:00',5.93),('8975','2013-08-10','10:55:00',5.94),('8975','2013-08-10','11:00:00',6.03),('8975','2013-08-10','11:05:00',6.07),('8975','2013-08-10','11:10:00',6.06),('8975','2013-08-10','11:15:00',6.1),('8975','2013-08-10','11:20:00',6.06),('8975','2013-08-10','11:25:00',6.14),('8975','2013-08-10','11:30:00',6.22),('8975','2013-08-10','11:35:00',6.23),('8975','2013-08-10','11:40:00',6.2),('8975','2013-08-10','11:45:00',6.2),('8975','2013-08-10','11:50:00',6.23),('8975','2013-08-10','11:55:00',6.24),('8975','2013-08-10','12:00:00',6.24),('8975','2013-08-10','12:05:00',6.26),('8975','2013-08-10','12:10:00',6.24),('8975','2013-08-10','12:15:00',6.22),('8975','2013-08-10','12:20:00',6.2),('8975','2013-08-10','12:25:00',6.18),('8975','2013-08-10','12:30:00',6.22),('8975','2013-08-10','12:35:00',6.24),('8975','2013-08-10','12:40:00',6.27),('8975','2013-08-10','12:45:00',6.23),('8975','2013-08-10','12:50:00',6.18),('8975','2013-08-10','12:55:00',6.16),('8975','2013-08-10','13:00:00',6.13),('8975','2013-08-10','13:05:00',6.12),('8975','2013-08-10','13:10:00',6.09),('8975','2013-08-10','13:15:00',6.13),('8975','2013-08-10','13:20:00',6.08),('8975','2013-08-10','13:25:00',5.99),('8975','2013-08-10','13:30:00',5.92),('8975','2013-08-10','13:35:00',5.9),('8975','2013-08-10','13:40:00',5.9),('8975','2013-08-10','13:45:00',5.88),('8975','2013-08-10','13:50:00',5.8),('8975','2013-08-10','13:55:00',5.75),('8975','2013-08-10','14:00:00',5.74),('8975','2013-08-10','14:05:00',5.68),('8975','2013-08-10','14:10:00',5.62),('8975','2013-08-10','14:15:00',5.59),('8975','2013-08-10','14:20:00',5.54),('8975','2013-08-10','14:25:00',5.42),('8975','2013-08-10','14:30:00',5.34),('8975','2013-08-10','14:35:00',5.27),('8975','2013-08-10','14:40:00',5.19),('8975','2013-08-10','14:45:00',5.11),('8975','2013-08-10','14:50:00',5.11),('8975','2013-08-10','14:55:00',4.98),('8975','2013-08-10','15:00:00',3.53),('8975','2013-08-10','15:05:00',4.79),('8975','2013-08-10','15:10:00',4.76),('8975','2013-08-10','15:15:00',3.94),('8975','2013-08-10','15:20:00',4.33),('8975','2013-08-10','15:25:00',3.39),('8975','2013-08-10','15:30:00',4.56),('8975','2013-08-10','15:35:00',4.47),('8975','2013-08-10','15:40:00',4.36),('8975','2013-08-10','15:45:00',4.3),('8975','2013-08-10','15:50:00',4.21),('8975','2013-08-10','15:55:00',4.07),('8975','2013-08-10','16:00:00',3.98),('8975','2013-08-10','16:05:00',3.87),('8975','2013-08-10','16:10:00',3.78),('8975','2013-08-10','16:15:00',3.66),('8975','2013-08-10','16:20:00',3.53),('8975','2013-08-10','16:25:00',3.44),('8975','2013-08-10','16:30:00',3.35),('8975','2013-08-10','16:35:00',3.23),('8975','2013-08-10','16:40:00',3.11),('8975','2013-08-10','16:45:00',2.98),('8975','2013-08-10','16:50:00',2.85),('8975','2013-08-10','16:55:00',2.73),('8975','2013-08-10','17:00:00',2.62),('8975','2013-08-10','17:05:00',2.51),('8975','2013-08-10','17:10:00',2.41),('8975','2013-08-10','17:15:00',2.31),('8975','2013-08-10','17:20:00',2.18),('8975','2013-08-10','17:25:00',2.08),('8975','2013-08-10','17:30:00',1.98),('8975','2013-08-10','17:35:00',1.89),('8975','2013-08-10','17:40:00',1.79),('8975','2013-08-10','17:45:00',1.71),('8975','2013-08-10','17:50:00',1.63),('8975','2013-08-10','17:55:00',1.55),('8975','2013-08-10','18:00:00',1.48),('8975','2013-08-10','18:05:00',1.42),('8975','2013-08-10','18:10:00',1.34),('8975','2013-08-10','18:15:00',1.3),('8975','2013-08-10','18:20:00',1.27),('8975','2013-08-10','18:25:00',1.2),('8975','2013-08-10','18:30:00',1.15),('8975','2013-08-10','18:35:00',1.09),('8975','2013-08-10','18:40:00',1.05),('8975','2013-08-09','07:00:00',1.12),('8975','2013-08-09','07:05:00',1.23),('8975','2013-08-09','07:10:00',1.43),('8975','2013-08-09','07:15:00',1.63),('8975','2013-08-09','07:20:00',1.77),('8975','2013-08-09','07:25:00',1.96),('8975','2013-08-09','07:30:00',2.19),('8975','2013-08-09','07:35:00',2.33),('8975','2013-08-09','07:40:00',2.45),('8975','2013-08-09','07:45:00',2.61),('8975','2013-08-09','07:50:00',2.72),('8975','2013-08-09','07:55:00',2.82),('8975','2013-08-09','08:00:00',2.96),('8975','2013-08-09','08:05:00',3.11),('8975','2013-08-09','08:10:00',3.22),('8975','2013-08-09','08:15:00',3.35),('8975','2013-08-09','08:20:00',3.5),('8975','2013-08-09','08:25:00',3.61),('8975','2013-08-09','08:30:00',3.72),('8975','2013-08-09','08:35:00',3.8),('8975','2013-08-09','08:40:00',3.88),('8975','2013-08-09','08:45:00',4),('8975','2013-08-09','08:50:00',4.1),('8975','2013-08-09','08:55:00',4.18),('8975','2013-08-09','09:00:00',4.31),('8975','2013-08-09','09:05:00',4.41),('8975','2013-08-09','09:10:00',4.51),('8975','2013-08-09','09:15:00',4.61),('8975','2013-08-09','09:20:00',4.73),('8975','2013-08-09','09:25:00',4.82),('8975','2013-08-09','09:30:00',3.84),('8975','2013-08-09','09:35:00',4.97),('8975','2013-08-09','09:40:00',5.04),('8975','2013-08-09','09:45:00',5.13),('8975','2013-08-09','09:50:00',5.23),('8975','2013-08-09','09:55:00',5.27),('8975','2013-08-09','10:00:00',5.41),('8975','2013-08-09','10:05:00',5.46),('8975','2013-08-09','10:10:00',5.53),('8975','2013-08-09','10:15:00',5.61),('8975','2013-08-09','10:20:00',5.65),('8975','2013-08-09','10:25:00',5.71),('8975','2013-08-09','10:30:00',5.79),('8975','2013-08-09','10:35:00',5.82),('8975','2013-08-09','10:40:00',5.87),('8975','2013-08-09','10:45:00',5.92),('8975','2013-08-09','10:50:00',5.95),('8975','2013-08-09','10:55:00',6),('8975','2013-08-09','11:00:00',6.12),('8975','2013-08-09','11:05:00',6.21),('8975','2013-08-09','11:10:00',5.28),('8975','2013-08-09','11:15:00',5.03),('8975','2013-08-09','11:20:00',6.68),('8975','2013-08-09','11:25:00',6.7),('8975','2013-08-09','11:30:00',6.59),('8975','2013-08-09','11:35:00',6.28),('8975','2013-08-09','11:40:00',6.3),('8975','2013-08-09','11:45:00',6.31),('8975','2013-08-09','11:50:00',6.29),('8975','2013-08-09','11:55:00',6.36),('8975','2013-08-09','12:00:00',6.35),('8975','2013-08-09','12:05:00',6.37),('8975','2013-08-09','12:10:00',6.39),('8975','2013-08-09','12:15:00',6.36),('8975','2013-08-09','12:20:00',6.38),('8975','2013-08-09','12:25:00',6.41),('8975','2013-08-09','12:30:00',6.42),('8975','2013-08-09','12:35:00',6.39),('8975','2013-08-09','12:40:00',6.42),('8975','2013-08-09','12:45:00',6.48),('8975','2013-08-09','12:50:00',6.57),('8975','2013-08-09','12:55:00',6.53),('8975','2013-08-09','13:00:00',6.43),('8975','2013-08-09','13:05:00',6.35),('8975','2013-08-09','13:10:00',6.36),('8975','2013-08-09','13:15:00',6.44),('8975','2013-08-09','13:20:00',5.66),('8975','2013-08-09','13:25:00',6.36),('8975','2013-08-09','13:30:00',6.55),('8975','2013-08-09','13:35:00',6.8),('8975','2013-08-09','13:40:00',5.2),('8975','2013-08-09','13:45:00',1.81),('8975','2013-08-09','13:55:00',2.65),('8975','2013-08-09','14:00:00',6.04),('8975','2013-08-09','14:05:00',5.59),('8975','2013-08-09','14:10:00',3.67),('8975','2013-08-09','14:15:00',4.02),('8975','2013-08-09','14:20:00',2.89),('8975','2013-08-09','14:25:00',1.74),('8975','2013-08-09','14:30:00',1.85),('8975','2013-08-09','14:35:00',1.57),('8975','2013-08-09','14:40:00',1.44),('8975','2013-08-09','14:45:00',1.48),('8975','2013-08-09','14:50:00',1.49),('8975','2013-08-09','14:55:00',1.41),('8975','2013-08-09','15:00:00',1.56),('8975','2013-08-09','15:05:00',1.69),('8975','2013-08-09','15:10:00',1.77),('8975','2013-08-09','15:15:00',1.87),('8975','2013-08-09','15:20:00',1.97),('8975','2013-08-09','15:25:00',1.97),('8975','2013-08-09','15:30:00',1.84),('8975','2013-08-09','15:35:00',2.08),('8975','2013-08-09','15:40:00',2.12),('8975','2013-08-09','15:45:00',2.33),('8975','2013-08-09','15:50:00',2.95),('8975','2013-08-09','15:55:00',4.76),('8975','2013-08-09','16:00:00',5.04),('8975','2013-08-09','16:05:00',4.97),('8975','2013-08-09','16:10:00',4.22),('8975','2013-08-09','16:15:00',2.62),('8975','2013-08-09','16:20:00',4.58),('8975','2013-08-09','16:25:00',1.73),('8975','2013-08-09','16:30:00',2.24),('8975','2013-08-09','16:35:00',3.64),('8975','2013-08-09','16:40:00',3.47),('8975','2013-08-09','16:45:00',3),('8975','2013-08-09','16:50:00',3.2),('8975','2013-08-09','16:55:00',2.95),('8975','2013-08-09','17:00:00',2.39),('8975','2013-08-09','17:05:00',2.2),('8975','2013-08-09','17:10:00',1.02),('8975','2013-08-09','17:15:00',1.39),('8975','2013-08-09','17:20:00',1.35),('8975','2013-08-09','17:25:00',1.95),('8975','2013-08-09','17:30:00',1.2),('8975','2013-08-09','17:55:00',1.32),('8975','2014-04-08','07:35:00',1.12),('8975','2014-04-08','07:40:00',1.24),('8975','2014-04-08','08:00:00',1.69),('8975','2014-04-08','08:05:00',2.42),('8975','2014-04-08','08:10:00',2.47),('8975','2014-04-08','08:15:00',2.17),('8975','2014-04-08','08:20:00',2.67),('8975','2014-04-08','08:25:00',1.96),('8975','2014-04-08','08:30:00',1.6),('8975','2014-04-08','08:35:00',1.16),('8975','2014-04-08','08:55:00',1.29),('8975','2014-04-08','09:00:00',3.06),('8975','2014-04-08','09:05:00',1.63),('8975','2014-04-08','09:10:00',1.44),('8975','2014-04-08','09:15:00',1.49),('8975','2014-04-08','09:20:00',1.48),('8975','2014-04-08','09:25:00',1.58),('8975','2014-04-08','09:30:00',1.6),('8975','2014-04-08','09:35:00',1.44),('8975','2014-04-08','09:40:00',1.34),('8975','2014-04-08','09:45:00',1.52),('8975','2014-04-08','09:50:00',4.18),('8975','2014-04-08','09:55:00',5.27),('8975','2014-04-08','10:00:00',5.24),('8975','2014-04-08','10:05:00',5.2),('8975','2014-04-08','10:10:00',5.3),('8975','2014-04-08','10:15:00',5.37),('8975','2014-04-08','10:20:00',5.55),('8975','2014-04-08','10:25:00',5.82),('8975','2014-04-08','10:30:00',6.2),('8975','2014-04-08','10:35:00',4.46),('8975','2014-04-08','10:40:00',2.65),('8975','2014-04-08','10:45:00',5.34),('8975','2014-04-08','10:50:00',5.38),('8975','2014-04-08','10:55:00',6.25),('8975','2014-04-08','11:00:00',6.14),('8975','2014-04-08','11:05:00',6.13),('8975','2014-04-08','11:10:00',6.19),('8975','2014-04-08','11:15:00',6.32),('8975','2014-04-08','11:20:00',6.54),('8975','2014-04-08','11:25:00',6.65),('8975','2014-04-08','11:30:00',6.62),('8975','2014-04-08','11:35:00',6.59),('8975','2014-04-08','11:40:00',6.52),('8975','2014-04-08','11:45:00',5.9),('8975','2014-04-08','11:50:00',6.07),('8975','2014-04-08','11:55:00',6.62),('8975','2014-04-08','12:00:00',5.31),('8975','2014-04-08','12:05:00',6.86),('8975','2014-04-08','12:10:00',7.05),('8975','2014-04-08','12:15:00',7.22),('8975','2014-04-08','12:20:00',6.32),('8975','2014-04-08','12:25:00',2.58),('8975','2014-04-08','12:30:00',2.41),('8975','2014-04-08','12:35:00',2.43),('8975','2014-04-08','12:40:00',2.17),('8975','2014-04-08','12:45:00',1.55),('8975','2014-04-08','12:50:00',1.12),('8975','2014-04-08','13:15:00',1.11),('8975','2014-04-08','13:20:00',1.27),('8975','2014-04-08','13:25:00',1.26),('8975','2014-04-08','13:30:00',1.11),('8975','2014-04-08','13:35:00',1.01),('8975','2014-04-08','13:50:00',1.03),('8975','2014-04-08','13:55:00',1.26),('8975','2014-04-08','14:00:00',1.75),('8975','2014-04-08','14:05:00',1.94),('8975','2014-04-08','14:10:00',1.73),('8975','2014-04-08','14:15:00',1.55),('8975','2014-04-08','14:20:00',1.41),('8975','2014-04-08','14:25:00',1.72),('8975','2014-04-08','14:30:00',1.68),('8975','2014-04-08','14:35:00',2.08),('8975','2014-04-08','14:40:00',4.31),('8975','2014-04-08','14:45:00',2.7),('8975','2014-04-08','14:50:00',2.25),('8975','2014-04-08','14:55:00',3.03),('8975','2014-04-08','15:00:00',4.71),('8975','2014-04-08','15:05:00',2.11),('8975','2014-04-08','15:10:00',2.64),('8975','2014-04-08','15:15:00',4.76),('8975','2014-04-08','15:20:00',4.88),('8975','2014-04-08','15:25:00',4.12),('8975','2014-04-08','15:30:00',2.85),('8975','2014-04-08','15:35:00',3.01),('8975','2014-04-08','15:40:00',2.18),('8975','2014-04-08','15:45:00',1.94),('8975','2014-04-08','15:50:00',1.61),('8975','2014-04-08','15:55:00',1.68),('8975','2014-04-08','16:00:00',1.8),('8975','2014-04-08','16:05:00',2.12),('8975','2014-04-08','16:10:00',3.58),('8975','2014-04-08','16:15:00',3.15),('8975','2014-04-08','16:20:00',3.58),('8975','2014-04-08','16:25:00',3.57),('8975','2014-04-08','16:30:00',3.59),('8975','2014-04-08','16:35:00',3.41),('8975','2014-04-08','16:40:00',2.16),('8975','2014-04-08','16:45:00',2.68),('8975','2014-04-08','16:50:00',3.43),('8975','2014-04-08','16:55:00',3.44),('8975','2014-04-08','17:00:00',2.98),('8975','2014-04-08','17:05:00',2.97),('8975','2014-04-08','17:10:00',2.52),('8975','2014-04-08','17:15:00',2.08),('8975','2014-04-08','17:20:00',1.98),('8975','2014-04-08','17:25:00',1.73),('8975','2014-04-08','17:30:00',1.96),('8975','2014-04-08','17:35:00',1.34),('8975','2014-04-08','17:40:00',1.06),('8975','2014-04-08','17:45:00',1.45),('8975','2014-04-08','17:50:00',1.89),('8975','2014-04-08','17:55:00',1.6),('8975','2014-04-08','18:00:00',1.58),('8975','2014-04-08','18:05:00',1.02),('8975','2014-04-08','18:10:00',1.07),('8975','2013-08-08','07:10:00',1.15),('8975','2013-08-08','07:15:00',1.31),('8975','2013-08-08','07:20:00',1.5),('8975','2013-08-08','07:25:00',1.63),('8975','2013-08-08','07:30:00',1.01),('8975','2013-08-08','07:35:00',1.05),('8975','2013-08-08','07:40:00',1.12),('8975','2013-08-08','07:55:00',1.03),('8975','2013-08-08','08:00:00',1.94),('8975','2013-08-08','08:05:00',2.14),('8975','2013-08-08','08:10:00',1.6),('8975','2013-08-08','08:15:00',1.39),('8975','2013-08-08','08:20:00',1.34),('8975','2013-08-08','08:25:00',1.49),('8975','2013-08-08','08:30:00',1.83),('8975','2013-08-08','08:35:00',3.11),('8975','2013-08-08','08:40:00',3.52),('8975','2013-08-08','08:45:00',3.17),('8975','2013-08-08','08:50:00',3.44),('8975','2013-08-08','08:55:00',3.6),('8975','2013-08-08','09:00:00',3.67),('8975','2013-08-08','09:05:00',3.87),('8975','2013-08-08','09:10:00',4.28),('8975','2013-08-08','09:15:00',4.05),('8975','2013-08-08','09:20:00',3.22),('8975','2013-08-08','09:25:00',3.33),('8975','2013-08-08','09:30:00',4.06),('8975','2013-08-08','09:35:00',3.73),('8975','2013-08-08','09:40:00',2.13),('8975','2013-08-08','09:45:00',1.53),('8975','2013-08-08','09:50:00',1.65),('8975','2013-08-08','09:55:00',2.46),('8975','2013-08-08','10:00:00',3.07),('8975','2013-08-08','10:05:00',4.01),('8975','2013-08-08','10:10:00',4.23),('8975','2013-08-08','10:15:00',4.92),('8975','2013-08-08','10:20:00',4.95),('8975','2013-08-08','10:25:00',4.93),('8975','2013-08-08','10:30:00',5.2),('8975','2013-08-08','10:35:00',5.18),('8975','2013-08-08','10:40:00',5.31),('8975','2013-08-08','10:45:00',5.3),('8975','2013-08-08','10:50:00',5.28),('8975','2013-08-08','10:55:00',5.35),('8975','2013-08-08','11:00:00',5.45),('8975','2013-08-08','11:05:00',5.42),('8975','2013-08-08','11:10:00',5.54),('8975','2013-08-08','11:15:00',5.52),('8975','2013-08-08','11:20:00',5.48),('8975','2013-08-08','11:25:00',5.55),('8975','2013-08-08','11:30:00',5.57),('8975','2013-08-08','11:35:00',5.56),('8975','2013-08-08','11:40:00',5.59),('8975','2013-08-08','11:45:00',5.64),('8975','2013-08-08','11:50:00',5.63),('8975','2013-08-08','11:55:00',5.71),('8975','2013-08-08','12:00:00',5.75),('8975','2013-08-08','12:05:00',5.74),('8975','2013-08-08','12:10:00',5.72),('8975','2013-08-08','12:15:00',5.8),('8975','2013-08-08','12:20:00',5.77),('8975','2013-08-08','12:25:00',3.03),('8975','2013-08-08','12:30:00',3.26),('8975','2013-08-08','12:35:00',4.21),('8975','2013-08-08','12:40:00',5.02),('8975','2013-08-08','12:45:00',3.49),('8975','2013-08-08','12:50:00',3.25),('8975','2013-08-08','12:55:00',3.23),('8975','2013-08-08','13:00:00',1.47),('8975','2013-08-08','13:05:00',1.29),('8975','2013-08-08','13:10:00',1.3),('8975','2013-08-08','13:15:00',2.26),('8975','2013-08-08','13:20:00',3.3),('8975','2013-08-08','13:25:00',3.04),('8975','2013-08-08','13:30:00',2.79),('8975','2013-08-08','13:35:00',2.48),('8975','2013-08-08','13:40:00',2.28),('8975','2013-08-08','13:45:00',2.34),('8975','2013-08-08','13:50:00',2.34),('8975','2013-08-08','13:55:00',2),('8975','2013-08-08','14:00:00',1.95),('8975','2013-08-08','14:05:00',2.04),('8975','2013-08-08','14:10:00',1.89),('8975','2013-08-08','14:15:00',1.49),('8975','2013-08-08','14:20:00',1.44),('8975','2013-08-08','14:25:00',1.64),('8975','2013-08-08','14:30:00',1.52),('8975','2013-08-08','14:35:00',1.02),('8975','2013-08-08','15:05:00',2.33),('8975','2013-08-08','15:10:00',3.91),('8975','2013-08-08','15:15:00',3.11),('8975','2013-08-08','15:20:00',2.11),('8975','2013-08-08','15:25:00',1.66),('8975','2013-08-08','15:30:00',2.08),('8975','2013-08-08','15:35:00',3.2),('8975','2013-08-08','15:40:00',2.49),('8975','2013-08-08','15:45:00',4.03),('8975','2013-08-08','15:50:00',3.5),('8975','2013-08-08','15:55:00',3.19),('8975','2013-08-08','16:00:00',1.63),('8975','2013-08-08','16:05:00',1.06),('8975','2013-08-08','16:10:00',1.02),('8975','2013-08-08','16:15:00',1.07),('8975','2013-08-08','16:20:00',1.2),('8975','2013-08-08','16:25:00',1.36),('8975','2013-08-08','16:35:00',1.01),('8975','2013-08-08','16:40:00',1.06),('8975','2013-08-08','16:45:00',1.47),('8975','2013-08-08','16:50:00',2.36),('8975','2013-08-08','16:55:00',2.46),('8975','2013-08-08','17:00:00',2.82),('8975','2013-08-08','17:05:00',1.72),('8975','2013-08-08','17:10:00',1.22),('8975','2013-08-08','17:25:00',1.04),('8975','2013-08-08','17:30:00',1.24),('8975','2013-08-08','17:35:00',1.29),('8975','2013-08-08','17:40:00',1.18),('8975','2013-08-08','17:45:00',1.16),('8975','2013-08-08','19:00:00',1.04),('8975','2013-08-08','19:05:00',1.26),('8975','2013-08-08','19:10:00',1.32),('8975','2013-08-08','19:15:00',1.38),('8975','2013-08-08','19:20:00',1.6),('8975','2013-08-08','19:25:00',1.44),('8975','2013-08-07','07:05:00',1.02),('8975','2013-08-07','07:10:00',1.16),('8975','2013-08-07','07:15:00',1.28),('8975','2013-08-07','07:20:00',1.46),('8975','2013-08-07','07:25:00',1.64),('8975','2013-08-07','07:30:00',1.81),('8975','2013-08-07','07:35:00',1.96),('8975','2013-08-07','07:40:00',2.1),('8975','2013-08-07','07:45:00',2.22),('8975','2013-08-07','07:50:00',2.32),('8975','2013-08-07','07:55:00',2.44),('8975','2013-08-07','08:00:00',2.56),('8975','2013-08-07','08:05:00',2.66),('8975','2013-08-07','08:10:00',2.78),('8975','2013-08-07','08:15:00',2.9),('8975','2013-08-07','08:20:00',2.99),('8975','2013-08-07','08:25:00',3.1),('8975','2013-08-07','08:30:00',3.2),('8975','2013-08-07','08:35:00',3.3),('8975','2013-08-07','08:40:00',3.39),('8975','2013-08-07','08:45:00',3.49),('8975','2013-08-07','08:50:00',3.59),('8975','2013-08-07','08:55:00',3.68),('8975','2013-08-07','09:00:00',3.8),('8975','2013-08-07','09:05:00',3.91),('8975','2013-08-07','09:10:00',4),('8975','2013-08-07','09:15:00',4.09),('8975','2013-08-07','09:20:00',4.16),('8975','2013-08-07','09:25:00',4.26),('8975','2013-08-07','09:30:00',4.32),('8975','2013-08-07','09:35:00',4.38),('8975','2013-08-07','09:40:00',4.45),('8975','2013-08-07','09:45:00',4.54),('8975','2013-08-07','09:50:00',4.64),('8975','2013-08-07','09:55:00',4.71),('8975','2013-08-07','10:00:00',4.75),('8975','2013-08-07','10:05:00',4.82),('8975','2013-08-07','10:10:00',4.85),('8975','2013-08-07','10:15:00',4.95),('8975','2013-08-07','10:20:00',4.99),('8975','2013-08-07','10:25:00',5.04),('8975','2013-08-07','10:30:00',5.09),('8975','2013-08-07','10:35:00',5.16),('8975','2013-08-07','10:40:00',5.21),('8975','2013-08-07','10:45:00',5.27),('8975','2013-08-07','10:50:00',5.31),('8975','2013-08-07','10:55:00',5.34),('8975','2013-08-07','11:00:00',5.4),('8975','2013-08-07','11:05:00',5.41),('8975','2013-08-07','11:10:00',5.45),('8975','2013-08-07','11:15:00',5.48),('8975','2013-08-07','11:20:00',5.49),('8975','2013-08-07','11:25:00',5.53),('8975','2013-08-07','11:30:00',5.58),('8975','2013-08-07','11:35:00',5.55),('8975','2013-08-07','11:40:00',5.56),('8975','2013-08-07','11:45:00',5.52),('8975','2013-08-07','11:50:00',5.57),('8975','2013-08-07','11:55:00',5.65),('8975','2013-08-07','12:00:00',5.65),('8975','2013-08-07','12:05:00',5.67),('8975','2013-08-07','12:10:00',5.69),('8975','2013-08-07','12:15:00',5.7),('8975','2013-08-07','12:20:00',5.7),('8975','2013-08-07','12:25:00',5.71),('8975','2013-08-07','12:30:00',5.78),('8975','2013-08-07','12:35:00',5.72),('8975','2013-08-07','12:40:00',5.72),('8975','2013-08-07','12:45:00',5.77),('8975','2013-08-07','12:50:00',5.68),('8975','2013-08-07','12:55:00',5.64),('8975','2013-08-07','13:00:00',5.73),('8975','2013-08-07','13:05:00',5.68),('8975','2013-08-07','13:10:00',5.68),('8975','2013-08-07','13:15:00',5.66),('8975','2013-08-07','13:20:00',5.61),('8975','2013-08-07','13:25:00',5.61),('8975','2013-08-07','13:30:00',5.57),('8975','2013-08-07','13:35:00',5.54),('8975','2013-08-07','13:40:00',5.55),('8975','2013-08-07','13:45:00',5.51),('8975','2013-08-07','13:50:00',5.49),('8975','2013-08-07','13:55:00',5.44),('8975','2013-08-07','14:00:00',5.36),('8975','2013-08-07','14:05:00',5.32),('8975','2013-08-07','14:10:00',5.31),('8975','2013-08-07','14:15:00',5.25),('8975','2013-08-07','14:20:00',5.17),('8975','2013-08-07','14:25:00',5.15),('8975','2013-08-07','14:30:00',5.06),('8975','2013-08-07','14:35:00',4.96),('8975','2013-08-07','14:40:00',4.89),('8975','2013-08-07','14:45:00',4.85),('8975','2013-08-07','14:50:00',4.77),('8975','2013-08-07','14:55:00',4.71),('8975','2013-08-07','15:00:00',4.63),('8975','2013-08-07','15:05:00',4.58),('8975','2013-08-07','15:10:00',4.47),('8975','2013-08-07','15:15:00',4.37),('8975','2013-08-07','15:20:00',4.34),('8975','2013-08-07','15:25:00',4.25),('8975','2013-08-07','15:30:00',4.16),('8975','2013-08-07','15:35:00',4.1),('8975','2013-08-07','15:40:00',4),('8975','2013-08-07','15:45:00',3.91),('8975','2013-08-07','15:50:00',3.83),('8975','2013-08-07','15:55:00',3.77),('8975','2013-08-07','16:00:00',3.68),('8975','2013-08-07','16:05:00',3.61),('8975','2013-08-07','16:10:00',3.51),('8975','2013-08-07','16:15:00',3.41),('8975','2013-08-07','16:20:00',3.32),('8975','2013-08-07','16:25:00',3.26),('8975','2013-08-07','16:30:00',3.15),('8975','2013-08-07','16:35:00',3.06),('8975','2013-08-07','16:40:00',2.93),('8975','2013-08-07','16:45:00',2.8),('8975','2013-08-07','16:50:00',2.64),('8975','2013-08-07','16:55:00',2.58),('8975','2013-08-07','17:00:00',2.47),('8975','2013-08-07','17:05:00',2.35),('8975','2013-08-07','17:10:00',2.25),('8975','2013-08-07','17:15:00',2.15),('8975','2013-08-07','17:20:00',2.06),('8975','2013-08-07','17:25:00',1.96),('8975','2013-08-07','17:30:00',1.87),('8975','2013-08-07','17:35:00',1.8),('8975','2013-08-07','17:40:00',1.73),('8975','2013-08-07','17:45:00',1.65),('8975','2013-08-07','17:50:00',1.56),('8975','2013-08-07','17:55:00',1.5),('8975','2013-08-07','18:00:00',1.44),('8975','2013-08-07','18:05:00',1.36),('8975','2013-08-07','18:10:00',1.3),('8975','2013-08-07','18:15:00',1.22),('8975','2013-08-07','18:20:00',1.18),('8975','2013-08-07','18:25:00',1.12),('8975','2013-08-07','18:30:00',1.07),('8975','2013-08-07','18:35:00',1.02),('8975','2013-08-06','07:00:00',1.07),('8975','2013-08-06','07:05:00',1.19),('8975','2013-08-06','07:10:00',1.31),('8975','2013-08-06','07:15:00',1.42),('8975','2013-08-06','07:20:00',1.48),('8975','2013-08-06','07:25:00',1.74),('8975','2013-08-06','07:30:00',1.97),('8975','2013-08-06','07:35:00',2.12),('8975','2013-08-06','07:40:00',2.25),('8975','2013-08-06','07:45:00',2.35),('8975','2013-08-06','07:50:00',2.48),('8975','2013-08-06','07:55:00',2.61),('8975','2013-08-06','08:00:00',2.72),('8975','2013-08-06','08:05:00',2.82),('8975','2013-08-06','08:10:00',2.94),('8975','2013-08-06','08:15:00',3.05),('8975','2013-08-06','08:20:00',3.15),('8975','2013-08-06','08:25:00',3.25),('8975','2013-08-06','08:30:00',3.36),('8975','2013-08-06','08:35:00',3.46),('8975','2013-08-06','08:40:00',3.57),('8975','2013-08-06','08:45:00',3.65),('8975','2013-08-06','08:50:00',3.74),('8975','2013-08-06','08:55:00',3.83),('8975','2013-08-06','09:00:00',3.9),('8975','2013-08-06','09:05:00',3.98),('8975','2013-08-06','09:10:00',4.05),('8975','2013-08-06','09:15:00',4.17),('8975','2013-08-06','09:20:00',4.26),('8975','2013-08-06','09:25:00',4.36),('8975','2013-08-06','09:30:00',4.43),('8975','2013-08-06','09:35:00',4.53),('8975','2013-08-06','09:40:00',4.59),('8975','2013-08-06','09:45:00',4.67),('8975','2013-08-06','09:50:00',4.74),('8975','2013-08-06','09:55:00',4.78),('8975','2013-08-06','10:00:00',4.85),('8975','2013-08-06','10:05:00',4.88),('8975','2013-08-06','10:10:00',4.95),('8975','2013-08-06','10:15:00',5.03),('8975','2013-08-06','10:20:00',5.07),('8975','2013-08-06','10:25:00',5.13),('8975','2013-08-06','10:30:00',5.2),('8975','2013-08-06','10:35:00',5.25),('8975','2013-08-06','10:40:00',5.28),('8975','2013-08-06','10:45:00',5.34),('8975','2013-08-06','10:50:00',5.39),('8975','2013-08-06','10:55:00',5.43),('8975','2013-08-06','11:00:00',5.46),('8975','2013-08-06','11:05:00',5.49),('8975','2013-08-06','11:10:00',5.54),('8975','2013-08-06','11:15:00',5.54),('8975','2013-08-06','11:20:00',5.54),('8975','2013-08-06','11:25:00',5.59),('8975','2013-08-06','11:30:00',5.63),('8975','2013-08-06','11:35:00',5.63),('8975','2013-08-06','11:40:00',5.66),('8975','2013-08-06','11:45:00',5.72),('8975','2013-08-06','11:50:00',5.72),('8975','2013-08-06','11:55:00',5.7),('8975','2013-08-06','12:00:00',5.72),('8975','2013-08-06','12:05:00',5.71),('8975','2013-08-06','12:10:00',5.76),('8975','2013-08-06','12:15:00',5.78),('8975','2013-08-06','12:20:00',5.76),('8975','2013-08-06','12:25:00',5.75),('8975','2013-08-06','12:30:00',5.7),('8975','2013-08-06','12:35:00',5.78),('8975','2013-08-06','12:40:00',5.78),('8975','2013-08-06','12:45:00',5.79),('8975','2013-08-06','12:50:00',5.71),('8975','2013-08-06','12:55:00',5.69),('8975','2013-08-06','13:00:00',5.69),('8975','2013-08-06','13:05:00',5.66),('8975','2013-08-06','13:10:00',5.66),('8975','2013-08-06','13:15:00',5.69),('8975','2013-08-06','13:20:00',5.71),('8975','2013-08-06','13:25:00',5.65),('8975','2013-08-06','13:30:00',5.61),('8975','2013-08-06','13:35:00',5.5),('8975','2013-08-06','13:40:00',5.63),('8975','2013-08-06','13:45:00',5.58),('8975','2013-08-06','13:50:00',5.52),('8975','2013-08-06','13:55:00',5.54),('8975','2013-08-06','14:00:00',5.46),('8975','2013-08-06','14:05:00',5.41),('8975','2013-08-06','14:10:00',5.36),('8975','2013-08-06','14:15:00',5.34),('8975','2013-08-06','14:20:00',5.28),('8975','2013-08-06','14:25:00',5.2),('8975','2013-08-06','14:30:00',5.19),('8975','2013-08-06','14:35:00',5.04),('8975','2013-08-06','14:40:00',4.9),('8975','2013-08-06','14:45:00',4.86),('8975','2013-08-06','14:50:00',4.81),('8975','2013-08-06','14:55:00',4.74),('8975','2013-08-06','15:00:00',4.71),('8975','2013-08-06','15:05:00',4.65),('8975','2013-08-06','15:10:00',4.4),('8975','2013-08-06','15:15:00',4.42),('8975','2013-08-06','15:20:00',4.29),('8975','2013-08-06','15:25:00',4.08),('8975','2013-08-06','15:30:00',3.95),('8975','2013-08-06','15:35:00',3.97),('8975','2013-08-06','15:40:00',3.99),('8975','2013-08-06','15:45:00',3.94),('8975','2013-08-06','15:50:00',3.86),('8975','2013-08-06','15:55:00',3.78),('8975','2013-08-06','16:00:00',3.77),('8975','2013-08-06','16:05:00',3.69),('8975','2013-08-06','16:10:00',3.58),('8975','2013-08-06','16:15:00',3.45),('8975','2013-08-06','16:20:00',3.38),('8975','2013-08-06','16:25:00',3.29),('8975','2013-08-06','16:30:00',3.18),('8975','2013-08-06','16:35:00',3.08),('8975','2013-08-06','16:40:00',2.99),('8975','2013-08-06','16:45:00',2.88),('8975','2013-08-06','16:50:00',2.78),('8975','2013-08-06','16:55:00',2.68),('8975','2013-08-06','17:00:00',2.57),('8975','2013-08-06','17:05:00',2.45),('8975','2013-08-06','17:10:00',2.37),('8975','2013-08-06','17:15:00',2.26),('8975','2013-08-06','17:20:00',2.16),('8975','2013-08-06','17:25:00',2.07),('8975','2013-08-06','17:30:00',1.98),('8975','2013-08-06','17:35:00',1.89),('8975','2013-08-06','17:40:00',1.81),('8975','2013-08-06','17:45:00',1.72),('8975','2013-08-06','17:50:00',1.63),('8975','2013-08-06','17:55:00',1.56),('8975','2013-08-06','18:00:00',1.48),('8975','2013-08-06','18:05:00',1.4),('8975','2013-08-06','18:10:00',1.34),('8975','2013-08-06','18:15:00',1.29),('8975','2013-08-06','18:20:00',1.21),('8975','2013-08-06','18:25:00',1.16),('8975','2013-08-06','18:30:00',1.11),('8975','2013-08-06','18:35:00',1.06),('8975','2013-08-06','18:40:00',1.03),('8975','2013-08-05','07:05:00',1.04),('8975','2013-08-05','07:10:00',1.18),('8975','2013-08-05','07:15:00',1.29),('8975','2013-08-05','07:20:00',1.47),('8975','2013-08-05','07:25:00',1.65),('8975','2013-08-05','07:30:00',1.8),('8975','2013-08-05','07:35:00',1.95),('8975','2013-08-05','07:40:00',2.1),('8975','2013-08-05','07:45:00',2.23),('8975','2013-08-05','07:50:00',2.35),('8975','2013-08-05','07:55:00',2.47),('8975','2013-08-05','08:00:00',2.58),('8975','2013-08-05','08:05:00',2.7),('8975','2013-08-05','08:10:00',2.83),('8975','2013-08-05','08:15:00',2.94),('8975','2013-08-05','08:20:00',3.04),('8975','2013-08-05','08:25:00',3.15),('8975','2013-08-05','08:30:00',3.26),('8975','2013-08-05','08:35:00',3.35),('8975','2013-08-05','08:40:00',3.44),('8975','2013-08-05','08:45:00',3.56),('8975','2013-08-05','08:50:00',3.67),('8975','2013-08-05','08:55:00',3.74),('8975','2013-08-05','09:00:00',3.82),('8975','2013-08-05','09:05:00',3.92),('8975','2013-08-05','09:10:00',4.01),('8975','2013-08-05','09:15:00',4.07),('8975','2013-08-05','09:20:00',4.15),('8975','2013-08-05','09:25:00',4.25),('8975','2013-08-05','09:30:00',4.34),('8975','2013-08-05','09:35:00',4.43),('8975','2013-08-05','09:40:00',4.52),('8975','2013-08-05','09:45:00',4.61),('8975','2013-08-05','09:50:00',4.7),('8975','2013-08-05','09:55:00',4.77),('8975','2013-08-05','10:00:00',4.85),('8975','2013-08-05','10:05:00',4.92),('8975','2013-08-05','10:10:00',4.98),('8975','2013-08-05','10:15:00',5.05),('8975','2013-08-05','10:20:00',5.11),('8975','2013-08-05','10:25:00',5.15),('8975','2013-08-05','10:30:00',5.21),('8975','2013-08-05','10:35:00',5.25),('8975','2013-08-05','10:40:00',5.29),('8975','2013-08-05','10:45:00',5.35),('8975','2013-08-05','10:50:00',5.4),('8975','2013-08-05','10:55:00',5.43),('8975','2013-08-05','11:00:00',5.46),('8975','2013-08-05','11:05:00',5.53),('8975','2013-08-05','11:10:00',5.55),('8975','2013-08-05','11:15:00',5.57),('8975','2013-08-05','11:20:00',5.58),('8975','2013-08-05','11:25:00',5.63),('8975','2013-08-05','11:30:00',5.61),('8975','2013-08-05','11:35:00',5.64),('8975','2013-08-05','11:40:00',5.68),('8975','2013-08-05','11:45:00',5.69),('8975','2013-08-05','11:50:00',5.67),('8975','2013-08-05','11:55:00',5.71),('8975','2013-08-05','12:00:00',5.69),('8975','2013-08-05','12:05:00',5.75),('8975','2013-08-05','12:10:00',5.79),('8975','2013-08-05','12:15:00',5.78),('8975','2013-08-05','12:20:00',5.73),('8975','2013-08-05','12:25:00',5.74),('8975','2013-08-05','12:30:00',5.76),('8975','2013-08-05','12:35:00',5.74),('8975','2013-08-05','12:40:00',5.75),('8975','2013-08-05','12:45:00',5.74),('8975','2013-08-05','12:50:00',5.65),('8975','2013-08-05','12:55:00',5.68),('8975','2013-08-05','13:00:00',5.72),('8975','2013-08-05','13:05:00',5.66),('8975','2013-08-05','13:10:00',5.7),('8975','2013-08-05','13:15:00',5.68),('8975','2013-08-05','13:20:00',5.65),('8975','2013-08-05','13:25:00',5.68),('8975','2013-08-05','13:30:00',5.69),('8975','2013-08-05','13:35:00',5.64),('8975','2013-08-05','13:40:00',5.66),('8975','2013-08-05','13:45:00',5.62),('8975','2013-08-05','13:50:00',5.58),('8975','2013-08-05','13:55:00',5.56),('8975','2013-08-05','14:00:00',5.54),('8975','2013-08-05','14:05:00',5.52),('8975','2013-08-05','14:10:00',5.48),('8975','2013-08-05','14:15:00',5.46),('8975','2013-08-05','14:20:00',5.42),('8975','2013-08-05','14:25:00',5.38),('8975','2013-08-05','14:30:00',5.31),('8975','2013-08-05','14:35:00',5.24),('8975','2013-08-05','14:40:00',5.19),('8975','2013-08-05','14:45:00',5.13),('8975','2013-08-05','14:50:00',5.07),('8975','2013-08-05','14:55:00',5),('8975','2013-08-05','15:00:00',4.94),('8975','2013-08-05','15:05:00',4.85),('8975','2013-08-05','15:10:00',4.77),('8975','2013-08-05','15:15:00',4.71),('8975','2013-08-05','15:20:00',4.64),('8975','2013-08-05','15:25:00',4.54),('8975','2013-08-05','15:30:00',4.45),('8975','2013-08-05','15:35:00',4.31),('8975','2013-08-05','15:40:00',4.28),('8975','2013-08-05','15:45:00',4.17),('8975','2013-08-05','15:50:00',4.08),('8975','2013-08-05','15:55:00',3.98),('8975','2013-08-05','16:00:00',3.88),('8975','2013-08-05','16:05:00',3.78),('8975','2013-08-05','16:10:00',3.69),('8975','2013-08-05','16:15:00',3.59),('8975','2013-08-05','16:20:00',3.48),('8975','2013-08-05','16:25:00',3.37),('8975','2013-08-05','16:30:00',3.27),('8975','2013-08-05','16:35:00',3.13),('8975','2013-08-05','16:40:00',3.06),('8975','2013-08-05','16:45:00',2.94),('8975','2013-08-05','16:50:00',2.83),('8975','2013-08-05','16:55:00',2.74),('8975','2013-08-05','17:00:00',2.64),('8975','2013-08-05','17:05:00',2.52),('8975','2013-08-05','17:10:00',2.41),('8975','2013-08-05','17:15:00',2.3),('8975','2013-08-05','17:20:00',2.2),('8975','2013-08-05','17:25:00',2.11),('8975','2013-08-05','17:30:00',2),('8975','2013-08-05','17:35:00',1.88),('8975','2013-08-05','17:40:00',1.78),('8975','2013-08-05','17:45:00',1.7),('8975','2013-08-05','17:50:00',1.63),('8975','2013-08-05','17:55:00',1.55),('8975','2013-08-05','18:00:00',1.49),('8975','2013-08-05','18:05:00',1.43),('8975','2013-08-05','18:10:00',1.36),('8975','2013-08-05','18:15:00',1.31),('8975','2013-08-05','18:20:00',1.25),('8975','2013-08-05','18:25:00',1.2),('8975','2013-08-05','18:30:00',1.14),('8975','2013-08-05','18:35:00',1.11),('8975','2013-08-05','18:40:00',1.05),('8975','2013-08-04','07:00:00',1.1),('8975','2013-08-04','07:05:00',1.23),('8975','2013-08-04','07:10:00',1.33),('8975','2013-08-04','07:15:00',1.44),('8975','2013-08-04','07:20:00',1.61),('8975','2013-08-04','07:25:00',1.82),('8975','2013-08-04','07:30:00',1.96),('8975','2013-08-04','07:35:00',2.11),('8975','2013-08-04','07:40:00',2.23),('8975','2013-08-04','07:45:00',2.37),('8975','2013-08-04','07:50:00',2.53),('8975','2013-08-04','07:55:00',2.65),('8975','2013-08-04','08:00:00',2.75),('8975','2013-08-04','08:05:00',2.88),('8975','2013-08-04','08:10:00',2.99),('8975','2013-08-04','08:15:00',3.07),('8975','2013-08-04','08:20:00',3.18),('8975','2013-08-04','08:25:00',3.27),('8975','2013-08-04','08:30:00',3.33),('8975','2013-08-04','08:35:00',3.42),('8975','2013-08-04','08:40:00',3.51),('8975','2013-08-04','08:45:00',3.61),('8975','2013-08-04','08:50:00',3.72),('8975','2013-08-04','08:55:00',3.84),('8975','2013-08-04','09:00:00',3.92),('8975','2013-08-04','09:05:00',4.04),('8975','2013-08-04','09:10:00',4.12),('8975','2013-08-04','09:15:00',4.22),('8975','2013-08-04','09:20:00',4.31),('8975','2013-08-04','09:25:00',4.41),('8975','2013-08-04','09:30:00',4.47),('8975','2013-08-04','09:35:00',4.58),('8975','2013-08-04','09:40:00',4.67),('8975','2013-08-04','09:45:00',4.72),('8975','2013-08-04','09:50:00',4.79),('8975','2013-08-04','09:55:00',4.86),('8975','2013-08-04','10:00:00',4.94),('8975','2013-08-04','10:05:00',5.01),('8975','2013-08-04','10:10:00',5.07),('8975','2013-08-04','10:15:00',5.13),('8975','2013-08-04','10:20:00',5.21),('8975','2013-08-04','10:25:00',5.25),('8975','2013-08-04','10:30:00',5.3),('8975','2013-08-04','10:35:00',5.37),('8975','2013-08-04','10:40:00',5.39),('8975','2013-08-04','10:45:00',5.47),('8975','2013-08-04','10:50:00',5.54),('8975','2013-08-04','10:55:00',5.58),('8975','2013-08-04','11:00:00',5.6),('8975','2013-08-04','11:05:00',5.61),('8975','2013-08-04','11:10:00',5.68),('8975','2013-08-04','11:15:00',5.71),('8975','2013-08-04','11:20:00',5.71),('8975','2013-08-04','11:25:00',5.77),('8975','2013-08-04','11:30:00',5.72),('8975','2013-08-04','11:35:00',5.78),('8975','2013-08-04','11:40:00',5.85),('8975','2013-08-04','11:45:00',5.87),('8975','2013-08-04','11:50:00',5.87),('8975','2013-08-04','11:55:00',5.86),('8975','2013-08-04','12:00:00',5.85),('8975','2013-08-04','12:05:00',5.87),('8975','2013-08-04','12:10:00',5.98),('8975','2013-08-04','12:15:00',5.93),('8975','2013-08-04','12:20:00',5.88),('8975','2013-08-04','12:25:00',5.91),('8975','2013-08-04','12:30:00',5.91),('8975','2013-08-04','12:35:00',5.89),('8975','2013-08-04','12:40:00',5.92),('8975','2013-08-04','12:45:00',5.89),('8975','2013-08-04','12:50:00',5.84),('8975','2013-08-04','12:55:00',5.82),('8975','2013-08-04','13:00:00',5.8),('8975','2013-08-04','13:05:00',5.82),('8975','2013-08-04','13:10:00',5.75),('8975','2013-08-04','13:15:00',5.75),('8975','2013-08-04','13:20:00',5.74),('8975','2013-08-04','13:25:00',5.67),('8975','2013-08-04','13:30:00',5.71),('8975','2013-08-04','13:35:00',5.63),('8975','2013-08-04','13:40:00',5.55),('8975','2013-08-04','13:45:00',5.55),('8975','2013-08-04','13:50:00',5.24),('8975','2013-08-04','13:55:00',4.88),('8975','2013-08-04','14:00:00',5.34),('8975','2013-08-04','14:05:00',4.34),('8975','2013-08-04','14:10:00',5.17),('8975','2013-08-04','14:15:00',4.64),('8975','2013-08-04','14:20:00',4.4),('8975','2013-08-04','14:25:00',5.21),('8975','2013-08-04','14:30:00',5.15),('8975','2013-08-04','14:35:00',5.05),('8975','2013-08-04','14:40:00',5.05),('8975','2013-08-04','14:45:00',4.98),('8975','2013-08-04','14:50:00',4.94),('8975','2013-08-04','14:55:00',4.88),('8975','2013-08-04','15:00:00',4.82),('8975','2013-08-04','15:05:00',4.78),('8975','2013-08-04','15:10:00',4.69),('8975','2013-08-04','15:15:00',4.64),('8975','2013-08-04','15:20:00',4.55),('8975','2013-08-04','15:25:00',4.47),('8975','2013-08-04','15:30:00',4.42),('8975','2013-08-04','15:35:00',4.35),('8975','2013-08-04','15:40:00',4.25),('8975','2013-08-04','15:45:00',4.14),('8975','2013-08-04','15:50:00',4.06),('8975','2013-08-04','15:55:00',3.98),('8975','2013-08-04','16:00:00',3.9),('8975','2013-08-04','16:05:00',3.8),('8975','2013-08-04','16:10:00',3.7),('8975','2013-08-04','16:15:00',3.58),('8975','2013-08-04','16:20:00',3.47),('8975','2013-08-04','16:25:00',3.36),('8975','2013-08-04','16:30:00',3.25),('8975','2013-08-04','16:35:00',3.15),('8975','2013-08-04','16:40:00',3.04),('8975','2013-08-04','16:45:00',2.95),('8975','2013-08-04','16:50:00',2.83),('8975','2013-08-04','16:55:00',2.71),('8975','2013-08-04','17:00:00',2.59),('8975','2013-08-04','17:05:00',2.5),('8975','2013-08-04','17:10:00',2.39),('8975','2013-08-04','17:15:00',2.29),('8975','2013-08-04','17:20:00',2.19),('8975','2013-08-04','17:25:00',2.09),('8975','2013-08-04','17:30:00',2),('8975','2013-08-04','17:35:00',1.9),('8975','2013-08-04','17:40:00',1.82),('8975','2013-08-04','17:45:00',1.75),('8975','2013-08-04','17:50:00',1.65),('8975','2013-08-04','17:55:00',1.57),('8975','2013-08-04','18:00:00',1.51),('8975','2013-08-04','18:05:00',1.43),('8975','2013-08-04','18:10:00',1.36),('8975','2013-08-04','18:15:00',1.26),('8975','2013-08-04','18:20:00',1.21),('8975','2013-08-04','18:25:00',1.15),('8975','2013-08-04','18:30:00',1.09),('8975','2013-08-04','18:35:00',1.07),('8975','2013-08-04','18:40:00',1.02),('8975','2013-08-03','07:00:00',1.52),('8975','2013-08-03','07:05:00',1.67),('8975','2013-08-03','07:10:00',1.74),('8975','2013-08-03','07:15:00',1.88),('8975','2013-08-03','07:20:00',2.03),('8975','2013-08-03','07:25:00',2.25),('8975','2013-08-03','07:30:00',2.38),('8975','2013-08-03','07:35:00',2.51),('8975','2013-08-03','07:40:00',2.62),('8975','2013-08-03','07:45:00',2.75),('8975','2013-08-03','07:50:00',2.86),('8975','2013-08-03','07:55:00',2.99),('8975','2013-08-03','08:00:00',3.06),('8975','2013-08-03','08:05:00',3.15),('8975','2013-08-03','08:10:00',3.25),('8975','2013-08-03','08:15:00',3.36),('8975','2013-08-03','08:20:00',3.47),('8975','2013-08-03','08:25:00',3.58),('8975','2013-08-03','08:30:00',3.68),('8975','2013-08-03','08:35:00',3.76),('8975','2013-08-03','08:40:00',3.86),('8975','2013-08-03','08:45:00',3.95),('8975','2013-08-03','08:50:00',4.03),('8975','2013-08-03','08:55:00',4.1),('8975','2013-08-03','09:00:00',4.16),('8975','2013-08-03','09:05:00',4.27),('8975','2013-08-03','09:10:00',4.37),('8975','2013-08-03','09:15:00',4.44),('8975','2013-08-03','09:20:00',4.55),('8975','2013-08-03','09:25:00',4.62),('8975','2013-08-03','09:30:00',4.72),('8975','2013-08-03','09:35:00',4.81),('8975','2013-08-03','09:40:00',4.87),('8975','2013-08-03','09:45:00',4.94),('8975','2013-08-03','09:50:00',5.01),('8975','2013-08-03','09:55:00',5.08),('8975','2013-08-03','10:00:00',5.13),('8975','2013-08-03','10:05:00',5.19),('8975','2013-08-03','10:10:00',5.25),('8975','2013-08-03','10:15:00',5.28),('8975','2013-08-03','10:20:00',5.37),('8975','2013-08-03','10:25:00',5.42),('8975','2013-08-03','10:30:00',5.49),('8975','2013-08-03','10:35:00',5.55),('8975','2013-08-03','10:40:00',5.59),('8975','2013-08-03','10:45:00',5.66),('8975','2013-08-03','10:50:00',5.71),('8975','2013-08-03','10:55:00',5.73),('8975','2013-08-03','11:00:00',5.73),('8975','2013-08-03','11:05:00',5.74),('8975','2013-08-03','11:10:00',5.77),('8975','2013-08-03','11:15:00',5.84),('8975','2013-08-03','11:20:00',5.87),('8975','2013-08-03','11:25:00',5.93),('8975','2013-08-03','11:30:00',5.93),('8975','2013-08-03','11:35:00',6),('8975','2013-08-03','11:40:00',6.03),('8975','2013-08-03','11:45:00',6.07),('8975','2013-08-03','11:50:00',6.05),('8975','2013-08-03','11:55:00',6.04),('8975','2013-08-03','12:00:00',6.08),('8975','2013-08-03','12:05:00',6.09),('8975','2013-08-03','12:10:00',6.12),('8975','2013-08-03','12:15:00',6.12),('8975','2013-08-03','12:20:00',6.04),('8975','2013-08-03','12:25:00',6.02),('8975','2013-08-03','12:30:00',6.08),('8975','2013-08-03','12:35:00',6.1),('8975','2013-08-03','12:40:00',6.1),('8975','2013-08-03','12:45:00',5.99),('8975','2013-08-03','12:50:00',6.11),('8975','2013-08-03','12:55:00',6.08),('8975','2013-08-03','13:00:00',5.94),('8975','2013-08-03','13:05:00',5.98),('8975','2013-08-03','13:10:00',5.78),('8975','2013-08-03','13:15:00',5.65),('8975','2013-08-03','13:20:00',5.94),('8975','2013-08-03','13:25:00',5.91),('8975','2013-08-03','13:30:00',5.51),('8975','2013-08-03','13:35:00',5.6),('8975','2013-08-03','13:40:00',5.57),('8975','2013-08-03','13:45:00',5.76),('8975','2013-08-03','13:50:00',5.53),('8975','2013-08-03','13:55:00',5.76),('8975','2013-08-03','14:00:00',5.71),('8975','2013-08-03','14:05:00',5.7),('8975','2013-08-03','14:10:00',5.65),('8975','2013-08-03','14:15:00',5.61),('8975','2013-08-03','14:20:00',5.53),('8975','2013-08-03','14:25:00',5.52),('8975','2013-08-03','14:30:00',5.47),('8975','2013-08-03','14:35:00',5.4),('8975','2013-08-03','14:40:00',5.34),('8975','2013-08-03','14:45:00',5.26),('8975','2013-08-03','14:50:00',5.18),('8975','2013-08-03','14:55:00',5.11),('8975','2013-08-03','15:00:00',4.99),('8975','2013-08-03','15:05:00',4.99),('8975','2013-08-03','15:10:00',4.9),('8975','2013-08-03','15:15:00',4.82),('8975','2013-08-03','15:20:00',4.7),('8975','2013-08-03','15:25:00',4.61),('8975','2013-08-03','15:30:00',4.51),('8975','2013-08-03','15:35:00',4.38),('8975','2013-08-03','15:40:00',4.34),('8975','2013-08-03','15:45:00',4.25),('8975','2013-08-03','15:50:00',4.15),('8975','2013-08-03','15:55:00',3.97),('8975','2013-08-03','16:00:00',3.81),('8975','2013-08-03','16:05:00',3.89),('8975','2013-08-03','16:10:00',3.82),('8975','2013-08-03','16:15:00',3.69),('8975','2013-08-03','16:20:00',3.58),('8975','2013-08-03','16:25:00',3.47),('8975','2013-08-03','16:30:00',3.39),('8975','2013-08-03','16:35:00',3.25),('8975','2013-08-03','16:40:00',3.14),('8975','2013-08-03','16:45:00',3.03),('8975','2013-08-03','16:50:00',2.9),('8975','2013-08-03','16:55:00',2.8),('8975','2013-08-03','17:00:00',2.68),('8975','2013-08-03','17:05:00',2.59),('8975','2013-08-03','17:10:00',2.45),('8975','2013-08-03','17:15:00',2.34),('8975','2013-08-03','17:20:00',2.24),('8975','2013-08-03','17:25:00',2.14),('8975','2013-08-03','17:30:00',2.04),('8975','2013-08-03','17:35:00',1.95),('8975','2013-08-03','17:40:00',1.85),('8975','2013-08-03','17:45:00',1.75),('8975','2013-08-03','17:50:00',1.67),('8975','2013-08-03','17:55:00',1.59),('8975','2013-08-03','18:00:00',1.51),('8975','2013-08-03','18:05:00',1.44),('8975','2013-08-03','18:10:00',1.37),('8975','2013-08-03','18:15:00',1.29),('8975','2013-08-03','18:20:00',1.26),('8975','2013-08-03','18:25:00',1.2),('8975','2013-08-03','18:30:00',1.15),('8975','2013-08-03','18:35:00',1.08),('8975','2013-08-03','18:40:00',1.02),('8975','2013-08-02','07:00:00',1.46),('8975','2013-08-02','07:05:00',1.56),('8975','2013-08-02','07:10:00',1.63),('8975','2013-08-02','07:15:00',1.49),('8975','2013-08-02','07:20:00',2),('8975','2013-08-02','07:25:00',1.93),('8975','2013-08-02','07:30:00',2.16),('8975','2013-08-02','07:35:00',2.4),('8975','2013-08-02','07:40:00',2.52),('8975','2013-08-02','07:45:00',2.49),('8975','2013-08-02','07:50:00',2.8),('8975','2013-08-02','07:55:00',2.5),('8975','2013-08-02','08:00:00',3.04),('8975','2013-08-02','08:05:00',2.72),('8975','2013-08-02','08:10:00',3.19),('8975','2013-08-02','08:15:00',3.33),('8975','2013-08-02','08:20:00',3.44),('8975','2013-08-02','08:25:00',3.53),('8975','2013-08-02','08:30:00',3.62),('8975','2013-08-02','08:35:00',3.72),('8975','2013-08-02','08:40:00',3.83),('8975','2013-08-02','08:45:00',3.92),('8975','2013-08-02','08:50:00',4.01),('8975','2013-08-02','08:55:00',4.08),('8975','2013-08-02','09:00:00',4.2),('8975','2013-08-02','09:05:00',4.28),('8975','2013-08-02','09:10:00',4.35),('8975','2013-08-02','09:15:00',4.43),('8975','2013-08-02','09:20:00',4.5),('8975','2013-08-02','09:25:00',4.59),('8975','2013-08-02','09:30:00',4.63),('8975','2013-08-02','09:35:00',4.74),('8975','2013-08-02','09:40:00',4.81),('8975','2013-08-02','09:45:00',4.89),('8975','2013-08-02','09:50:00',4.96),('8975','2013-08-02','09:55:00',5.03),('8975','2013-08-02','10:00:00',5.09),('8975','2013-08-02','10:05:00',5.17),('8975','2013-08-02','10:10:00',5.24),('8975','2013-08-02','10:15:00',5.26),('8975','2013-08-02','10:20:00',5.34),('8975','2013-08-02','10:25:00',5.4),('8975','2013-08-02','10:30:00',5.44),('8975','2013-08-02','10:35:00',5.53),('8975','2013-08-02','10:40:00',5.58),('8975','2013-08-02','10:45:00',5.64),('8975','2013-08-02','10:50:00',5.7),('8975','2013-08-02','10:55:00',5.73),('8975','2013-08-02','11:00:00',5.78),('8975','2013-08-02','11:05:00',5.82),('8975','2013-08-02','11:10:00',5.85),('8975','2013-08-02','11:15:00',5.84),('8975','2013-08-02','11:20:00',5.94),('8975','2013-08-02','11:25:00',5.95),('8975','2013-08-02','11:30:00',5.94),('8975','2013-08-02','11:35:00',6.02),('8975','2013-08-02','11:40:00',5.97),('8975','2013-08-02','11:45:00',5.99),('8975','2013-08-02','11:50:00',6.01),('8975','2013-08-02','11:55:00',6.07),('8975','2013-08-02','12:00:00',6.05),('8975','2013-08-02','12:05:00',6.11),('8975','2013-08-02','12:10:00',6.12),('8975','2013-08-02','12:15:00',5.99),('8975','2013-08-02','12:20:00',5.97),('8975','2013-08-02','12:25:00',5.95),('8975','2013-08-02','12:30:00',5.89),('8975','2013-08-02','12:35:00',6),('8975','2013-08-02','12:40:00',5.96),('8975','2013-08-02','12:45:00',5.88),('8975','2013-08-02','12:50:00',5.81),('8975','2013-08-02','12:55:00',5.82),('8975','2013-08-02','13:00:00',5.84),('8975','2013-08-02','13:05:00',5.82),('8975','2013-08-02','13:10:00',5.82),('8975','2013-08-02','13:15:00',5.78),('8975','2013-08-02','13:20:00',5.79),('8975','2013-08-02','13:25:00',5.76),('8975','2013-08-02','13:30:00',5.64),('8975','2013-08-02','13:35:00',5.64),('8975','2013-08-02','13:40:00',5.54),('8975','2013-08-02','13:45:00',5.42),('8975','2013-08-02','13:50:00',5.55),('8975','2013-08-02','13:55:00',5.47),('8975','2013-08-02','14:00:00',5.35),('8975','2013-08-02','14:05:00',5.37),('8975','2013-08-02','14:10:00',5.35),('8975','2013-08-02','14:15:00',5.29),('8975','2013-08-02','14:20:00',5.23),('8975','2013-08-02','14:25:00',5.16),('8975','2013-08-02','14:30:00',5.21),('8975','2013-08-02','14:35:00',5.3),('8975','2013-08-02','14:40:00',5.26),('8975','2013-08-02','14:45:00',5.13),('8975','2013-08-02','14:50:00',5.11),('8975','2013-08-02','14:55:00',5.01),('8975','2013-08-02','15:00:00',4.96),('8975','2013-08-02','15:05:00',4.89),('8975','2013-08-02','15:10:00',4.81),('8975','2013-08-02','15:15:00',4.73),('8975','2013-08-02','15:20:00',4.66),('8975','2013-08-02','15:25:00',4.6),('8975','2013-08-02','15:30:00',4.51),('8975','2013-08-02','15:35:00',4.42),('8975','2013-08-02','15:40:00',4.34),('8975','2013-08-02','15:45:00',4.23),('8975','2013-08-02','15:50:00',4.14),('8975','2013-08-02','15:55:00',4.05),('8975','2013-08-02','16:00:00',3.95),('8975','2013-08-02','16:05:00',3.86),('8975','2013-08-02','16:10:00',3.73),('8975','2013-08-02','16:15:00',3.64),('8975','2013-08-02','16:20:00',3.53),('8975','2013-08-02','16:25:00',3.42),('8975','2013-08-02','16:30:00',3.3),('8975','2013-08-02','16:35:00',3.23),('8975','2013-08-02','16:40:00',3.12),('8975','2013-08-02','16:45:00',2.98),('8975','2013-08-02','16:50:00',2.87),('8975','2013-08-02','16:55:00',2.78),('8975','2013-08-02','17:00:00',2.66),('8975','2013-08-02','17:05:00',2.54),('8975','2013-08-02','17:10:00',2.43),('8975','2013-08-02','17:15:00',2.33),('8975','2013-08-02','17:20:00',2.22),('8975','2013-08-02','17:25:00',2.13),('8975','2013-08-02','17:30:00',2.02),('8975','2013-08-02','17:35:00',1.93),('8975','2013-08-02','17:40:00',1.84),('8975','2013-08-02','17:45:00',1.75),('8975','2013-08-02','17:50:00',1.67),('8975','2013-08-02','17:55:00',1.59),('8975','2013-08-02','18:00:00',1.51),('8975','2013-08-02','18:05:00',1.44),('8975','2013-08-02','18:10:00',1.37),('8975','2013-08-02','18:15:00',1.32),('8975','2013-08-02','18:20:00',1.25),('8975','2013-08-02','18:25:00',1.21),('8975','2013-08-02','18:30:00',1.16),('8975','2013-08-02','18:35:00',1.12),('8975','2013-08-02','18:40:00',1.07),('8975','2013-08-02','18:45:00',1.02),('8975','2013-08-01','07:00:00',1.77),('8975','2013-08-01','07:05:00',1.9),('8975','2013-08-01','07:10:00',2.01),('8975','2013-08-01','07:15:00',2.13),('8975','2013-08-01','07:20:00',2.3),('8975','2013-08-01','07:25:00',2.45),('8975','2013-08-01','07:30:00',2.57),('8975','2013-08-01','07:35:00',2.7),('8975','2013-08-01','07:40:00',2.82),('8975','2013-08-01','07:45:00',2.93),('8975','2013-08-01','07:50:00',3.03),('8975','2013-08-01','07:55:00',3.11),('8975','2013-08-01','08:00:00',3.22),('8975','2013-08-01','08:05:00',3.32),('8975','2013-08-01','08:10:00',3.41),('8975','2013-08-01','08:15:00',3.5),('8975','2013-08-01','08:20:00',3.58),('8975','2013-08-01','08:25:00',3.68),('8975','2013-08-01','08:30:00',3.78),('8975','2013-08-01','12:40:00',6.07),('8975','2013-08-01','12:45:00',6.12),('8975','2013-08-01','12:50:00',6.15),('8975','2013-08-01','12:55:00',6.15),('8975','2013-08-01','13:00:00',6.13),('8975','2013-08-01','13:05:00',6.03),('8975','2013-08-01','13:10:00',6.01),('8975','2013-08-01','13:15:00',6.01),('8975','2013-08-01','13:20:00',6.04),('8975','2013-08-01','13:25:00',5.99),('8975','2013-08-01','13:30:00',5.98),('8975','2013-08-01','13:35:00',5.97),('8975','2013-08-01','13:40:00',5.82),('8975','2013-08-01','13:45:00',5.72),('8975','2013-08-01','13:50:00',5.66),('8975','2013-08-01','13:55:00',5.52),('8975','2013-08-01','14:00:00',5.66),('8975','2013-08-01','14:05:00',5.61),('8975','2013-08-01','14:10:00',5.56),('8975','2013-08-01','14:15:00',5.57),('8975','2013-08-01','14:20:00',5.63),('8975','2013-08-01','14:25:00',5.55),('8975','2013-08-01','14:30:00',5.42),('8975','2013-08-01','14:35:00',5.38),('8975','2013-08-01','14:40:00',5.29),('8975','2013-08-01','14:45:00',5.27),('8975','2013-08-01','14:50:00',5.17),('8975','2013-08-01','14:55:00',5.13),('8975','2013-08-01','15:00:00',5.06),('8975','2013-08-01','15:05:00',4.99),('8975','2013-08-01','15:10:00',4.92),('8975','2013-08-01','15:15:00',4.84),('8975','2013-08-01','15:20:00',4.79),('8975','2013-08-01','15:25:00',4.74),('8975','2013-08-01','15:30:00',4.64),('8975','2013-08-01','15:35:00',4.53),('8975','2013-08-01','15:40:00',4.44),('8975','2013-08-01','15:45:00',4.34),('8975','2013-08-01','15:50:00',4.25),('8975','2013-08-01','15:55:00',4.16),('8975','2013-08-01','16:00:00',4.07),('8975','2013-08-01','16:05:00',3.97),('8975','2013-08-01','16:10:00',3.84),('8975','2013-08-01','16:15:00',3.73),('8975','2013-08-01','16:20:00',3.65),('8975','2013-08-01','16:25:00',3.56),('8975','2013-08-01','16:30:00',3.47),('8975','2013-08-01','16:35:00',3.35),('8975','2013-08-01','16:40:00',3.23),('8975','2013-08-01','16:45:00',3.12),('8975','2013-08-01','16:50:00',3),('8975','2013-08-01','16:55:00',2.86),('8975','2013-08-01','17:00:00',2.76),('8975','2013-08-01','17:05:00',2.66),('8975','2013-08-01','17:10:00',2.52),('8975','2013-08-01','17:15:00',2.42),('8975','2013-08-01','17:20:00',2.3),('8975','2013-08-01','17:25:00',2.19),('8975','2013-08-01','17:30:00',2.08),('8975','2013-08-01','17:35:00',1.99),('8975','2013-08-01','17:40:00',1.9),('8975','2013-08-01','17:45:00',1.8),('8975','2013-08-01','17:50:00',1.72),('8975','2013-08-01','17:55:00',1.64),('8975','2013-08-01','18:00:00',1.56),('8975','2013-08-01','18:05:00',1.5),('8975','2013-08-01','18:10:00',1.44),('8975','2013-08-01','18:15:00',1.37),('8975','2013-08-01','18:20:00',1.3),('8975','2013-08-01','18:25:00',1.25),('8975','2013-08-01','18:30:00',1.2),('8975','2013-08-01','18:35:00',1.14),('8975','2013-08-01','18:40:00',1.07),('8975','2013-08-01','18:45:00',1.03),('8975','2013-07-31','07:00:00',1.82),('8975','2013-07-31','07:05:00',1.94),('8975','2013-07-31','07:10:00',2.06),('8975','2013-07-31','07:15:00',2.16),('8975','2013-07-31','07:20:00',2.35),('8975','2013-07-31','07:25:00',2.51),('8975','2013-07-31','07:30:00',2.62),('8975','2013-07-31','07:35:00',2.73),('8975','2013-07-31','07:40:00',2.86),('8975','2013-07-31','07:45:00',2.96),('8975','2013-07-31','07:50:00',3.03),('8975','2013-07-31','07:55:00',3.13),('8975','2013-07-31','08:00:00',3.26),('8975','2013-07-31','08:05:00',3.39),('8975','2013-07-31','08:10:00',3.49),('8975','2013-07-31','08:15:00',3.61),('8975','2013-07-31','08:20:00',3.71),('8975','2013-07-31','08:25:00',3.83),('8975','2013-07-31','08:30:00',3.94),('8975','2013-07-31','08:35:00',4.03),('8975','2013-07-31','08:40:00',4.14),('8975','2013-07-31','08:45:00',4.23),('8975','2013-07-31','08:50:00',4.32),('8975','2013-07-31','08:55:00',4.41),('8975','2013-07-31','09:00:00',4.5),('8975','2013-07-31','09:05:00',4.62),('8975','2013-07-31','09:10:00',4.72),('8975','2013-07-31','09:15:00',4.84),('8975','2013-07-31','09:20:00',4.93),('8975','2013-07-31','09:25:00',5.04),('8975','2013-07-31','09:30:00',5.11),('8975','2013-07-31','09:35:00',5.18),('8975','2013-07-31','09:40:00',5.29),('8975','2013-07-31','09:45:00',5.38),('8975','2013-07-31','09:50:00',5.47),('8975','2013-07-31','09:55:00',5.27),('8975','2013-07-31','10:00:00',5.45),('8975','2013-07-31','10:05:00',4.94),('8975','2013-07-31','10:10:00',5.66),('8975','2013-07-31','10:15:00',5.65),('8975','2013-07-31','10:20:00',5.62),('8975','2013-07-31','10:25:00',5.64),('8975','2013-07-31','10:30:00',5.59),('8975','2013-07-31','10:35:00',4.84),('8975','2013-07-31','10:40:00',5.38),('8975','2013-07-31','10:45:00',5.56),('8975','2013-07-31','10:50:00',5.7),('8975','2013-07-31','10:55:00',6.26),('8975','2013-07-31','11:00:00',6.3),('8975','2013-07-31','11:05:00',6.36),('8975','2013-07-31','11:10:00',6.35),('8975','2013-07-31','11:15:00',6.33),('8975','2013-07-31','11:20:00',6.39),('8975','2013-07-31','11:25:00',6.39),('8975','2013-07-31','11:30:00',6.42),('8975','2013-07-31','11:35:00',6.51),('8975','2013-07-31','11:40:00',6.58),('8975','2013-07-31','11:45:00',6.5),('8975','2013-07-31','11:50:00',6.54),('8975','2013-07-31','11:55:00',6.49),('8975','2013-07-31','12:00:00',6.61),('8975','2013-07-31','12:05:00',6.66),('8975','2013-07-31','12:10:00',6.66),('8975','2013-07-31','12:15:00',6.64),('8975','2013-07-31','12:20:00',6.51),('8975','2013-07-31','12:25:00',6.59),('8975','2013-07-31','12:30:00',6.6),('8975','2013-07-31','12:35:00',6.57),('8975','2013-07-31','12:40:00',6.61),('8975','2013-07-31','12:45:00',6.59),('8975','2013-07-31','12:50:00',6.54),('8975','2013-07-31','12:55:00',6.46),('8975','2013-07-31','13:00:00',6.48),('8975','2013-07-31','13:05:00',6.52),('8975','2013-07-31','13:10:00',6.51),('8975','2013-07-31','13:15:00',6.54),('8975','2013-07-31','13:20:00',6.46),('8975','2013-07-31','13:25:00',6.38),('8975','2013-07-31','13:30:00',6.22),('8975','2013-07-31','13:35:00',6.23),('8975','2013-07-31','13:40:00',6.17),('8975','2013-07-31','13:45:00',6.23),('8975','2013-07-31','13:50:00',5.36),('8975','2013-07-31','13:55:00',6.1),('8975','2013-07-31','14:00:00',5.85),('8975','2013-07-31','14:05:00',5.95),('8975','2013-07-31','14:10:00',5.14),('8975','2013-07-31','14:15:00',4.83),('8975','2013-07-31','14:20:00',5.71),('8975','2013-07-31','14:25:00',5.69),('8975','2013-07-31','14:30:00',5.57),('8975','2013-07-31','14:35:00',5.63),('8975','2013-07-31','14:40:00',5.55),('8975','2013-07-31','14:45:00',5.48),('8975','2013-07-31','14:50:00',5.38),('8975','2013-07-31','14:55:00',5.29),('8975','2013-07-31','15:00:00',5.16),('8975','2013-07-31','15:05:00',5.08),('8975','2013-07-31','15:10:00',4.07),('8975','2013-07-31','15:15:00',5.07),('8975','2013-07-31','15:20:00',5),('8975','2013-07-31','15:25:00',3.8),('8975','2013-07-31','15:30:00',4.78),('8975','2013-07-31','15:35:00',4.72),('8975','2013-07-31','15:40:00',4.91),('8975','2013-07-31','15:45:00',4.41),('8975','2013-07-31','15:50:00',4.34),('8975','2013-07-31','15:55:00',4.08),('8975','2013-07-31','16:00:00',4.19),('8975','2013-07-31','16:05:00',3.92),('8975','2013-07-31','16:10:00',3.92),('8975','2013-07-31','16:15:00',3.72),('8975','2013-07-31','16:20:00',3.72),('8975','2013-07-31','16:25:00',3.62),('8975','2013-07-31','16:30:00',3.52),('8975','2013-07-31','16:35:00',3.39),('8975','2013-07-31','16:40:00',3.27),('8975','2013-07-31','16:45:00',3.16),('8975','2013-07-31','16:50:00',3.04),('8975','2013-07-31','16:55:00',2.9),('8975','2013-07-31','17:00:00',2.78),('8975','2013-07-31','17:05:00',2.64),('8975','2013-07-31','17:10:00',2.54),('8975','2013-07-31','17:15:00',2.43),('8975','2013-07-31','17:20:00',2.32),('8975','2013-07-31','17:25:00',2.21),('8975','2013-07-31','17:30:00',2.11),('8975','2013-07-31','17:35:00',2.01),('8975','2013-07-31','17:40:00',1.91),('8975','2013-07-31','17:45:00',1.81),('8975','2013-07-31','17:50:00',1.72),('8975','2013-07-31','17:55:00',1.63),('8975','2013-07-31','18:00:00',1.56),('8975','2013-07-31','18:05:00',1.49),('8975','2013-07-31','18:10:00',1.42),('8975','2013-07-31','18:15:00',1.35),('8975','2013-07-31','18:20:00',1.3),('8975','2013-07-31','18:25:00',1.26),('8975','2013-07-31','18:30:00',1.22),('8975','2013-07-31','18:35:00',1.17),('8975','2013-07-31','18:40:00',1.12),('8975','2013-07-31','18:45:00',1.08),('8975','2013-07-31','18:50:00',1.02),('8975','2013-07-30','06:45:00',1.36),('8975','2013-07-30','06:50:00',1.49),('8975','2013-07-30','06:55:00',1.64),('8975','2013-07-30','07:00:00',1.79),('8975','2013-07-30','07:05:00',1.85),('8975','2013-07-30','07:10:00',2.06),('8975','2013-07-30','07:15:00',2.17),('8975','2013-07-30','07:20:00',1.99),('8975','2013-07-30','07:25:00',1.36),('8975','2013-07-30','07:35:00',1.46),('8975','2013-07-30','07:40:00',2.48),('8975','2013-07-30','07:45:00',3.09),('8975','2013-07-30','07:50:00',3.19),('8975','2013-07-30','07:55:00',3.3),('8975','2013-07-30','08:00:00',3.42),('8975','2013-07-30','08:05:00',3.51),('8975','2013-07-30','08:10:00',3.61),('8975','2013-07-30','08:15:00',3.71),('8975','2013-07-30','08:20:00',3.82),('8975','2013-07-30','08:25:00',3.92),('8975','2013-07-30','08:30:00',4.02),('8975','2013-07-30','08:35:00',4.11),('8975','2013-07-30','08:40:00',4.21),('8975','2013-07-30','08:45:00',4.3),('8975','2013-07-30','08:50:00',4.4),('8975','2013-07-30','08:55:00',4.48),('8975','2013-07-30','09:00:00',4.6),('8975','2013-07-30','09:05:00',4.7),('8975','2013-07-30','09:10:00',4.81),('8975','2013-07-30','09:15:00',4.9),('8975','2013-07-30','09:20:00',4.99),('8975','2013-07-30','09:25:00',5.06),('8975','2013-07-30','09:30:00',5.13),('8975','2013-07-30','09:35:00',5.25),('8975','2013-07-30','09:40:00',5.34),('8975','2013-07-30','09:45:00',5.39),('8975','2013-07-30','09:50:00',5.46),('8975','2013-07-30','09:55:00',5.54),('8975','2013-07-30','10:00:00',5.62),('8975','2013-07-30','10:05:00',5.7),('8975','2013-07-30','10:10:00',5.73),('8975','2013-07-30','10:15:00',5.82),('8975','2013-07-30','10:20:00',5.92),('8975','2013-07-30','10:25:00',6.01),('8975','2013-07-30','10:30:00',6.06),('8975','2013-07-30','10:35:00',6.12),('8975','2013-07-30','10:40:00',6.15),('8975','2013-07-30','10:45:00',6.2),('8975','2013-07-30','10:50:00',6.3),('8975','2013-07-30','10:55:00',6.34),('8975','2013-07-30','11:00:00',6.4),('8975','2013-07-30','11:05:00',6.42),('8975','2013-07-30','11:10:00',6.43),('8975','2013-07-30','11:15:00',6.47),('8975','2013-07-30','11:20:00',6.5),('8975','2013-07-30','11:25:00',6.49),('8975','2013-07-30','11:30:00',6.55),('8975','2013-07-30','11:35:00',6.57),('8975','2013-07-30','11:40:00',6.61),('8975','2013-07-30','11:45:00',6.65),('8975','2013-07-30','11:50:00',6.67),('8975','2013-07-30','11:55:00',6.65),('8975','2013-07-30','12:00:00',6.68),('8975','2013-07-30','12:05:00',6.69),('8975','2013-07-30','12:10:00',6.68),('8975','2013-07-30','12:15:00',6.73),('8975','2013-07-30','12:20:00',6.71),('8975','2013-07-30','12:25:00',6.72),('8975','2013-07-30','12:30:00',6.69),('8975','2013-07-30','12:35:00',6.65),('8975','2013-07-30','12:40:00',6.61),('8975','2013-07-30','12:45:00',6.69),('8975','2013-07-30','12:50:00',6.86),('8975','2013-07-30','12:55:00',6.69),('8975','2013-07-30','13:00:00',6.85),('8975','2013-07-30','13:05:00',6.85),('8975','2013-07-30','13:10:00',6.67),('8975','2013-07-30','13:15:00',6.56),('8975','2013-07-30','13:20:00',4.1),('8975','2013-07-30','13:25:00',6.57),('8975','2013-07-30','13:30:00',4.31),('8975','2013-07-30','13:35:00',5.57),('8975','2013-07-30','13:40:00',5.91),('8975','2013-07-30','13:45:00',3.29),('8975','2013-07-30','13:50:00',5.19),('8975','2013-07-30','13:55:00',5.16),('8975','2013-07-30','14:00:00',3.58),('8975','2013-07-30','14:05:00',5.55),('8975','2013-07-30','14:10:00',3.57),('8975','2013-07-30','14:15:00',4.32),('8975','2013-07-30','14:20:00',6.36),('8975','2013-07-30','14:25:00',6.26),('8975','2013-07-30','14:30:00',5.9),('8975','2013-07-30','14:35:00',5.75),('8975','2013-07-30','14:40:00',5.77),('8975','2013-07-30','14:45:00',5.72),('8975','2013-07-30','14:50:00',5.2),('8975','2013-07-30','14:55:00',5.07),('8975','2013-07-30','15:00:00',3.17),('8975','2013-07-30','15:05:00',4.06),('8975','2013-07-30','15:10:00',5.38),('8975','2013-07-30','15:15:00',5.28),('8975','2013-07-30','15:20:00',5.26),('8975','2013-07-30','15:25:00',3.13),('8975','2013-07-30','15:30:00',3.28),('8975','2013-07-30','15:35:00',4.86),('8975','2013-07-30','15:40:00',4.83),('8975','2013-07-30','15:45:00',3.24),('8975','2013-07-30','15:50:00',4.42),('8975','2013-07-30','15:55:00',4.32),('8975','2013-07-30','16:00:00',4.21),('8975','2013-07-30','16:05:00',4.25),('8975','2013-07-30','16:10:00',4.22),('8975','2013-07-30','16:15:00',4.01),('8975','2013-07-30','16:20:00',3.93),('8975','2013-07-30','16:25:00',3.97),('8975','2013-07-30','16:30:00',3.81),('8975','2013-07-30','16:35:00',3.54),('8975','2013-07-30','16:40:00',3.39),('8975','2013-07-30','16:45:00',3.01),('8975','2013-07-30','16:50:00',3.01),('8975','2013-07-30','16:55:00',2.96),('8975','2013-07-30','17:00:00',2.85),('8975','2013-07-30','17:05:00',2.73),('8975','2013-07-30','17:10:00',2.63),('8975','2013-07-30','17:15:00',2.57),('8975','2013-07-30','17:20:00',2.4),('8975','2013-07-30','17:25:00',2.26),('8975','2013-07-30','17:30:00',2.11),('8975','2013-07-30','17:35:00',2.01),('8975','2013-07-30','17:40:00',1.91),('8975','2013-07-30','17:45:00',1.81),('8975','2013-07-30','17:50:00',1.76),('8975','2013-07-30','17:55:00',1.68),('8975','2013-07-30','18:00:00',1.61),('8975','2013-07-30','18:05:00',1.52),('8975','2013-07-30','18:10:00',1.45),('8975','2013-07-30','18:15:00',1.36),('8975','2013-07-30','18:20:00',1.31),('8975','2013-07-30','18:25:00',1.27),('8975','2013-07-30','18:30:00',1.23),('8975','2013-07-30','18:35:00',1.21),('8975','2013-07-30','18:40:00',1.16),('8975','2013-07-30','18:45:00',1.1),('8975','2013-07-30','18:50:00',1.06),('8975','2013-07-30','18:55:00',1.01),('8975','2014-04-07','07:45:00',1.15),('8975','2014-04-07','07:50:00',1.92),('8975','2014-04-07','07:55:00',1.82),('8975','2014-04-07','08:00:00',2.52),('8975','2014-04-07','08:05:00',1.62),('8975','2014-04-07','08:10:00',1.53),('8975','2014-04-07','08:15:00',2.15),('8975','2014-04-07','08:20:00',2.94),('8975','2014-04-07','08:25:00',3.35),('8975','2014-04-07','08:30:00',3.33),('8975','2014-04-07','08:35:00',2.92),('8975','2014-04-07','08:40:00',2.81),('8975','2014-04-07','08:45:00',3.39),('8975','2014-04-07','08:50:00',3.35),('8975','2014-04-07','08:55:00',3.65),('8975','2014-04-07','09:00:00',3.74),('8975','2014-04-07','09:05:00',3.84),('8975','2014-04-07','09:10:00',3.96),('8975','2014-04-07','09:15:00',4.03),('8975','2014-04-07','09:20:00',4.14),('8975','2014-04-07','09:25:00',4.26),('8975','2014-04-07','09:30:00',4.32),('8975','2014-04-07','09:35:00',4.4),('8975','2014-04-07','09:40:00',4.4),('8975','2014-04-07','09:45:00',4.47),('8975','2014-04-07','09:50:00',4.58),('8975','2014-04-07','09:55:00',4.63),('8975','2014-04-07','10:00:00',4.64),('8975','2014-04-07','10:05:00',4.65),('8975','2014-04-07','10:10:00',4.81),('8975','2014-04-07','10:15:00',5.09),('8975','2014-04-07','10:20:00',5.12),('8975','2014-04-07','10:25:00',5.2),('8975','2014-04-07','10:30:00',5.32),('8975','2014-04-07','10:35:00',5.43),('8975','2014-04-07','10:40:00',5.47),('8975','2014-04-07','10:45:00',5.5),('8975','2014-04-07','10:50:00',5.51),('8975','2014-04-07','10:55:00',5.62),('8975','2014-04-07','11:00:00',5.63),('8975','2014-04-07','11:05:00',5.73),('8975','2014-04-07','11:10:00',5.71),('8975','2014-04-07','11:15:00',5.41),('8975','2014-04-07','11:20:00',5.62),('8975','2014-04-07','11:25:00',5.51),('8975','2014-04-07','11:30:00',5.84),('8975','2014-04-07','11:35:00',5.47),('8975','2014-04-07','11:40:00',5.83),('8975','2014-04-07','11:45:00',5.81),('8975','2014-04-07','11:50:00',5.8),('8975','2014-04-07','11:55:00',5.77),('8975','2014-04-07','12:00:00',6.01),('8975','2014-04-07','12:05:00',5.81),('8975','2014-04-07','12:10:00',5.65),('8975','2014-04-07','12:15:00',5.22),('8975','2014-04-07','12:20:00',5.3),('8975','2014-04-07','12:25:00',5.43),('8975','2014-04-07','12:30:00',5.88),('8975','2014-04-07','12:35:00',6.3),('8975','2014-04-07','12:40:00',5.11),('8975','2014-04-07','12:45:00',4.09),('8975','2014-04-07','12:50:00',4.84),('8975','2014-04-07','12:55:00',5.82),('8975','2014-04-07','13:00:00',5.77),('8975','2014-04-07','13:05:00',5.85),('8975','2014-04-07','13:10:00',5.92),('8975','2014-04-07','13:15:00',6.04),('8975','2014-04-07','13:20:00',6.02),('8975','2014-04-07','13:25:00',5.98),('8975','2014-04-07','13:30:00',5.98),('8975','2014-04-07','13:35:00',5.93),('8975','2014-04-07','13:40:00',5.89),('8975','2014-04-07','13:45:00',5.81),('8975','2014-04-07','13:50:00',5.73),('8975','2014-04-07','13:55:00',5.72),('8975','2014-04-07','14:00:00',5.65),('8975','2014-04-07','14:05:00',5.56),('8975','2014-04-07','14:10:00',5.55),('8975','2014-04-07','14:15:00',5.49),('8975','2014-04-07','14:20:00',5),('8975','2014-04-07','14:25:00',4.89),('8975','2014-04-07','14:30:00',5.31),('8975','2014-04-07','14:35:00',5.31),('8975','2014-04-07','14:40:00',4.35),('8975','2014-04-07','14:45:00',4.65),('8975','2014-04-07','14:50:00',4.85),('8975','2014-04-07','14:55:00',4.95),('8975','2014-04-07','15:00:00',4.79),('8975','2014-04-07','15:05:00',4.62),('8975','2014-04-07','15:10:00',4.58),('8975','2014-04-07','15:15:00',4.32),('8975','2014-04-07','15:20:00',4.11),('8975','2014-04-07','15:25:00',4.03),('8975','2014-04-07','15:30:00',3.69),('8975','2014-04-07','15:35:00',3.85),('8975','2014-04-07','15:40:00',3.87),('8975','2014-04-07','15:45:00',3.6),('8975','2014-04-07','15:50:00',3.62),('8975','2014-04-07','15:55:00',3.55),('8975','2014-04-07','16:00:00',3.38),('8975','2014-04-07','16:05:00',3.28),('8975','2014-04-07','16:10:00',3.14),('8975','2014-04-07','16:15:00',2.96),('8975','2014-04-07','16:20:00',2.82),('8975','2014-04-07','16:25:00',2.68),('8975','2014-04-07','16:30:00',2.9),('8975','2014-04-07','16:35:00',2.74),('8975','2014-04-07','16:40:00',2.66),('8975','2014-04-07','16:45:00',2.5),('8975','2014-04-07','16:50:00',2.37),('8975','2014-04-07','16:55:00',2.28),('8975','2014-04-07','17:00:00',2.08),('8975','2014-04-07','17:05:00',2.1),('8975','2014-04-07','17:10:00',1.97),('8975','2014-04-07','17:15:00',1.88),('8975','2014-04-07','17:20:00',1.76),('8975','2014-04-07','17:25:00',1.67),('8975','2014-04-07','17:30:00',1.56),('8975','2014-04-07','17:35:00',1.48),('8975','2014-04-07','17:40:00',1.46),('8975','2014-04-07','17:45:00',1.44),('8975','2014-04-07','17:50:00',1.41),('8975','2014-04-07','17:55:00',1.28),('8975','2014-04-07','18:00:00',1.26),('8975','2014-04-07','18:05:00',1.23),('8975','2014-04-07','18:10:00',1.17),('8975','2014-04-07','18:15:00',1.12),('8975','2014-04-07','18:20:00',1.03),('8975','2013-07-29','07:00:00',1.1),('8975','2013-07-29','07:05:00',1.33),('8975','2013-07-29','07:10:00',1.67),('8975','2013-07-29','07:15:00',1.81),('8975','2013-07-29','07:20:00',2.55),('8975','2013-07-29','07:25:00',3.19),('8975','2013-07-29','07:30:00',2.61),('8975','2013-07-29','07:50:00',2.37),('8975','2013-07-29','07:55:00',3.12),('8975','2013-07-29','08:00:00',3.23),('8975','2013-07-29','08:05:00',3.37),('8975','2013-07-29','08:10:00',3.48),('8975','2013-07-29','08:15:00',3.8),('8975','2013-07-29','08:20:00',4.08),('8975','2013-07-29','08:25:00',4.09),('8975','2013-07-29','08:30:00',4.14),('8975','2013-07-29','08:35:00',4.11),('8975','2013-07-29','08:40:00',4.12),('8975','2013-07-29','08:45:00',4.36),('8975','2013-07-29','08:50:00',4.36),('8975','2013-07-29','08:55:00',4.03),('8975','2013-07-29','09:00:00',3.96),('8975','2013-07-29','09:05:00',4.74),('8975','2013-07-29','09:10:00',4.84),('8975','2013-07-29','09:15:00',4.8),('8975','2013-07-29','09:20:00',4.84),('8975','2013-07-29','09:25:00',3.16),('8975','2013-07-29','09:30:00',3.89),('8975','2013-07-29','09:35:00',3.67),('8975','2013-07-29','09:40:00',3.39),('8975','2013-07-29','09:45:00',4.54),('8975','2013-07-29','09:50:00',3.08),('8975','2013-07-29','09:55:00',2.76),('8975','2013-07-29','10:00:00',5.24),('8975','2013-07-29','10:05:00',3.89),('8975','2013-07-29','10:10:00',6.15),('8975','2013-07-29','10:15:00',5.96),('8975','2013-07-29','10:20:00',5.67),('8975','2013-07-29','10:25:00',2.9),('8975','2013-07-29','10:30:00',2.62),('8975','2013-07-29','10:35:00',2.59),('8975','2013-07-29','10:40:00',6.37),('8975','2013-07-29','10:45:00',6.22),('8975','2013-07-29','10:50:00',6.19),('8975','2013-07-29','10:55:00',6.17),('8975','2013-07-29','11:00:00',6.28),('8975','2013-07-29','11:05:00',6.21),('8975','2013-07-29','11:10:00',5.8),('8975','2013-07-29','11:15:00',5.41),('8975','2013-07-29','11:20:00',6.55),('8975','2013-07-29','11:25:00',6.61),('8975','2013-07-29','11:30:00',6.57),('8975','2013-07-29','11:35:00',6.52),('8975','2013-07-29','11:40:00',6.46),('8975','2013-07-29','11:45:00',6.49),('8975','2013-07-29','11:50:00',5.01),('8975','2013-07-29','11:55:00',5.75),('8975','2013-07-29','12:00:00',6.27),('8975','2013-07-29','12:05:00',5.82),('8975','2013-07-29','12:10:00',6.34),('8975','2013-07-29','12:15:00',5.63),('8975','2013-07-29','12:20:00',5.78),('8975','2013-07-29','12:25:00',5.74),('8975','2013-07-29','12:30:00',6.18),('8975','2013-07-29','12:35:00',6.34),('8975','2013-07-29','12:40:00',6.56),('8975','2013-07-29','12:45:00',6.6),('8975','2013-07-29','12:50:00',6.57),('8975','2013-07-29','12:55:00',6.47),('8975','2013-07-29','13:00:00',4.13),('8975','2013-07-29','13:05:00',5.53),('8975','2013-07-29','13:10:00',3.8),('8975','2013-07-29','13:15:00',3.64),('8975','2013-07-29','13:20:00',6.7),('8975','2013-07-29','13:25:00',6.37),('8975','2013-07-29','13:30:00',6.33),('8975','2013-07-29','13:35:00',6.36),('8975','2013-07-29','13:40:00',6.35),('8975','2013-07-29','13:45:00',6.27),('8975','2013-07-29','13:50:00',6.16),('8975','2013-07-29','13:55:00',5.78),('8975','2013-07-29','14:00:00',6.26),('8975','2013-07-29','14:05:00',6.23),('8975','2013-07-29','14:10:00',6.11),('8975','2013-07-29','14:15:00',5.45),('8975','2013-07-29','14:20:00',6.01),('8975','2013-07-29','14:25:00',5.89),('8975','2013-07-29','14:30:00',5.81),('8975','2013-07-29','14:35:00',5.69),('8975','2013-07-29','14:40:00',5.44),('8975','2013-07-29','14:45:00',5.45),('8975','2013-07-29','14:50:00',5.28),('8975','2013-07-29','14:55:00',5.24),('8975','2013-07-29','15:00:00',5.23),('8975','2013-07-29','15:05:00',5.16),('8975','2013-07-29','15:10:00',5.03),('8975','2013-07-29','15:15:00',4.86),('8975','2013-07-29','15:20:00',4.88),('8975','2013-07-29','15:25:00',4.73),('8975','2013-07-29','15:30:00',4.61),('8975','2013-07-29','15:35:00',4.58),('8975','2013-07-29','15:40:00',4.49),('8975','2013-07-29','15:45:00',4.41),('8975','2013-07-29','15:50:00',4.33),('8975','2013-07-29','15:55:00',4.22),('8975','2013-07-29','16:00:00',4.08),('8975','2013-07-29','16:05:00',4),('8975','2013-07-29','16:10:00',3.88),('8975','2013-07-29','16:15:00',3.8),('8975','2013-07-29','16:20:00',3.72),('8975','2013-07-29','16:25:00',3.61),('8975','2013-07-29','16:30:00',3.49),('8975','2013-07-29','16:35:00',3.38),('8975','2013-07-29','16:40:00',3.29),('8975','2013-07-29','16:45:00',3.17),('8975','2013-07-29','16:50:00',3.07),('8975','2013-07-29','16:55:00',2.95),('8975','2013-07-29','17:00:00',2.82),('8975','2013-07-29','17:05:00',2.71),('8975','2013-07-29','17:10:00',2.6),('8975','2013-07-29','17:15:00',2.48),('8975','2013-07-29','17:20:00',2.36),('8975','2013-07-29','17:25:00',2.26),('8975','2013-07-29','17:30:00',2.15),('8975','2013-07-29','17:35:00',2.07),('8975','2013-07-29','17:40:00',1.98),('8975','2013-07-29','17:45:00',1.88),('8975','2013-07-29','17:50:00',1.8),('8975','2013-07-29','17:55:00',1.72),('8975','2013-07-29','18:00:00',1.62),('8975','2013-07-29','18:05:00',1.53),('8975','2013-07-29','18:10:00',1.45),('8975','2013-07-29','18:15:00',1.41),('8975','2013-07-29','18:20:00',1.34),('8975','2013-07-29','18:25:00',1.28),('8975','2013-07-29','18:30:00',1.22),('8975','2013-07-29','18:35:00',1.14),('8975','2013-07-29','18:40:00',1.1),('8975','2013-07-29','18:45:00',1.05),('8975','2013-07-29','18:50:00',1.01),('8975','2013-07-28','06:55:00',1.12),('8975','2013-07-28','07:00:00',1.26),('8975','2013-07-28','07:05:00',1.38),('8975','2013-07-28','07:10:00',1.47),('8975','2013-07-28','07:15:00',1.62),('8975','2013-07-28','07:20:00',1.79),('8975','2013-07-28','07:25:00',1.93),('8975','2013-07-28','07:30:00',2.1),('8975','2013-07-28','07:35:00',2.26),('8975','2013-07-28','07:40:00',2.38),('8975','2013-07-28','07:45:00',2.49),('8975','2013-07-28','07:50:00',2.6),('8975','2013-07-28','07:55:00',2.72),('8975','2013-07-28','08:00:00',2.86),('8975','2013-07-28','08:05:00',2.96),('8975','2013-07-28','08:10:00',3.09),('8975','2013-07-28','08:15:00',3.19),('8975','2013-07-28','08:20:00',3.25),('8975','2013-07-28','08:25:00',3.38),('8975','2013-07-28','08:30:00',3.47),('8975','2013-07-28','08:35:00',3.54),('8975','2013-07-28','08:40:00',3.63),('8975','2013-07-28','08:45:00',3.76),('8975','2013-07-28','08:50:00',3.74),('8975','2013-07-28','08:55:00',3.52),('8975','2013-07-28','09:00:00',3.82),('8975','2013-07-28','09:05:00',3.1),('8975','2013-07-28','09:10:00',3.9),('8975','2013-07-28','09:15:00',3.85),('8975','2013-07-28','09:20:00',4.31),('8975','2013-07-28','09:25:00',4.29),('8975','2013-07-28','09:30:00',4.32),('8975','2013-07-28','09:35:00',4.25),('8975','2013-07-28','09:40:00',4.48),('8975','2013-07-28','09:45:00',4.76),('8975','2013-07-28','09:50:00',4.98),('8975','2013-07-28','09:55:00',5.05),('8975','2013-07-28','10:00:00',5.16),('8975','2013-07-28','10:05:00',5.19),('8975','2013-07-28','10:10:00',5.25),('8975','2013-07-28','10:15:00',5.33),('8975','2013-07-28','10:20:00',5.36),('8975','2013-07-28','10:25:00',5.37),('8975','2013-07-28','10:30:00',5.51),('8975','2013-07-28','10:35:00',5.56),('8975','2013-07-28','10:40:00',5.66),('8975','2013-07-28','10:45:00',5.65),('8975','2013-07-28','10:50:00',5.68),('8975','2013-07-28','10:55:00',5.73),('8975','2013-07-28','11:00:00',5.77),('8975','2013-07-28','11:05:00',5.8),('8975','2013-07-28','11:10:00',5.82),('8975','2013-07-28','11:15:00',5.84),('8975','2013-07-28','11:20:00',5.84),('8975','2013-07-28','11:25:00',5.86),('8975','2013-07-28','11:30:00',5.88),('8975','2013-07-28','11:35:00',5.9),('8975','2013-07-28','11:40:00',5.92),('8975','2013-07-28','11:45:00',5.9),('8975','2013-07-28','11:50:00',5.9),('8975','2013-07-28','11:55:00',5.95),('8975','2013-07-28','12:00:00',5.91),('8975','2013-07-28','12:05:00',5.88),('8975','2013-07-28','12:10:00',5.92),('8975','2013-07-28','12:15:00',5.89),('8975','2013-07-28','12:20:00',5.92),('8975','2013-07-28','12:25:00',5.97),('8975','2013-07-28','12:30:00',6.02),('8975','2013-07-28','12:35:00',5.95),('8975','2013-07-28','12:40:00',5.79),('8975','2013-07-28','12:45:00',5.74),('8975','2013-07-28','12:50:00',5.76),('8975','2013-07-28','12:55:00',5.77),('8975','2013-07-28','13:00:00',5.7),('8975','2013-07-28','13:05:00',5.85),('8975','2013-07-28','13:10:00',5.88),('8975','2013-07-28','13:15:00',5.89),('8975','2013-07-28','13:20:00',5.89),('8975','2013-07-28','13:25:00',5.92),('8975','2013-07-28','13:30:00',5.92),('8975','2013-07-28','13:35:00',5.97),('8975','2013-07-28','13:40:00',5.96),('8975','2013-07-28','13:45:00',5.94),('8975','2013-07-28','13:50:00',5.94),('8975','2013-07-28','13:55:00',5.87),('8975','2013-07-28','14:00:00',5.84),('8975','2013-07-28','14:05:00',5.76),('8975','2013-07-28','14:10:00',5.75),('8975','2013-07-28','14:15:00',5.67),('8975','2013-07-28','14:20:00',5.64),('8975','2013-07-28','14:25:00',5.58),('8975','2013-07-28','14:30:00',5.53),('8975','2013-07-28','14:35:00',5.47),('8975','2013-07-28','14:40:00',5.36),('8975','2013-07-28','14:45:00',5.33),('8975','2013-07-28','14:50:00',5.29),('8975','2013-07-28','14:55:00',5.22),('8975','2013-07-28','15:00:00',5.12),('8975','2013-07-28','15:05:00',5.06),('8975','2013-07-28','15:10:00',4.96),('8975','2013-07-28','15:15:00',4.91),('8975','2013-07-28','15:20:00',4.81),('8975','2013-07-28','15:25:00',4.75),('8975','2013-07-28','15:30:00',4.67),('8975','2013-07-28','15:35:00',4.61),('8975','2013-07-28','15:40:00',4.59),('8975','2013-07-28','15:45:00',4.58),('8975','2013-07-28','15:50:00',3.84),('8975','2013-07-28','15:55:00',2.93),('8975','2013-07-28','16:00:00',2.54),('8975','2013-07-28','16:05:00',3.43),('8975','2013-07-28','16:10:00',3.42),('8975','2013-07-28','16:15:00',3.75),('8975','2013-07-28','16:20:00',3.25),('8975','2013-07-28','16:25:00',3.87),('8975','2013-07-28','16:30:00',3.65),('8975','2013-07-28','16:35:00',2.6),('8975','2013-07-28','16:40:00',3.27),('8975','2013-07-28','16:45:00',3.66),('8975','2013-07-28','16:50:00',3.3),('8975','2013-07-28','16:55:00',1.94),('8975','2013-07-28','17:00:00',1.92),('8975','2013-07-28','17:05:00',2.2),('8975','2013-07-28','17:10:00',1.38),('8975','2013-07-28','17:15:00',1.62),('8975','2013-07-28','17:20:00',2.74),('8975','2013-07-28','17:25:00',2.39),('8975','2013-07-28','17:30:00',1.58),('8975','2013-07-28','17:35:00',1.53),('8975','2013-07-28','17:40:00',1.51),('8975','2013-07-28','17:45:00',2.14),('8975','2013-07-28','17:50:00',1.91),('8975','2013-07-28','17:55:00',1.72),('8975','2013-07-28','18:00:00',1.26),('8975','2013-07-28','18:10:00',1.5),('8975','2013-07-28','18:15:00',1.32),('8975','2013-07-28','18:20:00',1.49),('8975','2013-07-28','18:25:00',1.47),('8975','2013-07-28','18:30:00',1.38),('8975','2013-07-28','18:35:00',1.21),('8975','2013-07-28','19:00:00',1.07),('8975','2013-07-28','19:05:00',1.1),('8975','2013-07-27','06:55:00',1.11),('8975','2013-07-27','07:00:00',1.28),('8975','2013-07-27','07:05:00',1.43),('8975','2013-07-27','07:10:00',1.56),('8975','2013-07-27','07:15:00',1.69),('8975','2013-07-27','07:20:00',1.86),('8975','2013-07-27','07:25:00',1.99),('8975','2013-07-27','07:30:00',2.11),('8975','2013-07-27','07:35:00',2.24),('8975','2013-07-27','07:40:00',2.35),('8975','2013-07-27','07:45:00',2.47),('8975','2013-07-27','07:50:00',2.58),('8975','2013-07-27','07:55:00',2.7),('8975','2013-07-27','08:00:00',2.81),('8975','2013-07-27','08:05:00',2.91),('8975','2013-07-27','08:10:00',3.05),('8975','2013-07-27','08:15:00',3.2),('8975','2013-07-27','08:20:00',3.3),('8975','2013-07-27','08:25:00',3.4),('8975','2013-07-27','08:30:00',3.51),('8975','2013-07-27','08:35:00',3.61),('8975','2013-07-27','08:40:00',3.7),('8975','2013-07-27','08:45:00',3.83),('8975','2013-07-27','08:50:00',3.95),('8975','2013-07-27','08:55:00',4.03),('8975','2013-07-27','09:00:00',4.15),('8975','2013-07-27','09:05:00',4.22),('8975','2013-07-27','09:10:00',4.35),('8975','2013-07-27','09:15:00',4.38),('8975','2013-07-27','09:20:00',4.48),('8975','2013-07-27','09:25:00',4.51),('8975','2013-07-27','09:30:00',4.64),('8975','2013-07-27','09:35:00',4.77),('8975','2013-07-27','09:40:00',4.86),('8975','2013-07-27','09:45:00',4.94),('8975','2013-07-27','09:50:00',4.98),('8975','2013-07-27','09:55:00',5.04),('8975','2013-07-27','10:00:00',5.13),('8975','2013-07-27','10:05:00',5.13),('8975','2013-07-27','10:10:00',5.25),('8975','2013-07-27','10:15:00',5.3),('8975','2013-07-27','10:20:00',5.34),('8975','2013-07-27','10:25:00',5.36),('8975','2013-07-27','10:30:00',5.44),('8975','2013-07-27','10:35:00',5.55),('8975','2013-07-27','10:40:00',5.62),('8975','2013-07-27','10:45:00',5.7),('8975','2013-07-27','10:50:00',5.72),('8975','2013-07-27','10:55:00',5.74),('8975','2013-07-27','11:00:00',5.76),('8975','2013-07-27','11:05:00',5.81),('8975','2013-07-27','11:10:00',5.75),('8975','2013-07-27','11:15:00',5.84),('8975','2013-07-27','11:20:00',5.78),('8975','2013-07-27','11:25:00',5.88),('8975','2013-07-27','11:30:00',5.83),('8975','2013-07-27','11:35:00',5.82),('8975','2013-07-27','11:40:00',5.94),('8975','2013-07-27','11:45:00',5.92),('8975','2013-07-27','11:50:00',5.94),('8975','2013-07-27','11:55:00',5.89),('8975','2013-07-27','12:00:00',5.88),('8975','2013-07-27','12:05:00',5.87),('8975','2013-07-27','12:10:00',5.87),('8975','2013-07-27','12:15:00',5.93),('8975','2013-07-27','12:20:00',6.04),('8975','2013-07-27','12:25:00',6.07),('8975','2013-07-27','12:30:00',6.04),('8975','2013-07-27','12:35:00',5.97),('8975','2013-07-27','12:40:00',6.05),('8975','2013-07-27','12:45:00',6.14),('8975','2013-07-27','12:50:00',6.14),('8975','2013-07-27','12:55:00',5.98),('8975','2013-07-27','13:00:00',5.2),('8975','2013-07-27','13:05:00',3.33),('8975','2013-07-27','13:10:00',5.27),('8975','2013-07-27','13:15:00',5.85),('8975','2013-07-27','13:20:00',6.05),('8975','2013-07-27','13:25:00',5.23),('8975','2013-07-27','13:30:00',5.47),('8975','2013-07-27','13:35:00',5.46),('8975','2013-07-27','13:40:00',5.58),('8975','2013-07-27','13:45:00',5.95),('8975','2013-07-27','13:50:00',5.9),('8975','2013-07-27','13:55:00',5.76),('8975','2013-07-27','14:00:00',5.74),('8975','2013-07-27','14:05:00',5.68),('8975','2013-07-27','14:10:00',5.63),('8975','2013-07-27','14:15:00',5.61),('8975','2013-07-27','14:20:00',5.52),('8975','2013-07-27','14:25:00',5.48),('8975','2013-07-27','14:30:00',5.43),('8975','2013-07-27','14:35:00',5.39),('8975','2013-07-27','14:40:00',5.37),('8975','2013-07-27','14:45:00',5.26),('8975','2013-07-27','14:50:00',5.17),('8975','2013-07-27','14:55:00',5.11),('8975','2013-07-27','15:00:00',5.04),('8975','2013-07-27','15:05:00',5),('8975','2013-07-27','15:10:00',4.94),('8975','2013-07-27','15:15:00',4.83),('8975','2013-07-27','15:20:00',4.72),('8975','2013-07-27','15:25:00',4.63),('8975','2013-07-27','15:30:00',4.58),('8975','2013-07-27','15:35:00',4.52),('8975','2013-07-27','15:40:00',4.42),('8975','2013-07-27','15:45:00',4.32),('8975','2013-07-27','15:50:00',4.25),('8975','2013-07-27','15:55:00',4.15),('8975','2013-07-27','16:00:00',4.08),('8975','2013-07-27','16:05:00',3.96),('8975','2013-07-27','16:10:00',3.87),('8975','2013-07-27','16:15:00',3.82),('8975','2013-07-27','16:20:00',3.74),('8975','2013-07-27','16:25:00',3.64),('8975','2013-07-27','16:30:00',3.52),('8975','2013-07-27','16:35:00',3.41),('8975','2013-07-27','16:40:00',3.32),('8975','2013-07-27','16:45:00',3.21),('8975','2013-07-27','16:50:00',3.11),('8975','2013-07-27','16:55:00',2.97),('8975','2013-07-27','17:00:00',2.84),('8975','2013-07-27','17:05:00',2.74),('8975','2013-07-27','17:10:00',2.63),('8975','2013-07-27','17:15:00',2.52),('8975','2013-07-27','17:20:00',2.42),('8975','2013-07-27','17:25:00',2.31),('8975','2013-07-27','17:30:00',2.21),('8975','2013-07-27','17:35:00',2.11),('8975','2013-07-27','17:40:00',2.01),('8975','2013-07-27','17:45:00',1.91),('8975','2013-07-27','17:50:00',1.82),('8975','2013-07-27','17:55:00',1.72),('8975','2013-07-27','18:00:00',1.63),('8975','2013-07-27','18:05:00',1.56),('8975','2013-07-27','18:10:00',1.48),('8975','2013-07-27','18:15:00',1.43),('8975','2013-07-27','18:20:00',1.37),('8975','2013-07-27','18:25:00',1.31),('8975','2013-07-27','18:30:00',1.25),('8975','2013-07-27','18:35:00',1.2),('8975','2013-07-27','18:40:00',1.13),('8975','2013-07-27','18:45:00',1.06),('8975','2013-07-27','18:50:00',1.03),('8975','2013-07-26','06:50:00',1.02),('8975','2013-07-26','06:55:00',1.16),('8975','2013-07-26','07:00:00',1.29),('8975','2013-07-26','07:05:00',1.41),('8975','2013-07-26','07:10:00',1.52),('8975','2013-07-26','07:15:00',1.68),('8975','2013-07-26','07:20:00',1.81),('8975','2013-07-26','07:25:00',1.94),('8975','2013-07-26','07:30:00',2.08),('8975','2013-07-26','07:35:00',2.21),('8975','2013-07-26','07:40:00',2.34),('8975','2013-07-26','07:45:00',2.48),('8975','2013-07-26','07:50:00',2.63),('8975','2013-07-26','07:55:00',2.77),('8975','2013-07-26','08:00:00',2.9),('8975','2013-07-26','08:05:00',3),('8975','2013-07-26','08:10:00',3.12),('8975','2013-07-26','08:15:00',3.21),('8975','2013-07-26','08:20:00',3.32),('8975','2013-07-26','08:25:00',3.42),('8975','2013-07-26','08:30:00',3.56),('8975','2013-07-26','08:35:00',3.68),('8975','2013-07-26','08:40:00',3.81),('8975','2013-07-26','08:45:00',3.93),('8975','2013-07-26','08:50:00',4.03),('8975','2013-07-26','08:55:00',4.09),('8975','2013-07-26','09:00:00',4.15),('8975','2013-07-26','09:05:00',4.27),('8975','2013-07-26','09:10:00',4.4),('8975','2013-07-26','09:15:00',4.49),('8975','2013-07-26','09:20:00',4.56),('8975','2013-07-26','09:25:00',4.64),('8975','2013-07-26','09:30:00',4.7),('8975','2013-07-26','09:35:00',4.79),('8975','2013-07-26','09:40:00',4.91),('8975','2013-07-26','09:45:00',4.99),('8975','2013-07-26','09:50:00',5.08),('8975','2013-07-26','09:55:00',5.16),('8975','2013-07-26','10:00:00',5.26),('8975','2013-07-26','10:05:00',5.32),('8975','2013-07-26','10:10:00',5.4),('8975','2013-07-26','10:15:00',5.45),('8975','2013-07-26','10:20:00',5.46),('8975','2013-07-26','10:25:00',5.49),('8975','2013-07-26','10:30:00',5.6),('8975','2013-07-26','10:35:00',5.63),('8975','2013-07-26','10:40:00',5.64),('8975','2013-07-26','10:45:00',5.64),('8975','2013-07-26','10:50:00',5.67),('8975','2013-07-26','10:55:00',5.75),('8975','2013-07-26','11:00:00',5.81),('8975','2013-07-26','11:05:00',5.84),('8975','2013-07-26','11:10:00',5.92),('8975','2013-07-26','11:15:00',5.92),('8975','2013-07-26','11:20:00',5.96),('8975','2013-07-26','11:25:00',6),('8975','2013-07-26','11:30:00',6.01),('8975','2013-07-26','11:35:00',6.01),('8975','2013-07-26','11:40:00',5.98),('8975','2013-07-26','11:45:00',6.03),('8975','2013-07-26','11:50:00',6.13),('8975','2013-07-26','11:55:00',6.15),('8975','2013-07-26','12:00:00',6.19),('8975','2013-07-26','12:05:00',6.05),('8975','2013-07-26','12:10:00',6.03),('8975','2013-07-26','12:15:00',6.2),('8975','2013-07-26','12:20:00',6.19),('8975','2013-07-26','12:25:00',6.19),('8975','2013-07-26','12:30:00',6.2),('8975','2013-07-26','12:35:00',6.19),('8975','2013-07-26','12:40:00',5.99),('8975','2013-07-26','12:45:00',6.04),('8975','2013-07-26','12:50:00',5.88),('8975','2013-07-26','12:55:00',6.03),('8975','2013-07-26','13:00:00',6.1),('8975','2013-07-26','13:05:00',6),('8975','2013-07-26','13:10:00',4.39),('8975','2013-07-26','13:15:00',6.19),('8975','2013-07-26','13:20:00',6.46),('8975','2013-07-26','13:25:00',6.24),('8975','2013-07-26','13:30:00',6.25),('8975','2013-07-26','13:35:00',6.18),('8975','2013-07-26','13:40:00',6.25),('8975','2013-07-26','13:45:00',6.03),('8975','2013-07-26','13:50:00',6.01),('8975','2013-07-26','13:55:00',6.02),('8975','2013-07-26','14:00:00',5.91),('8975','2013-07-26','14:05:00',5.83),('8975','2013-07-26','14:10:00',5.8),('8975','2013-07-26','14:15:00',5.67),('8975','2013-07-26','14:20:00',5.63),('8975','2013-07-26','14:25:00',5.67),('8975','2013-07-26','14:30:00',5.49),('8975','2013-07-26','14:35:00',5.4),('8975','2013-07-26','14:40:00',5.41),('8975','2013-07-26','14:45:00',5.37),('8975','2013-07-26','14:50:00',5.27),('8975','2013-07-26','14:55:00',5.2),('8975','2013-07-26','15:00:00',5.12),('8975','2013-07-26','15:05:00',5.04),('8975','2013-07-26','15:10:00',4.96),('8975','2013-07-26','15:15:00',4.92),('8975','2013-07-26','15:20:00',4.84),('8975','2013-07-26','15:25:00',4.77),('8975','2013-07-26','15:30:00',4.7),('8975','2013-07-26','15:35:00',4.62),('8975','2013-07-26','15:40:00',4.54),('8975','2013-07-26','15:45:00',4.43),('8975','2013-07-26','15:50:00',4.35),('8975','2013-07-26','15:55:00',4.24),('8975','2013-07-26','16:00:00',4.17),('8975','2013-07-26','16:05:00',4.07),('8975','2013-07-26','16:10:00',3.98),('8975','2013-07-26','16:15:00',3.87),('8975','2013-07-26','16:20:00',3.79),('8975','2013-07-26','16:25:00',3.67),('8975','2013-07-26','16:30:00',3.3),('8975','2013-07-26','16:35:00',3.06),('8975','2013-07-26','16:40:00',2.93),('8975','2013-07-26','16:45:00',3.17),('8975','2013-07-26','16:50:00',3),('8975','2013-07-26','16:55:00',2.97),('8975','2013-07-26','17:00:00',2.53),('8975','2013-07-26','17:05:00',2.53),('8975','2013-07-26','17:10:00',2.51),('8975','2013-07-26','17:15:00',2.37),('8975','2013-07-26','17:20:00',2.43),('8975','2013-07-26','17:25:00',2.31),('8975','2013-07-26','17:30:00',2.2),('8975','2013-07-26','17:35:00',2.1),('8975','2013-07-26','17:40:00',2.01),('8975','2013-07-26','17:45:00',1.93),('8975','2013-07-26','17:50:00',1.84),('8975','2013-07-26','17:55:00',1.75),('8975','2013-07-26','18:00:00',1.66),('8975','2013-07-26','18:05:00',1.56),('8975','2013-07-26','18:10:00',1.53),('8975','2013-07-26','18:15:00',1.47),('8975','2013-07-26','18:20:00',1.4),('8975','2013-07-26','18:25:00',1.33),('8975','2013-07-26','18:30:00',1.28),('8975','2013-07-26','18:35:00',1.24),('8975','2013-07-26','18:40:00',1.17),('8975','2013-07-26','18:45:00',1.11),('8975','2013-07-26','18:50:00',1.06),('8975','2013-07-26','18:55:00',1.02),('8975','2013-07-25','06:55:00',1.09),('8975','2013-07-25','07:00:00',1.25),('8975','2013-07-25','07:05:00',1.38),('8975','2013-07-25','07:10:00',1.51),('8975','2013-07-25','07:15:00',1.67),('8975','2013-07-25','07:20:00',1.79),('8975','2013-07-25','07:25:00',1.91),('8975','2013-07-25','07:30:00',2.04),('8975','2013-07-25','07:35:00',2.18),('8975','2013-07-25','07:40:00',2.32),('8975','2013-07-25','07:45:00',2.42),('8975','2013-07-25','07:50:00',2.49),('8975','2013-07-25','07:55:00',2.67),('8975','2013-07-25','08:00:00',2.78),('8975','2013-07-25','08:05:00',2.87),('8975','2013-07-25','08:10:00',2.94),('8975','2013-07-25','08:15:00',3.09),('8975','2013-07-25','08:20:00',3.21),('8975','2013-07-25','08:25:00',3.38),('8975','2013-07-25','08:30:00',3.43),('8975','2013-07-25','08:35:00',3.47),('8975','2013-07-25','08:40:00',3.73),('8975','2013-07-25','08:45:00',3.73),('8975','2013-07-25','08:50:00',3.93),('8975','2013-07-25','08:55:00',4.02),('8975','2013-07-25','09:00:00',4.09),('8975','2013-07-25','09:05:00',4.11),('8975','2013-07-25','09:10:00',4.33),('8975','2013-07-25','09:15:00',4.45),('8975','2013-07-25','09:20:00',4.54),('8975','2013-07-25','09:25:00',4.64),('8975','2013-07-25','09:30:00',4.72),('8975','2013-07-25','09:35:00',4.79),('8975','2013-07-25','09:40:00',4.9),('8975','2013-07-25','09:45:00',5),('8975','2013-07-25','09:50:00',5.07),('8975','2013-07-25','09:55:00',5.1),('8975','2013-07-25','10:00:00',5.13),('8975','2013-07-25','10:05:00',5.14),('8975','2013-07-25','10:10:00',5.24),('8975','2013-07-25','10:15:00',5.35),('8975','2013-07-25','10:20:00',5.45),('8975','2013-07-25','10:25:00',5.51),('8975','2013-07-25','10:30:00',5.49),('8975','2013-07-25','10:35:00',5.55),('8975','2013-07-25','10:40:00',5.54),('8975','2013-07-25','10:45:00',5.71),('8975','2013-07-25','10:50:00',5.72),('8975','2013-07-25','10:55:00',5.75),('8975','2013-07-25','11:00:00',5.74),('8975','2013-07-25','11:05:00',5.85),('8975','2013-07-25','11:10:00',6.02),('8975','2013-07-25','11:15:00',6.04),('8975','2013-07-25','11:20:00',6.19),('8975','2013-07-25','11:25:00',5.75),('8975','2013-07-25','11:30:00',6.07),('8975','2013-07-25','11:35:00',6.17),('8975','2013-07-25','11:40:00',6.09),('8975','2013-07-25','11:45:00',5.94),('8975','2013-07-25','11:50:00',3.79),('8975','2013-07-25','11:55:00',5.96),('8975','2013-07-25','12:00:00',6.34),('8975','2013-07-25','12:05:00',3.68),('8975','2013-07-25','12:10:00',5.8),('8975','2013-07-25','12:15:00',5.8),('8975','2013-07-25','12:20:00',3.8),('8975','2013-07-25','12:25:00',2.25),('8975','2013-07-25','12:30:00',3.94),('8975','2013-07-25','12:35:00',5.86),('8975','2013-07-25','12:40:00',4.15),('8975','2013-07-25','12:45:00',2.55),('8975','2013-07-25','12:50:00',5.14),('8975','2013-07-25','12:55:00',3.31),('8975','2013-07-25','13:00:00',6.95),('8975','2013-07-25','13:05:00',6.52),('8975','2013-07-25','13:10:00',6.86),('8975','2013-07-25','13:15:00',5.53),('8975','2013-07-25','13:20:00',4.87),('8975','2013-07-25','13:25:00',4.31),('8975','2013-07-25','13:30:00',2.36),('8975','2013-07-25','13:35:00',3.52),('8975','2013-07-25','13:40:00',6.34),('8975','2013-07-25','13:45:00',6.45),('8975','2013-07-25','13:50:00',6.51),('8975','2013-07-25','13:55:00',6.24),('8975','2013-07-25','14:00:00',6.21),('8975','2013-07-25','14:05:00',6.29),('8975','2013-07-25','14:10:00',6.41),('8975','2013-07-25','14:15:00',5.56),('8975','2013-07-25','14:20:00',6.07),('8975','2013-07-25','14:25:00',5.83),('8975','2013-07-25','14:30:00',5.66),('8975','2013-07-25','14:35:00',5.66),('8975','2013-07-25','14:40:00',5.47),('8975','2013-07-25','14:45:00',5.51),('8975','2013-07-25','14:50:00',5.4),('8975','2013-07-25','14:55:00',5.26),('8975','2013-07-25','15:00:00',5.21),('8975','2013-07-25','15:05:00',5.13),('8975','2013-07-25','15:10:00',5.09),('8975','2013-07-25','15:15:00',5.01),('8975','2013-07-25','15:20:00',4.91),('8975','2013-07-25','15:25:00',4.85),('8975','2013-07-25','15:30:00',4.74),('8975','2013-07-25','15:35:00',4.62),('8975','2013-07-25','15:40:00',4.52),('8975','2013-07-25','15:45:00',4.47),('8975','2013-07-25','15:50:00',4.37),('8975','2013-07-25','15:55:00',4.3),('8975','2013-07-25','16:00:00',4.2),('8975','2013-07-25','16:05:00',4.06),('8975','2013-07-25','16:10:00',3.98),('8975','2013-07-25','16:15:00',3.88),('8975','2013-07-25','16:20:00',3.78),('8975','2013-07-25','16:25:00',3.69),('8975','2013-07-25','16:30:00',3.59),('8975','2013-07-25','16:35:00',3.49),('8975','2013-07-25','16:40:00',3.39),('8975','2013-07-25','16:45:00',3.27),('8975','2013-07-25','16:50:00',3.17),('8975','2013-07-25','16:55:00',3.04),('8975','2013-07-25','17:00:00',2.96),('8975','2013-07-25','17:05:00',2.83),('8975','2013-07-25','17:10:00',2.7),('8975','2013-07-25','17:15:00',2.58),('8975','2013-07-25','17:20:00',2.45),('8975','2013-07-25','17:25:00',2.36),('8975','2013-07-25','17:30:00',2.28),('8975','2013-07-25','17:35:00',2.13),('8975','2013-07-25','17:40:00',2.03),('8975','2013-07-25','17:45:00',1.94),('8975','2013-07-25','17:50:00',1.84),('8975','2013-07-25','17:55:00',1.73),('8975','2013-07-25','18:00:00',1.64),('8975','2013-07-25','18:05:00',1.58),('8975','2013-07-25','18:10:00',1.5),('8975','2013-07-25','18:15:00',1.45),('8975','2013-07-25','18:20:00',1.39),('8975','2013-07-25','18:25:00',1.31),('8975','2013-07-25','18:30:00',1.25),('8975','2013-07-25','18:35:00',1.2),('8975','2013-07-25','18:40:00',1.14),('8975','2013-07-25','18:45:00',1.11),('8975','2013-07-25','18:50:00',1.05),('8975','2013-07-24','06:55:00',1.03),('8975','2013-07-24','07:00:00',1.13),('8975','2013-07-24','07:05:00',1.31),('8975','2013-07-24','07:10:00',1.39),('8975','2013-07-24','07:15:00',1.56),('8975','2013-07-24','07:20:00',1.67),('8975','2013-07-24','07:25:00',1.84),('8975','2013-07-24','07:30:00',2.01),('8975','2013-07-24','07:35:00',2.16),('8975','2013-07-24','07:40:00',2.3),('8975','2013-07-24','07:45:00',2.44),('8975','2013-07-24','07:50:00',2.58),('8975','2013-07-24','07:55:00',2.69),('8975','2013-07-24','08:00:00',2.83),('8975','2013-07-24','08:05:00',2.96),('8975','2013-07-24','08:10:00',3.11),('8975','2013-07-24','08:15:00',3.21),('8975','2013-07-24','08:20:00',3.25),('8975','2013-07-24','08:25:00',3.43),('8975','2013-07-24','08:30:00',3.46),('8975','2013-07-24','08:35:00',3.56),('8975','2013-07-24','08:40:00',3.66),('8975','2013-07-24','08:45:00',3.82),('8975','2013-07-24','08:50:00',3.97),('8975','2013-07-24','08:55:00',4.03),('8975','2013-07-24','09:00:00',4.45),('8975','2013-07-24','09:05:00',3.62),('8975','2013-07-24','09:10:00',4.07),('8975','2013-07-24','09:15:00',2.85),('8975','2013-07-24','09:20:00',3.77),('8975','2013-07-24','09:25:00',1.48),('8975','2013-07-24','09:30:00',2.66),('8975','2013-07-24','09:35:00',5.31),('8975','2013-07-24','09:40:00',2.92),('8975','2013-07-24','09:45:00',3.08),('8975','2013-07-24','09:50:00',5.26),('8975','2013-07-24','09:55:00',4.97),('8975','2013-07-24','10:00:00',5.26),('8975','2013-07-24','10:05:00',5.32),('8975','2013-07-24','10:10:00',5.52),('8975','2013-07-24','10:15:00',5.72),('8975','2013-07-24','10:20:00',5.52),('8975','2013-07-24','10:25:00',5.04),('8975','2013-07-24','10:30:00',4.88),('8975','2013-07-24','10:35:00',3.81),('8975','2013-07-24','10:40:00',2.87),('8975','2013-07-24','10:45:00',5.95),('8975','2013-07-24','10:50:00',6.19),('8975','2013-07-24','10:55:00',4.6),('8975','2013-07-24','11:00:00',3),('8975','2013-07-24','11:05:00',4.25),('8975','2013-07-24','11:10:00',2.13),('8975','2013-07-24','11:15:00',5.24),('8975','2013-07-24','11:20:00',6.6),('8975','2013-07-24','11:25:00',3.97),('8975','2013-07-24','11:30:00',1.44),('8975','2013-07-24','11:35:00',5.87),('8975','2013-07-24','11:40:00',6.77),('8975','2013-07-24','11:45:00',6.69),('8975','2013-07-24','11:50:00',6.71),('8975','2013-07-24','11:55:00',6.36),('8975','2013-07-24','12:00:00',3.93),('8975','2013-07-24','12:05:00',2.06),('8975','2013-07-24','12:10:00',2.48),('8975','2013-07-24','12:15:00',6.82),('8975','2013-07-24','12:20:00',6.4),('8975','2013-07-24','12:25:00',5.82),('8975','2013-07-24','12:30:00',4.26),('8975','2013-07-24','12:35:00',7),('8975','2013-07-24','12:40:00',6.73),('8975','2013-07-24','12:45:00',5.57),('8975','2013-07-24','12:50:00',6.73),('8975','2013-07-24','12:55:00',6.38),('8975','2013-07-24','13:00:00',4.85),('8975','2013-07-24','13:05:00',6.52),('8975','2013-07-24','13:10:00',6.23),('8975','2013-07-24','13:15:00',6.37),('8975','2013-07-24','13:20:00',6.4),('8975','2013-07-24','13:25:00',6.37),('8975','2013-07-24','13:30:00',6.27),('8975','2013-07-24','13:35:00',6.25),('8975','2013-07-24','13:40:00',6.25),('8975','2013-07-24','13:45:00',6.02),('8975','2013-07-24','13:50:00',6.02),('8975','2013-07-24','13:55:00',6.09),('8975','2013-07-24','14:00:00',6.09),('8975','2013-07-24','14:05:00',6.1),('8975','2013-07-24','14:10:00',6.09),('8975','2013-07-24','14:15:00',6),('8975','2013-07-24','14:20:00',5.96),('8975','2013-07-24','14:25:00',5.88),('8975','2013-07-24','14:30:00',5.82),('8975','2013-07-24','14:35:00',5.74),('8975','2013-07-24','14:40:00',5.69),('8975','2013-07-24','14:45:00',5.58),('8975','2013-07-24','14:50:00',5.49),('8975','2013-07-24','14:55:00',5.41),('8975','2013-07-24','15:00:00',5.38),('8975','2013-07-24','15:05:00',5.34),('8975','2013-07-24','15:10:00',5.25),('8975','2013-07-24','15:15:00',5.17),('8975','2013-07-24','15:20:00',5.09),('8975','2013-07-24','15:25:00',4.95),('8975','2013-07-24','15:30:00',4.91),('8975','2013-07-24','15:35:00',4.83),('8975','2013-07-24','15:40:00',4.74),('8975','2013-07-24','15:45:00',4.62),('8975','2013-07-24','15:50:00',4.52),('8975','2013-07-24','15:55:00',4.44),('8975','2013-07-24','16:00:00',4.33),('8975','2013-07-24','16:05:00',4.23),('8975','2013-07-24','16:10:00',4.11),('8975','2013-07-24','16:15:00',4.03),('8975','2013-07-24','16:20:00',3.93),('8975','2013-07-24','16:25:00',3.84),('8975','2013-07-24','16:30:00',3.73),('8975','2013-07-24','16:35:00',3.63),('8975','2013-07-24','16:40:00',3.53),('8975','2013-07-24','16:45:00',3.41),('8975','2013-07-24','16:50:00',3.28),('8975','2013-07-24','16:55:00',3.15),('8975','2013-07-24','17:00:00',2.97),('8975','2013-07-24','17:05:00',2.66),('8975','2013-07-24','17:10:00',2.38),('8975','2013-07-24','17:15:00',2.45),('8975','2013-07-24','17:20:00',2.18),('8975','2013-07-24','17:25:00',2.11),('8975','2013-07-24','17:30:00',2.22),('8975','2013-07-24','17:35:00',1.96),('8975','2013-07-24','17:40:00',1.92),('8975','2013-07-24','17:45:00',1.75),('8975','2013-07-24','17:50:00',1.83),('8975','2013-07-24','17:55:00',1.53),('8975','2013-07-24','18:00:00',1.66),('8975','2013-07-24','18:05:00',1.64),('8975','2013-07-24','18:10:00',1.55),('8975','2013-07-24','18:15:00',1.5),('8975','2013-07-24','18:20:00',1.43),('8975','2013-07-24','18:25:00',1.35),('8975','2013-07-24','18:30:00',1.31),('8975','2013-07-24','18:35:00',1.27),('8975','2013-07-24','18:40:00',1.21),('8975','2013-07-24','18:45:00',1.15),('8975','2013-07-24','18:50:00',1.08),('8975','2013-07-24','18:55:00',1.03),('8975','2013-07-23','07:25:00',1.04),('8975','2013-07-23','07:35:00',1.09),('8975','2013-07-23','07:40:00',1.1),('8975','2013-07-23','07:45:00',1.12),('8975','2013-07-23','07:50:00',1.74),('8975','2013-07-23','07:55:00',2.2),('8975','2013-07-23','08:00:00',1.98),('8975','2013-07-23','08:05:00',1.86),('8975','2013-07-23','08:10:00',3.09),('8975','2013-07-23','08:15:00',2.46),('8975','2013-07-23','08:20:00',1.24),('8975','2013-07-23','08:25:00',2.67),('8975','2013-07-23','08:30:00',2.82),('8975','2013-07-23','08:35:00',3.64),('8975','2013-07-23','08:40:00',3.93),('8975','2013-07-23','08:45:00',3.98),('8975','2013-07-23','08:50:00',4.18),('8975','2013-07-23','08:55:00',4.19),('8975','2013-07-23','09:00:00',3.14),('8975','2013-07-23','09:05:00',4.66),('8975','2013-07-23','09:10:00',4.49),('8975','2013-07-23','09:15:00',4.89),('8975','2013-07-23','09:20:00',5.12),('8975','2013-07-23','09:25:00',4.64),('8975','2013-07-23','09:30:00',2.47),('8975','2013-07-23','09:35:00',2.61),('8975','2013-07-23','09:40:00',1.79),('8975','2013-07-23','09:45:00',1.64),('8975','2013-07-23','09:50:00',1.57),('8975','2013-07-23','09:55:00',1.4),('8975','2013-07-23','10:00:00',1.53),('8975','2013-07-23','10:05:00',2.07),('8975','2013-07-23','10:10:00',4.24),('8975','2013-07-23','10:15:00',4.92),('8975','2013-07-23','10:20:00',5.65),('8975','2013-07-23','10:25:00',5.81),('8975','2013-07-23','10:30:00',5.8),('8975','2013-07-23','10:35:00',6.25),('8975','2013-07-23','10:40:00',6.65),('8975','2013-07-23','10:45:00',6.11),('8975','2013-07-23','10:50:00',6.05),('8975','2013-07-23','10:55:00',3.31),('8975','2013-07-23','11:00:00',2.25),('8975','2013-07-23','11:05:00',6.2),('8975','2013-07-23','11:10:00',6.38),('8975','2013-07-23','11:15:00',6.49),('8975','2013-07-23','11:20:00',6.24),('8975','2013-07-23','11:25:00',6.19),('8975','2013-07-23','11:30:00',6.24),('8975','2013-07-23','11:35:00',5.59),('8975','2013-07-23','11:40:00',6.52),('8975','2013-07-23','11:45:00',6.75),('8975','2013-07-23','11:50:00',6.66),('8975','2013-07-23','11:55:00',6.14),('8975','2013-07-23','12:00:00',5.62),('8975','2013-07-23','12:05:00',3.39),('8975','2013-07-23','12:10:00',5.61),('8975','2013-07-23','12:15:00',3.28),('8975','2013-07-23','12:20:00',3.16),('8975','2013-07-23','12:25:00',2.11),('8975','2013-07-23','12:30:00',3.68),('8975','2013-07-23','12:35:00',5.9),('8975','2013-07-23','12:40:00',2.86),('8975','2013-07-23','12:45:00',7.26),('8975','2013-07-23','12:50:00',6.9),('8975','2013-07-23','12:55:00',3.76),('8975','2013-07-23','13:00:00',2.1),('8975','2013-07-23','13:05:00',3.98),('8975','2013-07-23','13:10:00',2.56),('8975','2013-07-23','13:15:00',1.66),('8975','2013-07-23','13:20:00',1.54),('8975','2013-07-23','13:25:00',2.23),('8975','2013-07-23','13:30:00',2.09),('8975','2013-07-23','13:35:00',4.65),('8975','2013-07-23','13:40:00',2.89),('8975','2013-07-23','13:45:00',5.19),('8975','2013-07-23','13:50:00',6.76),('8975','2013-07-23','13:55:00',6.74),('8975','2013-07-23','14:00:00',6.49),('8975','2013-07-23','14:05:00',5.9),('8975','2013-07-23','14:10:00',6.48),('8975','2013-07-23','14:15:00',6.46),('8975','2013-07-23','14:20:00',6.19),('8975','2013-07-23','14:25:00',6.3),('8975','2013-07-23','14:30:00',5.64),('8975','2013-07-23','14:35:00',5.33),('8975','2013-07-23','14:40:00',5.89),('8975','2013-07-23','14:45:00',5.44),('8975','2013-07-23','14:50:00',5.93),('8975','2013-07-23','14:55:00',4.9),('8975','2013-07-23','15:00:00',5.7),('8975','2013-07-23','15:05:00',5.46),('8975','2013-07-23','15:10:00',5.49),('8975','2013-07-23','15:15:00',5.51),('8975','2013-07-23','15:20:00',5.38),('8975','2013-07-23','15:25:00',5.29),('8975','2013-07-23','15:30:00',5.19),('8975','2013-07-23','15:35:00',4.81),('8975','2013-07-23','15:40:00',4.85),('8975','2013-07-23','15:45:00',4.97),('8975','2013-07-23','15:50:00',4.79),('8975','2013-07-23','15:55:00',4.71),('8975','2013-07-23','16:00:00',4.61),('8975','2013-07-23','16:05:00',4.6),('8975','2013-07-23','16:10:00',4.57),('8975','2013-07-23','16:15:00',4.31),('8975','2013-07-23','16:20:00',4.19),('8975','2013-07-23','16:25:00',4.14),('8975','2013-07-23','16:30:00',4.04),('8975','2013-07-23','16:35:00',3.86),('8975','2013-07-23','16:40:00',3.82),('8975','2013-07-23','16:45:00',3.73),('8975','2013-07-23','16:50:00',3.57),('8975','2013-07-23','16:55:00',3.53),('8975','2013-07-23','17:00:00',3.43),('8975','2013-07-23','17:05:00',3.28),('8975','2013-07-23','17:10:00',3.1),('8975','2013-07-23','17:15:00',2.93),('8975','2013-07-23','17:20:00',2.77),('8975','2013-07-23','17:25:00',2.61),('8975','2013-07-23','17:30:00',2.47),('8975','2013-07-23','17:35:00',2.34),('8975','2013-07-23','17:40:00',2.19),('8975','2013-07-23','17:45:00',2.08),('8975','2013-07-23','17:50:00',1.98),('8975','2013-07-23','17:55:00',1.85),('8975','2013-07-23','18:00:00',1.74),('8975','2013-07-23','18:05:00',1.66),('8975','2013-07-23','18:10:00',1.59),('8975','2013-07-23','18:15:00',1.51),('8975','2013-07-23','18:20:00',1.45),('8975','2013-07-23','18:25:00',1.28),('8975','2013-07-23','18:30:00',1.2),('8975','2013-07-23','18:35:00',1.02),('8975','2013-07-23','18:40:00',1.18),('8975','2013-07-23','18:45:00',1.15),('8975','2013-07-23','18:50:00',1.03),('8975','2013-07-22','06:40:00',1.08),('8975','2013-07-22','06:45:00',1.21),('8975','2013-07-22','06:50:00',1.37),('8975','2013-07-22','06:55:00',1.52),('8975','2013-07-22','07:00:00',1.67),('8975','2013-07-22','07:05:00',1.81),('8975','2013-07-22','07:10:00',1.94),('8975','2013-07-22','07:15:00',2.08),('8975','2013-07-22','07:20:00',2.22),('8975','2013-07-22','07:25:00',2.36),('8975','2013-07-22','07:30:00',2.5),('8975','2013-07-22','07:35:00',2.63),('8975','2013-07-22','07:40:00',2.74),('8975','2013-07-22','07:45:00',2.84),('8975','2013-07-22','07:50:00',2.95),('8975','2013-07-22','07:55:00',3.05),('8975','2013-07-22','08:00:00',3.17),('8975','2013-07-22','08:05:00',3.26),('8975','2013-07-22','08:10:00',3.36),('8975','2013-07-22','08:15:00',3.45),('8975','2013-07-22','08:20:00',3.55),('8975','2013-07-22','08:25:00',3.69),('8975','2013-07-22','08:30:00',3.83),('8975','2013-07-22','08:35:00',3.92),('8975','2013-07-22','08:40:00',4.03),('8975','2013-07-22','08:45:00',4.14),('8975','2013-07-22','08:50:00',4.24),('8975','2013-07-22','08:55:00',4.35),('8975','2013-07-22','09:00:00',4.45),('8975','2013-07-22','09:05:00',4.53),('8975','2013-07-22','09:10:00',4.61),('8975','2013-07-22','09:15:00',4.63),('8975','2013-07-22','09:20:00',4.68),('8975','2013-07-22','09:25:00',4.75),('8975','2013-07-22','09:30:00',4.82),('8975','2013-07-22','09:35:00',4.91),('8975','2013-07-22','09:40:00',4.97),('8975','2013-07-22','09:45:00',4.99),('8975','2013-07-22','09:50:00',5.08),('8975','2013-07-22','09:55:00',5.18),('8975','2013-07-22','10:00:00',5.17),('8975','2013-07-22','10:05:00',5.32),('8975','2013-07-22','10:10:00',5.49),('8975','2013-07-22','10:15:00',5.6),('8975','2013-07-22','10:20:00',5.65),('8975','2013-07-22','10:25:00',5.71),('8975','2013-07-22','10:30:00',5.77),('8975','2013-07-22','10:35:00',5.83),('8975','2013-07-22','10:40:00',5.89),('8975','2013-07-22','10:45:00',5.88),('8975','2013-07-22','10:50:00',5.94),('8975','2013-07-22','10:55:00',6.01),('8975','2013-07-22','11:00:00',6.09),('8975','2013-07-22','11:05:00',6.09),('8975','2013-07-22','11:10:00',6.12),('8975','2013-07-22','11:15:00',6.17),('8975','2013-07-22','11:20:00',6.27),('8975','2013-07-22','11:25:00',6.28),('8975','2013-07-22','11:30:00',6.32),('8975','2013-07-22','11:35:00',6.37),('8975','2013-07-22','11:40:00',6.42),('8975','2013-07-22','11:45:00',6.39),('8975','2013-07-22','11:50:00',6.41),('8975','2013-07-22','11:55:00',6.38),('8975','2013-07-22','12:00:00',6.51),('8975','2013-07-22','12:05:00',6.45),('8975','2013-07-22','12:10:00',6.45),('8975','2013-07-22','12:15:00',6.47),('8975','2013-07-22','12:20:00',6.64),('8975','2013-07-22','12:25:00',6.65),('8975','2013-07-22','12:30:00',6.59),('8975','2013-07-22','12:35:00',6.59),('8975','2013-07-22','12:40:00',3.89),('8975','2013-07-22','12:45:00',2.56),('8975','2013-07-22','12:50:00',2.35),('8975','2013-07-22','12:55:00',2.3),('8975','2013-07-22','13:00:00',7.21),('8975','2013-07-22','13:05:00',4.65),('8975','2013-07-22','13:10:00',2.02),('8975','2013-07-22','13:15:00',1.2),('8975','2013-07-22','13:20:00',1.03),('8975','2013-07-22','13:25:00',1.02),('8975','2013-07-22','13:55:00',1.14),('8975','2013-07-22','14:00:00',1.65),('8975','2013-07-22','14:05:00',2.41),('8975','2013-07-22','14:35:00',1.52),('8975','2013-07-22','14:40:00',1.57),('8975','2013-07-22','14:45:00',2.18),('8975','2013-07-22','14:50:00',3.82),('8975','2013-07-22','14:55:00',4.46),('8975','2013-07-22','15:00:00',5.65),('8975','2013-07-22','15:05:00',5.8),('8975','2013-07-22','15:10:00',5.61),('8975','2013-07-22','15:15:00',5.44),('8975','2013-07-22','15:20:00',5.31),('8975','2013-07-22','15:25:00',5.11),('8975','2013-07-22','15:30:00',4.71),('8975','2013-07-22','15:35:00',4.66),('8975','2013-07-22','15:40:00',4.74),('8975','2013-07-22','15:45:00',4.54),('8975','2013-07-22','15:50:00',4.5),('8975','2013-07-22','15:55:00',4.43),('8975','2013-07-22','16:00:00',4.36),('8975','2013-07-22','16:05:00',4.28),('8975','2013-07-22','16:10:00',4.13),('8975','2013-07-22','16:15:00',4.06),('8975','2013-07-22','16:20:00',3.92),('8975','2013-07-22','16:25:00',3.8),('8975','2013-07-22','16:30:00',3.71),('8975','2013-07-22','16:35:00',3.59),('8975','2013-07-22','16:40:00',3.49),('8975','2013-07-22','16:45:00',3.39),('8975','2013-07-22','16:50:00',3.28),('8975','2013-07-22','16:55:00',3.19),('8975','2013-07-22','17:00:00',3.08),('8975','2013-07-22','17:05:00',2.96),('8975','2013-07-22','17:10:00',2.84),('8975','2013-07-22','17:15:00',2.74),('8975','2013-07-22','17:20:00',2.64),('8975','2013-07-22','17:25:00',2.56),('8975','2013-07-22','17:30:00',2.45),('8975','2013-07-22','17:35:00',2.35),('8975','2013-07-22','17:40:00',2.27),('8975','2013-07-22','17:45:00',2.16),('8975','2013-07-22','17:50:00',2.06),('8975','2013-07-22','17:55:00',1.97),('8975','2013-07-22','18:00:00',1.89),('8975','2013-07-22','18:05:00',1.79),('8975','2013-07-22','18:10:00',1.69),('8975','2013-07-22','18:15:00',1.6),('8975','2013-07-22','18:20:00',1.53),('8975','2013-07-22','18:25:00',1.45),('8975','2013-07-22','18:30:00',1.38),('8975','2013-07-22','18:35:00',1.31),('8975','2013-07-22','18:40:00',1.15),('8975','2013-07-21','06:50:00',1.13),('8975','2013-07-21','06:55:00',1.32),('8975','2013-07-21','07:00:00',1.47),('8975','2013-07-21','07:05:00',1.62),('8975','2013-07-21','07:10:00',1.78),('8975','2013-07-21','07:15:00',1.92),('8975','2013-07-21','07:20:00',2.05),('8975','2013-07-21','07:25:00',2.19),('8975','2013-07-21','07:30:00',2.32),('8975','2013-07-21','07:35:00',2.45),('8975','2013-07-21','07:40:00',2.58),('8975','2013-07-21','07:45:00',2.71),('8975','2013-07-21','07:50:00',2.82),('8975','2013-07-21','07:55:00',2.95),('8975','2013-07-21','08:00:00',3.07),('8975','2013-07-21','08:05:00',3.2),('8975','2013-07-21','08:10:00',3.3),('8975','2013-07-21','08:15:00',3.4),('8975','2013-07-21','08:20:00',3.51),('8975','2013-07-21','08:25:00',3.64),('8975','2013-07-21','08:30:00',3.73),('8975','2013-07-21','08:35:00',3.83),('8975','2013-07-21','08:40:00',3.99),('8975','2013-07-21','08:45:00',4.08),('8975','2013-07-21','08:50:00',4.15),('8975','2013-07-21','08:55:00',4.26),('8975','2013-07-21','09:00:00',4.39),('8975','2013-07-21','09:05:00',4.49),('8975','2013-07-21','09:10:00',4.59),('8975','2013-07-21','09:15:00',4.69),('8975','2013-07-21','09:20:00',4.78),('8975','2013-07-21','09:25:00',4.87),('8975','2013-07-21','09:30:00',4.93),('8975','2013-07-21','09:35:00',5.02),('8975','2013-07-21','09:40:00',5.07),('8975','2013-07-21','09:45:00',5.17),('8975','2013-07-21','09:50:00',5.26),('8975','2013-07-21','09:55:00',5.32),('8975','2013-07-21','10:00:00',5.39),('8975','2013-07-21','10:05:00',5.46),('8975','2013-07-21','10:10:00',5.51),('8975','2013-07-21','10:15:00',5.57),('8975','2013-07-21','10:20:00',5.66),('8975','2013-07-21','10:25:00',5.71),('8975','2013-07-21','10:30:00',5.8),('8975','2013-07-21','10:35:00',5.84),('8975','2013-07-21','10:40:00',5.94),('8975','2013-07-21','10:45:00',5.96),('8975','2013-07-21','10:50:00',5.97),('8975','2013-07-21','10:55:00',6.01),('8975','2013-07-21','11:00:00',6.01),('8975','2013-07-21','11:05:00',6.09),('8975','2013-07-21','11:10:00',6.15),('8975','2013-07-21','11:15:00',6.18),('8975','2013-07-21','11:20:00',6.17),('8975','2013-07-21','11:25:00',6.18),('8975','2013-07-21','11:30:00',6.22),('8975','2013-07-21','11:35:00',6.23),('8975','2013-07-21','11:40:00',6.3),('8975','2013-07-21','11:45:00',6.34),('8975','2013-07-21','11:50:00',6.32),('8975','2013-07-21','11:55:00',6.29),('8975','2013-07-21','12:00:00',6.31),('8975','2013-07-21','12:05:00',6.32),('8975','2013-07-21','12:10:00',6.31),('8975','2013-07-21','12:15:00',6.29),('8975','2013-07-21','12:20:00',6.34),('8975','2013-07-21','12:25:00',6.34),('8975','2013-07-21','12:30:00',6.43),('8975','2013-07-21','12:35:00',6.38),('8975','2013-07-21','12:40:00',6.31),('8975','2013-07-21','12:45:00',6.32),('8975','2013-07-21','12:50:00',6.35),('8975','2013-07-21','12:55:00',6.3),('8975','2013-07-21','13:00:00',6.27),('8975','2013-07-21','13:05:00',6.13),('8975','2013-07-21','13:10:00',6.11),('8975','2013-07-21','13:15:00',6.16),('8975','2013-07-21','13:20:00',6.19),('8975','2013-07-21','13:25:00',6.21),('8975','2013-07-21','13:30:00',6.15),('8975','2013-07-21','13:35:00',6.11),('8975','2013-07-21','13:40:00',6.1),('8975','2013-07-21','13:45:00',6.04),('8975','2013-07-21','13:50:00',6.03),('8975','2013-07-21','13:55:00',5.95),('8975','2013-07-21','14:00:00',5.89),('8975','2013-07-21','14:05:00',5.89),('8975','2013-07-21','14:10:00',5.86),('8975','2013-07-21','14:15:00',5.8),('8975','2013-07-21','14:20:00',5.74),('8975','2013-07-21','14:25:00',5.73),('8975','2013-07-21','14:30:00',5.67),('8975','2013-07-21','14:35:00',5.55),('8975','2013-07-21','14:40:00',5.52),('8975','2013-07-21','14:45:00',5.4),('8975','2013-07-21','14:50:00',5.19),('8975','2013-07-21','14:55:00',5.15),('8975','2013-07-21','15:00:00',5.28),('8975','2013-07-21','15:05:00',5.24),('8975','2013-07-21','15:10:00',5.2),('8975','2013-07-21','15:15:00',5.12),('8975','2013-07-21','15:20:00',5.04),('8975','2013-07-21','15:25:00',4.98),('8975','2013-07-21','15:30:00',4.88),('8975','2013-07-21','15:35:00',3.95),('8975','2013-07-21','15:40:00',1.66),('8975','2013-07-21','15:45:00',2.83),('8975','2013-07-21','15:50:00',3.47),('8975','2013-07-21','15:55:00',3.9),('8975','2013-07-21','16:00:00',4.93),('8975','2013-07-21','16:05:00',4.78),('8975','2013-07-21','16:10:00',4.85),('8975','2013-07-21','16:15:00',4.67),('8975','2013-07-21','16:20:00',4.5),('8975','2013-07-21','16:25:00',4.21),('8975','2013-07-21','16:30:00',3.86),('8975','2013-07-21','16:35:00',3.71),('8975','2013-07-21','16:40:00',3.51),('8975','2013-07-21','16:45:00',3.42),('8975','2013-07-21','16:50:00',3.24),('8975','2013-07-21','16:55:00',2.86),('8975','2013-07-21','17:00:00',3.07),('8975','2013-07-21','17:05:00',2.99),('8975','2013-07-21','17:10:00',2.9),('8975','2013-07-21','17:15:00',2.75),('8975','2013-07-21','17:20:00',2.65),('8975','2013-07-21','17:25:00',2.45),('8975','2013-07-21','17:30:00',2.43),('8975','2013-07-21','17:35:00',2.39),('8975','2013-07-21','17:40:00',2.27),('8975','2013-07-21','17:45:00',2.1),('8975','2013-07-21','17:50:00',2.01),('8975','2013-07-21','17:55:00',1.94),('8975','2013-07-21','18:00:00',1.88),('8975','2013-07-21','18:05:00',1.74),('8975','2013-07-21','18:10:00',1.62),('8975','2013-07-21','18:15:00',1.56),('8975','2013-07-21','18:20:00',1.49),('8975','2013-07-21','18:25:00',1.41),('8975','2013-07-21','18:30:00',1.27),('8975','2013-07-21','18:35:00',1.24),('8975','2013-07-21','18:40:00',1.18),('8975','2013-07-21','18:45:00',1.13),('8975','2013-07-21','18:50:00',1.06),('8975','2013-07-20','06:50:00',1.05),('8975','2013-07-20','06:55:00',1.22),('8975','2013-07-20','07:00:00',1.35),('8975','2013-07-20','07:05:00',1.44),('8975','2013-07-20','07:10:00',1.61),('8975','2013-07-20','07:15:00',1.75),('8975','2013-07-20','07:20:00',1.88),('8975','2013-07-20','07:25:00',2.03),('8975','2013-07-20','07:30:00',2.18),('8975','2013-07-20','07:35:00',2.33),('8975','2013-07-20','07:40:00',2.26),('8975','2013-07-20','07:45:00',2.38),('8975','2013-07-20','07:50:00',2.74),('8975','2013-07-20','07:55:00',2.8),('8975','2013-07-20','08:00:00',2.83),('8975','2013-07-20','08:05:00',2.98),('8975','2013-07-20','08:10:00',3.13),('8975','2013-07-20','08:15:00',3.24),('8975','2013-07-20','08:20:00',3.36),('8975','2013-07-20','08:25:00',3.47),('8975','2013-07-20','08:30:00',3.61),('8975','2013-07-20','08:35:00',3.66),('8975','2013-07-20','08:40:00',3.77),('8975','2013-07-20','08:45:00',3.86),('8975','2013-07-20','08:50:00',3.99),('8975','2013-07-20','08:55:00',4.14),('8975','2013-07-20','09:00:00',4.19),('8975','2013-07-20','09:05:00',4.3),('8975','2013-07-20','09:10:00',4.41),('8975','2013-07-20','09:15:00',4.52),('8975','2013-07-20','09:20:00',4.61),('8975','2013-07-20','09:25:00',4.69),('8975','2013-07-20','09:30:00',4.78),('8975','2013-07-20','09:35:00',4.87),('8975','2013-07-20','09:40:00',4.9),('8975','2013-07-20','09:45:00',5),('8975','2013-07-20','09:50:00',5.08),('8975','2013-07-20','09:55:00',5.17),('8975','2013-07-20','10:00:00',5.25),('8975','2013-07-20','10:05:00',5.35),('8975','2013-07-20','10:10:00',5.46),('8975','2013-07-20','10:15:00',5.49),('8975','2013-07-20','10:20:00',5.57),('8975','2013-07-20','10:25:00',5.63),('8975','2013-07-20','10:30:00',5.71),('8975','2013-07-20','10:35:00',5.79),('8975','2013-07-20','10:40:00',5.8),('8975','2013-07-20','10:45:00',5.81),('8975','2013-07-20','10:50:00',5.82),('8975','2013-07-20','10:55:00',5.89),('8975','2013-07-20','11:00:00',5.89),('8975','2013-07-20','11:05:00',5.97),('8975','2013-07-20','11:10:00',6.04),('8975','2013-07-20','11:15:00',6.08),('8975','2013-07-20','11:20:00',6.1),('8975','2013-07-20','11:25:00',6.12),('8975','2013-07-20','11:30:00',5.98),('8975','2013-07-20','11:35:00',6.09),('8975','2013-07-20','11:40:00',6.34),('8975','2013-07-20','11:45:00',6.42),('8975','2013-07-20','11:50:00',6.33),('8975','2013-07-20','11:55:00',6.31),('8975','2013-07-20','12:00:00',6.31),('8975','2013-07-20','12:05:00',6.33),('8975','2013-07-20','12:10:00',6.36),('8975','2013-07-20','12:15:00',6.62),('8975','2013-07-20','12:20:00',6.7),('8975','2013-07-20','12:25:00',6.13),('8975','2013-07-20','12:30:00',6.78),('8975','2013-07-20','12:35:00',6.71),('8975','2013-07-20','12:40:00',7.14),('8975','2013-07-20','12:45:00',5.36),('8975','2013-07-20','12:50:00',4.79),('8975','2013-07-20','12:55:00',7.37),('8975','2013-07-20','13:00:00',3.98),('8975','2013-07-20','13:05:00',7.48),('8975','2013-07-20','13:10:00',7.56),('8975','2013-07-20','13:15:00',7.49),('8975','2013-07-20','13:20:00',7.33),('8975','2013-07-20','13:25:00',5.57),('8975','2013-07-20','13:30:00',6.64),('8975','2013-07-20','13:35:00',6.8),('8975','2013-07-20','13:40:00',6.81),('8975','2013-07-20','13:45:00',6.45),('8975','2013-07-20','13:50:00',4.01),('8975','2013-07-20','13:55:00',1.56),('8975','2013-07-20','14:00:00',1.08),('8975','2013-07-20','14:05:00',1.14),('8975','2013-07-20','14:10:00',1.13),('8975','2013-07-20','14:15:00',1.25),('8975','2013-07-20','14:20:00',2.9),('8975','2013-07-20','14:25:00',2.49),('8975','2013-07-20','14:30:00',1.83),('8975','2013-07-20','14:35:00',1.88),('8975','2013-07-20','14:40:00',2.08),('8975','2013-07-20','14:45:00',2.19),('8975','2013-07-20','14:50:00',2.43),('8975','2013-07-20','14:55:00',2.75),('8975','2013-07-20','15:00:00',2.46),('8975','2013-07-20','15:05:00',2.53),('8975','2013-07-20','15:10:00',2.48),('8975','2013-07-20','15:15:00',3.36),('8975','2013-07-20','15:20:00',3.13),('8975','2013-07-20','15:25:00',3.06),('8975','2013-07-20','15:30:00',2.84),('8975','2013-07-20','15:35:00',2.59),('8975','2013-07-20','15:40:00',3.32),('8975','2013-07-20','15:45:00',3.44),('8975','2013-07-20','15:50:00',2.96),('8975','2013-07-20','15:55:00',2.63),('8975','2013-07-20','16:00:00',2.17),('8975','2013-07-20','16:05:00',1.77),('8975','2013-07-20','16:10:00',1.42),('8975','2013-07-20','16:15:00',1.25),('8975','2013-07-20','16:20:00',1.17),('8975','2013-07-20','16:25:00',1.2),('8975','2013-07-20','16:30:00',1.24),('8975','2013-07-20','16:35:00',1.31),('8975','2013-07-20','16:40:00',1.38),('8975','2013-07-20','16:45:00',1.33),('8975','2013-07-20','16:50:00',1.34),('8975','2013-07-20','16:55:00',1.46),('8975','2013-07-20','17:00:00',1.71),('8975','2013-07-20','17:05:00',1.82),('8975','2013-07-20','17:10:00',1.99),('8975','2013-07-20','17:15:00',1.78),('8975','2013-07-20','17:20:00',1.55),('8975','2013-07-20','17:25:00',1.38),('8975','2013-07-20','17:30:00',1.29),('8975','2013-07-20','17:35:00',1.23),('8975','2013-07-20','17:40:00',1.22),('8975','2013-07-20','17:45:00',1.19),('8975','2013-07-20','17:50:00',1.2),('8975','2013-07-20','17:55:00',1.22),('8975','2013-07-20','18:00:00',1.23),('8975','2013-07-20','18:05:00',1.2),('8975','2013-07-20','18:10:00',1.05),('8975','2014-04-06','07:30:00',1.08),('8975','2014-04-06','07:35:00',1.1),('8975','2014-04-06','07:40:00',1.22),('8975','2014-04-06','07:45:00',1.12),('8975','2014-04-06','07:50:00',1.02),('8975','2014-04-06','08:10:00',1.37),('8975','2014-04-06','08:15:00',1.52),('8975','2014-04-06','08:20:00',1.7),('8975','2014-04-06','08:25:00',2.05),('8975','2014-04-06','08:30:00',2.41),('8975','2014-04-06','08:35:00',2.8),('8975','2014-04-06','08:40:00',3),('8975','2014-04-06','08:45:00',3.08),('8975','2014-04-06','08:50:00',2.85),('8975','2014-04-06','08:55:00',2.65),('8975','2014-04-06','09:00:00',2.24),('8975','2014-04-06','09:05:00',2.09),('8975','2014-04-06','09:10:00',2.34),('8975','2014-04-06','09:15:00',3.42),('8975','2014-04-06','09:20:00',2.25),('8975','2014-04-06','09:25:00',2.1),('8975','2014-04-06','09:30:00',2.02),('8975','2014-04-06','09:35:00',1.94),('8975','2014-04-06','09:40:00',1.95),('8975','2014-04-06','09:45:00',2.04),('8975','2014-04-06','09:50:00',2.18),('8975','2014-04-06','09:55:00',2.25),('8975','2014-04-06','10:00:00',2.3),('8975','2014-04-06','10:05:00',2.3),('8975','2014-04-06','10:10:00',2.4),('8975','2014-04-06','10:15:00',2.21),('8975','2014-04-06','10:20:00',2.15),('8975','2014-04-06','10:25:00',2.2),('8975','2014-04-06','10:30:00',2.28),('8975','2014-04-06','10:35:00',2.36),('8975','2014-04-06','10:40:00',2.51),('8975','2014-04-06','10:45:00',2.51),('8975','2014-04-06','10:50:00',2.61),('8975','2014-04-06','10:55:00',2.75),('8975','2014-04-06','11:00:00',3.17),('8975','2014-04-06','11:05:00',3.02),('8975','2014-04-06','11:10:00',3.46),('8975','2014-04-06','11:15:00',3.56),('8975','2014-04-06','11:20:00',3.55),('8975','2014-04-06','11:25:00',3.25),('8975','2014-04-06','11:30:00',3.15),('8975','2014-04-06','11:35:00',3.09),('8975','2014-04-06','11:40:00',3.34),('8975','2014-04-06','11:45:00',3.09),('8975','2014-04-06','11:50:00',2.82),('8975','2014-04-06','11:55:00',2.69),('8975','2014-04-06','12:00:00',2.69),('8975','2014-04-06','12:05:00',3.1),('8975','2014-04-06','12:10:00',3.7),('8975','2014-04-06','12:15:00',4.63),('8975','2014-04-06','12:20:00',5.96),('8975','2014-04-06','12:25:00',6.09),('8975','2014-04-06','12:30:00',3.85),('8975','2014-04-06','12:35:00',3.4),('8975','2014-04-06','12:40:00',3.33),('8975','2014-04-06','12:45:00',5.64),('8975','2014-04-06','12:50:00',6.08),('8975','2014-04-06','12:55:00',5.93),('8975','2014-04-06','13:00:00',5.9),('8975','2014-04-06','13:05:00',5.85),('8975','2014-04-06','13:10:00',5.82),('8975','2014-04-06','13:15:00',5.73),('8975','2014-04-06','13:20:00',5.68),('8975','2014-04-06','13:25:00',5.71),('8975','2014-04-06','13:30:00',5.63),('8975','2014-04-06','13:35:00',5.56),('8975','2014-04-06','13:40:00',5.49),('8975','2014-04-06','13:45:00',5.52),('8975','2014-04-06','13:50:00',5.52),('8975','2014-04-06','13:55:00',5.47),('8975','2014-04-06','14:00:00',5.52),('8975','2014-04-06','14:05:00',5.46),('8975','2014-04-06','14:10:00',5.44),('8975','2014-04-06','14:15:00',5.35),('8975','2014-04-06','14:20:00',5.28),('8975','2014-04-06','14:25:00',5.27),('8975','2014-04-06','14:30:00',5.33),('8975','2014-04-06','14:35:00',5.19),('8975','2014-04-06','14:40:00',5.06),('8975','2014-04-06','14:45:00',4.99),('8975','2014-04-06','14:50:00',4.96),('8975','2014-04-06','14:55:00',4.96),('8975','2014-04-06','15:00:00',5.12),('8975','2014-04-06','15:05:00',5.02),('8975','2014-04-06','15:10:00',4.79),('8975','2014-04-06','15:15:00',4.85),('8975','2014-04-06','15:20:00',4.86),('8975','2014-04-06','15:25:00',4.73),('8975','2014-04-06','15:30:00',4.43),('8975','2014-04-06','15:35:00',4.39),('8975','2014-04-06','15:40:00',4.27),('8975','2014-04-06','15:45:00',4.09),('8975','2014-04-06','15:50:00',4.25),('8975','2014-04-06','15:55:00',3.96),('8975','2014-04-06','16:00:00',3.42),('8975','2014-04-06','16:05:00',2.13),('8975','2014-04-06','16:10:00',2.88),('8975','2014-04-06','16:15:00',3.56),('8975','2014-04-06','16:20:00',3.19),('8975','2014-04-06','16:25:00',2.88),('8975','2014-04-06','16:30:00',2.66),('8975','2014-04-06','16:35:00',2.64),('8975','2014-04-06','16:40:00',2.19),('8975','2014-04-06','16:45:00',1.62),('8975','2014-04-06','16:50:00',2.32),('8975','2014-04-06','16:55:00',2.26),('8975','2014-04-06','17:00:00',2.57),('8975','2014-04-06','17:05:00',2.55),('8975','2014-04-06','17:10:00',2.36),('8975','2014-04-06','17:15:00',2.1),('8975','2014-04-06','17:20:00',1.97),('8975','2014-04-06','17:25:00',1.66),('8975','2014-04-06','17:30:00',1.32),('8975','2014-04-06','17:35:00',1.03),('8975','2014-04-06','17:50:00',1.04),('8975','2014-04-06','17:55:00',1.33),('8975','2014-04-06','18:00:00',1.29),('8975','2014-04-06','18:05:00',1.2),('8975','2014-04-06','18:10:00',1.13),('8975','2014-04-06','18:15:00',1.1),('8975','2014-04-06','18:20:00',1.07),('8975','2013-07-19','06:40:00',1.02),('8975','2013-07-19','06:45:00',1.22),('8975','2013-07-19','06:50:00',1.4),('8975','2013-07-19','06:55:00',1.57),('8975','2013-07-19','07:00:00',1.47),('8975','2013-07-19','07:05:00',1.69),('8975','2013-07-19','07:10:00',1.69),('8975','2013-07-19','07:15:00',2.09),('8975','2013-07-19','07:20:00',1.51),('8975','2013-07-19','07:25:00',2.03),('8975','2013-07-19','07:30:00',2.5),('8975','2013-07-19','07:35:00',2.63),('8975','2013-07-19','07:40:00',2.71),('8975','2013-07-19','07:45:00',2.83),('8975','2013-07-19','07:50:00',2.94),('8975','2013-07-19','07:55:00',3.07),('8975','2013-07-19','08:00:00',3.16),('8975','2013-07-19','08:05:00',3.26),('8975','2013-07-19','08:10:00',3.37),('8975','2013-07-19','08:15:00',3.47),('8975','2013-07-19','08:20:00',3.59),('8975','2013-07-19','08:25:00',3.69),('8975','2013-07-19','08:30:00',3.81),('8975','2013-07-19','08:35:00',3.94),('8975','2013-07-19','08:40:00',4.05),('8975','2013-07-19','08:45:00',4.12),('8975','2013-07-19','08:50:00',4.22),('8975','2013-07-19','08:55:00',4.38),('8975','2013-07-19','09:00:00',4.43),('8975','2013-07-19','09:05:00',4.64),('8975','2013-07-19','09:10:00',4.78),('8975','2013-07-19','09:15:00',4.91),('8975','2013-07-19','09:20:00',4.86),('8975','2013-07-19','09:25:00',4.76),('8975','2013-07-19','09:30:00',4.51),('8975','2013-07-19','09:35:00',4.58),('8975','2013-07-19','09:40:00',4.9),('8975','2013-07-19','09:45:00',5.15),('8975','2013-07-19','09:50:00',5.07),('8975','2013-07-19','09:55:00',4.36),('8975','2013-07-19','10:00:00',5.09),('8975','2013-07-19','10:05:00',5.42),('8975','2013-07-19','10:10:00',5.5),('8975','2013-07-19','10:15:00',5.53),('8975','2013-07-19','10:20:00',5.6),('8975','2013-07-19','10:25:00',5.65),('8975','2013-07-19','10:30:00',5.73),('8975','2013-07-19','10:35:00',5.79),('8975','2013-07-19','10:40:00',5.8),('8975','2013-07-19','10:45:00',5.85),('8975','2013-07-19','10:50:00',5.96),('8975','2013-07-19','10:55:00',6.04),('8975','2013-07-19','11:00:00',6.08),('8975','2013-07-19','11:05:00',6.07),('8975','2013-07-19','11:10:00',6.04),('8975','2013-07-19','11:15:00',6.01),('8975','2013-07-19','11:20:00',6.15),('8975','2013-07-19','11:25:00',6.28),('8975','2013-07-19','11:30:00',5.97),('8975','2013-07-19','11:35:00',5.95),('8975','2013-07-19','11:40:00',6.09),('8975','2013-07-19','11:45:00',5.89),('8975','2013-07-19','11:50:00',5.27),('8975','2013-07-19','11:55:00',3.98),('8975','2013-07-19','12:00:00',6.18),('8975','2013-07-19','12:05:00',6.44),('8975','2013-07-19','12:10:00',5.88),('8975','2013-07-19','12:15:00',5.65),('8975','2013-07-19','12:20:00',4.8),('8975','2013-07-19','12:25:00',4.9),('8975','2013-07-19','12:30:00',6.47),('8975','2013-07-19','12:35:00',6.53),('8975','2013-07-19','12:40:00',6.66),('8975','2013-07-19','12:45:00',6.63),('8975','2013-07-19','12:50:00',6.48),('8975','2013-07-19','12:55:00',6.34),('8975','2013-07-19','13:00:00',3.08),('8975','2013-07-19','13:05:00',1.62),('8975','2013-07-19','13:10:00',1.92),('8975','2013-07-19','13:15:00',5.64),('8975','2013-07-19','13:20:00',7.14),('8975','2013-07-19','13:25:00',3.28),('8975','2013-07-19','13:30:00',1.79),('8975','2013-07-19','13:35:00',1.65),('8975','2013-07-19','13:40:00',4.87),('8975','2013-07-19','13:45:00',6.85),('8975','2013-07-19','13:50:00',6.92),('8975','2013-07-19','13:55:00',6.61),('8975','2013-07-19','14:00:00',6.62),('8975','2013-07-19','14:05:00',6.31),('8975','2013-07-19','14:10:00',6.21),('8975','2013-07-19','14:15:00',6.23),('8975','2013-07-19','14:20:00',6.15),('8975','2013-07-19','14:25:00',6.04),('8975','2013-07-19','14:30:00',5.88),('8975','2013-07-19','14:35:00',5.85),('8975','2013-07-19','14:40:00',5.81),('8975','2013-07-19','14:45:00',5.84),('8975','2013-07-19','14:50:00',5.85),('8975','2013-07-19','14:55:00',5.84),('8975','2013-07-19','15:00:00',5.58),('8975','2013-07-19','15:05:00',5.48),('8975','2013-07-19','15:10:00',5.38),('8975','2013-07-19','15:15:00',5.27),('8975','2013-07-19','15:20:00',5.18),('8975','2013-07-19','15:25:00',4.9),('8975','2013-07-19','15:30:00',4.91),('8975','2013-07-19','15:35:00',4.84),('8975','2013-07-19','15:40:00',4.8),('8975','2013-07-19','15:45:00',4.7),('8975','2013-07-19','15:50:00',4.62),('8975','2013-07-19','15:55:00',4.54),('8975','2013-07-19','16:00:00',4.43),('8975','2013-07-19','16:05:00',4.32),('8975','2013-07-19','16:10:00',4.2),('8975','2013-07-19','16:15:00',4.12),('8975','2013-07-19','16:20:00',4.04),('8975','2013-07-19','16:25:00',3.89),('8975','2013-07-19','16:30:00',3.77),('8975','2013-07-19','16:35:00',3.69),('8975','2013-07-19','16:40:00',3.54),('8975','2013-07-19','16:45:00',3.42),('8975','2013-07-19','16:50:00',3.32),('8975','2013-07-19','16:55:00',3.2),('8975','2013-07-19','17:00:00',3.1),('8975','2013-07-19','17:05:00',2.97),('8975','2013-07-19','17:10:00',2.83),('8975','2013-07-19','17:15:00',2.73),('8975','2013-07-19','17:20:00',2.61),('8975','2013-07-19','17:25:00',2.49),('8975','2013-07-19','17:30:00',2.38),('8975','2013-07-19','17:35:00',2.29),('8975','2013-07-19','17:40:00',2.19),('8975','2013-07-19','17:45:00',2.09),('8975','2013-07-19','17:50:00',1.98),('8975','2013-07-19','17:55:00',1.91),('8975','2013-07-19','18:00:00',1.82),('8975','2013-07-19','18:05:00',1.74),('8975','2013-07-19','18:10:00',1.66),('8975','2013-07-19','18:15:00',1.58),('8975','2013-07-19','18:20:00',1.51),('8975','2013-07-19','18:25:00',1.44),('8975','2013-07-19','18:30:00',1.38),('8975','2013-07-19','18:35:00',1.31),('8975','2013-07-19','18:40:00',1.26),('8975','2013-07-19','18:45:00',1.19),('8975','2013-07-19','18:50:00',1.11),('8975','2013-07-19','18:55:00',1.07),('8975','2013-07-19','19:00:00',1.03),('8975','2013-07-18','06:45:00',1),('8975','2013-07-18','06:50:00',1.16),('8975','2013-07-18','06:55:00',1.29),('8975','2013-07-18','07:00:00',1.41),('8975','2013-07-18','07:05:00',1.55),('8975','2013-07-18','07:10:00',1.74),('8975','2013-07-18','07:15:00',1.86),('8975','2013-07-18','07:20:00',1.98),('8975','2013-07-18','07:25:00',2.11),('8975','2013-07-18','07:30:00',2.25),('8975','2013-07-18','07:35:00',2.38),('8975','2013-07-18','07:40:00',2.5),('8975','2013-07-18','07:45:00',2.61),('8975','2013-07-18','07:50:00',2.74),('8975','2013-07-18','07:55:00',2.84),('8975','2013-07-18','08:00:00',2.96),('8975','2013-07-18','08:05:00',3.05),('8975','2013-07-18','08:10:00',3.18),('8975','2013-07-18','08:15:00',3.29),('8975','2013-07-18','08:20:00',3.41),('8975','2013-07-18','08:25:00',3.49),('8975','2013-07-18','08:30:00',3.59),('8975','2013-07-18','08:35:00',3.74),('8975','2013-07-18','08:40:00',3.86),('8975','2013-07-18','08:45:00',3.96),('8975','2013-07-18','08:50:00',4.1),('8975','2013-07-18','08:55:00',4.17),('8975','2013-07-18','09:00:00',4.22),('8975','2013-07-18','09:05:00',4.34),('8975','2013-07-18','09:10:00',4.43),('8975','2013-07-18','09:15:00',4.5),('8975','2013-07-18','09:20:00',4.6),('8975','2013-07-18','09:25:00',4.67),('8975','2013-07-18','09:30:00',4.75),('8975','2013-07-18','09:35:00',4.81),('8975','2013-07-18','09:40:00',4.87),('8975','2013-07-18','09:45:00',4.95),('8975','2013-07-18','09:50:00',4.99),('8975','2013-07-18','09:55:00',5.04),('8975','2013-07-18','10:00:00',5.11),('8975','2013-07-18','10:05:00',5.17),('8975','2013-07-18','10:10:00',5.23),('8975','2013-07-18','10:15:00',5.32),('8975','2013-07-18','10:20:00',5.3),('8975','2013-07-18','10:25:00',5.34),('8975','2013-07-18','10:30:00',5.5),('8975','2013-07-18','10:35:00',5.6),('8975','2013-07-18','10:40:00',5.61),('8975','2013-07-18','10:45:00',5.62),('8975','2013-07-18','10:50:00',5.67),('8975','2013-07-18','10:55:00',5.65),('8975','2013-07-18','11:00:00',5.74),('8975','2013-07-18','11:05:00',5.86),('8975','2013-07-18','11:10:00',5.91),('8975','2013-07-18','11:15:00',5.98),('8975','2013-07-18','11:20:00',6.07),('8975','2013-07-18','11:25:00',6.07),('8975','2013-07-18','11:30:00',6.12),('8975','2013-07-18','11:35:00',6.08),('8975','2013-07-18','11:40:00',5.97),('8975','2013-07-18','11:45:00',6.06),('8975','2013-07-18','11:50:00',6.22),('8975','2013-07-18','11:55:00',6.35),('8975','2013-07-18','12:00:00',6.38),('8975','2013-07-18','12:05:00',6.14),('8975','2013-07-18','12:10:00',3.07),('8975','2013-07-18','12:15:00',5.07),('8975','2013-07-18','12:20:00',6.56),('8975','2013-07-18','12:25:00',5.63),('8975','2013-07-18','12:30:00',6.47),('8975','2013-07-18','12:35:00',6.67),('8975','2013-07-18','12:40:00',6.62),('8975','2013-07-18','12:45:00',2.46),('8975','2013-07-18','12:50:00',4.23),('8975','2013-07-18','12:55:00',3.69),('8975','2013-07-18','13:00:00',4.64),('8975','2013-07-18','13:05:00',6.88),('8975','2013-07-18','13:10:00',6.91),('8975','2013-07-18','13:15:00',6.72),('8975','2013-07-18','13:20:00',2.85),('8975','2013-07-18','13:25:00',4.92),('8975','2013-07-18','13:30:00',6.83),('8975','2013-07-18','13:35:00',6.5),('8975','2013-07-18','13:40:00',5.87),('8975','2013-07-18','13:45:00',5.51),('8975','2013-07-18','13:50:00',6.07),('8975','2013-07-18','13:55:00',6.39),('8975','2013-07-18','14:00:00',6.36),('8975','2013-07-18','14:05:00',6.2),('8975','2013-07-18','14:10:00',6.27),('8975','2013-07-18','14:15:00',6.4),('8975','2013-07-18','14:20:00',5.82),('8975','2013-07-18','14:25:00',4.06),('8975','2013-07-18','14:30:00',5.92),('8975','2013-07-18','14:35:00',6.26),('8975','2013-07-18','14:40:00',4.67),('8975','2013-07-18','14:45:00',5.55),('8975','2013-07-18','14:50:00',5.12),('8975','2013-07-18','14:55:00',5.36),('8975','2013-07-18','15:00:00',4.81),('8975','2013-07-18','15:05:00',5.57),('8975','2013-07-18','15:10:00',4.07),('8975','2013-07-18','15:15:00',4.3),('8975','2013-07-18','15:20:00',5.26),('8975','2013-07-18','15:25:00',5.42),('8975','2013-07-18','15:30:00',5.35),('8975','2013-07-18','15:35:00',5.26),('8975','2013-07-18','15:40:00',5.24),('8975','2013-07-18','15:45:00',5.09),('8975','2013-07-18','15:50:00',4.93),('8975','2013-07-18','15:55:00',4.75),('8975','2013-07-18','16:00:00',4.68),('8975','2013-07-18','16:05:00',4.63),('8975','2013-07-18','16:10:00',4.54),('8975','2013-07-18','16:15:00',4.45),('8975','2013-07-18','16:20:00',4.23),('8975','2013-07-18','16:25:00',4.26),('8975','2013-07-18','16:30:00',4.23),('8975','2013-07-18','16:35:00',4.11),('8975','2013-07-18','16:40:00',3.99),('8975','2013-07-18','16:45:00',3.93),('8975','2013-07-18','16:50:00',3.81),('8975','2013-07-18','16:55:00',3.76),('8975','2013-07-18','17:00:00',3.64),('8975','2013-07-18','17:05:00',3.55),('8975','2013-07-18','17:10:00',3.41),('8975','2013-07-18','17:15:00',3.27),('8975','2013-07-18','17:20:00',3.07),('8975','2013-07-18','17:25:00',2.36),('8975','2013-07-18','17:30:00',2.65),('8975','2013-07-18','17:35:00',2.77),('8975','2013-07-18','17:40:00',2.4),('8975','2013-07-18','17:45:00',2.05),('8975','2013-07-18','17:50:00',1.47),('8975','2013-07-18','17:55:00',1.32),('8975','2013-07-18','18:00:00',1.17),('8975','2013-07-17','06:40:00',1.08),('8975','2013-07-17','06:45:00',1.23),('8975','2013-07-17','06:50:00',1.37),('8975','2013-07-17','06:55:00',1.54),('8975','2013-07-17','07:00:00',1.67),('8975','2013-07-17','07:05:00',1.81),('8975','2013-07-17','07:10:00',1.95),('8975','2013-07-17','07:15:00',2.09),('8975','2013-07-17','07:20:00',2.23),('8975','2013-07-17','07:25:00',2.42),('8975','2013-07-17','07:30:00',2.56),('8975','2013-07-17','07:35:00',2.7),('8975','2013-07-17','07:40:00',2.8),('8975','2013-07-17','07:45:00',2.95),('8975','2013-07-17','07:50:00',3.07),('8975','2013-07-17','07:55:00',3.16),('8975','2013-07-17','08:00:00',3.22),('8975','2013-07-17','08:05:00',3.34),('8975','2013-07-17','08:10:00',3.44),('8975','2013-07-17','08:15:00',3.54),('8975','2013-07-17','08:20:00',3.65),('8975','2013-07-17','08:25:00',3.75),('8975','2013-07-17','08:30:00',3.86),('8975','2013-07-17','08:35:00',3.96),('8975','2013-07-17','08:40:00',4.07),('8975','2013-07-17','08:45:00',4.17),('8975','2013-07-17','08:50:00',4.28),('8975','2013-07-17','08:55:00',4.4),('8975','2013-07-17','09:00:00',4.47),('8975','2013-07-17','09:05:00',4.57),('8975','2013-07-17','09:10:00',4.65),('8975','2013-07-17','09:15:00',4.74),('8975','2013-07-17','09:20:00',4.83),('8975','2013-07-17','09:25:00',4.9),('8975','2013-07-17','09:30:00',4.96),('8975','2013-07-17','09:35:00',5.08),('8975','2013-07-17','09:40:00',5.14),('8975','2013-07-17','09:45:00',5.19),('8975','2013-07-17','09:50:00',5.27),('8975','2013-07-17','09:55:00',5.33),('8975','2013-07-17','10:00:00',5.42),('8975','2013-07-17','10:05:00',5.49),('8975','2013-07-17','10:10:00',5.54),('8975','2013-07-17','10:15:00',5.55),('8975','2013-07-17','10:20:00',5.6),('8975','2013-07-17','10:25:00',5.77),('8975','2013-07-17','10:30:00',5.8),('8975','2013-07-17','10:35:00',5.83),('8975','2013-07-17','10:40:00',5.84),('8975','2013-07-17','10:45:00',5.61),('8975','2013-07-17','10:50:00',5.96),('8975','2013-07-17','10:55:00',6.02),('8975','2013-07-17','11:00:00',6.08),('8975','2013-07-17','11:05:00',6.13),('8975','2013-07-17','11:10:00',6.16),('8975','2013-07-17','11:15:00',6.21),('8975','2013-07-17','11:20:00',6.24),('8975','2013-07-17','11:25:00',6.29),('8975','2013-07-17','11:30:00',6.24),('8975','2013-07-17','11:35:00',6.3),('8975','2013-07-17','11:40:00',6.32),('8975','2013-07-17','11:45:00',6.33),('8975','2013-07-17','11:50:00',6.37),('8975','2013-07-17','11:55:00',6.4),('8975','2013-07-17','12:00:00',6.36),('8975','2013-07-17','12:05:00',6.38),('8975','2013-07-17','12:10:00',6.35),('8975','2013-07-17','12:15:00',6.42),('8975','2013-07-17','12:20:00',6.5),('8975','2013-07-17','12:25:00',6.48),('8975','2013-07-17','12:30:00',6.54),('8975','2013-07-17','12:35:00',6.5),('8975','2013-07-17','12:40:00',6.77),('8975','2013-07-17','12:45:00',6.78),('8975','2013-07-17','12:50:00',6.67),('8975','2013-07-17','12:55:00',6.47),('8975','2013-07-17','13:00:00',5.58),('8975','2013-07-17','13:05:00',1.5),('8975','2013-07-17','13:10:00',2.86),('8975','2013-07-17','13:15:00',6.6),('8975','2013-07-17','13:20:00',6.58),('8975','2013-07-17','13:25:00',6.87),('8975','2013-07-17','13:30:00',6.76),('8975','2013-07-17','13:35:00',6.75),('8975','2013-07-17','13:40:00',5.55),('8975','2013-07-17','13:45:00',6.14),('8975','2013-07-17','13:50:00',6.23),('8975','2013-07-17','13:55:00',6.11),('8975','2013-07-17','14:00:00',6.21),('8975','2013-07-17','14:05:00',6.15),('8975','2013-07-17','14:10:00',6.07),('8975','2013-07-17','14:15:00',6.01),('8975','2013-07-17','14:20:00',5.95),('8975','2013-07-17','14:25:00',5.98),('8975','2013-07-17','14:30:00',5.93),('8975','2013-07-17','14:35:00',5.85),('8975','2013-07-17','14:40:00',5.76),('8975','2013-07-17','14:45:00',5.74),('8975','2013-07-17','14:50:00',5.67),('8975','2013-07-17','14:55:00',5.53),('8975','2013-07-17','15:00:00',5.43),('8975','2013-07-17','15:05:00',5.38),('8975','2013-07-17','15:10:00',5.32),('8975','2013-07-17','15:15:00',5.24),('8975','2013-07-17','15:20:00',5.13),('8975','2013-07-17','15:25:00',5.07),('8975','2013-07-17','15:30:00',4.99),('8975','2013-07-17','15:35:00',4.87),('8975','2013-07-17','15:40:00',4.8),('8975','2013-07-17','15:45:00',4.68),('8975','2013-07-17','15:50:00',4.59),('8975','2013-07-17','15:55:00',4.47),('8975','2013-07-17','16:00:00',4.37),('8975','2013-07-17','16:05:00',4.28),('8975','2013-07-17','16:10:00',4.17),('8975','2013-07-17','16:15:00',4.07),('8975','2013-07-17','16:20:00',3.95),('8975','2013-07-17','16:25:00',3.86),('8975','2013-07-17','16:30:00',3.75),('8975','2013-07-17','16:35:00',3.63),('8975','2013-07-17','16:40:00',3.54),('8975','2013-07-17','16:45:00',3.43),('8975','2013-07-17','16:50:00',3.32),('8975','2013-07-17','16:55:00',3.19),('8975','2013-07-17','17:00:00',3.07),('8975','2013-07-17','17:05:00',2.97),('8975','2013-07-17','17:10:00',2.84),('8975','2013-07-17','17:15:00',2.72),('8975','2013-07-17','17:20:00',2.61),('8975','2013-07-17','17:25:00',2.49),('8975','2013-07-17','17:30:00',2.39),('8975','2013-07-17','17:35:00',2.26),('8975','2013-07-17','17:40:00',2.13),('8975','2013-07-17','17:45:00',2.02),('8975','2013-07-17','17:50:00',1.92),('8975','2013-07-17','17:55:00',1.76),('8975','2013-07-17','18:00:00',1.7),('8975','2013-07-17','18:05:00',1.53),('8975','2013-07-17','18:10:00',1.47),('8975','2013-07-17','18:15:00',1.48),('8975','2013-07-17','18:20:00',1.3),('8975','2013-07-17','18:25:00',1.28),('8975','2013-07-17','18:30:00',1.09),('8975','2013-07-16','06:40:00',1.03),('8975','2013-07-16','06:45:00',1.25),('8975','2013-07-16','06:50:00',1.44),('8975','2013-07-16','06:55:00',1.6),('8975','2013-07-16','07:00:00',1.77),('8975','2013-07-16','07:05:00',1.9),('8975','2013-07-16','07:10:00',2.11),('8975','2013-07-16','07:15:00',2.25),('8975','2013-07-16','07:20:00',2.35),('8975','2013-07-16','07:25:00',2.44),('8975','2013-07-16','07:30:00',2.61),('8975','2013-07-16','07:35:00',2.75),('8975','2013-07-16','07:40:00',2.91),('8975','2013-07-16','07:45:00',3.03),('8975','2013-07-16','07:50:00',3.18),('8975','2013-07-16','07:55:00',3.3),('8975','2013-07-16','08:00:00',3.4),('8975','2013-07-16','08:05:00',3.53),('8975','2013-07-16','08:10:00',3.64),('8975','2013-07-16','08:15:00',3.78),('8975','2013-07-16','08:20:00',3.88),('8975','2013-07-16','08:25:00',3.96),('8975','2013-07-16','08:30:00',4.06),('8975','2013-07-16','08:35:00',4.2),('8975','2013-07-16','08:40:00',4.29),('8975','2013-07-16','08:45:00',4.42),('8975','2013-07-16','08:50:00',4.54),('8975','2013-07-16','08:55:00',4.69),('8975','2013-07-16','09:00:00',4.77),('8975','2013-07-16','09:05:00',4.86),('8975','2013-07-16','09:10:00',4.95),('8975','2013-07-16','09:15:00',5.05),('8975','2013-07-16','09:20:00',5.14),('8975','2013-07-16','09:25:00',5.26),('8975','2013-07-16','09:30:00',5.34),('8975','2013-07-16','09:35:00',5.45),('8975','2013-07-16','09:40:00',5.52),('8975','2013-07-16','09:45:00',5.54),('8975','2013-07-16','09:50:00',5.6),('8975','2013-07-16','09:55:00',5.7),('8975','2013-07-16','10:00:00',5.77),('8975','2013-07-16','10:05:00',5.8),('8975','2013-07-16','10:10:00',5.86),('8975','2013-07-16','10:15:00',5.9),('8975','2013-07-16','10:20:00',5.95),('8975','2013-07-16','10:25:00',6),('8975','2013-07-16','10:30:00',6.07),('8975','2013-07-16','10:35:00',6.11),('8975','2013-07-16','10:40:00',6.12),('8975','2013-07-16','10:45:00',6.18),('8975','2013-07-16','10:50:00',6.25),('8975','2013-07-16','10:55:00',6.29),('8975','2013-07-16','11:00:00',6.32),('8975','2013-07-16','11:05:00',6.37),('8975','2013-07-16','11:10:00',6.46),('8975','2013-07-16','11:15:00',6.47),('8975','2013-07-16','11:20:00',6.51),('8975','2013-07-16','11:25:00',6.59),('8975','2013-07-16','11:30:00',6.64),('8975','2013-07-16','11:35:00',6.66),('8975','2013-07-16','11:40:00',6.67),('8975','2013-07-16','11:45:00',6.67),('8975','2013-07-16','11:50:00',6.63),('8975','2013-07-16','11:55:00',6.66),('8975','2013-07-16','12:00:00',6.65),('8975','2013-07-16','12:05:00',6.66),('8975','2013-07-16','12:10:00',6.64),('8975','2013-07-16','12:15:00',6.67),('8975','2013-07-16','12:20:00',6.65),('8975','2013-07-16','12:25:00',6.64),('8975','2013-07-16','12:30:00',6.72),('8975','2013-07-16','12:35:00',6.67),('8975','2013-07-16','12:40:00',6.61),('8975','2013-07-16','12:45:00',6.61),('8975','2013-07-16','12:50:00',6.63),('8975','2013-07-16','12:55:00',6.64),('8975','2013-07-16','13:00:00',6.57),('8975','2013-07-16','13:05:00',6.49),('8975','2013-07-16','13:10:00',6.52),('8975','2013-07-16','13:15:00',6.45),('8975','2013-07-16','13:20:00',6.38),('8975','2013-07-16','13:25:00',6.38),('8975','2013-07-16','13:30:00',6.36),('8975','2013-07-16','13:35:00',6.32),('8975','2013-07-16','13:40:00',6.23),('8975','2013-07-16','13:45:00',6.22),('8975','2013-07-16','13:50:00',6.24),('8975','2013-07-16','13:55:00',6.2),('8975','2013-07-16','14:00:00',6.14),('8975','2013-07-16','14:05:00',6.08),('8975','2013-07-16','14:10:00',6.03),('8975','2013-07-16','14:15:00',6.02),('8975','2013-07-16','14:20:00',5.86),('8975','2013-07-16','14:25:00',5.87),('8975','2013-07-16','14:30:00',5.85),('8975','2013-07-16','14:35:00',5.83),('8975','2013-07-16','14:40:00',5.82),('8975','2013-07-16','14:45:00',5.64),('8975','2013-07-16','14:50:00',5.6),('8975','2013-07-16','14:55:00',5.58),('8975','2013-07-16','15:00:00',5.54),('8975','2013-07-16','15:05:00',5.36),('8975','2013-07-16','15:10:00',5.31),('8975','2013-07-16','15:15:00',5.23),('8975','2013-07-16','15:20:00',5.11),('8975','2013-07-16','15:25:00',5.13),('8975','2013-07-16','15:30:00',5.05),('8975','2013-07-16','15:35:00',5),('8975','2013-07-16','15:40:00',3.65),('8975','2013-07-16','15:45:00',4.77),('8975','2013-07-16','15:50:00',4.73),('8975','2013-07-16','15:55:00',3.13),('8975','2013-07-16','16:00:00',3.74),('8975','2013-07-16','16:05:00',4.4),('8975','2013-07-16','16:10:00',4.36),('8975','2013-07-16','16:15:00',3.41),('8975','2013-07-16','16:20:00',4.04),('8975','2013-07-16','16:25:00',3.89),('8975','2013-07-16','16:30:00',3.84),('8975','2013-07-16','16:35:00',3.93),('8975','2013-07-16','16:40:00',2.69),('8975','2013-07-16','16:45:00',3.55),('8975','2013-07-16','16:50:00',3.54),('8975','2013-07-16','16:55:00',3.11),('8975','2013-07-16','17:00:00',3.01),('8975','2013-07-16','17:05:00',3.15),('8975','2013-07-16','17:10:00',3.02),('8975','2013-07-16','17:15:00',2.91),('8975','2013-07-16','17:20:00',2.71),('8975','2013-07-16','17:25:00',2.54),('8975','2013-07-16','17:30:00',2.43),('8975','2013-07-16','17:35:00',2.34),('8975','2013-07-16','17:40:00',2.25),('8975','2013-07-16','17:45:00',2.13),('8975','2013-07-16','17:50:00',2.06),('8975','2013-07-16','17:55:00',1.94),('8975','2013-07-16','18:00:00',1.84),('8975','2013-07-16','18:05:00',1.76),('8975','2013-07-16','18:10:00',1.67),('8975','2013-07-16','18:15:00',1.58),('8975','2013-07-16','18:20:00',1.51),('8975','2013-07-16','18:25:00',1.44),('8975','2013-07-16','18:30:00',1.36),('8975','2013-07-16','18:35:00',1.3),('8975','2013-07-16','18:40:00',1.24),('8975','2013-07-16','18:45:00',1.17),('8975','2013-07-16','18:50:00',1.13),('8975','2013-07-16','18:55:00',1.07),('8975','2013-07-16','19:00:00',1.02),('8975','2013-07-15','06:35:00',1),('8975','2013-07-15','06:40:00',1.16),('8975','2013-07-15','06:45:00',1.29),('8975','2013-07-15','06:50:00',1.45),('8975','2013-07-15','06:55:00',1.59),('8975','2013-07-15','07:00:00',1.75),('8975','2013-07-15','07:05:00',1.92),('8975','2013-07-15','07:10:00',2.05),('8975','2013-07-15','07:15:00',2.17),('8975','2013-07-15','07:20:00',2.31),('8975','2013-07-15','07:25:00',2.43),('8975','2013-07-15','07:30:00',2.56),('8975','2013-07-15','07:35:00',2.7),('8975','2013-07-15','07:40:00',2.82),('8975','2013-07-15','07:45:00',2.92),('8975','2013-07-15','07:50:00',3.03),('8975','2013-07-15','07:55:00',3.12),('8975','2013-07-15','08:00:00',3.22),('8975','2013-07-15','08:05:00',3.28),('8975','2013-07-15','08:10:00',3.35),('8975','2013-07-15','08:15:00',3.49),('8975','2013-07-15','08:20:00',3.61),('8975','2013-07-15','08:25:00',3.72),('8975','2013-07-15','08:30:00',3.83),('8975','2013-07-15','08:35:00',3.95),('8975','2013-07-15','08:40:00',4.06),('8975','2013-07-15','08:45:00',4.18),('8975','2013-07-15','08:50:00',4.31),('8975','2013-07-15','08:55:00',4.37),('8975','2013-07-15','09:00:00',4.5),('8975','2013-07-15','09:05:00',4.59),('8975','2013-07-15','09:10:00',4.7),('8975','2013-07-15','09:15:00',4.79),('8975','2013-07-15','09:20:00',4.89),('8975','2013-07-15','09:25:00',4.96),('8975','2013-07-15','09:30:00',5.02),('8975','2013-07-15','09:35:00',5.11),('8975','2013-07-15','09:40:00',5.21),('8975','2013-07-15','09:45:00',5.26),('8975','2013-07-15','09:50:00',5.37),('8975','2013-07-15','09:55:00',5.49),('8975','2013-07-15','10:00:00',5.6),('8975','2013-07-15','10:05:00',5.7),('8975','2013-07-15','10:10:00',5.73),('8975','2013-07-15','10:15:00',5.75),('8975','2013-07-15','10:20:00',5.85),('8975','2013-07-15','10:25:00',5.9),('8975','2013-07-15','10:30:00',5.99),('8975','2013-07-15','10:35:00',5.96),('8975','2013-07-15','10:40:00',6.11),('8975','2013-07-15','10:45:00',6.13),('8975','2013-07-15','10:50:00',6.19),('8975','2013-07-15','10:55:00',6.24),('8975','2013-07-15','11:00:00',6.33),('8975','2013-07-15','11:05:00',6.39),('8975','2013-07-15','11:10:00',6.46),('8975','2013-07-15','11:15:00',6.47),('8975','2013-07-15','11:20:00',6.49),('8975','2013-07-15','11:25:00',6.47),('8975','2013-07-15','11:30:00',6.47),('8975','2013-07-15','11:35:00',6.49),('8975','2013-07-15','11:40:00',6.54),('8975','2013-07-15','11:45:00',6.58),('8975','2013-07-15','11:50:00',6.6),('8975','2013-07-15','11:55:00',6.62),('8975','2013-07-15','12:00:00',6.63),('8975','2013-07-15','12:05:00',6.64),('8975','2013-07-15','12:10:00',6.61),('8975','2013-07-15','12:15:00',6.62),('8975','2013-07-15','12:20:00',6.57),('8975','2013-07-15','12:25:00',6.58),('8975','2013-07-15','12:30:00',6.54),('8975','2013-07-15','12:35:00',6.53),('8975','2013-07-15','12:40:00',6.55),('8975','2013-07-15','12:45:00',6.57),('8975','2013-07-15','12:50:00',6.61),('8975','2013-07-15','12:55:00',6.51),('8975','2013-07-15','13:00:00',6.43),('8975','2013-07-15','13:05:00',6.41),('8975','2013-07-15','13:10:00',6.39),('8975','2013-07-15','13:15:00',6.29),('8975','2013-07-15','13:20:00',6.31),('8975','2013-07-15','13:25:00',6.26),('8975','2013-07-15','13:30:00',6.3),('8975','2013-07-15','13:35:00',6.25),('8975','2013-07-15','13:40:00',6.25),('8975','2013-07-15','13:45:00',6.33),('8975','2013-07-15','13:50:00',6.4),('8975','2013-07-15','13:55:00',6.26),('8975','2013-07-15','14:00:00',6.11),('8975','2013-07-15','14:05:00',6.17),('8975','2013-07-15','14:10:00',6.3),('8975','2013-07-15','14:15:00',4.86),('8975','2013-07-15','14:20:00',4.63),('8975','2013-07-15','14:25:00',5.04),('8975','2013-07-15','14:30:00',4.64),('8975','2013-07-15','14:35:00',5.8),('8975','2013-07-15','14:40:00',6.01),('8975','2013-07-15','14:45:00',5.77),('8975','2013-07-15','14:50:00',5.68),('8975','2013-07-15','14:55:00',5.62),('8975','2013-07-15','15:00:00',5.53),('8975','2013-07-15','15:05:00',5.47),('8975','2013-07-15','15:10:00',5.39),('8975','2013-07-15','15:15:00',5.3),('8975','2013-07-15','15:20:00',5.2),('8975','2013-07-15','15:25:00',5.13),('8975','2013-07-15','15:30:00',5.14),('8975','2013-07-15','15:35:00',5.2),('8975','2013-07-15','15:40:00',5.1),('8975','2013-07-15','15:45:00',4.92),('8975','2013-07-15','15:50:00',4.66),('8975','2013-07-15','15:55:00',4.5),('8975','2013-07-15','16:00:00',4.16),('8975','2013-07-15','16:05:00',3.94),('8975','2013-07-15','16:10:00',2.39),('8975','2013-07-15','16:15:00',1.55),('8975','2013-07-15','16:20:00',2.37),('8975','2013-07-15','16:25:00',2.19),('8975','2013-07-15','16:30:00',1.72),('8975','2013-07-15','16:45:00',1.26),('8975','2013-07-15','16:50:00',1.82),('8975','2013-07-15','16:55:00',2.61),('8975','2013-07-15','17:00:00',2.41),('8975','2013-07-15','17:05:00',3.21),('8975','2013-07-15','17:10:00',3.32),('8975','2013-07-15','17:15:00',2.69),('8975','2013-07-15','17:20:00',2.55),('8975','2013-07-15','17:25:00',2.41),('8975','2013-07-15','17:30:00',2.87),('8975','2013-07-15','17:35:00',2.15),('8975','2013-07-15','17:40:00',2.54),('8975','2013-07-15','17:45:00',2.57),('8975','2013-07-15','17:50:00',2.35),('8975','2013-07-15','17:55:00',1.97),('8975','2013-07-15','18:00:00',1.8),('8975','2013-07-15','18:05:00',1.37),('8975','2013-07-15','18:10:00',1.52),('8975','2013-07-15','18:15:00',1.64),('8975','2013-07-15','18:20:00',1.32),('8975','2013-07-15','18:25:00',1.34),('8975','2013-07-15','18:30:00',1.34),('8975','2013-07-15','18:35:00',1.3),('8975','2013-07-15','18:40:00',1.25),('8975','2013-07-15','18:45:00',1.18),('8975','2013-07-15','18:50:00',1.11),('8975','2013-07-14','06:40:00',1.18),('8975','2013-07-14','06:45:00',1.35),('8975','2013-07-14','06:50:00',1.53),('8975','2013-07-14','06:55:00',1.68),('8975','2013-07-14','07:00:00',1.83),('8975','2013-07-14','07:05:00',1.99),('8975','2013-07-14','07:10:00',2.13),('8975','2013-07-14','07:15:00',2.29),('8975','2013-07-14','07:20:00',2.41),('8975','2013-07-14','07:25:00',2.54),('8975','2013-07-14','07:30:00',2.67),('8975','2013-07-14','07:35:00',2.8),('8975','2013-07-14','07:40:00',2.93),('8975','2013-07-14','07:45:00',3.05),('8975','2013-07-14','07:50:00',3.17),('8975','2013-07-14','07:55:00',3.27),('8975','2013-07-14','08:00:00',3.38),('8975','2013-07-14','08:05:00',3.48),('8975','2013-07-14','08:10:00',3.57),('8975','2013-07-14','08:15:00',3.72),('8975','2013-07-14','08:20:00',3.83),('8975','2013-07-14','08:25:00',3.94),('8975','2013-07-14','08:30:00',4.05),('8975','2013-07-14','08:35:00',4.17),('8975','2013-07-14','08:40:00',4.28),('8975','2013-07-14','08:45:00',4.39),('8975','2013-07-14','08:50:00',4.49),('8975','2013-07-14','08:55:00',4.61),('8975','2013-07-14','09:00:00',4.68),('8975','2013-07-14','09:05:00',4.77),('8975','2013-07-14','09:10:00',4.85),('8975','2013-07-14','09:15:00',4.98),('8975','2013-07-14','09:20:00',5.04),('8975','2013-07-14','09:25:00',5.13),('8975','2013-07-14','09:30:00',5.21),('8975','2013-07-14','09:35:00',5.33),('8975','2013-07-14','09:40:00',5.41),('8975','2013-07-14','09:45:00',5.44),('8975','2013-07-14','09:50:00',5.52),('8975','2013-07-14','09:55:00',5.61),('8975','2013-07-14','10:00:00',5.69),('8975','2013-07-14','10:05:00',5.73),('8975','2013-07-14','10:10:00',5.78),('8975','2013-07-14','10:15:00',5.83),('8975','2013-07-14','10:20:00',5.88),('8975','2013-07-14','10:25:00',5.92),('8975','2013-07-14','10:30:00',5.63),('8975','2013-07-14','10:35:00',5.89),('8975','2013-07-14','10:40:00',5.71),('8975','2013-07-14','10:45:00',5.78),('8975','2013-07-14','10:50:00',6.02),('8975','2013-07-14','10:55:00',5.79),('8975','2013-07-14','11:00:00',5.77),('8975','2013-07-14','11:05:00',5.7),('8975','2013-07-14','11:10:00',5),('8975','2013-07-14','11:15:00',5.17),('8975','2013-07-14','11:20:00',6.07),('8975','2013-07-14','11:25:00',5.82),('8975','2013-07-14','11:30:00',6.26),('8975','2013-07-14','11:35:00',6.47),('8975','2013-07-14','11:40:00',6.5),('8975','2013-07-14','11:45:00',6.51),('8975','2013-07-14','11:50:00',6.53),('8975','2013-07-14','11:55:00',6.56),('8975','2013-07-14','12:00:00',6.47),('8975','2013-07-14','12:05:00',6.43),('8975','2013-07-14','12:10:00',6.39),('8975','2013-07-14','12:15:00',6.56),('8975','2013-07-14','12:20:00',6.49),('8975','2013-07-14','12:25:00',6.57),('8975','2013-07-14','12:30:00',6.52),('8975','2013-07-14','12:35:00',6.51),('8975','2013-07-14','12:40:00',6.53),('8975','2013-07-14','12:45:00',6.54),('8975','2013-07-14','12:50:00',6.52),('8975','2013-07-14','12:55:00',6.55),('8975','2013-07-14','13:00:00',6.52),('8975','2013-07-14','13:05:00',6.55),('8975','2013-07-14','13:10:00',6.34),('8975','2013-07-14','13:15:00',6.36),('8975','2013-07-14','13:20:00',6.54),('8975','2013-07-14','13:25:00',6.6),('8975','2013-07-14','13:30:00',3.73),('8975','2013-07-14','13:35:00',1.67),('8975','2013-07-14','13:40:00',6.42),('8975','2013-07-14','13:45:00',4.19),('8975','2013-07-14','13:50:00',4.93),('8975','2013-07-14','13:55:00',3.13),('8975','2013-07-14','14:00:00',3.43),('8975','2013-07-14','14:05:00',6.26),('8975','2013-07-14','14:10:00',6.67),('8975','2013-07-14','14:15:00',5.17),('8975','2013-07-14','14:20:00',3.35),('8975','2013-07-14','14:25:00',3.45),('8975','2013-07-14','14:30:00',5.81),('8975','2013-07-14','14:35:00',6.27),('8975','2013-07-14','14:40:00',6.18),('8975','2013-07-14','14:45:00',5.08),('8975','2013-07-14','14:50:00',1.75),('8975','2013-07-14','14:55:00',5.31),('8975','2013-07-14','15:00:00',6.09),('8975','2013-07-14','15:05:00',3.76),('8975','2013-07-14','15:10:00',4.88),('8975','2013-07-14','15:15:00',5.59),('8975','2013-07-14','15:20:00',5.4),('8975','2013-07-14','15:25:00',5.27),('8975','2013-07-14','15:30:00',3.88),('8975','2013-07-14','15:35:00',5.04),('8975','2013-07-14','15:40:00',3.83),('8975','2013-07-14','15:45:00',5.17),('8975','2013-07-14','15:50:00',5),('8975','2013-07-14','15:55:00',4.77),('8975','2013-07-14','16:00:00',4.53),('8975','2013-07-14','16:05:00',4.4),('8975','2013-07-14','16:10:00',4.32),('8975','2013-07-14','16:15:00',4.17),('8975','2013-07-14','16:20:00',4.07),('8975','2013-07-14','16:25:00',3.96),('8975','2013-07-14','16:30:00',3.9),('8975','2013-07-14','16:35:00',3.74),('8975','2013-07-14','16:40:00',3.61),('8975','2013-07-14','16:45:00',3.51),('8975','2013-07-14','16:50:00',3.4),('8975','2013-07-14','16:55:00',3.31),('8975','2013-07-14','17:00:00',3.2),('8975','2013-07-14','17:05:00',3.07),('8975','2013-07-14','17:10:00',2.94),('8975','2013-07-14','17:15:00',2.83),('8975','2013-07-14','17:20:00',2.71),('8975','2013-07-14','17:25:00',2.61),('8975','2013-07-14','17:30:00',2.48),('8975','2013-07-14','17:35:00',2.36),('8975','2013-07-14','17:40:00',2.26),('8975','2013-07-14','17:45:00',2.14),('8975','2013-07-14','17:50:00',2.06),('8975','2013-07-14','17:55:00',1.96),('8975','2013-07-14','18:00:00',1.86),('8975','2013-07-14','18:05:00',1.76),('8975','2013-07-14','18:10:00',1.67),('8975','2013-07-14','18:15:00',1.59),('8975','2013-07-14','18:20:00',1.51),('8975','2013-07-14','18:25:00',1.45),('8975','2013-07-14','18:30:00',1.37),('8975','2013-07-14','18:35:00',1.3),('8975','2013-07-14','18:40:00',1.24),('8975','2013-07-14','18:45:00',1.18),('8975','2013-07-14','18:50:00',1.15),('8975','2013-07-14','18:55:00',1.09),('8975','2013-07-14','19:00:00',1.06),('8975','2013-07-14','19:05:00',1.01),('8975','2013-07-13','07:30:00',1.01),('8975','2013-07-13','07:35:00',1.62),('8975','2013-07-13','07:40:00',2.4),('8975','2013-07-13','07:45:00',2.58),('8975','2013-07-13','07:50:00',3.14),('8975','2013-07-13','07:55:00',3.34),('8975','2013-07-13','08:00:00',3.33),('8975','2013-07-13','08:05:00',2.83),('8975','2013-07-13','08:10:00',3.32),('8975','2013-07-13','08:15:00',4.17),('8975','2013-07-13','08:20:00',4.03),('8975','2013-07-13','08:25:00',2.92),('8975','2013-07-13','08:30:00',1.98),('8975','2013-07-13','08:35:00',2.15),('8975','2013-07-13','08:40:00',1.71),('8975','2013-07-13','08:45:00',1.48),('8975','2013-07-13','08:50:00',1.45),('8975','2013-07-13','08:55:00',2.72),('8975','2013-07-13','09:00:00',2.79),('8975','2013-07-13','09:05:00',3.12),('8975','2013-07-13','09:10:00',3.81),('8975','2013-07-13','09:15:00',4.17),('8975','2013-07-13','09:20:00',3),('8975','2013-07-13','09:25:00',4.05),('8975','2013-07-13','09:30:00',3.81),('8975','2013-07-13','09:35:00',3.96),('8975','2013-07-13','09:40:00',3.72),('8975','2013-07-13','09:45:00',3.05),('8975','2013-07-13','09:50:00',2.94),('8975','2013-07-13','09:55:00',2.67),('8975','2013-07-13','10:00:00',2.76),('8975','2013-07-13','10:05:00',3.05),('8975','2013-07-13','10:10:00',3.13),('8975','2013-07-13','10:15:00',3.07),('8975','2013-07-13','10:20:00',3.27),('8975','2013-07-13','10:25:00',4.76),('8975','2013-07-13','10:30:00',6.25),('8975','2013-07-13','10:35:00',6.26),('8975','2013-07-13','10:40:00',5.75),('8975','2013-07-13','10:45:00',5.25),('8975','2013-07-13','10:50:00',5.25),('8975','2013-07-13','10:55:00',6.48),('8975','2013-07-13','11:00:00',2.67),('8975','2013-07-13','11:05:00',3.9),('8975','2013-07-13','11:10:00',5),('8975','2013-07-13','11:15:00',2.91),('8975','2013-07-13','11:20:00',2.83),('8975','2013-07-13','11:25:00',2.65),('8975','2013-07-13','11:30:00',4.64),('8975','2013-07-13','11:35:00',7.76),('8975','2013-07-13','11:40:00',7.72),('8975','2013-07-13','11:45:00',7.63),('8975','2013-07-13','11:50:00',5.15),('8975','2013-07-13','11:55:00',5.33),('8975','2013-07-13','12:00:00',5.74),('8975','2013-07-13','12:05:00',5.69),('8975','2013-07-13','12:10:00',3.99),('8975','2013-07-13','12:15:00',2.47),('8975','2013-07-13','12:20:00',2.08),('8975','2013-07-13','12:25:00',2.46),('8975','2013-07-13','12:30:00',7.68),('8975','2013-07-13','12:35:00',7.49),('8975','2013-07-13','12:40:00',7.27),('8975','2013-07-13','12:45:00',7.17),('8975','2013-07-13','12:50:00',4.87),('8975','2013-07-13','12:55:00',6.25),('8975','2013-07-13','13:00:00',7.25),('8975','2013-07-13','13:05:00',7.03),('8975','2013-07-13','13:10:00',7.13),('8975','2013-07-13','13:15:00',7.01),('8975','2013-07-13','13:20:00',6.83),('8975','2013-07-13','13:25:00',6.56),('8975','2013-07-13','13:30:00',6.65),('8975','2013-07-13','13:35:00',6.57),('8975','2013-07-13','13:40:00',6.55),('8975','2013-07-13','13:45:00',6.56),('8975','2013-07-13','13:50:00',6.51),('8975','2013-07-13','13:55:00',6.47),('8975','2013-07-13','14:00:00',6.41),('8975','2013-07-13','14:05:00',6.48),('8975','2013-07-13','14:10:00',6.43),('8975','2013-07-13','14:15:00',6.39),('8975','2013-07-13','14:20:00',6.37),('8975','2013-07-13','14:25:00',6.26),('8975','2013-07-13','14:30:00',6.12),('8975','2013-07-13','14:35:00',6.03),('8975','2013-07-13','14:40:00',5.94),('8975','2013-07-13','14:45:00',5.84),('8975','2013-07-13','14:50:00',5.76),('8975','2013-07-13','14:55:00',5.61),('8975','2013-07-13','15:00:00',5.54),('8975','2013-07-13','15:05:00',5.46),('8975','2013-07-13','15:10:00',5.38),('8975','2013-07-13','15:15:00',5.34),('8975','2013-07-13','15:20:00',5.26),('8975','2013-07-13','15:25:00',5.14),('8975','2013-07-13','15:30:00',5.09),('8975','2013-07-13','15:35:00',5.01),('8975','2013-07-13','15:40:00',4.88),('8975','2013-07-13','15:45:00',4.78),('8975','2013-07-13','15:50:00',4.62),('8975','2013-07-13','15:55:00',4.64),('8975','2013-07-13','16:00:00',4.55),('8975','2013-07-13','16:05:00',4.42),('8975','2013-07-13','16:10:00',4.37),('8975','2013-07-13','16:15:00',4.35),('8975','2013-07-13','16:20:00',4.33),('8975','2013-07-13','16:25:00',3.59),('8975','2013-07-13','16:30:00',4.2),('8975','2013-07-13','16:35:00',4.06),('8975','2013-07-13','16:40:00',3.25),('8975','2013-07-13','16:45:00',3.19),('8975','2013-07-13','16:50:00',3.31),('8975','2013-07-13','16:55:00',3.67),('8975','2013-07-13','17:00:00',3.47),('8975','2013-07-13','17:05:00',3.33),('8975','2013-07-13','17:10:00',2.98),('8975','2013-07-13','17:15:00',3.1),('8975','2013-07-13','17:20:00',1.78),('8975','2013-07-13','17:25:00',2.7),('8975','2013-07-13','17:30:00',3.21),('8975','2013-07-13','17:35:00',2.93),('8975','2013-07-13','17:40:00',2.6),('8975','2013-07-13','17:45:00',2.13),('8975','2013-07-13','17:50:00',2.01),('8975','2013-07-13','17:55:00',2.23),('8975','2013-07-13','18:00:00',2.15),('8975','2013-07-13','18:05:00',1.94),('8975','2013-07-13','18:10:00',1.61),('8975','2013-07-13','18:45:00',1.22),('8975','2013-07-13','18:50:00',1.13),('8975','2013-07-13','19:10:00',1),('8975','2013-07-13','19:15:00',1.14),('8975','2013-07-13','19:20:00',1.3),('8975','2013-07-12','07:10:00',1.44),('8975','2013-07-12','07:15:00',1.69),('8975','2013-07-12','07:20:00',1.77),('8975','2013-07-12','07:25:00',1.72),('8975','2013-07-12','07:30:00',2.09),('8975','2013-07-12','07:35:00',2.03),('8975','2013-07-12','07:40:00',2.28),('8975','2013-07-12','07:45:00',2.33),('8975','2013-07-12','07:50:00',2.49),('8975','2013-07-12','07:55:00',2.51),('8975','2013-07-12','08:00:00',2.89),('8975','2013-07-12','08:05:00',2.7),('8975','2013-07-12','08:10:00',2.89),('8975','2013-07-12','08:15:00',3.35),('8975','2013-07-12','08:20:00',3.63),('8975','2013-07-12','08:25:00',3.72),('8975','2013-07-12','08:30:00',3.79),('8975','2013-07-12','08:35:00',3.89),('8975','2013-07-12','08:40:00',4.08),('8975','2013-07-12','08:45:00',4.13),('8975','2013-07-12','08:50:00',4.25),('8975','2013-07-12','08:55:00',4.34),('8975','2013-07-12','09:00:00',4.44),('8975','2013-07-12','09:05:00',4.52),('8975','2013-07-12','09:10:00',4.56),('8975','2013-07-12','09:15:00',4.65),('8975','2013-07-12','09:20:00',4.76),('8975','2013-07-12','09:25:00',4.96),('8975','2013-07-12','09:30:00',4.91),('8975','2013-07-12','09:35:00',5.02),('8975','2013-07-12','09:40:00',5.14),('8975','2013-07-12','09:45:00',5.24),('8975','2013-07-12','09:50:00',5.22),('8975','2013-07-12','09:55:00',5.27),('8975','2013-07-12','10:00:00',5.45),('8975','2013-07-12','10:05:00',5.54),('8975','2013-07-12','10:10:00',5.59),('8975','2013-07-12','10:15:00',5.61),('8975','2013-07-12','10:20:00',5.78),('8975','2013-07-12','10:25:00',5.95),('8975','2013-07-12','10:30:00',5.86),('8975','2013-07-12','10:35:00',5.74),('8975','2013-07-12','10:40:00',5.8),('8975','2013-07-12','10:45:00',6.29),('8975','2013-07-12','10:50:00',6.74),('8975','2013-07-12','10:55:00',5.91),('8975','2013-07-12','11:00:00',3.75),('8975','2013-07-12','11:05:00',2.82),('8975','2013-07-12','11:10:00',5.96),('8975','2013-07-12','11:15:00',2.64),('8975','2013-07-12','11:20:00',5.77),('8975','2013-07-12','11:25:00',3.02),('8975','2013-07-12','11:30:00',1.78),('8975','2013-07-12','11:35:00',5.39),('8975','2013-07-12','11:40:00',7.1),('8975','2013-07-12','11:45:00',6.91),('8975','2013-07-12','11:50:00',4.41),('8975','2013-07-12','11:55:00',7.05),('8975','2013-07-12','12:00:00',7.07),('8975','2013-07-12','12:05:00',6.96),('8975','2013-07-12','12:10:00',6.9),('8975','2013-07-12','12:15:00',6.38),('8975','2013-07-12','12:20:00',2.31),('8975','2013-07-12','12:25:00',2.61),('8975','2013-07-12','12:30:00',7.09),('8975','2013-07-12','12:35:00',4.29),('8975','2013-07-12','12:40:00',3.63),('8975','2013-07-12','12:45:00',7.14),('8975','2013-07-12','12:50:00',6.49),('8975','2013-07-12','12:55:00',3.25),('8975','2013-07-12','13:00:00',7.02),('8975','2013-07-12','13:05:00',6.79),('8975','2013-07-12','13:10:00',6.84),('8975','2013-07-12','13:15:00',6.71),('8975','2013-07-12','13:20:00',6.69),('8975','2013-07-12','13:25:00',6.55),('8975','2013-07-12','13:30:00',6.47),('8975','2013-07-12','13:35:00',6.46),('8975','2013-07-12','13:40:00',6.46),('8975','2013-07-12','13:45:00',6.43),('8975','2013-07-12','13:50:00',6.4),('8975','2013-07-12','13:55:00',6.31),('8975','2013-07-12','14:00:00',6.29),('8975','2013-07-12','14:05:00',6.21),('8975','2013-07-12','14:10:00',6.19),('8975','2013-07-12','14:15:00',6.14),('8975','2013-07-12','14:20:00',6.05),('8975','2013-07-12','14:25:00',6.03),('8975','2013-07-12','14:30:00',5.98),('8975','2013-07-12','14:35:00',5.92),('8975','2013-07-12','14:40:00',5.91),('8975','2013-07-12','14:45:00',5.86),('8975','2013-07-12','14:50:00',5.77),('8975','2013-07-12','14:55:00',5.73),('8975','2013-07-12','15:00:00',5.65),('8975','2013-07-12','15:05:00',5.56),('8975','2013-07-12','15:10:00',5.52),('8975','2013-07-12','15:15:00',5.48),('8975','2013-07-12','15:20:00',5.18),('8975','2013-07-12','15:25:00',5.34),('8975','2013-07-12','15:30:00',4.79),('8975','2013-07-12','15:35:00',5.13),('8975','2013-07-12','15:40:00',5.06),('8975','2013-07-12','15:45:00',4.94),('8975','2013-07-12','15:50:00',4.82),('8975','2013-07-12','15:55:00',4.72),('8975','2013-07-12','16:00:00',4.61),('8975','2013-07-12','16:05:00',4.49),('8975','2013-07-12','16:10:00',4.4),('8975','2013-07-12','16:15:00',4.29),('8975','2013-07-12','16:20:00',4.12),('8975','2013-07-12','16:25:00',4.11),('8975','2013-07-12','16:30:00',3.98),('8975','2013-07-12','16:35:00',3.87),('8975','2013-07-12','16:40:00',3.74),('8975','2013-07-12','16:45:00',3.65),('8975','2013-07-12','16:50:00',3.5),('8975','2013-07-12','16:55:00',3.4),('8975','2013-07-12','17:00:00',3.26),('8975','2013-07-12','17:05:00',3.03),('8975','2013-07-12','17:10:00',3.03),('8975','2013-07-12','17:15:00',2.88),('8975','2013-07-12','17:20:00',2.71),('8975','2013-07-12','17:25:00',2.66),('8975','2013-07-12','17:30:00',2.49),('8975','2013-07-12','17:35:00',2.41),('8975','2013-07-12','17:40:00',2.32),('8975','2013-07-12','17:45:00',2.2),('8975','2013-07-12','17:50:00',2.07),('8975','2013-07-12','17:55:00',2.1),('8975','2013-07-12','18:00:00',1.92),('8975','2013-07-12','18:05:00',1.78),('8975','2013-07-12','18:10:00',1.77),('8975','2013-07-12','18:15:00',1.69),('8975','2013-07-12','18:20:00',1.6),('8975','2013-07-12','18:25:00',1.56),('8975','2013-07-12','18:30:00',1.46),('8975','2013-07-12','18:35:00',1.4),('8975','2013-07-12','18:40:00',1.14),('8975','2013-07-12','18:50:00',1.03),('8975','2013-07-12','18:55:00',1.28),('8975','2013-07-12','19:00:00',1.16),('8975','2013-07-12','19:05:00',1.07),('8975','2013-07-12','19:10:00',1.01),('8975','2013-07-11','06:55:00',1.07),('8975','2013-07-11','07:00:00',1.18),('8975','2013-07-11','07:05:00',1.16),('8975','2013-07-11','07:10:00',1.08),('8975','2013-07-11','07:15:00',1.48),('8975','2013-07-11','07:20:00',1.66),('8975','2013-07-11','07:25:00',1.64),('8975','2013-07-11','07:30:00',1.26),('8975','2013-07-11','07:35:00',1.13),('8975','2013-07-11','07:45:00',1.25),('8975','2013-07-11','07:50:00',1.06),('8975','2013-07-11','07:55:00',1.1),('8975','2013-07-11','08:00:00',1.47),('8975','2013-07-11','08:05:00',1.6),('8975','2013-07-11','08:10:00',1.87),('8975','2013-07-11','08:15:00',2.04),('8975','2013-07-11','08:20:00',2.34),('8975','2013-07-11','08:25:00',1.69),('8975','2013-07-11','08:30:00',1.39),('8975','2013-07-11','08:35:00',1.63),('8975','2013-07-11','08:40:00',2.05),('8975','2013-07-11','08:45:00',2.52),('8975','2013-07-11','08:50:00',1.96),('8975','2013-07-11','08:55:00',1.14),('8975','2013-07-11','09:00:00',1.06),('8975','2013-07-11','09:05:00',1.68),('8975','2013-07-11','09:10:00',1.79),('8975','2013-07-11','09:15:00',2.3),('8975','2013-07-11','09:20:00',3.05),('8975','2013-07-11','09:25:00',4.4),('8975','2013-07-11','09:30:00',4.28),('8975','2013-07-11','09:35:00',5.11),('8975','2013-07-11','09:40:00',5.41),('8975','2013-07-11','09:45:00',4.88),('8975','2013-07-11','09:50:00',5.01),('8975','2013-07-11','09:55:00',4.37),('8975','2013-07-11','10:00:00',4.04),('8975','2013-07-11','10:05:00',3.94),('8975','2013-07-11','10:10:00',4.26),('8975','2013-07-11','10:15:00',5.57),('8975','2013-07-11','10:20:00',6.14),('8975','2013-07-11','10:25:00',5.98),('8975','2013-07-11','10:30:00',5.54),('8975','2013-07-11','10:35:00',3.99),('8975','2013-07-11','10:40:00',2.03),('8975','2013-07-11','10:45:00',6.11),('8975','2013-07-11','10:50:00',6.21),('8975','2013-07-11','10:55:00',6.75),('8975','2013-07-11','11:00:00',3.08),('8975','2013-07-11','11:05:00',5.38),('8975','2013-07-11','11:10:00',6.42),('8975','2013-07-11','11:15:00',5.55),('8975','2013-07-11','11:20:00',5.89),('8975','2013-07-11','11:25:00',4.66),('8975','2013-07-11','11:30:00',2.73),('8975','2013-07-11','11:35:00',3.39),('8975','2013-07-11','11:40:00',3.5),('8975','2013-07-11','11:45:00',5.51),('8975','2013-07-11','11:50:00',5.03),('8975','2013-07-11','11:55:00',1.77),('8975','2013-07-11','12:00:00',4.74),('8975','2013-07-11','12:05:00',7.38),('8975','2013-07-11','12:10:00',7.37),('8975','2013-07-11','12:15:00',5.86),('8975','2013-07-11','12:20:00',7.62),('8975','2013-07-11','12:25:00',7.27),('8975','2013-07-11','12:30:00',7.44),('8975','2013-07-11','12:35:00',5.36),('8975','2013-07-11','12:40:00',7.33),('8975','2013-07-11','12:45:00',7.38),('8975','2013-07-11','12:50:00',7.32),('8975','2013-07-11','12:55:00',6.82),('8975','2013-07-11','13:00:00',6.91),('8975','2013-07-11','13:05:00',6.8),('8975','2013-07-11','13:10:00',6.61),('8975','2013-07-11','13:15:00',6.77),('8975','2013-07-11','13:20:00',6.49),('8975','2013-07-11','13:25:00',6.53),('8975','2013-07-11','13:30:00',6.58),('8975','2013-07-11','13:35:00',6.37),('8975','2013-07-11','13:40:00',6.68),('8975','2013-07-11','13:45:00',6.46),('8975','2013-07-11','13:50:00',6.51),('8975','2013-07-11','13:55:00',6.44),('8975','2013-07-11','14:00:00',6.06),('8975','2013-07-11','14:05:00',5.11),('8975','2013-07-11','14:10:00',3.47),('8975','2013-07-11','14:15:00',2.53),('8975','2013-07-11','14:20:00',6.86),('8975','2013-07-11','14:25:00',4.93),('8975','2013-07-11','14:30:00',6.29),('8975','2013-07-11','14:35:00',4.33),('8975','2013-07-11','14:40:00',5.99),('8975','2013-07-11','14:45:00',5.87),('8975','2013-07-11','14:50:00',5.73),('8975','2013-07-11','14:55:00',5.63),('8975','2013-07-11','15:00:00',5.54),('8975','2013-07-11','15:05:00',5.39),('8975','2013-07-11','15:10:00',5.45),('8975','2013-07-11','15:15:00',5.46),('8975','2013-07-11','15:20:00',4.36),('8975','2013-07-11','15:25:00',5.19),('8975','2013-07-11','15:30:00',5.24),('8975','2013-07-11','15:35:00',5.05),('8975','2013-07-11','15:40:00',5.02),('8975','2013-07-11','15:45:00',4.82),('8975','2013-07-11','15:50:00',4.72),('8975','2013-07-11','15:55:00',4.57),('8975','2013-07-11','16:00:00',4.43),('8975','2013-07-11','16:05:00',4.4),('8975','2013-07-11','16:10:00',4.23),('8975','2013-07-11','16:15:00',4.12),('8975','2013-07-11','16:20:00',4.03),('8975','2013-07-11','16:25:00',3.92),('8975','2013-07-11','16:30:00',3.85),('8975','2013-07-11','16:35:00',3.75),('8975','2013-07-11','16:40:00',3.7),('8975','2013-07-11','16:45:00',3.59),('8975','2013-07-11','16:50:00',3.46),('8975','2013-07-11','16:55:00',3.32),('8975','2013-07-11','17:00:00',3.21),('8975','2013-07-11','17:05:00',3.1),('8975','2013-07-11','17:10:00',2.98),('8975','2013-07-11','17:15:00',2.83),('8975','2013-07-11','17:20:00',2.73),('8975','2013-07-11','17:25:00',2.6),('8975','2013-07-11','17:30:00',2.48),('8975','2013-07-11','17:35:00',2.38),('8975','2013-07-11','17:40:00',2.26),('8975','2013-07-11','17:45:00',2.16),('8975','2013-07-11','17:50:00',2.1),('8975','2013-07-11','17:55:00',1.98),('8975','2013-07-11','18:00:00',1.91),('8975','2013-07-11','18:05:00',1.79),('8975','2013-07-11','18:10:00',1.72),('8975','2013-07-11','18:15:00',1.64),('8975','2013-07-11','18:20:00',1.56),('8975','2013-07-11','18:25:00',1.51),('8975','2013-07-11','18:30:00',1.42),('8975','2013-07-11','18:35:00',1.37),('8975','2013-07-11','18:40:00',1.32),('8975','2013-07-11','18:45:00',1.25),('8975','2013-07-11','18:50:00',1.17),('8975','2013-07-11','18:55:00',1.12),('8975','2013-07-11','19:00:00',1.07),('8975','2013-07-11','19:05:00',1.01),('8975','2013-07-10','06:45:00',1.07),('8975','2013-07-10','06:50:00',1.22),('8975','2013-07-10','06:55:00',1.32),('8975','2013-07-10','07:00:00',1.45),('8975','2013-07-10','07:05:00',1.59),('8975','2013-07-10','07:10:00',1.74),('8975','2013-07-10','07:15:00',1.83),('8975','2013-07-10','07:20:00',1.98),('8975','2013-07-10','07:25:00',2.15),('8975','2013-07-10','07:30:00',2.37),('8975','2013-07-10','07:35:00',2.49),('8975','2013-07-10','07:40:00',2.62),('8975','2013-07-10','07:45:00',2.78),('8975','2013-07-10','07:50:00',2.89),('8975','2013-07-10','07:55:00',3.01),('8975','2013-07-10','08:00:00',3.16),('8975','2013-07-10','08:05:00',3.27),('8975','2013-07-10','08:10:00',3.34),('8975','2013-07-10','08:15:00',3.47),('8975','2013-07-10','08:20:00',3.61),('8975','2013-07-10','08:25:00',3.67),('8975','2013-07-10','08:30:00',3.76),('8975','2013-07-10','08:35:00',3.88),('8975','2013-07-10','08:40:00',4),('8975','2013-07-10','08:45:00',3.94),('8975','2013-07-10','08:50:00',4.01),('8975','2013-07-10','08:55:00',4.4),('8975','2013-07-10','09:00:00',4.37),('8975','2013-07-10','09:05:00',4.65),('8975','2013-07-10','09:10:00',3.46),('8975','2013-07-10','09:15:00',3.73),('8975','2013-07-10','09:20:00',4.33),('8975','2013-07-10','09:25:00',4.55),('8975','2013-07-10','09:30:00',5),('8975','2013-07-10','09:35:00',5.11),('8975','2013-07-10','09:40:00',5.38),('8975','2013-07-10','09:45:00',5.37),('8975','2013-07-10','09:50:00',5.13),('8975','2013-07-10','09:55:00',5.59),('8975','2013-07-10','10:00:00',5.21),('8975','2013-07-10','10:05:00',4.76),('8975','2013-07-10','10:10:00',5.83),('8975','2013-07-10','10:15:00',3.34),('8975','2013-07-10','10:20:00',2.67),('8975','2013-07-10','10:25:00',2.56),('8975','2013-07-10','10:30:00',4.77),('8975','2013-07-10','10:35:00',3.5),('8975','2013-07-10','10:40:00',6.04),('8975','2013-07-10','10:45:00',6.55),('8975','2013-07-10','10:50:00',6.72),('8975','2013-07-10','10:55:00',5.37),('8975','2013-07-10','11:00:00',1.8),('8975','2013-07-10','11:05:00',3.01),('8975','2013-07-10','11:10:00',6.92),('8975','2013-07-10','11:15:00',7.07),('8975','2013-07-10','11:20:00',3.96),('8975','2013-07-10','11:25:00',5.4),('8975','2013-07-10','11:30:00',6.78),('8975','2013-07-10','11:35:00',5.68),('8975','2013-07-10','11:40:00',6.94),('8975','2013-07-10','11:45:00',3.29),('8975','2013-07-10','11:50:00',2.12),('8975','2013-07-10','11:55:00',5.58),('8975','2013-07-10','12:00:00',7.06),('8975','2013-07-10','12:05:00',2.24),('8975','2013-07-10','12:10:00',2.06),('8975','2013-07-10','12:15:00',5.05),('8975','2013-07-10','12:20:00',7.26),('8975','2013-07-10','12:25:00',3.31),('8975','2013-07-10','12:30:00',2.97),('8975','2013-07-10','12:35:00',3.41),('8975','2013-07-10','12:40:00',5.84),('8975','2013-07-10','12:45:00',5.71),('8975','2013-07-10','12:50:00',6.65),('8975','2013-07-10','12:55:00',3.85),('8975','2013-07-10','13:00:00',7.28),('8975','2013-07-10','13:05:00',6.26),('8975','2013-07-10','13:10:00',6.11),('8975','2013-07-10','13:15:00',6.08),('8975','2013-07-10','13:20:00',5.71),('8975','2013-07-10','13:25:00',6.46),('8975','2013-07-10','13:30:00',3.57),('8975','2013-07-10','13:35:00',5.93),('8975','2013-07-10','13:40:00',7.12),('8975','2013-07-10','13:45:00',6.88),('8975','2013-07-10','13:50:00',7.02),('8975','2013-07-10','13:55:00',6.65),('8975','2013-07-10','14:00:00',4.54),('8975','2013-07-10','14:05:00',5.64),('8975','2013-07-10','14:10:00',6.63),('8975','2013-07-10','14:15:00',6.25),('8975','2013-07-10','14:20:00',6.63),('8975','2013-07-10','14:25:00',6.24),('8975','2013-07-10','14:30:00',6.28),('8975','2013-07-10','14:35:00',4.08),('8975','2013-07-10','14:40:00',5.76),('8975','2013-07-10','14:45:00',5.98),('8975','2013-07-10','14:50:00',4.51),('8975','2013-07-10','14:55:00',6.11),('8975','2013-07-10','15:00:00',3.53),('8975','2013-07-10','15:05:00',4.36),('8975','2013-07-10','15:10:00',5.68),('8975','2013-07-10','15:15:00',6.05),('8975','2013-07-10','15:20:00',5.44),('8975','2013-07-10','15:25:00',3.85),('8975','2013-07-10','15:30:00',4.33),('8975','2013-07-10','15:35:00',5.01),('8975','2013-07-10','15:40:00',4.66),('8975','2013-07-10','15:45:00',3.2),('8975','2013-07-10','15:50:00',5.04),('8975','2013-07-10','15:55:00',3.21),('8975','2013-07-10','16:00:00',3.33),('8975','2013-07-10','16:05:00',4.54),('8975','2013-07-10','16:10:00',5.05),('8975','2013-07-10','16:15:00',4.05),('8975','2013-07-10','16:20:00',3.35),('8975','2013-07-10','16:25:00',4.78),('8975','2013-07-10','16:30:00',3.65),('8975','2013-07-10','16:35:00',4.15),('8975','2013-07-10','16:40:00',3.41),('8975','2013-07-10','16:45:00',2.84),('8975','2013-07-10','16:50:00',2.67),('8975','2013-07-10','16:55:00',3.63),('8975','2013-07-10','17:00:00',2.94),('8975','2013-07-10','17:05:00',3.62),('8975','2013-07-10','17:10:00',2.98),('8975','2013-07-10','17:15:00',3.35),('8975','2013-07-10','17:20:00',2.15),('8975','2013-07-10','17:25:00',2.11),('8975','2013-07-10','17:30:00',3.01),('8975','2013-07-10','17:35:00',2.7),('8975','2013-07-10','17:40:00',2.59),('8975','2013-07-10','17:45:00',2.69),('8975','2013-07-10','17:50:00',2.34),('8975','2013-07-10','17:55:00',2.26),('8975','2013-07-10','18:00:00',2.13),('8975','2013-07-10','18:05:00',2.3),('8975','2013-07-10','18:10:00',2),('8975','2013-07-10','18:15:00',2.18),('8975','2013-07-10','18:20:00',1.9),('8975','2013-07-10','18:25:00',1.42),('8975','2013-07-10','18:30:00',1.94),('8975','2013-07-10','18:35:00',1.64),('8975','2013-07-10','18:40:00',1.12),('8975','2013-07-10','18:45:00',1.22),('8975','2013-07-10','18:50:00',1.29),('8975','2013-07-10','18:55:00',1.22),('8975','2013-07-10','19:00:00',1.15),('8975','2013-07-10','19:05:00',1.06),('8975','2013-07-10','19:10:00',1.02),('8975','2014-05-02','06:40:00',1.38),('8975','2014-05-02','06:45:00',1.29),('8975','2014-05-02','07:00:00',1.45),('8975','2014-05-02','07:05:00',2.25),('8975','2014-05-02','07:10:00',2.41),('8975','2014-05-02','07:15:00',2.55),('8975','2014-05-02','07:20:00',2.74),('8975','2014-05-02','07:25:00',2.89),('8975','2014-05-02','07:30:00',2.93),('8975','2014-05-02','07:35:00',3.38),('8975','2014-05-02','07:40:00',3.29),('8975','2014-05-02','07:45:00',3.4),('8975','2014-05-02','07:50:00',3.59),('8975','2014-05-02','07:55:00',3.74),('8975','2014-05-02','08:00:00',3.16),('8975','2014-05-02','08:05:00',2.78),('8975','2014-05-02','08:10:00',1.55),('8975','2014-05-02','08:15:00',1.56),('8975','2014-05-02','08:20:00',1.67),('8975','2014-05-02','08:25:00',1.81),('8975','2014-05-02','08:30:00',2.05),('8975','2014-05-02','08:35:00',1.93),('8975','2014-05-02','08:40:00',2.27),('8975','2014-05-02','08:45:00',4.16),('8975','2014-05-02','08:50:00',5.67),('8975','2014-05-02','08:55:00',5.35),('8975','2014-05-02','09:00:00',4.9),('8975','2014-05-02','09:05:00',3.49),('8975','2014-05-02','09:10:00',3.76),('8975','2014-05-02','09:15:00',3.98),('8975','2014-05-02','09:20:00',6.04),('8975','2014-05-02','09:25:00',6.63),('8975','2014-05-02','09:30:00',2.91),('8975','2014-05-02','09:35:00',2.06),('8975','2014-05-02','09:40:00',2.1),('8975','2014-05-02','09:45:00',2.55),('8975','2014-05-02','09:50:00',5.22),('8975','2014-05-02','09:55:00',6.56),('8975','2014-05-02','10:00:00',6.28),('8975','2014-05-02','10:05:00',6.61),('8975','2014-05-02','10:10:00',5.27),('8975','2014-05-02','10:15:00',4.09),('8975','2014-05-02','10:20:00',3.4),('8975','2014-05-02','10:25:00',6.83),('8975','2014-05-02','10:30:00',5.05),('8975','2014-05-02','10:35:00',4.47),('8975','2014-05-02','10:40:00',2.57),('8975','2014-05-02','10:45:00',2.59),('8975','2014-05-02','10:50:00',6.36),('8975','2014-05-02','10:55:00',3.65),('8975','2014-05-02','11:00:00',7.5),('8975','2014-05-02','11:05:00',7.08),('8975','2014-05-02','11:10:00',8.31),('8975','2014-05-02','11:15:00',6.68),('8975','2014-05-02','11:20:00',6.76),('8975','2014-05-02','11:25:00',6.24),('8975','2014-05-02','11:30:00',4.4),('8975','2014-05-02','11:35:00',4.78),('8975','2014-05-02','11:40:00',3.91),('8975','2014-05-02','11:45:00',3.21),('8975','2014-05-02','11:50:00',2.95),('8975','2014-05-02','11:55:00',2.47),('8975','2014-05-02','12:00:00',2.08),('8975','2014-05-02','12:05:00',1.83),('8975','2014-05-02','12:10:00',1.72),('8975','2014-05-02','12:15:00',1.65),('8975','2014-05-02','12:20:00',1.69),('8975','2014-05-02','12:25:00',2.1),('8975','2014-05-02','12:30:00',3.04),('8975','2014-05-02','12:35:00',4.41),('8975','2014-05-02','12:40:00',3.74),('8975','2014-05-02','12:45:00',3.23),('8975','2014-05-02','12:50:00',2.63),('8975','2014-05-02','12:55:00',2.69),('8975','2014-05-02','13:00:00',3.28),('8975','2014-05-02','13:05:00',5.07),('8975','2014-05-02','13:10:00',3.58),('8975','2014-05-02','13:15:00',3.93),('8975','2014-05-02','13:20:00',4.5),('8975','2014-05-02','13:25:00',4.88),('8975','2014-05-02','13:30:00',3.35),('8975','2014-05-02','13:35:00',2.81),('8975','2014-05-02','13:40:00',2.69),('8975','2014-05-02','13:45:00',2.68),('8975','2014-05-02','13:50:00',2.74),('8975','2014-05-02','13:55:00',2.82),('8975','2014-05-02','14:00:00',2.97),('8975','2014-05-02','14:05:00',3.42),('8975','2014-05-02','14:10:00',4.54),('8975','2014-05-02','14:15:00',6.2),('8975','2014-05-02','14:20:00',6.44),('8975','2014-05-02','14:25:00',3.17),('8975','2014-05-02','14:30:00',2.19),('8975','2014-05-02','14:35:00',2.05),('8975','2014-05-02','14:40:00',1.36),('8975','2014-05-02','14:45:00',6.76),('8975','2014-05-02','14:50:00',7.39),('8975','2014-05-02','14:55:00',7.7),('8975','2014-05-02','15:00:00',7.48),('8975','2014-05-02','15:05:00',6.04),('8975','2014-05-02','15:10:00',2.78),('8975','2014-05-02','15:15:00',1.63),('8975','2014-05-02','15:20:00',1.35),('8975','2014-05-02','15:25:00',1.04),('8975','2014-05-02','15:30:00',1.23),('8975','2014-05-02','15:35:00',1.23),('8975','2014-05-02','15:40:00',1.19),('8975','2014-05-02','15:45:00',1.07),('8975','2014-05-02','16:30:00',1.05),('8975','2014-05-02','16:35:00',1.18),('8975','2014-05-02','16:40:00',1.34),('8975','2014-05-02','16:45:00',1.49),('8975','2014-05-02','16:50:00',1.56),('8975','2014-05-02','16:55:00',1.6),('8975','2014-05-02','17:00:00',1.6),('8975','2014-05-02','17:05:00',1.58),('8975','2014-05-02','17:10:00',1.57),('8975','2014-05-02','17:15:00',1.55),('8975','2014-05-02','17:20:00',1.52),('8975','2014-05-02','17:25:00',1.52),('8975','2014-05-02','17:30:00',1.5),('8975','2014-05-02','17:35:00',1.44),('8975','2014-05-02','17:40:00',1.4),('8975','2014-05-02','17:45:00',1.35),('8975','2014-05-02','17:50:00',1.38),('8975','2014-05-02','17:55:00',1.56),('8975','2014-05-02','18:00:00',1.35),('8975','2014-05-02','18:05:00',1.15),('8975','2014-04-05','08:05:00',2.65),('8975','2014-04-05','08:10:00',3.06),('8975','2014-04-05','08:15:00',3.15),('8975','2014-04-05','08:20:00',3.25),('8975','2014-04-05','08:25:00',3.41),('8975','2014-04-05','08:30:00',3.51),('8975','2014-04-05','08:35:00',3.61),('8975','2014-04-05','08:40:00',3.68),('8975','2014-04-05','08:45:00',3.71),('8975','2014-04-05','08:50:00',3.94),('8975','2014-04-05','08:55:00',3.83),('8975','2014-04-05','09:00:00',1.52),('8975','2014-04-05','09:05:00',1.6),('8975','2014-04-05','09:10:00',3.63),('8975','2014-04-05','09:15:00',4.33),('8975','2014-04-05','09:20:00',4.11),('8975','2014-04-05','09:25:00',1.34),('8975','2014-04-05','09:30:00',2.35),('8975','2014-04-05','09:35:00',3.23),('8975','2014-04-05','09:40:00',4.53),('8975','2014-04-05','09:45:00',5.71),('8975','2014-04-05','09:50:00',6.28),('8975','2014-04-05','09:55:00',5.97),('8975','2014-04-05','10:00:00',2.42),('8975','2014-04-05','10:05:00',1.72),('8975','2014-04-05','10:10:00',1.77),('8975','2014-04-05','10:15:00',2.06),('8975','2014-04-05','10:20:00',2.03),('8975','2014-04-05','10:25:00',2.06),('8975','2014-04-05','10:30:00',2.39),('8975','2014-04-05','10:35:00',2.75),('8975','2014-04-05','10:40:00',3.52),('8975','2014-04-05','10:45:00',5.52),('8975','2014-04-05','10:50:00',5.2),('8975','2014-04-05','10:55:00',6.75),('8975','2014-04-05','11:00:00',7.23),('8975','2014-04-05','11:05:00',6.86),('8975','2014-04-05','11:10:00',6.33),('8975','2014-04-05','11:15:00',4.98),('8975','2014-04-05','11:20:00',6.9),('8975','2014-04-05','11:25:00',6.64),('8975','2014-04-05','11:30:00',6.52),('8975','2014-04-05','11:35:00',6.68),('8975','2014-04-05','11:40:00',6.95),('8975','2014-04-05','11:45:00',6.9),('8975','2014-04-05','11:50:00',6.96),('8975','2014-04-05','11:55:00',6.88),('8975','2014-04-05','12:00:00',6.31),('8975','2014-04-05','12:05:00',4.45),('8975','2014-04-05','12:10:00',4.84),('8975','2014-04-05','12:15:00',6.62),('8975','2014-04-05','12:20:00',7.41),('8975','2014-04-05','12:25:00',4.23),('8975','2014-04-05','12:30:00',2.68),('8975','2014-04-05','12:35:00',5.69),('8975','2014-04-05','12:40:00',2.16),('8975','2014-04-05','12:45:00',2.48),('8975','2014-04-05','12:50:00',2.05),('8975','2014-04-05','12:55:00',1.97),('8975','2014-04-05','13:00:00',2.73),('8975','2014-04-05','13:05:00',5.87),('8975','2014-04-05','13:10:00',6.1),('8975','2014-04-05','13:15:00',4.17),('8975','2014-04-05','13:20:00',4.1),('8975','2014-04-05','13:25:00',3.43),('8975','2014-04-05','13:30:00',3.8),('8975','2014-04-05','13:35:00',3.07),('8975','2014-04-05','13:40:00',4.34),('8975','2014-04-05','13:45:00',5.21),('8975','2014-04-05','13:50:00',4.31),('8975','2014-04-05','13:55:00',4.16),('8975','2014-04-05','14:00:00',3.77),('8975','2014-04-05','14:05:00',5.88),('8975','2014-04-05','14:10:00',5.85),('8975','2014-04-05','14:15:00',6),('8975','2014-04-05','14:20:00',6.2),('8975','2014-04-05','14:25:00',4.68),('8975','2014-04-05','14:30:00',1.74),('8975','2014-04-05','14:35:00',2.52),('8975','2014-04-05','14:40:00',4.3),('8975','2014-04-05','14:45:00',2.39),('8975','2014-04-05','14:50:00',2.49),('8975','2014-04-05','14:55:00',2.51),('8975','2014-04-05','15:00:00',2.51),('8975','2014-04-05','15:05:00',1.86),('8975','2014-04-05','15:10:00',1.76),('8975','2014-04-05','15:15:00',2.76),('8975','2014-04-05','15:20:00',4.7),('8975','2014-04-05','15:25:00',1.94),('8975','2014-04-05','15:30:00',1.97),('8975','2014-04-05','15:35:00',1.18),('8975','2014-04-05','15:40:00',1.13),('8975','2014-04-05','15:45:00',1.39),('8975','2014-04-05','15:50:00',1.72),('8975','2014-04-05','15:55:00',3.21),('8975','2014-04-05','16:00:00',4.44),('8975','2014-04-05','16:05:00',2.79),('8975','2014-04-05','16:10:00',2.24),('8975','2014-04-05','16:15:00',1.31),('8975','2014-04-05','16:30:00',1.25),('8975','2014-04-05','16:35:00',1.85),('8975','2014-04-05','16:40:00',2.01),('8975','2014-04-05','16:45:00',3.34),('8975','2014-04-05','16:50:00',3.39),('8975','2014-04-05','16:55:00',2.95),('8975','2014-04-05','17:00:00',1.55),('8975','2014-04-05','17:05:00',1.14),('8975','2014-04-05','17:10:00',1.08),('8975','2014-04-05','17:30:00',1.52),('8975','2014-04-05','17:35:00',1.72),('8975','2014-04-05','17:40:00',1.59),('8975','2014-04-05','17:45:00',1.02),('8975','2014-04-05','17:50:00',1.62),('8975','2014-04-05','17:55:00',1.54),('8975','2014-04-05','18:00:00',1.45),('8975','2014-04-05','18:05:00',1.42),('8975','2014-04-05','18:10:00',1.37),('8975','2014-04-05','18:15:00',1.35),('8975','2014-04-05','18:20:00',1.36),('8975','2014-04-05','18:25:00',1.29),('8975','2014-04-05','18:30:00',1.19),('8975','2013-07-09','06:35:00',1.04),('8975','2013-07-09','06:40:00',1.17),('8975','2013-07-09','06:45:00',1.34),('8975','2013-07-09','06:50:00',1.51),('8975','2013-07-09','06:55:00',1.72),('8975','2013-07-09','07:00:00',1.9),('8975','2013-07-09','07:05:00',2.1),('8975','2013-07-09','07:10:00',2.28),('8975','2013-07-09','07:15:00',2.5),('8975','2013-07-09','07:20:00',2.8),('8975','2013-07-09','07:25:00',3.09),('8975','2013-07-09','07:30:00',3.34),('8975','2013-07-09','07:35:00',3.61),('8975','2013-07-09','07:40:00',3.84),('8975','2013-07-09','07:45:00',4.05),('8975','2013-07-09','07:50:00',4.27),('8975','2013-07-09','07:55:00',2.83),('8975','2013-07-09','08:00:00',3.51),('8975','2013-07-09','08:05:00',3.87),('8975','2013-07-09','08:10:00',3.83),('8975','2013-07-09','08:15:00',3.44),('8975','2013-07-09','08:20:00',4.14),('8975','2013-07-09','08:25:00',4.68),('8975','2013-07-09','08:30:00',5.04),('8975','2013-07-09','08:35:00',3.89),('8975','2013-07-09','08:40:00',4.96),('8975','2013-07-09','08:45:00',4.57),('8975','2013-07-09','08:50:00',4.01),('8975','2013-07-09','08:55:00',3.53),('8975','2013-07-09','09:00:00',4.73),('8975','2013-07-09','09:05:00',4.19),('8975','2013-07-09','09:10:00',4.96),('8975','2013-07-09','09:15:00',5.2),('8975','2013-07-09','09:20:00',4.39),('8975','2013-07-09','09:25:00',5.3),('8975','2013-07-09','09:30:00',5.3),('8975','2013-07-09','09:35:00',5.32),('8975','2013-07-09','09:40:00',5.32),('8975','2013-07-09','09:45:00',5.29),('8975','2013-07-09','09:50:00',5.46),('8975','2013-07-09','09:55:00',5.57),('8975','2013-07-09','10:00:00',5.59),('8975','2013-07-09','10:05:00',5.64),('8975','2013-07-09','10:10:00',5.64),('8975','2013-07-09','10:15:00',5.7),('8975','2013-07-09','10:20:00',5.78),('8975','2013-07-09','10:25:00',5.85),('8975','2013-07-09','10:30:00',5.93),('8975','2013-07-09','10:35:00',5.98),('8975','2013-07-09','10:40:00',5.97),('8975','2013-07-09','10:45:00',5.99),('8975','2013-07-09','10:50:00',6.03),('8975','2013-07-09','10:55:00',6.05),('8975','2013-07-09','11:00:00',6.12),('8975','2013-07-09','11:05:00',6.23),('8975','2013-07-09','11:10:00',6.27),('8975','2013-07-09','11:15:00',6.29),('8975','2013-07-09','11:20:00',6.28),('8975','2013-07-09','11:25:00',6.3),('8975','2013-07-09','11:30:00',6.39),('8975','2013-07-09','11:35:00',6.4),('8975','2013-07-09','11:40:00',6.37),('8975','2013-07-09','11:45:00',6.46),('8975','2013-07-09','11:50:00',6.46),('8975','2013-07-09','11:55:00',6.46),('8975','2013-07-09','12:00:00',6.51),('8975','2013-07-09','12:05:00',6.55),('8975','2013-07-09','12:10:00',6.58),('8975','2013-07-09','12:15:00',6.59),('8975','2013-07-09','12:20:00',6.59),('8975','2013-07-09','12:25:00',6.5),('8975','2013-07-09','12:30:00',6.6),('8975','2013-07-09','12:35:00',6.63),('8975','2013-07-09','12:40:00',6.65),('8975','2013-07-09','12:45:00',6.53),('8975','2013-07-09','12:50:00',6.64),('8975','2013-07-09','12:55:00',6.69),('8975','2013-07-09','13:00:00',6.61),('8975','2013-07-09','13:05:00',6.59),('8975','2013-07-09','13:10:00',6.56),('8975','2013-07-09','13:15:00',6.53),('8975','2013-07-09','13:20:00',6.53),('8975','2013-07-09','13:25:00',6.51),('8975','2013-07-09','13:30:00',6.49),('8975','2013-07-09','13:35:00',6.5),('8975','2013-07-09','13:40:00',6.5),('8975','2013-07-09','13:45:00',6.46),('8975','2013-07-09','13:50:00',6.45),('8975','2013-07-09','13:55:00',6.39),('8975','2013-07-09','14:00:00',6.34),('8975','2013-07-09','14:05:00',6.3),('8975','2013-07-09','14:10:00',6.18),('8975','2013-07-09','14:15:00',6.2),('8975','2013-07-09','14:20:00',6.18),('8975','2013-07-09','14:25:00',5.82),('8975','2013-07-09','14:30:00',5.98),('8975','2013-07-09','14:35:00',5.46),('8975','2013-07-09','14:40:00',5.42),('8975','2013-07-09','14:45:00',5.8),('8975','2013-07-09','14:50:00',5.68),('8975','2013-07-09','14:55:00',5.51),('8975','2013-07-09','15:00:00',5.16),('8975','2013-07-09','15:05:00',4.42),('8975','2013-07-09','15:10:00',5.09),('8975','2013-07-09','15:15:00',5.46),('8975','2013-07-09','15:20:00',5.39),('8975','2013-07-09','15:25:00',5.33),('8975','2013-07-09','15:30:00',5.26),('8975','2013-07-09','15:35:00',5.15),('8975','2013-07-09','15:40:00',5.03),('8975','2013-07-09','15:45:00',4.91),('8975','2013-07-09','15:50:00',4.83),('8975','2013-07-09','15:55:00',4.71),('8975','2013-07-09','16:00:00',4.63),('8975','2013-07-09','16:05:00',4.53),('8975','2013-07-09','16:10:00',4.42),('8975','2013-07-09','16:15:00',4.34),('8975','2013-07-09','16:20:00',4.21),('8975','2013-07-09','16:25:00',4.1),('8975','2013-07-09','16:30:00',4),('8975','2013-07-09','16:35:00',3.88),('8975','2013-07-09','16:40:00',3.77),('8975','2013-07-09','16:45:00',3.68),('8975','2013-07-09','16:50:00',3.58),('8975','2013-07-09','16:55:00',3.47),('8975','2013-07-09','17:00:00',3.41),('8975','2013-07-09','17:05:00',3.48),('8975','2013-07-09','17:10:00',2.17),('8975','2013-07-09','17:15:00',2.84),('8975','2013-07-09','17:20:00',3.12),('8975','2013-07-09','17:25:00',2.23),('8975','2013-07-09','17:35:00',1.23),('8975','2013-07-09','17:40:00',2.24),('8975','2013-07-09','17:45:00',1.72),('8975','2013-07-09','17:50:00',2.23),('8975','2013-07-09','17:55:00',2.04),('8975','2013-07-09','18:00:00',2.04),('8975','2013-07-09','18:05:00',1.69),('8975','2013-07-09','18:10:00',1.68),('8975','2013-07-09','18:15:00',1.78),('8975','2013-07-09','18:20:00',1.4),('8975','2013-07-09','18:25:00',1.4),('8975','2013-07-09','19:10:00',1.08),('8975','2013-07-09','19:15:00',1.05),('8975','2013-07-08','06:45:00',1.16),('8975','2013-07-08','06:50:00',1.32),('8975','2013-07-08','06:55:00',1.28),('8975','2013-07-08','07:00:00',1.76),('8975','2013-07-08','07:05:00',1.98),('8975','2013-07-08','07:10:00',2.1),('8975','2013-07-08','07:15:00',2.24),('8975','2013-07-08','07:20:00',2.32),('8975','2013-07-08','07:25:00',2.33),('8975','2013-07-08','07:30:00',2.53),('8975','2013-07-08','07:35:00',2.76),('8975','2013-07-08','07:40:00',2.9),('8975','2013-07-08','07:45:00',3),('8975','2013-07-08','07:50:00',3.07),('8975','2013-07-08','07:55:00',3.22),('8975','2013-07-08','08:00:00',3.37),('8975','2013-07-08','08:05:00',3.45),('8975','2013-07-08','08:10:00',3.57),('8975','2013-07-08','08:15:00',3.67),('8975','2013-07-08','08:20:00',3.75),('8975','2013-07-08','08:25:00',3.84),('8975','2013-07-08','08:30:00',3.94),('8975','2013-07-08','08:35:00',4.04),('8975','2013-07-08','08:40:00',4.17),('8975','2013-07-08','08:45:00',4.24),('8975','2013-07-08','08:50:00',4.33),('8975','2013-07-08','08:55:00',4.44),('8975','2013-07-08','09:00:00',4.54),('8975','2013-07-08','09:05:00',4.63),('8975','2013-07-08','09:10:00',4.71),('8975','2013-07-08','09:15:00',4.81),('8975','2013-07-08','09:20:00',4.92),('8975','2013-07-08','09:25:00',5),('8975','2013-07-08','09:30:00',5.06),('8975','2013-07-08','09:35:00',5.13),('8975','2013-07-08','09:40:00',5.15),('8975','2013-07-08','09:45:00',5.25),('8975','2013-07-08','09:50:00',5.37),('8975','2013-07-08','09:55:00',5.43),('8975','2013-07-08','10:00:00',5.52),('8975','2013-07-08','10:05:00',5.54),('8975','2013-07-08','10:10:00',5.6),('8975','2013-07-08','10:15:00',5.53),('8975','2013-07-08','10:20:00',5.63),('8975','2013-07-08','10:25:00',5.82),('8975','2013-07-08','10:30:00',5.89),('8975','2013-07-08','10:35:00',5.93),('8975','2013-07-08','10:40:00',5.98),('8975','2013-07-08','10:45:00',6),('8975','2013-07-08','10:50:00',6.05),('8975','2013-07-08','10:55:00',6.13),('8975','2013-07-08','11:00:00',6.3),('8975','2013-07-08','11:05:00',6.36),('8975','2013-07-08','11:10:00',5.9),('8975','2013-07-08','11:15:00',6.47),('8975','2013-07-08','11:20:00',6.24),('8975','2013-07-08','11:25:00',4.09),('8975','2013-07-08','11:30:00',3.91),('8975','2013-07-08','11:35:00',3.85),('8975','2013-07-08','11:40:00',4.24),('8975','2013-07-08','11:45:00',5.13),('8975','2013-07-08','11:50:00',6.85),('8975','2013-07-08','11:55:00',6.95),('8975','2013-07-08','12:00:00',7.21),('8975','2013-07-08','12:05:00',6.58),('8975','2013-07-08','12:10:00',6.09),('8975','2013-07-08','12:15:00',6.63),('8975','2013-07-08','12:20:00',6.59),('8975','2013-07-08','12:25:00',6.51),('8975','2013-07-08','12:30:00',6.51),('8975','2013-07-08','12:35:00',6.46),('8975','2013-07-08','12:40:00',6.46),('8975','2013-07-08','12:45:00',6.45),('8975','2013-07-08','12:50:00',6.46),('8975','2013-07-08','12:55:00',6.37),('8975','2013-07-08','13:00:00',6.27),('8975','2013-07-08','13:05:00',6.56),('8975','2013-07-08','13:10:00',6.66),('8975','2013-07-08','13:15:00',6.71),('8975','2013-07-08','13:20:00',6.61),('8975','2013-07-08','13:25:00',6.62),('8975','2013-07-08','13:30:00',6.79),('8975','2013-07-08','13:35:00',6.28),('8975','2013-07-08','13:40:00',5.81),('8975','2013-07-08','13:45:00',5.81),('8975','2013-07-08','13:50:00',5.2),('8975','2013-07-08','13:55:00',4.62),('8975','2013-07-08','14:00:00',4.63),('8975','2013-07-08','14:05:00',4.59),('8975','2013-07-08','14:10:00',4.79),('8975','2013-07-08','14:15:00',5.14),('8975','2013-07-08','14:20:00',5.69),('8975','2013-07-08','14:25:00',5.93),('8975','2013-07-08','14:30:00',3.78),('8975','2013-07-08','14:35:00',2.05),('8975','2013-07-08','14:40:00',1.59),('8975','2013-07-08','14:45:00',1.31),('8975','2013-07-07','07:00:00',1.49),('8975','2013-07-07','07:05:00',1.08),('8975','2013-07-07','07:10:00',1.34),('8975','2013-07-07','07:15:00',1.55),('8975','2013-07-07','07:20:00',1.38),('8975','2013-07-07','07:35:00',1.48),('8975','2013-07-07','07:40:00',2.51),('8975','2013-07-07','07:45:00',3.4),('8975','2013-07-07','07:50:00',2.91),('8975','2013-07-07','07:55:00',3.13),('8975','2013-07-07','08:00:00',3.2),('8975','2013-07-07','08:05:00',2.87),('8975','2013-07-07','08:10:00',3.26),('8975','2013-07-07','08:15:00',3.62),('8975','2013-07-07','08:20:00',3.81),('8975','2013-07-07','08:25:00',3.88),('8975','2013-07-07','08:30:00',3.96),('8975','2013-07-07','08:35:00',4.03),('8975','2013-07-07','08:40:00',4.12),('8975','2013-07-07','08:45:00',4.24),('8975','2013-07-07','08:50:00',4.33),('8975','2013-07-07','08:55:00',4.41),('8975','2013-07-07','09:00:00',4.51),('8975','2013-07-07','09:05:00',4.61),('8975','2013-07-07','09:10:00',4.73),('8975','2013-07-07','09:15:00',4.79),('8975','2013-07-07','09:20:00',4.94),('8975','2013-07-07','09:25:00',4.95),('8975','2013-07-07','09:30:00',4.86),('8975','2013-07-07','09:35:00',5.2),('8975','2013-07-07','09:40:00',5.31),('8975','2013-07-07','09:45:00',5.48),('8975','2013-07-07','09:50:00',5.53),('8975','2013-07-07','09:55:00',5.63),('8975','2013-07-07','10:00:00',5.72),('8975','2013-07-07','10:05:00',5.74),('8975','2013-07-07','10:10:00',5.73),('8975','2013-07-07','10:15:00',5.88),('8975','2013-07-07','10:20:00',5.94),('8975','2013-07-07','10:25:00',6),('8975','2013-07-07','10:30:00',6.03),('8975','2013-07-07','10:35:00',6.1),('8975','2013-07-07','10:40:00',6.13),('8975','2013-07-07','10:45:00',6.18),('8975','2013-07-07','10:50:00',6.21),('8975','2013-07-07','10:55:00',6.23),('8975','2013-07-07','11:00:00',6.29),('8975','2013-07-07','11:05:00',6.39),('8975','2013-07-07','11:10:00',6.44),('8975','2013-07-07','11:15:00',6.2),('8975','2013-07-07','11:20:00',6.16),('8975','2013-07-07','11:25:00',6.23),('8975','2013-07-07','11:30:00',6.64),('8975','2013-07-07','11:35:00',6.66),('8975','2013-07-07','11:40:00',6.69),('8975','2013-07-07','11:45:00',6.66),('8975','2013-07-07','11:50:00',6.7),('8975','2013-07-07','11:55:00',6.72),('8975','2013-07-07','12:00:00',6.5),('8975','2013-07-07','12:05:00',6.77),('8975','2013-07-07','12:10:00',3.2),('8975','2013-07-07','12:15:00',3.02),('8975','2013-07-07','12:20:00',3.3),('8975','2013-07-07','12:25:00',3.53),('8975','2013-07-07','12:30:00',3.71),('8975','2013-07-07','12:35:00',6.34),('8975','2013-07-07','12:40:00',6.93),('8975','2013-07-07','12:45:00',6.8),('8975','2013-07-07','12:50:00',6.82),('8975','2013-07-07','12:55:00',4.84),('8975','2013-07-07','13:00:00',6.38),('8975','2013-07-07','13:05:00',2.97),('8975','2013-07-07','13:10:00',5.47),('8975','2013-07-07','13:15:00',7.95),('8975','2013-07-07','13:20:00',7.91),('8975','2013-07-07','13:25:00',5.16),('8975','2013-07-07','13:30:00',1.38),('8975','2013-07-07','13:35:00',1.01),('8975','2013-07-07','14:05:00',1.07),('8975','2013-07-07','14:10:00',1.18),('8975','2013-07-07','14:15:00',1.29),('8975','2013-07-07','14:20:00',1.3),('8975','2013-07-07','14:25:00',1.34),('8975','2013-07-07','14:30:00',1.44),('8975','2013-07-07','14:35:00',1.64),('8975','2013-07-07','14:40:00',1.72),('8975','2013-07-07','14:45:00',1.62),('8975','2013-07-07','14:50:00',1.52),('8975','2013-07-07','14:55:00',1.48),('8975','2013-07-07','15:00:00',1.39),('8975','2013-07-07','15:05:00',1.25),('8975','2013-07-07','15:10:00',1.12),('8975','2013-07-07','15:15:00',1.04),('8975','2013-07-07','17:20:00',1.05),('8975','2013-07-07','17:25:00',1.29),('8975','2013-07-07','17:30:00',1.51),('8975','2013-07-07','17:35:00',1.62),('8975','2013-07-07','17:40:00',1.65),('8975','2013-07-07','17:45:00',1.63),('8975','2013-07-07','17:50:00',1.61),('8975','2013-07-07','17:55:00',1.54),('8975','2013-07-07','18:00:00',1.44),('8975','2013-07-07','18:05:00',1.32),('8975','2013-07-07','18:10:00',1.26),('8975','2013-07-07','18:15:00',1.24),('8975','2013-07-07','18:20:00',1.28),('8975','2013-07-07','18:25:00',1.22),('8975','2013-07-07','18:30:00',1.2),('8975','2013-07-07','18:35:00',1.22),('8975','2013-07-07','18:40:00',1.16),('8975','2013-07-07','18:45:00',1.42),('8975','2013-07-07','18:50:00',1.51),('8975','2013-07-07','18:55:00',1.34),('8975','2013-07-07','19:00:00',1.18),('8975','2013-07-07','19:05:00',1.03),('8975','2013-07-06','06:25:00',1),('8975','2013-07-06','06:30:00',1.24),('8975','2013-07-06','06:35:00',1.41),('8975','2013-07-06','06:40:00',1.59),('8975','2013-07-06','06:45:00',1.75),('8975','2013-07-06','06:50:00',1.89),('8975','2013-07-06','06:55:00',2.04),('8975','2013-07-06','07:00:00',2.18),('8975','2013-07-06','07:05:00',2.31),('8975','2013-07-06','07:10:00',2.44),('8975','2013-07-06','07:15:00',2.57),('8975','2013-07-06','07:20:00',2.7),('8975','2013-07-06','07:25:00',2.84),('8975','2013-07-06','07:30:00',2.95),('8975','2013-07-06','07:35:00',3.04),('8975','2013-07-06','07:40:00',3.17),('8975','2013-07-06','07:45:00',3.28),('8975','2013-07-06','07:50:00',3.38),('8975','2013-07-06','07:55:00',3.49),('8975','2013-07-06','08:00:00',3.59),('8975','2013-07-06','08:05:00',3.68),('8975','2013-07-06','08:10:00',3.82),('8975','2013-07-06','08:15:00',3.87),('8975','2013-07-06','08:20:00',2.98),('8975','2013-07-06','08:25:00',3.05),('8975','2013-07-06','08:30:00',3.17),('8975','2013-07-06','08:35:00',4.02),('8975','2013-07-06','08:40:00',3.8),('8975','2013-07-06','08:45:00',3.33),('8975','2013-07-06','08:50:00',1.78),('8975','2013-07-06','08:55:00',4.95),('8975','2013-07-06','09:00:00',5.24),('8975','2013-07-06','09:05:00',5.24),('8975','2013-07-06','09:10:00',5.04),('8975','2013-07-06','09:15:00',4.8),('8975','2013-07-06','09:20:00',2.92),('8975','2013-07-06','09:25:00',2.84),('8975','2013-07-06','09:30:00',5.06),('8975','2013-07-06','09:35:00',5.55),('8975','2013-07-06','09:40:00',5.49),('8975','2013-07-06','09:45:00',5.3),('8975','2013-07-06','09:50:00',5.9),('8975','2013-07-06','09:55:00',5.79),('8975','2013-07-06','10:00:00',5.81),('8975','2013-07-06','10:05:00',5.58),('8975','2013-07-06','10:10:00',6.14),('8975','2013-07-06','10:15:00',6.02),('8975','2013-07-06','10:20:00',5.26),('8975','2013-07-06','10:25:00',5.49),('8975','2013-07-06','10:30:00',5.27),('8975','2013-07-06','10:35:00',5.91),('8975','2013-07-06','10:40:00',6.35),('8975','2013-07-06','10:45:00',5.65),('8975','2013-07-06','10:50:00',6.28),('8975','2013-07-06','10:55:00',6.33),('8975','2013-07-06','11:00:00',6.34),('8975','2013-07-06','11:05:00',6.41),('8975','2013-07-06','11:10:00',6.6),('8975','2013-07-06','11:15:00',6.69),('8975','2013-07-06','11:20:00',6.43),('8975','2013-07-06','11:25:00',6.1),('8975','2013-07-06','11:30:00',5.46),('8975','2013-07-06','11:35:00',5.84),('8975','2013-07-06','11:40:00',5.45),('8975','2013-07-06','11:45:00',5.88),('8975','2013-07-06','11:50:00',4.6),('8975','2013-07-06','11:55:00',3.99),('8975','2013-07-06','12:00:00',3.06),('8975','2013-07-06','12:05:00',5.6),('8975','2013-07-06','12:10:00',6.17),('8975','2013-07-06','12:15:00',6.74),('8975','2013-07-06','12:20:00',7.11),('8975','2013-07-06','12:25:00',6.42),('8975','2013-07-06','12:30:00',6.22),('8975','2013-07-06','12:35:00',6.12),('8975','2013-07-06','12:40:00',5.64),('8975','2013-07-06','12:45:00',5.77),('8975','2013-07-06','12:50:00',6.08),('8975','2013-07-06','12:55:00',5.67),('8975','2013-07-06','13:00:00',6.29),('8975','2013-07-06','13:05:00',5.99),('8975','2013-07-06','13:10:00',5.75),('8975','2013-07-06','13:15:00',5.48),('8975','2013-07-06','13:20:00',5.2),('8975','2013-07-06','13:25:00',6.27),('8975','2013-07-06','13:30:00',6.28),('8975','2013-07-06','13:35:00',6.66),('8975','2013-07-06','13:40:00',6.73),('8975','2013-07-06','13:45:00',7.01),('8975','2013-07-06','13:50:00',7.28),('8975','2013-07-06','13:55:00',4.71),('8975','2013-07-06','14:00:00',4.11),('8975','2013-07-06','14:05:00',2.45),('8975','2013-07-06','14:10:00',2.91),('8975','2013-07-06','14:15:00',2.71),('8975','2013-07-06','14:20:00',1.53),('8975','2013-07-06','14:25:00',1.12),('8975','2013-07-06','14:30:00',1.06),('8975','2013-07-06','14:35:00',1.11),('8975','2013-07-06','14:40:00',1.1),('8975','2013-07-06','14:45:00',1.09),('8975','2013-07-06','14:50:00',1.11),('8975','2013-07-06','14:55:00',1.2),('8975','2013-07-06','15:00:00',1.42),('8975','2013-07-06','15:05:00',1.52),('8975','2013-07-06','15:10:00',1.3),('8975','2013-07-06','15:15:00',1.06),('8975','2013-07-06','15:20:00',1.07),('8975','2013-07-06','15:25:00',1.07),('8975','2013-07-06','16:50:00',1.14),('8975','2013-07-06','16:55:00',1.31),('8975','2013-07-06','17:00:00',1.46),('8975','2013-07-06','17:05:00',1.55),('8975','2013-07-06','17:10:00',1.6),('8975','2013-07-06','17:15:00',1.62),('8975','2013-07-06','17:20:00',1.61),('8975','2013-07-06','17:25:00',1.55),('8975','2013-07-06','17:30:00',1.49),('8975','2013-07-06','17:35:00',1.42),('8975','2013-07-06','17:40:00',1.37),('8975','2013-07-06','17:45:00',1.33),('8975','2013-07-06','17:50:00',1.31),('8975','2013-07-06','17:55:00',1.27),('8975','2013-07-06','18:00:00',1.27),('8975','2013-07-06','18:05:00',1.25),('8975','2013-07-06','18:10:00',1.22),('8975','2013-07-06','18:15:00',1.22),('8975','2013-07-06','18:20:00',1.23),('8975','2013-07-06','18:25:00',1.19),('8975','2013-07-06','18:30:00',1.12),('8975','2013-07-06','18:35:00',1.04),('8975','2013-07-05','06:30:00',1.11),('8975','2013-07-05','06:35:00',1.26),('8975','2013-07-05','06:40:00',1.41),('8975','2013-07-05','06:45:00',1.57),('8975','2013-07-05','06:50:00',1.71),('8975','2013-07-05','06:55:00',1.87),('8975','2013-07-05','07:00:00',2.02),('8975','2013-07-05','07:05:00',2.16),('8975','2013-07-05','07:10:00',2.29),('8975','2013-07-05','07:15:00',2.42),('8975','2013-07-05','07:20:00',2.54),('8975','2013-07-05','07:25:00',2.67),('8975','2013-07-05','07:30:00',2.8),('8975','2013-07-05','07:35:00',2.91),('8975','2013-07-05','07:40:00',3.02),('8975','2013-07-05','07:45:00',3.14),('8975','2013-07-05','07:50:00',3.24),('8975','2013-07-05','07:55:00',3.36),('8975','2013-07-05','08:00:00',3.45),('8975','2013-07-05','08:05:00',3.54),('8975','2013-07-05','08:10:00',3.65),('8975','2013-07-05','08:15:00',3.76),('8975','2013-07-05','08:20:00',3.87),('8975','2013-07-05','08:25:00',3.98),('8975','2013-07-05','08:30:00',4.11),('8975','2013-07-05','08:35:00',4.24),('8975','2013-07-05','08:40:00',4.34),('8975','2013-07-05','08:45:00',4.44),('8975','2013-07-05','08:50:00',4.53),('8975','2013-07-05','08:55:00',4.6),('8975','2013-07-05','09:00:00',4.69),('8975','2013-07-05','09:05:00',4.78),('8975','2013-07-05','09:10:00',4.91),('8975','2013-07-05','09:15:00',4.97),('8975','2013-07-05','09:20:00',5.06),('8975','2013-07-05','09:25:00',5.13),('8975','2013-07-05','09:30:00',5.21),('8975','2013-07-05','09:35:00',5.28),('8975','2013-07-05','09:40:00',5.35),('8975','2013-07-05','09:45:00',5.44),('8975','2013-07-05','09:50:00',5.53),('8975','2013-07-05','09:55:00',5.64),('8975','2013-07-05','10:00:00',5.69),('8975','2013-07-05','10:05:00',5.72),('8975','2013-07-05','10:10:00',5.82),('8975','2013-07-05','10:15:00',5.86),('8975','2013-07-05','10:20:00',5.93),('8975','2013-07-05','10:25:00',5.96),('8975','2013-07-05','10:30:00',5.97),('8975','2013-07-05','10:35:00',6.02),('8975','2013-07-05','10:40:00',6.06),('8975','2013-07-05','10:45:00',6.14),('8975','2013-07-05','10:50:00',6.23),('8975','2013-07-05','10:55:00',6.33),('8975','2013-07-05','11:00:00',5.77),('8975','2013-07-05','11:05:00',5.71),('8975','2013-07-05','11:10:00',6.48),('8975','2013-07-05','11:15:00',5.68),('8975','2013-07-05','11:20:00',5.93),('8975','2013-07-05','11:25:00',5.99),('8975','2013-07-05','11:30:00',5.72),('8975','2013-07-05','11:35:00',6.27),('8975','2013-07-05','11:40:00',6.2),('8975','2013-07-05','11:45:00',6.56),('8975','2013-07-05','11:50:00',6.61),('8975','2013-07-05','11:55:00',6.65),('8975','2013-07-05','12:00:00',6.69),('8975','2013-07-05','12:05:00',6.73),('8975','2013-07-05','12:10:00',6.87),('8975','2013-07-05','12:15:00',6.82),('8975','2013-07-05','12:20:00',7.01),('8975','2013-07-05','12:25:00',7.17),('8975','2013-07-05','12:30:00',7.08),('8975','2013-07-05','12:35:00',6.89),('8975','2013-07-05','12:40:00',6.88),('8975','2013-07-05','12:45:00',6.84),('8975','2013-07-05','12:50:00',6.76),('8975','2013-07-05','12:55:00',6.72),('8975','2013-07-05','13:00:00',6.77),('8975','2013-07-05','13:05:00',6.77),('8975','2013-07-05','13:10:00',6.77),('8975','2013-07-05','13:15:00',6.77),('8975','2013-07-05','13:20:00',6.7),('8975','2013-07-05','13:25:00',6.61),('8975','2013-07-05','13:30:00',6.56),('8975','2013-07-05','13:35:00',6.5),('8975','2013-07-05','13:40:00',6.54),('8975','2013-07-05','13:45:00',6.49),('8975','2013-07-05','13:50:00',6.37),('8975','2013-07-05','13:55:00',6.33),('8975','2013-07-05','14:00:00',6.4),('8975','2013-07-05','14:05:00',6.3),('8975','2013-07-05','14:10:00',6.14),('8975','2013-07-05','14:15:00',6.38),('8975','2013-07-05','14:20:00',3.79),('8975','2013-07-05','14:25:00',2.85),('8975','2013-07-05','14:30:00',6.28),('8975','2013-07-05','14:35:00',6.1),('8975','2013-07-05','14:40:00',5.55),('8975','2013-07-05','14:45:00',4.25),('8975','2013-07-05','14:50:00',5.95),('8975','2013-07-05','14:55:00',6.02),('8975','2013-07-05','15:00:00',5.62),('8975','2013-07-05','15:05:00',1.42),('8975','2013-07-05','15:10:00',2.87),('8975','2013-07-05','15:15:00',5.36),('8975','2013-07-05','15:20:00',5.65),('8975','2013-07-05','15:25:00',5.46),('8975','2013-07-05','15:30:00',5.47),('8975','2013-07-05','15:35:00',3.73),('8975','2013-07-05','15:40:00',1.64),('8975','2013-07-05','16:45:00',1.07),('8975','2013-07-05','16:50:00',2.01),('8975','2013-07-05','16:55:00',2.04),('8975','2013-07-05','17:00:00',1.56),('8975','2013-07-05','17:05:00',1.65),('8975','2013-07-05','17:10:00',1.56),('8975','2013-07-05','17:15:00',1.55),('8975','2013-07-05','17:20:00',2.15),('8975','2013-07-05','17:25:00',1.94),('8975','2013-07-05','17:30:00',1.64),('8975','2013-07-05','17:35:00',1.69),('8975','2013-07-05','17:40:00',1.7),('8975','2013-07-05','17:45:00',1.49),('8975','2013-07-05','17:50:00',1.2),('8975','2013-07-05','17:55:00',1.13),('8975','2013-07-05','18:00:00',1.06),('8975','2013-07-05','18:05:00',1.01),('8975','2013-07-04','06:30:00',1.09),('8975','2013-07-04','06:35:00',1.21),('8975','2013-07-04','06:40:00',1.34),('8975','2013-07-04','06:45:00',1.39),('8975','2013-07-04','06:50:00',1.65),('8975','2013-07-04','06:55:00',1.87),('8975','2013-07-04','07:00:00',2.02),('8975','2013-07-04','07:05:00',2.15),('8975','2013-07-04','07:10:00',2.29),('8975','2013-07-04','07:15:00',2.4),('8975','2013-07-04','07:20:00',2.54),('8975','2013-07-04','07:25:00',2.71),('8975','2013-07-04','07:30:00',2.79),('8975','2013-07-04','07:35:00',2.91),('8975','2013-07-04','07:40:00',3.07),('8975','2013-07-04','07:45:00',3.18),('8975','2013-07-04','07:50:00',3.29),('8975','2013-07-04','07:55:00',3.38),('8975','2013-07-04','08:00:00',3.45),('8975','2013-07-04','08:05:00',3.56),('8975','2013-07-04','08:10:00',3.66),('8975','2013-07-04','08:15:00',3.79),('8975','2013-07-04','08:20:00',3.94),('8975','2013-07-04','08:25:00',4),('8975','2013-07-04','08:30:00',4.07),('8975','2013-07-04','08:35:00',4.13),('8975','2013-07-04','08:40:00',4.24),('8975','2013-07-04','08:45:00',4.33),('8975','2013-07-04','08:50:00',4.41),('8975','2013-07-04','08:55:00',4.52),('8975','2013-07-04','09:00:00',4.65),('8975','2013-07-04','09:05:00',4.74),('8975','2013-07-04','09:10:00',4.86),('8975','2013-07-04','09:15:00',4.98),('8975','2013-07-04','09:20:00',5.09),('8975','2013-07-04','09:25:00',5.15),('8975','2013-07-04','09:30:00',5.2),('8975','2013-07-04','09:35:00',5.24),('8975','2013-07-04','09:40:00',5.34),('8975','2013-07-04','09:45:00',5.42),('8975','2013-07-04','09:50:00',5.46),('8975','2013-07-04','09:55:00',5.56),('8975','2013-07-04','10:00:00',5.65),('8975','2013-07-04','10:05:00',5.73),('8975','2013-07-04','10:10:00',5.77),('8975','2013-07-04','10:15:00',5.84),('8975','2013-07-04','10:20:00',5.86),('8975','2013-07-04','10:25:00',5.91),('8975','2013-07-04','10:30:00',5.96),('8975','2013-07-04','10:35:00',6.02),('8975','2013-07-04','10:40:00',6.07),('8975','2013-07-04','10:45:00',6.1),('8975','2013-07-04','10:50:00',6.16),('8975','2013-07-04','10:55:00',6.2),('8975','2013-07-04','11:00:00',6.22),('8975','2013-07-04','11:05:00',6.19),('8975','2013-07-04','11:10:00',6.21),('8975','2013-07-04','11:15:00',6.3),('8975','2013-07-04','11:20:00',6.31),('8975','2013-07-04','11:25:00',6.34),('8975','2013-07-04','11:30:00',6.38),('8975','2013-07-04','11:35:00',6.47),('8975','2013-07-04','11:40:00',6.47),('8975','2013-07-04','11:45:00',6.53),('8975','2013-07-04','11:50:00',6.54),('8975','2013-07-04','11:55:00',6.61),('8975','2013-07-04','12:00:00',6.54),('8975','2013-07-04','12:05:00',6.51),('8975','2013-07-04','12:10:00',6.56),('8975','2013-07-04','12:15:00',6.6),('8975','2013-07-04','12:20:00',6.6),('8975','2013-07-04','12:25:00',6.8),('8975','2013-07-04','12:30:00',6.81),('8975','2013-07-04','12:35:00',6.71),('8975','2013-07-04','12:40:00',6.73),('8975','2013-07-04','12:45:00',6.66),('8975','2013-07-04','12:50:00',6.7),('8975','2013-07-04','12:55:00',6.68),('8975','2013-07-04','13:00:00',6.71),('8975','2013-07-04','13:05:00',3.01),('8975','2013-07-04','13:10:00',2.66),('8975','2013-07-04','13:15:00',4.84),('8975','2013-07-04','13:20:00',7.01),('8975','2013-07-04','13:25:00',6.3),('8975','2013-07-04','13:30:00',4.72),('8975','2013-07-04','13:35:00',6.12),('8975','2013-07-04','13:40:00',5.62),('8975','2013-07-04','13:45:00',6.6),('8975','2013-07-04','13:50:00',6.54),('8975','2013-07-04','13:55:00',6.31),('8975','2013-07-04','14:00:00',6.42),('8975','2013-07-04','14:05:00',6.53),('8975','2013-07-04','14:10:00',6.46),('8975','2013-07-04','14:15:00',6.21),('8975','2013-07-04','14:20:00',6.21),('8975','2013-07-04','14:25:00',6.16),('8975','2013-07-04','14:30:00',6.06),('8975','2013-07-04','14:35:00',6.05),('8975','2013-07-04','14:40:00',6),('8975','2013-07-04','14:45:00',5.39),('8975','2013-07-04','14:50:00',1.67),('8975','2013-07-04','14:55:00',5.2),('8975','2013-07-04','15:00:00',5.26),('8975','2013-07-04','15:05:00',3.64),('8975','2013-07-04','15:10:00',2.38),('8975','2013-07-04','15:15:00',5.2),('8975','2013-07-04','15:20:00',5.07),('8975','2013-07-04','15:25:00',3.86),('8975','2013-07-04','15:30:00',3.61),('8975','2013-07-04','15:35:00',3.71),('8975','2013-07-04','15:40:00',4.91),('8975','2013-07-04','15:45:00',4.06),('8975','2013-07-04','15:50:00',4.97),('8975','2013-07-04','15:55:00',3.08),('8975','2013-07-04','16:00:00',4.26),('8975','2013-07-04','16:05:00',4.59),('8975','2013-07-04','16:10:00',4.53),('8975','2013-07-04','16:15:00',4.24),('8975','2013-07-04','16:20:00',4.17),('8975','2013-07-04','16:25:00',4.08),('8975','2013-07-04','16:30:00',4),('8975','2013-07-04','16:35:00',3.94),('8975','2013-07-04','16:40:00',3.8),('8975','2013-07-04','16:45:00',3.76),('8975','2013-07-04','16:50:00',3.61),('8975','2013-07-04','16:55:00',3.4),('8975','2013-07-04','17:00:00',3.29),('8975','2013-07-04','17:05:00',3.19),('8975','2013-07-04','17:10:00',3.12),('8975','2013-07-04','17:15:00',3.09),('8975','2013-07-04','17:20:00',2.99),('8975','2013-07-04','17:25:00',2.82),('8975','2013-07-04','17:30:00',2.7),('8975','2013-07-04','17:35:00',2.55),('8975','2013-07-04','17:40:00',2.38),('8975','2013-07-04','17:45:00',2.23),('8975','2013-07-04','17:50:00',2.06),('8975','2013-07-04','17:55:00',2),('8975','2013-07-04','18:00:00',1.98),('8975','2013-07-04','18:05:00',1.92),('8975','2013-07-04','18:10:00',1.74),('8975','2013-07-04','18:15:00',1.6),('8975','2013-07-04','18:20:00',1.37),('8975','2013-07-04','18:25:00',1.29),('8975','2013-07-04','18:35:00',1.27),('8975','2013-07-04','18:40:00',1.26),('8975','2013-07-04','18:45:00',1.22),('8975','2013-07-04','18:50:00',1.16),('8975','2013-07-04','18:55:00',1.08),('8975','2013-07-04','19:00:00',1.03),('8975','2013-07-03','08:50:00',1.2),('8975','2013-07-03','08:55:00',1.48),('8975','2013-07-03','09:00:00',1.44),('8975','2013-07-03','09:05:00',1.22),('8975','2013-07-03','09:10:00',1.04),('8975','2013-07-03','09:15:00',1.07),('8975','2013-07-03','09:20:00',1.08),('8975','2013-07-03','09:25:00',1.21),('8975','2013-07-03','09:30:00',1.28),('8975','2013-07-03','09:35:00',1.21),('8975','2013-07-03','09:40:00',1.01),('8975','2013-07-03','10:15:00',1.08),('8975','2013-07-03','10:20:00',1.18),('8975','2013-07-03','10:25:00',1.21),('8975','2013-07-03','10:30:00',1.23),('8975','2013-07-03','10:35:00',1.25),('8975','2013-07-03','10:40:00',1.19),('8975','2013-07-03','10:45:00',1.02),('8975','2013-07-03','10:55:00',1.03),('8975','2013-07-03','11:00:00',1.29),('8975','2013-07-03','11:05:00',1.48),('8975','2013-07-03','11:10:00',1.62),('8975','2013-07-03','11:15:00',1.72),('8975','2013-07-03','11:20:00',1.73),('8975','2013-07-03','11:25:00',1.94),('8975','2013-07-03','11:30:00',2.21),('8975','2013-07-03','11:35:00',2.49),('8975','2013-07-03','11:40:00',2.76),('8975','2013-07-03','11:45:00',2.82),('8975','2013-07-03','11:50:00',2.68),('8975','2013-07-03','11:55:00',2.46),('8975','2013-07-03','12:00:00',2.5),('8975','2013-07-03','12:05:00',2.83),('8975','2013-07-03','12:10:00',2.88),('8975','2013-07-03','12:15:00',3.44),('8975','2013-07-03','12:20:00',5.78),('8975','2013-07-03','12:25:00',7.31),('8975','2013-07-03','12:30:00',5.58),('8975','2013-07-03','12:35:00',4.28),('8975','2013-07-03','12:40:00',4.05),('8975','2013-07-03','12:45:00',2.91),('8975','2013-07-03','12:50:00',2.09),('8975','2013-07-03','12:55:00',1.79),('8975','2013-07-03','13:00:00',2.17),('8975','2013-07-03','13:05:00',3.28),('8975','2013-07-03','13:10:00',4.65),('8975','2013-07-03','13:15:00',6.29),('8975','2013-07-03','13:20:00',5.06),('8975','2013-07-03','13:25:00',4.99),('8975','2013-07-03','13:30:00',5.22),('8975','2013-07-03','13:35:00',5.58),('8975','2013-07-03','13:40:00',7.61),('8975','2013-07-03','13:45:00',8.19),('8975','2013-07-03','13:50:00',7.81),('8975','2013-07-03','13:55:00',6.96),('8975','2013-07-03','14:00:00',4.99),('8975','2013-07-03','14:05:00',3.65),('8975','2013-07-03','14:10:00',3.63),('8975','2013-07-03','14:15:00',4.09),('8975','2013-07-03','14:20:00',4.06),('8975','2013-07-03','14:25:00',3.36),('8975','2013-07-03','14:30:00',3.35),('8975','2013-07-03','14:35:00',3.51),('8975','2013-07-03','14:40:00',3.58),('8975','2013-07-03','14:45:00',3.45),('8975','2013-07-03','14:50:00',3.36),('8975','2013-07-03','14:55:00',3.46),('8975','2013-07-03','15:00:00',2.79),('8975','2013-07-03','15:05:00',4.49),('8975','2013-07-03','15:10:00',3.84),('8975','2013-07-03','15:15:00',3.67),('8975','2013-07-03','15:20:00',4.62),('8975','2013-07-03','15:25:00',5.83),('8975','2013-07-03','15:30:00',4.66),('8975','2013-07-03','15:35:00',6.01),('8975','2013-07-03','15:40:00',3.57),('8975','2013-07-03','15:45:00',3.19),('8975','2013-07-03','15:50:00',3.36),('8975','2013-07-03','15:55:00',2.82),('8975','2013-07-03','16:00:00',2.96),('8975','2013-07-03','16:05:00',3.54),('8975','2013-07-03','16:10:00',3.3),('8975','2013-07-03','16:15:00',2.9),('8975','2013-07-03','16:20:00',3.01),('8975','2013-07-03','16:25:00',3.95),('8975','2013-07-03','16:30:00',4.23),('8975','2013-07-03','16:35:00',2.9),('8975','2013-07-03','16:40:00',2.79),('8975','2013-07-03','16:45:00',2.49),('8975','2013-07-03','16:50:00',2.93),('8975','2013-07-03','16:55:00',2.27),('8975','2013-07-03','17:00:00',2),('8975','2013-07-03','17:05:00',1.91),('8975','2013-07-03','17:10:00',2.09),('8975','2013-07-03','17:15:00',3.12),('8975','2013-07-03','17:20:00',2.16),('8975','2013-07-03','17:25:00',2.64),('8975','2013-07-03','17:30:00',1.77),('8975','2013-07-03','17:35:00',2.14),('8975','2013-07-03','17:40:00',3.07),('8975','2013-07-03','17:45:00',2.92),('8975','2013-07-03','17:50:00',2.85),('8975','2013-07-03','17:55:00',2.77),('8975','2013-07-03','18:00:00',2.66),('8975','2013-07-03','18:05:00',2.53),('8975','2013-07-03','18:10:00',2.41),('8975','2013-07-03','18:15:00',2.38),('8975','2013-07-03','18:20:00',2.26),('8975','2013-07-03','18:25:00',2.19),('8975','2013-07-03','18:30:00',1.77),('8975','2013-07-03','18:35:00',1.43),('8975','2013-07-03','18:40:00',1.07),('8975','2013-07-02','06:20:00',1.01),('8975','2013-07-02','06:25:00',1.18),('8975','2013-07-02','06:30:00',1.33),('8975','2013-07-02','06:35:00',1.48),('8975','2013-07-02','06:40:00',1.61),('8975','2013-07-02','06:45:00',1.76),('8975','2013-07-02','06:50:00',1.93),('8975','2013-07-02','06:55:00',2.09),('8975','2013-07-02','07:00:00',2.23),('8975','2013-07-02','07:05:00',2.36),('8975','2013-07-02','07:10:00',2.5),('8975','2013-07-02','07:15:00',2.64),('8975','2013-07-02','07:20:00',2.77),('8975','2013-07-02','07:25:00',2.9),('8975','2013-07-02','07:30:00',3.02),('8975','2013-07-02','07:35:00',3.15),('8975','2013-07-02','07:40:00',3.26),('8975','2013-07-02','07:45:00',3.35),('8975','2013-07-02','07:50:00',3.45),('8975','2013-07-02','07:55:00',3.57),('8975','2013-07-02','08:00:00',3.6),('8975','2013-07-02','08:05:00',3.72),('8975','2013-07-02','08:10:00',3.86),('8975','2013-07-02','08:15:00',3.96),('8975','2013-07-02','08:20:00',4.05),('8975','2013-07-02','08:25:00',4.17),('8975','2013-07-02','08:30:00',4.26),('8975','2013-07-02','08:35:00',4.33),('8975','2013-07-02','08:40:00',4.43),('8975','2013-07-02','08:45:00',4.53),('8975','2013-07-02','08:50:00',4.62),('8975','2013-07-02','08:55:00',4.74),('8975','2013-07-02','09:00:00',4.81),('8975','2013-07-02','09:05:00',4.83),('8975','2013-07-02','09:10:00',4.93),('8975','2013-07-02','09:15:00',5),('8975','2013-07-02','09:20:00',5.09),('8975','2013-07-02','09:25:00',5.19),('8975','2013-07-02','09:30:00',5.2),('8975','2013-07-02','09:35:00',5.27),('8975','2013-07-02','09:40:00',5.38),('8975','2013-07-02','09:45:00',5.42),('8975','2013-07-02','09:50:00',5.53),('8975','2013-07-02','09:55:00',5.49),('8975','2013-07-02','10:00:00',5.56),('8975','2013-07-02','10:05:00',5.64),('8975','2013-07-02','10:10:00',5.68),('8975','2013-07-02','10:15:00',5.68),('8975','2013-07-02','10:20:00',5.77),('8975','2013-07-02','10:25:00',5.83),('8975','2013-07-02','10:30:00',5.9),('8975','2013-07-02','10:35:00',5.99),('8975','2013-07-02','10:40:00',6.08),('8975','2013-07-02','10:45:00',6.05),('8975','2013-07-02','10:50:00',6.2),('8975','2013-07-02','10:55:00',6.33),('8975','2013-07-02','11:00:00',6.34),('8975','2013-07-02','11:05:00',6.38),('8975','2013-07-02','11:10:00',6.4),('8975','2013-07-02','11:15:00',6.44),('8975','2013-07-02','11:20:00',6.47),('8975','2013-07-02','11:25:00',6.48),('8975','2013-07-02','11:30:00',6.51),('8975','2013-07-02','11:35:00',6.55),('8975','2013-07-02','11:40:00',6.6),('8975','2013-07-02','11:45:00',6.69),('8975','2013-07-02','11:50:00',6.55),('8975','2013-07-02','11:55:00',6.65),('8975','2013-07-02','12:00:00',6.65),('8975','2013-07-02','12:05:00',6.7),('8975','2013-07-02','12:10:00',6.74),('8975','2013-07-02','12:15:00',6.72),('8975','2013-07-02','12:20:00',6.76),('8975','2013-07-02','12:25:00',6.76),('8975','2013-07-02','12:30:00',6.73),('8975','2013-07-02','12:35:00',6.73),('8975','2013-07-02','12:40:00',6.78),('8975','2013-07-02','12:45:00',6.83),('8975','2013-07-02','12:50:00',6.83),('8975','2013-07-02','12:55:00',6.82),('8975','2013-07-02','13:00:00',6.8),('8975','2013-07-02','13:05:00',6.73),('8975','2013-07-02','13:10:00',6.7),('8975','2013-07-02','13:15:00',5.86),('8975','2013-07-02','13:20:00',5.75),('8975','2013-07-02','13:25:00',6.47),('8975','2013-07-02','13:30:00',6.24),('8975','2013-07-02','13:35:00',6.31),('8975','2013-07-02','13:40:00',6.36),('8975','2013-07-02','13:45:00',6),('8975','2013-07-02','13:50:00',5.63),('8975','2013-07-02','13:55:00',5.75),('8975','2013-07-02','14:00:00',5.71),('8975','2013-07-02','14:05:00',6.2),('8975','2013-07-02','14:10:00',6.3),('8975','2013-07-02','14:15:00',6.26),('8975','2013-07-02','14:20:00',6.23),('8975','2013-07-02','14:25:00',6.18),('8975','2013-07-02','14:30:00',6.12),('8975','2013-07-02','14:35:00',6.03),('8975','2013-07-02','14:40:00',6.01),('8975','2013-07-02','14:45:00',5.93),('8975','2013-07-02','14:50:00',5.89),('8975','2013-07-02','14:55:00',5.8),('8975','2013-07-02','15:00:00',5.73),('8975','2013-07-02','15:05:00',5.64),('8975','2013-07-02','15:10:00',5.58),('8975','2013-07-02','15:15:00',5.51),('8975','2013-07-02','15:20:00',5.43),('8975','2013-07-02','15:25:00',5.32),('8975','2013-07-02','15:30:00',5.24),('8975','2013-07-02','15:35:00',5.14),('8975','2013-07-02','15:40:00',5.04),('8975','2013-07-02','15:45:00',4.94),('8975','2013-07-02','15:50:00',4.83),('8975','2013-07-02','15:55:00',4.75),('8975','2013-07-02','16:00:00',4.64),('8975','2013-07-02','16:05:00',4.51),('8975','2013-07-02','16:10:00',4.44),('8975','2013-07-02','16:15:00',4.34),('8975','2013-07-02','16:20:00',4.24),('8975','2013-07-02','16:25:00',4.14),('8975','2013-07-02','16:30:00',4.03),('8975','2013-07-02','16:35:00',3.92),('8975','2013-07-02','16:40:00',3.79),('8975','2013-07-02','16:45:00',3.68),('8975','2013-07-02','16:50:00',3.56),('8975','2013-07-02','16:55:00',3.45),('8975','2013-07-02','17:00:00',3.33),('8975','2013-07-02','17:05:00',3.21),('8975','2013-07-02','17:10:00',3.1),('8975','2013-07-02','17:15:00',2.97),('8975','2013-07-02','17:20:00',2.85),('8975','2013-07-02','17:25:00',2.73),('8975','2013-07-02','17:30:00',2.62),('8975','2013-07-02','17:35:00',2.5),('8975','2013-07-02','17:40:00',2.4),('8975','2013-07-02','17:45:00',2.29),('8975','2013-07-02','17:50:00',2.18),('8975','2013-07-02','17:55:00',2.07),('8975','2013-07-02','18:00:00',1.97),('8975','2013-07-02','18:05:00',1.88),('8975','2013-07-02','18:10:00',1.79),('8975','2013-07-02','18:15:00',1.7),('8975','2013-07-02','18:20:00',1.62),('8975','2013-07-02','18:25:00',1.55),('8975','2013-07-02','18:30:00',1.48),('8975','2013-07-02','18:35:00',1.42),('8975','2013-07-02','18:40:00',1.37),('8975','2013-07-02','18:45:00',1.32),('8975','2013-07-02','18:50:00',1.26),('8975','2013-07-02','18:55:00',1.23),('8975','2013-07-02','19:00:00',1.18),('8975','2013-07-02','19:05:00',1.11),('8975','2013-07-02','19:10:00',1.06),('8975','2013-07-02','19:15:00',1.02),('8975','2013-07-01','06:30:00',1.15),('8975','2013-07-01','06:35:00',1.32),('8975','2013-07-01','06:40:00',1.47),('8975','2013-07-01','06:45:00',1.64),('8975','2013-07-01','06:50:00',1.8),('8975','2013-07-01','06:55:00',1.95),('8975','2013-07-01','07:00:00',2.1),('8975','2013-07-01','07:05:00',2.24),('8975','2013-07-01','07:10:00',2.38),('8975','2013-07-01','07:15:00',2.52),('8975','2013-07-01','07:20:00',2.64),('8975','2013-07-01','07:25:00',2.77),('8975','2013-07-01','07:30:00',2.88),('8975','2013-07-01','07:35:00',3.01),('8975','2013-07-01','07:40:00',3.12),('8975','2013-07-01','07:45:00',3.22),('8975','2013-07-01','07:50:00',3.33),('8975','2013-07-01','07:55:00',3.44),('8975','2013-07-01','08:00:00',3.55),('8975','2013-07-01','08:05:00',3.66),('8975','2013-07-01','08:10:00',3.76),('8975','2013-07-01','08:15:00',3.85),('8975','2013-07-01','08:20:00',3.96),('8975','2013-07-01','08:25:00',4.09),('8975','2013-07-01','08:30:00',4.19),('8975','2013-07-01','08:35:00',4.3),('8975','2013-07-01','08:40:00',4.4),('8975','2013-07-01','08:45:00',4.49),('8975','2013-07-01','08:50:00',4.57),('8975','2013-07-01','08:55:00',4.67),('8975','2013-07-01','09:00:00',4.77),('8975','2013-07-01','09:05:00',4.87),('8975','2013-07-01','09:10:00',4.93),('8975','2013-07-01','09:15:00',5.01),('8975','2013-07-01','09:20:00',5.1),('8975','2013-07-01','09:25:00',5.17),('8975','2013-07-01','09:30:00',5.21),('8975','2013-07-01','09:35:00',5.32),('8975','2013-07-01','09:40:00',5.37),('8975','2013-07-01','09:45:00',5.42),('8975','2013-07-01','09:50:00',5.45),('8975','2013-07-01','09:55:00',5.52),('8975','2013-07-01','10:00:00',5.61),('8975','2013-07-01','10:05:00',5.68),('8975','2013-07-01','10:10:00',5.69),('8975','2013-07-01','10:15:00',5.78),('8975','2013-07-01','10:20:00',5.87),('8975','2013-07-01','10:25:00',5.92),('8975','2013-07-01','10:30:00',5.94),('8975','2013-07-01','10:35:00',6.01),('8975','2013-07-01','10:40:00',6.06),('8975','2013-07-01','10:45:00',6.1),('8975','2013-07-01','10:50:00',6.12),('8975','2013-07-01','10:55:00',6.15),('8975','2013-07-01','11:00:00',6.14),('8975','2013-07-01','11:05:00',6.18),('8975','2013-07-01','11:10:00',6.28),('8975','2013-07-01','11:15:00',6.19),('8975','2013-07-01','11:20:00',6.22),('8975','2013-07-01','11:25:00',6.28),('8975','2013-07-01','11:30:00',6.27),('8975','2013-07-01','11:35:00',6.21),('8975','2013-07-01','11:40:00',6.28),('8975','2013-07-01','11:45:00',6.21),('8975','2013-07-01','11:50:00',6.24),('8975','2013-07-01','11:55:00',6.19),('8975','2013-07-01','12:00:00',6.23),('8975','2013-07-01','12:05:00',6.33),('8975','2013-07-01','12:10:00',6.35),('8975','2013-07-01','12:15:00',6.34),('8975','2013-07-01','12:20:00',6.42),('8975','2013-07-01','12:25:00',6.45),('8975','2013-07-01','12:30:00',2.84),('8975','2013-07-01','12:35:00',3.53),('8975','2013-07-01','12:40:00',6.94),('8975','2013-07-01','12:45:00',2.05),('8975','2013-07-01','12:50:00',1.65),('8975','2013-07-01','12:55:00',1.45),('8975','2013-07-01','13:00:00',1.33),('8975','2013-07-01','13:05:00',1.26),('8975','2013-07-01','13:10:00',1.47),('8975','2013-07-01','13:15:00',5.76),('8975','2013-07-01','13:20:00',7.01),('8975','2013-07-01','13:25:00',6.77),('8975','2013-07-01','13:30:00',6.58),('8975','2013-07-01','13:35:00',6.46),('8975','2013-07-01','13:40:00',6.55),('8975','2013-07-01','13:45:00',6.36),('8975','2013-07-01','13:50:00',6.12),('8975','2013-07-01','13:55:00',6.27),('8975','2013-07-01','14:00:00',6.21),('8975','2013-07-01','14:05:00',6.28),('8975','2013-07-01','14:10:00',6.12),('8975','2013-07-01','14:15:00',6.12),('8975','2013-07-01','14:20:00',6.06),('8975','2013-07-01','14:25:00',6.03),('8975','2013-07-01','14:30:00',6),('8975','2013-07-01','14:35:00',5.91),('8975','2013-07-01','14:40:00',5.85),('8975','2013-07-01','14:45:00',5.82),('8975','2013-07-01','14:50:00',5.75),('8975','2013-07-01','14:55:00',5.65),('8975','2013-07-01','15:00:00',5.59),('8975','2013-07-01','15:05:00',5.54),('8975','2013-07-01','15:10:00',5.45),('8975','2013-07-01','15:15:00',5.38),('8975','2013-07-01','15:20:00',5.3),('8975','2013-07-01','15:25:00',5.24),('8975','2013-07-01','15:30:00',5.15),('8975','2013-07-01','15:35:00',5.06),('8975','2013-07-01','15:40:00',4.97),('8975','2013-07-01','15:45:00',4.86),('8975','2013-07-01','15:50:00',4.76),('8975','2013-07-01','15:55:00',4.68),('8975','2013-07-01','16:00:00',4.6),('8975','2013-07-01','16:05:00',4.49),('8975','2013-07-01','16:10:00',4.38),('8975','2013-07-01','16:15:00',4.27),('8975','2013-07-01','16:20:00',4.16),('8975','2013-07-01','16:25:00',4.05),('8975','2013-07-01','16:30:00',3.97),('8975','2013-07-01','16:35:00',3.86),('8975','2013-07-01','16:40:00',3.75),('8975','2013-07-01','16:45:00',3.64),('8975','2013-07-01','16:50:00',3.53),('8975','2013-07-01','16:55:00',3.39),('8975','2013-07-01','17:00:00',3.28),('8975','2013-07-01','17:05:00',3.16),('8975','2013-07-01','17:10:00',3.03),('8975','2013-07-01','17:15:00',2.92),('8975','2013-07-01','17:20:00',2.81),('8975','2013-07-01','17:25:00',2.67),('8975','2013-07-01','17:30:00',2.39),('8975','2013-07-01','17:35:00',2.29),('8975','2013-07-01','17:40:00',2.09),('8975','2013-07-01','17:45:00',2.02),('8975','2013-07-01','17:50:00',1.79),('8975','2013-07-01','17:55:00',1.9),('8975','2013-07-01','18:00:00',1.71),('8975','2013-07-01','18:05:00',1.77),('8975','2013-07-01','18:10:00',1.6),('8975','2013-07-01','18:15:00',1.37),('8975','2013-07-01','18:20:00',1.47),('8975','2013-07-01','18:25:00',1.42),('8975','2013-07-01','18:30:00',1.16),('8975','2013-07-01','18:35:00',1.29),('8975','2013-07-01','18:40:00',1.26),('8975','2013-07-01','18:45:00',1.27),('8975','2013-07-01','18:50:00',1.21),('8975','2013-07-01','18:55:00',1.16),('8975','2013-07-01','19:00:00',1.1),('8975','2013-07-01','19:05:00',1.06),('8975','2013-07-01','19:10:00',1.01),('8975','2013-06-30','06:30:00',1.14),('8975','2013-06-30','06:35:00',1.25),('8975','2013-06-30','06:40:00',1.43),('8975','2013-06-30','06:45:00',1.58),('8975','2013-06-30','06:50:00',1.76),('8975','2013-06-30','06:55:00',1.88),('8975','2013-06-30','07:00:00',2.05),('8975','2013-06-30','07:05:00',2.17),('8975','2013-06-30','07:10:00',2.34),('8975','2013-06-30','07:15:00',2.53),('8975','2013-06-30','07:20:00',2.63),('8975','2013-06-30','07:25:00',2.74),('8975','2013-06-30','07:30:00',2.89),('8975','2013-06-30','07:35:00',3),('8975','2013-06-30','07:40:00',3.1),('8975','2013-06-30','07:45:00',3.21),('8975','2013-06-30','07:50:00',3.34),('8975','2013-06-30','07:55:00',3.48),('8975','2013-06-30','08:00:00',3.6),('8975','2013-06-30','08:05:00',3.7),('8975','2013-06-30','08:10:00',3.81),('8975','2013-06-30','08:15:00',3.91),('8975','2013-06-30','08:20:00',4.01),('8975','2013-06-30','08:25:00',4.15),('8975','2013-06-30','08:30:00',4.27),('8975','2013-06-30','08:35:00',4.39),('8975','2013-06-30','08:40:00',4.54),('8975','2013-06-30','08:45:00',4.64),('8975','2013-06-30','08:50:00',4.71),('8975','2013-06-30','08:55:00',4.78),('8975','2013-06-30','09:00:00',4.88),('8975','2013-06-30','09:05:00',4.98),('8975','2013-06-30','09:10:00',5.05),('8975','2013-06-30','09:15:00',5.11),('8975','2013-06-30','09:20:00',5.22),('8975','2013-06-30','09:25:00',5.26),('8975','2013-06-30','09:30:00',5.38),('8975','2013-06-30','09:35:00',5.45),('8975','2013-06-30','09:40:00',5.53),('8975','2013-06-30','09:45:00',5.61),('8975','2013-06-30','09:50:00',5.66),('8975','2013-06-30','09:55:00',5.71),('8975','2013-06-30','10:00:00',5.8),('8975','2013-06-30','10:05:00',5.88),('8975','2013-06-30','10:10:00',5.94),('8975','2013-06-30','10:15:00',6.03),('8975','2013-06-30','10:20:00',6.08),('8975','2013-06-30','10:25:00',6.13),('8975','2013-06-30','10:30:00',6.19),('8975','2013-06-30','10:35:00',6.23),('8975','2013-06-30','10:40:00',6.27),('8975','2013-06-30','10:45:00',6.31),('8975','2013-06-30','10:50:00',6.36),('8975','2013-06-30','10:55:00',6.41),('8975','2013-06-30','11:00:00',6.47),('8975','2013-06-30','11:05:00',6.45),('8975','2013-06-30','11:10:00',6.46),('8975','2013-06-30','11:15:00',6.52),('8975','2013-06-30','11:20:00',6.45),('8975','2013-06-30','11:25:00',6.55),('8975','2013-06-30','11:30:00',6.6),('8975','2013-06-30','11:35:00',6.67),('8975','2013-06-30','11:40:00',6.76),('8975','2013-06-30','11:45:00',6.75),('8975','2013-06-30','11:50:00',6.77),('8975','2013-06-30','11:55:00',6.77),('8975','2013-06-30','12:00:00',6.76),('8975','2013-06-30','12:05:00',6.73),('8975','2013-06-30','12:10:00',6.79),('8975','2013-06-30','12:15:00',6.8),('8975','2013-06-30','12:20:00',6.86),('8975','2013-06-30','12:25:00',6.87),('8975','2013-06-30','12:30:00',6.86),('8975','2013-06-30','12:35:00',6.84),('8975','2013-06-30','12:40:00',6.85),('8975','2013-06-30','12:45:00',6.81),('8975','2013-06-30','12:50:00',6.77),('8975','2013-06-30','12:55:00',6.75),('8975','2013-06-30','13:00:00',6.7),('8975','2013-06-30','13:05:00',6.64),('8975','2013-06-30','13:10:00',6.62),('8975','2013-06-30','13:15:00',6.58),('8975','2013-06-30','13:20:00',6.34),('8975','2013-06-30','13:25:00',6.66),('8975','2013-06-30','13:30:00',6.64),('8975','2013-06-30','13:35:00',6.6),('8975','2013-06-30','13:40:00',6.49),('8975','2013-06-30','13:45:00',6.29),('8975','2013-06-30','13:50:00',6.39),('8975','2013-06-30','13:55:00',6.42),('8975','2013-06-30','14:00:00',6.34),('8975','2013-06-30','14:05:00',6.38),('8975','2013-06-30','14:10:00',6.32),('8975','2013-06-30','14:15:00',6.29),('8975','2013-06-30','14:20:00',6.28),('8975','2013-06-30','14:25:00',6.17),('8975','2013-06-30','14:30:00',6.07),('8975','2013-06-30','14:35:00',6),('8975','2013-06-30','14:40:00',5.99),('8975','2013-06-30','14:45:00',5.89),('8975','2013-06-30','14:50:00',5.77),('8975','2013-06-30','14:55:00',5.68),('8975','2013-06-30','15:00:00',5.6),('8975','2013-06-30','15:05:00',5.56),('8975','2013-06-30','15:10:00',5.47),('8975','2013-06-30','15:15:00',5.44),('8975','2013-06-30','15:20:00',5.33),('8975','2013-06-30','15:25:00',5.27),('8975','2013-06-30','15:30:00',5.16),('8975','2013-06-30','15:35:00',5.02),('8975','2013-06-30','15:40:00',4.94),('8975','2013-06-30','15:45:00',4.87),('8975','2013-06-30','15:50:00',4.78),('8975','2013-06-30','15:55:00',4.67),('8975','2013-06-30','16:00:00',4.56),('8975','2013-06-30','16:05:00',4.48),('8975','2013-06-30','16:10:00',4.38),('8975','2013-06-30','16:15:00',4.24),('8975','2013-06-30','16:20:00',4.13),('8975','2013-06-30','16:25:00',4),('8975','2013-06-30','16:30:00',3.93),('8975','2013-06-30','16:35:00',3.82),('8975','2013-06-30','16:40:00',3.71),('8975','2013-06-30','16:45:00',3.6),('8975','2013-06-30','16:50:00',3.5),('8975','2013-06-30','16:55:00',3.39),('8975','2013-06-30','17:00:00',3.27),('8975','2013-06-30','17:05:00',3.14),('8975','2013-06-30','17:10:00',3.04),('8975','2013-06-30','17:15:00',2.91),('8975','2013-06-30','17:20:00',2.81),('8975','2013-06-30','17:25:00',2.67),('8975','2013-06-30','17:30:00',2.56),('8975','2013-06-30','17:35:00',2.46),('8975','2013-06-30','17:40:00',2.34),('8975','2013-06-30','17:45:00',2.26),('8975','2013-06-30','17:50:00',2.15),('8975','2013-06-30','17:55:00',1.98),('8975','2013-06-30','18:00:00',1.85),('8975','2013-06-30','18:05:00',1.85),('8975','2013-06-30','18:10:00',1.74),('8975','2013-06-30','18:15:00',1.43),('8975','2013-06-30','18:20:00',1.42),('8975','2013-06-30','18:25:00',1.59),('8975','2013-06-30','18:30:00',1.54),('8975','2013-06-30','18:35:00',1.46),('8975','2013-06-30','18:40:00',1.34),('8975','2013-06-30','18:45:00',1.28),('8975','2013-06-30','18:50:00',1.22),('8975','2013-06-30','18:55:00',1.14),('8975','2013-06-30','19:00:00',1.11),('8975','2013-06-30','19:05:00',1.04),('8975','2014-04-04','08:40:00',1.05),('8975','2014-04-04','08:55:00',1.03),('8975','2014-04-04','09:00:00',1.12),('8975','2014-04-04','09:05:00',1.36),('8975','2014-04-04','09:10:00',1.7),('8975','2014-04-04','09:15:00',2.05),('8975','2014-04-04','09:20:00',2.69),('8975','2014-04-04','09:25:00',3.23),('8975','2014-04-04','09:30:00',6.56),('8975','2014-04-04','09:35:00',6.39),('8975','2014-04-04','09:40:00',5.81),('8975','2014-04-04','09:45:00',5.26),('8975','2014-04-04','09:50:00',5.32),('8975','2014-04-04','09:55:00',4.03),('8975','2014-04-04','10:00:00',4.28),('8975','2014-04-04','10:05:00',5.13),('8975','2014-04-04','10:10:00',3.01),('8975','2014-04-04','10:15:00',4.16),('8975','2014-04-04','10:20:00',4.96),('8975','2014-04-04','10:25:00',4.74),('8975','2014-04-04','10:30:00',4.32),('8975','2014-04-04','10:35:00',5.22),('8975','2014-04-04','10:40:00',5.45),('8975','2014-04-04','10:45:00',5.97),('8975','2014-04-04','10:50:00',5.18),('8975','2014-04-04','10:55:00',4.43),('8975','2014-04-04','11:00:00',5.07),('8975','2014-04-04','11:05:00',6.06),('8975','2014-04-04','11:10:00',6.57),('8975','2014-04-04','11:15:00',6.08),('8975','2014-04-04','11:20:00',6.7),('8975','2014-04-04','11:25:00',6.87),('8975','2014-04-04','11:30:00',4.71),('8975','2014-04-04','11:35:00',3.51),('8975','2014-04-04','11:40:00',4.65),('8975','2014-04-04','11:45:00',5.89),('8975','2014-04-04','11:50:00',6.51),('8975','2014-04-04','11:55:00',6.67),('8975','2014-04-04','12:00:00',6.12),('8975','2014-04-04','12:05:00',5.46),('8975','2014-04-04','12:10:00',4.61),('8975','2014-04-04','12:15:00',5.63),('8975','2014-04-04','12:20:00',5.8),('8975','2014-04-04','12:25:00',5.24),('8975','2014-04-04','12:30:00',4.26),('8975','2014-04-04','12:35:00',4.04),('8975','2014-04-04','12:40:00',5.37),('8975','2014-04-04','12:45:00',7.02),('8975','2014-04-04','12:50:00',7.6),('8975','2014-04-04','12:55:00',5.53),('8975','2014-04-04','13:00:00',5.85),('8975','2014-04-04','13:05:00',5.15),('8975','2014-04-04','13:10:00',2.86),('8975','2014-04-04','13:15:00',2.47),('8975','2014-04-04','13:20:00',2.19),('8975','2014-04-04','13:25:00',4.7),('8975','2014-04-04','13:30:00',6.26),('8975','2014-04-04','13:35:00',2.89),('8975','2014-04-04','13:40:00',4.26),('8975','2014-04-04','13:45:00',3.15),('8975','2014-04-04','13:50:00',3.28),('8975','2014-04-04','13:55:00',5.16),('8975','2014-04-04','14:00:00',3.97),('8975','2014-04-04','14:05:00',4.81),('8975','2014-04-04','14:10:00',6.96),('8975','2014-04-04','14:15:00',2.92),('8975','2014-04-04','14:20:00',1.62),('8975','2014-04-04','14:25:00',1.64),('8975','2014-04-04','14:30:00',2.86),('8975','2014-04-04','14:35:00',5.15),('8975','2014-04-04','14:40:00',1.64),('8975','2014-04-04','14:45:00',1.29),('8975','2014-04-04','14:50:00',1.02),('8975','2014-04-04','14:55:00',1.32),('8975','2014-04-04','15:00:00',5.73),('8975','2014-04-04','15:05:00',5.55),('8975','2014-04-04','15:10:00',5.68),('8975','2014-04-04','15:15:00',4.05),('8975','2014-04-04','15:20:00',5.3),('8975','2014-04-04','15:25:00',5.54),('8975','2014-04-04','15:30:00',4.87),('8975','2014-04-04','15:35:00',2.29),('8975','2014-04-04','15:40:00',3.77),('8975','2014-04-04','15:45:00',2.45),('8975','2014-04-04','15:50:00',2.53),('8975','2014-04-04','15:55:00',2.28),('8975','2014-04-04','16:00:00',2.03),('8975','2014-04-04','16:05:00',1.89),('8975','2014-04-04','16:10:00',1.76),('8975','2014-04-04','16:15:00',2.64),('8975','2014-04-04','16:20:00',4.56),('8975','2014-04-04','16:25:00',4.81),('8975','2014-04-04','16:30:00',3.72),('8975','2014-04-04','16:35:00',3.6),('8975','2014-04-04','16:40:00',3.3),('8975','2014-04-04','16:45:00',2.33),('8975','2014-04-04','16:50:00',2.01),('8975','2014-04-04','16:55:00',2.37),('8975','2014-04-04','17:00:00',1.95),('8975','2014-04-04','17:05:00',1.98),('8975','2014-04-04','17:10:00',1.98),('8975','2014-04-04','17:15:00',1.54),('8975','2014-04-04','17:20:00',1.39),('8975','2014-04-04','17:25:00',1.55),('8975','2014-04-04','17:30:00',1.6),('8975','2014-04-04','17:35:00',1.38),('8975','2014-04-04','17:40:00',1.08),('8975','2014-04-04','17:45:00',1.09),('8975','2014-04-04','17:50:00',1.14),('8975','2014-04-04','17:55:00',1.41),('8975','2014-04-04','18:00:00',1.51),('8975','2014-04-04','18:05:00',1.6),('8975','2014-04-04','18:10:00',1.59),('8975','2014-04-04','18:15:00',1.58),('8975','2014-04-04','18:20:00',1.51),('8975','2014-04-04','18:25:00',1.11),('8975','2013-06-29','06:20:00',1.14),('8975','2013-06-29','06:25:00',1.3),('8975','2013-06-29','06:30:00',1.43),('8975','2013-06-29','06:35:00',1.63),('8975','2013-06-29','06:40:00',1.82),('8975','2013-06-29','06:45:00',1.95),('8975','2013-06-29','06:50:00',2.08),('8975','2013-06-29','06:55:00',2.21),('8975','2013-06-29','07:00:00',2.34),('8975','2013-06-29','07:05:00',2.47),('8975','2013-06-29','07:10:00',2.6),('8975','2013-06-29','07:15:00',2.72),('8975','2013-06-29','07:20:00',2.85),('8975','2013-06-29','07:25:00',2.97),('8975','2013-06-29','07:30:00',3.07),('8975','2013-06-29','07:35:00',3.22),('8975','2013-06-29','07:40:00',3.32),('8975','2013-06-29','07:45:00',3.42),('8975','2013-06-29','07:50:00',3.55),('8975','2013-06-29','07:55:00',3.66),('8975','2013-06-29','08:00:00',3.76),('8975','2013-06-29','08:05:00',3.88),('8975','2013-06-29','08:10:00',3.99),('8975','2013-06-29','08:15:00',4.1),('8975','2013-06-29','08:20:00',4.21),('8975','2013-06-29','08:25:00',4.32),('8975','2013-06-29','08:30:00',4.4),('8975','2013-06-29','08:35:00',4.5),('8975','2013-06-29','08:40:00',4.62),('8975','2013-06-29','08:45:00',4.71),('8975','2013-06-29','08:50:00',4.81),('8975','2013-06-29','08:55:00',4.9),('8975','2013-06-29','09:00:00',4.99),('8975','2013-06-29','09:05:00',5.08),('8975','2013-06-29','09:10:00',5.17),('8975','2013-06-29','09:15:00',5.26),('8975','2013-06-29','09:20:00',5.35),('8975','2013-06-29','09:25:00',5.46),('8975','2013-06-29','09:30:00',5.53),('8975','2013-06-29','09:35:00',5.6),('8975','2013-06-29','09:40:00',5.69),('8975','2013-06-29','09:45:00',5.76),('8975','2013-06-29','09:50:00',5.84),('8975','2013-06-29','09:55:00',5.91),('8975','2013-06-29','10:00:00',5.99),('8975','2013-06-29','10:05:00',6.07),('8975','2013-06-29','10:10:00',6.12),('8975','2013-06-29','10:15:00',6.18),('8975','2013-06-29','10:20:00',6.21),('8975','2013-06-29','10:25:00',6.3),('8975','2013-06-29','10:30:00',6.36),('8975','2013-06-29','10:35:00',6.4),('8975','2013-06-29','10:40:00',6.49),('8975','2013-06-29','10:45:00',6.52),('8975','2013-06-29','10:50:00',6.52),('8975','2013-06-29','10:55:00',6.54),('8975','2013-06-29','11:00:00',6.56),('8975','2013-06-29','11:05:00',6.6),('8975','2013-06-29','11:10:00',6.63),('8975','2013-06-29','11:15:00',6.67),('8975','2013-06-29','11:20:00',6.7),('8975','2013-06-29','11:25:00',6.78),('8975','2013-06-29','11:30:00',6.82),('8975','2013-06-29','11:35:00',6.78),('8975','2013-06-29','11:40:00',6.76),('8975','2013-06-29','11:45:00',6.83),('8975','2013-06-29','11:50:00',6.86),('8975','2013-06-29','11:55:00',6.87),('8975','2013-06-29','12:00:00',6.9),('8975','2013-06-29','12:05:00',6.89),('8975','2013-06-29','12:10:00',6.92),('8975','2013-06-29','12:15:00',6.9),('8975','2013-06-29','12:20:00',6.95),('8975','2013-06-29','12:25:00',6.94),('8975','2013-06-29','12:30:00',6.97),('8975','2013-06-29','12:35:00',7),('8975','2013-06-29','12:40:00',6.96),('8975','2013-06-29','12:45:00',6.91),('8975','2013-06-29','12:50:00',6.84),('8975','2013-06-29','12:55:00',6.81),('8975','2013-06-29','13:00:00',6.85),('8975','2013-06-29','13:05:00',6.97),('8975','2013-06-29','13:10:00',6.99),('8975','2013-06-29','13:15:00',6.89),('8975','2013-06-29','13:20:00',6.83),('8975','2013-06-29','13:25:00',6.81),('8975','2013-06-29','13:30:00',6.77),('8975','2013-06-29','13:35:00',6.81),('8975','2013-06-29','13:40:00',6.79),('8975','2013-06-29','13:45:00',6.34),('8975','2013-06-29','13:50:00',6.27),('8975','2013-06-29','13:55:00',6.65),('8975','2013-06-29','14:00:00',6.63),('8975','2013-06-29','14:05:00',6.42),('8975','2013-06-29','14:10:00',6.35),('8975','2013-06-29','14:15:00',6.33),('8975','2013-06-29','14:20:00',6.28),('8975','2013-06-29','14:25:00',6.22),('8975','2013-06-29','14:30:00',6.14),('8975','2013-06-29','14:35:00',6.07),('8975','2013-06-29','14:40:00',5.98),('8975','2013-06-29','14:45:00',5.88),('8975','2013-06-29','14:50:00',5.86),('8975','2013-06-29','14:55:00',5.84),('8975','2013-06-29','15:00:00',5.78),('8975','2013-06-29','15:05:00',5.68),('8975','2013-06-29','15:10:00',5.65),('8975','2013-06-29','15:15:00',5.62),('8975','2013-06-29','15:20:00',5.54),('8975','2013-06-29','15:25:00',5.47),('8975','2013-06-29','15:30:00',5.43),('8975','2013-06-29','15:35:00',5.3),('8975','2013-06-29','15:40:00',5.22),('8975','2013-06-29','15:45:00',5.11),('8975','2013-06-29','15:50:00',5.02),('8975','2013-06-29','15:55:00',4.92),('8975','2013-06-29','16:00:00',4.78),('8975','2013-06-29','16:05:00',4.69),('8975','2013-06-29','16:10:00',4.68),('8975','2013-06-29','16:15:00',4.6),('8975','2013-06-29','16:20:00',4.51),('8975','2013-06-29','16:25:00',4.47),('8975','2013-06-29','16:30:00',4.59),('8975','2013-06-29','16:35:00',4.36),('8975','2013-06-29','16:40:00',3.96),('8975','2013-06-29','16:45:00',3.75),('8975','2013-06-29','16:50:00',3.64),('8975','2013-06-29','16:55:00',3.54),('8975','2013-06-29','17:00:00',3.4),('8975','2013-06-29','17:05:00',3.32),('8975','2013-06-29','17:10:00',3.25),('8975','2013-06-29','17:15:00',3.09),('8975','2013-06-29','17:20:00',2.91),('8975','2013-06-29','17:25:00',2.78),('8975','2013-06-29','17:30:00',2.64),('8975','2013-06-29','17:35:00',2.49),('8975','2013-06-29','17:40:00',2.4),('8975','2013-06-29','17:45:00',2.33),('8975','2013-06-29','17:50:00',2.27),('8975','2013-06-29','17:55:00',1.43),('8975','2013-06-29','18:00:00',1.76),('8975','2013-06-29','18:05:00',1.9),('8975','2013-06-29','18:10:00',1.83),('8975','2013-06-29','18:15:00',1.72),('8975','2013-06-29','18:20:00',1.66),('8975','2013-06-29','18:25:00',1.59),('8975','2013-06-29','18:30:00',1.51),('8975','2013-06-29','18:35:00',1.43),('8975','2013-06-29','18:40:00',1.37),('8975','2013-06-29','18:45:00',1.31),('8975','2013-06-29','18:50:00',1.27),('8975','2013-06-29','18:55:00',1.21),('8975','2013-06-29','19:00:00',1.16),('8975','2013-06-29','19:05:00',1.1),('8975','2013-06-29','19:10:00',1.05),('8975','2013-06-28','07:25:00',1.94),('8975','2013-06-28','07:30:00',3.33),('8975','2013-06-28','07:35:00',3.77),('8975','2013-06-28','07:40:00',3.89),('8975','2013-06-28','07:45:00',3.85),('8975','2013-06-28','07:50:00',3.91),('8975','2013-06-28','07:55:00',4.15),('8975','2013-06-28','08:00:00',4.5),('8975','2013-06-28','08:05:00',4.71),('8975','2013-06-28','08:10:00',4.88),('8975','2013-06-28','08:15:00',4.43),('8975','2013-06-28','08:20:00',4.73),('8975','2013-06-28','08:25:00',4.9),('8975','2013-06-28','08:30:00',4.73),('8975','2013-06-28','08:35:00',4.77),('8975','2013-06-28','08:40:00',3.54),('8975','2013-06-28','08:45:00',4.1),('8975','2013-06-28','08:50:00',4.91),('8975','2013-06-28','08:55:00',4.98),('8975','2013-06-28','09:00:00',5.07),('8975','2013-06-28','09:05:00',5.13),('8975','2013-06-28','09:10:00',5.19),('8975','2013-06-28','09:15:00',5.23),('8975','2013-06-28','09:20:00',5.3),('8975','2013-06-28','09:25:00',5.39),('8975','2013-06-28','09:30:00',5.47),('8975','2013-06-28','09:35:00',5.58),('8975','2013-06-28','09:40:00',5.67),('8975','2013-06-28','09:45:00',5.76),('8975','2013-06-28','09:50:00',5.83),('8975','2013-06-28','09:55:00',5.89),('8975','2013-06-28','10:00:00',5.94),('8975','2013-06-28','10:05:00',5.98),('8975','2013-06-28','10:10:00',6.06),('8975','2013-06-28','10:15:00',6.14),('8975','2013-06-28','10:20:00',6.14),('8975','2013-06-28','10:25:00',6.16),('8975','2013-06-28','10:30:00',6.29),('8975','2013-06-28','10:35:00',6.3),('8975','2013-06-28','10:40:00',6.36),('8975','2013-06-28','10:45:00',6.44),('8975','2013-06-28','10:50:00',6.47),('8975','2013-06-28','10:55:00',6.56),('8975','2013-06-28','11:00:00',6.6),('8975','2013-06-28','11:05:00',4.96),('8975','2013-06-28','11:10:00',6),('8975','2013-06-28','11:15:00',5.73),('8975','2013-06-28','11:20:00',7.24),('8975','2013-06-28','11:25:00',7.43),('8975','2013-06-28','11:30:00',7.57),('8975','2013-06-28','11:35:00',7.2),('8975','2013-06-28','11:40:00',2.25),('8975','2013-06-28','11:45:00',4.37),('8975','2013-06-28','11:50:00',7.35),('8975','2013-06-28','11:55:00',5.95),('8975','2013-06-28','12:00:00',4.07),('8975','2013-06-28','12:05:00',7.53),('8975','2013-06-28','12:10:00',7.44),('8975','2013-06-28','12:15:00',7.51),('8975','2013-06-28','12:20:00',7.62),('8975','2013-06-28','12:25:00',7.55),('8975','2013-06-28','12:30:00',7.05),('8975','2013-06-28','12:35:00',6.35),('8975','2013-06-28','12:40:00',3.44),('8975','2013-06-28','12:45:00',2.25),('8975','2013-06-28','12:50:00',7.2),('8975','2013-06-28','12:55:00',7.69),('8975','2013-06-28','13:00:00',7.34),('8975','2013-06-28','13:05:00',2.7),('8975','2013-06-28','13:10:00',3.28),('8975','2013-06-28','13:15:00',7.05),('8975','2013-06-28','13:20:00',4.53),('8975','2013-06-28','13:25:00',3.94),('8975','2013-06-28','13:30:00',5.27),('8975','2013-06-28','13:35:00',1.37),('8975','2013-06-28','13:40:00',1.22),('8975','2013-06-28','13:45:00',1.72),('8975','2013-06-28','13:50:00',2.41),('8975','2013-06-28','13:55:00',3.59),('8975','2013-06-28','14:00:00',7.86),('8975','2013-06-28','14:05:00',7.26),('8975','2013-06-28','14:10:00',7.15),('8975','2013-06-28','14:15:00',7.05),('8975','2013-06-28','14:20:00',7.18),('8975','2013-06-28','14:25:00',7.24),('8975','2013-06-28','14:30:00',7.16),('8975','2013-06-28','14:35:00',6.97),('8975','2013-06-28','14:40:00',6.82),('8975','2013-06-28','14:45:00',6.86),('8975','2013-06-28','14:50:00',7.09),('8975','2013-06-28','14:55:00',4.35),('8975','2013-06-28','15:00:00',4.19),('8975','2013-06-28','15:05:00',7.73),('8975','2013-06-28','15:10:00',3.98),('8975','2013-06-28','15:15:00',3.64),('8975','2013-06-28','15:20:00',2.58),('8975','2013-06-28','15:25:00',1.51),('8975','2013-06-28','15:45:00',1.24),('8975','2013-06-28','16:35:00',1.21),('8975','2013-06-28','16:40:00',1.68),('8975','2013-06-28','16:45:00',2.26),('8975','2013-06-28','16:50:00',2.65),('8975','2013-06-28','16:55:00',2.02),('8975','2013-06-28','17:00:00',1.99),('8975','2013-06-28','17:05:00',3.41),('8975','2013-06-28','17:10:00',2.08),('8975','2013-06-28','17:15:00',1.67),('8975','2013-06-28','17:20:00',2.05),('8975','2013-06-28','17:25:00',3.24),('8975','2013-06-28','17:30:00',3.27),('8975','2013-06-28','17:35:00',2.75),('8975','2013-06-28','17:40:00',1.27),('8975','2013-06-28','17:45:00',1.86),('8975','2013-06-28','17:50:00',1.98),('8975','2013-06-28','17:55:00',2.18),('8975','2013-06-28','18:00:00',2),('8975','2013-06-28','18:05:00',1.86),('8975','2013-06-28','18:10:00',1.22),('8975','2013-06-28','18:25:00',1.55),('8975','2013-06-28','18:30:00',1.38),('8975','2013-06-28','18:35:00',1.55),('8975','2013-06-28','18:40:00',1.61),('8975','2013-06-28','18:45:00',1.28),('8975','2013-06-28','19:10:00',1.2),('8975','2013-06-27','06:30:00',1.31),('8975','2013-06-27','06:35:00',1.5),('8975','2013-06-27','06:40:00',1.57),('8975','2013-06-27','07:05:00',2.1),('8975','2013-06-27','07:10:00',2.76),('8975','2013-06-27','07:15:00',2.56),('8975','2013-06-27','07:20:00',2.86),('8975','2013-06-27','07:25:00',3.09),('8975','2013-06-27','07:30:00',3.04),('8975','2013-06-27','07:35:00',3.16),('8975','2013-06-27','07:40:00',3.04),('8975','2013-06-27','07:45:00',3.5),('8975','2013-06-27','07:50:00',3.39),('8975','2013-06-27','07:55:00',3.67),('8975','2013-06-27','08:00:00',3.33),('8975','2013-06-27','08:05:00',3.25),('8975','2013-06-27','08:10:00',3.74),('8975','2013-06-27','08:15:00',3.94),('8975','2013-06-27','08:20:00',4.1),('8975','2013-06-27','08:25:00',3.73),('8975','2013-06-27','08:30:00',4.21),('8975','2013-06-27','08:35:00',4.19),('8975','2013-06-27','08:40:00',4.31),('8975','2013-06-27','08:45:00',4.51),('8975','2013-06-27','08:50:00',4.69),('8975','2013-06-27','08:55:00',4.21),('8975','2013-06-27','09:00:00',4.83),('8975','2013-06-27','09:05:00',4.84),('8975','2013-06-27','09:10:00',3.35),('8975','2013-06-27','09:15:00',3.12),('8975','2013-06-27','09:20:00',1.38),('8975','2013-06-27','09:25:00',5.83),('8975','2013-06-27','09:30:00',5.79),('8975','2013-06-27','09:35:00',5.98),('8975','2013-06-27','09:40:00',6.27),('8975','2013-06-27','09:45:00',3.56),('8975','2013-06-27','09:50:00',5.88),('8975','2013-06-27','09:55:00',5.05),('8975','2013-06-27','10:00:00',6.36),('8975','2013-06-27','10:05:00',6.62),('8975','2013-06-27','10:10:00',6.67),('8975','2013-06-27','10:15:00',4.5),('8975','2013-06-27','10:20:00',2.48),('8975','2013-06-27','10:25:00',4.35),('8975','2013-06-27','10:30:00',4.73),('8975','2013-06-27','10:35:00',2.81),('8975','2013-06-27','10:40:00',3.1),('8975','2013-06-27','10:45:00',5.75),('8975','2013-06-27','10:50:00',7.59),('8975','2013-06-27','10:55:00',5.15),('8975','2013-06-27','11:00:00',6.39),('8975','2013-06-27','11:05:00',5.63),('8975','2013-06-27','11:10:00',3.45),('8975','2013-06-27','11:15:00',2.66),('8975','2013-06-27','11:20:00',5.23),('8975','2013-06-27','11:25:00',6.14),('8975','2013-06-27','11:30:00',7.18),('8975','2013-06-27','11:35:00',7.27),('8975','2013-06-27','11:40:00',6.91),('8975','2013-06-27','11:45:00',6.42),('8975','2013-06-27','11:50:00',6.04),('8975','2013-06-27','11:55:00',6.44),('8975','2013-06-27','12:00:00',5.72),('8975','2013-06-27','12:05:00',4.16),('8975','2013-06-27','12:10:00',4.75),('8975','2013-06-27','12:15:00',3.26),('8975','2013-06-27','12:20:00',6.85),('8975','2013-06-27','12:25:00',7.35),('8975','2013-06-27','12:30:00',7.56),('8975','2013-06-27','12:35:00',7.35),('8975','2013-06-27','12:40:00',6.98),('8975','2013-06-27','12:45:00',7.14),('8975','2013-06-27','12:50:00',5.92),('8975','2013-06-27','12:55:00',4.48),('8975','2013-06-27','13:00:00',7.15),('8975','2013-06-27','13:05:00',6.61),('8975','2013-06-27','13:10:00',6.79),('8975','2013-06-27','13:15:00',6.82),('8975','2013-06-27','13:20:00',6.82),('8975','2013-06-27','13:25:00',5.14),('8975','2013-06-27','13:30:00',7),('8975','2013-06-27','13:35:00',6.92),('8975','2013-06-27','13:40:00',6.65),('8975','2013-06-27','13:45:00',6.1),('8975','2013-06-27','13:50:00',6.75),('8975','2013-06-27','13:55:00',5.39),('8975','2013-06-27','14:00:00',5.83),('8975','2013-06-27','14:05:00',6.38),('8975','2013-06-27','14:10:00',5.37),('8975','2013-06-27','14:15:00',6.12),('8975','2013-06-27','14:20:00',5.01),('8975','2013-06-27','14:25:00',6.3),('8975','2013-06-27','14:30:00',5.11),('8975','2013-06-27','14:35:00',6.34),('8975','2013-06-27','14:40:00',5.66),('8975','2013-06-27','14:45:00',6.54),('8975','2013-06-27','14:50:00',4.36),('8975','2013-06-27','14:55:00',6.07),('8975','2013-06-27','15:00:00',6.33),('8975','2013-06-27','15:05:00',5.48),('8975','2013-06-27','15:10:00',6.18),('8975','2013-06-27','15:15:00',3.69),('8975','2013-06-27','15:20:00',5.72),('8975','2013-06-27','15:25:00',5.82),('8975','2013-06-27','15:30:00',5.22),('8975','2013-06-27','15:35:00',5.72),('8975','2013-06-27','15:40:00',3.59),('8975','2013-06-27','15:45:00',4.54),('8975','2013-06-27','15:50:00',5.72),('8975','2013-06-27','15:55:00',4.89),('8975','2013-06-27','16:00:00',4.63),('8975','2013-06-27','16:05:00',3.27),('8975','2013-06-27','16:10:00',4.11),('8975','2013-06-27','16:15:00',3.41),('8975','2013-06-27','16:20:00',3.43),('8975','2013-06-27','16:25:00',3.53),('8975','2013-06-27','16:30:00',2.36),('8975','2013-06-27','16:35:00',3.52),('8975','2013-06-27','16:40:00',4.05),('8975','2013-06-27','16:45:00',3.91),('8975','2013-06-27','16:50:00',3.65),('8975','2013-06-27','16:55:00',3.54),('8975','2013-06-27','17:00:00',3.38),('8975','2013-06-27','17:05:00',3.27),('8975','2013-06-27','17:10:00',3.08),('8975','2013-06-27','17:15:00',2.99),('8975','2013-06-27','17:20:00',2.88),('8975','2013-06-27','17:25:00',2.87),('8975','2013-06-27','17:30:00',2.63),('8975','2013-06-27','17:35:00',2.52),('8975','2013-06-27','17:40:00',2.41),('8975','2013-06-27','17:45:00',2.32),('8975','2013-06-27','17:50:00',2.24),('8975','2013-06-27','17:55:00',2.12),('8975','2013-06-27','18:00:00',2),('8975','2013-06-27','18:05:00',1.9),('8975','2013-06-27','18:10:00',1.84),('8975','2013-06-27','18:15:00',1.88),('8975','2013-06-27','18:20:00',1.81),('8975','2013-06-27','18:25:00',1.61),('8975','2013-06-27','18:30:00',1.53),('8975','2013-06-27','18:35:00',1.27),('8975','2013-06-27','18:40:00',1.41),('8975','2013-06-27','18:45:00',1.33),('8975','2013-06-27','18:50:00',1.28),('8975','2013-06-27','18:55:00',1.18),('8975','2013-06-27','19:00:00',1.1),('8975','2013-06-27','19:05:00',1.11),('8975','2013-06-26','06:35:00',1.3),('8975','2013-06-26','06:40:00',1.1),('8975','2013-06-26','06:50:00',1.05),('8975','2013-06-26','07:20:00',2.79),('8975','2013-06-26','07:25:00',2.88),('8975','2013-06-26','07:30:00',3.02),('8975','2013-06-26','07:35:00',3.1),('8975','2013-06-26','07:40:00',3.25),('8975','2013-06-26','07:45:00',3.42),('8975','2013-06-26','07:50:00',3.56),('8975','2013-06-26','07:55:00',3.53),('8975','2013-06-26','08:00:00',3.67),('8975','2013-06-26','08:05:00',3.79),('8975','2013-06-26','08:10:00',3.84),('8975','2013-06-26','08:15:00',3.94),('8975','2013-06-26','08:20:00',3.57),('8975','2013-06-26','08:25:00',4.18),('8975','2013-06-26','08:30:00',4.33),('8975','2013-06-26','08:35:00',4.34),('8975','2013-06-26','08:40:00',4.46),('8975','2013-06-26','08:45:00',4.57),('8975','2013-06-26','08:50:00',4.65),('8975','2013-06-26','08:55:00',4.9),('8975','2013-06-26','09:00:00',5.04),('8975','2013-06-26','09:05:00',5),('8975','2013-06-26','09:10:00',5.16),('8975','2013-06-26','09:15:00',5.21),('8975','2013-06-26','09:20:00',5.71),('8975','2013-06-26','09:25:00',5.63),('8975','2013-06-26','09:30:00',5.52),('8975','2013-06-26','09:35:00',5.24),('8975','2013-06-26','09:40:00',5.74),('8975','2013-06-26','09:45:00',5.67),('8975','2013-06-26','09:50:00',5.76),('8975','2013-06-26','09:55:00',3.41),('8975','2013-06-26','10:00:00',2.4),('8975','2013-06-26','10:05:00',2.1),('8975','2013-06-26','10:10:00',3.65),('8975','2013-06-26','10:15:00',3.07),('8975','2013-06-26','10:20:00',6.46),('8975','2013-06-26','10:25:00',6.42),('8975','2013-06-26','10:30:00',6.54),('8975','2013-06-26','10:35:00',5.44),('8975','2013-06-26','10:40:00',7.04),('8975','2013-06-26','10:45:00',7.18),('8975','2013-06-26','10:50:00',6.26),('8975','2013-06-26','10:55:00',5.75),('8975','2013-06-26','11:00:00',2.92),('8975','2013-06-26','11:05:00',7.4),('8975','2013-06-26','11:10:00',7.04),('8975','2013-06-26','11:15:00',6.47),('8975','2013-06-26','11:20:00',1.48),('8975','2013-06-26','11:25:00',5.94),('8975','2013-06-26','11:30:00',3.94),('8975','2013-06-26','11:35:00',3.08),('8975','2013-06-26','11:40:00',3.74),('8975','2013-06-26','11:45:00',2.33),('8975','2013-06-26','11:50:00',2.01),('8975','2013-06-26','11:55:00',2),('8975','2013-06-26','12:00:00',1.85),('8975','2013-06-26','12:05:00',1.76),('8975','2013-06-26','12:10:00',1.81),('8975','2013-06-26','12:15:00',1.52),('8975','2013-06-26','12:20:00',1.6),('8975','2013-06-26','12:25:00',2.07),('8975','2013-06-26','12:30:00',2.59),('8975','2013-06-26','12:35:00',2.51),('8975','2013-06-26','12:40:00',5),('8975','2013-06-26','12:45:00',6.55),('8975','2013-06-26','12:50:00',4.13),('8975','2013-06-26','12:55:00',2.23),('8975','2013-06-26','13:00:00',1.69),('8975','2013-06-26','13:05:00',1.64),('8975','2013-06-26','13:10:00',1.83),('8975','2013-06-26','13:15:00',2.06),('8975','2013-06-26','13:20:00',2.34),('8975','2013-06-26','13:25:00',2.3),('8975','2013-06-26','13:30:00',1.9),('8975','2013-06-26','13:35:00',1.91),('8975','2013-06-26','13:40:00',2.22),('8975','2013-06-26','13:45:00',2.68),('8975','2013-06-26','13:50:00',3.26),('8975','2013-06-26','13:55:00',2.91),('8975','2013-06-26','14:00:00',4.26),('8975','2013-06-26','14:05:00',4.02),('8975','2013-06-26','14:10:00',6.87),('8975','2013-06-26','14:15:00',2.69),('8975','2013-06-26','14:20:00',2.65),('8975','2013-06-26','14:25:00',2.62),('8975','2013-06-26','14:30:00',2.51),('8975','2013-06-26','14:35:00',3.08),('8975','2013-06-26','14:40:00',6.2),('8975','2013-06-26','14:45:00',5.98),('8975','2013-06-26','14:50:00',6.22),('8975','2013-06-26','14:55:00',5.95),('8975','2013-06-26','15:00:00',5.61),('8975','2013-06-26','15:05:00',5.5),('8975','2013-06-26','15:10:00',5.46),('8975','2013-06-26','15:15:00',5.43),('8975','2013-06-26','15:20:00',5.38),('8975','2013-06-26','15:25:00',5.34),('8975','2013-06-26','15:30:00',5.23),('8975','2013-06-26','15:35:00',5.13),('8975','2013-06-26','15:40:00',5.04),('8975','2013-06-26','15:45:00',4.93),('8975','2013-06-26','15:50:00',4.83),('8975','2013-06-26','15:55:00',4.72),('8975','2013-06-26','16:00:00',4.54),('8975','2013-06-26','16:05:00',4.47),('8975','2013-06-26','16:10:00',4.4),('8975','2013-06-26','16:15:00',4.35),('8975','2013-06-26','16:20:00',4.26),('8975','2013-06-26','16:25:00',4.15),('8975','2013-06-26','16:30:00',4.05),('8975','2013-06-26','16:35:00',3.84),('8975','2013-06-26','16:40:00',3.81),('8975','2013-06-26','16:45:00',3.74),('8975','2013-06-26','16:50:00',3.65),('8975','2013-06-26','16:55:00',3.54),('8975','2013-06-26','17:00:00',3.4),('8975','2013-06-26','17:05:00',3.24),('8975','2013-06-26','17:10:00',3.06),('8975','2013-06-26','17:15:00',2.99),('8975','2013-06-26','17:20:00',3.04),('8975','2013-06-26','17:25:00',2.89),('8975','2013-06-26','17:30:00',2.79),('8975','2013-06-26','17:35:00',2.62),('8975','2013-06-26','17:40:00',2.5),('8975','2013-06-26','17:45:00',1.83),('8975','2013-06-26','17:50:00',1.97),('8975','2013-06-26','17:55:00',2.13),('8975','2013-06-26','18:00:00',2.04),('8975','2013-06-26','18:05:00',1.93),('8975','2013-06-26','18:10:00',1.83),('8975','2013-06-26','18:15:00',1.71),('8975','2013-06-26','18:20:00',1.61),('8975','2013-06-26','18:25:00',1.62),('8975','2013-06-26','18:30:00',1.6),('8975','2013-06-26','18:35:00',1.48),('8975','2013-06-26','18:40:00',1.33),('8975','2013-06-26','18:45:00',1.23),('8975','2013-06-26','18:50:00',1.22),('8975','2013-06-26','18:55:00',1.18),('8975','2013-06-26','19:00:00',1.12),('8975','2013-06-26','19:05:00',1.05),('8975','2013-06-25','06:20:00',1.03),('8975','2013-06-25','06:25:00',1.19),('8975','2013-06-25','06:30:00',1.42),('8975','2013-06-25','06:35:00',1.62),('8975','2013-06-25','06:40:00',1.8),('8975','2013-06-25','06:45:00',1.97),('8975','2013-06-25','06:50:00',2.12),('8975','2013-06-25','06:55:00',2.21),('8975','2013-06-25','07:00:00',2.16),('8975','2013-06-25','07:05:00',1.92),('8975','2013-06-25','07:10:00',2.17),('8975','2013-06-25','07:15:00',2.53),('8975','2013-06-25','07:20:00',2.65),('8975','2013-06-25','07:25:00',2.53),('8975','2013-06-25','07:30:00',2.99),('8975','2013-06-25','07:35:00',3.01),('8975','2013-06-25','07:40:00',3.18),('8975','2013-06-25','07:45:00',3.14),('8975','2013-06-25','07:50:00',3.49),('8975','2013-06-25','07:55:00',3.29),('8975','2013-06-25','08:00:00',3.47),('8975','2013-06-25','08:05:00',3.43),('8975','2013-06-25','08:10:00',3.8),('8975','2013-06-25','08:15:00',3.98),('8975','2013-06-25','08:20:00',4.1),('8975','2013-06-25','08:25:00',4.2),('8975','2013-06-25','08:30:00',4.29),('8975','2013-06-25','08:35:00',4.36),('8975','2013-06-25','08:40:00',4.42),('8975','2013-06-25','08:45:00',4.53),('8975','2013-06-25','08:50:00',4.59),('8975','2013-06-25','08:55:00',4.72),('8975','2013-06-25','09:00:00',4.84),('8975','2013-06-25','09:05:00',4.93),('8975','2013-06-25','09:10:00',5),('8975','2013-06-25','09:15:00',5.03),('8975','2013-06-25','09:20:00',5.12),('8975','2013-06-25','09:25:00',5.24),('8975','2013-06-25','09:30:00',5.35),('8975','2013-06-25','09:35:00',5.38),('8975','2013-06-25','09:40:00',5.41),('8975','2013-06-25','09:45:00',5.51),('8975','2013-06-25','09:50:00',5.57),('8975','2013-06-25','09:55:00',5.64),('8975','2013-06-25','10:00:00',5.7),('8975','2013-06-25','10:05:00',5.82),('8975','2013-06-25','10:10:00',5.85),('8975','2013-06-25','10:15:00',5.89),('8975','2013-06-25','10:20:00',6.03),('8975','2013-06-25','10:25:00',6.03),('8975','2013-06-25','10:30:00',6.12),('8975','2013-06-25','10:35:00',6.18),('8975','2013-06-25','10:40:00',6.26),('8975','2013-06-25','10:45:00',6.29),('8975','2013-06-25','10:50:00',6.32),('8975','2013-06-25','10:55:00',6.3),('8975','2013-06-25','11:00:00',6.37),('8975','2013-06-25','11:05:00',6.39),('8975','2013-06-25','11:10:00',6.39),('8975','2013-06-25','11:15:00',6.42),('8975','2013-06-25','11:20:00',6.46),('8975','2013-06-25','11:25:00',6.52),('8975','2013-06-25','11:30:00',6.53),('8975','2013-06-25','11:35:00',6.57),('8975','2013-06-25','11:40:00',6.65),('8975','2013-06-25','11:45:00',6.72),('8975','2013-06-25','11:50:00',6.76),('8975','2013-06-25','11:55:00',6.75),('8975','2013-06-25','12:00:00',6.82),('8975','2013-06-25','12:05:00',6.85),('8975','2013-06-25','12:10:00',6.79),('8975','2013-06-25','12:15:00',6.68),('8975','2013-06-25','12:20:00',6.69),('8975','2013-06-25','12:25:00',6.81),('8975','2013-06-25','12:30:00',6.9),('8975','2013-06-25','12:35:00',6.94),('8975','2013-06-25','12:40:00',6.95),('8975','2013-06-25','12:45:00',7.07),('8975','2013-06-25','12:50:00',7.25),('8975','2013-06-25','12:55:00',7.09),('8975','2013-06-25','13:00:00',7.07),('8975','2013-06-25','13:05:00',7.13),('8975','2013-06-25','13:10:00',7.12),('8975','2013-06-25','13:15:00',6.93),('8975','2013-06-25','13:20:00',6.95),('8975','2013-06-25','13:25:00',7.1),('8975','2013-06-25','13:30:00',7.16),('8975','2013-06-25','13:35:00',6.97),('8975','2013-06-25','13:40:00',6.95),('8975','2013-06-25','13:45:00',6.49),('8975','2013-06-25','13:50:00',6.63),('8975','2013-06-25','13:55:00',6.39),('8975','2013-06-25','14:00:00',6.76),('8975','2013-06-25','14:05:00',6.78),('8975','2013-06-25','14:10:00',6.47),('8975','2013-06-25','14:15:00',2.86),('8975','2013-06-25','14:20:00',5.1),('8975','2013-06-25','14:25:00',3.41),('8975','2013-06-25','14:30:00',2.38),('8975','2013-06-25','14:35:00',3.38),('8975','2013-06-25','14:40:00',5.43),('8975','2013-06-25','14:45:00',6.63),('8975','2013-06-25','14:50:00',6.41),('8975','2013-06-25','14:55:00',6.19),('8975','2013-06-25','15:00:00',5.67),('8975','2013-06-25','15:05:00',5.56),('8975','2013-06-25','15:10:00',5.5),('8975','2013-06-25','15:15:00',5.4),('8975','2013-06-25','15:20:00',5.29),('8975','2013-06-25','15:25:00',5.17),('8975','2013-06-25','15:30:00',5.13),('8975','2013-06-25','15:35:00',5.18),('8975','2013-06-25','15:40:00',5.04),('8975','2013-06-25','15:45:00',4.87),('8975','2013-06-25','15:50:00',4.78),('8975','2013-06-25','15:55:00',4.67),('8975','2013-06-25','16:00:00',4.61),('8975','2013-06-25','16:05:00',4.51),('8975','2013-06-25','16:10:00',4.39),('8975','2013-06-25','16:15:00',4.36),('8975','2013-06-25','16:20:00',4.29),('8975','2013-06-25','16:25:00',4.14),('8975','2013-06-25','16:30:00',4.03),('8975','2013-06-25','16:35:00',3.96),('8975','2013-06-25','16:40:00',3.86),('8975','2013-06-25','16:45:00',3.75),('8975','2013-06-25','16:50:00',3.58),('8975','2013-06-25','16:55:00',3.47),('8975','2013-06-25','17:00:00',3.38),('8975','2013-06-25','17:05:00',3.26),('8975','2013-06-25','17:10:00',3.12),('8975','2013-06-25','17:15:00',2.98),('8975','2013-06-25','17:20:00',2.89),('8975','2013-06-25','17:25:00',2.75),('8975','2013-06-25','17:30:00',2.65),('8975','2013-06-25','17:35:00',2.58),('8975','2013-06-25','17:40:00',2.45),('8975','2013-06-25','17:45:00',2.33),('8975','2013-06-25','17:50:00',2.23),('8975','2013-06-25','17:55:00',2.12),('8975','2013-06-25','18:00:00',2.03),('8975','2013-06-25','18:05:00',2.07),('8975','2013-06-25','18:10:00',2.44),('8975','2013-06-25','18:15:00',1.68),('8975','2013-06-25','18:25:00',1.09),('8975','2013-06-24','06:30:00',1.23),('8975','2013-06-24','06:35:00',1.37),('8975','2013-06-24','06:40:00',1.6),('8975','2013-06-24','06:45:00',1.78),('8975','2013-06-24','06:50:00',1.93),('8975','2013-06-24','06:55:00',2.12),('8975','2013-06-24','07:00:00',2.3),('8975','2013-06-24','07:05:00',2.42),('8975','2013-06-24','07:10:00',2.49),('8975','2013-06-24','07:15:00',2.66),('8975','2013-06-24','07:20:00',2.8),('8975','2013-06-24','07:25:00',2.81),('8975','2013-06-24','07:30:00',2.48),('8975','2013-06-24','07:35:00',1.94),('8975','2013-06-24','07:40:00',3.29),('8975','2013-06-24','07:45:00',3.47),('8975','2013-06-24','07:50:00',3.43),('8975','2013-06-24','07:55:00',2.33),('8975','2013-06-24','08:00:00',1.31),('8975','2013-06-24','08:05:00',2.34),('8975','2013-06-24','08:10:00',4.07),('8975','2013-06-24','08:15:00',4.43),('8975','2013-06-24','08:20:00',4.41),('8975','2013-06-24','08:25:00',4.25),('8975','2013-06-24','08:30:00',4.19),('8975','2013-06-24','08:35:00',4.34),('8975','2013-06-24','08:40:00',4.61),('8975','2013-06-24','08:45:00',4.66),('8975','2013-06-24','08:50:00',4.74),('8975','2013-06-24','08:55:00',4.85),('8975','2013-06-24','09:00:00',4.97),('8975','2013-06-24','09:05:00',5.06),('8975','2013-06-24','09:10:00',5.13),('8975','2013-06-24','09:15:00',5.22),('8975','2013-06-24','09:20:00',5.32),('8975','2013-06-24','09:25:00',5.42),('8975','2013-06-24','09:30:00',5.56),('8975','2013-06-24','09:35:00',5.68),('8975','2013-06-24','09:40:00',5.77),('8975','2013-06-24','09:45:00',6.03),('8975','2013-06-24','09:50:00',6.24),('8975','2013-06-24','09:55:00',6.07),('8975','2013-06-24','10:00:00',3.58),('8975','2013-06-24','10:05:00',1.75),('8975','2013-06-24','10:10:00',1.57),('8975','2013-06-24','10:15:00',1.68),('8975','2013-06-24','10:20:00',3),('8975','2013-06-24','10:25:00',7.43),('8975','2013-06-24','10:30:00',5.54),('8975','2013-06-24','10:35:00',1.78),('8975','2013-06-24','10:40:00',6.56),('8975','2013-06-24','10:45:00',7.3),('8975','2013-06-24','10:50:00',7.08),('8975','2013-06-24','10:55:00',7.11),('8975','2013-06-24','11:00:00',7.2),('8975','2013-06-24','11:05:00',7.19),('8975','2013-06-24','11:10:00',5.85),('8975','2013-06-24','11:15:00',1.9),('8975','2013-06-24','11:20:00',4.56),('8975','2013-06-24','11:25:00',4.8),('8975','2013-06-24','11:30:00',7.99),('8975','2013-06-24','11:35:00',7.91),('8975','2013-06-24','11:40:00',7.58),('8975','2013-06-24','11:45:00',7.73),('8975','2013-06-24','11:50:00',7.68),('8975','2013-06-24','11:55:00',4.81),('8975','2013-06-24','12:00:00',6.11),('8975','2013-06-24','12:05:00',4.11),('8975','2013-06-24','12:10:00',1.85),('8975','2013-06-24','12:15:00',1.86),('8975','2013-06-24','12:20:00',2.17),('8975','2013-06-24','12:25:00',2),('8975','2013-06-24','12:30:00',1.94),('8975','2013-06-24','12:35:00',1.59),('8975','2013-06-24','12:40:00',2.68),('8975','2013-06-24','12:45:00',4.65),('8975','2013-06-24','12:50:00',4.47),('8975','2013-06-24','12:55:00',5.11),('8975','2013-06-24','13:00:00',5.51),('8975','2013-06-24','13:05:00',2.89),('8975','2013-06-24','13:10:00',7.9),('8975','2013-06-24','13:15:00',4.51),('8975','2013-06-24','13:20:00',7.45),('8975','2013-06-24','13:25:00',6.82),('8975','2013-06-24','13:30:00',6.02),('8975','2013-06-24','13:35:00',4.47),('8975','2013-06-24','13:40:00',7.09),('8975','2013-06-24','13:45:00',6.64),('8975','2013-06-24','13:50:00',5.71),('8975','2013-06-24','13:55:00',7.07),('8975','2013-06-24','14:00:00',4.08),('8975','2013-06-24','14:05:00',6.91),('8975','2013-06-24','14:10:00',7),('8975','2013-06-24','14:15:00',6.95),('8975','2013-06-24','14:20:00',6.08),('8975','2013-06-24','14:25:00',6.3),('8975','2013-06-24','14:30:00',5.79),('8975','2013-06-24','14:35:00',6.01),('8975','2013-06-24','14:40:00',6.07),('8975','2013-06-24','14:45:00',6.06),('8975','2013-06-24','14:50:00',6.01),('8975','2013-06-24','14:55:00',5.96),('8975','2013-06-24','15:00:00',5.82),('8975','2013-06-24','15:05:00',5.65),('8975','2013-06-24','15:10:00',5.63),('8975','2013-06-24','15:15:00',5.59),('8975','2013-06-24','15:20:00',5.46),('8975','2013-06-24','15:25:00',5.26),('8975','2013-06-24','15:30:00',5.18),('8975','2013-06-24','15:35:00',5.1),('8975','2013-06-24','15:40:00',4.98),('8975','2013-06-24','15:45:00',4.88),('8975','2013-06-24','15:50:00',4.77),('8975','2013-06-24','15:55:00',4.66),('8975','2013-06-24','16:00:00',4.59),('8975','2013-06-24','16:05:00',4.51),('8975','2013-06-24','16:10:00',4.41),('8975','2013-06-24','16:15:00',4.18),('8975','2013-06-24','16:20:00',4.15),('8975','2013-06-24','16:25:00',3.97),('8975','2013-06-24','16:30:00',3.74),('8975','2013-06-24','16:35:00',3.4),('8975','2013-06-24','16:40:00',3.45),('8975','2013-06-24','16:45:00',3.37),('8975','2013-06-24','16:50:00',3.16),('8975','2013-06-24','16:55:00',3.33),('8975','2013-06-24','17:00:00',3.06),('8975','2013-06-24','17:05:00',2.81),('8975','2013-06-24','17:10:00',2.71),('8975','2013-06-24','17:15:00',2.93),('8975','2013-06-24','17:20:00',2.8),('8975','2013-06-24','17:25:00',2.7),('8975','2013-06-24','17:30:00',2.57),('8975','2013-06-24','17:35:00',2.47),('8975','2013-06-24','17:40:00',2.36),('8975','2013-06-24','17:45:00',2.25),('8975','2013-06-24','17:50:00',2.14),('8975','2013-06-24','17:55:00',2.05),('8975','2013-06-24','18:00:00',1.96),('8975','2013-06-24','18:05:00',1.86),('8975','2013-06-24','18:10:00',1.76),('8975','2013-06-24','18:15:00',1.67),('8975','2013-06-24','18:20:00',1.6),('8975','2013-06-24','18:25:00',1.52),('8975','2013-06-24','18:30:00',1.46),('8975','2013-06-24','18:35:00',1.4),('8975','2013-06-24','18:40:00',1.34),('8975','2013-06-24','18:45:00',1.28),('8975','2013-06-24','18:50:00',1.21),('8975','2013-06-24','18:55:00',1.16),('8975','2013-06-24','19:00:00',1.12),('8975','2013-06-24','19:05:00',1.07),('8975','2013-06-24','19:10:00',1.03),('8975','2013-06-23','07:25:00',1.73),('8975','2013-06-23','07:30:00',1.4),('8975','2013-06-23','07:50:00',1.3),('8975','2013-06-23','08:20:00',1.78),('8975','2013-06-23','08:25:00',4.07),('8975','2013-06-23','08:30:00',3.47),('8975','2013-06-23','08:35:00',4.66),('8975','2013-06-23','08:40:00',4.8),('8975','2013-06-23','08:45:00',4.66),('8975','2013-06-23','08:50:00',5.12),('8975','2013-06-23','08:55:00',5.36),('8975','2013-06-23','09:00:00',4.92),('8975','2013-06-23','09:05:00',2.75),('8975','2013-06-23','09:10:00',5.13),('8975','2013-06-23','09:15:00',5.25),('8975','2013-06-23','09:20:00',2.97),('8975','2013-06-23','09:25:00',6.28),('8975','2013-06-23','09:30:00',1.96),('8975','2013-06-23','09:35:00',2.3),('8975','2013-06-23','09:40:00',5.6),('8975','2013-06-23','09:45:00',6.25),('8975','2013-06-23','09:50:00',6.26),('8975','2013-06-23','09:55:00',6.05),('8975','2013-06-23','10:00:00',6.2),('8975','2013-06-23','10:05:00',6.28),('8975','2013-06-23','10:10:00',6.46),('8975','2013-06-23','10:15:00',6.79),('8975','2013-06-23','10:20:00',7.15),('8975','2013-06-23','10:25:00',6.28),('8975','2013-06-23','10:30:00',4.94),('8975','2013-06-23','10:35:00',2.21),('8975','2013-06-23','10:40:00',2.17),('8975','2013-06-23','10:45:00',7.38),('8975','2013-06-23','10:50:00',6.2),('8975','2013-06-23','10:55:00',3.99),('8975','2013-06-23','11:00:00',6.42),('8975','2013-06-23','11:05:00',2.65),('8975','2013-06-23','11:10:00',1.9),('8975','2013-06-23','11:15:00',5.54),('8975','2013-06-23','11:20:00',4.93),('8975','2013-06-23','11:25:00',5),('8975','2013-06-23','11:30:00',4.84),('8975','2013-06-23','11:35:00',2.47),('8975','2013-06-23','11:40:00',2),('8975','2013-06-23','11:45:00',4.36),('8975','2013-06-23','11:50:00',4.42),('8975','2013-06-23','11:55:00',2.59),('8975','2013-06-23','12:00:00',3.41),('8975','2013-06-23','12:05:00',7.32),('8975','2013-06-23','12:10:00',7.93),('8975','2013-06-23','12:15:00',7.26),('8975','2013-06-23','12:20:00',3.21),('8975','2013-06-23','12:25:00',7.32),('8975','2013-06-23','12:30:00',7.86),('8975','2013-06-23','12:35:00',7.88),('8975','2013-06-23','12:40:00',7.01),('8975','2013-06-23','12:45:00',4.57),('8975','2013-06-23','12:50:00',6.18),('8975','2013-06-23','12:55:00',6.14),('8975','2013-06-23','13:00:00',4.16),('8975','2013-06-23','13:05:00',5.57),('8975','2013-06-23','13:10:00',7.18),('8975','2013-06-23','13:15:00',6.68),('8975','2013-06-23','13:20:00',7.55),('8975','2013-06-23','13:25:00',3.76),('8975','2013-06-23','13:30:00',7.65),('8975','2013-06-23','13:35:00',7.03),('8975','2013-06-23','13:40:00',6.08),('8975','2013-06-23','13:45:00',7),('8975','2013-06-23','13:50:00',6.88),('8975','2013-06-23','13:55:00',6.72),('8975','2013-06-23','14:00:00',6.68),('8975','2013-06-23','14:05:00',6.64),('8975','2013-06-23','14:10:00',6.54),('8975','2013-06-23','14:15:00',6.53),('8975','2013-06-23','14:20:00',6.52),('8975','2013-06-23','14:25:00',6.51),('8975','2013-06-23','14:30:00',6.46),('8975','2013-06-23','14:35:00',5.68),('8975','2013-06-23','14:40:00',5.98),('8975','2013-06-23','14:45:00',5.34),('8975','2013-06-23','14:50:00',6.92),('8975','2013-06-23','14:55:00',5.43),('8975','2013-06-23','15:00:00',6.3),('8975','2013-06-23','15:05:00',5.48),('8975','2013-06-23','15:10:00',2.88),('8975','2013-06-23','15:15:00',3.73),('8975','2013-06-23','15:20:00',3.09),('8975','2013-06-23','15:25:00',4.65),('8975','2013-06-23','15:30:00',5.89),('8975','2013-06-23','15:35:00',2.17),('8975','2013-06-23','15:40:00',3.14),('8975','2013-06-23','15:45:00',3.43),('8975','2013-06-23','15:50:00',3.2),('8975','2013-06-23','15:55:00',4.5),('8975','2013-06-23','16:00:00',5.57),('8975','2013-06-23','16:05:00',3.6),('8975','2013-06-23','16:10:00',3.35),('8975','2013-06-23','16:15:00',5.24),('8975','2013-06-23','16:20:00',2.67),('8975','2013-06-23','16:25:00',2.46),('8975','2013-06-23','16:30:00',3.16),('8975','2013-06-23','16:35:00',2.25),('8975','2013-06-23','16:40:00',2.73),('8975','2013-06-23','16:45:00',2.18),('8975','2013-06-23','16:50:00',3.51),('8975','2013-06-23','16:55:00',1.75),('8975','2013-06-23','17:00:00',1.81),('8975','2013-06-23','17:05:00',2.41),('8975','2013-06-23','17:10:00',1.83),('8975','2013-06-23','17:15:00',2.51),('8975','2013-06-23','17:20:00',1.93),('8975','2013-06-23','17:25:00',1.26),('8975','2013-06-23','17:30:00',1.53),('8975','2013-06-23','17:35:00',1.76),('8975','2013-06-23','17:40:00',1.33),('8975','2013-06-23','17:45:00',1.06),('8975','2013-06-23','17:50:00',1.8),('8975','2013-06-23','17:55:00',1.66),('8975','2013-06-23','18:00:00',1.32),('8975','2013-06-23','18:05:00',1.74),('8975','2013-06-23','18:10:00',2.2),('8975','2013-06-23','18:15:00',1.57),('8975','2013-06-23','18:20:00',1.31),('8975','2013-06-23','18:25:00',1.16),('8975','2013-06-23','18:30:00',1.76),('8975','2013-06-23','18:35:00',1.87),('8975','2013-06-23','18:40:00',1.02),('8975','2013-06-23','18:45:00',1.68),('8975','2013-06-23','18:50:00',1.55),('8975','2013-06-23','18:55:00',1.28),('8975','2013-06-23','19:00:00',1.26),('8975','2013-06-23','19:05:00',1.2),('8975','2013-06-22','08:35:00',1.04),('8975','2013-06-22','08:40:00',1.27),('8975','2013-06-22','08:45:00',2.42),('8975','2013-06-22','08:50:00',2.32),('8975','2013-06-22','08:55:00',1.96),('8975','2013-06-22','09:00:00',4.17),('8975','2013-06-22','09:05:00',3.11),('8975','2013-06-22','09:15:00',1.32),('8975','2013-06-22','09:20:00',3.11),('8975','2013-06-22','09:25:00',5.21),('8975','2013-06-22','09:30:00',5.72),('8975','2013-06-22','09:35:00',5.96),('8975','2013-06-22','09:40:00',4.69),('8975','2013-06-22','09:45:00',2.97),('8975','2013-06-22','09:50:00',4.5),('8975','2013-06-22','09:55:00',5.55),('8975','2013-06-22','10:00:00',6.34),('8975','2013-06-22','10:05:00',5.45),('8975','2013-06-22','10:10:00',3.5),('8975','2013-06-22','10:15:00',6.7),('8975','2013-06-22','10:20:00',6.8),('8975','2013-06-22','10:25:00',4.22),('8975','2013-06-22','10:30:00',6.38),('8975','2013-06-22','10:35:00',6.26),('8975','2013-06-22','10:40:00',6.29),('8975','2013-06-22','10:45:00',6.29),('8975','2013-06-22','10:50:00',6.31),('8975','2013-06-22','10:55:00',6.31),('8975','2013-06-22','11:00:00',6.37),('8975','2013-06-22','11:05:00',6.48),('8975','2013-06-22','11:10:00',6.43),('8975','2013-06-22','11:15:00',6.53),('8975','2013-06-22','11:20:00',6.06),('8975','2013-06-22','11:25:00',6.62),('8975','2013-06-22','11:30:00',6.64),('8975','2013-06-22','11:35:00',6.53),('8975','2013-06-22','11:40:00',6.64),('8975','2013-06-22','11:45:00',6.71),('8975','2013-06-22','11:50:00',6.58),('8975','2013-06-22','11:55:00',3.37),('8975','2013-06-22','12:00:00',3.38),('8975','2013-06-22','12:05:00',5.5),('8975','2013-06-22','12:10:00',7.23),('8975','2013-06-22','12:15:00',7.11),('8975','2013-06-22','12:20:00',7.1),('8975','2013-06-22','12:25:00',6.75),('8975','2013-06-22','12:30:00',7.03),('8975','2013-06-22','12:35:00',6.89),('8975','2013-06-22','12:40:00',6.89),('8975','2013-06-22','12:45:00',6.85),('8975','2013-06-22','12:50:00',6.81),('8975','2013-06-22','12:55:00',6.81),('8975','2013-06-22','13:00:00',6.82),('8975','2013-06-22','13:05:00',6.77),('8975','2013-06-22','13:10:00',6.76),('8975','2013-06-22','13:15:00',6.71),('8975','2013-06-22','13:20:00',6.68),('8975','2013-06-22','13:25:00',6.69),('8975','2013-06-22','13:30:00',6.62),('8975','2013-06-22','13:35:00',6.62),('8975','2013-06-22','13:40:00',6.57),('8975','2013-06-22','13:45:00',6.49),('8975','2013-06-22','13:50:00',6.55),('8975','2013-06-22','13:55:00',6.49),('8975','2013-06-22','14:00:00',6.46),('8975','2013-06-22','14:05:00',6.35),('8975','2013-06-22','14:10:00',6.39),('8975','2013-06-22','14:15:00',6.32),('8975','2013-06-22','14:20:00',6.3),('8975','2013-06-22','14:25:00',6.21),('8975','2013-06-22','14:30:00',6.14),('8975','2013-06-22','14:35:00',6.05),('8975','2013-06-22','14:40:00',6.01),('8975','2013-06-22','14:45:00',5.91),('8975','2013-06-22','14:50:00',5.88),('8975','2013-06-22','14:55:00',5.81),('8975','2013-06-22','15:00:00',5.75),('8975','2013-06-22','15:05:00',5.67),('8975','2013-06-22','15:10:00',5.62),('8975','2013-06-22','15:15:00',5.55),('8975','2013-06-22','15:20:00',5.45),('8975','2013-06-22','15:25:00',5.34),('8975','2013-06-22','15:30:00',5.21),('8975','2013-06-22','15:35:00',5.12),('8975','2013-06-22','15:40:00',5.07),('8975','2013-06-22','15:45:00',4.98),('8975','2013-06-22','15:50:00',4.86),('8975','2013-06-22','15:55:00',4.76),('8975','2013-06-22','16:00:00',4.66),('8975','2013-06-22','16:05:00',4.54),('8975','2013-06-22','16:10:00',4.43),('8975','2013-06-22','16:15:00',4.33),('8975','2013-06-22','16:20:00',4.22),('8975','2013-06-22','16:25:00',4.1),('8975','2013-06-22','16:30:00',4.01),('8975','2013-06-22','16:35:00',3.89),('8975','2013-06-22','16:40:00',3.79),('8975','2013-06-22','16:45:00',3.68),('8975','2013-06-22','16:50:00',3.58),('8975','2013-06-22','16:55:00',3.45),('8975','2013-06-22','17:00:00',3.34),('8975','2013-06-22','17:05:00',3.22),('8975','2013-06-22','17:10:00',3.1),('8975','2013-06-22','17:15:00',2.97),('8975','2013-06-22','17:20:00',2.83),('8975','2013-06-22','17:25:00',2.73),('8975','2013-06-22','17:30:00',2.61),('8975','2013-06-22','17:35:00',2.49),('8975','2013-06-22','17:40:00',2.29),('8975','2013-06-22','17:45:00',2.28),('8975','2013-06-22','17:50:00',2.2),('8975','2013-06-22','17:55:00',2.08),('8975','2013-06-22','18:00:00',1.98),('8975','2013-06-22','18:05:00',1.88),('8975','2013-06-22','18:10:00',1.8),('8975','2013-06-22','18:15:00',1.72),('8975','2013-06-22','18:20:00',1.52),('8975','2013-06-22','18:25:00',1.57),('8975','2013-06-22','18:30:00',1.47),('8975','2013-06-22','18:35:00',1.42),('8975','2013-06-22','18:40:00',1.38),('8975','2013-06-22','18:45:00',1.32),('8975','2013-06-22','18:50:00',1.25),('8975','2013-06-22','18:55:00',1.13),('8975','2013-06-22','19:00:00',1.03),('8975','2013-06-22','19:05:00',1),('8975','2013-06-22','19:10:00',1.07),('8975','2013-06-22','19:15:00',1.04),('8975','2013-06-21','06:25:00',1.15),('8975','2013-06-21','06:30:00',1.29),('8975','2013-06-21','06:35:00',1.42),('8975','2013-06-21','06:40:00',1.53),('8975','2013-06-21','06:45:00',1.67),('8975','2013-06-21','06:50:00',1.8),('8975','2013-06-21','06:55:00',1.92),('8975','2013-06-21','07:00:00',2.04),('8975','2013-06-21','07:05:00',2.17),('8975','2013-06-21','07:10:00',2.31),('8975','2013-06-21','07:15:00',2.44),('8975','2013-06-21','07:20:00',2.56),('8975','2013-06-21','07:25:00',2.69),('8975','2013-06-21','07:30:00',2.8),('8975','2013-06-21','07:35:00',2.92),('8975','2013-06-21','07:40:00',3.01),('8975','2013-06-21','07:45:00',3.08),('8975','2013-06-21','07:50:00',3.18),('8975','2013-06-21','07:55:00',3.27),('8975','2013-06-21','08:00:00',3.4),('8975','2013-06-21','08:05:00',3.46),('8975','2013-06-21','08:10:00',3.53),('8975','2013-06-21','08:15:00',3.64),('8975','2013-06-21','08:20:00',3.78),('8975','2013-06-21','08:25:00',3.87),('8975','2013-06-21','08:30:00',3.98),('8975','2013-06-21','08:35:00',4.11),('8975','2013-06-21','08:40:00',4.23),('8975','2013-06-21','08:45:00',4.33),('8975','2013-06-21','08:50:00',4.42),('8975','2013-06-21','08:55:00',4.51),('8975','2013-06-21','09:00:00',4.58),('8975','2013-06-21','09:05:00',4.65),('8975','2013-06-21','09:10:00',4.74),('8975','2013-06-21','09:15:00',4.78),('8975','2013-06-21','09:20:00',4.84),('8975','2013-06-21','09:25:00',4.93),('8975','2013-06-21','09:30:00',5.06),('8975','2013-06-21','09:35:00',5.19),('8975','2013-06-21','09:40:00',5.23),('8975','2013-06-21','09:45:00',5.33),('8975','2013-06-21','09:50:00',5.4),('8975','2013-06-21','09:55:00',5.46),('8975','2013-06-21','10:00:00',5.5),('8975','2013-06-21','10:05:00',5.6),('8975','2013-06-21','10:10:00',5.71),('8975','2013-06-21','10:15:00',5.78),('8975','2013-06-21','10:20:00',5.84),('8975','2013-06-21','10:25:00',5.85),('8975','2013-06-21','10:30:00',5.87),('8975','2013-06-21','10:35:00',5.94),('8975','2013-06-21','10:40:00',6.06),('8975','2013-06-21','10:45:00',6.11),('8975','2013-06-21','10:50:00',6.18),('8975','2013-06-21','10:55:00',6.23),('8975','2013-06-21','11:00:00',6.26),('8975','2013-06-21','11:05:00',6.3),('8975','2013-06-21','11:10:00',6.35),('8975','2013-06-21','11:15:00',6.37),('8975','2013-06-21','11:20:00',6.41),('8975','2013-06-21','11:25:00',6.44),('8975','2013-06-21','11:30:00',6.42),('8975','2013-06-21','11:35:00',6.44),('8975','2013-06-21','11:40:00',6.5),('8975','2013-06-21','11:45:00',6.51),('8975','2013-06-21','11:50:00',6.45),('8975','2013-06-21','11:55:00',6.55),('8975','2013-06-21','12:00:00',6.51),('8975','2013-06-21','12:05:00',6.32),('8975','2013-06-21','12:10:00',6.39),('8975','2013-06-21','12:15:00',6.55),('8975','2013-06-21','12:20:00',6.43),('8975','2013-06-21','12:25:00',6.53),('8975','2013-06-21','12:30:00',6.55),('8975','2013-06-21','12:35:00',6.57),('8975','2013-06-21','12:40:00',6.54),('8975','2013-06-21','12:45:00',6.39),('8975','2013-06-21','12:50:00',5.81),('8975','2013-06-21','12:55:00',5.4),('8975','2013-06-21','13:00:00',6.11),('8975','2013-06-21','13:05:00',6.25),('8975','2013-06-21','13:10:00',6.01),('8975','2013-06-21','13:15:00',5.65),('8975','2013-06-21','13:20:00',5.03),('8975','2013-06-21','13:25:00',4.61),('8975','2013-06-21','13:30:00',5.5),('8975','2013-06-21','13:35:00',6.06),('8975','2013-06-21','13:40:00',5.72),('8975','2013-06-21','13:45:00',6.21),('8975','2013-06-21','13:50:00',6.12),('8975','2013-06-21','13:55:00',4.05),('8975','2013-06-21','14:00:00',4.96),('8975','2013-06-21','14:05:00',6.82),('8975','2013-06-21','14:10:00',6.48),('8975','2013-06-21','14:15:00',6.19),('8975','2013-06-21','14:20:00',5.96),('8975','2013-06-21','14:25:00',6.49),('8975','2013-06-21','14:30:00',4.36),('8975','2013-06-21','14:35:00',3.26),('8975','2013-06-21','14:40:00',2.59),('8975','2013-06-21','14:45:00',3.72),('8975','2013-06-21','14:50:00',5.48),('8975','2013-06-21','14:55:00',5.78),('8975','2013-06-21','15:00:00',5.97),('8975','2013-06-21','15:05:00',4.13),('8975','2013-06-21','15:10:00',6.05),('8975','2013-06-21','15:15:00',5.85),('8975','2013-06-21','15:20:00',5.18),('8975','2013-06-21','15:25:00',4.49),('8975','2013-06-21','15:30:00',3.07),('8975','2013-06-21','15:35:00',2.14),('8975','2013-06-21','15:40:00',2.27),('8975','2013-06-21','15:45:00',3.69),('8975','2013-06-21','15:50:00',3.48),('8975','2013-06-21','15:55:00',3.82),('8975','2013-06-21','16:00:00',2.96),('8975','2013-06-21','16:05:00',1.94),('8975','2013-06-21','16:10:00',2.02),('8975','2013-06-21','16:15:00',2.78),('8975','2013-06-21','16:20:00',2.77),('8975','2013-06-21','16:25:00',1.99),('8975','2013-06-21','16:30:00',1.55),('8975','2013-06-21','16:35:00',1.34),('8975','2013-06-21','16:40:00',1.25),('8975','2013-06-21','16:45:00',1.22),('8975','2013-06-21','16:50:00',1.33),('8975','2013-06-21','16:55:00',1.87),('8975','2013-06-21','17:00:00',2.24),('8975','2013-06-21','17:05:00',2.32),('8975','2013-06-21','17:10:00',3.16),('8975','2013-06-21','17:15:00',3.92),('8975','2013-06-21','17:20:00',3.7),('8975','2013-06-21','17:25:00',3.23),('8975','2013-06-21','17:30:00',2.59),('8975','2013-06-21','17:35:00',2.98),('8975','2013-06-21','17:40:00',2.86),('8975','2013-06-21','17:45:00',2.73),('8975','2013-06-21','17:50:00',2.51),('8975','2013-06-21','17:55:00',2.38),('8975','2013-06-21','18:00:00',2.05),('8975','2013-06-21','18:05:00',1.75),('8975','2013-06-21','18:10:00',1.24),('8975','2013-06-21','18:15:00',1.26),('8975','2013-06-21','18:20:00',1.32),('8975','2013-06-20','06:30:00',1.03),('8975','2013-06-20','06:35:00',1.2),('8975','2013-06-20','06:40:00',1.37),('8975','2013-06-20','06:45:00',1.57),('8975','2013-06-20','06:50:00',1.71),('8975','2013-06-20','06:55:00',1.84),('8975','2013-06-20','07:00:00',1.99),('8975','2013-06-20','07:05:00',2.14),('8975','2013-06-20','07:10:00',2.29),('8975','2013-06-20','07:15:00',2.42),('8975','2013-06-20','07:20:00',2.55),('8975','2013-06-20','07:25:00',2.66),('8975','2013-06-20','07:30:00',2.78),('8975','2013-06-20','07:35:00',2.9),('8975','2013-06-20','07:40:00',2.99),('8975','2013-06-20','07:45:00',3.1),('8975','2013-06-20','07:50:00',3.22),('8975','2013-06-20','07:55:00',3.34),('8975','2013-06-20','08:00:00',3.41),('8975','2013-06-20','08:05:00',3.52),('8975','2013-06-20','08:10:00',3.6),('8975','2013-06-20','08:15:00',3.69),('8975','2013-06-20','08:20:00',3.8),('8975','2013-06-20','08:25:00',3.88),('8975','2013-06-20','08:30:00',3.95),('8975','2013-06-20','08:35:00',4.02),('8975','2013-06-20','08:40:00',4.14),('8975','2013-06-20','08:45:00',4.22),('8975','2013-06-20','08:50:00',4.32),('8975','2013-06-20','08:55:00',4.4),('8975','2013-06-20','09:00:00',4.44),('8975','2013-06-20','09:05:00',4.47),('8975','2013-06-20','09:10:00',4.56),('8975','2013-06-20','09:15:00',4.64),('8975','2013-06-20','09:20:00',4.73),('8975','2013-06-20','09:25:00',4.81),('8975','2013-06-20','09:30:00',4.89),('8975','2013-06-20','09:35:00',4.95),('8975','2013-06-20','09:40:00',5.05),('8975','2013-06-20','09:45:00',5.06),('8975','2013-06-20','09:50:00',5.1),('8975','2013-06-20','09:55:00',5.15),('8975','2013-06-20','10:00:00',5.29),('8975','2013-06-20','10:05:00',5.37),('8975','2013-06-20','10:10:00',5.32),('8975','2013-06-20','10:15:00',5.36),('8975','2013-06-20','10:20:00',5.44),('8975','2013-06-20','10:25:00',5.51),('8975','2013-06-20','10:30:00',5.59),('8975','2013-06-20','10:35:00',5.61),('8975','2013-06-20','10:40:00',5.58),('8975','2013-06-20','10:45:00',5.59),('8975','2013-06-20','10:50:00',5.73),('8975','2013-06-20','10:55:00',5.79),('8975','2013-06-20','11:00:00',5.82),('8975','2013-06-20','11:05:00',5.88),('8975','2013-06-20','11:10:00',5.98),('8975','2013-06-20','11:15:00',6.01),('8975','2013-06-20','11:20:00',6.01),('8975','2013-06-20','11:25:00',6.01),('8975','2013-06-20','11:30:00',6.01),('8975','2013-06-20','11:35:00',6.01),('8975','2013-06-20','11:40:00',6.1),('8975','2013-06-20','11:45:00',6.12),('8975','2013-06-20','11:50:00',6.15),('8975','2013-06-20','11:55:00',6.15),('8975','2013-06-20','12:00:00',6.18),('8975','2013-06-20','12:05:00',6.09),('8975','2013-06-20','12:10:00',6.16),('8975','2013-06-20','12:15:00',6.09),('8975','2013-06-20','12:20:00',6.21),('8975','2013-06-20','12:25:00',6.14),('8975','2013-06-20','12:30:00',6.15),('8975','2013-06-20','12:35:00',6.2),('8975','2013-06-20','12:40:00',6.17),('8975','2013-06-20','12:45:00',6.07),('8975','2013-06-20','12:50:00',6.08),('8975','2013-06-20','12:55:00',6.07),('8975','2013-06-20','13:00:00',6.14),('8975','2013-06-20','13:05:00',6.18),('8975','2013-06-20','13:10:00',6.11),('8975','2013-06-20','13:15:00',6.11),('8975','2013-06-20','13:20:00',6.16),('8975','2013-06-20','13:25:00',6.16),('8975','2013-06-20','13:30:00',6.09),('8975','2013-06-20','13:35:00',6.12),('8975','2013-06-20','13:40:00',6.05),('8975','2013-06-20','13:45:00',6.04),('8975','2013-06-20','13:50:00',5.95),('8975','2013-06-20','13:55:00',5.91),('8975','2013-06-20','14:00:00',5.87),('8975','2013-06-20','14:05:00',5.91),('8975','2013-06-20','14:10:00',5.87),('8975','2013-06-20','14:15:00',5.83),('8975','2013-06-20','14:20:00',5.81),('8975','2013-06-20','14:25:00',5.76),('8975','2013-06-20','14:30:00',5.74),('8975','2013-06-20','14:35:00',5.7),('8975','2013-06-20','14:40:00',5.63),('8975','2013-06-20','14:45:00',5.57),('8975','2013-06-20','14:50:00',5.52),('8975','2013-06-20','14:55:00',5.46),('8975','2013-06-20','15:00:00',5.32),('8975','2013-06-20','15:05:00',5.31),('8975','2013-06-20','15:10:00',5.26),('8975','2013-06-20','15:15:00',5.18),('8975','2013-06-20','15:20:00',4.49),('8975','2013-06-20','15:25:00',4.56),('8975','2013-06-20','15:30:00',4.75),('8975','2013-06-20','15:35:00',4.68),('8975','2013-06-20','15:40:00',4.43),('8975','2013-06-20','15:45:00',4.43),('8975','2013-06-20','15:50:00',4.51),('8975','2013-06-20','15:55:00',4.39),('8975','2013-06-20','16:00:00',4.13),('8975','2013-06-20','16:05:00',4.31),('8975','2013-06-20','16:10:00',4.2),('8975','2013-06-20','16:15:00',4.1),('8975','2013-06-20','16:20:00',3.98),('8975','2013-06-20','16:25:00',3.9),('8975','2013-06-20','16:30:00',3.79),('8975','2013-06-20','16:35:00',3.67),('8975','2013-06-20','16:40:00',3.56),('8975','2013-06-20','16:45:00',3.47),('8975','2013-06-20','16:50:00',3.37),('8975','2013-06-20','16:55:00',3.26),('8975','2013-06-20','17:00:00',3.13),('8975','2013-06-20','17:05:00',3.02),('8975','2013-06-20','17:10:00',2.91),('8975','2013-06-20','17:15:00',2.8),('8975','2013-06-20','17:20:00',2.69),('8975','2013-06-20','17:25:00',2.58),('8975','2013-06-20','17:30:00',2.46),('8975','2013-06-20','17:35:00',2.35),('8975','2013-06-20','17:40:00',2.26),('8975','2013-06-20','17:45:00',2.15),('8975','2013-06-20','17:50:00',2.04),('8975','2013-06-20','17:55:00',1.95),('8975','2013-06-20','18:00:00',1.86),('8975','2013-06-20','18:05:00',1.79),('8975','2013-06-20','18:10:00',1.7),('8975','2013-06-20','18:15:00',1.62),('8975','2013-06-20','18:20:00',1.54),('8975','2013-06-20','18:25:00',1.47),('8975','2013-06-20','18:30:00',1.4),('8975','2013-06-20','18:35:00',1.33),('8975','2013-06-20','18:40:00',1.27),('8975','2013-06-20','18:45:00',1.18),('8975','2013-06-20','18:50:00',1.15),('8975','2013-06-20','18:55:00',1.09),('8975','2013-06-20','19:00:00',1.05),('8975','2013-06-20','19:05:00',1.04),('8975','2014-04-03','08:35:00',1.19),('8975','2014-04-03','08:40:00',1.89),('8975','2014-04-03','08:45:00',2.02),('8975','2014-04-03','08:50:00',2.09),('8975','2014-04-03','08:55:00',2.88),('8975','2014-04-03','09:00:00',3.15),('8975','2014-04-03','09:05:00',3.55),('8975','2014-04-03','09:10:00',3.94),('8975','2014-04-03','09:15:00',4.12),('8975','2014-04-03','09:20:00',4.05),('8975','2014-04-03','09:25:00',3.21),('8975','2014-04-03','09:30:00',2.89),('8975','2014-04-03','09:35:00',2.85),('8975','2014-04-03','09:40:00',2.57),('8975','2014-04-03','09:45:00',2.29),('8975','2014-04-03','09:50:00',1.79),('8975','2014-04-03','09:55:00',1.62),('8975','2014-04-03','10:00:00',1.13),('8975','2014-04-03','10:10:00',1.22),('8975','2014-04-03','10:15:00',1.26),('8975','2014-04-03','10:55:00',1),('8975','2014-04-03','12:45:00',1.06),('8975','2014-04-03','12:50:00',1.05),('8975','2014-04-03','13:15:00',1.28),('8975','2014-04-03','13:20:00',3.36),('8975','2014-04-03','13:25:00',2.67),('8975','2014-04-03','13:30:00',3.7),('8975','2014-04-03','13:35:00',5.6),('8975','2014-04-03','13:40:00',6.46),('8975','2014-04-03','13:45:00',4.52),('8975','2014-04-03','13:50:00',5.97),('8975','2014-04-03','13:55:00',3.75),('8975','2014-04-03','14:00:00',4.26),('8975','2014-04-03','14:05:00',4.44),('8975','2014-04-03','14:10:00',6.49),('8975','2014-04-03','14:15:00',4.07),('8975','2014-04-03','14:20:00',4.97),('8975','2014-04-03','14:25:00',3.41),('8975','2014-04-03','14:30:00',3.05),('8975','2014-04-03','14:35:00',3.09),('8975','2014-04-03','14:40:00',2.8),('8975','2014-04-03','14:45:00',2.99),('8975','2014-04-03','14:50:00',4.3),('8975','2014-04-03','14:55:00',5.18),('8975','2014-04-03','15:00:00',5.27),('8975','2014-04-03','15:05:00',5.27),('8975','2014-04-03','15:10:00',3.6),('8975','2014-04-03','15:15:00',4.47),('8975','2014-04-03','15:20:00',1.64),('8975','2014-04-03','15:25:00',2.58),('8975','2014-04-03','15:30:00',2),('8975','2014-04-03','15:35:00',2.26),('8975','2014-04-03','15:40:00',2.47),('8975','2014-04-03','15:45:00',2.4),('8975','2014-04-03','15:50:00',2.99),('8975','2014-04-03','15:55:00',2.97),('8975','2014-04-03','16:00:00',4.28),('8975','2014-04-03','16:05:00',2.99),('8975','2014-04-03','16:10:00',2.78),('8975','2014-04-03','16:15:00',2.45),('8975','2014-04-03','16:20:00',1.62),('8975','2014-04-03','16:25:00',1.79),('8975','2014-04-03','16:30:00',4.02),('8975','2014-04-03','16:35:00',3.11),('8975','2014-04-03','16:40:00',1.96),('8975','2014-04-03','16:45:00',3.02),('8975','2014-04-03','16:50:00',3.23),('8975','2014-04-03','16:55:00',2.68),('8975','2014-04-03','17:00:00',2.62),('8975','2014-04-03','17:05:00',2.28),('8975','2014-04-03','17:10:00',2.41),('8975','2014-04-03','17:15:00',1.61),('8975','2014-04-03','17:20:00',1.7),('8975','2014-04-03','17:25:00',2.22),('8975','2014-04-03','17:30:00',2.41),('8975','2014-04-03','17:35:00',1.55),('8975','2014-04-03','17:40:00',1.95),('8975','2014-04-03','17:45:00',1.63),('8975','2014-04-03','17:50:00',1.67),('8975','2014-04-03','17:55:00',1.6),('8975','2014-04-03','18:00:00',1.47),('8975','2014-04-03','18:05:00',1.36),('8975','2014-04-03','18:10:00',1.28),('8975','2014-04-03','18:15:00',1.21),('8975','2014-04-03','18:20:00',1.15),('8975','2014-04-03','18:25:00',1.05),('8975','2014-04-03','18:30:00',1.01),('8975','2013-06-19','06:25:00',1.09),('8975','2013-06-19','06:30:00',1.25),('8975','2013-06-19','06:35:00',1.36),('8975','2013-06-19','06:40:00',1.48),('8975','2013-06-19','06:45:00',1.66),('8975','2013-06-19','06:50:00',1.81),('8975','2013-06-19','06:55:00',1.93),('8975','2013-06-19','07:00:00',2.01),('8975','2013-06-19','07:05:00',2.14),('8975','2013-06-19','07:10:00',2.25),('8975','2013-06-19','07:15:00',2.36),('8975','2013-06-19','07:20:00',2.48),('8975','2013-06-19','07:25:00',2.6),('8975','2013-06-19','07:30:00',2.71),('8975','2013-06-19','07:35:00',2.81),('8975','2013-06-19','07:40:00',2.92),('8975','2013-06-19','07:45:00',3.02),('8975','2013-06-19','07:50:00',3.18),('8975','2013-06-19','07:55:00',3.3),('8975','2013-06-19','08:00:00',3.4),('8975','2013-06-19','08:05:00',3.47),('8975','2013-06-19','08:10:00',3.59),('8975','2013-06-19','08:15:00',3.74),('8975','2013-06-19','08:20:00',3.83),('8975','2013-06-19','08:25:00',3.93),('8975','2013-06-19','08:30:00',4.02),('8975','2013-06-19','08:35:00',4.15),('8975','2013-06-19','08:40:00',4.25),('8975','2013-06-19','08:45:00',4.36),('8975','2013-06-19','08:50:00',4.46),('8975','2013-06-19','08:55:00',4.53),('8975','2013-06-19','09:00:00',4.57),('8975','2013-06-19','09:05:00',4.67),('8975','2013-06-19','09:10:00',4.75),('8975','2013-06-19','09:15:00',4.83),('8975','2013-06-19','09:20:00',4.93),('8975','2013-06-19','09:25:00',5.01),('8975','2013-06-19','09:30:00',5.1),('8975','2013-06-19','09:35:00',5.17),('8975','2013-06-19','09:40:00',5.2),('8975','2013-06-19','09:45:00',5.28),('8975','2013-06-19','09:50:00',5.37),('8975','2013-06-19','09:55:00',5.44),('8975','2013-06-19','10:00:00',5.43),('8975','2013-06-19','10:05:00',5.56),('8975','2013-06-19','10:10:00',5.58),('8975','2013-06-19','10:15:00',5.69),('8975','2013-06-19','10:20:00',5.68),('8975','2013-06-19','10:25:00',5.82),('8975','2013-06-19','10:30:00',5.83),('8975','2013-06-19','10:35:00',5.79),('8975','2013-06-19','10:40:00',5.76),('8975','2013-06-19','10:45:00',5.75),('8975','2013-06-19','10:50:00',5.8),('8975','2013-06-19','10:55:00',5.93),('8975','2013-06-19','11:00:00',6),('8975','2013-06-19','11:05:00',6.09),('8975','2013-06-19','11:10:00',6.1),('8975','2013-06-19','11:15:00',6.12),('8975','2013-06-19','11:20:00',6.05),('8975','2013-06-19','11:25:00',6.09),('8975','2013-06-19','11:30:00',6.11),('8975','2013-06-19','11:35:00',6.1),('8975','2013-06-19','11:40:00',6.07),('8975','2013-06-19','11:45:00',6.1),('8975','2013-06-19','11:50:00',6.04),('8975','2013-06-19','11:55:00',5.97),('8975','2013-06-19','12:00:00',5.89),('8975','2013-06-19','12:05:00',3.81),('8975','2013-06-19','12:10:00',5.49),('8975','2013-06-19','12:15:00',3.32),('8975','2013-06-19','12:20:00',4.27),('8975','2013-06-19','12:25:00',6.27),('8975','2013-06-19','12:30:00',2.7),('8975','2013-06-19','12:35:00',1.67),('8975','2013-06-19','12:40:00',4.92),('8975','2013-06-19','12:45:00',6.4),('8975','2013-06-19','12:50:00',6.41),('8975','2013-06-19','12:55:00',6.57),('8975','2013-06-19','13:00:00',5.77),('8975','2013-06-19','13:05:00',3.32),('8975','2013-06-19','13:10:00',4.81),('8975','2013-06-19','13:15:00',6.33),('8975','2013-06-19','13:20:00',6.27),('8975','2013-06-19','13:25:00',6.21),('8975','2013-06-19','13:30:00',6.22),('8975','2013-06-19','13:35:00',6.16),('8975','2013-06-19','13:40:00',6.17),('8975','2013-06-19','13:45:00',6.11),('8975','2013-06-19','13:50:00',6.05),('8975','2013-06-19','13:55:00',6.1),('8975','2013-06-19','14:00:00',5.93),('8975','2013-06-19','14:05:00',6.03),('8975','2013-06-19','14:10:00',6.1),('8975','2013-06-19','14:15:00',6.01),('8975','2013-06-19','14:20:00',5.91),('8975','2013-06-19','14:25:00',5.91),('8975','2013-06-19','14:30:00',5.82),('8975','2013-06-19','14:35:00',5.81),('8975','2013-06-19','14:40:00',5.78),('8975','2013-06-19','14:45:00',5.71),('8975','2013-06-19','14:50:00',5.69),('8975','2013-06-19','14:55:00',5.62),('8975','2013-06-19','15:00:00',5.52),('8975','2013-06-19','15:05:00',5.48),('8975','2013-06-19','15:10:00',5.38),('8975','2013-06-19','15:15:00',5.3),('8975','2013-06-19','15:20:00',5.22),('8975','2013-06-19','15:25:00',5.11),('8975','2013-06-19','15:30:00',5.01),('8975','2013-06-19','15:35:00',4.92),('8975','2013-06-19','15:40:00',4.84),('8975','2013-06-19','15:45:00',4.75),('8975','2013-06-19','15:50:00',4.65),('8975','2013-06-19','15:55:00',4.55),('8975','2013-06-19','16:00:00',4.44),('8975','2013-06-19','16:05:00',4.38),('8975','2013-06-19','16:10:00',4.26),('8975','2013-06-19','16:15:00',4.17),('8975','2013-06-19','16:20:00',4.05),('8975','2013-06-19','16:25:00',3.95),('8975','2013-06-19','16:30:00',3.83),('8975','2013-06-19','16:35:00',3.7),('8975','2013-06-19','16:40:00',3.6),('8975','2013-06-19','16:45:00',3.48),('8975','2013-06-19','16:50:00',3.39),('8975','2013-06-19','16:55:00',3.27),('8975','2013-06-19','17:00:00',3.16),('8975','2013-06-19','17:05:00',3.02),('8975','2013-06-19','17:10:00',2.91),('8975','2013-06-19','17:15:00',2.8),('8975','2013-06-19','17:20:00',2.68),('8975','2013-06-19','17:25:00',2.55),('8975','2013-06-19','17:30:00',2.44),('8975','2013-06-19','17:35:00',2.32),('8975','2013-06-19','17:40:00',2.23),('8975','2013-06-19','17:45:00',2.14),('8975','2013-06-19','17:50:00',2.04),('8975','2013-06-19','17:55:00',1.95),('8975','2013-06-19','18:00:00',1.87),('8975','2013-06-19','18:05:00',1.78),('8975','2013-06-19','18:10:00',1.7),('8975','2013-06-19','18:15:00',1.62),('8975','2013-06-19','18:20:00',1.54),('8975','2013-06-19','18:25:00',1.47),('8975','2013-06-19','18:30:00',1.39),('8975','2013-06-19','18:35:00',1.33),('8975','2013-06-19','18:40:00',1.27),('8975','2013-06-19','18:45:00',1.2),('8975','2013-06-19','18:50:00',1.15),('8975','2013-06-19','18:55:00',1.11),('8975','2013-06-19','19:00:00',1.05),('8975','2013-06-19','19:05:00',1.02),('8975','2013-06-18','06:25:00',1.01),('8975','2013-06-18','06:30:00',1.15),('8975','2013-06-18','06:35:00',1.29),('8975','2013-06-18','06:40:00',1.42),('8975','2013-06-18','06:45:00',1.56),('8975','2013-06-18','06:50:00',1.7),('8975','2013-06-18','06:55:00',1.84),('8975','2013-06-18','07:00:00',1.97),('8975','2013-06-18','07:05:00',2.09),('8975','2013-06-18','07:10:00',2.21),('8975','2013-06-18','07:15:00',2.32),('8975','2013-06-18','07:20:00',2.44),('8975','2013-06-18','07:25:00',2.56),('8975','2013-06-18','07:30:00',2.68),('8975','2013-06-18','07:35:00',2.79),('8975','2013-06-18','07:40:00',2.88),('8975','2013-06-18','07:45:00',2.98),('8975','2013-06-18','07:50:00',3.11),('8975','2013-06-18','07:55:00',3.24),('8975','2013-06-18','08:00:00',3.34),('8975','2013-06-18','08:05:00',3.4),('8975','2013-06-18','08:10:00',3.51),('8975','2013-06-18','08:15:00',3.61),('8975','2013-06-18','08:20:00',3.75),('8975','2013-06-18','08:25:00',3.84),('8975','2013-06-18','08:30:00',3.93),('8975','2013-06-18','08:35:00',4.02),('8975','2013-06-18','08:40:00',4.1),('8975','2013-06-18','08:45:00',4.19),('8975','2013-06-18','08:50:00',4.28),('8975','2013-06-18','08:55:00',4.35),('8975','2013-06-18','09:00:00',4.42),('8975','2013-06-18','09:05:00',4.51),('8975','2013-06-18','09:10:00',4.6),('8975','2013-06-18','09:15:00',4.7),('8975','2013-06-18','09:20:00',4.8),('8975','2013-06-18','09:25:00',4.87),('8975','2013-06-18','09:30:00',4.92),('8975','2013-06-18','09:35:00',4.98),('8975','2013-06-18','09:40:00',5.04),('8975','2013-06-18','09:45:00',5.12),('8975','2013-06-18','09:50:00',5.2),('8975','2013-06-18','09:55:00',5.28),('8975','2013-06-18','10:00:00',5.33),('8975','2013-06-18','10:05:00',5.35),('8975','2013-06-18','10:10:00',5.41),('8975','2013-06-18','10:15:00',5.47),('8975','2013-06-18','10:20:00',5.51),('8975','2013-06-18','10:25:00',5.6),('8975','2013-06-18','10:30:00',5.66),('8975','2013-06-18','10:35:00',5.68),('8975','2013-06-18','10:40:00',5.7),('8975','2013-06-18','10:45:00',5.71),('8975','2013-06-18','10:50:00',5.78),('8975','2013-06-18','10:55:00',5.77),('8975','2013-06-18','11:00:00',5.79),('8975','2013-06-18','11:05:00',5.81),('8975','2013-06-18','11:10:00',5.81),('8975','2013-06-18','11:15:00',5.78),('8975','2013-06-18','11:20:00',5.87),('8975','2013-06-18','11:25:00',5.84),('8975','2013-06-18','11:30:00',5.93),('8975','2013-06-18','11:35:00',6.03),('8975','2013-06-18','11:40:00',5.96),('8975','2013-06-18','11:45:00',5.99),('8975','2013-06-18','11:50:00',6.03),('8975','2013-06-18','11:55:00',6.01),('8975','2013-06-18','12:00:00',6.12),('8975','2013-06-18','12:05:00',6.17),('8975','2013-06-18','12:10:00',6.04),('8975','2013-06-18','12:15:00',6.17),('8975','2013-06-18','12:20:00',6.22),('8975','2013-06-18','12:25:00',6.15),('8975','2013-06-18','12:30:00',6.28),('8975','2013-06-18','12:35:00',6.19),('8975','2013-06-18','12:40:00',6.15),('8975','2013-06-18','12:45:00',6.25),('8975','2013-06-18','12:50:00',6.2),('8975','2013-06-18','12:55:00',6.18),('8975','2013-06-18','13:00:00',6.07),('8975','2013-06-18','13:05:00',6.12),('8975','2013-06-18','13:10:00',6.12),('8975','2013-06-18','13:15:00',6.08),('8975','2013-06-18','13:20:00',6.04),('8975','2013-06-18','13:25:00',6.1),('8975','2013-06-18','13:30:00',6.03),('8975','2013-06-18','13:35:00',6.03),('8975','2013-06-18','13:40:00',6.06),('8975','2013-06-18','13:45:00',6.04),('8975','2013-06-18','13:50:00',6.02),('8975','2013-06-18','13:55:00',5.98),('8975','2013-06-18','14:00:00',5.98),('8975','2013-06-18','14:05:00',5.94),('8975','2013-06-18','14:10:00',5.88),('8975','2013-06-18','14:15:00',5.81),('8975','2013-06-18','14:20:00',5.76),('8975','2013-06-18','14:25:00',5.73),('8975','2013-06-18','14:30:00',5.66),('8975','2013-06-18','14:35:00',5.6),('8975','2013-06-18','14:40:00',5.55),('8975','2013-06-18','14:45:00',5.47),('8975','2013-06-18','14:50:00',5.4),('8975','2013-06-18','14:55:00',5.35),('8975','2013-06-18','15:00:00',5.29),('8975','2013-06-18','15:05:00',5.22),('8975','2013-06-18','15:10:00',5.15),('8975','2013-06-18','15:15:00',5.07),('8975','2013-06-18','15:20:00',5),('8975','2013-06-18','15:25:00',4.92),('8975','2013-06-18','15:30:00',4.81),('8975','2013-06-18','15:35:00',4.72),('8975','2013-06-18','15:40:00',4.64),('8975','2013-06-18','15:45:00',4.53),('8975','2013-06-18','15:50:00',4.46),('8975','2013-06-18','15:55:00',4.34),('8975','2013-06-18','16:00:00',4.16),('8975','2013-06-18','16:05:00',4.13),('8975','2013-06-18','16:10:00',3.76),('8975','2013-06-18','16:15:00',3.59),('8975','2013-06-18','16:20:00',3.85),('8975','2013-06-18','16:25:00',3.36),('8975','2013-06-18','16:30:00',2.92),('8975','2013-06-18','16:35:00',2.65),('8975','2013-06-18','16:40:00',2.71),('8975','2013-06-18','16:45:00',3.39),('8975','2013-06-18','16:50:00',3.3),('8975','2013-06-18','16:55:00',3.2),('8975','2013-06-18','17:00:00',3.1),('8975','2013-06-18','17:05:00',2.99),('8975','2013-06-18','17:10:00',2.88),('8975','2013-06-18','17:15:00',2.77),('8975','2013-06-18','17:20:00',2.67),('8975','2013-06-18','17:25:00',2.57),('8975','2013-06-18','17:30:00',2.46),('8975','2013-06-18','17:35:00',2.35),('8975','2013-06-18','17:40:00',2.24),('8975','2013-06-18','17:45:00',2.13),('8975','2013-06-18','17:50:00',2.04),('8975','2013-06-18','17:55:00',1.94),('8975','2013-06-18','18:00:00',1.84),('8975','2013-06-18','18:05:00',1.75),('8975','2013-06-18','18:10:00',1.65),('8975','2013-06-18','18:15:00',1.57),('8975','2013-06-18','18:20:00',1.49),('8975','2013-06-18','18:25:00',1.41),('8975','2013-06-18','18:30:00',1.2),('8975','2013-06-18','18:35:00',1.14),('8975','2013-06-18','18:40:00',1.06),('8975','2013-06-18','18:45:00',1),('8975','2013-06-18','18:50:00',1),('8975','2013-06-17','06:30:00',1),('8975','2013-06-17','06:35:00',1.14),('8975','2013-06-17','06:40:00',1.27),('8975','2013-06-17','06:45:00',1.4),('8975','2013-06-17','06:50:00',1.55),('8975','2013-06-17','06:55:00',1.7),('8975','2013-06-17','07:00:00',1.83),('8975','2013-06-17','07:05:00',1.98),('8975','2013-06-17','07:10:00',2.11),('8975','2013-06-17','07:15:00',2.24),('8975','2013-06-17','07:20:00',2.36),('8975','2013-06-17','07:25:00',2.49),('8975','2013-06-17','07:30:00',2.61),('8975','2013-06-17','07:35:00',2.73),('8975','2013-06-17','07:40:00',2.83),('8975','2013-06-17','07:45:00',2.92),('8975','2013-06-17','07:50:00',3.03),('8975','2013-06-17','07:55:00',3.14),('8975','2013-06-17','08:00:00',3.24),('8975','2013-06-17','08:05:00',3.35),('8975','2013-06-17','08:10:00',3.46),('8975','2013-06-17','08:15:00',3.58),('8975','2013-06-17','08:20:00',3.69),('8975','2013-06-17','08:25:00',3.77),('8975','2013-06-17','08:30:00',3.86),('8975','2013-06-17','08:35:00',3.95),('8975','2013-06-17','08:40:00',4.04),('8975','2013-06-17','08:45:00',4.11),('8975','2013-06-17','08:50:00',4.24),('8975','2013-06-17','08:55:00',4.33),('8975','2013-06-17','09:00:00',4.39),('8975','2013-06-17','09:05:00',4.47),('8975','2013-06-17','09:10:00',4.54),('8975','2013-06-17','09:15:00',4.61),('8975','2013-06-17','09:20:00',4.71),('8975','2013-06-17','09:25:00',4.81),('8975','2013-06-17','09:30:00',4.87),('8975','2013-06-17','09:35:00',4.95),('8975','2013-06-17','09:40:00',5.04),('8975','2013-06-17','09:45:00',5.1),('8975','2013-06-17','09:50:00',5.17),('8975','2013-06-17','09:55:00',5.24),('8975','2013-06-17','10:00:00',5.28),('8975','2013-06-17','10:05:00',5.37),('8975','2013-06-17','10:10:00',5.37),('8975','2013-06-17','10:15:00',5.39),('8975','2013-06-17','10:20:00',5.55),('8975','2013-06-17','10:25:00',5.54),('8975','2013-06-17','10:30:00',5.62),('8975','2013-06-17','10:35:00',5.7),('8975','2013-06-17','10:40:00',5.73),('8975','2013-06-17','10:45:00',5.77),('8975','2013-06-17','10:50:00',5.85),('8975','2013-06-17','10:55:00',5.81),('8975','2013-06-17','11:00:00',5.74),('8975','2013-06-17','11:05:00',5.81),('8975','2013-06-17','11:10:00',5.85),('8975','2013-06-17','11:15:00',5.81),('8975','2013-06-17','11:20:00',5.99),('8975','2013-06-17','11:25:00',5.98),('8975','2013-06-17','11:30:00',6.04),('8975','2013-06-17','11:35:00',5.97),('8975','2013-06-17','11:40:00',5.92),('8975','2013-06-17','11:45:00',5.93),('8975','2013-06-17','11:50:00',5.96),('8975','2013-06-17','11:55:00',6),('8975','2013-06-17','12:00:00',5.99),('8975','2013-06-17','12:05:00',5.89),('8975','2013-06-17','12:10:00',5.81),('8975','2013-06-17','12:15:00',5.79),('8975','2013-06-17','12:20:00',5.75),('8975','2013-06-17','12:25:00',6.08),('8975','2013-06-17','12:30:00',4.22),('8975','2013-06-17','12:35:00',5.87),('8975','2013-06-17','12:40:00',6.02),('8975','2013-06-17','12:45:00',6.17),('8975','2013-06-17','12:50:00',6.12),('8975','2013-06-17','12:55:00',6.22),('8975','2013-06-17','13:00:00',6.27),('8975','2013-06-17','13:05:00',6.36),('8975','2013-06-17','13:10:00',6.29),('8975','2013-06-17','13:15:00',5.05),('8975','2013-06-17','13:20:00',5.09),('8975','2013-06-17','13:25:00',6.01),('8975','2013-06-17','13:30:00',5.7),('8975','2013-06-17','13:35:00',5.8),('8975','2013-06-17','13:40:00',5.6),('8975','2013-06-17','13:45:00',5.67),('8975','2013-06-17','13:50:00',5.95),('8975','2013-06-17','13:55:00',6.16),('8975','2013-06-17','14:00:00',6.02),('8975','2013-06-17','14:05:00',5.98),('8975','2013-06-17','14:10:00',5.97),('8975','2013-06-17','14:15:00',5.9),('8975','2013-06-17','14:20:00',5.85),('8975','2013-06-17','14:25:00',5.77),('8975','2013-06-17','14:30:00',5.75),('8975','2013-06-17','14:35:00',5.76),('8975','2013-06-17','14:40:00',5.77),('8975','2013-06-17','14:45:00',5.6),('8975','2013-06-17','14:50:00',5.52),('8975','2013-06-17','14:55:00',5.45),('8975','2013-06-17','15:00:00',5.38),('8975','2013-06-17','15:05:00',5.31),('8975','2013-06-17','15:10:00',5.24),('8975','2013-06-17','15:15:00',5.18),('8975','2013-06-17','15:20:00',5.08),('8975','2013-06-17','15:25:00',5.03),('8975','2013-06-17','15:30:00',4.99),('8975','2013-06-17','15:35:00',4.93),('8975','2013-06-17','15:40:00',4.82),('8975','2013-06-17','15:45:00',4.71),('8975','2013-06-17','15:50:00',4.68),('8975','2013-06-17','15:55:00',4.6),('8975','2013-06-17','16:00:00',4.54),('8975','2013-06-17','16:05:00',4.47),('8975','2013-06-17','16:10:00',4.38),('8975','2013-06-17','16:15:00',4.28),('8975','2013-06-17','16:20:00',4.16),('8975','2013-06-17','16:25:00',4.04),('8975','2013-06-17','16:30:00',3.93),('8975','2013-06-17','16:35:00',3.76),('8975','2013-06-17','16:40:00',3.64),('8975','2013-06-17','16:45:00',3.46),('8975','2013-06-17','16:50:00',3.3),('8975','2013-06-17','16:55:00',3.23),('8975','2013-06-17','17:00:00',3.11),('8975','2013-06-17','17:05:00',2.99),('8975','2013-06-17','17:10:00',2.89),('8975','2013-06-17','17:15:00',2.81),('8975','2013-06-17','17:20:00',2.64),('8975','2013-06-17','17:25:00',2.57),('8975','2013-06-17','17:30:00',2.47),('8975','2013-06-17','17:35:00',2.34),('8975','2013-06-17','17:40:00',2.24),('8975','2013-06-17','17:45:00',2.17),('8975','2013-06-17','17:50:00',2.06),('8975','2013-06-17','17:55:00',1.97),('8975','2013-06-17','18:00:00',1.9),('8975','2013-06-17','18:05:00',1.82),('8975','2013-06-17','18:10:00',1.7),('8975','2013-06-17','18:15:00',1.62),('8975','2013-06-17','18:20:00',1.57),('8975','2013-06-17','18:25:00',1.51),('8975','2013-06-17','18:30:00',1.43),('8975','2013-06-17','18:35:00',1.37),('8975','2013-06-17','18:40:00',1.31),('8975','2013-06-17','18:45:00',1.23),('8975','2013-06-17','18:50:00',1.21),('8975','2013-06-17','18:55:00',1.13),('8975','2013-06-17','19:00:00',1.11),('8975','2013-06-17','19:05:00',1.05),('8975','2013-06-16','06:25:00',1.12),('8975','2013-06-16','06:30:00',1.27),('8975','2013-06-16','06:35:00',1.43),('8975','2013-06-16','06:40:00',1.57),('8975','2013-06-16','06:45:00',1.71),('8975','2013-06-16','06:50:00',1.86),('8975','2013-06-16','06:55:00',1.98),('8975','2013-06-16','07:00:00',2.11),('8975','2013-06-16','07:05:00',2.24),('8975','2013-06-16','07:10:00',2.37),('8975','2013-06-16','07:15:00',2.5),('8975','2013-06-16','07:20:00',2.61),('8975','2013-06-16','07:25:00',2.74),('8975','2013-06-16','07:30:00',2.84),('8975','2013-06-16','07:35:00',2.93),('8975','2013-06-16','07:40:00',3.04),('8975','2013-06-16','07:45:00',3.16),('8975','2013-06-16','07:50:00',3.27),('8975','2013-06-16','07:55:00',3.38),('8975','2013-06-16','08:00:00',3.47),('8975','2013-06-16','08:05:00',3.58),('8975','2013-06-16','08:10:00',3.67),('8975','2013-06-16','08:15:00',3.73),('8975','2013-06-16','08:20:00',3.87),('8975','2013-06-16','08:25:00',3.97),('8975','2013-06-16','08:30:00',4.06),('8975','2013-06-16','08:35:00',4.16),('8975','2013-06-16','08:40:00',4.23),('8975','2013-06-16','08:45:00',4.31),('8975','2013-06-16','08:50:00',4.45),('8975','2013-06-16','08:55:00',4.52),('8975','2013-06-16','09:00:00',4.63),('8975','2013-06-16','09:05:00',4.7),('8975','2013-06-16','09:10:00',4.78),('8975','2013-06-16','09:15:00',4.83),('8975','2013-06-16','09:20:00',4.95),('8975','2013-06-16','09:25:00',5.02),('8975','2013-06-16','09:30:00',5.12),('8975','2013-06-16','09:35:00',5.16),('8975','2013-06-16','09:40:00',5.2),('8975','2013-06-16','09:45:00',5.27),('8975','2013-06-16','09:50:00',5.34),('8975','2013-06-16','09:55:00',5.44),('8975','2013-06-16','10:00:00',5.52),('8975','2013-06-16','10:05:00',5.56),('8975','2013-06-16','10:10:00',5.63),('8975','2013-06-16','10:15:00',5.68),('8975','2013-06-16','10:20:00',5.78),('8975','2013-06-16','10:25:00',5.8),('8975','2013-06-16','10:30:00',5.83),('8975','2013-06-16','10:35:00',5.87),('8975','2013-06-16','10:40:00',5.9),('8975','2013-06-16','10:45:00',5.92),('8975','2013-06-16','10:50:00',5.98),('8975','2013-06-16','10:55:00',6.03),('8975','2013-06-16','11:00:00',6.08),('8975','2013-06-16','11:05:00',6.06),('8975','2013-06-16','11:10:00',6.15),('8975','2013-06-16','11:15:00',6.13),('8975','2013-06-16','11:20:00',6.15),('8975','2013-06-16','11:25:00',6.18),('8975','2013-06-16','11:30:00',6.15),('8975','2013-06-16','11:35:00',6.21),('8975','2013-06-16','11:40:00',6.2),('8975','2013-06-16','11:45:00',6.25),('8975','2013-06-16','11:50:00',6.22),('8975','2013-06-16','11:55:00',6.16),('8975','2013-06-16','12:00:00',6.23),('8975','2013-06-16','12:05:00',6.24),('8975','2013-06-16','12:10:00',5.81),('8975','2013-06-16','12:15:00',5.68),('8975','2013-06-16','12:20:00',6),('8975','2013-06-16','12:25:00',5.96),('8975','2013-06-16','12:30:00',5.56),('8975','2013-06-16','12:35:00',6.07),('8975','2013-06-16','12:40:00',5.76),('8975','2013-06-16','12:45:00',4.57),('8975','2013-06-16','12:50:00',4.79),('8975','2013-06-16','12:55:00',5.42),('8975','2013-06-16','13:00:00',6.31),('8975','2013-06-16','13:05:00',6.3),('8975','2013-06-16','13:10:00',6.27),('8975','2013-06-16','13:15:00',6.29),('8975','2013-06-16','13:20:00',6.22),('8975','2013-06-16','13:25:00',6.21),('8975','2013-06-16','13:30:00',6.18),('8975','2013-06-16','13:35:00',6.15),('8975','2013-06-16','13:40:00',6.12),('8975','2013-06-16','13:45:00',6.1),('8975','2013-06-16','13:50:00',6.07),('8975','2013-06-16','13:55:00',6.01),('8975','2013-06-16','14:00:00',5.95),('8975','2013-06-16','14:05:00',5.89),('8975','2013-06-16','14:10:00',5.85),('8975','2013-06-16','14:15:00',5.84),('8975','2013-06-16','14:20:00',5.82),('8975','2013-06-16','14:25:00',5.76),('8975','2013-06-16','14:30:00',5.7),('8975','2013-06-16','14:35:00',5.67),('8975','2013-06-16','14:40:00',5.59),('8975','2013-06-16','14:45:00',5.51),('8975','2013-06-16','14:50:00',5.45),('8975','2013-06-16','14:55:00',5.37),('8975','2013-06-16','15:00:00',5.29),('8975','2013-06-16','15:05:00',5.24),('8975','2013-06-16','15:10:00',5.18),('8975','2013-06-16','15:15:00',5.12),('8975','2013-06-16','15:20:00',5.04),('8975','2013-06-16','15:25:00',4.93),('8975','2013-06-16','15:30:00',4.87),('8975','2013-06-16','15:35:00',4.79),('8975','2013-06-16','15:40:00',4.67),('8975','2013-06-16','15:45:00',4.61),('8975','2013-06-16','15:50:00',4.56),('8975','2013-06-16','15:55:00',4.46),('8975','2013-06-16','16:00:00',4.37),('8975','2013-06-16','16:05:00',4.26),('8975','2013-06-16','16:10:00',4.17),('8975','2013-06-16','16:15:00',4.07),('8975','2013-06-16','16:20:00',4.01),('8975','2013-06-16','16:25:00',3.9),('8975','2013-06-16','16:30:00',3.79),('8975','2013-06-16','16:35:00',3.71),('8975','2013-06-16','16:40:00',3.59),('8975','2013-06-16','16:45:00',3.5),('8975','2013-06-16','16:50:00',3.4),('8975','2013-06-16','16:55:00',3.3),('8975','2013-06-16','17:00:00',3.18),('8975','2013-06-16','17:05:00',3.07),('8975','2013-06-16','17:10:00',2.97),('8975','2013-06-16','17:15:00',2.89),('8975','2013-06-16','17:20:00',2.78),('8975','2013-06-16','17:25:00',2.69),('8975','2013-06-16','17:30:00',2.59),('8975','2013-06-16','17:35:00',2.49),('8975','2013-06-16','17:40:00',2.35),('8975','2013-06-16','17:45:00',2.26),('8975','2013-06-16','17:50:00',2.18),('8975','2013-06-16','17:55:00',2.09),('8975','2013-06-16','18:00:00',1.99),('8975','2013-06-16','18:05:00',1.9),('8975','2013-06-16','18:10:00',1.83),('8975','2013-06-16','18:15:00',1.74),('8975','2013-06-16','18:20:00',1.65),('8975','2013-06-16','18:25:00',1.49),('8975','2013-06-16','18:30:00',1.46),('8975','2013-06-16','18:35:00',1.51),('8975','2013-06-16','18:40:00',1.47),('8975','2013-06-16','18:45:00',1.43),('8975','2013-06-16','18:50:00',1.39),('8975','2013-06-16','18:55:00',1.33),('8975','2013-06-16','19:00:00',1.27),('8975','2013-06-16','19:05:00',1.22),('8975','2013-06-16','19:10:00',1.14),('8975','2013-06-16','19:15:00',1.07),('8975','2013-06-15','06:25:00',1.05),('8975','2013-06-15','06:30:00',1.2),('8975','2013-06-15','06:35:00',1.37),('8975','2013-06-15','06:40:00',1.55),('8975','2013-06-15','06:45:00',1.72),('8975','2013-06-15','06:50:00',1.86),('8975','2013-06-15','06:55:00',2.02),('8975','2013-06-15','07:00:00',2.17),('8975','2013-06-15','07:05:00',2.28),('8975','2013-06-15','07:10:00',2.4),('8975','2013-06-15','07:15:00',2.52),('8975','2013-06-15','07:20:00',2.65),('8975','2013-06-15','07:25:00',2.79),('8975','2013-06-15','07:30:00',2.9),('8975','2013-06-15','07:35:00',3.01),('8975','2013-06-15','07:40:00',3.13),('8975','2013-06-15','07:45:00',3.23),('8975','2013-06-15','07:50:00',3.32),('8975','2013-06-15','07:55:00',3.42),('8975','2013-06-15','08:00:00',3.53),('8975','2013-06-15','08:05:00',3.65),('8975','2013-06-15','08:10:00',3.77),('8975','2013-06-15','08:15:00',3.86),('8975','2013-06-15','08:20:00',3.96),('8975','2013-06-15','08:25:00',4.08),('8975','2013-06-15','08:30:00',4.18),('8975','2013-06-15','08:35:00',4.26),('8975','2013-06-15','08:40:00',4.36),('8975','2013-06-15','08:45:00',4.48),('8975','2013-06-15','08:50:00',4.59),('8975','2013-06-15','08:55:00',4.66),('8975','2013-06-15','09:00:00',4.7),('8975','2013-06-15','09:05:00',4.82),('8975','2013-06-15','09:10:00',4.9),('8975','2013-06-15','09:15:00',4.99),('8975','2013-06-15','09:20:00',4.63),('8975','2013-06-15','09:25:00',5.02),('8975','2013-06-15','09:30:00',4.94),('8975','2013-06-15','09:35:00',5.21),('8975','2013-06-15','09:40:00',4.58),('8975','2013-06-15','09:45:00',5.24),('8975','2013-06-15','09:50:00',5.2),('8975','2013-06-15','09:55:00',4.8),('8975','2013-06-15','10:00:00',5.12),('8975','2013-06-15','10:05:00',4.61),('8975','2013-06-15','10:10:00',5.15),('8975','2013-06-15','10:15:00',5.61),('8975','2013-06-15','10:20:00',5.85),('8975','2013-06-15','10:25:00',5.87),('8975','2013-06-15','10:30:00',5.9),('8975','2013-06-15','10:35:00',5.94),('8975','2013-06-15','10:40:00',6.03),('8975','2013-06-15','10:45:00',6.11),('8975','2013-06-15','10:50:00',6.18),('8975','2013-06-15','10:55:00',6.17),('8975','2013-06-15','11:00:00',6.19),('8975','2013-06-15','11:05:00',6.22),('8975','2013-06-15','11:10:00',6.21),('8975','2013-06-15','11:15:00',6.22),('8975','2013-06-15','11:20:00',6.34),('8975','2013-06-15','11:25:00',6.39),('8975','2013-06-15','11:30:00',6.39),('8975','2013-06-15','11:35:00',6.44),('8975','2013-06-15','11:40:00',6.44),('8975','2013-06-15','11:45:00',6.45),('8975','2013-06-15','11:50:00',6.47),('8975','2013-06-15','11:55:00',6.48),('8975','2013-06-15','12:00:00',6.53),('8975','2013-06-15','12:05:00',6.56),('8975','2013-06-15','12:10:00',6.5),('8975','2013-06-15','12:15:00',6.57),('8975','2013-06-15','12:20:00',6.56),('8975','2013-06-15','12:25:00',6.54),('8975','2013-06-15','12:30:00',6.49),('8975','2013-06-15','12:35:00',6.49),('8975','2013-06-15','12:40:00',6.46),('8975','2013-06-15','12:45:00',6.39),('8975','2013-06-15','12:50:00',6.53),('8975','2013-06-15','12:55:00',6.55),('8975','2013-06-15','13:00:00',6.53),('8975','2013-06-15','13:05:00',6.5),('8975','2013-06-15','13:10:00',6.53),('8975','2013-06-15','13:15:00',6.51),('8975','2013-06-15','13:20:00',6.45),('8975','2013-06-15','13:25:00',6.48),('8975','2013-06-15','13:30:00',6.38),('8975','2013-06-15','13:35:00',6.41),('8975','2013-06-15','13:40:00',6.37),('8975','2013-06-15','13:45:00',6.34),('8975','2013-06-15','13:50:00',6.28),('8975','2013-06-15','13:55:00',6.29),('8975','2013-06-15','14:00:00',6.21),('8975','2013-06-15','14:05:00',6.19),('8975','2013-06-15','14:10:00',6.13),('8975','2013-06-15','14:15:00',6.08),('8975','2013-06-15','14:20:00',6.03),('8975','2013-06-15','14:25:00',5.97),('8975','2013-06-15','14:30:00',5.9),('8975','2013-06-15','14:35:00',5.85),('8975','2013-06-15','14:40:00',5.78),('8975','2013-06-15','14:45:00',5.71),('8975','2013-06-15','14:50:00',5.61),('8975','2013-06-15','14:55:00',5.55),('8975','2013-06-15','15:00:00',5.49),('8975','2013-06-15','15:05:00',5.43),('8975','2013-06-15','15:10:00',5.37),('8975','2013-06-15','15:15:00',5.28),('8975','2013-06-15','15:20:00',5.2),('8975','2013-06-15','15:25:00',5.11),('8975','2013-06-15','15:30:00',5.03),('8975','2013-06-15','15:35:00',4.95),('8975','2013-06-15','15:40:00',4.85),('8975','2013-06-15','15:45:00',4.75),('8975','2013-06-15','15:50:00',4.65),('8975','2013-06-15','15:55:00',4.55),('8975','2013-06-15','16:00:00',4.44),('8975','2013-06-15','16:05:00',4.36),('8975','2013-06-15','16:10:00',4.26),('8975','2013-06-15','16:15:00',4.16),('8975','2013-06-15','16:20:00',4.05),('8975','2013-06-15','16:25:00',3.95),('8975','2013-06-15','16:30:00',3.84),('8975','2013-06-15','16:35:00',3.72),('8975','2013-06-15','16:40:00',3.61),('8975','2013-06-15','16:45:00',3.48),('8975','2013-06-15','16:50:00',3.38),('8975','2013-06-15','16:55:00',3.27),('8975','2013-06-15','17:00:00',3.15),('8975','2013-06-15','17:05:00',3.03),('8975','2013-06-15','17:10:00',2.91),('8975','2013-06-15','17:15:00',2.78),('8975','2013-06-15','17:20:00',2.67),('8975','2013-06-15','17:25:00',2.57),('8975','2013-06-15','17:30:00',2.43),('8975','2013-06-15','17:35:00',2.32),('8975','2013-06-15','17:40:00',2.2),('8975','2013-06-15','17:45:00',2.08),('8975','2013-06-15','17:50:00',2.01),('8975','2013-06-15','17:55:00',1.91),('8975','2013-06-15','18:00:00',1.83),('8975','2013-06-15','18:05:00',1.74),('8975','2013-06-15','18:10:00',1.66),('8975','2013-06-15','18:15:00',1.58),('8975','2013-06-15','18:20:00',1.51),('8975','2013-06-15','18:25:00',1.45),('8975','2013-06-15','18:30:00',1.38),('8975','2013-06-15','18:35:00',1.31),('8975','2013-06-15','18:40:00',1.26),('8975','2013-06-15','18:45:00',1.2),('8975','2013-06-15','18:50:00',1.14),('8975','2013-06-15','18:55:00',1.11),('8975','2013-06-15','19:00:00',1.04),('8975','2013-06-15','19:05:00',1.02),('8975','2013-06-14','06:30:00',1.12),('8975','2013-06-14','06:35:00',1.28),('8975','2013-06-14','06:40:00',1.46),('8975','2013-06-14','06:45:00',1.62),('8975','2013-06-14','06:50:00',1.76),('8975','2013-06-14','06:55:00',1.88),('8975','2013-06-14','07:00:00',2.01),('8975','2013-06-14','07:05:00',2.13),('8975','2013-06-14','07:10:00',2.24),('8975','2013-06-14','07:15:00',2.36),('8975','2013-06-14','07:20:00',2.5),('8975','2013-06-14','07:25:00',2.61),('8975','2013-06-14','07:30:00',2.73),('8975','2013-06-14','07:35:00',2.85),('8975','2013-06-14','07:40:00',2.97),('8975','2013-06-14','07:45:00',3.1),('8975','2013-06-14','07:50:00',3.19),('8975','2013-06-14','07:55:00',3.29),('8975','2013-06-14','08:00:00',3.38),('8975','2013-06-14','08:05:00',3.51),('8975','2013-06-14','08:10:00',3.71),('8975','2013-06-14','08:15:00',3.72),('8975','2013-06-14','08:20:00',3.87),('8975','2013-06-14','08:25:00',3.94),('8975','2013-06-14','08:30:00',4.05),('8975','2013-06-14','08:35:00',4.12),('8975','2013-06-14','08:40:00',4.1),('8975','2013-06-14','08:45:00',4.07),('8975','2013-06-14','08:50:00',4.15),('8975','2013-06-14','08:55:00',4),('8975','2013-06-14','09:00:00',4.09),('8975','2013-06-14','09:05:00',4.65),('8975','2013-06-14','09:10:00',4.77),('8975','2013-06-14','09:15:00',4.85),('8975','2013-06-14','09:20:00',4.92),('8975','2013-06-14','09:25:00',5.17),('8975','2013-06-14','09:30:00',5.18),('8975','2013-06-14','09:35:00',5.27),('8975','2013-06-14','09:40:00',5.29),('8975','2013-06-14','09:45:00',5.33),('8975','2013-06-14','09:50:00',5.53),('8975','2013-06-14','09:55:00',5.41),('8975','2013-06-14','10:00:00',5.42),('8975','2013-06-14','10:05:00',5.76),('8975','2013-06-14','10:10:00',5.92),('8975','2013-06-14','10:15:00',4.41),('8975','2013-06-14','10:20:00',5.45),('8975','2013-06-14','10:25:00',5.73),('8975','2013-06-14','10:30:00',5.88),('8975','2013-06-14','10:35:00',2.3),('8975','2013-06-14','10:40:00',2.97),('8975','2013-06-14','10:45:00',4.52),('8975','2013-06-14','10:50:00',6.63),('8975','2013-06-14','10:55:00',6.54),('8975','2013-06-14','11:00:00',6.69),('8975','2013-06-14','11:05:00',5.97),('8975','2013-06-14','11:10:00',5.65),('8975','2013-06-14','11:15:00',4.5),('8975','2013-06-14','11:20:00',5.56),('8975','2013-06-14','11:25:00',6.99),('8975','2013-06-14','11:30:00',6.22),('8975','2013-06-14','11:35:00',6.91),('8975','2013-06-14','11:40:00',5.4),('8975','2013-06-14','11:45:00',4.95),('8975','2013-06-14','11:50:00',5.96),('8975','2013-06-14','11:55:00',5.17),('8975','2013-06-14','12:00:00',4.35),('8975','2013-06-14','12:05:00',6.86),('8975','2013-06-14','12:10:00',6.8),('8975','2013-06-14','12:15:00',6.72),('8975','2013-06-14','12:20:00',6.7),('8975','2013-06-14','12:25:00',6.64),('8975','2013-06-14','12:30:00',6.65),('8975','2013-06-14','12:35:00',6.76),('8975','2013-06-14','12:40:00',6.7),('8975','2013-06-14','12:45:00',6.66),('8975','2013-06-14','12:50:00',6.66),('8975','2013-06-14','12:55:00',6.7),('8975','2013-06-14','13:00:00',6.68),('8975','2013-06-14','13:05:00',6.6),('8975','2013-06-14','13:10:00',6.59),('8975','2013-06-14','13:15:00',6.49),('8975','2013-06-14','13:20:00',6.5),('8975','2013-06-14','13:25:00',6.49),('8975','2013-06-14','13:30:00',6.42),('8975','2013-06-14','13:35:00',6.39),('8975','2013-06-14','13:40:00',6.36),('8975','2013-06-14','13:45:00',6.31),('8975','2013-06-14','13:50:00',6.29),('8975','2013-06-14','13:55:00',6.27),('8975','2013-06-14','14:00:00',6.19),('8975','2013-06-14','14:05:00',6.08),('8975','2013-06-14','14:10:00',6.09),('8975','2013-06-14','14:15:00',6.04),('8975','2013-06-14','14:20:00',6.01),('8975','2013-06-14','14:25:00',5.96),('8975','2013-06-14','14:30:00',5.86),('8975','2013-06-14','14:35:00',5.78),('8975','2013-06-14','14:40:00',5.7),('8975','2013-06-14','14:45:00',5.64),('8975','2013-06-14','14:50:00',5.61),('8975','2013-06-14','14:55:00',5.53),('8975','2013-06-14','15:00:00',5.46),('8975','2013-06-14','15:05:00',5.36),('8975','2013-06-14','15:10:00',5.3),('8975','2013-06-14','15:15:00',5.22),('8975','2013-06-14','15:20:00',5.02),('8975','2013-06-14','15:25:00',4.52),('8975','2013-06-14','15:30:00',4.51),('8975','2013-06-14','15:35:00',4.7),('8975','2013-06-14','15:40:00',4.81),('8975','2013-06-14','15:45:00',4.58),('8975','2013-06-14','15:50:00',4.51),('8975','2013-06-14','15:55:00',4.14),('8975','2013-06-14','16:00:00',4.15),('8975','2013-06-14','16:05:00',4.16),('8975','2013-06-14','16:10:00',4.18),('8975','2013-06-14','16:15:00',3.73),('8975','2013-06-14','16:20:00',4.03),('8975','2013-06-14','16:25:00',3.94),('8975','2013-06-14','16:30:00',3.82),('8975','2013-06-14','16:35:00',3.7),('8975','2013-06-14','16:40:00',3.58),('8975','2013-06-14','16:45:00',3.47),('8975','2013-06-14','16:50:00',3.38),('8975','2013-06-14','16:55:00',3.28),('8975','2013-06-14','17:00:00',3.16),('8975','2013-06-14','17:05:00',3.04),('8975','2013-06-14','17:10:00',2.93),('8975','2013-06-14','17:15:00',2.79),('8975','2013-06-14','17:20:00',2.67),('8975','2013-06-14','17:25:00',2.57),('8975','2013-06-14','17:30:00',2.46),('8975','2013-06-14','17:35:00',2.34),('8975','2013-06-14','17:40:00',2.24),('8975','2013-06-14','17:45:00',2.11),('8975','2013-06-14','17:50:00',2),('8975','2013-06-14','17:55:00',1.93),('8975','2013-06-14','18:00:00',1.84),('8975','2013-06-14','18:05:00',1.76),('8975','2013-06-14','18:10:00',1.67),('8975','2013-06-14','18:15:00',1.59),('8975','2013-06-14','18:20:00',1.52),('8975','2013-06-14','18:25:00',1.45),('8975','2013-06-14','18:30:00',1.33),('8975','2013-06-14','18:35:00',1.29),('8975','2013-06-14','18:40:00',1.23),('8975','2013-06-14','18:45:00',1.19),('8975','2013-06-14','18:50:00',1.16),('8975','2013-06-14','18:55:00',1.12),('8975','2013-06-14','19:00:00',1.06),('8975','2013-06-14','19:05:00',1.01),('8975','2013-06-13','06:15:00',1.16),('8975','2013-06-13','06:20:00',1.32),('8975','2013-06-13','06:25:00',1.47),('8975','2013-06-13','06:30:00',1.63),('8975','2013-06-13','06:35:00',1.79),('8975','2013-06-13','06:40:00',1.94),('8975','2013-06-13','06:45:00',2.09),('8975','2013-06-13','06:50:00',2.23),('8975','2013-06-13','06:55:00',2.36),('8975','2013-06-13','07:00:00',2.49),('8975','2013-06-13','07:05:00',2.63),('8975','2013-06-13','07:10:00',2.75),('8975','2013-06-13','07:15:00',2.88),('8975','2013-06-13','07:20:00',3.02),('8975','2013-06-13','07:25:00',3.14),('8975','2013-06-13','07:30:00',3.26),('8975','2013-06-13','07:35:00',3.37),('8975','2013-06-13','07:40:00',3.46),('8975','2013-06-13','07:45:00',3.57),('8975','2013-06-13','07:50:00',3.67),('8975','2013-06-13','07:55:00',3.76),('8975','2013-06-13','08:00:00',3.87),('8975','2013-06-13','08:05:00',3.96),('8975','2013-06-13','08:10:00',4.05),('8975','2013-06-13','08:15:00',4.12),('8975','2013-06-13','08:20:00',4.22),('8975','2013-06-13','08:25:00',4.3),('8975','2013-06-13','08:30:00',4.39),('8975','2013-06-13','08:35:00',4.5),('8975','2013-06-13','08:40:00',4.59),('8975','2013-06-13','08:45:00',4.67),('8975','2013-06-13','08:50:00',4.76),('8975','2013-06-13','08:55:00',4.86),('8975','2013-06-13','09:00:00',4.95),('8975','2013-06-13','09:05:00',5.03),('8975','2013-06-13','09:10:00',5.11),('8975','2013-06-13','09:15:00',5.18),('8975','2013-06-13','09:20:00',5.24),('8975','2013-06-13','09:25:00',5.32),('8975','2013-06-13','09:30:00',5.39),('8975','2013-06-13','09:35:00',5.5),('8975','2013-06-13','09:40:00',5.59),('8975','2013-06-13','09:45:00',5.64),('8975','2013-06-13','09:50:00',5.72),('8975','2013-06-13','09:55:00',5.73),('8975','2013-06-13','10:00:00',5.83),('8975','2013-06-13','10:05:00',5.84),('8975','2013-06-13','10:10:00',5.86),('8975','2013-06-13','10:15:00',6),('8975','2013-06-13','10:20:00',6),('8975','2013-06-13','10:25:00',6.05),('8975','2013-06-13','10:30:00',5.86),('8975','2013-06-13','10:35:00',6.33),('8975','2013-06-13','10:40:00',6.33),('8975','2013-06-13','10:45:00',6.39),('8975','2013-06-13','10:50:00',6.38),('8975','2013-06-13','10:55:00',6.38),('8975','2013-06-13','11:00:00',6.36),('8975','2013-06-13','11:05:00',6.41),('8975','2013-06-13','11:10:00',6.45),('8975','2013-06-13','11:15:00',6.55),('8975','2013-06-13','11:20:00',6.62),('8975','2013-06-13','11:25:00',6.33),('8975','2013-06-13','11:30:00',6.73),('8975','2013-06-13','11:35:00',6.73),('8975','2013-06-13','11:40:00',6.67),('8975','2013-06-13','11:45:00',6.65),('8975','2013-06-13','11:50:00',6.65),('8975','2013-06-13','11:55:00',6.63),('8975','2013-06-13','12:00:00',6.62),('8975','2013-06-13','12:05:00',6.64),('8975','2013-06-13','12:10:00',6.64),('8975','2013-06-13','12:15:00',6.69),('8975','2013-06-13','12:20:00',6.73),('8975','2013-06-13','12:25:00',6.69),('8975','2013-06-13','12:30:00',6.72),('8975','2013-06-13','12:35:00',6.67),('8975','2013-06-13','12:40:00',6.63),('8975','2013-06-13','12:45:00',6.65),('8975','2013-06-13','12:50:00',6.72),('8975','2013-06-13','12:55:00',6.68),('8975','2013-06-13','13:00:00',6.62),('8975','2013-06-13','13:05:00',6.69),('8975','2013-06-13','13:10:00',6.66),('8975','2013-06-13','13:15:00',6.63),('8975','2013-06-13','13:20:00',6.73),('8975','2013-06-13','13:25:00',6.66),('8975','2013-06-13','13:30:00',6.52),('8975','2013-06-13','13:35:00',6.4),('8975','2013-06-13','13:40:00',6.4),('8975','2013-06-13','13:45:00',6.37),('8975','2013-06-13','13:50:00',6.3),('8975','2013-06-13','13:55:00',6.24),('8975','2013-06-13','14:00:00',6.26),('8975','2013-06-13','14:05:00',6.2),('8975','2013-06-13','14:10:00',6.2),('8975','2013-06-13','14:15:00',6.2),('8975','2013-06-13','14:20:00',6.11),('8975','2013-06-13','14:25:00',6.01),('8975','2013-06-13','14:30:00',5.95),('8975','2013-06-13','14:35:00',5.96),('8975','2013-06-13','14:40:00',5.81),('8975','2013-06-13','14:45:00',5.77),('8975','2013-06-13','14:50:00',5.74),('8975','2013-06-13','14:55:00',5.66),('8975','2013-06-13','15:00:00',5.61),('8975','2013-06-13','15:05:00',5.52),('8975','2013-06-13','15:10:00',5.44),('8975','2013-06-13','15:15:00',5.37),('8975','2013-06-13','15:20:00',5.33),('8975','2013-06-13','15:25:00',5.22),('8975','2013-06-13','15:30:00',5.13),('8975','2013-06-13','15:35:00',5.04),('8975','2013-06-13','15:40:00',4.96),('8975','2013-06-13','15:45:00',4.84),('8975','2013-06-13','15:50:00',4.76),('8975','2013-06-13','15:55:00',4.68),('8975','2013-06-13','16:00:00',4.56),('8975','2013-06-13','16:05:00',4.44),('8975','2013-06-13','16:10:00',4.34),('8975','2013-06-13','16:15:00',4.22),('8975','2013-06-13','16:20:00',4.11),('8975','2013-06-13','16:25:00',4.02),('8975','2013-06-13','16:30:00',3.9),('8975','2013-06-13','16:35:00',3.79),('8975','2013-06-13','16:40:00',3.66),('8975','2013-06-13','16:45:00',3.53),('8975','2013-06-13','16:50:00',3.38),('8975','2013-06-13','16:55:00',3.27),('8975','2013-06-13','17:00:00',3.18),('8975','2013-06-13','17:05:00',3),('8975','2013-06-13','17:10:00',2.83),('8975','2013-06-13','17:15:00',2.79),('8975','2013-06-13','17:20:00',2.64),('8975','2013-06-13','17:25:00',2.58),('8975','2013-06-13','17:30:00',2.38),('8975','2013-06-13','17:35:00',2.31),('8975','2013-06-13','17:40:00',2.27),('8975','2013-06-13','17:45:00',2.17),('8975','2013-06-13','17:50:00',2.06),('8975','2013-06-13','17:55:00',1.95),('8975','2013-06-13','18:00:00',1.85),('8975','2013-06-13','18:05:00',1.76),('8975','2013-06-13','18:10:00',1.71),('8975','2013-06-13','18:15:00',1.62),('8975','2013-06-13','18:20:00',1.53),('8975','2013-06-13','18:25:00',1.46),('8975','2013-06-13','18:30:00',1.41),('8975','2013-06-13','18:35:00',1.35),('8975','2013-06-13','18:40:00',1.3),('8975','2013-06-13','18:45:00',1.27),('8975','2013-06-13','18:50:00',1.21),('8975','2013-06-13','18:55:00',1.17),('8975','2013-06-13','19:00:00',1.11),('8975','2013-06-13','19:05:00',1.02),('8975','2013-06-12','06:15:00',1.24),('8975','2013-06-12','06:20:00',1.41),('8975','2013-06-12','06:25:00',1.56),('8975','2013-06-12','06:30:00',1.7),('8975','2013-06-12','06:35:00',1.86),('8975','2013-06-12','06:40:00',1.98),('8975','2013-06-12','06:45:00',2.13),('8975','2013-06-12','06:50:00',2.29),('8975','2013-06-12','06:55:00',2.42),('8975','2013-06-12','07:00:00',2.52),('8975','2013-06-12','07:05:00',2.62),('8975','2013-06-12','07:10:00',2.76),('8975','2013-06-12','07:15:00',2.9),('8975','2013-06-12','07:20:00',3.05),('8975','2013-06-12','07:25:00',3.17),('8975','2013-06-12','07:30:00',3.28),('8975','2013-06-12','07:35:00',3.39),('8975','2013-06-12','07:40:00',3.5),('8975','2013-06-12','07:45:00',3.6),('8975','2013-06-12','07:50:00',3.72),('8975','2013-06-12','07:55:00',3.83),('8975','2013-06-12','08:00:00',3.91),('8975','2013-06-12','08:05:00',3.97),('8975','2013-06-12','08:10:00',4.07),('8975','2013-06-12','08:15:00',4.17),('8975','2013-06-12','08:20:00',4.28),('8975','2013-06-12','08:25:00',4.38),('8975','2013-06-12','08:30:00',4.46),('8975','2013-06-12','08:35:00',4.57),('8975','2013-06-12','08:40:00',4.68),('8975','2013-06-12','08:45:00',4.74),('8975','2013-06-12','08:50:00',4.83),('8975','2013-06-12','08:55:00',4.91),('8975','2013-06-12','09:00:00',4.99),('8975','2013-06-12','09:05:00',5.07),('8975','2013-06-12','09:10:00',5.19),('8975','2013-06-12','09:15:00',5.26),('8975','2013-06-12','09:20:00',5.35),('8975','2013-06-12','09:25:00',5.47),('8975','2013-06-12','09:30:00',5.58),('8975','2013-06-12','09:35:00',5.65),('8975','2013-06-12','09:40:00',5.73),('8975','2013-06-12','09:45:00',5.84),('8975','2013-06-12','09:50:00',5.91),('8975','2013-06-12','09:55:00',5.96),('8975','2013-06-12','10:00:00',6.03),('8975','2013-06-12','10:05:00',6.11),('8975','2013-06-12','10:10:00',6.14),('8975','2013-06-12','10:15:00',6.24),('8975','2013-06-12','10:20:00',6.33),('8975','2013-06-12','10:25:00',6.38),('8975','2013-06-12','10:30:00',6.47),('8975','2013-06-12','10:35:00',6.54),('8975','2013-06-12','10:40:00',6.61),('8975','2013-06-12','10:45:00',6.66),('8975','2013-06-12','10:50:00',6.71),('8975','2013-06-12','10:55:00',6.78),('8975','2013-06-12','11:00:00',6.8),('8975','2013-06-12','11:05:00',6.81),('8975','2013-06-12','11:10:00',6.84),('8975','2013-06-12','11:15:00',6.87),('8975','2013-06-12','11:20:00',6.89),('8975','2013-06-12','11:25:00',6.92),('8975','2013-06-12','11:30:00',6.95),('8975','2013-06-12','11:35:00',7.01),('8975','2013-06-12','11:40:00',7.03),('8975','2013-06-12','11:45:00',6.96),('8975','2013-06-12','11:50:00',7.06),('8975','2013-06-12','11:55:00',6.7),('8975','2013-06-12','12:00:00',6.8),('8975','2013-06-12','12:05:00',5.64),('8975','2013-06-12','12:10:00',5.35),('8975','2013-06-12','12:15:00',5.97),('8975','2013-06-12','12:20:00',6.98),('8975','2013-06-12','12:25:00',6.63),('8975','2013-06-12','12:30:00',6.76),('8975','2013-06-12','12:35:00',6.5),('8975','2013-06-12','12:40:00',6.38),('8975','2013-06-12','12:45:00',6.7),('8975','2013-06-12','12:50:00',7),('8975','2013-06-12','12:55:00',7),('8975','2013-06-12','13:00:00',6.99),('8975','2013-06-12','13:05:00',6.93),('8975','2013-06-12','13:10:00',6.92),('8975','2013-06-12','13:15:00',6.83),('8975','2013-06-12','13:20:00',6.85),('8975','2013-06-12','13:25:00',6.81),('8975','2013-06-12','13:30:00',6.75),('8975','2013-06-12','13:35:00',6.68),('8975','2013-06-12','13:40:00',6.65),('8975','2013-06-12','13:45:00',5.98),('8975','2013-06-12','13:50:00',6.53),('8975','2013-06-12','13:55:00',6.53),('8975','2013-06-12','14:00:00',6.49),('8975','2013-06-12','14:05:00',6.41),('8975','2013-06-12','14:10:00',6.3),('8975','2013-06-12','14:15:00',6.28),('8975','2013-06-12','14:20:00',3.52),('8975','2013-06-12','14:25:00',4.92),('8975','2013-06-12','14:30:00',4.19),('8975','2013-06-12','14:35:00',1.77),('8975','2013-06-12','14:40:00',3.44),('8975','2013-06-12','14:45:00',6.15),('8975','2013-06-12','14:50:00',5.99),('8975','2013-06-12','14:55:00',5.79),('8975','2013-06-12','15:00:00',5.67),('8975','2013-06-12','15:05:00',5.6),('8975','2013-06-12','15:10:00',5.5),('8975','2013-06-12','15:15:00',5.41),('8975','2013-06-12','15:20:00',5.32),('8975','2013-06-12','15:25:00',5.21),('8975','2013-06-12','15:30:00',5.11),('8975','2013-06-12','15:35:00',5.08),('8975','2013-06-12','15:40:00',4.97),('8975','2013-06-12','15:45:00',4.83),('8975','2013-06-12','15:50:00',4.76),('8975','2013-06-12','15:55:00',4.65),('8975','2013-06-12','16:00:00',4.47),('8975','2013-06-12','16:05:00',4.4),('8975','2013-06-12','16:10:00',4.29),('8975','2013-06-12','16:15:00',4.18),('8975','2013-06-12','16:20:00',4.03),('8975','2013-06-12','16:25:00',3.95),('8975','2013-06-12','16:30:00',3.8),('8975','2013-06-12','16:35:00',3.7),('8975','2013-06-12','16:40:00',3.56),('8975','2013-06-12','16:45:00',3.5),('8975','2013-06-12','16:50:00',3.37),('8975','2013-06-12','16:55:00',3.31),('8975','2013-06-12','17:00:00',3.22),('8975','2013-06-12','17:05:00',3.09),('8975','2013-06-12','17:10:00',2.97),('8975','2013-06-12','17:15:00',2.84),('8975','2013-06-12','17:20:00',2.71),('8975','2013-06-12','17:25:00',2.58),('8975','2013-06-12','17:30:00',2.46),('8975','2013-06-12','17:35:00',2.36),('8975','2013-06-12','17:40:00',2.25),('8975','2013-06-12','17:45:00',2.13),('8975','2013-06-12','17:50:00',2.04),('8975','2013-06-12','17:55:00',1.93),('8975','2013-06-12','18:00:00',1.84),('8975','2013-06-12','18:05:00',1.75),('8975','2013-06-12','18:10:00',1.67),('8975','2013-06-12','18:15:00',1.6),('8975','2013-06-12','18:20:00',1.52),('8975','2013-06-12','18:25:00',1.45),('8975','2013-06-12','18:30:00',1.38),('8975','2013-06-12','18:35:00',1.32),('8975','2013-06-12','18:40:00',1.27),('8975','2013-06-12','18:45:00',1.22),('8975','2013-06-12','18:50:00',1.19),('8975','2013-06-12','18:55:00',1.13),('8975','2013-06-12','19:00:00',1.09),('8975','2013-06-12','19:05:00',1.04),('8975','2013-06-11','06:15:00',1.26),('8975','2013-06-11','06:20:00',1.44),('8975','2013-06-11','06:25:00',1.61),('8975','2013-06-11','06:30:00',1.75),('8975','2013-06-11','06:35:00',1.9),('8975','2013-06-11','06:40:00',2.05),('8975','2013-06-11','06:45:00',2.18),('8975','2013-06-11','06:50:00',2.31),('8975','2013-06-11','06:55:00',2.44),('8975','2013-06-11','07:00:00',2.61),('8975','2013-06-11','07:05:00',2.74),('8975','2013-06-11','07:10:00',2.85),('8975','2013-06-11','07:15:00',2.95),('8975','2013-06-11','07:20:00',3.08),('8975','2013-06-11','07:25:00',3.18),('8975','2013-06-11','07:30:00',3.29),('8975','2013-06-11','07:35:00',3.38),('8975','2013-06-11','07:40:00',3.49),('8975','2013-06-11','07:45:00',3.57),('8975','2013-06-11','07:50:00',3.68),('8975','2013-06-11','07:55:00',3.8),('8975','2013-06-11','08:00:00',3.9),('8975','2013-06-11','08:05:00',4.01),('8975','2013-06-11','08:10:00',4.12),('8975','2013-06-11','08:15:00',4.22),('8975','2013-06-11','08:20:00',4.34),('8975','2013-06-11','08:25:00',4.46),('8975','2013-06-11','08:30:00',4.57),('8975','2013-06-11','08:35:00',4.66),('8975','2013-06-11','08:40:00',4.74),('8975','2013-06-11','08:45:00',4.85),('8975','2013-06-11','08:50:00',4.98),('8975','2013-06-11','08:55:00',5.09),('8975','2013-06-11','09:00:00',5.2),('8975','2013-06-11','09:05:00',5.28),('8975','2013-06-11','09:10:00',5.4),('8975','2013-06-11','09:15:00',5.5),('8975','2013-06-11','09:20:00',5.61),('8975','2013-06-11','09:25:00',5.7),('8975','2013-06-11','09:30:00',5.77),('8975','2013-06-11','09:35:00',5.87),('8975','2013-06-11','09:40:00',5.92),('8975','2013-06-11','09:45:00',5.94),('8975','2013-06-11','09:50:00',6.03),('8975','2013-06-11','09:55:00',6.14),('8975','2013-06-11','10:00:00',6.2),('8975','2013-06-11','10:05:00',6.24),('8975','2013-06-11','10:10:00',6.32),('8975','2013-06-11','10:15:00',6.35),('8975','2013-06-11','10:20:00',6.44),('8975','2013-06-11','10:25:00',6.48),('8975','2013-06-11','10:30:00',6.57),('8975','2013-06-11','10:35:00',6.58),('8975','2013-06-11','10:40:00',6.57),('8975','2013-06-11','10:45:00',6.63),('8975','2013-06-11','10:50:00',6.63),('8975','2013-06-11','10:55:00',6.73),('8975','2013-06-11','11:00:00',6.71),('8975','2013-06-11','11:05:00',6.82),('8975','2013-06-11','11:10:00',6.86),('8975','2013-06-11','11:15:00',6.91),('8975','2013-06-11','11:20:00',6.98),('8975','2013-06-11','11:25:00',6.96),('8975','2013-06-11','11:30:00',6.98),('8975','2013-06-11','11:35:00',6.95),('8975','2013-06-11','11:40:00',6.92),('8975','2013-06-11','11:45:00',6.95),('8975','2013-06-11','11:50:00',7.01),('8975','2013-06-11','11:55:00',7.04),('8975','2013-06-11','12:00:00',7.11),('8975','2013-06-11','12:05:00',6.98),('8975','2013-06-11','12:10:00',6.5),('8975','2013-06-11','12:15:00',6.63),('8975','2013-06-11','12:20:00',7.07),('8975','2013-06-11','12:25:00',5.87),('8975','2013-06-11','12:30:00',5),('8975','2013-06-11','12:35:00',4.15),('8975','2013-06-11','12:40:00',6.86),('8975','2013-06-11','12:45:00',2.1),('8975','2013-06-11','12:50:00',1.45),('8975','2013-06-11','12:55:00',3.29),('8975','2013-06-11','13:00:00',5.85),('8975','2013-06-11','13:05:00',3.12),('8975','2013-06-11','13:10:00',4.36),('8975','2013-06-11','13:15:00',5.78),('8975','2013-06-11','13:20:00',6.82),('8975','2013-06-11','13:25:00',6.97),('8975','2013-06-11','13:30:00',6.77),('8975','2013-06-11','13:35:00',6.76),('8975','2013-06-11','13:40:00',6.73),('8975','2013-06-11','13:45:00',6.82),('8975','2013-06-11','13:50:00',5.71),('8975','2013-06-11','13:55:00',6.21),('8975','2013-06-11','14:00:00',4.84),('8975','2013-06-11','14:05:00',5.58),('8975','2013-06-11','14:10:00',1.63),('8975','2013-06-11','14:15:00',6.18),('8975','2013-06-11','14:20:00',6.07),('8975','2013-06-11','14:25:00',5.41),('8975','2013-06-11','14:30:00',4.59),('8975','2013-06-11','14:35:00',6.49),('8975','2013-06-11','14:40:00',6.48),('8975','2013-06-11','14:45:00',6.23),('8975','2013-06-11','14:50:00',5.99),('8975','2013-06-11','14:55:00',6.16),('8975','2013-06-11','15:00:00',6.11),('8975','2013-06-11','15:05:00',5.98),('8975','2013-06-11','15:10:00',5.86),('8975','2013-06-11','15:15:00',5.78),('8975','2013-06-11','15:20:00',5.46),('8975','2013-06-11','15:25:00',5.4),('8975','2013-06-11','15:30:00',5.27),('8975','2013-06-11','15:35:00',5.26),('8975','2013-06-11','15:40:00',5.14),('8975','2013-06-11','15:45:00',5.05),('8975','2013-06-11','15:50:00',4.93),('8975','2013-06-11','15:55:00',4.91),('8975','2013-06-11','16:00:00',4.8),('8975','2013-06-11','16:05:00',4.63),('8975','2013-06-11','16:10:00',4.48),('8975','2013-06-11','16:15:00',4.37),('8975','2013-06-11','16:20:00',4.27),('8975','2013-06-11','16:25:00',4.17),('8975','2013-06-11','16:30:00',4.09),('8975','2013-06-11','16:35:00',3.96),('8975','2013-06-11','16:40:00',3.85),('8975','2013-06-11','16:45:00',3.75),('8975','2013-06-11','16:50:00',3.58),('8975','2013-06-11','16:55:00',3.38),('8975','2013-06-11','17:00:00',3.28),('8975','2013-06-11','17:05:00',3.13),('8975','2013-06-11','17:10:00',3.06),('8975','2013-06-11','17:15:00',2.93),('8975','2013-06-11','17:20:00',2.83),('8975','2013-06-11','17:25:00',2.71),('8975','2013-06-11','17:30:00',2.54),('8975','2013-06-11','17:35:00',2.24),('8975','2013-06-11','17:40:00',2.39),('8975','2013-06-11','17:45:00',2.17),('8975','2013-06-11','18:10:00',1.81),('8975','2013-06-11','18:15:00',1.7),('8975','2013-06-11','18:20:00',1.65),('8975','2013-06-11','18:25:00',1.49),('8975','2013-06-11','18:30:00',1.42),('8975','2013-06-11','18:35:00',1.38),('8975','2013-06-11','18:40:00',1.32),('8975','2013-06-11','18:45:00',1.29),('8975','2013-06-11','18:50:00',1.21),('8975','2013-06-11','18:55:00',1.17),('8975','2013-06-11','19:00:00',1.13),('8975','2013-06-11','19:05:00',1.07),('8975','2013-06-10','07:00:00',1.06),('8975','2013-06-10','07:10:00',1.13),('8975','2013-06-10','07:15:00',1.61),('8975','2013-06-10','07:20:00',1.76),('8975','2013-06-10','07:25:00',2.33),('8975','2013-06-10','07:30:00',3.27),('8975','2013-06-10','07:35:00',3.37),('8975','2013-06-10','07:40:00',3.44),('8975','2013-06-10','07:45:00',3.58),('8975','2013-06-10','07:50:00',3.71),('8975','2013-06-10','07:55:00',2.61),('8975','2013-06-10','08:00:00',3.4),('8975','2013-06-10','08:05:00',4.33),('8975','2013-06-10','08:10:00',4.34),('8975','2013-06-10','08:15:00',4.26),('8975','2013-06-10','08:20:00',1.69),('8975','2013-06-10','08:25:00',4.75),('8975','2013-06-10','08:30:00',2.84),('8975','2013-06-10','08:35:00',1.68),('8975','2013-06-10','08:40:00',5.22),('8975','2013-06-10','08:45:00',5.24),('8975','2013-06-10','08:50:00',5.3),('8975','2013-06-10','08:55:00',5.47),('8975','2013-06-10','09:00:00',5.65),('8975','2013-06-10','09:05:00',5.53),('8975','2013-06-10','09:10:00',5.56),('8975','2013-06-10','09:15:00',5.51),('8975','2013-06-10','09:20:00',5.7),('8975','2013-06-10','09:25:00',5.88),('8975','2013-06-10','09:30:00',5.45),('8975','2013-06-10','09:35:00',2.35),('8975','2013-06-10','09:40:00',4.05),('8975','2013-06-10','09:45:00',6.49),('8975','2013-06-10','09:50:00',5.53),('8975','2013-06-10','09:55:00',2),('8975','2013-06-10','10:00:00',3.4),('8975','2013-06-10','10:05:00',5.7),('8975','2013-06-10','10:10:00',4.58),('8975','2013-06-10','10:15:00',4.86),('8975','2013-06-10','10:20:00',3.05),('8975','2013-06-10','10:25:00',5.11),('8975','2013-06-10','10:30:00',6.51),('8975','2013-06-10','10:35:00',6.66),('8975','2013-06-10','10:40:00',6.75),('8975','2013-06-10','10:45:00',6.67),('8975','2013-06-10','10:50:00',6.85),('8975','2013-06-10','10:55:00',6.77),('8975','2013-06-10','11:00:00',6.4),('8975','2013-06-10','11:05:00',5.01),('8975','2013-06-10','11:10:00',4.63),('8975','2013-06-10','11:15:00',7.34),('8975','2013-06-10','11:20:00',7.09),('8975','2013-06-10','11:25:00',7.06),('8975','2013-06-10','11:30:00',7.04),('8975','2013-06-10','11:35:00',7.02),('8975','2013-06-10','11:40:00',7.02),('8975','2013-06-10','11:45:00',7.05),('8975','2013-06-10','11:50:00',7.04),('8975','2013-06-10','11:55:00',7.08),('8975','2013-06-10','12:00:00',7.13),('8975','2013-06-10','12:05:00',7.13),('8975','2013-06-10','12:10:00',7.09),('8975','2013-06-10','12:15:00',7.11),('8975','2013-06-10','12:20:00',7.14),('8975','2013-06-10','12:25:00',7.1),('8975','2013-06-10','12:30:00',7.13),('8975','2013-06-10','12:35:00',7.12),('8975','2013-06-10','12:40:00',7.15),('8975','2013-06-10','12:45:00',7.11),('8975','2013-06-10','12:50:00',7.19),('8975','2013-06-10','12:55:00',7.12),('8975','2013-06-10','13:00:00',7.04),('8975','2013-06-10','13:05:00',7.09),('8975','2013-06-10','13:10:00',7.06),('8975','2013-06-10','13:15:00',7.03),('8975','2013-06-10','13:20:00',6.55),('8975','2013-06-10','13:25:00',6.87),('8975','2013-06-10','13:30:00',6.93),('8975','2013-06-10','13:35:00',6.95),('8975','2013-06-10','13:40:00',6.92),('8975','2013-06-10','13:45:00',7.02),('8975','2013-06-10','13:50:00',7),('8975','2013-06-10','13:55:00',6.83),('8975','2013-06-10','14:00:00',6.48),('8975','2013-06-10','14:05:00',6.73),('8975','2013-06-10','14:10:00',6.57),('8975','2013-06-10','14:15:00',6.42),('8975','2013-06-10','14:20:00',6.37),('8975','2013-06-10','14:25:00',6.32),('8975','2013-06-10','14:30:00',6.24),('8975','2013-06-10','14:35:00',6.2),('8975','2013-06-10','14:40:00',6.16),('8975','2013-06-10','14:45:00',6.09),('8975','2013-06-10','14:50:00',6),('8975','2013-06-10','14:55:00',5.93),('8975','2013-06-10','15:00:00',5.87),('8975','2013-06-10','15:05:00',5.75),('8975','2013-06-10','15:10:00',5.47),('8975','2013-06-10','15:15:00',5.58),('8975','2013-06-10','15:20:00',5.49),('8975','2013-06-10','15:25:00',5.31),('8975','2013-06-10','15:30:00',5.39),('8975','2013-06-10','15:35:00',5.18),('8975','2013-06-10','15:40:00',4.77),('8975','2013-06-10','15:45:00',4.68),('8975','2013-06-10','15:50:00',5.08),('8975','2013-06-10','15:55:00',4.97),('8975','2013-06-10','16:00:00',4.9),('8975','2013-06-10','16:05:00',4.76),('8975','2013-06-10','16:10:00',4.64),('8975','2013-06-10','16:15:00',4.54),('8975','2013-06-10','16:20:00',4.42),('8975','2013-06-10','16:25:00',4.34),('8975','2013-06-10','16:30:00',4.23),('8975','2013-06-10','16:35:00',4.15),('8975','2013-06-10','16:40:00',4.15),('8975','2013-06-10','16:45:00',4.29),('8975','2013-06-10','16:50:00',4.28),('8975','2013-06-10','16:55:00',4.13),('8975','2013-06-10','17:00:00',2.68),('8975','2013-06-10','17:05:00',2.33),('8975','2013-06-10','17:10:00',1.4),('8975','2013-06-10','17:15:00',1.14),('8975','2013-06-10','17:20:00',1.01),('8975','2013-06-10','19:30:00',1),('8975','2013-06-10','19:35:00',1.06),('8975','2014-04-02','08:15:00',1.05),('8975','2014-04-02','08:20:00',1.07),('8975','2014-04-02','08:25:00',1.05),('8975','2014-04-02','08:30:00',1.14),('8975','2014-04-02','08:35:00',1.21),('8975','2014-04-02','08:40:00',1.37),('8975','2014-04-02','08:45:00',1.6),('8975','2014-04-02','08:50:00',1.72),('8975','2014-04-02','08:55:00',1.96),('8975','2014-04-02','09:00:00',2.18),('8975','2014-04-02','09:05:00',2.26),('8975','2014-04-02','09:10:00',2.15),('8975','2014-04-02','09:15:00',2.01),('8975','2014-04-02','09:20:00',2.06),('8975','2014-04-02','09:25:00',2.14),('8975','2014-04-02','09:30:00',2.69),('8975','2014-04-02','09:35:00',3.19),('8975','2014-04-02','09:40:00',3.26),('8975','2014-04-02','09:45:00',3.24),('8975','2014-04-02','09:50:00',3.18),('8975','2014-04-02','09:55:00',3.33),('8975','2014-04-02','10:00:00',3.93),('8975','2014-04-02','10:05:00',4.72),('8975','2014-04-02','10:10:00',4.89),('8975','2014-04-02','10:15:00',5.51),('8975','2014-04-02','10:20:00',5.45),('8975','2014-04-02','10:25:00',3.91),('8975','2014-04-02','10:30:00',4.06),('8975','2014-04-02','10:35:00',4.5),('8975','2014-04-02','10:40:00',3.48),('8975','2014-04-02','10:45:00',3.52),('8975','2014-04-02','10:50:00',3.23),('8975','2014-04-02','10:55:00',3.65),('8975','2014-04-02','11:00:00',3.03),('8975','2014-04-02','11:05:00',2.71),('8975','2014-04-02','11:10:00',2.52),('8975','2014-04-02','11:15:00',2.34),('8975','2014-04-02','11:20:00',2.24),('8975','2014-04-02','11:25:00',2.1),('8975','2014-04-02','11:30:00',2.11),('8975','2014-04-02','11:35:00',2.26),('8975','2014-04-02','11:40:00',2.49),('8975','2014-04-02','11:45:00',2.95),('8975','2014-04-02','11:50:00',3.69),('8975','2014-04-02','11:55:00',3.75),('8975','2014-04-02','12:00:00',3.58),('8975','2014-04-02','12:05:00',3.53),('8975','2014-04-02','12:10:00',3.45),('8975','2014-04-02','12:15:00',3.41),('8975','2014-04-02','12:20:00',3.84),('8975','2014-04-02','12:25:00',4.92),('8975','2014-04-02','12:30:00',6.44),('8975','2014-04-02','12:35:00',6.15),('8975','2014-04-02','12:40:00',6.1),('8975','2014-04-02','12:45:00',3.24),('8975','2014-04-02','12:50:00',4.25),('8975','2014-04-02','12:55:00',3.91),('8975','2014-04-02','13:00:00',4.94),('8975','2014-04-02','13:05:00',5.58),('8975','2014-04-02','13:10:00',4.18),('8975','2014-04-02','13:15:00',6.99),('8975','2014-04-02','13:20:00',3.86),('8975','2014-04-02','13:25:00',4.65),('8975','2014-04-02','13:30:00',5.27),('8975','2014-04-02','13:35:00',6.44),('8975','2014-04-02','13:40:00',4.83),('8975','2014-04-02','13:45:00',3.21),('8975','2014-04-02','13:50:00',3.01),('8975','2014-04-02','13:55:00',4.31),('8975','2014-04-02','14:00:00',5.07),('8975','2014-04-02','14:05:00',4.88),('8975','2014-04-02','14:10:00',3.49),('8975','2014-04-02','14:15:00',5.58),('8975','2014-04-02','14:20:00',5.21),('8975','2014-04-02','14:25:00',4.93),('8975','2014-04-02','14:30:00',5.51),('8975','2014-04-02','14:35:00',5.26),('8975','2014-04-02','14:40:00',5.05),('8975','2014-04-02','14:45:00',4.83),('8975','2014-04-02','14:50:00',4.74),('8975','2014-04-02','14:55:00',4.6),('8975','2014-04-02','15:00:00',4.5),('8975','2014-04-02','15:05:00',4.41),('8975','2014-04-02','15:10:00',4.29),('8975','2014-04-02','15:15:00',4.17),('8975','2014-04-02','15:20:00',4.12),('8975','2014-04-02','15:25:00',4),('8975','2014-04-02','15:30:00',3.92),('8975','2014-04-02','15:35:00',3.71),('8975','2014-04-02','15:40:00',3.76),('8975','2014-04-02','15:45:00',3.66),('8975','2014-04-02','15:50:00',3.5),('8975','2014-04-02','15:55:00',3.35),('8975','2014-04-02','16:00:00',3.36),('8975','2014-04-02','16:05:00',3.25),('8975','2014-04-02','16:10:00',3.21),('8975','2014-04-02','16:15:00',3.09),('8975','2014-04-02','16:20:00',2.99),('8975','2014-04-02','16:25:00',2.84),('8975','2014-04-02','16:30:00',2.72),('8975','2014-04-02','16:35:00',2.63),('8975','2014-04-02','16:40:00',2.55),('8975','2014-04-02','16:45:00',2.36),('8975','2014-04-02','16:50:00',2.16),('8975','2014-04-02','16:55:00',1.9),('8975','2014-04-02','17:00:00',1.53),('8975','2014-04-02','17:05:00',1.41),('8975','2014-04-02','17:10:00',1.26),('8975','2014-04-02','17:15:00',1.16),('8975','2014-04-02','17:20:00',1.55),('8975','2014-04-02','17:25:00',1.25),('8975','2014-04-02','17:30:00',1.17),('8975','2014-04-02','17:45:00',1.55),('8975','2014-04-02','17:50:00',1.49),('8975','2014-04-02','17:55:00',1.39),('8975','2014-04-02','18:00:00',1.31),('8975','2014-04-02','18:05:00',1.24),('8975','2014-04-02','18:10:00',1.18),('8975','2014-04-02','18:15:00',1.09),('8975','2014-04-02','18:20:00',1.02),('8975','2013-06-09','07:05:00',1.59),('8975','2013-06-09','07:10:00',2.27),('8975','2013-06-09','07:20:00',1.94),('8975','2013-06-09','07:25:00',1.71),('8975','2013-06-09','07:30:00',2.66),('8975','2013-06-09','07:35:00',3.83),('8975','2013-06-09','07:40:00',2.05),('8975','2013-06-09','07:45:00',1.69),('8975','2013-06-09','07:50:00',1.37),('8975','2013-06-09','07:55:00',1.48),('8975','2013-06-09','08:00:00',1.64),('8975','2013-06-09','08:05:00',3.17),('8975','2013-06-09','08:10:00',4.28),('8975','2013-06-09','08:15:00',3.31),('8975','2013-06-09','08:20:00',3.25),('8975','2013-06-09','08:25:00',2.35),('8975','2013-06-09','08:30:00',2.14),('8975','2013-06-09','08:35:00',2.1),('8975','2013-06-09','08:40:00',1.68),('8975','2013-06-09','08:45:00',2.03),('8975','2013-06-09','08:50:00',2.27),('8975','2013-06-09','08:55:00',2.19),('8975','2013-06-09','09:00:00',2.74),('8975','2013-06-09','09:05:00',2.03),('8975','2013-06-09','09:10:00',2.88),('8975','2013-06-09','09:15:00',1.59),('8975','2013-06-09','09:20:00',3.91),('8975','2013-06-09','09:25:00',4.93),('8975','2013-06-09','09:30:00',4.86),('8975','2013-06-09','09:35:00',5.74),('8975','2013-06-09','09:40:00',3.16),('8975','2013-06-09','09:45:00',5.04),('8975','2013-06-09','09:50:00',3.05),('8975','2013-06-09','09:55:00',3.21),('8975','2013-06-09','10:00:00',4.75),('8975','2013-06-09','10:05:00',5.95),('8975','2013-06-09','10:10:00',3.77),('8975','2013-06-09','10:15:00',6.21),('8975','2013-06-09','10:20:00',6.85),('8975','2013-06-09','10:25:00',6.14),('8975','2013-06-09','10:30:00',4.97),('8975','2013-06-09','10:35:00',5.07),('8975','2013-06-09','10:40:00',3.66),('8975','2013-06-09','10:45:00',3.36),('8975','2013-06-09','10:50:00',3.27),('8975','2013-06-09','10:55:00',6.51),('8975','2013-06-09','11:00:00',2.25),('8975','2013-06-09','11:05:00',2.35),('8975','2013-06-09','11:10:00',4.96),('8975','2013-06-09','11:15:00',4.29),('8975','2013-06-09','11:20:00',5.29),('8975','2013-06-09','11:25:00',4.9),('8975','2013-06-09','11:30:00',4.67),('8975','2013-06-09','11:35:00',7.14),('8975','2013-06-09','11:40:00',3.43),('8975','2013-06-09','11:45:00',2.88),('8975','2013-06-09','11:50:00',2.57),('8975','2013-06-09','11:55:00',5.88),('8975','2013-06-09','12:00:00',2.8),('8975','2013-06-09','12:05:00',2.29),('8975','2013-06-09','12:10:00',4.55),('8975','2013-06-09','12:15:00',4.14),('8975','2013-06-09','12:20:00',7.08),('8975','2013-06-09','12:25:00',6.35),('8975','2013-06-09','12:30:00',6.1),('8975','2013-06-09','12:35:00',3.66),('8975','2013-06-09','12:40:00',5.28),('8975','2013-06-09','12:45:00',4.85),('8975','2013-06-09','12:50:00',6.34),('8975','2013-06-09','12:55:00',3.64),('8975','2013-06-09','13:00:00',5.28),('8975','2013-06-09','13:05:00',3.96),('8975','2013-06-09','13:10:00',3.14),('8975','2013-06-09','13:15:00',8.04),('8975','2013-06-09','13:20:00',5.51),('8975','2013-06-09','13:25:00',5.33),('8975','2013-06-09','13:30:00',6.7),('8975','2013-06-09','13:35:00',7.74),('8975','2013-06-09','13:40:00',5.42),('8975','2013-06-09','13:45:00',7.36),('8975','2013-06-09','13:50:00',5.36),('8975','2013-06-09','13:55:00',6.3),('8975','2013-06-09','14:00:00',6.32),('8975','2013-06-09','14:05:00',6.55),('8975','2013-06-09','14:10:00',5.36),('8975','2013-06-09','14:15:00',7.01),('8975','2013-06-09','14:20:00',6.69),('8975','2013-06-09','14:25:00',6.31),('8975','2013-06-09','14:30:00',5.83),('8975','2013-06-09','14:35:00',6.22),('8975','2013-06-09','14:40:00',5.27),('8975','2013-06-09','14:45:00',6.42),('8975','2013-06-09','14:50:00',6.1),('8975','2013-06-09','14:55:00',6),('8975','2013-06-09','15:00:00',5.87),('8975','2013-06-09','15:05:00',5.76),('8975','2013-06-09','15:10:00',5.64),('8975','2013-06-09','15:15:00',5.63),('8975','2013-06-09','15:20:00',5.54),('8975','2013-06-09','15:25:00',5.47),('8975','2013-06-09','15:30:00',5.36),('8975','2013-06-09','15:35:00',5.29),('8975','2013-06-09','15:40:00',5.21),('8975','2013-06-09','15:45:00',5.07),('8975','2013-06-09','15:50:00',4.95),('8975','2013-06-09','15:55:00',4.87),('8975','2013-06-09','16:00:00',4.76),('8975','2013-06-09','16:05:00',4.62),('8975','2013-06-09','16:10:00',4.53),('8975','2013-06-09','16:15:00',4.44),('8975','2013-06-09','16:20:00',4.31),('8975','2013-06-09','16:25:00',4.21),('8975','2013-06-09','16:30:00',4.08),('8975','2013-06-09','16:35:00',3.98),('8975','2013-06-09','16:40:00',3.82),('8975','2013-06-09','16:45:00',3.69),('8975','2013-06-09','16:50:00',3.55),('8975','2013-06-09','16:55:00',3.43),('8975','2013-06-09','17:00:00',3.34),('8975','2013-06-09','17:05:00',3.24),('8975','2013-06-09','17:10:00',3.12),('8975','2013-06-09','17:15:00',2.99),('8975','2013-06-09','17:20:00',2.87),('8975','2013-06-09','17:25:00',2.73),('8975','2013-06-09','17:30:00',2.61),('8975','2013-06-09','17:35:00',2.48),('8975','2013-06-09','17:40:00',2.36),('8975','2013-06-09','17:45:00',2.26),('8975','2013-06-09','17:50:00',2.15),('8975','2013-06-09','17:55:00',2.06),('8975','2013-06-09','18:00:00',1.94),('8975','2013-06-09','18:05:00',1.84),('8975','2013-06-09','18:10:00',1.76),('8975','2013-06-09','18:15:00',1.68),('8975','2013-06-09','18:20:00',1.6),('8975','2013-06-09','18:25:00',1.53),('8975','2013-06-09','18:30:00',1.47),('8975','2013-06-09','18:35:00',1.41),('8975','2013-06-09','18:40:00',1.36),('8975','2013-06-09','18:45:00',1.31),('8975','2013-06-09','18:50:00',1.26),('8975','2013-06-09','18:55:00',1.21),('8975','2013-06-09','19:00:00',1.15),('8975','2013-06-09','19:05:00',1.09),('8975','2013-06-09','19:10:00',1.04),('8975','2013-06-08','07:25:00',1.57),('8975','2013-06-08','07:30:00',2.8),('8975','2013-06-08','07:35:00',3.51),('8975','2013-06-08','07:40:00',2.37),('8975','2013-06-08','07:45:00',2.03),('8975','2013-06-08','07:50:00',2.85),('8975','2013-06-08','07:55:00',3.53),('8975','2013-06-08','08:00:00',3.71),('8975','2013-06-08','08:05:00',3.69),('8975','2013-06-08','08:10:00',2.98),('8975','2013-06-08','08:15:00',3.67),('8975','2013-06-08','08:20:00',4.11),('8975','2013-06-08','08:25:00',4.19),('8975','2013-06-08','08:30:00',4.28),('8975','2013-06-08','08:35:00',4.41),('8975','2013-06-08','08:40:00',4.57),('8975','2013-06-08','08:45:00',4.6),('8975','2013-06-08','08:50:00',4.65),('8975','2013-06-08','08:55:00',4.79),('8975','2013-06-08','09:00:00',4.83),('8975','2013-06-08','09:05:00',4.95),('8975','2013-06-08','09:10:00',5.01),('8975','2013-06-08','09:15:00',5.04),('8975','2013-06-08','09:20:00',5.17),('8975','2013-06-08','09:25:00',5.25),('8975','2013-06-08','09:30:00',5.34),('8975','2013-06-08','09:35:00',5.34),('8975','2013-06-08','09:40:00',5.49),('8975','2013-06-08','09:45:00',5.55),('8975','2013-06-08','09:50:00',5.64),('8975','2013-06-08','09:55:00',5.72),('8975','2013-06-08','10:00:00',5.73),('8975','2013-06-08','10:05:00',5.76),('8975','2013-06-08','10:10:00',5.94),('8975','2013-06-08','10:15:00',6.01),('8975','2013-06-08','10:20:00',6.03),('8975','2013-06-08','10:25:00',6.01),('8975','2013-06-08','10:30:00',6.03),('8975','2013-06-08','10:35:00',6.1),('8975','2013-06-08','10:40:00',6.1),('8975','2013-06-08','10:45:00',6.13),('8975','2013-06-08','10:50:00',6.19),('8975','2013-06-08','10:55:00',5.77),('8975','2013-06-08','11:00:00',5.76),('8975','2013-06-08','11:05:00',6.07),('8975','2013-06-08','11:10:00',5.66),('8975','2013-06-08','11:15:00',5.52),('8975','2013-06-08','11:20:00',6.46),('8975','2013-06-08','11:25:00',6.35),('8975','2013-06-08','11:30:00',6.09),('8975','2013-06-08','11:35:00',6.27),('8975','2013-06-08','11:40:00',6.14),('8975','2013-06-08','11:45:00',6.2),('8975','2013-06-08','11:50:00',6.62),('8975','2013-06-08','11:55:00',6.6),('8975','2013-06-08','12:00:00',6.66),('8975','2013-06-08','12:05:00',6.77),('8975','2013-06-08','12:10:00',6.42),('8975','2013-06-08','12:15:00',6.76),('8975','2013-06-08','12:20:00',6.66),('8975','2013-06-08','12:25:00',6.65),('8975','2013-06-08','12:30:00',6.6),('8975','2013-06-08','12:35:00',6.58),('8975','2013-06-08','12:40:00',6.65),('8975','2013-06-08','12:45:00',6.11),('8975','2013-06-08','12:50:00',6.64),('8975','2013-06-08','12:55:00',5.54),('8975','2013-06-08','13:00:00',4.86),('8975','2013-06-08','13:05:00',3.4),('8975','2013-06-08','13:10:00',3.91),('8975','2013-06-08','13:15:00',6.2),('8975','2013-06-08','13:20:00',3.75),('8975','2013-06-08','13:25:00',6.85),('8975','2013-06-08','13:30:00',6.6),('8975','2013-06-08','13:35:00',6.68),('8975','2013-06-08','13:40:00',6.76),('8975','2013-06-08','13:45:00',6.76),('8975','2013-06-08','13:50:00',7.04),('8975','2013-06-08','13:55:00',5.21),('8975','2013-06-08','14:00:00',4.89),('8975','2013-06-08','14:05:00',6.66),('8975','2013-06-08','14:10:00',6.42),('8975','2013-06-08','14:15:00',4.51),('8975','2013-06-08','14:20:00',2.78),('8975','2013-06-08','14:25:00',1.84),('8975','2013-06-08','14:30:00',4.57),('8975','2013-06-08','14:35:00',5.57),('8975','2013-06-08','14:40:00',6.44),('8975','2013-06-08','14:45:00',6.52),('8975','2013-06-08','14:50:00',6.1),('8975','2013-06-08','14:55:00',5.83),('8975','2013-06-08','15:00:00',5.64),('8975','2013-06-08','15:05:00',5.71),('8975','2013-06-08','15:10:00',5.48),('8975','2013-06-08','15:15:00',5.4),('8975','2013-06-08','15:20:00',5.26),('8975','2013-06-08','15:25:00',5.25),('8975','2013-06-08','15:30:00',4.78),('8975','2013-06-08','15:35:00',4.51),('8975','2013-06-08','15:40:00',3.85),('8975','2013-06-08','15:45:00',4.26),('8975','2013-06-08','15:50:00',4.89),('8975','2013-06-08','15:55:00',4.5),('8975','2013-06-08','16:00:00',2.49),('8975','2013-06-08','16:05:00',4.53),('8975','2013-06-08','16:10:00',3.42),('8975','2013-06-08','16:15:00',2.46),('8975','2013-06-08','16:20:00',2.4),('8975','2013-06-08','16:25:00',3.09),('8975','2013-06-08','16:30:00',1.86),('8975','2013-06-08','16:35:00',1.52),('8975','2013-06-08','16:40:00',1.46),('8975','2013-06-08','16:45:00',1.46),('8975','2013-06-08','16:50:00',1.38),('8975','2013-06-08','16:55:00',1.3),('8975','2013-06-08','17:00:00',1.36),('8975','2013-06-08','17:05:00',1.58),('8975','2013-06-08','17:10:00',1.46),('8975','2013-06-08','17:15:00',1.28),('8975','2013-06-08','17:20:00',1.4),('8975','2013-06-08','17:25:00',1.04),('8975','2013-06-08','17:35:00',1.06),('8975','2013-06-08','17:40:00',1.19),('8975','2013-06-08','17:45:00',1.07),('8975','2013-06-08','18:00:00',1.46),('8975','2013-06-08','18:05:00',1.28),('8975','2013-06-08','18:10:00',1.46),('8975','2013-06-08','18:15:00',1.34),('8975','2013-06-08','18:20:00',1.19),('8975','2013-06-08','18:30:00',1.26),('8975','2013-06-07','06:15:00',1.02),('8975','2013-06-07','06:20:00',1.21),('8975','2013-06-07','06:25:00',1.39),('8975','2013-06-07','06:30:00',1.56),('8975','2013-06-07','06:35:00',1.71),('8975','2013-06-07','06:40:00',1.83),('8975','2013-06-07','06:45:00',1.94),('8975','2013-06-07','06:50:00',2.05),('8975','2013-06-07','06:55:00',2.2),('8975','2013-06-07','07:00:00',2.32),('8975','2013-06-07','07:05:00',2.42),('8975','2013-06-07','07:10:00',2.53),('8975','2013-06-07','07:15:00',2.67),('8975','2013-06-07','07:20:00',2.76),('8975','2013-06-07','07:25:00',2.89),('8975','2013-06-07','07:30:00',3),('8975','2013-06-07','07:35:00',3.13),('8975','2013-06-07','07:40:00',3.23),('8975','2013-06-07','07:45:00',3.31),('8975','2013-06-07','07:50:00',3.4),('8975','2013-06-07','07:55:00',3.46),('8975','2013-06-07','08:00:00',3.58),('8975','2013-06-07','08:05:00',3.7),('8975','2013-06-07','08:10:00',3.83),('8975','2013-06-07','08:15:00',3.94),('8975','2013-06-07','08:20:00',4.03),('8975','2013-06-07','08:25:00',4.16),('8975','2013-06-07','08:30:00',4.25),('8975','2013-06-07','08:35:00',4.35),('8975','2013-06-07','08:40:00',4.44),('8975','2013-06-07','08:45:00',4.5),('8975','2013-06-07','08:50:00',4.65),('8975','2013-06-07','08:55:00',4.69),('8975','2013-06-07','09:00:00',4.81),('8975','2013-06-07','09:05:00',4.86),('8975','2013-06-07','09:10:00',4.98),('8975','2013-06-07','09:15:00',5.14),('8975','2013-06-07','09:20:00',5.18),('8975','2013-06-07','09:25:00',5.25),('8975','2013-06-07','09:30:00',5.33),('8975','2013-06-07','09:35:00',5.42),('8975','2013-06-07','09:40:00',5.5),('8975','2013-06-07','09:45:00',5.61),('8975','2013-06-07','09:50:00',5.72),('8975','2013-06-07','09:55:00',5.75),('8975','2013-06-07','10:00:00',5.86),('8975','2013-06-07','10:05:00',6.06),('8975','2013-06-07','10:10:00',6.07),('8975','2013-06-07','10:15:00',6.21),('8975','2013-06-07','10:20:00',6.15),('8975','2013-06-07','10:25:00',6.12),('8975','2013-06-07','10:30:00',6.15),('8975','2013-06-07','10:35:00',6.21),('8975','2013-06-07','10:40:00',6.44),('8975','2013-06-07','10:45:00',6.52),('8975','2013-06-07','10:50:00',6.65),('8975','2013-06-07','10:55:00',4.99),('8975','2013-06-07','11:00:00',3.31),('8975','2013-06-07','11:05:00',2.1),('8975','2013-06-07','11:10:00',6.51),('8975','2013-06-07','11:15:00',7.25),('8975','2013-06-07','11:20:00',4.02),('8975','2013-06-07','11:25:00',5.84),('8975','2013-06-07','11:30:00',6.5),('8975','2013-06-07','11:35:00',7.48),('8975','2013-06-07','11:40:00',5.9),('8975','2013-06-07','11:45:00',3.29),('8975','2013-06-07','11:50:00',4.87),('8975','2013-06-07','11:55:00',7.21),('8975','2013-06-07','12:00:00',7.26),('8975','2013-06-07','12:05:00',7.31),('8975','2013-06-07','12:10:00',7.36),('8975','2013-06-07','12:15:00',2.35),('8975','2013-06-07','12:20:00',5.85),('8975','2013-06-07','12:25:00',2.64),('8975','2013-06-07','12:30:00',1.73),('8975','2013-06-07','12:35:00',2.77),('8975','2013-06-07','12:40:00',6.87),('8975','2013-06-07','12:45:00',7.3),('8975','2013-06-07','12:50:00',7.26),('8975','2013-06-07','12:55:00',6.98),('8975','2013-06-07','13:00:00',6.96),('8975','2013-06-07','13:05:00',7),('8975','2013-06-07','13:10:00',6.73),('8975','2013-06-07','13:15:00',7.26),('8975','2013-06-07','13:20:00',7.32),('8975','2013-06-07','13:25:00',7.18),('8975','2013-06-07','13:30:00',7.1),('8975','2013-06-07','13:35:00',6.98),('8975','2013-06-07','13:40:00',6.66),('8975','2013-06-07','13:45:00',6.91),('8975','2013-06-07','13:50:00',6.76),('8975','2013-06-07','13:55:00',6.61),('8975','2013-06-07','14:00:00',6.52),('8975','2013-06-07','14:05:00',6.54),('8975','2013-06-07','14:10:00',6.45),('8975','2013-06-07','14:15:00',6.36),('8975','2013-06-07','14:20:00',6.32),('8975','2013-06-07','14:25:00',6.32),('8975','2013-06-07','14:30:00',6.22),('8975','2013-06-07','14:35:00',6.14),('8975','2013-06-07','14:40:00',5.95),('8975','2013-06-07','14:45:00',6.18),('8975','2013-06-07','14:50:00',5.99),('8975','2013-06-07','14:55:00',5.92),('8975','2013-06-07','15:00:00',5.78),('8975','2013-06-07','15:05:00',5.48),('8975','2013-06-07','15:10:00',5.37),('8975','2013-06-07','15:15:00',5.15),('8975','2013-06-07','15:20:00',5.39),('8975','2013-06-07','15:25:00',5.13),('8975','2013-06-07','15:30:00',4.21),('8975','2013-06-07','15:35:00',4.22),('8975','2013-06-07','15:40:00',4.24),('8975','2013-06-07','15:45:00',4.71),('8975','2013-06-07','15:50:00',5.27),('8975','2013-06-07','15:55:00',4.69),('8975','2013-06-07','16:00:00',4.78),('8975','2013-06-07','16:05:00',4.64),('8975','2013-06-07','16:10:00',4.63),('8975','2013-06-07','16:15:00',4.5),('8975','2013-06-07','16:20:00',4.39),('8975','2013-06-07','16:25:00',4.18),('8975','2013-06-07','16:30:00',3.98),('8975','2013-06-07','16:35:00',3.81),('8975','2013-06-07','16:40:00',3.73),('8975','2013-06-07','16:45:00',3.61),('8975','2013-06-07','16:50:00',2.96),('8975','2013-06-07','16:55:00',2.96),('8975','2013-06-07','17:00:00',3.24),('8975','2013-06-07','17:05:00',3),('8975','2013-06-07','17:10:00',2.9),('8975','2013-06-07','17:15:00',3.25),('8975','2013-06-07','17:20:00',3.01),('8975','2013-06-07','17:25:00',2.81),('8975','2013-06-07','17:30:00',2.36),('8975','2013-06-07','17:35:00',2.27),('8975','2013-06-07','17:40:00',2.25),('8975','2013-06-07','17:45:00',2.36),('8975','2013-06-07','17:50:00',2.15),('8975','2013-06-07','17:55:00',2.1),('8975','2013-06-07','18:00:00',1.97),('8975','2013-06-07','18:05:00',1.59),('8975','2013-06-07','18:10:00',1.3),('8975','2013-06-07','18:15:00',1.42),('8975','2013-06-07','18:20:00',1.48),('8975','2013-06-07','18:25:00',1.41),('8975','2013-06-07','18:30:00',1.16),('8975','2013-06-06','06:15:00',1.19),('8975','2013-06-06','06:20:00',1.35),('8975','2013-06-06','06:25:00',1.51),('8975','2013-06-06','06:30:00',1.66),('8975','2013-06-06','06:35:00',1.83),('8975','2013-06-06','06:40:00',1.99),('8975','2013-06-06','06:45:00',2.13),('8975','2013-06-06','06:50:00',2.27),('8975','2013-06-06','06:55:00',2.41),('8975','2013-06-06','07:00:00',2.53),('8975','2013-06-06','07:05:00',2.67),('8975','2013-06-06','07:10:00',2.8),('8975','2013-06-06','07:15:00',2.95),('8975','2013-06-06','07:20:00',3.1),('8975','2013-06-06','07:25:00',3.21),('8975','2013-06-06','07:30:00',3.31),('8975','2013-06-06','07:35:00',3.43),('8975','2013-06-06','07:40:00',3.55),('8975','2013-06-06','07:45:00',3.66),('8975','2013-06-06','07:50:00',3.75),('8975','2013-06-06','07:55:00',3.86),('8975','2013-06-06','08:00:00',3.96),('8975','2013-06-06','08:05:00',4.05),('8975','2013-06-06','08:10:00',4.17),('8975','2013-06-06','08:15:00',4.27),('8975','2013-06-06','08:20:00',4.39),('8975','2013-06-06','08:25:00',4.51),('8975','2013-06-06','08:30:00',4.63),('8975','2013-06-06','08:35:00',4.76),('8975','2013-06-06','08:40:00',4.85),('8975','2013-06-06','08:45:00',4.94),('8975','2013-06-06','08:50:00',4.63),('8975','2013-06-06','08:55:00',4.85),('8975','2013-06-06','09:00:00',4.9),('8975','2013-06-06','09:05:00',4.57),('8975','2013-06-06','09:10:00',5.35),('8975','2013-06-06','09:15:00',5.19),('8975','2013-06-06','09:20:00',5.17),('8975','2013-06-06','09:25:00',5.34),('8975','2013-06-06','09:30:00',5.76),('8975','2013-06-06','09:35:00',5.65),('8975','2013-06-06','09:40:00',5.53),('8975','2013-06-06','09:45:00',6.01),('8975','2013-06-06','09:50:00',6.1),('8975','2013-06-06','09:55:00',6.14),('8975','2013-06-06','10:00:00',6.21),('8975','2013-06-06','10:05:00',6.29),('8975','2013-06-06','10:10:00',6.35),('8975','2013-06-06','10:15:00',6.43),('8975','2013-06-06','10:20:00',6.49),('8975','2013-06-06','10:25:00',6.54),('8975','2013-06-06','10:30:00',6.6),('8975','2013-06-06','10:35:00',6.65),('8975','2013-06-06','10:40:00',6.68),('8975','2013-06-06','10:45:00',6.74),('8975','2013-06-06','10:50:00',6.81),('8975','2013-06-06','10:55:00',6.84),('8975','2013-06-06','11:00:00',6.87),('8975','2013-06-06','11:05:00',6.88),('8975','2013-06-06','11:10:00',6.91),('8975','2013-06-06','11:15:00',6.98),('8975','2013-06-06','11:20:00',7.01),('8975','2013-06-06','11:25:00',7.01),('8975','2013-06-06','11:30:00',7.01),('8975','2013-06-06','11:35:00',7.02),('8975','2013-06-06','11:40:00',7.06),('8975','2013-06-06','11:45:00',7.1),('8975','2013-06-06','11:50:00',7.1),('8975','2013-06-06','11:55:00',7.05),('8975','2013-06-06','12:00:00',7.04),('8975','2013-06-06','12:05:00',7.07),('8975','2013-06-06','12:10:00',7.07),('8975','2013-06-06','12:15:00',7.09),('8975','2013-06-06','12:20:00',7.11),('8975','2013-06-06','12:25:00',7.05),('8975','2013-06-06','12:30:00',7.02),('8975','2013-06-06','12:35:00',7.05),('8975','2013-06-06','12:40:00',7.05),('8975','2013-06-06','12:45:00',7.03),('8975','2013-06-06','12:50:00',6.97),('8975','2013-06-06','12:55:00',6.95),('8975','2013-06-06','13:00:00',6.92),('8975','2013-06-06','13:05:00',6.94),('8975','2013-06-06','13:10:00',6.92),('8975','2013-06-06','13:15:00',6.87),('8975','2013-06-06','13:20:00',6.84),('8975','2013-06-06','13:25:00',6.84),('8975','2013-06-06','13:30:00',6.81),('8975','2013-06-06','13:35:00',6.72),('8975','2013-06-06','13:40:00',6.72),('8975','2013-06-06','13:45:00',6.66),('8975','2013-06-06','13:50:00',6.63),('8975','2013-06-06','13:55:00',6.53),('8975','2013-06-06','14:00:00',6.47),('8975','2013-06-06','14:05:00',6.37),('8975','2013-06-06','14:10:00',6.26),('8975','2013-06-06','14:15:00',6.18),('8975','2013-06-06','14:20:00',6.18),('8975','2013-06-06','14:25:00',6.09),('8975','2013-06-06','14:30:00',5.97),('8975','2013-06-06','14:35:00',5.97),('8975','2013-06-06','14:40:00',5.89),('8975','2013-06-06','14:45:00',5.75),('8975','2013-06-06','14:50:00',5.68),('8975','2013-06-06','14:55:00',5.65),('8975','2013-06-06','15:00:00',5.63),('8975','2013-06-06','15:05:00',5.58),('8975','2013-06-06','15:10:00',5.52),('8975','2013-06-06','15:15:00',5.46),('8975','2013-06-06','15:20:00',5.42),('8975','2013-06-06','15:25:00',5.34),('8975','2013-06-06','15:30:00',5.21),('8975','2013-06-06','15:35:00',5.15),('8975','2013-06-06','15:40:00',5.02),('8975','2013-06-06','15:45:00',4.89),('8975','2013-06-06','15:50:00',4.81),('8975','2013-06-06','15:55:00',4.72),('8975','2013-06-06','16:00:00',4.62),('8975','2013-06-06','16:05:00',4.52),('8975','2013-06-06','16:10:00',4.44),('8975','2013-06-06','16:15:00',4.35),('8975','2013-06-06','16:20:00',4.24),('8975','2013-06-06','16:25:00',4.13),('8975','2013-06-06','16:30:00',4),('8975','2013-06-06','16:35:00',3.91),('8975','2013-06-06','16:40:00',3.81),('8975','2013-06-06','16:45:00',3.69),('8975','2013-06-06','16:50:00',3.56),('8975','2013-06-06','16:55:00',3.44),('8975','2013-06-06','17:00:00',3.32),('8975','2013-06-06','17:05:00',3.22),('8975','2013-06-06','17:10:00',3.11),('8975','2013-06-06','17:15:00',3),('8975','2013-06-06','17:20:00',2.87),('8975','2013-06-06','17:25:00',2.72),('8975','2013-06-06','17:30:00',2.62),('8975','2013-06-06','17:35:00',2.53),('8975','2013-06-06','17:40:00',2.45),('8975','2013-06-06','17:45:00',2.38),('8975','2013-06-06','17:50:00',2.3),('8975','2013-06-06','17:55:00',2.2),('8975','2013-06-06','18:00:00',2.05),('8975','2013-06-06','18:05:00',1.88),('8975','2013-06-06','18:10:00',1.81),('8975','2013-06-06','18:15:00',1.73),('8975','2013-06-06','18:20:00',1.6),('8975','2013-06-06','18:25:00',1.49),('8975','2013-06-06','18:30:00',1.38),('8975','2013-06-06','18:35:00',1.34),('8975','2013-06-06','18:40:00',1.3),('8975','2013-06-06','18:45:00',1.22),('8975','2013-06-06','18:50:00',1.17),('8975','2013-06-06','18:55:00',1.13),('8975','2013-06-06','19:00:00',1.09),('8975','2013-06-06','19:05:00',1.04),('8975','2013-06-05','06:55:00',2.24),('8975','2013-06-05','07:00:00',2.58),('8975','2013-06-05','07:05:00',2.87),('8975','2013-06-05','07:10:00',2.98),('8975','2013-06-05','07:15:00',2.7),('8975','2013-06-05','07:20:00',2.3),('8975','2013-06-05','07:25:00',1.42),('8975','2013-06-05','07:30:00',1.39),('8975','2013-06-05','07:35:00',1.82),('8975','2013-06-05','07:40:00',2.18),('8975','2013-06-05','07:45:00',2.13),('8975','2013-06-05','07:50:00',2.63),('8975','2013-06-05','07:55:00',3.61),('8975','2013-06-05','08:00:00',4.09),('8975','2013-06-05','08:05:00',2.73),('8975','2013-06-05','08:10:00',4.16),('8975','2013-06-05','08:15:00',3.61),('8975','2013-06-05','08:20:00',4),('8975','2013-06-05','08:25:00',4.39),('8975','2013-06-05','08:30:00',4.41),('8975','2013-06-05','08:35:00',4.37),('8975','2013-06-05','08:40:00',4.52),('8975','2013-06-05','08:45:00',4.75),('8975','2013-06-05','08:50:00',4.77),('8975','2013-06-05','08:55:00',4.81),('8975','2013-06-05','09:00:00',4.94),('8975','2013-06-05','09:05:00',5.03),('8975','2013-06-05','09:10:00',5.21),('8975','2013-06-05','09:15:00',5.28),('8975','2013-06-05','09:20:00',5.34),('8975','2013-06-05','09:25:00',5.47),('8975','2013-06-05','09:30:00',5.57),('8975','2013-06-05','09:35:00',5.71),('8975','2013-06-05','09:40:00',5.69),('8975','2013-06-05','09:45:00',5.8),('8975','2013-06-05','09:50:00',5.9),('8975','2013-06-05','09:55:00',6),('8975','2013-06-05','10:00:00',6.03),('8975','2013-06-05','10:05:00',6),('8975','2013-06-05','10:10:00',6.01),('8975','2013-06-05','10:15:00',6.11),('8975','2013-06-05','10:20:00',6.21),('8975','2013-06-05','10:25:00',6.3),('8975','2013-06-05','10:30:00',6.3),('8975','2013-06-05','10:35:00',6.3),('8975','2013-06-05','10:40:00',6.31),('8975','2013-06-05','10:45:00',6.46),('8975','2013-06-05','10:50:00',6.5),('8975','2013-06-05','10:55:00',6.56),('8975','2013-06-05','11:00:00',6.64),('8975','2013-06-05','11:05:00',6.64),('8975','2013-06-05','11:10:00',6.67),('8975','2013-06-05','11:15:00',6.8),('8975','2013-06-05','11:20:00',6.75),('8975','2013-06-05','11:25:00',6.71),('8975','2013-06-05','11:30:00',6.82),('8975','2013-06-05','11:35:00',7),('8975','2013-06-05','11:40:00',6.83),('8975','2013-06-05','11:45:00',6.81),('8975','2013-06-05','11:50:00',6.8),('8975','2013-06-05','11:55:00',6.85),('8975','2013-06-05','12:00:00',6.98),('8975','2013-06-05','12:05:00',6.92),('8975','2013-06-05','12:10:00',6.73),('8975','2013-06-05','12:15:00',6.75),('8975','2013-06-05','12:20:00',6.76),('8975','2013-06-05','12:25:00',6.8),('8975','2013-06-05','12:30:00',6.9),('8975','2013-06-05','12:35:00',6.82),('8975','2013-06-05','12:40:00',6.78),('8975','2013-06-05','12:45:00',6.7),('8975','2013-06-05','12:50:00',6.8),('8975','2013-06-05','12:55:00',6.94),('8975','2013-06-05','13:00:00',6.69),('8975','2013-06-05','13:05:00',6.72),('8975','2013-06-05','13:10:00',7.16),('8975','2013-06-05','13:15:00',6.77),('8975','2013-06-05','13:20:00',5.72),('8975','2013-06-05','13:25:00',6.89),('8975','2013-06-05','13:30:00',6.84),('8975','2013-06-05','13:35:00',6.16),('8975','2013-06-05','13:40:00',6.66),('8975','2013-06-05','13:45:00',6.52),('8975','2013-06-05','13:50:00',7),('8975','2013-06-05','13:55:00',6.46),('8975','2013-06-05','14:00:00',3.76),('8975','2013-06-05','14:05:00',4.9),('8975','2013-06-05','14:10:00',5.49),('8975','2013-06-05','14:15:00',6.57),('8975','2013-06-05','14:20:00',6.66),('8975','2013-06-05','14:25:00',6.49),('8975','2013-06-05','14:30:00',6.28),('8975','2013-06-05','14:35:00',6.2),('8975','2013-06-05','14:40:00',6.13),('8975','2013-06-05','14:45:00',6.03),('8975','2013-06-05','14:50:00',6.05),('8975','2013-06-05','14:55:00',5.3),('8975','2013-06-05','15:00:00',5.59),('8975','2013-06-05','15:05:00',6.01),('8975','2013-06-05','15:10:00',5.88),('8975','2013-06-05','15:15:00',5.72),('8975','2013-06-05','15:20:00',4.84),('8975','2013-06-05','15:25:00',5.47),('8975','2013-06-05','15:30:00',4.7),('8975','2013-06-05','15:35:00',4.45),('8975','2013-06-05','15:40:00',5.04),('8975','2013-06-05','15:45:00',2.63),('8975','2013-06-05','15:50:00',5.45),('8975','2013-06-05','15:55:00',5.46),('8975','2013-06-05','16:00:00',5.32),('8975','2013-06-05','16:05:00',5.03),('8975','2013-06-05','16:10:00',4.56),('8975','2013-06-05','16:15:00',4.29),('8975','2013-06-05','16:20:00',4.22),('8975','2013-06-05','16:25:00',4.09),('8975','2013-06-05','16:30:00',3.99),('8975','2013-06-05','16:35:00',3.93),('8975','2013-06-05','16:40:00',3.75),('8975','2013-06-05','16:45:00',3.61),('8975','2013-06-05','16:50:00',3.54),('8975','2013-06-05','16:55:00',3.36),('8975','2013-06-05','17:00:00',3.17),('8975','2013-06-05','17:05:00',3.04),('8975','2013-06-05','17:10:00',2.93),('8975','2013-06-05','17:15:00',2.84),('8975','2013-06-05','17:20:00',2.74),('8975','2013-06-05','17:25:00',2.55),('8975','2013-06-05','17:30:00',2.49),('8975','2013-06-05','17:35:00',2.38),('8975','2013-06-05','17:40:00',2.24),('8975','2013-06-05','17:45:00',2.12),('8975','2013-06-05','17:50:00',2.03),('8975','2013-06-05','17:55:00',1.95),('8975','2013-06-05','18:00:00',1.85),('8975','2013-06-05','18:05:00',1.77),('8975','2013-06-05','18:10:00',1.68),('8975','2013-06-05','18:15:00',1.58),('8975','2013-06-05','18:20:00',1.52),('8975','2013-06-05','18:25:00',1.45),('8975','2013-06-05','18:30:00',1.39),('8975','2013-06-05','18:35:00',1.32),('8975','2013-06-05','18:40:00',1.28),('8975','2013-06-05','18:45:00',1.22),('8975','2013-06-05','18:50:00',1.16),('8975','2013-06-05','18:55:00',1.12),('8975','2013-06-05','19:00:00',1.05),('8975','2013-06-04','07:15:00',1.32),('8975','2013-06-04','07:20:00',2.42),('8975','2013-06-04','07:25:00',2.22),('8975','2013-06-04','07:30:00',2.98),('8975','2013-06-04','07:35:00',2.78),('8975','2013-06-04','07:40:00',1.81),('8975','2013-06-04','07:45:00',2.66),('8975','2013-06-04','07:50:00',2.57),('8975','2013-06-04','07:55:00',3.73),('8975','2013-06-04','08:00:00',3.76),('8975','2013-06-04','08:05:00',3.5),('8975','2013-06-04','08:10:00',4.2),('8975','2013-06-04','08:15:00',4.27),('8975','2013-06-04','08:20:00',4.3),('8975','2013-06-04','08:25:00',4.41),('8975','2013-06-04','08:30:00',4.52),('8975','2013-06-04','08:35:00',4.59),('8975','2013-06-04','08:40:00',4.69),('8975','2013-06-04','08:45:00',4.83),('8975','2013-06-04','08:50:00',4.95),('8975','2013-06-04','08:55:00',5.04),('8975','2013-06-04','09:00:00',5.15),('8975','2013-06-04','09:05:00',5.14),('8975','2013-06-04','09:10:00',5.41),('8975','2013-06-04','09:15:00',5.6),('8975','2013-06-04','09:20:00',5.63),('8975','2013-06-04','09:25:00',5.8),('8975','2013-06-04','09:30:00',6.05),('8975','2013-06-04','09:35:00',5.9),('8975','2013-06-04','09:40:00',6.35),('8975','2013-06-04','09:45:00',5.78),('8975','2013-06-04','09:50:00',5.7),('8975','2013-06-04','09:55:00',6.98),('8975','2013-06-04','10:00:00',5),('8975','2013-06-04','10:05:00',2.7),('8975','2013-06-04','10:10:00',2.63),('8975','2013-06-04','10:15:00',2.3),('8975','2013-06-04','10:20:00',2.48),('8975','2013-06-04','10:25:00',2.4),('8975','2013-06-04','10:30:00',2.55),('8975','2013-06-04','10:35:00',6.51),('8975','2013-06-04','10:40:00',7.2),('8975','2013-06-04','10:45:00',6.51),('8975','2013-06-04','10:50:00',7.01),('8975','2013-06-04','10:55:00',7.03),('8975','2013-06-04','11:00:00',7.2),('8975','2013-06-04','11:05:00',7.54),('8975','2013-06-04','11:10:00',6.16),('8975','2013-06-04','11:15:00',2.68),('8975','2013-06-04','11:20:00',2.11),('8975','2013-06-04','11:25:00',1.8),('8975','2013-06-04','11:30:00',1.82),('8975','2013-06-04','11:35:00',2.77),('8975','2013-06-04','11:40:00',3.01),('8975','2013-06-04','11:45:00',2.61),('8975','2013-06-04','11:50:00',1.58),('8975','2013-06-04','11:55:00',1.64),('8975','2013-06-04','12:00:00',1.85),('8975','2013-06-04','12:05:00',2.55),('8975','2013-06-04','12:10:00',4.31),('8975','2013-06-04','12:15:00',2.83),('8975','2013-06-04','12:20:00',3.9),('8975','2013-06-04','12:25:00',2.84),('8975','2013-06-04','12:30:00',2.23),('8975','2013-06-04','12:35:00',4.53),('8975','2013-06-04','12:40:00',3.31),('8975','2013-06-04','12:45:00',2.68),('8975','2013-06-04','12:50:00',4.58),('8975','2013-06-04','12:55:00',6.3),('8975','2013-06-04','13:00:00',5.5),('8975','2013-06-04','13:05:00',8.38),('8975','2013-06-04','13:10:00',8.05),('8975','2013-06-04','13:15:00',7.17),('8975','2013-06-04','13:20:00',3.94),('8975','2013-06-04','13:25:00',6.11),('8975','2013-06-04','13:30:00',7.72),('8975','2013-06-04','13:35:00',7.76),('8975','2013-06-04','13:40:00',6.78),('8975','2013-06-04','13:45:00',6.03),('8975','2013-06-04','13:50:00',6.65),('8975','2013-06-04','13:55:00',6.93),('8975','2013-06-04','14:00:00',6.72),('8975','2013-06-04','14:05:00',6.69),('8975','2013-06-04','14:10:00',6.64),('8975','2013-06-04','14:15:00',6.54),('8975','2013-06-04','14:20:00',6.48),('8975','2013-06-04','14:25:00',6.42),('8975','2013-06-04','14:30:00',6.33),('8975','2013-06-04','14:35:00',6.29),('8975','2013-06-04','14:40:00',6.27),('8975','2013-06-04','14:45:00',6.19),('8975','2013-06-04','14:50:00',6.08),('8975','2013-06-04','14:55:00',5.97),('8975','2013-06-04','15:00:00',5.88),('8975','2013-06-04','15:05:00',5.87),('8975','2013-06-04','15:10:00',5.65),('8975','2013-06-04','15:15:00',5.67),('8975','2013-06-04','15:20:00',5.59),('8975','2013-06-04','15:25:00',5.37),('8975','2013-06-04','15:30:00',4.82),('8975','2013-06-04','15:35:00',5.37),('8975','2013-06-04','15:40:00',5.46),('8975','2013-06-04','15:45:00',5.14),('8975','2013-06-04','15:50:00',5.07),('8975','2013-06-04','15:55:00',4.93),('8975','2013-06-04','16:00:00',4.83),('8975','2013-06-04','16:05:00',4.77),('8975','2013-06-04','16:10:00',3.73),('8975','2013-06-04','16:15:00',3.79),('8975','2013-06-04','16:20:00',4.3),('8975','2013-06-04','16:25:00',4.29),('8975','2013-06-04','16:30:00',4.15),('8975','2013-06-04','16:35:00',3.97),('8975','2013-06-04','16:40:00',3.88),('8975','2013-06-04','16:45:00',3.75),('8975','2013-06-04','16:50:00',3.64),('8975','2013-06-04','16:55:00',3.51),('8975','2013-06-04','17:00:00',3.09),('8975','2013-06-04','17:05:00',2.46),('8975','2013-06-04','17:10:00',3.32),('8975','2013-06-04','17:15:00',3.01),('8975','2013-06-04','17:20:00',2.65),('8975','2013-06-04','17:25:00',2.87),('8975','2013-06-04','17:30:00',2.69),('8975','2013-06-04','17:35:00',2.07),('8975','2013-06-04','17:40:00',2.31),('8975','2013-06-04','17:45:00',2.25),('8975','2013-06-04','17:50:00',2.11),('8975','2013-06-04','17:55:00',2),('8975','2013-06-04','18:00:00',1.91),('8975','2013-06-04','18:05:00',1.82),('8975','2013-06-04','18:10:00',1.81),('8975','2013-06-04','18:15:00',1.54),('8975','2013-06-04','18:20:00',1),('8975','2013-06-04','18:31:00',1.5),('8975','2013-06-04','18:35:00',1.44),('8975','2013-06-04','18:40:00',1.35),('8975','2013-06-04','18:50:00',1.3),('8975','2013-06-04','18:55:00',1.29),('8975','2013-06-03','07:05:00',1.85),('8975','2013-06-03','07:10:00',2.67),('8975','2013-06-03','07:15:00',2.81),('8975','2013-06-03','07:20:00',2.79),('8975','2013-06-03','07:25:00',2.91),('8975','2013-06-03','07:30:00',3.14),('8975','2013-06-03','07:35:00',3.34),('8975','2013-06-03','07:40:00',3.57),('8975','2013-06-03','07:45:00',3.9),('8975','2013-06-03','07:50:00',4.14),('8975','2013-06-03','07:55:00',4.29),('8975','2013-06-03','08:00:00',4.59),('8975','2013-06-03','08:05:00',4.83),('8975','2013-06-03','08:10:00',4.85),('8975','2013-06-03','08:15:00',4.87),('8975','2013-06-03','08:20:00',5.07),('8975','2013-06-03','08:25:00',5.16),('8975','2013-06-03','08:30:00',5.02),('8975','2013-06-03','08:35:00',3.87),('8975','2013-06-03','08:40:00',3.35),('8975','2013-06-03','08:45:00',2.77),('8975','2013-06-03','08:50:00',2.35),('8975','2013-06-03','08:55:00',2.06),('8975','2013-06-03','09:00:00',2.43),('8975','2013-06-03','09:05:00',3.23),('8975','2013-06-03','09:10:00',3.43),('8975','2013-06-03','09:15:00',4.05),('8975','2013-06-03','09:20:00',4.67),('8975','2013-06-03','09:25:00',4.75),('8975','2013-06-03','09:30:00',5.07),('8975','2013-06-03','09:35:00',4.57),('8975','2013-06-03','09:40:00',3.81),('8975','2013-06-03','09:45:00',3.94),('8975','2013-06-03','09:50:00',4.58),('8975','2013-06-03','09:55:00',3.92),('8975','2013-06-03','10:00:00',3.84),('8975','2013-06-03','10:05:00',3.3),('8975','2013-06-03','10:10:00',3.33),('8975','2013-06-03','10:15:00',2.98),('8975','2013-06-03','10:20:00',3.16),('8975','2013-06-03','10:25:00',3.09),('8975','2013-06-03','10:30:00',2.79),('8975','2013-06-03','10:35:00',2.78),('8975','2013-06-03','10:40:00',3.14),('8975','2013-06-03','10:45:00',4.63),('8975','2013-06-03','10:50:00',5.14),('8975','2013-06-03','10:55:00',5.1),('8975','2013-06-03','11:00:00',4.75),('8975','2013-06-03','11:05:00',4.82),('8975','2013-06-03','11:10:00',5.42),('8975','2013-06-03','11:15:00',6.28),('8975','2013-06-03','11:20:00',4.18),('8975','2013-06-03','11:25:00',4.25),('8975','2013-06-03','11:30:00',4.57),('8975','2013-06-03','11:35:00',5.33),('8975','2013-06-03','11:40:00',5.4),('8975','2013-06-03','11:45:00',5.81),('8975','2013-06-03','11:50:00',6.55),('8975','2013-06-03','11:55:00',7.66),('8975','2013-06-03','12:00:00',7.25),('8975','2013-06-03','12:05:00',8.24),('8975','2013-06-03','12:10:00',6.21),('8975','2013-06-03','12:15:00',5.29),('8975','2013-06-03','12:20:00',3.8),('8975','2013-06-03','12:25:00',4.06),('8975','2013-06-03','12:30:00',4.06),('8975','2013-06-03','12:35:00',5.7),('8975','2013-06-03','12:40:00',3.74),('8975','2013-06-03','12:45:00',4.64),('8975','2013-06-03','12:50:00',3.86),('8975','2013-06-03','12:55:00',3.92),('8975','2013-06-03','13:00:00',3.79),('8975','2013-06-03','13:05:00',2.92),('8975','2013-06-03','13:10:00',2.67),('8975','2013-06-03','13:15:00',2.38),('8975','2013-06-03','13:20:00',1.94),('8975','2013-06-03','13:25:00',2.07),('8975','2013-06-03','13:30:00',6.56),('8975','2013-06-03','13:35:00',6.62),('8975','2013-06-03','13:40:00',8.55),('8975','2013-06-03','13:45:00',8.47),('8975','2013-06-03','13:50:00',8.31),('8975','2013-06-03','13:55:00',5.04),('8975','2013-06-03','14:00:00',2.9),('8975','2013-06-03','14:05:00',4.4),('8975','2013-06-03','14:10:00',6.79),('8975','2013-06-03','14:15:00',5.6),('8975','2013-06-03','14:20:00',2.83),('8975','2013-06-03','14:25:00',2.32),('8975','2013-06-03','14:30:00',1.88),('8975','2013-06-03','14:35:00',2.04),('8975','2013-06-03','14:40:00',3.15),('8975','2013-06-03','14:45:00',3.67),('8975','2013-06-03','14:50:00',2.55),('8975','2013-06-03','14:55:00',6.47),('8975','2013-06-03','15:00:00',7.2),('8975','2013-06-03','15:05:00',4.97),('8975','2013-06-03','15:10:00',3.09),('8975','2013-06-03','15:15:00',4.01),('8975','2013-06-03','15:20:00',5.55),('8975','2013-06-03','15:25:00',3.25),('8975','2013-06-03','15:30:00',2.15),('8975','2013-06-03','16:05:00',1.17),('8975','2013-06-03','16:10:00',1.08),('8975','2013-06-03','17:20:00',1.12),('8975','2013-06-03','17:40:00',1.21),('8975','2013-06-03','17:45:00',1.42),('8975','2013-06-03','17:50:00',1.23),('8975','2013-06-03','17:55:00',1.22),('8975','2013-06-03','18:00:00',1.22),('8975','2013-06-03','18:05:00',1.37),('8975','2013-06-03','18:10:00',1.41),('8975','2013-06-03','18:15:00',1.23),('8975','2013-06-03','18:45:00',1.1),('8975','2013-06-02','06:45:00',1.07),('8975','2013-06-02','06:50:00',1.77),('8975','2013-06-02','06:55:00',2.05),('8975','2013-06-02','07:00:00',2.09),('8975','2013-06-02','07:05:00',1.64),('8975','2013-06-02','07:10:00',1.9),('8975','2013-06-02','07:15:00',2.73),('8975','2013-06-02','07:20:00',3.07),('8975','2013-06-02','07:25:00',1.49),('8975','2013-06-02','07:35:00',1.88),('8975','2013-06-02','07:40:00',3.52),('8975','2013-06-02','07:45:00',3.59),('8975','2013-06-02','07:50:00',3.73),('8975','2013-06-02','07:55:00',3.81),('8975','2013-06-02','08:00:00',3.85),('8975','2013-06-02','08:05:00',3.96),('8975','2013-06-02','08:10:00',4.07),('8975','2013-06-02','08:15:00',4.16),('8975','2013-06-02','08:20:00',4.27),('8975','2013-06-02','08:25:00',4.33),('8975','2013-06-02','08:30:00',4.45),('8975','2013-06-02','08:35:00',4.52),('8975','2013-06-02','08:40:00',4.62),('8975','2013-06-02','08:45:00',4.74),('8975','2013-06-02','08:50:00',4.89),('8975','2013-06-02','08:55:00',5.04),('8975','2013-06-02','09:00:00',5.15),('8975','2013-06-02','09:05:00',5.27),('8975','2013-06-02','09:10:00',5.41),('8975','2013-06-02','09:15:00',5.3),('8975','2013-06-02','09:20:00',5.79),('8975','2013-06-02','09:25:00',5.15),('8975','2013-06-02','09:30:00',3.2),('8975','2013-06-02','09:35:00',3.42),('8975','2013-06-02','09:40:00',4.3),('8975','2013-06-02','09:45:00',5.86),('8975','2013-06-02','09:50:00',4.59),('8975','2013-06-02','09:55:00',7),('8975','2013-06-02','10:00:00',5.62),('8975','2013-06-02','10:05:00',3.82),('8975','2013-06-02','10:10:00',2.14),('8975','2013-06-02','10:15:00',1.59),('8975','2013-06-02','10:20:00',1.74),('8975','2013-06-02','10:25:00',2.34),('8975','2013-06-02','10:30:00',6),('8975','2013-06-02','10:35:00',7.18),('8975','2013-06-02','10:40:00',2.8),('8975','2013-06-02','10:45:00',2.68),('8975','2013-06-02','10:50:00',3.05),('8975','2013-06-02','10:55:00',3.15),('8975','2013-06-02','11:00:00',4.89),('8975','2013-06-02','11:05:00',4.99),('8975','2013-06-02','11:10:00',4.46),('8975','2013-06-02','11:15:00',3.22),('8975','2013-06-02','11:20:00',4.7),('8975','2013-06-02','11:25:00',7.18),('8975','2013-06-02','11:30:00',6.04),('8975','2013-06-02','11:35:00',6.44),('8975','2013-06-02','11:40:00',5.67),('8975','2013-06-02','11:45:00',6.11),('8975','2013-06-02','11:50:00',6.82),('8975','2013-06-02','11:55:00',5.74),('8975','2013-06-02','12:00:00',2.4),('8975','2013-06-02','12:05:00',1.86),('8975','2013-06-02','12:10:00',2.04),('8975','2013-06-02','12:15:00',2.38),('8975','2013-06-02','12:20:00',2.46),('8975','2013-06-02','12:25:00',2.82),('8975','2013-06-02','12:30:00',3.94),('8975','2013-06-02','12:35:00',6.34),('8975','2013-06-02','12:40:00',3.08),('8975','2013-06-02','12:45:00',3.53),('8975','2013-06-02','12:50:00',3.42),('8975','2013-06-02','12:55:00',4.81),('8975','2013-06-02','13:00:00',5.73),('8975','2013-06-02','13:05:00',8.48),('8975','2013-06-02','13:10:00',8.3),('8975','2013-06-02','13:15:00',7.74),('8975','2013-06-02','13:20:00',6.31),('8975','2013-06-02','13:25:00',6.39),('8975','2013-06-02','13:30:00',7.31),('8975','2013-06-02','13:35:00',7.31),('8975','2013-06-02','13:40:00',7.37),('8975','2013-06-02','13:45:00',7.09),('8975','2013-06-02','13:50:00',3.64),('8975','2013-06-02','13:55:00',2.95),('8975','2013-06-02','14:00:00',3.52),('8975','2013-06-02','14:05:00',6.92),('8975','2013-06-02','14:10:00',5.46),('8975','2013-06-02','14:15:00',5.01),('8975','2013-06-02','14:20:00',3.79),('8975','2013-06-02','14:25:00',5.5),('8975','2013-06-02','14:30:00',6.39),('8975','2013-06-02','14:35:00',4.13),('8975','2013-06-02','14:40:00',3.26),('8975','2013-06-02','14:45:00',6.16),('8975','2013-06-02','14:50:00',3.17),('8975','2013-06-02','14:55:00',4.32),('8975','2013-06-02','15:00:00',6.47),('8975','2013-06-02','15:05:00',5.47),('8975','2013-06-02','15:10:00',5.4),('8975','2013-06-02','15:15:00',6.09),('8975','2013-06-02','15:20:00',5.81),('8975','2013-06-02','15:25:00',5.63),('8975','2013-06-02','15:30:00',5.51),('8975','2013-06-02','15:35:00',5.44),('8975','2013-06-02','15:40:00',5.29),('8975','2013-06-02','15:45:00',5.17),('8975','2013-06-02','15:50:00',5.07),('8975','2013-06-02','15:55:00',4.98),('8975','2013-06-02','16:00:00',4.87),('8975','2013-06-02','16:05:00',4.76),('8975','2013-06-02','16:10:00',4.71),('8975','2013-06-02','16:15:00',4.63),('8975','2013-06-02','16:20:00',4.47),('8975','2013-06-02','16:25:00',4.39),('8975','2013-06-02','16:30:00',4.44),('8975','2013-06-02','16:35:00',4.3),('8975','2013-06-02','16:40:00',4.38),('8975','2013-06-02','16:45:00',4.16),('8975','2013-06-02','16:50:00',3.45),('8975','2013-06-02','16:55:00',2.8),('8975','2013-06-02','17:00:00',2.95),('8975','2013-06-02','17:05:00',3.73),('8975','2013-06-02','17:10:00',3.25),('8975','2013-06-02','17:15:00',3.47),('8975','2013-06-02','17:20:00',3.51),('8975','2013-06-02','17:25:00',2.39),('8975','2013-06-02','17:30:00',1.44),('8975','2013-06-02','17:35:00',1.12),('8975','2013-06-02','17:40:00',1.06),('8975','2013-06-02','17:45:00',1.14),('8975','2013-06-02','17:50:00',1.31),('8975','2013-06-02','17:55:00',1.28),('8975','2013-06-02','18:00:00',1.05),('8975','2013-06-01','06:20:00',1.24),('8975','2013-06-01','06:25:00',1.46),('8975','2013-06-01','06:30:00',1.67),('8975','2013-06-01','06:35:00',1.88),('8975','2013-06-01','06:40:00',2.03),('8975','2013-06-01','06:45:00',2.09),('8975','2013-06-01','06:50:00',2.58),('8975','2013-06-01','06:55:00',2.95),('8975','2013-06-01','07:00:00',2.88),('8975','2013-06-01','07:05:00',1.36),('8975','2013-06-01','08:25:00',1.16),('8975','2013-06-01','08:30:00',1.46),('8975','2013-06-01','08:35:00',1.71),('8975','2013-06-01','08:40:00',1.65),('8975','2013-06-01','08:45:00',1.67),('8975','2013-06-01','08:50:00',1.94),('8975','2013-06-01','08:55:00',1.64),('8975','2013-06-01','09:00:00',1.53),('8975','2013-06-01','09:05:00',1.68),('8975','2013-06-01','09:10:00',2.01),('8975','2013-06-01','09:15:00',2.24),('8975','2013-06-01','09:20:00',3.95),('8975','2013-06-01','09:25:00',6.54),('8975','2013-06-01','09:30:00',5.73),('8975','2013-06-01','09:35:00',5.69),('8975','2013-06-01','09:40:00',5.86),('8975','2013-06-01','09:45:00',6.12),('8975','2013-06-01','09:50:00',6.18),('8975','2013-06-01','09:55:00',6.25),('8975','2013-06-01','10:00:00',6.3),('8975','2013-06-01','10:05:00',6.51),('8975','2013-06-01','10:10:00',6.76),('8975','2013-06-01','10:15:00',6.25),('8975','2013-06-01','10:20:00',5.83),('8975','2013-06-01','10:25:00',6.68),('8975','2013-06-01','10:30:00',5.91),('8975','2013-06-01','10:35:00',4.49),('8975','2013-06-01','10:40:00',2.44),('8975','2013-06-01','10:45:00',2.14),('8975','2013-06-01','10:50:00',7.16),('8975','2013-06-01','10:55:00',4.37),('8975','2013-06-01','11:00:00',4.91),('8975','2013-06-01','11:05:00',6.27),('8975','2013-06-01','11:10:00',7.89),('8975','2013-06-01','11:15:00',7.24),('8975','2013-06-01','11:20:00',8.04),('8975','2013-06-01','11:25:00',7.18),('8975','2013-06-01','11:30:00',7.1),('8975','2013-06-01','11:35:00',3.21),('8975','2013-06-01','11:40:00',2.56),('8975','2013-06-01','11:45:00',2.84),('8975','2013-06-01','11:50:00',3.22),('8975','2013-06-01','11:55:00',3.57),('8975','2013-06-01','12:00:00',3.23),('8975','2013-06-01','12:05:00',7.64),('8975','2013-06-01','12:10:00',8.33),('8975','2013-06-01','12:15:00',7.71),('8975','2013-06-01','12:20:00',4.75),('8975','2013-06-01','12:25:00',2.52),('8975','2013-06-01','12:30:00',2.6),('8975','2013-06-01','12:35:00',4.22),('8975','2013-06-01','12:40:00',2.37),('8975','2013-06-01','12:45:00',2.28),('8975','2013-06-01','12:50:00',2.48),('8975','2013-06-01','12:55:00',2.25),('8975','2013-06-01','13:00:00',5.25),('8975','2013-06-01','13:05:00',4.44),('8975','2013-06-01','13:10:00',4.3),('8975','2013-06-01','13:15:00',6.79),('8975','2013-06-01','13:20:00',7.46),('8975','2013-06-01','13:25:00',7.31),('8975','2013-06-01','13:30:00',7.07),('8975','2013-06-01','13:35:00',6.91),('8975','2013-06-01','13:40:00',6.89),('8975','2013-06-01','13:45:00',6.83),('8975','2013-06-01','13:50:00',6.79),('8975','2013-06-01','13:55:00',6.73),('8975','2013-06-01','14:00:00',6.66),('8975','2013-06-01','14:05:00',6.62),('8975','2013-06-01','14:10:00',6.71),('8975','2013-06-01','14:15:00',6.5),('8975','2013-06-01','14:20:00',6.38),('8975','2013-06-01','14:25:00',6.38),('8975','2013-06-01','14:30:00',6.31),('8975','2013-06-01','14:35:00',6.24),('8975','2013-06-01','14:40:00',6.11),('8975','2013-06-01','14:45:00',6.09),('8975','2013-06-01','14:50:00',5.94),('8975','2013-06-01','14:55:00',5.9),('8975','2013-06-01','15:00:00',5.89),('8975','2013-06-01','15:05:00',5.81),('8975','2013-06-01','15:10:00',5.7),('8975','2013-06-01','15:15:00',5.63),('8975','2013-06-01','15:20:00',5.49),('8975','2013-06-01','15:25:00',5.52),('8975','2013-06-01','15:30:00',5.44),('8975','2013-06-01','15:35:00',5.3),('8975','2013-06-01','15:40:00',5.2),('8975','2013-06-01','15:45:00',5.1),('8975','2013-06-01','15:50:00',4.97),('8975','2013-06-01','15:55:00',4.97),('8975','2013-06-01','16:00:00',4.67),('8975','2013-06-01','16:05:00',4.72),('8975','2013-06-01','16:10:00',4.82),('8975','2013-06-01','16:15:00',4.6),('8975','2013-06-01','16:20:00',4.02),('8975','2013-06-01','16:25:00',4.12),('8975','2013-06-01','16:30:00',3),('8975','2013-06-01','16:35:00',4.18),('8975','2013-06-01','16:40:00',4.05),('8975','2013-06-01','16:45:00',3.66),('8975','2013-06-01','16:50:00',3.84),('8975','2013-06-01','16:55:00',3),('8975','2013-06-01','17:00:00',3.15),('8975','2013-06-01','17:05:00',3.27),('8975','2013-06-01','17:10:00',2.22),('8975','2013-06-01','17:15:00',3.23),('8975','2013-06-01','17:20:00',2.67),('8975','2013-06-01','17:25:00',2.85),('8975','2013-06-01','17:30:00',2.36),('8975','2013-06-01','17:35:00',2.39),('8975','2013-06-01','17:40:00',2.81),('8975','2013-06-01','17:45:00',2.4),('8975','2013-06-01','17:50:00',1.65),('8975','2013-06-01','17:55:00',2.03),('8975','2013-06-01','18:00:00',1.75),('8975','2013-06-01','18:05:00',1.74),('8975','2013-06-01','18:10:00',1.76),('8975','2013-06-01','18:15:00',1.33),('8975','2013-06-01','18:20:00',1.45),('8975','2013-06-01','18:25:00',1.6),('8975','2013-06-01','18:30:00',1.32),('8975','2013-06-01','18:45:00',1.51),('8975','2013-06-01','18:50:00',1),('8975','2013-06-01','19:00:00',1.34),('8975','2013-06-01','19:05:00',1.23),('8975','2013-06-01','19:10:00',1.05),('8975','2013-05-31','06:15:00',1.06),('8975','2013-05-31','06:20:00',1.32),('8975','2013-05-31','06:25:00',1.53),('8975','2013-05-31','06:30:00',1.72),('8975','2013-05-31','06:35:00',1.92),('8975','2013-05-31','06:40:00',2.08),('8975','2013-05-31','06:45:00',2.23),('8975','2013-05-31','06:50:00',2.37),('8975','2013-05-31','06:55:00',2.51),('8975','2013-05-31','07:00:00',2.62),('8975','2013-05-31','07:05:00',2.76),('8975','2013-05-31','07:10:00',2.93),('8975','2013-05-31','07:15:00',3.05),('8975','2013-05-31','07:20:00',3.17),('8975','2013-05-31','07:25:00',3.3),('8975','2013-05-31','07:30:00',3.42),('8975','2013-05-31','07:35:00',3.55),('8975','2013-05-31','07:40:00',3.48),('8975','2013-05-31','07:45:00',4.11),('8975','2013-05-31','07:50:00',4.25),('8975','2013-05-31','07:55:00',2.97),('8975','2013-05-31','08:00:00',1.13),('8975','2013-05-31','08:05:00',1.71),('8975','2013-05-31','08:10:00',3.05),('8975','2013-05-31','08:15:00',3.21),('8975','2013-05-31','08:20:00',3.7),('8975','2013-05-31','08:25:00',2.06),('8975','2013-05-31','08:30:00',2.89),('8975','2013-05-31','08:35:00',1.45),('8975','2013-05-31','08:40:00',1.33),('8975','2013-05-31','08:55:00',1.04),('8975','2013-05-31','09:00:00',1.11),('8975','2013-05-31','09:40:00',1.07),('8975','2013-05-31','09:45:00',1.38),('8975','2013-05-31','09:50:00',1.36),('8975','2013-05-31','09:55:00',1.19),('8975','2013-05-31','10:00:00',1.18),('8975','2013-05-31','10:05:00',1.23),('8975','2013-05-31','10:10:00',1.12),('8975','2013-05-31','10:15:00',1.14),('8975','2013-05-31','10:20:00',1.18),('8975','2013-05-31','10:30:00',1.68),('8975','2013-05-31','10:35:00',2.15),('8975','2013-05-31','10:40:00',1.29),('8975','2013-05-31','10:50:00',1.85),('8975','2013-05-31','10:55:00',1.61),('8975','2013-05-31','11:45:00',1.57),('8975','2013-05-31','11:50:00',2.83),('8975','2013-05-31','11:55:00',3.79),('8975','2013-05-31','12:00:00',8.63),('8975','2013-05-31','12:05:00',7.94),('8975','2013-05-31','12:10:00',3.56),('8975','2013-05-31','12:15:00',2.35),('8975','2013-05-31','12:20:00',2.22),('8975','2013-05-31','12:25:00',2.2),('8975','2013-05-31','12:30:00',1.88),('8975','2013-05-31','12:35:00',1.88),('8975','2013-05-31','12:40:00',2.59),('8975','2013-05-31','12:45:00',3.01),('8975','2013-05-31','12:50:00',3.15),('8975','2013-05-31','12:55:00',3.68),('8975','2013-05-31','13:00:00',4.23),('8975','2013-05-31','13:05:00',4.25),('8975','2013-05-31','13:10:00',4.27),('8975','2013-05-31','13:15:00',4.32),('8975','2013-05-31','13:20:00',3.65),('8975','2013-05-31','13:25:00',2.71),('8975','2013-05-31','13:30:00',2.29),('8975','2013-05-31','13:35:00',1.91),('8975','2013-05-31','13:40:00',1.94),('8975','2013-05-31','13:45:00',2.35),('8975','2013-05-31','13:50:00',2.5),('8975','2013-05-31','13:55:00',2.83),('8975','2013-05-31','14:00:00',3.73),('8975','2013-05-31','14:05:00',4.15),('8975','2013-05-31','14:10:00',3.6),('8975','2013-05-31','14:15:00',4.3),('8975','2013-05-31','14:20:00',3.28),('8975','2013-05-31','14:25:00',2.33),('8975','2013-05-31','14:30:00',2.13),('8975','2013-05-31','14:35:00',2.21),('8975','2013-05-31','14:40:00',2.22),('8975','2013-05-31','14:45:00',2.22),('8975','2013-05-31','14:50:00',2.01),('8975','2013-05-31','14:55:00',1.57),('8975','2013-05-31','15:00:00',1.53),('8975','2013-05-31','15:05:00',1.47),('8975','2013-05-31','15:10:00',1.1),('8975','2013-05-31','16:10:00',1.1),('8975','2013-05-31','16:15:00',1.21),('8975','2013-05-31','16:20:00',1.28),('8975','2013-05-31','16:35:00',1.2),('8975','2013-05-31','16:40:00',1.4),('8975','2013-05-31','16:45:00',1.12),('8975','2013-05-31','16:50:00',1.13),('8975','2013-05-31','16:55:00',1.08),('8975','2013-05-31','18:25:00',1.15),('8975','2013-05-31','18:30:00',1.73),('8975','2013-05-31','18:35:00',1.78),('8975','2013-05-31','18:40:00',1.27),('8975','2013-05-31','18:45:00',1.17),('8975','2013-05-31','18:50:00',1.18),('8975','2013-05-31','18:55:00',1.1),('8975','2013-05-31','19:00:00',1.36),('8975','2013-05-31','19:05:00',1.71),('8975','2013-05-31','19:10:00',1.11),('8975','2014-04-01','08:00:00',1.53),('8975','2014-04-01','08:05:00',2.1),('8975','2014-04-01','08:10:00',1.7),('8975','2014-04-01','08:15:00',1.73),('8975','2014-04-01','08:20:00',1.2),('8975','2014-04-01','08:30:00',1.65),('8975','2014-04-01','08:35:00',1.56),('8975','2014-04-01','08:40:00',1.09),('8975','2014-04-01','08:45:00',1.28),('8975','2014-04-01','08:50:00',1.39),('8975','2014-04-01','08:55:00',1.41),('8975','2014-04-01','09:00:00',1.55),('8975','2014-04-01','09:05:00',2.5),('8975','2014-04-01','09:10:00',4.65),('8975','2014-04-01','09:15:00',4.41),('8975','2014-04-01','09:20:00',4.43),('8975','2014-04-01','09:25:00',4.02),('8975','2014-04-01','09:30:00',3.33),('8975','2014-04-01','09:35:00',2.38),('8975','2014-04-01','09:50:00',1.11),('8975','2014-04-01','09:55:00',1.39);
INSERT INTO `solarlog` VALUES ('8975','2014-04-01','10:00:00',1.65),('8975','2014-04-01','10:05:00',2.36),('8975','2014-04-01','10:10:00',5.66),('8975','2014-04-01','10:15:00',6.23),('8975','2014-04-01','10:20:00',5.98),('8975','2014-04-01','10:25:00',3.17),('8975','2014-04-01','10:30:00',3.53),('8975','2014-04-01','10:35:00',1.73),('8975','2014-04-01','10:40:00',1.61),('8975','2014-04-01','10:45:00',5.29),('8975','2014-04-01','10:50:00',5.8),('8975','2014-04-01','10:55:00',5.77),('8975','2014-04-01','11:00:00',5.65),('8975','2014-04-01','11:05:00',2.18),('8975','2014-04-01','11:10:00',1.79),('8975','2014-04-01','11:15:00',2.71),('8975','2014-04-01','11:20:00',2.04),('8975','2014-04-01','11:25:00',5.71),('8975','2014-04-01','11:30:00',6.63),('8975','2014-04-01','11:35:00',2.84),('8975','2014-04-01','11:40:00',3.63),('8975','2014-04-01','11:45:00',6.13),('8975','2014-04-01','11:50:00',6.43),('8975','2014-04-01','11:55:00',6.66),('8975','2014-04-01','12:00:00',2.66),('8975','2014-04-01','12:05:00',2.2),('8975','2014-04-01','12:10:00',6.07),('8975','2014-04-01','12:15:00',5.93),('8975','2014-04-01','12:20:00',5.92),('8975','2014-04-01','12:25:00',6.82),('8975','2014-04-01','12:30:00',5.49),('8975','2014-04-01','12:35:00',1.84),('8975','2014-04-01','12:40:00',1.8),('8975','2014-04-01','12:45:00',2.61),('8975','2014-04-01','12:50:00',3.52),('8975','2014-04-01','12:55:00',6.78),('8975','2014-04-01','13:00:00',2.87),('8975','2014-04-01','13:05:00',1.88),('8975','2014-04-01','13:10:00',3.82),('8975','2014-04-01','13:15:00',1.61),('8975','2014-04-01','13:20:00',3.36),('8975','2014-04-01','13:25:00',2.93),('8975','2014-04-01','13:30:00',4.91),('8975','2014-04-01','13:35:00',6.25),('8975','2014-04-01','13:40:00',6.05),('8975','2014-04-01','13:45:00',6.05),('8975','2014-04-01','13:50:00',5.86),('8975','2014-04-01','13:55:00',4.41),('8975','2014-04-01','14:00:00',5.77),('8975','2014-04-01','14:05:00',5.8),('8975','2014-04-01','14:10:00',5.58),('8975','2014-04-01','14:15:00',5.47),('8975','2014-04-01','14:20:00',5.4),('8975','2014-04-01','14:25:00',4.47),('8975','2014-04-01','14:30:00',5.3),('8975','2014-04-01','14:35:00',5.3),('8975','2014-04-01','14:40:00',5.27),('8975','2014-04-01','14:45:00',5.29),('8975','2014-04-01','14:50:00',4.93),('8975','2014-04-01','14:55:00',4.59),('8975','2014-04-01','15:00:00',4.55),('8975','2014-04-01','15:05:00',4.51),('8975','2014-04-01','15:10:00',4.38),('8975','2014-04-01','15:15:00',4.25),('8975','2014-04-01','15:20:00',4.15),('8975','2014-04-01','15:25:00',4.13),('8975','2014-04-01','15:30:00',4.01),('8975','2014-04-01','15:35:00',3.84),('8975','2014-04-01','15:40:00',3.72),('8975','2014-04-01','15:45:00',3.78),('8975','2014-04-01','15:50:00',3.62),('8975','2014-04-01','15:55:00',3.39),('8975','2014-04-01','16:00:00',3.15),('8975','2014-04-01','16:05:00',3.16),('8975','2014-04-01','16:10:00',3.05),('8975','2014-04-01','16:15:00',2.95),('8975','2014-04-01','16:20:00',2.88),('8975','2014-04-01','16:25:00',2.84),('8975','2014-04-01','16:30:00',2.59),('8975','2014-04-01','16:35:00',2.71),('8975','2014-04-01','16:40:00',2.55),('8975','2014-04-01','16:45:00',2.45),('8975','2014-04-01','16:50:00',2.28),('8975','2014-04-01','16:55:00',2.19),('8975','2014-04-01','17:00:00',2.16),('8975','2014-04-01','17:05:00',1.95),('8975','2014-04-01','17:10:00',1.84),('8975','2014-04-01','17:15:00',1.64),('8975','2014-04-01','17:20:00',1.6),('8975','2014-04-01','17:25:00',1.58),('8975','2014-04-01','17:30:00',1.46),('8975','2014-04-01','17:35:00',1.37),('8975','2014-04-01','17:40:00',1.17),('8975','2014-04-01','17:45:00',1.08),('8975','2014-04-01','17:50:00',1.47),('8975','2014-04-01','17:55:00',1.36),('8975','2014-04-01','18:00:00',1.25),('8975','2013-05-30','06:30:00',1.36),('8975','2013-05-30','06:35:00',1.67),('8975','2013-05-30','06:40:00',1.79),('8975','2013-05-30','06:45:00',1.98),('8975','2013-05-30','06:50:00',2.24),('8975','2013-05-30','06:55:00',2.29),('8975','2013-05-30','07:00:00',2.46),('8975','2013-05-30','07:05:00',2.62),('8975','2013-05-30','07:10:00',2.81),('8975','2013-05-30','07:15:00',2.97),('8975','2013-05-30','07:20:00',3.12),('8975','2013-05-30','07:25:00',3.23),('8975','2013-05-30','07:30:00',3.35),('8975','2013-05-30','07:35:00',3.49),('8975','2013-05-30','07:40:00',3.59),('8975','2013-05-30','07:45:00',3.68),('8975','2013-05-30','07:50:00',3.79),('8975','2013-05-30','07:55:00',3.92),('8975','2013-05-30','08:00:00',4.04),('8975','2013-05-30','08:05:00',4.14),('8975','2013-05-30','08:10:00',4.24),('8975','2013-05-30','08:15:00',4.3),('8975','2013-05-30','08:20:00',4.4),('8975','2013-05-30','08:25:00',4.56),('8975','2013-05-30','08:30:00',4.67),('8975','2013-05-30','08:35:00',4.32),('8975','2013-05-30','08:40:00',3.87),('8975','2013-05-30','08:45:00',3.88),('8975','2013-05-30','08:50:00',2.07),('8975','2013-05-30','08:55:00',2.71),('8975','2013-05-30','09:00:00',3.05),('8975','2013-05-30','09:05:00',1.29),('8975','2013-05-30','09:10:00',1.77),('8975','2013-05-30','09:15:00',1.3),('8975','2013-05-30','09:20:00',4.04),('8975','2013-05-30','09:25:00',5.52),('8975','2013-05-30','09:30:00',6.13),('8975','2013-05-30','09:35:00',4.35),('8975','2013-05-30','09:40:00',1.84),('8975','2013-05-30','09:45:00',5.17),('8975','2013-05-30','09:50:00',6.79),('8975','2013-05-30','09:55:00',7.09),('8975','2013-05-30','10:00:00',2.05),('8975','2013-05-30','10:05:00',6.99),('8975','2013-05-30','10:10:00',3.7),('8975','2013-05-30','10:15:00',6.21),('8975','2013-05-30','10:20:00',3.46),('8975','2013-05-30','10:25:00',2.17),('8975','2013-05-30','10:30:00',1.45),('8975','2013-05-30','10:35:00',3.14),('8975','2013-05-30','10:40:00',7.88),('8975','2013-05-30','10:45:00',4),('8975','2013-05-30','10:50:00',2.14),('8975','2013-05-30','10:55:00',3.05),('8975','2013-05-30','11:00:00',4.31),('8975','2013-05-30','11:05:00',8.27),('8975','2013-05-30','11:10:00',5.13),('8975','2013-05-30','11:15:00',4.65),('8975','2013-05-30','11:20:00',1.84),('8975','2013-05-30','11:25:00',4.34),('8975','2013-05-30','11:30:00',3.37),('8975','2013-05-30','11:35:00',5.8),('8975','2013-05-30','11:40:00',2.25),('8975','2013-05-30','11:45:00',1.85),('8975','2013-05-30','11:50:00',7.48),('8975','2013-05-30','11:55:00',4.11),('8975','2013-05-30','12:00:00',4.07),('8975','2013-05-30','12:05:00',2.11),('8975','2013-05-30','12:10:00',4.32),('8975','2013-05-30','12:15:00',1.93),('8975','2013-05-30','12:20:00',2.73),('8975','2013-05-30','12:25:00',3.43),('8975','2013-05-30','12:30:00',3.39),('8975','2013-05-30','12:35:00',2.63),('8975','2013-05-30','12:40:00',4.81),('8975','2013-05-30','12:45:00',3.18),('8975','2013-05-30','12:50:00',1.07),('8975','2013-05-30','12:55:00',1.61),('8975','2013-05-30','13:00:00',4.35),('8975','2013-05-30','13:05:00',2.66),('8975','2013-05-30','13:10:00',1.09),('8975','2013-05-30','13:15:00',1.02),('8975','2013-05-30','13:20:00',1.66),('8975','2013-05-30','13:25:00',3),('8975','2013-05-30','13:30:00',6.62),('8975','2013-05-30','13:35:00',5.75),('8975','2013-05-30','13:40:00',1.66),('8975','2013-05-30','13:45:00',1.63),('8975','2013-05-30','13:50:00',1.52),('8975','2013-05-30','13:55:00',2.7),('8975','2013-05-30','14:00:00',1.95),('8975','2013-05-30','14:05:00',1.46),('8975','2013-05-30','14:10:00',1.46),('8975','2013-05-30','14:20:00',1.26),('8975','2013-05-30','14:25:00',1.23),('8975','2013-05-30','14:50:00',1.28),('8975','2013-05-30','14:55:00',1.03),('8975','2013-05-30','15:00:00',1.13),('8975','2013-05-30','15:05:00',1.85),('8975','2013-05-30','15:10:00',2.53),('8975','2013-05-30','15:15:00',4.86),('8975','2013-05-30','15:20:00',5.98),('8975','2013-05-30','15:25:00',5.61),('8975','2013-05-30','15:30:00',3.6),('8975','2013-05-30','15:35:00',3.01),('8975','2013-05-30','15:40:00',2.68),('8975','2013-05-30','15:45:00',2.75),('8975','2013-05-30','15:50:00',3.3),('8975','2013-05-30','15:55:00',3.08),('8975','2013-05-30','16:00:00',2.12),('8975','2013-05-30','16:05:00',2.3),('8975','2013-05-30','16:10:00',1.96),('8975','2013-05-30','16:15:00',1.65),('8975','2013-05-30','16:20:00',1.97),('8975','2013-05-30','16:25:00',2.45),('8975','2013-05-30','16:30:00',2.23),('8975','2013-05-30','16:35:00',1.98),('8975','2013-05-30','16:40:00',2.23),('8975','2013-05-30','16:45:00',1.93),('8975','2013-05-30','16:50:00',1.34),('8975','2013-05-30','16:55:00',1.16),('8975','2013-05-30','17:00:00',1.01),('8975','2013-05-30','17:15:00',1.12),('8975','2013-05-30','17:20:00',1.33),('8975','2013-05-30','17:25:00',1.42),('8975','2013-05-30','17:30:00',1.38),('8975','2013-05-30','17:35:00',1.13),('8975','2013-05-29','07:40:00',1.11),('8975','2013-05-29','07:45:00',1.56),('8975','2013-05-29','07:50:00',3.81),('8975','2013-05-29','07:55:00',2.24),('8975','2013-05-29','08:00:00',1.07),('8975','2013-05-29','08:15:00',1.03),('8975','2013-05-29','08:20:00',1.27),('8975','2013-05-29','08:25:00',2.77),('8975','2013-05-29','08:30:00',2.05),('8975','2013-05-29','08:35:00',2.88),('8975','2013-05-29','08:40:00',5.29),('8975','2013-05-29','08:45:00',5.22),('8975','2013-05-29','08:50:00',5.24),('8975','2013-05-29','08:55:00',5.28),('8975','2013-05-29','09:00:00',5.02),('8975','2013-05-29','09:05:00',5.61),('8975','2013-05-29','09:10:00',5.67),('8975','2013-05-29','09:15:00',5.44),('8975','2013-05-29','09:20:00',5.76),('8975','2013-05-29','09:25:00',5.84),('8975','2013-05-29','09:30:00',5.96),('8975','2013-05-29','09:35:00',6.02),('8975','2013-05-29','09:40:00',6.39),('8975','2013-05-29','09:45:00',6.1),('8975','2013-05-29','09:50:00',4.97),('8975','2013-05-29','09:55:00',4.33),('8975','2013-05-29','10:00:00',1.92),('8975','2013-05-29','10:05:00',1.41),('8975','2013-05-29','10:10:00',3.33),('8975','2013-05-29','10:15:00',3.4),('8975','2013-05-29','10:20:00',2.07),('8975','2013-05-29','10:25:00',3.75),('8975','2013-05-29','10:30:00',4.38),('8975','2013-05-29','10:35:00',3.84),('8975','2013-05-29','10:40:00',2.57),('8975','2013-05-29','10:45:00',5.18),('8975','2013-05-29','10:50:00',1.65),('8975','2013-05-29','10:55:00',6.33),('8975','2013-05-29','11:00:00',5.17),('8975','2013-05-29','11:05:00',6.38),('8975','2013-05-29','11:10:00',8.31),('8975','2013-05-29','11:15:00',8.28),('8975','2013-05-29','11:20:00',7.98),('8975','2013-05-29','11:25:00',6.7),('8975','2013-05-29','11:30:00',6.44),('8975','2013-05-29','11:35:00',5.64),('8975','2013-05-29','11:40:00',8.6),('8975','2013-05-29','11:45:00',6.82),('8975','2013-05-29','11:50:00',2.24),('8975','2013-05-29','11:55:00',7.13),('8975','2013-05-29','12:00:00',8.44),('8975','2013-05-29','12:05:00',7.04),('8975','2013-05-29','12:10:00',2.66),('8975','2013-05-29','12:15:00',5.72),('8975','2013-05-29','12:20:00',7.52),('8975','2013-05-29','12:25:00',6.35),('8975','2013-05-29','12:30:00',8),('8975','2013-05-29','12:35:00',7.81),('8975','2013-05-29','12:40:00',5.33),('8975','2013-05-29','12:45:00',4.89),('8975','2013-05-29','12:50:00',7.66),('8975','2013-05-29','12:55:00',8.04),('8975','2013-05-29','13:00:00',7.83),('8975','2013-05-29','13:05:00',4.31),('8975','2013-05-29','13:10:00',3.16),('8975','2013-05-29','13:15:00',2.52),('8975','2013-05-29','13:20:00',3.35),('8975','2013-05-29','13:25:00',3.86),('8975','2013-05-29','13:30:00',4.78),('8975','2013-05-29','13:35:00',5.69),('8975','2013-05-29','13:40:00',5.62),('8975','2013-05-29','13:45:00',4.51),('8975','2013-05-29','13:50:00',7.58),('8975','2013-05-29','13:55:00',6.91),('8975','2013-05-29','14:00:00',6.04),('8975','2013-05-29','14:05:00',6.54),('8975','2013-05-29','14:10:00',5.97),('8975','2013-05-29','14:15:00',7.72),('8975','2013-05-29','14:20:00',7.55),('8975','2013-05-29','14:25:00',7.36),('8975','2013-05-29','14:30:00',7.18),('8975','2013-05-29','14:35:00',7.06),('8975','2013-05-29','14:40:00',5.51),('8975','2013-05-29','14:45:00',6.48),('8975','2013-05-29','14:50:00',6.78),('8975','2013-05-29','14:55:00',5.84),('8975','2013-05-29','15:00:00',4.88),('8975','2013-05-29','15:05:00',4.55),('8975','2013-05-29','15:10:00',5.42),('8975','2013-05-29','15:15:00',5.52),('8975','2013-05-29','15:20:00',4.42),('8975','2013-05-29','15:25:00',5.96),('8975','2013-05-29','15:30:00',3.96),('8975','2013-05-29','15:35:00',4.61),('8975','2013-05-29','15:40:00',6.14),('8975','2013-05-29','15:45:00',3.46),('8975','2013-05-29','15:50:00',3.33),('8975','2013-05-29','15:55:00',3.8),('8975','2013-05-29','16:00:00',5.15),('8975','2013-05-29','16:05:00',5.63),('8975','2013-05-29','16:10:00',5.72),('8975','2013-05-29','16:15:00',4.93),('8975','2013-05-29','16:20:00',4.76),('8975','2013-05-29','16:25:00',4.78),('8975','2013-05-29','16:30:00',4.03),('8975','2013-05-29','16:35:00',3.48),('8975','2013-05-29','16:40:00',3.57),('8975','2013-05-29','16:45:00',3.62),('8975','2013-05-29','16:50:00',3.5),('8975','2013-05-29','16:55:00',3.93),('8975','2013-05-29','17:00:00',3.36),('8975','2013-05-29','17:05:00',2.9),('8975','2013-05-29','17:10:00',2.61),('8975','2013-05-29','17:15:00',2.7),('8975','2013-05-29','17:20:00',3.34),('8975','2013-05-29','17:25:00',1.88),('8975','2013-05-29','17:30:00',1.38),('8975','2013-05-29','17:35:00',1.23),('8975','2013-05-29','17:40:00',1.02),('8975','2013-05-29','17:55:00',1.13),('8975','2013-05-29','18:00:00',2.87),('8975','2013-05-29','18:05:00',1.79),('8975','2013-05-29','18:20:00',1.05),('8975','2013-05-29','18:25:00',1.15),('8975','2013-05-29','18:30:00',1.37),('8975','2013-05-29','18:35:00',1.63),('8975','2013-05-29','18:40:00',1.57),('8975','2013-05-29','18:45:00',2.01),('8975','2013-05-29','18:50:00',1.71),('8975','2013-05-29','18:55:00',1.03),('8975','2013-05-28','06:25:00',1.15),('8975','2013-05-28','06:30:00',1.33),('8975','2013-05-28','06:35:00',1.53),('8975','2013-05-28','06:40:00',1.71),('8975','2013-05-28','06:45:00',1.84),('8975','2013-05-28','06:50:00',2.04),('8975','2013-05-28','06:55:00',2.26),('8975','2013-05-28','07:00:00',2.45),('8975','2013-05-28','07:05:00',2.63),('8975','2013-05-28','07:10:00',2.79),('8975','2013-05-28','07:15:00',2.66),('8975','2013-05-28','07:20:00',2.54),('8975','2013-05-28','07:25:00',2.06),('8975','2013-05-28','07:30:00',2.21),('8975','2013-05-28','07:35:00',3.05),('8975','2013-05-28','07:40:00',2.69),('8975','2013-05-28','07:45:00',3.33),('8975','2013-05-28','07:50:00',3.4),('8975','2013-05-28','07:55:00',3.75),('8975','2013-05-28','08:00:00',3.7),('8975','2013-05-28','08:05:00',3.76),('8975','2013-05-28','08:10:00',3.96),('8975','2013-05-28','08:15:00',4.14),('8975','2013-05-28','08:20:00',3.93),('8975','2013-05-28','08:25:00',3.36),('8975','2013-05-28','08:30:00',4.09),('8975','2013-05-28','08:35:00',4.72),('8975','2013-05-28','08:40:00',4.82),('8975','2013-05-28','08:45:00',4.9),('8975','2013-05-28','08:50:00',4.98),('8975','2013-05-28','08:55:00',5.08),('8975','2013-05-28','09:00:00',5.12),('8975','2013-05-28','09:05:00',5.28),('8975','2013-05-28','09:10:00',5.43),('8975','2013-05-28','09:15:00',5.52),('8975','2013-05-28','09:20:00',5.59),('8975','2013-05-28','09:25:00',5.7),('8975','2013-05-28','09:30:00',5.76),('8975','2013-05-28','09:35:00',5.88),('8975','2013-05-28','09:40:00',5.99),('8975','2013-05-28','09:45:00',6.07),('8975','2013-05-28','09:50:00',6.13),('8975','2013-05-28','09:55:00',6.19),('8975','2013-05-28','10:00:00',6.28),('8975','2013-05-28','10:05:00',6.39),('8975','2013-05-28','10:10:00',6.45),('8975','2013-05-28','10:15:00',6.52),('8975','2013-05-28','10:20:00',6.6),('8975','2013-05-28','10:25:00',6.69),('8975','2013-05-28','10:30:00',6.77),('8975','2013-05-28','10:35:00',6.83),('8975','2013-05-28','10:40:00',6.89),('8975','2013-05-28','10:45:00',6.97),('8975','2013-05-28','10:50:00',7.02),('8975','2013-05-28','10:55:00',7.11),('8975','2013-05-28','11:00:00',7.31),('8975','2013-05-28','11:05:00',6.8),('8975','2013-05-28','11:10:00',7.02),('8975','2013-05-28','11:15:00',7.06),('8975','2013-05-28','11:20:00',6.68),('8975','2013-05-28','11:25:00',7.96),('8975','2013-05-28','11:30:00',5.69),('8975','2013-05-28','11:35:00',6.95),('8975','2013-05-28','11:40:00',5.34),('8975','2013-05-28','11:45:00',4.09),('8975','2013-05-28','11:50:00',6.14),('8975','2013-05-28','11:55:00',6.09),('8975','2013-05-28','12:00:00',6.62),('8975','2013-05-28','12:05:00',7.73),('8975','2013-05-28','12:10:00',7.97),('8975','2013-05-28','12:15:00',6.74),('8975','2013-05-28','12:20:00',7.12),('8975','2013-05-28','12:25:00',7.66),('8975','2013-05-28','12:30:00',6.5),('8975','2013-05-28','12:35:00',6.35),('8975','2013-05-28','12:40:00',7.57),('8975','2013-05-28','12:45:00',7.51),('8975','2013-05-28','12:50:00',6.57),('8975','2013-05-28','12:55:00',7.48),('8975','2013-05-28','13:00:00',7.46),('8975','2013-05-28','13:05:00',7.64),('8975','2013-05-28','13:10:00',6.71),('8975','2013-05-28','13:15:00',7.38),('8975','2013-05-28','13:20:00',6.65),('8975','2013-05-28','13:25:00',7.77),('8975','2013-05-28','13:30:00',7.53),('8975','2013-05-28','13:35:00',7.42),('8975','2013-05-28','13:40:00',7.92),('8975','2013-05-28','13:45:00',6.15),('8975','2013-05-28','13:50:00',5.67),('8975','2013-05-28','13:55:00',6.12),('8975','2013-05-28','14:00:00',7.14),('8975','2013-05-28','14:05:00',6.8),('8975','2013-05-28','14:10:00',6.49),('8975','2013-05-28','14:15:00',7.04),('8975','2013-05-28','14:20:00',3.63),('8975','2013-05-28','14:25:00',6.19),('8975','2013-05-28','14:30:00',3.27),('8975','2013-05-28','14:35:00',7.02),('8975','2013-05-28','14:40:00',6.87),('8975','2013-05-28','14:45:00',6.73),('8975','2013-05-28','14:50:00',5.5),('8975','2013-05-28','14:55:00',6.69),('8975','2013-05-28','15:00:00',6.29),('8975','2013-05-28','15:05:00',5.3),('8975','2013-05-28','15:10:00',5.56),('8975','2013-05-28','15:15:00',5.93),('8975','2013-05-28','15:20:00',4.91),('8975','2013-05-28','15:25:00',3.87),('8975','2013-05-28','15:30:00',3.55),('8975','2013-05-28','15:35:00',4.24),('8975','2013-05-28','15:40:00',4.22),('8975','2013-05-28','15:45:00',4.32),('8975','2013-05-28','15:50:00',4.31),('8975','2013-05-28','15:55:00',3.88),('8975','2013-05-28','16:00:00',3.79),('8975','2013-05-28','16:05:00',4.13),('8975','2013-05-28','16:10:00',3.43),('8975','2013-05-28','16:15:00',3.47),('8975','2013-05-28','16:20:00',3.49),('8975','2013-05-28','16:25:00',3.49),('8975','2013-05-28','16:30:00',2.72),('8975','2013-05-28','16:35:00',2.87),('8975','2013-05-28','16:40:00',3.41),('8975','2013-05-28','16:45:00',3.13),('8975','2013-05-28','16:50:00',2.59),('8975','2013-05-28','16:55:00',2.38),('8975','2013-05-28','17:00:00',1.9),('8975','2013-05-28','17:25:00',1.13),('8975','2013-05-28','17:30:00',1.21),('8975','2013-05-28','17:35:00',1.85),('8975','2013-05-28','17:40:00',2.13),('8975','2013-05-28','17:45:00',1.77),('8975','2013-05-28','17:50:00',1.32),('8975','2013-05-28','17:55:00',1.1),('8975','2013-05-28','18:00:00',1.25),('8975','2013-05-28','18:05:00',1.36),('8975','2013-05-28','18:10:00',1.21),('8975','2013-05-28','18:15:00',1.48),('8975','2013-05-28','18:20:00',1.15),('8975','2013-05-28','19:05:00',1.1),('8975','2013-05-28','19:10:00',1.27),('8975','2013-05-28','19:15:00',1.08),('8975','2013-05-27','06:30:00',1.14),('8975','2013-05-27','06:35:00',1.38),('8975','2013-05-27','06:40:00',1.91),('8975','2013-05-27','06:45:00',2.15),('8975','2013-05-27','06:50:00',2.26),('8975','2013-05-27','06:55:00',1.82),('8975','2013-05-27','07:00:00',1.17),('8975','2013-05-27','07:05:00',1.34),('8975','2013-05-27','07:10:00',2.04),('8975','2013-05-27','07:15:00',2.71),('8975','2013-05-27','07:20:00',3.09),('8975','2013-05-27','07:25:00',2.83),('8975','2013-05-27','07:30:00',1.73),('8975','2013-05-27','07:35:00',2.13),('8975','2013-05-27','07:40:00',2.53),('8975','2013-05-27','07:45:00',2.48),('8975','2013-05-27','07:50:00',2.4),('8975','2013-05-27','07:55:00',2.58),('8975','2013-05-27','08:00:00',2.72),('8975','2013-05-27','08:05:00',2.83),('8975','2013-05-27','08:10:00',3.48),('8975','2013-05-27','08:15:00',3.75),('8975','2013-05-27','08:20:00',3.79),('8975','2013-05-27','08:25:00',3.15),('8975','2013-05-27','08:30:00',3.62),('8975','2013-05-27','08:35:00',3.03),('8975','2013-05-27','08:40:00',2.6),('8975','2013-05-27','08:45:00',2.58),('8975','2013-05-27','08:50:00',3.05),('8975','2013-05-27','08:55:00',3.15),('8975','2013-05-27','09:00:00',3.11),('8975','2013-05-27','09:05:00',3.22),('8975','2013-05-27','09:10:00',2.82),('8975','2013-05-27','09:15:00',2.84),('8975','2013-05-27','09:20:00',3.68),('8975','2013-05-27','09:25:00',4.13),('8975','2013-05-27','09:30:00',4.13),('8975','2013-05-27','09:35:00',4.16),('8975','2013-05-27','09:40:00',3.85),('8975','2013-05-27','09:45:00',3.59),('8975','2013-05-27','09:50:00',3.9),('8975','2013-05-27','09:55:00',4.13),('8975','2013-05-27','10:00:00',3.79),('8975','2013-05-27','10:05:00',4.23),('8975','2013-05-27','10:10:00',4.56),('8975','2013-05-27','10:15:00',4.89),('8975','2013-05-27','10:20:00',4.84),('8975','2013-05-27','10:25:00',4.93),('8975','2013-05-27','10:30:00',5.59),('8975','2013-05-27','10:35:00',5.47),('8975','2013-05-27','10:40:00',4.49),('8975','2013-05-27','10:45:00',4.37),('8975','2013-05-27','10:50:00',4.96),('8975','2013-05-27','10:55:00',4.05),('8975','2013-05-27','11:00:00',3.93),('8975','2013-05-27','11:05:00',4.56),('8975','2013-05-27','11:10:00',3.97),('8975','2013-05-27','11:15:00',4),('8975','2013-05-27','11:20:00',4.22),('8975','2013-05-27','11:25:00',3.88),('8975','2013-05-27','11:30:00',5.9),('8975','2013-05-27','11:35:00',5.75),('8975','2013-05-27','11:40:00',6.31),('8975','2013-05-27','11:45:00',4.47),('8975','2013-05-27','11:50:00',1.89),('8975','2013-05-27','11:55:00',2.79),('8975','2013-05-27','12:00:00',2.46),('8975','2013-05-27','12:05:00',3.21),('8975','2013-05-27','12:10:00',6.17),('8975','2013-05-27','12:15:00',4.35),('8975','2013-05-27','12:20:00',4.03),('8975','2013-05-27','12:25:00',4.38),('8975','2013-05-27','12:30:00',4.56),('8975','2013-05-27','12:35:00',4.2),('8975','2013-05-27','12:40:00',4.58),('8975','2013-05-27','12:45:00',4.94),('8975','2013-05-27','12:50:00',4.45),('8975','2013-05-27','12:55:00',4.49),('8975','2013-05-27','13:00:00',4.6),('8975','2013-05-27','13:05:00',4.85),('8975','2013-05-27','13:10:00',4.76),('8975','2013-05-27','13:15:00',4.84),('8975','2013-05-27','13:20:00',4.42),('8975','2013-05-27','13:25:00',3.09),('8975','2013-05-27','13:30:00',3.34),('8975','2013-05-27','13:35:00',3),('8975','2013-05-27','13:40:00',3.21),('8975','2013-05-27','13:45:00',3.7),('8975','2013-05-27','13:50:00',4.99),('8975','2013-05-27','13:55:00',4.34),('8975','2013-05-27','14:00:00',4.09),('8975','2013-05-27','14:05:00',4.92),('8975','2013-05-27','14:10:00',6.21),('8975','2013-05-27','14:15:00',4.69),('8975','2013-05-27','14:20:00',4.36),('8975','2013-05-27','14:25:00',4.54),('8975','2013-05-27','14:30:00',4.78),('8975','2013-05-27','14:35:00',4.97),('8975','2013-05-27','14:40:00',5.35),('8975','2013-05-27','14:45:00',4.89),('8975','2013-05-27','14:50:00',3.86),('8975','2013-05-27','14:55:00',3.45),('8975','2013-05-27','15:00:00',4.33),('8975','2013-05-27','15:05:00',4.65),('8975','2013-05-27','15:10:00',3.16),('8975','2013-05-27','15:15:00',4.44),('8975','2013-05-27','15:20:00',4.44),('8975','2013-05-27','15:25:00',3.03),('8975','2013-05-27','15:30:00',2.46),('8975','2013-05-27','15:35:00',2.77),('8975','2013-05-27','15:40:00',5.18),('8975','2013-05-27','15:45:00',4.75),('8975','2013-05-27','15:50:00',4.2),('8975','2013-05-27','15:55:00',2.78),('8975','2013-05-27','16:00:00',2.14),('8975','2013-05-27','16:05:00',2.61),('8975','2013-05-27','16:10:00',1.85),('8975','2013-05-27','16:15:00',2.67),('8975','2013-05-27','16:20:00',3.4),('8975','2013-05-27','16:25:00',3.88),('8975','2013-05-27','16:30:00',3.75),('8975','2013-05-27','16:35:00',3.81),('8975','2013-05-27','16:40:00',3.57),('8975','2013-05-27','16:45:00',3.41),('8975','2013-05-27','16:50:00',3.31),('8975','2013-05-27','16:55:00',3.19),('8975','2013-05-27','17:00:00',3.1),('8975','2013-05-27','17:05:00',2.99),('8975','2013-05-27','17:10:00',2.88),('8975','2013-05-27','17:15:00',2.78),('8975','2013-05-27','17:20:00',2.66),('8975','2013-05-27','17:25:00',2.47),('8975','2013-05-27','17:30:00',2.39),('8975','2013-05-27','17:35:00',2.26),('8975','2013-05-27','17:40:00',2.12),('8975','2013-05-27','17:45:00',2.01),('8975','2013-05-27','17:50:00',1.91),('8975','2013-05-27','17:55:00',1.82),('8975','2013-05-27','18:00:00',1.82),('8975','2013-05-27','18:05:00',1.73),('8975','2013-05-27','18:10:00',1.43),('8975','2013-05-27','18:35:00',1.33),('8975','2013-05-27','18:40:00',1.25),('8975','2013-05-27','18:45:00',1.21),('8975','2013-05-27','18:50:00',1.15),('8975','2013-05-27','18:55:00',1.1),('8975','2013-05-27','19:00:00',1.03),('8975','2013-05-26','06:40:00',1.04),('8975','2013-05-26','06:45:00',1.06),('8975','2013-05-26','06:50:00',1.54),('8975','2013-05-26','06:55:00',1.41),('8975','2013-05-26','07:00:00',2.41),('8975','2013-05-26','07:05:00',2.98),('8975','2013-05-26','07:10:00',2.17),('8975','2013-05-26','07:15:00',1.1),('8975','2013-05-26','07:20:00',2.5),('8975','2013-05-26','07:25:00',3.44),('8975','2013-05-26','07:30:00',3.45),('8975','2013-05-26','07:35:00',3.55),('8975','2013-05-26','07:40:00',3.73),('8975','2013-05-26','07:45:00',3.62),('8975','2013-05-26','07:50:00',3.67),('8975','2013-05-26','07:55:00',1.85),('8975','2013-05-26','08:00:00',2.7),('8975','2013-05-26','08:05:00',4.22),('8975','2013-05-26','08:10:00',3.92),('8975','2013-05-26','08:15:00',3.78),('8975','2013-05-26','08:20:00',4.68),('8975','2013-05-26','08:25:00',4.72),('8975','2013-05-26','08:30:00',4.72),('8975','2013-05-26','08:35:00',4.43),('8975','2013-05-26','08:40:00',4.49),('8975','2013-05-26','08:45:00',4.48),('8975','2013-05-26','08:50:00',2.83),('8975','2013-05-26','08:55:00',4.01),('8975','2013-05-26','09:00:00',5.53),('8975','2013-05-26','09:05:00',5.77),('8975','2013-05-26','09:10:00',6.06),('8975','2013-05-26','09:15:00',6.3),('8975','2013-05-26','09:20:00',3.05),('8975','2013-05-26','09:25:00',6.16),('8975','2013-05-26','09:30:00',6.23),('8975','2013-05-26','09:35:00',6.36),('8975','2013-05-26','09:40:00',6.35),('8975','2013-05-26','09:45:00',6.47),('8975','2013-05-26','09:50:00',6.79),('8975','2013-05-26','09:55:00',5.82),('8975','2013-05-26','10:00:00',4.33),('8975','2013-05-26','10:05:00',6.73),('8975','2013-05-26','10:10:00',6.95),('8975','2013-05-26','10:15:00',6.99),('8975','2013-05-26','10:20:00',7.02),('8975','2013-05-26','10:25:00',7.4),('8975','2013-05-26','10:30:00',6.71),('8975','2013-05-26','10:35:00',1.67),('8975','2013-05-26','10:40:00',5.53),('8975','2013-05-26','10:45:00',7.75),('8975','2013-05-26','10:50:00',2.75),('8975','2013-05-26','10:55:00',3.07),('8975','2013-05-26','11:00:00',6.3),('8975','2013-05-26','11:05:00',6.25),('8975','2013-05-26','11:10:00',2.4),('8975','2013-05-26','11:15:00',3.89),('8975','2013-05-26','11:20:00',6.98),('8975','2013-05-26','11:25:00',2.28),('8975','2013-05-26','11:30:00',4.02),('8975','2013-05-26','11:35:00',7.9),('8975','2013-05-26','11:40:00',4.43),('8975','2013-05-26','11:45:00',6.39),('8975','2013-05-26','11:50:00',6.06),('8975','2013-05-26','11:55:00',6.76),('8975','2013-05-26','12:00:00',7.27),('8975','2013-05-26','12:05:00',7.87),('8975','2013-05-26','12:10:00',6.55),('8975','2013-05-26','12:15:00',4.91),('8975','2013-05-26','12:20:00',8.38),('8975','2013-05-26','12:25:00',8.11),('8975','2013-05-26','12:30:00',8.01),('8975','2013-05-26','12:35:00',7.23),('8975','2013-05-26','12:40:00',7.47),('8975','2013-05-26','12:45:00',8.04),('8975','2013-05-26','12:50:00',7.61),('8975','2013-05-26','12:55:00',5.39),('8975','2013-05-26','13:00:00',5.47),('8975','2013-05-26','13:05:00',6.02),('8975','2013-05-26','13:10:00',4.88),('8975','2013-05-26','13:15:00',2.32),('8975','2013-05-26','13:20:00',7.81),('8975','2013-05-26','13:25:00',7.52),('8975','2013-05-26','13:30:00',5.59),('8975','2013-05-26','13:35:00',6.35),('8975','2013-05-26','13:40:00',6.58),('8975','2013-05-26','13:45:00',6.97),('8975','2013-05-26','13:50:00',7.31),('8975','2013-05-26','13:55:00',7.13),('8975','2013-05-26','14:00:00',4.5),('8975','2013-05-26','14:05:00',4.7),('8975','2013-05-26','14:10:00',6.81),('8975','2013-05-26','14:15:00',6.82),('8975','2013-05-26','14:20:00',6.91),('8975','2013-05-26','14:25:00',5.87),('8975','2013-05-26','14:30:00',6.67),('8975','2013-05-26','14:35:00',6.56),('8975','2013-05-26','14:40:00',6.67),('8975','2013-05-26','14:45:00',6.45),('8975','2013-05-26','14:50:00',6.36),('8975','2013-05-26','14:55:00',5.42),('8975','2013-05-26','15:00:00',4.43),('8975','2013-05-26','15:05:00',3.51),('8975','2013-05-26','15:10:00',6.27),('8975','2013-05-26','15:15:00',4.21),('8975','2013-05-26','15:20:00',5.71),('8975','2013-05-26','15:25:00',4.94),('8975','2013-05-26','15:30:00',4.92),('8975','2013-05-26','15:35:00',5.79),('8975','2013-05-26','15:40:00',5.18),('8975','2013-05-26','15:45:00',4.77),('8975','2013-05-26','15:50:00',5.38),('8975','2013-05-26','15:55:00',3.97),('8975','2013-05-26','16:00:00',3.91),('8975','2013-05-26','16:05:00',3.36),('8975','2013-05-26','16:10:00',3.63),('8975','2013-05-26','16:15:00',3.25),('8975','2013-05-26','16:20:00',5.27),('8975','2013-05-26','16:25:00',4.78),('8975','2013-05-26','16:30:00',4.45),('8975','2013-05-26','16:35:00',3.52),('8975','2013-05-26','16:40:00',2.01),('8975','2013-05-26','16:45:00',1.87),('8975','2013-05-26','16:50:00',2.06),('8975','2013-05-26','16:55:00',2.22),('8975','2013-05-26','17:00:00',2.31),('8975','2013-05-26','17:05:00',2.29),('8975','2013-05-26','17:10:00',2.6),('8975','2013-05-26','17:15:00',2.36),('8975','2013-05-26','17:20:00',2.1),('8975','2013-05-26','17:25:00',1.93),('8975','2013-05-26','17:30:00',1.84),('8975','2013-05-26','17:35:00',1.7),('8975','2013-05-26','17:40:00',1.6),('8975','2013-05-26','17:45:00',1.52),('8975','2013-05-26','17:50:00',1.46),('8975','2013-05-26','17:55:00',1.48),('8975','2013-05-26','18:00:00',1.47),('8975','2013-05-26','18:05:00',1.31),('8975','2013-05-26','18:10:00',1.34),('8975','2013-05-26','18:15:00',1.48),('8975','2013-05-26','18:20:00',1.73),('8975','2013-05-26','18:25:00',2.08),('8975','2013-05-26','18:30:00',1.9),('8975','2013-05-26','18:35:00',1.2),('8975','2013-05-26','18:45:00',1.23),('8975','2013-05-26','18:50:00',1.02),('8975','2013-05-26','18:55:00',1.29),('8975','2013-05-26','19:00:00',1.49),('8975','2013-05-26','19:05:00',1.61),('8975','2013-05-26','19:10:00',1.46),('8975','2013-05-26','19:15:00',1.27),('8975','2013-05-26','19:30:00',1.09),('8975','2013-05-26','19:35:00',1.01),('8975','2013-05-25','07:20:00',2.29),('8975','2013-05-25','07:25:00',1.35),('8975','2013-05-25','07:35:00',3.67),('8975','2013-05-25','07:40:00',3.79),('8975','2013-05-25','07:45:00',4),('8975','2013-05-25','07:50:00',4.54),('8975','2013-05-25','07:55:00',2.47),('8975','2013-05-25','08:00:00',1.41),('8975','2013-05-25','08:05:00',3.88),('8975','2013-05-25','08:10:00',4.98),('8975','2013-05-25','08:15:00',1.04),('8975','2013-05-25','08:20:00',1.31),('8975','2013-05-25','08:25:00',1.94),('8975','2013-05-25','08:30:00',6.1),('8975','2013-05-25','08:35:00',1.53),('8975','2013-05-25','08:40:00',1.05),('8975','2013-05-25','08:45:00',6.06),('8975','2013-05-25','08:50:00',3.97),('8975','2013-05-25','08:55:00',2.75),('8975','2013-05-25','09:00:00',3.22),('8975','2013-05-25','09:05:00',1.55),('8975','2013-05-25','09:10:00',1.91),('8975','2013-05-25','09:15:00',3.61),('8975','2013-05-25','09:20:00',5.93),('8975','2013-05-25','09:25:00',1.66),('8975','2013-05-25','09:30:00',1.19),('8975','2013-05-25','09:35:00',1.66),('8975','2013-05-25','09:40:00',3.98),('8975','2013-05-25','09:45:00',6.02),('8975','2013-05-25','09:50:00',1.34),('8975','2013-05-25','09:55:00',2.45),('8975','2013-05-25','10:00:00',3.14),('8975','2013-05-25','10:05:00',4.3),('8975','2013-05-25','10:10:00',7.27),('8975','2013-05-25','10:15:00',5.72),('8975','2013-05-25','10:20:00',5.69),('8975','2013-05-25','10:25:00',7.47),('8975','2013-05-25','10:30:00',7.26),('8975','2013-05-25','10:35:00',6.01),('8975','2013-05-25','10:40:00',7.06),('8975','2013-05-25','10:45:00',6.11),('8975','2013-05-25','10:50:00',7.54),('8975','2013-05-25','10:55:00',7.32),('8975','2013-05-25','11:00:00',7.45),('8975','2013-05-25','11:05:00',7.44),('8975','2013-05-25','11:10:00',7.47),('8975','2013-05-25','11:15:00',7.51),('8975','2013-05-25','11:20:00',7.58),('8975','2013-05-25','11:25:00',7.6),('8975','2013-05-25','11:30:00',7.8),('8975','2013-05-25','11:35:00',7.35),('8975','2013-05-25','11:40:00',7.53),('8975','2013-05-25','11:45:00',7.38),('8975','2013-05-25','11:50:00',7.7),('8975','2013-05-25','11:55:00',7.81),('8975','2013-05-25','12:00:00',7.45),('8975','2013-05-25','12:05:00',6.63),('8975','2013-05-25','12:10:00',8.53),('8975','2013-05-25','12:15:00',8.13),('8975','2013-05-25','12:20:00',8.01),('8975','2013-05-25','12:25:00',5.24),('8975','2013-05-25','12:30:00',7.95),('8975','2013-05-25','12:35:00',6.7),('8975','2013-05-25','12:40:00',6.53),('8975','2013-05-25','12:45:00',8.05),('8975','2013-05-25','12:50:00',7.82),('8975','2013-05-25','12:55:00',6.54),('8975','2013-05-25','13:00:00',7.73),('8975','2013-05-25','13:05:00',7.72),('8975','2013-05-25','13:10:00',7.45),('8975','2013-05-25','13:15:00',7.46),('8975','2013-05-25','13:20:00',5.95),('8975','2013-05-25','13:25:00',5.92),('8975','2013-05-25','13:30:00',7.11),('8975','2013-05-25','13:35:00',6.77),('8975','2013-05-25','13:40:00',7.4),('8975','2013-05-25','13:45:00',7.27),('8975','2013-05-25','13:50:00',7.18),('8975','2013-05-25','13:55:00',7.09),('8975','2013-05-25','14:00:00',7.13),('8975','2013-05-25','14:05:00',6.98),('8975','2013-05-25','14:10:00',6.89),('8975','2013-05-25','14:15:00',6.65),('8975','2013-05-25','14:20:00',6.79),('8975','2013-05-25','14:25:00',6.67),('8975','2013-05-25','14:30:00',6.62),('8975','2013-05-25','14:35:00',6.53),('8975','2013-05-25','14:40:00',6.43),('8975','2013-05-25','14:45:00',6.38),('8975','2013-05-25','14:50:00',6.31),('8975','2013-05-25','14:55:00',6.21),('8975','2013-05-25','15:00:00',6.12),('8975','2013-05-25','15:05:00',6.04),('8975','2013-05-25','15:10:00',5.94),('8975','2013-05-25','15:15:00',5.89),('8975','2013-05-25','15:20:00',5.78),('8975','2013-05-25','15:25:00',5.63),('8975','2013-05-25','15:30:00',5.57),('8975','2013-05-25','15:35:00',5.46),('8975','2013-05-25','15:40:00',5.36),('8975','2013-05-25','15:45:00',5.25),('8975','2013-05-25','15:50:00',5.13),('8975','2013-05-25','15:55:00',5.01),('8975','2013-05-25','16:00:00',4.91),('8975','2013-05-25','16:05:00',4.76),('8975','2013-05-25','16:10:00',4.5),('8975','2013-05-25','16:15:00',4.54),('8975','2013-05-25','16:20:00',4.38),('8975','2013-05-25','16:25:00',4.24),('8975','2013-05-25','16:30:00',4.13),('8975','2013-05-25','16:35:00',4.02),('8975','2013-05-25','16:40:00',3.85),('8975','2013-05-25','16:45:00',3.77),('8975','2013-05-25','16:50:00',3.64),('8975','2013-05-25','16:55:00',3.5),('8975','2013-05-25','17:00:00',3.36),('8975','2013-05-25','17:05:00',3.24),('8975','2013-05-25','17:10:00',3.09),('8975','2013-05-25','17:15:00',2.97),('8975','2013-05-25','17:20:00',2.84),('8975','2013-05-25','17:25:00',2.7),('8975','2013-05-25','17:30:00',2.58),('8975','2013-05-25','17:35:00',2.47),('8975','2013-05-25','17:40:00',2.33),('8975','2013-05-25','17:45:00',2.22),('8975','2013-05-25','17:50:00',2.1),('8975','2013-05-25','17:55:00',1.99),('8975','2013-05-25','18:00:00',1.89),('8975','2013-05-25','18:05:00',1.8),('8975','2013-05-25','18:10:00',1.71),('8975','2013-05-25','18:15:00',1.63),('8975','2013-05-25','18:20:00',1.58),('8975','2013-05-25','18:25:00',1.52),('8975','2013-05-25','18:30:00',1.47),('8975','2013-05-25','18:35:00',1.42),('8975','2013-05-25','18:40:00',1.37),('8975','2013-05-25','18:45:00',1.33),('8975','2013-05-25','18:50:00',1.27),('8975','2013-05-25','18:55:00',1.21),('8975','2013-05-25','19:00:00',1.17),('8975','2013-05-25','19:05:00',1.1),('8975','2013-05-25','19:10:00',1.05),('8975','2013-05-24','06:25:00',1.15),('8975','2013-05-24','06:35:00',1.47),('8975','2013-05-24','06:55:00',1.62),('8975','2013-05-24','07:10:00',1.75),('8975','2013-05-24','07:15:00',3.21),('8975','2013-05-24','07:20:00',2.5),('8975','2013-05-24','07:25:00',1.5),('8975','2013-05-24','07:30:00',3.57),('8975','2013-05-24','07:35:00',4.25),('8975','2013-05-24','07:40:00',2.94),('8975','2013-05-24','07:45:00',1.17),('8975','2013-05-24','07:50:00',1.28),('8975','2013-05-24','07:55:00',4.01),('8975','2013-05-24','08:00:00',4.51),('8975','2013-05-24','08:05:00',4.09),('8975','2013-05-24','08:10:00',2.4),('8975','2013-05-24','08:15:00',1.07),('8975','2013-05-24','08:20:00',3.33),('8975','2013-05-24','08:25:00',5.34),('8975','2013-05-24','08:30:00',5.2),('8975','2013-05-24','08:35:00',3.48),('8975','2013-05-24','08:40:00',3.45),('8975','2013-05-24','08:45:00',2.06),('8975','2013-05-24','08:50:00',3.46),('8975','2013-05-24','08:55:00',2.94),('8975','2013-05-24','09:00:00',2.85),('8975','2013-05-24','09:05:00',4.14),('8975','2013-05-24','09:10:00',5.88),('8975','2013-05-24','09:15:00',5.92),('8975','2013-05-24','09:20:00',2.51),('8975','2013-05-24','09:25:00',2.67),('8975','2013-05-24','09:30:00',1.5),('8975','2013-05-24','09:35:00',3.14),('8975','2013-05-24','09:40:00',6.76),('8975','2013-05-24','09:45:00',4.04),('8975','2013-05-24','09:50:00',4.63),('8975','2013-05-24','09:55:00',3.63),('8975','2013-05-24','10:00:00',1.83),('8975','2013-05-24','10:05:00',1.49),('8975','2013-05-24','10:10:00',1.92),('8975','2013-05-24','10:15:00',1.28),('8975','2013-05-24','10:25:00',2),('8975','2013-05-24','10:30:00',1.77),('8975','2013-05-24','10:35:00',2.03),('8975','2013-05-24','10:40:00',3.17),('8975','2013-05-24','10:45:00',2.4),('8975','2013-05-24','10:50:00',2.56),('8975','2013-05-24','10:55:00',1.74),('8975','2013-05-24','11:00:00',2.85),('8975','2013-05-24','11:05:00',3.09),('8975','2013-05-24','11:10:00',5.87),('8975','2013-05-24','11:15:00',5.11),('8975','2013-05-24','11:20:00',2.4),('8975','2013-05-24','11:25:00',1.46),('8975','2013-05-24','11:35:00',1.72),('8975','2013-05-24','11:40:00',2.24),('8975','2013-05-24','11:45:00',4.83),('8975','2013-05-24','11:50:00',4.14),('8975','2013-05-24','11:55:00',2.55),('8975','2013-05-24','12:00:00',1.78),('8975','2013-05-24','12:05:00',2.18),('8975','2013-05-24','12:10:00',2.21),('8975','2013-05-24','12:15:00',1.74),('8975','2013-05-24','12:20:00',2.18),('8975','2013-05-24','12:25:00',3.06),('8975','2013-05-24','12:30:00',2.22),('8975','2013-05-24','12:35:00',2.08),('8975','2013-05-24','12:40:00',2.7),('8975','2013-05-24','12:45:00',4.12),('8975','2013-05-24','12:50:00',5.53),('8975','2013-05-24','12:55:00',6.85),('8975','2013-05-24','13:00:00',4.27),('8975','2013-05-24','13:05:00',2.26),('8975','2013-05-24','13:10:00',3.26),('8975','2013-05-24','13:15:00',4),('8975','2013-05-24','13:20:00',2.42),('8975','2013-05-24','13:25:00',2.99),('8975','2013-05-24','13:30:00',2.35),('8975','2013-05-24','13:35:00',2.26),('8975','2013-05-24','13:40:00',3.35),('8975','2013-05-24','13:45:00',4.27),('8975','2013-05-24','13:50:00',7.78),('8975','2013-05-24','13:55:00',6.43),('8975','2013-05-24','14:00:00',5.94),('8975','2013-05-24','14:05:00',6.46),('8975','2013-05-24','14:10:00',7.62),('8975','2013-05-24','14:15:00',6.08),('8975','2013-05-24','14:20:00',6.21),('8975','2013-05-24','14:25:00',7.45),('8975','2013-05-24','14:30:00',5.48),('8975','2013-05-24','14:35:00',6.45),('8975','2013-05-24','14:40:00',2.34),('8975','2013-05-24','14:45:00',3.83),('8975','2013-05-24','14:50:00',6.3),('8975','2013-05-24','14:55:00',5.7),('8975','2013-05-24','15:00:00',3.53),('8975','2013-05-24','15:05:00',2.55),('8975','2013-05-24','15:10:00',2.54),('8975','2013-05-24','15:15:00',3.74),('8975','2013-05-24','15:20:00',4.68),('8975','2013-05-24','15:25:00',7.45),('8975','2013-05-24','15:30:00',2.5),('8975','2013-05-24','15:35:00',4.73),('8975','2013-05-24','15:40:00',4.71),('8975','2013-05-24','15:45:00',3),('8975','2013-05-24','15:50:00',1.89),('8975','2013-05-24','15:55:00',3.18),('8975','2013-05-24','16:00:00',5),('8975','2013-05-24','16:05:00',3.52),('8975','2013-05-24','16:10:00',3.68),('8975','2013-05-24','16:15:00',4.42),('8975','2013-05-24','16:20:00',5.5),('8975','2013-05-24','16:25:00',2.7),('8975','2013-05-24','16:30:00',3.25),('8975','2013-05-24','16:35:00',2.46),('8975','2013-05-24','16:40:00',1.61),('8975','2013-05-24','16:45:00',1.72),('8975','2013-05-24','16:50:00',4.56),('8975','2013-05-24','16:55:00',2.69),('8975','2013-05-24','17:00:00',3.3),('8975','2013-05-24','17:05:00',3.84),('8975','2013-05-24','17:10:00',3.47),('8975','2013-05-24','17:15:00',2.53),('8975','2013-05-24','17:20:00',2.79),('8975','2013-05-24','17:25:00',1.99),('8975','2013-05-24','17:30:00',2.14),('8975','2013-05-24','17:35:00',1.63),('8975','2013-05-24','17:40:00',2.57),('8975','2013-05-24','17:45:00',3.08),('8975','2013-05-24','17:50:00',1.72),('8975','2013-05-24','17:55:00',1.43),('8975','2013-05-24','18:00:00',2.47),('8975','2013-05-24','18:05:00',2.03),('8975','2013-05-24','18:10:00',1.86),('8975','2013-05-24','18:15:00',1.36),('8975','2013-05-24','18:20:00',1.26),('8975','2013-05-23','07:00:00',1.33),('8975','2013-05-23','07:05:00',1.68),('8975','2013-05-23','07:10:00',1.61),('8975','2013-05-23','08:00:00',2.67),('8975','2013-05-23','08:05:00',3.14),('8975','2013-05-23','08:10:00',4.67),('8975','2013-05-23','08:15:00',3.01),('8975','2013-05-23','08:25:00',1.14),('8975','2013-05-23','08:30:00',4.74),('8975','2013-05-23','08:35:00',4.39),('8975','2013-05-23','08:40:00',4.77),('8975','2013-05-23','08:45:00',4.68),('8975','2013-05-23','08:50:00',5.25),('8975','2013-05-23','08:55:00',5.42),('8975','2013-05-23','09:00:00',5.97),('8975','2013-05-23','09:05:00',3.65),('8975','2013-05-23','09:10:00',1.05),('8975','2013-05-23','09:15:00',1.76),('8975','2013-05-23','09:20:00',4.71),('8975','2013-05-23','09:25:00',6.87),('8975','2013-05-23','09:30:00',6.28),('8975','2013-05-23','09:35:00',2.19),('8975','2013-05-23','09:40:00',7.11),('8975','2013-05-23','09:45:00',3.44),('8975','2013-05-23','09:50:00',3.48),('8975','2013-05-23','09:55:00',6.94),('8975','2013-05-23','10:00:00',1.5),('8975','2013-05-23','10:05:00',2),('8975','2013-05-23','10:10:00',1.68),('8975','2013-05-23','10:15:00',1.07),('8975','2013-05-23','10:20:00',2.77),('8975','2013-05-23','10:25:00',4.7),('8975','2013-05-23','10:30:00',4.18),('8975','2013-05-23','10:35:00',7.16),('8975','2013-05-23','10:40:00',7.88),('8975','2013-05-23','10:45:00',6.71),('8975','2013-05-23','10:50:00',2.18),('8975','2013-05-23','10:55:00',6.61),('8975','2013-05-23','11:00:00',3.57),('8975','2013-05-23','11:05:00',6.55),('8975','2013-05-23','11:10:00',7.55),('8975','2013-05-23','11:15:00',7.67),('8975','2013-05-23','11:20:00',7.74),('8975','2013-05-23','11:25:00',5.94),('8975','2013-05-23','11:30:00',1.92),('8975','2013-05-23','11:35:00',1.61),('8975','2013-05-23','11:40:00',2.82),('8975','2013-05-23','11:45:00',7.9),('8975','2013-05-23','11:50:00',7.35),('8975','2013-05-23','11:55:00',8.11),('8975','2013-05-23','12:00:00',3.17),('8975','2013-05-23','12:05:00',6.12),('8975','2013-05-23','12:10:00',6.11),('8975','2013-05-23','12:15:00',3.12),('8975','2013-05-23','12:20:00',3.91),('8975','2013-05-23','12:25:00',7.09),('8975','2013-05-23','12:30:00',3.79),('8975','2013-05-23','12:35:00',4),('8975','2013-05-23','12:40:00',4.29),('8975','2013-05-23','12:45:00',4.48),('8975','2013-05-23','12:50:00',4.2),('8975','2013-05-23','12:55:00',4.14),('8975','2013-05-23','13:00:00',3.38),('8975','2013-05-23','13:05:00',4.32),('8975','2013-05-23','13:10:00',4.69),('8975','2013-05-23','13:15:00',4),('8975','2013-05-23','13:20:00',3.53),('8975','2013-05-23','13:25:00',5.61),('8975','2013-05-23','13:30:00',5.22),('8975','2013-05-23','13:35:00',7.78),('8975','2013-05-23','13:40:00',7.02),('8975','2013-05-23','13:45:00',2.7),('8975','2013-05-23','13:50:00',5.2),('8975','2013-05-23','13:55:00',7.4),('8975','2013-05-23','14:00:00',5.75),('8975','2013-05-23','14:05:00',3.25),('8975','2013-05-23','14:10:00',1.99),('8975','2013-05-23','14:15:00',4.27),('8975','2013-05-23','14:20:00',4.66),('8975','2013-05-23','14:25:00',4.77),('8975','2013-05-23','14:30:00',7.82),('8975','2013-05-23','14:35:00',6.72),('8975','2013-05-23','14:40:00',2.79),('8975','2013-05-23','14:45:00',2.37),('8975','2013-05-23','14:50:00',2.9),('8975','2013-05-23','14:55:00',3.41),('8975','2013-05-23','15:00:00',6.58),('8975','2013-05-23','15:05:00',3.27),('8975','2013-05-23','15:10:00',3.97),('8975','2013-05-23','15:15:00',7.28),('8975','2013-05-23','15:20:00',6.34),('8975','2013-05-23','15:25:00',7.22),('8975','2013-05-23','15:30:00',5.45),('8975','2013-05-23','15:35:00',3.96),('8975','2013-05-23','15:40:00',4.07),('8975','2013-05-23','15:45:00',5.06),('8975','2013-05-23','15:50:00',6.2),('8975','2013-05-23','15:55:00',4.7),('8975','2013-05-23','16:00:00',3.25),('8975','2013-05-23','16:05:00',3.56),('8975','2013-05-23','16:10:00',3.15),('8975','2013-05-23','16:15:00',3.15),('8975','2013-05-23','16:20:00',2.76),('8975','2013-05-23','16:25:00',3.85),('8975','2013-05-23','16:30:00',3.05),('8975','2013-05-23','16:35:00',1.73),('8975','2013-05-23','16:40:00',1.02),('8975','2013-05-23','16:50:00',1.83),('8975','2013-05-23','16:55:00',2.72),('8975','2013-05-23','17:00:00',1.88),('8975','2013-05-23','17:05:00',1.39),('8975','2013-05-23','17:10:00',1.03),('8975','2013-05-23','17:15:00',1.16),('8975','2013-05-23','17:20:00',1.39),('8975','2013-05-23','17:25:00',1.45),('8975','2013-05-23','17:30:00',1.74),('8975','2013-05-23','17:35:00',1.73),('8975','2013-05-23','17:40:00',1.41),('8975','2013-05-23','17:45:00',1.17),('8975','2013-05-23','18:05:00',1.02),('8975','2013-05-22','07:05:00',1.09),('8975','2013-05-22','07:10:00',1.89),('8975','2013-05-22','07:15:00',1.52),('8975','2013-05-22','07:45:00',1.23),('8975','2013-05-22','07:50:00',1.47),('8975','2013-05-22','07:55:00',1.6),('8975','2013-05-22','08:00:00',2.35),('8975','2013-05-22','08:05:00',2.56),('8975','2013-05-22','08:10:00',1.37),('8975','2013-05-22','08:25:00',2.33),('8975','2013-05-22','08:30:00',5.8),('8975','2013-05-22','08:35:00',1.79),('8975','2013-05-22','08:40:00',1.06),('8975','2013-05-22','08:45:00',1.3),('8975','2013-05-22','08:50:00',3.56),('8975','2013-05-22','08:55:00',3.49),('8975','2013-05-22','09:00:00',4.49),('8975','2013-05-22','09:05:00',3.73),('8975','2013-05-22','09:10:00',1.53),('8975','2013-05-22','09:15:00',1.94),('8975','2013-05-22','09:20:00',4.45),('8975','2013-05-22','09:25:00',2.47),('8975','2013-05-22','09:30:00',3.99),('8975','2013-05-22','09:35:00',5.99),('8975','2013-05-22','09:40:00',2.92),('8975','2013-05-22','09:45:00',5.11),('8975','2013-05-22','09:50:00',6.58),('8975','2013-05-22','09:55:00',4.69),('8975','2013-05-22','10:00:00',5.3),('8975','2013-05-22','10:05:00',3.95),('8975','2013-05-22','10:10:00',4.27),('8975','2013-05-22','10:15:00',2.48),('8975','2013-05-22','10:20:00',7.79),('8975','2013-05-22','10:25:00',7.58),('8975','2013-05-22','10:30:00',5.22),('8975','2013-05-22','10:35:00',5.84),('8975','2013-05-22','10:40:00',3.41),('8975','2013-05-22','10:45:00',5.45),('8975','2013-05-22','10:50:00',5.65),('8975','2013-05-22','10:55:00',8.09),('8975','2013-05-22','11:00:00',4.12),('8975','2013-05-22','11:05:00',8.2),('8975','2013-05-22','11:10:00',6.16),('8975','2013-05-22','11:15:00',2.84),('8975','2013-05-22','11:20:00',7.91),('8975','2013-05-22','11:25:00',7.17),('8975','2013-05-22','11:30:00',5.54),('8975','2013-05-22','11:35:00',5.27),('8975','2013-05-22','11:40:00',3.68),('8975','2013-05-22','11:45:00',6.75),('8975','2013-05-22','11:50:00',7.71),('8975','2013-05-22','11:55:00',7.36),('8975','2013-05-22','12:00:00',5.64),('8975','2013-05-22','12:05:00',8.03),('8975','2013-05-22','12:10:00',7.11),('8975','2013-05-22','12:15:00',3.46),('8975','2013-05-22','12:20:00',4.67),('8975','2013-05-22','12:25:00',7.12),('8975','2013-05-22','12:30:00',7.7),('8975','2013-05-22','12:35:00',1.93),('8975','2013-05-22','12:40:00',6.65),('8975','2013-05-22','12:45:00',6.53),('8975','2013-05-22','12:50:00',7.33),('8975','2013-05-22','12:55:00',6.18),('8975','2013-05-22','13:00:00',6.91),('8975','2013-05-22','13:05:00',7.58),('8975','2013-05-22','13:10:00',6.65),('8975','2013-05-22','13:15:00',5.59),('8975','2013-05-22','13:20:00',7.19),('8975','2013-05-22','13:25:00',5.46),('8975','2013-05-22','13:30:00',5.96),('8975','2013-05-22','13:35:00',3.93),('8975','2013-05-22','13:40:00',2.77),('8975','2013-05-22','13:45:00',6.95),('8975','2013-05-22','13:50:00',6.99),('8975','2013-05-22','13:55:00',4.36),('8975','2013-05-22','14:00:00',6.9),('8975','2013-05-22','14:05:00',5.95),('8975','2013-05-22','14:10:00',6.33),('8975','2013-05-22','14:15:00',5.94),('8975','2013-05-22','14:20:00',6),('8975','2013-05-22','14:25:00',5.03),('8975','2013-05-22','14:30:00',3.96),('8975','2013-05-22','14:35:00',7.06),('8975','2013-05-22','14:40:00',5.91),('8975','2013-05-22','14:45:00',4.75),('8975','2013-05-22','14:50:00',5.89),('8975','2013-05-22','14:55:00',3.64),('8975','2013-05-22','15:00:00',6.32),('8975','2013-05-22','15:05:00',4.73),('8975','2013-05-22','15:10:00',3.38),('8975','2013-05-22','15:15:00',3.27),('8975','2013-05-22','15:20:00',3.31),('8975','2013-05-22','15:25:00',1.7),('8975','2013-05-22','15:30:00',5.36),('8975','2013-05-22','15:35:00',3.48),('8975','2013-05-22','15:40:00',5.37),('8975','2013-05-22','15:45:00',1.84),('8975','2013-05-22','15:50:00',2.06),('8975','2013-05-22','15:55:00',2.2),('8975','2013-05-22','16:00:00',4.19),('8975','2013-05-22','16:05:00',2.66),('8975','2013-05-22','16:10:00',2.54),('8975','2013-05-22','16:15:00',3.13),('8975','2013-05-22','16:20:00',4.52),('8975','2013-05-22','16:25:00',4.27),('8975','2013-05-22','16:30:00',3.75),('8975','2013-05-22','16:35:00',2.21),('8975','2013-05-22','16:40:00',2.75),('8975','2013-05-22','16:45:00',1.38),('8975','2013-05-22','16:50:00',1.77),('8975','2013-05-22','16:55:00',1.93),('8975','2013-05-22','17:00:00',1.2),('8975','2013-05-22','17:05:00',2.75),('8975','2013-05-22','17:10:00',2.03),('8975','2013-05-22','17:15:00',2.5),('8975','2013-05-22','17:20:00',2.83),('8975','2013-05-22','17:25:00',1.44),('8975','2013-05-22','17:30:00',1.06),('8975','2013-05-22','17:35:00',2),('8975','2013-05-22','17:40:00',1.72),('8975','2013-05-22','17:45:00',1.78),('8975','2013-05-22','17:50:00',1.82),('8975','2013-05-22','17:55:00',1.8),('8975','2013-05-22','18:00:00',2.79),('8975','2013-05-22','18:05:00',2.89),('8975','2013-05-22','18:10:00',1.81),('8975','2013-05-22','18:45:00',1.38),('8975','2013-05-22','18:50:00',1.8),('8975','2013-05-22','18:55:00',1.46),('8975','2013-05-22','19:00:00',1.07),('8975','2013-05-21','07:20:00',1.03),('8975','2013-05-21','07:25:00',1.22),('8975','2013-05-21','07:30:00',1.09),('8975','2013-05-21','07:35:00',1.08),('8975','2013-05-21','07:40:00',1.26),('8975','2013-05-21','07:45:00',1.53),('8975','2013-05-21','07:50:00',2.66),('8975','2013-05-21','07:55:00',2.66),('8975','2013-05-21','08:00:00',3.19),('8975','2013-05-21','08:05:00',2.93),('8975','2013-05-21','08:10:00',3.18),('8975','2013-05-21','08:15:00',4.27),('8975','2013-05-21','08:20:00',4.21),('8975','2013-05-21','08:25:00',3.67),('8975','2013-05-21','08:30:00',4.47),('8975','2013-05-21','08:35:00',4.03),('8975','2013-05-21','08:40:00',2.66),('8975','2013-05-21','08:45:00',4.24),('8975','2013-05-21','08:50:00',2.07),('8975','2013-05-21','09:10:00',1.16),('8975','2013-05-21','09:15:00',1.5),('8975','2013-05-21','09:20:00',1.53),('8975','2013-05-21','09:25:00',3.09),('8975','2013-05-21','09:30:00',5.79),('8975','2013-05-21','09:35:00',5.69),('8975','2013-05-21','09:40:00',5.62),('8975','2013-05-21','09:45:00',5.66),('8975','2013-05-21','09:50:00',5.71),('8975','2013-05-21','09:55:00',5.78),('8975','2013-05-21','10:00:00',5.87),('8975','2013-05-21','10:05:00',5.98),('8975','2013-05-21','10:10:00',6.07),('8975','2013-05-21','10:15:00',6.12),('8975','2013-05-21','10:20:00',5.92),('8975','2013-05-21','10:25:00',6.35),('8975','2013-05-21','10:30:00',6.29),('8975','2013-05-21','10:35:00',6.37),('8975','2013-05-21','10:40:00',6.53),('8975','2013-05-21','10:45:00',6.55),('8975','2013-05-21','10:50:00',6.51),('8975','2013-05-21','10:55:00',6.58),('8975','2013-05-21','11:00:00',6.73),('8975','2013-05-21','11:05:00',6.86),('8975','2013-05-21','11:10:00',5.32),('8975','2013-05-21','11:15:00',7),('8975','2013-05-21','11:20:00',6.87),('8975','2013-05-21','11:25:00',6.63),('8975','2013-05-21','11:30:00',6.19),('8975','2013-05-21','11:35:00',5.59),('8975','2013-05-21','11:40:00',6.74),('8975','2013-05-21','11:45:00',6.66),('8975','2013-05-21','11:50:00',4.31),('8975','2013-05-21','11:55:00',4.64),('8975','2013-05-21','12:00:00',4.91),('8975','2013-05-21','12:05:00',3.7),('8975','2013-05-21','12:10:00',4.02),('8975','2013-05-21','12:15:00',6.28),('8975','2013-05-21','12:20:00',7.03),('8975','2013-05-21','12:25:00',4.64),('8975','2013-05-21','12:30:00',3.34),('8975','2013-05-21','12:35:00',4.06),('8975','2013-05-21','12:40:00',2.41),('8975','2013-05-21','12:45:00',1.06),('8975','2013-05-21','13:00:00',3.62),('8975','2013-05-21','13:05:00',5.17),('8975','2013-05-21','13:10:00',4.17),('8975','2013-05-21','13:15:00',4.66),('8975','2013-05-21','13:20:00',3.11),('8975','2013-05-21','13:25:00',2.07),('8975','2013-05-21','13:30:00',3.06),('8975','2013-05-21','13:35:00',6.84),('8975','2013-05-21','13:40:00',4.31),('8975','2013-05-21','13:45:00',3.38),('8975','2013-05-21','13:50:00',4.37),('8975','2013-05-21','13:55:00',3.19),('8975','2013-05-21','14:00:00',4.07),('8975','2013-05-21','14:05:00',5.9),('8975','2013-05-21','14:10:00',6.71),('8975','2013-05-21','14:15:00',6.4),('8975','2013-05-21','14:20:00',6.27),('8975','2013-05-21','14:25:00',6.14),('8975','2013-05-21','14:30:00',6.04),('8975','2013-05-21','14:35:00',5.96),('8975','2013-05-21','14:40:00',5.9),('8975','2013-05-21','14:45:00',5.8),('8975','2013-05-21','14:50:00',5.73),('8975','2013-05-21','14:55:00',5.62),('8975','2013-05-21','15:00:00',5.52),('8975','2013-05-21','15:05:00',5.41),('8975','2013-05-21','15:10:00',5.33),('8975','2013-05-21','15:15:00',5.27),('8975','2013-05-21','15:20:00',5.19),('8975','2013-05-21','15:25:00',4.98),('8975','2013-05-21','15:30:00',3.44),('8975','2013-05-21','15:35:00',5.32),('8975','2013-05-21','15:40:00',5.15),('8975','2013-05-21','15:45:00',4.17),('8975','2013-05-21','15:50:00',4.63),('8975','2013-05-21','15:55:00',4.49),('8975','2013-05-21','16:00:00',4.37),('8975','2013-05-21','16:05:00',4.24),('8975','2013-05-21','16:10:00',3.97),('8975','2013-05-21','16:15:00',4.04),('8975','2013-05-21','16:20:00',3.6),('8975','2013-05-21','16:25:00',2.94),('8975','2013-05-21','16:30:00',3.7),('8975','2013-05-21','16:35:00',3.58),('8975','2013-05-21','16:40:00',3.48),('8975','2013-05-21','16:45:00',2.92),('8975','2013-05-21','16:50:00',2.14),('8975','2013-05-21','16:55:00',1.27),('8975','2013-05-21','17:00:00',1.57),('8975','2013-05-21','17:05:00',1.58),('8975','2013-05-21','17:10:00',1.1),('8975','2013-05-21','17:15:00',1.56),('8975','2013-05-21','17:20:00',1.61),('8975','2013-05-21','17:25:00',1.83),('8975','2013-05-21','17:30:00',1.88),('8975','2013-05-21','17:35:00',2.35),('8975','2013-05-21','17:40:00',1.05),('8975','2013-05-21','17:50:00',1.48),('8975','2013-05-21','17:55:00',1.94),('8975','2013-05-21','18:00:00',1.83),('8975','2014-03-31','07:35:00',1.14),('8975','2014-03-31','07:40:00',1.32),('8975','2014-03-31','07:45:00',1.46),('8975','2014-03-31','07:50:00',1.82),('8975','2014-03-31','07:55:00',2.02),('8975','2014-03-31','08:00:00',2.18),('8975','2014-03-31','08:05:00',2.41),('8975','2014-03-31','08:10:00',2.58),('8975','2014-03-31','08:15:00',2.7),('8975','2014-03-31','08:20:00',2.83),('8975','2014-03-31','08:25:00',2.98),('8975','2014-03-31','08:30:00',3.11),('8975','2014-03-31','08:35:00',3.18),('8975','2014-03-31','08:40:00',3.31),('8975','2014-03-31','08:45:00',3.42),('8975','2014-03-31','08:50:00',3.52),('8975','2014-03-31','08:55:00',3.63),('8975','2014-03-31','09:00:00',3.73),('8975','2014-03-31','09:05:00',3.81),('8975','2014-03-31','09:10:00',3.94),('8975','2014-03-31','09:15:00',3.96),('8975','2014-03-31','09:20:00',4.08),('8975','2014-03-31','09:25:00',4.26),('8975','2014-03-31','09:30:00',4.39),('8975','2014-03-31','09:35:00',4.44),('8975','2014-03-31','09:40:00',4.57),('8975','2014-03-31','09:45:00',4.66),('8975','2014-03-31','09:50:00',4.75),('8975','2014-03-31','09:55:00',4.86),('8975','2014-03-31','10:00:00',3.9),('8975','2014-03-31','10:05:00',3.95),('8975','2014-03-31','10:10:00',5.08),('8975','2014-03-31','10:15:00',5.24),('8975','2014-03-31','10:20:00',5.47),('8975','2014-03-31','10:25:00',2.47),('8975','2014-03-31','10:30:00',2.16),('8975','2014-03-31','10:35:00',2.78),('8975','2014-03-31','10:40:00',5.91),('8975','2014-03-31','10:45:00',5.94),('8975','2014-03-31','10:50:00',5.84),('8975','2014-03-31','10:55:00',5.85),('8975','2014-03-31','11:00:00',5.77),('8975','2014-03-31','11:05:00',5.85),('8975','2014-03-31','11:10:00',5.88),('8975','2014-03-31','11:15:00',5.93),('8975','2014-03-31','11:20:00',5.92),('8975','2014-03-31','11:25:00',6.02),('8975','2014-03-31','11:30:00',6.08),('8975','2014-03-31','11:35:00',6.13),('8975','2014-03-31','11:40:00',6.11),('8975','2014-03-31','11:45:00',6.1),('8975','2014-03-31','11:50:00',6.13),('8975','2014-03-31','11:55:00',6.21),('8975','2014-03-31','12:00:00',6.23),('8975','2014-03-31','12:05:00',6.19),('8975','2014-03-31','12:10:00',6.25),('8975','2014-03-31','12:15:00',6.23),('8975','2014-03-31','12:20:00',6.3),('8975','2014-03-31','12:25:00',6.32),('8975','2014-03-31','12:30:00',6.36),('8975','2014-03-31','12:35:00',6.33),('8975','2014-03-31','12:40:00',6.36),('8975','2014-03-31','12:45:00',6.38),('8975','2014-03-31','12:50:00',6.3),('8975','2014-03-31','12:55:00',6.25),('8975','2014-03-31','13:00:00',6.42),('8975','2014-03-31','13:05:00',6.3),('8975','2014-03-31','13:10:00',6.21),('8975','2014-03-31','13:15:00',5.73),('8975','2014-03-31','13:20:00',6.09),('8975','2014-03-31','13:25:00',5.89),('8975','2014-03-31','13:30:00',5.07),('8975','2014-03-31','13:35:00',5.16),('8975','2014-03-31','13:40:00',5.35),('8975','2014-03-31','13:45:00',4.98),('8975','2014-03-31','13:50:00',5.83),('8975','2014-03-31','13:55:00',5.9),('8975','2014-03-31','14:00:00',4.94),('8975','2014-03-31','14:05:00',5.77),('8975','2014-03-31','14:10:00',5.21),('8975','2014-03-31','14:15:00',3.87),('8975','2014-03-31','14:20:00',5.61),('8975','2014-03-31','14:25:00',4.51),('8975','2014-03-31','14:30:00',4.22),('8975','2014-03-31','14:35:00',4.59),('8975','2014-03-31','14:40:00',4.77),('8975','2014-03-31','14:45:00',5.31),('8975','2014-03-31','14:50:00',5.21),('8975','2014-03-31','14:55:00',5.15),('8975','2014-03-31','15:00:00',4.3),('8975','2014-03-31','15:05:00',4.88),('8975','2014-03-31','15:10:00',2.78),('8975','2014-03-31','15:15:00',4.91),('8975','2014-03-31','15:20:00',4.65),('8975','2014-03-31','15:25:00',4.31),('8975','2014-03-31','15:30:00',4.41),('8975','2014-03-31','15:35:00',4.23),('8975','2014-03-31','15:40:00',4.05),('8975','2014-03-31','15:45:00',3.99),('8975','2014-03-31','15:50:00',3.91),('8975','2014-03-31','15:55:00',3.67),('8975','2014-03-31','16:00:00',2.81),('8975','2014-03-31','16:05:00',3.7),('8975','2014-03-31','16:10:00',3.32),('8975','2014-03-31','16:15:00',3.34),('8975','2014-03-31','16:20:00',3.2),('8975','2014-03-31','16:25:00',3),('8975','2014-03-31','16:30:00',2.7),('8975','2014-03-31','16:35:00',2.73),('8975','2014-03-31','16:40:00',2.28),('8975','2014-03-31','16:45:00',2.32),('8975','2014-03-31','16:50:00',1.4),('8975','2014-03-31','16:55:00',2.16),('8975','2014-03-31','17:00:00',1.89),('8975','2014-03-31','17:05:00',1.59),('8975','2014-03-31','17:10:00',1.87),('8975','2014-03-31','17:15:00',1.82),('8975','2014-03-31','17:20:00',1.63),('8975','2014-03-31','17:25:00',1.36),('8975','2014-03-31','17:30:00',1.19),('8975','2014-03-31','17:35:00',1.42),('8975','2014-03-31','17:40:00',1.27),('8975','2014-03-31','17:45:00',1.34),('8975','2014-03-31','17:50:00',1.36),('8975','2014-03-31','17:55:00',1.32),('8975','2014-03-31','18:00:00',1.29),('8975','2014-03-31','18:05:00',1.25),('8975','2014-03-31','18:10:00',1.09),('8975','2014-03-31','18:15:00',1.09),('8975','2013-05-20','06:30:00',1.01),('8975','2013-05-20','06:35:00',1.19),('8975','2013-05-20','06:40:00',1.37),('8975','2013-05-20','06:45:00',1.55),('8975','2013-05-20','06:50:00',1.71),('8975','2013-05-20','06:55:00',1.88),('8975','2013-05-20','07:00:00',1.99),('8975','2013-05-20','07:05:00',2.16),('8975','2013-05-20','07:10:00',2.35),('8975','2013-05-20','07:15:00',2.49),('8975','2013-05-20','07:20:00',2.65),('8975','2013-05-20','07:25:00',2.81),('8975','2013-05-20','07:30:00',3.09),('8975','2013-05-20','07:35:00',3.54),('8975','2013-05-20','07:40:00',3.77),('8975','2013-05-20','07:45:00',3.16),('8975','2013-05-20','07:50:00',2.32),('8975','2013-05-20','07:55:00',2.01),('8975','2013-05-20','08:00:00',2.96),('8975','2013-05-20','08:05:00',2.45),('8975','2013-05-20','08:10:00',2.59),('8975','2013-05-20','08:15:00',3.38),('8975','2013-05-20','08:20:00',3.63),('8975','2013-05-20','08:25:00',3.75),('8975','2013-05-20','08:30:00',2.47),('8975','2013-05-20','08:35:00',2.38),('8975','2013-05-20','08:40:00',2.82),('8975','2013-05-20','08:45:00',2.24),('8975','2013-05-20','08:50:00',2.62),('8975','2013-05-20','08:55:00',3.46),('8975','2013-05-20','09:00:00',2.84),('8975','2013-05-20','09:05:00',2.52),('8975','2013-05-20','09:10:00',2.72),('8975','2013-05-20','09:15:00',3.43),('8975','2013-05-20','09:20:00',5.1),('8975','2013-05-20','09:25:00',4),('8975','2013-05-20','09:30:00',3.48),('8975','2013-05-20','09:35:00',4.18),('8975','2013-05-20','09:40:00',3.26),('8975','2013-05-20','09:45:00',2.82),('8975','2013-05-20','09:50:00',2.78),('8975','2013-05-20','09:55:00',3.05),('8975','2013-05-20','10:00:00',3.47),('8975','2013-05-20','10:05:00',4.12),('8975','2013-05-20','10:10:00',3.89),('8975','2013-05-20','10:15:00',4.06),('8975','2013-05-20','10:20:00',3.49),('8975','2013-05-20','10:25:00',3.02),('8975','2013-05-20','10:30:00',2.99),('8975','2013-05-20','10:35:00',3.24),('8975','2013-05-20','10:40:00',4.55),('8975','2013-05-20','10:45:00',4.32),('8975','2013-05-20','10:50:00',3.09),('8975','2013-05-20','10:55:00',2.74),('8975','2013-05-20','11:00:00',3.39),('8975','2013-05-20','11:05:00',3.71),('8975','2013-05-20','11:10:00',5.89),('8975','2013-05-20','11:15:00',5.17),('8975','2013-05-20','11:20:00',5.83),('8975','2013-05-20','11:25:00',5.87),('8975','2013-05-20','11:30:00',4.52),('8975','2013-05-20','11:35:00',4.7),('8975','2013-05-20','11:40:00',5.23),('8975','2013-05-20','11:45:00',4.29),('8975','2013-05-20','11:50:00',5.1),('8975','2013-05-20','11:55:00',7.06),('8975','2013-05-20','12:00:00',7.34),('8975','2013-05-20','12:05:00',5.8),('8975','2013-05-20','12:10:00',4.79),('8975','2013-05-20','12:15:00',5.06),('8975','2013-05-20','12:20:00',3.81),('8975','2013-05-20','12:25:00',6.09),('8975','2013-05-20','12:30:00',4.58),('8975','2013-05-20','12:35:00',5.75),('8975','2013-05-20','12:40:00',7.4),('8975','2013-05-20','12:45:00',5.93),('8975','2013-05-20','12:50:00',3.3),('8975','2013-05-20','12:55:00',7.32),('8975','2013-05-20','13:00:00',6.96),('8975','2013-05-20','13:05:00',5.63),('8975','2013-05-20','13:10:00',6.04),('8975','2013-05-20','13:15:00',6.89),('8975','2013-05-20','13:20:00',4.24),('8975','2013-05-20','13:25:00',4.97),('8975','2013-05-20','13:30:00',4.37),('8975','2013-05-20','13:35:00',2.24),('8975','2013-05-20','13:40:00',1.35),('8975','2013-05-20','14:00:00',1.2),('8975','2013-05-20','14:05:00',1.88),('8975','2013-05-20','14:10:00',2.9),('8975','2013-05-20','14:15:00',3.11),('8975','2013-05-20','14:20:00',2.82),('8975','2013-05-20','14:25:00',4.45),('8975','2013-05-20','14:30:00',3.64),('8975','2013-05-20','14:35:00',3.45),('8975','2013-05-20','14:40:00',3.23),('8975','2013-05-20','14:45:00',2.44),('8975','2013-05-20','14:50:00',1.72),('8975','2013-05-20','14:55:00',1.21),('8975','2013-05-20','15:10:00',1.15),('8975','2013-05-20','15:15:00',1.87),('8975','2013-05-20','15:20:00',2.44),('8975','2013-05-20','15:25:00',2.55),('8975','2013-05-20','15:30:00',3.47),('8975','2013-05-20','15:35:00',2.85),('8975','2013-05-20','15:40:00',2.27),('8975','2013-05-20','15:45:00',2.17),('8975','2013-05-20','15:50:00',1.94),('8975','2013-05-20','15:55:00',1.96),('8975','2013-05-20','16:00:00',2.02),('8975','2013-05-20','16:05:00',1.97),('8975','2013-05-20','16:10:00',2.04),('8975','2013-05-20','16:15:00',1.87),('8975','2013-05-20','16:20:00',1.57),('8975','2013-05-20','16:25:00',2.28),('8975','2013-05-20','16:30:00',2.47),('8975','2013-05-20','16:35:00',2.61),('8975','2013-05-20','16:40:00',2.88),('8975','2013-05-20','16:45:00',2.41),('8975','2013-05-20','16:50:00',1.7),('8975','2013-05-20','17:00:00',1.02),('8975','2013-05-20','17:05:00',1.11),('8975','2013-05-19','06:25:00',1.07),('8975','2013-05-19','06:40:00',1.29),('8975','2013-05-19','06:45:00',1.89),('8975','2013-05-19','06:50:00',2.12),('8975','2013-05-19','06:55:00',2.28),('8975','2013-05-19','07:00:00',2.54),('8975','2013-05-19','07:05:00',2.4),('8975','2013-05-19','07:10:00',2.6),('8975','2013-05-19','07:15:00',2.79),('8975','2013-05-19','07:20:00',2.87),('8975','2013-05-19','07:25:00',2.75),('8975','2013-05-19','07:30:00',3.14),('8975','2013-05-19','07:35:00',3.29),('8975','2013-05-19','07:40:00',3.37),('8975','2013-05-19','07:45:00',3.45),('8975','2013-05-19','07:50:00',3.56),('8975','2013-05-19','07:55:00',3.69),('8975','2013-05-19','08:00:00',3.88),('8975','2013-05-19','08:05:00',3.79),('8975','2013-05-19','08:10:00',4.06),('8975','2013-05-19','08:15:00',2.06),('8975','2013-05-19','08:20:00',3.41),('8975','2013-05-19','08:25:00',3.61),('8975','2013-05-19','08:30:00',1.38),('8975','2013-05-19','08:35:00',3.68),('8975','2013-05-19','08:40:00',4.35),('8975','2013-05-19','08:45:00',5.65),('8975','2013-05-19','08:50:00',5.6),('8975','2013-05-19','08:55:00',5.48),('8975','2013-05-19','09:00:00',5.72),('8975','2013-05-19','09:05:00',6.15),('8975','2013-05-19','09:10:00',5.79),('8975','2013-05-19','09:15:00',2.24),('8975','2013-05-19','09:20:00',1.81),('8975','2013-05-19','09:25:00',3.13),('8975','2013-05-19','09:30:00',4.34),('8975','2013-05-19','09:35:00',1.97),('8975','2013-05-19','09:40:00',1),('8975','2013-05-19','09:45:00',4.6),('8975','2013-05-19','09:50:00',2.02),('8975','2013-05-19','09:55:00',4.58),('8975','2013-05-19','10:00:00',2.4),('8975','2013-05-19','10:05:00',3.79),('8975','2013-05-19','10:10:00',6.31),('8975','2013-05-19','10:15:00',2.11),('8975','2013-05-19','10:20:00',4.06),('8975','2013-05-19','10:25:00',1.45),('8975','2013-05-19','10:30:00',2.78),('8975','2013-05-19','10:35:00',5.56),('8975','2013-05-19','10:40:00',5.25),('8975','2013-05-19','10:45:00',4.48),('8975','2013-05-19','10:50:00',3.85),('8975','2013-05-19','10:55:00',6.97),('8975','2013-05-19','11:00:00',4.19),('8975','2013-05-19','11:05:00',7.66),('8975','2013-05-19','11:10:00',5.63),('8975','2013-05-19','11:15:00',5.99),('8975','2013-05-19','11:20:00',7.61),('8975','2013-05-19','11:25:00',1.56),('8975','2013-05-19','11:30:00',4.15),('8975','2013-05-19','11:35:00',2.89),('8975','2013-05-19','11:40:00',4.17),('8975','2013-05-19','11:45:00',1.88),('8975','2013-05-19','11:50:00',5.66),('8975','2013-05-19','11:55:00',5.21),('8975','2013-05-19','12:00:00',2.96),('8975','2013-05-19','12:05:00',8.65),('8975','2013-05-19','12:10:00',4.33),('8975','2013-05-19','12:15:00',4.74),('8975','2013-05-19','12:20:00',8.06),('8975','2013-05-19','12:25:00',3.3),('8975','2013-05-19','12:30:00',4.11),('8975','2013-05-19','12:35:00',6.74),('8975','2013-05-19','12:40:00',2.46),('8975','2013-05-19','12:45:00',7.05),('8975','2013-05-19','12:50:00',7.4),('8975','2013-05-19','12:55:00',4.59),('8975','2013-05-19','13:00:00',2.84),('8975','2013-05-19','13:05:00',2.48),('8975','2013-05-19','13:10:00',2.07),('8975','2013-05-19','13:15:00',2.41),('8975','2013-05-19','13:20:00',2.76),('8975','2013-05-19','13:25:00',7.54),('8975','2013-05-19','13:30:00',5.46),('8975','2013-05-19','13:35:00',6.27),('8975','2013-05-19','13:40:00',4.35),('8975','2013-05-19','13:45:00',6.67),('8975','2013-05-19','13:50:00',7.55),('8975','2013-05-19','13:55:00',5.8),('8975','2013-05-19','14:00:00',5.05),('8975','2013-05-19','14:05:00',2.12),('8975','2013-05-19','14:10:00',6.23),('8975','2013-05-19','14:15:00',3.89),('8975','2013-05-19','14:20:00',1.72),('8975','2013-05-19','14:25:00',4.06),('8975','2013-05-19','14:30:00',7.3),('8975','2013-05-19','14:35:00',1.95),('8975','2013-05-19','14:40:00',5.48),('8975','2013-05-19','14:45:00',2.77),('8975','2013-05-19','14:50:00',4.36),('8975','2013-05-19','14:55:00',6.13),('8975','2013-05-19','15:00:00',3.17),('8975','2013-05-19','15:05:00',6.76),('8975','2013-05-19','15:10:00',5.98),('8975','2013-05-19','15:15:00',5.16),('8975','2013-05-19','15:20:00',2.67),('8975','2013-05-19','15:25:00',1.72),('8975','2013-05-19','15:30:00',5.67),('8975','2013-05-19','15:35:00',3.46),('8975','2013-05-19','15:40:00',5.89),('8975','2013-05-19','15:45:00',5.79),('8975','2013-05-19','15:50:00',3.18),('8975','2013-05-19','15:55:00',4.58),('8975','2013-05-19','16:00:00',1.97),('8975','2013-05-19','16:05:00',2.33),('8975','2013-05-19','16:10:00',3.88),('8975','2013-05-19','16:15:00',2.47),('8975','2013-05-19','16:20:00',4.7),('8975','2013-05-19','16:25:00',4.57),('8975','2013-05-19','16:30:00',4.42),('8975','2013-05-19','16:35:00',4.26),('8975','2013-05-19','16:40:00',4.16),('8975','2013-05-19','16:45:00',3.69),('8975','2013-05-19','16:50:00',3.55),('8975','2013-05-19','16:55:00',3.25),('8975','2013-05-19','17:00:00',3.28),('8975','2013-05-19','17:05:00',3.13),('8975','2013-05-19','17:10:00',2.55),('8975','2013-05-19','17:15:00',1.64),('8975','2013-05-19','17:20:00',2.06),('8975','2013-05-19','17:25:00',2.68),('8975','2013-05-19','17:30:00',3.12),('8975','2013-05-19','17:35:00',2.45),('8975','2013-05-19','17:40:00',2.23),('8975','2013-05-19','17:45:00',2.1),('8975','2013-05-19','17:50:00',1.99),('8975','2013-05-19','17:55:00',1.88),('8975','2013-05-19','18:00:00',1.77),('8975','2013-05-19','18:05:00',2.11),('8975','2013-05-19','18:10:00',2.07),('8975','2013-05-19','18:15:00',1.98),('8975','2013-05-19','18:20:00',1.66),('8975','2013-05-19','18:25:00',1.49),('8975','2013-05-19','18:30:00',1.39),('8975','2013-05-19','18:35:00',1.32),('8975','2013-05-19','18:40:00',1.08),('8975','2013-05-19','18:45:00',1.21),('8975','2013-05-19','18:50:00',1.14),('8975','2013-05-19','18:55:00',1.07),('8975','2013-05-19','19:00:00',1.03),('8975','2013-05-18','08:00:00',1.03),('8975','2013-05-18','08:10:00',1.04),('8975','2013-05-18','08:15:00',1.09),('8975','2013-05-18','08:20:00',1.04),('8975','2013-05-18','08:25:00',1.13),('8975','2013-05-18','08:30:00',1.77),('8975','2013-05-18','08:35:00',2.09),('8975','2013-05-18','08:40:00',1.52),('8975','2013-05-18','08:45:00',1.79),('8975','2013-05-18','08:50:00',2.48),('8975','2013-05-18','08:55:00',2.29),('8975','2013-05-18','09:00:00',2.19),('8975','2013-05-18','09:05:00',2.05),('8975','2013-05-18','09:10:00',2.36),('8975','2013-05-18','09:15:00',2.69),('8975','2013-05-18','09:20:00',1.42),('8975','2013-05-18','09:30:00',1.25),('8975','2013-05-18','09:35:00',1.2),('8975','2013-05-18','09:40:00',1.61),('8975','2013-05-18','09:45:00',1.97),('8975','2013-05-18','09:50:00',1.96),('8975','2013-05-18','09:55:00',2.26),('8975','2013-05-18','10:00:00',3.09),('8975','2013-05-18','10:05:00',3.92),('8975','2013-05-18','10:10:00',4.9),('8975','2013-05-18','10:15:00',4.87),('8975','2013-05-18','10:20:00',5.05),('8975','2013-05-18','10:25:00',6.29),('8975','2013-05-18','10:30:00',7.7),('8975','2013-05-18','10:35:00',7.48),('8975','2013-05-18','10:40:00',7.54),('8975','2013-05-18','10:45:00',7.48),('8975','2013-05-18','10:50:00',7.35),('8975','2013-05-18','10:55:00',7.12),('8975','2013-05-18','11:00:00',7.12),('8975','2013-05-18','11:05:00',6.86),('8975','2013-05-18','11:10:00',6.83),('8975','2013-05-18','11:15:00',7.29),('8975','2013-05-18','11:20:00',7.17),('8975','2013-05-18','11:25:00',7.37),('8975','2013-05-18','11:30:00',7.41),('8975','2013-05-18','11:35:00',7.39),('8975','2013-05-18','11:40:00',7.53),('8975','2013-05-18','11:45:00',7.62),('8975','2013-05-18','11:50:00',7.57),('8975','2013-05-18','11:55:00',8.03),('8975','2013-05-18','12:00:00',7.81),('8975','2013-05-18','12:05:00',7.2),('8975','2013-05-18','12:10:00',5.81),('8975','2013-05-18','12:15:00',6.52),('8975','2013-05-18','12:20:00',4.58),('8975','2013-05-18','12:25:00',3.9),('8975','2013-05-18','12:30:00',4.11),('8975','2013-05-18','12:35:00',5.62),('8975','2013-05-18','12:40:00',6.86),('8975','2013-05-18','12:45:00',5.34),('8975','2013-05-18','12:50:00',4.36),('8975','2013-05-18','12:55:00',3.78),('8975','2013-05-18','13:00:00',5.04),('8975','2013-05-18','13:05:00',5.96),('8975','2013-05-18','13:10:00',5.3),('8975','2013-05-18','13:15:00',6.31),('8975','2013-05-18','13:20:00',5.91),('8975','2013-05-18','13:25:00',7.14),('8975','2013-05-18','13:30:00',7.03),('8975','2013-05-18','13:35:00',7),('8975','2013-05-18','13:40:00',6.93),('8975','2013-05-18','13:45:00',6.83),('8975','2013-05-18','13:50:00',6.82),('8975','2013-05-18','13:55:00',6.77),('8975','2013-05-18','14:00:00',6.7),('8975','2013-05-18','14:05:00',6.63),('8975','2013-05-18','14:10:00',6.62),('8975','2013-05-18','14:15:00',6.59),('8975','2013-05-18','14:20:00',6.53),('8975','2013-05-18','14:25:00',6.46),('8975','2013-05-18','14:30:00',6.4),('8975','2013-05-18','14:35:00',6.35),('8975','2013-05-18','14:40:00',6.27),('8975','2013-05-18','14:45:00',6.15),('8975','2013-05-18','14:50:00',6.09),('8975','2013-05-18','14:55:00',5.98),('8975','2013-05-18','15:00:00',5.93),('8975','2013-05-18','15:05:00',5.84),('8975','2013-05-18','15:10:00',5.69),('8975','2013-05-18','15:15:00',5.62),('8975','2013-05-18','15:20:00',5.56),('8975','2013-05-18','15:25:00',5.42),('8975','2013-05-18','15:30:00',5.31),('8975','2013-05-18','15:35:00',5.24),('8975','2013-05-18','15:40:00',5.14),('8975','2013-05-18','15:45:00',4.67),('8975','2013-05-18','15:50:00',4.43),('8975','2013-05-18','15:55:00',3.78),('8975','2013-05-18','16:00:00',3.61),('8975','2013-05-18','16:05:00',4.37),('8975','2013-05-18','16:10:00',4.12),('8975','2013-05-18','16:15:00',4.17),('8975','2013-05-18','16:20:00',4.15),('8975','2013-05-18','16:25:00',3.72),('8975','2013-05-18','16:30:00',3.96),('8975','2013-05-18','16:35:00',3.69),('8975','2013-05-18','16:40:00',3.51),('8975','2013-05-18','16:45:00',3.42),('8975','2013-05-18','16:50:00',3.16),('8975','2013-05-18','16:55:00',3.29),('8975','2013-05-18','17:00:00',3.2),('8975','2013-05-18','17:05:00',3.09),('8975','2013-05-18','17:10:00',2.95),('8975','2013-05-18','17:15:00',2.82),('8975','2013-05-18','17:20:00',2.71),('8975','2013-05-18','17:25:00',2.57),('8975','2013-05-18','17:30:00',2.45),('8975','2013-05-18','17:35:00',2.34),('8975','2013-05-18','17:40:00',2.22),('8975','2013-05-18','17:45:00',2.1),('8975','2013-05-18','17:50:00',1.99),('8975','2013-05-18','17:55:00',1.89),('8975','2013-05-18','18:00:00',1.81),('8975','2013-05-18','18:05:00',1.72),('8975','2013-05-18','18:10:00',1.65),('8975','2013-05-18','18:15:00',1.58),('8975','2013-05-18','18:20:00',1.51),('8975','2013-05-18','18:25:00',1.48),('8975','2013-05-18','18:30:00',1.43),('8975','2013-05-18','18:35:00',1.39),('8975','2013-05-18','18:40:00',1.34),('8975','2013-05-18','18:45:00',1.29),('8975','2013-05-18','18:50:00',1.23),('8975','2013-05-18','18:55:00',1.18),('8975','2013-05-18','19:00:00',1.13),('8975','2013-05-18','19:05:00',1.06),('8975','2013-05-18','19:10:00',1.01),('8975','2013-05-17','06:25:00',1.04),('8975','2013-05-17','06:30:00',1.23),('8975','2013-05-17','06:35:00',1.4),('8975','2013-05-17','06:40:00',1.62),('8975','2013-05-17','06:45:00',1.79),('8975','2013-05-17','06:50:00',1.94),('8975','2013-05-17','06:55:00',2.11),('8975','2013-05-17','07:00:00',2.26),('8975','2013-05-17','07:05:00',2.39),('8975','2013-05-17','07:10:00',2.54),('8975','2013-05-17','07:15:00',2.68),('8975','2013-05-17','07:20:00',2.81),('8975','2013-05-17','07:25:00',2.94),('8975','2013-05-17','07:30:00',3.08),('8975','2013-05-17','07:35:00',3.19),('8975','2013-05-17','07:40:00',3.46),('8975','2013-05-17','07:45:00',2.41),('8975','2013-05-17','07:50:00',3.96),('8975','2013-05-17','07:55:00',4.5),('8975','2013-05-17','08:00:00',4.51),('8975','2013-05-17','08:05:00',3.66),('8975','2013-05-17','08:10:00',1.84),('8975','2013-05-17','08:15:00',1.8),('8975','2013-05-17','08:20:00',3.12),('8975','2013-05-17','08:25:00',4.64),('8975','2013-05-17','08:30:00',3.98),('8975','2013-05-17','08:35:00',4.25),('8975','2013-05-17','08:40:00',4.9),('8975','2013-05-17','08:45:00',4.81),('8975','2013-05-17','08:50:00',4.91),('8975','2013-05-17','08:55:00',5.01),('8975','2013-05-17','09:00:00',5.1),('8975','2013-05-17','09:05:00',5.19),('8975','2013-05-17','09:10:00',5.38),('8975','2013-05-17','09:15:00',5.42),('8975','2013-05-17','09:20:00',5.49),('8975','2013-05-17','09:25:00',5.56),('8975','2013-05-17','09:30:00',5.62),('8975','2013-05-17','09:35:00',5.69),('8975','2013-05-17','09:40:00',5.76),('8975','2013-05-17','09:45:00',5.83),('8975','2013-05-17','09:50:00',5.9),('8975','2013-05-17','09:55:00',5.99),('8975','2013-05-17','10:00:00',6.03),('8975','2013-05-17','10:05:00',6.08),('8975','2013-05-17','10:10:00',6.19),('8975','2013-05-17','10:15:00',6.22),('8975','2013-05-17','10:20:00',6.31),('8975','2013-05-17','10:25:00',6.35),('8975','2013-05-17','10:30:00',6.37),('8975','2013-05-17','10:35:00',6.36),('8975','2013-05-17','10:40:00',6.43),('8975','2013-05-17','10:45:00',6.48),('8975','2013-05-17','10:50:00',6.54),('8975','2013-05-17','10:55:00',6.72),('8975','2013-05-17','11:00:00',7.09),('8975','2013-05-17','11:05:00',5.21),('8975','2013-05-17','11:10:00',6.01),('8975','2013-05-17','11:15:00',5.86),('8975','2013-05-17','11:20:00',7.1),('8975','2013-05-17','11:25:00',7.06),('8975','2013-05-17','11:30:00',6.57),('8975','2013-05-17','11:35:00',7.03),('8975','2013-05-17','11:40:00',6.87),('8975','2013-05-17','11:45:00',6.4),('8975','2013-05-17','11:50:00',6.99),('8975','2013-05-17','11:55:00',6.52),('8975','2013-05-17','12:00:00',6.51),('8975','2013-05-17','12:05:00',6.78),('8975','2013-05-17','12:10:00',6.65),('8975','2013-05-17','12:15:00',6.72),('8975','2013-05-17','12:20:00',6.78),('8975','2013-05-17','12:25:00',6.58),('8975','2013-05-17','12:30:00',5.09),('8975','2013-05-17','12:35:00',6.84),('8975','2013-05-17','12:40:00',6.59),('8975','2013-05-17','12:45:00',6.15),('8975','2013-05-17','12:50:00',6.68),('8975','2013-05-17','12:55:00',6.63),('8975','2013-05-17','13:00:00',6.6),('8975','2013-05-17','13:05:00',6.62),('8975','2013-05-17','13:10:00',6.57),('8975','2013-05-17','13:15:00',6.51),('8975','2013-05-17','13:20:00',6.49),('8975','2013-05-17','13:25:00',6.49),('8975','2013-05-17','13:30:00',6.51),('8975','2013-05-17','13:35:00',6.68),('8975','2013-05-17','13:40:00',6.78),('8975','2013-05-17','13:45:00',6.76),('8975','2013-05-17','13:50:00',4.75),('8975','2013-05-17','13:55:00',4.68),('8975','2013-05-17','14:00:00',6.16),('8975','2013-05-17','14:05:00',6.45),('8975','2013-05-17','14:10:00',6.45),('8975','2013-05-17','14:15:00',6.32),('8975','2013-05-17','14:20:00',6.12),('8975','2013-05-17','14:25:00',5.92),('8975','2013-05-17','14:30:00',5.64),('8975','2013-05-17','14:35:00',5.42),('8975','2013-05-17','14:40:00',6.18),('8975','2013-05-17','14:45:00',3.83),('8975','2013-05-17','14:50:00',5.78),('8975','2013-05-17','14:55:00',5.37),('8975','2013-05-17','15:00:00',5.34),('8975','2013-05-17','15:05:00',5.22),('8975','2013-05-17','15:10:00',5.09),('8975','2013-05-17','15:15:00',4.99),('8975','2013-05-17','15:20:00',4.87),('8975','2013-05-17','15:25:00',4.77),('8975','2013-05-17','15:30:00',4.69),('8975','2013-05-17','15:35:00',4.59),('8975','2013-05-17','15:40:00',4.47),('8975','2013-05-17','15:45:00',4.36),('8975','2013-05-17','15:50:00',4.26),('8975','2013-05-17','15:55:00',4.15),('8975','2013-05-17','16:00:00',4.06),('8975','2013-05-17','16:05:00',3.94),('8975','2013-05-17','16:10:00',3.84),('8975','2013-05-17','16:15:00',3.77),('8975','2013-05-17','16:20:00',3.67),('8975','2013-05-17','16:25:00',3.55),('8975','2013-05-17','16:30:00',3.45),('8975','2013-05-17','16:35:00',3.34),('8975','2013-05-17','16:40:00',3.22),('8975','2013-05-17','16:45:00',3.1),('8975','2013-05-17','16:50:00',2.98),('8975','2013-05-17','16:55:00',2.88),('8975','2013-05-17','17:00:00',2.77),('8975','2013-05-17','17:05:00',2.68),('8975','2013-05-17','17:10:00',2.57),('8975','2013-05-17','17:15:00',2.46),('8975','2013-05-17','17:20:00',2.36),('8975','2013-05-17','17:25:00',2.25),('8975','2013-05-17','17:30:00',2.15),('8975','2013-05-17','17:35:00',2.07),('8975','2013-05-17','17:40:00',1.98),('8975','2013-05-17','17:45:00',1.9),('8975','2013-05-17','17:50:00',1.82),('8975','2013-05-17','17:55:00',1.73),('8975','2013-05-17','18:00:00',1.65),('8975','2013-05-17','18:05:00',1.57),('8975','2013-05-17','18:10:00',1.5),('8975','2013-05-17','18:15:00',1.43),('8975','2013-05-17','18:20:00',1.36),('8975','2013-05-17','18:25:00',1.3),('8975','2013-05-17','18:30:00',1.24),('8975','2013-05-17','18:35:00',1.16),('8975','2013-05-17','18:40:00',1.1),('8975','2013-05-17','18:45:00',1.02),('8975','2013-05-15','09:15:00',1.5),('8975','2013-05-15','09:20:00',2.09),('8975','2013-05-15','09:25:00',2.72),('8975','2013-05-15','09:30:00',2.93),('8975','2013-05-15','09:35:00',3.72),('8975','2013-05-15','09:40:00',4.04),('8975','2013-05-15','09:45:00',4.51),('8975','2013-05-15','09:50:00',2.19),('8975','2013-05-15','09:55:00',3.02),('8975','2013-05-15','10:00:00',2.89),('8975','2013-05-15','10:05:00',2.96),('8975','2013-05-15','10:10:00',2.37),('8975','2013-05-15','10:15:00',2.99),('8975','2013-05-15','10:20:00',4.91),('8975','2013-05-15','10:25:00',4.02),('8975','2013-05-15','10:30:00',3.6),('8975','2013-05-15','10:35:00',2.41),('8975','2013-05-15','10:40:00',1.87),('8975','2013-05-15','10:45:00',1.91),('8975','2013-05-15','10:50:00',2.38),('8975','2013-05-15','10:55:00',3.85),('8975','2013-05-15','11:00:00',7.37),('8975','2013-05-15','11:05:00',4.65),('8975','2013-05-15','11:10:00',5.77),('8975','2013-05-15','11:15:00',2.62),('8975','2013-05-15','11:20:00',1.77),('8975','2013-05-15','11:25:00',1.91),('8975','2013-05-15','11:30:00',2.57),('8975','2013-05-15','11:35:00',3.28),('8975','2013-05-15','11:40:00',4.45),('8975','2013-05-15','11:45:00',3.03),('8975','2013-05-15','11:50:00',2.88),('8975','2013-05-15','11:55:00',2.85),('8975','2013-05-15','12:00:00',2.89),('8975','2013-05-15','12:05:00',3.2),('8975','2013-05-15','12:10:00',3.75),('8975','2013-05-15','12:15:00',3.81),('8975','2013-05-15','12:20:00',3.38),('8975','2013-05-15','12:25:00',3.89),('8975','2013-05-15','12:30:00',6.12),('8975','2013-05-15','12:35:00',4.68),('8975','2013-05-15','12:40:00',5.21),('8975','2013-05-15','12:45:00',4.32),('8975','2013-05-15','12:50:00',4.89),('8975','2013-05-15','12:55:00',6.84),('8975','2013-05-15','13:00:00',5.31),('8975','2013-05-15','13:05:00',6.42),('8975','2013-05-15','13:10:00',6.53),('8975','2013-05-15','13:15:00',6.49),('8975','2013-05-15','13:20:00',6.48),('8975','2013-05-15','13:25:00',6.33),('8975','2013-05-15','13:30:00',6.27),('8975','2013-05-15','13:35:00',6.23),('8975','2013-05-15','13:40:00',6.15),('8975','2013-05-15','13:45:00',6.04),('8975','2013-05-15','13:50:00',6.04),('8975','2013-05-15','13:55:00',5.98),('8975','2013-05-15','14:00:00',5.96),('8975','2013-05-15','14:05:00',5.95),('8975','2013-05-15','14:10:00',5.87),('8975','2013-05-15','14:15:00',5.8),('8975','2013-05-15','14:20:00',5.73),('8975','2013-05-15','14:25:00',5.61),('8975','2013-05-15','14:30:00',5.53),('8975','2013-05-15','14:35:00',5.44),('8975','2013-05-15','14:40:00',5.39),('8975','2013-05-15','14:45:00',5.3),('8975','2013-05-15','14:50:00',4.97),('8975','2013-05-15','14:55:00',4.65),('8975','2013-05-15','15:00:00',5.13),('8975','2013-05-15','15:05:00',5.11),('8975','2013-05-15','15:10:00',5.09),('8975','2013-05-15','15:15:00',4.57),('8975','2013-05-15','15:20:00',4.87),('8975','2013-05-15','15:25:00',4.71),('8975','2013-05-15','15:30:00',4.59),('8975','2013-05-15','15:35:00',4.46),('8975','2013-05-15','15:40:00',4.55),('8975','2013-05-15','15:45:00',4.36),('8975','2013-05-15','15:50:00',4.33),('8975','2013-05-15','15:55:00',4.25),('8975','2013-05-15','16:00:00',4.17),('8975','2013-05-15','16:05:00',3.92),('8975','2013-05-15','16:10:00',4.02),('8975','2013-05-15','16:15:00',3.62),('8975','2013-05-15','16:20:00',3.9),('8975','2013-05-15','16:25:00',3.82),('8975','2013-05-15','16:30:00',3.76),('8975','2013-05-15','16:35:00',3.39),('8975','2013-05-15','16:40:00',2.63),('8975','2013-05-15','16:45:00',2.63),('8975','2013-05-15','16:50:00',2.93),('8975','2013-05-15','16:55:00',2.46),('8975','2013-05-15','17:00:00',1.78),('8975','2013-05-15','17:05:00',1.22),('8975','2013-05-15','17:10:00',1.4),('8975','2013-05-15','17:15:00',1.8),('8975','2013-05-15','17:20:00',2.43),('8975','2013-05-15','17:25:00',2.67),('8975','2013-05-15','17:30:00',2.88),('8975','2013-05-15','17:35:00',2.59),('8975','2013-05-15','17:40:00',2.14),('8975','2013-05-15','17:45:00',1.58),('8975','2013-05-15','18:30:00',1.1),('8975','2013-05-15','18:35:00',1.2),('8975','2013-05-15','18:40:00',1.18),('8975','2013-05-15','18:45:00',1.37),('8975','2013-05-15','18:50:00',1.5),('8975','2013-05-15','18:55:00',1.5),('8975','2013-05-15','19:00:00',1.59),('8975','2013-05-15','19:05:00',1.48),('8975','2013-05-15','19:10:00',1.25),('8975','2013-05-15','19:15:00',1.06),('8975','2013-05-14','06:50:00',1.2),('8975','2013-05-14','06:55:00',2.04),('8975','2013-05-14','07:00:00',1.91),('8975','2013-05-14','07:05:00',1.87),('8975','2013-05-14','07:10:00',2.6),('8975','2013-05-14','07:15:00',2.75),('8975','2013-05-14','07:20:00',2.88),('8975','2013-05-14','07:25:00',3.06),('8975','2013-05-14','07:30:00',3.22),('8975','2013-05-14','07:35:00',3.36),('8975','2013-05-14','07:40:00',3.49),('8975','2013-05-14','07:45:00',3.7),('8975','2013-05-14','07:50:00',3.64),('8975','2013-05-14','07:55:00',3.31),('8975','2013-05-14','08:00:00',3.34),('8975','2013-05-14','08:05:00',3.44),('8975','2013-05-14','08:10:00',3.87),('8975','2013-05-14','08:15:00',4.04),('8975','2013-05-14','08:20:00',4.03),('8975','2013-05-14','08:25:00',4.13),('8975','2013-05-14','08:30:00',4.23),('8975','2013-05-14','08:35:00',4.37),('8975','2013-05-14','08:40:00',4.47),('8975','2013-05-14','08:45:00',4.64),('8975','2013-05-14','08:50:00',4.79),('8975','2013-05-14','08:55:00',4.82),('8975','2013-05-14','09:00:00',4.66),('8975','2013-05-14','09:05:00',5),('8975','2013-05-14','09:10:00',4.91),('8975','2013-05-14','09:15:00',4.97),('8975','2013-05-14','09:20:00',4.95),('8975','2013-05-14','09:25:00',4.04),('8975','2013-05-14','09:30:00',5.35),('8975','2013-05-14','09:35:00',5.41),('8975','2013-05-14','09:40:00',5.33),('8975','2013-05-14','09:45:00',5.5),('8975','2013-05-14','09:50:00',5.6),('8975','2013-05-14','09:55:00',5.64),('8975','2013-05-14','10:00:00',5.77),('8975','2013-05-14','10:05:00',5.89),('8975','2013-05-14','10:10:00',5.98),('8975','2013-05-14','10:15:00',5.76),('8975','2013-05-14','10:20:00',5.84),('8975','2013-05-14','10:25:00',6.04),('8975','2013-05-14','10:30:00',5.97),('8975','2013-05-14','10:35:00',6.13),('8975','2013-05-14','10:40:00',6.28),('8975','2013-05-14','10:45:00',6.33),('8975','2013-05-14','10:50:00',6.23),('8975','2013-05-14','10:55:00',6.05),('8975','2013-05-14','11:00:00',5.98),('8975','2013-05-14','11:05:00',6.38),('8975','2013-05-14','11:10:00',6.43),('8975','2013-05-14','11:15:00',6.54),('8975','2013-05-14','11:20:00',6.17),('8975','2013-05-14','11:25:00',6.55),('8975','2013-05-14','11:30:00',6.45),('8975','2013-05-14','11:35:00',5.68),('8975','2013-05-14','11:40:00',5.1),('8975','2013-05-14','11:45:00',4.46),('8975','2013-05-14','11:50:00',3.99),('8975','2013-05-14','11:55:00',3.28),('8975','2013-05-14','12:00:00',3.84),('8975','2013-05-14','12:05:00',6.87),('8975','2013-05-14','12:10:00',7.9),('8975','2013-05-14','12:15:00',5.83),('8975','2013-05-14','12:20:00',3.42),('8975','2013-05-14','12:25:00',5.84),('8975','2013-05-14','12:30:00',6.6),('8975','2013-05-14','12:35:00',5.78),('8975','2013-05-14','12:40:00',7.19),('8975','2013-05-14','12:45:00',4.13),('8975','2013-05-14','12:50:00',4.32),('8975','2013-05-14','12:55:00',5.5),('8975','2013-05-14','13:00:00',4.77),('8975','2013-05-14','13:05:00',5.54),('8975','2013-05-14','13:10:00',3.99),('8975','2013-05-14','13:15:00',4.08),('8975','2013-05-14','13:20:00',4.41),('8975','2013-05-14','13:25:00',5.02),('8975','2013-05-14','13:30:00',4.78),('8975','2013-05-14','13:35:00',4.22),('8975','2013-05-14','13:40:00',4.83),('8975','2013-05-14','13:45:00',4.11),('8975','2013-05-14','13:50:00',3.64),('8975','2013-05-14','13:55:00',3.26),('8975','2013-05-14','14:00:00',2.88),('8975','2013-05-14','14:05:00',2.6),('8975','2013-05-14','14:10:00',2.73),('8975','2013-05-14','14:15:00',2.76),('8975','2013-05-14','14:20:00',2.87),('8975','2013-05-14','14:25:00',2.7),('8975','2013-05-14','14:30:00',2.48),('8975','2013-05-14','14:35:00',2.49),('8975','2013-05-14','14:40:00',2.57),('8975','2013-05-14','14:45:00',2.5),('8975','2013-05-14','14:50:00',2.51),('8975','2013-05-14','14:55:00',2.53),('8975','2013-05-14','15:00:00',2.39),('8975','2013-05-14','15:05:00',1.86),('8975','2013-05-14','15:10:00',1.48),('8975','2013-05-14','15:15:00',1.43),('8975','2013-05-14','15:20:00',1.33),('8975','2013-05-14','15:25:00',1.19),('8975','2013-05-14','15:30:00',1.25),('8975','2013-05-14','15:35:00',1.25),('8975','2013-05-14','15:40:00',1.47),('8975','2013-05-14','15:45:00',2),('8975','2013-05-14','15:50:00',2.9),('8975','2013-05-14','15:55:00',3.32),('8975','2013-05-14','16:00:00',3.08),('8975','2013-05-14','16:05:00',2.89),('8975','2013-05-14','16:10:00',2.46),('8975','2013-05-14','16:15:00',2.19),('8975','2013-05-14','16:20:00',2.41),('8975','2013-05-14','16:25:00',2.4),('8975','2013-05-14','16:30:00',2.14),('8975','2013-05-14','16:35:00',2.03),('8975','2013-05-14','16:40:00',1.92),('8975','2013-05-14','16:45:00',1.9),('8975','2013-05-14','16:50:00',1.97),('8975','2013-05-14','16:55:00',2.25),('8975','2013-05-14','17:00:00',2.55),('8975','2013-05-14','17:05:00',3.04),('8975','2013-05-14','17:10:00',2.65),('8975','2013-05-14','17:15:00',2.74),('8975','2013-05-14','17:20:00',2.59),('8975','2013-05-14','17:25:00',2.04),('8975','2013-05-14','17:30:00',1.48),('8975','2013-05-14','17:35:00',1.33),('8975','2013-05-14','17:40:00',1.26),('8975','2013-05-14','17:45:00',1.32),('8975','2013-05-14','17:50:00',1.35),('8975','2013-05-14','17:55:00',1.31),('8975','2013-05-14','18:00:00',1.21),('8975','2013-05-13','06:25:00',1.15),('8975','2013-05-13','06:30:00',1.59),('8975','2013-05-13','06:35:00',1.74),('8975','2013-05-13','06:40:00',1.9),('8975','2013-05-13','06:45:00',2.05),('8975','2013-05-13','06:50:00',2.2),('8975','2013-05-13','06:55:00',2.33),('8975','2013-05-13','07:00:00',2.46),('8975','2013-05-13','07:05:00',2.61),('8975','2013-05-13','07:10:00',2.8),('8975','2013-05-13','07:15:00',2.93),('8975','2013-05-13','07:20:00',3.06),('8975','2013-05-13','07:25:00',3.18),('8975','2013-05-13','07:30:00',3.29),('8975','2013-05-13','07:35:00',3.41),('8975','2013-05-13','07:40:00',3.54),('8975','2013-05-13','07:45:00',3.67),('8975','2013-05-13','07:50:00',3.78),('8975','2013-05-13','07:55:00',3.88),('8975','2013-05-13','08:00:00',3.96),('8975','2013-05-13','08:05:00',4.06),('8975','2013-05-13','08:10:00',4.17),('8975','2013-05-13','08:15:00',4.26),('8975','2013-05-13','08:20:00',4.38),('8975','2013-05-13','08:25:00',4.43),('8975','2013-05-13','08:30:00',4.56),('8975','2013-05-13','08:35:00',4.68),('8975','2013-05-13','08:40:00',4.77),('8975','2013-05-13','08:45:00',4.88),('8975','2013-05-13','08:50:00',4.98),('8975','2013-05-13','08:55:00',5.06),('8975','2013-05-13','09:00:00',5.16),('8975','2013-05-13','09:05:00',5.24),('8975','2013-05-13','09:10:00',5.34),('8975','2013-05-13','09:15:00',5.4),('8975','2013-05-13','09:20:00',5.49),('8975','2013-05-13','09:25:00',5.52),('8975','2013-05-13','09:30:00',5.64),('8975','2013-05-13','09:35:00',5.74),('8975','2013-05-13','09:40:00',5.8),('8975','2013-05-13','09:45:00',5.88),('8975','2013-05-13','09:50:00',5.96),('8975','2013-05-13','09:55:00',6.05),('8975','2013-05-13','10:00:00',6.1),('8975','2013-05-13','10:05:00',6.21),('8975','2013-05-13','10:10:00',6.31),('8975','2013-05-13','10:15:00',6.35),('8975','2013-05-13','10:20:00',6.4),('8975','2013-05-13','10:25:00',6.43),('8975','2013-05-13','10:30:00',6.43),('8975','2013-05-13','10:35:00',6.51),('8975','2013-05-13','10:40:00',6.54),('8975','2013-05-13','10:45:00',6.6),('8975','2013-05-13','10:50:00',6.61),('8975','2013-05-13','10:55:00',6.69),('8975','2013-05-13','11:00:00',6.72),('8975','2013-05-13','11:05:00',6.72),('8975','2013-05-13','11:10:00',6.73),('8975','2013-05-13','11:15:00',6.77),('8975','2013-05-13','11:20:00',6.81),('8975','2013-05-13','11:25:00',6.89),('8975','2013-05-13','11:30:00',6.94),('8975','2013-05-13','11:35:00',6.96),('8975','2013-05-13','11:40:00',6.93),('8975','2013-05-13','11:45:00',6.94),('8975','2013-05-13','11:50:00',6.98),('8975','2013-05-13','11:55:00',7),('8975','2013-05-13','12:00:00',7.02),('8975','2013-05-13','12:05:00',6.97),('8975','2013-05-13','12:10:00',7),('8975','2013-05-13','12:15:00',6.98),('8975','2013-05-13','12:20:00',6.95),('8975','2013-05-13','12:25:00',6.92),('8975','2013-05-13','12:30:00',6.87),('8975','2013-05-13','12:35:00',6.83),('8975','2013-05-13','12:40:00',6.85),('8975','2013-05-13','12:45:00',6.82),('8975','2013-05-13','12:50:00',6.86),('8975','2013-05-13','12:55:00',6.83),('8975','2013-05-13','13:00:00',6.77),('8975','2013-05-13','13:05:00',6.83),('8975','2013-05-13','13:10:00',6.82),('8975','2013-05-13','13:15:00',6.71),('8975','2013-05-13','13:20:00',6.64),('8975','2013-05-13','13:25:00',6.67),('8975','2013-05-13','13:30:00',6.71),('8975','2013-05-13','13:35:00',6.6),('8975','2013-05-13','13:40:00',6.53),('8975','2013-05-13','13:45:00',6.48),('8975','2013-05-13','13:50:00',6.4),('8975','2013-05-13','13:55:00',6.38),('8975','2013-05-13','14:00:00',6.3),('8975','2013-05-13','14:05:00',6.27),('8975','2013-05-13','14:10:00',6.17),('8975','2013-05-13','14:15:00',6.09),('8975','2013-05-13','14:20:00',6.04),('8975','2013-05-13','14:25:00',5.96),('8975','2013-05-13','14:30:00',5.84),('8975','2013-05-13','14:35:00',5.79),('8975','2013-05-13','14:40:00',5.84),('8975','2013-05-13','14:45:00',5.82),('8975','2013-05-13','14:50:00',5.77),('8975','2013-05-13','14:55:00',5.71),('8975','2013-05-13','15:00:00',5.63),('8975','2013-05-13','15:05:00',5.52),('8975','2013-05-13','15:10:00',5.37),('8975','2013-05-13','15:15:00',5.28),('8975','2013-05-13','15:20:00',5.22),('8975','2013-05-13','15:25:00',5.16),('8975','2013-05-13','15:30:00',5.07),('8975','2013-05-13','15:35:00',4.97),('8975','2013-05-13','15:40:00',4.84),('8975','2013-05-13','15:45:00',4.35),('8975','2013-05-13','15:50:00',4.05),('8975','2013-05-13','15:55:00',3.91),('8975','2013-05-13','16:00:00',3.98),('8975','2013-05-13','16:05:00',4.14),('8975','2013-05-13','16:10:00',3.84),('8975','2013-05-13','16:15:00',3.98),('8975','2013-05-13','16:20:00',3.38),('8975','2013-05-13','16:25:00',3.48),('8975','2013-05-13','16:30:00',3.06),('8975','2013-05-13','16:35:00',3.49),('8975','2013-05-13','16:40:00',3.28),('8975','2013-05-13','16:45:00',3.17),('8975','2013-05-13','16:50:00',3.09),('8975','2013-05-13','16:55:00',3.07),('8975','2013-05-13','17:00:00',2.95),('8975','2013-05-13','17:05:00',2.82),('8975','2013-05-13','17:10:00',2.69),('8975','2013-05-13','17:15:00',2.57),('8975','2013-05-13','17:20:00',2.46),('8975','2013-05-13','17:25:00',2.35),('8975','2013-05-13','17:30:00',2.23),('8975','2013-05-13','17:35:00',2.11),('8975','2013-05-13','17:40:00',2.01),('8975','2013-05-13','17:45:00',1.91),('8975','2013-05-13','17:50:00',1.82),('8975','2013-05-13','17:55:00',1.73),('8975','2013-05-13','18:00:00',1.65),('8975','2013-05-13','18:05:00',1.58),('8975','2013-05-13','18:10:00',1.5),('8975','2013-05-13','18:15:00',1.45),('8975','2013-05-13','18:20:00',1.4),('8975','2013-05-13','18:25:00',1.36),('8975','2013-05-13','18:30:00',1.31),('8975','2013-05-13','18:35:00',1.26),('8975','2013-05-13','18:40:00',1.22),('8975','2013-05-13','18:45:00',1.13),('8975','2013-05-13','18:50:00',1.07),('8975','2013-05-13','18:55:00',1.02),('8975','2013-05-12','06:40:00',1.19),('8975','2013-05-12','06:45:00',1.4),('8975','2013-05-12','06:50:00',1.57),('8975','2013-05-12','06:55:00',1.73),('8975','2013-05-12','07:00:00',1.99),('8975','2013-05-12','07:05:00',2.09),('8975','2013-05-12','07:10:00',2.26),('8975','2013-05-12','07:15:00',2.16),('8975','2013-05-12','07:20:00',1.81),('8975','2013-05-12','07:25:00',1.74),('8975','2013-05-12','07:30:00',2.49),('8975','2013-05-12','07:35:00',2.91),('8975','2013-05-12','07:40:00',3.05),('8975','2013-05-12','07:45:00',3.08),('8975','2013-05-12','07:50:00',3.29),('8975','2013-05-12','07:55:00',3.11),('8975','2013-05-12','08:00:00',3.53),('8975','2013-05-12','08:05:00',3.6),('8975','2013-05-12','08:10:00',3.79),('8975','2013-05-12','08:15:00',3.95),('8975','2013-05-12','08:20:00',4.05),('8975','2013-05-12','08:25:00',4.16),('8975','2013-05-12','08:30:00',4.25),('8975','2013-05-12','08:35:00',4.33),('8975','2013-05-12','08:40:00',4.46),('8975','2013-05-12','08:45:00',4.61),('8975','2013-05-12','08:50:00',4.72),('8975','2013-05-12','08:55:00',4.81),('8975','2013-05-12','09:00:00',4.95),('8975','2013-05-12','09:05:00',5),('8975','2013-05-12','09:10:00',5.07),('8975','2013-05-12','09:15:00',5.13),('8975','2013-05-12','09:20:00',5.22),('8975','2013-05-12','09:25:00',5.37),('8975','2013-05-12','09:30:00',5.37),('8975','2013-05-12','09:35:00',5.56),('8975','2013-05-12','09:40:00',5.58),('8975','2013-05-12','09:45:00',5.7),('8975','2013-05-12','09:50:00',5.85),('8975','2013-05-12','09:55:00',6.01),('8975','2013-05-12','10:00:00',4.04),('8975','2013-05-12','10:05:00',6.28),('8975','2013-05-12','10:10:00',6.34),('8975','2013-05-12','10:15:00',6.37),('8975','2013-05-12','10:20:00',6.54),('8975','2013-05-12','10:25:00',5.9),('8975','2013-05-12','10:30:00',6.68),('8975','2013-05-12','10:35:00',4.37),('8975','2013-05-12','10:40:00',6.78),('8975','2013-05-12','10:45:00',7.06),('8975','2013-05-12','10:50:00',2.88),('8975','2013-05-12','10:55:00',1.93),('8975','2013-05-12','11:00:00',2.86),('8975','2013-05-12','11:05:00',5.63),('8975','2013-05-12','11:10:00',5.12),('8975','2013-05-12','11:15:00',6.48),('8975','2013-05-12','11:20:00',2.83),('8975','2013-05-12','11:25:00',2.68),('8975','2013-05-12','11:30:00',2.66),('8975','2013-05-12','11:35:00',2.72),('8975','2013-05-12','11:40:00',5.63),('8975','2013-05-12','11:45:00',4.97),('8975','2013-05-12','11:50:00',3.53),('8975','2013-05-12','11:55:00',3.29),('8975','2013-05-12','12:00:00',3.17),('8975','2013-05-12','12:05:00',3.06),('8975','2013-05-12','12:10:00',4.54),('8975','2013-05-12','12:15:00',5.21),('8975','2013-05-12','12:20:00',4.47),('8975','2013-05-12','12:25:00',1.98),('8975','2013-05-12','12:30:00',1.78),('8975','2013-05-12','12:35:00',5.64),('8975','2013-05-12','12:40:00',7.62),('8975','2013-05-12','12:45:00',7.58),('8975','2013-05-12','12:50:00',7.54),('8975','2013-05-12','12:55:00',7.47),('8975','2013-05-12','13:00:00',7.3),('8975','2013-05-12','13:05:00',6.8),('8975','2013-05-12','13:10:00',4.7),('8975','2013-05-12','13:15:00',4.17),('8975','2013-05-12','13:20:00',2.52),('8975','2013-05-12','13:25:00',4.77),('8975','2013-05-12','13:30:00',5.94),('8975','2013-05-12','13:35:00',7.3),('8975','2013-05-12','13:40:00',7.22),('8975','2013-05-12','13:45:00',7.64),('8975','2013-05-12','13:50:00',5.91),('8975','2013-05-12','13:55:00',4.61),('8975','2013-05-12','14:00:00',2.6),('8975','2013-05-12','14:05:00',1.65),('8975','2013-05-12','14:10:00',1.41),('8975','2013-05-12','14:15:00',5.16),('8975','2013-05-12','14:20:00',5.94),('8975','2013-05-12','14:25:00',5.77),('8975','2013-05-12','14:30:00',6.6),('8975','2013-05-12','14:35:00',2.56),('8975','2013-05-12','14:40:00',1.89),('8975','2013-05-12','14:45:00',1.47),('8975','2013-05-12','14:50:00',1.8),('8975','2013-05-12','14:55:00',1.86),('8975','2013-05-12','15:00:00',1.84),('8975','2013-05-12','15:05:00',4.76),('8975','2013-05-12','15:10:00',1.7),('8975','2013-05-12','15:15:00',1.56),('8975','2013-05-12','15:20:00',1.31),('8975','2013-05-12','15:25:00',1.23),('8975','2013-05-12','15:30:00',1.33),('8975','2013-05-12','15:35:00',1.3),('8975','2013-05-12','15:40:00',1.57),('8975','2013-05-12','15:45:00',1.97),('8975','2013-05-12','15:50:00',1.85),('8975','2013-05-12','15:55:00',1.34),('8975','2013-05-12','16:00:00',1.69),('8975','2013-05-12','16:05:00',2.76),('8975','2013-05-12','16:10:00',2.57),('8975','2013-05-12','16:15:00',2.13),('8975','2013-05-12','16:20:00',2.3),('8975','2013-05-12','16:25:00',2.29),('8975','2013-05-12','16:30:00',2.09),('8975','2013-05-12','16:35:00',2),('8975','2013-05-12','16:40:00',2.05),('8975','2013-05-12','16:45:00',2.23),('8975','2013-05-12','16:50:00',4.31),('8975','2013-05-12','16:55:00',3.87),('8975','2013-05-12','17:00:00',3.53),('8975','2013-05-12','17:05:00',3.4),('8975','2013-05-12','17:10:00',2.53),('8975','2013-05-12','17:15:00',2.62),('8975','2013-05-12','17:20:00',3.53),('8975','2013-05-12','17:25:00',3.56),('8975','2013-05-12','17:30:00',3.54),('8975','2013-05-12','17:35:00',3.42),('8975','2013-05-12','17:40:00',3.16),('8975','2013-05-12','17:45:00',2.94),('8975','2013-05-12','17:50:00',2.85),('8975','2013-05-12','17:55:00',2.11),('8975','2013-05-12','18:00:00',1.41),('8975','2013-05-12','18:05:00',1.23),('8975','2013-05-12','18:10:00',1.22),('8975','2013-05-12','18:15:00',1.84),('8975','2013-05-12','18:20:00',1.77),('8975','2013-05-12','18:25:00',1.22),('8975','2013-05-11','07:35:00',1.02),('8975','2013-05-11','07:40:00',1.22),('8975','2013-05-11','07:45:00',1.34),('8975','2013-05-11','07:50:00',2.11),('8975','2013-05-11','07:55:00',2.27),('8975','2013-05-11','08:00:00',1.66),('8975','2013-05-11','08:05:00',2.78),('8975','2013-05-11','08:10:00',3.2),('8975','2013-05-11','08:15:00',2.23),('8975','2013-05-11','08:20:00',2.33),('8975','2013-05-11','08:25:00',1.97),('8975','2013-05-11','08:30:00',2.02),('8975','2013-05-11','08:35:00',4.48),('8975','2013-05-11','08:40:00',2.6),('8975','2013-05-11','08:45:00',2.22),('8975','2013-05-11','08:50:00',5.03),('8975','2013-05-11','08:55:00',4.3),('8975','2013-05-11','09:00:00',3.65),('8975','2013-05-11','09:05:00',4.85),('8975','2013-05-11','09:10:00',5.86),('8975','2013-05-11','09:15:00',5.99),('8975','2013-05-11','09:20:00',5.76),('8975','2013-05-11','09:25:00',6.55),('8975','2013-05-11','09:30:00',3.6),('8975','2013-05-11','09:35:00',2.35),('8975','2013-05-11','09:40:00',2.45),('8975','2013-05-11','09:45:00',2.51),('8975','2013-05-11','09:50:00',2.13),('8975','2013-05-11','09:55:00',2.13),('8975','2013-05-11','10:00:00',2.18),('8975','2013-05-11','10:05:00',4.56),('8975','2013-05-11','10:10:00',6.85),('8975','2013-05-11','10:15:00',6.25),('8975','2013-05-11','10:20:00',1.91),('8975','2013-05-11','10:25:00',1.48),('8975','2013-05-11','10:30:00',1.55),('8975','2013-05-11','10:35:00',1.51),('8975','2013-05-11','10:40:00',1.48),('8975','2013-05-11','10:45:00',1.68),('8975','2013-05-11','10:50:00',1.74),('8975','2013-05-11','10:55:00',1.81),('8975','2013-05-11','11:00:00',5.95),('8975','2013-05-11','11:05:00',1.95),('8975','2013-05-11','11:10:00',1.79),('8975','2013-05-11','11:15:00',1.74),('8975','2013-05-11','11:20:00',1.78),('8975','2013-05-11','11:25:00',3.67),('8975','2013-05-11','11:30:00',3.66),('8975','2013-05-11','11:35:00',8.18),('8975','2013-05-11','11:40:00',3.92),('8975','2013-05-11','11:45:00',4.01),('8975','2013-05-11','11:50:00',3.4),('8975','2013-05-11','11:55:00',2.26),('8975','2013-05-11','12:00:00',3.4),('8975','2013-05-11','12:05:00',3.87),('8975','2013-05-11','12:10:00',6.23),('8975','2013-05-11','12:15:00',6.71),('8975','2013-05-11','12:20:00',5.37),('8975','2013-05-11','12:25:00',2.28),('8975','2013-05-11','12:30:00',1.7),('8975','2013-05-11','12:35:00',1.96),('8975','2013-05-11','12:40:00',2.45),('8975','2013-05-11','12:45:00',2.25),('8975','2013-05-11','12:50:00',1.77),('8975','2013-05-11','12:55:00',2.11),('8975','2013-05-11','13:00:00',3),('8975','2013-05-11','13:05:00',3.07),('8975','2013-05-11','13:10:00',6.33),('8975','2013-05-11','13:15:00',8.38),('8975','2013-05-11','13:20:00',7.76),('8975','2013-05-11','13:25:00',7.51),('8975','2013-05-11','13:30:00',6.87),('8975','2013-05-11','13:35:00',7.48),('8975','2013-05-11','13:40:00',7.37),('8975','2013-05-11','13:45:00',6.36),('8975','2013-05-11','13:50:00',2.57),('8975','2013-05-11','13:55:00',6.94),('8975','2013-05-11','14:00:00',2.88),('8975','2013-05-11','14:05:00',6.34),('8975','2013-05-11','14:10:00',5.25),('8975','2013-05-11','14:15:00',6.62),('8975','2013-05-11','14:20:00',2.19),('8975','2013-05-11','14:25:00',4.75),('8975','2013-05-11','14:30:00',6.4),('8975','2013-05-11','14:35:00',3.73),('8975','2013-05-11','14:40:00',3.39),('8975','2013-05-11','14:45:00',3.24),('8975','2013-05-11','14:50:00',5.06),('8975','2013-05-11','14:55:00',5.29),('8975','2013-05-11','15:00:00',6.17),('8975','2013-05-11','15:05:00',4.09),('8975','2013-05-11','15:10:00',5.12),('8975','2013-05-11','15:15:00',4.15),('8975','2013-05-11','15:20:00',5.82),('8975','2013-05-11','15:25:00',5.48),('8975','2013-05-11','15:30:00',5.22),('8975','2013-05-11','15:35:00',4.91),('8975','2013-05-11','15:40:00',4.92),('8975','2013-05-11','15:45:00',4.87),('8975','2013-05-11','15:50:00',4.72),('8975','2013-05-11','15:55:00',4.54),('8975','2013-05-11','16:00:00',4.45),('8975','2013-05-11','16:05:00',4.33),('8975','2013-05-11','16:10:00',4.2),('8975','2013-05-11','16:15:00',4.1),('8975','2013-05-11','16:20:00',4),('8975','2013-05-11','16:25:00',3.85),('8975','2013-05-11','16:30:00',3.78),('8975','2013-05-11','16:35:00',3.74),('8975','2013-05-11','16:40:00',3.75),('8975','2013-05-11','16:45:00',3.68),('8975','2013-05-11','16:50:00',3.54),('8975','2013-05-11','16:55:00',4.05),('8975','2013-05-11','17:00:00',3.36),('8975','2013-05-11','17:05:00',3.78),('8975','2013-05-11','17:10:00',3.65),('8975','2013-05-11','17:15:00',3.93),('8975','2013-05-11','17:20:00',2.96),('8975','2013-05-11','17:25:00',2.13),('8975','2013-05-11','17:30:00',2.68),('8975','2013-05-11','17:35:00',1.94),('8975','2013-05-11','17:40:00',2.28),('8975','2013-05-11','17:45:00',2.24),('8975','2013-05-11','17:50:00',2.23),('8975','2013-05-11','17:55:00',1.45),('8975','2013-05-11','18:00:00',2.83),('8975','2013-05-11','18:05:00',2.14),('8975','2013-05-11','18:10:00',1.99),('8975','2013-05-11','18:15:00',2.35),('8975','2013-05-11','18:20:00',2.03),('8975','2013-05-11','18:25:00',1.47),('8975','2013-05-11','18:30:00',1.47),('8975','2013-05-11','18:35:00',1.85),('8975','2013-05-11','18:40:00',1.6),('8975','2013-05-11','18:45:00',1.24),('8975','2013-05-11','18:50:00',1.13),('8975','2013-05-11','19:00:00',1.11),('8975','2013-05-11','19:05:00',1.23),('8975','2013-05-11','19:10:00',1.01),('8975','2013-05-11','19:15:00',1.02),('8975','2014-03-30','07:30:00',1.11),('8975','2014-03-30','07:35:00',1.23),('8975','2014-03-30','07:40:00',1.45),('8975','2014-03-30','07:45:00',1.66),('8975','2014-03-30','07:50:00',1.71),('8975','2014-03-30','07:55:00',1.82),('8975','2014-03-30','08:00:00',2.16),('8975','2014-03-30','08:05:00',2.42),('8975','2014-03-30','08:10:00',2.59),('8975','2014-03-30','08:15:00',2.73),('8975','2014-03-30','08:20:00',2.86),('8975','2014-03-30','08:25:00',2.99),('8975','2014-03-30','08:30:00',3.13),('8975','2014-03-30','08:35:00',3.24),('8975','2014-03-30','08:40:00',3.33),('8975','2014-03-30','08:45:00',3.41),('8975','2014-03-30','08:50:00',3.49),('8975','2014-03-30','08:55:00',3.59),('8975','2014-03-30','09:00:00',3.66),('8975','2014-03-30','09:05:00',3.78),('8975','2014-03-30','09:10:00',3.89),('8975','2014-03-30','09:15:00',3.99),('8975','2014-03-30','09:20:00',4.1),('8975','2014-03-30','09:25:00',4.19),('8975','2014-03-30','09:30:00',4.27),('8975','2014-03-30','09:35:00',4.39),('8975','2014-03-30','09:40:00',4.5),('8975','2014-03-30','09:45:00',4.61),('8975','2014-03-30','09:50:00',4.7),('8975','2014-03-30','09:55:00',4.79),('8975','2014-03-30','10:00:00',4.85),('8975','2014-03-30','10:05:00',4.92),('8975','2014-03-30','10:10:00',5),('8975','2014-03-30','10:15:00',5.05),('8975','2014-03-30','10:20:00',5.14),('8975','2014-03-30','10:25:00',5.2),('8975','2014-03-30','10:30:00',5.26),('8975','2014-03-30','10:35:00',5.33),('8975','2014-03-30','10:40:00',5.36),('8975','2014-03-30','10:45:00',5.38),('8975','2014-03-30','10:50:00',5.44),('8975','2014-03-30','10:55:00',5.5),('8975','2014-03-30','11:00:00',5.54),('8975','2014-03-30','11:05:00',5.61),('8975','2014-03-30','11:10:00',5.66),('8975','2014-03-30','11:15:00',5.67),('8975','2014-03-30','11:20:00',5.72),('8975','2014-03-30','11:25:00',5.74),('8975','2014-03-30','11:30:00',5.81),('8975','2014-03-30','11:35:00',5.86),('8975','2014-03-30','11:40:00',5.85),('8975','2014-03-30','11:45:00',5.89),('8975','2014-03-30','11:50:00',5.97),('8975','2014-03-30','11:55:00',5.96),('8975','2014-03-30','12:00:00',5.97),('8975','2014-03-30','12:05:00',6.01),('8975','2014-03-30','12:10:00',6.03),('8975','2014-03-30','12:15:00',6.03),('8975','2014-03-30','12:20:00',6.01),('8975','2014-03-30','12:25:00',6.01),('8975','2014-03-30','12:30:00',6.01),('8975','2014-03-30','12:35:00',6.03),('8975','2014-03-30','12:40:00',6),('8975','2014-03-30','12:45:00',5.95),('8975','2014-03-30','12:50:00',5.94),('8975','2014-03-30','12:55:00',5.9),('8975','2014-03-30','13:00:00',5.83),('8975','2014-03-30','13:05:00',5.9),('8975','2014-03-30','13:10:00',5.91),('8975','2014-03-30','13:15:00',5.87),('8975','2014-03-30','13:20:00',5.84),('8975','2014-03-30','13:25:00',5.82),('8975','2014-03-30','13:30:00',5.77),('8975','2014-03-30','13:35:00',5.75),('8975','2014-03-30','13:40:00',5.75),('8975','2014-03-30','13:45:00',5.7),('8975','2014-03-30','13:50:00',5.65),('8975','2014-03-30','13:55:00',5.57),('8975','2014-03-30','14:00:00',5.5),('8975','2014-03-30','14:05:00',5.47),('8975','2014-03-30','14:10:00',5.42),('8975','2014-03-30','14:15:00',5.34),('8975','2014-03-30','14:20:00',5.28),('8975','2014-03-30','14:25:00',5.18),('8975','2014-03-30','14:30:00',5.1),('8975','2014-03-30','14:35:00',5.05),('8975','2014-03-30','14:40:00',4.98),('8975','2014-03-30','14:45:00',4.88),('8975','2014-03-30','14:50:00',4.78),('8975','2014-03-30','14:55:00',4.72),('8975','2014-03-30','15:00:00',4.62),('8975','2014-03-30','15:05:00',4.56),('8975','2014-03-30','15:10:00',4.37),('8975','2014-03-30','15:15:00',4.17),('8975','2014-03-30','15:20:00',4.17),('8975','2014-03-30','15:25:00',4.07),('8975','2014-03-30','15:30:00',3.95),('8975','2014-03-30','15:35:00',3.83),('8975','2014-03-30','15:40:00',3.73),('8975','2014-03-30','15:45:00',3.6),('8975','2014-03-30','15:50:00',3.49),('8975','2014-03-30','15:55:00',3.23),('8975','2014-03-30','16:00:00',3.24),('8975','2014-03-30','16:05:00',3.15),('8975','2014-03-30','16:10:00',3.06),('8975','2014-03-30','16:15:00',2.94),('8975','2014-03-30','16:20:00',2.84),('8975','2014-03-30','16:25:00',2.71),('8975','2014-03-30','16:30:00',2.64),('8975','2014-03-30','16:35:00',2.54),('8975','2014-03-30','16:40:00',2.42),('8975','2014-03-30','16:45:00',2.31),('8975','2014-03-30','16:50:00',2.2),('8975','2014-03-30','16:55:00',2.1),('8975','2014-03-30','17:00:00',2),('8975','2014-03-30','17:05:00',1.9),('8975','2014-03-30','17:10:00',1.81),('8975','2014-03-30','17:15:00',1.75),('8975','2014-03-30','17:20:00',1.69),('8975','2014-03-30','17:25:00',1.61),('8975','2014-03-30','17:30:00',1.54),('8975','2014-03-30','17:35:00',1.51),('8975','2014-03-30','17:40:00',1.47),('8975','2014-03-30','17:45:00',1.42),('8975','2014-03-30','17:50:00',1.37),('8975','2014-03-30','17:55:00',1.3),('8975','2014-03-30','18:00:00',1.24),('8975','2014-03-30','18:05:00',1.17),('8975','2014-03-30','18:10:00',1.11),('8975','2014-03-30','18:15:00',1.04),('8975','2013-05-10','07:10:00',1.27),('8975','2013-05-10','07:15:00',2.2),('8975','2013-05-10','07:20:00',2.34),('8975','2013-05-10','07:25:00',2.45),('8975','2013-05-10','07:30:00',2.22),('8975','2013-05-10','07:35:00',2.62),('8975','2013-05-10','07:40:00',2.82),('8975','2013-05-10','07:45:00',3.23),('8975','2013-05-10','07:50:00',3.35),('8975','2013-05-10','07:55:00',3.42),('8975','2013-05-10','08:00:00',3.1),('8975','2013-05-10','08:05:00',2.64),('8975','2013-05-10','08:10:00',2.57),('8975','2013-05-10','08:15:00',2.21),('8975','2013-05-10','08:20:00',2.36),('8975','2013-05-10','08:25:00',1.33),('8975','2013-05-10','08:30:00',2.28),('8975','2013-05-10','08:35:00',2.09),('8975','2013-05-10','08:40:00',1.09),('8975','2013-05-10','08:45:00',1.27),('8975','2013-05-10','08:50:00',1.42),('8975','2013-05-10','08:55:00',1.72),('8975','2013-05-10','09:00:00',1.48),('8975','2013-05-10','09:05:00',2.46),('8975','2013-05-10','09:10:00',2.46),('8975','2013-05-10','09:15:00',2.86),('8975','2013-05-10','09:20:00',3.4),('8975','2013-05-10','09:25:00',3.58),('8975','2013-05-10','09:30:00',4.59),('8975','2013-05-10','09:35:00',4.42),('8975','2013-05-10','09:40:00',4.2),('8975','2013-05-10','09:45:00',3.14),('8975','2013-05-10','09:50:00',6.22),('8975','2013-05-10','09:55:00',5.4),('8975','2013-05-10','10:00:00',2.05),('8975','2013-05-10','10:05:00',1.63),('8975','2013-05-10','10:10:00',1.59),('8975','2013-05-10','10:15:00',1.36),('8975','2013-05-10','10:20:00',1.18),('8975','2013-05-10','10:25:00',1.81),('8975','2013-05-10','10:30:00',2.66),('8975','2013-05-10','10:35:00',2.02),('8975','2013-05-10','10:40:00',1.69),('8975','2013-05-10','10:45:00',5.41),('8975','2013-05-10','10:50:00',4.74),('8975','2013-05-10','10:55:00',2.02),('8975','2013-05-10','11:00:00',2.7),('8975','2013-05-10','11:05:00',2.34),('8975','2013-05-10','11:10:00',1.32),('8975','2013-05-10','11:15:00',1),('8975','2013-05-10','11:20:00',1.35),('8975','2013-05-10','11:25:00',2.11),('8975','2013-05-10','11:30:00',2.55),('8975','2013-05-10','11:35:00',2.94),('8975','2013-05-10','11:40:00',8.22),('8975','2013-05-10','11:45:00',8.2),('8975','2013-05-10','11:50:00',4.44),('8975','2013-05-10','11:55:00',2.76),('8975','2013-05-10','12:00:00',4.02),('8975','2013-05-10','12:05:00',3.3),('8975','2013-05-10','12:10:00',2.31),('8975','2013-05-10','12:15:00',3.57),('8975','2013-05-10','12:20:00',3.04),('8975','2013-05-10','12:25:00',5.06),('8975','2013-05-10','12:30:00',3.88),('8975','2013-05-10','12:35:00',5.74),('8975','2013-05-10','12:40:00',7.09),('8975','2013-05-10','12:45:00',4.92),('8975','2013-05-10','12:50:00',3.09),('8975','2013-05-10','12:55:00',3.21),('8975','2013-05-10','13:00:00',3.92),('8975','2013-05-10','13:05:00',4.59),('8975','2013-05-10','13:10:00',2.15),('8975','2013-05-10','13:15:00',2.53),('8975','2013-05-10','13:20:00',5.03),('8975','2013-05-10','13:25:00',2.18),('8975','2013-05-10','13:30:00',2),('8975','2013-05-10','13:35:00',2.02),('8975','2013-05-10','13:40:00',1.16),('8975','2013-05-10','13:50:00',1.18),('8975','2013-05-10','13:55:00',2.02),('8975','2013-05-10','14:00:00',3.14),('8975','2013-05-10','14:05:00',4.55),('8975','2013-05-10','14:10:00',6.07),('8975','2013-05-10','14:15:00',5.58),('8975','2013-05-10','14:20:00',4.08),('8975','2013-05-10','14:25:00',6.25),('8975','2013-05-10','14:30:00',2.79),('8975','2013-05-10','14:35:00',5.04),('8975','2013-05-10','14:40:00',4.47),('8975','2013-05-10','14:45:00',5.13),('8975','2013-05-10','14:50:00',4.37),('8975','2013-05-10','14:55:00',5.87),('8975','2013-05-10','15:00:00',5.83),('8975','2013-05-10','15:05:00',5.16),('8975','2013-05-10','15:10:00',4.3),('8975','2013-05-10','15:15:00',4.16),('8975','2013-05-10','15:20:00',4.22),('8975','2013-05-10','15:25:00',4.8),('8975','2013-05-10','15:30:00',5.19),('8975','2013-05-10','15:35:00',5.2),('8975','2013-05-10','15:40:00',5.12),('8975','2013-05-10','15:45:00',5.07),('8975','2013-05-10','15:50:00',4.79),('8975','2013-05-10','15:55:00',4.31),('8975','2013-05-10','16:00:00',4.55),('8975','2013-05-10','16:05:00',4.49),('8975','2013-05-10','16:10:00',4.41),('8975','2013-05-10','16:15:00',4.29),('8975','2013-05-10','16:20:00',4.31),('8975','2013-05-10','16:25:00',4.24),('8975','2013-05-10','16:30:00',3.92),('8975','2013-05-10','16:35:00',3.72),('8975','2013-05-10','16:40:00',3.43),('8975','2013-05-10','16:45:00',3.31),('8975','2013-05-10','16:50:00',2.86),('8975','2013-05-10','16:55:00',2.92),('8975','2013-05-10','17:00:00',2.84),('8975','2013-05-10','17:05:00',2.88),('8975','2013-05-10','17:10:00',1.74),('8975','2013-05-10','17:15:00',1.22),('8975','2013-05-10','17:20:00',1.15),('8975','2013-05-10','17:25:00',1.69),('8975','2013-05-10','17:30:00',1.29),('8975','2013-05-10','17:35:00',1.72),('8975','2013-05-10','17:40:00',2.17),('8975','2013-05-10','17:45:00',1.42),('8975','2013-05-10','17:50:00',2.1),('8975','2013-05-10','17:55:00',1.32),('8975','2013-05-10','18:00:00',1.59),('8975','2013-05-10','18:05:00',1.69),('8975','2013-05-10','18:10:00',1.57),('8975','2013-05-10','18:15:00',1.86),('8975','2013-05-10','18:20:00',1.8),('8975','2013-05-10','18:25:00',1.65),('8975','2013-05-10','18:30:00',1),('8975','2013-05-10','18:40:00',1.13),('8975','2013-05-10','18:50:00',1.03),('8975','2013-05-10','18:55:00',1.49),('8975','2013-05-10','19:00:00',1.1),('8975','2013-05-09','06:40:00',1.08),('8975','2013-05-09','06:55:00',1.09),('8975','2013-05-09','07:00:00',1.74),('8975','2013-05-09','07:15:00',1.76),('8975','2013-05-09','07:20:00',1.98),('8975','2013-05-09','07:25:00',2.72),('8975','2013-05-09','07:30:00',2.89),('8975','2013-05-09','07:35:00',2.85),('8975','2013-05-09','07:40:00',1.46),('8975','2013-05-09','07:45:00',1.37),('8975','2013-05-09','07:50:00',2.83),('8975','2013-05-09','07:55:00',3.8),('8975','2013-05-09','08:00:00',3.96),('8975','2013-05-09','08:05:00',4.15),('8975','2013-05-09','08:10:00',4.29),('8975','2013-05-09','08:15:00',4.57),('8975','2013-05-09','08:20:00',4.33),('8975','2013-05-09','08:25:00',4.29),('8975','2013-05-09','08:30:00',4.01),('8975','2013-05-09','08:35:00',3.97),('8975','2013-05-09','08:40:00',1.79),('8975','2013-05-09','08:45:00',1.07),('8975','2013-05-09','08:55:00',1.17),('8975','2013-05-09','09:00:00',2.87),('8975','2013-05-09','09:05:00',4.61),('8975','2013-05-09','09:10:00',5.34),('8975','2013-05-09','09:15:00',5.4),('8975','2013-05-09','09:20:00',5.21),('8975','2013-05-09','09:25:00',4.7),('8975','2013-05-09','09:30:00',5.25),('8975','2013-05-09','09:35:00',5),('8975','2013-05-09','09:40:00',3.32),('8975','2013-05-09','09:45:00',5.31),('8975','2013-05-09','09:50:00',4.25),('8975','2013-05-09','09:55:00',4.41),('8975','2013-05-09','10:00:00',2.65),('8975','2013-05-09','10:05:00',3.02),('8975','2013-05-09','10:10:00',2.17),('8975','2013-05-09','10:15:00',2.56),('8975','2013-05-09','10:20:00',3.38),('8975','2013-05-09','10:25:00',6.55),('8975','2013-05-09','10:30:00',6.85),('8975','2013-05-09','10:35:00',5.52),('8975','2013-05-09','10:40:00',2.86),('8975','2013-05-09','10:45:00',2.22),('8975','2013-05-09','10:50:00',3.06),('8975','2013-05-09','10:55:00',7.09),('8975','2013-05-09','11:00:00',6.94),('8975','2013-05-09','11:05:00',6.84),('8975','2013-05-09','11:10:00',6.85),('8975','2013-05-09','11:15:00',6.79),('8975','2013-05-09','11:20:00',5.22),('8975','2013-05-09','11:25:00',6.8),('8975','2013-05-09','11:30:00',6.09),('8975','2013-05-09','11:35:00',6.93),('8975','2013-05-09','11:40:00',6.7),('8975','2013-05-09','11:45:00',3.76),('8975','2013-05-09','11:50:00',3.95),('8975','2013-05-09','11:55:00',7.04),('8975','2013-05-09','12:00:00',6.3),('8975','2013-05-09','12:05:00',5.97),('8975','2013-05-09','12:10:00',5.94),('8975','2013-05-09','12:15:00',6.25),('8975','2013-05-09','12:20:00',5.92),('8975','2013-05-09','12:25:00',4.98),('8975','2013-05-09','12:30:00',4.49),('8975','2013-05-09','12:35:00',4.77),('8975','2013-05-09','12:40:00',6.12),('8975','2013-05-09','12:45:00',6.89),('8975','2013-05-09','12:50:00',7.2),('8975','2013-05-09','12:55:00',7.62),('8975','2013-05-09','13:00:00',7.56),('8975','2013-05-09','13:05:00',5.9),('8975','2013-05-09','13:10:00',4.59),('8975','2013-05-09','13:15:00',5.35),('8975','2013-05-09','13:20:00',5.42),('8975','2013-05-09','13:25:00',4.83),('8975','2013-05-09','13:30:00',4.51),('8975','2013-05-09','13:35:00',4.31),('8975','2013-05-09','13:40:00',3.92),('8975','2013-05-09','13:45:00',4),('8975','2013-05-09','13:50:00',3.39),('8975','2013-05-09','13:55:00',3.36),('8975','2013-05-09','14:00:00',3.26),('8975','2013-05-09','14:05:00',3.59),('8975','2013-05-09','14:10:00',4.81),('8975','2013-05-09','14:15:00',4.41),('8975','2013-05-09','14:20:00',4.42),('8975','2013-05-09','14:25:00',3.99),('8975','2013-05-09','14:30:00',4.13),('8975','2013-05-09','14:35:00',4.28),('8975','2013-05-09','14:40:00',4.54),('8975','2013-05-09','14:45:00',3.15),('8975','2013-05-09','14:50:00',2.42),('8975','2013-05-09','14:55:00',2.06),('8975','2013-05-09','15:00:00',1.92),('8975','2013-05-09','15:05:00',2.09),('8975','2013-05-09','15:10:00',2.66),('8975','2013-05-09','15:15:00',3.94),('8975','2013-05-09','15:20:00',4.21),('8975','2013-05-09','15:25:00',3.38),('8975','2013-05-09','15:30:00',3.1),('8975','2013-05-09','15:35:00',3.14),('8975','2013-05-09','15:40:00',3.57),('8975','2013-05-09','15:45:00',3.3),('8975','2013-05-09','15:50:00',2.89),('8975','2013-05-09','15:55:00',2.83),('8975','2013-05-09','16:00:00',2.76),('8975','2013-05-09','16:05:00',2.61),('8975','2013-05-09','16:10:00',2.5),('8975','2013-05-09','16:15:00',2.36),('8975','2013-05-09','16:20:00',2.17),('8975','2013-05-09','16:25:00',2.18),('8975','2013-05-09','16:30:00',2.3),('8975','2013-05-09','16:35:00',2.33),('8975','2013-05-09','16:40:00',2.25),('8975','2013-05-09','16:45:00',2.17),('8975','2013-05-09','16:50:00',2.05),('8975','2013-05-09','16:55:00',1.73),('8975','2013-05-09','17:00:00',1.4),('8975','2013-05-09','17:05:00',1.38),('8975','2013-05-09','17:10:00',1.64),('8975','2013-05-09','17:15:00',2.61),('8975','2013-05-09','17:20:00',3.51),('8975','2013-05-09','17:25:00',3.27),('8975','2013-05-09','17:30:00',3.05),('8975','2013-05-09','17:35:00',2.84),('8975','2013-05-09','17:40:00',2.13),('8975','2013-05-09','17:45:00',1.99),('8975','2013-05-09','17:50:00',1.64),('8975','2013-05-09','17:55:00',1.55),('8975','2013-05-09','18:00:00',1.45),('8975','2013-05-09','18:05:00',1.38),('8975','2013-05-09','18:10:00',1.27),('8975','2013-05-09','18:15:00',1.31),('8975','2013-05-09','18:20:00',1.4),('8975','2013-05-09','18:25:00',1.03),('8975','2013-05-08','06:40:00',1.3),('8975','2013-05-08','06:55:00',1.13),('8975','2013-05-08','07:00:00',2.14),('8975','2013-05-08','07:05:00',1.73),('8975','2013-05-08','07:10:00',1.94),('8975','2013-05-08','07:15:00',2.6),('8975','2013-05-08','07:20:00',2.66),('8975','2013-05-08','07:25:00',2.78),('8975','2013-05-08','07:30:00',2.91),('8975','2013-05-08','07:35:00',3.06),('8975','2013-05-08','07:40:00',3.19),('8975','2013-05-08','07:45:00',3.31),('8975','2013-05-08','07:50:00',3.44),('8975','2013-05-08','07:55:00',3.55),('8975','2013-05-08','08:00:00',3.66),('8975','2013-05-08','08:05:00',3.73),('8975','2013-05-08','08:10:00',3.84),('8975','2013-05-08','08:15:00',3.95),('8975','2013-05-08','08:20:00',4.07),('8975','2013-05-08','08:25:00',4.17),('8975','2013-05-08','08:30:00',4.25),('8975','2013-05-08','08:35:00',4.37),('8975','2013-05-08','08:40:00',4.45),('8975','2013-05-08','08:45:00',4.57),('8975','2013-05-08','08:50:00',4.66),('8975','2013-05-08','08:55:00',4.76),('8975','2013-05-08','09:00:00',4.87),('8975','2013-05-08','09:05:00',4.85),('8975','2013-05-08','09:10:00',4.86),('8975','2013-05-08','09:15:00',4.83),('8975','2013-05-08','09:20:00',5.14),('8975','2013-05-08','09:25:00',5.16),('8975','2013-05-08','09:30:00',5.45),('8975','2013-05-08','09:35:00',5.03),('8975','2013-05-08','09:40:00',5.45),('8975','2013-05-08','09:45:00',5.51),('8975','2013-05-08','09:50:00',4.99),('8975','2013-05-08','09:55:00',5.68),('8975','2013-05-08','10:00:00',5.85),('8975','2013-05-08','10:05:00',6),('8975','2013-05-08','10:10:00',6.1),('8975','2013-05-08','10:15:00',6.22),('8975','2013-05-08','10:20:00',6.22),('8975','2013-05-08','10:25:00',6.29),('8975','2013-05-08','10:30:00',6.32),('8975','2013-05-08','10:35:00',6.33),('8975','2013-05-08','10:40:00',6.41),('8975','2013-05-08','10:45:00',6.44),('8975','2013-05-08','10:50:00',6.47),('8975','2013-05-08','10:55:00',6.53),('8975','2013-05-08','11:00:00',6.55),('8975','2013-05-08','11:05:00',6.59),('8975','2013-05-08','11:10:00',6.64),('8975','2013-05-08','11:15:00',6.65),('8975','2013-05-08','11:20:00',6.67),('8975','2013-05-08','11:25:00',6.75),('8975','2013-05-08','11:30:00',6.76),('8975','2013-05-08','11:35:00',6.73),('8975','2013-05-08','11:40:00',6.76),('8975','2013-05-08','11:45:00',6.77),('8975','2013-05-08','11:50:00',6.76),('8975','2013-05-08','11:55:00',6.78),('8975','2013-05-08','12:00:00',6.81),('8975','2013-05-08','12:05:00',6.77),('8975','2013-05-08','12:10:00',6.77),('8975','2013-05-08','12:15:00',6.79),('8975','2013-05-08','12:20:00',6.72),('8975','2013-05-08','12:25:00',6.76),('8975','2013-05-08','12:30:00',6.86),('8975','2013-05-08','12:35:00',6.86),('8975','2013-05-08','12:40:00',6.76),('8975','2013-05-08','12:45:00',6.74),('8975','2013-05-08','12:50:00',6.83),('8975','2013-05-08','12:55:00',6.04),('8975','2013-05-08','13:00:00',3.13),('8975','2013-05-08','13:05:00',6.79),('8975','2013-05-08','13:10:00',6.76),('8975','2013-05-08','13:15:00',6.67),('8975','2013-05-08','13:20:00',6.62),('8975','2013-05-08','13:25:00',6.61),('8975','2013-05-08','13:30:00',6.56),('8975','2013-05-08','13:35:00',6.61),('8975','2013-05-08','13:40:00',6.59),('8975','2013-05-08','13:45:00',6.58),('8975','2013-05-08','13:50:00',6.45),('8975','2013-05-08','13:55:00',5.94),('8975','2013-05-08','14:00:00',6.64),('8975','2013-05-08','14:05:00',6.54),('8975','2013-05-08','14:10:00',6.61),('8975','2013-05-08','14:15:00',6.55),('8975','2013-05-08','14:20:00',6.05),('8975','2013-05-08','14:25:00',6.16),('8975','2013-05-08','14:30:00',5.99),('8975','2013-05-08','14:35:00',5.91),('8975','2013-05-08','14:40:00',5.84),('8975','2013-05-08','14:45:00',5.76),('8975','2013-05-08','14:50:00',5.62),('8975','2013-05-08','14:55:00',5.61),('8975','2013-05-08','15:00:00',5.47),('8975','2013-05-08','15:05:00',5.38),('8975','2013-05-08','15:10:00',5.33),('8975','2013-05-08','15:15:00',5.23),('8975','2013-05-08','15:20:00',5.1),('8975','2013-05-08','15:25:00',5.02),('8975','2013-05-08','15:30:00',4.95),('8975','2013-05-08','15:35:00',4.87),('8975','2013-05-08','15:40:00',4.75),('8975','2013-05-08','15:45:00',4.62),('8975','2013-05-08','15:50:00',4.5),('8975','2013-05-08','15:55:00',4.4),('8975','2013-05-08','16:00:00',4.32),('8975','2013-05-08','16:05:00',4.22),('8975','2013-05-08','16:10:00',4.05),('8975','2013-05-08','16:15:00',3.93),('8975','2013-05-08','16:20:00',3.85),('8975','2013-05-08','16:25:00',3.74),('8975','2013-05-08','16:30:00',3.63),('8975','2013-05-08','16:35:00',3.49),('8975','2013-05-08','16:40:00',3.35),('8975','2013-05-08','16:45:00',3.23),('8975','2013-05-08','16:50:00',3.1),('8975','2013-05-08','16:55:00',2.98),('8975','2013-05-08','17:00:00',2.84),('8975','2013-05-08','17:05:00',2.71),('8975','2013-05-08','17:10:00',2.58),('8975','2013-05-08','17:15:00',2.46),('8975','2013-05-08','17:20:00',2.36),('8975','2013-05-08','17:25:00',2.24),('8975','2013-05-08','17:30:00',2.13),('8975','2013-05-08','17:35:00',2.03),('8975','2013-05-08','17:40:00',1.94),('8975','2013-05-08','17:45:00',1.83),('8975','2013-05-08','17:50:00',1.74),('8975','2013-05-08','17:55:00',1.66),('8975','2013-05-08','18:00:00',1.58),('8975','2013-05-08','18:05:00',1.52),('8975','2013-05-08','18:10:00',1.44),('8975','2013-05-08','18:15:00',1.41),('8975','2013-05-08','18:20:00',1.36),('8975','2013-05-08','18:25:00',1.31),('8975','2013-05-08','18:30:00',1.26),('8975','2013-05-08','18:35:00',1.21),('8975','2013-05-08','18:40:00',1.15),('8975','2013-05-08','18:45:00',1.08),('8975','2013-05-08','18:50:00',1.02),('8975','2013-05-07','07:25:00',1.53),('8975','2013-05-07','07:30:00',2.68),('8975','2013-05-07','07:45:00',1.04),('8975','2013-05-07','07:50:00',1.34),('8975','2013-05-07','07:55:00',1.15),('8975','2013-05-07','08:00:00',1.33),('8975','2013-05-07','08:05:00',3.18),('8975','2013-05-07','08:10:00',4.03),('8975','2013-05-07','08:15:00',4.29),('8975','2013-05-07','08:20:00',4.24),('8975','2013-05-07','08:25:00',4.22),('8975','2013-05-07','08:30:00',4.22),('8975','2013-05-07','08:35:00',4.17),('8975','2013-05-07','08:40:00',4.36),('8975','2013-05-07','08:45:00',4.6),('8975','2013-05-07','08:50:00',5),('8975','2013-05-07','08:55:00',3.63),('8975','2013-05-07','09:00:00',4.26),('8975','2013-05-07','09:05:00',2.88),('8975','2013-05-07','09:10:00',3.98),('8975','2013-05-07','09:15:00',4.28),('8975','2013-05-07','09:20:00',2.43),('8975','2013-05-07','09:25:00',2.65),('8975','2013-05-07','09:30:00',3.29),('8975','2013-05-07','09:35:00',4.71),('8975','2013-05-07','09:40:00',2.86),('8975','2013-05-07','09:45:00',5.98),('8975','2013-05-07','09:50:00',4.16),('8975','2013-05-07','09:55:00',3.22),('8975','2013-05-07','10:00:00',5.25),('8975','2013-05-07','10:05:00',4.07),('8975','2013-05-07','10:10:00',2.37),('8975','2013-05-07','10:15:00',1.75),('8975','2013-05-07','10:20:00',4.15),('8975','2013-05-07','10:25:00',4.46),('8975','2013-05-07','10:30:00',6.56),('8975','2013-05-07','10:35:00',7.06),('8975','2013-05-07','10:40:00',5.95),('8975','2013-05-07','10:45:00',1.97),('8975','2013-05-07','10:50:00',2.5),('8975','2013-05-07','10:55:00',7.47),('8975','2013-05-07','11:00:00',4.88),('8975','2013-05-07','11:05:00',2.09),('8975','2013-05-07','11:10:00',2.44),('8975','2013-05-07','11:15:00',6.3),('8975','2013-05-07','11:20:00',1.61),('8975','2013-05-07','11:25:00',1.79),('8975','2013-05-07','11:30:00',6.43),('8975','2013-05-07','11:35:00',7.71),('8975','2013-05-07','11:40:00',7.61),('8975','2013-05-07','11:45:00',7.74),('8975','2013-05-07','11:50:00',8.05),('8975','2013-05-07','11:55:00',5.8),('8975','2013-05-07','12:00:00',2.14),('8975','2013-05-07','12:05:00',1.23),('8975','2013-05-07','12:20:00',1.29),('8975','2013-05-07','12:25:00',2.3),('8975','2013-05-07','12:30:00',3.66),('8975','2013-05-07','12:35:00',2.96),('8975','2013-05-07','12:40:00',2.52),('8975','2013-05-07','12:45:00',1.47),('8975','2013-05-07','12:50:00',1.62),('8975','2013-05-07','12:55:00',1.47),('8975','2013-05-07','13:00:00',1.33),('8975','2013-05-07','13:05:00',1.49),('8975','2013-05-07','13:10:00',1.83),('8975','2013-05-07','13:15:00',2.07),('8975','2013-05-07','13:20:00',2.15),('8975','2013-05-07','13:25:00',2.95),('8975','2013-05-07','13:30:00',7.39),('8975','2013-05-07','13:35:00',5.22),('8975','2013-05-07','13:40:00',2.21),('8975','2013-05-07','13:45:00',5.68),('8975','2013-05-07','13:50:00',8.23),('8975','2013-05-07','13:55:00',6.89),('8975','2013-05-07','14:00:00',4.28),('8975','2013-05-07','14:05:00',7.75),('8975','2013-05-07','14:10:00',5.27),('8975','2013-05-07','14:15:00',2.5),('8975','2013-05-07','14:20:00',4.31),('8975','2013-05-07','14:25:00',5.73),('8975','2013-05-07','14:30:00',5.78),('8975','2013-05-07','14:35:00',2.63),('8975','2013-05-07','14:40:00',6.67),('8975','2013-05-07','14:45:00',5.12),('8975','2013-05-07','14:50:00',4.34),('8975','2013-05-07','14:55:00',5.99),('8975','2013-05-07','15:00:00',5.76),('8975','2013-05-07','15:05:00',5.63),('8975','2013-05-07','15:10:00',5.44),('8975','2013-05-07','15:15:00',5.31),('8975','2013-05-07','15:20:00',5.03),('8975','2013-05-07','15:25:00',5.22),('8975','2013-05-07','15:30:00',5.18),('8975','2013-05-07','15:35:00',4.98),('8975','2013-05-07','15:40:00',4.87),('8975','2013-05-07','15:45:00',4.75),('8975','2013-05-07','15:50:00',4.64),('8975','2013-05-07','15:55:00',4.5),('8975','2013-05-07','16:00:00',4.41),('8975','2013-05-07','16:05:00',4.31),('8975','2013-05-07','16:10:00',4.21),('8975','2013-05-07','16:15:00',4.09),('8975','2013-05-07','16:20:00',3.98),('8975','2013-05-07','16:25:00',3.82),('8975','2013-05-07','16:30:00',3.78),('8975','2013-05-07','16:35:00',3.7),('8975','2013-05-07','16:40:00',3.08),('8975','2013-05-07','16:45:00',2.75),('8975','2013-05-07','16:50:00',1.69),('8975','2013-05-07','16:55:00',1.5),('8975','2013-05-07','17:00:00',2.68),('8975','2013-05-07','17:05:00',3.46),('8975','2013-05-07','17:10:00',2.42),('8975','2013-05-07','17:15:00',2.64),('8975','2013-05-07','17:20:00',2.73),('8975','2013-05-07','17:25:00',2.84),('8975','2013-05-07','17:30:00',2.73),('8975','2013-05-07','17:35:00',2.55),('8975','2013-05-07','17:40:00',2.54),('8975','2013-05-07','17:45:00',2.67),('8975','2013-05-07','17:50:00',2.62),('8975','2013-05-07','17:55:00',2.59),('8975','2013-05-07','18:00:00',2.43),('8975','2013-05-07','18:05:00',1.45),('8975','2013-05-07','18:10:00',1.5),('8975','2013-05-07','18:15:00',1.7),('8975','2013-05-07','18:20:00',1.83),('8975','2013-05-07','18:25:00',1.75),('8975','2013-05-07','18:30:00',1.55),('8975','2013-05-07','18:35:00',1.1),('8975','2013-05-07','18:40:00',1.14),('8975','2013-05-07','18:50:00',1.1),('8975','2013-05-07','18:55:00',1.02),('8975','2013-05-06','06:35:00',1.18),('8975','2013-05-06','06:40:00',1.35),('8975','2013-05-06','06:55:00',1.09),('8975','2013-05-06','07:00:00',1.75),('8975','2013-05-06','07:05:00',1.52),('8975','2013-05-06','07:10:00',2.3),('8975','2013-05-06','07:15:00',2.37),('8975','2013-05-06','07:20:00',2.67),('8975','2013-05-06','07:25:00',2.8),('8975','2013-05-06','07:30:00',2.66),('8975','2013-05-06','07:35:00',3.02),('8975','2013-05-06','07:40:00',2.82),('8975','2013-05-06','07:45:00',2.9),('8975','2013-05-06','07:50:00',3.03),('8975','2013-05-06','07:55:00',3.11),('8975','2013-05-06','08:00:00',3.64),('8975','2013-05-06','08:05:00',3.71),('8975','2013-05-06','08:10:00',3.84),('8975','2013-05-06','08:15:00',3.97),('8975','2013-05-06','08:20:00',4.1),('8975','2013-05-06','08:25:00',4.18),('8975','2013-05-06','08:30:00',4.31),('8975','2013-05-06','08:35:00',4.44),('8975','2013-05-06','08:40:00',4.45),('8975','2013-05-06','08:45:00',4.68),('8975','2013-05-06','08:50:00',4.51),('8975','2013-05-06','08:55:00',4.5),('8975','2013-05-06','09:00:00',4.9),('8975','2013-05-06','09:05:00',4.02),('8975','2013-05-06','09:10:00',2.74),('8975','2013-05-06','09:15:00',2.52),('8975','2013-05-06','09:20:00',1.67),('8975','2013-05-06','09:25:00',3.59),('8975','2013-05-06','09:30:00',2.28),('8975','2013-05-06','09:35:00',3.19),('8975','2013-05-06','09:40:00',5.36),('8975','2013-05-06','09:45:00',7.36),('8975','2013-05-06','09:50:00',3.22),('8975','2013-05-06','09:55:00',3.45),('8975','2013-05-06','10:00:00',5.42),('8975','2013-05-06','10:05:00',1.7),('8975','2013-05-06','10:10:00',1.48),('8975','2013-05-06','10:15:00',1.81),('8975','2013-05-06','10:20:00',1.28),('8975','2013-05-06','10:25:00',1.03),('8975','2013-05-06','10:45:00',1.01),('8975','2013-05-06','10:50:00',1.13),('8975','2013-05-06','10:55:00',1.21),('8975','2013-05-06','11:00:00',1.55),('8975','2013-05-06','11:05:00',2.38),('8975','2013-05-06','11:10:00',4.26),('8975','2013-05-06','11:15:00',6.32),('8975','2013-05-06','11:20:00',4.13),('8975','2013-05-06','11:25:00',1.5),('8975','2013-05-06','11:30:00',1.6),('8975','2013-05-06','11:35:00',1),('8975','2013-05-06','11:55:00',1.08),('8975','2013-05-06','12:00:00',1.08),('8975','2013-05-06','12:05:00',1.04),('8975','2013-05-06','12:10:00',1.15),('8975','2013-05-06','12:15:00',1.25),('8975','2013-05-06','12:20:00',1.17),('8975','2013-05-06','12:25:00',1.13),('8975','2013-05-06','12:45:00',1.11),('8975','2013-05-06','12:50:00',1.5),('8975','2013-05-06','12:55:00',1.73),('8975','2013-05-06','13:00:00',3.05),('8975','2013-05-06','13:05:00',4.71),('8975','2013-05-06','13:10:00',7.82),('8975','2013-05-06','13:15:00',7.16),('8975','2013-05-06','13:20:00',5.28),('8975','2013-05-06','13:25:00',4.08),('8975','2013-05-06','13:30:00',7.42),('8975','2013-05-06','13:35:00',7.87),('8975','2013-05-06','13:40:00',7.61),('8975','2013-05-06','13:45:00',7.22),('8975','2013-05-06','13:50:00',7.15),('8975','2013-05-06','13:55:00',6.97),('8975','2013-05-06','14:00:00',6.76),('8975','2013-05-06','14:05:00',6.68),('8975','2013-05-06','14:10:00',6.64),('8975','2013-05-06','14:15:00',6.76),('8975','2013-05-06','14:20:00',5),('8975','2013-05-06','14:25:00',4.67),('8975','2013-05-06','14:30:00',5.33),('8975','2013-05-06','14:35:00',7.08),('8975','2013-05-06','14:40:00',5.39),('8975','2013-05-06','14:45:00',6.4),('8975','2013-05-06','14:50:00',3.33),('8975','2013-05-06','14:55:00',6.59),('8975','2013-05-06','15:00:00',5.06),('8975','2013-05-06','15:05:00',6),('8975','2013-05-06','15:10:00',5.77),('8975','2013-05-06','15:15:00',5.79),('8975','2013-05-06','15:20:00',5.98),('8975','2013-05-06','15:25:00',6.09),('8975','2013-05-06','15:30:00',5.3),('8975','2013-05-06','15:35:00',3.51),('8975','2013-05-06','15:40:00',2.52),('8975','2013-05-06','15:45:00',2.21),('8975','2013-05-06','15:50:00',2.18),('8975','2013-05-06','15:55:00',3.83),('8975','2013-05-06','16:00:00',4.61),('8975','2013-05-06','16:05:00',2.36),('8975','2013-05-06','16:10:00',2.73),('8975','2013-05-06','16:15:00',5.13),('8975','2013-05-06','16:20:00',2.62),('8975','2013-05-06','16:25:00',4.82),('8975','2013-05-06','16:30:00',4.86),('8975','2013-05-06','16:35:00',4.52),('8975','2013-05-06','16:40:00',4.63),('8975','2013-05-06','16:45:00',3.87),('8975','2013-05-06','16:50:00',4.57),('8975','2013-05-06','16:55:00',3.69),('8975','2013-05-06','17:00:00',3.87),('8975','2013-05-06','17:05:00',3.13),('8975','2013-05-06','17:10:00',1.91),('8975','2013-05-06','17:15:00',1.81),('8975','2013-05-06','17:20:00',2.07),('8975','2013-05-06','17:25:00',1.94),('8975','2013-05-06','17:30:00',1.72),('8975','2013-05-06','17:35:00',1.59),('8975','2013-05-06','17:40:00',1.49),('8975','2013-05-06','17:45:00',1.4),('8975','2013-05-06','17:50:00',1.2),('8975','2013-05-06','18:45:00',1.54),('8975','2013-05-05','08:15:00',1.13),('8975','2013-05-05','08:20:00',1.38),('8975','2013-05-05','08:25:00',1.88),('8975','2013-05-05','08:30:00',2.09),('8975','2013-05-05','08:35:00',1.97),('8975','2013-05-05','08:40:00',1.43),('8975','2013-05-05','08:45:00',1.56),('8975','2013-05-05','08:50:00',3.56),('8975','2013-05-05','08:55:00',3.42),('8975','2013-05-05','09:00:00',3.5),('8975','2013-05-05','09:05:00',2.64),('8975','2013-05-05','09:10:00',3.22),('8975','2013-05-05','09:15:00',1.87),('8975','2013-05-05','09:20:00',2.22),('8975','2013-05-05','09:25:00',1.82),('8975','2013-05-05','09:30:00',1.3),('8975','2013-05-05','09:50:00',1.48),('8975','2013-05-05','09:55:00',2.41),('8975','2013-05-05','10:00:00',3.38),('8975','2013-05-05','10:05:00',1.82),('8975','2013-05-05','10:10:00',1.86),('8975','2013-05-05','10:15:00',3.48),('8975','2013-05-05','10:20:00',3.65),('8975','2013-05-05','10:25:00',3.47),('8975','2013-05-05','10:30:00',3.52),('8975','2013-05-05','10:35:00',3.1),('8975','2013-05-05','10:40:00',2.97),('8975','2013-05-05','10:45:00',4.53),('8975','2013-05-05','10:50:00',2.95),('8975','2013-05-05','10:55:00',3.55),('8975','2013-05-05','11:00:00',3.34),('8975','2013-05-05','11:05:00',3.41),('8975','2013-05-05','11:10:00',3.03),('8975','2013-05-05','11:15:00',2.8),('8975','2013-05-05','11:20:00',3.47),('8975','2013-05-05','11:25:00',3.3),('8975','2013-05-05','11:30:00',2.01),('8975','2013-05-05','11:35:00',3.97),('8975','2013-05-05','11:40:00',3.7),('8975','2013-05-05','11:45:00',6.02),('8975','2013-05-05','11:50:00',2.5),('8975','2013-05-05','11:55:00',2.84),('8975','2013-05-05','12:00:00',4.13),('8975','2013-05-05','12:05:00',3.88),('8975','2013-05-05','12:10:00',4.47),('8975','2013-05-05','12:15:00',2.99),('8975','2013-05-05','12:20:00',7.11),('8975','2013-05-05','12:25:00',4.18),('8975','2013-05-05','12:30:00',5.94),('8975','2013-05-05','12:35:00',6.66),('8975','2013-05-05','12:40:00',3.62),('8975','2013-05-05','12:45:00',3.85),('8975','2013-05-05','12:50:00',3.76),('8975','2013-05-05','12:55:00',5.96),('8975','2013-05-05','13:00:00',6.39),('8975','2013-05-05','13:05:00',7.85),('8975','2013-05-05','13:10:00',6.48),('8975','2013-05-05','13:15:00',5.73),('8975','2013-05-05','13:20:00',6.47),('8975','2013-05-05','13:25:00',6.67),('8975','2013-05-05','13:30:00',7.89),('8975','2013-05-05','13:35:00',6.32),('8975','2013-05-05','13:40:00',7.13),('8975','2013-05-05','13:45:00',7.03),('8975','2013-05-05','13:50:00',6.05),('8975','2013-05-05','13:55:00',5.28),('8975','2013-05-05','14:00:00',6.83),('8975','2013-05-05','14:05:00',4.94),('8975','2013-05-05','14:10:00',6.38),('8975','2013-05-05','14:15:00',4.24),('8975','2013-05-05','14:20:00',6.28),('8975','2013-05-05','14:25:00',4.27),('8975','2013-05-05','14:30:00',5.64),('8975','2013-05-05','14:35:00',6.95),('8975','2013-05-05','14:40:00',5.31),('8975','2013-05-05','14:45:00',5.04),('8975','2013-05-05','14:50:00',3.3),('8975','2013-05-05','14:55:00',6.46),('8975','2013-05-05','15:00:00',3.35),('8975','2013-05-05','15:05:00',4.36),('8975','2013-05-05','15:10:00',5.49),('8975','2013-05-05','15:15:00',4.06),('8975','2013-05-05','15:20:00',4.6),('8975','2013-05-05','15:25:00',5.28),('8975','2013-05-05','15:30:00',3.31),('8975','2013-05-05','15:35:00',3.04),('8975','2013-05-05','15:40:00',3.29),('8975','2013-05-05','15:45:00',3.82),('8975','2013-05-05','15:50:00',4.65),('8975','2013-05-05','15:55:00',2.11),('8975','2013-05-05','16:00:00',3),('8975','2013-05-05','16:05:00',2.08),('8975','2013-05-05','16:10:00',2.66),('8975','2013-05-05','16:15:00',3.35),('8975','2013-05-05','16:20:00',3.11),('8975','2013-05-05','16:25:00',3.11),('8975','2013-05-05','16:30:00',2.22),('8975','2013-05-05','16:35:00',2.92),('8975','2013-05-05','16:40:00',1.82),('8975','2013-05-05','16:45:00',3.4),('8975','2013-05-05','16:50:00',3.38),('8975','2013-05-05','16:55:00',2.66),('8975','2013-05-05','17:00:00',1.17),('8975','2013-05-05','17:10:00',2.12),('8975','2013-05-05','17:15:00',3.4),('8975','2013-05-05','17:20:00',1.91),('8975','2013-05-05','17:25:00',1.62),('8975','2013-05-05','17:30:00',1.02),('8975','2013-05-05','17:35:00',1.41),('8975','2013-05-05','17:40:00',2.08),('8975','2013-05-05','17:45:00',2.14),('8975','2013-05-05','17:50:00',1.14),('8975','2013-05-05','17:55:00',1.02),('8975','2013-05-05','18:00:00',1.39),('8975','2013-05-05','18:05:00',1.54),('8975','2013-05-05','18:10:00',1.43),('8975','2013-05-05','18:15:00',1.15),('8975','2013-05-05','18:20:00',1.91),('8975','2013-05-05','18:25:00',1.25),('8975','2013-05-04','07:10:00',1.32),('8975','2013-05-04','07:15:00',1.93),('8975','2013-05-04','07:20:00',2.08),('8975','2013-05-04','07:25:00',1.37),('8975','2013-05-04','07:30:00',1.63),('8975','2013-05-04','07:35:00',1.26),('8975','2013-05-04','07:40:00',2.2),('8975','2013-05-04','07:45:00',2.77),('8975','2013-05-04','07:50:00',2.35),('8975','2013-05-04','07:55:00',2.84),('8975','2013-05-04','08:00:00',3.04),('8975','2013-05-04','08:05:00',3.34),('8975','2013-05-04','08:10:00',3.45),('8975','2013-05-04','08:15:00',3.59),('8975','2013-05-04','08:20:00',4.02),('8975','2013-05-04','08:25:00',4.22),('8975','2013-05-04','08:30:00',4.28),('8975','2013-05-04','08:35:00',4.14),('8975','2013-05-04','08:40:00',3.78),('8975','2013-05-04','08:45:00',2.72),('8975','2013-05-04','08:50:00',2.84),('8975','2013-05-04','08:55:00',2.34),('8975','2013-05-04','09:00:00',2.42),('8975','2013-05-04','09:05:00',2.4),('8975','2013-05-04','09:10:00',2.57),('8975','2013-05-04','09:15:00',2.26),('8975','2013-05-04','09:20:00',2.63),('8975','2013-05-04','09:25:00',2.93),('8975','2013-05-04','09:30:00',2.33),('8975','2013-05-04','09:35:00',3.63),('8975','2013-05-04','09:40:00',4.17),('8975','2013-05-04','09:45:00',5.64),('8975','2013-05-04','09:50:00',4.69),('8975','2013-05-04','09:55:00',4.99),('8975','2013-05-04','10:00:00',4.59),('8975','2013-05-04','10:05:00',4.82),('8975','2013-05-04','10:10:00',4.01),('8975','2013-05-04','10:15:00',5.63),('8975','2013-05-04','10:20:00',5.46),('8975','2013-05-04','10:25:00',4.37),('8975','2013-05-04','10:30:00',4.69),('8975','2013-05-04','10:35:00',5.81),('8975','2013-05-04','10:40:00',6.24),('8975','2013-05-04','10:45:00',4.92),('8975','2013-05-04','10:50:00',4.07),('8975','2013-05-04','10:55:00',2.94),('8975','2013-05-04','11:00:00',2.71),('8975','2013-05-04','11:05:00',3.51),('8975','2013-05-04','11:10:00',2.93),('8975','2013-05-04','11:15:00',3.14),('8975','2013-05-04','11:20:00',4.79),('8975','2013-05-04','11:25:00',6.71),('8975','2013-05-04','11:30:00',4.83),('8975','2013-05-04','11:35:00',6.3),('8975','2013-05-04','11:40:00',4.62),('8975','2013-05-04','11:45:00',4.43),('8975','2013-05-04','11:50:00',5.24),('8975','2013-05-04','11:55:00',4.24),('8975','2013-05-04','12:00:00',4.37),('8975','2013-05-04','12:05:00',4.27),('8975','2013-05-04','12:10:00',4.75),('8975','2013-05-04','12:15:00',4.96),('8975','2013-05-04','12:20:00',4.92),('8975','2013-05-04','12:25:00',7.56),('8975','2013-05-04','12:30:00',6.87),('8975','2013-05-04','12:35:00',6.62),('8975','2013-05-04','12:40:00',7.05),('8975','2013-05-04','12:45:00',6.74),('8975','2013-05-04','12:50:00',4.71),('8975','2013-05-04','12:55:00',5.3),('8975','2013-05-04','13:00:00',5.13),('8975','2013-05-04','13:05:00',3.5),('8975','2013-05-04','13:10:00',3.96),('8975','2013-05-04','13:15:00',6.1),('8975','2013-05-04','13:20:00',6.79),('8975','2013-05-04','13:25:00',5.89),('8975','2013-05-04','13:30:00',4.82),('8975','2013-05-04','13:35:00',7.21),('8975','2013-05-04','13:40:00',6.62),('8975','2013-05-04','13:45:00',6.45),('8975','2013-05-04','13:50:00',6.55),('8975','2013-05-04','13:55:00',6.44),('8975','2013-05-04','14:00:00',6.57),('8975','2013-05-04','14:05:00',6.17),('8975','2013-05-04','14:10:00',4.9),('8975','2013-05-04','14:15:00',5.65),('8975','2013-05-04','14:20:00',6.27),('8975','2013-05-04','14:25:00',5.79),('8975','2013-05-04','14:30:00',5.63),('8975','2013-05-04','14:35:00',5.55),('8975','2013-05-04','14:40:00',5.44),('8975','2013-05-04','14:45:00',5.38),('8975','2013-05-04','14:50:00',5.33),('8975','2013-05-04','14:55:00',5.22),('8975','2013-05-04','15:00:00',5.17),('8975','2013-05-04','15:05:00',5.09),('8975','2013-05-04','15:10:00',4.98),('8975','2013-05-04','15:15:00',4.91),('8975','2013-05-04','15:20:00',4.86),('8975','2013-05-04','15:25:00',4.76),('8975','2013-05-04','15:30:00',4.69),('8975','2013-05-04','15:35:00',4.58),('8975','2013-05-04','15:40:00',4.44),('8975','2013-05-04','15:45:00',4.36),('8975','2013-05-04','15:50:00',4.25),('8975','2013-05-04','15:55:00',4.14),('8975','2013-05-04','16:00:00',4.04),('8975','2013-05-04','16:05:00',3.93),('8975','2013-05-04','16:10:00',3.81),('8975','2013-05-04','16:15:00',3.71),('8975','2013-05-04','16:20:00',3.61),('8975','2013-05-04','16:25:00',3.49),('8975','2013-05-04','16:30:00',3.38),('8975','2013-05-04','16:35:00',3.27),('8975','2013-05-04','16:40:00',3.15),('8975','2013-05-04','16:45:00',3.03),('8975','2013-05-04','16:50:00',2.89),('8975','2013-05-04','16:55:00',2.76),('8975','2013-05-04','17:00:00',2.64),('8975','2013-05-04','17:05:00',2.52),('8975','2013-05-04','17:10:00',2.4),('8975','2013-05-04','17:15:00',2.32),('8975','2013-05-04','17:20:00',2.21),('8975','2013-05-04','17:25:00',2.09),('8975','2013-05-04','17:30:00',1.93),('8975','2013-05-04','17:35:00',1.66),('8975','2013-05-04','17:40:00',1.61),('8975','2013-05-04','17:45:00',1.63),('8975','2013-05-04','17:50:00',1.4),('8975','2013-05-04','17:55:00',1.23),('8975','2013-05-04','18:00:00',1.51),('8975','2013-05-04','18:05:00',1.36),('8975','2013-05-04','18:10:00',1.19),('8975','2013-05-04','18:15:00',1.2),('8975','2013-05-04','18:20:00',1.23),('8975','2013-05-04','18:25:00',1.07),('8975','2013-05-04','18:30:00',1.04),('8975','2013-05-04','18:35:00',1.07),('8975','2013-05-04','18:40:00',1.07),('8975','2013-05-03','07:00:00',1.06),('8975','2013-05-03','07:05:00',1.2),('8975','2013-05-03','07:10:00',1.47),('8975','2013-05-03','07:15:00',1.07),('8975','2013-05-03','07:35:00',2.35),('8975','2013-05-03','07:40:00',2.52),('8975','2013-05-03','07:45:00',2.45),('8975','2013-05-03','07:50:00',2.8),('8975','2013-05-03','07:55:00',3.13),('8975','2013-05-03','08:00:00',3.19),('8975','2013-05-03','08:05:00',3.32),('8975','2013-05-03','08:10:00',3.41),('8975','2013-05-03','08:15:00',3.53),('8975','2013-05-03','08:20:00',3.61),('8975','2013-05-03','08:25:00',3.67),('8975','2013-05-03','08:30:00',3.82),('8975','2013-05-03','08:35:00',3.91),('8975','2013-05-03','08:40:00',4.03),('8975','2013-05-03','08:45:00',4.13),('8975','2013-05-03','08:50:00',4.22),('8975','2013-05-03','08:55:00',4.26),('8975','2013-05-03','09:00:00',4.31),('8975','2013-05-03','09:05:00',4.43),('8975','2013-05-03','09:10:00',4.49),('8975','2013-05-03','09:15:00',4.61),('8975','2013-05-03','09:20:00',4.72),('8975','2013-05-03','09:25:00',4.72),('8975','2013-05-03','09:30:00',4.73),('8975','2013-05-03','09:35:00',5.05),('8975','2013-05-03','09:40:00',5.12),('8975','2013-05-03','09:45:00',5.26),('8975','2013-05-03','09:50:00',5.35),('8975','2013-05-03','09:55:00',5.42),('8975','2013-05-03','10:00:00',5.53),('8975','2013-05-03','10:05:00',5.55),('8975','2013-05-03','10:10:00',5.64),('8975','2013-05-03','10:15:00',5.73),('8975','2013-05-03','10:20:00',5.79),('8975','2013-05-03','10:25:00',5.82),('8975','2013-05-03','10:30:00',5.87),('8975','2013-05-03','10:35:00',5.86),('8975','2013-05-03','10:40:00',5.91),('8975','2013-05-03','10:45:00',5.87),('8975','2013-05-03','10:50:00',5.69),('8975','2013-05-03','10:55:00',5.68),('8975','2013-05-03','11:00:00',5.68),('8975','2013-05-03','11:05:00',5.54),('8975','2013-05-03','11:10:00',5.29),('8975','2013-05-03','11:15:00',5.22),('8975','2013-05-03','11:20:00',5.71),('8975','2013-05-03','11:25:00',5.42),('8975','2013-05-03','11:30:00',5.57),('8975','2013-05-03','11:35:00',5.48),('8975','2013-05-03','11:40:00',5.48),('8975','2013-05-03','11:45:00',5.65),('8975','2013-05-03','11:50:00',5.51),('8975','2013-05-03','11:55:00',5.53),('8975','2013-05-03','12:00:00',5.47),('8975','2013-05-03','12:05:00',5.77),('8975','2013-05-03','12:10:00',5.69),('8975','2013-05-03','12:15:00',5.91),('8975','2013-05-03','12:20:00',5.93),('8975','2013-05-03','12:25:00',5.98),('8975','2013-05-03','12:30:00',6.07),('8975','2013-05-03','12:35:00',6.07),('8975','2013-05-03','12:40:00',6.04),('8975','2013-05-03','12:45:00',5.95),('8975','2013-05-03','12:50:00',5.65),('8975','2013-05-03','12:55:00',5.43),('8975','2013-05-03','13:00:00',5.19),('8975','2013-05-03','13:05:00',5.24),('8975','2013-05-03','13:10:00',6.11),('8975','2013-05-03','13:15:00',6.15),('8975','2013-05-03','13:20:00',6.06),('8975','2013-05-03','13:25:00',5.66),('8975','2013-05-03','13:30:00',5.9),('8975','2013-05-03','13:35:00',5.52),('8975','2013-05-03','13:40:00',5.58),('8975','2013-05-03','13:45:00',5.06),('8975','2013-05-03','13:50:00',5.2),('8975','2013-05-03','13:55:00',4.83),('8975','2013-05-03','14:00:00',5.23),('8975','2013-05-03','14:05:00',5.24),('8975','2013-05-03','14:10:00',5.04),('8975','2013-05-03','14:15:00',5.28),('8975','2013-05-03','14:20:00',5.09),('8975','2013-05-03','14:25:00',4.85),('8975','2013-05-03','14:30:00',4.92),('8975','2013-05-03','14:35:00',4.8),('8975','2013-05-03','14:40:00',4.96),('8975','2013-05-03','14:45:00',4.7),('8975','2013-05-03','14:50:00',4.67),('8975','2013-05-03','14:55:00',4.7),('8975','2013-05-03','15:00:00',4.84),('8975','2013-05-03','15:05:00',4.77),('8975','2013-05-03','15:10:00',4.37),('8975','2013-05-03','15:15:00',4.58),('8975','2013-05-03','15:20:00',4.59),('8975','2013-05-03','15:25:00',4.59),('8975','2013-05-03','15:30:00',4.52),('8975','2013-05-03','15:35:00',4.2),('8975','2013-05-03','15:40:00',4.36),('8975','2013-05-03','15:45:00',4.23),('8975','2013-05-03','15:50:00',4.11),('8975','2013-05-03','15:55:00',3.99),('8975','2013-05-03','16:00:00',3.88),('8975','2013-05-03','16:05:00',3.76),('8975','2013-05-03','16:10:00',3.57),('8975','2013-05-03','16:15:00',3.49),('8975','2013-05-03','16:20:00',3.46),('8975','2013-05-03','16:25:00',3.35),('8975','2013-05-03','16:30:00',3.2),('8975','2013-05-03','16:35:00',3.01),('8975','2013-05-03','16:40:00',2.6),('8975','2013-05-03','16:45:00',2.63),('8975','2013-05-03','16:50:00',2.7),('8975','2013-05-03','16:55:00',2.6),('8975','2013-05-03','17:00:00',2.54),('8975','2013-05-03','17:05:00',2.2),('8975','2013-05-03','17:10:00',1.89),('8975','2013-05-03','17:15:00',2.19),('8975','2013-05-03','17:20:00',2.15),('8975','2013-05-03','17:25:00',2.02),('8975','2013-05-03','17:30:00',1.85),('8975','2013-05-03','17:35:00',1.8),('8975','2013-05-03','17:40:00',1.72),('8975','2013-05-03','17:45:00',1.68),('8975','2013-05-03','17:50:00',1.62),('8975','2013-05-03','17:55:00',1.54),('8975','2013-05-03','18:00:00',1.5),('8975','2013-05-03','18:05:00',1.44),('8975','2013-05-03','18:10:00',1.2),('8975','2013-05-03','18:15:00',1.08),('8975','2013-05-02','07:25:00',1.14),('8975','2013-05-02','07:30:00',1),('8975','2013-05-02','07:45:00',1.12),('8975','2013-05-02','07:50:00',1.48),('8975','2013-05-02','07:55:00',1.7),('8975','2013-05-02','08:00:00',2.1),('8975','2013-05-02','08:05:00',3.22),('8975','2013-05-02','08:10:00',3.77),('8975','2013-05-02','08:15:00',3.95),('8975','2013-05-02','08:20:00',3.93),('8975','2013-05-02','08:25:00',3.96),('8975','2013-05-02','08:30:00',4.09),('8975','2013-05-02','08:35:00',4.19),('8975','2013-05-02','08:40:00',4.31),('8975','2013-05-02','08:45:00',4.29),('8975','2013-05-02','08:50:00',4.19),('8975','2013-05-02','08:55:00',4.23),('8975','2013-05-02','09:00:00',4.54),('8975','2013-05-02','09:05:00',4.68),('8975','2013-05-02','09:10:00',4.79),('8975','2013-05-02','09:15:00',4.91),('8975','2013-05-02','09:20:00',4.97),('8975','2013-05-02','09:25:00',5.08),('8975','2013-05-02','09:30:00',5.21),('8975','2013-05-02','09:35:00',5.28),('8975','2013-05-02','09:40:00',5.35),('8975','2013-05-02','09:45:00',5.41),('8975','2013-05-02','09:50:00',5.45),('8975','2013-05-02','09:55:00',5.56),('8975','2013-05-02','10:00:00',5.57),('8975','2013-05-02','10:05:00',5.71),('8975','2013-05-02','10:10:00',5.8),('8975','2013-05-02','10:15:00',5.84),('8975','2013-05-02','10:20:00',5.9),('8975','2013-05-02','10:25:00',5.94),('8975','2013-05-02','10:30:00',6.02),('8975','2013-05-02','10:35:00',6.05),('8975','2013-05-02','10:40:00',6.12),('8975','2013-05-02','10:45:00',6.16),('8975','2013-05-02','10:50:00',6.22),('8975','2013-05-02','10:55:00',6.27),('8975','2013-05-02','11:00:00',6.28),('8975','2013-05-02','11:05:00',6.31),('8975','2013-05-02','11:10:00',6.34),('8975','2013-05-02','11:15:00',6.36),('8975','2013-05-02','11:20:00',6.37),('8975','2013-05-02','11:25:00',6.38),('8975','2013-05-02','11:30:00',6.41),('8975','2013-05-02','11:35:00',6.42),('8975','2013-05-02','11:40:00',6.48),('8975','2013-05-02','11:45:00',6.47),('8975','2013-05-02','11:50:00',6.48),('8975','2013-05-02','11:55:00',6.48),('8975','2013-05-02','12:00:00',6.47),('8975','2013-05-02','12:05:00',6.46),('8975','2013-05-02','12:10:00',6.51),('8975','2013-05-02','12:15:00',6.46),('8975','2013-05-02','12:20:00',6.36),('8975','2013-05-02','12:25:00',6.14),('8975','2013-05-02','12:30:00',6.2),('8975','2013-05-02','12:35:00',5.24),('8975','2013-05-02','12:40:00',5.6),('8975','2013-05-02','12:45:00',6.02),('8975','2013-05-02','12:50:00',6.32),('8975','2013-05-02','12:55:00',6.16),('8975','2013-05-02','13:00:00',6.23),('8975','2013-05-02','13:05:00',5.42),('8975','2013-05-02','13:10:00',6.13),('8975','2013-05-02','13:15:00',6.1),('8975','2013-05-02','13:20:00',6.1),('8975','2013-05-02','13:25:00',6.05),('8975','2013-05-02','13:30:00',6.06),('8975','2013-05-02','13:35:00',5.92),('8975','2013-05-02','13:40:00',5.8),('8975','2013-05-02','13:45:00',5.68),('8975','2013-05-02','13:50:00',5.78),('8975','2013-05-02','13:55:00',5.79),('8975','2013-05-02','14:00:00',5.6),('8975','2013-05-02','14:05:00',5.64),('8975','2013-05-02','14:10:00',5.46),('8975','2013-05-02','14:15:00',5.23),('8975','2013-05-02','14:20:00',5.45),('8975','2013-05-02','14:25:00',5.36),('8975','2013-05-02','14:30:00',5.3),('8975','2013-05-02','14:35:00',5.35),('8975','2013-05-02','14:40:00',5.27),('8975','2013-05-02','14:45:00',5.2),('8975','2013-05-02','14:50:00',5.18),('8975','2013-05-02','14:55:00',5.12),('8975','2013-05-02','15:00:00',5.05),('8975','2013-05-02','15:05:00',4.95),('8975','2013-05-02','15:10:00',4.89),('8975','2013-05-02','15:15:00',4.8),('8975','2013-05-02','15:20:00',4.74),('8975','2013-05-02','15:25:00',4.66),('8975','2013-05-02','15:30:00',4.58),('8975','2013-05-02','15:35:00',4.48),('8975','2013-05-02','15:40:00',4.39),('8975','2013-05-02','15:45:00',4.26),('8975','2013-05-02','15:50:00',4.15),('8975','2013-05-02','15:55:00',4.09),('8975','2013-05-02','16:00:00',3.99),('8975','2013-05-02','16:05:00',3.88),('8975','2013-05-02','16:10:00',3.79),('8975','2013-05-02','16:15:00',3.66),('8975','2013-05-02','16:20:00',3.47),('8975','2013-05-02','16:25:00',3.41),('8975','2013-05-02','16:30:00',3.36),('8975','2013-05-02','16:35:00',3.25),('8975','2013-05-02','16:40:00',3.13),('8975','2013-05-02','16:45:00',2.97),('8975','2013-05-02','16:50:00',2.87),('8975','2013-05-02','16:55:00',2.75),('8975','2013-05-02','17:00:00',2.62),('8975','2013-05-02','17:05:00',2.51),('8975','2013-05-02','17:10:00',2.38),('8975','2013-05-02','17:15:00',2.27),('8975','2013-05-02','17:20:00',2.16),('8975','2013-05-02','17:25:00',2.03),('8975','2013-05-02','17:30:00',1.92),('8975','2013-05-02','17:35:00',1.81),('8975','2013-05-02','17:40:00',1.72),('8975','2013-05-02','17:45:00',1.65),('8975','2013-05-02','17:50:00',1.57),('8975','2013-05-02','17:55:00',1.51),('8975','2013-05-02','18:00:00',1.44),('8975','2013-05-02','18:05:00',1.38),('8975','2013-05-02','18:10:00',1.33),('8975','2013-05-02','18:15:00',1.27),('8975','2013-05-02','18:20:00',1.2),('8975','2013-05-02','18:25:00',1.16),('8975','2013-05-02','18:30:00',1.11),('8975','2013-05-02','18:35:00',1.04),('8975','2013-05-01','08:40:00',1.49),('8975','2013-05-01','08:45:00',1.2),('8975','2013-05-01','08:50:00',1.36),('8975','2013-05-01','08:55:00',2.31),('8975','2013-05-01','09:00:00',3.37),('8975','2013-05-01','09:05:00',2.22),('8975','2013-05-01','09:10:00',1.42),('8975','2013-05-01','09:15:00',1.41),('8975','2013-05-01','09:20:00',1.9),('8975','2013-05-01','09:25:00',2.72),('8975','2013-05-01','09:30:00',3.29),('8975','2013-05-01','09:35:00',3.63),('8975','2013-05-01','09:40:00',3.09),('8975','2013-05-01','09:45:00',3.95),('8975','2013-05-01','09:50:00',2.07),('8975','2013-05-01','09:55:00',1.66),('8975','2013-05-01','10:00:00',1.84),('8975','2013-05-01','10:05:00',2.55),('8975','2013-05-01','10:10:00',2.31),('8975','2013-05-01','10:15:00',2.47),('8975','2013-05-01','10:20:00',2.57),('8975','2013-05-01','10:25:00',3.49),('8975','2013-05-01','10:30:00',5.08),('8975','2013-05-01','10:35:00',4.77),('8975','2013-05-01','10:40:00',6.44),('8975','2013-05-01','10:45:00',3.28),('8975','2013-05-01','10:50:00',6.26),('8975','2013-05-01','10:55:00',6.85),('8975','2013-05-01','11:00:00',6.66),('8975','2013-05-01','11:05:00',5.87),('8975','2013-05-01','11:10:00',4.88),('8975','2013-05-01','11:15:00',5.3),('8975','2013-05-01','11:20:00',5.92),('8975','2013-05-01','11:25:00',6.65),('8975','2013-05-01','11:30:00',6.48),('8975','2013-05-01','11:35:00',6.41),('8975','2013-05-01','11:40:00',6.36),('8975','2013-05-01','11:45:00',6.34),('8975','2013-05-01','11:50:00',6.35),('8975','2013-05-01','11:55:00',6.29),('8975','2013-05-01','12:00:00',6.22),('8975','2013-05-01','12:05:00',6.28),('8975','2013-05-01','12:10:00',6.32),('8975','2013-05-01','12:15:00',6.33),('8975','2013-05-01','12:20:00',6.29),('8975','2013-05-01','12:25:00',6.35),('8975','2013-05-01','12:30:00',6.42),('8975','2013-05-01','12:35:00',6.49),('8975','2013-05-01','12:40:00',6.47),('8975','2013-05-01','12:45:00',6.44),('8975','2013-05-01','12:50:00',6.5),('8975','2013-05-01','12:55:00',6.52),('8975','2013-05-01','13:00:00',6.54),('8975','2013-05-01','13:05:00',6.5),('8975','2013-05-01','13:10:00',6.53),('8975','2013-05-01','13:15:00',6.48),('8975','2013-05-01','13:20:00',6.49),('8975','2013-05-01','13:25:00',6.44),('8975','2013-05-01','13:30:00',6.38),('8975','2013-05-01','13:35:00',6.34),('8975','2013-05-01','13:40:00',6.23),('8975','2013-05-01','13:45:00',6.21),('8975','2013-05-01','13:50:00',6.19),('8975','2013-05-01','13:55:00',6.08),('8975','2013-05-01','14:00:00',6.02),('8975','2013-05-01','14:05:00',5.97),('8975','2013-05-01','14:10:00',5.91),('8975','2013-05-01','14:15:00',5.84),('8975','2013-05-01','14:20:00',5.77),('8975','2013-05-01','14:25:00',5.7),('8975','2013-05-01','14:30:00',5.61),('8975','2013-05-01','14:35:00',5.55),('8975','2013-05-01','14:40:00',5.49),('8975','2013-05-01','14:45:00',5.44),('8975','2013-05-01','14:50:00',5.37),('8975','2013-05-01','14:55:00',5.28),('8975','2013-05-01','15:00:00',5.17),('8975','2013-05-01','15:05:00',5.06),('8975','2013-05-01','15:10:00',4.97),('8975','2013-05-01','15:15:00',4.89),('8975','2013-05-01','15:20:00',4.76),('8975','2013-05-01','15:25:00',4.65),('8975','2013-05-01','15:30:00',4.51),('8975','2013-05-01','15:35:00',4.42),('8975','2013-05-01','15:40:00',4.28),('8975','2013-05-01','15:45:00',4.2),('8975','2013-05-01','15:50:00',4.11),('8975','2013-05-01','15:55:00',4.01),('8975','2013-05-01','16:00:00',3.91),('8975','2013-05-01','16:05:00',3.81),('8975','2013-05-01','16:10:00',3.71),('8975','2013-05-01','16:15:00',3.62),('8975','2013-05-01','16:20:00',3.5),('8975','2013-05-01','16:25:00',3.4),('8975','2013-05-01','16:30:00',3.28),('8975','2013-05-01','16:35:00',3.18),('8975','2013-05-01','16:40:00',3.08),('8975','2013-05-01','16:45:00',2.94),('8975','2013-05-01','16:50:00',2.83),('8975','2013-05-01','16:55:00',2.73),('8975','2013-05-01','17:00:00',2.62),('8975','2013-05-01','17:05:00',2.5),('8975','2013-05-01','17:10:00',2.4),('8975','2013-05-01','17:15:00',2.3),('8975','2013-05-01','17:20:00',2.18),('8975','2013-05-01','17:25:00',2.08),('8975','2013-05-01','17:30:00',1.97),('8975','2013-05-01','17:35:00',1.88),('8975','2013-05-01','17:40:00',1.8),('8975','2013-05-01','17:45:00',1.73),('8975','2013-05-01','17:50:00',1.64),('8975','2013-05-01','17:55:00',1.56),('8975','2013-05-01','18:00:00',1.5),('8975','2013-05-01','18:05:00',1.43),('8975','2013-05-01','18:10:00',1.38),('8975','2013-05-01','18:15:00',1.31),('8975','2013-05-01','18:20:00',1.27),('8975','2013-05-01','18:25:00',1.22),('8975','2013-05-01','18:30:00',1.17),('8975','2013-05-01','18:35:00',1.11),('8975','2013-05-01','18:40:00',1.05),('8975','2014-03-29','07:30:00',1.12),('8975','2014-03-29','07:35:00',1.23),('8975','2014-03-29','07:40:00',1.53),('8975','2014-03-29','07:45:00',1.57),('8975','2014-03-29','07:50:00',1.69),('8975','2014-03-29','07:55:00',1.84),('8975','2014-03-29','08:00:00',1.79),('8975','2014-03-29','08:05:00',1.78),('8975','2014-03-29','08:10:00',2.18),('8975','2014-03-29','08:15:00',2.39),('8975','2014-03-29','08:20:00',2.59),('8975','2014-03-29','08:25:00',2.71),('8975','2014-03-29','08:30:00',2.73),('8975','2014-03-29','08:35:00',2.65),('8975','2014-03-29','08:40:00',2.64),('8975','2014-03-29','08:45:00',2.46),('8975','2014-03-29','08:50:00',2.58),('8975','2014-03-29','08:55:00',2.67),('8975','2014-03-29','09:00:00',2.68),('8975','2014-03-29','09:05:00',2.61),('8975','2014-03-29','09:10:00',2.75),('8975','2014-03-29','09:15:00',2.99),('8975','2014-03-29','09:20:00',3.31),('8975','2014-03-29','09:25:00',3.72),('8975','2014-03-29','09:30:00',3.92),('8975','2014-03-29','09:35:00',4.14),('8975','2014-03-29','09:40:00',4.08),('8975','2014-03-29','09:45:00',3.95),('8975','2014-03-29','09:50:00',4.02),('8975','2014-03-29','09:55:00',4.16),('8975','2014-03-29','10:00:00',4.58),('8975','2014-03-29','10:05:00',4.68),('8975','2014-03-29','10:10:00',4.89),('8975','2014-03-29','10:15:00',5.03),('8975','2014-03-29','10:20:00',5.01),('8975','2014-03-29','10:25:00',4.97),('8975','2014-03-29','10:30:00',5.07),('8975','2014-03-29','10:35:00',5.14),('8975','2014-03-29','10:40:00',5.17),('8975','2014-03-29','10:45:00',5.12),('8975','2014-03-29','10:50:00',5.13),('8975','2014-03-29','10:55:00',5.12),('8975','2014-03-29','11:00:00',5.1),('8975','2014-03-29','11:05:00',5.02),('8975','2014-03-29','11:10:00',4.94),('8975','2014-03-29','11:15:00',5.21),('8975','2014-03-29','11:20:00',5.4),('8975','2014-03-29','11:25:00',5.42),('8975','2014-03-29','11:30:00',5.29),('8975','2014-03-29','11:35:00',5.41),('8975','2014-03-29','11:40:00',5.72),('8975','2014-03-29','11:45:00',5.87),('8975','2014-03-29','11:50:00',5.95),('8975','2014-03-29','11:55:00',5.94),('8975','2014-03-29','12:00:00',6.17),('8975','2014-03-29','12:05:00',6.27),('8975','2014-03-29','12:10:00',5.87),('8975','2014-03-29','12:15:00',5.98),('8975','2014-03-29','12:20:00',5.59),('8975','2014-03-29','12:25:00',5.44),('8975','2014-03-29','12:30:00',5.81),('8975','2014-03-29','12:35:00',6.01),('8975','2014-03-29','12:40:00',5.94),('8975','2014-03-29','12:45:00',5.99),('8975','2014-03-29','12:50:00',6.05),('8975','2014-03-29','12:55:00',6.04),('8975','2014-03-29','13:00:00',6.04),('8975','2014-03-29','13:05:00',6.05),('8975','2014-03-29','13:10:00',6.02),('8975','2014-03-29','13:15:00',6.03),('8975','2014-03-29','13:20:00',5.96),('8975','2014-03-29','13:25:00',5.86),('8975','2014-03-29','13:30:00',5.86),('8975','2014-03-29','13:35:00',5.84),('8975','2014-03-29','13:40:00',5.8),('8975','2014-03-29','13:45:00',5.36),('8975','2014-03-29','13:50:00',5.33),('8975','2014-03-29','13:55:00',5.31),('8975','2014-03-29','14:00:00',5.09),('8975','2014-03-29','14:05:00',5.06),('8975','2014-03-29','14:10:00',5.29),('8975','2014-03-29','14:15:00',5.27),('8975','2014-03-29','14:20:00',5.18),('8975','2014-03-29','14:25:00',4.83),('8975','2014-03-29','14:30:00',4.68),('8975','2014-03-29','14:35:00',4.36),('8975','2014-03-29','14:40:00',3.35),('8975','2014-03-29','14:45:00',2.43),('8975','2014-03-29','14:50:00',1.99),('8975','2014-03-29','14:55:00',2.84),('8975','2014-03-29','15:00:00',4.07),('8975','2014-03-29','15:05:00',4.36),('8975','2014-03-29','15:10:00',4.36),('8975','2014-03-29','15:15:00',4.32),('8975','2014-03-29','15:20:00',4.09),('8975','2014-03-29','15:25:00',3.96),('8975','2014-03-29','15:30:00',3.86),('8975','2014-03-29','15:35:00',3.94),('8975','2014-03-29','15:40:00',3.81),('8975','2014-03-29','15:45:00',3.74),('8975','2014-03-29','15:50:00',3.48),('8975','2014-03-29','15:55:00',3.23),('8975','2014-03-29','16:00:00',3.46),('8975','2014-03-29','16:05:00',3.3),('8975','2014-03-29','16:10:00',3.35),('8975','2014-03-29','16:15:00',3.3),('8975','2014-03-29','16:20:00',3.16),('8975','2014-03-29','16:25:00',2.97),('8975','2014-03-29','16:30:00',3.01),('8975','2014-03-29','16:35:00',2.79),('8975','2014-03-29','16:40:00',2.44),('8975','2014-03-29','16:45:00',2),('8975','2014-03-29','16:50:00',1.84),('8975','2014-03-29','16:55:00',1.85),('8975','2014-03-29','17:00:00',1.96),('8975','2014-03-29','17:05:00',2.11),('8975','2014-03-29','17:10:00',2.05),('8975','2014-03-29','17:15:00',1.93),('8975','2014-03-29','17:20:00',1.83),('8975','2014-03-29','17:25:00',1.73),('8975','2014-03-29','17:30:00',1.69),('8975','2014-03-29','17:35:00',1.59),('8975','2014-03-29','17:40:00',1.57),('8975','2014-03-29','17:45:00',1.39),('8975','2014-03-29','17:50:00',1.26),('8975','2014-03-29','17:55:00',1.18),('8975','2014-03-29','18:00:00',1.18),('8975','2014-03-29','18:05:00',1.22),('8975','2014-03-29','18:10:00',1),('8975','2013-04-30','07:10:00',1.02),('8975','2013-04-30','07:15:00',1.14),('8975','2013-04-30','07:20:00',1.23),('8975','2013-04-30','07:25:00',1.57),('8975','2013-04-30','07:30:00',1.73),('8975','2013-04-30','07:35:00',1.87),('8975','2013-04-30','07:40:00',2.05),('8975','2013-04-30','07:45:00',2.22),('8975','2013-04-30','07:50:00',2.36),('8975','2013-04-30','07:55:00',2.52),('8975','2013-04-30','08:00:00',2.63),('8975','2013-04-30','08:05:00',2.72),('8975','2013-04-30','08:10:00',2.84),('8975','2013-04-30','08:15:00',3.02),('8975','2013-04-30','08:20:00',3.19),('8975','2013-04-30','08:25:00',3.37),('8975','2013-04-30','08:30:00',3.52),('8975','2013-04-30','08:35:00',3.64),('8975','2013-04-30','08:40:00',3.75),('8975','2013-04-30','08:45:00',3.88),('8975','2013-04-30','08:50:00',4.01),('8975','2013-04-30','08:55:00',4.15),('8975','2013-04-30','09:00:00',4.25),('8975','2013-04-30','09:05:00',4.34),('8975','2013-04-30','09:10:00',4.39),('8975','2013-04-30','09:15:00',4.47),('8975','2013-04-30','09:20:00',4.52),('8975','2013-04-30','09:25:00',4.57),('8975','2013-04-30','09:30:00',4.6),('8975','2013-04-30','09:35:00',4.74),('8975','2013-04-30','09:40:00',4.81),('8975','2013-04-30','09:45:00',4.92),('8975','2013-04-30','09:50:00',4.97),('8975','2013-04-30','09:55:00',5.03),('8975','2013-04-30','10:00:00',5.03),('8975','2013-04-30','10:05:00',5.14),('8975','2013-04-30','10:10:00',5.35),('8975','2013-04-30','10:15:00',5.41),('8975','2013-04-30','10:20:00',5.43),('8975','2013-04-30','10:25:00',5.5),('8975','2013-04-30','10:30:00',5.51),('8975','2013-04-30','10:35:00',5.57),('8975','2013-04-30','10:40:00',5.9),('8975','2013-04-30','10:45:00',5.93),('8975','2013-04-30','10:50:00',5.93),('8975','2013-04-30','10:55:00',5.94),('8975','2013-04-30','11:00:00',5.98),('8975','2013-04-30','11:05:00',5.98),('8975','2013-04-30','11:10:00',6.09),('8975','2013-04-30','11:15:00',5.85),('8975','2013-04-30','11:20:00',5.31),('8975','2013-04-30','11:25:00',4.65),('8975','2013-04-30','11:30:00',4.39),('8975','2013-04-30','11:35:00',5.06),('8975','2013-04-30','11:40:00',5.14),('8975','2013-04-30','11:45:00',4.86),('8975','2013-04-30','11:50:00',6.36),('8975','2013-04-30','11:55:00',6.36),('8975','2013-04-30','12:00:00',6.26),('8975','2013-04-30','12:05:00',6.18),('8975','2013-04-30','12:10:00',6.14),('8975','2013-04-30','12:15:00',6.17),('8975','2013-04-30','12:20:00',6.23),('8975','2013-04-30','12:25:00',6.19),('8975','2013-04-30','12:30:00',6.22),('8975','2013-04-30','12:35:00',6.27),('8975','2013-04-30','12:40:00',5.86),('8975','2013-04-30','12:45:00',3.46),('8975','2013-04-30','12:50:00',2.6),('8975','2013-04-30','12:55:00',3.49),('8975','2013-04-30','13:00:00',2.88),('8975','2013-04-30','13:05:00',5.73),('8975','2013-04-30','13:10:00',5.94),('8975','2013-04-30','13:15:00',6.55),('8975','2013-04-30','13:20:00',6.41),('8975','2013-04-30','13:25:00',6.14),('8975','2013-04-30','13:30:00',6.97),('8975','2013-04-30','13:35:00',6),('8975','2013-04-30','13:40:00',6.48),('8975','2013-04-30','13:45:00',6.04),('8975','2013-04-30','13:50:00',5.25),('8975','2013-04-30','13:55:00',5.78),('8975','2013-04-30','14:00:00',5.59),('8975','2013-04-30','14:05:00',5.83),('8975','2013-04-30','14:10:00',4.9),('8975','2013-04-30','14:15:00',5.5),('8975','2013-04-30','14:20:00',5.87),('8975','2013-04-30','14:25:00',5.88),('8975','2013-04-30','14:30:00',5.8),('8975','2013-04-30','14:35:00',5.21),('8975','2013-04-30','14:40:00',4.6),('8975','2013-04-30','14:45:00',5.36),('8975','2013-04-30','14:50:00',4.51),('8975','2013-04-30','14:55:00',4.14),('8975','2013-04-30','15:00:00',4.58),('8975','2013-04-30','15:05:00',4.89),('8975','2013-04-30','15:10:00',4.56),('8975','2013-04-30','15:15:00',4.47),('8975','2013-04-30','15:20:00',4.69),('8975','2013-04-30','15:25:00',4.63),('8975','2013-04-30','15:30:00',3.71),('8975','2013-04-30','15:35:00',3.38),('8975','2013-04-30','15:40:00',3.55),('8975','2013-04-30','15:45:00',3.25),('8975','2013-04-30','15:50:00',2.45),('8975','2013-04-30','15:55:00',2.75),('8975','2013-04-30','16:00:00',3.13),('8975','2013-04-30','16:05:00',2.9),('8975','2013-04-30','16:10:00',2.59),('8975','2013-04-30','16:15:00',2.34),('8975','2013-04-30','16:20:00',1.95),('8975','2013-04-30','16:25:00',1.65),('8975','2013-04-30','16:30:00',1.53),('8975','2013-04-30','16:35:00',1.64),('8975','2013-04-30','16:40:00',1.72),('8975','2013-04-30','16:45:00',1.63),('8975','2013-04-30','16:50:00',1.42),('8975','2013-04-30','16:55:00',1.33),('8975','2013-04-30','17:00:00',1.36),('8975','2013-04-30','17:05:00',1.38),('8975','2013-04-30','17:10:00',1.43),('8975','2013-04-30','17:15:00',1.41),('8975','2013-04-30','17:20:00',1.27),('8975','2013-04-30','17:25:00',1.08),('8975','2013-04-29','07:55:00',1.03),('8975','2013-04-29','08:00:00',1.13),('8975','2013-04-29','08:15:00',1.04),('8975','2013-04-29','08:30:00',1.24),('8975','2013-04-29','08:35:00',1.38),('8975','2013-04-29','08:40:00',1.37),('8975','2013-04-29','08:45:00',1.49),('8975','2013-04-29','08:50:00',2.81),('8975','2013-04-29','08:55:00',3.2),('8975','2013-04-29','09:00:00',2.75),('8975','2013-04-29','09:05:00',2.87),('8975','2013-04-29','09:10:00',4.55),('8975','2013-04-29','09:15:00',4.85),('8975','2013-04-29','09:20:00',5.1),('8975','2013-04-29','09:25:00',4.8),('8975','2013-04-29','09:30:00',4.61),('8975','2013-04-29','09:35:00',3.03),('8975','2013-04-29','09:40:00',3.03),('8975','2013-04-29','09:45:00',3.86),('8975','2013-04-29','09:50:00',4.94),('8975','2013-04-29','09:55:00',5.38),('8975','2013-04-29','10:00:00',5.96),('8975','2013-04-29','10:05:00',4.37),('8975','2013-04-29','10:10:00',4.48),('8975','2013-04-29','10:15:00',3.26),('8975','2013-04-29','10:20:00',5.2),('8975','2013-04-29','10:25:00',4.75),('8975','2013-04-29','10:30:00',4.04),('8975','2013-04-29','10:35:00',2.93),('8975','2013-04-29','10:40:00',2.57),('8975','2013-04-29','10:45:00',2.18),('8975','2013-04-29','10:50:00',2.37),('8975','2013-04-29','10:55:00',2.44),('8975','2013-04-29','11:00:00',2.62),('8975','2013-04-29','11:05:00',2.98),('8975','2013-04-29','11:10:00',2.91),('8975','2013-04-29','11:15:00',3.38),('8975','2013-04-29','11:20:00',3.4),('8975','2013-04-29','11:25:00',3.2),('8975','2013-04-29','11:30:00',3.22),('8975','2013-04-29','11:35:00',3.72),('8975','2013-04-29','11:40:00',3.02),('8975','2013-04-29','11:45:00',2.82),('8975','2013-04-29','11:50:00',2.89),('8975','2013-04-29','11:55:00',2.94),('8975','2013-04-29','12:00:00',2.95),('8975','2013-04-29','12:05:00',2.99),('8975','2013-04-29','12:10:00',2.83),('8975','2013-04-29','12:15:00',2.61),('8975','2013-04-29','12:20:00',2.35),('8975','2013-04-29','12:25:00',2.18),('8975','2013-04-29','12:30:00',2.45),('8975','2013-04-29','12:35:00',5.43),('8975','2013-04-29','12:40:00',7.41),('8975','2013-04-29','12:45:00',7.08),('8975','2013-04-29','12:50:00',6.72),('8975','2013-04-29','12:55:00',6.22),('8975','2013-04-29','13:00:00',6.66),('8975','2013-04-29','13:05:00',6.53),('8975','2013-04-29','13:10:00',6.34),('8975','2013-04-29','13:15:00',6.21),('8975','2013-04-29','13:20:00',6.13),('8975','2013-04-29','13:25:00',6.07),('8975','2013-04-29','13:30:00',6.09),('8975','2013-04-29','13:35:00',6.03),('8975','2013-04-29','13:40:00',5.94),('8975','2013-04-29','13:45:00',5.86),('8975','2013-04-29','13:50:00',5.81),('8975','2013-04-29','13:55:00',5.75),('8975','2013-04-29','14:00:00',5.64),('8975','2013-04-29','14:05:00',5.65),('8975','2013-04-29','14:10:00',5.57),('8975','2013-04-29','14:15:00',5.51),('8975','2013-04-29','14:20:00',5.46),('8975','2013-04-29','14:25:00',5.4),('8975','2013-04-29','14:30:00',5.32),('8975','2013-04-29','14:35:00',5.2),('8975','2013-04-29','14:40:00',4.33),('8975','2013-04-29','14:45:00',4.33),('8975','2013-04-29','14:50:00',4.09),('8975','2013-04-29','14:55:00',4.52),('8975','2013-04-29','15:00:00',4.55),('8975','2013-04-29','15:05:00',3.9),('8975','2013-04-29','15:10:00',3.24),('8975','2013-04-29','15:15:00',3.77),('8975','2013-04-29','15:20:00',4.25),('8975','2013-04-29','15:25:00',4.28),('8975','2013-04-29','15:30:00',4.17),('8975','2013-04-29','15:35:00',4.12),('8975','2013-04-29','15:40:00',4),('8975','2013-04-29','15:45:00',3.93),('8975','2013-04-29','15:50:00',3.85),('8975','2013-04-29','15:55:00',3.75),('8975','2013-04-29','16:00:00',3.64),('8975','2013-04-29','16:05:00',3.54),('8975','2013-04-29','16:10:00',3.45),('8975','2013-04-29','16:15:00',3.31),('8975','2013-04-29','16:20:00',3.25),('8975','2013-04-29','16:25:00',3.17),('8975','2013-04-29','16:30:00',3.07),('8975','2013-04-29','16:35:00',2.52),('8975','2013-04-29','16:40:00',2.64),('8975','2013-04-29','16:45:00',2.41),('8975','2013-04-29','16:50:00',2.66),('8975','2013-04-29','16:55:00',2.63),('8975','2013-04-29','17:00:00',2.36),('8975','2013-04-29','17:05:00',2.27),('8975','2013-04-29','17:10:00',1.56),('8975','2013-04-29','17:15:00',1.24),('8975','2013-04-29','17:20:00',1.46),('8975','2013-04-29','17:25:00',1.86),('8975','2013-04-29','17:30:00',1.84),('8975','2013-04-29','17:35:00',1.76),('8975','2013-04-29','17:40:00',1.68),('8975','2013-04-29','17:45:00',1.59),('8975','2013-04-29','17:50:00',1.5),('8975','2013-04-29','17:55:00',1.41),('8975','2013-04-29','18:00:00',1.34),('8975','2013-04-29','18:05:00',1.28),('8975','2013-04-29','18:10:00',1.21),('8975','2013-04-29','18:15:00',1.14),('8975','2013-04-29','18:20:00',1.08),('8975','2013-04-29','18:25:00',1.01),('8975','2013-04-28','07:15:00',1.27),('8975','2013-04-28','07:20:00',1.65),('8975','2013-04-28','07:25:00',2.01),('8975','2013-04-28','07:30:00',2.07),('8975','2013-04-28','07:35:00',1.95),('8975','2013-04-28','07:40:00',1.8),('8975','2013-04-28','07:45:00',1.98),('8975','2013-04-28','07:50:00',2.01),('8975','2013-04-28','07:55:00',2.28),('8975','2013-04-28','08:00:00',2.74),('8975','2013-04-28','08:05:00',2.94),('8975','2013-04-28','08:10:00',2.8),('8975','2013-04-28','08:15:00',2.9),('8975','2013-04-28','08:20:00',3.08),('8975','2013-04-28','08:25:00',3.36),('8975','2013-04-28','08:30:00',3.78),('8975','2013-04-28','08:35:00',4.18),('8975','2013-04-28','08:40:00',3.88),('8975','2013-04-28','08:45:00',4.01),('8975','2013-04-28','08:50:00',4.29),('8975','2013-04-28','08:55:00',3.79),('8975','2013-04-28','09:00:00',3.29),('8975','2013-04-28','09:05:00',4.53),('8975','2013-04-28','09:10:00',4.81),('8975','2013-04-28','09:15:00',5),('8975','2013-04-28','09:20:00',4.75),('8975','2013-04-28','09:25:00',4.62),('8975','2013-04-28','09:30:00',4.64),('8975','2013-04-28','09:35:00',4.87),('8975','2013-04-28','09:40:00',5.05),('8975','2013-04-28','09:45:00',5.11),('8975','2013-04-28','09:50:00',5.03),('8975','2013-04-28','09:55:00',4.79),('8975','2013-04-28','10:00:00',4.02),('8975','2013-04-28','10:05:00',4.06),('8975','2013-04-28','10:10:00',4.46),('8975','2013-04-28','10:15:00',3.41),('8975','2013-04-28','10:20:00',3.85),('8975','2013-04-28','10:25:00',4.28),('8975','2013-04-28','10:30:00',5.03),('8975','2013-04-28','10:35:00',4.39),('8975','2013-04-28','10:40:00',5.64),('8975','2013-04-28','10:45:00',5.01),('8975','2013-04-28','10:50:00',5.04),('8975','2013-04-28','10:55:00',4.74),('8975','2013-04-28','11:00:00',5.7),('8975','2013-04-28','11:05:00',5.34),('8975','2013-04-28','11:10:00',5.18),('8975','2013-04-28','11:15:00',5.07),('8975','2013-04-28','11:20:00',5.78),('8975','2013-04-28','11:25:00',5.86),('8975','2013-04-28','11:30:00',6.07),('8975','2013-04-28','11:35:00',5.71),('8975','2013-04-28','11:40:00',5.9),('8975','2013-04-28','11:45:00',5.72),('8975','2013-04-28','11:50:00',6.26),('8975','2013-04-28','11:55:00',6.1),('8975','2013-04-28','12:00:00',6.36),('8975','2013-04-28','12:05:00',6.17),('8975','2013-04-28','12:10:00',6.09),('8975','2013-04-28','12:15:00',6.19),('8975','2013-04-28','12:20:00',6.22),('8975','2013-04-28','12:25:00',6.08),('8975','2013-04-28','12:30:00',6.16),('8975','2013-04-28','12:35:00',6.23),('8975','2013-04-28','12:40:00',6.24),('8975','2013-04-28','12:45:00',6.25),('8975','2013-04-28','12:50:00',6.05),('8975','2013-04-28','12:55:00',6.07),('8975','2013-04-28','13:00:00',6.1),('8975','2013-04-28','13:05:00',5.95),('8975','2013-04-28','13:10:00',5.79),('8975','2013-04-28','13:15:00',5.58),('8975','2013-04-28','13:20:00',6.02),('8975','2013-04-28','13:25:00',6.2),('8975','2013-04-28','13:30:00',5.97),('8975','2013-04-28','13:35:00',5.9),('8975','2013-04-28','13:40:00',5.81),('8975','2013-04-28','13:45:00',5.93),('8975','2013-04-28','13:50:00',5.65),('8975','2013-04-28','13:55:00',5.99),('8975','2013-04-28','14:00:00',5.41),('8975','2013-04-28','14:05:00',5.65),('8975','2013-04-28','14:10:00',5.59),('8975','2013-04-28','14:15:00',5.8),('8975','2013-04-28','14:20:00',5.7),('8975','2013-04-28','14:25:00',5.49),('8975','2013-04-28','14:30:00',5.19),('8975','2013-04-28','14:35:00',5.08),('8975','2013-04-28','14:40:00',4.87),('8975','2013-04-28','14:45:00',5.2),('8975','2013-04-28','14:50:00',4.96),('8975','2013-04-28','14:55:00',5.05),('8975','2013-04-28','15:00:00',4.99),('8975','2013-04-28','15:05:00',5.11),('8975','2013-04-28','15:10:00',4.56),('8975','2013-04-28','15:15:00',4.48),('8975','2013-04-28','15:20:00',4.79),('8975','2013-04-28','15:25:00',4.72),('8975','2013-04-28','15:30:00',4.48),('8975','2013-04-28','15:35:00',3.86),('8975','2013-04-28','15:40:00',3.62),('8975','2013-04-28','15:45:00',3.5),('8975','2013-04-28','15:50:00',3.8),('8975','2013-04-28','15:55:00',3.94),('8975','2013-04-28','16:00:00',3.96),('8975','2013-04-28','16:05:00',4.09),('8975','2013-04-28','16:10:00',3.88),('8975','2013-04-28','16:15:00',4.58),('8975','2013-04-28','16:20:00',3.99),('8975','2013-04-28','16:25:00',3.29),('8975','2013-04-28','16:30:00',3.41),('8975','2013-04-28','16:35:00',3.5),('8975','2013-04-28','16:40:00',3.48),('8975','2013-04-28','16:45:00',3.45),('8975','2013-04-28','16:50:00',3.47),('8975','2013-04-28','16:55:00',3.42),('8975','2013-04-28','17:00:00',3.02),('8975','2013-04-28','17:05:00',2.66),('8975','2013-04-28','17:10:00',2.66),('8975','2013-04-28','17:15:00',2.3),('8975','2013-04-28','17:20:00',2.13),('8975','2013-04-28','17:25:00',1.89),('8975','2013-04-28','17:30:00',1.88),('8975','2013-04-28','17:35:00',1.6),('8975','2013-04-28','17:40:00',1.51),('8975','2013-04-28','17:45:00',1.53),('8975','2013-04-28','17:50:00',1.77),('8975','2013-04-28','17:55:00',1.83),('8975','2013-04-28','18:00:00',1.8),('8975','2013-04-28','18:05:00',1.97),('8975','2013-04-28','18:10:00',1.8),('8975','2013-04-28','18:15:00',1.69),('8975','2013-04-28','18:20:00',1.5),('8975','2013-04-28','18:25:00',1.53),('8975','2013-04-28','18:30:00',1.37),('8975','2013-04-28','18:35:00',1.09),('8975','2013-04-27','06:55:00',1.1),('8975','2013-04-27','07:00:00',1.27),('8975','2013-04-27','07:05:00',1.43),('8975','2013-04-27','07:10:00',1.66),('8975','2013-04-27','07:15:00',1.9),('8975','2013-04-27','07:20:00',2.08),('8975','2013-04-27','07:25:00',2.29),('8975','2013-04-27','07:30:00',2.45),('8975','2013-04-27','07:35:00',2.6),('8975','2013-04-27','07:40:00',2.76),('8975','2013-04-27','07:45:00',2.91),('8975','2013-04-27','07:50:00',3.03),('8975','2013-04-27','07:55:00',3.09),('8975','2013-04-27','08:00:00',3.19),('8975','2013-04-27','08:05:00',3.32),('8975','2013-04-27','08:10:00',3.5),('8975','2013-04-27','08:15:00',3.59),('8975','2013-04-27','08:20:00',3.74),('8975','2013-04-27','08:25:00',3.86),('8975','2013-04-27','08:30:00',3.85),('8975','2013-04-27','08:35:00',3.97),('8975','2013-04-27','08:40:00',4.13),('8975','2013-04-27','08:45:00',4.23),('8975','2013-04-27','08:50:00',4.35),('8975','2013-04-27','08:55:00',4.44),('8975','2013-04-27','09:00:00',4.55),('8975','2013-04-27','09:05:00',4.67),('8975','2013-04-27','09:10:00',4.78),('8975','2013-04-27','09:15:00',4.88),('8975','2013-04-27','09:20:00',4.97),('8975','2013-04-27','09:25:00',5.06),('8975','2013-04-27','09:30:00',5.15),('8975','2013-04-27','09:35:00',5.25),('8975','2013-04-27','09:40:00',5.32),('8975','2013-04-27','09:45:00',5.41),('8975','2013-04-27','09:50:00',5.51),('8975','2013-04-27','09:55:00',5.59),('8975','2013-04-27','10:00:00',5.66),('8975','2013-04-27','10:05:00',5.7),('8975','2013-04-27','10:10:00',5.61),('8975','2013-04-27','10:15:00',5.77),('8975','2013-04-27','10:20:00',5.87),('8975','2013-04-27','10:25:00',6.04),('8975','2013-04-27','10:30:00',6.02),('8975','2013-04-27','10:35:00',6.2),('8975','2013-04-27','10:40:00',5.46),('8975','2013-04-27','10:45:00',6.21),('8975','2013-04-27','10:50:00',6.2),('8975','2013-04-27','10:55:00',6.22),('8975','2013-04-27','11:00:00',6.22),('8975','2013-04-27','11:05:00',6.26),('8975','2013-04-27','11:10:00',6.33),('8975','2013-04-27','11:15:00',6.36),('8975','2013-04-27','11:20:00',6.25),('8975','2013-04-27','11:25:00',6.48),('8975','2013-04-27','11:30:00',6.35),('8975','2013-04-27','11:35:00',6.22),('8975','2013-04-27','11:40:00',6.34),('8975','2013-04-27','11:45:00',5.81),('8975','2013-04-27','11:50:00',6.22),('8975','2013-04-27','11:55:00',6.15),('8975','2013-04-27','12:00:00',5.5),('8975','2013-04-27','12:05:00',5.59),('8975','2013-04-27','12:10:00',6.25),('8975','2013-04-27','12:15:00',5.86),('8975','2013-04-27','12:20:00',6.42),('8975','2013-04-27','12:25:00',5.79),('8975','2013-04-27','12:30:00',4.7),('8975','2013-04-27','12:35:00',4.43),('8975','2013-04-27','12:40:00',5.12),('8975','2013-04-27','12:45:00',6.78),('8975','2013-04-27','12:50:00',6.16),('8975','2013-04-27','12:55:00',5.67),('8975','2013-04-27','13:00:00',6.02),('8975','2013-04-27','13:05:00',6.51),('8975','2013-04-27','13:10:00',6.13),('8975','2013-04-27','13:15:00',5.4),('8975','2013-04-27','13:20:00',6.08),('8975','2013-04-27','13:25:00',3.29),('8975','2013-04-27','13:30:00',4.17),('8975','2013-04-27','13:35:00',2.33),('8975','2013-04-27','13:40:00',2.4),('8975','2013-04-27','13:45:00',2.49),('8975','2013-04-27','13:50:00',4.65),('8975','2013-04-27','13:55:00',6.69),('8975','2013-04-27','14:00:00',5.54),('8975','2013-04-27','14:05:00',5.99),('8975','2013-04-27','14:10:00',6.02),('8975','2013-04-27','14:15:00',5.88),('8975','2013-04-27','14:20:00',5.83),('8975','2013-04-27','14:25:00',5.68),('8975','2013-04-27','14:30:00',5.59),('8975','2013-04-27','14:35:00',5.51),('8975','2013-04-27','14:40:00',5.43),('8975','2013-04-27','14:45:00',5.33),('8975','2013-04-27','14:50:00',5.24),('8975','2013-04-27','14:55:00',5.14),('8975','2013-04-27','15:00:00',5.06),('8975','2013-04-27','15:05:00',4.95),('8975','2013-04-27','15:10:00',4.88),('8975','2013-04-27','15:15:00',4.77),('8975','2013-04-27','15:20:00',4.69),('8975','2013-04-27','15:25:00',4.59),('8975','2013-04-27','15:30:00',4.5),('8975','2013-04-27','15:35:00',4.39),('8975','2013-04-27','15:40:00',4.3),('8975','2013-04-27','15:45:00',4.2),('8975','2013-04-27','15:50:00',4.08),('8975','2013-04-27','15:55:00',3.99),('8975','2013-04-27','16:00:00',3.89),('8975','2013-04-27','16:05:00',3.77),('8975','2013-04-27','16:10:00',3.65),('8975','2013-04-27','16:15:00',3.29),('8975','2013-04-27','16:20:00',3.23),('8975','2013-04-27','16:25:00',3.21),('8975','2013-04-27','16:30:00',2.86),('8975','2013-04-27','16:35:00',2.98),('8975','2013-04-27','16:40:00',2.94),('8975','2013-04-27','16:45:00',2.72),('8975','2013-04-27','16:50:00',2.72),('8975','2013-04-27','16:55:00',2.41),('8975','2013-04-27','17:00:00',2.39),('8975','2013-04-27','17:05:00',1.83),('8975','2013-04-27','17:10:00',2.06),('8975','2013-04-27','17:15:00',2.24),('8975','2013-04-27','17:20:00',2.06),('8975','2013-04-27','17:25:00',2.01),('8975','2013-04-27','17:30:00',1.83),('8975','2013-04-27','17:35:00',1.67),('8975','2013-04-27','17:40:00',1.66),('8975','2013-04-27','17:45:00',1.66),('8975','2013-04-27','17:50:00',1.62),('8975','2013-04-27','17:55:00',1.48),('8975','2013-04-27','18:00:00',1.49),('8975','2013-04-27','18:05:00',1.33),('8975','2013-04-27','18:10:00',1.06),('8975','2013-04-27','18:15:00',1.14),('8975','2013-04-27','18:20:00',1.3),('8975','2013-04-27','18:25:00',1.29),('8975','2013-04-27','18:30:00',1.08),('8975','2013-04-27','18:35:00',1),('8975','2013-04-26','11:55:00',1.05),('8975','2013-04-26','12:00:00',1.12),('8975','2013-04-26','12:05:00',1.08),('8975','2013-04-26','12:35:00',1.07),('8975','2013-04-26','12:40:00',1.34),('8975','2013-04-26','12:45:00',1.42),('8975','2013-04-26','12:50:00',1.71),('8975','2013-04-26','12:55:00',2.21),('8975','2013-04-26','13:00:00',2.09),('8975','2013-04-26','13:05:00',1.54),('8975','2013-04-26','13:10:00',1.66),('8975','2013-04-26','13:15:00',2.11),('8975','2013-04-26','13:20:00',2.3),('8975','2013-04-26','13:25:00',1.84),('8975','2013-04-26','13:30:00',2.17),('8975','2013-04-26','13:35:00',2.74),('8975','2013-04-26','13:40:00',3.08),('8975','2013-04-26','13:45:00',2.07),('8975','2013-04-26','13:50:00',1.83),('8975','2013-04-26','13:55:00',1.18),('8975','2013-04-26','14:00:00',1.26),('8975','2013-04-26','14:05:00',1.32),('8975','2013-04-26','14:10:00',1.15),('8975','2013-04-26','14:15:00',1.15),('8975','2013-04-26','14:20:00',1.33),('8975','2013-04-26','14:25:00',2.6),('8975','2013-04-26','14:30:00',3.32),('8975','2013-04-26','14:35:00',1.95),('8975','2013-04-26','14:40:00',2.15),('8975','2013-04-26','14:45:00',1.73),('8975','2013-04-26','14:50:00',1.62),('8975','2013-04-26','14:55:00',2.46),('8975','2013-04-26','15:00:00',3.74),('8975','2013-04-26','15:05:00',4.34),('8975','2013-04-26','15:10:00',2.44),('8975','2013-04-26','15:15:00',1.79),('8975','2013-04-26','16:30:00',1.75),('8975','2013-04-26','16:35:00',1.69),('8975','2013-04-26','16:40:00',2.14),('8975','2013-04-26','16:45:00',2.16),('8975','2013-04-26','16:50:00',2.81),('8975','2013-04-26','16:55:00',3.44),('8975','2013-04-26','17:00:00',2.39),('8975','2013-04-26','17:05:00',1.64),('8975','2013-04-26','17:10:00',1.18),('8975','2013-04-26','17:15:00',1.04),('8975','2013-04-26','17:20:00',1.64),('8975','2013-04-26','17:25:00',1.12),('8975','2013-04-26','17:30:00',1.03),('8975','2013-04-26','17:35:00',1.34),('8975','2013-04-26','17:40:00',1.7),('8975','2013-04-26','17:45:00',1.59),('8975','2013-04-26','17:50:00',1.93),('8975','2013-04-26','17:55:00',2),('8975','2013-04-26','18:00:00',1.9),('8975','2013-04-26','18:05:00',1.49),('8975','2013-04-26','18:10:00',1.37),('8975','2013-04-26','18:15:00',1.22),('8975','2013-04-25','07:00:00',1.11),('8975','2013-04-25','07:05:00',1.24),('8975','2013-04-25','07:10:00',1.4),('8975','2013-04-25','07:15:00',1.48),('8975','2013-04-25','07:20:00',1.45),('8975','2013-04-25','07:25:00',1.47),('8975','2013-04-25','07:30:00',1.36),('8975','2013-04-25','07:35:00',1.15),('8975','2013-04-25','07:40:00',1.11),('8975','2013-04-25','07:45:00',1.2),('8975','2013-04-25','07:50:00',1.5),('8975','2013-04-25','07:55:00',1.59),('8975','2013-04-25','08:00:00',1.76),('8975','2013-04-25','08:05:00',2.5),('8975','2013-04-25','08:10:00',2.83),('8975','2013-04-25','08:15:00',2.97),('8975','2013-04-25','08:20:00',3.02),('8975','2013-04-25','08:25:00',3.02),('8975','2013-04-25','08:30:00',3.27),('8975','2013-04-25','08:35:00',3.36),('8975','2013-04-25','08:40:00',3.47),('8975','2013-04-25','08:45:00',3.77),('8975','2013-04-25','08:50:00',3.89),('8975','2013-04-25','08:55:00',3.82),('8975','2013-04-25','09:00:00',4.04),('8975','2013-04-25','09:05:00',3.07),('8975','2013-04-25','09:10:00',2.21),('8975','2013-04-25','09:15:00',2.32),('8975','2013-04-25','09:20:00',3.07),('8975','2013-04-25','09:25:00',3.62),('8975','2013-04-25','09:30:00',3.53),('8975','2013-04-25','09:35:00',2.75),('8975','2013-04-25','09:40:00',3.9),('8975','2013-04-25','09:45:00',5.28),('8975','2013-04-25','09:50:00',3.65),('8975','2013-04-25','09:55:00',4.25),('8975','2013-04-25','10:00:00',5.58),('8975','2013-04-25','10:05:00',5.41),('8975','2013-04-25','10:10:00',5.45),('8975','2013-04-25','10:15:00',5.52),('8975','2013-04-25','10:20:00',5.07),('8975','2013-04-25','10:25:00',5.33),('8975','2013-04-25','10:30:00',5.8),('8975','2013-04-25','10:35:00',5.94),('8975','2013-04-25','10:40:00',6.17),('8975','2013-04-25','10:45:00',5.26),('8975','2013-04-25','10:50:00',3.05),('8975','2013-04-25','10:55:00',3.97),('8975','2013-04-25','11:00:00',6.03),('8975','2013-04-25','11:05:00',5.98),('8975','2013-04-25','11:10:00',6.07),('8975','2013-04-25','11:15:00',5.92),('8975','2013-04-25','11:20:00',5.37),('8975','2013-04-25','11:25:00',5.52),('8975','2013-04-25','11:30:00',5.2),('8975','2013-04-25','11:35:00',5.63),('8975','2013-04-25','11:40:00',4.62),('8975','2013-04-25','11:45:00',4.75),('8975','2013-04-25','11:50:00',3.87),('8975','2013-04-25','11:55:00',4.79),('8975','2013-04-25','12:00:00',4.8),('8975','2013-04-25','12:05:00',3.92),('8975','2013-04-25','12:10:00',3.79),('8975','2013-04-25','12:15:00',4.64),('8975','2013-04-25','12:20:00',3.23),('8975','2013-04-25','12:25:00',2.79),('8975','2013-04-25','12:30:00',3.09),('8975','2013-04-25','12:35:00',4.02),('8975','2013-04-25','12:40:00',4.14),('8975','2013-04-25','12:45:00',3.41),('8975','2013-04-25','12:50:00',3.36),('8975','2013-04-25','12:55:00',2.58),('8975','2013-04-25','13:00:00',2.12),('8975','2013-04-25','13:05:00',2.28),('8975','2013-04-25','13:10:00',3.21),('8975','2013-04-25','13:15:00',3.29),('8975','2013-04-25','13:20:00',2.99),('8975','2013-04-25','13:25:00',4.06),('8975','2013-04-25','13:30:00',4.59),('8975','2013-04-25','13:35:00',4.17),('8975','2013-04-25','13:40:00',3.27),('8975','2013-04-25','13:45:00',3.39),('8975','2013-04-25','13:50:00',3.85),('8975','2013-04-25','13:55:00',3.61),('8975','2013-04-25','14:00:00',3.96),('8975','2013-04-25','14:05:00',4.02),('8975','2013-04-25','14:10:00',3.85),('8975','2013-04-25','14:15:00',3.64),('8975','2013-04-25','14:20:00',4.29),('8975','2013-04-25','14:25:00',4.77),('8975','2013-04-25','14:30:00',5.1),('8975','2013-04-25','14:35:00',3.31),('8975','2013-04-25','14:40:00',2.3),('8975','2013-04-25','14:45:00',3.22),('8975','2013-04-25','14:50:00',5.93),('8975','2013-04-25','14:55:00',5.04),('8975','2013-04-25','15:00:00',3.83),('8975','2013-04-25','15:05:00',2.02),('8975','2013-04-25','15:10:00',2.74),('8975','2013-04-25','15:15:00',2.31),('8975','2013-04-25','15:20:00',2.32),('8975','2013-04-25','15:25:00',3.34),('8975','2013-04-25','15:30:00',3.29),('8975','2013-04-25','15:35:00',3.18),('8975','2013-04-25','15:40:00',4.1),('8975','2013-04-25','15:45:00',3.46),('8975','2013-04-25','15:50:00',3.27),('8975','2013-04-25','15:55:00',1.83),('8975','2013-04-24','07:40:00',1.16),('8975','2013-04-24','07:45:00',1.89),('8975','2013-04-24','07:50:00',1.27),('8975','2013-04-24','07:55:00',1.32),('8975','2013-04-24','08:00:00',1.76),('8975','2013-04-24','08:05:00',2.15),('8975','2013-04-24','08:10:00',2.11),('8975','2013-04-24','08:15:00',2.78),('8975','2013-04-24','08:20:00',2.16),('8975','2013-04-24','08:25:00',1.94),('8975','2013-04-24','08:30:00',2.11),('8975','2013-04-24','08:35:00',2.06),('8975','2013-04-24','08:40:00',2.05),('8975','2013-04-24','08:45:00',3.72),('8975','2013-04-24','08:50:00',4.05),('8975','2013-04-24','08:55:00',4.16),('8975','2013-04-24','09:00:00',3.38),('8975','2013-04-24','09:05:00',2.66),('8975','2013-04-24','09:10:00',2.99),('8975','2013-04-24','09:15:00',2.56),('8975','2013-04-24','09:20:00',2.8),('8975','2013-04-24','09:25:00',2.79),('8975','2013-04-24','09:30:00',2.58),('8975','2013-04-24','09:35:00',2.7),('8975','2013-04-24','09:40:00',3.65),('8975','2013-04-24','09:45:00',5.32),('8975','2013-04-24','09:50:00',5.55),('8975','2013-04-24','09:55:00',5.6),('8975','2013-04-24','10:00:00',5.28),('8975','2013-04-24','10:05:00',5.17),('8975','2013-04-24','10:10:00',5.42),('8975','2013-04-24','10:15:00',5.04),('8975','2013-04-24','10:20:00',5.62),('8975','2013-04-24','10:25:00',5.75),('8975','2013-04-24','10:30:00',5.98),('8975','2013-04-24','10:35:00',5.94),('8975','2013-04-24','10:40:00',5.91),('8975','2013-04-24','10:45:00',5.97),('8975','2013-04-24','10:50:00',6.16),('8975','2013-04-24','10:55:00',6.18),('8975','2013-04-24','11:00:00',6.23),('8975','2013-04-24','11:05:00',6.28),('8975','2013-04-24','11:10:00',6.19),('8975','2013-04-24','11:15:00',6.23),('8975','2013-04-24','11:20:00',6.25),('8975','2013-04-24','11:25:00',6.35),('8975','2013-04-24','11:30:00',6.36),('8975','2013-04-24','11:35:00',6.42),('8975','2013-04-24','11:40:00',6.45),('8975','2013-04-24','11:45:00',6.46),('8975','2013-04-24','11:50:00',6.36),('8975','2013-04-24','11:55:00',6.16),('8975','2013-04-24','12:00:00',6.2),('8975','2013-04-24','12:05:00',6.3),('8975','2013-04-24','12:10:00',6.43),('8975','2013-04-24','12:15:00',6.47),('8975','2013-04-24','12:20:00',6.45),('8975','2013-04-24','12:25:00',6.41),('8975','2013-04-24','12:30:00',6.38),('8975','2013-04-24','12:35:00',6.38),('8975','2013-04-24','12:40:00',6.38),('8975','2013-04-24','12:45:00',6.4),('8975','2013-04-24','12:50:00',6.34),('8975','2013-04-24','12:55:00',6.31),('8975','2013-04-24','13:00:00',6.32),('8975','2013-04-24','13:05:00',6.34),('8975','2013-04-24','13:10:00',6.38),('8975','2013-04-24','13:15:00',6),('8975','2013-04-24','13:20:00',5.78),('8975','2013-04-24','13:25:00',4.5),('8975','2013-04-24','13:30:00',3.91),('8975','2013-04-24','13:35:00',3.74),('8975','2013-04-24','13:40:00',3.66),('8975','2013-04-24','13:45:00',3.51),('8975','2013-04-24','13:50:00',3.54),('8975','2013-04-24','13:55:00',3.82),('8975','2013-04-24','14:00:00',3.75),('8975','2013-04-24','14:05:00',3.66),('8975','2013-04-24','14:10:00',3.75),('8975','2013-04-24','14:15:00',3.71),('8975','2013-04-24','14:20:00',3.55),('8975','2013-04-24','14:25:00',3.92),('8975','2013-04-24','14:30:00',4.63),('8975','2013-04-24','14:35:00',5.25),('8975','2013-04-24','14:40:00',5.05),('8975','2013-04-24','14:45:00',4.91),('8975','2013-04-24','14:50:00',4.43),('8975','2013-04-24','14:55:00',4.48),('8975','2013-04-24','15:00:00',4.29),('8975','2013-04-24','15:05:00',3.87),('8975','2013-04-24','15:10:00',3.96),('8975','2013-04-24','15:15:00',4.3),('8975','2013-04-24','15:20:00',4.53),('8975','2013-04-24','15:25:00',4.62),('8975','2013-04-24','15:30:00',4.48),('8975','2013-04-24','15:35:00',4.09),('8975','2013-04-24','15:40:00',3.95),('8975','2013-04-24','15:45:00',3.55),('8975','2013-04-24','15:50:00',3.28),('8975','2013-04-24','15:55:00',3.3),('8975','2013-04-24','16:00:00',3.04),('8975','2013-04-24','16:05:00',2.65),('8975','2013-04-24','16:10:00',3.21),('8975','2013-04-24','16:15:00',2.66),('8975','2013-04-24','16:20:00',2.87),('8975','2013-04-24','16:25:00',2.53),('8975','2013-04-24','16:30:00',2.7),('8975','2013-04-24','16:35:00',3.13),('8975','2013-04-24','16:40:00',2.79),('8975','2013-04-24','16:45:00',2.36),('8975','2013-04-24','16:50:00',2.43),('8975','2013-04-24','16:55:00',2.78),('8975','2013-04-24','17:00:00',2.87),('8975','2013-04-24','17:05:00',3.04),('8975','2013-04-24','17:10:00',2.93),('8975','2013-04-24','17:15:00',2.54),('8975','2013-04-24','17:20:00',2.42),('8975','2013-04-24','17:25:00',2.03),('8975','2013-04-24','17:30:00',1.7),('8975','2013-04-24','17:35:00',1.73),('8975','2013-04-24','17:40:00',1.66),('8975','2013-04-24','17:45:00',1.46),('8975','2013-04-24','17:50:00',1.32),('8975','2013-04-24','17:55:00',1.19),('8975','2013-04-24','18:00:00',1.15),('8975','2013-04-24','18:05:00',1.1),('8975','2013-04-24','18:10:00',1.02),('8975','2013-04-23','07:25:00',1.08),('8975','2013-04-23','07:30:00',1.19),('8975','2013-04-23','07:35:00',1.74),('8975','2013-04-23','07:40:00',2.11),('8975','2013-04-23','07:45:00',2.39),('8975','2013-04-23','07:50:00',2.75),('8975','2013-04-23','07:55:00',2.84),('8975','2013-04-23','08:00:00',2.82),('8975','2013-04-23','08:05:00',3.1),('8975','2013-04-23','08:10:00',3.37),('8975','2013-04-23','08:15:00',3.5),('8975','2013-04-23','08:20:00',3.78),('8975','2013-04-23','08:25:00',3.77),('8975','2013-04-23','08:30:00',3.58),('8975','2013-04-23','08:35:00',3.54),('8975','2013-04-23','08:40:00',3.66),('8975','2013-04-23','08:45:00',3.68),('8975','2013-04-23','08:50:00',3.8),('8975','2013-04-23','08:55:00',3.99),('8975','2013-04-23','09:00:00',4.5),('8975','2013-04-23','09:05:00',3.44),('8975','2013-04-23','09:10:00',4.86),('8975','2013-04-23','09:15:00',3.75),('8975','2013-04-23','09:20:00',4.05),('8975','2013-04-23','09:25:00',5.62),('8975','2013-04-23','09:30:00',4.86),('8975','2013-04-23','09:35:00',5.65),('8975','2013-04-23','09:40:00',4.81),('8975','2013-04-23','09:45:00',4.97),('8975','2013-04-23','09:50:00',5.83),('8975','2013-04-23','09:55:00',5.4),('8975','2013-04-23','10:00:00',5.73),('8975','2013-04-23','10:05:00',5.86),('8975','2013-04-23','10:10:00',6.02),('8975','2013-04-23','10:15:00',6.01),('8975','2013-04-23','10:20:00',5.87),('8975','2013-04-23','10:25:00',5.73),('8975','2013-04-23','10:30:00',5.71),('8975','2013-04-23','10:35:00',5.94),('8975','2013-04-23','10:40:00',6.13),('8975','2013-04-23','10:45:00',6.21),('8975','2013-04-23','10:50:00',6.35),('8975','2013-04-23','10:55:00',6.46),('8975','2013-04-23','11:00:00',6.23),('8975','2013-04-23','11:05:00',6.36),('8975','2013-04-23','11:10:00',6.76),('8975','2013-04-23','11:15:00',6.67),('8975','2013-04-23','11:20:00',6.92),('8975','2013-04-23','11:25:00',7.06),('8975','2013-04-23','11:30:00',6.51),('8975','2013-04-23','11:35:00',4.72),('8975','2013-04-23','11:40:00',5.16),('8975','2013-04-23','11:45:00',4.65),('8975','2013-04-23','11:50:00',4.64),('8975','2013-04-23','11:55:00',6.34),('8975','2013-04-23','12:00:00',4.58),('8975','2013-04-23','12:05:00',4.08),('8975','2013-04-23','12:10:00',5.51),('8975','2013-04-23','12:15:00',6.69),('8975','2013-04-23','12:20:00',7.4),('8975','2013-04-23','12:25:00',6.36),('8975','2013-04-23','12:30:00',6.23),('8975','2013-04-23','12:35:00',6.5),('8975','2013-04-23','12:40:00',6.52),('8975','2013-04-23','12:45:00',6.19),('8975','2013-04-23','12:50:00',6.09),('8975','2013-04-23','12:55:00',6.57),('8975','2013-04-23','13:00:00',7.15),('8975','2013-04-23','13:05:00',5.72),('8975','2013-04-23','13:10:00',6.23),('8975','2013-04-23','13:15:00',6.84),('8975','2013-04-23','13:20:00',6.13),('8975','2013-04-23','13:25:00',6.3),('8975','2013-04-23','13:30:00',5.6),('8975','2013-04-23','13:35:00',6.41),('8975','2013-04-23','13:40:00',6.92),('8975','2013-04-23','13:45:00',6.41),('8975','2013-04-23','13:50:00',5.3),('8975','2013-04-23','13:55:00',5.93),('8975','2013-04-23','14:00:00',6.63),('8975','2013-04-23','14:05:00',4.76),('8975','2013-04-23','14:10:00',4.99),('8975','2013-04-23','14:15:00',6.16),('8975','2013-04-23','14:20:00',5.95),('8975','2013-04-23','14:25:00',5.97),('8975','2013-04-23','14:30:00',5.55),('8975','2013-04-23','14:35:00',5.19),('8975','2013-04-23','14:40:00',4.87),('8975','2013-04-23','14:45:00',4.51),('8975','2013-04-23','14:50:00',3.77),('8975','2013-04-23','14:55:00',4.05),('8975','2013-04-23','15:00:00',3.75),('8975','2013-04-23','15:05:00',3.76),('8975','2013-04-23','15:10:00',3.43),('8975','2013-04-23','15:15:00',3.51),('8975','2013-04-23','15:20:00',3.95),('8975','2013-04-23','15:25:00',3.31),('8975','2013-04-23','15:30:00',3),('8975','2013-04-23','15:35:00',2.8),('8975','2013-04-23','15:40:00',2.66),('8975','2013-04-23','15:45:00',2.71),('8975','2013-04-23','15:50:00',2.75),('8975','2013-04-23','15:55:00',3.29),('8975','2013-04-23','16:00:00',4.25),('8975','2013-04-23','16:05:00',3.71),('8975','2013-04-23','16:10:00',3.9),('8975','2013-04-23','16:15:00',4.09),('8975','2013-04-23','16:20:00',4.28),('8975','2013-04-23','16:25:00',3.35),('8975','2013-04-23','16:30:00',2.91),('8975','2013-04-23','16:35:00',2.73),('8975','2013-04-23','16:40:00',3.22),('8975','2013-04-23','16:45:00',3.33),('8975','2013-04-23','16:50:00',3),('8975','2013-04-23','16:55:00',3.16),('8975','2013-04-23','17:00:00',3.1),('8975','2013-04-23','17:05:00',2.98),('8975','2013-04-23','17:10:00',2.81),('8975','2013-04-23','17:15:00',2.2),('8975','2013-04-23','17:20:00',2.06),('8975','2013-04-23','17:25:00',1.73),('8975','2013-04-23','17:30:00',1.43),('8975','2013-04-23','17:35:00',1.45),('8975','2013-04-23','17:40:00',1.15),('8975','2013-04-23','17:45:00',1.37),('8975','2013-04-23','17:50:00',1.37),('8975','2013-04-23','17:55:00',1.66),('8975','2013-04-23','18:00:00',1.38),('8975','2013-04-23','18:05:00',1.31),('8975','2013-04-23','18:10:00',1.16),('8975','2013-04-23','18:15:00',1.08),('8975','2013-04-23','18:20:00',1.43),('8975','2013-04-23','18:25:00',1.2),('8975','2013-04-22','06:50:00',1.02),('8975','2013-04-22','06:55:00',1.3),('8975','2013-04-22','07:00:00',1.43),('8975','2013-04-22','07:05:00',1.66),('8975','2013-04-22','07:10:00',1.81),('8975','2013-04-22','07:15:00',2.06),('8975','2013-04-22','07:20:00',2.09),('8975','2013-04-22','07:25:00',2.44),('8975','2013-04-22','07:30:00',2.67),('8975','2013-04-22','07:35:00',2.83),('8975','2013-04-22','07:40:00',2.95),('8975','2013-04-22','07:45:00',3.09),('8975','2013-04-22','07:50:00',3.21),('8975','2013-04-22','07:55:00',3.32),('8975','2013-04-22','08:00:00',3.44),('8975','2013-04-22','08:05:00',3.55),('8975','2013-04-22','08:10:00',3.66),('8975','2013-04-22','08:15:00',3.79),('8975','2013-04-22','08:20:00',3.93),('8975','2013-04-22','08:25:00',4.05),('8975','2013-04-22','08:30:00',4.16),('8975','2013-04-22','08:35:00',4.26),('8975','2013-04-22','08:40:00',4.35),('8975','2013-04-22','08:45:00',4.46),('8975','2013-04-22','08:50:00',4.56),('8975','2013-04-22','08:55:00',4.65),('8975','2013-04-22','09:00:00',4.76),('8975','2013-04-22','09:05:00',4.9),('8975','2013-04-22','09:10:00',5),('8975','2013-04-22','09:15:00',5.09),('8975','2013-04-22','09:20:00',5.17),('8975','2013-04-22','09:25:00',5.21),('8975','2013-04-22','09:30:00',5.3),('8975','2013-04-22','09:35:00',5.47),('8975','2013-04-22','09:40:00',4.78),('8975','2013-04-22','09:45:00',5.38),('8975','2013-04-22','09:50:00',5.82),('8975','2013-04-22','09:55:00',5.81),('8975','2013-04-22','10:00:00',5.85),('8975','2013-04-22','10:05:00',5.9),('8975','2013-04-22','10:10:00',5.96),('8975','2013-04-22','10:15:00',6.04),('8975','2013-04-22','10:20:00',6.08),('8975','2013-04-22','10:25:00',6.11),('8975','2013-04-22','10:30:00',6.19),('8975','2013-04-22','10:35:00',6.22),('8975','2013-04-22','10:40:00',6.29),('8975','2013-04-22','10:45:00',6.25),('8975','2013-04-22','10:50:00',6.37),('8975','2013-04-22','10:55:00',6.42),('8975','2013-04-22','11:00:00',6.48),('8975','2013-04-22','11:05:00',6.47),('8975','2013-04-22','11:10:00',6.49),('8975','2013-04-22','11:15:00',6.52),('8975','2013-04-22','11:20:00',6.53),('8975','2013-04-22','11:25:00',6.54),('8975','2013-04-22','11:30:00',6.58),('8975','2013-04-22','11:35:00',6.61),('8975','2013-04-22','11:40:00',6.6),('8975','2013-04-22','11:45:00',6.61),('8975','2013-04-22','11:50:00',6.63),('8975','2013-04-22','11:55:00',6.66),('8975','2013-04-22','12:00:00',6.56),('8975','2013-04-22','12:05:00',6.61),('8975','2013-04-22','12:10:00',6.69),('8975','2013-04-22','12:15:00',6.71),('8975','2013-04-22','12:20:00',6.65),('8975','2013-04-22','12:25:00',6.78),('8975','2013-04-22','12:30:00',5.74),('8975','2013-04-22','12:35:00',3.55),('8975','2013-04-22','12:40:00',5.7),('8975','2013-04-22','12:45:00',1.77),('8975','2013-04-22','12:50:00',4.92),('8975','2013-04-22','12:55:00',6.09),('8975','2013-04-22','13:00:00',6.16),('8975','2013-04-22','13:05:00',5.96),('8975','2013-04-22','13:10:00',7.83),('8975','2013-04-22','13:15:00',7.28),('8975','2013-04-22','13:20:00',6.59),('8975','2013-04-22','13:25:00',6.59),('8975','2013-04-22','13:30:00',6.62),('8975','2013-04-22','13:35:00',6.73),('8975','2013-04-22','13:40:00',6.32),('8975','2013-04-22','13:45:00',4.5),('8975','2013-04-22','13:50:00',6.32),('8975','2013-04-22','13:55:00',6.24),('8975','2013-04-22','14:00:00',6.48),('8975','2013-04-22','14:05:00',6.42),('8975','2013-04-22','14:10:00',5.64),('8975','2013-04-22','14:15:00',5.94),('8975','2013-04-22','14:20:00',5.29),('8975','2013-04-22','14:25:00',5.71),('8975','2013-04-22','14:30:00',5.7),('8975','2013-04-22','14:35:00',5.93),('8975','2013-04-22','14:40:00',6.03),('8975','2013-04-22','14:45:00',4.22),('8975','2013-04-22','14:50:00',3.16),('8975','2013-04-22','14:55:00',3.65),('8975','2013-04-22','15:00:00',3.92),('8975','2013-04-22','15:05:00',3.86),('8975','2013-04-22','15:10:00',4.73),('8975','2013-04-22','15:15:00',4.19),('8975','2013-04-22','15:20:00',3.96),('8975','2013-04-22','15:25:00',3.62),('8975','2013-04-22','15:30:00',3.39),('8975','2013-04-22','15:35:00',3.05),('8975','2013-04-22','15:40:00',3.12),('8975','2013-04-22','15:45:00',3.75),('8975','2013-04-22','15:50:00',3.13),('8975','2013-04-22','15:55:00',3.3),('8975','2013-04-22','16:00:00',2.74),('8975','2013-04-22','16:05:00',2.94),('8975','2013-04-22','16:10:00',2.47),('8975','2013-04-22','16:15:00',2.13),('8975','2013-04-22','16:20:00',1.92),('8975','2013-04-22','16:25:00',1.79),('8975','2013-04-22','16:30:00',1.74),('8975','2013-04-22','16:35:00',1.77),('8975','2013-04-22','16:40:00',1.83),('8975','2013-04-22','16:45:00',1.63),('8975','2013-04-22','16:50:00',1.49),('8975','2013-04-22','16:55:00',1.55),('8975','2013-04-22','17:00:00',1.68),('8975','2013-04-22','17:05:00',1.91),('8975','2013-04-22','17:10:00',2.45),('8975','2013-04-22','17:15:00',1.66),('8975','2013-04-22','17:20:00',1.92),('8975','2013-04-22','17:25:00',1.85),('8975','2013-04-22','17:30:00',1.71),('8975','2013-04-22','17:35:00',1.69),('8975','2013-04-22','17:40:00',1.67),('8975','2013-04-22','17:45:00',1.27),('8975','2013-04-21','09:00:00',1.2),('8975','2013-04-21','09:05:00',1.13),('8975','2013-04-21','09:10:00',1.26),('8975','2013-04-21','09:20:00',1.02),('8975','2013-04-21','09:25:00',1.3),('8975','2013-04-21','09:30:00',1.68),('8975','2013-04-21','09:35:00',1.42),('8975','2013-04-21','09:40:00',1.16),('8975','2013-04-21','10:30:00',1.44),('8975','2013-04-21','10:35:00',5.54),('8975','2013-04-21','10:40:00',5.98),('8975','2013-04-21','10:45:00',6.2),('8975','2013-04-21','10:50:00',4.38),('8975','2013-04-21','10:55:00',3.83),('8975','2013-04-21','11:00:00',3.55),('8975','2013-04-21','11:05:00',3.22),('8975','2013-04-21','11:10:00',3.23),('8975','2013-04-21','11:15:00',2.15),('8975','2013-04-21','11:20:00',2.69),('8975','2013-04-21','11:25:00',5.05),('8975','2013-04-21','11:30:00',5.02),('8975','2013-04-21','11:35:00',7.31),('8975','2013-04-21','11:40:00',4.44),('8975','2013-04-21','11:45:00',2.75),('8975','2013-04-21','11:50:00',5.74),('8975','2013-04-21','11:55:00',5.65),('8975','2013-04-21','12:00:00',5.47),('8975','2013-04-21','12:05:00',5.32),('8975','2013-04-21','12:10:00',4.9),('8975','2013-04-21','12:15:00',6.64),('8975','2013-04-21','12:20:00',3.08),('8975','2013-04-21','12:25:00',2.7),('8975','2013-04-21','12:30:00',2.59),('8975','2013-04-21','12:35:00',6.74),('8975','2013-04-21','12:40:00',7.53),('8975','2013-04-21','12:45:00',6.71),('8975','2013-04-21','12:50:00',7.39),('8975','2013-04-21','12:55:00',5.7),('8975','2013-04-21','13:00:00',7.5),('8975','2013-04-21','13:05:00',1.74),('8975','2013-04-21','13:10:00',4.21),('8975','2013-04-21','13:15:00',4.45),('8975','2013-04-21','13:20:00',2.42),('8975','2013-04-21','13:25:00',3.33),('8975','2013-04-21','13:30:00',6.21),('8975','2013-04-21','13:35:00',8.3),('8975','2013-04-21','13:40:00',6.74),('8975','2013-04-21','13:45:00',1.89),('8975','2013-04-21','13:50:00',1.87),('8975','2013-04-21','13:55:00',2.31),('8975','2013-04-21','14:00:00',1.94),('8975','2013-04-21','14:05:00',2.34),('8975','2013-04-21','14:10:00',1.95),('8975','2013-04-21','14:15:00',6.06),('8975','2013-04-21','14:20:00',7.43),('8975','2013-04-21','14:25:00',6.7),('8975','2013-04-21','14:30:00',4.87),('8975','2013-04-21','14:35:00',6.64),('8975','2013-04-21','14:40:00',6.24),('8975','2013-04-21','14:45:00',6.09),('8975','2013-04-21','14:50:00',5.38),('8975','2013-04-21','14:55:00',4.8),('8975','2013-04-21','15:00:00',4.57),('8975','2013-04-21','15:05:00',2.41),('8975','2013-04-21','15:10:00',1.49),('8975','2013-04-21','15:15:00',1.47),('8975','2013-04-21','15:20:00',5.51),('8975','2013-04-21','15:25:00',2.91),('8975','2013-04-21','15:30:00',2.01),('8975','2013-04-21','15:35:00',2.34),('8975','2013-04-21','15:40:00',5.74),('8975','2013-04-21','15:45:00',2.66),('8975','2013-04-21','15:50:00',1.73),('8975','2013-04-21','15:55:00',1.95),('8975','2013-04-21','16:00:00',2.13),('8975','2013-04-21','16:05:00',1.32),('8975','2013-04-21','16:10:00',1.41),('8975','2013-04-21','16:15:00',1.68),('8975','2013-04-21','16:20:00',1.11),('8975','2013-04-21','16:30:00',1.12),('8975','2013-04-21','16:35:00',1.28),('8975','2013-04-21','16:40:00',1.88),('8975','2013-04-21','16:45:00',1.31),('8975','2013-04-21','16:50:00',1.04),('8975','2013-04-21','17:10:00',1.01),('8975','2013-04-21','17:25:00',1.15),('8975','2013-04-21','17:30:00',1.31),('8975','2013-04-21','17:35:00',1.45),('8975','2013-04-21','17:40:00',1.16),('8975','2013-04-21','18:15:00',1.02),('8975','2013-04-21','18:50:00',1.22),('8975','2013-04-21','18:55:00',1.06),('8975','2014-03-28','06:40:00',1.21),('8975','2014-03-28','06:45:00',1.35),('8975','2014-03-28','06:50:00',1.61),('8975','2014-03-28','06:55:00',1.73),('8975','2014-03-28','07:00:00',1.97),('8975','2014-03-28','07:05:00',2.25),('8975','2014-03-28','07:10:00',2.42),('8975','2014-03-28','07:15:00',2.57),('8975','2014-03-28','07:20:00',2.68),('8975','2014-03-28','07:25:00',2.77),('8975','2014-03-28','07:30:00',2.88),('8975','2014-03-28','07:35:00',3.04),('8975','2014-03-28','07:40:00',3.19),('8975','2014-03-28','07:45:00',3.32),('8975','2014-03-28','07:50:00',3.42),('8975','2014-03-28','07:55:00',3.52),('8975','2014-03-28','08:00:00',3.6),('8975','2014-03-28','08:05:00',3.67),('8975','2014-03-28','08:10:00',3.82),('8975','2014-03-28','08:15:00',3.93),('8975','2014-03-28','08:20:00',3.97),('8975','2014-03-28','08:25:00',4.05),('8975','2014-03-28','08:30:00',4.13),('8975','2014-03-28','08:35:00',4.23),('8975','2014-03-28','08:40:00',4.32),('8975','2014-03-28','08:45:00',4.43),('8975','2014-03-28','08:50:00',4.52),('8975','2014-03-28','08:55:00',4.63),('8975','2014-03-28','09:00:00',4.77),('8975','2014-03-28','09:05:00',4.84),('8975','2014-03-28','09:10:00',4.97),('8975','2014-03-28','09:15:00',5.06),('8975','2014-03-28','09:20:00',5.15),('8975','2014-03-28','09:25:00',5.26),('8975','2014-03-28','09:30:00',5.32),('8975','2014-03-28','09:35:00',5.37),('8975','2014-03-28','09:40:00',5.45),('8975','2014-03-28','09:45:00',5.49),('8975','2014-03-28','09:50:00',5.53),('8975','2014-03-28','09:55:00',5.56),('8975','2014-03-28','10:00:00',5.61),('8975','2014-03-28','10:05:00',5.64),('8975','2014-03-28','10:10:00',5.74),('8975','2014-03-28','10:15:00',5.77),('8975','2014-03-28','10:20:00',5.86),('8975','2014-03-28','10:25:00',5.95),('8975','2014-03-28','10:30:00',5.97),('8975','2014-03-28','10:35:00',5.98),('8975','2014-03-28','10:40:00',6.03),('8975','2014-03-28','10:45:00',6.09),('8975','2014-03-28','10:50:00',6.1),('8975','2014-03-28','10:55:00',6.15),('8975','2014-03-28','11:00:00',6.15),('8975','2014-03-28','11:05:00',6.11),('8975','2014-03-28','11:10:00',6.12),('8975','2014-03-28','11:15:00',6.11),('8975','2014-03-28','11:20:00',6.1),('8975','2014-03-28','11:25:00',6.14),('8975','2014-03-28','11:30:00',6.2),('8975','2014-03-28','11:35:00',6.14),('8975','2014-03-28','11:40:00',6.01),('8975','2014-03-28','11:45:00',6.1),('8975','2014-03-28','11:50:00',6.1),('8975','2014-03-28','11:55:00',6.06),('8975','2014-03-28','12:00:00',6.01),('8975','2014-03-28','12:05:00',5.93),('8975','2014-03-28','12:10:00',5.96),('8975','2014-03-28','12:15:00',5.91),('8975','2014-03-28','12:20:00',5.85),('8975','2014-03-28','12:25:00',5.83),('8975','2014-03-28','12:30:00',5.79),('8975','2014-03-28','12:35:00',4.87),('8975','2014-03-28','12:40:00',5.64),('8975','2014-03-28','12:45:00',5.69),('8975','2014-03-28','12:50:00',5.67),('8975','2014-03-28','12:55:00',5.58),('8975','2014-03-28','13:00:00',5.57),('8975','2014-03-28','13:05:00',5.45),('8975','2014-03-28','13:10:00',5.42),('8975','2014-03-28','13:15:00',5.3),('8975','2014-03-28','13:20:00',5.22),('8975','2014-03-28','13:25:00',5.12),('8975','2014-03-28','13:30:00',4.97),('8975','2014-03-28','13:35:00',4.93),('8975','2014-03-28','13:40:00',4.9),('8975','2014-03-28','13:45:00',4.78),('8975','2014-03-28','13:50:00',4.64),('8975','2014-03-28','13:55:00',4.58),('8975','2014-03-28','14:00:00',4.52),('8975','2014-03-28','14:05:00',4.37),('8975','2014-03-28','14:10:00',4.15),('8975','2014-03-28','14:15:00',4.04),('8975','2014-03-28','14:20:00',3.95),('8975','2014-03-28','14:25:00',3.85),('8975','2014-03-28','14:30:00',3.79),('8975','2014-03-28','14:35:00',3.66),('8975','2014-03-28','14:40:00',3.65),('8975','2014-03-28','14:45:00',3.55),('8975','2014-03-28','14:50:00',3.42),('8975','2014-03-28','14:55:00',3.18),('8975','2014-03-28','15:00:00',2.83),('8975','2014-03-28','15:05:00',3.13),('8975','2014-03-28','15:10:00',2.79),('8975','2014-03-28','15:15:00',2.94),('8975','2014-03-28','15:20:00',2.83),('8975','2014-03-28','15:25:00',2.68),('8975','2014-03-28','15:30:00',2.53),('8975','2014-03-28','15:35:00',2.43),('8975','2014-03-28','15:40:00',2.36),('8975','2014-03-28','15:45:00',2.26),('8975','2014-03-28','15:50:00',2.12),('8975','2014-03-28','15:55:00',2.03),('8975','2014-03-28','16:00:00',1.96),('8975','2014-03-28','16:05:00',1.87),('8975','2014-03-28','16:10:00',1.78),('8975','2014-03-28','16:15:00',1.71),('8975','2014-03-28','16:20:00',1.58),('8975','2014-03-28','16:25:00',1.56),('8975','2014-03-28','16:30:00',1.53),('8975','2014-03-28','16:35:00',1.38),('8975','2014-03-28','16:40:00',1.26),('8975','2014-03-28','16:45:00',1.06),('8975','2014-03-28','16:50:00',1.13),('8975','2014-03-28','16:55:00',1.22),('8975','2014-03-28','17:00:00',1.18),('8975','2014-03-28','17:05:00',1.1),('8975','2014-03-28','17:10:00',1.03),('8975','2013-04-20','07:55:00',1.74),('8975','2013-04-20','08:00:00',1.8),('8975','2013-04-20','08:05:00',1.88),('8975','2013-04-20','08:10:00',2.22),('8975','2013-04-20','08:15:00',2.03),('8975','2013-04-20','08:20:00',1.88),('8975','2013-04-20','08:25:00',2.76),('8975','2013-04-20','08:30:00',3.16),('8975','2013-04-20','08:35:00',2.57),('8975','2013-04-20','08:40:00',1.79),('8975','2013-04-20','08:45:00',1.84),('8975','2013-04-20','08:50:00',2.38),('8975','2013-04-20','08:55:00',2.3),('8975','2013-04-20','09:00:00',3.51),('8975','2013-04-20','09:05:00',3.44),('8975','2013-04-20','09:10:00',4.34),('8975','2013-04-20','09:15:00',3.72),('8975','2013-04-20','09:20:00',2.21),('8975','2013-04-20','09:25:00',3.47),('8975','2013-04-20','09:30:00',5.58),('8975','2013-04-20','09:35:00',4.94),('8975','2013-04-20','09:40:00',5.33),('8975','2013-04-20','09:45:00',6.04),('8975','2013-04-20','09:50:00',4.61),('8975','2013-04-20','09:55:00',5.34),('8975','2013-04-20','10:00:00',4.25),('8975','2013-04-20','10:05:00',3.61),('8975','2013-04-20','10:10:00',3.54),('8975','2013-04-20','10:15:00',3.98),('8975','2013-04-20','10:20:00',6.48),('8975','2013-04-20','10:25:00',3.56),('8975','2013-04-20','10:30:00',3.47),('8975','2013-04-20','10:35:00',4),('8975','2013-04-20','10:40:00',5.93),('8975','2013-04-20','10:45:00',3.38),('8975','2013-04-20','10:50:00',3.87),('8975','2013-04-20','10:55:00',4.79),('8975','2013-04-20','11:00:00',7.04),('8975','2013-04-20','11:05:00',5.61),('8975','2013-04-20','11:10:00',4.85),('8975','2013-04-20','11:15:00',4.42),('8975','2013-04-20','11:20:00',4.99),('8975','2013-04-20','11:25:00',4.34),('8975','2013-04-20','11:30:00',4.28),('8975','2013-04-20','11:35:00',4.32),('8975','2013-04-20','11:40:00',4.41),('8975','2013-04-20','11:45:00',5),('8975','2013-04-20','11:50:00',4.38),('8975','2013-04-20','11:55:00',4.69),('8975','2013-04-20','12:00:00',3.83),('8975','2013-04-20','12:05:00',3.9),('8975','2013-04-20','12:10:00',3.65),('8975','2013-04-20','12:15:00',3.53),('8975','2013-04-20','12:20:00',3.11),('8975','2013-04-20','12:25:00',3.25),('8975','2013-04-20','12:30:00',3.45),('8975','2013-04-20','12:35:00',3.45),('8975','2013-04-20','12:40:00',3.51),('8975','2013-04-20','12:45:00',3.46),('8975','2013-04-20','12:50:00',3.25),('8975','2013-04-20','12:55:00',3.3),('8975','2013-04-20','13:00:00',3.87),('8975','2013-04-20','13:05:00',4.1),('8975','2013-04-20','13:10:00',4.23),('8975','2013-04-20','13:15:00',3.77),('8975','2013-04-20','13:20:00',3.59),('8975','2013-04-20','13:25:00',3.78),('8975','2013-04-20','13:30:00',6.3),('8975','2013-04-20','13:35:00',5.51),('8975','2013-04-20','13:40:00',5.06),('8975','2013-04-20','13:45:00',4.92),('8975','2013-04-20','13:50:00',4.09),('8975','2013-04-20','13:55:00',6.83),('8975','2013-04-20','14:00:00',6.48),('8975','2013-04-20','14:05:00',6.4),('8975','2013-04-20','14:10:00',6.31),('8975','2013-04-20','14:15:00',6.71),('8975','2013-04-20','14:20:00',6.45),('8975','2013-04-20','14:25:00',6.33),('8975','2013-04-20','14:30:00',5.6),('8975','2013-04-20','14:35:00',5.98),('8975','2013-04-20','14:40:00',5.45),('8975','2013-04-20','14:45:00',3.61),('8975','2013-04-20','14:50:00',2.83),('8975','2013-04-20','14:55:00',2.77),('8975','2013-04-20','15:00:00',5.1),('8975','2013-04-20','15:05:00',5.36),('8975','2013-04-20','15:10:00',4.71),('8975','2013-04-20','15:15:00',3.26),('8975','2013-04-20','15:20:00',2.64),('8975','2013-04-20','15:25:00',2.75),('8975','2013-04-20','15:30:00',2.49),('8975','2013-04-20','15:35:00',2.18),('8975','2013-04-20','15:40:00',2.19),('8975','2013-04-20','15:45:00',1.82),('8975','2013-04-20','15:50:00',1.61),('8975','2013-04-20','15:55:00',1.45),('8975','2013-04-20','16:00:00',1.27),('8975','2013-04-20','16:05:00',1.13),('8975','2013-04-20','16:10:00',1.18),('8975','2013-04-20','16:15:00',1.13),('8975','2013-04-20','16:35:00',1.01),('8975','2013-04-20','16:55:00',1.25),('8975','2013-04-20','17:00:00',1.42),('8975','2013-04-20','17:05:00',1.31),('8975','2013-04-20','17:10:00',1.11),('8975','2013-04-20','17:15:00',1.1),('8975','2013-04-19','07:15:00',1),('8975','2013-04-19','07:25:00',1.43),('8975','2013-04-19','07:30:00',1.87),('8975','2013-04-19','07:35:00',2.43),('8975','2013-04-19','07:40:00',2.35),('8975','2013-04-19','07:45:00',1.85),('8975','2013-04-19','07:50:00',2.04),('8975','2013-04-19','07:55:00',2.28),('8975','2013-04-19','08:00:00',2.55),('8975','2013-04-19','08:05:00',2.73),('8975','2013-04-19','08:10:00',3.01),('8975','2013-04-19','08:15:00',2.64),('8975','2013-04-19','08:20:00',2.63),('8975','2013-04-19','08:25:00',2.91),('8975','2013-04-19','08:30:00',3.17),('8975','2013-04-19','08:35:00',3.48),('8975','2013-04-19','08:40:00',3.82),('8975','2013-04-19','08:45:00',3.97),('8975','2013-04-19','08:50:00',3.46),('8975','2013-04-19','08:55:00',4.37),('8975','2013-04-19','09:00:00',3.98),('8975','2013-04-19','09:05:00',4.66),('8975','2013-04-19','09:10:00',5.04),('8975','2013-04-19','09:15:00',4.74),('8975','2013-04-19','09:20:00',4.96),('8975','2013-04-19','09:25:00',4.4),('8975','2013-04-19','09:30:00',2.48),('8975','2013-04-19','09:35:00',2.54),('8975','2013-04-19','09:40:00',1.69),('8975','2013-04-19','09:45:00',1.43),('8975','2013-04-19','09:50:00',1.41),('8975','2013-04-19','09:55:00',1.2),('8975','2013-04-19','10:25:00',1.45),('8975','2013-04-19','10:30:00',1.99),('8975','2013-04-19','10:35:00',2.43),('8975','2013-04-19','10:40:00',5.05),('8975','2013-04-19','10:45:00',6.43),('8975','2013-04-19','10:50:00',5.1),('8975','2013-04-19','10:55:00',3.12),('8975','2013-04-19','11:00:00',5.23),('8975','2013-04-19','11:05:00',6.53),('8975','2013-04-19','11:10:00',6.92),('8975','2013-04-19','11:15:00',5.42),('8975','2013-04-19','11:20:00',7.31),('8975','2013-04-19','11:25:00',5.6),('8975','2013-04-19','11:30:00',2.58),('8975','2013-04-19','11:35:00',5.19),('8975','2013-04-19','11:40:00',7.12),('8975','2013-04-19','11:45:00',7.39),('8975','2013-04-19','11:50:00',7.18),('8975','2013-04-19','11:55:00',5.09),('8975','2013-04-19','12:00:00',6.79),('8975','2013-04-19','12:05:00',6.56),('8975','2013-04-19','12:10:00',6.86),('8975','2013-04-19','12:15:00',6.82),('8975','2013-04-19','12:20:00',6.78),('8975','2013-04-19','12:25:00',6.89),('8975','2013-04-19','12:30:00',6.88),('8975','2013-04-19','12:35:00',6.63),('8975','2013-04-19','12:40:00',6.69),('8975','2013-04-19','12:45:00',6.73),('8975','2013-04-19','12:50:00',3.9),('8975','2013-04-19','12:55:00',3.54),('8975','2013-04-19','13:00:00',6.98),('8975','2013-04-19','13:05:00',5.05),('8975','2013-04-19','13:10:00',2.07),('8975','2013-04-19','13:15:00',6.59),('8975','2013-04-19','13:20:00',6.81),('8975','2013-04-19','13:25:00',6.63),('8975','2013-04-19','13:30:00',6.55),('8975','2013-04-19','13:35:00',5.6),('8975','2013-04-19','13:40:00',2.69),('8975','2013-04-19','13:45:00',5.44),('8975','2013-04-19','13:50:00',4),('8975','2013-04-19','13:55:00',5.72),('8975','2013-04-19','14:00:00',7.02),('8975','2013-04-19','14:05:00',6.2),('8975','2013-04-19','14:10:00',5.68),('8975','2013-04-19','14:15:00',5.69),('8975','2013-04-19','14:20:00',5.58),('8975','2013-04-19','14:25:00',5.4),('8975','2013-04-19','14:30:00',5.36),('8975','2013-04-19','14:35:00',5.27),('8975','2013-04-19','14:40:00',5.21),('8975','2013-04-19','14:45:00',5.29),('8975','2013-04-19','14:50:00',5.24),('8975','2013-04-19','14:55:00',5.14),('8975','2013-04-19','15:00:00',5.04),('8975','2013-04-19','15:05:00',4.87),('8975','2013-04-19','15:10:00',3.95),('8975','2013-04-19','15:15:00',4.64),('8975','2013-04-19','15:20:00',4.38),('8975','2013-04-19','15:25:00',3.14),('8975','2013-04-19','15:30:00',1.67),('8975','2013-04-19','15:35:00',1.17),('8975','2013-04-19','15:40:00',1.16),('8975','2013-04-19','15:45:00',1.22),('8975','2013-04-19','15:50:00',1.17),('8975','2013-04-19','15:55:00',1.13),('8975','2013-04-19','16:00:00',1.3),('8975','2013-04-19','16:05:00',1.77),('8975','2013-04-19','16:10:00',2.34),('8975','2013-04-19','16:15:00',2.52),('8975','2013-04-19','16:20:00',3.16),('8975','2013-04-19','16:25:00',3.21),('8975','2013-04-19','16:30:00',3.16),('8975','2013-04-19','16:35:00',3.6),('8975','2013-04-19','16:40:00',3.89),('8975','2013-04-19','16:45:00',3.46),('8975','2013-04-19','16:50:00',3.09),('8975','2013-04-19','16:55:00',2.82),('8975','2013-04-19','17:00:00',2.65),('8975','2013-04-19','17:05:00',2.47),('8975','2013-04-19','17:10:00',2.42),('8975','2013-04-19','17:15:00',2.27),('8975','2013-04-19','17:20:00',2.16),('8975','2013-04-19','17:25:00',2.21),('8975','2013-04-19','17:30:00',2.24),('8975','2013-04-19','17:35:00',2.16),('8975','2013-04-19','17:40:00',1.8),('8975','2013-04-19','17:45:00',1.12),('8975','2013-04-19','17:50:00',1.08),('8975','2013-04-19','17:55:00',1.47),('8975','2013-04-19','18:00:00',1.28),('8975','2013-04-19','18:05:00',1.68),('8975','2013-04-19','18:10:00',1.76),('8975','2013-04-19','18:15:00',1.4),('8975','2013-04-18','07:30:00',1.18),('8975','2013-04-18','07:40:00',1.08),('8975','2013-04-18','07:50:00',1.42),('8975','2013-04-18','07:55:00',2.12),('8975','2013-04-18','08:00:00',2.83),('8975','2013-04-18','08:05:00',1.13),('8975','2013-04-18','08:10:00',2.51),('8975','2013-04-18','08:15:00',2.87),('8975','2013-04-18','08:20:00',3.23),('8975','2013-04-18','08:25:00',3.38),('8975','2013-04-18','08:30:00',3.3),('8975','2013-04-18','08:35:00',3.64),('8975','2013-04-18','08:40:00',3.78),('8975','2013-04-18','08:45:00',3.9),('8975','2013-04-18','08:50:00',4.07),('8975','2013-04-18','08:55:00',4.25),('8975','2013-04-18','09:00:00',4.29),('8975','2013-04-18','09:05:00',4.04),('8975','2013-04-18','09:10:00',4.37),('8975','2013-04-18','09:15:00',4.33),('8975','2013-04-18','09:20:00',4.46),('8975','2013-04-18','09:25:00',4.47),('8975','2013-04-18','09:30:00',4.57),('8975','2013-04-18','09:35:00',4.72),('8975','2013-04-18','09:40:00',4.74),('8975','2013-04-18','09:45:00',4.74),('8975','2013-04-18','09:50:00',4.77),('8975','2013-04-18','09:55:00',4.86),('8975','2013-04-18','10:00:00',4.95),('8975','2013-04-18','10:05:00',5),('8975','2013-04-18','10:10:00',5.15),('8975','2013-04-18','10:15:00',5.23),('8975','2013-04-18','10:20:00',5.4),('8975','2013-04-18','10:25:00',5.49),('8975','2013-04-18','10:30:00',5.48),('8975','2013-04-18','10:35:00',5.5),('8975','2013-04-18','10:40:00',5.59),('8975','2013-04-18','10:45:00',5.63),('8975','2013-04-18','10:50:00',5.64),('8975','2013-04-18','10:55:00',5.65),('8975','2013-04-18','11:00:00',5.63),('8975','2013-04-18','11:05:00',5.75),('8975','2013-04-18','11:10:00',5.78),('8975','2013-04-18','11:15:00',5.76),('8975','2013-04-18','11:20:00',5.73),('8975','2013-04-18','11:25:00',5.79),('8975','2013-04-18','11:30:00',5.83),('8975','2013-04-18','11:35:00',5.9),('8975','2013-04-18','11:40:00',5.94),('8975','2013-04-18','11:45:00',5.76),('8975','2013-04-18','11:50:00',5.94),('8975','2013-04-18','11:55:00',6.07),('8975','2013-04-18','12:00:00',5.99),('8975','2013-04-18','12:05:00',6.1),('8975','2013-04-18','12:10:00',6.07),('8975','2013-04-18','12:15:00',6.13),('8975','2013-04-18','12:20:00',6.08),('8975','2013-04-18','12:25:00',6.12),('8975','2013-04-18','12:30:00',6),('8975','2013-04-18','12:35:00',5.92),('8975','2013-04-18','12:40:00',5.99),('8975','2013-04-18','12:45:00',5.96),('8975','2013-04-18','12:50:00',5.81),('8975','2013-04-18','12:55:00',5.92),('8975','2013-04-18','13:00:00',5.88),('8975','2013-04-18','13:05:00',5.91),('8975','2013-04-18','13:10:00',5.99),('8975','2013-04-18','13:15:00',5.81),('8975','2013-04-18','13:20:00',5.83),('8975','2013-04-18','13:25:00',5.88),('8975','2013-04-18','13:30:00',5.85),('8975','2013-04-18','13:35:00',5.77),('8975','2013-04-18','13:40:00',5.67),('8975','2013-04-18','13:45:00',5.63),('8975','2013-04-18','13:50:00',5.56),('8975','2013-04-18','13:55:00',5.53),('8975','2013-04-18','14:00:00',5.47),('8975','2013-04-18','14:05:00',5.5),('8975','2013-04-18','14:10:00',5.36),('8975','2013-04-18','14:15:00',5.27),('8975','2013-04-18','14:20:00',5.26),('8975','2013-04-18','14:25:00',5.07),('8975','2013-04-18','14:30:00',4.6),('8975','2013-04-18','14:35:00',4.7),('8975','2013-04-18','14:40:00',4.22),('8975','2013-04-18','14:45:00',4.86),('8975','2013-04-18','14:50:00',4.67),('8975','2013-04-18','14:55:00',4.36),('8975','2013-04-18','15:00:00',4.28),('8975','2013-04-18','15:05:00',4.26),('8975','2013-04-18','15:10:00',4.43),('8975','2013-04-18','15:15:00',4.06),('8975','2013-04-18','15:20:00',3.75),('8975','2013-04-18','15:25:00',4.2),('8975','2013-04-18','15:30:00',4.04),('8975','2013-04-18','15:35:00',3.98),('8975','2013-04-18','15:40:00',3.9),('8975','2013-04-18','15:45:00',3.8),('8975','2013-04-18','15:50:00',3.69),('8975','2013-04-18','15:55:00',3.58),('8975','2013-04-18','16:00:00',3.49),('8975','2013-04-18','16:05:00',3.4),('8975','2013-04-18','16:10:00',3.3),('8975','2013-04-18','16:15:00',3.21),('8975','2013-04-18','16:20:00',3.1),('8975','2013-04-18','16:25:00',3.01),('8975','2013-04-18','16:30:00',2.89),('8975','2013-04-18','16:35:00',2.79),('8975','2013-04-18','16:40:00',2.7),('8975','2013-04-18','16:45:00',2.61),('8975','2013-04-18','16:50:00',2.47),('8975','2013-04-18','16:55:00',2.36),('8975','2013-04-18','17:00:00',2.26),('8975','2013-04-18','17:05:00',2.16),('8975','2013-04-18','17:10:00',2.06),('8975','2013-04-18','17:15:00',1.95),('8975','2013-04-18','17:20:00',1.86),('8975','2013-04-18','17:25:00',1.78),('8975','2013-04-18','17:30:00',1.7),('8975','2013-04-18','17:35:00',1.61),('8975','2013-04-18','17:40:00',1.53),('8975','2013-04-18','17:45:00',1.46),('8975','2013-04-18','17:50:00',1.38),('8975','2013-04-18','17:55:00',1.33),('8975','2013-04-18','18:00:00',1.29),('8975','2013-04-18','18:05:00',1.22),('8975','2013-04-18','18:10:00',1.16),('8975','2013-04-18','18:15:00',1.11),('8975','2013-04-18','18:20:00',1.06),('8975','2013-04-18','18:25:00',1.02),('8975','2013-04-17','07:00:00',1.34),('8975','2013-04-17','07:05:00',1.54),('8975','2013-04-17','07:10:00',1.68),('8975','2013-04-17','07:40:00',1.13),('8975','2013-04-17','07:45:00',1.14),('8975','2013-04-17','07:50:00',1.23),('8975','2013-04-17','07:55:00',1.26),('8975','2013-04-17','08:00:00',1.46),('8975','2013-04-17','08:05:00',1.93),('8975','2013-04-17','08:10:00',2.73),('8975','2013-04-17','08:15:00',2.85),('8975','2013-04-17','08:20:00',2.85),('8975','2013-04-17','08:25:00',2.85),('8975','2013-04-17','08:30:00',2.82),('8975','2013-04-17','08:35:00',3.23),('8975','2013-04-17','08:40:00',2.88),('8975','2013-04-17','08:45:00',2.93),('8975','2013-04-17','08:50:00',3.1),('8975','2013-04-17','08:55:00',3.53),('8975','2013-04-17','09:00:00',3.7),('8975','2013-04-17','09:05:00',3.87),('8975','2013-04-17','09:10:00',3.89),('8975','2013-04-17','09:15:00',3.94),('8975','2013-04-17','09:20:00',4.03),('8975','2013-04-17','09:25:00',3.97),('8975','2013-04-17','09:30:00',4.25),('8975','2013-04-17','09:35:00',4.65),('8975','2013-04-17','09:40:00',5.05),('8975','2013-04-17','09:45:00',5.1),('8975','2013-04-17','09:50:00',4.16),('8975','2013-04-17','09:55:00',3.97),('8975','2013-04-17','10:00:00',4.56),('8975','2013-04-17','10:05:00',5.11),('8975','2013-04-17','10:10:00',5.33),('8975','2013-04-17','10:15:00',5.75),('8975','2013-04-17','10:20:00',5.78),('8975','2013-04-17','10:25:00',5.63),('8975','2013-04-17','10:30:00',5.76),('8975','2013-04-17','10:35:00',5.76),('8975','2013-04-17','10:40:00',5.8),('8975','2013-04-17','10:45:00',5.84),('8975','2013-04-17','10:50:00',5.85),('8975','2013-04-17','10:55:00',5.93),('8975','2013-04-17','11:00:00',5.92),('8975','2013-04-17','11:05:00',5.96),('8975','2013-04-17','11:10:00',5.99),('8975','2013-04-17','11:15:00',6.05),('8975','2013-04-17','11:20:00',6.07),('8975','2013-04-17','11:25:00',6.11),('8975','2013-04-17','11:30:00',6.1),('8975','2013-04-17','11:35:00',6.17),('8975','2013-04-17','11:40:00',6.13),('8975','2013-04-17','11:45:00',6.19),('8975','2013-04-17','11:50:00',6.08),('8975','2013-04-17','11:55:00',6.27),('8975','2013-04-17','12:00:00',6.14),('8975','2013-04-17','12:05:00',6.25),('8975','2013-04-17','12:10:00',6.27),('8975','2013-04-17','12:15:00',6.24),('8975','2013-04-17','12:20:00',6.31),('8975','2013-04-17','12:25:00',6.28),('8975','2013-04-17','12:30:00',6.29),('8975','2013-04-17','12:35:00',6.26),('8975','2013-04-17','12:40:00',6.27),('8975','2013-04-17','12:45:00',6.24),('8975','2013-04-17','12:50:00',6.27),('8975','2013-04-17','12:55:00',6.29),('8975','2013-04-17','13:00:00',6.22),('8975','2013-04-17','13:05:00',6.24),('8975','2013-04-17','13:10:00',6.23),('8975','2013-04-17','13:15:00',6.2),('8975','2013-04-17','13:20:00',6.14),('8975','2013-04-17','13:25:00',6.08),('8975','2013-04-17','13:30:00',6.03),('8975','2013-04-17','13:35:00',6.03),('8975','2013-04-17','13:40:00',5.98),('8975','2013-04-17','13:45:00',5.92),('8975','2013-04-17','13:50:00',5.89),('8975','2013-04-17','13:55:00',5.86),('8975','2013-04-17','14:00:00',5.8),('8975','2013-04-17','14:05:00',5.73),('8975','2013-04-17','14:10:00',5.68),('8975','2013-04-17','14:15:00',5.57),('8975','2013-04-17','14:20:00',5.55),('8975','2013-04-17','14:25:00',5.48),('8975','2013-04-17','14:30:00',5.41),('8975','2013-04-17','14:35:00',5.33),('8975','2013-04-17','14:40:00',5.23),('8975','2013-04-17','14:45:00',5.16),('8975','2013-04-17','14:50:00',5.08),('8975','2013-04-17','14:55:00',4.99),('8975','2013-04-17','15:00:00',4.88),('8975','2013-04-17','15:05:00',4.76),('8975','2013-04-17','15:10:00',4.68),('8975','2013-04-17','15:15:00',4.58),('8975','2013-04-17','15:20:00',4.49),('8975','2013-04-17','15:25:00',4.41),('8975','2013-04-17','15:30:00',4.16),('8975','2013-04-17','15:35:00',3.97),('8975','2013-04-17','15:40:00',4.05),('8975','2013-04-17','15:45:00',3.95),('8975','2013-04-17','15:50:00',3.85),('8975','2013-04-17','15:55:00',3.73),('8975','2013-04-17','16:00:00',3.58),('8975','2013-04-17','16:05:00',3.46),('8975','2013-04-17','16:10:00',3.37),('8975','2013-04-17','16:15:00',3.25),('8975','2013-04-17','16:20:00',3.14),('8975','2013-04-17','16:25:00',3.07),('8975','2013-04-17','16:30:00',2.94),('8975','2013-04-17','16:35:00',2.84),('8975','2013-04-17','16:40:00',2.75),('8975','2013-04-17','16:45:00',2.62),('8975','2013-04-17','16:50:00',2.52),('8975','2013-04-17','16:55:00',2.42),('8975','2013-04-17','17:00:00',2.32),('8975','2013-04-17','17:05:00',2.19),('8975','2013-04-17','17:10:00',2.07),('8975','2013-04-17','17:15:00',1.99),('8975','2013-04-17','17:20:00',1.91),('8975','2013-04-17','17:25:00',1.82),('8975','2013-04-17','17:30:00',1.73),('8975','2013-04-17','17:35:00',1.65),('8975','2013-04-17','17:40:00',1.57),('8975','2013-04-17','17:45:00',1.49),('8975','2013-04-17','17:50:00',1.45),('8975','2013-04-17','17:55:00',1.4),('8975','2013-04-17','18:00:00',1.36),('8975','2013-04-17','18:05:00',1.3),('8975','2013-04-17','18:10:00',1.24),('8975','2013-04-17','18:15:00',1.17),('8975','2013-04-17','18:20:00',1.11),('8975','2013-04-17','18:25:00',1.03),('8975','2013-04-16','07:00:00',1.06),('8975','2013-04-16','07:05:00',1.25),('8975','2013-04-16','07:10:00',1.47),('8975','2013-04-16','07:15:00',1.58),('8975','2013-04-16','07:20:00',1.67),('8975','2013-04-16','07:25:00',2.02),('8975','2013-04-16','07:30:00',2.13),('8975','2013-04-16','07:35:00',2.33),('8975','2013-04-16','07:40:00',2.52),('8975','2013-04-16','07:45:00',2.66),('8975','2013-04-16','07:50:00',2.8),('8975','2013-04-16','07:55:00',2.92),('8975','2013-04-16','08:00:00',3.05),('8975','2013-04-16','08:05:00',3.16),('8975','2013-04-16','08:10:00',3.29),('8975','2013-04-16','08:15:00',3.42),('8975','2013-04-16','08:20:00',3.52),('8975','2013-04-16','08:25:00',3.62),('8975','2013-04-16','08:30:00',3.71),('8975','2013-04-16','08:35:00',3.81),('8975','2013-04-16','08:40:00',3.9),('8975','2013-04-16','08:45:00',4),('8975','2013-04-16','08:50:00',4.1),('8975','2013-04-16','08:55:00',4.18),('8975','2013-04-16','09:00:00',4.27),('8975','2013-04-16','09:05:00',4.35),('8975','2013-04-16','09:10:00',4.44),('8975','2013-04-16','09:15:00',4.55),('8975','2013-04-16','09:20:00',4.65),('8975','2013-04-16','09:25:00',4.76),('8975','2013-04-16','09:30:00',4.83),('8975','2013-04-16','09:35:00',4.94),('8975','2013-04-16','09:40:00',5.04),('8975','2013-04-16','09:45:00',5.12),('8975','2013-04-16','09:50:00',5.18),('8975','2013-04-16','09:55:00',5.26),('8975','2013-04-16','10:00:00',5.32),('8975','2013-04-16','10:05:00',5.38),('8975','2013-04-16','10:10:00',5.48),('8975','2013-04-16','10:15:00',5.55),('8975','2013-04-16','10:20:00',5.63),('8975','2013-04-16','10:25:00',5.67),('8975','2013-04-16','10:30:00',5.73),('8975','2013-04-16','10:35:00',5.77),('8975','2013-04-16','10:40:00',5.81),('8975','2013-04-16','10:45:00',5.85),('8975','2013-04-16','10:50:00',5.93),('8975','2013-04-16','10:55:00',5.96),('8975','2013-04-16','11:00:00',5.98),('8975','2013-04-16','11:05:00',6.03),('8975','2013-04-16','11:10:00',6.12),('8975','2013-04-16','11:15:00',6.16),('8975','2013-04-16','11:20:00',6.18),('8975','2013-04-16','11:25:00',6.18),('8975','2013-04-16','11:30:00',6.21),('8975','2013-04-16','11:35:00',6.25),('8975','2013-04-16','11:40:00',6.25),('8975','2013-04-16','11:45:00',6.27),('8975','2013-04-16','11:50:00',6.28),('8975','2013-04-16','11:55:00',6.31),('8975','2013-04-16','12:00:00',6.29),('8975','2013-04-16','12:05:00',6.26),('8975','2013-04-16','12:10:00',6.29),('8975','2013-04-16','12:15:00',6.31),('8975','2013-04-16','12:20:00',6.27),('8975','2013-04-16','12:25:00',6.32),('8975','2013-04-16','12:30:00',6.28),('8975','2013-04-16','12:35:00',6.3),('8975','2013-04-16','12:40:00',6.28),('8975','2013-04-16','12:45:00',6.25),('8975','2013-04-16','12:50:00',6.24),('8975','2013-04-16','12:55:00',6.23),('8975','2013-04-16','13:00:00',6.2),('8975','2013-04-16','13:05:00',6.15),('8975','2013-04-16','13:10:00',5.75),('8975','2013-04-16','13:15:00',4.8),('8975','2013-04-16','13:20:00',4.99),('8975','2013-04-16','13:25:00',5.51),('8975','2013-04-16','13:30:00',5.37),('8975','2013-04-16','13:35:00',6.04),('8975','2013-04-16','13:40:00',5.88),('8975','2013-04-16','13:45:00',5.57),('8975','2013-04-16','13:50:00',5.68),('8975','2013-04-16','13:55:00',5.53),('8975','2013-04-16','14:00:00',5.59),('8975','2013-04-16','14:05:00',5.95),('8975','2013-04-16','14:10:00',6.25),('8975','2013-04-16','14:15:00',5.94),('8975','2013-04-16','14:20:00',5.89),('8975','2013-04-16','14:25:00',5.22),('8975','2013-04-16','14:30:00',5.25),('8975','2013-04-16','14:35:00',6.04),('8975','2013-04-16','14:40:00',5.22),('8975','2013-04-16','14:45:00',4.95),('8975','2013-04-16','14:50:00',5.78),('8975','2013-04-16','14:55:00',5.5),('8975','2013-04-16','15:00:00',5.4),('8975','2013-04-16','15:05:00',5.43),('8975','2013-04-16','15:10:00',5.63),('8975','2013-04-16','15:15:00',5.12),('8975','2013-04-16','15:20:00',3.65),('8975','2013-04-16','15:25:00',2.27),('8975','2013-04-16','15:30:00',3.44),('8975','2013-04-16','15:35:00',4.08),('8975','2013-04-16','15:40:00',4.48),('8975','2013-04-16','15:45:00',4.46),('8975','2013-04-16','15:50:00',4.47),('8975','2013-04-16','15:55:00',4.34),('8975','2013-04-16','16:00:00',4.23),('8975','2013-04-16','16:05:00',3.34),('8975','2013-04-16','16:10:00',3.52),('8975','2013-04-16','16:15:00',3.64),('8975','2013-04-16','16:20:00',3.42),('8975','2013-04-16','16:25:00',3.3),('8975','2013-04-16','16:30:00',3.21),('8975','2013-04-16','16:35:00',3.13),('8975','2013-04-16','16:40:00',2.92),('8975','2013-04-16','16:45:00',2.75),('8975','2013-04-16','16:50:00',2.7),('8975','2013-04-16','16:55:00',2.52),('8975','2013-04-16','17:00:00',2.38),('8975','2013-04-16','17:05:00',2.24),('8975','2013-04-16','17:10:00',2.13),('8975','2013-04-16','17:15:00',2.01),('8975','2013-04-16','17:20:00',1.92),('8975','2013-04-16','17:25:00',1.83),('8975','2013-04-16','17:30:00',1.73),('8975','2013-04-16','17:35:00',1.64),('8975','2013-04-16','17:40:00',1.57),('8975','2013-04-16','17:45:00',1.5),('8975','2013-04-16','17:50:00',1.44),('8975','2013-04-16','17:55:00',1.39),('8975','2013-04-16','18:00:00',1.34),('8975','2013-04-16','18:05:00',1.28),('8975','2013-04-16','18:10:00',1.24),('8975','2013-04-16','18:15:00',1.18),('8975','2013-04-16','18:20:00',1.12),('8975','2013-04-16','18:25:00',1.06),('8975','2013-04-16','18:30:00',1),('8975','2013-04-15','07:15:00',1.02),('8975','2013-04-15','07:20:00',1.05),('8975','2013-04-15','07:30:00',1.02),('8975','2013-04-15','07:35:00',1.05),('8975','2013-04-15','07:40:00',2),('8975','2013-04-15','07:45:00',2.17),('8975','2013-04-15','07:50:00',2.31),('8975','2013-04-15','07:55:00',2.26),('8975','2013-04-15','08:00:00',2.43),('8975','2013-04-15','08:05:00',2.73),('8975','2013-04-15','08:10:00',2.86),('8975','2013-04-15','08:15:00',2.67),('8975','2013-04-15','08:20:00',1.33),('8975','2013-04-15','08:25:00',1.45),('8975','2013-04-15','08:30:00',1.53),('8975','2013-04-15','08:35:00',1.39),('8975','2013-04-15','08:40:00',1.49),('8975','2013-04-15','08:45:00',1.65),('8975','2013-04-15','08:50:00',1.93),('8975','2013-04-15','08:55:00',2.53),('8975','2013-04-15','09:00:00',2.08),('8975','2013-04-15','09:05:00',1.43),('8975','2013-04-15','09:10:00',1.74),('8975','2013-04-15','09:15:00',4.01),('8975','2013-04-15','09:20:00',3.33),('8975','2013-04-15','09:25:00',2.36),('8975','2013-04-15','09:30:00',3.26),('8975','2013-04-15','09:35:00',3.14),('8975','2013-04-15','09:40:00',2.59),('8975','2013-04-15','09:45:00',2.61),('8975','2013-04-15','09:50:00',2.57),('8975','2013-04-15','09:55:00',2.34),('8975','2013-04-15','10:00:00',2.21),('8975','2013-04-15','10:05:00',2.15),('8975','2013-04-15','10:10:00',2.25),('8975','2013-04-15','10:15:00',2.37),('8975','2013-04-15','10:20:00',2.52),('8975','2013-04-15','10:25:00',2.56),('8975','2013-04-15','10:30:00',2.55),('8975','2013-04-15','10:35:00',2.61),('8975','2013-04-15','10:40:00',2.61),('8975','2013-04-15','10:45:00',2.51),('8975','2013-04-15','10:50:00',2.51),('8975','2013-04-15','10:55:00',2.67),('8975','2013-04-15','11:00:00',2.86),('8975','2013-04-15','11:05:00',2.97),('8975','2013-04-15','11:10:00',2.98),('8975','2013-04-15','11:15:00',3.03),('8975','2013-04-15','11:20:00',3.11),('8975','2013-04-15','11:25:00',3.01),('8975','2013-04-15','11:30:00',3.05),('8975','2013-04-15','11:35:00',2.95),('8975','2013-04-15','11:40:00',2.95),('8975','2013-04-15','11:45:00',3.51),('8975','2013-04-15','11:50:00',3.82),('8975','2013-04-15','11:55:00',3.93),('8975','2013-04-15','12:00:00',4.3),('8975','2013-04-15','12:05:00',4.8),('8975','2013-04-15','12:10:00',5.86),('8975','2013-04-15','12:15:00',4.96),('8975','2013-04-15','12:20:00',4.85),('8975','2013-04-15','12:25:00',5.49),('8975','2013-04-15','12:30:00',3.6),('8975','2013-04-15','12:35:00',4.03),('8975','2013-04-15','12:40:00',4.01),('8975','2013-04-15','12:45:00',5.68),('8975','2013-04-15','12:50:00',5.46),('8975','2013-04-15','12:55:00',5.4),('8975','2013-04-15','13:00:00',6.29),('8975','2013-04-15','13:05:00',6.14),('8975','2013-04-15','13:10:00',5.99),('8975','2013-04-15','13:15:00',5.88),('8975','2013-04-15','13:20:00',5.08),('8975','2013-04-15','13:25:00',5.6),('8975','2013-04-15','13:30:00',5.87),('8975','2013-04-15','13:35:00',5.26),('8975','2013-04-15','13:40:00',4.95),('8975','2013-04-15','13:45:00',5.58),('8975','2013-04-15','13:50:00',5.6),('8975','2013-04-15','13:55:00',5.45),('8975','2013-04-15','14:00:00',5.33),('8975','2013-04-15','14:05:00',4.86),('8975','2013-04-15','14:10:00',4.57),('8975','2013-04-15','14:15:00',4.63),('8975','2013-04-15','14:20:00',5.4),('8975','2013-04-15','14:25:00',5.55),('8975','2013-04-15','14:30:00',4.79),('8975','2013-04-15','14:35:00',4.95),('8975','2013-04-15','14:40:00',3.76),('8975','2013-04-15','14:45:00',5.03),('8975','2013-04-15','14:50:00',5.01),('8975','2013-04-15','14:55:00',4.83),('8975','2013-04-15','15:00:00',4.87),('8975','2013-04-15','15:05:00',4.65),('8975','2013-04-15','15:10:00',4.71),('8975','2013-04-15','15:15:00',4.62),('8975','2013-04-15','15:20:00',4.46),('8975','2013-04-15','15:25:00',3.67),('8975','2013-04-15','15:30:00',3.52),('8975','2013-04-15','15:35:00',3.85),('8975','2013-04-15','15:40:00',3.88),('8975','2013-04-15','15:45:00',3.9),('8975','2013-04-15','15:50:00',3.79),('8975','2013-04-15','15:55:00',3.71),('8975','2013-04-15','16:00:00',3.59),('8975','2013-04-15','16:05:00',3.44),('8975','2013-04-15','16:10:00',3.37),('8975','2013-04-15','16:15:00',3.1),('8975','2013-04-15','16:20:00',3.19),('8975','2013-04-15','16:25:00',3.05),('8975','2013-04-15','16:30:00',3.01),('8975','2013-04-15','16:35:00',2.95),('8975','2013-04-15','16:40:00',3.01),('8975','2013-04-15','16:45:00',3.11),('8975','2013-04-15','16:50:00',3.07),('8975','2013-04-15','16:55:00',2.57),('8975','2013-04-15','17:00:00',2.33),('8975','2013-04-15','17:05:00',2.47),('8975','2013-04-15','17:10:00',2.53),('8975','2013-04-15','17:15:00',2.46),('8975','2013-04-15','17:20:00',2.37),('8975','2013-04-15','17:25:00',2.16),('8975','2013-04-15','17:30:00',2),('8975','2013-04-15','17:35:00',1.93),('8975','2013-04-15','17:40:00',2.2),('8975','2013-04-15','17:45:00',2.03),('8975','2013-04-15','17:50:00',1.83),('8975','2013-04-15','17:55:00',1.55),('8975','2013-04-15','18:00:00',1.13),('8975','2013-04-15','18:05:00',1.16),('8975','2013-04-15','18:10:00',1.11),('8975','2013-04-15','18:15:00',1.09),('8975','2013-04-14','07:05:00',1.36),('8975','2013-04-14','07:10:00',1.52),('8975','2013-04-14','07:15:00',1.75),('8975','2013-04-14','07:20:00',1.77),('8975','2013-04-14','07:25:00',1.86),('8975','2013-04-14','07:30:00',2),('8975','2013-04-14','07:35:00',2.27),('8975','2013-04-14','07:40:00',2.55),('8975','2013-04-14','07:45:00',2.73),('8975','2013-04-14','07:50:00',2.83),('8975','2013-04-14','07:55:00',2.95),('8975','2013-04-14','08:00:00',3.09),('8975','2013-04-14','08:05:00',3.17),('8975','2013-04-14','08:10:00',3.24),('8975','2013-04-14','08:15:00',3.33),('8975','2013-04-14','08:20:00',3.43),('8975','2013-04-14','08:25:00',3.54),('8975','2013-04-14','08:30:00',3.69),('8975','2013-04-14','08:35:00',3.72),('8975','2013-04-14','08:40:00',3.86),('8975','2013-04-14','08:45:00',4.01),('8975','2013-04-14','08:50:00',4.09),('8975','2013-04-14','08:55:00',4.19),('8975','2013-04-14','09:00:00',4.3),('8975','2013-04-14','09:05:00',4.4),('8975','2013-04-14','09:10:00',4.48),('8975','2013-04-14','09:15:00',4.55),('8975','2013-04-14','09:20:00',4.65),('8975','2013-04-14','09:25:00',4.75),('8975','2013-04-14','09:30:00',4.83),('8975','2013-04-14','09:35:00',4.93),('8975','2013-04-14','09:40:00',5),('8975','2013-04-14','09:45:00',5.09),('8975','2013-04-14','09:50:00',5.17),('8975','2013-04-14','09:55:00',5.24),('8975','2013-04-14','10:00:00',5.31),('8975','2013-04-14','10:05:00',5.38),('8975','2013-04-14','10:10:00',5.47),('8975','2013-04-14','10:15:00',5.51),('8975','2013-04-14','10:20:00',5.57),('8975','2013-04-14','10:25:00',5.67),('8975','2013-04-14','10:30:00',5.71),('8975','2013-04-14','10:35:00',5.75),('8975','2013-04-14','10:40:00',5.81),('8975','2013-04-14','10:45:00',5.84),('8975','2013-04-14','10:50:00',5.89),('8975','2013-04-14','10:55:00',5.93),('8975','2013-04-14','11:00:00',6.01),('8975','2013-04-14','11:05:00',6.03),('8975','2013-04-14','11:10:00',6.06),('8975','2013-04-14','11:15:00',6.09),('8975','2013-04-14','11:20:00',6.12),('8975','2013-04-14','11:25:00',6.18),('8975','2013-04-14','11:30:00',6.2),('8975','2013-04-14','11:35:00',6.23),('8975','2013-04-14','11:40:00',6.26),('8975','2013-04-14','11:45:00',6.24),('8975','2013-04-14','11:50:00',6.26),('8975','2013-04-14','11:55:00',6.28),('8975','2013-04-14','12:00:00',6.29),('8975','2013-04-14','12:05:00',6.24),('8975','2013-04-14','12:10:00',6.25),('8975','2013-04-14','12:15:00',6.25),('8975','2013-04-14','12:20:00',6.27),('8975','2013-04-14','12:25:00',6.24),('8975','2013-04-14','12:30:00',6.2),('8975','2013-04-14','12:35:00',6.18),('8975','2013-04-14','12:40:00',6.17),('8975','2013-04-14','12:45:00',6.18),('8975','2013-04-14','12:50:00',6.17),('8975','2013-04-14','12:55:00',6.17),('8975','2013-04-14','13:00:00',6.17),('8975','2013-04-14','13:05:00',6.06),('8975','2013-04-14','13:10:00',6.03),('8975','2013-04-14','13:15:00',6),('8975','2013-04-14','13:20:00',5.96),('8975','2013-04-14','13:25:00',5.96),('8975','2013-04-14','13:30:00',5.95),('8975','2013-04-14','13:35:00',5.91),('8975','2013-04-14','13:40:00',5.83),('8975','2013-04-14','13:45:00',5.84),('8975','2013-04-14','13:50:00',5.83),('8975','2013-04-14','13:55:00',5.76),('8975','2013-04-14','14:00:00',5.77),('8975','2013-04-14','14:05:00',5.74),('8975','2013-04-14','14:10:00',5.7),('8975','2013-04-14','14:15:00',5.63),('8975','2013-04-14','14:20:00',5.57),('8975','2013-04-14','14:25:00',5.5),('8975','2013-04-14','14:30:00',5.42),('8975','2013-04-14','14:35:00',5.34),('8975','2013-04-14','14:40:00',5.27),('8975','2013-04-14','14:45:00',5.19),('8975','2013-04-14','14:50:00',5.08),('8975','2013-04-14','14:55:00',4.97),('8975','2013-04-14','15:00:00',4.89),('8975','2013-04-14','15:05:00',4.82),('8975','2013-04-14','15:10:00',4.72),('8975','2013-04-14','15:15:00',4.64),('8975','2013-04-14','15:20:00',4.53),('8975','2013-04-14','15:25:00',4.21),('8975','2013-04-14','15:30:00',4.05),('8975','2013-04-14','15:35:00',4.15),('8975','2013-04-14','15:40:00',4.04),('8975','2013-04-14','15:45:00',3.95),('8975','2013-04-14','15:50:00',3.84),('8975','2013-04-14','15:55:00',3.72),('8975','2013-04-14','16:00:00',3.58),('8975','2013-04-14','16:05:00',3.46),('8975','2013-04-14','16:10:00',3.36),('8975','2013-04-14','16:15:00',3.27),('8975','2013-04-14','16:20:00',3.15),('8975','2013-04-14','16:25:00',3.04),('8975','2013-04-14','16:30:00',2.94),('8975','2013-04-14','16:35:00',2.83),('8975','2013-04-14','16:40:00',2.72),('8975','2013-04-14','16:45:00',2.62),('8975','2013-04-14','16:50:00',2.51),('8975','2013-04-14','16:55:00',2.39),('8975','2013-04-14','17:00:00',2.28),('8975','2013-04-14','17:05:00',2.18),('8975','2013-04-14','17:10:00',2.07),('8975','2013-04-14','17:15:00',1.96),('8975','2013-04-14','17:20:00',1.66),('8975','2013-04-14','17:25:00',1.45),('8975','2013-04-14','17:30:00',1.43),('8975','2013-04-14','17:35:00',1.4),('8975','2013-04-14','17:40:00',1.16),('8975','2013-04-14','17:45:00',1.2),('8975','2013-04-14','17:50:00',1.17),('8975','2013-04-14','17:55:00',1.37),('8975','2013-04-14','18:00:00',1.21),('8975','2013-04-14','18:05:00',1.14),('8975','2013-04-14','18:10:00',1.06),('8975','2013-04-14','18:15:00',1.17),('8975','2013-04-13','07:15:00',1.21),('8975','2013-04-13','07:20:00',1.34),('8975','2013-04-13','07:25:00',1.53),('8975','2013-04-13','07:30:00',1.69),('8975','2013-04-13','07:35:00',1.84),('8975','2013-04-13','07:40:00',2.16),('8975','2013-04-13','07:45:00',2.35),('8975','2013-04-13','07:50:00',2.52),('8975','2013-04-13','07:55:00',2.69),('8975','2013-04-13','08:00:00',2.81),('8975','2013-04-13','08:05:00',2.73),('8975','2013-04-13','08:10:00',2.97),('8975','2013-04-13','08:15:00',3.14),('8975','2013-04-13','08:20:00',3.27),('8975','2013-04-13','08:25:00',3.38),('8975','2013-04-13','08:30:00',3.48),('8975','2013-04-13','08:35:00',3.57),('8975','2013-04-13','08:40:00',3.65),('8975','2013-04-13','08:45:00',3.75),('8975','2013-04-13','08:50:00',3.87),('8975','2013-04-13','08:55:00',3.98),('8975','2013-04-13','09:00:00',4.07),('8975','2013-04-13','09:05:00',4.16),('8975','2013-04-13','09:10:00',4.23),('8975','2013-04-13','09:15:00',4.33),('8975','2013-04-13','09:20:00',4.45),('8975','2013-04-13','09:25:00',4.55),('8975','2013-04-13','09:30:00',4.65),('8975','2013-04-13','09:35:00',4.72),('8975','2013-04-13','09:40:00',4.79),('8975','2013-04-13','09:45:00',4.89),('8975','2013-04-13','09:50:00',5),('8975','2013-04-13','09:55:00',5.06),('8975','2013-04-13','10:00:00',5.15),('8975','2013-04-13','10:05:00',5.21),('8975','2013-04-13','10:10:00',5.3),('8975','2013-04-13','10:15:00',5.4),('8975','2013-04-13','10:20:00',5.38),('8975','2013-04-13','10:25:00',5.47),('8975','2013-04-13','10:30:00',5.58),('8975','2013-04-13','10:35:00',5.63),('8975','2013-04-13','10:40:00',5.68),('8975','2013-04-13','10:45:00',5.73),('8975','2013-04-13','10:50:00',5.79),('8975','2013-04-13','10:55:00',5.84),('8975','2013-04-13','11:00:00',5.9),('8975','2013-04-13','11:05:00',5.97),('8975','2013-04-13','11:10:00',5.99),('8975','2013-04-13','11:15:00',6.02),('8975','2013-04-13','11:20:00',6.05),('8975','2013-04-13','11:25:00',6.09),('8975','2013-04-13','11:30:00',6.12),('8975','2013-04-13','11:35:00',6.17),('8975','2013-04-13','11:40:00',6.16),('8975','2013-04-13','11:45:00',6.17),('8975','2013-04-13','11:50:00',6.23),('8975','2013-04-13','11:55:00',6.21),('8975','2013-04-13','12:00:00',6.2),('8975','2013-04-13','12:05:00',6.25),('8975','2013-04-13','12:10:00',6.25),('8975','2013-04-13','12:15:00',6.21),('8975','2013-04-13','12:20:00',6.17),('8975','2013-04-13','12:25:00',6.24),('8975','2013-04-13','12:30:00',6.14),('8975','2013-04-13','12:35:00',6.19),('8975','2013-04-13','12:40:00',5.71),('8975','2013-04-13','12:45:00',6.49),('8975','2013-04-13','12:50:00',3.99),('8975','2013-04-13','12:55:00',1.2),('8975','2013-04-13','13:00:00',4.62),('8975','2013-04-13','13:05:00',6.62),('8975','2013-04-13','13:10:00',6.15),('8975','2013-04-13','13:15:00',5.04),('8975','2013-04-13','13:20:00',4.69),('8975','2013-04-13','13:25:00',5.93),('8975','2013-04-13','13:30:00',5.53),('8975','2013-04-13','13:35:00',6.1),('8975','2013-04-13','13:40:00',5.95),('8975','2013-04-13','13:45:00',5.89),('8975','2013-04-13','13:50:00',5.83),('8975','2013-04-13','13:55:00',5.75),('8975','2013-04-13','14:00:00',5.63),('8975','2013-04-13','14:05:00',5.62),('8975','2013-04-13','14:10:00',5.52),('8975','2013-04-13','14:15:00',5.49),('8975','2013-04-13','14:20:00',5.45),('8975','2013-04-13','14:25:00',5.36),('8975','2013-04-13','14:30:00',5.32),('8975','2013-04-13','14:35:00',5.34),('8975','2013-04-13','14:40:00',5.24),('8975','2013-04-13','14:45:00',5.08),('8975','2013-04-13','14:50:00',5),('8975','2013-04-13','14:55:00',4.72),('8975','2013-04-13','15:00:00',4.76),('8975','2013-04-13','15:05:00',4.71),('8975','2013-04-13','15:10:00',4.68),('8975','2013-04-13','15:15:00',4.76),('8975','2013-04-13','15:20:00',4.05),('8975','2013-04-13','15:25:00',3.38),('8975','2013-04-13','15:30:00',4.3),('8975','2013-04-13','15:35:00',4.05),('8975','2013-04-13','15:40:00',4.21),('8975','2013-04-13','15:45:00',4.19),('8975','2013-04-13','15:50:00',4.13),('8975','2013-04-13','15:55:00',3.17),('8975','2013-04-13','16:00:00',3.55),('8975','2013-04-13','16:05:00',3.38),('8975','2013-04-13','16:10:00',3.27),('8975','2013-04-13','16:15:00',3.17),('8975','2013-04-13','16:20:00',3.12),('8975','2013-04-13','16:25:00',2.97),('8975','2013-04-13','16:30:00',2.9),('8975','2013-04-13','16:35:00',2.82),('8975','2013-04-13','16:40:00',2.67),('8975','2013-04-13','16:45:00',2.54),('8975','2013-04-13','16:50:00',2.47),('8975','2013-04-13','16:55:00',2.36),('8975','2013-04-13','17:00:00',2.25),('8975','2013-04-13','17:05:00',2.14),('8975','2013-04-13','17:10:00',2.06),('8975','2013-04-13','17:15:00',1.97),('8975','2013-04-13','17:20:00',1.85),('8975','2013-04-13','17:25:00',1.76),('8975','2013-04-13','17:30:00',1.68),('8975','2013-04-13','17:35:00',1.59),('8975','2013-04-13','17:40:00',1.52),('8975','2013-04-13','17:45:00',1.45),('8975','2013-04-13','17:50:00',1.39),('8975','2013-04-13','17:55:00',1.33),('8975','2013-04-13','18:00:00',1.28),('8975','2013-04-13','18:05:00',1.24),('8975','2013-04-13','18:10:00',1.21),('8975','2013-04-13','18:15:00',1.16),('8975','2013-04-13','18:20:00',1.09),('8975','2013-04-13','18:25:00',1.02),('8975','2013-04-12','07:15:00',1.01),('8975','2013-04-12','07:20:00',1.07),('8975','2013-04-12','07:25:00',1.39),('8975','2013-04-12','07:30:00',1.61),('8975','2013-04-12','07:35:00',1.83),('8975','2013-04-12','07:40:00',1.87),('8975','2013-04-12','07:45:00',2.25),('8975','2013-04-12','07:50:00',2.42),('8975','2013-04-12','07:55:00',2.5),('8975','2013-04-12','08:00:00',2.56),('8975','2013-04-12','08:05:00',2.82),('8975','2013-04-12','08:10:00',2.87),('8975','2013-04-12','08:15:00',3.1),('8975','2013-04-12','08:20:00',3.44),('8975','2013-04-12','08:25:00',1.96),('8975','2013-04-12','08:35:00',1.06),('8975','2013-04-12','08:40:00',1.12),('8975','2013-04-12','08:45:00',1.07),('8975','2013-04-12','08:50:00',1.34),('8975','2013-04-12','08:55:00',1.6),('8975','2013-04-12','09:00:00',1.66),('8975','2013-04-12','09:05:00',1.61),('8975','2013-04-12','09:10:00',1.68),('8975','2013-04-12','09:15:00',2.2),('8975','2013-04-12','09:20:00',1.9),('8975','2013-04-12','09:25:00',3.98),('8975','2013-04-12','09:30:00',4.81),('8975','2013-04-12','09:35:00',4.9),('8975','2013-04-12','09:40:00',4.24),('8975','2013-04-12','09:45:00',4.97),('8975','2013-04-12','09:50:00',5.04),('8975','2013-04-12','09:55:00',5.11),('8975','2013-04-12','10:00:00',5.16),('8975','2013-04-12','10:05:00',5.35),('8975','2013-04-12','10:10:00',5.03),('8975','2013-04-12','10:15:00',3.69),('8975','2013-04-12','10:20:00',2.98),('8975','2013-04-12','10:25:00',2.82),('8975','2013-04-12','10:30:00',5.21),('8975','2013-04-12','10:35:00',5.77),('8975','2013-04-12','10:40:00',2.53),('8975','2013-04-12','10:45:00',4.68),('8975','2013-04-12','10:50:00',1.92),('8975','2013-04-12','10:55:00',1.37),('8975','2013-04-12','11:00:00',4.14),('8975','2013-04-12','11:05:00',5.24),('8975','2013-04-12','11:10:00',5.81),('8975','2013-04-12','11:15:00',4.96),('8975','2013-04-12','11:20:00',5.23),('8975','2013-04-12','11:25:00',1.92),('8975','2013-04-12','11:30:00',1.47),('8975','2013-04-12','11:35:00',2.05),('8975','2013-04-12','11:40:00',6.62),('8975','2013-04-12','11:45:00',5.42),('8975','2013-04-12','11:50:00',3.77),('8975','2013-04-12','11:55:00',6.24),('8975','2013-04-12','12:00:00',6.12),('8975','2013-04-12','12:05:00',6.49),('8975','2013-04-12','12:10:00',6.26),('8975','2013-04-12','12:15:00',4.17),('8975','2013-04-12','12:20:00',6.95),('8975','2013-04-12','12:25:00',6.77),('8975','2013-04-12','12:30:00',4.3),('8975','2013-04-12','12:35:00',6.66),('8975','2013-04-12','12:40:00',6.57),('8975','2013-04-12','12:45:00',6.43),('8975','2013-04-12','12:50:00',6.33),('8975','2013-04-12','12:55:00',6.3),('8975','2013-04-12','13:00:00',4.22),('8975','2013-04-12','13:05:00',5.47),('8975','2013-04-12','13:10:00',6.69),('8975','2013-04-12','13:15:00',6.3),('8975','2013-04-12','13:20:00',5.17),('8975','2013-04-12','13:25:00',5.59),('8975','2013-04-12','13:30:00',3.39),('8975','2013-04-12','13:35:00',4.1),('8975','2013-04-12','13:40:00',4.1),('8975','2013-04-12','13:45:00',2.74),('8975','2013-04-12','13:50:00',3.21),('8975','2013-04-12','13:55:00',2.69),('8975','2013-04-12','14:00:00',2.48),('8975','2013-04-12','14:05:00',2.39),('8975','2013-04-12','14:10:00',2.8),('8975','2013-04-12','14:15:00',4.06),('8975','2013-04-12','14:20:00',4.31),('8975','2013-04-12','14:25:00',4.21),('8975','2013-04-12','14:30:00',5.06),('8975','2013-04-12','14:35:00',5.25),('8975','2013-04-12','14:40:00',5.17),('8975','2013-04-12','14:45:00',5.03),('8975','2013-04-12','14:50:00',4.9),('8975','2013-04-12','14:55:00',4.89),('8975','2013-04-12','15:00:00',4.53),('8975','2013-04-12','15:05:00',4.06),('8975','2013-04-12','15:10:00',4.15),('8975','2013-04-12','15:15:00',3.95),('8975','2013-04-12','15:20:00',3.97),('8975','2013-04-12','15:25:00',3.65),('8975','2013-04-12','15:30:00',3.61),('8975','2013-04-12','15:35:00',3.53),('8975','2013-04-12','15:40:00',3.55),('8975','2013-04-12','15:45:00',3.58),('8975','2013-04-12','15:50:00',3.53),('8975','2013-04-12','15:55:00',3.45),('8975','2013-04-12','16:00:00',3.27),('8975','2013-04-12','16:05:00',3.13),('8975','2013-04-12','16:10:00',3.1),('8975','2013-04-12','16:15:00',3.09),('8975','2013-04-12','16:20:00',3),('8975','2013-04-12','16:25:00',2.88),('8975','2013-04-12','16:30:00',2.65),('8975','2013-04-12','16:35:00',2.6),('8975','2013-04-12','16:40:00',2.4),('8975','2013-04-12','16:45:00',2.27),('8975','2013-04-12','16:50:00',2.24),('8975','2013-04-12','16:55:00',2),('8975','2013-04-12','17:00:00',1.77),('8975','2013-04-12','17:05:00',1.63),('8975','2013-04-12','17:10:00',1.77),('8975','2013-04-12','17:15:00',2.21),('8975','2013-04-12','17:20:00',1.88),('8975','2013-04-12','17:25:00',1.98),('8975','2013-04-12','17:30:00',1.79),('8975','2013-04-12','17:35:00',1.7),('8975','2013-04-12','17:40:00',1.63),('8975','2013-04-12','17:45:00',1.51),('8975','2013-04-12','17:50:00',1.4),('8975','2013-04-12','17:55:00',1.47),('8975','2013-04-12','18:00:00',1.22),('8975','2013-04-12','18:05:00',1.24),('8975','2013-04-12','18:10:00',1.13),('8975','2013-04-12','18:15:00',1.19),('8975','2013-04-12','18:20:00',1.17),('8975','2013-04-12','18:25:00',1.09),('8975','2013-04-12','18:30:00',1.04),('8975','2013-04-11','07:50:00',2.08),('8975','2013-04-11','07:55:00',2.24),('8975','2013-04-11','08:00:00',1.93),('8975','2013-04-11','08:05:00',1.92),('8975','2013-04-11','08:10:00',2.83),('8975','2013-04-11','08:15:00',1.63),('8975','2013-04-11','08:20:00',2.54),('8975','2013-04-11','08:25:00',3.07),('8975','2013-04-11','08:30:00',2.38),('8975','2013-04-11','08:35:00',2.84),('8975','2013-04-11','08:40:00',2.46),('8975','2013-04-11','08:45:00',2.76),('8975','2013-04-11','08:50:00',2.49),('8975','2013-04-11','08:55:00',2.49),('8975','2013-04-11','09:00:00',1.89),('8975','2013-04-11','09:05:00',1.34),('8975','2013-04-11','09:10:00',1.64),('8975','2013-04-11','09:15:00',2.05),('8975','2013-04-11','09:20:00',2.31),('8975','2013-04-11','09:25:00',2.12),('8975','2013-04-11','09:30:00',1.7),('8975','2013-04-11','09:35:00',1.38),('8975','2013-04-11','09:40:00',1.42),('8975','2013-04-11','09:45:00',1.34),('8975','2013-04-11','09:50:00',1.52),('8975','2013-04-11','09:55:00',1.78),('8975','2013-04-11','10:00:00',1.97),('8975','2013-04-11','10:05:00',1.67),('8975','2013-04-11','10:10:00',3),('8975','2013-04-11','10:15:00',4.67),('8975','2013-04-11','10:20:00',2.73),('8975','2013-04-11','10:25:00',2.68),('8975','2013-04-11','10:30:00',3.24),('8975','2013-04-11','10:35:00',5.19),('8975','2013-04-11','10:40:00',6.78),('8975','2013-04-11','10:45:00',7.31),('8975','2013-04-11','10:50:00',7.38),('8975','2013-04-11','10:55:00',5.48),('8975','2013-04-11','11:00:00',2.75),('8975','2013-04-11','11:05:00',4.96),('8975','2013-04-11','11:10:00',6.75),('8975','2013-04-11','11:15:00',6.04),('8975','2013-04-11','11:20:00',6.25),('8975','2013-04-11','11:25:00',2.72),('8975','2013-04-11','11:30:00',5.98),('8975','2013-04-11','11:35:00',2.83),('8975','2013-04-11','11:40:00',4.61),('8975','2013-04-11','11:45:00',6.79),('8975','2013-04-11','11:50:00',6.61),('8975','2013-04-11','11:55:00',6.82),('8975','2013-04-11','12:00:00',6.17),('8975','2013-04-11','12:05:00',6.21),('8975','2013-04-11','12:10:00',6.57),('8975','2013-04-11','12:15:00',6.44),('8975','2013-04-11','12:20:00',6.52),('8975','2013-04-11','12:25:00',6.5),('8975','2013-04-11','12:30:00',6.45),('8975','2013-04-11','12:35:00',6.43),('8975','2013-04-11','12:40:00',6.21),('8975','2013-04-11','12:45:00',6.05),('8975','2013-04-11','12:50:00',6.16),('8975','2013-04-11','12:55:00',5.88),('8975','2013-04-11','13:00:00',6.29),('8975','2013-04-11','13:05:00',6.33),('8975','2013-04-11','13:10:00',6.28),('8975','2013-04-11','13:15:00',6.24),('8975','2013-04-11','13:20:00',6.27),('8975','2013-04-11','13:25:00',6.19),('8975','2013-04-11','13:30:00',6.09),('8975','2013-04-11','13:35:00',6.17),('8975','2013-04-11','13:40:00',6.07),('8975','2013-04-11','13:45:00',5.98),('8975','2013-04-11','13:50:00',5.9),('8975','2013-04-11','13:55:00',5.9),('8975','2013-04-11','14:00:00',5.83),('8975','2013-04-11','14:05:00',5.77),('8975','2013-04-11','14:10:00',5.73),('8975','2013-04-11','14:15:00',5.67),('8975','2013-04-11','14:20:00',5.59),('8975','2013-04-11','14:25:00',5.48),('8975','2013-04-11','14:30:00',5.37),('8975','2013-04-11','14:35:00',5.29),('8975','2013-04-11','14:40:00',5.19),('8975','2013-04-11','14:45:00',5.14),('8975','2013-04-11','14:50:00',5.03),('8975','2013-04-11','14:55:00',4.93),('8975','2013-04-11','15:00:00',4.85),('8975','2013-04-11','15:05:00',4.74),('8975','2013-04-11','15:10:00',4.66),('8975','2013-04-11','15:15:00',4.53),('8975','2013-04-11','15:20:00',4.26),('8975','2013-04-11','15:25:00',4.08),('8975','2013-04-11','15:30:00',4.1),('8975','2013-04-11','15:35:00',4.06),('8975','2013-04-11','15:40:00',3.97),('8975','2013-04-11','15:45:00',3.86),('8975','2013-04-11','15:50:00',3.76),('8975','2013-04-11','15:55:00',3.62),('8975','2013-04-11','16:00:00',3.5),('8975','2013-04-11','16:05:00',3.39),('8975','2013-04-11','16:10:00',3.32),('8975','2013-04-11','16:15:00',3.04),('8975','2013-04-11','16:20:00',3.1),('8975','2013-04-11','16:25:00',2.99),('8975','2013-04-11','16:30:00',2.07),('8975','2013-04-11','16:35:00',1.35),('8975','2013-04-11','16:40:00',2.37),('8975','2013-04-11','16:45:00',2.73),('8975','2013-04-11','16:50:00',2.51),('8975','2013-04-11','16:55:00',2.37),('8975','2013-04-11','17:00:00',2.28),('8975','2013-04-11','17:05:00',2.17),('8975','2013-04-11','17:10:00',2.05),('8975','2013-04-11','17:15:00',1.95),('8975','2013-04-11','17:20:00',1.87),('8975','2013-04-11','17:25:00',1.79),('8975','2013-04-11','17:30:00',1.71),('8975','2013-04-11','17:35:00',1.64),('8975','2013-04-11','17:40:00',1.57),('8975','2013-04-11','17:45:00',1.48),('8975','2013-04-11','17:50:00',1.43),('8975','2013-04-11','17:55:00',1.37),('8975','2013-04-11','18:00:00',1.31),('8975','2013-04-11','18:05:00',1.25),('8975','2013-04-11','18:10:00',1.2),('8975','2013-04-11','18:15:00',1.13),('8975','2013-04-11','18:20:00',1.05),('8975','2014-03-27','06:50:00',1.11),('8975','2014-03-27','06:55:00',1.58),('8975','2014-03-27','07:00:00',1.86),('8975','2014-03-27','07:05:00',2.38),('8975','2014-03-27','07:10:00',2.72),('8975','2014-03-27','07:15:00',2.94),('8975','2014-03-27','07:20:00',2.93),('8975','2014-03-27','07:25:00',2.85),('8975','2014-03-27','07:30:00',3.02),('8975','2014-03-27','07:35:00',3.21),('8975','2014-03-27','07:40:00',3.22),('8975','2014-03-27','07:45:00',3.48),('8975','2014-03-27','07:50:00',3.65),('8975','2014-03-27','07:55:00',3.71),('8975','2014-03-27','08:00:00',3.77),('8975','2014-03-27','08:05:00',3.87),('8975','2014-03-27','08:10:00',4),('8975','2014-03-27','08:15:00',4.12),('8975','2014-03-27','08:20:00',4.25),('8975','2014-03-27','08:25:00',4.33),('8975','2014-03-27','08:30:00',4.39),('8975','2014-03-27','08:35:00',4.47),('8975','2014-03-27','08:40:00',4.59),('8975','2014-03-27','08:45:00',4.63),('8975','2014-03-27','08:50:00',4.74),('8975','2014-03-27','08:55:00',4.87),('8975','2014-03-27','09:00:00',4.99),('8975','2014-03-27','09:05:00',5.15),('8975','2014-03-27','09:10:00',5.33),('8975','2014-03-27','09:15:00',5.51),('8975','2014-03-27','09:20:00',5.33),('8975','2014-03-27','09:25:00',5.39),('8975','2014-03-27','09:30:00',5.63),('8975','2014-03-27','09:35:00',5.93),('8975','2014-03-27','09:40:00',5.31),('8975','2014-03-27','09:45:00',3.94),('8975','2014-03-27','09:50:00',3.34),('8975','2014-03-27','09:55:00',5.91),('8975','2014-03-27','10:00:00',5.75),('8975','2014-03-27','10:05:00',5.88),('8975','2014-03-27','10:10:00',6.13),('8975','2014-03-27','10:15:00',5.95),('8975','2014-03-27','10:20:00',4.28),('8975','2014-03-27','10:25:00',5.25),('8975','2014-03-27','10:30:00',5.39),('8975','2014-03-27','10:35:00',5.83),('8975','2014-03-27','10:40:00',5.44),('8975','2014-03-27','10:45:00',5.25),('8975','2014-03-27','10:50:00',6.3),('8975','2014-03-27','10:55:00',6.28),('8975','2014-03-27','11:00:00',6.19),('8975','2014-03-27','11:05:00',6.19),('8975','2014-03-27','11:10:00',6.35),('8975','2014-03-27','11:15:00',5.6),('8975','2014-03-27','11:20:00',3.36),('8975','2014-03-27','11:25:00',1.25),('8975','2014-03-27','11:30:00',3.17),('8975','2014-03-27','11:35:00',2.92),('8975','2014-03-27','11:40:00',5.37),('8975','2014-03-27','11:45:00',3.21),('8975','2014-03-27','11:50:00',1.84),('8975','2014-03-27','11:55:00',2),('8975','2014-03-27','12:00:00',2.22),('8975','2014-03-27','12:05:00',3.59),('8975','2014-03-27','12:10:00',6.7),('8975','2014-03-27','12:15:00',6.73),('8975','2014-03-27','12:20:00',6.72),('8975','2014-03-27','12:25:00',7.17),('8975','2014-03-27','12:30:00',3.09),('8975','2014-03-27','12:35:00',1.59),('8975','2014-03-27','12:40:00',4.36),('8975','2014-03-27','12:45:00',3.89),('8975','2014-03-27','12:50:00',5.05),('8975','2014-03-27','12:55:00',5.46),('8975','2014-03-27','13:00:00',4.91),('8975','2014-03-27','13:05:00',3.66),('8975','2014-03-27','13:10:00',7.06),('8975','2014-03-27','13:15:00',5.74),('8975','2014-03-27','13:20:00',5.33),('8975','2014-03-27','13:25:00',5.2),('8975','2014-03-27','13:30:00',2.75),('8975','2014-03-27','13:35:00',4.69),('8975','2014-03-27','13:40:00',5.2),('8975','2014-03-27','13:45:00',5.24),('8975','2014-03-27','13:50:00',5.1),('8975','2014-03-27','13:55:00',5),('8975','2014-03-27','14:00:00',4.77),('8975','2014-03-27','14:05:00',4.63),('8975','2014-03-27','14:10:00',4.45),('8975','2014-03-27','14:15:00',4.32),('8975','2014-03-27','14:20:00',4.17),('8975','2014-03-27','14:25:00',4.12),('8975','2014-03-27','14:30:00',4.02),('8975','2014-03-27','14:35:00',3.93),('8975','2014-03-27','14:40:00',3.83),('8975','2014-03-27','14:45:00',3.6),('8975','2014-03-27','14:50:00',3.48),('8975','2014-03-27','14:55:00',3.46),('8975','2014-03-27','15:00:00',3.38),('8975','2014-03-27','15:05:00',3.27),('8975','2014-03-27','15:10:00',3.16),('8975','2014-03-27','15:15:00',3.04),('8975','2014-03-27','15:20:00',2.88),('8975','2014-03-27','15:25:00',2.8),('8975','2014-03-27','15:30:00',2.69),('8975','2014-03-27','15:35:00',2.58),('8975','2014-03-27','15:40:00',2.46),('8975','2014-03-27','15:45:00',2.37),('8975','2014-03-27','15:50:00',2.3),('8975','2014-03-27','15:55:00',2.2),('8975','2014-03-27','16:00:00',2.18),('8975','2014-03-27','16:05:00',2.25),('8975','2014-03-27','16:10:00',2.18),('8975','2014-03-27','16:15:00',2.14),('8975','2014-03-27','16:20:00',1.9),('8975','2014-03-27','16:25:00',1.65),('8975','2014-03-27','16:30:00',1.62),('8975','2014-03-27','16:35:00',1.49),('8975','2014-03-27','16:50:00',1.39),('8975','2014-03-27','16:55:00',1.01),('8975','2014-03-27','17:05:00',1.21),('8975','2014-03-27','17:10:00',1.16),('8975','2014-03-27','17:15:00',1.18),('8975','2014-03-27','17:20:00',1.33),('8975','2014-03-27','17:25:00',1.26),('8975','2013-04-10','07:10:00',1.03),('8975','2013-04-10','07:15:00',1.2),('8975','2013-04-10','07:20:00',1.38),('8975','2013-04-10','07:25:00',1.57),('8975','2013-04-10','07:30:00',1.84),('8975','2013-04-10','07:35:00',1.89),('8975','2013-04-10','07:40:00',2.04),('8975','2013-04-10','07:45:00',2.39),('8975','2013-04-10','07:50:00',2.59),('8975','2013-04-10','07:55:00',2.73),('8975','2013-04-10','08:00:00',2.87),('8975','2013-04-10','08:05:00',2.96),('8975','2013-04-10','08:10:00',3.03),('8975','2013-04-10','08:15:00',3.16),('8975','2013-04-10','08:20:00',3.26),('8975','2013-04-10','08:25:00',3.39),('8975','2013-04-10','08:30:00',3.48),('8975','2013-04-10','08:35:00',3.55),('8975','2013-04-10','08:40:00',3.66),('8975','2013-04-10','08:45:00',3.77),('8975','2013-04-10','08:50:00',3.83),('8975','2013-04-10','08:55:00',3.97),('8975','2013-04-10','09:00:00',4.06),('8975','2013-04-10','09:05:00',4.19),('8975','2013-04-10','09:10:00',4.2),('8975','2013-04-10','09:15:00',4.18),('8975','2013-04-10','09:20:00',4.35),('8975','2013-04-10','09:25:00',4.45),('8975','2013-04-10','09:30:00',4.6),('8975','2013-04-10','09:35:00',4.84),('8975','2013-04-10','09:40:00',5.13),('8975','2013-04-10','09:45:00',3.98),('8975','2013-04-10','09:50:00',4.43),('8975','2013-04-10','09:55:00',5.1),('8975','2013-04-10','10:00:00',5.38),('8975','2013-04-10','10:05:00',5),('8975','2013-04-10','10:10:00',5.36),('8975','2013-04-10','10:15:00',3.02),('8975','2013-04-10','10:20:00',3.69),('8975','2013-04-10','10:25:00',4.65),('8975','2013-04-10','10:30:00',4.26),('8975','2013-04-10','10:35:00',6.16),('8975','2013-04-10','10:40:00',6.16),('8975','2013-04-10','10:45:00',6.25),('8975','2013-04-10','10:50:00',6.71),('8975','2013-04-10','10:55:00',6.86),('8975','2013-04-10','11:00:00',6.69),('8975','2013-04-10','11:05:00',5.83),('8975','2013-04-10','11:10:00',6.13),('8975','2013-04-10','11:15:00',6.04),('8975','2013-04-10','11:20:00',4.54),('8975','2013-04-10','11:25:00',5.78),('8975','2013-04-10','11:30:00',2.97),('8975','2013-04-10','11:35:00',6.18),('8975','2013-04-10','11:40:00',3.94),('8975','2013-04-10','11:45:00',7.35),('8975','2013-04-10','11:50:00',7.06),('8975','2013-04-10','11:55:00',3.56),('8975','2013-04-10','12:00:00',6.98),('8975','2013-04-10','12:05:00',3.08),('8975','2013-04-10','12:10:00',4.47),('8975','2013-04-10','12:15:00',3.35),('8975','2013-04-10','12:20:00',7.19),('8975','2013-04-10','12:25:00',7.04),('8975','2013-04-10','12:30:00',6.79),('8975','2013-04-10','12:35:00',6.66),('8975','2013-04-10','12:40:00',7.06),('8975','2013-04-10','12:45:00',5.4),('8975','2013-04-10','12:50:00',6.74),('8975','2013-04-10','12:55:00',6.72),('8975','2013-04-10','13:00:00',6.42),('8975','2013-04-10','13:05:00',5.32),('8975','2013-04-10','13:10:00',5.94),('8975','2013-04-10','13:15:00',5.84),('8975','2013-04-10','13:20:00',5.32),('8975','2013-04-10','13:25:00',5.78),('8975','2013-04-10','13:30:00',5.64),('8975','2013-04-10','13:35:00',5.96),('8975','2013-04-10','13:40:00',5.45),('8975','2013-04-10','13:45:00',5.65),('8975','2013-04-10','13:50:00',5.96),('8975','2013-04-10','13:55:00',5.95),('8975','2013-04-10','14:00:00',4.95),('8975','2013-04-10','14:05:00',5.1),('8975','2013-04-10','14:10:00',5.91),('8975','2013-04-10','14:15:00',5.86),('8975','2013-04-10','14:20:00',5.63),('8975','2013-04-10','14:25:00',5.75),('8975','2013-04-10','14:30:00',5.7),('8975','2013-04-10','14:35:00',5.22),('8975','2013-04-10','14:40:00',5.19),('8975','2013-04-10','14:45:00',5.48),('8975','2013-04-10','14:50:00',5.3),('8975','2013-04-10','14:55:00',4.47),('8975','2013-04-10','15:00:00',4.84),('8975','2013-04-10','15:05:00',4.85),('8975','2013-04-10','15:10:00',4.73),('8975','2013-04-10','15:15:00',4.58),('8975','2013-04-10','15:20:00',4.3),('8975','2013-04-10','15:25:00',4.14),('8975','2013-04-10','15:30:00',4.25),('8975','2013-04-10','15:35:00',4.15),('8975','2013-04-10','15:40:00',4),('8975','2013-04-10','15:45:00',3.9),('8975','2013-04-10','15:50:00',3.79),('8975','2013-04-10','15:55:00',3.63),('8975','2013-04-10','16:00:00',3.48),('8975','2013-04-10','16:05:00',3.4),('8975','2013-04-10','16:10:00',3.31),('8975','2013-04-10','16:15:00',3.17),('8975','2013-04-10','16:20:00',3.08),('8975','2013-04-10','16:25:00',2.97),('8975','2013-04-10','16:30:00',2.87),('8975','2013-04-10','16:35:00',2.77),('8975','2013-04-10','16:40:00',2.69),('8975','2013-04-10','16:45:00',2.56),('8975','2013-04-10','16:50:00',2.46),('8975','2013-04-10','16:55:00',2.35),('8975','2013-04-10','17:00:00',2.22),('8975','2013-04-10','17:05:00',2.15),('8975','2013-04-10','17:10:00',2.05),('8975','2013-04-10','17:15:00',1.95),('8975','2013-04-10','17:20:00',1.86),('8975','2013-04-10','17:25:00',1.77),('8975','2013-04-10','17:30:00',1.69),('8975','2013-04-10','17:35:00',1.62),('8975','2013-04-10','17:40:00',1.55),('8975','2013-04-10','17:45:00',1.48),('8975','2013-04-10','17:50:00',1.44),('8975','2013-04-10','17:55:00',1.35),('8975','2013-04-10','18:00:00',1.26),('8975','2013-04-10','18:05:00',1.2),('8975','2013-04-10','18:10:00',1.05),('8975','2013-04-10','18:15:00',1.13),('8975','2013-04-10','18:20:00',1.12),('8975','2013-04-10','18:25:00',1.09),('8975','2013-04-10','18:30:00',1),('8975','2013-04-09','08:50:00',2.23),('8975','2013-04-09','08:55:00',4.06),('8975','2013-04-09','09:00:00',4.34),('8975','2013-04-09','09:05:00',4.69),('8975','2013-04-09','09:10:00',5.04),('8975','2013-04-09','09:15:00',4.92),('8975','2013-04-09','09:20:00',4.78),('8975','2013-04-09','09:25:00',4.78),('8975','2013-04-09','09:30:00',4.77),('8975','2013-04-09','09:35:00',4.89),('8975','2013-04-09','09:40:00',4.63),('8975','2013-04-09','09:45:00',4.87),('8975','2013-04-09','09:50:00',4.86),('8975','2013-04-09','09:55:00',5.4),('8975','2013-04-09','10:00:00',5.57),('8975','2013-04-09','10:05:00',5.83),('8975','2013-04-09','10:10:00',5.1),('8975','2013-04-09','10:15:00',4.99),('8975','2013-04-09','10:20:00',6.34),('8975','2013-04-09','10:25:00',6.24),('8975','2013-04-09','10:30:00',5.91),('8975','2013-04-09','10:35:00',6.15),('8975','2013-04-09','10:40:00',6.1),('8975','2013-04-09','10:45:00',6.24),('8975','2013-04-09','10:50:00',6.12),('8975','2013-04-09','10:55:00',6.09),('8975','2013-04-09','11:00:00',5.96),('8975','2013-04-09','11:05:00',5.77),('8975','2013-04-09','11:10:00',5.94),('8975','2013-04-09','11:15:00',5.97),('8975','2013-04-09','11:20:00',6.15),('8975','2013-04-09','11:25:00',6.28),('8975','2013-04-09','11:30:00',6.41),('8975','2013-04-09','11:35:00',6.48),('8975','2013-04-09','11:40:00',6.46),('8975','2013-04-09','11:45:00',6.47),('8975','2013-04-09','11:50:00',6.49),('8975','2013-04-09','11:55:00',6.55),('8975','2013-04-09','12:00:00',6.59),('8975','2013-04-09','12:05:00',6.72),('8975','2013-04-09','12:10:00',6.67),('8975','2013-04-09','12:15:00',6.65),('8975','2013-04-09','12:20:00',6.59),('8975','2013-04-09','12:25:00',6.59),('8975','2013-04-09','12:30:00',6.75),('8975','2013-04-09','12:35:00',6.8),('8975','2013-04-09','12:40:00',6.57),('8975','2013-04-09','12:45:00',6.6),('8975','2013-04-09','12:50:00',5.95),('8975','2013-04-09','12:55:00',5.62),('8975','2013-04-09','13:00:00',7.11),('8975','2013-04-09','13:05:00',3.14),('8975','2013-04-09','13:10:00',3.4),('8975','2013-04-09','13:15:00',4.71),('8975','2013-04-09','13:20:00',2.71),('8975','2013-04-09','13:25:00',5.05),('8975','2013-04-09','13:30:00',4.12),('8975','2013-04-09','13:35:00',3.3),('8975','2013-04-09','13:40:00',5.38),('8975','2013-04-09','13:45:00',6.78),('8975','2013-04-09','13:50:00',2.8),('8975','2013-04-09','13:55:00',6.23),('8975','2013-04-09','14:00:00',4.83),('8975','2013-04-09','14:05:00',5.1),('8975','2013-04-09','14:10:00',6.13),('8975','2013-04-09','14:15:00',5.97),('8975','2013-04-09','14:20:00',5.97),('8975','2013-04-09','14:25:00',6),('8975','2013-04-09','14:30:00',4.59),('8975','2013-04-09','14:35:00',5.54),('8975','2013-04-09','14:40:00',4.48),('8975','2013-04-09','14:45:00',4.06),('8975','2013-04-09','14:50:00',4.63),('8975','2013-04-09','14:55:00',3.18),('8975','2013-04-09','15:00:00',5.53),('8975','2013-04-09','15:05:00',2.96),('8975','2013-04-09','15:10:00',4.45),('8975','2013-04-09','15:15:00',3.42),('8975','2013-04-09','15:20:00',4.54),('8975','2013-04-09','15:25:00',4.45),('8975','2013-04-09','15:30:00',4.19),('8975','2013-04-09','15:35:00',4.27),('8975','2013-04-09','15:40:00',4.05),('8975','2013-04-09','15:45:00',4),('8975','2013-04-09','15:50:00',3.94),('8975','2013-04-09','15:55:00',3.99),('8975','2013-04-09','16:00:00',3.35),('8975','2013-04-09','16:05:00',3.63),('8975','2013-04-09','16:10:00',3.19),('8975','2013-04-09','16:15:00',3.2),('8975','2013-04-09','16:20:00',3.24),('8975','2013-04-09','16:25:00',2.71),('8975','2013-04-09','16:30:00',3.23),('8975','2013-04-09','16:35:00',3.2),('8975','2013-04-09','16:40:00',2.98),('8975','2013-04-09','16:45:00',2.57),('8975','2013-04-09','16:50:00',2.74),('8975','2013-04-09','16:55:00',1.97),('8975','2013-04-09','17:00:00',2.38),('8975','2013-04-09','17:05:00',1.16),('8975','2013-04-09','17:10:00',1.77),('8975','2013-04-09','17:15:00',2.25),('8975','2013-04-09','17:20:00',2.07),('8975','2013-04-09','17:25:00',1.99),('8975','2013-04-09','17:30:00',1.87),('8975','2013-04-09','17:35:00',1.74),('8975','2013-04-09','17:40:00',1.71),('8975','2013-04-09','17:45:00',1.69),('8975','2013-04-09','17:50:00',1.62),('8975','2013-04-09','17:55:00',1.52),('8975','2013-04-09','18:00:00',1.29),('8975','2013-04-09','18:05:00',1.03),('8975','2013-04-09','18:10:00',1.22),('8975','2013-04-09','18:15:00',1.15),('8975','2013-04-08','07:20:00',1.12),('8975','2013-04-08','07:25:00',1.35),('8975','2013-04-08','07:30:00',1.53),('8975','2013-04-08','07:35:00',1.83),('8975','2013-04-08','07:40:00',2.02),('8975','2013-04-08','07:45:00',1.9),('8975','2013-04-08','07:50:00',2.17),('8975','2013-04-08','07:55:00',2.72),('8975','2013-04-08','08:00:00',2.96),('8975','2013-04-08','08:05:00',1.66),('8975','2013-04-08','08:10:00',2.26),('8975','2013-04-08','08:15:00',1.15),('8975','2013-04-08','08:20:00',3.51),('8975','2013-04-08','08:25:00',3.21),('8975','2013-04-08','08:30:00',2.64),('8975','2013-04-08','08:35:00',2.2),('8975','2013-04-08','08:40:00',1.04),('8975','2013-04-08','08:55:00',1.05),('8975','2013-04-08','09:00:00',1.67),('8975','2013-04-08','09:05:00',2.76),('8975','2013-04-08','09:10:00',1.87),('8975','2013-04-08','09:15:00',2.5),('8975','2013-04-08','09:20:00',2.24),('8975','2013-04-08','09:25:00',2.06),('8975','2013-04-08','09:30:00',3.28),('8975','2013-04-08','09:35:00',5.42),('8975','2013-04-08','09:40:00',3.55),('8975','2013-04-08','09:45:00',2.6),('8975','2013-04-08','09:50:00',4.49),('8975','2013-04-08','09:55:00',2.33),('8975','2013-04-08','10:00:00',5.03),('8975','2013-04-08','10:05:00',3.36),('8975','2013-04-08','10:10:00',4.18),('8975','2013-04-08','10:15:00',4.01),('8975','2013-04-08','10:20:00',2.01),('8975','2013-04-08','10:25:00',4.4),('8975','2013-04-08','10:30:00',4.12),('8975','2013-04-08','10:35:00',4.73),('8975','2013-04-08','10:40:00',4.71),('8975','2013-04-08','10:45:00',6.36),('8975','2013-04-08','10:50:00',6.54),('8975','2013-04-08','10:55:00',6.86),('8975','2013-04-08','11:00:00',5.74),('8975','2013-04-08','11:05:00',3.47),('8975','2013-04-08','11:10:00',7.48),('8975','2013-04-08','11:15:00',4.44),('8975','2013-04-08','11:20:00',3.62),('8975','2013-04-08','11:25:00',2.74),('8975','2013-04-08','11:30:00',3.97),('8975','2013-04-08','11:35:00',7.36),('8975','2013-04-08','11:40:00',6.74),('8975','2013-04-08','11:45:00',2.6),('8975','2013-04-08','11:50:00',6.4),('8975','2013-04-08','11:55:00',7.42),('8975','2013-04-08','12:00:00',7.06),('8975','2013-04-08','12:05:00',6.17),('8975','2013-04-08','12:10:00',5.83),('8975','2013-04-08','12:15:00',7),('8975','2013-04-08','12:20:00',6.43),('8975','2013-04-08','12:25:00',5.68),('8975','2013-04-08','12:30:00',5.89),('8975','2013-04-08','12:35:00',2.69),('8975','2013-04-08','12:40:00',6.38),('8975','2013-04-08','12:45:00',5.85),('8975','2013-04-08','12:50:00',5.12),('8975','2013-04-08','12:55:00',6.67),('8975','2013-04-08','13:00:00',6.37),('8975','2013-04-08','13:05:00',6.51),('8975','2013-04-08','13:10:00',4.93),('8975','2013-04-08','13:15:00',4.87),('8975','2013-04-08','13:20:00',4.69),('8975','2013-04-08','13:25:00',6.66),('8975','2013-04-08','13:30:00',7.19),('8975','2013-04-08','13:35:00',5.95),('8975','2013-04-08','13:40:00',5.86),('8975','2013-04-08','13:45:00',6.43),('8975','2013-04-08','13:50:00',5.55),('8975','2013-04-08','13:55:00',6.01),('8975','2013-04-08','14:00:00',5.78),('8975','2013-04-08','14:05:00',5.84),('8975','2013-04-08','14:10:00',5.12),('8975','2013-04-08','14:15:00',4.99),('8975','2013-04-08','14:20:00',4.96),('8975','2013-04-08','14:25:00',5.11),('8975','2013-04-08','14:30:00',4.68),('8975','2013-04-08','14:35:00',4.94),('8975','2013-04-08','14:40:00',4.16),('8975','2013-04-08','14:45:00',1.95),('8975','2013-04-08','14:50:00',3.62),('8975','2013-04-08','14:55:00',4.4),('8975','2013-04-08','15:00:00',5.55),('8975','2013-04-08','15:05:00',4.36),('8975','2013-04-08','15:10:00',4.14),('8975','2013-04-08','15:15:00',3.35),('8975','2013-04-08','15:20:00',4.25),('8975','2013-04-08','15:25:00',4.11),('8975','2013-04-08','15:30:00',4.86),('8975','2013-04-08','15:35:00',4.74),('8975','2013-04-08','15:40:00',3.79),('8975','2013-04-08','15:45:00',2.25),('8975','2013-04-08','15:50:00',3.15),('8975','2013-04-08','15:55:00',2.51),('8975','2013-04-08','16:00:00',2.01),('8975','2013-04-08','16:05:00',1.42),('8975','2013-04-08','16:10:00',1.28),('8975','2013-04-08','16:15:00',1.32),('8975','2013-04-08','16:20:00',1.16),('8975','2013-04-08','16:25:00',1.65),('8975','2013-04-08','16:30:00',2.22),('8975','2013-04-08','16:35:00',1.62),('8975','2013-04-08','16:40:00',2.5),('8975','2013-04-08','16:45:00',3.22),('8975','2013-04-08','16:50:00',3.42),('8975','2013-04-08','16:55:00',2.49),('8975','2013-04-08','17:00:00',1.78),('8975','2013-04-08','17:05:00',1.22),('8975','2013-04-08','17:10:00',1.98),('8975','2013-04-08','17:15:00',2.06),('8975','2013-04-08','17:30:00',1.09),('8975','2013-04-08','17:35:00',1.37),('8975','2013-04-08','17:40:00',1.32),('8975','2013-04-08','17:50:00',1.25),('8975','2013-04-08','18:15:00',1.05),('8975','2013-04-08','18:20:00',1.04),('8975','2013-04-07','07:55:00',1.01),('8975','2013-04-07','08:00:00',1.22),('8975','2013-04-07','08:05:00',2.16),('8975','2013-04-07','08:10:00',2.69),('8975','2013-04-07','08:15:00',1.74),('8975','2013-04-07','08:20:00',1.32),('8975','2013-04-07','08:25:00',1.39),('8975','2013-04-07','08:30:00',1.38),('8975','2013-04-07','08:35:00',1.9),('8975','2013-04-07','08:40:00',2.3),('8975','2013-04-07','08:45:00',2.68),('8975','2013-04-07','08:50:00',2.77),('8975','2013-04-07','08:55:00',3.93),('8975','2013-04-07','09:00:00',4.6),('8975','2013-04-07','09:05:00',3.91),('8975','2013-04-07','09:10:00',3.54),('8975','2013-04-07','09:15:00',4.86),('8975','2013-04-07','09:20:00',4.88),('8975','2013-04-07','09:25:00',4.73),('8975','2013-04-07','09:30:00',4.92),('8975','2013-04-07','09:35:00',5.15),('8975','2013-04-07','09:40:00',5.17),('8975','2013-04-07','09:45:00',4.69),('8975','2013-04-07','09:50:00',2.55),('8975','2013-04-07','09:55:00',4.56),('8975','2013-04-07','10:00:00',5.47),('8975','2013-04-07','10:05:00',5.3),('8975','2013-04-07','10:10:00',5.49),('8975','2013-04-07','10:15:00',5.39),('8975','2013-04-07','10:20:00',5.63),('8975','2013-04-07','10:25:00',5.54),('8975','2013-04-07','10:30:00',5.74),('8975','2013-04-07','10:35:00',5.53),('8975','2013-04-07','10:40:00',6.01),('8975','2013-04-07','10:45:00',6.21),('8975','2013-04-07','10:50:00',6),('8975','2013-04-07','10:55:00',5.84),('8975','2013-04-07','11:00:00',5.47),('8975','2013-04-07','11:05:00',5.17),('8975','2013-04-07','11:10:00',4.5),('8975','2013-04-07','11:15:00',3.83),('8975','2013-04-07','11:20:00',3.83),('8975','2013-04-07','11:25:00',3.44),('8975','2013-04-07','11:30:00',4.21),('8975','2013-04-07','11:35:00',4.93),('8975','2013-04-07','11:40:00',5.23),('8975','2013-04-07','11:45:00',4.59),('8975','2013-04-07','11:50:00',4.14),('8975','2013-04-07','11:55:00',3.64),('8975','2013-04-07','12:00:00',3.44),('8975','2013-04-07','12:05:00',3.43),('8975','2013-04-07','12:10:00',3.74),('8975','2013-04-07','12:15:00',4.09),('8975','2013-04-07','12:20:00',4.23),('8975','2013-04-07','12:25:00',3.61),('8975','2013-04-07','12:30:00',3.39),('8975','2013-04-07','12:35:00',3.06),('8975','2013-04-07','12:40:00',2.9),('8975','2013-04-07','12:45:00',2.74),('8975','2013-04-07','12:50:00',2.56),('8975','2013-04-07','12:55:00',3.8),('8975','2013-04-07','13:00:00',4.66),('8975','2013-04-07','13:05:00',3.35),('8975','2013-04-07','13:10:00',4.1),('8975','2013-04-07','13:15:00',3.17),('8975','2013-04-07','13:20:00',2.95),('8975','2013-04-07','13:25:00',4.44),('8975','2013-04-07','13:30:00',4.4),('8975','2013-04-07','13:35:00',4),('8975','2013-04-07','13:40:00',3.81),('8975','2013-04-07','13:45:00',2.79),('8975','2013-04-07','13:50:00',4.23),('8975','2013-04-07','13:55:00',3.83),('8975','2013-04-07','14:00:00',5.33),('8975','2013-04-07','14:05:00',5.38),('8975','2013-04-07','14:10:00',5.16),('8975','2013-04-07','14:15:00',5.48),('8975','2013-04-07','14:20:00',5.42),('8975','2013-04-07','14:25:00',5.73),('8975','2013-04-07','14:30:00',5.14),('8975','2013-04-07','14:35:00',4.55),('8975','2013-04-07','14:40:00',5.24),('8975','2013-04-07','14:45:00',5.5),('8975','2013-04-07','14:50:00',5.05),('8975','2013-04-07','14:55:00',5.02),('8975','2013-04-07','15:00:00',4.24),('8975','2013-04-07','15:05:00',3.66),('8975','2013-04-07','15:10:00',4.39),('8975','2013-04-07','15:15:00',3.94),('8975','2013-04-07','15:20:00',3.53),('8975','2013-04-07','15:25:00',4.54),('8975','2013-04-07','15:30:00',4.47),('8975','2013-04-07','15:35:00',4.19),('8975','2013-04-07','15:40:00',4.04),('8975','2013-04-07','15:45:00',3.91),('8975','2013-04-07','15:50:00',3.77),('8975','2013-04-07','15:55:00',3.6),('8975','2013-04-07','16:00:00',3.48),('8975','2013-04-07','16:05:00',3.18),('8975','2013-04-07','16:10:00',3.08),('8975','2013-04-07','16:15:00',3.28),('8975','2013-04-07','16:20:00',3.19),('8975','2013-04-07','16:25:00',2.99),('8975','2013-04-07','16:30:00',2.92),('8975','2013-04-07','16:35:00',2.76),('8975','2013-04-07','16:40:00',2.71),('8975','2013-04-07','16:45:00',2.6),('8975','2013-04-07','16:50:00',2.47),('8975','2013-04-07','16:55:00',2.36),('8975','2013-04-07','17:00:00',2.28),('8975','2013-04-07','17:05:00',2.18),('8975','2013-04-07','17:10:00',1.99),('8975','2013-04-07','17:15:00',1.82),('8975','2013-04-07','17:20:00',1.82),('8975','2013-04-07','17:25:00',1.89),('8975','2013-04-07','17:30:00',1.75),('8975','2013-04-07','17:35:00',1.56),('8975','2013-04-07','17:40:00',1.48),('8975','2013-04-07','17:45:00',1.44),('8975','2013-04-07','17:50:00',1.23),('8975','2013-04-07','17:55:00',1.17),('8975','2013-04-07','18:00:00',1.26),('8975','2013-04-07','18:15:00',1.05),('8975','2013-04-07','18:20:00',1.58),('8975','2013-04-07','18:25:00',1.5),('8975','2013-04-07','18:30:00',1.01),('8975','2013-04-06','07:55:00',1.01),('8975','2013-04-06','08:00:00',1.17),('8975','2013-04-06','08:05:00',1.34),('8975','2013-04-06','08:10:00',1.54),('8975','2013-04-06','08:15:00',1.72),('8975','2013-04-06','08:20:00',2.07),('8975','2013-04-06','08:25:00',2.31),('8975','2013-04-06','08:30:00',2.39),('8975','2013-04-06','08:35:00',2.46),('8975','2013-04-06','08:40:00',2.47),('8975','2013-04-06','08:45:00',2.49),('8975','2013-04-06','08:50:00',2.53),('8975','2013-04-06','08:55:00',2.6),('8975','2013-04-06','09:00:00',2.65),('8975','2013-04-06','09:05:00',2.63),('8975','2013-04-06','09:10:00',2.73),('8975','2013-04-06','09:15:00',3.15),('8975','2013-04-06','09:20:00',3.17),('8975','2013-04-06','09:25:00',3.22),('8975','2013-04-06','09:30:00',3.16),('8975','2013-04-06','09:35:00',3),('8975','2013-04-06','09:40:00',2.78),('8975','2013-04-06','09:45:00',2.77),('8975','2013-04-06','09:50:00',3.51),('8975','2013-04-06','09:55:00',3.93),('8975','2013-04-06','10:00:00',4.35),('8975','2013-04-06','10:05:00',4.86),('8975','2013-04-06','10:10:00',4.91),('8975','2013-04-06','10:15:00',4.96),('8975','2013-04-06','10:20:00',5.21),('8975','2013-04-06','10:25:00',5.21),('8975','2013-04-06','10:30:00',4.4),('8975','2013-04-06','10:35:00',4.28),('8975','2013-04-06','10:40:00',4.65),('8975','2013-04-06','10:45:00',4.78),('8975','2013-04-06','10:50:00',4.6),('8975','2013-04-06','10:55:00',3.86),('8975','2013-04-06','11:00:00',3.69),('8975','2013-04-06','11:05:00',3.39),('8975','2013-04-06','11:10:00',3.43),('8975','2013-04-06','11:15:00',4.74),('8975','2013-04-06','11:20:00',6.15),('8975','2013-04-06','11:25:00',6.35),('8975','2013-04-06','11:30:00',6.39),('8975','2013-04-06','11:35:00',5.8),('8975','2013-04-06','11:40:00',5.23),('8975','2013-04-06','11:45:00',4.13),('8975','2013-04-06','11:50:00',3.85),('8975','2013-04-06','11:55:00',3.98),('8975','2013-04-06','12:00:00',3.91),('8975','2013-04-06','12:05:00',4.07),('8975','2013-04-06','12:10:00',4.4),('8975','2013-04-06','12:15:00',4.12),('8975','2013-04-06','12:20:00',4.69),('8975','2013-04-06','12:25:00',4.81),('8975','2013-04-06','12:30:00',4.44),('8975','2013-04-06','12:35:00',4.81),('8975','2013-04-06','12:40:00',4.17),('8975','2013-04-06','12:45:00',4.06),('8975','2013-04-06','12:50:00',3.97),('8975','2013-04-06','12:55:00',4.25),('8975','2013-04-06','13:00:00',4.76),('8975','2013-04-06','13:05:00',5.1),('8975','2013-04-06','13:10:00',4.92),('8975','2013-04-06','13:15:00',4.38),('8975','2013-04-06','13:20:00',4.7),('8975','2013-04-06','13:25:00',4.73),('8975','2013-04-06','13:30:00',4.61),('8975','2013-04-06','13:35:00',4.91),('8975','2013-04-06','13:40:00',4.57),('8975','2013-04-06','13:45:00',3.79),('8975','2013-04-06','13:50:00',4.22),('8975','2013-04-06','13:55:00',3.93),('8975','2013-04-06','14:00:00',4.31),('8975','2013-04-06','14:05:00',4.19),('8975','2013-04-06','14:10:00',3.47),('8975','2013-04-06','14:15:00',2.38),('8975','2013-04-06','14:20:00',3.22),('8975','2013-04-06','14:25:00',3.17),('8975','2013-04-06','14:30:00',2.83),('8975','2013-04-06','14:35:00',2.36),('8975','2013-04-06','14:40:00',2.67),('8975','2013-04-06','14:45:00',3.02),('8975','2013-04-06','14:50:00',2.48),('8975','2013-04-06','14:55:00',2.68),('8975','2013-04-06','15:00:00',3.39),('8975','2013-04-06','15:05:00',3.2),('8975','2013-04-06','15:10:00',2.75),('8975','2013-04-06','15:15:00',3.27),('8975','2013-04-06','15:20:00',2.98),('8975','2013-04-06','15:25:00',3.39),('8975','2013-04-06','15:30:00',3.34),('8975','2013-04-06','15:35:00',3.76),('8975','2013-04-06','15:40:00',3.6),('8975','2013-04-06','15:45:00',3.51),('8975','2013-04-06','15:50:00',3.33),('8975','2013-04-06','15:55:00',3.16),('8975','2013-04-06','16:00:00',2.95),('8975','2013-04-06','16:05:00',2.6),('8975','2013-04-06','16:10:00',2.37),('8975','2013-04-06','16:15:00',2.09),('8975','2013-04-06','16:20:00',2.09),('8975','2013-04-06','16:25:00',2.02),('8975','2013-04-06','16:30:00',1.83),('8975','2013-04-06','16:35:00',2.33),('8975','2013-04-06','16:40:00',2.14),('8975','2013-04-06','16:45:00',2.46),('8975','2013-04-06','16:50:00',2.86),('8975','2013-04-06','16:55:00',2.86),('8975','2013-04-06','17:00:00',2.65),('8975','2013-04-06','17:05:00',2.41),('8975','2013-04-06','17:10:00',2.25),('8975','2013-04-06','17:15:00',2.22),('8975','2013-04-06','17:20:00',1.92),('8975','2013-04-06','17:25:00',2.07),('8975','2013-04-06','17:30:00',2),('8975','2013-04-06','17:35:00',1.93),('8975','2013-04-06','17:40:00',1.82),('8975','2013-04-06','17:45:00',1.84),('8975','2013-04-06','17:50:00',1.83),('8975','2013-04-06','17:55:00',1.64),('8975','2013-04-06','18:00:00',1.26),('8975','2013-04-05','07:25:00',1.42),('8975','2013-04-05','07:30:00',1.54),('8975','2013-04-05','07:35:00',1.73),('8975','2013-04-05','07:40:00',1.87),('8975','2013-04-05','07:45:00',2.09),('8975','2013-04-05','07:50:00',2.37),('8975','2013-04-05','07:55:00',2.63),('8975','2013-04-05','08:00:00',2.8),('8975','2013-04-05','08:05:00',2.93),('8975','2013-04-05','08:10:00',3.03),('8975','2013-04-05','08:15:00',3.12),('8975','2013-04-05','08:20:00',3.21),('8975','2013-04-05','08:25:00',3.3),('8975','2013-04-05','08:30:00',3.4),('8975','2013-04-05','08:35:00',3.5),('8975','2013-04-05','08:40:00',3.59),('8975','2013-04-05','08:45:00',3.68),('8975','2013-04-05','08:50:00',3.81),('8975','2013-04-05','08:55:00',3.92),('8975','2013-04-05','09:00:00',4),('8975','2013-04-05','09:05:00',4.08),('8975','2013-04-05','09:10:00',4.22),('8975','2013-04-05','09:15:00',4.35),('8975','2013-04-05','09:20:00',4.45),('8975','2013-04-05','09:25:00',4.54),('8975','2013-04-05','09:30:00',4.62),('8975','2013-04-05','09:35:00',4.61),('8975','2013-04-05','09:40:00',4.83),('8975','2013-04-05','09:45:00',4.9),('8975','2013-04-05','09:50:00',4.96),('8975','2013-04-05','09:55:00',5.04),('8975','2013-04-05','10:00:00',5.11),('8975','2013-04-05','10:05:00',5.18),('8975','2013-04-05','10:10:00',5.28),('8975','2013-04-05','10:15:00',5.36),('8975','2013-04-05','10:20:00',5.48),('8975','2013-04-05','10:25:00',5.57),('8975','2013-04-05','10:30:00',5.64),('8975','2013-04-05','10:35:00',5.64),('8975','2013-04-05','10:40:00',5.67),('8975','2013-04-05','10:45:00',5.78),('8975','2013-04-05','10:50:00',5.81),('8975','2013-04-05','10:55:00',5.84),('8975','2013-04-05','11:00:00',5.9),('8975','2013-04-05','11:05:00',5.91),('8975','2013-04-05','11:10:00',5.86),('8975','2013-04-05','11:15:00',5.99),('8975','2013-04-05','11:20:00',6.09),('8975','2013-04-05','11:25:00',6.11),('8975','2013-04-05','11:30:00',6.14),('8975','2013-04-05','11:35:00',6.2),('8975','2013-04-05','11:40:00',6.22),('8975','2013-04-05','11:45:00',6.22),('8975','2013-04-05','11:50:00',6.25),('8975','2013-04-05','11:55:00',6.29),('8975','2013-04-05','12:00:00',6.28),('8975','2013-04-05','12:05:00',6.28),('8975','2013-04-05','12:10:00',6.27),('8975','2013-04-05','12:15:00',6.3),('8975','2013-04-05','12:20:00',6.29),('8975','2013-04-05','12:25:00',6.39),('8975','2013-04-05','12:30:00',6.36),('8975','2013-04-05','12:35:00',6.38),('8975','2013-04-05','12:40:00',6.3),('8975','2013-04-05','12:45:00',5.78),('8975','2013-04-05','12:50:00',2.64),('8975','2013-04-05','12:55:00',4.59),('8975','2013-04-05','13:00:00',6.73),('8975','2013-04-05','13:05:00',6.63),('8975','2013-04-05','13:10:00',4.11),('8975','2013-04-05','13:15:00',1.33),('8975','2013-04-05','13:20:00',2.39),('8975','2013-04-05','13:25:00',7.23),('8975','2013-04-05','13:30:00',6.08),('8975','2013-04-05','13:35:00',2.81),('8975','2013-04-05','13:40:00',6.61),('8975','2013-04-05','13:45:00',6.74),('8975','2013-04-05','13:50:00',4.8),('8975','2013-04-05','13:55:00',6),('8975','2013-04-05','14:00:00',2.77),('8975','2013-04-05','14:05:00',2.76),('8975','2013-04-05','14:10:00',1.74),('8975','2013-04-05','14:15:00',1.86),('8975','2013-04-05','14:20:00',4.8),('8975','2013-04-05','14:25:00',6.32),('8975','2013-04-05','14:30:00',5.83),('8975','2013-04-05','14:35:00',4.23),('8975','2013-04-05','14:40:00',2.83),('8975','2013-04-05','14:45:00',3.13),('8975','2013-04-05','14:50:00',3.69),('8975','2013-04-05','14:55:00',5.1),('8975','2013-04-05','15:00:00',5),('8975','2013-04-05','15:05:00',4.74),('8975','2013-04-05','15:10:00',4.6),('8975','2013-04-05','15:15:00',4.37),('8975','2013-04-05','15:20:00',4.19),('8975','2013-04-05','15:25:00',4.16),('8975','2013-04-05','15:30:00',4.04),('8975','2013-04-05','15:35:00',3.86),('8975','2013-04-05','15:40:00',3.67),('8975','2013-04-05','15:45:00',3.58),('8975','2013-04-05','15:50:00',3.55),('8975','2013-04-05','15:55:00',3.41),('8975','2013-04-05','16:00:00',2.99),('8975','2013-04-05','16:05:00',3.22),('8975','2013-04-05','16:10:00',3.24),('8975','2013-04-05','16:15:00',2.56),('8975','2013-04-05','16:20:00',2.57),('8975','2013-04-05','16:25:00',2.48),('8975','2013-04-05','16:30:00',2.86),('8975','2013-04-05','16:35:00',2.79),('8975','2013-04-05','16:40:00',2.28),('8975','2013-04-05','16:45:00',2.65),('8975','2013-04-05','16:50:00',2.32),('8975','2013-04-05','16:55:00',1.91),('8975','2013-04-05','17:00:00',1.92),('8975','2013-04-05','17:05:00',1.78),('8975','2013-04-05','17:10:00',1.63),('8975','2013-04-05','17:15:00',1.39),('8975','2013-04-05','17:20:00',1.2),('8975','2013-04-05','17:25:00',1.28),('8975','2013-04-05','17:30:00',1.22),('8975','2013-04-05','17:35:00',1.14),('8975','2013-04-05','17:40:00',1.11),('8975','2013-04-05','17:45:00',1.13),('8975','2013-04-05','17:50:00',1.08),('8975','2013-04-04','08:00:00',2.3),('8975','2013-04-04','08:05:00',2.61),('8975','2013-04-04','08:10:00',2.48),('8975','2013-04-04','08:15:00',2.16),('8975','2013-04-04','08:20:00',3.38),('8975','2013-04-04','08:25:00',2.34),('8975','2013-04-04','08:45:00',1.55),('8975','2013-04-04','08:50:00',1.82),('8975','2013-04-04','08:55:00',3.9),('8975','2013-04-04','09:00:00',4.41),('8975','2013-04-04','09:05:00',4.82),('8975','2013-04-04','09:10:00',4.16),('8975','2013-04-04','09:15:00',3.79),('8975','2013-04-04','09:20:00',3),('8975','2013-04-04','09:25:00',1.59),('8975','2013-04-04','09:30:00',1.17),('8975','2013-04-04','09:35:00',1.72),('8975','2013-04-04','09:40:00',2.83),('8975','2013-04-04','09:45:00',1.39),('8975','2013-04-04','09:50:00',2.15),('8975','2013-04-04','09:55:00',1.83),('8975','2013-04-04','10:00:00',1.77),('8975','2013-04-04','10:05:00',2.73),('8975','2013-04-04','10:10:00',5.04),('8975','2013-04-04','10:15:00',4.05),('8975','2013-04-04','10:20:00',3.1),('8975','2013-04-04','10:25:00',2.52),('8975','2013-04-04','10:30:00',4.83),('8975','2013-04-04','10:35:00',1.56),('8975','2013-04-04','10:40:00',4.79),('8975','2013-04-04','10:45:00',3.83),('8975','2013-04-04','10:50:00',5.7),('8975','2013-04-04','10:55:00',3.83),('8975','2013-04-04','11:00:00',5.08),('8975','2013-04-04','11:05:00',4.32),('8975','2013-04-04','11:10:00',5.33),('8975','2013-04-04','11:15:00',3.79),('8975','2013-04-04','11:20:00',6.83),('8975','2013-04-04','11:25:00',6.64),('8975','2013-04-04','11:30:00',3.57),('8975','2013-04-04','11:35:00',7.27),('8975','2013-04-04','11:40:00',4.75),('8975','2013-04-04','11:45:00',6.21),('8975','2013-04-04','11:50:00',6.2),('8975','2013-04-04','11:55:00',6.97),('8975','2013-04-04','12:00:00',7.1),('8975','2013-04-04','12:05:00',5.16),('8975','2013-04-04','12:10:00',3.25),('8975','2013-04-04','12:15:00',6.28),('8975','2013-04-04','12:20:00',5.96),('8975','2013-04-04','12:25:00',3.8),('8975','2013-04-04','12:30:00',2.71),('8975','2013-04-04','12:35:00',3.13),('8975','2013-04-04','12:40:00',3.18),('8975','2013-04-04','12:45:00',5.14),('8975','2013-04-04','12:50:00',3.32),('8975','2013-04-04','12:55:00',7.2),('8975','2013-04-04','13:00:00',3.89),('8975','2013-04-04','13:05:00',3.03),('8975','2013-04-04','13:10:00',4.15),('8975','2013-04-04','13:15:00',4.01),('8975','2013-04-04','13:20:00',4.52),('8975','2013-04-04','13:25:00',4.5),('8975','2013-04-04','13:30:00',4.97),('8975','2013-04-04','13:35:00',6.19),('8975','2013-04-04','13:40:00',6.1),('8975','2013-04-04','13:45:00',3.37),('8975','2013-04-04','13:50:00',5.15),('8975','2013-04-04','13:55:00',5.77),('8975','2013-04-04','14:00:00',3.41),('8975','2013-04-04','14:05:00',4.92),('8975','2013-04-04','14:10:00',5.42),('8975','2013-04-04','14:15:00',4.45),('8975','2013-04-04','14:20:00',4.3),('8975','2013-04-04','14:25:00',5.49),('8975','2013-04-04','14:30:00',3.14),('8975','2013-04-04','14:35:00',6.39),('8975','2013-04-04','14:40:00',5.76),('8975','2013-04-04','14:45:00',2.72),('8975','2013-04-04','14:50:00',4.36),('8975','2013-04-04','14:55:00',4.78),('8975','2013-04-04','15:00:00',5.21),('8975','2013-04-04','15:05:00',4.63),('8975','2013-04-04','15:10:00',3.18),('8975','2013-04-04','15:15:00',2.68),('8975','2013-04-04','15:20:00',2.6),('8975','2013-04-04','15:25:00',2.79),('8975','2013-04-04','15:30:00',3.2),('8975','2013-04-04','15:35:00',2.28),('8975','2013-04-04','15:40:00',2.12),('8975','2013-04-04','15:45:00',2.66),('8975','2013-04-04','15:50:00',3.52),('8975','2013-04-04','15:55:00',3.04),('8975','2013-04-04','16:00:00',2.72),('8975','2013-04-04','16:05:00',2.67),('8975','2013-04-04','16:10:00',2.97),('8975','2013-04-04','16:15:00',3.35),('8975','2013-04-04','16:20:00',3.79),('8975','2013-04-04','16:25:00',2.61),('8975','2013-04-04','16:30:00',2.37),('8975','2013-04-04','16:35:00',2.73),('8975','2013-04-04','16:40:00',2.51),('8975','2013-04-04','16:45:00',3.14),('8975','2013-04-04','16:50:00',1.93),('8975','2013-04-04','16:55:00',3.04),('8975','2013-04-04','17:00:00',2.41),('8975','2013-04-04','17:05:00',2.88),('8975','2013-04-04','17:10:00',1.91),('8975','2013-04-04','17:15:00',2.04),('8975','2013-04-04','17:20:00',2.46),('8975','2013-04-04','17:25:00',2.03),('8975','2013-04-04','17:30:00',1.9),('8975','2013-04-04','17:35:00',1.83),('8975','2013-04-04','17:40:00',1.64),('8975','2013-04-04','17:55:00',1.46),('8975','2013-04-04','18:00:00',1.54),('8975','2013-04-04','18:05:00',1.39),('8975','2013-04-04','18:10:00',1.38),('8975','2013-04-04','18:15:00',1.39),('8975','2013-04-04','18:20:00',1.25),('8975','2013-04-04','18:25:00',1.1),('8975','2013-04-04','18:30:00',1.05),('8975','2013-04-03','08:05:00',1.06),('8975','2013-04-03','08:20:00',1.07),('8975','2013-04-03','08:25:00',1.12),('8975','2013-04-03','08:30:00',1.18),('8975','2013-04-03','08:35:00',1.55),('8975','2013-04-03','08:40:00',1.38),('8975','2013-04-03','08:45:00',1.43),('8975','2013-04-03','08:50:00',1.69),('8975','2013-04-03','08:55:00',2.92),('8975','2013-04-03','09:00:00',3.76),('8975','2013-04-03','09:05:00',2.2),('8975','2013-04-03','09:10:00',3.09),('8975','2013-04-03','09:15:00',2.36),('8975','2013-04-03','09:20:00',2.18),('8975','2013-04-03','09:25:00',1.76),('8975','2013-04-03','09:30:00',3.26),('8975','2013-04-03','09:35:00',4.54),('8975','2013-04-03','09:40:00',4.17),('8975','2013-04-03','09:45:00',3.25),('8975','2013-04-03','09:50:00',2.2),('8975','2013-04-03','09:55:00',2.12),('8975','2013-04-03','10:00:00',3.15),('8975','2013-04-03','10:05:00',4.29),('8975','2013-04-03','10:10:00',2.65),('8975','2013-04-03','10:15:00',2.79),('8975','2013-04-03','10:20:00',5.16),('8975','2013-04-03','10:25:00',6.9),('8975','2013-04-03','10:30:00',4.64),('8975','2013-04-03','10:35:00',2.79),('8975','2013-04-03','10:40:00',6.07),('8975','2013-04-03','10:45:00',3.09),('8975','2013-04-03','10:50:00',3.14),('8975','2013-04-03','10:55:00',6.78),('8975','2013-04-03','11:00:00',5.68),('8975','2013-04-03','11:05:00',2.16),('8975','2013-04-03','11:10:00',1.74),('8975','2013-04-03','11:15:00',2.29),('8975','2013-04-03','11:20:00',2.27),('8975','2013-04-03','11:25:00',1.66),('8975','2013-04-03','11:30:00',1.95),('8975','2013-04-03','11:35:00',3.17),('8975','2013-04-03','11:40:00',4.4),('8975','2013-04-03','11:45:00',4.01),('8975','2013-04-03','11:50:00',4.07),('8975','2013-04-03','11:55:00',6.89),('8975','2013-04-03','12:00:00',6.1),('8975','2013-04-03','12:05:00',4.75),('8975','2013-04-03','12:10:00',5.98),('8975','2013-04-03','12:15:00',6.37),('8975','2013-04-03','12:20:00',5.59),('8975','2013-04-03','12:25:00',4.91),('8975','2013-04-03','12:30:00',5.36),('8975','2013-04-03','12:35:00',6.62),('8975','2013-04-03','12:40:00',6.36),('8975','2013-04-03','12:45:00',5.99),('8975','2013-04-03','12:50:00',6.09),('8975','2013-04-03','12:55:00',5.51),('8975','2013-04-03','13:00:00',5.66),('8975','2013-04-03','13:05:00',5.63),('8975','2013-04-03','13:10:00',6.05),('8975','2013-04-03','13:15:00',6.09),('8975','2013-04-03','13:20:00',5.94),('8975','2013-04-03','13:25:00',6.04),('8975','2013-04-03','13:30:00',5.78),('8975','2013-04-03','13:35:00',4.82),('8975','2013-04-03','13:40:00',3.95),('8975','2013-04-03','13:45:00',4.96),('8975','2013-04-03','13:50:00',4.84),('8975','2013-04-03','13:55:00',3.7),('8975','2013-04-03','14:00:00',4.23),('8975','2013-04-03','14:05:00',5.72),('8975','2013-04-03','14:10:00',5.63),('8975','2013-04-03','14:15:00',5.57),('8975','2013-04-03','14:20:00',5.34),('8975','2013-04-03','14:25:00',5.14),('8975','2013-04-03','14:30:00',5.05),('8975','2013-04-03','14:35:00',5.15),('8975','2013-04-03','14:40:00',5.07),('8975','2013-04-03','14:45:00',4.87),('8975','2013-04-03','14:50:00',4.75),('8975','2013-04-03','14:55:00',4.82),('8975','2013-04-03','15:00:00',4.69),('8975','2013-04-03','15:05:00',4.47),('8975','2013-04-03','15:10:00',4.18),('8975','2013-04-03','15:15:00',4.27),('8975','2013-04-03','15:20:00',4.16),('8975','2013-04-03','15:25:00',4.09),('8975','2013-04-03','15:30:00',3.97),('8975','2013-04-03','15:35:00',3.87),('8975','2013-04-03','15:40:00',3.8),('8975','2013-04-03','15:45:00',3.68),('8975','2013-04-03','15:50:00',3.52),('8975','2013-04-03','15:55:00',3.37),('8975','2013-04-03','16:00:00',3.31),('8975','2013-04-03','16:05:00',3.11),('8975','2013-04-03','16:10:00',3.07),('8975','2013-04-03','16:15:00',2.79),('8975','2013-04-03','16:20:00',3.08),('8975','2013-04-03','16:25:00',2.31),('8975','2013-04-03','16:30:00',2.65),('8975','2013-04-03','16:35:00',1.99),('8975','2013-04-03','16:40:00',2.27),('8975','2013-04-03','16:45:00',2.02),('8975','2013-04-03','16:50:00',2.05),('8975','2013-04-03','16:55:00',2.14),('8975','2013-04-03','17:00:00',1.97),('8975','2013-04-03','17:05:00',1.94),('8975','2013-04-03','17:10:00',1.71),('8975','2013-04-03','17:15:00',1.68),('8975','2013-04-03','17:20:00',1.37),('8975','2013-04-03','17:25:00',1.36),('8975','2013-04-03','17:30:00',1.11),('8975','2013-04-03','17:35:00',1.07),('8975','2013-04-03','17:40:00',1.18),('8975','2013-04-03','17:45:00',1.17),('8975','2013-04-03','17:50:00',1.28),('8975','2013-04-03','17:55:00',1.36),('8975','2013-04-03','18:00:00',1.16),('8975','2013-04-02','07:35:00',1.37),('8975','2013-04-02','07:40:00',1.79),('8975','2013-04-02','07:45:00',2.2),('8975','2013-04-02','07:50:00',2.14),('8975','2013-04-02','07:55:00',2.39),('8975','2013-04-02','08:00:00',2.68),('8975','2013-04-02','08:05:00',2.75),('8975','2013-04-02','08:10:00',2.98),('8975','2013-04-02','08:15:00',3.23),('8975','2013-04-02','08:20:00',3.27),('8975','2013-04-02','08:25:00',3.57),('8975','2013-04-02','08:30:00',3.45),('8975','2013-04-02','08:35:00',2.87),('8975','2013-04-02','08:40:00',2.97),('8975','2013-04-02','08:45:00',3.87),('8975','2013-04-02','08:50:00',3.9),('8975','2013-04-02','08:55:00',4.06),('8975','2013-04-02','09:00:00',4.21),('8975','2013-04-02','09:05:00',3.35),('8975','2013-04-02','09:10:00',2.89),('8975','2013-04-02','09:15:00',3.02),('8975','2013-04-02','09:20:00',4.26),('8975','2013-04-02','09:25:00',4.24),('8975','2013-04-02','09:30:00',4.02),('8975','2013-04-02','09:35:00',4.7),('8975','2013-04-02','09:40:00',3.27),('8975','2013-04-02','09:45:00',5.35),('8975','2013-04-02','09:50:00',4.46),('8975','2013-04-02','09:55:00',4.46),('8975','2013-04-02','10:00:00',2.71),('8975','2013-04-02','10:05:00',2.8),('8975','2013-04-02','10:10:00',4.85),('8975','2013-04-02','10:15:00',3.04),('8975','2013-04-02','10:20:00',4.88),('8975','2013-04-02','10:25:00',5.82),('8975','2013-04-02','10:30:00',4.89),('8975','2013-04-02','10:35:00',6.08),('8975','2013-04-02','10:40:00',4.52),('8975','2013-04-02','10:45:00',5.27),('8975','2013-04-02','10:50:00',6.88),('8975','2013-04-02','10:55:00',3.75),('8975','2013-04-02','11:00:00',2.4),('8975','2013-04-02','11:05:00',1.5),('8975','2013-04-02','11:10:00',4.4),('8975','2013-04-02','11:15:00',3.02),('8975','2013-04-02','11:20:00',1.48),('8975','2013-04-02','11:25:00',2.25),('8975','2013-04-02','11:30:00',3.11),('8975','2013-04-02','11:35:00',4),('8975','2013-04-02','11:40:00',4.4),('8975','2013-04-02','11:45:00',4.9),('8975','2013-04-02','11:50:00',5.33),('8975','2013-04-02','11:55:00',5.24),('8975','2013-04-02','12:00:00',6.04),('8975','2013-04-02','12:05:00',5.5),('8975','2013-04-02','12:10:00',6.82),('8975','2013-04-02','12:15:00',3.99),('8975','2013-04-02','12:20:00',4.26),('8975','2013-04-02','12:25:00',6),('8975','2013-04-02','12:30:00',4.64),('8975','2013-04-02','12:35:00',4.08),('8975','2013-04-02','12:40:00',5.92),('8975','2013-04-02','12:45:00',4.54),('8975','2013-04-02','12:50:00',7.28),('8975','2013-04-02','12:55:00',7.22),('8975','2013-04-02','13:00:00',5.46),('8975','2013-04-02','13:05:00',3.69),('8975','2013-04-02','13:10:00',6.16),('8975','2013-04-02','13:15:00',7.08),('8975','2013-04-02','13:20:00',4.53),('8975','2013-04-02','13:25:00',5.5),('8975','2013-04-02','13:30:00',4.74),('8975','2013-04-02','13:35:00',4.35),('8975','2013-04-02','13:40:00',5.23),('8975','2013-04-02','13:45:00',6.87),('8975','2013-04-02','13:50:00',7.15),('8975','2013-04-02','13:55:00',6.02),('8975','2013-04-02','14:00:00',4.22),('8975','2013-04-02','14:05:00',5.61),('8975','2013-04-02','14:10:00',7.28),('8975','2013-04-02','14:15:00',3.5),('8975','2013-04-02','14:20:00',3.67),('8975','2013-04-02','14:25:00',2.47),('8975','2013-04-02','14:30:00',5.93),('8975','2013-04-02','14:35:00',4.65),('8975','2013-04-02','14:40:00',4.87),('8975','2013-04-02','14:45:00',5.34),('8975','2013-04-02','14:50:00',5.12),('8975','2013-04-02','14:55:00',4.36),('8975','2013-04-02','15:00:00',5.09),('8975','2013-04-02','15:05:00',3.97),('8975','2013-04-02','15:10:00',4.22),('8975','2013-04-02','15:15:00',5.21),('8975','2013-04-02','15:20:00',4.78),('8975','2013-04-02','15:25:00',4.23),('8975','2013-04-02','15:30:00',2.91),('8975','2013-04-02','15:35:00',4.04),('8975','2013-04-02','15:40:00',3),('8975','2013-04-02','15:45:00',2.84),('8975','2013-04-02','15:50:00',3.95),('8975','2013-04-02','15:55:00',4.05),('8975','2013-04-02','16:00:00',3.98),('8975','2013-04-02','16:05:00',2.6),('8975','2013-04-02','16:10:00',3.68),('8975','2013-04-02','16:15:00',3.36),('8975','2013-04-02','16:20:00',3.36),('8975','2013-04-02','16:25:00',2.62),('8975','2013-04-02','16:30:00',3.32),('8975','2013-04-02','16:35:00',3.07),('8975','2013-04-02','16:40:00',2.79),('8975','2013-04-02','16:45:00',2.54),('8975','2013-04-02','16:50:00',2.24),('8975','2013-04-02','16:55:00',2.23),('8975','2013-04-02','17:00:00',2.19),('8975','2013-04-02','17:05:00',2.06),('8975','2013-04-02','17:10:00',2.04),('8975','2013-04-02','17:15:00',1.93),('8975','2013-04-02','17:20:00',1.84),('8975','2013-04-02','17:25:00',1.76),('8975','2013-04-02','17:30:00',1.69),('8975','2013-04-02','17:35:00',1.63),('8975','2013-04-02','17:40:00',1.58),('8975','2013-04-02','17:45:00',1.53),('8975','2013-04-02','17:50:00',1.47),('8975','2013-04-02','17:55:00',1.42),('8975','2013-04-02','18:00:00',1.38),('8975','2013-04-02','18:05:00',1.32),('8975','2013-04-02','18:10:00',1.28),('8975','2013-04-02','18:15:00',1.19),('8975','2013-04-02','18:20:00',1.14),('8975','2013-04-02','18:30:00',1.02),('8975','2013-04-01','08:40:00',2.8),('8975','2013-04-01','08:45:00',3.2),('8975','2013-04-01','08:50:00',1.18),('8975','2013-04-01','08:55:00',3.53),('8975','2013-04-01','09:00:00',3.96),('8975','2013-04-01','09:05:00',4.05),('8975','2013-04-01','09:10:00',4.64),('8975','2013-04-01','09:15:00',3.77),('8975','2013-04-01','09:20:00',1.27),('8975','2013-04-01','09:25:00',4.05),('8975','2013-04-01','09:30:00',5.32),('8975','2013-04-01','09:35:00',4.73),('8975','2013-04-01','09:40:00',5.42),('8975','2013-04-01','09:45:00',4.91),('8975','2013-04-01','09:50:00',2.12),('8975','2013-04-01','09:55:00',3.07),('8975','2013-04-01','10:00:00',1.92),('8975','2013-04-01','10:05:00',2.23),('8975','2013-04-01','10:10:00',1),('8975','2013-04-01','10:15:00',3.13),('8975','2013-04-01','10:20:00',1.91),('8975','2013-04-01','10:25:00',1.56),('8975','2013-04-01','10:30:00',1.14),('8975','2013-04-01','10:35:00',3.14),('8975','2013-04-01','10:40:00',4.18),('8975','2013-04-01','10:45:00',4.32),('8975','2013-04-01','10:50:00',5.98),('8975','2013-04-01','10:55:00',1.54),('8975','2013-04-01','11:00:00',1.79),('8975','2013-04-01','11:05:00',4.95),('8975','2013-04-01','11:10:00',2.71),('8975','2013-04-01','11:15:00',1.47),('8975','2013-04-01','11:20:00',1.4),('8975','2013-04-01','11:25:00',1.51),('8975','2013-04-01','11:30:00',2.55),('8975','2013-04-01','11:35:00',1.17),('8975','2013-04-01','11:40:00',2.95),('8975','2013-04-01','11:45:00',3.8),('8975','2013-04-01','11:50:00',2.84),('8975','2013-04-01','11:55:00',1.78),('8975','2013-04-01','12:00:00',2.74),('8975','2013-04-01','12:05:00',5.92),('8975','2013-04-01','12:10:00',3.99),('8975','2013-04-01','12:15:00',2.27),('8975','2013-04-01','12:30:00',2.21),('8975','2013-04-01','12:35:00',2.87),('8975','2013-04-01','12:40:00',3.27),('8975','2013-04-01','12:45:00',3.17),('8975','2013-04-01','12:50:00',2.75),('8975','2013-04-01','12:55:00',3.11),('8975','2013-04-01','13:00:00',3.72),('8975','2013-04-01','13:05:00',4.05),('8975','2013-04-01','13:10:00',4.15),('8975','2013-04-01','13:15:00',2.91),('8975','2013-04-01','13:20:00',2.88),('8975','2013-04-01','13:25:00',4.93),('8975','2013-04-01','13:30:00',3.81),('8975','2013-04-01','13:35:00',3.07),('8975','2013-04-01','13:40:00',3.69),('8975','2013-04-01','13:45:00',3.31),('8975','2013-04-01','13:50:00',2.77),('8975','2013-04-01','13:55:00',4.33),('8975','2013-04-01','14:00:00',4.06),('8975','2013-04-01','14:05:00',3.96),('8975','2013-04-01','14:10:00',5.45),('8975','2013-04-01','14:15:00',4.37),('8975','2013-04-01','14:20:00',8.06),('8975','2013-04-01','14:25:00',6.64),('8975','2013-04-01','14:30:00',2.97),('8975','2013-04-01','14:35:00',2.93),('8975','2013-04-01','14:40:00',4.17),('8975','2013-04-01','14:45:00',3.62),('8975','2013-04-01','14:50:00',2.25),('8975','2013-04-01','14:55:00',2.41),('8975','2013-04-01','15:00:00',1.78),('8975','2013-04-01','15:15:00',1.13),('8975','2013-04-01','15:20:00',1.54),('8975','2013-04-01','15:30:00',1),('8975','2013-04-01','15:35:00',1.08),('8975','2013-04-01','15:40:00',1.57),('8975','2013-04-01','15:45:00',1.48),('8975','2013-04-01','15:55:00',1.25),('8975','2013-04-01','16:00:00',1.88),('8975','2013-04-01','16:05:00',1.74),('8975','2013-04-01','16:10:00',1.36),('8975','2013-04-01','16:15:00',1.75),('8975','2013-04-01','16:20:00',1.62),('8975','2013-04-01','16:25:00',1.41),('8975','2013-04-01','16:30:00',1.79),('8975','2013-04-01','16:35:00',1.76),('8975','2013-04-01','16:40:00',1.46),('8975','2013-04-01','16:45:00',1.22),('8975','2013-04-01','16:55:00',1.19),('8975','2013-04-01','17:00:00',1.37),('8975','2013-04-01','17:05:00',1),('8975','2013-04-01','17:40:00',1.72),('8975','2013-04-01','17:45:00',1.02),('8975','2014-05-01','06:50:00',1.4),('8975','2014-05-01','06:55:00',1.44),('8975','2014-05-01','07:00:00',1.51),('8975','2014-05-01','07:05:00',1.94),('8975','2014-05-01','07:10:00',2.12),('8975','2014-05-01','07:15:00',2.34),('8975','2014-05-01','07:20:00',2),('8975','2014-05-01','07:25:00',2.58),('8975','2014-05-01','07:30:00',2.86),('8975','2014-05-01','07:35:00',3.01),('8975','2014-05-01','07:40:00',3.07),('8975','2014-05-01','07:45:00',3.14),('8975','2014-05-01','07:50:00',2.84),('8975','2014-05-01','07:55:00',1.71),('8975','2014-05-01','08:00:00',2.82),('8975','2014-05-01','08:05:00',4.22),('8975','2014-05-01','08:10:00',2.25),('8975','2014-05-01','08:15:00',1.55),('8975','2014-05-01','08:20:00',3.88),('8975','2014-05-01','08:25:00',2.61),('8975','2014-05-01','08:30:00',2.31),('8975','2014-05-01','08:35:00',1.05),('8975','2014-05-01','08:40:00',1.77),('8975','2014-05-01','08:45:00',4.17),('8975','2014-05-01','08:50:00',1.6),('8975','2014-05-01','08:55:00',1.08),('8975','2014-05-01','09:00:00',1.06),('8975','2014-05-01','09:05:00',1.26),('8975','2014-05-01','09:10:00',1.31),('8975','2014-05-01','09:15:00',2.32),('8975','2014-05-01','09:20:00',2.33),('8975','2014-05-01','09:25:00',3.09),('8975','2014-05-01','09:30:00',2.37),('8975','2014-05-01','09:35:00',2.7),('8975','2014-05-01','09:40:00',2.15),('8975','2014-05-01','09:45:00',1.97),('8975','2014-05-01','09:50:00',2.24),('8975','2014-05-01','09:55:00',2.18),('8975','2014-05-01','10:00:00',2.66),('8975','2014-05-01','10:05:00',3.03),('8975','2014-05-01','10:10:00',2.69),('8975','2014-05-01','10:15:00',2.54),('8975','2014-05-01','10:20:00',2.09),('8975','2014-05-01','10:25:00',1.78),('8975','2014-05-01','10:30:00',1.26),('8975','2014-05-01','10:35:00',1.3),('8975','2014-05-01','10:40:00',1.66),('8975','2014-05-01','10:45:00',2.19),('8975','2014-05-01','10:50:00',1.88),('8975','2014-05-01','11:20:00',1.12),('8975','2014-05-01','11:25:00',1.12),('8975','2014-05-01','11:30:00',1.07),('8975','2014-05-01','12:25:00',1.08),('8975','2014-05-01','12:30:00',1.53),('8975','2014-05-01','12:35:00',1.93),('8975','2014-05-01','12:40:00',1.65),('8975','2014-05-01','12:45:00',2.11),('8975','2014-05-01','12:50:00',2.8),('8975','2014-05-01','12:55:00',2.86),('8975','2014-05-01','13:00:00',2.96),('8975','2014-05-01','13:05:00',3.62),('8975','2014-05-01','13:10:00',2.67),('8975','2014-05-01','13:15:00',4.55),('8975','2014-05-01','13:20:00',4.56),('8975','2014-05-01','13:25:00',3.96),('8975','2014-05-01','13:30:00',4.09),('8975','2014-05-01','13:35:00',2.58),('8975','2014-05-01','13:40:00',3.96),('8975','2014-05-01','13:45:00',3.23),('8975','2014-05-01','13:50:00',2.13),('8975','2014-05-01','13:55:00',2.23),('8975','2014-05-01','14:00:00',4.33),('8975','2014-05-01','14:05:00',3.41),('8975','2014-05-01','14:10:00',1.86),('8975','2014-05-01','14:15:00',1.25),('8975','2014-05-01','14:20:00',2.02),('8975','2014-05-01','14:25:00',4.03),('8975','2014-05-01','14:30:00',4.84),('8975','2014-05-01','14:35:00',2.98),('8975','2014-05-01','14:40:00',2.98),('8975','2014-05-01','14:45:00',2.52),('8975','2014-05-01','14:50:00',2.44),('8975','2014-05-01','14:55:00',2.97),('8975','2014-05-01','15:00:00',6.06),('8975','2014-05-01','15:05:00',4.94),('8975','2014-05-01','15:10:00',6.07),('8975','2014-05-01','15:15:00',4.2),('8975','2014-05-01','15:20:00',2.19),('8975','2014-05-01','15:25:00',1.75),('8975','2014-05-01','15:30:00',3.65),('8975','2014-05-01','15:35:00',6.85),('8975','2014-05-01','15:40:00',3.42),('8975','2014-05-01','15:45:00',1.71),('8975','2014-05-01','15:50:00',1.67),('8975','2014-05-01','15:55:00',1.53),('8975','2014-05-01','16:00:00',2.12),('8975','2014-05-01','16:05:00',2.04),('8975','2014-05-01','16:10:00',1.38),('8975','2014-05-01','16:15:00',2.19),('8975','2014-05-01','16:20:00',2.16),('8975','2014-05-01','16:55:00',1.28),('8975','2014-05-01','17:00:00',1.19),('8975','2014-05-01','17:05:00',1.41),('8975','2014-05-01','17:10:00',1.3),('8975','2014-05-01','17:15:00',1.85),('8975','2014-05-01','17:20:00',1.62),('8975','2014-05-01','17:25:00',1.71),('8975','2014-05-01','17:30:00',1.32),('8975','2014-05-01','17:35:00',1.1),('8975','2014-03-26','07:45:00',1.16),('8975','2014-03-26','07:50:00',1.3),('8975','2014-03-26','07:55:00',2.22),('8975','2014-03-26','08:00:00',2.54),('8975','2014-03-26','08:05:00',2.1),('8975','2014-03-26','09:10:00',1.39),('8975','2014-03-26','09:15:00',1.45),('8975','2014-03-26','09:20:00',1.37),('8975','2014-03-26','09:25:00',1.22),('8975','2014-03-26','09:50:00',1.05),('8975','2014-03-26','09:55:00',1.48),('8975','2014-03-26','10:00:00',1.41),('8975','2014-03-26','10:05:00',1.81),('8975','2014-03-26','10:10:00',1.98),('8975','2014-03-26','10:15:00',1.88),('8975','2014-03-26','10:20:00',2.37),('8975','2014-03-26','10:25:00',2.83),('8975','2014-03-26','10:30:00',3.33),('8975','2014-03-26','10:35:00',3.27),('8975','2014-03-26','10:40:00',3.02),('8975','2014-03-26','10:45:00',1.43),('8975','2014-03-26','10:50:00',1.43),('8975','2014-03-26','10:55:00',2.1),('8975','2014-03-26','11:00:00',1.32),('8975','2014-03-26','11:05:00',3.7),('8975','2014-03-26','11:10:00',5.46),('8975','2014-03-26','11:15:00',5.04),('8975','2014-03-26','11:20:00',2.02),('8975','2014-03-26','11:25:00',1.53),('8975','2014-03-26','11:30:00',1.15),('8975','2014-03-26','11:45:00',1.05),('8975','2014-03-26','11:50:00',1.65),('8975','2014-03-26','11:55:00',2.93),('8975','2014-03-26','12:00:00',1.94),('8975','2014-03-26','12:05:00',2.43),('8975','2014-03-26','12:10:00',2.33),('8975','2014-03-26','12:15:00',1.81),('8975','2014-03-26','12:20:00',1.59),('8975','2014-03-26','12:50:00',1.18),('8975','2014-03-26','12:55:00',1.53),('8975','2014-03-26','13:00:00',1.6),('8975','2014-03-26','13:05:00',2.01),('8975','2014-03-26','13:10:00',2.64),('8975','2014-03-26','13:15:00',3.24),('8975','2014-03-26','13:20:00',3.33),('8975','2014-03-26','13:25:00',3.33),('8975','2014-03-26','13:30:00',2.91),('8975','2014-03-26','13:35:00',2.95),('8975','2014-03-26','13:40:00',2.67),('8975','2014-03-26','13:45:00',2.88),('8975','2014-03-26','13:50:00',3.9),('8975','2014-03-26','13:55:00',4.43),('8975','2014-03-26','14:00:00',2.51),('8975','2014-03-26','14:05:00',1.61),('8975','2014-03-26','14:10:00',2.8),('8975','2014-03-26','14:15:00',4.6),('8975','2014-03-26','14:20:00',5.45),('8975','2014-03-26','14:25:00',4.34),('8975','2014-03-26','14:30:00',3.69),('8975','2014-03-26','14:35:00',3.17),('8975','2014-03-26','14:40:00',2.51),('8975','2014-03-26','14:45:00',2.7),('8975','2014-03-26','14:50:00',2.52),('8975','2014-03-26','14:55:00',2.04),('8975','2014-03-26','15:00:00',3.16),('8975','2014-03-26','15:05:00',1.49),('8975','2014-03-26','15:15:00',1.09),('8975','2014-03-26','15:20:00',2.7),('8975','2014-03-26','15:25:00',3.74),('8975','2014-03-26','15:30:00',2.37),('8975','2014-03-26','15:35:00',2.3),('8975','2014-03-26','15:40:00',1.29),('8975','2014-03-26','15:45:00',1.44),('8975','2014-03-26','15:50:00',1.61),('8975','2014-03-26','15:55:00',1.2),('8975','2014-03-26','16:00:00',1.27),('8975','2014-03-26','16:05:00',1.79),('8975','2014-03-26','16:10:00',2),('8975','2014-03-26','16:15:00',1.47),('8975','2014-03-26','16:20:00',1.3),('8975','2014-03-26','16:25:00',1.63),('8975','2014-03-26','16:30:00',1.29),('8975','2014-03-26','16:35:00',1.4),('8975','2014-03-26','16:40:00',1.4),('8975','2014-03-26','16:45:00',1.41),('8975','2014-03-26','16:50:00',1.01),('8975','2014-03-26','16:55:00',1.06),('8975','2013-03-31','08:00:00',1.15),('8975','2013-03-31','08:15:00',1.22),('8975','2013-03-31','08:20:00',2.59),('8975','2013-03-31','08:25:00',3.31),('8975','2013-03-31','08:30:00',3.58),('8975','2013-03-31','08:35:00',3.56),('8975','2013-03-31','08:40:00',2.63),('8975','2013-03-31','08:45:00',2.04),('8975','2013-03-31','08:50:00',1.8),('8975','2013-03-31','08:55:00',2.56),('8975','2013-03-31','09:00:00',4.15),('8975','2013-03-31','09:05:00',3.77),('8975','2013-03-31','09:10:00',4.31),('8975','2013-03-31','09:15:00',4.25),('8975','2013-03-31','09:20:00',3.89),('8975','2013-03-31','09:25:00',4.43),('8975','2013-03-31','09:30:00',4.64),('8975','2013-03-31','09:35:00',3.76),('8975','2013-03-31','09:40:00',4.31),('8975','2013-03-31','09:45:00',5.08),('8975','2013-03-31','09:50:00',5.01),('8975','2013-03-31','09:55:00',4.79),('8975','2013-03-31','10:00:00',5.44),('8975','2013-03-31','10:05:00',5.02),('8975','2013-03-31','10:10:00',3.5),('8975','2013-03-31','10:15:00',5.17),('8975','2013-03-31','10:20:00',2.52),('8975','2013-03-31','10:25:00',2.31),('8975','2013-03-31','10:30:00',1.93),('8975','2013-03-31','10:35:00',2.7),('8975','2013-03-31','10:40:00',4.27),('8975','2013-03-31','10:45:00',2.49),('8975','2013-03-31','10:50:00',1.46),('8975','2013-03-31','10:55:00',1.74),('8975','2013-03-31','11:00:00',2.6),('8975','2013-03-31','11:05:00',4.59),('8975','2013-03-31','11:10:00',4.41),('8975','2013-03-31','11:15:00',5.43),('8975','2013-03-31','11:20:00',3.73),('8975','2013-03-31','11:25:00',3.75),('8975','2013-03-31','11:30:00',3.54),('8975','2013-03-31','11:35:00',5.12),('8975','2013-03-31','11:40:00',5.91),('8975','2013-03-31','11:45:00',4.89),('8975','2013-03-31','11:50:00',3.86),('8975','2013-03-31','11:55:00',4.18),('8975','2013-03-31','12:00:00',4.52),('8975','2013-03-31','12:05:00',3.11),('8975','2013-03-31','12:10:00',3.3),('8975','2013-03-31','12:15:00',3.73),('8975','2013-03-31','12:20:00',3.08),('8975','2013-03-31','12:25:00',3.13),('8975','2013-03-31','12:30:00',4.04),('8975','2013-03-31','12:35:00',3.71),('8975','2013-03-31','12:40:00',3.85),('8975','2013-03-31','12:45:00',4.59),('8975','2013-03-31','12:50:00',4.78),('8975','2013-03-31','12:55:00',4.25),('8975','2013-03-31','13:00:00',4.17),('8975','2013-03-31','13:05:00',4.2),('8975','2013-03-31','13:10:00',4.14),('8975','2013-03-31','13:15:00',4.79),('8975','2013-03-31','13:20:00',3.67),('8975','2013-03-31','13:25:00',3.9),('8975','2013-03-31','13:30:00',3.94),('8975','2013-03-31','13:35:00',4.67),('8975','2013-03-31','13:40:00',6.88),('8975','2013-03-31','13:45:00',6.35),('8975','2013-03-31','13:50:00',5.5),('8975','2013-03-31','13:55:00',4.96),('8975','2013-03-31','14:00:00',3.92),('8975','2013-03-31','14:05:00',3.1),('8975','2013-03-31','14:10:00',3.96),('8975','2013-03-31','14:15:00',4.15),('8975','2013-03-31','14:20:00',4.46),('8975','2013-03-31','14:25:00',4.67),('8975','2013-03-31','14:30:00',2.66),('8975','2013-03-31','14:35:00',2.91),('8975','2013-03-31','14:40:00',2.67),('8975','2013-03-31','14:45:00',2.74),('8975','2013-03-31','14:50:00',3.03),('8975','2013-03-31','14:55:00',3.14),('8975','2013-03-31','15:00:00',3.02),('8975','2013-03-31','15:05:00',3.14),('8975','2013-03-31','15:10:00',3.15),('8975','2013-03-31','15:15:00',3.24),('8975','2013-03-31','15:20:00',3.34),('8975','2013-03-31','15:25:00',3.17),('8975','2013-03-31','15:30:00',3.19),('8975','2013-03-31','15:35:00',3.56),('8975','2013-03-31','15:40:00',3.39),('8975','2013-03-31','15:45:00',3.58),('8975','2013-03-31','15:50:00',3.61),('8975','2013-03-31','15:55:00',2.68),('8975','2013-03-31','16:00:00',2.59),('8975','2013-03-31','16:05:00',2.16),('8975','2013-03-31','16:10:00',2),('8975','2013-03-31','16:15:00',1.71),('8975','2013-03-31','16:20:00',1.6),('8975','2013-03-31','16:25:00',1.42),('8975','2013-03-31','16:30:00',1.16),('8975','2013-03-31','16:35:00',1.19),('8975','2013-03-31','16:40:00',1.12),('8975','2013-03-30','08:15:00',1.23),('8975','2013-03-30','08:20:00',2.4),('8975','2013-03-30','08:25:00',1.46),('8975','2013-03-30','08:30:00',2.09),('8975','2013-03-30','08:35:00',3.01),('8975','2013-03-30','08:40:00',1.98),('8975','2013-03-30','08:45:00',1.76),('8975','2013-03-30','08:50:00',1.55),('8975','2013-03-30','08:55:00',2.59),('8975','2013-03-30','09:00:00',2.08),('8975','2013-03-30','09:05:00',3.02),('8975','2013-03-30','09:10:00',2.64),('8975','2013-03-30','09:15:00',1.92),('8975','2013-03-30','09:20:00',4.88),('8975','2013-03-30','09:25:00',4.03),('8975','2013-03-30','09:30:00',2.97),('8975','2013-03-30','09:35:00',2.7),('8975','2013-03-30','09:40:00',1.63),('8975','2013-03-30','09:45:00',4.57),('8975','2013-03-30','09:50:00',1.94),('8975','2013-03-30','09:55:00',3.15),('8975','2013-03-30','10:00:00',3.19),('8975','2013-03-30','10:05:00',2.29),('8975','2013-03-30','10:15:00',1.65),('8975','2013-03-30','10:20:00',2.9),('8975','2013-03-30','10:25:00',4.21),('8975','2013-03-30','10:30:00',4.85),('8975','2013-03-30','10:35:00',3.97),('8975','2013-03-30','10:45:00',2.05),('8975','2013-03-30','10:50:00',3.18),('8975','2013-03-30','10:55:00',2.77),('8975','2013-03-30','11:00:00',1.14),('8975','2013-03-30','11:05:00',1.02),('8975','2013-03-30','11:10:00',2.67),('8975','2013-03-30','11:15:00',2.17),('8975','2013-03-30','11:20:00',1.77),('8975','2013-03-30','11:25:00',1.48),('8975','2013-03-30','11:30:00',1.17),('8975','2013-03-30','11:35:00',1.9),('8975','2013-03-30','11:40:00',2.28),('8975','2013-03-30','11:45:00',1.69),('8975','2013-03-30','11:50:00',2.62),('8975','2013-03-30','11:55:00',2.66),('8975','2013-03-30','12:00:00',2.1),('8975','2013-03-30','12:05:00',2.23),('8975','2013-03-30','12:10:00',2.39),('8975','2013-03-30','12:15:00',2.3),('8975','2013-03-30','12:20:00',2.68),('8975','2013-03-30','12:25:00',3.24),('8975','2013-03-30','12:30:00',2.64),('8975','2013-03-30','12:35:00',2.62),('8975','2013-03-30','12:40:00',1.99),('8975','2013-03-30','12:45:00',1.59),('8975','2013-03-30','12:50:00',2.55),('8975','2013-03-30','12:55:00',3.53),('8975','2013-03-30','13:00:00',4.1),('8975','2013-03-30','13:05:00',5.19),('8975','2013-03-30','13:10:00',2.41),('8975','2013-03-30','13:15:00',4.17),('8975','2013-03-30','13:20:00',5.45),('8975','2013-03-30','13:25:00',2.9),('8975','2013-03-30','13:30:00',1.55),('8975','2013-03-30','13:35:00',4.75),('8975','2013-03-30','13:40:00',5.7),('8975','2013-03-30','13:45:00',2.45),('8975','2013-03-30','13:50:00',3.51),('8975','2013-03-30','13:55:00',4.48),('8975','2013-03-30','14:00:00',2.18),('8975','2013-03-30','14:05:00',3.19),('8975','2013-03-30','14:10:00',5.01),('8975','2013-03-30','14:15:00',3.87),('8975','2013-03-30','14:20:00',5.21),('8975','2013-03-30','14:25:00',5.62),('8975','2013-03-30','14:30:00',4.72),('8975','2013-03-30','14:35:00',2.87),('8975','2013-03-30','14:40:00',5.33),('8975','2013-03-30','14:45:00',5.68),('8975','2013-03-30','14:50:00',5.16),('8975','2013-03-30','14:55:00',4.27),('8975','2013-03-30','15:00:00',3.94),('8975','2013-03-30','15:05:00',4.09),('8975','2013-03-30','15:10:00',3.87),('8975','2013-03-30','15:15:00',5.66),('8975','2013-03-30','15:20:00',4.39),('8975','2013-03-30','15:25:00',3.12),('8975','2013-03-30','15:30:00',2.97),('8975','2013-03-30','15:35:00',3.96),('8975','2013-03-30','15:40:00',3.79),('8975','2013-03-30','15:45:00',3.35),('8975','2013-03-30','15:50:00',1.57),('8975','2013-03-30','15:55:00',2.99),('8975','2013-03-30','16:00:00',3.94),('8975','2013-03-30','16:05:00',2.17),('8975','2013-03-30','16:10:00',2.17),('8975','2013-03-30','16:15:00',2.88),('8975','2013-03-30','16:20:00',2.44),('8975','2013-03-30','16:25:00',1.89),('8975','2013-03-30','16:30:00',1.68),('8975','2013-03-30','16:35:00',1.75),('8975','2013-03-30','16:40:00',1.79),('8975','2013-03-30','16:45:00',1.78),('8975','2013-03-30','16:50:00',1.42),('8975','2013-03-30','16:55:00',1.38),('8975','2013-03-30','17:00:00',1.67),('8975','2013-03-30','17:05:00',1.61),('8975','2013-03-30','17:10:00',1.67),('8975','2013-03-30','17:15:00',1.55),('8975','2013-03-30','17:20:00',1.74),('8975','2013-03-30','17:25:00',1.65),('8975','2013-03-30','17:30:00',1.78),('8975','2013-03-30','17:35:00',1.72),('8975','2013-03-30','17:40:00',1.1),('8975','2013-03-30','17:45:00',1.29),('8975','2013-03-30','17:50:00',1.33),('8975','2013-03-30','17:55:00',2.06),('8975','2013-03-30','18:00:00',1.05),('8975','2013-03-30','18:10:00',1.17),('8975','2013-03-30','18:15:00',1.75),('8975','2013-03-29','07:05:00',1.05),('8975','2013-03-29','07:50:00',1.21),('8975','2013-03-29','07:55:00',1.39),('8975','2013-03-29','08:00:00',1.14),('8975','2013-03-29','08:05:00',1.01),('8975','2013-03-29','08:10:00',1.12),('8975','2013-03-29','08:15:00',1.35),('8975','2013-03-29','08:20:00',1.36),('8975','2013-03-29','08:25:00',1.48),('8975','2013-03-29','08:30:00',1.55),('8975','2013-03-29','08:35:00',1.82),('8975','2013-03-29','08:40:00',1.61),('8975','2013-03-29','08:45:00',1.29),('8975','2013-03-29','08:50:00',1.5),('8975','2013-03-29','08:55:00',1.18),('8975','2013-03-29','09:00:00',1.45),('8975','2013-03-29','09:05:00',2.32),('8975','2013-03-29','09:10:00',3.72),('8975','2013-03-29','09:15:00',5.91),('8975','2013-03-29','09:20:00',4.82),('8975','2013-03-29','09:25:00',1.73),('8975','2013-03-29','09:30:00',1.75),('8975','2013-03-29','09:35:00',2.17),('8975','2013-03-29','09:40:00',2.38),('8975','2013-03-29','09:45:00',2.27),('8975','2013-03-29','09:50:00',2.16),('8975','2013-03-29','09:55:00',2.51),('8975','2013-03-29','10:00:00',2.97),('8975','2013-03-29','10:05:00',2.99),('8975','2013-03-29','10:10:00',3.04),('8975','2013-03-29','10:15:00',2.68),('8975','2013-03-29','10:20:00',2.28),('8975','2013-03-29','10:25:00',2.31),('8975','2013-03-29','10:30:00',2.69),('8975','2013-03-29','10:35:00',3.19),('8975','2013-03-29','10:40:00',3.7),('8975','2013-03-29','10:45:00',4.07),('8975','2013-03-29','10:50:00',3.98),('8975','2013-03-29','10:55:00',3.11),('8975','2013-03-29','11:00:00',3.21),('8975','2013-03-29','11:05:00',3.29),('8975','2013-03-29','11:10:00',2.99),('8975','2013-03-29','11:15:00',2.87),('8975','2013-03-29','11:20:00',2.71),('8975','2013-03-29','11:25:00',3.4),('8975','2013-03-29','11:30:00',4.9),('8975','2013-03-29','11:35:00',4.88),('8975','2013-03-29','11:40:00',5.05),('8975','2013-03-29','11:45:00',5.46),('8975','2013-03-29','11:50:00',4.57),('8975','2013-03-29','11:55:00',5.73),('8975','2013-03-29','12:00:00',5.51),('8975','2013-03-29','12:05:00',3.72),('8975','2013-03-29','12:10:00',3.77),('8975','2013-03-29','12:15:00',3.6),('8975','2013-03-29','12:20:00',2.38),('8975','2013-03-29','12:25:00',1.22),('8975','2013-03-29','12:30:00',1.94),('8975','2013-03-29','12:35:00',1.03),('8975','2013-03-29','12:45:00',2.16),('8975','2013-03-29','12:50:00',1.05),('8975','2013-03-29','13:05:00',1.07),('8975','2013-03-29','13:10:00',3),('8975','2013-03-29','13:15:00',3.54),('8975','2013-03-29','13:20:00',2.17),('8975','2013-03-29','13:25:00',1.63),('8975','2013-03-29','13:40:00',1.36),('8975','2013-03-29','13:45:00',3.77),('8975','2013-03-29','13:50:00',3.15),('8975','2013-03-29','13:55:00',1.72),('8975','2013-03-29','14:00:00',1.87),('8975','2013-03-29','14:05:00',1.42),('8975','2013-03-29','14:10:00',1.18),('8975','2013-03-29','14:15:00',1.38),('8975','2013-03-29','14:20:00',1.3),('8975','2013-03-29','14:25:00',1.72),('8975','2013-03-29','14:30:00',2.27),('8975','2013-03-29','14:35:00',1.72),('8975','2013-03-29','14:40:00',1.68),('8975','2013-03-29','14:45:00',1.87),('8975','2013-03-29','14:50:00',1.95),('8975','2013-03-29','14:55:00',1.18),('8975','2013-03-29','15:15:00',1.72),('8975','2013-03-29','15:20:00',1.88),('8975','2013-03-29','15:25:00',1.72),('8975','2013-03-29','15:30:00',1.39),('8975','2013-03-29','15:35:00',1.28),('8975','2013-03-29','15:40:00',1.32),('8975','2013-03-29','15:45:00',1.22),('8975','2013-03-28','06:50:00',1.22),('8975','2013-03-28','06:55:00',1.78),('8975','2013-03-28','07:00:00',2.14),('8975','2013-03-28','07:05:00',2.36),('8975','2013-03-28','07:10:00',2.52),('8975','2013-03-28','07:15:00',2.68),('8975','2013-03-28','07:20:00',2.61),('8975','2013-03-28','07:25:00',2.36),('8975','2013-03-28','07:30:00',3.23),('8975','2013-03-28','07:35:00',3.2),('8975','2013-03-28','07:40:00',3.32),('8975','2013-03-28','07:45:00',3.47),('8975','2013-03-28','07:50:00',2.17),('8975','2013-03-28','07:55:00',2.25),('8975','2013-03-28','08:00:00',2.47),('8975','2013-03-28','08:05:00',3.54),('8975','2013-03-28','08:10:00',4.07),('8975','2013-03-28','08:15:00',4.12),('8975','2013-03-28','08:20:00',4.25),('8975','2013-03-28','08:25:00',4.31),('8975','2013-03-28','08:30:00',4.39),('8975','2013-03-28','08:35:00',4.56),('8975','2013-03-28','08:40:00',4.59),('8975','2013-03-28','08:45:00',4.6),('8975','2013-03-28','08:50:00',4.69),('8975','2013-03-28','08:55:00',3.81),('8975','2013-03-28','09:00:00',4.25),('8975','2013-03-28','09:05:00',4.97),('8975','2013-03-28','09:10:00',4.84),('8975','2013-03-28','09:15:00',5.13),('8975','2013-03-28','09:20:00',5.58),('8975','2013-03-28','09:25:00',5.36),('8975','2013-03-28','09:30:00',5.92),('8975','2013-03-28','09:35:00',5.67),('8975','2013-03-28','09:40:00',5.53),('8975','2013-03-28','09:45:00',5.25),('8975','2013-03-28','09:50:00',4.53),('8975','2013-03-28','09:55:00',5.63),('8975','2013-03-28','10:00:00',5.75),('8975','2013-03-28','10:05:00',5.52),('8975','2013-03-28','10:10:00',4.37),('8975','2013-03-28','10:15:00',5.04),('8975','2013-03-28','10:20:00',5.45),('8975','2013-03-28','10:25:00',5.2),('8975','2013-03-28','10:30:00',5.2),('8975','2013-03-28','10:35:00',5.74),('8975','2013-03-28','10:40:00',6.08),('8975','2013-03-28','10:45:00',5.86),('8975','2013-03-28','10:50:00',5.98),('8975','2013-03-28','10:55:00',5.54),('8975','2013-03-28','11:00:00',6.25),('8975','2013-03-28','11:05:00',6.18),('8975','2013-03-28','11:10:00',6.57),('8975','2013-03-28','11:15:00',6.73),('8975','2013-03-28','11:20:00',6.55),('8975','2013-03-28','11:25:00',6.5),('8975','2013-03-28','11:30:00',6.45),('8975','2013-03-28','11:35:00',6.27),('8975','2013-03-28','11:40:00',6.38),('8975','2013-03-28','11:45:00',6.42),('8975','2013-03-28','11:50:00',6.46),('8975','2013-03-28','11:55:00',6.42),('8975','2013-03-28','12:00:00',6.42),('8975','2013-03-28','12:05:00',6.49),('8975','2013-03-28','12:10:00',6.46),('8975','2013-03-28','12:15:00',6.1),('8975','2013-03-28','12:20:00',6.24),('8975','2013-03-28','12:25:00',6.11),('8975','2013-03-28','12:30:00',5.93),('8975','2013-03-28','12:35:00',6.06),('8975','2013-03-28','12:40:00',5.83),('8975','2013-03-28','12:45:00',5.76),('8975','2013-03-28','12:50:00',5.93),('8975','2013-03-28','12:55:00',4.23),('8975','2013-03-28','13:00:00',5.76),('8975','2013-03-28','13:05:00',5.27),('8975','2013-03-28','13:10:00',5.27),('8975','2013-03-28','13:15:00',5.5),('8975','2013-03-28','13:20:00',5.91),('8975','2013-03-28','13:25:00',6.09),('8975','2013-03-28','13:30:00',5.6),('8975','2013-03-28','13:35:00',4.52),('8975','2013-03-28','13:40:00',4.34),('8975','2013-03-28','13:45:00',4.58),('8975','2013-03-28','13:50:00',4.68),('8975','2013-03-28','13:55:00',4.76),('8975','2013-03-28','14:00:00',4.97),('8975','2013-03-28','14:05:00',4.05),('8975','2013-03-28','14:10:00',3.48),('8975','2013-03-28','14:15:00',3.27),('8975','2013-03-28','14:20:00',3.56),('8975','2013-03-28','14:25:00',3.73),('8975','2013-03-28','14:30:00',3.17),('8975','2013-03-28','14:35:00',3.01),('8975','2013-03-28','14:40:00',2.99),('8975','2013-03-28','14:45:00',2.9),('8975','2013-03-28','14:50:00',2.78),('8975','2013-03-28','14:55:00',2.67),('8975','2013-03-28','15:00:00',2.44),('8975','2013-03-28','15:05:00',2.34),('8975','2013-03-28','15:10:00',2.28),('8975','2013-03-28','15:15:00',2.2),('8975','2013-03-28','15:20:00',2.09),('8975','2013-03-28','15:25:00',1.98),('8975','2013-03-28','15:30:00',1.84),('8975','2013-03-28','15:35:00',1.77),('8975','2013-03-28','15:40:00',1.7),('8975','2013-03-28','15:45:00',1.62),('8975','2013-03-28','15:50:00',1.74),('8975','2013-03-28','15:55:00',1.97),('8975','2013-03-28','16:00:00',2.49),('8975','2013-03-28','16:05:00',2.26),('8975','2013-03-28','16:10:00',1.65),('8975','2013-03-28','16:15:00',1.57),('8975','2013-03-28','16:20:00',1.45),('8975','2013-03-28','16:25:00',1.52),('8975','2013-03-28','16:30:00',1.47),('8975','2013-03-28','16:35:00',1.72),('8975','2013-03-28','16:40:00',2.42),('8975','2013-03-28','16:45:00',2.08),('8975','2013-03-28','16:50:00',1.61),('8975','2013-03-28','16:55:00',1.44),('8975','2013-03-28','17:00:00',1.35),('8975','2013-03-28','17:20:00',1.15),('8975','2013-03-28','17:25:00',1.35),('8975','2013-03-28','17:30:00',1.21),('8975','2013-03-27','07:30:00',1.07),('8975','2013-03-27','07:40:00',1.19),('8975','2013-03-27','08:50:00',1.25),('8975','2013-03-27','08:55:00',1.28),('8975','2013-03-27','09:00:00',1.4),('8975','2013-03-27','09:05:00',2.71),('8975','2013-03-27','09:10:00',7.1),('8975','2013-03-27','09:15:00',3.82),('8975','2013-03-27','09:20:00',2.55),('8975','2013-03-27','09:25:00',1.94),('8975','2013-03-27','09:30:00',1.35),('8975','2013-03-27','09:35:00',1.39),('8975','2013-03-27','09:40:00',1.6),('8975','2013-03-27','09:45:00',1.66),('8975','2013-03-27','09:50:00',1.78),('8975','2013-03-27','09:55:00',1.75),('8975','2013-03-27','10:00:00',1.94),('8975','2013-03-27','10:05:00',1.44),('8975','2013-03-27','10:10:00',1.36),('8975','2013-03-27','10:20:00',1.11),('8975','2013-03-27','10:55:00',1.35),('8975','2013-03-27','11:00:00',1.02),('8975','2013-03-27','11:20:00',1.4),('8975','2013-03-27','11:25:00',1.68),('8975','2013-03-27','11:30:00',2.37),('8975','2013-03-27','11:35:00',2.95),('8975','2013-03-27','11:40:00',3.25),('8975','2013-03-27','11:45:00',2.08),('8975','2013-03-27','11:50:00',3.34),('8975','2013-03-27','11:55:00',3.23),('8975','2013-03-27','12:00:00',2.25),('8975','2013-03-27','12:05:00',1.79),('8975','2013-03-27','12:10:00',2.47),('8975','2013-03-27','12:15:00',2.43),('8975','2013-03-27','12:20:00',1.52),('8975','2013-03-27','12:25:00',1.69),('8975','2013-03-27','12:30:00',1.44),('8975','2013-03-27','12:35:00',1.68),('8975','2013-03-27','12:40:00',2.08),('8975','2013-03-27','12:45:00',3.95),('8975','2013-03-27','12:50:00',6.41),('8975','2013-03-27','12:55:00',4.43),('8975','2013-03-27','13:00:00',5.85),('8975','2013-03-27','13:05:00',4.88),('8975','2013-03-27','13:10:00',4.91),('8975','2013-03-27','13:15:00',3.06),('8975','2013-03-27','13:20:00',2.54),('8975','2013-03-27','13:25:00',3.71),('8975','2013-03-27','13:30:00',3.62),('8975','2013-03-27','13:35:00',3.22),('8975','2013-03-27','13:40:00',3.13),('8975','2013-03-27','13:45:00',4.4),('8975','2013-03-27','13:50:00',3.03),('8975','2013-03-27','13:55:00',2.97),('8975','2013-03-27','14:00:00',3.53),('8975','2013-03-27','14:05:00',2.95),('8975','2013-03-27','14:10:00',2.1),('8975','2013-03-27','14:15:00',2.42),('8975','2013-03-27','14:20:00',3.04),('8975','2013-03-27','14:25:00',3.56),('8975','2013-03-27','14:30:00',2.96),('8975','2013-03-27','14:35:00',2.04),('8975','2013-03-27','14:40:00',2.5),('8975','2013-03-27','14:45:00',2.5),('8975','2013-03-27','14:50:00',1.62),('8975','2013-03-27','14:55:00',1.61),('8975','2013-03-27','15:00:00',2.05),('8975','2013-03-27','15:05:00',2.51),('8975','2013-03-27','15:10:00',3),('8975','2013-03-27','15:15:00',3.12),('8975','2013-03-27','15:20:00',2.41),('8975','2013-03-27','15:25:00',1.55),('8975','2013-03-27','15:30:00',1.86),('8975','2013-03-27','15:35:00',3.16),('8975','2013-03-27','15:40:00',1.97),('8975','2013-03-27','15:45:00',2.17),('8975','2013-03-27','15:50:00',1.94),('8975','2013-03-27','15:55:00',2.53),('8975','2013-03-27','16:00:00',2.01),('8975','2013-03-27','16:05:00',1.51),('8975','2013-03-27','16:10:00',1.2),('8975','2013-03-27','16:25:00',1.16),('8975','2013-03-27','16:30:00',1.84),('8975','2013-03-27','16:35:00',1.35),('8975','2013-03-27','16:40:00',1.06),('8975','2013-03-27','16:45:00',1.24),('8975','2013-03-27','16:55:00',1.16),('8975','2013-03-27','17:00:00',2.04),('8975','2013-03-27','17:05:00',1.73),('8975','2013-03-27','17:10:00',1.33),('8975','2013-03-27','17:15:00',1.18),('8975','2013-03-27','17:20:00',1.06),('8975','2013-03-26','06:35:00',1.03),('8975','2013-03-26','06:40:00',1.21),('8975','2013-03-26','06:45:00',1.42),('8975','2013-03-26','06:50:00',1.45),('8975','2013-03-26','06:55:00',1.71),('8975','2013-03-26','07:00:00',1.78),('8975','2013-03-26','07:05:00',2.05),('8975','2013-03-26','07:10:00',2.39),('8975','2013-03-26','07:15:00',2.58),('8975','2013-03-26','07:20:00',2.66),('8975','2013-03-26','07:25:00',2.71),('8975','2013-03-26','07:30:00',2.65),('8975','2013-03-26','07:35:00',2.64),('8975','2013-03-26','07:40:00',3.15),('8975','2013-03-26','07:45:00',1.74),('8975','2013-03-26','07:50:00',1.28),('8975','2013-03-26','07:55:00',2.97),('8975','2013-03-26','08:00:00',3.06),('8975','2013-03-26','08:05:00',2.73),('8975','2013-03-26','08:10:00',2.75),('8975','2013-03-26','08:15:00',2.65),('8975','2013-03-26','08:20:00',2.52),('8975','2013-03-26','08:25:00',2.97),('8975','2013-03-26','08:30:00',3.98),('8975','2013-03-26','08:35:00',2.73),('8975','2013-03-26','08:40:00',2.02),('8975','2013-03-26','08:45:00',2.24),('8975','2013-03-26','08:50:00',4.35),('8975','2013-03-26','08:55:00',3.47),('8975','2013-03-26','09:00:00',2.23),('8975','2013-03-26','09:05:00',2.27),('8975','2013-03-26','09:10:00',2.45),('8975','2013-03-26','09:15:00',5.51),('8975','2013-03-26','09:20:00',4.21),('8975','2013-03-26','09:25:00',2.92),('8975','2013-03-26','09:30:00',1.98),('8975','2013-03-26','09:35:00',1.88),('8975','2013-03-26','09:40:00',2.06),('8975','2013-03-26','09:45:00',3.14),('8975','2013-03-26','09:50:00',3.99),('8975','2013-03-26','09:55:00',5.55),('8975','2013-03-26','10:00:00',2.57),('8975','2013-03-26','10:05:00',2.33),('8975','2013-03-26','10:10:00',3.34),('8975','2013-03-26','10:15:00',3.04),('8975','2013-03-26','10:20:00',2.91),('8975','2013-03-26','10:25:00',3.54),('8975','2013-03-26','10:30:00',4.21),('8975','2013-03-26','10:35:00',2.69),('8975','2013-03-26','10:40:00',3.49),('8975','2013-03-26','10:45:00',3.06),('8975','2013-03-26','10:50:00',3.33),('8975','2013-03-26','10:55:00',3.13),('8975','2013-03-26','11:00:00',2.86),('8975','2013-03-26','11:05:00',2.78),('8975','2013-03-26','11:10:00',2.82),('8975','2013-03-26','11:15:00',3.04),('8975','2013-03-26','11:20:00',3.08),('8975','2013-03-26','11:25:00',2.96),('8975','2013-03-26','11:30:00',3.22),('8975','2013-03-26','11:35:00',2.9),('8975','2013-03-26','11:40:00',2.83),('8975','2013-03-26','11:45:00',2.91),('8975','2013-03-26','11:50:00',2.87),('8975','2013-03-26','11:55:00',4.73),('8975','2013-03-26','12:00:00',4.57),('8975','2013-03-26','12:05:00',4.54),('8975','2013-03-26','12:10:00',3.29),('8975','2013-03-26','12:15:00',3.52),('8975','2013-03-26','12:20:00',3.5),('8975','2013-03-26','12:25:00',3.1),('8975','2013-03-26','12:30:00',5.76),('8975','2013-03-26','12:35:00',7.98),('8975','2013-03-26','12:40:00',5.72),('8975','2013-03-26','12:45:00',6.55),('8975','2013-03-26','12:50:00',5.91),('8975','2013-03-26','12:55:00',4.06),('8975','2013-03-26','13:00:00',2.95),('8975','2013-03-26','13:05:00',2.78),('8975','2013-03-26','13:10:00',3.55),('8975','2013-03-26','13:15:00',2.58),('8975','2013-03-26','13:20:00',2.58),('8975','2013-03-26','13:25:00',2.45),('8975','2013-03-26','13:30:00',3.41),('8975','2013-03-26','13:35:00',3.03),('8975','2013-03-26','13:40:00',2.79),('8975','2013-03-26','13:45:00',3.6),('8975','2013-03-26','13:50:00',2.92),('8975','2013-03-26','13:55:00',3.21),('8975','2013-03-26','14:00:00',3.09),('8975','2013-03-26','14:05:00',2.6),('8975','2013-03-26','14:10:00',2.54),('8975','2013-03-26','14:15:00',2.92),('8975','2013-03-26','14:20:00',3.68),('8975','2013-03-26','14:25:00',3.3),('8975','2013-03-26','14:30:00',2.41),('8975','2013-03-26','14:35:00',2.92),('8975','2013-03-26','14:40:00',3.95),('8975','2013-03-26','14:45:00',3.76),('8975','2013-03-26','14:50:00',2.62),('8975','2013-03-26','14:55:00',2.14),('8975','2013-03-26','15:00:00',1.43),('8975','2013-03-26','15:05:00',1.61),('8975','2013-03-26','15:10:00',1.73),('8975','2013-03-26','15:15:00',1.47),('8975','2013-03-26','15:20:00',1.51),('8975','2013-03-26','15:25:00',1.09),('8975','2013-03-26','15:55:00',1.02),('8975','2013-03-26','16:00:00',1.16),('8975','2013-03-26','16:05:00',1.14),('8975','2013-03-26','16:10:00',1.08),('8975','2013-03-26','16:15:00',1.04),('8975','2013-03-26','16:20:00',1.02),('8975','2013-03-26','16:25:00',1.04),('8975','2013-03-26','16:30:00',1.05),('8975','2013-03-26','16:35:00',1.06),('8975','2013-03-26','16:40:00',1.18),('8975','2013-03-26','16:45:00',1.4),('8975','2013-03-26','16:50:00',1.54),('8975','2013-03-26','16:55:00',2.07),('8975','2013-03-26','17:00:00',1.77),('8975','2013-03-26','17:05:00',1.89),('8975','2013-03-26','17:10:00',1.7),('8975','2013-03-26','17:15:00',1.36),('8975','2013-03-25','07:20:00',1.01),('8975','2013-03-25','07:40:00',1.25),('8975','2013-03-25','07:45:00',1.61),('8975','2013-03-25','07:50:00',2.3),('8975','2013-03-25','07:55:00',1.45),('8975','2013-03-25','08:00:00',1.07),('8975','2013-03-25','08:10:00',1.32),('8975','2013-03-25','08:25:00',1.19),('8975','2013-03-25','08:30:00',1.88),('8975','2013-03-25','08:35:00',2.38),('8975','2013-03-25','08:40:00',2.53),('8975','2013-03-25','08:45:00',1.29),('8975','2013-03-25','09:05:00',1.24),('8975','2013-03-25','09:10:00',2.15),('8975','2013-03-25','09:15:00',2.86),('8975','2013-03-25','09:20:00',1.88),('8975','2013-03-25','09:35:00',1.44),('8975','2013-03-25','09:40:00',3.1),('8975','2013-03-25','09:45:00',3.76),('8975','2013-03-25','09:50:00',1.87),('8975','2013-03-25','09:55:00',2.29),('8975','2013-03-25','10:00:00',3.01),('8975','2013-03-25','10:05:00',4.4),('8975','2013-03-25','10:10:00',3.38),('8975','2013-03-25','10:15:00',2.89),('8975','2013-03-25','10:20:00',4.04),('8975','2013-03-25','10:25:00',2.65),('8975','2013-03-25','10:30:00',1.11),('8975','2013-03-25','10:40:00',1.12),('8975','2013-03-25','10:45:00',2.03),('8975','2013-03-25','10:50:00',2.9),('8975','2013-03-25','10:55:00',1.79),('8975','2013-03-25','11:00:00',2.13),('8975','2013-03-25','11:05:00',2.3),('8975','2013-03-25','11:10:00',2.88),('8975','2013-03-25','11:15:00',3.86),('8975','2013-03-25','11:20:00',3.6),('8975','2013-03-25','11:25:00',2.86),('8975','2013-03-25','11:30:00',1.81),('8975','2013-03-25','11:40:00',1.05),('8975','2013-03-25','11:45:00',2.55),('8975','2013-03-25','11:50:00',4.37),('8975','2013-03-25','11:55:00',2.6),('8975','2013-03-25','12:00:00',2.94),('8975','2013-03-25','12:05:00',2.07),('8975','2013-03-25','12:10:00',2.02),('8975','2013-03-25','12:15:00',2.24),('8975','2013-03-25','12:20:00',2.18),('8975','2013-03-25','12:25:00',2.69),('8975','2013-03-25','12:30:00',2.49),('8975','2013-03-25','12:35:00',4.53),('8975','2013-03-25','12:40:00',3.82),('8975','2013-03-25','12:45:00',3.8),('8975','2013-03-25','12:50:00',3.09),('8975','2013-03-25','12:55:00',1.93),('8975','2013-03-25','13:00:00',3.19),('8975','2013-03-25','13:05:00',3.21),('8975','2013-03-25','13:10:00',2.91),('8975','2013-03-25','13:15:00',2.34),('8975','2013-03-25','13:20:00',2.74),('8975','2013-03-25','13:25:00',3.78),('8975','2013-03-25','13:30:00',2.96),('8975','2013-03-25','13:35:00',2.84),('8975','2013-03-25','13:40:00',2.79),('8975','2013-03-25','13:45:00',2.69),('8975','2013-03-25','13:50:00',2.44),('8975','2013-03-25','13:55:00',2.43),('8975','2013-03-25','14:00:00',2.31),('8975','2013-03-25','14:05:00',2.29),('8975','2013-03-25','14:10:00',2.12),('8975','2013-03-25','14:15:00',1.96),('8975','2013-03-25','14:20:00',1.75),('8975','2013-03-25','14:25:00',1.42),('8975','2013-03-25','14:30:00',1.24),('8975','2013-03-25','14:35:00',1.3),('8975','2013-03-25','14:40:00',1.44),('8975','2013-03-25','14:45:00',1.42),('8975','2013-03-25','14:50:00',1.33),('8975','2013-03-25','14:55:00',1.35),('8975','2013-03-25','15:00:00',1.38),('8975','2013-03-25','15:05:00',1.37),('8975','2013-03-25','15:10:00',1.24),('8975','2013-03-25','15:15:00',1.2),('8975','2013-03-25','15:20:00',1.3),('8975','2013-03-25','15:25:00',1.32),('8975','2013-03-25','15:30:00',1.43),('8975','2013-03-25','15:35:00',1.45),('8975','2013-03-25','15:40:00',1.34),('8975','2013-03-24','08:10:00',1.44),('8975','2013-03-24','08:15:00',2.96),('8975','2013-03-24','08:20:00',4.59),('8975','2013-03-24','08:25:00',3.06),('8975','2013-03-24','08:30:00',1.21),('8975','2013-03-24','08:35:00',1.15),('8975','2013-03-24','08:40:00',2.11),('8975','2013-03-24','08:45:00',2.11),('8975','2013-03-24','08:50:00',1.71),('8975','2013-03-24','08:55:00',2.3),('8975','2013-03-24','09:00:00',2.03),('8975','2013-03-24','09:05:00',1.59),('8975','2013-03-24','09:10:00',1.81),('8975','2013-03-24','09:15:00',2.69),('8975','2013-03-24','09:20:00',4.76),('8975','2013-03-24','09:25:00',2.39),('8975','2013-03-24','09:30:00',1.97),('8975','2013-03-24','09:35:00',1.31),('8975','2013-03-24','09:40:00',1.03),('8975','2013-03-24','09:45:00',2.92),('8975','2013-03-24','09:50:00',7.75),('8975','2013-03-24','09:55:00',7.1),('8975','2013-03-24','10:00:00',5.14),('8975','2013-03-24','10:05:00',3.41),('8975','2013-03-24','10:10:00',1.7),('8975','2013-03-24','10:15:00',2.6),('8975','2013-03-24','10:20:00',2.84),('8975','2013-03-24','10:25:00',4.94),('8975','2013-03-24','10:30:00',4.14),('8975','2013-03-24','10:35:00',3.52),('8975','2013-03-24','10:40:00',4.88),('8975','2013-03-24','10:45:00',5.82),('8975','2013-03-24','10:50:00',6.25),('8975','2013-03-24','10:55:00',5.56),('8975','2013-03-24','11:00:00',6.1),('8975','2013-03-24','11:05:00',6.39),('8975','2013-03-24','11:10:00',2.94),('8975','2013-03-24','11:15:00',7.11),('8975','2013-03-24','11:20:00',7.3),('8975','2013-03-24','11:25:00',6.58),('8975','2013-03-24','11:30:00',7.23),('8975','2013-03-24','11:35:00',4.99),('8975','2013-03-24','11:40:00',3.43),('8975','2013-03-24','11:45:00',2.91),('8975','2013-03-24','11:50:00',6.93),('8975','2013-03-24','11:55:00',7.07),('8975','2013-03-24','12:00:00',5.86),('8975','2013-03-24','12:05:00',5.31),('8975','2013-03-24','12:10:00',4.61),('8975','2013-03-24','12:15:00',4.1),('8975','2013-03-24','12:20:00',3.69),('8975','2013-03-24','12:25:00',3.85),('8975','2013-03-24','12:30:00',4.65),('8975','2013-03-24','12:35:00',4.58),('8975','2013-03-24','12:40:00',4.35),('8975','2013-03-24','12:45:00',4.29),('8975','2013-03-24','12:50:00',4.1),('8975','2013-03-24','12:55:00',3.45),('8975','2013-03-24','13:00:00',6.88),('8975','2013-03-24','13:05:00',4.5),('8975','2013-03-24','13:10:00',4.72),('8975','2013-03-24','13:15:00',6.59),('8975','2013-03-24','13:20:00',3.28),('8975','2013-03-24','13:25:00',5.08),('8975','2013-03-24','13:30:00',2.5),('8975','2013-03-24','13:35:00',1.88),('8975','2013-03-24','13:40:00',2.03),('8975','2013-03-24','13:45:00',3.14),('8975','2013-03-24','13:50:00',2.92),('8975','2013-03-24','13:55:00',2.03),('8975','2013-03-24','14:00:00',1.6),('8975','2013-03-24','14:05:00',2.31),('8975','2013-03-24','14:10:00',3.53),('8975','2013-03-24','14:15:00',1.6),('8975','2013-03-24','14:20:00',2.7),('8975','2013-03-24','14:25:00',4.29),('8975','2013-03-24','14:30:00',5.8),('8975','2013-03-24','14:35:00',4.95),('8975','2013-03-24','14:40:00',2.91),('8975','2013-03-24','14:45:00',2.32),('8975','2013-03-24','14:50:00',2.15),('8975','2013-03-24','14:55:00',2.65),('8975','2013-03-24','15:00:00',3.09),('8975','2013-03-24','15:05:00',2.81),('8975','2013-03-24','15:10:00',2.72),('8975','2013-03-24','15:15:00',2.96),('8975','2013-03-24','15:20:00',2.53),('8975','2013-03-24','15:25:00',2.28),('8975','2013-03-24','15:30:00',2.85),('8975','2013-03-24','15:35:00',3.55),('8975','2013-03-24','15:40:00',3.13),('8975','2013-03-24','15:45:00',2.56),('8975','2013-03-24','15:50:00',2.19),('8975','2013-03-24','15:55:00',3.11),('8975','2013-03-24','16:00:00',2.92),('8975','2013-03-24','16:05:00',2.31),('8975','2013-03-24','16:10:00',1.77),('8975','2013-03-24','16:15:00',1.48),('8975','2013-03-24','16:20:00',1.19),('8975','2013-03-24','16:25:00',1.5),('8975','2013-03-24','16:30:00',2.22),('8975','2013-03-24','16:35:00',2.23),('8975','2013-03-24','16:40:00',2.05),('8975','2013-03-24','16:45:00',1.92),('8975','2013-03-24','16:50:00',1.64),('8975','2013-03-23','06:55:00',1.17),('8975','2013-03-23','07:00:00',1.2),('8975','2013-03-23','07:05:00',1.65),('8975','2013-03-23','07:10:00',1.92),('8975','2013-03-23','07:15:00',1.85),('8975','2013-03-23','07:20:00',2.2),('8975','2013-03-23','07:25:00',2.02),('8975','2013-03-23','07:30:00',2.15),('8975','2013-03-23','07:35:00',2.33),('8975','2013-03-23','07:40:00',2.29),('8975','2013-03-23','07:45:00',2.65),('8975','2013-03-23','07:50:00',2.85),('8975','2013-03-23','07:55:00',3.37),('8975','2013-03-23','08:00:00',3.6),('8975','2013-03-23','08:05:00',3.63),('8975','2013-03-23','08:10:00',3.7),('8975','2013-03-23','08:15:00',3.84),('8975','2013-03-23','08:20:00',3.99),('8975','2013-03-23','08:25:00',4.09),('8975','2013-03-23','08:30:00',4.16),('8975','2013-03-23','08:35:00',4.26),('8975','2013-03-23','08:40:00',4.33),('8975','2013-03-23','08:45:00',4.39),('8975','2013-03-23','08:50:00',4.44),('8975','2013-03-23','08:55:00',4.55),('8975','2013-03-23','09:00:00',4.62),('8975','2013-03-23','09:05:00',4.72),('8975','2013-03-23','09:10:00',4.79),('8975','2013-03-23','09:15:00',4.84),('8975','2013-03-23','09:20:00',4.95),('8975','2013-03-23','09:25:00',5.02),('8975','2013-03-23','09:30:00',5.08),('8975','2013-03-23','09:35:00',5.14),('8975','2013-03-23','09:40:00',5.23),('8975','2013-03-23','09:45:00',5.29),('8975','2013-03-23','09:50:00',5.36),('8975','2013-03-23','09:55:00',5.4),('8975','2013-03-23','10:00:00',5.48),('8975','2013-03-23','10:05:00',5.52),('8975','2013-03-23','10:10:00',5.56),('8975','2013-03-23','10:15:00',5.57),('8975','2013-03-23','10:20:00',5.65),('8975','2013-03-23','10:25:00',5.66),('8975','2013-03-23','10:30:00',5.69),('8975','2013-03-23','10:35:00',5.71),('8975','2013-03-23','10:40:00',5.73),('8975','2013-03-23','10:45:00',5.78),('8975','2013-03-23','10:50:00',5.83),('8975','2013-03-23','10:55:00',5.87),('8975','2013-03-23','11:00:00',5.9),('8975','2013-03-23','11:05:00',5.86),('8975','2013-03-23','11:10:00',5.9),('8975','2013-03-23','11:15:00',5.83),('8975','2013-03-23','11:20:00',5.83),('8975','2013-03-23','11:25:00',5.87),('8975','2013-03-23','11:30:00',5.85),('8975','2013-03-23','11:35:00',5.84),('8975','2013-03-23','11:40:00',5.82),('8975','2013-03-23','11:45:00',5.82),('8975','2013-03-23','11:50:00',5.79),('8975','2013-03-23','11:55:00',5.82),('8975','2013-03-23','12:00:00',5.83),('8975','2013-03-23','12:05:00',5.89),('8975','2013-03-23','12:10:00',5.92),('8975','2013-03-23','12:15:00',5.91),('8975','2013-03-23','12:20:00',5.94),('8975','2013-03-23','12:25:00',5.88),('8975','2013-03-23','12:30:00',5.84),('8975','2013-03-23','12:35:00',5.81),('8975','2013-03-23','12:40:00',5.71),('8975','2013-03-23','12:45:00',5.73),('8975','2013-03-23','12:50:00',5.61),('8975','2013-03-23','12:55:00',5.53),('8975','2013-03-23','13:00:00',5.5),('8975','2013-03-23','13:05:00',5.48),('8975','2013-03-23','13:10:00',5.43),('8975','2013-03-23','13:15:00',5.34),('8975','2013-03-23','13:20:00',5.24),('8975','2013-03-23','13:25:00',5.1),('8975','2013-03-23','13:30:00',4.93),('8975','2013-03-23','13:35:00',4.95),('8975','2013-03-23','13:40:00',4.92),('8975','2013-03-23','13:45:00',4.79),('8975','2013-03-23','13:50:00',4.72),('8975','2013-03-23','13:55:00',4.61),('8975','2013-03-23','14:00:00',4.5),('8975','2013-03-23','14:05:00',4.37),('8975','2013-03-23','14:10:00',4.23),('8975','2013-03-23','14:15:00',4.08),('8975','2013-03-23','14:20:00',3.98),('8975','2013-03-23','14:25:00',3.86),('8975','2013-03-23','14:30:00',3.73),('8975','2013-03-23','14:35:00',3.63),('8975','2013-03-23','14:40:00',3.54),('8975','2013-03-23','14:45:00',3.4),('8975','2013-03-23','14:50:00',3.21),('8975','2013-03-23','14:55:00',3.26),('8975','2013-03-23','15:00:00',3.14),('8975','2013-03-23','15:05:00',3.07),('8975','2013-03-23','15:10:00',2.86),('8975','2013-03-23','15:15:00',3.08),('8975','2013-03-23','15:20:00',2.9),('8975','2013-03-23','15:25:00',2.63),('8975','2013-03-23','15:30:00',2.39),('8975','2013-03-23','15:35:00',2.39),('8975','2013-03-23','15:40:00',2.32),('8975','2013-03-23','15:45:00',1.75),('8975','2013-03-23','15:50:00',1.61),('8975','2013-03-23','15:55:00',1.55),('8975','2013-03-23','16:00:00',1.63),('8975','2013-03-23','16:05:00',1.73),('8975','2013-03-23','16:10:00',1.48),('8975','2013-03-23','16:15:00',1.61),('8975','2013-03-23','16:20:00',1.44),('8975','2013-03-23','16:25:00',1.66),('8975','2013-03-23','16:30:00',1.4),('8975','2013-03-23','16:35:00',1.39),('8975','2013-03-23','16:40:00',1.18),('8975','2013-03-23','16:45:00',1.18),('8975','2013-03-22','06:45:00',1.04),('8975','2013-03-22','06:50:00',1.32),('8975','2013-03-22','06:55:00',1.54),('8975','2013-03-22','07:00:00',1.65),('8975','2013-03-22','07:05:00',1.37),('8975','2013-03-22','07:10:00',1.63),('8975','2013-03-22','07:15:00',2.36),('8975','2013-03-22','07:20:00',2.4),('8975','2013-03-22','07:25:00',2.38),('8975','2013-03-22','07:30:00',2.5),('8975','2013-03-22','07:35:00',2.52),('8975','2013-03-22','07:40:00',2.7),('8975','2013-03-22','07:45:00',2.28),('8975','2013-03-22','07:50:00',2.61),('8975','2013-03-22','07:55:00',2.43),('8975','2013-03-22','08:00:00',3.41),('8975','2013-03-22','08:05:00',3.52),('8975','2013-03-22','08:10:00',3.79),('8975','2013-03-22','08:15:00',3.94),('8975','2013-03-22','08:20:00',4.01),('8975','2013-03-22','08:25:00',4.06),('8975','2013-03-22','08:30:00',4.17),('8975','2013-03-22','08:35:00',4.25),('8975','2013-03-22','08:40:00',4.44),('8975','2013-03-22','08:45:00',4.49),('8975','2013-03-22','08:50:00',4.59),('8975','2013-03-22','08:55:00',4.81),('8975','2013-03-22','09:00:00',4.87),('8975','2013-03-22','09:05:00',5),('8975','2013-03-22','09:10:00',5.03),('8975','2013-03-22','09:15:00',5.11),('8975','2013-03-22','09:20:00',5.13),('8975','2013-03-22','09:25:00',5.31),('8975','2013-03-22','09:30:00',5.39),('8975','2013-03-22','09:35:00',5.42),('8975','2013-03-22','09:40:00',5.29),('8975','2013-03-22','09:45:00',5.46),('8975','2013-03-22','09:50:00',5.4),('8975','2013-03-22','09:55:00',5.56),('8975','2013-03-22','10:00:00',5.5),('8975','2013-03-22','10:05:00',5.64),('8975','2013-03-22','10:10:00',5.79),('8975','2013-03-22','10:15:00',5.81),('8975','2013-03-22','10:20:00',5.68),('8975','2013-03-22','10:25:00',5.73),('8975','2013-03-22','10:30:00',5.92),('8975','2013-03-22','10:35:00',5.94),('8975','2013-03-22','10:40:00',5.83),('8975','2013-03-22','10:45:00',5.79),('8975','2013-03-22','10:50:00',5.76),('8975','2013-03-22','10:55:00',5.69),('8975','2013-03-22','11:00:00',5.43),('8975','2013-03-22','11:05:00',5.81),('8975','2013-03-22','11:10:00',5.03),('8975','2013-03-22','11:15:00',4.64),('8975','2013-03-22','11:20:00',5),('8975','2013-03-22','11:25:00',5.51),('8975','2013-03-22','11:30:00',5.64),('8975','2013-03-22','11:35:00',5.93),('8975','2013-03-22','11:40:00',5.83),('8975','2013-03-22','11:45:00',5.77),('8975','2013-03-22','11:50:00',5.65),('8975','2013-03-22','11:55:00',5.81),('8975','2013-03-22','12:00:00',6.01),('8975','2013-03-22','12:05:00',6.05),('8975','2013-03-22','12:10:00',6.03),('8975','2013-03-22','12:15:00',6),('8975','2013-03-22','12:20:00',6.04),('8975','2013-03-22','12:25:00',5.7),('8975','2013-03-22','12:30:00',5.87),('8975','2013-03-22','12:35:00',5.86),('8975','2013-03-22','12:40:00',5.6),('8975','2013-03-22','12:45:00',5.63),('8975','2013-03-22','12:50:00',5.66),('8975','2013-03-22','12:55:00',5.27),('8975','2013-03-22','13:00:00',4.85),('8975','2013-03-22','13:05:00',5.57),('8975','2013-03-22','13:10:00',5.39),('8975','2013-03-22','13:15:00',5.38),('8975','2013-03-22','13:20:00',5.18),('8975','2013-03-22','13:25:00',4.96),('8975','2013-03-22','13:30:00',4.81),('8975','2013-03-22','13:35:00',4.86),('8975','2013-03-22','13:40:00',4.78),('8975','2013-03-22','13:45:00',4.73),('8975','2013-03-22','13:50:00',4.64),('8975','2013-03-22','13:55:00',4.55),('8975','2013-03-22','14:00:00',4.48),('8975','2013-03-22','14:05:00',4.35),('8975','2013-03-22','14:10:00',4.09),('8975','2013-03-22','14:15:00',3.92),('8975','2013-03-22','14:20:00',3.9),('8975','2013-03-22','14:25:00',3.68),('8975','2013-03-22','14:30:00',3.93),('8975','2013-03-22','14:35:00',3.8),('8975','2013-03-22','14:40:00',3.55),('8975','2013-03-22','14:45:00',3.46),('8975','2013-03-22','14:50:00',3.32),('8975','2013-03-22','14:55:00',3.3),('8975','2013-03-22','15:00:00',2.82),('8975','2013-03-22','15:05:00',3.09),('8975','2013-03-22','15:10:00',2.98),('8975','2013-03-22','15:15:00',2.76),('8975','2013-03-22','15:20:00',2.82),('8975','2013-03-22','15:25:00',2.59),('8975','2013-03-22','15:30:00',2.44),('8975','2013-03-22','15:35:00',2.38),('8975','2013-03-22','15:40:00',2.28),('8975','2013-03-22','15:45:00',2.03),('8975','2013-03-22','15:50:00',1.99),('8975','2013-03-22','15:55:00',1.97),('8975','2013-03-22','16:00:00',1.78),('8975','2013-03-22','16:05:00',1.86),('8975','2013-03-22','16:10:00',2.07),('8975','2013-03-22','16:15:00',1.85),('8975','2013-03-22','16:20:00',1.68),('8975','2013-03-22','16:25:00',1.68),('8975','2013-03-22','16:30:00',1.35),('8975','2013-03-22','16:35:00',1.48),('8975','2013-03-22','16:40:00',1.35),('8975','2013-03-22','16:45:00',1.32),('8975','2013-03-22','16:50:00',1.16),('8975','2013-03-22','16:55:00',1.2),('8975','2013-03-22','17:00:00',1.43),('8975','2013-03-22','17:05:00',1.4),('8975','2013-03-22','17:10:00',1.28),('8975','2013-03-22','17:15:00',1.1),('8975','2014-03-25','06:35:00',1.08),('8975','2014-03-25','06:40:00',1.38),('8975','2014-03-25','06:45:00',1.52),('8975','2014-03-25','06:50:00',1.57),('8975','2014-03-25','06:55:00',1.86),('8975','2014-03-25','07:00:00',2.18),('8975','2014-03-25','07:05:00',2.16),('8975','2014-03-25','07:10:00',2.5),('8975','2014-03-25','07:15:00',2.61),('8975','2014-03-25','07:20:00',2.73),('8975','2014-03-25','07:25:00',2.92),('8975','2014-03-25','07:30:00',3.08),('8975','2014-03-25','07:35:00',3.2),('8975','2014-03-25','07:40:00',3.31),('8975','2014-03-25','07:45:00',3.41),('8975','2014-03-25','07:50:00',3.5),('8975','2014-03-25','07:55:00',3.63),('8975','2014-03-25','08:00:00',3.73),('8975','2014-03-25','08:05:00',3.85),('8975','2014-03-25','08:10:00',4.06),('8975','2014-03-25','08:15:00',4.48),('8975','2014-03-25','08:20:00',1.95),('8975','2014-03-25','08:25:00',1.92),('8975','2014-03-25','08:30:00',1.59),('8975','2014-03-25','08:35:00',1.51),('8975','2014-03-25','08:40:00',1.97),('8975','2014-03-25','08:45:00',2.01),('8975','2014-03-25','08:50:00',2.33),('8975','2014-03-25','08:55:00',2.24),('8975','2014-03-25','09:00:00',2.24),('8975','2014-03-25','09:05:00',2.38),('8975','2014-03-25','09:10:00',2.99),('8975','2014-03-25','09:15:00',2.61),('8975','2014-03-25','09:20:00',2.09),('8975','2014-03-25','09:25:00',3.98),('8975','2014-03-25','09:30:00',5.57),('8975','2014-03-25','09:35:00',5.5),('8975','2014-03-25','09:40:00',5.6),('8975','2014-03-25','09:45:00',2.05),('8975','2014-03-25','09:50:00',5.11),('8975','2014-03-25','09:55:00',6.2),('8975','2014-03-25','10:00:00',4.87),('8975','2014-03-25','10:05:00',6.47),('8975','2014-03-25','10:10:00',6.03),('8975','2014-03-25','10:15:00',5.84),('8975','2014-03-25','10:20:00',4.68),('8975','2014-03-25','10:25:00',5.67),('8975','2014-03-25','10:30:00',4.01),('8975','2014-03-25','10:35:00',1.85),('8975','2014-03-25','10:40:00',3.91),('8975','2014-03-25','10:45:00',7.61),('8975','2014-03-25','10:50:00',6.34),('8975','2014-03-25','10:55:00',5.91),('8975','2014-03-25','11:00:00',4.46),('8975','2014-03-25','11:05:00',7.73),('8975','2014-03-25','11:10:00',7.43),('8975','2014-03-25','11:15:00',3.77),('8975','2014-03-25','11:20:00',1.76),('8975','2014-03-25','11:25:00',1.84),('8975','2014-03-25','11:30:00',2.68),('8975','2014-03-25','11:35:00',2.61),('8975','2014-03-25','11:40:00',3.46),('8975','2014-03-25','11:45:00',4.07),('8975','2014-03-25','11:50:00',3.39),('8975','2014-03-25','11:55:00',6.96),('8975','2014-03-25','12:00:00',2.71),('8975','2014-03-25','12:05:00',6.2),('8975','2014-03-25','12:10:00',2.92),('8975','2014-03-25','12:15:00',4.6),('8975','2014-03-25','12:20:00',3.21),('8975','2014-03-25','12:25:00',2.51),('8975','2014-03-25','12:30:00',2.72),('8975','2014-03-25','12:35:00',2.58),('8975','2014-03-25','12:40:00',2.72),('8975','2014-03-25','12:45:00',2.27),('8975','2014-03-25','12:50:00',1.98),('8975','2014-03-25','12:55:00',1.73),('8975','2014-03-25','13:00:00',1.84),('8975','2014-03-25','13:05:00',1.56),('8975','2014-03-25','13:10:00',1.15),('8975','2014-03-25','13:15:00',1),('8975','2014-03-25','13:20:00',2.72),('8975','2014-03-25','13:25:00',2.61),('8975','2014-03-25','13:30:00',2.15),('8975','2014-03-25','13:35:00',3.05),('8975','2014-03-25','13:40:00',1.47),('8975','2014-03-25','13:45:00',1.28),('8975','2014-03-25','13:50:00',1.87),('8975','2014-03-25','13:55:00',3.57),('8975','2014-03-25','14:00:00',3.28),('8975','2014-03-25','14:05:00',4.51),('8975','2014-03-25','14:10:00',2.95),('8975','2014-03-25','14:15:00',1.73),('8975','2014-03-25','14:20:00',1.58),('8975','2014-03-25','14:25:00',1.44),('8975','2014-03-25','14:30:00',1.25),('8975','2014-03-25','14:35:00',1.26),('8975','2014-03-25','14:40:00',1.92),('8975','2014-03-25','14:45:00',2.84),('8975','2014-03-25','14:50:00',3.6),('8975','2014-03-25','14:55:00',3.82),('8975','2014-03-25','15:00:00',3.6),('8975','2014-03-25','15:05:00',3.42),('8975','2014-03-25','15:10:00',3.49),('8975','2014-03-25','15:15:00',3.58),('8975','2014-03-25','15:20:00',3.12),('8975','2014-03-25','15:25:00',3.45),('8975','2014-03-25','15:30:00',3.4),('8975','2014-03-25','15:35:00',3.03),('8975','2014-03-25','15:40:00',2.69),('8975','2014-03-25','15:45:00',2.19),('8975','2014-03-25','15:50:00',2.14),('8975','2014-03-25','15:55:00',1.82),('8975','2014-03-25','16:00:00',1.34),('8975','2014-03-25','16:05:00',1.32),('8975','2014-03-25','16:10:00',1.44),('8975','2014-03-25','16:15:00',1.68),('8975','2014-03-25','16:20:00',1.58),('8975','2014-03-25','16:25:00',1.16),('8975','2014-03-25','16:30:00',1.15),('8975','2013-03-21','06:45:00',1.07),('8975','2013-03-21','06:50:00',1.11),('8975','2013-03-21','06:55:00',1.41),('8975','2013-03-21','07:00:00',1.71),('8975','2013-03-21','07:05:00',1.3),('8975','2013-03-21','07:10:00',2.02),('8975','2013-03-21','07:15:00',2.2),('8975','2013-03-21','07:20:00',2.34),('8975','2013-03-21','07:25:00',2.59),('8975','2013-03-21','07:30:00',2.65),('8975','2013-03-21','07:35:00',3.06),('8975','2013-03-21','07:40:00',3.19),('8975','2013-03-21','07:45:00',3.27),('8975','2013-03-21','07:50:00',3.39),('8975','2013-03-21','07:55:00',3.49),('8975','2013-03-21','08:00:00',3.57),('8975','2013-03-21','08:05:00',3.69),('8975','2013-03-21','08:10:00',3.78),('8975','2013-03-21','08:15:00',3.9),('8975','2013-03-21','08:20:00',4.01),('8975','2013-03-21','08:25:00',4.12),('8975','2013-03-21','08:30:00',4.21),('8975','2013-03-21','08:35:00',4.34),('8975','2013-03-21','08:40:00',4.43),('8975','2013-03-21','08:45:00',4.49),('8975','2013-03-21','08:50:00',4.64),('8975','2013-03-21','08:55:00',4.67),('8975','2013-03-21','09:00:00',4.75),('8975','2013-03-21','09:05:00',4.82),('8975','2013-03-21','09:10:00',4.91),('8975','2013-03-21','09:15:00',4.99),('8975','2013-03-21','09:20:00',5.08),('8975','2013-03-21','09:25:00',5.16),('8975','2013-03-21','09:30:00',5.15),('8975','2013-03-21','09:35:00',5.37),('8975','2013-03-21','09:40:00',5.41),('8975','2013-03-21','09:45:00',5.42),('8975','2013-03-21','09:50:00',5.55),('8975','2013-03-21','09:55:00',5.61),('8975','2013-03-21','10:00:00',5.64),('8975','2013-03-21','10:05:00',5.74),('8975','2013-03-21','10:10:00',5.81),('8975','2013-03-21','10:15:00',5.83),('8975','2013-03-21','10:20:00',5.85),('8975','2013-03-21','10:25:00',5.94),('8975','2013-03-21','10:30:00',5.94),('8975','2013-03-21','10:35:00',5.99),('8975','2013-03-21','10:40:00',6.03),('8975','2013-03-21','10:45:00',6.04),('8975','2013-03-21','10:50:00',6.04),('8975','2013-03-21','10:55:00',6.1),('8975','2013-03-21','11:00:00',6.11),('8975','2013-03-21','11:05:00',6.16),('8975','2013-03-21','11:10:00',6.16),('8975','2013-03-21','11:15:00',6.12),('8975','2013-03-21','11:20:00',6.14),('8975','2013-03-21','11:25:00',6.15),('8975','2013-03-21','11:30:00',6.15),('8975','2013-03-21','11:35:00',6.14),('8975','2013-03-21','11:40:00',6.18),('8975','2013-03-21','11:45:00',6.17),('8975','2013-03-21','11:50:00',6.15),('8975','2013-03-21','11:55:00',6.11),('8975','2013-03-21','12:00:00',6.16),('8975','2013-03-21','12:05:00',6.14),('8975','2013-03-21','12:10:00',6.11),('8975','2013-03-21','12:15:00',6.09),('8975','2013-03-21','12:20:00',6.06),('8975','2013-03-21','12:25:00',6.04),('8975','2013-03-21','12:30:00',5.98),('8975','2013-03-21','12:35:00',5.93),('8975','2013-03-21','12:40:00',5.81),('8975','2013-03-21','12:45:00',5.82),('8975','2013-03-21','12:50:00',5.78),('8975','2013-03-21','12:55:00',5.73),('8975','2013-03-21','13:00:00',5.72),('8975','2013-03-21','13:05:00',5.68),('8975','2013-03-21','13:10:00',5.64),('8975','2013-03-21','13:15:00',5.52),('8975','2013-03-21','13:20:00',5.4),('8975','2013-03-21','13:25:00',4.74),('8975','2013-03-21','13:30:00',4.5),('8975','2013-03-21','13:35:00',5.16),('8975','2013-03-21','13:40:00',4.71),('8975','2013-03-21','13:45:00',4.97),('8975','2013-03-21','13:50:00',4.95),('8975','2013-03-21','13:55:00',4.8),('8975','2013-03-21','14:00:00',4.64),('8975','2013-03-21','14:05:00',4.41),('8975','2013-03-21','14:10:00',4.25),('8975','2013-03-21','14:15:00',4.18),('8975','2013-03-21','14:20:00',4.1),('8975','2013-03-21','14:25:00',4.04),('8975','2013-03-21','14:30:00',3.95),('8975','2013-03-21','14:35:00',3.84),('8975','2013-03-21','14:40:00',3.53),('8975','2013-03-21','14:45:00',3.42),('8975','2013-03-21','14:50:00',3.39),('8975','2013-03-21','14:55:00',3.35),('8975','2013-03-21','15:00:00',3.23),('8975','2013-03-21','15:05:00',3.16),('8975','2013-03-21','15:10:00',2.78),('8975','2013-03-21','15:15:00',2.38),('8975','2013-03-21','15:20:00',1.72),('8975','2013-03-21','15:25:00',2.07),('8975','2013-03-21','15:30:00',2.08),('8975','2013-03-21','15:35:00',2.13),('8975','2013-03-21','15:40:00',2.01),('8975','2013-03-21','15:45:00',1.88),('8975','2013-03-21','15:50:00',1.89),('8975','2013-03-21','15:55:00',1.62),('8975','2013-03-21','16:00:00',1.72),('8975','2013-03-21','16:05:00',1.52),('8975','2013-03-21','16:10:00',1.8),('8975','2013-03-21','16:15:00',1.82),('8975','2013-03-21','16:20:00',1.83),('8975','2013-03-21','16:25:00',1.78),('8975','2013-03-21','16:30:00',1.83),('8975','2013-03-21','16:35:00',1.83),('8975','2013-03-21','16:40:00',1.76),('8975','2013-03-21','16:45:00',1.69),('8975','2013-03-21','16:50:00',1.65),('8975','2013-03-21','16:55:00',1.61),('8975','2013-03-21','17:00:00',1.28),('8975','2013-03-21','17:05:00',1.34),('8975','2013-03-21','17:10:00',1.28),('8975','2013-03-21','17:15:00',1.2),('8975','2013-03-21','17:20:00',1.12),('8975','2013-03-20','07:25:00',1.16),('8975','2013-03-20','07:30:00',2.72),('8975','2013-03-20','07:35:00',1.97),('8975','2013-03-20','07:40:00',2.42),('8975','2013-03-20','07:45:00',3.77),('8975','2013-03-20','07:50:00',3.39),('8975','2013-03-20','07:55:00',1.57),('8975','2013-03-20','08:00:00',1.17),('8975','2013-03-20','08:05:00',1.22),('8975','2013-03-20','08:10:00',3.25),('8975','2013-03-20','08:15:00',4.12),('8975','2013-03-20','08:20:00',3.74),('8975','2013-03-20','08:25:00',2.66),('8975','2013-03-20','08:30:00',2.83),('8975','2013-03-20','08:35:00',1.48),('8975','2013-03-20','08:40:00',3.92),('8975','2013-03-20','08:45:00',4.53),('8975','2013-03-20','08:50:00',2.64),('8975','2013-03-20','08:55:00',4.95),('8975','2013-03-20','09:00:00',3.35),('8975','2013-03-20','09:05:00',3.5),('8975','2013-03-20','09:10:00',5.69),('8975','2013-03-20','09:15:00',5.55),('8975','2013-03-20','09:20:00',5.81),('8975','2013-03-20','09:25:00',5.3),('8975','2013-03-20','09:30:00',5.44),('8975','2013-03-20','09:35:00',3.75),('8975','2013-03-20','09:40:00',5.31),('8975','2013-03-20','09:45:00',4.48),('8975','2013-03-20','09:50:00',5.31),('8975','2013-03-20','09:55:00',5.36),('8975','2013-03-20','10:00:00',5.62),('8975','2013-03-20','10:05:00',5.99),('8975','2013-03-20','10:10:00',6.08),('8975','2013-03-20','10:15:00',6.07),('8975','2013-03-20','10:20:00',6.11),('8975','2013-03-20','10:25:00',6.19),('8975','2013-03-20','10:30:00',6.23),('8975','2013-03-20','10:35:00',6.23),('8975','2013-03-20','10:40:00',6.26),('8975','2013-03-20','10:45:00',6.22),('8975','2013-03-20','10:50:00',6.22),('8975','2013-03-20','10:55:00',6.45),('8975','2013-03-20','11:00:00',5.9),('8975','2013-03-20','11:05:00',6.35),('8975','2013-03-20','11:10:00',6.34),('8975','2013-03-20','11:15:00',6.37),('8975','2013-03-20','11:20:00',6.39),('8975','2013-03-20','11:25:00',6.42),('8975','2013-03-20','11:30:00',6.45),('8975','2013-03-20','11:35:00',6.43),('8975','2013-03-20','11:40:00',6.45),('8975','2013-03-20','11:45:00',6.48),('8975','2013-03-20','11:50:00',6.49),('8975','2013-03-20','11:55:00',6.46),('8975','2013-03-20','12:00:00',6.43),('8975','2013-03-20','12:05:00',6.42),('8975','2013-03-20','12:10:00',6.38),('8975','2013-03-20','12:15:00',6.35),('8975','2013-03-20','12:20:00',6.32),('8975','2013-03-20','12:25:00',6.27),('8975','2013-03-20','12:30:00',6.25),('8975','2013-03-20','12:35:00',6.18),('8975','2013-03-20','12:40:00',6.13),('8975','2013-03-20','12:45:00',6.07),('8975','2013-03-20','12:50:00',5.97),('8975','2013-03-20','12:55:00',5.94),('8975','2013-03-20','13:00:00',5.87),('8975','2013-03-20','13:05:00',5.8),('8975','2013-03-20','13:10:00',5.72),('8975','2013-03-20','13:15:00',5.62),('8975','2013-03-20','13:20:00',5.43),('8975','2013-03-20','13:25:00',5.37),('8975','2013-03-20','13:30:00',5.29),('8975','2013-03-20','13:35:00',5.2),('8975','2013-03-20','13:40:00',5.14),('8975','2013-03-20','13:45:00',5.02),('8975','2013-03-20','13:50:00',4.91),('8975','2013-03-20','13:55:00',4.82),('8975','2013-03-20','14:00:00',4.71),('8975','2013-03-20','14:05:00',4.53),('8975','2013-03-20','14:10:00',4.43),('8975','2013-03-20','14:15:00',4.24),('8975','2013-03-20','14:20:00',4.13),('8975','2013-03-20','14:25:00',4.07),('8975','2013-03-20','14:30:00',3.99),('8975','2013-03-20','14:35:00',3.85),('8975','2013-03-20','14:40:00',3.7),('8975','2013-03-20','14:45:00',3.57),('8975','2013-03-20','14:50:00',3.5),('8975','2013-03-20','14:55:00',3.35),('8975','2013-03-20','15:00:00',3.27),('8975','2013-03-20','15:05:00',3.17),('8975','2013-03-20','15:10:00',3.06),('8975','2013-03-20','15:15:00',2.91),('8975','2013-03-20','15:20:00',2.81),('8975','2013-03-20','15:25:00',2.7),('8975','2013-03-20','15:30:00',2.56),('8975','2013-03-20','15:35:00',2.44),('8975','2013-03-20','15:40:00',2.32),('8975','2013-03-20','15:45:00',2.2),('8975','2013-03-20','15:50:00',2.09),('8975','2013-03-20','15:55:00',1.99),('8975','2013-03-20','16:00:00',1.9),('8975','2013-03-20','16:05:00',1.82),('8975','2013-03-20','16:10:00',1.74),('8975','2013-03-20','16:15:00',1.69),('8975','2013-03-20','16:20:00',1.64),('8975','2013-03-20','16:25:00',1.59),('8975','2013-03-20','16:30:00',1.55),('8975','2013-03-20','16:35:00',1.49),('8975','2013-03-20','16:40:00',1.44),('8975','2013-03-20','16:45:00',1.39),('8975','2013-03-20','16:50:00',1.34),('8975','2013-03-20','16:55:00',1.27),('8975','2013-03-20','17:00:00',1.22),('8975','2013-03-20','17:05:00',1.17),('8975','2013-03-20','17:10:00',1.13),('8975','2013-03-20','17:15:00',1.06),('8975','2013-03-19','06:45:00',1.08),('8975','2013-03-19','06:50:00',1.31),('8975','2013-03-19','06:55:00',1.41),('8975','2013-03-19','07:00:00',1.6),('8975','2013-03-19','07:05:00',1.94),('8975','2013-03-19','07:10:00',2.17),('8975','2013-03-19','07:15:00',2.25),('8975','2013-03-19','07:20:00',2.56),('8975','2013-03-19','07:25:00',2.74),('8975','2013-03-19','07:30:00',2.94),('8975','2013-03-19','07:35:00',3.18),('8975','2013-03-19','07:40:00',1.58),('8975','2013-03-19','07:45:00',1.8),('8975','2013-03-19','07:50:00',2.88),('8975','2013-03-19','07:55:00',3.72),('8975','2013-03-19','08:00:00',2.2),('8975','2013-03-19','08:05:00',3.19),('8975','2013-03-19','08:10:00',3.75),('8975','2013-03-19','08:15:00',3.86),('8975','2013-03-19','08:20:00',3.91),('8975','2013-03-19','08:25:00',3.91),('8975','2013-03-19','08:30:00',3.31),('8975','2013-03-19','08:35:00',4.24),('8975','2013-03-19','08:40:00',4.19),('8975','2013-03-19','08:45:00',4.29),('8975','2013-03-19','08:50:00',4.38),('8975','2013-03-19','08:55:00',4.47),('8975','2013-03-19','09:00:00',4.87),('8975','2013-03-19','09:05:00',5),('8975','2013-03-19','09:10:00',4),('8975','2013-03-19','09:15:00',4.78),('8975','2013-03-19','09:20:00',5.01),('8975','2013-03-19','09:25:00',5.11),('8975','2013-03-19','09:30:00',5.12),('8975','2013-03-19','09:35:00',5),('8975','2013-03-19','09:40:00',5.36),('8975','2013-03-19','09:45:00',5.43),('8975','2013-03-19','09:50:00',5.45),('8975','2013-03-19','09:55:00',5.42),('8975','2013-03-19','10:00:00',5.59),('8975','2013-03-19','10:05:00',5.18),('8975','2013-03-19','10:10:00',3.47),('8975','2013-03-19','10:15:00',4.09),('8975','2013-03-19','10:20:00',3.34),('8975','2013-03-19','10:25:00',3.73),('8975','2013-03-19','10:30:00',5.52),('8975','2013-03-19','10:35:00',6.41),('8975','2013-03-19','10:40:00',3.11),('8975','2013-03-19','10:45:00',4.48),('8975','2013-03-19','10:50:00',4.97),('8975','2013-03-19','10:55:00',5.38),('8975','2013-03-19','11:00:00',4.92),('8975','2013-03-19','11:05:00',4.87),('8975','2013-03-19','11:10:00',4.14),('8975','2013-03-19','11:15:00',3.86),('8975','2013-03-19','11:20:00',4.24),('8975','2013-03-19','11:25:00',3.99),('8975','2013-03-19','11:30:00',3.92),('8975','2013-03-19','11:35:00',4.16),('8975','2013-03-19','11:40:00',3.35),('8975','2013-03-19','11:45:00',3.21),('8975','2013-03-19','11:50:00',3.25),('8975','2013-03-19','11:55:00',3.44),('8975','2013-03-19','12:00:00',3.64),('8975','2013-03-19','12:05:00',3.94),('8975','2013-03-19','12:10:00',3.03),('8975','2013-03-19','12:15:00',2.69),('8975','2013-03-19','12:20:00',2.4),('8975','2013-03-19','12:25:00',2.06),('8975','2013-03-19','12:30:00',1.9),('8975','2013-03-19','12:35:00',2.44),('8975','2013-03-19','12:40:00',1.64),('8975','2013-03-19','12:45:00',1.99),('8975','2013-03-19','12:50:00',2.68),('8975','2013-03-19','12:55:00',3.13),('8975','2013-03-19','13:00:00',3.08),('8975','2013-03-19','13:05:00',2.51),('8975','2013-03-19','13:10:00',2.33),('8975','2013-03-19','13:15:00',2.11),('8975','2013-03-19','13:20:00',2.17),('8975','2013-03-19','13:25:00',2.22),('8975','2013-03-19','13:30:00',2.41),('8975','2013-03-19','13:35:00',2.33),('8975','2013-03-19','13:40:00',2.89),('8975','2013-03-19','13:45:00',3.18),('8975','2013-03-19','13:50:00',2.66),('8975','2013-03-19','13:55:00',2.55),('8975','2013-03-19','14:00:00',2.49),('8975','2013-03-19','14:05:00',2.15),('8975','2013-03-19','14:10:00',2.16),('8975','2013-03-19','14:15:00',2.82),('8975','2013-03-19','14:20:00',3.25),('8975','2013-03-19','14:25:00',2.85),('8975','2013-03-19','14:30:00',2.49),('8975','2013-03-19','14:35:00',2.16),('8975','2013-03-19','14:40:00',1.75),('8975','2013-03-19','14:45:00',1.61),('8975','2013-03-19','14:50:00',1.32),('8975','2013-03-19','14:55:00',1.14),('8975','2013-03-19','15:00:00',1.16),('8975','2013-03-19','15:05:00',1.06),('8975','2013-03-18','06:55:00',1.12),('8975','2013-03-18','07:00:00',1.15),('8975','2013-03-18','07:05:00',2.11),('8975','2013-03-18','07:10:00',2.27),('8975','2013-03-18','07:15:00',2.18),('8975','2013-03-18','07:20:00',2.25),('8975','2013-03-18','07:25:00',2.6),('8975','2013-03-18','07:30:00',2.76),('8975','2013-03-18','07:35:00',2.89),('8975','2013-03-18','07:40:00',3.04),('8975','2013-03-18','07:45:00',3.14),('8975','2013-03-18','07:50:00',3.29),('8975','2013-03-18','07:55:00',2.94),('8975','2013-03-18','08:00:00',2.09),('8975','2013-03-18','08:05:00',2.36),('8975','2013-03-18','08:10:00',2.44),('8975','2013-03-18','08:15:00',2.3),('8975','2013-03-18','08:20:00',3.79),('8975','2013-03-18','08:25:00',4.02),('8975','2013-03-18','08:30:00',4.16),('8975','2013-03-18','08:35:00',4.32),('8975','2013-03-18','08:40:00',2.98),('8975','2013-03-18','08:45:00',1.72),('8975','2013-03-18','08:50:00',4.62),('8975','2013-03-18','08:55:00',4.69),('8975','2013-03-18','09:00:00',4.77),('8975','2013-03-18','09:05:00',4.8),('8975','2013-03-18','09:10:00',4.97),('8975','2013-03-18','09:15:00',5.08),('8975','2013-03-18','09:20:00',5.21),('8975','2013-03-18','09:25:00',5.23),('8975','2013-03-18','09:30:00',5.28),('8975','2013-03-18','09:35:00',5.03),('8975','2013-03-18','09:40:00',5.25),('8975','2013-03-18','09:45:00',4.36),('8975','2013-03-18','09:50:00',4.2),('8975','2013-03-18','09:55:00',5.33),('8975','2013-03-18','10:00:00',5.78),('8975','2013-03-18','10:05:00',5.89),('8975','2013-03-18','10:10:00',5.69),('8975','2013-03-18','10:15:00',5.92),('8975','2013-03-18','10:20:00',5.94),('8975','2013-03-18','10:25:00',6.18),('8975','2013-03-18','10:30:00',6.06),('8975','2013-03-18','10:35:00',5.79),('8975','2013-03-18','10:40:00',6.2),('8975','2013-03-18','10:45:00',6.26),('8975','2013-03-18','10:50:00',6.27),('8975','2013-03-18','10:55:00',5.4),('8975','2013-03-18','11:00:00',6.43),('8975','2013-03-18','11:05:00',6.1),('8975','2013-03-18','11:10:00',5.97),('8975','2013-03-18','11:15:00',6.08),('8975','2013-03-18','11:20:00',6.32),('8975','2013-03-18','11:25:00',6.12),('8975','2013-03-18','11:30:00',6.2),('8975','2013-03-18','11:35:00',4.58),('8975','2013-03-18','11:40:00',6.53),('8975','2013-03-18','11:45:00',6.66),('8975','2013-03-18','11:50:00',6.53),('8975','2013-03-18','11:55:00',6.38),('8975','2013-03-18','12:00:00',6.22),('8975','2013-03-18','12:05:00',6.25),('8975','2013-03-18','12:10:00',6.06),('8975','2013-03-18','12:15:00',6.01),('8975','2013-03-18','12:20:00',5.87),('8975','2013-03-18','12:25:00',5.93),('8975','2013-03-18','12:30:00',5.99),('8975','2013-03-18','12:35:00',5.95),('8975','2013-03-18','12:40:00',5.91),('8975','2013-03-18','12:45:00',5.03),('8975','2013-03-18','12:50:00',5.92),('8975','2013-03-18','12:55:00',5.87),('8975','2013-03-18','13:00:00',5.67),('8975','2013-03-18','13:05:00',5.6),('8975','2013-03-18','13:10:00',5.53),('8975','2013-03-18','13:15:00',5.46),('8975','2013-03-18','13:20:00',5.34),('8975','2013-03-18','13:25:00',5.24),('8975','2013-03-18','13:30:00',5.14),('8975','2013-03-18','13:35:00',5.06),('8975','2013-03-18','13:40:00',4.96),('8975','2013-03-18','13:45:00',4.86),('8975','2013-03-18','13:50:00',4.71),('8975','2013-03-18','13:55:00',4.67),('8975','2013-03-18','14:00:00',4.58),('8975','2013-03-18','14:05:00',4.44),('8975','2013-03-18','14:10:00',4.24),('8975','2013-03-18','14:15:00',3.91),('8975','2013-03-18','14:20:00',3.93),('8975','2013-03-18','14:25:00',3.97),('8975','2013-03-18','14:30:00',3.84),('8975','2013-03-18','14:35:00',3.72),('8975','2013-03-18','14:40:00',3.52),('8975','2013-03-18','14:45:00',3.3),('8975','2013-03-18','14:50:00',3.29),('8975','2013-03-18','14:55:00',3.27),('8975','2013-03-18','15:00:00',3.04),('8975','2013-03-18','15:05:00',3.05),('8975','2013-03-18','15:10:00',2.93),('8975','2013-03-18','15:15:00',2.84),('8975','2013-03-18','15:20:00',2.72),('8975','2013-03-18','15:25:00',2.63),('8975','2013-03-18','15:30:00',2.49),('8975','2013-03-18','15:35:00',2.38),('8975','2013-03-18','15:40:00',2.29),('8975','2013-03-18','15:45:00',2.17),('8975','2013-03-18','15:50:00',2.06),('8975','2013-03-18','15:55:00',1.99),('8975','2013-03-18','16:00:00',1.9),('8975','2013-03-18','16:05:00',1.81),('8975','2013-03-18','16:10:00',1.73),('8975','2013-03-18','16:15:00',1.7),('8975','2013-03-18','16:20:00',1.63),('8975','2013-03-18','16:25:00',1.6),('8975','2013-03-18','16:30:00',1.57),('8975','2013-03-18','16:35:00',1.51),('8975','2013-03-18','16:40:00',1.3),('8975','2013-03-18','16:45:00',1.1),('8975','2013-03-18','16:50:00',1.07),('8975','2013-03-18','16:55:00',1.24),('8975','2013-03-18','17:00:00',1.04),('8975','2013-03-18','17:15:00',1.14),('8975','2013-03-18','17:20:00',1.07),('8975','2013-03-17','08:25:00',1.06),('8975','2013-03-17','08:30:00',1.19),('8975','2013-03-17','08:35:00',1.12),('8975','2013-03-17','08:40:00',1.11),('8975','2013-03-17','08:45:00',1.51),('8975','2013-03-17','08:50:00',1.24),('8975','2013-03-17','08:55:00',1.08),('8975','2013-03-17','09:40:00',1.09),('8975','2013-03-17','09:45:00',1.16),('8975','2013-03-17','09:50:00',1.21),('8975','2013-03-17','09:55:00',1.63),('8975','2013-03-17','10:00:00',2.13),('8975','2013-03-17','10:05:00',2.68),('8975','2013-03-17','10:10:00',2.45),('8975','2013-03-17','10:15:00',2.12),('8975','2013-03-17','10:20:00',2.83),('8975','2013-03-17','10:25:00',3.22),('8975','2013-03-17','10:30:00',3.13),('8975','2013-03-17','10:35:00',2.51),('8975','2013-03-17','10:40:00',2.34),('8975','2013-03-17','10:45:00',2.35),('8975','2013-03-17','10:50:00',2.26),('8975','2013-03-17','10:55:00',1.91),('8975','2013-03-17','11:00:00',2.02),('8975','2013-03-17','11:05:00',2.2),('8975','2013-03-17','11:10:00',2.64),('8975','2013-03-17','11:15:00',2.84),('8975','2013-03-17','11:20:00',2.94),('8975','2013-03-17','11:25:00',3.46),('8975','2013-03-17','11:30:00',3.66),('8975','2013-03-17','11:35:00',3.39),('8975','2013-03-17','11:40:00',3.14),('8975','2013-03-17','11:45:00',2.62),('8975','2013-03-17','11:50:00',2.19),('8975','2013-03-17','11:55:00',2.74),('8975','2013-03-17','12:00:00',2.74),('8975','2013-03-17','12:05:00',5.08),('8975','2013-03-17','12:10:00',4.22),('8975','2013-03-17','12:15:00',5.46),('8975','2013-03-17','12:20:00',3.76),('8975','2013-03-17','12:25:00',3.82),('8975','2013-03-17','12:30:00',5.52),('8975','2013-03-17','12:35:00',6.04),('8975','2013-03-17','12:40:00',4.42),('8975','2013-03-17','12:45:00',4.24),('8975','2013-03-17','12:50:00',5.4),('8975','2013-03-17','12:55:00',5.93),('8975','2013-03-17','13:00:00',6.54),('8975','2013-03-17','13:05:00',4.46),('8975','2013-03-17','13:10:00',2.36),('8975','2013-03-17','13:15:00',1.62),('8975','2013-03-17','13:20:00',1.81),('8975','2013-03-17','13:25:00',3.74),('8975','2013-03-17','13:30:00',2.07),('8975','2013-03-17','13:35:00',2.06),('8975','2013-03-17','13:40:00',3.4),('8975','2013-03-17','13:45:00',2.84),('8975','2013-03-17','13:50:00',2.54),('8975','2013-03-17','13:55:00',2.52),('8975','2013-03-17','14:00:00',2.78),('8975','2013-03-17','14:05:00',4.14),('8975','2013-03-17','14:10:00',2.84),('8975','2013-03-17','14:15:00',2.07),('8975','2013-03-17','14:20:00',2.44),('8975','2013-03-17','14:25:00',2.61),('8975','2013-03-17','14:30:00',1.44),('8975','2013-03-17','14:35:00',1.85),('8975','2013-03-17','14:40:00',2.08),('8975','2013-03-17','14:45:00',1.94),('8975','2013-03-17','14:50:00',1.15),('8975','2013-03-17','14:55:00',1.6),('8975','2013-03-17','15:00:00',1.68),('8975','2013-03-17','15:05:00',1.5),('8975','2013-03-17','15:10:00',1.09),('8975','2013-03-17','15:15:00',1.45),('8975','2013-03-17','15:20:00',1.14),('8975','2013-03-17','15:25:00',1.06),('8975','2013-03-16','07:50:00',1.02),('8975','2013-03-16','07:55:00',1.08),('8975','2013-03-16','08:00:00',1.24),('8975','2013-03-16','08:05:00',1.38),('8975','2013-03-16','08:10:00',1.56),('8975','2013-03-16','08:15:00',1.67),('8975','2013-03-16','08:20:00',2.08),('8975','2013-03-16','08:25:00',2.84),('8975','2013-03-16','08:30:00',2.55),('8975','2013-03-16','08:35:00',1.97),('8975','2013-03-16','08:40:00',2.11),('8975','2013-03-16','08:45:00',2.62),('8975','2013-03-16','08:50:00',2.44),('8975','2013-03-16','08:55:00',2.23),('8975','2013-03-16','09:00:00',2.25),('8975','2013-03-16','09:05:00',2.48),('8975','2013-03-16','09:10:00',2.91),('8975','2013-03-16','09:15:00',2.99),('8975','2013-03-16','09:20:00',2.43),('8975','2013-03-16','09:25:00',2.05),('8975','2013-03-16','09:30:00',2.33),('8975','2013-03-16','09:35:00',2.48),('8975','2013-03-16','09:40:00',2.62),('8975','2013-03-16','09:45:00',2.65),('8975','2013-03-16','09:50:00',2.89),('8975','2013-03-16','09:55:00',3.11),('8975','2013-03-16','10:00:00',3.48),('8975','2013-03-16','10:05:00',2.91),('8975','2013-03-16','10:10:00',2.91),('8975','2013-03-16','10:15:00',3.12),('8975','2013-03-16','10:20:00',3.27),('8975','2013-03-16','10:25:00',3.28),('8975','2013-03-16','10:30:00',3.15),('8975','2013-03-16','10:35:00',3.07),('8975','2013-03-16','10:40:00',2.85),('8975','2013-03-16','10:45:00',3),('8975','2013-03-16','10:50:00',2.97),('8975','2013-03-16','10:55:00',2.81),('8975','2013-03-16','11:00:00',2.6),('8975','2013-03-16','11:05:00',2.28),('8975','2013-03-16','11:10:00',2.26),('8975','2013-03-16','11:15:00',2.4),('8975','2013-03-16','11:20:00',2.75),('8975','2013-03-16','11:25:00',2.94),('8975','2013-03-16','11:30:00',2.72),('8975','2013-03-16','11:35:00',2.53),('8975','2013-03-16','11:40:00',2.33),('8975','2013-03-16','11:45:00',2.25),('8975','2013-03-16','11:50:00',2.09),('8975','2013-03-16','11:55:00',1.91),('8975','2013-03-16','12:00:00',1.9),('8975','2013-03-16','12:05:00',1.97),('8975','2013-03-16','12:10:00',2.46),('8975','2013-03-16','12:15:00',3.25),('8975','2013-03-16','12:20:00',3.95),('8975','2013-03-16','12:25:00',4.22),('8975','2013-03-16','12:30:00',4.84),('8975','2013-03-16','12:35:00',3.95),('8975','2013-03-16','12:40:00',3.88),('8975','2013-03-16','12:45:00',3.59),('8975','2013-03-16','12:50:00',3.35),('8975','2013-03-16','12:55:00',2.94),('8975','2013-03-16','13:00:00',3.61),('8975','2013-03-16','13:05:00',3.7),('8975','2013-03-16','13:10:00',4.72),('8975','2013-03-16','13:15:00',4.57),('8975','2013-03-16','13:20:00',3.83),('8975','2013-03-16','13:25:00',3.05),('8975','2013-03-16','13:30:00',4.03),('8975','2013-03-16','13:35:00',3.5),('8975','2013-03-16','13:40:00',3.27),('8975','2013-03-16','13:45:00',2.89),('8975','2013-03-16','13:50:00',2.45),('8975','2013-03-16','13:55:00',4.01),('8975','2013-03-16','14:00:00',3.39),('8975','2013-03-16','14:05:00',3.48),('8975','2013-03-16','14:10:00',3.86),('8975','2013-03-16','14:15:00',3.7),('8975','2013-03-16','14:20:00',3.87),('8975','2013-03-16','14:25:00',3.04),('8975','2013-03-16','14:30:00',2.93),('8975','2013-03-16','14:35:00',2.71),('8975','2013-03-16','14:40:00',2.15),('8975','2013-03-16','14:45:00',2.08),('8975','2013-03-16','14:50:00',1.87),('8975','2013-03-16','14:55:00',1.94),('8975','2013-03-16','15:00:00',2.6),('8975','2013-03-16','15:05:00',2.9),('8975','2013-03-16','15:10:00',3.76),('8975','2013-03-16','15:15:00',3.07),('8975','2013-03-16','15:20:00',3.43),('8975','2013-03-16','15:25:00',3.53),('8975','2013-03-16','15:30:00',2.86),('8975','2013-03-16','15:35:00',1.99),('8975','2013-03-16','15:40:00',1.81),('8975','2013-03-16','15:45:00',1.76),('8975','2013-03-16','15:50:00',1.02),('8975','2013-03-16','16:40:00',1.21),('8975','2013-03-16','16:45:00',1.42),('8975','2013-03-15','07:45:00',1.11),('8975','2013-03-15','07:50:00',1.38),('8975','2013-03-15','07:55:00',1.52),('8975','2013-03-15','08:00:00',2.09),('8975','2013-03-15','08:05:00',2.32),('8975','2013-03-15','08:10:00',3.36),('8975','2013-03-15','08:15:00',3.71),('8975','2013-03-15','08:20:00',3.17),('8975','2013-03-15','08:25:00',4.32),('8975','2013-03-15','08:30:00',4.34),('8975','2013-03-15','08:35:00',4.42),('8975','2013-03-15','08:40:00',4.52),('8975','2013-03-15','08:45:00',4.55),('8975','2013-03-15','08:50:00',4.22),('8975','2013-03-15','08:55:00',4.33),('8975','2013-03-15','09:00:00',3.08),('8975','2013-03-15','09:05:00',4.08),('8975','2013-03-15','09:10:00',5.34),('8975','2013-03-15','09:15:00',4.88),('8975','2013-03-15','09:20:00',3.83),('8975','2013-03-15','09:25:00',5.55),('8975','2013-03-15','09:30:00',5.83),('8975','2013-03-15','09:35:00',3.86),('8975','2013-03-15','09:40:00',5.58),('8975','2013-03-15','09:45:00',5.91),('8975','2013-03-15','09:50:00',6.02),('8975','2013-03-15','09:55:00',5.8),('8975','2013-03-15','10:00:00',5.31),('8975','2013-03-15','10:05:00',4.28),('8975','2013-03-15','10:10:00',4.88),('8975','2013-03-15','10:15:00',4.72),('8975','2013-03-15','10:20:00',5.36),('8975','2013-03-15','10:25:00',6.68),('8975','2013-03-15','10:30:00',4.55),('8975','2013-03-15','10:35:00',4.86),('8975','2013-03-15','10:40:00',6.46),('8975','2013-03-15','10:45:00',6.27),('8975','2013-03-15','10:50:00',6.28),('8975','2013-03-15','10:55:00',6.27),('8975','2013-03-15','11:00:00',6.26),('8975','2013-03-15','11:05:00',6.29),('8975','2013-03-15','11:10:00',6.31),('8975','2013-03-15','11:15:00',6.31),('8975','2013-03-15','11:20:00',6.31),('8975','2013-03-15','11:25:00',6.27),('8975','2013-03-15','11:30:00',6.27),('8975','2013-03-15','11:35:00',6.27),('8975','2013-03-15','11:40:00',6.25),('8975','2013-03-15','11:45:00',6.22),('8975','2013-03-15','11:50:00',6.21),('8975','2013-03-15','11:55:00',6.22),('8975','2013-03-15','12:00:00',6.19),('8975','2013-03-15','12:05:00',6.13),('8975','2013-03-15','12:10:00',6.11),('8975','2013-03-15','12:15:00',6.08),('8975','2013-03-15','12:20:00',6.08),('8975','2013-03-15','12:25:00',6.02),('8975','2013-03-15','12:30:00',5.94),('8975','2013-03-15','12:35:00',5.9),('8975','2013-03-15','12:40:00',5.87),('8975','2013-03-15','12:45:00',5.76),('8975','2013-03-15','12:50:00',5.72),('8975','2013-03-15','12:55:00',5.79),('8975','2013-03-15','13:00:00',5.72),('8975','2013-03-15','13:05:00',5.59),('8975','2013-03-15','13:10:00',5.48),('8975','2013-03-15','13:15:00',5.34),('8975','2013-03-15','13:20:00',5.19),('8975','2013-03-15','13:25:00',5.43),('8975','2013-03-15','13:30:00',5.37),('8975','2013-03-15','13:35:00',3.68),('8975','2013-03-15','13:40:00',1.92),('8975','2013-03-15','13:45:00',4.21),('8975','2013-03-15','13:50:00',4.72),('8975','2013-03-15','13:55:00',5.04),('8975','2013-03-15','14:00:00',4.9),('8975','2013-03-15','14:05:00',2.76),('8975','2013-03-15','14:10:00',3.88),('8975','2013-03-15','14:15:00',3.08),('8975','2013-03-15','14:20:00',4.2),('8975','2013-03-15','14:25:00',4.19),('8975','2013-03-15','14:30:00',2.06),('8975','2013-03-15','14:35:00',4.08),('8975','2013-03-15','14:40:00',4.09),('8975','2013-03-15','14:45:00',3.96),('8975','2013-03-15','14:50:00',1.58),('8975','2013-03-15','14:55:00',2.06),('8975','2013-03-15','15:00:00',1.3),('8975','2013-03-15','15:05:00',2.5),('8975','2013-03-15','15:10:00',3.15),('8975','2013-03-15','15:15:00',2.82),('8975','2013-03-15','15:20:00',1.58),('8975','2013-03-15','15:25:00',1.03),('8975','2013-03-15','15:35:00',1.04),('8975','2013-03-15','15:40:00',1.28),('8975','2013-03-15','15:45:00',1.09),('8975','2013-03-15','16:00:00',1.14),('8975','2013-03-15','16:05:00',1.94),('8975','2013-03-15','16:10:00',1.9),('8975','2013-03-15','16:15:00',2.07),('8975','2013-03-15','16:20:00',1.99),('8975','2013-03-15','16:25:00',1.82),('8975','2013-03-15','16:40:00',1.09),('8975','2013-03-15','16:55:00',1.23),('8975','2013-03-15','17:00:00',1.28),('8975','2013-03-15','17:05:00',1.2),('8975','2013-03-15','17:10:00',1.13),('8975','2013-03-15','17:15:00',1.09),('8975','2013-03-15','17:20:00',1.02),('8975','2013-03-14','10:25:00',1.06),('8975','2013-03-14','10:30:00',1.43),('8975','2013-03-14','10:35:00',1.57),('8975','2013-03-14','10:40:00',1.62),('8975','2013-03-14','10:45:00',1.98),('8975','2013-03-14','10:50:00',2.05),('8975','2013-03-14','10:55:00',2.3),('8975','2013-03-14','11:00:00',2.28),('8975','2013-03-14','11:05:00',1.95),('8975','2013-03-14','11:10:00',2),('8975','2013-03-14','11:15:00',1.8),('8975','2013-03-14','11:20:00',2.17),('8975','2013-03-14','11:25:00',2.62),('8975','2013-03-14','11:30:00',3.06),('8975','2013-03-14','11:35:00',4.09),('8975','2013-03-14','11:40:00',4.01),('8975','2013-03-14','11:45:00',4.72),('8975','2013-03-14','11:50:00',3.13),('8975','2013-03-14','11:55:00',3.3),('8975','2013-03-14','12:00:00',3.13),('8975','2013-03-14','12:05:00',2.74),('8975','2013-03-14','12:10:00',2.67),('8975','2013-03-14','12:15:00',2.56),('8975','2013-03-14','12:20:00',2.59),('8975','2013-03-14','12:25:00',2.76),('8975','2013-03-14','12:30:00',2.85),('8975','2013-03-14','12:35:00',3.3),('8975','2013-03-14','12:40:00',2.92),('8975','2013-03-14','12:45:00',2.62),('8975','2013-03-14','12:50:00',2.49),('8975','2013-03-14','12:55:00',2.29),('8975','2013-03-14','13:00:00',2.02),('8975','2013-03-14','13:05:00',1.92),('8975','2013-03-14','13:10:00',1.89),('8975','2013-03-14','13:15:00',2.03),('8975','2013-03-14','13:20:00',2.15),('8975','2013-03-14','13:25:00',2.3),('8975','2013-03-14','13:30:00',2.32),('8975','2013-03-14','13:35:00',2.2),('8975','2013-03-14','13:40:00',2.35),('8975','2013-03-14','13:45:00',2.63),('8975','2013-03-14','13:50:00',2.23),('8975','2013-03-14','13:55:00',1.83),('8975','2013-03-14','14:00:00',1.58),('8975','2013-03-14','14:05:00',1.47),('8975','2013-03-14','14:10:00',1.3),('8975','2013-03-14','14:15:00',1.18),('8975','2013-03-14','14:20:00',1.06),('8975','2013-03-14','14:50:00',1.45),('8975','2013-03-14','14:55:00',1.84),('8975','2013-03-14','15:00:00',2.1),('8975','2013-03-14','15:05:00',1.98),('8975','2013-03-14','15:10:00',1.93),('8975','2013-03-14','15:15:00',2.03),('8975','2013-03-14','15:20:00',2.15),('8975','2013-03-14','15:25:00',2.45),('8975','2013-03-14','15:30:00',2.06),('8975','2013-03-14','15:35:00',1.72),('8975','2013-03-14','15:40:00',1.46),('8975','2013-03-14','15:45:00',1.47),('8975','2013-03-14','15:50:00',1.44),('8975','2013-03-14','15:55:00',1.35),('8975','2013-03-14','16:00:00',1.6),('8975','2013-03-14','16:05:00',1.25),('8975','2013-03-14','16:10:00',1.16),('8975','2013-03-14','16:15:00',1.2),('8975','2013-03-14','16:20:00',1.05),('8975','2013-03-14','17:20:00',1.04),('8975','2013-03-13','08:20:00',1.16),('8975','2013-03-13','08:25:00',1.11),('8975','2013-03-13','10:15:00',1.06),('8975','2013-03-13','10:20:00',1.06),('8975','2013-03-13','10:25:00',1.06),('8975','2013-03-13','11:25:00',1.16),('8975','2013-03-13','11:30:00',1.43),('8975','2013-03-13','11:35:00',1.6),('8975','2013-03-13','11:40:00',1.49),('8975','2013-03-13','11:45:00',1.23),('8975','2013-03-13','11:50:00',1.32),('8975','2013-03-13','11:55:00',1.29),('8975','2013-03-13','12:00:00',1.21),('8975','2013-03-13','12:05:00',1.14),('8975','2013-03-13','12:10:00',1.07),('8975','2013-03-13','12:15:00',1.03),('8975','2013-03-13','12:20:00',1.03),('8975','2013-03-13','12:25:00',1.05),('8975','2013-03-13','12:30:00',1.09),('8975','2013-03-13','12:35:00',1.1),('8975','2013-03-13','12:40:00',1.14),('8975','2013-03-13','12:45:00',1.24),('8975','2013-03-13','12:50:00',1.39),('8975','2013-03-13','12:55:00',1.61),('8975','2013-03-13','13:00:00',1.75),('8975','2013-03-13','13:05:00',1.84),('8975','2013-03-13','13:10:00',1.74),('8975','2013-03-13','13:15:00',1.7),('8975','2013-03-13','13:20:00',2.14),('8975','2013-03-13','13:25:00',2.02),('8975','2013-03-13','13:30:00',1.87),('8975','2013-03-13','13:35:00',2.42),('8975','2013-03-13','13:40:00',3.07),('8975','2013-03-13','13:45:00',2.99),('8975','2013-03-13','13:50:00',2.33),('8975','2013-03-13','13:55:00',2.36),('8975','2013-03-13','14:00:00',2.42),('8975','2013-03-13','14:05:00',1.85),('8975','2013-03-13','14:10:00',1.91),('8975','2013-03-13','14:15:00',1.74),('8975','2013-03-13','14:20:00',1.67),('8975','2013-03-13','14:25:00',1.85),('8975','2013-03-13','14:30:00',1.65),('8975','2013-03-13','14:35:00',1.27),('8975','2013-03-13','15:05:00',1.05),('8975','2013-03-13','15:10:00',1.7),('8975','2013-03-13','15:15:00',2.03),('8975','2013-03-13','15:20:00',1.91),('8975','2013-03-13','15:25:00',1.97),('8975','2013-03-13','15:30:00',2.12),('8975','2013-03-13','15:35:00',1.8),('8975','2013-03-13','15:40:00',1.26),('8975','2013-03-12','07:05:00',1.01),('8975','2013-03-12','07:20:00',1.15),('8975','2013-03-12','07:35:00',1.59),('8975','2013-03-12','07:40:00',1.84),('8975','2013-03-12','08:25:00',1.09),('8975','2013-03-12','08:35:00',1.03),('8975','2013-03-12','08:40:00',1.12),('8975','2013-03-12','08:45:00',1.54),('8975','2013-03-12','08:50:00',2.14),('8975','2013-03-12','08:55:00',1.64),('8975','2013-03-12','09:00:00',1.19),('8975','2013-03-12','09:05:00',1.55),('8975','2013-03-12','09:10:00',1.99),('8975','2013-03-12','09:15:00',1.79),('8975','2013-03-12','09:20:00',1.62),('8975','2013-03-12','09:25:00',1.48),('8975','2013-03-12','09:30:00',1.35),('8975','2013-03-12','09:35:00',1.02),('8975','2013-03-12','09:40:00',2.02),('8975','2013-03-12','09:45:00',1.47),('8975','2013-03-12','10:00:00',1.4),('8975','2013-03-12','10:05:00',1.48),('8975','2013-03-12','10:10:00',3.16),('8975','2013-03-12','10:15:00',3.49),('8975','2013-03-12','10:20:00',3.26),('8975','2013-03-12','10:25:00',4.39),('8975','2013-03-12','10:30:00',6.09),('8975','2013-03-12','10:35:00',4.53),('8975','2013-03-12','10:40:00',2.85),('8975','2013-03-12','10:45:00',1.91),('8975','2013-03-12','10:50:00',1.84),('8975','2013-03-12','10:55:00',2.02),('8975','2013-03-12','11:00:00',1.81),('8975','2013-03-12','11:05:00',1.36),('8975','2013-03-12','11:10:00',1.54),('8975','2013-03-12','11:15:00',1.76),('8975','2013-03-12','11:20:00',1.24),('8975','2013-03-12','11:25:00',2.06),('8975','2013-03-12','11:30:00',2.47),('8975','2013-03-12','11:35:00',2.21),('8975','2013-03-12','11:40:00',2.01),('8975','2013-03-12','11:45:00',2.14),('8975','2013-03-12','11:50:00',1.91),('8975','2013-03-12','11:55:00',1.24),('8975','2013-03-12','12:25:00',1.05),('8975','2013-03-12','12:30:00',1.35),('8975','2013-03-12','12:35:00',1.29),('8975','2013-03-12','12:40:00',1.52),('8975','2013-03-12','12:45:00',1.83),('8975','2013-03-12','12:50:00',2.21),('8975','2013-03-12','12:55:00',2.04),('8975','2013-03-12','13:00:00',2.01),('8975','2013-03-12','13:05:00',1.79),('8975','2013-03-12','13:10:00',1.63),('8975','2013-03-12','13:15:00',1.44),('8975','2013-03-12','13:20:00',1.24),('8975','2013-03-12','13:25:00',1.14),('8975','2013-03-12','13:30:00',1.31),('8975','2013-03-12','13:35:00',1.55),('8975','2013-03-12','13:40:00',1.35),('8975','2013-03-12','13:45:00',1.2),('8975','2013-03-12','13:50:00',1.19),('8975','2013-03-12','13:55:00',1),('8975','2013-03-12','14:30:00',1.05),('8975','2013-03-12','14:35:00',1.01),('8975','2013-03-12','14:40:00',1.01),('8975','2013-03-12','14:45:00',1.37),('8975','2013-03-12','14:50:00',1.49),('8975','2013-03-12','14:55:00',1.28),('8975','2013-03-12','15:00:00',1.33),('8975','2013-03-12','15:05:00',1.45),('8975','2013-03-12','15:10:00',1.36),('8975','2014-03-24','06:35:00',1.16),('8975','2014-03-24','06:40:00',1.54),('8975','2014-03-24','06:45:00',1.63),('8975','2014-03-24','06:50:00',1.6),('8975','2014-03-24','06:55:00',1.74),('8975','2014-03-24','07:00:00',1.75),('8975','2014-03-24','07:05:00',1.8),('8975','2014-03-24','07:10:00',2.59),('8975','2014-03-24','07:15:00',2.97),('8975','2014-03-24','07:20:00',3.27),('8975','2014-03-24','07:25:00',3.25),('8975','2014-03-24','07:30:00',3.19),('8975','2014-03-24','07:35:00',2.15),('8975','2014-03-24','07:40:00',2.14),('8975','2014-03-24','07:45:00',2.39),('8975','2014-03-24','07:50:00',2.6),('8975','2014-03-24','07:55:00',2.51),('8975','2014-03-24','08:00:00',2.35),('8975','2014-03-24','08:05:00',2.2),('8975','2014-03-24','08:10:00',2.4),('8975','2014-03-24','08:15:00',2.63),('8975','2014-03-24','08:20:00',2.39),('8975','2014-03-24','08:25:00',1.99),('8975','2014-03-24','08:30:00',1.77),('8975','2014-03-24','08:35:00',1.79),('8975','2014-03-24','08:40:00',2.18),('8975','2014-03-24','08:45:00',2.91),('8975','2014-03-24','08:50:00',3.37),('8975','2014-03-24','08:55:00',3.53),('8975','2014-03-24','09:00:00',3.3),('8975','2014-03-24','09:05:00',3.14),('8975','2014-03-24','09:10:00',3.16),('8975','2014-03-24','09:15:00',4.25),('8975','2014-03-24','09:20:00',4.32),('8975','2014-03-24','09:25:00',3.55),('8975','2014-03-24','09:30:00',3.2),('8975','2014-03-24','09:35:00',3.04),('8975','2014-03-24','09:40:00',2.98),('8975','2014-03-24','09:45:00',2.72),('8975','2014-03-24','09:50:00',2.89),('8975','2014-03-24','09:55:00',3.41),('8975','2014-03-24','10:00:00',3.72),('8975','2014-03-24','10:05:00',4.13),('8975','2014-03-24','10:10:00',4.5),('8975','2014-03-24','10:15:00',4.54),('8975','2014-03-24','10:20:00',4.53),('8975','2014-03-24','10:25:00',4.13),('8975','2014-03-24','10:30:00',4.58),('8975','2014-03-24','10:35:00',3.85),('8975','2014-03-24','10:40:00',3.37),('8975','2014-03-24','10:45:00',3.07),('8975','2014-03-24','10:50:00',3.01),('8975','2014-03-24','10:55:00',3),('8975','2014-03-24','11:00:00',3.09),('8975','2014-03-24','11:05:00',3.34),('8975','2014-03-24','11:10:00',3.63),('8975','2014-03-24','11:15:00',4.37),('8975','2014-03-24','11:20:00',4.76),('8975','2014-03-24','11:25:00',4.58),('8975','2014-03-24','11:30:00',3.96),('8975','2014-03-24','11:35:00',4.64),('8975','2014-03-24','11:40:00',3.98),('8975','2014-03-24','11:45:00',3.18),('8975','2014-03-24','11:50:00',2.8),('8975','2014-03-24','11:55:00',2.17),('8975','2014-03-24','12:00:00',1.62),('8975','2014-03-24','12:05:00',1.26),('8975','2014-03-24','12:10:00',1.41),('8975','2014-03-24','12:15:00',1.93),('8975','2014-03-24','12:20:00',2.11),('8975','2014-03-24','12:25:00',1.73),('8975','2014-03-24','12:30:00',1.28),('8975','2014-03-24','12:35:00',1.25),('8975','2014-03-24','13:30:00',1.47),('8975','2014-03-24','13:35:00',1.81),('8975','2014-03-24','13:40:00',1.7),('8975','2014-03-24','13:45:00',1.54),('8975','2014-03-24','13:50:00',1.35),('8975','2014-03-24','13:55:00',1.28),('8975','2014-03-24','14:00:00',1.34),('8975','2014-03-24','14:05:00',1.47),('8975','2014-03-24','14:10:00',1.59),('8975','2014-03-24','14:15:00',1.5),('8975','2014-03-24','14:20:00',1.09),('8975','2014-03-24','14:30:00',1.04),('8975','2014-03-24','14:35:00',1.09),('8975','2014-03-24','14:40:00',1.04),('8975','2014-03-24','15:15:00',1.03),('8975','2013-03-11','08:15:00',2.81),('8975','2013-03-11','08:20:00',3.66),('8975','2013-03-11','08:25:00',3.66),('8975','2013-03-11','08:30:00',3.92),('8975','2013-03-11','08:35:00',2.37),('8975','2013-03-11','08:40:00',2.62),('8975','2013-03-11','08:45:00',3.39),('8975','2013-03-11','08:50:00',2.32),('8975','2013-03-11','08:55:00',1.19),('8975','2013-03-11','09:00:00',4.47),('8975','2013-03-11','09:05:00',4.56),('8975','2013-03-11','09:10:00',4.62),('8975','2013-03-11','09:15:00',4.68),('8975','2013-03-11','09:20:00',4.76),('8975','2013-03-11','09:25:00',4.84),('8975','2013-03-11','09:30:00',4.97),('8975','2013-03-11','09:35:00',5.04),('8975','2013-03-11','09:40:00',5.2),('8975','2013-03-11','09:45:00',5.77),('8975','2013-03-11','09:50:00',4.96),('8975','2013-03-11','09:55:00',2.5),('8975','2013-03-11','10:00:00',5.2),('8975','2013-03-11','10:05:00',5.5),('8975','2013-03-11','10:10:00',3.47),('8975','2013-03-11','10:15:00',5.96),('8975','2013-03-11','10:20:00',5.59),('8975','2013-03-11','10:25:00',6.2),('8975','2013-03-11','10:30:00',4.14),('8975','2013-03-11','10:35:00',4.44),('8975','2013-03-11','10:40:00',6.21),('8975','2013-03-11','10:45:00',6.53),('8975','2013-03-11','10:50:00',6.11),('8975','2013-03-11','10:55:00',6.08),('8975','2013-03-11','11:00:00',5.4),('8975','2013-03-11','11:05:00',5.91),('8975','2013-03-11','11:10:00',6.72),('8975','2013-03-11','11:15:00',4.13),('8975','2013-03-11','11:20:00',2.03),('8975','2013-03-11','11:25:00',3.46),('8975','2013-03-11','11:30:00',2.1),('8975','2013-03-11','11:35:00',2.86),('8975','2013-03-11','11:40:00',3.3),('8975','2013-03-11','11:45:00',3.96),('8975','2013-03-11','11:50:00',5.63),('8975','2013-03-11','11:55:00',2.54),('8975','2013-03-11','12:00:00',1.51),('8975','2013-03-11','12:05:00',1.43),('8975','2013-03-11','12:10:00',5.12),('8975','2013-03-11','12:15:00',2.11),('8975','2013-03-11','12:20:00',5.51),('8975','2013-03-11','12:25:00',2.65),('8975','2013-03-11','12:30:00',6.97),('8975','2013-03-11','12:35:00',5.67),('8975','2013-03-11','12:40:00',5.27),('8975','2013-03-11','12:45:00',6.14),('8975','2013-03-11','12:50:00',4.82),('8975','2013-03-11','12:55:00',3.88),('8975','2013-03-11','13:00:00',4.52),('8975','2013-03-11','13:05:00',5.9),('8975','2013-03-11','13:10:00',4.08),('8975','2013-03-11','13:15:00',1.67),('8975','2013-03-11','13:20:00',2.09),('8975','2013-03-11','13:25:00',2.39),('8975','2013-03-11','13:30:00',1.7),('8975','2013-03-11','13:35:00',1.73),('8975','2013-03-11','13:40:00',1.32),('8975','2013-03-11','13:45:00',2.05),('8975','2013-03-11','13:50:00',4.11),('8975','2013-03-11','13:55:00',3.76),('8975','2013-03-11','14:00:00',3.54),('8975','2013-03-11','14:05:00',3.41),('8975','2013-03-11','14:15:00',1.51),('8975','2013-03-11','14:20:00',1.16),('8975','2013-03-11','14:30:00',1.36),('8975','2013-03-11','14:35:00',1.21),('8975','2013-03-11','15:20:00',1.75),('8975','2013-03-11','15:25:00',1.72),('8975','2013-03-11','15:30:00',1.02),('8975','2013-03-11','15:35:00',1),('8975','2013-03-10','07:05:00',1.16),('8975','2013-03-10','07:10:00',1.45),('8975','2013-03-10','07:15:00',1.59),('8975','2013-03-10','07:20:00',1.9),('8975','2013-03-10','07:25:00',2.12),('8975','2013-03-10','07:30:00',2.53),('8975','2013-03-10','07:35:00',2.18),('8975','2013-03-10','07:40:00',1.89),('8975','2013-03-10','07:45:00',1.15),('8975','2013-03-10','07:50:00',1.22),('8975','2013-03-10','07:55:00',1.03),('8975','2013-03-10','08:05:00',2.26),('8975','2013-03-10','08:10:00',3.35),('8975','2013-03-10','08:15:00',3.45),('8975','2013-03-10','08:20:00',3.52),('8975','2013-03-10','08:25:00',3.65),('8975','2013-03-10','08:30:00',3.76),('8975','2013-03-10','08:35:00',3.82),('8975','2013-03-10','08:40:00',3.93),('8975','2013-03-10','08:45:00',4.02),('8975','2013-03-10','08:50:00',4.12),('8975','2013-03-10','08:55:00',4.19),('8975','2013-03-10','09:00:00',4.28),('8975','2013-03-10','09:05:00',4.36),('8975','2013-03-10','09:10:00',4.43),('8975','2013-03-10','09:15:00',4.29),('8975','2013-03-10','09:20:00',4.74),('8975','2013-03-10','09:25:00',2.97),('8975','2013-03-10','09:30:00',5.04),('8975','2013-03-10','09:35:00',4.33),('8975','2013-03-10','09:40:00',3.43),('8975','2013-03-10','09:45:00',3.05),('8975','2013-03-10','09:50:00',2.2),('8975','2013-03-10','09:55:00',1.88),('8975','2013-03-10','10:00:00',1.57),('8975','2013-03-10','10:05:00',1.61),('8975','2013-03-10','10:10:00',1.62),('8975','2013-03-10','10:15:00',1.56),('8975','2013-03-10','10:20:00',1.92),('8975','2013-03-10','10:25:00',2.24),('8975','2013-03-10','10:30:00',2.13),('8975','2013-03-10','10:35:00',2.78),('8975','2013-03-10','10:40:00',3.79),('8975','2013-03-10','10:45:00',4.69),('8975','2013-03-10','10:50:00',3.62),('8975','2013-03-10','10:55:00',3.75),('8975','2013-03-10','11:00:00',2.34),('8975','2013-03-10','11:05:00',2.29),('8975','2013-03-10','11:10:00',2.53),('8975','2013-03-10','11:15:00',1.98),('8975','2013-03-10','11:20:00',1.86),('8975','2013-03-10','11:25:00',2.13),('8975','2013-03-10','11:30:00',2.47),('8975','2013-03-10','11:35:00',4.02),('8975','2013-03-10','11:40:00',3.61),('8975','2013-03-10','11:45:00',4.28),('8975','2013-03-10','11:50:00',4.64),('8975','2013-03-10','11:55:00',3.35),('8975','2013-03-10','12:00:00',2.8),('8975','2013-03-10','12:05:00',2.28),('8975','2013-03-10','12:10:00',1.7),('8975','2013-03-10','12:15:00',1.01),('8975','2013-03-10','12:20:00',1.13),('8975','2013-03-10','12:25:00',1.42),('8975','2013-03-10','12:30:00',1.42),('8975','2013-03-10','12:35:00',1.95),('8975','2013-03-10','12:40:00',1.89),('8975','2013-03-10','12:45:00',2.36),('8975','2013-03-10','12:50:00',3.63),('8975','2013-03-10','12:55:00',2.46),('8975','2013-03-10','13:00:00',2.14),('8975','2013-03-10','13:05:00',2.78),('8975','2013-03-10','13:10:00',4.79),('8975','2013-03-10','13:15:00',3.7),('8975','2013-03-10','13:20:00',2.99),('8975','2013-03-10','13:25:00',3.46),('8975','2013-03-10','13:30:00',2.68),('8975','2013-03-10','13:35:00',3.86),('8975','2013-03-10','13:40:00',3.29),('8975','2013-03-10','13:45:00',2.72),('8975','2013-03-10','13:50:00',3.34),('8975','2013-03-10','13:55:00',1.74),('8975','2013-03-10','14:00:00',1.65),('8975','2013-03-10','14:05:00',1.46),('8975','2013-03-10','14:10:00',1.21),('8975','2013-03-10','14:25:00',1.42),('8975','2013-03-10','14:30:00',1.59),('8975','2013-03-10','14:35:00',1.57),('8975','2013-03-10','14:40:00',1.68),('8975','2013-03-10','14:45:00',1.28),('8975','2013-03-10','14:50:00',1.42),('8975','2013-03-10','14:55:00',1.33),('8975','2013-03-10','15:05:00',1.01),('8975','2013-03-10','15:10:00',1.1),('8975','2013-03-10','15:15:00',1.12),('8975','2013-03-10','15:20:00',1.19),('8975','2013-03-10','15:25:00',1.25),('8975','2013-03-10','15:30:00',2.28),('8975','2013-03-10','15:35:00',2.72),('8975','2013-03-10','15:40:00',2.96),('8975','2013-03-10','15:45:00',2.78),('8975','2013-03-10','15:50:00',2.56),('8975','2013-03-10','15:55:00',2.05),('8975','2013-03-10','16:00:00',2.21),('8975','2013-03-10','16:05:00',1.73),('8975','2013-03-10','16:10:00',1.38),('8975','2013-03-10','16:15:00',1.99),('8975','2013-03-10','16:20:00',2.03),('8975','2013-03-10','16:25:00',1.88),('8975','2013-03-10','16:30:00',1.87),('8975','2013-03-10','16:40:00',1.52),('8975','2013-03-10','16:45:00',1.6),('8975','2013-03-10','16:50:00',1.28),('8975','2013-03-09','07:10:00',1.06),('8975','2013-03-09','07:15:00',1.4),('8975','2013-03-09','07:20:00',1.71),('8975','2013-03-09','07:25:00',1.46),('8975','2013-03-09','07:30:00',1.13),('8975','2013-03-09','07:35:00',1.05),('8975','2013-03-09','07:40:00',1.42),('8975','2013-03-09','07:45:00',1.29),('8975','2013-03-09','07:50:00',2.78),('8975','2013-03-09','07:55:00',3.1),('8975','2013-03-09','08:00:00',3.2),('8975','2013-03-09','08:05:00',3.3),('8975','2013-03-09','08:10:00',3.15),('8975','2013-03-09','08:15:00',3.19),('8975','2013-03-09','08:20:00',3.53),('8975','2013-03-09','08:25:00',3.65),('8975','2013-03-09','08:30:00',3.76),('8975','2013-03-09','08:35:00',3.81),('8975','2013-03-09','08:40:00',3.89),('8975','2013-03-09','08:45:00',4),('8975','2013-03-09','08:50:00',4.11),('8975','2013-03-09','08:55:00',4.19),('8975','2013-03-09','09:00:00',4.27),('8975','2013-03-09','09:05:00',4.35),('8975','2013-03-09','09:10:00',4.43),('8975','2013-03-09','09:15:00',4.51),('8975','2013-03-09','09:20:00',4.57),('8975','2013-03-09','09:25:00',4.67),('8975','2013-03-09','09:30:00',4.76),('8975','2013-03-09','09:35:00',4.87),('8975','2013-03-09','09:40:00',4.91),('8975','2013-03-09','09:45:00',3.19),('8975','2013-03-09','09:50:00',5.57),('8975','2013-03-09','09:55:00',3.18),('8975','2013-03-09','10:00:00',4.16),('8975','2013-03-09','10:05:00',3.53),('8975','2013-03-09','10:10:00',4.12),('8975','2013-03-09','10:15:00',3.84),('8975','2013-03-09','10:20:00',5.51),('8975','2013-03-09','10:25:00',6.06),('8975','2013-03-09','10:30:00',5.35),('8975','2013-03-09','10:35:00',4.39),('8975','2013-03-09','10:40:00',5.65),('8975','2013-03-09','10:45:00',3.49),('8975','2013-03-09','10:50:00',3.57),('8975','2013-03-09','10:55:00',5.95),('8975','2013-03-09','11:00:00',6.35),('8975','2013-03-09','11:05:00',3.41),('8975','2013-03-09','11:10:00',4.9),('8975','2013-03-09','11:15:00',6.85),('8975','2013-03-09','11:20:00',1.96),('8975','2013-03-09','11:25:00',4.3),('8975','2013-03-09','11:30:00',3.22),('8975','2013-03-09','11:35:00',2.58),('8975','2013-03-09','11:40:00',3.1),('8975','2013-03-09','11:45:00',6.48),('8975','2013-03-09','11:50:00',4.88),('8975','2013-03-09','11:55:00',5.79),('8975','2013-03-09','12:00:00',5.69),('8975','2013-03-09','12:05:00',5.56),('8975','2013-03-09','12:10:00',5.71),('8975','2013-03-09','12:15:00',4.89),('8975','2013-03-09','12:20:00',3.31),('8975','2013-03-09','12:25:00',2.95),('8975','2013-03-09','12:30:00',5.64),('8975','2013-03-09','12:35:00',5.31),('8975','2013-03-09','12:40:00',4.7),('8975','2013-03-09','12:45:00',4.77),('8975','2013-03-09','12:50:00',5.66),('8975','2013-03-09','12:55:00',5.34),('8975','2013-03-09','13:00:00',5.21),('8975','2013-03-09','13:05:00',5.04),('8975','2013-03-09','13:10:00',4.96),('8975','2013-03-09','13:15:00',5.03),('8975','2013-03-09','13:20:00',4.74),('8975','2013-03-09','13:25:00',4.9),('8975','2013-03-09','13:30:00',4.77),('8975','2013-03-09','13:35:00',4.87),('8975','2013-03-09','13:40:00',4.52),('8975','2013-03-09','13:45:00',4.8),('8975','2013-03-09','13:50:00',3.4),('8975','2013-03-09','13:55:00',3.09),('8975','2013-03-09','14:00:00',2.49),('8975','2013-03-09','14:05:00',3.3),('8975','2013-03-09','14:10:00',3.13),('8975','2013-03-09','14:15:00',3.49),('8975','2013-03-09','14:20:00',3.56),('8975','2013-03-09','14:25:00',3.66),('8975','2013-03-09','14:30:00',3.39),('8975','2013-03-09','14:35:00',3.85),('8975','2013-03-09','14:40:00',2.6),('8975','2013-03-09','14:45:00',2.26),('8975','2013-03-09','14:50:00',2.91),('8975','2013-03-09','14:55:00',2.17),('8975','2013-03-09','15:00:00',2.42),('8975','2013-03-09','15:05:00',2.39),('8975','2013-03-09','15:10:00',2.19),('8975','2013-03-09','15:15:00',1.48),('8975','2013-03-09','15:20:00',1.55),('8975','2013-03-09','15:50:00',1.42),('8975','2013-03-09','15:55:00',1.22),('8975','2013-03-08','07:45:00',1.94),('8975','2013-03-08','07:50:00',2.65),('8975','2013-03-08','07:55:00',2.84),('8975','2013-03-08','08:00:00',3.38),('8975','2013-03-08','08:05:00',3.25),('8975','2013-03-08','08:10:00',3.25),('8975','2013-03-08','08:15:00',3.03),('8975','2013-03-08','08:20:00',2.75),('8975','2013-03-08','08:25:00',2.84),('8975','2013-03-08','08:30:00',3.71),('8975','2013-03-08','08:35:00',3.78),('8975','2013-03-08','08:40:00',3.79),('8975','2013-03-08','08:45:00',3.49),('8975','2013-03-08','08:50:00',1.72),('8975','2013-03-08','08:55:00',3.59),('8975','2013-03-08','09:00:00',1.42),('8975','2013-03-08','09:05:00',1.21),('8975','2013-03-08','09:10:00',2),('8975','2013-03-08','09:15:00',1.77),('8975','2013-03-08','09:20:00',1.4),('8975','2013-03-08','09:25:00',1.35),('8975','2013-03-08','09:30:00',1.94),('8975','2013-03-08','09:35:00',2.45),('8975','2013-03-08','09:40:00',5.16),('8975','2013-03-08','09:45:00',1.85),('8975','2013-03-08','09:50:00',1.22),('8975','2013-03-08','09:55:00',1.97),('8975','2013-03-08','10:00:00',2.96),('8975','2013-03-08','10:05:00',3.29),('8975','2013-03-08','10:10:00',2.79),('8975','2013-03-08','10:15:00',2.9),('8975','2013-03-08','10:20:00',3.1),('8975','2013-03-08','10:25:00',2.1),('8975','2013-03-08','10:30:00',1.89),('8975','2013-03-08','10:35:00',2.04),('8975','2013-03-08','10:40:00',4.55),('8975','2013-03-08','10:45:00',3.05),('8975','2013-03-08','10:50:00',2.53),('8975','2013-03-08','10:55:00',5.4),('8975','2013-03-08','11:00:00',5.86),('8975','2013-03-08','11:05:00',3.11),('8975','2013-03-08','11:10:00',4.36),('8975','2013-03-08','11:15:00',3.77),('8975','2013-03-08','11:20:00',3.59),('8975','2013-03-08','11:25:00',2.35),('8975','2013-03-08','11:30:00',4.24),('8975','2013-03-08','11:35:00',5.47),('8975','2013-03-08','11:40:00',3.66),('8975','2013-03-08','11:45:00',4.89),('8975','2013-03-08','11:50:00',5.82),('8975','2013-03-08','11:55:00',5.65),('8975','2013-03-08','12:00:00',5.8),('8975','2013-03-08','12:05:00',4.73),('8975','2013-03-08','12:10:00',5.89),('8975','2013-03-08','12:15:00',3.04),('8975','2013-03-08','12:20:00',3.2),('8975','2013-03-08','12:25:00',3.93),('8975','2013-03-08','12:30:00',2.32),('8975','2013-03-08','12:35:00',2.92),('8975','2013-03-08','12:40:00',4.22),('8975','2013-03-08','12:45:00',4.92),('8975','2013-03-08','12:50:00',5.51),('8975','2013-03-08','12:55:00',4.7),('8975','2013-03-08','13:00:00',2.72),('8975','2013-03-08','13:05:00',4.11),('8975','2013-03-08','13:10:00',5.07),('8975','2013-03-08','13:15:00',4.33),('8975','2013-03-08','13:20:00',4.3),('8975','2013-03-08','13:25:00',3.87),('8975','2013-03-08','13:30:00',1.91),('8975','2013-03-08','13:35:00',4.41),('8975','2013-03-08','13:40:00',4.38),('8975','2013-03-08','13:45:00',2.86),('8975','2013-03-08','13:50:00',2.54),('8975','2013-03-08','13:55:00',3.39),('8975','2013-03-08','14:00:00',4.31),('8975','2013-03-08','14:05:00',4.08),('8975','2013-03-08','14:10:00',3.68),('8975','2013-03-08','14:15:00',3.74),('8975','2013-03-08','14:20:00',3.57),('8975','2013-03-08','14:25:00',3.47),('8975','2013-03-08','14:30:00',3.23),('8975','2013-03-08','14:35:00',3.11),('8975','2013-03-08','14:40:00',2.96),('8975','2013-03-08','14:45:00',3.03),('8975','2013-03-08','14:50:00',2.92),('8975','2013-03-08','14:55:00',2.83),('8975','2013-03-08','15:00:00',2.73),('8975','2013-03-08','15:05:00',2.62),('8975','2013-03-08','15:10:00',2.53),('8975','2013-03-08','15:15:00',2.42),('8975','2013-03-08','15:20:00',2.31),('8975','2013-03-08','15:25:00',2.16),('8975','2013-03-08','15:30:00',2.09),('8975','2013-03-08','15:35:00',1.99),('8975','2013-03-08','15:40:00',1.92),('8975','2013-03-08','15:45:00',1.82),('8975','2013-03-08','15:50:00',1.7),('8975','2013-03-08','15:55:00',1.67),('8975','2013-03-08','16:00:00',1.61),('8975','2013-03-08','16:05:00',1.59),('8975','2013-03-08','16:10:00',1.31),('8975','2013-03-08','16:15:00',1.59),('8975','2013-03-08','16:20:00',1.51),('8975','2013-03-08','16:25:00',1.58),('8975','2013-03-08','16:30:00',1.37),('8975','2013-03-08','16:35:00',1.2),('8975','2013-03-08','16:40:00',1.21),('8975','2013-03-07','08:10:00',1.92),('8975','2013-03-07','08:15:00',1.42),('8975','2013-03-07','08:20:00',1.3),('8975','2013-03-07','08:25:00',1.88),('8975','2013-03-07','08:30:00',2.71),('8975','2013-03-07','08:35:00',2.53),('8975','2013-03-07','08:40:00',1.35),('8975','2013-03-07','08:45:00',1.45),('8975','2013-03-07','08:50:00',1.19),('8975','2013-03-07','08:55:00',1.43),('8975','2013-03-07','09:00:00',1.54),('8975','2013-03-07','09:10:00',1.1),('8975','2013-03-07','09:15:00',1.3),('8975','2013-03-07','09:20:00',1.13),('8975','2013-03-07','09:25:00',1.79),('8975','2013-03-07','09:30:00',4.28),('8975','2013-03-07','09:35:00',5.65),('8975','2013-03-07','09:40:00',3.54),('8975','2013-03-07','09:45:00',4.02),('8975','2013-03-07','09:50:00',4.09),('8975','2013-03-07','09:55:00',3.83),('8975','2013-03-07','10:00:00',2.5),('8975','2013-03-07','10:05:00',2.58),('8975','2013-03-07','10:10:00',3.64),('8975','2013-03-07','10:15:00',2.05),('8975','2013-03-07','10:20:00',2.29),('8975','2013-03-07','10:25:00',5.78),('8975','2013-03-07','10:30:00',4.86),('8975','2013-03-07','10:35:00',3.04),('8975','2013-03-07','10:40:00',2.54),('8975','2013-03-07','10:45:00',1.92),('8975','2013-03-07','10:50:00',1.73),('8975','2013-03-07','10:55:00',1.62),('8975','2013-03-07','11:00:00',1.21),('8975','2013-03-07','11:15:00',1.07),('8975','2013-03-07','11:20:00',1.27),('8975','2013-03-07','11:25:00',1.44),('8975','2013-03-07','11:30:00',3.61),('8975','2013-03-07','11:35:00',4.41),('8975','2013-03-07','11:40:00',4.45),('8975','2013-03-07','11:45:00',4.62),('8975','2013-03-07','11:50:00',3.25),('8975','2013-03-07','11:55:00',3.29),('8975','2013-03-07','12:00:00',2.42),('8975','2013-03-07','12:05:00',1.91),('8975','2013-03-07','12:10:00',1.96),('8975','2013-03-07','12:15:00',2.64),('8975','2013-03-07','12:20:00',3.06),('8975','2013-03-07','12:25:00',2.57),('8975','2013-03-07','12:30:00',2.07),('8975','2013-03-07','12:35:00',3.53),('8975','2013-03-07','12:40:00',5.89),('8975','2013-03-07','12:45:00',4.82),('8975','2013-03-07','12:50:00',4.82),('8975','2013-03-07','12:55:00',4.96),('8975','2013-03-07','13:00:00',5.23),('8975','2013-03-07','13:05:00',4.02),('8975','2013-03-07','13:10:00',2.65),('8975','2013-03-07','13:15:00',2.25),('8975','2013-03-07','13:20:00',2.32),('8975','2013-03-07','13:25:00',2.88),('8975','2013-03-07','13:30:00',3.14),('8975','2013-03-07','13:35:00',2.66),('8975','2013-03-07','13:40:00',1.9),('8975','2013-03-07','13:45:00',1.39),('8975','2013-03-07','13:50:00',1.53),('8975','2013-03-07','13:55:00',1.49),('8975','2013-03-07','17:10:00',1.77),('8975','2013-03-07','17:15:00',1.4),('8975','2013-03-06','08:35:00',1.52),('8975','2013-03-06','08:40:00',1.86),('8975','2013-03-06','08:45:00',1.42),('8975','2013-03-06','08:50:00',1.56),('8975','2013-03-06','08:55:00',1.57),('8975','2013-03-06','09:00:00',1.38),('8975','2013-03-06','09:05:00',1.44),('8975','2013-03-06','09:10:00',1.03),('8975','2013-03-06','09:15:00',1.63),('8975','2013-03-06','09:20:00',1.21),('8975','2013-03-06','10:25:00',1.54),('8975','2013-03-06','10:30:00',1.25),('8975','2013-03-06','10:45:00',1.23),('8975','2013-03-06','10:50:00',2.1),('8975','2013-03-06','10:55:00',1.73),('8975','2013-03-06','11:00:00',1.88),('8975','2013-03-06','11:05:00',2.05),('8975','2013-03-06','11:10:00',1.34),('8975','2013-03-06','11:25:00',2.27),('8975','2013-03-06','11:30:00',3.85),('8975','2013-03-06','11:35:00',2.84),('8975','2013-03-06','11:40:00',2.27),('8975','2013-03-06','11:45:00',2.28),('8975','2013-03-06','11:50:00',2.25),('8975','2013-03-06','11:55:00',1.37),('8975','2013-03-06','12:00:00',1.66),('8975','2013-03-06','12:05:00',1.46),('8975','2013-03-06','12:20:00',1.56),('8975','2013-03-06','12:25:00',1.58),('8975','2013-03-06','12:30:00',1.25),('8975','2013-03-06','12:35:00',1.92),('8975','2013-03-06','12:40:00',2.74),('8975','2013-03-06','12:45:00',2.76),('8975','2013-03-06','12:50:00',2.33),('8975','2013-03-06','12:55:00',2.62),('8975','2013-03-06','13:00:00',2.73),('8975','2013-03-06','13:05:00',1.84),('8975','2013-03-06','13:10:00',2.17),('8975','2013-03-06','13:15:00',2.67),('8975','2013-03-06','13:20:00',3.06),('8975','2013-03-06','13:25:00',2.58),('8975','2013-03-06','13:30:00',2.54),('8975','2013-03-06','13:35:00',1.66),('8975','2013-03-06','13:50:00',1.15),('8975','2013-03-06','13:55:00',1.1),('8975','2013-03-06','14:00:00',1.4),('8975','2013-03-06','14:05:00',1.5),('8975','2013-03-06','14:10:00',1.35),('8975','2013-03-06','14:15:00',1.18),('8975','2013-03-06','14:20:00',1.16),('8975','2013-03-06','14:45:00',1.28),('8975','2013-03-06','15:40:00',1.05),('8975','2013-03-06','16:05:00',1.27),('8975','2013-03-06','16:10:00',1.22),('8975','2013-03-06','16:15:00',1.09),('8975','2013-03-06','16:35:00',1.24),('8975','2013-03-06','16:40:00',1.38),('8975','2013-03-04','07:35:00',1.09),('8975','2013-03-04','08:00:00',1.12),('8975','2013-03-04','08:05:00',1.4),('8975','2013-03-04','08:10:00',1.96),('8975','2013-03-04','08:15:00',2.21),('8975','2013-03-04','08:20:00',1.48),('8975','2013-03-04','08:25:00',2.55),('8975','2013-03-04','08:30:00',3.82),('8975','2013-03-04','08:35:00',2.64),('8975','2013-03-04','08:40:00',2.72),('8975','2013-03-04','08:45:00',2.86),('8975','2013-03-04','08:50:00',2.94),('8975','2013-03-04','08:55:00',2.53),('8975','2013-03-04','09:00:00',2.62),('8975','2013-03-04','09:05:00',2.87),('8975','2013-03-04','09:10:00',2.72),('8975','2013-03-04','09:15:00',2.49),('8975','2013-03-04','09:20:00',2.53),('8975','2013-03-04','09:25:00',2.46),('8975','2013-03-04','09:30:00',2.6),('8975','2013-03-04','09:35:00',2.76),('8975','2013-03-04','09:40:00',2.92),('8975','2013-03-04','09:45:00',2.92),('8975','2013-03-04','09:50:00',2.9),('8975','2013-03-04','09:55:00',2.79),('8975','2013-03-04','10:00:00',2.6),('8975','2013-03-04','10:05:00',2.74),('8975','2013-03-04','10:10:00',2.88),('8975','2013-03-04','10:15:00',3.25),('8975','2013-03-04','10:20:00',3.47),('8975','2013-03-04','10:25:00',2.93),('8975','2013-03-04','10:30:00',3.09),('8975','2013-03-04','10:35:00',3.56),('8975','2013-03-04','10:40:00',3.56),('8975','2013-03-04','10:45:00',3.77),('8975','2013-03-04','10:50:00',4.08),('8975','2013-03-04','10:55:00',4.04),('8975','2013-03-04','11:00:00',3.6),('8975','2013-03-04','11:05:00',4.05),('8975','2013-03-04','11:10:00',4.11),('8975','2013-03-04','11:15:00',4.11),('8975','2013-03-04','11:20:00',4.03),('8975','2013-03-04','11:25:00',3.9),('8975','2013-03-04','11:30:00',3.63),('8975','2013-03-04','11:35:00',3.98),('8975','2013-03-04','11:40:00',4.79),('8975','2013-03-04','11:45:00',4.23),('8975','2013-03-04','11:50:00',4.61),('8975','2013-03-04','11:55:00',4.75),('8975','2013-03-04','12:00:00',4.48),('8975','2013-03-04','12:05:00',4.65),('8975','2013-03-04','12:10:00',4.48),('8975','2013-03-04','12:15:00',3.93),('8975','2013-03-04','12:20:00',3.92),('8975','2013-03-04','12:25:00',4.37),('8975','2013-03-04','12:30:00',3.49),('8975','2013-03-04','12:35:00',2.71),('8975','2013-03-04','12:40:00',3.24),('8975','2013-03-04','12:45:00',3.43),('8975','2013-03-04','12:50:00',3.23),('8975','2013-03-04','12:55:00',2.92),('8975','2013-03-04','13:00:00',2.63),('8975','2013-03-04','13:05:00',2.6),('8975','2013-03-04','13:10:00',2.74),('8975','2013-03-04','13:15:00',2.88),('8975','2013-03-04','13:20:00',2.73),('8975','2013-03-04','13:25:00',2.52),('8975','2013-03-04','13:30:00',2.34),('8975','2013-03-04','13:35:00',2.28),('8975','2013-03-04','13:40:00',2.15),('8975','2013-03-04','13:45:00',1.96),('8975','2013-03-04','13:50:00',1.77),('8975','2013-03-04','13:55:00',1.66),('8975','2013-03-04','14:00:00',1.66),('8975','2013-03-04','14:05:00',1.7),('8975','2013-03-04','14:10:00',1.77),('8975','2013-03-04','14:15:00',1.66),('8975','2013-03-04','14:20:00',1.54),('8975','2013-03-04','14:25:00',1.55),('8975','2013-03-04','14:30:00',1.49),('8975','2013-03-04','14:35:00',1.52),('8975','2013-03-04','14:40:00',1.59),('8975','2013-03-04','14:45:00',1.65),('8975','2013-03-04','14:50:00',1.59),('8975','2013-03-04','14:55:00',1.41),('8975','2013-03-04','15:00:00',1.28),('8975','2013-03-04','15:05:00',1.19),('8975','2013-03-04','15:20:00',1.01),('8975','2013-03-04','15:25:00',1.16),('8975','2013-03-04','15:30:00',1.33),('8975','2013-03-04','15:35:00',1.34),('8975','2013-03-04','15:40:00',1.43),('8975','2013-03-04','15:45:00',1.66),('8975','2013-03-04','15:50:00',1.57),('8975','2013-03-04','15:55:00',1.39),('8975','2013-03-04','16:00:00',1.27),('8975','2013-03-04','16:05:00',1.08),('8975','2013-03-03','07:15:00',1.19),('8975','2013-03-03','07:20:00',1.4),('8975','2013-03-03','07:25:00',1.57),('8975','2013-03-03','07:30:00',1.82),('8975','2013-03-03','07:35:00',2),('8975','2013-03-03','07:40:00',2.16),('8975','2013-03-03','07:45:00',2.32),('8975','2013-03-03','07:50:00',2.46),('8975','2013-03-03','07:55:00',2.6),('8975','2013-03-03','08:00:00',2.72),('8975','2013-03-03','08:05:00',2.87),('8975','2013-03-03','08:10:00',2.98),('8975','2013-03-03','08:15:00',3.07),('8975','2013-03-03','08:20:00',3.18),('8975','2013-03-03','08:25:00',3.28),('8975','2013-03-03','08:30:00',3.36),('8975','2013-03-03','08:35:00',3.45),('8975','2013-03-03','08:40:00',3.54),('8975','2013-03-03','08:45:00',3.64),('8975','2013-03-03','08:50:00',3.73),('8975','2013-03-03','08:55:00',3.8),('8975','2013-03-03','09:00:00',3.94),('8975','2013-03-03','09:05:00',4.03),('8975','2013-03-03','09:10:00',4.09),('8975','2013-03-03','09:15:00',4.21),('8975','2013-03-03','09:20:00',4.24),('8975','2013-03-03','09:25:00',4.32),('8975','2013-03-03','09:30:00',4.45),('8975','2013-03-03','09:35:00',4.51),('8975','2013-03-03','09:40:00',4.61),('8975','2013-03-03','09:45:00',4.72),('8975','2013-03-03','09:50:00',4.76),('8975','2013-03-03','09:55:00',4.84),('8975','2013-03-03','10:00:00',4.86),('8975','2013-03-03','10:05:00',4.93),('8975','2013-03-03','10:10:00',4.93),('8975','2013-03-03','10:15:00',4.98),('8975','2013-03-03','10:20:00',5.02),('8975','2013-03-03','10:25:00',5.08),('8975','2013-03-03','10:30:00',5.09),('8975','2013-03-03','10:35:00',5.13),('8975','2013-03-03','10:40:00',5.19),('8975','2013-03-03','10:45:00',5.22),('8975','2013-03-03','10:50:00',5.19),('8975','2013-03-03','10:55:00',5.21),('8975','2013-03-03','11:00:00',5.21),('8975','2013-03-03','11:05:00',5.31),('8975','2013-03-03','11:10:00',5.2),('8975','2013-03-03','11:15:00',5.24),('8975','2013-03-03','11:20:00',5.25),('8975','2013-03-03','11:25:00',5.26),('8975','2013-03-03','11:30:00',5.29),('8975','2013-03-03','11:35:00',5.33),('8975','2013-03-03','11:40:00',5.32),('8975','2013-03-03','11:45:00',5.3),('8975','2013-03-03','11:50:00',5.17),('8975','2013-03-03','11:55:00',5.14),('8975','2013-03-03','12:00:00',5.18),('8975','2013-03-03','12:05:00',5.19),('8975','2013-03-03','12:10:00',5.1),('8975','2013-03-03','12:15:00',5.12),('8975','2013-03-03','12:20:00',5.16),('8975','2013-03-03','12:25:00',5),('8975','2013-03-03','12:30:00',4.98),('8975','2013-03-03','12:35:00',4.87),('8975','2013-03-03','12:40:00',4.79),('8975','2013-03-03','12:45:00',4.8),('8975','2013-03-03','12:50:00',4.68),('8975','2013-03-03','12:55:00',4.58),('8975','2013-03-03','13:00:00',4.53),('8975','2013-03-03','13:05:00',4.48),('8975','2013-03-03','13:10:00',4.25),('8975','2013-03-03','13:15:00',3.93),('8975','2013-03-03','13:20:00',1.27),('8975','2013-03-03','13:25:00',3.77),('8975','2013-03-03','13:30:00',4.06),('8975','2013-03-03','13:35:00',4.52),('8975','2013-03-03','13:40:00',4.27),('8975','2013-03-03','13:45:00',3.95),('8975','2013-03-03','13:50:00',3.89),('8975','2013-03-03','13:55:00',3.64),('8975','2013-03-03','14:00:00',3.55),('8975','2013-03-03','14:05:00',3.53),('8975','2013-03-03','14:10:00',3.36),('8975','2013-03-03','14:15:00',3.4),('8975','2013-03-03','14:20:00',3.4),('8975','2013-03-03','14:25:00',3.05),('8975','2013-03-03','14:30:00',2.98),('8975','2013-03-03','14:35:00',2.94),('8975','2013-03-03','14:40:00',2.7),('8975','2013-03-03','14:45:00',2.75),('8975','2013-03-03','14:50:00',2.65),('8975','2013-03-03','14:55:00',2.34),('8975','2013-03-03','15:00:00',2.57),('8975','2013-03-03','15:05:00',2.37),('8975','2013-03-03','15:10:00',2.27),('8975','2013-03-03','15:15:00',2.22),('8975','2013-03-03','15:20:00',2.12),('8975','2013-03-03','15:25:00',2.01),('8975','2013-03-03','15:30:00',1.93),('8975','2013-03-03','15:35:00',1.83),('8975','2013-03-03','15:40:00',1.78),('8975','2013-03-03','15:45:00',1.73),('8975','2013-03-03','15:50:00',1.64),('8975','2013-03-03','15:55:00',1.59),('8975','2013-03-03','16:00:00',1.53),('8975','2013-03-03','16:05:00',1.46),('8975','2013-03-03','16:10:00',1.39),('8975','2013-03-03','16:15:00',1.39),('8975','2013-03-03','16:20:00',1.37),('8975','2013-03-03','16:25:00',1.34),('8975','2013-03-03','16:30:00',1.29),('8975','2013-03-03','16:35:00',1.21),('8975','2013-03-03','16:40:00',1.13),('8975','2013-03-03','16:45:00',1.07),('8975','2013-03-03','16:50:00',1.02),('8975','2013-03-02','07:10:00',1.08),('8975','2013-03-02','07:15:00',1.46),('8975','2013-03-02','07:20:00',1.69),('8975','2013-03-02','07:25:00',1.88),('8975','2013-03-02','07:30:00',2.09),('8975','2013-03-02','07:35:00',2.27),('8975','2013-03-02','07:40:00',2.43),('8975','2013-03-02','07:45:00',2.58),('8975','2013-03-02','07:50:00',2.74),('8975','2013-03-02','07:55:00',2.86),('8975','2013-03-02','08:00:00',2.98),('8975','2013-03-02','08:05:00',3.08),('8975','2013-03-02','08:10:00',3.17),('8975','2013-03-02','08:15:00',3.25),('8975','2013-03-02','08:20:00',3.35),('8975','2013-03-02','08:25:00',3.5),('8975','2013-03-02','08:30:00',3.57),('8975','2013-03-02','08:35:00',3.65),('8975','2013-03-02','08:40:00',3.74),('8975','2013-03-02','08:45:00',3.83),('8975','2013-03-02','08:50:00',3.91),('8975','2013-03-02','08:55:00',3.99),('8975','2013-03-02','09:00:00',4.08),('8975','2013-03-02','09:05:00',4.16),('8975','2013-03-02','09:10:00',4.24),('8975','2013-03-02','09:15:00',4.32),('8975','2013-03-02','09:20:00',4.41),('8975','2013-03-02','09:25:00',4.5),('8975','2013-03-02','09:30:00',4.63),('8975','2013-03-02','09:35:00',4.69),('8975','2013-03-02','09:40:00',4.77),('8975','2013-03-02','09:45:00',4.83),('8975','2013-03-02','09:50:00',4.96),('8975','2013-03-02','09:55:00',5.05),('8975','2013-03-02','10:00:00',4.96),('8975','2013-03-02','10:05:00',5.14),('8975','2013-03-02','10:10:00',5.22),('8975','2013-03-02','10:15:00',5.27),('8975','2013-03-02','10:20:00',5.34),('8975','2013-03-02','10:25:00',5.39),('8975','2013-03-02','10:30:00',5.43),('8975','2013-03-02','10:35:00',5.46),('8975','2013-03-02','10:40:00',5.48),('8975','2013-03-02','10:45:00',5.48),('8975','2013-03-02','10:50:00',5.49),('8975','2013-03-02','10:55:00',5.5),('8975','2013-03-02','11:00:00',5.51),('8975','2013-03-02','11:05:00',5.53),('8975','2013-03-02','11:10:00',5.55),('8975','2013-03-02','11:15:00',5.52),('8975','2013-03-02','11:20:00',5.51),('8975','2013-03-02','11:25:00',5.52),('8975','2013-03-02','11:30:00',5.54),('8975','2013-03-02','11:35:00',5.51),('8975','2013-03-02','11:40:00',5.5),('8975','2013-03-02','11:45:00',5.47),('8975','2013-03-02','11:50:00',5.48),('8975','2013-03-02','11:55:00',5.41),('8975','2013-03-02','12:00:00',5.33),('8975','2013-03-02','12:05:00',5.34),('8975','2013-03-02','12:10:00',5.34),('8975','2013-03-02','12:15:00',5.28),('8975','2013-03-02','12:20:00',5.23),('8975','2013-03-02','12:25:00',5.17),('8975','2013-03-02','12:30:00',5.13),('8975','2013-03-02','12:35:00',5.1),('8975','2013-03-02','12:40:00',5.04),('8975','2013-03-02','12:45:00',4.98),('8975','2013-03-02','12:50:00',4.92),('8975','2013-03-02','12:55:00',4.89),('8975','2013-03-02','13:00:00',4.82),('8975','2013-03-02','13:05:00',4.7),('8975','2013-03-02','13:10:00',4.63),('8975','2013-03-02','13:15:00',4.36),('8975','2013-03-02','13:20:00',4.33),('8975','2013-03-02','13:25:00',4.34),('8975','2013-03-02','13:30:00',4.23),('8975','2013-03-02','13:35:00',4.23),('8975','2013-03-02','13:40:00',4.23),('8975','2013-03-02','13:45:00',4.14),('8975','2013-03-02','13:50:00',4.04),('8975','2013-03-02','13:55:00',3.77),('8975','2013-03-02','14:00:00',3.69),('8975','2013-03-02','14:05:00',3.65),('8975','2013-03-02','14:10:00',3.55),('8975','2013-03-02','14:15:00',3.41),('8975','2013-03-02','14:20:00',3.37),('8975','2013-03-02','14:25:00',3.21),('8975','2013-03-02','14:30:00',3.01),('8975','2013-03-02','14:35:00',3.01),('8975','2013-03-02','14:40:00',2.95),('8975','2013-03-02','14:45:00',2.84),('8975','2013-03-02','14:50:00',2.76),('8975','2013-03-02','14:55:00',2.66),('8975','2013-03-02','15:00:00',2.53),('8975','2013-03-02','15:05:00',2.47),('8975','2013-03-02','15:10:00',2.38),('8975','2013-03-02','15:15:00',2.29),('8975','2013-03-02','15:20:00',2.15),('8975','2013-03-02','15:25:00',2.06),('8975','2013-03-02','15:30:00',1.98),('8975','2013-03-02','15:35:00',1.87),('8975','2013-03-02','15:40:00',1.81),('8975','2013-03-02','15:45:00',1.73),('8975','2013-03-02','15:50:00',1.67),('8975','2013-03-02','15:55:00',1.62),('8975','2013-03-02','16:00:00',1.56),('8975','2013-03-02','16:05:00',1.52),('8975','2013-03-02','16:10:00',1.48),('8975','2013-03-02','16:15:00',1.44),('8975','2013-03-02','16:20:00',1.4),('8975','2013-03-02','16:25:00',1.36),('8975','2013-03-02','16:30:00',1.31),('8975','2013-03-02','16:35:00',1.25),('8975','2013-03-02','16:40:00',1.21),('8975','2013-03-02','16:45:00',1.15),('8975','2013-03-02','16:50:00',1.09),('8975','2013-03-02','16:55:00',1.03),('8975','2014-03-23','07:45:00',1.98),('8975','2014-03-23','07:50:00',1.48),('8975','2014-03-23','07:55:00',1.2),('8975','2014-03-23','08:35:00',1.31),('8975','2014-03-23','08:40:00',1.31),('8975','2014-03-23','08:45:00',1.16),('8975','2014-03-23','08:50:00',1.52),('8975','2014-03-23','08:55:00',2.66),('8975','2014-03-23','09:00:00',3.12),('8975','2014-03-23','09:05:00',1.54),('8975','2014-03-23','09:15:00',2.66),('8975','2014-03-23','09:20:00',1.57),('8975','2014-03-23','09:25:00',1.48),('8975','2014-03-23','09:30:00',2.22),('8975','2014-03-23','09:35:00',1.55),('8975','2014-03-23','09:40:00',2.8),('8975','2014-03-23','09:45:00',1.33),('8975','2014-03-23','09:50:00',1.53),('8975','2014-03-23','09:55:00',1.53),('8975','2014-03-23','10:00:00',3.44),('8975','2014-03-23','10:05:00',3.74),('8975','2014-03-23','10:10:00',7.26),('8975','2014-03-23','10:15:00',4.03),('8975','2014-03-23','10:20:00',1.56),('8975','2014-03-23','10:25:00',1.07),('8975','2014-03-23','10:30:00',1.22),('8975','2014-03-23','10:35:00',3.83),('8975','2014-03-23','10:40:00',1.89),('8975','2014-03-23','10:45:00',4.08),('8975','2014-03-23','10:50:00',6.34),('8975','2014-03-23','10:55:00',2.29),('8975','2014-03-23','11:00:00',3.95),('8975','2014-03-23','11:05:00',3.63),('8975','2014-03-23','11:10:00',4.78),('8975','2014-03-23','11:15:00',4.73),('8975','2014-03-23','11:20:00',3.08),('8975','2014-03-23','11:25:00',4.73),('8975','2014-03-23','11:30:00',6.47),('8975','2014-03-23','11:35:00',2.06),('8975','2014-03-23','11:40:00',1.37),('8975','2014-03-23','11:45:00',1.01),('8975','2014-03-23','11:55:00',1.36),('8975','2014-03-23','12:00:00',1.1),('8975','2014-03-23','12:20:00',1.25),('8975','2014-03-23','12:25:00',1.31),('8975','2014-03-23','12:30:00',1.66),('8975','2014-03-23','12:35:00',2.62),('8975','2014-03-23','12:40:00',2.88),('8975','2014-03-23','12:45:00',2.69),('8975','2014-03-23','12:50:00',2.17),('8975','2014-03-23','12:55:00',1.96),('8975','2014-03-23','13:00:00',2.04),('8975','2014-03-23','13:05:00',1.91),('8975','2014-03-23','13:10:00',1.57),('8975','2014-03-23','13:25:00',1.24),('8975','2014-03-23','13:30:00',1.92),('8975','2014-03-23','13:35:00',1.72),('8975','2014-03-23','13:40:00',1.18),('8975','2014-03-23','13:45:00',1.5),('8975','2014-03-23','13:50:00',2.04),('8975','2014-03-23','13:55:00',1.92),('8975','2014-03-23','14:00:00',1.79),('8975','2014-03-23','14:05:00',1.57),('8975','2014-03-23','14:10:00',2.03),('8975','2014-03-23','14:15:00',2.77),('8975','2014-03-23','14:20:00',3.27),('8975','2014-03-23','14:25:00',2.99),('8975','2014-03-23','14:30:00',2.98),('8975','2014-03-23','14:35:00',3.18),('8975','2014-03-23','14:40:00',3.58),('8975','2014-03-23','14:45:00',3.65),('8975','2014-03-23','14:50:00',3.5),('8975','2014-03-23','14:55:00',3.13),('8975','2014-03-23','15:00:00',2.78),('8975','2014-03-23','15:05:00',2.75),('8975','2014-03-23','15:10:00',2.35),('8975','2014-03-23','15:15:00',2.34),('8975','2014-03-23','15:20:00',2.09),('8975','2014-03-23','15:25:00',1.99),('8975','2014-03-23','15:30:00',2.36),('8975','2014-03-23','15:35:00',2.25),('8975','2014-03-23','15:40:00',1.92),('8975','2014-03-23','15:45:00',1.41),('8975','2014-03-23','15:50:00',1.6),('8975','2014-03-23','15:55:00',1.95),('8975','2014-03-23','16:00:00',2.4),('8975','2014-03-23','16:05:00',1.8),('8975','2014-03-23','16:10:00',1.59),('8975','2014-03-23','16:15:00',1.51),('8975','2013-03-01','09:45:00',1.17),('8975','2013-03-01','09:50:00',1.21),('8975','2013-03-01','09:55:00',1.06),('8975','2013-03-01','10:00:00',1.09),('8975','2013-03-01','10:05:00',1.13),('8975','2013-03-01','10:15:00',1.02),('8975','2013-03-01','10:20:00',1.2),('8975','2013-03-01','10:25:00',1.11),('8975','2013-03-01','10:30:00',1.14),('8975','2013-03-01','10:35:00',1.33),('8975','2013-03-01','10:40:00',1.46),('8975','2013-03-01','10:45:00',1.46),('8975','2013-03-01','10:50:00',1.63),('8975','2013-03-01','10:55:00',1.7),('8975','2013-03-01','11:00:00',1.78),('8975','2013-03-01','11:05:00',1.47),('8975','2013-03-01','11:10:00',1.75),('8975','2013-03-01','11:15:00',2.05),('8975','2013-03-01','11:20:00',1.96),('8975','2013-03-01','11:25:00',1.64),('8975','2013-03-01','11:30:00',1.49),('8975','2013-03-01','11:35:00',1.59),('8975','2013-03-01','11:40:00',1.68),('8975','2013-03-01','11:45:00',1.53),('8975','2013-03-01','11:50:00',1.61),('8975','2013-03-01','11:55:00',1.49),('8975','2013-03-01','12:00:00',1.51),('8975','2013-03-01','12:05:00',1.77),('8975','2013-03-01','12:10:00',1.79),('8975','2013-03-01','12:15:00',1.88),('8975','2013-03-01','12:20:00',1.6),('8975','2013-03-01','12:25:00',1.76),('8975','2013-03-01','12:30:00',2.09),('8975','2013-03-01','12:35:00',2.11),('8975','2013-03-01','12:40:00',2.37),('8975','2013-03-01','12:45:00',2.23),('8975','2013-03-01','12:50:00',2.24),('8975','2013-03-01','12:55:00',2.94),('8975','2013-03-01','13:00:00',3.43),('8975','2013-03-01','13:05:00',3.59),('8975','2013-03-01','13:10:00',2.28),('8975','2013-03-01','13:15:00',1.65),('8975','2013-03-01','13:20:00',1.53),('8975','2013-03-01','13:25:00',1.54),('8975','2013-03-01','13:30:00',1.56),('8975','2013-03-01','13:35:00',1.6),('8975','2013-03-01','13:40:00',1.67),('8975','2013-03-01','13:45:00',1.78),('8975','2013-03-01','13:50:00',1.75),('8975','2013-03-01','13:55:00',1.79),('8975','2013-03-01','14:00:00',2.02),('8975','2013-03-01','14:05:00',2.07),('8975','2013-03-01','14:10:00',1.9),('8975','2013-03-01','14:15:00',1.67),('8975','2013-03-01','14:20:00',1.62),('8975','2013-03-01','14:25:00',1.49),('8975','2013-03-01','14:30:00',1.05),('8975','2013-03-01','14:55:00',1.18),('8975','2013-03-01','15:00:00',1.22),('8975','2013-03-01','15:05:00',1.31),('8975','2013-03-01','15:10:00',1.31),('8975','2013-03-01','15:15:00',1.32),('8975','2013-03-01','15:20:00',1.29),('8975','2013-03-01','15:25:00',1.17),('8975','2013-03-01','15:30:00',1.34),('8975','2013-03-01','15:35:00',1.38),('8975','2013-03-01','15:40:00',1.28),('8975','2013-03-01','15:45:00',1.31),('8975','2013-03-01','15:50:00',1.14),('8975','2013-03-01','15:55:00',1.11),('8975','2013-03-01','16:00:00',1.09),('8975','2013-02-28','07:45:00',1.17),('8975','2013-02-28','07:50:00',1.54),('8975','2013-02-28','07:55:00',1.94),('8975','2013-02-28','08:00:00',2.08),('8975','2013-02-28','08:05:00',1.99),('8975','2013-02-28','08:10:00',1.86),('8975','2013-02-28','08:15:00',2.07),('8975','2013-02-28','08:20:00',2.16),('8975','2013-02-28','08:25:00',2.18),('8975','2013-02-28','08:30:00',2.36),('8975','2013-02-28','08:35:00',2.55),('8975','2013-02-28','08:40:00',2.91),('8975','2013-02-28','08:45:00',3),('8975','2013-02-28','08:50:00',2.94),('8975','2013-02-28','08:55:00',3.03),('8975','2013-02-28','09:00:00',3.3),('8975','2013-02-28','09:05:00',3.32),('8975','2013-02-28','09:10:00',3.13),('8975','2013-02-28','09:15:00',3.33),('8975','2013-02-28','09:20:00',3.36),('8975','2013-02-28','09:25:00',3.46),('8975','2013-02-28','09:30:00',3.73),('8975','2013-02-28','09:35:00',3.88),('8975','2013-02-28','09:40:00',4.03),('8975','2013-02-28','09:45:00',4.04),('8975','2013-02-28','09:50:00',4),('8975','2013-02-28','09:55:00',4.05),('8975','2013-02-28','10:00:00',4.13),('8975','2013-02-28','10:05:00',3.68),('8975','2013-02-28','10:10:00',3.23),('8975','2013-02-28','10:15:00',3.37),('8975','2013-02-28','10:20:00',3.77),('8975','2013-02-28','10:25:00',3.95),('8975','2013-02-28','10:30:00',4.2),('8975','2013-02-28','10:35:00',3.92),('8975','2013-02-28','10:40:00',3.68),('8975','2013-02-28','10:45:00',3.26),('8975','2013-02-28','10:50:00',3.07),('8975','2013-02-28','10:55:00',2.75),('8975','2013-02-28','11:00:00',2.48),('8975','2013-02-28','11:05:00',2.37),('8975','2013-02-28','11:10:00',2.62),('8975','2013-02-28','11:15:00',2.86),('8975','2013-02-28','11:20:00',2.88),('8975','2013-02-28','11:25:00',2.92),('8975','2013-02-28','11:30:00',3.01),('8975','2013-02-28','11:35:00',2.88),('8975','2013-02-28','11:40:00',2.74),('8975','2013-02-28','11:45:00',2.7),('8975','2013-02-28','11:50:00',2.59),('8975','2013-02-28','11:55:00',2.51),('8975','2013-02-28','12:00:00',2.43),('8975','2013-02-28','12:05:00',2.29),('8975','2013-02-28','12:10:00',2.12),('8975','2013-02-28','12:15:00',1.9),('8975','2013-02-28','12:20:00',1.8),('8975','2013-02-28','12:25:00',1.83),('8975','2013-02-28','12:30:00',1.87),('8975','2013-02-28','12:35:00',1.82),('8975','2013-02-28','12:40:00',1.79),('8975','2013-02-28','12:45:00',1.81),('8975','2013-02-28','12:50:00',1.86),('8975','2013-02-28','12:55:00',1.99),('8975','2013-02-28','13:00:00',2.07),('8975','2013-02-28','13:05:00',2.09),('8975','2013-02-28','13:10:00',2.17),('8975','2013-02-28','13:15:00',2.32),('8975','2013-02-28','13:20:00',2.53),('8975','2013-02-28','13:25:00',2.64),('8975','2013-02-28','13:30:00',2.53),('8975','2013-02-28','13:35:00',2.39),('8975','2013-02-28','13:40:00',2.32),('8975','2013-02-28','13:45:00',2.33),('8975','2013-02-28','13:50:00',2.27),('8975','2013-02-28','13:55:00',2.18),('8975','2013-02-28','14:00:00',2.1),('8975','2013-02-28','14:05:00',2),('8975','2013-02-28','14:10:00',1.87),('8975','2013-02-28','14:15:00',1.78),('8975','2013-02-28','14:20:00',1.73),('8975','2013-02-28','14:25:00',1.74),('8975','2013-02-28','14:30:00',1.79),('8975','2013-02-28','14:35:00',1.77),('8975','2013-02-28','14:40:00',1.69),('8975','2013-02-28','14:45:00',1.58),('8975','2013-02-28','14:50:00',1.52),('8975','2013-02-28','14:55:00',1.52),('8975','2013-02-28','15:00:00',1.51),('8975','2013-02-28','15:05:00',1.42),('8975','2013-02-28','15:10:00',1.29),('8975','2013-02-28','15:15:00',1.24),('8975','2013-02-28','15:20:00',1.15),('8975','2013-02-28','15:25:00',1.02),('8975','2013-02-28','15:40:00',1.06),('8975','2013-02-28','15:45:00',1.02),('8975','2013-02-27','07:25:00',1.12),('8975','2013-02-27','07:30:00',1.31),('8975','2013-02-27','07:35:00',1.5),('8975','2013-02-27','07:40:00',1.68),('8975','2013-02-27','07:45:00',1.85),('8975','2013-02-27','07:50:00',1.97),('8975','2013-02-27','07:55:00',2.13),('8975','2013-02-27','08:00:00',2.27),('8975','2013-02-27','08:05:00',2.41),('8975','2013-02-27','08:10:00',2.55),('8975','2013-02-27','08:15:00',2.67),('8975','2013-02-27','08:20:00',2.77),('8975','2013-02-27','08:25:00',2.91),('8975','2013-02-27','08:30:00',3),('8975','2013-02-27','08:35:00',3.1),('8975','2013-02-27','08:40:00',3.2),('8975','2013-02-27','08:45:00',3.31),('8975','2013-02-27','08:50:00',3.39),('8975','2013-02-27','08:55:00',3.51),('8975','2013-02-27','09:00:00',3.61),('8975','2013-02-27','09:05:00',3.68),('8975','2013-02-27','09:10:00',3.7),('8975','2013-02-27','09:15:00',3.86),('8975','2013-02-27','09:20:00',3.94),('8975','2013-02-27','09:25:00',4.02),('8975','2013-02-27','09:30:00',4.11),('8975','2013-02-27','09:35:00',4.2),('8975','2013-02-27','09:40:00',4.27),('8975','2013-02-27','09:45:00',4.38),('8975','2013-02-27','09:50:00',4.21),('8975','2013-02-27','09:55:00',4.45),('8975','2013-02-27','10:00:00',4.47),('8975','2013-02-27','10:05:00',4.41),('8975','2013-02-27','10:10:00',4.65),('8975','2013-02-27','10:15:00',4.73),('8975','2013-02-27','10:20:00',4.73),('8975','2013-02-27','10:25:00',4.73),('8975','2013-02-27','10:30:00',4.68),('8975','2013-02-27','10:35:00',4.85),('8975','2013-02-27','10:40:00',4.7),('8975','2013-02-27','10:45:00',4.9),('8975','2013-02-27','10:50:00',4.9),('8975','2013-02-27','10:55:00',4.94),('8975','2013-02-27','11:00:00',4.99),('8975','2013-02-27','11:05:00',4.99),('8975','2013-02-27','11:10:00',5.04),('8975','2013-02-27','11:15:00',4.98),('8975','2013-02-27','11:20:00',5.01),('8975','2013-02-27','11:25:00',5.09),('8975','2013-02-27','11:30:00',5.01),('8975','2013-02-27','11:35:00',5),('8975','2013-02-27','11:40:00',4.96),('8975','2013-02-27','11:45:00',5.03),('8975','2013-02-27','11:50:00',4.99),('8975','2013-02-27','11:55:00',5.01),('8975','2013-02-27','12:00:00',4.89),('8975','2013-02-27','12:05:00',4.77),('8975','2013-02-27','12:10:00',3.52),('8975','2013-02-27','12:15:00',4.68),('8975','2013-02-27','12:20:00',4.22),('8975','2013-02-27','12:25:00',4.61),('8975','2013-02-27','12:30:00',4.7),('8975','2013-02-27','12:35:00',4.66),('8975','2013-02-27','12:40:00',4.16),('8975','2013-02-27','12:45:00',4.5),('8975','2013-02-27','12:50:00',4.48),('8975','2013-02-27','12:55:00',4.59),('8975','2013-02-27','13:00:00',4.37),('8975','2013-02-27','13:05:00',4.25),('8975','2013-02-27','13:10:00',3.36),('8975','2013-02-27','13:15:00',2.42),('8975','2013-02-27','13:20:00',4),('8975','2013-02-27','13:25:00',3.75),('8975','2013-02-27','13:30:00',1.53),('8975','2013-02-27','13:35:00',1.14),('8975','2013-02-27','13:40:00',1.23),('8975','2013-02-27','13:45:00',3.15),('8975','2013-02-27','13:50:00',2.13),('8975','2013-02-27','13:55:00',2.83),('8975','2013-02-27','14:00:00',3.28),('8975','2013-02-27','14:05:00',3.25),('8975','2013-02-27','14:10:00',3.29),('8975','2013-02-27','14:15:00',3.38),('8975','2013-02-27','14:20:00',3.12),('8975','2013-02-27','14:25:00',3.01),('8975','2013-02-27','14:30:00',2.87),('8975','2013-02-27','14:35:00',2.58),('8975','2013-02-27','14:40:00',2.79),('8975','2013-02-27','14:45:00',2.68),('8975','2013-02-27','14:50:00',2.57),('8975','2013-02-27','14:55:00',2.49),('8975','2013-02-27','15:00:00',2.38),('8975','2013-02-27','15:05:00',2.28),('8975','2013-02-27','15:10:00',2.17),('8975','2013-02-27','15:15:00',2.07),('8975','2013-02-27','15:20:00',1.96),('8975','2013-02-27','15:25:00',1.87),('8975','2013-02-27','15:30:00',1.81),('8975','2013-02-27','15:35:00',1.71),('8975','2013-02-27','15:40:00',1.66),('8975','2013-02-27','15:45:00',1.62),('8975','2013-02-27','15:50:00',1.57),('8975','2013-02-27','15:55:00',1.5),('8975','2013-02-27','16:00:00',1.46),('8975','2013-02-27','16:05:00',1.42),('8975','2013-02-27','16:10:00',1.36),('8975','2013-02-27','16:15:00',1.31),('8975','2013-02-27','16:20:00',1.26),('8975','2013-02-27','16:25:00',1.2),('8975','2013-02-27','16:30:00',1.14),('8975','2013-02-27','16:35:00',1.1),('8975','2013-02-27','16:40:00',1.04),('8975','2013-02-26','07:30:00',1.21),('8975','2013-02-26','07:35:00',1.39),('8975','2013-02-26','07:40:00',1.56),('8975','2013-02-26','07:45:00',1.73),('8975','2013-02-26','07:50:00',1.88),('8975','2013-02-26','07:55:00',2.06),('8975','2013-02-26','08:00:00',2.24),('8975','2013-02-26','08:05:00',2.36),('8975','2013-02-26','08:10:00',2.46),('8975','2013-02-26','08:15:00',2.56),('8975','2013-02-26','08:20:00',2.68),('8975','2013-02-26','08:25:00',2.78),('8975','2013-02-26','08:30:00',2.88),('8975','2013-02-26','08:35:00',2.99),('8975','2013-02-26','08:40:00',3.1),('8975','2013-02-26','08:45:00',3.2),('8975','2013-02-26','08:50:00',3.3),('8975','2013-02-26','08:55:00',3.38),('8975','2013-02-26','09:00:00',3.46),('8975','2013-02-26','09:05:00',3.56),('8975','2013-02-26','09:10:00',3.67),('8975','2013-02-26','09:15:00',3.79),('8975','2013-02-26','09:20:00',3.83),('8975','2013-02-26','09:25:00',3.87),('8975','2013-02-26','09:30:00',3.99),('8975','2013-02-26','09:35:00',4.1),('8975','2013-02-26','09:40:00',4.21),('8975','2013-02-26','09:45:00',4.29),('8975','2013-02-26','09:50:00',4.36),('8975','2013-02-26','09:55:00',4.43),('8975','2013-02-26','10:00:00',4.48),('8975','2013-02-26','10:05:00',4.37),('8975','2013-02-26','10:10:00',4.57),('8975','2013-02-26','10:15:00',4.63),('8975','2013-02-26','10:20:00',4.71),('8975','2013-02-26','10:25:00',4.72),('8975','2013-02-26','10:30:00',4.84),('8975','2013-02-26','10:35:00',4.83),('8975','2013-02-26','10:40:00',4.93),('8975','2013-02-26','10:45:00',4.89),('8975','2013-02-26','10:50:00',4.94),('8975','2013-02-26','10:55:00',4.97),('8975','2013-02-26','11:00:00',5.02),('8975','2013-02-26','11:05:00',5.07),('8975','2013-02-26','11:10:00',4.32),('8975','2013-02-26','11:15:00',4.33),('8975','2013-02-26','11:20:00',5.23),('8975','2013-02-26','11:25:00',5.2),('8975','2013-02-26','11:30:00',5.26),('8975','2013-02-26','11:35:00',5.4),('8975','2013-02-26','11:40:00',5.41),('8975','2013-02-26','11:45:00',5.43),('8975','2013-02-26','11:50:00',5.35),('8975','2013-02-26','11:55:00',5.44),('8975','2013-02-26','12:00:00',5.45),('8975','2013-02-26','12:05:00',5.33),('8975','2013-02-26','12:10:00',4.7),('8975','2013-02-26','12:15:00',5.13),('8975','2013-02-26','12:20:00',5.33),('8975','2013-02-26','12:25:00',3.4),('8975','2013-02-26','12:30:00',4.75),('8975','2013-02-26','12:35:00',4.85),('8975','2013-02-26','12:40:00',4.67),('8975','2013-02-26','12:45:00',3.73),('8975','2013-02-26','12:50:00',3.72),('8975','2013-02-26','12:55:00',4.66),('8975','2013-02-26','13:00:00',4.72),('8975','2013-02-26','13:05:00',4.47),('8975','2013-02-26','13:10:00',4.29),('8975','2013-02-26','13:15:00',4.37),('8975','2013-02-26','13:20:00',4.37),('8975','2013-02-26','13:25:00',4.22),('8975','2013-02-26','13:30:00',4.36),('8975','2013-02-26','13:35:00',4.19),('8975','2013-02-26','13:40:00',4.11),('8975','2013-02-26','13:45:00',4.09),('8975','2013-02-26','13:50:00',4.08),('8975','2013-02-26','13:55:00',3.69),('8975','2013-02-26','14:00:00',3.57),('8975','2013-02-26','14:05:00',3.57),('8975','2013-02-26','14:10:00',3.52),('8975','2013-02-26','14:15:00',3.44),('8975','2013-02-26','14:20:00',3.2),('8975','2013-02-26','14:25:00',2.84),('8975','2013-02-26','14:30:00',1.94),('8975','2013-02-26','14:35:00',2.79),('8975','2013-02-26','14:40:00',2.94),('8975','2013-02-26','14:45:00',2.83),('8975','2013-02-26','14:50:00',2.75),('8975','2013-02-26','14:55:00',2.59),('8975','2013-02-26','15:00:00',2.49),('8975','2013-02-26','15:05:00',2.37),('8975','2013-02-26','15:10:00',2.24),('8975','2013-02-26','15:15:00',2.09),('8975','2013-02-26','15:20:00',2.02),('8975','2013-02-26','15:25:00',1.93),('8975','2013-02-26','15:30:00',1.85),('8975','2013-02-26','15:35:00',1.77),('8975','2013-02-26','15:40:00',1.72),('8975','2013-02-26','15:45:00',1.64),('8975','2013-02-26','15:50:00',1.59),('8975','2013-02-26','15:55:00',1.54),('8975','2013-02-26','16:00:00',1.48),('8975','2013-02-26','16:05:00',1.46),('8975','2013-02-26','16:10:00',1.41),('8975','2013-02-26','16:15:00',1.35),('8975','2013-02-26','16:20:00',1.3),('8975','2013-02-26','16:25:00',1.24),('8975','2013-02-26','16:30:00',1.19),('8975','2013-02-26','16:35:00',1.13),('8975','2013-02-26','16:40:00',1.07),('8975','2013-02-26','16:45:00',1),('8975','2013-02-25','08:55:00',1.15),('8975','2013-02-25','09:00:00',1.27),('8975','2013-02-25','09:05:00',1.39),('8975','2013-02-25','09:10:00',1.53),('8975','2013-02-25','09:15:00',1.62),('8975','2013-02-25','09:20:00',1.75),('8975','2013-02-25','09:25:00',1.94),('8975','2013-02-25','09:30:00',2.28),('8975','2013-02-25','09:35:00',2.71),('8975','2013-02-25','09:40:00',2.9),('8975','2013-02-25','09:45:00',2.89),('8975','2013-02-25','09:50:00',3.21),('8975','2013-02-25','09:55:00',3.26),('8975','2013-02-25','10:00:00',3.46),('8975','2013-02-25','10:05:00',3.25),('8975','2013-02-25','10:10:00',3.84),('8975','2013-02-25','10:15:00',4.4),('8975','2013-02-25','10:20:00',5.15),('8975','2013-02-25','10:25:00',4.81),('8975','2013-02-25','10:30:00',4.12),('8975','2013-02-25','10:35:00',2.84),('8975','2013-02-25','10:40:00',2.36),('8975','2013-02-25','10:45:00',2.38),('8975','2013-02-25','10:50:00',2.58),('8975','2013-02-25','10:55:00',2.62),('8975','2013-02-25','11:00:00',2.59),('8975','2013-02-25','11:05:00',2.51),('8975','2013-02-25','11:10:00',3.29),('8975','2013-02-25','11:15:00',2.94),('8975','2013-02-25','11:21:00',2.93),('8975','2013-02-25','11:25:00',2.77),('8975','2013-02-25','11:30:00',2.67),('8975','2013-02-25','11:35:00',2.46),('8975','2013-02-25','11:40:00',2.44),('8975','2013-02-25','11:45:00',2.99),('8975','2013-02-25','11:50:00',2.56),('8975','2013-02-25','11:55:00',2.45),('8975','2013-02-25','12:00:00',2.23),('8975','2013-02-25','12:05:00',2.1),('8975','2013-02-25','12:10:00',2.26),('8975','2013-02-25','12:15:00',2.32),('8975','2013-02-25','12:20:00',2.3),('8975','2013-02-25','12:25:00',2.2),('8975','2013-02-25','12:30:00',2.06),('8975','2013-02-25','12:35:00',1.87),('8975','2013-02-25','12:40:00',1.78),('8975','2013-02-25','12:45:00',1.64),('8975','2013-02-25','12:50:00',1.5),('8975','2013-02-25','12:55:00',1.67),('8975','2013-02-25','13:00:00',1.63),('8975','2013-02-25','13:05:00',1.43),('8975','2013-02-25','13:10:00',1.3),('8975','2013-02-25','13:15:00',1.35),('8975','2013-02-25','13:20:00',1.43),('8975','2013-02-25','13:25:00',1.5),('8975','2013-02-25','13:30:00',1.5),('8975','2013-02-25','13:35:00',1.52),('8975','2013-02-25','13:40:00',1.48),('8975','2013-02-25','13:45:00',1.42),('8975','2013-02-25','13:50:00',1.36),('8975','2013-02-25','13:55:00',1.39),('8975','2013-02-25','14:00:00',1.43),('8975','2013-02-25','14:05:00',1.34),('8975','2013-02-25','14:10:00',1.5),('8975','2013-02-25','14:15:00',1.53),('8975','2013-02-24','08:35:00',1.45),('8975','2013-02-24','08:40:00',1.85),('8975','2013-02-24','08:45:00',1.83),('8975','2013-02-24','08:50:00',1.51),('8975','2013-02-24','08:55:00',2.24),('8975','2013-02-24','09:00:00',1.71),('8975','2013-02-24','09:05:00',1.33),('8975','2013-02-24','09:10:00',1.46),('8975','2013-02-24','09:15:00',1.44),('8975','2013-02-24','09:20:00',1.84),('8975','2013-02-24','09:25:00',2.35),('8975','2013-02-24','09:30:00',2.24),('8975','2013-02-24','09:35:00',1.88),('8975','2013-02-24','09:40:00',1.44),('8975','2013-02-24','09:45:00',1.32),('8975','2013-02-24','10:40:00',1.86),('8975','2013-02-24','10:45:00',3.52),('8975','2013-02-24','10:50:00',6.26),('8975','2013-02-24','10:55:00',6.76),('8975','2013-02-24','11:00:00',5.1),('8975','2013-02-24','11:05:00',2.97),('8975','2013-02-24','11:10:00',2.37),('8975','2013-02-24','11:15:00',2.38),('8975','2013-02-24','11:20:00',1.92),('8975','2013-02-24','11:25:00',1.86),('8975','2013-02-24','11:30:00',1.99),('8975','2013-02-24','11:35:00',1.99),('8975','2013-02-24','11:40:00',2.35),('8975','2013-02-24','11:45:00',3.1),('8975','2013-02-24','11:50:00',6.93),('8975','2013-02-24','11:55:00',5.86),('8975','2013-02-24','12:00:00',4.49),('8975','2013-02-24','12:05:00',3.67),('8975','2013-02-24','12:10:00',3.63),('8975','2013-02-24','12:15:00',3.35),('8975','2013-02-24','12:20:00',4.89),('8975','2013-02-24','12:25:00',5.33),('8975','2013-02-24','12:30:00',5.39),('8975','2013-02-24','12:35:00',5.8),('8975','2013-02-24','12:40:00',3.85),('8975','2013-02-24','12:45:00',4.67),('8975','2013-02-24','12:50:00',4.82),('8975','2013-02-24','12:55:00',4.66),('8975','2013-02-24','13:00:00',4.4),('8975','2013-02-24','13:05:00',3.62),('8975','2013-02-24','13:10:00',3.96),('8975','2013-02-24','13:15:00',3.11),('8975','2013-02-24','13:20:00',2.13),('8975','2013-02-24','13:25:00',2.27),('8975','2013-02-24','13:30:00',1.76),('8975','2013-02-24','13:35:00',1.58),('8975','2013-02-24','13:40:00',1.34),('8975','2013-02-24','13:45:00',1.22),('8975','2013-02-24','13:50:00',1.22),('8975','2013-02-24','13:55:00',1.09),('8975','2013-02-24','14:30:00',1.04),('8975','2013-02-24','14:35:00',1.42),('8975','2013-02-24','14:40:00',1.34),('8975','2013-02-24','14:45:00',1.23),('8975','2013-02-24','14:50:00',1.21),('8975','2013-02-24','14:55:00',1.31),('8975','2013-02-24','15:00:00',1.25),('8975','2013-02-24','15:05:00',1.19),('8975','2013-02-24','15:15:00',1.02),('8975','2013-02-24','16:35:00',1.07),('8975','2013-02-24','16:55:00',1.15),('8975','2013-02-23','08:00:00',1.74),('8975','2013-02-23','08:05:00',1.12),('8975','2013-02-23','08:30:00',1.05),('8975','2013-02-23','08:45:00',1.06),('8975','2013-02-23','08:50:00',1.2),('8975','2013-02-23','08:55:00',1.46),('8975','2013-02-23','09:00:00',1.06),('8975','2013-02-23','10:30:00',1.03),('8975','2013-02-23','10:35:00',1.17),('8975','2013-02-23','10:40:00',1.53),('8975','2013-02-23','10:45:00',1.71),('8975','2013-02-23','10:50:00',2.66),('8975','2013-02-23','10:55:00',2.27),('8975','2013-02-23','11:00:00',1.61),('8975','2013-02-23','11:05:00',1.64),('8975','2013-02-23','11:10:00',1.64),('8975','2013-02-23','11:15:00',1.61),('8975','2013-02-23','11:20:00',1.47),('8975','2013-02-23','11:25:00',1.51),('8975','2013-02-23','11:30:00',1.51),('8975','2013-02-23','11:35:00',1.26),('8975','2013-02-23','11:40:00',1.45),('8975','2013-02-23','11:45:00',1.38),('8975','2013-02-23','11:50:00',1.47),('8975','2013-02-23','11:55:00',1.31),('8975','2013-02-23','12:00:00',1.29),('8975','2013-02-23','12:05:00',1.32),('8975','2013-02-23','12:10:00',1.08),('8975','2013-02-23','12:30:00',1.04),('8975','2013-02-23','12:35:00',1.83),('8975','2013-02-23','12:40:00',1.77),('8975','2013-02-23','12:45:00',2.01),('8975','2013-02-23','12:50:00',2.12),('8975','2013-02-23','12:55:00',2.32),('8975','2013-02-23','13:00:00',2.65),('8975','2013-02-23','13:05:00',2.22),('8975','2013-02-23','13:10:00',2.55),('8975','2013-02-23','13:15:00',2.08),('8975','2013-02-23','13:20:00',2.41),('8975','2013-02-23','13:25:00',1.74),('8975','2013-02-23','13:30:00',1.68),('8975','2013-02-23','13:35:00',1.85),('8975','2013-02-23','13:40:00',2.69),('8975','2013-02-23','13:45:00',1.95),('8975','2013-02-23','13:50:00',1.42),('8975','2013-02-23','13:55:00',1.45),('8975','2013-02-23','14:00:00',1.45),('8975','2013-02-23','14:05:00',2.67),('8975','2013-02-23','14:10:00',2.07),('8975','2013-02-23','14:15:00',1.65),('8975','2013-02-23','14:20:00',1.63),('8975','2013-02-23','14:25:00',1.43),('8975','2013-02-23','14:30:00',1.69),('8975','2013-02-23','14:35:00',1.62),('8975','2013-02-23','14:40:00',1.27),('8975','2013-02-23','14:45:00',1.35),('8975','2013-02-23','14:50:00',1.05),('8975','2013-02-23','15:00:00',1.39),('8975','2013-02-23','15:05:00',1.56),('8975','2013-02-23','15:10:00',1.99),('8975','2013-02-23','15:15:00',1.43),('8975','2013-02-23','15:20:00',1.96),('8975','2013-02-23','15:25:00',2.16),('8975','2013-02-23','15:30:00',2.34),('8975','2013-02-23','15:35:00',2.17),('8975','2013-02-23','15:40:00',1.83),('8975','2013-02-23','15:45:00',1.41),('8975','2013-02-23','15:50:00',1.38),('8975','2013-02-23','15:55:00',1.09),('8975','2013-02-23','16:00:00',1.91),('8975','2013-02-23','16:40:00',1.06),('8975','2013-02-23','16:45:00',1.01),('8975','2013-02-22','07:25:00',1.16),('8975','2013-02-22','07:30:00',1.5),('8975','2013-02-22','07:35:00',1.71),('8975','2013-02-22','07:40:00',1.89),('8975','2013-02-22','07:45:00',2.08),('8975','2013-02-22','07:50:00',2.25),('8975','2013-02-22','07:55:00',2.44),('8975','2013-02-22','08:00:00',2.58),('8975','2013-02-22','08:05:00',2.71),('8975','2013-02-22','08:10:00',2.31),('8975','2013-02-22','08:15:00',3.54),('8975','2013-02-22','08:20:00',1.61),('8975','2013-02-22','08:25:00',1.16),('8975','2013-02-22','08:30:00',1.08),('8975','2013-02-22','08:45:00',1.04),('8975','2013-02-22','08:50:00',1.39),('8975','2013-02-22','08:55:00',1.76),('8975','2013-02-22','09:00:00',1.93),('8975','2013-02-22','09:05:00',2.04),('8975','2013-02-22','09:10:00',1.59),('8975','2013-02-22','09:15:00',1.31),('8975','2013-02-22','09:30:00',1.24),('8975','2013-02-22','09:35:00',1.53),('8975','2013-02-22','09:40:00',1.96),('8975','2013-02-22','09:45:00',2.39),('8975','2013-02-22','09:50:00',2.29),('8975','2013-02-22','09:55:00',2.15),('8975','2013-02-22','10:00:00',1.72),('8975','2013-02-22','10:05:00',1.57),('8975','2013-02-22','10:10:00',1.31),('8975','2013-02-22','10:15:00',1.15),('8975','2013-02-22','10:20:00',1.23),('8975','2013-02-22','10:25:00',1.59),('8975','2013-02-22','10:30:00',1.34),('8975','2013-02-22','10:35:00',1.47),('8975','2013-02-22','10:40:00',1.17),('8975','2013-02-22','10:45:00',1.27),('8975','2013-02-22','10:50:00',1.15),('8975','2013-02-22','11:20:00',1.18),('8975','2013-02-22','11:25:00',1.01),('8975','2013-02-22','11:30:00',1.04),('8975','2013-02-22','11:35:00',1.36),('8975','2013-02-22','11:40:00',1.49),('8975','2013-02-22','11:45:00',1.45),('8975','2013-02-22','11:50:00',1.11),('8975','2013-02-22','11:55:00',1.07),('8975','2013-02-22','12:00:00',1),('8975','2013-02-22','12:05:00',1.4),('8975','2013-02-22','12:10:00',1.36),('8975','2013-02-22','12:15:00',1.28),('8975','2013-02-22','12:20:00',1.4),('8975','2013-02-22','12:25:00',1.15),('8975','2013-02-22','12:30:00',1.27),('8975','2013-02-22','12:40:00',1.04),('8975','2013-02-22','12:45:00',1.22),('8975','2013-02-22','12:50:00',1.47),('8975','2013-02-22','12:55:00',1.09),('8975','2013-02-22','13:10:00',1.26),('8975','2013-02-22','13:15:00',1.29),('8975','2013-02-22','13:20:00',1.11),('8975','2013-02-22','13:25:00',1.09),('8975','2013-02-22','13:50:00',1.15),('8975','2013-02-22','13:55:00',1.9),('8975','2013-02-22','14:00:00',2.11),('8975','2013-02-22','14:05:00',2.89),('8975','2013-02-22','14:10:00',2.3),('8975','2013-02-22','14:45:00',1.52),('8975','2013-02-22','14:50:00',1.17),('8975','2013-02-21','09:35:00',1.34),('8975','2013-02-21','09:40:00',1.3),('8975','2013-02-21','09:45:00',1.05),('8975','2013-02-21','09:50:00',1.17),('8975','2013-02-21','10:00:00',1.07),('8975','2013-02-21','10:15:00',1.16),('8975','2013-02-21','11:35:00',1.01),('8975','2013-02-21','12:55:00',1.2),('8975','2013-02-21','14:10:00',1.13),('8975','2013-02-21','14:15:00',1.34),('8975','2013-02-21','14:20:00',1.27),('8975','2013-02-21','14:30:00',1.8),('8975','2013-02-21','14:35:00',1.91),('8975','2013-02-21','14:40:00',1.89),('8975','2013-02-21','14:45:00',1.42),('8975','2013-02-21','14:50:00',1.73),('8975','2013-02-21','14:55:00',1.69),('8975','2013-02-21','15:00:00',1.25),('8975','2013-02-21','15:45:00',1.01),('8975','2013-02-21','15:50:00',1.07),('8975','2013-02-21','16:15:00',1.28),('8975','2013-02-21','16:20:00',1.94),('8975','2013-02-21','16:25:00',1.81),('8975','2013-02-21','16:30:00',1.19),('8975','2013-02-20','09:45:00',1.25),('8975','2013-02-20','09:50:00',1.32),('8975','2013-02-20','09:55:00',1.31),('8975','2013-02-20','10:00:00',1.24),('8975','2013-02-20','10:05:00',1.23),('8975','2013-02-20','10:10:00',1.21),('8975','2013-02-20','10:15:00',1.18),('8975','2013-02-20','10:20:00',1.18),('8975','2013-02-20','10:25:00',1.2),('8975','2013-02-20','10:30:00',1.22),('8975','2013-02-20','10:35:00',1.25),('8975','2013-02-20','10:40:00',1.31),('8975','2013-02-20','10:45:00',1.24),('8975','2013-02-20','10:50:00',1.27),('8975','2013-02-20','10:55:00',1.22),('8975','2013-02-20','11:00:00',1.14),('8975','2013-02-20','11:05:00',1.03),('8975','2013-02-20','11:15:00',1.09),('8975','2013-02-20','11:20:00',1.27),('8975','2013-02-20','11:25:00',1.38),('8975','2013-02-20','11:30:00',1.44),('8975','2013-02-20','11:35:00',1.51),('8975','2013-02-20','11:40:00',1.52),('8975','2013-02-20','11:45:00',1.63),('8975','2013-02-20','11:50:00',1.76),('8975','2013-02-20','11:55:00',1.86),('8975','2013-02-20','12:00:00',1.79),('8975','2013-02-20','12:05:00',1.8),('8975','2013-02-20','12:10:00',1.91),('8975','2013-02-20','12:15:00',2.06),('8975','2013-02-20','12:20:00',2.19),('8975','2013-02-20','12:25:00',2.14),('8975','2013-02-20','12:30:00',2.02),('8975','2013-02-20','12:35:00',1.93),('8975','2013-02-20','12:40:00',1.87),('8975','2013-02-20','12:45:00',1.85),('8975','2013-02-20','12:50:00',1.94),('8975','2013-02-20','12:55:00',2.09),('8975','2013-02-20','13:00:00',2.07),('8975','2013-02-20','13:05:00',1.92),('8975','2013-02-20','13:10:00',1.82),('8975','2013-02-20','13:15:00',1.85),('8975','2013-02-20','13:20:00',1.88),('8975','2013-02-20','13:25:00',1.91),('8975','2013-02-20','13:30:00',1.95),('8975','2013-02-20','13:35:00',1.97),('8975','2013-02-20','13:40:00',1.93),('8975','2013-02-20','13:45:00',1.82),('8975','2013-02-20','13:50:00',1.9),('8975','2013-02-20','13:55:00',1.94),('8975','2013-02-20','14:00:00',1.91),('8975','2013-02-20','14:05:00',1.85),('8975','2013-02-20','14:10:00',1.73),('8975','2013-02-20','14:15:00',1.57),('8975','2013-02-20','14:20:00',1.39),('8975','2013-02-20','14:25:00',1.28),('8975','2013-02-20','14:30:00',1.31),('8975','2013-02-20','14:35:00',1.3),('8975','2013-02-20','14:40:00',1.2),('8975','2013-02-20','14:45:00',1.15),('8975','2013-02-20','14:50:00',1.13),('8975','2013-02-20','14:55:00',1.01),('8975','2013-02-20','15:50:00',1.01),('8975','2013-02-20','15:55:00',1.09),('8975','2013-02-20','16:00:00',1.18),('8975','2013-02-20','16:05:00',1.22),('8975','2013-02-20','16:10:00',1.21),('8975','2013-02-20','16:15:00',1.19),('8975','2013-02-20','16:20:00',1.59),('8975','2013-02-20','16:25:00',1.9),('8975','2013-02-20','16:30:00',1.78),('8975','2013-02-20','16:35:00',1.56),('8975','2013-02-20','16:40:00',1.34),('8975','2013-02-20','16:45:00',1.19),('8975','2013-02-20','16:50:00',1.04),('8975','2014-03-22','08:05:00',1),('8975','2014-03-22','08:10:00',1.11),('8975','2014-03-22','08:15:00',1.11),('8975','2014-03-22','08:20:00',1.26),('8975','2014-03-22','08:25:00',1.38),('8975','2014-03-22','08:30:00',1.59),('8975','2014-03-22','08:35:00',1.67),('8975','2014-03-22','08:40:00',1.26),('8975','2014-03-22','08:45:00',1.46),('8975','2014-03-22','08:50:00',2.06),('8975','2014-03-22','08:55:00',2.6),('8975','2014-03-22','09:00:00',1.9),('8975','2014-03-22','09:05:00',3.42),('8975','2014-03-22','09:10:00',4.65),('8975','2014-03-22','09:15:00',4.05),('8975','2014-03-22','09:20:00',2.75),('8975','2014-03-22','09:25:00',1.85),('8975','2014-03-22','09:30:00',2.26),('8975','2014-03-22','09:35:00',2.28),('8975','2014-03-22','09:40:00',1.99),('8975','2014-03-22','09:45:00',1.49),('8975','2014-03-22','09:50:00',1.37),('8975','2014-03-22','09:55:00',1.17),('8975','2014-03-22','10:00:00',1.14),('8975','2014-03-22','10:05:00',1.17),('8975','2014-03-22','10:10:00',1.38),('8975','2014-03-22','10:15:00',1.16),('8975','2014-03-22','10:20:00',1.35),('8975','2014-03-22','10:25:00',2.08),('8975','2014-03-22','10:30:00',2.05),('8975','2014-03-22','10:35:00',2.05),('8975','2014-03-22','10:40:00',2.07),('8975','2014-03-22','10:45:00',2),('8975','2014-03-22','10:50:00',2.44),('8975','2014-03-22','10:55:00',3.05),('8975','2014-03-22','11:00:00',2.27),('8975','2014-03-22','11:05:00',1.95),('8975','2014-03-22','11:10:00',2.98),('8975','2014-03-22','11:15:00',1.43),('8975','2014-03-22','11:20:00',1.12),('8975','2014-03-22','11:25:00',1.53),('8975','2014-03-22','11:30:00',1.19),('8975','2014-03-22','11:35:00',2.3),('8975','2014-03-22','11:40:00',2.69),('8975','2014-03-22','11:45:00',1.3),('8975','2014-03-22','11:55:00',1.67),('8975','2014-03-22','12:00:00',1.35),('8975','2014-03-22','12:35:00',1.12),('8975','2014-03-22','12:40:00',1.02),('8975','2014-03-22','13:40:00',1.41),('8975','2014-03-22','13:45:00',2.87),('8975','2014-03-22','13:50:00',2.31),('8975','2014-03-22','13:55:00',1.57),('8975','2014-03-22','14:00:00',1.43),('8975','2014-03-22','14:50:00',2.49),('8975','2014-03-22','14:55:00',1.37),('8975','2014-03-22','15:05:00',1.59),('8975','2014-03-22','15:10:00',2.14),('8975','2014-03-22','15:15:00',2.38),('8975','2014-03-22','15:20:00',2.87),('8975','2014-03-22','15:25:00',1.88),('8975','2014-03-22','15:30:00',1.31),('8975','2014-03-22','15:35:00',1.62),('8975','2014-03-22','15:40:00',1.05),('8975','2013-02-19','08:05:00',1.34),('8975','2013-02-19','08:10:00',2.48),('8975','2013-02-19','08:15:00',2.7),('8975','2013-02-19','08:20:00',2.75),('8975','2013-02-19','08:25:00',2.86),('8975','2013-02-19','08:30:00',2.99),('8975','2013-02-19','08:35:00',3.1),('8975','2013-02-19','08:40:00',3.19),('8975','2013-02-19','08:45:00',3.26),('8975','2013-02-19','08:50:00',3.35),('8975','2013-02-19','08:55:00',3.43),('8975','2013-02-19','09:00:00',3.35),('8975','2013-02-19','09:05:00',2.27),('8975','2013-02-19','09:10:00',2.32),('8975','2013-02-19','09:15:00',1.97),('8975','2013-02-19','09:20:00',1.94),('8975','2013-02-19','09:25:00',1.75),('8975','2013-02-19','09:30:00',2.97),('8975','2013-02-19','09:35:00',3.2),('8975','2013-02-19','09:40:00',2.09),('8975','2013-02-19','09:45:00',2.98),('8975','2013-02-19','09:50:00',1.84),('8975','2013-02-19','09:55:00',1.53),('8975','2013-02-19','10:00:00',2.8),('8975','2013-02-19','10:05:00',1.88),('8975','2013-02-19','10:10:00',1.48),('8975','2013-02-19','10:15:00',1.24),('8975','2013-02-19','10:20:00',1.11),('8975','2013-02-19','10:25:00',1.06),('8975','2013-02-19','10:30:00',1.19),('8975','2013-02-19','10:35:00',1.47),('8975','2013-02-19','10:40:00',3.24),('8975','2013-02-19','10:45:00',5.15),('8975','2013-02-19','10:50:00',2.78),('8975','2013-02-19','10:55:00',2.01),('8975','2013-02-19','11:00:00',4.52),('8975','2013-02-19','11:05:00',5.09),('8975','2013-02-19','11:10:00',2.84),('8975','2013-02-19','11:15:00',3.25),('8975','2013-02-19','11:20:00',3.86),('8975','2013-02-19','11:25:00',5.85),('8975','2013-02-19','11:30:00',6.34),('8975','2013-02-19','11:35:00',5.48),('8975','2013-02-19','11:40:00',3.54),('8975','2013-02-19','11:45:00',3.45),('8975','2013-02-19','11:50:00',3.74),('8975','2013-02-19','11:55:00',3.36),('8975','2013-02-19','12:00:00',3.16),('8975','2013-02-19','12:05:00',4.36),('8975','2013-02-19','12:10:00',2.74),('8975','2013-02-19','12:15:00',2.26),('8975','2013-02-19','12:20:00',5.05),('8975','2013-02-19','12:25:00',3.32),('8975','2013-02-19','12:30:00',2.94),('8975','2013-02-19','12:35:00',1.5),('8975','2013-02-19','12:40:00',2.03),('8975','2013-02-19','12:45:00',2.62),('8975','2013-02-19','12:50:00',3.92),('8975','2013-02-19','12:55:00',5.44),('8975','2013-02-19','13:00:00',4.33),('8975','2013-02-19','13:05:00',4.28),('8975','2013-02-19','13:10:00',1.29),('8975','2013-02-19','13:15:00',2.11),('8975','2013-02-19','13:20:00',4.08),('8975','2013-02-19','13:25:00',5.49),('8975','2013-02-19','13:30:00',4.56),('8975','2013-02-19','13:35:00',3.62),('8975','2013-02-19','13:40:00',2.04),('8975','2013-02-19','13:45:00',2.46),('8975','2013-02-19','13:50:00',2.51),('8975','2013-02-19','13:55:00',1.93),('8975','2013-02-19','14:00:00',1.61),('8975','2013-02-19','14:05:00',1.43),('8975','2013-02-19','14:10:00',1.48),('8975','2013-02-19','14:15:00',1.27),('8975','2013-02-19','14:20:00',1.14),('8975','2013-02-19','14:25:00',1.06),('8975','2013-02-19','14:30:00',1.3),('8975','2013-02-19','14:35:00',1.36),('8975','2013-02-19','14:40:00',1.31),('8975','2013-02-19','14:45:00',1.3),('8975','2013-02-19','14:50:00',1.41),('8975','2013-02-19','14:55:00',1.95),('8975','2013-02-19','15:00:00',1.84),('8975','2013-02-19','15:05:00',2.45),('8975','2013-02-19','15:10:00',2.63),('8975','2013-02-19','15:15:00',2.64),('8975','2013-02-19','15:20:00',2.38),('8975','2013-02-19','15:25:00',1.46),('8975','2013-02-19','15:30:00',1.52),('8975','2013-02-19','15:35:00',1.67),('8975','2013-02-19','15:40:00',1.42),('8975','2013-02-19','15:45:00',1.57),('8975','2013-02-19','15:50:00',2.11),('8975','2013-02-19','15:55:00',1.67),('8975','2013-02-19','16:00:00',2.07),('8975','2013-02-19','16:05:00',2.01),('8975','2013-02-19','16:10:00',1.87),('8975','2013-02-19','16:15:00',1.71),('8975','2013-02-19','16:20:00',1.4),('8975','2013-02-19','16:25:00',1.34),('8975','2013-02-19','16:30:00',1.32),('8975','2013-02-19','16:35:00',1.04),('8975','2013-02-18','07:35:00',1.29),('8975','2013-02-18','07:40:00',1.51),('8975','2013-02-18','07:45:00',1.69),('8975','2013-02-18','07:50:00',1.86),('8975','2013-02-18','07:55:00',2.01),('8975','2013-02-18','08:00:00',2.13),('8975','2013-02-18','08:05:00',2.22),('8975','2013-02-18','08:10:00',2.38),('8975','2013-02-18','08:15:00',2.51),('8975','2013-02-18','08:20:00',2.64),('8975','2013-02-18','08:25:00',2.76),('8975','2013-02-18','08:30:00',2.89),('8975','2013-02-18','08:35:00',2.99),('8975','2013-02-18','08:40:00',3.08),('8975','2013-02-18','08:45:00',3.15),('8975','2013-02-18','08:50:00',3.23),('8975','2013-02-18','08:55:00',3.32),('8975','2013-02-18','09:00:00',3.4),('8975','2013-02-18','09:05:00',3.49),('8975','2013-02-18','09:10:00',3.59),('8975','2013-02-18','09:15:00',3.65),('8975','2013-02-18','09:20:00',3.71),('8975','2013-02-18','09:25:00',3.8),('8975','2013-02-18','09:30:00',3.84),('8975','2013-02-18','09:35:00',3.88),('8975','2013-02-18','09:40:00',3.99),('8975','2013-02-18','09:45:00',4.09),('8975','2013-02-18','09:50:00',4.21),('8975','2013-02-18','09:55:00',4.28),('8975','2013-02-18','10:00:00',4.29),('8975','2013-02-18','10:05:00',4.37),('8975','2013-02-18','10:10:00',4.15),('8975','2013-02-18','10:15:00',4.05),('8975','2013-02-18','10:20:00',4.24),('8975','2013-02-18','10:25:00',4.54),('8975','2013-02-18','10:30:00',4.56),('8975','2013-02-18','10:35:00',4.64),('8975','2013-02-18','10:40:00',4.69),('8975','2013-02-18','10:45:00',4.65),('8975','2013-02-18','10:50:00',4.71),('8975','2013-02-18','10:55:00',4.77),('8975','2013-02-18','11:00:00',4.79),('8975','2013-02-18','11:05:00',4.78),('8975','2013-02-18','11:10:00',4.72),('8975','2013-02-18','11:15:00',4.81),('8975','2013-02-18','11:20:00',4.85),('8975','2013-02-18','11:25:00',4.92),('8975','2013-02-18','11:30:00',4.9),('8975','2013-02-18','11:35:00',4.87),('8975','2013-02-18','11:40:00',4.88),('8975','2013-02-18','11:45:00',4.88),('8975','2013-02-18','11:50:00',4.78),('8975','2013-02-18','11:55:00',4.76),('8975','2013-02-18','12:00:00',4.6),('8975','2013-02-18','12:05:00',4.56),('8975','2013-02-18','12:10:00',4.63),('8975','2013-02-18','12:15:00',4.64),('8975','2013-02-18','12:20:00',4.61),('8975','2013-02-18','12:25:00',4.58),('8975','2013-02-18','12:30:00',4.53),('8975','2013-02-18','12:35:00',4.46),('8975','2013-02-18','12:40:00',4.41),('8975','2013-02-18','12:45:00',4.35),('8975','2013-02-18','12:50:00',4.29),('8975','2013-02-18','12:55:00',4.3),('8975','2013-02-18','13:00:00',4.21),('8975','2013-02-18','13:05:00',3.93),('8975','2013-02-18','13:10:00',4.05),('8975','2013-02-18','13:15:00',3.96),('8975','2013-02-18','13:20:00',3.89),('8975','2013-02-18','13:25:00',3.82),('8975','2013-02-18','13:30:00',3.67),('8975','2013-02-18','13:35:00',3.6),('8975','2013-02-18','13:40:00',3.7),('8975','2013-02-18','13:45:00',3.56),('8975','2013-02-18','13:50:00',3.36),('8975','2013-02-18','13:55:00',3.18),('8975','2013-02-18','14:00:00',2.97),('8975','2013-02-18','14:05:00',3.1),('8975','2013-02-18','14:10:00',3.08),('8975','2013-02-18','14:15:00',2.86),('8975','2013-02-18','14:20:00',2.6),('8975','2013-02-18','14:25:00',1.83),('8975','2013-02-18','14:30:00',1.93),('8975','2013-02-18','14:35:00',2.49),('8975','2013-02-18','14:40:00',2.5),('8975','2013-02-18','14:45:00',2.32),('8975','2013-02-18','14:50:00',2.28),('8975','2013-02-18','14:55:00',2.27),('8975','2013-02-18','15:00:00',2.18),('8975','2013-02-18','15:05:00',2.07),('8975','2013-02-18','15:10:00',1.99),('8975','2013-02-18','15:15:00',1.88),('8975','2013-02-18','15:20:00',1.8),('8975','2013-02-18','15:25:00',1.75),('8975','2013-02-18','15:30:00',1.69),('8975','2013-02-18','15:35:00',1.64),('8975','2013-02-18','15:40:00',1.58),('8975','2013-02-18','15:45:00',1.51),('8975','2013-02-18','15:50:00',1.46),('8975','2013-02-18','15:55:00',1.45),('8975','2013-02-18','16:00:00',1.41),('8975','2013-02-18','16:05:00',1.36),('8975','2013-02-18','16:10:00',1.31),('8975','2013-02-18','16:15:00',1.25),('8975','2013-02-18','16:20:00',1.2),('8975','2013-02-18','16:25:00',1.14),('8975','2013-02-18','16:30:00',1.09),('8975','2013-02-18','16:35:00',1.02),('8975','2013-02-17','07:55:00',1.56),('8975','2013-02-17','08:00:00',2.01),('8975','2013-02-17','08:05:00',2.08),('8975','2013-02-17','08:10:00',2.21),('8975','2013-02-17','08:15:00',2.39),('8975','2013-02-17','08:20:00',2.5),('8975','2013-02-17','08:25:00',2.61),('8975','2013-02-17','08:30:00',2.71),('8975','2013-02-17','08:35:00',2.82),('8975','2013-02-17','08:40:00',2.91),('8975','2013-02-17','08:45:00',3.03),('8975','2013-02-17','08:50:00',3.11),('8975','2013-02-17','08:55:00',3.16),('8975','2013-02-17','09:00:00',3.25),('8975','2013-02-17','09:05:00',3.32),('8975','2013-02-17','09:10:00',3.38),('8975','2013-02-17','09:15:00',3.57),('8975','2013-02-17','09:20:00',3.68),('8975','2013-02-17','09:25:00',4.09),('8975','2013-02-17','09:30:00',2.31),('8975','2013-02-17','09:35:00',1.71),('8975','2013-02-17','09:40:00',1.17),('8975','2013-02-17','09:45:00',2.11),('8975','2013-02-17','09:50:00',1.23),('8975','2013-02-17','09:55:00',1.46),('8975','2013-02-17','10:00:00',1.46),('8975','2013-02-17','10:05:00',1.05),('8975','2013-02-17','10:30:00',1.14),('8975','2013-02-17','10:35:00',1.32),('8975','2013-02-17','10:40:00',1.51),('8975','2013-02-17','10:45:00',1.4),('8975','2013-02-17','10:50:00',1.41),('8975','2013-02-17','10:55:00',1.73),('8975','2013-02-17','11:00:00',1.85),('8975','2013-02-17','11:05:00',1.87),('8975','2013-02-17','11:10:00',1.8),('8975','2013-02-17','11:15:00',1.76),('8975','2013-02-17','11:20:00',2.07),('8975','2013-02-17','11:25:00',2.33),('8975','2013-02-17','11:30:00',2.16),('8975','2013-02-17','11:35:00',2.25),('8975','2013-02-17','11:40:00',2.07),('8975','2013-02-17','11:45:00',2.02),('8975','2013-02-17','11:50:00',2.4),('8975','2013-02-17','11:55:00',2.82),('8975','2013-02-17','12:00:00',2.8),('8975','2013-02-17','12:05:00',2.5),('8975','2013-02-17','12:10:00',2.33),('8975','2013-02-17','12:15:00',2.22),('8975','2013-02-17','12:20:00',2.21),('8975','2013-02-17','12:25:00',2.36),('8975','2013-02-17','12:30:00',2.17),('8975','2013-02-17','12:35:00',2.05),('8975','2013-02-17','12:40:00',2.19),('8975','2013-02-17','12:45:00',2.45),('8975','2013-02-17','12:50:00',2.38),('8975','2013-02-17','12:55:00',2.28),('8975','2013-02-17','13:00:00',2.21),('8975','2013-02-17','13:05:00',2.07),('8975','2013-02-17','13:10:00',1.9),('8975','2013-02-17','13:15:00',1.92),('8975','2013-02-17','13:20:00',1.77),('8975','2013-02-17','13:25:00',1.87),('8975','2013-02-17','13:30:00',1.93),('8975','2013-02-17','13:35:00',1.93),('8975','2013-02-17','13:40:00',1.94),('8975','2013-02-17','13:45:00',1.7),('8975','2013-02-17','13:50:00',1.82),('8975','2013-02-17','13:55:00',2.05),('8975','2013-02-17','14:00:00',1.95),('8975','2013-02-17','14:05:00',1.69),('8975','2013-02-17','14:10:00',1.53),('8975','2013-02-17','14:15:00',1.41),('8975','2013-02-17','14:20:00',1.54),('8975','2013-02-17','14:25:00',1.05),('8975','2013-02-17','15:00:00',1.51),('8975','2013-02-17','15:05:00',1.65),('8975','2013-02-17','15:10:00',1.16),('8975','2013-02-17','15:35:00',1.08),('8975','2013-02-16','07:40:00',1.1),('8975','2013-02-16','07:45:00',1.22),('8975','2013-02-16','07:50:00',1.39),('8975','2013-02-16','07:55:00',1.57),('8975','2013-02-16','08:00:00',1.75),('8975','2013-02-16','08:05:00',1.89),('8975','2013-02-16','08:10:00',2.03),('8975','2013-02-16','08:15:00',2.2),('8975','2013-02-16','08:20:00',2.34),('8975','2013-02-16','08:25:00',2.46),('8975','2013-02-16','08:30:00',2.63),('8975','2013-02-16','08:35:00',2.82),('8975','2013-02-16','08:40:00',3),('8975','2013-02-16','08:45:00',3.07),('8975','2013-02-16','08:50:00',2.95),('8975','2013-02-16','08:55:00',2.97),('8975','2013-02-16','09:00:00',3.15),('8975','2013-02-16','09:05:00',3.15),('8975','2013-02-16','09:10:00',3.36),('8975','2013-02-16','09:15:00',3.46),('8975','2013-02-16','09:20:00',3.55),('8975','2013-02-16','09:25:00',3.63),('8975','2013-02-16','09:30:00',3.64),('8975','2013-02-16','09:35:00',3.64),('8975','2013-02-16','09:40:00',3.74),('8975','2013-02-16','09:45:00',3.83),('8975','2013-02-16','09:50:00',3.96),('8975','2013-02-16','09:55:00',4.08),('8975','2013-02-16','10:00:00',4.16),('8975','2013-02-16','10:05:00',4.21),('8975','2013-02-16','10:10:00',4.09),('8975','2013-02-16','10:15:00',3.92),('8975','2013-02-16','10:20:00',3.92),('8975','2013-02-16','10:25:00',4.28),('8975','2013-02-16','10:30:00',4.37),('8975','2013-02-16','10:35:00',4.39),('8975','2013-02-16','10:40:00',4.45),('8975','2013-02-16','10:45:00',4.45),('8975','2013-02-16','10:50:00',4.48),('8975','2013-02-16','10:55:00',4.49),('8975','2013-02-16','11:00:00',4.55),('8975','2013-02-16','11:05:00',4.61),('8975','2013-02-16','11:10:00',4.65),('8975','2013-02-16','11:15:00',4.65),('8975','2013-02-16','11:20:00',4.67),('8975','2013-02-16','11:25:00',4.66),('8975','2013-02-16','11:30:00',4.61),('8975','2013-02-16','11:35:00',4.61),('8975','2013-02-16','11:40:00',4.63),('8975','2013-02-16','11:45:00',4.55),('8975','2013-02-16','11:50:00',4.41),('8975','2013-02-16','11:55:00',4.46),('8975','2013-02-16','12:00:00',4.39),('8975','2013-02-16','12:05:00',4.2),('8975','2013-02-16','12:10:00',4.37),('8975','2013-02-16','12:15:00',4.36),('8975','2013-02-16','12:20:00',4.29),('8975','2013-02-16','12:25:00',4.21),('8975','2013-02-16','12:30:00',4.12),('8975','2013-02-16','12:35:00',4.1),('8975','2013-02-16','12:40:00',1.37),('8975','2013-02-16','12:45:00',1.04),('8975','2013-02-16','12:50:00',1.13),('8975','2013-02-16','12:55:00',1.81),('8975','2013-02-16','13:00:00',2.76),('8975','2013-02-16','13:05:00',1.2),('8975','2013-02-16','13:20:00',1.02),('8975','2013-02-16','13:25:00',1.16),('8975','2013-02-16','13:30:00',1.01),('8975','2013-02-16','13:45:00',2.49),('8975','2013-02-16','13:50:00',2.02),('8975','2013-02-16','13:55:00',1.33),('8975','2013-02-16','14:45:00',1.08),('8975','2013-02-16','14:50:00',1.55),('8975','2013-02-16','14:55:00',1.03),('8975','2013-02-16','15:00:00',1.3),('8975','2013-02-16','15:05:00',2.33),('8975','2013-02-16','15:10:00',2.45),('8975','2013-02-16','15:15:00',1.35),('8975','2013-02-16','15:20:00',1.46),('8975','2013-02-16','15:25:00',1.67),('8975','2013-02-16','15:30:00',1.96),('8975','2013-02-16','15:35:00',1.96),('8975','2013-02-16','15:40:00',2.16),('8975','2013-02-16','15:45:00',1.99),('8975','2013-02-16','15:50:00',1.88),('8975','2013-02-16','15:55:00',1.86),('8975','2013-02-16','16:00:00',1.7),('8975','2013-02-16','16:05:00',1.68),('8975','2013-02-16','16:10:00',1.03),('8975','2013-02-16','16:20:00',1.26),('8975','2013-02-16','16:25:00',1.7),('8975','2013-02-16','16:30:00',1.55),('8975','2013-02-16','16:35:00',1.06),('8975','2013-02-16','16:40:00',1.01),('8975','2013-02-15','07:55:00',1.66),('8975','2013-02-15','08:00:00',1.83),('8975','2013-02-15','08:05:00',1.95),('8975','2013-02-15','08:10:00',2.06),('8975','2013-02-15','08:15:00',2.17),('8975','2013-02-15','08:20:00',2.29),('8975','2013-02-15','08:25:00',2.44),('8975','2013-02-15','08:30:00',2.56),('8975','2013-02-15','08:35:00',2.69),('8975','2013-02-15','08:40:00',2.8),('8975','2013-02-15','08:45:00',2.89),('8975','2013-02-15','08:50:00',2.95),('8975','2013-02-15','08:55:00',2.87),('8975','2013-02-15','09:00:00',2.04),('8975','2013-02-15','09:05:00',1.41),('8975','2013-02-15','09:10:00',1.6),('8975','2013-02-15','09:15:00',2.32),('8975','2013-02-15','09:20:00',3.16),('8975','2013-02-15','09:25:00',3.75),('8975','2013-02-15','09:30:00',3.74),('8975','2013-02-15','09:35:00',3.78),('8975','2013-02-15','09:40:00',3.76),('8975','2013-02-15','09:45:00',3.85),('8975','2013-02-15','09:50:00',3.99),('8975','2013-02-15','09:55:00',4.1),('8975','2013-02-15','10:00:00',4.12),('8975','2013-02-15','10:05:00',4.22),('8975','2013-02-15','10:10:00',4.15),('8975','2013-02-15','10:15:00',4.09),('8975','2013-02-15','10:20:00',4.17),('8975','2013-02-15','10:25:00',4.32),('8975','2013-02-15','10:30:00',4.4),('8975','2013-02-15','10:35:00',4.29),('8975','2013-02-15','10:40:00',3.56),('8975','2013-02-15','10:45:00',4.08),('8975','2013-02-15','10:50:00',3.27),('8975','2013-02-15','10:55:00',4.55),('8975','2013-02-15','11:00:00',4.18),('8975','2013-02-15','11:05:00',3.59),('8975','2013-02-15','11:10:00',4.97),('8975','2013-02-15','11:15:00',4.92),('8975','2013-02-15','11:20:00',4.65),('8975','2013-02-15','11:25:00',4.76),('8975','2013-02-15','11:30:00',4.74),('8975','2013-02-15','11:35:00',4.71),('8975','2013-02-15','11:40:00',4.74),('8975','2013-02-15','11:45:00',4.68),('8975','2013-02-15','11:50:00',4.67),('8975','2013-02-15','11:55:00',4.62),('8975','2013-02-15','12:00:00',4.52),('8975','2013-02-15','12:05:00',4.49),('8975','2013-02-15','12:10:00',4.44),('8975','2013-02-15','12:15:00',4.45),('8975','2013-02-15','12:20:00',4.42),('8975','2013-02-15','12:25:00',4.36),('8975','2013-02-15','12:30:00',4.4),('8975','2013-02-15','12:35:00',3.81),('8975','2013-02-15','12:40:00',4.31),('8975','2013-02-15','12:45:00',4.24),('8975','2013-02-15','12:50:00',4.2),('8975','2013-02-15','12:55:00',4.14),('8975','2013-02-15','13:00:00',4),('8975','2013-02-15','13:05:00',3.93),('8975','2013-02-15','13:10:00',3.66),('8975','2013-02-15','13:15:00',3.57),('8975','2013-02-15','13:20:00',3.75),('8975','2013-02-15','13:25:00',3.79),('8975','2013-02-15','13:30:00',3.7),('8975','2013-02-15','13:35:00',3.66),('8975','2013-02-15','13:40:00',3.68),('8975','2013-02-15','13:45:00',1.52),('8975','2013-02-15','13:50:00',1.77),('8975','2013-02-15','13:55:00',1.89),('8975','2013-02-15','14:00:00',2.31),('8975','2013-02-15','14:05:00',3.23),('8975','2013-02-15','14:10:00',3.08),('8975','2013-02-15','14:15:00',2.21),('8975','2013-02-15','14:20:00',1.36),('8975','2013-02-15','14:25:00',1.41),('8975','2013-02-15','14:30:00',1.5),('8975','2013-02-15','14:35:00',1.73),('8975','2013-02-15','14:40:00',1.86),('8975','2013-02-15','14:45:00',1.71),('8975','2013-02-15','14:50:00',1.75),('8975','2013-02-15','14:55:00',1.38),('8975','2013-02-15','15:00:00',1.32),('8975','2013-02-15','15:05:00',1.42),('8975','2013-02-15','15:10:00',1.38),('8975','2013-02-15','15:15:00',1.38),('8975','2013-02-15','15:20:00',1.35),('8975','2013-02-15','15:25:00',1.44),('8975','2013-02-15','15:30:00',1.53),('8975','2013-02-15','15:35:00',1.61),('8975','2013-02-15','15:40:00',1.54),('8975','2013-02-15','15:45:00',2.15),('8975','2013-02-15','15:50:00',2.11),('8975','2013-02-15','15:55:00',1.3),('8975','2013-02-15','16:00:00',1.29),('8975','2013-02-15','16:05:00',1.35),('8975','2013-02-15','16:10:00',1.45),('8975','2013-02-15','16:15:00',1.34),('8975','2013-02-15','16:20:00',1.02),('8975','2013-02-15','16:25:00',1.26),('8975','2013-02-15','16:30:00',1.23),('8975','2013-02-14','07:40:00',1.15),('8975','2013-02-14','07:45:00',1.25),('8975','2013-02-14','07:50:00',1.54),('8975','2013-02-14','07:55:00',1.61),('8975','2013-02-14','08:00:00',1.8),('8975','2013-02-14','08:05:00',1.4),('8975','2013-02-14','08:10:00',1.73),('8975','2013-02-14','08:15:00',1.4),('8975','2013-02-14','08:50:00',1.05),('8975','2013-02-14','08:55:00',1.7),('8975','2013-02-14','09:00:00',1.29),('8975','2013-02-14','09:05:00',1.1),('8975','2013-02-14','09:10:00',1),('8975','2013-02-14','09:15:00',1.11),('8975','2013-02-14','09:20:00',1.15),('8975','2013-02-14','09:25:00',1.59),('8975','2013-02-14','09:30:00',1.53),('8975','2013-02-14','09:35:00',1.87),('8975','2013-02-14','09:40:00',1.61),('8975','2013-02-14','09:45:00',1.31),('8975','2013-02-14','09:50:00',1.74),('8975','2013-02-14','09:55:00',2.61),('8975','2013-02-14','10:00:00',3.37),('8975','2013-02-14','10:05:00',2.4),('8975','2013-02-14','10:10:00',1.5),('8975','2013-02-14','10:15:00',2.08),('8975','2013-02-14','10:20:00',2.62),('8975','2013-02-14','10:25:00',3.22),('8975','2013-02-14','10:30:00',3.42),('8975','2013-02-14','10:35:00',4.05),('8975','2013-02-14','10:40:00',3.85),('8975','2013-02-14','10:45:00',4.67),('8975','2013-02-14','10:50:00',4.44),('8975','2013-02-14','10:55:00',2.38),('8975','2013-02-14','11:00:00',2.9),('8975','2013-02-14','11:05:00',3.14),('8975','2013-02-14','11:10:00',2.92),('8975','2013-02-14','11:15:00',4.43),('8975','2013-02-14','11:20:00',4.29),('8975','2013-02-14','11:25:00',4.51),('8975','2013-02-14','11:30:00',3.59),('8975','2013-02-14','11:35:00',3.5),('8975','2013-02-14','11:40:00',3.67),('8975','2013-02-14','11:45:00',4.33),('8975','2013-02-14','11:50:00',4.65),('8975','2013-02-14','11:55:00',4.22),('8975','2013-02-14','12:00:00',3.93),('8975','2013-02-14','12:05:00',4.85),('8975','2013-02-14','12:10:00',4.67),('8975','2013-02-14','12:15:00',4.89),('8975','2013-02-14','12:20:00',4.93),('8975','2013-02-14','12:25:00',4.55),('8975','2013-02-14','12:30:00',4.53),('8975','2013-02-14','12:35:00',4.42),('8975','2013-02-14','12:40:00',3.61),('8975','2013-02-14','12:45:00',3.62),('8975','2013-02-14','12:50:00',4.24),('8975','2013-02-14','12:55:00',4.15),('8975','2013-02-14','13:00:00',3.97),('8975','2013-02-14','13:05:00',3.8),('8975','2013-02-14','13:10:00',3.82),('8975','2013-02-14','13:15:00',3.84),('8975','2013-02-14','13:20:00',3.52),('8975','2013-02-14','13:25:00',2.71),('8975','2013-02-14','13:30:00',2.83),('8975','2013-02-14','13:35:00',2.46),('8975','2013-02-14','13:40:00',3.15),('8975','2013-02-14','13:45:00',3.18),('8975','2013-02-14','13:50:00',3.29),('8975','2013-02-14','13:55:00',3.06),('8975','2013-02-14','14:00:00',3.03),('8975','2013-02-14','14:05:00',3.51),('8975','2013-02-14','14:10:00',2.87),('8975','2013-02-14','14:15:00',2.93),('8975','2013-02-14','14:20:00',2.78),('8975','2013-02-14','14:25:00',2.29),('8975','2013-02-14','14:30:00',2.41),('8975','2013-02-14','14:35:00',2.4),('8975','2013-02-14','14:40:00',2.55),('8975','2013-02-14','14:45:00',2.07),('8975','2013-02-14','14:50:00',1.69),('8975','2013-02-14','14:55:00',1.3),('8975','2013-02-14','15:00:00',1.54),('8975','2013-02-14','15:05:00',1.86),('8975','2013-02-14','15:10:00',1.31),('8975','2013-02-14','15:15:00',1.34),('8975','2013-02-14','15:20:00',1.28),('8975','2013-02-14','15:25:00',1.3),('8975','2013-02-14','15:30:00',1.52),('8975','2013-02-14','15:35:00',1.54),('8975','2013-02-14','15:40:00',1.48),('8975','2013-02-14','15:45:00',1.34),('8975','2013-02-14','15:50:00',1.13),('8975','2013-02-14','15:55:00',1.08),('8975','2013-02-14','16:00:00',1.01),('8975','2013-02-13','07:40:00',1.25),('8975','2013-02-13','07:45:00',1.56),('8975','2013-02-13','07:50:00',1.74),('8975','2013-02-13','07:55:00',1.94),('8975','2013-02-13','08:00:00',2.1),('8975','2013-02-13','08:05:00',2.21),('8975','2013-02-13','08:10:00',2.35),('8975','2013-02-13','08:15:00',2.46),('8975','2013-02-13','08:20:00',2.6),('8975','2013-02-13','08:25:00',2.71),('8975','2013-02-13','08:30:00',2.82),('8975','2013-02-13','08:35:00',2.91),('8975','2013-02-13','08:40:00',3),('8975','2013-02-13','08:45:00',3.09),('8975','2013-02-13','08:50:00',3.18),('8975','2013-02-13','08:55:00',3.26),('8975','2013-02-13','09:00:00',3.35),('8975','2013-02-13','09:05:00',3.43),('8975','2013-02-13','09:10:00',3.51),('8975','2013-02-13','09:15:00',3.58),('8975','2013-02-13','09:20:00',3.67),('8975','2013-02-13','09:25:00',3.75),('8975','2013-02-13','09:30:00',3.83),('8975','2013-02-13','09:35:00',3.88),('8975','2013-02-13','09:40:00',3.92),('8975','2013-02-13','09:45:00',4.01),('8975','2013-02-13','09:50:00',4.12),('8975','2013-02-13','09:55:00',4.23),('8975','2013-02-13','10:00:00',4.3),('8975','2013-02-13','10:05:00',4.37),('8975','2013-02-13','10:10:00',4.39),('8975','2013-02-13','10:15:00',4.29),('8975','2013-02-13','10:20:00',4.47),('8975','2013-02-13','10:25:00',4.53),('8975','2013-02-13','10:30:00',4.56),('8975','2013-02-13','10:35:00',4.6),('8975','2013-02-13','10:40:00',4.66),('8975','2013-02-13','10:45:00',4.69),('8975','2013-02-13','10:50:00',4.72),('8975','2013-02-13','10:55:00',4.74),('8975','2013-02-13','11:00:00',4.76),('8975','2013-02-13','11:05:00',4.77),('8975','2013-02-13','11:10:00',4.79),('8975','2013-02-13','11:15:00',4.74),('8975','2013-02-13','11:20:00',4.79),('8975','2013-02-13','11:25:00',4.79),('8975','2013-02-13','11:30:00',4.79),('8975','2013-02-13','11:35:00',4.79),('8975','2013-02-13','11:40:00',4.8),('8975','2013-02-13','11:45:00',4.74),('8975','2013-02-13','11:50:00',4.75),('8975','2013-02-13','11:55:00',4.54),('8975','2013-02-13','12:00:00',4.45),('8975','2013-02-13','12:05:00',4.6),('8975','2013-02-13','12:10:00',4.58),('8975','2013-02-13','12:15:00',4.46),('8975','2013-02-13','12:20:00',4.46),('8975','2013-02-13','12:25:00',4.42),('8975','2013-02-13','12:30:00',4.39),('8975','2013-02-13','12:35:00',4.36),('8975','2013-02-13','12:40:00',4.31),('8975','2013-02-13','12:45:00',4.21),('8975','2013-02-13','12:50:00',4.15),('8975','2013-02-13','12:55:00',4.07),('8975','2013-02-13','13:00:00',3.93),('8975','2013-02-13','13:05:00',3.88),('8975','2013-02-13','13:10:00',3.85),('8975','2013-02-13','13:15:00',3.71),('8975','2013-02-13','13:20:00',3.77),('8975','2013-02-13','13:25:00',3.67),('8975','2013-02-13','13:30:00',3.59),('8975','2013-02-13','13:35:00',3.52),('8975','2013-02-13','13:40:00',3.44),('8975','2013-02-13','13:45:00',3.3),('8975','2013-02-13','13:50:00',3.18),('8975','2013-02-13','13:55:00',2.98),('8975','2013-02-13','14:00:00',2.96),('8975','2013-02-13','14:05:00',2.93),('8975','2013-02-13','14:10:00',2.8),('8975','2013-02-13','14:15:00',2.66),('8975','2013-02-13','14:20:00',2.57),('8975','2013-02-13','14:25:00',2.54),('8975','2013-02-13','14:30:00',2.45),('8975','2013-02-13','14:35:00',2.38),('8975','2013-02-13','14:40:00',2.33),('8975','2013-02-13','14:45:00',2.22),('8975','2013-02-13','14:50:00',2.14),('8975','2013-02-13','14:55:00',2.07),('8975','2013-02-13','15:00:00',1.95),('8975','2013-02-13','15:05:00',1.85),('8975','2013-02-13','15:10:00',1.77),('8975','2013-02-13','15:15:00',1.69),('8975','2013-02-13','15:20:00',1.62),('8975','2013-02-13','15:25:00',1.56),('8975','2013-02-13','15:30:00',1.53),('8975','2013-02-13','15:35:00',1.48),('8975','2013-02-13','15:40:00',1.44),('8975','2013-02-13','15:45:00',1.4),('8975','2013-02-13','15:50:00',1.36),('8975','2013-02-13','15:55:00',1.32),('8975','2013-02-13','16:00:00',1.28),('8975','2013-02-13','16:05:00',1.25),('8975','2013-02-13','16:10:00',1.2),('8975','2013-02-13','16:15:00',1.16),('8975','2013-02-13','16:20:00',1.1),('8975','2013-02-13','16:25:00',1.05),('8975','2013-02-12','08:40:00',1.02),('8975','2013-02-12','08:45:00',1.17),('8975','2013-02-12','08:50:00',1.33),('8975','2013-02-12','08:55:00',1.49),('8975','2013-02-12','09:00:00',1.69),('8975','2013-02-12','09:05:00',1.84),('8975','2013-02-12','09:10:00',2.02),('8975','2013-02-12','09:15:00',2.23),('8975','2013-02-12','09:20:00',2.34),('8975','2013-02-12','09:25:00',2.71),('8975','2013-02-12','09:30:00',3.01),('8975','2013-02-12','09:35:00',3.51),('8975','2013-02-12','09:40:00',3.77),('8975','2013-02-12','09:45:00',3.81),('8975','2013-02-12','09:50:00',3.36),('8975','2013-02-12','09:55:00',3.77),('8975','2013-02-12','10:00:00',4.11),('8975','2013-02-12','10:05:00',4.13),('8975','2013-02-12','10:10:00',4.27),('8975','2013-02-12','10:15:00',4.2),('8975','2013-02-12','10:20:00',4.34),('8975','2013-02-12','10:25:00',4.49),('8975','2013-02-12','10:30:00',4.55),('8975','2013-02-12','10:35:00',4.67),('8975','2013-02-12','10:40:00',4.8),('8975','2013-02-12','10:45:00',4.76),('8975','2013-02-12','10:50:00',4.79),('8975','2013-02-12','10:55:00',4.8),('8975','2013-02-12','11:00:00',4.83),('8975','2013-02-12','11:05:00',4.81),('8975','2013-02-12','11:10:00',4.76),('8975','2013-02-12','11:15:00',4.5),('8975','2013-02-12','11:20:00',3.7),('8975','2013-02-12','11:25:00',1.91),('8975','2013-02-12','11:30:00',2.3),('8975','2013-02-12','11:35:00',4.88),('8975','2013-02-12','11:40:00',4.02),('8975','2013-02-12','11:45:00',3.78),('8975','2013-02-12','11:50:00',2.51),('8975','2013-02-12','11:55:00',3.3),('8975','2013-02-12','12:00:00',4.02),('8975','2013-02-12','12:05:00',2.97),('8975','2013-02-12','12:10:00',3.6),('8975','2013-02-12','12:15:00',2.58),('8975','2013-02-12','12:20:00',3.75),('8975','2013-02-12','12:25:00',3.38),('8975','2013-02-12','12:30:00',2.15),('8975','2013-02-12','12:35:00',3.21),('8975','2013-02-12','12:40:00',3.02),('8975','2013-02-12','12:45:00',2.92),('8975','2013-02-12','12:50:00',3.46),('8975','2013-02-12','12:55:00',3.42),('8975','2013-02-12','13:00:00',3.77),('8975','2013-02-12','13:05:00',3.38),('8975','2013-02-12','13:10:00',3.85),('8975','2013-02-12','13:15:00',4.2),('8975','2013-02-12','13:20:00',4.07),('8975','2013-02-12','13:25:00',3.8),('8975','2013-02-12','13:30:00',3.82),('8975','2013-02-12','13:35:00',3.73),('8975','2013-02-12','13:40:00',3.58),('8975','2013-02-12','13:45:00',3.23),('8975','2013-02-12','13:50:00',3.01),('8975','2013-02-12','13:55:00',2.35),('8975','2013-02-12','14:00:00',3.08),('8975','2013-02-12','14:05:00',2.51),('8975','2013-02-12','14:10:00',2.84),('8975','2013-02-12','14:15:00',2.68),('8975','2013-02-12','14:20:00',2.51),('8975','2013-02-12','14:25:00',2.48),('8975','2013-02-12','14:30:00',2.5),('8975','2013-02-12','14:35:00',2.47),('8975','2013-02-12','14:40:00',2.36),('8975','2013-02-12','14:45:00',2.25),('8975','2013-02-12','14:50:00',2.16),('8975','2013-02-12','14:55:00',2.07),('8975','2013-02-12','15:00:00',2.01),('8975','2013-02-12','15:05:00',1.89),('8975','2013-02-12','15:10:00',1.78),('8975','2013-02-12','15:15:00',1.71),('8975','2013-02-12','15:20:00',1.66),('8975','2013-02-12','15:25:00',1.6),('8975','2013-02-12','15:30:00',1.58),('8975','2013-02-12','15:35:00',1.53),('8975','2013-02-12','15:40:00',1.49),('8975','2013-02-12','15:45:00',1.45),('8975','2013-02-12','15:50:00',1.4),('8975','2013-02-12','15:55:00',1.35),('8975','2013-02-12','16:00:00',1.31),('8975','2013-02-12','16:05:00',1.29),('8975','2013-02-12','16:10:00',1.23),('8975','2013-02-12','16:15:00',1.17),('8975','2013-02-12','16:20:00',1.09),('8975','2013-02-12','16:25:00',1.05),('8975','2013-02-12','16:30:00',1.02),('8975','2013-02-10','09:25:00',1.02),('8975','2013-02-10','09:30:00',1.23),('8975','2013-02-10','09:35:00',1.04),('8975','2013-02-10','10:10:00',1.05),('8975','2013-02-10','10:15:00',1.27),('8975','2013-02-10','10:20:00',1.44),('8975','2013-02-10','10:25:00',1.65),('8975','2013-02-10','10:30:00',1.92),('8975','2013-02-10','10:35:00',1.88),('8975','2013-02-10','10:40:00',1.65),('8975','2013-02-10','10:45:00',1.5),('8975','2013-02-10','10:50:00',1.42),('8975','2013-02-10','10:55:00',1.63),('8975','2013-02-10','11:00:00',2.25),('8975','2013-02-10','11:05:00',2.13),('8975','2013-02-10','11:10:00',2.37),('8975','2013-02-10','11:15:00',2.4),('8975','2013-02-10','11:20:00',1.79),('8975','2013-02-10','11:25:00',1.27),('8975','2013-02-10','11:35:00',1.24),('8975','2013-02-10','11:40:00',1.46),('8975','2013-02-10','11:45:00',1.7),('8975','2013-02-10','11:50:00',1.21),('8975','2013-02-10','12:35:00',1.02),('8975','2013-02-10','12:40:00',1.51),('8975','2013-02-10','12:45:00',2.08),('8975','2013-02-10','12:50:00',1.16),('8975','2013-02-10','13:55:00',1.51),('8975','2013-02-10','14:00:00',1.52),('8975','2013-02-10','14:05:00',1.66),('8975','2013-02-10','14:10:00',1.65),('8975','2013-02-10','14:15:00',1.47),('8975','2013-02-10','14:20:00',1.72),('8975','2013-02-10','14:25:00',2.46),('8975','2013-02-10','14:30:00',2.61),('8975','2013-02-10','14:35:00',2.05),('8975','2013-02-10','14:40:00',2.39),('8975','2013-02-10','14:45:00',2.01),('8975','2013-02-10','14:50:00',1.45),('8975','2013-02-10','14:55:00',1.4),('8975','2013-02-10','15:00:00',1.05),('8975','2013-02-10','15:05:00',1.29),('8975','2013-02-10','15:10:00',1.38),('8975','2013-02-10','15:35:00',1),('8975','2013-02-10','15:40:00',1.09),('8975','2013-02-10','15:45:00',1.11),('8975','2014-03-21','07:30:00',1.37),('8975','2014-03-21','07:35:00',2.41),('8975','2014-03-21','07:41:00',2.57),('8975','2014-03-21','07:45:00',1.55),('8975','2014-03-21','07:50:00',1.69),('8975','2014-03-21','07:55:00',1.25),('8975','2014-03-21','08:11:00',1.21),('8975','2014-03-21','08:15:00',3),('8975','2014-03-21','08:20:00',3.24),('8975','2014-03-21','08:25:00',3.21),('8975','2014-03-21','08:30:00',3.36),('8975','2014-03-21','08:35:00',1.37),('8975','2014-03-21','08:40:00',1.89),('8975','2014-03-21','08:45:00',3.72),('8975','2014-03-21','08:50:00',2.82),('8975','2014-03-21','08:55:00',4.53),('8975','2014-03-21','09:00:00',3.29),('8975','2014-03-21','09:05:00',1.83),('8975','2014-03-21','09:10:00',2.32),('8975','2014-03-21','09:15:00',2.45),('8975','2014-03-21','09:20:00',2.9),('8975','2014-03-21','09:25:00',2.12),('8975','2014-03-21','09:30:00',2.08),('8975','2014-03-21','09:35:00',2.28),('8975','2014-03-21','09:40:00',5.42),('8975','2014-03-21','09:45:00',4.82),('8975','2014-03-21','09:50:00',4.87),('8975','2014-03-21','09:55:00',5.14),('8975','2014-03-21','10:00:00',3.32),('8975','2014-03-21','10:05:00',4.31),('8975','2014-03-21','10:10:00',5.79),('8975','2014-03-21','10:15:00',2.97),('8975','2014-03-21','10:20:00',1.91),('8975','2014-03-21','10:25:00',1.78),('8975','2014-03-21','10:30:00',2.14),('8975','2014-03-21','10:35:00',2.66),('8975','2014-03-21','10:40:00',3.27),('8975','2014-03-21','10:45:00',2.87),('8975','2014-03-21','10:50:00',2.45),('8975','2014-03-21','10:55:00',2.07),('8975','2014-03-21','11:00:00',1.89),('8975','2014-03-21','11:05:00',1.66),('8975','2014-03-21','11:10:00',1.97),('8975','2014-03-21','11:15:00',2.34),('8975','2014-03-21','11:20:00',3.11),('8975','2014-03-21','11:25:00',4.75),('8975','2014-03-21','11:30:00',4.88),('8975','2014-03-21','11:35:00',3.76),('8975','2014-03-21','11:40:00',3.58),('8975','2014-03-21','11:45:00',4.52),('8975','2014-03-21','11:50:00',2.69),('8975','2014-03-21','11:55:00',4.16),('8975','2014-03-21','12:00:00',2.8),('8975','2014-03-21','12:05:00',4.51),('8975','2014-03-21','12:10:00',3.78),('8975','2014-03-21','12:15:00',5.28),('8975','2014-03-21','12:20:00',3.79),('8975','2014-03-21','12:25:00',4.65),('8975','2014-03-21','12:30:00',2.16),('8975','2014-03-21','12:35:00',3.25),('8975','2014-03-21','12:40:00',5.69),('8975','2014-03-21','12:45:00',4.07),('8975','2014-03-21','12:50:00',5.52),('8975','2014-03-21','12:55:00',3.27),('8975','2014-03-21','13:00:00',3.43),('8975','2014-03-21','13:05:00',2.84),('8975','2014-03-21','13:10:00',1.76),('8975','2014-03-21','13:15:00',1.96),('8975','2014-03-21','13:20:00',3.54),('8975','2014-03-21','13:25:00',2.47),('8975','2014-03-21','13:30:00',3.92),('8975','2014-03-21','13:35:00',3.82),('8975','2014-03-21','13:40:00',3.32),('8975','2014-03-21','13:45:00',3.31),('8975','2014-03-21','13:50:00',1.57),('8975','2014-03-21','13:55:00',3.77),('8975','2014-03-21','14:00:00',3.67),('8975','2014-03-21','14:05:00',3.85),('8975','2014-03-21','14:10:00',4.16),('8975','2014-03-21','14:15:00',3.86),('8975','2014-03-21','14:20:00',3.62),('8975','2014-03-21','14:25:00',3.44),('8975','2014-03-21','14:30:00',3.59),('8975','2014-03-21','14:35:00',3.45),('8975','2014-03-21','14:40:00',3.25),('8975','2014-03-21','14:45:00',3.16),('8975','2014-03-21','14:50:00',2.99),('8975','2014-03-21','14:55:00',2.91),('8975','2014-03-21','15:00:00',2.93),('8975','2014-03-21','15:05:00',2.84),('8975','2014-03-21','15:10:00',2.74),('8975','2014-03-21','15:15:00',2.56),('8975','2014-03-21','15:20:00',2.51),('8975','2014-03-21','15:25:00',2.11),('8975','2014-03-21','15:30:00',1.6),('8975','2014-03-21','15:35:00',1.86),('8975','2014-03-21','15:40:00',1.98),('8975','2014-03-21','15:45:00',2.68),('8975','2014-03-21','15:50:00',2.9),('8975','2014-03-21','15:55:00',2.54),('8975','2014-03-21','16:00:00',2.29),('8975','2014-03-21','16:05:00',1.96),('8975','2014-03-21','16:10:00',1.71),('8975','2014-03-21','16:15:00',1.19),('8975','2014-03-21','17:05:00',1.09),('8975','2013-02-09','09:15:00',1.08),('8975','2013-02-09','09:40:00',1.34),('8975','2013-02-09','09:45:00',2.25),('8975','2013-02-09','09:50:00',2.78),('8975','2013-02-09','09:55:00',3.35),('8975','2013-02-09','10:00:00',3.08),('8975','2013-02-09','10:05:00',3.86),('8975','2013-02-09','10:10:00',3.67),('8975','2013-02-09','10:15:00',4.02),('8975','2013-02-09','10:20:00',3.88),('8975','2013-02-09','10:25:00',3.92),('8975','2013-02-09','10:30:00',4.38),('8975','2013-02-09','10:35:00',4.46),('8975','2013-02-09','10:40:00',4.49),('8975','2013-02-09','10:45:00',4.51),('8975','2013-02-09','10:50:00',4.56),('8975','2013-02-09','10:55:00',4.6),('8975','2013-02-09','11:00:00',4.64),('8975','2013-02-09','11:05:00',4.65),('8975','2013-02-09','11:10:00',4.64),('8975','2013-02-09','11:15:00',4.65),('8975','2013-02-09','11:20:00',4.68),('8975','2013-02-09','11:25:00',4.69),('8975','2013-02-09','11:30:00',4.7),('8975','2013-02-09','11:35:00',4.67),('8975','2013-02-09','11:40:00',4.64),('8975','2013-02-09','11:45:00',4.57),('8975','2013-02-09','11:50:00',4.25),('8975','2013-02-09','11:55:00',4.12),('8975','2013-02-09','12:00:00',4.37),('8975','2013-02-09','12:05:00',4.36),('8975','2013-02-09','12:10:00',4.43),('8975','2013-02-09','12:15:00',4.38),('8975','2013-02-09','12:20:00',4.26),('8975','2013-02-09','12:25:00',4.2),('8975','2013-02-09','12:30:00',4.2),('8975','2013-02-09','12:35:00',4.14),('8975','2013-02-09','12:40:00',4.07),('8975','2013-02-09','12:45:00',4.07),('8975','2013-02-09','12:50:00',4),('8975','2013-02-09','12:55:00',3.95),('8975','2013-02-09','13:00:00',3.87),('8975','2013-02-09','13:05:00',3.65),('8975','2013-02-09','13:10:00',3.49),('8975','2013-02-09','13:15:00',3.56),('8975','2013-02-09','13:20:00',3.65),('8975','2013-02-09','13:25:00',3.55),('8975','2013-02-09','13:30:00',3.4),('8975','2013-02-09','13:35:00',3.35),('8975','2013-02-09','13:40:00',3.2),('8975','2013-02-09','13:45:00',3.1),('8975','2013-02-09','13:50:00',2.85),('8975','2013-02-09','13:55:00',2.77),('8975','2013-02-09','14:00:00',2.79),('8975','2013-02-09','14:05:00',2.72),('8975','2013-02-09','14:10:00',2.6),('8975','2013-02-09','14:15:00',2.49),('8975','2013-02-09','14:20:00',2.42),('8975','2013-02-09','14:25:00',2.15),('8975','2013-02-09','14:30:00',1.77),('8975','2013-02-09','14:35:00',1.53),('8975','2013-02-09','14:40:00',2.12),('8975','2013-02-09','14:45:00',2.13),('8975','2013-02-09','14:50:00',2.02),('8975','2013-02-09','14:55:00',1.87),('8975','2013-02-09','15:00:00',1.82),('8975','2013-02-09','15:05:00',1.78),('8975','2013-02-09','15:10:00',1.75),('8975','2013-02-09','15:15:00',1.36),('8975','2013-02-09','15:20:00',1.55),('8975','2013-02-09','15:25:00',1.86),('8975','2013-02-09','15:30:00',1.44),('8975','2013-02-09','15:35:00',2.23),('8975','2013-02-09','15:40:00',2),('8975','2013-02-09','15:45:00',1.2),('8975','2013-02-09','16:25:00',1.1),('8975','2013-02-09','16:30:00',1.4),('8975','2013-02-09','16:35:00',1.25),('8975','2013-02-09','16:40:00',1.01),('8975','2013-02-08','09:20:00',1.11),('8975','2013-02-08','09:25:00',1.3),('8975','2013-02-08','09:30:00',1.54),('8975','2013-02-08','09:35:00',1.61),('8975','2013-02-08','09:40:00',1.38),('8975','2013-02-08','09:45:00',1.25),('8975','2013-02-08','09:50:00',1.22),('8975','2013-02-08','09:55:00',1.15),('8975','2013-02-08','10:00:00',1.02),('8975','2013-02-08','10:40:00',1.07),('8975','2013-02-08','10:45:00',1.25),('8975','2013-02-08','10:50:00',1.39),('8975','2013-02-08','10:55:00',1.49),('8975','2013-02-08','11:00:00',1.58),('8975','2013-02-08','11:05:00',1.63),('8975','2013-02-08','11:10:00',1.67),('8975','2013-02-08','11:15:00',1.77),('8975','2013-02-08','11:20:00',1.84),('8975','2013-02-08','11:25:00',1.89),('8975','2013-02-08','11:30:00',1.92),('8975','2013-02-08','11:35:00',1.87),('8975','2013-02-08','11:40:00',1.85),('8975','2013-02-08','11:45:00',1.88),('8975','2013-02-08','11:50:00',1.85),('8975','2013-02-08','11:55:00',1.81),('8975','2013-02-08','12:00:00',1.81),('8975','2013-02-08','12:05:00',1.81),('8975','2013-02-08','12:10:00',1.79),('8975','2013-02-08','12:15:00',1.82),('8975','2013-02-08','12:20:00',1.84),('8975','2013-02-08','12:25:00',1.85),('8975','2013-02-08','12:30:00',1.91),('8975','2013-02-08','12:35:00',2.01),('8975','2013-02-08','12:40:00',2.03),('8975','2013-02-08','12:45:00',2.06),('8975','2013-02-08','12:50:00',2.07),('8975','2013-02-08','12:55:00',2.04),('8975','2013-02-08','13:00:00',2.19),('8975','2013-02-08','13:05:00',2.43),('8975','2013-02-08','13:10:00',2.62),('8975','2013-02-08','13:15:00',2.76),('8975','2013-02-08','13:20:00',2.99),('8975','2013-02-08','13:25:00',3.11),('8975','2013-02-08','13:30:00',3.19),('8975','2013-02-08','13:35:00',3.24),('8975','2013-02-08','13:40:00',3.19),('8975','2013-02-08','13:45:00',3.36),('8975','2013-02-08','13:50:00',3.21),('8975','2013-02-08','13:55:00',3.35),('8975','2013-02-08','14:00:00',3.16),('8975','2013-02-08','14:05:00',3),('8975','2013-02-08','14:10:00',2.92),('8975','2013-02-08','14:15:00',2.63),('8975','2013-02-08','14:20:00',3.53),('8975','2013-02-08','14:25:00',3.34),('8975','2013-02-08','14:30:00',2.98),('8975','2013-02-08','14:35:00',2.59),('8975','2013-02-08','14:40:00',2.28),('8975','2013-02-08','14:45:00',2.11),('8975','2013-02-08','14:50:00',2.04),('8975','2013-02-08','14:55:00',1.92),('8975','2013-02-08','15:00:00',1.81),('8975','2013-02-08','15:05:00',1.71),('8975','2013-02-08','15:10:00',1.63),('8975','2013-02-08','15:15:00',1.62),('8975','2013-02-08','15:20:00',1.58),('8975','2013-02-08','15:25:00',1.54),('8975','2013-02-08','15:30:00',1.46),('8975','2013-02-08','15:35:00',1.4),('8975','2013-02-08','15:40:00',1.35),('8975','2013-02-08','15:45:00',1.24),('8975','2013-02-08','15:50:00',1.3),('8975','2013-02-08','15:55:00',1.25),('8975','2013-02-08','16:20:00',1.08),('8975','2013-02-08','16:25:00',1.02),('8975','2013-02-07','08:55:00',1.1),('8975','2013-02-07','09:20:00',1.06),('8975','2013-02-07','09:25:00',1.27),('8975','2013-02-07','09:30:00',1.35),('8975','2013-02-07','09:35:00',2.04),('8975','2013-02-07','09:40:00',4.26),('8975','2013-02-07','09:45:00',4),('8975','2013-02-07','09:50:00',4.52),('8975','2013-02-07','09:55:00',4.03),('8975','2013-02-07','10:00:00',3.34),('8975','2013-02-07','10:05:00',4.48),('8975','2013-02-07','10:10:00',4.52),('8975','2013-02-07','10:15:00',4.53),('8975','2013-02-07','10:20:00',5.03),('8975','2013-02-07','10:25:00',4.96),('8975','2013-02-07','10:30:00',3.87),('8975','2013-02-07','10:35:00',4.36),('8975','2013-02-07','10:40:00',3.2),('8975','2013-02-07','10:45:00',4.68),('8975','2013-02-07','10:50:00',4.78),('8975','2013-02-07','10:55:00',4.75),('8975','2013-02-07','11:00:00',4.82),('8975','2013-02-07','11:05:00',4.28),('8975','2013-02-07','11:10:00',4.73),('8975','2013-02-07','11:15:00',4.72),('8975','2013-02-07','11:20:00',4.72),('8975','2013-02-07','11:25:00',4.71),('8975','2013-02-07','11:30:00',4.7),('8975','2013-02-07','11:35:00',4.68),('8975','2013-02-07','11:40:00',4.66),('8975','2013-02-07','11:45:00',4.39),('8975','2013-02-07','11:50:00',4.51),('8975','2013-02-07','11:55:00',4.44),('8975','2013-02-07','12:00:00',4.32),('8975','2013-02-07','12:05:00',4.42),('8975','2013-02-07','12:10:00',4.37),('8975','2013-02-07','12:15:00',4.29),('8975','2013-02-07','12:20:00',4.24),('8975','2013-02-07','12:25:00',4.22),('8975','2013-02-07','12:30:00',4.17),('8975','2013-02-07','12:35:00',4.14),('8975','2013-02-07','12:40:00',4.24),('8975','2013-02-07','12:45:00',4.19),('8975','2013-02-07','12:50:00',2.27),('8975','2013-02-07','12:55:00',2.61),('8975','2013-02-07','13:00:00',3.18),('8975','2013-02-07','13:05:00',2.64),('8975','2013-02-07','13:10:00',2.59),('8975','2013-02-07','13:15:00',2.71),('8975','2013-02-07','13:20:00',2.56),('8975','2013-02-07','13:25:00',2.65),('8975','2013-02-07','13:30:00',2.61),('8975','2013-02-07','13:35:00',2.86),('8975','2013-02-07','13:40:00',2.4),('8975','2013-02-07','13:45:00',2.03),('8975','2013-02-07','13:50:00',2.2),('8975','2013-02-07','13:55:00',2.34),('8975','2013-02-07','14:00:00',2.14),('8975','2013-02-07','14:05:00',2.02),('8975','2013-02-07','14:10:00',1.9),('8975','2013-02-07','14:15:00',1.87),('8975','2013-02-07','14:20:00',1.91),('8975','2013-02-07','14:25:00',2.1),('8975','2013-02-07','14:30:00',2.21),('8975','2013-02-07','14:35:00',2.97),('8975','2013-02-07','14:40:00',3.5),('8975','2013-02-07','14:45:00',2.09),('8975','2013-02-07','14:50:00',2.18),('8975','2013-02-07','14:55:00',2.31),('8975','2013-02-07','15:00:00',2.9),('8975','2013-02-07','15:05:00',2.92),('8975','2013-02-07','15:10:00',2.65),('8975','2013-02-07','15:15:00',2.38),('8975','2013-02-07','15:20:00',2.1),('8975','2013-02-07','15:25:00',1.56),('8975','2013-02-07','15:30:00',1.62),('8975','2013-02-07','15:35:00',1.55),('8975','2013-02-07','15:40:00',1.49),('8975','2013-02-07','15:45:00',1.44),('8975','2013-02-07','15:50:00',1.39),('8975','2013-02-07','15:55:00',1.33),('8975','2013-02-07','16:00:00',1.3),('8975','2013-02-07','16:05:00',1.23),('8975','2013-02-07','16:10:00',1.18),('8975','2013-02-07','16:15:00',1.13),('8975','2013-02-06','10:25:00',1.17),('8975','2013-02-06','10:30:00',1.11),('8975','2013-02-06','10:35:00',1.54),('8975','2013-02-06','10:40:00',1.54),('8975','2013-02-06','10:45:00',1.37),('8975','2013-02-06','10:50:00',1.12),('8975','2013-02-06','10:55:00',1.64),('8975','2013-02-06','11:00:00',1.81),('8975','2013-02-06','11:05:00',2.01),('8975','2013-02-06','11:10:00',1.46),('8975','2013-02-06','12:20:00',2.48),('8975','2013-02-06','12:25:00',3.75),('8975','2013-02-06','12:30:00',2.4),('8975','2013-02-06','12:35:00',1.42),('8975','2013-02-06','12:45:00',1.02),('8975','2013-02-06','12:50:00',1.15),('8975','2013-02-06','13:10:00',1.25),('8975','2013-02-06','13:15:00',2.62),('8975','2013-02-06','13:20:00',1.46),('8975','2013-02-06','13:25:00',1.94),('8975','2013-02-06','13:30:00',1.5),('8975','2013-02-06','13:45:00',1.37),('8975','2013-02-06','13:50:00',1.28),('8975','2013-02-06','13:55:00',1.57),('8975','2013-02-06','14:00:00',2.05),('8975','2013-02-06','14:05:00',2.14),('8975','2013-02-06','14:10:00',2.78),('8975','2013-02-06','14:15:00',2.61),('8975','2013-02-06','14:20:00',1.98),('8975','2013-02-06','14:25:00',1.47),('8975','2013-02-06','14:30:00',1.12),('8975','2013-02-06','14:35:00',1.58),('8975','2013-02-06','14:40:00',2.71),('8975','2013-02-06','14:45:00',2.83),('8975','2013-02-06','14:50:00',2.01),('8975','2013-02-06','14:55:00',2.01),('8975','2013-02-06','15:00:00',1.79),('8975','2013-02-06','15:05:00',2.63),('8975','2013-02-06','15:10:00',2.5),('8975','2013-02-06','15:15:00',2.81),('8975','2013-02-06','15:20:00',2),('8975','2013-02-06','15:25:00',2.19),('8975','2013-02-06','15:30:00',2.36),('8975','2013-02-06','15:35:00',1.79),('8975','2013-02-06','15:40:00',1.24),('8975','2013-02-05','07:55:00',1.14),('8975','2013-02-05','08:35:00',1.37),('8975','2013-02-05','08:40:00',1.54),('8975','2013-02-05','08:45:00',1.98),('8975','2013-02-05','08:50:00',2.67),('8975','2013-02-05','08:55:00',1.77),('8975','2013-02-05','09:00:00',2.17),('8975','2013-02-05','09:05:00',2.1),('8975','2013-02-05','09:10:00',2.36),('8975','2013-02-05','09:15:00',1.77),('8975','2013-02-05','09:20:00',1.76),('8975','2013-02-05','09:25:00',1.94),('8975','2013-02-05','09:30:00',2.6),('8975','2013-02-05','09:35:00',1.9),('8975','2013-02-05','09:40:00',1.97),('8975','2013-02-05','09:45:00',2.15),('8975','2013-02-05','09:50:00',2.23),('8975','2013-02-05','09:55:00',2.71),('8975','2013-02-05','10:00:00',2.38),('8975','2013-02-05','10:05:00',2.62),('8975','2013-02-05','10:10:00',2.68),('8975','2013-02-05','10:15:00',2.05),('8975','2013-02-05','10:20:00',1.9),('8975','2013-02-05','10:25:00',2.38),('8975','2013-02-05','10:30:00',2.25),('8975','2013-02-05','10:35:00',3.08),('8975','2013-02-05','10:40:00',2.11),('8975','2013-02-05','10:45:00',1.96),('8975','2013-02-05','10:50:00',4.02),('8975','2013-02-05','10:55:00',3.31),('8975','2013-02-05','11:00:00',2.32),('8975','2013-02-05','11:05:00',2.3),('8975','2013-02-05','11:10:00',2.56),('8975','2013-02-05','11:15:00',2.21),('8975','2013-02-05','11:20:00',3.05),('8975','2013-02-05','11:25:00',3.63),('8975','2013-02-05','11:30:00',2.6),('8975','2013-02-05','11:35:00',2.35),('8975','2013-02-05','11:40:00',2.47),('8975','2013-02-05','11:45:00',2.49),('8975','2013-02-05','11:50:00',2.47),('8975','2013-02-05','11:55:00',2.33),('8975','2013-02-05','12:00:00',2.15),('8975','2013-02-05','12:05:00',1.7),('8975','2013-02-05','12:10:00',1.4),('8975','2013-02-05','12:15:00',1.81),('8975','2013-02-05','12:20:00',1.64),('8975','2013-02-05','12:25:00',1.66),('8975','2013-02-05','12:30:00',1.37),('8975','2013-02-05','12:35:00',1.11),('8975','2013-02-05','12:45:00',1.04),('8975','2013-02-05','12:50:00',1.02),('8975','2013-02-05','12:55:00',1.03),('8975','2013-02-05','13:10:00',1.06),('8975','2013-02-05','13:15:00',1.26),('8975','2013-02-05','13:20:00',1.38),('8975','2013-02-05','13:25:00',1.51),('8975','2013-02-05','13:30:00',1.74),('8975','2013-02-05','13:35:00',1.75),('8975','2013-02-05','13:40:00',1.61),('8975','2013-02-05','13:45:00',1.47),('8975','2013-02-05','13:50:00',1.8),('8975','2013-02-05','13:55:00',1.97),('8975','2013-02-05','14:00:00',2.22),('8975','2013-02-05','14:05:00',1.8),('8975','2013-02-05','14:10:00',1.28),('8975','2013-02-05','14:30:00',3.14),('8975','2013-02-05','14:35:00',2.13),('8975','2013-02-05','14:40:00',1.89),('8975','2013-02-05','15:25:00',1.34),('8975','2013-02-04','07:50:00',1.11),('8975','2013-02-04','07:55:00',1.34),('8975','2013-02-04','08:00:00',1.55),('8975','2013-02-04','08:05:00',1.74),('8975','2013-02-04','08:10:00',1.88),('8975','2013-02-04','08:15:00',2.02),('8975','2013-02-04','08:20:00',2.11),('8975','2013-02-04','08:25:00',2.24),('8975','2013-02-04','08:30:00',2.38),('8975','2013-02-04','08:35:00',2.49),('8975','2013-02-04','08:40:00',2.57),('8975','2013-02-04','08:45:00',2.64),('8975','2013-02-04','08:50:00',2.72),('8975','2013-02-04','08:55:00',2.8),('8975','2013-02-04','09:00:00',2.89),('8975','2013-02-04','09:05:00',2.93),('8975','2013-02-04','09:10:00',3.04),('8975','2013-02-04','09:15:00',3.14),('8975','2013-02-04','09:20:00',3.22),('8975','2013-02-04','09:25:00',3.31),('8975','2013-02-04','09:30:00',3.36),('8975','2013-02-04','09:35:00',3.43),('8975','2013-02-04','09:40:00',3.44),('8975','2013-02-04','09:45:00',3.44),('8975','2013-02-04','09:50:00',3.53),('8975','2013-02-04','09:55:00',3.63),('8975','2013-02-04','10:00:00',3.71),('8975','2013-02-04','10:05:00',3.75),('8975','2013-02-04','10:10:00',3.46),('8975','2013-02-04','10:15:00',3.47),('8975','2013-02-04','10:20:00',3.6),('8975','2013-02-04','10:25:00',3.88),('8975','2013-02-04','10:30:00',3.86),('8975','2013-02-04','10:35:00',3.84),('8975','2013-02-04','10:40:00',3.87),('8975','2013-02-04','10:45:00',3.94),('8975','2013-02-04','10:50:00',3.93),('8975','2013-02-04','10:55:00',3.96),('8975','2013-02-04','11:00:00',3.91),('8975','2013-02-04','11:05:00',3.85),('8975','2013-02-04','11:10:00',3.88),('8975','2013-02-04','11:15:00',3.89),('8975','2013-02-04','11:20:00',4),('8975','2013-02-04','11:25:00',3.94),('8975','2013-02-04','11:30:00',3.74),('8975','2013-02-04','11:35:00',3.64),('8975','2013-02-04','11:40:00',3.82),('8975','2013-02-04','11:45:00',4.07),('8975','2013-02-04','11:50:00',2.82),('8975','2013-02-04','11:55:00',2.41),('8975','2013-02-04','12:00:00',2.38),('8975','2013-02-04','12:05:00',2.19),('8975','2013-02-04','12:10:00',1.81),('8975','2013-02-04','12:15:00',2.87),('8975','2013-02-04','12:20:00',2.13),('8975','2013-02-04','12:25:00',1.85),('8975','2013-02-04','12:30:00',1.64),('8975','2013-02-04','12:35:00',2.42),('8975','2013-02-04','12:40:00',2.47),('8975','2013-02-04','12:45:00',3.37),('8975','2013-02-04','12:50:00',2.64),('8975','2013-02-04','12:55:00',1.49),('8975','2013-02-04','13:00:00',1),('8975','2013-02-04','13:05:00',1.56),('8975','2013-02-04','13:10:00',2.07),('8975','2013-02-04','13:15:00',1.81),('8975','2013-02-04','13:20:00',1.82),('8975','2013-02-04','13:25:00',2.15),('8975','2013-02-04','13:30:00',2.03),('8975','2013-02-04','13:35:00',1.55),('8975','2013-02-04','13:40:00',1.47),('8975','2013-02-04','13:45:00',1.66),('8975','2013-02-04','13:50:00',1.89),('8975','2013-02-04','13:55:00',1.81),('8975','2013-02-04','14:00:00',1.78),('8975','2013-02-04','14:05:00',1.76),('8975','2013-02-04','14:10:00',1.5),('8975','2013-02-04','14:15:00',1.31),('8975','2013-02-04','14:20:00',1.92),('8975','2013-02-04','14:25:00',2.29),('8975','2013-02-04','14:30:00',2.13),('8975','2013-02-04','14:35:00',2.03),('8975','2013-02-04','14:40:00',2.38),('8975','2013-02-04','14:45:00',2.36),('8975','2013-02-04','14:50:00',1.22),('8975','2013-02-04','14:55:00',1.12),('8975','2013-02-04','15:00:00',1.09),('8975','2013-02-04','15:05:00',1.42),('8975','2013-02-04','15:10:00',1.33),('8975','2013-02-04','15:15:00',1.12),('8975','2013-02-03','07:50:00',1.05),('8975','2013-02-03','07:55:00',1.45),('8975','2013-02-03','08:00:00',1.64),('8975','2013-02-03','08:05:00',1.83),('8975','2013-02-03','08:10:00',1.96),('8975','2013-02-03','08:15:00',2.11),('8975','2013-02-03','08:20:00',2.24),('8975','2013-02-03','08:25:00',2.35),('8975','2013-02-03','08:30:00',2.48),('8975','2013-02-03','08:35:00',2.6),('8975','2013-02-03','08:40:00',2.68),('8975','2013-02-03','08:45:00',2.75),('8975','2013-02-03','08:50:00',2.83),('8975','2013-02-03','08:55:00',2.6),('8975','2013-02-03','09:00:00',3.03),('8975','2013-02-03','09:05:00',3.17),('8975','2013-02-03','09:10:00',3.27),('8975','2013-02-03','09:15:00',3.39),('8975','2013-02-03','09:20:00',3.27),('8975','2013-02-03','09:25:00',3.18),('8975','2013-02-03','09:30:00',3.43),('8975','2013-02-03','09:35:00',3.45),('8975','2013-02-03','09:40:00',3.5),('8975','2013-02-03','09:45:00',3.07),('8975','2013-02-03','09:50:00',3.46),('8975','2013-02-03','09:55:00',3.81),('8975','2013-02-03','10:00:00',3.91),('8975','2013-02-03','10:05:00',4.03),('8975','2013-02-03','10:10:00',4.15),('8975','2013-02-03','10:15:00',4.23),('8975','2013-02-03','10:20:00',3.93),('8975','2013-02-03','10:25:00',4.12),('8975','2013-02-03','10:30:00',4.02),('8975','2013-02-03','10:35:00',3.67),('8975','2013-02-03','10:40:00',3.86),('8975','2013-02-03','10:45:00',4.23),('8975','2013-02-03','10:50:00',4.24),('8975','2013-02-03','10:55:00',4.27),('8975','2013-02-03','11:00:00',4.27),('8975','2013-02-03','11:05:00',4.33),('8975','2013-02-03','11:10:00',4.33),('8975','2013-02-03','11:15:00',4.34),('8975','2013-02-03','11:20:00',4.34),('8975','2013-02-03','11:25:00',4.31),('8975','2013-02-03','11:30:00',4.32),('8975','2013-02-03','11:35:00',4.29),('8975','2013-02-03','11:40:00',4.28),('8975','2013-02-03','11:45:00',3.99),('8975','2013-02-03','11:50:00',3.69),('8975','2013-02-03','11:55:00',4),('8975','2013-02-03','12:00:00',3.99),('8975','2013-02-03','12:05:00',4.01),('8975','2013-02-03','12:10:00',4.04),('8975','2013-02-03','12:15:00',4),('8975','2013-02-03','12:20:00',3.92),('8975','2013-02-03','12:25:00',3.86),('8975','2013-02-03','12:30:00',3.83),('8975','2013-02-03','12:35:00',3.78),('8975','2013-02-03','12:40:00',3.73),('8975','2013-02-03','12:45:00',3.62),('8975','2013-02-03','12:50:00',3.59),('8975','2013-02-03','12:55:00',3.45),('8975','2013-02-03','13:00:00',3.36),('8975','2013-02-03','13:05:00',3.39),('8975','2013-02-03','13:10:00',3.4),('8975','2013-02-03','13:15:00',3.38),('8975','2013-02-03','13:20:00',3.27),('8975','2013-02-03','13:25:00',3.1),('8975','2013-02-03','13:30:00',2.95),('8975','2013-02-03','13:35:00',2.74),('8975','2013-02-03','13:40:00',2.82),('8975','2013-02-03','13:45:00',2.51),('8975','2013-02-03','13:50:00',2.61),('8975','2013-02-03','13:55:00',2.43),('8975','2013-02-03','14:00:00',2.33),('8975','2013-02-03','14:05:00',2.23),('8975','2013-02-03','14:10:00',2.33),('8975','2013-02-03','14:15:00',2.13),('8975','2013-02-03','14:20:00',1.85),('8975','2013-02-03','14:25:00',1.81),('8975','2013-02-03','14:30:00',1.94),('8975','2013-02-03','14:35:00',1.79),('8975','2013-02-03','14:40:00',1.31),('8975','2013-02-03','14:45:00',1.62),('8975','2013-02-03','14:50:00',1.58),('8975','2013-02-03','14:55:00',1.53),('8975','2013-02-03','15:00:00',1.6),('8975','2013-02-03','15:05:00',1.53),('8975','2013-02-03','15:10:00',1.49),('8975','2013-02-03','15:15:00',1.48),('8975','2013-02-03','15:20:00',1.45),('8975','2013-02-03','15:25:00',1.41),('8975','2013-02-03','15:30:00',1.38),('8975','2013-02-03','15:35:00',1.34),('8975','2013-02-03','15:40:00',1.31),('8975','2013-02-03','15:45:00',1.28),('8975','2013-02-03','15:50:00',1.25),('8975','2013-02-03','15:55:00',1.21),('8975','2013-02-03','16:00:00',1.17),('8975','2013-02-03','16:05:00',1.13),('8975','2013-02-03','16:10:00',1.09),('8975','2013-02-03','16:15:00',1.04),('8975','2013-02-02','08:40:00',1.36),('8975','2013-02-02','08:45:00',1.16),('8975','2013-02-02','09:00:00',1.33),('8975','2013-02-02','09:15:00',1.09),('8975','2013-02-02','09:20:00',1.49),('8975','2013-02-02','09:25:00',1.59),('8975','2013-02-02','09:30:00',1.37),('8975','2013-02-02','09:35:00',1.48),('8975','2013-02-02','09:40:00',2.78),('8975','2013-02-02','09:45:00',4.55),('8975','2013-02-02','09:50:00',2.38),('8975','2013-02-02','09:55:00',2.78),('8975','2013-02-02','10:00:00',3.55),('8975','2013-02-02','10:05:00',1.53),('8975','2013-02-02','10:10:00',1.11),('8975','2013-02-02','10:15:00',2.16),('8975','2013-02-02','10:20:00',2.38),('8975','2013-02-02','10:25:00',1.46),('8975','2013-02-02','10:30:00',1.25),('8975','2013-02-02','10:35:00',1.2),('8975','2013-02-02','10:40:00',1.08),('8975','2013-02-02','11:15:00',2.23),('8975','2013-02-02','11:20:00',1.89),('8975','2013-02-02','11:40:00',1.1),('8975','2013-02-02','11:45:00',1.82),('8975','2013-02-02','11:50:00',2.02),('8975','2013-02-02','11:55:00',1.96),('8975','2013-02-02','12:00:00',1.83),('8975','2013-02-02','12:05:00',1.8),('8975','2013-02-02','12:10:00',1.6),('8975','2013-02-02','12:15:00',1.09),('8975','2013-02-02','13:50:00',1.16),('8975','2013-02-02','14:55:00',1),('8975','2013-02-01','10:05:00',1.08),('8975','2013-02-01','10:10:00',1.28),('8975','2013-02-01','10:15:00',1.94),('8975','2013-02-01','10:20:00',1.97),('8975','2013-02-01','10:25:00',1.78),('8975','2013-02-01','10:30:00',2.03),('8975','2013-02-01','10:35:00',2.09),('8975','2013-02-01','10:40:00',2.2),('8975','2013-02-01','10:45:00',2.34),('8975','2013-02-01','10:50:00',2.17),('8975','2013-02-01','10:55:00',2.85),('8975','2013-02-01','11:00:00',3.12),('8975','2013-02-01','11:05:00',2.64),('8975','2013-02-01','11:10:00',2.83),('8975','2013-02-01','11:15:00',3.03),('8975','2013-02-01','11:20:00',2.88),('8975','2013-02-01','11:25:00',3.48),('8975','2013-02-01','11:30:00',3.16),('8975','2013-02-01','11:35:00',2.74),('8975','2013-02-01','11:40:00',2.6),('8975','2013-02-01','11:45:00',2.17),('8975','2013-02-01','11:50:00',2.23),('8975','2013-02-01','11:55:00',1.71),('8975','2013-02-01','12:00:00',1.33),('8975','2013-02-01','12:05:00',1.08),('8975','2013-02-01','12:50:00',1.42),('8975','2013-02-01','12:55:00',2.8),('8975','2013-02-01','13:00:00',1.86),('8975','2013-02-01','13:05:00',2.14),('8975','2013-02-01','13:10:00',2.49),('8975','2013-02-01','13:15:00',2.5),('8975','2013-02-01','13:20:00',2.24),('8975','2013-02-01','13:25:00',2.21),('8975','2013-02-01','13:30:00',2.01),('8975','2013-02-01','13:35:00',2.56),('8975','2013-02-01','13:40:00',2.77),('8975','2013-02-01','13:45:00',2.63),('8975','2013-02-01','13:50:00',2.31),('8975','2013-02-01','13:55:00',1.54),('8975','2013-01-31','08:15:00',1.38),('8975','2013-01-31','08:20:00',1.49),('8975','2013-01-31','08:25:00',1),('8975','2013-01-31','08:30:00',1.89),('8975','2013-01-31','08:35:00',1.85),('8975','2013-01-31','08:40:00',1.69),('8975','2013-01-31','08:45:00',2.05),('8975','2013-01-31','08:50:00',1.35),('8975','2013-01-31','09:00:00',1.1),('8975','2013-01-31','09:05:00',1.47),('8975','2013-01-31','09:10:00',1.06),('8975','2013-01-31','09:15:00',1.39),('8975','2013-01-31','09:20:00',1.11),('8975','2013-01-31','09:30:00',1.38),('8975','2013-01-31','09:35:00',1.47),('8975','2013-01-31','09:40:00',1.33),('8975','2013-01-31','09:45:00',1.42),('8975','2013-01-31','09:50:00',1.6),('8975','2013-01-31','09:55:00',1.16),('8975','2013-01-31','10:00:00',1.04),('8975','2013-01-31','10:10:00',2.5),('8975','2013-01-31','10:15:00',3),('8975','2013-01-31','10:20:00',1.96),('8975','2013-01-31','10:25:00',3.44),('8975','2013-01-31','10:30:00',3.81),('8975','2013-01-31','10:35:00',1.61),('8975','2013-01-31','10:40:00',1.91),('8975','2013-01-31','10:45:00',3.14),('8975','2013-01-31','10:50:00',2.32),('8975','2013-01-31','10:55:00',3.8),('8975','2013-01-31','11:00:00',4.03),('8975','2013-01-31','11:05:00',3.59),('8975','2013-01-31','11:10:00',4.25),('8975','2013-01-31','11:15:00',4.58),('8975','2013-01-31','11:20:00',4.91),('8975','2013-01-31','11:25:00',5.21),('8975','2013-01-31','11:30:00',5.16),('8975','2013-01-31','11:35:00',5.26),('8975','2013-01-31','11:40:00',4.98),('8975','2013-01-31','11:45:00',4.82),('8975','2013-01-31','11:50:00',4.08),('8975','2013-01-31','11:55:00',4.09),('8975','2013-01-31','12:00:00',4.72),('8975','2013-01-31','12:05:00',4.36),('8975','2013-01-31','12:10:00',4.3),('8975','2013-01-31','12:15:00',3.93),('8975','2013-01-31','12:20:00',3.2),('8975','2013-01-31','12:25:00',1.79),('8975','2013-01-31','12:30:00',2.87),('8975','2013-01-31','12:35:00',3.99),('8975','2013-01-31','12:40:00',3.67),('8975','2013-01-31','12:45:00',3.27),('8975','2013-01-31','12:50:00',3.8),('8975','2013-01-31','12:55:00',2.29),('8975','2013-01-31','13:00:00',3.68),('8975','2013-01-31','13:05:00',3.29),('8975','2013-01-31','13:10:00',3.02),('8975','2013-01-31','13:15:00',3.2),('8975','2013-01-31','13:20:00',2.47),('8975','2013-01-31','13:25:00',3.24),('8975','2013-01-31','13:30:00',3.05),('8975','2013-01-31','13:35:00',2.55),('8975','2013-01-31','13:40:00',2.71),('8975','2013-01-31','13:45:00',2.31),('8975','2013-01-31','13:50:00',2.29),('8975','2013-01-31','13:55:00',3.25),('8975','2013-01-31','14:00:00',1.99),('8975','2013-01-31','14:05:00',1.95),('8975','2013-01-31','14:10:00',2.12),('8975','2013-01-31','14:15:00',2.41),('8975','2013-01-31','14:20:00',2.06),('8975','2013-01-31','14:25:00',1.98),('8975','2013-01-31','14:30:00',2.02),('8975','2013-01-31','14:35:00',1.47),('8975','2013-01-31','14:40:00',1.92),('8975','2013-01-31','14:45:00',1.61),('8975','2013-01-31','14:50:00',1.15),('8975','2013-01-31','14:55:00',1.74),('8975','2013-01-31','15:05:00',1.26),('8975','2013-01-31','15:10:00',1.94),('8975','2013-01-31','15:15:00',1.63),('8975','2013-01-31','15:20:00',1.5),('8975','2013-01-31','15:25:00',1.24),('8975','2013-01-31','15:30:00',1.31),('8975','2013-01-31','15:35:00',1.03),('8975','2013-01-31','15:40:00',1.06),('8975','2013-01-31','15:50:00',1.34),('8975','2014-03-20','07:00:00',1.11),('8975','2014-03-20','07:05:00',1.04),('8975','2014-03-20','07:14:00',1.2),('8975','2014-03-20','07:15:00',1.72),('8975','2014-03-20','07:20:00',1.82),('8975','2014-03-20','07:25:00',1.79),('8975','2014-03-20','07:30:00',1.85),('8975','2014-03-20','07:35:00',2.19),('8975','2014-03-20','07:40:00',2.42),('8975','2014-03-20','07:46:00',2.55),('8975','2014-03-20','07:50:00',2.85),('8975','2014-03-20','07:55:00',2.92),('8975','2014-03-20','08:00:00',3.03),('8975','2014-03-20','08:05:00',3.1),('8975','2014-03-20','08:10:00',3.24),('8975','2014-03-20','08:16:00',3.33),('8975','2014-03-20','08:20:00',3.41),('8975','2014-03-20','08:25:00',3.52),('8975','2014-03-20','08:30:00',3.66),('8975','2014-03-20','08:35:00',3.72),('8975','2014-03-20','08:40:00',3.81),('8975','2014-03-20','08:45:00',3.87),('8975','2014-03-20','08:50:00',4),('8975','2014-03-20','08:55:00',4.06),('8975','2014-03-20','09:00:00',4.19),('8975','2014-03-20','09:05:00',4.21),('8975','2014-03-20','09:10:00',4.39),('8975','2014-03-20','09:15:00',4.43),('8975','2014-03-20','09:20:00',4.46),('8975','2014-03-20','09:25:00',4.69),('8975','2014-03-20','09:30:00',4.6),('8975','2014-03-20','09:35:00',4.68),('8975','2014-03-20','09:40:00',4.87),('8975','2014-03-20','09:45:00',4.9),('8975','2014-03-20','09:50:00',4.95),('8975','2014-03-20','09:55:00',4.93),('8975','2014-03-20','10:00:00',5),('8975','2014-03-20','10:05:00',4.99),('8975','2014-03-20','10:10:00',5),('8975','2014-03-20','10:15:00',5.06),('8975','2014-03-20','10:20:00',5.06),('8975','2014-03-20','10:25:00',5.11),('8975','2014-03-20','10:30:00',5.22),('8975','2014-03-20','10:35:00',5.25),('8975','2014-03-20','10:40:00',5.3),('8975','2014-03-20','10:45:00',5.25),('8975','2014-03-20','10:50:00',5.2),('8975','2014-03-20','10:55:00',5.16),('8975','2014-03-20','11:00:00',5.31),('8975','2014-03-20','11:05:00',5.27),('8975','2014-03-20','11:10:00',5.29),('8975','2014-03-20','11:15:00',5.24),('8975','2014-03-20','11:20:00',5.43),('8975','2014-03-20','11:25:00',5.41),('8975','2014-03-20','11:30:00',5.54),('8975','2014-03-20','11:35:00',5.15),('8975','2014-03-20','11:40:00',2.72),('8975','2014-03-20','11:45:00',2.87),('8975','2014-03-20','11:50:00',6.07),('8975','2014-03-20','11:55:00',5.82),('8975','2014-03-20','12:00:00',5.62),('8975','2014-03-20','12:05:00',5.52),('8975','2014-03-20','12:10:00',5.44),('8975','2014-03-20','12:15:00',5.43),('8975','2014-03-20','12:20:00',5.31),('8975','2014-03-20','12:25:00',5.29),('8975','2014-03-20','12:30:00',5.32),('8975','2014-03-20','12:35:00',5.3),('8975','2014-03-20','12:40:00',5.33),('8975','2014-03-20','12:45:00',5.25),('8975','2014-03-20','12:50:00',5.09),('8975','2014-03-20','12:55:00',5.11),('8975','2014-03-20','13:00:00',5.01),('8975','2014-03-20','13:05:00',4.99),('8975','2014-03-20','13:10:00',4.95),('8975','2014-03-20','13:15:00',4.91),('8975','2014-03-20','13:20:00',4.73),('8975','2014-03-20','13:25:00',4.64),('8975','2014-03-20','13:30:00',4.47),('8975','2014-03-20','13:35:00',4.51),('8975','2014-03-20','13:40:00',4.43),('8975','2014-03-20','13:45:00',4.38),('8975','2014-03-20','13:50:00',4.28),('8975','2014-03-20','13:55:00',4.22),('8975','2014-03-20','14:00:00',4.12),('8975','2014-03-20','14:05:00',4.03),('8975','2014-03-20','14:10:00',3.92),('8975','2014-03-20','14:15:00',3.85),('8975','2014-03-20','14:20:00',3.73),('8975','2014-03-20','14:25:00',3.62),('8975','2014-03-20','14:30:00',3.41),('8975','2014-03-20','14:35:00',3.23),('8975','2014-03-20','14:40:00',3.11),('8975','2014-03-20','14:45:00',3.02),('8975','2014-03-20','14:50:00',1.99),('8975','2014-03-20','14:55:00',1.18),('8975','2014-03-20','15:00:00',1.33),('8975','2014-03-20','15:05:00',2.3),('8975','2014-03-20','15:10:00',3.46),('8975','2014-03-20','15:15:00',3.25),('8975','2014-03-20','15:20:00',3.03),('8975','2014-03-20','15:25:00',3.29),('8975','2014-03-20','15:30:00',2.96),('8975','2014-03-20','15:35:00',2.96),('8975','2014-03-20','15:40:00',2.84),('8975','2014-03-20','15:45:00',2.8),('8975','2014-03-20','15:50:00',2.71),('8975','2014-03-20','15:55:00',2.57),('8975','2014-03-20','16:00:00',2.37),('8975','2014-03-20','16:05:00',2.19),('8975','2014-03-20','16:10:00',2.04),('8975','2014-03-20','16:15:00',1.86),('8975','2014-03-20','16:20:00',1.65),('8975','2014-03-20','16:25:00',1.56),('8975','2014-03-20','16:30:00',1.44),('8975','2014-03-20','16:35:00',1.39),('8975','2014-03-20','16:40:00',1.34),('8975','2014-03-20','16:45:00',1.3),('8975','2014-03-20','16:50:00',1.22),('8975','2014-03-20','16:55:00',1.16),('8975','2014-03-20','17:00:00',1.02),('8975','2014-03-20','17:05:00',1),('8975','2013-01-30','09:05:00',1.6),('8975','2013-01-30','09:10:00',2.43),('8975','2013-01-30','09:15:00',1.45),('8975','2013-01-30','09:20:00',1.71),('8975','2013-01-30','09:25:00',1.14),('8975','2013-01-30','09:30:00',1.57),('8975','2013-01-30','09:35:00',2.55),('8975','2013-01-30','09:40:00',2.89),('8975','2013-01-30','09:45:00',2.51),('8975','2013-01-30','09:50:00',1.62),('8975','2013-01-30','09:55:00',1.05),('8975','2013-01-30','10:00:00',1.07),('8975','2013-01-30','10:05:00',3.46),('8975','2013-01-30','10:10:00',3.44),('8975','2013-01-30','10:15:00',3.14),('8975','2013-01-30','10:20:00',3.15),('8975','2013-01-30','10:25:00',3.39),('8975','2013-01-30','10:30:00',3.54),('8975','2013-01-30','10:35:00',3.39),('8975','2013-01-30','10:40:00',3.31),('8975','2013-01-30','10:45:00',3.72),('8975','2013-01-30','10:50:00',3.71),('8975','2013-01-30','10:55:00',4.05),('8975','2013-01-30','11:00:00',3.98),('8975','2013-01-30','11:05:00',2.98),('8975','2013-01-30','11:10:00',1.69),('8975','2013-01-30','11:15:00',3.87),('8975','2013-01-30','11:20:00',3.85),('8975','2013-01-30','11:25:00',4.13),('8975','2013-01-30','11:30:00',3.93),('8975','2013-01-30','11:35:00',3.93),('8975','2013-01-30','11:40:00',3.74),('8975','2013-01-30','11:45:00',3.67),('8975','2013-01-30','11:50:00',3.79),('8975','2013-01-30','11:55:00',3.63),('8975','2013-01-30','12:00:00',3.57),('8975','2013-01-30','12:05:00',3.64),('8975','2013-01-30','12:10:00',3.56),('8975','2013-01-30','12:15:00',3.48),('8975','2013-01-30','12:20:00',3.47),('8975','2013-01-30','12:25:00',3.45),('8975','2013-01-30','12:30:00',3.38),('8975','2013-01-30','12:35:00',3.37),('8975','2013-01-30','12:40:00',3.29),('8975','2013-01-30','12:45:00',3.29),('8975','2013-01-30','12:50:00',3.24),('8975','2013-01-30','12:55:00',3.11),('8975','2013-01-30','13:00:00',3.05),('8975','2013-01-30','13:05:00',3.04),('8975','2013-01-30','13:10:00',3.01),('8975','2013-01-30','13:15:00',2.99),('8975','2013-01-30','13:20:00',2.91),('8975','2013-01-30','13:25:00',2.67),('8975','2013-01-30','13:30:00',2.72),('8975','2013-01-30','13:35:00',2.58),('8975','2013-01-30','13:40:00',2.6),('8975','2013-01-30','13:45:00',2.46),('8975','2013-01-30','13:50:00',2.46),('8975','2013-01-30','13:55:00',2.32),('8975','2013-01-30','14:00:00',2.18),('8975','2013-01-30','14:05:00',2.14),('8975','2013-01-30','14:10:00',2.08),('8975','2013-01-30','14:15:00',2.01),('8975','2013-01-30','14:20:00',1.92),('8975','2013-01-30','14:25:00',1.9),('8975','2013-01-30','14:30:00',1.82),('8975','2013-01-30','14:35:00',1.74),('8975','2013-01-30','14:40:00',1.66),('8975','2013-01-30','14:45:00',1.58),('8975','2013-01-30','14:50:00',1.55),('8975','2013-01-30','14:55:00',1.52),('8975','2013-01-30','15:00:00',1.48),('8975','2013-01-30','15:05:00',1.47),('8975','2013-01-30','15:10:00',1.42),('8975','2013-01-30','15:15:00',1.46),('8975','2013-01-30','15:20:00',1.46),('8975','2013-01-30','15:25:00',1.3),('8975','2013-01-30','15:30:00',1.28),('8975','2013-01-30','15:35:00',1.38),('8975','2013-01-30','15:40:00',1.31),('8975','2013-01-30','15:45:00',1.23),('8975','2013-01-30','15:50:00',1.17),('8975','2013-01-30','15:55:00',1.11),('8975','2013-01-29','09:20:00',1.22),('8975','2013-01-29','09:25:00',1.36),('8975','2013-01-29','09:30:00',1.47),('8975','2013-01-29','09:35:00',1.53),('8975','2013-01-29','09:40:00',1.28),('8975','2013-01-29','09:45:00',1.15),('8975','2013-01-29','10:00:00',1.62),('8975','2013-01-29','10:05:00',1.62),('8975','2013-01-29','10:10:00',2.59),('8975','2013-01-29','10:15:00',2.3),('8975','2013-01-29','10:20:00',2.7),('8975','2013-01-29','10:25:00',2.34),('8975','2013-01-29','10:30:00',2),('8975','2013-01-29','10:35:00',1.94),('8975','2013-01-29','10:40:00',2.37),('8975','2013-01-29','10:45:00',2.38),('8975','2013-01-29','10:50:00',3.58),('8975','2013-01-29','10:55:00',2.86),('8975','2013-01-29','11:00:00',2.73),('8975','2013-01-29','11:05:00',3),('8975','2013-01-29','11:10:00',2.88),('8975','2013-01-29','11:15:00',3.62),('8975','2013-01-29','11:20:00',3.45),('8975','2013-01-29','11:25:00',3.52),('8975','2013-01-29','11:30:00',3.64),('8975','2013-01-29','11:35:00',3.37),('8975','2013-01-29','11:40:00',3.74),('8975','2013-01-29','11:45:00',2.18),('8975','2013-01-29','11:50:00',2.59),('8975','2013-01-29','11:55:00',2.57),('8975','2013-01-29','12:00:00',1.89),('8975','2013-01-29','12:05:00',2.63),('8975','2013-01-29','12:10:00',3.77),('8975','2013-01-29','12:15:00',2.91),('8975','2013-01-29','12:20:00',1.55),('8975','2013-01-29','12:25:00',1.28),('8975','2013-01-29','12:30:00',1.37),('8975','2013-01-29','12:35:00',2.94),('8975','2013-01-29','12:40:00',3.45),('8975','2013-01-29','12:45:00',3.95),('8975','2013-01-29','12:50:00',3.7),('8975','2013-01-29','12:55:00',3.45),('8975','2013-01-29','13:00:00',3.28),('8975','2013-01-29','13:05:00',3.27),('8975','2013-01-29','13:10:00',3.17),('8975','2013-01-29','13:15:00',3.2),('8975','2013-01-29','13:20:00',3.15),('8975','2013-01-29','13:25:00',1.89),('8975','2013-01-29','13:35:00',2.23),('8975','2013-01-29','13:40:00',2.26),('8975','2013-01-29','13:45:00',2.58),('8975','2013-01-29','13:50:00',2.75),('8975','2013-01-29','13:55:00',2.42),('8975','2013-01-29','14:00:00',1.71),('8975','2013-01-29','14:05:00',1.4),('8975','2013-01-29','14:10:00',1.7),('8975','2013-01-29','14:15:00',1.92),('8975','2013-01-29','14:20:00',1.78),('8975','2013-01-29','14:25:00',1.41),('8975','2013-01-29','14:30:00',1.7),('8975','2013-01-29','14:35:00',1.71),('8975','2013-01-29','14:40:00',1.95),('8975','2013-01-29','14:45:00',1.61),('8975','2013-01-29','14:50:00',1.26),('8975','2013-01-29','14:55:00',1.24),('8975','2013-01-29','15:00:00',1.29),('8975','2013-01-29','15:05:00',1.35),('8975','2013-01-29','15:10:00',1.17),('8975','2013-01-29','15:15:00',1.06),('8975','2013-01-28','08:00:00',1.12),('8975','2013-01-28','08:05:00',1.33),('8975','2013-01-28','08:10:00',1.49),('8975','2013-01-28','08:15:00',1.62),('8975','2013-01-28','08:20:00',1.73),('8975','2013-01-28','08:25:00',1.83),('8975','2013-01-28','08:30:00',1.93),('8975','2013-01-28','08:35:00',2.01),('8975','2013-01-28','08:40:00',2.17),('8975','2013-01-28','08:45:00',1.67),('8975','2013-01-28','08:50:00',1.72),('8975','2013-01-28','08:55:00',2.45),('8975','2013-01-28','09:00:00',2.56),('8975','2013-01-28','09:05:00',2.64),('8975','2013-01-28','09:10:00',2.71),('8975','2013-01-28','09:15:00',2.75),('8975','2013-01-28','09:20:00',2.85),('8975','2013-01-28','09:25:00',2.92),('8975','2013-01-28','09:30:00',3),('8975','2013-01-28','09:35:00',3.1),('8975','2013-01-28','09:40:00',3.19),('8975','2013-01-28','09:45:00',3.24),('8975','2013-01-28','09:50:00',3.27),('8975','2013-01-28','09:55:00',3.29),('8975','2013-01-28','10:00:00',3.37),('8975','2013-01-28','10:05:00',3.48),('8975','2013-01-28','10:10:00',3.58),('8975','2013-01-28','10:15:00',3.67),('8975','2013-01-28','10:20:00',3.59),('8975','2013-01-28','10:25:00',3.48),('8975','2013-01-28','10:30:00',3.62),('8975','2013-01-28','10:35:00',3.81),('8975','2013-01-28','10:40:00',3.86),('8975','2013-01-28','10:45:00',3.89),('8975','2013-01-28','10:50:00',3.88),('8975','2013-01-28','10:55:00',3.83),('8975','2013-01-28','11:00:00',3.84),('8975','2013-01-28','11:05:00',3.9),('8975','2013-01-28','11:10:00',3.88),('8975','2013-01-28','11:15:00',3.86),('8975','2013-01-28','11:20:00',3.88),('8975','2013-01-28','11:25:00',3.89),('8975','2013-01-28','11:30:00',3.78),('8975','2013-01-28','11:35:00',3.96),('8975','2013-01-28','11:40:00',3.94),('8975','2013-01-28','11:45:00',3.86),('8975','2013-01-28','11:50:00',3.84),('8975','2013-01-28','11:55:00',3.72),('8975','2013-01-28','12:00:00',3.71),('8975','2013-01-28','12:05:00',3.64),('8975','2013-01-28','12:10:00',3.69),('8975','2013-01-28','12:15:00',3.61),('8975','2013-01-28','12:20:00',3.53),('8975','2013-01-28','12:25:00',3.45),('8975','2013-01-28','12:30:00',3.44),('8975','2013-01-28','12:35:00',3.39),('8975','2013-01-28','12:40:00',3.34),('8975','2013-01-28','12:45:00',3.25),('8975','2013-01-28','12:50:00',3.07),('8975','2013-01-28','12:55:00',3.1),('8975','2013-01-28','13:00:00',3.04),('8975','2013-01-28','13:05:00',3.05),('8975','2013-01-28','13:10:00',3.06),('8975','2013-01-28','13:15:00',2.99),('8975','2013-01-28','13:20:00',2.93),('8975','2013-01-28','13:25:00',2.85),('8975','2013-01-28','13:30:00',2.69),('8975','2013-01-28','13:35:00',2.57),('8975','2013-01-28','13:40:00',2.53),('8975','2013-01-28','13:45:00',2.46),('8975','2013-01-28','13:50:00',2.32),('8975','2013-01-28','13:55:00',2.1),('8975','2013-01-28','14:00:00',2.02),('8975','2013-01-28','14:05:00',2.02),('8975','2013-01-28','14:10:00',2.06),('8975','2013-01-28','14:15:00',1.99),('8975','2013-01-28','14:20:00',1.94),('8975','2013-01-28','14:25:00',1.87),('8975','2013-01-28','14:30:00',1.8),('8975','2013-01-28','14:35:00',1.78),('8975','2013-01-28','14:40:00',1.7),('8975','2013-01-28','14:45:00',1.57),('8975','2013-01-28','14:50:00',1.5),('8975','2013-01-28','14:55:00',1.45),('8975','2013-01-28','15:00:00',1.39),('8975','2013-01-28','15:05:00',1.39),('8975','2013-01-28','15:10:00',1.39),('8975','2013-01-28','15:15:00',1.37),('8975','2013-01-28','15:20:00',1.34),('8975','2013-01-28','15:25:00',1.3),('8975','2013-01-28','15:30:00',1.27),('8975','2013-01-28','15:35:00',1.25),('8975','2013-01-28','15:40:00',1.22),('8975','2013-01-28','15:45:00',1.17),('8975','2013-01-28','15:50:00',1.14),('8975','2013-01-28','15:55:00',1.09),('8975','2013-01-28','16:00:00',1.05),('8975','2013-01-28','16:05:00',1.03),('8975','2013-01-27','10:55:00',1.02),('8975','2013-01-27','11:00:00',1.22),('8975','2013-01-27','11:05:00',1.4),('8975','2013-01-27','11:10:00',1.37),('8975','2013-01-27','11:15:00',1.16),('8975','2013-01-27','11:20:00',1.14),('8975','2013-01-27','11:25:00',1.1),('8975','2013-01-27','12:35:00',1.13),('8975','2013-01-27','12:40:00',1.46),('8975','2013-01-27','12:45:00',1.87),('8975','2013-01-27','12:50:00',2.06),('8975','2013-01-27','12:55:00',1.89),('8975','2013-01-27','13:00:00',1.72),('8975','2013-01-27','13:05:00',1.62),('8975','2013-01-27','13:10:00',1.44),('8975','2013-01-27','13:15:00',1.42),('8975','2013-01-27','13:20:00',1.47),('8975','2013-01-27','13:25:00',1.59),('8975','2013-01-27','13:30:00',1.5),('8975','2013-01-27','13:35:00',1.21),('8975','2013-01-27','13:40:00',1.05),('8975','2013-01-27','13:50:00',1.05),('8975','2013-01-27','13:55:00',1.07),('8975','2013-01-27','14:00:00',1.15),('8975','2013-01-27','14:05:00',1.15),('8975','2013-01-27','14:10:00',1.11),('8975','2013-01-27','14:15:00',1.01),('8975','2013-01-26','08:05:00',1.18),('8975','2013-01-26','08:10:00',1.34),('8975','2013-01-26','08:15:00',1.48),('8975','2013-01-26','08:20:00',1.62),('8975','2013-01-26','08:25:00',1.81),('8975','2013-01-26','08:30:00',2.01),('8975','2013-01-26','08:35:00',2.29),('8975','2013-01-26','08:40:00',2.44),('8975','2013-01-26','08:45:00',2.4),('8975','2013-01-26','08:50:00',1.95),('8975','2013-01-26','08:55:00',2.45),('8975','2013-01-26','09:00:00',2.6),('8975','2013-01-26','09:05:00',2.52),('8975','2013-01-26','09:10:00',2.63),('8975','2013-01-26','09:15:00',2.7),('8975','2013-01-26','09:20:00',2.79),('8975','2013-01-26','09:25:00',2.87),('8975','2013-01-26','09:30:00',2.95),('8975','2013-01-26','09:35:00',3.05),('8975','2013-01-26','09:40:00',3.12),('8975','2013-01-26','09:45:00',3.18),('8975','2013-01-26','09:50:00',3.19),('8975','2013-01-26','09:55:00',3.25),('8975','2013-01-26','10:00:00',3.3),('8975','2013-01-26','10:05:00',3.38),('8975','2013-01-26','10:10:00',3.45),('8975','2013-01-26','10:15:00',3.52),('8975','2013-01-26','10:20:00',3.45),('8975','2013-01-26','10:25:00',3.34),('8975','2013-01-26','10:30:00',3.41),('8975','2013-01-26','10:35:00',3.59),('8975','2013-01-26','10:40:00',3.62),('8975','2013-01-26','10:45:00',3.65),('8975','2013-01-26','10:50:00',3.65),('8975','2013-01-26','10:55:00',3.6),('8975','2013-01-26','11:00:00',3.65),('8975','2013-01-26','11:05:00',3.76),('8975','2013-01-26','11:10:00',3.76),('8975','2013-01-26','11:15:00',3.79),('8975','2013-01-26','11:20:00',3.8),('8975','2013-01-26','11:25:00',3.78),('8975','2013-01-26','11:30:00',3.79),('8975','2013-01-26','11:35:00',3.79),('8975','2013-01-26','11:40:00',3.71),('8975','2013-01-26','11:45:00',3.54),('8975','2013-01-26','11:50:00',3.64),('8975','2013-01-26','11:55:00',3.59),('8975','2013-01-26','12:00:00',3.53),('8975','2013-01-26','12:05:00',3.61),('8975','2013-01-26','12:10:00',3.57),('8975','2013-01-26','12:15:00',3.46),('8975','2013-01-26','12:20:00',3.44),('8975','2013-01-26','12:25:00',3.33),('8975','2013-01-26','12:30:00',3.37),('8975','2013-01-26','12:35:00',3.28),('8975','2013-01-26','12:40:00',3.26),('8975','2013-01-26','12:45:00',3.2),('8975','2013-01-26','12:50:00',3.11),('8975','2013-01-26','12:55:00',3),('8975','2013-01-26','13:00:00',3.03),('8975','2013-01-26','13:05:00',3.01),('8975','2013-01-26','13:10:00',2.98),('8975','2013-01-26','13:15:00',2.92),('8975','2013-01-26','13:20:00',2.83),('8975','2013-01-26','13:25:00',2.73),('8975','2013-01-26','13:30:00',2.54),('8975','2013-01-26','13:35:00',2.48),('8975','2013-01-26','13:40:00',2.39),('8975','2013-01-26','13:45:00',2.35),('8975','2013-01-26','13:50:00',2.33),('8975','2013-01-26','13:55:00',2.25),('8975','2013-01-26','14:00:00',2.15),('8975','2013-01-26','14:05:00',2.08),('8975','2013-01-26','14:10:00',2.02),('8975','2013-01-26','14:15:00',1.95),('8975','2013-01-26','14:20:00',1.92),('8975','2013-01-26','14:25:00',1.83),('8975','2013-01-26','14:30:00',1.74),('8975','2013-01-26','14:35:00',1.69),('8975','2013-01-26','14:40:00',1.66),('8975','2013-01-26','14:45:00',1.55),('8975','2013-01-26','14:50:00',1.48),('8975','2013-01-26','14:55:00',1.44),('8975','2013-01-26','15:00:00',1.39),('8975','2013-01-26','15:05:00',1.4),('8975','2013-01-26','15:10:00',1.38),('8975','2013-01-26','15:15:00',1.35),('8975','2013-01-26','15:20:00',1.3),('8975','2013-01-26','15:25:00',1.26),('8975','2013-01-26','15:30:00',1.21),('8975','2013-01-26','15:35:00',1.17),('8975','2013-01-26','15:40:00',1.13),('8975','2013-01-26','15:45:00',1.09),('8975','2013-01-26','15:50:00',1.06),('8975','2013-01-26','15:55:00',1.01),('8975','2013-01-25','08:55:00',1.7),('8975','2013-01-25','09:00:00',2.46),('8975','2013-01-25','09:05:00',2.77),('8975','2013-01-25','09:10:00',2.77),('8975','2013-01-25','09:15:00',1.88),('8975','2013-01-25','09:20:00',1.88),('8975','2013-01-25','09:25:00',1.62),('8975','2013-01-25','09:30:00',1.2),('8975','2013-01-25','09:35:00',1.75),('8975','2013-01-25','09:40:00',1.72),('8975','2013-01-25','09:50:00',1.54),('8975','2013-01-25','09:55:00',1.99),('8975','2013-01-25','10:00:00',1.77),('8975','2013-01-25','10:05:00',1.51),('8975','2013-01-25','10:10:00',1.3),('8975','2013-01-25','10:15:00',1.46),('8975','2013-01-25','10:20:00',1.85),('8975','2013-01-25','10:25:00',2.2),('8975','2013-01-25','10:30:00',1.49),('8975','2013-01-25','10:35:00',1.39),('8975','2013-01-25','10:40:00',1.61),('8975','2013-01-25','10:45:00',1.71),('8975','2013-01-25','10:50:00',1.88),('8975','2013-01-25','10:55:00',1.87),('8975','2013-01-25','11:00:00',1.68),('8975','2013-01-25','11:05:00',1.55),('8975','2013-01-25','11:10:00',1.63),('8975','2013-01-25','11:15:00',1.62),('8975','2013-01-25','11:20:00',1.63),('8975','2013-01-25','11:25:00',1.42),('8975','2013-01-25','11:30:00',1.57),('8975','2013-01-25','11:35:00',1.49),('8975','2013-01-25','11:40:00',1.49),('8975','2013-01-25','11:45:00',1.37),('8975','2013-01-25','11:50:00',1.47),('8975','2013-01-25','11:55:00',1.41),('8975','2013-01-25','12:00:00',1.29),('8975','2013-01-25','12:05:00',1.23),('8975','2013-01-25','12:10:00',1.11),('8975','2013-01-25','12:15:00',1.11),('8975','2013-01-25','12:20:00',1.22),('8975','2013-01-25','12:25:00',1.34),('8975','2013-01-25','12:30:00',1.26),('8975','2013-01-25','12:35:00',1.28),('8975','2013-01-25','12:40:00',1.24),('8975','2013-01-25','12:45:00',1.24),('8975','2013-01-25','12:50:00',1.35),('8975','2013-01-25','12:55:00',1.08),('8975','2013-01-25','13:05:00',1.07),('8975','2013-01-25','13:10:00',1.12),('8975','2013-01-25','13:35:00',1.1),('8975','2013-01-25','13:40:00',1.16),('8975','2013-01-25','13:45:00',1.09),('8975','2013-01-25','13:50:00',1.01),('8975','2013-01-25','13:55:00',1),('8975','2013-01-24','08:20:00',1.21),('8975','2013-01-24','08:25:00',1.34),('8975','2013-01-24','08:30:00',1.92),('8975','2013-01-24','08:35:00',2.1),('8975','2013-01-24','08:40:00',2.1),('8975','2013-01-24','08:45:00',2.02),('8975','2013-01-24','08:50:00',2.28),('8975','2013-01-24','08:55:00',2.55),('8975','2013-01-24','09:00:00',2.36),('8975','2013-01-24','09:05:00',1.87),('8975','2013-01-24','09:10:00',2.5),('8975','2013-01-24','09:15:00',2.69),('8975','2013-01-24','09:20:00',2.83),('8975','2013-01-24','09:25:00',3.04),('8975','2013-01-24','09:30:00',2.93),('8975','2013-01-24','09:35:00',2.69),('8975','2013-01-24','09:40:00',2.93),('8975','2013-01-24','09:45:00',3.38),('8975','2013-01-24','09:50:00',3.57),('8975','2013-01-24','09:55:00',3.74),('8975','2013-01-24','10:00:00',3.74),('8975','2013-01-24','10:05:00',3.64),('8975','2013-01-24','10:10:00',3.67),('8975','2013-01-24','10:15:00',2.33),('8975','2013-01-24','10:20:00',1.5),('8975','2013-01-24','10:25:00',2.21),('8975','2013-01-24','10:30:00',2.24),('8975','2013-01-24','10:35:00',1.43),('8975','2013-01-24','10:40:00',3.42),('8975','2013-01-24','10:45:00',3.88),('8975','2013-01-24','10:50:00',3.05),('8975','2013-01-24','10:55:00',3.56),('8975','2013-01-24','11:00:00',4.2),('8975','2013-01-24','11:05:00',3.2),('8975','2013-01-24','11:10:00',3.66),('8975','2013-01-24','11:15:00',3.94),('8975','2013-01-24','11:20:00',3.85),('8975','2013-01-24','11:25:00',3.88),('8975','2013-01-24','11:30:00',3.94),('8975','2013-01-24','11:35:00',3.93),('8975','2013-01-24','11:40:00',3.82),('8975','2013-01-24','11:45:00',3.64),('8975','2013-01-24','11:50:00',3.78),('8975','2013-01-24','11:55:00',3.69),('8975','2013-01-24','12:00:00',3.51),('8975','2013-01-24','12:05:00',3.6),('8975','2013-01-24','12:10:00',3.58),('8975','2013-01-24','12:15:00',3.44),('8975','2013-01-24','12:20:00',3.45),('8975','2013-01-24','12:25:00',3.46),('8975','2013-01-24','12:30:00',2.97),('8975','2013-01-24','12:35:00',3.03),('8975','2013-01-24','12:40:00',3.22),('8975','2013-01-24','12:45:00',3.21),('8975','2013-01-24','12:50:00',3.02),('8975','2013-01-24','12:55:00',3.09),('8975','2013-01-24','13:00:00',2.96),('8975','2013-01-24','13:05:00',2.96),('8975','2013-01-24','13:10:00',2.97),('8975','2013-01-24','13:15:00',2.98),('8975','2013-01-24','13:20:00',2.91),('8975','2013-01-24','13:25:00',2.94),('8975','2013-01-24','13:30:00',2.79),('8975','2013-01-24','13:35:00',2.7),('8975','2013-01-24','13:40:00',2.59),('8975','2013-01-24','13:45:00',2.37),('8975','2013-01-24','13:50:00',2.25),('8975','2013-01-24','13:55:00',2.19),('8975','2013-01-24','14:00:00',2.09),('8975','2013-01-24','14:05:00',1.94),('8975','2013-01-24','14:10:00',1.97),('8975','2013-01-24','14:15:00',1.84),('8975','2013-01-24','14:20:00',1.78),('8975','2013-01-24','14:25:00',1.73),('8975','2013-01-24','14:30:00',1.6),('8975','2013-01-24','14:35:00',1.55),('8975','2013-01-24','14:40:00',1.5),('8975','2013-01-24','14:45:00',1.5),('8975','2013-01-24','14:50:00',1.48),('8975','2013-01-24','14:55:00',1.42),('8975','2013-01-24','15:00:00',1.38),('8975','2013-01-24','15:05:00',1.41),('8975','2013-01-24','15:10:00',1.39),('8975','2013-01-24','15:15:00',1.36),('8975','2013-01-24','15:20:00',1.36),('8975','2013-01-24','15:25:00',1.36),('8975','2013-01-24','15:30:00',1.41),('8975','2013-01-24','15:35:00',1.38),('8975','2013-01-24','15:40:00',1.24),('8975','2013-01-24','15:45:00',1.32),('8975','2013-01-24','15:50:00',1.33),('8975','2013-01-24','15:55:00',1.18),('8975','2013-01-23','08:50:00',1.04),('8975','2013-01-23','08:55:00',1.08),('8975','2013-01-23','09:15:00',1.49),('8975','2013-01-23','09:20:00',1.23),('8975','2013-01-23','09:25:00',1.42),('8975','2013-01-23','09:30:00',1.28),('8975','2013-01-23','09:35:00',1.35),('8975','2013-01-23','09:40:00',2.31),('8975','2013-01-23','09:45:00',3.13),('8975','2013-01-23','09:50:00',3.34),('8975','2013-01-23','09:55:00',3.47),('8975','2013-01-23','10:00:00',3.33),('8975','2013-01-23','10:05:00',3.57),('8975','2013-01-23','10:10:00',3.46),('8975','2013-01-23','10:15:00',3.56),('8975','2013-01-23','10:20:00',3.68),('8975','2013-01-23','10:25:00',3.49),('8975','2013-01-23','10:30:00',3.64),('8975','2013-01-23','10:35:00',3.76),('8975','2013-01-23','10:40:00',3.61),('8975','2013-01-23','10:45:00',2.84),('8975','2013-01-23','10:50:00',3),('8975','2013-01-23','10:55:00',1.42),('8975','2013-01-23','11:00:00',1.73),('8975','2013-01-23','11:05:00',1.24),('8975','2013-01-23','12:40:00',1.13),('8975','2013-01-23','12:45:00',1.24),('8975','2013-01-23','12:50:00',1.34),('8975','2013-01-23','12:55:00',1.4),('8975','2013-01-23','13:00:00',1.44),('8975','2013-01-23','13:05:00',1.42),('8975','2013-01-23','13:10:00',1.28),('8975','2013-01-23','13:15:00',1.21),('8975','2013-01-23','13:20:00',1.26),('8975','2013-01-23','13:25:00',1.34),('8975','2013-01-23','13:30:00',1.4),('8975','2013-01-23','13:35:00',1.39),('8975','2013-01-23','13:40:00',1.39),('8975','2013-01-23','13:45:00',1.42),('8975','2013-01-23','13:50:00',1.46),('8975','2013-01-23','13:55:00',1.53),('8975','2013-01-23','14:00:00',1.78),('8975','2013-01-23','14:05:00',1.72),('8975','2013-01-23','14:10:00',1.71),('8975','2013-01-23','14:15:00',1.89),('8975','2013-01-23','14:20:00',2.65),('8975','2013-01-23','14:25:00',2.94),('8975','2013-01-23','14:30:00',2.37),('8975','2013-01-23','14:35:00',1.71),('8975','2013-01-23','14:40:00',1.43),('8975','2013-01-23','14:45:00',1.69),('8975','2013-01-23','14:50:00',1.76),('8975','2013-01-23','14:55:00',1.61),('8975','2013-01-23','15:20:00',1.24),('8975','2013-01-23','15:25:00',1.36),('8975','2013-01-23','15:30:00',1.35),('8975','2013-01-23','15:35:00',1.02),('8975','2013-01-23','15:45:00',1.15),('8975','2013-01-23','15:50:00',1.2),('8975','2013-01-23','15:55:00',1.11),('8975','2013-01-23','16:00:00',1.02),('8975','2013-01-22','09:45:00',1.06),('8975','2013-01-22','09:50:00',1.38),('8975','2013-01-22','09:55:00',2.12),('8975','2013-01-22','10:00:00',1.25),('8975','2013-01-22','10:15:00',1.16),('8975','2013-01-22','10:20:00',1.3),('8975','2013-01-22','10:25:00',1.98),('8975','2013-01-22','10:30:00',3.3),('8975','2013-01-22','10:35:00',2.79),('8975','2013-01-22','10:40:00',2.09),('8975','2013-01-22','10:45:00',2.79),('8975','2013-01-22','10:50:00',3.05),('8975','2013-01-22','10:55:00',1.68),('8975','2013-01-22','11:00:00',1.07),('8975','2013-01-21','08:05:00',1.26),('8975','2013-01-21','08:10:00',1.17),('8975','2013-01-21','08:15:00',1.1),('8975','2013-01-21','08:20:00',1.17),('8975','2013-01-21','08:30:00',1.2),('8975','2013-01-21','08:35:00',1.43),('8975','2013-01-21','08:40:00',1.15),('8975','2013-01-21','08:45:00',2.01),('8975','2013-01-21','08:50:00',1.78),('8975','2013-01-21','09:00:00',1.56),('8975','2013-01-21','09:05:00',2.44),('8975','2013-01-21','09:25:00',2.01),('8975','2013-01-21','09:30:00',3.01),('8975','2013-01-21','09:35:00',3.21),('8975','2013-01-21','09:40:00',2.81),('8975','2013-01-21','09:45:00',2.71),('8975','2013-01-21','09:50:00',1.68),('8975','2013-01-21','09:55:00',2.89),('8975','2013-01-21','10:00:00',2.11),('8975','2013-01-21','10:05:00',3.35),('8975','2013-01-21','10:10:00',3.29),('8975','2013-01-21','10:15:00',3.74),('8975','2013-01-21','10:20:00',3.51),('8975','2013-01-21','10:25:00',3.54),('8975','2013-01-21','10:30:00',3.56),('8975','2013-01-21','10:35:00',3.75),('8975','2013-01-21','10:40:00',3.57),('8975','2013-01-21','10:45:00',4.07),('8975','2013-01-21','10:50:00',3.49),('8975','2013-01-21','10:55:00',2.72),('8975','2013-01-21','11:00:00',1.17),('8975','2013-01-21','11:05:00',1.16),('8975','2013-01-21','11:10:00',1.7),('8975','2013-01-21','11:15:00',1.81),('8975','2013-01-21','11:20:00',2.24),('8975','2013-01-21','11:25:00',1.25),('8975','2013-01-21','11:30:00',1.21),('8975','2013-01-21','11:35:00',1.24),('8975','2013-01-21','11:45:00',1.4),('8975','2013-01-21','11:50:00',2.45),('8975','2013-01-21','11:55:00',1.61),('8975','2013-01-21','12:00:00',1.2),('8975','2013-01-21','12:05:00',1.43),('8975','2013-01-21','12:10:00',2.44),('8975','2013-01-21','12:15:00',2.95),('8975','2013-01-21','12:20:00',2.27),('8975','2013-01-21','12:25:00',2.07),('8975','2013-01-21','12:30:00',1.55),('8975','2013-01-21','12:35:00',1.68),('8975','2013-01-21','12:40:00',3.17),('8975','2013-01-21','12:45:00',1.31),('8975','2013-01-21','12:50:00',1.5),('8975','2013-01-21','12:55:00',1.09),('8975','2013-01-21','13:00:00',2.39),('8975','2013-01-21','13:05:00',2.11),('8975','2013-01-21','13:10:00',2.13),('8975','2013-01-21','13:15:00',1.55),('8975','2013-01-21','13:20:00',2.11),('8975','2013-01-21','13:25:00',1.03),('8975','2013-01-21','13:30:00',1.3),('8975','2013-01-21','13:40:00',1.25),('8975','2013-01-21','13:45:00',1.43),('8975','2013-01-21','13:50:00',1.33),('8975','2013-01-21','14:00:00',1.01),('8975','2013-01-21','14:05:00',1.05),('8975','2013-01-21','14:10:00',1.45),('8975','2013-01-21','14:15:00',1.29),('8975','2013-01-21','14:25:00',1.28),('8975','2013-01-21','14:30:00',1.26),('8975','2013-01-21','14:35:00',1.63),('8975','2013-01-21','14:40:00',2.36),('8975','2013-01-21','14:45:00',1.8),('8975','2013-01-21','14:50:00',1.05),('8975','2014-03-19','06:53:00',1.07),('8975','2014-03-19','06:55:00',1.23),('8975','2014-03-19','07:00:00',1.37),('8975','2014-03-19','07:05:00',1.46),('8975','2014-03-19','07:13:00',1.7),('8975','2014-03-19','07:15:00',2.06),('8975','2014-03-19','07:20:00',2.15),('8975','2014-03-19','07:25:00',2.25),('8975','2014-03-19','07:30:00',2.36),('8975','2014-03-19','07:35:00',2.5),('8975','2014-03-19','07:40:00',2.72),('8975','2014-03-19','07:45:00',2.78),('8975','2014-03-19','07:50:00',2.86),('8975','2014-03-19','07:55:00',2.94),('8975','2014-03-19','08:00:00',3.14),('8975','2014-03-19','08:05:00',3.19),('8975','2014-03-19','08:10:00',3.33),('8975','2014-03-19','08:15:00',3.37),('8975','2014-03-19','08:20:00',3.4),('8975','2014-03-19','08:25:00',3.42),('8975','2014-03-19','08:30:00',3.65),('8975','2014-03-19','08:35:00',3.73),('8975','2014-03-19','08:40:00',3.93),('8975','2014-03-19','08:45:00',4.08),('8975','2014-03-19','08:50:00',4.1),('8975','2014-03-19','08:55:00',4.24),('8975','2014-03-19','09:00:00',4.14),('8975','2014-03-19','09:05:00',4.34),('8975','2014-03-19','09:10:00',4.43),('8975','2014-03-19','09:15:00',4.49),('8975','2014-03-19','09:20:00',4.58),('8975','2014-03-19','09:25:00',4.54),('8975','2014-03-19','09:30:00',4.57),('8975','2014-03-19','09:35:00',4.76),('8975','2014-03-19','09:40:00',4.75),('8975','2014-03-19','09:45:00',4.78),('8975','2014-03-19','09:50:00',4.79),('8975','2014-03-19','09:55:00',4.83),('8975','2014-03-19','10:00:00',4.97),('8975','2014-03-19','10:05:00',5.23),('8975','2014-03-19','10:10:00',5.15),('8975','2014-03-19','10:15:00',5.1),('8975','2014-03-19','10:20:00',5.14),('8975','2014-03-19','10:25:00',5.33),('8975','2014-03-19','10:30:00',5.14),('8975','2014-03-19','10:35:00',5.02),('8975','2014-03-19','10:40:00',4.81),('8975','2014-03-19','10:45:00',5.01),('8975','2014-03-19','10:50:00',5.3),('8975','2014-03-19','10:55:00',5.39),('8975','2014-03-19','11:00:00',5.51),('8975','2014-03-19','11:05:00',5.52),('8975','2014-03-19','11:10:00',5.42),('8975','2014-03-19','11:15:00',5.27),('8975','2014-03-19','11:20:00',5.38),('8975','2014-03-19','11:25:00',5.37),('8975','2014-03-19','11:30:00',5.56),('8975','2014-03-19','11:35:00',5.66),('8975','2014-03-19','11:40:00',5.82),('8975','2014-03-19','11:45:00',5.38),('8975','2014-03-19','11:50:00',5.11),('8975','2014-03-19','11:55:00',4.76),('8975','2014-03-19','12:00:00',5),('8975','2014-03-19','12:05:00',5.11),('8975','2014-03-19','12:10:00',5.28),('8975','2014-03-19','12:15:00',5.1),('8975','2014-03-19','12:20:00',4.87),('8975','2014-03-19','12:25:00',5.07),('8975','2014-03-19','12:30:00',5.1),('8975','2014-03-19','12:35:00',5.15),('8975','2014-03-19','12:40:00',5.22),('8975','2014-03-19','12:45:00',5.21),('8975','2014-03-19','12:50:00',5.12),('8975','2014-03-19','12:55:00',5.01),('8975','2014-03-19','13:00:00',4.92),('8975','2014-03-19','13:05:00',4.87),('8975','2014-03-19','13:10:00',4.8),('8975','2014-03-19','13:15:00',4.76),('8975','2014-03-19','13:20:00',4.62),('8975','2014-03-19','13:25:00',4.39),('8975','2014-03-19','13:30:00',4.23),('8975','2014-03-19','13:35:00',4.16),('8975','2014-03-19','13:40:00',3.91),('8975','2014-03-19','13:45:00',3.84),('8975','2014-03-19','13:50:00',3.75),('8975','2014-03-19','13:55:00',3.41),('8975','2014-03-19','14:00:00',3.65),('8975','2014-03-19','14:05:00',2.84),('8975','2014-03-19','14:10:00',3.39),('8975','2014-03-19','14:15:00',3.41),('8975','2014-03-19','14:20:00',3.4),('8975','2014-03-19','14:25:00',3.21),('8975','2014-03-19','14:30:00',2.7),('8975','2014-03-19','14:35:00',2.7),('8975','2014-03-19','14:40:00',2.8),('8975','2014-03-19','14:45:00',2.71),('8975','2014-03-19','14:50:00',2.67),('8975','2014-03-19','14:55:00',2.39),('8975','2014-03-19','15:00:00',2.31),('8975','2014-03-19','15:05:00',2.37),('8975','2014-03-19','15:10:00',2.27),('8975','2014-03-19','15:15:00',2.25),('8975','2014-03-19','15:20:00',2.31),('8975','2014-03-19','15:25:00',2.15),('8975','2014-03-19','15:30:00',2.08),('8975','2014-03-19','15:35:00',1.87),('8975','2014-03-19','15:40:00',1.7),('8975','2014-03-19','15:45:00',1.66),('8975','2014-03-19','15:50:00',1.55),('8975','2014-03-19','15:55:00',1.42),('8975','2014-03-19','16:00:00',1.18),('8975','2014-03-19','16:05:00',1.15),('8975','2014-03-19','16:10:00',1.17),('8975','2014-03-19','16:15:00',1.16),('8975','2014-03-19','16:20:00',1.26),('8975','2014-03-19','16:25:00',1.23),('8975','2014-03-19','16:30:00',1.15),('8975','2014-03-19','16:35:00',1.11),('8975','2013-01-20','10:15:00',1.08),('8975','2013-01-20','11:00:00',1.43),('8975','2013-01-20','11:05:00',1.58),('8975','2013-01-20','11:10:00',2.1),('8975','2013-01-20','11:15:00',2.03),('8975','2013-01-20','11:20:00',1.65),('8975','2013-01-20','11:25:00',1.46),('8975','2013-01-20','11:30:00',1.02),('8975','2013-01-20','11:40:00',1.42),('8975','2013-01-20','11:45:00',1.3),('8975','2013-01-20','11:50:00',1.72),('8975','2013-01-20','11:55:00',3.01),('8975','2013-01-20','12:00:00',2.87),('8975','2013-01-20','12:05:00',2.92),('8975','2013-01-20','12:10:00',3.41),('8975','2013-01-20','12:15:00',2.75),('8975','2013-01-20','12:20:00',1.42),('8975','2013-01-20','12:25:00',1.75),('8975','2013-01-20','12:30:00',1.27),('8975','2013-01-20','12:35:00',1.55),('8975','2013-01-20','12:40:00',1.35),('8975','2013-01-20','12:45:00',1.03),('8975','2013-01-20','12:50:00',2.72),('8975','2013-01-20','12:55:00',2.36),('8975','2013-01-20','13:00:00',1.8),('8975','2013-01-20','13:05:00',1.69),('8975','2013-01-20','13:10:00',1.38),('8975','2013-01-20','13:15:00',1.39),('8975','2013-01-20','13:20:00',1.33),('8975','2013-01-20','13:25:00',1.33),('8975','2013-01-20','13:30:00',2.2),('8975','2013-01-20','13:35:00',1.94),('8975','2013-01-20','13:40:00',1.61),('8975','2013-01-20','13:45:00',1.89),('8975','2013-01-20','13:50:00',2.61),('8975','2013-01-20','13:55:00',2.03),('8975','2013-01-20','14:00:00',2.04),('8975','2013-01-20','14:05:00',1.85),('8975','2013-01-20','14:10:00',1.97),('8975','2013-01-20','14:15:00',1.6),('8975','2013-01-20','14:25:00',1.19),('8975','2013-01-20','14:30:00',1.31),('8975','2013-01-19','08:30:00',1.05),('8975','2013-01-19','08:35:00',1.3),('8975','2013-01-19','08:40:00',1.08),('8975','2013-01-19','10:00:00',1.06),('8975','2013-01-19','10:05:00',1.07),('8975','2013-01-19','10:20:00',1.01),('8975','2013-01-19','10:25:00',1.26),('8975','2013-01-19','10:30:00',1.31),('8975','2013-01-19','10:35:00',1.03),('8975','2013-01-19','10:40:00',1.25),('8975','2013-01-19','10:45:00',1.25),('8975','2013-01-19','10:50:00',1.53),('8975','2013-01-19','10:55:00',1.71),('8975','2013-01-19','11:00:00',1.92),('8975','2013-01-19','11:05:00',1.8),('8975','2013-01-19','11:10:00',2.06),('8975','2013-01-19','11:15:00',2.15),('8975','2013-01-19','11:20:00',1.95),('8975','2013-01-19','11:25:00',2.37),('8975','2013-01-19','11:30:00',2.6),('8975','2013-01-19','11:35:00',2.11),('8975','2013-01-19','11:40:00',1.74),('8975','2013-01-19','11:45:00',1.72),('8975','2013-01-19','12:10:00',1.1),('8975','2013-01-19','12:15:00',1.34),('8975','2013-01-19','12:20:00',1.51),('8975','2013-01-19','12:25:00',1.54),('8975','2013-01-19','12:30:00',1.42),('8975','2013-01-19','12:35:00',1.35),('8975','2013-01-19','12:40:00',1.27),('8975','2013-01-19','12:45:00',1.25),('8975','2013-01-19','12:50:00',1.2),('8975','2013-01-19','12:55:00',1.19),('8975','2013-01-19','13:00:00',1.16),('8975','2013-01-19','13:05:00',1.12),('8975','2013-01-19','13:10:00',1.15),('8975','2013-01-19','13:15:00',1.25),('8975','2013-01-19','13:20:00',1.27),('8975','2013-01-19','13:25:00',1.25),('8975','2013-01-19','13:30:00',1.16),('8975','2013-01-19','13:35:00',1.31),('8975','2013-01-19','13:40:00',1.45),('8975','2013-01-19','13:45:00',1.36),('8975','2013-01-19','13:50:00',1.33),('8975','2013-01-19','13:55:00',1.17),('8975','2013-01-19','14:00:00',1.06),('8975','2013-01-19','14:20:00',1.11),('8975','2013-01-18','09:00:00',1.04),('8975','2013-01-18','09:05:00',1.23),('8975','2013-01-18','09:10:00',1.54),('8975','2013-01-18','09:15:00',1.99),('8975','2013-01-18','09:20:00',1.85),('8975','2013-01-18','09:25:00',1.4),('8975','2013-01-18','09:30:00',1.18),('8975','2013-01-18','09:35:00',1.08),('8975','2013-01-18','09:45:00',1.26),('8975','2013-01-18','09:50:00',1.7),('8975','2013-01-18','09:55:00',2.22),('8975','2013-01-18','10:00:00',2.09),('8975','2013-01-18','10:05:00',1.74),('8975','2013-01-18','10:10:00',1.2),('8975','2013-01-18','10:35:00',1.51),('8975','2013-01-18','10:40:00',1.95),('8975','2013-01-18','10:45:00',2.32),('8975','2013-01-18','10:50:00',2.08),('8975','2013-01-18','10:55:00',1.21),('8975','2013-01-18','11:00:00',1.26),('8975','2013-01-18','11:05:00',1.39),('8975','2013-01-18','11:10:00',1.53),('8975','2013-01-18','11:15:00',1.57),('8975','2013-01-18','11:20:00',1.78),('8975','2013-01-18','11:25:00',1.81),('8975','2013-01-18','11:30:00',1.38),('8975','2013-01-18','11:35:00',1.12),('8975','2013-01-18','11:40:00',1.04),('8975','2013-01-18','11:45:00',1.13),('8975','2013-01-18','11:50:00',1.13),('8975','2013-01-18','12:05:00',1.04),('8975','2013-01-18','12:10:00',1.06),('8975','2013-01-18','12:15:00',1.08),('8975','2013-01-18','14:30:00',1.02),('8975','2013-01-17','08:50:00',1.11),('8975','2013-01-17','08:55:00',1.24),('8975','2013-01-17','10:10:00',1.2),('8975','2013-01-17','10:15:00',2.65),('8975','2013-01-17','10:20:00',4.33),('8975','2013-01-17','10:25:00',3.18),('8975','2013-01-17','10:30:00',2.31),('8975','2013-01-17','10:35:00',1.82),('8975','2013-01-17','10:40:00',1.42),('8975','2013-01-17','10:45:00',1.23),('8975','2013-01-17','10:50:00',1.24),('8975','2013-01-17','10:55:00',1.24),('8975','2013-01-17','11:00:00',1.3),('8975','2013-01-17','11:05:00',1.45),('8975','2013-01-17','11:10:00',1.42),('8975','2013-01-17','11:15:00',1.37),('8975','2013-01-17','11:20:00',1.26),('8975','2013-01-17','11:25:00',1.32),('8975','2013-01-17','11:30:00',1.64),('8975','2013-01-17','11:35:00',1.96),('8975','2013-01-17','11:40:00',1.77),('8975','2013-01-17','11:45:00',1.55),('8975','2013-01-17','11:50:00',1.35),('8975','2013-01-17','11:55:00',1.35),('8975','2013-01-17','12:00:00',1.43),('8975','2013-01-17','12:05:00',1.43),('8975','2013-01-17','12:10:00',1.62),('8975','2013-01-17','12:15:00',1.67),('8975','2013-01-17','12:20:00',1.67),('8975','2013-01-17','12:25:00',1.7),('8975','2013-01-17','12:30:00',1.68),('8975','2013-01-17','12:35:00',1.92),('8975','2013-01-17','12:40:00',2.02),('8975','2013-01-17','12:45:00',2.1),('8975','2013-01-17','12:50:00',2.54),('8975','2013-01-17','12:55:00',2.75),('8975','2013-01-17','13:00:00',3.36),('8975','2013-01-17','13:05:00',3.53),('8975','2013-01-17','13:10:00',3.63),('8975','2013-01-17','13:15:00',3.29),('8975','2013-01-17','13:20:00',3.22),('8975','2013-01-17','13:25:00',2.35),('8975','2013-01-17','13:30:00',2.03),('8975','2013-01-17','13:35:00',1.81),('8975','2013-01-17','13:40:00',2.58),('8975','2013-01-17','13:45:00',2.91),('8975','2013-01-17','13:50:00',2.44),('8975','2013-01-17','13:55:00',2.01),('8975','2013-01-17','14:00:00',2.41),('8975','2013-01-17','14:05:00',2.79),('8975','2013-01-17','14:10:00',2.89),('8975','2013-01-17','14:15:00',2.91),('8975','2013-01-17','14:20:00',2.8),('8975','2013-01-17','14:25:00',2.36),('8975','2013-01-17','14:30:00',1.81),('8975','2013-01-17','14:35:00',1.6),('8975','2013-01-17','14:40:00',1.42),('8975','2013-01-17','14:45:00',1.51),('8975','2013-01-17','14:50:00',1.34),('8975','2013-01-17','14:55:00',1.44),('8975','2013-01-17','15:00:00',1.24),('8975','2013-01-17','15:05:00',1.15),('8975','2013-01-17','15:10:00',1.18),('8975','2013-01-17','15:15:00',1.1),('8975','2013-01-17','15:25:00',1.11),('8975','2013-01-16','09:10:00',1.16),('8975','2013-01-16','09:15:00',1.23),('8975','2013-01-16','09:20:00',1.15),('8975','2013-01-16','09:25:00',1.02),('8975','2013-01-16','09:30:00',1.18),('8975','2013-01-16','09:35:00',1.27),('8975','2013-01-16','09:40:00',1.41),('8975','2013-01-16','09:45:00',1.62),('8975','2013-01-16','09:50:00',1.93),('8975','2013-01-16','09:55:00',1.84),('8975','2013-01-16','10:00:00',1.36),('8975','2013-01-16','10:05:00',1.45),('8975','2013-01-16','10:10:00',1.75),('8975','2013-01-16','10:15:00',1.96),('8975','2013-01-16','10:20:00',2.1),('8975','2013-01-16','10:25:00',2.51),('8975','2013-01-16','10:30:00',2.33),('8975','2013-01-16','10:35:00',2.24),('8975','2013-01-16','10:40:00',2.15),('8975','2013-01-16','10:45:00',2.33),('8975','2013-01-16','10:50:00',2.27),('8975','2013-01-16','10:55:00',2.63),('8975','2013-01-16','11:00:00',2.36),('8975','2013-01-16','11:05:00',2.25),('8975','2013-01-16','11:10:00',2.57),('8975','2013-01-16','11:15:00',2.7),('8975','2013-01-16','11:20:00',2.51),('8975','2013-01-16','11:25:00',2.2),('8975','2013-01-16','11:30:00',2.01),('8975','2013-01-16','11:35:00',2.02),('8975','2013-01-16','11:40:00',2.13),('8975','2013-01-16','11:45:00',1.82),('8975','2013-01-16','11:50:00',2.03),('8975','2013-01-16','11:55:00',2.1),('8975','2013-01-16','12:00:00',2.32),('8975','2013-01-16','12:05:00',2.35),('8975','2013-01-16','12:10:00',2.46),('8975','2013-01-16','12:15:00',2.74),('8975','2013-01-16','12:20:00',2.45),('8975','2013-01-16','12:25:00',2.34),('8975','2013-01-16','12:30:00',1.86),('8975','2013-01-16','12:35:00',2.07),('8975','2013-01-16','12:40:00',2.19),('8975','2013-01-16','12:45:00',1.71),('8975','2013-01-16','12:50:00',1.33),('8975','2013-01-16','12:55:00',1.83),('8975','2013-01-16','13:00:00',2.1),('8975','2013-01-16','13:05:00',1.93),('8975','2013-01-16','13:10:00',1.62),('8975','2013-01-16','13:15:00',1.61),('8975','2013-01-16','13:20:00',1.78),('8975','2013-01-16','13:25:00',1.75),('8975','2013-01-16','13:30:00',1.58),('8975','2013-01-16','13:35:00',1.69),('8975','2013-01-16','13:40:00',2.1),('8975','2013-01-16','13:45:00',2.11),('8975','2013-01-16','13:50:00',1.29),('8975','2013-01-16','13:55:00',1.15),('8975','2013-01-16','14:00:00',1.55),('8975','2013-01-16','14:05:00',1.32),('8975','2013-01-16','14:10:00',1.45),('8975','2013-01-16','14:15:00',1.06),('8975','2013-01-16','14:20:00',1.14),('8975','2013-01-16','14:25:00',1.57),('8975','2013-01-16','14:30:00',2.06),('8975','2013-01-16','14:35:00',1.9),('8975','2013-01-16','14:40:00',1.26),('8975','2013-01-15','09:15:00',1.56),('8975','2013-01-15','09:20:00',1.78),('8975','2013-01-15','09:25:00',2.09),('8975','2013-01-15','09:30:00',2.79),('8975','2013-01-15','09:35:00',2.87),('8975','2013-01-15','09:40:00',2.76),('8975','2013-01-15','09:45:00',1.44),('8975','2013-01-15','09:55:00',1.46),('8975','2013-01-15','10:00:00',1.51),('8975','2013-01-15','10:05:00',1.29),('8975','2013-01-15','10:30:00',1.27),('8975','2013-01-15','10:35:00',2.81),('8975','2013-01-15','10:40:00',2.47),('8975','2013-01-15','10:45:00',2.22),('8975','2013-01-15','10:50:00',1.16),('8975','2013-01-15','10:55:00',1.78),('8975','2013-01-15','11:00:00',1.16),('8975','2013-01-15','11:05:00',1.17),('8975','2013-01-15','11:20:00',1.13),('8975','2013-01-15','11:25:00',2.31),('8975','2013-01-15','12:00:00',2.43),('8975','2013-01-15','12:05:00',2.12),('8975','2013-01-15','12:10:00',2.58),('8975','2013-01-15','12:15:00',3.93),('8975','2013-01-15','12:20:00',3.2),('8975','2013-01-15','12:25:00',1),('8975','2013-01-15','13:00:00',2.01),('8975','2013-01-15','13:05:00',3.92),('8975','2013-01-15','13:10:00',3.54),('8975','2013-01-15','13:15:00',3.62),('8975','2013-01-15','13:20:00',2.97),('8975','2013-01-15','13:25:00',1.43),('8975','2013-01-15','13:50:00',1.09),('8975','2013-01-15','13:55:00',2.61),('8975','2013-01-15','14:00:00',2.65),('8975','2013-01-15','14:05:00',2.08),('8975','2013-01-15','15:05:00',1.18),('8975','2013-01-15','15:10:00',1.04),('8975','2013-01-14','08:15:00',1.19),('8975','2013-01-14','08:55:00',1.14),('8975','2013-01-14','09:00:00',1.03),('8975','2013-01-14','09:50:00',1.25),('8975','2013-01-14','09:55:00',1.56),('8975','2013-01-14','10:00:00',1.51),('8975','2013-01-14','10:05:00',1.22),('8975','2013-01-14','10:10:00',1.65),('8975','2013-01-14','10:15:00',1.44),('8975','2013-01-14','10:20:00',1.52),('8975','2013-01-14','10:25:00',1.47),('8975','2013-01-14','10:30:00',1.13),('8975','2013-01-14','10:35:00',1.29),('8975','2013-01-14','10:40:00',1.51),('8975','2013-01-14','10:45:00',1.72),('8975','2013-01-14','10:50:00',2.07),('8975','2013-01-14','10:55:00',2.13),('8975','2013-01-14','11:00:00',2.07),('8975','2013-01-14','11:05:00',2.16),('8975','2013-01-14','11:10:00',2.16),('8975','2013-01-14','11:15:00',2.04),('8975','2013-01-14','11:20:00',2.09),('8975','2013-01-14','11:25:00',2.01),('8975','2013-01-14','11:30:00',1.83),('8975','2013-01-14','11:35:00',1.83),('8975','2013-01-14','11:40:00',1.72),('8975','2013-01-14','11:45:00',1.55),('8975','2013-01-14','11:50:00',1.54),('8975','2013-01-14','11:55:00',1.67),('8975','2013-01-14','12:00:00',1.59),('8975','2013-01-14','12:05:00',1.53),('8975','2013-01-14','12:10:00',1.62),('8975','2013-01-14','12:15:00',1.86),('8975','2013-01-14','12:20:00',2.02),('8975','2013-01-14','12:25:00',1.87),('8975','2013-01-14','12:30:00',1.73),('8975','2013-01-14','12:35:00',1.68),('8975','2013-01-14','12:40:00',1.88),('8975','2013-01-14','12:45:00',1.91),('8975','2013-01-14','12:50:00',1.78),('8975','2013-01-14','12:55:00',1.6),('8975','2013-01-14','13:00:00',1.49),('8975','2013-01-14','13:05:00',1.47),('8975','2013-01-14','13:10:00',1.41),('8975','2013-01-14','13:15:00',1.55),('8975','2013-01-14','13:20:00',1.51),('8975','2013-01-14','13:25:00',1.51),('8975','2013-01-14','13:30:00',1.64),('8975','2013-01-14','13:35:00',1.65),('8975','2013-01-14','13:40:00',1.79),('8975','2013-01-14','13:45:00',1.69),('8975','2013-01-14','13:50:00',1.7),('8975','2013-01-14','13:55:00',2),('8975','2013-01-14','14:00:00',2.75),('8975','2013-01-14','14:05:00',2.5),('8975','2013-01-14','14:10:00',2.3),('8975','2013-01-14','14:15:00',2.36),('8975','2013-01-14','14:20:00',2.49),('8975','2013-01-14','14:25:00',1.72),('8975','2013-01-14','14:30:00',1.48),('8975','2013-01-14','14:35:00',1.3),('8975','2013-01-14','14:40:00',1.53),('8975','2013-01-14','14:45:00',1.49),('8975','2013-01-14','14:50:00',1.06),('8975','2013-01-14','14:55:00',1.06),('8975','2013-01-14','15:00:00',1.58),('8975','2013-01-14','15:05:00',1.65),('8975','2013-01-14','15:10:00',1.58),('8975','2013-01-14','15:15:00',1.41),('8975','2013-01-14','15:20:00',1.28),('8975','2013-01-14','16:00:00',1.05),('8975','2013-01-14','16:05:00',1.14),('8975','2013-01-14','16:10:00',1.07),('8975','2013-01-13','11:20:00',1.44),('8975','2013-01-13','11:25:00',1.37),('8975','2013-01-13','11:30:00',1.02),('8975','2013-01-13','11:35:00',1.03),('8975','2013-01-13','11:50:00',1.18),('8975','2013-01-13','12:20:00',1.15),('8975','2013-01-13','12:25:00',1.52),('8975','2013-01-13','12:30:00',1.41),('8975','2013-01-13','12:35:00',1.43),('8975','2013-01-13','12:40:00',1.41),('8975','2013-01-13','12:45:00',1.68),('8975','2013-01-13','12:50:00',1.93),('8975','2013-01-13','12:55:00',1.85),('8975','2013-01-13','13:00:00',1.85),('8975','2013-01-13','13:05:00',1.7),('8975','2013-01-13','13:10:00',1.56),('8975','2013-01-13','13:15:00',1.34),('8975','2013-01-13','13:35:00',1.14),('8975','2013-01-13','15:15:00',1.4),('8975','2013-01-13','15:20:00',1.44),('8975','2013-01-13','15:25:00',1.41),('8975','2013-01-12','09:10:00',1.65),('8975','2013-01-12','09:15:00',2.84),('8975','2013-01-12','09:20:00',2.75),('8975','2013-01-12','09:25:00',2.74),('8975','2013-01-12','09:30:00',2.73),('8975','2013-01-12','09:35:00',2.39),('8975','2013-01-12','09:40:00',1.23),('8975','2013-01-12','09:45:00',1.35),('8975','2013-01-12','09:50:00',2.26),('8975','2013-01-12','09:55:00',2.75),('8975','2013-01-12','10:00:00',2.62),('8975','2013-01-12','10:05:00',2.31),('8975','2013-01-12','10:10:00',1.34),('8975','2013-01-12','10:15:00',1.26),('8975','2013-01-12','10:20:00',1.41),('8975','2013-01-12','10:25:00',2.31),('8975','2013-01-12','10:30:00',2.31),('8975','2013-01-12','10:35:00',1.33),('8975','2013-01-11','08:10:00',1.07),('8975','2013-01-11','08:15:00',1.21),('8975','2013-01-11','08:20:00',1.32),('8975','2013-01-11','08:25:00',1.48),('8975','2013-01-11','08:30:00',1.6),('8975','2013-01-11','08:35:00',1.72),('8975','2013-01-11','08:40:00',1.81),('8975','2013-01-11','08:45:00',1.91),('8975','2013-01-11','08:50:00',1.99),('8975','2013-01-11','08:55:00',2.06),('8975','2013-01-11','09:00:00',2.16),('8975','2013-01-11','09:05:00',2.23),('8975','2013-01-11','09:10:00',2.29),('8975','2013-01-11','09:15:00',2.35),('8975','2013-01-11','09:20:00',2.43),('8975','2013-01-11','09:25:00',2.5),('8975','2013-01-11','09:30:00',2.54),('8975','2013-01-11','09:35:00',2.59),('8975','2013-01-11','09:40:00',2.64),('8975','2013-01-11','09:45:00',2.73),('8975','2013-01-11','09:50:00',2.75),('8975','2013-01-11','09:55:00',2.76),('8975','2013-01-11','10:00:00',2.83),('8975','2013-01-11','10:05:00',2.88),('8975','2013-01-11','10:10:00',2.94),('8975','2013-01-11','10:15:00',3),('8975','2013-01-11','10:20:00',3.03),('8975','2013-01-11','10:25:00',2.98),('8975','2013-01-11','10:30:00',3.05),('8975','2013-01-11','10:35:00',3.1),('8975','2013-01-11','10:40:00',3.15),('8975','2013-01-11','10:45:00',3.18),('8975','2013-01-11','10:50:00',3.18),('8975','2013-01-11','10:55:00',3.16),('8975','2013-01-11','11:00:00',3.16),('8975','2013-01-11','11:05:00',3.16),('8975','2013-01-11','11:10:00',3.13),('8975','2013-01-11','11:15:00',3.1),('8975','2013-01-11','11:20:00',3.08),('8975','2013-01-11','11:25:00',3.08),('8975','2013-01-11','11:30:00',3.08),('8975','2013-01-11','11:35:00',3.05),('8975','2013-01-11','11:40:00',3.01),('8975','2013-01-11','11:45:00',3),('8975','2013-01-11','11:50:00',2.92),('8975','2013-01-11','11:55:00',2.9),('8975','2013-01-11','12:00:00',2.85),('8975','2013-01-11','12:05:00',2.82),('8975','2013-01-11','12:10:00',2.37),('8975','2013-01-11','12:15:00',2.67),('8975','2013-01-11','12:20:00',2.67),('8975','2013-01-11','12:25:00',2.73),('8975','2013-01-11','12:30:00',1.75),('8975','2013-01-11','12:40:00',1.22),('8975','2013-01-11','12:45:00',2.15),('8975','2013-01-11','12:50:00',1.02),('8975','2013-01-11','12:55:00',1.19),('8975','2013-01-11','13:00:00',1.2),('8975','2013-01-11','13:05:00',1.54),('8975','2013-01-11','13:10:00',1.76),('8975','2013-01-11','13:15:00',1.11),('8975','2013-01-11','13:20:00',1.52),('8975','2013-01-11','13:25:00',1.69),('8975','2013-01-11','13:30:00',1.65),('8975','2013-01-11','13:35:00',1.34),('8975','2013-01-11','13:40:00',2),('8975','2013-01-11','13:45:00',2.02),('8975','2013-01-11','13:50:00',2.13),('8975','2013-01-11','13:55:00',1.74),('8975','2013-01-11','14:00:00',1.97),('8975','2013-01-11','14:05:00',1.94),('8975','2013-01-11','14:10:00',1.6),('8975','2013-01-11','14:15:00',1.43),('8975','2013-01-11','14:20:00',1.37),('8975','2013-01-11','14:25:00',1.36),('8975','2013-01-11','14:30:00',1.28),('8975','2013-01-11','14:35:00',1.25),('8975','2013-01-11','14:40:00',1.24),('8975','2013-01-11','14:45:00',1.23),('8975','2013-01-11','14:50:00',1.22),('8975','2013-01-11','14:55:00',1.18),('8975','2013-01-11','15:00:00',1.04),('8975','2013-01-11','15:10:00',1.07),('8975','2013-01-11','15:15:00',1.09),('8975','2013-01-11','15:20:00',1.01),('8975','2014-03-18','07:10:00',1.26),('8975','2014-03-18','07:20:00',1.06),('8975','2014-03-18','07:28:00',1.86),('8975','2014-03-18','08:35:00',1.06),('8975','2014-03-18','08:40:00',1.12),('8975','2014-03-18','08:45:00',1.34),('8975','2014-03-18','08:50:00',1.47),('8975','2014-03-18','08:55:00',1.58),('8975','2014-03-18','09:00:00',1.67),('8975','2014-03-18','09:05:00',2.04),('8975','2014-03-18','09:10:00',2.19),('8975','2014-03-18','09:15:00',2.33),('8975','2014-03-18','09:20:00',2.18),('8975','2014-03-18','09:25:00',2.68),('8975','2014-03-18','09:30:00',3),('8975','2014-03-18','09:35:00',3.8),('8975','2014-03-18','09:40:00',4.33),('8975','2014-03-18','09:45:00',4.91),('8975','2014-03-18','09:50:00',3.01),('8975','2014-03-18','09:55:00',2.79),('8975','2014-03-18','10:00:00',2.21),('8975','2014-03-18','10:05:00',1.62),('8975','2014-03-18','10:10:00',1.5),('8975','2014-03-18','10:15:00',1.64),('8975','2014-03-18','10:20:00',2.03),('8975','2014-03-18','10:25:00',2.48),('8975','2014-03-18','10:30:00',4.24),('8975','2014-03-18','10:35:00',5.91),('8975','2014-03-18','10:40:00',4.47),('8975','2014-03-18','10:45:00',3.2),('8975','2014-03-18','10:50:00',2.66),('8975','2014-03-18','10:55:00',1.89),('8975','2014-03-18','11:00:00',1.88),('8975','2014-03-18','11:05:00',2.31),('8975','2014-03-18','11:10:00',2.37),('8975','2014-03-18','11:15:00',2.55),('8975','2014-03-18','11:20:00',3.11),('8975','2014-03-18','11:25:00',4.59),('8975','2014-03-18','11:30:00',5.42),('8975','2014-03-18','11:35:00',6.15),('8975','2014-03-18','11:40:00',6.17),('8975','2014-03-18','11:45:00',6.89),('8975','2014-03-18','11:50:00',6.71),('8975','2014-03-18','11:55:00',4.77),('8975','2014-03-18','12:00:00',3.1),('8975','2014-03-18','12:05:00',2.56),('8975','2014-03-18','12:10:00',3.15),('8975','2014-03-18','12:15:00',6.24),('8975','2014-03-18','12:20:00',3.4),('8975','2014-03-18','12:25:00',3.54),('8975','2014-03-18','12:30:00',3.71),('8975','2014-03-18','12:35:00',5.37),('8975','2014-03-18','12:40:00',5.33),('8975','2014-03-18','12:45:00',3.15),('8975','2014-03-18','12:50:00',4.53),('8975','2014-03-18','12:55:00',5.26),('8975','2014-03-18','13:00:00',5.23),('8975','2014-03-18','13:05:00',3.98),('8975','2014-03-18','13:10:00',4.94),('8975','2014-03-18','13:15:00',5.01),('8975','2014-03-18','13:20:00',5.03),('8975','2014-03-18','13:25:00',2.41),('8975','2014-03-18','13:30:00',1.87),('8975','2014-03-18','13:35:00',4.23),('8975','2014-03-18','13:40:00',4.31),('8975','2014-03-18','13:45:00',4.57),('8975','2014-03-18','13:50:00',4.57),('8975','2014-03-18','13:55:00',3.82),('8975','2014-03-18','14:00:00',3.77),('8975','2014-03-18','14:05:00',4.01),('8975','2014-03-18','14:10:00',3.95),('8975','2014-03-18','14:15:00',3.59),('8975','2014-03-18','14:20:00',2.85),('8975','2014-03-18','14:25:00',3.36),('8975','2014-03-18','14:30:00',3.29),('8975','2014-03-18','14:35:00',3.35),('8975','2014-03-18','14:40:00',3.2),('8975','2014-03-18','14:45:00',3.11),('8975','2014-03-18','14:50:00',3.1),('8975','2014-03-18','14:55:00',3),('8975','2014-03-18','15:00:00',2.95),('8975','2014-03-18','15:05:00',2.85),('8975','2014-03-18','15:10:00',2.67),('8975','2014-03-18','15:15:00',2.59),('8975','2014-03-18','15:20:00',2.47),('8975','2014-03-18','15:25:00',2.39),('8975','2014-03-18','15:30:00',2.32),('8975','2014-03-18','15:35:00',1.91),('8975','2014-03-18','15:40:00',1.48),('8975','2014-03-18','15:45:00',1.4),('8975','2014-03-18','15:55:00',1.58),('8975','2014-03-18','16:00:00',1.72),('8975','2014-03-18','16:05:00',1.44),('8975','2014-03-18','16:10:00',1.65),('8975','2014-03-18','16:15:00',1.55),('8975','2014-03-18','16:20:00',1.5),('8975','2014-03-18','16:25:00',1.32),('8975','2014-03-18','16:30:00',1.11),('8975','2014-03-18','16:35:00',1.13),('8975','2014-03-18','16:40:00',1.01),('8975','2013-01-10','09:45:00',1.08),('8975','2013-01-10','09:50:00',1.08),('8975','2013-01-10','09:55:00',1.72),('8975','2013-01-10','10:00:00',1.31),('8975','2013-01-10','10:05:00',1.54),('8975','2013-01-10','10:10:00',1.43),('8975','2013-01-10','10:15:00',1.82),('8975','2013-01-10','10:20:00',2.85),('8975','2013-01-10','10:25:00',2.99),('8975','2013-01-10','10:30:00',2.87),('8975','2013-01-10','10:35:00',2.93),('8975','2013-01-10','10:40:00',3.01),('8975','2013-01-10','10:45:00',3.04),('8975','2013-01-10','10:50:00',3.08),('8975','2013-01-10','10:55:00',3.06),('8975','2013-01-10','11:00:00',2.51),('8975','2013-01-10','11:05:00',2.82),('8975','2013-01-10','11:10:00',2.78),('8975','2013-01-10','11:15:00',3.01),('8975','2013-01-10','11:20:00',2.79),('8975','2013-01-10','11:25:00',1.33),('8975','2013-01-10','11:30:00',1.33),('8975','2013-01-10','11:35:00',1.81),('8975','2013-01-10','11:40:00',1.04),('8975','2013-01-10','11:45:00',1.99),('8975','2013-01-10','11:50:00',2.5),('8975','2013-01-10','11:55:00',1.87),('8975','2013-01-10','12:00:00',1.49),('8975','2013-01-10','12:05:00',1.27),('8975','2013-01-10','12:10:00',1.13),('8975','2013-01-10','12:15:00',1.32),('8975','2013-01-10','12:20:00',1.06),('8975','2013-01-10','12:50:00',1.52),('8975','2013-01-10','12:55:00',1.85),('8975','2013-01-10','13:00:00',1.88),('8975','2013-01-10','13:05:00',1.85),('8975','2013-01-10','13:10:00',2.51),('8975','2013-01-10','13:15:00',1.89),('8975','2013-01-10','13:20:00',1.26),('8975','2013-01-10','13:30:00',1.75),('8975','2013-01-10','13:35:00',2.22),('8975','2013-01-10','13:40:00',1.47),('8975','2013-01-10','13:45:00',1.51),('8975','2013-01-10','14:20:00',1.58),('8975','2013-01-10','14:25:00',1.26),('8975','2013-01-10','14:30:00',1.29),('8975','2013-01-10','14:35:00',1.05),('8975','2013-01-10','14:40:00',1.01),('8975','2013-01-10','14:45:00',1.29),('8975','2013-01-10','14:50:00',1.32),('8975','2013-01-10','15:00:00',1.39),('8975','2013-01-10','15:05:00',1.31),('8975','2013-01-09','11:20:00',1.24),('8975','2013-01-09','11:25:00',1.47),('8975','2013-01-09','11:30:00',1.5),('8975','2013-01-09','11:35:00',1.15),('8975','2013-01-09','11:45:00',1.13),('8975','2013-01-09','11:50:00',1.65),('8975','2013-01-09','11:55:00',1.98),('8975','2013-01-09','12:00:00',2.07),('8975','2013-01-09','12:05:00',2),('8975','2013-01-09','12:10:00',1.75),('8975','2013-01-09','12:15:00',1.21),('8975','2013-01-09','13:45:00',1),('8975','2013-01-09','13:55:00',1.06),('8975','2013-01-09','14:00:00',1.04),('8975','2013-01-08','09:35:00',1.01),('8975','2013-01-08','09:40:00',1.08),('8975','2013-01-08','09:45:00',1.02),('8975','2013-01-08','10:10:00',1.02),('8975','2013-01-08','10:15:00',1.06),('8975','2013-01-08','10:20:00',1.15),('8975','2013-01-08','10:25:00',1.25),('8975','2013-01-08','10:30:00',1.31),('8975','2013-01-08','10:35:00',1.39),('8975','2013-01-08','10:40:00',1.45),('8975','2013-01-08','10:45:00',1.67),('8975','2013-01-08','10:50:00',2.19),('8975','2013-01-08','10:55:00',1.61),('8975','2013-01-08','11:00:00',1.91),('8975','2013-01-08','11:05:00',1.93),('8975','2013-01-08','11:10:00',2.89),('8975','2013-01-08','11:15:00',2.64),('8975','2013-01-08','11:20:00',1.7),('8975','2013-01-08','11:25:00',1.9),('8975','2013-01-08','11:30:00',2),('8975','2013-01-08','11:35:00',1.82),('8975','2013-01-08','11:40:00',1.57),('8975','2013-01-08','11:45:00',1.79),('8975','2013-01-08','11:50:00',1.87),('8975','2013-01-08','11:55:00',1.74),('8975','2013-01-08','12:00:00',1.76),('8975','2013-01-08','12:05:00',1.71),('8975','2013-01-08','12:10:00',1.59),('8975','2013-01-08','12:15:00',1.68),('8975','2013-01-08','12:20:00',1.54),('8975','2013-01-08','12:25:00',1.47),('8975','2013-01-08','12:30:00',1.51),('8975','2013-01-08','12:35:00',1.51),('8975','2013-01-08','12:40:00',1.42),('8975','2013-01-08','12:45:00',1.45),('8975','2013-01-08','12:50:00',1.6),('8975','2013-01-08','12:55:00',1.8),('8975','2013-01-08','13:00:00',2),('8975','2013-01-08','13:05:00',2.08),('8975','2013-01-08','13:10:00',1.86),('8975','2013-01-08','13:15:00',1.49),('8975','2013-01-08','13:20:00',1.37),('8975','2013-01-08','13:25:00',1.21),('8975','2013-01-08','13:30:00',1.28),('8975','2013-01-08','13:35:00',1.3),('8975','2013-01-08','13:40:00',1.26),('8975','2013-01-08','13:45:00',1.18),('8975','2013-01-08','13:50:00',1.12),('8975','2013-01-08','13:55:00',1.1),('8975','2013-01-08','14:00:00',1.06),('8975','2013-01-08','14:05:00',1.02),('8975','2013-01-07','08:30:00',1.37),('8975','2013-01-07','08:35:00',2.17),('8975','2013-01-07','08:40:00',2.25),('8975','2013-01-07','08:45:00',2.34),('8975','2013-01-07','08:50:00',2.4),('8975','2013-01-07','08:55:00',2.49),('8975','2013-01-07','09:00:00',2.69),('8975','2013-01-07','09:05:00',2.64),('8975','2013-01-07','09:10:00',1.65),('8975','2013-01-07','09:15:00',1.98),('8975','2013-01-07','09:20:00',2.25),('8975','2013-01-07','09:25:00',2.45),('8975','2013-01-07','09:30:00',2.39),('8975','2013-01-07','09:35:00',2),('8975','2013-01-07','09:40:00',2.85),('8975','2013-01-07','09:45:00',3.04),('8975','2013-01-07','09:50:00',3.16),('8975','2013-01-07','09:55:00',3.15),('8975','2013-01-07','10:00:00',2.98),('8975','2013-01-07','10:05:00',2.7),('8975','2013-01-07','10:10:00',2.73),('8975','2013-01-07','10:15:00',2.65),('8975','2013-01-07','10:20:00',2.4),('8975','2013-01-07','10:25:00',2.44),('8975','2013-01-07','10:30:00',2.46),('8975','2013-01-07','10:35:00',2.62),('8975','2013-01-07','10:40:00',3.01),('8975','2013-01-07','10:45:00',2.92),('8975','2013-01-07','10:50:00',2.8),('8975','2013-01-07','10:55:00',3.02),('8975','2013-01-07','11:00:00',3.02),('8975','2013-01-07','11:05:00',3.09),('8975','2013-01-07','11:10:00',3.09),('8975','2013-01-07','11:15:00',3.08),('8975','2013-01-07','11:20:00',2.78),('8975','2013-01-07','11:25:00',2.85),('8975','2013-01-07','11:30:00',2.93),('8975','2013-01-07','11:35:00',2.62),('8975','2013-01-07','11:40:00',2.89),('8975','2013-01-07','11:45:00',3.26),('8975','2013-01-07','11:50:00',2.68),('8975','2013-01-07','11:55:00',2.21),('8975','2013-01-07','12:00:00',2.26),('8975','2013-01-07','12:05:00',2.03),('8975','2013-01-07','12:10:00',2.01),('8975','2013-01-07','12:15:00',2.18),('8975','2013-01-07','12:20:00',1.73),('8975','2013-01-07','12:25:00',1.9),('8975','2013-01-07','12:30:00',1.56),('8975','2013-01-07','12:35:00',1.47),('8975','2013-01-07','12:40:00',1.92),('8975','2013-01-07','12:45:00',2.06),('8975','2013-01-07','12:50:00',1.61),('8975','2013-01-07','12:55:00',1.56),('8975','2013-01-07','13:00:00',1.57),('8975','2013-01-07','13:05:00',1.72),('8975','2013-01-07','13:10:00',1.36),('8975','2013-01-07','13:15:00',1.34),('8975','2013-01-07','13:20:00',1.52),('8975','2013-01-07','13:25:00',1.28),('8975','2013-01-07','13:30:00',1.16),('8975','2013-01-07','13:35:00',1.24),('8975','2013-01-07','13:40:00',1.51),('8975','2013-01-07','13:45:00',1.62),('8975','2013-01-07','13:50:00',1.46),('8975','2013-01-07','13:55:00',1.56),('8975','2013-01-07','14:00:00',1.39),('8975','2013-01-07','14:05:00',1.2),('8975','2013-01-07','14:10:00',1.13),('8975','2013-01-07','14:15:00',1.12),('8975','2013-01-07','14:20:00',1.12),('8975','2013-01-07','14:25:00',1.18),('8975','2013-01-07','14:30:00',1.19),('8975','2013-01-07','14:35:00',1.24),('8975','2013-01-07','14:40:00',1.28),('8975','2013-01-07','15:10:00',1.07),('8975','2013-01-06','08:15:00',1.02),('8975','2013-01-06','08:20:00',1.15),('8975','2013-01-06','08:25:00',1.28),('8975','2013-01-06','08:30:00',1.42),('8975','2013-01-06','08:35:00',1.55),('8975','2013-01-06','08:40:00',1.61),('8975','2013-01-06','08:45:00',1.75),('8975','2013-01-06','08:50:00',1.83),('8975','2013-01-06','08:55:00',1.95),('8975','2013-01-06','09:00:00',2.05),('8975','2013-01-06','09:05:00',1.94),('8975','2013-01-06','09:10:00',1.88),('8975','2013-01-06','09:15:00',1.7),('8975','2013-01-06','09:20:00',2.23),('8975','2013-01-06','09:25:00',2.38),('8975','2013-01-06','09:30:00',2.46),('8975','2013-01-06','09:35:00',2.5),('8975','2013-01-06','09:40:00',2.61),('8975','2013-01-06','09:45:00',2.68),('8975','2013-01-06','09:50:00',2.72),('8975','2013-01-06','09:55:00',2.69),('8975','2013-01-06','10:00:00',2.71),('8975','2013-01-06','10:05:00',2.79),('8975','2013-01-06','10:10:00',2.83),('8975','2013-01-06','10:15:00',2.91),('8975','2013-01-06','10:20:00',2.91),('8975','2013-01-06','10:25:00',2.83),('8975','2013-01-06','10:30:00',2.93),('8975','2013-01-06','10:35:00',3.01),('8975','2013-01-06','10:40:00',3.07),('8975','2013-01-06','10:45:00',3.11),('8975','2013-01-06','10:50:00',2.83),('8975','2013-01-06','10:55:00',3.01),('8975','2013-01-06','11:00:00',3.09),('8975','2013-01-06','11:05:00',3.11),('8975','2013-01-06','11:10:00',3.07),('8975','2013-01-06','11:15:00',3.03),('8975','2013-01-06','11:20:00',3.04),('8975','2013-01-06','11:25:00',3.01),('8975','2013-01-06','11:30:00',2.95),('8975','2013-01-06','11:35:00',2.87),('8975','2013-01-06','11:40:00',2.9),('8975','2013-01-06','11:45:00',2.85),('8975','2013-01-06','11:50:00',2.74),('8975','2013-01-06','11:55:00',2.7),('8975','2013-01-06','12:00:00',2.78),('8975','2013-01-06','12:05:00',2.69),('8975','2013-01-06','12:10:00',2.68),('8975','2013-01-06','12:15:00',2.68),('8975','2013-01-06','12:20:00',2.62),('8975','2013-01-06','12:25:00',2.55),('8975','2013-01-06','12:30:00',2.58),('8975','2013-01-06','12:35:00',2.47),('8975','2013-01-06','12:40:00',2.36),('8975','2013-01-06','12:45:00',2.28),('8975','2013-01-06','12:50:00',2.32),('8975','2013-01-06','12:55:00',2.32),('8975','2013-01-06','13:00:00',2.26),('8975','2013-01-06','13:05:00',2.15),('8975','2013-01-06','13:10:00',2.12),('8975','2013-01-06','13:15:00',2.01),('8975','2013-01-06','13:20:00',1.97),('8975','2013-01-06','13:25:00',1.88),('8975','2013-01-06','13:30:00',1.84),('8975','2013-01-06','13:35:00',1.77),('8975','2013-01-06','13:40:00',1.7),('8975','2013-01-06','13:45:00',1.63),('8975','2013-01-06','13:50:00',1.6),('8975','2013-01-06','13:55:00',1.51),('8975','2013-01-06','14:00:00',1.5),('8975','2013-01-06','14:05:00',1.43),('8975','2013-01-06','14:10:00',1.38),('8975','2013-01-06','14:15:00',1.34),('8975','2013-01-06','14:20:00',1.25),('8975','2013-01-06','14:25:00',1.19),('8975','2013-01-06','14:30:00',1.13),('8975','2013-01-06','14:35:00',1.06),('8975','2013-01-06','14:40:00',1.01),('8975','2013-01-06','14:45:00',1.09),('8975','2013-01-06','14:50:00',1.1),('8975','2013-01-06','14:55:00',1.11),('8975','2013-01-06','15:00:00',1.08),('8975','2013-01-06','15:05:00',1.05),('8975','2013-01-06','15:10:00',1.03),('8975','2013-01-05','08:05:00',1.06),('8975','2013-01-05','08:10:00',1.19),('8975','2013-01-05','08:15:00',1.31),('8975','2013-01-05','08:20:00',1.41),('8975','2013-01-05','08:25:00',1.5),('8975','2013-01-05','08:30:00',1.61),('8975','2013-01-05','08:35:00',1.71),('8975','2013-01-05','08:40:00',1.8),('8975','2013-01-05','08:45:00',1.9),('8975','2013-01-05','08:50:00',1.99),('8975','2013-01-05','08:55:00',2.06),('8975','2013-01-05','09:00:00',2.12),('8975','2013-01-05','09:05:00',2.2),('8975','2013-01-05','09:10:00',2.26),('8975','2013-01-05','09:15:00',2.33),('8975','2013-01-05','09:20:00',2.39),('8975','2013-01-05','09:25:00',2.43),('8975','2013-01-05','09:30:00',2.49),('8975','2013-01-05','09:35:00',2.54),('8975','2013-01-05','09:40:00',2.64),('8975','2013-01-05','09:45:00',2.68),('8975','2013-01-05','09:50:00',2.75),('8975','2013-01-05','09:55:00',2.74),('8975','2013-01-05','10:00:00',2.76),('8975','2013-01-05','10:05:00',2.77),('8975','2013-01-05','10:10:00',2.81),('8975','2013-01-05','10:15:00',2.83),('8975','2013-01-05','10:20:00',2.8),('8975','2013-01-05','10:25:00',2.82),('8975','2013-01-05','10:30:00',2.91),('8975','2013-01-05','10:35:00',2.97),('8975','2013-01-05','10:40:00',3.02),('8975','2013-01-05','10:45:00',3.04),('8975','2013-01-05','10:50:00',3.03),('8975','2013-01-05','10:55:00',3.05),('8975','2013-01-05','11:00:00',3.03),('8975','2013-01-05','11:05:00',3.05),('8975','2013-01-05','11:10:00',3.03),('8975','2013-01-05','11:15:00',3.04),('8975','2013-01-05','11:20:00',3.05),('8975','2013-01-05','11:25:00',3.05),('8975','2013-01-05','11:30:00',3.04),('8975','2013-01-05','11:35:00',2.93),('8975','2013-01-05','11:40:00',2.98),('8975','2013-01-05','11:45:00',2.92),('8975','2013-01-05','11:50:00',2.75),('8975','2013-01-05','11:55:00',2.7),('8975','2013-01-05','12:00:00',2.79),('8975','2013-01-05','12:05:00',2.68),('8975','2013-01-05','12:10:00',2.68),('8975','2013-01-05','12:15:00',2.65),('8975','2013-01-05','12:20:00',2.59),('8975','2013-01-05','12:25:00',2.55),('8975','2013-01-05','12:30:00',2.56),('8975','2013-01-05','12:35:00',2.47),('8975','2013-01-05','12:40:00',2.35),('8975','2013-01-05','12:45:00',2.39),('8975','2013-01-05','12:50:00',2.34),('8975','2013-01-05','12:55:00',2.33),('8975','2013-01-05','13:00:00',2.3),('8975','2013-01-05','13:05:00',2.25),('8975','2013-01-05','13:10:00',2.1),('8975','2013-01-05','13:15:00',2.03),('8975','2013-01-05','13:20:00',1.99),('8975','2013-01-05','13:25:00',1.86),('8975','2013-01-05','13:30:00',1.88),('8975','2013-01-05','13:35:00',1.78),('8975','2013-01-05','13:40:00',1.71),('8975','2013-01-05','13:45:00',1.66),('8975','2013-01-05','13:50:00',1.63),('8975','2013-01-05','13:55:00',1.57),('8975','2013-01-05','14:00:00',1.59),('8975','2013-01-05','14:05:00',1.55),('8975','2013-01-05','14:10:00',1.49),('8975','2013-01-05','14:15:00',1.41),('8975','2013-01-05','14:20:00',1.35),('8975','2013-01-05','14:25:00',1.25),('8975','2013-01-05','14:30:00',1.19),('8975','2013-01-05','14:35:00',1.09),('8975','2013-01-05','14:40:00',1.02),('8975','2013-01-05','14:45:00',1.14),('8975','2013-01-05','14:50:00',1.16),('8975','2013-01-05','14:55:00',1.15),('8975','2013-01-05','15:00:00',1.13),('8975','2013-01-05','15:05:00',1.08),('8975','2013-01-05','15:10:00',1.08),('8975','2013-01-05','15:15:00',1.03),('8975','2013-01-04','08:45:00',1.16),('8975','2013-01-04','08:50:00',1.13),('8975','2013-01-04','08:55:00',1),('8975','2013-01-04','09:05:00',1.07),('8975','2013-01-04','09:10:00',1.11),('8975','2013-01-04','09:15:00',1.06),('8975','2013-01-04','09:20:00',1),('8975','2013-01-04','09:25:00',1.08),('8975','2013-01-04','09:30:00',1.07),('8975','2013-01-04','09:35:00',1.17),('8975','2013-01-04','09:40:00',1.26),('8975','2013-01-04','09:45:00',1.21),('8975','2013-01-04','09:50:00',1.18),('8975','2013-01-04','09:55:00',1.23),('8975','2013-01-04','10:00:00',1.36),('8975','2013-01-04','10:05:00',1.46),('8975','2013-01-04','10:10:00',1.59),('8975','2013-01-04','10:15:00',1.68),('8975','2013-01-04','10:20:00',1.57),('8975','2013-01-04','10:25:00',1.51),('8975','2013-01-04','10:30:00',1.5),('8975','2013-01-04','10:35:00',1.67),('8975','2013-01-04','10:40:00',1.74),('8975','2013-01-04','10:45:00',1.67),('8975','2013-01-04','10:50:00',1.75),('8975','2013-01-04','10:55:00',2.66),('8975','2013-01-04','11:00:00',2.8),('8975','2013-01-04','11:05:00',2.51),('8975','2013-01-04','11:10:00',2.93),('8975','2013-01-04','11:15:00',2.25),('8975','2013-01-04','11:20:00',2.89),('8975','2013-01-04','11:25:00',3.21),('8975','2013-01-04','11:30:00',3.2),('8975','2013-01-04','11:35:00',2.97),('8975','2013-01-04','11:40:00',2.6),('8975','2013-01-04','11:45:00',2.72),('8975','2013-01-04','11:50:00',2.53),('8975','2013-01-04','11:55:00',2.12),('8975','2013-01-04','12:00:00',1.87),('8975','2013-01-04','12:05:00',1.75),('8975','2013-01-04','12:10:00',1.74),('8975','2013-01-04','12:15:00',2.03),('8975','2013-01-04','12:20:00',1.78),('8975','2013-01-04','12:25:00',1.68),('8975','2013-01-04','12:30:00',1.53),('8975','2013-01-04','12:35:00',1.74),('8975','2013-01-04','12:40:00',2.34),('8975','2013-01-04','12:45:00',2.54),('8975','2013-01-04','12:50:00',2.02),('8975','2013-01-04','12:55:00',1.76),('8975','2013-01-04','13:00:00',1.54),('8975','2013-01-04','13:05:00',1.6),('8975','2013-01-04','13:10:00',1.63),('8975','2013-01-04','13:15:00',1.45),('8975','2013-01-04','13:20:00',1.29),('8975','2013-01-04','13:25:00',1.32),('8975','2013-01-04','13:30:00',2),('8975','2013-01-04','13:35:00',1.78),('8975','2013-01-04','13:40:00',1.42),('8975','2013-01-04','13:45:00',1.28),('8975','2013-01-04','13:50:00',1.37),('8975','2013-01-04','13:55:00',1.53),('8975','2013-01-04','14:00:00',1.43),('8975','2013-01-04','14:05:00',1.75),('8975','2013-01-04','14:10:00',1.81),('8975','2013-01-04','14:15:00',1.47),('8975','2013-01-04','14:20:00',1.25),('8975','2013-01-04','14:30:00',1.21),('8975','2013-01-04','14:35:00',1.29),('8975','2013-01-04','14:40:00',1.36),('8975','2013-01-04','14:45:00',1.56),('8975','2013-01-04','14:50:00',1.15),('8975','2013-01-04','15:00:00',1.27),('8975','2013-01-04','15:05:00',1.17),('8975','2013-01-03','08:15:00',1.01),('8975','2013-01-03','08:20:00',1.1),('8975','2013-01-03','08:25:00',1.02),('8975','2013-01-03','08:35:00',1.1),('8975','2013-01-03','08:40:00',1.29),('8975','2013-01-03','08:45:00',1.84),('8975','2013-01-03','08:50:00',2.03),('8975','2013-01-03','08:55:00',1.96),('8975','2013-01-03','09:00:00',2.07),('8975','2013-01-03','09:05:00',1.95),('8975','2013-01-03','09:10:00',1.91),('8975','2013-01-03','09:15:00',2),('8975','2013-01-03','09:20:00',2.15),('8975','2013-01-03','09:25:00',1.96),('8975','2013-01-03','09:30:00',2.09),('8975','2013-01-03','09:35:00',1.94),('8975','2013-01-03','09:40:00',1.71),('8975','2013-01-03','09:45:00',2.02),('8975','2013-01-03','09:50:00',2.03),('8975','2013-01-03','09:55:00',2.26),('8975','2013-01-03','10:00:00',2.98),('8975','2013-01-03','10:05:00',3.05),('8975','2013-01-03','10:10:00',2.82),('8975','2013-01-03','10:15:00',2.76),('8975','2013-01-03','10:20:00',2.67),('8975','2013-01-03','10:25:00',2.56),('8975','2013-01-03','10:30:00',2.94),('8975','2013-01-03','10:35:00',3.09),('8975','2013-01-03','10:40:00',3.18),('8975','2013-01-03','10:45:00',3.26),('8975','2013-01-03','10:50:00',3.43),('8975','2013-01-03','10:55:00',3.58),('8975','2013-01-03','11:00:00',3.39),('8975','2013-01-03','11:05:00',2.57),('8975','2013-01-03','11:10:00',1.57),('8975','2013-01-03','11:15:00',1.44),('8975','2013-01-03','11:20:00',1.42),('8975','2013-01-03','11:25:00',1.28),('8975','2013-01-03','11:30:00',1.09),('8975','2013-01-03','11:35:00',1.12),('8975','2013-01-03','11:40:00',1.02),('8975','2013-01-03','11:45:00',1.48),('8975','2013-01-03','11:50:00',2.04),('8975','2013-01-03','11:55:00',2.87),('8975','2013-01-03','12:00:00',3.62),('8975','2013-01-03','12:05:00',3.22),('8975','2013-01-03','12:10:00',2.54),('8975','2013-01-03','12:15:00',1.85),('8975','2013-01-03','12:20:00',1.44),('8975','2013-01-03','12:25:00',1.22),('8975','2013-01-03','12:30:00',1.82),('8975','2013-01-03','12:35:00',1.94),('8975','2013-01-03','12:40:00',2.23),('8975','2013-01-03','12:45:00',2.48),('8975','2013-01-03','12:50:00',2.53),('8975','2013-01-03','12:55:00',2.53),('8975','2013-01-03','13:00:00',2.38),('8975','2013-01-03','13:05:00',2.19),('8975','2013-01-03','13:10:00',1.32),('8975','2013-01-03','13:15:00',1.59),('8975','2013-01-03','13:20:00',1.88),('8975','2013-01-03','13:25:00',1.81),('8975','2013-01-03','13:30:00',1.78),('8975','2013-01-03','13:35:00',1.64),('8975','2013-01-03','13:40:00',1.61),('8975','2013-01-03','13:45:00',1.57),('8975','2013-01-03','13:50:00',1.49),('8975','2013-01-03','13:55:00',1.48),('8975','2013-01-03','14:00:00',1.46),('8975','2013-01-03','14:05:00',1.39),('8975','2013-01-03','14:10:00',1.31),('8975','2013-01-03','14:15:00',1.29),('8975','2013-01-03','14:20:00',1.21),('8975','2013-01-03','14:25:00',1.15),('8975','2013-01-03','14:30:00',1.06),('8975','2013-01-03','14:40:00',1.1),('8975','2013-01-03','14:45:00',1.16),('8975','2013-01-03','14:50:00',1.13),('8975','2013-01-03','14:55:00',1.1),('8975','2013-01-03','15:00:00',1.08),('8975','2013-01-03','15:05:00',1.05),('8975','2013-01-03','15:15:00',1.02),('8975','2013-01-01','10:00:00',1.03),('8975','2013-01-01','13:40:00',1.2),('8975','2013-01-01','13:45:00',1.35),('8975','2013-01-01','13:50:00',1.27),('8975','2013-01-01','13:55:00',1.11),('8975','2014-03-17','07:30:00',1.24),('8975','2014-03-17','07:35:00',1.33),('8975','2014-03-17','07:40:00',1.68),('8975','2014-03-17','07:45:00',1.59),('8975','2014-03-17','07:50:00',1.06),('8975','2014-03-17','08:00:00',1.2),('8975','2014-03-17','08:05:00',2.3),('8975','2014-03-17','08:10:00',2.07),('8975','2014-03-17','08:15:00',1.57),('8975','2014-03-17','08:20:00',1.14),('8975','2014-03-17','08:25:00',1.08),('8975','2014-03-17','08:30:00',1.14),('8975','2014-03-17','08:35:00',1.23),('8975','2014-03-17','08:40:00',1.88),('8975','2014-03-17','08:45:00',1.51),('8975','2014-03-17','08:50:00',1.52),('8975','2014-03-17','08:55:00',1.67),('8975','2014-03-17','09:00:00',2.52),('8975','2014-03-17','09:05:00',3.31),('8975','2014-03-17','09:10:00',1.68),('8975','2014-03-17','09:15:00',1.37),('8975','2014-03-17','09:20:00',1.38),('8975','2014-03-17','09:25:00',1.57),('8975','2014-03-17','09:30:00',1.44),('8975','2014-03-17','09:35:00',1.92),('8975','2014-03-17','09:40:00',1.55),('8975','2014-03-17','09:45:00',1.47),('8975','2014-03-17','09:50:00',1.74),('8975','2014-03-17','09:55:00',1.43),('8975','2014-03-17','10:00:00',1.33),('8975','2014-03-17','10:05:00',1.6),('8975','2014-03-17','10:10:00',3.68),('8975','2014-03-17','10:15:00',5.38),('8975','2014-03-17','10:20:00',4.1),('8975','2014-03-17','10:25:00',3.13),('8975','2014-03-17','10:30:00',2.36),('8975','2014-03-17','10:35:00',1.69),('8975','2014-03-17','10:40:00',1.9),('8975','2014-03-17','10:45:00',3.09),('8975','2014-03-17','10:50:00',3.51),('8975','2014-03-17','10:55:00',6.14),('8975','2014-03-17','11:00:00',4.44),('8975','2014-03-17','11:05:00',3.15),('8975','2014-03-17','11:10:00',2.29),('8975','2014-03-17','11:15:00',2.56),('8975','2014-03-17','11:20:00',3.54),('8975','2014-03-17','11:25:00',2.71),('8975','2014-03-17','11:30:00',3.33),('8975','2014-03-17','11:35:00',6.41),('8975','2014-03-17','11:40:00',4.75),('8975','2014-03-17','11:45:00',6.37),('8975','2014-03-17','11:50:00',5.86),('8975','2014-03-17','11:55:00',4.43),('8975','2014-03-17','12:00:00',3.08),('8975','2014-03-17','12:05:00',2.83),('8975','2014-03-17','12:10:00',4.67),('8975','2014-03-17','12:15:00',6.43),('8975','2014-03-17','12:20:00',3.63),('8975','2014-03-17','12:25:00',5.74),('8975','2014-03-17','12:30:00',6.17),('8975','2014-03-17','12:35:00',5.6),('8975','2014-03-17','12:40:00',4.4),('8975','2014-03-17','12:45:00',5.91),('8975','2014-03-17','12:50:00',5.42),('8975','2014-03-17','12:55:00',5.28),('8975','2014-03-17','13:00:00',5.1),('8975','2014-03-17','13:05:00',4.57),('8975','2014-03-17','13:10:00',5.21),('8975','2014-03-17','13:15:00',4.35),('8975','2014-03-17','13:20:00',4.73),('8975','2014-03-17','13:25:00',4.52),('8975','2014-03-17','13:30:00',4.3),('8975','2014-03-17','13:35:00',4.51),('8975','2014-03-17','13:40:00',4.42),('8975','2014-03-17','13:45:00',4.29),('8975','2014-03-17','13:50:00',4.1),('8975','2014-03-17','13:55:00',4.15),('8975','2014-03-17','14:00:00',4.01),('8975','2014-03-17','14:05:00',3.94),('8975','2014-03-17','14:10:00',3.67),('8975','2014-03-17','14:15:00',3.56),('8975','2014-03-17','14:20:00',3.65),('8975','2014-03-17','14:25:00',3.56),('8975','2014-03-17','14:30:00',3.48),('8975','2014-03-17','14:35:00',3.31),('8975','2014-03-17','14:40:00',3.1),('8975','2014-03-17','14:45:00',2.98),('8975','2014-03-17','14:50:00',3.04),('8975','2014-03-17','14:55:00',2.92),('8975','2014-03-17','15:00:00',2.87),('8975','2014-03-17','15:05:00',2.78),('8975','2014-03-17','15:10:00',2.66),('8975','2014-03-17','15:15:00',2.56),('8975','2014-03-17','15:20:00',2.46),('8975','2014-03-17','15:25:00',2.34),('8975','2014-03-17','15:30:00',2.21),('8975','2014-03-17','15:35:00',2.15),('8975','2014-03-17','15:40:00',2.03),('8975','2014-03-17','15:45:00',1.94),('8975','2014-03-17','15:50:00',1.85),('8975','2014-03-17','15:55:00',1.77),('8975','2014-03-17','16:00:00',1.69),('8975','2014-03-17','16:05:00',1.61),('8975','2014-03-17','16:10:00',1.55),('8975','2014-03-17','16:15:00',1.48),('8975','2014-03-17','16:20:00',1.45),('8975','2014-03-17','16:25:00',1.4),('8975','2014-03-17','16:30:00',1.36),('8975','2014-03-17','16:35:00',1.35),('8975','2014-03-17','16:40:00',1.3),('8975','2014-03-17','16:45:00',1.24),('8975','2014-03-17','16:50:00',1.18),('8975','2014-03-17','16:55:00',1.11),('8975','2014-03-17','17:00:00',1.04),('8975','2012-12-31','08:15:00',1.08),('8975','2012-12-31','08:20:00',1.19),('8975','2012-12-31','08:25:00',1.31),('8975','2012-12-31','08:30:00',1.4),('8975','2012-12-31','08:35:00',1.53),('8975','2012-12-31','08:40:00',1.66),('8975','2012-12-31','08:45:00',1.75),('8975','2012-12-31','08:50:00',1.81),('8975','2012-12-31','08:55:00',1.87),('8975','2012-12-31','09:00:00',1.93),('8975','2012-12-31','09:05:00',2.04),('8975','2012-12-31','09:10:00',2.11),('8975','2012-12-31','09:15:00',2.17),('8975','2012-12-31','09:20:00',2.22),('8975','2012-12-31','09:25:00',2.29),('8975','2012-12-31','09:30:00',2.34),('8975','2012-12-31','09:35:00',2.4),('8975','2012-12-31','09:40:00',2.47),('8975','2012-12-31','09:45:00',2.53),('8975','2012-12-31','09:50:00',2.57),('8975','2012-12-31','09:55:00',2.58),('8975','2012-12-31','10:00:00',2.61),('8975','2012-12-31','10:05:00',2.64),('8975','2012-12-31','10:10:00',2.68),('8975','2012-12-31','10:15:00',2.73),('8975','2012-12-31','10:20:00',2.71),('8975','2012-12-31','10:25:00',2.73),('8975','2012-12-31','10:30:00',2.8),('8975','2012-12-31','10:35:00',2.88),('8975','2012-12-31','10:40:00',2.97),('8975','2012-12-31','10:45:00',3.03),('8975','2012-12-31','10:50:00',1.93),('8975','2012-12-31','10:55:00',1.85),('8975','2012-12-31','11:00:00',1.05),('8975','2012-12-31','11:05:00',1.05),('8975','2012-12-31','11:10:00',1.33),('8975','2012-12-31','11:15:00',1.29),('8975','2012-12-31','11:20:00',2.01),('8975','2012-12-31','11:25:00',3.33),('8975','2012-12-31','11:30:00',3.36),('8975','2012-12-31','11:35:00',2.61),('8975','2012-12-31','11:40:00',2.74),('8975','2012-12-31','11:45:00',2.59),('8975','2012-12-31','11:50:00',1.72),('8975','2012-12-31','11:55:00',2.44),('8975','2012-12-31','12:00:00',2.86),('8975','2012-12-31','12:05:00',1.88),('8975','2012-12-31','12:10:00',1.87),('8975','2012-12-31','12:15:00',1.83),('8975','2012-12-31','12:20:00',1.71),('8975','2012-12-31','12:25:00',1.59),('8975','2012-12-31','12:30:00',1.72),('8975','2012-12-31','12:35:00',1.65),('8975','2012-12-31','12:40:00',2.12),('8975','2012-12-31','12:45:00',2.11),('8975','2012-12-31','12:50:00',2.71),('8975','2012-12-31','12:55:00',2.93),('8975','2012-12-31','13:00:00',2.38),('8975','2012-12-31','13:05:00',1.55),('8975','2012-12-31','13:10:00',1.24),('8975','2012-12-31','13:15:00',1.28),('8975','2012-12-31','13:20:00',1.2),('8975','2012-12-31','13:25:00',1.1),('8975','2012-12-30','08:00:00',1),('8975','2012-12-30','08:05:00',1.18),('8975','2012-12-30','08:10:00',1.26),('8975','2012-12-30','08:15:00',1.43),('8975','2012-12-30','08:20:00',1.42),('8975','2012-12-30','08:25:00',1.62),('8975','2012-12-30','08:30:00',1.74),('8975','2012-12-30','08:35:00',1.85),('8975','2012-12-30','08:40:00',1.31),('8975','2012-12-30','08:45:00',1.01),('8975','2012-12-30','08:50:00',1.27),('8975','2012-12-30','08:55:00',1.53),('8975','2012-12-30','09:00:00',2.1),('8975','2012-12-30','09:05:00',2.12),('8975','2012-12-30','09:10:00',2),('8975','2012-12-30','09:15:00',2.21),('8975','2012-12-30','09:20:00',2.23),('8975','2012-12-30','09:25:00',2.52),('8975','2012-12-30','09:30:00',2.77),('8975','2012-12-30','09:35:00',1.96),('8975','2012-12-30','09:40:00',1.06),('8975','2012-12-30','09:55:00',1.01),('8975','2012-12-30','10:00:00',2.17),('8975','2012-12-30','10:05:00',2.83),('8975','2012-12-30','10:10:00',2.89),('8975','2012-12-30','10:15:00',3.07),('8975','2012-12-30','10:20:00',3),('8975','2012-12-30','10:25:00',2.9),('8975','2012-12-30','10:30:00',2.98),('8975','2012-12-30','10:35:00',3.04),('8975','2012-12-30','10:40:00',3.08),('8975','2012-12-30','10:45:00',3.03),('8975','2012-12-30','10:50:00',2.98),('8975','2012-12-30','10:55:00',3.02),('8975','2012-12-30','11:00:00',2.99),('8975','2012-12-30','11:05:00',2.95),('8975','2012-12-30','11:10:00',2.99),('8975','2012-12-30','11:15:00',3.06),('8975','2012-12-30','11:20:00',3.03),('8975','2012-12-30','11:25:00',3.06),('8975','2012-12-30','11:30:00',3.02),('8975','2012-12-30','11:35:00',2.99),('8975','2012-12-30','11:40:00',2.92),('8975','2012-12-30','11:45:00',2.6),('8975','2012-12-30','11:50:00',2.8),('8975','2012-12-30','11:55:00',2.82),('8975','2012-12-30','12:00:00',2.76),('8975','2012-12-30','12:05:00',2.72),('8975','2012-12-30','12:10:00',2.71),('8975','2012-12-30','12:15:00',2.62),('8975','2012-12-30','12:20:00',2.63),('8975','2012-12-30','12:25:00',2.61),('8975','2012-12-30','12:30:00',2.52),('8975','2012-12-30','12:35:00',2.44),('8975','2012-12-30','12:40:00',2.43),('8975','2012-12-30','12:45:00',2.38),('8975','2012-12-30','12:50:00',2.36),('8975','2012-12-30','12:55:00',2.31),('8975','2012-12-30','13:00:00',2.19),('8975','2012-12-30','13:05:00',2.12),('8975','2012-12-30','13:10:00',2.05),('8975','2012-12-30','13:15:00',1.96),('8975','2012-12-30','13:20:00',1.9),('8975','2012-12-30','13:25:00',1.89),('8975','2012-12-30','13:30:00',1.77),('8975','2012-12-30','13:35:00',1.68),('8975','2012-12-30','13:40:00',1.59),('8975','2012-12-30','13:45:00',1.57),('8975','2012-12-30','13:50:00',1.55),('8975','2012-12-30','13:55:00',1.53),('8975','2012-12-30','14:00:00',1.47),('8975','2012-12-30','14:05:00',1.4),('8975','2012-12-30','14:10:00',1.3),('8975','2012-12-30','14:15:00',1.22),('8975','2012-12-30','14:20:00',1.11),('8975','2012-12-30','14:25:00',1.11),('8975','2012-12-30','14:30:00',1.12),('8975','2012-12-30','14:35:00',1.11),('8975','2012-12-30','14:40:00',1.13),('8975','2012-12-30','14:45:00',1.17),('8975','2012-12-30','14:50:00',1.14),('8975','2012-12-30','14:55:00',1.11),('8975','2012-12-30','15:00:00',1.09),('8975','2012-12-30','15:05:00',1.06),('8975','2012-12-30','15:10:00',1.04),('8975','2012-12-29','08:10:00',1.12),('8975','2012-12-29','08:15:00',1.24),('8975','2012-12-29','08:20:00',1.35),('8975','2012-12-29','08:25:00',1.45),('8975','2012-12-29','08:30:00',1.56),('8975','2012-12-29','08:35:00',1.67),('8975','2012-12-29','08:40:00',1.75),('8975','2012-12-29','08:45:00',1.86),('8975','2012-12-29','08:50:00',1.94),('8975','2012-12-29','08:55:00',2.02),('8975','2012-12-29','09:00:00',2.07),('8975','2012-12-29','09:05:00',2.13),('8975','2012-12-29','09:10:00',2.2),('8975','2012-12-29','09:15:00',2.27),('8975','2012-12-29','09:20:00',2.34),('8975','2012-12-29','09:25:00',2.38),('8975','2012-12-29','09:30:00',2.44),('8975','2012-12-29','09:35:00',2.51),('8975','2012-12-29','09:40:00',2.57),('8975','2012-12-29','09:45:00',2.63),('8975','2012-12-29','09:50:00',2.67),('8975','2012-12-29','09:55:00',2.63),('8975','2012-12-29','10:00:00',2.48),('8975','2012-12-29','10:05:00',2.68),('8975','2012-12-29','10:10:00',2.62),('8975','2012-12-29','10:15:00',2.76),('8975','2012-12-29','10:20:00',2.65),('8975','2012-12-29','10:25:00',2.81),('8975','2012-12-29','10:30:00',2.58),('8975','2012-12-29','10:35:00',2.84),('8975','2012-12-29','10:40:00',2.92),('8975','2012-12-29','10:45:00',2.96),('8975','2012-12-29','10:50:00',2.81),('8975','2012-12-29','10:55:00',2.7),('8975','2012-12-29','11:00:00',2.99),('8975','2012-12-29','11:05:00',2.92),('8975','2012-12-29','11:10:00',3.06),('8975','2012-12-29','11:15:00',3.06),('8975','2012-12-29','11:20:00',2.81),('8975','2012-12-29','11:25:00',3),('8975','2012-12-29','11:30:00',2.99),('8975','2012-12-29','11:35:00',2.98),('8975','2012-12-29','11:40:00',2.89),('8975','2012-12-29','11:45:00',2.84),('8975','2012-12-29','11:50:00',2.77),('8975','2012-12-29','11:55:00',2.73),('8975','2012-12-29','12:00:00',2.72),('8975','2012-12-29','12:05:00',2.64),('8975','2012-12-29','12:10:00',2.61),('8975','2012-12-29','12:15:00',2.6),('8975','2012-12-29','12:20:00',2.56),('8975','2012-12-29','12:25:00',2.53),('8975','2012-12-29','12:30:00',2.46),('8975','2012-12-29','12:35:00',2.38),('8975','2012-12-29','12:40:00',2.34),('8975','2012-12-29','12:45:00',2.33),('8975','2012-12-29','12:50:00',2.23),('8975','2012-12-29','12:55:00',2.2),('8975','2012-12-29','13:00:00',2.17),('8975','2012-12-29','13:05:00',1.98),('8975','2012-12-29','13:10:00',1.94),('8975','2012-12-29','13:15:00',1.92),('8975','2012-12-29','13:20:00',1.87),('8975','2012-12-29','13:25:00',1.86),('8975','2012-12-29','13:30:00',1.75),('8975','2012-12-29','13:35:00',1.65),('8975','2012-12-29','13:40:00',1.61),('8975','2012-12-29','13:45:00',1.61),('8975','2012-12-29','13:50:00',1.54),('8975','2012-12-29','13:55:00',1.52),('8975','2012-12-29','14:00:00',1.47),('8975','2012-12-29','14:05:00',1.39),('8975','2012-12-29','14:10:00',1.3),('8975','2012-12-29','14:15:00',1.19),('8975','2012-12-29','14:20:00',1.01),('8975','2012-12-29','14:30:00',1.14),('8975','2012-12-29','14:35:00',1.13),('8975','2012-12-29','14:40:00',1.14),('8975','2012-12-29','14:45:00',1.18),('8975','2012-12-29','14:50:00',1.15),('8975','2012-12-29','14:55:00',1.11),('8975','2012-12-29','15:00:00',1.09),('8975','2012-12-29','15:05:00',1.07),('8975','2012-12-29','15:10:00',1.04),('8975','2012-12-29','15:15:00',1.01),('8975','2012-12-29','15:20:00',1),('8975','2012-12-28','08:10:00',1.1),('8975','2012-12-28','08:15:00',1.22),('8975','2012-12-28','08:20:00',1.33),('8975','2012-12-28','08:25:00',1.46),('8975','2012-12-28','08:30:00',1.6),('8975','2012-12-28','08:35:00',1.74),('8975','2012-12-28','08:40:00',1.84),('8975','2012-12-28','08:45:00',1.96),('8975','2012-12-28','08:50:00',2.02),('8975','2012-12-28','08:55:00',2.06),('8975','2012-12-28','09:00:00',2.12),('8975','2012-12-28','09:05:00',2.16),('8975','2012-12-28','09:10:00',2.19),('8975','2012-12-28','09:15:00',2.19),('8975','2012-12-28','09:20:00',2.35),('8975','2012-12-28','09:25:00',2.4),('8975','2012-12-28','09:30:00',2.45),('8975','2012-12-28','09:35:00',2.54),('8975','2012-12-28','09:40:00',2.62),('8975','2012-12-28','09:45:00',2.72),('8975','2012-12-28','09:50:00',2.77),('8975','2012-12-28','09:55:00',2.79),('8975','2012-12-28','10:00:00',2.82),('8975','2012-12-28','10:05:00',2.83),('8975','2012-12-28','10:10:00',2.85),('8975','2012-12-28','10:15:00',2.89),('8975','2012-12-28','10:20:00',2.84),('8975','2012-12-28','10:25:00',2.83),('8975','2012-12-28','10:30:00',2.92),('8975','2012-12-28','10:35:00',2.96),('8975','2012-12-28','10:40:00',3.01),('8975','2012-12-28','10:45:00',3),('8975','2012-12-28','10:50:00',2.93),('8975','2012-12-28','10:55:00',2.97),('8975','2012-12-28','11:00:00',3.05),('8975','2012-12-28','11:05:00',3.04),('8975','2012-12-28','11:10:00',3.06),('8975','2012-12-28','11:15:00',3.09),('8975','2012-12-28','11:20:00',3.07),('8975','2012-12-28','11:25:00',3.08),('8975','2012-12-28','11:30:00',3.04),('8975','2012-12-28','11:35:00',3.02),('8975','2012-12-28','11:40:00',2.86),('8975','2012-12-28','11:45:00',2.87),('8975','2012-12-28','11:50:00',2.82),('8975','2012-12-28','11:55:00',2.73),('8975','2012-12-28','12:00:00',2.74),('8975','2012-12-28','12:05:00',2.68),('8975','2012-12-28','12:10:00',2.64),('8975','2012-12-28','12:15:00',2.62),('8975','2012-12-28','12:20:00',2.56),('8975','2012-12-28','12:25:00',2.55),('8975','2012-12-28','12:30:00',2.49),('8975','2012-12-28','12:35:00',2.41),('8975','2012-12-28','12:40:00',2.37),('8975','2012-12-28','12:45:00',2.36),('8975','2012-12-28','12:50:00',2.23),('8975','2012-12-28','12:55:00',2.26),('8975','2012-12-28','13:00:00',2.17),('8975','2012-12-28','13:05:00',1.97),('8975','2012-12-28','13:10:00',1.95),('8975','2012-12-28','13:15:00',1.92),('8975','2012-12-28','13:20:00',1.89),('8975','2012-12-28','13:25:00',1.87),('8975','2012-12-28','13:30:00',1.76),('8975','2012-12-28','13:35:00',1.65),('8975','2012-12-28','13:40:00',1.62),('8975','2012-12-28','13:45:00',1.61),('8975','2012-12-28','13:50:00',1.57),('8975','2012-12-28','13:55:00',1.52),('8975','2012-12-28','14:00:00',1.45),('8975','2012-12-28','14:05:00',1.39),('8975','2012-12-28','14:10:00',1.31),('8975','2012-12-28','14:15:00',1.16),('8975','2012-12-28','14:25:00',1.06),('8975','2012-12-28','14:30:00',1.13),('8975','2012-12-28','14:35:00',1.14),('8975','2012-12-28','14:40:00',1.16),('8975','2012-12-28','14:45:00',1.19),('8975','2012-12-28','14:50:00',1.16),('8975','2012-12-28','14:55:00',1.12),('8975','2012-12-28','15:00:00',1.1),('8975','2012-12-28','15:05:00',1.08),('8975','2012-12-28','15:10:00',1.05),('8975','2012-12-28','15:15:00',1.04),('8975','2012-12-28','15:20:00',1.01),('8975','2012-12-27','08:40:00',1.32),('8975','2012-12-27','08:45:00',1.59),('8975','2012-12-27','08:50:00',1.75),('8975','2012-12-27','08:55:00',1.85),('8975','2012-12-27','09:00:00',1.94),('8975','2012-12-27','09:05:00',1.99),('8975','2012-12-27','09:10:00',2.07),('8975','2012-12-27','09:15:00',2.16),('8975','2012-12-27','09:20:00',2.2),('8975','2012-12-27','09:25:00',2.24),('8975','2012-12-27','09:30:00',2.29),('8975','2012-12-27','09:35:00',2.33),('8975','2012-12-27','09:40:00',2.41),('8975','2012-12-27','09:45:00',2.47),('8975','2012-12-27','09:50:00',2.51),('8975','2012-12-27','09:55:00',2.55),('8975','2012-12-27','10:00:00',2.54),('8975','2012-12-27','10:05:00',2.59),('8975','2012-12-27','10:10:00',2.59),('8975','2012-12-27','10:15:00',2.65),('8975','2012-12-27','10:20:00',2.63),('8975','2012-12-27','10:25:00',2.6),('8975','2012-12-27','10:30:00',2.69),('8975','2012-12-27','10:35:00',2.78),('8975','2012-12-27','10:40:00',2.85),('8975','2012-12-27','10:45:00',2.85),('8975','2012-12-27','10:50:00',2.85),('8975','2012-12-27','10:55:00',2.85),('8975','2012-12-27','11:00:00',2.86),('8975','2012-12-27','11:05:00',2.92),('8975','2012-12-27','11:10:00',2.92),('8975','2012-12-27','11:15:00',2.76),('8975','2012-12-27','11:20:00',3.07),('8975','2012-12-27','11:25:00',2.78),('8975','2012-12-27','11:30:00',2.92),('8975','2012-12-27','11:35:00',2.94),('8975','2012-12-27','11:40:00',2.4),('8975','2012-12-27','11:45:00',2.36),('8975','2012-12-27','11:50:00',1.69),('8975','2012-12-27','11:55:00',2.31),('8975','2012-12-27','12:05:00',1.92),('8975','2012-12-27','12:10:00',1.99),('8975','2012-12-27','12:15:00',2.35),('8975','2012-12-27','12:20:00',2.46),('8975','2012-12-27','12:25:00',2.47),('8975','2012-12-27','12:30:00',2.42),('8975','2012-12-27','12:35:00',2.38),('8975','2012-12-27','12:40:00',2.27),('8975','2012-12-27','12:45:00',2.3),('8975','2012-12-27','12:50:00',2.26),('8975','2012-12-27','12:55:00',2.14),('8975','2012-12-27','13:00:00',2.03),('8975','2012-12-27','13:05:00',1.89),('8975','2012-12-27','13:10:00',1.88),('8975','2012-12-27','13:15:00',1.88),('8975','2012-12-27','13:20:00',1.84),('8975','2012-12-27','13:25:00',1.81),('8975','2012-12-27','13:30:00',1.7),('8975','2012-12-27','13:35:00',1.59),('8975','2012-12-27','13:40:00',1.46),('8975','2012-12-27','13:45:00',1.42),('8975','2012-12-27','13:50:00',1.52),('8975','2012-12-27','13:55:00',1.44),('8975','2012-12-27','14:00:00',1.42),('8975','2012-12-27','14:05:00',1.33),('8975','2012-12-27','14:10:00',1.24),('8975','2012-12-27','14:15:00',1.15),('8975','2012-12-27','14:20:00',1.15),('8975','2012-12-27','14:25:00',1.14),('8975','2012-12-27','14:30:00',1.12),('8975','2012-12-27','14:35:00',1.11),('8975','2012-12-27','14:40:00',1.17),('8975','2012-12-27','14:45:00',1.19),('8975','2012-12-27','14:50:00',1.13),('8975','2012-12-27','14:55:00',1.11),('8975','2012-12-27','15:00:00',1.06),('8975','2012-12-27','15:05:00',1.02),('8975','2012-12-26','08:25:00',1.19),('8975','2012-12-26','08:30:00',1.25),('8975','2012-12-26','08:35:00',1.36),('8975','2012-12-26','08:40:00',1.27),('8975','2012-12-26','08:45:00',1.1),('8975','2012-12-26','08:50:00',1.67),('8975','2012-12-26','08:55:00',1.89),('8975','2012-12-26','09:00:00',1.37),('8975','2012-12-26','09:10:00',1.59),('8975','2012-12-26','09:15:00',1.74),('8975','2012-12-26','09:20:00',2.13),('8975','2012-12-26','09:25:00',2.13),('8975','2012-12-26','09:30:00',2.16),('8975','2012-12-26','09:35:00',2.3),('8975','2012-12-26','09:40:00',2.37),('8975','2012-12-26','09:45:00',2.42),('8975','2012-12-26','09:50:00',2.48),('8975','2012-12-26','09:55:00',2.59),('8975','2012-12-26','10:00:00',2.57),('8975','2012-12-26','10:05:00',2.58),('8975','2012-12-26','10:10:00',2.62),('8975','2012-12-26','10:15:00',2.59),('8975','2012-12-26','10:20:00',2.43),('8975','2012-12-26','10:25:00',2.46),('8975','2012-12-26','10:30:00',2.47),('8975','2012-12-26','10:35:00',2.57),('8975','2012-12-26','10:40:00',2.59),('8975','2012-12-26','10:45:00',1.53),('8975','2012-12-26','10:55:00',1.2),('8975','2012-12-26','11:00:00',1.9),('8975','2012-12-26','11:05:00',2.71),('8975','2012-12-26','11:10:00',2.02),('8975','2012-12-26','11:15:00',2.67),('8975','2012-12-26','11:20:00',1.43),('8975','2012-12-26','11:55:00',1.05),('8975','2012-12-26','12:00:00',2.2),('8975','2012-12-26','12:05:00',2.61),('8975','2012-12-26','12:10:00',2.57),('8975','2012-12-26','12:15:00',2.51),('8975','2012-12-26','12:20:00',1.48),('8975','2012-12-26','12:35:00',1.15),('8975','2012-12-26','12:40:00',1.75),('8975','2012-12-26','12:45:00',1.85),('8975','2012-12-26','12:50:00',2.35),('8975','2012-12-26','12:55:00',2.27),('8975','2012-12-26','13:05:00',1.33),('8975','2012-12-26','13:10:00',1.35),('8975','2012-12-26','13:15:00',1.21),('8975','2012-12-26','13:20:00',1.31),('8975','2012-12-26','13:25:00',1.29),('8975','2012-12-26','13:30:00',1.28),('8975','2012-12-26','13:35:00',2.17),('8975','2012-12-26','13:40:00',1.98),('8975','2012-12-26','13:45:00',1.09),('8975','2012-12-26','13:50:00',1.75),('8975','2012-12-26','13:55:00',2.22),('8975','2012-12-26','14:00:00',1.4),('8975','2012-12-26','14:05:00',1.65),('8975','2012-12-26','14:10:00',1.44),('8975','2012-12-26','14:15:00',1.12),('8975','2012-12-26','14:20:00',1.16),('8975','2012-12-26','14:25:00',1.12),('8975','2012-12-26','14:30:00',1.04),('8975','2012-12-26','14:35:00',1.04),('8975','2012-12-26','14:50:00',1.03),('8975','2012-12-26','14:55:00',1.03),('8975','2012-12-25','09:15:00',1.71),('8975','2012-12-25','09:20:00',2.32),('8975','2012-12-25','09:25:00',2.33),('8975','2012-12-25','09:30:00',2.33),('8975','2012-12-25','09:35:00',2.35),('8975','2012-12-25','09:40:00',2.49),('8975','2012-12-25','09:45:00',2.55),('8975','2012-12-25','09:50:00',2.58),('8975','2012-12-25','09:55:00',2.61),('8975','2012-12-25','10:00:00',2.64),('8975','2012-12-25','10:05:00',2.66),('8975','2012-12-25','10:10:00',2.68),('8975','2012-12-25','10:15:00',2.68),('8975','2012-12-25','10:20:00',2.63),('8975','2012-12-25','10:25:00',2.58),('8975','2012-12-25','10:30:00',2.57),('8975','2012-12-25','10:35:00',2.69),('8975','2012-12-25','10:40:00',2.75),('8975','2012-12-25','10:45:00',2.69),('8975','2012-12-25','10:50:00',2.74),('8975','2012-12-25','10:55:00',2.78),('8975','2012-12-25','11:00:00',2.77),('8975','2012-12-25','11:05:00',2.77),('8975','2012-12-25','11:10:00',2.76),('8975','2012-12-25','11:15:00',2.77),('8975','2012-12-25','11:20:00',2.77),('8975','2012-12-25','11:25:00',2.8),('8975','2012-12-25','11:30:00',2.68),('8975','2012-12-25','11:35:00',2.67),('8975','2012-12-25','11:40:00',2.54),('8975','2012-12-25','11:45:00',2.64),('8975','2012-12-25','11:50:00',2.67),('8975','2012-12-25','11:55:00',2.66),('8975','2012-12-25','12:00:00',2.59),('8975','2012-12-25','12:05:00',2.55),('8975','2012-12-25','12:10:00',2.55),('8975','2012-12-25','12:15:00',2.5),('8975','2012-12-25','12:20:00',2.46),('8975','2012-12-25','12:25:00',2.45),('8975','2012-12-25','12:30:00',2.2),('8975','2012-12-25','12:35:00',1.97),('8975','2012-12-25','12:40:00',2.25),('8975','2012-12-25','12:45:00',2.2),('8975','2012-12-25','12:50:00',2.01),('8975','2012-12-25','12:55:00',1.98),('8975','2012-12-25','13:00:00',2.01),('8975','2012-12-25','13:05:00',1.82),('8975','2012-12-25','13:10:00',1.94),('8975','2012-12-25','13:15:00',1.62),('8975','2012-12-25','13:20:00',1.51),('8975','2012-12-25','13:25:00',1.56),('8975','2012-12-25','13:35:00',1.49),('8975','2012-12-25','13:40:00',1.62),('8975','2012-12-25','13:45:00',1.44),('8975','2012-12-25','13:50:00',1.1),('8975','2012-12-25','14:00:00',1.36),('8975','2012-12-25','14:05:00',1.25),('8975','2012-12-25','14:10:00',1.3),('8975','2012-12-25','14:15:00',1.2),('8975','2012-12-25','14:20:00',1.05),('8975','2012-12-24','10:05:00',1.03),('8975','2012-12-24','10:10:00',1.08),('8975','2012-12-24','10:15:00',1.11),('8975','2012-12-24','10:20:00',1.18),('8975','2012-12-24','10:25:00',1.18),('8975','2012-12-24','10:30:00',1.14),('8975','2012-12-24','10:35:00',1.14),('8975','2012-12-24','10:40:00',1.1),('8975','2012-12-24','10:45:00',1.13),('8975','2012-12-24','10:50:00',1.11),('8975','2012-12-24','10:55:00',1.26),('8975','2012-12-24','11:00:00',1.2),('8975','2012-12-24','11:05:00',1.33),('8975','2012-12-24','11:10:00',1.37),('8975','2012-12-24','11:15:00',1.32),('8975','2012-12-24','11:20:00',1.38),('8975','2012-12-24','11:25:00',1.33),('8975','2012-12-24','11:30:00',1.39),('8975','2012-12-24','11:35:00',1.35),('8975','2012-12-24','11:40:00',1.29),('8975','2012-12-24','11:45:00',1.31),('8975','2012-12-24','11:50:00',1.32),('8975','2012-12-24','11:55:00',1.36),('8975','2012-12-24','12:00:00',1.32),('8975','2012-12-24','12:05:00',1.28),('8975','2012-12-24','12:10:00',1.36),('8975','2012-12-24','12:15:00',1.38),('8975','2012-12-24','12:20:00',1.3),('8975','2012-12-24','12:25:00',1.35),('8975','2012-12-24','12:30:00',1.26),('8975','2012-12-24','12:35:00',1.15),('8975','2012-12-24','12:40:00',1.18),('8975','2012-12-24','12:45:00',1.31),('8975','2012-12-24','12:50:00',1.27),('8975','2012-12-24','12:55:00',1.4),('8975','2012-12-24','13:00:00',1.23),('8975','2012-12-24','13:05:00',1.26),('8975','2012-12-24','13:10:00',1.43),('8975','2012-12-24','13:15:00',1.29),('8975','2012-12-24','13:20:00',1.2),('8975','2012-12-24','13:30:00',1.17),('8975','2012-12-24','13:35:00',1.11),('8975','2012-12-24','13:40:00',1.03),('8975','2012-12-24','14:00:00',1.05),('8975','2012-12-23','11:40:00',1.03),('8975','2012-12-23','11:45:00',1.05),('8975','2012-12-23','11:50:00',1.06),('8975','2012-12-23','11:55:00',1.15),('8975','2012-12-23','12:00:00',1.28),('8975','2012-12-23','12:05:00',1.36),('8975','2012-12-23','12:10:00',1.27),('8975','2012-12-23','12:15:00',1.21),('8975','2012-12-23','12:20:00',1.14),('8975','2012-12-23','12:25:00',1.15),('8975','2012-12-23','12:30:00',1.17),('8975','2012-12-23','12:35:00',1.19),('8975','2012-12-23','12:40:00',1.15),('8975','2012-12-23','12:45:00',1.09),('8975','2012-12-23','12:50:00',1.04),('8975','2012-12-23','12:55:00',1.03),('8975','2012-12-22','08:10:00',1.13),('8975','2012-12-22','08:15:00',1.23),('8975','2012-12-22','08:20:00',1.37),('8975','2012-12-22','08:25:00',1.46),('8975','2012-12-22','08:30:00',1.58),('8975','2012-12-22','08:35:00',1.7),('8975','2012-12-22','08:40:00',1.79),('8975','2012-12-22','08:45:00',1.87),('8975','2012-12-22','08:50:00',1.92),('8975','2012-12-22','08:55:00',2),('8975','2012-12-22','09:00:00',2.09),('8975','2012-12-22','09:05:00',2.15),('8975','2012-12-22','09:10:00',2.21),('8975','2012-12-22','09:15:00',2.21),('8975','2012-12-22','09:20:00',2.22),('8975','2012-12-22','09:25:00',2.3),('8975','2012-12-22','09:30:00',2.34),('8975','2012-12-22','09:35:00',2.46),('8975','2012-12-22','09:40:00',2.51),('8975','2012-12-22','09:45:00',2.57),('8975','2012-12-22','09:50:00',2.58),('8975','2012-12-22','09:55:00',2.6),('8975','2012-12-22','10:00:00',2.61),('8975','2012-12-22','10:05:00',2.65),('8975','2012-12-22','10:10:00',2.7),('8975','2012-12-22','10:15:00',2.71),('8975','2012-12-22','10:20:00',2.6),('8975','2012-12-22','10:25:00',2.63),('8975','2012-12-22','10:30:00',2.58),('8975','2012-12-22','10:35:00',2.68),('8975','2012-12-22','10:40:00',2.76),('8975','2012-12-22','10:45:00',2.76),('8975','2012-12-22','10:50:00',2.75),('8975','2012-12-22','10:55:00',2.7),('8975','2012-12-22','11:00:00',2.83),('8975','2012-12-22','11:05:00',2.86),('8975','2012-12-22','11:10:00',2.86),('8975','2012-12-22','11:15:00',2.88),('8975','2012-12-22','11:20:00',2.9),('8975','2012-12-22','11:25:00',2.71),('8975','2012-12-22','11:30:00',2.49),('8975','2012-12-22','11:35:00',2.72),('8975','2012-12-22','11:40:00',2.76),('8975','2012-12-22','11:45:00',2.69),('8975','2012-12-22','11:50:00',2.69),('8975','2012-12-22','11:55:00',2.65),('8975','2012-12-22','12:00:00',2.41),('8975','2012-12-22','12:05:00',2.39),('8975','2012-12-22','12:10:00',2.39),('8975','2012-12-22','12:15:00',1.91),('8975','2012-12-22','12:20:00',2.29),('8975','2012-12-22','12:25:00',1.69),('8975','2012-12-22','12:30:00',1.43),('8975','2012-12-22','12:35:00',1.64),('8975','2012-12-22','12:40:00',1.85),('8975','2012-12-22','12:45:00',1.38),('8975','2012-12-22','12:50:00',1.42),('8975','2012-12-22','12:55:00',2.33),('8975','2012-12-22','13:00:00',2.19),('8975','2012-12-22','13:05:00',1.68),('8975','2012-12-22','13:10:00',1.86),('8975','2012-12-22','13:15:00',2.36),('8975','2012-12-22','13:20:00',1.74),('8975','2012-12-22','13:25:00',1.42),('8975','2012-12-22','13:30:00',1.44),('8975','2012-12-22','13:35:00',1.43),('8975','2012-12-22','13:40:00',1.28),('8975','2012-12-22','13:45:00',1.23),('8975','2012-12-22','13:50:00',1.21),('8975','2012-12-22','13:55:00',1.26),('8975','2012-12-22','14:00:00',1.79),('8975','2012-12-22','14:05:00',1.6),('8975','2012-12-22','14:10:00',1.36),('8975','2012-12-22','14:15:00',1.4),('8975','2012-12-22','14:20:00',1.16),('8975','2012-12-22','14:35:00',1.16),('8975','2012-12-22','14:40:00',1.27),('8975','2012-12-22','14:45:00',1.32),('8975','2012-12-22','14:50:00',1.02),('8975','2014-04-30','07:40:00',1.57),('8975','2014-04-30','07:45:00',2.48),('8975','2014-04-30','07:50:00',3.19),('8975','2014-04-30','07:55:00',3.41),('8975','2014-04-30','08:00:00',3.73),('8975','2014-04-30','08:05:00',3.82),('8975','2014-04-30','08:10:00',3.85),('8975','2014-04-30','08:15:00',3.87),('8975','2014-04-30','08:20:00',3.93),('8975','2014-04-30','08:25:00',4.06),('8975','2014-04-30','08:30:00',4.17),('8975','2014-04-30','08:35:00',4.12),('8975','2014-04-30','08:40:00',4.37),('8975','2014-04-30','08:45:00',4.5),('8975','2014-04-30','08:50:00',4.62),('8975','2014-04-30','08:55:00',4.92),('8975','2014-04-30','09:00:00',4.11),('8975','2014-04-30','09:05:00',4.01),('8975','2014-04-30','09:10:00',3.59),('8975','2014-04-30','09:15:00',5.41),('8975','2014-04-30','09:20:00',5.53),('8975','2014-04-30','09:25:00',5.39),('8975','2014-04-30','09:30:00',4.13),('8975','2014-04-30','09:35:00',4.87),('8975','2014-04-30','09:40:00',3.59),('8975','2014-04-30','09:45:00',5.54),('8975','2014-04-30','09:50:00',3.55),('8975','2014-04-30','09:55:00',1.94),('8975','2014-04-30','10:00:00',1.64),('8975','2014-04-30','10:05:00',1.95),('8975','2014-04-30','10:10:00',2.72),('8975','2014-04-30','10:15:00',4.48),('8975','2014-04-30','10:20:00',4.31),('8975','2014-04-30','10:25:00',6.15),('8975','2014-04-30','10:30:00',7.17),('8975','2014-04-30','10:35:00',6.8),('8975','2014-04-30','10:40:00',7.18),('8975','2014-04-30','10:45:00',5.56),('8975','2014-04-30','10:50:00',4.3),('8975','2014-04-30','10:55:00',4.68),('8975','2014-04-30','11:00:00',5.41),('8975','2014-04-30','11:05:00',7.36),('8975','2014-04-30','11:10:00',7.44),('8975','2014-04-30','11:15:00',4.74),('8975','2014-04-30','11:20:00',4.19),('8975','2014-04-30','11:25:00',3.94),('8975','2014-04-30','11:30:00',6.75),('8975','2014-04-30','11:35:00',7.69),('8975','2014-04-30','11:40:00',5.41),('8975','2014-04-30','11:45:00',3.15),('8975','2014-04-30','11:50:00',5.17),('8975','2014-04-30','11:55:00',5.52),('8975','2014-04-30','12:00:00',7.69),('8975','2014-04-30','12:05:00',7.4),('8975','2014-04-30','12:10:00',7.45),('8975','2014-04-30','12:15:00',7.53),('8975','2014-04-30','12:20:00',7.52),('8975','2014-04-30','12:25:00',3.51),('8975','2014-04-30','12:30:00',1.92),('8975','2014-04-30','12:35:00',2.73),('8975','2014-04-30','12:40:00',5.97),('8975','2014-04-30','12:45:00',7.97),('8975','2014-04-30','12:50:00',7.56),('8975','2014-04-30','12:55:00',7.15),('8975','2014-04-30','13:00:00',7.28),('8975','2014-04-30','13:05:00',7.08),('8975','2014-04-30','13:10:00',7.05),('8975','2014-04-30','13:15:00',7.02),('8975','2014-04-30','13:20:00',7.14),('8975','2014-04-30','13:25:00',7.44),('8975','2014-04-30','13:30:00',6.85),('8975','2014-04-30','13:35:00',7.21),('8975','2014-04-30','13:40:00',6.59),('8975','2014-04-30','13:45:00',7.05),('8975','2014-04-30','13:50:00',7.19),('8975','2014-04-30','13:55:00',6.81),('8975','2014-04-30','14:00:00',6.76),('8975','2014-04-30','14:05:00',6.66),('8975','2014-04-30','14:10:00',6.75),('8975','2014-04-30','14:15:00',6.55),('8975','2014-04-30','14:20:00',6.49),('8975','2014-04-30','14:25:00',6.24),('8975','2014-04-30','14:30:00',6.07),('8975','2014-04-30','14:35:00',6.1),('8975','2014-04-30','14:40:00',6.27),('8975','2014-04-30','14:45:00',6.26),('8975','2014-04-30','14:50:00',6.08),('8975','2014-04-30','14:55:00',6.18),('8975','2014-04-30','15:00:00',5.57),('8975','2014-04-30','15:05:00',5.98),('8975','2014-04-30','15:10:00',5.69),('8975','2014-04-30','15:15:00',5.41),('8975','2014-04-30','15:20:00',5.39),('8975','2014-04-30','15:25:00',5.25),('8975','2014-04-30','15:30:00',5.01),('8975','2014-04-30','15:35:00',4.84),('8975','2014-04-30','15:40:00',4.73),('8975','2014-04-30','15:45:00',4.67),('8975','2014-04-30','15:50:00',4.52),('8975','2014-04-30','15:55:00',4.29),('8975','2014-04-30','16:00:00',4.26),('8975','2014-04-30','16:05:00',4.28),('8975','2014-04-30','16:10:00',4.03),('8975','2014-04-30','16:15:00',3.87),('8975','2014-04-30','16:20:00',3.79),('8975','2014-04-30','16:25:00',3.49),('8975','2014-04-30','16:30:00',3.64),('8975','2014-04-30','16:35:00',3.62),('8975','2014-04-30','16:40:00',3.31),('8975','2014-04-30','16:45:00',2.84),('8975','2014-04-30','16:50:00',2.38),('8975','2014-04-30','16:55:00',3.03),('8975','2014-04-30','17:00:00',2.87),('8975','2014-04-30','17:05:00',2.37),('8975','2014-04-30','17:10:00',2.56),('8975','2014-04-30','17:15:00',2.46),('8975','2014-04-30','17:20:00',2.34),('8975','2014-04-30','17:25:00',2.24),('8975','2014-04-30','17:30:00',2.12),('8975','2014-04-30','17:35:00',2),('8975','2014-04-30','17:40:00',1.87),('8975','2014-04-30','17:45:00',1.8),('8975','2014-04-30','17:50:00',1.74),('8975','2014-04-30','17:55:00',1.69),('8975','2014-04-30','18:00:00',1.64),('8975','2014-04-30','18:05:00',1.55),('8975','2014-04-30','18:10:00',1.5),('8975','2014-04-30','18:15:00',1.44),('8975','2014-04-30','18:20:00',1.37),('8975','2014-04-30','18:25:00',1.33),('8975','2014-04-30','18:30:00',1.3),('8975','2014-04-30','18:35:00',1.22),('8975','2014-04-30','18:40:00',1.15),('8975','2014-04-30','18:45:00',1.08),('8975','2014-03-16','08:40:00',1.1),('8975','2014-03-16','08:45:00',1.22),('8975','2014-03-16','08:50:00',1.45),('8975','2014-03-16','08:55:00',1.46),('8975','2014-03-16','09:00:00',1.86),('8975','2014-03-16','09:05:00',1.83),('8975','2014-03-16','09:10:00',1.81),('8975','2014-03-16','09:15:00',2.02),('8975','2014-03-16','09:20:00',2.32),('8975','2014-03-16','09:25:00',2.1),('8975','2014-03-16','09:30:00',2.2),('8975','2014-03-16','09:35:00',2.26),('8975','2014-03-16','09:40:00',2.49),('8975','2014-03-16','09:45:00',2.49),('8975','2014-03-16','09:50:00',2.76),('8975','2014-03-16','09:55:00',2.72),('8975','2014-03-16','10:00:00',2.69),('8975','2014-03-16','10:05:00',2.59),('8975','2014-03-16','10:10:00',2.89),('8975','2014-03-16','10:15:00',3.89),('8975','2014-03-16','10:20:00',2.69),('8975','2014-03-16','10:25:00',2.31),('8975','2014-03-16','10:30:00',2.05),('8975','2014-03-16','10:35:00',1.93),('8975','2014-03-16','10:40:00',2.07),('8975','2014-03-16','10:45:00',2.62),('8975','2014-03-16','10:50:00',2.5),('8975','2014-03-16','10:55:00',2.87),('8975','2014-03-16','11:00:00',2.74),('8975','2014-03-16','11:05:00',2.87),('8975','2014-03-16','11:10:00',2.63),('8975','2014-03-16','11:15:00',2.29),('8975','2014-03-16','11:20:00',2.29),('8975','2014-03-16','11:25:00',2.72),('8975','2014-03-16','11:30:00',2.56),('8975','2014-03-16','11:35:00',2.15),('8975','2014-03-16','11:40:00',1.9),('8975','2014-03-16','11:45:00',2.03),('8975','2014-03-16','11:50:00',2.16),('8975','2014-03-16','11:55:00',2.55),('8975','2014-03-16','12:00:00',2.56),('8975','2014-03-16','12:05:00',2.23),('8975','2014-03-16','12:10:00',2.19),('8975','2014-03-16','12:15:00',3.63),('8975','2014-03-16','12:20:00',2.14),('8975','2014-03-16','12:25:00',2.2),('8975','2014-03-16','12:30:00',2.39),('8975','2014-03-16','12:35:00',2.81),('8975','2014-03-16','12:40:00',4.6),('8975','2014-03-16','12:45:00',4.04),('8975','2014-03-16','12:50:00',5.63),('8975','2014-03-16','12:55:00',5.45),('8975','2014-03-16','13:00:00',5.38),('8975','2014-03-16','13:05:00',5.41),('8975','2014-03-16','13:10:00',5),('8975','2014-03-16','13:15:00',4.44),('8975','2014-03-16','13:20:00',4.25),('8975','2014-03-16','13:25:00',4.12),('8975','2014-03-16','13:30:00',4.47),('8975','2014-03-16','13:35:00',4.54),('8975','2014-03-16','13:40:00',4.26),('8975','2014-03-16','13:45:00',4.15),('8975','2014-03-16','13:50:00',3.81),('8975','2014-03-16','13:55:00',4.36),('8975','2014-03-16','14:00:00',2.91),('8975','2014-03-16','14:05:00',3.73),('8975','2014-03-16','14:10:00',4.14),('8975','2014-03-16','14:15:00',4.03),('8975','2014-03-16','14:20:00',3.89),('8975','2014-03-16','14:25:00',3.76),('8975','2014-03-16','14:30:00',3.54),('8975','2014-03-16','14:35:00',3.39),('8975','2014-03-16','14:40:00',3.19),('8975','2014-03-16','14:45:00',3.15),('8975','2014-03-16','14:50:00',3.05),('8975','2014-03-16','14:55:00',2.92),('8975','2014-03-16','15:00:00',2.86),('8975','2014-03-16','15:05:00',2.86),('8975','2014-03-16','15:10:00',2.71),('8975','2014-03-16','15:15:00',2.48),('8975','2014-03-16','15:20:00',2.5),('8975','2014-03-16','15:25:00',2.33),('8975','2014-03-16','15:30:00',1.72),('8975','2014-03-16','15:35:00',2.04),('8975','2014-03-16','15:40:00',2.07),('8975','2014-03-16','15:45:00',1.94),('8975','2014-03-16','15:50:00',1.88),('8975','2014-03-16','15:55:00',1.83),('8975','2014-03-16','16:00:00',1.44),('8975','2014-03-16','16:15:00',1.21),('8975','2014-03-16','16:20:00',1.47),('8975','2014-03-16','16:26:00',1.34),('8975','2012-12-21','09:30:00',1.12),('8975','2012-12-21','09:35:00',1.26),('8975','2012-12-21','09:40:00',1.35),('8975','2012-12-21','09:45:00',1.05),('8975','2012-12-21','09:50:00',1.03),('8975','2012-12-21','09:55:00',1.13),('8975','2012-12-21','10:00:00',1.17),('8975','2012-12-21','10:05:00',1.17),('8975','2012-12-21','10:10:00',1.23),('8975','2012-12-21','10:15:00',1.25),('8975','2012-12-21','10:20:00',1.19),('8975','2012-12-21','10:25:00',1.3),('8975','2012-12-21','10:30:00',1.32),('8975','2012-12-21','10:35:00',3.02),('8975','2012-12-21','10:40:00',3.36),('8975','2012-12-21','10:45:00',3.32),('8975','2012-12-21','10:50:00',3.18),('8975','2012-12-21','10:55:00',2.85),('8975','2012-12-21','11:00:00',1.19),('8975','2012-12-21','11:20:00',1.53),('8975','2012-12-21','11:25:00',1.2),('8975','2012-12-21','11:30:00',1.43),('8975','2012-12-21','11:35:00',1.45),('8975','2012-12-21','11:40:00',3.41),('8975','2012-12-21','11:45:00',2.98),('8975','2012-12-21','11:50:00',2.86),('8975','2012-12-21','11:55:00',1.94),('8975','2012-12-21','12:00:00',2.17),('8975','2012-12-21','12:05:00',2.16),('8975','2012-12-21','12:10:00',2.11),('8975','2012-12-21','12:15:00',2.91),('8975','2012-12-21','12:20:00',2.33),('8975','2012-12-21','12:25:00',2.06),('8975','2012-12-21','12:30:00',2.86),('8975','2012-12-21','12:35:00',3.1),('8975','2012-12-21','12:40:00',3.04),('8975','2012-12-21','12:45:00',3.07),('8975','2012-12-21','12:50:00',3.09),('8975','2012-12-21','12:55:00',2.47),('8975','2012-12-21','13:00:00',2.38),('8975','2012-12-21','13:05:00',2.06),('8975','2012-12-21','13:10:00',1.89),('8975','2012-12-21','13:15:00',2.31),('8975','2012-12-21','13:20:00',2.42),('8975','2012-12-21','13:25:00',2.59),('8975','2012-12-21','13:30:00',2.13),('8975','2012-12-21','13:35:00',1.45),('8975','2012-12-21','13:40:00',1.34),('8975','2012-12-21','13:45:00',1.19),('8975','2012-12-21','13:50:00',1.21),('8975','2012-12-21','13:55:00',1.36),('8975','2012-12-21','14:00:00',1.27),('8975','2012-12-21','14:05:00',1.2),('8975','2012-12-21','14:20:00',1.2),('8975','2014-03-15','07:10:00',1.17),('8975','2014-03-15','07:15:00',1.24),('8975','2014-03-15','07:20:00',1.38),('8975','2014-03-15','07:28:00',1.51),('8975','2014-03-15','07:30:00',1.64),('8975','2014-03-15','07:35:00',1.68),('8975','2014-03-15','07:41:00',1.71),('8975','2014-03-15','07:45:00',1.86),('8975','2014-03-15','07:50:00',1.9),('8975','2014-03-15','07:55:00',2.26),('8975','2014-03-15','08:00:00',2.38),('8975','2014-03-15','08:05:00',2.57),('8975','2014-03-15','08:11:00',2.6),('8975','2014-03-15','08:15:00',2.63),('8975','2014-03-15','08:20:00',2.71),('8975','2014-03-15','08:25:00',2.91),('8975','2014-03-15','08:30:00',3.06),('8975','2014-03-15','08:35:00',3.16),('8975','2014-03-15','08:40:00',3.24),('8975','2014-03-15','08:45:00',3.36),('8975','2014-03-15','08:50:00',3.4),('8975','2014-03-15','08:55:00',3.5),('8975','2014-03-15','09:00:00',3.45),('8975','2014-03-15','09:05:00',3.55),('8975','2014-03-15','09:10:00',3.72),('8975','2014-03-15','09:15:00',4.08),('8975','2014-03-15','09:20:00',3.99),('8975','2014-03-15','09:25:00',4.03),('8975','2014-03-15','09:30:00',4.05),('8975','2014-03-15','09:35:00',4.04),('8975','2014-03-15','09:40:00',3.98),('8975','2014-03-15','09:45:00',4.33),('8975','2014-03-15','09:50:00',4.57),('8975','2014-03-15','09:55:00',4.53),('8975','2014-03-15','10:00:00',4.58),('8975','2014-03-15','10:05:00',4.62),('8975','2014-03-15','10:10:00',4.66),('8975','2014-03-15','10:15:00',4.82),('8975','2014-03-15','10:20:00',4.84),('8975','2014-03-15','10:25:00',4.84),('8975','2014-03-15','10:30:00',4.78),('8975','2014-03-15','10:35:00',4.75),('8975','2014-03-15','10:40:00',4.85),('8975','2014-03-15','10:45:00',4.94),('8975','2014-03-15','10:50:00',4.33),('8975','2014-03-15','10:55:00',3.71),('8975','2014-03-15','11:00:00',5.04),('8975','2014-03-15','11:05:00',4.41),('8975','2014-03-15','11:10:00',4.27),('8975','2014-03-15','11:15:00',4.82),('8975','2014-03-15','11:20:00',5.13),('8975','2014-03-15','11:25:00',5.01),('8975','2014-03-15','11:30:00',5.16),('8975','2014-03-15','11:35:00',5.09),('8975','2014-03-15','11:40:00',5.17),('8975','2014-03-15','11:45:00',5.03),('8975','2014-03-15','11:50:00',5.06),('8975','2014-03-15','11:55:00',4.98),('8975','2014-03-15','12:00:00',3.66),('8975','2014-03-15','12:05:00',4.68),('8975','2014-03-15','12:10:00',4.59),('8975','2014-03-15','12:15:00',4.91),('8975','2014-03-15','12:20:00',4.85),('8975','2014-03-15','12:25:00',4.88),('8975','2014-03-15','12:30:00',4.88),('8975','2014-03-15','12:35:00',4.79),('8975','2014-03-15','12:40:00',4.79),('8975','2014-03-15','12:45:00',4.69),('8975','2014-03-15','12:50:00',4.62),('8975','2014-03-15','12:55:00',4.58),('8975','2014-03-15','13:00:00',4.26),('8975','2014-03-15','13:05:00',4.51),('8975','2014-03-15','13:10:00',4.47),('8975','2014-03-15','13:15:00',4.36),('8975','2014-03-15','13:20:00',4.14),('8975','2014-03-15','13:25:00',4.14),('8975','2014-03-15','13:30:00',4.09),('8975','2014-03-15','13:35:00',4.23),('8975','2014-03-15','13:40:00',4.27),('8975','2014-03-15','13:45:00',4.19),('8975','2014-03-15','13:50:00',4.03),('8975','2014-03-15','13:55:00',3.91),('8975','2014-03-15','14:00:00',3.78),('8975','2014-03-15','14:05:00',3.5),('8975','2014-03-15','14:10:00',3.42),('8975','2014-03-15','14:15:00',3.37),('8975','2014-03-15','14:20:00',3.39),('8975','2014-03-15','14:25:00',3.33),('8975','2014-03-15','14:30:00',3.3),('8975','2014-03-15','14:35:00',3.16),('8975','2014-03-15','14:40:00',3),('8975','2014-03-15','14:45:00',2.98),('8975','2014-03-15','14:50:00',2.83),('8975','2014-03-15','14:55:00',2.78),('8975','2014-03-15','15:00:00',2.67),('8975','2014-03-15','15:05:00',2.78),('8975','2014-03-15','15:10:00',2.86),('8975','2014-03-15','15:15:00',2.5),('8975','2014-03-15','15:20:00',2.22),('8975','2014-03-15','15:25:00',2.22),('8975','2014-03-15','15:30:00',2.12),('8975','2014-03-15','15:35:00',2.04),('8975','2014-03-15','15:40:00',1.64),('8975','2014-03-15','15:45:00',1.52),('8975','2014-03-15','15:50:00',1.61),('8975','2014-03-15','15:55:00',1.5),('8975','2014-03-15','16:00:00',1.34),('8975','2014-03-15','16:05:00',1.46),('8975','2014-03-15','16:10:00',1.41),('8975','2014-03-15','16:15:00',1.58),('8975','2014-03-15','16:20:00',1.52),('8975','2014-03-15','16:25:00',1.5),('8975','2014-03-15','16:30:00',1.54),('8975','2014-03-15','16:35:00',1.48),('8975','2014-03-15','16:40:00',1.38),('8975','2014-03-15','16:45:00',1.19),('8975','2014-03-15','16:50:00',1.11),('8975','2014-03-14','07:15:00',1.02),('8975','2014-03-14','07:20:00',1.14),('8975','2014-03-14','07:25:00',1.3),('8975','2014-03-14','07:30:00',1.46),('8975','2014-03-14','07:35:00',1.58),('8975','2014-03-14','07:40:00',1.72),('8975','2014-03-14','07:45:00',1.86),('8975','2014-03-14','07:50:00',2.02),('8975','2014-03-14','07:55:00',2.16),('8975','2014-03-14','08:00:00',2.3),('8975','2014-03-14','08:05:00',2.44),('8975','2014-03-14','08:10:00',2.57),('8975','2014-03-14','08:15:00',2.68),('8975','2014-03-14','08:20:00',2.82),('8975','2014-03-14','08:25:00',2.92),('8975','2014-03-14','08:30:00',3.02),('8975','2014-03-14','08:35:00',3.12),('8975','2014-03-14','08:40:00',3.2),('8975','2014-03-14','08:45:00',3.3),('8975','2014-03-14','08:50:00',3.38),('8975','2014-03-14','08:55:00',3.46),('8975','2014-03-14','09:00:00',3.56),('8975','2014-03-14','09:05:00',3.66),('8975','2014-03-14','09:10:00',3.75),('8975','2014-03-14','09:15:00',3.81),('8975','2014-03-14','09:20:00',3.93),('8975','2014-03-14','09:25:00',4.04),('8975','2014-03-14','09:30:00',4.11),('8975','2014-03-14','09:35:00',4.21),('8975','2014-03-14','09:40:00',4.27),('8975','2014-03-14','09:45:00',4.32),('8975','2014-03-14','09:50:00',4.36),('8975','2014-03-14','09:55:00',4.46),('8975','2014-03-14','10:00:00',4.51),('8975','2014-03-14','10:05:00',4.51),('8975','2014-03-14','10:10:00',4.58),('8975','2014-03-14','10:15:00',4.63),('8975','2014-03-14','10:20:00',4.65),('8975','2014-03-14','10:25:00',4.76),('8975','2014-03-14','10:30:00',4.75),('8975','2014-03-14','10:35:00',4.77),('8975','2014-03-14','10:40:00',4.82),('8975','2014-03-14','10:45:00',4.85),('8975','2014-03-14','10:50:00',4.9),('8975','2014-03-14','10:55:00',4.97),('8975','2014-03-14','11:00:00',5.03),('8975','2014-03-14','11:05:00',4.97),('8975','2014-03-14','11:10:00',5.08),('8975','2014-03-14','11:15:00',5.12),('8975','2014-03-14','11:20:00',5.08),('8975','2014-03-14','11:25:00',5.17),('8975','2014-03-14','11:30:00',5.08),('8975','2014-03-14','11:35:00',5.08),('8975','2014-03-14','11:40:00',5.18),('8975','2014-03-14','11:45:00',5.08),('8975','2014-03-14','11:50:00',5.07),('8975','2014-03-14','11:55:00',5.09),('8975','2014-03-14','12:00:00',5.06),('8975','2014-03-14','12:05:00',5.09),('8975','2014-03-14','12:10:00',5.04),('8975','2014-03-14','12:15:00',4.91),('8975','2014-03-14','12:20:00',4.87),('8975','2014-03-14','12:25:00',4.93),('8975','2014-03-14','12:30:00',5.05),('8975','2014-03-14','12:35:00',4.93),('8975','2014-03-14','12:40:00',4.86),('8975','2014-03-14','12:45:00',4.86),('8975','2014-03-14','12:50:00',4.76),('8975','2014-03-14','12:55:00',4.74),('8975','2014-03-14','13:00:00',4.68),('8975','2014-03-14','13:05:00',4.68),('8975','2014-03-14','13:10:00',4.61),('8975','2014-03-14','13:15:00',4.46),('8975','2014-03-14','13:20:00',4.46),('8975','2014-03-14','13:25:00',4.38),('8975','2014-03-14','13:30:00',4.16),('8975','2014-03-14','13:35:00',4.21),('8975','2014-03-14','13:40:00',4.22),('8975','2014-03-14','13:45:00',4.13),('8975','2014-03-14','13:50:00',4.05),('8975','2014-03-14','13:55:00',4),('8975','2014-03-14','14:00:00',3.87),('8975','2014-03-14','14:05:00',3.76),('8975','2014-03-14','14:10:00',3.67),('8975','2014-03-14','14:15:00',3.42),('8975','2014-03-14','14:20:00',3.49),('8975','2014-03-14','14:25:00',3.37),('8975','2014-03-14','14:30:00',3.28),('8975','2014-03-14','14:35:00',3.24),('8975','2014-03-14','14:40:00',3.06),('8975','2014-03-14','14:45:00',2.98),('8975','2014-03-14','14:50:00',2.97),('8975','2014-03-14','14:55:00',2.86),('8975','2014-03-14','15:00:00',2.78),('8975','2014-03-14','15:05:00',2.69),('8975','2014-03-14','15:10:00',2.52),('8975','2014-03-14','15:15:00',2.39),('8975','2014-03-14','15:20:00',2.34),('8975','2014-03-14','15:25:00',2.25),('8975','2014-03-14','15:30:00',2.15),('8975','2014-03-14','15:35:00',2.02),('8975','2014-03-14','15:40:00',1.94),('8975','2014-03-14','15:45:00',1.87),('8975','2014-03-14','15:51:00',1.83),('8975','2014-03-14','15:55:00',1.72),('8975','2014-03-14','16:00:00',1.67),('8975','2014-03-14','16:05:00',1.58),('8975','2014-03-14','16:10:00',1.54),('8975','2014-03-14','16:15:00',1.46),('8975','2014-03-14','16:20:00',1.4),('8975','2014-03-14','16:25:00',1.29),('8975','2014-03-14','16:30:00',1.22),('8975','2014-03-14','16:35:00',1.18),('8975','2014-03-14','16:40:00',1.15),('8975','2014-03-14','16:45:00',1.09),('8975','2014-03-14','16:50:00',1.03),('8975','2014-03-13','07:45:00',1.05),('8975','2014-03-13','07:50:00',1.15),('8975','2014-03-13','07:55:00',1.24),('8975','2014-03-13','08:00:00',1.33),('8975','2014-03-13','08:05:00',1.45),('8975','2014-03-13','08:10:00',1.65),('8975','2014-03-13','08:15:00',1.83),('8975','2014-03-13','08:20:00',1.95),('8975','2014-03-13','08:25:00',2.1),('8975','2014-03-13','08:30:00',2.15),('8975','2014-03-13','08:35:00',2),('8975','2014-03-13','08:40:00',1.73),('8975','2014-03-13','08:45:00',1.63),('8975','2014-03-13','08:50:00',1.66),('8975','2014-03-13','08:55:00',1.77),('8975','2014-03-13','09:00:00',1.98),('8975','2014-03-13','09:05:00',2.27),('8975','2014-03-13','09:10:00',2.43),('8975','2014-03-13','09:15:00',2.42),('8975','2014-03-13','09:20:00',2.5),('8975','2014-03-13','09:25:00',2.58),('8975','2014-03-13','09:30:00',2.77),('8975','2014-03-13','09:35:00',3.4),('8975','2014-03-13','09:40:00',4.04),('8975','2014-03-13','09:45:00',4.89),('8975','2014-03-13','09:50:00',5.39),('8975','2014-03-13','09:55:00',5.6),('8975','2014-03-13','10:00:00',5.7),('8975','2014-03-13','10:05:00',5.57),('8975','2014-03-13','10:10:00',5.43),('8975','2014-03-13','10:15:00',5.32),('8975','2014-03-13','10:20:00',4.98),('8975','2014-03-13','10:25:00',4.89),('8975','2014-03-13','10:30:00',4.99),('8975','2014-03-13','10:35:00',5.23),('8975','2014-03-13','10:40:00',5.03),('8975','2014-03-13','10:45:00',3.62),('8975','2014-03-13','10:50:00',3.37),('8975','2014-03-13','10:55:00',4.72),('8975','2014-03-13','11:00:00',4.95),('8975','2014-03-13','11:05:00',5.25),('8975','2014-03-13','11:10:00',5.51),('8975','2014-03-13','11:15:00',5.44),('8975','2014-03-13','11:20:00',5.35),('8975','2014-03-13','11:25:00',5.29),('8975','2014-03-13','11:30:00',5.45),('8975','2014-03-13','11:35:00',5.4),('8975','2014-03-13','11:40:00',5.45),('8975','2014-03-13','11:45:00',5.56),('8975','2014-03-13','11:50:00',5.57),('8975','2014-03-13','11:55:00',5.52),('8975','2014-03-13','12:00:00',5.41),('8975','2014-03-13','12:05:00',5.37),('8975','2014-03-13','12:10:00',4.96),('8975','2014-03-13','12:15:00',4.23),('8975','2014-03-13','12:20:00',3.39),('8975','2014-03-13','12:25:00',3),('8975','2014-03-13','12:30:00',2.42),('8975','2014-03-13','12:35:00',2.72),('8975','2014-03-13','12:40:00',3.93),('8975','2014-03-13','12:45:00',4.67),('8975','2014-03-13','12:50:00',3.92),('8975','2014-03-13','12:55:00',4.01),('8975','2014-03-13','13:00:00',2.77),('8975','2014-03-13','13:05:00',3.24),('8975','2014-03-13','13:10:00',3.26),('8975','2014-03-13','13:15:00',3.92),('8975','2014-03-13','13:20:00',3.77),('8975','2014-03-13','13:25:00',3.33),('8975','2014-03-13','13:30:00',3.34),('8975','2014-03-13','13:35:00',2.92),('8975','2014-03-13','13:40:00',3.18),('8975','2014-03-13','13:45:00',3.27),('8975','2014-03-13','13:50:00',3.31),('8975','2014-03-13','13:55:00',3.35),('8975','2014-03-13','14:00:00',3.82),('8975','2014-03-13','14:05:00',3.84),('8975','2014-03-13','14:10:00',3.55),('8975','2014-03-13','14:15:00',3.65),('8975','2014-03-13','14:20:00',3.72),('8975','2014-03-13','14:25:00',3.35),('8975','2014-03-13','14:30:00',3.08),('8975','2014-03-13','14:35:00',2.8),('8975','2014-03-13','14:40:00',2.31),('8975','2014-03-13','14:45:00',2.12),('8975','2014-03-13','14:50:00',2.06),('8975','2014-03-13','14:55:00',1.93),('8975','2014-03-13','15:00:00',1.88),('8975','2014-03-13','15:05:00',1.83),('8975','2014-03-13','15:10:00',1.69),('8975','2014-03-13','15:15:00',1.63),('8975','2014-03-13','15:20:00',1.67),('8975','2014-03-13','15:25:00',1.73),('8975','2014-03-13','15:30:00',2.08),('8975','2014-03-13','15:35:00',2.15),('8975','2014-03-13','15:40:00',1.83),('8975','2014-03-13','15:45:00',1.57),('8975','2014-03-13','15:50:00',1.58),('8975','2014-03-13','15:55:00',1.52),('8975','2014-03-13','16:00:00',1.45),('8975','2014-03-13','16:05:00',1.38),('8975','2014-03-13','16:10:00',1.25),('8975','2014-03-13','16:15:00',1.13),('8975','2014-03-13','16:20:00',1.03),('8975','2014-03-12','07:09:00',1.31),('8975','2014-03-12','07:10:00',1.54),('8975','2014-03-12','07:15:00',1.69),('8975','2014-03-12','07:20:00',1.86),('8975','2014-03-12','07:28:00',2.04),('8975','2014-03-12','07:30:00',2.3),('8975','2014-03-12','07:35:00',2.4),('8975','2014-03-12','07:41:00',2.51),('8975','2014-03-12','07:45:00',2.67),('8975','2014-03-12','07:50:00',2.77),('8975','2014-03-12','07:55:00',2.91),('8975','2014-03-12','08:00:00',3),('8975','2014-03-12','08:05:00',3.12),('8975','2014-03-12','08:10:00',3.21),('8975','2014-03-12','08:15:00',3.33),('8975','2014-03-12','08:20:00',3.4),('8975','2014-03-12','08:25:00',3.52),('8975','2014-03-12','08:30:00',3.58),('8975','2014-03-12','08:35:00',3.69),('8975','2014-03-12','08:40:00',3.76),('8975','2014-03-12','08:45:00',3.88),('8975','2014-03-12','08:50:00',3.95),('8975','2014-03-12','08:55:00',4.04),('8975','2014-03-12','09:00:00',4.11),('8975','2014-03-12','09:05:00',4.23),('8975','2014-03-12','09:10:00',4.3),('8975','2014-03-12','09:15:00',4.41),('8975','2014-03-12','09:20:00',4.48),('8975','2014-03-12','09:25:00',4.55),('8975','2014-03-12','09:30:00',4.63),('8975','2014-03-12','09:35:00',4.69),('8975','2014-03-12','09:40:00',4.71),('8975','2014-03-12','09:45:00',4.82),('8975','2014-03-12','09:50:00',4.87),('8975','2014-03-12','09:55:00',4.96),('8975','2014-03-12','10:00:00',5.03),('8975','2014-03-12','10:05:00',5.12),('8975','2014-03-12','10:10:00',5.17),('8975','2014-03-12','10:15:00',5.2),('8975','2014-03-12','10:20:00',5.24),('8975','2014-03-12','10:25:00',5.25),('8975','2014-03-12','10:30:00',5.29),('8975','2014-03-12','10:35:00',5.34),('8975','2014-03-12','10:40:00',5.37),('8975','2014-03-12','10:45:00',5.38),('8975','2014-03-12','10:50:00',5.39),('8975','2014-03-12','10:55:00',5.42),('8975','2014-03-12','11:00:00',5.43),('8975','2014-03-12','11:05:00',5.44),('8975','2014-03-12','11:10:00',5.45),('8975','2014-03-12','11:15:00',5.21),('8975','2014-03-12','11:20:00',5.34),('8975','2014-03-12','11:25:00',5.44),('8975','2014-03-12','11:30:00',5.46),('8975','2014-03-12','11:35:00',4.97),('8975','2014-03-12','11:40:00',5.34),('8975','2014-03-12','11:45:00',4.55),('8975','2014-03-12','11:50:00',5.24),('8975','2014-03-12','11:55:00',4.96),('8975','2014-03-12','12:00:00',4.88),('8975','2014-03-12','12:05:00',4.78),('8975','2014-03-12','12:10:00',4.75),('8975','2014-03-12','12:15:00',5.25),('8975','2014-03-12','12:20:00',5.21),('8975','2014-03-12','12:25:00',5.18),('8975','2014-03-12','12:30:00',5.13),('8975','2014-03-12','12:35:00',5.07),('8975','2014-03-12','12:40:00',5),('8975','2014-03-12','12:45:00',4.93),('8975','2014-03-12','12:50:00',4.89),('8975','2014-03-12','12:55:00',4.84),('8975','2014-03-12','13:00:00',4.75),('8975','2014-03-12','13:05:00',4.67),('8975','2014-03-12','13:10:00',4.54),('8975','2014-03-12','13:15:00',4.35),('8975','2014-03-12','13:20:00',4.45),('8975','2014-03-12','13:25:00',4.25),('8975','2014-03-12','13:30:00',3.97),('8975','2014-03-12','13:35:00',4.21),('8975','2014-03-12','13:40:00',4.19),('8975','2014-03-12','13:45:00',4.11),('8975','2014-03-12','13:50:00',3.99),('8975','2014-03-12','13:55:00',3.85),('8975','2014-03-12','14:00:00',3.67),('8975','2014-03-12','14:05:00',3.64),('8975','2014-03-12','14:10:00',3.4),('8975','2014-03-12','14:15:00',3.4),('8975','2014-03-12','14:20:00',3.39),('8975','2014-03-12','14:25:00',3.34),('8975','2014-03-12','14:30:00',3.2),('8975','2014-03-12','14:35:00',3.07),('8975','2014-03-12','14:40:00',2.91),('8975','2014-03-12','14:45:00',2.91),('8975','2014-03-12','14:50:00',2.86),('8975','2014-03-12','14:55:00',2.78),('8975','2014-03-12','15:00:00',2.69),('8975','2014-03-12','15:05:00',2.59),('8975','2014-03-12','15:10:00',2.47),('8975','2014-03-12','15:15:00',2.36),('8975','2014-03-12','15:20:00',2.26),('8975','2014-03-12','15:25:00',2.15),('8975','2014-03-12','15:30:00',2.04),('8975','2014-03-12','15:35:00',1.95),('8975','2014-03-12','15:40:00',1.87),('8975','2014-03-12','15:45:00',1.77),('8975','2014-03-12','15:50:00',1.7),('8975','2014-03-12','15:55:00',1.62),('8975','2014-03-12','16:00:00',1.55),('8975','2014-03-12','16:05:00',1.48),('8975','2014-03-12','16:10:00',1.43),('8975','2014-03-12','16:15:00',1.38),('8975','2014-03-12','16:20:00',1.35),('8975','2014-03-12','16:25:00',1.32),('8975','2014-03-12','16:30:00',1.26),('8975','2014-03-12','16:35:00',1.21),('8975','2014-03-12','16:40:00',1.16),('8975','2014-03-12','16:45:00',1.09),('8975','2014-03-12','16:50:00',1.04),('8975','2014-03-11','07:00:00',1.06),('8975','2014-03-11','07:05:00',1.27),('8975','2014-03-11','07:10:00',1.42),('8975','2014-03-11','07:15:00',1.6),('8975','2014-03-11','07:20:00',1.83),('8975','2014-03-11','07:25:00',2.01),('8975','2014-03-11','07:30:00',2.19),('8975','2014-03-11','07:35:00',2.36),('8975','2014-03-11','07:40:00',2.49),('8975','2014-03-11','07:45:00',2.62),('8975','2014-03-11','07:50:00',2.74),('8975','2014-03-11','07:55:00',2.87),('8975','2014-03-11','08:00:00',2.98),('8975','2014-03-11','08:05:00',3.07),('8975','2014-03-11','08:10:00',3.17),('8975','2014-03-11','08:15:00',3.26),('8975','2014-03-11','08:20:00',3.37),('8975','2014-03-11','08:25:00',3.49),('8975','2014-03-11','08:30:00',3.59),('8975','2014-03-11','08:35:00',3.69),('8975','2014-03-11','08:40:00',3.78),('8975','2014-03-11','08:45:00',3.87),('8975','2014-03-11','08:50:00',3.97),('8975','2014-03-11','08:55:00',4.07),('8975','2014-03-11','09:00:00',4.17),('8975','2014-03-11','09:05:00',4.26),('8975','2014-03-11','09:10:00',4.36),('8975','2014-03-11','09:15:00',4.41),('8975','2014-03-11','09:20:00',4.51),('8975','2014-03-11','09:25:00',4.59),('8975','2014-03-11','09:30:00',4.67),('8975','2014-03-11','09:35:00',4.7),('8975','2014-03-11','09:40:00',4.79),('8975','2014-03-11','09:45:00',4.86),('8975','2014-03-11','09:50:00',4.91),('8975','2014-03-11','09:55:00',4.97),('8975','2014-03-11','10:00:00',5.05),('8975','2014-03-11','10:05:00',5.11),('8975','2014-03-11','10:10:00',5.17),('8975','2014-03-11','10:15:00',5.21),('8975','2014-03-11','10:20:00',5.24),('8975','2014-03-11','10:25:00',5.31),('8975','2014-03-11','10:30:00',5.35),('8975','2014-03-11','10:35:00',5.41),('8975','2014-03-11','10:40:00',5.47),('8975','2014-03-11','10:45:00',5.52),('8975','2014-03-11','10:50:00',5.53),('8975','2014-03-11','10:55:00',5.53),('8975','2014-03-11','11:00:00',5.55),('8975','2014-03-11','11:05:00',5.56),('8975','2014-03-11','11:10:00',5.57),('8975','2014-03-11','11:15:00',5.6),('8975','2014-03-11','11:20:00',5.6),('8975','2014-03-11','11:25:00',5.64),('8975','2014-03-11','11:30:00',5.64),('8975','2014-03-11','11:35:00',5.63),('8975','2014-03-11','11:40:00',5.61),('8975','2014-03-11','11:45:00',5.58),('8975','2014-03-11','11:50:00',5.56),('8975','2014-03-11','11:55:00',5.48),('8975','2014-03-11','12:00:00',5.46),('8975','2014-03-11','12:05:00',5.45),('8975','2014-03-11','12:10:00',5.42),('8975','2014-03-11','12:15:00',5.37),('8975','2014-03-11','12:20:00',5.33),('8975','2014-03-11','12:25:00',5.31),('8975','2014-03-11','12:30:00',5.27),('8975','2014-03-11','12:35:00',5.15),('8975','2014-03-11','12:40:00',5.16),('8975','2014-03-11','12:45:00',5.08),('8975','2014-03-11','12:50:00',5.04),('8975','2014-03-11','12:55:00',4.98),('8975','2014-03-11','13:00:00',4.91),('8975','2014-03-11','13:05:00',4.87),('8975','2014-03-11','13:10:00',4.64),('8975','2014-03-11','13:15:00',4.52),('8975','2014-03-11','13:20:00',4.54),('8975','2014-03-11','13:25:00',4.19),('8975','2014-03-11','13:30:00',4.09),('8975','2014-03-11','13:35:00',4.28),('8975','2014-03-11','13:40:00',4.25),('8975','2014-03-11','13:45:00',4.12),('8975','2014-03-11','13:50:00',4.08),('8975','2014-03-11','13:55:00',4.03),('8975','2014-03-11','14:00:00',3.41),('8975','2014-03-11','14:05:00',3.49),('8975','2014-03-11','14:10:00',3.43),('8975','2014-03-11','14:15:00',2.84),('8975','2014-03-11','14:20:00',2.96),('8975','2014-03-11','14:25:00',3.35),('8975','2014-03-11','14:30:00',3.14),('8975','2014-03-11','14:35:00',3.14),('8975','2014-03-11','14:40:00',2.88),('8975','2014-03-11','14:45:00',2.75),('8975','2014-03-11','14:50:00',2.67),('8975','2014-03-11','14:55:00',2.53),('8975','2014-03-11','15:00:00',2.46),('8975','2014-03-11','15:05:00',2.32),('8975','2014-03-11','15:10:00',2.31),('8975','2014-03-11','15:15:00',2.33),('8975','2014-03-11','15:20:00',2.22),('8975','2014-03-11','15:25:00',2.08),('8975','2014-03-11','15:30:00',2.02),('8975','2014-03-11','15:35:00',1.92),('8975','2014-03-11','15:40:00',1.85),('8975','2014-03-11','15:45:00',1.78),('8975','2014-03-11','15:50:00',1.74),('8975','2014-03-11','15:55:00',1.68),('8975','2014-03-11','16:00:00',1.61),('8975','2014-03-11','16:05:00',1.55),('8975','2014-03-11','16:10:00',1.5),('8975','2014-03-11','16:15:00',1.44),('8975','2014-03-11','16:20:00',1.4),('8975','2014-03-11','16:25:00',1.35),('8975','2014-03-11','16:30:00',1.28),('8975','2014-03-11','16:35:00',1.22),('8975','2014-03-11','16:40:00',1.19),('8975','2014-03-11','16:45:00',1.11),('8975','2014-03-11','16:51:00',1.06),('8975','2014-03-10','10:15:00',1.1),('8975','2014-03-10','10:20:00',1.41),('8975','2014-03-10','10:25:00',1.44),('8975','2014-03-10','10:30:00',1.48),('8975','2014-03-10','10:35:00',1.51),('8975','2014-03-10','10:40:00',1.49),('8975','2014-03-10','10:45:00',1.5),('8975','2014-03-10','10:50:00',1.35),('8975','2014-03-10','10:55:00',1.38),('8975','2014-03-10','11:00:00',1.55),('8975','2014-03-10','11:05:00',1.63),('8975','2014-03-10','11:10:00',1.5),('8975','2014-03-10','11:15:00',1.57),('8975','2014-03-10','11:20:00',1.55),('8975','2014-03-10','11:25:00',1.54),('8975','2014-03-10','11:30:00',1.47),('8975','2014-03-10','11:35:00',1.62),('8975','2014-03-10','11:40:00',1.54),('8975','2014-03-10','11:45:00',1.56),('8975','2014-03-10','11:50:00',1.38),('8975','2014-03-10','11:55:00',1.47),('8975','2014-03-10','12:00:00',1.61),('8975','2014-03-10','12:05:00',1.63),('8975','2014-03-10','12:10:00',1.75),('8975','2014-03-10','12:15:00',1.97),('8975','2014-03-10','12:20:00',2.2),('8975','2014-03-10','12:25:00',2.03),('8975','2014-03-10','12:30:00',1.89),('8975','2014-03-10','12:35:00',1.9),('8975','2014-03-10','12:40:00',1.95),('8975','2014-03-10','12:45:00',1.95),('8975','2014-03-10','12:50:00',1.98),('8975','2014-03-10','12:55:00',2.02),('8975','2014-03-10','13:00:00',1.92),('8975','2014-03-10','13:05:00',1.94),('8975','2014-03-10','13:10:00',2.09),('8975','2014-03-10','13:15:00',1.91),('8975','2014-03-10','13:20:00',1.94),('8975','2014-03-10','13:25:00',1.74),('8975','2014-03-10','13:30:00',1.84),('8975','2014-03-10','13:35:00',1.64),('8975','2014-03-10','13:40:00',1.7),('8975','2014-03-10','13:45:00',2.03),('8975','2014-03-10','13:50:00',2.47),('8975','2014-03-10','13:55:00',2.81),('8975','2014-03-10','14:00:00',2.9),('8975','2014-03-10','14:05:00',2.59),('8975','2014-03-10','14:10:00',2.86),('8975','2014-03-10','14:15:00',2.83),('8975','2014-03-10','14:20:00',2.78),('8975','2014-03-10','14:25:00',2.63),('8975','2014-03-10','14:30:00',2.1),('8975','2014-03-10','14:35:00',2.01),('8975','2014-03-10','14:40:00',1.88),('8975','2014-03-10','14:45:00',1.8),('8975','2014-03-10','14:50:00',1.71),('8975','2014-03-10','14:55:00',1.72),('8975','2014-03-10','15:00:00',2.03),('8975','2014-03-10','15:05:00',2.38),('8975','2014-03-10','15:10:00',2.36),('8975','2014-03-10','15:15:00',2.03),('8975','2014-03-10','15:20:00',1.89),('8975','2014-03-10','15:25:00',1.67),('8975','2014-03-10','15:30:00',1.59),('8975','2014-03-10','15:35:00',1.54),('8975','2014-03-10','15:40:00',1.56),('8975','2014-03-10','15:45:00',1.49),('8975','2014-03-10','15:50:00',1.56),('8975','2014-03-10','15:55:00',1.43),('8975','2014-03-10','16:00:00',1.32),('8975','2014-03-10','16:05:00',1.26),('8975','2014-03-10','16:10:00',1.27),('8975','2014-03-10','16:15:00',1.19),('8975','2014-03-10','16:20:00',1.17),('8975','2014-03-10','16:25:00',1.06),('8975','2014-03-09','08:20:00',1.01),('8975','2014-03-09','08:25:00',1.11),('8975','2014-03-09','08:30:00',1.17),('8975','2014-03-09','08:35:00',1.37),('8975','2014-03-09','08:40:00',1.53),('8975','2014-03-09','08:45:00',1.51),('8975','2014-03-09','08:50:00',1.57),('8975','2014-03-09','08:55:00',1.57),('8975','2014-03-09','09:00:00',1.6),('8975','2014-03-09','09:05:00',1.73),('8975','2014-03-09','09:10:00',1.63),('8975','2014-03-09','09:15:00',1.24),('8975','2014-03-09','09:20:00',1.12),('8975','2014-03-09','09:25:00',1.31),('8975','2014-03-09','09:30:00',1.57),('8975','2014-03-09','09:35:00',1.52),('8975','2014-03-09','09:40:00',1.58),('8975','2014-03-09','09:45:00',1.54),('8975','2014-03-09','09:50:00',1.48),('8975','2014-03-09','09:55:00',1.45),('8975','2014-03-09','10:00:00',1.23),('8975','2014-03-09','10:05:00',1.2),('8975','2014-03-09','10:10:00',1.4),('8975','2014-03-09','10:15:00',1.58),('8975','2014-03-09','10:20:00',1.55),('8975','2014-03-09','10:25:00',1.48),('8975','2014-03-09','10:30:00',1.62),('8975','2014-03-09','10:35:00',2.05),('8975','2014-03-09','10:40:00',1.7),('8975','2014-03-09','10:45:00',1.17),('8975','2014-03-09','11:10:00',1.07),('8975','2014-03-09','11:15:00',1.35),('8975','2014-03-09','11:20:00',1.55),('8975','2014-03-09','11:25:00',1.45),('8975','2014-03-09','11:30:00',1.23),('8975','2014-03-09','12:30:00',1.08),('8975','2014-03-09','12:35:00',1.22),('8975','2014-03-09','12:40:00',1.38),('8975','2014-03-09','12:45:00',1.56),('8975','2014-03-09','12:50:00',1.78),('8975','2014-03-09','12:55:00',1.91),('8975','2014-03-09','13:00:00',2.01),('8975','2014-03-09','13:05:00',2.06),('8975','2014-03-09','13:10:00',2.19),('8975','2014-03-09','13:15:00',2.37),('8975','2014-03-09','13:20:00',2.17),('8975','2014-03-09','13:25:00',2.12),('8975','2014-03-09','13:30:00',2.05),('8975','2014-03-09','13:35:00',1.66),('8975','2014-03-09','13:40:00',1.36),('8975','2014-03-09','13:45:00',1.33),('8975','2014-03-09','13:50:00',1.94),('8975','2014-03-09','13:55:00',1.63),('8975','2014-03-09','14:00:00',1.35),('8975','2014-03-09','14:05:00',2.01),('8975','2014-03-09','14:10:00',2.38),('8975','2014-03-09','14:15:00',2.12),('8975','2014-03-09','14:20:00',1.57),('8975','2014-03-09','14:25:00',1.76),('8975','2014-03-09','14:30:00',2.3),('8975','2014-03-09','14:35:00',2.07),('8975','2014-03-09','14:40:00',2.55),('8975','2014-03-09','14:45:00',3.35),('8975','2014-03-09','14:50:00',3.51),('8975','2014-03-09','14:55:00',3.02),('8975','2014-03-09','15:00:00',2.62),('8975','2014-03-09','15:05:00',2.09),('8975','2014-03-09','15:10:00',1.43),('8975','2014-03-09','15:15:00',1.77),('8975','2014-03-09','15:20:00',2.6),('8975','2014-03-09','15:25:00',2.72),('8975','2014-03-09','15:30:00',2.63),('8975','2014-03-09','15:35:00',2.44),('8975','2014-03-09','15:40:00',2.14),('8975','2014-03-09','15:45:00',1.85),('8975','2014-03-09','15:55:00',1.12),('8975','2014-03-09','16:00:00',1.33),('8975','2014-03-09','16:05:00',1.22),('8975','2014-03-09','16:10:00',1.23),('8975','2014-03-09','16:15:00',1.02),('8975','2014-03-09','16:25:00',1.02),('8975','2014-03-08','07:30:00',1.95),('8975','2014-03-08','07:35:00',2.06),('8975','2014-03-08','07:40:00',2.06),('8975','2014-03-08','07:45:00',2.28),('8975','2014-03-08','07:50:00',2.45),('8975','2014-03-08','07:55:00',2.57),('8975','2014-03-08','08:00:00',2.76),('8975','2014-03-08','08:05:00',2.88),('8975','2014-03-08','08:10:00',3.03),('8975','2014-03-08','08:15:00',2.9),('8975','2014-03-08','08:20:00',1.11),('8975','2014-03-08','08:25:00',1.2),('8975','2014-03-08','08:30:00',2.35),('8975','2014-03-08','08:35:00',1.13),('8975','2014-03-08','08:40:00',1.47),('8975','2014-03-08','08:45:00',1.92),('8975','2014-03-08','08:50:00',1.74),('8975','2014-03-08','08:55:00',2.85),('8975','2014-03-08','09:00:00',3.16),('8975','2014-03-08','09:05:00',3.47),('8975','2014-03-08','09:10:00',3.72),('8975','2014-03-08','09:15:00',2.51),('8975','2014-03-08','09:20:00',4.34),('8975','2014-03-08','09:25:00',4.62),('8975','2014-03-08','09:30:00',4.67),('8975','2014-03-08','09:35:00',4.84),('8975','2014-03-08','09:40:00',5.01),('8975','2014-03-08','09:45:00',5.09),('8975','2014-03-08','09:50:00',5.11),('8975','2014-03-08','09:55:00',5.05),('8975','2014-03-08','10:00:00',5.13),('8975','2014-03-08','10:05:00',5.19),('8975','2014-03-08','10:10:00',5.27),('8975','2014-03-08','10:15:00',5.25),('8975','2014-03-08','10:20:00',5.29),('8975','2014-03-08','10:25:00',5.43),('8975','2014-03-08','10:30:00',5.54),('8975','2014-03-08','10:35:00',5.49),('8975','2014-03-08','10:40:00',4.95),('8975','2014-03-08','10:45:00',5.44),('8975','2014-03-08','10:50:00',5.29),('8975','2014-03-08','10:55:00',5.63),('8975','2014-03-08','11:00:00',5.73),('8975','2014-03-08','11:05:00',5.93),('8975','2014-03-08','11:10:00',5.36),('8975','2014-03-08','11:15:00',5.11),('8975','2014-03-08','11:20:00',2.59),('8975','2014-03-08','11:25:00',2.68),('8975','2014-03-08','11:30:00',4),('8975','2014-03-08','11:35:00',4.5),('8975','2014-03-08','11:40:00',6.36),('8975','2014-03-08','11:45:00',4.88),('8975','2014-03-08','11:50:00',6.84),('8975','2014-03-08','11:55:00',5.8),('8975','2014-03-08','12:00:00',2.15),('8975','2014-03-08','12:05:00',2.81),('8975','2014-03-08','12:10:00',3.82),('8975','2014-03-08','12:15:00',1.92),('8975','2014-03-08','12:20:00',3.03),('8975','2014-03-08','12:25:00',5.38),('8975','2014-03-08','12:30:00',6.03),('8975','2014-03-08','12:35:00',6.09),('8975','2014-03-08','12:40:00',5.82),('8975','2014-03-08','12:45:00',5.36),('8975','2014-03-08','12:50:00',5.47),('8975','2014-03-08','12:55:00',5.7),('8975','2014-03-08','13:00:00',5.72),('8975','2014-03-08','13:05:00',5.64),('8975','2014-03-08','13:10:00',4.39),('8975','2014-03-08','13:15:00',4.35),('8975','2014-03-08','13:20:00',4.99),('8975','2014-03-08','13:25:00',4.84),('8975','2014-03-08','13:30:00',4.69),('8975','2014-03-08','13:35:00',4.69),('8975','2014-03-08','13:40:00',3.4),('8975','2014-03-08','13:45:00',1.58),('8975','2014-03-08','13:50:00',3.25),('8975','2014-03-08','13:55:00',4.29),('8975','2014-03-08','14:00:00',2.83),('8975','2014-03-08','14:05:00',3.79),('8975','2014-03-08','14:10:00',3.12),('8975','2014-03-08','14:15:00',3.78),('8975','2014-03-08','14:20:00',3.6),('8975','2014-03-08','14:25:00',3.95),('8975','2014-03-08','14:30:00',3.81),('8975','2014-03-08','14:35:00',3.61),('8975','2014-03-08','14:40:00',2.64),('8975','2014-03-08','14:45:00',2.22),('8975','2014-03-08','14:50:00',3.05),('8975','2014-03-08','14:55:00',3),('8975','2014-03-08','15:00:00',2.94),('8975','2014-03-08','15:05:00',2.8),('8975','2014-03-08','15:10:00',2.67),('8975','2014-03-08','15:15:00',2.52),('8975','2014-03-08','15:20:00',2.37),('8975','2014-03-08','15:25:00',2.29),('8975','2014-03-08','15:30:00',2.29),('8975','2014-03-08','15:35:00',2.13),('8975','2014-03-08','15:40:00',1.96),('8975','2014-03-08','15:45:00',1.76),('8975','2014-03-08','15:50:00',1.6),('8975','2014-03-08','15:55:00',1.97),('8975','2014-03-08','16:00:00',1.86),('8975','2014-03-08','16:05:00',1.68),('8975','2014-03-08','16:10:00',1.25),('8975','2014-03-08','16:20:00',1.15),('8975','2014-03-08','16:25:00',1.15),('8975','2014-03-08','16:30:00',1.34),('8975','2014-03-08','16:35:00',1.32),('8975','2014-03-08','16:40:00',1.31),('8975','2014-03-08','16:45:00',1.19),('8975','2014-03-08','16:50:00',1.06),('8975','2014-03-07','07:10:00',1.22),('8975','2014-03-07','07:15:00',1.41),('8975','2014-03-07','07:20:00',1.6),('8975','2014-03-07','07:25:00',1.83),('8975','2014-03-07','07:30:00',2.01),('8975','2014-03-07','07:35:00',2.15),('8975','2014-03-07','07:40:00',2.31),('8975','2014-03-07','07:45:00',2.42),('8975','2014-03-07','07:50:00',2.54),('8975','2014-03-07','07:55:00',2.67),('8975','2014-03-07','08:00:00',2.8),('8975','2014-03-07','08:05:00',2.91),('8975','2014-03-07','08:10:00',3.02),('8975','2014-03-07','08:15:00',3.12),('8975','2014-03-07','08:20:00',3.23),('8975','2014-03-07','08:25:00',3.34),('8975','2014-03-07','08:30:00',3.45),('8975','2014-03-07','08:35:00',3.53),('8975','2014-03-07','08:40:00',3.63),('8975','2014-03-07','08:45:00',3.73),('8975','2014-03-07','08:50:00',3.83),('8975','2014-03-07','08:55:00',3.93),('8975','2014-03-07','09:00:00',4.04),('8975','2014-03-07','09:05:00',4.14),('8975','2014-03-07','09:10:00',4.2),('8975','2014-03-07','09:15:00',4.3),('8975','2014-03-07','09:20:00',4.4),('8975','2014-03-07','09:25:00',4.48),('8975','2014-03-07','09:30:00',4.57),('8975','2014-03-07','09:35:00',4.63),('8975','2014-03-07','09:40:00',4.66),('8975','2014-03-07','09:45:00',4.78),('8975','2014-03-07','09:50:00',4.83),('8975','2014-03-07','09:55:00',4.89),('8975','2014-03-07','10:00:00',4.96),('8975','2014-03-07','10:05:00',5),('8975','2014-03-07','10:10:00',5.07),('8975','2014-03-07','10:15:00',5.12),('8975','2014-03-07','10:20:00',5.2),('8975','2014-03-07','10:25:00',5.24),('8975','2014-03-07','10:30:00',5.3),('8975','2014-03-07','10:35:00',5.34),('8975','2014-03-07','10:40:00',5.37),('8975','2014-03-07','10:45:00',5.4),('8975','2014-03-07','10:50:00',5.43),('8975','2014-03-07','10:55:00',5.45),('8975','2014-03-07','11:00:00',5.49),('8975','2014-03-07','11:05:00',5.53),('8975','2014-03-07','11:10:00',5.57),('8975','2014-03-07','11:15:00',5.63),('8975','2014-03-07','11:20:00',5.74),('8975','2014-03-07','11:25:00',5.87),('8975','2014-03-07','11:30:00',6.11),('8975','2014-03-07','11:35:00',4.53),('8975','2014-03-07','11:40:00',2.38),('8975','2014-03-07','11:45:00',2.02),('8975','2014-03-07','11:50:00',2.13),('8975','2014-03-07','11:55:00',2.05),('8975','2014-03-07','12:00:00',1.76),('8975','2014-03-07','12:05:00',1.63),('8975','2014-03-07','12:10:00',1.62),('8975','2014-03-07','12:15:00',1.7),('8975','2014-03-07','12:20:00',2.05),('8975','2014-03-07','12:25:00',2.29),('8975','2014-03-07','12:30:00',2.54),('8975','2014-03-07','12:35:00',4.59),('8975','2014-03-07','12:40:00',3.31),('8975','2014-03-07','12:45:00',2.84),('8975','2014-03-07','12:50:00',2.54),('8975','2014-03-07','12:55:00',3.9),('8975','2014-03-07','13:00:00',2.59),('8975','2014-03-07','13:05:00',2.36),('8975','2014-03-07','13:10:00',2.11),('8975','2014-03-07','13:15:00',1.73),('8975','2014-03-07','13:20:00',1.49),('8975','2014-03-07','13:25:00',1.98),('8975','2014-03-07','13:30:00',3.49),('8975','2014-03-07','13:35:00',3.42),('8975','2014-03-07','13:40:00',4.62),('8975','2014-03-07','13:45:00',3.5),('8975','2014-03-07','13:50:00',4),('8975','2014-03-07','13:55:00',1.95),('8975','2014-03-07','14:00:00',1.61),('8975','2014-03-07','14:05:00',1.65),('8975','2014-03-07','14:10:00',1.54),('8975','2014-03-07','14:15:00',1.27),('8975','2014-03-07','14:20:00',1.13),('8975','2014-03-07','14:25:00',1.02),('8975','2014-03-07','14:30:00',1.05),('8975','2014-03-07','14:35:00',1.3),('8975','2014-03-07','14:40:00',1.52),('8975','2014-03-07','14:45:00',1.47),('8975','2014-03-07','14:50:00',1.49),('8975','2014-03-07','14:55:00',1.51),('8975','2014-03-07','15:00:00',1.33),('8975','2014-03-07','15:05:00',1.3),('8975','2014-03-07','15:10:00',1.42),('8975','2014-03-07','15:15:00',1.91),('8975','2014-03-07','15:20:00',1.98),('8975','2014-03-07','15:25:00',2.16),('8975','2014-03-07','15:30:00',2.69),('8975','2014-03-07','15:35:00',1.43),('8975','2014-03-07','15:45:00',1.02),('8975','2014-03-07','15:50:00',1.26),('8975','2014-03-07','15:55:00',1.25),('8975','2014-03-07','16:00:00',1.25),('8975','2014-03-07','16:05:00',1.04),('8975','2014-03-07','16:20:00',1.02),('8975','2014-03-07','16:30:00',1.54),('8975','2014-03-07','16:35:00',1.39),('8975','2014-03-07','16:40:00',1.26),('8975','2014-03-07','16:45:00',1.23),('8975','2014-03-07','16:50:00',1.15),('8975','2014-03-07','16:55:00',1.08),('8975','2014-04-29','07:00:00',1.19),('8975','2014-04-29','07:05:00',1.37),('8975','2014-04-29','07:10:00',1.76),('8975','2014-04-29','07:15:00',1.9),('8975','2014-04-29','07:20:00',2.33),('8975','2014-04-29','07:25:00',2.52),('8975','2014-04-29','07:30:00',2.66),('8975','2014-04-29','07:35:00',2.8),('8975','2014-04-29','07:40:00',2.92),('8975','2014-04-29','07:45:00',3.08),('8975','2014-04-29','07:50:00',3.19),('8975','2014-04-29','07:55:00',3.29),('8975','2014-04-29','08:00:00',3.39),('8975','2014-04-29','08:05:00',3.5),('8975','2014-04-29','08:10:00',3.6),('8975','2014-04-29','08:15:00',3.65),('8975','2014-04-29','08:20:00',3.75),('8975','2014-04-29','08:25:00',3.86),('8975','2014-04-29','08:30:00',3.96),('8975','2014-04-29','08:35:00',4.04),('8975','2014-04-29','08:40:00',4.09),('8975','2014-04-29','08:45:00',4.06),('8975','2014-04-29','08:50:00',3.85),('8975','2014-04-29','08:55:00',5.07),('8975','2014-04-29','09:00:00',4.64),('8975','2014-04-29','09:05:00',3.2),('8975','2014-04-29','09:10:00',2.4),('8975','2014-04-29','09:15:00',4.4),('8975','2014-04-29','09:20:00',2.69),('8975','2014-04-29','09:25:00',2.01),('8975','2014-04-29','09:30:00',2.41),('8975','2014-04-29','09:35:00',5.74),('8975','2014-04-29','09:40:00',5.76),('8975','2014-04-29','09:45:00',5.97),('8975','2014-04-29','09:50:00',3.89),('8975','2014-04-29','09:55:00',5.06),('8975','2014-04-29','10:00:00',3.98),('8975','2014-04-29','10:05:00',4.05),('8975','2014-04-29','10:10:00',2.45),('8975','2014-04-29','10:15:00',3.08),('8975','2014-04-29','10:20:00',2.37),('8975','2014-04-29','10:25:00',2.36),('8975','2014-04-29','10:30:00',3.07),('8975','2014-04-29','10:35:00',2.84),('8975','2014-04-29','10:40:00',2.7),('8975','2014-04-29','10:45:00',2.51),('8975','2014-04-29','10:50:00',2.36),('8975','2014-04-29','10:55:00',2.41),('8975','2014-04-29','11:00:00',4.49),('8975','2014-04-29','11:05:00',4.16),('8975','2014-04-29','11:10:00',2.72),('8975','2014-04-29','11:15:00',3.13),('8975','2014-04-29','11:20:00',2.82),('8975','2014-04-29','11:25:00',3.07),('8975','2014-04-29','11:30:00',3.42),('8975','2014-04-29','11:35:00',4.24),('8975','2014-04-29','11:40:00',3.54),('8975','2014-04-29','11:45:00',2.52),('8975','2014-04-29','11:50:00',2.09),('8975','2014-04-29','11:55:00',3.13),('8975','2014-04-29','12:00:00',2.92),('8975','2014-04-29','12:05:00',4.74),('8975','2014-04-29','12:10:00',5.75),('8975','2014-04-29','12:15:00',8.86),('8975','2014-04-29','12:20:00',4.62),('8975','2014-04-29','12:25:00',3.47),('8975','2014-04-29','12:30:00',5.18),('8975','2014-04-29','12:35:00',5.53),('8975','2014-04-29','12:40:00',3.62),('8975','2014-04-29','12:45:00',2.77),('8975','2014-04-29','12:50:00',5.17),('8975','2014-04-29','12:55:00',6.24),('8975','2014-04-29','13:00:00',4.41),('8975','2014-04-29','13:05:00',4.01),('8975','2014-04-29','13:10:00',5.55),('8975','2014-04-29','13:15:00',4.88),('8975','2014-04-29','13:20:00',4.54),('8975','2014-04-29','13:25:00',4.32),('8975','2014-04-29','13:30:00',5.17),('8975','2014-04-29','13:35:00',5.16),('8975','2014-04-29','13:40:00',7.42),('8975','2014-04-29','13:45:00',6.57),('8975','2014-04-29','13:50:00',3.89),('8975','2014-04-29','13:55:00',4.41),('8975','2014-04-29','14:00:00',3.22),('8975','2014-04-29','14:05:00',3.01),('8975','2014-04-29','14:10:00',2.46),('8975','2014-04-29','14:15:00',2.94),('8975','2014-04-29','14:20:00',3.92),('8975','2014-04-29','14:25:00',4.31),('8975','2014-04-29','14:30:00',4.88),('8975','2014-04-29','14:35:00',5.72),('8975','2014-04-29','14:40:00',3.72),('8975','2014-04-29','14:45:00',3.02),('8975','2014-04-29','14:50:00',2.73),('8975','2014-04-29','14:55:00',2.74),('8975','2014-04-29','15:00:00',2.59),('8975','2014-04-29','15:05:00',2.26),('8975','2014-04-29','15:10:00',2.48),('8975','2014-04-29','15:15:00',2.22),('8975','2014-04-29','15:20:00',1.62),('8975','2014-04-29','15:25:00',1.73),('8975','2014-04-29','15:30:00',2.87),('8975','2014-04-29','15:35:00',3.5),('8975','2014-04-29','15:40:00',5.65),('8975','2014-04-29','15:45:00',5.3),('8975','2014-04-29','15:50:00',5.53),('8975','2014-04-29','15:55:00',3.62),('8975','2014-04-29','16:00:00',3.19),('8975','2014-04-29','16:05:00',3.16),('8975','2014-04-29','16:10:00',2.17),('8975','2014-04-29','16:15:00',1.83),('8975','2014-04-29','16:20:00',2.15),('8975','2014-04-29','16:25:00',2.9),('8975','2014-04-29','16:30:00',3.57),('8975','2014-04-29','16:35:00',4.32),('8975','2014-04-29','16:40:00',3.96),('8975','2014-04-29','16:45:00',3.76),('8975','2014-04-29','16:50:00',2.36),('8975','2014-04-29','16:55:00',3.49),('8975','2014-04-29','17:00:00',2.98),('8975','2014-04-29','17:05:00',2.98),('8975','2014-04-29','17:10:00',2),('8975','2014-04-29','17:15:00',1.9),('8975','2014-04-29','17:20:00',1.37),('8975','2014-04-29','17:25:00',1.14),('8975','2014-04-29','17:30:00',1.6),('8975','2014-04-29','17:35:00',1.84),('8975','2014-04-29','17:40:00',1.55),('8975','2014-04-29','17:45:00',1.3),('8975','2014-04-29','17:55:00',1.18),('8975','2014-04-29','18:00:00',1.01),('8975','2014-04-29','18:10:00',1.14),('8975','2014-03-06','09:30:00',1.02),('8975','2014-03-06','09:35:00',1.33),('8975','2014-03-06','09:40:00',1.07),('8975','2014-03-06','10:10:00',1.06),('8975','2014-03-06','10:15:00',1.06),('8975','2014-03-06','10:20:00',1.08),('8975','2014-03-06','10:30:00',1.04),('8975','2014-03-06','10:35:00',1.54),('8975','2014-03-06','10:40:00',1.31),('8975','2014-03-06','10:45:00',1.11),('8975','2014-03-06','10:50:00',1.05),('8975','2014-03-06','10:55:00',1.11),('8975','2014-03-06','11:00:00',1.38),('8975','2014-03-06','11:05:00',1.39),('8975','2014-03-06','11:10:00',1.22),('8975','2014-03-06','11:15:00',1.29),('8975','2014-03-06','11:20:00',1.53),('8975','2014-03-06','11:25:00',1.47),('8975','2014-03-06','11:30:00',4.04),('8975','2014-03-06','11:35:00',4.08),('8975','2014-03-06','11:40:00',2.83),('8975','2014-03-06','11:45:00',4.45),('8975','2014-03-06','11:50:00',4.88),('8975','2014-03-06','11:55:00',6.49),('8975','2014-03-06','12:00:00',6.42),('8975','2014-03-06','12:05:00',4.21),('8975','2014-03-06','12:10:00',5.36),('8975','2014-03-06','12:15:00',5.85),('8975','2014-03-06','12:20:00',5.77),('8975','2014-03-06','12:25:00',5.21),('8975','2014-03-06','12:30:00',3.48),('8975','2014-03-06','12:35:00',3.98),('8975','2014-03-06','12:40:00',4.02),('8975','2014-03-06','12:45:00',1.47),('8975','2014-03-06','12:50:00',3.68),('8975','2014-03-06','12:55:00',5.85),('8975','2014-03-06','13:00:00',5.79),('8975','2014-03-06','13:05:00',5.58),('8975','2014-03-06','13:10:00',5.7),('8975','2014-03-06','13:15:00',5.5),('8975','2014-03-06','13:20:00',5.24),('8975','2014-03-06','13:25:00',5.29),('8975','2014-03-06','13:30:00',5.12),('8975','2014-03-06','13:35:00',4.4),('8975','2014-03-06','13:40:00',4),('8975','2014-03-06','13:45:00',3.47),('8975','2014-03-06','13:50:00',2.09),('8975','2014-03-06','13:55:00',1.8),('8975','2014-03-06','14:00:00',1.76),('8975','2014-03-06','14:05:00',1.72),('8975','2014-03-06','14:10:00',1.7),('8975','2014-03-06','14:15:00',1.64),('8975','2014-03-06','14:20:00',1.62),('8975','2014-03-06','14:25:00',1.56),('8975','2014-03-06','14:30:00',1.62),('8975','2014-03-06','14:35:00',1.77),('8975','2014-03-06','14:40:00',1.9),('8975','2014-03-06','14:45:00',1.89),('8975','2014-03-06','14:50:00',2.23),('8975','2014-03-06','14:55:00',3.03),('8975','2014-03-06','15:00:00',3.52),('8975','2014-03-06','15:05:00',3.84),('8975','2014-03-06','15:10:00',3.84),('8975','2014-03-06','15:15:00',3.69),('8975','2014-03-06','15:20:00',3.5),('8975','2014-03-06','15:25:00',3.15),('8975','2014-03-06','15:30:00',2.81),('8975','2014-03-06','15:35:00',2.57),('8975','2014-03-06','15:40:00',1.1),('8975','2014-03-06','15:45:00',1.02),('8975','2014-03-06','15:50:00',1.04),('8975','2014-03-06','15:55:00',2.03),('8975','2014-03-06','16:00:00',2.21),('8975','2014-03-06','16:05:00',1.97),('8975','2014-03-06','16:10:00',1.89),('8975','2014-03-06','16:15:00',1.94),('8975','2014-03-06','16:20:00',1.75),('8975','2014-03-06','16:25:00',1.61),('8975','2014-03-06','16:30:00',1.08),('8975','2014-03-06','16:35:00',1.54),('8975','2014-03-06','16:40:00',1.69),('8975','2014-03-06','16:45:00',1.7),('8975','2014-03-06','16:50:00',1.59),('8975','2014-03-06','16:55:00',1.5),('8975','2014-03-06','17:00:00',1.43),('8975','2014-03-06','17:05:00',1.36),('8975','2014-03-06','17:10:00',1.24),('8975','2014-03-06','17:15:00',1.09),('8975','2014-03-05','07:55:00',1.52),('8975','2014-03-05','08:00:00',1.38),('8975','2014-03-05','08:05:00',3.26),('8975','2014-03-05','08:10:00',3.33),('8975','2014-03-05','08:15:00',1.68),('8975','2014-03-05','08:20:00',1.55),('8975','2014-03-05','08:25:00',1.75),('8975','2014-03-05','08:30:00',1.06),('8975','2014-03-05','08:35:00',1.11),('8975','2014-03-05','08:40:00',1.04),('8975','2014-03-05','08:45:00',1.37),('8975','2014-03-05','08:50:00',1.31),('8975','2014-03-05','08:55:00',1.21),('8975','2014-03-05','09:00:00',1.48),('8975','2014-03-05','09:05:00',1.37),('8975','2014-03-05','09:10:00',1.37),('8975','2014-03-05','09:15:00',1.53),('8975','2014-03-05','09:20:00',1.76),('8975','2014-03-05','09:25:00',1.65),('8975','2014-03-05','09:30:00',1.72),('8975','2014-03-05','09:35:00',1.89),('8975','2014-03-05','09:40:00',2.27),('8975','2014-03-05','09:45:00',2.57),('8975','2014-03-05','09:50:00',2.9),('8975','2014-03-05','09:55:00',3.79),('8975','2014-03-05','10:00:00',3.74),('8975','2014-03-05','10:05:00',3.81),('8975','2014-03-05','10:10:00',4.64),('8975','2014-03-05','10:15:00',4.78),('8975','2014-03-05','10:20:00',5.07),('8975','2014-03-05','10:25:00',4.44),('8975','2014-03-05','10:30:00',3.07),('8975','2014-03-05','10:35:00',2.39),('8975','2014-03-05','10:40:00',1.93),('8975','2014-03-05','10:45:00',4.31),('8975','2014-03-05','10:50:00',1.98),('8975','2014-03-05','10:55:00',1.25),('8975','2014-03-05','11:00:00',1.61),('8975','2014-03-05','11:05:00',1.18),('8975','2014-03-05','11:10:00',1.42),('8975','2014-03-05','11:15:00',3.16),('8975','2014-03-05','11:20:00',3.57),('8975','2014-03-05','11:25:00',3.45),('8975','2014-03-05','11:30:00',4.82),('8975','2014-03-05','11:35:00',3.01),('8975','2014-03-05','11:40:00',3.29),('8975','2014-03-05','11:45:00',6.32),('8975','2014-03-05','11:50:00',6.94),('8975','2014-03-05','11:55:00',7.28),('8975','2014-03-05','12:00:00',6.79),('8975','2014-03-05','12:05:00',2.99),('8975','2014-03-05','12:10:00',5.54),('8975','2014-03-05','12:15:00',3.11),('8975','2014-03-05','12:20:00',1.92),('8975','2014-03-05','12:25:00',4.63),('8975','2014-03-05','12:30:00',5.44),('8975','2014-03-05','12:35:00',3.91),('8975','2014-03-05','12:40:00',2.35),('8975','2014-03-05','12:45:00',1.62),('8975','2014-03-05','12:50:00',1.57),('8975','2014-03-05','12:55:00',1.86),('8975','2014-03-05','13:00:00',2.19),('8975','2014-03-05','13:05:00',2.16),('8975','2014-03-05','13:10:00',1.92),('8975','2014-03-05','13:15:00',1.87),('8975','2014-03-05','13:20:00',1.99),('8975','2014-03-05','13:25:00',1.69),('8975','2014-03-05','13:30:00',2.06),('8975','2014-03-05','13:35:00',1.84),('8975','2014-03-05','13:40:00',1.79),('8975','2014-03-05','13:45:00',1.66),('8975','2014-03-05','13:50:00',1.54),('8975','2014-03-05','13:55:00',1.5),('8975','2014-03-05','14:00:00',1.58),('8975','2014-03-05','14:05:00',1.64),('8975','2014-03-05','14:10:00',1.72),('8975','2014-03-05','14:15:00',1.61),('8975','2014-03-05','14:20:00',1.99),('8975','2014-03-05','14:25:00',2.19),('8975','2014-03-05','14:30:00',2.07),('8975','2014-03-05','14:35:00',2.62),('8975','2014-03-05','14:40:00',2.19),('8975','2014-03-05','14:45:00',1.47),('8975','2014-03-05','14:50:00',1.59),('8975','2014-03-05','14:55:00',1.55),('8975','2014-03-05','15:00:00',1.67),('8975','2014-03-05','15:05:00',1.81),('8975','2014-03-05','15:10:00',1.81),('8975','2014-03-05','15:15:00',1.34),('8975','2014-03-05','15:35:00',1.05),('8975','2014-03-05','16:40:00',1.45),('8975','2014-03-05','16:45:00',1.49),('8975','2014-03-05','16:50:00',1.41),('8975','2014-03-05','17:10:00',1.05),('8975','2014-03-04','07:05:00',1.13),('8975','2014-03-04','07:10:00',1.36),('8975','2014-03-04','07:15:00',1.84),('8975','2014-03-04','07:20:00',2.03),('8975','2014-03-04','07:25:00',2.28),('8975','2014-03-04','07:30:00',2.48),('8975','2014-03-04','07:35:00',2.64),('8975','2014-03-04','07:40:00',2.82),('8975','2014-03-04','07:45:00',2.94),('8975','2014-03-04','07:50:00',3.06),('8975','2014-03-04','07:55:00',3.16),('8975','2014-03-04','08:00:00',3.19),('8975','2014-03-04','08:05:00',1.5),('8975','2014-03-04','08:10:00',1.03),('8975','2014-03-04','08:15:00',3.3),('8975','2014-03-04','08:20:00',3.65),('8975','2014-03-04','08:25:00',1.98),('8975','2014-03-04','08:30:00',1.04),('8975','2014-03-04','08:35:00',1.5),('8975','2014-03-04','08:40:00',2.04),('8975','2014-03-04','08:45:00',2.81),('8975','2014-03-04','08:50:00',4.06),('8975','2014-03-04','08:55:00',1.46),('8975','2014-03-04','09:00:00',2.66),('8975','2014-03-04','09:05:00',3.53),('8975','2014-03-04','09:10:00',3.59),('8975','2014-03-04','09:15:00',3.74),('8975','2014-03-04','09:20:00',4.47),('8975','2014-03-04','09:25:00',4.52),('8975','2014-03-04','09:30:00',4.61),('8975','2014-03-04','09:35:00',4.69),('8975','2014-03-04','09:40:00',4.74),('8975','2014-03-04','09:45:00',4.79),('8975','2014-03-04','09:50:00',4.84),('8975','2014-03-04','09:55:00',4.92),('8975','2014-03-04','10:00:00',4.96),('8975','2014-03-04','10:05:00',5.03),('8975','2014-03-04','10:10:00',5.16),('8975','2014-03-04','10:15:00',5.17),('8975','2014-03-04','10:20:00',5.19),('8975','2014-03-04','10:25:00',5.22),('8975','2014-03-04','10:30:00',5.23),('8975','2014-03-04','10:35:00',5.27),('8975','2014-03-04','10:40:00',5.28),('8975','2014-03-04','10:45:00',5.31),('8975','2014-03-04','10:50:00',5.34),('8975','2014-03-04','10:55:00',5.36),('8975','2014-03-04','11:00:00',5.43),('8975','2014-03-04','11:05:00',5.45),('8975','2014-03-04','11:10:00',5.47),('8975','2014-03-04','11:15:00',5.19),('8975','2014-03-04','11:20:00',5.51),('8975','2014-03-04','11:25:00',5.55),('8975','2014-03-04','11:30:00',5.56),('8975','2014-03-04','11:35:00',5.6),('8975','2014-03-04','11:40:00',5.51),('8975','2014-03-04','11:45:00',5.29),('8975','2014-03-04','11:50:00',5.21),('8975','2014-03-04','11:55:00',4.97),('8975','2014-03-04','12:00:00',4.87),('8975','2014-03-04','12:05:00',4.82),('8975','2014-03-04','12:10:00',3.98),('8975','2014-03-04','12:15:00',3.22),('8975','2014-03-04','12:20:00',1.54),('8975','2014-03-04','12:25:00',1.44),('8975','2014-03-04','12:30:00',1.58),('8975','2014-03-04','12:35:00',1.89),('8975','2014-03-04','12:40:00',2.07),('8975','2014-03-04','12:45:00',2.04),('8975','2014-03-04','12:50:00',1.76),('8975','2014-03-04','12:55:00',1.58),('8975','2014-03-04','13:00:00',1.48),('8975','2014-03-04','13:05:00',2.42),('8975','2014-03-04','13:10:00',2.78),('8975','2014-03-04','13:15:00',2.54),('8975','2014-03-04','13:20:00',1.76),('8975','2014-03-04','13:25:00',1.88),('8975','2014-03-04','13:30:00',1.78),('8975','2014-03-04','13:35:00',1.87),('8975','2014-03-04','13:40:00',2.59),('8975','2014-03-04','13:45:00',3.94),('8975','2014-03-04','13:50:00',2.2),('8975','2014-03-04','13:55:00',1.66),('8975','2014-03-04','14:00:00',1.52),('8975','2014-03-04','14:05:00',1.56),('8975','2014-03-04','14:10:00',1.52),('8975','2014-03-04','14:15:00',1.71),('8975','2014-03-04','14:20:00',1.79),('8975','2014-03-04','14:25:00',1.81),('8975','2014-03-04','14:30:00',1.94),('8975','2014-03-04','14:35:00',1.61),('8975','2014-03-04','14:40:00',1.66),('8975','2014-03-04','14:45:00',1.82),('8975','2014-03-04','14:50:00',2.16),('8975','2014-03-04','14:55:00',2.4),('8975','2014-03-04','15:00:00',1.78),('8975','2014-03-04','15:05:00',1.5),('8975','2014-03-04','15:10:00',2.38),('8975','2014-03-04','15:15:00',1.55),('8975','2014-03-04','15:20:00',1.32),('8975','2014-03-04','15:25:00',1.18),('8975','2014-03-04','15:30:00',1.37),('8975','2014-03-04','15:35:00',1.56),('8975','2014-03-04','15:40:00',2),('8975','2014-03-04','15:45:00',1.98),('8975','2014-03-04','15:50:00',1.98),('8975','2014-03-04','15:55:00',2.6),('8975','2014-03-04','16:00:00',2.78),('8975','2014-03-04','16:05:00',2.29),('8975','2014-03-04','16:10:00',2.21),('8975','2014-03-04','16:15:00',1.29),('8975','2014-03-04','16:20:00',1.07),('8975','2014-03-03','09:00:00',1.23),('8975','2014-03-03','09:05:00',3.27),('8975','2014-03-03','09:10:00',1.32),('8975','2014-03-03','09:15:00',4.77),('8975','2014-03-03','09:20:00',2.47),('8975','2014-03-03','09:25:00',1.94),('8975','2014-03-03','09:30:00',1.94),('8975','2014-03-03','09:35:00',2.18),('8975','2014-03-03','09:40:00',3.21),('8975','2014-03-03','09:45:00',1.76),('8975','2014-03-03','09:50:00',1.54),('8975','2014-03-03','09:55:00',4.72),('8975','2014-03-03','10:00:00',2.2),('8975','2014-03-03','10:05:00',1.45),('8975','2014-03-03','10:15:00',1.11),('8975','2014-03-03','10:20:00',2.48),('8975','2014-03-03','10:25:00',6.43),('8975','2014-03-03','10:30:00',3.14),('8975','2014-03-03','10:35:00',6.21),('8975','2014-03-03','10:40:00',5.97),('8975','2014-03-03','10:45:00',3.75),('8975','2014-03-03','10:50:00',1.18),('8975','2014-03-03','10:55:00',3.52),('8975','2014-03-03','11:00:00',1.92),('8975','2014-03-03','11:05:00',2.24),('8975','2014-03-03','11:10:00',4.03),('8975','2014-03-03','11:15:00',5.29),('8975','2014-03-03','11:20:00',2.57),('8975','2014-03-03','11:25:00',2.08),('8975','2014-03-03','11:30:00',1.28),('8975','2014-03-03','11:35:00',1),('8975','2014-03-03','11:40:00',1.79),('8975','2014-03-03','11:45:00',6.67),('8975','2014-03-03','11:50:00',6.54),('8975','2014-03-03','11:55:00',5.79),('8975','2014-03-03','12:00:00',5.6),('8975','2014-03-03','12:05:00',5.47),('8975','2014-03-03','12:10:00',5.45),('8975','2014-03-03','12:15:00',5.37),('8975','2014-03-03','12:20:00',5.34),('8975','2014-03-03','12:25:00',5.31),('8975','2014-03-03','12:30:00',5.19),('8975','2014-03-03','12:35:00',5.09),('8975','2014-03-03','12:40:00',5.18),('8975','2014-03-03','12:45:00',4.71),('8975','2014-03-03','12:50:00',4.95),('8975','2014-03-03','12:55:00',5.02),('8975','2014-03-03','13:00:00',4.75),('8975','2014-03-03','13:05:00',3.79),('8975','2014-03-03','13:10:00',4.82),('8975','2014-03-03','13:15:00',3.3),('8975','2014-03-03','13:20:00',1.81),('8975','2014-03-03','13:25:00',1.61),('8975','2014-03-03','13:30:00',2.07),('8975','2014-03-03','13:35:00',1.28),('8975','2014-03-03','13:40:00',1.04),('8975','2014-03-03','13:45:00',1.26),('8975','2014-03-03','13:50:00',1.55),('8975','2014-03-03','13:55:00',1.64),('8975','2014-03-03','14:00:00',1.2),('8975','2014-03-03','14:05:00',2.02),('8975','2014-03-03','14:10:00',1.98),('8975','2014-03-03','14:15:00',3.56),('8975','2014-03-03','14:20:00',4.2),('8975','2014-03-03','14:25:00',3.15),('8975','2014-03-03','14:30:00',3.34),('8975','2014-03-03','14:35:00',3.18),('8975','2014-03-03','14:40:00',3.12),('8975','2014-03-03','14:45:00',3.05),('8975','2014-03-03','14:50:00',3.07),('8975','2014-03-03','14:55:00',1.84),('8975','2014-03-03','15:00:00',1.93),('8975','2014-03-03','15:05:00',2.71),('8975','2014-03-03','15:10:00',2.5),('8975','2014-03-03','15:15:00',2.08),('8975','2014-03-03','15:20:00',1.54),('8975','2014-03-03','15:25:00',2.49),('8975','2014-03-03','15:30:00',2.38),('8975','2014-03-03','15:35:00',2.34),('8975','2014-03-03','15:40:00',2.03),('8975','2014-03-03','15:45:00',1.7),('8975','2014-03-03','15:50:00',1.88),('8975','2014-03-03','16:00:00',1.23),('8975','2014-03-03','16:05:00',1.41),('8975','2014-03-03','16:10:00',1.4),('8975','2014-03-03','16:15:00',1.39),('8975','2014-03-03','16:20:00',1.66),('8975','2014-03-03','16:25:00',1.36),('8975','2014-03-03','16:35:00',1.07),('8975','2014-03-03','16:45:00',1.25),('8975','2014-03-03','16:50:00',1.19),('8975','2014-03-02','07:10:00',1.04),('8975','2014-03-02','07:15:00',1.41),('8975','2014-03-02','07:20:00',1.65),('8975','2014-03-02','07:25:00',1.84),('8975','2014-03-02','07:30:00',2.07),('8975','2014-03-02','07:35:00',2.25),('8975','2014-03-02','07:40:00',2.38),('8975','2014-03-02','07:45:00',2.51),('8975','2014-03-02','07:50:00',2.6),('8975','2014-03-02','07:55:00',2.77),('8975','2014-03-02','08:00:00',2.34),('8975','2014-03-02','08:05:00',2.27),('8975','2014-03-02','08:10:00',3.11),('8975','2014-03-02','08:15:00',3.19),('8975','2014-03-02','08:20:00',3.27),('8975','2014-03-02','08:25:00',3.35),('8975','2014-03-02','08:30:00',3.41),('8975','2014-03-02','08:35:00',3.49),('8975','2014-03-02','08:40:00',3.62),('8975','2014-03-02','08:45:00',3.72),('8975','2014-03-02','08:50:00',3.69),('8975','2014-03-02','08:55:00',3.84),('8975','2014-03-02','09:00:00',3.75),('8975','2014-03-02','09:05:00',3.55),('8975','2014-03-02','09:10:00',3.18),('8975','2014-03-02','09:15:00',3.58),('8975','2014-03-02','09:20:00',4.15),('8975','2014-03-02','09:25:00',4.32),('8975','2014-03-02','09:30:00',4.49),('8975','2014-03-02','09:35:00',4.43),('8975','2014-03-02','09:40:00',3.86),('8975','2014-03-02','09:45:00',4.19),('8975','2014-03-02','09:50:00',4.44),('8975','2014-03-02','09:55:00',4.3),('8975','2014-03-02','10:00:00',4.5),('8975','2014-03-02','10:05:00',4.82),('8975','2014-03-02','10:10:00',4.88),('8975','2014-03-02','10:15:00',4.93),('8975','2014-03-02','10:20:00',4.94),('8975','2014-03-02','10:25:00',4.98),('8975','2014-03-02','10:30:00',5.03),('8975','2014-03-02','10:35:00',5.05),('8975','2014-03-02','10:40:00',5.05),('8975','2014-03-02','10:45:00',5.09),('8975','2014-03-02','10:50:00',5.12),('8975','2014-03-02','10:55:00',5.11),('8975','2014-03-02','11:00:00',5.13),('8975','2014-03-02','11:05:00',5.12),('8975','2014-03-02','11:10:00',5.18),('8975','2014-03-02','11:15:00',5.16),('8975','2014-03-02','11:20:00',3.86),('8975','2014-03-02','11:25:00',2.12),('8975','2014-03-02','11:30:00',5.58),('8975','2014-03-02','11:35:00',5.72),('8975','2014-03-02','11:40:00',5.49),('8975','2014-03-02','11:45:00',5.33),('8975','2014-03-02','11:50:00',5.29),('8975','2014-03-02','11:55:00',5.31),('8975','2014-03-02','12:00:00',5.25),('8975','2014-03-02','12:05:00',5.21),('8975','2014-03-02','12:10:00',5.25),('8975','2014-03-02','12:15:00',5.22),('8975','2014-03-02','12:20:00',5.18),('8975','2014-03-02','12:25:00',5.07),('8975','2014-03-02','12:30:00',5.07),('8975','2014-03-02','12:35:00',5.03),('8975','2014-03-02','12:40:00',5.01),('8975','2014-03-02','12:45:00',4.95),('8975','2014-03-02','12:50:00',4.9),('8975','2014-03-02','12:55:00',4.85),('8975','2014-03-02','13:00:00',4.8),('8975','2014-03-02','13:05:00',4.65),('8975','2014-03-02','13:10:00',4.61),('8975','2014-03-02','13:15:00',4.38),('8975','2014-03-02','13:20:00',4.21),('8975','2014-03-02','13:25:00',4.36),('8975','2014-03-02','13:30:00',4.26),('8975','2014-03-02','13:35:00',4.19),('8975','2014-03-02','13:40:00',4.15),('8975','2014-03-02','13:45:00',4.08),('8975','2014-03-02','13:50:00',4.03),('8975','2014-03-02','13:55:00',3.82),('8975','2014-03-02','14:00:00',3.71),('8975','2014-03-02','14:05:00',3.64),('8975','2014-03-02','14:10:00',3.62),('8975','2014-03-02','14:15:00',2.79),('8975','2014-03-02','14:20:00',3.34),('8975','2014-03-02','14:25:00',3.09),('8975','2014-03-02','14:30:00',3.05),('8975','2014-03-02','14:35:00',2.9),('8975','2014-03-02','14:40:00',2.98),('8975','2014-03-02','14:45:00',2.87),('8975','2014-03-02','14:50:00',2.76),('8975','2014-03-02','14:55:00',2.7),('8975','2014-03-02','15:00:00',2.36),('8975','2014-03-02','15:05:00',2.43),('8975','2014-03-02','15:10:00',2.35),('8975','2014-03-02','15:15:00',1.52),('8975','2014-03-02','15:20:00',1.01),('8975','2014-03-02','15:25:00',1.92),('8975','2014-03-02','15:30:00',1.49),('8975','2014-03-02','15:35:00',1.41),('8975','2014-03-02','15:40:00',1.63),('8975','2014-03-02','15:45:00',1.58),('8975','2014-03-02','15:50:00',1.52),('8975','2014-03-02','15:55:00',1.43),('8975','2014-03-02','16:00:00',1.45),('8975','2014-03-02','16:05:00',1.39),('8975','2014-03-02','16:10:00',1.39),('8975','2014-03-02','16:15:00',1.32),('8975','2014-03-02','16:20:00',1.27),('8975','2014-03-02','16:25:00',1.15),('8975','2014-03-02','16:30:00',1.19),('8975','2014-03-02','16:35:00',1.19),('8975','2014-03-02','16:40:00',1.03),('8975','2014-03-02','16:45:00',1.12),('8975','2014-03-02','16:55:00',1.16),('8975','2014-03-02','17:00:00',1.06),('8975','2014-03-01','07:45:00',1.23),('8975','2014-03-01','08:00:00',1.27),('8975','2014-03-01','08:05:00',2.14),('8975','2014-03-01','08:10:00',3.82),('8975','2014-03-01','08:15:00',3.8),('8975','2014-03-01','08:20:00',3.49),('8975','2014-03-01','08:25:00',3.39),('8975','2014-03-01','08:30:00',3.34),('8975','2014-03-01','08:35:00',3.43),('8975','2014-03-01','08:40:00',3.59),('8975','2014-03-01','08:45:00',3.69),('8975','2014-03-01','08:50:00',3.78),('8975','2014-03-01','08:55:00',3.86),('8975','2014-03-01','09:00:00',3.97),('8975','2014-03-01','09:05:00',4.05),('8975','2014-03-01','09:10:00',4.18),('8975','2014-03-01','09:15:00',4.2),('8975','2014-03-01','09:20:00',4.05),('8975','2014-03-01','09:25:00',4.67),('8975','2014-03-01','09:30:00',4.77),('8975','2014-03-01','09:35:00',4.91),('8975','2014-03-01','09:40:00',4.5),('8975','2014-03-01','09:45:00',1.24),('8975','2014-03-01','09:50:00',1.38),('8975','2014-03-01','09:55:00',1.88),('8975','2014-03-01','10:00:00',2.26),('8975','2014-03-01','10:05:00',2.37),('8975','2014-03-01','10:10:00',2),('8975','2014-03-01','10:15:00',1.86),('8975','2014-03-01','10:20:00',1.74),('8975','2014-03-01','10:25:00',1.93),('8975','2014-03-01','10:30:00',1.85),('8975','2014-03-01','10:35:00',1.77),('8975','2014-03-01','10:40:00',1.52),('8975','2014-03-01','10:45:00',1.64),('8975','2014-03-01','10:50:00',1.63),('8975','2014-03-01','10:55:00',4.61),('8975','2014-03-01','11:00:00',4.46),('8975','2014-03-01','11:05:00',2.39),('8975','2014-03-01','11:10:00',1.98),('8975','2014-03-01','11:15:00',2.18),('8975','2014-03-01','11:20:00',3.03),('8975','2014-03-01','11:25:00',3.17),('8975','2014-03-01','11:30:00',3.24),('8975','2014-03-01','11:35:00',3.39),('8975','2014-03-01','11:40:00',6.37),('8975','2014-03-01','11:45:00',6.35),('8975','2014-03-01','11:50:00',3.64),('8975','2014-03-01','11:55:00',3.4),('8975','2014-03-01','12:00:00',2.67),('8975','2014-03-01','12:05:00',2.89),('8975','2014-03-01','12:10:00',4.31),('8975','2014-03-01','12:15:00',3.84),('8975','2014-03-01','12:20:00',2.96),('8975','2014-03-01','12:25:00',2.25),('8975','2014-03-01','12:30:00',2.09),('8975','2014-03-01','12:35:00',1.71),('8975','2014-03-01','12:40:00',1.57),('8975','2014-03-01','12:45:00',1.76),('8975','2014-03-01','12:50:00',2.03),('8975','2014-03-01','12:55:00',2.12),('8975','2014-03-01','13:00:00',2.09),('8975','2014-03-01','13:05:00',1.92),('8975','2014-03-01','13:10:00',1.53),('8975','2014-03-01','13:15:00',1.42),('8975','2014-03-01','13:20:00',1.47),('8975','2014-03-01','13:25:00',1.53),('8975','2014-03-01','13:30:00',1.59),('8975','2014-03-01','13:35:00',1.65),('8975','2014-03-01','13:40:00',1.52),('8975','2014-03-01','13:45:00',1.5),('8975','2014-03-01','13:50:00',1.62),('8975','2014-03-01','13:55:00',1.92),('8975','2014-03-01','14:00:00',2.19),('8975','2014-03-01','14:05:00',2.19),('8975','2014-03-01','14:10:00',2),('8975','2014-03-01','14:15:00',1.84),('8975','2014-03-01','14:20:00',1.73),('8975','2014-03-01','14:25:00',1.81),('8975','2014-03-01','14:30:00',1.87),('8975','2014-03-01','14:35:00',1.9),('8975','2014-03-01','14:40:00',1.86),('8975','2014-03-01','14:45:00',1.87),('8975','2014-03-01','14:50:00',1.87),('8975','2014-03-01','14:55:00',1.81),('8975','2014-03-01','15:00:00',1.85),('8975','2014-03-01','15:05:00',1.88),('8975','2014-03-01','15:10:00',1.84),('8975','2014-03-01','15:15:00',1.84),('8975','2014-03-01','15:20:00',1.85),('8975','2014-03-01','15:25:00',1.85),('8975','2014-03-01','15:30:00',1.81),('8975','2014-03-01','15:35:00',1.73),('8975','2014-03-01','15:40:00',1.59),('8975','2014-03-01','15:45:00',1.47),('8975','2014-03-01','15:50:00',1.36),('8975','2014-03-01','15:55:00',1.25),('8975','2014-03-01','16:00:00',1.16),('8975','2014-03-01','16:05:00',1.06),('8975','2014-02-28','14:45:00',1.12),('8975','2014-02-28','14:50:00',1.08),('8975','2014-02-28','14:55:00',1.13),('8975','2014-02-27','07:40:00',1.75),('8975','2014-02-27','07:45:00',2.22),('8975','2014-02-27','07:50:00',2.34),('8975','2014-02-27','07:55:00',2.58),('8975','2014-02-27','08:00:00',2.95),('8975','2014-02-27','08:05:00',3.04),('8975','2014-02-27','08:10:00',1.48),('8975','2014-02-27','08:15:00',1.99),('8975','2014-02-27','08:20:00',2.71),('8975','2014-02-27','08:25:00',2.72),('8975','2014-02-27','08:30:00',2),('8975','2014-02-27','08:35:00',3.58),('8975','2014-02-27','09:10:00',1.28),('8975','2014-02-27','09:15:00',2.05),('8975','2014-02-27','09:20:00',2.93),('8975','2014-02-27','09:25:00',2.96),('8975','2014-02-27','09:30:00',3.98),('8975','2014-02-27','09:35:00',1.53),('8975','2014-02-27','09:40:00',2.79),('8975','2014-02-27','09:45:00',4.94),('8975','2014-02-27','09:50:00',5.63),('8975','2014-02-27','09:55:00',4.18),('8975','2014-02-27','10:00:00',1.89),('8975','2014-02-27','10:05:00',2.13),('8975','2014-02-27','10:10:00',2.39),('8975','2014-02-27','10:15:00',2.07),('8975','2014-02-27','10:20:00',3.86),('8975','2014-02-27','10:25:00',5.57),('8975','2014-02-27','10:30:00',5.73),('8975','2014-02-27','10:35:00',5.99),('8975','2014-02-27','10:40:00',2.34),('8975','2014-02-27','10:45:00',1.36),('8975','2014-02-27','11:05:00',1.52),('8975','2014-02-27','11:10:00',1.08),('8975','2014-02-27','11:15:00',1.3),('8975','2014-02-27','11:20:00',1.61),('8975','2014-02-27','11:25:00',1.31),('8975','2014-02-27','11:40:00',1.13),('8975','2014-02-27','11:45:00',1.51),('8975','2014-02-27','11:50:00',1.85),('8975','2014-02-27','11:55:00',2.16),('8975','2014-02-27','12:00:00',2.76),('8975','2014-02-27','12:05:00',3.53),('8975','2014-02-27','12:10:00',3.41),('8975','2014-02-27','12:15:00',2.47),('8975','2014-02-27','12:20:00',1.95),('8975','2014-02-27','12:25:00',1.96),('8975','2014-02-27','12:30:00',2.26),('8975','2014-02-27','12:35:00',4.7),('8975','2014-02-27','12:40:00',1.95),('8975','2014-02-27','12:45:00',1.92),('8975','2014-02-27','12:50:00',1.94),('8975','2014-02-27','12:55:00',1.95),('8975','2014-02-27','13:00:00',4.2),('8975','2014-02-27','13:05:00',2.89),('8975','2014-02-27','13:10:00',2.51),('8975','2014-02-27','13:15:00',1.5),('8975','2014-02-27','13:45:00',2.5),('8975','2014-02-27','13:50:00',4.25),('8975','2014-02-27','13:55:00',3.09),('8975','2014-02-27','14:00:00',2.07),('8975','2014-02-27','14:05:00',1.56),('8975','2014-02-27','14:10:00',2.88),('8975','2014-02-27','14:15:00',3.81),('8975','2014-02-27','14:20:00',3.12),('8975','2014-02-27','14:25:00',2.58),('8975','2014-02-27','14:30:00',2.93),('8975','2014-02-27','14:35:00',2.15),('8975','2014-02-27','14:40:00',2.09),('8975','2014-02-27','14:45:00',2.02),('8975','2014-02-27','14:50:00',2.18),('8975','2014-02-27','14:55:00',2.47),('8975','2014-02-27','15:00:00',2.1),('8975','2014-02-27','15:05:00',1.34),('8975','2014-02-27','15:20:00',1.31),('8975','2014-02-27','15:25:00',2.75),('8975','2014-02-27','15:30:00',2.49),('8975','2014-02-27','15:35:00',2.47),('8975','2014-02-27','15:40:00',1.33),('8975','2014-02-27','16:10:00',1.69),('8975','2014-02-27','16:15:00',2.42),('8975','2014-02-27','16:20:00',1.86),('8975','2014-02-27','16:25:00',1.14),('8975','2014-02-27','16:35:00',1.13),('8975','2014-02-27','16:40:00',1.51),('8975','2014-02-27','16:45:00',1.67),('8975','2014-02-27','16:50:00',1.44),('8975','2014-02-26','10:30:00',1.31),('8975','2014-02-26','10:35:00',1.39),('8975','2014-02-26','10:40:00',1.58),('8975','2014-02-26','10:45:00',1.85),('8975','2014-02-26','10:50:00',1.98),('8975','2014-02-26','10:55:00',2.05),('8975','2014-02-26','11:00:00',2.37),('8975','2014-02-26','11:05:00',2.51),('8975','2014-02-26','11:10:00',2.51),('8975','2014-02-26','11:15:00',2.46),('8975','2014-02-26','11:20:00',2.31),('8975','2014-02-26','11:25:00',2.65),('8975','2014-02-26','11:30:00',2.97),('8975','2014-02-26','11:35:00',2.72),('8975','2014-02-26','11:40:00',2.36),('8975','2014-02-26','11:45:00',2.09),('8975','2014-02-26','11:50:00',2.03),('8975','2014-02-26','11:55:00',2),('8975','2014-02-26','12:00:00',1.91),('8975','2014-02-26','12:05:00',1.77),('8975','2014-02-26','12:10:00',1.45),('8975','2014-02-26','12:15:00',1.76),('8975','2014-02-26','12:20:00',1.99),('8975','2014-02-26','12:25:00',2),('8975','2014-02-26','12:30:00',1.75),('8975','2014-02-26','12:35:00',1.64),('8975','2014-02-26','12:40:00',1.66),('8975','2014-02-26','12:45:00',1.71),('8975','2014-02-26','12:50:00',1.7),('8975','2014-02-26','12:55:00',1.75),('8975','2014-02-26','13:00:00',1.84),('8975','2014-02-26','13:05:00',1.9),('8975','2014-02-26','13:10:00',2),('8975','2014-02-26','13:15:00',2.08),('8975','2014-02-26','13:20:00',2.03),('8975','2014-02-26','13:25:00',2.09),('8975','2014-02-26','13:30:00',2.33),('8975','2014-02-26','13:35:00',2.51),('8975','2014-02-26','13:40:00',2.53),('8975','2014-02-26','13:45:00',2.52),('8975','2014-02-26','13:50:00',2.82),('8975','2014-02-26','13:55:00',2.89),('8975','2014-02-26','14:00:00',2.66),('8975','2014-02-26','14:05:00',2.51),('8975','2014-02-26','14:10:00',2.22),('8975','2014-02-26','14:15:00',2.12),('8975','2014-02-26','14:20:00',2.14),('8975','2014-02-26','14:25:00',2.23),('8975','2014-02-26','14:30:00',2.34),('8975','2014-02-26','14:35:00',2.22),('8975','2014-02-26','14:40:00',2.06),('8975','2014-02-26','14:45:00',2),('8975','2014-02-26','14:50:00',1.92),('8975','2014-02-26','14:55:00',1.83),('8975','2014-02-26','15:00:00',1.83),('8975','2014-02-26','15:05:00',1.76),('8975','2014-02-26','15:10:00',1.9),('8975','2014-02-26','15:15:00',2.02),('8975','2014-02-26','15:20:00',1.98),('8975','2014-02-26','15:25:00',1.8),('8975','2014-02-26','15:30:00',1.8),('8975','2014-02-26','15:35:00',1.72),('8975','2014-02-26','15:40:00',1.44),('8975','2014-02-26','15:45:00',1.2),('8975','2014-02-26','15:50:00',1),('8975','2014-02-26','16:00:00',1.02),('8975','2014-02-26','16:35:00',1.11),('8975','2014-02-26','16:40:00',1.74),('8975','2014-02-26','16:45:00',1.45),('8975','2014-02-26','16:50:00',1.4),('8975','2014-02-26','16:55:00',1.44),('8975','2014-02-26','17:00:00',1.17),('8975','2014-02-26','17:05:00',1.07),('8975','2014-02-25','07:30:00',1),('8975','2014-02-25','07:35:00',1.08),('8975','2014-02-25','07:40:00',1.59),('8975','2014-02-25','07:45:00',1.75),('8975','2014-02-25','07:50:00',1.74),('8975','2014-02-25','07:55:00',2.08),('8975','2014-02-25','08:00:00',2.37),('8975','2014-02-25','08:05:00',2.5),('8975','2014-02-25','08:10:00',2.69),('8975','2014-02-25','08:15:00',2.81),('8975','2014-02-25','08:20:00',2.9),('8975','2014-02-25','08:25:00',2.99),('8975','2014-02-25','08:30:00',3.02),('8975','2014-02-25','08:35:00',3.2),('8975','2014-02-25','08:40:00',3.35),('8975','2014-02-25','08:45:00',3.68),('8975','2014-02-25','08:50:00',3.41),('8975','2014-02-25','08:55:00',3.53),('8975','2014-02-25','09:00:00',3.58),('8975','2014-02-25','09:05:00',3.45),('8975','2014-02-25','09:10:00',3.63),('8975','2014-02-25','09:15:00',3.33),('8975','2014-02-25','09:20:00',3.95),('8975','2014-02-25','09:25:00',4.26),('8975','2014-02-25','09:30:00',3.55),('8975','2014-02-25','09:35:00',3.39),('8975','2014-02-25','09:40:00',3.86),('8975','2014-02-25','09:45:00',2.32),('8975','2014-02-25','09:50:00',2.09),('8975','2014-02-25','09:55:00',1.89),('8975','2014-02-25','10:00:00',1.66),('8975','2014-02-25','10:05:00',1.43),('8975','2014-02-25','10:10:00',1.39),('8975','2014-02-25','10:15:00',1.48),('8975','2014-02-25','10:20:00',1.56),('8975','2014-02-25','10:25:00',1.82),('8975','2014-02-25','10:30:00',1.54),('8975','2014-02-25','10:35:00',1.33),('8975','2014-02-25','10:40:00',1.15),('8975','2014-02-25','10:50:00',1.03),('8975','2014-02-25','10:55:00',1.26),('8975','2014-02-25','11:00:00',1.54),('8975','2014-02-25','11:05:00',1.61),('8975','2014-02-25','11:10:00',1.59),('8975','2014-02-25','11:15:00',1.23),('8975','2014-02-25','11:25:00',1.01),('8975','2014-02-25','11:30:00',1.2),('8975','2014-02-25','11:35:00',1.01),('8975','2014-02-25','11:40:00',1.02),('8975','2014-02-25','11:45:00',1.37),('8975','2014-02-25','11:50:00',1.63),('8975','2014-02-25','11:55:00',1.91),('8975','2014-02-25','12:00:00',3.3),('8975','2014-02-25','12:05:00',2.56),('8975','2014-02-25','12:10:00',2.35),('8975','2014-02-25','12:15:00',1.92),('8975','2014-02-25','12:20:00',2.3),('8975','2014-02-25','12:25:00',3.21),('8975','2014-02-25','12:30:00',3.39),('8975','2014-02-25','12:35:00',5.05),('8975','2014-02-25','12:40:00',3.84),('8975','2014-02-25','12:45:00',4.76),('8975','2014-02-25','12:50:00',2.59),('8975','2014-02-25','12:55:00',4.26),('8975','2014-02-25','13:00:00',4.49),('8975','2014-02-25','13:05:00',3.83),('8975','2014-02-25','13:10:00',3.9),('8975','2014-02-25','13:15:00',3.84),('8975','2014-02-25','13:20:00',4),('8975','2014-02-25','13:25:00',4.23),('8975','2014-02-25','13:30:00',4.65),('8975','2014-02-25','13:35:00',3.81),('8975','2014-02-25','13:40:00',3.7),('8975','2014-02-25','13:45:00',4.5),('8975','2014-02-25','13:50:00',4.88),('8975','2014-02-25','13:55:00',4.24),('8975','2014-02-25','14:00:00',3.44),('8975','2014-02-25','14:05:00',1.71),('8975','2014-02-25','14:10:00',2.45),('8975','2014-02-25','14:15:00',1.84),('8975','2014-02-25','14:20:00',4.05),('8975','2014-02-25','14:25:00',2.67),('8975','2014-02-25','14:30:00',2.69),('8975','2014-02-25','14:35:00',3.38),('8975','2014-02-25','14:40:00',2.86),('8975','2014-02-25','14:45:00',2.36),('8975','2014-02-25','14:50:00',2.99),('8975','2014-02-25','14:55:00',2.68),('8975','2014-02-25','15:00:00',2.44),('8975','2014-02-25','15:05:00',2.48),('8975','2014-02-25','15:10:00',2.46),('8975','2014-02-25','15:15:00',1.99),('8975','2014-02-25','15:20:00',1.69),('8975','2014-02-25','15:25:00',1.29),('8975','2014-02-25','15:30:00',1.32),('8975','2014-02-25','15:35:00',1.62),('8975','2014-02-25','15:40:00',1.43),('8975','2014-02-25','15:45:00',1.33),('8975','2014-02-25','15:50:00',1.5),('8975','2014-02-25','15:55:00',1.64),('8975','2014-02-25','16:00:00',1.96),('8975','2014-02-25','16:05:00',1.74),('8975','2014-02-25','16:10:00',1.33),('8975','2014-02-25','16:15:00',1.07),('8975','2014-02-25','16:20:00',1.07),('8975','2014-04-28','09:45:00',1.13),('8975','2014-04-28','09:50:00',1.61),('8975','2014-04-28','09:55:00',1.93),('8975','2014-04-28','10:00:00',1.98),('8975','2014-04-28','10:05:00',3.25),('8975','2014-04-28','10:10:00',4.09),('8975','2014-04-28','10:15:00',3.82),('8975','2014-04-28','10:20:00',4.78),('8975','2014-04-28','10:25:00',6.12),('8975','2014-04-28','10:30:00',6.84),('8975','2014-04-28','10:35:00',6.73),('8975','2014-04-28','10:40:00',6.75),('8975','2014-04-28','10:45:00',6.72),('8975','2014-04-28','10:50:00',6.85),('8975','2014-04-28','10:55:00',6.76),('8975','2014-04-28','11:00:00',6.38),('8975','2014-04-28','11:05:00',5.26),('8975','2014-04-28','11:10:00',5.6),('8975','2014-04-28','11:15:00',5.86),('8975','2014-04-28','11:20:00',3.06),('8975','2014-04-28','11:25:00',1.96),('8975','2014-04-28','11:30:00',4.01),('8975','2014-04-28','11:35:00',4.58),('8975','2014-04-28','11:40:00',3.46),('8975','2014-04-28','11:45:00',3.07),('8975','2014-04-28','11:50:00',3.79),('8975','2014-04-28','11:55:00',2.75),('8975','2014-04-28','12:00:00',4.67),('8975','2014-04-28','12:05:00',3),('8975','2014-04-28','12:10:00',2.67),('8975','2014-04-28','12:15:00',2.34),('8975','2014-04-28','12:20:00',2.55),('8975','2014-04-28','12:25:00',4.51),('8975','2014-04-28','12:30:00',3.51),('8975','2014-04-28','12:35:00',3.51),('8975','2014-04-28','12:40:00',6.76),('8975','2014-04-28','12:45:00',8.62),('8975','2014-04-28','12:50:00',4.16),('8975','2014-04-28','12:55:00',4.16),('8975','2014-04-28','13:00:00',3.24),('8975','2014-04-28','13:05:00',3.53),('8975','2014-04-28','13:10:00',4.74),('8975','2014-04-28','13:15:00',4.93),('8975','2014-04-28','13:20:00',7.52),('8975','2014-04-28','13:25:00',2.5),('8975','2014-04-28','13:30:00',7.94),('8975','2014-04-28','13:35:00',5.84),('8975','2014-04-28','13:40:00',3.77),('8975','2014-04-28','13:45:00',4.23),('8975','2014-04-28','13:50:00',2.29),('8975','2014-04-28','13:55:00',2.23),('8975','2014-04-28','14:00:00',1.79),('8975','2014-04-28','14:05:00',1.09),('8975','2014-04-28','14:35:00',1.02),('8975','2014-04-28','14:40:00',1.15),('8975','2014-04-28','14:45:00',1.31),('8975','2014-04-28','14:50:00',1.23),('8975','2014-04-28','14:55:00',1.03),('8975','2014-04-28','15:00:00',1.23),('8975','2014-04-28','15:05:00',1.75),('8975','2014-04-28','15:10:00',1.88),('8975','2014-04-28','15:15:00',1.51),('8975','2014-04-28','15:20:00',1.11),('8975','2014-04-28','15:25:00',1.29),('8975','2014-04-28','15:30:00',1.01),('8975','2014-04-28','15:35:00',1.05),('8975','2014-04-28','15:40:00',1.01),('8975','2014-04-28','16:00:00',1.14),('8975','2014-04-28','16:05:00',1.34),('8975','2014-04-28','16:10:00',1.41),('8975','2014-04-28','16:15:00',1.45),('8975','2014-04-28','16:20:00',1.5),('8975','2014-04-28','16:25:00',1.56),('8975','2014-04-28','16:30:00',1.57),('8975','2014-04-28','16:35:00',1.38),('8975','2014-04-28','16:40:00',1.08),('8975','2014-04-28','16:50:00',1.03),('8975','2014-04-28','16:55:00',1.15),('8975','2014-04-28','17:00:00',1.27),('8975','2014-04-28','17:05:00',1.68),('8975','2014-04-28','17:10:00',1.74),('8975','2014-04-28','17:15:00',1.47),('8975','2014-04-28','17:20:00',1.46),('8975','2014-04-28','17:25:00',2.64),('8975','2014-04-28','17:30:00',2.06),('8975','2014-04-28','17:35:00',2.03),('8975','2014-04-28','17:40:00',2.08),('8975','2014-04-28','17:45:00',1.99),('8975','2014-04-28','17:50:00',1.53),('8975','2014-02-24','07:35:00',1.07),('8975','2014-02-24','07:40:00',1.19),('8975','2014-02-24','07:45:00',1.3),('8975','2014-02-24','07:50:00',1.41),('8975','2014-02-24','07:55:00',1.51),('8975','2014-02-24','08:00:00',1.6),('8975','2014-02-24','08:05:00',1.68),('8975','2014-02-24','08:10:00',1.75),('8975','2014-02-24','08:15:00',1.83),('8975','2014-02-24','08:20:00',1.9),('8975','2014-02-24','08:25:00',1.97),('8975','2014-02-24','08:30:00',2.02),('8975','2014-02-24','08:35:00',2.09),('8975','2014-02-24','08:40:00',2.15),('8975','2014-02-24','08:45:00',2.22),('8975','2014-02-24','08:50:00',2.29),('8975','2014-02-24','08:55:00',2.35),('8975','2014-02-24','09:00:00',2.42),('8975','2014-02-24','09:05:00',2.34),('8975','2014-02-24','09:10:00',2.4),('8975','2014-02-24','09:15:00',2.25),('8975','2014-02-24','09:20:00',2.27),('8975','2014-02-24','09:25:00',2.45),('8975','2014-02-24','09:30:00',2.32),('8975','2014-02-24','09:35:00',2.06),('8975','2014-02-24','09:40:00',2.77),('8975','2014-02-24','09:45:00',2.91),('8975','2014-02-24','09:50:00',2.91),('8975','2014-02-24','09:55:00',2.93),('8975','2014-02-24','10:00:00',3.08),('8975','2014-02-24','10:05:00',2.85),('8975','2014-02-24','10:10:00',2.88),('8975','2014-02-24','10:15:00',3.1),('8975','2014-02-24','10:20:00',2.78),('8975','2014-02-24','10:25:00',2.98),('8975','2014-02-24','10:30:00',3.09),('8975','2014-02-24','10:35:00',2.91),('8975','2014-02-24','10:40:00',3.29),('8975','2014-02-24','10:45:00',3.37),('8975','2014-02-24','10:50:00',3.39),('8975','2014-02-24','10:55:00',3.38),('8975','2014-02-24','11:00:00',3.4),('8975','2014-02-24','11:05:00',3.42),('8975','2014-02-24','11:10:00',3.45),('8975','2014-02-24','11:15:00',3.49),('8975','2014-02-24','11:20:00',3.48),('8975','2014-02-24','11:25:00',3.53),('8975','2014-02-24','11:30:00',3.53),('8975','2014-02-24','11:35:00',3.51),('8975','2014-02-24','11:40:00',3.55),('8975','2014-02-24','11:45:00',3.53),('8975','2014-02-24','11:50:00',3.54),('8975','2014-02-24','11:55:00',3.55),('8975','2014-02-24','12:00:00',3.43),('8975','2014-02-24','12:05:00',3.45),('8975','2014-02-24','12:10:00',3.37),('8975','2014-02-24','12:15:00',3.38),('8975','2014-02-24','12:20:00',3.47),('8975','2014-02-24','12:25:00',3.45),('8975','2014-02-24','12:30:00',3.41),('8975','2014-02-24','12:35:00',3.32),('8975','2014-02-24','12:40:00',3.25),('8975','2014-02-24','12:45:00',3.23),('8975','2014-02-24','12:50:00',2.38),('8975','2014-02-24','12:55:00',1.42),('8975','2014-02-24','13:00:00',2.94),('8975','2014-02-24','13:05:00',1.81),('8975','2014-02-24','13:30:00',1.27),('8975','2014-02-24','13:35:00',1.41),('8975','2014-02-24','13:40:00',1.35),('8975','2014-02-24','13:45:00',1.16),('8975','2014-02-24','13:50:00',1.28),('8975','2014-02-24','13:55:00',1.34),('8975','2014-02-24','14:00:00',1.18),('8975','2014-02-24','14:05:00',1.13),('8975','2014-02-24','14:10:00',1.11),('8975','2014-02-24','14:15:00',1.22),('8975','2014-02-24','14:20:00',1.85),('8975','2014-02-24','14:25:00',2.36),('8975','2014-02-24','14:30:00',2.15),('8975','2014-02-24','14:35:00',1.79),('8975','2014-02-24','14:40:00',2.47),('8975','2014-02-24','14:45:00',2.08),('8975','2014-02-24','14:50:00',1.55),('8975','2014-02-24','14:55:00',1.87),('8975','2014-02-24','15:00:00',1.95),('8975','2014-02-24','15:05:00',1.79),('8975','2014-02-24','15:10:00',1.77),('8975','2014-02-24','15:15:00',1.16),('8975','2014-02-24','15:20:00',1.71),('8975','2014-02-24','15:25:00',1.61),('8975','2014-02-24','15:30:00',1.38),('8975','2014-02-24','15:35:00',1.2),('8975','2014-02-24','15:40:00',1.38),('8975','2014-02-24','15:45:00',1.06),('8975','2014-02-24','16:20:00',1.01),('8975','2014-02-23','07:30:00',1.05),('8975','2014-02-23','07:35:00',1.16),('8975','2014-02-23','07:40:00',1.11),('8975','2014-02-23','07:45:00',1.26),('8975','2014-02-23','07:50:00',1.39),('8975','2014-02-23','07:55:00',1.52),('8975','2014-02-23','08:00:00',1.69),('8975','2014-02-23','08:05:00',1.94),('8975','2014-02-23','08:10:00',2.12),('8975','2014-02-23','08:15:00',2.23),('8975','2014-02-23','08:20:00',2.3),('8975','2014-02-23','08:25:00',2.39),('8975','2014-02-23','08:30:00',2.27),('8975','2014-02-23','08:35:00',2.47),('8975','2014-02-23','08:40:00',2.76),('8975','2014-02-23','08:45:00',1.76),('8975','2014-02-23','08:50:00',2.12),('8975','2014-02-23','08:55:00',2.45),('8975','2014-02-23','09:00:00',2.42),('8975','2014-02-23','09:05:00',2.43),('8975','2014-02-23','09:10:00',2.49),('8975','2014-02-23','09:15:00',2.55),('8975','2014-02-23','09:20:00',2.63),('8975','2014-02-23','09:25:00',2.67),('8975','2014-02-23','09:30:00',2.71),('8975','2014-02-23','09:35:00',2.79),('8975','2014-02-23','09:40:00',2.87),('8975','2014-02-23','09:45:00',2.94),('8975','2014-02-23','09:50:00',3),('8975','2014-02-23','09:55:00',3.08),('8975','2014-02-23','10:00:00',3.14),('8975','2014-02-23','10:05:00',3.13),('8975','2014-02-23','10:10:00',3.2),('8975','2014-02-23','10:15:00',3.25),('8975','2014-02-23','10:20:00',3.29),('8975','2014-02-23','10:25:00',3.32),('8975','2014-02-23','10:30:00',3.35),('8975','2014-02-23','10:35:00',3.41),('8975','2014-02-23','10:40:00',3.44),('8975','2014-02-23','10:45:00',3.48),('8975','2014-02-23','10:50:00',3.53),('8975','2014-02-23','10:55:00',3.55),('8975','2014-02-23','11:00:00',3.54),('8975','2014-02-23','11:05:00',3.57),('8975','2014-02-23','11:10:00',3.6),('8975','2014-02-23','11:15:00',3.6),('8975','2014-02-23','11:20:00',3.67),('8975','2014-02-23','11:25:00',3.77),('8975','2014-02-23','11:30:00',3.94),('8975','2014-02-23','11:35:00',4.28),('8975','2014-02-23','11:40:00',4.13),('8975','2014-02-23','11:45:00',3.47),('8975','2014-02-23','11:50:00',4.17),('8975','2014-02-23','11:55:00',3.72),('8975','2014-02-23','12:00:00',3.07),('8975','2014-02-23','12:05:00',3.34),('8975','2014-02-23','12:10:00',3.51),('8975','2014-02-23','12:15:00',3.76),('8975','2014-02-23','12:20:00',3.76),('8975','2014-02-23','12:25:00',3.7),('8975','2014-02-23','12:30:00',3.87),('8975','2014-02-23','12:35:00',4.01),('8975','2014-02-23','12:40:00',2.32),('8975','2014-02-23','12:45:00',3.67),('8975','2014-02-23','12:50:00',2.69),('8975','2014-02-23','12:55:00',3.56),('8975','2014-02-23','13:00:00',3.58),('8975','2014-02-23','13:05:00',3.58),('8975','2014-02-23','13:10:00',3.29),('8975','2014-02-23','13:15:00',4.03),('8975','2014-02-23','13:20:00',3.87),('8975','2014-02-23','13:25:00',1.56),('8975','2014-02-23','13:30:00',1.12),('8975','2014-02-23','13:35:00',1.01),('8975','2014-02-23','14:10:00',1.03),('8975','2014-02-23','14:15:00',1.12),('8975','2014-02-23','14:20:00',1.15),('8975','2014-02-23','14:25:00',1.17),('8975','2014-02-23','14:30:00',1.26),('8975','2014-02-23','14:35:00',1.26),('8975','2014-02-23','14:40:00',1.19),('8975','2014-02-23','14:45:00',1.2),('8975','2014-02-23','14:50:00',1.24),('8975','2014-02-23','14:55:00',1.18),('8975','2014-02-23','15:00:00',1.05),('8975','2014-02-23','15:10:00',1.06),('8975','2014-02-23','15:15:00',1.15),('8975','2014-02-23','15:20:00',1.34),('8975','2014-02-23','15:25:00',2.1),('8975','2014-02-23','15:30:00',1.87),('8975','2014-02-23','15:35:00',1.91),('8975','2014-02-23','15:40:00',1.96),('8975','2014-02-23','15:45:00',1.93),('8975','2014-02-23','15:50:00',1.85),('8975','2014-02-23','15:55:00',1.91),('8975','2014-02-23','16:00:00',1.97),('8975','2014-02-23','16:05:00',1.95),('8975','2014-02-23','16:10:00',1.88),('8975','2014-02-23','16:15:00',1.74),('8975','2014-02-23','16:20:00',1.48),('8975','2014-02-23','16:25:00',1.29),('8975','2014-02-23','16:30:00',1.02),('8975','2014-02-22','07:40:00',1.09),('8975','2014-02-22','07:45:00',1.28),('8975','2014-02-22','07:50:00',1.39),('8975','2014-02-22','07:55:00',1.48),('8975','2014-02-22','08:00:00',1.57),('8975','2014-02-22','08:05:00',1.65),('8975','2014-02-22','08:10:00',1.72),('8975','2014-02-22','08:15:00',1.79),('8975','2014-02-22','08:20:00',1.87),('8975','2014-02-22','08:25:00',1.94),('8975','2014-02-22','08:30:00',2),('8975','2014-02-22','08:35:00',2.07),('8975','2014-02-22','08:40:00',2.13),('8975','2014-02-22','08:45:00',2.2),('8975','2014-02-22','08:50:00',2.26),('8975','2014-02-22','08:55:00',2.32),('8975','2014-02-22','09:00:00',2.38),('8975','2014-02-22','09:05:00',2.46),('8975','2014-02-22','09:10:00',2.54),('8975','2014-02-22','09:15:00',2.63),('8975','2014-02-22','09:20:00',2.69),('8975','2014-02-22','09:25:00',2.54),('8975','2014-02-22','09:30:00',2.4),('8975','2014-02-22','09:35:00',2.67),('8975','2014-02-22','09:40:00',2.81),('8975','2014-02-22','09:45:00',2.89),('8975','2014-02-22','09:50:00',2.93),('8975','2014-02-22','09:55:00',2.99),('8975','2014-02-22','10:00:00',3.05),('8975','2014-02-22','10:05:00',3.08),('8975','2014-02-22','10:10:00',3.1),('8975','2014-02-22','10:15:00',3.12),('8975','2014-02-22','10:20:00',3.15),('8975','2014-02-22','10:25:00',3.23),('8975','2014-02-22','10:30:00',3.29),('8975','2014-02-22','10:35:00',3.3),('8975','2014-02-22','10:40:00',3.3),('8975','2014-02-22','10:45:00',3.36),('8975','2014-02-22','10:50:00',3.43),('8975','2014-02-22','10:55:00',3.43),('8975','2014-02-22','11:00:00',3.48),('8975','2014-02-22','11:05:00',3.52),('8975','2014-02-22','11:10:00',3.57),('8975','2014-02-22','11:15:00',3.64),('8975','2014-02-22','11:20:00',3.36),('8975','2014-02-22','11:25:00',3.62),('8975','2014-02-22','11:30:00',3.13),('8975','2014-02-22','11:35:00',3.73),('8975','2014-02-22','11:40:00',3.71),('8975','2014-02-22','11:45:00',3.82),('8975','2014-02-22','11:50:00',3.89),('8975','2014-02-22','11:55:00',3.86),('8975','2014-02-22','12:00:00',3.69),('8975','2014-02-22','12:05:00',3.82),('8975','2014-02-22','12:10:00',3.64),('8975','2014-02-22','12:15:00',3.67),('8975','2014-02-22','12:20:00',3.26),('8975','2014-02-22','12:25:00',1.32),('8975','2014-02-22','12:30:00',1.62),('8975','2014-02-22','12:35:00',2.91),('8975','2014-02-22','12:40:00',2.03),('8975','2014-02-22','12:45:00',2.62),('8975','2014-02-22','12:50:00',2.77),('8975','2014-02-22','12:55:00',2.99),('8975','2014-02-22','13:00:00',3),('8975','2014-02-22','13:05:00',3.15),('8975','2014-02-22','13:10:00',3.22),('8975','2014-02-22','13:15:00',2.96),('8975','2014-02-22','13:20:00',3.01),('8975','2014-02-22','13:25:00',2.99),('8975','2014-02-22','13:30:00',2.87),('8975','2014-02-22','13:35:00',2.63),('8975','2014-02-22','13:40:00',2.53),('8975','2014-02-22','13:45:00',2.58),('8975','2014-02-22','13:50:00',2.6),('8975','2014-02-22','13:55:00',2.33),('8975','2014-02-22','14:00:00',1.9),('8975','2014-02-22','14:05:00',2.37),('8975','2014-02-22','14:10:00',2.25),('8975','2014-02-22','14:15:00',2.48),('8975','2014-02-22','14:20:00',1.13),('8975','2014-02-22','14:25:00',2.15),('8975','2014-02-22','14:30:00',2.52),('8975','2014-02-22','14:35:00',1.52),('8975','2014-02-22','14:40:00',2.4),('8975','2014-02-22','14:45:00',2.53),('8975','2014-02-22','14:50:00',1.74),('8975','2014-02-21','09:05:00',1.51),('8975','2014-02-21','09:10:00',1.5),('8975','2014-02-21','09:25:00',1.29),('8975','2014-02-21','09:45:00',1),('8975','2014-02-21','09:50:00',1.11),('8975','2014-02-21','09:55:00',1.11),('8975','2014-02-21','10:00:00',1.97),('8975','2014-02-21','10:05:00',2.57),('8975','2014-02-21','10:10:00',3.13),('8975','2014-02-21','10:15:00',2.67),('8975','2014-02-21','10:20:00',2.17),('8975','2014-02-21','10:25:00',1.96),('8975','2014-02-21','10:30:00',2.17),('8975','2014-02-21','10:35:00',1.79),('8975','2014-02-21','10:40:00',1.57),('8975','2014-02-21','10:45:00',2.47),('8975','2014-02-21','10:50:00',2.67),('8975','2014-02-21','10:55:00',1.21),('8975','2014-02-21','12:00:00',1.06),('8975','2014-02-21','12:05:00',1.11),('8975','2014-02-21','12:10:00',1.65),('8975','2014-02-21','12:15:00',1.97),('8975','2014-02-21','12:20:00',2.39),('8975','2014-02-21','12:25:00',1.85),('8975','2014-02-21','12:30:00',1.32),('8975','2014-02-21','12:35:00',1.24),('8975','2014-02-21','12:40:00',1.47),('8975','2014-02-21','12:45:00',2.65),('8975','2014-02-21','12:50:00',2.12),('8975','2014-02-21','12:55:00',1.72),('8975','2014-02-21','13:00:00',1.61),('8975','2014-02-21','13:05:00',2.29),('8975','2014-02-21','13:10:00',3.41),('8975','2014-02-21','13:15:00',2.6),('8975','2014-02-21','13:20:00',2.03),('8975','2014-02-21','13:25:00',1.86),('8975','2014-02-21','13:30:00',2.32),('8975','2014-02-21','13:35:00',1.55),('8975','2014-02-21','13:40:00',1.37),('8975','2014-02-21','13:45:00',1.1),('8975','2014-02-21','13:50:00',2.01),('8975','2014-02-21','13:55:00',1.1),('8975','2014-02-21','14:00:00',2.71),('8975','2014-02-21','14:05:00',2.59),('8975','2014-02-21','14:10:00',1.04),('8975','2014-02-21','14:15:00',1.36),('8975','2014-02-21','14:20:00',2.73),('8975','2014-02-21','14:25:00',1.64),('8975','2014-02-21','14:30:00',2.31),('8975','2014-02-21','14:35:00',2.02),('8975','2014-02-21','14:40:00',2.07),('8975','2014-02-21','14:45:00',1.87),('8975','2014-02-21','15:00:00',1.24),('8975','2014-02-21','15:05:00',1.67),('8975','2014-02-21','15:10:00',1.05),('8975','2014-02-21','15:20:00',1.48),('8975','2014-02-21','15:40:00',1.43),('8975','2014-02-21','15:45:00',1.05),('8975','2014-02-21','16:00:00',1.12),('8975','2014-02-21','16:05:00',1.35),('8975','2014-02-21','16:10:00',1.35),('8975','2014-02-21','16:15:00',1.22),('8975','2014-02-21','16:20:00',1.2),('8975','2014-02-21','16:25:00',1.04),('8975','2014-02-21','16:30:00',1.01),('8975','2014-02-20','09:35:00',1.13),('8975','2014-02-20','09:40:00',1.24),('8975','2014-02-20','09:45:00',1.4),('8975','2014-02-20','09:50:00',1.45),('8975','2014-02-20','09:55:00',1.38),('8975','2014-02-20','10:00:00',1.57),('8975','2014-02-20','10:05:00',1.65),('8975','2014-02-20','10:10:00',1.55),('8975','2014-02-20','10:15:00',2),('8975','2014-02-20','10:20:00',2.42),('8975','2014-02-20','10:25:00',2.83),('8975','2014-02-20','10:30:00',2.37),('8975','2014-02-20','10:35:00',1.99),('8975','2014-02-20','10:40:00',1.85),('8975','2014-02-20','10:45:00',1.77),('8975','2014-02-20','10:50:00',2.53),('8975','2014-02-20','10:55:00',2.24),('8975','2014-02-20','11:00:00',2.07),('8975','2014-02-20','11:05:00',1.8),('8975','2014-02-20','11:10:00',1.85),('8975','2014-02-20','11:15:00',2),('8975','2014-02-20','11:20:00',1.89),('8975','2014-02-20','11:25:00',1.92),('8975','2014-02-20','11:30:00',1.86),('8975','2014-02-20','11:35:00',1.92),('8975','2014-02-20','11:40:00',1.99),('8975','2014-02-20','11:45:00',1.85),('8975','2014-02-20','11:50:00',1.79),('8975','2014-02-20','11:55:00',2.19),('8975','2014-02-20','12:00:00',2.62),('8975','2014-02-20','12:05:00',2.42),('8975','2014-02-20','12:10:00',2.93),('8975','2014-02-20','12:15:00',1.65),('8975','2014-02-20','12:20:00',1.46),('8975','2014-02-20','12:25:00',1.39),('8975','2014-02-20','12:30:00',1.22),('8975','2014-02-20','12:35:00',1.06),('8975','2014-02-20','14:40:00',1.03),('8975','2014-02-20','14:45:00',1.26),('8975','2014-02-20','14:50:00',1.25),('8975','2014-02-20','14:55:00',1.32),('8975','2014-02-20','15:00:00',1.57),('8975','2014-02-20','15:05:00',1.33),('8975','2014-02-20','15:10:00',1.29),('8975','2014-02-20','15:20:00',1),('8975','2014-02-20','15:30:00',1.16),('8975','2014-02-20','15:35:00',1.22),('8975','2014-02-20','15:40:00',1.21),('8975','2014-02-20','15:45:00',1.41),('8975','2014-02-20','15:50:00',1.35),('8975','2014-02-20','15:55:00',1.29),('8975','2014-02-20','16:00:00',1.25),('8975','2014-02-20','16:05:00',1.2),('8975','2014-02-20','16:10:00',1.16),('8975','2014-02-20','16:15:00',1.11),('8975','2014-02-20','16:20:00',1.06),('8975','2014-02-19','11:20:00',1.23),('8975','2014-02-19','11:25:00',1.27),('8975','2014-02-19','11:30:00',1.24),('8975','2014-02-19','11:55:00',1.02),('8975','2014-02-19','12:00:00',1.07),('8975','2014-02-19','12:20:00',1.08),('8975','2014-02-19','12:25:00',1.22),('8975','2014-02-19','12:30:00',1.15),('8975','2014-02-19','12:35:00',1.13),('8975','2014-02-19','12:40:00',1.45),('8975','2014-02-19','12:45:00',1.38),('8975','2014-02-19','12:50:00',1.2),('8975','2014-02-19','12:55:00',1.33),('8975','2014-02-19','13:00:00',1.45),('8975','2014-02-19','13:15:00',1.42),('8975','2014-02-19','13:20:00',1.1),('8975','2014-02-19','13:25:00',1.05),('8975','2014-02-19','13:30:00',1.42),('8975','2014-02-19','13:35:00',1.23),('8975','2014-02-19','13:40:00',1.04),('8975','2014-02-19','13:55:00',1.04),('8975','2014-02-19','14:00:00',1.29),('8975','2014-02-18','09:20:00',1.05),('8975','2014-02-18','09:25:00',1.19),('8975','2014-02-18','09:30:00',1.25),('8975','2014-02-18','09:35:00',1.41),('8975','2014-02-18','09:40:00',1.55),('8975','2014-02-18','09:45:00',1.72),('8975','2014-02-18','09:50:00',1.63),('8975','2014-02-18','09:55:00',1.53),('8975','2014-02-18','10:00:00',1.48),('8975','2014-02-18','10:05:00',1.49),('8975','2014-02-18','10:10:00',1.6),('8975','2014-02-18','10:15:00',1.65),('8975','2014-02-18','10:20:00',1.49),('8975','2014-02-18','10:25:00',1.56),('8975','2014-02-18','10:30:00',1.67),('8975','2014-02-18','10:35:00',1.76),('8975','2014-02-18','10:40:00',2.05),('8975','2014-02-18','10:45:00',2.16),('8975','2014-02-18','10:50:00',1.98),('8975','2014-02-18','10:55:00',1.78),('8975','2014-02-18','11:00:00',1.66),('8975','2014-02-18','11:05:00',1.82),('8975','2014-02-18','11:10:00',2.06),('8975','2014-02-18','11:15:00',1.96),('8975','2014-02-18','11:20:00',2.08),('8975','2014-02-18','11:25:00',1.98),('8975','2014-02-18','11:30:00',2.09),('8975','2014-02-18','11:35:00',2.23),('8975','2014-02-18','11:40:00',1.86),('8975','2014-02-18','11:45:00',2),('8975','2014-02-18','11:50:00',2.07),('8975','2014-02-18','11:55:00',1.7),('8975','2014-02-18','12:00:00',1.83),('8975','2014-02-18','12:05:00',1.85),('8975','2014-02-18','12:10:00',1.58),('8975','2014-02-18','12:15:00',1.45),('8975','2014-02-18','12:20:00',1.24),('8975','2014-02-18','12:25:00',1.48),('8975','2014-02-18','12:30:00',1.65),('8975','2014-02-18','12:35:00',1.22),('8975','2014-02-18','12:40:00',1.3),('8975','2014-02-18','12:45:00',1.27),('8975','2014-02-18','13:00:00',1.03),('8975','2014-02-18','13:05:00',1.03),('8975','2014-02-18','13:10:00',1.16),('8975','2014-02-18','13:15:00',1.25),('8975','2014-02-18','13:20:00',1.21),('8975','2014-02-18','13:25:00',1.56),('8975','2014-02-18','13:30:00',1.52),('8975','2014-02-18','13:35:00',1.68),('8975','2014-02-18','13:40:00',1.57),('8975','2014-02-18','13:45:00',1.92),('8975','2014-02-18','13:50:00',1.97),('8975','2014-02-18','13:55:00',1.88),('8975','2014-02-18','14:00:00',1.66),('8975','2014-02-18','14:05:00',1.89),('8975','2014-02-18','14:10:00',1.59),('8975','2014-02-18','14:15:00',1.63),('8975','2014-02-18','14:20:00',2.15),('8975','2014-02-18','14:25:00',1.73),('8975','2014-02-18','14:30:00',1.53),('8975','2014-02-18','14:35:00',1.7),('8975','2014-02-18','14:40:00',1.35),('8975','2014-02-18','14:45:00',1.45),('8975','2014-02-18','14:50:00',1.49),('8975','2014-02-18','14:55:00',1.36),('8975','2014-02-18','15:00:00',1.25),('8975','2014-02-18','15:05:00',1.36),('8975','2014-02-18','15:10:00',1.24),('8975','2014-02-18','15:15:00',1.4),('8975','2014-02-18','15:20:00',1.12),('8975','2014-02-18','15:25:00',1.26),('8975','2014-02-18','15:30:00',1.05),('8975','2014-02-18','15:45:00',1.04),('8975','2014-02-18','15:50:00',1.25),('8975','2014-02-18','15:55:00',1.02),('8975','2014-02-17','07:45:00',1.1),('8975','2014-02-17','07:50:00',1.21),('8975','2014-02-17','07:55:00',1.3),('8975','2014-02-17','08:00:00',1.39),('8975','2014-02-17','08:05:00',1.46),('8975','2014-02-17','08:10:00',1.52),('8975','2014-02-17','08:15:00',1.6),('8975','2014-02-17','08:20:00',1.67),('8975','2014-02-17','08:25:00',1.73),('8975','2014-02-17','08:30:00',1.8),('8975','2014-02-17','08:35:00',1.85),('8975','2014-02-17','08:40:00',1.91),('8975','2014-02-17','08:45:00',1.97),('8975','2014-02-17','08:50:00',1.96),('8975','2014-02-17','08:55:00',2.09),('8975','2014-02-17','09:00:00',2.14),('8975','2014-02-17','09:05:00',2.19),('8975','2014-02-17','09:10:00',2.25),('8975','2014-02-17','09:15:00',2.29),('8975','2014-02-17','09:20:00',2.35),('8975','2014-02-17','09:25:00',2.41),('8975','2014-02-17','09:30:00',2.44),('8975','2014-02-17','09:35:00',2.47),('8975','2014-02-17','09:40:00',2.53),('8975','2014-02-17','09:45:00',2.6),('8975','2014-02-17','09:50:00',2.68),('8975','2014-02-17','09:55:00',2.76),('8975','2014-02-17','10:00:00',2.81),('8975','2014-02-17','10:05:00',2.87),('8975','2014-02-17','10:10:00',2.87),('8975','2014-02-17','10:15:00',2.9),('8975','2014-02-17','10:20:00',2.92),('8975','2014-02-17','10:25:00',2.96),('8975','2014-02-17','10:30:00',2.98),('8975','2014-02-17','10:35:00',3.02),('8975','2014-02-17','10:40:00',3.05),('8975','2014-02-17','10:45:00',3.08),('8975','2014-02-17','10:50:00',3.12),('8975','2014-02-17','10:55:00',3.16),('8975','2014-02-17','11:00:00',3.08),('8975','2014-02-17','11:05:00',2.66),('8975','2014-02-17','11:10:00',2.46),('8975','2014-02-17','11:15:00',2.26),('8975','2014-02-17','11:20:00',2.95),('8975','2014-02-17','11:25:00',3.3),('8975','2014-02-17','11:30:00',2.9),('8975','2014-02-17','11:35:00',2.38),('8975','2014-02-17','11:40:00',2.35),('8975','2014-02-17','11:45:00',2.38),('8975','2014-02-17','11:50:00',1.94),('8975','2014-02-17','11:55:00',1.7),('8975','2014-02-17','12:00:00',1.72),('8975','2014-02-17','12:05:00',1.77),('8975','2014-02-17','12:10:00',2),('8975','2014-02-17','12:15:00',2.04),('8975','2014-02-17','12:20:00',2.06),('8975','2014-02-17','12:25:00',2.37),('8975','2014-02-17','12:30:00',2.4),('8975','2014-02-17','12:35:00',1.9),('8975','2014-02-17','12:40:00',1.86),('8975','2014-02-17','12:45:00',1.78),('8975','2014-02-17','12:50:00',1.85),('8975','2014-02-17','12:55:00',1.88),('8975','2014-02-17','13:00:00',1.59),('8975','2014-02-17','13:05:00',1.55),('8975','2014-02-17','13:10:00',1.74),('8975','2014-02-17','13:15:00',2.11),('8975','2014-02-17','13:20:00',2.29),('8975','2014-02-17','13:25:00',2.2),('8975','2014-02-17','13:30:00',1.51),('8975','2014-02-17','13:35:00',1.16),('8975','2014-02-17','13:40:00',1.97),('8975','2014-02-17','13:45:00',1.96),('8975','2014-02-17','13:50:00',1.64),('8975','2014-02-17','13:55:00',1.55),('8975','2014-02-17','14:00:00',2.02),('8975','2014-02-17','14:05:00',2.29),('8975','2014-02-17','14:10:00',1.46),('8975','2014-02-17','14:15:00',1.15),('8975','2014-02-17','14:20:00',1.09),('8975','2014-02-17','14:25:00',1.32),('8975','2014-02-17','14:30:00',1.54),('8975','2014-02-17','14:35:00',1.46),('8975','2014-02-17','14:40:00',1.28),('8975','2014-02-17','14:45:00',1.2),('8975','2014-02-17','14:50:00',1.14),('8975','2014-02-17','14:55:00',1.09),('8975','2014-02-17','15:00:00',1.03),('8975','2014-02-17','15:35:00',1.17),('8975','2014-02-17','15:40:00',1.37),('8975','2014-02-17','15:45:00',1.4),('8975','2014-02-17','15:50:00',1.16),('8975','2014-02-17','15:55:00',1.05),('8975','2014-02-17','16:00:00',1.05),('8975','2014-02-17','16:05:00',1.18),('8975','2014-02-16','07:55:00',1.07),('8975','2014-02-16','08:00:00',1.15),('8975','2014-02-16','08:05:00',1.22),('8975','2014-02-16','08:10:00',1.31),('8975','2014-02-16','08:15:00',1.37),('8975','2014-02-16','08:20:00',1.46),('8975','2014-02-16','08:25:00',1.54),('8975','2014-02-16','08:30:00',1.62),('8975','2014-02-16','08:35:00',1.67),('8975','2014-02-16','08:40:00',1.72),('8975','2014-02-16','08:45:00',1.78),('8975','2014-02-16','08:50:00',1.81),('8975','2014-02-16','08:55:00',1.84),('8975','2014-02-16','09:00:00',1.91),('8975','2014-02-16','09:05:00',1.97),('8975','2014-02-16','09:10:00',2.09),('8975','2014-02-16','09:15:00',2.17),('8975','2014-02-16','09:20:00',2.22),('8975','2014-02-16','09:25:00',2.28),('8975','2014-02-16','09:30:00',2.32),('8975','2014-02-16','09:35:00',2.37),('8975','2014-02-16','09:40:00',2.39),('8975','2014-02-16','09:45:00',2.44),('8975','2014-02-16','09:50:00',2.52),('8975','2014-02-16','09:55:00',2.58),('8975','2014-02-16','10:00:00',2.61),('8975','2014-02-16','10:05:00',2.67),('8975','2014-02-16','10:10:00',2.67),('8975','2014-02-16','10:15:00',2.67),('8975','2014-02-16','10:20:00',2.68),('8975','2014-02-16','10:25:00',2.69),('8975','2014-02-16','10:30:00',2.74),('8975','2014-02-16','10:35:00',2.74),('8975','2014-02-16','10:40:00',2.77),('8975','2014-02-16','10:45:00',2.8),('8975','2014-02-16','10:50:00',2.84),('8975','2014-02-16','10:55:00',2.86),('8975','2014-02-16','11:00:00',2.89),('8975','2014-02-16','11:05:00',2.95),('8975','2014-02-16','11:10:00',3.01),('8975','2014-02-16','11:15:00',3.05),('8975','2014-02-16','11:20:00',3.09),('8975','2014-02-16','11:25:00',3.12),('8975','2014-02-16','11:30:00',3.14),('8975','2014-02-16','11:35:00',3.16),('8975','2014-02-16','11:40:00',3.17),('8975','2014-02-16','11:45:00',3.14),('8975','2014-02-16','11:50:00',3.08),('8975','2014-02-16','11:55:00',3.09),('8975','2014-02-16','12:00:00',3.01),('8975','2014-02-16','12:05:00',2.83),('8975','2014-02-16','12:10:00',2.92),('8975','2014-02-16','12:15:00',2.88),('8975','2014-02-16','12:20:00',2.87),('8975','2014-02-16','12:25:00',2.89),('8975','2014-02-16','12:30:00',2.87),('8975','2014-02-16','12:35:00',2.85),('8975','2014-02-16','12:40:00',2.82),('8975','2014-02-16','12:45:00',2.79),('8975','2014-02-16','12:50:00',2.79),('8975','2014-02-16','12:55:00',2.77),('8975','2014-02-16','13:00:00',2.73),('8975','2014-02-16','13:05:00',2.63),('8975','2014-02-16','13:10:00',2.65),('8975','2014-02-16','13:15:00',2.62),('8975','2014-02-16','13:20:00',2.56),('8975','2014-02-16','13:25:00',2.6),('8975','2014-02-16','13:30:00',2.6),('8975','2014-02-16','13:35:00',2.56),('8975','2014-02-16','13:40:00',2.48),('8975','2014-02-16','13:45:00',2.36),('8975','2014-02-16','13:50:00',2.29),('8975','2014-02-16','13:55:00',2.23),('8975','2014-02-16','14:00:00',2.16),('8975','2014-02-16','14:05:00',2.25),('8975','2014-02-16','14:10:00',2.14),('8975','2014-02-16','14:15:00',2.06),('8975','2014-02-16','14:20:00',2.13),('8975','2014-02-16','14:25:00',2.04),('8975','2014-02-16','14:30:00',1.99),('8975','2014-02-16','14:35:00',1.89),('8975','2014-02-16','14:40:00',1.78),('8975','2014-02-16','14:45:00',1.89),('8975','2014-02-16','14:50:00',1.7),('8975','2014-02-16','14:55:00',1.73),('8975','2014-02-16','15:00:00',1.65),('8975','2014-02-16','15:05:00',1.61),('8975','2014-02-16','15:10:00',1.55),('8975','2014-02-16','15:15:00',1.55),('8975','2014-02-16','15:20:00',1.52),('8975','2014-02-16','15:25:00',1.42),('8975','2014-02-16','15:30:00',1.4),('8975','2014-02-16','15:35:00',1.33),('8975','2014-02-16','15:40:00',1.26),('8975','2014-02-16','15:45:00',1.25),('8975','2014-02-16','15:50:00',1.2),('8975','2014-02-16','15:55:00',1.14),('8975','2014-02-16','16:00:00',1.08),('8975','2014-02-16','16:05:00',1.06),('8975','2014-02-16','16:10:00',1.01),('8975','2014-02-15','07:45:00',1.08),('8975','2014-02-15','07:50:00',1.17),('8975','2014-02-15','07:55:00',1.22),('8975','2014-02-15','08:00:00',1.34),('8975','2014-02-15','08:05:00',1.44),('8975','2014-02-15','08:10:00',1.52),('8975','2014-02-15','08:15:00',1.6),('8975','2014-02-15','08:20:00',1.69),('8975','2014-02-15','08:25:00',1.76),('8975','2014-02-15','08:30:00',1.83),('8975','2014-02-15','08:35:00',1.9),('8975','2014-02-15','08:40:00',1.88),('8975','2014-02-15','08:45:00',2.03),('8975','2014-02-15','08:50:00',2.02),('8975','2014-02-15','08:55:00',2.02),('8975','2014-02-15','09:00:00',2.21),('8975','2014-02-15','09:05:00',2.3),('8975','2014-02-15','09:10:00',2.21),('8975','2014-02-15','09:15:00',2.04),('8975','2014-02-15','09:20:00',2.43),('8975','2014-02-15','09:25:00',2.29),('8975','2014-02-15','09:30:00',2.28),('8975','2014-02-15','09:35:00',1.78),('8975','2014-02-15','09:40:00',2.42),('8975','2014-02-15','09:45:00',2.51),('8975','2014-02-15','09:50:00',2.68),('8975','2014-02-15','09:55:00',2.61),('8975','2014-02-15','10:00:00',2.74),('8975','2014-02-15','10:05:00',2.84),('8975','2014-02-15','10:10:00',2.85),('8975','2014-02-15','10:15:00',2.9),('8975','2014-02-15','10:20:00',2.97),('8975','2014-02-15','10:25:00',3.02),('8975','2014-02-15','10:30:00',2.98),('8975','2014-02-15','10:35:00',3.18),('8975','2014-02-15','10:40:00',3.21),('8975','2014-02-15','10:45:00',3.22),('8975','2014-02-15','10:50:00',2.54),('8975','2014-02-15','10:55:00',2.81),('8975','2014-02-15','11:00:00',3.2),('8975','2014-02-15','11:05:00',3.27),('8975','2014-02-15','11:10:00',3.09),('8975','2014-02-15','11:15:00',3.31),('8975','2014-02-15','11:20:00',3.17),('8975','2014-02-15','11:25:00',3.25),('8975','2014-02-15','11:30:00',3.21),('8975','2014-02-15','11:35:00',3.18),('8975','2014-02-15','11:40:00',3.18),('8975','2014-02-15','11:45:00',2.74),('8975','2014-02-15','11:50:00',3.21),('8975','2014-02-15','11:55:00',2.77),('8975','2014-02-15','12:00:00',2.93),('8975','2014-02-15','12:05:00',2.64),('8975','2014-02-15','12:10:00',2.94),('8975','2014-02-15','12:15:00',3.06),('8975','2014-02-15','12:20:00',3.06),('8975','2014-02-15','12:25:00',3.02),('8975','2014-02-15','12:30:00',3.01),('8975','2014-02-15','12:35:00',3.01),('8975','2014-02-15','12:40:00',2.96),('8975','2014-02-15','12:45:00',2.96),('8975','2014-02-15','12:50:00',2.93),('8975','2014-02-15','12:55:00',2.87),('8975','2014-02-15','13:00:00',2.74),('8975','2014-02-15','13:05:00',2.58),('8975','2014-02-15','13:10:00',2.63),('8975','2014-02-15','13:15:00',2.64),('8975','2014-02-15','13:20:00',2.45),('8975','2014-02-15','13:25:00',2.6),('8975','2014-02-15','13:30:00',2.65),('8975','2014-02-15','13:35:00',2.6),('8975','2014-02-15','13:40:00',2.57),('8975','2014-02-15','13:45:00',2.46),('8975','2014-02-15','13:50:00',2.19),('8975','2014-02-15','13:55:00',2.33),('8975','2014-02-15','14:00:00',2.32),('8975','2014-02-15','14:05:00',2.3),('8975','2014-02-15','14:10:00',2.2),('8975','2014-02-15','14:15:00',2.15),('8975','2014-02-15','14:20:00',2.14),('8975','2014-02-15','14:25:00',2.12),('8975','2014-02-15','14:30:00',2.06),('8975','2014-02-15','14:35:00',1.91),('8975','2014-02-15','14:40:00',1.91),('8975','2014-02-15','14:45:00',1.88),('8975','2014-02-15','14:50:00',1.82),('8975','2014-02-15','14:55:00',1.75),('8975','2014-02-15','15:00:00',1.69),('8975','2014-02-15','15:05:00',1.65),('8975','2014-02-15','15:10:00',1.52),('8975','2014-02-15','15:15:00',1.51),('8975','2014-02-15','15:20:00',1.43),('8975','2014-02-15','15:25:00',1.39),('8975','2014-02-15','15:30:00',1.36),('8975','2014-02-15','15:35:00',1.27),('8975','2014-02-15','15:40:00',1.25),('8975','2014-02-15','15:45:00',1.31),('8975','2014-02-15','16:20:00',1.05),('8975','2014-02-15','16:25:00',1.34),('8975','2014-02-15','16:30:00',1.3),('8975','2014-02-15','16:35:00',1.11),('8975','2014-04-27','07:20:00',1.89),('8975','2014-04-27','07:25:00',1.47),('8975','2014-04-27','07:45:00',1.01),('8975','2014-04-27','07:50:00',1.1),('8975','2014-04-27','07:55:00',1.27),('8975','2014-04-27','08:00:00',1.52),('8975','2014-04-27','08:05:00',1.23),('8975','2014-04-27','08:10:00',1.44),('8975','2014-04-27','08:15:00',3.59),('8975','2014-04-27','08:20:00',4.43),('8975','2014-04-27','08:25:00',3.72),('8975','2014-04-27','08:30:00',2.73),('8975','2014-04-27','08:35:00',1.82),('8975','2014-04-27','08:40:00',1.79),('8975','2014-04-27','08:45:00',2.09),('8975','2014-04-27','08:50:00',3.24),('8975','2014-04-27','08:55:00',1.94),('8975','2014-04-27','09:00:00',2.53),('8975','2014-04-27','09:05:00',4.33),('8975','2014-04-27','09:10:00',3.95),('8975','2014-04-27','09:15:00',5.63),('8975','2014-04-27','09:20:00',4.61),('8975','2014-04-27','09:25:00',3.59),('8975','2014-04-27','09:30:00',3.5),('8975','2014-04-27','09:35:00',2.9),('8975','2014-04-27','09:40:00',3.19),('8975','2014-04-27','09:45:00',2.91),('8975','2014-04-27','09:50:00',2.85),('8975','2014-04-27','09:55:00',3.05),('8975','2014-04-27','10:00:00',3.66),('8975','2014-04-27','10:05:00',4.43),('8975','2014-04-27','10:10:00',4.09),('8975','2014-04-27','10:15:00',3.17),('8975','2014-04-27','10:20:00',2.78),('8975','2014-04-27','10:25:00',2.01),('8975','2014-04-27','10:35:00',1.19),('8975','2014-04-27','10:40:00',2.02),('8975','2014-04-27','10:45:00',2.62),('8975','2014-04-27','10:50:00',2.61),('8975','2014-04-27','10:55:00',2.77),('8975','2014-04-27','11:00:00',4.88),('8975','2014-04-27','11:05:00',4.46),('8975','2014-04-27','11:10:00',4.19),('8975','2014-04-27','11:15:00',4),('8975','2014-04-27','11:20:00',3.18),('8975','2014-04-27','11:25:00',3.38),('8975','2014-04-27','11:30:00',3.51),('8975','2014-04-27','11:35:00',2.81),('8975','2014-04-27','11:40:00',2.11),('8975','2014-04-27','11:45:00',2.18),('8975','2014-04-27','11:50:00',2.21),('8975','2014-04-27','11:55:00',2.52),('8975','2014-04-27','12:00:00',2.76),('8975','2014-04-27','12:05:00',2.69),('8975','2014-04-27','12:10:00',3.43),('8975','2014-04-27','12:15:00',4),('8975','2014-04-27','12:20:00',4.3),('8975','2014-04-27','12:25:00',4.89),('8975','2014-04-27','12:30:00',4.51),('8975','2014-04-27','12:35:00',3.92),('8975','2014-04-27','12:40:00',3.4),('8975','2014-04-27','12:45:00',3.4),('8975','2014-04-27','12:50:00',3.56),('8975','2014-04-27','12:55:00',3.39),('8975','2014-04-27','13:00:00',3.47),('8975','2014-04-27','13:05:00',3.58),('8975','2014-04-27','13:10:00',4.21),('8975','2014-04-27','13:15:00',3.56),('8975','2014-04-27','13:20:00',4.03),('8975','2014-04-27','13:25:00',4.7),('8975','2014-04-27','13:30:00',6.21),('8975','2014-04-27','13:35:00',6.95),('8975','2014-04-27','13:40:00',5.29),('8975','2014-04-27','13:45:00',4.93),('8975','2014-04-27','13:50:00',5.27),('8975','2014-04-27','13:55:00',7.07),('8975','2014-04-27','14:00:00',5.61),('8975','2014-04-27','14:05:00',7.69),('8975','2014-04-27','14:10:00',5.52),('8975','2014-04-27','14:15:00',5.64),('8975','2014-04-27','14:20:00',4.2),('8975','2014-04-27','14:25:00',2.83),('8975','2014-04-27','14:30:00',3.17),('8975','2014-04-27','14:35:00',3.47),('8975','2014-04-27','14:40:00',5.61),('8975','2014-04-27','14:45:00',5.28),('8975','2014-04-27','14:50:00',5.33),('8975','2014-04-27','14:55:00',4.73),('8975','2014-04-27','15:00:00',4.71),('8975','2014-04-27','15:05:00',5.13),('8975','2014-04-27','15:10:00',3.93),('8975','2014-04-27','15:15:00',2.8),('8975','2014-04-27','15:20:00',4.77),('8975','2014-04-27','15:25:00',2.96),('8975','2014-04-27','15:30:00',2.41),('8975','2014-04-27','15:35:00',3.51),('8975','2014-04-27','15:40:00',4.88),('8975','2014-04-27','15:45:00',5.33),('8975','2014-04-27','15:50:00',3.3),('8975','2014-04-27','15:55:00',3.34),('8975','2014-04-27','16:00:00',3.4),('8975','2014-04-27','16:05:00',4.55),('8975','2014-04-27','16:10:00',4.45),('8975','2014-04-27','16:15:00',3.46),('8975','2014-04-27','16:20:00',2.7),('8975','2014-04-27','16:25:00',3.15),('8975','2014-04-27','16:30:00',3.08),('8975','2014-04-27','16:35:00',2.11),('8975','2014-04-27','16:40:00',1.05),('8975','2014-04-27','16:45:00',1.02),('8975','2014-04-27','17:20:00',1.49),('8975','2014-04-27','17:25:00',1.45),('8975','2014-04-27','17:30:00',2.31),('8975','2014-04-27','17:35:00',1.99),('8975','2014-04-27','17:40:00',1.33),('8975','2014-02-14','07:50:00',1.06),('8975','2014-02-14','07:55:00',1.17),('8975','2014-02-14','08:00:00',1.26),('8975','2014-02-14','08:05:00',1.34),('8975','2014-02-14','08:10:00',1.42),('8975','2014-02-14','08:15:00',1.48),('8975','2014-02-14','08:20:00',1.55),('8975','2014-02-14','08:25:00',1.63),('8975','2014-02-14','08:30:00',1.7),('8975','2014-02-14','08:35:00',1.76),('8975','2014-02-14','08:40:00',1.81),('8975','2014-02-14','08:45:00',1.88),('8975','2014-02-14','08:50:00',1.88),('8975','2014-02-14','08:55:00',1.85),('8975','2014-02-14','09:00:00',2.05),('8975','2014-02-14','09:05:00',2.12),('8975','2014-02-14','09:10:00',2.18),('8975','2014-02-14','09:15:00',2.21),('8975','2014-02-14','09:20:00',2.27),('8975','2014-02-14','09:25:00',2.33),('8975','2014-02-14','09:30:00',2.39),('8975','2014-02-14','09:35:00',2.39),('8975','2014-02-14','09:40:00',2.41),('8975','2014-02-14','09:45:00',2.5),('8975','2014-02-14','09:50:00',2.56),('8975','2014-02-14','09:55:00',2.64),('8975','2014-02-14','10:00:00',2.7),('8975','2014-02-14','10:05:00',2.75),('8975','2014-02-14','10:10:00',2.77),('8975','2014-02-14','10:15:00',2.77),('8975','2014-02-14','10:20:00',2.8),('8975','2014-02-14','10:25:00',2.81),('8975','2014-02-14','10:30:00',2.82),('8975','2014-02-14','10:35:00',2.89),('8975','2014-02-14','10:40:00',2.92),('8975','2014-02-14','10:45:00',2.99),('8975','2014-02-14','10:50:00',3.06),('8975','2014-02-14','10:55:00',2.64),('8975','2014-02-14','11:00:00',3.3),('8975','2014-02-14','11:05:00',3.36),('8975','2014-02-14','11:10:00',3.47),('8975','2014-02-14','11:15:00',3.72),('8975','2014-02-14','11:20:00',3.15),('8975','2014-02-14','11:25:00',2.69),('8975','2014-02-14','11:30:00',1.56),('8975','2014-02-14','11:35:00',3.39),('8975','2014-02-14','11:40:00',2.6),('8975','2014-02-14','11:45:00',3.26),('8975','2014-02-14','11:50:00',3.4),('8975','2014-02-14','11:55:00',3.21),('8975','2014-02-14','12:00:00',3.58),('8975','2014-02-14','12:05:00',3.04),('8975','2014-02-14','12:10:00',3.19),('8975','2014-02-14','12:15:00',3.11),('8975','2014-02-14','12:20:00',1.17),('8975','2014-02-14','12:25:00',3.16),('8975','2014-02-14','12:30:00',3.19),('8975','2014-02-14','12:35:00',3.02),('8975','2014-02-14','12:40:00',3.19),('8975','2014-02-14','12:45:00',3.02),('8975','2014-02-14','12:50:00',2.47),('8975','2014-02-14','12:55:00',3.2),('8975','2014-02-14','13:00:00',2.83),('8975','2014-02-14','13:05:00',2.28),('8975','2014-02-14','13:10:00',2.64),('8975','2014-02-14','13:15:00',2.6),('8975','2014-02-14','13:20:00',2.55),('8975','2014-02-14','13:25:00',2.36),('8975','2014-02-14','13:30:00',2.61),('8975','2014-02-14','13:35:00',2.53),('8975','2014-02-14','13:40:00',2.46),('8975','2014-02-14','13:45:00',2.33),('8975','2014-02-14','13:50:00',1.81),('8975','2014-02-14','13:55:00',2.24),('8975','2014-02-14','14:00:00',2.26),('8975','2014-02-14','14:05:00',2.21),('8975','2014-02-14','14:10:00',2.19),('8975','2014-02-14','14:15:00',2.09),('8975','2014-02-14','14:20:00',2.07),('8975','2014-02-14','14:25:00',2.03),('8975','2014-02-14','14:30:00',1.97),('8975','2014-02-14','14:35:00',1.88),('8975','2014-02-14','14:40:00',1.88),('8975','2014-02-14','14:45:00',1.79),('8975','2014-02-14','14:50:00',1.75),('8975','2014-02-14','14:55:00',1.65),('8975','2014-02-14','15:00:00',1.59),('8975','2014-02-14','15:05:00',1.56),('8975','2014-02-14','15:10:00',1.52),('8975','2014-02-14','15:15:00',1.46),('8975','2014-02-14','15:20:00',1.43),('8975','2014-02-14','15:25:00',1.39),('8975','2014-02-14','15:30:00',1.35),('8975','2014-02-14','15:35:00',1.32),('8975','2014-02-14','15:40:00',1.27),('8975','2014-02-14','15:45:00',1.23),('8975','2014-02-14','15:50:00',1.2),('8975','2014-02-14','15:55:00',1.16),('8975','2014-02-14','16:00:00',1.13),('8975','2014-02-14','16:05:00',1.08),('8975','2014-02-14','16:10:00',1.06),('8975','2014-02-13','08:40:00',1.19),('8975','2014-02-13','08:45:00',1.76),('8975','2014-02-13','08:50:00',1.91),('8975','2014-02-13','08:55:00',1.96),('8975','2014-02-13','09:00:00',2.02),('8975','2014-02-13','09:05:00',1.97),('8975','2014-02-13','09:10:00',1.58),('8975','2014-02-13','09:15:00',1.1),('8975','2014-02-13','09:20:00',1.85),('8975','2014-02-13','09:25:00',2.56),('8975','2014-02-13','09:30:00',1.64),('8975','2014-02-13','09:35:00',2.09),('8975','2014-02-13','09:40:00',1.83),('8975','2014-02-13','09:45:00',1.82),('8975','2014-02-13','09:50:00',2.62),('8975','2014-02-13','09:55:00',2.82),('8975','2014-02-13','10:00:00',2.88),('8975','2014-02-13','10:05:00',2.9),('8975','2014-02-13','10:10:00',2.79),('8975','2014-02-13','10:15:00',2.85),('8975','2014-02-13','10:20:00',2.9),('8975','2014-02-13','10:25:00',2.98),('8975','2014-02-13','10:30:00',2.98),('8975','2014-02-13','10:35:00',3),('8975','2014-02-13','10:40:00',3.02),('8975','2014-02-13','10:45:00',3.13),('8975','2014-02-13','10:50:00',3.16),('8975','2014-02-13','10:55:00',3.19),('8975','2014-02-13','11:00:00',3.24),('8975','2014-02-13','11:05:00',3.23),('8975','2014-02-13','11:10:00',3.24),('8975','2014-02-13','11:15:00',3.25),('8975','2014-02-13','11:20:00',3.26),('8975','2014-02-13','11:25:00',3.27),('8975','2014-02-13','11:30:00',3.28),('8975','2014-02-13','11:35:00',3.31),('8975','2014-02-13','11:40:00',3.3),('8975','2014-02-13','11:45:00',3.31),('8975','2014-02-13','11:50:00',3.32),('8975','2014-02-13','11:55:00',3.18),('8975','2014-02-13','12:00:00',3.26),('8975','2014-02-13','12:05:00',3.25),('8975','2014-02-13','12:10:00',3.2),('8975','2014-02-13','12:15:00',3.1),('8975','2014-02-13','12:20:00',3.15),('8975','2014-02-13','12:25:00',3.12),('8975','2014-02-13','12:30:00',3.09),('8975','2014-02-13','12:35:00',3.08),('8975','2014-02-13','12:40:00',3.05),('8975','2014-02-13','12:45:00',2.97),('8975','2014-02-13','12:50:00',2.95),('8975','2014-02-13','12:55:00',2.91),('8975','2014-02-13','13:00:00',2.78),('8975','2014-02-13','13:05:00',2.83),('8975','2014-02-13','13:10:00',2.77),('8975','2014-02-13','13:15:00',2.59),('8975','2014-02-13','13:20:00',2.76),('8975','2014-02-13','13:25:00',2.68),('8975','2014-02-13','13:30:00',2.67),('8975','2014-02-13','13:35:00',2.62),('8975','2014-02-13','13:40:00',2.54),('8975','2014-02-13','13:45:00',2.47),('8975','2014-02-13','13:50:00',2.37),('8975','2014-02-13','13:55:00',2.24),('8975','2014-02-13','14:00:00',2.27),('8975','2014-02-13','14:05:00',2.25),('8975','2014-02-13','14:10:00',2.23),('8975','2014-02-13','14:15:00',2.16),('8975','2014-02-13','14:20:00',2.11),('8975','2014-02-13','14:25:00',2.09),('8975','2014-02-13','14:30:00',2.02),('8975','2014-02-13','14:35:00',1.97),('8975','2014-02-13','14:40:00',1.9),('8975','2014-02-13','14:45:00',1.8),('8975','2014-02-13','14:50:00',1.76),('8975','2014-02-13','14:55:00',1.72),('8975','2014-02-13','15:00:00',1.65),('8975','2014-02-13','15:05:00',1.6),('8975','2014-02-13','15:10:00',1.55),('8975','2014-02-13','15:15:00',1.5),('8975','2014-02-13','15:20:00',1.45),('8975','2014-02-13','15:25:00',1.4),('8975','2014-02-13','15:30:00',1.36),('8975','2014-02-13','15:35:00',1.25),('8975','2014-02-13','15:40:00',1.13),('8975','2014-02-13','15:55:00',1.1),('8975','2014-02-13','16:05:00',1.06),('8975','2014-02-12','07:50:00',1.03),('8975','2014-02-12','07:55:00',1.13),('8975','2014-02-12','08:00:00',1.23),('8975','2014-02-12','08:05:00',1.33),('8975','2014-02-12','08:10:00',1.39),('8975','2014-02-12','08:15:00',1.37),('8975','2014-02-12','08:20:00',1.53),('8975','2014-02-12','08:25:00',1.43),('8975','2014-02-12','08:30:00',1.37),('8975','2014-02-12','08:35:00',1.65),('8975','2014-02-12','08:40:00',1.62),('8975','2014-02-12','08:45:00',1.78),('8975','2014-02-12','08:50:00',1.77),('8975','2014-02-12','08:55:00',1.94),('8975','2014-02-12','09:00:00',1.63),('8975','2014-02-12','09:05:00',1.2),('8975','2014-02-12','09:10:00',1.89),('8975','2014-02-12','09:15:00',2.11),('8975','2014-02-12','09:20:00',2.06),('8975','2014-02-12','09:25:00',2.13),('8975','2014-02-12','09:30:00',2.08),('8975','2014-02-12','09:35:00',2.4),('8975','2014-02-12','09:40:00',2.07),('8975','2014-02-12','09:45:00',2.26),('8975','2014-02-12','09:50:00',2.5),('8975','2014-02-12','09:55:00',2.62),('8975','2014-02-12','10:00:00',2.73),('8975','2014-02-12','10:05:00',2.79),('8975','2014-02-12','10:10:00',2.78),('8975','2014-02-12','10:15:00',2.77),('8975','2014-02-12','10:20:00',2.78),('8975','2014-02-12','10:25:00',2.84),('8975','2014-02-12','10:30:00',2.87),('8975','2014-02-12','10:35:00',2.92),('8975','2014-02-12','10:40:00',2.93),('8975','2014-02-12','10:45:00',2.97),('8975','2014-02-12','10:50:00',3.02),('8975','2014-02-12','10:55:00',3.03),('8975','2014-02-12','11:00:00',3.08),('8975','2014-02-12','11:05:00',3.09),('8975','2014-02-12','11:10:00',3.1),('8975','2014-02-12','11:15:00',3.12),('8975','2014-02-12','11:20:00',2.97),('8975','2014-02-12','11:25:00',3.19),('8975','2014-02-12','11:30:00',2.81),('8975','2014-02-12','11:35:00',2.13),('8975','2014-02-12','11:40:00',2.8),('8975','2014-02-12','11:45:00',3.41),('8975','2014-02-12','11:50:00',3.64),('8975','2014-02-12','11:55:00',3.62),('8975','2014-02-12','12:00:00',3.44),('8975','2014-02-12','12:05:00',2.94),('8975','2014-02-12','12:10:00',2.47),('8975','2014-02-12','12:15:00',3.25),('8975','2014-02-12','12:20:00',3.68),('8975','2014-02-12','12:25:00',3.51),('8975','2014-02-12','12:30:00',2.43),('8975','2014-02-12','12:35:00',2.14),('8975','2014-02-12','12:40:00',3.3),('8975','2014-02-12','12:45:00',2.99),('8975','2014-02-12','12:50:00',2.94),('8975','2014-02-12','12:55:00',3.08),('8975','2014-02-12','13:00:00',3.04),('8975','2014-02-12','13:05:00',2.9),('8975','2014-02-12','13:10:00',2.76),('8975','2014-02-12','13:15:00',2.68),('8975','2014-02-12','13:20:00',2.77),('8975','2014-02-12','13:25:00',2.73),('8975','2014-02-12','13:30:00',2.69),('8975','2014-02-12','13:35:00',2.64),('8975','2014-02-12','13:40:00',2.55),('8975','2014-02-12','13:45:00',2.31),('8975','2014-02-12','13:50:00',2.36),('8975','2014-02-12','13:55:00',2.32),('8975','2014-02-12','14:00:00',2.27),('8975','2014-02-12','14:05:00',2.24),('8975','2014-02-12','14:10:00',2.21),('8975','2014-02-12','14:15:00',2.16),('8975','2014-02-12','14:20:00',2.15),('8975','2014-02-12','14:25:00',2.09),('8975','2014-02-12','14:30:00',2.05),('8975','2014-02-12','14:35:00',2),('8975','2014-02-12','14:40:00',1.99),('8975','2014-02-12','14:45:00',1.82),('8975','2014-02-12','14:50:00',1.63),('8975','2014-02-12','14:55:00',1.06),('8975','2014-02-12','15:00:00',1.46),('8975','2014-02-12','15:05:00',1.77),('8975','2014-02-12','15:10:00',1.64),('8975','2014-02-12','15:15:00',1.58),('8975','2014-02-12','15:20:00',1.3),('8975','2014-02-12','15:25:00',1.51),('8975','2014-02-12','15:30:00',1.56),('8975','2014-02-12','15:35:00',1.22),('8975','2014-02-12','15:40:00',1.21),('8975','2014-02-11','08:45:00',1.86),('8975','2014-02-11','08:50:00',1.96),('8975','2014-02-11','08:55:00',1.85),('8975','2014-02-11','09:00:00',2.2),('8975','2014-02-11','09:05:00',2.02),('8975','2014-02-11','09:10:00',2.26),('8975','2014-02-11','09:15:00',2.22),('8975','2014-02-11','09:20:00',1.97),('8975','2014-02-11','09:25:00',1.97),('8975','2014-02-11','09:30:00',2.59),('8975','2014-02-11','09:35:00',2.57),('8975','2014-02-11','09:40:00',1.93),('8975','2014-02-11','09:45:00',2.01),('8975','2014-02-11','09:50:00',2.81),('8975','2014-02-11','09:55:00',1.43),('8975','2014-02-11','10:00:00',1.34),('8975','2014-02-11','10:05:00',2.29),('8975','2014-02-11','10:10:00',1.59),('8975','2014-02-11','10:15:00',1.41),('8975','2014-02-11','10:20:00',1.41),('8975','2014-02-11','10:25:00',2.17),('8975','2014-02-11','10:30:00',3.6),('8975','2014-02-11','10:35:00',2.87),('8975','2014-02-11','10:40:00',1.65),('8975','2014-02-11','10:45:00',2.18),('8975','2014-02-11','10:50:00',2.13),('8975','2014-02-11','10:55:00',1.71),('8975','2014-02-11','11:00:00',1.88),('8975','2014-02-11','11:05:00',1.84),('8975','2014-02-11','11:10:00',1.63),('8975','2014-02-11','11:15:00',1.68),('8975','2014-02-11','11:20:00',1.52),('8975','2014-02-11','11:25:00',1.67),('8975','2014-02-11','11:30:00',1.74),('8975','2014-02-11','11:35:00',1.46),('8975','2014-02-11','11:40:00',1.27),('8975','2014-02-11','11:45:00',1.19),('8975','2014-02-11','11:50:00',1.07),('8975','2014-02-11','12:05:00',1.19),('8975','2014-02-11','12:10:00',1.41),('8975','2014-02-11','12:15:00',1.58),('8975','2014-02-11','12:20:00',1.6),('8975','2014-02-11','12:25:00',1.65),('8975','2014-02-11','12:30:00',1.69),('8975','2014-02-11','12:35:00',1.62),('8975','2014-02-11','12:40:00',1.62),('8975','2014-02-11','12:45:00',1.82),('8975','2014-02-11','12:50:00',1.97),('8975','2014-02-11','12:55:00',1.86),('8975','2014-02-11','13:00:00',1.74),('8975','2014-02-11','13:05:00',1.56),('8975','2014-02-11','13:10:00',1.49),('8975','2014-02-11','13:15:00',1.42),('8975','2014-02-11','13:20:00',1.45),('8975','2014-02-11','13:25:00',2.14),('8975','2014-02-11','13:30:00',2.8),('8975','2014-02-11','13:35:00',3.23),('8975','2014-02-11','13:40:00',2.89),('8975','2014-02-11','13:45:00',2.05),('8975','2014-02-11','13:50:00',2.05),('8975','2014-02-11','13:55:00',2.04),('8975','2014-02-11','14:00:00',2.55),('8975','2014-02-11','14:05:00',2.63),('8975','2014-02-11','14:10:00',2.52),('8975','2014-02-11','14:15:00',2.22),('8975','2014-02-11','14:20:00',2.13),('8975','2014-02-11','14:25:00',2.18),('8975','2014-02-11','14:30:00',2.07),('8975','2014-02-11','14:35:00',2.22),('8975','2014-02-11','14:40:00',2.18),('8975','2014-02-11','14:45:00',1.67),('8975','2014-02-11','14:50:00',1.79),('8975','2014-02-11','14:55:00',1.41),('8975','2014-02-11','15:00:00',1.2),('8975','2014-02-11','15:05:00',1.5),('8975','2014-02-11','15:10:00',1.59),('8975','2014-02-11','15:15:00',1.55),('8975','2014-02-11','15:20:00',1.01),('8975','2014-02-11','15:25:00',1.14),('8975','2014-02-11','15:30:00',1.23),('8975','2014-02-11','15:35:00',1.59),('8975','2014-02-11','15:40:00',1.06),('8975','2014-02-10','09:20:00',1.4),('8975','2014-02-10','09:25:00',1.47),('8975','2014-02-10','09:30:00',1.4),('8975','2014-02-10','09:35:00',1.47),('8975','2014-02-10','09:40:00',1.39),('8975','2014-02-10','09:45:00',1.39),('8975','2014-02-10','09:50:00',1.51),('8975','2014-02-10','09:55:00',1.51),('8975','2014-02-10','10:00:00',1.3),('8975','2014-02-10','10:05:00',1.49),('8975','2014-02-10','10:10:00',1.64),('8975','2014-02-10','10:15:00',1.9),('8975','2014-02-10','10:20:00',2.08),('8975','2014-02-10','10:25:00',2.09),('8975','2014-02-10','10:30:00',2.3),('8975','2014-02-10','10:35:00',2.59),('8975','2014-02-10','10:40:00',2.6),('8975','2014-02-10','10:45:00',2.42),('8975','2014-02-10','10:50:00',2.21),('8975','2014-02-10','10:55:00',1.65),('8975','2014-02-10','11:00:00',1.65),('8975','2014-02-10','11:05:00',1.91),('8975','2014-02-10','11:10:00',2.45),('8975','2014-02-10','11:15:00',2.55),('8975','2014-02-10','11:20:00',2.48),('8975','2014-02-10','11:25:00',2.13),('8975','2014-02-10','11:30:00',1.77),('8975','2014-02-10','11:35:00',1.61),('8975','2014-02-10','11:40:00',1.47),('8975','2014-02-10','11:45:00',1.73),('8975','2014-02-10','11:50:00',1.89),('8975','2014-02-10','11:55:00',1.59),('8975','2014-02-10','12:00:00',1.53),('8975','2014-02-10','12:05:00',1.88),('8975','2014-02-10','12:10:00',1.79),('8975','2014-02-10','12:15:00',1.7),('8975','2014-02-10','12:20:00',1.92),('8975','2014-02-10','12:25:00',2.35),('8975','2014-02-10','12:30:00',2.22),('8975','2014-02-10','12:35:00',1.97),('8975','2014-02-10','12:40:00',1.64),('8975','2014-02-10','12:45:00',1.84),('8975','2014-02-10','12:50:00',1.55),('8975','2014-02-10','12:55:00',1.92),('8975','2014-02-10','13:00:00',1.89),('8975','2014-02-10','13:05:00',2.35),('8975','2014-02-10','13:10:00',2.6),('8975','2014-02-10','13:15:00',2.56),('8975','2014-02-10','13:20:00',2.77),('8975','2014-02-10','13:25:00',2.5),('8975','2014-02-10','13:30:00',2.28),('8975','2014-02-10','13:35:00',2.16),('8975','2014-02-10','13:40:00',2.63),('8975','2014-02-10','13:45:00',1.79),('8975','2014-02-10','13:50:00',1.63),('8975','2014-02-10','13:55:00',1.51),('8975','2014-02-10','14:00:00',1.94),('8975','2014-02-10','14:05:00',1.86),('8975','2014-02-10','14:10:00',1.79),('8975','2014-02-10','14:15:00',1.89),('8975','2014-02-10','14:20:00',1.5),('8975','2014-02-10','14:25:00',1.39),('8975','2014-02-10','14:30:00',1.49),('8975','2014-02-10','14:35:00',1.41),('8975','2014-02-10','14:40:00',1.23),('8975','2014-02-10','14:45:00',1.2),('8975','2014-02-10','14:50:00',1.02),('8975','2014-02-10','14:55:00',1.05),('8975','2014-02-10','15:00:00',1),('8975','2014-02-10','15:05:00',1.04),('8975','2014-02-10','15:10:00',1.1),('8975','2014-02-10','15:15:00',1.36),('8975','2014-02-10','15:20:00',1.41),('8975','2014-02-10','15:25:00',1.11),('8975','2014-02-10','16:05:00',1.05),('8975','2014-02-09','12:55:00',1.17),('8975','2014-02-09','13:00:00',1.43),('8975','2014-02-09','13:05:00',1.17),('8975','2014-02-09','13:35:00',1.02),('8975','2014-02-09','13:40:00',1.01),('8975','2014-02-09','13:55:00',1.14),('8975','2014-02-09','14:00:00',1.14),('8975','2014-02-09','14:20:00',1.02),('8975','2014-02-09','14:25:00',1.07),('8975','2014-02-09','14:30:00',1.17),('8975','2014-02-09','14:35:00',1.23),('8975','2014-02-09','14:40:00',1.24),('8975','2014-02-09','14:45:00',1.11),('8975','2014-02-08','11:05:00',1.05),('8975','2014-02-08','11:25:00',1.12),('8975','2014-02-08','11:30:00',1.21),('8975','2014-02-08','11:35:00',1.45),('8975','2014-02-08','12:25:00',2.47),('8975','2014-02-08','12:30:00',2.25),('8975','2014-02-08','12:35:00',1.88),('8975','2014-02-08','12:40:00',1.65),('8975','2014-02-08','12:45:00',2.92),('8975','2014-02-08','12:50:00',1.35),('8975','2014-02-08','12:55:00',1.59),('8975','2014-02-08','13:00:00',2.47),('8975','2014-02-08','13:05:00',2.43),('8975','2014-02-08','13:10:00',1.68),('8975','2014-02-08','13:15:00',1.38),('8975','2014-02-08','13:25:00',1.08),('8975','2014-02-08','13:40:00',1.04),('8975','2014-02-08','13:45:00',1.48),('8975','2014-02-08','13:55:00',1.1),('8975','2014-02-08','14:00:00',1.79),('8975','2014-02-08','14:05:00',1.59),('8975','2014-02-08','14:10:00',1.85),('8975','2014-02-08','14:15:00',1.07),('8975','2014-02-08','14:25:00',1.17),('8975','2014-02-08','14:30:00',1.23),('8975','2014-02-08','14:40:00',1.67),('8975','2014-02-08','14:45:00',1.27),('8975','2014-02-08','14:50:00',1.27),('8975','2014-02-08','15:00:00',1.13),('8975','2014-02-08','15:10:00',1.26),('8975','2014-02-08','15:15:00',1.6),('8975','2014-02-08','15:20:00',1.14),('8975','2014-02-08','15:45:00',1.02),('8975','2014-02-07','09:50:00',1.36),('8975','2014-02-07','10:05:00',1.28),('8975','2014-02-07','10:15:00',1.34),('8975','2014-02-07','10:20:00',1.27),('8975','2014-02-07','10:25:00',1.48),('8975','2014-02-07','10:30:00',2.47),('8975','2014-02-07','10:35:00',2.17),('8975','2014-02-07','10:45:00',1.57),('8975','2014-02-07','10:50:00',1.7),('8975','2014-02-07','10:55:00',2.83),('8975','2014-02-07','11:00:00',2.21),('8975','2014-02-07','11:05:00',2.47),('8975','2014-02-07','11:10:00',1),('8975','2014-02-07','11:15:00',2.25),('8975','2014-02-07','11:20:00',1.05),('8975','2014-02-07','11:30:00',1.45),('8975','2014-02-07','11:35:00',2.13),('8975','2014-02-07','11:40:00',1.71),('8975','2014-02-07','11:45:00',1.05),('8975','2014-02-07','11:50:00',1.4),('8975','2014-02-07','11:55:00',3.05),('8975','2014-02-07','12:00:00',2.27),('8975','2014-02-07','12:05:00',1.11),('8975','2014-02-07','12:10:00',1.22),('8975','2014-02-07','12:15:00',2.36),('8975','2014-02-07','12:20:00',1.59),('8975','2014-02-07','12:25:00',1.22),('8975','2014-02-07','12:30:00',2.42),('8975','2014-02-07','12:35:00',2.32),('8975','2014-02-07','12:40:00',2.66),('8975','2014-02-07','12:45:00',3.26),('8975','2014-02-07','12:50:00',3.17),('8975','2014-02-07','12:55:00',1.53),('8975','2014-02-07','13:00:00',1.94),('8975','2014-02-07','13:05:00',2.15),('8975','2014-02-07','13:10:00',1.13),('8975','2014-02-07','13:15:00',2.84),('8975','2014-02-07','13:20:00',1.08),('8975','2014-02-07','13:25:00',2.8),('8975','2014-02-07','13:30:00',1.9),('8975','2014-02-07','13:35:00',2.48),('8975','2014-02-07','13:40:00',1.16),('8975','2014-02-07','13:45:00',2.27),('8975','2014-02-07','13:50:00',1.86),('8975','2014-02-07','13:55:00',2.09),('8975','2014-02-07','14:00:00',2.27),('8975','2014-02-07','14:05:00',1.81),('8975','2014-02-07','14:15:00',2.3),('8975','2014-02-07','14:20:00',2.22),('8975','2014-02-07','14:25:00',2.04),('8975','2014-02-07','14:30:00',2.05),('8975','2014-02-07','14:35:00',2.24),('8975','2014-02-07','14:40:00',1.59),('8975','2014-02-07','14:45:00',2.04),('8975','2014-02-07','14:50:00',1.25),('8975','2014-02-07','14:55:00',1.42),('8975','2014-02-07','15:10:00',1.33),('8975','2014-02-07','15:15:00',1.84),('8975','2014-02-07','15:20:00',1.48),('8975','2014-02-07','15:35:00',1.87),('8975','2014-02-07','15:40:00',1.64),('8975','2014-02-07','15:55:00',1.15),('8975','2014-02-06','08:05:00',1.05),('8975','2014-02-06','08:15:00',1.27),('8975','2014-02-06','08:20:00',1.37),('8975','2014-02-06','08:25:00',1.45),('8975','2014-02-06','08:30:00',1.55),('8975','2014-02-06','08:35:00',1.61),('8975','2014-02-06','08:40:00',1.68),('8975','2014-02-06','08:45:00',1.73),('8975','2014-02-06','08:50:00',1.79),('8975','2014-02-06','08:55:00',1.85),('8975','2014-02-06','09:00:00',1.9),('8975','2014-02-06','09:05:00',1.96),('8975','2014-02-06','09:10:00',2),('8975','2014-02-06','09:15:00',2.05),('8975','2014-02-06','09:20:00',2.11),('8975','2014-02-06','09:25:00',2.16),('8975','2014-02-06','09:30:00',2.18),('8975','2014-02-06','09:35:00',2.22),('8975','2014-02-06','09:40:00',2.24),('8975','2014-02-06','09:45:00',2.25),('8975','2014-02-06','09:50:00',2.32),('8975','2014-02-06','09:55:00',2.38),('8975','2014-02-06','10:00:00',2.43),('8975','2014-02-06','10:05:00',2.52),('8975','2014-02-06','10:10:00',2.61),('8975','2014-02-06','10:15:00',2.7),('8975','2014-02-06','10:20:00',2.6),('8975','2014-02-06','10:25:00',2.22),('8975','2014-02-06','10:30:00',2.56),('8975','2014-02-06','10:35:00',2.56),('8975','2014-02-06','10:40:00',2.86),('8975','2014-02-06','10:45:00',2.66),('8975','2014-02-06','10:50:00',3.08),('8975','2014-02-06','10:55:00',3.14),('8975','2014-02-06','11:00:00',3.1),('8975','2014-02-06','11:05:00',3.21),('8975','2014-02-06','11:10:00',3.11),('8975','2014-02-06','11:15:00',3.05),('8975','2014-02-06','11:20:00',2.47),('8975','2014-02-06','11:25:00',3.03),('8975','2014-02-06','11:30:00',2.06),('8975','2014-02-06','11:35:00',3.23),('8975','2014-02-06','11:40:00',2.92),('8975','2014-02-06','11:45:00',3.29),('8975','2014-02-06','11:50:00',3.35),('8975','2014-02-06','11:55:00',3.45),('8975','2014-02-06','12:00:00',2.05),('8975','2014-02-06','12:05:00',2.12),('8975','2014-02-06','12:10:00',3.2),('8975','2014-02-06','12:15:00',2.73),('8975','2014-02-06','12:20:00',3.07),('8975','2014-02-06','12:25:00',2.59),('8975','2014-02-06','12:30:00',2.08),('8975','2014-02-06','12:35:00',2.02),('8975','2014-02-06','12:40:00',2.15),('8975','2014-02-06','12:45:00',1.52),('8975','2014-02-06','12:50:00',1.37),('8975','2014-02-06','12:55:00',1.99),('8975','2014-02-06','13:00:00',2.38),('8975','2014-02-06','13:05:00',2.62),('8975','2014-02-06','13:10:00',1.19),('8975','2014-02-06','13:15:00',1.38),('8975','2014-02-06','13:20:00',1.12),('8975','2014-02-06','13:25:00',2.19),('8975','2014-02-06','13:30:00',1.38),('8975','2014-02-06','13:35:00',1.89),('8975','2014-02-06','13:40:00',2.88),('8975','2014-02-06','13:45:00',2.15),('8975','2014-02-06','13:50:00',1.65),('8975','2014-02-06','13:55:00',2.08),('8975','2014-02-06','14:00:00',2.14),('8975','2014-02-06','14:05:00',2.04),('8975','2014-02-06','14:10:00',2.19),('8975','2014-02-06','14:15:00',2),('8975','2014-02-06','14:20:00',1.21),('8975','2014-02-06','14:25:00',1.41),('8975','2014-02-06','14:30:00',1.79),('8975','2014-02-06','14:35:00',1.92),('8975','2014-02-06','14:40:00',1.49),('8975','2014-02-06','14:45:00',1.59),('8975','2014-02-06','14:50:00',1.55),('8975','2014-02-06','14:55:00',1.54),('8975','2014-02-06','15:00:00',1.48),('8975','2014-02-06','15:05:00',1.43),('8975','2014-02-06','15:10:00',1.39),('8975','2014-02-06','15:15:00',1.4),('8975','2014-02-06','15:20:00',1.36),('8975','2014-02-06','15:25:00',1.31),('8975','2014-02-06','15:30:00',1.27),('8975','2014-02-06','15:35:00',1.23),('8975','2014-02-06','15:40:00',1.2),('8975','2014-02-06','15:45:00',1.16),('8975','2014-02-06','15:50:00',1.14),('8975','2014-02-06','15:55:00',1.08),('8975','2014-02-06','16:00:00',1.04),('8975','2014-02-06','16:05:00',1),('8975','2014-02-05','08:20:00',1.18),('8975','2014-02-05','08:25:00',1.07),('8975','2014-02-05','08:30:00',1.16),('8975','2014-02-05','08:35:00',1.13),('8975','2014-02-05','08:40:00',1.36),('8975','2014-02-05','08:45:00',1.54),('8975','2014-02-05','08:50:00',1.84),('8975','2014-02-05','08:55:00',1.97),('8975','2014-02-05','09:00:00',2.2),('8975','2014-02-05','09:05:00',2.39),('8975','2014-02-05','09:10:00',2.55),('8975','2014-02-05','09:15:00',2.4),('8975','2014-02-05','09:20:00',1.31),('8975','2014-02-05','09:30:00',1.78),('8975','2014-02-05','09:35:00',2.34),('8975','2014-02-05','09:40:00',2.37),('8975','2014-02-05','09:45:00',2.35),('8975','2014-02-05','09:50:00',2.39),('8975','2014-02-05','09:55:00',2.43),('8975','2014-02-05','10:00:00',2.52),('8975','2014-02-05','10:05:00',2.59),('8975','2014-02-05','10:10:00',2.64),('8975','2014-02-05','10:15:00',2.65),('8975','2014-02-05','10:20:00',2.66),('8975','2014-02-05','10:25:00',1.76),('8975','2014-02-05','10:30:00',2.38),('8975','2014-02-05','10:35:00',2.93),('8975','2014-02-05','10:40:00',2.87),('8975','2014-02-05','10:45:00',1.84),('8975','2014-02-05','10:50:00',3.25),('8975','2014-02-05','10:55:00',3.07),('8975','2014-02-05','11:00:00',1.17),('8975','2014-02-05','11:05:00',1.68),('8975','2014-02-05','11:10:00',1.31),('8975','2014-02-05','11:15:00',3.49),('8975','2014-02-05','11:20:00',3.41),('8975','2014-02-05','11:25:00',3.18),('8975','2014-02-05','11:30:00',3.22),('8975','2014-02-05','11:35:00',3.12),('8975','2014-02-05','11:40:00',3.06),('8975','2014-02-05','11:45:00',2.87),('8975','2014-02-05','11:50:00',2.97),('8975','2014-02-05','11:55:00',3.02),('8975','2014-02-05','12:00:00',2.99),('8975','2014-02-05','12:05:00',2.95),('8975','2014-02-05','12:10:00',2.97),('8975','2014-02-05','12:15:00',2.93),('8975','2014-02-05','12:20:00',2.87),('8975','2014-02-05','12:25:00',2.86),('8975','2014-02-05','12:30:00',2.87),('8975','2014-02-05','12:35:00',2.88),('8975','2014-02-05','12:40:00',2.84),('8975','2014-02-05','12:45:00',2.8),('8975','2014-02-05','12:50:00',2.73),('8975','2014-02-05','12:55:00',2.53),('8975','2014-02-05','13:00:00',2.46),('8975','2014-02-05','13:05:00',2.68),('8975','2014-02-05','13:10:00',2.58),('8975','2014-02-05','13:15:00',2.54),('8975','2014-02-05','13:20:00',2.37),('8975','2014-02-05','13:25:00',2.68),('8975','2014-02-05','13:30:00',2.76),('8975','2014-02-05','13:35:00',2.37),('8975','2014-02-05','13:40:00',2.07),('8975','2014-02-05','13:45:00',2.16),('8975','2014-02-05','13:50:00',2.08),('8975','2014-02-05','13:55:00',2.02),('8975','2014-02-05','14:00:00',2.01),('8975','2014-02-05','14:05:00',2.12),('8975','2014-02-05','14:10:00',2.13),('8975','2014-02-05','14:15:00',1.96),('8975','2014-02-05','14:20:00',1.94),('8975','2014-02-05','14:25:00',1.86),('8975','2014-02-05','14:30:00',1.51),('8975','2014-02-05','14:35:00',1.38),('8975','2014-02-05','14:40:00',1.73),('8975','2014-02-05','14:45:00',1.87),('8975','2014-02-05','14:50:00',1.81),('8975','2014-02-05','14:55:00',1.56),('8975','2014-02-05','15:00:00',1.49),('8975','2014-02-05','15:05:00',1.43),('8975','2014-02-05','15:10:00',1.37),('8975','2014-02-05','15:15:00',1.38),('8975','2014-02-05','15:20:00',1.39),('8975','2014-02-05','15:25:00',1.31),('8975','2014-02-05','15:30:00',1.26),('8975','2014-02-05','15:35:00',1.22),('8975','2014-02-05','15:40:00',1.19),('8975','2014-02-05','15:45:00',1.15),('8975','2014-02-05','15:50:00',1.11),('8975','2014-02-05','15:55:00',1.07),('8975','2014-02-05','16:00:00',1.03),('8975','2014-04-26','08:50:00',1.51),('8975','2014-04-26','08:55:00',1.48),('8975','2014-04-26','09:00:00',1.13),('8975','2014-04-26','09:15:00',1.01),('8975','2014-04-26','09:20:00',1.08),('8975','2014-04-26','09:40:00',1.11),('8975','2014-04-26','09:45:00',1.44),('8975','2014-04-26','09:50:00',1.34),('8975','2014-04-26','09:55:00',1.56),('8975','2014-04-26','10:00:00',1.54),('8975','2014-04-26','10:05:00',1.76),('8975','2014-04-26','10:10:00',1.62),('8975','2014-04-26','10:15:00',1.61),('8975','2014-04-26','10:25:00',1.17),('8975','2014-04-26','10:50:00',1.35),('8975','2014-04-26','10:55:00',1.65),('8975','2014-04-26','11:00:00',1.96),('8975','2014-04-26','11:05:00',1.87),('8975','2014-04-26','11:10:00',2.91),('8975','2014-04-26','11:15:00',2.58),('8975','2014-04-26','11:20:00',1.83),('8975','2014-04-26','11:25:00',1.28),('8975','2014-04-26','11:30:00',2.89),('8975','2014-04-26','11:35:00',3.2),('8975','2014-04-26','11:40:00',4),('8975','2014-04-26','11:45:00',5.01),('8975','2014-04-26','11:50:00',4.06),('8975','2014-04-26','11:55:00',4.36),('8975','2014-04-26','12:00:00',4.4),('8975','2014-04-26','12:05:00',3.62),('8975','2014-04-26','12:10:00',4.74),('8975','2014-04-26','12:15:00',5.52),('8975','2014-04-26','12:20:00',4.98),('8975','2014-04-26','12:25:00',4.37),('8975','2014-04-26','12:30:00',4.61),('8975','2014-04-26','12:35:00',5.19),('8975','2014-04-26','12:40:00',4.82),('8975','2014-04-26','12:45:00',5),('8975','2014-04-26','12:50:00',5.03),('8975','2014-04-26','12:55:00',4.42),('8975','2014-04-26','13:00:00',4.09),('8975','2014-04-26','13:05:00',3.44),('8975','2014-04-26','13:10:00',2.92),('8975','2014-04-26','13:15:00',3.37),('8975','2014-04-26','13:20:00',4.19),('8975','2014-04-26','13:25:00',3.65),('8975','2014-04-26','13:30:00',3.24),('8975','2014-04-26','13:35:00',3.01),('8975','2014-04-26','13:40:00',2.89),('8975','2014-04-26','13:45:00',2.89),('8975','2014-04-26','13:50:00',2.58),('8975','2014-04-26','13:55:00',2.33),('8975','2014-04-26','14:00:00',3.51),('8975','2014-04-26','14:05:00',3.11),('8975','2014-04-26','14:10:00',2.51),('8975','2014-04-26','14:15:00',2.72),('8975','2014-04-26','14:20:00',3.28),('8975','2014-04-26','14:25:00',3.88),('8975','2014-04-26','14:30:00',3.63),('8975','2014-04-26','14:35:00',4.25),('8975','2014-04-26','14:40:00',3.64),('8975','2014-04-26','14:45:00',3.15),('8975','2014-04-26','14:50:00',3.2),('8975','2014-04-26','14:55:00',3.27),('8975','2014-04-26','15:00:00',3.66),('8975','2014-04-26','15:05:00',4.95),('8975','2014-04-26','15:10:00',4.77),('8975','2014-04-26','15:15:00',3.34),('8975','2014-04-26','15:20:00',2.88),('8975','2014-04-26','15:25:00',1.91),('8975','2014-04-26','15:30:00',1.52),('8975','2014-04-26','15:35:00',1.68),('8975','2014-04-26','15:40:00',2.03),('8975','2014-04-26','15:45:00',1.69),('8975','2014-04-26','15:50:00',1.52),('8975','2014-02-04','10:10:00',1.52),('8975','2014-02-04','10:15:00',2.86),('8975','2014-02-04','10:20:00',2.52),('8975','2014-02-04','10:25:00',1.2),('8975','2014-02-04','10:30:00',1.03),('8975','2014-02-04','10:35:00',1.13),('8975','2014-02-04','10:50:00',1.53),('8975','2014-02-04','10:55:00',1.29),('8975','2014-02-04','11:05:00',2.26),('8975','2014-02-04','11:10:00',3.28),('8975','2014-02-04','11:15:00',2.55),('8975','2014-02-04','11:20:00',1.44),('8975','2014-02-04','11:25:00',1.53),('8975','2014-02-04','12:55:00',1.28),('8975','2014-02-04','13:05:00',1.18),('8975','2014-02-04','13:10:00',1.35),('8975','2014-02-04','13:15:00',1.09),('8975','2014-02-04','13:20:00',1.37),('8975','2014-02-04','13:25:00',1.51),('8975','2014-02-04','13:30:00',1.62),('8975','2014-02-04','13:35:00',1.77),('8975','2014-02-04','13:40:00',1.8),('8975','2014-02-04','13:45:00',1.77),('8975','2014-02-04','13:50:00',1.84),('8975','2014-02-04','13:55:00',1.38),('8975','2014-02-04','14:00:00',1.03),('8975','2014-02-04','14:30:00',2.21),('8975','2014-02-04','14:35:00',1.24),('8975','2014-02-03','09:10:00',1.08),('8975','2014-02-03','09:15:00',1.82),('8975','2014-02-03','09:20:00',1.77),('8975','2014-02-03','09:25:00',2.06),('8975','2014-02-03','09:30:00',2.63),('8975','2014-02-03','09:35:00',2.32),('8975','2014-02-03','09:40:00',2.55),('8975','2014-02-03','09:45:00',2.44),('8975','2014-02-03','09:50:00',1.83),('8975','2014-02-03','09:55:00',2.18),('8975','2014-02-03','10:00:00',1.88),('8975','2014-02-03','10:05:00',3.03),('8975','2014-02-03','10:10:00',1.69),('8975','2014-02-03','10:15:00',2.01),('8975','2014-02-03','10:20:00',1.65),('8975','2014-02-03','10:25:00',2.18),('8975','2014-02-03','10:30:00',1.31),('8975','2014-02-03','10:35:00',1.66),('8975','2014-02-03','10:40:00',2.93),('8975','2014-02-03','10:45:00',3.2),('8975','2014-02-03','10:50:00',2.57),('8975','2014-02-03','10:55:00',1.99),('8975','2014-02-03','11:00:00',2.99),('8975','2014-02-03','11:05:00',1.87),('8975','2014-02-03','11:10:00',1.47),('8975','2014-02-03','11:15:00',1.42),('8975','2014-02-03','11:20:00',1.59),('8975','2014-02-03','11:25:00',2.05),('8975','2014-02-03','11:30:00',1.75),('8975','2014-02-03','11:35:00',1.72),('8975','2014-02-03','11:45:00',1.55),('8975','2014-02-03','11:50:00',2.5),('8975','2014-02-03','11:55:00',2.23),('8975','2014-02-03','12:00:00',1.65),('8975','2014-02-03','12:05:00',2.34),('8975','2014-02-03','12:10:00',2.1),('8975','2014-02-03','12:15:00',1.64),('8975','2014-02-03','12:20:00',1.5),('8975','2014-02-03','12:25:00',1.24),('8975','2014-02-03','12:35:00',1),('8975','2014-02-03','12:40:00',1.07),('8975','2014-02-03','12:45:00',1.53),('8975','2014-02-03','12:50:00',1.32),('8975','2014-02-03','12:55:00',1.47),('8975','2014-02-03','13:00:00',1.53),('8975','2014-02-03','13:05:00',1.29),('8975','2014-02-03','13:10:00',1.24),('8975','2014-02-03','13:15:00',1.38),('8975','2014-02-03','13:20:00',1.62),('8975','2014-02-03','13:25:00',1.17),('8975','2014-02-03','13:30:00',1.22),('8975','2014-02-03','13:40:00',1.21),('8975','2014-02-03','13:45:00',1.24),('8975','2014-02-03','13:50:00',1.47),('8975','2014-02-03','13:55:00',1.2),('8975','2014-02-03','14:10:00',1.06),('8975','2014-02-02','09:45:00',1.03),('8975','2014-02-02','09:50:00',1.08),('8975','2014-02-02','10:10:00',1.05),('8975','2014-02-02','10:15:00',1.06),('8975','2014-02-02','10:20:00',1.07),('8975','2014-02-02','10:25:00',1.09),('8975','2014-02-02','10:30:00',1.25),('8975','2014-02-02','10:35:00',1.36),('8975','2014-02-02','10:40:00',1.26),('8975','2014-02-02','10:45:00',1.47),('8975','2014-02-02','10:50:00',1.19),('8975','2014-02-02','10:55:00',1.18),('8975','2014-02-02','11:00:00',1.08),('8975','2014-02-02','11:15:00',1.12),('8975','2014-02-02','11:20:00',1.24),('8975','2014-02-02','11:25:00',1.26),('8975','2014-02-02','11:30:00',1.41),('8975','2014-02-02','11:35:00',1.44),('8975','2014-02-02','11:40:00',1.56),('8975','2014-02-02','11:45:00',1.59),('8975','2014-02-02','11:50:00',1.52),('8975','2014-02-02','11:55:00',1.37),('8975','2014-02-02','12:00:00',1.21),('8975','2014-02-02','12:05:00',1.2),('8975','2014-02-02','12:10:00',1.2),('8975','2014-02-02','12:15:00',1.25),('8975','2014-02-02','12:20:00',1.29),('8975','2014-02-02','12:25:00',1.27),('8975','2014-02-02','12:30:00',1.14),('8975','2014-02-02','13:30:00',1.05),('8975','2014-02-02','13:35:00',1),('8975','2014-02-02','14:35:00',1.02),('8975','2014-02-02','14:40:00',1.04),('8975','2014-02-02','14:45:00',1.01),('8975','2014-02-01','11:55:00',1.1),('8975','2014-02-01','12:00:00',1.19),('8975','2014-02-01','12:05:00',1.21),('8975','2014-02-01','12:10:00',1.14),('8975','2014-01-31','10:55:00',1.06),('8975','2014-01-31','11:00:00',1.27),('8975','2014-01-31','11:05:00',1),('8975','2014-01-31','11:15:00',1.07),('8975','2014-01-31','11:20:00',1.72),('8975','2014-01-31','11:25:00',1.35),('8975','2014-01-31','11:30:00',1.59),('8975','2014-01-31','11:35:00',1.28),('8975','2014-01-31','11:55:00',1.6),('8975','2014-01-31','12:00:00',1.15),('8975','2014-01-31','12:05:00',1.88),('8975','2014-01-31','12:10:00',1.56),('8975','2014-01-31','12:15:00',1.67),('8975','2014-01-31','12:20:00',2.1),('8975','2014-01-31','12:25:00',1.33),('8975','2014-01-31','12:35:00',1.3),('8975','2014-01-31','12:40:00',1.76),('8975','2014-01-31','12:45:00',1.94),('8975','2014-01-31','12:50:00',1.67),('8975','2014-01-31','12:55:00',1.55),('8975','2014-01-31','13:00:00',1.54),('8975','2014-01-31','13:30:00',1),('8975','2014-01-30','13:50:00',1.05),('8975','2014-01-29','09:25:00',1.02),('8975','2014-01-29','09:50:00',1.76),('8975','2014-01-29','09:55:00',2.3),('8975','2014-01-29','10:00:00',1.51),('8975','2014-01-29','10:05:00',1.32),('8975','2014-01-29','10:10:00',2.23),('8975','2014-01-29','10:15:00',2.29),('8975','2014-01-29','10:20:00',2.11),('8975','2014-01-29','10:25:00',2.61),('8975','2014-01-29','10:30:00',2.55),('8975','2014-01-29','10:35:00',2.63),('8975','2014-01-29','10:40:00',2.42),('8975','2014-01-29','10:45:00',2.13),('8975','2014-01-29','10:50:00',2.82),('8975','2014-01-29','10:55:00',3.06),('8975','2014-01-29','11:00:00',2.52),('8975','2014-01-29','11:05:00',1.82),('8975','2014-01-29','11:10:00',2.44),('8975','2014-01-29','11:15:00',1.98),('8975','2014-01-29','11:20:00',1.76),('8975','2014-01-29','11:25:00',2.37),('8975','2014-01-29','11:30:00',1.88),('8975','2014-01-29','11:35:00',2.46),('8975','2014-01-29','11:40:00',3),('8975','2014-01-29','11:45:00',2.66),('8975','2014-01-29','11:50:00',2.83),('8975','2014-01-29','11:55:00',2.21),('8975','2014-01-29','12:00:00',2.18),('8975','2014-01-29','12:05:00',2.49),('8975','2014-01-29','12:10:00',2.76),('8975','2014-01-29','12:15:00',2.25),('8975','2014-01-29','12:20:00',2.41),('8975','2014-01-29','12:25:00',2.05),('8975','2014-01-29','12:30:00',1.94),('8975','2014-01-29','12:35:00',1.89),('8975','2014-01-29','12:40:00',2.11),('8975','2014-01-29','12:45:00',2.36),('8975','2014-01-29','12:50:00',2.43),('8975','2014-01-29','12:55:00',2.44),('8975','2014-01-29','13:00:00',2.53),('8975','2014-01-29','13:05:00',2.56),('8975','2014-01-29','13:10:00',2.35),('8975','2014-01-29','13:15:00',2.4),('8975','2014-01-29','13:20:00',2.34),('8975','2014-01-29','13:25:00',2.03),('8975','2014-01-29','13:30:00',1.66),('8975','2014-01-29','13:35:00',1.69),('8975','2014-01-29','13:40:00',2.01),('8975','2014-01-29','13:45:00',2.08),('8975','2014-01-29','13:50:00',1.8),('8975','2014-01-29','13:55:00',1.62),('8975','2014-01-29','14:00:00',1.59),('8975','2014-01-29','14:05:00',1.53),('8975','2014-01-29','14:10:00',1.52),('8975','2014-01-29','14:15:00',1.25),('8975','2014-01-29','14:20:00',1.15),('8975','2014-01-29','14:25:00',1.27),('8975','2014-01-29','14:30:00',1.34),('8975','2014-01-29','14:35:00',1.44),('8975','2014-01-29','14:40:00',1.54),('8975','2014-01-29','14:45:00',1.41),('8975','2014-01-29','14:50:00',1.46),('8975','2014-01-29','14:55:00',1.37),('8975','2014-01-29','15:00:00',1.33),('8975','2014-01-29','15:05:00',1.37),('8975','2014-01-29','15:10:00',1.33),('8975','2014-01-29','15:15:00',1.33),('8975','2014-01-29','15:20:00',1.37),('8975','2014-01-29','15:25:00',1.35),('8975','2014-01-29','15:30:00',1.23),('8975','2014-01-29','15:35:00',1.26),('8975','2014-01-29','15:40:00',1.12),('8975','2014-01-28','09:15:00',1.31),('8975','2014-01-28','09:20:00',1.99),('8975','2014-01-28','09:25:00',1.25),('8975','2014-01-28','09:30:00',1.84),('8975','2014-01-28','09:35:00',2.08),('8975','2014-01-28','09:40:00',2.08),('8975','2014-01-28','09:45:00',1.98),('8975','2014-01-28','09:50:00',1.88),('8975','2014-01-28','09:55:00',1.62),('8975','2014-01-28','10:00:00',1.42),('8975','2014-01-28','10:05:00',1.42),('8975','2014-01-28','10:10:00',1.8),('8975','2014-01-28','10:15:00',2.41),('8975','2014-01-28','10:20:00',1.62),('8975','2014-01-28','10:25:00',2.67),('8975','2014-01-28','10:30:00',2.61),('8975','2014-01-28','10:35:00',2.08),('8975','2014-01-28','10:40:00',2.72),('8975','2014-01-28','10:45:00',2.33),('8975','2014-01-28','10:50:00',2.04),('8975','2014-01-28','10:55:00',1.99),('8975','2014-01-28','11:00:00',2.14),('8975','2014-01-28','11:05:00',2.21),('8975','2014-01-28','11:10:00',1.99),('8975','2014-01-28','11:15:00',2.02),('8975','2014-01-28','11:20:00',1.86),('8975','2014-01-28','11:25:00',2.17),('8975','2014-01-28','11:30:00',2.1),('8975','2014-01-28','11:35:00',1.48),('8975','2014-01-28','11:40:00',1.66),('8975','2014-01-28','11:45:00',1.41),('8975','2014-01-28','12:45:00',1.56),('8975','2014-01-28','12:50:00',2.55),('8975','2014-01-28','12:55:00',2.24),('8975','2014-01-28','13:00:00',1.39),('8975','2014-01-28','13:30:00',1.52),('8975','2014-01-28','13:35:00',1.85),('8975','2014-01-28','13:40:00',1.42),('8975','2014-01-28','13:45:00',1.26),('8975','2014-01-28','13:50:00',1.54),('8975','2014-01-28','13:55:00',1.09),('8975','2014-01-28','14:00:00',1.02),('8975','2014-01-28','14:40:00',1),('8975','2014-01-28','15:10:00',1.6),('8975','2014-01-28','15:15:00',1.66),('8975','2014-01-27','09:05:00',1.28),('8975','2014-01-27','09:10:00',1.59),('8975','2014-01-27','09:15:00',1.6),('8975','2014-01-27','09:20:00',1.59),('8975','2014-01-27','09:25:00',1.52),('8975','2014-01-27','09:30:00',1.65),('8975','2014-01-27','09:35:00',1.71),('8975','2014-01-27','09:40:00',1.61),('8975','2014-01-27','09:45:00',2.05),('8975','2014-01-27','09:50:00',2.17),('8975','2014-01-27','09:55:00',2.14),('8975','2014-01-27','10:00:00',2.18),('8975','2014-01-27','10:05:00',2.08),('8975','2014-01-27','10:10:00',2.06),('8975','2014-01-27','10:15:00',2.3),('8975','2014-01-27','10:20:00',2.4),('8975','2014-01-27','10:25:00',2.49),('8975','2014-01-27','10:30:00',2.34),('8975','2014-01-27','10:35:00',2.54),('8975','2014-01-27','10:40:00',2.53),('8975','2014-01-27','10:45:00',1.91),('8975','2014-01-27','10:50:00',1.61),('8975','2014-01-27','10:55:00',2.24),('8975','2014-01-27','11:00:00',2.13),('8975','2014-01-27','11:05:00',2.96),('8975','2014-01-27','11:10:00',2.42),('8975','2014-01-27','11:15:00',2.31),('8975','2014-01-27','11:20:00',2.37),('8975','2014-01-27','11:25:00',2.65),('8975','2014-01-27','11:30:00',3.31),('8975','2014-01-27','11:35:00',3.08),('8975','2014-01-27','11:40:00',1.44),('8975','2014-01-27','11:45:00',2.16),('8975','2014-01-27','11:50:00',1.07),('8975','2014-01-27','11:55:00',1.01),('8975','2014-01-27','12:00:00',1.59),('8975','2014-01-27','12:05:00',2.35),('8975','2014-01-27','12:10:00',2.7),('8975','2014-01-27','12:15:00',2.45),('8975','2014-01-27','12:20:00',1.41),('8975','2014-01-27','12:25:00',1.23),('8975','2014-01-27','12:30:00',1.28),('8975','2014-01-27','12:35:00',1.54),('8975','2014-01-27','12:40:00',1.59),('8975','2014-01-27','12:45:00',2.13),('8975','2014-01-27','12:50:00',2.1),('8975','2014-01-27','12:55:00',2.3),('8975','2014-01-27','13:00:00',2.91),('8975','2014-01-27','13:05:00',2.07),('8975','2014-01-27','13:10:00',1.85),('8975','2014-01-27','13:15:00',2.52),('8975','2014-01-27','13:20:00',2.33),('8975','2014-01-27','13:25:00',2.18),('8975','2014-01-27','13:30:00',2.31),('8975','2014-01-27','13:35:00',2.14),('8975','2014-01-27','13:40:00',2.06),('8975','2014-01-27','13:45:00',1.9),('8975','2014-01-27','13:50:00',1.87),('8975','2014-01-27','13:55:00',1.82),('8975','2014-01-27','14:00:00',1.77),('8975','2014-01-27','14:05:00',1.71),('8975','2014-01-27','14:10:00',1.71),('8975','2014-01-27','14:15:00',1.66),('8975','2014-01-27','14:20:00',1.45),('8975','2014-01-27','14:25:00',1.21),('8975','2014-01-27','14:30:00',1.18),('8975','2014-01-27','14:35:00',1.41),('8975','2014-01-27','14:40:00',1.51),('8975','2014-01-27','14:45:00',1.44),('8975','2014-01-27','14:50:00',1.4),('8975','2014-01-27','14:55:00',1.32),('8975','2014-01-27','15:00:00',1.29),('8975','2014-01-27','15:05:00',1.29),('8975','2014-01-27','15:10:00',1.28),('8975','2014-01-27','15:15:00',1.24),('8975','2014-01-27','15:20:00',1.21),('8975','2014-01-27','15:25:00',1.17),('8975','2014-01-27','15:30:00',1.15),('8975','2014-01-27','15:35:00',1.11),('8975','2014-01-27','15:40:00',1.08),('8975','2014-01-27','15:45:00',1.03),('8975','2014-01-26','10:25:00',1.03),('8975','2014-01-26','10:30:00',1.1),('8975','2014-01-26','10:35:00',1.11),('8975','2014-01-26','10:40:00',1.09),('8975','2014-01-26','10:45:00',1.18),('8975','2014-01-26','10:50:00',1.16),('8975','2014-01-26','10:55:00',1.03),('8975','2014-01-26','11:00:00',1.14),('8975','2014-01-26','11:05:00',1.28),('8975','2014-01-26','11:10:00',1.14),('8975','2014-01-26','11:15:00',1.07),('8975','2014-01-26','11:20:00',1.22),('8975','2014-01-26','11:25:00',1.17),('8998','2014-05-04','07:40:00',1.07),('8998','2014-05-04','07:45:00',1.24),('8998','2014-05-04','07:50:00',1.36),('8998','2014-05-04','07:55:00',1.45),('8998','2014-05-04','08:00:00',1.44),('8998','2014-05-04','08:05:00',1.4),('8998','2014-05-04','08:10:00',1.38),('8998','2014-05-04','08:15:00',1.77),('8998','2014-05-04','08:20:00',1.73),('8998','2014-05-04','08:25:00',1.58),('8998','2014-05-04','08:30:00',1.97),('8998','2014-05-04','08:35:00',2.02),('8998','2014-05-04','08:40:00',2.03),('8998','2014-05-04','08:45:00',1.86),('8998','2014-05-04','08:50:00',1.76),('8998','2014-05-04','08:55:00',1.68),('8998','2014-05-04','09:00:00',1.84),('8998','2014-05-04','09:05:00',1.82),('8998','2014-05-04','09:10:00',1.98),('8998','2014-05-04','09:15:00',2.48),('8998','2014-05-04','09:20:00',2.52),('8998','2014-05-04','09:25:00',2.6),('8998','2014-05-04','09:30:00',2.71),('8998','2014-05-04','09:35:00',2.8),('8998','2014-05-04','09:40:00',2.84),('8998','2014-05-04','09:45:00',2.87),('8998','2014-05-04','09:50:00',2.91),('8998','2014-05-04','09:55:00',2.94),('8998','2014-05-04','10:00:00',2.97),('8998','2014-05-04','10:05:00',3),('8998','2014-05-04','10:10:00',3.04),('8998','2014-05-04','10:15:00',3.02),('8998','2014-05-04','10:20:00',3),('8998','2014-05-04','10:25:00',3.03),('8998','2014-05-04','10:30:00',3.06),('8998','2014-05-04','10:35:00',3.11),('8998','2014-05-04','10:40:00',3.09),('8998','2014-05-04','10:45:00',3.09),('8998','2014-05-04','10:50:00',3.13),('8998','2014-05-04','10:55:00',3.11),('8998','2014-05-04','11:00:00',3.14),('8998','2014-05-04','11:05:00',3.14),('8998','2014-05-04','11:10:00',3.14),('8998','2014-05-04','11:15:00',3.13),('8998','2014-05-04','11:20:00',3.13),('8998','2014-05-04','11:25:00',3.12),('8998','2014-05-04','11:30:00',3.11),('8998','2014-05-04','11:35:00',3.11),('8998','2014-05-04','11:40:00',3.14),('8998','2014-05-04','11:45:00',3.15),('8998','2014-05-04','11:50:00',3.16),('8998','2014-05-04','11:55:00',3.24),('8998','2014-05-04','12:00:00',2.33),('8998','2014-05-04','12:05:00',1.56),('8998','2014-05-04','12:10:00',2.12),('8998','2014-05-04','12:15:00',1.82),('8998','2014-05-04','12:20:00',1.65),('8998','2014-05-04','12:25:00',2.78),('8998','2014-05-04','12:30:00',2.98),('8998','2014-05-04','12:35:00',1.33),('8998','2014-05-04','12:40:00',1.32),('8998','2014-05-04','12:45:00',3.75),('8998','2014-05-04','12:50:00',2.55),('8998','2014-05-04','12:55:00',1.98),('8998','2014-05-04','13:00:00',1.7),('8998','2014-05-04','13:05:00',2.91),('8998','2014-05-04','13:10:00',3.1),('8998','2014-05-04','13:15:00',3.04),('8998','2014-05-04','13:20:00',2.93),('8998','2014-05-04','13:25:00',2.89),('8998','2014-05-04','13:30:00',2.88),('8998','2014-05-04','13:35:00',2.87),('8998','2014-05-04','13:40:00',2.82),('8998','2014-05-04','13:45:00',2.8),('8998','2014-05-04','13:50:00',2.8),('8998','2014-05-04','13:55:00',2.8),('8998','2014-05-04','14:00:00',2.79),('8998','2014-05-04','14:05:00',2.89),('8998','2014-05-04','14:10:00',2.92),('8998','2014-05-04','14:15:00',2.96),('8998','2014-05-04','14:20:00',3.19),('8998','2014-05-04','14:25:00',2.81),('8998','2014-05-04','14:30:00',1.54),('8998','2014-05-04','14:35:00',1.08),('8998','2014-05-04','14:55:00',1.12),('8998','2014-05-04','15:05:00',1.01),('8998','2014-05-04','15:25:00',1.75),('8998','2014-05-04','15:30:00',2.39),('8998','2014-05-04','15:35:00',1.59),('8998','2014-05-04','15:40:00',1.84),('8998','2014-05-04','15:45:00',1.13),('8998','2014-05-04','16:05:00',1.25),('8998','2014-05-04','17:00:00',1.06),('8998','2014-04-25','09:55:00',1.11),('8998','2014-04-25','10:00:00',1.07),('8998','2014-04-25','10:20:00',1.04),('8998','2014-04-25','10:25:00',1.12),('8998','2014-04-25','10:30:00',1.56),('8998','2014-04-25','10:35:00',1.42),('8998','2014-04-25','10:40:00',1.35),('8998','2014-04-25','10:45:00',1.44),('8998','2014-04-25','10:50:00',1.79),('8998','2014-04-25','10:55:00',2.5),('8998','2014-04-25','11:00:00',2.83),('8998','2014-04-25','11:05:00',2.59),('8998','2014-04-25','11:10:00',2.63),('8998','2014-04-25','11:15:00',2.53),('8998','2014-04-25','11:20:00',2.39),('8998','2014-04-25','11:25:00',2.37),('8998','2014-04-25','11:30:00',2.34),('8998','2014-04-25','11:35:00',2.27),('8998','2014-04-25','11:40:00',2.2),('8998','2014-04-25','11:45:00',2.39),('8998','2014-04-25','11:50:00',2.37),('8998','2014-04-25','11:55:00',2),('8998','2014-04-25','12:00:00',2.33),('8998','2014-04-25','12:05:00',2.32),('8998','2014-04-25','12:10:00',2.33),('8998','2014-04-25','12:15:00',2.13),('8998','2014-04-25','12:20:00',1.95),('8998','2014-04-25','12:25:00',1.33),('8998','2014-04-25','12:30:00',1.74),('8998','2014-04-25','12:35:00',2.37),('8998','2014-04-25','12:40:00',2.23),('8998','2014-04-25','12:45:00',2.34),('8998','2014-04-25','12:50:00',2.88),('8998','2014-04-25','12:55:00',2.99),('8998','2014-04-25','13:00:00',2.77),('8998','2014-04-25','13:05:00',2.32),('8998','2014-04-25','13:10:00',2.05),('8998','2014-04-25','13:15:00',3.01),('8998','2014-04-25','13:20:00',2.48),('8998','2014-04-25','13:25:00',1.42),('8998','2014-04-25','13:35:00',1.95),('8998','2014-04-25','13:40:00',2.83),('8998','2014-04-25','13:45:00',2.7),('8998','2014-04-25','13:50:00',2.71),('8998','2014-04-25','13:55:00',2.88),('8998','2014-04-25','14:00:00',2.01),('8998','2014-04-25','14:10:00',2.37),('8998','2014-04-25','14:35:00',1.41),('8998','2014-04-25','14:40:00',1.44),('8998','2014-01-25','09:05:00',1.18),('8998','2014-01-25','09:30:00',1.34),('8998','2014-01-25','09:35:00',1.56),('8998','2014-01-25','09:45:00',1.11),('8998','2014-01-25','09:50:00',1.23),('8998','2014-01-25','10:10:00',1.5),('8998','2014-01-25','10:15:00',2.03),('8998','2014-01-25','12:30:00',1.49),('8998','2014-01-25','12:35:00',1.49),('8998','2014-01-25','13:15:00',1.02),('8998','2014-01-25','13:20:00',1),('8998','2014-01-24','09:00:00',1.11),('8998','2014-01-24','09:05:00',1.8),('8998','2014-01-24','09:10:00',1.01),('8998','2014-01-24','09:15:00',1.06),('8998','2014-01-24','09:20:00',1.44),('8998','2014-01-24','09:50:00',1.03),('8998','2014-01-24','09:55:00',1.17),('8998','2014-01-24','10:00:00',1.06),('8998','2014-01-24','10:05:00',1.92),('8998','2014-01-24','10:10:00',2.22),('8998','2014-01-24','10:15:00',2.25),('8998','2014-01-24','10:20:00',2.1),('8998','2014-01-24','10:25:00',1.27),('8998','2014-01-24','10:30:00',1.28),('8998','2014-01-24','10:35:00',1.1),('8998','2014-01-24','10:40:00',1.45),('8998','2014-01-24','10:45:00',1.14),('8998','2014-01-24','10:50:00',1.39),('8998','2014-01-24','10:55:00',1.16),('8998','2014-01-24','11:30:00',2.28),('8998','2014-01-24','11:35:00',2.41),('8998','2014-01-24','11:40:00',1.19),('8998','2014-01-24','11:45:00',1.02),('8998','2014-01-24','11:50:00',1.07),('8998','2014-01-24','11:55:00',1.06),('8998','2014-01-24','12:00:00',1.05),('8998','2014-01-24','12:05:00',1.1),('8998','2014-01-24','12:10:00',1.18),('8998','2014-01-24','12:15:00',1.12),('8998','2014-01-24','12:20:00',1.12),('8998','2014-01-24','12:25:00',1.12),('8998','2014-01-24','12:30:00',1.13),('8998','2014-01-24','12:40:00',1.05),('8998','2014-01-24','12:45:00',1.26),('8998','2014-01-24','12:50:00',1.32),('8998','2014-01-24','12:55:00',1.49),('8998','2014-01-24','13:00:00',1.41),('8998','2014-01-24','13:05:00',1.54),('8998','2014-01-24','13:10:00',1.54),('8998','2014-01-24','13:15:00',1.01),('8998','2014-01-23','10:15:00',1.3),('8998','2014-01-23','10:30:00',1.29),('8998','2014-01-23','10:40:00',1.39),('8998','2014-01-23','10:45:00',1.57),('8998','2014-01-23','11:35:00',1.17),('8998','2014-01-23','11:50:00',2.19),('8998','2014-01-23','11:55:00',1.99),('8998','2014-01-23','12:00:00',1.05),('8998','2014-01-23','12:05:00',1.02),('8998','2014-01-23','12:25:00',1.01),('8998','2014-01-23','12:35:00',1.59),('8998','2014-01-23','12:40:00',1.53),('8998','2014-01-23','12:45:00',1.21),('8998','2014-01-23','13:05:00',1.06),('8998','2014-01-23','14:10:00',1.04),('8998','2014-01-20','10:55:00',1.18),('8998','2014-01-20','11:00:00',1.69),('8998','2014-01-20','12:05:00',1.09),('8998','2014-01-20','12:10:00',1.29),('8998','2014-01-20','12:15:00',1.15),('8998','2014-01-20','12:30:00',1.47),('8998','2014-01-20','12:35:00',1.04),('8998','2014-01-20','12:40:00',1.02),('8998','2014-01-20','12:50:00',1.16),('8998','2014-01-19','11:25:00',1.2),('8998','2014-01-19','11:30:00',1.33),('8998','2014-01-19','11:35:00',1.25),('8998','2014-01-19','11:40:00',2),('8998','2014-01-19','11:45:00',2.04),('8998','2014-01-19','11:50:00',1.11),('8998','2014-01-19','13:20:00',2.08),('8998','2014-01-19','13:25:00',1.85),('8998','2014-01-19','13:30:00',1.48),('8998','2014-01-19','13:35:00',1.29),('8998','2014-01-19','13:40:00',1.07),('8998','2014-01-19','13:45:00',1.1),('8998','2014-01-19','14:00:00',1.35),('8998','2014-01-17','10:05:00',1.27),('8998','2014-01-17','10:10:00',1.91),('8998','2014-01-17','10:15:00',1.96),('8998','2014-01-17','10:20:00',1.72),('8998','2014-01-17','10:25:00',1.11),('8998','2014-01-17','10:30:00',1.28),('8998','2014-01-17','11:10:00',1.29),('8998','2014-01-17','11:15:00',1.91),('8998','2014-01-17','11:20:00',1.85),('8998','2014-01-17','11:25:00',1.73),('8998','2014-01-17','11:30:00',1.7),('8998','2014-01-17','11:35:00',1.72),('8998','2014-01-17','11:40:00',1.45),('8998','2014-01-17','11:45:00',1.92),('8998','2014-01-17','11:50:00',1.94),('8998','2014-01-17','11:55:00',2.05),('8998','2014-01-17','12:00:00',1.9),('8998','2014-01-17','12:05:00',1.49),('8998','2014-01-17','12:10:00',1.7),('8998','2014-01-17','12:15:00',1.58),('8998','2014-01-17','12:20:00',1.56),('8998','2014-01-17','12:25:00',1.53),('8998','2014-01-17','12:30:00',1.54),('8998','2014-01-17','12:35:00',1.51),('8998','2014-01-17','12:40:00',1.49),('8998','2014-01-17','12:45:00',1.45),('8998','2014-01-17','12:50:00',1.35),('8998','2014-01-17','12:55:00',1.49),('8998','2014-01-17','13:00:00',1.04),('8998','2014-01-17','13:10:00',1.15),('8998','2014-01-17','13:15:00',1.36),('8998','2014-01-17','13:30:00',1.17),('8998','2014-01-17','13:45:00',1.05),('8998','2014-01-16','09:00:00',1.07),('8998','2014-01-16','09:05:00',1.27),('8998','2014-01-16','09:10:00',1.13),('8998','2014-01-16','09:20:00',1.26),('8998','2014-01-16','09:25:00',1.46),('8998','2014-01-16','09:30:00',1.42),('8998','2014-01-16','09:35:00',1.43),('8998','2014-01-16','09:40:00',1.57),('8998','2014-01-16','09:45:00',1.62),('8998','2014-01-16','09:50:00',1.02),('8998','2014-01-16','11:30:00',1.12),('8998','2014-01-16','12:05:00',1.17),('8998','2014-01-16','12:10:00',1.06),('8998','2014-04-24','07:55:00',1.11),('8998','2014-04-24','08:00:00',1.26),('8998','2014-04-24','08:05:00',1.21),('8998','2014-04-24','08:10:00',1.24),('8998','2014-04-24','08:15:00',1.26),('8998','2014-04-24','08:20:00',1.46),('8998','2014-04-24','08:25:00',1.57),('8998','2014-04-24','08:30:00',1.56),('8998','2014-04-24','08:35:00',1.49),('8998','2014-04-24','08:40:00',1.48),('8998','2014-04-24','08:45:00',1.55),('8998','2014-04-24','08:50:00',1.58),('8998','2014-04-24','08:55:00',1.61),('8998','2014-04-24','09:00:00',1.79),('8998','2014-04-24','09:05:00',1.73),('8998','2014-04-24','09:10:00',2.02),('8998','2014-04-24','09:15:00',2.01),('8998','2014-04-24','09:20:00',1.36),('8998','2014-04-24','09:25:00',1.03),('8998','2014-04-24','09:30:00',1.14),('8998','2014-04-24','09:35:00',1.01),('8998','2014-04-24','10:35:00',1.91),('8998','2014-04-24','10:40:00',3.08),('8998','2014-04-24','10:45:00',3.15),('8998','2014-04-24','10:50:00',2.74),('8998','2014-04-24','10:55:00',1.84),('8998','2014-04-24','11:00:00',2.83),('8998','2014-04-24','11:05:00',2.02),('8998','2014-04-24','11:15:00',1.36),('8998','2014-04-24','11:20:00',3.22),('8998','2014-04-24','11:25:00',2.79),('8998','2014-04-24','11:30:00',1.34),('8998','2014-04-24','11:35:00',3.08),('8998','2014-04-24','11:40:00',1.83),('8998','2014-04-24','11:45:00',1.41),('8998','2014-04-24','12:00:00',1.41),('8998','2014-04-24','12:05:00',1.21),('8998','2014-04-24','12:10:00',1.23),('8998','2014-04-24','12:15:00',1.97),('8998','2014-04-24','12:20:00',3.2),('8998','2014-04-24','12:25:00',2.11),('8998','2014-04-24','12:30:00',1.66),('8998','2014-04-24','12:35:00',2.47),('8998','2014-04-24','12:40:00',2.82),('8998','2014-04-24','12:45:00',2.97),('8998','2014-04-24','12:50:00',1.99),('8998','2014-04-24','12:55:00',1.68),('8998','2014-04-24','13:05:00',1.93),('8998','2014-04-24','13:10:00',1.08),('8998','2014-04-24','13:15:00',1.56),('8998','2014-04-24','13:20:00',1.24),('8998','2014-04-24','13:25:00',1.25),('8998','2014-04-24','13:30:00',1.49),('8998','2014-04-24','13:40:00',1.98),('8998','2014-04-24','13:45:00',1.48),('8998','2014-04-24','14:05:00',1.08),('8998','2014-04-24','14:10:00',1.01),('8998','2014-04-24','14:20:00',1.81),('8998','2014-04-24','14:25:00',2.09),('8998','2014-04-24','14:30:00',2.31),('8998','2014-04-24','14:35:00',2.51),('8998','2014-04-24','14:40:00',2.32),('8998','2014-04-24','14:45:00',2.3),('8998','2014-04-24','14:50:00',2.28),('8998','2014-04-24','14:55:00',2.17),('8998','2014-04-24','15:00:00',2.11),('8998','2014-04-24','15:05:00',2),('8998','2014-04-24','15:10:00',1.93),('8998','2014-04-24','15:15:00',1.89),('8998','2014-04-24','15:20:00',1.77),('8998','2014-04-24','15:25:00',1.75),('8998','2014-04-24','15:30:00',1.65),('8998','2014-04-24','15:35:00',1.65),('8998','2014-04-24','15:40:00',1.61),('8998','2014-04-24','15:45:00',1.53),('8998','2014-04-24','15:50:00',1.48),('8998','2014-04-24','15:55:00',1.44),('8998','2014-04-24','16:00:00',1.4),('8998','2014-04-24','16:05:00',1.3),('8998','2014-04-24','16:10:00',1.25),('8998','2014-04-24','16:15:00',1.16),('8998','2014-04-24','16:20:00',1.05),('8998','2014-04-24','16:25:00',1.03),('8998','2014-04-24','16:30:00',1.06),('8998','2014-04-24','16:35:00',1.02),('8998','2014-01-15','09:10:00',1.03),('8998','2014-01-15','09:20:00',1.37),('8998','2014-01-15','09:25:00',1.57),('8998','2014-01-15','09:30:00',1.61),('8998','2014-01-15','09:35:00',1.59),('8998','2014-01-15','09:40:00',1.67),('8998','2014-01-15','09:45:00',1.48),('8998','2014-01-15','09:50:00',1.09),('8998','2014-01-15','10:25:00',1.05),('8998','2014-01-15','10:30:00',1.44),('8998','2014-01-15','10:35:00',1.86),('8998','2014-01-15','10:40:00',1.82),('8998','2014-01-15','10:45:00',1.3),('8998','2014-01-15','10:50:00',1.35),('8998','2014-01-15','10:55:00',1.49),('8998','2014-01-15','11:00:00',1.45),('8998','2014-01-15','11:05:00',1.43),('8998','2014-01-15','11:10:00',1.46),('8998','2014-01-15','11:15:00',1.5),('8998','2014-01-15','11:20:00',1.33),('8998','2014-01-15','11:25:00',1.35),('8998','2014-01-15','11:30:00',1.2),('8998','2014-01-15','11:35:00',1.19),('8998','2014-01-15','11:40:00',1.12),('8998','2014-01-15','11:45:00',1.07),('8998','2014-01-15','11:50:00',1.21),('8998','2014-01-15','12:05:00',1.04),('8998','2014-01-15','12:10:00',1.13),('8998','2014-01-15','12:15:00',1.07),('8998','2014-01-15','12:35:00',1.07),('8998','2014-01-15','12:40:00',1.13),('8998','2014-01-15','12:45:00',1.16),('8998','2014-01-15','12:50:00',1.23),('8998','2014-01-15','12:55:00',1.25),('8998','2014-01-15','13:00:00',1.24),('8998','2014-01-15','13:05:00',1.3),('8998','2014-01-15','13:10:00',1.14),('8998','2014-01-15','13:15:00',1.2),('8998','2014-01-15','13:20:00',1.11),('8998','2014-01-15','13:25:00',1.15),('8998','2014-01-15','13:50:00',1.06),('8998','2014-01-14','10:15:00',1.17),('8998','2014-01-14','10:20:00',1.55),('8998','2014-01-14','10:25:00',1.71),('8998','2014-01-14','10:30:00',1.74),('8998','2014-01-14','10:35:00',1.08),('8998','2014-01-14','10:40:00',1.07),('8998','2014-01-14','10:45:00',1.56),('8998','2014-01-14','10:50:00',1.09),('8998','2014-01-14','11:05:00',1.02),('8998','2014-01-14','11:10:00',1.93),('8998','2014-01-14','11:15:00',1.77),('8998','2014-01-14','11:20:00',1.72),('8998','2014-01-14','11:25:00',1.64),('8998','2014-01-14','11:30:00',1.57),('8998','2014-01-14','11:35:00',1.51),('8998','2014-01-14','11:40:00',1.16),('8998','2014-01-14','11:45:00',1.63),('8998','2014-01-14','11:50:00',1.42),('8998','2014-01-14','11:55:00',1.33),('8998','2014-01-14','12:00:00',1.1),('8998','2014-01-14','12:05:00',1.08),('8998','2014-01-14','12:10:00',1.09),('8998','2014-01-14','12:15:00',1.25),('8998','2014-01-14','12:20:00',1.62),('8998','2014-01-14','12:25:00',1.44),('8998','2014-01-14','12:50:00',1),('8998','2014-01-14','13:15:00',1.35),('8998','2014-01-14','13:20:00',1.34),('8998','2014-01-14','13:25:00',1.22),('8998','2014-01-14','13:30:00',1.13),('8998','2014-01-14','13:35:00',1.03),('8998','2014-01-13','10:30:00',2.02),('8998','2014-01-13','10:35:00',2.26),('8998','2014-01-13','10:40:00',1.9),('8998','2014-01-13','10:45:00',1.76),('8998','2014-01-13','10:50:00',1.1),('8998','2014-01-13','11:00:00',1.01),('8998','2014-01-13','11:40:00',1.04),('8998','2014-01-12','09:15:00',1.21),('8998','2014-01-12','09:20:00',1.37),('8998','2014-01-12','09:25:00',1.38),('8998','2014-01-12','09:30:00',1.41),('8998','2014-01-12','09:35:00',1.44),('8998','2014-01-12','09:40:00',1.46),('8998','2014-01-12','09:45:00',1.48),('8998','2014-01-12','09:50:00',1.49),('8998','2014-01-12','09:55:00',1.51),('8998','2014-01-12','10:00:00',1.52),('8998','2014-01-12','10:05:00',1.52),('8998','2014-01-12','10:10:00',1.53),('8998','2014-01-12','10:15:00',1.54),('8998','2014-01-12','10:20:00',1.57),('8998','2014-01-12','10:25:00',1.58),('8998','2014-01-12','10:30:00',1.59),('8998','2014-01-12','10:35:00',1.6),('8998','2014-01-12','10:40:00',1.58),('8998','2014-01-12','10:45:00',1.62),('8998','2014-01-12','10:50:00',1.63),('8998','2014-01-12','10:55:00',1.64),('8998','2014-01-12','11:00:00',1.62),('8998','2014-01-12','11:05:00',1.64),('8998','2014-01-12','11:10:00',1.64),('8998','2014-01-12','11:15:00',1.64),('8998','2014-01-12','11:20:00',1.63),('8998','2014-01-12','11:25:00',1.62),('8998','2014-01-12','11:30:00',1.6),('8998','2014-01-12','11:35:00',1.6),('8998','2014-01-12','11:40:00',1.57),('8998','2014-01-12','11:45:00',1.55),('8998','2014-01-12','11:50:00',1.53),('8998','2014-01-12','11:55:00',1.51),('8998','2014-01-12','12:00:00',1.44),('8998','2014-01-12','12:05:00',1.43),('8998','2014-01-12','12:10:00',1.43),('8998','2014-01-12','12:15:00',1.42),('8998','2014-01-12','12:20:00',1.41),('8998','2014-01-12','12:25:00',1.37),('8998','2014-01-12','12:30:00',1.32),('8998','2014-01-12','12:35:00',1.3),('8998','2014-01-12','12:40:00',1.29),('8998','2014-01-12','12:45:00',1.27),('8998','2014-01-12','12:50:00',1.21),('8998','2014-01-12','12:55:00',1.16),('8998','2014-01-12','13:00:00',1.16),('8998','2014-01-12','13:05:00',1.1),('8998','2014-01-12','13:10:00',1.07),('8998','2014-01-12','13:15:00',1.01),('8998','2014-01-11','10:55:00',1.07),('8998','2014-01-11','11:00:00',1.09),('8998','2014-01-11','11:05:00',1.07),('8998','2014-01-11','11:10:00',1.33),('8998','2014-01-11','11:15:00',1.19),('8998','2014-01-11','11:20:00',1.17),('8998','2014-01-11','11:25:00',1.05),('8998','2014-01-11','11:30:00',1.15),('8998','2014-01-11','11:40:00',1.09),('8998','2014-01-11','11:45:00',1.26),('8998','2014-01-11','11:50:00',1.28),('8998','2014-01-11','11:55:00',1.26),('8998','2014-01-10','09:55:00',1.16),('8998','2014-01-10','10:00:00',1.35),('8998','2014-01-10','10:05:00',1.03),('8998','2014-01-10','10:15:00',1.13),('8998','2014-01-10','10:20:00',1.1),('8998','2014-01-10','10:25:00',1.36),('8998','2014-01-10','10:30:00',1.29),('8998','2014-01-10','10:35:00',1.32),('8998','2014-01-10','10:40:00',1.61),('8998','2014-01-10','10:45:00',1.71),('8998','2014-01-10','10:50:00',1.71),('8998','2014-01-10','10:55:00',1.66),('8998','2014-01-10','11:00:00',1.6),('8998','2014-01-10','11:05:00',1.51),('8998','2014-01-10','11:10:00',1.59),('8998','2014-01-10','11:15:00',1.47),('8998','2014-01-10','11:20:00',1.3),('8998','2014-01-10','11:25:00',1.28),('8998','2014-01-10','11:30:00',1.27),('8998','2014-01-10','11:35:00',1.18),('8998','2014-01-10','11:40:00',1.04),('8998','2014-01-10','11:45:00',1.07),('8998','2014-01-10','11:50:00',1.15),('8998','2014-01-10','11:55:00',1.15),('8998','2014-01-10','12:00:00',1.16),('8998','2014-01-10','12:05:00',1.26),('8998','2014-01-10','12:55:00',1.14),('8998','2014-01-10','13:00:00',1.13),('8998','2014-01-10','13:15:00',1.08),('8998','2014-01-08','09:30:00',1.04),('8998','2014-01-08','09:35:00',1.31),('8998','2014-01-08','09:40:00',1.23),('8998','2014-01-08','09:45:00',1.36),('8998','2014-01-08','09:50:00',1.48),('8998','2014-01-08','09:55:00',1.46),('8998','2014-01-08','10:00:00',1.47),('8998','2014-01-08','10:05:00',1.44),('8998','2014-01-08','10:10:00',1.19),('8998','2014-01-08','10:15:00',1.26),('8998','2014-01-08','10:20:00',1.3),('8998','2014-01-08','10:25:00',1.33),('8998','2014-01-08','10:30:00',1.38),('8998','2014-01-08','10:35:00',1.35),('8998','2014-01-08','10:40:00',1.35),('8998','2014-01-08','10:45:00',1.38),('8998','2014-01-08','10:50:00',1.49),('8998','2014-01-08','10:55:00',1.11),('8998','2014-01-08','11:45:00',1.05),('8998','2014-01-07','09:00:00',1),('8998','2014-01-07','09:05:00',1.06),('8998','2014-01-07','09:10:00',1.13),('8998','2014-01-07','09:15:00',1.19),('8998','2014-01-07','09:20:00',1.23),('8998','2014-01-07','09:25:00',1.25),('8998','2014-01-07','09:30:00',1.27),('8998','2014-01-07','09:35:00',1.28),('8998','2014-01-07','09:40:00',1.38),('8998','2014-01-07','09:45:00',1.42),('8998','2014-01-07','09:50:00',1.4),('8998','2014-01-07','09:55:00',1.44),('8998','2014-01-07','10:00:00',1.46),('8998','2014-01-07','10:05:00',1.43),('8998','2014-01-07','10:10:00',1.42),('8998','2014-01-07','10:15:00',1.46),('8998','2014-01-07','10:20:00',1.56),('8998','2014-01-07','10:25:00',1.6),('8998','2014-01-07','10:30:00',1.6),('8998','2014-01-07','10:35:00',1.48),('8998','2014-01-07','10:40:00',1.46),('8998','2014-01-07','10:45:00',1.58),('8998','2014-01-07','10:50:00',1.62),('8998','2014-01-07','10:55:00',1.64),('8998','2014-01-07','11:00:00',1.62),('8998','2014-01-07','11:05:00',1.62),('8998','2014-01-07','11:10:00',1.62),('8998','2014-01-07','11:15:00',1.63),('8998','2014-01-07','11:20:00',1.61),('8998','2014-01-07','11:25:00',1.6),('8998','2014-01-07','11:30:00',1.58),('8998','2014-01-07','11:35:00',1.62),('8998','2014-01-07','11:40:00',1.62),('8998','2014-01-07','11:45:00',1.57),('8998','2014-01-07','11:50:00',1.55),('8998','2014-01-07','11:55:00',1.5),('8998','2014-01-07','12:00:00',1.48),('8998','2014-01-07','12:05:00',1.47),('8998','2014-01-07','12:10:00',1.43),('8998','2014-01-07','12:15:00',1.42),('8998','2014-01-07','12:20:00',1.39),('8998','2014-01-07','12:25:00',1.37),('8998','2014-01-07','12:30:00',1.35),('8998','2014-01-07','12:35:00',1.32),('8998','2014-01-07','12:40:00',1.27),('8998','2014-01-07','12:45:00',1.19),('8998','2014-01-07','12:50:00',1.16),('8998','2014-01-07','12:55:00',1.15),('8998','2014-01-07','13:00:00',1.14),('8998','2014-01-07','13:05:00',1.09),('8998','2014-01-06','08:50:00',1.04),('8998','2014-01-06','08:55:00',1.06),('8998','2014-01-06','09:00:00',1.07),('8998','2014-01-06','09:05:00',1.24),('8998','2014-01-06','09:10:00',1.28),('8998','2014-01-06','09:15:00',1.32),('8998','2014-01-06','09:20:00',1.36),('8998','2014-01-06','09:25:00',1.39),('8998','2014-01-06','09:30:00',1.43),('8998','2014-01-06','09:35:00',1.46),('8998','2014-01-06','09:40:00',1.48),('8998','2014-01-06','09:45:00',1.51),('8998','2014-01-06','09:50:00',1.53),('8998','2014-01-06','09:55:00',1.55),('8998','2014-01-06','10:00:00',1.56),('8998','2014-01-06','10:05:00',1.57),('8998','2014-01-06','10:10:00',1.59),('8998','2014-01-06','10:15:00',1.6),('8998','2014-01-06','10:20:00',1.61),('8998','2014-01-06','10:25:00',1.62),('8998','2014-01-06','10:30:00',1.64),('8998','2014-01-06','10:35:00',1.65),('8998','2014-01-06','10:40:00',1.66),('8998','2014-01-06','10:45:00',1.67),('8998','2014-01-06','10:50:00',1.68),('8998','2014-01-06','10:55:00',1.68),('8998','2014-01-06','11:00:00',1.67),('8998','2014-01-06','11:05:00',1.67),('8998','2014-01-06','11:10:00',1.67),('8998','2014-01-06','11:15:00',1.66),('8998','2014-01-06','11:20:00',1.66),('8998','2014-01-06','11:25:00',1.66),('8998','2014-01-06','11:30:00',1.65),('8998','2014-01-06','11:35:00',1.64),('8998','2014-01-06','11:40:00',1.62),('8998','2014-01-06','11:45:00',1.61),('8998','2014-01-06','11:50:00',1.59),('8998','2014-01-06','11:55:00',1.57),('8998','2014-01-06','12:00:00',1.54),('8998','2014-01-06','12:05:00',1.52),('8998','2014-01-06','12:10:00',1.51),('8998','2014-01-06','12:15:00',1.46),('8998','2014-01-06','12:20:00',1.45),('8998','2014-01-06','12:25:00',1.42),('8998','2014-01-06','12:30:00',1.39),('8998','2014-01-06','12:35:00',1.35),('8998','2014-01-06','12:40:00',1.3),('8998','2014-01-06','12:45:00',1.28),('8998','2014-01-06','12:50:00',1.27),('8998','2014-01-06','12:55:00',1.22),('8998','2014-01-06','13:00:00',1.12),('8998','2014-01-06','13:05:00',1.04),('8998','2014-04-23','07:50:00',1.19),('8998','2014-04-23','07:55:00',1.29),('8998','2014-04-23','08:00:00',1.28),('8998','2014-04-23','08:05:00',1.3),('8998','2014-04-23','08:10:00',1.26),('8998','2014-04-23','08:15:00',1.29),('8998','2014-04-23','08:20:00',1.48),('8998','2014-04-23','08:25:00',1.64),('8998','2014-04-23','08:30:00',1.52),('8998','2014-04-23','08:35:00',1.41),('8998','2014-04-23','08:40:00',1.45),('8998','2014-04-23','08:45:00',1.54),('8998','2014-04-23','08:50:00',1.48),('8998','2014-04-23','08:55:00',1.59),('8998','2014-04-23','09:00:00',1.66),('8998','2014-04-23','09:05:00',1.83),('8998','2014-04-23','09:10:00',2.09),('8998','2014-04-23','09:15:00',2.24),('8998','2014-04-23','09:20:00',2.28),('8998','2014-04-23','09:25:00',2.35),('8998','2014-04-23','09:30:00',2.41),('8998','2014-04-23','09:35:00',2.45),('8998','2014-04-23','09:40:00',2.5),('8998','2014-04-23','09:45:00',2.58),('8998','2014-04-23','09:50:00',2.6),('8998','2014-04-23','09:55:00',2.61),('8998','2014-04-23','10:00:00',2.64),('8998','2014-04-23','10:05:00',2.67),('8998','2014-04-23','10:10:00',2.68),('8998','2014-04-23','10:15:00',2.71),('8998','2014-04-23','10:20:00',2.73),('8998','2014-04-23','10:25:00',2.72),('8998','2014-04-23','10:30:00',2.74),('8998','2014-04-23','10:35:00',2.75),('8998','2014-04-23','10:40:00',2.77),('8998','2014-04-23','10:45:00',2.79),('8998','2014-04-23','10:50:00',2.8),('8998','2014-04-23','10:55:00',2.81),('8998','2014-04-23','11:00:00',2.85),('8998','2014-04-23','11:05:00',2.87),('8998','2014-04-23','11:10:00',2.85),('8998','2014-04-23','11:15:00',2.87),('8998','2014-04-23','11:20:00',2.86),('8998','2014-04-23','11:25:00',2.85),('8998','2014-04-23','11:30:00',2.86),('8998','2014-04-23','11:35:00',2.87),('8998','2014-04-23','11:40:00',2.86),('8998','2014-04-23','11:45:00',2.83),('8998','2014-04-23','11:50:00',2.86),('8998','2014-04-23','11:55:00',2.87),('8998','2014-04-23','12:00:00',2.84),('8998','2014-04-23','12:05:00',2.86),('8998','2014-04-23','12:10:00',2.86),('8998','2014-04-23','12:15:00',2.93),('8998','2014-04-23','12:20:00',2.9),('8998','2014-04-23','12:25:00',2.81),('8998','2014-04-23','12:30:00',2.89),('8998','2014-04-23','12:35:00',2.86),('8998','2014-04-23','12:40:00',2.84),('8998','2014-04-23','12:45:00',2.87),('8998','2014-04-23','12:50:00',2.88),('8998','2014-04-23','12:55:00',2.74),('8998','2014-04-23','13:00:00',2.67),('8998','2014-04-23','13:05:00',2.76),('8998','2014-04-23','13:10:00',2.81),('8998','2014-04-23','13:15:00',2.84),('8998','2014-04-23','13:20:00',2.84),('8998','2014-04-23','13:25:00',2.76),('8998','2014-04-23','13:30:00',2.75),('8998','2014-04-23','13:35:00',2.74),('8998','2014-04-23','13:45:00',2.9),('8998','2014-04-23','13:50:00',1.05),('8998','2014-04-23','13:55:00',1.58),('8998','2014-04-23','14:00:00',2.16),('8998','2014-04-23','14:05:00',1.24),('8998','2014-04-23','14:10:00',2.59),('8998','2014-04-23','14:15:00',1.91),('8998','2014-04-23','14:20:00',2.14),('8998','2014-04-23','14:25:00',1.88),('8998','2014-04-23','14:30:00',2.7),('8998','2014-04-23','14:35:00',2.56),('8998','2014-04-23','14:40:00',1.78),('8998','2014-04-23','14:45:00',2.13),('8998','2014-04-23','14:50:00',1.02),('8998','2014-04-23','14:55:00',2.09),('8998','2014-04-23','15:00:00',2.79),('8998','2014-04-23','15:05:00',2.69),('8998','2014-04-23','15:10:00',2.38),('8998','2014-04-23','15:15:00',2.34),('8998','2014-04-23','15:20:00',1.5),('8998','2014-04-23','15:25:00',1.37),('8998','2014-04-23','15:30:00',1.49),('8998','2014-04-23','15:35:00',1.6),('8998','2014-04-23','15:40:00',1.3),('8998','2014-04-23','15:45:00',1.19),('8998','2014-04-23','15:50:00',1.48),('8998','2014-04-23','15:55:00',1.37),('8998','2014-04-23','16:00:00',1.86),('8998','2014-04-23','16:05:00',1.73),('8998','2014-04-23','16:10:00',1.33),('8998','2014-04-23','16:15:00',1.44),('8998','2014-04-23','16:20:00',1.43),('8998','2014-04-23','16:25:00',1.3),('8998','2014-04-23','16:30:00',1.62),('8998','2014-04-23','16:35:00',1.06),('8998','2014-04-23','16:40:00',1.05),('8998','2014-04-23','16:45:00',1.06),('8998','2014-01-05','11:40:00',1.78),('8998','2014-01-05','11:45:00',1.63),('8998','2014-01-05','11:50:00',1.63),('8998','2014-01-05','11:55:00',1.52),('8998','2014-01-05','12:00:00',1.58),('8998','2014-01-05','12:05:00',1.58),('8998','2014-01-05','12:10:00',1.53),('8998','2014-01-05','12:15:00',1.48),('8998','2014-01-05','12:20:00',1.44),('8998','2014-01-05','12:25:00',1.43),('8998','2014-01-05','12:30:00',1.39),('8998','2014-01-05','12:35:00',1.36),('8998','2014-01-05','12:40:00',1.34),('8998','2014-01-05','12:45:00',1.32),('8998','2014-01-05','12:50:00',1.32),('8998','2014-01-05','12:55:00',1.24),('8998','2014-01-05','13:00:00',1.15),('8998','2014-01-05','13:05:00',1.06),('8998','2014-01-02','09:20:00',1.14),('8998','2014-01-02','09:30:00',1.19),('8998','2014-01-02','09:35:00',1.42),('8998','2014-01-02','09:40:00',1.59),('8998','2014-01-02','09:45:00',1.55),('8998','2014-01-02','10:00:00',1.13),('8998','2014-01-02','10:05:00',1.34),('8998','2014-01-02','10:20:00',1.51),('8998','2014-01-02','12:05:00',1.02),('8998','2014-01-02','12:10:00',1.08),('8998','2014-01-02','12:45:00',1.04),('8998','2014-01-02','12:55:00',1.12),('8998','2014-01-01','08:50:00',1.02),('8998','2014-01-01','08:55:00',1.05),('8998','2014-01-01','09:05:00',1.18),('8998','2014-01-01','09:10:00',1.22),('8998','2014-01-01','09:15:00',1.25),('8998','2014-01-01','09:20:00',1.3),('8998','2014-01-01','09:25:00',1.33),('8998','2014-01-01','09:30:00',1.34),('8998','2014-01-01','09:35:00',1.36),('8998','2014-01-01','09:40:00',1.39),('8998','2014-01-01','09:45:00',1.42),('8998','2014-01-01','09:50:00',1.43),('8998','2014-01-01','09:55:00',1.46),('8998','2014-01-01','10:00:00',1.49),('8998','2014-01-01','10:05:00',1.56),('8998','2014-01-01','10:10:00',1.56),('8998','2014-01-01','10:15:00',1.53),('8998','2014-01-01','10:20:00',1.53),('8998','2014-01-01','10:25:00',1.55),('8998','2014-01-01','10:30:00',1.56),('8998','2014-01-01','10:35:00',1.57),('8998','2014-01-01','10:40:00',1.55),('8998','2014-01-01','10:45:00',1.55),('8998','2014-01-01','10:50:00',1.56),('8998','2014-01-01','10:55:00',1.6),('8998','2014-01-01','11:00:00',1.58),('8998','2014-01-01','11:05:00',1.56),('8998','2014-01-01','11:10:00',1.18),('8998','2014-01-01','11:30:00',1.01),('8998','2014-01-01','11:35:00',1.05),('8998','2014-01-01','11:40:00',1.06),('8998','2014-01-01','11:45:00',1.03),('8998','2014-01-01','12:55:00',1.25),('8998','2013-12-31','08:55:00',1.14),('8998','2013-12-31','09:00:00',1.08),('8998','2013-12-31','09:05:00',1.06),('8998','2013-12-31','09:10:00',1.48),('8998','2013-12-31','09:30:00',1.56),('8998','2013-12-31','09:40:00',1.19),('8998','2013-12-31','09:45:00',1.26),('8998','2013-12-31','09:50:00',1.68),('8998','2013-12-31','09:55:00',1.07),('8998','2013-12-31','13:40:00',1.18),('8998','2013-12-30','08:50:00',1.09),('8998','2013-12-30','09:00:00',1.3),('8998','2013-12-30','09:05:00',1.04),('8998','2013-12-30','09:15:00',1.09),('8998','2013-12-30','09:20:00',1.4),('8998','2013-12-30','09:25:00',1.43),('8998','2013-12-30','09:30:00',1.54),('8998','2013-12-30','09:35:00',1.58),('8998','2013-12-30','09:40:00',1.53),('8998','2013-12-30','09:45:00',1.54),('8998','2013-12-30','09:50:00',1.42),('8998','2013-12-30','11:10:00',1.23),('8998','2013-12-30','11:15:00',1.37),('8998','2013-12-30','11:20:00',1.06),('8998','2013-12-30','11:25:00',1.23),('8998','2013-12-30','11:30:00',1.29),('8998','2013-12-30','11:40:00',1.42),('8998','2013-12-30','11:55:00',1.62),('8998','2013-12-30','12:00:00',1.59),('8998','2013-12-30','12:05:00',1.54),('8998','2013-12-30','12:10:00',1.51),('8998','2013-12-30','12:15:00',1.48),('8998','2013-12-30','12:20:00',1.45),('8998','2013-12-30','12:25:00',1.41),('8998','2013-12-30','12:30:00',1.39),('8998','2013-12-30','12:35:00',1.35),('8998','2013-12-30','12:40:00',1.32),('8998','2013-12-30','12:45:00',1.28),('8998','2013-12-30','12:50:00',1.24),('8998','2013-12-30','12:55:00',1.18),('8998','2013-12-30','13:00:00',1.14),('8998','2013-12-30','13:05:00',1.08),('8998','2013-12-30','13:10:00',1.04),('8998','2013-12-28','08:40:00',1.21),('8998','2013-12-28','08:45:00',1.08),('8998','2013-12-28','09:10:00',1.15),('8998','2013-12-28','09:15:00',1.23),('8998','2013-12-28','09:20:00',1.39),('8998','2013-12-28','09:25:00',1.39),('8998','2013-12-28','09:30:00',1.43),('8998','2013-12-28','09:35:00',1.42),('8998','2013-12-28','09:40:00',1.47),('8998','2013-12-28','09:45:00',1.48),('8998','2013-12-28','09:50:00',1.41),('8998','2013-12-28','09:55:00',1.17),('8998','2013-12-28','10:00:00',1.24),('8998','2013-12-28','10:05:00',1.34),('8998','2013-12-28','10:10:00',1.04),('8998','2013-12-28','10:15:00',1.59),('8998','2013-12-28','10:20:00',1.68),('8998','2013-12-28','10:25:00',1.44),('8998','2013-12-28','10:30:00',1.8),('8998','2013-12-28','10:35:00',1.89),('8998','2013-12-28','10:40:00',2.11),('8998','2013-12-27','08:45:00',1.03),('8998','2013-12-27','08:50:00',1.08),('8998','2013-12-27','09:00:00',1.12),('8998','2013-12-27','09:05:00',1.21),('8998','2013-12-27','09:10:00',1.25),('8998','2013-12-27','09:15:00',1.3),('8998','2013-12-27','09:20:00',1.35),('8998','2013-12-27','09:25:00',1.39),('8998','2013-12-27','09:30:00',1.43),('8998','2013-12-27','09:35:00',1.44),('8998','2013-12-27','09:40:00',1.46),('8998','2013-12-27','09:45:00',1.49),('8998','2013-12-27','09:50:00',1.52),('8998','2013-12-27','09:55:00',1.54),('8998','2013-12-27','10:00:00',1.56),('8998','2013-12-27','10:05:00',1.56),('8998','2013-12-27','10:10:00',1.58),('8998','2013-12-27','10:15:00',1.58),('8998','2013-12-27','10:20:00',1.6),('8998','2013-12-27','10:25:00',1.62),('8998','2013-12-27','10:30:00',1.63),('8998','2013-12-27','10:35:00',1.64),('8998','2013-12-27','10:40:00',1.64),('8998','2013-12-27','10:45:00',1.64),('8998','2013-12-27','10:50:00',1.64),('8998','2013-12-27','10:55:00',1.64),('8998','2013-12-27','11:00:00',1.64),('8998','2013-12-27','11:05:00',1.64),('8998','2013-12-27','11:10:00',1.64),('8998','2013-12-27','11:15:00',1.63),('8998','2013-12-27','11:20:00',1.62),('8998','2013-12-27','11:25:00',1.61),('8998','2013-12-27','11:30:00',1.6),('8998','2013-12-27','11:35:00',1.59),('8998','2013-12-27','11:40:00',1.57),('8998','2013-12-27','11:45:00',1.56),('8998','2013-12-27','11:50:00',1.53),('8998','2013-12-27','11:55:00',1.51),('8998','2013-12-27','12:00:00',1.48),('8998','2013-12-27','12:05:00',1.44),('8998','2013-12-27','12:10:00',1.45),('8998','2013-12-27','12:15:00',1.43),('8998','2013-12-27','12:20:00',1.4),('8998','2013-12-27','12:25:00',1.36),('8998','2013-12-27','12:30:00',1.32),('8998','2013-12-27','12:35:00',1.29),('8998','2013-12-27','12:40:00',1.25),('8998','2013-12-27','12:45:00',1.22),('8998','2013-12-27','12:50:00',1.17),('8998','2013-12-27','12:55:00',1.06),('8998','2014-04-22','13:40:00',1.05),('8998','2014-04-22','13:45:00',1.08),('8998','2014-04-22','13:50:00',1.08),('8998','2014-04-22','13:55:00',1.04),('8998','2014-04-22','14:50:00',1.05),('8998','2014-04-22','14:55:00',1.2),('8998','2014-04-22','15:00:00',1.25),('8998','2014-04-22','15:05:00',1.25),('8998','2014-04-22','15:10:00',1.19),('8998','2014-04-22','15:15:00',1.15),('8998','2013-12-26','12:15:00',1.46),('8998','2013-12-26','12:45:00',1.07),('8998','2013-12-26','12:50:00',1.18),('8998','2013-12-26','12:55:00',1.08),('8998','2013-12-26','13:30:00',1.01),('8998','2013-12-26','13:35:00',1.13),('8998','2013-12-24','10:30:00',1.02),('8998','2013-12-24','10:35:00',1.16),('8998','2013-12-24','10:40:00',1.16),('8998','2013-12-24','10:45:00',1.01),('8998','2013-12-24','10:50:00',1.16),('8998','2013-12-24','11:20:00',1.05),('8998','2013-12-24','11:25:00',1.14),('8998','2013-12-24','11:30:00',1.06),('8998','2013-12-24','11:40:00',1.11),('8998','2013-12-24','11:45:00',1.18),('8998','2013-12-24','11:55:00',1.41),('8998','2013-12-24','12:00:00',1.5),('8998','2013-12-23','09:05:00',1.1),('8998','2013-12-23','09:10:00',1.14),('8998','2013-12-23','09:15:00',1.18),('8998','2013-12-23','09:20:00',1.21),('8998','2013-12-23','09:25:00',1.23),('8998','2013-12-23','09:30:00',1.29),('8998','2013-12-23','09:35:00',1.34),('8998','2013-12-23','09:40:00',1.37),('8998','2013-12-23','09:45:00',1.38),('8998','2013-12-23','09:50:00',1.37),('8998','2013-12-23','09:55:00',1.38),('8998','2013-12-23','10:00:00',1.35),('8998','2013-12-23','10:05:00',1.35),('8998','2013-12-23','10:10:00',1.42),('8998','2013-12-23','10:15:00',1.47),('8998','2013-12-23','10:20:00',1.45),('8998','2013-12-23','10:25:00',1.46),('8998','2013-12-23','10:30:00',1.49),('8998','2013-12-23','10:35:00',1.49),('8998','2013-12-23','10:40:00',1.5),('8998','2013-12-23','10:45:00',1.52),('8998','2013-12-23','10:50:00',1.51),('8998','2013-12-23','10:55:00',1.49),('8998','2013-12-23','11:00:00',1.49),('8998','2013-12-23','11:05:00',1.51),('8998','2013-12-23','11:10:00',1.47),('8998','2013-12-23','11:15:00',1.47),('8998','2013-12-23','11:20:00',1.48),('8998','2013-12-23','11:25:00',1.48),('8998','2013-12-23','11:30:00',1.48),('8998','2013-12-23','11:35:00',1.46),('8998','2013-12-23','11:40:00',1.45),('8998','2013-12-23','11:45:00',1.44),('8998','2013-12-23','11:50:00',1.41),('8998','2013-12-23','11:55:00',1.38),('8998','2013-12-23','12:00:00',1.35),('8998','2013-12-23','12:05:00',1.32),('8998','2013-12-23','12:10:00',1.29),('8998','2013-12-23','12:15:00',1.26),('8998','2013-12-23','12:20:00',1.25),('8998','2013-12-23','12:25:00',1.23),('8998','2013-12-23','12:30:00',1.2),('8998','2013-12-23','12:35:00',1.16),('8998','2013-12-23','12:40:00',1.12),('8998','2013-12-23','12:45:00',1.09),('8998','2013-12-23','12:50:00',1.05),('8998','2013-12-22','09:55:00',1.23),('8998','2013-12-22','10:00:00',1.44),('8998','2013-12-22','10:05:00',1.55),('8998','2013-12-22','10:10:00',1.6),('8998','2013-12-22','10:15:00',1.46),('8998','2013-12-22','10:20:00',1.56),('8998','2013-12-22','10:25:00',1.51),('8998','2013-12-22','10:30:00',1.39),('8998','2013-12-22','10:35:00',1.39),('8998','2013-12-22','10:40:00',1.4),('8998','2013-12-22','10:45:00',1.4),('8998','2013-12-22','10:50:00',1.38),('8998','2013-12-22','10:55:00',1.41),('8998','2013-12-22','11:00:00',1.62),('8998','2013-12-22','11:05:00',1.69),('8998','2013-12-22','11:10:00',1.69),('8998','2013-12-22','11:15:00',1.68),('8998','2013-12-22','11:20:00',1.6),('8998','2013-12-22','11:25:00',1.62),('8998','2013-12-22','11:30:00',1.51),('8998','2013-12-22','11:35:00',1.54),('8998','2013-12-22','11:40:00',1.56),('8998','2013-12-22','11:45:00',1.35),('8998','2013-12-22','11:50:00',1.36),('8998','2013-12-22','11:55:00',1.36),('8998','2013-12-22','12:00:00',1.38),('8998','2013-12-22','12:05:00',1.41),('8998','2013-12-22','12:10:00',1.36),('8998','2013-12-22','12:15:00',1.31),('8998','2013-12-22','12:20:00',1.29),('8998','2013-12-22','12:25:00',1.25),('8998','2013-12-22','12:30:00',1.3),('8998','2013-12-22','12:35:00',1.27),('8998','2013-12-22','12:40:00',1.23),('8998','2013-12-22','12:45:00',1.19),('8998','2013-12-22','12:50:00',1.14),('8998','2013-12-21','09:20:00',1.05),('8998','2013-12-21','09:30:00',1.03),('8998','2013-12-21','09:35:00',1.23),('8998','2013-12-21','09:40:00',1.68),('8998','2013-12-21','09:45:00',1.71),('8998','2013-12-21','09:50:00',1.8),('8998','2013-12-21','09:55:00',1.81),('8998','2013-12-21','10:00:00',1.78),('8998','2013-12-21','10:05:00',1.76),('8998','2013-12-21','10:10:00',1.77),('8998','2013-12-21','10:15:00',1.72),('8998','2013-12-21','10:20:00',1.64),('8998','2013-12-21','10:25:00',1.63),('8998','2013-12-21','10:30:00',1.69),('8998','2013-12-21','10:35:00',1.57),('8998','2013-12-21','10:40:00',1.46),('8998','2013-12-21','10:45:00',1.5),('8998','2013-12-21','10:50:00',1.57),('8998','2013-12-21','10:55:00',1.45),('8998','2013-12-21','11:00:00',1.28),('8998','2013-12-21','11:05:00',1.24),('8998','2013-12-21','11:10:00',1.64),('8998','2013-12-21','11:15:00',1.61),('8998','2013-12-21','11:20:00',1.44),('8998','2013-12-21','11:25:00',1.45),('8998','2013-12-21','11:30:00',1.35),('8998','2013-12-21','11:35:00',1.32),('8998','2013-12-21','11:40:00',1.4),('8998','2013-12-21','11:45:00',1.3),('8998','2013-12-21','12:35:00',1.04),('8998','2013-12-21','12:40:00',1.03),('8998','2013-12-21','12:50:00',1.11),('8998','2013-12-21','12:55:00',1.26),('8998','2013-12-21','13:00:00',1.2),('8998','2013-12-21','13:05:00',1.34),('8998','2013-12-21','13:10:00',1.31),('8998','2013-12-21','13:15:00',1.06),('8998','2013-12-20','08:50:00',1),('8998','2013-12-20','09:00:00',1.12),('8998','2013-12-20','09:05:00',1.14),('8998','2013-12-20','09:10:00',1.17),('8998','2013-12-20','09:15:00',1.22),('8998','2013-12-20','09:20:00',1.25),('8998','2013-12-20','09:25:00',1.28),('8998','2013-12-20','09:30:00',1.31),('8998','2013-12-20','09:35:00',1.35),('8998','2013-12-20','09:40:00',1.37),('8998','2013-12-20','09:45:00',1.39),('8998','2013-12-20','09:50:00',1.42),('8998','2013-12-20','09:55:00',1.46),('8998','2013-12-20','10:00:00',1.49),('8998','2013-12-20','10:05:00',1.5),('8998','2013-12-20','10:10:00',1.51),('8998','2013-12-20','10:15:00',1.52),('8998','2013-12-20','10:20:00',1.53),('8998','2013-12-20','10:25:00',1.54),('8998','2013-12-20','10:30:00',1.56),('8998','2013-12-20','10:35:00',1.57),('8998','2013-12-20','10:40:00',1.57),('8998','2013-12-20','10:45:00',1.58),('8998','2013-12-20','10:50:00',1.58),('8998','2013-12-20','10:55:00',1.57),('8998','2013-12-20','11:00:00',1.58),('8998','2013-12-20','11:05:00',1.59),('8998','2013-12-20','11:10:00',1.58),('8998','2013-12-20','11:15:00',1.57),('8998','2013-12-20','11:20:00',1.57),('8998','2013-12-20','11:25:00',1.57),('8998','2013-12-20','11:30:00',1.56),('8998','2013-12-20','11:35:00',1.54),('8998','2013-12-20','11:40:00',1.53),('8998','2013-12-20','11:45:00',1.51),('8998','2013-12-20','11:50:00',1.5),('8998','2013-12-20','11:55:00',1.48),('8998','2013-12-20','12:00:00',1.46),('8998','2013-12-20','12:05:00',1.44),('8998','2013-12-20','12:10:00',1.41),('8998','2013-12-20','12:15:00',1.38),('8998','2013-12-20','12:20:00',1.36),('8998','2013-12-20','12:25:00',1.33),('8998','2013-12-20','12:30:00',1.3),('8998','2013-12-20','12:35:00',1.27),('8998','2013-12-20','12:40:00',1.24),('8998','2013-12-20','12:45:00',1.18),('8998','2013-12-20','12:50:00',1.15),('8998','2013-12-20','12:55:00',1.08),('8998','2013-12-20','13:00:00',1.03),('8998','2013-12-19','09:05:00',1.07),('8998','2013-12-19','09:10:00',1.12),('8998','2013-12-19','09:15:00',1.15),('8998','2013-12-19','09:20:00',1.2),('8998','2013-12-19','09:25:00',1.24),('8998','2013-12-19','09:30:00',1.27),('8998','2013-12-19','09:35:00',1.3),('8998','2013-12-19','09:40:00',1.33),('8998','2013-12-19','09:45:00',1.36),('8998','2013-12-19','09:50:00',1.37),('8998','2013-12-19','09:55:00',1.39),('8998','2013-12-19','10:00:00',1.41),('8998','2013-12-19','10:05:00',1.43),('8998','2013-12-19','10:10:00',1.43),('8998','2013-12-19','10:15:00',1.44),('8998','2013-12-19','10:20:00',1.46),('8998','2013-12-19','10:25:00',1.48),('8998','2013-12-19','10:30:00',1.47),('8998','2013-12-19','10:35:00',1.48),('8998','2013-12-19','10:40:00',1.5),('8998','2013-12-19','10:45:00',1.5),('8998','2013-12-19','10:50:00',1.51),('8998','2013-12-19','10:55:00',1.51),('8998','2013-12-19','11:00:00',1.51),('8998','2013-12-19','11:05:00',1.51),('8998','2013-12-19','11:10:00',1.49),('8998','2013-12-19','11:15:00',1.48),('8998','2013-12-19','11:20:00',1.48),('8998','2013-12-19','11:25:00',1.47),('8998','2013-12-19','11:30:00',1.45),('8998','2013-12-19','11:35:00',1.44),('8998','2013-12-19','11:40:00',1.44),('8998','2013-12-19','11:45:00',1.43),('8998','2013-12-19','11:50:00',1.42),('8998','2013-12-19','11:55:00',1.41),('8998','2013-12-19','12:00:00',1.38),('8998','2013-12-19','12:05:00',1.35),('8998','2013-12-19','12:10:00',1.35),('8998','2013-12-19','12:15:00',1.32),('8998','2013-12-19','12:20:00',1.29),('8998','2013-12-19','12:25:00',1.24),('8998','2013-12-19','12:30:00',1.23),('8998','2013-12-19','12:35:00',1.2),('8998','2013-12-19','12:40:00',1.17),('8998','2013-12-19','12:45:00',1.11),('8998','2013-12-19','12:50:00',1.05),('8998','2013-12-18','09:00:00',1.14),('8998','2013-12-18','09:05:00',1.28),('8998','2013-12-18','09:10:00',1.2),('8998','2013-12-18','09:15:00',1.12),('8998','2013-12-18','09:25:00',1.41),('8998','2013-12-18','09:35:00',1.1),('8998','2013-12-18','09:50:00',1.08),('8998','2013-12-18','09:55:00',1.63),('8998','2013-12-18','10:00:00',1.48),('8998','2013-12-18','10:05:00',1.47),('8998','2013-12-18','10:10:00',1.54),('8998','2013-12-18','10:15:00',1.56),('8998','2013-12-18','10:20:00',1.27),('8998','2013-12-18','10:45:00',1.25),('8998','2013-12-18','10:50:00',1.76),('8998','2013-12-18','11:15:00',1.32),('8998','2013-12-17','08:55:00',1.09),('8998','2013-12-17','09:00:00',1.14),('8998','2013-12-17','09:05:00',1.18),('8998','2013-12-17','09:10:00',1.23),('8998','2013-12-17','09:15:00',1.26),('8998','2013-12-17','09:20:00',1.3),('8998','2013-12-17','09:25:00',1.33),('8998','2013-12-17','09:30:00',1.36),('8998','2013-12-17','09:35:00',1.39),('8998','2013-12-17','09:40:00',1.4),('8998','2013-12-17','09:45:00',1.44),('8998','2013-12-17','09:50:00',1.45),('8998','2013-12-17','09:55:00',1.46),('8998','2013-12-17','10:00:00',1.48),('8998','2013-12-17','10:05:00',1.52),('8998','2013-12-17','10:10:00',1.54),('8998','2013-12-17','10:15:00',1.56),('8998','2013-12-17','10:20:00',1.57),('8998','2013-12-17','10:25:00',1.58),('8998','2013-12-17','10:30:00',1.6),('8998','2013-12-17','10:35:00',1.6),('8998','2013-12-17','10:40:00',1.59),('8998','2013-12-17','10:45:00',1.59),('8998','2013-12-17','10:50:00',1.59),('8998','2013-12-17','10:55:00',1.59),('8998','2013-12-17','11:00:00',1.58),('8998','2013-12-17','11:05:00',1.58),('8998','2013-12-17','11:10:00',1.58),('8998','2013-12-17','11:15:00',1.57),('8998','2013-12-17','11:20:00',1.55),('8998','2013-12-17','11:25:00',1.53),('8998','2013-12-17','11:30:00',1.52),('8998','2013-12-17','11:35:00',1.5),('8998','2013-12-17','11:40:00',1.49),('8998','2013-12-17','11:45:00',1.47),('8998','2013-12-17','11:50:00',1.45),('8998','2013-12-17','11:55:00',1.44),('8998','2013-12-17','12:00:00',1.42),('8998','2013-12-17','12:05:00',1.4),('8998','2013-12-17','12:10:00',1.39),('8998','2013-12-17','12:15:00',1.36),('8998','2013-12-17','12:20:00',1.33),('8998','2013-12-17','12:25:00',1.3),('8998','2013-12-17','12:30:00',1.29),('8998','2013-12-17','12:35:00',1.24),('8998','2013-12-17','12:40:00',1.2),('8998','2013-12-17','12:45:00',1.16),('8998','2013-12-17','12:50:00',1.07),('8998','2014-04-21','07:55:00',1.09),('8998','2014-04-21','08:00:00',1.14),('8998','2014-04-21','08:05:00',1.16),('8998','2014-04-21','08:10:00',1.25),('8998','2014-04-21','08:15:00',1.3),('8998','2014-04-21','08:20:00',1.37),('8998','2014-04-21','08:25:00',1.54),('8998','2014-04-21','08:30:00',1.48),('8998','2014-04-21','08:35:00',1.47),('8998','2014-04-21','08:40:00',1.58),('8998','2014-04-21','08:45:00',1.57),('8998','2014-04-21','08:50:00',1.63),('8998','2014-04-21','08:55:00',1.7),('8998','2014-04-21','09:00:00',1.69),('8998','2014-04-21','09:05:00',1.85),('8998','2014-04-21','09:10:00',1.77),('8998','2014-04-21','09:15:00',1.68),('8998','2014-04-21','09:20:00',1.88),('8998','2014-04-21','09:25:00',1.89),('8998','2014-04-21','09:30:00',1.54),('8998','2014-04-21','09:35:00',1.96),('8998','2014-04-21','09:40:00',2.43),('8998','2014-04-21','09:45:00',2.52),('8998','2014-04-21','09:50:00',2.02),('8998','2014-04-21','09:55:00',1.13),('8998','2014-04-21','10:05:00',1.03),('8998','2014-04-21','10:10:00',1.4),('8998','2014-04-21','10:15:00',1.55),('8998','2014-04-21','10:20:00',2.39),('8998','2014-04-21','10:25:00',1.77),('8998','2014-04-21','10:30:00',2.65),('8998','2014-04-21','10:35:00',2.88),('8998','2014-04-21','10:40:00',2.65),('8998','2014-04-21','10:45:00',2.86),('8998','2014-04-21','10:50:00',3.27),('8998','2014-04-21','10:55:00',2.34),('8998','2014-04-21','11:00:00',1.5),('8998','2014-04-21','11:05:00',1.63),('8998','2014-04-21','11:10:00',1.19),('8998','2014-04-21','12:30:00',1.12),('8998','2014-04-21','12:35:00',1.06),('8998','2014-04-21','13:20:00',1.49),('8998','2014-04-21','13:25:00',1.74),('8998','2014-04-21','13:30:00',1.96),('8998','2014-04-21','13:35:00',1.76),('8998','2014-04-21','13:40:00',2.15),('8998','2014-04-21','13:45:00',2.15),('8998','2014-04-21','13:50:00',1.93),('8998','2014-04-21','13:55:00',1.12),('8998','2014-04-21','14:05:00',1.04),('8998','2014-04-21','14:10:00',2.22),('8998','2014-04-21','14:15:00',2.07),('8998','2014-04-21','14:20:00',2.3),('8998','2014-04-21','14:25:00',1.9),('8998','2014-04-21','14:30:00',1.3),('8998','2014-04-21','14:35:00',1.51),('8998','2014-04-21','14:40:00',2.02),('8998','2014-04-21','14:45:00',2.39),('8998','2014-04-21','14:50:00',2.15),('8998','2014-04-21','14:55:00',1.76),('8998','2014-04-21','15:30:00',1.11),('8998','2014-04-21','15:35:00',1.49),('8998','2014-04-21','15:40:00',1.35),('8998','2014-04-21','15:45:00',1.11),('8998','2014-04-21','15:50:00',1.3),('8998','2014-04-21','15:55:00',1.16),('8998','2014-04-21','16:00:00',1.31),('8998','2014-04-21','16:05:00',1.01),('8998','2014-04-21','16:20:00',1.03),('8998','2014-04-21','16:25:00',1.02),('8998','2013-12-16','08:40:00',1.04),('8998','2013-12-16','08:45:00',1.1),('8998','2013-12-16','08:55:00',1.21),('8998','2013-12-16','09:00:00',1.25),('8998','2013-12-16','09:05:00',1.29),('8998','2013-12-16','09:10:00',1.33),('8998','2013-12-16','09:15:00',1.36),('8998','2013-12-16','09:20:00',1.38),('8998','2013-12-16','09:25:00',1.41),('8998','2013-12-16','09:30:00',1.44),('8998','2013-12-16','09:35:00',1.46),('8998','2013-12-16','09:40:00',1.49),('8998','2013-12-16','09:45:00',1.52),('8998','2013-12-16','09:50:00',1.55),('8998','2013-12-16','09:55:00',1.57),('8998','2013-12-16','10:00:00',1.58),('8998','2013-12-16','10:05:00',1.6),('8998','2013-12-16','10:10:00',1.61),('8998','2013-12-16','10:15:00',1.61),('8998','2013-12-16','10:20:00',1.63),('8998','2013-12-16','10:25:00',1.63),('8998','2013-12-16','10:30:00',1.65),('8998','2013-12-16','10:35:00',1.65),('8998','2013-12-16','10:40:00',1.65),('8998','2013-12-16','10:45:00',1.64),('8998','2013-12-16','10:50:00',1.63),('8998','2013-12-16','10:55:00',1.63),('8998','2013-12-16','11:00:00',1.63),('8998','2013-12-16','11:05:00',1.62),('8998','2013-12-16','11:10:00',1.62),('8998','2013-12-16','11:15:00',1.62),('8998','2013-12-16','11:20:00',1.61),('8998','2013-12-16','11:25:00',1.59),('8998','2013-12-16','11:30:00',1.59),('8998','2013-12-16','11:35:00',1.57),('8998','2013-12-16','11:40:00',1.56),('8998','2013-12-16','11:45:00',1.55),('8998','2013-12-16','11:50:00',1.53),('8998','2013-12-16','11:55:00',1.5),('8998','2013-12-16','12:00:00',1.47),('8998','2013-12-16','12:05:00',1.45),('8998','2013-12-16','12:10:00',1.42),('8998','2013-12-16','12:15:00',1.41),('8998','2013-12-16','12:20:00',1.38),('8998','2013-12-16','12:25:00',1.35),('8998','2013-12-16','12:30:00',1.32),('8998','2013-12-16','12:35:00',1.3),('8998','2013-12-16','12:40:00',1.25),('8998','2013-12-16','12:45:00',1.2),('8998','2013-12-16','12:50:00',1.09),('8998','2013-12-15','08:40:00',1.02),('8998','2013-12-15','08:45:00',1.06),('8998','2013-12-15','08:55:00',1.18),('8998','2013-12-15','09:00:00',1.23),('8998','2013-12-15','09:05:00',1.27),('8998','2013-12-15','09:10:00',1.3),('8998','2013-12-15','09:15:00',1.33),('8998','2013-12-15','09:20:00',1.35),('8998','2013-12-15','09:25:00',1.39),('8998','2013-12-15','09:30:00',1.43),('8998','2013-12-15','09:35:00',1.46),('8998','2013-12-15','09:40:00',1.48),('8998','2013-12-15','09:45:00',1.5),('8998','2013-12-15','09:50:00',1.52),('8998','2013-12-15','09:55:00',1.53),('8998','2013-12-15','10:00:00',1.54),('8998','2013-12-15','10:05:00',1.56),('8998','2013-12-15','10:10:00',1.58),('8998','2013-12-15','10:15:00',1.58),('8998','2013-12-15','10:20:00',1.58),('8998','2013-12-15','10:25:00',1.57),('8998','2013-12-15','10:30:00',1.58),('8998','2013-12-15','10:35:00',1.58),('8998','2013-12-15','10:40:00',1.59),('8998','2013-12-15','10:45:00',1.59),('8998','2013-12-15','10:50:00',1.6),('8998','2013-12-15','10:55:00',1.6),('8998','2013-12-15','11:00:00',1.6),('8998','2013-12-15','11:05:00',1.59),('8998','2013-12-15','11:10:00',1.58),('8998','2013-12-15','11:15:00',1.57),('8998','2013-12-15','11:20:00',1.55),('8998','2013-12-15','11:25:00',1.55),('8998','2013-12-15','11:30:00',1.55),('8998','2013-12-15','11:35:00',1.54),('8998','2013-12-15','11:40:00',1.51),('8998','2013-12-15','11:45:00',1.5),('8998','2013-12-15','11:50:00',1.48),('8998','2013-12-15','11:55:00',1.47),('8998','2013-12-15','12:00:00',1.46),('8998','2013-12-15','12:05:00',1.44),('8998','2013-12-15','12:10:00',1.43),('8998','2013-12-15','12:15:00',1.4),('8998','2013-12-15','12:20:00',1.38),('8998','2013-12-15','12:25:00',1.35),('8998','2013-12-15','12:30:00',1.31),('8998','2013-12-15','12:35:00',1.28),('8998','2013-12-15','12:40:00',1.24),('8998','2013-12-15','12:45:00',1.2),('8998','2013-12-15','12:50:00',1.07),('8998','2013-12-15','12:55:00',1.05),('8998','2013-12-15','13:00:00',1.04),('8998','2013-12-13','08:55:00',1.09),('8998','2013-12-13','09:00:00',1.14),('8998','2013-12-13','09:05:00',1.19),('8998','2013-12-13','09:10:00',1.24),('8998','2013-12-13','09:15:00',1.28),('8998','2013-12-13','09:20:00',1.33),('8998','2013-12-13','09:25:00',1.36),('8998','2013-12-13','09:30:00',1.39),('8998','2013-12-13','09:35:00',1.42),('8998','2013-12-13','09:40:00',1.44),('8998','2013-12-13','09:45:00',1.46),('8998','2013-12-13','09:50:00',1.48),('8998','2013-12-13','09:55:00',1.49),('8998','2013-12-13','10:00:00',1.5),('8998','2013-12-13','10:05:00',1.52),('8998','2013-12-13','10:10:00',1.53),('8998','2013-12-13','10:15:00',1.56),('8998','2013-12-13','10:20:00',1.57),('8998','2013-12-13','10:25:00',1.56),('8998','2013-12-13','10:30:00',1.56),('8998','2013-12-13','10:35:00',1.57),('8998','2013-12-13','10:40:00',1.57),('8998','2013-12-13','10:45:00',1.57),('8998','2013-12-13','10:50:00',1.57),('8998','2013-12-13','10:55:00',1.55),('8998','2013-12-13','11:00:00',1.54),('8998','2013-12-13','11:05:00',1.53),('8998','2013-12-13','11:10:00',1.55),('8998','2013-12-13','11:15:00',1.54),('8998','2013-12-13','11:20:00',1.53),('8998','2013-12-13','11:25:00',1.51),('8998','2013-12-13','11:30:00',1.5),('8998','2013-12-13','11:35:00',1.49),('8998','2013-12-13','11:40:00',1.49),('8998','2013-12-13','11:45:00',1.45),('8998','2013-12-13','11:50:00',1.41),('8998','2013-12-13','11:55:00',1.38),('8998','2013-12-13','12:00:00',1.35),('8998','2013-12-13','12:05:00',1.34),('8998','2013-12-13','12:10:00',1.31),('8998','2013-12-13','12:15:00',1.31),('8998','2013-12-13','12:20:00',1.27),('8998','2013-12-13','12:25:00',1.24),('8998','2013-12-13','12:30:00',1.19),('8998','2013-12-13','12:35:00',1.17),('8998','2013-12-13','12:40:00',1.14),('8998','2013-12-13','12:45:00',1.09),('8998','2013-12-13','12:50:00',1.01),('8998','2013-12-12','09:00:00',1.03),('8998','2013-12-12','09:05:00',1.07),('8998','2013-12-12','09:10:00',1.11),('8998','2013-12-12','09:15:00',1.17),('8998','2013-12-12','09:20:00',1.21),('8998','2013-12-12','09:25:00',1.23),('8998','2013-12-12','09:30:00',1.24),('8998','2013-12-12','09:35:00',1.26),('8998','2013-12-12','09:40:00',1.29),('8998','2013-12-12','09:45:00',1.31),('8998','2013-12-12','09:50:00',1.35),('8998','2013-12-12','09:55:00',1.37),('8998','2013-12-12','10:00:00',1.38),('8998','2013-12-12','10:05:00',1.4),('8998','2013-12-12','10:10:00',1.41),('8998','2013-12-12','10:15:00',1.43),('8998','2013-12-12','10:20:00',1.44),('8998','2013-12-12','10:25:00',1.44),('8998','2013-12-12','10:30:00',1.46),('8998','2013-12-12','10:35:00',1.48),('8998','2013-12-12','10:40:00',1.48),('8998','2013-12-12','10:45:00',1.48),('8998','2013-12-12','10:50:00',1.48),('8998','2013-12-12','10:55:00',1.5),('8998','2013-12-12','11:00:00',1.5),('8998','2013-12-12','11:05:00',1.49),('8998','2013-12-12','11:10:00',1.46),('8998','2013-12-12','11:15:00',1.47),('8998','2013-12-12','11:20:00',1.48),('8998','2013-12-12','11:25:00',1.47),('8998','2013-12-12','11:30:00',1.45),('8998','2013-12-12','11:35:00',1.43),('8998','2013-12-12','11:40:00',1.41),('8998','2013-12-12','11:45:00',1.42),('8998','2013-12-12','11:50:00',1.4),('8998','2013-12-12','11:55:00',1.38),('8998','2013-12-12','12:00:00',1.38),('8998','2013-12-12','12:05:00',1.35),('8998','2013-12-12','12:10:00',1.3),('8998','2013-12-12','12:15:00',1.27),('8998','2013-12-12','12:20:00',1.23),('8998','2013-12-12','12:25:00',1.24),('8998','2013-12-12','12:30:00',1.22),('8998','2013-12-12','12:35:00',1.19),('8998','2013-12-12','12:40:00',1.15),('8998','2013-12-12','12:45:00',1.13),('8998','2013-12-11','08:55:00',1.1),('8998','2013-12-11','09:00:00',1.14),('8998','2013-12-11','09:05:00',1.17),('8998','2013-12-11','09:10:00',1.22),('8998','2013-12-11','09:15:00',1.25),('8998','2013-12-11','09:20:00',1.27),('8998','2013-12-11','09:25:00',1.32),('8998','2013-12-11','09:30:00',1.35),('8998','2013-12-11','09:35:00',1.39),('8998','2013-12-11','09:40:00',1.42),('8998','2013-12-11','09:45:00',1.43),('8998','2013-12-11','09:50:00',1.45),('8998','2013-12-11','09:55:00',1.46),('8998','2013-12-11','10:00:00',1.48),('8998','2013-12-11','10:05:00',1.5),('8998','2013-12-11','10:10:00',1.52),('8998','2013-12-11','10:15:00',1.54),('8998','2013-12-11','10:20:00',1.54),('8998','2013-12-11','10:25:00',1.54),('8998','2013-12-11','10:30:00',1.56),('8998','2013-12-11','10:35:00',1.56),('8998','2013-12-11','10:40:00',1.56),('8998','2013-12-11','10:45:00',1.56),('8998','2013-12-11','10:50:00',1.57),('8998','2013-12-11','10:55:00',1.56),('8998','2013-12-11','11:00:00',1.55),('8998','2013-12-11','11:05:00',1.54),('8998','2013-12-11','11:10:00',1.53),('8998','2013-12-11','11:15:00',1.53),('8998','2013-12-11','11:20:00',1.51),('8998','2013-12-11','11:25:00',1.51),('8998','2013-12-11','11:30:00',1.5),('8998','2013-12-11','11:35:00',1.5),('8998','2013-12-11','11:40:00',1.48),('8998','2013-12-11','11:45:00',1.45),('8998','2013-12-11','11:50:00',1.42),('8998','2013-12-11','11:55:00',1.4),('8998','2013-12-11','12:00:00',1.38),('8998','2013-12-11','12:05:00',1.38),('8998','2013-12-11','12:10:00',1.36),('8998','2013-12-11','12:15:00',1.33),('8998','2013-12-11','12:20:00',1.29),('8998','2013-12-11','12:25:00',1.28),('8998','2013-12-11','12:30:00',1.24),('8998','2013-12-11','12:35:00',1.21),('8998','2013-12-11','12:40:00',1.17),('8998','2013-12-11','12:45:00',1.13),('8998','2013-12-10','08:45:00',1.01),('8998','2013-12-10','08:55:00',1.15),('8998','2013-12-10','09:00:00',1.18),('8998','2013-12-10','09:05:00',1.22),('8998','2013-12-10','09:10:00',1.26),('8998','2013-12-10','09:15:00',1.3),('8998','2013-12-10','09:20:00',1.33),('8998','2013-12-10','09:25:00',1.36),('8998','2013-12-10','09:30:00',1.4),('8998','2013-12-10','09:35:00',1.43),('8998','2013-12-10','09:40:00',1.46),('8998','2013-12-10','09:45:00',1.49),('8998','2013-12-10','09:50:00',1.5),('8998','2013-12-10','09:55:00',1.54),('8998','2013-12-10','10:00:00',1.54),('8998','2013-12-10','10:05:00',1.55),('8998','2013-12-10','10:10:00',1.58),('8998','2013-12-10','10:15:00',1.59),('8998','2013-12-10','10:20:00',1.61),('8998','2013-12-10','10:25:00',1.62),('8998','2013-12-10','10:30:00',1.65),('8998','2013-12-10','10:35:00',1.66),('8998','2013-12-10','10:40:00',1.66),('8998','2013-12-10','10:45:00',1.63),('8998','2013-12-10','10:50:00',1.61),('8998','2013-12-10','10:55:00',1.61),('8998','2013-12-10','11:00:00',1.63),('8998','2013-12-10','11:05:00',1.64),('8998','2013-12-10','11:10:00',1.63),('8998','2013-12-10','11:15:00',1.61),('8998','2013-12-10','11:20:00',1.6),('8998','2013-12-10','11:25:00',1.55),('8998','2013-12-10','11:30:00',1.53),('8998','2013-12-10','11:35:00',1.53),('8998','2013-12-10','11:40:00',1.53),('8998','2013-12-10','11:45:00',1.51),('8998','2013-12-10','11:50:00',1.5),('8998','2013-12-10','11:55:00',1.49),('8998','2013-12-10','12:00:00',1.47),('8998','2013-12-10','12:05:00',1.44),('8998','2013-12-10','12:10:00',1.42),('8998','2013-12-10','12:15:00',1.4),('8998','2013-12-10','12:20:00',1.37),('8998','2013-12-10','12:25:00',1.29),('8998','2013-12-10','12:30:00',1.26),('8998','2013-12-10','12:35:00',1.24),('8998','2013-12-10','12:40:00',1.21),('8998','2013-12-10','12:45:00',1.17),('8998','2013-12-10','12:50:00',1.1),('8998','2013-12-10','12:55:00',1.06),('8998','2013-12-10','13:00:00',1.03),('8998','2013-12-09','08:40:00',1.01),('8998','2013-12-09','08:50:00',1.09),('8998','2013-12-09','08:55:00',1.18),('8998','2013-12-09','09:00:00',1.23),('8998','2013-12-09','09:05:00',1.27),('8998','2013-12-09','09:10:00',1.31),('8998','2013-12-09','09:15:00',1.34),('8998','2013-12-09','09:20:00',1.39),('8998','2013-12-09','09:25:00',1.42),('8998','2013-12-09','09:30:00',1.43),('8998','2013-12-09','09:35:00',1.45),('8998','2013-12-09','09:40:00',1.48),('8998','2013-12-09','09:45:00',1.51),('8998','2013-12-09','09:50:00',1.53),('8998','2013-12-09','09:55:00',1.56),('8998','2013-12-09','10:00:00',1.58),('8998','2013-12-09','10:05:00',1.6),('8998','2013-12-09','10:10:00',1.61),('8998','2013-12-09','10:15:00',1.62),('8998','2013-12-09','10:20:00',1.61),('8998','2013-12-09','10:25:00',1.61),('8998','2013-12-09','10:30:00',1.62),('8998','2013-12-09','10:35:00',1.63),('8998','2013-12-09','10:40:00',1.63),('8998','2013-12-09','10:45:00',1.63),('8998','2013-12-09','10:50:00',1.64),('8998','2013-12-09','10:55:00',1.64),('8998','2013-12-09','11:00:00',1.63),('8998','2013-12-09','11:05:00',1.63),('8998','2013-12-09','11:10:00',1.62),('8998','2013-12-09','11:15:00',1.62),('8998','2013-12-09','11:20:00',1.61),('8998','2013-12-09','11:25:00',1.6),('8998','2013-12-09','11:30:00',1.59),('8998','2013-12-09','11:35:00',1.58),('8998','2013-12-09','11:40:00',1.56),('8998','2013-12-09','11:45:00',1.54),('8998','2013-12-09','11:50:00',1.52),('8998','2013-12-09','11:55:00',1.5),('8998','2013-12-09','12:00:00',1.47),('8998','2013-12-09','12:05:00',1.44),('8998','2013-12-09','12:10:00',1.41),('8998','2013-12-09','12:15:00',1.38),('8998','2013-12-09','12:20:00',1.36),('8998','2013-12-09','12:25:00',1.32),('8998','2013-12-09','12:30:00',1.29),('8998','2013-12-09','12:35:00',1.23),('8998','2013-12-09','12:40:00',1.19),('8998','2013-12-09','12:45:00',1.14),('8998','2013-12-09','12:50:00',1.01),('8998','2013-12-08','09:35:00',1.39),('8998','2013-12-08','09:40:00',1.49),('8998','2013-12-08','09:45:00',1.49),('8998','2013-12-08','09:50:00',1.48),('8998','2013-12-08','09:55:00',1.5),('8998','2013-12-08','10:00:00',1.51),('8998','2013-12-08','10:05:00',1.57),('8998','2013-12-08','10:10:00',1.9),('8998','2013-12-08','10:15:00',1.85),('8998','2013-12-08','10:20:00',2.05),('8998','2013-12-08','10:25:00',1.32),('8998','2013-12-08','12:30:00',1.21),('8998','2013-12-08','12:55:00',1.02),('8998','2013-12-08','13:00:00',1.29),('8998','2013-12-08','13:05:00',1.03),('8998','2013-12-08','13:20:00',1.03),('8998','2013-12-07','11:15:00',1.08),('8998','2013-12-07','11:20:00',1.19),('8998','2014-04-20','09:20:00',1.16),('8998','2014-04-20','09:25:00',1.04),('8998','2014-04-20','10:00:00',1.08),('8998','2014-04-20','10:05:00',1.95),('8998','2014-04-20','10:10:00',2.74),('8998','2014-04-20','10:15:00',2.92),('8998','2014-04-20','10:20:00',2.8),('8998','2014-04-20','10:25:00',2.79),('8998','2014-04-20','10:30:00',2.76),('8998','2014-04-20','10:35:00',2.76),('8998','2014-04-20','10:40:00',2.77),('8998','2014-04-20','10:45:00',2.78),('8998','2014-04-20','10:50:00',2.79),('8998','2014-04-20','10:55:00',2.8),('8998','2014-04-20','11:00:00',2.81),('8998','2014-04-20','11:05:00',2.82),('8998','2014-04-20','11:10:00',2.83),('8998','2014-04-20','11:15:00',2.84),('8998','2014-04-20','11:20:00',2.84),('8998','2014-04-20','11:25:00',2.85),('8998','2014-04-20','11:30:00',2.85),('8998','2014-04-20','11:35:00',2.86),('8998','2014-04-20','11:40:00',2.86),('8998','2014-04-20','11:45:00',2.88),('8998','2014-04-20','11:50:00',2.89),('8998','2014-04-20','11:55:00',2.89),('8998','2014-04-20','12:00:00',2.88),('8998','2014-04-20','12:05:00',2.86),('8998','2014-04-20','12:10:00',2.86),('8998','2014-04-20','12:15:00',2.87),('8998','2014-04-20','12:20:00',2.88),('8998','2014-04-20','12:25:00',2.88),('8998','2014-04-20','12:30:00',2.87),('8998','2014-04-20','12:35:00',2.86),('8998','2014-04-20','12:40:00',2.86),('8998','2014-04-20','12:45:00',2.84),('8998','2014-04-20','12:50:00',2.83),('8998','2014-04-20','12:55:00',2.81),('8998','2014-04-20','13:00:00',2.78),('8998','2014-04-20','13:05:00',2.77),('8998','2014-04-20','13:10:00',2.75),('8998','2014-04-20','13:15:00',2.72),('8998','2014-04-20','13:20:00',2.7),('8998','2014-04-20','13:25:00',2.68),('8998','2014-04-20','13:30:00',2.66),('8998','2014-04-20','13:35:00',2.62),('8998','2014-04-20','13:40:00',2.57),('8998','2014-04-20','13:45:00',2.57),('8998','2014-04-20','13:50:00',2.56),('8998','2014-04-20','13:55:00',2.53),('8998','2014-04-20','14:00:00',2.51),('8998','2014-04-20','14:05:00',2.48),('8998','2014-04-20','14:10:00',2.44),('8998','2014-04-20','14:15:00',2.42),('8998','2014-04-20','14:20:00',2.39),('8998','2014-04-20','14:25:00',2.35),('8998','2014-04-20','14:30:00',2.31),('8998','2014-04-20','14:35:00',2.26),('8998','2014-04-20','14:40:00',2.21),('8998','2014-04-20','14:45:00',2.17),('8998','2014-04-20','14:50:00',2.13),('8998','2014-04-20','14:55:00',2.08),('8998','2014-04-20','15:00:00',2.04),('8998','2014-04-20','15:05:00',2),('8998','2014-04-20','15:10:00',1.94),('8998','2014-04-20','15:15:00',1.89),('8998','2014-04-20','15:20:00',1.84),('8998','2014-04-20','15:25:00',1.78),('8998','2014-04-20','15:30:00',1.73),('8998','2014-04-20','15:35:00',1.67),('8998','2014-04-20','15:40:00',1.62),('8998','2014-04-20','15:45:00',1.56),('8998','2014-04-20','15:50:00',1.51),('8998','2014-04-20','15:55:00',1.46),('8998','2014-04-20','16:00:00',1.4),('8998','2014-04-20','16:05:00',1.35),('8998','2014-04-20','16:10:00',1.24),('8998','2014-04-20','16:15:00',1.03),('8998','2014-04-20','16:20:00',1.23),('8998','2014-04-20','16:25:00',1.13),('8998','2014-04-20','16:30:00',1.04),('8998','2013-12-06','08:40:00',1.04),('8998','2013-12-06','08:50:00',1.15),('8998','2013-12-06','08:55:00',1.18),('8998','2013-12-06','09:00:00',1.22),('8998','2013-12-06','09:05:00',1.26),('8998','2013-12-06','09:10:00',1.3),('8998','2013-12-06','09:15:00',1.35),('8998','2013-12-06','09:20:00',1.37),('8998','2013-12-06','09:25:00',1.39),('8998','2013-12-06','09:30:00',1.42),('8998','2013-12-06','09:35:00',1.45),('8998','2013-12-06','09:40:00',1.48),('8998','2013-12-06','09:45:00',1.48),('8998','2013-12-06','09:50:00',1.5),('8998','2013-12-06','09:55:00',1.51),('8998','2013-12-06','10:00:00',1.53),('8998','2013-12-06','10:05:00',1.56),('8998','2013-12-06','10:10:00',1.56),('8998','2013-12-06','10:15:00',1.57),('8998','2013-12-06','10:20:00',1.58),('8998','2013-12-06','10:25:00',1.59),('8998','2013-12-06','10:30:00',1.59),('8998','2013-12-06','10:35:00',1.61),('8998','2013-12-06','10:40:00',1.62),('8998','2013-12-06','10:45:00',1.61),('8998','2013-12-06','10:50:00',1.58),('8998','2013-12-06','10:55:00',1.56),('8998','2013-12-06','11:00:00',1.57),('8998','2013-12-06','11:05:00',1.57),('8998','2013-12-06','11:10:00',1.56),('8998','2013-12-06','11:15:00',1.55),('8998','2013-12-06','11:20:00',1.55),('8998','2013-12-06','11:25:00',1.54),('8998','2013-12-06','11:30:00',1.53),('8998','2013-12-06','11:35:00',1.5),('8998','2013-12-06','11:40:00',1.48),('8998','2013-12-06','11:45:00',1.46),('8998','2013-12-06','11:50:00',1.44),('8998','2013-12-06','11:55:00',1.41),('8998','2013-12-06','12:00:00',1.39),('8998','2013-12-06','12:05:00',1.37),('8998','2013-12-06','12:10:00',1.35),('8998','2013-12-06','12:15:00',1.34),('8998','2013-12-06','12:20:00',1.31),('8998','2013-12-06','12:25:00',1.28),('8998','2013-12-06','12:30:00',1.25),('8998','2013-12-06','12:35:00',1.22),('8998','2013-12-06','12:40:00',1.18),('8998','2013-12-06','12:45:00',1.13),('8998','2013-12-06','12:50:00',1.04),('8998','2013-12-05','11:40:00',1.14),('8998','2013-12-05','11:45:00',1.01),('8998','2013-12-05','11:50:00',1.17),('8998','2013-12-05','11:55:00',1.04),('8998','2013-12-05','12:10:00',1.04),('8998','2013-12-05','12:20:00',1.06),('8998','2013-12-05','12:35:00',1.1),('8998','2013-12-05','12:40:00',1.07),('8998','2013-12-04','08:35:00',1),('8998','2013-12-04','08:45:00',1.09),('8998','2013-12-04','08:50:00',1.21),('8998','2013-12-04','08:55:00',1.25),('8998','2013-12-04','09:00:00',1.28),('8998','2013-12-04','09:05:00',1.32),('8998','2013-12-04','09:10:00',1.36),('8998','2013-12-04','09:15:00',1.39),('8998','2013-12-04','09:20:00',1.43),('8998','2013-12-04','09:25:00',1.45),('8998','2013-12-04','09:30:00',1.48),('8998','2013-12-04','09:35:00',1.5),('8998','2013-12-04','09:40:00',1.52),('8998','2013-12-04','09:45:00',1.53),('8998','2013-12-04','09:50:00',1.56),('8998','2013-12-04','09:55:00',1.57),('8998','2013-12-04','10:00:00',1.58),('8998','2013-12-04','10:05:00',1.6),('8998','2013-12-04','10:10:00',1.61),('8998','2013-12-04','10:15:00',1.63),('8998','2013-12-04','10:20:00',1.63),('8998','2013-12-04','10:25:00',1.64),('8998','2013-12-04','10:30:00',1.65),('8998','2013-12-04','10:35:00',1.66),('8998','2013-12-04','10:40:00',1.65),('8998','2013-12-04','10:45:00',1.64),('8998','2013-12-04','10:50:00',1.63),('8998','2013-12-04','10:55:00',1.62),('8998','2013-12-04','11:00:00',1.62),('8998','2013-12-04','11:05:00',1.63),('8998','2013-12-04','11:10:00',1.58),('8998','2013-12-04','11:15:00',1.6),('8998','2013-12-04','11:20:00',1.6),('8998','2013-12-04','11:25:00',1.59),('8998','2013-12-04','11:30:00',1.59),('8998','2013-12-04','11:35:00',1.54),('8998','2013-12-04','11:40:00',1.53),('8998','2013-12-04','11:45:00',1.5),('8998','2013-12-04','11:50:00',1.48),('8998','2013-12-04','11:55:00',1.47),('8998','2013-12-04','12:00:00',1.46),('8998','2013-12-04','12:05:00',1.43),('8998','2013-12-04','12:10:00',1.38),('8998','2013-12-04','12:15:00',1.34),('8998','2013-12-04','12:20:00',1.35),('8998','2013-12-04','12:25:00',1.27),('8998','2013-12-04','12:30:00',1.25),('8998','2013-12-04','12:35:00',1.25),('8998','2013-12-04','12:40:00',1.2),('8998','2013-12-04','12:45:00',1.05),('8998','2013-12-03','08:25:00',1.01),('8998','2013-12-03','08:30:00',1.08),('8998','2013-12-03','08:35:00',1.13),('8998','2013-12-03','08:40:00',1.03),('8998','2013-12-03','08:45:00',1.27),('8998','2013-12-03','08:50:00',1.32),('8998','2013-12-03','08:55:00',1.37),('8998','2013-12-03','09:00:00',1.41),('8998','2013-12-03','09:05:00',1.44),('8998','2013-12-03','09:10:00',1.48),('8998','2013-12-03','09:15:00',1.5),('8998','2013-12-03','09:20:00',1.53),('8998','2013-12-03','09:25:00',1.55),('8998','2013-12-03','09:30:00',1.58),('8998','2013-12-03','09:35:00',1.61),('8998','2013-12-03','09:40:00',1.64),('8998','2013-12-03','09:45:00',1.66),('8998','2013-12-03','09:50:00',1.68),('8998','2013-12-03','09:55:00',1.69),('8998','2013-12-03','10:00:00',1.7),('8998','2013-12-03','10:05:00',1.72),('8998','2013-12-03','10:10:00',1.72),('8998','2013-12-03','10:15:00',1.73),('8998','2013-12-03','10:20:00',1.73),('8998','2013-12-03','10:25:00',1.74),('8998','2013-12-03','10:30:00',1.75),('8998','2013-12-03','10:35:00',1.75),('8998','2013-12-03','10:40:00',1.74),('8998','2013-12-03','10:45:00',1.75),('8998','2013-12-03','10:50:00',1.75),('8998','2013-12-03','10:55:00',1.75),('8998','2013-12-03','11:00:00',1.73),('8998','2013-12-03','11:05:00',1.72),('8998','2013-12-03','11:10:00',1.71),('8998','2013-12-03','11:15:00',1.7),('8998','2013-12-03','11:20:00',1.68),('8998','2013-12-03','11:25:00',1.67),('8998','2013-12-03','11:30:00',1.66),('8998','2013-12-03','11:35:00',1.65),('8998','2013-12-03','11:40:00',1.62),('8998','2013-12-03','11:45:00',1.61),('8998','2013-12-03','11:50:00',1.58),('8998','2013-12-03','11:55:00',1.56),('8998','2013-12-03','12:00:00',1.54),('8998','2013-12-03','12:05:00',1.51),('8998','2013-12-03','12:10:00',1.48),('8998','2013-12-03','12:15:00',1.44),('8998','2013-12-03','12:20:00',1.42),('8998','2013-12-03','12:25:00',1.39),('8998','2013-12-03','12:30:00',1.36),('8998','2013-12-03','12:35:00',1.32),('8998','2013-12-03','12:40:00',1.28),('8998','2013-12-03','12:45:00',1.22),('8998','2013-12-03','12:50:00',1.12),('8998','2013-12-03','12:55:00',1.01),('8998','2013-12-02','09:30:00',1.06),('8998','2013-12-02','09:35:00',1.04),('8998','2013-12-02','09:40:00',1.21),('8998','2013-12-02','09:45:00',1.3),('8998','2013-12-02','09:50:00',1.41),('8998','2013-12-02','09:55:00',1.37),('8998','2013-12-02','10:00:00',1.71),('8998','2013-12-02','10:05:00',1.7),('8998','2013-12-02','10:10:00',1.72),('8998','2013-12-02','10:15:00',1.73),('8998','2013-12-02','10:20:00',1.72),('8998','2013-12-02','10:25:00',1.73),('8998','2013-12-02','10:30:00',1.74),('8998','2013-12-02','10:35:00',1.74),('8998','2013-12-02','10:40:00',1.74),('8998','2013-12-02','10:45:00',1.73),('8998','2013-12-02','10:50:00',1.75),('8998','2013-12-02','10:55:00',1.77),('8998','2013-12-02','11:00:00',1.78),('8998','2013-12-02','11:05:00',1.78),('8998','2013-12-02','11:10:00',1.78),('8998','2013-12-02','11:15:00',1.77),('8998','2013-12-02','11:20:00',1.75),('8998','2013-12-02','11:25:00',1.72),('8998','2013-12-02','11:30:00',1.68),('8998','2013-12-02','11:35:00',1.67),('8998','2013-12-02','11:40:00',1.65),('8998','2013-12-02','11:45:00',1.64),('8998','2013-12-02','11:50:00',1.62),('8998','2013-12-02','11:55:00',1.61),('8998','2013-12-02','12:00:00',1.59),('8998','2013-12-02','12:05:00',1.58),('8998','2013-12-02','12:10:00',1.57),('8998','2013-12-02','12:15:00',1.57),('8998','2013-12-02','12:20:00',1.56),('8998','2013-12-02','12:25:00',1.55),('8998','2013-12-02','12:30:00',1.54),('8998','2013-12-02','12:35:00',1.55),('8998','2013-12-02','12:40:00',1.55),('8998','2013-12-02','12:45:00',1.54),('8998','2013-12-02','12:50:00',1.54),('8998','2013-12-02','12:55:00',1.55),('8998','2013-12-02','13:00:00',1.53),('8998','2013-12-02','13:05:00',1.5),('8998','2013-12-02','13:10:00',1.44),('8998','2013-12-02','13:15:00',1.34),('8998','2013-12-02','13:20:00',1.28),('8998','2013-12-02','13:25:00',1.18),('8998','2013-12-02','13:30:00',1.06),('8998','2013-11-29','09:10:00',1.1),('8998','2013-11-29','09:15:00',1.38),('8998','2013-11-29','09:20:00',1.52),('8998','2013-11-29','09:25:00',1.46),('8998','2013-11-29','09:30:00',1.35),('8998','2013-11-29','09:35:00',1.55),('8998','2013-11-29','09:40:00',1.72),('8998','2013-11-29','09:45:00',1.42),('8998','2013-11-29','09:50:00',1.05),('8998','2013-11-28','08:25:00',1.05),('8998','2013-11-28','08:30:00',1.1),('8998','2013-11-28','08:40:00',1.24),('8998','2013-11-28','08:45:00',1.29),('8998','2013-11-28','08:50:00',1.33),('8998','2013-11-28','08:55:00',1.37),('8998','2013-11-28','09:00:00',1.42),('8998','2013-11-28','09:05:00',1.46),('8998','2013-11-28','09:10:00',1.49),('8998','2013-11-28','09:15:00',1.52),('8998','2013-11-28','09:20:00',1.56),('8998','2013-11-28','09:25:00',1.59),('8998','2013-11-28','09:30:00',1.61),('8998','2013-11-28','09:35:00',1.64),('8998','2013-11-28','09:40:00',1.67),('8998','2013-11-28','09:45:00',1.69),('8998','2013-11-28','09:50:00',1.71),('8998','2013-11-28','09:55:00',1.73),('8998','2013-11-28','10:00:00',1.74),('8998','2013-11-28','10:05:00',1.76),('8998','2013-11-28','10:10:00',1.77),('8998','2013-11-28','10:15:00',1.77),('8998','2013-11-28','10:20:00',1.78),('8998','2013-11-28','10:25:00',1.79),('8998','2013-11-28','10:30:00',1.79),('8998','2013-11-28','10:35:00',1.79),('8998','2013-11-28','10:40:00',1.8),('8998','2013-11-28','10:45:00',1.8),('8998','2013-11-28','10:50:00',1.79),('8998','2013-11-28','10:55:00',1.79),('8998','2013-11-28','11:00:00',1.78),('8998','2013-11-28','11:05:00',1.78),('8998','2013-11-28','11:10:00',1.76),('8998','2013-11-28','11:15:00',1.75),('8998','2013-11-28','11:20:00',1.74),('8998','2013-11-28','11:25:00',1.74),('8998','2013-11-28','11:30:00',1.71),('8998','2013-11-28','11:35:00',1.7),('8998','2013-11-28','11:40:00',1.68),('8998','2013-11-28','11:45:00',1.66),('8998','2013-11-28','11:50:00',1.63),('8998','2013-11-28','11:55:00',1.61),('8998','2013-11-28','12:00:00',1.59),('8998','2013-11-28','12:05:00',1.56),('8998','2013-11-28','12:10:00',1.53),('8998','2013-11-28','12:15:00',1.5),('8998','2013-11-28','12:20:00',1.47),('8998','2013-11-28','12:25:00',1.44),('8998','2013-11-28','12:30:00',1.4),('8998','2013-11-28','12:35:00',1.35),('8998','2013-11-28','12:40:00',1.3),('8998','2013-11-28','12:45:00',1.25),('8998','2013-11-28','12:50:00',1.21),('8998','2013-11-28','12:55:00',1.17),('8998','2013-11-28','13:00:00',1.1),('8998','2013-11-28','13:05:00',1.03),('8998','2014-04-19','07:55:00',1.18),('8998','2014-04-19','08:00:00',1.16),('8998','2014-04-19','08:05:00',1.18),('8998','2014-04-19','08:10:00',1.21),('8998','2014-04-19','08:15:00',1.4),('8998','2014-04-19','08:20:00',1.65),('8998','2014-04-19','08:25:00',2.11),('8998','2014-04-19','08:30:00',2.16),('8998','2014-04-19','08:35:00',2.24),('8998','2014-04-19','08:40:00',1.86),('8998','2014-04-19','08:45:00',1.16),('8998','2014-04-19','08:50:00',1.81),('8998','2014-04-19','09:00:00',1.56),('8998','2014-04-19','09:10:00',1.21),('8998','2014-04-19','09:15:00',2.4),('8998','2014-04-19','09:20:00',2.54),('8998','2014-04-19','09:25:00',2.67),('8998','2014-04-19','09:30:00',2.82),('8998','2014-04-19','09:35:00',2.52),('8998','2014-04-19','09:40:00',1.47),('8998','2014-04-19','09:45:00',1.15),('8998','2014-04-19','09:50:00',1.17),('8998','2014-04-19','09:55:00',1.51),('8998','2014-04-19','10:00:00',1.82),('8998','2014-04-19','10:05:00',2.56),('8998','2014-04-19','10:10:00',2.15),('8998','2014-04-19','10:15:00',2.23),('8998','2014-04-19','10:20:00',2.3),('8998','2014-04-19','10:25:00',2.04),('8998','2014-04-19','10:30:00',1.91),('8998','2014-04-19','10:35:00',2.04),('8998','2014-04-19','10:40:00',2),('8998','2014-04-19','10:45:00',2.03),('8998','2014-04-19','10:50:00',2.28),('8998','2014-04-19','10:55:00',2.45),('8998','2014-04-19','11:00:00',2.64),('8998','2014-04-19','11:05:00',2.56),('8998','2014-04-19','11:10:00',2.34),('8998','2014-04-19','11:15:00',2.84),('8998','2014-04-19','11:20:00',2.57),('8998','2014-04-19','11:25:00',2.43),('8998','2014-04-19','11:30:00',3.06),('8998','2014-04-19','11:35:00',3.27),('8998','2014-04-19','11:40:00',2.48),('8998','2014-04-19','11:45:00',2.56),('8998','2014-04-19','11:50:00',2.66),('8998','2014-04-19','12:00:00',2.15),('8998','2014-04-19','12:05:00',2.05),('8998','2014-04-19','12:10:00',2.64),('8998','2014-04-19','12:15:00',2.37),('8998','2014-04-19','12:20:00',1.02),('8998','2014-04-19','12:25:00',2.58),('8998','2014-04-19','12:30:00',3.21),('8998','2014-04-19','12:35:00',2.99),('8998','2014-04-19','12:40:00',2.96),('8998','2014-04-19','12:45:00',2.94),('8998','2014-04-19','12:50:00',2.97),('8998','2014-04-19','12:55:00',2.97),('8998','2014-04-19','13:00:00',2.97),('8998','2014-04-19','13:05:00',2.94),('8998','2014-04-19','13:10:00',2.99),('8998','2014-04-19','13:15:00',2.94),('8998','2014-04-19','13:20:00',2.81),('8998','2014-04-19','13:25:00',2.78),('8998','2014-04-19','13:30:00',2.79),('8998','2014-04-19','13:35:00',2.76),('8998','2014-04-19','13:40:00',2.74),('8998','2014-04-19','13:45:00',2.71),('8998','2014-04-19','13:50:00',2.68),('8998','2014-04-19','13:55:00',2.63),('8998','2014-04-19','14:00:00',2.59),('8998','2014-04-19','14:05:00',2.58),('8998','2014-04-19','14:10:00',2.55),('8998','2014-04-19','14:15:00',2.59),('8998','2014-04-19','14:20:00',2.12),('8998','2014-04-19','14:25:00',1.84),('8998','2014-04-19','14:30:00',1.88),('8998','2014-04-19','14:35:00',1.59),('8998','2014-04-19','14:40:00',1.62),('8998','2014-04-19','14:45:00',1.71),('8998','2014-04-19','14:50:00',1.65),('8998','2014-04-19','14:55:00',1.85),('8998','2014-04-19','15:00:00',2.23),('8998','2014-04-19','15:05:00',2.25),('8998','2014-04-19','15:10:00',1.98),('8998','2014-04-19','15:15:00',2.06),('8998','2014-04-19','15:20:00',1.93),('8998','2014-04-19','15:25:00',1.88),('8998','2014-04-19','15:30:00',1.82),('8998','2014-04-19','15:35:00',1.75),('8998','2014-04-19','15:40:00',1.72),('8998','2014-04-19','15:45:00',1.51),('8998','2014-04-19','15:50:00',1.18),('8998','2014-04-19','15:55:00',1.59),('8998','2014-04-19','16:00:00',1.47),('8998','2014-04-19','16:05:00',1.41),('8998','2014-04-19','16:10:00',1.35),('8998','2014-04-19','16:15:00',1.29),('8998','2014-04-19','16:20:00',1.25),('8998','2014-04-19','16:30:00',1.15),('8998','2014-04-19','16:35:00',1),('8998','2013-11-26','10:45:00',1.06),('8998','2013-11-26','10:50:00',1.02),('8998','2013-11-26','11:10:00',1.22),('8998','2013-11-26','11:20:00',1.04),('8998','2013-11-26','11:30:00',1.33),('8998','2013-11-26','11:35:00',1.39),('8998','2013-11-26','11:40:00',1.09),('8998','2013-11-26','11:45:00',1.05),('8998','2013-11-26','11:50:00',1.28),('8998','2013-11-26','11:55:00',1.91),('8998','2013-11-26','12:00:00',1.86),('8998','2013-11-26','12:05:00',1.43),('8998','2013-11-26','12:15:00',1.19),('8998','2013-11-26','12:20:00',1.63),('8998','2013-11-26','12:30:00',1.25),('8998','2013-11-25','08:05:00',1.05),('8998','2013-11-25','08:10:00',1.11),('8998','2013-11-25','09:15:00',1.08),('8998','2013-11-25','09:20:00',1.09),('8998','2013-11-25','09:25:00',1),('8998','2013-11-25','09:35:00',1.02),('8998','2013-11-25','09:40:00',1.5),('8998','2013-11-25','09:45:00',1.09),('8998','2013-11-25','09:50:00',1.19),('8998','2013-11-25','09:55:00',1.49),('8998','2013-11-25','10:00:00',1.38),('8998','2013-11-25','10:05:00',1.64),('8998','2013-11-25','10:25:00',1.22),('8998','2013-11-25','10:30:00',1.77),('8998','2013-11-25','10:35:00',1.95),('8998','2013-11-25','10:40:00',1.94),('8998','2013-11-25','10:45:00',1.94),('8998','2013-11-25','10:50:00',1.97),('8998','2013-11-25','10:55:00',2),('8998','2013-11-25','11:00:00',2.12),('8998','2013-11-25','11:05:00',1.64),('8998','2013-11-25','11:10:00',2.09),('8998','2013-11-25','11:15:00',2.33),('8998','2013-11-25','11:20:00',2.14),('8998','2013-11-25','11:25:00',2.11),('8998','2013-11-25','11:30:00',2.13),('8998','2013-11-25','11:35:00',2.22),('8998','2013-11-25','11:40:00',2.08),('8998','2013-11-25','11:45:00',1.98),('8998','2013-11-25','11:50:00',1.87),('8998','2013-11-25','11:55:00',1.01),('8998','2013-11-25','12:20:00',1.62),('8998','2013-11-25','12:25:00',1.56),('8998','2013-11-25','12:30:00',1.5),('8998','2013-11-25','12:35:00',1.47),('8998','2013-11-25','12:40:00',1.42),('8998','2013-11-25','12:45:00',1.35),('8998','2013-11-25','12:50:00',1.29),('8998','2013-11-25','12:55:00',1.26),('8998','2013-11-25','13:00:00',1.21),('8998','2013-11-25','13:05:00',1.12),('8998','2013-11-25','13:10:00',1.07),('8998','2013-11-25','13:15:00',1.02),('8998','2013-11-24','08:15:00',1.08),('8998','2013-11-24','08:20:00',1.17),('8998','2013-11-24','08:25:00',1.27),('8998','2013-11-24','08:30:00',1.3),('8998','2013-11-24','08:35:00',1.17),('8998','2013-11-24','08:40:00',1.45),('8998','2013-11-24','08:45:00',1.55),('8998','2013-11-24','08:50:00',1.65),('8998','2013-11-24','08:55:00',1.74),('8998','2013-11-24','09:00:00',1.87),('8998','2013-11-24','09:05:00',1.93),('8998','2013-11-24','09:10:00',1.92),('8998','2013-11-24','09:15:00',1.98),('8998','2013-11-24','09:20:00',2.04),('8998','2013-11-24','09:25:00',2.04),('8998','2013-11-24','09:30:00',1.86),('8998','2013-11-24','09:35:00',1.8),('8998','2013-11-24','09:40:00',1.54),('8998','2013-11-24','09:50:00',1.02),('8998','2013-11-24','09:55:00',1.07),('8998','2013-11-24','10:05:00',1.02),('8998','2013-11-24','10:15:00',1.11),('8998','2013-11-24','10:20:00',1.25),('8998','2013-11-24','10:25:00',1.2),('8998','2013-11-24','10:30:00',1.58),('8998','2013-11-24','10:35:00',2.45),('8998','2013-11-24','10:40:00',2.36),('8998','2013-11-24','10:45:00',2.06),('8998','2013-11-24','10:50:00',1.79),('8998','2013-11-24','10:55:00',1.74),('8998','2013-11-24','11:00:00',1.95),('8998','2013-11-24','11:05:00',2.04),('8998','2013-11-24','11:10:00',2.31),('8998','2013-11-24','11:15:00',1.35),('8998','2013-11-24','11:20:00',1.12),('8998','2013-11-24','11:55:00',1.12),('8998','2013-11-24','12:10:00',1.14),('8998','2013-11-24','12:40:00',1.47),('8998','2013-11-24','12:45:00',1.45),('8998','2013-11-24','12:50:00',1.04),('8998','2013-11-24','12:55:00',1.23),('8998','2013-11-24','13:00:00',1.61),('8998','2013-11-24','13:05:00',1.6),('8998','2013-11-24','13:10:00',1.08),('8998','2013-11-24','13:15:00',1.07),('8998','2013-11-24','13:20:00',1.13),('8998','2013-11-23','10:05:00',1.07),('8998','2013-11-23','10:10:00',1.12),('8998','2013-11-23','10:25:00',1.22),('8998','2013-11-23','10:30:00',1.29),('8998','2013-11-23','11:25:00',1.04),('8998','2013-11-22','10:30:00',1.22),('8998','2013-11-22','10:40:00',1.88),('8998','2013-11-20','08:15:00',1.08),('8998','2013-11-20','09:20:00',1.1),('8998','2013-11-20','09:40:00',1.15),('8998','2013-11-20','09:45:00',1.62),('8998','2013-11-20','09:50:00',1.6),('8998','2013-11-20','09:55:00',1.37),('8998','2013-11-20','10:00:00',1.09),('8998','2013-11-20','10:05:00',1.84),('8998','2013-11-20','10:10:00',1.73),('8998','2013-11-20','10:15:00',1.87),('8998','2013-11-20','10:20:00',1.87),('8998','2013-11-20','10:25:00',1.27),('8998','2013-11-20','10:30:00',1.59),('8998','2013-11-20','10:35:00',1.8),('8998','2013-11-20','10:40:00',1.86),('8998','2013-11-20','10:45:00',1.48),('8998','2013-11-20','11:25:00',1.22),('8998','2013-11-20','11:30:00',1.71),('8998','2013-11-20','11:35:00',1.01),('8998','2013-11-20','11:40:00',1.73),('8998','2013-11-20','11:45:00',1.31),('8998','2013-11-20','11:50:00',1.67),('8998','2013-11-20','11:55:00',1.63),('8998','2013-11-20','12:00:00',1.1),('8998','2013-11-20','12:05:00',1.55),('8998','2013-11-20','12:10:00',1.59),('8998','2013-11-20','12:15:00',1.56),('8998','2013-11-20','12:20:00',1.53),('8998','2013-11-20','12:25:00',1.55),('8998','2013-11-20','12:30:00',1.63),('8998','2013-11-20','12:35:00',1.72),('8998','2013-11-20','12:40:00',1.77),('8998','2013-11-20','12:45:00',1.67),('8998','2013-11-20','12:50:00',1.52),('8998','2013-11-20','12:55:00',1.65),('8998','2013-11-20','13:00:00',1.57),('8998','2013-11-20','13:05:00',1.32),('8998','2013-11-20','13:15:00',1.18),('8998','2013-11-20','13:20:00',1.19),('8998','2013-11-19','08:20:00',1.19),('8998','2013-11-19','09:00:00',1.19),('8998','2013-11-19','09:15:00',1.55),('8998','2013-11-19','09:20:00',1.53),('8998','2013-11-19','09:25:00',1.68),('8998','2013-11-19','09:30:00',1.72),('8998','2013-11-19','10:00:00',1.23),('8998','2013-11-19','10:15:00',1.28),('8998','2013-11-19','11:45:00',2.08),('8998','2013-11-19','11:50:00',2.1),('8998','2013-11-19','12:20:00',1.51),('8998','2013-11-19','13:00:00',1.08),('8998','2013-11-18','09:40:00',1.7),('8998','2013-11-18','09:45:00',1.61),('8998','2013-11-18','10:05:00',1.11),('8998','2013-11-18','10:50:00',1.16),('8998','2013-11-18','11:20:00',1.63),('8998','2013-11-18','11:25:00',1.5),('8998','2013-11-18','11:30:00',1.55),('8998','2013-11-18','11:35:00',1.76),('8998','2013-11-18','11:40:00',1.62),('8998','2013-11-18','11:45:00',1.55),('8998','2013-11-18','11:50:00',1.57),('8998','2013-11-18','11:55:00',1.56),('8998','2013-11-18','12:00:00',1.46),('8998','2013-11-18','12:05:00',1.38),('8998','2013-11-18','12:10:00',1.49),('8998','2013-11-18','12:15:00',1.47),('8998','2013-11-18','12:45:00',1.23),('8998','2013-11-18','12:55:00',1.61),('8998','2013-11-18','13:00:00',1.28),('8998','2013-11-18','13:15:00',1.11),('8998','2013-11-18','13:20:00',1.18),('8998','2013-11-17','08:25:00',1.04),('8998','2013-11-17','08:30:00',1.14),('8998','2013-11-17','08:35:00',1.15),('8998','2013-11-17','09:20:00',1.28),('8998','2013-11-17','09:25:00',1.33),('8998','2013-11-17','09:30:00',1.23),('8998','2013-11-17','09:35:00',1.61),('8998','2013-11-17','09:40:00',1.25),('8998','2013-11-17','09:45:00',1.08),('8998','2013-11-17','10:05:00',1),('8998','2013-11-17','10:10:00',1.1),('8998','2013-11-17','10:15:00',1.3),('8998','2013-11-17','10:20:00',1.11),('8998','2013-11-17','12:20:00',1.03),('8998','2013-11-17','12:25:00',1.06),('8998','2014-04-18','07:40:00',1.02),('8998','2014-04-18','07:55:00',1.52),('8998','2014-04-18','08:00:00',1.23),('8998','2014-04-18','08:10:00',1.41),('8998','2014-04-18','08:25:00',1.25),('8998','2014-04-18','08:30:00',1.62),('8998','2014-04-18','08:35:00',2.08),('8998','2014-04-18','08:40:00',1.86),('8998','2014-04-18','08:45:00',1.63),('8998','2014-04-18','08:50:00',1.28),('8998','2014-04-18','09:30:00',1.71),('8998','2014-04-18','09:35:00',1.8),('8998','2014-04-18','09:40:00',1.05),('8998','2014-04-18','10:55:00',1.01),('8998','2014-04-18','11:00:00',1.13),('8998','2014-04-18','11:15:00',1.16),('8998','2014-04-18','11:20:00',2.48),('8998','2014-04-18','11:25:00',1.99),('8998','2014-04-18','11:30:00',1.91),('8998','2014-04-18','11:35:00',1.69),('8998','2014-04-18','11:40:00',2.03),('8998','2014-04-18','11:45:00',1.53),('8998','2014-04-18','11:50:00',1.38),('8998','2014-04-18','14:35:00',1.02),('8998','2014-04-18','14:40:00',1.08),('8998','2014-04-18','14:45:00',1.18),('8998','2014-04-18','15:50:00',1.57),('8998','2014-04-18','15:55:00',2.03),('8998','2014-04-18','16:00:00',1.22),('8998','2014-04-18','16:05:00',1.01),('8998','2014-04-18','16:10:00',1.02),('8998','2014-04-18','16:20:00',1.14),('8998','2014-04-18','16:25:00',1.14),('8998','2014-04-18','16:30:00',1.55),('8998','2014-04-18','16:35:00',1.03),('8998','2013-11-16','08:45:00',1.1),('8998','2013-11-16','08:50:00',1.1),('8998','2013-11-16','08:55:00',1.9),('8998','2013-11-16','09:00:00',1.71),('8998','2013-11-16','09:05:00',1.65),('8998','2013-11-16','09:10:00',1.63),('8998','2013-11-16','09:15:00',1.61),('8998','2013-11-16','09:20:00',1.38),('8998','2013-11-16','09:25:00',1.66),('8998','2013-11-16','09:30:00',1.68),('8998','2013-11-16','09:35:00',1.7),('8998','2013-11-16','09:40:00',1.72),('8998','2013-11-16','09:45:00',1.72),('8998','2013-11-16','09:50:00',1.74),('8998','2013-11-16','09:55:00',1.75),('8998','2013-11-16','10:00:00',1.77),('8998','2013-11-16','10:05:00',1.78),('8998','2013-11-16','10:10:00',1.79),('8998','2013-11-16','10:15:00',1.79),('8998','2013-11-16','10:20:00',1.8),('8998','2013-11-16','10:25:00',1.79),('8998','2013-11-16','10:30:00',1.79),('8998','2013-11-16','10:35:00',1.78),('8998','2013-11-16','10:40:00',1.78),('8998','2013-11-16','10:45:00',1.77),('8998','2013-11-16','10:50:00',1.78),('8998','2013-11-16','10:55:00',1.77),('8998','2013-11-16','11:00:00',1.76),('8998','2013-11-16','11:05:00',1.75),('8998','2013-11-16','11:10:00',1.74),('8998','2013-11-16','11:15:00',1.73),('8998','2013-11-16','11:20:00',1.71),('8998','2013-11-16','11:25:00',1.69),('8998','2013-11-16','11:30:00',1.67),('8998','2013-11-16','11:35:00',1.66),('8998','2013-11-16','11:40:00',1.65),('8998','2013-11-16','11:45:00',1.63),('8998','2013-11-16','11:50:00',1.61),('8998','2013-11-16','11:55:00',1.58),('8998','2013-11-16','12:00:00',1.53),('8998','2013-11-16','12:05:00',1.52),('8998','2013-11-16','12:10:00',1.5),('8998','2013-11-16','12:15:00',1.47),('8998','2013-11-16','12:20:00',1.45),('8998','2013-11-16','12:25:00',1.41),('8998','2013-11-16','12:30:00',1.39),('8998','2013-11-16','12:35:00',1.36),('8998','2013-11-16','12:40:00',1.33),('8998','2013-11-16','12:45:00',1.29),('8998','2013-11-16','12:50:00',1.24),('8998','2013-11-16','12:55:00',1.19),('8998','2013-11-16','13:00:00',1.12),('8998','2013-11-14','10:55:00',1.33),('8998','2013-11-14','11:00:00',1.04),('8998','2013-11-14','11:20:00',1.12),('8998','2013-11-14','11:25:00',1.74),('8998','2013-11-14','11:30:00',1.1),('8998','2013-11-14','11:35:00',1.11),('8998','2013-11-14','11:40:00',1.28),('8998','2013-11-14','11:45:00',1.09),('8998','2013-11-14','12:25:00',1.12),('8998','2013-11-14','12:30:00',1.01),('8998','2013-11-13','08:25:00',1.22),('8998','2013-11-13','08:30:00',1.09),('8998','2013-11-13','08:35:00',1.21),('8998','2013-11-13','09:05:00',1.1),('8998','2013-11-13','09:10:00',1.01),('8998','2013-11-13','09:15:00',1.23),('8998','2013-11-13','09:20:00',1.69),('8998','2013-11-13','09:25:00',1.67),('8998','2013-11-13','09:30:00',1.68),('8998','2013-11-13','09:35:00',1.69),('8998','2013-11-13','09:40:00',1.7),('8998','2013-11-13','09:45:00',1.65),('8998','2013-11-13','09:50:00',1.33),('8998','2013-11-13','10:05:00',1.35),('8998','2013-11-13','10:15:00',1.81),('8998','2013-11-13','10:20:00',1.83),('8998','2013-11-13','10:25:00',1.79),('8998','2013-11-13','10:30:00',1.77),('8998','2013-11-13','10:35:00',1.76),('8998','2013-11-13','10:40:00',1.76),('8998','2013-11-13','10:45:00',1.77),('8998','2013-11-13','10:50:00',1.76),('8998','2013-11-13','10:55:00',1.72),('8998','2013-11-13','11:00:00',1.72),('8998','2013-11-13','11:05:00',1.76),('8998','2013-11-13','11:10:00',1.79),('8998','2013-11-13','11:15:00',1.81),('8998','2013-11-13','11:20:00',1.8),('8998','2013-11-13','11:25:00',1.81),('8998','2013-11-13','11:30:00',1.79),('8998','2013-11-13','11:35:00',1.72),('8998','2013-11-13','11:40:00',1.45),('8998','2013-11-13','11:50:00',1),('8998','2013-11-13','11:55:00',1.36),('8998','2013-11-13','12:00:00',1.22),('8998','2013-11-13','12:15:00',1.06),('8998','2013-11-12','10:20:00',1.06),('8998','2013-11-12','10:30:00',1.24),('8998','2013-11-12','10:35:00',2.33),('8998','2013-11-12','10:40:00',2.09),('8998','2013-11-12','10:45:00',1.92),('8998','2013-11-12','10:50:00',2.49),('8998','2013-11-12','10:55:00',2.37),('8998','2013-11-12','11:00:00',2.26),('8998','2013-11-11','11:40:00',1.73),('8998','2013-11-11','12:00:00',1.82),('8998','2013-11-11','12:30:00',2.14),('8998','2013-11-11','12:35:00',1.79),('8998','2013-11-11','12:40:00',1.31),('8998','2013-11-11','12:45:00',1.25),('8998','2013-11-11','12:50:00',1.01),('8998','2013-11-11','12:55:00',1.25),('8998','2013-11-11','13:00:00',1.26),('8998','2013-11-11','13:05:00',1.31),('8998','2013-11-11','13:10:00',1.43),('8998','2013-11-11','13:15:00',1.85),('8998','2013-11-11','13:20:00',1.56),('8998','2013-11-11','13:25:00',1.37),('8998','2013-11-11','13:30:00',1.2),('8998','2013-11-11','13:35:00',1.33),('8998','2013-11-11','13:40:00',1.66),('8998','2013-11-11','13:45:00',1.04),('8998','2013-11-10','10:15:00',1.52),('8998','2013-11-10','10:20:00',2.32),('8998','2013-11-10','10:25:00',1.17),('8998','2013-11-10','11:10:00',1.58),('8998','2013-11-10','11:15:00',1.39),('8998','2013-11-10','11:20:00',1.1),('8998','2013-11-10','11:25:00',2.11),('8998','2013-11-10','11:35:00',1.79),('8998','2013-11-10','11:40:00',2.33),('8998','2013-11-10','11:45:00',2.26),('8998','2013-11-10','11:50:00',2.23),('8998','2013-11-10','11:55:00',1.99),('8998','2013-11-10','12:00:00',1.85),('8998','2013-11-10','12:05:00',1.8),('8998','2013-11-10','12:10:00',1.76),('8998','2013-11-10','12:15:00',1.73),('8998','2013-11-10','12:20:00',1.61),('8998','2013-11-10','12:25:00',1.33),('8998','2013-11-10','12:30:00',1.66),('8998','2013-11-10','12:40:00',1.17),('8998','2013-11-10','13:10:00',1.3),('8998','2013-11-09','08:40:00',1.23),('8998','2013-11-09','08:45:00',1.12),('8998','2013-11-09','08:50:00',1.33),('8998','2013-11-09','08:55:00',1.61),('8998','2013-11-09','09:00:00',1.2),('8998','2013-11-09','09:05:00',1),('8998','2013-11-09','09:15:00',1.26),('8998','2013-11-09','09:20:00',1.63),('8998','2013-11-09','09:25:00',1.78),('8998','2013-11-09','09:30:00',1.58),('8998','2013-11-09','09:35:00',1.55),('8998','2013-11-09','09:40:00',1.61),('8998','2013-11-09','09:45:00',1.75),('8998','2013-11-09','09:50:00',1.81),('8998','2013-11-09','09:55:00',1.86),('8998','2013-11-09','10:00:00',1.79),('8998','2013-11-09','10:05:00',1.97),('8998','2013-11-09','10:10:00',2.01),('8998','2013-11-09','10:15:00',1.99),('8998','2013-11-09','10:20:00',1.82),('8998','2013-11-09','10:25:00',2.02),('8998','2013-11-09','10:30:00',2.16),('8998','2013-11-09','10:35:00',1.97),('8998','2013-11-09','10:40:00',1.63),('8998','2013-11-09','10:45:00',1.55),('8998','2013-11-09','10:50:00',1.75),('8998','2013-11-09','10:55:00',1.72),('8998','2013-11-09','11:00:00',1.65),('8998','2013-11-09','11:05:00',1.26),('8998','2013-11-09','11:45:00',1.21),('8998','2013-11-09','11:50:00',1.02),('8998','2013-11-09','12:10:00',1.05),('8998','2013-11-09','12:15:00',1.64),('8998','2013-11-09','12:20:00',1.66),('8998','2013-11-09','12:25:00',1.55),('8998','2013-11-09','12:30:00',1.19),('8998','2013-11-09','12:35:00',1.02),('8998','2013-11-09','12:40:00',1.56),('8998','2013-11-09','12:45:00',1.68),('8998','2013-11-09','12:50:00',1.77),('8998','2013-11-08','09:40:00',2.08),('8998','2013-11-08','09:45:00',1.41),('8998','2013-11-08','09:50:00',1.96),('8998','2013-11-08','09:55:00',2.24),('8998','2013-11-08','10:00:00',2.07),('8998','2013-11-08','10:05:00',1.86),('8998','2013-11-08','10:10:00',1.79),('8998','2013-11-08','10:15:00',1.69),('8998','2013-11-08','10:20:00',1.82),('8998','2013-11-08','10:25:00',1.95),('8998','2013-11-08','10:55:00',1.35),('8998','2013-11-08','11:00:00',1.64),('8998','2013-11-08','11:05:00',2.31),('8998','2013-11-08','11:10:00',1.99),('8998','2013-11-08','11:15:00',2.58),('8998','2013-11-08','11:20:00',1.86),('8998','2013-11-08','11:30:00',1.77),('8998','2013-11-08','11:35:00',1.71),('8998','2013-11-08','11:40:00',1.48),('8998','2013-11-08','11:45:00',1.37),('8998','2013-11-08','11:55:00',1.38),('8998','2013-11-08','12:00:00',1.57),('8998','2013-11-08','12:05:00',1.74),('8998','2013-11-08','12:10:00',1.26),('8998','2013-11-08','12:15:00',1.25),('8998','2013-11-08','12:25:00',1.01),('8998','2013-11-08','12:30:00',1.47),('8998','2013-11-08','12:35:00',1.81),('8998','2013-11-08','12:40:00',1.2),('8998','2013-11-08','12:50:00',1.5),('8998','2013-11-08','12:55:00',1.45),('8998','2013-11-08','13:00:00',1.75),('8998','2013-11-08','13:05:00',1.58),('8998','2013-11-08','13:10:00',1.61),('8998','2013-11-08','13:15:00',1.53),('8998','2013-11-08','13:20:00',1.01),('8998','2013-11-08','13:25:00',1.01),('8998','2013-11-08','13:30:00',1.17),('8998','2013-11-08','13:35:00',1.02),('8998','2013-11-07','09:10:00',1.07),('8998','2013-11-07','09:20:00',1.67),('8998','2013-11-07','09:25:00',1.7),('8998','2013-11-07','09:30:00',1.77),('8998','2013-11-07','09:35:00',1.84),('8998','2013-11-07','09:40:00',1.36),('8998','2013-11-07','09:50:00',1.51),('8998','2013-11-07','10:00:00',1.02),('8998','2013-11-07','10:05:00',1.3),('8998','2013-11-07','10:10:00',1.89),('8998','2013-11-07','10:50:00',1.62),('8998','2013-11-07','10:55:00',1.48),('8998','2013-11-07','11:25:00',1.84),('8998','2013-11-07','11:30:00',2.3),('8998','2013-11-07','11:35:00',2.22),('8998','2013-11-07','11:40:00',2.11),('8998','2013-11-07','11:45:00',2.05),('8998','2013-11-07','11:50:00',2.07),('8998','2013-11-07','11:55:00',1.88),('8998','2013-11-07','12:00:00',1.09),('8998','2013-11-07','12:05:00',1.72),('8998','2013-11-07','12:10:00',1.64),('8998','2013-11-07','12:15:00',1.38),('8998','2013-11-07','12:40:00',1.36),('8998','2013-11-07','12:50:00',1.41),('8998','2013-11-07','12:55:00',1.6),('8998','2013-11-07','13:00:00',1.55),('8998','2013-11-07','13:05:00',1.4),('8998','2013-11-07','13:10:00',1.36),('8998','2013-11-07','13:15:00',1.4),('8998','2013-11-07','13:20:00',1.02),('8998','2013-11-07','13:25:00',1.25),('8998','2014-04-17','08:05:00',1.59),('8998','2014-04-17','08:10:00',1.22),('8998','2014-04-17','08:40:00',1.32),('8998','2014-04-17','08:45:00',1.16),('8998','2014-04-17','09:05:00',2.03),('8998','2014-04-17','09:10:00',2.29),('8998','2014-04-17','09:15:00',2.12),('8998','2014-04-17','09:20:00',2.1),('8998','2014-04-17','09:25:00',1.71),('8998','2014-04-17','09:30:00',2.68),('8998','2014-04-17','09:35:00',1.42),('8998','2014-04-17','09:40:00',1.02),('8998','2014-04-17','09:45:00',1.56),('8998','2014-04-17','09:50:00',2.56),('8998','2014-04-17','09:55:00',2.38),('8998','2014-04-17','10:00:00',2.06),('8998','2014-04-17','10:05:00',1.27),('8998','2014-04-17','10:10:00',1.15),('8998','2014-04-17','10:15:00',1.32),('8998','2014-04-17','10:20:00',1.07),('8998','2014-04-17','10:25:00',1.11),('8998','2014-04-17','10:40:00',1.06),('8998','2014-04-17','10:45:00',2.1),('8998','2014-04-17','10:50:00',2.37),('8998','2014-04-17','10:55:00',2.33),('8998','2014-04-17','11:00:00',1.34),('8998','2014-04-17','11:05:00',1.18),('8998','2014-04-17','11:10:00',1.68),('8998','2014-04-17','11:15:00',1.99),('8998','2014-04-17','11:20:00',1.23),('8998','2014-04-17','11:30:00',1.23),('8998','2014-04-17','11:35:00',1.13),('8998','2014-04-17','11:40:00',1.2),('8998','2014-04-17','11:45:00',1.14),('8998','2014-04-17','11:50:00',1.34),('8998','2014-04-17','11:55:00',1.28),('8998','2014-04-17','12:00:00',1.26),('8998','2014-04-17','12:05:00',2.1),('8998','2014-04-17','12:10:00',2.41),('8998','2014-04-17','12:15:00',2.24),('8998','2014-04-17','12:20:00',2.85),('8998','2014-04-17','12:25:00',2.09),('8998','2014-04-17','12:30:00',3.2),('8998','2014-04-17','12:35:00',3),('8998','2014-04-17','12:40:00',3.1),('8998','2014-04-17','12:45:00',2.62),('8998','2014-04-17','12:50:00',2.55),('8998','2014-04-17','12:55:00',1.82),('8998','2014-04-17','13:00:00',3.12),('8998','2014-04-17','13:05:00',2.16),('8998','2014-04-17','13:10:00',1.84),('8998','2014-04-17','13:15:00',1.72),('8998','2014-04-17','13:20:00',1.52),('8998','2014-04-17','13:25:00',1.12),('8998','2014-04-17','13:30:00',1.03),('8998','2014-04-17','13:35:00',1.02),('8998','2014-04-17','13:55:00',1.51),('8998','2014-04-17','14:00:00',1.33),('8998','2014-04-17','14:05:00',1.06),('8998','2014-04-17','14:20:00',1.08),('8998','2014-04-17','14:25:00',1.36),('8998','2014-04-17','14:30:00',1.49),('8998','2014-04-17','14:35:00',1.62),('8998','2014-04-17','14:40:00',1.5),('8998','2014-04-17','14:45:00',1.74),('8998','2014-04-17','14:50:00',1.93),('8998','2014-04-17','14:55:00',1.35),('8998','2014-04-17','15:00:00',2.48),('8998','2014-04-17','15:05:00',1.43),('8998','2014-04-17','15:10:00',1.42),('8998','2014-04-17','15:15:00',1.54),('8998','2014-04-17','15:20:00',1.27),('8998','2014-04-17','15:25:00',1.34),('8998','2014-04-17','15:30:00',1.54),('8998','2014-04-17','15:35:00',1.99),('8998','2014-04-17','15:40:00',1.03),('8998','2014-04-17','15:45:00',1.31),('8998','2014-04-17','15:50:00',1.5),('8998','2014-04-17','15:55:00',1.41),('8998','2014-04-17','16:00:00',1.33),('8998','2014-04-17','16:05:00',1.08),('8998','2014-04-17','16:25:00',1.05),('8998','2014-04-17','16:30:00',1.12),('8998','2014-04-17','16:35:00',1.19),('8998','2014-04-17','16:40:00',1.07),('8998','2013-11-06','07:55:00',1.02),('8998','2013-11-06','08:00:00',1.08),('8998','2013-11-06','08:05:00',1.13),('8998','2013-11-06','08:15:00',1.29),('8998','2013-11-06','08:20:00',1.37),('8998','2013-11-06','08:25:00',1.41),('8998','2013-11-06','08:30:00',1.45),('8998','2013-11-06','08:35:00',1.48),('8998','2013-11-06','08:40:00',1.51),('8998','2013-11-06','08:45:00',1.54),('8998','2013-11-06','08:50:00',1.58),('8998','2013-11-06','08:55:00',1.61),('8998','2013-11-06','09:00:00',1.64),('8998','2013-11-06','09:05:00',1.67),('8998','2013-11-06','09:10:00',1.69),('8998','2013-11-06','09:15:00',1.72),('8998','2013-11-06','09:20:00',1.74),('8998','2013-11-06','09:25:00',1.77),('8998','2013-11-06','09:30:00',1.78),('8998','2013-11-06','09:35:00',1.8),('8998','2013-11-06','09:40:00',1.81),('8998','2013-11-06','09:45:00',1.83),('8998','2013-11-06','09:50:00',1.83),('8998','2013-11-06','09:55:00',1.84),('8998','2013-11-06','10:00:00',1.84),('8998','2013-11-06','10:05:00',1.82),('8998','2013-11-06','10:10:00',1.84),('8998','2013-11-06','10:15:00',1.84),('8998','2013-11-06','10:20:00',1.83),('8998','2013-11-06','10:25:00',1.84),('8998','2013-11-06','10:30:00',1.84),('8998','2013-11-06','10:35:00',1.84),('8998','2013-11-06','10:40:00',1.82),('8998','2013-11-06','10:45:00',1.81),('8998','2013-11-06','10:50:00',1.81),('8998','2013-11-06','10:55:00',1.79),('8998','2013-11-06','11:00:00',1.8),('8998','2013-11-06','11:05:00',1.78),('8998','2013-11-06','11:10:00',1.77),('8998','2013-11-06','11:15:00',1.76),('8998','2013-11-06','11:20:00',1.73),('8998','2013-11-06','11:25:00',1.71),('8998','2013-11-06','11:30:00',1.66),('8998','2013-11-06','11:35:00',1.62),('8998','2013-11-06','11:40:00',1.63),('8998','2013-11-06','11:45:00',1.65),('8998','2013-11-06','11:50:00',1.6),('8998','2013-11-06','11:55:00',1.57),('8998','2013-11-06','12:00:00',1.55),('8998','2013-11-06','12:05:00',1.54),('8998','2013-11-06','12:10:00',1.48),('8998','2013-11-06','12:15:00',1.47),('8998','2013-11-06','12:20:00',1.45),('8998','2013-11-06','12:25:00',1.42),('8998','2013-11-06','12:30:00',1.37),('8998','2013-11-06','12:35:00',1.37),('8998','2013-11-06','12:40:00',1.32),('8998','2013-11-06','12:45:00',1.28),('8998','2013-11-06','12:50:00',1.25),('8998','2013-11-06','12:55:00',1.28),('8998','2013-11-06','13:00:00',1.31),('8998','2013-11-06','13:05:00',1.37),('8998','2013-11-06','13:40:00',1.1),('8998','2013-11-05','08:10:00',1.26),('8998','2013-11-05','08:15:00',1.48),('8998','2013-11-05','08:20:00',1.32),('8998','2013-11-05','08:35:00',1.59),('8998','2013-11-05','08:40:00',1.6),('8998','2013-11-05','08:45:00',1.65),('8998','2013-11-05','08:50:00',1.75),('8998','2013-11-05','08:55:00',1.6),('8998','2013-11-05','09:00:00',1.13),('8998','2013-11-05','09:05:00',1.21),('8998','2013-11-05','09:10:00',1.05),('8998','2013-11-05','09:15:00',1.45),('8998','2013-11-05','09:20:00',1.73),('8998','2013-11-05','09:25:00',1.75),('8998','2013-11-05','09:30:00',1.86),('8998','2013-11-05','09:35:00',1.86),('8998','2013-11-05','09:40:00',1.88),('8998','2013-11-05','09:45:00',1.88),('8998','2013-11-05','09:50:00',1.88),('8998','2013-11-05','09:55:00',1.89),('8998','2013-11-05','10:00:00',1.92),('8998','2013-11-05','10:05:00',1.92),('8998','2013-11-05','10:10:00',1.93),('8998','2013-11-05','10:15:00',1.92),('8998','2013-11-05','10:20:00',1.94),('8998','2013-11-05','10:25:00',1.96),('8998','2013-11-05','10:30:00',1.96),('8998','2013-11-05','10:35:00',1.96),('8998','2013-11-05','10:40:00',1.95),('8998','2013-11-05','10:45:00',1.94),('8998','2013-11-05','10:50:00',1.94),('8998','2013-11-05','10:55:00',1.93),('8998','2013-11-05','11:00:00',1.92),('8998','2013-11-05','11:05:00',1.92),('8998','2013-11-05','11:10:00',1.89),('8998','2013-11-05','11:15:00',1.88),('8998','2013-11-05','11:20:00',1.87),('8998','2013-11-05','11:25:00',1.86),('8998','2013-11-05','11:30:00',1.84),('8998','2013-11-05','11:35:00',1.81),('8998','2013-11-05','11:40:00',1.8),('8998','2013-11-05','11:45:00',1.78),('8998','2013-11-05','11:50:00',1.77),('8998','2013-11-05','11:55:00',1.74),('8998','2013-11-05','12:00:00',1.71),('8998','2013-11-05','12:05:00',1.7),('8998','2013-11-05','12:10:00',1.66),('8998','2013-11-05','12:15:00',1.64),('8998','2013-11-05','12:20:00',1.61),('8998','2013-11-05','12:25:00',1.58),('8998','2013-11-05','12:30:00',1.54),('8998','2013-11-05','12:35:00',1.51),('8998','2013-11-05','12:40:00',1.47),('8998','2013-11-05','12:45:00',1.44),('8998','2013-11-05','12:50:00',1.4),('8998','2013-11-05','12:55:00',1.36),('8998','2013-11-05','13:00:00',1.32),('8998','2013-11-05','13:05:00',1.28),('8998','2013-11-05','13:10:00',1.24),('8998','2013-11-05','13:15:00',1.14),('8998','2013-11-05','13:20:00',1.08),('8998','2013-11-04','08:25:00',1.1),('8998','2013-11-04','08:30:00',1.4),('8998','2013-11-04','08:35:00',1.58),('8998','2013-11-04','08:40:00',1.62),('8998','2013-11-04','10:20:00',1.06),('8998','2013-11-04','10:25:00',1.52),('8998','2013-11-04','10:30:00',1.3),('8998','2013-11-04','10:35:00',1.48),('8998','2013-11-04','10:40:00',1.41),('8998','2013-11-04','10:45:00',1.39),('8998','2013-11-04','10:50:00',1.2),('8998','2013-11-04','10:55:00',1.07),('8998','2013-11-04','11:45:00',1.04),('8998','2013-11-04','12:20:00',1.09),('8998','2013-11-04','12:25:00',1.16),('8998','2013-11-04','13:35:00',1.1),('8998','2013-11-04','13:40:00',1.23),('8998','2013-11-04','13:45:00',1.09),('8998','2013-11-03','08:00:00',1.06),('8998','2013-11-03','08:10:00',1.16),('8998','2013-11-03','08:15:00',1.27),('8998','2013-11-03','08:20:00',1.37),('8998','2013-11-03','08:25:00',1.23),('8998','2013-11-03','08:30:00',1.1),('8998','2013-11-03','09:10:00',1.73),('8998','2013-11-03','09:15:00',1.94),('8998','2013-11-03','09:20:00',2),('8998','2013-11-03','09:25:00',2.29),('8998','2013-11-03','09:30:00',1.37),('8998','2013-11-03','10:05:00',1.77),('8998','2013-11-03','10:10:00',2.02),('8998','2013-11-03','10:15:00',2.02),('8998','2013-11-03','10:20:00',2.03),('8998','2013-11-03','10:25:00',2.21),('8998','2013-11-03','10:30:00',2.1),('8998','2013-11-03','10:35:00',1.45),('8998','2013-11-03','10:40:00',2.24),('8998','2013-11-03','10:45:00',1.46),('8998','2013-11-03','10:50:00',1.2),('8998','2013-11-03','11:00:00',1.34),('8998','2013-11-03','11:05:00',2.47),('8998','2013-11-03','11:10:00',1.23),('8998','2013-11-03','11:15:00',1.96),('8998','2013-11-03','11:20:00',1.22),('8998','2013-11-03','11:30:00',1.5),('8998','2013-11-03','11:35:00',1.87),('8998','2013-11-03','11:40:00',1.26),('8998','2013-11-03','11:45:00',1.51),('8998','2013-11-03','11:50:00',2.4),('8998','2013-11-03','11:55:00',2.08),('8998','2013-11-03','12:00:00',1.7),('8998','2013-11-03','12:05:00',1.74),('8998','2013-11-03','12:10:00',1.66),('8998','2013-11-03','12:15:00',1.38),('8998','2013-11-03','12:20:00',1.76),('8998','2013-11-03','12:25:00',1.7),('8998','2013-11-03','12:30:00',1.64),('8998','2013-11-03','12:35:00',1.65),('8998','2013-11-03','12:40:00',1.38),('8998','2013-11-03','12:45:00',1.37),('8998','2013-11-03','12:50:00',1.34),('8998','2013-11-03','12:55:00',1.42),('8998','2013-11-03','13:00:00',1.36),('8998','2013-11-03','13:05:00',1.34),('8998','2013-11-03','13:10:00',1.23),('8998','2013-11-03','13:15:00',1.15),('8998','2013-11-03','13:20:00',1.05),('8998','2013-11-03','13:25:00',1.07),('8998','2013-11-03','13:30:00',1.01),('8998','2013-11-02','08:40:00',1.22),('8998','2013-11-02','08:55:00',1.04),('8998','2013-11-02','09:40:00',1.81),('8998','2013-11-02','09:45:00',1.48),('8998','2013-11-02','10:10:00',1.6),('8998','2013-11-02','10:20:00',1.42),('8998','2013-11-02','10:25:00',1.73),('8998','2013-11-02','10:30:00',1.06),('8998','2013-11-02','11:25:00',1.39),('8998','2013-11-02','11:30:00',1.11),('8998','2013-11-02','11:35:00',1.75),('8998','2013-11-02','11:40:00',1.94),('8998','2013-11-02','11:45:00',1.51),('8998','2013-11-02','11:50:00',2.1),('8998','2013-11-02','11:55:00',2.03),('8998','2013-11-02','12:00:00',1.14),('8998','2013-11-02','12:05:00',1.58),('8998','2013-11-02','12:10:00',1.91),('8998','2013-11-02','14:05:00',1.02),('8998','2013-11-01','08:15:00',1.23),('8998','2013-11-01','08:20:00',1.28),('8998','2013-11-01','08:25:00',1.31),('8998','2013-11-01','08:30:00',1.37),('8998','2013-11-01','08:35:00',1.42),('8998','2013-11-01','08:40:00',1.46),('8998','2013-11-01','08:45:00',1.5),('8998','2013-11-01','08:50:00',1.53),('8998','2013-11-01','08:55:00',1.56),('8998','2013-11-01','09:00:00',1.6),('8998','2013-11-01','09:05:00',1.68),('8998','2013-11-01','09:10:00',1.75),('8998','2013-11-01','09:20:00',1.45),('8998','2013-11-01','09:25:00',1.86),('8998','2013-11-01','09:30:00',1.77),('8998','2013-11-01','09:35:00',1.79),('8998','2013-11-01','09:40:00',1.75),('8998','2013-11-01','09:45:00',1.34),('8998','2013-11-01','09:50:00',1.97),('8998','2013-11-01','09:55:00',1.97),('8998','2013-11-01','10:00:00',2.08),('8998','2013-11-01','10:05:00',2.31),('8998','2013-11-01','10:10:00',1.26),('8998','2013-11-01','11:55:00',1.01),('8998','2013-11-01','12:00:00',2.06),('8998','2013-11-01','12:05:00',2.18),('8998','2013-11-01','12:10:00',1.93),('8998','2013-11-01','12:15:00',2.19),('8998','2013-11-01','12:20:00',2.02),('8998','2013-11-01','12:25:00',2.04),('8998','2013-11-01','12:30:00',2.21),('8998','2013-11-01','12:35:00',2.08),('8998','2013-11-01','12:40:00',1.71),('8998','2013-11-01','12:45:00',1.44),('8998','2013-11-01','12:50:00',1.41),('8998','2013-11-01','12:55:00',1.79),('8998','2013-11-01','13:00:00',1.53),('8998','2013-11-01','13:05:00',1.72),('8998','2013-11-01','13:10:00',1.77),('8998','2013-11-01','13:15:00',1.21),('8998','2013-11-01','13:40:00',1.35),('8998','2013-11-01','13:45:00',1.14),('8998','2013-11-01','13:50:00',1.31),('8998','2013-11-01','13:55:00',1.21),('8998','2013-11-01','14:00:00',1.04),('8998','2013-10-31','08:20:00',1.07),('8998','2013-10-31','08:25:00',1.11),('8998','2013-10-31','08:30:00',1.29),('8998','2013-10-31','08:35:00',1.36),('8998','2013-10-31','08:40:00',1.46),('8998','2013-10-31','08:45:00',1.49),('8998','2013-10-31','08:50:00',1.4),('8998','2013-10-31','08:55:00',1.45),('8998','2013-10-31','09:00:00',1.5),('8998','2013-10-31','09:05:00',1.64),('8998','2013-10-31','09:10:00',1.68),('8998','2013-10-31','09:15:00',1.68),('8998','2013-10-31','09:20:00',1.72),('8998','2013-10-31','09:25:00',1.75),('8998','2013-10-31','09:30:00',1.76),('8998','2013-10-31','09:35:00',1.78),('8998','2013-10-31','09:40:00',1.81),('8998','2013-10-31','09:45:00',1.84),('8998','2013-10-31','09:50:00',1.86),('8998','2013-10-31','09:55:00',1.87),('8998','2013-10-31','10:00:00',1.88),('8998','2013-10-31','10:05:00',1.89),('8998','2013-10-31','10:10:00',1.9),('8998','2013-10-31','10:15:00',1.91),('8998','2013-10-31','10:20:00',1.92),('8998','2013-10-31','10:25:00',1.93),('8998','2013-10-31','10:30:00',1.88),('8998','2013-10-31','10:35:00',1.86),('8998','2013-10-31','10:40:00',1.89),('8998','2013-10-31','10:45:00',1.84),('8998','2013-10-31','10:50:00',1.83),('8998','2013-10-31','10:55:00',1.78),('8998','2013-10-31','11:00:00',1.83),('8998','2013-10-31','11:05:00',1.74),('8998','2013-10-31','11:10:00',1.5),('8998','2013-10-31','11:15:00',1.48),('8998','2013-10-31','11:20:00',1.78),('8998','2013-10-31','11:25:00',1.91),('8998','2013-10-31','11:30:00',1.9),('8998','2013-10-31','11:35:00',1.83),('8998','2013-10-31','11:40:00',1.69),('8998','2013-10-31','11:45:00',1.54),('8998','2013-10-31','11:50:00',1.77),('8998','2013-10-31','11:55:00',1.82),('8998','2013-10-31','12:00:00',1.8),('8998','2013-10-31','12:05:00',1.75),('8998','2013-10-31','12:10:00',1.62),('8998','2013-10-31','12:15:00',1.58),('8998','2013-10-31','12:20:00',1.25),('8998','2013-10-31','12:30:00',1.11),('8998','2013-10-31','12:35:00',1.33),('8998','2013-10-30','08:30:00',1.21),('8998','2013-10-30','08:35:00',1.34),('8998','2013-10-30','08:40:00',1.54),('8998','2013-10-30','08:45:00',1.52),('8998','2013-10-30','08:50:00',1.53),('8998','2013-10-30','09:00:00',1.53),('8998','2013-10-30','09:05:00',1.41),('8998','2013-10-30','09:20:00',1.02),('8998','2013-10-30','09:35:00',1.52),('8998','2013-10-30','09:40:00',1.37),('8998','2013-10-30','09:45:00',1.48),('8998','2013-10-30','09:50:00',1.52),('8998','2013-10-30','09:55:00',1.46),('8998','2013-10-30','10:00:00',1.45),('8998','2013-10-30','10:05:00',1.25),('8998','2013-10-30','10:10:00',1.09),('8998','2013-10-30','10:15:00',1.01),('8998','2013-10-30','10:20:00',1.17),('8998','2013-10-30','10:25:00',1.27),('8998','2013-10-30','10:30:00',1.21),('8998','2013-10-30','10:35:00',1.24),('8998','2013-10-30','10:40:00',1.29),('8998','2013-10-30','10:45:00',1.24),('8998','2013-10-30','10:50:00',1.25),('8998','2013-10-30','10:55:00',1.42),('8998','2013-10-30','11:00:00',1.76),('8998','2013-10-30','11:05:00',1.9),('8998','2013-10-30','11:10:00',1.83),('8998','2013-10-30','11:15:00',1.35),('8998','2013-10-30','11:20:00',1.8),('8998','2013-10-30','11:25:00',1.59),('8998','2013-10-30','11:30:00',1.63),('8998','2013-10-30','11:35:00',1.57),('8998','2013-10-30','11:40:00',1.65),('8998','2013-10-30','11:45:00',1.77),('8998','2013-10-30','11:50:00',1.76),('8998','2013-10-30','11:55:00',1.76),('8998','2013-10-30','12:00:00',1.7),('8998','2013-10-30','12:05:00',1.64),('8998','2013-10-30','12:10:00',1.59),('8998','2013-10-30','12:15:00',1.62),('8998','2013-10-30','12:20:00',1.57),('8998','2013-10-30','12:25:00',1.57),('8998','2013-10-30','12:30:00',1.51),('8998','2013-10-30','12:35:00',1.46),('8998','2013-10-30','12:40:00',1.48),('8998','2013-10-30','12:45:00',1.49),('8998','2013-10-30','12:50:00',1.48),('8998','2013-10-30','12:55:00',1.48),('8998','2013-10-30','13:00:00',1.43),('8998','2013-10-30','13:05:00',1.37),('8998','2013-10-30','13:10:00',1.32),('8998','2013-10-30','13:15:00',1.28),('8998','2013-10-30','13:20:00',1.21),('8998','2013-10-30','13:25:00',1.13),('8998','2013-10-29','08:10:00',1.03),('8998','2013-10-29','08:15:00',1.09),('8998','2013-10-29','08:20:00',1.13),('8998','2013-10-29','08:25:00',1.18),('8998','2013-10-29','08:30:00',1.22),('8998','2013-10-29','08:35:00',1.28),('8998','2013-10-29','08:40:00',1.35),('8998','2013-10-29','08:45:00',1.42),('8998','2013-10-29','08:50:00',1.42),('8998','2013-10-29','08:55:00',1.4),('8998','2013-10-29','09:00:00',1.47),('8998','2013-10-29','09:05:00',1.55),('8998','2013-10-29','09:10:00',1.63),('8998','2013-10-29','09:15:00',1.66),('8998','2013-10-29','09:20:00',1.67),('8998','2013-10-29','09:25:00',1.69),('8998','2013-10-29','09:30:00',1.73),('8998','2013-10-29','09:35:00',1.77),('8998','2013-10-29','09:40:00',1.74),('8998','2013-10-29','09:45:00',1.78),('8998','2013-10-29','09:50:00',1.73),('8998','2013-10-29','09:55:00',1.75),('8998','2013-10-29','10:00:00',1.61),('8998','2013-10-29','10:05:00',1.66),('8998','2013-10-29','10:10:00',1.69),('8998','2013-10-29','10:15:00',1.81),('8998','2013-10-29','10:20:00',1.8),('8998','2013-10-29','10:25:00',1.72),('8998','2013-10-29','10:30:00',1.62),('8998','2013-10-29','10:35:00',1.68),('8998','2013-10-29','10:40:00',1.7),('8998','2013-10-29','10:45:00',1.67),('8998','2013-10-29','10:50:00',1.63),('8998','2013-10-29','11:00:00',1.35),('8998','2013-10-29','11:05:00',1.47),('8998','2013-10-29','11:10:00',1.87),('8998','2013-10-29','11:15:00',1.85),('8998','2013-10-29','11:20:00',1.61),('8998','2013-10-29','11:50:00',1.51),('8998','2013-10-29','11:55:00',1.04),('8998','2013-10-29','12:30:00',1.45),('8998','2013-10-29','12:45:00',1.13),('8998','2013-10-29','12:55:00',1.27),('8998','2013-10-29','13:00:00',1.21),('8998','2013-10-28','08:40:00',1.17),('8998','2013-10-28','08:45:00',1.2),('8998','2013-10-28','08:50:00',1.6),('8998','2013-10-28','08:55:00',1.61),('8998','2013-10-28','09:00:00',1.65),('8998','2013-10-28','09:05:00',1.69),('8998','2013-10-28','09:10:00',1.7),('8998','2013-10-28','09:15:00',1.7),('8998','2013-10-28','09:20:00',1.76),('8998','2013-10-28','09:25:00',1.78),('8998','2013-10-28','09:30:00',1.8),('8998','2013-10-28','09:35:00',1.81),('8998','2013-10-28','09:40:00',1.83),('8998','2013-10-28','09:45:00',1.82),('8998','2013-10-28','09:50:00',1.49),('8998','2013-10-28','09:55:00',1.76),('8998','2013-10-28','10:00:00',1.77),('8998','2013-10-28','10:05:00',2.01),('8998','2013-10-28','10:10:00',1.98),('8998','2013-10-28','10:15:00',1.71),('8998','2013-10-28','10:20:00',1.69),('8998','2013-10-28','10:25:00',2.04),('8998','2013-10-28','10:30:00',2.19),('8998','2013-10-28','10:35:00',2.06),('8998','2013-10-28','10:40:00',2.08),('8998','2013-10-28','10:45:00',2.06),('8998','2013-10-28','10:50:00',2.12),('8998','2013-10-28','10:55:00',1.93),('8998','2013-10-28','11:00:00',1.29),('8998','2013-10-28','11:05:00',1.36),('8998','2013-10-28','11:10:00',1.02),('8998','2013-10-28','11:15:00',1.9),('8998','2013-10-28','11:20:00',1.87),('8998','2013-10-28','11:25:00',1.81),('8998','2013-10-28','11:30:00',1.95),('8998','2013-10-28','11:35:00',1.92),('8998','2013-10-28','11:40:00',1.88),('8998','2013-10-28','11:45:00',1.76),('8998','2013-10-28','11:50:00',1.73),('8998','2013-10-28','11:55:00',1.69),('8998','2013-10-28','12:00:00',1.62),('8998','2013-10-28','12:05:00',1.69),('8998','2013-10-28','12:10:00',1.63),('8998','2013-10-28','12:15:00',1.6),('8998','2013-10-28','12:20:00',1.59),('8998','2013-10-28','12:25:00',1.57),('8998','2013-10-28','12:30:00',1.53),('8998','2013-10-28','12:35:00',1.46),('8998','2013-10-28','12:40:00',1.48),('8998','2013-10-28','12:45:00',1.48),('8998','2013-10-28','12:50:00',1.44),('8998','2013-10-28','12:55:00',1.38),('8998','2013-10-28','13:00:00',1.31),('8998','2013-10-28','13:05:00',1.25),('8998','2013-10-28','13:10:00',1.25),('8998','2013-10-28','13:15:00',1.22),('8998','2013-10-28','13:20:00',1.16),('8998','2013-10-28','13:25:00',1.06),('8998','2013-10-28','13:30:00',1),('8998','2014-04-16','08:00:00',1.22),('8998','2014-04-16','08:05:00',1.29),('8998','2014-04-16','08:10:00',1.32),('8998','2014-04-16','08:15:00',1.53),('8998','2014-04-16','08:20:00',1.42),('8998','2014-04-16','08:25:00',1.56),('8998','2014-04-16','08:30:00',1.46),('8998','2014-04-16','08:35:00',1.48),('8998','2014-04-16','08:40:00',1.5),('8998','2014-04-16','08:45:00',1.55),('8998','2014-04-16','08:50:00',1.6),('8998','2014-04-16','08:55:00',1.42),('8998','2014-04-16','09:00:00',1.47),('8998','2014-04-16','09:05:00',1.57),('8998','2014-04-16','09:10:00',1.68),('8998','2014-04-16','09:15:00',1.8),('8998','2014-04-16','09:20:00',2),('8998','2014-04-16','09:25:00',2.34),('8998','2014-04-16','09:30:00',2.48),('8998','2014-04-16','09:35:00',2.56),('8998','2014-04-16','09:40:00',2.74),('8998','2014-04-16','09:45:00',2.8),('8998','2014-04-16','09:50:00',2.84),('8998','2014-04-16','09:55:00',2.91),('8998','2014-04-16','10:00:00',2.99),('8998','2014-04-16','10:05:00',3.18),('8998','2014-04-16','10:10:00',2.92),('8998','2014-04-16','10:15:00',2.51),('8998','2014-04-16','10:20:00',2.92),('8998','2014-04-16','10:25:00',3.29),('8998','2014-04-16','10:30:00',3.42),('8998','2014-04-16','10:35:00',3.53),('8998','2014-04-16','10:40:00',3.3),('8998','2014-04-16','10:45:00',2.64),('8998','2014-04-16','10:50:00',1.97),('8998','2014-04-16','10:55:00',1.97),('8998','2014-04-16','11:00:00',2),('8998','2014-04-16','11:05:00',2.95),('8998','2014-04-16','11:10:00',2.49),('8998','2014-04-16','11:15:00',2.35),('8998','2014-04-16','11:20:00',2.5),('8998','2014-04-16','11:25:00',2.72),('8998','2014-04-16','11:30:00',1.83),('8998','2014-04-16','11:35:00',2.15),('8998','2014-04-16','11:40:00',2.13),('8998','2014-04-16','11:45:00',2.43),('8998','2014-04-16','11:50:00',1.81),('8998','2014-04-16','11:55:00',1.45),('8998','2014-04-16','12:00:00',1.59),('8998','2014-04-16','12:05:00',2.06),('8998','2014-04-16','12:10:00',2.08),('8998','2014-04-16','12:15:00',1.78),('8998','2014-04-16','12:20:00',1.73),('8998','2014-04-16','12:25:00',1.88),('8998','2014-04-16','12:30:00',2.17),('8998','2014-04-16','12:35:00',2.78),('8998','2014-04-16','12:40:00',3.08),('8998','2014-04-16','12:45:00',2.95),('8998','2014-04-16','12:50:00',3.01),('8998','2014-04-16','12:55:00',3.06),('8998','2014-04-16','13:00:00',2.71),('8998','2014-04-16','13:05:00',1.5),('8998','2014-04-16','13:10:00',1.08),('8998','2014-04-16','13:20:00',2.64),('8998','2014-04-16','13:25:00',3.37),('8998','2014-04-16','13:30:00',2.35),('8998','2014-04-16','14:10:00',1.72),('8998','2014-04-16','14:30:00',1.03),('8998','2014-04-16','14:35:00',1.24),('8998','2014-04-16','14:40:00',2.18),('8998','2014-04-16','15:30:00',1.15),('8998','2014-04-16','15:35:00',1.31),('8998','2013-10-27','08:50:00',1.03),('8998','2013-10-27','08:55:00',1.56),('8998','2013-10-27','09:00:00',1.7),('8998','2013-10-27','09:05:00',1.84),('8998','2013-10-27','09:10:00',1.93),('8998','2013-10-27','09:15:00',1.53),('8998','2013-10-27','09:20:00',1.17),('8998','2013-10-27','09:25:00',1.85),('8998','2013-10-27','09:30:00',2.04),('8998','2013-10-27','09:35:00',1.62),('8998','2013-10-27','09:40:00',1.08),('8998','2013-10-27','09:45:00',1.06),('8998','2013-10-27','09:50:00',1.68),('8998','2013-10-27','09:55:00',1.29),('8998','2013-10-27','10:50:00',2.02),('8998','2013-10-27','10:55:00',1.99),('8998','2013-10-27','11:00:00',1.99),('8998','2013-10-27','11:05:00',1.97),('8998','2013-10-27','11:10:00',1.96),('8998','2013-10-27','11:15:00',1.96),('8998','2013-10-27','11:20:00',1.94),('8998','2013-10-27','11:25:00',1.92),('8998','2013-10-27','11:30:00',1.88),('8998','2013-10-27','11:35:00',1.88),('8998','2013-10-27','11:40:00',1.8),('8998','2013-10-27','11:45:00',1.81),('8998','2013-10-27','11:50:00',1.81),('8998','2013-10-27','11:55:00',1.7),('8998','2013-10-27','12:00:00',1.58),('8998','2013-10-27','12:05:00',1.68),('8998','2013-10-27','12:10:00',1.26),('8998','2013-10-27','12:15:00',1.83),('8998','2013-10-27','12:20:00',1.85),('8998','2013-10-27','12:25:00',1.84),('8998','2013-10-27','12:30:00',1.66),('8998','2013-10-27','12:35:00',1.89),('8998','2013-10-27','12:40:00',1.81),('8998','2013-10-27','12:45:00',1.72),('8998','2013-10-27','12:50:00',1.72),('8998','2013-10-27','12:55:00',1.63),('8998','2013-10-27','13:00:00',1.47),('8998','2013-10-27','13:05:00',1.4),('8998','2013-10-27','13:10:00',1.38),('8998','2013-10-27','13:15:00',1.32),('8998','2013-10-27','13:20:00',1.24),('8998','2013-10-27','13:25:00',1.18),('8998','2013-10-27','13:30:00',1.09),('8998','2013-10-27','13:35:00',1.02),('8998','2013-10-26','10:50:00',1),('8998','2013-10-26','11:40:00',1.57),('8998','2013-10-26','11:45:00',1.84),('8998','2013-10-26','11:50:00',1.48),('8998','2013-10-26','12:20:00',1.43),('8998','2013-10-26','12:25:00',1.73),('8998','2013-10-26','12:30:00',1.51),('8998','2013-10-26','12:35:00',1.69),('8998','2013-10-26','12:40:00',1.39),('8998','2013-10-26','12:50:00',1),('8998','2013-10-26','13:00:00',1.24),('8998','2013-10-26','13:10:00',1.2),('8998','2013-10-26','13:30:00',1.22),('8998','2013-10-26','13:35:00',1),('8998','2013-10-26','13:40:00',1.13),('8998','2013-10-25','09:05:00',1.17),('8998','2013-10-25','09:10:00',1.24),('8998','2013-10-25','09:15:00',1.31),('8998','2013-10-25','09:20:00',1.36),('8998','2013-10-25','09:25:00',1.4),('8998','2013-10-25','09:30:00',1.44),('8998','2013-10-25','09:35:00',1.49),('8998','2013-10-25','09:40:00',1.53),('8998','2013-10-25','09:45:00',1.57),('8998','2013-10-25','09:50:00',1.61),('8998','2013-10-25','09:55:00',1.65),('8998','2013-10-25','10:00:00',1.68),('8998','2013-10-25','10:05:00',1.72),('8998','2013-10-25','10:10:00',1.74),('8998','2013-10-25','10:15:00',1.77),('8998','2013-10-25','10:20:00',1.79),('8998','2013-10-25','10:25:00',1.81),('8998','2013-10-25','10:30:00',1.83),('8998','2013-10-25','10:35:00',1.84),('8998','2013-10-25','10:40:00',1.87),('8998','2013-10-25','10:45:00',1.87),('8998','2013-10-25','10:50:00',1.9),('8998','2013-10-25','10:55:00',1.92),('8998','2013-10-25','11:00:00',1.94),('8998','2013-10-25','11:05:00',1.96),('8998','2013-10-25','11:10:00',1.95),('8998','2013-10-25','11:15:00',1.95),('8998','2013-10-25','11:20:00',1.96),('8998','2013-10-25','11:25:00',1.95),('8998','2013-10-25','11:30:00',1.97),('8998','2013-10-25','11:35:00',1.95),('8998','2013-10-25','11:40:00',1.96),('8998','2013-10-25','11:45:00',1.96),('8998','2013-10-25','11:50:00',1.96),('8998','2013-10-25','11:55:00',1.92),('8998','2013-10-25','12:00:00',1.93),('8998','2013-10-25','12:05:00',1.91),('8998','2013-10-25','12:10:00',1.9),('8998','2013-10-25','12:15:00',1.85),('8998','2013-10-25','12:20:00',1.89),('8998','2013-10-25','12:25:00',1.84),('8998','2013-10-25','12:30:00',1.87),('8998','2013-10-25','12:35:00',1.87),('8998','2013-10-25','12:40:00',1.81),('8998','2013-10-25','12:45:00',1.79),('8998','2013-10-25','12:50:00',1.77),('8998','2013-10-25','12:55:00',1.73),('8998','2013-10-25','13:00:00',1.74),('8998','2013-10-25','13:05:00',1.71),('8998','2013-10-25','13:10:00',1.66),('8998','2013-10-25','13:15:00',1.52),('8998','2013-10-25','13:20:00',1.48),('8998','2013-10-25','13:25:00',1.54),('8998','2013-10-25','13:30:00',1.45),('8998','2013-10-25','13:35:00',1.52),('8998','2013-10-25','13:40:00',1.57),('8998','2013-10-25','13:45:00',1.46),('8998','2013-10-25','13:50:00',1.3),('8998','2013-10-25','13:55:00',1.39),('8998','2013-10-25','14:00:00',1.36),('8998','2013-10-25','14:05:00',1.25),('8998','2013-10-25','14:10:00',1.25),('8998','2013-10-25','14:15:00',1.31),('8998','2013-10-25','14:20:00',1.17),('8998','2013-10-24','09:05:00',1.21),('8998','2013-10-24','09:10:00',1.26),('8998','2013-10-24','09:15:00',1.34),('8998','2013-10-24','09:20:00',1.39),('8998','2013-10-24','09:25:00',1.44),('8998','2013-10-24','09:30:00',1.48),('8998','2013-10-24','09:35:00',1.52),('8998','2013-10-24','09:40:00',1.56),('8998','2013-10-24','09:45:00',1.59),('8998','2013-10-24','09:50:00',1.63),('8998','2013-10-24','09:55:00',1.67),('8998','2013-10-24','10:00:00',1.71),('8998','2013-10-24','10:05:00',1.74),('8998','2013-10-24','10:10:00',1.77),('8998','2013-10-24','10:15:00',1.79),('8998','2013-10-24','10:20:00',1.81),('8998','2013-10-24','10:25:00',1.85),('8998','2013-10-24','10:30:00',1.88),('8998','2013-10-24','10:35:00',1.9),('8998','2013-10-24','10:40:00',1.91),('8998','2013-10-24','10:45:00',1.92),('8998','2013-10-24','10:50:00',1.95),('8998','2013-10-24','10:55:00',1.94),('8998','2013-10-24','11:00:00',1.96),('8998','2013-10-24','11:05:00',1.95),('8998','2013-10-24','11:10:00',1.96),('8998','2013-10-24','11:15:00',1.98),('8998','2013-10-24','11:20:00',1.98),('8998','2013-10-24','11:25:00',1.98),('8998','2013-10-24','11:30:00',1.97),('8998','2013-10-24','11:35:00',1.97),('8998','2013-10-24','11:40:00',1.97),('8998','2013-10-24','11:45:00',1.97),('8998','2013-10-24','11:50:00',1.99),('8998','2013-10-24','11:55:00',2),('8998','2013-10-24','12:00:00',1.99),('8998','2013-10-24','12:05:00',1.99),('8998','2013-10-24','12:10:00',1.97),('8998','2013-10-24','12:15:00',1.97),('8998','2013-10-24','12:20:00',1.96),('8998','2013-10-24','12:25:00',1.94),('8998','2013-10-24','12:30:00',1.93),('8998','2013-10-24','12:35:00',1.91),('8998','2013-10-24','12:40:00',1.89),('8998','2013-10-24','12:45:00',1.86),('8998','2013-10-24','12:50:00',1.82),('8998','2013-10-24','12:55:00',1.8),('8998','2013-10-24','13:00:00',1.81),('8998','2013-10-24','13:05:00',1.78),('8998','2013-10-24','13:10:00',1.75),('8998','2013-10-24','13:15:00',1.7),('8998','2013-10-24','13:20:00',1.67),('8998','2013-10-24','13:25:00',1.61),('8998','2013-10-24','13:30:00',1.58),('8998','2013-10-24','13:35:00',1.57),('8998','2013-10-24','13:40:00',1.56),('8998','2013-10-24','13:45:00',1.5),('8998','2013-10-24','13:50:00',1.48),('8998','2013-10-24','13:55:00',1.46),('8998','2013-10-24','14:00:00',1.41),('8998','2013-10-24','14:05:00',1.37),('8998','2013-10-24','14:10:00',1.34),('8998','2013-10-24','14:15:00',1.3),('8998','2013-10-24','14:20:00',1.26),('8998','2013-10-24','14:25:00',1.2),('8998','2013-10-24','14:30:00',1.07),('8998','2013-10-23','09:15:00',1.29),('8998','2013-10-23','09:20:00',1.31),('8998','2013-10-23','10:40:00',1.07),('8998','2013-10-23','10:45:00',1.9),('8998','2013-10-23','10:50:00',1.53),('8998','2013-10-23','10:55:00',1.89),('8998','2013-10-23','11:00:00',2.22),('8998','2013-10-23','11:05:00',2.34),('8998','2013-10-23','11:10:00',2.54),('8998','2013-10-23','11:15:00',1.25),('8998','2013-10-23','11:20:00',1.04),('8998','2013-10-23','11:25:00',1.77),('8998','2013-10-23','11:30:00',1.41),('8998','2013-10-23','11:50:00',1.21),('8998','2013-10-23','11:55:00',2.19),('8998','2013-10-23','12:00:00',1.31),('8998','2013-10-23','12:05:00',1.02),('8998','2013-10-23','12:25:00',1.01),('8998','2013-10-23','12:30:00',1.04),('8998','2013-10-23','12:35:00',1.12),('8998','2013-10-23','12:40:00',1.26),('8998','2013-10-23','12:45:00',1.36),('8998','2013-10-23','12:50:00',1.43),('8998','2013-10-23','12:55:00',1.42),('8998','2013-10-23','13:00:00',1.75),('8998','2013-10-23','13:05:00',2.29),('8998','2013-10-23','13:10:00',1.86),('8998','2013-10-23','13:15:00',1.49),('8998','2013-10-23','13:20:00',1.51),('8998','2013-10-23','13:25:00',1.55),('8998','2013-10-23','13:55:00',1.14),('8998','2013-10-23','14:00:00',1.31),('8998','2013-10-23','14:05:00',1.21),('8998','2013-10-23','14:35:00',1.05),('8998','2013-10-23','14:40:00',1.03),('8998','2013-10-23','14:50:00',1.02),('8998','2013-10-22','10:50:00',1.3),('8998','2013-10-22','10:55:00',1.01),('8998','2013-10-22','11:00:00',1.12),('8998','2013-10-22','11:10:00',1.23),('8998','2013-10-22','11:15:00',1.96),('8998','2013-10-22','11:20:00',1.97),('8998','2013-10-22','11:25:00',2.11),('8998','2013-10-22','11:30:00',1.75),('8998','2013-10-22','11:35:00',1.97),('8998','2013-10-22','11:40:00',2.06),('8998','2013-10-22','11:45:00',1.96),('8998','2013-10-22','11:50:00',1.86),('8998','2013-10-22','11:55:00',1.89),('8998','2013-10-22','12:00:00',1.97),('8998','2013-10-22','12:05:00',1.92),('8998','2013-10-22','12:10:00',1.81),('8998','2013-10-22','12:15:00',1.83),('8998','2013-10-22','12:20:00',1.8),('8998','2013-10-22','12:25:00',1.86),('8998','2013-10-22','12:30:00',1.83),('8998','2013-10-22','12:35:00',1.79),('8998','2013-10-22','12:40:00',1.79),('8998','2013-10-22','12:45:00',1.62),('8998','2013-10-22','12:50:00',1.48),('8998','2013-10-22','12:55:00',1.28),('8998','2013-10-22','13:00:00',1.75),('8998','2013-10-22','13:05:00',1.69),('8998','2013-10-22','13:10:00',1.66),('8998','2013-10-22','13:15:00',1.67),('8998','2013-10-22','13:20:00',1.64),('8998','2013-10-22','13:25:00',1.62),('8998','2013-10-22','13:30:00',1.6),('8998','2013-10-22','13:35:00',1.57),('8998','2013-10-22','13:40:00',1.56),('8998','2013-10-22','13:45:00',1.54),('8998','2013-10-22','13:50:00',1.4),('8998','2013-10-22','13:55:00',1.09),('8998','2013-10-22','14:00:00',1.32),('8998','2013-10-22','14:05:00',1.3),('8998','2013-10-22','14:10:00',1.27),('8998','2013-10-22','14:15:00',1.33),('8998','2013-10-22','14:20:00',1.26),('8998','2013-10-22','14:25:00',1.19),('8998','2013-10-22','14:30:00',1.16),('8998','2013-10-22','14:35:00',1.09),('8998','2013-10-21','09:00:00',1.11),('8998','2013-10-21','09:05:00',1.18),('8998','2013-10-21','09:10:00',1.24),('8998','2013-10-21','09:15:00',1.31),('8998','2013-10-21','09:20:00',1.37),('8998','2013-10-21','09:25:00',1.43),('8998','2013-10-21','09:30:00',1.47),('8998','2013-10-21','09:35:00',1.52),('8998','2013-10-21','09:40:00',1.56),('8998','2013-10-21','09:45:00',1.59),('8998','2013-10-21','09:50:00',1.62),('8998','2013-10-21','09:55:00',1.66),('8998','2013-10-21','10:00:00',1.68),('8998','2013-10-21','10:05:00',1.71),('8998','2013-10-21','10:10:00',1.74),('8998','2013-10-21','10:15:00',1.78),('8998','2013-10-21','10:20:00',1.81),('8998','2013-10-21','10:25:00',1.84),('8998','2013-10-21','10:30:00',1.85),('8998','2013-10-21','10:35:00',1.87),('8998','2013-10-21','10:40:00',1.89),('8998','2013-10-21','10:45:00',1.91),('8998','2013-10-21','10:50:00',1.94),('8998','2013-10-21','10:55:00',1.92),('8998','2013-10-21','11:00:00',1.91),('8998','2013-10-21','11:05:00',1.94),('8998','2013-10-21','11:10:00',1.95),('8998','2013-10-21','11:15:00',1.95),('8998','2013-10-21','11:20:00',1.97),('8998','2013-10-21','11:25:00',1.95),('8998','2013-10-21','11:30:00',1.94),('8998','2013-10-21','11:35:00',1.95),('8998','2013-10-21','11:40:00',1.93),('8998','2013-10-21','11:45:00',1.9),('8998','2013-10-21','11:50:00',1.9),('8998','2013-10-21','11:55:00',1.92),('8998','2013-10-21','12:00:00',1.92),('8998','2013-10-21','12:05:00',1.92),('8998','2013-10-21','12:10:00',1.89),('8998','2013-10-21','12:15:00',1.86),('8998','2013-10-21','12:20:00',1.88),('8998','2013-10-21','12:25:00',1.88),('8998','2013-10-21','12:30:00',1.84),('8998','2013-10-21','12:35:00',1.84),('8998','2013-10-21','12:40:00',1.83),('8998','2013-10-21','12:45:00',1.82),('8998','2013-10-21','12:50:00',1.81),('8998','2013-10-21','12:55:00',1.73),('8998','2013-10-21','13:00:00',1.72),('8998','2013-10-21','13:05:00',1.7),('8998','2013-10-21','13:10:00',1.64),('8998','2013-10-21','13:15:00',1.63),('8998','2013-10-21','13:20:00',1.63),('8998','2013-10-21','13:25:00',1.62),('8998','2013-10-21','13:30:00',1.6),('8998','2013-10-21','13:35:00',1.5),('8998','2013-10-21','13:40:00',1.53),('8998','2013-10-21','13:45:00',1.5),('8998','2013-10-21','13:50:00',1.41),('8998','2013-10-21','13:55:00',1.39),('8998','2013-10-21','14:00:00',1.32),('8998','2013-10-21','14:05:00',1.37),('8998','2013-10-21','14:10:00',1.33),('8998','2013-10-21','14:15:00',1.25),('8998','2013-10-21','14:25:00',1.17),('8998','2013-10-20','09:10:00',1.09),('8998','2013-10-20','09:15:00',1.3),('8998','2013-10-20','09:20:00',1.48),('8998','2013-10-20','09:25:00',1.54),('8998','2013-10-20','09:30:00',1.44),('8998','2013-10-20','09:35:00',1.3),('8998','2013-10-20','09:40:00',1.57),('8998','2013-10-20','09:45:00',1.36),('8998','2013-10-20','09:50:00',1.42),('8998','2013-10-20','09:55:00',1.55),('8998','2013-10-20','10:00:00',1.54),('8998','2013-10-20','10:05:00',1.69),('8998','2013-10-20','10:10:00',1.82),('8998','2013-10-20','10:15:00',1.86),('8998','2013-10-20','10:20:00',1.82),('8998','2013-10-20','10:25:00',1.89),('8998','2013-10-20','10:30:00',1.85),('8998','2013-10-20','10:35:00',1.83),('8998','2013-10-20','10:40:00',1.79),('8998','2013-10-20','10:45:00',1.83),('8998','2013-10-20','10:50:00',1.9),('8998','2013-10-20','10:55:00',1.89),('8998','2013-10-20','11:00:00',2),('8998','2013-10-20','11:05:00',1.86),('8998','2013-10-20','11:10:00',1.62),('8998','2013-10-20','11:15:00',2.05),('8998','2013-10-20','11:20:00',2.04),('8998','2013-10-20','11:25:00',1.99),('8998','2013-10-20','11:30:00',2.03),('8998','2013-10-20','11:35:00',2.04),('8998','2013-10-20','11:40:00',1.99),('8998','2013-10-20','11:45:00',2.06),('8998','2013-10-20','11:50:00',2.04),('8998','2013-10-20','11:55:00',2.04),('8998','2013-10-20','12:00:00',2.05),('8998','2013-10-20','12:05:00',2.06),('8998','2013-10-20','12:10:00',2.04),('8998','2013-10-20','12:15:00',2.02),('8998','2013-10-20','12:20:00',2),('8998','2013-10-20','12:25:00',2),('8998','2013-10-20','12:30:00',1.9),('8998','2013-10-20','12:35:00',1.9),('8998','2013-10-20','12:40:00',1.94),('8998','2013-10-20','12:45:00',1.93),('8998','2013-10-20','12:50:00',1.9),('8998','2013-10-20','12:55:00',1.87),('8998','2013-10-20','13:00:00',1.83),('8998','2013-10-20','13:05:00',1.78),('8998','2013-10-20','13:10:00',1.66),('8998','2013-10-20','13:15:00',1.7),('8998','2013-10-20','13:20:00',1.69),('8998','2013-10-20','13:25:00',1.66),('8998','2013-10-20','13:30:00',1.69),('8998','2013-10-20','13:35:00',1.66),('8998','2013-10-20','13:40:00',1.61),('8998','2013-10-20','13:45:00',1.58),('8998','2013-10-20','13:50:00',1.54),('8998','2013-10-20','13:55:00',1.48),('8998','2013-10-20','14:00:00',1.41),('8998','2013-10-20','14:05:00',1.44),('8998','2013-10-20','14:10:00',1.4),('8998','2013-10-20','14:15:00',1.36),('8998','2013-10-20','14:20:00',1.32),('8998','2013-10-20','14:25:00',1.27),('8998','2013-10-20','14:30:00',1.19),('8998','2013-10-20','14:35:00',1.09),('8998','2013-10-19','08:55:00',1.08),('8998','2013-10-19','09:00:00',1.28),('8998','2013-10-19','09:05:00',1.3),('8998','2013-10-19','09:10:00',1.37),('8998','2013-10-19','09:15:00',1.44),('8998','2013-10-19','09:20:00',1.51),('8998','2013-10-19','09:25:00',1.56),('8998','2013-10-19','09:30:00',1.59),('8998','2013-10-19','09:35:00',1.62),('8998','2013-10-19','09:40:00',1.68),('8998','2013-10-19','09:45:00',1.72),('8998','2013-10-19','09:50:00',1.73),('8998','2013-10-19','09:55:00',1.77),('8998','2013-10-19','10:00:00',1.81),('8998','2013-10-19','10:05:00',1.86),('8998','2013-10-19','10:10:00',1.9),('8998','2013-10-19','10:15:00',1.91),('8998','2013-10-19','10:20:00',1.93),('8998','2013-10-19','10:25:00',1.96),('8998','2013-10-19','10:30:00',1.99),('8998','2013-10-19','10:35:00',2),('8998','2013-10-19','10:40:00',2.01),('8998','2013-10-19','10:45:00',2.04),('8998','2013-10-19','10:50:00',2.04),('8998','2013-10-19','10:55:00',2.05),('8998','2013-10-19','11:00:00',2.06),('8998','2013-10-19','11:05:00',2.08),('8998','2013-10-19','11:10:00',2.1),('8998','2013-10-19','11:15:00',2.09),('8998','2013-10-19','11:20:00',2.1),('8998','2013-10-19','11:25:00',2.1),('8998','2013-10-19','11:30:00',2.12),('8998','2013-10-19','11:35:00',2.11),('8998','2013-10-19','11:40:00',2.12),('8998','2013-10-19','11:45:00',2.11),('8998','2013-10-19','11:50:00',2.13),('8998','2013-10-19','11:55:00',2.06),('8998','2013-10-19','12:00:00',2.08),('8998','2013-10-19','12:05:00',2.09),('8998','2013-10-19','12:10:00',2.1),('8998','2013-10-19','12:15:00',1.31),('8998','2013-10-19','12:30:00',1.97),('8998','2013-10-19','12:35:00',1.62),('8998','2013-10-19','12:40:00',1.71),('8998','2013-10-19','12:50:00',1.16),('8998','2013-10-19','12:55:00',1.73),('8998','2013-10-19','13:00:00',1.59),('8998','2013-10-19','13:05:00',1.64),('8998','2013-10-19','13:10:00',2.19),('8998','2013-10-19','13:15:00',1.31),('8998','2013-10-19','13:30:00',1.43),('8998','2013-10-19','13:35:00',1.38),('8998','2013-10-19','13:45:00',1.5),('8998','2013-10-19','13:55:00',1.11),('8998','2013-10-19','14:10:00',1),('8998','2013-10-18','08:55:00',1.17),('8998','2013-10-18','09:00:00',1.2),('8998','2013-10-18','09:05:00',1.12),('8998','2013-10-18','09:10:00',1.59),('8998','2013-10-18','09:15:00',1.85),('8998','2013-10-18','09:20:00',1.87),('8998','2013-10-18','09:25:00',1.87),('8998','2013-10-18','09:30:00',1.88),('8998','2013-10-18','09:35:00',1.9),('8998','2013-10-18','09:40:00',1.96),('8998','2013-10-18','09:45:00',2.04),('8998','2013-10-18','09:50:00',2.08),('8998','2013-10-18','09:55:00',2.15),('8998','2013-10-18','10:00:00',2.12),('8998','2013-10-18','10:05:00',1.98),('8998','2013-10-18','10:10:00',2.12),('8998','2013-10-18','10:15:00',2.06),('8998','2013-10-18','10:20:00',2.2),('8998','2013-10-18','10:25:00',2.33),('8998','2013-10-18','10:30:00',2.34),('8998','2013-10-18','10:35:00',2.32),('8998','2013-10-18','10:40:00',2.3),('8998','2013-10-18','10:45:00',2.25),('8998','2013-10-18','10:50:00',2.27),('8998','2013-10-18','10:55:00',2.31),('8998','2013-10-18','11:00:00',2.3),('8998','2013-10-18','11:05:00',2.03),('8998','2013-10-18','11:20:00',1.6),('8998','2013-10-18','11:25:00',2.55),('8998','2013-10-18','11:30:00',2.43),('8998','2013-10-18','11:35:00',2.41),('8998','2013-10-18','11:40:00',1.56),('8998','2013-10-18','11:45:00',2.31),('8998','2013-10-18','11:50:00',2.25),('8998','2013-10-18','11:55:00',2.28),('8998','2013-10-18','12:00:00',1.69),('8998','2013-10-18','12:05:00',2.21),('8998','2013-10-18','12:10:00',2.26),('8998','2013-10-18','12:15:00',2.25),('8998','2013-10-18','12:20:00',2.27),('8998','2013-10-18','12:25:00',1.48),('8998','2013-10-18','12:30:00',2.16),('8998','2013-10-18','12:35:00',2.2),('8998','2013-10-18','12:40:00',2.26),('8998','2013-10-18','12:45:00',1.63),('8998','2013-10-18','12:50:00',2.24),('8998','2013-10-18','12:55:00',2.2),('8998','2013-10-18','13:00:00',2.39),('8998','2013-10-18','13:05:00',1.87),('8998','2013-10-18','13:10:00',1.91),('8998','2013-10-18','13:15:00',1.9),('8998','2013-10-18','13:20:00',1.85),('8998','2013-10-18','13:25:00',2.04),('8998','2013-10-18','13:30:00',2.05),('8998','2013-10-18','13:35:00',1.71),('8998','2013-10-18','13:40:00',1.52),('8998','2013-10-18','13:45:00',1.55),('8998','2013-10-18','13:50:00',1.57),('8998','2013-10-18','13:55:00',1.89),('8998','2013-10-18','14:00:00',1.51),('8998','2013-10-18','14:05:00',1.28),('8998','2013-10-18','14:15:00',1.19),('8998','2013-10-18','14:20:00',1.08),('8998','2013-10-18','14:25:00',1.07),('8998','2013-10-18','14:30:00',1.22),('8998','2013-10-18','14:35:00',1.55),('8998','2013-10-18','14:40:00',1.16),('8998','2013-10-18','14:50:00',1.12),('8998','2013-10-18','14:55:00',1.07),('8998','2014-05-03','07:40:00',1.31),('8998','2014-05-03','07:45:00',1.36),('8998','2014-05-03','07:50:00',1.54),('8998','2014-05-03','07:55:00',1.52),('8998','2014-05-03','08:00:00',1.42),('8998','2014-05-03','08:05:00',1.72),('8998','2014-05-03','08:10:00',1.7),('8998','2014-05-03','08:15:00',1.83),('8998','2014-05-03','08:20:00',1.76),('8998','2014-05-03','08:25:00',1.65),('8998','2014-05-03','08:30:00',2.06),('8998','2014-05-03','08:35:00',2.05),('8998','2014-05-03','08:40:00',1.19),('8998','2014-05-03','08:45:00',1.04),('8998','2014-05-03','08:50:00',1.45),('8998','2014-05-03','08:55:00',1.07),('8998','2014-05-03','09:00:00',1.21),('8998','2014-05-03','09:05:00',1.91),('8998','2014-05-03','09:10:00',1.6),('8998','2014-05-03','09:15:00',2),('8998','2014-05-03','09:20:00',2.95),('8998','2014-05-03','09:25:00',2.39),('8998','2014-05-03','09:30:00',1.09),('8998','2014-05-03','09:35:00',1.03),('8998','2014-05-03','09:40:00',1.68),('8998','2014-05-03','09:45:00',2.14),('8998','2014-05-03','09:50:00',2.04),('8998','2014-05-03','09:55:00',2.31),('8998','2014-05-03','10:00:00',3.28),('8998','2014-05-03','10:05:00',3.27),('8998','2014-05-03','10:10:00',3.19),('8998','2014-05-03','10:15:00',2.26),('8998','2014-05-03','10:20:00',1.5),('8998','2014-05-03','10:25:00',1.41),('8998','2014-05-03','10:30:00',1.42),('8998','2014-05-03','10:35:00',1.52),('8998','2014-05-03','10:40:00',1.57),('8998','2014-05-03','10:45:00',2.3),('8998','2014-05-03','10:50:00',2.27),('8998','2014-05-03','10:55:00',1.99),('8998','2014-05-03','11:00:00',1.87),('8998','2014-05-03','11:05:00',2.8),('8998','2014-05-03','11:10:00',3.37),('8998','2014-05-03','11:15:00',3.28),('8998','2014-05-03','11:20:00',3.19),('8998','2014-05-03','11:25:00',2.64),('8998','2014-05-03','11:30:00',3.16),('8998','2014-05-03','11:35:00',3.05),('8998','2014-05-03','11:40:00',2.3),('8998','2014-05-03','11:45:00',3.41),('8998','2014-05-03','11:50:00',2.05),('8998','2014-05-03','11:55:00',2.56),('8998','2014-05-03','12:00:00',2.31),('8998','2014-05-03','12:05:00',2.01),('8998','2014-05-03','12:10:00',1.92),('8998','2014-05-03','12:15:00',1.19),('8998','2014-05-03','12:20:00',1.31),('8998','2014-05-03','12:25:00',2.25),('8998','2014-05-03','12:30:00',3.77),('8998','2014-05-03','12:35:00',3.49),('8998','2014-05-03','12:40:00',3.63),('8998','2014-05-03','12:45:00',2.86),('8998','2014-05-03','12:50:00',1.81),('8998','2014-05-03','12:55:00',1.71),('8998','2014-05-03','13:00:00',1.77),('8998','2014-05-03','13:05:00',1.72),('8998','2014-05-03','13:10:00',1.68),('8998','2014-05-03','13:15:00',1.49),('8998','2014-05-03','13:20:00',1.36),('8998','2014-05-03','13:25:00',1.14),('8998','2014-05-03','13:30:00',1.27),('8998','2014-05-03','13:35:00',1.29),('8998','2014-05-03','13:40:00',1.2),('8998','2014-05-03','13:45:00',1.07),('8998','2014-05-03','13:50:00',1.06),('8998','2014-05-03','13:55:00',1.07),('8998','2014-05-03','14:00:00',1.06),('8998','2014-05-03','14:05:00',1.08),('8998','2014-05-03','14:10:00',1.05),('8998','2014-05-03','14:55:00',1.2),('8998','2014-05-03','15:00:00',1.3),('8998','2014-05-03','15:05:00',1.88),('8998','2014-05-03','15:10:00',1.95),('8998','2014-05-03','15:15:00',1.65),('8998','2014-05-03','15:20:00',1.02),('8998','2014-04-15','08:00:00',1.24),('8998','2014-04-15','08:05:00',1.2),('8998','2014-04-15','08:10:00',1.36),('8998','2014-04-15','08:15:00',1.55),('8998','2014-04-15','08:20:00',1.44),('8998','2014-04-15','08:25:00',1.58),('8998','2014-04-15','08:30:00',1.09),('8998','2014-04-15','08:35:00',1.02),('8998','2014-04-15','08:40:00',1.11),('8998','2014-04-15','08:45:00',1.56),('8998','2014-04-15','08:50:00',2.23),('8998','2014-04-15','08:55:00',2.27),('8998','2014-04-15','09:00:00',2.3),('8998','2014-04-15','09:05:00',2.35),('8998','2014-04-15','09:10:00',2.4),('8998','2014-04-15','09:15:00',2.45),('8998','2014-04-15','09:20:00',2.5),('8998','2014-04-15','09:25:00',2.58),('8998','2014-04-15','09:30:00',1.34),('8998','2014-04-15','09:45:00',1.02),('8998','2014-04-15','09:50:00',2.03),('8998','2014-04-15','09:55:00',3.1),('8998','2014-04-15','10:00:00',2.99),('8998','2014-04-15','10:05:00',3.01),('8998','2014-04-15','10:10:00',3.03),('8998','2014-04-15','10:15:00',3.07),('8998','2014-04-15','10:20:00',3.09),('8998','2014-04-15','10:25:00',3.09),('8998','2014-04-15','10:30:00',3.11),('8998','2014-04-15','10:35:00',3.13),('8998','2014-04-15','10:40:00',3.15),('8998','2014-04-15','10:45:00',3.18),('8998','2014-04-15','10:50:00',3.25),('8998','2014-04-15','10:55:00',2.91),('8998','2014-04-15','11:00:00',3.16),('8998','2014-04-15','11:05:00',2.43),('8998','2014-04-15','11:10:00',1.22),('8998','2014-04-15','11:15:00',1.75),('8998','2014-04-15','11:20:00',3.42),('8998','2014-04-15','11:25:00',2.22),('8998','2014-04-15','11:30:00',2.92),('8998','2014-04-15','11:35:00',2.04),('8998','2014-04-15','11:40:00',2.87),('8998','2014-04-15','11:45:00',3.15),('8998','2014-04-15','11:50:00',3.6),('8998','2014-04-15','11:55:00',3.38),('8998','2014-04-15','12:00:00',3.52),('8998','2014-04-15','12:05:00',1.36),('8998','2014-04-15','12:10:00',3.19),('8998','2014-04-15','12:15:00',3.41),('8998','2014-04-15','12:20:00',2.77),('8998','2014-04-15','12:30:00',1.87),('8998','2014-04-15','12:35:00',3.31),('8998','2014-04-15','12:40:00',3.33),('8998','2014-04-15','12:45:00',3.22),('8998','2014-04-15','12:50:00',3.25),('8998','2014-04-15','12:55:00',2.26),('8998','2014-04-15','13:00:00',1.92),('8998','2014-04-15','13:20:00',1.1),('8998','2014-04-15','13:35:00',1.11),('8998','2014-04-15','13:40:00',1.43),('8998','2014-04-15','13:45:00',3.13),('8998','2014-04-15','13:50:00',3.02),('8998','2014-04-15','13:55:00',1.79),('8998','2014-04-15','14:00:00',1.2),('8998','2014-04-15','14:05:00',2.08),('8998','2014-04-15','14:10:00',3.05),('8998','2014-04-15','14:15:00',3.12),('8998','2014-04-15','14:20:00',2.75),('8998','2014-04-15','14:25:00',2.31),('8998','2014-04-15','14:30:00',2.37),('8998','2014-04-15','14:35:00',2.59),('8998','2014-04-15','14:40:00',2.51),('8998','2014-04-15','14:45:00',1.74),('8998','2014-04-15','14:50:00',2.04),('8998','2014-04-15','15:05:00',1.71),('8998','2014-04-15','15:10:00',2.82),('8998','2014-04-15','15:15:00',1.55),('8998','2014-04-15','15:30:00',1.9),('8998','2014-04-15','15:35:00',2.06),('8998','2014-04-15','15:43:00',1.93),('8998','2014-04-15','15:45:00',1.74),('8998','2014-04-15','15:50:00',1.68),('8998','2014-04-15','15:55:00',1.6),('8998','2014-04-15','16:00:00',1.52),('8998','2014-04-15','16:05:00',1.45),('8998','2014-04-15','16:10:00',1.39),('8998','2014-04-15','16:15:00',1.33),('8998','2014-04-15','16:20:00',1.28),('8998','2014-04-15','16:25:00',1.2),('8998','2014-04-15','16:30:00',1.14),('8998','2014-04-15','16:35:00',1.09),('8998','2014-04-15','16:40:00',1.02),('8998','2013-10-17','08:50:00',1.15),('8998','2013-10-17','08:55:00',1.25),('8998','2013-10-17','09:00:00',1.42),('8998','2013-10-17','09:05:00',1.54),('8998','2013-10-17','09:10:00',1.62),('8998','2013-10-17','09:15:00',1.64),('8998','2013-10-17','09:20:00',1.78),('8998','2013-10-17','09:25:00',1.79),('8998','2013-10-17','09:30:00',1.86),('8998','2013-10-17','09:35:00',1.9),('8998','2013-10-17','09:40:00',1.94),('8998','2013-10-17','09:45:00',1.97),('8998','2013-10-17','09:50:00',2),('8998','2013-10-17','09:55:00',2.03),('8998','2013-10-17','10:00:00',2.04),('8998','2013-10-17','10:05:00',2.08),('8998','2013-10-17','10:10:00',2.09),('8998','2013-10-17','10:15:00',2.11),('8998','2013-10-17','10:20:00',2.12),('8998','2013-10-17','10:25:00',2.15),('8998','2013-10-17','10:30:00',2.18),('8998','2013-10-17','10:35:00',2.2),('8998','2013-10-17','10:40:00',2.23),('8998','2013-10-17','10:45:00',2.24),('8998','2013-10-17','10:50:00',2.23),('8998','2013-10-17','10:55:00',2.26),('8998','2013-10-17','11:00:00',2.22),('8998','2013-10-17','11:05:00',2.19),('8998','2013-10-17','11:10:00',2.12),('8998','2013-10-17','11:15:00',1.97),('8998','2013-10-17','11:20:00',2.21),('8998','2013-10-17','11:25:00',2.02),('8998','2013-10-17','11:30:00',2.26),('8998','2013-10-17','11:35:00',2.25),('8998','2013-10-17','11:40:00',2.29),('8998','2013-10-17','11:45:00',2.18),('8998','2013-10-17','11:50:00',2.22),('8998','2013-10-17','11:55:00',2.26),('8998','2013-10-17','12:00:00',2.14),('8998','2013-10-17','12:05:00',2.22),('8998','2013-10-17','12:10:00',2.2),('8998','2013-10-17','12:15:00',2.14),('8998','2013-10-17','12:20:00',2.11),('8998','2013-10-17','12:25:00',2.14),('8998','2013-10-17','12:30:00',2.14),('8998','2013-10-17','12:35:00',2.07),('8998','2013-10-17','12:40:00',2.08),('8998','2013-10-17','12:45:00',1.99),('8998','2013-10-17','12:50:00',1.96),('8998','2013-10-17','12:55:00',2),('8998','2013-10-17','13:00:00',1.97),('8998','2013-10-17','13:05:00',1.9),('8998','2013-10-17','13:10:00',1.8),('8998','2013-10-17','13:15:00',1.86),('8998','2013-10-17','13:20:00',1.84),('8998','2013-10-17','13:25:00',1.88),('8998','2013-10-17','13:30:00',1.84),('8998','2013-10-17','13:35:00',1.79),('8998','2013-10-17','13:40:00',1.77),('8998','2013-10-17','13:45:00',1.71),('8998','2013-10-17','13:50:00',1.68),('8998','2013-10-17','13:55:00',1.65),('8998','2013-10-17','14:00:00',1.48),('8998','2013-10-17','14:05:00',1.51),('8998','2013-10-17','14:10:00',1.47),('8998','2013-10-17','14:15:00',1.47),('8998','2013-10-17','14:20:00',1.43),('8998','2013-10-17','14:25:00',1.4),('8998','2013-10-17','14:30:00',1.34),('8998','2013-10-17','14:35:00',1.17),('8998','2013-10-17','14:40:00',1.06),('8998','2013-10-16','08:50:00',1.15),('8998','2013-10-16','08:55:00',1.46),('8998','2013-10-16','09:00:00',1.53),('8998','2013-10-16','09:05:00',1.59),('8998','2013-10-16','09:10:00',1.63),('8998','2013-10-16','09:15:00',1.71),('8998','2013-10-16','09:20:00',1.77),('8998','2013-10-16','09:25:00',1.82),('8998','2013-10-16','09:30:00',1.85),('8998','2013-10-16','09:35:00',1.89),('8998','2013-10-16','09:40:00',1.93),('8998','2013-10-16','09:45:00',1.96),('8998','2013-10-16','09:50:00',1.99),('8998','2013-10-16','09:55:00',2.03),('8998','2013-10-16','10:00:00',2.05),('8998','2013-10-16','10:05:00',2.07),('8998','2013-10-16','10:10:00',2.1),('8998','2013-10-16','10:15:00',2.13),('8998','2013-10-16','10:20:00',2.15),('8998','2013-10-16','10:25:00',2.17),('8998','2013-10-16','10:30:00',2.2),('8998','2013-10-16','10:35:00',2.22),('8998','2013-10-16','10:40:00',2.24),('8998','2013-10-16','10:45:00',2.25),('8998','2013-10-16','10:50:00',2.27),('8998','2013-10-16','10:55:00',2.28),('8998','2013-10-16','11:00:00',2.29),('8998','2013-10-16','11:05:00',2.3),('8998','2013-10-16','11:10:00',2.3),('8998','2013-10-16','11:15:00',2.3),('8998','2013-10-16','11:20:00',2.31),('8998','2013-10-16','11:25:00',2.31),('8998','2013-10-16','11:30:00',2.32),('8998','2013-10-16','11:35:00',2.33),('8998','2013-10-16','11:40:00',2.33),('8998','2013-10-16','11:45:00',2.3),('8998','2013-10-16','11:50:00',2.3),('8998','2013-10-16','11:55:00',2.3),('8998','2013-10-16','12:00:00',2.28),('8998','2013-10-16','12:05:00',2.27),('8998','2013-10-16','12:10:00',2.26),('8998','2013-10-16','12:15:00',2.26),('8998','2013-10-16','12:20:00',2.24),('8998','2013-10-16','12:25:00',2.22),('8998','2013-10-16','12:30:00',2.21),('8998','2013-10-16','12:35:00',2.18),('8998','2013-10-16','12:40:00',2.17),('8998','2013-10-16','12:45:00',2.17),('8998','2013-10-16','12:50:00',2.14),('8998','2013-10-16','12:55:00',2.12),('8998','2013-10-16','13:00:00',2.08),('8998','2013-10-16','13:05:00',2.05),('8998','2013-10-16','13:10:00',2.02),('8998','2013-10-16','13:15:00',2),('8998','2013-10-16','13:20:00',1.98),('8998','2013-10-16','13:25:00',1.94),('8998','2013-10-16','13:30:00',1.9),('8998','2013-10-16','13:35:00',1.86),('8998','2013-10-16','13:40:00',1.83),('8998','2013-10-16','13:45:00',1.8),('8998','2013-10-16','13:50:00',1.75),('8998','2013-10-16','13:55:00',1.73),('8998','2013-10-16','14:00:00',1.69),('8998','2013-10-16','14:05:00',1.64),('8998','2013-10-16','14:10:00',1.6),('8998','2013-10-16','14:15:00',1.56),('8998','2013-10-16','14:20:00',1.51),('8998','2013-10-16','14:25:00',1.46),('8998','2013-10-16','14:30:00',1.41),('8998','2013-10-16','14:35:00',1.27),('8998','2013-10-16','14:40:00',1.13),('8998','2013-10-16','14:45:00',1),('8998','2013-10-15','09:50:00',1.44),('8998','2013-10-15','11:15:00',1.09),('8998','2013-10-15','12:15:00',1.19),('8998','2013-10-15','12:20:00',2.05),('8998','2013-10-15','12:25:00',1.1),('8998','2013-10-15','12:40:00',2.35),('8998','2013-10-15','12:45:00',2.29),('8998','2013-10-15','12:50:00',2.15),('8998','2013-10-15','12:55:00',1.94),('8998','2013-10-15','13:00:00',1.66),('8998','2013-10-15','13:05:00',2.02),('8998','2013-10-15','13:10:00',2.06),('8998','2013-10-15','13:15:00',1.51),('8998','2013-10-15','13:20:00',1.49),('8998','2013-10-15','13:25:00',2.01),('8998','2013-10-15','13:30:00',1.72),('8998','2013-10-15','13:35:00',1.82),('8998','2013-10-15','13:40:00',1.91),('8998','2013-10-15','13:45:00',1.81),('8998','2013-10-15','13:50:00',1.76),('8998','2013-10-15','13:55:00',1.84),('8998','2013-10-15','14:00:00',1.56),('8998','2013-10-15','14:05:00',1.23),('8998','2013-10-15','14:10:00',1.61),('8998','2013-10-15','14:15:00',1.08),('8998','2013-10-15','14:20:00',1.57),('8998','2013-10-15','14:30:00',1.26),('8998','2013-10-15','14:35:00',1.11),('8998','2013-10-15','14:40:00',1.03),('8998','2013-10-15','14:45:00',1.29),('8998','2013-10-15','14:50:00',1.16),('8998','2013-10-15','15:00:00',1.06),('8998','2013-10-14','09:30:00',1.53),('8998','2013-10-14','09:40:00',1.33),('8998','2013-10-14','09:45:00',1.74),('8998','2013-10-14','09:50:00',1.93),('8998','2013-10-14','09:55:00',1.99),('8998','2013-10-14','10:00:00',1.93),('8998','2013-10-14','10:05:00',2.05),('8998','2013-10-14','10:10:00',1.6),('8998','2013-10-14','10:25:00',1.01),('8998','2013-10-14','10:30:00',1.57),('8998','2013-10-14','10:35:00',1.24),('8998','2013-10-14','10:40:00',1.51),('8998','2013-10-14','10:45:00',1.72),('8998','2013-10-14','10:50:00',1.69),('8998','2013-10-14','10:55:00',1.42),('8998','2013-10-14','11:00:00',1.41),('8998','2013-10-14','11:05:00',1.46),('8998','2013-10-14','11:10:00',1.97),('8998','2013-10-14','11:15:00',2.08),('8998','2013-10-14','11:20:00',2.12),('8998','2013-10-14','11:25:00',1.99),('8998','2013-10-14','11:30:00',2.02),('8998','2013-10-14','11:35:00',1.72),('8998','2013-10-14','11:40:00',1.35),('8998','2013-10-14','11:45:00',1.08),('8998','2013-10-14','11:50:00',1.04),('8998','2013-10-14','11:55:00',1.01),('8998','2013-10-14','12:00:00',1.04),('8998','2013-10-14','12:05:00',1.05),('8998','2013-10-14','12:10:00',1.08),('8998','2013-10-14','12:15:00',1.06),('8998','2013-10-14','12:20:00',1.1),('8998','2013-10-14','12:25:00',1.04),('8998','2013-10-14','13:10:00',1.19),('8998','2013-10-14','13:15:00',1.2),('8998','2013-10-14','13:20:00',1.61),('8998','2013-10-14','13:25:00',1.84),('8998','2013-10-14','13:30:00',1.19),('8998','2013-10-14','13:35:00',1.06),('8998','2013-10-14','13:40:00',1.02),('8998','2013-10-14','13:45:00',1.06),('8998','2013-10-14','14:15:00',1.08),('8998','2013-10-14','14:20:00',1.25),('8998','2013-10-14','14:25:00',1.3),('8998','2013-10-14','14:30:00',1.25),('8998','2013-10-14','14:40:00',1.04),('8998','2013-10-14','14:45:00',1.11),('8998','2013-10-14','14:50:00',1.18),('8998','2013-10-14','14:55:00',1.08),('8998','2013-10-13','08:55:00',1.29),('8998','2013-10-13','09:00:00',1.15),('8998','2013-10-13','09:05:00',1.17),('8998','2013-10-13','09:10:00',1.1),('8998','2013-10-13','09:20:00',1.06),('8998','2013-10-13','09:25:00',1.65),('8998','2013-10-13','09:30:00',1.78),('8998','2013-10-13','09:35:00',1.71),('8998','2013-10-13','09:40:00',1.41),('8998','2013-10-13','09:45:00',1.3),('8998','2013-10-13','09:50:00',1.53),('8998','2013-10-13','09:55:00',1.8),('8998','2013-10-13','10:00:00',1.72),('8998','2013-10-13','10:05:00',1.88),('8998','2013-10-13','10:10:00',1.95),('8998','2013-10-13','10:15:00',2.04),('8998','2013-10-13','10:20:00',2.05),('8998','2013-10-13','10:25:00',2.06),('8998','2013-10-13','10:30:00',2.07),('8998','2013-10-13','10:35:00',2.07),('8998','2013-10-13','10:40:00',2.02),('8998','2013-10-13','10:45:00',2.06),('8998','2013-10-13','10:50:00',2.13),('8998','2013-10-13','10:55:00',2.13),('8998','2013-10-13','11:00:00',2.17),('8998','2013-10-13','11:05:00',2.13),('8998','2013-10-13','11:10:00',2.2),('8998','2013-10-13','11:15:00',2.19),('8998','2013-10-13','11:20:00',2.17),('8998','2013-10-13','11:25:00',2.21),('8998','2013-10-13','11:30:00',2.24),('8998','2013-10-13','11:35:00',2.18),('8998','2013-10-13','11:40:00',2.18),('8998','2013-10-13','11:45:00',2.13),('8998','2013-10-13','11:50:00',2.14),('8998','2013-10-13','11:55:00',2.14),('8998','2013-10-13','12:00:00',2.13),('8998','2013-10-13','12:05:00',2.13),('8998','2013-10-13','12:10:00',2.14),('8998','2013-10-13','12:15:00',2.1),('8998','2013-10-13','12:20:00',1.94),('8998','2013-10-13','12:25:00',2.01),('8998','2013-10-13','12:30:00',2.13),('8998','2013-10-13','12:35:00',2.09),('8998','2013-10-13','12:40:00',2.07),('8998','2013-10-13','12:45:00',2.04),('8998','2013-10-13','12:50:00',2.01),('8998','2013-10-13','12:55:00',2),('8998','2013-10-13','13:00:00',1.98),('8998','2013-10-13','13:05:00',1.96),('8998','2013-10-13','13:10:00',1.94),('8998','2013-10-13','13:15:00',1.91),('8998','2013-10-13','13:20:00',1.88),('8998','2013-10-13','13:25:00',1.85),('8998','2013-10-13','13:30:00',1.82),('8998','2013-10-13','13:35:00',1.78),('8998','2013-10-13','13:40:00',1.75),('8998','2013-10-13','13:45:00',1.72),('8998','2013-10-13','13:50:00',1.69),('8998','2013-10-13','13:55:00',1.65),('8998','2013-10-13','14:00:00',1.61),('8998','2013-10-13','14:05:00',1.58),('8998','2013-10-13','14:10:00',1.54),('8998','2013-10-13','14:15:00',1.5),('8998','2013-10-13','14:20:00',1.46),('8998','2013-10-13','14:25:00',1.42),('8998','2013-10-13','14:30:00',1.38),('8998','2013-10-13','14:35:00',1.32),('8998','2013-10-13','14:40:00',1.17),('8998','2013-10-13','14:45:00',1.03),('8998','2013-10-12','09:15:00',1.59),('8998','2013-10-12','09:20:00',1.77),('8998','2013-10-12','09:25:00',1.64),('8998','2013-10-12','09:30:00',1.09),('8998','2013-10-12','09:35:00',1.24),('8998','2013-10-12','09:40:00',1.65),('8998','2013-10-12','09:45:00',2.35),('8998','2013-10-12','09:50:00',2.25),('8998','2013-10-12','09:55:00',2.31),('8998','2013-10-12','10:00:00',1.85),('8998','2013-10-12','10:05:00',1.24),('8998','2013-10-12','10:10:00',1.55),('8998','2013-10-12','10:15:00',1.87),('8998','2013-10-12','10:20:00',1.54),('8998','2013-10-12','10:25:00',1.64),('8998','2013-10-12','10:30:00',2.11),('8998','2013-10-12','10:35:00',2.5),('8998','2013-10-12','10:40:00',2.56),('8998','2013-10-12','10:45:00',2.58),('8998','2013-10-12','10:50:00',2.35),('8998','2013-10-12','10:55:00',1.65),('8998','2013-10-12','11:00:00',2.14),('8998','2013-10-12','11:05:00',2.29),('8998','2013-10-12','11:10:00',2.38),('8998','2013-10-12','11:15:00',2.44),('8998','2013-10-12','11:20:00',2.31),('8998','2013-10-12','11:25:00',2.24),('8998','2013-10-12','11:30:00',2.27),('8998','2013-10-12','11:35:00',2.25),('8998','2013-10-12','11:40:00',2.23),('8998','2013-10-12','11:45:00',2.21),('8998','2013-10-12','11:50:00',2.21),('8998','2013-10-12','11:55:00',2.19),('8998','2013-10-12','12:00:00',2.2),('8998','2013-10-12','12:05:00',2.19),('8998','2013-10-12','12:10:00',2.18),('8998','2013-10-12','12:15:00',2.18),('8998','2013-10-12','12:20:00',2.15),('8998','2013-10-12','12:25:00',2.04),('8998','2013-10-12','12:30:00',2.13),('8998','2013-10-12','12:35:00',2.14),('8998','2013-10-12','12:40:00',2.12),('8998','2013-10-12','12:45:00',2.06),('8998','2013-10-12','12:50:00',2.02),('8998','2013-10-12','12:55:00',2.02),('8998','2013-10-12','13:00:00',2),('8998','2013-10-12','13:05:00',1.97),('8998','2013-10-12','13:10:00',1.97),('8998','2013-10-12','13:15:00',1.98),('8998','2013-10-12','13:20:00',1.96),('8998','2013-10-12','13:25:00',1.74),('8998','2013-10-12','13:30:00',1.37),('8998','2013-10-12','13:35:00',1.72),('8998','2013-10-12','13:40:00',1.07),('8998','2013-10-12','13:45:00',1.15),('8998','2013-10-12','13:50:00',1.22),('8998','2013-10-12','13:55:00',1.34),('8998','2013-10-12','14:00:00',1.68),('8998','2013-10-12','14:05:00',1.73),('8998','2013-10-12','14:10:00',1.69),('8998','2013-10-12','14:15:00',1.54),('8998','2013-10-12','14:20:00',1.63),('8998','2013-10-12','14:25:00',1.6),('8998','2013-10-12','14:30:00',1.47),('8998','2013-10-12','14:35:00',1.08),('8998','2013-10-12','14:40:00',1.26),('8998','2013-10-12','14:45:00',1.04),('8998','2013-10-12','15:00:00',1.14),('8998','2013-10-12','15:05:00',1.14),('8998','2013-10-11','11:35:00',1.24),('8998','2013-10-11','11:40:00',2.19),('8998','2013-10-11','11:45:00',1.25),('8998','2013-10-11','11:50:00',1.08),('8998','2013-10-11','12:20:00',1.16),('8998','2013-10-11','12:25:00',2.46),('8998','2013-10-11','12:30:00',1.82),('8998','2013-10-11','12:35:00',2.18),('8998','2013-10-11','12:40:00',2.1),('8998','2013-10-11','12:45:00',1.86),('8998','2013-10-11','12:50:00',2.01),('8998','2013-10-11','12:55:00',1.65),('8998','2013-10-11','13:00:00',1.22),('8998','2013-10-11','13:30:00',2.13),('8998','2013-10-11','13:35:00',1.24),('8998','2013-10-10','09:25:00',1.05),('8998','2013-10-10','09:35:00',1.18),('8998','2013-10-10','09:45:00',2.09),('8998','2013-10-10','09:50:00',2.09),('8998','2013-10-10','09:55:00',2.09),('8998','2013-10-10','10:00:00',2.1),('8998','2013-10-10','10:05:00',2.14),('8998','2013-10-10','10:10:00',2.17),('8998','2013-10-10','10:15:00',1.89),('8998','2013-10-10','10:20:00',1.92),('8998','2013-10-10','10:25:00',1.4),('8998','2013-10-10','10:30:00',1.79),('8998','2013-10-10','10:35:00',2.52),('8998','2013-10-10','10:40:00',1.25),('8998','2013-10-10','11:05:00',1.87),('8998','2013-10-10','11:10:00',2.15),('8998','2013-10-10','11:40:00',1.37),('8998','2013-10-10','11:45:00',1.26),('8998','2013-10-10','11:50:00',1.47),('8998','2013-10-10','11:55:00',1.29),('8998','2013-10-10','12:00:00',1.74),('8998','2013-10-10','12:05:00',3),('8998','2013-10-10','12:10:00',1.4),('8998','2013-10-10','12:30:00',1.26),('8998','2013-10-10','13:05:00',1.79),('8998','2013-10-10','13:10:00',1.18),('8998','2013-10-10','13:20:00',1.23),('8998','2013-10-10','13:25:00',2.3),('8998','2013-10-10','13:30:00',1.09),('8998','2013-10-10','13:40:00',1.66),('8998','2013-10-10','13:45:00',2.23),('8998','2013-10-09','09:10:00',1.58),('8998','2013-10-09','09:15:00',1.77),('8998','2013-10-09','09:20:00',1.82),('8998','2013-10-09','09:25:00',1.77),('8998','2013-10-09','09:30:00',1.77),('8998','2013-10-09','09:35:00',1.53),('8998','2013-10-09','09:40:00',1.58),('8998','2013-10-09','09:45:00',1.47),('8998','2013-10-09','10:15:00',1.66),('8998','2013-10-09','10:20:00',2.19),('8998','2013-10-09','10:25:00',2.12),('8998','2013-10-09','10:30:00',2.15),('8998','2013-10-09','10:45:00',1.36),('8998','2013-10-09','11:25:00',2.41),('8998','2013-10-09','11:30:00',1.73),('8998','2013-10-09','11:45:00',1.07),('8998','2013-10-09','11:50:00',1.02),('8998','2013-10-09','11:55:00',2.3),('8998','2013-10-09','12:00:00',2.47),('8998','2013-10-09','12:05:00',1.75),('8998','2013-10-09','12:10:00',1.01),('8998','2013-10-09','12:25:00',2.04),('8998','2013-10-09','12:30:00',1.14),('8998','2013-10-09','12:35:00',2.4),('8998','2013-10-09','12:40:00',2.72),('8998','2013-10-09','12:45:00',2),('8998','2013-10-09','12:50:00',1.73),('8998','2013-10-09','13:00:00',1.8),('8998','2013-10-09','13:05:00',2.44),('8998','2013-10-09','13:10:00',1.53),('8998','2013-10-09','13:25:00',1.64),('8998','2013-10-09','13:30:00',1.52),('8998','2013-10-09','13:35:00',1.44),('8998','2013-10-09','13:40:00',1.25),('8998','2013-10-09','13:45:00',2.06),('8998','2013-10-09','13:50:00',2.06),('8998','2013-10-09','13:55:00',1.99),('8998','2013-10-09','14:00:00',1.89),('8998','2013-10-09','14:05:00',1.36),('8998','2013-10-09','14:10:00',1.19),('8998','2013-10-09','14:15:00',1),('8998','2013-10-09','14:20:00',1.85),('8998','2013-10-09','14:25:00',1.74),('8998','2013-10-09','14:30:00',1.38),('8998','2013-10-09','14:35:00',1.1),('8998','2013-10-09','14:40:00',1.73),('8998','2013-10-09','14:45:00',1.4),('8998','2013-10-09','14:50:00',1.39),('8998','2013-10-09','14:55:00',1.34),('8998','2013-10-09','15:00:00',1.2),('8998','2013-10-09','15:05:00',1.3),('8998','2013-10-09','15:10:00',1.14),('8998','2013-10-09','15:15:00',1.09),('8998','2013-10-08','08:40:00',1.04),('8998','2013-10-08','08:45:00',1.2),('8998','2013-10-08','08:50:00',1.52),('8998','2013-10-08','08:55:00',1.58),('8998','2013-10-08','09:00:00',1.64),('8998','2013-10-08','09:05:00',1.7),('8998','2013-10-08','09:10:00',1.76),('8998','2013-10-08','09:15:00',1.7),('8998','2013-10-08','09:20:00',1.57),('8998','2013-10-08','09:25:00',1.9),('8998','2013-10-08','09:30:00',1.92),('8998','2013-10-08','09:35:00',1.95),('8998','2013-10-08','09:40:00',2.01),('8998','2013-10-08','09:45:00',2.07),('8998','2013-10-08','09:50:00',2.09),('8998','2013-10-08','09:55:00',2.16),('8998','2013-10-08','10:00:00',2.25),('8998','2013-10-08','10:05:00',2.24),('8998','2013-10-08','10:10:00',2.38),('8998','2013-10-08','10:15:00',1.1),('8998','2013-10-08','10:30:00',1.12),('8998','2013-10-08','10:35:00',1.45),('8998','2013-10-08','10:40:00',1.22),('8998','2013-10-08','10:45:00',1.5),('8998','2013-10-08','10:50:00',2.95),('8998','2013-10-08','10:55:00',1.3),('8998','2013-10-08','11:00:00',2.12),('8998','2013-10-08','11:05:00',2.42),('8998','2013-10-08','11:10:00',2.99),('8998','2013-10-08','11:15:00',2.92),('8998','2013-10-08','11:20:00',2.65),('8998','2013-10-08','11:25:00',2.22),('8998','2013-10-08','11:30:00',2.77),('8998','2013-10-08','11:35:00',2.92),('8998','2013-10-08','11:40:00',2.31),('8998','2013-10-08','11:45:00',2.01),('8998','2013-10-08','11:50:00',2.3),('8998','2013-10-08','11:55:00',2.5),('8998','2013-10-08','12:00:00',1.94),('8998','2013-10-08','12:10:00',1.58),('8998','2013-10-08','12:15:00',1.39),('8998','2013-10-08','12:20:00',2.22),('8998','2013-10-08','12:25:00',2.42),('8998','2013-10-08','12:30:00',1.13),('8998','2013-10-08','12:40:00',1.01),('8998','2013-10-08','13:15:00',1.04),('8998','2013-10-08','13:20:00',1.31),('8998','2013-10-08','13:25:00',1.48),('8998','2013-10-08','13:30:00',1.33),('8998','2013-10-08','13:35:00',1.4),('8998','2013-10-08','13:40:00',2.1),('8998','2013-10-08','13:45:00',1.8),('8998','2013-10-08','13:50:00',1.76),('8998','2013-10-08','13:55:00',2.44),('8998','2013-10-08','14:00:00',2.23),('8998','2013-10-08','14:10:00',1.29),('8998','2013-10-08','14:55:00',1.23),('8998','2013-10-08','15:05:00',1.26),('8998','2013-10-08','15:10:00',1.3),('8998','2013-10-08','15:15:00',1.16),('8998','2014-04-14','09:00:00',1.52),('8998','2014-04-14','09:05:00',1.92),('8998','2014-04-14','09:10:00',1.24),('8998','2014-04-14','09:15:00',1.81),('8998','2014-04-14','09:20:00',1.45),('8998','2014-04-14','09:25:00',2.12),('8998','2014-04-14','09:30:00',1.8),('8998','2014-04-14','09:50:00',2.61),('8998','2014-04-14','10:10:00',1.02),('8998','2014-04-14','10:15:00',1.7),('8998','2014-04-14','10:20:00',1.22),('8998','2014-04-14','10:25:00',1.02),('8998','2014-04-14','10:30:00',1.59),('8998','2014-04-14','10:35:00',2.67),('8998','2014-04-14','10:40:00',1.5),('8998','2014-04-14','10:45:00',2.29),('8998','2014-04-14','10:50:00',1.9),('8998','2014-04-14','10:55:00',1.2),('8998','2014-04-14','11:00:00',1.03),('8998','2014-04-14','11:05:00',2.54),('8998','2014-04-14','11:10:00',2.46),('8998','2014-04-14','11:15:00',1.17),('8998','2014-04-14','11:25:00',1.06),('8998','2014-04-14','11:50:00',1.01),('8998','2014-04-14','12:15:00',1.21),('8998','2014-04-14','12:20:00',1.45),('8998','2014-04-14','13:10:00',1.14),('8998','2014-04-14','13:15:00',1.15),('8998','2014-04-14','13:20:00',1.95),('8998','2014-04-14','13:25:00',1.27),('8998','2014-04-14','13:30:00',2.21),('8998','2014-04-14','13:35:00',1.9),('8998','2014-04-14','13:40:00',1.91),('8998','2014-04-14','13:45:00',1.02),('8998','2014-04-14','14:00:00',1.46),('8998','2014-04-14','14:05:00',1.83),('8998','2014-04-14','14:10:00',1.12),('8998','2014-04-14','14:15:00',2.16),('8998','2014-04-14','14:20:00',2.09),('8998','2014-04-14','14:25:00',2.19),('8998','2014-04-14','14:30:00',1.51),('8998','2014-04-14','14:35:00',1.45),('8998','2014-04-14','14:40:00',1.01),('8998','2014-04-14','15:20:00',1.1),('8998','2014-04-14','15:25:00',1.43),('8998','2014-04-14','15:30:00',1.05),('8998','2013-10-07','11:00:00',1.23),('8998','2013-10-07','11:05:00',1.03),('8998','2013-10-07','11:10:00',2.05),('8998','2013-10-07','11:15:00',3.03),('8998','2013-10-07','11:20:00',2.7),('8998','2013-10-07','11:25:00',1.41),('8998','2013-10-07','11:30:00',2.2),('8998','2013-10-07','11:35:00',1.87),('8998','2013-10-07','11:40:00',1.19),('8998','2013-10-07','11:45:00',1.15),('8998','2013-10-07','12:30:00',2.47),('8998','2013-10-07','12:35:00',1.39),('8998','2013-10-07','12:40:00',3.05),('8998','2013-10-07','12:45:00',2.63),('8998','2013-10-07','12:50:00',2.6),('8998','2013-10-07','12:55:00',2.55),('8998','2013-10-07','13:00:00',2.23),('8998','2013-10-07','13:05:00',2.26),('8998','2013-10-07','13:10:00',1.52),('8998','2013-10-07','13:15:00',2.33),('8998','2013-10-07','13:20:00',1.23),('8998','2013-10-07','13:25:00',1.96),('8998','2013-10-07','13:30:00',1.29),('8998','2013-10-07','14:10:00',1.32),('8998','2013-10-07','14:15:00',1.32),('8998','2013-10-07','14:20:00',1.58),('8998','2013-10-07','14:25:00',1.58),('8998','2013-10-07','14:30:00',1.65),('8998','2013-10-07','14:45:00',1.53),('8998','2013-10-07','14:50:00',1.51),('8998','2013-10-07','14:55:00',1.35),('8998','2013-10-07','15:00:00',1.27),('8998','2013-10-07','15:05:00',1.24),('8998','2013-10-07','15:10:00',1.21),('8998','2013-10-07','15:15:00',1.04),('8998','2013-10-07','15:30:00',1.22),('8998','2013-10-07','15:35:00',1.03),('8998','2013-10-06','08:40:00',1.18),('8998','2013-10-06','09:10:00',1.71),('8998','2013-10-06','09:15:00',1.79),('8998','2013-10-06','09:20:00',1.84),('8998','2013-10-06','09:25:00',1.9),('8998','2013-10-06','09:30:00',1.41),('8998','2013-10-06','09:35:00',1.97),('8998','2013-10-06','09:40:00',2.02),('8998','2013-10-06','09:45:00',2.06),('8998','2013-10-06','09:50:00',1.52),('8998','2013-10-06','09:55:00',2.03),('8998','2013-10-06','10:00:00',2.13),('8998','2013-10-06','10:05:00',2.17),('8998','2013-10-06','10:10:00',2.18),('8998','2013-10-06','10:15:00',1.57),('8998','2013-10-06','10:20:00',2.23),('8998','2013-10-06','10:25:00',2.25),('8998','2013-10-06','10:30:00',2.3),('8998','2013-10-06','10:35:00',1.65),('8998','2013-10-06','10:40:00',2.28),('8998','2013-10-06','10:45:00',2.39),('8998','2013-10-06','10:50:00',2.41),('8998','2013-10-06','10:55:00',2.11),('8998','2013-10-06','11:00:00',2.19),('8998','2013-10-06','11:05:00',2.4),('8998','2013-10-06','11:10:00',1.93),('8998','2013-10-06','11:15:00',2.23),('8998','2013-10-06','11:20:00',2.47),('8998','2013-10-06','11:25:00',2.45),('8998','2013-10-06','11:30:00',2.42),('8998','2013-10-06','11:35:00',2.42),('8998','2013-10-06','11:40:00',2.42),('8998','2013-10-06','11:45:00',2.4),('8998','2013-10-06','11:50:00',2.38),('8998','2013-10-06','11:55:00',2.42),('8998','2013-10-06','12:00:00',2.36),('8998','2013-10-06','12:05:00',2.04),('8998','2013-10-06','12:10:00',2.57),('8998','2013-10-06','12:15:00',1.85),('8998','2013-10-06','12:20:00',1.96),('8998','2013-10-06','12:25:00',2.36),('8998','2013-10-06','12:30:00',2.6),('8998','2013-10-06','12:35:00',2.43),('8998','2013-10-06','12:40:00',2.47),('8998','2013-10-06','12:45:00',2.45),('8998','2013-10-06','12:50:00',2.41),('8998','2013-10-06','12:55:00',2.45),('8998','2013-10-06','13:00:00',2.1),('8998','2013-10-06','13:05:00',2.33),('8998','2013-10-06','13:10:00',2.31),('8998','2013-10-06','13:15:00',1.34),('8998','2013-10-06','13:20:00',2.07),('8998','2013-10-06','13:25:00',2.06),('8998','2013-10-06','13:30:00',2.25),('8998','2013-10-06','13:40:00',1.15),('8998','2013-10-06','13:45:00',1.18),('8998','2013-10-06','13:50:00',1.56),('8998','2013-10-06','13:55:00',2.4),('8998','2013-10-06','14:00:00',2.51),('8998','2013-10-06','14:05:00',1.42),('8998','2013-10-06','14:10:00',1.01),('8998','2013-10-06','14:25:00',1.63),('8998','2013-10-06','14:35:00',1.11),('8998','2013-10-06','14:40:00',1.18),('8998','2013-10-06','14:45:00',1.57),('8998','2013-10-06','14:50:00',1.74),('8998','2013-10-06','14:55:00',1.71),('8998','2013-10-06','15:00:00',1.06),('8998','2013-10-06','15:10:00',1.15),('8998','2013-10-05','09:35:00',1.39),('8998','2013-10-05','09:40:00',1.23),('8998','2013-10-05','09:50:00',1.79),('8998','2013-10-05','09:55:00',2.11),('8998','2013-10-05','10:00:00',2.45),('8998','2013-10-05','10:05:00',2.47),('8998','2013-10-05','10:10:00',2.38),('8998','2013-10-05','10:15:00',2.19),('8998','2013-10-05','10:20:00',2.18),('8998','2013-10-05','10:25:00',2.42),('8998','2013-10-05','10:30:00',2.33),('8998','2013-10-05','10:35:00',2.29),('8998','2013-10-05','10:40:00',1.92),('8998','2013-10-05','10:45:00',1.55),('8998','2013-10-05','10:50:00',1.71),('8998','2013-10-05','10:55:00',1.89),('8998','2013-10-05','11:00:00',1.92),('8998','2013-10-05','11:05:00',2.11),('8998','2013-10-05','11:10:00',2.19),('8998','2013-10-05','11:15:00',2.08),('8998','2013-10-05','11:20:00',2.07),('8998','2013-10-05','11:25:00',2.2),('8998','2013-10-05','11:30:00',2.1),('8998','2013-10-05','11:35:00',2.06),('8998','2013-10-05','11:40:00',1.78),('8998','2013-10-05','11:45:00',1.38),('8998','2013-10-05','11:50:00',1.44),('8998','2013-10-05','11:55:00',1.86),('8998','2013-10-05','12:00:00',1.9),('8998','2013-10-05','12:05:00',1.89),('8998','2013-10-05','12:10:00',2.35),('8998','2013-10-05','12:15:00',2.24),('8998','2013-10-05','12:20:00',1.9),('8998','2013-10-05','12:25:00',1.63),('8998','2013-10-05','12:30:00',1.76),('8998','2013-10-05','12:35:00',1.81),('8998','2013-10-05','12:40:00',1.51),('8998','2013-10-05','12:45:00',1.47),('8998','2013-10-05','12:50:00',1.77),('8998','2013-10-05','12:55:00',2.11),('8998','2013-10-05','13:00:00',2.16),('8998','2013-10-05','13:05:00',2.05),('8998','2013-10-05','13:10:00',1.53),('8998','2013-10-05','13:20:00',2.08),('8998','2013-10-05','13:50:00',2.02),('8998','2013-10-05','13:55:00',1.36),('8998','2013-10-05','14:00:00',1.08),('8998','2013-10-05','14:05:00',2.07),('8998','2013-10-05','14:10:00',2.17),('8998','2013-10-05','14:15:00',1.42),('8998','2013-10-05','14:20:00',1.2),('8998','2013-10-05','14:25:00',1.05),('8998','2013-10-05','14:30:00',1.02),('8998','2013-10-05','14:50:00',1.09),('8998','2013-10-05','14:55:00',1.38),('8998','2013-10-05','15:00:00',1.22),('8998','2013-10-03','09:55:00',2.28),('8998','2013-10-03','10:00:00',1.7),('8998','2013-10-03','10:05:00',1.24),('8998','2013-10-03','10:10:00',1.19),('8998','2013-10-03','10:15:00',1.47),('8998','2013-10-03','10:20:00',1.1),('8998','2013-10-03','10:25:00',1.75),('8998','2013-10-03','10:30:00',1.57),('8998','2013-10-03','10:35:00',1.21),('8998','2013-10-03','10:40:00',2.19),('8998','2013-10-03','10:45:00',1.86),('8998','2013-10-03','10:50:00',1.33),('8998','2013-10-03','10:55:00',2.13),('8998','2013-10-03','11:00:00',1.87),('8998','2013-10-03','11:05:00',1.28),('8998','2013-10-03','11:10:00',1.22),('8998','2013-10-03','11:15:00',2.61),('8998','2013-10-03','11:20:00',2.2),('8998','2013-10-03','11:25:00',2.3),('8998','2013-10-03','11:30:00',2.8),('8998','2013-10-03','11:35:00',2.73),('8998','2013-10-03','11:40:00',2.67),('8998','2013-10-03','11:45:00',2.61),('8998','2013-10-03','11:50:00',2.56),('8998','2013-10-03','11:55:00',2.54),('8998','2013-10-03','12:00:00',2.53),('8998','2013-10-03','12:05:00',2.52),('8998','2013-10-03','12:10:00',2.53),('8998','2013-10-03','12:15:00',2.27),('8998','2013-10-03','12:20:00',2.38),('8998','2013-10-03','12:25:00',2.51),('8998','2013-10-03','12:30:00',2.33),('8998','2013-10-03','12:35:00',2.18),('8998','2013-10-03','12:40:00',2.4),('8998','2013-10-03','12:45:00',2.39),('8998','2013-10-03','12:50:00',2.28),('8998','2013-10-03','12:55:00',2.28),('8998','2013-10-03','13:00:00',2.27),('8998','2013-10-03','13:05:00',2.29),('8998','2013-10-03','13:10:00',2.31),('8998','2013-10-03','13:15:00',2.48),('8998','2013-10-03','13:20:00',2.34),('8998','2013-10-03','13:25:00',2.14),('8998','2013-10-03','13:30:00',2.24),('8998','2013-10-03','13:35:00',1.59),('8998','2013-10-03','13:40:00',2.07),('8998','2013-10-03','13:45:00',1.99),('8998','2013-10-03','13:50:00',1.94),('8998','2013-10-03','13:55:00',1.91),('8998','2013-10-03','14:00:00',1.88),('8998','2013-10-03','14:05:00',1.84),('8998','2013-10-03','14:10:00',1.67),('8998','2013-10-03','14:15:00',1.49),('8998','2013-10-03','14:20:00',1.53),('8998','2013-10-03','14:25:00',1.67),('8998','2013-10-03','14:30:00',1.44),('8998','2013-10-03','14:35:00',1.05),('8998','2013-10-03','14:50:00',1.26),('8998','2013-10-03','14:55:00',1.24),('8998','2013-10-03','15:00:00',1.06),('8998','2013-10-03','15:05:00',1.13),('8998','2013-10-03','15:25:00',1),('8998','2013-10-03','15:30:00',1.03),('8998','2013-10-02','08:40:00',1.52),('8998','2013-10-02','08:45:00',1.63),('8998','2013-10-02','08:50:00',1.71),('8998','2013-10-02','08:55:00',1.78),('8998','2013-10-02','09:00:00',1.84),('8998','2013-10-02','09:05:00',1.89),('8998','2013-10-02','09:10:00',1.94),('8998','2013-10-02','09:15:00',1.99),('8998','2013-10-02','09:20:00',2.05),('8998','2013-10-02','09:25:00',2.13),('8998','2013-10-02','09:30:00',2.17),('8998','2013-10-02','09:35:00',2.21),('8998','2013-10-02','09:40:00',2.25),('8998','2013-10-02','09:45:00',2.3),('8998','2013-10-02','09:50:00',2.33),('8998','2013-10-02','09:55:00',2.36),('8998','2013-10-02','10:00:00',2.4),('8998','2013-10-02','10:05:00',2.44),('8998','2013-10-02','10:10:00',2.46),('8998','2013-10-02','10:15:00',2.5),('8998','2013-10-02','10:20:00',2.52),('8998','2013-10-02','10:25:00',2.54),('8998','2013-10-02','10:30:00',2.56),('8998','2013-10-02','10:35:00',2.58),('8998','2013-10-02','10:40:00',2.59),('8998','2013-10-02','10:45:00',2.62),('8998','2013-10-02','10:50:00',2.62),('8998','2013-10-02','10:55:00',2.64),('8998','2013-10-02','11:00:00',2.64),('8998','2013-10-02','11:05:00',2.64),('8998','2013-10-02','11:10:00',2.65),('8998','2013-10-02','11:15:00',2.66),('8998','2013-10-02','11:20:00',2.67),('8998','2013-10-02','11:25:00',2.67),('8998','2013-10-02','11:30:00',2.66),('8998','2013-10-02','11:35:00',2.68),('8998','2013-10-02','11:40:00',2.68),('8998','2013-10-02','11:45:00',2.67),('8998','2013-10-02','11:50:00',2.68),('8998','2013-10-02','11:55:00',2.68),('8998','2013-10-02','12:00:00',2.66),('8998','2013-10-02','12:05:00',2.65),('8998','2013-10-02','12:10:00',2.63),('8998','2013-10-02','12:15:00',2.6),('8998','2013-10-02','12:20:00',2.57),('8998','2013-10-02','12:25:00',2.57),('8998','2013-10-02','12:30:00',2.57),('8998','2013-10-02','12:35:00',2.55),('8998','2013-10-02','12:40:00',2.53),('8998','2013-10-02','12:45:00',2.5),('8998','2013-10-02','12:50:00',2.48),('8998','2013-10-02','12:55:00',2.46),('8998','2013-10-02','13:00:00',2.42),('8998','2013-10-02','13:05:00',2.37),('8998','2013-10-02','13:10:00',2.36),('8998','2013-10-02','13:15:00',2.33),('8998','2013-10-02','13:20:00',2.3),('8998','2013-10-02','13:25:00',2.26),('8998','2013-10-02','13:30:00',2.24),('8998','2013-10-02','13:35:00',2.21),('8998','2013-10-02','13:40:00',2.18),('8998','2013-10-02','13:45:00',2.13),('8998','2013-10-02','13:50:00',2.09),('8998','2013-10-02','13:55:00',2.06),('8998','2013-10-02','14:00:00',2.03),('8998','2013-10-02','14:05:00',1.99),('8998','2013-10-02','14:10:00',1.94),('8998','2013-10-02','14:15:00',1.89),('8998','2013-10-02','14:20:00',1.85),('8998','2013-10-02','14:25:00',1.8),('8998','2013-10-02','14:30:00',1.75),('8998','2013-10-02','14:35:00',1.7),('8998','2013-10-02','14:40:00',1.65),('8998','2013-10-02','14:45:00',1.59),('8998','2013-10-02','14:50:00',1.52),('8998','2013-10-02','14:55:00',1.45),('8998','2013-10-02','15:00:00',1.4),('8998','2013-10-02','15:05:00',1.32),('8998','2013-10-02','15:10:00',1.24),('8998','2013-10-02','15:15:00',1.18),('8998','2013-10-02','15:20:00',1.11),('8998','2013-10-02','15:25:00',1),('8998','2013-10-01','08:35:00',1.08),('8998','2013-10-01','08:40:00',1.4),('8998','2013-10-01','08:45:00',1.49),('8998','2013-10-01','08:50:00',1.59),('8998','2013-10-01','08:55:00',1.67),('8998','2013-10-01','09:00:00',1.73),('8998','2013-10-01','09:05:00',1.77),('8998','2013-10-01','09:10:00',1.83),('8998','2013-10-01','09:15:00',1.88),('8998','2013-10-01','09:20:00',1.94),('8998','2013-10-01','09:25:00',2.01),('8998','2013-10-01','09:30:00',2.05),('8998','2013-10-01','09:35:00',2.1),('8998','2013-10-01','09:40:00',2.13),('8998','2013-10-01','09:45:00',2.16),('8998','2013-10-01','09:50:00',2.19),('8998','2013-10-01','09:55:00',2.22),('8998','2013-10-01','10:00:00',2.24),('8998','2013-10-01','10:05:00',2.27),('8998','2013-10-01','10:10:00',2.29),('8998','2013-10-01','10:15:00',2.31),('8998','2013-10-01','10:20:00',2.35),('8998','2013-10-01','10:25:00',2.38),('8998','2013-10-01','10:30:00',2.4),('8998','2013-10-01','10:35:00',2.43),('8998','2013-10-01','10:40:00',2.47),('8998','2013-10-01','10:45:00',2.49),('8998','2013-10-01','10:50:00',2.51),('8998','2013-10-01','10:55:00',2.52),('8998','2013-10-01','11:00:00',2.54),('8998','2013-10-01','11:05:00',2.55),('8998','2013-10-01','11:10:00',2.56),('8998','2013-10-01','11:15:00',2.57),('8998','2013-10-01','11:20:00',2.58),('8998','2013-10-01','11:25:00',2.57),('8998','2013-10-01','11:30:00',2.57),('8998','2013-10-01','11:35:00',2.57),('8998','2013-10-01','11:40:00',2.58),('8998','2013-10-01','11:45:00',2.58),('8998','2013-10-01','11:50:00',2.58),('8998','2013-10-01','11:55:00',2.56),('8998','2013-10-01','12:00:00',2.56),('8998','2013-10-01','12:05:00',2.54),('8998','2013-10-01','12:10:00',2.54),('8998','2013-10-01','12:15:00',2.53),('8998','2013-10-01','12:20:00',2.51),('8998','2013-10-01','12:25:00',2.49),('8998','2013-10-01','12:30:00',2.47),('8998','2013-10-01','12:35:00',2.46),('8998','2013-10-01','12:40:00',2.43),('8998','2013-10-01','12:45:00',2.42),('8998','2013-10-01','12:50:00',2.41),('8998','2013-10-01','12:55:00',2.38),('8998','2013-10-01','13:00:00',2.36),('8998','2013-10-01','13:05:00',2.34),('8998','2013-10-01','13:10:00',2.31),('8998','2013-10-01','13:15:00',2.28),('8998','2013-10-01','13:20:00',2.25),('8998','2013-10-01','13:25:00',2.23),('8998','2013-10-01','13:30:00',2.2),('8998','2013-10-01','13:35:00',2.16),('8998','2013-10-01','13:40:00',2.13),('8998','2013-10-01','13:45:00',2.1),('8998','2013-10-01','13:50:00',2.06),('8998','2013-10-01','13:55:00',2.01),('8998','2013-10-01','14:00:00',1.98),('8998','2013-10-01','14:05:00',1.93),('8998','2013-10-01','14:10:00',1.89),('8998','2013-10-01','14:15:00',1.85),('8998','2013-10-01','14:20:00',1.8),('8998','2013-10-01','14:25:00',1.76),('8998','2013-10-01','14:30:00',1.71),('8998','2013-10-01','14:35:00',1.67),('8998','2013-10-01','14:40:00',1.61),('8998','2013-10-01','14:45:00',1.56),('8998','2013-10-01','14:50:00',1.5),('8998','2013-10-01','14:55:00',1.43),('8998','2013-10-01','15:00:00',1.38),('8998','2013-10-01','15:05:00',1.33),('8998','2013-10-01','15:10:00',1.24),('8998','2013-10-01','15:15:00',1.17),('8998','2013-10-01','15:20:00',1.11),('8998','2013-10-01','15:25:00',1),('8998','2013-09-30','08:40:00',1.25),('8998','2013-09-30','08:45:00',1.56),('8998','2013-09-30','08:50:00',1.63),('8998','2013-09-30','08:55:00',1.7),('8998','2013-09-30','09:00:00',1.74),('8998','2013-09-30','09:05:00',1.78),('8998','2013-09-30','09:10:00',1.81),('8998','2013-09-30','09:15:00',1.85),('8998','2013-09-30','09:20:00',1.9),('8998','2013-09-30','09:25:00',1.96),('8998','2013-09-30','09:30:00',2),('8998','2013-09-30','09:35:00',2.02),('8998','2013-09-30','09:40:00',2.05),('8998','2013-09-30','09:45:00',2.09),('8998','2013-09-30','09:50:00',2.13),('8998','2013-09-30','09:55:00',2.16),('8998','2013-09-30','10:00:00',2.19),('8998','2013-09-30','10:05:00',2.21),('8998','2013-09-30','10:10:00',2.25),('8998','2013-09-30','10:15:00',2.27),('8998','2013-09-30','10:20:00',2.3),('8998','2013-09-30','10:25:00',2.33),('8998','2013-09-30','10:30:00',2.37),('8998','2013-09-30','10:35:00',2.38),('8998','2013-09-30','10:40:00',2.39),('8998','2013-09-30','10:45:00',2.4),('8998','2013-09-30','10:50:00',2.41),('8998','2013-09-30','10:55:00',2.41),('8998','2013-09-30','11:00:00',2.44),('8998','2013-09-30','11:05:00',1.7),('8998','2013-09-30','11:10:00',2.68),('8998','2013-09-30','11:15:00',1.35),('8998','2013-09-30','11:20:00',2.48),('8998','2013-09-30','11:25:00',2.01),('8998','2013-09-30','11:30:00',2.59),('8998','2013-09-30','11:35:00',1.53),('8998','2013-09-30','11:40:00',2.59),('8998','2013-09-30','11:45:00',2.69),('8998','2013-09-30','11:50:00',2.67),('8998','2013-09-30','11:55:00',2.67),('8998','2013-09-30','12:00:00',2.44),('8998','2013-09-30','12:10:00',2.38),('8998','2013-09-30','12:15:00',2.51),('8998','2013-09-30','12:20:00',2.63),('8998','2013-09-30','12:25:00',2.64),('8998','2013-09-30','12:30:00',2.7),('8998','2013-09-30','12:35:00',2.67),('8998','2013-09-30','12:40:00',1.66),('8998','2013-09-30','12:45:00',2.12),('8998','2013-09-30','12:50:00',2.45),('8998','2013-09-30','12:55:00',2.41),('8998','2013-09-30','13:00:00',2.34),('8998','2013-09-30','13:05:00',2.41),('8998','2013-09-30','13:20:00',2.47),('8998','2013-09-30','13:25:00',2.5),('8998','2013-09-30','13:30:00',1.95),('8998','2013-09-30','13:35:00',2.15),('8998','2013-09-30','13:40:00',1.39),('8998','2013-09-30','13:45:00',1.75),('8998','2013-09-30','13:55:00',1.18),('8998','2013-09-30','14:00:00',2.05),('8998','2013-09-30','14:05:00',1.95),('8998','2013-09-30','14:10:00',1.89),('8998','2013-09-30','14:15:00',1.85),('8998','2013-09-30','14:20:00',1.81),('8998','2013-09-30','14:25:00',1.76),('8998','2013-09-30','14:30:00',1.71),('8998','2013-09-30','14:35:00',1.66),('8998','2013-09-30','14:40:00',1.64),('8998','2013-09-30','14:45:00',1.63),('8998','2013-09-30','14:50:00',1.62),('8998','2013-09-30','14:55:00',1.55),('8998','2013-09-30','15:00:00',1.46),('8998','2013-09-30','15:05:00',1.38),('8998','2013-09-30','15:10:00',1.28),('8998','2013-09-30','15:15:00',1.19),('8998','2013-09-30','15:20:00',1.13),('8998','2013-09-30','15:25:00',1.02),('8998','2013-09-29','10:25:00',1.03),('8998','2013-09-29','10:30:00',1.2),('8998','2013-09-29','10:35:00',1.38),('8998','2013-09-29','10:40:00',1.72),('8998','2013-09-29','10:45:00',2.59),('8998','2013-09-29','10:50:00',2.69),('8998','2013-09-29','10:55:00',2.43),('8998','2013-09-29','11:00:00',2.13),('8998','2013-09-29','11:05:00',2.44),('8998','2013-09-29','11:10:00',2.36),('8998','2013-09-29','11:15:00',2.04),('8998','2013-09-29','11:20:00',1.81),('8998','2013-09-29','11:25:00',2.14),('8998','2013-09-29','11:30:00',1.25),('8998','2013-09-29','11:35:00',1.29),('8998','2013-09-29','11:40:00',2.07),('8998','2013-09-29','11:45:00',1.46),('8998','2013-09-29','11:50:00',1.27),('8998','2013-09-29','11:55:00',1.03),('8998','2013-09-29','12:00:00',1.22),('8998','2013-09-29','12:05:00',2.26),('8998','2013-09-29','12:10:00',1.86),('8998','2013-09-29','12:15:00',2.66),('8998','2013-09-29','12:20:00',2.76),('8998','2013-09-29','12:25:00',2.76),('8998','2013-09-29','12:30:00',2.57),('8998','2013-09-29','12:35:00',2.49),('8998','2013-09-29','12:40:00',2.56),('8998','2013-09-29','12:45:00',1.88),('8998','2013-09-29','12:50:00',2.52),('8998','2013-09-29','12:55:00',2.49),('8998','2013-09-29','13:00:00',2.46),('8998','2013-09-29','13:05:00',2.01),('8998','2013-09-29','13:10:00',2.56),('8998','2013-09-29','13:15:00',2.14),('8998','2013-09-29','13:20:00',2.63),('8998','2013-09-29','13:25:00',2.78),('8998','2013-09-29','13:30:00',2.78),('8998','2013-09-29','13:35:00',2.11),('8998','2013-09-29','13:40:00',1.67),('8998','2013-09-29','13:45:00',1.04),('8998','2013-09-29','13:50:00',1.78),('8998','2013-09-29','13:55:00',1.47),('8998','2013-09-29','14:30:00',1.36),('8998','2013-09-29','14:35:00',1.73),('8998','2013-09-29','14:40:00',2.15),('8998','2013-09-29','14:45:00',1.62),('8998','2013-09-29','14:50:00',1.86),('8998','2013-09-29','14:55:00',1.21),('8998','2013-09-29','15:00:00',1.42),('8998','2013-09-29','15:05:00',1.28),('8998','2013-09-29','15:10:00',1.41),('8998','2013-09-29','15:15:00',1.07),('8998','2013-09-29','15:25:00',1.25),('8998','2013-09-29','15:40:00',1.23),('8998','2013-09-28','09:15:00',1.05),('8998','2013-09-28','10:00:00',1.01),('8998','2013-09-28','10:05:00',1.4),('8998','2013-09-28','10:10:00',1.6),('8998','2013-09-28','10:15:00',2.06),('8998','2013-09-28','10:20:00',1.79),('8998','2013-09-28','10:25:00',1.64),('8998','2013-09-28','10:30:00',1.91),('8998','2013-09-28','10:35:00',2.07),('8998','2013-09-28','10:40:00',2.24),('8998','2013-09-28','10:45:00',2.12),('8998','2013-09-28','10:50:00',2.2),('8998','2013-09-28','10:55:00',2.15),('8998','2013-09-28','11:00:00',2.18),('8998','2013-09-28','11:05:00',2.08),('8998','2013-09-28','11:10:00',2.05),('8998','2013-09-28','11:15:00',2.22),('8998','2013-09-28','11:20:00',2.21),('8998','2013-09-28','11:25:00',2.06),('8998','2013-09-28','11:30:00',2.21),('8998','2013-09-28','11:35:00',2.18),('8998','2013-09-28','11:40:00',2.24),('8998','2013-09-28','11:45:00',2.21),('8998','2013-09-28','11:50:00',2.35),('8998','2013-09-28','11:55:00',2.29),('8998','2013-09-28','12:00:00',2.13),('8998','2013-09-28','12:05:00',2.26),('8998','2013-09-28','12:10:00',2.24),('8998','2013-09-28','12:15:00',2.45),('8998','2013-09-28','12:20:00',2.08),('8998','2013-09-28','12:25:00',1.4),('8998','2013-09-28','12:30:00',1.42),('8998','2013-09-28','12:35:00',1.35),('8998','2013-09-28','12:40:00',1.17),('8998','2013-09-28','12:45:00',1.06),('8998','2013-09-28','12:50:00',1.08),('8998','2013-09-28','13:30:00',1.51),('8998','2013-09-28','13:35:00',1.09),('8998','2013-09-28','13:40:00',1.09),('8998','2013-09-28','13:45:00',1),('8998','2013-09-28','13:50:00',1.03),('8998','2013-09-28','13:55:00',1.37),('8998','2013-09-28','14:00:00',1.24),('8998','2013-09-28','14:05:00',1.49),('8998','2013-09-28','14:10:00',1.04),('8998','2013-09-28','14:15:00',1.04),('8998','2013-09-28','14:20:00',1.41),('8998','2013-09-28','14:25:00',1.02),('8998','2014-04-13','08:00:00',1.02),('8998','2014-04-13','08:05:00',1.31),('8998','2014-04-13','08:10:00',1.45),('8998','2014-04-13','08:15:00',1.54),('8998','2014-04-13','08:20:00',1.52),('8998','2014-04-13','08:25:00',1.38),('8998','2014-04-13','08:30:00',1.41),('8998','2014-04-13','08:35:00',1.66),('8998','2014-04-13','08:40:00',1.76),('8998','2014-04-13','08:45:00',1.97),('8998','2014-04-13','08:50:00',2.04),('8998','2014-04-13','08:55:00',2.08),('8998','2014-04-13','09:00:00',2.16),('8998','2014-04-13','09:05:00',2.22),('8998','2014-04-13','09:10:00',2.27),('8998','2014-04-13','09:15:00',2.31),('8998','2014-04-13','09:20:00',2.34),('8998','2014-04-13','09:25:00',2.38),('8998','2014-04-13','09:30:00',2.46),('8998','2014-04-13','09:35:00',2.49),('8998','2014-04-13','09:40:00',2.51),('8998','2014-04-13','09:45:00',2.56),('8998','2014-04-13','09:50:00',2.6),('8998','2014-04-13','09:55:00',2.64),('8998','2014-04-13','10:00:00',2.68),('8998','2014-04-13','10:05:00',2.71),('8998','2014-04-13','10:10:00',2.75),('8998','2014-04-13','10:15:00',2.77),('8998','2014-04-13','10:20:00',2.8),('8998','2014-04-13','10:25:00',2.82),('8998','2014-04-13','10:30:00',2.83),('8998','2014-04-13','10:35:00',2.86),('8998','2014-04-13','10:40:00',2.87),('8998','2014-04-13','10:45:00',2.88),('8998','2014-04-13','10:50:00',2.9),('8998','2014-04-13','10:55:00',2.92),('8998','2014-04-13','11:00:00',2.93),('8998','2014-04-13','11:05:00',2.94),('8998','2014-04-13','11:10:00',2.94),('8998','2014-04-13','11:15:00',2.96),('8998','2014-04-13','11:20:00',2.96),('8998','2014-04-13','11:25:00',2.96),('8998','2014-04-13','11:30:00',2.95),('8998','2014-04-13','11:35:00',2.96),('8998','2014-04-13','11:40:00',2.97),('8998','2014-04-13','11:45:00',2.95),('8998','2014-04-13','11:50:00',2.95),('8998','2014-04-13','11:55:00',2.96),('8998','2014-04-13','12:00:00',2.96),('8998','2014-04-13','12:05:00',2.95),('8998','2014-04-13','12:10:00',2.95),('8998','2014-04-13','12:15:00',2.99),('8998','2014-04-13','12:20:00',2.97),('8998','2014-04-13','12:25:00',2.95),('8998','2014-04-13','12:30:00',2.96),('8998','2014-04-13','12:35:00',2.94),('8998','2014-04-13','12:40:00',2.92),('8998','2014-04-13','12:45:00',2.91),('8998','2014-04-13','12:50:00',2.89),('8998','2014-04-13','12:55:00',2.86),('8998','2014-04-13','13:00:00',2.84),('8998','2014-04-13','13:05:00',2.82),('8998','2014-04-13','13:10:00',2.8),('8998','2014-04-13','13:15:00',2.75),('8998','2014-04-13','13:20:00',2.74),('8998','2014-04-13','13:25:00',2.72),('8998','2014-04-13','13:30:00',2.72),('8998','2014-04-13','13:35:00',2.69),('8998','2014-04-13','13:40:00',2.66),('8998','2014-04-13','13:45:00',2.63),('8998','2014-04-13','13:50:00',2.6),('8998','2014-04-13','13:55:00',2.58),('8998','2014-04-13','14:00:00',2.56),('8998','2014-04-13','14:05:00',2.51),('8998','2014-04-13','14:10:00',2.49),('8998','2014-04-13','14:15:00',2.47),('8998','2014-04-13','14:20:00',2.41),('8998','2014-04-13','14:25:00',2.38),('8998','2014-04-13','14:30:00',2.34),('8998','2014-04-13','14:35:00',2.29),('8998','2014-04-13','14:40:00',2.26),('8998','2014-04-13','14:45:00',2.21),('8998','2014-04-13','14:50:00',2.16),('8998','2014-04-13','14:55:00',2.11),('8998','2014-04-13','15:00:00',2.07),('8998','2014-04-13','15:05:00',2.02),('8998','2014-04-13','15:10:00',1.97),('8998','2014-04-13','15:15:00',1.92),('8998','2014-04-13','15:20:00',1.86),('8998','2014-04-13','15:25:00',1.8),('8998','2014-04-13','15:30:00',1.75),('8998','2014-04-13','15:35:00',1.7),('8998','2014-04-13','15:40:00',1.65),('8998','2014-04-13','15:45:00',1.58),('8998','2014-04-13','15:50:00',1.53),('8998','2014-04-13','15:55:00',1.46),('8998','2014-04-13','16:00:00',1.4),('8998','2014-04-13','16:05:00',1.34),('8998','2014-04-13','16:10:00',1.28),('8998','2014-04-13','16:15:00',1.22),('8998','2014-04-13','16:20:00',1.16),('8998','2014-04-13','16:25:00',1.09),('8998','2014-04-13','16:30:00',1.03),('8998','2013-09-27','08:35:00',1.05),('8998','2013-09-27','08:40:00',1.32),('8998','2013-09-27','08:45:00',1.38),('8998','2013-09-27','08:50:00',1.42),('8998','2013-09-27','08:55:00',1.5),('8998','2013-09-27','09:00:00',1.53),('8998','2013-09-27','09:05:00',1.6),('8998','2013-09-27','09:10:00',1.68),('8998','2013-09-27','09:15:00',1.74),('8998','2013-09-27','09:20:00',1.8),('8998','2013-09-27','09:25:00',1.87),('8998','2013-09-27','09:30:00',1.92),('8998','2013-09-27','09:35:00',1.96),('8998','2013-09-27','09:40:00',2.02),('8998','2013-09-27','09:45:00',2.05),('8998','2013-09-27','09:50:00',2.11),('8998','2013-09-27','09:55:00',2.16),('8998','2013-09-27','10:00:00',1.13),('8998','2013-09-27','10:05:00',1.4),('8998','2013-09-27','10:10:00',1.21),('8998','2013-09-27','10:35:00',2.13),('8998','2013-09-27','10:40:00',1.71),('8998','2013-09-27','10:45:00',2.09),('8998','2013-09-27','10:50:00',2.44),('8998','2013-09-27','10:55:00',2.68),('8998','2013-09-27','11:00:00',1.33),('8998','2013-09-27','11:15:00',1.13),('8998','2013-09-27','11:20:00',1.87),('8998','2013-09-27','11:25:00',2.68),('8998','2013-09-27','11:30:00',2.79),('8998','2013-09-27','11:35:00',2.24),('8998','2013-09-27','11:40:00',1.58),('8998','2013-09-27','12:00:00',1.06),('8998','2013-09-27','12:05:00',2.73),('8998','2013-09-27','12:10:00',2.68),('8998','2013-09-27','12:15:00',2.11),('8998','2013-09-27','12:20:00',1.44),('8998','2013-09-27','12:25:00',2.49),('8998','2013-09-27','12:35:00',1.68),('8998','2013-09-27','12:40:00',2.16),('8998','2013-09-27','12:50:00',2.14),('8998','2013-09-27','12:55:00',2.46),('8998','2013-09-27','13:00:00',1.24),('8998','2013-09-27','13:05:00',2.35),('8998','2013-09-27','13:30:00',1.93),('8998','2013-09-27','13:35:00',1.09),('8998','2013-09-27','13:45:00',1.05),('8998','2013-09-27','13:50:00',1.37),('8998','2013-09-27','14:20:00',1.13),('8998','2013-09-27','14:25:00',2.26),('8998','2013-09-27','14:30:00',1.69),('8998','2013-09-27','14:35:00',1.38),('8998','2013-09-27','14:40:00',2.06),('8998','2013-09-27','14:45:00',1.95),('8998','2013-09-27','14:50:00',1.71),('8998','2013-09-27','15:00:00',1.5),('8998','2013-09-27','15:05:00',1.67),('8998','2013-09-27','15:10:00',1.28),('8998','2013-09-27','15:15:00',1.61),('8998','2013-09-27','15:20:00',1.53),('8998','2013-09-27','15:25:00',1.51),('8998','2013-09-27','15:30:00',1.39),('8998','2013-09-27','15:35:00',1.22),('8998','2013-09-27','15:40:00',1.19),('8998','2013-09-27','15:45:00',1.04),('8998','2013-09-26','08:35:00',1.28),('8998','2013-09-26','08:40:00',1.31),('8998','2013-09-26','08:45:00',1.36),('8998','2013-09-26','08:50:00',1.29),('8998','2013-09-26','08:55:00',1.54),('8998','2013-09-26','09:00:00',1.27),('8998','2013-09-26','09:55:00',1.1),('8998','2013-09-26','10:00:00',1.1),('8998','2013-09-26','10:05:00',1.77),('8998','2013-09-26','10:10:00',1.7),('8998','2013-09-26','10:15:00',1.2),('8998','2013-09-26','10:20:00',1.73),('8998','2013-09-26','10:25:00',1.35),('8998','2013-09-26','10:30:00',1.69),('8998','2013-09-26','10:45:00',1.15),('8998','2013-09-26','10:50:00',2.19),('8998','2013-09-26','10:55:00',2.36),('8998','2013-09-26','11:00:00',2.4),('8998','2013-09-26','11:05:00',2.37),('8998','2013-09-26','11:10:00',2.14),('8998','2013-09-26','11:15:00',2.38),('8998','2013-09-26','11:20:00',2.29),('8998','2013-09-26','11:25:00',2.25),('8998','2013-09-26','11:30:00',2.28),('8998','2013-09-26','11:45:00',1.62),('8998','2013-09-26','12:00:00',2.2),('8998','2013-09-26','12:05:00',1.34),('8998','2013-09-26','12:10:00',2.12),('8998','2013-09-26','12:15:00',2.03),('8998','2013-09-26','12:45:00',1.03),('8998','2013-09-26','12:50:00',2.38),('8998','2013-09-26','12:55:00',2.32),('8998','2013-09-26','13:00:00',2.31),('8998','2013-09-26','13:05:00',2.29),('8998','2013-09-26','13:10:00',2.29),('8998','2013-09-26','13:15:00',1.11),('8998','2013-09-26','13:20:00',2.24),('8998','2013-09-26','13:25:00',1.99),('8998','2013-09-26','13:45:00',1.72),('8998','2013-09-26','13:50:00',1.04),('8998','2013-09-26','14:05:00',1.89),('8998','2013-09-26','14:10:00',1.75),('8998','2013-09-26','14:15:00',1.82),('8998','2013-09-26','14:20:00',2.01),('8998','2013-09-26','14:25:00',1.9),('8998','2013-09-26','14:30:00',1.86),('8998','2013-09-26','14:35:00',1.77),('8998','2013-09-26','14:40:00',1.73),('8998','2013-09-26','14:45:00',1.63),('8998','2013-09-26','14:50:00',1.43),('8998','2013-09-26','14:55:00',1.45),('8998','2013-09-26','15:00:00',1.15),('8998','2013-09-26','15:05:00',1.15),('8998','2013-09-26','15:15:00',1.32),('8998','2013-09-26','15:25:00',1.12),('8998','2013-09-26','15:30:00',1.12),('8998','2013-09-25','08:40:00',1.4),('8998','2013-09-25','08:45:00',1.51),('8998','2013-09-25','08:50:00',1.57),('8998','2013-09-25','08:55:00',1.65),('8998','2013-09-25','09:00:00',1.73),('8998','2013-09-25','09:05:00',1.78),('8998','2013-09-25','09:10:00',1.84),('8998','2013-09-25','09:15:00',1.88),('8998','2013-09-25','09:20:00',1.96),('8998','2013-09-25','09:25:00',1.99),('8998','2013-09-25','09:30:00',2.04),('8998','2013-09-25','09:35:00',2.07),('8998','2013-09-25','09:40:00',2.09),('8998','2013-09-25','09:45:00',2.13),('8998','2013-09-25','09:50:00',2.14),('8998','2013-09-25','09:55:00',2.15),('8998','2013-09-25','10:00:00',2.21),('8998','2013-09-25','10:05:00',2.21),('8998','2013-09-25','10:10:00',2.22),('8998','2013-09-25','10:15:00',2.27),('8998','2013-09-25','10:20:00',2.27),('8998','2013-09-25','10:25:00',2.29),('8998','2013-09-25','10:30:00',2.29),('8998','2013-09-25','10:35:00',2.31),('8998','2013-09-25','10:40:00',2.31),('8998','2013-09-25','10:45:00',2.08),('8998','2013-09-25','10:50:00',2.38),('8998','2013-09-25','10:55:00',2.41),('8998','2013-09-25','11:00:00',2.41),('8998','2013-09-25','11:05:00',2.35),('8998','2013-09-25','11:10:00',2.4),('8998','2013-09-25','11:15:00',2.39),('8998','2013-09-25','11:20:00',2.42),('8998','2013-09-25','11:25:00',2.46),('8998','2013-09-25','11:30:00',2.43),('8998','2013-09-25','11:35:00',2.49),('8998','2013-09-25','11:40:00',2.17),('8998','2013-09-25','11:45:00',1.94),('8998','2013-09-25','11:50:00',2.44),('8998','2013-09-25','11:55:00',2.11),('8998','2013-09-25','12:00:00',1.59),('8998','2013-09-25','12:05:00',1.99),('8998','2013-09-25','12:20:00',1.18),('8998','2013-09-25','12:40:00',1.15),('8998','2013-09-25','12:45:00',1.29),('8998','2013-09-25','12:50:00',1.15),('8998','2013-09-25','12:55:00',1.47),('8998','2013-09-25','13:00:00',2.16),('8998','2013-09-25','13:05:00',1.43),('8998','2013-09-25','13:10:00',1.01),('8998','2013-09-25','13:15:00',2.09),('8998','2013-09-25','13:20:00',2.56),('8998','2013-09-25','13:25:00',2.12),('8998','2013-09-25','13:30:00',1.42),('8998','2013-09-25','13:35:00',1.36),('8998','2013-09-25','13:40:00',1.01),('8998','2013-09-25','13:55:00',1.18),('8998','2013-09-25','14:00:00',1.28),('8998','2013-09-25','14:05:00',1.61),('8998','2013-09-25','14:10:00',2.3),('8998','2013-09-25','14:15:00',2.17),('8998','2013-09-25','14:20:00',2),('8998','2013-09-25','14:25:00',1.28),('8998','2013-09-25','14:35:00',1.17),('8998','2013-09-25','14:40:00',1.26),('8998','2013-09-25','14:45:00',1.4),('8998','2013-09-25','14:50:00',2),('8998','2013-09-25','14:55:00',1.41),('8998','2013-09-25','15:25:00',1.35),('8998','2013-09-25','15:45:00',1.04),('8998','2013-09-25','15:50:00',1.1),('8998','2013-09-24','08:50:00',1.06),('8998','2013-09-24','09:10:00',1.6),('8998','2013-09-24','09:15:00',1.58),('8998','2013-09-24','09:25:00',1.08),('8998','2013-09-24','09:30:00',1.72),('8998','2013-09-24','09:35:00',1.6),('8998','2013-09-24','09:40:00',2.05),('8998','2013-09-24','09:45:00',1.9),('8998','2013-09-24','09:50:00',1.55),('8998','2013-09-24','09:55:00',1.25),('8998','2013-09-24','10:00:00',2.47),('8998','2013-09-24','10:05:00',1.63),('8998','2013-09-24','10:25:00',1.3),('8998','2013-09-24','10:30:00',1.22),('8998','2013-09-24','10:45:00',2.35),('8998','2013-09-24','10:50:00',2.83),('8998','2013-09-24','10:55:00',2.95),('8998','2013-09-24','11:00:00',2.24),('8998','2013-09-24','11:10:00',1.16),('8998','2013-09-24','11:15:00',1.06),('8998','2013-09-24','11:25:00',1.5),('8998','2013-09-24','11:30:00',2.67),('8998','2013-09-24','11:35:00',2.63),('8998','2013-09-24','11:40:00',2.4),('8998','2013-09-24','11:45:00',2.6),('8998','2013-09-24','11:50:00',1.81),('8998','2013-09-24','11:55:00',1.42),('8998','2013-09-24','12:00:00',1.7),('8998','2013-09-24','12:15:00',2.29),('8998','2013-09-24','12:20:00',2.62),('8998','2013-09-24','12:25:00',2.56),('8998','2013-09-24','12:30:00',1.85),('8998','2013-09-24','12:35:00',2.57),('8998','2013-09-24','12:40:00',2.67),('8998','2013-09-24','12:45:00',1.14),('8998','2013-09-24','13:35:00',2.12),('8998','2013-09-24','13:40:00',1.73),('8998','2013-09-24','13:45:00',2.52),('8998','2013-09-24','13:50:00',2.55),('8998','2013-09-24','13:55:00',2.45),('8998','2013-09-24','14:00:00',1.09),('8998','2013-09-24','14:35:00',1.02),('8998','2013-09-24','14:40:00',1.67),('8998','2013-09-24','14:45:00',1.69),('8998','2013-09-24','14:50:00',1.29),('8998','2013-09-24','14:55:00',1.87),('8998','2013-09-24','15:00:00',1.45),('8998','2013-09-24','15:05:00',1.86),('8998','2013-09-24','15:10:00',1.71),('8998','2013-09-24','15:15:00',1.59),('8998','2013-09-24','15:20:00',1.47),('8998','2013-09-24','15:25:00',1.32),('8998','2013-09-24','15:30:00',1.29),('8998','2013-09-24','15:35:00',1.06),('8998','2013-09-24','15:40:00',1.29),('8998','2013-09-24','15:45:00',1.1),('8998','2013-09-23','08:30:00',1.39),('8998','2013-09-23','08:35:00',1.53),('8998','2013-09-23','08:40:00',1.59),('8998','2013-09-23','08:45:00',1.64),('8998','2013-09-23','08:50:00',1.69),('8998','2013-09-23','08:55:00',1.75),('8998','2013-09-23','09:00:00',1.82),('8998','2013-09-23','09:05:00',1.87),('8998','2013-09-23','09:10:00',1.94),('8998','2013-09-23','09:15:00',1.99),('8998','2013-09-23','09:20:00',2.05),('8998','2013-09-23','09:25:00',2.1),('8998','2013-09-23','09:30:00',2.15),('8998','2013-09-23','09:35:00',2.18),('8998','2013-09-23','09:40:00',2.21),('8998','2013-09-23','09:45:00',2.24),('8998','2013-09-23','09:50:00',2.26),('8998','2013-09-23','09:55:00',2.28),('8998','2013-09-23','10:00:00',2.29),('8998','2013-09-23','10:05:00',2.33),('8998','2013-09-23','10:10:00',2.37),('8998','2013-09-23','10:15:00',2.41),('8998','2013-09-23','10:20:00',2.43),('8998','2013-09-23','10:25:00',2.45),('8998','2013-09-23','10:30:00',2.48),('8998','2013-09-23','10:35:00',2.48),('8998','2013-09-23','10:40:00',2.49),('8998','2013-09-23','10:45:00',2.52),('8998','2013-09-23','10:50:00',2.53),('8998','2013-09-23','10:55:00',2.53),('8998','2013-09-23','11:00:00',2.54),('8998','2013-09-23','11:05:00',2.55),('8998','2013-09-23','11:10:00',2.54),('8998','2013-09-23','11:15:00',2.55),('8998','2013-09-23','11:20:00',2.55),('8998','2013-09-23','11:25:00',2.55),('8998','2013-09-23','11:30:00',2.55),('8998','2013-09-23','11:35:00',2.55),('8998','2013-09-23','11:40:00',2.56),('8998','2013-09-23','11:45:00',2.55),('8998','2013-09-23','11:50:00',2.55),('8998','2013-09-23','11:55:00',2.55),('8998','2013-09-23','12:00:00',2.54),('8998','2013-09-23','12:05:00',2.53),('8998','2013-09-23','12:10:00',2.52),('8998','2013-09-23','12:15:00',2.5),('8998','2013-09-23','12:20:00',2.49),('8998','2013-09-23','12:25:00',2.46),('8998','2013-09-23','12:30:00',2.44),('8998','2013-09-23','12:35:00',2.43),('8998','2013-09-23','12:40:00',2.44),('8998','2013-09-23','12:45:00',2.44),('8998','2013-09-23','12:50:00',2.43),('8998','2013-09-23','12:55:00',2.39),('8998','2013-09-23','13:00:00',2.35),('8998','2013-09-23','13:05:00',2.36),('8998','2013-09-23','13:10:00',2.33),('8998','2013-09-23','13:15:00',2.31),('8998','2013-09-23','13:20:00',2.29),('8998','2013-09-23','13:25:00',2.25),('8998','2013-09-23','13:30:00',2.23),('8998','2013-09-23','13:35:00',2.18),('8998','2013-09-23','13:40:00',2.16),('8998','2013-09-23','13:45:00',2.15),('8998','2013-09-23','13:50:00',2.12);
INSERT INTO `solarlog` VALUES ('8998','2013-09-23','13:55:00',2.07),('8998','2013-09-23','14:00:00',2.03),('8998','2013-09-23','14:05:00',2),('8998','2013-09-23','14:10:00',1.96),('8998','2013-09-23','14:15:00',1.91),('8998','2013-09-23','14:20:00',1.87),('8998','2013-09-23','14:25:00',1.83),('8998','2013-09-23','14:30:00',1.8),('8998','2013-09-23','14:35:00',1.75),('8998','2013-09-23','14:40:00',1.71),('8998','2013-09-23','14:45:00',1.65),('8998','2013-09-23','14:50:00',1.6),('8998','2013-09-23','14:55:00',1.55),('8998','2013-09-23','15:00:00',1.49),('8998','2013-09-23','15:05:00',1.45),('8998','2013-09-23','15:10:00',1.41),('8998','2013-09-23','15:15:00',1.35),('8998','2013-09-23','15:20:00',1.3),('8998','2013-09-23','15:25:00',1.21),('8998','2013-09-23','15:30:00',1.17),('8998','2013-09-23','15:35:00',1.08),('8998','2013-09-23','15:40:00',1.03),('8998','2013-09-22','08:25:00',1.1),('8998','2013-09-22','08:30:00',1.45),('8998','2013-09-22','08:35:00',1.59),('8998','2013-09-22','08:40:00',1.64),('8998','2013-09-22','08:45:00',1.7),('8998','2013-09-22','08:50:00',1.75),('8998','2013-09-22','08:55:00',1.8),('8998','2013-09-22','09:00:00',1.89),('8998','2013-09-22','09:05:00',1.95),('8998','2013-09-22','09:10:00',1.99),('8998','2013-09-22','09:15:00',2.06),('8998','2013-09-22','09:20:00',2.12),('8998','2013-09-22','09:25:00',2.16),('8998','2013-09-22','09:30:00',2.2),('8998','2013-09-22','09:35:00',2.24),('8998','2013-09-22','09:40:00',2.27),('8998','2013-09-22','09:45:00',2.29),('8998','2013-09-22','09:50:00',2.32),('8998','2013-09-22','09:55:00',2.34),('8998','2013-09-22','10:00:00',2.38),('8998','2013-09-22','10:05:00',2.4),('8998','2013-09-22','10:10:00',2.43),('8998','2013-09-22','10:15:00',2.44),('8998','2013-09-22','10:20:00',2.46),('8998','2013-09-22','10:25:00',2.48),('8998','2013-09-22','10:30:00',2.49),('8998','2013-09-22','10:35:00',2.51),('8998','2013-09-22','10:40:00',2.53),('8998','2013-09-22','10:45:00',2.54),('8998','2013-09-22','10:50:00',2.57),('8998','2013-09-22','10:55:00',2.57),('8998','2013-09-22','11:00:00',2.57),('8998','2013-09-22','11:05:00',2.61),('8998','2013-09-22','11:10:00',2.62),('8998','2013-09-22','11:15:00',2.65),('8998','2013-09-22','11:20:00',2.66),('8998','2013-09-22','11:25:00',2.66),('8998','2013-09-22','11:30:00',2.67),('8998','2013-09-22','11:35:00',2.67),('8998','2013-09-22','11:40:00',2.66),('8998','2013-09-22','11:45:00',2.67),('8998','2013-09-22','11:50:00',2.66),('8998','2013-09-22','11:55:00',2.66),('8998','2013-09-22','12:00:00',2.65),('8998','2013-09-22','12:05:00',2.66),('8998','2013-09-22','12:10:00',2.68),('8998','2013-09-22','12:15:00',2.66),('8998','2013-09-22','12:20:00',2.63),('8998','2013-09-22','12:25:00',2.59),('8998','2013-09-22','12:30:00',2.56),('8998','2013-09-22','12:35:00',2.54),('8998','2013-09-22','12:40:00',2.53),('8998','2013-09-22','12:45:00',2.52),('8998','2013-09-22','12:50:00',2.49),('8998','2013-09-22','12:55:00',2.48),('8998','2013-09-22','13:00:00',2.46),('8998','2013-09-22','13:05:00',2.44),('8998','2013-09-22','13:10:00',2.42),('8998','2013-09-22','13:15:00',2.38),('8998','2013-09-22','13:20:00',2.33),('8998','2013-09-22','13:25:00',2.33),('8998','2013-09-22','13:30:00',2.29),('8998','2013-09-22','13:35:00',2.26),('8998','2013-09-22','13:40:00',2.22),('8998','2013-09-22','13:45:00',2.19),('8998','2013-09-22','13:50:00',2.16),('8998','2013-09-22','13:55:00',2.11),('8998','2013-09-22','14:00:00',2.06),('8998','2013-09-22','14:05:00',2),('8998','2013-09-22','14:10:00',1.97),('8998','2013-09-22','14:15:00',1.95),('8998','2013-09-22','14:20:00',1.9),('8998','2013-09-22','14:25:00',1.89),('8998','2013-09-22','14:30:00',1.91),('8998','2013-09-22','14:35:00',1.83),('8998','2013-09-22','14:40:00',1.76),('8998','2013-09-22','14:45:00',1.69),('8998','2013-09-22','14:50:00',1.63),('8998','2013-09-22','14:55:00',1.61),('8998','2013-09-22','15:00:00',1.56),('8998','2013-09-22','15:05:00',1.18),('8998','2013-09-22','15:10:00',1.04),('8998','2013-09-22','15:15:00',1.42),('8998','2013-09-22','15:20:00',1.35),('8998','2013-09-22','15:25:00',1.29),('8998','2013-09-22','15:30:00',1.17),('8998','2013-09-22','15:35:00',1.11),('8998','2013-09-22','15:40:00',1),('8998','2013-09-21','08:30:00',1.42),('8998','2013-09-21','08:35:00',1.52),('8998','2013-09-21','08:40:00',1.59),('8998','2013-09-21','08:45:00',1.65),('8998','2013-09-21','08:50:00',1.7),('8998','2013-09-21','08:55:00',1.77),('8998','2013-09-21','09:00:00',1.85),('8998','2013-09-21','09:05:00',1.91),('8998','2013-09-21','09:10:00',1.98),('8998','2013-09-21','09:15:00',2.08),('8998','2013-09-21','09:20:00',2.12),('8998','2013-09-21','09:25:00',2.17),('8998','2013-09-21','09:30:00',2.2),('8998','2013-09-21','09:35:00',2.24),('8998','2013-09-21','09:40:00',2.26),('8998','2013-09-21','09:45:00',2.29),('8998','2013-09-21','09:50:00',2.32),('8998','2013-09-21','09:55:00',2.36),('8998','2013-09-21','10:00:00',2.4),('8998','2013-09-21','10:05:00',2.45),('8998','2013-09-21','10:10:00',2.48),('8998','2013-09-21','10:15:00',2.5),('8998','2013-09-21','10:20:00',2.53),('8998','2013-09-21','10:25:00',2.54),('8998','2013-09-21','10:30:00',2.58),('8998','2013-09-21','10:35:00',2.61),('8998','2013-09-21','10:40:00',2.62),('8998','2013-09-21','10:45:00',2.62),('8998','2013-09-21','10:50:00',2.63),('8998','2013-09-21','10:55:00',2.63),('8998','2013-09-21','11:00:00',2.64),('8998','2013-09-21','11:05:00',2.63),('8998','2013-09-21','11:10:00',2.63),('8998','2013-09-21','11:15:00',2.64),('8998','2013-09-21','11:20:00',2.67),('8998','2013-09-21','11:25:00',2.68),('8998','2013-09-21','11:30:00',2.68),('8998','2013-09-21','11:35:00',2.7),('8998','2013-09-21','11:40:00',2.71),('8998','2013-09-21','11:45:00',2.72),('8998','2013-09-21','11:50:00',2.71),('8998','2013-09-21','11:55:00',2.71),('8998','2013-09-21','12:00:00',2.71),('8998','2013-09-21','12:05:00',2.71),('8998','2013-09-21','12:10:00',2.7),('8998','2013-09-21','12:15:00',2.67),('8998','2013-09-21','12:20:00',2.68),('8998','2013-09-21','12:25:00',2.65),('8998','2013-09-21','12:30:00',2.62),('8998','2013-09-21','12:35:00',2.61),('8998','2013-09-21','12:40:00',2.6),('8998','2013-09-21','12:45:00',2.55),('8998','2013-09-21','12:50:00',2.57),('8998','2013-09-21','12:55:00',2.59),('8998','2013-09-21','13:00:00',2.54),('8998','2013-09-21','13:05:00',2.51),('8998','2013-09-21','13:10:00',2.52),('8998','2013-09-21','13:15:00',2.46),('8998','2013-09-21','13:20:00',2.41),('8998','2013-09-21','13:25:00',2.38),('8998','2013-09-21','13:30:00',2.34),('8998','2013-09-21','13:35:00',2.3),('8998','2013-09-21','13:40:00',2.27),('8998','2013-09-21','13:45:00',2.25),('8998','2013-09-21','13:50:00',2.24),('8998','2013-09-21','13:55:00',2.06),('8998','2013-09-21','14:00:00',2.14),('8998','2013-09-21','14:05:00',2.15),('8998','2013-09-21','14:10:00',2.08),('8998','2013-09-21','14:15:00',2.11),('8998','2013-09-21','14:20:00',1.46),('8998','2013-09-21','14:25:00',1.9),('8998','2013-09-21','14:30:00',1.97),('8998','2013-09-21','14:35:00',1.9),('8998','2013-09-21','14:40:00',1.38),('8998','2013-09-21','14:45:00',1.6),('8998','2013-09-21','14:50:00',1.75),('8998','2013-09-21','14:55:00',1.7),('8998','2013-09-21','15:00:00',1.68),('8998','2013-09-21','15:05:00',1.71),('8998','2013-09-21','15:10:00',1.63),('8998','2013-09-21','15:15:00',1.71),('8998','2013-09-21','15:20:00',1.79),('8998','2013-09-21','15:40:00',1.04),('8998','2013-09-21','15:45:00',1.2),('8998','2013-09-21','15:50:00',1.09),('8998','2013-09-21','15:55:00',1.09),('8998','2013-09-21','16:00:00',1.24),('8998','2013-09-21','16:05:00',1.29),('8998','2013-09-21','16:10:00',1.36),('8998','2013-09-21','16:15:00',1.09),('8998','2013-09-20','08:25:00',1.22),('8998','2013-09-20','08:30:00',1.44),('8998','2013-09-20','08:35:00',1.54),('8998','2013-09-20','08:40:00',1.59),('8998','2013-09-20','08:45:00',1.64),('8998','2013-09-20','08:50:00',1.69),('8998','2013-09-20','08:55:00',1.75),('8998','2013-09-20','09:00:00',1.82),('8998','2013-09-20','09:05:00',1.88),('8998','2013-09-20','09:10:00',1.94),('8998','2013-09-20','09:15:00',2.01),('8998','2013-09-20','09:20:00',2.06),('8998','2013-09-20','09:25:00',2.09),('8998','2013-09-20','09:30:00',2.13),('8998','2013-09-20','09:35:00',2.17),('8998','2013-09-20','09:40:00',2.19),('8998','2013-09-20','09:45:00',2.24),('8998','2013-09-20','09:50:00',2.26),('8998','2013-09-20','09:55:00',2.31),('8998','2013-09-20','10:00:00',2.34),('8998','2013-09-20','10:05:00',2.37),('8998','2013-09-20','10:10:00',2.4),('8998','2013-09-20','10:15:00',2.43),('8998','2013-09-20','10:20:00',2.44),('8998','2013-09-20','10:25:00',2.46),('8998','2013-09-20','10:30:00',2.47),('8998','2013-09-20','10:35:00',2.49),('8998','2013-09-20','10:40:00',2.51),('8998','2013-09-20','10:45:00',2.52),('8998','2013-09-20','10:50:00',2.54),('8998','2013-09-20','10:55:00',2.56),('8998','2013-09-20','11:00:00',2.57),('8998','2013-09-20','11:05:00',2.57),('8998','2013-09-20','11:10:00',2.57),('8998','2013-09-20','11:15:00',2.58),('8998','2013-09-20','11:20:00',2.6),('8998','2013-09-20','11:25:00',2.61),('8998','2013-09-20','11:30:00',2.61),('8998','2013-09-20','11:35:00',2.6),('8998','2013-09-20','11:40:00',2.62),('8998','2013-09-20','11:45:00',2.61),('8998','2013-09-20','11:50:00',2.63),('8998','2013-09-20','11:55:00',2.55),('8998','2013-09-20','12:00:00',2.6),('8998','2013-09-20','12:05:00',2.62),('8998','2013-09-20','12:10:00',2.6),('8998','2013-09-20','12:15:00',2.6),('8998','2013-09-20','12:20:00',2.58),('8998','2013-09-20','12:25:00',2.32),('8998','2013-09-20','12:30:00',2.62),('8998','2013-09-20','12:35:00',2.57),('8998','2013-09-20','12:40:00',2.31),('8998','2013-09-20','12:45:00',2.3),('8998','2013-09-20','12:50:00',2.5),('8998','2013-09-20','12:55:00',2.48),('8998','2013-09-20','13:00:00',2.46),('8998','2013-09-20','13:05:00',2.34),('8998','2013-09-20','13:10:00',2.42),('8998','2013-09-20','13:15:00',2.4),('8998','2013-09-20','13:20:00',1.88),('8998','2013-09-20','13:25:00',2.14),('8998','2013-09-20','13:30:00',2.22),('8998','2013-09-20','13:35:00',2.25),('8998','2013-09-20','13:40:00',1.96),('8998','2013-09-20','13:45:00',1.92),('8998','2013-09-20','13:50:00',1.98),('8998','2013-09-20','13:55:00',2.02),('8998','2013-09-20','14:00:00',1.94),('8998','2013-09-20','14:05:00',2.04),('8998','2013-09-20','14:10:00',1.96),('8998','2013-09-20','14:15:00',2.01),('8998','2013-09-20','14:20:00',2),('8998','2013-09-20','14:25:00',1.94),('8998','2013-09-20','14:30:00',1.89),('8998','2013-09-20','14:35:00',1.84),('8998','2013-09-20','14:40:00',1.78),('8998','2013-09-20','14:45:00',1.73),('8998','2013-09-20','14:50:00',1.69),('8998','2013-09-20','14:55:00',1.64),('8998','2013-09-20','15:00:00',1.58),('8998','2013-09-20','15:05:00',1.53),('8998','2013-09-20','15:10:00',1.44),('8998','2013-09-20','15:15:00',1.41),('8998','2013-09-20','15:20:00',1.37),('8998','2013-09-20','15:25:00',1.31),('8998','2013-09-20','15:30:00',1.25),('8998','2013-09-20','15:35:00',1.18),('8998','2013-09-19','08:35:00',1.26),('8998','2013-09-19','08:40:00',1.45),('8998','2013-09-19','08:45:00',1.44),('8998','2013-09-19','09:05:00',1.04),('8998','2013-09-19','09:20:00',1.38),('8998','2013-09-19','09:25:00',1.68),('8998','2013-09-19','09:30:00',1.06),('8998','2013-09-19','09:45:00',1),('8998','2013-09-19','09:50:00',1.06),('8998','2013-09-19','09:55:00',1.07),('8998','2013-09-19','10:00:00',1.19),('8998','2013-09-19','10:05:00',1.5),('8998','2013-09-19','10:10:00',2.76),('8998','2013-09-19','10:15:00',1.55),('8998','2013-09-19','10:20:00',2.8),('8998','2013-09-19','10:25:00',1.47),('8998','2013-09-19','10:30:00',1.5),('8998','2013-09-19','10:35:00',1.95),('8998','2013-09-19','10:40:00',1.72),('8998','2013-09-19','10:45:00',1.9),('8998','2013-09-19','10:50:00',1.95),('8998','2013-09-19','10:55:00',2.08),('8998','2013-09-19','11:00:00',1.86),('8998','2013-09-19','11:05:00',1.49),('8998','2013-09-19','11:10:00',1.49),('8998','2013-09-19','11:15:00',1.86),('8998','2013-09-19','11:20:00',1.93),('8998','2013-09-19','11:25:00',1.71),('8998','2013-09-19','11:30:00',2.07),('8998','2013-09-19','11:35:00',2),('8998','2013-09-19','11:40:00',2.28),('8998','2013-09-19','11:45:00',3),('8998','2013-09-19','11:50:00',2.95),('8998','2013-09-19','11:55:00',2.82),('8998','2013-09-19','12:00:00',2.69),('8998','2013-09-19','12:05:00',2.66),('8998','2013-09-19','12:10:00',2.64),('8998','2013-09-19','12:15:00',2.66),('8998','2013-09-19','12:20:00',2.67),('8998','2013-09-19','12:25:00',2.7),('8998','2013-09-19','12:30:00',2.17),('8998','2013-09-19','12:35:00',2.36),('8998','2013-09-19','12:40:00',1.9),('8998','2013-09-19','12:45:00',2.57),('8998','2013-09-19','12:50:00',2.17),('8998','2013-09-19','12:55:00',2.63),('8998','2013-09-19','13:00:00',2.41),('8998','2013-09-19','13:05:00',2.12),('8998','2013-09-19','13:10:00',2.39),('8998','2013-09-19','13:15:00',2.24),('8998','2013-09-19','13:20:00',2.19),('8998','2013-09-19','13:25:00',2.56),('8998','2013-09-19','13:30:00',2.44),('8998','2013-09-19','13:35:00',1.52),('8998','2013-09-19','13:40:00',2.08),('8998','2013-09-19','13:45:00',2.34),('8998','2013-09-19','13:50:00',2.23),('8998','2013-09-19','13:55:00',2.01),('8998','2013-09-19','14:00:00',2.15),('8998','2013-09-19','14:05:00',2.17),('8998','2013-09-19','14:10:00',1.42),('8998','2013-09-19','14:15:00',1.95),('8998','2013-09-19','14:20:00',1.27),('8998','2013-09-19','14:30:00',2.13),('8998','2013-09-19','14:35:00',2.06),('8998','2013-09-19','14:40:00',1.99),('8998','2013-09-19','14:45:00',1.97),('8998','2013-09-19','14:50:00',1.96),('8998','2013-09-19','14:55:00',1.91),('8998','2013-09-19','15:00:00',1.63),('8998','2013-09-19','15:10:00',1.6),('8998','2013-09-19','15:15:00',1.27),('8998','2013-09-19','15:20:00',1.34),('8998','2013-09-19','15:45:00',1.28),('8998','2013-09-19','15:50:00',1.21),('8998','2013-09-19','15:55:00',1.22),('8998','2013-09-19','16:10:00',1.08),('8998','2013-09-19','16:15:00',1.06),('8998','2013-09-18','08:30:00',1.43),('8998','2013-09-18','08:35:00',1.53),('8998','2013-09-18','08:45:00',1.48),('8998','2013-09-18','08:50:00',1.07),('8998','2013-09-18','09:00:00',1.02),('8998','2013-09-18','09:10:00',1.27),('8998','2013-09-18','09:15:00',1.81),('8998','2013-09-18','10:05:00',1.41),('8998','2013-09-18','10:10:00',2.16),('8998','2013-09-18','10:15:00',2.34),('8998','2013-09-18','10:20:00',1.07),('8998','2013-09-18','10:35:00',2.01),('8998','2013-09-18','10:40:00',2.72),('8998','2013-09-18','10:45:00',1.86),('8998','2013-09-18','10:50:00',1.31),('8998','2013-09-18','10:55:00',1.73),('8998','2013-09-18','11:00:00',2.98),('8998','2013-09-18','11:05:00',2.69),('8998','2013-09-18','11:10:00',1.07),('8998','2013-09-18','11:15:00',1.48),('8998','2013-09-18','11:20:00',1.72),('8998','2013-09-18','11:25:00',1.1),('8998','2013-09-18','11:30:00',3.22),('8998','2013-09-18','11:35:00',2.15),('8998','2013-09-18','11:40:00',2.72),('8998','2013-09-18','11:45:00',1.78),('8998','2013-09-18','11:50:00',2.78),('8998','2013-09-18','11:55:00',2.66),('8998','2013-09-18','12:00:00',1.9),('8998','2013-09-18','12:05:00',1.26),('8998','2013-09-18','12:10:00',2.25),('8998','2013-09-18','12:15:00',2.64),('8998','2013-09-18','12:20:00',2.26),('8998','2013-09-18','12:25:00',3.09),('8998','2013-09-18','12:30:00',2.99),('8998','2013-09-18','12:35:00',2.71),('8998','2013-09-18','12:40:00',2.67),('8998','2013-09-18','12:45:00',1.16),('8998','2013-09-18','12:50:00',2.74),('8998','2013-09-18','12:55:00',2.71),('8998','2013-09-18','13:00:00',2.73),('8998','2013-09-18','13:05:00',2.69),('8998','2013-09-18','13:10:00',2.78),('8998','2013-09-18','13:15:00',2.58),('8998','2013-09-18','13:20:00',2.45),('8998','2013-09-18','13:25:00',1.39),('8998','2013-09-18','13:30:00',2.52),('8998','2013-09-18','13:35:00',2.61),('8998','2013-09-18','13:40:00',2.62),('8998','2013-09-18','13:45:00',2.34),('8998','2013-09-18','13:50:00',1.02),('8998','2013-09-18','14:05:00',1.59),('8998','2013-09-18','14:10:00',2.04),('8998','2013-09-18','14:15:00',2.16),('8998','2013-09-18','14:20:00',2.1),('8998','2013-09-18','14:25:00',1.92),('8998','2013-09-18','14:30:00',1.96),('8998','2013-09-18','14:35:00',1.91),('8998','2013-09-18','14:40:00',1.86),('8998','2013-09-18','14:45:00',1.83),('8998','2013-09-18','14:50:00',1.77),('8998','2013-09-18','14:55:00',1.4),('8998','2013-09-18','15:00:00',1.78),('8998','2013-09-18','15:05:00',1.67),('8998','2013-09-18','15:10:00',1.43),('8998','2013-09-18','15:15:00',1.4),('8998','2013-09-18','15:20:00',1.54),('8998','2013-09-18','15:25:00',1.42),('8998','2013-09-18','15:30:00',1.14),('8998','2013-09-18','15:40:00',1.19),('8998','2013-09-18','15:45:00',1.21),('8998','2013-09-18','15:50:00',1.14),('8998','2014-04-12','09:10:00',1.27),('8998','2014-04-12','09:15:00',1.07),('8998','2014-04-12','09:20:00',1.16),('8998','2014-04-12','09:25:00',1.48),('8998','2014-04-12','09:30:00',1.65),('8998','2014-04-12','09:35:00',1.14),('8998','2014-04-12','09:40:00',1.58),('8998','2014-04-12','09:45:00',1.39),('8998','2014-04-12','09:50:00',1.34),('8998','2014-04-12','09:55:00',1.29),('8998','2014-04-12','10:00:00',2.35),('8998','2014-04-12','10:05:00',2.8),('8998','2014-04-12','10:10:00',1.53),('8998','2014-04-12','10:15:00',2.09),('8998','2014-04-12','10:20:00',2.42),('8998','2014-04-12','10:25:00',1.33),('8998','2014-04-12','10:30:00',3.1),('8998','2014-04-12','10:35:00',2.94),('8998','2014-04-12','10:40:00',2.86),('8998','2014-04-12','10:45:00',2.95),('8998','2014-04-12','10:50:00',2.93),('8998','2014-04-12','10:55:00',2.91),('8998','2014-04-12','11:00:00',2.94),('8998','2014-04-12','11:05:00',2.97),('8998','2014-04-12','11:10:00',2.9),('8998','2014-04-12','11:15:00',3.18),('8998','2014-04-12','11:20:00',3.55),('8998','2014-04-12','11:25:00',1.94),('8998','2014-04-12','11:30:00',1.51),('8998','2014-04-12','11:35:00',2.98),('8998','2014-04-12','11:40:00',2.64),('8998','2014-04-12','11:45:00',2.74),('8998','2014-04-12','11:50:00',2.57),('8998','2014-04-12','11:55:00',2.13),('8998','2014-04-12','12:00:00',1.79),('8998','2014-04-12','12:05:00',1.17),('8998','2014-04-12','12:10:00',1.04),('8998','2014-04-12','13:10:00',1.39),('8998','2014-04-12','13:15:00',1.27),('8998','2014-04-12','13:20:00',1.54),('8998','2014-04-12','13:25:00',2.14),('8998','2014-04-12','13:30:00',2.83),('8998','2014-04-12','13:35:00',2.56),('8998','2014-04-12','13:40:00',2.56),('8998','2014-04-12','13:45:00',1.33),('8998','2014-04-12','13:50:00',2.11),('8998','2014-04-12','13:55:00',2.05),('8998','2014-04-12','14:00:00',2.43),('8998','2014-04-12','14:05:00',1.8),('8998','2014-04-12','14:10:00',2.44),('8998','2014-04-12','14:15:00',2.31),('8998','2014-04-12','14:20:00',1.15),('8998','2014-04-12','14:45:00',1.39),('8998','2014-04-12','14:50:00',1.41),('8998','2014-04-12','14:55:00',1.1),('8998','2014-04-12','15:00:00',1.87),('8998','2014-04-12','15:05:00',1.97),('8998','2014-04-12','15:10:00',2.07),('8998','2014-04-12','15:15:00',1.88),('8998','2014-04-12','15:20:00',1.85),('8998','2014-04-12','15:25:00',1.81),('8998','2014-04-12','15:30:00',1.79),('8998','2014-04-12','15:35:00',1.26),('8998','2014-04-12','15:50:00',1.2),('8998','2014-04-12','15:55:00',1.22),('8998','2014-04-12','16:00:00',1.78),('8998','2014-04-12','16:05:00',1.3),('8998','2014-04-12','16:40:00',1.37),('8998','2014-04-12','16:45:00',1.5),('8998','2014-04-12','16:50:00',1.14),('8998','2014-04-12','16:55:00',1.28),('8998','2014-04-12','17:00:00',1.07),('8998','2013-09-17','08:45:00',1.09),('8998','2013-09-17','09:05:00',1.53),('8998','2013-09-17','09:20:00',2.22),('8998','2013-09-17','09:25:00',1.57),('8998','2013-09-17','09:30:00',1.59),('8998','2013-09-17','09:35:00',1.8),('8998','2013-09-17','09:40:00',2.37),('8998','2013-09-17','09:45:00',1.65),('8998','2013-09-17','10:00:00',1.51),('8998','2013-09-17','10:05:00',2.93),('8998','2013-09-17','10:10:00',2.7),('8998','2013-09-17','10:15:00',2.52),('8998','2013-09-17','10:20:00',2.45),('8998','2013-09-17','10:25:00',2.47),('8998','2013-09-17','10:30:00',2.45),('8998','2013-09-17','10:35:00',2.48),('8998','2013-09-17','10:40:00',2.47),('8998','2013-09-17','10:45:00',2.24),('8998','2013-09-17','10:50:00',2.34),('8998','2013-09-17','10:55:00',1.84),('8998','2013-09-17','11:00:00',1.87),('8998','2013-09-17','11:05:00',2.53),('8998','2013-09-17','11:10:00',1.6),('8998','2013-09-17','11:15:00',2.18),('8998','2013-09-17','11:20:00',1.71),('8998','2013-09-17','11:25:00',2.16),('8998','2013-09-17','11:30:00',2.86),('8998','2013-09-17','11:35:00',2.8),('8998','2013-09-17','11:40:00',1.39),('8998','2013-09-17','11:45:00',1.48),('8998','2013-09-17','11:50:00',2.59),('8998','2013-09-17','11:55:00',2.85),('8998','2013-09-17','12:00:00',2.82),('8998','2013-09-17','12:05:00',2.02),('8998','2013-09-17','12:10:00',2.87),('8998','2013-09-17','12:15:00',2.89),('8998','2013-09-17','12:20:00',2.76),('8998','2013-09-17','12:25:00',2.78),('8998','2013-09-17','12:30:00',2.56),('8998','2013-09-17','12:35:00',1.41),('8998','2013-09-17','12:40:00',3),('8998','2013-09-17','12:45:00',2.65),('8998','2013-09-17','12:50:00',2.77),('8998','2013-09-17','12:55:00',2.72),('8998','2013-09-17','13:00:00',2.68),('8998','2013-09-17','13:05:00',1.46),('8998','2013-09-17','13:10:00',2.67),('8998','2013-09-17','13:15:00',1.51),('8998','2013-09-17','13:20:00',2.66),('8998','2013-09-17','13:25:00',2.43),('8998','2013-09-17','13:30:00',2.57),('8998','2013-09-17','13:35:00',2.47),('8998','2013-09-17','13:40:00',2.4),('8998','2013-09-17','13:45:00',2.38),('8998','2013-09-17','13:50:00',2.15),('8998','2013-09-17','13:55:00',1.7),('8998','2013-09-17','14:00:00',2.35),('8998','2013-09-17','14:05:00',2.12),('8998','2013-09-17','14:10:00',2.21),('8998','2013-09-17','14:15:00',2.17),('8998','2013-09-17','14:20:00',2.13),('8998','2013-09-17','14:25:00',2.07),('8998','2013-09-17','14:30:00',1.99),('8998','2013-09-17','14:35:00',1.95),('8998','2013-09-17','14:40:00',1.91),('8998','2013-09-17','14:45:00',1.83),('8998','2013-09-17','14:50:00',1.79),('8998','2013-09-17','14:55:00',1.77),('8998','2013-09-17','15:00:00',1.68),('8998','2013-09-17','15:05:00',1.64),('8998','2013-09-17','15:15:00',1.15),('8998','2013-09-17','15:20:00',1.54),('8998','2013-09-17','15:25:00',1.52),('8998','2013-09-17','15:30:00',1.47),('8998','2013-09-17','15:35:00',1.4),('8998','2013-09-17','15:40:00',1.41),('8998','2013-09-17','15:45:00',1.16),('8998','2013-09-17','16:10:00',1.08),('8998','2013-09-16','09:40:00',1.13),('8998','2013-09-16','09:45:00',2.11),('8998','2013-09-16','09:50:00',1.23),('8998','2013-09-16','09:55:00',1.09),('8998','2013-09-16','10:00:00',1.82),('8998','2013-09-16','10:05:00',1.39),('8998','2013-09-16','10:10:00',1.62),('8998','2013-09-16','10:25:00',1.66),('8998','2013-09-16','10:30:00',2.48),('8998','2013-09-16','10:35:00',1.33),('8998','2013-09-16','10:40:00',1.49),('8998','2013-09-16','10:45:00',1.91),('8998','2013-09-16','10:50:00',3.03),('8998','2013-09-16','10:55:00',2.09),('8998','2013-09-16','11:00:00',1.51),('8998','2013-09-16','11:05:00',1.22),('8998','2013-09-16','11:10:00',2.54),('8998','2013-09-16','11:15:00',2.12),('8998','2013-09-16','11:20:00',1.79),('8998','2013-09-16','11:25:00',1.35),('8998','2013-09-16','11:30:00',1.3),('8998','2013-09-16','11:35:00',2.42),('8998','2013-09-16','11:40:00',2.77),('8998','2013-09-16','11:45:00',2.65),('8998','2013-09-16','11:50:00',2.36),('8998','2013-09-16','11:55:00',2.09),('8998','2013-09-16','12:00:00',2.52),('8998','2013-09-16','12:05:00',2.3),('8998','2013-09-16','12:10:00',1.24),('8998','2013-09-16','12:15:00',1.64),('8998','2013-09-16','12:20:00',1.5),('8998','2013-09-16','12:25:00',2.74),('8998','2013-09-16','12:30:00',2.48),('8998','2013-09-16','12:35:00',1.49),('8998','2013-09-16','12:40:00',2.35),('8998','2013-09-16','12:45:00',2.32),('8998','2013-09-16','12:50:00',2.03),('8998','2013-09-16','12:55:00',1.59),('8998','2013-09-16','13:00:00',1.86),('8998','2013-09-16','13:05:00',1.01),('8998','2013-09-16','13:10:00',1.48),('8998','2013-09-16','13:15:00',2.23),('8998','2013-09-16','13:20:00',1.54),('8998','2013-09-16','13:25:00',1.39),('8998','2013-09-16','13:30:00',1.2),('8998','2013-09-16','13:35:00',1.18),('8998','2013-09-16','13:40:00',1.73),('8998','2013-09-16','13:45:00',1.24),('8998','2013-09-16','14:00:00',1.15),('8998','2013-09-16','14:25:00',1.17),('8998','2013-09-16','14:55:00',1.76),('8998','2013-09-16','15:00:00',1.93),('8998','2013-09-16','15:05:00',1.5),('8998','2013-09-16','15:10:00',1.45),('8998','2013-09-16','15:15:00',1.33),('8998','2013-09-16','15:20:00',1.51),('8998','2013-09-16','15:25:00',1.49),('8998','2013-09-16','15:30:00',1.23),('8998','2013-09-16','15:50:00',1.06),('8998','2013-09-16','15:55:00',1.22),('8998','2013-09-16','16:05:00',1.02),('8998','2013-09-15','08:20:00',1.01),('8998','2013-09-15','08:25:00',1.29),('8998','2013-09-15','08:30:00',1.14),('8998','2013-09-15','08:35:00',1.41),('8998','2013-09-15','08:40:00',1.64),('8998','2013-09-15','08:50:00',1.37),('8998','2013-09-15','08:55:00',1.1),('8998','2013-09-15','09:05:00',1.73),('8998','2013-09-15','09:10:00',2.07),('8998','2013-09-15','09:15:00',1.76),('8998','2013-09-15','09:20:00',1.77),('8998','2013-09-15','09:25:00',2.03),('8998','2013-09-15','09:30:00',1.99),('8998','2013-09-15','09:35:00',2.18),('8998','2013-09-15','09:40:00',2.2),('8998','2013-09-15','09:45:00',2.23),('8998','2013-09-15','09:50:00',2.31),('8998','2013-09-15','09:55:00',2.36),('8998','2013-09-15','10:00:00',2.39),('8998','2013-09-15','10:05:00',2.43),('8998','2013-09-15','10:10:00',2.48),('8998','2013-09-15','10:15:00',1.24),('8998','2013-09-15','10:20:00',1.68),('8998','2013-09-15','10:25:00',1.43),('8998','2013-09-15','10:30:00',2.39),('8998','2013-09-15','10:35:00',2.92),('8998','2013-09-15','10:40:00',2.71),('8998','2013-09-15','10:45:00',3.17),('8998','2013-09-15','10:50:00',1.53),('8998','2013-09-15','11:05:00',2.04),('8998','2013-09-15','11:10:00',1.52),('8998','2013-09-15','11:15:00',1.39),('8998','2013-09-15','11:20:00',1.85),('8998','2013-09-15','11:25:00',1.2),('8998','2013-09-15','11:30:00',2.92),('8998','2013-09-15','11:35:00',2.89),('8998','2013-09-15','11:40:00',2.91),('8998','2013-09-15','11:45:00',1.66),('8998','2013-09-15','11:50:00',1.94),('8998','2013-09-15','11:55:00',2.93),('8998','2013-09-15','12:00:00',2.97),('8998','2013-09-15','12:05:00',2.79),('8998','2013-09-15','12:10:00',2.5),('8998','2013-09-15','12:15:00',2.35),('8998','2013-09-15','12:20:00',2.84),('8998','2013-09-15','12:25:00',2.73),('8998','2013-09-15','12:30:00',2.69),('8998','2013-09-15','12:35:00',2.67),('8998','2013-09-15','12:40:00',2.75),('8998','2013-09-15','12:45:00',2.94),('8998','2013-09-15','12:50:00',1.95),('8998','2013-09-15','12:55:00',2.04),('8998','2013-09-15','13:00:00',1.67),('8998','2013-09-15','13:05:00',2.53),('8998','2013-09-15','13:10:00',2.48),('8998','2013-09-15','13:15:00',2.57),('8998','2013-09-15','13:20:00',2.58),('8998','2013-09-15','13:25:00',2.49),('8998','2013-09-15','13:30:00',2.42),('8998','2013-09-15','13:35:00',2.46),('8998','2013-09-15','13:40:00',2.43),('8998','2013-09-15','13:45:00',2.35),('8998','2013-09-15','13:50:00',2.33),('8998','2013-09-15','13:55:00',2.43),('8998','2013-09-15','14:00:00',2.33),('8998','2013-09-15','14:05:00',1.87),('8998','2013-09-15','14:10:00',2.18),('8998','2013-09-15','14:15:00',2.12),('8998','2013-09-15','14:20:00',2.07),('8998','2013-09-15','14:25:00',2.03),('8998','2013-09-15','14:30:00',2),('8998','2013-09-15','14:35:00',1.95),('8998','2013-09-15','14:40:00',1.9),('8998','2013-09-15','14:45:00',1.85),('8998','2013-09-15','14:50:00',1.8),('8998','2013-09-15','14:55:00',1.76),('8998','2013-09-15','15:00:00',1.71),('8998','2013-09-15','15:05:00',1.66),('8998','2013-09-15','15:10:00',1.61),('8998','2013-09-15','15:15:00',1.56),('8998','2013-09-15','15:20:00',1.5),('8998','2013-09-15','15:25:00',1.44),('8998','2013-09-15','15:30:00',1.39),('8998','2013-09-15','15:35:00',1.33),('8998','2013-09-15','15:40:00',1.28),('8998','2013-09-15','15:45:00',1.22),('8998','2013-09-15','15:50:00',1.15),('8998','2013-09-15','15:55:00',1.05),('8998','2013-09-15','16:00:00',1.02),('8998','2013-09-14','08:20:00',1.27),('8998','2013-09-14','08:25:00',1.42),('8998','2013-09-14','08:30:00',1.34),('8998','2013-09-14','08:35:00',1.31),('8998','2013-09-14','08:40:00',1.41),('8998','2013-09-14','08:45:00',1.6),('8998','2013-09-14','08:50:00',1.67),('8998','2013-09-14','08:55:00',1.57),('8998','2013-09-14','09:00:00',1.74),('8998','2013-09-14','09:05:00',1.85),('8998','2013-09-14','09:10:00',2.03),('8998','2013-09-14','09:15:00',2.18),('8998','2013-09-14','09:20:00',2.08),('8998','2013-09-14','09:25:00',2.15),('8998','2013-09-14','09:30:00',2.18),('8998','2013-09-14','09:35:00',2.27),('8998','2013-09-14','09:40:00',2.3),('8998','2013-09-14','09:45:00',2.28),('8998','2013-09-14','09:50:00',2.35),('8998','2013-09-14','09:55:00',2.35),('8998','2013-09-14','10:00:00',2.43),('8998','2013-09-14','10:05:00',2.46),('8998','2013-09-14','10:10:00',2.44),('8998','2013-09-14','10:15:00',2.32),('8998','2013-09-14','10:20:00',2.41),('8998','2013-09-14','10:25:00',2.47),('8998','2013-09-14','10:30:00',2.29),('8998','2013-09-14','10:35:00',2.11),('8998','2013-09-14','10:40:00',1.17),('8998','2013-09-14','10:55:00',1.88),('8998','2013-09-14','11:00:00',1.76),('8998','2013-09-14','11:05:00',2.88),('8998','2013-09-14','11:10:00',2.09),('8998','2013-09-14','11:15:00',1.13),('8998','2013-09-14','11:35:00',2.03),('8998','2013-09-14','11:40:00',1.08),('8998','2013-09-14','11:50:00',2.06),('8998','2013-09-14','11:55:00',1.45),('8998','2013-09-14','12:25:00',1.12),('8998','2013-09-14','12:30:00',1.21),('8998','2013-09-14','12:35:00',1.12),('8998','2013-09-14','12:40:00',1.11),('8998','2013-09-14','13:45:00',1.52),('8998','2013-09-14','13:50:00',1.67),('8998','2013-09-14','14:00:00',1.14),('8998','2013-09-14','14:05:00',1.14),('8998','2013-09-14','14:10:00',1.02),('8998','2013-09-14','15:15:00',1.45),('8998','2013-09-14','15:20:00',1.35),('8998','2013-09-14','15:25:00',1.04),('8998','2013-09-13','08:20:00',1.15),('8998','2013-09-13','08:25:00',1.4),('8998','2013-09-13','08:30:00',1.41),('8998','2013-09-13','08:35:00',1.52),('8998','2013-09-13','08:40:00',1.65),('8998','2013-09-13','08:45:00',1.72),('8998','2013-09-13','08:50:00',1.76),('8998','2013-09-13','08:55:00',1.81),('8998','2013-09-13','09:00:00',1.87),('8998','2013-09-13','09:05:00',1.97),('8998','2013-09-13','09:10:00',2.05),('8998','2013-09-13','09:15:00',2.1),('8998','2013-09-13','09:20:00',2.14),('8998','2013-09-13','09:25:00',2.18),('8998','2013-09-13','09:30:00',2.23),('8998','2013-09-13','09:35:00',2.24),('8998','2013-09-13','09:40:00',2.27),('8998','2013-09-13','09:45:00',2.31),('8998','2013-09-13','09:50:00',2.29),('8998','2013-09-13','09:55:00',2.39),('8998','2013-09-13','10:00:00',2.27),('8998','2013-09-13','10:05:00',1.69),('8998','2013-09-13','10:10:00',2.2),('8998','2013-09-13','10:15:00',2.21),('8998','2013-09-13','10:20:00',2.43),('8998','2013-09-13','10:25:00',2.52),('8998','2013-09-13','10:30:00',2.5),('8998','2013-09-13','10:35:00',2.56),('8998','2013-09-13','10:40:00',2.65),('8998','2013-09-13','10:45:00',2.75),('8998','2013-09-13','10:50:00',2.96),('8998','2013-09-13','10:55:00',2.76),('8998','2013-09-13','11:00:00',2.97),('8998','2013-09-13','11:05:00',1.45),('8998','2013-09-13','11:25:00',1.65),('8998','2013-09-13','11:30:00',2.94),('8998','2013-09-13','11:35:00',2.88),('8998','2013-09-13','11:40:00',2.95),('8998','2013-09-13','11:45:00',2.79),('8998','2013-09-13','11:50:00',2.58),('8998','2013-09-13','11:55:00',2.44),('8998','2013-09-13','12:00:00',1.31),('8998','2013-09-13','12:05:00',2.34),('8998','2013-09-13','12:10:00',1.27),('8998','2013-09-13','12:15:00',1.32),('8998','2013-09-13','12:20:00',1.1),('8998','2013-09-13','12:40:00',2.11),('8998','2013-09-13','13:15:00',2.36),('8998','2013-09-13','13:20:00',2.78),('8998','2013-09-13','13:25:00',2.33),('8998','2013-09-13','13:30:00',2.76),('8998','2013-09-13','13:35:00',1.89),('8998','2013-09-13','13:45:00',1.52),('8998','2013-09-13','13:50:00',1.42),('8998','2013-09-13','13:55:00',2.34),('8998','2013-09-13','14:00:00',2.66),('8998','2013-09-13','14:05:00',2.41),('8998','2013-09-13','14:10:00',2.31),('8998','2013-09-13','14:15:00',2.25),('8998','2013-09-13','14:20:00',2.21),('8998','2013-09-13','14:25:00',2.1),('8998','2013-09-13','14:30:00',2.12),('8998','2013-09-13','14:35:00',2.06),('8998','2013-09-13','14:40:00',1.99),('8998','2013-09-13','14:45:00',1.95),('8998','2013-09-13','14:50:00',1.91),('8998','2013-09-13','14:55:00',1.85),('8998','2013-09-13','15:00:00',1.76),('8998','2013-09-13','15:05:00',1.72),('8998','2013-09-13','15:10:00',1.65),('8998','2013-09-13','15:15:00',1.59),('8998','2013-09-13','15:20:00',1.53),('8998','2013-09-13','15:25:00',1.49),('8998','2013-09-13','15:30:00',1.45),('8998','2013-09-13','15:35:00',1.38),('8998','2013-09-13','15:40:00',1.34),('8998','2013-09-13','15:45:00',1.27),('8998','2013-09-13','15:50:00',1.2),('8998','2013-09-13','15:55:00',1.15),('8998','2013-09-13','16:00:00',1.08),('8998','2013-09-12','09:35:00',1),('8998','2013-09-12','09:40:00',1.22),('8998','2013-09-12','09:45:00',1.11),('8998','2013-09-12','09:50:00',1.15),('8998','2013-09-12','09:55:00',1.55),('8998','2013-09-12','10:00:00',2.43),('8998','2013-09-12','10:05:00',1.36),('8998','2013-09-12','10:10:00',1.64),('8998','2013-09-12','10:15:00',3.1),('8998','2013-09-12','10:20:00',2.74),('8998','2013-09-12','10:25:00',1.37),('8998','2013-09-12','10:30:00',1.71),('8998','2013-09-12','10:35:00',2.9),('8998','2013-09-12','10:40:00',2.67),('8998','2013-09-12','10:45:00',2.65),('8998','2013-09-12','10:50:00',2.65),('8998','2013-09-12','10:55:00',2.66),('8998','2013-09-12','11:00:00',2.68),('8998','2013-09-12','11:05:00',2.68),('8998','2013-09-12','11:10:00',2.7),('8998','2013-09-12','11:15:00',2.71),('8998','2013-09-12','11:20:00',2.69),('8998','2013-09-12','11:25:00',2.71),('8998','2013-09-12','11:30:00',2.7),('8998','2013-09-12','11:35:00',2.72),('8998','2013-09-12','11:40:00',2.72),('8998','2013-09-12','11:45:00',2.72),('8998','2013-09-12','11:50:00',2.73),('8998','2013-09-12','11:55:00',2.71),('8998','2013-09-12','12:00:00',2.71),('8998','2013-09-12','12:05:00',2.74),('8998','2013-09-12','12:10:00',2.74),('8998','2013-09-12','12:15:00',2.73),('8998','2013-09-12','12:20:00',2.73),('8998','2013-09-12','12:25:00',2.73),('8998','2013-09-12','12:30:00',1.42),('8998','2013-09-12','12:35:00',2.76),('8998','2013-09-12','12:40:00',2.74),('8998','2013-09-12','12:45:00',2.71),('8998','2013-09-12','12:50:00',2.69),('8998','2013-09-12','12:55:00',2.63),('8998','2013-09-12','13:00:00',2.6),('8998','2013-09-12','13:05:00',2.59),('8998','2013-09-12','13:10:00',2.56),('8998','2013-09-12','13:15:00',2.53),('8998','2013-09-12','13:20:00',2.5),('8998','2013-09-12','13:25:00',2.47),('8998','2013-09-12','13:30:00',2.43),('8998','2013-09-12','13:35:00',2.39),('8998','2013-09-12','13:40:00',2.36),('8998','2013-09-12','13:45:00',2.34),('8998','2013-09-12','13:50:00',2.31),('8998','2013-09-12','13:55:00',2.28),('8998','2013-09-12','14:00:00',2.25),('8998','2013-09-12','14:05:00',2.22),('8998','2013-09-12','14:10:00',2.18),('8998','2013-09-12','14:15:00',2.14),('8998','2013-09-12','14:20:00',2.1),('8998','2013-09-12','14:25:00',2.08),('8998','2013-09-12','14:30:00',2.05),('8998','2013-09-12','14:35:00',2),('8998','2013-09-12','14:40:00',1.93),('8998','2013-09-12','14:45:00',1.91),('8998','2013-09-12','14:50:00',1.86),('8998','2013-09-12','14:55:00',1.82),('8998','2013-09-12','15:00:00',1.73),('8998','2013-09-12','15:05:00',1.7),('8998','2013-09-12','15:10:00',1.66),('8998','2013-09-12','15:15:00',1.63),('8998','2013-09-12','15:20:00',1.55),('8998','2013-09-12','15:25:00',1.5),('8998','2013-09-12','15:30:00',1.44),('8998','2013-09-12','15:35:00',1.39),('8998','2013-09-12','15:40:00',1.34),('8998','2013-09-12','15:45:00',1.28),('8998','2013-09-12','15:50:00',1.23),('8998','2013-09-12','15:55:00',1.17),('8998','2013-09-12','16:00:00',1.11),('8998','2013-09-12','16:05:00',1.05),('8998','2013-09-11','08:20:00',1.36),('8998','2013-09-11','08:25:00',1.57),('8998','2013-09-11','08:30:00',1.68),('8998','2013-09-11','08:35:00',1.45),('8998','2013-09-11','08:55:00',1.59),('8998','2013-09-11','09:00:00',1.9),('8998','2013-09-11','09:05:00',1.77),('8998','2013-09-11','09:10:00',1.23),('8998','2013-09-11','09:15:00',1.88),('8998','2013-09-11','09:20:00',1.92),('8998','2013-09-11','09:25:00',2.16),('8998','2013-09-11','09:30:00',2.24),('8998','2013-09-11','09:35:00',1.95),('8998','2013-09-11','09:40:00',1.62),('8998','2013-09-11','09:45:00',1.98),('8998','2013-09-11','09:50:00',1.65),('8998','2013-09-11','09:55:00',1.11),('8998','2013-09-11','10:05:00',1.01),('8998','2013-09-11','10:10:00',1.27),('8998','2013-09-11','10:15:00',1.23),('8998','2013-09-11','10:20:00',1.07),('8998','2013-09-11','10:30:00',1.12),('8998','2013-09-11','10:35:00',1.22),('8998','2013-09-11','10:55:00',1.32),('8998','2013-09-11','11:00:00',1.73),('8998','2013-09-11','11:05:00',2.81),('8998','2013-09-11','11:10:00',2.02),('8998','2013-09-11','11:15:00',2.26),('8998','2013-09-11','11:45:00',1.36),('8998','2013-09-11','11:50:00',1.13),('8998','2013-09-11','11:55:00',2.31),('8998','2013-09-11','12:00:00',2.49),('8998','2013-09-11','12:05:00',2.73),('8998','2013-09-11','12:10:00',2.63),('8998','2013-09-11','12:15:00',2.45),('8998','2013-09-11','12:20:00',1.15),('8998','2013-09-11','12:25:00',1.26),('8998','2013-09-11','12:30:00',1.26),('8998','2013-09-11','12:35:00',1.84),('8998','2013-09-11','12:40:00',2.78),('8998','2013-09-11','12:45:00',1.07),('8998','2013-09-11','12:50:00',2.02),('8998','2013-09-11','12:55:00',1.23),('8998','2013-09-11','13:00:00',2.78),('8998','2013-09-11','13:05:00',2.04),('8998','2013-09-11','13:10:00',1.96),('8998','2013-09-11','13:15:00',2.32),('8998','2013-09-11','13:20:00',2.77),('8998','2013-09-11','13:25:00',3.1),('8998','2013-09-11','13:30:00',2.62),('8998','2013-09-11','13:35:00',2.12),('8998','2013-09-11','13:40:00',1.87),('8998','2013-09-11','13:45:00',2.55),('8998','2013-09-11','13:50:00',2.61),('8998','2013-09-11','13:55:00',2.41),('8998','2013-09-11','14:00:00',2.33),('8998','2013-09-11','14:05:00',2.1),('8998','2013-09-11','14:10:00',1.71),('8998','2013-09-11','14:15:00',2.27),('8998','2013-09-11','14:20:00',2.12),('8998','2013-09-11','14:25:00',2.25),('8998','2013-09-11','14:30:00',2.2),('8998','2013-09-11','14:35:00',1.75),('8998','2013-09-11','14:40:00',1.54),('8998','2013-09-11','14:45:00',1.99),('8998','2013-09-11','14:50:00',1.92),('8998','2013-09-11','14:55:00',1.87),('8998','2013-09-11','15:00:00',1.82),('8998','2013-09-11','15:05:00',1.8),('8998','2013-09-11','15:10:00',1.34),('8998','2013-09-11','15:15:00',1.52),('8998','2013-09-11','15:20:00',1.6),('8998','2013-09-11','15:25:00',1.34),('8998','2013-09-11','15:30:00',1.49),('8998','2013-09-11','15:35:00',1.43),('8998','2013-09-11','15:40:00',1.34),('8998','2013-09-11','15:45:00',1.33),('8998','2013-09-11','15:50:00',1.25),('8998','2013-09-11','15:55:00',1.13),('8998','2013-09-11','16:00:00',1.14),('8998','2013-09-10','09:00:00',1.45),('8998','2013-09-10','09:05:00',2.09),('8998','2013-09-10','09:10:00',2.27),('8998','2013-09-10','09:15:00',1.9),('8998','2013-09-10','09:20:00',2.46),('8998','2013-09-10','09:25:00',1.75),('8998','2013-09-10','09:30:00',1.19),('8998','2013-09-10','09:35:00',1.15),('8998','2013-09-10','09:40:00',1.27),('8998','2013-09-10','10:05:00',1.38),('8998','2013-09-10','10:10:00',1.37),('8998','2013-09-10','10:15:00',1.63),('8998','2013-09-10','10:20:00',2.56),('8998','2013-09-10','10:25:00',1.59),('8998','2013-09-10','10:30:00',2.59),('8998','2013-09-10','10:35:00',2.34),('8998','2013-09-10','10:40:00',2.18),('8998','2013-09-10','10:45:00',1.25),('8998','2013-09-10','10:50:00',2.23),('8998','2013-09-10','10:55:00',1.39),('8998','2013-09-10','11:00:00',1.12),('8998','2013-09-10','11:05:00',1.72),('8998','2013-09-10','11:10:00',2.23),('8998','2013-09-10','11:15:00',2.04),('8998','2013-09-10','11:20:00',2.91),('8998','2013-09-10','11:25:00',2.3),('8998','2013-09-10','11:35:00',1.85),('8998','2013-09-10','11:40:00',2.05),('8998','2013-09-10','11:45:00',2.91),('8998','2013-09-10','11:50:00',2.9),('8998','2013-09-10','11:55:00',2.94),('8998','2013-09-10','12:00:00',1.5),('8998','2013-09-10','12:05:00',2.86),('8998','2013-09-10','12:10:00',2.06),('8998','2013-09-10','12:15:00',1.47),('8998','2013-09-10','12:20:00',2.31),('8998','2013-09-10','12:25:00',2.11),('8998','2013-09-10','12:30:00',2.61),('8998','2013-09-10','12:35:00',2.35),('8998','2013-09-10','12:45:00',1.04),('8998','2013-09-10','12:50:00',2.57),('8998','2013-09-10','12:55:00',2.29),('8998','2013-09-10','13:00:00',2.09),('8998','2013-09-10','13:05:00',2.66),('8998','2013-09-10','13:10:00',2.7),('8998','2013-09-10','13:15:00',2.86),('8998','2013-09-10','13:20:00',2.36),('8998','2013-09-10','13:25:00',2.63),('8998','2013-09-10','13:30:00',2.39),('8998','2013-09-10','13:35:00',1.08),('8998','2013-09-10','13:40:00',1.89),('8998','2013-09-10','13:45:00',1.11),('8998','2013-09-10','13:50:00',2.31),('8998','2013-09-10','13:55:00',1.69),('8998','2013-09-10','14:00:00',1.62),('8998','2013-09-10','14:05:00',2.43),('8998','2013-09-10','14:10:00',2.16),('8998','2013-09-10','14:15:00',2.29),('8998','2013-09-10','14:20:00',1.32),('8998','2013-09-10','14:25:00',2.21),('8998','2013-09-10','14:30:00',1.35),('8998','2013-09-10','14:35:00',2),('8998','2013-09-10','14:45:00',1.67),('8998','2013-09-10','14:50:00',2.09),('8998','2013-09-10','14:55:00',1.88),('8998','2013-09-10','15:05:00',2),('8998','2013-09-10','15:15:00',1.7),('8998','2013-09-10','15:20:00',1.44),('8998','2013-09-10','15:25:00',1.59),('8998','2013-09-10','15:30:00',1.49),('8998','2013-09-10','15:45:00',1.46),('8998','2013-09-10','15:50:00',1.38),('8998','2013-09-10','15:55:00',1.01),('8998','2013-09-10','16:00:00',1.11),('8998','2013-09-10','16:05:00',1.24),('8998','2013-09-10','16:15:00',1.04),('8998','2013-09-09','08:55:00',1.38),('8998','2013-09-09','09:00:00',1.78),('8998','2013-09-09','09:05:00',1.78),('8998','2013-09-09','09:10:00',2.21),('8998','2013-09-09','09:15:00',1.83),('8998','2013-09-09','09:20:00',1.4),('8998','2013-09-09','09:25:00',1.39),('8998','2013-09-09','09:30:00',2.22),('8998','2013-09-09','09:35:00',2.42),('8998','2013-09-09','09:40:00',1.26),('8998','2013-09-09','09:45:00',1.05),('8998','2013-09-09','10:40:00',1.06),('8998','2013-09-09','10:45:00',1.57),('8998','2013-09-09','11:00:00',1.14),('8998','2013-09-09','11:10:00',1.02),('8998','2013-09-09','11:25:00',1.21),('8998','2013-09-09','11:55:00',1.26),('8998','2013-09-09','12:00:00',1.06),('8998','2013-09-09','13:40:00',1.19),('8998','2013-09-09','13:45:00',1.82),('8998','2013-09-09','13:50:00',1.25),('8998','2013-09-09','13:55:00',1.07),('8998','2013-09-09','14:15:00',1.09),('8998','2013-09-09','14:20:00',1.09),('8998','2013-09-09','14:25:00',1.37),('8998','2013-09-09','14:30:00',1.33),('8998','2013-09-09','14:40:00',1.14),('8998','2013-09-09','14:45:00',1.21),('8998','2013-09-09','14:50:00',1.3),('8998','2013-09-09','14:55:00',1.21),('8998','2013-09-09','15:00:00',1.37),('8998','2013-09-09','15:05:00',1.3),('8998','2013-09-09','15:10:00',1.03),('8998','2013-09-09','15:20:00',1.15),('8998','2013-09-09','15:25:00',1.05),('8998','2013-09-09','15:30:00',1.18),('8998','2013-09-09','15:35:00',1.12),('8998','2013-09-08','09:00:00',1.05),('8998','2013-09-08','10:05:00',1.28),('8998','2013-09-08','10:10:00',1.38),('8998','2013-09-08','10:15:00',1.35),('8998','2013-09-08','10:35:00',1.26),('8998','2013-09-08','10:40:00',1.34),('8998','2013-09-08','10:45:00',1.48),('8998','2013-09-08','10:50:00',1.95),('8998','2013-09-08','10:55:00',1.86),('8998','2013-09-08','11:00:00',2.04),('8998','2013-09-08','11:05:00',1.57),('8998','2013-09-08','11:10:00',1.25),('8998','2013-09-08','11:15:00',1.54),('8998','2013-09-08','11:20:00',1.83),('8998','2013-09-08','11:25:00',2.04),('8998','2013-09-08','11:30:00',1.59),('8998','2013-09-08','11:35:00',1.53),('8998','2013-09-08','11:40:00',2.37),('8998','2013-09-08','11:45:00',2.46),('8998','2013-09-08','11:50:00',1.85),('8998','2013-09-08','11:55:00',2.29),('8998','2013-09-08','12:00:00',2.1),('8998','2013-09-08','12:05:00',2.24),('8998','2013-09-08','12:10:00',2.11),('8998','2013-09-08','12:15:00',1.6),('8998','2013-09-08','12:20:00',1.27),('8998','2013-09-08','12:45:00',1.18),('8998','2013-09-08','12:55:00',1.02),('8998','2013-09-08','13:05:00',1.53),('8998','2013-09-08','13:10:00',1.8),('8998','2013-09-08','13:15:00',2.22),('8998','2013-09-08','13:20:00',1.81),('8998','2013-09-08','13:25:00',1.59),('8998','2013-09-08','13:30:00',1.87),('8998','2013-09-08','13:35:00',2.38),('8998','2013-09-08','13:40:00',2.3),('8998','2013-09-08','13:45:00',2.36),('8998','2013-09-08','13:50:00',2.49),('8998','2013-09-08','13:55:00',2.49),('8998','2013-09-08','14:00:00',2.2),('8998','2013-09-08','14:05:00',2.06),('8998','2013-09-08','14:10:00',2.27),('8998','2013-09-08','14:15:00',1.72),('8998','2013-09-08','14:20:00',1.34),('8998','2013-09-08','14:25:00',1.21),('8998','2013-09-08','14:30:00',1.13),('8998','2013-09-08','14:35:00',2.25),('8998','2013-09-08','14:40:00',2.08),('8998','2013-09-08','14:45:00',1.17),('8998','2013-09-08','14:50:00',1.9),('8998','2013-09-08','14:55:00',1.89),('8998','2013-09-08','15:00:00',1.51),('8998','2013-09-08','15:05:00',1.39),('8998','2013-09-08','15:10:00',1.6),('8998','2013-09-08','15:20:00',1.15),('8998','2013-09-08','15:30:00',1.54),('8998','2013-09-08','15:35:00',1.25),('8998','2013-09-08','15:40:00',1.4),('8998','2013-09-08','16:15:00',1.07),('8998','2013-09-08','16:45:00',1.09),('8998','2014-04-11','09:15:00',1.19),('8998','2014-04-11','09:20:00',1.31),('8998','2014-04-11','09:25:00',1.52),('8998','2014-04-11','09:30:00',1.4),('8998','2014-04-11','09:35:00',1.19),('8998','2014-04-11','09:40:00',1.07),('8998','2014-04-11','10:10:00',1.06),('8998','2014-04-11','10:15:00',1.13),('8998','2014-04-11','10:20:00',1.23),('8998','2014-04-11','10:25:00',1.41),('8998','2014-04-11','10:30:00',1.5),('8998','2014-04-11','10:35:00',1.67),('8998','2014-04-11','10:40:00',1.93),('8998','2014-04-11','10:45:00',1.96),('8998','2014-04-11','10:50:00',2.15),('8998','2014-04-11','10:55:00',1.81),('8998','2014-04-11','11:00:00',2.12),('8998','2014-04-11','11:05:00',2.37),('8998','2014-04-11','11:10:00',2.99),('8998','2014-04-11','11:15:00',3.19),('8998','2014-04-11','11:20:00',2.95),('8998','2014-04-11','11:25:00',2.54),('8998','2014-04-11','11:30:00',2.72),('8998','2014-04-11','11:35:00',2.94),('8998','2014-04-11','11:40:00',2.82),('8998','2014-04-11','11:45:00',2.89),('8998','2014-04-11','11:50:00',2.54),('8998','2014-04-11','11:55:00',2.03),('8998','2014-04-11','12:00:00',2.14),('8998','2014-04-11','12:05:00',1.15),('8998','2014-04-11','12:10:00',2.16),('8998','2014-04-11','12:15:00',2.03),('8998','2014-04-11','12:20:00',1.55),('8998','2014-04-11','12:25:00',1.8),('8998','2014-04-11','12:30:00',1.86),('8998','2014-04-11','12:35:00',1.81),('8998','2014-04-11','12:40:00',1.99),('8998','2014-04-11','12:45:00',2.33),('8998','2014-04-11','12:50:00',2.05),('8998','2014-04-11','12:55:00',1.08),('8998','2014-04-11','13:00:00',1.03),('8998','2014-04-11','13:05:00',1.23),('8998','2014-04-11','13:10:00',2.27),('8998','2014-04-11','13:15:00',2.69),('8998','2014-04-11','13:20:00',2.85),('8998','2014-04-11','13:25:00',2.53),('8998','2014-04-11','13:30:00',2.96),('8998','2014-04-11','13:35:00',2.1),('8998','2014-04-11','13:40:00',1.73),('8998','2014-04-11','13:50:00',1.9),('8998','2014-04-11','13:55:00',1.35),('8998','2014-04-11','14:05:00',1.51),('8998','2014-04-11','14:10:00',2.08),('8998','2014-04-11','14:15:00',2.65),('8998','2014-04-11','14:20:00',1.83),('8998','2014-04-11','14:25:00',2.28),('8998','2014-04-11','14:30:00',2.02),('8998','2014-04-11','14:35:00',1.59),('8998','2014-04-11','14:40:00',1.3),('8998','2014-04-11','14:45:00',1.08),('8998','2014-04-11','14:50:00',1.78),('8998','2014-04-11','14:55:00',2.29),('8998','2014-04-11','15:00:00',1.77),('8998','2014-04-11','15:05:00',1.86),('8998','2014-04-11','15:10:00',1.91),('8998','2014-04-11','15:15:00',1.74),('8998','2014-04-11','15:20:00',1.62),('8998','2014-04-11','15:25:00',1.5),('8998','2014-04-11','15:35:00',1.28),('8998','2014-04-11','15:40:00',1.47),('8998','2014-04-11','15:45:00',1.52),('8998','2014-04-11','15:50:00',1.63),('8998','2014-04-11','15:55:00',1.57),('8998','2014-04-11','16:00:00',1.51),('8998','2014-04-11','16:05:00',1.46),('8998','2014-04-11','16:10:00',1.43),('8998','2014-04-11','16:15:00',1.32),('8998','2014-04-11','16:20:00',1.38),('8998','2014-04-11','16:25:00',1.27),('8998','2014-04-11','16:30:00',1.18),('8998','2014-04-11','16:35:00',1.08),('8998','2013-09-07','11:35:00',2.46),('8998','2013-09-07','11:40:00',2.48),('8998','2013-09-07','11:45:00',2.46),('8998','2013-09-07','11:50:00',2.42),('8998','2013-09-07','11:55:00',2.4),('8998','2013-09-07','12:00:00',2.38),('8998','2013-09-07','12:05:00',2.37),('8998','2013-09-07','12:10:00',2.4),('8998','2013-09-07','12:15:00',2.49),('8998','2013-09-07','12:20:00',2.5),('8998','2013-09-07','12:25:00',2.4),('8998','2013-09-07','12:30:00',2.41),('8998','2013-09-07','12:35:00',2.47),('8998','2013-09-07','12:40:00',2.37),('8998','2013-09-07','12:45:00',2.3),('8998','2013-09-07','12:50:00',2.33),('8998','2013-09-07','12:55:00',2.33),('8998','2013-09-07','13:00:00',2.29),('8998','2013-09-07','13:05:00',2.32),('8998','2013-09-07','13:10:00',2.34),('8998','2013-09-07','13:15:00',2.25),('8998','2013-09-07','13:20:00',2.2),('8998','2013-09-07','13:25:00',2.09),('8998','2013-09-07','13:30:00',1.96),('8998','2013-09-07','13:35:00',1.97),('8998','2013-09-07','13:40:00',1.52),('8998','2013-09-07','13:45:00',1.3),('8998','2013-09-07','13:50:00',1.47),('8998','2013-09-07','13:55:00',1.57),('8998','2013-09-07','14:00:00',1.94),('8998','2013-09-07','14:05:00',1.97),('8998','2013-09-07','14:10:00',2.06),('8998','2013-09-07','14:15:00',1.9),('8998','2013-09-07','14:20:00',1.75),('8998','2013-09-07','14:25:00',2.26),('8998','2013-09-07','14:30:00',1.91),('8998','2013-09-07','14:35:00',2.04),('8998','2013-09-07','14:40:00',1.91),('8998','2013-09-07','14:45:00',1.87),('8998','2013-09-07','14:50:00',1.82),('8998','2013-09-07','14:55:00',1.75),('8998','2013-09-07','15:00:00',1.71),('8998','2013-09-07','15:05:00',1.45),('8998','2013-09-07','15:15:00',1.27),('8998','2013-09-07','15:20:00',1.58),('8998','2013-09-07','15:25:00',1.6),('8998','2013-09-07','15:30:00',1.56),('8998','2013-09-07','15:35:00',1.46),('8998','2013-09-07','15:40:00',1.32),('8998','2013-09-07','15:45:00',1.31),('8998','2013-09-07','15:50:00',1.29),('8998','2013-09-07','15:55:00',1.02),('8998','2013-09-07','16:00:00',1.01),('8998','2014-04-10','08:30:00',1.38),('8998','2014-04-10','08:35:00',1.42),('8998','2014-04-10','08:40:00',1.47),('8998','2014-04-10','08:45:00',1.68),('8998','2014-04-10','08:50:00',1.91),('8998','2014-04-10','08:55:00',2.08),('8998','2014-04-10','09:00:00',2.12),('8998','2014-04-10','09:05:00',2.16),('8998','2014-04-10','09:10:00',2.19),('8998','2014-04-10','09:15:00',2.2),('8998','2014-04-10','09:20:00',2.25),('8998','2014-04-10','09:25:00',2.36),('8998','2014-04-10','09:30:00',2.41),('8998','2014-04-10','09:35:00',2.45),('8998','2014-04-10','09:40:00',2.47),('8998','2014-04-10','09:45:00',2.49),('8998','2014-04-10','09:50:00',2.52),('8998','2014-04-10','09:55:00',2.56),('8998','2014-04-10','10:00:00',2.59),('8998','2014-04-10','10:05:00',2.64),('8998','2014-04-10','10:10:00',2.67),('8998','2014-04-10','10:15:00',2.73),('8998','2014-04-10','10:20:00',2.72),('8998','2014-04-10','10:25:00',2.73),('8998','2014-04-10','10:30:00',2.77),('8998','2014-04-10','10:35:00',2.77),('8998','2014-04-10','10:40:00',2.78),('8998','2014-04-10','10:45:00',2.8),('8998','2014-04-10','10:50:00',2.84),('8998','2014-04-10','10:55:00',2.86),('8998','2014-04-10','11:00:00',2.89),('8998','2014-04-10','11:05:00',2.89),('8998','2014-04-10','11:10:00',2.9),('8998','2014-04-10','11:15:00',2.88),('8998','2014-04-10','11:20:00',2.87),('8998','2014-04-10','11:25:00',2.98),('8998','2014-04-10','11:30:00',2.96),('8998','2014-04-10','11:35:00',2.98),('8998','2014-04-10','11:40:00',2.91),('8998','2014-04-10','11:45:00',2.94),('8998','2014-04-10','11:50:00',2.95),('8998','2014-04-10','11:55:00',3),('8998','2014-04-10','12:00:00',3.13),('8998','2014-04-10','12:05:00',2.68),('8998','2014-04-10','12:10:00',2.09),('8998','2014-04-10','12:15:00',3.18),('8998','2014-04-10','12:20:00',3),('8998','2014-04-10','12:25:00',1.85),('8998','2014-04-10','12:30:00',3.03),('8998','2014-04-10','12:35:00',3.1),('8998','2014-04-10','12:40:00',1.44),('8998','2014-04-10','12:45:00',3.2),('8998','2014-04-10','12:50:00',3.16),('8998','2014-04-10','12:55:00',3.04),('8998','2014-04-10','13:00:00',2.96),('8998','2014-04-10','13:05:00',1.53),('8998','2014-04-10','13:10:00',1.6),('8998','2014-04-10','13:15:00',2.41),('8998','2014-04-10','13:20:00',2.34),('8998','2014-04-10','13:25:00',2.98),('8998','2014-04-10','13:30:00',1.8),('8998','2014-04-10','13:35:00',1.85),('8998','2014-04-10','13:40:00',2.99),('8998','2014-04-10','13:45:00',2.48),('8998','2014-04-10','13:50:00',2.79),('8998','2014-04-10','13:55:00',1.95),('8998','2014-04-10','14:00:00',2.2),('8998','2014-04-10','14:05:00',2.32),('8998','2014-04-10','14:10:00',2.51),('8998','2014-04-10','14:15:00',2.17),('8998','2014-04-10','14:20:00',1.7),('8998','2014-04-10','14:25:00',2.26),('8998','2014-04-10','14:30:00',2.47),('8998','2014-04-10','14:35:00',2.21),('8998','2014-04-10','14:40:00',2.62),('8998','2014-04-10','14:45:00',2.35),('8998','2014-04-10','14:50:00',2.64),('8998','2014-04-10','14:55:00',2),('8998','2014-04-10','15:00:00',1.53),('8998','2014-04-10','15:05:00',2.12),('8998','2014-04-10','15:10:00',2.18),('8998','2014-04-10','15:15:00',1.96),('8998','2014-04-10','15:20:00',1.74),('8998','2014-04-10','15:25:00',2),('8998','2014-04-10','15:30:00',1.79),('8998','2014-04-10','15:35:00',1.75),('8998','2014-04-10','15:40:00',1.55),('8998','2014-04-10','15:45:00',1.56),('8998','2014-04-10','15:50:00',1.51),('8998','2014-04-10','15:55:00',1.5),('8998','2014-04-10','16:00:00',1.42),('8998','2014-04-10','16:05:00',1.34),('8998','2014-04-10','16:10:00',1.27),('8998','2014-04-10','16:15:00',1.2),('8998','2014-04-10','16:20:00',1.13),('8998','2014-04-10','16:25:00',1.08),('8998','2014-04-10','16:30:00',1.03),('8998','2013-08-27','08:10:00',1.29),('8998','2013-08-27','08:15:00',1.38),('8998','2013-08-27','08:20:00',1.42),('8998','2013-08-27','08:25:00',1.38),('8998','2013-08-27','08:30:00',1.32),('8998','2013-08-27','08:35:00',1.42),('8998','2013-08-27','08:40:00',1.4),('8998','2013-08-27','08:45:00',1.32),('8998','2013-08-27','08:50:00',1.04),('8998','2013-08-27','08:55:00',1.04),('8998','2013-08-27','09:00:00',1.57),('8998','2013-08-27','09:05:00',1.3),('8998','2013-08-27','09:10:00',1.26),('8998','2013-08-27','09:15:00',1.34),('8998','2013-08-27','09:20:00',1.18),('8998','2013-08-27','09:30:00',1.1),('8998','2013-08-27','09:35:00',2.36),('8998','2013-08-27','09:40:00',2.45),('8998','2013-08-27','09:45:00',2.47),('8998','2013-08-27','09:50:00',2.5),('8998','2013-08-27','09:55:00',2.49),('8998','2013-08-27','10:00:00',2.49),('8998','2013-08-27','10:05:00',2.54),('8998','2013-08-27','10:10:00',1.16),('8998','2013-08-27','10:15:00',2.58),('8998','2013-08-27','10:20:00',2.64),('8998','2013-08-27','10:25:00',1.93),('8998','2013-08-27','10:30:00',1.97),('8998','2013-08-27','10:35:00',1.73),('8998','2013-08-27','10:40:00',2.35),('8998','2013-08-27','10:45:00',1.92),('8998','2013-08-27','10:50:00',2.82),('8998','2013-08-27','10:55:00',2.84),('8998','2013-08-27','11:00:00',2.19),('8998','2013-08-27','11:05:00',1.67),('8998','2013-08-27','11:10:00',1.99),('8998','2013-08-27','11:15:00',2.48),('8998','2013-08-27','11:20:00',2.57),('8998','2013-08-27','11:25:00',2.96),('8998','2013-08-27','11:30:00',2.99),('8998','2013-08-27','11:35:00',2.91),('8998','2013-08-27','11:40:00',3.08),('8998','2013-08-27','11:45:00',2.56),('8998','2013-08-27','11:50:00',1.42),('8998','2013-08-27','11:55:00',2.48),('8998','2013-08-27','12:00:00',1.22),('8998','2013-08-27','12:05:00',2.34),('8998','2013-08-27','12:10:00',2.93),('8998','2013-08-27','12:15:00',2.92),('8998','2013-08-27','12:20:00',2.91),('8998','2013-08-27','12:25:00',2.78),('8998','2013-08-27','12:30:00',2.91),('8998','2013-08-27','12:35:00',2.85),('8998','2013-08-27','12:40:00',2.72),('8998','2013-08-27','12:45:00',2.89),('8998','2013-08-27','12:50:00',2.88),('8998','2013-08-27','12:55:00',2.8),('8998','2013-08-27','13:00:00',2.8),('8998','2013-08-27','13:05:00',2.41),('8998','2013-08-27','13:10:00',2.67),('8998','2013-08-27','13:15:00',2.83),('8998','2013-08-27','13:20:00',2.71),('8998','2013-08-27','13:25:00',2.7),('8998','2013-08-27','13:30:00',2.68),('8998','2013-08-27','13:35:00',2.61),('8998','2013-08-27','13:40:00',2.6),('8998','2013-08-27','13:45:00',2.42),('8998','2013-08-27','13:50:00',2.5),('8998','2013-08-27','13:55:00',2.47),('8998','2013-08-27','14:00:00',2.21),('8998','2013-08-27','14:05:00',2.5),('8998','2013-08-27','14:10:00',2.37),('8998','2013-08-27','14:15:00',2.48),('8998','2013-08-27','14:20:00',2.37),('8998','2013-08-27','14:25:00',2.32),('8998','2013-08-27','14:30:00',2.2),('8998','2013-08-27','14:35:00',1.74),('8998','2013-08-27','14:40:00',1.61),('8998','2013-08-27','14:45:00',2.25),('8998','2013-08-27','14:50:00',2.13),('8998','2013-08-27','14:55:00',2.07),('8998','2013-08-27','15:00:00',2),('8998','2013-08-27','15:05:00',1.96),('8998','2013-08-27','15:10:00',1.96),('8998','2013-08-27','15:15:00',1.92),('8998','2013-08-27','15:20:00',1.86),('8998','2013-08-27','15:25:00',1.77),('8998','2013-08-27','15:30:00',1.16),('8998','2013-08-27','15:35:00',1.15),('8998','2013-08-27','15:40:00',1.27),('8998','2013-08-27','15:50:00',1.47),('8998','2013-08-27','15:55:00',1.16),('8998','2013-08-27','16:00:00',1.45),('8998','2013-08-27','16:05:00',1.45),('8998','2013-08-27','16:10:00',1.44),('8998','2013-08-27','16:15:00',1.26),('8998','2013-08-27','16:25:00',1.26),('8998','2013-08-27','16:30:00',1.12),('8998','2013-08-26','08:20:00',1.05),('8998','2013-08-26','08:25:00',1.38),('8998','2013-08-26','08:30:00',1.41),('8998','2013-08-26','08:35:00',1.03),('8998','2013-08-26','08:45:00',1.15),('8998','2013-08-26','09:10:00',1.14),('8998','2013-08-26','09:15:00',1.18),('8998','2013-08-26','09:20:00',1.31),('8998','2013-08-26','09:25:00',1.76),('8998','2013-08-26','09:30:00',2.04),('8998','2013-08-26','09:35:00',1.2),('8998','2013-08-26','09:55:00',1.26),('8998','2013-08-26','10:00:00',1.69),('8998','2013-08-26','10:05:00',2.05),('8998','2013-08-26','10:10:00',2.47),('8998','2013-08-26','10:15:00',2.52),('8998','2013-08-26','10:20:00',2.61),('8998','2013-08-26','10:25:00',2.61),('8998','2013-08-26','10:30:00',2.61),('8998','2013-08-26','10:35:00',2.65),('8998','2013-08-26','10:40:00',2.58),('8998','2013-08-26','10:45:00',2.65),('8998','2013-08-26','10:50:00',2.68),('8998','2013-08-26','10:55:00',2.65),('8998','2013-08-26','11:00:00',2.67),('8998','2013-08-26','11:05:00',2.72),('8998','2013-08-26','11:10:00',2.68),('8998','2013-08-26','11:15:00',2.66),('8998','2013-08-26','11:20:00',2.51),('8998','2013-08-26','11:25:00',2.66),('8998','2013-08-26','11:30:00',2.68),('8998','2013-08-26','11:35:00',2.67),('8998','2013-08-26','11:40:00',2.55),('8998','2013-08-26','11:45:00',2.97),('8998','2013-08-26','11:50:00',2.7),('8998','2013-08-26','11:55:00',2.83),('8998','2013-08-26','12:00:00',2.92),('8998','2013-08-26','12:05:00',2.95),('8998','2013-08-26','12:10:00',2.42),('8998','2013-08-26','12:15:00',2.41),('8998','2013-08-26','12:20:00',2.66),('8998','2013-08-26','12:25:00',2.53),('8998','2013-08-26','12:30:00',2.66),('8998','2013-08-26','12:35:00',2.89),('8998','2013-08-26','12:40:00',2.6),('8998','2013-08-26','12:45:00',2.12),('8998','2013-08-26','12:50:00',1.67),('8998','2013-08-26','12:55:00',1.54),('8998','2013-08-26','13:00:00',1.1),('8998','2013-08-26','13:05:00',1.21),('8998','2013-08-26','13:10:00',1.71),('8998','2013-08-26','13:15:00',1.25),('8998','2013-08-26','13:20:00',1.24),('8998','2013-08-26','13:25:00',1.31),('8998','2013-08-26','13:30:00',1.69),('8998','2013-08-26','13:35:00',1.35),('8998','2013-08-26','13:40:00',1.34),('8998','2013-08-26','13:45:00',1.45),('8998','2013-08-26','13:50:00',2.63),('8998','2013-08-26','13:55:00',2.03),('8998','2013-08-26','14:00:00',2.24),('8998','2013-08-26','14:05:00',1.52),('8998','2013-08-26','14:10:00',1.3),('8998','2013-08-26','14:15:00',2.14),('8998','2013-08-26','14:20:00',1.7),('8998','2013-08-26','14:25:00',1),('8998','2013-08-26','16:10:00',1.57),('8998','2013-08-26','16:15:00',1.6),('8998','2013-08-26','17:10:00',1.01),('8998','2013-08-25','08:05:00',1.34),('8998','2013-08-25','08:10:00',1.25),('8998','2013-08-25','08:20:00',1.44),('8998','2013-08-25','08:25:00',1.22),('8998','2013-08-25','08:30:00',1.67),('8998','2013-08-25','08:35:00',1.4),('8998','2013-08-25','08:40:00',1.56),('8998','2013-08-25','08:45:00',1.46),('8998','2013-08-25','08:50:00',1.65),('8998','2013-08-25','08:55:00',1.9),('8998','2013-08-25','09:00:00',1.94),('8998','2013-08-25','09:05:00',1.96),('8998','2013-08-25','09:10:00',2.03),('8998','2013-08-25','09:15:00',2.09),('8998','2013-08-25','09:20:00',2.15),('8998','2013-08-25','09:25:00',2.18),('8998','2013-08-25','09:30:00',2.23),('8998','2013-08-25','09:35:00',2.26),('8998','2013-08-25','09:40:00',2.31),('8998','2013-08-25','09:45:00',2.36),('8998','2013-08-25','09:50:00',2.39),('8998','2013-08-25','09:55:00',2.41),('8998','2013-08-25','10:00:00',2.43),('8998','2013-08-25','10:05:00',2.47),('8998','2013-08-25','10:10:00',2.49),('8998','2013-08-25','10:15:00',2.5),('8998','2013-08-25','10:20:00',2.56),('8998','2013-08-25','10:25:00',2.61),('8998','2013-08-25','10:30:00',2.61),('8998','2013-08-25','10:35:00',2.62),('8998','2013-08-25','10:40:00',2.63),('8998','2013-08-25','10:45:00',2.65),('8998','2013-08-25','10:50:00',2.65),('8998','2013-08-25','10:55:00',2.71),('8998','2013-08-25','11:00:00',2.7),('8998','2013-08-25','11:05:00',2.71),('8998','2013-08-25','11:10:00',2.71),('8998','2013-08-25','11:15:00',2.73),('8998','2013-08-25','11:20:00',2.74),('8998','2013-08-25','11:25:00',2.72),('8998','2013-08-25','11:30:00',2.72),('8998','2013-08-25','11:35:00',2.76),('8998','2013-08-25','11:40:00',2.76),('8998','2013-08-25','11:45:00',2.74),('8998','2013-08-25','11:50:00',2.73),('8998','2013-08-25','11:55:00',2.73),('8998','2013-08-25','12:00:00',2.75),('8998','2013-08-25','12:05:00',2.74),('8998','2013-08-25','12:10:00',2.74),('8998','2013-08-25','12:15:00',2.74),('8998','2013-08-25','12:20:00',2.72),('8998','2013-08-25','12:25:00',2.68),('8998','2013-08-25','12:30:00',2.66),('8998','2013-08-25','12:35:00',2.65),('8998','2013-08-25','12:40:00',2.66),('8998','2013-08-25','12:45:00',2.66),('8998','2013-08-25','12:50:00',2.66),('8998','2013-08-25','12:55:00',2.64),('8998','2013-08-25','13:00:00',2.74),('8998','2013-08-25','13:05:00',3.04),('8998','2013-08-25','13:10:00',2.71),('8998','2013-08-25','13:15:00',1.85),('8998','2013-08-25','13:20:00',2.01),('8998','2013-08-25','13:25:00',1.82),('8998','2013-08-25','13:30:00',1.83),('8998','2013-08-25','13:35:00',2.42),('8998','2013-08-25','13:40:00',2.46),('8998','2013-08-25','13:45:00',2.43),('8998','2013-08-25','13:50:00',2.49),('8998','2013-08-25','13:55:00',1.97),('8998','2013-08-25','14:00:00',1.88),('8998','2013-08-25','14:05:00',2.35),('8998','2013-08-25','14:10:00',1.41),('8998','2013-08-25','14:15:00',2.38),('8998','2013-08-25','14:20:00',2.23),('8998','2013-08-25','14:25:00',2.16),('8998','2013-08-25','14:30:00',2.14),('8998','2013-08-25','14:35:00',2.06),('8998','2013-08-25','14:40:00',1.86),('8998','2013-08-25','14:45:00',1.48),('8998','2013-08-25','14:50:00',1.19),('8998','2013-08-25','14:55:00',1.08),('8998','2013-08-25','15:00:00',1.07),('8998','2013-08-25','15:45:00',1.06),('8998','2013-08-25','15:50:00',1.01),('8998','2013-08-25','16:00:00',1.13),('8998','2013-08-25','16:05:00',1.64),('8998','2013-08-25','16:10:00',1.33),('8998','2013-08-25','16:15:00',1.16),('8998','2013-08-25','16:20:00',1.12),('8998','2013-08-25','16:25:00',1.04),('8998','2013-08-24','08:05:00',1.01),('8998','2013-08-24','08:10:00',1.16),('8998','2013-08-24','08:15:00',1.17),('8998','2013-08-24','08:20:00',1.03),('8998','2013-08-24','08:25:00',1.09),('8998','2013-08-24','08:30:00',1.04),('8998','2013-08-24','08:45:00',1.41),('8998','2013-08-24','09:20:00',1.87),('8998','2013-08-24','09:25:00',1.77),('8998','2013-08-24','09:30:00',2.03),('8998','2013-08-24','09:35:00',1.63),('8998','2013-08-24','09:40:00',2.59),('8998','2013-08-24','09:45:00',2.78),('8998','2013-08-24','09:50:00',2.5),('8998','2013-08-24','09:55:00',2.73),('8998','2013-08-24','10:00:00',1.96),('8998','2013-08-24','10:05:00',1.36),('8998','2013-08-24','15:25:00',1.05),('8998','2013-08-24','15:30:00',1.37),('8998','2013-08-24','15:35:00',1.89),('8998','2013-08-24','15:40:00',1.9),('8998','2013-08-24','15:45:00',1.93),('8998','2013-08-24','15:50:00',1.57),('8998','2013-08-24','16:00:00',1.64),('8998','2013-08-24','16:05:00',1.5),('8998','2013-08-24','16:10:00',1.38),('8998','2013-08-24','16:15:00',1.29),('8998','2013-08-24','16:20:00',1.21),('8998','2013-08-24','16:25:00',1.15),('8998','2013-08-24','16:30:00',1.08),('8998','2013-08-23','08:25:00',1.31),('8998','2013-08-23','08:30:00',1.3),('8998','2013-08-23','08:35:00',1.43),('8998','2013-08-23','08:40:00',1.55),('8998','2013-08-23','08:45:00',1.53),('8998','2013-08-23','08:50:00',1.41),('8998','2013-08-23','08:55:00',1.79),('8998','2013-08-23','09:00:00',1.89),('8998','2013-08-23','09:05:00',1.88),('8998','2013-08-23','09:10:00',1.99),('8998','2013-08-23','09:15:00',1.82),('8998','2013-08-23','09:20:00',2.07),('8998','2013-08-23','09:25:00',1.75),('8998','2013-08-23','09:30:00',1.69),('8998','2013-08-23','09:35:00',1.58),('8998','2013-08-23','09:40:00',2.27),('8998','2013-08-23','09:45:00',1.53),('8998','2013-08-23','09:50:00',1.94),('8998','2013-08-23','09:55:00',2.06),('8998','2013-08-23','10:00:00',2.52),('8998','2013-08-23','10:05:00',2.51),('8998','2013-08-23','10:10:00',2.53),('8998','2013-08-23','10:15:00',2.53),('8998','2013-08-23','10:20:00',2.55),('8998','2013-08-23','10:25:00',2.56),('8998','2013-08-23','10:30:00',2.57),('8998','2013-08-23','10:35:00',2.57),('8998','2013-08-23','10:40:00',2.62),('8998','2013-08-23','10:45:00',2.62),('8998','2013-08-23','10:50:00',2.34),('8998','2013-08-23','10:55:00',2.36),('8998','2013-08-23','11:00:00',2.69),('8998','2013-08-23','11:05:00',2.7),('8998','2013-08-23','11:10:00',2.72),('8998','2013-08-23','11:15:00',2.72),('8998','2013-08-23','11:20:00',2.74),('8998','2013-08-23','11:25:00',2.73),('8998','2013-08-23','11:30:00',2.68),('8998','2013-08-23','11:35:00',2.73),('8998','2013-08-23','11:40:00',2.72),('8998','2013-08-23','11:45:00',2.71),('8998','2013-08-23','11:50:00',2.74),('8998','2013-08-23','11:55:00',2.71),('8998','2013-08-23','12:00:00',2.71),('8998','2013-08-23','12:05:00',2.69),('8998','2013-08-23','12:10:00',2.69),('8998','2013-08-23','12:15:00',2.71),('8998','2013-08-23','12:20:00',2.69),('8998','2013-08-23','12:25:00',2.69),('8998','2013-08-23','12:30:00',2.66),('8998','2013-08-23','12:35:00',2.66),('8998','2013-08-23','12:40:00',2.66),('8998','2013-08-23','12:45:00',2.65),('8998','2013-08-23','12:50:00',2.63),('8998','2013-08-23','12:55:00',2.6),('8998','2013-08-23','13:00:00',2.54),('8998','2013-08-23','13:05:00',2.56),('8998','2013-08-23','13:10:00',2.57),('8998','2013-08-23','13:15:00',2.55),('8998','2013-08-23','13:20:00',2.54),('8998','2013-08-23','13:25:00',2.53),('8998','2013-08-23','13:30:00',2.51),('8998','2013-08-23','13:35:00',2.48),('8998','2013-08-23','13:40:00',2.45),('8998','2013-08-23','13:45:00',2.43),('8998','2013-08-23','13:50:00',2.42),('8998','2013-08-23','13:55:00',2.38),('8998','2013-08-23','14:00:00',2.35),('8998','2013-08-23','14:05:00',2.31),('8998','2013-08-23','14:10:00',2.29),('8998','2013-08-23','14:15:00',2.25),('8998','2013-08-23','14:20:00',2.22),('8998','2013-08-23','14:25:00',2.18),('8998','2013-08-23','14:30:00',2.15),('8998','2013-08-23','14:35:00',2.12),('8998','2013-08-23','14:40:00',2.07),('8998','2013-08-23','14:45:00',2.02),('8998','2013-08-23','14:50:00',1.99),('8998','2013-08-23','14:55:00',1.95),('8998','2013-08-23','15:00:00',1.9),('8998','2013-08-23','15:05:00',1.86),('8998','2013-08-23','15:10:00',1.81),('8998','2013-08-23','15:15:00',1.77),('8998','2013-08-23','15:20:00',1.71),('8998','2013-08-23','15:25:00',1.67),('8998','2013-08-23','15:30:00',1.62),('8998','2013-08-23','15:35:00',1.57),('8998','2013-08-23','15:40:00',1.52),('8998','2013-08-23','15:45:00',1.46),('8998','2013-08-23','15:50:00',1.42),('8998','2013-08-23','15:55:00',1.36),('8998','2013-08-23','16:00:00',1.31),('8998','2013-08-23','16:05:00',1.26),('8998','2013-08-23','16:10:00',1.21),('8998','2013-08-23','16:15:00',1.16),('8998','2013-08-23','16:20:00',1.1),('8998','2013-08-23','16:25:00',1.04),('8998','2013-08-22','08:15:00',1.01),('8998','2013-08-22','08:20:00',1.07),('8998','2013-08-22','08:25:00',1.14),('8998','2013-08-22','08:30:00',1.2),('8998','2013-08-22','08:35:00',1.25),('8998','2013-08-22','08:40:00',1.27),('8998','2013-08-22','08:45:00',1.31),('8998','2013-08-22','08:50:00',1.37),('8998','2013-08-22','08:55:00',1.39),('8998','2013-08-22','09:00:00',1.44),('8998','2013-08-22','09:05:00',1.49),('8998','2013-08-22','09:10:00',1.53),('8998','2013-08-22','09:15:00',1.54),('8998','2013-08-22','09:20:00',1.58),('8998','2013-08-22','09:25:00',1.66),('8998','2013-08-22','09:30:00',1.93),('8998','2013-08-22','09:35:00',1.97),('8998','2013-08-22','09:40:00',2.01),('8998','2013-08-22','09:45:00',2.09),('8998','2013-08-22','09:50:00',2.16),('8998','2013-08-22','09:55:00',2.18),('8998','2013-08-22','10:00:00',2.24),('8998','2013-08-22','10:05:00',2.24),('8998','2013-08-22','10:10:00',2.23),('8998','2013-08-22','10:15:00',2.28),('8998','2013-08-22','10:20:00',2.33),('8998','2013-08-22','10:25:00',2.35),('8998','2013-08-22','10:30:00',2.36),('8998','2013-08-22','10:35:00',2.38),('8998','2013-08-22','10:40:00',2.36),('8998','2013-08-22','10:45:00',2.41),('8998','2013-08-22','10:50:00',2.41),('8998','2013-08-22','10:55:00',2.38),('8998','2013-08-22','11:00:00',2.41),('8998','2013-08-22','11:05:00',2.52),('8998','2013-08-22','11:10:00',2.55),('8998','2013-08-22','11:15:00',2.02),('8998','2013-08-22','11:20:00',1.64),('8998','2013-08-22','11:25:00',2.23),('8998','2013-08-22','11:30:00',2.67),('8998','2013-08-22','11:35:00',1.87),('8998','2013-08-22','11:40:00',1.8),('8998','2013-08-22','11:45:00',2.61),('8998','2013-08-22','11:50:00',2.63),('8998','2013-08-22','11:55:00',2.6),('8998','2013-08-22','12:00:00',2.15),('8998','2013-08-22','12:05:00',1.61),('8998','2013-08-22','12:15:00',1.46),('8998','2013-08-22','13:10:00',1.07),('8998','2013-08-22','13:15:00',1.76),('8998','2013-08-22','13:25:00',1.71),('8998','2013-08-22','13:30:00',2.75),('8998','2013-08-22','13:35:00',2.46),('8998','2013-08-22','13:40:00',1.92),('8998','2013-08-22','13:45:00',2.47),('8998','2013-08-22','13:50:00',1.51),('8998','2013-08-22','13:55:00',2.06),('8998','2013-08-22','14:00:00',2.71),('8998','2013-08-22','14:05:00',2.52),('8998','2013-08-22','14:10:00',2.49),('8998','2013-08-22','14:15:00',2.48),('8998','2013-08-22','14:20:00',2.11),('8998','2013-08-22','14:25:00',1.9),('8998','2013-08-22','14:30:00',2.2),('8998','2013-08-22','14:35:00',2.21),('8998','2013-08-22','14:40:00',2.19),('8998','2013-08-22','14:45:00',2.12),('8998','2013-08-22','14:50:00',2.02),('8998','2013-08-22','14:55:00',1.91),('8998','2013-08-22','15:00:00',1.83),('8998','2013-08-22','15:05:00',1.74),('8998','2013-08-22','15:10:00',1.76),('8998','2013-08-22','15:15:00',1.75),('8998','2013-08-22','15:20:00',1.7),('8998','2013-08-22','15:25:00',1.68),('8998','2013-08-22','15:30:00',1.72),('8998','2013-08-22','15:35:00',1.57),('8998','2013-08-22','15:40:00',1.51),('8998','2013-08-22','15:45:00',1.48),('8998','2013-08-22','15:50:00',1.36),('8998','2013-08-22','15:55:00',1.37),('8998','2013-08-22','16:00:00',1.3),('8998','2013-08-22','16:05:00',1.2),('8998','2013-08-22','16:10:00',1.03),('8998','2013-08-22','16:15:00',1.05),('8998','2013-08-22','16:20:00',1.19),('8998','2013-08-22','16:25:00',1.07),('8998','2013-08-22','16:30:00',1.01),('8998','2013-08-22','16:35:00',1.02),('8998','2013-08-21','08:10:00',1.02),('8998','2013-08-21','08:15:00',1.08),('8998','2013-08-21','08:20:00',1.16),('8998','2013-08-21','08:25:00',1.18),('8998','2013-08-21','08:30:00',1.23),('8998','2013-08-21','08:35:00',1.28),('8998','2013-08-21','08:40:00',1.31),('8998','2013-08-21','08:45:00',1.36),('8998','2013-08-21','08:50:00',1.4),('8998','2013-08-21','08:55:00',1.46),('8998','2013-08-21','09:00:00',1.53),('8998','2013-08-21','09:05:00',1.62),('8998','2013-08-21','09:10:00',1.68),('8998','2013-08-21','09:15:00',1.73),('8998','2013-08-21','09:20:00',1.78),('8998','2013-08-21','09:25:00',1.7),('8998','2013-08-21','09:30:00',1.65),('8998','2013-08-21','09:35:00',1.1),('8998','2013-08-21','09:40:00',1.25),('8998','2013-08-21','09:45:00',1.63),('8998','2013-08-21','09:50:00',1.96),('8998','2013-08-21','09:55:00',2.22),('8998','2013-08-21','10:00:00',2.59),('8998','2013-08-21','10:05:00',2.6),('8998','2013-08-21','10:10:00',2.59),('8998','2013-08-21','10:15:00',2.54),('8998','2013-08-21','10:20:00',2.52),('8998','2013-08-21','10:25:00',2.55),('8998','2013-08-21','10:30:00',2.57),('8998','2013-08-21','10:35:00',2.56),('8998','2013-08-21','10:40:00',2.59),('8998','2013-08-21','10:45:00',2.6),('8998','2013-08-21','10:50:00',2.62),('8998','2013-08-21','10:55:00',2.63),('8998','2013-08-21','11:00:00',2.63),('8998','2013-08-21','11:05:00',2.63),('8998','2013-08-21','11:10:00',2.64),('8998','2013-08-21','11:15:00',2.65),('8998','2013-08-21','11:20:00',2.63),('8998','2013-08-21','11:25:00',2.64),('8998','2013-08-21','11:30:00',2.67),('8998','2013-08-21','11:35:00',2.67),('8998','2013-08-21','11:40:00',2.67),('8998','2013-08-21','11:45:00',2.67),('8998','2013-08-21','11:50:00',2.67),('8998','2013-08-21','11:55:00',2.67),('8998','2013-08-21','12:00:00',2.66),('8998','2013-08-21','12:05:00',2.66),('8998','2013-08-21','12:10:00',2.66),('8998','2013-08-21','12:15:00',2.65),('8998','2013-08-21','12:20:00',2.64),('8998','2013-08-21','12:25:00',2.63),('8998','2013-08-21','12:30:00',2.61),('8998','2013-08-21','12:35:00',2.61),('8998','2013-08-21','12:40:00',2.59),('8998','2013-08-21','12:45:00',2.59),('8998','2013-08-21','12:50:00',2.57),('8998','2013-08-21','12:55:00',2.55),('8998','2013-08-21','13:00:00',2.38),('8998','2013-08-21','13:05:00',2.38),('8998','2013-08-21','13:10:00',2.41),('8998','2013-08-21','13:15:00',2.43),('8998','2013-08-21','13:20:00',2.39),('8998','2013-08-21','13:25:00',2.4),('8998','2013-08-21','13:30:00',2.38),('8998','2013-08-21','13:35:00',2.37),('8998','2013-08-21','13:40:00',2.37),('8998','2013-08-21','13:45:00',2.35),('8998','2013-08-21','13:50:00',2.33),('8998','2013-08-21','13:55:00',2.3),('8998','2013-08-21','14:00:00',2.26),('8998','2013-08-21','14:05:00',2.25),('8998','2013-08-21','14:10:00',2.23),('8998','2013-08-21','14:15:00',2.2),('8998','2013-08-21','14:20:00',2.19),('8998','2013-08-21','14:25:00',2.19),('8998','2013-08-21','14:30:00',2.09),('8998','2013-08-21','14:35:00',2.1),('8998','2013-08-21','14:40:00',1.91),('8998','2013-08-21','14:45:00',2.05),('8998','2013-08-21','14:50:00',1.99),('8998','2013-08-21','14:55:00',1.84),('8998','2013-08-21','15:00:00',1.89),('8998','2013-08-21','15:05:00',1.87),('8998','2013-08-21','15:10:00',1.83),('8998','2013-08-21','15:15:00',1.78),('8998','2013-08-21','15:20:00',1.7),('8998','2013-08-21','15:25:00',1.64),('8998','2013-08-21','15:30:00',1.61),('8998','2013-08-21','15:35:00',1.56),('8998','2013-08-21','15:40:00',1.53),('8998','2013-08-21','15:45:00',1.48),('8998','2013-08-21','15:50:00',1.44),('8998','2013-08-21','15:55:00',1.39),('8998','2013-08-21','16:00:00',1.34),('8998','2013-08-21','16:05:00',1.26),('8998','2013-08-21','16:10:00',1.21),('8998','2013-08-21','16:15:00',1.16),('8998','2013-08-21','16:20:00',1.11),('8998','2013-08-21','16:25:00',1.06),('8998','2013-08-21','16:30:00',1.02),('8998','2013-08-20','09:05:00',1.08),('8998','2013-08-20','09:10:00',1.09),('8998','2013-08-20','09:15:00',1.92),('8998','2013-08-20','09:20:00',2.06),('8998','2013-08-20','09:50:00',2.58),('8998','2013-08-20','09:55:00',2.96),('8998','2013-08-20','10:00:00',2.74),('8998','2013-08-20','10:05:00',2.13),('8998','2013-08-20','10:10:00',1.78),('8998','2013-08-20','10:15:00',2.2),('8998','2013-08-20','10:20:00',1.55),('8998','2013-08-20','10:25:00',1.5),('8998','2013-08-20','10:30:00',1.44),('8998','2013-08-20','10:35:00',2.77),('8998','2013-08-20','10:40:00',2.45),('8998','2013-08-20','10:45:00',2.15),('8998','2013-08-20','10:50:00',1.89),('8998','2013-08-20','10:55:00',1.37),('8998','2013-08-20','11:00:00',1.73),('8998','2013-08-20','11:05:00',1.5),('8998','2013-08-20','11:10:00',1.27),('8998','2013-08-20','11:15:00',1.64),('8998','2013-08-20','11:20:00',2.69),('8998','2013-08-20','11:25:00',2.12),('8998','2013-08-20','11:30:00',2.07),('8998','2013-08-20','11:35:00',2.94),('8998','2013-08-20','11:40:00',3.02),('8998','2013-08-20','11:45:00',2.98),('8998','2013-08-20','11:50:00',2.39),('8998','2013-08-20','11:55:00',2.75),('8998','2013-08-20','12:00:00',2.98),('8998','2013-08-20','12:05:00',2.95),('8998','2013-08-20','12:10:00',2.92),('8998','2013-08-20','12:15:00',2.89),('8998','2013-08-20','12:20:00',2.76),('8998','2013-08-20','12:25:00',1.76),('8998','2013-08-20','12:30:00',2.73),('8998','2013-08-20','12:35:00',2.44),('8998','2013-08-20','12:40:00',2.43),('8998','2013-08-20','12:45:00',2.67),('8998','2013-08-20','12:50:00',2.56),('8998','2013-08-20','12:55:00',2.44),('8998','2013-08-20','13:00:00',2.51),('8998','2013-08-20','13:05:00',2.57),('8998','2013-08-20','13:10:00',2.58),('8998','2013-08-20','13:15:00',2.59),('8998','2013-08-20','13:20:00',2.57),('8998','2013-08-20','13:25:00',2.58),('8998','2013-08-20','13:30:00',2.56),('8998','2013-08-20','13:35:00',2.53),('8998','2013-08-20','13:40:00',2.53),('8998','2013-08-20','13:45:00',2.43),('8998','2013-08-20','13:50:00',2.35),('8998','2013-08-20','13:55:00',2.31),('8998','2013-08-20','14:00:00',2.39),('8998','2013-08-20','14:05:00',2.35),('8998','2013-08-20','14:10:00',2.35),('8998','2013-08-20','14:15:00',2.36),('8998','2013-08-20','14:20:00',2.23),('8998','2013-08-20','14:25:00',1.86),('8998','2013-08-20','14:30:00',1.98),('8998','2013-08-20','14:35:00',1.9),('8998','2013-08-20','14:40:00',1.92),('8998','2013-08-20','14:45:00',1.92),('8998','2013-08-20','14:50:00',1.84),('8998','2013-08-20','14:55:00',1.79),('8998','2013-08-20','15:00:00',1.82),('8998','2013-08-20','15:05:00',1.83),('8998','2013-08-20','15:10:00',1.75),('8998','2013-08-20','15:15:00',1.69),('8998','2013-08-20','15:20:00',1.66),('8998','2013-08-20','15:25:00',1.65),('8998','2013-08-20','15:30:00',1.55),('8998','2013-08-20','15:35:00',1.47),('8998','2013-08-20','15:40:00',1.38),('8998','2013-08-20','15:45:00',1.41),('8998','2013-08-20','15:50:00',1.43),('8998','2013-08-20','15:55:00',1.29),('8998','2013-08-20','16:00:00',1.21),('8998','2013-08-20','16:05:00',1.2),('8998','2013-08-20','16:10:00',1.14),('8998','2013-08-20','16:15:00',1.16),('8998','2013-08-20','16:20:00',1.17),('8998','2013-08-20','16:25:00',1.13),('8998','2013-08-20','16:30:00',1.15),('8998','2013-08-20','16:35:00',1.08),('8998','2013-08-20','16:40:00',1.03),('8998','2013-08-19','09:05:00',1.02),('8998','2013-08-19','09:25:00',1.34),('8998','2013-08-19','09:30:00',2),('8998','2013-08-19','09:35:00',2.08),('8998','2013-08-19','09:40:00',2.4),('8998','2013-08-19','09:45:00',2.5),('8998','2013-08-19','09:50:00',2.39),('8998','2013-08-19','09:55:00',1.48),('8998','2013-08-19','10:00:00',2.97),('8998','2013-08-19','10:05:00',1.42),('8998','2013-08-19','10:10:00',1.55),('8998','2013-08-19','10:15:00',2.05),('8998','2013-08-19','10:20:00',1.44),('8998','2013-08-19','10:25:00',1.1),('8998','2013-08-19','10:50:00',1.57),('8998','2013-08-19','10:55:00',2.07),('8998','2013-08-19','11:20:00',3.08),('8998','2013-08-19','11:25:00',3.06),('8998','2013-08-19','11:30:00',1.34),('8998','2013-08-19','11:40:00',2.56),('8998','2013-08-19','11:45:00',3.05),('8998','2013-08-19','11:50:00',2.12),('8998','2013-08-19','11:55:00',3.26),('8998','2013-08-19','12:00:00',1.7),('8998','2013-08-19','12:40:00',1.17),('8998','2013-08-19','12:45:00',1.25),('8998','2013-08-19','12:50:00',1.33),('8998','2013-08-19','12:55:00',1.34),('8998','2013-08-19','13:00:00',1.31),('8998','2013-08-19','13:05:00',1.17),('8998','2013-08-19','13:10:00',1.1),('8998','2013-08-19','13:15:00',1.1),('8998','2013-08-19','13:20:00',1.14),('8998','2013-08-19','13:25:00',1.22),('8998','2013-08-19','13:30:00',1.33),('8998','2013-08-19','13:35:00',1.61),('8998','2013-08-19','13:40:00',2.42),('8998','2013-08-19','13:45:00',2.32),('8998','2013-08-19','13:50:00',2.63),('8998','2013-08-19','13:55:00',2.58),('8998','2013-08-19','14:00:00',2.51),('8998','2013-08-19','14:05:00',2.48),('8998','2013-08-19','14:10:00',2.41),('8998','2013-08-19','14:15:00',2.37),('8998','2013-08-19','14:20:00',2.36),('8998','2013-08-19','14:25:00',2.24),('8998','2013-08-19','14:30:00',1.81),('8998','2013-08-19','14:35:00',2.14),('8998','2013-08-19','14:40:00',2.13),('8998','2013-08-19','14:45:00',2.08),('8998','2013-08-19','14:50:00',2.2),('8998','2013-08-19','14:55:00',1.85),('8998','2013-08-19','15:00:00',2.21),('8998','2013-08-19','15:05:00',2.12),('8998','2013-08-19','15:10:00',2.2),('8998','2013-08-19','15:15:00',2.09),('8998','2013-08-19','15:20:00',2.03),('8998','2013-08-19','15:25:00',2),('8998','2013-08-19','15:30:00',1.97),('8998','2013-08-19','15:35:00',1.94),('8998','2013-08-19','15:40:00',1.98),('8998','2013-08-19','15:45:00',2.05),('8998','2013-08-19','15:50:00',2.06),('8998','2013-08-19','15:55:00',2.19),('8998','2013-08-19','16:00:00',2),('8998','2013-08-19','16:05:00',1.86),('8998','2013-08-19','16:10:00',1.85),('8998','2013-08-19','16:15:00',1.78),('8998','2013-08-19','16:20:00',1.7),('8998','2013-08-19','16:25:00',1.54),('8998','2013-08-19','16:30:00',1.35),('8998','2013-08-19','16:35:00',1.39),('8998','2013-08-19','16:40:00',1.42),('8998','2013-08-19','16:45:00',1.33),('8998','2013-08-19','16:50:00',1.1),('8998','2014-04-09','08:05:00',1.13),('8998','2014-04-09','08:10:00',1.22),('8998','2014-04-09','08:15:00',1.45),('8998','2014-04-09','08:20:00',1.55),('8998','2014-04-09','08:25:00',1.58),('8998','2014-04-09','08:30:00',1.51),('8998','2014-04-09','08:35:00',1.41),('8998','2014-04-09','08:40:00',1.43),('8998','2014-04-09','08:45:00',1.59),('8998','2014-04-09','08:50:00',1.93),('8998','2014-04-09','08:55:00',2.16),('8998','2014-04-09','09:00:00',2.22),('8998','2014-04-09','09:05:00',2.3),('8998','2014-04-09','09:10:00',2.34),('8998','2014-04-09','09:15:00',2.34),('8998','2014-04-09','09:20:00',2.33),('8998','2014-04-09','09:25:00',2.5),('8998','2014-04-09','09:30:00',2.57),('8998','2014-04-09','09:35:00',2.6),('8998','2014-04-09','09:40:00',2.61),('8998','2014-04-09','09:45:00',2.63),('8998','2014-04-09','09:50:00',2.68),('8998','2014-04-09','09:55:00',2.71),('8998','2014-04-09','10:00:00',2.75),('8998','2014-04-09','10:05:00',2.77),('8998','2014-04-09','10:10:00',2.81),('8998','2014-04-09','10:15:00',2.78),('8998','2014-04-09','10:20:00',2.81),('8998','2014-04-09','10:25:00',2.83),('8998','2014-04-09','10:30:00',2.84),('8998','2014-04-09','10:35:00',2.93),('8998','2014-04-09','10:40:00',2.93),('8998','2014-04-09','10:45:00',2.91),('8998','2014-04-09','10:50:00',2.85),('8998','2014-04-09','10:55:00',2.91),('8998','2014-04-09','11:00:00',2.93),('8998','2014-04-09','11:05:00',2.99),('8998','2014-04-09','11:10:00',2.92),('8998','2014-04-09','11:15:00',3),('8998','2014-04-09','11:20:00',3.07),('8998','2014-04-09','11:25:00',3.09),('8998','2014-04-09','11:30:00',3.04),('8998','2014-04-09','11:35:00',3.07),('8998','2014-04-09','11:40:00',2.96),('8998','2014-04-09','11:45:00',2.99),('8998','2014-04-09','11:50:00',2.87),('8998','2014-04-09','11:55:00',3.01),('8998','2014-04-09','12:00:00',2.95),('8998','2014-04-09','12:05:00',2.75),('8998','2014-04-09','12:10:00',2.86),('8998','2014-04-09','12:15:00',2.89),('8998','2014-04-09','12:20:00',2.88),('8998','2014-04-09','12:25:00',2.78),('8998','2014-04-09','12:30:00',2.82),('8998','2014-04-09','12:35:00',2.91),('8998','2014-04-09','12:40:00',2.88),('8998','2014-04-09','12:45:00',2.87),('8998','2014-04-09','12:50:00',2.81),('8998','2014-04-09','12:55:00',2.76),('8998','2014-04-09','13:00:00',2.7),('8998','2014-04-09','13:05:00',2.58),('8998','2014-04-09','13:10:00',2.59),('8998','2014-04-09','13:15:00',2.61),('8998','2014-04-09','13:20:00',2.59),('8998','2014-04-09','13:25:00',2.75),('8998','2014-04-09','13:30:00',2.68),('8998','2014-04-09','13:35:00',2.72),('8998','2014-04-09','13:40:00',2.52),('8998','2014-04-09','13:45:00',2.66),('8998','2014-04-09','13:50:00',2.6),('8998','2014-04-09','13:55:00',2.55),('8998','2014-04-09','14:00:00',2.52),('8998','2014-04-09','14:05:00',2.48),('8998','2014-04-09','14:10:00',2.45),('8998','2014-04-09','14:15:00',2.4),('8998','2014-04-09','14:20:00',2.39),('8998','2014-04-09','14:25:00',2.36),('8998','2014-04-09','14:30:00',2.31),('8998','2014-04-09','14:35:00',2.28),('8998','2014-04-09','14:40:00',2.23),('8998','2014-04-09','14:45:00',2),('8998','2014-04-09','14:50:00',2.17),('8998','2014-04-09','14:55:00',2.09),('8998','2014-04-09','15:00:00',2.04),('8998','2014-04-09','15:05:00',1.99),('8998','2014-04-09','15:10:00',1.93),('8998','2014-04-09','15:15:00',1.89),('8998','2014-04-09','15:20:00',1.84),('8998','2014-04-09','15:25:00',1.78),('8998','2014-04-09','15:30:00',1.59),('8998','2014-04-09','15:35:00',1.54),('8998','2014-04-09','15:40:00',1.56),('8998','2014-04-09','15:45:00',1.49),('8998','2014-04-09','15:50:00',1.49),('8998','2014-04-09','15:55:00',1.45),('8998','2014-04-09','16:00:00',1.36),('8998','2014-04-09','16:05:00',1.37),('8998','2014-04-09','16:10:00',1.31),('8998','2014-04-09','16:15:00',1.3),('8998','2014-04-09','16:20:00',1.19),('8998','2014-04-09','16:25:00',1.17),('8998','2014-04-09','16:30:00',1.1),('8998','2014-04-09','16:35:00',1.05),('8998','2013-08-18','08:05:00',1.08),('8998','2013-08-18','08:10:00',1.11),('8998','2013-08-18','08:15:00',1.18),('8998','2013-08-18','08:20:00',1.25),('8998','2013-08-18','08:25:00',1.31),('8998','2013-08-18','08:30:00',1.48),('8998','2013-08-18','08:35:00',1.45),('8998','2013-08-18','08:40:00',1.41),('8998','2013-08-18','08:45:00',1.42),('8998','2013-08-18','08:50:00',1.44),('8998','2013-08-18','08:55:00',1.49),('8998','2013-08-18','09:00:00',1.51),('8998','2013-08-18','09:05:00',1.55),('8998','2013-08-18','09:10:00',1.58),('8998','2013-08-18','09:15:00',1.59),('8998','2013-08-18','09:20:00',1.67),('8998','2013-08-18','09:25:00',1.62),('8998','2013-08-18','09:30:00',1.98),('8998','2013-08-18','09:35:00',2.18),('8998','2013-08-18','09:40:00',2.29),('8998','2013-08-18','09:45:00',2.33),('8998','2013-08-18','09:50:00',2.4),('8998','2013-08-18','09:55:00',2.43),('8998','2013-08-18','10:00:00',2.45),('8998','2013-08-18','10:05:00',2.49),('8998','2013-08-18','10:10:00',2.52),('8998','2013-08-18','10:15:00',2.55),('8998','2013-08-18','10:20:00',2.57),('8998','2013-08-18','10:25:00',2.58),('8998','2013-08-18','10:30:00',2.6),('8998','2013-08-18','10:35:00',2.6),('8998','2013-08-18','10:40:00',2.62),('8998','2013-08-18','10:45:00',2.63),('8998','2013-08-18','10:50:00',2.66),('8998','2013-08-18','10:55:00',2.67),('8998','2013-08-18','11:00:00',2.66),('8998','2013-08-18','11:05:00',2.66),('8998','2013-08-18','11:10:00',2.67),('8998','2013-08-18','11:15:00',2.69),('8998','2013-08-18','11:20:00',2.69),('8998','2013-08-18','11:25:00',2.7),('8998','2013-08-18','11:30:00',2.7),('8998','2013-08-18','11:35:00',2.71),('8998','2013-08-18','11:40:00',2.69),('8998','2013-08-18','11:45:00',2.68),('8998','2013-08-18','11:50:00',2.69),('8998','2013-08-18','11:55:00',2.69),('8998','2013-08-18','12:00:00',2.65),('8998','2013-08-18','12:05:00',2.65),('8998','2013-08-18','12:10:00',2.72),('8998','2013-08-18','12:15:00',2.7),('8998','2013-08-18','12:20:00',2.7),('8998','2013-08-18','12:25:00',2.69),('8998','2013-08-18','12:30:00',2.69),('8998','2013-08-18','12:35:00',2.66),('8998','2013-08-18','12:40:00',2.66),('8998','2013-08-18','12:45:00',2.64),('8998','2013-08-18','12:50:00',2.64),('8998','2013-08-18','12:55:00',2.62),('8998','2013-08-18','13:00:00',2.62),('8998','2013-08-18','13:05:00',2.62),('8998','2013-08-18','13:10:00',2.6),('8998','2013-08-18','13:15:00',2.56),('8998','2013-08-18','13:20:00',2.56),('8998','2013-08-18','13:25:00',2.53),('8998','2013-08-18','13:30:00',2.53),('8998','2013-08-18','13:35:00',2.5),('8998','2013-08-18','13:40:00',2.48),('8998','2013-08-18','13:45:00',2.46),('8998','2013-08-18','13:50:00',2.43),('8998','2013-08-18','13:55:00',2.42),('8998','2013-08-18','14:00:00',2.39),('8998','2013-08-18','14:05:00',2.35),('8998','2013-08-18','14:10:00',2.33),('8998','2013-08-18','14:15:00',2.29),('8998','2013-08-18','14:20:00',2.26),('8998','2013-08-18','14:25:00',2.23),('8998','2013-08-18','14:30:00',2.2),('8998','2013-08-18','14:35:00',2.17),('8998','2013-08-18','14:40:00',2.13),('8998','2013-08-18','14:45:00',2.1),('8998','2013-08-18','14:50:00',2.06),('8998','2013-08-18','14:55:00',2.02),('8998','2013-08-18','15:00:00',1.98),('8998','2013-08-18','15:05:00',1.94),('8998','2013-08-18','15:10:00',1.91),('8998','2013-08-18','15:15:00',1.85),('8998','2013-08-18','15:20:00',1.81),('8998','2013-08-18','15:25:00',1.77),('8998','2013-08-18','15:30:00',1.72),('8998','2013-08-18','15:35:00',1.67),('8998','2013-08-18','15:40:00',1.62),('8998','2013-08-18','15:45:00',1.57),('8998','2013-08-18','15:50:00',1.51),('8998','2013-08-18','15:55:00',1.47),('8998','2013-08-18','16:00:00',1.41),('8998','2013-08-18','16:05:00',1.35),('8998','2013-08-18','16:10:00',1.29),('8998','2013-08-18','16:15:00',1.22),('8998','2013-08-18','16:20:00',1.19),('8998','2013-08-18','16:25:00',1.14),('8998','2013-08-18','16:30:00',1.08),('8998','2013-08-18','16:35:00',1.02),('8998','2013-08-17','07:55:00',1.01),('8998','2013-08-17','08:05:00',1.09),('8998','2013-08-17','08:10:00',1.14),('8998','2013-08-17','08:15:00',1.19),('8998','2013-08-17','08:20:00',1.28),('8998','2013-08-17','08:25:00',1.42),('8998','2013-08-17','08:30:00',1.57),('8998','2013-08-17','08:35:00',1.52),('8998','2013-08-17','08:40:00',1.45),('8998','2013-08-17','08:45:00',1.45),('8998','2013-08-17','08:50:00',1.49),('8998','2013-08-17','08:55:00',1.67),('8998','2013-08-17','09:00:00',1.91),('8998','2013-08-17','09:05:00',2.02),('8998','2013-08-17','09:10:00',2.08),('8998','2013-08-17','09:15:00',2.12),('8998','2013-08-17','09:20:00',2.16),('8998','2013-08-17','09:25:00',2.19),('8998','2013-08-17','09:30:00',2.24),('8998','2013-08-17','09:35:00',2.32),('8998','2013-08-17','09:40:00',2.38),('8998','2013-08-17','09:45:00',2.2),('8998','2013-08-17','09:50:00',2.49),('8998','2013-08-17','09:55:00',1.8),('8998','2013-08-17','10:00:00',2.53),('8998','2013-08-17','10:05:00',2.11),('8998','2013-08-17','10:10:00',2.19),('8998','2013-08-17','10:15:00',2.58),('8998','2013-08-17','10:20:00',2.58),('8998','2013-08-17','10:25:00',2.61),('8998','2013-08-17','10:30:00',2.61),('8998','2013-08-17','10:35:00',2.6),('8998','2013-08-17','10:40:00',2.62),('8998','2013-08-17','10:45:00',2.63),('8998','2013-08-17','10:50:00',2.64),('8998','2013-08-17','10:55:00',2.65),('8998','2013-08-17','11:00:00',2.63),('8998','2013-08-17','11:05:00',2.69),('8998','2013-08-17','11:10:00',2.67),('8998','2013-08-17','11:15:00',2.66),('8998','2013-08-17','11:20:00',2.67),('8998','2013-08-17','11:25:00',2.68),('8998','2013-08-17','11:30:00',2.69),('8998','2013-08-17','11:35:00',2.67),('8998','2013-08-17','11:40:00',2.69),('8998','2013-08-17','11:45:00',2.71),('8998','2013-08-17','11:50:00',2.72),('8998','2013-08-17','11:55:00',2.7),('8998','2013-08-17','12:00:00',2.67),('8998','2013-08-17','12:05:00',2.68),('8998','2013-08-17','12:10:00',2.71),('8998','2013-08-17','12:15:00',2.63),('8998','2013-08-17','12:20:00',2.7),('8998','2013-08-17','12:25:00',2.76),('8998','2013-08-17','12:30:00',2.69),('8998','2013-08-17','12:35:00',2.5),('8998','2013-08-17','12:40:00',1.65),('8998','2013-08-17','12:45:00',1.47),('8998','2013-08-17','12:55:00',1.72),('8998','2013-08-17','13:00:00',1.04),('8998','2013-08-17','13:05:00',2.85),('8998','2013-08-17','13:10:00',2.81),('8998','2013-08-17','13:15:00',2.48),('8998','2013-08-17','13:20:00',2.53),('8998','2013-08-17','13:25:00',2.67),('8998','2013-08-17','13:30:00',2.57),('8998','2013-08-17','13:35:00',2.54),('8998','2013-08-17','13:40:00',2.56),('8998','2013-08-17','13:45:00',2.51),('8998','2013-08-17','13:50:00',2.49),('8998','2013-08-17','13:55:00',2.14),('8998','2013-08-17','14:00:00',2.45),('8998','2013-08-17','14:05:00',2.43),('8998','2013-08-17','14:10:00',2.36),('8998','2013-08-17','14:15:00',2.32),('8998','2013-08-17','14:20:00',2.27),('8998','2013-08-17','14:25:00',2.24),('8998','2013-08-17','14:30:00',2.21),('8998','2013-08-17','14:35:00',2.18),('8998','2013-08-17','14:40:00',2.14),('8998','2013-08-17','14:45:00',2.11),('8998','2013-08-17','14:50:00',2.06),('8998','2013-08-17','14:55:00',2.02),('8998','2013-08-17','15:00:00',1.98),('8998','2013-08-17','15:05:00',1.94),('8998','2013-08-17','15:10:00',1.89),('8998','2013-08-17','15:15:00',1.85),('8998','2013-08-17','15:20:00',1.8),('8998','2013-08-17','15:25:00',1.76),('8998','2013-08-17','15:30:00',1.71),('8998','2013-08-17','15:35:00',1.67),('8998','2013-08-17','15:40:00',1.62),('8998','2013-08-17','15:45:00',1.57),('8998','2013-08-17','15:50:00',1.52),('8998','2013-08-17','15:55:00',1.46),('8998','2013-08-17','16:00:00',1.42),('8998','2013-08-17','16:05:00',1.36),('8998','2013-08-17','16:10:00',1.3),('8998','2013-08-17','16:15:00',1.25),('8998','2013-08-17','16:20:00',1.21),('8998','2013-08-17','16:25:00',1.15),('8998','2013-08-17','16:30:00',1.09),('8998','2013-08-17','16:35:00',1.04),('8998','2013-08-16','08:05:00',1.06),('8998','2013-08-16','08:10:00',1.11),('8998','2013-08-16','08:15:00',1.17),('8998','2013-08-16','08:20:00',1.25),('8998','2013-08-16','08:25:00',1.29),('8998','2013-08-16','08:30:00',1.28),('8998','2013-08-16','08:35:00',1.47),('8998','2013-08-16','08:40:00',1.44),('8998','2013-08-16','08:45:00',1.41),('8998','2013-08-16','08:50:00',1.45),('8998','2013-08-16','08:55:00',1.45),('8998','2013-08-16','09:00:00',1.51),('8998','2013-08-16','09:05:00',1.51),('8998','2013-08-16','09:10:00',1.59),('8998','2013-08-16','09:15:00',1.56),('8998','2013-08-16','09:20:00',1.61),('8998','2013-08-16','09:25:00',1.7),('8998','2013-08-16','09:30:00',1.88),('8998','2013-08-16','09:35:00',2.16),('8998','2013-08-16','09:40:00',2.22),('8998','2013-08-16','09:45:00',2.3),('8998','2013-08-16','09:50:00',2.42),('8998','2013-08-16','09:55:00',2.47),('8998','2013-08-16','10:00:00',2.5),('8998','2013-08-16','10:05:00',2.53),('8998','2013-08-16','10:10:00',2.55),('8998','2013-08-16','10:15:00',2.57),('8998','2013-08-16','10:20:00',2.58),('8998','2013-08-16','10:25:00',2.6),('8998','2013-08-16','10:30:00',2.62),('8998','2013-08-16','10:35:00',2.63),('8998','2013-08-16','10:40:00',2.64),('8998','2013-08-16','10:45:00',2.66),('8998','2013-08-16','10:50:00',2.69),('8998','2013-08-16','10:55:00',2.7),('8998','2013-08-16','11:00:00',2.7),('8998','2013-08-16','11:05:00',2.71),('8998','2013-08-16','11:10:00',2.73),('8998','2013-08-16','11:15:00',2.71),('8998','2013-08-16','11:20:00',2.71),('8998','2013-08-16','11:25:00',2.72),('8998','2013-08-16','11:30:00',2.73),('8998','2013-08-16','11:35:00',2.72),('8998','2013-08-16','11:40:00',2.75),('8998','2013-08-16','11:45:00',2.74),('8998','2013-08-16','11:50:00',2.73),('8998','2013-08-16','11:55:00',2.77),('8998','2013-08-16','12:00:00',2.71),('8998','2013-08-16','12:05:00',2.71),('8998','2013-08-16','12:10:00',2.69),('8998','2013-08-16','12:15:00',2.59),('8998','2013-08-16','12:20:00',2.7),('8998','2013-08-16','12:25:00',2.72),('8998','2013-08-16','12:30:00',2.75),('8998','2013-08-16','12:35:00',2.71),('8998','2013-08-16','12:40:00',2.57),('8998','2013-08-16','12:45:00',2.63),('8998','2013-08-16','12:50:00',2.69),('8998','2013-08-16','12:55:00',2.64),('8998','2013-08-16','13:00:00',2.59),('8998','2013-08-16','13:05:00',2.44),('8998','2013-08-16','13:10:00',2.66),('8998','2013-08-16','13:15:00',2.67),('8998','2013-08-16','13:20:00',2.64),('8998','2013-08-16','13:25:00',2.68),('8998','2013-08-16','13:30:00',2.01),('8998','2013-08-16','13:35:00',2.33),('8998','2013-08-16','13:40:00',1.15),('8998','2013-08-16','14:00:00',1.29),('8998','2013-08-16','14:05:00',2.02),('8998','2013-08-16','14:10:00',2.11),('8998','2013-08-16','14:15:00',2.43),('8998','2013-08-16','14:20:00',2.39),('8998','2013-08-16','14:25:00',2.36),('8998','2013-08-16','14:30:00',2.27),('8998','2013-08-16','14:35:00',2.23),('8998','2013-08-16','14:40:00',2.15),('8998','2013-08-16','14:45:00',2.13),('8998','2013-08-16','14:50:00',2.12),('8998','2013-08-16','14:55:00',2.03),('8998','2013-08-16','15:00:00',2.01),('8998','2013-08-16','15:05:00',1.97),('8998','2013-08-16','15:10:00',1.91),('8998','2013-08-16','15:15:00',1.85),('8998','2013-08-16','15:20:00',1.83),('8998','2013-08-16','15:25:00',1.77),('8998','2013-08-16','15:30:00',1.73),('8998','2013-08-16','15:35:00',1.7),('8998','2013-08-16','15:40:00',1.63),('8998','2013-08-16','15:45:00',1.57),('8998','2013-08-16','15:50:00',1.52),('8998','2013-08-16','15:55:00',1.47),('8998','2013-08-16','16:00:00',1.42),('8998','2013-08-16','16:05:00',1.36),('8998','2013-08-16','16:10:00',1.31),('8998','2013-08-16','16:15:00',1.26),('8998','2013-08-16','16:20:00',1.22),('8998','2013-08-16','16:25:00',1.16),('8998','2013-08-16','16:30:00',1.11),('8998','2013-08-16','16:35:00',1.06),('8998','2013-08-15','08:00:00',1.1),('8998','2013-08-15','08:05:00',1.13),('8998','2013-08-15','08:10:00',1.18),('8998','2013-08-15','08:15:00',1.34),('8998','2013-08-15','08:20:00',1.34),('8998','2013-08-15','08:25:00',1.47),('8998','2013-08-15','08:30:00',1.59),('8998','2013-08-15','08:35:00',1.62),('8998','2013-08-15','08:40:00',1.54),('8998','2013-08-15','08:45:00',1.49),('8998','2013-08-15','08:50:00',1.53),('8998','2013-08-15','08:55:00',1.51),('8998','2013-08-15','09:00:00',1.57),('8998','2013-08-15','09:05:00',1.7),('8998','2013-08-15','09:10:00',1.66),('8998','2013-08-15','09:15:00',1.73),('8998','2013-08-15','09:20:00',2.03),('8998','2013-08-15','09:25:00',2.29),('8998','2013-08-15','09:30:00',2.34),('8998','2013-08-15','09:35:00',2.41),('8998','2013-08-15','09:40:00',2.46),('8998','2013-08-15','09:45:00',2.5),('8998','2013-08-15','09:50:00',2.58),('8998','2013-08-15','09:55:00',2.6),('8998','2013-08-15','10:00:00',2.64),('8998','2013-08-15','10:05:00',2.65),('8998','2013-08-15','10:10:00',2.67),('8998','2013-08-15','10:15:00',2.7),('8998','2013-08-15','10:20:00',2.72),('8998','2013-08-15','10:25:00',2.73),('8998','2013-08-15','10:30:00',2.76),('8998','2013-08-15','10:35:00',2.77),('8998','2013-08-15','10:40:00',2.78),('8998','2013-08-15','10:45:00',2.79),('8998','2013-08-15','10:50:00',2.8),('8998','2013-08-15','10:55:00',2.81),('8998','2013-08-15','11:00:00',2.81),('8998','2013-08-15','11:05:00',2.84),('8998','2013-08-15','11:10:00',2.83),('8998','2013-08-15','11:15:00',2.82),('8998','2013-08-15','11:20:00',2.83),('8998','2013-08-15','11:25:00',2.83),('8998','2013-08-15','11:30:00',2.83),('8998','2013-08-15','11:35:00',2.84),('8998','2013-08-15','11:40:00',2.82),('8998','2013-08-15','11:45:00',2.82),('8998','2013-08-15','11:50:00',2.81),('8998','2013-08-15','11:55:00',2.8),('8998','2013-08-15','12:00:00',2.82),('8998','2013-08-15','12:05:00',2.82),('8998','2013-08-15','12:10:00',2.82),('8998','2013-08-15','12:15:00',2.81),('8998','2013-08-15','12:20:00',2.82),('8998','2013-08-15','12:25:00',2.79),('8998','2013-08-15','12:30:00',2.78),('8998','2013-08-15','12:35:00',2.74),('8998','2013-08-15','12:40:00',2.73),('8998','2013-08-15','12:45:00',2.72),('8998','2013-08-15','12:50:00',2.71),('8998','2013-08-15','12:55:00',2.69),('8998','2013-08-15','13:00:00',2.67),('8998','2013-08-15','13:05:00',2.66),('8998','2013-08-15','13:10:00',2.64),('8998','2013-08-15','13:15:00',2.63),('8998','2013-08-15','13:20:00',2.59),('8998','2013-08-15','13:25:00',2.56),('8998','2013-08-15','13:30:00',2.54),('8998','2013-08-15','13:35:00',2.53),('8998','2013-08-15','13:40:00',2.5),('8998','2013-08-15','13:45:00',2.49),('8998','2013-08-15','13:50:00',2.47),('8998','2013-08-15','13:55:00',2.43),('8998','2013-08-15','14:00:00',2.41),('8998','2013-08-15','14:05:00',2.39),('8998','2013-08-15','14:10:00',2.36),('8998','2013-08-15','14:15:00',2.33),('8998','2013-08-15','14:20:00',2.29),('8998','2013-08-15','14:25:00',2.26),('8998','2013-08-15','14:30:00',2.21),('8998','2013-08-15','14:35:00',2.17),('8998','2013-08-15','14:40:00',2.13),('8998','2013-08-15','14:45:00',2.1),('8998','2013-08-15','14:50:00',2.06),('8998','2013-08-15','14:55:00',2.02),('8998','2013-08-15','15:00:00',1.98),('8998','2013-08-15','15:05:00',1.92),('8998','2013-08-15','15:10:00',1.89),('8998','2013-08-15','15:15:00',1.84),('8998','2013-08-15','15:20:00',1.79),('8998','2013-08-15','15:25:00',1.75),('8998','2013-08-15','15:30:00',1.72),('8998','2013-08-15','15:35:00',1.67),('8998','2013-08-15','15:40:00',1.62),('8998','2013-08-15','15:45:00',1.58),('8998','2013-08-15','15:50:00',1.52),('8998','2013-08-15','15:55:00',1.48),('8998','2013-08-15','16:00:00',1.43),('8998','2013-08-15','16:05:00',1.38),('8998','2013-08-15','16:10:00',1.33),('8998','2013-08-15','16:15:00',1.27),('8998','2013-08-15','16:20:00',1.21),('8998','2013-08-15','16:25:00',1.16),('8998','2013-08-15','16:30:00',1.1),('8998','2013-08-15','16:35:00',1.05),('8998','2013-08-14','08:05:00',1.28),('8998','2013-08-14','08:10:00',1.18),('8998','2013-08-14','08:15:00',1.19),('8998','2013-08-14','08:20:00',1.48),('8998','2013-08-14','08:25:00',1.41),('8998','2013-08-14','08:30:00',1.43),('8998','2013-08-14','08:35:00',1.59),('8998','2013-08-14','08:40:00',1.62),('8998','2013-08-14','08:45:00',1.58),('8998','2013-08-14','08:50:00',1.56),('8998','2013-08-14','08:55:00',1.58),('8998','2013-08-14','09:00:00',1.67),('8998','2013-08-14','09:05:00',1.59),('8998','2013-08-14','09:10:00',1.32),('8998','2013-08-14','09:15:00',1.16),('8998','2013-08-14','09:20:00',1.7),('8998','2013-08-14','09:25:00',1.81),('8998','2013-08-14','09:30:00',1.86),('8998','2013-08-14','09:35:00',2.25),('8998','2013-08-14','09:40:00',2.33),('8998','2013-08-14','09:45:00',2.46),('8998','2013-08-14','09:50:00',2.58),('8998','2013-08-14','09:55:00',2.61),('8998','2013-08-14','10:00:00',2.63),('8998','2013-08-14','10:05:00',2.64),('8998','2013-08-14','10:10:00',2.67),('8998','2013-08-14','10:15:00',2.7),('8998','2013-08-14','10:20:00',2.72),('8998','2013-08-14','10:25:00',2.77),('8998','2013-08-14','10:30:00',2.79),('8998','2013-08-14','10:35:00',2.78),('8998','2013-08-14','10:40:00',2.8),('8998','2013-08-14','10:45:00',2.76),('8998','2013-08-14','10:50:00',2.7),('8998','2013-08-14','10:55:00',2.62),('8998','2013-08-14','11:00:00',2.58),('8998','2013-08-14','11:05:00',2.22),('8998','2013-08-14','11:10:00',1.95),('8998','2013-08-14','11:15:00',2.1),('8998','2013-08-14','11:20:00',2.38),('8998','2013-08-14','11:25:00',2.62),('8998','2013-08-14','11:30:00',2.92),('8998','2013-08-14','11:35:00',3.02),('8998','2013-08-14','11:40:00',3.07),('8998','2013-08-14','11:45:00',3.1),('8998','2013-08-14','11:50:00',3.09),('8998','2013-08-14','11:55:00',3.07),('8998','2013-08-14','12:00:00',3.04),('8998','2013-08-14','12:05:00',3.02),('8998','2013-08-14','12:10:00',2.97),('8998','2013-08-14','12:15:00',2.97),('8998','2013-08-14','12:20:00',2.94),('8998','2013-08-14','12:25:00',2.93),('8998','2013-08-14','12:30:00',2.9),('8998','2013-08-14','12:35:00',2.91),('8998','2013-08-14','12:40:00',2.87),('8998','2013-08-14','12:45:00',2.87),('8998','2013-08-14','12:50:00',2.81),('8998','2013-08-14','12:55:00',2.65),('8998','2013-08-14','13:00:00',2.66),('8998','2013-08-14','13:05:00',2.64),('8998','2013-08-14','13:10:00',2.6),('8998','2013-08-14','13:15:00',2.52),('8998','2013-08-14','13:20:00',2.5),('8998','2013-08-14','13:25:00',2.6),('8998','2013-08-14','13:30:00',2.64),('8998','2013-08-14','13:35:00',2.62),('8998','2013-08-14','13:40:00',2.57),('8998','2013-08-14','13:45:00',2.53),('8998','2013-08-14','13:50:00',2.49),('8998','2013-08-14','13:55:00',2.44),('8998','2013-08-14','14:00:00',2.46),('8998','2013-08-14','14:05:00',2.44),('8998','2013-08-14','14:10:00',2.4),('8998','2013-08-14','14:15:00',2.37),('8998','2013-08-14','14:20:00',2.33),('8998','2013-08-14','14:25:00',2.24),('8998','2013-08-14','14:30:00',2.18),('8998','2013-08-14','14:35:00',2.22),('8998','2013-08-14','14:40:00',2.17),('8998','2013-08-14','14:45:00',2.11),('8998','2013-08-14','14:50:00',2.09),('8998','2013-08-14','14:55:00',2.03),('8998','2013-08-14','15:00:00',1.99),('8998','2013-08-14','15:05:00',1.97),('8998','2013-08-14','15:10:00',1.93),('8998','2013-08-14','15:15:00',1.87),('8998','2013-08-14','15:20:00',1.8),('8998','2013-08-14','15:25:00',1.76),('8998','2013-08-14','15:30:00',1.74),('8998','2013-08-14','15:35:00',1.7),('8998','2013-08-14','15:40:00',1.64),('8998','2013-08-14','15:45:00',1.57),('8998','2013-08-14','15:50:00',1.52),('8998','2013-08-14','15:55:00',1.5),('8998','2013-08-14','16:00:00',1.43),('8998','2013-08-14','16:05:00',1.36),('8998','2013-08-14','16:10:00',1.16),('8998','2013-08-14','16:15:00',1.26),('8998','2013-08-14','16:20:00',1.24),('8998','2013-08-14','16:25:00',1.16),('8998','2013-08-14','16:30:00',1.09),('8998','2013-08-14','16:35:00',1.05),('8998','2013-08-13','07:55:00',1.1),('8998','2013-08-13','08:00:00',1.07),('8998','2013-08-13','08:05:00',1.11),('8998','2013-08-13','08:10:00',1.15),('8998','2013-08-13','08:15:00',1.21),('8998','2013-08-13','08:20:00',1.27),('8998','2013-08-13','08:25:00',1.28),('8998','2013-08-13','08:30:00',1.34),('8998','2013-08-13','08:35:00',1.44),('8998','2013-08-13','08:40:00',1.63),('8998','2013-08-13','08:45:00',1.63),('8998','2013-08-13','08:50:00',1.53),('8998','2013-08-13','08:55:00',1.54),('8998','2013-08-13','09:00:00',1.56),('8998','2013-08-13','09:05:00',1.77),('8998','2013-08-13','09:10:00',1.72),('8998','2013-08-13','09:15:00',1.72),('8998','2013-08-13','09:20:00',1.7),('8998','2013-08-13','09:25:00',1.75),('8998','2013-08-13','09:30:00',1.88),('8998','2013-08-13','09:35:00',2.22),('8998','2013-08-13','09:40:00',2.21),('8998','2013-08-13','10:00:00',1.31),('8998','2013-08-13','10:05:00',2.17),('8998','2013-08-13','10:10:00',2.23),('8998','2013-08-13','10:15:00',2.35),('8998','2013-08-13','10:20:00',2.28),('8998','2013-08-13','10:25:00',2.63),('8998','2013-08-13','10:30:00',2.78),('8998','2013-08-13','10:35:00',2.81),('8998','2013-08-13','10:40:00',2.87),('8998','2013-08-13','10:45:00',2.09),('8998','2013-08-13','10:50:00',2.33),('8998','2013-08-13','10:55:00',1.16),('8998','2013-08-13','11:00:00',1.9),('8998','2013-08-13','11:05:00',2.94),('8998','2013-08-13','11:10:00',1.44),('8998','2013-08-13','11:15:00',1.52),('8998','2013-08-13','11:20:00',2.32),('8998','2013-08-13','11:25:00',2.38),('8998','2013-08-13','11:30:00',2.88),('8998','2013-08-13','11:35:00',2.9),('8998','2013-08-13','11:40:00',2.94),('8998','2013-08-13','11:45:00',2.06),('8998','2013-08-13','11:50:00',1.04),('8998','2013-08-13','11:55:00',1.02),('8998','2013-08-13','12:05:00',1.46),('8998','2013-08-13','12:10:00',1.44),('8998','2013-08-13','12:15:00',1.55),('8998','2013-08-13','12:20:00',1.39),('8998','2013-08-13','12:35:00',1.64),('8998','2013-08-13','12:55:00',1.47),('8998','2013-08-13','13:00:00',1.11),('8998','2013-08-13','13:30:00',1.23),('8998','2013-08-13','13:40:00',1.87),('8998','2013-08-13','13:45:00',2.41),('8998','2013-08-13','13:50:00',2.87),('8998','2013-08-13','13:55:00',2.05),('8998','2013-08-13','14:00:00',1.16),('8998','2013-08-13','14:05:00',2.63),('8998','2013-08-13','14:10:00',1.62),('8998','2013-08-13','14:15:00',2.68),('8998','2013-08-13','14:20:00',2.59),('8998','2013-08-13','14:25:00',2.57),('8998','2013-08-13','14:30:00',2.49),('8998','2013-08-13','14:35:00',2.44),('8998','2013-08-13','14:40:00',2.33),('8998','2013-08-13','14:45:00',2.25),('8998','2013-08-13','14:50:00',2.22),('8998','2013-08-13','14:55:00',1.58),('8998','2013-08-13','15:00:00',2.12),('8998','2013-08-13','15:05:00',2.08),('8998','2013-08-13','15:10:00',2),('8998','2013-08-13','15:15:00',1.98),('8998','2013-08-13','15:20:00',2.03),('8998','2013-08-13','15:25:00',1.95),('8998','2013-08-13','15:30:00',1.81),('8998','2013-08-13','15:35:00',1.74),('8998','2013-08-13','15:40:00',1.7),('8998','2013-08-13','15:45:00',1.65),('8998','2013-08-13','15:50:00',1.6),('8998','2013-08-13','15:55:00',1.54),('8998','2013-08-13','16:00:00',1.5),('8998','2013-08-13','16:05:00',1.46),('8998','2013-08-13','16:10:00',1.42),('8998','2013-08-13','16:15:00',1.35),('8998','2013-08-13','16:20:00',1.31),('8998','2013-08-13','16:25:00',1.24),('8998','2013-08-13','16:30:00',1.18),('8998','2013-08-13','16:35:00',1.14),('8998','2013-08-13','16:40:00',1.08),('8998','2013-08-13','16:45:00',1.01),('8998','2013-08-12','07:55:00',1.02),('8998','2013-08-12','08:00:00',1.13),('8998','2013-08-12','08:05:00',1.14),('8998','2013-08-12','08:10:00',1.18),('8998','2013-08-12','08:15:00',1.21),('8998','2013-08-12','08:20:00',1.3),('8998','2013-08-12','08:25:00',1.39),('8998','2013-08-12','08:30:00',1.37),('8998','2013-08-12','08:35:00',1.66),('8998','2013-08-12','08:40:00',1.66),('8998','2013-08-12','08:45:00',1.59),('8998','2013-08-12','08:50:00',1.54),('8998','2013-08-12','08:55:00',1.54),('8998','2013-08-12','09:00:00',1.56),('8998','2013-08-12','09:05:00',1.61),('8998','2013-08-12','09:10:00',1.61),('8998','2013-08-12','09:15:00',1.66),('8998','2013-08-12','09:20:00',1.66),('8998','2013-08-12','09:25:00',1.76),('8998','2013-08-12','09:30:00',1.75),('8998','2013-08-12','09:35:00',2.06),('8998','2013-08-12','09:40:00',2.28),('8998','2013-08-12','09:45:00',2.42),('8998','2013-08-12','09:50:00',2.47),('8998','2013-08-12','09:55:00',2.51),('8998','2013-08-12','10:00:00',2.16),('8998','2013-08-12','10:05:00',1.26),('8998','2013-08-12','10:10:00',2.54),('8998','2013-08-12','10:15:00',2.7),('8998','2013-08-12','10:20:00',2.62),('8998','2013-08-12','10:25:00',2.67),('8998','2013-08-12','10:30:00',2.66),('8998','2013-08-12','10:35:00',2.71),('8998','2013-08-12','10:40:00',2.71),('8998','2013-08-12','10:45:00',2.7),('8998','2013-08-12','10:50:00',2.71),('8998','2013-08-12','10:55:00',2.71),('8998','2013-08-12','11:00:00',2.73),('8998','2013-08-12','11:05:00',2.76),('8998','2013-08-12','11:10:00',2.75),('8998','2013-08-12','11:15:00',2.74),('8998','2013-08-12','11:20:00',2.77),('8998','2013-08-12','11:25:00',2.76),('8998','2013-08-12','11:30:00',2.77),('8998','2013-08-12','11:35:00',2.75),('8998','2013-08-12','11:40:00',2.75),('8998','2013-08-12','11:45:00',2.74),('8998','2013-08-12','11:50:00',2.76),('8998','2013-08-12','11:55:00',2.81),('8998','2013-08-12','12:00:00',2.84),('8998','2013-08-12','12:05:00',2.87),('8998','2013-08-12','12:10:00',2.87),('8998','2013-08-12','12:15:00',2.9),('8998','2013-08-12','12:20:00',2.91),('8998','2013-08-12','12:25:00',2.92),('8998','2013-08-12','12:30:00',2.92),('8998','2013-08-12','12:35:00',2.67),('8998','2013-08-12','12:40:00',2.76),('8998','2013-08-12','12:45:00',1.63),('8998','2013-08-12','12:50:00',2.48),('8998','2013-08-12','12:55:00',2.83),('8998','2013-08-12','13:15:00',1.2),('8998','2013-08-12','13:20:00',3.19),('8998','2013-08-12','13:25:00',3.01),('8998','2013-08-12','13:30:00',2.92),('8998','2013-08-12','13:35:00',2.82),('8998','2013-08-12','13:40:00',2.82),('8998','2013-08-12','13:45:00',2.88),('8998','2013-08-12','13:50:00',2.88),('8998','2013-08-12','13:55:00',2.78),('8998','2013-08-12','14:00:00',2.65),('8998','2013-08-12','14:05:00',2.7),('8998','2013-08-12','14:10:00',2.23),('8998','2013-08-12','14:15:00',2.64),('8998','2013-08-12','14:20:00',2.6),('8998','2013-08-12','14:25:00',2.01),('8998','2013-08-12','14:35:00',2.46),('8998','2013-08-12','14:40:00',1.64),('8998','2013-08-12','14:45:00',1.16),('8998','2013-08-12','14:50:00',2.25),('8998','2013-08-12','14:55:00',2.4),('8998','2013-08-12','15:00:00',1.92),('8998','2013-08-12','15:05:00',1.67),('8998','2013-08-12','15:10:00',1.38),('8998','2013-08-12','15:15:00',1.68),('8998','2013-08-12','15:20:00',1.91),('8998','2013-08-12','15:25:00',1.92),('8998','2013-08-12','15:30:00',1.82),('8998','2013-08-12','15:35:00',1.8),('8998','2013-08-12','15:40:00',1.76),('8998','2013-08-12','15:45:00',1.68),('8998','2013-08-12','15:50:00',1.61),('8998','2013-08-12','15:55:00',1.54),('8998','2013-08-12','16:00:00',1.49),('8998','2013-08-12','16:05:00',1.43),('8998','2013-08-12','16:10:00',1.37),('8998','2013-08-12','16:15:00',1.33),('8998','2013-08-12','16:20:00',1.28),('8998','2013-08-12','16:25:00',1.22),('8998','2013-08-12','16:30:00',1.17),('8998','2013-08-12','16:35:00',1.12),('8998','2013-08-12','16:40:00',1.06),('8998','2013-08-12','16:45:00',1.01),('8998','2013-08-11','07:50:00',1.02),('8998','2013-08-11','07:55:00',1.12),('8998','2013-08-11','08:00:00',1.14),('8998','2013-08-11','08:05:00',1.1),('8998','2013-08-11','08:10:00',1.16),('8998','2013-08-11','08:15:00',1.21),('8998','2013-08-11','08:20:00',1.29),('8998','2013-08-11','08:25:00',1.39),('8998','2013-08-11','08:30:00',1.35),('8998','2013-08-11','08:35:00',1.39),('8998','2013-08-11','08:40:00',1.58),('8998','2013-08-11','08:45:00',1.59),('8998','2013-08-11','08:50:00',1.52),('8998','2013-08-11','08:55:00',1.49),('8998','2013-08-11','09:00:00',1.53),('8998','2013-08-11','09:05:00',1.58),('8998','2013-08-11','09:10:00',1.6),('8998','2013-08-11','09:15:00',1.64),('8998','2013-08-11','09:20:00',1.69),('8998','2013-08-11','09:25:00',1.78),('8998','2013-08-11','09:30:00',1.85),('8998','2013-08-11','09:35:00',2.03),('8998','2013-08-11','09:40:00',2.23),('8998','2013-08-11','09:45:00',2.38),('8998','2013-08-11','09:50:00',2.42),('8998','2013-08-11','09:55:00',2.46),('8998','2013-08-11','10:00:00',2.48),('8998','2013-08-11','10:05:00',2.49),('8998','2013-08-11','10:10:00',2.5),('8998','2013-08-11','10:15:00',2.53),('8998','2013-08-11','10:20:00',2.56),('8998','2013-08-11','10:25:00',2.58),('8998','2013-08-11','10:30:00',2.59),('8998','2013-08-11','10:35:00',2.59),('8998','2013-08-11','10:40:00',2.63),('8998','2013-08-11','10:45:00',2.65),('8998','2013-08-11','10:50:00',2.67),('8998','2013-08-11','10:55:00',2.7),('8998','2013-08-11','11:00:00',2.69),('8998','2013-08-11','11:05:00',2.69),('8998','2013-08-11','11:10:00',2.72),('8998','2013-08-11','11:15:00',2.73),('8998','2013-08-11','11:20:00',2.69),('8998','2013-08-11','11:25:00',2.72),('8998','2013-08-11','11:30:00',2.73),('8998','2013-08-11','11:35:00',2.65),('8998','2013-08-11','11:40:00',2.73),('8998','2013-08-11','11:45:00',2.75),('8998','2013-08-11','11:50:00',2.74),('8998','2013-08-11','11:55:00',2.76),('8998','2013-08-11','12:00:00',2.8),('8998','2013-08-11','12:05:00',2.86),('8998','2013-08-11','12:10:00',2.78),('8998','2013-08-11','12:15:00',2.17),('8998','2013-08-11','12:45:00',2.15),('8998','2013-08-11','12:50:00',1.25),('8998','2013-08-11','13:25:00',1.44),('8998','2013-08-11','13:50:00',1.65),('8998','2013-08-11','13:55:00',2.53),('8998','2013-08-11','14:15:00',1.08),('8998','2013-08-11','14:50:00',1.35),('8998','2013-08-11','14:55:00',2.62),('8998','2013-08-11','15:00:00',2.39),('8998','2013-08-11','15:05:00',2.1),('8998','2013-08-11','15:10:00',2.26),('8998','2013-08-11','15:15:00',2.16),('8998','2013-08-11','15:20:00',1.66),('8998','2013-08-11','15:25:00',1.98),('8998','2013-08-11','15:30:00',1.93),('8998','2013-08-11','15:35:00',1.76),('8998','2013-08-11','15:40:00',1.73),('8998','2013-08-11','15:45:00',1.67),('8998','2013-08-11','15:50:00',1.62),('8998','2013-08-11','15:55:00',1.57),('8998','2013-08-11','16:00:00',1.5),('8998','2013-08-11','16:05:00',1.44),('8998','2013-08-11','16:10:00',1.39),('8998','2013-08-11','16:15:00',1.33),('8998','2013-08-11','16:20:00',1.28),('8998','2013-08-11','16:25:00',1.24),('8998','2013-08-11','16:30:00',1.19),('8998','2013-08-11','16:35:00',1.12),('8998','2013-08-11','16:40:00',1.08),('8998','2013-08-11','16:45:00',1.01),('8998','2013-08-10','07:50:00',1.04),('8998','2013-08-10','07:55:00',1.18),('8998','2013-08-10','08:00:00',1.16),('8998','2013-08-10','08:05:00',1.14),('8998','2013-08-10','08:10:00',1.2),('8998','2013-08-10','08:15:00',1.26),('8998','2013-08-10','08:20:00',1.37),('8998','2013-08-10','08:25:00',1.44),('8998','2013-08-10','08:30:00',1.41),('8998','2013-08-10','08:35:00',1.41),('8998','2013-08-10','08:40:00',1.57),('8998','2013-08-10','08:45:00',1.66),('8998','2013-08-10','08:50:00',1.57),('8998','2013-08-10','08:55:00',1.52),('8998','2013-08-10','09:00:00',1.56),('8998','2013-08-10','09:05:00',1.59),('8998','2013-08-10','09:10:00',1.62),('8998','2013-08-10','09:15:00',1.66),('8998','2013-08-10','09:20:00',1.71),('8998','2013-08-10','09:25:00',1.8),('8998','2013-08-10','09:30:00',1.92),('8998','2013-08-10','09:35:00',2.08),('8998','2013-08-10','09:40:00',2.31),('8998','2013-08-10','09:45:00',2.48),('8998','2013-08-10','09:50:00',2.51),('8998','2013-08-10','09:55:00',2.54),('8998','2013-08-10','10:00:00',2.58),('8998','2013-08-10','10:05:00',2.61),('8998','2013-08-10','10:10:00',2.62),('8998','2013-08-10','10:15:00',2.66),('8998','2013-08-10','10:20:00',2.67),('8998','2013-08-10','10:25:00',2.68),('8998','2013-08-10','10:30:00',2.7),('8998','2013-08-10','10:35:00',2.71),('8998','2013-08-10','10:40:00',2.72),('8998','2013-08-10','10:45:00',2.75),('8998','2013-08-10','10:50:00',2.76),('8998','2013-08-10','10:55:00',2.78),('8998','2013-08-10','11:00:00',2.79),('8998','2013-08-10','11:05:00',2.81),('8998','2013-08-10','11:10:00',2.83),('8998','2013-08-10','11:15:00',2.81),('8998','2013-08-10','11:20:00',2.83),('8998','2013-08-10','11:25:00',2.84),('8998','2013-08-10','11:30:00',2.84),('8998','2013-08-10','11:35:00',2.82),('8998','2013-08-10','11:40:00',2.82),('8998','2013-08-10','11:45:00',2.81),('8998','2013-08-10','11:50:00',2.85),('8998','2013-08-10','11:55:00',2.84),('8998','2013-08-10','12:00:00',2.83),('8998','2013-08-10','12:05:00',2.83),('8998','2013-08-10','12:10:00',2.83),('8998','2013-08-10','12:15:00',2.82),('8998','2013-08-10','12:20:00',2.82),('8998','2013-08-10','12:25:00',2.82),('8998','2013-08-10','12:30:00',2.81),('8998','2013-08-10','12:35:00',2.79),('8998','2013-08-10','12:40:00',2.78),('8998','2013-08-10','12:45:00',2.75),('8998','2013-08-10','12:50:00',2.74),('8998','2013-08-10','12:55:00',2.73),('8998','2013-08-10','13:00:00',2.71),('8998','2013-08-10','13:05:00',2.7),('8998','2013-08-10','13:10:00',2.66),('8998','2013-08-10','13:15:00',2.64),('8998','2013-08-10','13:20:00',2.61),('8998','2013-08-10','13:25:00',2.61),('8998','2013-08-10','13:30:00',2.59),('8998','2013-08-10','13:35:00',2.55),('8998','2013-08-10','13:40:00',2.56),('8998','2013-08-10','13:45:00',2.52),('8998','2013-08-10','13:50:00',2.5),('8998','2013-08-10','13:55:00',2.46),('8998','2013-08-10','14:00:00',2.44),('8998','2013-08-10','14:05:00',2.41),('8998','2013-08-10','14:10:00',2.41),('8998','2013-08-10','14:15:00',2.33),('8998','2013-08-10','14:20:00',2.33),('8998','2013-08-10','14:25:00',2.28),('8998','2013-08-10','14:30:00',2.25),('8998','2013-08-10','14:35:00',2.2),('8998','2013-08-10','14:40:00',2.2),('8998','2013-08-10','14:45:00',2.15),('8998','2013-08-10','14:50:00',2.08),('8998','2013-08-10','14:55:00',2.07),('8998','2013-08-10','15:00:00',2.06),('8998','2013-08-10','15:05:00',2.01),('8998','2013-08-10','15:10:00',1.95),('8998','2013-08-10','15:15:00',1.89),('8998','2013-08-10','15:20:00',1.86),('8998','2013-08-10','15:25:00',1.86),('8998','2013-08-10','15:30:00',1.26),('8998','2013-08-10','15:35:00',1.73),('8998','2013-08-10','15:40:00',1.72),('8998','2013-08-10','15:45:00',1.67),('8998','2013-08-10','15:50:00',1.64),('8998','2013-08-10','15:55:00',1.58),('8998','2013-08-10','16:00:00',1.52),('8998','2013-08-10','16:05:00',1.47),('8998','2013-08-10','16:10:00',1.42),('8998','2013-08-10','16:15:00',1.36),('8998','2013-08-10','16:20:00',1.31),('8998','2013-08-10','16:25:00',1.25),('8998','2013-08-10','16:30:00',1.18),('8998','2013-08-10','16:35:00',1.13),('8998','2013-08-10','16:40:00',1.07),('8998','2013-08-10','16:45:00',1.01),('8998','2013-08-09','07:50:00',1.04),('8998','2013-08-09','07:55:00',1.19),('8998','2013-08-09','08:00:00',1.19),('8998','2013-08-09','08:05:00',1.24),('8998','2013-08-09','08:10:00',1.21),('8998','2013-08-09','08:15:00',1.3),('8998','2013-08-09','08:20:00',1.4),('8998','2013-08-09','08:25:00',1.52),('8998','2013-08-09','08:30:00',1.47),('8998','2013-08-09','08:35:00',1.45),('8998','2013-08-09','08:40:00',1.55),('8998','2013-08-09','08:45:00',1.73),('8998','2013-08-09','08:50:00',1.66),('8998','2013-08-09','08:55:00',1.59),('8998','2013-08-09','09:00:00',1.58),('8998','2013-08-09','09:05:00',1.6),('8998','2013-08-09','09:10:00',1.65),('8998','2013-08-09','09:15:00',1.67),('8998','2013-08-09','09:20:00',1.75),('8998','2013-08-09','09:25:00',1.81),('8998','2013-08-09','09:30:00',1.96),('8998','2013-08-09','09:35:00',2.13),('8998','2013-08-09','09:40:00',2.33),('8998','2013-08-09','09:45:00',2.5),('8998','2013-08-09','09:50:00',2.53),('8998','2013-08-09','09:55:00',2.54),('8998','2013-08-09','10:00:00',2.59),('8998','2013-08-09','10:05:00',2.6),('8998','2013-08-09','10:10:00',2.62),('8998','2013-08-09','10:15:00',2.65),('8998','2013-08-09','10:20:00',2.67),('8998','2013-08-09','10:25:00',2.69),('8998','2013-08-09','10:30:00',2.7),('8998','2013-08-09','10:35:00',2.71),('8998','2013-08-09','10:40:00',2.75),('8998','2013-08-09','10:45:00',2.76),('8998','2013-08-09','10:50:00',2.79),('8998','2013-08-09','10:55:00',2.83),('8998','2013-08-09','11:00:00',2.9),('8998','2013-08-09','11:05:00',2.89),('8998','2013-08-09','11:10:00',2.7),('8998','2013-08-09','11:15:00',2.61),('8998','2013-08-09','11:20:00',1.94),('8998','2013-08-09','11:25:00',2.14),('8998','2013-08-09','11:30:00',2.48),('8998','2013-08-09','11:35:00',2.95),('8998','2013-08-09','11:40:00',2.91),('8998','2013-08-09','11:45:00',2.89),('8998','2013-08-09','11:50:00',2.89),('8998','2013-08-09','11:55:00',2.87),('8998','2013-08-09','12:00:00',2.87),('8998','2013-08-09','12:05:00',2.87),('8998','2013-08-09','12:10:00',2.87),('8998','2013-08-09','12:15:00',2.85),('8998','2013-08-09','12:20:00',2.84),('8998','2013-08-09','12:25:00',2.85),('8998','2013-08-09','12:30:00',2.81),('8998','2013-08-09','12:35:00',2.82),('8998','2013-08-09','12:40:00',2.83),('8998','2013-08-09','12:45:00',2.89),('8998','2013-08-09','12:50:00',2.92),('8998','2013-08-09','12:55:00',2.91),('8998','2013-08-09','13:00:00',2.86),('8998','2013-08-09','13:05:00',2.81),('8998','2013-08-09','13:10:00',2.83),('8998','2013-08-09','13:15:00',2.88),('8998','2013-08-09','13:20:00',2.89),('8998','2013-08-09','13:25:00',2.93),('8998','2013-08-09','13:30:00',2.46),('8998','2013-08-09','13:35:00',1.84),('8998','2013-08-09','13:45:00',1.09),('8998','2013-08-09','13:50:00',2.77),('8998','2013-08-09','13:55:00',2.7),('8998','2013-08-09','14:00:00',2.84),('8998','2013-08-09','14:05:00',2.2),('8998','2013-08-09','14:10:00',2.83),('8998','2013-08-09','14:15:00',2.41),('8998','2013-08-09','14:20:00',1.33),('8998','2013-08-09','15:50:00',1.07),('8998','2013-08-09','15:55:00',1.22),('8998','2013-08-09','16:00:00',1.31),('8998','2013-08-09','16:05:00',2.09),('8998','2013-08-09','16:10:00',1.17),('8998','2013-08-09','16:15:00',1.24),('8998','2013-08-09','16:20:00',1.38),('8998','2013-08-09','16:30:00',1.03),('8998','2013-08-09','16:35:00',1.49),('8998','2013-08-09','16:40:00',1.31),('8998','2013-08-09','16:45:00',1.26),('8998','2013-08-09','16:50:00',1.13),('8998','2014-04-08','08:20:00',1.07),('8998','2014-04-08','09:50:00',1.62),('8998','2014-04-08','09:55:00',2.67),('8998','2014-04-08','10:00:00',2.64),('8998','2014-04-08','10:05:00',2.62),('8998','2014-04-08','10:10:00',2.66),('8998','2014-04-08','10:15:00',2.78),('8998','2014-04-08','10:20:00',2.83),('8998','2014-04-08','10:25:00',2.35),('8998','2014-04-08','10:30:00',2.47),('8998','2014-04-08','10:35:00',3.01),('8998','2014-04-08','10:40:00',1.75),('8998','2014-04-08','10:55:00',1.05),('8998','2014-04-08','11:00:00',2.75),('8998','2014-04-08','11:05:00',3.29),('8998','2014-04-08','11:10:00',3.3),('8998','2014-04-08','11:15:00',3.26),('8998','2014-04-08','11:20:00',2.21),('8998','2014-04-08','11:25:00',1.05),('8998','2014-04-08','11:40:00',2.32),('8998','2014-04-08','11:45:00',3.16),('8998','2014-04-08','11:50:00',1.67),('8998','2014-04-08','11:55:00',2.79),('8998','2014-04-08','12:00:00',2.77),('8998','2014-04-08','12:05:00',3.1),('8998','2014-04-08','12:10:00',1.24),('8998','2014-04-08','13:25:00',1.34),('8998','2014-04-08','13:30:00',1.1),('8998','2014-04-08','13:35:00',1.03),('8998','2014-04-08','14:10:00',1.66),('8998','2014-04-08','14:15:00',1.72),('8998','2014-04-08','14:20:00',1.56),('8998','2014-04-08','14:25:00',1.61),('8998','2014-04-08','14:30:00',1.55),('8998','2014-04-08','14:35:00',2.41),('8998','2014-04-08','14:40:00',1.38),('8998','2014-04-08','14:45:00',1.26),('8998','2014-04-08','14:50:00',1.21),('8998','2014-04-08','14:55:00',1.35),('8998','2014-04-08','15:00:00',1.28),('8998','2014-04-08','15:05:00',2.42),('8998','2014-04-08','15:10:00',2.43),('8998','2014-04-08','15:15:00',2.19),('8998','2014-04-08','15:20:00',2.08),('8998','2014-04-08','15:25:00',1.08),('8998','2014-04-08','15:30:00',1.72),('8998','2014-04-08','15:35:00',1.37),('8998','2014-04-08','15:40:00',1),('8998','2014-04-08','15:45:00',1.29),('8998','2014-04-08','16:10:00',1.35),('8998','2014-04-08','16:15:00',1.43),('8998','2014-04-08','16:20:00',1.46),('8998','2014-04-08','16:25:00',1.32),('8998','2014-04-08','16:30:00',1.13),('8998','2014-04-08','17:05:00',1.06),('8998','2013-08-08','08:05:00',1.12),('8998','2013-08-08','08:35:00',1.04),('8998','2013-08-08','08:40:00',1.37),('8998','2013-08-08','08:45:00',1.27),('8998','2013-08-08','08:50:00',1.57),('8998','2013-08-08','08:55:00',1.45),('8998','2013-08-08','09:00:00',1.4),('8998','2013-08-08','09:05:00',1.63),('8998','2013-08-08','09:10:00',1.71),('8998','2013-08-08','09:15:00',1.53),('8998','2013-08-08','09:20:00',1.38),('8998','2013-08-08','09:25:00',1.25),('8998','2013-08-08','09:30:00',1.8),('8998','2013-08-08','09:35:00',2.21),('8998','2013-08-08','09:40:00',1.77),('8998','2013-08-08','09:45:00',2.33),('8998','2013-08-08','09:50:00',2.33),('8998','2013-08-08','09:55:00',1.58),('8998','2013-08-08','10:00:00',1.68),('8998','2013-08-08','10:05:00',2.08),('8998','2013-08-08','10:10:00',2.34),('8998','2013-08-08','10:15:00',2.39),('8998','2013-08-08','10:20:00',2.37),('8998','2013-08-08','10:25:00',2.39),('8998','2013-08-08','10:30:00',2.43),('8998','2013-08-08','10:35:00',2.44),('8998','2013-08-08','10:40:00',2.52),('8998','2013-08-08','10:45:00',2.44),('8998','2013-08-08','10:50:00',2.51),('8998','2013-08-08','10:55:00',2.53),('8998','2013-08-08','11:00:00',2.54),('8998','2013-08-08','11:05:00',2.55),('8998','2013-08-08','11:10:00',2.56),('8998','2013-08-08','11:15:00',2.59),('8998','2013-08-08','11:20:00',2.6),('8998','2013-08-08','11:25:00',2.61),('8998','2013-08-08','11:30:00',2.62),('8998','2013-08-08','11:35:00',2.58),('8998','2013-08-08','11:40:00',2.58),('8998','2013-08-08','11:45:00',2.6),('8998','2013-08-08','11:50:00',2.61),('8998','2013-08-08','11:55:00',2.63),('8998','2013-08-08','12:00:00',2.6),('8998','2013-08-08','12:05:00',2.59),('8998','2013-08-08','12:10:00',2.61),('8998','2013-08-08','12:15:00',2.63),('8998','2013-08-08','12:20:00',2.69),('8998','2013-08-08','12:25:00',2.52),('8998','2013-08-08','12:30:00',1.82),('8998','2013-08-08','12:35:00',2.14),('8998','2013-08-08','12:40:00',2.77),('8998','2013-08-08','12:45:00',2.01),('8998','2013-08-08','12:50:00',1.65),('8998','2013-08-08','12:55:00',1.79),('8998','2013-08-08','13:00:00',1.04),('8998','2013-08-08','13:25:00',1.4),('8998','2013-08-08','13:30:00',1.38),('8998','2013-08-08','13:35:00',1.03),('8998','2013-08-08','13:40:00',1.09),('8998','2013-08-08','13:45:00',1.01),('8998','2013-08-08','13:50:00',1.04),('8998','2013-08-08','14:10:00',1.09),('8998','2013-08-08','15:10:00',1.73),('8998','2013-08-08','15:15:00',1.59),('8998','2013-08-08','15:35:00',1.18),('8998','2013-08-08','15:45:00',1.68),('8998','2013-08-08','15:50:00',1.33),('8998','2013-08-08','15:55:00',1.3),('8998','2013-08-08','16:55:00',1.18),('8998','2013-08-08','17:05:00',1.01),('8998','2013-08-07','08:00:00',1.02),('8998','2013-08-07','08:05:00',1.08),('8998','2013-08-07','08:10:00',1.13),('8998','2013-08-07','08:15:00',1.21),('8998','2013-08-07','08:20:00',1.2),('8998','2013-08-07','08:25:00',1.25),('8998','2013-08-07','08:30:00',1.28),('8998','2013-08-07','08:35:00',1.33),('8998','2013-08-07','08:40:00',1.37),('8998','2013-08-07','08:45:00',1.39),('8998','2013-08-07','08:50:00',1.41),('8998','2013-08-07','08:55:00',1.45),('8998','2013-08-07','09:00:00',1.48),('8998','2013-08-07','09:05:00',1.53),('8998','2013-08-07','09:10:00',1.55),('8998','2013-08-07','09:15:00',1.57),('8998','2013-08-07','09:20:00',1.69),('8998','2013-08-07','09:25:00',1.7),('8998','2013-08-07','09:30:00',1.86),('8998','2013-08-07','09:35:00',2.05),('8998','2013-08-07','09:40:00',2.21),('8998','2013-08-07','09:45:00',2.3),('8998','2013-08-07','09:50:00',2.32),('8998','2013-08-07','09:55:00',2.35),('8998','2013-08-07','10:00:00',2.37),('8998','2013-08-07','10:05:00',2.4),('8998','2013-08-07','10:10:00',2.43),('8998','2013-08-07','10:15:00',2.45),('8998','2013-08-07','10:20:00',2.45),('8998','2013-08-07','10:25:00',2.47),('8998','2013-08-07','10:30:00',2.5),('8998','2013-08-07','10:35:00',2.5),('8998','2013-08-07','10:40:00',2.52),('8998','2013-08-07','10:45:00',2.54),('8998','2013-08-07','10:50:00',2.55),('8998','2013-08-07','10:55:00',2.56),('8998','2013-08-07','11:00:00',2.56),('8998','2013-08-07','11:05:00',2.58),('8998','2013-08-07','11:10:00',2.59),('8998','2013-08-07','11:15:00',2.59),('8998','2013-08-07','11:20:00',2.6),('8998','2013-08-07','11:25:00',2.6),('8998','2013-08-07','11:30:00',2.56),('8998','2013-08-07','11:35:00',2.58),('8998','2013-08-07','11:40:00',2.61),('8998','2013-08-07','11:45:00',2.59),('8998','2013-08-07','11:50:00',2.58),('8998','2013-08-07','11:55:00',2.59),('8998','2013-08-07','12:00:00',2.62),('8998','2013-08-07','12:05:00',2.6),('8998','2013-08-07','12:10:00',2.57),('8998','2013-08-07','12:15:00',2.58),('8998','2013-08-07','12:20:00',2.56),('8998','2013-08-07','12:25:00',2.57),('8998','2013-08-07','12:30:00',2.59),('8998','2013-08-07','12:35:00',2.6),('8998','2013-08-07','12:40:00',2.56),('8998','2013-08-07','12:45:00',2.56),('8998','2013-08-07','12:50:00',2.55),('8998','2013-08-07','12:55:00',2.55),('8998','2013-08-07','13:00:00',2.52),('8998','2013-08-07','13:05:00',2.53),('8998','2013-08-07','13:10:00',2.51),('8998','2013-08-07','13:15:00',2.49),('8998','2013-08-07','13:20:00',2.47),('8998','2013-08-07','13:25:00',2.47),('8998','2013-08-07','13:30:00',2.45),('8998','2013-08-07','13:35:00',2.42),('8998','2013-08-07','13:40:00',2.39),('8998','2013-08-07','13:45:00',2.34),('8998','2013-08-07','13:50:00',2.34),('8998','2013-08-07','13:55:00',2.31),('8998','2013-08-07','14:00:00',2.31),('8998','2013-08-07','14:05:00',2.28),('8998','2013-08-07','14:10:00',2.24),('8998','2013-08-07','14:15:00',2.21),('8998','2013-08-07','14:20:00',2.18),('8998','2013-08-07','14:25:00',2.14),('8998','2013-08-07','14:30:00',2.12),('8998','2013-08-07','14:35:00',2.09),('8998','2013-08-07','14:40:00',2.06),('8998','2013-08-07','14:45:00',2.02),('8998','2013-08-07','14:50:00',1.99),('8998','2013-08-07','14:55:00',1.94),('8998','2013-08-07','15:00:00',1.91),('8998','2013-08-07','15:05:00',1.86),('8998','2013-08-07','15:10:00',1.81),('8998','2013-08-07','15:15:00',1.79),('8998','2013-08-07','15:20:00',1.74),('8998','2013-08-07','15:25:00',1.7),('8998','2013-08-07','15:30:00',1.66),('8998','2013-08-07','15:35:00',1.6),('8998','2013-08-07','15:40:00',1.55),('8998','2013-08-07','15:45:00',1.52),('8998','2013-08-07','15:50:00',1.47),('8998','2013-08-07','15:55:00',1.42),('8998','2013-08-07','16:00:00',1.38),('8998','2013-08-07','16:05:00',1.33),('8998','2013-08-07','16:10:00',1.29),('8998','2013-08-07','16:15:00',1.25),('8998','2013-08-07','16:20:00',1.2),('8998','2013-08-07','16:25:00',1.16),('8998','2013-08-07','16:30:00',1.11),('8998','2013-08-07','16:35:00',1.06),('8998','2013-08-07','16:40:00',1.02),('8998','2013-08-06','07:50:00',1.01),('8998','2013-08-06','07:55:00',1.03),('8998','2013-08-06','08:00:00',1.04),('8998','2013-08-06','08:05:00',1.09),('8998','2013-08-06','08:10:00',1.15),('8998','2013-08-06','08:15:00',1.25),('8998','2013-08-06','08:20:00',1.24),('8998','2013-08-06','08:25:00',1.27),('8998','2013-08-06','08:30:00',1.31),('8998','2013-08-06','08:35:00',1.34),('8998','2013-08-06','08:40:00',1.42),('8998','2013-08-06','08:45:00',1.44),('8998','2013-08-06','08:50:00',1.6),('8998','2013-08-06','08:55:00',1.63),('8998','2013-08-06','09:00:00',1.88),('8998','2013-08-06','09:05:00',1.88),('8998','2013-08-06','09:10:00',1.88),('8998','2013-08-06','09:15:00',1.9),('8998','2013-08-06','09:20:00',1.79),('8998','2013-08-06','09:25:00',1.76),('8998','2013-08-06','09:30:00',1.98),('8998','2013-08-06','09:35:00',2.11),('8998','2013-08-06','09:40:00',2.24),('8998','2013-08-06','09:45:00',2.28),('8998','2013-08-06','09:50:00',2.33),('8998','2013-08-06','09:55:00',2.37),('8998','2013-08-06','10:00:00',2.41),('8998','2013-08-06','10:05:00',2.41),('8998','2013-08-06','10:10:00',2.47),('8998','2013-08-06','10:15:00',2.47),('8998','2013-08-06','10:20:00',2.52),('8998','2013-08-06','10:25:00',2.53),('8998','2013-08-06','10:30:00',2.54),('8998','2013-08-06','10:35:00',2.52),('8998','2013-08-06','10:40:00',2.55),('8998','2013-08-06','10:45:00',2.58),('8998','2013-08-06','10:50:00',2.6),('8998','2013-08-06','10:55:00',2.6),('8998','2013-08-06','11:00:00',2.6),('8998','2013-08-06','11:05:00',2.61),('8998','2013-08-06','11:10:00',2.61),('8998','2013-08-06','11:15:00',2.63),('8998','2013-08-06','11:20:00',2.64),('8998','2013-08-06','11:25:00',2.65),('8998','2013-08-06','11:30:00',2.64),('8998','2013-08-06','11:35:00',2.64),('8998','2013-08-06','11:40:00',2.63),('8998','2013-08-06','11:45:00',2.63),('8998','2013-08-06','11:50:00',2.63),('8998','2013-08-06','11:55:00',2.62),('8998','2013-08-06','12:00:00',2.65),('8998','2013-08-06','12:05:00',2.63),('8998','2013-08-06','12:10:00',2.64),('8998','2013-08-06','12:15:00',2.62),('8998','2013-08-06','12:20:00',2.61),('8998','2013-08-06','12:25:00',2.59),('8998','2013-08-06','12:30:00',2.57),('8998','2013-08-06','12:35:00',2.58),('8998','2013-08-06','12:40:00',2.53),('8998','2013-08-06','12:45:00',2.52),('8998','2013-08-06','12:50:00',2.53),('8998','2013-08-06','12:55:00',2.53),('8998','2013-08-06','13:00:00',2.51),('8998','2013-08-06','13:05:00',2.51),('8998','2013-08-06','13:10:00',2.52),('8998','2013-08-06','13:15:00',2.48),('8998','2013-08-06','13:20:00',2.5),('8998','2013-08-06','13:25:00',2.44),('8998','2013-08-06','13:30:00',2.45),('8998','2013-08-06','13:35:00',2.34),('8998','2013-08-06','13:40:00',2.4),('8998','2013-08-06','13:45:00',2.4),('8998','2013-08-06','13:50:00',2.34),('8998','2013-08-06','13:55:00',2.36),('8998','2013-08-06','14:00:00',2.3),('8998','2013-08-06','14:05:00',2.31),('8998','2013-08-06','14:10:00',2.3),('8998','2013-08-06','14:15:00',2.2),('8998','2013-08-06','14:20:00',2.19),('8998','2013-08-06','14:25:00',2.14),('8998','2013-08-06','14:30:00',2.1),('8998','2013-08-06','14:35:00',2.07),('8998','2013-08-06','14:40:00',2.06),('8998','2013-08-06','14:45:00',2.07),('8998','2013-08-06','14:50:00',2.02),('8998','2013-08-06','14:55:00',1.99),('8998','2013-08-06','15:00:00',1.95),('8998','2013-08-06','15:05:00',1.9),('8998','2013-08-06','15:10:00',1.87),('8998','2013-08-06','15:15:00',1.82),('8998','2013-08-06','15:20:00',1.79),('8998','2013-08-06','15:25:00',1.74),('8998','2013-08-06','15:30:00',1.71),('8998','2013-08-06','15:35:00',1.66),('8998','2013-08-06','15:40:00',1.61),('8998','2013-08-06','15:45:00',1.56),('8998','2013-08-06','15:50:00',1.51),('8998','2013-08-06','15:55:00',1.46),('8998','2013-08-06','16:00:00',1.39),('8998','2013-08-06','16:05:00',1.36),('8998','2013-08-06','16:10:00',1.31),('8998','2013-08-06','16:15:00',1.26),('8998','2013-08-06','16:20:00',1.22),('8998','2013-08-06','16:25:00',1.18),('8998','2013-08-06','16:30:00',1.13),('8998','2013-08-06','16:35:00',1.08),('8998','2013-08-06','16:40:00',1.02),('8998','2013-08-05','08:00:00',1.05),('8998','2013-08-05','08:05:00',1.09),('8998','2013-08-05','08:10:00',1.17),('8998','2013-08-05','08:15:00',1.23),('8998','2013-08-05','08:20:00',1.26),('8998','2013-08-05','08:25:00',1.27),('8998','2013-08-05','08:30:00',1.33),('8998','2013-08-05','08:35:00',1.34),('8998','2013-08-05','08:40:00',1.41),('8998','2013-08-05','08:45:00',1.43),('8998','2013-08-05','08:50:00',1.46),('8998','2013-08-05','08:55:00',1.49),('8998','2013-08-05','09:00:00',1.51),('8998','2013-08-05','09:05:00',1.54),('8998','2013-08-05','09:10:00',1.59),('8998','2013-08-05','09:15:00',1.61),('8998','2013-08-05','09:20:00',1.69),('8998','2013-08-05','09:25:00',1.78),('8998','2013-08-05','09:30:00',1.89),('8998','2013-08-05','09:35:00',2.09),('8998','2013-08-05','09:40:00',2.23),('8998','2013-08-05','09:45:00',2.3),('8998','2013-08-05','09:50:00',2.33),('8998','2013-08-05','09:55:00',2.33),('8998','2013-08-05','10:00:00',2.38),('8998','2013-08-05','10:05:00',2.41),('8998','2013-08-05','10:10:00',2.43),('8998','2013-08-05','10:15:00',2.45),('8998','2013-08-05','10:20:00',2.48),('8998','2013-08-05','10:25:00',2.49),('8998','2013-08-05','10:30:00',2.5),('8998','2013-08-05','10:35:00',2.51),('8998','2013-08-05','10:40:00',2.52),('8998','2013-08-05','10:45:00',2.54),('8998','2013-08-05','10:50:00',2.55),('8998','2013-08-05','10:55:00',2.55),('8998','2013-08-05','11:00:00',2.56),('8998','2013-08-05','11:05:00',2.59),('8998','2013-08-05','11:10:00',2.61),('8998','2013-08-05','11:15:00',2.62),('8998','2013-08-05','11:20:00',2.64),('8998','2013-08-05','11:25:00',2.63),('8998','2013-08-05','11:30:00',2.65),('8998','2013-08-05','11:35:00',2.66),('8998','2013-08-05','11:40:00',2.65),('8998','2013-08-05','11:45:00',2.64),('8998','2013-08-05','11:50:00',2.63),('8998','2013-08-05','11:55:00',2.63),('8998','2013-08-05','12:00:00',2.65),('8998','2013-08-05','12:05:00',2.64),('8998','2013-08-05','12:10:00',2.64),('8998','2013-08-05','12:15:00',2.63),('8998','2013-08-05','12:20:00',2.61),('8998','2013-08-05','12:25:00',2.57),('8998','2013-08-05','12:30:00',2.58),('8998','2013-08-05','12:35:00',2.57),('8998','2013-08-05','12:40:00',2.56),('8998','2013-08-05','12:45:00',2.53),('8998','2013-08-05','12:50:00',2.52),('8998','2013-08-05','12:55:00',2.54),('8998','2013-08-05','13:00:00',2.53),('8998','2013-08-05','13:05:00',2.53),('8998','2013-08-05','13:10:00',2.5),('8998','2013-08-05','13:15:00',2.5),('8998','2013-08-05','13:20:00',2.49),('8998','2013-08-05','13:25:00',2.48),('8998','2013-08-05','13:30:00',2.46),('8998','2013-08-05','13:35:00',2.45),('8998','2013-08-05','13:40:00',2.43),('8998','2013-08-05','13:45:00',2.42),('8998','2013-08-05','13:50:00',2.41),('8998','2013-08-05','13:55:00',2.39),('8998','2013-08-05','14:00:00',2.38),('8998','2013-08-05','14:05:00',2.35),('8998','2013-08-05','14:10:00',2.32),('8998','2013-08-05','14:15:00',2.3),('8998','2013-08-05','14:20:00',2.27),('8998','2013-08-05','14:25:00',2.24),('8998','2013-08-05','14:30:00',2.22),('8998','2013-08-05','14:35:00',2.18),('8998','2013-08-05','14:40:00',2.14),('8998','2013-08-05','14:45:00',2.1),('8998','2013-08-05','14:50:00',2.07),('8998','2013-08-05','14:55:00',2.04),('8998','2013-08-05','15:00:00',2.01),('8998','2013-08-05','15:05:00',1.97),('8998','2013-08-05','15:10:00',1.92),('8998','2013-08-05','15:15:00',1.88),('8998','2013-08-05','15:20:00',1.84),('8998','2013-08-05','15:25:00',1.8),('8998','2013-08-05','15:30:00',1.75),('8998','2013-08-05','15:35:00',1.71),('8998','2013-08-05','15:40:00',1.66),('8998','2013-08-05','15:45:00',1.61),('8998','2013-08-05','15:50:00',1.57),('8998','2013-08-05','15:55:00',1.52),('8998','2013-08-05','16:00:00',1.47),('8998','2013-08-05','16:05:00',1.41),('8998','2013-08-05','16:10:00',1.36),('8998','2013-08-05','16:15:00',1.31),('8998','2013-08-05','16:20:00',1.27),('8998','2013-08-05','16:25:00',1.21),('8998','2013-08-05','16:30:00',1.17),('8998','2013-08-05','16:35:00',1.11),('8998','2013-08-05','16:40:00',1.06),('8998','2013-08-05','16:45:00',1.01),('8998','2013-08-04','07:50:00',1.08),('8998','2013-08-04','07:55:00',1.08),('8998','2013-08-04','08:00:00',1.1),('8998','2013-08-04','08:05:00',1.14),('8998','2013-08-04','08:10:00',1.21),('8998','2013-08-04','08:15:00',1.27),('8998','2013-08-04','08:20:00',1.32),('8998','2013-08-04','08:25:00',1.3),('8998','2013-08-04','08:30:00',1.36),('8998','2013-08-04','08:35:00',1.37),('8998','2013-08-04','08:40:00',1.43),('8998','2013-08-04','08:45:00',1.47),('8998','2013-08-04','08:50:00',1.49),('8998','2013-08-04','08:55:00',1.52),('8998','2013-08-04','09:00:00',1.55),('8998','2013-08-04','09:05:00',1.56),('8998','2013-08-04','09:10:00',1.61),('8998','2013-08-04','09:15:00',1.64),('8998','2013-08-04','09:20:00',1.68),('8998','2013-08-04','09:25:00',1.82),('8998','2013-08-04','09:30:00',1.91),('8998','2013-08-04','09:35:00',2.14),('8998','2013-08-04','09:40:00',2.26),('8998','2013-08-04','09:45:00',2.31),('8998','2013-08-04','09:50:00',2.34),('8998','2013-08-04','09:55:00',2.38),('8998','2013-08-04','10:00:00',2.41),('8998','2013-08-04','10:05:00',2.44),('8998','2013-08-04','10:10:00',2.47),('8998','2013-08-04','10:15:00',2.48),('8998','2013-08-04','10:20:00',2.52),('8998','2013-08-04','10:25:00',2.55),('8998','2013-08-04','10:30:00',2.56),('8998','2013-08-04','10:35:00',2.56),('8998','2013-08-04','10:40:00',2.58),('8998','2013-08-04','10:45:00',2.6),('8998','2013-08-04','10:50:00',2.62),('8998','2013-08-04','10:55:00',2.64),('8998','2013-08-04','11:00:00',2.64),('8998','2013-08-04','11:05:00',2.67),('8998','2013-08-04','11:10:00',2.68),('8998','2013-08-04','11:15:00',2.69),('8998','2013-08-04','11:20:00',2.71),('8998','2013-08-04','11:25:00',2.71),('8998','2013-08-04','11:30:00',2.7),('8998','2013-08-04','11:35:00',2.7),('8998','2013-08-04','11:40:00',2.69),('8998','2013-08-04','11:45:00',2.7),('8998','2013-08-04','11:50:00',2.7),('8998','2013-08-04','11:55:00',2.7),('8998','2013-08-04','12:00:00',2.7),('8998','2013-08-04','12:05:00',2.69),('8998','2013-08-04','12:10:00',2.69),('8998','2013-08-04','12:15:00',2.68),('8998','2013-08-04','12:20:00',2.68),('8998','2013-08-04','12:25:00',2.68),('8998','2013-08-04','12:30:00',2.66),('8998','2013-08-04','12:35:00',2.64),('8998','2013-08-04','12:40:00',2.65),('8998','2013-08-04','12:45:00',2.66),('8998','2013-08-04','12:50:00',2.62),('8998','2013-08-04','12:55:00',2.59),('8998','2013-08-04','13:00:00',2.61),('8998','2013-08-04','13:05:00',2.6),('8998','2013-08-04','13:10:00',2.53),('8998','2013-08-04','13:15:00',2.53),('8998','2013-08-04','13:20:00',2.52),('8998','2013-08-04','13:25:00',2.49),('8998','2013-08-04','13:30:00',2.47),('8998','2013-08-04','13:35:00',2.47),('8998','2013-08-04','13:40:00',2.45),('8998','2013-08-04','13:45:00',2.43),('8998','2013-08-04','13:50:00',2.39),('8998','2013-08-04','13:55:00',2.33),('8998','2013-08-04','14:00:00',2.31),('8998','2013-08-04','14:05:00',2.32),('8998','2013-08-04','14:10:00',2.27),('8998','2013-08-04','14:15:00',2.25),('8998','2013-08-04','14:20:00',2.24),('8998','2013-08-04','14:25:00',2.18),('8998','2013-08-04','14:30:00',2.17),('8998','2013-08-04','14:35:00',2.14),('8998','2013-08-04','14:40:00',2.11),('8998','2013-08-04','14:45:00',2.08),('8998','2013-08-04','14:50:00',2.04),('8998','2013-08-04','14:55:00',2.01),('8998','2013-08-04','15:00:00',1.96),('8998','2013-08-04','15:05:00',1.93),('8998','2013-08-04','15:10:00',1.89),('8998','2013-08-04','15:15:00',1.86),('8998','2013-08-04','15:20:00',1.81),('8998','2013-08-04','15:25:00',1.78),('8998','2013-08-04','15:30:00',1.75),('8998','2013-08-04','15:35:00',1.7),('8998','2013-08-04','15:40:00',1.65),('8998','2013-08-04','15:45:00',1.6),('8998','2013-08-04','15:50:00',1.54),('8998','2013-08-04','15:55:00',1.5),('8998','2013-08-04','16:00:00',1.46),('8998','2013-08-04','16:05:00',1.43),('8998','2013-08-04','16:10:00',1.37),('8998','2013-08-04','16:15:00',1.31),('8998','2013-08-04','16:20:00',1.26),('8998','2013-08-04','16:25:00',1.21),('8998','2013-08-04','16:30:00',1.16),('8998','2013-08-04','16:35:00',1.12),('8998','2013-08-04','16:40:00',1.06),('8998','2013-08-04','16:45:00',1.01),('8998','2013-08-03','07:45:00',1.08),('8998','2013-08-03','07:50:00',1.16),('8998','2013-08-03','07:55:00',1.16),('8998','2013-08-03','08:00:00',1.3),('8998','2013-08-03','08:05:00',1.16),('8998','2013-08-03','08:10:00',1.25),('8998','2013-08-03','08:15:00',1.3),('8998','2013-08-03','08:20:00',1.33),('8998','2013-08-03','08:25:00',1.34),('8998','2013-08-03','08:30:00',1.54),('8998','2013-08-03','08:35:00',1.54),('8998','2013-08-03','08:40:00',1.87),('8998','2013-08-03','08:45:00',1.88),('8998','2013-08-03','08:50:00',1.82),('8998','2013-08-03','08:55:00',1.93),('8998','2013-08-03','09:00:00',2.05),('8998','2013-08-03','09:05:00',2.08),('8998','2013-08-03','09:10:00',2.06),('8998','2013-08-03','09:15:00',2.04),('8998','2013-08-03','09:20:00',2.04),('8998','2013-08-03','09:25:00',1.88),('8998','2013-08-03','09:30:00',1.99),('8998','2013-08-03','09:35:00',2.24),('8998','2013-08-03','09:40:00',2.42),('8998','2013-08-03','09:45:00',2.45),('8998','2013-08-03','09:50:00',2.48),('8998','2013-08-03','09:55:00',2.5),('8998','2013-08-03','10:00:00',2.53),('8998','2013-08-03','10:05:00',2.56),('8998','2013-08-03','10:10:00',2.57),('8998','2013-08-03','10:15:00',2.59),('8998','2013-08-03','10:20:00',2.62),('8998','2013-08-03','10:25:00',2.65),('8998','2013-08-03','10:30:00',2.67),('8998','2013-08-03','10:35:00',2.68),('8998','2013-08-03','10:40:00',2.69),('8998','2013-08-03','10:45:00',2.69),('8998','2013-08-03','10:50:00',2.7),('8998','2013-08-03','10:55:00',2.7),('8998','2013-08-03','11:00:00',2.7),('8998','2013-08-03','11:05:00',2.7),('8998','2013-08-03','11:10:00',2.71),('8998','2013-08-03','11:15:00',2.72),('8998','2013-08-03','11:20:00',2.74),('8998','2013-08-03','11:25:00',2.75),('8998','2013-08-03','11:30:00',2.76),('8998','2013-08-03','11:35:00',2.78),('8998','2013-08-03','11:40:00',2.78),('8998','2013-08-03','11:45:00',2.77),('8998','2013-08-03','11:50:00',2.77),('8998','2013-08-03','11:55:00',2.79),('8998','2013-08-03','12:00:00',2.79),('8998','2013-08-03','12:05:00',2.78),('8998','2013-08-03','12:10:00',2.78),('8998','2013-08-03','12:15:00',2.76),('8998','2013-08-03','12:20:00',2.75),('8998','2013-08-03','12:25:00',2.73),('8998','2013-08-03','12:30:00',2.72),('8998','2013-08-03','12:35:00',2.71),('8998','2013-08-03','12:40:00',2.72),('8998','2013-08-03','12:45:00',2.69),('8998','2013-08-03','12:50:00',2.69),('8998','2013-08-03','12:55:00',2.64),('8998','2013-08-03','13:00:00',2.64),('8998','2013-08-03','13:05:00',2.66),('8998','2013-08-03','13:10:00',2.6),('8998','2013-08-03','13:15:00',2.58),('8998','2013-08-03','13:20:00',2.56),('8998','2013-08-03','13:25:00',2.52),('8998','2013-08-03','13:30:00',2.52),('8998','2013-08-03','13:35:00',2.53),('8998','2013-08-03','13:40:00',2.52),('8998','2013-08-03','13:45:00',2.52),('8998','2013-08-03','13:50:00',2.5),('8998','2013-08-03','13:55:00',2.46),('8998','2013-08-03','14:00:00',2.45),('8998','2013-08-03','14:05:00',2.43),('8998','2013-08-03','14:10:00',2.39),('8998','2013-08-03','14:15:00',2.37),('8998','2013-08-03','14:20:00',2.32),('8998','2013-08-03','14:25:00',2.3),('8998','2013-08-03','14:30:00',2.27),('8998','2013-08-03','14:35:00',2.25),('8998','2013-08-03','14:40:00',2.22),('8998','2013-08-03','14:45:00',2.17),('8998','2013-08-03','14:50:00',2.13),('8998','2013-08-03','14:55:00',2.09),('8998','2013-08-03','15:00:00',2.05),('8998','2013-08-03','15:05:00',2.01),('8998','2013-08-03','15:10:00',1.98),('8998','2013-08-03','15:15:00',1.93),('8998','2013-08-03','15:20:00',1.89),('8998','2013-08-03','15:25:00',1.83),('8998','2013-08-03','15:30:00',1.77),('8998','2013-08-03','15:35:00',1.76),('8998','2013-08-03','15:40:00',1.7),('8998','2013-08-03','15:45:00',1.65),('8998','2013-08-03','15:50:00',1.59),('8998','2013-08-03','15:55:00',1.54),('8998','2013-08-03','16:00:00',1.5),('8998','2013-08-03','16:05:00',1.44),('8998','2013-08-03','16:10:00',1.39),('8998','2013-08-03','16:15:00',1.35),('8998','2013-08-03','16:20:00',1.31),('8998','2013-08-03','16:25:00',1.25),('8998','2013-08-03','16:30:00',1.2),('8998','2013-08-03','16:35:00',1.14),('8998','2013-08-03','16:40:00',1.09),('8998','2013-08-03','16:45:00',1.03),('8998','2013-08-02','07:40:00',1.05),('8998','2013-08-02','07:45:00',1.1),('8998','2013-08-02','07:50:00',1.16),('8998','2013-08-02','07:55:00',1.28),('8998','2013-08-02','08:00:00',1.28),('8998','2013-08-02','08:05:00',1.18),('8998','2013-08-02','08:10:00',1.26),('8998','2013-08-02','08:15:00',1.32),('8998','2013-08-02','08:20:00',1.31),('8998','2013-08-02','08:25:00',1.29),('8998','2013-08-02','08:30:00',1.33),('8998','2013-08-02','08:35:00',1.35),('8998','2013-08-02','08:40:00',1.43),('8998','2013-08-02','08:45:00',1.48),('8998','2013-08-02','08:50:00',1.48),('8998','2013-08-02','08:55:00',1.73),('8998','2013-08-02','09:00:00',1.68),('8998','2013-08-02','09:05:00',1.61),('8998','2013-08-02','09:10:00',1.55),('8998','2013-08-02','09:15:00',1.69),('8998','2013-08-02','09:20:00',1.68),('8998','2013-08-02','09:25:00',1.84),('8998','2013-08-02','09:30:00',2.03),('8998','2013-08-02','09:35:00',2.25),('8998','2013-08-02','09:40:00',2.4),('8998','2013-08-02','09:45:00',2.43),('8998','2013-08-02','09:50:00',2.47),('8998','2013-08-02','09:55:00',2.5),('8998','2013-08-02','10:00:00',2.52),('8998','2013-08-02','10:05:00',2.55),('8998','2013-08-02','10:10:00',2.56),('8998','2013-08-02','10:15:00',2.6),('8998','2013-08-02','10:20:00',2.6),('8998','2013-08-02','10:25:00',2.62),('8998','2013-08-02','10:30:00',2.62),('8998','2013-08-02','10:35:00',2.62),('8998','2013-08-02','10:40:00',2.69),('8998','2013-08-02','10:45:00',2.71),('8998','2013-08-02','10:50:00',2.71),('8998','2013-08-02','10:55:00',2.73),('8998','2013-08-02','11:00:00',2.75),('8998','2013-08-02','11:05:00',2.74),('8998','2013-08-02','11:10:00',2.73),('8998','2013-08-02','11:15:00',2.76),('8998','2013-08-02','11:20:00',2.75),('8998','2013-08-02','11:25:00',2.77),('8998','2013-08-02','11:30:00',2.77),('8998','2013-08-02','11:35:00',2.75),('8998','2013-08-02','11:40:00',2.75),('8998','2013-08-02','11:45:00',2.73),('8998','2013-08-02','11:50:00',2.76),('8998','2013-08-02','11:55:00',2.76),('8998','2013-08-02','12:00:00',2.75),('8998','2013-08-02','12:05:00',2.78),('8998','2013-08-02','12:10:00',2.76),('8998','2013-08-02','12:15:00',2.75),('8998','2013-08-02','12:20:00',2.74),('8998','2013-08-02','12:25:00',2.74),('8998','2013-08-02','12:30:00',2.74),('8998','2013-08-02','12:35:00',2.71),('8998','2013-08-02','12:40:00',2.71),('8998','2013-08-02','12:45:00',2.7),('8998','2013-08-02','12:50:00',2.7),('8998','2013-08-02','12:55:00',2.68),('8998','2013-08-02','13:00:00',2.63),('8998','2013-08-02','13:05:00',2.59),('8998','2013-08-02','13:10:00',2.56),('8998','2013-08-02','13:15:00',2.53),('8998','2013-08-02','13:20:00',2.48),('8998','2013-08-02','13:25:00',2.47),('8998','2013-08-02','13:30:00',2.45),('8998','2013-08-02','13:35:00',2.38),('8998','2013-08-02','13:40:00',2.43),('8998','2013-08-02','13:45:00',2.43),('8998','2013-08-02','13:50:00',2.41),('8998','2013-08-02','13:55:00',2.4),('8998','2013-08-02','14:00:00',2.43),('8998','2013-08-02','14:05:00',2.4),('8998','2013-08-02','14:10:00',2.3),('8998','2013-08-02','14:15:00',2.24),('8998','2013-08-02','14:20:00',2.18),('8998','2013-08-02','14:25:00',2.14),('8998','2013-08-02','14:30:00',2.17),('8998','2013-08-02','14:35:00',2.19),('8998','2013-08-02','14:40:00',2.14),('8998','2013-08-02','14:45:00',2.13),('8998','2013-08-02','14:50:00',2.09),('8998','2013-08-02','14:55:00',2.07),('8998','2013-08-02','15:00:00',2.03),('8998','2013-08-02','15:05:00',1.98),('8998','2013-08-02','15:10:00',1.94),('8998','2013-08-02','15:15:00',1.89),('8998','2013-08-02','15:20:00',1.88),('8998','2013-08-02','15:25:00',1.84),('8998','2013-08-02','15:30:00',1.79),('8998','2013-08-02','15:35:00',1.75),('8998','2013-08-02','15:40:00',1.7),('8998','2013-08-02','15:45:00',1.65),('8998','2013-08-02','15:50:00',1.61),('8998','2013-08-02','15:55:00',1.55),('8998','2013-08-02','16:00:00',1.49),('8998','2013-08-02','16:05:00',1.44),('8998','2013-08-02','16:10:00',1.39),('8998','2013-08-02','16:15:00',1.33),('8998','2013-08-02','16:20:00',1.28),('8998','2013-08-02','16:25:00',1.23),('8998','2013-08-02','16:30:00',1.18),('8998','2013-08-02','16:35:00',1.13),('8998','2013-08-02','16:40:00',1.08),('8998','2013-08-02','16:45:00',1.03),('8998','2013-08-01','07:35:00',1.01),('8998','2013-08-01','07:40:00',1.11),('8998','2013-08-01','07:45:00',1.19),('8998','2013-08-01','07:50:00',1.26),('8998','2013-08-01','07:55:00',1.23),('8998','2013-08-01','08:00:00',1.19),('8998','2013-08-01','08:05:00',1.26),('8998','2013-08-01','08:10:00',1.29),('8998','2013-08-01','08:15:00',1.39),('8998','2013-08-01','08:20:00',1.37),('8998','2013-08-01','08:25:00',1.35),('8998','2013-08-01','08:30:00',1.36),('8998','2013-08-01','08:35:00',1.41),('8998','2013-08-01','08:40:00',1.53),('8998','2013-08-01','08:45:00',1.53),('8998','2013-08-01','08:50:00',1.57),('8998','2013-08-01','08:55:00',1.84),('8998','2013-08-01','09:00:00',1.74),('8998','2013-08-01','09:05:00',1.67),('8998','2013-08-01','09:10:00',1.58),('8998','2013-08-01','09:15:00',1.77),('8998','2013-08-01','09:20:00',1.76),('8998','2013-08-01','09:25:00',1.92),('8998','2013-08-01','09:30:00',2.14),('8998','2013-08-01','09:35:00',2.36),('8998','2013-08-01','09:40:00',2.48),('8998','2013-08-01','09:45:00',2.5),('8998','2013-08-01','09:50:00',2.54),('8998','2013-08-01','09:55:00',2.55),('8998','2013-08-01','10:00:00',2.55),('8998','2013-08-01','10:05:00',2.59),('8998','2013-08-01','10:10:00',2.62),('8998','2013-08-01','10:15:00',2.64),('8998','2013-08-01','10:20:00',2.65),('8998','2013-08-01','10:25:00',2.66),('8998','2013-08-01','10:30:00',2.68),('8998','2013-08-01','10:35:00',2.71),('8998','2013-08-01','10:40:00',2.72),('8998','2013-08-01','10:45:00',2.74),('8998','2013-08-01','10:50:00',2.76),('8998','2013-08-01','10:55:00',2.76),('8998','2013-08-01','11:00:00',2.76),('8998','2013-08-01','11:05:00',2.77),('8998','2013-08-01','11:10:00',2.77),('8998','2013-08-01','11:15:00',2.78),('8998','2013-08-01','11:20:00',2.8),('8998','2013-08-01','11:25:00',2.82),('8998','2013-08-01','11:30:00',2.83),('8998','2013-08-01','11:35:00',2.82),('8998','2013-08-01','11:40:00',2.8),('8998','2013-08-01','11:45:00',2.82),('8998','2013-08-01','11:50:00',2.81),('8998','2013-08-01','11:55:00',2.83),('8998','2013-08-01','12:00:00',2.83),('8998','2013-08-01','12:05:00',2.82),('8998','2013-08-01','12:10:00',2.83),('8998','2013-08-01','12:15:00',2.8),('8998','2013-08-01','12:20:00',2.79),('8998','2013-08-01','12:25:00',2.75),('8998','2013-08-01','12:30:00',2.73),('8998','2013-08-01','12:35:00',2.73),('8998','2013-08-01','12:40:00',2.72),('8998','2013-08-01','12:45:00',2.7),('8998','2013-08-01','12:50:00',2.68),('8998','2013-08-01','12:55:00',2.65),('8998','2013-08-01','13:00:00',2.68),('8998','2013-08-01','13:05:00',2.69),('8998','2013-08-01','13:10:00',2.7),('8998','2013-08-01','13:15:00',2.68),('8998','2013-08-01','13:20:00',2.65),('8998','2013-08-01','13:25:00',2.6),('8998','2013-08-01','13:30:00',2.61),('8998','2013-08-01','13:35:00',2.6),('8998','2013-08-01','13:40:00',2.55),('8998','2013-08-01','13:45:00',2.51),('8998','2013-08-01','13:50:00',2.49),('8998','2013-08-01','13:55:00',2.47),('8998','2013-08-01','14:00:00',2.45),('8998','2013-08-01','14:05:00',2.42),('8998','2013-08-01','14:10:00',2.39),('8998','2013-08-01','14:15:00',2.36),('8998','2013-08-01','14:20:00',2.3),('8998','2013-08-01','14:25:00',2.25),('8998','2013-08-01','14:30:00',2.28),('8998','2013-08-01','14:35:00',2.28),('8998','2013-08-01','14:40:00',2.23),('8998','2013-08-01','14:45:00',2.21),('8998','2013-08-01','14:50:00',2.16),('8998','2013-08-01','14:55:00',2.12),('8998','2013-08-01','15:00:00',2.08),('8998','2013-08-01','15:05:00',2.05),('8998','2013-08-01','15:10:00',1.98),('8998','2013-08-01','15:15:00',1.91),('8998','2013-08-01','15:20:00',1.9),('8998','2013-08-01','15:25:00',1.86),('8998','2013-08-01','15:30:00',1.83),('8998','2013-08-01','15:35:00',1.78),('8998','2013-08-01','15:40:00',1.73),('8998','2013-08-01','15:45:00',1.7),('8998','2013-08-01','15:50:00',1.64),('8998','2013-08-01','15:55:00',1.57),('8998','2013-08-01','16:00:00',1.53),('8998','2013-08-01','16:05:00',1.49),('8998','2013-08-01','16:10:00',1.44),('8998','2013-08-01','16:15:00',1.38),('8998','2013-08-01','16:20:00',1.32),('8998','2013-08-01','16:25:00',1.26),('8998','2013-08-01','16:30:00',1.22),('8998','2013-08-01','16:35:00',1.18),('8998','2013-08-01','16:40:00',1.12),('8998','2013-08-01','16:45:00',1.07),('8998','2013-08-01','16:50:00',1.02),('8998','2013-07-31','07:35:00',1.06),('8998','2013-07-31','07:40:00',1.12),('8998','2013-07-31','07:45:00',1.23),('8998','2013-07-31','07:50:00',1.28),('8998','2013-07-31','07:55:00',1.28),('8998','2013-07-31','08:00:00',1.2),('8998','2013-07-31','08:05:00',1.22),('8998','2013-07-31','08:10:00',1.26),('8998','2013-07-31','08:15:00',1.37),('8998','2013-07-31','08:20:00',1.38),('8998','2013-07-31','08:25:00',1.4),('8998','2013-07-31','08:30:00',1.37),('8998','2013-07-31','08:35:00',1.48),('8998','2013-07-31','08:40:00',1.59),('8998','2013-07-31','08:45:00',1.57),('8998','2013-07-31','08:50:00',1.66),('8998','2013-07-31','08:55:00',1.85),('8998','2013-07-31','09:00:00',1.83),('8998','2013-07-31','09:05:00',1.73),('8998','2013-07-31','09:10:00',1.71),('8998','2013-07-31','09:15:00',1.82),('8998','2013-07-31','09:20:00',1.86),('8998','2013-07-31','09:25:00',2.02),('8998','2013-07-31','09:30:00',2.28),('8998','2013-07-31','09:35:00',2.46),('8998','2013-07-31','09:40:00',2.59),('8998','2013-07-31','09:45:00',2.63),('8998','2013-07-31','09:50:00',2.65),('8998','2013-07-31','09:55:00',2.68),('8998','2013-07-31','10:00:00',2.71),('8998','2013-07-31','10:05:00',2.75),('8998','2013-07-31','10:10:00',2.78),('8998','2013-07-31','10:15:00',2.79),('8998','2013-07-31','10:20:00',2.8),('8998','2013-07-31','10:25:00',2.83),('8998','2013-07-31','10:30:00',2.85),('8998','2013-07-31','10:35:00',2.85),('8998','2013-07-31','10:40:00',2.86),('8998','2013-07-31','10:45:00',2.88),('8998','2013-07-31','10:50:00',2.91),('8998','2013-07-31','10:55:00',2.91),('8998','2013-07-31','11:00:00',2.92),('8998','2013-07-31','11:05:00',2.94),('8998','2013-07-31','11:10:00',2.98),('8998','2013-07-31','11:15:00',3),('8998','2013-07-31','11:20:00',3),('8998','2013-07-31','11:25:00',3.01),('8998','2013-07-31','11:30:00',3),('8998','2013-07-31','11:35:00',3.02),('8998','2013-07-31','11:40:00',3.02),('8998','2013-07-31','11:45:00',3.03),('8998','2013-07-31','11:50:00',3.01),('8998','2013-07-31','11:55:00',3),('8998','2013-07-31','12:00:00',3.01),('8998','2013-07-31','12:05:00',3.01),('8998','2013-07-31','12:10:00',2.98),('8998','2013-07-31','12:15:00',3.01),('8998','2013-07-31','12:20:00',2.98),('8998','2013-07-31','12:25:00',2.96),('8998','2013-07-31','12:30:00',2.95),('8998','2013-07-31','12:35:00',2.95),('8998','2013-07-31','12:40:00',2.95),('8998','2013-07-31','12:45:00',2.91),('8998','2013-07-31','12:50:00',2.93),('8998','2013-07-31','12:55:00',2.9),('8998','2013-07-31','13:00:00',2.87),('8998','2013-07-31','13:05:00',2.84),('8998','2013-07-31','13:10:00',2.83),('8998','2013-07-31','13:15:00',2.8),('8998','2013-07-31','13:20:00',2.8),('8998','2013-07-31','13:25:00',2.8),('8998','2013-07-31','13:30:00',2.59),('8998','2013-07-31','13:35:00',2.71),('8998','2013-07-31','13:40:00',2.71),('8998','2013-07-31','13:45:00',2.66),('8998','2013-07-31','13:50:00',2.61),('8998','2013-07-31','13:55:00',2.53),('8998','2013-07-31','14:00:00',2.51),('8998','2013-07-31','14:05:00',2.58),('8998','2013-07-31','14:10:00',2.48),('8998','2013-07-31','14:15:00',2.45),('8998','2013-07-31','14:20:00',2.36),('8998','2013-07-31','14:25:00',2.4),('8998','2013-07-31','14:30:00',2.36),('8998','2013-07-31','14:35:00',1.88),('8998','2013-07-31','14:40:00',2.14),('8998','2013-07-31','14:45:00',1.9),('8998','2013-07-31','14:50:00',1.9),('8998','2013-07-31','14:55:00',2.2),('8998','2013-07-31','15:00:00',2.15),('8998','2013-07-31','15:05:00',2.12),('8998','2013-07-31','15:10:00',1.74),('8998','2013-07-31','15:15:00',1.84),('8998','2013-07-31','15:20:00',2.05),('8998','2013-07-31','15:25:00',1.98),('8998','2013-07-31','15:30:00',1.92),('8998','2013-07-31','15:35:00',1.7),('8998','2013-07-31','15:40:00',1.24),('8998','2013-07-31','15:45:00',1.76),('8998','2013-07-31','15:50:00',1.71),('8998','2013-07-31','15:55:00',1.67),('8998','2013-07-31','16:00:00',1.62),('8998','2013-07-31','16:05:00',1.56),('8998','2013-07-31','16:10:00',1.49),('8998','2013-07-31','16:15:00',1.43),('8998','2013-07-31','16:20:00',1.38),('8998','2013-07-31','16:25:00',1.32),('8998','2013-07-31','16:30:00',1.26),('8998','2013-07-31','16:35:00',1.21),('8998','2013-07-31','16:40:00',1.16),('8998','2013-07-31','16:45:00',1.1),('8998','2013-07-31','16:50:00',1.03),('8998','2013-07-30','07:40:00',1.18),('8998','2013-07-30','07:45:00',1.29),('8998','2013-07-30','07:50:00',1.34),('8998','2013-07-30','07:55:00',1.35),('8998','2013-07-30','08:00:00',1.25),('8998','2013-07-30','08:05:00',1.46),('8998','2013-07-30','08:10:00',1.5),('8998','2013-07-30','08:15:00',1.45),('8998','2013-07-30','08:20:00',1.74),('8998','2013-07-30','08:25:00',1.91),('8998','2013-07-30','08:30:00',1.86),('8998','2013-07-30','08:35:00',1.76),('8998','2013-07-30','08:40:00',1.94),('8998','2013-07-30','08:45:00',2.12),('8998','2013-07-30','08:50:00',2.08),('8998','2013-07-30','08:55:00',2.01),('8998','2013-07-30','09:00:00',1.96),('8998','2013-07-30','09:05:00',1.85),('8998','2013-07-30','09:10:00',2.33),('8998','2013-07-30','09:15:00',2.32),('8998','2013-07-30','09:20:00',2.26),('8998','2013-07-30','09:25:00',2.31),('8998','2013-07-30','09:30:00',2.39),('8998','2013-07-30','09:35:00',2.54),('8998','2013-07-30','09:40:00',2.61),('8998','2013-07-30','09:45:00',2.63),('8998','2013-07-30','09:50:00',2.67),('8998','2013-07-30','09:55:00',2.7),('8998','2013-07-30','10:00:00',2.71),('8998','2013-07-30','10:05:00',2.75),('8998','2013-07-30','10:10:00',2.76),('8998','2013-07-30','10:15:00',2.81),('8998','2013-07-30','10:20:00',2.81),('8998','2013-07-30','10:25:00',2.8),('8998','2013-07-30','10:30:00',2.82),('8998','2013-07-30','10:35:00',2.87),('8998','2013-07-30','10:40:00',2.9),('8998','2013-07-30','10:45:00',2.93),('8998','2013-07-30','10:50:00',2.95),('8998','2013-07-30','10:55:00',2.95),('8998','2013-07-30','11:00:00',2.99),('8998','2013-07-30','11:05:00',2.99),('8998','2013-07-30','11:10:00',3.01),('8998','2013-07-30','11:15:00',3.01),('8998','2013-07-30','11:20:00',3.02),('8998','2013-07-30','11:25:00',3.02),('8998','2013-07-30','11:30:00',3.01),('8998','2013-07-30','11:35:00',3.02),('8998','2013-07-30','11:40:00',3.03),('8998','2013-07-30','11:45:00',3.04),('8998','2013-07-30','11:50:00',3.05),('8998','2013-07-30','11:55:00',3.05),('8998','2013-07-30','12:00:00',3.05),('8998','2013-07-30','12:05:00',3.03),('8998','2013-07-30','12:10:00',3),('8998','2013-07-30','12:15:00',3),('8998','2013-07-30','12:20:00',3.01),('8998','2013-07-30','12:25:00',3.04),('8998','2013-07-30','12:30:00',2.99),('8998','2013-07-30','12:35:00',2.98),('8998','2013-07-30','12:40:00',2.99),('8998','2013-07-30','12:45:00',2.14),('8998','2013-07-30','12:50:00',2.14),('8998','2013-07-30','12:55:00',3.03),('8998','2013-07-30','13:00:00',1.21),('8998','2013-07-30','13:05:00',3.04),('8998','2013-07-30','13:10:00',2.82),('8998','2013-07-30','13:15:00',2.89),('8998','2013-07-30','13:20:00',2.66),('8998','2013-07-30','13:25:00',2.8),('8998','2013-07-30','13:30:00',2.8),('8998','2013-07-30','13:35:00',2.78),('8998','2013-07-30','13:40:00',2.81),('8998','2013-07-30','13:45:00',2.84),('8998','2013-07-30','13:50:00',2.37),('8998','2013-07-30','13:55:00',1.38),('8998','2013-07-30','14:00:00',2.36),('8998','2013-07-30','14:05:00',2.67),('8998','2013-07-30','14:10:00',2.1),('8998','2013-07-30','14:15:00',2.46),('8998','2013-07-30','14:20:00',2.6),('8998','2013-07-30','14:25:00',2.53),('8998','2013-07-30','14:30:00',2.44),('8998','2013-07-30','14:35:00',2.39),('8998','2013-07-30','14:40:00',2.4),('8998','2013-07-30','14:45:00',2.39),('8998','2013-07-30','14:50:00',1.97),('8998','2013-07-30','15:00:00',1.17),('8998','2013-07-30','15:05:00',2.18),('8998','2013-07-30','15:10:00',1.6),('8998','2013-07-30','15:15:00',1.17),('8998','2013-07-30','15:20:00',1.97),('8998','2013-07-30','15:25:00',1.8),('8998','2013-07-30','15:30:00',2.02),('8998','2013-07-30','15:35:00',1.71),('8998','2013-07-30','15:40:00',1.85),('8998','2013-07-30','15:45:00',1.77),('8998','2013-07-30','15:50:00',1.72),('8998','2013-07-30','15:55:00',1.65),('8998','2013-07-30','16:00:00',1.6),('8998','2013-07-30','16:05:00',1.58),('8998','2013-07-30','16:10:00',1.55),('8998','2013-07-30','16:15:00',1.5),('8998','2013-07-30','16:20:00',1.39),('8998','2013-07-30','16:25:00',1.36),('8998','2013-07-30','16:40:00',1.17),('8998','2013-07-30','16:45:00',1.1),('8998','2013-07-30','16:50:00',1.06),('8998','2014-04-07','08:15:00',1.18),('8998','2014-04-07','08:20:00',1.18),('8998','2014-04-07','08:25:00',1.21),('8998','2014-04-07','08:30:00',1.17),('8998','2014-04-07','08:35:00',1.09),('8998','2014-04-07','08:40:00',1.25),('8998','2014-04-07','08:45:00',1.39),('8998','2014-04-07','08:50:00',1.59),('8998','2014-04-07','08:55:00',1.79),('8998','2014-04-07','09:00:00',1.85),('8998','2014-04-07','09:05:00',1.91),('8998','2014-04-07','09:10:00',2),('8998','2014-04-07','09:15:00',2.11),('8998','2014-04-07','09:20:00',2.16),('8998','2014-04-07','09:25:00',2.22),('8998','2014-04-07','09:30:00',2.24),('8998','2014-04-07','09:35:00',2.28),('8998','2014-04-07','09:40:00',2.29),('8998','2014-04-07','09:45:00',2.32),('8998','2014-04-07','09:50:00',2.36),('8998','2014-04-07','09:55:00',2.37),('8998','2014-04-07','10:00:00',2.38),('8998','2014-04-07','10:05:00',2.38),('8998','2014-04-07','10:10:00',2.38),('8998','2014-04-07','10:15:00',2.52),('8998','2014-04-07','10:20:00',2.58),('8998','2014-04-07','10:25:00',2.57),('8998','2014-04-07','10:30:00',2.59),('8998','2014-04-07','10:35:00',2.57),('8998','2014-04-07','10:40:00',2.62),('8998','2014-04-07','10:45:00',2.66),('8998','2014-04-07','10:50:00',2.7),('8998','2014-04-07','10:55:00',2.71),('8998','2014-04-07','11:00:00',2.69),('8998','2014-04-07','11:05:00',2.7),('8998','2014-04-07','11:10:00',2.73),('8998','2014-04-07','11:15:00',2.7),('8998','2014-04-07','11:20:00',2.62),('8998','2014-04-07','11:25:00',2.81),('8998','2014-04-07','11:30:00',2.78),('8998','2014-04-07','11:35:00',2.59),('8998','2014-04-07','11:40:00',2.73),('8998','2014-04-07','11:45:00',2.75),('8998','2014-04-07','11:50:00',2.7),('8998','2014-04-07','11:55:00',2.66),('8998','2014-04-07','12:00:00',2.77),('8998','2014-04-07','12:05:00',2.72),('8998','2014-04-07','12:10:00',2.57),('8998','2014-04-07','12:15:00',2.52),('8998','2014-04-07','12:20:00',2.5),('8998','2014-04-07','12:25:00',2.42),('8998','2014-04-07','12:30:00',2.97),('8998','2014-04-07','12:35:00',2.8),('8998','2014-04-07','12:40:00',2.47),('8998','2014-04-07','12:45:00',2.2),('8998','2014-04-07','12:50:00',2.51),('8998','2014-04-07','12:55:00',2.68),('8998','2014-04-07','13:00:00',2.54),('8998','2014-04-07','13:05:00',2.71),('8998','2014-04-07','13:10:00',2.72),('8998','2014-04-07','13:15:00',2.7),('8998','2014-04-07','13:20:00',2.64),('8998','2014-04-07','13:25:00',2.6),('8998','2014-04-07','13:30:00',2.63),('8998','2014-04-07','13:35:00',2.59),('8998','2014-04-07','13:40:00',2.54),('8998','2014-04-07','13:45:00',2.5),('8998','2014-04-07','13:50:00',2.49),('8998','2014-04-07','13:55:00',2.48),('8998','2014-04-07','14:00:00',2.42),('8998','2014-04-07','14:05:00',2.39),('8998','2014-04-07','14:10:00',2.36),('8998','2014-04-07','14:15:00',2.33),('8998','2014-04-07','14:20:00',2.19),('8998','2014-04-07','14:25:00',2.21),('8998','2014-04-07','14:30:00',2.19),('8998','2014-04-07','14:35:00',2.04),('8998','2014-04-07','14:40:00',1.96),('8998','2014-04-07','14:45:00',1.75),('8998','2014-04-07','14:50:00',2.02),('8998','2014-04-07','14:55:00',2.03),('8998','2014-04-07','15:00:00',1.96),('8998','2014-04-07','15:05:00',1.88),('8998','2014-04-07','15:10:00',1.86),('8998','2014-04-07','15:15:00',1.8),('8998','2014-04-07','15:20:00',1.74),('8998','2014-04-07','15:25:00',1.69),('8998','2014-04-07','15:30:00',1.63),('8998','2014-04-07','15:35:00',1.57),('8998','2014-04-07','15:40:00',1.52),('8998','2014-04-07','15:45:00',1.4),('8998','2014-04-07','15:50:00',1.4),('8998','2014-04-07','15:55:00',1.35),('8998','2014-04-07','16:00:00',1.28),('8998','2014-04-07','16:05:00',1.23),('8998','2014-04-07','16:10:00',1.15),('8998','2014-04-07','16:15:00',1.05),('8998','2014-04-07','16:25:00',1),('8998','2014-04-07','16:30:00',1.01),('8998','2013-07-29','07:55:00',1.13),('8998','2013-07-29','08:00:00',1.21),('8998','2013-07-29','08:05:00',1.25),('8998','2013-07-29','08:10:00',1.3),('8998','2013-07-29','08:15:00',1.33),('8998','2013-07-29','08:20:00',1.45),('8998','2013-07-29','08:25:00',1.5),('8998','2013-07-29','08:30:00',1.42),('8998','2013-07-29','08:35:00',1.49),('8998','2013-07-29','08:40:00',1.49),('8998','2013-07-29','08:45:00',1.59),('8998','2013-07-29','08:50:00',1.61),('8998','2013-07-29','08:55:00',1.65),('8998','2013-07-29','09:00:00',1.66),('8998','2013-07-29','09:05:00',1.69),('8998','2013-07-29','09:10:00',1.66),('8998','2013-07-29','09:15:00',1.82),('8998','2013-07-29','09:20:00',2.04),('8998','2013-07-29','09:25:00',2.13),('8998','2013-07-29','09:30:00',2.44),('8998','2013-07-29','09:35:00',2.61),('8998','2013-07-29','09:40:00',2.73),('8998','2013-07-29','09:45:00',2.72),('8998','2013-07-29','09:50:00',2.7),('8998','2013-07-29','09:55:00',2.71),('8998','2013-07-29','10:00:00',2.65),('8998','2013-07-29','10:05:00',2.74),('8998','2013-07-29','10:10:00',2.78),('8998','2013-07-29','10:15:00',2.38),('8998','2013-07-29','10:20:00',2.52),('8998','2013-07-29','10:25:00',2.81),('8998','2013-07-29','10:30:00',2.83),('8998','2013-07-29','10:35:00',2.87),('8998','2013-07-29','10:40:00',2.84),('8998','2013-07-29','10:45:00',2.85),('8998','2013-07-29','10:50:00',2.83),('8998','2013-07-29','10:55:00',2.82),('8998','2013-07-29','11:00:00',2.84),('8998','2013-07-29','11:05:00',2.9),('8998','2013-07-29','11:10:00',2.95),('8998','2013-07-29','11:15:00',2.97),('8998','2013-07-29','11:20:00',2.83),('8998','2013-07-29','11:25:00',2.83),('8998','2013-07-29','11:30:00',2.7),('8998','2013-07-29','11:35:00',1.49),('8998','2013-07-29','11:40:00',2.49),('8998','2013-07-29','11:45:00',2.96),('8998','2013-07-29','11:50:00',2.98),('8998','2013-07-29','11:55:00',2.95),('8998','2013-07-29','12:00:00',2.95),('8998','2013-07-29','12:05:00',2.92),('8998','2013-07-29','12:10:00',2.93),('8998','2013-07-29','12:15:00',2.87),('8998','2013-07-29','12:20:00',2.84),('8998','2013-07-29','12:25:00',2.82),('8998','2013-07-29','12:30:00',2.8),('8998','2013-07-29','12:35:00',2.9),('8998','2013-07-29','12:40:00',2.67),('8998','2013-07-29','12:45:00',2.23),('8998','2013-07-29','12:50:00',2.94),('8998','2013-07-29','12:55:00',2.99),('8998','2013-07-29','13:00:00',1.58),('8998','2013-07-29','13:05:00',1.84),('8998','2013-07-29','13:10:00',2.86),('8998','2013-07-29','13:15:00',2.9),('8998','2013-07-29','13:20:00',2),('8998','2013-07-29','13:25:00',1.44),('8998','2013-07-29','13:30:00',2.43),('8998','2013-07-29','13:35:00',2.92),('8998','2013-07-29','13:40:00',2.78),('8998','2013-07-29','13:45:00',2.74),('8998','2013-07-29','13:50:00',2.81),('8998','2013-07-29','13:55:00',2.8),('8998','2013-07-29','14:00:00',2.57),('8998','2013-07-29','14:05:00',2.74),('8998','2013-07-29','14:10:00',2.71),('8998','2013-07-29','14:15:00',2.52),('8998','2013-07-29','14:20:00',2.45),('8998','2013-07-29','14:25:00',2.46),('8998','2013-07-29','14:30:00',2),('8998','2013-07-29','14:35:00',2.3),('8998','2013-07-29','14:40:00',2.27),('8998','2013-07-29','14:45:00',2.25),('8998','2013-07-29','14:50:00',2.24),('8998','2013-07-29','14:55:00',2.19),('8998','2013-07-29','15:00:00',2.12),('8998','2013-07-29','15:05:00',2.07),('8998','2013-07-29','15:10:00',1.95),('8998','2013-07-29','15:15:00',1.97),('8998','2013-07-29','15:20:00',1.96),('8998','2013-07-29','15:25:00',1.88),('8998','2013-07-29','15:30:00',1.83),('8998','2013-07-29','15:35:00',1.8),('8998','2013-07-29','15:40:00',1.75),('8998','2013-07-29','15:45:00',1.69),('8998','2013-07-29','15:50:00',1.65),('8998','2013-07-29','15:55:00',1.6),('8998','2013-07-29','16:00:00',1.56),('8998','2013-07-29','16:05:00',1.5),('8998','2013-07-29','16:10:00',1.44),('8998','2013-07-29','16:15:00',1.4),('8998','2013-07-29','16:20:00',1.36),('8998','2013-07-29','16:25:00',1.3),('8998','2013-07-29','16:30:00',1.24),('8998','2013-07-29','16:35:00',1.19),('8998','2013-07-29','16:40:00',1.15),('8998','2013-07-29','16:45:00',1.09),('8998','2013-07-29','16:50:00',1.03),('8998','2013-07-28','07:50:00',1.08),('8998','2013-07-28','07:55:00',1.17),('8998','2013-07-28','08:00:00',1.17),('8998','2013-07-28','08:05:00',1.2),('8998','2013-07-28','08:10:00',1.23),('8998','2013-07-28','08:15:00',1.27),('8998','2013-07-28','08:20:00',1.34),('8998','2013-07-28','08:25:00',1.39),('8998','2013-07-28','08:30:00',1.39),('8998','2013-07-28','08:35:00',1.42),('8998','2013-07-28','08:40:00',1.46),('8998','2013-07-28','08:45:00',1.5),('8998','2013-07-28','08:50:00',1.56),('8998','2013-07-28','08:55:00',1.6),('8998','2013-07-28','09:00:00',1.6),('8998','2013-07-28','09:05:00',1.65),('8998','2013-07-28','09:10:00',1.7),('8998','2013-07-28','09:15:00',1.74),('8998','2013-07-28','09:20:00',1.85),('8998','2013-07-28','09:25:00',1.92),('8998','2013-07-28','09:30:00',2.13),('8998','2013-07-28','09:35:00',2.28),('8998','2013-07-28','09:40:00',2.37),('8998','2013-07-28','09:45:00',2.41),('8998','2013-07-28','09:50:00',2.43),('8998','2013-07-28','09:55:00',2.45),('8998','2013-07-28','10:00:00',2.5),('8998','2013-07-28','10:05:00',2.53),('8998','2013-07-28','10:10:00',2.56),('8998','2013-07-28','10:15:00',2.57),('8998','2013-07-28','10:20:00',2.61),('8998','2013-07-28','10:25:00',2.64),('8998','2013-07-28','10:30:00',2.63),('8998','2013-07-28','10:35:00',2.67),('8998','2013-07-28','10:40:00',2.69),('8998','2013-07-28','10:45:00',2.68),('8998','2013-07-28','10:50:00',2.68),('8998','2013-07-28','10:55:00',2.68),('8998','2013-07-28','11:00:00',2.71),('8998','2013-07-28','11:05:00',2.7),('8998','2013-07-28','11:10:00',2.66),('8998','2013-07-28','11:15:00',2.66),('8998','2013-07-28','11:20:00',2.68),('8998','2013-07-28','11:25:00',2.7),('8998','2013-07-28','11:30:00',2.71),('8998','2013-07-28','11:35:00',2.7),('8998','2013-07-28','11:40:00',2.7),('8998','2013-07-28','11:45:00',2.71),('8998','2013-07-28','11:50:00',2.72),('8998','2013-07-28','11:55:00',2.72),('8998','2013-07-28','12:00:00',2.72),('8998','2013-07-28','12:05:00',2.69),('8998','2013-07-28','12:10:00',2.67),('8998','2013-07-28','12:15:00',2.69),('8998','2013-07-28','12:20:00',2.69),('8998','2013-07-28','12:25:00',2.7),('8998','2013-07-28','12:30:00',2.69),('8998','2013-07-28','12:35:00',2.69),('8998','2013-07-28','12:40:00',2.68),('8998','2013-07-28','12:45:00',2.67),('8998','2013-07-28','12:50:00',2.65),('8998','2013-07-28','12:55:00',2.62),('8998','2013-07-28','13:00:00',2.56),('8998','2013-07-28','13:05:00',2.63),('8998','2013-07-28','13:10:00',2.62),('8998','2013-07-28','13:15:00',2.58),('8998','2013-07-28','13:20:00',2.63),('8998','2013-07-28','13:25:00',2.6),('8998','2013-07-28','13:30:00',2.57),('8998','2013-07-28','13:35:00',2.56),('8998','2013-07-28','13:40:00',2.57),('8998','2013-07-28','13:45:00',2.56),('8998','2013-07-28','13:50:00',2.52),('8998','2013-07-28','13:55:00',2.5),('8998','2013-07-28','14:00:00',2.48),('8998','2013-07-28','14:05:00',2.45),('8998','2013-07-28','14:10:00',2.42),('8998','2013-07-28','14:15:00',2.39),('8998','2013-07-28','14:20:00',2.37),('8998','2013-07-28','14:25:00',2.33),('8998','2013-07-28','14:30:00',2.29),('8998','2013-07-28','14:35:00',2.25),('8998','2013-07-28','14:40:00',2.22),('8998','2013-07-28','14:45:00',2.19),('8998','2013-07-28','14:50:00',2.16),('8998','2013-07-28','14:55:00',2.12),('8998','2013-07-28','15:00:00',2.09),('8998','2013-07-28','15:05:00',2.05),('8998','2013-07-28','15:10:00',2),('8998','2013-07-28','15:15:00',1.97),('8998','2013-07-28','15:20:00',1.92),('8998','2013-07-28','15:25:00',1.87),('8998','2013-07-28','15:30:00',1.83),('8998','2013-07-28','15:35:00',1.79),('8998','2013-07-28','15:40:00',1.77),('8998','2013-07-28','15:45:00',1.74),('8998','2013-07-28','15:50:00',1.52),('8998','2013-07-28','16:05:00',1.36),('8998','2013-07-28','16:10:00',1.5),('8998','2013-07-28','16:15:00',1.43),('8998','2013-07-28','16:20:00',1.24),('8998','2013-07-28','16:25:00',1.09),('8998','2013-07-28','16:30:00',1.38),('8998','2013-07-28','16:35:00',1.28),('8998','2013-07-28','16:45:00',1.26),('8998','2013-07-28','16:50:00',1.17),('8998','2013-07-27','07:50:00',1.08),('8998','2013-07-27','07:55:00',1.13),('8998','2013-07-27','08:00:00',1.12),('8998','2013-07-27','08:05:00',1.16),('8998','2013-07-27','08:10:00',1.2),('8998','2013-07-27','08:15:00',1.25),('8998','2013-07-27','08:20:00',1.33),('8998','2013-07-27','08:25:00',1.38),('8998','2013-07-27','08:30:00',1.37),('8998','2013-07-27','08:35:00',1.39),('8998','2013-07-27','08:40:00',1.44),('8998','2013-07-27','08:45:00',1.48),('8998','2013-07-27','08:50:00',1.52),('8998','2013-07-27','08:55:00',1.6),('8998','2013-07-27','09:00:00',1.57),('8998','2013-07-27','09:05:00',1.61),('8998','2013-07-27','09:10:00',1.7),('8998','2013-07-27','09:15:00',1.73),('8998','2013-07-27','09:20:00',1.83),('8998','2013-07-27','09:25:00',1.95),('8998','2013-07-27','09:30:00',2.2),('8998','2013-07-27','09:35:00',2.33),('8998','2013-07-27','09:40:00',2.4),('8998','2013-07-27','09:45:00',2.41),('8998','2013-07-27','09:50:00',2.44),('8998','2013-07-27','09:55:00',2.46),('8998','2013-07-27','10:00:00',2.49),('8998','2013-07-27','10:05:00',2.5),('8998','2013-07-27','10:10:00',2.53),('8998','2013-07-27','10:15:00',2.55),('8998','2013-07-27','10:20:00',2.57),('8998','2013-07-27','10:25:00',2.59),('8998','2013-07-27','10:30:00',2.62),('8998','2013-07-27','10:35:00',2.59),('8998','2013-07-27','10:40:00',2.65),('8998','2013-07-27','10:45:00',2.67),('8998','2013-07-27','10:50:00',2.67),('8998','2013-07-27','10:55:00',2.67),('8998','2013-07-27','11:00:00',2.66),('8998','2013-07-27','11:05:00',2.68),('8998','2013-07-27','11:10:00',2.72),('8998','2013-07-27','11:15:00',2.73),('8998','2013-07-27','11:20:00',2.75),('8998','2013-07-27','11:25:00',2.76),('8998','2013-07-27','11:30:00',2.74),('8998','2013-07-27','11:35:00',2.75),('8998','2013-07-27','11:40:00',2.72),('8998','2013-07-27','11:45:00',2.71),('8998','2013-07-27','11:50:00',2.7),('8998','2013-07-27','11:55:00',2.71),('8998','2013-07-27','12:00:00',2.74),('8998','2013-07-27','12:05:00',2.74),('8998','2013-07-27','12:10:00',2.69),('8998','2013-07-27','12:15:00',2.71),('8998','2013-07-27','12:20:00',2.66),('8998','2013-07-27','12:25:00',2.67),('8998','2013-07-27','12:30:00',2.69),('8998','2013-07-27','12:35:00',2.75),('8998','2013-07-27','12:40:00',2.73),('8998','2013-07-27','12:45:00',2.69),('8998','2013-07-27','12:50:00',2.68),('8998','2013-07-27','12:55:00',2.65),('8998','2013-07-27','13:00:00',2.65),('8998','2013-07-27','13:05:00',2.59),('8998','2013-07-27','13:10:00',2.53),('8998','2013-07-27','13:15:00',2.69),('8998','2013-07-27','13:20:00',2.65),('8998','2013-07-27','13:25:00',2.66),('8998','2013-07-27','13:30:00',2.56),('8998','2013-07-27','13:35:00',2.57),('8998','2013-07-27','13:40:00',2.55),('8998','2013-07-27','13:45:00',2.52),('8998','2013-07-27','13:50:00',2.57),('8998','2013-07-27','13:55:00',2.52),('8998','2013-07-27','14:00:00',2.48),('8998','2013-07-27','14:05:00',2.47),('8998','2013-07-27','14:10:00',2.43),('8998','2013-07-27','14:15:00',2.39),('8998','2013-07-27','14:20:00',2.36),('8998','2013-07-27','14:25:00',2.31),('8998','2013-07-27','14:30:00',2.29),('8998','2013-07-27','14:35:00',2.24),('8998','2013-07-27','14:40:00',2.25),('8998','2013-07-27','14:45:00',2.18),('8998','2013-07-27','14:50:00',2.15),('8998','2013-07-27','14:55:00',2.11),('8998','2013-07-27','15:00:00',2.07),('8998','2013-07-27','15:05:00',2.03),('8998','2013-07-27','15:10:00',1.98),('8998','2013-07-27','15:15:00',1.97),('8998','2013-07-27','15:20:00',1.93),('8998','2013-07-27','15:25:00',1.85),('8998','2013-07-27','15:30:00',1.83),('8998','2013-07-27','15:35:00',1.79),('8998','2013-07-27','15:40:00',1.73),('8998','2013-07-27','15:45:00',1.7),('8998','2013-07-27','15:50:00',1.64),('8998','2013-07-27','15:55:00',1.6),('8998','2013-07-27','16:00:00',1.56),('8998','2013-07-27','16:05:00',1.51),('8998','2013-07-27','16:10:00',1.47),('8998','2013-07-27','16:15:00',1.42),('8998','2013-07-27','16:20:00',1.37),('8998','2013-07-27','16:25:00',1.33),('8998','2013-07-27','16:30:00',1.27),('8998','2013-07-27','16:35:00',1.21),('8998','2013-07-27','16:40:00',1.17),('8998','2013-07-27','16:45:00',1.11),('8998','2013-07-27','16:50:00',1.05),('8998','2013-07-27','16:55:00',1),('8998','2013-07-26','07:50:00',1.06),('8998','2013-07-26','07:55:00',1.14),('8998','2013-07-26','08:00:00',1.16),('8998','2013-07-26','08:05:00',1.18),('8998','2013-07-26','08:10:00',1.22),('8998','2013-07-26','08:15:00',1.28),('8998','2013-07-26','08:20:00',1.37),('8998','2013-07-26','08:25:00',1.32),('8998','2013-07-26','08:30:00',1.41),('8998','2013-07-26','08:35:00',1.42),('8998','2013-07-26','08:40:00',1.47),('8998','2013-07-26','08:45:00',1.49),('8998','2013-07-26','08:50:00',1.56),('8998','2013-07-26','08:55:00',1.63),('8998','2013-07-26','09:00:00',1.6),('8998','2013-07-26','09:05:00',1.62),('8998','2013-07-26','09:10:00',1.74),('8998','2013-07-26','09:15:00',1.77),('8998','2013-07-26','09:20:00',1.9),('8998','2013-07-26','09:25:00',2.07),('8998','2013-07-26','09:30:00',2.24),('8998','2013-07-26','09:35:00',2.38),('8998','2013-07-26','09:40:00',2.42),('8998','2013-07-26','09:45:00',2.47),('8998','2013-07-26','09:50:00',2.49),('8998','2013-07-26','09:55:00',2.51),('8998','2013-07-26','10:00:00',2.55),('8998','2013-07-26','10:05:00',2.58),('8998','2013-07-26','10:10:00',2.61),('8998','2013-07-26','10:15:00',2.64),('8998','2013-07-26','10:20:00',2.67),('8998','2013-07-26','10:25:00',2.69),('8998','2013-07-26','10:30:00',2.7),('8998','2013-07-26','10:35:00',2.69),('8998','2013-07-26','10:40:00',2.7),('8998','2013-07-26','10:45:00',2.72),('8998','2013-07-26','10:50:00',2.72),('8998','2013-07-26','10:55:00',2.73),('8998','2013-07-26','11:00:00',2.74),('8998','2013-07-26','11:05:00',2.77),('8998','2013-07-26','11:10:00',2.8),('8998','2013-07-26','11:15:00',2.79),('8998','2013-07-26','11:20:00',2.78),('8998','2013-07-26','11:25:00',2.82),('8998','2013-07-26','11:30:00',2.82),('8998','2013-07-26','11:35:00',2.84),('8998','2013-07-26','11:40:00',2.81),('8998','2013-07-26','11:45:00',2.82),('8998','2013-07-26','11:50:00',2.8),('8998','2013-07-26','11:55:00',2.8),('8998','2013-07-26','12:00:00',2.79),('8998','2013-07-26','12:05:00',2.79),('8998','2013-07-26','12:10:00',2.79),('8998','2013-07-26','12:15:00',2.77),('8998','2013-07-26','12:20:00',2.82),('8998','2013-07-26','12:25:00',2.8),('8998','2013-07-26','12:30:00',2.73),('8998','2013-07-26','12:35:00',2.79),('8998','2013-07-26','12:40:00',2.77),('8998','2013-07-26','12:45:00',2.69),('8998','2013-07-26','12:50:00',2.67),('8998','2013-07-26','12:55:00',2.7),('8998','2013-07-26','13:00:00',2.71),('8998','2013-07-26','13:05:00',2.78),('8998','2013-07-26','13:10:00',2.74),('8998','2013-07-26','13:15:00',2.72),('8998','2013-07-26','13:20:00',2.72),('8998','2013-07-26','13:25:00',2.75),('8998','2013-07-26','13:30:00',2.76),('8998','2013-07-26','13:35:00',2.52),('8998','2013-07-26','13:40:00',2.39),('8998','2013-07-26','13:45:00',2.69),('8998','2013-07-26','13:50:00',2.67),('8998','2013-07-26','13:55:00',2.65),('8998','2013-07-26','14:00:00',2.45),('8998','2013-07-26','14:05:00',2.49),('8998','2013-07-26','14:10:00',2.07),('8998','2013-07-26','14:15:00',2.26),('8998','2013-07-26','14:20:00',2.45),('8998','2013-07-26','14:25:00',2.37),('8998','2013-07-26','14:30:00',2.31),('8998','2013-07-26','14:35:00',2.29),('8998','2013-07-26','14:40:00',2.26),('8998','2013-07-26','14:45:00',2.22),('8998','2013-07-26','14:50:00',2.17),('8998','2013-07-26','14:55:00',2.12),('8998','2013-07-26','15:00:00',2.07),('8998','2013-07-26','15:05:00',2),('8998','2013-07-26','15:10:00',2.01),('8998','2013-07-26','15:15:00',1.96),('8998','2013-07-26','15:20:00',1.92),('8998','2013-07-26','15:25:00',1.88),('8998','2013-07-26','15:30:00',1.84),('8998','2013-07-26','15:35:00',1.8),('8998','2013-07-26','15:40:00',1.75),('8998','2013-07-26','15:45:00',1.71),('8998','2013-07-26','15:50:00',1.67),('8998','2013-07-26','15:55:00',1.61),('8998','2013-07-26','16:00:00',1.57),('8998','2013-07-26','16:05:00',1.52),('8998','2013-07-26','16:10:00',1.47),('8998','2013-07-26','16:15:00',1.42),('8998','2013-07-26','16:20:00',1.37),('8998','2013-07-26','16:25:00',1.32),('8998','2013-07-26','16:30:00',1.27),('8998','2013-07-26','16:35:00',1.22),('8998','2013-07-26','16:40:00',1.16),('8998','2013-07-26','16:45:00',1.11),('8998','2013-07-26','16:50:00',1.05),('8998','2013-07-26','16:55:00',1),('8998','2013-07-25','07:50:00',1.03),('8998','2013-07-25','07:55:00',1.09),('8998','2013-07-25','08:00:00',1.1),('8998','2013-07-25','08:05:00',1.16),('8998','2013-07-25','08:10:00',1.23),('8998','2013-07-25','08:15:00',1.29),('8998','2013-07-25','08:20:00',1.34),('8998','2013-07-25','08:25:00',1.31),('8998','2013-07-25','08:30:00',1.39),('8998','2013-07-25','08:35:00',1.42),('8998','2013-07-25','08:40:00',1.46),('8998','2013-07-25','08:45:00',1.5),('8998','2013-07-25','08:50:00',1.59),('8998','2013-07-25','08:55:00',1.63),('8998','2013-07-25','09:00:00',1.64),('8998','2013-07-25','09:05:00',1.63),('8998','2013-07-25','09:10:00',1.76),('8998','2013-07-25','09:15:00',1.79),('8998','2013-07-25','09:20:00',1.91),('8998','2013-07-25','09:25:00',2.05),('8998','2013-07-25','09:30:00',2.16),('8998','2013-07-25','09:35:00',2.26),('8998','2013-07-25','09:40:00',2.32),('8998','2013-07-25','09:45:00',2.34),('8998','2013-07-25','09:50:00',1.51),('8998','2013-07-25','09:55:00',2.43),('8998','2013-07-25','10:00:00',2.47),('8998','2013-07-25','10:05:00',2.54),('8998','2013-07-25','10:10:00',2.51),('8998','2013-07-25','10:15:00',2.57),('8998','2013-07-25','10:20:00',2.59),('8998','2013-07-25','10:25:00',2.61),('8998','2013-07-25','10:30:00',2.65),('8998','2013-07-25','10:35:00',2.65),('8998','2013-07-25','10:40:00',2.67),('8998','2013-07-25','10:45:00',2.69),('8998','2013-07-25','10:50:00',2.7),('8998','2013-07-25','10:55:00',2.7),('8998','2013-07-25','11:00:00',2.73),('8998','2013-07-25','11:05:00',2.74),('8998','2013-07-25','11:10:00',2.73),('8998','2013-07-25','11:15:00',2.72),('8998','2013-07-25','11:20:00',2.07),('8998','2013-07-25','11:25:00',2.66),('8998','2013-07-25','11:30:00',2.57),('8998','2013-07-25','11:35:00',2.58),('8998','2013-07-25','11:40:00',2.66),('8998','2013-07-25','11:45:00',2.7),('8998','2013-07-25','11:50:00',2.81),('8998','2013-07-25','11:55:00',2.8),('8998','2013-07-25','12:00:00',2.76),('8998','2013-07-25','12:05:00',2.74),('8998','2013-07-25','12:15:00',1.92),('8998','2013-07-25','12:20:00',1.49),('8998','2013-07-25','12:25:00',2.82),('8998','2013-07-25','12:30:00',2.79),('8998','2013-07-25','12:35:00',2.82),('8998','2013-07-25','12:40:00',2.89),('8998','2013-07-25','12:45:00',2.97),('8998','2013-07-25','12:50:00',2.94),('8998','2013-07-25','12:55:00',2.83),('8998','2013-07-25','13:00:00',1.92),('8998','2013-07-25','13:15:00',1.41),('8998','2013-07-25','13:20:00',2.32),('8998','2013-07-25','13:25:00',2.61),('8998','2013-07-25','13:30:00',2.96),('8998','2013-07-25','13:35:00',2.78),('8998','2013-07-25','13:40:00',2.69),('8998','2013-07-25','13:45:00',2.7),('8998','2013-07-25','13:50:00',2.62),('8998','2013-07-25','13:55:00',2.22),('8998','2013-07-25','14:00:00',2.68),('8998','2013-07-25','14:05:00',2.69),('8998','2013-07-25','14:10:00',2.54),('8998','2013-07-25','14:15:00',2.52),('8998','2013-07-25','14:20:00',2.52),('8998','2013-07-25','14:25:00',2.47),('8998','2013-07-25','14:30:00',2.36),('8998','2013-07-25','14:35:00',2.31),('8998','2013-07-25','14:40:00',2.32),('8998','2013-07-25','14:45:00',2.22),('8998','2013-07-25','14:50:00',2.21),('8998','2013-07-25','14:55:00',2.14),('8998','2013-07-25','15:00:00',2.15),('8998','2013-07-25','15:05:00',2.07),('8998','2013-07-25','15:10:00',2.05),('8998','2013-07-25','15:15:00',2),('8998','2013-07-25','15:20:00',1.96),('8998','2013-07-25','15:25:00',1.9),('8998','2013-07-25','15:30:00',1.86),('8998','2013-07-25','15:35:00',1.83),('8998','2013-07-25','15:40:00',1.78),('8998','2013-07-25','15:45:00',1.75),('8998','2013-07-25','15:50:00',1.71),('8998','2013-07-25','15:55:00',1.65),('8998','2013-07-25','16:00:00',1.59),('8998','2013-07-25','16:05:00',1.54),('8998','2013-07-25','16:10:00',1.48),('8998','2013-07-25','16:15:00',1.44),('8998','2013-07-25','16:20:00',1.39),('8998','2013-07-25','16:25:00',1.35),('8998','2013-07-25','16:30:00',1.3),('8998','2013-07-25','16:35:00',1.24),('8998','2013-07-25','16:40:00',1.19),('8998','2013-07-25','16:45:00',1.15),('8998','2013-07-25','16:50:00',1.09),('8998','2013-07-25','16:55:00',1.03),('8998','2013-07-24','07:50:00',1.03),('8998','2013-07-24','07:55:00',1.09),('8998','2013-07-24','08:00:00',1.16),('8998','2013-07-24','08:05:00',1.21),('8998','2013-07-24','08:10:00',1.26),('8998','2013-07-24','08:15:00',1.32),('8998','2013-07-24','08:20:00',1.4),('8998','2013-07-24','08:25:00',1.4),('8998','2013-07-24','08:30:00',1.45),('8998','2013-07-24','08:35:00',1.44),('8998','2013-07-24','08:40:00',1.5),('8998','2013-07-24','08:45:00',1.54),('8998','2013-07-24','08:50:00',1.59),('8998','2013-07-24','08:55:00',1.58),('8998','2013-07-24','09:00:00',1.66),('8998','2013-07-24','09:05:00',1.63),('8998','2013-07-24','09:10:00',1.65),('8998','2013-07-24','09:15:00',2.06),('8998','2013-07-24','09:20:00',2.19),('8998','2013-07-24','09:25:00',1.78),('8998','2013-07-24','09:30:00',1.44),('8998','2013-07-24','09:40:00',1.32),('8998','2013-07-24','09:45:00',1),('8998','2013-07-24','09:50:00',1.62),('8998','2013-07-24','10:10:00',1.59),('8998','2013-07-24','10:15:00',2.77),('8998','2013-07-24','10:20:00',2.8),('8998','2013-07-24','10:25:00',2.85),('8998','2013-07-24','10:30:00',2.84),('8998','2013-07-24','10:35:00',2.62),('8998','2013-07-24','10:40:00',2.28),('8998','2013-07-24','10:45:00',2.5),('8998','2013-07-24','10:50:00',2.71),('8998','2013-07-24','10:55:00',2.9),('8998','2013-07-24','11:00:00',2.85),('8998','2013-07-24','11:05:00',1.99),('8998','2013-07-24','11:10:00',2.2),('8998','2013-07-24','11:15:00',2.8),('8998','2013-07-24','11:20:00',2.58),('8998','2013-07-24','11:25:00',2.5),('8998','2013-07-24','11:30:00',2.58),('8998','2013-07-24','11:35:00',2.88),('8998','2013-07-24','11:40:00',2.88),('8998','2013-07-24','11:45:00',3.06),('8998','2013-07-24','11:50:00',3.11),('8998','2013-07-24','11:55:00',2.32),('8998','2013-07-24','12:00:00',2.3),('8998','2013-07-24','12:05:00',2.98),('8998','2013-07-24','12:10:00',2.99),('8998','2013-07-24','12:15:00',2.4),('8998','2013-07-24','12:20:00',1.9),('8998','2013-07-24','12:25:00',2.41),('8998','2013-07-24','12:35:00',1.69),('8998','2013-07-24','12:55:00',1.22),('8998','2013-07-24','13:00:00',2.84),('8998','2013-07-24','13:05:00',1.7),('8998','2013-07-24','13:10:00',1.35),('8998','2013-07-24','13:15:00',1.67),('8998','2013-07-24','13:20:00',2.46),('8998','2013-07-24','13:25:00',2.96),('8998','2013-07-24','13:30:00',2.87),('8998','2013-07-24','13:35:00',2.63),('8998','2013-07-24','13:40:00',2.63),('8998','2013-07-24','13:45:00',2.64),('8998','2013-07-24','13:50:00',2.6),('8998','2013-07-24','13:55:00',2.57),('8998','2013-07-24','14:00:00',2.59),('8998','2013-07-24','14:05:00',2.58),('8998','2013-07-24','14:10:00',2.57),('8998','2013-07-24','14:15:00',2.53),('8998','2013-07-24','14:20:00',2.53),('8998','2013-07-24','14:25:00',2.49),('8998','2013-07-24','14:30:00',2.44),('8998','2013-07-24','14:35:00',2.4),('8998','2013-07-24','14:40:00',2.35),('8998','2013-07-24','14:45:00',2.3),('8998','2013-07-24','14:50:00',2.25),('8998','2013-07-24','14:55:00',2.22),('8998','2013-07-24','15:00:00',2.19),('8998','2013-07-24','15:05:00',2.16),('8998','2013-07-24','15:10:00',2.11),('8998','2013-07-24','15:15:00',2.06),('8998','2013-07-24','15:20:00',2.03),('8998','2013-07-24','15:25:00',1.99),('8998','2013-07-24','15:30:00',1.95),('8998','2013-07-24','15:35:00',1.9),('8998','2013-07-24','15:40:00',1.86),('8998','2013-07-24','15:45:00',1.82),('8998','2013-07-24','15:50:00',1.76),('8998','2013-07-24','15:55:00',1.71),('8998','2013-07-24','16:00:00',1.65),('8998','2013-07-24','16:05:00',1.59),('8998','2013-07-24','16:10:00',1.54),('8998','2013-07-24','16:15:00',1.48),('8998','2013-07-24','16:20:00',1.43),('8998','2013-07-24','16:25:00',1.38),('8998','2013-07-24','16:30:00',1.32),('8998','2013-07-24','16:35:00',1.29),('8998','2013-07-24','16:40:00',1.23),('8998','2013-07-24','16:45:00',1.17),('8998','2013-07-24','16:50:00',1.12),('8998','2013-07-24','16:55:00',1.07),('8998','2013-07-23','08:00:00',1.12),('8998','2013-07-23','08:20:00',1.16),('8998','2013-07-23','08:40:00',1.01),('8998','2013-07-23','08:45:00',1.15),('8998','2013-07-23','08:50:00',1.71),('8998','2013-07-23','08:55:00',1.34),('8998','2013-07-23','09:00:00',1.07),('8998','2013-07-23','09:05:00',1.66),('8998','2013-07-23','09:10:00',1.93),('8998','2013-07-23','09:15:00',1.72),('8998','2013-07-23','09:20:00',1.53),('8998','2013-07-23','09:30:00',1.24),('8998','2013-07-23','09:35:00',1.66),('8998','2013-07-23','09:40:00',1.58),('8998','2013-07-23','09:45:00',1.65),('8998','2013-07-23','09:50:00',1.57),('8998','2013-07-23','09:55:00',1.05),('8998','2013-07-23','10:20:00',1.1),('8998','2013-07-23','10:25:00',2.29),('8998','2013-07-23','10:30:00',2.78),('8998','2013-07-23','10:35:00',2.81),('8998','2013-07-23','10:40:00',2.91),('8998','2013-07-23','10:45:00',2.91),('8998','2013-07-23','10:50:00',1.99),('8998','2013-07-23','10:55:00',1.98),('8998','2013-07-23','11:00:00',1.31),('8998','2013-07-23','11:05:00',1.52),('8998','2013-07-23','11:10:00',3.05),('8998','2013-07-23','11:15:00',3.05),('8998','2013-07-23','11:20:00',3.04),('8998','2013-07-23','11:25:00',3.02),('8998','2013-07-23','11:30:00',2.99),('8998','2013-07-23','11:35:00',3.07),('8998','2013-07-23','11:40:00',2.94),('8998','2013-07-23','11:45:00',2.89),('8998','2013-07-23','11:50:00',2.9),('8998','2013-07-23','11:55:00',2.91),('8998','2013-07-23','12:00:00',3.03),('8998','2013-07-23','12:05:00',3.16),('8998','2013-07-23','12:10:00',2.2),('8998','2013-07-23','12:15:00',1.11),('8998','2013-07-23','12:20:00',1.98),('8998','2013-07-23','12:25:00',3.19),('8998','2013-07-23','12:30:00',1.76),('8998','2013-07-23','12:40:00',1.69),('8998','2013-07-23','12:45:00',3.18),('8998','2013-07-23','12:50:00',1.3),('8998','2013-07-23','13:00:00',3.03),('8998','2013-07-23','13:05:00',2.75),('8998','2013-07-23','13:15:00',2.13),('8998','2013-07-23','13:25:00',2.73),('8998','2013-07-23','13:30:00',1.02),('8998','2013-07-23','13:35:00',2.97),('8998','2013-07-23','13:40:00',2.2),('8998','2013-07-23','13:45:00',2.58),('8998','2013-07-23','13:50:00',2.04),('8998','2013-07-23','13:55:00',2.83),('8998','2013-07-23','14:00:00',2.81),('8998','2013-07-23','14:05:00',2.75),('8998','2013-07-23','14:10:00',2.71),('8998','2013-07-23','14:15:00',2.68),('8998','2013-07-23','14:20:00',2.62),('8998','2013-07-23','14:25:00',2.52),('8998','2013-07-23','14:30:00',2.56),('8998','2013-07-23','14:35:00',1.94),('8998','2013-07-23','14:40:00',2.53),('8998','2013-07-23','14:45:00',2.43),('8998','2013-07-23','14:50:00',2.5),('8998','2013-07-23','14:55:00',2.45),('8998','2013-07-23','15:00:00',2.31),('8998','2013-07-23','15:05:00',2.31),('8998','2013-07-23','15:10:00',2.22),('8998','2013-07-23','15:15:00',2.2),('8998','2013-07-23','15:20:00',2.14),('8998','2013-07-23','15:25:00',2.1),('8998','2013-07-23','15:30:00',1.97),('8998','2013-07-23','15:35:00',1.9),('8998','2013-07-23','15:40:00',1.92),('8998','2013-07-23','15:45:00',1.86),('8998','2013-07-23','15:50:00',1.81),('8998','2013-07-23','15:55:00',1.84),('8998','2013-07-23','16:00:00',1.78),('8998','2013-07-23','16:05:00',1.71),('8998','2013-07-23','16:10:00',1.63),('8998','2013-07-23','16:15:00',1.49),('8998','2013-07-23','16:20:00',1.64),('8998','2013-07-23','16:25:00',1.52),('8998','2013-07-23','16:30:00',1.51),('8998','2013-07-23','16:35:00',1.37),('8998','2013-07-23','16:40:00',1.37),('8998','2013-07-23','16:45:00',1.25),('8998','2013-07-23','16:50:00',1.22),('8998','2013-07-23','16:55:00',1.25),('8998','2013-07-23','17:00:00',1.19),('8998','2013-07-22','07:45:00',1.14),('8998','2013-07-22','07:50:00',1.2),('8998','2013-07-22','07:55:00',1.28),('8998','2013-07-22','08:00:00',1.34),('8998','2013-07-22','08:05:00',1.35),('8998','2013-07-22','08:10:00',1.35),('8998','2013-07-22','08:15:00',1.38),('8998','2013-07-22','08:20:00',1.45),('8998','2013-07-22','08:25:00',1.42),('8998','2013-07-22','08:30:00',1.51),('8998','2013-07-22','08:35:00',1.46),('8998','2013-07-22','08:40:00',1.51),('8998','2013-07-22','08:45:00',1.61),('8998','2013-07-22','08:50:00',1.69),('8998','2013-07-22','08:55:00',1.67),('8998','2013-07-22','09:00:00',1.74),('8998','2013-07-22','09:05:00',1.72),('8998','2013-07-22','09:10:00',1.79),('8998','2013-07-22','09:15:00',1.91),('8998','2013-07-22','09:20:00',1.99),('8998','2013-07-22','09:25:00',2.23),('8998','2013-07-22','09:30:00',2.38),('8998','2013-07-22','09:35:00',2.46),('8998','2013-07-22','09:40:00',2.49),('8998','2013-07-22','09:45:00',2.5),('8998','2013-07-22','09:50:00',2.53),('8998','2013-07-22','09:55:00',2.54),('8998','2013-07-22','10:00:00',2.54),('8998','2013-07-22','10:05:00',2.6),('8998','2013-07-22','10:10:00',2.61),('8998','2013-07-22','10:15:00',2.63),('8998','2013-07-22','10:20:00',2.66),('8998','2013-07-22','10:25:00',2.69),('8998','2013-07-22','10:30:00',2.73),('8998','2013-07-22','10:35:00',2.79),('8998','2013-07-22','10:40:00',2.83),('8998','2013-07-22','10:45:00',2.82),('8998','2013-07-22','10:50:00',2.82),('8998','2013-07-22','10:55:00',2.82),('8998','2013-07-22','11:00:00',2.84),('8998','2013-07-22','11:05:00',2.85),('8998','2013-07-22','11:10:00',2.84),('8998','2013-07-22','11:15:00',2.86),('8998','2013-07-22','11:20:00',2.85),('8998','2013-07-22','11:25:00',2.86),('8998','2013-07-22','11:30:00',2.89),('8998','2013-07-22','11:35:00',2.92),('8998','2013-07-22','11:40:00',2.89),('8998','2013-07-22','11:45:00',2.87),('8998','2013-07-22','11:50:00',2.85),('8998','2013-07-22','11:55:00',2.83),('8998','2013-07-22','12:00:00',2.9),('8998','2013-07-22','12:05:00',2.88),('8998','2013-07-22','12:10:00',2.88),('8998','2013-07-22','12:15:00',2.89),('8998','2013-07-22','12:20:00',2.87),('8998','2013-07-22','12:25:00',2.87),('8998','2013-07-22','12:30:00',2.86),('8998','2013-07-22','12:35:00',2.82),('8998','2013-07-22','12:40:00',2.87),('8998','2013-07-22','12:45:00',2.07),('8998','2013-07-22','12:50:00',1.86),('8998','2013-07-22','12:55:00',1.94),('8998','2013-07-22','13:00:00',1.07),('8998','2013-07-22','13:10:00',1.92),('8998','2013-07-22','13:15:00',2.11),('8998','2013-07-22','13:30:00',1.93),('8998','2013-07-22','13:35:00',2.97),('8998','2013-07-22','13:40:00',2.92),('8998','2013-07-22','13:45:00',2.75),('8998','2013-07-22','13:50:00',1.87),('8998','2013-07-22','13:55:00',1.83),('8998','2013-07-22','14:00:00',2.74),('8998','2013-07-22','14:05:00',1.44),('8998','2013-07-22','14:40:00',2.47),('8998','2013-07-22','14:45:00',2.02),('8998','2013-07-22','14:50:00',2.5),('8998','2013-07-22','14:55:00',2.64),('8998','2013-07-22','15:00:00',1.85),('8998','2013-07-22','15:05:00',2.68),('8998','2013-07-22','15:10:00',2.47),('8998','2013-07-22','15:15:00',2.24),('8998','2013-07-22','15:20:00',2.23),('8998','2013-07-22','15:25:00',2.09),('8998','2013-07-22','15:30:00',2),('8998','2013-07-22','15:35:00',1.43),('8998','2013-07-22','15:40:00',1.89),('8998','2013-07-22','15:45:00',1.79),('8998','2013-07-22','15:50:00',1.75),('8998','2013-07-22','15:55:00',1.72),('8998','2013-07-22','16:00:00',1.67),('8998','2013-07-22','16:05:00',1.61),('8998','2013-07-22','16:10:00',1.56),('8998','2013-07-22','16:15:00',1.48),('8998','2013-07-22','16:20:00',1.47),('8998','2013-07-22','16:25:00',1.41),('8998','2013-07-22','16:30:00',1.36),('8998','2013-07-22','16:35:00',1.29),('8998','2013-07-22','16:40:00',1.25),('8998','2013-07-22','16:45:00',1.19),('8998','2013-07-22','16:50:00',1.13),('8998','2013-07-22','16:55:00',1.09),('8998','2013-07-22','17:00:00',1.03),('8998','2013-07-21','07:45:00',1.06),('8998','2013-07-21','07:50:00',1.2),('8998','2013-07-21','07:55:00',1.29),('8998','2013-07-21','08:00:00',1.26),('8998','2013-07-21','08:05:00',1.3),('8998','2013-07-21','08:10:00',1.31),('8998','2013-07-21','08:15:00',1.36),('8998','2013-07-21','08:20:00',1.42),('8998','2013-07-21','08:25:00',1.47),('8998','2013-07-21','08:30:00',1.51),('8998','2013-07-21','08:35:00',1.49),('8998','2013-07-21','08:40:00',1.52),('8998','2013-07-21','08:45:00',1.58),('8998','2013-07-21','08:50:00',1.68),('8998','2013-07-21','08:55:00',1.68),('8998','2013-07-21','09:00:00',1.75),('8998','2013-07-21','09:05:00',1.74),('8998','2013-07-21','09:10:00',1.79),('8998','2013-07-21','09:15:00',1.9),('8998','2013-07-21','09:20:00',2.02),('8998','2013-07-21','09:25:00',2.24),('8998','2013-07-21','09:30:00',2.4),('8998','2013-07-21','09:35:00',2.46),('8998','2013-07-21','09:40:00',2.5),('8998','2013-07-21','09:45:00',2.54),('8998','2013-07-21','09:50:00',2.56),('8998','2013-07-21','09:55:00',2.59),('8998','2013-07-21','10:00:00',2.62),('8998','2013-07-21','10:05:00',2.65),('8998','2013-07-21','10:10:00',2.67),('8998','2013-07-21','10:15:00',2.71),('8998','2013-07-21','10:20:00',2.74),('8998','2013-07-21','10:25:00',2.77),('8998','2013-07-21','10:30:00',2.78),('8998','2013-07-21','10:35:00',2.78),('8998','2013-07-21','10:40:00',2.81),('8998','2013-07-21','10:45:00',2.82),('8998','2013-07-21','10:50:00',2.83),('8998','2013-07-21','10:55:00',2.84),('8998','2013-07-21','11:00:00',2.84),('8998','2013-07-21','11:05:00',2.85),('8998','2013-07-21','11:10:00',2.86),('8998','2013-07-21','11:15:00',2.85),('8998','2013-07-21','11:20:00',2.85),('8998','2013-07-21','11:25:00',2.86),('8998','2013-07-21','11:30:00',2.86),('8998','2013-07-21','11:35:00',2.86),('8998','2013-07-21','11:40:00',2.85),('8998','2013-07-21','11:45:00',2.85),('8998','2013-07-21','11:50:00',2.83),('8998','2013-07-21','11:55:00',2.83),('8998','2013-07-21','12:00:00',2.84),('8998','2013-07-21','12:05:00',2.86),('8998','2013-07-21','12:10:00',2.85),('8998','2013-07-21','12:15:00',2.85),('8998','2013-07-21','12:20:00',2.85),('8998','2013-07-21','12:25:00',2.87),('8998','2013-07-21','12:30:00',2.87),('8998','2013-07-21','12:35:00',2.84),('8998','2013-07-21','12:40:00',2.84),('8998','2013-07-21','12:45:00',2.83),('8998','2013-07-21','12:50:00',2.81),('8998','2013-07-21','12:55:00',2.8),('8998','2013-07-21','13:00:00',2.83),('8998','2013-07-21','13:05:00',2.81),('8998','2013-07-21','13:10:00',2.77),('8998','2013-07-21','13:15:00',2.76),('8998','2013-07-21','13:20:00',2.74),('8998','2013-07-21','13:25:00',2.7),('8998','2013-07-21','13:30:00',2.67),('8998','2013-07-21','13:35:00',2.67),('8998','2013-07-21','13:40:00',2.7),('8998','2013-07-21','13:45:00',2.66),('8998','2013-07-21','13:50:00',2.63),('8998','2013-07-21','13:55:00',2.56),('8998','2013-07-21','14:00:00',2.56),('8998','2013-07-21','14:05:00',2.49),('8998','2013-07-21','14:10:00',2.49),('8998','2013-07-21','14:15:00',2.49),('8998','2013-07-21','14:20:00',2.47),('8998','2013-07-21','14:25:00',2.42),('8998','2013-07-21','14:30:00',2.38),('8998','2013-07-21','14:35:00',2.36),('8998','2013-07-21','14:40:00',2.33),('8998','2013-07-21','14:45:00',2.29),('8998','2013-07-21','14:50:00',2.25),('8998','2013-07-21','14:55:00',2.17),('8998','2013-07-21','15:00:00',2.11),('8998','2013-07-21','15:05:00',2),('8998','2013-07-21','15:10:00',2.08),('8998','2013-07-21','15:15:00',2.09),('8998','2013-07-21','15:20:00',2.03),('8998','2013-07-21','15:25:00',1.95),('8998','2013-07-21','15:40:00',1.83),('8998','2013-07-21','15:45:00',2.02),('8998','2013-07-21','15:50:00',1.97),('8998','2013-07-21','15:55:00',2.07),('8998','2013-07-21','16:00:00',1.89),('8998','2013-07-21','16:05:00',1.15),('8998','2013-07-21','16:15:00',1.54),('8998','2013-07-21','16:20:00',1.8),('8998','2013-07-21','16:25:00',1.68),('8998','2013-07-21','16:30:00',1.54),('8998','2013-07-21','16:35:00',1.44),('8998','2013-07-21','16:40:00',1.31),('8998','2013-07-21','16:45:00',1.23),('8998','2013-07-21','16:50:00',1.17),('8998','2013-07-21','16:55:00',1.1),('8998','2013-07-21','17:00:00',1.05),('8998','2013-07-21','17:05:00',1.01),('8998','2013-07-20','07:45:00',1.03),('8998','2013-07-20','07:50:00',1.1),('8998','2013-07-20','07:55:00',1.1),('8998','2013-07-20','08:00:00',1.14),('8998','2013-07-20','08:05:00',1.16),('8998','2013-07-20','08:10:00',1.26),('8998','2013-07-20','08:15:00',1.32),('8998','2013-07-20','08:20:00',1.36),('8998','2013-07-20','08:25:00',1.44),('8998','2013-07-20','08:30:00',1.47),('8998','2013-07-20','08:35:00',1.49),('8998','2013-07-20','08:40:00',1.49),('8998','2013-07-20','08:45:00',1.53),('8998','2013-07-20','08:50:00',1.54),('8998','2013-07-20','08:55:00',1.63),('8998','2013-07-20','09:00:00',1.72),('8998','2013-07-20','09:05:00',1.72),('8998','2013-07-20','09:10:00',1.76),('8998','2013-07-20','09:15:00',1.86),('8998','2013-07-20','09:20:00',1.99),('8998','2013-07-20','09:25:00',2.19),('8998','2013-07-20','09:30:00',2.33),('8998','2013-07-20','09:35:00',2.38),('8998','2013-07-20','09:40:00',2.43),('8998','2013-07-20','09:45:00',2.45),('8998','2013-07-20','09:50:00',2.48),('8998','2013-07-20','09:55:00',2.52),('8998','2013-07-20','10:00:00',2.55),('8998','2013-07-20','10:05:00',2.58),('8998','2013-07-20','10:10:00',2.58),('8998','2013-07-20','10:15:00',2.62),('8998','2013-07-20','10:20:00',2.65),('8998','2013-07-20','10:25:00',2.68),('8998','2013-07-20','10:30:00',2.66),('8998','2013-07-20','10:35:00',2.69),('8998','2013-07-20','10:40:00',2.72),('8998','2013-07-20','10:45:00',2.74),('8998','2013-07-20','10:50:00',2.76),('8998','2013-07-20','10:55:00',2.75),('8998','2013-07-20','11:00:00',2.76),('8998','2013-07-20','11:05:00',2.75),('8998','2013-07-20','11:10:00',2.77),('8998','2013-07-20','11:15:00',2.82),('8998','2013-07-20','11:20:00',2.83),('8998','2013-07-20','11:25:00',2.86),('8998','2013-07-20','11:30:00',2.85),('8998','2013-07-20','11:35:00',2.86),('8998','2013-07-20','11:40:00',3.01),('8998','2013-07-20','11:45:00',2.65),('8998','2013-07-20','11:50:00',2.95),('8998','2013-07-20','11:55:00',2.9),('8998','2013-07-20','12:00:00',2.88),('8998','2013-07-20','12:05:00',2.66),('8998','2013-07-20','12:10:00',2.9),('8998','2013-07-20','12:15:00',3.01),('8998','2013-07-20','12:20:00',3.07),('8998','2013-07-20','12:25:00',3.09),('8998','2013-07-20','12:30:00',3.13),('8998','2013-07-20','12:35:00',3),('8998','2013-07-20','12:40:00',3.12),('8998','2013-07-20','12:45:00',2.62),('8998','2013-07-20','12:50:00',3.14),('8998','2013-07-20','12:55:00',3.41),('8998','2013-07-20','13:00:00',3.21),('8998','2013-07-20','13:05:00',3.24),('8998','2013-07-20','13:10:00',3),('8998','2013-07-20','13:15:00',2.74),('8998','2013-07-20','13:20:00',2.78),('8998','2013-07-20','13:25:00',3.03),('8998','2013-07-20','13:30:00',2.83),('8998','2013-07-20','13:35:00',1.49),('8998','2013-07-20','14:45:00',1.51),('8998','2013-07-20','14:50:00',1.46),('8998','2013-07-20','14:55:00',1.17),('8998','2013-07-20','15:00:00',1.14),('8998','2013-07-20','15:15:00',2.07),('8998','2013-07-20','15:20:00',2.06),('8998','2013-07-20','15:25:00',1.02),('8998','2013-07-20','15:35:00',1.07),('8998','2013-07-20','15:40:00',2.34),('8998','2013-07-20','15:45:00',1.34),('8998','2013-07-20','15:50:00',1.45),('8998','2013-07-20','15:55:00',1.29),('8998','2014-04-06','08:30:00',1),('8998','2014-04-06','08:35:00',1.31),('8998','2014-04-06','08:40:00',1.38),('8998','2014-04-06','08:45:00',1.48),('8998','2014-04-06','08:50:00',1.22),('8998','2014-04-06','09:10:00',1.13),('8998','2014-04-06','09:15:00',1.19),('8998','2014-04-06','09:20:00',1.11),('8998','2014-04-06','09:55:00',1.13),('8998','2014-04-06','10:00:00',1.02),('8998','2014-04-06','10:05:00',1.03),('8998','2014-04-06','10:10:00',1.07),('8998','2014-04-06','10:30:00',1.04),('8998','2014-04-06','10:35:00',1.12),('8998','2014-04-06','10:40:00',1.16),('8998','2014-04-06','10:45:00',1.17),('8998','2014-04-06','10:50:00',1.21),('8998','2014-04-06','10:55:00',1.27),('8998','2014-04-06','11:00:00',1.34),('8998','2014-04-06','11:05:00',1.44),('8998','2014-04-06','11:10:00',1.68),('8998','2014-04-06','11:15:00',1.78),('8998','2014-04-06','11:20:00',1.61),('8998','2014-04-06','11:25:00',1.52),('8998','2014-04-06','11:30:00',1.5),('8998','2014-04-06','11:35:00',1.48),('8998','2014-04-06','11:40:00',1.4),('8998','2014-04-06','11:45:00',1.32),('8998','2014-04-06','11:50:00',1.29),('8998','2014-04-06','11:55:00',1.27),('8998','2014-04-06','12:00:00',1.4),('8998','2014-04-06','12:05:00',1.69),('8998','2014-04-06','12:10:00',1.98),('8998','2014-04-06','12:15:00',2.6),('8998','2014-04-06','12:20:00',3.11),('8998','2014-04-06','12:25:00',2.79),('8998','2014-04-06','12:30:00',1.83),('8998','2014-04-06','12:35:00',1.57),('8998','2014-04-06','12:40:00',2.12),('8998','2014-04-06','12:45:00',2.78),('8998','2014-04-06','12:50:00',2.76),('8998','2014-04-06','12:55:00',2.71),('8998','2014-04-06','13:00:00',2.69),('8998','2014-04-06','13:05:00',2.65),('8998','2014-04-06','13:10:00',2.62),('8998','2014-04-06','13:15:00',2.6),('8998','2014-04-06','13:20:00',2.59),('8998','2014-04-06','13:25:00',2.56),('8998','2014-04-06','13:30:00',2.54),('8998','2014-04-06','13:35:00',2.49),('8998','2014-04-06','13:40:00',2.47),('8998','2014-04-06','13:45:00',2.45),('8998','2014-04-06','13:50:00',2.41),('8998','2014-04-06','13:55:00',2.4),('8998','2014-04-06','14:00:00',2.36),('8998','2014-04-06','14:05:00',2.33),('8998','2014-04-06','14:10:00',2.3),('8998','2014-04-06','14:15:00',2.28),('8998','2014-04-06','14:20:00',2.28),('8998','2014-04-06','14:25:00',2.36),('8998','2014-04-06','14:30:00',2.28),('8998','2014-04-06','14:35:00',2.19),('8998','2014-04-06','14:40:00',2.14),('8998','2014-04-06','14:45:00',2.01),('8998','2014-04-06','14:50:00',2.08),('8998','2014-04-06','14:55:00',1.67),('8998','2014-04-06','15:00:00',1.83),('8998','2014-04-06','15:05:00',2.02),('8998','2014-04-06','15:10:00',1.54),('8998','2014-04-06','15:15:00',2.05),('8998','2014-04-06','15:20:00',2.16),('8998','2014-04-06','15:25:00',1.98),('8998','2014-04-06','15:30:00',1.77),('8998','2014-04-06','15:35:00',1.79),('8998','2014-04-06','15:40:00',1.71),('8998','2014-04-06','15:45:00',1.79),('8998','2014-04-06','15:50:00',1.88),('8998','2014-04-06','15:55:00',1.7),('8998','2014-04-06','16:10:00',1.38),('8998','2014-04-06','16:15:00',1.23),('8998','2014-04-06','16:20:00',1.07),('8998','2014-04-06','16:25:00',1.02),('8998','2013-07-19','07:45:00',1.14),('8998','2013-07-19','07:50:00',1.12),('8998','2013-07-19','07:55:00',1.14),('8998','2013-07-19','08:00:00',1.17),('8998','2013-07-19','08:05:00',1.22),('8998','2013-07-19','08:10:00',1.29),('8998','2013-07-19','08:15:00',1.37),('8998','2013-07-19','08:20:00',1.4),('8998','2013-07-19','08:25:00',1.48),('8998','2013-07-19','08:30:00',1.46),('8998','2013-07-19','08:35:00',1.54),('8998','2013-07-19','08:40:00',1.49),('8998','2013-07-19','08:45:00',1.57),('8998','2013-07-19','08:50:00',1.7),('8998','2013-07-19','08:55:00',1.73),('8998','2013-07-19','09:00:00',1.78),('8998','2013-07-19','09:05:00',1.81),('8998','2013-07-19','09:10:00',1.87),('8998','2013-07-19','09:15:00',2.01),('8998','2013-07-19','09:20:00',2.16),('8998','2013-07-19','09:25:00',2.26),('8998','2013-07-19','09:30:00',2.36),('8998','2013-07-19','09:35:00',2.41),('8998','2013-07-19','09:40:00',2.39),('8998','2013-07-19','09:45:00',2.49),('8998','2013-07-19','09:50:00',2.43),('8998','2013-07-19','09:55:00',2.47),('8998','2013-07-19','10:00:00',2.6),('8998','2013-07-19','10:05:00',2.61),('8998','2013-07-19','10:10:00',2.65),('8998','2013-07-19','10:15:00',2.67),('8998','2013-07-19','10:20:00',2.69),('8998','2013-07-19','10:25:00',2.71),('8998','2013-07-19','10:30:00',2.73),('8998','2013-07-19','10:35:00',2.76),('8998','2013-07-19','10:40:00',2.77),('8998','2013-07-19','10:45:00',2.79),('8998','2013-07-19','10:50:00',2.82),('8998','2013-07-19','10:55:00',2.82),('8998','2013-07-19','11:00:00',2.83),('8998','2013-07-19','11:05:00',2.83),('8998','2013-07-19','11:10:00',2.82),('8998','2013-07-19','11:15:00',2.87),('8998','2013-07-19','11:20:00',2.87),('8998','2013-07-19','11:25:00',2.87),('8998','2013-07-19','11:30:00',2.87),('8998','2013-07-19','11:35:00',2.85),('8998','2013-07-19','11:40:00',2.87),('8998','2013-07-19','11:45:00',2.86),('8998','2013-07-19','11:50:00',2.91),('8998','2013-07-19','11:55:00',2.93),('8998','2013-07-19','12:00:00',2.93),('8998','2013-07-19','12:05:00',2.93),('8998','2013-07-19','12:10:00',2.96),('8998','2013-07-19','12:15:00',2.91),('8998','2013-07-19','12:20:00',2.5),('8998','2013-07-19','12:25:00',2.57),('8998','2013-07-19','12:30:00',2.88),('8998','2013-07-19','12:35:00',2.82),('8998','2013-07-19','12:40:00',2.84),('8998','2013-07-19','12:45:00',2.94),('8998','2013-07-19','12:50:00',2.89),('8998','2013-07-19','12:55:00',2.9),('8998','2013-07-19','13:00:00',2.92),('8998','2013-07-19','13:05:00',2.87),('8998','2013-07-19','13:10:00',2.77),('8998','2013-07-19','13:15:00',2.54),('8998','2013-07-19','13:20:00',2.6),('8998','2013-07-19','13:25:00',2.11),('8998','2013-07-19','13:30:00',2.85),('8998','2013-07-19','13:35:00',2.84),('8998','2013-07-19','13:40:00',2.86),('8998','2013-07-19','13:45:00',2.82),('8998','2013-07-19','13:50:00',1.93),('8998','2013-07-19','14:00:00',2.06),('8998','2013-07-19','14:05:00',2.85),('8998','2013-07-19','14:10:00',2.63),('8998','2013-07-19','14:15:00',2.14),('8998','2013-07-19','14:20:00',1.36),('8998','2013-07-19','14:25:00',2.71),('8998','2013-07-19','14:30:00',2.61),('8998','2013-07-19','14:35:00',2.07),('8998','2013-07-19','14:40:00',2.33),('8998','2013-07-19','14:45:00',1.02),('8998','2013-07-19','14:50:00',1.96),('8998','2013-07-19','15:00:00',1.1),('8998','2013-07-19','15:05:00',2.41),('8998','2013-07-19','15:10:00',2.32),('8998','2013-07-19','15:15:00',2.22),('8998','2013-07-19','15:20:00',2.12),('8998','2013-07-19','15:25:00',2.06),('8998','2013-07-19','15:30:00',2),('8998','2013-07-19','15:35:00',1.93),('8998','2013-07-19','15:40:00',1.9),('8998','2013-07-19','15:45:00',1.84),('8998','2013-07-19','15:50:00',1.78),('8998','2013-07-19','15:55:00',1.75),('8998','2013-07-19','16:00:00',1.71),('8998','2013-07-19','16:05:00',1.65),('8998','2013-07-19','16:10:00',1.59),('8998','2013-07-19','16:15:00',1.55),('8998','2013-07-19','16:20:00',1.5),('8998','2013-07-19','16:25:00',1.44),('8998','2013-07-19','16:30:00',1.39),('8998','2013-07-19','16:35:00',1.33),('8998','2013-07-19','16:40:00',1.27),('8998','2013-07-19','16:45:00',1.2),('8998','2013-07-19','16:50:00',1.14),('8998','2013-07-19','16:55:00',1.09),('8998','2013-07-19','17:00:00',1.02),('8998','2013-07-18','07:45:00',1.05),('8998','2013-07-18','07:50:00',1.1),('8998','2013-07-18','07:55:00',1.11),('8998','2013-07-18','08:00:00',1.15),('8998','2013-07-18','08:05:00',1.21),('8998','2013-07-18','08:10:00',1.28),('8998','2013-07-18','08:15:00',1.32),('8998','2013-07-18','08:20:00',1.38),('8998','2013-07-18','08:25:00',1.45),('8998','2013-07-18','08:30:00',1.41),('8998','2013-07-18','08:35:00',1.51),('8998','2013-07-18','08:40:00',1.49),('8998','2013-07-18','08:45:00',1.59),('8998','2013-07-18','08:50:00',1.57),('8998','2013-07-18','08:55:00',1.64),('8998','2013-07-18','09:00:00',1.73),('8998','2013-07-18','09:05:00',1.78),('8998','2013-07-18','09:10:00',1.79),('8998','2013-07-18','09:15:00',1.91),('8998','2013-07-18','09:20:00',2.07),('8998','2013-07-18','09:25:00',2.21),('8998','2013-07-18','09:30:00',2.34),('8998','2013-07-18','09:35:00',2.38),('8998','2013-07-18','09:40:00',2.42),('8998','2013-07-18','09:45:00',2.43),('8998','2013-07-18','09:50:00',2.46),('8998','2013-07-18','09:55:00',2.47),('8998','2013-07-18','10:00:00',2.5),('8998','2013-07-18','10:05:00',2.51),('8998','2013-07-18','10:10:00',2.53),('8998','2013-07-18','10:15:00',2.54),('8998','2013-07-18','10:20:00',2.55),('8998','2013-07-18','10:25:00',2.65),('8998','2013-07-18','10:30:00',2.59),('8998','2013-07-18','10:35:00',2.69),('8998','2013-07-18','10:40:00',2.66),('8998','2013-07-18','10:45:00',2.67),('8998','2013-07-18','10:50:00',2.7),('8998','2013-07-18','10:55:00',2.71),('8998','2013-07-18','11:00:00',2.73),('8998','2013-07-18','11:05:00',2.69),('8998','2013-07-18','11:10:00',2.69),('8998','2013-07-18','11:15:00',2.71),('8998','2013-07-18','11:20:00',2.73),('8998','2013-07-18','11:25:00',2.76),('8998','2013-07-18','11:30:00',2.75),('8998','2013-07-18','11:35:00',2.71),('8998','2013-07-18','11:40:00',2.71),('8998','2013-07-18','11:45:00',2.82),('8998','2013-07-18','11:50:00',2.78),('8998','2013-07-18','11:55:00',2.7),('8998','2013-07-18','12:00:00',2.16),('8998','2013-07-18','12:05:00',2.66),('8998','2013-07-18','12:10:00',2.83),('8998','2013-07-18','12:15:00',2.89),('8998','2013-07-18','12:20:00',2.84),('8998','2013-07-18','12:25:00',2.84),('8998','2013-07-18','12:30:00',2.83),('8998','2013-07-18','12:35:00',2.78),('8998','2013-07-18','12:40:00',2.79),('8998','2013-07-18','12:45:00',2.75),('8998','2013-07-18','12:50:00',2.8),('8998','2013-07-18','12:55:00',1.97),('8998','2013-07-18','13:00:00',2.51),('8998','2013-07-18','13:05:00',2.83),('8998','2013-07-18','13:10:00',2.8),('8998','2013-07-18','13:15:00',1.49),('8998','2013-07-18','13:20:00',1.05),('8998','2013-07-18','13:25:00',2.41),('8998','2013-07-18','13:30:00',2.95),('8998','2013-07-18','13:35:00',2.85),('8998','2013-07-18','13:40:00',2.78),('8998','2013-07-18','13:45:00',2.77),('8998','2013-07-18','13:50:00',2.75),('8998','2013-07-18','13:55:00',2.74),('8998','2013-07-18','14:00:00',2.74),('8998','2013-07-18','14:05:00',2.7),('8998','2013-07-18','14:10:00',2.15),('8998','2013-07-18','14:15:00',2.46),('8998','2013-07-18','14:20:00',2.15),('8998','2013-07-18','14:25:00',2.12),('8998','2013-07-18','14:30:00',2.49),('8998','2013-07-18','14:35:00',2.59),('8998','2013-07-18','14:40:00',2.31),('8998','2013-07-18','14:45:00',2.41),('8998','2013-07-18','14:50:00',2.17),('8998','2013-07-18','14:55:00',2.34),('8998','2013-07-18','15:00:00',2.11),('8998','2013-07-18','15:05:00',2.29),('8998','2013-07-18','15:10:00',2.2),('8998','2013-07-18','15:15:00',1.84),('8998','2013-07-18','15:20:00',1.71),('8998','2013-07-18','15:25:00',1.67),('8998','2013-07-18','15:30:00',2.18),('8998','2013-07-18','15:35:00',2.1),('8998','2013-07-18','15:40:00',1.84),('8998','2013-07-18','15:45:00',2.02),('8998','2013-07-18','15:50:00',2),('8998','2013-07-18','15:55:00',1.82),('8998','2013-07-18','16:00:00',1.85),('8998','2013-07-18','16:05:00',1.8),('8998','2013-07-18','16:10:00',1.73),('8998','2013-07-18','16:15:00',1.7),('8998','2013-07-18','16:20:00',1.66),('8998','2013-07-18','16:25:00',1.62),('8998','2013-07-18','16:30:00',1.59),('8998','2013-07-18','16:35:00',1.55),('8998','2013-07-18','16:40:00',1.5),('8998','2013-07-18','16:45:00',1.46),('8998','2013-07-18','16:50:00',1.34),('8998','2013-07-18','16:55:00',1.39),('8998','2013-07-18','17:00:00',1.05),('8998','2013-07-18','17:05:00',1.34),('8998','2013-07-18','17:10:00',1.3),('8998','2013-07-18','17:15:00',1.1),('8998','2013-07-17','07:40:00',1.03),('8998','2013-07-17','07:45:00',1.26),('8998','2013-07-17','07:50:00',1.21),('8998','2013-07-17','07:55:00',1.28),('8998','2013-07-17','08:00:00',1.25),('8998','2013-07-17','08:05:00',1.27),('8998','2013-07-17','08:10:00',1.33),('8998','2013-07-17','08:15:00',1.49),('8998','2013-07-17','08:20:00',1.57),('8998','2013-07-17','08:25:00',1.54),('8998','2013-07-17','08:30:00',1.48),('8998','2013-07-17','08:35:00',1.57),('8998','2013-07-17','08:40:00',1.51),('8998','2013-07-17','08:45:00',1.58),('8998','2013-07-17','08:50:00',1.56),('8998','2013-07-17','08:55:00',1.64),('8998','2013-07-17','09:00:00',1.76),('8998','2013-07-17','09:05:00',1.83),('8998','2013-07-17','09:10:00',1.82),('8998','2013-07-17','09:15:00',1.98),('8998','2013-07-17','09:20:00',2.17),('8998','2013-07-17','09:25:00',2.32),('8998','2013-07-17','09:30:00',2.45),('8998','2013-07-17','09:35:00',2.48),('8998','2013-07-17','09:40:00',2.51),('8998','2013-07-17','09:45:00',2.53),('8998','2013-07-17','09:50:00',2.57),('8998','2013-07-17','09:55:00',2.59),('8998','2013-07-17','10:00:00',2.61),('8998','2013-07-17','10:05:00',2.62),('8998','2013-07-17','10:10:00',2.67),('8998','2013-07-17','10:15:00',2.68),('8998','2013-07-17','10:20:00',2.69),('8998','2013-07-17','10:25:00',2.71),('8998','2013-07-17','10:30:00',2.75),('8998','2013-07-17','10:35:00',2.78),('8998','2013-07-17','10:40:00',2.8),('8998','2013-07-17','10:45:00',2.81),('8998','2013-07-17','10:50:00',2.83),('8998','2013-07-17','10:55:00',2.83),('8998','2013-07-17','11:00:00',2.82),('8998','2013-07-17','11:05:00',2.82),('8998','2013-07-17','11:10:00',2.84),('8998','2013-07-17','11:15:00',2.85),('8998','2013-07-17','11:20:00',2.87),('8998','2013-07-17','11:25:00',2.86),('8998','2013-07-17','11:30:00',2.86),('8998','2013-07-17','11:35:00',2.87),('8998','2013-07-17','11:40:00',2.86),('8998','2013-07-17','11:45:00',2.86),('8998','2013-07-17','11:50:00',2.86),('8998','2013-07-17','11:55:00',2.89),('8998','2013-07-17','12:00:00',2.9),('8998','2013-07-17','12:05:00',2.85),('8998','2013-07-17','12:10:00',2.82),('8998','2013-07-17','12:15:00',2.82),('8998','2013-07-17','12:20:00',2.85),('8998','2013-07-17','12:25:00',2.84),('8998','2013-07-17','12:30:00',2.75),('8998','2013-07-17','12:35:00',2.95),('8998','2013-07-17','12:40:00',3.02),('8998','2013-07-17','12:45:00',2),('8998','2013-07-17','12:50:00',1.08),('8998','2013-07-17','12:55:00',2.48),('8998','2013-07-17','13:00:00',2.98),('8998','2013-07-17','13:05:00',2.83),('8998','2013-07-17','13:10:00',2.77),('8998','2013-07-17','13:15:00',2.74),('8998','2013-07-17','13:20:00',2.83),('8998','2013-07-17','13:25:00',2.82),('8998','2013-07-17','13:30:00',2.85),('8998','2013-07-17','13:35:00',2.68),('8998','2013-07-17','13:40:00',2.43),('8998','2013-07-17','13:45:00',2.76),('8998','2013-07-17','13:50:00',2.72),('8998','2013-07-17','13:55:00',2.58),('8998','2013-07-17','14:00:00',2.62),('8998','2013-07-17','14:05:00',2.55),('8998','2013-07-17','14:10:00',2.53),('8998','2013-07-17','14:15:00',2.27),('8998','2013-07-17','14:20:00',2.52),('8998','2013-07-17','14:25:00',2.48),('8998','2013-07-17','14:30:00',2.42),('8998','2013-07-17','14:35:00',2.41),('8998','2013-07-17','14:40:00',2.37),('8998','2013-07-17','14:45:00',2.32),('8998','2013-07-17','14:50:00',2.29),('8998','2013-07-17','14:55:00',2.22),('8998','2013-07-17','15:00:00',2.17),('8998','2013-07-17','15:05:00',2.16),('8998','2013-07-17','15:10:00',2.12),('8998','2013-07-17','15:15:00',2.06),('8998','2013-07-17','15:20:00',2.03),('8998','2013-07-17','15:25:00',2.02),('8998','2013-07-17','15:30:00',1.95),('8998','2013-07-17','15:35:00',1.89),('8998','2013-07-17','15:40:00',1.86),('8998','2013-07-17','15:45:00',1.81),('8998','2013-07-17','15:50:00',1.76),('8998','2013-07-17','15:55:00',1.71),('8998','2013-07-17','16:00:00',1.65),('8998','2013-07-17','16:05:00',1.61),('8998','2013-07-17','16:10:00',1.55),('8998','2013-07-17','16:15:00',1.49),('8998','2013-07-17','16:20:00',1.44),('8998','2013-07-17','16:25:00',1.39),('8998','2013-07-17','16:30:00',1.34),('8998','2013-07-17','16:35:00',1.3),('8998','2013-07-17','16:40:00',1.24),('8998','2013-07-17','16:45:00',1.18),('8998','2013-07-17','16:50:00',1.13),('8998','2013-07-17','16:55:00',1.07),('8998','2013-07-17','17:00:00',1),('8998','2013-07-16','07:40:00',1.05),('8998','2013-07-16','07:45:00',1.2),('8998','2013-07-16','07:50:00',1.21),('8998','2013-07-16','07:55:00',1.31),('8998','2013-07-16','08:00:00',1.25),('8998','2013-07-16','08:05:00',1.32),('8998','2013-07-16','08:10:00',1.42),('8998','2013-07-16','08:15:00',1.53),('8998','2013-07-16','08:20:00',1.67),('8998','2013-07-16','08:25:00',1.62),('8998','2013-07-16','08:30:00',1.54),('8998','2013-07-16','08:35:00',1.65),('8998','2013-07-16','08:40:00',1.57),('8998','2013-07-16','08:45:00',1.64),('8998','2013-07-16','08:50:00',1.79),('8998','2013-07-16','08:55:00',1.78),('8998','2013-07-16','09:00:00',1.83),('8998','2013-07-16','09:05:00',1.93),('8998','2013-07-16','09:10:00',1.94),('8998','2013-07-16','09:15:00',2.14),('8998','2013-07-16','09:20:00',2.39),('8998','2013-07-16','09:25:00',2.54),('8998','2013-07-16','09:30:00',2.6),('8998','2013-07-16','09:35:00',2.61),('8998','2013-07-16','09:40:00',2.65),('8998','2013-07-16','09:45:00',2.69),('8998','2013-07-16','09:50:00',2.71),('8998','2013-07-16','09:55:00',2.72),('8998','2013-07-16','10:00:00',2.75),('8998','2013-07-16','10:05:00',2.77),('8998','2013-07-16','10:10:00',2.79),('8998','2013-07-16','10:15:00',2.79),('8998','2013-07-16','10:20:00',2.81),('8998','2013-07-16','10:25:00',2.84),('8998','2013-07-16','10:30:00',2.85),('8998','2013-07-16','10:35:00',2.87),('8998','2013-07-16','10:40:00',2.88),('8998','2013-07-16','10:45:00',2.92),('8998','2013-07-16','10:50:00',2.94),('8998','2013-07-16','10:55:00',2.95),('8998','2013-07-16','11:00:00',2.97),('8998','2013-07-16','11:05:00',3),('8998','2013-07-16','11:10:00',2.99),('8998','2013-07-16','11:15:00',2.99),('8998','2013-07-16','11:20:00',2.99),('8998','2013-07-16','11:25:00',3.01),('8998','2013-07-16','11:30:00',3.01),('8998','2013-07-16','11:35:00',3.01),('8998','2013-07-16','11:40:00',3),('8998','2013-07-16','11:45:00',3),('8998','2013-07-16','11:50:00',3.02),('8998','2013-07-16','11:55:00',3.03),('8998','2013-07-16','12:00:00',3.02),('8998','2013-07-16','12:05:00',3.01),('8998','2013-07-16','12:10:00',3),('8998','2013-07-16','12:15:00',2.96),('8998','2013-07-16','12:20:00',2.95),('8998','2013-07-16','12:25:00',2.97),('8998','2013-07-16','12:30:00',2.94),('8998','2013-07-16','12:35:00',2.94),('8998','2013-07-16','12:40:00',2.92),('8998','2013-07-16','12:45:00',2.91),('8998','2013-07-16','12:50:00',2.91),('8998','2013-07-16','12:55:00',2.91),('8998','2013-07-16','13:00:00',2.9),('8998','2013-07-16','13:05:00',2.88),('8998','2013-07-16','13:10:00',2.84),('8998','2013-07-16','13:15:00',2.82),('8998','2013-07-16','13:20:00',2.77),('8998','2013-07-16','13:25:00',2.76),('8998','2013-07-16','13:30:00',2.74),('8998','2013-07-16','13:35:00',2.71),('8998','2013-07-16','13:40:00',2.71),('8998','2013-07-16','13:45:00',2.7),('8998','2013-07-16','13:50:00',2.66),('8998','2013-07-16','13:55:00',2.64),('8998','2013-07-16','14:00:00',2.63),('8998','2013-07-16','14:05:00',2.58),('8998','2013-07-16','14:10:00',2.55),('8998','2013-07-16','14:15:00',2.53),('8998','2013-07-16','14:20:00',2.5),('8998','2013-07-16','14:25:00',2.46),('8998','2013-07-16','14:30:00',2.43),('8998','2013-07-16','14:35:00',2.4),('8998','2013-07-16','14:40:00',2.55),('8998','2013-07-16','14:45:00',2.44),('8998','2013-07-16','14:50:00',2.32),('8998','2013-07-16','14:55:00',2.23),('8998','2013-07-16','15:00:00',2.25),('8998','2013-07-16','15:05:00',2.19),('8998','2013-07-16','15:10:00',2.09),('8998','2013-07-16','15:15:00',2.21),('8998','2013-07-16','15:20:00',2.13),('8998','2013-07-16','15:25:00',2.04),('8998','2013-07-16','15:30:00',1.96),('8998','2013-07-16','15:35:00',1.94),('8998','2013-07-16','15:40:00',1.51),('8998','2013-07-16','15:45:00',1.84),('8998','2013-07-16','15:50:00',1.8),('8998','2013-07-16','15:55:00',1.76),('8998','2013-07-16','16:00:00',1.72),('8998','2013-07-16','16:05:00',1.66),('8998','2013-07-16','16:10:00',1.64),('8998','2013-07-16','16:15:00',1.58),('8998','2013-07-16','16:20:00',1.5),('8998','2013-07-16','16:25:00',1.44),('8998','2013-07-16','16:30:00',1.4),('8998','2013-07-16','16:35:00',1.36),('8998','2013-07-16','16:40:00',1.29),('8998','2013-07-16','16:45:00',1.28),('8998','2013-07-16','16:50:00',1.21),('8998','2013-07-16','16:55:00',1.13),('8998','2013-07-16','17:05:00',1.05),('8998','2013-07-16','17:10:00',1.01),('8998','2013-07-15','07:45:00',1.18),('8998','2013-07-15','07:50:00',1.19),('8998','2013-07-15','07:55:00',1.27),('8998','2013-07-15','08:00:00',1.21),('8998','2013-07-15','08:05:00',1.26),('8998','2013-07-15','08:10:00',1.33),('8998','2013-07-15','08:15:00',1.44),('8998','2013-07-15','08:20:00',1.61),('8998','2013-07-15','08:25:00',1.58),('8998','2013-07-15','08:30:00',1.54),('8998','2013-07-15','08:35:00',1.59),('8998','2013-07-15','08:40:00',1.52),('8998','2013-07-15','08:45:00',1.57),('8998','2013-07-15','08:50:00',1.61),('8998','2013-07-15','08:55:00',1.62),('8998','2013-07-15','09:00:00',1.77),('8998','2013-07-15','09:05:00',1.85),('8998','2013-07-15','09:10:00',1.86),('8998','2013-07-15','09:15:00',2.03),('8998','2013-07-15','09:20:00',2.22),('8998','2013-07-15','09:25:00',2.36),('8998','2013-07-15','09:30:00',2.43),('8998','2013-07-15','09:35:00',2.46),('8998','2013-07-15','09:40:00',2.49),('8998','2013-07-15','09:45:00',2.56),('8998','2013-07-15','09:50:00',2.6),('8998','2013-07-15','09:55:00',2.63),('8998','2013-07-15','10:00:00',2.66),('8998','2013-07-15','10:05:00',2.7),('8998','2013-07-15','10:10:00',2.75),('8998','2013-07-15','10:15:00',2.75),('8998','2013-07-15','10:20:00',2.75),('8998','2013-07-15','10:25:00',2.78),('8998','2013-07-15','10:30:00',2.81),('8998','2013-07-15','10:35:00',2.82),('8998','2013-07-15','10:40:00',2.84),('8998','2013-07-15','10:45:00',2.85),('8998','2013-07-15','10:50:00',2.86),('8998','2013-07-15','10:55:00',2.88),('8998','2013-07-15','11:00:00',2.89),('8998','2013-07-15','11:05:00',2.91),('8998','2013-07-15','11:10:00',2.93),('8998','2013-07-15','11:15:00',2.92),('8998','2013-07-15','11:20:00',2.93),('8998','2013-07-15','11:25:00',2.94),('8998','2013-07-15','11:30:00',2.92),('8998','2013-07-15','11:35:00',2.9),('8998','2013-07-15','11:40:00',2.92),('8998','2013-07-15','11:45:00',2.95),('8998','2013-07-15','11:50:00',2.99),('8998','2013-07-15','11:55:00',2.99),('8998','2013-07-15','12:00:00',2.99),('8998','2013-07-15','12:05:00',2.97),('8998','2013-07-15','12:10:00',2.98),('8998','2013-07-15','12:15:00',2.97),('8998','2013-07-15','12:20:00',2.95),('8998','2013-07-15','12:25:00',2.94),('8998','2013-07-15','12:30:00',2.92),('8998','2013-07-15','12:35:00',2.9),('8998','2013-07-15','12:40:00',2.88),('8998','2013-07-15','12:45:00',2.83),('8998','2013-07-15','12:50:00',2.83),('8998','2013-07-15','12:55:00',2.81),('8998','2013-07-15','13:00:00',2.81),('8998','2013-07-15','13:05:00',2.82),('8998','2013-07-15','13:10:00',2.8),('8998','2013-07-15','13:15:00',2.81),('8998','2013-07-15','13:20:00',2.77),('8998','2013-07-15','13:25:00',2.78),('8998','2013-07-15','13:30:00',2.75),('8998','2013-07-15','13:35:00',2.75),('8998','2013-07-15','13:40:00',2.74),('8998','2013-07-15','13:45:00',2.78),('8998','2013-07-15','13:50:00',2.75),('8998','2013-07-15','13:55:00',2.47),('8998','2013-07-15','14:00:00',2.6),('8998','2013-07-15','14:05:00',2.62),('8998','2013-07-15','14:10:00',2.4),('8998','2013-07-15','14:15:00',1.78),('8998','2013-07-15','14:20:00',1.24),('8998','2013-07-15','14:25:00',2.59),('8998','2013-07-15','14:30:00',2.53),('8998','2013-07-15','14:35:00',2.5),('8998','2013-07-15','14:40:00',2.42),('8998','2013-07-15','14:45:00',2.37),('8998','2013-07-15','14:50:00',2.36),('8998','2013-07-15','14:55:00',2.32),('8998','2013-07-15','15:00:00',2.26),('8998','2013-07-15','15:05:00',2.2),('8998','2013-07-15','15:10:00',2.14),('8998','2013-07-15','15:15:00',2.09),('8998','2013-07-15','15:20:00',2.07),('8998','2013-07-15','15:25:00',2.03),('8998','2013-07-15','15:30:00',2.02),('8998','2013-07-15','15:35:00',1.96),('8998','2013-07-15','15:40:00',1.85),('8998','2013-07-15','15:45:00',1.33),('8998','2013-07-15','15:50:00',1.81),('8998','2013-07-15','15:55:00',1.75),('8998','2013-07-15','16:00:00',1.05),('8998','2013-07-15','16:10:00',1.57),('8998','2013-07-15','16:15:00',1.52),('8998','2013-07-15','16:20:00',1.13),('8998','2013-07-15','17:00:00',1.25),('8998','2013-07-15','17:05:00',1.25),('8998','2013-07-15','17:10:00',1.28),('8998','2013-07-15','17:15:00',1.18),('8998','2013-07-15','17:20:00',1.05),('8998','2013-07-14','07:45:00',1.18),('8998','2013-07-14','07:50:00',1.2),('8998','2013-07-14','07:55:00',1.29),('8998','2013-07-14','08:00:00',1.24),('8998','2013-07-14','08:05:00',1.29),('8998','2013-07-14','08:10:00',1.36),('8998','2013-07-14','08:15:00',1.4),('8998','2013-07-14','08:20:00',1.48),('8998','2013-07-14','08:25:00',1.59),('8998','2013-07-14','08:30:00',1.57),('8998','2013-07-14','08:35:00',1.64),('8998','2013-07-14','08:40:00',1.59),('8998','2013-07-14','08:45:00',1.6),('8998','2013-07-14','08:50:00',1.67),('8998','2013-07-14','08:55:00',1.74),('8998','2013-07-14','09:00:00',1.83),('8998','2013-07-14','09:05:00',1.91),('8998','2013-07-14','09:10:00',1.91),('8998','2013-07-14','09:15:00',2.11),('8998','2013-07-14','09:20:00',2.32),('8998','2013-07-14','09:25:00',2.48),('8998','2013-07-14','09:30:00',2.55),('8998','2013-07-14','09:35:00',2.58),('8998','2013-07-14','09:40:00',2.6),('8998','2013-07-14','09:45:00',2.62),('8998','2013-07-14','09:50:00',2.67),('8998','2013-07-14','09:55:00',2.69),('8998','2013-07-14','10:00:00',2.69),('8998','2013-07-14','10:05:00',2.71),('8998','2013-07-14','10:10:00',2.75),('8998','2013-07-14','10:15:00',2.76),('8998','2013-07-14','10:20:00',2.76),('8998','2013-07-14','10:25:00',2.79),('8998','2013-07-14','10:30:00',2.79),('8998','2013-07-14','10:35:00',2.81),('8998','2013-07-14','10:40:00',2.83),('8998','2013-07-14','10:45:00',2.84),('8998','2013-07-14','10:50:00',2.85),('8998','2013-07-14','10:55:00',2.87),('8998','2013-07-14','11:00:00',2.89),('8998','2013-07-14','11:05:00',2.9),('8998','2013-07-14','11:10:00',2.91),('8998','2013-07-14','11:15:00',2.92),('8998','2013-07-14','11:20:00',2.93),('8998','2013-07-14','11:25:00',2.93),('8998','2013-07-14','11:30:00',2.93),('8998','2013-07-14','11:35:00',2.94),('8998','2013-07-14','11:40:00',2.96),('8998','2013-07-14','11:45:00',2.93),('8998','2013-07-14','11:50:00',2.92),('8998','2013-07-14','11:55:00',2.95),('8998','2013-07-14','12:00:00',2.95),('8998','2013-07-14','12:05:00',2.91),('8998','2013-07-14','12:10:00',2.91),('8998','2013-07-14','12:15:00',2.96),('8998','2013-07-14','12:20:00',2.95),('8998','2013-07-14','12:25:00',2.92),('8998','2013-07-14','12:30:00',2.92),('8998','2013-07-14','12:35:00',2.89),('8998','2013-07-14','12:40:00',2.85),('8998','2013-07-14','12:45:00',2.82),('8998','2013-07-14','12:50:00',2.84),('8998','2013-07-14','12:55:00',2.85),('8998','2013-07-14','13:00:00',2.42),('8998','2013-07-14','13:05:00',2.58),('8998','2013-07-14','13:10:00',2.6),('8998','2013-07-14','13:15:00',2.82),('8998','2013-07-14','13:20:00',2.75),('8998','2013-07-14','13:25:00',2.9),('8998','2013-07-14','13:30:00',2.91),('8998','2013-07-14','13:35:00',1.8),('8998','2013-07-14','13:45:00',1.55),('8998','2013-07-14','13:50:00',2.98),('8998','2013-07-14','13:55:00',2.92),('8998','2013-07-14','14:00:00',2.91),('8998','2013-07-14','14:05:00',1.75),('8998','2013-07-14','14:20:00',2.32),('8998','2013-07-14','14:25:00',2.65),('8998','2013-07-14','14:30:00',2.29),('8998','2013-07-14','14:35:00',2.56),('8998','2013-07-14','14:40:00',2.53),('8998','2013-07-14','14:45:00',2.45),('8998','2013-07-14','14:50:00',2.44),('8998','2013-07-14','14:55:00',2.41),('8998','2013-07-14','15:00:00',2.38),('8998','2013-07-14','15:05:00',2.32),('8998','2013-07-14','15:10:00',2.27),('8998','2013-07-14','15:15:00',2.21),('8998','2013-07-14','15:20:00',2.12),('8998','2013-07-14','15:25:00',2.09),('8998','2013-07-14','15:30:00',2.04),('8998','2013-07-14','15:35:00',1.98),('8998','2013-07-14','15:40:00',2.02),('8998','2013-07-14','15:45:00',1.82),('8998','2013-07-14','15:50:00',1.93),('8998','2013-07-14','15:55:00',1.66),('8998','2013-07-14','16:00:00',1.72),('8998','2013-07-14','16:05:00',1.67),('8998','2013-07-14','16:10:00',1.62),('8998','2013-07-14','16:15:00',1.58),('8998','2013-07-14','16:20:00',1.48),('8998','2013-07-14','16:25:00',1.42),('8998','2013-07-14','16:30:00',1.38),('8998','2013-07-14','16:35:00',1.34),('8998','2013-07-14','16:40:00',1.28),('8998','2013-07-14','16:45:00',1.22),('8998','2013-07-14','16:50:00',1.17),('8998','2013-07-14','16:55:00',1.12),('8998','2013-07-14','17:00:00',1.07),('8998','2013-07-14','17:05:00',1.02),('8998','2013-07-13','07:55:00',1.09),('8998','2013-07-13','08:05:00',1.26),('8998','2013-07-13','08:10:00',1.91),('8998','2013-07-13','08:15:00',1.53),('8998','2013-07-13','08:20:00',2.08),('8998','2013-07-13','08:25:00',1.42),('8998','2013-07-13','08:35:00',1.04),('8998','2013-07-13','08:40:00',1.04),('8998','2013-07-13','08:50:00',1.04),('8998','2013-07-13','08:55:00',1.16),('8998','2013-07-13','09:05:00',1.14),('8998','2013-07-13','09:10:00',1.17),('8998','2013-07-13','09:15:00',1.29),('8998','2013-07-13','09:20:00',1.63),('8998','2013-07-13','09:25:00',2.14),('8998','2013-07-13','09:30:00',1.98),('8998','2013-07-13','09:35:00',1.47),('8998','2013-07-13','09:40:00',1.3),('8998','2013-07-13','09:45:00',1.3),('8998','2013-07-13','09:50:00',1.23),('8998','2013-07-13','09:55:00',1.37),('8998','2013-07-13','10:00:00',1.29),('8998','2013-07-13','10:05:00',1.37),('8998','2013-07-13','10:10:00',1.36),('8998','2013-07-13','10:15:00',1.43),('8998','2013-07-13','10:20:00',1.87),('8998','2013-07-13','10:25:00',2.25),('8998','2013-07-13','10:30:00',2.02),('8998','2013-07-13','10:35:00',2.79),('8998','2013-07-13','10:40:00',2.92),('8998','2013-07-13','10:45:00',2.7),('8998','2013-07-13','10:50:00',3.17),('8998','2013-07-13','10:55:00',2.66),('8998','2013-07-13','11:00:00',3.1),('8998','2013-07-13','11:05:00',3.04),('8998','2013-07-13','11:10:00',2.02),('8998','2013-07-13','11:15:00',2.44),('8998','2013-07-13','11:20:00',3.31),('8998','2013-07-13','11:25:00',3.03),('8998','2013-07-13','11:30:00',3.13),('8998','2013-07-13','11:35:00',3.05),('8998','2013-07-13','11:40:00',2.89),('8998','2013-07-13','11:45:00',3.22),('8998','2013-07-13','11:50:00',3.09),('8998','2013-07-13','11:55:00',1.27),('8998','2013-07-13','12:05:00',1.16),('8998','2013-07-13','12:10:00',2.77),('8998','2013-07-13','12:15:00',2.68),('8998','2013-07-13','12:20:00',1.56),('8998','2013-07-13','12:25:00',1.73),('8998','2013-07-13','12:30:00',1.2),('8998','2013-07-13','12:35:00',1.07),('8998','2013-07-13','12:40:00',1.27),('8998','2013-07-13','12:45:00',2.28),('8998','2013-07-13','12:50:00',2.13),('8998','2013-07-13','12:55:00',2.61),('8998','2013-07-13','13:00:00',3.14),('8998','2013-07-13','13:05:00',3.17),('8998','2013-07-13','13:10:00',3.04),('8998','2013-07-13','13:15:00',3.03),('8998','2013-07-13','13:20:00',3.08),('8998','2013-07-13','13:25:00',2.95),('8998','2013-07-13','13:30:00',2.92),('8998','2013-07-13','13:35:00',2.87),('8998','2013-07-13','13:40:00',2.83),('8998','2013-07-13','13:45:00',2.83),('8998','2013-07-13','13:50:00',2.83),('8998','2013-07-13','13:55:00',2.81),('8998','2013-07-13','14:00:00',2.8),('8998','2013-07-13','14:05:00',2.78),('8998','2013-07-13','14:10:00',2.74),('8998','2013-07-13','14:15:00',2.72),('8998','2013-07-13','14:20:00',2.69),('8998','2013-07-13','14:25:00',2.64),('8998','2013-07-13','14:30:00',2.6),('8998','2013-07-13','14:35:00',2.51),('8998','2013-07-13','14:40:00',2.44),('8998','2013-07-13','14:45:00',2.42),('8998','2013-07-13','14:50:00',2.45),('8998','2013-07-13','14:55:00',2.42),('8998','2013-07-13','15:00:00',2.3),('8998','2013-07-13','15:05:00',2.24),('8998','2013-07-13','15:10:00',2.18),('8998','2013-07-13','15:15:00',2.14),('8998','2013-07-13','15:20:00',2.09),('8998','2013-07-13','15:25:00',2.05),('8998','2013-07-13','15:30:00',2),('8998','2013-07-13','15:35:00',1.95),('8998','2013-07-13','15:40:00',1.9),('8998','2013-07-13','15:45:00',1.85),('8998','2013-07-13','15:50:00',1.8),('8998','2013-07-13','15:55:00',1.79),('8998','2013-07-13','16:00:00',1.72),('8998','2013-07-13','16:05:00',1.71),('8998','2013-07-13','16:10:00',1.66),('8998','2013-07-13','16:15:00',1.61),('8998','2013-07-13','16:20:00',1.44),('8998','2013-07-13','16:25:00',1.51),('8998','2013-07-13','16:30:00',1.22),('8998','2013-07-13','16:35:00',1.2),('8998','2013-07-13','16:40:00',1.38),('8998','2013-07-13','16:45:00',1.3),('8998','2013-07-13','16:50:00',1.33),('8998','2013-07-13','16:55:00',1.28),('8998','2013-07-13','17:00:00',1.14),('8998','2013-07-12','07:45:00',1.1),('8998','2013-07-12','07:50:00',1.13),('8998','2013-07-12','07:55:00',1.21),('8998','2013-07-12','08:00:00',1.2),('8998','2013-07-12','08:05:00',1.28),('8998','2013-07-12','08:10:00',1.37),('8998','2013-07-12','08:15:00',1.42),('8998','2013-07-12','08:20:00',1.49),('8998','2013-07-12','08:25:00',1.54),('8998','2013-07-12','08:30:00',1.56),('8998','2013-07-12','08:35:00',1.55),('8998','2013-07-12','08:40:00',1.58),('8998','2013-07-12','08:45:00',1.6),('8998','2013-07-12','08:50:00',1.69),('8998','2013-07-12','08:55:00',1.61),('8998','2013-07-12','09:00:00',1.89),('8998','2013-07-12','09:05:00',2.08),('8998','2013-07-12','09:10:00',2.13),('8998','2013-07-12','09:15:00',2.23),('8998','2013-07-12','09:20:00',2.29),('8998','2013-07-12','09:25:00',2.42),('8998','2013-07-12','09:30:00',2.45),('8998','2013-07-12','09:35:00',2.48),('8998','2013-07-12','09:40:00',2.5),('8998','2013-07-12','09:45:00',2.55),('8998','2013-07-12','09:50:00',2.6),('8998','2013-07-12','09:55:00',2.59),('8998','2013-07-12','10:00:00',2.57),('8998','2013-07-12','10:05:00',2.65),('8998','2013-07-12','10:10:00',2.68),('8998','2013-07-12','10:15:00',2.63),('8998','2013-07-12','10:20:00',2.71),('8998','2013-07-12','10:25:00',2.79),('8998','2013-07-12','10:30:00',2.85),('8998','2013-07-12','10:35:00',2.77),('8998','2013-07-12','10:40:00',2.69),('8998','2013-07-12','10:45:00',2.79),('8998','2013-07-12','10:50:00',2.58),('8998','2013-07-12','10:55:00',2.92),('8998','2013-07-12','11:00:00',2.83),('8998','2013-07-12','11:05:00',2.98),('8998','2013-07-12','11:10:00',3.06),('8998','2013-07-12','11:15:00',2.09),('8998','2013-07-12','11:20:00',1.09),('8998','2013-07-12','11:25:00',1.76),('8998','2013-07-12','11:30:00',2.93),('8998','2013-07-12','11:35:00',3.11),('8998','2013-07-12','11:40:00',2.36),('8998','2013-07-12','11:45:00',1.18),('8998','2013-07-12','11:50:00',2.97),('8998','2013-07-12','11:55:00',2.32),('8998','2013-07-12','12:00:00',2.13),('8998','2013-07-12','12:05:00',2.52),('8998','2013-07-12','12:10:00',3.01),('8998','2013-07-12','12:15:00',1.32),('8998','2013-07-12','12:20:00',1.31),('8998','2013-07-12','12:25:00',1.93),('8998','2013-07-12','12:35:00',3.16),('8998','2013-07-12','12:40:00',3.17),('8998','2013-07-12','12:45:00',1.81),('8998','2013-07-12','12:50:00',2.26),('8998','2013-07-12','12:55:00',3.03),('8998','2013-07-12','13:00:00',3.01),('8998','2013-07-12','13:05:00',3.05),('8998','2013-07-12','13:10:00',2.32),('8998','2013-07-12','13:15:00',2.45),('8998','2013-07-12','13:20:00',3.03),('8998','2013-07-12','13:25:00',2.94),('8998','2013-07-12','13:30:00',2.85),('8998','2013-07-12','13:35:00',2.83),('8998','2013-07-12','13:40:00',2.79),('8998','2013-07-12','13:45:00',2.74),('8998','2013-07-12','13:50:00',2.73),('8998','2013-07-12','13:55:00',2.69),('8998','2013-07-12','14:00:00',2.65),('8998','2013-07-12','14:05:00',2.64),('8998','2013-07-12','14:10:00',2.59),('8998','2013-07-12','14:15:00',2.57),('8998','2013-07-12','14:20:00',2.55),('8998','2013-07-12','14:25:00',2.51),('8998','2013-07-12','14:30:00',2.49),('8998','2013-07-12','14:35:00',2.46),('8998','2013-07-12','14:40:00',2.42),('8998','2013-07-12','14:45:00',2.39),('8998','2013-07-12','14:50:00',2.34),('8998','2013-07-12','14:55:00',2.32),('8998','2013-07-12','15:00:00',2.28),('8998','2013-07-12','15:05:00',2.26),('8998','2013-07-12','15:10:00',2.21),('8998','2013-07-12','15:15:00',2.17),('8998','2013-07-12','15:20:00',2.05),('8998','2013-07-12','15:25:00',2.11),('8998','2013-07-12','15:30:00',2.03),('8998','2013-07-12','15:35:00',2.01),('8998','2013-07-12','15:40:00',1.95),('8998','2013-07-12','15:45:00',1.9),('8998','2013-07-12','15:50:00',1.85),('8998','2013-07-12','15:55:00',1.8),('8998','2013-07-12','16:00:00',1.75),('8998','2013-07-12','16:05:00',1.7),('8998','2013-07-12','16:10:00',1.65),('8998','2013-07-12','16:15:00',1.57),('8998','2013-07-12','16:20:00',1.48),('8998','2013-07-12','16:25:00',1.49),('8998','2013-07-12','16:30:00',1.44),('8998','2013-07-12','16:35:00',1.39),('8998','2013-07-12','16:40:00',1.33),('8998','2013-07-12','16:45:00',1.27),('8998','2013-07-12','16:50:00',1.2),('8998','2013-07-12','16:55:00',1.14),('8998','2013-07-12','17:00:00',1.08),('8998','2013-07-12','17:05:00',1.01),('8998','2013-07-11','08:15:00',1.5),('8998','2013-07-11','08:20:00',1.87),('8998','2013-07-11','08:40:00',1),('8998','2013-07-11','08:45:00',1.19),('8998','2013-07-11','09:10:00',1.23),('8998','2013-07-11','09:15:00',1.47),('8998','2013-07-11','09:20:00',1.75),('8998','2013-07-11','09:25:00',2.28),('8998','2013-07-11','09:30:00',1.6),('8998','2013-07-11','09:35:00',1.42),('8998','2013-07-11','09:40:00',1.65),('8998','2013-07-11','09:45:00',2.58),('8998','2013-07-11','09:50:00',2.54),('8998','2013-07-11','09:55:00',2.6),('8998','2013-07-11','10:00:00',2.58),('8998','2013-07-11','10:05:00',2.6),('8998','2013-07-11','10:10:00',1.46),('8998','2013-07-11','10:15:00',2.28),('8998','2013-07-11','10:20:00',1.16),('8998','2013-07-11','10:25:00',1.07),('8998','2013-07-11','10:30:00',1.63),('8998','2013-07-11','10:35:00',1.68),('8998','2013-07-11','10:50:00',1.2),('8998','2013-07-11','10:55:00',1.58),('8998','2013-07-11','11:00:00',3.27),('8998','2013-07-11','11:05:00',1.52),('8998','2013-07-11','11:15:00',2.04),('8998','2013-07-11','11:25:00',2.82),('8998','2013-07-11','11:30:00',3.17),('8998','2013-07-11','11:35:00',3.1),('8998','2013-07-11','11:40:00',1.72),('8998','2013-07-11','11:45:00',2.53),('8998','2013-07-11','11:50:00',2.64),('8998','2013-07-11','11:55:00',2.81),('8998','2013-07-11','12:00:00',3.19),('8998','2013-07-11','12:05:00',1.87),('8998','2013-07-11','12:10:00',3.14),('8998','2013-07-11','12:15:00',1.66),('8998','2013-07-11','12:20:00',3.18),('8998','2013-07-11','12:25:00',2.04),('8998','2013-07-11','12:30:00',3.17),('8998','2013-07-11','12:35:00',2.84),('8998','2013-07-11','12:40:00',2.11),('8998','2013-07-11','12:45:00',2.62),('8998','2013-07-11','12:50:00',1.99),('8998','2013-07-11','12:55:00',3.1),('8998','2013-07-11','13:00:00',2.99),('8998','2013-07-11','13:05:00',2.99),('8998','2013-07-11','13:10:00',2.96),('8998','2013-07-11','13:15:00',2.96),('8998','2013-07-11','13:20:00',2.9),('8998','2013-07-11','13:25:00',2.86),('8998','2013-07-11','13:30:00',2.9),('8998','2013-07-11','13:35:00',2.86),('8998','2013-07-11','13:40:00',2.85),('8998','2013-07-11','13:45:00',2.81),('8998','2013-07-11','13:50:00',2.85),('8998','2013-07-11','13:55:00',2.78),('8998','2013-07-11','14:00:00',2.21),('8998','2013-07-11','14:05:00',2.32),('8998','2013-07-11','14:10:00',2.02),('8998','2013-07-11','14:15:00',2.56),('8998','2013-07-11','14:20:00',2.92),('8998','2013-07-11','14:25:00',2.8),('8998','2013-07-11','14:30:00',1.87),('8998','2013-07-11','14:35:00',2.13),('8998','2013-07-11','14:40:00',2.47),('8998','2013-07-11','14:45:00',2.41),('8998','2013-07-11','14:50:00',2.38),('8998','2013-07-11','14:55:00',2.34),('8998','2013-07-11','15:00:00',2.18),('8998','2013-07-11','15:05:00',2.25),('8998','2013-07-11','15:10:00',2.14),('8998','2013-07-11','15:15:00',1.79),('8998','2013-07-11','15:20:00',2.13),('8998','2013-07-11','15:25:00',2.08),('8998','2013-07-11','15:30:00',2.02),('8998','2013-07-11','15:35:00',1.67),('8998','2013-07-11','15:40:00',2),('8998','2013-07-11','15:45:00',1.66),('8998','2013-07-11','15:50:00',1.8),('8998','2013-07-11','15:55:00',1.77),('8998','2013-07-11','16:00:00',1.72),('8998','2013-07-11','16:05:00',1.66),('8998','2013-07-11','16:10:00',1.61),('8998','2013-07-11','16:15:00',1.54),('8998','2013-07-11','16:20:00',1.5),('8998','2013-07-11','16:25:00',1.46),('8998','2013-07-11','16:30:00',1.4),('8998','2013-07-11','16:35:00',1.34),('8998','2013-07-11','16:40:00',1.3),('8998','2013-07-11','16:45:00',1.25),('8998','2013-07-11','16:50:00',1.19),('8998','2013-07-11','16:55:00',1.14),('8998','2013-07-11','17:00:00',1.08),('8998','2013-07-11','17:05:00',1.03),('8998','2013-07-10','07:45:00',1.07),('8998','2013-07-10','07:50:00',1.12),('8998','2013-07-10','07:55:00',1.15),('8998','2013-07-10','08:00:00',1.22),('8998','2013-07-10','08:05:00',1.29),('8998','2013-07-10','08:10:00',1.34),('8998','2013-07-10','08:15:00',1.38),('8998','2013-07-10','08:20:00',1.45),('8998','2013-07-10','08:25:00',1.53),('8998','2013-07-10','08:30:00',1.6),('8998','2013-07-10','08:35:00',1.5),('8998','2013-07-10','08:40:00',1.6),('8998','2013-07-10','08:45:00',1.59),('8998','2013-07-10','08:50:00',1.64),('8998','2013-07-10','08:55:00',1.66),('8998','2013-07-10','09:00:00',1.82),('8998','2013-07-10','09:05:00',1.89),('8998','2013-07-10','09:10:00',1.9),('8998','2013-07-10','09:15:00',2.14),('8998','2013-07-10','09:20:00',2.2),('8998','2013-07-10','09:25:00',2.52),('8998','2013-07-10','09:30:00',2.55),('8998','2013-07-10','09:35:00',2.29),('8998','2013-07-10','09:40:00',2.19),('8998','2013-07-10','09:45:00',2.69),('8998','2013-07-10','09:50:00',2.15),('8998','2013-07-10','09:55:00',1.8),('8998','2013-07-10','10:00:00',2.05),('8998','2013-07-10','10:05:00',1.14),('8998','2013-07-10','10:10:00',1.15),('8998','2013-07-10','10:15:00',2.84),('8998','2013-07-10','10:20:00',2.78),('8998','2013-07-10','10:25:00',2.72),('8998','2013-07-10','10:30:00',2.96),('8998','2013-07-10','10:35:00',1.63),('8998','2013-07-10','10:45:00',2.24),('8998','2013-07-10','10:50:00',2.86),('8998','2013-07-10','10:55:00',3.04),('8998','2013-07-10','11:00:00',2.47),('8998','2013-07-10','11:05:00',2.21),('8998','2013-07-10','11:10:00',2.93),('8998','2013-07-10','11:15:00',2.02),('8998','2013-07-10','11:20:00',2.12),('8998','2013-07-10','11:25:00',1.93),('8998','2013-07-10','11:30:00',2.35),('8998','2013-07-10','11:35:00',2.11),('8998','2013-07-10','11:40:00',3.33),('8998','2013-07-10','11:45:00',3.1),('8998','2013-07-10','11:50:00',1.71),('8998','2013-07-10','11:55:00',1.41),('8998','2013-07-10','12:00:00',2.69),('8998','2013-07-10','12:15:00',1.3),('8998','2013-07-10','12:20:00',3.1),('8998','2013-07-10','12:25:00',3.14),('8998','2013-07-10','12:30:00',2.89),('8998','2013-07-10','12:35:00',3.11),('8998','2013-07-10','12:40:00',2.28),('8998','2013-07-10','12:45:00',1.67),('8998','2013-07-10','12:50:00',2.19),('8998','2013-07-10','12:55:00',2.65),('8998','2013-07-10','13:00:00',3.15),('8998','2013-07-10','13:05:00',2.74),('8998','2013-07-10','13:10:00',2.91),('8998','2013-07-10','13:15:00',3.03),('8998','2013-07-10','13:20:00',2.95),('8998','2013-07-10','13:25:00',2.92),('8998','2013-07-10','13:30:00',2.98),('8998','2013-07-10','13:35:00',2.81),('8998','2013-07-10','13:40:00',2.92),('8998','2013-07-10','13:45:00',2.61),('8998','2013-07-10','13:50:00',2.07),('8998','2013-07-10','13:55:00',2.15),('8998','2013-07-10','14:00:00',2.5),('8998','2013-07-10','14:05:00',2.48),('8998','2013-07-10','14:10:00',2.73),('8998','2013-07-10','14:15:00',2.71),('8998','2013-07-10','14:20:00',2.62),('8998','2013-07-10','14:25:00',2.36),('8998','2013-07-10','14:30:00',2.13),('8998','2013-07-10','14:35:00',2.55),('8998','2013-07-10','14:40:00',2.49),('8998','2013-07-10','14:45:00',2.46),('8998','2013-07-10','14:50:00',2.47),('8998','2013-07-10','14:55:00',1.76),('8998','2013-07-10','15:00:00',2.55),('8998','2013-07-10','15:05:00',1.28),('8998','2013-07-10','15:10:00',1.17),('8998','2013-07-10','15:15:00',2.31),('8998','2013-07-10','15:20:00',1.47),('8998','2013-07-10','15:25:00',1.6),('8998','2013-07-10','15:30:00',1.85),('8998','2013-07-10','15:35:00',2.19),('8998','2013-07-10','15:40:00',1.63),('8998','2013-07-10','15:45:00',1.79),('8998','2013-07-10','15:50:00',1.56),('8998','2013-07-10','15:55:00',1.25),('8998','2013-07-10','16:00:00',1.45),('8998','2013-07-10','16:05:00',1.51),('8998','2013-07-10','16:10:00',1.62),('8998','2013-07-10','16:15:00',1.29),('8998','2013-07-10','16:20:00',1.24),('8998','2013-07-10','16:25:00',1.28),('8998','2013-07-10','16:30:00',1.45),('8998','2013-07-10','16:40:00',1.5),('8998','2013-07-10','16:45:00',1.16),('8998','2013-07-10','16:50:00',1.34),('8998','2013-07-10','16:55:00',1.3),('8998','2013-07-10','17:00:00',1.14),('8998','2013-07-10','17:05:00',1),('8998','2014-05-02','07:40:00',1.28),('8998','2014-05-02','07:45:00',1.2),('8998','2014-05-02','07:50:00',1.23),('8998','2014-05-02','07:55:00',1.5),('8998','2014-05-02','08:00:00',1.47),('8998','2014-05-02','08:05:00',1.76),('8998','2014-05-02','08:10:00',1.88),('8998','2014-05-02','08:15:00',1.69),('8998','2014-05-02','08:20:00',1.19),('8998','2014-05-02','08:30:00',1.09),('8998','2014-05-02','08:40:00',1.15),('8998','2014-05-02','08:45:00',1.96),('8998','2014-05-02','08:50:00',2.34),('8998','2014-05-02','08:55:00',2.51),('8998','2014-05-02','09:00:00',2.76),('8998','2014-05-02','09:05:00',3.01),('8998','2014-05-02','09:10:00',1.87),('8998','2014-05-02','09:15:00',1.2),('8998','2014-05-02','09:20:00',2.13),('8998','2014-05-02','09:25:00',2.71),('8998','2014-05-02','09:30:00',1.65),('8998','2014-05-02','09:35:00',2.72),('8998','2014-05-02','09:40:00',1.57),('8998','2014-05-02','09:45:00',2.52),('8998','2014-05-02','09:50:00',1.39),('8998','2014-05-02','09:55:00',2.54),('8998','2014-05-02','10:00:00',3.08),('8998','2014-05-02','10:05:00',3.05),('8998','2014-05-02','10:10:00',3.08),('8998','2014-05-02','10:15:00',3.22),('8998','2014-05-02','10:20:00',2.41),('8998','2014-05-02','10:25:00',2.77),('8998','2014-05-02','10:30:00',1.89),('8998','2014-05-02','10:45:00',1.47),('8998','2014-05-02','10:55:00',1.58),('8998','2014-05-02','11:05:00',2.28),('8998','2014-05-02','11:10:00',3.83),('8998','2014-05-02','11:15:00',1.33),('8998','2014-05-02','11:20:00',2),('8998','2014-05-02','11:25:00',2.49),('8998','2014-05-02','11:30:00',3.45),('8998','2014-05-02','11:35:00',2.15),('8998','2014-05-02','11:40:00',2.05),('8998','2014-05-02','11:45:00',2),('8998','2014-05-02','11:50:00',1.7),('8998','2014-05-02','11:55:00',1.84),('8998','2014-05-02','12:00:00',1.62),('8998','2014-05-02','12:05:00',1.42),('8998','2014-05-02','12:10:00',1.31),('8998','2014-05-02','12:15:00',1.15),('8998','2014-05-02','12:20:00',1),('8998','2014-05-02','12:25:00',1.01),('8998','2014-05-02','12:30:00',1.24),('8998','2014-05-02','12:35:00',1.42),('8998','2014-05-02','12:40:00',1.27),('8998','2014-05-02','12:45:00',1.34),('8998','2014-05-02','12:50:00',1.44),('8998','2014-05-02','12:55:00',1.49),('8998','2014-05-02','13:00:00',1.47),('8998','2014-05-02','13:05:00',1.33),('8998','2014-05-02','13:10:00',1.97),('8998','2014-05-02','13:15:00',1.98),('8998','2014-05-02','13:20:00',1.74),('8998','2014-05-02','13:25:00',2.13),('8998','2014-05-02','13:30:00',2.04),('8998','2014-05-02','13:35:00',1.68),('8998','2014-05-02','13:40:00',1.27),('8998','2014-05-02','13:45:00',1.22),('8998','2014-05-02','13:50:00',1.21),('8998','2014-05-02','13:55:00',1.22),('8998','2014-05-02','14:00:00',1.2),('8998','2014-05-02','14:05:00',1.19),('8998','2014-05-02','14:10:00',1.29),('8998','2014-05-02','14:15:00',1.42),('8998','2014-05-02','14:20:00',1.59),('8998','2014-05-02','14:25:00',1.87),('8998','2014-05-02','14:30:00',1.6),('8998','2014-05-02','14:35:00',1.22),('8998','2014-05-02','14:40:00',1.12),('8998','2014-04-05','08:15:00',1.15),('8998','2014-04-05','08:20:00',1.44),('8998','2014-04-05','08:25:00',1.36),('8998','2014-04-05','08:30:00',1.29),('8998','2014-04-05','08:35:00',1.64),('8998','2014-04-05','08:40:00',1.81),('8998','2014-04-05','08:45:00',1.86),('8998','2014-04-05','08:50:00',1.77),('8998','2014-04-05','08:55:00',1.57),('8998','2014-04-05','09:00:00',1.75),('8998','2014-04-05','09:05:00',2.12),('8998','2014-04-05','09:10:00',2.37),('8998','2014-04-05','09:15:00',2.38),('8998','2014-04-05','09:20:00',2.09),('8998','2014-04-05','09:25:00',1.95),('8998','2014-04-05','09:30:00',1.56),('8998','2014-04-05','09:35:00',2.24),('8998','2014-04-05','09:40:00',2.29),('8998','2014-04-05','09:45:00',2.98),('8998','2014-04-05','09:50:00',3.1),('8998','2014-04-05','09:55:00',2.91),('8998','2014-04-05','10:00:00',2.22),('8998','2014-04-05','10:05:00',2.85),('8998','2014-04-05','10:10:00',2.89),('8998','2014-04-05','10:15:00',3.07),('8998','2014-04-05','10:20:00',2.35),('8998','2014-04-05','10:30:00',1),('8998','2014-04-05','10:35:00',1.11),('8998','2014-04-05','10:40:00',1.23),('8998','2014-04-05','10:45:00',2.41),('8998','2014-04-05','10:50:00',2.1),('8998','2014-04-05','10:55:00',1.42),('8998','2014-04-05','11:00:00',1.45),('8998','2014-04-05','11:05:00',1.38),('8998','2014-04-05','11:10:00',2.08),('8998','2014-04-05','11:15:00',2.89),('8998','2014-04-05','11:20:00',3.17),('8998','2014-04-05','11:25:00',3.13),('8998','2014-04-05','11:30:00',3.23),('8998','2014-04-05','11:35:00',3.41),('8998','2014-04-05','11:40:00',3.19),('8998','2014-04-05','11:45:00',3.21),('8998','2014-04-05','11:50:00',2.87),('8998','2014-04-05','11:55:00',3.05),('8998','2014-04-05','12:00:00',3.22),('8998','2014-04-05','12:05:00',3.06),('8998','2014-04-05','12:10:00',3.05),('8998','2014-04-05','12:15:00',3.06),('8998','2014-04-05','12:20:00',2.72),('8998','2014-04-05','12:25:00',2.34),('8998','2014-04-05','12:30:00',2.36),('8998','2014-04-05','12:35:00',2.21),('8998','2014-04-05','12:40:00',1.93),('8998','2014-04-05','12:45:00',2.29),('8998','2014-04-05','12:50:00',2.14),('8998','2014-04-05','12:55:00',3.1),('8998','2014-04-05','13:00:00',2.55),('8998','2014-04-05','13:05:00',2.31),('8998','2014-04-05','13:10:00',2.88),('8998','2014-04-05','13:15:00',2.67),('8998','2014-04-05','13:20:00',1.46),('8998','2014-04-05','13:30:00',3.04),('8998','2014-04-05','13:35:00',1.47),('8998','2014-04-05','13:40:00',2.07),('8998','2014-04-05','13:45:00',3.01),('8998','2014-04-05','13:50:00',2.77),('8998','2014-04-05','13:55:00',2.71),('8998','2014-04-05','14:00:00',2.63),('8998','2014-04-05','14:05:00',2.48),('8998','2014-04-05','14:10:00',2.62),('8998','2014-04-05','14:15:00',2.12),('8998','2014-04-05','14:20:00',2.23),('8998','2014-04-05','14:25:00',1.64),('8998','2014-04-05','14:40:00',2.38),('8998','2014-04-05','14:45:00',2.92),('8998','2014-04-05','14:50:00',2.41),('8998','2014-04-05','14:55:00',1.22),('8998','2014-04-05','15:10:00',1.81),('8998','2014-04-05','15:15:00',1.74),('8998','2014-04-05','15:50:00',1.04),('8998','2014-04-05','15:55:00',1.9),('8998','2014-04-05','16:00:00',1.36),('8998','2014-04-05','16:40:00',1.07),('8998','2014-04-05','16:45:00',1.23),('8998','2014-04-05','16:50:00',1.09),('8998','2013-07-09','07:25:00',1.12),('8998','2013-07-09','07:30:00',1.18),('8998','2013-07-09','07:35:00',1.13),('8998','2013-07-09','07:40:00',1.14),('8998','2013-07-09','07:45:00',1.37),('8998','2013-07-09','07:50:00',1.57),('8998','2013-07-09','07:55:00',1.68),('8998','2013-07-09','08:00:00',1.76),('8998','2013-07-09','08:05:00',1.54),('8998','2013-07-09','08:10:00',1.41),('8998','2013-07-09','08:15:00',1.49),('8998','2013-07-09','08:20:00',1.58),('8998','2013-07-09','08:25:00',2),('8998','2013-07-09','08:30:00',1.91),('8998','2013-07-09','08:35:00',2),('8998','2013-07-09','08:40:00',2.11),('8998','2013-07-09','08:45:00',1.82),('8998','2013-07-09','08:50:00',1.82),('8998','2013-07-09','08:55:00',1.73),('8998','2013-07-09','09:00:00',1.85),('8998','2013-07-09','09:05:00',1.96),('8998','2013-07-09','09:10:00',2.07),('8998','2013-07-09','09:15:00',2.32),('8998','2013-07-09','09:20:00',2.48),('8998','2013-07-09','09:25:00',2.55),('8998','2013-07-09','09:30:00',2.6),('8998','2013-07-09','09:35:00',2.59),('8998','2013-07-09','09:40:00',2.59),('8998','2013-07-09','09:45:00',2.61),('8998','2013-07-09','09:50:00',2.63),('8998','2013-07-09','09:55:00',2.71),('8998','2013-07-09','10:00:00',2.56),('8998','2013-07-09','10:05:00',2.72),('8998','2013-07-09','10:10:00',2.73),('8998','2013-07-09','10:15:00',2.74),('8998','2013-07-09','10:20:00',2.77),('8998','2013-07-09','10:25:00',2.81),('8998','2013-07-09','10:30:00',2.81),('8998','2013-07-09','10:35:00',2.83),('8998','2013-07-09','10:40:00',2.84),('8998','2013-07-09','10:45:00',2.86),('8998','2013-07-09','10:50:00',2.84),('8998','2013-07-09','10:55:00',2.84),('8998','2013-07-09','11:00:00',2.89),('8998','2013-07-09','11:05:00',2.92),('8998','2013-07-09','11:10:00',2.91),('8998','2013-07-09','11:15:00',2.91),('8998','2013-07-09','11:20:00',2.92),('8998','2013-07-09','11:25:00',2.92),('8998','2013-07-09','11:30:00',2.9),('8998','2013-07-09','11:35:00',2.87),('8998','2013-07-09','11:40:00',2.83),('8998','2013-07-09','11:45:00',2.87),('8998','2013-07-09','11:50:00',2.91),('8998','2013-07-09','11:55:00',2.94),('8998','2013-07-09','12:00:00',2.91),('8998','2013-07-09','12:05:00',2.92),('8998','2013-07-09','12:10:00',2.91),('8998','2013-07-09','12:15:00',2.92),('8998','2013-07-09','12:20:00',2.94),('8998','2013-07-09','12:25:00',2.97),('8998','2013-07-09','12:30:00',2.97),('8998','2013-07-09','12:35:00',2.92),('8998','2013-07-09','12:40:00',2.88),('8998','2013-07-09','12:45:00',2.9),('8998','2013-07-09','12:50:00',2.9),('8998','2013-07-09','12:55:00',2.88),('8998','2013-07-09','13:00:00',2.86),('8998','2013-07-09','13:05:00',2.88),('8998','2013-07-09','13:10:00',2.88),('8998','2013-07-09','13:15:00',2.83),('8998','2013-07-09','13:20:00',2.8),('8998','2013-07-09','13:25:00',2.8),('8998','2013-07-09','13:30:00',2.78),('8998','2013-07-09','13:35:00',2.76),('8998','2013-07-09','13:40:00',2.74),('8998','2013-07-09','13:45:00',2.73),('8998','2013-07-09','13:50:00',2.72),('8998','2013-07-09','13:55:00',2.67),('8998','2013-07-09','14:00:00',2.66),('8998','2013-07-09','14:05:00',2.64),('8998','2013-07-09','14:10:00',2.61),('8998','2013-07-09','14:15:00',2.59),('8998','2013-07-09','14:20:00',2.55),('8998','2013-07-09','14:25:00',2.51),('8998','2013-07-09','14:30:00',2.47),('8998','2013-07-09','14:35:00',2.46),('8998','2013-07-09','14:40:00',2.43),('8998','2013-07-09','14:45:00',2.4),('8998','2013-07-09','14:50:00',2.36),('8998','2013-07-09','14:55:00',2.33),('8998','2013-07-09','15:00:00',2.29),('8998','2013-07-09','15:05:00',2.26),('8998','2013-07-09','15:10:00',2.22),('8998','2013-07-09','15:15:00',2.18),('8998','2013-07-09','15:20:00',2.14),('8998','2013-07-09','15:25:00',2.1),('8998','2013-07-09','15:30:00',2.06),('8998','2013-07-09','15:35:00',2.02),('8998','2013-07-09','15:40:00',1.96),('8998','2013-07-09','15:45:00',1.9),('8998','2013-07-09','15:50:00',1.85),('8998','2013-07-09','15:55:00',1.81),('8998','2013-07-09','16:00:00',1.77),('8998','2013-07-09','16:05:00',1.72),('8998','2013-07-09','16:10:00',1.66),('8998','2013-07-09','16:15:00',1.58),('8998','2013-07-09','16:20:00',1.55),('8998','2013-07-09','16:25:00',1.49),('8998','2013-07-09','16:30:00',1.43),('8998','2013-07-09','16:35:00',1.39),('8998','2013-07-09','16:40:00',1.33),('8998','2013-07-09','16:45:00',1.29),('8998','2013-07-09','16:50:00',1.24),('8998','2013-07-09','16:55:00',1.22),('8998','2013-07-09','17:00:00',1.22),('8998','2013-07-09','17:05:00',1.11),('8998','2013-07-08','07:35:00',1.05),('8998','2013-07-08','07:40:00',1.07),('8998','2013-07-08','07:45:00',1.08),('8998','2013-07-08','07:50:00',1.15),('8998','2013-07-08','07:55:00',1.16),('8998','2013-07-08','08:00:00',1.22),('8998','2013-07-08','08:05:00',1.29),('8998','2013-07-08','08:10:00',1.34),('8998','2013-07-08','08:15:00',1.4),('8998','2013-07-08','08:20:00',1.44),('8998','2013-07-08','08:25:00',1.52),('8998','2013-07-08','08:30:00',1.6),('8998','2013-07-08','08:35:00',1.48),('8998','2013-07-08','08:40:00',1.63),('8998','2013-07-08','08:45:00',1.55),('8998','2013-07-08','08:50:00',1.62),('8998','2013-07-08','08:55:00',1.66),('8998','2013-07-08','09:00:00',1.81),('8998','2013-07-08','09:05:00',1.85),('8998','2013-07-08','09:10:00',1.95),('8998','2013-07-08','09:15:00',2.18),('8998','2013-07-08','09:20:00',2.35),('8998','2013-07-08','09:25:00',2.44),('8998','2013-07-08','09:30:00',2.49),('8998','2013-07-08','09:35:00',2.52),('8998','2013-07-08','09:40:00',2.56),('8998','2013-07-08','09:45:00',2.6),('8998','2013-07-08','09:50:00',2.61),('8998','2013-07-08','09:55:00',2.64),('8998','2013-07-08','10:00:00',2.65),('8998','2013-07-08','10:05:00',2.68),('8998','2013-07-08','10:10:00',2.72),('8998','2013-07-08','10:15:00',2.73),('8998','2013-07-08','10:20:00',2.76),('8998','2013-07-08','10:25:00',2.79),('8998','2013-07-08','10:30:00',2.78),('8998','2013-07-08','10:35:00',2.79),('8998','2013-07-08','10:40:00',2.8),('8998','2013-07-08','10:45:00',2.82),('8998','2013-07-08','10:50:00',2.84),('8998','2013-07-08','10:55:00',2.89),('8998','2013-07-08','11:00:00',2.92),('8998','2013-07-08','11:05:00',2.77),('8998','2013-07-08','11:10:00',2.58),('8998','2013-07-08','11:15:00',2.44),('8998','2013-07-08','11:20:00',2.52),('8998','2013-07-08','11:25:00',2.55),('8998','2013-07-08','11:30:00',1.68),('8998','2013-07-08','11:35:00',1.94),('8998','2013-07-08','11:40:00',2.04),('8998','2013-07-08','11:45:00',2.94),('8998','2013-07-08','11:50:00',3.47),('8998','2013-07-08','11:55:00',3.4),('8998','2013-07-08','12:00:00',3.37),('8998','2013-07-08','12:05:00',3.12),('8998','2013-07-08','12:10:00',2.38),('8998','2013-07-08','12:15:00',3.02),('8998','2013-07-08','12:20:00',2.95),('8998','2013-07-08','12:25:00',2.89),('8998','2013-07-08','12:30:00',2.84),('8998','2013-07-08','12:35:00',2.86),('8998','2013-07-08','12:40:00',2.85),('8998','2013-07-08','12:45:00',2.81),('8998','2013-07-08','12:50:00',2.83),('8998','2013-07-08','12:55:00',2.85),('8998','2013-07-08','13:00:00',2.82),('8998','2013-07-08','13:05:00',2.64),('8998','2013-07-08','13:10:00',2.87),('8998','2013-07-08','13:15:00',2.93),('8998','2013-07-08','13:20:00',2.89),('8998','2013-07-08','13:25:00',2.91),('8998','2013-07-08','13:30:00',2.96),('8998','2013-07-08','13:35:00',2.78),('8998','2013-07-08','13:40:00',2.73),('8998','2013-07-08','13:45:00',2.27),('8998','2013-07-08','13:50:00',2.12),('8998','2013-07-08','13:55:00',2.12),('8998','2013-07-08','14:00:00',2.08),('8998','2013-07-08','14:05:00',2.07),('8998','2013-07-08','14:10:00',2.28),('8998','2013-07-08','14:15:00',2.28),('8998','2013-07-08','14:20:00',1.73),('8998','2013-07-08','14:25:00',1.35),('8998','2013-07-07','07:40:00',1.17),('8998','2013-07-07','07:45:00',1.1),('8998','2013-07-07','07:50:00',1.06),('8998','2013-07-07','07:55:00',1.05),('8998','2013-07-07','08:00:00',1.07),('8998','2013-07-07','08:05:00',1.1),('8998','2013-07-07','08:10:00',1.27),('8998','2013-07-07','08:15:00',1.37),('8998','2013-07-07','08:20:00',1.44),('8998','2013-07-07','08:25:00',1.56),('8998','2013-07-07','08:30:00',1.65),('8998','2013-07-07','08:35:00',1.52),('8998','2013-07-07','08:40:00',1.67),('8998','2013-07-07','08:45:00',1.57),('8998','2013-07-07','08:50:00',1.63),('8998','2013-07-07','08:55:00',1.7),('8998','2013-07-07','09:00:00',1.82),('8998','2013-07-07','09:05:00',1.87),('8998','2013-07-07','09:10:00',1.97),('8998','2013-07-07','09:15:00',2.19),('8998','2013-07-07','09:20:00',2.35),('8998','2013-07-07','09:25:00',2.4),('8998','2013-07-07','09:30:00',2.49),('8998','2013-07-07','09:35:00',2.59),('8998','2013-07-07','09:40:00',2.6),('8998','2013-07-07','09:45:00',2.59),('8998','2013-07-07','09:50:00',2.58),('8998','2013-07-07','09:55:00',2.66),('8998','2013-07-07','10:00:00',2.69),('8998','2013-07-07','10:05:00',2.71),('8998','2013-07-07','10:10:00',2.68),('8998','2013-07-07','10:15:00',2.73),('8998','2013-07-07','10:20:00',2.75),('8998','2013-07-07','10:25:00',2.78),('8998','2013-07-07','10:30:00',2.71),('8998','2013-07-07','10:35:00',2.82),('8998','2013-07-07','10:40:00',2.81),('8998','2013-07-07','10:45:00',2.8),('8998','2013-07-07','10:50:00',2.81),('8998','2013-07-07','10:55:00',2.8),('8998','2013-07-07','11:00:00',2.82),('8998','2013-07-07','11:05:00',2.85),('8998','2013-07-07','11:10:00',2.89),('8998','2013-07-07','11:15:00',2.93),('8998','2013-07-07','11:20:00',2.98),('8998','2013-07-07','11:25:00',2.99),('8998','2013-07-07','11:30:00',3.03),('8998','2013-07-07','11:35:00',3.01),('8998','2013-07-07','11:40:00',2.8),('8998','2013-07-07','11:45:00',3),('8998','2013-07-07','11:50:00',2.98),('8998','2013-07-07','11:55:00',2.95),('8998','2013-07-07','12:00:00',2.94),('8998','2013-07-07','12:05:00',2.98),('8998','2013-07-07','12:10:00',3.03),('8998','2013-07-07','12:15:00',3.04),('8998','2013-07-07','12:20:00',3.13),('8998','2013-07-07','12:25:00',2.99),('8998','2013-07-07','12:30:00',2.84),('8998','2013-07-07','12:35:00',2.98),('8998','2013-07-07','12:40:00',2.96),('8998','2013-07-07','12:45:00',2.97),('8998','2013-07-07','12:50:00',2.97),('8998','2013-07-07','12:55:00',3.02),('8998','2013-07-07','13:00:00',2.8),('8998','2013-07-07','13:05:00',3.15),('8998','2013-07-07','13:10:00',3.34),('8998','2013-07-07','13:15:00',2.61),('8998','2013-07-07','13:20:00',1.7),('8998','2013-07-06','07:30:00',1.03),('8998','2013-07-06','07:35:00',1.22),('8998','2013-07-06','07:40:00',1.14),('8998','2013-07-06','07:45:00',1.29),('8998','2013-07-06','07:50:00',1.32),('8998','2013-07-06','07:55:00',1.3),('8998','2013-07-06','08:00:00',1.3),('8998','2013-07-06','08:05:00',1.38),('8998','2013-07-06','08:10:00',1.42),('8998','2013-07-06','08:15:00',1.48),('8998','2013-07-06','08:20:00',1.45),('8998','2013-07-06','08:25:00',1.39),('8998','2013-07-06','08:30:00',1.69),('8998','2013-07-06','08:35:00',1.48),('8998','2013-07-06','08:50:00',1.9),('8998','2013-07-06','08:55:00',2.06),('8998','2013-07-06','09:00:00',1.93),('8998','2013-07-06','09:05:00',1.77),('8998','2013-07-06','09:10:00',1.86),('8998','2013-07-06','09:15:00',1.92),('8998','2013-07-06','09:20:00',1.58),('8998','2013-07-06','09:25:00',2.1),('8998','2013-07-06','09:30:00',2.5),('8998','2013-07-06','09:35:00',2.58),('8998','2013-07-06','09:40:00',2.36),('8998','2013-07-06','09:45:00',2.83),('8998','2013-07-06','09:50:00',2.81),('8998','2013-07-06','09:55:00',2.84),('8998','2013-07-06','10:00:00',2.82),('8998','2013-07-06','10:05:00',2.66),('8998','2013-07-06','10:10:00',2.77),('8998','2013-07-06','10:15:00',2.56),('8998','2013-07-06','10:20:00',2.77),('8998','2013-07-06','10:25:00',2.66),('8998','2013-07-06','10:30:00',2.61),('8998','2013-07-06','10:35:00',3),('8998','2013-07-06','10:40:00',2.72),('8998','2013-07-06','10:45:00',2.97),('8998','2013-07-06','10:50:00',2.98),('8998','2013-07-06','10:55:00',2.96),('8998','2013-07-06','11:00:00',2.96),('8998','2013-07-06','11:05:00',2.99),('8998','2013-07-06','11:10:00',3.02),('8998','2013-07-06','11:15:00',2.89),('8998','2013-07-06','11:20:00',2.82),('8998','2013-07-06','11:25:00',2.54),('8998','2013-07-06','11:30:00',2.64),('8998','2013-07-06','11:35:00',2.59),('8998','2013-07-06','11:40:00',2.57),('8998','2013-07-06','11:45:00',2.18),('8998','2013-07-06','11:50:00',2.04),('8998','2013-07-06','11:55:00',1.51),('8998','2013-07-06','12:00:00',2.26),('8998','2013-07-06','12:05:00',2.88),('8998','2013-07-06','12:10:00',2.88),('8998','2013-07-06','12:15:00',3.07),('8998','2013-07-06','12:20:00',2.94),('8998','2013-07-06','12:25:00',2.75),('8998','2013-07-06','12:30:00',2.79),('8998','2013-07-06','12:35:00',2.96),('8998','2013-07-06','12:40:00',3.02),('8998','2013-07-06','12:45:00',2.98),('8998','2013-07-06','12:50:00',2.91),('8998','2013-07-06','12:55:00',3.03),('8998','2013-07-06','13:00:00',2.96),('8998','2013-07-06','13:05:00',2.94),('8998','2013-07-06','13:10:00',2.94),('8998','2013-07-06','13:15:00',2.89),('8998','2013-07-06','13:20:00',2.88),('8998','2013-07-06','13:25:00',2.79),('8998','2013-07-06','13:30:00',2.69),('8998','2013-07-06','13:35:00',2.92),('8998','2013-07-06','13:40:00',1.97),('8998','2013-07-06','13:45:00',3.08),('8998','2013-07-06','13:50:00',3.05),('8998','2013-07-06','13:55:00',2.62),('8998','2013-07-06','14:00:00',2.35),('8998','2013-07-06','14:05:00',2.51),('8998','2013-07-06','14:10:00',1.51),('8998','2013-07-06','14:15:00',1.26),('8998','2013-07-05','07:35:00',1.11),('8998','2013-07-05','07:40:00',1.11),('8998','2013-07-05','07:45:00',1.21),('8998','2013-07-05','07:50:00',1.25),('8998','2013-07-05','07:55:00',1.26),('8998','2013-07-05','08:00:00',1.24),('8998','2013-07-05','08:05:00',1.33),('8998','2013-07-05','08:10:00',1.37),('8998','2013-07-05','08:15:00',1.63),('8998','2013-07-05','08:20:00',1.76),('8998','2013-07-05','08:25:00',1.64),('8998','2013-07-05','08:30:00',1.63),('8998','2013-07-05','08:35:00',1.49),('8998','2013-07-05','08:40:00',1.66),('8998','2013-07-05','08:45:00',1.57),('8998','2013-07-05','08:50:00',1.93),('8998','2013-07-05','08:55:00',1.88),('8998','2013-07-05','09:00:00',1.84),('8998','2013-07-05','09:05:00',1.87),('8998','2013-07-05','09:10:00',2.1),('8998','2013-07-05','09:15:00',2.29),('8998','2013-07-05','09:20:00',2.45),('8998','2013-07-05','09:25:00',2.51),('8998','2013-07-05','09:30:00',2.53),('8998','2013-07-05','09:35:00',2.55),('8998','2013-07-05','09:40:00',2.58),('8998','2013-07-05','09:45:00',2.61),('8998','2013-07-05','09:50:00',2.64),('8998','2013-07-05','09:55:00',2.69),('8998','2013-07-05','10:00:00',2.71),('8998','2013-07-05','10:05:00',2.75),('8998','2013-07-05','10:10:00',2.79),('8998','2013-07-05','10:15:00',2.8),('8998','2013-07-05','10:20:00',2.81),('8998','2013-07-05','10:25:00',2.83),('8998','2013-07-05','10:30:00',2.84),('8998','2013-07-05','10:35:00',2.84),('8998','2013-07-05','10:40:00',2.86),('8998','2013-07-05','10:45:00',2.89),('8998','2013-07-05','10:50:00',2.94),('8998','2013-07-05','10:55:00',2.96),('8998','2013-07-05','11:00:00',2.96),('8998','2013-07-05','11:05:00',2.98),('8998','2013-07-05','11:10:00',2.97),('8998','2013-07-05','11:15:00',2.94),('8998','2013-07-05','11:20:00',2.98),('8998','2013-07-05','11:25:00',3),('8998','2013-07-05','11:30:00',2.97),('8998','2013-07-05','11:35:00',2.96),('8998','2013-07-05','11:40:00',2.94),('8998','2013-07-05','11:45:00',2.96),('8998','2013-07-05','11:50:00',2.96),('8998','2013-07-05','11:55:00',2.94),('8998','2013-07-05','12:00:00',2.96),('8998','2013-07-05','12:05:00',2.96),('8998','2013-07-05','12:10:00',3),('8998','2013-07-05','12:15:00',2.99),('8998','2013-07-05','12:20:00',3.01),('8998','2013-07-05','12:25:00',2.95),('8998','2013-07-05','12:30:00',2.98),('8998','2013-07-05','12:35:00',2.95),('8998','2013-07-05','12:40:00',2.97),('8998','2013-07-05','12:45:00',2.96),('8998','2013-07-05','12:50:00',2.93),('8998','2013-07-05','12:55:00',2.94),('8998','2013-07-05','13:00:00',2.95),('8998','2013-07-05','13:05:00',2.95),('8998','2013-07-05','13:10:00',2.96),('8998','2013-07-05','13:15:00',2.95),('8998','2013-07-05','13:20:00',2.9),('8998','2013-07-05','13:25:00',2.86),('8998','2013-07-05','13:30:00',2.87),('8998','2013-07-05','13:35:00',2.8),('8998','2013-07-05','13:40:00',2.8),('8998','2013-07-05','13:45:00',2.78),('8998','2013-07-05','13:50:00',2.72),('8998','2013-07-05','13:55:00',2.71),('8998','2013-07-05','14:00:00',2.72),('8998','2013-07-05','14:05:00',2.69),('8998','2013-07-05','14:10:00',2.65),('8998','2013-07-05','14:15:00',2.47),('8998','2013-07-05','14:20:00',2.68),('8998','2013-07-05','14:25:00',2.59),('8998','2013-07-05','14:30:00',2.54),('8998','2013-07-05','14:35:00',2.54),('8998','2013-07-05','14:40:00',2.48),('8998','2013-07-05','14:45:00',2.45),('8998','2013-07-05','14:50:00',2.39),('8998','2013-07-05','14:55:00',2.07),('8998','2013-07-05','15:00:00',2.41),('8998','2013-07-05','15:05:00',2.33),('8998','2013-07-05','15:10:00',2.32),('8998','2013-07-05','15:15:00',2.27),('8998','2013-07-05','15:20:00',2.27),('8998','2013-07-05','15:25:00',2.24),('8998','2013-07-05','15:30:00',2),('8998','2013-07-04','07:45:00',1.22),('8998','2013-07-04','07:50:00',1.24),('8998','2013-07-04','07:55:00',1.24),('8998','2013-07-04','08:00:00',1.28),('8998','2013-07-04','08:05:00',1.35),('8998','2013-07-04','08:10:00',1.38),('8998','2013-07-04','08:15:00',1.63),('8998','2013-07-04','08:20:00',1.76),('8998','2013-07-04','08:25:00',1.64),('8998','2013-07-04','08:30:00',1.63),('8998','2013-07-04','08:35:00',1.52),('8998','2013-07-04','08:40:00',1.64),('8998','2013-07-04','08:45:00',1.58),('8998','2013-07-04','08:50:00',1.97),('8998','2013-07-04','08:55:00',1.89),('8998','2013-07-04','09:00:00',1.84),('8998','2013-07-04','09:05:00',1.87),('8998','2013-07-04','09:10:00',2.08),('8998','2013-07-04','09:15:00',2.25),('8998','2013-07-04','09:20:00',2.41),('8998','2013-07-04','09:25:00',2.48),('8998','2013-07-04','09:30:00',2.52),('8998','2013-07-04','09:35:00',2.57),('8998','2013-07-04','09:40:00',2.6),('8998','2013-07-04','09:45:00',2.61),('8998','2013-07-04','09:50:00',2.63),('8998','2013-07-04','09:55:00',2.65),('8998','2013-07-04','10:00:00',2.67),('8998','2013-07-04','10:05:00',2.7),('8998','2013-07-04','10:10:00',2.74),('8998','2013-07-04','10:15:00',2.77),('8998','2013-07-04','10:20:00',2.79),('8998','2013-07-04','10:25:00',2.8),('8998','2013-07-04','10:30:00',2.82),('8998','2013-07-04','10:35:00',2.83),('8998','2013-07-04','10:40:00',2.83),('8998','2013-07-04','10:45:00',2.84),('8998','2013-07-04','10:50:00',2.85),('8998','2013-07-04','10:55:00',2.87),('8998','2013-07-04','11:00:00',2.87),('8998','2013-07-04','11:05:00',2.88),('8998','2013-07-04','11:10:00',2.9),('8998','2013-07-04','11:15:00',2.9),('8998','2013-07-04','11:20:00',2.91),('8998','2013-07-04','11:25:00',2.93),('8998','2013-07-04','11:30:00',2.95),('8998','2013-07-04','11:35:00',2.95),('8998','2013-07-04','11:40:00',2.94),('8998','2013-07-04','11:45:00',2.92),('8998','2013-07-04','11:50:00',2.97),('8998','2013-07-04','11:55:00',2.94),('8998','2013-07-04','12:00:00',2.94),('8998','2013-07-04','12:05:00',2.94),('8998','2013-07-04','12:10:00',2.92),('8998','2013-07-04','12:15:00',2.95),('8998','2013-07-04','12:20:00',2.97),('8998','2013-07-04','12:25:00',1.85),('8998','2013-07-04','12:30:00',2.81),('8998','2013-07-04','12:35:00',2.13),('8998','2013-07-04','12:40:00',2.91),('8998','2013-07-04','12:45:00',3.01),('8998','2013-07-04','12:50:00',2.83),('8998','2013-07-04','12:55:00',2.63),('8998','2013-07-04','13:00:00',2.91),('8998','2013-07-04','13:05:00',1.9),('8998','2013-07-04','13:10:00',2.95),('8998','2013-07-04','13:15:00',2.65),('8998','2013-07-04','13:20:00',2.63),('8998','2013-07-04','13:25:00',2.78),('8998','2013-07-04','13:30:00',2.61),('8998','2013-07-04','13:35:00',2.84),('8998','2013-07-04','13:40:00',2.84),('8998','2013-07-04','13:45:00',2.78),('8998','2013-07-04','13:50:00',2.72),('8998','2013-07-04','13:55:00',2.76),('8998','2013-07-04','14:00:00',2.76),('8998','2013-07-04','14:05:00',2.42),('8998','2013-07-04','14:10:00',2.27),('8998','2013-07-04','14:15:00',2.64),('8998','2013-07-04','14:20:00',2.57),('8998','2013-07-04','14:25:00',2.59),('8998','2013-07-04','14:30:00',2.49),('8998','2013-07-04','14:35:00',2.3),('8998','2013-07-04','14:40:00',2.45),('8998','2013-07-04','14:45:00',2.04),('8998','2013-07-04','14:50:00',2.37),('8998','2013-07-04','14:55:00',2.31),('8998','2013-07-04','15:00:00',2.17),('8998','2013-07-04','15:05:00',2.28),('8998','2013-07-04','15:10:00',2.29),('8998','2013-07-04','15:15:00',1.88),('8998','2013-07-04','15:20:00',1.7),('8998','2013-07-04','15:25:00',1.62),('8998','2013-07-04','15:30:00',1.99),('8998','2013-07-04','15:35:00',2.07),('8998','2013-07-04','15:40:00',1.99),('8998','2013-07-04','15:45:00',1.99),('8998','2013-07-04','15:50:00',1.93),('8998','2013-07-04','15:55:00',1.83),('8998','2013-07-04','16:00:00',1.76),('8998','2013-07-04','16:05:00',1.74),('8998','2013-07-04','16:10:00',1.67),('8998','2013-07-04','16:15:00',1.61),('8998','2013-07-04','16:20:00',1.57),('8998','2013-07-04','16:25:00',1.51),('8998','2013-07-04','16:30:00',1.47),('8998','2013-07-04','16:35:00',1.4),('8998','2013-07-04','16:40:00',1.36),('8998','2013-07-04','16:45:00',1.32),('8998','2013-07-04','16:50:00',1.23),('8998','2013-07-04','16:55:00',1.11),('8998','2013-07-04','17:00:00',1.1),('8998','2013-07-04','17:05:00',1.09),('8998','2013-07-04','17:10:00',1.07),('8998','2013-07-04','17:15:00',1.04),('8998','2013-07-03','11:45:00',1.17),('8998','2013-07-03','11:50:00',1.26),('8998','2013-07-03','11:55:00',1.15),('8998','2013-07-03','12:00:00',1.11),('8998','2013-07-03','12:05:00',1.07),('8998','2013-07-03','12:10:00',1.51),('8998','2013-07-03','12:15:00',2.15),('8998','2013-07-03','12:20:00',1.9),('8998','2013-07-03','12:25:00',2.24),('8998','2013-07-03','12:30:00',2.19),('8998','2013-07-03','12:35:00',1.73),('8998','2013-07-03','12:40:00',1.27),('8998','2013-07-03','12:45:00',1.03),('8998','2013-07-03','13:15:00',1.03),('8998','2013-07-03','13:20:00',1.22),('8998','2013-07-03','13:25:00',1.42),('8998','2013-07-03','13:30:00',1.32),('8998','2013-07-03','13:35:00',1.4),('8998','2013-07-03','13:40:00',1.65),('8998','2013-07-03','13:45:00',1.52),('8998','2013-07-03','13:50:00',2.14),('8998','2013-07-03','13:55:00',1.86),('8998','2013-07-03','14:00:00',1.53),('8998','2013-07-03','14:05:00',1.49),('8998','2013-07-03','14:10:00',1.46),('8998','2013-07-03','14:15:00',1.49),('8998','2013-07-03','14:20:00',1.53),('8998','2013-07-03','14:25:00',1.31),('8998','2013-07-03','14:30:00',1.24),('8998','2013-07-03','14:35:00',1.27),('8998','2013-07-03','14:40:00',2.1),('8998','2013-07-03','14:45:00',3.21),('8998','2013-07-03','14:50:00',1.58),('8998','2013-07-03','14:55:00',1.59),('8998','2013-07-03','15:00:00',2.76),('8998','2013-07-03','15:05:00',2.38),('8998','2013-07-03','15:10:00',1.84),('8998','2013-07-03','15:15:00',2.68),('8998','2013-07-03','15:20:00',2.53),('8998','2013-07-03','15:25:00',2.47),('8998','2013-07-03','15:30:00',1.65),('8998','2013-07-03','15:35:00',1.83),('8998','2013-07-03','15:40:00',1.82),('8998','2013-07-03','15:45:00',1.84),('8998','2013-07-03','15:50:00',1.39),('8998','2013-07-03','15:55:00',1.41),('8998','2013-07-03','16:00:00',1.46),('8998','2013-07-03','16:05:00',1.3),('8998','2013-07-03','16:10:00',1.24),('8998','2013-07-03','16:15:00',1.16),('8998','2013-07-03','16:20:00',1.2),('8998','2013-07-03','16:25:00',1.24),('8998','2013-07-03','16:30:00',1.2),('8998','2013-07-03','16:35:00',1.19),('8998','2013-07-03','16:40:00',1),('8998','2013-07-03','16:50:00',1.01),('8998','2013-07-03','17:10:00',1.1),('8998','2013-07-03','17:15:00',1.22),('8998','2013-07-03','17:20:00',1.24),('8998','2013-07-03','17:25:00',1.12),('8998','2013-07-02','07:40:00',1.03),('8998','2013-07-02','07:45:00',1.3),('8998','2013-07-02','07:50:00',1.32),('8998','2013-07-02','07:55:00',1.3),('8998','2013-07-02','08:00:00',1.34),('8998','2013-07-02','08:05:00',1.37),('8998','2013-07-02','08:10:00',1.7),('8998','2013-07-02','08:15:00',1.9),('8998','2013-07-02','08:20:00',1.86),('8998','2013-07-02','08:25:00',1.7),('8998','2013-07-02','08:30:00',1.68),('8998','2013-07-02','08:35:00',1.67),('8998','2013-07-02','08:40:00',1.69),('8998','2013-07-02','08:45:00',1.72),('8998','2013-07-02','08:50:00',2.06),('8998','2013-07-02','08:55:00',1.98),('8998','2013-07-02','09:00:00',1.92),('8998','2013-07-02','09:05:00',1.91),('8998','2013-07-02','09:10:00',2.24),('8998','2013-07-02','09:15:00',2.36),('8998','2013-07-02','09:20:00',2.52),('8998','2013-07-02','09:25:00',2.56),('8998','2013-07-02','09:30:00',2.59),('8998','2013-07-02','09:35:00',2.58),('8998','2013-07-02','09:40:00',2.6),('8998','2013-07-02','09:45:00',2.66),('8998','2013-07-02','09:50:00',2.69),('8998','2013-07-02','09:55:00',2.7),('8998','2013-07-02','10:00:00',2.74),('8998','2013-07-02','10:05:00',2.75),('8998','2013-07-02','10:10:00',2.71),('8998','2013-07-02','10:15:00',2.72),('8998','2013-07-02','10:20:00',2.72),('8998','2013-07-02','10:25:00',2.79),('8998','2013-07-02','10:30:00',2.85),('8998','2013-07-02','10:35:00',2.82),('8998','2013-07-02','10:40:00',2.84),('8998','2013-07-02','10:45:00',2.88),('8998','2013-07-02','10:50:00',2.9),('8998','2013-07-02','10:55:00',2.9),('8998','2013-07-02','11:00:00',2.92),('8998','2013-07-02','11:05:00',2.93),('8998','2013-07-02','11:10:00',2.94),('8998','2013-07-02','11:15:00',2.97),('8998','2013-07-02','11:20:00',2.99),('8998','2013-07-02','11:25:00',3),('8998','2013-07-02','11:30:00',2.98),('8998','2013-07-02','11:35:00',2.96),('8998','2013-07-02','11:40:00',2.94),('8998','2013-07-02','11:45:00',3.01),('8998','2013-07-02','11:50:00',3.03),('8998','2013-07-02','11:55:00',3.02),('8998','2013-07-02','12:00:00',3.03),('8998','2013-07-02','12:05:00',3.06),('8998','2013-07-02','12:10:00',2.99),('8998','2013-07-02','12:15:00',3.03),('8998','2013-07-02','12:20:00',3.02),('8998','2013-07-02','12:25:00',3),('8998','2013-07-02','12:30:00',2.99),('8998','2013-07-02','12:35:00',3),('8998','2013-07-02','12:40:00',2.98),('8998','2013-07-02','12:45:00',2.93),('8998','2013-07-02','12:50:00',2.94),('8998','2013-07-02','12:55:00',2.93),('8998','2013-07-02','13:00:00',2.94),('8998','2013-07-02','13:05:00',2.93),('8998','2013-07-02','13:10:00',2.92),('8998','2013-07-02','13:15:00',2.9),('8998','2013-07-02','13:20:00',2.89),('8998','2013-07-02','13:25:00',2.84),('8998','2013-07-02','13:30:00',2.83),('8998','2013-07-02','13:35:00',2.8),('8998','2013-07-02','13:40:00',2.79),('8998','2013-07-02','13:45:00',2.78),('8998','2013-07-02','13:50:00',2.75),('8998','2013-07-02','13:55:00',2.72),('8998','2013-07-02','14:00:00',2.69),('8998','2013-07-02','14:05:00',2.66),('8998','2013-07-02','14:10:00',2.63),('8998','2013-07-02','14:15:00',2.6),('8998','2013-07-02','14:20:00',2.59),('8998','2013-07-02','14:25:00',2.56),('8998','2013-07-02','14:30:00',2.54),('8998','2013-07-02','14:35:00',2.5),('8998','2013-07-02','14:40:00',2.45),('8998','2013-07-02','14:45:00',2.42),('8998','2013-07-02','14:50:00',2.39),('8998','2013-07-02','14:55:00',2.35),('8998','2013-07-02','15:00:00',2.32),('8998','2013-07-02','15:05:00',2.29),('8998','2013-07-02','15:10:00',2.24),('8998','2013-07-02','15:15:00',2.21),('8998','2013-07-02','15:20:00',2.16),('8998','2013-07-02','15:25:00',2.12),('8998','2013-07-02','15:30:00',2.07),('8998','2013-07-02','15:35:00',2.02),('8998','2013-07-02','15:40:00',1.98),('8998','2013-07-02','15:45:00',1.93),('8998','2013-07-02','15:50:00',1.88),('8998','2013-07-02','15:55:00',1.83),('8998','2013-07-02','16:00:00',1.77),('8998','2013-07-02','16:05:00',1.72),('8998','2013-07-02','16:10:00',1.67),('8998','2013-07-02','16:15:00',1.62),('8998','2013-07-02','16:20:00',1.56),('8998','2013-07-02','16:25:00',1.5),('8998','2013-07-02','16:30:00',1.45),('8998','2013-07-02','16:35:00',1.4),('8998','2013-07-02','16:40:00',1.34),('8998','2013-07-02','16:45:00',1.29),('8998','2013-07-02','16:50:00',1.23),('8998','2013-07-02','16:55:00',1.17),('8998','2013-07-02','17:00:00',1.11),('8998','2013-07-02','17:05:00',1.06),('8998','2013-07-02','17:10:00',1),('8998','2013-07-01','07:30:00',1.03),('8998','2013-07-01','07:35:00',1.18),('8998','2013-07-01','07:40:00',1.15),('8998','2013-07-01','07:45:00',1.28),('8998','2013-07-01','07:50:00',1.29),('8998','2013-07-01','07:55:00',1.28),('8998','2013-07-01','08:00:00',1.32),('8998','2013-07-01','08:05:00',1.34),('8998','2013-07-01','08:10:00',1.38),('8998','2013-07-01','08:15:00',1.45),('8998','2013-07-01','08:20:00',1.89),('8998','2013-07-01','08:25:00',1.95),('8998','2013-07-01','08:30:00',1.99),('8998','2013-07-01','08:35:00',2.02),('8998','2013-07-01','08:40:00',2.11),('8998','2013-07-01','08:45:00',2.1),('8998','2013-07-01','08:50:00',2.03),('8998','2013-07-01','08:55:00',1.96),('8998','2013-07-01','09:00:00',1.91),('8998','2013-07-01','09:05:00',1.91),('8998','2013-07-01','09:10:00',2.24),('8998','2013-07-01','09:15:00',2.4),('8998','2013-07-01','09:20:00',2.52),('8998','2013-07-01','09:25:00',2.55),('8998','2013-07-01','09:30:00',2.59),('8998','2013-07-01','09:35:00',2.6),('8998','2013-07-01','09:40:00',2.62),('8998','2013-07-01','09:45:00',2.65),('8998','2013-07-01','09:50:00',2.67),('8998','2013-07-01','09:55:00',2.7),('8998','2013-07-01','10:00:00',2.73),('8998','2013-07-01','10:05:00',2.75),('8998','2013-07-01','10:10:00',2.75),('8998','2013-07-01','10:15:00',2.76),('8998','2013-07-01','10:20:00',2.78),('8998','2013-07-01','10:25:00',2.79),('8998','2013-07-01','10:30:00',2.82),('8998','2013-07-01','10:35:00',2.84),('8998','2013-07-01','10:40:00',2.85),('8998','2013-07-01','10:45:00',2.87),('8998','2013-07-01','10:50:00',2.87),('8998','2013-07-01','10:55:00',2.86),('8998','2013-07-01','11:00:00',2.88),('8998','2013-07-01','11:05:00',2.87),('8998','2013-07-01','11:10:00',2.86),('8998','2013-07-01','11:15:00',2.86),('8998','2013-07-01','11:20:00',2.86),('8998','2013-07-01','11:25:00',2.87),('8998','2013-07-01','11:30:00',2.89),('8998','2013-07-01','11:35:00',2.93),('8998','2013-07-01','11:40:00',2.92),('8998','2013-07-01','11:45:00',2.87),('8998','2013-07-01','11:50:00',2.86),('8998','2013-07-01','11:55:00',2.88),('8998','2013-07-01','12:00:00',2.86),('8998','2013-07-01','12:05:00',2.81),('8998','2013-07-01','12:10:00',2.91),('8998','2013-07-01','12:15:00',2.88),('8998','2013-07-01','12:20:00',2.84),('8998','2013-07-01','12:25:00',2.75),('8998','2013-07-01','12:30:00',2.86),('8998','2013-07-01','12:35:00',2.92),('8998','2013-07-01','12:40:00',2.94),('8998','2013-07-01','12:45:00',2.94),('8998','2013-07-01','12:50:00',2.95),('8998','2013-07-01','12:55:00',1.32),('8998','2013-07-01','13:00:00',2.43),('8998','2013-07-01','13:10:00',2.91),('8998','2013-07-01','13:15:00',3.02),('8998','2013-07-01','13:20:00',2.97),('8998','2013-07-01','13:25:00',3),('8998','2013-07-01','13:30:00',2.93),('8998','2013-07-01','13:35:00',2.86),('8998','2013-07-01','13:40:00',2.84),('8998','2013-07-01','13:45:00',2.65),('8998','2013-07-01','13:50:00',2.58),('8998','2013-07-01','13:55:00',2.61),('8998','2013-07-01','14:00:00',2.59),('8998','2013-07-01','14:05:00',2.57),('8998','2013-07-01','14:10:00',2.54),('8998','2013-07-01','14:15:00',2.54),('8998','2013-07-01','14:20:00',2.53),('8998','2013-07-01','14:25:00',2.49),('8998','2013-07-01','14:30:00',2.45),('8998','2013-07-01','14:35:00',2.44),('8998','2013-07-01','14:40:00',2.4),('8998','2013-07-01','14:45:00',2.36),('8998','2013-07-01','14:50:00',2.33),('8998','2013-07-01','14:55:00',2.29),('8998','2013-07-01','15:00:00',2.24),('8998','2013-07-01','15:05:00',2.22),('8998','2013-07-01','15:10:00',2.19),('8998','2013-07-01','15:15:00',2.14),('8998','2013-07-01','15:20:00',2.1),('8998','2013-07-01','15:25:00',2.06),('8998','2013-07-01','15:30:00',2.02),('8998','2013-07-01','15:35:00',1.98),('8998','2013-07-01','15:40:00',1.94),('8998','2013-07-01','15:45:00',1.88),('8998','2013-07-01','15:50:00',1.83),('8998','2013-07-01','15:55:00',1.78),('8998','2013-07-01','16:00:00',1.74),('8998','2013-07-01','16:05:00',1.7),('8998','2013-07-01','16:10:00',1.64),('8998','2013-07-01','16:15:00',1.58),('8998','2013-07-01','16:20:00',1.53),('8998','2013-07-01','16:25:00',1.47),('8998','2013-07-01','16:30:00',1.42),('8998','2013-07-01','16:35:00',1.36),('8998','2013-07-01','16:40:00',1.31),('8998','2013-07-01','16:45:00',1.25),('8998','2013-07-01','16:50:00',1.2),('8998','2013-07-01','16:55:00',1.15),('8998','2013-07-01','17:00:00',1.11),('8998','2013-07-01','17:05:00',1.05),('8998','2013-06-30','07:40:00',1.1),('8998','2013-06-30','07:45:00',1.28),('8998','2013-06-30','07:50:00',1.3),('8998','2013-06-30','07:55:00',1.31),('8998','2013-06-30','08:00:00',1.38),('8998','2013-06-30','08:05:00',1.38),('8998','2013-06-30','08:10:00',1.42),('8998','2013-06-30','08:15:00',1.64),('8998','2013-06-30','08:20:00',1.84),('8998','2013-06-30','08:25:00',1.72),('8998','2013-06-30','08:30:00',1.7),('8998','2013-06-30','08:35:00',1.69),('8998','2013-06-30','08:40:00',1.7),('8998','2013-06-30','08:45:00',1.75),('8998','2013-06-30','08:50:00',2.08),('8998','2013-06-30','08:55:00',2.03),('8998','2013-06-30','09:00:00',1.98),('8998','2013-06-30','09:05:00',2.01),('8998','2013-06-30','09:10:00',2.3),('8998','2013-06-30','09:15:00',2.43),('8998','2013-06-30','09:20:00',2.58),('8998','2013-06-30','09:25:00',2.61),('8998','2013-06-30','09:30:00',2.66),('8998','2013-06-30','09:35:00',2.68),('8998','2013-06-30','09:40:00',2.7),('8998','2013-06-30','09:45:00',2.72),('8998','2013-06-30','09:50:00',2.75),('8998','2013-06-30','09:55:00',2.76),('8998','2013-06-30','10:00:00',2.78),('8998','2013-06-30','10:05:00',2.8),('8998','2013-06-30','10:10:00',2.84),('8998','2013-06-30','10:15:00',2.88),('8998','2013-06-30','10:20:00',2.88),('8998','2013-06-30','10:25:00',2.91),('8998','2013-06-30','10:30:00',2.92),('8998','2013-06-30','10:35:00',2.93),('8998','2013-06-30','10:40:00',2.99),('8998','2013-06-30','10:45:00',3),('8998','2013-06-30','10:50:00',2.99),('8998','2013-06-30','10:55:00',2.99),('8998','2013-06-30','11:00:00',3.02),('8998','2013-06-30','11:05:00',3.04),('8998','2013-06-30','11:10:00',3.07),('8998','2013-06-30','11:15:00',3.07),('8998','2013-06-30','11:20:00',3.07),('8998','2013-06-30','11:25:00',3.07),('8998','2013-06-30','11:30:00',3.08),('8998','2013-06-30','11:35:00',3.06),('8998','2013-06-30','11:40:00',3.05),('8998','2013-06-30','11:45:00',3.04),('8998','2013-06-30','11:50:00',3.04),('8998','2013-06-30','11:55:00',3.05),('8998','2013-06-30','12:00:00',3.04),('8998','2013-06-30','12:05:00',3.03),('8998','2013-06-30','12:10:00',3.01),('8998','2013-06-30','12:15:00',3.02),('8998','2013-06-30','12:20:00',3.01),('8998','2013-06-30','12:25:00',2.99),('8998','2013-06-30','12:30:00',3),('8998','2013-06-30','12:35:00',2.98),('8998','2013-06-30','12:40:00',2.96),('8998','2013-06-30','12:45:00',2.98),('8998','2013-06-30','12:50:00',2.98),('8998','2013-06-30','12:55:00',2.99),('8998','2013-06-30','13:00:00',2.97),('8998','2013-06-30','13:05:00',2.93),('8998','2013-06-30','13:10:00',2.93),('8998','2013-06-30','13:15:00',2.9),('8998','2013-06-30','13:20:00',2.89),('8998','2013-06-30','13:25:00',2.88),('8998','2013-06-30','13:30:00',2.85),('8998','2013-06-30','13:35:00',2.82),('8998','2013-06-30','13:40:00',2.78),('8998','2013-06-30','13:45:00',2.72),('8998','2013-06-30','13:50:00',2.72),('8998','2013-06-30','13:55:00',2.67),('8998','2013-06-30','14:00:00',2.64),('8998','2013-06-30','14:05:00',2.68),('8998','2013-06-30','14:10:00',2.67),('8998','2013-06-30','14:15:00',2.64),('8998','2013-06-30','14:20:00',2.6),('8998','2013-06-30','14:25:00',2.55),('8998','2013-06-30','14:30:00',2.51),('8998','2013-06-30','14:35:00',2.47),('8998','2013-06-30','14:40:00',2.45),('8998','2013-06-30','14:45:00',2.42),('8998','2013-06-30','14:50:00',2.35),('8998','2013-06-30','14:55:00',2.32),('8998','2013-06-30','15:00:00',2.27),('8998','2013-06-30','15:05:00',2.21),('8998','2013-06-30','15:10:00',2.18),('8998','2013-06-30','15:15:00',2.15),('8998','2013-06-30','15:20:00',2.11),('8998','2013-06-30','15:25:00',2.06),('8998','2013-06-30','15:30:00',2.02),('8998','2013-06-30','15:35:00',1.97),('8998','2013-06-30','15:40:00',1.92),('8998','2013-06-30','15:45:00',1.88),('8998','2013-06-30','15:50:00',1.84),('8998','2013-06-30','15:55:00',1.78),('8998','2013-06-30','16:00:00',1.74),('8998','2013-06-30','16:05:00',1.68),('8998','2013-06-30','16:10:00',1.64),('8998','2013-06-30','16:15:00',1.58),('8998','2013-06-30','16:20:00',1.51),('8998','2013-06-30','16:25:00',1.46),('8998','2013-06-30','16:30:00',1.41),('8998','2013-06-30','16:35:00',1.35),('8998','2013-06-30','16:40:00',1.3),('8998','2013-06-30','16:45:00',1.25),('8998','2013-06-30','16:50:00',1.21),('8998','2013-06-30','16:55:00',1.15),('8998','2013-06-30','17:00:00',1.11),('8998','2013-06-30','17:05:00',1.05),('8998','2014-04-04','09:20:00',1.28),('8998','2014-04-04','09:25:00',2.41),('8998','2014-04-04','09:30:00',3.13),('8998','2014-04-04','09:35:00',3.01),('8998','2014-04-04','09:40:00',2.49),('8998','2014-04-04','09:45:00',1.91),('8998','2014-04-04','09:50:00',1.49),('8998','2014-04-04','09:55:00',1.84),('8998','2014-04-04','10:00:00',1.75),('8998','2014-04-04','10:05:00',1.64),('8998','2014-04-04','10:10:00',1.79),('8998','2014-04-04','10:15:00',1.2),('8998','2014-04-04','10:20:00',1.97),('8998','2014-04-04','10:25:00',2.16),('8998','2014-04-04','10:30:00',2.24),('8998','2014-04-04','10:35:00',2.48),('8998','2014-04-04','10:40:00',2.67),('8998','2014-04-04','10:45:00',2.35),('8998','2014-04-04','10:50:00',2.19),('8998','2014-04-04','10:55:00',2.44),('8998','2014-04-04','11:00:00',2.69),('8998','2014-04-04','11:05:00',2.91),('8998','2014-04-04','11:10:00',3.04),('8998','2014-04-04','11:15:00',3.26),('8998','2014-04-04','11:20:00',3.08),('8998','2014-04-04','11:25:00',1.95),('8998','2014-04-04','11:30:00',1.6),('8998','2014-04-04','11:35:00',2.07),('8998','2014-04-04','11:40:00',2.76),('8998','2014-04-04','11:45:00',3.01),('8998','2014-04-04','11:50:00',3.21),('8998','2014-04-04','11:55:00',3),('8998','2014-04-04','12:00:00',2.21),('8998','2014-04-04','12:05:00',2.12),('8998','2014-04-04','12:10:00',2.25),('8998','2014-04-04','12:15:00',2.04),('8998','2014-04-04','12:20:00',2.48),('8998','2014-04-04','12:25:00',1.91),('8998','2014-04-04','12:30:00',1.73),('8998','2014-04-04','12:35:00',1.66),('8998','2014-04-04','12:40:00',2.82),('8998','2014-04-04','12:45:00',3.26),('8998','2014-04-04','12:50:00',3.23),('8998','2014-04-04','12:55:00',2.33),('8998','2014-04-04','13:00:00',2.4),('8998','2014-04-04','13:05:00',1.88),('8998','2014-04-04','13:10:00',2.72),('8998','2014-04-04','13:15:00',1.68),('8998','2014-04-04','13:20:00',2.79),('8998','2014-04-04','13:25:00',2.33),('8998','2014-04-04','13:30:00',2.67),('8998','2014-04-04','13:35:00',3.14),('8998','2014-04-04','13:40:00',3.06),('8998','2014-04-04','13:45:00',2.2),('8998','2014-04-04','13:50:00',2.73),('8998','2014-04-04','13:55:00',2.56),('8998','2014-04-04','14:00:00',2.42),('8998','2014-04-04','14:05:00',3.07),('8998','2014-04-04','14:10:00',1.19),('8998','2014-04-04','14:50:00',1.49),('8998','2014-04-04','14:55:00',2.24),('8998','2014-04-04','15:00:00',1.78),('8998','2014-04-04','15:05:00',2.1),('8998','2014-04-04','15:15:00',1.7),('8998','2014-04-04','15:20:00',2.45),('8998','2014-04-04','15:25:00',1.79),('8998','2014-04-04','15:35:00',1.04),('8998','2014-04-04','15:40:00',1.39),('8998','2014-04-04','15:45:00',1.09),('8998','2014-04-04','16:15:00',1.28),('8998','2014-04-04','16:20:00',1.55),('8998','2014-04-04','16:25:00',1.75),('8998','2014-04-04','16:30:00',1.09),('8998','2014-04-04','16:35:00',1.11),('8998','2013-06-29','07:35:00',1.05),('8998','2013-06-29','07:40:00',1.16),('8998','2013-06-29','07:45:00',1.36),('8998','2013-06-29','07:50:00',1.44),('8998','2013-06-29','07:55:00',1.59),('8998','2013-06-29','08:00:00',1.73),('8998','2013-06-29','08:05:00',1.78),('8998','2013-06-29','08:10:00',1.9),('8998','2013-06-29','08:15:00',1.97),('8998','2013-06-29','08:20:00',1.91),('8998','2013-06-29','08:25:00',1.78),('8998','2013-06-29','08:30:00',1.75),('8998','2013-06-29','08:35:00',1.73),('8998','2013-06-29','08:40:00',1.73),('8998','2013-06-29','08:45:00',1.82),('8998','2013-06-29','08:50:00',2.15),('8998','2013-06-29','08:55:00',2.09),('8998','2013-06-29','09:00:00',2),('8998','2013-06-29','09:05:00',2),('8998','2013-06-29','09:10:00',2.32),('8998','2013-06-29','09:15:00',2.5),('8998','2013-06-29','09:20:00',2.63),('8998','2013-06-29','09:25:00',2.66),('8998','2013-06-29','09:30:00',2.69),('8998','2013-06-29','09:35:00',2.72),('8998','2013-06-29','09:40:00',2.76),('8998','2013-06-29','09:45:00',2.8),('8998','2013-06-29','09:50:00',2.83),('8998','2013-06-29','09:55:00',2.84),('8998','2013-06-29','10:00:00',2.88),('8998','2013-06-29','10:05:00',2.89),('8998','2013-06-29','10:10:00',2.88),('8998','2013-06-29','10:15:00',2.92),('8998','2013-06-29','10:20:00',2.94),('8998','2013-06-29','10:25:00',2.94),('8998','2013-06-29','10:30:00',2.97),('8998','2013-06-29','10:35:00',3),('8998','2013-06-29','10:40:00',3.02),('8998','2013-06-29','10:45:00',3.01),('8998','2013-06-29','10:50:00',3.02),('8998','2013-06-29','10:55:00',3.04),('8998','2013-06-29','11:00:00',3.05),('8998','2013-06-29','11:05:00',3.06),('8998','2013-06-29','11:10:00',3.05),('8998','2013-06-29','11:15:00',3.06),('8998','2013-06-29','11:20:00',3.06),('8998','2013-06-29','11:25:00',3.07),('8998','2013-06-29','11:30:00',3.08),('8998','2013-06-29','11:35:00',3.08),('8998','2013-06-29','11:40:00',3.08),('8998','2013-06-29','11:45:00',3.07),('8998','2013-06-29','11:50:00',3.08),('8998','2013-06-29','11:55:00',3.07),('8998','2013-06-29','12:00:00',3.06),('8998','2013-06-29','12:05:00',3.08),('8998','2013-06-29','12:10:00',3.08),('8998','2013-06-29','12:15:00',3.04),('8998','2013-06-29','12:20:00',3.03),('8998','2013-06-29','12:25:00',3.04),('8998','2013-06-29','12:30:00',3.04),('8998','2013-06-29','12:35:00',3.04),('8998','2013-06-29','12:40:00',3.04),('8998','2013-06-29','12:45:00',3.04),('8998','2013-06-29','12:50:00',3.04),('8998','2013-06-29','12:55:00',3.01),('8998','2013-06-29','13:00:00',2.98),('8998','2013-06-29','13:05:00',2.97),('8998','2013-06-29','13:10:00',2.95),('8998','2013-06-29','13:15:00',2.94),('8998','2013-06-29','13:20:00',2.93),('8998','2013-06-29','13:25:00',2.95),('8998','2013-06-29','13:30:00',2.9),('8998','2013-06-29','13:35:00',2.86),('8998','2013-06-29','13:40:00',2.85),('8998','2013-06-29','13:45:00',2.85),('8998','2013-06-29','13:50:00',2.87),('8998','2013-06-29','13:55:00',2.33),('8998','2013-06-29','14:00:00',2.81),('8998','2013-06-29','14:05:00',2.77),('8998','2013-06-29','14:10:00',2.73),('8998','2013-06-29','14:15:00',2.67),('8998','2013-06-29','14:20:00',2.65),('8998','2013-06-29','14:25:00',2.61),('8998','2013-06-29','14:30:00',2.57),('8998','2013-06-29','14:35:00',2.54),('8998','2013-06-29','14:40:00',2.53),('8998','2013-06-29','14:45:00',2.48),('8998','2013-06-29','14:50:00',2.45),('8998','2013-06-29','14:55:00',2.41),('8998','2013-06-29','15:00:00',2.36),('8998','2013-06-29','15:05:00',2.32),('8998','2013-06-29','15:10:00',2.29),('8998','2013-06-29','15:15:00',2.24),('8998','2013-06-29','15:20:00',2.22),('8998','2013-06-29','15:25:00',2.16),('8998','2013-06-29','15:30:00',2.12),('8998','2013-06-29','15:35:00',2.08),('8998','2013-06-29','15:40:00',2.03),('8998','2013-06-29','15:45:00',1.99),('8998','2013-06-29','15:50:00',1.95),('8998','2013-06-29','15:55:00',1.91),('8998','2013-06-29','16:00:00',1.85),('8998','2013-06-29','16:05:00',1.8),('8998','2013-06-29','16:10:00',1.77),('8998','2013-06-29','16:15:00',1.75),('8998','2013-06-29','16:20:00',1.8),('8998','2013-06-29','16:25:00',1.84),('8998','2013-06-29','16:30:00',1.52),('8998','2013-06-29','16:35:00',1.49),('8998','2013-06-29','16:40:00',1.37),('8998','2013-06-29','16:45:00',1.32),('8998','2013-06-29','16:50:00',1.27),('8998','2013-06-29','16:55:00',1.2),('8998','2013-06-29','17:00:00',1.14),('8998','2013-06-29','17:05:00',1.11),('8998','2013-06-29','17:10:00',1.07),('8998','2013-06-28','07:35:00',1.28),('8998','2013-06-28','07:40:00',1.22),('8998','2013-06-28','07:45:00',1.34),('8998','2013-06-28','07:50:00',1.37),('8998','2013-06-28','07:55:00',1.41),('8998','2013-06-28','08:00:00',1.79),('8998','2013-06-28','08:05:00',1.85),('8998','2013-06-28','08:10:00',1.91),('8998','2013-06-28','08:15:00',1.73),('8998','2013-06-28','08:20:00',1.2),('8998','2013-06-28','08:25:00',1.53),('8998','2013-06-28','08:30:00',1.9),('8998','2013-06-28','08:35:00',1.86),('8998','2013-06-28','08:40:00',1.12),('8998','2013-06-28','08:45:00',1.76),('8998','2013-06-28','08:50:00',2.2),('8998','2013-06-28','08:55:00',2.13),('8998','2013-06-28','09:00:00',2.03),('8998','2013-06-28','09:05:00',2.03),('8998','2013-06-28','09:10:00',2.32),('8998','2013-06-28','09:15:00',2.5),('8998','2013-06-28','09:20:00',2.6),('8998','2013-06-28','09:25:00',2.64),('8998','2013-06-28','09:30:00',2.65),('8998','2013-06-28','09:35:00',2.72),('8998','2013-06-28','09:40:00',2.73),('8998','2013-06-28','09:45:00',2.74),('8998','2013-06-28','09:50:00',2.78),('8998','2013-06-28','09:55:00',2.8),('8998','2013-06-28','10:00:00',2.83),('8998','2013-06-28','10:05:00',2.86),('8998','2013-06-28','10:10:00',2.88),('8998','2013-06-28','10:15:00',2.87),('8998','2013-06-28','10:20:00',2.9),('8998','2013-06-28','10:25:00',2.93),('8998','2013-06-28','10:30:00',2.94),('8998','2013-06-28','10:35:00',2.95),('8998','2013-06-28','10:40:00',2.97),('8998','2013-06-28','10:45:00',3.01),('8998','2013-06-28','10:50:00',3),('8998','2013-06-28','10:55:00',3.07),('8998','2013-06-28','11:00:00',3.08),('8998','2013-06-28','11:05:00',3.11),('8998','2013-06-28','11:10:00',3.13),('8998','2013-06-28','11:15:00',3.2),('8998','2013-06-28','11:20:00',1.79),('8998','2013-06-28','11:25:00',3.35),('8998','2013-06-28','11:30:00',3.36),('8998','2013-06-28','11:35:00',2.81),('8998','2013-06-28','11:40:00',2.81),('8998','2013-06-28','11:50:00',2.25),('8998','2013-06-28','11:55:00',3.53),('8998','2013-06-28','12:00:00',2.32),('8998','2013-06-28','12:05:00',3.26),('8998','2013-06-28','12:10:00',3.31),('8998','2013-06-28','12:15:00',2.58),('8998','2013-06-28','12:20:00',1.05),('8998','2013-06-28','12:25:00',3.41),('8998','2013-06-28','12:30:00',3.09),('8998','2013-06-28','12:35:00',3.27),('8998','2013-06-28','12:40:00',3.21),('8998','2013-06-28','12:45:00',3.45),('8998','2013-06-28','12:50:00',1.53),('8998','2013-06-28','12:55:00',2.57),('8998','2013-06-28','13:00:00',2.24),('8998','2013-06-28','13:05:00',1.66),('8998','2013-06-28','13:10:00',3.57),('8998','2013-06-28','13:15:00',3.27),('8998','2013-06-28','13:20:00',1.61),('8998','2013-06-28','13:25:00',2.79),('8998','2013-06-28','13:30:00',1.06),('8998','2013-06-28','13:45:00',2),('8998','2013-06-28','13:50:00',3.05),('8998','2013-06-28','13:55:00',2.47),('8998','2013-06-28','14:00:00',3.09),('8998','2013-06-28','14:05:00',2.37),('8998','2013-06-28','14:10:00',2.95),('8998','2013-06-28','14:15:00',3.25),('8998','2013-06-28','14:20:00',2.91),('8998','2013-06-28','14:25:00',1.87),('8998','2013-06-28','14:30:00',3.16),('8998','2013-06-28','14:35:00',2.96),('8998','2013-06-28','14:40:00',2.94),('8998','2013-06-28','14:45:00',2.99),('8998','2013-06-28','14:50:00',2.25),('8998','2013-06-28','15:00:00',1.17),('8998','2013-06-28','15:05:00',1.91),('8998','2013-06-28','15:10:00',1.29),('8998','2013-06-28','16:50:00',1.26),('8998','2013-06-28','17:30:00',1.07),('8998','2013-06-27','07:20:00',1.15),('8998','2013-06-27','07:25:00',1.23),('8998','2013-06-27','07:30:00',1.26),('8998','2013-06-27','07:35:00',1.23),('8998','2013-06-27','07:40:00',1.26),('8998','2013-06-27','07:45:00',1.41),('8998','2013-06-27','07:50:00',1.38),('8998','2013-06-27','07:55:00',1.39),('8998','2013-06-27','08:00:00',1.46),('8998','2013-06-27','08:05:00',1.73),('8998','2013-06-27','08:10:00',1.74),('8998','2013-06-27','08:15:00',1.88),('8998','2013-06-27','08:20:00',1.84),('8998','2013-06-27','08:25:00',1.64),('8998','2013-06-27','08:30:00',1.71),('8998','2013-06-27','08:35:00',1.73),('8998','2013-06-27','08:40:00',1.74),('8998','2013-06-27','08:45:00',1.76),('8998','2013-06-27','08:50:00',2.1),('8998','2013-06-27','08:55:00',2.04),('8998','2013-06-27','09:00:00',2.11),('8998','2013-06-27','09:05:00',2.23),('8998','2013-06-27','09:10:00',2.34),('8998','2013-06-27','09:15:00',2.22),('8998','2013-06-27','09:30:00',1.5),('8998','2013-06-27','09:35:00',2.92),('8998','2013-06-27','09:40:00',2.75),('8998','2013-06-27','09:45:00',1.72),('8998','2013-06-27','09:50:00',1.15),('8998','2013-06-27','09:55:00',2.02),('8998','2013-06-27','10:00:00',3.01),('8998','2013-06-27','10:05:00',1.99),('8998','2013-06-27','10:10:00',3.1),('8998','2013-06-27','10:15:00',3.04),('8998','2013-06-27','10:20:00',3.09),('8998','2013-06-27','10:25:00',2.6),('8998','2013-06-27','10:35:00',2.34),('8998','2013-06-27','10:40:00',3.44),('8998','2013-06-27','10:45:00',3.17),('8998','2013-06-27','10:50:00',3.22),('8998','2013-06-27','10:55:00',1.79),('8998','2013-06-27','11:00:00',2.23),('8998','2013-06-27','11:05:00',3.56),('8998','2013-06-27','11:10:00',2.26),('8998','2013-06-27','11:15:00',1.08),('8998','2013-06-27','11:20:00',1.22),('8998','2013-06-27','11:25:00',2.09),('8998','2013-06-27','11:30:00',3.5),('8998','2013-06-27','11:35:00',2.95),('8998','2013-06-27','11:40:00',3.28),('8998','2013-06-27','11:45:00',2.86),('8998','2013-06-27','11:50:00',3.46),('8998','2013-06-27','11:55:00',2.49),('8998','2013-06-27','12:00:00',1.99),('8998','2013-06-27','12:05:00',2.17),('8998','2013-06-27','12:10:00',2.17),('8998','2013-06-27','12:15:00',3.52),('8998','2013-06-27','12:20:00',3.29),('8998','2013-06-27','12:25:00',3.31),('8998','2013-06-27','12:30:00',3.06),('8998','2013-06-27','12:35:00',3.3),('8998','2013-06-27','12:40:00',2.55),('8998','2013-06-27','12:45:00',2.91),('8998','2013-06-27','12:50:00',3.23),('8998','2013-06-27','12:55:00',3.17),('8998','2013-06-27','13:00:00',2.92),('8998','2013-06-27','13:05:00',3.12),('8998','2013-06-27','13:10:00',2.62),('8998','2013-06-27','13:15:00',3.24),('8998','2013-06-27','13:20:00',3.09),('8998','2013-06-27','13:25:00',2.99),('8998','2013-06-27','13:30:00',3.04),('8998','2013-06-27','13:35:00',3.03),('8998','2013-06-27','13:40:00',2.97),('8998','2013-06-27','13:45:00',2.82),('8998','2013-06-27','13:50:00',3.04),('8998','2013-06-27','13:55:00',2.88),('8998','2013-06-27','14:00:00',2.74),('8998','2013-06-27','14:05:00',2.6),('8998','2013-06-27','14:10:00',2.72),('8998','2013-06-27','14:15:00',2.34),('8998','2013-06-27','14:20:00',2.87),('8998','2013-06-27','14:25:00',2.86),('8998','2013-06-27','14:30:00',2.41),('8998','2013-06-27','14:35:00',2.46),('8998','2013-06-27','14:40:00',2.33),('8998','2013-06-27','14:45:00',2.19),('8998','2013-06-27','14:50:00',2.72),('8998','2013-06-27','14:55:00',2.31),('8998','2013-06-27','15:00:00',2.04),('8998','2013-06-27','15:05:00',2.4),('8998','2013-06-27','15:10:00',2.24),('8998','2013-06-27','15:15:00',2.27),('8998','2013-06-27','15:20:00',1.13),('8998','2013-06-27','15:25:00',2.37),('8998','2013-06-27','15:30:00',1.6),('8998','2013-06-27','15:35:00',1.12),('8998','2013-06-27','15:40:00',2.1),('8998','2013-06-27','15:45:00',1.37),('8998','2013-06-27','15:50:00',2.36),('8998','2013-06-27','15:55:00',2.1),('8998','2013-06-27','16:00:00',1.45),('8998','2013-06-27','16:05:00',2.13),('8998','2013-06-27','16:10:00',1.41),('8998','2013-06-27','16:15:00',1.9),('8998','2013-06-27','16:20:00',1.18),('8998','2013-06-27','16:25:00',1.23),('8998','2013-06-27','16:35:00',1.05),('8998','2013-06-27','16:40:00',1.37),('8998','2013-06-27','17:05:00',1.14),('8998','2013-06-27','17:10:00',1.04),('8998','2013-06-26','07:30:00',1.23),('8998','2013-06-26','07:35:00',1.22),('8998','2013-06-26','07:40:00',1.26),('8998','2013-06-26','07:45:00',1.37),('8998','2013-06-26','07:50:00',1.42),('8998','2013-06-26','07:55:00',1.41),('8998','2013-06-26','08:00:00',1.42),('8998','2013-06-26','08:05:00',1.43),('8998','2013-06-26','08:10:00',1.47),('8998','2013-06-26','08:15:00',1.61),('8998','2013-06-26','08:20:00',1.88),('8998','2013-06-26','08:25:00',1.78),('8998','2013-06-26','08:30:00',1.76),('8998','2013-06-26','08:35:00',1.7),('8998','2013-06-26','08:40:00',1.71),('8998','2013-06-26','08:45:00',1.87),('8998','2013-06-26','08:50:00',2.11),('8998','2013-06-26','08:55:00',2.07),('8998','2013-06-26','09:00:00',1.97),('8998','2013-06-26','09:05:00',2.03),('8998','2013-06-26','09:10:00',2.31),('8998','2013-06-26','09:15:00',2.51),('8998','2013-06-26','09:20:00',2.62),('8998','2013-06-26','09:25:00',2.64),('8998','2013-06-26','09:30:00',2.68),('8998','2013-06-26','09:35:00',2.7),('8998','2013-06-26','09:40:00',2.72),('8998','2013-06-26','09:45:00',2.74),('8998','2013-06-26','09:50:00',2.81),('8998','2013-06-26','09:55:00',2.81),('8998','2013-06-26','10:00:00',2.6),('8998','2013-06-26','10:05:00',3.03),('8998','2013-06-26','10:10:00',2.46),('8998','2013-06-26','10:15:00',2.84),('8998','2013-06-26','10:20:00',2.97),('8998','2013-06-26','10:25:00',2.96),('8998','2013-06-26','10:30:00',3),('8998','2013-06-26','10:35:00',3.05),('8998','2013-06-26','10:40:00',3.08),('8998','2013-06-26','10:45:00',3.21),('8998','2013-06-26','10:50:00',3.21),('8998','2013-06-26','10:55:00',3.16),('8998','2013-06-26','11:00:00',2.64),('8998','2013-06-26','11:05:00',3.22),('8998','2013-06-26','11:10:00',3.06),('8998','2013-06-26','11:15:00',3.17),('8998','2013-06-26','11:20:00',3.13),('8998','2013-06-26','11:25:00',3.09),('8998','2013-06-26','11:30:00',3.15),('8998','2013-06-26','11:35:00',3),('8998','2013-06-26','11:40:00',1.1),('8998','2013-06-26','11:45:00',3.17),('8998','2013-06-26','11:50:00',1.99),('8998','2013-06-26','11:55:00',1.01),('8998','2013-06-26','12:00:00',1.48),('8998','2013-06-26','12:10:00',1.61),('8998','2013-06-26','12:25:00',1.07),('8998','2013-06-26','12:30:00',1.03),('8998','2013-06-26','12:35:00',2.52),('8998','2013-06-26','12:40:00',1.68),('8998','2013-06-26','12:45:00',1.02),('8998','2013-06-26','13:10:00',1.06),('8998','2013-06-26','13:15:00',1.94),('8998','2013-06-26','13:20:00',2.27),('8998','2013-06-26','13:25:00',1.57),('8998','2013-06-26','13:30:00',1.2),('8998','2013-06-26','13:35:00',2.4),('8998','2013-06-26','13:40:00',1.03),('8998','2013-06-26','13:55:00',1.01),('8998','2013-06-26','14:10:00',1.03),('8998','2013-06-26','14:15:00',1.19),('8998','2013-06-26','14:20:00',1.21),('8998','2013-06-26','14:25:00',1.33),('8998','2013-06-26','14:30:00',2.88),('8998','2013-06-26','14:35:00',2.71),('8998','2013-06-26','14:40:00',2.64),('8998','2013-06-26','14:45:00',2.18),('8998','2013-06-26','14:50:00',1.77),('8998','2013-06-26','14:55:00',2.17),('8998','2013-06-26','15:00:00',2.36),('8998','2013-06-26','15:05:00',2.31),('8998','2013-06-26','15:10:00',2.25),('8998','2013-06-26','15:15:00',2.19),('8998','2013-06-26','15:20:00',2.15),('8998','2013-06-26','15:25:00',2.14),('8998','2013-06-26','15:30:00',2.1),('8998','2013-06-26','15:35:00',2.04),('8998','2013-06-26','15:40:00',1.99),('8998','2013-06-26','15:45:00',1.94),('8998','2013-06-26','15:50:00',1.88),('8998','2013-06-26','15:55:00',1.83),('8998','2013-06-26','16:00:00',1.75),('8998','2013-06-26','16:05:00',1.69),('8998','2013-06-26','16:10:00',1.65),('8998','2013-06-26','16:15:00',1.61),('8998','2013-06-26','16:20:00',1.57),('8998','2013-06-26','16:25:00',1.53),('8998','2013-06-26','16:30:00',1.48),('8998','2013-06-26','16:35:00',1.35),('8998','2013-06-26','16:40:00',1.34),('8998','2013-06-26','16:45:00',1.34),('8998','2013-06-26','16:50:00',1.28),('8998','2013-06-26','16:55:00',1.23),('8998','2013-06-26','17:00:00',1.18),('8998','2013-06-26','17:05:00',1.11),('8998','2013-06-26','17:10:00',1.04),('8998','2013-06-25','07:35:00',1.06),('8998','2013-06-25','07:40:00',1.2),('8998','2013-06-25','07:45:00',1.39),('8998','2013-06-25','07:50:00',1.42),('8998','2013-06-25','07:55:00',1.39),('8998','2013-06-25','08:00:00',1.38),('8998','2013-06-25','08:05:00',1.4),('8998','2013-06-25','08:10:00',1.44),('8998','2013-06-25','08:15:00',1.79),('8998','2013-06-25','08:20:00',1.85),('8998','2013-06-25','08:25:00',1.75),('8998','2013-06-25','08:30:00',1.74),('8998','2013-06-25','08:35:00',1.68),('8998','2013-06-25','08:40:00',1.7),('8998','2013-06-25','08:45:00',1.84),('8998','2013-06-25','08:50:00',2.1),('8998','2013-06-25','08:55:00',2.04),('8998','2013-06-25','09:00:00',1.91),('8998','2013-06-25','09:05:00',2),('8998','2013-06-25','09:10:00',2.27),('8998','2013-06-25','09:15:00',2.44),('8998','2013-06-25','09:20:00',2.51),('8998','2013-06-25','09:25:00',2.56),('8998','2013-06-25','09:30:00',2.61),('8998','2013-06-25','09:35:00',2.65),('8998','2013-06-25','09:40:00',2.66),('8998','2013-06-25','09:45:00',2.67),('8998','2013-06-25','09:50:00',2.69),('8998','2013-06-25','09:55:00',2.73),('8998','2013-06-25','10:00:00',2.78),('8998','2013-06-25','10:05:00',2.82),('8998','2013-06-25','10:10:00',2.83),('8998','2013-06-25','10:15:00',2.85),('8998','2013-06-25','10:20:00',2.88),('8998','2013-06-25','10:25:00',2.87),('8998','2013-06-25','10:30:00',2.87),('8998','2013-06-25','10:35:00',2.91),('8998','2013-06-25','10:40:00',2.96),('8998','2013-06-25','10:45:00',2.96),('8998','2013-06-25','10:50:00',2.98),('8998','2013-06-25','10:55:00',2.98),('8998','2013-06-25','11:00:00',3),('8998','2013-06-25','11:05:00',2.99),('8998','2013-06-25','11:10:00',3.01),('8998','2013-06-25','11:15:00',3.01),('8998','2013-06-25','11:20:00',3.01),('8998','2013-06-25','11:25:00',3.01),('8998','2013-06-25','11:30:00',3.01),('8998','2013-06-25','11:35:00',3.02),('8998','2013-06-25','11:40:00',3.02),('8998','2013-06-25','11:45:00',3.03),('8998','2013-06-25','11:50:00',3.03),('8998','2013-06-25','11:55:00',3.04),('8998','2013-06-25','12:00:00',3.07),('8998','2013-06-25','12:05:00',3.05),('8998','2013-06-25','12:10:00',3.04),('8998','2013-06-25','12:15:00',2.95),('8998','2013-06-25','12:20:00',2.9),('8998','2013-06-25','12:25:00',2.94),('8998','2013-06-25','12:30:00',3.02),('8998','2013-06-25','12:35:00',2.98),('8998','2013-06-25','12:40:00',3.05),('8998','2013-06-25','12:45:00',3),('8998','2013-06-25','12:50:00',1.5),('8998','2013-06-25','13:15:00',2.41),('8998','2013-06-25','13:20:00',3.27),('8998','2013-06-25','13:25:00',2.45),('8998','2013-06-25','13:55:00',1.71),('8998','2013-06-25','14:00:00',1.85),('8998','2013-06-25','14:10:00',1.36),('8998','2013-06-25','14:15:00',2.98),('8998','2013-06-25','14:20:00',2.78),('8998','2013-06-25','14:25:00',2.33),('8998','2013-06-25','14:30:00',2.23),('8998','2013-06-25','14:35:00',2.59),('8998','2013-06-25','14:45:00',2.2),('8998','2013-06-25','14:50:00',2.66),('8998','2013-06-25','14:55:00',2.31),('8998','2013-06-25','15:00:00',2.39),('8998','2013-06-25','15:05:00',2.33),('8998','2013-06-25','15:10:00',2.28),('8998','2013-06-25','15:15:00',2.22),('8998','2013-06-25','15:20:00',2.16),('8998','2013-06-25','15:25:00',2.12),('8998','2013-06-25','15:30:00',2.1),('8998','2013-06-25','15:35:00',2.09),('8998','2013-06-25','15:40:00',2.01),('8998','2013-06-25','15:45:00',1.95),('8998','2013-06-25','15:50:00',1.92),('8998','2013-06-25','15:55:00',1.66),('8998','2013-06-25','16:00:00',1.79),('8998','2013-06-25','16:05:00',1.73),('8998','2013-06-25','16:10:00',1.69),('8998','2013-06-25','16:15:00',1.65),('8998','2013-06-25','16:20:00',1.59),('8998','2013-06-25','16:25:00',1.54),('8998','2013-06-25','16:30:00',1.51),('8998','2013-06-25','16:35:00',1.44),('8998','2013-06-25','16:40:00',1.36),('8998','2013-06-25','16:45:00',1.32),('8998','2013-06-25','16:50:00',1.25),('8998','2013-06-25','16:55:00',1.19),('8998','2013-06-25','17:00:00',1.14),('8998','2013-06-25','17:05:00',1.09),('8998','2013-06-25','17:10:00',1.05),('8998','2013-06-24','07:40:00',1.37),('8998','2013-06-24','07:45:00',1.48),('8998','2013-06-24','07:50:00',1.31),('8998','2013-06-24','07:55:00',1.26),('8998','2013-06-24','08:05:00',1.28),('8998','2013-06-24','08:10:00',1.21),('8998','2013-06-24','08:15:00',1.18),('8998','2013-06-24','08:20:00',1.85),('8998','2013-06-24','08:30:00',1.61),('8998','2013-06-24','08:35:00',2.18),('8998','2013-06-24','08:40:00',2.22),('8998','2013-06-24','08:45:00',2.21),('8998','2013-06-24','08:50:00',2.18),('8998','2013-06-24','08:55:00',2.13),('8998','2013-06-24','09:00:00',2),('8998','2013-06-24','09:05:00',2.09),('8998','2013-06-24','09:10:00',2.36),('8998','2013-06-24','09:15:00',2.58),('8998','2013-06-24','09:20:00',2.52),('8998','2013-06-24','09:25:00',2.73),('8998','2013-06-24','09:30:00',2.75),('8998','2013-06-24','09:35:00',2.85),('8998','2013-06-24','09:40:00',2.86),('8998','2013-06-24','09:45:00',2.86),('8998','2013-06-24','09:50:00',2.98),('8998','2013-06-24','09:55:00',3.05),('8998','2013-06-24','10:00:00',3.08),('8998','2013-06-24','10:05:00',1.4),('8998','2013-06-24','10:10:00',2.35),('8998','2013-06-24','10:15:00',3.24),('8998','2013-06-24','10:20:00',3.2),('8998','2013-06-24','10:25:00',1.99),('8998','2013-06-24','10:30:00',3.29),('8998','2013-06-24','10:35:00',3.29),('8998','2013-06-24','10:40:00',3.26),('8998','2013-06-24','10:45:00',3.18),('8998','2013-06-24','10:50:00',3.16),('8998','2013-06-24','10:55:00',2.72),('8998','2013-06-24','11:05:00',1.45),('8998','2013-06-24','11:10:00',2.67),('8998','2013-06-24','11:15:00',1.71),('8998','2013-06-24','11:20:00',2.82),('8998','2013-06-24','11:30:00',1.5),('8998','2013-06-24','11:35:00',2.61),('8998','2013-06-24','11:40:00',3.32),('8998','2013-06-24','11:45:00',3.39),('8998','2013-06-24','11:50:00',2.79),('8998','2013-06-24','11:55:00',2.31),('8998','2013-06-24','12:00:00',2.96),('8998','2013-06-24','12:05:00',2.23),('8998','2013-06-24','12:10:00',1.82),('8998','2013-06-24','12:15:00',2.3),('8998','2013-06-24','12:20:00',1.43),('8998','2013-06-24','12:40:00',1.2),('8998','2013-06-24','12:55:00',1.63),('8998','2013-06-24','13:00:00',3.44),('8998','2013-06-24','13:05:00',3.26),('8998','2013-06-24','13:10:00',3.2),('8998','2013-06-24','13:15:00',2.88),('8998','2013-06-24','13:20:00',3.08),('8998','2013-06-24','13:25:00',3.01),('8998','2013-06-24','13:30:00',3.07),('8998','2013-06-24','13:35:00',2.84),('8998','2013-06-24','13:40:00',2.15),('8998','2013-06-24','13:45:00',3.13),('8998','2013-06-24','13:50:00',2.49),('8998','2013-06-24','13:55:00',2.94),('8998','2013-06-24','14:00:00',2.29),('8998','2013-06-24','14:05:00',2.9),('8998','2013-06-24','14:10:00',2.94),('8998','2013-06-24','14:15:00',2.04),('8998','2013-06-24','14:20:00',2.61),('8998','2013-06-24','14:25:00',2.71),('8998','2013-06-24','14:30:00',2.63),('8998','2013-06-24','14:35:00',2.56),('8998','2013-06-24','14:40:00',2.39),('8998','2013-06-24','14:45:00',2.31),('8998','2013-06-24','14:50:00',2.49),('8998','2013-06-24','14:55:00',2.42),('8998','2013-06-24','15:00:00',2.38),('8998','2013-06-24','15:05:00',2.34),('8998','2013-06-24','15:10:00',2.27),('8998','2013-06-24','15:15:00',2.27),('8998','2013-06-24','15:20:00',2.19),('8998','2013-06-24','15:25:00',2.1),('8998','2013-06-24','15:30:00',2.05),('8998','2013-06-24','15:35:00',2),('8998','2013-06-24','15:40:00',1.94),('8998','2013-06-24','15:45:00',1.89),('8998','2013-06-24','15:50:00',1.84),('8998','2013-06-24','15:55:00',1.78),('8998','2013-06-24','16:00:00',1.74),('8998','2013-06-24','16:05:00',1.7),('8998','2013-06-24','16:10:00',1.65),('8998','2013-06-24','16:15:00',1.59),('8998','2013-06-24','16:20:00',1.54),('8998','2013-06-24','16:25:00',1.48),('8998','2013-06-24','16:30:00',1.43),('8998','2013-06-24','16:35:00',1.37),('8998','2013-06-24','16:40:00',1.32),('8998','2013-06-24','16:45:00',1.27),('8998','2013-06-24','16:50:00',1.22),('8998','2013-06-24','16:55:00',1.16),('8998','2013-06-24','17:00:00',1.1),('8998','2013-06-24','17:05:00',1.05),('8998','2013-06-23','08:45:00',1.89),('8998','2013-06-23','08:50:00',2.48),('8998','2013-06-23','08:55:00',2.49),('8998','2013-06-23','09:00:00',1.9),('8998','2013-06-23','09:05:00',2.05),('8998','2013-06-23','09:15:00',2.31),('8998','2013-06-23','09:20:00',2.71),('8998','2013-06-23','09:25:00',2.65),('8998','2013-06-23','09:30:00',2.46),('8998','2013-06-23','09:40:00',1.74),('8998','2013-06-23','09:45:00',1.88),('8998','2013-06-23','09:50:00',2.39),('8998','2013-06-23','09:55:00',3.04),('8998','2013-06-23','10:00:00',2.99),('8998','2013-06-23','10:05:00',2.98),('8998','2013-06-23','10:10:00',3.04),('8998','2013-06-23','10:15:00',3.2),('8998','2013-06-23','10:20:00',1.93),('8998','2013-06-23','10:25:00',3.3),('8998','2013-06-23','10:30:00',1.77),('8998','2013-06-23','10:35:00',2.56),('8998','2013-06-23','10:40:00',1.68),('8998','2013-06-23','10:45:00',1.95),('8998','2013-06-23','10:50:00',2.68),('8998','2013-06-23','10:55:00',2.46),('8998','2013-06-23','11:00:00',3.51),('8998','2013-06-23','11:05:00',2.81),('8998','2013-06-23','11:10:00',2.96),('8998','2013-06-23','11:15:00',1.78),('8998','2013-06-23','11:20:00',2.54),('8998','2013-06-23','11:25:00',1.05),('8998','2013-06-23','11:30:00',1.31),('8998','2013-06-23','11:45:00',1.13),('8998','2013-06-23','11:50:00',2.23),('8998','2013-06-23','11:55:00',2.8),('8998','2013-06-23','12:00:00',2.62),('8998','2013-06-23','12:05:00',2.75),('8998','2013-06-23','12:10:00',3.31),('8998','2013-06-23','12:15:00',2.79),('8998','2013-06-23','12:20:00',2.77),('8998','2013-06-23','12:25:00',1.83),('8998','2013-06-23','12:30:00',1.78),('8998','2013-06-23','12:35:00',3.48),('8998','2013-06-23','12:40:00',3.55),('8998','2013-06-23','12:45:00',1.59),('8998','2013-06-23','12:50:00',3.64),('8998','2013-06-23','12:55:00',3.54),('8998','2013-06-23','13:00:00',3.36),('8998','2013-06-23','13:05:00',3.4),('8998','2013-06-23','13:10:00',2.86),('8998','2013-06-23','13:15:00',2.22),('8998','2013-06-23','13:20:00',1.68),('8998','2013-06-23','13:25:00',2.86),('8998','2013-06-23','13:30:00',3.07),('8998','2013-06-23','13:35:00',2.7),('8998','2013-06-23','13:40:00',2.87),('8998','2013-06-23','13:45:00',3.06),('8998','2013-06-23','13:50:00',2.93),('8998','2013-06-23','13:55:00',2.86),('8998','2013-06-23','14:00:00',2.83),('8998','2013-06-23','14:05:00',2.82),('8998','2013-06-23','14:10:00',2.78),('8998','2013-06-23','14:15:00',2.73),('8998','2013-06-23','14:20:00',2.71),('8998','2013-06-23','14:25:00',2.68),('8998','2013-06-23','14:30:00',2.66),('8998','2013-06-23','14:35:00',2.6),('8998','2013-06-23','14:40:00',2.58),('8998','2013-06-23','14:45:00',2.58),('8998','2013-06-23','14:50:00',2.44),('8998','2013-06-23','14:55:00',2.69),('8998','2013-06-23','15:00:00',2.67),('8998','2013-06-23','15:05:00',1.87),('8998','2013-06-23','15:10:00',1.18),('8998','2013-06-23','15:15:00',2.23),('8998','2013-06-23','15:20:00',2.4),('8998','2013-06-23','15:25:00',2.15),('8998','2013-06-23','15:30:00',1.63),('8998','2013-06-23','15:35:00',1.94),('8998','2013-06-23','15:40:00',1.29),('8998','2013-06-23','15:45:00',2),('8998','2013-06-23','15:50:00',1.4),('8998','2013-06-23','15:55:00',1.66),('8998','2013-06-23','16:00:00',2.04),('8998','2013-06-23','16:05:00',1.94),('8998','2013-06-23','16:10:00',1.97),('8998','2013-06-23','16:15:00',1.96),('8998','2013-06-23','16:20:00',1.49),('8998','2013-06-23','16:25:00',1.34),('8998','2013-06-23','16:30:00',1.74),('8998','2013-06-23','16:35:00',1.39),('8998','2013-06-23','16:40:00',1.02),('8998','2013-06-23','16:45:00',1.11),('8998','2013-06-23','16:50:00',1.1),('8998','2013-06-23','17:10:00',1.13),('8998','2013-06-23','17:15:00',1.37),('8998','2013-06-23','17:20:00',1.2),('8998','2013-06-23','17:30:00',1.04),('8998','2013-06-22','08:50:00',1.36),('8998','2013-06-22','09:00:00',1.41),('8998','2013-06-22','09:05:00',1.38),('8998','2013-06-22','09:20:00',1.51),('8998','2013-06-22','09:25:00',2.5),('8998','2013-06-22','09:30:00',2.8),('8998','2013-06-22','09:35:00',2.78),('8998','2013-06-22','09:40:00',2.99),('8998','2013-06-22','09:45:00',1.95),('8998','2013-06-22','09:50:00',1.09),('8998','2013-06-22','09:55:00',1.07),('8998','2013-06-22','10:00:00',2.82),('8998','2013-06-22','10:05:00',3.04),('8998','2013-06-22','10:10:00',2.36),('8998','2013-06-22','10:15:00',2.7),('8998','2013-06-22','10:20:00',1.96),('8998','2013-06-22','10:25:00',1.18),('8998','2013-06-22','10:40:00',1.63),('8998','2013-06-22','10:45:00',3.18),('8998','2013-06-22','10:50:00',1.75),('8998','2013-06-22','10:55:00',3.05),('8998','2013-06-22','11:00:00',2.94),('8998','2013-06-22','11:05:00',2.96),('8998','2013-06-22','11:10:00',3.03),('8998','2013-06-22','11:15:00',3.02),('8998','2013-06-22','11:20:00',3.11),('8998','2013-06-22','11:25:00',3.02),('8998','2013-06-22','11:30:00',2.97),('8998','2013-06-22','11:35:00',3),('8998','2013-06-22','11:40:00',2.95),('8998','2013-06-22','11:45:00',2.97),('8998','2013-06-22','11:50:00',3.02),('8998','2013-06-22','11:55:00',3.04),('8998','2013-06-22','12:00:00',2.08),('8998','2013-06-22','12:05:00',2.18),('8998','2013-06-22','12:10:00',3.15),('8998','2013-06-22','12:15:00',3.08),('8998','2013-06-22','12:20:00',3.07),('8998','2013-06-22','12:25:00',2.98),('8998','2013-06-22','12:30:00',3.04),('8998','2013-06-22','12:35:00',3.02),('8998','2013-06-22','12:40:00',3),('8998','2013-06-22','12:45:00',2.98),('8998','2013-06-22','12:50:00',2.96),('8998','2013-06-22','12:55:00',2.95),('8998','2013-06-22','13:00:00',2.94),('8998','2013-06-22','13:05:00',2.94),('8998','2013-06-22','13:10:00',2.92),('8998','2013-06-22','13:15:00',2.89),('8998','2013-06-22','13:20:00',2.87),('8998','2013-06-22','13:25:00',2.85),('8998','2013-06-22','13:30:00',2.83),('8998','2013-06-22','13:35:00',2.82),('8998','2013-06-22','13:40:00',2.8),('8998','2013-06-22','13:45:00',2.78),('8998','2013-06-22','13:50:00',2.76),('8998','2013-06-22','13:55:00',2.73),('8998','2013-06-22','14:00:00',2.69),('8998','2013-06-22','14:05:00',2.67),('8998','2013-06-22','14:10:00',2.63),('8998','2013-06-22','14:15:00',2.6),('8998','2013-06-22','14:20:00',2.59),('8998','2013-06-22','14:25:00',2.57),('8998','2013-06-22','14:30:00',2.55),('8998','2013-06-22','14:35:00',2.52),('8998','2013-06-22','14:40:00',2.48),('8998','2013-06-22','14:45:00',2.44),('8998','2013-06-22','14:50:00',2.41),('8998','2013-06-22','14:55:00',2.38),('8998','2013-06-22','15:00:00',2.34),('8998','2013-06-22','15:05:00',2.3),('8998','2013-06-22','15:10:00',2.26),('8998','2013-06-22','15:15:00',2.22),('8998','2013-06-22','15:20:00',2.17),('8998','2013-06-22','15:25:00',2.12),('8998','2013-06-22','15:30:00',2.06),('8998','2013-06-22','15:35:00',2),('8998','2013-06-22','15:40:00',1.97),('8998','2013-06-22','15:45:00',1.92),('8998','2013-06-22','15:50:00',1.87),('8998','2013-06-22','15:55:00',1.82),('8998','2013-06-22','16:00:00',1.76),('8998','2013-06-22','16:05:00',1.72),('8998','2013-06-22','16:10:00',1.65),('8998','2013-06-22','16:15:00',1.6),('8998','2013-06-22','16:20:00',1.54),('8998','2013-06-22','16:25:00',1.48),('8998','2013-06-22','16:30:00',1.43),('8998','2013-06-22','16:35:00',1.38),('8998','2013-06-22','16:40:00',1.33),('8998','2013-06-22','16:45:00',1.27),('8998','2013-06-22','16:50:00',1.21),('8998','2013-06-22','16:55:00',1.15),('8998','2013-06-22','17:00:00',1.1),('8998','2013-06-22','17:05:00',1.04),('8998','2013-06-21','07:40:00',1.13),('8998','2013-06-21','07:45:00',1.25),('8998','2013-06-21','07:50:00',1.27),('8998','2013-06-21','07:55:00',1.28),('8998','2013-06-21','08:00:00',1.32),('8998','2013-06-21','08:05:00',1.32),('8998','2013-06-21','08:10:00',1.38),('8998','2013-06-21','08:15:00',1.39),('8998','2013-06-21','08:20:00',1.45),('8998','2013-06-21','08:25:00',1.58),('8998','2013-06-21','08:30:00',1.69),('8998','2013-06-21','08:35:00',1.63),('8998','2013-06-21','08:40:00',1.69),('8998','2013-06-21','08:45:00',1.81),('8998','2013-06-21','08:50:00',2),('8998','2013-06-21','08:55:00',1.96),('8998','2013-06-21','09:00:00',1.85),('8998','2013-06-21','09:05:00',1.98),('8998','2013-06-21','09:10:00',2.19),('8998','2013-06-21','09:15:00',2.36),('8998','2013-06-21','09:20:00',2.42),('8998','2013-06-21','09:25:00',2.44),('8998','2013-06-21','09:30:00',2.45),('8998','2013-06-21','09:35:00',2.5),('8998','2013-06-21','09:40:00',2.53),('8998','2013-06-21','09:45:00',2.56),('8998','2013-06-21','09:50:00',2.58),('8998','2013-06-21','09:55:00',2.6),('8998','2013-06-21','10:00:00',2.64),('8998','2013-06-21','10:05:00',2.67),('8998','2013-06-21','10:10:00',2.69),('8998','2013-06-21','10:15:00',2.72),('8998','2013-06-21','10:20:00',2.74),('8998','2013-06-21','10:25:00',2.77),('8998','2013-06-21','10:30:00',2.76),('8998','2013-06-21','10:35:00',2.78),('8998','2013-06-21','10:40:00',2.81),('8998','2013-06-21','10:45:00',2.85),('8998','2013-06-21','10:50:00',2.86),('8998','2013-06-21','10:55:00',2.85),('8998','2013-06-21','11:00:00',2.86),('8998','2013-06-21','11:05:00',2.87),('8998','2013-06-21','11:10:00',2.89),('8998','2013-06-21','11:15:00',2.9),('8998','2013-06-21','11:20:00',2.92),('8998','2013-06-21','11:25:00',2.91),('8998','2013-06-21','11:30:00',2.9),('8998','2013-06-21','11:35:00',2.92),('8998','2013-06-21','11:40:00',2.91),('8998','2013-06-21','11:45:00',2.9),('8998','2013-06-21','11:50:00',2.9),('8998','2013-06-21','11:55:00',2.89),('8998','2013-06-21','12:00:00',2.9),('8998','2013-06-21','12:05:00',2.85),('8998','2013-06-21','12:10:00',2.78),('8998','2013-06-21','12:15:00',2.89),('8998','2013-06-21','12:20:00',2.89),('8998','2013-06-21','12:25:00',2.83),('8998','2013-06-21','12:30:00',2.86),('8998','2013-06-21','12:35:00',2.87),('8998','2013-06-21','12:40:00',2.87),('8998','2013-06-21','12:45:00',2.83),('8998','2013-06-21','12:50:00',2.76),('8998','2013-06-21','12:55:00',2.73),('8998','2013-06-21','13:00:00',2.69),('8998','2013-06-21','13:05:00',2.69),('8998','2013-06-21','13:10:00',2.64),('8998','2013-06-21','13:15:00',2.58),('8998','2013-06-21','13:20:00',2.48),('8998','2013-06-21','13:25:00',2.57),('8998','2013-06-21','13:30:00',2.81),('8998','2013-06-21','13:35:00',2.79),('8998','2013-06-21','13:40:00',2.55),('8998','2013-06-21','13:45:00',2.53),('8998','2013-06-21','13:50:00',2.71),('8998','2013-06-21','13:55:00',2.11),('8998','2013-06-21','14:00:00',1.4),('8998','2013-06-21','14:05:00',2.9),('8998','2013-06-21','14:10:00',2.74),('8998','2013-06-21','14:15:00',2.69),('8998','2013-06-21','14:20:00',2.12),('8998','2013-06-21','14:25:00',2.62),('8998','2013-06-21','14:30:00',1.89),('8998','2013-06-21','14:35:00',1.43),('8998','2013-06-21','14:40:00',1.1),('8998','2013-06-21','14:45:00',1.27),('8998','2013-06-21','14:50:00',2.04),('8998','2013-06-21','14:55:00',2.53),('8998','2013-06-21','15:00:00',2.33),('8998','2013-06-21','15:05:00',2.04),('8998','2013-06-21','15:10:00',2.12),('8998','2013-06-21','15:15:00',2.35),('8998','2013-06-21','15:20:00',2.13),('8998','2013-06-21','15:25:00',1.97),('8998','2013-06-21','15:30:00',1.27),('8998','2013-06-21','15:35:00',1.17),('8998','2013-06-21','15:40:00',1.12),('8998','2013-06-21','15:45:00',1.47),('8998','2013-06-21','15:50:00',1.49),('8998','2013-06-21','15:55:00',1.45),('8998','2013-06-21','16:00:00',1.28),('8998','2013-06-21','16:20:00',1.17),('8998','2013-06-21','17:10:00',1.06),('8998','2013-06-21','17:15:00',1.43),('8998','2013-06-21','17:20:00',1.34),('8998','2013-06-21','17:25:00',1.27),('8998','2013-06-21','17:30:00',1.06),('8998','2013-06-20','07:40:00',1.13),('8998','2013-06-20','07:45:00',1.27),('8998','2013-06-20','07:50:00',1.31),('8998','2013-06-20','07:55:00',1.32),('8998','2013-06-20','08:00:00',1.36),('8998','2013-06-20','08:05:00',1.38),('8998','2013-06-20','08:10:00',1.42),('8998','2013-06-20','08:15:00',1.42),('8998','2013-06-20','08:20:00',1.46),('8998','2013-06-20','08:25:00',1.59),('8998','2013-06-20','08:30:00',1.69),('8998','2013-06-20','08:35:00',1.62),('8998','2013-06-20','08:40:00',1.68),('8998','2013-06-20','08:45:00',1.58),('8998','2013-06-20','08:50:00',1.77),('8998','2013-06-20','08:55:00',1.85),('8998','2013-06-20','09:00:00',1.83),('8998','2013-06-20','09:05:00',1.96),('8998','2013-06-20','09:10:00',2.14),('8998','2013-06-20','09:15:00',2.28),('8998','2013-06-20','09:20:00',2.32),('8998','2013-06-20','09:25:00',2.37),('8998','2013-06-20','09:30:00',2.39),('8998','2013-06-20','09:35:00',2.41),('8998','2013-06-20','09:40:00',2.42),('8998','2013-06-20','09:45:00',2.46),('8998','2013-06-20','09:50:00',2.5),('8998','2013-06-20','09:55:00',2.49),('8998','2013-06-20','10:00:00',2.5),('8998','2013-06-20','10:05:00',2.51),('8998','2013-06-20','10:10:00',2.55),('8998','2013-06-20','10:15:00',2.57),('8998','2013-06-20','10:20:00',2.59),('8998','2013-06-20','10:25:00',2.59),('8998','2013-06-20','10:30:00',2.63),('8998','2013-06-20','10:35:00',2.65),('8998','2013-06-20','10:40:00',2.63),('8998','2013-06-20','10:45:00',2.63),('8998','2013-06-20','10:50:00',2.69),('8998','2013-06-20','10:55:00',2.71),('8998','2013-06-20','11:00:00',2.7),('8998','2013-06-20','11:05:00',2.69),('8998','2013-06-20','11:10:00',2.68),('8998','2013-06-20','11:15:00',2.75),('8998','2013-06-20','11:20:00',2.77),('8998','2013-06-20','11:25:00',2.78),('8998','2013-06-20','11:30:00',2.78),('8998','2013-06-20','11:35:00',2.75),('8998','2013-06-20','11:40:00',2.78),('8998','2013-06-20','11:45:00',2.77),('8998','2013-06-20','11:50:00',2.8),('8998','2013-06-20','11:55:00',2.81),('8998','2013-06-20','12:00:00',2.79),('8998','2013-06-20','12:05:00',2.79),('8998','2013-06-20','12:10:00',2.77),('8998','2013-06-20','12:15:00',2.76),('8998','2013-06-20','12:20:00',2.74),('8998','2013-06-20','12:25:00',2.7),('8998','2013-06-20','12:30:00',2.78),('8998','2013-06-20','12:35:00',2.74),('8998','2013-06-20','12:40:00',2.7),('8998','2013-06-20','12:45:00',2.71),('8998','2013-06-20','12:50:00',2.67),('8998','2013-06-20','12:55:00',2.66),('8998','2013-06-20','13:00:00',2.65),('8998','2013-06-20','13:05:00',2.59),('8998','2013-06-20','13:10:00',2.58),('8998','2013-06-20','13:15:00',2.61),('8998','2013-06-20','13:20:00',2.6),('8998','2013-06-20','13:25:00',2.61),('8998','2013-06-20','13:30:00',2.61),('8998','2013-06-20','13:35:00',2.62),('8998','2013-06-20','13:40:00',2.58),('8998','2013-06-20','13:45:00',2.54),('8998','2013-06-20','13:50:00',2.53),('8998','2013-06-20','13:55:00',2.54),('8998','2013-06-20','14:00:00',2.51),('8998','2013-06-20','14:05:00',2.52),('8998','2013-06-20','14:10:00',2.47),('8998','2013-06-20','14:15:00',2.43),('8998','2013-06-20','14:20:00',2.42),('8998','2013-06-20','14:25:00',2.39),('8998','2013-06-20','14:30:00',2.37),('8998','2013-06-20','14:35:00',2.35),('8998','2013-06-20','14:40:00',2.31),('8998','2013-06-20','14:45:00',2.29),('8998','2013-06-20','14:50:00',2.25),('8998','2013-06-20','14:55:00',2.22),('8998','2013-06-20','15:00:00',2.18),('8998','2013-06-20','15:05:00',2.14),('8998','2013-06-20','15:10:00',2.09),('8998','2013-06-20','15:15:00',2.05),('8998','2013-06-20','15:20:00',2.01),('8998','2013-06-20','15:25:00',1.97),('8998','2013-06-20','15:30:00',1.93),('8998','2013-06-20','15:35:00',1.88),('8998','2013-06-20','15:40:00',1.84),('8998','2013-06-20','15:45:00',1.79),('8998','2013-06-20','15:50:00',1.75),('8998','2013-06-20','15:55:00',1.7),('8998','2013-06-20','16:00:00',1.65),('8998','2013-06-20','16:05:00',1.6),('8998','2013-06-20','16:10:00',1.56),('8998','2013-06-20','16:15:00',1.51),('8998','2013-06-20','16:20:00',1.45),('8998','2013-06-20','16:25:00',1.41),('8998','2013-06-20','16:30:00',1.36),('8998','2013-06-20','16:35:00',1.3),('8998','2013-06-20','16:40:00',1.25),('8998','2013-06-20','16:45:00',1.2),('8998','2013-06-20','16:50:00',1.14),('8998','2013-06-20','16:55:00',1.09),('8998','2013-06-20','17:00:00',1.03),('8998','2014-04-03','09:10:00',1.1),('8998','2014-04-03','13:20:00',1.04),('8998','2014-04-03','13:25:00',1.88),('8998','2014-04-03','13:30:00',1.37),('8998','2014-04-03','13:35:00',1.98),('8998','2014-04-03','13:40:00',2.36),('8998','2014-04-03','13:45:00',2.26),('8998','2014-04-03','13:50:00',2.03),('8998','2014-04-03','13:55:00',1.92),('8998','2014-04-03','14:00:00',1.21),('8998','2014-04-03','14:05:00',3.06),('8998','2014-04-03','14:10:00',1.93),('8998','2014-04-03','14:15:00',2.84),('8998','2014-04-03','14:20:00',2.09),('8998','2014-04-03','14:25:00',2.12),('8998','2014-04-03','14:35:00',1.51),('8998','2014-04-03','14:40:00',1.27),('8998','2014-04-03','14:50:00',1.58),('8998','2014-04-03','14:55:00',1.82),('8998','2014-04-03','15:00:00',2.22),('8998','2014-04-03','15:05:00',2.14),('8998','2014-04-03','15:10:00',2.19),('8998','2014-04-03','15:15:00',1.43),('8998','2014-04-03','15:20:00',1.31),('8998','2014-04-03','15:25:00',1.06),('8998','2014-04-03','15:40:00',1.08),('8998','2014-04-03','15:45:00',1.18),('8998','2014-04-03','15:50:00',1.05),('8998','2014-04-03','15:55:00',1.46),('8998','2014-04-03','16:00:00',1.57),('8998','2014-04-03','16:05:00',1.24),('8998','2014-04-03','16:10:00',1.47),('8998','2014-04-03','16:15:00',1.09),('8998','2014-04-03','16:35:00',1.05),('8998','2014-04-03','16:45:00',1.22),('8998','2014-04-03','16:50:00',1.38),('8998','2013-06-19','07:30:00',1.04),('8998','2013-06-19','07:45:00',1.11),('8998','2013-06-19','07:50:00',1.22),('8998','2013-06-19','07:55:00',1.4),('8998','2013-06-19','08:00:00',1.48),('8998','2013-06-19','08:05:00',1.64),('8998','2013-06-19','08:10:00',1.7),('8998','2013-06-19','08:15:00',1.77),('8998','2013-06-19','08:20:00',1.73),('8998','2013-06-19','08:25:00',1.65),('8998','2013-06-19','08:30:00',1.65),('8998','2013-06-19','08:35:00',1.57),('8998','2013-06-19','08:40:00',1.64),('8998','2013-06-19','08:45:00',1.85),('8998','2013-06-19','08:50:00',2),('8998','2013-06-19','08:55:00',1.92),('8998','2013-06-19','09:00:00',1.79),('8998','2013-06-19','09:05:00',1.98),('8998','2013-06-19','09:10:00',2.24),('8998','2013-06-19','09:15:00',2.36),('8998','2013-06-19','09:20:00',2.42),('8998','2013-06-19','09:25:00',2.45),('8998','2013-06-19','09:30:00',2.48),('8998','2013-06-19','09:35:00',2.51),('8998','2013-06-19','09:40:00',2.53),('8998','2013-06-19','09:45:00',2.52),('8998','2013-06-19','09:50:00',2.57),('8998','2013-06-19','09:55:00',2.6),('8998','2013-06-19','10:00:00',2.64),('8998','2013-06-19','10:05:00',2.66),('8998','2013-06-19','10:10:00',2.69),('8998','2013-06-19','10:15:00',2.69),('8998','2013-06-19','10:20:00',2.71),('8998','2013-06-19','10:25:00',2.74),('8998','2013-06-19','10:30:00',2.74),('8998','2013-06-19','10:35:00',2.78),('8998','2013-06-19','10:40:00',2.77),('8998','2013-06-19','10:45:00',2.78),('8998','2013-06-19','10:50:00',2.76),('8998','2013-06-19','10:55:00',2.77),('8998','2013-06-19','11:00:00',2.79),('8998','2013-06-19','11:05:00',2.82),('8998','2013-06-19','11:10:00',2.83),('8998','2013-06-19','11:15:00',2.81),('8998','2013-06-19','11:20:00',2.82),('8998','2013-06-19','11:25:00',2.76),('8998','2013-06-19','11:30:00',2.77),('8998','2013-06-19','11:35:00',2.81),('8998','2013-06-19','11:40:00',2.82),('8998','2013-06-19','11:45:00',2.79),('8998','2013-06-19','11:50:00',2.8),('8998','2013-06-19','11:55:00',2.77),('8998','2013-06-19','12:00:00',2.75),('8998','2013-06-19','12:05:00',2.73),('8998','2013-06-19','12:10:00',2.72),('8998','2013-06-19','12:15:00',2.71),('8998','2013-06-19','12:20:00',2.65),('8998','2013-06-19','12:25:00',2.63),('8998','2013-06-19','12:30:00',2.6),('8998','2013-06-19','12:35:00',2.79),('8998','2013-06-19','12:40:00',2.77),('8998','2013-06-19','12:45:00',2.63),('8998','2013-06-19','12:50:00',2.75),('8998','2013-06-19','12:55:00',2.55),('8998','2013-06-19','13:00:00',1.45),('8998','2013-06-19','13:05:00',2.17),('8998','2013-06-19','13:10:00',2.84),('8998','2013-06-19','13:15:00',2.77),('8998','2013-06-19','13:20:00',2.64),('8998','2013-06-19','13:25:00',2.63),('8998','2013-06-19','13:30:00',2.18),('8998','2013-06-19','13:35:00',2.58),('8998','2013-06-19','13:40:00',2.59),('8998','2013-06-19','13:45:00',2.6),('8998','2013-06-19','13:50:00',2.55),('8998','2013-06-19','13:55:00',2.51),('8998','2013-06-19','14:00:00',2.52),('8998','2013-06-19','14:05:00',2.55),('8998','2013-06-19','14:10:00',2.53),('8998','2013-06-19','14:15:00',2.49),('8998','2013-06-19','14:20:00',2.46),('8998','2013-06-19','14:25:00',2.43),('8998','2013-06-19','14:30:00',2.39),('8998','2013-06-19','14:35:00',2.39),('8998','2013-06-19','14:40:00',2.39),('8998','2013-06-19','14:45:00',2.34),('8998','2013-06-19','14:50:00',2.32),('8998','2013-06-19','14:55:00',2.28),('8998','2013-06-19','15:00:00',2.24),('8998','2013-06-19','15:05:00',2.19),('8998','2013-06-19','15:10:00',2.15),('8998','2013-06-19','15:15:00',2.11),('8998','2013-06-19','15:20:00',2.06),('8998','2013-06-19','15:25:00',2.02),('8998','2013-06-19','15:30:00',1.98),('8998','2013-06-19','15:35:00',1.93),('8998','2013-06-19','15:40:00',1.88),('8998','2013-06-19','15:45:00',1.83),('8998','2013-06-19','15:50:00',1.78),('8998','2013-06-19','15:55:00',1.73),('8998','2013-06-19','16:00:00',1.68),('8998','2013-06-19','16:05:00',1.64),('8998','2013-06-19','16:10:00',1.59),('8998','2013-06-19','16:15:00',1.53),('8998','2013-06-19','16:20:00',1.47),('8998','2013-06-19','16:25:00',1.42),('8998','2013-06-19','16:30:00',1.37),('8998','2013-06-19','16:35:00',1.31),('8998','2013-06-19','16:40:00',1.26),('8998','2013-06-19','16:45:00',1.19),('8998','2013-06-19','16:50:00',1.14),('8998','2013-06-19','16:55:00',1.1),('8998','2013-06-19','17:00:00',1.04),('8998','2013-06-18','07:40:00',1.07),('8998','2013-06-18','07:45:00',1.2),('8998','2013-06-18','07:50:00',1.22),('8998','2013-06-18','07:55:00',1.23),('8998','2013-06-18','08:00:00',1.26),('8998','2013-06-18','08:05:00',1.28),('8998','2013-06-18','08:10:00',1.33),('8998','2013-06-18','08:15:00',1.34),('8998','2013-06-18','08:20:00',1.66),('8998','2013-06-18','08:25:00',1.6),('8998','2013-06-18','08:30:00',1.6),('8998','2013-06-18','08:35:00',1.55),('8998','2013-06-18','08:40:00',1.61),('8998','2013-06-18','08:45:00',1.79),('8998','2013-06-18','08:50:00',1.95),('8998','2013-06-18','08:55:00',1.89),('8998','2013-06-18','09:00:00',1.77),('8998','2013-06-18','09:05:00',1.95),('8998','2013-06-18','09:10:00',2.16),('8998','2013-06-18','09:15:00',2.32),('8998','2013-06-18','09:20:00',2.37),('8998','2013-06-18','09:25:00',2.39),('8998','2013-06-18','09:30:00',2.42),('8998','2013-06-18','09:35:00',2.45),('8998','2013-06-18','09:40:00',2.47),('8998','2013-06-18','09:45:00',2.5),('8998','2013-06-18','09:50:00',2.52),('8998','2013-06-18','09:55:00',2.55),('8998','2013-06-18','10:00:00',2.56),('8998','2013-06-18','10:05:00',2.58),('8998','2013-06-18','10:10:00',2.6),('8998','2013-06-18','10:15:00',2.63),('8998','2013-06-18','10:20:00',2.65),('8998','2013-06-18','10:25:00',2.65),('8998','2013-06-18','10:30:00',2.64),('8998','2013-06-18','10:35:00',2.65),('8998','2013-06-18','10:40:00',2.65),('8998','2013-06-18','10:45:00',2.69),('8998','2013-06-18','10:50:00',2.69),('8998','2013-06-18','10:55:00',2.7),('8998','2013-06-18','11:00:00',2.67),('8998','2013-06-18','11:05:00',2.71),('8998','2013-06-18','11:10:00',2.72),('8998','2013-06-18','11:15:00',2.71),('8998','2013-06-18','11:20:00',2.71),('8998','2013-06-18','11:25:00',2.69),('8998','2013-06-18','11:30:00',2.7),('8998','2013-06-18','11:35:00',2.73),('8998','2013-06-18','11:40:00',2.76),('8998','2013-06-18','11:45:00',2.75),('8998','2013-06-18','11:50:00',2.71),('8998','2013-06-18','11:55:00',2.68),('8998','2013-06-18','12:00:00',2.73),('8998','2013-06-18','12:05:00',2.68),('8998','2013-06-18','12:10:00',2.73),('8998','2013-06-18','12:15:00',2.7),('8998','2013-06-18','12:20:00',2.71),('8998','2013-06-18','12:25:00',2.71),('8998','2013-06-18','12:30:00',2.73),('8998','2013-06-18','12:35:00',2.73),('8998','2013-06-18','12:40:00',2.68),('8998','2013-06-18','12:45:00',2.71),('8998','2013-06-18','12:50:00',2.69),('8998','2013-06-18','12:55:00',2.68),('8998','2013-06-18','13:00:00',2.64),('8998','2013-06-18','13:05:00',2.62),('8998','2013-06-18','13:10:00',2.61),('8998','2013-06-18','13:15:00',2.61),('8998','2013-06-18','13:20:00',2.57),('8998','2013-06-18','13:25:00',2.61),('8998','2013-06-18','13:30:00',2.61),('8998','2013-06-18','13:35:00',2.59),('8998','2013-06-18','13:40:00',2.58),('8998','2013-06-18','13:45:00',2.55),('8998','2013-06-18','13:50:00',2.51),('8998','2013-06-18','13:55:00',2.53),('8998','2013-06-18','14:00:00',2.52),('8998','2013-06-18','14:05:00',2.49),('8998','2013-06-18','14:10:00',2.45),('8998','2013-06-18','14:15:00',2.41),('8998','2013-06-18','14:20:00',2.37),('8998','2013-06-18','14:25:00',2.34),('8998','2013-06-18','14:30:00',2.31),('8998','2013-06-18','14:35:00',2.27),('8998','2013-06-18','14:40:00',2.24),('8998','2013-06-18','14:45:00',2.21),('8998','2013-06-18','14:50:00',2.18),('8998','2013-06-18','14:55:00',2.14),('8998','2013-06-18','15:00:00',2.12),('8998','2013-06-18','15:05:00',2.08),('8998','2013-06-18','15:10:00',2.04),('8998','2013-06-18','15:15:00',2),('8998','2013-06-18','15:20:00',1.97),('8998','2013-06-18','15:25:00',1.94),('8998','2013-06-18','15:30:00',1.9),('8998','2013-06-18','15:35:00',1.85),('8998','2013-06-18','15:40:00',1.8),('8998','2013-06-18','15:45:00',1.76),('8998','2013-06-18','15:50:00',1.7),('8998','2013-06-18','15:55:00',1.65),('8998','2013-06-18','16:00:00',1.6),('8998','2013-06-18','16:05:00',1.55),('8998','2013-06-18','16:10:00',1.51),('8998','2013-06-18','16:15:00',1.46),('8998','2013-06-18','16:20:00',1.4),('8998','2013-06-18','16:25:00',1.36),('8998','2013-06-18','16:30:00',1.31),('8998','2013-06-18','16:35:00',1.26),('8998','2013-06-18','16:40:00',1.21),('8998','2013-06-18','16:45:00',1.16),('8998','2013-06-18','16:50:00',1.11),('8998','2013-06-18','16:55:00',1.07),('8998','2013-06-18','17:00:00',1.02),('8998','2013-06-17','07:40:00',1.08),('8998','2013-06-17','07:45:00',1.2),('8998','2013-06-17','07:50:00',1.22),('8998','2013-06-17','07:55:00',1.22),('8998','2013-06-17','08:00:00',1.25),('8998','2013-06-17','08:05:00',1.27),('8998','2013-06-17','08:10:00',1.33),('8998','2013-06-17','08:15:00',1.33),('8998','2013-06-17','08:20:00',1.39),('8998','2013-06-17','08:25:00',1.55),('8998','2013-06-17','08:30:00',1.6),('8998','2013-06-17','08:35:00',1.54),('8998','2013-06-17','08:40:00',1.6),('8998','2013-06-17','08:45:00',1.64),('8998','2013-06-17','08:50:00',1.92),('8998','2013-06-17','08:55:00',1.87),('8998','2013-06-17','09:00:00',1.75),('8998','2013-06-17','09:05:00',1.94),('8998','2013-06-17','09:10:00',2.12),('8998','2013-06-17','09:15:00',2.3),('8998','2013-06-17','09:20:00',2.34),('8998','2013-06-17','09:25:00',2.38),('8998','2013-06-17','09:30:00',2.4),('8998','2013-06-17','09:35:00',2.42),('8998','2013-06-17','09:40:00',2.45),('8998','2013-06-17','09:45:00',2.45),('8998','2013-06-17','09:50:00',2.48),('8998','2013-06-17','09:55:00',2.49),('8998','2013-06-17','10:00:00',2.52),('8998','2013-06-17','10:05:00',2.52),('8998','2013-06-17','10:10:00',2.56),('8998','2013-06-17','10:15:00',2.59),('8998','2013-06-17','10:20:00',2.62),('8998','2013-06-17','10:25:00',2.63),('8998','2013-06-17','10:30:00',2.61),('8998','2013-06-17','10:35:00',2.59),('8998','2013-06-17','10:40:00',2.63),('8998','2013-06-17','10:45:00',2.66),('8998','2013-06-17','10:50:00',2.67),('8998','2013-06-17','10:55:00',2.7),('8998','2013-06-17','11:00:00',2.71),('8998','2013-06-17','11:05:00',2.72),('8998','2013-06-17','11:10:00',2.74),('8998','2013-06-17','11:15:00',2.75),('8998','2013-06-17','11:20:00',2.74),('8998','2013-06-17','11:25:00',2.74),('8998','2013-06-17','11:30:00',2.76),('8998','2013-06-17','11:35:00',2.76),('8998','2013-06-17','11:40:00',2.7),('8998','2013-06-17','11:45:00',2.71),('8998','2013-06-17','11:50:00',2.73),('8998','2013-06-17','11:55:00',2.7),('8998','2013-06-17','12:00:00',2.67),('8998','2013-06-17','12:05:00',2.67),('8998','2013-06-17','12:10:00',2.65),('8998','2013-06-17','12:15:00',2.61),('8998','2013-06-17','12:20:00',2.62),('8998','2013-06-17','12:25:00',2.62),('8998','2013-06-17','12:30:00',2.64),('8998','2013-06-17','12:35:00',2.62),('8998','2013-06-17','12:40:00',2.5),('8998','2013-06-17','12:45:00',2.03),('8998','2013-06-17','12:50:00',1.63),('8998','2013-06-17','12:55:00',2.61),('8998','2013-06-17','13:00:00',2.69),('8998','2013-06-17','13:05:00',1.51),('8998','2013-06-17','13:10:00',1.87),('8998','2013-06-17','13:15:00',2.72),('8998','2013-06-17','13:20:00',2.73),('8998','2013-06-17','13:25:00',2.72),('8998','2013-06-17','13:30:00',1.73),('8998','2013-06-17','13:35:00',2.6),('8998','2013-06-17','13:40:00',2.61),('8998','2013-06-17','13:45:00',2.59),('8998','2013-06-17','13:50:00',2.6),('8998','2013-06-17','13:55:00',2.63),('8998','2013-06-17','14:00:00',2.58),('8998','2013-06-17','14:05:00',2.59),('8998','2013-06-17','14:10:00',2.53),('8998','2013-06-17','14:15:00',2.48),('8998','2013-06-17','14:20:00',2.42),('8998','2013-06-17','14:25:00',2.41),('8998','2013-06-17','14:30:00',2.38),('8998','2013-06-17','14:35:00',2.37),('8998','2013-06-17','14:40:00',2.37),('8998','2013-06-17','14:45:00',2.3),('8998','2013-06-17','14:50:00',2.27),('8998','2013-06-17','14:55:00',2.23),('8998','2013-06-17','15:00:00',2.21),('8998','2013-06-17','15:05:00',2.15),('8998','2013-06-17','15:10:00',2.1),('8998','2013-06-17','15:15:00',2.06),('8998','2013-06-17','15:20:00',2.02),('8998','2013-06-17','15:25:00',1.99),('8998','2013-06-17','15:30:00',1.95),('8998','2013-06-17','15:35:00',1.92),('8998','2013-06-17','15:40:00',1.9),('8998','2013-06-17','15:45:00',1.88),('8998','2013-06-17','15:50:00',1.83),('8998','2013-06-17','15:55:00',1.81),('8998','2013-06-17','16:00:00',1.78),('8998','2013-06-17','16:05:00',1.75),('8998','2013-06-17','16:10:00',1.71),('8998','2013-06-17','16:15:00',1.67),('8998','2013-06-17','16:20:00',1.6),('8998','2013-06-17','16:25:00',1.47),('8998','2013-06-17','16:30:00',1.37),('8998','2013-06-17','16:35:00',1.34),('8998','2013-06-17','16:40:00',1.29),('8998','2013-06-17','16:45:00',1.21),('8998','2013-06-17','16:50:00',1.15),('8998','2013-06-17','16:55:00',1.1),('8998','2013-06-17','17:00:00',1.05),('8998','2013-06-16','07:35:00',1.01),('8998','2013-06-16','07:40:00',1.18),('8998','2013-06-16','07:45:00',1.28),('8998','2013-06-16','07:50:00',1.39),('8998','2013-06-16','07:55:00',1.54),('8998','2013-06-16','08:00:00',1.64),('8998','2013-06-16','08:05:00',1.71),('8998','2013-06-16','08:10:00',1.76),('8998','2013-06-16','08:15:00',1.81),('8998','2013-06-16','08:20:00',1.73),('8998','2013-06-16','08:25:00',1.66),('8998','2013-06-16','08:30:00',1.65),('8998','2013-06-16','08:35:00',1.6),('8998','2013-06-16','08:40:00',1.64),('8998','2013-06-16','08:45:00',1.85),('8998','2013-06-16','08:50:00',2.01),('8998','2013-06-16','08:55:00',1.94),('8998','2013-06-16','09:00:00',1.82),('8998','2013-06-16','09:05:00',2.04),('8998','2013-06-16','09:10:00',2.27),('8998','2013-06-16','09:15:00',2.4),('8998','2013-06-16','09:20:00',2.43),('8998','2013-06-16','09:25:00',2.47),('8998','2013-06-16','09:30:00',2.51),('8998','2013-06-16','09:35:00',2.54),('8998','2013-06-16','09:40:00',2.56),('8998','2013-06-16','09:45:00',2.59),('8998','2013-06-16','09:50:00',2.62),('8998','2013-06-16','09:55:00',2.63),('8998','2013-06-16','10:00:00',2.65),('8998','2013-06-16','10:05:00',2.66),('8998','2013-06-16','10:10:00',2.68),('8998','2013-06-16','10:15:00',2.7),('8998','2013-06-16','10:20:00',2.72),('8998','2013-06-16','10:25:00',2.74),('8998','2013-06-16','10:30:00',2.75),('8998','2013-06-16','10:35:00',2.76),('8998','2013-06-16','10:40:00',2.78),('8998','2013-06-16','10:45:00',2.8),('8998','2013-06-16','10:50:00',2.8),('8998','2013-06-16','10:55:00',2.83),('8998','2013-06-16','11:00:00',2.81),('8998','2013-06-16','11:05:00',2.81),('8998','2013-06-16','11:10:00',2.81),('8998','2013-06-16','11:15:00',2.81),('8998','2013-06-16','11:20:00',2.84),('8998','2013-06-16','11:25:00',2.84),('8998','2013-06-16','11:30:00',2.83),('8998','2013-06-16','11:35:00',2.83),('8998','2013-06-16','11:40:00',2.81),('8998','2013-06-16','11:45:00',2.81),('8998','2013-06-16','11:50:00',2.79),('8998','2013-06-16','11:55:00',2.78),('8998','2013-06-16','12:00:00',2.77),('8998','2013-06-16','12:05:00',2.78),('8998','2013-06-16','12:10:00',2.78),('8998','2013-06-16','12:15:00',2.78),('8998','2013-06-16','12:20:00',2.79),('8998','2013-06-16','12:25:00',2.76),('8998','2013-06-16','12:30:00',2.75),('8998','2013-06-16','12:35:00',2.74),('8998','2013-06-16','12:40:00',2.73),('8998','2013-06-16','12:45:00',2.71),('8998','2013-06-16','12:50:00',2.72),('8998','2013-06-16','12:55:00',2.72),('8998','2013-06-16','13:00:00',2.74),('8998','2013-06-16','13:05:00',2.73),('8998','2013-06-16','13:10:00',2.71),('8998','2013-06-16','13:15:00',2.71),('8998','2013-06-16','13:20:00',2.67),('8998','2013-06-16','13:25:00',2.65),('8998','2013-06-16','13:30:00',2.65),('8998','2013-06-16','13:35:00',2.62),('8998','2013-06-16','13:40:00',2.6),('8998','2013-06-16','13:45:00',2.57),('8998','2013-06-16','13:50:00',2.54),('8998','2013-06-16','13:55:00',2.53),('8998','2013-06-16','14:00:00',2.51),('8998','2013-06-16','14:05:00',2.49),('8998','2013-06-16','14:10:00',2.46),('8998','2013-06-16','14:15:00',2.44),('8998','2013-06-16','14:20:00',2.43),('8998','2013-06-16','14:25:00',2.39),('8998','2013-06-16','14:30:00',2.36),('8998','2013-06-16','14:35:00',2.34),('8998','2013-06-16','14:40:00',2.31),('8998','2013-06-16','14:45:00',2.27),('8998','2013-06-16','14:50:00',2.23),('8998','2013-06-16','14:55:00',2.19),('8998','2013-06-16','15:00:00',2.15),('8998','2013-06-16','15:05:00',2.1),('8998','2013-06-16','15:10:00',2.06),('8998','2013-06-16','15:15:00',2.02),('8998','2013-06-16','15:20:00',1.99),('8998','2013-06-16','15:25:00',1.94),('8998','2013-06-16','15:30:00',1.91),('8998','2013-06-16','15:35:00',1.88),('8998','2013-06-16','15:40:00',1.82),('8998','2013-06-16','15:45:00',1.78),('8998','2013-06-16','15:50:00',1.74),('8998','2013-06-16','15:55:00',1.69),('8998','2013-06-16','16:00:00',1.65),('8998','2013-06-16','16:05:00',1.6),('8998','2013-06-16','16:10:00',1.56),('8998','2013-06-16','16:15:00',1.51),('8998','2013-06-16','16:20:00',1.47),('8998','2013-06-16','16:25:00',1.42),('8998','2013-06-16','16:30:00',1.37),('8998','2013-06-16','16:35:00',1.33),('8998','2013-06-16','16:40:00',1.28),('8998','2013-06-16','16:45:00',1.23),('8998','2013-06-16','16:50:00',1.18),('8998','2013-06-16','16:55:00',1.13),('8998','2013-06-16','17:00:00',1.09),('8998','2013-06-16','17:05:00',1.04),('8998','2013-06-15','07:35:00',1.03),('8998','2013-06-15','07:40:00',1.19),('8998','2013-06-15','07:45:00',1.32),('8998','2013-06-15','07:50:00',1.32),('8998','2013-06-15','07:55:00',1.32),('8998','2013-06-15','08:00:00',1.34),('8998','2013-06-15','08:05:00',1.49),('8998','2013-06-15','08:10:00',1.75),('8998','2013-06-15','08:15:00',1.82),('8998','2013-06-15','08:20:00',1.75),('8998','2013-06-15','08:25:00',1.7),('8998','2013-06-15','08:30:00',1.67),('8998','2013-06-15','08:35:00',1.64),('8998','2013-06-15','08:40:00',1.66),('8998','2013-06-15','08:45:00',1.98),('8998','2013-06-15','08:50:00',2.01),('8998','2013-06-15','08:55:00',2.12),('8998','2013-06-15','09:00:00',2.25),('8998','2013-06-15','09:05:00',2.29),('8998','2013-06-15','09:10:00',2.34),('8998','2013-06-15','09:15:00',2.47),('8998','2013-06-15','09:20:00',2.52),('8998','2013-06-15','09:25:00',2.54),('8998','2013-06-15','09:30:00',2.55),('8998','2013-06-15','09:35:00',2.6),('8998','2013-06-15','09:40:00',2.62),('8998','2013-06-15','09:45:00',2.63),('8998','2013-06-15','09:50:00',2.65),('8998','2013-06-15','09:55:00',2.66),('8998','2013-06-15','10:00:00',2.68),('8998','2013-06-15','10:05:00',2.7),('8998','2013-06-15','10:10:00',2.7),('8998','2013-06-15','10:15:00',2.75),('8998','2013-06-15','10:20:00',2.75),('8998','2013-06-15','10:25:00',2.77),('8998','2013-06-15','10:30:00',2.79),('8998','2013-06-15','10:35:00',2.81),('8998','2013-06-15','10:40:00',2.83),('8998','2013-06-15','10:45:00',2.83),('8998','2013-06-15','10:50:00',2.85),('8998','2013-06-15','10:55:00',2.84),('8998','2013-06-15','11:00:00',2.85),('8998','2013-06-15','11:05:00',2.85),('8998','2013-06-15','11:10:00',2.86),('8998','2013-06-15','11:15:00',2.86),('8998','2013-06-15','11:20:00',2.86),('8998','2013-06-15','11:25:00',2.88),('8998','2013-06-15','11:30:00',2.9),('8998','2013-06-15','11:35:00',2.94),('8998','2013-06-15','11:40:00',2.93),('8998','2013-06-15','11:45:00',2.9),('8998','2013-06-15','11:50:00',2.91),('8998','2013-06-15','11:55:00',2.93),('8998','2013-06-15','12:00:00',2.94),('8998','2013-06-15','12:05:00',2.93),('8998','2013-06-15','12:10:00',2.93),('8998','2013-06-15','12:15:00',2.92),('8998','2013-06-15','12:20:00',2.9),('8998','2013-06-15','12:25:00',2.9),('8998','2013-06-15','12:30:00',2.89),('8998','2013-06-15','12:35:00',2.87),('8998','2013-06-15','12:40:00',2.85),('8998','2013-06-15','12:45:00',2.82),('8998','2013-06-15','12:50:00',2.81),('8998','2013-06-15','12:55:00',2.81),('8998','2013-06-15','13:00:00',2.81),('8998','2013-06-15','13:05:00',2.8),('8998','2013-06-15','13:10:00',2.8),('8998','2013-06-15','13:15:00',2.78),('8998','2013-06-15','13:20:00',2.76),('8998','2013-06-15','13:25:00',2.74),('8998','2013-06-15','13:30:00',2.73),('8998','2013-06-15','13:35:00',2.71),('8998','2013-06-15','13:40:00',2.68),('8998','2013-06-15','13:45:00',2.65),('8998','2013-06-15','13:50:00',2.63),('8998','2013-06-15','13:55:00',2.6),('8998','2013-06-15','14:00:00',2.6),('8998','2013-06-15','14:05:00',2.57),('8998','2013-06-15','14:10:00',2.55),('8998','2013-06-15','14:15:00',2.52),('8998','2013-06-15','14:20:00',2.48),('8998','2013-06-15','14:25:00',2.45),('8998','2013-06-15','14:30:00',2.41),('8998','2013-06-15','14:35:00',2.38),('8998','2013-06-15','14:40:00',2.34),('8998','2013-06-15','14:45:00',2.3),('8998','2013-06-15','14:50:00',2.26),('8998','2013-06-15','14:55:00',2.23),('8998','2013-06-15','15:00:00',2.19),('8998','2013-06-15','15:05:00',2.16),('8998','2013-06-15','15:10:00',2.12),('8998','2013-06-15','15:15:00',2.08),('8998','2013-06-15','15:20:00',2.04),('8998','2013-06-15','15:25:00',2.01),('8998','2013-06-15','15:30:00',1.96),('8998','2013-06-15','15:35:00',1.91),('8998','2013-06-15','15:40:00',1.87),('8998','2013-06-15','15:45:00',1.82),('8998','2013-06-15','15:50:00',1.77),('8998','2013-06-15','15:55:00',1.72),('8998','2013-06-15','16:00:00',1.67),('8998','2013-06-15','16:05:00',1.62),('8998','2013-06-15','16:10:00',1.57),('8998','2013-06-15','16:15:00',1.52),('8998','2013-06-15','16:20:00',1.47),('8998','2013-06-15','16:25:00',1.41),('8998','2013-06-15','16:30:00',1.36),('8998','2013-06-15','16:35:00',1.31),('8998','2013-06-15','16:40:00',1.26),('8998','2013-06-15','16:45:00',1.2),('8998','2013-06-15','16:50:00',1.14),('8998','2013-06-15','16:55:00',1.09),('8998','2013-06-15','17:00:00',1.04),('8998','2013-06-14','07:40:00',1.11),('8998','2013-06-14','07:45:00',1.18),('8998','2013-06-14','07:50:00',1.22),('8998','2013-06-14','07:55:00',1.29),('8998','2013-06-14','08:00:00',1.31),('8998','2013-06-14','08:05:00',1.35),('8998','2013-06-14','08:10:00',1.39),('8998','2013-06-14','08:15:00',1.67),('8998','2013-06-14','08:20:00',1.69),('8998','2013-06-14','08:25:00',1.66),('8998','2013-06-14','08:30:00',1.63),('8998','2013-06-14','08:35:00',1.63),('8998','2013-06-14','08:40:00',1.66),('8998','2013-06-14','08:45:00',1.66),('8998','2013-06-14','08:50:00',1.83),('8998','2013-06-14','08:55:00',1.85),('8998','2013-06-14','09:00:00',1.84),('8998','2013-06-14','09:05:00',2.09),('8998','2013-06-14','09:10:00',2.25),('8998','2013-06-14','09:15:00',2.42),('8998','2013-06-14','09:20:00',2.45),('8998','2013-06-14','09:25:00',2.42),('8998','2013-06-14','09:30:00',2.48),('8998','2013-06-14','09:35:00',2.26),('8998','2013-06-14','09:40:00',2.48),('8998','2013-06-14','09:45:00',2.37),('8998','2013-06-14','09:50:00',2.6),('8998','2013-06-14','09:55:00',2.61),('8998','2013-06-14','10:00:00',1.78),('8998','2013-06-14','10:05:00',1.33),('8998','2013-06-14','10:10:00',1.53),('8998','2013-06-14','10:15:00',2.33),('8998','2013-06-14','10:20:00',2.61),('8998','2013-06-14','10:25:00',2.57),('8998','2013-06-14','10:30:00',2.77),('8998','2013-06-14','10:35:00',2.92),('8998','2013-06-14','10:40:00',2.87),('8998','2013-06-14','10:45:00',2.78),('8998','2013-06-14','10:50:00',2.92),('8998','2013-06-14','10:55:00',2.92),('8998','2013-06-14','11:00:00',1.82),('8998','2013-06-14','11:05:00',1.33),('8998','2013-06-14','11:10:00',2.58),('8998','2013-06-14','11:15:00',2.67),('8998','2013-06-14','11:20:00',2.9),('8998','2013-06-14','11:25:00',2.75),('8998','2013-06-14','11:30:00',2.32),('8998','2013-06-14','11:35:00',2.61),('8998','2013-06-14','11:40:00',1.85),('8998','2013-06-14','11:45:00',1.46),('8998','2013-06-14','11:50:00',1.6),('8998','2013-06-14','11:55:00',3.22),('8998','2013-06-14','12:00:00',3.14),('8998','2013-06-14','12:05:00',2.82),('8998','2013-06-14','12:10:00',3.09),('8998','2013-06-14','12:15:00',3.11),('8998','2013-06-14','12:20:00',3.06),('8998','2013-06-14','12:25:00',2.99),('8998','2013-06-14','12:30:00',2.98),('8998','2013-06-14','12:35:00',2.97),('8998','2013-06-14','12:40:00',2.94),('8998','2013-06-14','12:45:00',2.91),('8998','2013-06-14','12:50:00',2.87),('8998','2013-06-14','12:55:00',2.86),('8998','2013-06-14','13:00:00',2.86),('8998','2013-06-14','13:05:00',2.83),('8998','2013-06-14','13:10:00',2.82),('8998','2013-06-14','13:15:00',2.82),('8998','2013-06-14','13:20:00',2.78),('8998','2013-06-14','13:25:00',2.75),('8998','2013-06-14','13:30:00',2.74),('8998','2013-06-14','13:35:00',2.71),('8998','2013-06-14','13:40:00',2.69),('8998','2013-06-14','13:45:00',2.68),('8998','2013-06-14','13:50:00',2.66),('8998','2013-06-14','13:55:00',2.62),('8998','2013-06-14','14:00:00',2.6),('8998','2013-06-14','14:05:00',2.57),('8998','2013-06-14','14:10:00',2.54),('8998','2013-06-14','14:15:00',2.51),('8998','2013-06-14','14:20:00',2.48),('8998','2013-06-14','14:25:00',2.43),('8998','2013-06-14','14:30:00',2.4),('8998','2013-06-14','14:35:00',2.36),('8998','2013-06-14','14:40:00',2.34),('8998','2013-06-14','14:45:00',2.31),('8998','2013-06-14','14:50:00',2.25),('8998','2013-06-14','14:55:00',2.25),('8998','2013-06-14','15:00:00',2.2),('8998','2013-06-14','15:05:00',2.15),('8998','2013-06-14','15:10:00',2.12),('8998','2013-06-14','15:15:00',2.09),('8998','2013-06-14','15:20:00',2.05),('8998','2013-06-14','15:25:00',2.01),('8998','2013-06-14','15:30:00',1.97),('8998','2013-06-14','15:35:00',1.92),('8998','2013-06-14','15:40:00',1.87),('8998','2013-06-14','15:45:00',1.82),('8998','2013-06-14','15:50:00',1.77),('8998','2013-06-14','15:55:00',1.72),('8998','2013-06-14','16:00:00',1.67),('8998','2013-06-14','16:05:00',1.62),('8998','2013-06-14','16:10:00',1.56),('8998','2013-06-14','16:15:00',1.51),('8998','2013-06-14','16:20:00',1.46),('8998','2013-06-14','16:25:00',1.41),('8998','2013-06-14','16:30:00',1.36),('8998','2013-06-14','16:35:00',1.31),('8998','2013-06-14','16:40:00',1.25),('8998','2013-06-14','16:45:00',1.2),('8998','2013-06-14','16:50:00',1.15),('8998','2013-06-14','16:55:00',1.09),('8998','2013-06-14','17:00:00',1.05),('8998','2013-06-13','07:30:00',1.01),('8998','2013-06-13','07:35:00',1.09),('8998','2013-06-13','07:40:00',1.29),('8998','2013-06-13','07:45:00',1.39),('8998','2013-06-13','07:50:00',1.38),('8998','2013-06-13','07:55:00',1.37),('8998','2013-06-13','08:00:00',1.36),('8998','2013-06-13','08:05:00',1.51),('8998','2013-06-13','08:10:00',1.9),('8998','2013-06-13','08:15:00',1.93),('8998','2013-06-13','08:20:00',1.8),('8998','2013-06-13','08:25:00',1.74),('8998','2013-06-13','08:30:00',1.69),('8998','2013-06-13','08:35:00',1.67),('8998','2013-06-13','08:40:00',1.69),('8998','2013-06-13','08:45:00',2.08),('8998','2013-06-13','08:50:00',2.08),('8998','2013-06-13','08:55:00',1.98),('8998','2013-06-13','09:00:00',1.87),('8998','2013-06-13','09:05:00',2.16),('8998','2013-06-13','09:10:00',2.36),('8998','2013-06-13','09:15:00',2.55),('8998','2013-06-13','09:20:00',2.58),('8998','2013-06-13','09:25:00',2.61),('8998','2013-06-13','09:30:00',2.63),('8998','2013-06-13','09:35:00',2.67),('8998','2013-06-13','09:40:00',2.71),('8998','2013-06-13','09:45:00',2.75),('8998','2013-06-13','09:50:00',2.77),('8998','2013-06-13','09:55:00',2.8),('8998','2013-06-13','10:00:00',2.83),('8998','2013-06-13','10:05:00',2.83),('8998','2013-06-13','10:10:00',2.81),('8998','2013-06-13','10:15:00',2.83),('8998','2013-06-13','10:20:00',2.88),('8998','2013-06-13','10:25:00',2.83),('8998','2013-06-13','10:30:00',2.9),('8998','2013-06-13','10:35:00',2.95),('8998','2013-06-13','10:40:00',2.93),('8998','2013-06-13','10:45:00',2.95),('8998','2013-06-13','10:50:00',2.94),('8998','2013-06-13','10:55:00',2.9),('8998','2013-06-13','11:00:00',2.88),('8998','2013-06-13','11:05:00',2.91),('8998','2013-06-13','11:10:00',2.96),('8998','2013-06-13','11:15:00',3),('8998','2013-06-13','11:20:00',2.96),('8998','2013-06-13','11:25:00',2.89),('8998','2013-06-13','11:30:00',3.03),('8998','2013-06-13','11:35:00',3.01),('8998','2013-06-13','11:40:00',3),('8998','2013-06-13','11:45:00',2.99),('8998','2013-06-13','11:50:00',3.01),('8998','2013-06-13','11:55:00',2.98),('8998','2013-06-13','12:00:00',2.96),('8998','2013-06-13','12:05:00',2.93),('8998','2013-06-13','12:10:00',2.96),('8998','2013-06-13','12:15:00',2.95),('8998','2013-06-13','12:20:00',2.93),('8998','2013-06-13','12:25:00',2.92),('8998','2013-06-13','12:30:00',2.91),('8998','2013-06-13','12:35:00',2.88),('8998','2013-06-13','12:40:00',2.88),('8998','2013-06-13','12:45:00',2.87),('8998','2013-06-13','12:50:00',2.82),('8998','2013-06-13','12:55:00',2.81),('8998','2013-06-13','13:00:00',2.8),('8998','2013-06-13','13:05:00',2.83),('8998','2013-06-13','13:10:00',2.02),('8998','2013-06-13','13:15:00',1.33),('8998','2013-06-13','13:20:00',1.89),('8998','2013-06-13','13:30:00',2.23),('8998','2013-06-13','13:35:00',2.46),('8998','2013-06-13','13:40:00',2.76),('8998','2013-06-13','13:45:00',2.69),('8998','2013-06-13','13:50:00',2.7),('8998','2013-06-13','13:55:00',2.66),('8998','2013-06-13','14:00:00',2.6),('8998','2013-06-13','14:05:00',2.64),('8998','2013-06-13','14:10:00',2.62),('8998','2013-06-13','14:15:00',2.58),('8998','2013-06-13','14:20:00',2.52),('8998','2013-06-13','14:25:00',2.49),('8998','2013-06-13','14:30:00',2.48),('8998','2013-06-13','14:35:00',2.46),('8998','2013-06-13','14:40:00',2.4),('8998','2013-06-13','14:45:00',2.34),('8998','2013-06-13','14:50:00',2.3),('8998','2013-06-13','14:55:00',2.27),('8998','2013-06-13','15:00:00',2.24),('8998','2013-06-13','15:05:00',2.2),('8998','2013-06-13','15:10:00',2.17),('8998','2013-06-13','15:15:00',2.13),('8998','2013-06-13','15:20:00',2.09),('8998','2013-06-13','15:25:00',2.04),('8998','2013-06-13','15:30:00',1.99),('8998','2013-06-13','15:35:00',1.95),('8998','2013-06-13','15:40:00',1.91),('8998','2013-06-13','15:45:00',1.86),('8998','2013-06-13','15:50:00',1.81),('8998','2013-06-13','15:55:00',1.75),('8998','2013-06-13','16:00:00',1.69),('8998','2013-06-13','16:05:00',1.64),('8998','2013-06-13','16:10:00',1.59),('8998','2013-06-13','16:15:00',1.54),('8998','2013-06-13','16:20:00',1.5),('8998','2013-06-13','16:25:00',1.44),('8998','2013-06-13','16:30:00',1.38),('8998','2013-06-13','16:35:00',1.32),('8998','2013-06-13','16:40:00',1.26),('8998','2013-06-13','16:45:00',1.21),('8998','2013-06-13','16:50:00',1.16),('8998','2013-06-13','16:55:00',1.09),('8998','2013-06-13','17:00:00',1.05),('8998','2013-06-12','07:30:00',1.02),('8998','2013-06-12','07:35:00',1.12),('8998','2013-06-12','07:40:00',1.34),('8998','2013-06-12','07:45:00',1.38),('8998','2013-06-12','07:50:00',1.38),('8998','2013-06-12','07:55:00',1.38),('8998','2013-06-12','08:00:00',1.38),('8998','2013-06-12','08:05:00',1.56),('8998','2013-06-12','08:10:00',1.94),('8998','2013-06-12','08:15:00',1.95),('8998','2013-06-12','08:20:00',1.8),('8998','2013-06-12','08:25:00',1.73),('8998','2013-06-12','08:30:00',1.67),('8998','2013-06-12','08:35:00',1.67),('8998','2013-06-12','08:40:00',1.68),('8998','2013-06-12','08:45:00',2.08),('8998','2013-06-12','08:50:00',2.07),('8998','2013-06-12','08:55:00',1.99),('8998','2013-06-12','09:00:00',1.88),('8998','2013-06-12','09:05:00',2.19),('8998','2013-06-12','09:10:00',2.4),('8998','2013-06-12','09:15:00',2.59),('8998','2013-06-12','09:20:00',2.65),('8998','2013-06-12','09:25:00',2.69),('8998','2013-06-12','09:30:00',2.73),('8998','2013-06-12','09:35:00',2.76),('8998','2013-06-12','09:40:00',2.78),('8998','2013-06-12','09:45:00',2.8),('8998','2013-06-12','09:50:00',2.83),('8998','2013-06-12','09:55:00',2.85),('8998','2013-06-12','10:00:00',2.89),('8998','2013-06-12','10:05:00',2.91),('8998','2013-06-12','10:10:00',2.93),('8998','2013-06-12','10:15:00',2.94),('8998','2013-06-12','10:20:00',2.94),('8998','2013-06-12','10:25:00',2.96),('8998','2013-06-12','10:30:00',2.99),('8998','2013-06-12','10:35:00',3),('8998','2013-06-12','10:40:00',3.01),('8998','2013-06-12','10:45:00',3.07),('8998','2013-06-12','10:50:00',3.07),('8998','2013-06-12','10:55:00',3.07),('8998','2013-06-12','11:00:00',3.09),('8998','2013-06-12','11:05:00',3.09),('8998','2013-06-12','11:10:00',3.09),('8998','2013-06-12','11:15:00',3.1),('8998','2013-06-12','11:20:00',3.12),('8998','2013-06-12','11:25:00',3.12),('8998','2013-06-12','11:30:00',3.12),('8998','2013-06-12','11:35:00',3.14),('8998','2013-06-12','11:40:00',3.12),('8998','2013-06-12','11:45:00',3.15),('8998','2013-06-12','11:50:00',3.15),('8998','2013-06-12','11:55:00',3.13),('8998','2013-06-12','12:00:00',3.11),('8998','2013-06-12','12:05:00',3.13),('8998','2013-06-12','12:10:00',3.11),('8998','2013-06-12','12:15:00',3.11),('8998','2013-06-12','12:20:00',3.11),('8998','2013-06-12','12:25:00',3.11),('8998','2013-06-12','12:30:00',3.1),('8998','2013-06-12','12:35:00',3.07),('8998','2013-06-12','12:40:00',3.06),('8998','2013-06-12','12:45:00',3.04),('8998','2013-06-12','12:50:00',3.01),('8998','2013-06-12','12:55:00',2.98),('8998','2013-06-12','13:00:00',2.98),('8998','2013-06-12','13:05:00',2.96),('8998','2013-06-12','13:10:00',2.94),('8998','2013-06-12','13:15:00',2.93),('8998','2013-06-12','13:20:00',2.88),('8998','2013-06-12','13:25:00',2.88),('8998','2013-06-12','13:30:00',2.86),('8998','2013-06-12','13:35:00',2.85),('8998','2013-06-12','13:40:00',2.83),('8998','2013-06-12','13:45:00',2.78),('8998','2013-06-12','13:50:00',2.76),('8998','2013-06-12','13:55:00',2.73),('8998','2013-06-12','14:00:00',2.71),('8998','2013-06-12','14:05:00',2.67),('8998','2013-06-12','14:10:00',2.63),('8998','2013-06-12','14:15:00',2.62),('8998','2013-06-12','14:20:00',2.58),('8998','2013-06-12','14:25:00',2.62),('8998','2013-06-12','14:30:00',1.39),('8998','2013-06-12','14:35:00',2.47),('8998','2013-06-12','14:40:00',2.51),('8998','2013-06-12','14:45:00',2.44),('8998','2013-06-12','14:50:00',2.35),('8998','2013-06-12','14:55:00',2.34),('8998','2013-06-12','15:00:00',2.31),('8998','2013-06-12','15:05:00',2.24),('8998','2013-06-12','15:10:00',2.19),('8998','2013-06-12','15:15:00',2.15),('8998','2013-06-12','15:20:00',2.11),('8998','2013-06-12','15:25:00',2.07),('8998','2013-06-12','15:30:00',2.02),('8998','2013-06-12','15:35:00',1.97),('8998','2013-06-12','15:40:00',1.93),('8998','2013-06-12','15:45:00',1.88),('8998','2013-06-12','15:50:00',1.83),('8998','2013-06-12','15:55:00',1.78),('8998','2013-06-12','16:00:00',1.72),('8998','2013-06-12','16:05:00',1.67),('8998','2013-06-12','16:10:00',1.61),('8998','2013-06-12','16:15:00',1.56),('8998','2013-06-12','16:20:00',1.5),('8998','2013-06-12','16:25:00',1.45),('8998','2013-06-12','16:30:00',1.39),('8998','2013-06-12','16:35:00',1.33),('8998','2013-06-12','16:40:00',1.28),('8998','2013-06-12','16:45:00',1.22),('8998','2013-06-12','16:50:00',1.16),('8998','2013-06-12','16:55:00',1.11),('8998','2013-06-12','17:00:00',1.04),('8998','2013-06-11','07:30:00',1.03),('8998','2013-06-11','07:35:00',1.11),('8998','2013-06-11','07:40:00',1.32),('8998','2013-06-11','07:45:00',1.37),('8998','2013-06-11','07:50:00',1.35),('8998','2013-06-11','07:55:00',1.38),('8998','2013-06-11','08:00:00',1.38),('8998','2013-06-11','08:05:00',1.69),('8998','2013-06-11','08:10:00',1.98),('8998','2013-06-11','08:15:00',1.98),('8998','2013-06-11','08:20:00',1.81),('8998','2013-06-11','08:25:00',1.76),('8998','2013-06-11','08:30:00',1.71),('8998','2013-06-11','08:35:00',1.72),('8998','2013-06-11','08:40:00',1.85),('8998','2013-06-11','08:45:00',2.18),('8998','2013-06-11','08:50:00',2.21),('8998','2013-06-11','08:55:00',2.37),('8998','2013-06-11','09:00:00',2.45),('8998','2013-06-11','09:05:00',2.5),('8998','2013-06-11','09:10:00',2.56),('8998','2013-06-11','09:15:00',2.69),('8998','2013-06-11','09:20:00',2.72),('8998','2013-06-11','09:25:00',2.75),('8998','2013-06-11','09:30:00',2.78),('8998','2013-06-11','09:35:00',2.8),('8998','2013-06-11','09:40:00',2.82),('8998','2013-06-11','09:45:00',2.85),('8998','2013-06-11','09:50:00',2.88),('8998','2013-06-11','09:55:00',2.91),('8998','2013-06-11','10:00:00',2.9),('8998','2013-06-11','10:05:00',2.92),('8998','2013-06-11','10:10:00',2.94),('8998','2013-06-11','10:15:00',2.98),('8998','2013-06-11','10:20:00',3),('8998','2013-06-11','10:25:00',3),('8998','2013-06-11','10:30:00',3),('8998','2013-06-11','10:35:00',3),('8998','2013-06-11','10:40:00',3),('8998','2013-06-11','10:45:00',3.05),('8998','2013-06-11','10:50:00',3.08),('8998','2013-06-11','10:55:00',3.13),('8998','2013-06-11','11:00:00',3.15),('8998','2013-06-11','11:05:00',3.15),('8998','2013-06-11','11:10:00',3.16),('8998','2013-06-11','11:15:00',3.14),('8998','2013-06-11','11:20:00',3.14),('8998','2013-06-11','11:25:00',3.15),('8998','2013-06-11','11:30:00',3.16),('8998','2013-06-11','11:35:00',3.15),('8998','2013-06-11','11:40:00',3.16),('8998','2013-06-11','11:45:00',3.12),('8998','2013-06-11','11:50:00',3.16),('8998','2013-06-11','11:55:00',3.16),('8998','2013-06-11','12:00:00',3.15),('8998','2013-06-11','12:05:00',3.16),('8998','2013-06-11','12:10:00',3.13),('8998','2013-06-11','12:15:00',3.14),('8998','2013-06-11','12:20:00',3.12),('8998','2013-06-11','12:25:00',3.08),('8998','2013-06-11','12:30:00',3.13),('8998','2013-06-11','12:35:00',2.95),('8998','2013-06-11','12:40:00',1.66),('8998','2013-06-11','12:45:00',1.97),('8998','2013-06-11','12:50:00',3.32),('8998','2013-06-11','12:55:00',2.66),('8998','2013-06-11','13:00:00',2.5),('8998','2013-06-11','13:05:00',3.1),('8998','2013-06-11','13:10:00',3),('8998','2013-06-11','13:15:00',2.94),('8998','2013-06-11','13:20:00',2.9),('8998','2013-06-11','13:25:00',2.89),('8998','2013-06-11','13:30:00',2.9),('8998','2013-06-11','13:35:00',2.89),('8998','2013-06-11','13:40:00',2.84),('8998','2013-06-11','13:45:00',2.84),('8998','2013-06-11','13:50:00',2.81),('8998','2013-06-11','13:55:00',2.82),('8998','2013-06-11','14:00:00',2.83),('8998','2013-06-11','14:05:00',1.61),('8998','2013-06-11','14:10:00',2.38),('8998','2013-06-11','14:15:00',2.51),('8998','2013-06-11','14:20:00',1.48),('8998','2013-06-11','14:25:00',1.18),('8998','2013-06-11','14:30:00',2.77),('8998','2013-06-11','14:35:00',2.71),('8998','2013-06-11','14:40:00',2.52),('8998','2013-06-11','14:45:00',2.42),('8998','2013-06-11','14:50:00',2.6),('8998','2013-06-11','14:55:00',2.62),('8998','2013-06-11','15:00:00',2.56),('8998','2013-06-11','15:05:00',2.32),('8998','2013-06-11','15:10:00',2.35),('8998','2013-06-11','15:15:00',1.74),('8998','2013-06-11','15:20:00',2.31),('8998','2013-06-11','15:25:00',2.09),('8998','2013-06-11','15:30:00',2.09),('8998','2013-06-11','15:35:00',2.09),('8998','2013-06-11','15:40:00',2.02),('8998','2013-06-11','15:45:00',1.96),('8998','2013-06-11','15:50:00',1.87),('8998','2013-06-11','15:55:00',1.87),('8998','2013-06-11','16:00:00',1.65),('8998','2013-06-11','16:05:00',1.68),('8998','2013-06-11','16:10:00',1.72),('8998','2013-06-11','16:15:00',1.65),('8998','2013-06-11','16:20:00',1.54),('8998','2013-06-11','16:25:00',1.46),('8998','2013-06-11','16:30:00',1.44),('8998','2013-06-11','16:35:00',1.38),('8998','2013-06-11','16:40:00',1.34),('8998','2013-06-11','16:45:00',1.05),('8998','2013-06-11','16:50:00',1.21),('8998','2013-06-11','16:55:00',1.13),('8998','2013-06-11','17:00:00',1.06),('8998','2013-06-11','17:05:00',1.02),('8998','2013-06-10','07:35:00',1.11),('8998','2013-06-10','07:40:00',1.34),('8998','2013-06-10','07:45:00',1.38),('8998','2013-06-10','07:50:00',1.34),('8998','2013-06-10','08:00:00',1.37),('8998','2013-06-10','08:10:00',1.47),('8998','2013-06-10','08:15:00',2.15),('8998','2013-06-10','08:20:00',2.01),('8998','2013-06-10','08:25:00',1.88),('8998','2013-06-10','08:30:00',1.87),('8998','2013-06-10','08:35:00',1.82),('8998','2013-06-10','08:40:00',1.84),('8998','2013-06-10','08:45:00',2.01),('8998','2013-06-10','08:50:00',2.19),('8998','2013-06-10','08:55:00',2.18),('8998','2013-06-10','09:00:00',2.14),('8998','2013-06-10','09:05:00',2.42),('8998','2013-06-10','09:10:00',2.58),('8998','2013-06-10','09:15:00',2.73),('8998','2013-06-10','09:20:00',2.75),('8998','2013-06-10','09:25:00',2.88),('8998','2013-06-10','09:30:00',2.8),('8998','2013-06-10','09:35:00',2.72),('8998','2013-06-10','09:45:00',1.11),('8998','2013-06-10','09:50:00',2.22),('8998','2013-06-10','09:55:00',2.86),('8998','2013-06-10','10:00:00',1.91),('8998','2013-06-10','10:05:00',2.64),('8998','2013-06-10','10:10:00',1.98),('8998','2013-06-10','10:15:00',3.08),('8998','2013-06-10','10:20:00',3.1),('8998','2013-06-10','10:25:00',2.55),('8998','2013-06-10','10:30:00',3.15),('8998','2013-06-10','10:35:00',3.02),('8998','2013-06-10','10:40:00',2.31),('8998','2013-06-10','10:45:00',2.77),('8998','2013-06-10','10:50:00',3.17),('8998','2013-06-10','10:55:00',3.22),('8998','2013-06-10','11:00:00',3.26),('8998','2013-06-10','11:05:00',3.08),('8998','2013-06-10','11:10:00',2.47),('8998','2013-06-10','11:15:00',2.99),('8998','2013-06-10','11:20:00',3.3),('8998','2013-06-10','11:25:00',2.19),('8998','2013-06-10','11:30:00',3.02),('8998','2013-06-10','11:35:00',3.21),('8998','2013-06-10','11:40:00',3.19),('8998','2013-06-10','11:45:00',3.16),('8998','2013-06-10','11:50:00',3.17),('8998','2013-06-10','11:55:00',3.17),('8998','2013-06-10','12:00:00',2.91),('8998','2013-06-10','12:05:00',1.84),('8998','2013-06-10','12:10:00',3.25),('8998','2013-06-10','12:15:00',3.18),('8998','2013-06-10','12:20:00',3),('8998','2013-06-10','12:25:00',3.17),('8998','2013-06-10','12:30:00',3.15),('8998','2013-06-10','12:35:00',3.14),('8998','2013-06-10','12:40:00',3.11),('8998','2013-06-10','12:45:00',3.09),('8998','2013-06-10','12:50:00',3.08),('8998','2013-06-10','12:55:00',3.08),('8998','2013-06-10','13:00:00',3.06),('8998','2013-06-10','13:05:00',3.06),('8998','2013-06-10','13:10:00',3.06),('8998','2013-06-10','13:15:00',3.06),('8998','2013-06-10','13:20:00',3.01),('8998','2013-06-10','13:25:00',2.98),('8998','2013-06-10','13:30:00',2.97),('8998','2013-06-10','13:35:00',2.96),('8998','2013-06-10','13:40:00',2.98),('8998','2013-06-10','13:45:00',2.91),('8998','2013-06-10','13:50:00',2.79),('8998','2013-06-10','13:55:00',2.95),('8998','2013-06-10','14:00:00',2.89),('8998','2013-06-10','14:05:00',2.81),('8998','2013-06-10','14:10:00',2.74),('8998','2013-06-10','14:15:00',2.7),('8998','2013-06-10','14:20:00',2.66),('8998','2013-06-10','14:25:00',2.62),('8998','2013-06-10','14:30:00',2.58),('8998','2013-06-10','14:35:00',2.55),('8998','2013-06-10','14:40:00',2.51),('8998','2013-06-10','14:45:00',2.47),('8998','2013-06-10','14:50:00',2.43),('8998','2013-06-10','14:55:00',2.38),('8998','2013-06-10','15:00:00',2.34),('8998','2013-06-10','15:05:00',2.3),('8998','2013-06-10','15:10:00',2.25),('8998','2013-06-10','15:15:00',2.21),('8998','2013-06-10','15:20:00',2.18),('8998','2013-06-10','15:25:00',2.1),('8998','2013-06-10','15:30:00',2.09),('8998','2013-06-10','15:35:00',2.08),('8998','2013-06-10','15:40:00',2.01),('8998','2013-06-10','15:45:00',1.44),('8998','2013-06-10','15:50:00',1.87),('8998','2013-06-10','15:55:00',1.69),('8998','2013-06-10','16:00:00',1.87),('8998','2013-06-10','16:05:00',1.81),('8998','2013-06-10','16:10:00',1.76),('8998','2013-06-10','16:15:00',1.69),('8998','2013-06-10','16:20:00',1.64),('8998','2013-06-10','16:25:00',1.58),('8998','2013-06-10','16:30:00',1.54),('8998','2013-06-10','16:35:00',1.51),('8998','2013-06-10','16:40:00',1.54),('8998','2013-06-10','16:45:00',1.63),('8998','2013-06-10','16:50:00',1.65),('8998','2013-06-10','16:55:00',1.53),('8998','2013-06-10','17:00:00',1.39),('8998','2013-06-10','17:05:00',1.14),('8998','2014-04-02','09:05:00',1.09),('8998','2014-04-02','09:10:00',1.07),('8998','2014-04-02','09:30:00',1.14),('8998','2014-04-02','09:35:00',1.44),('8998','2014-04-02','09:40:00',1.56),('8998','2014-04-02','09:45:00',1.52),('8998','2014-04-02','09:50:00',1.46),('8998','2014-04-02','09:55:00',1.51),('8998','2014-04-02','10:00:00',1.85),('8998','2014-04-02','10:05:00',2.2),('8998','2014-04-02','10:10:00',2.31),('8998','2014-04-02','10:15:00',2.62),('8998','2014-04-02','10:20:00',2.63),('8998','2014-04-02','10:25:00',2.4),('8998','2014-04-02','10:30:00',2.16),('8998','2014-04-02','10:35:00',2.33),('8998','2014-04-02','10:40:00',1.76),('8998','2014-04-02','10:45:00',1.88),('8998','2014-04-02','10:50:00',1.58),('8998','2014-04-02','10:55:00',1.64),('8998','2014-04-02','11:00:00',1.55),('8998','2014-04-02','11:05:00',1.25),('8998','2014-04-02','11:10:00',1.18),('8998','2014-04-02','11:15:00',1.09),('8998','2014-04-02','11:20:00',1.04),('8998','2014-04-02','11:40:00',1.05),('8998','2014-04-02','11:45:00',1.19),('8998','2014-04-02','11:50:00',1.47),('8998','2014-04-02','11:55:00',1.7),('8998','2014-04-02','12:00:00',1.61),('8998','2014-04-02','12:05:00',1.64),('8998','2014-04-02','12:10:00',1.57),('8998','2014-04-02','12:15:00',1.53),('8998','2014-04-02','12:20:00',1.67),('8998','2014-04-02','12:25:00',2.05),('8998','2014-04-02','12:30:00',2.7),('8998','2014-04-02','12:35:00',2.61),('8998','2014-04-02','12:40:00',2.85),('8998','2014-04-02','12:45:00',1.72),('8998','2014-04-02','12:50:00',1.82),('8998','2014-04-02','12:55:00',1.88),('8998','2014-04-02','13:00:00',1.77),('8998','2014-04-02','13:05:00',2.23),('8998','2014-04-02','13:10:00',1.61),('8998','2014-04-02','13:15:00',3.01),('8998','2014-04-02','13:20:00',2.09),('8998','2014-04-02','13:25:00',1.88),('8998','2014-04-02','13:30:00',1.87),('8998','2014-04-02','13:35:00',2.92),('8998','2014-04-02','13:40:00',2.65),('8998','2014-04-02','13:45:00',1.47),('8998','2014-04-02','13:50:00',1.39),('8998','2014-04-02','13:55:00',1.6),('8998','2014-04-02','14:00:00',2.35),('8998','2014-04-02','14:05:00',2.29),('8998','2014-04-02','14:10:00',1.75),('8998','2014-04-02','14:15:00',2.12),('8998','2014-04-02','14:20:00',2.25),('8998','2014-04-02','14:25:00',2.21),('8998','2014-04-02','14:30:00',2.23),('8998','2014-04-02','14:35:00',2.26),('8998','2014-04-02','14:40:00',2.16),('8998','2014-04-02','14:45:00',2.08),('8998','2014-04-02','14:50:00',2),('8998','2014-04-02','14:55:00',1.92),('8998','2014-04-02','15:00:00',1.88),('8998','2014-04-02','15:05:00',1.83),('8998','2014-04-02','15:10:00',1.77),('8998','2014-04-02','15:15:00',1.73),('8998','2014-04-02','15:20:00',1.7),('8998','2014-04-02','15:25:00',1.64),('8998','2014-04-02','15:30:00',1.59),('8998','2014-04-02','15:35:00',1.54),('8998','2014-04-02','15:40:00',1.48),('8998','2014-04-02','15:45:00',1.43),('8998','2014-04-02','15:50:00',1.38),('8998','2014-04-02','15:55:00',1.33),('8998','2014-04-02','16:00:00',1.3),('8998','2014-04-02','16:05:00',1.22),('8998','2014-04-02','16:10:00',1.19),('8998','2014-04-02','16:15:00',1.1),('8998','2014-04-02','16:20:00',1.06),('8998','2013-06-09','07:30:00',1.2),('8998','2013-06-09','07:35:00',1.45),('8998','2013-06-09','08:00:00',1.03),('8998','2013-06-09','08:05:00',1.5),('8998','2013-06-09','08:10:00',2.08),('8998','2013-06-09','08:15:00',1.61),('8998','2013-06-09','08:20:00',1.97),('8998','2013-06-09','08:25:00',1.13),('8998','2013-06-09','08:30:00',1.03),('8998','2013-06-09','09:00:00',1.03),('8998','2013-06-09','09:10:00',1.68),('8998','2013-06-09','09:20:00',2.28),('8998','2013-06-09','09:25:00',1.54),('8998','2013-06-09','09:30:00',1.89),('8998','2013-06-09','09:35:00',2.84),('8998','2013-06-09','09:40:00',2.08),('8998','2013-06-09','09:45:00',3.18),('8998','2013-06-09','09:50:00',1.66),('8998','2013-06-09','09:55:00',1.55),('8998','2013-06-09','10:00:00',1.74),('8998','2013-06-09','10:05:00',1.98),('8998','2013-06-09','10:10:00',2.56),('8998','2013-06-09','10:15:00',2.38),('8998','2013-06-09','10:20:00',1.64),('8998','2013-06-09','10:25:00',1.34),('8998','2013-06-09','10:30:00',1.43),('8998','2013-06-09','10:35:00',1.28),('8998','2013-06-09','10:40:00',1.33),('8998','2013-06-09','10:50:00',1.39),('8998','2013-06-09','10:55:00',1.82),('8998','2013-06-09','11:00:00',2.69),('8998','2013-06-09','11:05:00',2.34),('8998','2013-06-09','11:10:00',2.22),('8998','2013-06-09','11:15:00',3.27),('8998','2013-06-09','11:20:00',3.4),('8998','2013-06-09','11:25:00',3.27),('8998','2013-06-09','11:30:00',3.24),('8998','2013-06-09','11:35:00',3.26),('8998','2013-06-09','11:40:00',2.09),('8998','2013-06-09','11:45:00',2.34),('8998','2013-06-09','11:50:00',1.85),('8998','2013-06-09','11:55:00',2.3),('8998','2013-06-09','12:00:00',3.45),('8998','2013-06-09','12:05:00',1.51),('8998','2013-06-09','12:10:00',2.06),('8998','2013-06-09','12:15:00',2.11),('8998','2013-06-09','12:20:00',2.64),('8998','2013-06-09','12:25:00',3.3),('8998','2013-06-09','12:30:00',3.37),('8998','2013-06-09','12:35:00',3.37),('8998','2013-06-09','12:40:00',2.91),('8998','2013-06-09','12:45:00',3.43),('8998','2013-06-09','12:50:00',1.49),('8998','2013-06-09','12:55:00',3.07),('8998','2013-06-09','13:00:00',3.52),('8998','2013-06-09','13:05:00',2.99),('8998','2013-06-09','13:10:00',2.84),('8998','2013-06-09','13:15:00',2.01),('8998','2013-06-09','13:20:00',1.48),('8998','2013-06-09','13:25:00',1.66),('8998','2013-06-09','13:30:00',1.27),('8998','2013-06-09','13:35:00',2.5),('8998','2013-06-09','13:40:00',2.63),('8998','2013-06-09','13:45:00',3.04),('8998','2013-06-09','13:50:00',3.21),('8998','2013-06-09','13:55:00',2.63),('8998','2013-06-09','14:00:00',2.97),('8998','2013-06-09','14:05:00',2.88),('8998','2013-06-09','14:10:00',2.81),('8998','2013-06-09','14:15:00',2.73),('8998','2013-06-09','14:20:00',2.48),('8998','2013-06-09','14:25:00',2.56),('8998','2013-06-09','14:30:00',2.62),('8998','2013-06-09','14:35:00',2.59),('8998','2013-06-09','14:40:00',2.53),('8998','2013-06-09','14:45:00',2.53),('8998','2013-06-09','14:50:00',2.48),('8998','2013-06-09','14:55:00',2.41),('8998','2013-06-09','15:00:00',2.36),('8998','2013-06-09','15:05:00',2.33),('8998','2013-06-09','15:10:00',2.28),('8998','2013-06-09','15:15:00',2.24),('8998','2013-06-09','15:20:00',2.21),('8998','2013-06-09','15:25:00',2.15),('8998','2013-06-09','15:30:00',2.11),('8998','2013-06-09','15:35:00',2.06),('8998','2013-06-09','15:40:00',2.02),('8998','2013-06-09','15:45:00',1.97),('8998','2013-06-09','15:50:00',1.9),('8998','2013-06-09','15:55:00',1.86),('8998','2013-06-09','16:00:00',1.8),('8998','2013-06-09','16:05:00',1.74),('8998','2013-06-09','16:10:00',1.68),('8998','2013-06-09','16:15:00',1.63),('8998','2013-06-09','16:20:00',1.57),('8998','2013-06-09','16:25:00',1.51),('8998','2013-06-09','16:30:00',1.45),('8998','2013-06-09','16:35:00',1.39),('8998','2013-06-09','16:40:00',1.33),('8998','2013-06-09','16:45:00',1.28),('8998','2013-06-09','16:50:00',1.22),('8998','2013-06-09','16:55:00',1.16),('8998','2013-06-09','17:00:00',1.1),('8998','2013-06-09','17:05:00',1.04),('8998','2013-06-08','07:35:00',1.34),('8998','2013-06-08','07:40:00',1.19),('8998','2013-06-08','07:55:00',1.45),('8998','2013-06-08','08:00:00',1.51),('8998','2013-06-08','08:05:00',1.51),('8998','2013-06-08','08:10:00',1.47),('8998','2013-06-08','08:15:00',1.61),('8998','2013-06-08','08:20:00',1.65),('8998','2013-06-08','08:25:00',1.74),('8998','2013-06-08','08:30:00',1.73),('8998','2013-06-08','08:35:00',1.75),('8998','2013-06-08','08:40:00',1.7),('8998','2013-06-08','08:45:00',1.76),('8998','2013-06-08','08:50:00',1.89),('8998','2013-06-08','08:55:00',1.96),('8998','2013-06-08','09:00:00',1.97),('8998','2013-06-08','09:05:00',2.23),('8998','2013-06-08','09:10:00',2.36),('8998','2013-06-08','09:15:00',2.51),('8998','2013-06-08','09:20:00',2.44),('8998','2013-06-08','09:25:00',2.55),('8998','2013-06-08','09:30:00',2.58),('8998','2013-06-08','09:35:00',2.64),('8998','2013-06-08','09:40:00',2.68),('8998','2013-06-08','09:45:00',2.7),('8998','2013-06-08','09:50:00',2.72),('8998','2013-06-08','09:55:00',2.73),('8998','2013-06-08','10:00:00',2.75),('8998','2013-06-08','10:05:00',2.77),('8998','2013-06-08','10:10:00',2.79),('8998','2013-06-08','10:15:00',2.82),('8998','2013-06-08','10:20:00',2.84),('8998','2013-06-08','10:25:00',2.85),('8998','2013-06-08','10:30:00',2.83),('8998','2013-06-08','10:35:00',2.9),('8998','2013-06-08','10:40:00',2.91),('8998','2013-06-08','10:45:00',2.88),('8998','2013-06-08','10:50:00',2.92),('8998','2013-06-08','10:55:00',2.9),('8998','2013-06-08','11:00:00',2.92),('8998','2013-06-08','11:05:00',2.95),('8998','2013-06-08','11:10:00',2.92),('8998','2013-06-08','11:15:00',2.9),('8998','2013-06-08','11:20:00',2.93),('8998','2013-06-08','11:25:00',2.98),('8998','2013-06-08','11:30:00',2.95),('8998','2013-06-08','11:35:00',2.95),('8998','2013-06-08','11:40:00',2.94),('8998','2013-06-08','11:45:00',2.96),('8998','2013-06-08','11:50:00',2.97),('8998','2013-06-08','11:55:00',2.95),('8998','2013-06-08','12:00:00',2.96),('8998','2013-06-08','12:05:00',2.95),('8998','2013-06-08','12:10:00',2.61),('8998','2013-06-08','12:15:00',2.85),('8998','2013-06-08','12:20:00',2.94),('8998','2013-06-08','12:25:00',2.9),('8998','2013-06-08','12:30:00',2.88),('8998','2013-06-08','12:35:00',2.85),('8998','2013-06-08','12:40:00',2.89),('8998','2013-06-08','12:45:00',2.82),('8998','2013-06-08','12:50:00',2.7),('8998','2013-06-08','12:55:00',2.5),('8998','2013-06-08','13:00:00',2.52),('8998','2013-06-08','13:05:00',1.78),('8998','2013-06-08','13:10:00',2.65),('8998','2013-06-08','13:15:00',1.24),('8998','2013-06-08','13:20:00',1.36),('8998','2013-06-08','13:25:00',3.17),('8998','2013-06-08','13:30:00',2.97),('8998','2013-06-08','13:35:00',2.88),('8998','2013-06-08','13:40:00',2.9),('8998','2013-06-08','13:45:00',2.86),('8998','2013-06-08','13:50:00',2.91),('8998','2013-06-08','13:55:00',2.73),('8998','2013-06-08','14:00:00',2.52),('8998','2013-06-08','14:05:00',2.75),('8998','2013-06-08','14:10:00',2.74),('8998','2013-06-08','14:15:00',1.7),('8998','2013-06-08','14:20:00',1.33),('8998','2013-06-08','14:35:00',2.14),('8998','2013-06-08','14:40:00',2.36),('8998','2013-06-08','14:45:00',2.22),('8998','2013-06-08','14:50:00',2.36),('8998','2013-06-08','14:55:00',2.4),('8998','2013-06-08','15:00:00',2.32),('8998','2013-06-08','15:05:00',2.21),('8998','2013-06-08','15:10:00',2.21),('8998','2013-06-08','15:15:00',2.08),('8998','2013-06-08','15:20:00',2.08),('8998','2013-06-08','15:25:00',2.06),('8998','2013-06-08','15:30:00',1.94),('8998','2013-06-08','15:35:00',2.01),('8998','2013-06-08','15:40:00',1.52),('8998','2013-06-08','15:45:00',1.54),('8998','2013-06-08','15:50:00',1.69),('8998','2013-06-08','15:55:00',1.88),('8998','2013-06-08','16:00:00',1.15),('8998','2013-06-08','16:05:00',1.61),('8998','2013-06-08','16:10:00',1.57),('8998','2013-06-08','16:25:00',1.29),('8998','2013-06-07','07:35:00',1.11),('8998','2013-06-07','07:40:00',1.28),('8998','2013-06-07','07:45:00',1.3),('8998','2013-06-07','07:50:00',1.27),('8998','2013-06-07','07:55:00',1.31),('8998','2013-06-07','08:00:00',1.35),('8998','2013-06-07','08:05:00',1.37),('8998','2013-06-07','08:10:00',1.76),('8998','2013-06-07','08:15:00',1.87),('8998','2013-06-07','08:20:00',1.93),('8998','2013-06-07','08:25:00',1.98),('8998','2013-06-07','08:30:00',2.04),('8998','2013-06-07','08:35:00',2.11),('8998','2013-06-07','08:40:00',2.09),('8998','2013-06-07','08:45:00',2.04),('8998','2013-06-07','08:50:00',1.97),('8998','2013-06-07','08:55:00',1.91),('8998','2013-06-07','09:00:00',2.11),('8998','2013-06-07','09:05:00',2.3),('8998','2013-06-07','09:10:00',2.39),('8998','2013-06-07','09:15:00',2.52),('8998','2013-06-07','09:20:00',2.54),('8998','2013-06-07','09:25:00',2.56),('8998','2013-06-07','09:30:00',2.61),('8998','2013-06-07','09:35:00',2.61),('8998','2013-06-07','09:40:00',2.64),('8998','2013-06-07','09:45:00',2.63),('8998','2013-06-07','09:50:00',2.65),('8998','2013-06-07','09:55:00',2.61),('8998','2013-06-07','10:00:00',2.65),('8998','2013-06-07','10:05:00',2.77),('8998','2013-06-07','10:10:00',2.87),('8998','2013-06-07','10:15:00',2.87),('8998','2013-06-07','10:20:00',2.87),('8998','2013-06-07','10:25:00',2.87),('8998','2013-06-07','10:30:00',2.9),('8998','2013-06-07','10:35:00',2.93),('8998','2013-06-07','10:40:00',2.96),('8998','2013-06-07','10:45:00',2.85),('8998','2013-06-07','10:50:00',3.02),('8998','2013-06-07','10:55:00',2.41),('8998','2013-06-07','11:00:00',1.18),('8998','2013-06-07','11:05:00',3.02),('8998','2013-06-07','11:10:00',3.35),('8998','2013-06-07','11:15:00',3.22),('8998','2013-06-07','11:20:00',3.22),('8998','2013-06-07','11:25:00',3.3),('8998','2013-06-07','11:30:00',2.85),('8998','2013-06-07','11:35:00',1.77),('8998','2013-06-07','11:40:00',3.3),('8998','2013-06-07','11:45:00',3.22),('8998','2013-06-07','11:50:00',3.23),('8998','2013-06-07','11:55:00',2.78),('8998','2013-06-07','12:05:00',2.2),('8998','2013-06-07','12:15:00',2.39),('8998','2013-06-07','12:20:00',3.15),('8998','2013-06-07','12:35:00',2.42),('8998','2013-06-07','12:40:00',3.21),('8998','2013-06-07','12:45:00',3.21),('8998','2013-06-07','12:50:00',3.19),('8998','2013-06-07','12:55:00',3.14),('8998','2013-06-07','13:00:00',1.98),('8998','2013-06-07','13:05:00',3.2),('8998','2013-06-07','13:10:00',3.1),('8998','2013-06-07','13:15:00',3.12),('8998','2013-06-07','13:20:00',3.11),('8998','2013-06-07','13:25:00',2.98),('8998','2013-06-07','13:30:00',2.91),('8998','2013-06-07','13:35:00',2.96),('8998','2013-06-07','13:40:00',2.94),('8998','2013-06-07','13:45:00',2.88),('8998','2013-06-07','13:50:00',2.84),('8998','2013-06-07','13:55:00',2.8),('8998','2013-06-07','14:00:00',2.75),('8998','2013-06-07','14:05:00',2.72),('8998','2013-06-07','14:10:00',2.69),('8998','2013-06-07','14:15:00',2.67),('8998','2013-06-07','14:20:00',2.63),('8998','2013-06-07','14:25:00',2.58),('8998','2013-06-07','14:30:00',2.56),('8998','2013-06-07','14:35:00',2.51),('8998','2013-06-07','14:40:00',2.48),('8998','2013-06-07','14:45:00',2.45),('8998','2013-06-07','14:50:00',2.43),('8998','2013-06-07','14:55:00',2.37),('8998','2013-06-07','15:00:00',2.37),('8998','2013-06-07','15:05:00',2.26),('8998','2013-06-07','15:10:00',2.06),('8998','2013-06-07','15:15:00',2.13),('8998','2013-06-07','15:20:00',2.17),('8998','2013-06-07','15:25:00',2.01),('8998','2013-06-07','15:30:00',2.03),('8998','2013-06-07','15:35:00',2.1),('8998','2013-06-07','15:40:00',2.03),('8998','2013-06-07','15:45:00',2.05),('8998','2013-06-07','15:50:00',2),('8998','2013-06-07','15:55:00',1.85),('8998','2013-06-07','16:00:00',1.81),('8998','2013-06-07','16:05:00',1.76),('8998','2013-06-07','16:10:00',1.72),('8998','2013-06-07','16:15:00',1.76),('8998','2013-06-07','16:20:00',1.7),('8998','2013-06-07','16:25:00',1.59),('8998','2013-06-07','16:30:00',1.45),('8998','2013-06-07','16:35:00',1.37),('8998','2013-06-07','16:40:00',1.31),('8998','2013-06-07','16:45:00',1.25),('8998','2013-06-07','16:50:00',1.06),('8998','2013-06-07','16:55:00',1.05),('8998','2013-06-07','17:00:00',1.1),('8998','2013-06-07','17:10:00',1.13),('8998','2013-06-07','17:15:00',1.15),('8998','2013-06-07','17:20:00',1.05),('8998','2013-06-06','07:25:00',1.17),('8998','2013-06-06','07:30:00',1.28),('8998','2013-06-06','07:35:00',1.25),('8998','2013-06-06','07:40:00',1.37),('8998','2013-06-06','07:45:00',1.37),('8998','2013-06-06','07:50:00',1.33),('8998','2013-06-06','07:55:00',1.36),('8998','2013-06-06','08:00:00',1.39),('8998','2013-06-06','08:05:00',1.42),('8998','2013-06-06','08:10:00',1.8),('8998','2013-06-06','08:15:00',1.9),('8998','2013-06-06','08:20:00',1.75),('8998','2013-06-06','08:25:00',1.69),('8998','2013-06-06','08:30:00',1.71),('8998','2013-06-06','08:35:00',1.72),('8998','2013-06-06','08:40:00',1.86),('8998','2013-06-06','08:45:00',2.16),('8998','2013-06-06','08:50:00',2.04),('8998','2013-06-06','08:55:00',1.98),('8998','2013-06-06','09:00:00',2.03),('8998','2013-06-06','09:05:00',2.33),('8998','2013-06-06','09:10:00',2.52),('8998','2013-06-06','09:15:00',2.7),('8998','2013-06-06','09:20:00',2.73),('8998','2013-06-06','09:25:00',2.77),('8998','2013-06-06','09:30:00',2.8),('8998','2013-06-06','09:35:00',2.86),('8998','2013-06-06','09:40:00',2.92),('8998','2013-06-06','09:45:00',2.96),('8998','2013-06-06','09:50:00',2.96),('8998','2013-06-06','09:55:00',2.99),('8998','2013-06-06','10:00:00',3.01),('8998','2013-06-06','10:05:00',3.03),('8998','2013-06-06','10:10:00',3.07),('8998','2013-06-06','10:15:00',3.08),('8998','2013-06-06','10:20:00',3.08),('8998','2013-06-06','10:25:00',3.12),('8998','2013-06-06','10:30:00',3.13),('8998','2013-06-06','10:35:00',3.13),('8998','2013-06-06','10:40:00',3.14),('8998','2013-06-06','10:45:00',3.14),('8998','2013-06-06','10:50:00',3.16),('8998','2013-06-06','10:55:00',3.17),('8998','2013-06-06','11:00:00',3.19),('8998','2013-06-06','11:05:00',3.19),('8998','2013-06-06','11:10:00',3.19),('8998','2013-06-06','11:15:00',3.18),('8998','2013-06-06','11:20:00',3.17),('8998','2013-06-06','11:25:00',3.18),('8998','2013-06-06','11:30:00',3.19),('8998','2013-06-06','11:35:00',3.19),('8998','2013-06-06','11:40:00',3.2),('8998','2013-06-06','11:45:00',3.2),('8998','2013-06-06','11:50:00',3.2),('8998','2013-06-06','11:55:00',3.19),('8998','2013-06-06','12:00:00',3.19),('8998','2013-06-06','12:05:00',3.18),('8998','2013-06-06','12:10:00',3.18),('8998','2013-06-06','12:15:00',3.18),('8998','2013-06-06','12:20:00',3.17),('8998','2013-06-06','12:25:00',3.16),('8998','2013-06-06','12:30:00',3.14),('8998','2013-06-06','12:35:00',3.1),('8998','2013-06-06','12:40:00',3.12),('8998','2013-06-06','12:45:00',3.1),('8998','2013-06-06','12:50:00',3.07),('8998','2013-06-06','12:55:00',3.05),('8998','2013-06-06','13:00:00',3.03),('8998','2013-06-06','13:05:00',3),('8998','2013-06-06','13:10:00',2.98),('8998','2013-06-06','13:15:00',2.97),('8998','2013-06-06','13:20:00',2.94),('8998','2013-06-06','13:25:00',2.92),('8998','2013-06-06','13:30:00',2.9),('8998','2013-06-06','13:35:00',2.85),('8998','2013-06-06','13:40:00',2.81),('8998','2013-06-06','13:45:00',2.79),('8998','2013-06-06','13:50:00',2.76),('8998','2013-06-06','13:55:00',2.75),('8998','2013-06-06','14:00:00',2.71),('8998','2013-06-06','14:05:00',2.68),('8998','2013-06-06','14:10:00',2.63),('8998','2013-06-06','14:15:00',2.61),('8998','2013-06-06','14:20:00',2.56),('8998','2013-06-06','14:25:00',2.52),('8998','2013-06-06','14:30:00',2.5),('8998','2013-06-06','14:35:00',2.47),('8998','2013-06-06','14:40:00',2.45),('8998','2013-06-06','14:45:00',2.42),('8998','2013-06-06','14:50:00',2.39),('8998','2013-06-06','14:55:00',2.34),('8998','2013-06-06','15:00:00',2.3),('8998','2013-06-06','15:05:00',2.29),('8998','2013-06-06','15:10:00',2.29),('8998','2013-06-06','15:15:00',2.22),('8998','2013-06-06','15:20:00',2.13),('8998','2013-06-06','15:25:00',2.09),('8998','2013-06-06','15:30:00',2.06),('8998','2013-06-06','15:35:00',2.02),('8998','2013-06-06','15:40:00',1.94),('8998','2013-06-06','15:45:00',1.91),('8998','2013-06-06','15:50:00',1.85),('8998','2013-06-06','15:55:00',1.8),('8998','2013-06-06','16:00:00',1.76),('8998','2013-06-06','16:05:00',1.69),('8998','2013-06-06','16:10:00',1.64),('8998','2013-06-06','16:15:00',1.55),('8998','2013-06-06','16:20:00',1.5),('8998','2013-06-06','16:25:00',1.47),('8998','2013-06-06','16:30:00',1.4),('8998','2013-06-06','16:35:00',1.35),('8998','2013-06-06','16:40:00',1.32),('8998','2013-06-06','16:45:00',1.27),('8998','2013-06-06','16:50:00',1.21),('8998','2013-06-06','16:55:00',1.16),('8998','2013-06-06','17:00:00',1.1),('8998','2013-06-06','17:05:00',1.05),('8998','2013-06-05','07:50:00',1.19),('8998','2013-06-05','07:55:00',1.51),('8998','2013-06-05','08:00:00',1.62),('8998','2013-06-05','08:05:00',1.21),('8998','2013-06-05','08:10:00',1.36),('8998','2013-06-05','08:15:00',1.38),('8998','2013-06-05','08:20:00',1.57),('8998','2013-06-05','08:25:00',1.78),('8998','2013-06-05','08:30:00',1.78),('8998','2013-06-05','08:35:00',1.78),('8998','2013-06-05','08:40:00',1.76),('8998','2013-06-05','08:45:00',2.07),('8998','2013-06-05','08:50:00',1.98),('8998','2013-06-05','08:55:00',1.96),('8998','2013-06-05','09:00:00',2.04),('8998','2013-06-05','09:05:00',2.39),('8998','2013-06-05','09:10:00',2.48),('8998','2013-06-05','09:15:00',2.6),('8998','2013-06-05','09:20:00',2.62),('8998','2013-06-05','09:25:00',2.68),('8998','2013-06-05','09:30:00',2.68),('8998','2013-06-05','09:35:00',2.74),('8998','2013-06-05','09:40:00',2.81),('8998','2013-06-05','09:45:00',2.83),('8998','2013-06-05','09:50:00',2.84),('8998','2013-06-05','09:55:00',2.79),('8998','2013-06-05','10:00:00',2.84),('8998','2013-06-05','10:05:00',2.94),('8998','2013-06-05','10:10:00',2.94),('8998','2013-06-05','10:15:00',2.96),('8998','2013-06-05','10:20:00',3),('8998','2013-06-05','10:25:00',3.02),('8998','2013-06-05','10:30:00',3),('8998','2013-06-05','10:35:00',2.99),('8998','2013-06-05','10:40:00',3),('8998','2013-06-05','10:45:00',3.05),('8998','2013-06-05','10:50:00',3.04),('8998','2013-06-05','10:55:00',3.05),('8998','2013-06-05','11:00:00',3.08),('8998','2013-06-05','11:05:00',3.05),('8998','2013-06-05','11:10:00',3.06),('8998','2013-06-05','11:15:00',3.09),('8998','2013-06-05','11:20:00',3.08),('8998','2013-06-05','11:25:00',3.08),('8998','2013-06-05','11:30:00',3.07),('8998','2013-06-05','11:35:00',3.08),('8998','2013-06-05','11:40:00',3.11),('8998','2013-06-05','11:45:00',3.07),('8998','2013-06-05','11:50:00',3.04),('8998','2013-06-05','11:55:00',2.99),('8998','2013-06-05','12:00:00',2.99),('8998','2013-06-05','12:05:00',3.06),('8998','2013-06-05','12:10:00',3.09),('8998','2013-06-05','12:15:00',3.07),('8998','2013-06-05','12:20:00',3.06),('8998','2013-06-05','12:25:00',3.05),('8998','2013-06-05','12:30:00',3.06),('8998','2013-06-05','12:35:00',3.02),('8998','2013-06-05','12:40:00',3.01),('8998','2013-06-05','12:45:00',3.01),('8998','2013-06-05','12:50:00',3),('8998','2013-06-05','12:55:00',2.98),('8998','2013-06-05','13:00:00',2.97),('8998','2013-06-05','13:05:00',2.98),('8998','2013-06-05','13:10:00',2.97),('8998','2013-06-05','13:15:00',2.98),('8998','2013-06-05','13:20:00',2.98),('8998','2013-06-05','13:25:00',2.93),('8998','2013-06-05','13:30:00',2.92),('8998','2013-06-05','13:35:00',2.86),('8998','2013-06-05','13:40:00',2.85),('8998','2013-06-05','13:45:00',2.58),('8998','2013-06-05','13:50:00',2.76),('8998','2013-06-05','13:55:00',2.74),('8998','2013-06-05','14:00:00',2.76),('8998','2013-06-05','14:05:00',2.82),('8998','2013-06-05','14:10:00',2.81),('8998','2013-06-05','14:15:00',2.51),('8998','2013-06-05','14:20:00',2.54),('8998','2013-06-05','14:25:00',2.22),('8998','2013-06-05','14:30:00',2.65),('8998','2013-06-05','14:35:00',2.53),('8998','2013-06-05','14:40:00',2.52),('8998','2013-06-05','14:45:00',1.78),('8998','2013-06-05','14:50:00',2.08),('8998','2013-06-05','14:55:00',2.7),('8998','2013-06-05','15:00:00',2.55),('8998','2013-06-05','15:05:00',2.43),('8998','2013-06-05','15:10:00',2.36),('8998','2013-06-05','15:15:00',2.09),('8998','2013-06-05','15:20:00',2.24),('8998','2013-06-05','15:25:00',2.16),('8998','2013-06-05','15:30:00',2.08),('8998','2013-06-05','15:35:00',2),('8998','2013-06-05','15:40:00',2),('8998','2013-06-05','15:45:00',1.96),('8998','2013-06-05','15:50:00',1.88),('8998','2013-06-05','15:55:00',1.78),('8998','2013-06-05','16:00:00',1.84),('8998','2013-06-05','16:05:00',1.78),('8998','2013-06-05','16:10:00',1.6),('8998','2013-06-05','16:15:00',1.55),('8998','2013-06-05','16:20:00',1.47),('8998','2013-06-05','16:25:00',1.46),('8998','2013-06-05','16:30:00',1.43),('8998','2013-06-05','16:35:00',1.41),('8998','2013-06-05','16:40:00',1.35),('8998','2013-06-05','16:45:00',1.24),('8998','2013-06-05','16:50:00',1.17),('8998','2013-06-05','16:55:00',1.12),('8998','2013-06-05','17:00:00',1.06),('8998','2013-06-04','07:55:00',1.41),('8998','2013-06-04','08:00:00',1.42),('8998','2013-06-04','08:10:00',1.32),('8998','2013-06-04','08:15:00',1.56),('8998','2013-06-04','08:20:00',1.79),('8998','2013-06-04','08:25:00',1.78),('8998','2013-06-04','08:30:00',1.78),('8998','2013-06-04','08:35:00',1.75),('8998','2013-06-04','08:40:00',1.74),('8998','2013-06-04','08:45:00',1.79),('8998','2013-06-04','08:50:00',1.9),('8998','2013-06-04','08:55:00',2),('8998','2013-06-04','09:00:00',2.05),('8998','2013-06-04','09:05:00',2.23),('8998','2013-06-04','09:10:00',2.5),('8998','2013-06-04','09:15:00',2.63),('8998','2013-06-04','09:20:00',2.8),('8998','2013-06-04','09:25:00',2.49),('8998','2013-06-04','09:30:00',2.79),('8998','2013-06-04','09:35:00',2.94),('8998','2013-06-04','09:40:00',3.08),('8998','2013-06-04','09:45:00',2.63),('8998','2013-06-04','09:50:00',2.49),('8998','2013-06-04','09:55:00',1.64),('8998','2013-06-04','10:00:00',1.65),('8998','2013-06-04','10:05:00',3.1),('8998','2013-06-04','10:10:00',1.22),('8998','2013-06-04','10:15:00',1.36),('8998','2013-06-04','10:20:00',1.27),('8998','2013-06-04','10:25:00',2.25),('8998','2013-06-04','10:30:00',1.21),('8998','2013-06-04','10:35:00',2.67),('8998','2013-06-04','10:40:00',2.26),('8998','2013-06-04','10:45:00',2.6),('8998','2013-06-04','10:50:00',2.88),('8998','2013-06-04','10:55:00',3.27),('8998','2013-06-04','11:00:00',3.24),('8998','2013-06-04','11:05:00',3.25),('8998','2013-06-04','11:10:00',1.08),('8998','2013-06-04','11:20:00',1.16),('8998','2013-06-04','11:35:00',1.45),('8998','2013-06-04','11:40:00',2.12),('8998','2013-06-04','11:45:00',3.37),('8998','2013-06-04','11:50:00',2.47),('8998','2013-06-04','11:55:00',2.61),('8998','2013-06-04','12:00:00',1.1),('8998','2013-06-04','12:05:00',2.67),('8998','2013-06-04','12:10:00',3.61),('8998','2013-06-04','12:15:00',1.74),('8998','2013-06-04','12:20:00',3.05),('8998','2013-06-04','12:25:00',3.62),('8998','2013-06-04','12:30:00',3.02),('8998','2013-06-04','12:35:00',3.14),('8998','2013-06-04','12:40:00',3.24),('8998','2013-06-04','12:45:00',2.92),('8998','2013-06-04','12:50:00',2.41),('8998','2013-06-04','12:55:00',1.03),('8998','2013-06-04','13:00:00',1.31),('8998','2013-06-04','13:05:00',2.35),('8998','2013-06-04','13:10:00',1.7),('8998','2013-06-04','13:15:00',1.37),('8998','2013-06-04','13:20:00',1.97),('8998','2013-06-04','13:25:00',2.68),('8998','2013-06-04','13:30:00',2.29),('8998','2013-06-04','13:35:00',3.56),('8998','2013-06-04','13:40:00',3.3),('8998','2013-06-04','13:45:00',3.16),('8998','2013-06-04','13:50:00',3),('8998','2013-06-04','13:55:00',2.95),('8998','2013-06-04','14:00:00',2.88),('8998','2013-06-04','14:05:00',2.82),('8998','2013-06-04','14:10:00',2.77),('8998','2013-06-04','14:15:00',2.75),('8998','2013-06-04','14:20:00',2.73),('8998','2013-06-04','14:25:00',2.66),('8998','2013-06-04','14:30:00',2.61),('8998','2013-06-04','14:35:00',2.55),('8998','2013-06-04','14:40:00',2.56),('8998','2013-06-04','14:45:00',2.56),('8998','2013-06-04','14:50:00',2.51),('8998','2013-06-04','14:55:00',2.46),('8998','2013-06-04','15:00:00',2.37),('8998','2013-06-04','15:05:00',2.31),('8998','2013-06-04','15:10:00',2.28),('8998','2013-06-04','15:15:00',2.25),('8998','2013-06-04','15:20:00',2.14),('8998','2013-06-04','15:25:00',2.19),('8998','2013-06-04','15:30:00',2.14),('8998','2013-06-04','15:35:00',2),('8998','2013-06-04','15:40:00',2),('8998','2013-06-04','15:45:00',2.03),('8998','2013-06-04','15:50:00',1.97),('8998','2013-06-04','15:55:00',1.9),('8998','2013-06-04','16:00:00',1.83),('8998','2013-06-04','16:05:00',1.78),('8998','2013-06-04','16:10:00',1.69),('8998','2013-06-04','16:15:00',1.65),('8998','2013-06-04','16:20:00',1.58),('8998','2013-06-04','16:25:00',1.53),('8998','2013-06-04','16:30:00',1.44),('8998','2013-06-04','16:35:00',1.4),('8998','2013-06-04','16:40:00',1.35),('8998','2013-06-04','16:45:00',1.29),('8998','2013-06-04','16:50:00',1.25),('8998','2013-06-04','16:55:00',1.19),('8998','2013-06-04','17:00:00',1.13),('8998','2013-06-04','17:05:00',1.06),('8998','2013-06-03','07:20:00',1.02),('8998','2013-06-03','07:25:00',1.04),('8998','2013-06-03','07:35:00',1.15),('8998','2013-06-03','07:40:00',1.28),('8998','2013-06-03','07:45:00',1.38),('8998','2013-06-03','07:50:00',1.46),('8998','2013-06-03','07:55:00',1.55),('8998','2013-06-03','08:00:00',1.66),('8998','2013-06-03','08:05:00',1.74),('8998','2013-06-03','08:10:00',1.73),('8998','2013-06-03','08:15:00',1.81),('8998','2013-06-03','08:20:00',1.97),('8998','2013-06-03','08:25:00',1.81),('8998','2013-06-03','08:30:00',1.66),('8998','2013-06-03','08:35:00',2.15),('8998','2013-06-03','08:40:00',1.92),('8998','2013-06-03','08:45:00',1.68),('8998','2013-06-03','08:50:00',1.04),('8998','2013-06-03','08:55:00',1.08),('8998','2013-06-03','09:00:00',1.25),('8998','2013-06-03','09:05:00',1.58),('8998','2013-06-03','09:10:00',1.92),('8998','2013-06-03','09:15:00',2.51),('8998','2013-06-03','09:20:00',2.56),('8998','2013-06-03','09:25:00',3.32),('8998','2013-06-03','09:30:00',2.57),('8998','2013-06-03','09:35:00',2.34),('8998','2013-06-03','09:40:00',1.36),('8998','2013-06-03','09:45:00',1.43),('8998','2013-06-03','09:50:00',1.24),('8998','2013-06-03','09:55:00',1.17),('8998','2013-06-03','10:00:00',1.48),('8998','2013-06-03','10:05:00',1.68),('8998','2013-06-03','10:10:00',2.68),('8998','2013-06-03','10:15:00',2.39),('8998','2013-06-03','10:20:00',1.43),('8998','2013-06-03','10:25:00',1.33),('8998','2013-06-03','10:30:00',1.25),('8998','2013-06-03','10:35:00',1.31),('8998','2013-06-03','10:40:00',1.36),('8998','2013-06-03','10:45:00',1.57),('8998','2013-06-03','10:50:00',2.17),('8998','2013-06-03','10:55:00',2.73),('8998','2013-06-03','11:00:00',1.77),('8998','2013-06-03','11:05:00',2.06),('8998','2013-06-03','11:10:00',2.62),('8998','2013-06-03','11:15:00',2.39),('8998','2013-06-03','11:20:00',1.67),('8998','2013-06-03','11:25:00',2.2),('8998','2013-06-03','11:30:00',2.64),('8998','2013-06-03','11:35:00',2.18),('8998','2013-06-03','11:40:00',2.36),('8998','2013-06-03','11:45:00',3.14),('8998','2013-06-03','11:50:00',3.46),('8998','2013-06-03','11:55:00',3.12),('8998','2013-06-03','12:00:00',2.47),('8998','2013-06-03','12:05:00',2.12),('8998','2013-06-03','12:10:00',1.8),('8998','2013-06-03','12:15:00',1.89),('8998','2013-06-03','12:20:00',1.33),('8998','2013-06-03','12:25:00',1.46),('8998','2013-06-03','12:30:00',1.96),('8998','2013-06-03','12:35:00',2.81),('8998','2013-06-03','12:40:00',1.81),('8998','2013-06-03','12:45:00',2.05),('8998','2013-06-03','12:50:00',1.75),('8998','2013-06-03','12:55:00',1.41),('8998','2013-06-03','13:00:00',1.56),('8998','2013-06-03','13:05:00',1.13),('8998','2013-06-03','13:15:00',1.01),('8998','2013-06-03','13:25:00',1.07),('8998','2013-06-03','13:30:00',1.29),('8998','2013-06-03','13:35:00',3.06),('8998','2013-06-03','13:40:00',2.88),('8998','2013-06-03','13:45:00',3.64),('8998','2013-06-03','13:50:00',3.61),('8998','2013-06-03','13:55:00',1.87),('8998','2013-06-03','14:00:00',1.27),('8998','2013-06-03','14:05:00',2.95),('8998','2013-06-03','14:10:00',3.35),('8998','2013-06-03','14:15:00',3.09),('8998','2013-06-03','14:20:00',2.3),('8998','2013-06-03','14:25:00',1.63),('8998','2013-06-03','14:30:00',1.03),('8998','2013-06-03','14:35:00',1.27),('8998','2013-06-03','14:40:00',1.65),('8998','2013-06-03','14:55:00',2.24),('8998','2013-06-03','15:00:00',3.4),('8998','2013-06-03','15:05:00',3.28),('8998','2013-06-03','15:10:00',1.65),('8998','2013-06-02','07:45:00',1.33),('8998','2013-06-02','07:50:00',1.33),('8998','2013-06-02','07:55:00',1.46),('8998','2013-06-02','08:00:00',1.53),('8998','2013-06-02','08:05:00',1.52),('8998','2013-06-02','08:10:00',1.53),('8998','2013-06-02','08:15:00',1.6),('8998','2013-06-02','08:20:00',1.76),('8998','2013-06-02','08:25:00',1.75),('8998','2013-06-02','08:30:00',1.77),('8998','2013-06-02','08:35:00',1.73),('8998','2013-06-02','08:40:00',1.76),('8998','2013-06-02','08:45:00',1.79),('8998','2013-06-02','08:50:00',1.93),('8998','2013-06-02','08:55:00',1.93),('8998','2013-06-02','09:00:00',2.06),('8998','2013-06-02','09:05:00',2.19),('8998','2013-06-02','09:10:00',2.54),('8998','2013-06-02','09:15:00',2.68),('8998','2013-06-02','09:20:00',2.19),('8998','2013-06-02','09:25:00',2.41),('8998','2013-06-02','09:30:00',2.26),('8998','2013-06-02','09:35:00',1.57),('8998','2013-06-02','09:40:00',1.77),('8998','2013-06-02','09:45:00',2.23),('8998','2013-06-02','09:50:00',3),('8998','2013-06-02','09:55:00',3.27),('8998','2013-06-02','10:00:00',3.48),('8998','2013-06-02','10:05:00',3.49),('8998','2013-06-02','10:10:00',2.96),('8998','2013-06-02','10:15:00',1.96),('8998','2013-06-02','10:20:00',1.09),('8998','2013-06-02','10:25:00',1.29),('8998','2013-06-02','10:30:00',1.02),('8998','2013-06-02','10:35:00',1.01),('8998','2013-06-02','10:40:00',1.25),('8998','2013-06-02','10:45:00',1.36),('8998','2013-06-02','10:50:00',2.55),('8998','2013-06-02','10:55:00',3.74),('8998','2013-06-02','11:00:00',1.68),('8998','2013-06-02','11:05:00',1.26),('8998','2013-06-02','11:15:00',1.05),('8998','2013-06-02','11:20:00',1.25),('8998','2013-06-02','11:25:00',1.28),('8998','2013-06-02','11:30:00',1.09),('8998','2013-06-02','11:35:00',1.01),('8998','2013-06-02','11:40:00',1.11),('8998','2013-06-02','11:45:00',1.96),('8998','2013-06-02','11:50:00',1.23),('8998','2013-06-02','11:55:00',1.21),('8998','2013-06-02','12:00:00',1.23),('8998','2013-06-02','12:05:00',2.94),('8998','2013-06-02','12:10:00',1.27),('8998','2013-06-02','12:15:00',1.03),('8998','2013-06-02','12:20:00',1.15),('8998','2013-06-02','12:25:00',1.09),('8998','2013-06-02','12:30:00',1.22),('8998','2013-06-02','12:35:00',1.25),('8998','2013-06-02','12:40:00',2.94),('8998','2013-06-02','12:45:00',1.74),('8998','2013-06-02','12:50:00',1.94),('8998','2013-06-02','12:55:00',1.89),('8998','2013-06-02','13:00:00',1.43),('8998','2013-06-02','13:05:00',1.26),('8998','2013-06-02','13:10:00',1.36),('8998','2013-06-02','13:15:00',1.79),('8998','2013-06-02','13:20:00',3.48),('8998','2013-06-02','13:25:00',2.37),('8998','2013-06-02','13:30:00',2.59),('8998','2013-06-02','13:35:00',2.82),('8998','2013-06-02','13:40:00',3.33),('8998','2013-06-02','13:45:00',1.62),('8998','2013-06-02','13:50:00',3.37),('8998','2013-06-02','13:55:00',2.08),('8998','2013-06-02','14:00:00',2.86),('8998','2013-06-02','14:05:00',2.87),('8998','2013-06-02','14:10:00',1.55),('8998','2013-06-02','14:15:00',1.47),('8998','2013-06-02','14:20:00',1.15),('8998','2013-06-02','14:25:00',1.84),('8998','2013-06-02','14:30:00',2.93),('8998','2013-06-02','14:35:00',3.04),('8998','2013-06-02','14:40:00',2.21),('8998','2013-06-02','14:45:00',2.33),('8998','2013-06-02','14:50:00',2.03),('8998','2013-06-02','14:55:00',2.17),('8998','2013-06-02','15:00:00',2.29),('8998','2013-06-02','15:05:00',1.94),('8998','2013-06-02','15:10:00',2.28),('8998','2013-06-02','15:15:00',1.53),('8998','2013-06-02','15:20:00',1.9),('8998','2013-06-02','15:25:00',2.24),('8998','2013-06-02','15:30:00',2.15),('8998','2013-06-02','15:35:00',2.11),('8998','2013-06-02','15:40:00',2.05),('8998','2013-06-02','15:45:00',2),('8998','2013-06-02','15:50:00',1.96),('8998','2013-06-02','15:55:00',1.93),('8998','2013-06-02','16:00:00',1.87),('8998','2013-06-02','16:05:00',1.82),('8998','2013-06-02','16:10:00',1.79),('8998','2013-06-02','16:15:00',1.68),('8998','2013-06-02','16:20:00',1.64),('8998','2013-06-02','16:25:00',1.61),('8998','2013-06-02','16:30:00',1.67),('8998','2013-06-02','16:35:00',1.59),('8998','2013-06-02','16:40:00',1.59),('8998','2013-06-02','16:45:00',1.4),('8998','2013-06-02','16:50:00',1.14),('8998','2013-06-02','16:55:00',1.06),('8998','2013-06-02','17:00:00',1.24),('8998','2013-06-02','17:05:00',1.38),('8998','2013-06-02','17:10:00',1.44),('8998','2013-06-02','17:15:00',1.27),('8998','2013-06-02','17:20:00',1.15),('8998','2013-06-01','09:15:00',1.02),('8998','2013-06-01','09:20:00',1.59),('8998','2013-06-01','09:25:00',3.18),('8998','2013-06-01','09:30:00',2.99),('8998','2013-06-01','09:35:00',2.92),('8998','2013-06-01','09:40:00',2.9),('8998','2013-06-01','09:45:00',2.9),('8998','2013-06-01','09:50:00',2.93),('8998','2013-06-01','09:55:00',2.95),('8998','2013-06-01','10:00:00',2.94),('8998','2013-06-01','10:05:00',3.04),('8998','2013-06-01','10:10:00',3.05),('8998','2013-06-01','10:15:00',3.03),('8998','2013-06-01','10:20:00',3.04),('8998','2013-06-01','10:25:00',3.11),('8998','2013-06-01','10:30:00',3.16),('8998','2013-06-01','10:35:00',3.25),('8998','2013-06-01','10:40:00',3.29),('8998','2013-06-01','10:45:00',2.63),('8998','2013-06-01','10:50:00',1.29),('8998','2013-06-01','10:55:00',1.18),('8998','2013-06-01','11:00:00',3.4),('8998','2013-06-01','11:05:00',3.07),('8998','2013-06-01','11:10:00',3.39),('8998','2013-06-01','11:15:00',2.33),('8998','2013-06-01','11:20:00',2.95),('8998','2013-06-01','11:25:00',1.83),('8998','2013-06-01','11:30:00',3.32),('8998','2013-06-01','11:35:00',1.75),('8998','2013-06-01','11:40:00',1.25),('8998','2013-06-01','11:50:00',1.35),('8998','2013-06-01','11:55:00',3.28),('8998','2013-06-01','12:00:00',3.05),('8998','2013-06-01','12:05:00',1.88),('8998','2013-06-01','12:10:00',2.75),('8998','2013-06-01','12:15:00',3.46),('8998','2013-06-01','12:20:00',1.81),('8998','2013-06-01','12:25:00',1.81),('8998','2013-06-01','12:30:00',2.84),('8998','2013-06-01','12:35:00',3.66),('8998','2013-06-01','12:40:00',2.41),('8998','2013-06-01','12:45:00',3.33),('8998','2013-06-01','12:50:00',1.7),('8998','2013-06-01','13:00:00',2.03),('8998','2013-06-01','13:05:00',1.87),('8998','2013-06-01','13:10:00',1.39),('8998','2013-06-01','13:15:00',3.58),('8998','2013-06-01','13:20:00',3.24),('8998','2013-06-01','13:25:00',3.08),('8998','2013-06-01','13:30:00',3.01),('8998','2013-06-01','13:35:00',2.97),('8998','2013-06-01','13:40:00',2.93),('8998','2013-06-01','13:45:00',2.88),('8998','2013-06-01','13:50:00',2.84),('8998','2013-06-01','13:55:00',2.82),('8998','2013-06-01','14:00:00',2.8),('8998','2013-06-01','14:05:00',2.76),('8998','2013-06-01','14:10:00',2.74),('8998','2013-06-01','14:15:00',2.74),('8998','2013-06-01','14:20:00',2.63),('8998','2013-06-01','14:25:00',2.66),('8998','2013-06-01','14:30:00',2.62),('8998','2013-06-01','14:35:00',2.56),('8998','2013-06-01','14:40:00',2.53),('8998','2013-06-01','14:45:00',2.49),('8998','2013-06-01','14:50:00',2.43),('8998','2013-06-01','14:55:00',2.41),('8998','2013-06-01','15:00:00',2.35),('8998','2013-06-01','15:05:00',2.32),('8998','2013-06-01','15:10:00',2.28),('8998','2013-06-01','15:15:00',2.26),('8998','2013-06-01','15:20:00',2.2),('8998','2013-06-01','15:25:00',1.96),('8998','2013-06-01','15:30:00',1.92),('8998','2013-06-01','15:35:00',1.88),('8998','2013-06-01','15:40:00',1.54),('8998','2013-06-01','15:45:00',1.61),('8998','2013-06-01','15:50:00',1.91),('8998','2013-06-01','15:55:00',1.69),('8998','2013-06-01','16:00:00',1.7),('8998','2013-06-01','16:05:00',1.75),('8998','2013-06-01','16:10:00',1.78),('8998','2013-06-01','16:15:00',1.74),('8998','2013-06-01','16:20:00',1.58),('8998','2013-06-01','16:25:00',1.59),('8998','2013-06-01','16:30:00',1.49),('8998','2013-06-01','16:35:00',1.4),('8998','2013-06-01','16:40:00',1.46),('8998','2013-06-01','16:45:00',1.34),('8998','2013-06-01','16:50:00',1.21),('8998','2013-06-01','16:55:00',1.25),('8998','2013-06-01','17:00:00',1.1),('8998','2013-06-01','17:10:00',1.05),('8998','2013-05-31','07:15:00',1.08),('8998','2013-05-31','07:20:00',1.25),('8998','2013-05-31','07:25:00',1.27),('8998','2013-05-31','07:30:00',1.22),('8998','2013-05-31','07:35:00',1.23),('8998','2013-05-31','07:40:00',1.36),('8998','2013-05-31','07:45:00',1.51),('8998','2013-05-31','07:55:00',1.29),('8998','2013-05-31','08:15:00',1.04),('8998','2013-05-31','08:20:00',1.27),('8998','2013-05-31','08:35:00',1.58),('8998','2013-05-31','10:50:00',1.42),('8998','2013-05-31','10:55:00',1.76),('8998','2013-05-31','11:55:00',1.32),('8998','2013-05-31','12:00:00',1.56),('8998','2013-05-31','12:05:00',2.19),('8998','2013-05-31','12:10:00',2.32),('8998','2013-05-31','12:15:00',1.26),('8998','2013-05-31','12:45:00',1.05),('8998','2013-05-31','12:50:00',1.34),('8998','2013-05-31','12:55:00',1.26),('8998','2013-05-31','13:00:00',1.46),('8998','2013-05-31','13:05:00',1.64),('8998','2013-05-31','13:10:00',1.7),('8998','2013-05-31','13:15:00',1.89),('8998','2013-05-31','13:20:00',1.77),('8998','2013-05-31','13:25:00',1.36),('8998','2013-05-31','13:30:00',1.24),('8998','2013-05-31','13:55:00',1.03),('8998','2013-05-31','14:00:00',1.3),('8998','2013-05-31','14:05:00',1.71),('8998','2013-05-31','14:10:00',1.71),('8998','2013-05-31','14:15:00',1.77),('8998','2013-05-31','14:20:00',1.98),('8998','2013-05-31','14:25:00',1.3),('8998','2013-05-31','14:30:00',1),('8998','2013-05-31','14:35:00',1.04),('8998','2013-05-31','14:40:00',1.01),('8998','2014-04-01','08:55:00',1.86),('8998','2014-04-01','09:00:00',1.14),('8998','2014-04-01','09:55:00',1.14),('8998','2014-04-01','10:00:00',2.28),('8998','2014-04-01','10:05:00',2),('8998','2014-04-01','10:10:00',2.58),('8998','2014-04-01','10:15:00',2.69),('8998','2014-04-01','10:20:00',2.57),('8998','2014-04-01','10:25:00',2.35),('8998','2014-04-01','10:50:00',2.07),('8998','2014-04-01','10:55:00',2.87),('8998','2014-04-01','11:00:00',2.73),('8998','2014-04-01','11:05:00',2.6),('8998','2014-04-01','11:10:00',1.4),('8998','2014-04-01','11:15:00',2.13),('8998','2014-04-01','11:20:00',2.46),('8998','2014-04-01','11:25:00',2.98),('8998','2014-04-01','11:30:00',1.81),('8998','2014-04-01','11:35:00',1.35),('8998','2014-04-01','11:40:00',1.51),('8998','2014-04-01','11:45:00',1.76),('8998','2014-04-01','11:50:00',3.12),('8998','2014-04-01','11:55:00',3.07),('8998','2014-04-01','12:00:00',2.97),('8998','2014-04-01','12:05:00',1.94),('8998','2014-04-01','12:15:00',1.81),('8998','2014-04-01','12:20:00',2.91),('8998','2014-04-01','12:25:00',3.12),('8998','2014-04-01','12:30:00',2.91),('8998','2014-04-01','12:35:00',2.29),('8998','2014-04-01','12:40:00',2.3),('8998','2014-04-01','12:45:00',2.66),('8998','2014-04-01','12:50:00',2.87),('8998','2014-04-01','12:55:00',1.69),('8998','2014-04-01','13:00:00',2.1),('8998','2014-04-01','13:05:00',1.75),('8998','2014-04-01','13:10:00',2.23),('8998','2014-04-01','13:15:00',1.44),('8998','2014-04-01','13:20:00',1.71),('8998','2014-04-01','13:25:00',1.43),('8998','2014-04-01','13:30:00',2.1),('8998','2014-04-01','13:35:00',2.13),('8998','2014-04-01','13:40:00',2.04),('8998','2014-04-01','13:45:00',2.85),('8998','2014-04-01','13:50:00',2.64),('8998','2014-04-01','13:55:00',2.63),('8998','2014-04-01','14:00:00',2.6),('8998','2014-04-01','14:05:00',2.48),('8998','2014-04-01','14:10:00',2.52),('8998','2014-04-01','14:15:00',2.5),('8998','2014-04-01','14:20:00',2.39),('8998','2014-04-01','14:25:00',2.4),('8998','2014-04-01','14:30:00',2.31),('8998','2014-04-01','14:35:00',2.17),('8998','2014-04-01','14:40:00',2.27),('8998','2014-04-01','14:45:00',2.18),('8998','2014-04-01','14:50:00',1.72),('8998','2014-04-01','14:55:00',1.69),('8998','2014-04-01','15:00:00',1.96),('8998','2014-04-01','15:05:00',1.91),('8998','2014-04-01','15:10:00',1.75),('8998','2014-04-01','15:15:00',1.72),('8998','2014-04-01','15:20:00',1.7),('8998','2014-04-01','15:25:00',1.64),('8998','2014-04-01','15:30:00',1.53),('8998','2014-04-01','15:35:00',1.46),('8998','2014-04-01','15:40:00',1.52),('8998','2014-04-01','15:45:00',1.5),('8998','2014-04-01','15:50:00',1.44),('8998','2014-04-01','15:55:00',1.25),('8998','2014-04-01','16:00:00',1.26),('8998','2014-04-01','16:05:00',1.22),('8998','2014-04-01','16:10:00',1.15),('8998','2014-04-01','16:15:00',1.1),('8998','2014-04-01','16:20:00',1.03),('8998','2013-05-30','07:15:00',1.11),('8998','2013-05-30','07:20:00',1.22),('8998','2013-05-30','07:25:00',1.31),('8998','2013-05-30','07:30:00',1.26),('8998','2013-05-30','07:35:00',1.3),('8998','2013-05-30','07:40:00',1.34),('8998','2013-05-30','07:45:00',1.46),('8998','2013-05-30','07:50:00',1.41),('8998','2013-05-30','07:55:00',1.48),('8998','2013-05-30','08:00:00',1.59),('8998','2013-05-30','08:05:00',1.66),('8998','2013-05-30','08:10:00',1.97),('8998','2013-05-30','08:15:00',1.85),('8998','2013-05-30','08:20:00',1.81),('8998','2013-05-30','08:25:00',1.78),('8998','2013-05-30','08:30:00',1.84),('8998','2013-05-30','08:35:00',1.32),('8998','2013-05-30','08:40:00',2.53),('8998','2013-05-30','08:45:00',2.43),('8998','2013-05-30','08:50:00',2.84),('8998','2013-05-30','08:55:00',1.57),('8998','2013-05-30','09:15:00',1.65),('8998','2013-05-30','09:35:00',1.68),('8998','2013-05-30','09:40:00',1.71),('8998','2013-05-30','09:45:00',3.25),('8998','2013-05-30','09:50:00',3.22),('8998','2013-05-30','09:55:00',3.27),('8998','2013-05-30','10:00:00',3),('8998','2013-05-30','10:05:00',2.84),('8998','2013-05-30','10:10:00',2.06),('8998','2013-05-30','10:15:00',1.8),('8998','2013-05-30','10:20:00',2.41),('8998','2013-05-30','10:35:00',1.74),('8998','2013-05-30','10:40:00',2.64),('8998','2013-05-30','10:45:00',3.77),('8998','2013-05-30','10:50:00',1.95),('8998','2013-05-30','10:55:00',2.32),('8998','2013-05-30','11:00:00',1.21),('8998','2013-05-30','11:05:00',1.42),('8998','2013-05-30','11:10:00',2.99),('8998','2013-05-30','11:15:00',3.11),('8998','2013-05-30','11:20:00',1.35),('8998','2013-05-30','11:25:00',2.28),('8998','2013-05-30','11:30:00',3.6),('8998','2013-05-30','11:35:00',1.35),('8998','2013-05-30','11:45:00',2.57),('8998','2013-05-30','11:50:00',2.97),('8998','2013-05-30','11:55:00',1.84),('8998','2013-05-30','12:00:00',2.32),('8998','2013-05-30','12:05:00',3.31),('8998','2013-05-30','12:10:00',2.75),('8998','2013-05-30','12:15:00',1.25),('8998','2013-05-30','12:20:00',1.18),('8998','2013-05-30','12:25:00',2.64),('8998','2013-05-30','12:30:00',1.36),('8998','2013-05-30','12:35:00',1.11),('8998','2013-05-30','12:40:00',3.23),('8998','2013-05-30','12:45:00',2.05),('8998','2013-05-30','12:55:00',1.07),('8998','2013-05-30','13:00:00',3.36),('8998','2013-05-30','13:05:00',1.75),('8998','2013-05-30','13:25:00',1.35),('8998','2013-05-30','13:30:00',2.27),('8998','2013-05-30','13:35:00',3.33),('8998','2013-05-30','13:40:00',2.01),('8998','2013-05-30','13:45:00',1.15),('8998','2013-05-30','14:00:00',1.88),('8998','2013-05-30','15:10:00',1.17),('8998','2013-05-30','15:15:00',1.63),('8998','2013-05-30','15:20:00',2.89),('8998','2013-05-30','15:25:00',1.41),('8998','2013-05-30','15:30:00',1.75),('8998','2013-05-30','15:35:00',1.48),('8998','2013-05-30','15:40:00',1.32),('8998','2013-05-30','15:45:00',1.14),('8998','2013-05-30','15:50:00',1.25),('8998','2013-05-30','15:55:00',1.46),('8998','2013-05-30','16:00:00',1.17),('8998','2013-05-29','08:25:00',1.02),('8998','2013-05-29','08:40:00',2.44),('8998','2013-05-29','08:45:00',2.52),('8998','2013-05-29','08:50:00',2.54),('8998','2013-05-29','08:55:00',2.56),('8998','2013-05-29','09:00:00',2.56),('8998','2013-05-29','09:05:00',2.6),('8998','2013-05-29','09:10:00',2.68),('8998','2013-05-29','09:15:00',2.74),('8998','2013-05-29','09:20:00',2.75),('8998','2013-05-29','09:25:00',2.99),('8998','2013-05-29','09:30:00',3.09),('8998','2013-05-29','09:35:00',3),('8998','2013-05-29','09:40:00',3.04),('8998','2013-05-29','09:45:00',2.75),('8998','2013-05-29','09:50:00',3.18),('8998','2013-05-29','09:55:00',2.27),('8998','2013-05-29','10:05:00',1.03),('8998','2013-05-29','10:10:00',3.18),('8998','2013-05-29','10:15:00',1.03),('8998','2013-05-29','10:20:00',3.23),('8998','2013-05-29','10:25:00',1.01),('8998','2013-05-29','10:40:00',1.35),('8998','2013-05-29','10:45:00',3.08),('8998','2013-05-29','10:50:00',3.65),('8998','2013-05-29','10:55:00',3.41),('8998','2013-05-29','11:00:00',3.35),('8998','2013-05-29','11:05:00',3.15),('8998','2013-05-29','11:10:00',1.6),('8998','2013-05-29','11:15:00',1.11),('8998','2013-05-29','11:20:00',3.45),('8998','2013-05-29','11:25:00',1.97),('8998','2013-05-29','11:30:00',2.07),('8998','2013-05-29','11:35:00',3.16),('8998','2013-05-29','11:40:00',3.78),('8998','2013-05-29','11:45:00',2.47),('8998','2013-05-29','11:50:00',3.74),('8998','2013-05-29','11:55:00',1.02),('8998','2013-05-29','12:00:00',1.87),('8998','2013-05-29','12:05:00',3.76),('8998','2013-05-29','12:10:00',3.18),('8998','2013-05-29','12:15:00',2.58),('8998','2013-05-29','12:20:00',3.59),('8998','2013-05-29','12:25:00',2.76),('8998','2013-05-29','12:30:00',2.96),('8998','2013-05-29','12:35:00',2.82),('8998','2013-05-29','12:40:00',2.78),('8998','2013-05-29','12:45:00',1.53),('8998','2013-05-29','12:50:00',2.73),('8998','2013-05-29','12:55:00',3.33),('8998','2013-05-29','13:00:00',2.65),('8998','2013-05-29','13:05:00',1.38),('8998','2013-05-29','13:10:00',1.33),('8998','2013-05-29','13:15:00',1.8),('8998','2013-05-29','13:20:00',1.49),('8998','2013-05-29','13:25:00',1.49),('8998','2013-05-29','13:30:00',1.82),('8998','2013-05-29','13:35:00',1.22),('8998','2013-05-29','13:40:00',2.64),('8998','2013-05-29','13:45:00',2.39),('8998','2013-05-29','13:50:00',1.13),('8998','2013-05-29','13:55:00',1.34),('8998','2013-05-29','14:00:00',3.09),('8998','2013-05-29','14:05:00',3.35),('8998','2013-05-29','14:10:00',2.6),('8998','2013-05-29','14:15:00',1.48),('8998','2013-05-29','14:20:00',2.87),('8998','2013-05-29','14:25:00',1.55),('8998','2013-05-29','14:30:00',3.07),('8998','2013-05-29','14:35:00',2.4),('8998','2013-05-29','14:40:00',2.86),('8998','2013-05-29','14:45:00',2.77),('8998','2013-05-29','14:50:00',2.79),('8998','2013-05-29','14:55:00',2.65),('8998','2013-05-29','15:00:00',2.59),('8998','2013-05-29','15:05:00',2.57),('8998','2013-05-29','15:15:00',2.41),('8998','2013-05-29','15:20:00',2.5),('8998','2013-05-29','15:25:00',2.39),('8998','2013-05-29','15:30:00',2.36),('8998','2013-05-29','15:35:00',2.43),('8998','2013-05-29','15:40:00',2.35),('8998','2013-05-29','15:45:00',1.86),('8998','2013-05-29','15:50:00',2),('8998','2013-05-29','15:55:00',1.62),('8998','2013-05-29','16:00:00',2.37),('8998','2013-05-29','16:05:00',1.92),('8998','2013-05-29','16:10:00',1.97),('8998','2013-05-29','16:15:00',1.82),('8998','2013-05-29','16:20:00',1.61),('8998','2013-05-29','16:25:00',1.35),('8998','2013-05-29','16:45:00',1.08),('8998','2013-05-29','16:50:00',1.22),('8998','2013-05-29','16:55:00',1.2),('8998','2013-05-28','07:15:00',1.09),('8998','2013-05-28','07:20:00',1.21),('8998','2013-05-28','07:25:00',1.21),('8998','2013-05-28','07:30:00',1.19),('8998','2013-05-28','07:35:00',1.28),('8998','2013-05-28','07:40:00',1.37),('8998','2013-05-28','07:45:00',1.4),('8998','2013-05-28','07:50:00',1.32),('8998','2013-05-28','07:55:00',1.34),('8998','2013-05-28','08:00:00',1.65),('8998','2013-05-28','08:05:00',1.9),('8998','2013-05-28','08:10:00',1.88),('8998','2013-05-28','08:15:00',1.75),('8998','2013-05-28','08:20:00',1.71),('8998','2013-05-28','08:25:00',1.68),('8998','2013-05-28','08:30:00',1.69),('8998','2013-05-28','08:35:00',1.67),('8998','2013-05-28','08:40:00',1.74),('8998','2013-05-28','08:45:00',1.79),('8998','2013-05-28','08:50:00',1.91),('8998','2013-05-28','08:55:00',1.97),('8998','2013-05-28','09:00:00',2.36),('8998','2013-05-28','09:05:00',2.48),('8998','2013-05-28','09:10:00',2.57),('8998','2013-05-28','09:15:00',2.69),('8998','2013-05-28','09:20:00',2.76),('8998','2013-05-28','09:25:00',2.79),('8998','2013-05-28','09:30:00',2.81),('8998','2013-05-28','09:35:00',2.84),('8998','2013-05-28','09:40:00',2.88),('8998','2013-05-28','09:45:00',2.92),('8998','2013-05-28','09:50:00',2.93),('8998','2013-05-28','09:55:00',2.96),('8998','2013-05-28','10:00:00',2.97),('8998','2013-05-28','10:05:00',3),('8998','2013-05-28','10:10:00',3.01),('8998','2013-05-28','10:15:00',3.02),('8998','2013-05-28','10:20:00',3.08),('8998','2013-05-28','10:25:00',3.11),('8998','2013-05-28','10:30:00',3.14),('8998','2013-05-28','10:35:00',3.17),('8998','2013-05-28','10:40:00',3.18),('8998','2013-05-28','10:45:00',3.22),('8998','2013-05-28','10:50:00',3.22),('8998','2013-05-28','10:55:00',3.25),('8998','2013-05-28','11:00:00',3.26),('8998','2013-05-28','11:05:00',3.29),('8998','2013-05-28','11:10:00',3.31),('8998','2013-05-28','11:15:00',2.53),('8998','2013-05-28','11:20:00',2.89),('8998','2013-05-28','11:25:00',2),('8998','2013-05-28','11:30:00',3.48),('8998','2013-05-28','11:35:00',3.49),('8998','2013-05-28','11:40:00',2.84),('8998','2013-05-28','11:45:00',2.99),('8998','2013-05-28','11:50:00',2.82),('8998','2013-05-28','11:55:00',2.73),('8998','2013-05-28','12:00:00',3.43),('8998','2013-05-28','12:05:00',2.8),('8998','2013-05-28','12:10:00',2.72),('8998','2013-05-28','12:15:00',2.76),('8998','2013-05-28','12:20:00',3.51),('8998','2013-05-28','12:25:00',3.31),('8998','2013-05-28','12:30:00',3.31),('8998','2013-05-28','12:35:00',3.29),('8998','2013-05-28','12:40:00',3.28),('8998','2013-05-28','12:45:00',3.1),('8998','2013-05-28','12:50:00',3.14),('8998','2013-05-28','12:55:00',3.14),('8998','2013-05-28','13:00:00',3.21),('8998','2013-05-28','13:05:00',3.24),('8998','2013-05-28','13:10:00',2.6),('8998','2013-05-28','13:15:00',3.16),('8998','2013-05-28','13:20:00',3.46),('8998','2013-05-28','13:25:00',3.48),('8998','2013-05-28','13:30:00',3.35),('8998','2013-05-28','13:35:00',2.78),('8998','2013-05-28','13:40:00',3.05),('8998','2013-05-28','13:45:00',2.93),('8998','2013-05-28','13:50:00',2.67),('8998','2013-05-28','13:55:00',2.51),('8998','2013-05-28','14:00:00',2.99),('8998','2013-05-28','14:05:00',2.89),('8998','2013-05-28','14:10:00',2.75),('8998','2013-05-28','14:15:00',2.81),('8998','2013-05-28','14:20:00',2.78),('8998','2013-05-28','14:25:00',2.31),('8998','2013-05-28','14:30:00',2.73),('8998','2013-05-28','14:35:00',2.12),('8998','2013-05-28','14:40:00',2.84),('8998','2013-05-28','14:45:00',2.74),('8998','2013-05-28','14:50:00',2.49),('8998','2013-05-28','14:55:00',2.54),('8998','2013-05-28','15:00:00',2.65),('8998','2013-05-28','15:05:00',2.64),('8998','2013-05-28','15:10:00',2.51),('8998','2013-05-28','15:15:00',1.59),('8998','2013-05-28','15:20:00',1.84),('8998','2013-05-28','15:25:00',1.59),('8998','2013-05-28','15:30:00',1.7),('8998','2013-05-28','15:35:00',1.85),('8998','2013-05-28','15:40:00',1.83),('8998','2013-05-28','15:45:00',1.78),('8998','2013-05-28','15:50:00',1.72),('8998','2013-05-28','15:55:00',1.78),('8998','2013-05-28','16:00:00',1.61),('8998','2013-05-28','16:05:00',1.59),('8998','2013-05-28','16:10:00',1.37),('8998','2013-05-28','16:15:00',1.28),('8998','2013-05-28','16:20:00',1.24),('8998','2013-05-28','16:25:00',1.25),('8998','2013-05-28','16:30:00',1.23),('8998','2013-05-28','16:35:00',1.13),('8998','2013-05-28','16:40:00',1.25),('8998','2013-05-28','16:45:00',1.15),('8998','2013-05-27','07:20:00',1.11),('8998','2013-05-27','07:25:00',1.12),('8998','2013-05-27','07:40:00',1.05),('8998','2013-05-27','07:45:00',1.13),('8998','2013-05-27','07:50:00',1.12),('8998','2013-05-27','07:55:00',1.1),('8998','2013-05-27','08:00:00',1.15),('8998','2013-05-27','08:05:00',1.24),('8998','2013-05-27','08:10:00',1.34),('8998','2013-05-27','08:15:00',1.6),('8998','2013-05-27','08:20:00',1.69),('8998','2013-05-27','08:25:00',1.48),('8998','2013-05-27','08:30:00',1.58),('8998','2013-05-27','08:35:00',1.45),('8998','2013-05-27','08:40:00',1.27),('8998','2013-05-27','08:45:00',1.16),('8998','2013-05-27','08:50:00',1.36),('8998','2013-05-27','08:55:00',1.21),('8998','2013-05-27','09:00:00',1.37),('8998','2013-05-27','09:05:00',1.51),('8998','2013-05-27','09:10:00',1.42),('8998','2013-05-27','09:15:00',1.3),('8998','2013-05-27','09:20:00',1.57),('8998','2013-05-27','09:25:00',1.84),('8998','2013-05-27','09:30:00',1.98),('8998','2013-05-27','09:35:00',2.07),('8998','2013-05-27','09:40:00',1.91),('8998','2013-05-27','09:45:00',1.71),('8998','2013-05-27','09:50:00',1.72),('8998','2013-05-27','09:55:00',1.81),('8998','2013-05-27','10:00:00',1.67),('8998','2013-05-27','10:05:00',1.77),('8998','2013-05-27','10:10:00',2.01),('8998','2013-05-27','10:15:00',2.08),('8998','2013-05-27','10:20:00',2.22),('8998','2013-05-27','10:25:00',2.16),('8998','2013-05-27','10:30:00',2.41),('8998','2013-05-27','10:35:00',2.48),('8998','2013-05-27','10:40:00',2.21),('8998','2013-05-27','10:45:00',1.98),('8998','2013-05-27','10:50:00',2.16),('8998','2013-05-27','10:55:00',1.89),('8998','2013-05-27','11:00:00',1.86),('8998','2013-05-27','11:05:00',1.79),('8998','2013-05-27','11:10:00',2.05),('8998','2013-05-27','11:15:00',1.49),('8998','2013-05-27','11:20:00',1.74),('8998','2013-05-27','11:25:00',1.56),('8998','2013-05-27','11:30:00',2.7),('8998','2013-05-27','11:35:00',2.34),('8998','2013-05-27','11:40:00',2.66),('8998','2013-05-27','11:45:00',2.78),('8998','2013-05-27','11:55:00',1.09),('8998','2013-05-27','12:00:00',1.15),('8998','2013-05-27','12:05:00',1.23),('8998','2013-05-27','12:10:00',2),('8998','2013-05-27','12:15:00',1.96),('8998','2013-05-27','12:20:00',1.64),('8998','2013-05-27','12:25:00',1.64),('8998','2013-05-27','12:30:00',1.91),('8998','2013-05-27','12:35:00',1.86),('8998','2013-05-27','12:40:00',1.86),('8998','2013-05-27','12:45:00',2.13),('8998','2013-05-27','12:50:00',1.92),('8998','2013-05-27','12:55:00',1.9),('8998','2013-05-27','13:00:00',1.97),('8998','2013-05-27','13:05:00',2.09),('8998','2013-05-27','13:10:00',2.2),('8998','2013-05-27','13:15:00',1.94),('8998','2013-05-27','13:20:00',2.55),('8998','2013-05-27','13:25:00',1.4),('8998','2013-05-27','13:30:00',1.52),('8998','2013-05-27','13:35:00',1.27),('8998','2013-05-27','13:40:00',1.41),('8998','2013-05-27','13:45:00',1.31),('8998','2013-05-27','13:50:00',1.87),('8998','2013-05-27','13:55:00',1.94),('8998','2013-05-27','14:00:00',1.8),('8998','2013-05-27','14:05:00',1.83),('8998','2013-05-27','14:10:00',2.54),('8998','2013-05-27','14:15:00',2.69),('8998','2013-05-27','14:20:00',1.66),('8998','2013-05-27','14:25:00',1.93),('8998','2013-05-27','14:30:00',2.24),('8998','2013-05-27','14:35:00',1.93),('8998','2013-05-27','14:40:00',2.16),('8998','2013-05-27','14:45:00',2.48),('8998','2013-05-27','14:50:00',1.89),('8998','2013-05-27','14:55:00',1.72),('8998','2013-05-27','15:00:00',1.45),('8998','2013-05-27','15:05:00',2.29),('8998','2013-05-27','15:10:00',1.16),('8998','2013-05-27','15:15:00',1.54),('8998','2013-05-27','15:20:00',1.9),('8998','2013-05-27','15:25:00',1.33),('8998','2013-05-27','15:30:00',1.01),('8998','2013-05-27','15:35:00',1.01),('8998','2013-05-27','15:40:00',1.32),('8998','2013-05-27','15:45:00',2.11),('8998','2013-05-27','15:50:00',1.73),('8998','2013-05-27','15:55:00',1.38),('8998','2013-05-27','16:20:00',1.24),('8998','2013-05-27','16:25:00',1.22),('8998','2013-05-27','16:30:00',1.15),('8998','2013-05-27','16:35:00',1.44),('8998','2013-05-27','16:40:00',1.28),('8998','2013-05-27','16:45:00',1.2),('8998','2013-05-27','16:50:00',1.15),('8998','2013-05-27','16:55:00',1.08),('8998','2013-05-27','17:00:00',1.04),('8998','2013-05-26','07:30:00',1.46),('8998','2013-05-26','07:35:00',1.52),('8998','2013-05-26','07:40:00',1.44),('8998','2013-05-26','07:45:00',1.35),('8998','2013-05-26','07:50:00',1.37),('8998','2013-05-26','08:00:00',1.37),('8998','2013-05-26','08:05:00',1.84),('8998','2013-05-26','08:10:00',2.21),('8998','2013-05-26','08:15:00',1.7),('8998','2013-05-26','08:20:00',2.06),('8998','2013-05-26','08:25:00',2.31),('8998','2013-05-26','08:30:00',2.22),('8998','2013-05-26','08:35:00',2.16),('8998','2013-05-26','08:40:00',2.1),('8998','2013-05-26','08:45:00',2.1),('8998','2013-05-26','08:50:00',2.34),('8998','2013-05-26','08:55:00',1.91),('8998','2013-05-26','09:00:00',2.27),('8998','2013-05-26','09:05:00',2.76),('8998','2013-05-26','09:10:00',2.52),('8998','2013-05-26','09:15:00',1.62),('8998','2013-05-26','09:20:00',2.18),('8998','2013-05-26','09:25:00',2.59),('8998','2013-05-26','09:30:00',3.03),('8998','2013-05-26','09:35:00',2.99),('8998','2013-05-26','09:40:00',2.97),('8998','2013-05-26','09:45:00',3),('8998','2013-05-26','09:50:00',1.91),('8998','2013-05-26','09:55:00',2.24),('8998','2013-05-26','10:00:00',3.27),('8998','2013-05-26','10:05:00',2.81),('8998','2013-05-26','10:10:00',3.23),('8998','2013-05-26','10:15:00',3.28),('8998','2013-05-26','10:20:00',2.8),('8998','2013-05-26','10:25:00',1.9),('8998','2013-05-26','10:30:00',1.74),('8998','2013-05-26','10:45:00',2.37),('8998','2013-05-26','10:50:00',2.18),('8998','2013-05-26','10:55:00',1.99),('8998','2013-05-26','11:00:00',2.13),('8998','2013-05-26','11:05:00',2.4),('8998','2013-05-26','11:10:00',2.43),('8998','2013-05-26','11:15:00',1.47),('8998','2013-05-26','11:20:00',2.48),('8998','2013-05-26','11:25:00',3.53),('8998','2013-05-26','11:30:00',2.11),('8998','2013-05-26','11:35:00',2.75),('8998','2013-05-26','11:40:00',2.05),('8998','2013-05-26','11:45:00',3.6),('8998','2013-05-26','11:50:00',1.73),('8998','2013-05-26','11:55:00',1.46),('8998','2013-05-26','12:00:00',3.12),('8998','2013-05-26','12:05:00',3.2),('8998','2013-05-26','12:10:00',1.84),('8998','2013-05-26','12:15:00',3),('8998','2013-05-26','12:20:00',2.31),('8998','2013-05-26','12:25:00',2.69),('8998','2013-05-26','12:30:00',2.73),('8998','2013-05-26','12:35:00',1.83),('8998','2013-05-26','12:40:00',2.48),('8998','2013-05-26','12:45:00',3.7),('8998','2013-05-26','12:50:00',3.46),('8998','2013-05-26','12:55:00',3.26),('8998','2013-05-26','13:00:00',2.17),('8998','2013-05-26','13:05:00',2.55),('8998','2013-05-26','13:10:00',3.3),('8998','2013-05-26','13:15:00',2.8),('8998','2013-05-26','13:20:00',3.08),('8998','2013-05-26','13:25:00',2.65),('8998','2013-05-26','13:30:00',3.25),('8998','2013-05-26','13:35:00',2.8),('8998','2013-05-26','13:40:00',2.97),('8998','2013-05-26','13:45:00',3.26),('8998','2013-05-26','13:50:00',2.68),('8998','2013-05-26','13:55:00',2.04),('8998','2013-05-26','14:00:00',2.98),('8998','2013-05-26','14:05:00',2.93),('8998','2013-05-26','14:10:00',2.83),('8998','2013-05-26','14:15:00',2.26),('8998','2013-05-26','14:20:00',2.51),('8998','2013-05-26','14:25:00',2.36),('8998','2013-05-26','14:30:00',2.5),('8998','2013-05-26','14:35:00',2.74),('8998','2013-05-26','14:45:00',2.85),('8998','2013-05-26','14:50:00',2.75),('8998','2013-05-26','14:55:00',2.14),('8998','2013-05-26','15:00:00',1.69),('8998','2013-05-26','15:05:00',1.59),('8998','2013-05-26','15:10:00',2.49),('8998','2013-05-26','15:15:00',1.72),('8998','2013-05-26','15:20:00',1.99),('8998','2013-05-26','15:25:00',1.9),('8998','2013-05-26','15:30:00',2.02),('8998','2013-05-26','15:35:00',2.27),('8998','2013-05-26','15:40:00',1.82),('8998','2013-05-26','15:45:00',1.73),('8998','2013-05-26','15:50:00',2.16),('8998','2013-05-26','15:55:00',1.44),('8998','2013-05-26','16:00:00',1.68),('8998','2013-05-26','16:05:00',1.22),('8998','2013-05-26','16:10:00',1.45),('8998','2013-05-26','16:15:00',1.28),('8998','2013-05-26','16:20:00',1.89),('8998','2013-05-26','16:25:00',1.74),('8998','2013-05-26','16:30:00',1.5),('8998','2013-05-26','16:35:00',1.41),('8998','2013-05-26','17:10:00',1.04),('8998','2013-05-25','07:35:00',1.17),('8998','2013-05-25','07:40:00',1.49),('8998','2013-05-25','07:45:00',1.68),('8998','2013-05-25','07:50:00',2.08),('8998','2013-05-25','07:55:00',1.04),('8998','2013-05-25','08:05:00',2.25),('8998','2013-05-25','08:10:00',2.09),('8998','2013-05-25','08:25:00',1.4),('8998','2013-05-25','08:30:00',2.08),('8998','2013-05-25','08:35:00',2.34),('8998','2013-05-25','08:40:00',2.29),('8998','2013-05-25','08:45:00',2.07),('8998','2013-05-25','08:50:00',2.11),('8998','2013-05-25','09:00:00',2.19),('8998','2013-05-25','09:10:00',1.48),('8998','2013-05-25','09:15:00',2.51),('8998','2013-05-25','09:25:00',1.33),('8998','2013-05-25','09:45:00',1.78),('8998','2013-05-25','10:00:00',1.09),('8998','2013-05-25','10:05:00',2.76),('8998','2013-05-25','10:10:00',3.56),('8998','2013-05-25','10:15:00',2.4),('8998','2013-05-25','10:20:00',3.03),('8998','2013-05-25','10:25:00',2.51),('8998','2013-05-25','10:30:00',2.91),('8998','2013-05-25','10:35:00',2.7),('8998','2013-05-25','10:40:00',3.4),('8998','2013-05-25','10:45:00',3.39),('8998','2013-05-25','10:50:00',3.4),('8998','2013-05-25','10:55:00',3.19),('8998','2013-05-25','11:00:00',3.31),('8998','2013-05-25','11:05:00',3.44),('8998','2013-05-25','11:10:00',3.43),('8998','2013-05-25','11:15:00',3.41),('8998','2013-05-25','11:20:00',3.44),('8998','2013-05-25','11:25:00',3.46),('8998','2013-05-25','11:30:00',3.46),('8998','2013-05-25','11:35:00',3.48),('8998','2013-05-25','11:40:00',3.5),('8998','2013-05-25','11:45:00',3.51),('8998','2013-05-25','11:50:00',3.52),('8998','2013-05-25','11:55:00',3.44),('8998','2013-05-25','12:00:00',3.43),('8998','2013-05-25','12:05:00',3.48),('8998','2013-05-25','12:10:00',3.45),('8998','2013-05-25','12:15:00',3.22),('8998','2013-05-25','12:20:00',2.69),('8998','2013-05-25','12:25:00',2.8),('8998','2013-05-25','12:30:00',3.53),('8998','2013-05-25','12:35:00',3.43),('8998','2013-05-25','12:40:00',2.98),('8998','2013-05-25','12:45:00',2.36),('8998','2013-05-25','12:50:00',3.41),('8998','2013-05-25','12:55:00',3.36),('8998','2013-05-25','13:00:00',3.35),('8998','2013-05-25','13:05:00',3.33),('8998','2013-05-25','13:10:00',3.28),('8998','2013-05-25','13:15:00',3.12),('8998','2013-05-25','13:20:00',3.21),('8998','2013-05-25','13:25:00',3.22),('8998','2013-05-25','13:30:00',3.18),('8998','2013-05-25','13:35:00',3.15),('8998','2013-05-25','13:40:00',3.1),('8998','2013-05-25','13:45:00',3.09),('8998','2013-05-25','13:50:00',2.57),('8998','2013-05-25','13:55:00',2.99),('8998','2013-05-25','14:00:00',2.94),('8998','2013-05-25','14:05:00',2.92),('8998','2013-05-25','14:10:00',2.87),('8998','2013-05-25','14:15:00',2.82),('8998','2013-05-25','14:20:00',2.79),('8998','2013-05-25','14:25:00',2.74),('8998','2013-05-25','14:30:00',2.71),('8998','2013-05-25','14:35:00',2.68),('8998','2013-05-25','14:40:00',2.63),('8998','2013-05-25','14:45:00',2.59),('8998','2013-05-25','14:50:00',2.56),('8998','2013-05-25','14:55:00',2.51),('8998','2013-05-25','15:00:00',2.45),('8998','2013-05-25','15:05:00',2.41),('8998','2013-05-25','15:10:00',2.38),('8998','2013-05-25','15:15:00',2.34),('8998','2013-05-25','15:20:00',2.28),('8998','2013-05-25','15:25:00',2.22),('8998','2013-05-25','15:30:00',2.17),('8998','2013-05-25','15:35:00',2.12),('8998','2013-05-25','15:40:00',2.07),('8998','2013-05-25','15:45:00',2.01),('8998','2013-05-25','15:50:00',1.94),('8998','2013-05-25','15:55:00',1.89),('8998','2013-05-25','16:00:00',1.83),('8998','2013-05-25','16:05:00',1.77),('8998','2013-05-25','16:10:00',1.71),('8998','2013-05-25','16:15:00',1.65),('8998','2013-05-25','16:20:00',1.59),('8998','2013-05-25','16:25:00',1.53),('8998','2013-05-25','16:30:00',1.46),('8998','2013-05-25','16:35:00',1.39),('8998','2013-05-25','16:40:00',1.33),('8998','2013-05-25','16:45:00',1.27),('8998','2013-05-25','16:50:00',1.21),('8998','2013-05-25','16:55:00',1.14),('8998','2013-05-25','17:00:00',1.07),('8998','2013-05-25','17:05:00',1.01),('8998','2013-05-24','07:15:00',1.04),('8998','2013-05-24','07:20:00',1.07),('8998','2013-05-24','07:30:00',1.44),('8998','2013-05-24','07:35:00',1.74),('8998','2013-05-24','07:40:00',1.46),('8998','2013-05-24','07:55:00',1.87),('8998','2013-05-24','08:00:00',2.18),('8998','2013-05-24','08:05:00',2.26),('8998','2013-05-24','08:10:00',1.49),('8998','2013-05-24','08:20:00',1.36),('8998','2013-05-24','08:25:00',2.49),('8998','2013-05-24','08:30:00',2.45),('8998','2013-05-24','08:35:00',1.3),('8998','2013-05-24','08:40:00',1.45),('8998','2013-05-24','08:45:00',1.35),('8998','2013-05-24','08:50:00',1.65),('8998','2013-05-24','08:55:00',2.37),('8998','2013-05-24','09:00:00',1.74),('8998','2013-05-24','09:05:00',2.73),('8998','2013-05-24','09:10:00',2.12),('8998','2013-05-24','09:15:00',2.59),('8998','2013-05-24','09:20:00',1.49),('8998','2013-05-24','09:25:00',1.36),('8998','2013-05-24','09:35:00',2.07),('8998','2013-05-24','09:40:00',3.38),('8998','2013-05-24','09:45:00',2.31),('8998','2013-05-24','09:50:00',2.99),('8998','2013-05-24','09:55:00',1.92),('8998','2013-05-24','10:15:00',1.08),('8998','2013-05-24','10:45:00',1.07),('8998','2013-05-24','10:50:00',1.03),('8998','2013-05-24','11:05:00',1.38),('8998','2013-05-24','11:10:00',3.14),('8998','2013-05-24','11:15:00',2.77),('8998','2013-05-24','11:20:00',2.21),('8998','2013-05-24','11:40:00',1.92),('8998','2013-05-24','11:45:00',1.62),('8998','2013-05-24','11:50:00',1.3),('8998','2013-05-24','11:55:00',1.49),('8998','2013-05-24','12:00:00',1),('8998','2013-05-24','12:10:00',1.24),('8998','2013-05-24','12:25:00',1.37),('8998','2013-05-24','12:30:00',1.16),('8998','2013-05-24','12:40:00',1.2),('8998','2013-05-24','12:45:00',1.31),('8998','2013-05-24','12:55:00',1.33),('8998','2013-05-24','13:05:00',1.33),('8998','2013-05-24','13:10:00',1.01),('8998','2013-05-24','13:15:00',1.27),('8998','2013-05-24','13:20:00',1.92),('8998','2013-05-24','13:25:00',1.72),('8998','2013-05-24','13:30:00',1.57),('8998','2013-05-24','13:40:00',1.38),('8998','2013-05-24','13:45:00',1.45),('8998','2013-05-24','13:50:00',1.56),('8998','2013-05-24','13:55:00',2.22),('8998','2013-05-24','14:00:00',2.59),('8998','2013-05-24','14:05:00',3.02),('8998','2013-05-24','14:10:00',2.73),('8998','2013-05-24','14:15:00',3.02),('8998','2013-05-24','14:20:00',2.47),('8998','2013-05-24','14:25:00',1.15),('8998','2013-05-24','14:30:00',1.96),('8998','2013-05-24','14:35:00',1.22),('8998','2013-05-24','14:40:00',1.45),('8998','2013-05-24','14:45:00',1.41),('8998','2013-05-24','14:50:00',1.76),('8998','2013-05-24','14:55:00',1.26),('8998','2013-05-24','15:00:00',2.2),('8998','2013-05-24','15:05:00',2.06),('8998','2013-05-24','15:10:00',1.37),('8998','2013-05-24','15:15:00',1.73),('8998','2013-05-24','15:20:00',1.04),('8998','2013-05-24','15:25:00',1.6),('8998','2013-05-24','15:30:00',2.06),('8998','2013-05-24','15:35:00',2.43),('8998','2013-05-24','15:40:00',2.28),('8998','2013-05-24','15:45:00',2.12),('8998','2013-05-24','15:50:00',2.1),('8998','2013-05-24','15:55:00',2.17),('8998','2013-05-24','16:00:00',1.83),('8998','2013-05-24','16:10:00',1.32),('8998','2013-05-24','16:25:00',1.01),('8998','2013-05-24','16:30:00',1.56),('8998','2013-05-24','16:35:00',1.58),('8998','2013-05-24','16:40:00',1.68),('8998','2013-05-24','16:45:00',1.23),('8998','2013-05-24','17:10:00',1.17),('8998','2013-05-23','08:05:00',1.97),('8998','2013-05-23','08:10:00',1.88),('8998','2013-05-23','08:15:00',1.95),('8998','2013-05-23','08:25:00',1.16),('8998','2013-05-23','08:30:00',2.13),('8998','2013-05-23','08:35:00',1.71),('8998','2013-05-23','08:45:00',2.41),('8998','2013-05-23','08:50:00',2.5),('8998','2013-05-23','08:55:00',2.55),('8998','2013-05-23','09:00:00',2.59),('8998','2013-05-23','09:05:00',2.67),('8998','2013-05-23','09:20:00',1.59),('8998','2013-05-23','09:25:00',1.44),('8998','2013-05-23','09:30:00',2.68),('8998','2013-05-23','09:40:00',1.05),('8998','2013-05-23','09:55:00',2.02),('8998','2013-05-23','10:00:00',2.7),('8998','2013-05-23','10:25:00',1.62),('8998','2013-05-23','10:30:00',3.3),('8998','2013-05-23','10:35:00',3.4),('8998','2013-05-23','10:40:00',3.36),('8998','2013-05-23','10:45:00',3.07),('8998','2013-05-23','10:50:00',3.1),('8998','2013-05-23','10:55:00',3.53),('8998','2013-05-23','11:00:00',3.07),('8998','2013-05-23','11:05:00',3.14),('8998','2013-05-23','11:10:00',3),('8998','2013-05-23','11:15:00',2.73),('8998','2013-05-23','11:20:00',3.46),('8998','2013-05-23','11:25:00',3.58),('8998','2013-05-23','11:30:00',2.79),('8998','2013-05-23','11:35:00',1.06),('8998','2013-05-23','11:45:00',1.8),('8998','2013-05-23','11:50:00',3.71),('8998','2013-05-23','11:55:00',2.9),('8998','2013-05-23','12:00:00',1.39),('8998','2013-05-23','12:05:00',2.09),('8998','2013-05-23','12:10:00',2.93),('8998','2013-05-23','12:15:00',2.16),('8998','2013-05-23','12:20:00',1.47),('8998','2013-05-23','12:25:00',2.7),('8998','2013-05-23','12:30:00',3.27),('8998','2013-05-23','12:35:00',1.5),('8998','2013-05-23','12:40:00',1.97),('8998','2013-05-23','12:45:00',1.89),('8998','2013-05-23','12:50:00',2.24),('8998','2013-05-23','12:55:00',1.91),('8998','2013-05-23','13:00:00',1.69),('8998','2013-05-23','13:05:00',1.43),('8998','2013-05-23','13:10:00',1.77),('8998','2013-05-23','13:15:00',2.22),('8998','2013-05-23','13:20:00',2.39),('8998','2013-05-23','13:25:00',1.82),('8998','2013-05-23','13:30:00',1.29),('8998','2013-05-23','13:35:00',2.51),('8998','2013-05-23','13:40:00',1.91),('8998','2013-05-23','13:55:00',1.91),('8998','2013-05-23','14:00:00',1.64),('8998','2013-05-23','14:05:00',1.69),('8998','2013-05-23','14:15:00',2.76),('8998','2013-05-23','14:20:00',2.49),('8998','2013-05-23','14:25:00',1.85),('8998','2013-05-23','14:30:00',1.83),('8998','2013-05-23','14:35:00',1.92),('8998','2013-05-23','14:40:00',1.84),('8998','2013-05-23','14:45:00',1.7),('8998','2013-05-23','14:50:00',1.11),('8998','2013-05-23','14:55:00',1.26),('8998','2013-05-23','15:00:00',1.46),('8998','2013-05-23','15:05:00',2.39),('8998','2013-05-23','15:10:00',1.99),('8998','2013-05-23','15:15:00',1.53),('8998','2013-05-23','15:20:00',3.04),('8998','2013-05-23','15:25:00',2.23),('8998','2013-05-23','15:30:00',2.02),('8998','2013-05-23','15:35:00',1.76),('8998','2013-05-23','15:40:00',1.97),('8998','2013-05-23','15:45:00',2.48),('8998','2013-05-23','15:50:00',2.78),('8998','2013-05-23','15:55:00',2.69),('8998','2013-05-23','16:00:00',1.53),('8998','2013-05-23','16:05:00',1.33),('8998','2013-05-23','16:10:00',1.4),('8998','2013-05-23','16:15:00',1.58),('8998','2013-05-23','16:20:00',1.3),('8998','2013-05-23','16:25:00',1.53),('8998','2013-05-23','16:30:00',1.81),('8998','2013-05-23','16:35:00',1.1),('8998','2013-05-23','16:55:00',1.12),('8998','2013-05-22','08:05:00',1.36),('8998','2013-05-22','08:10:00',1.9),('8998','2013-05-22','08:30:00',1.25),('8998','2013-05-22','08:35:00',1.81),('8998','2013-05-22','08:40:00',2.13),('8998','2013-05-22','08:45:00',1.99),('8998','2013-05-22','08:50:00',1.77),('8998','2013-05-22','09:00:00',2.43),('8998','2013-05-22','09:05:00',1.52),('8998','2013-05-22','09:20:00',2.28),('8998','2013-05-22','09:25:00',2.88),('8998','2013-05-22','09:30:00',3.31),('8998','2013-05-22','09:35:00',1.84),('8998','2013-05-22','09:40:00',2.08),('8998','2013-05-22','09:45:00',1.36),('8998','2013-05-22','09:50:00',3.14),('8998','2013-05-22','09:55:00',1.55),('8998','2013-05-22','10:05:00',3.07),('8998','2013-05-22','10:10:00',2.53),('8998','2013-05-22','10:15:00',3.08),('8998','2013-05-22','10:20:00',2.42),('8998','2013-05-22','10:25:00',3.11),('8998','2013-05-22','10:30:00',2.79),('8998','2013-05-22','10:35:00',3.06),('8998','2013-05-22','10:40:00',2.93),('8998','2013-05-22','10:45:00',3.52),('8998','2013-05-22','10:50:00',3.24),('8998','2013-05-22','10:55:00',2.34),('8998','2013-05-22','11:00:00',2.31),('8998','2013-05-22','11:05:00',2.24),('8998','2013-05-22','11:10:00',2.26),('8998','2013-05-22','11:15:00',1.75),('8998','2013-05-22','11:20:00',1.5),('8998','2013-05-22','11:25:00',2.04),('8998','2013-05-22','11:30:00',2.17),('8998','2013-05-22','11:35:00',2.59),('8998','2013-05-22','11:40:00',3.45),('8998','2013-05-22','11:45:00',2.48),('8998','2013-05-22','11:50:00',2.15),('8998','2013-05-22','11:55:00',2.65),('8998','2013-05-22','12:00:00',3.39),('8998','2013-05-22','12:05:00',3.45),('8998','2013-05-22','12:10:00',3.45),('8998','2013-05-22','12:15:00',3.11),('8998','2013-05-22','12:20:00',2.37),('8998','2013-05-22','12:25:00',2.86),('8998','2013-05-22','12:30:00',2.81),('8998','2013-05-22','12:35:00',1.83),('8998','2013-05-22','12:40:00',3.07),('8998','2013-05-22','12:45:00',2.36),('8998','2013-05-22','12:50:00',2.35),('8998','2013-05-22','12:55:00',2.95),('8998','2013-05-22','13:00:00',3.45),('8998','2013-05-22','13:05:00',2.06),('8998','2013-05-22','13:10:00',3.25),('8998','2013-05-22','13:15:00',2.77),('8998','2013-05-22','13:20:00',2.32),('8998','2013-05-22','13:25:00',2.86),('8998','2013-05-22','13:30:00',2.74),('8998','2013-05-22','13:35:00',1.54),('8998','2013-05-22','13:40:00',1.28),('8998','2013-05-22','13:45:00',2.5),('8998','2013-05-22','13:50:00',2.14),('8998','2013-05-22','13:55:00',2.7),('8998','2013-05-22','14:00:00',2.98),('8998','2013-05-22','14:05:00',3),('8998','2013-05-22','14:10:00',2.22),('8998','2013-05-22','14:15:00',2.82),('8998','2013-05-22','14:20:00',2.76),('8998','2013-05-22','14:25:00',1.91),('8998','2013-05-22','14:35:00',3.06),('8998','2013-05-22','14:40:00',2.03),('8998','2013-05-22','14:45:00',1.48),('8998','2013-05-22','14:50:00',1.36),('8998','2013-05-22','14:55:00',2.14),('8998','2013-05-22','15:00:00',2.44),('8998','2013-05-22','15:05:00',2.4),('8998','2013-05-22','15:15:00',1),('8998','2013-05-22','15:20:00',2.47),('8998','2013-05-22','15:25:00',1.05),('8998','2013-05-22','15:30:00',1.59),('8998','2013-05-22','15:35:00',1.94),('8998','2013-05-22','15:40:00',1.32),('8998','2013-05-22','15:45:00',1.71),('8998','2013-05-22','16:00:00',1.9),('8998','2013-05-22','16:05:00',2.13),('8998','2013-05-22','16:10:00',1.45),('8998','2013-05-22','16:15:00',1.24),('8998','2013-05-22','16:20:00',1.7),('8998','2013-05-22','16:25:00',1.09),('8998','2013-05-22','16:30:00',1.47),('8998','2013-05-22','16:45:00',1.09),('8998','2013-05-22','17:10:00',1.36),('8998','2013-05-22','17:15:00',1.15),('8998','2013-05-21','08:00:00',1.06),('8998','2013-05-21','08:05:00',1.57),('8998','2013-05-21','08:10:00',1.07),('8998','2013-05-21','08:15:00',1.95),('8998','2013-05-21','08:20:00',1.88),('8998','2013-05-21','08:25:00',1.67),('8998','2013-05-21','08:30:00',1.87),('8998','2013-05-21','08:35:00',2.25),('8998','2013-05-21','08:40:00',1.29),('8998','2013-05-21','08:45:00',1.35),('8998','2013-05-21','09:30:00',2.56),('8998','2013-05-21','09:35:00',2.79),('8998','2013-05-21','09:40:00',2.73),('8998','2013-05-21','09:45:00',2.71),('8998','2013-05-21','09:50:00',2.73),('8998','2013-05-21','09:55:00',2.76),('8998','2013-05-21','10:00:00',2.79),('8998','2013-05-21','10:05:00',2.82),('8998','2013-05-21','10:10:00',2.87),('8998','2013-05-21','10:15:00',2.89),('8998','2013-05-21','10:20:00',2.83),('8998','2013-05-21','10:25:00',2.96),('8998','2013-05-21','10:30:00',2.95),('8998','2013-05-21','10:35:00',2.9),('8998','2013-05-21','10:40:00',3.06),('8998','2013-05-21','10:45:00',3.05),('8998','2013-05-21','10:50:00',3),('8998','2013-05-21','10:55:00',3.01),('8998','2013-05-21','11:00:00',3.06),('8998','2013-05-21','11:05:00',3.12),('8998','2013-05-21','11:10:00',2.89),('8998','2013-05-21','11:15:00',2.75),('8998','2013-05-21','11:20:00',3.18),('8998','2013-05-21','11:25:00',3.3),('8998','2013-05-21','11:30:00',2.68),('8998','2013-05-21','11:35:00',2.72),('8998','2013-05-21','11:40:00',2.52),('8998','2013-05-21','11:45:00',3.29),('8998','2013-05-21','11:50:00',1.93),('8998','2013-05-21','11:55:00',1.44),('8998','2013-05-21','12:00:00',2.23),('8998','2013-05-21','12:05:00',1.73),('8998','2013-05-21','12:10:00',1.64),('8998','2013-05-21','12:15:00',2.13),('8998','2013-05-21','12:20:00',2.99),('8998','2013-05-21','12:25:00',2.31),('8998','2013-05-21','12:30:00',1.69),('8998','2013-05-21','12:35:00',1.66),('8998','2013-05-21','12:40:00',1.26),('8998','2013-05-21','13:05:00',2.97),('8998','2013-05-21','13:10:00',1.66),('8998','2013-05-21','13:15:00',1.59),('8998','2013-05-21','13:20:00',1.75),('8998','2013-05-21','13:30:00',1.21),('8998','2013-05-21','13:35:00',2.25),('8998','2013-05-21','13:40:00',2.38),('8998','2013-05-21','13:45:00',1.57),('8998','2013-05-21','13:50:00',1.58),('8998','2013-05-21','13:55:00',1.69),('8998','2013-05-21','14:00:00',1.74),('8998','2013-05-21','14:05:00',2.4),('8998','2013-05-21','14:10:00',2.52),('8998','2013-05-21','14:15:00',2.77),('8998','2013-05-21','14:20:00',2.65),('8998','2013-05-21','14:25:00',2.59),('8998','2013-05-21','14:30:00',2.51),('8998','2013-05-21','14:35:00',2.46),('8998','2013-05-21','14:40:00',2.45),('8998','2013-05-21','14:45:00',2.4),('8998','2013-05-21','14:50:00',2.35),('8998','2013-05-21','14:55:00',2.3),('8998','2013-05-21','15:00:00',2.26),('8998','2013-05-21','15:05:00',2.2),('8998','2013-05-21','15:10:00',2.16),('8998','2013-05-21','15:15:00',2.13),('8998','2013-05-21','15:20:00',1.96),('8998','2013-05-21','15:25:00',1.19),('8998','2013-05-21','15:30:00',1.01),('8998','2013-05-21','15:35:00',1.2),('8998','2013-05-21','15:45:00',1.31),('8998','2013-05-21','15:50:00',1.82),('8998','2013-05-21','15:55:00',1.7),('8998','2013-05-21','16:00:00',1.67),('8998','2013-05-21','16:05:00',1.6),('8998','2013-05-21','16:10:00',1.55),('8998','2013-05-21','16:15:00',1.48),('8998','2013-05-21','16:20:00',1.44),('8998','2013-05-21','16:25:00',1.39),('8998','2013-05-21','16:30:00',1.34),('8998','2013-05-21','16:35:00',1.28),('8998','2013-05-21','16:40:00',1.23),('8998','2014-03-31','08:20:00',1.03),('8998','2014-03-31','08:25:00',1.07),('8998','2014-03-31','08:30:00',1.46),('8998','2014-03-31','08:35:00',1.56),('8998','2014-03-31','08:40:00',1.6),('8998','2014-03-31','08:45:00',1.59),('8998','2014-03-31','08:50:00',1.59),('8998','2014-03-31','08:55:00',1.84),('8998','2014-03-31','09:00:00',1.93),('8998','2014-03-31','09:05:00',1.98),('8998','2014-03-31','09:10:00',2.06),('8998','2014-03-31','09:15:00',2.14),('8998','2014-03-31','09:20:00',2.17),('8998','2014-03-31','09:25:00',2.21),('8998','2014-03-31','09:30:00',2.23),('8998','2014-03-31','09:35:00',2.28),('8998','2014-03-31','09:40:00',2.31),('8998','2014-03-31','09:45:00',2.39),('8998','2014-03-31','09:50:00',2.44),('8998','2014-03-31','09:55:00',2.44),('8998','2014-03-31','10:00:00',2.5),('8998','2014-03-31','10:05:00',2.56),('8998','2014-03-31','10:10:00',2.47),('8998','2014-03-31','10:15:00',2.53),('8998','2014-03-31','10:20:00',2.61),('8998','2014-03-31','10:25:00',2.69),('8998','2014-03-31','10:30:00',2.67),('8998','2014-03-31','10:35:00',2.39),('8998','2014-03-31','10:40:00',2.18),('8998','2014-03-31','10:45:00',2.2),('8998','2014-03-31','10:50:00',2.17),('8998','2014-03-31','10:55:00',2.93),('8998','2014-03-31','11:00:00',2.84),('8998','2014-03-31','11:05:00',2.85),('8998','2014-03-31','11:10:00',2.83),('8998','2014-03-31','11:15:00',2.83),('8998','2014-03-31','11:20:00',2.85),('8998','2014-03-31','11:25:00',2.79),('8998','2014-03-31','11:30:00',2.89),('8998','2014-03-31','11:35:00',2.89),('8998','2014-03-31','11:40:00',2.88),('8998','2014-03-31','11:45:00',2.85),('8998','2014-03-31','11:50:00',2.91),('8998','2014-03-31','11:55:00',2.87),('8998','2014-03-31','12:00:00',2.9),('8998','2014-03-31','12:05:00',2.87),('8998','2014-03-31','12:10:00',2.88),('8998','2014-03-31','12:15:00',2.86),('8998','2014-03-31','12:20:00',2.88),('8998','2014-03-31','12:25:00',2.88),('8998','2014-03-31','12:30:00',2.88),('8998','2014-03-31','12:35:00',2.87),('8998','2014-03-31','12:40:00',2.85),('8998','2014-03-31','12:45:00',2.84),('8998','2014-03-31','12:50:00',2.83),('8998','2014-03-31','12:55:00',2.78),('8998','2014-03-31','13:00:00',2.82),('8998','2014-03-31','13:05:00',2.86),('8998','2014-03-31','13:10:00',2.83),('8998','2014-03-31','13:15:00',2.37),('8998','2014-03-31','13:20:00',2.65),('8998','2014-03-31','13:25:00',2.7),('8998','2014-03-31','13:30:00',2.67),('8998','2014-03-31','13:35:00',2.65),('8998','2014-03-31','13:40:00',2.62),('8998','2014-03-31','13:45:00',2.49),('8998','2014-03-31','13:50:00',2.51),('8998','2014-03-31','13:55:00',2.43),('8998','2014-03-31','14:00:00',2.5),('8998','2014-03-31','14:05:00',2.47),('8998','2014-03-31','14:10:00',2.42),('8998','2014-03-31','14:15:00',2.42),('8998','2014-03-31','14:20:00',2.35),('8998','2014-03-31','14:25:00',2.27),('8998','2014-03-31','14:30:00',1.74),('8998','2014-03-31','14:35:00',1.91),('8998','2014-03-31','14:40:00',2.28),('8998','2014-03-31','14:45:00',2.33),('8998','2014-03-31','14:50:00',1.82),('8998','2014-03-31','14:55:00',2.12),('8998','2014-03-31','15:00:00',1.8),('8998','2014-03-31','15:05:00',1.82),('8998','2014-03-31','15:10:00',2.06),('8998','2014-03-31','15:15:00',1.53),('8998','2014-03-31','15:20:00',1.69),('8998','2014-03-31','15:25:00',1.78),('8998','2014-03-31','15:30:00',1.85),('8998','2014-03-31','15:35:00',1.58),('8998','2014-03-31','15:40:00',1.34),('8998','2014-03-31','15:45:00',1.6),('8998','2014-03-31','15:50:00',1.64),('8998','2014-03-31','15:55:00',1.01),('8998','2014-03-31','16:00:00',1.28),('8998','2014-03-31','16:05:00',1.01),('8998','2014-03-31','16:10:00',1.02),('8998','2014-03-31','16:15:00',1.12),('8998','2014-03-31','16:20:00',1.07),('8998','2013-05-20','07:30:00',1.01),('8998','2013-05-20','07:35:00',1.19),('8998','2013-05-20','07:40:00',1.32),('8998','2013-05-20','07:45:00',1.34),('8998','2013-05-20','07:50:00',1.14),('8998','2013-05-20','08:00:00',1.3),('8998','2013-05-20','08:10:00',1.35),('8998','2013-05-20','08:15:00',1.82),('8998','2013-05-20','08:20:00',1.27),('8998','2013-05-20','08:25:00',1.72),('8998','2013-05-20','08:30:00',1.21),('8998','2013-05-20','08:35:00',1.04),('8998','2013-05-20','08:40:00',1.2),('8998','2013-05-20','08:50:00',1.03),('8998','2013-05-20','08:55:00',1.45),('8998','2013-05-20','09:00:00',1.29),('8998','2013-05-20','09:05:00',1.09),('8998','2013-05-20','09:10:00',1.22),('8998','2013-05-20','09:15:00',1.39),('8998','2013-05-20','09:20:00',1.89),('8998','2013-05-20','09:25:00',2.17),('8998','2013-05-20','09:30:00',1.62),('8998','2013-05-20','09:35:00',1.57),('8998','2013-05-20','09:40:00',1.59),('8998','2013-05-20','09:45:00',1.34),('8998','2013-05-20','09:50:00',1.25),('8998','2013-05-20','09:55:00',1.47),('8998','2013-05-20','10:00:00',1.56),('8998','2013-05-20','10:05:00',1.74),('8998','2013-05-20','10:10:00',1.79),('8998','2013-05-20','10:15:00',1.78),('8998','2013-05-20','10:20:00',1.72),('8998','2013-05-20','10:25:00',1.52),('8998','2013-05-20','10:30:00',1.36),('8998','2013-05-20','10:35:00',1.36),('8998','2013-05-20','10:40:00',1.55),('8998','2013-05-20','10:45:00',2.38),('8998','2013-05-20','10:50:00',1.69),('8998','2013-05-20','10:55:00',1.23),('8998','2013-05-20','11:00:00',1.37),('8998','2013-05-20','11:05:00',1.24),('8998','2013-05-20','11:10:00',2.13),('8998','2013-05-20','11:15:00',3.27),('8998','2013-05-20','11:20:00',2.5),('8998','2013-05-20','11:25:00',3.16),('8998','2013-05-20','11:30:00',2.08),('8998','2013-05-20','11:35:00',1.84),('8998','2013-05-20','11:40:00',1.91),('8998','2013-05-20','11:45:00',2.68),('8998','2013-05-20','11:50:00',1.93),('8998','2013-05-20','11:55:00',2.78),('8998','2013-05-20','12:00:00',2.28),('8998','2013-05-20','12:05:00',2.71),('8998','2013-05-20','12:10:00',2.05),('8998','2013-05-20','12:15:00',2.27),('8998','2013-05-20','12:20:00',1.7),('8998','2013-05-20','12:25:00',2.32),('8998','2013-05-20','12:30:00',2.96),('8998','2013-05-20','12:35:00',1.73),('8998','2013-05-20','12:40:00',2.96),('8998','2013-05-20','12:45:00',2.92),('8998','2013-05-20','12:50:00',1.82),('8998','2013-05-20','12:55:00',3.17),('8998','2013-05-20','13:00:00',2.82),('8998','2013-05-20','13:05:00',3.01),('8998','2013-05-20','13:10:00',1.75),('8998','2013-05-20','13:15:00',2.51),('8998','2013-05-20','13:20:00',1.85),('8998','2013-05-20','13:25:00',2.16),('8998','2013-05-20','13:30:00',2.08),('8998','2013-05-20','13:35:00',1.15),('8998','2013-05-20','14:10:00',1.12),('8998','2013-05-20','14:15:00',1.4),('8998','2013-05-20','14:20:00',1.27),('8998','2013-05-20','14:25:00',1.58),('8998','2013-05-20','14:30:00',1.66),('8998','2013-05-20','14:35:00',1.31),('8998','2013-05-20','14:40:00',1.29),('8998','2013-05-20','14:45:00',1.2),('8998','2013-05-20','15:20:00',1.03),('8998','2013-05-20','15:25:00',1.08),('8998','2013-05-20','15:30:00',1.47),('8998','2013-05-20','15:35:00',1.1),('8998','2013-05-20','16:30:00',1.08),('8998','2013-05-20','16:35:00',1.18),('8998','2013-05-20','16:40:00',1.25),('8998','2013-05-20','16:45:00',1.18),('8998','2013-05-19','07:30:00',1.09),('8998','2013-05-19','07:35:00',1.22),('8998','2013-05-19','07:40:00',1.44),('8998','2013-05-19','07:45:00',1.51),('8998','2013-05-19','07:50:00',1.55),('8998','2013-05-19','07:55:00',1.56),('8998','2013-05-19','08:00:00',1.78),('8998','2013-05-19','08:05:00',1.57),('8998','2013-05-19','08:10:00',1.9),('8998','2013-05-19','08:15:00',1.55),('8998','2013-05-19','08:20:00',1.24),('8998','2013-05-19','08:50:00',2.57),('8998','2013-05-19','08:55:00',2.62),('8998','2013-05-19','09:00:00',2.74),('8998','2013-05-19','09:05:00',2.27),('8998','2013-05-19','09:10:00',2.87),('8998','2013-05-19','09:15:00',2.03),('8998','2013-05-19','09:20:00',1.76),('8998','2013-05-19','09:25:00',1.55),('8998','2013-05-19','09:35:00',1.54),('8998','2013-05-19','09:50:00',3.02),('8998','2013-05-19','09:55:00',1.34),('8998','2013-05-19','10:15:00',1.13),('8998','2013-05-19','10:30:00',2.17),('8998','2013-05-19','10:35:00',2.05),('8998','2013-05-19','10:45:00',1.07),('8998','2013-05-19','10:50:00',1.02),('8998','2013-05-19','10:55:00',1.4),('8998','2013-05-19','11:00:00',2.7),('8998','2013-05-19','11:05:00',3.52),('8998','2013-05-19','11:10:00',3.26),('8998','2013-05-19','11:15:00',3.46),('8998','2013-05-19','11:20:00',2.47),('8998','2013-05-19','11:25:00',2.62),('8998','2013-05-19','11:30:00',2.81),('8998','2013-05-19','11:35:00',2.79),('8998','2013-05-19','11:40:00',1.3),('8998','2013-05-19','11:45:00',1.17),('8998','2013-05-19','11:50:00',1.29),('8998','2013-05-19','11:55:00',2.67),('8998','2013-05-19','12:00:00',1.91),('8998','2013-05-19','12:05:00',3.67),('8998','2013-05-19','12:10:00',2.46),('8998','2013-05-19','12:15:00',1.43),('8998','2013-05-19','12:20:00',1.96),('8998','2013-05-19','12:25:00',1.31),('8998','2013-05-19','12:30:00',1.51),('8998','2013-05-19','12:35:00',2.42),('8998','2013-05-19','12:40:00',2.19),('8998','2013-05-19','12:45:00',3.39),('8998','2013-05-19','12:50:00',1.69),('8998','2013-05-19','12:55:00',1.36),('8998','2013-05-19','13:00:00',1.41),('8998','2013-05-19','13:05:00',2.37),('8998','2013-05-19','13:10:00',1.52),('8998','2013-05-19','13:15:00',1.6),('8998','2013-05-19','13:20:00',3.24),('8998','2013-05-19','13:25:00',2.67),('8998','2013-05-19','13:30:00',2.34),('8998','2013-05-19','13:35:00',1.73),('8998','2013-05-19','13:40:00',2),('8998','2013-05-19','13:45:00',1.8),('8998','2013-05-19','13:50:00',3.28),('8998','2013-05-19','13:55:00',2.26),('8998','2013-05-19','14:00:00',3.17),('8998','2013-05-19','14:05:00',1.9),('8998','2013-05-19','14:15:00',2.88),('8998','2013-05-19','14:20:00',2.2),('8998','2013-05-19','14:25:00',1.47),('8998','2013-05-19','14:30:00',2.91),('8998','2013-05-19','14:35:00',2.06),('8998','2013-05-19','14:45:00',1.74),('8998','2013-05-19','14:50:00',2.91),('8998','2013-05-19','14:55:00',2.54),('8998','2013-05-19','15:00:00',2.17),('8998','2013-05-19','15:10:00',2.27),('8998','2013-05-19','15:15:00',2.27),('8998','2013-05-19','15:20:00',1.5),('8998','2013-05-19','15:25:00',2.48),('8998','2013-05-19','15:30:00',1.68),('8998','2013-05-19','15:35:00',2.35),('8998','2013-05-19','15:40:00',1.63),('8998','2013-05-19','15:45:00',1.3),('8998','2013-05-19','15:50:00',1.64),('8998','2013-05-19','16:00:00',1.2),('8998','2013-05-19','16:05:00',1.75),('8998','2013-05-19','16:10:00',1.78),('8998','2013-05-19','16:15:00',1.85),('8998','2013-05-19','16:20:00',1.69),('8998','2013-05-19','16:25:00',1.59),('8998','2013-05-19','16:30:00',1.52),('8998','2013-05-19','16:35:00',1.4),('8998','2013-05-19','16:40:00',1.36),('8998','2013-05-19','16:45:00',1.19),('8998','2013-05-19','16:50:00',1.14),('8998','2013-05-19','16:55:00',1.08),('8998','2013-05-19','17:05:00',1.03),('8998','2013-05-18','08:55:00',1.34),('8998','2013-05-18','09:00:00',1.4),('8998','2013-05-18','09:15:00',1.01),('8998','2013-05-18','10:00:00',1.04),('8998','2013-05-18','10:05:00',1.18),('8998','2013-05-18','10:10:00',1.44),('8998','2013-05-18','10:15:00',2.34),('8998','2013-05-18','10:20:00',2.4),('8998','2013-05-18','10:25:00',1.71),('8998','2013-05-18','10:30:00',2.16),('8998','2013-05-18','10:35:00',1.91),('8998','2013-05-18','10:40:00',1.53),('8998','2013-05-18','10:45:00',2.28),('8998','2013-05-18','10:50:00',1.4),('8998','2013-05-18','10:55:00',1.61),('8998','2013-05-18','11:00:00',1.53),('8998','2013-05-18','11:05:00',2.5),('8998','2013-05-18','11:10:00',2.07),('8998','2013-05-18','11:15:00',2.95),('8998','2013-05-18','11:20:00',3.54),('8998','2013-05-18','11:25:00',3.42),('8998','2013-05-18','11:30:00',3.45),('8998','2013-05-18','11:35:00',3.38),('8998','2013-05-18','11:40:00',3.46),('8998','2013-05-18','11:45:00',3.46),('8998','2013-05-18','11:50:00',3.41),('8998','2013-05-18','11:55:00',3.41),('8998','2013-05-18','12:00:00',3.42),('8998','2013-05-18','12:05:00',3.36),('8998','2013-05-18','12:10:00',3.35),('8998','2013-05-18','12:15:00',3.34),('8998','2013-05-18','12:20:00',3.43),('8998','2013-05-18','12:25:00',3.7),('8998','2013-05-18','12:30:00',2.9),('8998','2013-05-18','12:35:00',3.6),('8998','2013-05-18','12:40:00',3.42),('8998','2013-05-18','12:45:00',3.36),('8998','2013-05-18','12:50:00',2.46),('8998','2013-05-18','12:55:00',1.94),('8998','2013-05-18','13:00:00',3.03),('8998','2013-05-18','13:05:00',3.21),('8998','2013-05-18','13:10:00',2.85),('8998','2013-05-18','13:15:00',2.66),('8998','2013-05-18','13:20:00',3.04),('8998','2013-05-18','13:25:00',2.73),('8998','2013-05-18','13:30:00',2.99),('8998','2013-05-18','13:35:00',2.97),('8998','2013-05-18','13:40:00',2.92),('8998','2013-05-18','13:45:00',2.88),('8998','2013-05-18','13:50:00',2.86),('8998','2013-05-18','13:55:00',2.84),('8998','2013-05-18','14:00:00',2.81),('8998','2013-05-18','14:05:00',2.8),('8998','2013-05-18','14:10:00',2.77),('8998','2013-05-18','14:15:00',2.72),('8998','2013-05-18','14:20:00',2.69),('8998','2013-05-18','14:25:00',2.65),('8998','2013-05-18','14:30:00',2.62),('8998','2013-05-18','14:35:00',2.56),('8998','2013-05-18','14:40:00',2.54),('8998','2013-05-18','14:45:00',2.49),('8998','2013-05-18','14:50:00',2.44),('8998','2013-05-18','14:55:00',2.39),('8998','2013-05-18','15:00:00',2.37),('8998','2013-05-18','15:05:00',2.32),('8998','2013-05-18','15:10:00',2.27),('8998','2013-05-18','15:15:00',2.24),('8998','2013-05-18','15:20:00',2.17),('8998','2013-05-18','15:25:00',2.12),('8998','2013-05-18','15:30:00',2.06),('8998','2013-05-18','15:35:00',2.01),('8998','2013-05-18','15:40:00',1.95),('8998','2013-05-18','15:45:00',1.9),('8998','2013-05-18','15:50:00',1.84),('8998','2013-05-18','15:55:00',1.8),('8998','2013-05-18','16:00:00',1.73),('8998','2013-05-18','16:05:00',1.67),('8998','2013-05-18','16:10:00',1.61),('8998','2013-05-18','16:15:00',1.55),('8998','2013-05-18','16:20:00',1.49),('8998','2013-05-18','16:25:00',1.44),('8998','2013-05-18','16:30:00',1.38),('8998','2013-05-18','16:35:00',1.32),('8998','2013-05-18','16:40:00',1.26),('8998','2013-05-18','16:45:00',1.2),('8998','2013-05-18','16:50:00',1.13),('8998','2013-05-18','16:55:00',1.07),('8998','2013-05-18','17:00:00',1.01),('8998','2013-05-17','07:30:00',1.08),('8998','2013-05-17','07:35:00',1.29),('8998','2013-05-17','07:40:00',1.38),('8998','2013-05-17','07:45:00',1.39),('8998','2013-05-17','07:50:00',1.05),('8998','2013-05-17','07:55:00',1.81),('8998','2013-05-17','08:00:00',1.9),('8998','2013-05-17','08:05:00',1.82),('8998','2013-05-17','08:20:00',1.06),('8998','2013-05-17','08:25:00',2.48),('8998','2013-05-17','08:30:00',2.29),('8998','2013-05-17','08:35:00',2.02),('8998','2013-05-17','08:40:00',2.32),('8998','2013-05-17','08:45:00',2.22),('8998','2013-05-17','08:50:00',2.21),('8998','2013-05-17','08:55:00',2.22),('8998','2013-05-17','09:00:00',2.07),('8998','2013-05-17','09:05:00',1.98),('8998','2013-05-17','09:10:00',2.19),('8998','2013-05-17','09:15:00',2.42),('8998','2013-05-17','09:20:00',2.6),('8998','2013-05-17','09:25:00',2.71),('8998','2013-05-17','09:30:00',2.74),('8998','2013-05-17','09:35:00',2.77),('8998','2013-05-17','09:40:00',2.78),('8998','2013-05-17','09:45:00',2.82),('8998','2013-05-17','09:50:00',2.85),('8998','2013-05-17','09:55:00',2.89),('8998','2013-05-17','10:00:00',2.91),('8998','2013-05-17','10:05:00',2.9),('8998','2013-05-17','10:10:00',2.94),('8998','2013-05-17','10:15:00',2.94),('8998','2013-05-17','10:20:00',2.98),('8998','2013-05-17','10:25:00',2.98),('8998','2013-05-17','10:30:00',2.98),('8998','2013-05-17','10:35:00',2.96),('8998','2013-05-17','10:40:00',3.01),('8998','2013-05-17','10:45:00',3.01),('8998','2013-05-17','10:50:00',3.02),('8998','2013-05-17','10:55:00',2.92),('8998','2013-05-17','11:00:00',3.15),('8998','2013-05-17','11:05:00',2.99),('8998','2013-05-17','11:10:00',2.5),('8998','2013-05-17','11:15:00',3.32),('8998','2013-05-17','11:20:00',3.19),('8998','2013-05-17','11:25:00',3.24),('8998','2013-05-17','11:30:00',3.2),('8998','2013-05-17','11:35:00',3),('8998','2013-05-17','11:40:00',3.14),('8998','2013-05-17','11:45:00',2.93),('8998','2013-05-17','11:50:00',2.93),('8998','2013-05-17','11:55:00',3.03),('8998','2013-05-17','12:00:00',3.07),('8998','2013-05-17','12:05:00',2.99),('8998','2013-05-17','12:10:00',3.02),('8998','2013-05-17','12:15:00',2.99),('8998','2013-05-17','12:20:00',2.99),('8998','2013-05-17','12:25:00',3),('8998','2013-05-17','12:30:00',2.43),('8998','2013-05-17','12:35:00',3.06),('8998','2013-05-17','12:40:00',2.99),('8998','2013-05-17','12:45:00',2.88),('8998','2013-05-17','12:50:00',2.94),('8998','2013-05-17','12:55:00',2.91),('8998','2013-05-17','13:00:00',2.89),('8998','2013-05-17','13:05:00',2.87),('8998','2013-05-17','13:10:00',2.85),('8998','2013-05-17','13:15:00',2.85),('8998','2013-05-17','13:20:00',2.82),('8998','2013-05-17','13:25:00',2.8),('8998','2013-05-17','13:30:00',2.81),('8998','2013-05-17','13:35:00',2.41),('8998','2013-05-17','13:40:00',2.71),('8998','2013-05-17','13:45:00',2.85),('8998','2013-05-17','13:50:00',2.51),('8998','2013-05-17','13:55:00',2.31),('8998','2013-05-17','14:00:00',1.93),('8998','2013-05-17','14:05:00',2.04),('8998','2013-05-17','14:10:00',2.91),('8998','2013-05-17','14:15:00',2.72),('8998','2013-05-17','14:20:00',2.68),('8998','2013-05-17','14:25:00',2.59),('8998','2013-05-17','14:30:00',2.58),('8998','2013-05-17','14:35:00',2.43),('8998','2013-05-17','14:40:00',2.65),('8998','2013-05-17','14:45:00',2.49),('8998','2013-05-17','14:50:00',2.28),('8998','2013-05-17','14:55:00',1.99),('8998','2013-05-17','15:00:00',2.18),('8998','2013-05-17','15:05:00',2.11),('8998','2013-05-17','15:10:00',2.05),('8998','2013-05-17','15:15:00',1.99),('8998','2013-05-17','15:20:00',1.93),('8998','2013-05-17','15:25:00',1.88),('8998','2013-05-17','15:30:00',1.83),('8998','2013-05-17','15:35:00',1.79),('8998','2013-05-17','15:40:00',1.74),('8998','2013-05-17','15:45:00',1.68),('8998','2013-05-17','15:50:00',1.64),('8998','2013-05-17','15:55:00',1.59),('8998','2013-05-17','16:00:00',1.54),('8998','2013-05-17','16:05:00',1.49),('8998','2013-05-17','16:10:00',1.44),('8998','2013-05-17','16:15:00',1.38),('8998','2013-05-17','16:20:00',1.34),('8998','2013-05-17','16:25:00',1.28),('8998','2013-05-17','16:30:00',1.23),('8998','2013-05-17','16:35:00',1.18),('8998','2013-05-17','16:40:00',1.13),('8998','2013-05-17','16:45:00',1.08),('8998','2013-05-17','16:50:00',1.02),('8998','2013-05-16','07:45:00',1.27),('8998','2013-05-16','07:50:00',1.02),('8998','2013-05-16','08:00:00',1.37),('8998','2013-05-16','08:15:00',1.36),('8998','2013-05-16','08:20:00',2.03),('8998','2013-05-16','08:25:00',1.19),('8998','2013-05-16','10:30:00',1.15),('8998','2013-05-16','10:40:00',1.07),('8998','2013-05-16','10:45:00',1.17),('8998','2013-05-16','10:50:00',2.16),('8998','2013-05-16','10:55:00',2.79),('8998','2013-05-16','11:00:00',1.69),('8998','2013-05-16','11:05:00',1.67),('8998','2013-05-16','11:10:00',1.11),('8998','2013-05-16','11:15:00',1.88),('8998','2013-05-16','11:20:00',1.55),('8998','2013-05-16','11:25:00',1.3),('8998','2013-05-16','11:30:00',1.42),('8998','2013-05-16','11:35:00',1.96),('8998','2013-05-16','11:40:00',1.21),('8998','2013-05-16','11:45:00',1.15),('8998','2013-05-16','11:50:00',2.01),('8998','2013-05-16','11:55:00',1.9),('8998','2013-05-16','12:00:00',1.79),('8998','2013-05-16','12:05:00',1.88),('8998','2013-05-16','12:10:00',2.35),('8998','2013-05-16','12:15:00',1.78),('8998','2013-05-16','12:20:00',1.86),('8998','2013-05-16','12:25:00',1.99),('8998','2013-05-16','12:30:00',1.77),('8998','2013-05-16','12:35:00',2.23),('8998','2013-05-16','12:40:00',2.84),('8998','2013-05-16','12:45:00',3.12),('8998','2013-05-16','12:50:00',3.28),('8998','2013-05-16','12:55:00',3.15),('8998','2013-05-16','13:00:00',2.54),('8998','2013-05-16','13:05:00',3.21),('8998','2013-05-16','13:10:00',2.24),('8998','2013-05-16','13:15:00',2.65),('8998','2013-05-16','13:20:00',3.32),('8998','2013-05-16','13:25:00',3.12),('8998','2013-05-16','13:30:00',2.22),('8998','2013-05-16','13:35:00',3.17),('8998','2013-05-16','13:40:00',2.49),('8998','2013-05-16','13:45:00',2.84),('8998','2013-05-16','13:50:00',2.77),('8998','2013-05-16','13:55:00',3.06),('8998','2013-05-16','14:00:00',2.22),('8998','2013-05-16','14:05:00',1.53),('8998','2013-05-16','14:10:00',2.82),('8998','2013-05-16','14:15:00',2.75),('8998','2013-05-16','14:20:00',2.82),('8998','2013-05-16','14:25:00',2.37),('8998','2013-05-16','14:30:00',2.61),('8998','2013-05-16','14:35:00',2.42),('8998','2013-05-16','14:40:00',1.79),('8998','2013-05-16','14:45:00',1.87),('8998','2013-05-16','14:50:00',1.96),('8998','2013-05-16','14:55:00',1.39),('8998','2013-05-16','15:00:00',2.38),('8998','2013-05-16','15:05:00',1.73),('8998','2013-05-16','15:10:00',1.13),('8998','2013-05-16','15:15:00',1.5),('8998','2013-05-16','15:20:00',1.79),('8998','2013-05-16','15:25:00',1.94),('8998','2013-05-16','15:30:00',1.1),('8998','2013-05-16','15:35:00',1.65),('8998','2013-05-16','15:40:00',2.34),('8998','2013-05-16','15:45:00',1.02),('8998','2013-05-16','15:50:00',1.71),('8998','2013-05-16','15:55:00',1.79),('8998','2013-05-16','16:00:00',1.99),('8998','2013-05-16','16:05:00',1.21),('8998','2013-05-16','16:15:00',1.45),('8998','2013-05-16','16:20:00',1.56),('8998','2013-05-16','16:25:00',1.45),('8998','2013-05-16','16:30:00',1.57),('8998','2013-05-16','16:35:00',1.66),('8998','2013-05-16','16:40:00',1.66),('8998','2013-05-16','16:45:00',1.45),('8998','2013-05-16','16:50:00',1.2),('8998','2013-05-16','16:55:00',1.06),('8998','2013-05-15','09:25:00',1.3),('8998','2013-05-15','09:30:00',1.35),('8998','2013-05-15','09:35:00',1.58),('8998','2013-05-15','09:40:00',1.94),('8998','2013-05-15','09:45:00',2.3),('8998','2013-05-15','09:50:00',1),('8998','2013-05-15','10:00:00',1.25),('8998','2013-05-15','10:15:00',1.12),('8998','2013-05-15','10:20:00',1.57),('8998','2013-05-15','10:25:00',1.67),('8998','2013-05-15','10:30:00',1.34),('8998','2013-05-15','10:40:00',1.02),('8998','2013-05-15','10:50:00',1.18),('8998','2013-05-15','10:55:00',1.31),('8998','2013-05-15','11:00:00',3.2),('8998','2013-05-15','11:05:00',2.88),('8998','2013-05-15','11:10:00',2.32),('8998','2013-05-15','11:15:00',1.58),('8998','2013-05-15','11:30:00',1.15),('8998','2013-05-15','11:35:00',2.33),('8998','2013-05-15','11:40:00',3.05),('8998','2013-05-15','11:45:00',3.05),('8998','2013-05-15','11:50:00',2.88),('8998','2013-05-15','11:55:00',1.94),('8998','2013-05-15','12:00:00',1.26),('8998','2013-05-15','12:05:00',1.14),('8998','2013-05-15','12:10:00',1.2),('8998','2013-05-15','12:15:00',2.01),('8998','2013-05-15','12:20:00',1.43),('8998','2013-05-15','12:25:00',1.61),('8998','2013-05-15','12:30:00',2.19),('8998','2013-05-15','12:35:00',2.47),('8998','2013-05-15','12:40:00',2.87),('8998','2013-05-15','12:45:00',2.59),('8998','2013-05-15','12:50:00',1.88),('8998','2013-05-15','12:55:00',2.96),('8998','2013-05-15','13:00:00',2.88),('8998','2013-05-15','13:05:00',2.64),('8998','2013-05-15','13:10:00',2.81),('8998','2013-05-15','13:15:00',2.32),('8998','2013-05-15','13:20:00',2.24),('8998','2013-05-15','13:25:00',2.81),('8998','2013-05-15','13:30:00',2.73),('8998','2013-05-15','13:35:00',2.69),('8998','2013-05-15','13:40:00',2.63),('8998','2013-05-15','13:45:00',2.6),('8998','2013-05-15','13:50:00',2.58),('8998','2013-05-15','13:55:00',2.57),('8998','2013-05-15','14:00:00',2.54),('8998','2013-05-15','14:05:00',2.52),('8998','2013-05-15','14:10:00',2.47),('8998','2013-05-15','14:15:00',2.42),('8998','2013-05-15','14:20:00',2.41),('8998','2013-05-15','14:25:00',2.32),('8998','2013-05-15','14:30:00',2.32),('8998','2013-05-15','14:35:00',2.27),('8998','2013-05-15','14:40:00',2.23),('8998','2013-05-15','14:45:00',2.19),('8998','2013-05-15','14:50:00',2.07),('8998','2013-05-15','14:55:00',1.73),('8998','2013-05-15','15:00:00',2.07),('8998','2013-05-15','15:05:00',2.06),('8998','2013-05-15','15:10:00',2.03),('8998','2013-05-15','15:15:00',1.84),('8998','2013-05-15','15:20:00',1.87),('8998','2013-05-15','15:25:00',1.89),('8998','2013-05-15','15:30:00',1.82),('8998','2013-05-15','15:35:00',1.75),('8998','2013-05-15','15:40:00',1.79),('8998','2013-05-15','15:45:00',1.72),('8998','2013-05-15','15:50:00',1.68),('8998','2013-05-15','15:55:00',1.64),('8998','2013-05-15','16:00:00',1.6),('8998','2013-05-15','16:05:00',1.53),('8998','2013-05-15','16:10:00',1.51),('8998','2013-05-15','16:15:00',1.43),('8998','2013-05-15','16:20:00',1.47),('8998','2013-05-15','16:25:00',1.43),('8998','2013-05-15','16:30:00',1.42),('8998','2013-05-15','16:35:00',1.38),('8998','2013-05-15','16:50:00',1.07),('8998','2013-05-14','07:35:00',1.16),('8998','2013-05-14','07:40:00',1.43),('8998','2013-05-14','07:45:00',1.48),('8998','2013-05-14','07:50:00',1.36),('8998','2013-05-14','07:55:00',1.29),('8998','2013-05-14','08:00:00',1.35),('8998','2013-05-14','08:05:00',1.34),('8998','2013-05-14','08:10:00',1.52),('8998','2013-05-14','08:15:00',1.51),('8998','2013-05-14','08:20:00',1.48),('8998','2013-05-14','08:25:00',1.52),('8998','2013-05-14','08:30:00',1.6),('8998','2013-05-14','08:35:00',1.72),('8998','2013-05-14','08:40:00',1.67),('8998','2013-05-14','08:45:00',1.8),('8998','2013-05-14','08:50:00',2.09),('8998','2013-05-14','08:55:00',2.03),('8998','2013-05-14','09:00:00',1.83),('8998','2013-05-14','09:05:00',1.86),('8998','2013-05-14','09:10:00',1.98),('8998','2013-05-14','09:15:00',2.12),('8998','2013-05-14','09:20:00',2.35),('8998','2013-05-14','09:25:00',2.53),('8998','2013-05-14','09:30:00',2.65),('8998','2013-05-14','09:35:00',2.68),('8998','2013-05-14','09:40:00',2.65),('8998','2013-05-14','09:45:00',2.72),('8998','2013-05-14','09:50:00',2.77),('8998','2013-05-14','09:55:00',2.77),('8998','2013-05-14','10:00:00',2.84),('8998','2013-05-14','10:05:00',2.89),('8998','2013-05-14','10:10:00',2.87),('8998','2013-05-14','10:15:00',2.82),('8998','2013-05-14','10:20:00',2.92),('8998','2013-05-14','10:25:00',2.95),('8998','2013-05-14','10:30:00',2.88),('8998','2013-05-14','10:35:00',2.91),('8998','2013-05-14','10:40:00',2.95),('8998','2013-05-14','10:45:00',3),('8998','2013-05-14','10:50:00',2.99),('8998','2013-05-14','10:55:00',2.9),('8998','2013-05-14','11:00:00',2.87),('8998','2013-05-14','11:05:00',2.88),('8998','2013-05-14','11:10:00',2.98),('8998','2013-05-14','11:15:00',3.01),('8998','2013-05-14','11:20:00',2.88),('8998','2013-05-14','11:25:00',2.96),('8998','2013-05-14','11:30:00',2.91),('8998','2013-05-14','11:35:00',2.81),('8998','2013-05-14','11:40:00',2.47),('8998','2013-05-14','11:45:00',2.23),('8998','2013-05-14','11:50:00',1.86),('8998','2013-05-14','11:55:00',1.39),('8998','2013-05-14','12:00:00',1.55),('8998','2013-05-14','12:05:00',2.37),('8998','2013-05-14','12:10:00',3.15),('8998','2013-05-14','12:15:00',3.5),('8998','2013-05-14','12:20:00',1.94),('8998','2013-05-14','12:25:00',2.57),('8998','2013-05-14','12:30:00',1.9),('8998','2013-05-14','12:35:00',2.04),('8998','2013-05-14','12:40:00',3.41),('8998','2013-05-14','12:45:00',1.76),('8998','2013-05-14','12:50:00',1.73),('8998','2013-05-14','12:55:00',1.9),('8998','2013-05-14','13:00:00',1.99),('8998','2013-05-14','13:05:00',2.28),('8998','2013-05-14','13:10:00',2.06),('8998','2013-05-14','13:15:00',1.61),('8998','2013-05-14','13:20:00',1.9),('8998','2013-05-14','13:25:00',1.81),('8998','2013-05-14','13:30:00',1.88),('8998','2013-05-14','13:35:00',1.69),('8998','2013-05-14','13:40:00',1.7),('8998','2013-05-14','13:45:00',1.81),('8998','2013-05-14','13:50:00',1.5),('8998','2013-05-14','13:55:00',1.47),('8998','2013-05-14','14:00:00',1.32),('8998','2013-05-14','14:05:00',1.16),('8998','2013-05-14','14:10:00',1.15),('8998','2013-05-14','14:15:00',1.16),('8998','2013-05-14','14:20:00',1.17),('8998','2013-05-14','14:25:00',1.19),('8998','2013-05-14','14:30:00',1.06),('8998','2013-05-14','14:35:00',1.01),('8998','2013-05-14','14:40:00',1.1),('8998','2013-05-14','14:45:00',1.03),('8998','2013-05-14','14:50:00',1.04),('8998','2013-05-14','14:55:00',1.03),('8998','2013-05-14','15:00:00',1.04),('8998','2013-05-14','15:55:00',1.21),('8998','2013-05-14','16:00:00',1.27),('8998','2013-05-14','16:05:00',1.2),('8998','2013-05-14','16:10:00',1.13),('8998','2013-05-14','16:15:00',1.01),('8998','2013-05-14','16:20:00',1.08),('8998','2013-05-14','16:25:00',1.12),('8998','2013-05-14','16:30:00',1.03),('8998','2013-05-14','17:00:00',1.02),('8998','2013-05-14','17:05:00',1.18),('8998','2013-05-14','17:10:00',1.04),('8998','2013-05-14','17:15:00',1.2),('8998','2013-05-13','07:35:00',1.3),('8998','2013-05-13','07:40:00',1.49),('8998','2013-05-13','07:45:00',1.49),('8998','2013-05-13','07:50:00',1.35),('8998','2013-05-13','07:55:00',1.63),('8998','2013-05-13','08:00:00',1.71),('8998','2013-05-13','08:05:00',1.66),('8998','2013-05-13','08:10:00',1.56),('8998','2013-05-13','08:15:00',1.57),('8998','2013-05-13','08:20:00',1.55),('8998','2013-05-13','08:25:00',1.57),('8998','2013-05-13','08:30:00',1.73),('8998','2013-05-13','08:35:00',1.78),('8998','2013-05-13','08:40:00',1.74),('8998','2013-05-13','08:45:00',2.07),('8998','2013-05-13','08:50:00',2.21),('8998','2013-05-13','08:55:00',2.02),('8998','2013-05-13','09:00:00',1.92),('8998','2013-05-13','09:05:00',1.89),('8998','2013-05-13','09:10:00',2.1),('8998','2013-05-13','09:15:00',2.21),('8998','2013-05-13','09:20:00',2.57),('8998','2013-05-13','09:25:00',2.78),('8998','2013-05-13','09:30:00',2.81),('8998','2013-05-13','09:35:00',2.84),('8998','2013-05-13','09:40:00',2.84),('8998','2013-05-13','09:45:00',2.88),('8998','2013-05-13','09:50:00',2.92),('8998','2013-05-13','09:55:00',2.94),('8998','2013-05-13','10:00:00',2.98),('8998','2013-05-13','10:05:00',2.99),('8998','2013-05-13','10:10:00',3.01),('8998','2013-05-13','10:15:00',3.04),('8998','2013-05-13','10:20:00',3.04),('8998','2013-05-13','10:25:00',3.04),('8998','2013-05-13','10:30:00',3.06),('8998','2013-05-13','10:35:00',3.08),('8998','2013-05-13','10:40:00',3.09),('8998','2013-05-13','10:45:00',3.09),('8998','2013-05-13','10:50:00',3.12),('8998','2013-05-13','10:55:00',3.11),('8998','2013-05-13','11:00:00',3.11),('8998','2013-05-13','11:05:00',3.13),('8998','2013-05-13','11:10:00',3.13),('8998','2013-05-13','11:15:00',3.12),('8998','2013-05-13','11:20:00',3.12),('8998','2013-05-13','11:25:00',3.12),('8998','2013-05-13','11:30:00',3.13),('8998','2013-05-13','11:35:00',3.11),('8998','2013-05-13','11:40:00',3.11),('8998','2013-05-13','11:45:00',3.1),('8998','2013-05-13','11:50:00',3.11),('8998','2013-05-13','11:55:00',3.11),('8998','2013-05-13','12:00:00',3.09),('8998','2013-05-13','12:05:00',3.08),('8998','2013-05-13','12:10:00',3.08),('8998','2013-05-13','12:15:00',3.07),('8998','2013-05-13','12:20:00',3.08),('8998','2013-05-13','12:25:00',3.08),('8998','2013-05-13','12:30:00',3.06),('8998','2013-05-13','12:35:00',3.04),('8998','2013-05-13','12:40:00',3.05),('8998','2013-05-13','12:45:00',3.03),('8998','2013-05-13','12:50:00',3.01),('8998','2013-05-13','12:55:00',3),('8998','2013-05-13','13:00:00',2.96),('8998','2013-05-13','13:05:00',2.95),('8998','2013-05-13','13:10:00',2.97),('8998','2013-05-13','13:15:00',2.94),('8998','2013-05-13','13:20:00',2.91),('8998','2013-05-13','13:25:00',2.86),('8998','2013-05-13','13:30:00',2.85),('8998','2013-05-13','13:35:00',2.85),('8998','2013-05-13','13:40:00',2.82),('8998','2013-05-13','13:45:00',2.77),('8998','2013-05-13','13:50:00',2.74),('8998','2013-05-13','13:55:00',2.69),('8998','2013-05-13','14:00:00',2.65),('8998','2013-05-13','14:05:00',2.65),('8998','2013-05-13','14:10:00',2.63),('8998','2013-05-13','14:15:00',2.59),('8998','2013-05-13','14:20:00',2.54),('8998','2013-05-13','14:25:00',2.49),('8998','2013-05-13','14:30:00',2.45),('8998','2013-05-13','14:35:00',2.41),('8998','2013-05-13','14:40:00',2.36),('8998','2013-05-13','14:45:00',2.33),('8998','2013-05-13','14:50:00',2.31),('8998','2013-05-13','14:55:00',2.29),('8998','2013-05-13','15:00:00',2.25),('8998','2013-05-13','15:05:00',2.22),('8998','2013-05-13','15:10:00',2.17),('8998','2013-05-13','15:15:00',2.12),('8998','2013-05-13','15:20:00',2.07),('8998','2013-05-13','15:25:00',2.03),('8998','2013-05-13','15:30:00',1.98),('8998','2013-05-13','15:35:00',1.93),('8998','2013-05-13','15:40:00',1.87),('8998','2013-05-13','15:45:00',1.81),('8998','2013-05-13','15:50:00',1.77),('8998','2013-05-13','15:55:00',1.71),('8998','2013-05-13','16:00:00',1.65),('8998','2013-05-13','16:05:00',1.59),('8998','2013-05-13','16:10:00',1.54),('8998','2013-05-13','16:15:00',1.48),('8998','2013-05-13','16:20:00',1.42),('8998','2013-05-13','16:25:00',1.36),('8998','2013-05-13','16:30:00',1.3),('8998','2013-05-13','16:35:00',1.24),('8998','2013-05-13','16:40:00',1.17),('8998','2013-05-13','16:45:00',1.11),('8998','2013-05-13','16:50:00',1.05),('8998','2013-05-12','07:35:00',1.14),('8998','2013-05-12','07:45:00',1.08),('8998','2013-05-12','08:00:00',1.32),('8998','2013-05-12','08:05:00',1.58),('8998','2013-05-12','08:10:00',1.83),('8998','2013-05-12','08:15:00',1.9),('8998','2013-05-12','08:20:00',1.89),('8998','2013-05-12','08:25:00',1.84),('8998','2013-05-12','08:30:00',1.79),('8998','2013-05-12','08:35:00',1.73),('8998','2013-05-12','08:40:00',1.73),('8998','2013-05-12','08:45:00',1.7),('8998','2013-05-12','08:50:00',1.76),('8998','2013-05-12','08:55:00',1.79),('8998','2013-05-12','09:00:00',1.8),('8998','2013-05-12','09:05:00',1.91),('8998','2013-05-12','09:10:00',2.07),('8998','2013-05-12','09:15:00',2.14),('8998','2013-05-12','09:20:00',2.41),('8998','2013-05-12','09:25:00',2.63),('8998','2013-05-12','09:30:00',2.67),('8998','2013-05-12','09:35:00',2.69),('8998','2013-05-12','09:40:00',2.73),('8998','2013-05-12','09:45:00',2.8),('8998','2013-05-12','09:50:00',2.83),('8998','2013-05-12','09:55:00',2.91),('8998','2013-05-12','10:00:00',2.79),('8998','2013-05-12','10:05:00',2.01),('8998','2013-05-12','10:10:00',2.98),('8998','2013-05-12','10:15:00',3.2),('8998','2013-05-12','10:20:00',2.16),('8998','2013-05-12','10:25:00',2.24),('8998','2013-05-12','10:30:00',3.34),('8998','2013-05-12','10:40:00',1.22),('8998','2013-05-12','10:45:00',2.99),('8998','2013-05-12','10:50:00',3.46),('8998','2013-05-12','10:55:00',2.08),('8998','2013-05-12','11:00:00',2.2),('8998','2013-05-12','11:05:00',1.6),('8998','2013-05-12','11:10:00',1.26),('8998','2013-05-12','11:15:00',1.71),('8998','2013-05-12','11:20:00',1.12),('8998','2013-05-12','11:25:00',1.36),('8998','2013-05-12','11:30:00',1.51),('8998','2013-05-12','11:35:00',2.5),('8998','2013-05-12','11:40:00',1.79),('8998','2013-05-12','11:45:00',2.05),('8998','2013-05-12','11:50:00',1.28),('8998','2013-05-12','11:55:00',1.22),('8998','2013-05-12','12:00:00',1.08),('8998','2013-05-12','12:05:00',1.11),('8998','2013-05-12','12:10:00',2.32),('8998','2013-05-12','12:15:00',1.78),('8998','2013-05-12','12:20:00',1.02),('8998','2013-05-12','12:25:00',1.88),('8998','2013-05-12','12:30:00',2.97),('8998','2013-05-12','12:35:00',2.17),('8998','2013-05-12','12:40:00',1.54),('8998','2013-05-12','12:45:00',1.55),('8998','2013-05-12','12:50:00',2.68),('8998','2013-05-12','12:55:00',3.42),('8998','2013-05-12','13:00:00',3.33),('8998','2013-05-12','13:05:00',2.91),('8998','2013-05-12','13:10:00',3.26),('8998','2013-05-12','13:15:00',3.35),('8998','2013-05-12','13:20:00',3.1),('8998','2013-05-12','13:25:00',3.2),('8998','2013-05-12','13:30:00',3.2),('8998','2013-05-12','13:35:00',2.9),('8998','2013-05-12','13:40:00',1.69),('8998','2013-05-12','13:45:00',1.66),('8998','2013-05-12','14:00:00',1.07),('8998','2013-05-12','14:05:00',3.17),('8998','2013-05-12','14:10:00',3.14),('8998','2013-05-12','14:15:00',2.98),('8998','2013-05-12','14:20:00',2.75),('8998','2013-05-12','14:25:00',2.04),('8998','2013-05-12','14:30:00',1.2),('8998','2013-05-12','14:35:00',2.66),('8998','2013-05-12','14:40:00',2.71),('8998','2013-05-12','14:45:00',1.19),('8998','2013-05-12','14:50:00',1.63),('8998','2013-05-12','14:55:00',2.7),('8998','2013-05-12','15:00:00',2.31),('8998','2013-05-12','15:05:00',1.32),('8998','2013-05-12','16:20:00',1),('8998','2013-05-12','16:30:00',1.19),('8998','2013-05-12','16:40:00',1.28),('8998','2013-05-12','16:45:00',1.46),('8998','2013-05-12','16:50:00',1.71),('8998','2013-05-12','16:55:00',1.47),('8998','2013-05-12','17:00:00',1.31),('8998','2013-05-12','17:05:00',1.12),('8998','2013-05-12','17:15:00',1.3),('8998','2013-05-12','17:20:00',1.28),('8998','2013-05-12','17:25:00',1.07),('8998','2013-05-11','08:00:00',1.29),('8998','2013-05-11','08:10:00',1.44),('8998','2013-05-11','08:15:00',1.97),('8998','2013-05-11','08:20:00',1.67),('8998','2013-05-11','08:25:00',1.18),('8998','2013-05-11','08:45:00',1.64),('8998','2013-05-11','08:50:00',1.33),('8998','2013-05-11','09:00:00',1.08),('8998','2013-05-11','09:30:00',2.37),('8998','2013-05-11','09:35:00',1.03),('8998','2013-05-11','09:40:00',1.35),('8998','2013-05-11','09:45:00',2.13),('8998','2013-05-11','09:50:00',2.83),('8998','2013-05-11','09:55:00',2.82),('8998','2013-05-11','10:00:00',3.08),('8998','2013-05-11','10:05:00',2.11),('8998','2013-05-11','10:10:00',1.04),('8998','2013-05-11','10:15:00',2.06),('8998','2013-05-11','10:45:00',2.85),('8998','2013-05-11','10:50:00',1.87),('8998','2013-05-11','10:55:00',3.64),('8998','2013-05-11','11:00:00',3.39),('8998','2013-05-11','11:05:00',1.03),('8998','2013-05-11','11:15:00',3.02),('8998','2013-05-11','11:20:00',3.54),('8998','2013-05-11','11:25:00',3.5),('8998','2013-05-11','11:30:00',3.56),('8998','2013-05-11','11:35:00',3.37),('8998','2013-05-11','11:40:00',3.2),('8998','2013-05-11','11:45:00',3.54),('8998','2013-05-11','11:50:00',1.99),('8998','2013-05-11','11:55:00',3.55),('8998','2013-05-11','12:00:00',2.71),('8998','2013-05-11','12:05:00',2.69),('8998','2013-05-11','12:10:00',3.15),('8998','2013-05-11','12:15:00',1.99),('8998','2013-05-11','12:35:00',1.12),('8998','2013-05-11','12:40:00',1.42),('8998','2013-05-11','12:45:00',1.72),('8998','2013-05-11','12:50:00',3.72),('8998','2013-05-11','12:55:00',2.42),('8998','2013-05-11','13:00:00',2.83),('8998','2013-05-11','13:05:00',1.01),('8998','2013-05-11','13:10:00',2.3),('8998','2013-05-11','13:15:00',2.81),('8998','2013-05-11','13:20:00',1.33),('8998','2013-05-11','13:25:00',1.52),('8998','2013-05-11','13:30:00',2.47),('8998','2013-05-11','13:35:00',3.1),('8998','2013-05-11','13:40:00',3.29),('8998','2013-05-11','13:45:00',2.39),('8998','2013-05-11','13:50:00',2.8),('8998','2013-05-11','13:55:00',2.72),('8998','2013-05-11','14:00:00',2.01),('8998','2013-05-11','14:05:00',3.3),('8998','2013-05-11','14:10:00',2.37),('8998','2013-05-11','14:15:00',2.53),('8998','2013-05-11','14:20:00',2.9),('8998','2013-05-11','14:25:00',2.78),('8998','2013-05-11','14:30:00',2.71),('8998','2013-05-11','14:35:00',2.67),('8998','2013-05-11','14:40:00',2.61),('8998','2013-05-11','14:45:00',2.5),('8998','2013-05-11','14:50:00',2.5),('8998','2013-05-11','14:55:00',2.45),('8998','2013-05-11','15:00:00',2.12),('8998','2013-05-11','15:05:00',2.41),('8998','2013-05-11','15:10:00',2.25),('8998','2013-05-11','15:15:00',1.92),('8998','2013-05-11','15:20:00',2),('8998','2013-05-11','15:25:00',2.14),('8998','2013-05-11','15:30:00',2.06),('8998','2013-05-11','15:35:00',1.98),('8998','2013-05-11','15:40:00',1.91),('8998','2013-05-11','15:45:00',1.86),('8998','2013-05-11','15:50:00',1.79),('8998','2013-05-11','15:55:00',1.72),('8998','2013-05-11','16:00:00',1.65),('8998','2013-05-11','16:05:00',1.45),('8998','2013-05-11','16:10:00',1.54),('8998','2013-05-11','16:15:00',1.49),('8998','2013-05-11','16:20:00',1.43),('8998','2013-05-11','16:25:00',1.37),('8998','2013-05-11','16:30:00',1.32),('8998','2013-05-11','16:35:00',1.31),('8998','2013-05-11','16:40:00',1.33),('8998','2013-05-11','16:45:00',1.45),('8998','2013-05-11','16:50:00',1.51),('8998','2013-05-11','16:55:00',1.41),('8998','2013-05-11','17:00:00',1.6),('8998','2013-05-11','17:05:00',1.42),('8998','2013-05-11','17:10:00',1.43),('8998','2013-05-11','17:15:00',1.46),('8998','2013-05-11','17:20:00',1.33),('8998','2013-05-11','17:25:00',1.11),('8998','2013-05-11','17:30:00',1.05),('8998','2014-03-30','08:25:00',1.09),('8998','2014-03-30','08:30:00',1.45),('8998','2014-03-30','08:35:00',1.54),('8998','2014-03-30','08:40:00',1.57),('8998','2014-03-30','08:45:00',1.62),('8998','2014-03-30','08:50:00',1.76),('8998','2014-03-30','08:55:00',1.85),('8998','2014-03-30','09:00:00',1.95),('8998','2014-03-30','09:05:00',2),('8998','2014-03-30','09:10:00',2.05),('8998','2014-03-30','09:15:00',2.13),('8998','2014-03-30','09:20:00',2.18),('8998','2014-03-30','09:25:00',2.23),('8998','2014-03-30','09:30:00',2.28),('8998','2014-03-30','09:35:00',2.31),('8998','2014-03-30','09:40:00',2.34),('8998','2014-03-30','09:45:00',2.38),('8998','2014-03-30','09:50:00',2.41),('8998','2014-03-30','09:55:00',2.44),('8998','2014-03-30','10:00:00',2.48),('8998','2014-03-30','10:05:00',2.5),('8998','2014-03-30','10:10:00',2.52),('8998','2014-03-30','10:15:00',2.54),('8998','2014-03-30','10:20:00',2.56),('8998','2014-03-30','10:25:00',2.58),('8998','2014-03-30','10:30:00',2.59),('8998','2014-03-30','10:35:00',2.62),('8998','2014-03-30','10:40:00',2.66),('8998','2014-03-30','10:45:00',2.69),('8998','2014-03-30','10:50:00',2.67),('8998','2014-03-30','10:55:00',2.7),('8998','2014-03-30','11:00:00',2.72),('8998','2014-03-30','11:05:00',2.75),('8998','2014-03-30','11:10:00',2.75),('8998','2014-03-30','11:15:00',2.75),('8998','2014-03-30','11:20:00',2.77),('8998','2014-03-30','11:25:00',2.77),('8998','2014-03-30','11:30:00',2.78),('8998','2014-03-30','11:35:00',2.78),('8998','2014-03-30','11:40:00',2.77),('8998','2014-03-30','11:45:00',2.74),('8998','2014-03-30','11:50:00',2.75),('8998','2014-03-30','11:55:00',2.78),('8998','2014-03-30','12:00:00',2.79),('8998','2014-03-30','12:05:00',2.77),('8998','2014-03-30','12:10:00',2.75),('8998','2014-03-30','12:15:00',2.73),('8998','2014-03-30','12:20:00',2.76),('8998','2014-03-30','12:25:00',2.75),('8998','2014-03-30','12:30:00',2.72),('8998','2014-03-30','12:35:00',2.72),('8998','2014-03-30','12:40:00',2.7),('8998','2014-03-30','12:45:00',2.68),('8998','2014-03-30','12:50:00',2.64),('8998','2014-03-30','12:55:00',2.64),('8998','2014-03-30','13:00:00',2.63),('8998','2014-03-30','13:05:00',2.63),('8998','2014-03-30','13:10:00',2.62),('8998','2014-03-30','13:15:00',2.6),('8998','2014-03-30','13:20:00',2.58),('8998','2014-03-30','13:25:00',2.56),('8998','2014-03-30','13:30:00',2.53),('8998','2014-03-30','13:35:00',2.52),('8998','2014-03-30','13:40:00',2.49),('8998','2014-03-30','13:45:00',2.48),('8998','2014-03-30','13:50:00',2.44),('8998','2014-03-30','13:55:00',2.42),('8998','2014-03-30','14:00:00',2.39),('8998','2014-03-30','14:05:00',2.37),('8998','2014-03-30','14:10:00',2.32),('8998','2014-03-30','14:15:00',2.29),('8998','2014-03-30','14:20:00',2.26),('8998','2014-03-30','14:25:00',2.22),('8998','2014-03-30','14:30:00',2.18),('8998','2014-03-30','14:35:00',2.13),('8998','2014-03-30','14:40:00',2.09),('8998','2014-03-30','14:45:00',2.05),('8998','2014-03-30','14:50:00',1.99),('8998','2014-03-30','14:55:00',1.95),('8998','2014-03-30','15:00:00',1.91),('8998','2014-03-30','15:05:00',1.86),('8998','2014-03-30','15:10:00',1.81),('8998','2014-03-30','15:15:00',1.76),('8998','2014-03-30','15:20:00',1.7),('8998','2014-03-30','15:25:00',1.64),('8998','2014-03-30','15:30:00',1.59),('8998','2014-03-30','15:35:00',1.53),('8998','2014-03-30','15:40:00',1.48),('8998','2014-03-30','15:45:00',1.42),('8998','2014-03-30','15:50:00',1.36),('8998','2014-03-30','15:55:00',1.3),('8998','2014-03-30','16:00:00',1.23),('8998','2014-03-30','16:05:00',1.17),('8998','2014-03-30','16:10:00',1.11),('8998','2014-03-30','16:15:00',1.04),('8998','2013-05-10','07:45:00',1.32),('8998','2013-05-10','07:50:00',1.35),('8998','2013-05-10','07:55:00',1.45),('8998','2013-05-10','08:00:00',1.35),('8998','2013-05-10','08:05:00',1.48),('8998','2013-05-10','08:20:00',1.07),('8998','2013-05-10','09:20:00',1.51),('8998','2013-05-10','09:25:00',1.02),('8998','2013-05-10','09:30:00',2.12),('8998','2013-05-10','09:35:00',1.35),('8998','2013-05-10','09:40:00',1.51),('8998','2013-05-10','09:45:00',1.96),('8998','2013-05-10','09:50:00',1.2),('8998','2013-05-10','09:55:00',1.31),('8998','2013-05-10','10:00:00',1.17),('8998','2013-05-10','10:05:00',1.31),('8998','2013-05-10','10:55:00',2.03),('8998','2013-05-10','11:00:00',3.22),('8998','2013-05-10','11:05:00',2.53),('8998','2013-05-10','11:35:00',1.95),('8998','2013-05-10','11:40:00',1.57),('8998','2013-05-10','11:45:00',2.46),('8998','2013-05-10','11:50:00',2.4),('8998','2013-05-10','12:05:00',1.27),('8998','2013-05-10','12:10:00',1.11),('8998','2013-05-10','12:15:00',1.09),('8998','2013-05-10','12:20:00',1.24),('8998','2013-05-10','12:25:00',3.64),('8998','2013-05-10','12:30:00',2.44),('8998','2013-05-10','12:35:00',1.57),('8998','2013-05-10','12:40:00',1.34),('8998','2013-05-10','12:45:00',1.44),('8998','2013-05-10','12:50:00',1.29),('8998','2013-05-10','12:55:00',1.1),('8998','2013-05-10','13:00:00',1.04),('8998','2013-05-10','13:05:00',1.02),('8998','2013-05-10','14:00:00',1.28),('8998','2013-05-10','14:05:00',1.85),('8998','2013-05-10','14:10:00',2.23),('8998','2013-05-10','14:15:00',1.45),('8998','2013-05-10','14:20:00',2.67),('8998','2013-05-10','14:25:00',2.33),('8998','2013-05-10','14:30:00',2.07),('8998','2013-05-10','14:35:00',1.73),('8998','2013-05-10','14:40:00',1.68),('8998','2013-05-10','14:45:00',2.07),('8998','2013-05-10','14:50:00',2.6),('8998','2013-05-10','14:55:00',2.56),('8998','2013-05-10','15:00:00',2.34),('8998','2013-05-10','15:05:00',2.2),('8998','2013-05-10','15:10:00',2.16),('8998','2013-05-10','15:15:00',2.2),('8998','2013-05-10','15:20:00',2.15),('8998','2013-05-10','15:25:00',2.08),('8998','2013-05-10','15:30:00',2.02),('8998','2013-05-10','15:35:00',1.97),('8998','2013-05-10','15:40:00',1.93),('8998','2013-05-10','15:45:00',1.88),('8998','2013-05-10','15:50:00',1.53),('8998','2013-05-10','15:55:00',1.8),('8998','2013-05-10','16:00:00',1.5),('8998','2013-05-10','16:05:00',1.69),('8998','2013-05-10','16:10:00',1.6),('8998','2013-05-10','16:15:00',1.01),('8998','2013-05-10','16:20:00',1.56),('8998','2013-05-10','16:25:00',1.46),('8998','2013-05-10','16:30:00',1.32),('8998','2013-05-10','16:35:00',1.18),('8998','2013-05-10','16:40:00',1.2),('8998','2013-05-10','16:45:00',1.15),('8998','2013-05-09','07:35:00',1),('8998','2013-05-09','08:00:00',1.29),('8998','2013-05-09','08:05:00',1.86),('8998','2013-05-09','08:10:00',1.84),('8998','2013-05-09','08:15:00',1.92),('8998','2013-05-09','08:20:00',1.77),('8998','2013-05-09','08:25:00',1.65),('8998','2013-05-09','08:30:00',1.7),('8998','2013-05-09','08:35:00',1.71),('8998','2013-05-09','08:40:00',1.14),('8998','2013-05-09','09:00:00',1.24),('8998','2013-05-09','09:05:00',1.9),('8998','2013-05-09','09:10:00',2.09),('8998','2013-05-09','09:15:00',2.26),('8998','2013-05-09','09:20:00',2.32),('8998','2013-05-09','09:25:00',2.14),('8998','2013-05-09','09:30:00',2.2),('8998','2013-05-09','09:35:00',2.71),('8998','2013-05-09','09:40:00',2.6),('8998','2013-05-09','09:45:00',2.33),('8998','2013-05-09','09:50:00',2.4),('8998','2013-05-09','09:55:00',2.64),('8998','2013-05-09','10:00:00',2.08),('8998','2013-05-09','10:05:00',2.49),('8998','2013-05-09','10:10:00',2.53),('8998','2013-05-09','10:15:00',2.71),('8998','2013-05-09','10:20:00',1.55),('8998','2013-05-09','10:25:00',2.09),('8998','2013-05-09','10:30:00',2.3),('8998','2013-05-09','10:40:00',2.5),('8998','2013-05-09','10:45:00',3.25),('8998','2013-05-09','10:50:00',3.26),('8998','2013-05-09','10:55:00',3.07),('8998','2013-05-09','11:00:00',3.2),('8998','2013-05-09','11:05:00',3.21),('8998','2013-05-09','11:10:00',3.17),('8998','2013-05-09','11:15:00',2.85),('8998','2013-05-09','11:20:00',3.33),('8998','2013-05-09','11:25:00',2.99),('8998','2013-05-09','11:30:00',2.69),('8998','2013-05-09','11:35:00',2.94),('8998','2013-05-09','11:40:00',3.16),('8998','2013-05-09','11:45:00',2.14),('8998','2013-05-09','11:50:00',2.55),('8998','2013-05-09','11:55:00',2.92),('8998','2013-05-09','12:00:00',2.9),('8998','2013-05-09','12:05:00',2.4),('8998','2013-05-09','12:10:00',1.68),('8998','2013-05-09','12:15:00',1.58),('8998','2013-05-09','12:20:00',1.89),('8998','2013-05-09','12:25:00',1.69),('8998','2013-05-09','12:30:00',1.58),('8998','2013-05-09','12:35:00',1.8),('8998','2013-05-09','12:40:00',2.54),('8998','2013-05-09','12:45:00',3.24),('8998','2013-05-09','12:50:00',2.7),('8998','2013-05-09','12:55:00',2.36),('8998','2013-05-09','13:00:00',2.76),('8998','2013-05-09','13:05:00',2.61),('8998','2013-05-09','13:10:00',3.22),('8998','2013-05-09','13:15:00',3.32),('8998','2013-05-09','13:20:00',2.34),('8998','2013-05-09','13:25:00',2.01),('8998','2013-05-09','13:30:00',2.15),('8998','2013-05-09','13:35:00',2.33),('8998','2013-05-09','13:40:00',3.08),('8998','2013-05-09','13:45:00',2.86),('8998','2013-05-09','13:50:00',1.72),('8998','2013-05-09','13:55:00',1.49),('8998','2013-05-09','14:00:00',1.34),('8998','2013-05-09','14:05:00',1.33),('8998','2013-05-09','14:10:00',1.57),('8998','2013-05-09','14:15:00',1.7),('8998','2013-05-09','14:20:00',1.77),('8998','2013-05-09','14:25:00',1.75),('8998','2013-05-09','14:30:00',1.73),('8998','2013-05-09','14:35:00',2.13),('8998','2013-05-09','14:40:00',1.93),('8998','2013-05-09','14:45:00',1.5),('8998','2013-05-09','14:50:00',1.14),('8998','2013-05-09','15:10:00',1.07),('8998','2013-05-09','15:15:00',1.83),('8998','2013-05-09','15:20:00',1.82),('8998','2013-05-09','15:25:00',1.36),('8998','2013-05-09','15:30:00',1.25),('8998','2013-05-09','15:35:00',1.26),('8998','2013-05-09','15:40:00',1.3),('8998','2013-05-09','15:45:00',1.29),('8998','2013-05-09','15:50:00',1.21),('8998','2013-05-09','15:55:00',1.15),('8998','2013-05-09','16:00:00',1.1),('8998','2013-05-09','16:05:00',1.09),('8998','2013-05-09','16:10:00',1.08),('8998','2013-05-09','16:15:00',1.02),('8998','2013-05-09','17:20:00',1.01),('8998','2013-05-09','17:25:00',1.03),('8998','2013-05-09','17:35:00',1.01),('8998','2013-05-08','07:35:00',1.19),('8998','2013-05-08','07:40:00',1.28),('8998','2013-05-08','07:45:00',1.3),('8998','2013-05-08','07:50:00',1.27),('8998','2013-05-08','07:55:00',1.31),('8998','2013-05-08','08:00:00',1.39),('8998','2013-05-08','08:05:00',1.44),('8998','2013-05-08','08:10:00',1.43),('8998','2013-05-08','08:15:00',1.48),('8998','2013-05-08','08:20:00',1.74),('8998','2013-05-08','08:25:00',1.72),('8998','2013-05-08','08:30:00',1.61),('8998','2013-05-08','08:35:00',1.65),('8998','2013-05-08','08:40:00',1.81),('8998','2013-05-08','08:45:00',1.99),('8998','2013-05-08','08:50:00',1.86),('8998','2013-05-08','08:55:00',1.74),('8998','2013-05-08','09:00:00',1.7),('8998','2013-05-08','09:05:00',1.84),('8998','2013-05-08','09:10:00',1.85),('8998','2013-05-08','09:15:00',2.04),('8998','2013-05-08','09:20:00',2.23),('8998','2013-05-08','09:25:00',2.53),('8998','2013-05-08','09:30:00',2.71),('8998','2013-05-08','09:35:00',2.74),('8998','2013-05-08','09:40:00',2.76),('8998','2013-05-08','09:45:00',2.79),('8998','2013-05-08','09:50:00',2.83),('8998','2013-05-08','09:55:00',2.87),('8998','2013-05-08','10:00:00',2.88),('8998','2013-05-08','10:05:00',2.9),('8998','2013-05-08','10:10:00',2.93),('8998','2013-05-08','10:15:00',2.94),('8998','2013-05-08','10:20:00',2.96),('8998','2013-05-08','10:25:00',2.98),('8998','2013-05-08','10:30:00',3),('8998','2013-05-08','10:35:00',3.01),('8998','2013-05-08','10:40:00',3.03),('8998','2013-05-08','10:45:00',3.04),('8998','2013-05-08','10:50:00',3.04),('8998','2013-05-08','10:55:00',3.05),('8998','2013-05-08','11:00:00',3.06),('8998','2013-05-08','11:05:00',3.07),('8998','2013-05-08','11:10:00',3.09),('8998','2013-05-08','11:15:00',3.08),('8998','2013-05-08','11:20:00',3.08),('8998','2013-05-08','11:25:00',3.06),('8998','2013-05-08','11:30:00',3.08),('8998','2013-05-08','11:35:00',3.07),('8998','2013-05-08','11:40:00',3.05),('8998','2013-05-08','11:45:00',3.04),('8998','2013-05-08','11:50:00',3.04),('8998','2013-05-08','11:55:00',3.05),('8998','2013-05-08','12:00:00',3.05),('8998','2013-05-08','12:05:00',3.04),('8998','2013-05-08','12:10:00',3.06),('8998','2013-05-08','12:15:00',3.03),('8998','2013-05-08','12:20:00',3.01),('8998','2013-05-08','12:25:00',3.01),('8998','2013-05-08','12:30:00',3.01),('8998','2013-05-08','12:35:00',2.79),('8998','2013-05-08','12:40:00',3.03),('8998','2013-05-08','12:45:00',3),('8998','2013-05-08','12:50:00',3.01),('8998','2013-05-08','12:55:00',2.96),('8998','2013-05-08','13:00:00',2.91),('8998','2013-05-08','13:05:00',2.88),('8998','2013-05-08','13:10:00',2.89),('8998','2013-05-08','13:15:00',2.89),('8998','2013-05-08','13:20:00',2.89),('8998','2013-05-08','13:25:00',2.86),('8998','2013-05-08','13:30:00',2.84),('8998','2013-05-08','13:35:00',2.81),('8998','2013-05-08','13:40:00',2.81),('8998','2013-05-08','13:45:00',2.83),('8998','2013-05-08','13:50:00',2.77),('8998','2013-05-08','13:55:00',2.69),('8998','2013-05-08','14:00:00',2.05),('8998','2013-05-08','14:05:00',2.57),('8998','2013-05-08','14:10:00',1.92),('8998','2013-05-08','14:15:00',1.87),('8998','2013-05-08','14:20:00',2.37),('8998','2013-05-08','14:25:00',2.01),('8998','2013-05-08','14:30:00',2.25),('8998','2013-05-08','14:35:00',2.42),('8998','2013-05-08','14:40:00',2.39),('8998','2013-05-08','14:45:00',2.37),('8998','2013-05-08','14:50:00',2.3),('8998','2013-05-08','14:55:00',2.07),('8998','2013-05-08','15:00:00',2.28),('8998','2013-05-08','15:05:00',2.2),('8998','2013-05-08','15:10:00',2.16),('8998','2013-05-08','15:15:00',2.09),('8998','2013-05-08','15:20:00',2.01),('8998','2013-05-08','15:25:00',1.95),('8998','2013-05-08','15:30:00',1.92),('8998','2013-05-08','15:35:00',1.88),('8998','2013-05-08','15:40:00',1.82),('8998','2013-05-08','15:45:00',1.77),('8998','2013-05-08','15:50:00',1.71),('8998','2013-05-08','15:55:00',1.66),('8998','2013-05-08','16:00:00',1.59),('8998','2013-05-08','16:05:00',1.53),('8998','2013-05-08','16:10:00',1.48),('8998','2013-05-08','16:15:00',1.42),('8998','2013-05-08','16:20:00',1.36),('8998','2013-05-08','16:25:00',1.29),('8998','2013-05-08','16:30:00',1.24),('8998','2013-05-08','16:35:00',1.18),('8998','2013-05-08','16:40:00',1.13),('8998','2013-05-08','16:45:00',1.06),('8998','2013-05-08','16:50:00',1),('8998','2013-05-07','08:05:00',1.33),('8998','2013-05-07','08:10:00',1.65),('8998','2013-05-07','08:15:00',1.61),('8998','2013-05-07','08:20:00',1.61),('8998','2013-05-07','08:25:00',1.56),('8998','2013-05-07','08:30:00',1.57),('8998','2013-05-07','08:35:00',1.69),('8998','2013-05-07','08:40:00',1.37),('8998','2013-05-07','08:45:00',1.9),('8998','2013-05-07','08:50:00',2.28),('8998','2013-05-07','08:55:00',2.51),('8998','2013-05-07','09:00:00',2.44),('8998','2013-05-07','09:05:00',2.65),('8998','2013-05-07','09:10:00',2.56),('8998','2013-05-07','09:15:00',1.73),('8998','2013-05-07','09:20:00',1.97),('8998','2013-05-07','09:25:00',1.2),('8998','2013-05-07','09:40:00',1.67),('8998','2013-05-07','09:45:00',1.71),('8998','2013-05-07','09:50:00',1.08),('8998','2013-05-07','10:05:00',1.25),('8998','2013-05-07','10:10:00',2.92),('8998','2013-05-07','10:15:00',1.68),('8998','2013-05-07','11:05:00',3.64),('8998','2013-05-07','11:10:00',3.45),('8998','2013-05-07','11:15:00',3.34),('8998','2013-05-07','11:20:00',3.19),('8998','2013-05-07','11:25:00',3.22),('8998','2013-05-07','11:30:00',3.33),('8998','2013-05-07','11:35:00',3.13),('8998','2013-05-07','11:40:00',2.65),('8998','2013-05-07','11:45:00',1.57),('8998','2013-05-07','11:50:00',1.12),('8998','2013-05-07','11:55:00',1.16),('8998','2013-05-07','12:00:00',3),('8998','2013-05-07','12:05:00',2.45),('8998','2013-05-07','12:20:00',1.79),('8998','2013-05-07','12:25:00',3.56),('8998','2013-05-07','12:30:00',1.4),('8998','2013-05-07','12:45:00',1.25),('8998','2013-05-07','12:50:00',1.01),('8998','2013-05-07','12:55:00',1.74),('8998','2013-05-07','13:00:00',2.68),('8998','2013-05-07','13:05:00',3.62),('8998','2013-05-07','13:10:00',3.56),('8998','2013-05-07','13:15:00',2.19),('8998','2013-05-07','13:45:00',3.34),('8998','2013-05-07','13:50:00',3.18),('8998','2013-05-07','13:55:00',2.72),('8998','2013-05-07','14:00:00',2.21),('8998','2013-05-07','14:05:00',1.8),('8998','2013-05-07','14:10:00',2.07),('8998','2013-05-07','14:20:00',1),('8998','2013-05-07','14:30:00',1.16),('8998','2013-05-07','14:35:00',1.14),('8998','2013-05-07','14:40:00',2.89),('8998','2013-05-07','14:45:00',1.91),('8998','2013-05-07','14:50:00',2.09),('8998','2013-05-07','14:55:00',2.58),('8998','2013-05-07','15:00:00',2.28),('8998','2013-05-07','15:05:00',2.28),('8998','2013-05-07','15:10:00',2.02),('8998','2013-05-07','15:15:00',2.28),('8998','2013-05-07','15:20:00',2.17),('8998','2013-05-07','15:25:00',2.12),('8998','2013-05-07','15:30:00',2.08),('8998','2013-05-07','15:35:00',1.96),('8998','2013-05-07','15:40:00',1.9),('8998','2013-05-07','15:45:00',1.84),('8998','2013-05-07','15:50:00',1.78),('8998','2013-05-07','15:55:00',1.74),('8998','2013-05-07','16:00:00',1.7),('8998','2013-05-07','16:05:00',1.66),('8998','2013-05-07','16:10:00',1.62),('8998','2013-05-07','16:15:00',1.56),('8998','2013-05-07','16:20:00',1.47),('8998','2013-05-07','16:25:00',1.36),('8998','2013-05-07','16:30:00',1.44),('8998','2013-05-07','16:35:00',1.4),('8998','2013-05-07','16:40:00',1.37),('8998','2013-05-07','16:50:00',1.13),('8998','2013-05-07','16:55:00',1.25),('8998','2013-05-07','17:00:00',1.31),('8998','2013-05-07','17:05:00',1.14),('8998','2013-05-07','17:10:00',1.16),('8998','2013-05-07','17:15:00',1.07),('8998','2013-05-06','07:35:00',1.15),('8998','2013-05-06','07:40:00',1.29),('8998','2013-05-06','07:45:00',1.29),('8998','2013-05-06','07:50:00',1.27),('8998','2013-05-06','07:55:00',1.3),('8998','2013-05-06','08:00:00',1.34),('8998','2013-05-06','08:05:00',1.43),('8998','2013-05-06','08:10:00',1.46),('8998','2013-05-06','08:15:00',1.45),('8998','2013-05-06','08:20:00',1.49),('8998','2013-05-06','08:25:00',1.49),('8998','2013-05-06','08:30:00',1.93),('8998','2013-05-06','08:35:00',2.03),('8998','2013-05-06','08:40:00',2),('8998','2013-05-06','08:45:00',1.96),('8998','2013-05-06','08:50:00',1.8),('8998','2013-05-06','08:55:00',2.05),('8998','2013-05-06','09:00:00',2.43),('8998','2013-05-06','09:05:00',2.57),('8998','2013-05-06','09:10:00',1.84),('8998','2013-05-06','09:15:00',2.11),('8998','2013-05-06','09:20:00',1.53),('8998','2013-05-06','09:35:00',1.82),('8998','2013-05-06','09:40:00',1.71),('8998','2013-05-06','09:45:00',1.31),('8998','2013-05-06','09:50:00',2),('8998','2013-05-06','10:00:00',1.12),('8998','2013-05-06','11:20:00',2.39),('8998','2013-05-06','11:25:00',2.32),('8998','2013-05-06','11:30:00',1.28),('8998','2013-05-06','12:05:00',1.54),('8998','2013-05-06','12:15:00',2.87),('8998','2013-05-06','12:25:00',1.61),('8998','2013-05-06','12:30:00',3.69),('8998','2013-05-06','12:35:00',1.01),('8998','2013-05-06','13:30:00',1.01),('8998','2013-05-06','13:40:00',2.61),('8998','2013-05-06','13:45:00',3.02),('8998','2013-05-06','13:50:00',3.28),('8998','2013-05-06','13:55:00',3.11),('8998','2013-05-06','14:00:00',3),('8998','2013-05-06','14:05:00',2.87),('8998','2013-05-06','14:10:00',2.85),('8998','2013-05-06','14:15:00',2.86),('8998','2013-05-06','14:20:00',2.79),('8998','2013-05-06','14:25:00',1.69),('8998','2013-05-06','14:30:00',2.7),('8998','2013-05-06','14:35:00',1.96),('8998','2013-05-06','14:40:00',3.03),('8998','2013-05-06','14:45:00',2.43),('8998','2013-05-06','14:50:00',2.24),('8998','2013-05-06','14:55:00',2.74),('8998','2013-05-06','15:00:00',2.03),('8998','2013-05-06','15:05:00',2.61),('8998','2013-05-06','15:10:00',2),('8998','2013-05-06','15:15:00',2.18),('8998','2013-05-06','15:20:00',1.93),('8998','2013-05-06','15:25:00',1.36),('8998','2013-05-06','15:30:00',1.29),('8998','2013-05-06','15:35:00',1.78),('8998','2013-05-06','15:40:00',1.34),('8998','2013-05-06','15:45:00',1.59),('8998','2013-05-06','15:50:00',1.09),('8998','2013-05-06','15:55:00',1.15),('8998','2013-05-06','16:00:00',1.86),('8998','2013-05-06','16:05:00',1.56),('8998','2013-05-06','16:15:00',1.13),('8998','2013-05-06','16:20:00',2.24),('8998','2013-05-06','16:25:00',2.08),('8998','2013-05-06','16:30:00',1.89),('8998','2013-05-06','16:35:00',1.79),('8998','2013-05-06','16:40:00',1.8),('8998','2013-05-06','16:45:00',1.37),('8998','2013-05-06','16:50:00',1.4),('8998','2013-05-06','16:55:00',1.32),('8998','2013-05-06','17:00:00',1.35),('8998','2013-05-06','17:05:00',1.3),('8998','2013-05-06','17:10:00',1.08),('8998','2013-05-05','08:30:00',1.07),('8998','2013-05-05','08:55:00',1.22),('8998','2013-05-05','09:00:00',1.49),('8998','2013-05-05','09:10:00',1.23),('8998','2013-05-05','09:15:00',1.07),('8998','2013-05-05','10:00:00',1.22),('8998','2013-05-05','10:15:00',1.07),('8998','2013-05-05','10:20:00',1.42),('8998','2013-05-05','10:25:00',1.11),('8998','2013-05-05','10:30:00',1.18),('8998','2013-05-05','10:35:00',1.16),('8998','2013-05-05','10:40:00',1.17),('8998','2013-05-05','10:45:00',1.87),('8998','2013-05-05','10:50:00',1.92),('8998','2013-05-05','10:55:00',1.5),('8998','2013-05-05','11:00:00',1.52),('8998','2013-05-05','11:05:00',1.5),('8998','2013-05-05','11:10:00',1.47),('8998','2013-05-05','11:15:00',1.19),('8998','2013-05-05','11:20:00',1.55),('8998','2013-05-05','11:25:00',1.56),('8998','2013-05-05','11:30:00',1.6),('8998','2013-05-05','11:35:00',1.06),('8998','2013-05-05','11:40:00',2.27),('8998','2013-05-05','11:45:00',2.87),('8998','2013-05-05','11:50:00',2.43),('8998','2013-05-05','11:55:00',1.26),('8998','2013-05-05','12:00:00',1.17),('8998','2013-05-05','12:05:00',1.39),('8998','2013-05-05','12:10:00',3.26),('8998','2013-05-05','12:15:00',2.29),('8998','2013-05-05','12:20:00',1.87),('8998','2013-05-05','12:25:00',2.11),('8998','2013-05-05','12:30:00',2.81),('8998','2013-05-05','12:35:00',2.39),('8998','2013-05-05','12:40:00',2.02),('8998','2013-05-05','12:45:00',1.68),('8998','2013-05-05','12:50:00',1.96),('8998','2013-05-05','12:55:00',3.08),('8998','2013-05-05','13:00:00',1.25),('8998','2013-05-05','13:05:00',2.27),('8998','2013-05-05','13:10:00',2.91),('8998','2013-05-05','13:15:00',2.39),('8998','2013-05-05','13:20:00',2.38),('8998','2013-05-05','13:25:00',1.68),('8998','2013-05-05','13:30:00',2.68),('8998','2013-05-05','13:35:00',1.73),('8998','2013-05-05','13:40:00',2.6),('8998','2013-05-05','13:45:00',3.13),('8998','2013-05-05','13:50:00',2.87),('8998','2013-05-05','13:55:00',2.81),('8998','2013-05-05','14:00:00',1.95),('8998','2013-05-05','14:05:00',3.01),('8998','2013-05-05','14:10:00',1.61),('8998','2013-05-05','14:15:00',2.19),('8998','2013-05-05','14:20:00',2.49),('8998','2013-05-05','14:25:00',1.74),('8998','2013-05-05','14:30:00',2.15),('8998','2013-05-05','14:35:00',2.21),('8998','2013-05-05','14:40:00',1.25),('8998','2013-05-05','14:45:00',2.21),('8998','2013-05-05','14:50:00',1.23),('8998','2013-05-05','14:55:00',2.18),('8998','2013-05-05','15:00:00',2.57),('8998','2013-05-05','15:05:00',1.62),('8998','2013-05-05','15:10:00',2.23),('8998','2013-05-05','15:15:00',1.48),('8998','2013-05-05','15:20:00',1.14),('8998','2013-05-05','15:25:00',1.95),('8998','2013-05-05','15:30:00',1.37),('8998','2013-05-05','15:35:00',1.04),('8998','2013-05-05','15:40:00',1.14),('8998','2013-05-05','15:55:00',1.25),('8998','2013-05-05','16:00:00',1.15),('8998','2013-05-05','16:20:00',1.01),('8998','2013-05-05','16:25:00',1.22),('8998','2013-05-05','16:30:00',1.25),('8998','2013-05-05','16:35:00',1.04),('8998','2013-05-05','16:40:00',1.43),('8998','2013-05-05','16:45:00',1.32),('8998','2013-05-05','16:50:00',1.07),('8998','2013-05-05','16:55:00',1.27),('8998','2013-05-04','07:45:00',1.16),('8998','2013-05-04','07:50:00',1.19),('8998','2013-05-04','07:55:00',1.2),('8998','2013-05-04','08:00:00',1.26),('8998','2013-05-04','08:05:00',1.38),('8998','2013-05-04','08:10:00',1.41),('8998','2013-05-04','08:15:00',1.47),('8998','2013-05-04','08:20:00',1.61),('8998','2013-05-04','08:25:00',1.88),('8998','2013-05-04','08:30:00',1.95),('8998','2013-05-04','08:35:00',1.75),('8998','2013-05-04','08:40:00',1.84),('8998','2013-05-04','08:45:00',1.61),('8998','2013-05-04','08:50:00',1.21),('8998','2013-05-04','08:55:00',1.06),('8998','2013-05-04','09:00:00',1.14),('8998','2013-05-04','09:05:00',1.22),('8998','2013-05-04','09:10:00',1.48),('8998','2013-05-04','09:15:00',1.55),('8998','2013-05-04','09:20:00',1.46),('8998','2013-05-04','09:25:00',1.55),('8998','2013-05-04','09:30:00',1.75),('8998','2013-05-04','09:35:00',1.19),('8998','2013-05-04','09:40:00',1.97),('8998','2013-05-04','09:45:00',2.56),('8998','2013-05-04','09:50:00',1.76),('8998','2013-05-04','09:55:00',2.99),('8998','2013-05-04','10:00:00',2.01),('8998','2013-05-04','10:05:00',1.96),('8998','2013-05-04','10:10:00',1.82),('8998','2013-05-04','10:15:00',1.48),('8998','2013-05-04','10:20:00',2.64),('8998','2013-05-04','10:25:00',1.92),('8998','2013-05-04','10:30:00',2),('8998','2013-05-04','10:35:00',1.87),('8998','2013-05-04','10:40:00',1.83),('8998','2013-05-04','10:45:00',1.93),('8998','2013-05-04','10:50:00',1.48),('8998','2013-05-04','10:55:00',1.31),('8998','2013-05-04','11:00:00',1.15),('8998','2013-05-04','11:05:00',1.38),('8998','2013-05-04','11:10:00',1.35),('8998','2013-05-04','11:15:00',1.31),('8998','2013-05-04','11:20:00',1.73),('8998','2013-05-04','11:25:00',2.57),('8998','2013-05-04','11:30:00',2.06),('8998','2013-05-04','11:35:00',2.77),('8998','2013-05-04','11:40:00',2.38),('8998','2013-05-04','11:45:00',2.22),('8998','2013-05-04','11:50:00',2),('8998','2013-05-04','11:55:00',2.64),('8998','2013-05-04','12:00:00',1.86),('8998','2013-05-04','12:05:00',1.98),('8998','2013-05-04','12:10:00',1.81),('8998','2013-05-04','12:15:00',2.03),('8998','2013-05-04','12:20:00',2.21),('8998','2013-05-04','12:25:00',2.49),('8998','2013-05-04','12:30:00',2.64),('8998','2013-05-04','12:35:00',2.81),('8998','2013-05-04','12:40:00',2.53),('8998','2013-05-04','12:45:00',2.48),('8998','2013-05-04','12:50:00',2.34),('8998','2013-05-04','12:55:00',2.62),('8998','2013-05-04','13:00:00',2.79),('8998','2013-05-04','13:05:00',2.96),('8998','2013-05-04','13:10:00',2.89),('8998','2013-05-04','13:15:00',3.03),('8998','2013-05-04','13:20:00',2.48),('8998','2013-05-04','13:25:00',1.45),('8998','2013-05-04','13:30:00',1.03),('8998','2013-05-04','13:35:00',2.52),('8998','2013-05-04','13:40:00',2.8),('8998','2013-05-04','13:45:00',2.82),('8998','2013-05-04','13:50:00',2.77),('8998','2013-05-04','13:55:00',2.76),('8998','2013-05-04','14:00:00',2.81),('8998','2013-05-04','14:05:00',2.89),('8998','2013-05-04','14:10:00',2.15),('8998','2013-05-04','14:15:00',1.89),('8998','2013-05-04','14:20:00',2.46),('8998','2013-05-04','14:25:00',2.43),('8998','2013-05-04','14:30:00',2.33),('8998','2013-05-04','14:35:00',2.28),('8998','2013-05-04','14:40:00',2.23),('8998','2013-05-04','14:45:00',2.21),('8998','2013-05-04','14:50:00',2.16),('8998','2013-05-04','14:55:00',2.12),('8998','2013-05-04','15:00:00',2.08),('8998','2013-05-04','15:05:00',2.04),('8998','2013-05-04','15:10:00',1.98),('8998','2013-05-04','15:15:00',1.94),('8998','2013-05-04','15:20:00',1.9),('8998','2013-05-04','15:25:00',1.85),('8998','2013-05-04','15:30:00',1.81),('8998','2013-05-04','15:35:00',1.76),('8998','2013-05-04','15:40:00',1.7),('8998','2013-05-04','15:45:00',1.65),('8998','2013-05-04','15:50:00',1.61),('8998','2013-05-04','15:55:00',1.55),('8998','2013-05-04','16:00:00',1.5),('8998','2013-05-04','16:05:00',1.45),('8998','2013-05-04','16:10:00',1.4),('8998','2013-05-04','16:15:00',1.35),('8998','2013-05-04','16:20:00',1.29),('8998','2013-05-04','16:25:00',1.24),('8998','2013-05-04','16:30:00',1.18),('8998','2013-05-04','16:35:00',1.12),('8998','2013-05-04','16:40:00',1.07),('8998','2013-05-04','16:45:00',1.01),('8998','2013-05-03','07:40:00',1.14),('8998','2013-05-03','07:45:00',1.08),('8998','2013-05-03','07:55:00',1.19),('8998','2013-05-03','08:00:00',1.27),('8998','2013-05-03','08:05:00',1.33),('8998','2013-05-03','08:10:00',1.37),('8998','2013-05-03','08:15:00',1.4),('8998','2013-05-03','08:20:00',1.41),('8998','2013-05-03','08:25:00',1.45),('8998','2013-05-03','08:30:00',1.51),('8998','2013-05-03','08:35:00',1.53),('8998','2013-05-03','08:40:00',1.58),('8998','2013-05-03','08:45:00',1.62),('8998','2013-05-03','08:50:00',1.63),('8998','2013-05-03','08:55:00',1.68),('8998','2013-05-03','09:00:00',1.71),('8998','2013-05-03','09:05:00',1.72),('8998','2013-05-03','09:10:00',1.82),('8998','2013-05-03','09:15:00',1.85),('8998','2013-05-03','09:20:00',1.99),('8998','2013-05-03','09:25:00',2.18),('8998','2013-05-03','09:30:00',2.34),('8998','2013-05-03','09:35:00',2.47),('8998','2013-05-03','09:40:00',2.52),('8998','2013-05-03','09:45:00',2.58),('8998','2013-05-03','09:50:00',2.62),('8998','2013-05-03','09:55:00',2.64),('8998','2013-05-03','10:00:00',2.69),('8998','2013-05-03','10:05:00',2.7),('8998','2013-05-03','10:10:00',2.72),('8998','2013-05-03','10:15:00',2.75),('8998','2013-05-03','10:20:00',2.8),('8998','2013-05-03','10:25:00',2.8),('8998','2013-05-03','10:30:00',2.82),('8998','2013-05-03','10:35:00',2.83),('8998','2013-05-03','10:40:00',2.8),('8998','2013-05-03','10:45:00',2.78),('8998','2013-05-03','10:50:00',2.75),('8998','2013-05-03','10:55:00',2.72),('8998','2013-05-03','11:00:00',2.71),('8998','2013-05-03','11:05:00',2.71),('8998','2013-05-03','11:10:00',2.58),('8998','2013-05-03','11:15:00',2.43),('8998','2013-05-03','11:20:00',2.59),('8998','2013-05-03','11:25:00',2.7),('8998','2013-05-03','11:30:00',2.54),('8998','2013-05-03','11:35:00',2.64),('8998','2013-05-03','11:40:00',2.53),('8998','2013-05-03','11:45:00',2.56),('8998','2013-05-03','11:50:00',2.58),('8998','2013-05-03','11:55:00',2.54),('8998','2013-05-03','12:00:00',2.49),('8998','2013-05-03','12:05:00',2.58),('8998','2013-05-03','12:10:00',2.6),('8998','2013-05-03','12:15:00',2.62),('8998','2013-05-03','12:20:00',2.66),('8998','2013-05-03','12:25:00',2.72),('8998','2013-05-03','12:30:00',2.71),('8998','2013-05-03','12:35:00',2.74),('8998','2013-05-03','12:40:00',2.7),('8998','2013-05-03','12:45:00',2.69),('8998','2013-05-03','12:50:00',2.6),('8998','2013-05-03','12:55:00',2.54),('8998','2013-05-03','13:00:00',2.49),('8998','2013-05-03','13:05:00',2.29),('8998','2013-05-03','13:10:00',2.33),('8998','2013-05-03','13:15:00',2.67),('8998','2013-05-03','13:20:00',2.7),('8998','2013-05-03','13:25:00',2.54),('8998','2013-05-03','13:30:00',2.5),('8998','2013-05-03','13:35:00',2.39),('8998','2013-05-03','13:40:00',2.43),('8998','2013-05-03','13:45:00',2.4),('8998','2013-05-03','13:50:00',2.09),('8998','2013-05-03','13:55:00',2.22),('8998','2013-05-03','14:00:00',2.26),('8998','2013-05-03','14:05:00',2.32),('8998','2013-05-03','14:10:00',2.18),('8998','2013-05-03','14:15:00',2.19),('8998','2013-05-03','14:20:00',2.25),('8998','2013-05-03','14:25:00',2.01),('8998','2013-05-03','14:30:00',2.11),('8998','2013-05-03','14:35:00',1.96),('8998','2013-05-03','14:40:00',2.02),('8998','2013-05-03','14:45:00',1.99),('8998','2013-05-03','14:50:00',1.85),('8998','2013-05-03','14:55:00',1.91),('8998','2013-05-03','15:00:00',1.91),('8998','2013-05-03','15:05:00',1.96),('8998','2013-05-03','15:10:00',1.79),('8998','2013-05-03','15:15:00',1.82),('8998','2013-05-03','15:20:00',1.81),('8998','2013-05-03','15:25:00',1.82),('8998','2013-05-03','15:30:00',1.76),('8998','2013-05-03','15:35:00',1.67),('8998','2013-05-03','15:40:00',1.59),('8998','2013-05-03','15:45:00',1.61),('8998','2013-05-03','15:50:00',1.54),('8998','2013-05-03','15:55:00',1.49),('8998','2013-05-03','16:00:00',1.43),('8998','2013-05-03','16:05:00',1.38),('8998','2013-05-03','16:10:00',1.33),('8998','2013-05-03','16:15:00',1.28),('8998','2013-05-03','16:20:00',1.22),('8998','2013-05-03','16:25:00',1.17),('8998','2013-05-03','16:30:00',1.11),('8998','2013-05-03','16:35:00',1.06),('8998','2013-05-03','16:40:00',1),('8998','2013-05-02','08:05:00',1.29),('8998','2013-05-02','08:10:00',1.47),('8998','2013-05-02','08:15:00',1.64),('8998','2013-05-02','08:20:00',1.54),('8998','2013-05-02','08:25:00',1.64),('8998','2013-05-02','08:30:00',1.69),('8998','2013-05-02','08:35:00',1.68),('8998','2013-05-02','08:40:00',1.71),('8998','2013-05-02','08:45:00',1.73),('8998','2013-05-02','08:50:00',1.67),('8998','2013-05-02','08:55:00',1.66),('8998','2013-05-02','09:00:00',1.75),('8998','2013-05-02','09:05:00',1.76),('8998','2013-05-02','09:10:00',1.82),('8998','2013-05-02','09:15:00',1.89),('8998','2013-05-02','09:20:00',2.02),('8998','2013-05-02','09:25:00',2.15),('8998','2013-05-02','09:30:00',2.4),('8998','2013-05-02','09:35:00',2.58),('8998','2013-05-02','09:40:00',2.63),('8998','2013-05-02','09:45:00',2.65),('8998','2013-05-02','09:50:00',2.69),('8998','2013-05-02','09:55:00',2.7),('8998','2013-05-02','10:00:00',2.75),('8998','2013-05-02','10:05:00',2.77),('8998','2013-05-02','10:10:00',2.81),('8998','2013-05-02','10:15:00',2.82),('8998','2013-05-02','10:20:00',2.83),('8998','2013-05-02','10:25:00',2.84),('8998','2013-05-02','10:30:00',2.86),('8998','2013-05-02','10:35:00',2.86),('8998','2013-05-02','10:40:00',2.85),('8998','2013-05-02','10:45:00',2.89),('8998','2013-05-02','10:50:00',2.9),('8998','2013-05-02','10:55:00',2.91),('8998','2013-05-02','11:00:00',2.92),('8998','2013-05-02','11:05:00',2.93),('8998','2013-05-02','11:10:00',2.94),('8998','2013-05-02','11:15:00',2.93),('8998','2013-05-02','11:20:00',2.95),('8998','2013-05-02','11:25:00',2.96),('8998','2013-05-02','11:30:00',2.94),('8998','2013-05-02','11:35:00',2.95),('8998','2013-05-02','11:40:00',2.95),('8998','2013-05-02','11:45:00',2.93),('8998','2013-05-02','11:50:00',2.95),('8998','2013-05-02','11:55:00',2.94),('8998','2013-05-02','12:00:00',2.93),('8998','2013-05-02','12:05:00',2.9),('8998','2013-05-02','12:10:00',2.92),('8998','2013-05-02','12:15:00',2.93),('8998','2013-05-02','12:20:00',2.92),('8998','2013-05-02','12:25:00',2.91),('8998','2013-05-02','12:30:00',2.89),('8998','2013-05-02','12:35:00',2.85),('8998','2013-05-02','12:40:00',2.82),('8998','2013-05-02','12:45:00',2.81),('8998','2013-05-02','12:50:00',2.81),('8998','2013-05-02','12:55:00',2.84),('8998','2013-05-02','13:00:00',2.81),('8998','2013-05-02','13:05:00',2.77),('8998','2013-05-02','13:10:00',2.75),('8998','2013-05-02','13:15:00',2.72),('8998','2013-05-02','13:20:00',2.73),('8998','2013-05-02','13:25:00',2.7),('8998','2013-05-02','13:30:00',2.66),('8998','2013-05-02','13:35:00',2.61),('8998','2013-05-02','13:40:00',2.49),('8998','2013-05-02','13:45:00',2.48),('8998','2013-05-02','13:50:00',2.46),('8998','2013-05-02','13:55:00',2.47),('8998','2013-05-02','14:00:00',2.43),('8998','2013-05-02','14:05:00',2.29),('8998','2013-05-02','14:10:00',2.3),('8998','2013-05-02','14:15:00',2.23),('8998','2013-05-02','14:20:00',2.27),('8998','2013-05-02','14:25:00',2.25),('8998','2013-05-02','14:30:00',2.24),('8998','2013-05-02','14:35:00',2.23),('8998','2013-05-02','14:40:00',2.14),('8998','2013-05-02','14:45:00',2.09),('8998','2013-05-02','14:50:00',2.06),('8998','2013-05-02','14:55:00',2.02),('8998','2013-05-02','15:00:00',1.98),('8998','2013-05-02','15:05:00',1.95),('8998','2013-05-02','15:10:00',1.94),('8998','2013-05-02','15:15:00',1.91),('8998','2013-05-02','15:20:00',1.86),('8998','2013-05-02','15:25:00',1.81),('8998','2013-05-02','15:30:00',1.77),('8998','2013-05-02','15:35:00',1.73),('8998','2013-05-02','15:40:00',1.67),('8998','2013-05-02','15:45:00',1.62),('8998','2013-05-02','15:50:00',1.56),('8998','2013-05-02','15:55:00',1.5),('8998','2013-05-02','16:00:00',1.47),('8998','2013-05-02','16:05:00',1.41),('8998','2013-05-02','16:10:00',1.36),('8998','2013-05-02','16:15:00',1.3),('8998','2013-05-02','16:20:00',1.23),('8998','2013-05-02','16:25:00',1.17),('8998','2013-05-02','16:30:00',1.15),('8998','2013-05-02','16:35:00',1.1),('8998','2013-05-02','16:40:00',1.04),('8998','2013-05-01','09:00:00',1.61),('8998','2013-05-01','09:05:00',1.52),('8998','2013-05-01','09:25:00',1.19),('8998','2013-05-01','09:30:00',1.43),('8998','2013-05-01','09:35:00',1.74),('8998','2013-05-01','09:40:00',1.13),('8998','2013-05-01','09:45:00',2.08),('8998','2013-05-01','10:05:00',1.1),('8998','2013-05-01','10:10:00',1.15),('8998','2013-05-01','10:15:00',1.17),('8998','2013-05-01','10:20:00',1.18),('8998','2013-05-01','10:25:00',1.43),('8998','2013-05-01','10:30:00',2.47),('8998','2013-05-01','10:35:00',2.17),('8998','2013-05-01','10:40:00',2.93),('8998','2013-05-01','10:45:00',2.27),('8998','2013-05-01','10:50:00',2.65),('8998','2013-05-01','10:55:00',3.09),('8998','2013-05-01','11:00:00',3.14),('8998','2013-05-01','11:05:00',2.99),('8998','2013-05-01','11:10:00',2.24),('8998','2013-05-01','11:15:00',2.18),('8998','2013-05-01','11:20:00',2.04),('8998','2013-05-01','11:25:00',3.06),('8998','2013-05-01','11:30:00',3.06),('8998','2013-05-01','11:35:00',3.04),('8998','2013-05-01','11:40:00',2.95),('8998','2013-05-01','11:45:00',2.93),('8998','2013-05-01','11:50:00',2.91),('8998','2013-05-01','11:55:00',2.89),('8998','2013-05-01','12:00:00',2.87),('8998','2013-05-01','12:05:00',2.83),('8998','2013-05-01','12:10:00',2.79),('8998','2013-05-01','12:15:00',2.8),('8998','2013-05-01','12:20:00',2.81),('8998','2013-05-01','12:25:00',2.78),('8998','2013-05-01','12:30:00',2.79),('8998','2013-05-01','12:35:00',2.83),('8998','2013-05-01','12:40:00',2.85),('8998','2013-05-01','12:45:00',2.86),('8998','2013-05-01','12:50:00',2.84),('8998','2013-05-01','12:55:00',2.83),('8998','2013-05-01','13:00:00',2.84),('8998','2013-05-01','13:05:00',2.82),('8998','2013-05-01','13:10:00',2.83),('8998','2013-05-01','13:15:00',2.83),('8998','2013-05-01','13:20:00',2.81),('8998','2013-05-01','13:25:00',2.78),('8998','2013-05-01','13:30:00',2.75),('8998','2013-05-01','13:35:00',2.72),('8998','2013-05-01','13:40:00',2.69),('8998','2013-05-01','13:45:00',2.66),('8998','2013-05-01','13:50:00',2.63),('8998','2013-05-01','13:55:00',2.61),('8998','2013-05-01','14:00:00',2.57),('8998','2013-05-01','14:05:00',2.52),('8998','2013-05-01','14:10:00',2.48),('8998','2013-05-01','14:15:00',2.46),('8998','2013-05-01','14:20:00',2.42),('8998','2013-05-01','14:25:00',2.37),('8998','2013-05-01','14:30:00',2.33),('8998','2013-05-01','14:35:00',2.3),('8998','2013-05-01','14:40:00',2.26),('8998','2013-05-01','14:45:00',2.23),('8998','2013-05-01','14:50:00',2.19),('8998','2013-05-01','14:55:00',2.15),('8998','2013-05-01','15:00:00',2.1),('8998','2013-05-01','15:05:00',2.04),('8998','2013-05-01','15:10:00',2),('8998','2013-05-01','15:15:00',1.94),('8998','2013-05-01','15:20:00',1.9),('8998','2013-05-01','15:25:00',1.84),('8998','2013-05-01','15:30:00',1.77),('8998','2013-05-01','15:35:00',1.7),('8998','2013-05-01','15:40:00',1.66),('8998','2013-05-01','15:45:00',1.6),('8998','2013-05-01','15:50:00',1.56),('8998','2013-05-01','15:55:00',1.51),('8998','2013-05-01','16:00:00',1.46),('8998','2013-05-01','16:05:00',1.4),('8998','2013-05-01','16:10:00',1.36),('8998','2013-05-01','16:15:00',1.3),('8998','2013-05-01','16:20:00',1.25),('8998','2013-05-01','16:25:00',1.19),('8998','2013-05-01','16:30:00',1.13),('8998','2013-05-01','16:35:00',1.07),('8998','2013-05-01','16:40:00',1.02),('8998','2014-03-29','08:25:00',1.01),('8998','2014-03-29','08:30:00',1.04),('8998','2014-03-29','08:35:00',1.09),('8998','2014-03-29','08:40:00',1.08),('8998','2014-03-29','08:45:00',1.08),('8998','2014-03-29','08:50:00',1.1),('8998','2014-03-29','08:55:00',1.12),('8998','2014-03-29','09:00:00',1.21),('8998','2014-03-29','09:05:00',1.31),('8998','2014-03-29','09:10:00',1.36),('8998','2014-03-29','09:15:00',1.27),('8998','2014-03-29','09:20:00',1.43),('8998','2014-03-29','09:25:00',1.62),('8998','2014-03-29','09:30:00',1.77),('8998','2014-03-29','09:35:00',2.02),('8998','2014-03-29','09:40:00',2.05),('8998','2014-03-29','09:45:00',2.11),('8998','2014-03-29','09:50:00',2.11),('8998','2014-03-29','09:55:00',2.13),('8998','2014-03-29','10:00:00',1.99),('8998','2014-03-29','10:05:00',2.26),('8998','2014-03-29','10:10:00',2.38),('8998','2014-03-29','10:15:00',2.37),('8998','2014-03-29','10:20:00',2.35),('8998','2014-03-29','10:25:00',2.34),('8998','2014-03-29','10:30:00',2.45),('8998','2014-03-29','10:35:00',2.52),('8998','2014-03-29','10:40:00',2.52),('8998','2014-03-29','10:45:00',2.52),('8998','2014-03-29','10:50:00',2.5),('8998','2014-03-29','10:55:00',2.53),('8998','2014-03-29','11:00:00',2.52),('8998','2014-03-29','11:05:00',2.49),('8998','2014-03-29','11:10:00',2.48),('8998','2014-03-29','11:15:00',2.42),('8998','2014-03-29','11:20:00',2.28),('8998','2014-03-29','11:25:00',2.36),('8998','2014-03-29','11:30:00',2.58),('8998','2014-03-29','11:35:00',2.58),('8998','2014-03-29','11:40:00',2.65),('8998','2014-03-29','11:45:00',2.72),('8998','2014-03-29','11:50:00',2.76),('8998','2014-03-29','11:55:00',2.79),('8998','2014-03-29','12:00:00',2.79),('8998','2014-03-29','12:05:00',2.89),('8998','2014-03-29','12:10:00',2.92),('8998','2014-03-29','12:15:00',2.96),('8998','2014-03-29','12:20:00',2.93),('8998','2014-03-29','12:25:00',2.88),('8998','2014-03-29','12:30:00',2.78),('8998','2014-03-29','12:35:00',2.57),('8998','2014-03-29','12:40:00',2.7),('8998','2014-03-29','12:45:00',2.68),('8998','2014-03-29','12:50:00',2.69),('8998','2014-03-29','12:55:00',2.65),('8998','2014-03-29','13:00:00',2.7),('8998','2014-03-29','13:05:00',2.74),('8998','2014-03-29','13:10:00',2.72),('8998','2014-03-29','13:15:00',2.71),('8998','2014-03-29','13:20:00',2.66),('8998','2014-03-29','13:25:00',2.65),('8998','2014-03-29','13:30:00',2.65),('8998','2014-03-29','13:35:00',2.66),('8998','2014-03-29','13:40:00',2.6),('8998','2014-03-29','13:45:00',2.57),('8998','2014-03-29','13:50:00',2.54),('8998','2014-03-29','13:55:00',2.48),('8998','2014-03-29','14:00:00',2.38),('8998','2014-03-29','14:05:00',2.37),('8998','2014-03-29','14:10:00',2.32),('8998','2014-03-29','14:15:00',2.24),('8998','2014-03-29','14:20:00',2.25),('8998','2014-03-29','14:25:00',2.25),('8998','2014-03-29','14:30:00',2.26),('8998','2014-03-29','14:35:00',2.22),('8998','2014-03-29','14:40:00',2.04),('8998','2014-03-29','14:45:00',1.89),('8998','2014-03-29','14:50:00',1.71),('8998','2014-03-29','14:55:00',1.45),('8998','2014-03-29','15:00:00',1.06),('8998','2014-03-29','15:25:00',1.25),('8998','2014-03-29','15:30:00',1.53),('8998','2014-03-29','15:35:00',1.48),('8998','2014-03-29','15:40:00',1.44),('8998','2014-03-29','15:45:00',1.46),('8998','2014-03-29','15:50:00',1.42),('8998','2014-03-29','15:55:00',1.36),('8998','2014-03-29','16:00:00',1.26),('8998','2014-03-29','16:05:00',1.1),('8998','2014-03-29','16:10:00',1.02),('8998','2014-03-29','16:20:00',1.06),('8998','2014-03-29','16:25:00',1.04),('8998','2013-04-30','07:50:00',1.04),('8998','2013-04-30','07:55:00',1.11),('8998','2013-04-30','08:00:00',1.17),('8998','2013-04-30','08:05:00',1.24),('8998','2013-04-30','08:10:00',1.26),('8998','2013-04-30','08:15:00',1.32),('8998','2013-04-30','08:20:00',1.38),('8998','2013-04-30','08:25:00',1.46),('8998','2013-04-30','08:30:00',1.5),('8998','2013-04-30','08:35:00',1.56),('8998','2013-04-30','08:40:00',1.6),('8998','2013-04-30','08:45:00',1.62),('8998','2013-04-30','08:50:00',1.69),('8998','2013-04-30','08:55:00',1.73),('8998','2013-04-30','09:00:00',1.76),('8998','2013-04-30','09:05:00',1.79),('8998','2013-04-30','09:10:00',1.84),('8998','2013-04-30','09:15:00',1.9),('8998','2013-04-30','09:20:00',2),('8998','2013-04-30','09:25:00',2.02),('8998','2013-04-30','09:30:00',2.16),('8998','2013-04-30','09:35:00',2.26),('8998','2013-04-30','09:40:00',2.32),('8998','2013-04-30','09:45:00',2.37),('8998','2013-04-30','09:50:00',2.4),('8998','2013-04-30','09:55:00',2.42),('8998','2013-04-30','10:00:00',2.44),('8998','2013-04-30','10:05:00',2.44),('8998','2013-04-30','10:10:00',2.49),('8998','2013-04-30','10:15:00',2.55),('8998','2013-04-30','10:20:00',2.58),('8998','2013-04-30','10:25:00',2.6),('8998','2013-04-30','10:30:00',2.62),('8998','2013-04-30','10:35:00',2.62),('8998','2013-04-30','10:40:00',2.69),('8998','2013-04-30','10:45:00',2.81),('8998','2013-04-30','10:50:00',2.82),('8998','2013-04-30','10:55:00',2.8),('8998','2013-04-30','11:00:00',2.79),('8998','2013-04-30','11:05:00',2.82),('8998','2013-04-30','11:10:00',2.8),('8998','2013-04-30','11:15:00',2.61),('8998','2013-04-30','11:20:00',2.6),('8998','2013-04-30','11:25:00',2.52),('8998','2013-04-30','11:30:00',2.47),('8998','2013-04-30','11:35:00',2.55),('8998','2013-04-30','11:40:00',2.1),('8998','2013-04-30','11:45:00',1.93),('8998','2013-04-30','11:50:00',2.35),('8998','2013-04-30','11:55:00',2.88),('8998','2013-04-30','12:00:00',2.83),('8998','2013-04-30','12:05:00',2.78),('8998','2013-04-30','12:10:00',2.76),('8998','2013-04-30','12:15:00',2.73),('8998','2013-04-30','12:20:00',2.72),('8998','2013-04-30','12:25:00',2.74),('8998','2013-04-30','12:30:00',2.73),('8998','2013-04-30','12:35:00',2.74),('8998','2013-04-30','12:40:00',2.75),('8998','2013-04-30','12:45:00',2.61),('8998','2013-04-30','12:50:00',2.11),('8998','2013-04-30','12:55:00',1),('8998','2013-04-30','13:00:00',1),('8998','2013-04-30','13:05:00',1.16),('8998','2013-04-30','13:10:00',1.42),('8998','2013-04-30','13:15:00',2.5),('8998','2013-04-30','13:20:00',3.22),('8998','2013-04-30','13:25:00',2.61),('8998','2013-04-30','13:30:00',1.71),('8998','2013-04-30','13:35:00',2.21),('8998','2013-04-30','13:40:00',2.54),('8998','2013-04-30','13:45:00',2.94),('8998','2013-04-30','13:50:00',2.7),('8998','2013-04-30','13:55:00',2.58),('8998','2013-04-30','14:00:00',2.49),('8998','2013-04-30','14:05:00',2.36),('8998','2013-04-30','14:10:00',2.32),('8998','2013-04-30','14:15:00',2),('8998','2013-04-30','14:20:00',2.37),('8998','2013-04-30','14:25:00',2.36),('8998','2013-04-30','14:30:00',2.35),('8998','2013-04-30','14:35:00',2.27),('8998','2013-04-30','14:40:00',1.98),('8998','2013-04-30','14:45:00',2.11),('8998','2013-04-30','14:50:00',1.78),('8998','2013-04-30','14:55:00',1.66),('8998','2013-04-30','15:00:00',1.68),('8998','2013-04-30','15:05:00',1.96),('8998','2013-04-30','15:10:00',1.99),('8998','2013-04-30','15:15:00',1.9),('8998','2013-04-30','15:20:00',1.79),('8998','2013-04-30','15:25:00',1.86),('8998','2013-04-30','15:30:00',1.6),('8998','2013-04-30','15:35:00',1.35),('8998','2013-04-30','15:40:00',1.35),('8998','2013-04-30','15:45:00',1.34),('8998','2013-04-30','15:50:00',1.08),('8998','2013-04-30','15:55:00',1.01),('8998','2013-04-30','16:00:00',1.2),('8998','2013-04-30','16:05:00',1.2),('8998','2013-04-30','16:10:00',1.07),('8998','2013-04-29','08:55:00',1.26),('8998','2013-04-29','09:00:00',1.54),('8998','2013-04-29','09:05:00',1.35),('8998','2013-04-29','09:10:00',1.77),('8998','2013-04-29','09:15:00',2.12),('8998','2013-04-29','09:20:00',2.12),('8998','2013-04-29','09:25:00',2.27),('8998','2013-04-29','09:30:00',2.36),('8998','2013-04-29','09:35:00',2.03),('8998','2013-04-29','09:40:00',1.44),('8998','2013-04-29','09:45:00',1.59),('8998','2013-04-29','09:50:00',2.21),('8998','2013-04-29','09:55:00',2.41),('8998','2013-04-29','10:00:00',2.71),('8998','2013-04-29','10:05:00',2.8),('8998','2013-04-29','10:10:00',2.24),('8998','2013-04-29','10:15:00',1.93),('8998','2013-04-29','10:20:00',1.73),('8998','2013-04-29','10:25:00',1.9),('8998','2013-04-29','10:30:00',1.57),('8998','2013-04-29','10:35:00',1.48),('8998','2013-04-29','10:40:00',1.23),('8998','2013-04-29','10:50:00',1),('8998','2013-04-29','10:55:00',1.09),('8998','2013-04-29','11:00:00',1.08),('8998','2013-04-29','11:05:00',1.2),('8998','2013-04-29','11:10:00',1.25),('8998','2013-04-29','11:15:00',1.29),('8998','2013-04-29','11:20:00',1.54),('8998','2013-04-29','11:25:00',1.41),('8998','2013-04-29','11:30:00',1.36),('8998','2013-04-29','11:35:00',1.43),('8998','2013-04-29','11:40:00',1.47),('8998','2013-04-29','11:45:00',1.25),('8998','2013-04-29','11:50:00',1.28),('8998','2013-04-29','11:55:00',1.29),('8998','2013-04-29','12:00:00',1.29),('8998','2013-04-29','12:05:00',1.29),('8998','2013-04-29','12:10:00',1.28),('8998','2013-04-29','12:15:00',1.19),('8998','2013-04-29','12:20:00',1.04),('8998','2013-04-29','12:35:00',1.51),('8998','2013-04-29','12:40:00',2.97),('8998','2013-04-29','12:45:00',3.27),('8998','2013-04-29','12:50:00',3.1),('8998','2013-04-29','12:55:00',2.79),('8998','2013-04-29','13:00:00',2.86),('8998','2013-04-29','13:05:00',2.79),('8998','2013-04-29','13:10:00',2.84),('8998','2013-04-29','13:15:00',2.76),('8998','2013-04-29','13:20:00',2.7),('8998','2013-04-29','13:25:00',2.65),('8998','2013-04-29','13:30:00',2.6),('8998','2013-04-29','13:35:00',2.59),('8998','2013-04-29','13:40:00',2.53),('8998','2013-04-29','13:45:00',2.49),('8998','2013-04-29','13:50:00',2.45),('8998','2013-04-29','13:55:00',2.41),('8998','2013-04-29','14:00:00',2.38),('8998','2013-04-29','14:05:00',2.35),('8998','2013-04-29','14:10:00',2.31),('8998','2013-04-29','14:15:00',2.28),('8998','2013-04-29','14:20:00',2.26),('8998','2013-04-29','14:25:00',2.23),('8998','2013-04-29','14:30:00',2.18),('8998','2013-04-29','14:35:00',2.15),('8998','2013-04-29','14:40:00',2.11),('8998','2013-04-29','14:45:00',2.07),('8998','2013-04-29','14:50:00',2.02),('8998','2013-04-29','14:55:00',1.97),('8998','2013-04-29','15:00:00',1.92),('8998','2013-04-29','15:05:00',1.87),('8998','2013-04-29','15:10:00',1.82),('8998','2013-04-29','15:15:00',1.77),('8998','2013-04-29','15:20:00',1.73),('8998','2013-04-29','15:25:00',1.69),('8998','2013-04-29','15:30:00',1.64),('8998','2013-04-29','15:35:00',1.6),('8998','2013-04-29','15:40:00',1.55),('8998','2013-04-29','15:45:00',1.5),('8998','2013-04-29','15:50:00',1.44),('8998','2013-04-29','15:55:00',1.4),('8998','2013-04-29','16:00:00',1.35),('8998','2013-04-29','16:05:00',1.3),('8998','2013-04-29','16:10:00',1.26),('8998','2013-04-29','16:15:00',1.21),('8998','2013-04-29','16:20:00',1.16),('8998','2013-04-29','16:25:00',1.11),('8998','2013-04-29','16:30:00',1.07),('8998','2013-04-29','16:35:00',1.02),('8998','2013-04-28','08:00:00',1.18),('8998','2013-04-28','08:05:00',1.31),('8998','2013-04-28','08:10:00',1.26),('8998','2013-04-28','08:15:00',1.25),('8998','2013-04-28','08:20:00',1.32),('8998','2013-04-28','08:25:00',1.48),('8998','2013-04-28','08:30:00',1.62),('8998','2013-04-28','08:35:00',1.8),('8998','2013-04-28','08:40:00',1.81),('8998','2013-04-28','08:45:00',1.74),('8998','2013-04-28','08:50:00',1.85),('8998','2013-04-28','08:55:00',1.82),('8998','2013-04-28','09:00:00',1.38),('8998','2013-04-28','09:05:00',1.8),('8998','2013-04-28','09:10:00',2.02),('8998','2013-04-28','09:15:00',2.15),('8998','2013-04-28','09:20:00',2.07),('8998','2013-04-28','09:25:00',1.98),('8998','2013-04-28','09:30:00',2.09),('8998','2013-04-28','09:35:00',2.26),('8998','2013-04-28','09:40:00',2.28),('8998','2013-04-28','09:45:00',2.34),('8998','2013-04-28','09:50:00',2.51),('8998','2013-04-28','09:55:00',2.28),('8998','2013-04-28','10:00:00',2.39),('8998','2013-04-28','10:05:00',2.37),('8998','2013-04-28','10:10:00',2.32),('8998','2013-04-28','10:15:00',1.95),('8998','2013-04-28','10:20:00',1.84),('8998','2013-04-28','10:25:00',2.29),('8998','2013-04-28','10:30:00',2.22),('8998','2013-04-28','10:35:00',2.63),('8998','2013-04-28','10:40:00',2.64),('8998','2013-04-28','10:45:00',2.67),('8998','2013-04-28','10:50:00',2.53),('8998','2013-04-28','10:55:00',2.33),('8998','2013-04-28','11:00:00',2.59),('8998','2013-04-28','11:05:00',2.54),('8998','2013-04-28','11:10:00',2.43),('8998','2013-04-28','11:15:00',2.25),('8998','2013-04-28','11:20:00',2.62),('8998','2013-04-28','11:25:00',2.7),('8998','2013-04-28','11:30:00',2.8),('8998','2013-04-28','11:35:00',2.66),('8998','2013-04-28','11:40:00',2.67),('8998','2013-04-28','11:45:00',2.6),('8998','2013-04-28','11:50:00',2.83),('8998','2013-04-28','11:55:00',2.8),('8998','2013-04-28','12:00:00',2.86),('8998','2013-04-28','12:05:00',2.86),('8998','2013-04-28','12:10:00',2.75),('8998','2013-04-28','12:15:00',2.74),('8998','2013-04-28','12:20:00',2.77),('8998','2013-04-28','12:25:00',2.68),('8998','2013-04-28','12:30:00',2.7),('8998','2013-04-28','12:35:00',2.74),('8998','2013-04-28','12:40:00',2.78),('8998','2013-04-28','12:45:00',2.77),('8998','2013-04-28','12:50:00',2.76),('8998','2013-04-28','12:55:00',2.65),('8998','2013-04-28','13:00:00',2.7),('8998','2013-04-28','13:05:00',2.66),('8998','2013-04-28','13:10:00',2.56),('8998','2013-04-28','13:15:00',2.39),('8998','2013-04-28','13:20:00',2.52),('8998','2013-04-28','13:25:00',2.65),('8998','2013-04-28','13:30:00',2.61),('8998','2013-04-28','13:35:00',2.53),('8998','2013-04-28','13:40:00',2.55),('8998','2013-04-28','13:45:00',2.52),('8998','2013-04-28','13:50:00',2.38),('8998','2013-04-28','13:55:00',2.61),('8998','2013-04-28','14:00:00',2.4),('8998','2013-04-28','14:05:00',2.38),('8998','2013-04-28','14:10:00',2.42),('8998','2013-04-28','14:15:00',2.45),('8998','2013-04-28','14:20:00',2.42),('8998','2013-04-28','14:25:00',2.32),('8998','2013-04-28','14:30:00',2.19),('8998','2013-04-28','14:35:00',2.11),('8998','2013-04-28','14:40:00',1.99),('8998','2013-04-28','14:45:00',2.13),('8998','2013-04-28','14:50:00',2.05),('8998','2013-04-28','14:55:00',2.08),('8998','2013-04-28','15:00:00',1.99),('8998','2013-04-28','15:05:00',2.09),('8998','2013-04-28','15:10:00',1.89),('8998','2013-04-28','15:15:00',1.73),('8998','2013-04-28','15:20:00',1.8),('8998','2013-04-28','15:25:00',1.91),('8998','2013-04-28','15:30:00',1.83),('8998','2013-04-28','15:35:00',1.6),('8998','2013-04-28','15:40:00',1.45),('8998','2013-04-28','15:45:00',1.39),('8998','2013-04-28','15:50:00',1.41),('8998','2013-04-28','15:55:00',1.5),('8998','2013-04-28','16:00:00',1.45),('8998','2013-04-28','16:05:00',1.54),('8998','2013-04-28','16:10:00',1.45),('8998','2013-04-28','16:15:00',1.63),('8998','2013-04-28','16:20:00',1.6),('8998','2013-04-28','16:25:00',1.25),('8998','2013-04-28','16:30:00',1.26),('8998','2013-04-28','16:35:00',1.23),('8998','2013-04-28','16:40:00',1.26),('8998','2013-04-28','16:45:00',1.2),('8998','2013-04-28','16:50:00',1.18),('8998','2013-04-28','16:55:00',1.17),('8998','2013-04-28','17:00:00',1.05),('8998','2013-04-27','07:45:00',1.02),('8998','2013-04-27','07:50:00',1.17),('8998','2013-04-27','07:55:00',1.17),('8998','2013-04-27','08:00:00',1.21),('8998','2013-04-27','08:05:00',1.33),('8998','2013-04-27','08:10:00',1.4),('8998','2013-04-27','08:15:00',1.5),('8998','2013-04-27','08:20:00',1.45),('8998','2013-04-27','08:25:00',1.54),('8998','2013-04-27','08:30:00',1.77),('8998','2013-04-27','08:35:00',1.68),('8998','2013-04-27','08:40:00',1.6),('8998','2013-04-27','08:45:00',1.61),('8998','2013-04-27','08:50:00',1.64),('8998','2013-04-27','08:55:00',1.64),('8998','2013-04-27','09:00:00',1.68),('8998','2013-04-27','09:05:00',1.74),('8998','2013-04-27','09:10:00',1.76),('8998','2013-04-27','09:15:00',1.81),('8998','2013-04-27','09:20:00',1.92),('8998','2013-04-27','09:25:00',2.03),('8998','2013-04-27','09:30:00',2.34),('8998','2013-04-27','09:35:00',2.45),('8998','2013-04-27','09:40:00',2.6),('8998','2013-04-27','09:45:00',2.66),('8998','2013-04-27','09:50:00',2.7),('8998','2013-04-27','09:55:00',2.72),('8998','2013-04-27','10:00:00',2.73),('8998','2013-04-27','10:05:00',2.72),('8998','2013-04-27','10:10:00',2.79),('8998','2013-04-27','10:15:00',2.73),('8998','2013-04-27','10:20:00',2.81),('8998','2013-04-27','10:25:00',2.87),('8998','2013-04-27','10:30:00',2.79),('8998','2013-04-27','10:35:00',2.86),('8998','2013-04-27','10:40:00',2.6),('8998','2013-04-27','10:45:00',2.94),('8998','2013-04-27','10:50:00',2.91),('8998','2013-04-27','10:55:00',2.91),('8998','2013-04-27','11:00:00',2.92),('8998','2013-04-27','11:05:00',2.91),('8998','2013-04-27','11:10:00',2.95),('8998','2013-04-27','11:15:00',2.93),('8998','2013-04-27','11:20:00',2.95),('8998','2013-04-27','11:25:00',2.97),('8998','2013-04-27','11:30:00',2.97),('8998','2013-04-27','11:35:00',2.87),('8998','2013-04-27','11:40:00',2.86),('8998','2013-04-27','11:45:00',2.75),('8998','2013-04-27','11:50:00',2.76),('8998','2013-04-27','11:55:00',2.87),('8998','2013-04-27','12:00:00',2.5),('8998','2013-04-27','12:05:00',2.47),('8998','2013-04-27','12:10:00',2.71),('8998','2013-04-27','12:15:00',2.83),('8998','2013-04-27','12:20:00',2.74),('8998','2013-04-27','12:25:00',2.41),('8998','2013-04-27','12:30:00',2.33),('8998','2013-04-27','12:35:00',2.09),('8998','2013-04-27','12:40:00',2.12),('8998','2013-04-27','12:45:00',2.74),('8998','2013-04-27','12:50:00',2.86),('8998','2013-04-27','12:55:00',2.59),('8998','2013-04-27','13:00:00',2.66),('8998','2013-04-27','13:05:00',2.83),('8998','2013-04-27','13:10:00',2.76),('8998','2013-04-27','13:15:00',2.55),('8998','2013-04-27','13:20:00',2.57),('8998','2013-04-27','13:25:00',2.55),('8998','2013-04-27','13:30:00',2.66),('8998','2013-04-27','13:35:00',2.64),('8998','2013-04-27','13:40:00',2.79),('8998','2013-04-27','13:45:00',2.7),('8998','2013-04-27','13:50:00',2.66),('8998','2013-04-27','13:55:00',2.29),('8998','2013-04-27','14:00:00',2.49),('8998','2013-04-27','14:05:00',2.48),('8998','2013-04-27','14:10:00',2.4),('8998','2013-04-27','14:15:00',2.43),('8998','2013-04-27','14:20:00',1.98),('8998','2013-04-27','14:25:00',2.08),('8998','2013-04-27','14:30:00',2.29),('8998','2013-04-27','14:35:00',2.26),('8998','2013-04-27','14:40:00',2.21),('8998','2013-04-27','14:45:00',2.15),('8998','2013-04-27','14:50:00',2.11),('8998','2013-04-27','14:55:00',2.06),('8998','2013-04-27','15:00:00',2.03),('8998','2013-04-27','15:05:00',1.98),('8998','2013-04-27','15:10:00',1.94),('8998','2013-04-27','15:15:00',1.91),('8998','2013-04-27','15:20:00',1.86),('8998','2013-04-27','15:25:00',1.81),('8998','2013-04-27','15:30:00',1.76),('8998','2013-04-27','15:35:00',1.71),('8998','2013-04-27','15:40:00',1.66),('8998','2013-04-27','15:45:00',1.61),('8998','2013-04-27','15:50:00',1.55),('8998','2013-04-27','15:55:00',1.5),('8998','2013-04-27','16:00:00',1.45),('8998','2013-04-27','16:05:00',1.4),('8998','2013-04-27','16:10:00',1.34),('8998','2013-04-27','16:15:00',1.28),('8998','2013-04-27','16:20:00',1.22),('8998','2013-04-27','16:25:00',1.17),('8998','2013-04-27','16:30:00',1.12),('8998','2013-04-27','16:35:00',1.06),('8998','2013-04-27','16:40:00',1),('8998','2013-04-26','13:00:00',1.04),('8998','2013-04-26','13:20:00',1.03),('8998','2013-04-26','13:40:00',1.27),('8998','2013-04-26','14:30:00',1.47),('8998','2013-04-26','14:35:00',1.42),('8998','2013-04-26','16:50:00',1.04),('8998','2013-04-26','16:55:00',1.09),('8998','2013-04-26','17:00:00',1.25),('8998','2013-04-25','08:10:00',1.23),('8998','2013-04-25','08:15:00',1.34),('8998','2013-04-25','08:20:00',1.38),('8998','2013-04-25','08:25:00',1.42),('8998','2013-04-25','08:30:00',1.44),('8998','2013-04-25','08:35:00',1.52),('8998','2013-04-25','08:40:00',1.56),('8998','2013-04-25','08:45:00',1.62),('8998','2013-04-25','08:50:00',1.64),('8998','2013-04-25','08:55:00',1.41),('8998','2013-04-25','09:00:00',1.08),('8998','2013-04-25','09:05:00',1.44),('8998','2013-04-25','09:10:00',1.62),('8998','2013-04-25','09:15:00',1.03),('8998','2013-04-25','09:25:00',1.1),('8998','2013-04-25','09:30:00',1.51),('8998','2013-04-25','09:35:00',1.59),('8998','2013-04-25','09:40:00',1.96),('8998','2013-04-25','09:45:00',2.31),('8998','2013-04-25','09:50:00',2.28),('8998','2013-04-25','09:55:00',1.45),('8998','2013-04-25','10:00:00',1.46),('8998','2013-04-25','10:05:00',1.88),('8998','2013-04-25','10:10:00',2.51),('8998','2013-04-25','10:15:00',2.65),('8998','2013-04-25','10:20:00',2.66),('8998','2013-04-25','10:25:00',2.09),('8998','2013-04-25','10:30:00',2.61),('8998','2013-04-25','10:35:00',2.82),('8998','2013-04-25','10:40:00',2.82),('8998','2013-04-25','10:45:00',2.39),('8998','2013-04-25','10:50:00',1.55),('8998','2013-04-25','10:55:00',2.21),('8998','2013-04-25','11:00:00',2.38),('8998','2013-04-25','11:05:00',2.72),('8998','2013-04-25','11:10:00',2.38),('8998','2013-04-25','11:15:00',2.72),('8998','2013-04-25','11:20:00',2.21),('8998','2013-04-25','11:25:00',2.25),('8998','2013-04-25','11:30:00',2.25),('8998','2013-04-25','11:35:00',2.48),('8998','2013-04-25','11:40:00',2.52),('8998','2013-04-25','11:45:00',2.51),('8998','2013-04-25','11:50:00',1.99),('8998','2013-04-25','11:55:00',1.82),('8998','2013-04-25','12:00:00',1.96),('8998','2013-04-25','12:05:00',1.95),('8998','2013-04-25','12:10:00',1.63),('8998','2013-04-25','12:15:00',1.79),('8998','2013-04-25','12:20:00',1.78),('8998','2013-04-25','12:25:00',1.52),('8998','2013-04-25','12:30:00',1.28),('8998','2013-04-25','12:35:00',1.53),('8998','2013-04-25','12:40:00',2.33),('8998','2013-04-25','12:45:00',2.67),('8998','2013-04-25','12:50:00',1.67),('8998','2013-04-25','12:55:00',1.41),('8998','2013-04-25','13:00:00',1.05),('8998','2013-04-25','13:10:00',1.1),('8998','2013-04-25','13:15:00',1.53),('8998','2013-04-25','13:20:00',1.13),('8998','2013-04-25','13:25:00',1.27),('8998','2013-04-25','13:30:00',1.64),('8998','2013-04-25','13:35:00',1.52),('8998','2013-04-25','13:40:00',1.82),('8998','2013-04-25','13:45:00',1.51),('8998','2013-04-25','13:50:00',2),('8998','2013-04-25','13:55:00',1.69),('8998','2013-04-25','14:00:00',1.76),('8998','2013-04-25','14:05:00',2.28),('8998','2013-04-25','14:10:00',2.07),('8998','2013-04-25','14:15:00',2.29),('8998','2013-04-25','14:20:00',1.91),('8998','2013-04-25','14:25:00',2.2),('8998','2013-04-25','14:30:00',2.35),('8998','2013-04-25','14:35:00',1.85),('8998','2013-04-25','14:40:00',1.15),('8998','2013-04-25','14:45:00',1.08),('8998','2013-04-25','14:50:00',2.13),('8998','2013-04-25','14:55:00',2.38),('8998','2013-04-25','15:00:00',2.16),('8998','2013-04-25','15:05:00',1.83),('8998','2013-04-25','15:15:00',1.05),('8998','2013-04-25','15:30:00',1.28),('8998','2013-04-25','15:35:00',1.18),('8998','2013-04-25','15:40:00',1.12),('8998','2013-04-25','15:45:00',1.16),('8998','2013-04-25','15:50:00',1.08),('8998','2013-04-24','08:10:00',1.02),('8998','2013-04-24','08:15:00',1.28),('8998','2013-04-24','08:20:00',1.08),('8998','2013-04-24','08:45:00',1.08),('8998','2013-04-24','08:50:00',1.7),('8998','2013-04-24','08:55:00',2.02),('8998','2013-04-24','09:00:00',1.74),('8998','2013-04-24','09:05:00',1.26),('8998','2013-04-24','09:10:00',1.12),('8998','2013-04-24','09:15:00',1.07),('8998','2013-04-24','09:20:00',1.09),('8998','2013-04-24','09:25:00',1.34),('8998','2013-04-24','09:30:00',1.27),('8998','2013-04-24','09:35:00',1.39),('8998','2013-04-24','09:40:00',2.02),('8998','2013-04-24','09:45:00',2.4),('8998','2013-04-24','09:50:00',2.77),('8998','2013-04-24','09:55:00',2.75),('8998','2013-04-24','10:00:00',2.74),('8998','2013-04-24','10:05:00',2.58),('8998','2013-04-24','10:10:00',2.37),('8998','2013-04-24','10:15:00',2.44),('8998','2013-04-24','10:20:00',2.77),('8998','2013-04-24','10:25:00',2.82),('8998','2013-04-24','10:30:00',2.87),('8998','2013-04-24','10:35:00',2.9),('8998','2013-04-24','10:40:00',2.87),('8998','2013-04-24','10:45:00',2.76),('8998','2013-04-24','10:50:00',2.87),('8998','2013-04-24','10:55:00',2.92),('8998','2013-04-24','11:00:00',2.95),('8998','2013-04-24','11:05:00',2.99),('8998','2013-04-24','11:10:00',2.97),('8998','2013-04-24','11:15:00',2.95),('8998','2013-04-24','11:20:00',2.96),('8998','2013-04-24','11:25:00',2.97),('8998','2013-04-24','11:30:00',2.95),('8998','2013-04-24','11:35:00',2.99),('8998','2013-04-24','11:40:00',2.99),('8998','2013-04-24','11:45:00',3),('8998','2013-04-24','11:50:00',3.01),('8998','2013-04-24','11:55:00',2.95),('8998','2013-04-24','12:00:00',2.88),('8998','2013-04-24','12:05:00',2.88),('8998','2013-04-24','12:10:00',2.91),('8998','2013-04-24','12:15:00',2.91),('8998','2013-04-24','12:20:00',2.91),('8998','2013-04-24','12:25:00',2.88),('8998','2013-04-24','12:30:00',2.88),('8998','2013-04-24','12:35:00',2.87),('8998','2013-04-24','12:40:00',2.84),('8998','2013-04-24','12:45:00',2.83),('8998','2013-04-24','12:50:00',2.8),('8998','2013-04-24','12:55:00',2.81),('8998','2013-04-24','13:00:00',2.83),('8998','2013-04-24','13:05:00',2.88),('8998','2013-04-24','13:10:00',2.76),('8998','2013-04-24','13:15:00',2.64),('8998','2013-04-24','13:20:00',2.51),('8998','2013-04-24','13:25:00',2.51),('8998','2013-04-24','13:30:00',1.99),('8998','2013-04-24','13:35:00',1.97),('8998','2013-04-24','13:40:00',1.64),('8998','2013-04-24','13:45:00',1.51),('8998','2013-04-24','13:50:00',1.38),('8998','2013-04-24','13:55:00',1.44),('8998','2013-04-24','14:00:00',1.55),('8998','2013-04-24','14:05:00',1.41),('8998','2013-04-24','14:10:00',1.52),('8998','2013-04-24','14:15:00',1.6),('8998','2013-04-24','14:20:00',1.64),('8998','2013-04-24','14:25:00',1.65),('8998','2013-04-24','14:30:00',1.9),('8998','2013-04-24','14:35:00',2.26),('8998','2013-04-24','14:40:00',2.16),('8998','2013-04-24','14:45:00',2.14),('8998','2013-04-24','14:50:00',1.9),('8998','2013-04-24','14:55:00',1.96),('8998','2013-04-24','15:00:00',1.84),('8998','2013-04-24','15:05:00',1.68),('8998','2013-04-24','15:10:00',1.59),('8998','2013-04-24','15:15:00',1.79),('8998','2013-04-24','15:20:00',1.88),('8998','2013-04-24','15:25:00',1.9),('8998','2013-04-24','15:30:00',1.86),('8998','2013-04-24','15:35:00',1.72),('8998','2013-04-24','15:40:00',1.61),('8998','2013-04-24','15:45:00',1.49),('8998','2013-04-24','15:50:00',1.4),('8998','2013-04-24','15:55:00',1.34),('8998','2013-04-24','16:00:00',1.37),('8998','2013-04-24','16:05:00',1.17),('8998','2013-04-24','16:10:00',1.16),('8998','2013-04-24','16:15:00',1.14),('8998','2013-04-24','16:20:00',1.16),('8998','2013-04-24','16:25:00',1.09),('8998','2013-04-24','16:35:00',1.18),('8998','2013-04-24','16:40:00',1.03),('8998','2013-04-24','16:45:00',1.07),('8998','2013-04-24','17:10:00',1.03),('8998','2013-04-23','07:55:00',1.24),('8998','2013-04-23','08:00:00',1.26),('8998','2013-04-23','08:05:00',1.25),('8998','2013-04-23','08:10:00',1.3),('8998','2013-04-23','08:15:00',1.47),('8998','2013-04-23','08:20:00',1.59),('8998','2013-04-23','08:25:00',1.78),('8998','2013-04-23','08:30:00',1.83),('8998','2013-04-23','08:35:00',1.74),('8998','2013-04-23','08:40:00',1.72),('8998','2013-04-23','08:45:00',1.7),('8998','2013-04-23','08:50:00',1.73),('8998','2013-04-23','08:55:00',1.7),('8998','2013-04-23','09:00:00',1.72),('8998','2013-04-23','09:05:00',2.21),('8998','2013-04-23','09:10:00',2.24),('8998','2013-04-23','09:15:00',2.05),('8998','2013-04-23','09:20:00',1.71),('8998','2013-04-23','09:25:00',1.96),('8998','2013-04-23','09:30:00',2.45),('8998','2013-04-23','09:35:00',2.49),('8998','2013-04-23','09:40:00',2.36),('8998','2013-04-23','09:45:00',2.34),('8998','2013-04-23','09:50:00',2.47),('8998','2013-04-23','09:55:00',2.86),('8998','2013-04-23','10:00:00',2.82),('8998','2013-04-23','10:05:00',2.87),('8998','2013-04-23','10:10:00',2.85),('8998','2013-04-23','10:15:00',2.83),('8998','2013-04-23','10:20:00',2.81),('8998','2013-04-23','10:25:00',2.77),('8998','2013-04-23','10:30:00',2.71),('8998','2013-04-23','10:35:00',2.66),('8998','2013-04-23','10:40:00',2.9),('8998','2013-04-23','10:45:00',3.01),('8998','2013-04-23','10:50:00',2.99),('8998','2013-04-23','10:55:00',3.04),('8998','2013-04-23','11:00:00',3.07),('8998','2013-04-23','11:05:00',2.96),('8998','2013-04-23','11:10:00',3.12),('8998','2013-04-23','11:15:00',3.19),('8998','2013-04-23','11:20:00',3.22),('8998','2013-04-23','11:25:00',3.3),('8998','2013-04-23','11:30:00',3.12),('8998','2013-04-23','11:35:00',2.56),('8998','2013-04-23','11:40:00',1.75),('8998','2013-04-23','11:45:00',2.03),('8998','2013-04-23','11:50:00',1.45),('8998','2013-04-23','11:55:00',1.9),('8998','2013-04-23','12:00:00',2.49),('8998','2013-04-23','12:05:00',1.72),('8998','2013-04-23','12:10:00',2.07),('8998','2013-04-23','12:15:00',2.78),('8998','2013-04-23','12:20:00',3.37),('8998','2013-04-23','12:25:00',2.82),('8998','2013-04-23','12:30:00',2.74),('8998','2013-04-23','12:35:00',2.77),('8998','2013-04-23','12:40:00',2.55),('8998','2013-04-23','12:45:00',2.73),('8998','2013-04-23','12:50:00',2.91),('8998','2013-04-23','12:55:00',2.76),('8998','2013-04-23','13:00:00',2.6),('8998','2013-04-23','13:05:00',2.27),('8998','2013-04-23','13:10:00',3.04),('8998','2013-04-23','13:15:00',2.61),('8998','2013-04-23','13:20:00',2.6),('8998','2013-04-23','13:25:00',2.56),('8998','2013-04-23','13:30:00',2.41),('8998','2013-04-23','13:35:00',2.29),('8998','2013-04-23','13:40:00',2.86),('8998','2013-04-23','13:45:00',2.3),('8998','2013-04-23','13:50:00',1.67),('8998','2013-04-23','13:55:00',2.57),('8998','2013-04-23','14:00:00',2.56),('8998','2013-04-23','14:05:00',1.82),('8998','2013-04-23','14:10:00',1.75),('8998','2013-04-23','14:15:00',2.6),('8998','2013-04-23','14:20:00',2.24),('8998','2013-04-23','14:25:00',2.38),('8998','2013-04-23','14:30:00',2.25),('8998','2013-04-23','14:35:00',1.92),('8998','2013-04-23','14:40:00',1.78),('8998','2013-04-23','14:45:00',1.75),('8998','2013-04-23','14:50:00',1.52),('8998','2013-04-23','14:55:00',1.39),('8998','2013-04-23','15:00:00',1.55),('8998','2013-04-23','15:05:00',1.44),('8998','2013-04-23','15:10:00',1.37),('8998','2013-04-23','15:15:00',1.45),('8998','2013-04-23','15:20:00',1.5),('8998','2013-04-23','15:25:00',1.32),('8998','2013-04-23','15:30:00',1.16),('8998','2013-04-23','15:35:00',1.11),('8998','2013-04-23','15:40:00',1.09),('8998','2013-04-23','15:45:00',1.09),('8998','2013-04-23','15:50:00',1.1),('8998','2013-04-23','15:55:00',1.24),('8998','2013-04-23','16:00:00',1.44),('8998','2013-04-23','16:05:00',1.48),('8998','2013-04-23','16:10:00',1.45),('8998','2013-04-23','16:15:00',1.39),('8998','2013-04-23','16:20:00',1.74),('8998','2013-04-23','16:25:00',1.32),('8998','2013-04-23','16:30:00',1.13),('8998','2013-04-23','16:40:00',1.16),('8998','2013-04-23','16:45:00',1.2),('8998','2013-04-23','16:50:00',1.08),('8998','2013-04-23','16:55:00',1.16),('8998','2013-04-23','17:00:00',1.12),('8998','2013-04-22','07:50:00',1.07),('8998','2013-04-22','07:55:00',1.14),('8998','2013-04-22','08:00:00',1.21),('8998','2013-04-22','08:05:00',1.33),('8998','2013-04-22','08:10:00',1.39),('8998','2013-04-22','08:15:00',1.52),('8998','2013-04-22','08:20:00',1.55),('8998','2013-04-22','08:25:00',1.75),('8998','2013-04-22','08:30:00',1.58),('8998','2013-04-22','08:35:00',1.51),('8998','2013-04-22','08:40:00',1.55),('8998','2013-04-22','08:45:00',1.86),('8998','2013-04-22','08:50:00',1.91),('8998','2013-04-22','08:55:00',1.75),('8998','2013-04-22','09:00:00',1.71),('8998','2013-04-22','09:05:00',1.67),('8998','2013-04-22','09:10:00',1.8),('8998','2013-04-22','09:15:00',1.85),('8998','2013-04-22','09:20:00',1.87),('8998','2013-04-22','09:25:00',2.36),('8998','2013-04-22','09:30:00',2.44),('8998','2013-04-22','09:35:00',2.59),('8998','2013-04-22','09:40:00',2.5),('8998','2013-04-22','09:45:00',2.36),('8998','2013-04-22','09:50:00',2.84),('8998','2013-04-22','09:55:00',2.87),('8998','2013-04-22','10:00:00',2.86),('8998','2013-04-22','10:05:00',2.89),('8998','2013-04-22','10:10:00',2.9),('8998','2013-04-22','10:15:00',2.92),('8998','2013-04-22','10:20:00',2.95),('8998','2013-04-22','10:25:00',2.97),('8998','2013-04-22','10:30:00',2.98),('8998','2013-04-22','10:35:00',3),('8998','2013-04-22','10:40:00',2.97),('8998','2013-04-22','10:45:00',2.92),('8998','2013-04-22','10:50:00',2.97),('8998','2013-04-22','10:55:00',3.03),('8998','2013-04-22','11:00:00',3.05),('8998','2013-04-22','11:05:00',3.06),('8998','2013-04-22','11:10:00',3.07),('8998','2013-04-22','11:15:00',3.07),('8998','2013-04-22','11:20:00',3.09),('8998','2013-04-22','11:25:00',3.11),('8998','2013-04-22','11:30:00',3.1),('8998','2013-04-22','11:35:00',3.07),('8998','2013-04-22','11:40:00',3.05),('8998','2013-04-22','11:45:00',3.04),('8998','2013-04-22','11:50:00',3.05),('8998','2013-04-22','11:55:00',3.06),('8998','2013-04-22','12:00:00',3.04),('8998','2013-04-22','12:05:00',3.01),('8998','2013-04-22','12:10:00',2.99),('8998','2013-04-22','12:15:00',2.98),('8998','2013-04-22','12:20:00',2.95),('8998','2013-04-22','12:25:00',2.92),('8998','2013-04-22','12:30:00',1.5),('8998','2013-04-22','12:35:00',1.18),('8998','2013-04-22','12:40:00',2.1),('8998','2013-04-22','12:45:00',1.17),('8998','2013-04-22','12:50:00',2.22),('8998','2013-04-22','12:55:00',1.55),('8998','2013-04-22','13:00:00',1.69),('8998','2013-04-22','13:05:00',2.41),('8998','2013-04-22','13:10:00',1.08),('8998','2013-04-22','13:15:00',2.5),('8998','2013-04-22','13:20:00',2.83),('8998','2013-04-22','13:25:00',2.97),('8998','2013-04-22','13:30:00',2.79),('8998','2013-04-22','13:35:00',2.84),('8998','2013-04-22','13:40:00',2.94),('8998','2013-04-22','13:45:00',2.04),('8998','2013-04-22','13:50:00',2.45),('8998','2013-04-22','13:55:00',2.78),('8998','2013-04-22','14:00:00',1.88),('8998','2013-04-22','14:05:00',2.42),('8998','2013-04-22','14:10:00',1.85),('8998','2013-04-22','14:15:00',2.26),('8998','2013-04-22','14:20:00',2.4),('8998','2013-04-22','14:25:00',2.18),('8998','2013-04-22','14:30:00',2.5),('8998','2013-04-22','14:35:00',2.45),('8998','2013-04-22','14:40:00',2.41),('8998','2013-04-22','14:45:00',2.08),('8998','2013-04-22','14:50:00',1.43),('8998','2013-04-22','14:55:00',1.52),('8998','2013-04-22','15:00:00',1.55),('8998','2013-04-22','15:05:00',1.56),('8998','2013-04-22','15:10:00',1.77),('8998','2013-04-22','15:15:00',1.84),('8998','2013-04-22','15:20:00',1.68),('8998','2013-04-22','15:25:00',1.54),('8998','2013-04-22','15:30:00',1.5),('8998','2013-04-22','15:35:00',1.52),('8998','2013-04-22','15:40:00',1.29),('8998','2013-04-22','15:45:00',1.49),('8998','2013-04-22','15:50:00',1.19),('8998','2013-04-22','15:55:00',1.01),('8998','2013-04-22','16:00:00',1),('8998','2013-04-22','16:05:00',1.05),('8998','2013-04-22','16:10:00',1.01),('8998','2013-04-22','16:15:00',1.05),('8998','2013-04-21','10:35:00',1.54),('8998','2013-04-21','10:40:00',2.66),('8998','2013-04-21','10:45:00',3.75),('8998','2013-04-21','10:50:00',1.77),('8998','2013-04-21','10:55:00',1.56),('8998','2013-04-21','11:00:00',1.46),('8998','2013-04-21','11:05:00',1.37),('8998','2013-04-21','11:10:00',1.79),('8998','2013-04-21','11:15:00',1.12),('8998','2013-04-21','11:20:00',1.06),('8998','2013-04-21','11:25:00',1.38),('8998','2013-04-21','11:30:00',2.24),('8998','2013-04-21','11:35:00',2.72),('8998','2013-04-21','11:40:00',3.03),('8998','2013-04-21','11:45:00',1.56),('8998','2013-04-21','11:50:00',1.27),('8998','2013-04-21','11:55:00',2.61),('8998','2013-04-21','12:00:00',2.61),('8998','2013-04-21','12:05:00',2.49),('8998','2013-04-21','12:10:00',2.89),('8998','2013-04-21','12:15:00',2.31),('8998','2013-04-21','12:20:00',2.39),('8998','2013-04-21','12:25:00',2.07),('8998','2013-04-21','12:30:00',1.66),('8998','2013-04-21','12:35:00',1.48),('8998','2013-04-21','12:40:00',3.09),('8998','2013-04-21','12:45:00',2.79),('8998','2013-04-21','12:50:00',3.19),('8998','2013-04-21','12:55:00',3.14),('8998','2013-04-21','13:00:00',3.12),('8998','2013-04-21','13:15:00',2.09),('8998','2013-04-21','13:20:00',2.74),('8998','2013-04-21','13:25:00',1.51),('8998','2013-04-21','13:30:00',2.63),('8998','2013-04-21','13:35:00',1.37),('8998','2013-04-21','13:40:00',1.4),('8998','2013-04-21','13:45:00',2.96),('8998','2013-04-21','14:10:00',1.44),('8998','2013-04-21','14:20:00',1.45),('8998','2013-04-21','14:25:00',1.74),('8998','2013-04-21','14:30:00',2.79),('8998','2013-04-21','14:35:00',1.85),('8998','2013-04-21','14:40:00',1.78),('8998','2013-04-21','14:45:00',2.55),('8998','2013-04-21','14:50:00',2.59),('8998','2013-04-21','14:55:00',2.58),('8998','2013-04-21','15:00:00',1.6),('8998','2013-04-21','15:05:00',1.5),('8998','2013-04-21','15:10:00',1.38),('8998','2013-04-21','15:25:00',1.13),('8998','2013-04-21','15:30:00',1.1),('8998','2013-04-21','15:45:00',1.67),('8998','2013-04-21','15:50:00',1.53),('8998','2014-03-28','07:30:00',1.27),('8998','2014-03-28','07:35:00',1.43),('8998','2014-03-28','07:40:00',1.46),('8998','2014-03-28','07:45:00',1.33),('8998','2014-03-28','07:50:00',1.43),('8998','2014-03-28','07:55:00',1.7),('8998','2014-03-28','08:00:00',1.82),('8998','2014-03-28','08:05:00',1.87),('8998','2014-03-28','08:10:00',1.96),('8998','2014-03-28','08:15:00',2.05),('8998','2014-03-28','08:20:00',2.11),('8998','2014-03-28','08:25:00',2.16),('8998','2014-03-28','08:30:00',2.2),('8998','2014-03-28','08:35:00',2.25),('8998','2014-03-28','08:40:00',2.27),('8998','2014-03-28','08:45:00',2.31),('8998','2014-03-28','08:50:00',2.36),('8998','2014-03-28','08:55:00',2.36),('8998','2014-03-28','09:00:00',2.38),('8998','2014-03-28','09:05:00',2.4),('8998','2014-03-28','09:10:00',2.43),('8998','2014-03-28','09:15:00',2.48),('8998','2014-03-28','09:20:00',2.54),('8998','2014-03-28','09:25:00',2.57),('8998','2014-03-28','09:30:00',2.59),('8998','2014-03-28','09:35:00',2.63),('8998','2014-03-28','09:40:00',2.65),('8998','2014-03-28','09:45:00',2.67),('8998','2014-03-28','09:50:00',2.7),('8998','2014-03-28','09:55:00',2.76),('8998','2014-03-28','10:00:00',2.76),('8998','2014-03-28','10:05:00',2.79),('8998','2014-03-28','10:10:00',2.82),('8998','2014-03-28','10:15:00',2.84),('8998','2014-03-28','10:20:00',2.85),('8998','2014-03-28','10:25:00',2.88),('8998','2014-03-28','10:30:00',2.86),('8998','2014-03-28','10:35:00',2.87),('8998','2014-03-28','10:40:00',2.88),('8998','2014-03-28','10:45:00',2.88),('8998','2014-03-28','10:50:00',2.88),('8998','2014-03-28','10:55:00',2.87),('8998','2014-03-28','11:00:00',2.86),('8998','2014-03-28','11:05:00',2.83),('8998','2014-03-28','11:10:00',2.83),('8998','2014-03-28','11:15:00',2.82),('8998','2014-03-28','11:20:00',2.81),('8998','2014-03-28','11:25:00',2.81),('8998','2014-03-28','11:30:00',2.79),('8998','2014-03-28','11:35:00',2.75),('8998','2014-03-28','11:40:00',2.7),('8998','2014-03-28','11:45:00',2.76),('8998','2014-03-28','11:50:00',2.74),('8998','2014-03-28','11:55:00',2.71),('8998','2014-03-28','12:00:00',2.69),('8998','2014-03-28','12:05:00',2.65),('8998','2014-03-28','12:10:00',2.63),('8998','2014-03-28','12:15:00',2.65),('8998','2014-03-28','12:20:00',2.65),('8998','2014-03-28','12:25:00',2.62),('8998','2014-03-28','12:30:00',2.6),('8998','2014-03-28','12:35:00',2.58),('8998','2014-03-28','12:40:00',2.53),('8998','2014-03-28','12:45:00',2.51),('8998','2014-03-28','12:50:00',2.48),('8998','2014-03-28','12:55:00',2.43),('8998','2014-03-28','13:00:00',2.39),('8998','2014-03-28','13:05:00',2.38),('8998','2014-03-28','13:10:00',2.33),('8998','2014-03-28','13:15:00',2.3),('8998','2014-03-28','13:20:00',2.25),('8998','2014-03-28','13:25:00',2.2),('8998','2014-03-28','13:30:00',2.14),('8998','2014-03-28','13:35:00',2.1),('8998','2014-03-28','13:40:00',2.04),('8998','2014-03-28','13:45:00',1.99),('8998','2014-03-28','13:50:00',1.94),('8998','2014-03-28','13:55:00',1.89),('8998','2014-03-28','14:00:00',1.85),('8998','2014-03-28','14:05:00',1.82),('8998','2014-03-28','14:10:00',1.77),('8998','2014-03-28','14:15:00',1.71),('8998','2014-03-28','14:20:00',1.65),('8998','2014-03-28','14:25:00',1.6),('8998','2014-03-28','14:30:00',1.54),('8998','2014-03-28','14:35:00',1.35),('8998','2014-03-28','14:40:00',1.29),('8998','2014-03-28','14:45:00',1.35),('8998','2014-03-28','14:50:00',1.34),('8998','2014-03-28','14:55:00',1.32),('8998','2014-03-28','15:00:00',1.25),('8998','2014-03-28','15:05:00',1.16),('8998','2014-03-28','15:10:00',1.07),('8998','2014-03-28','15:15:00',1.02),('8998','2013-04-20','08:40:00',1.13),('8998','2013-04-20','08:45:00',1.25),('8998','2013-04-20','08:50:00',2.32),('8998','2013-04-20','08:55:00',2.25),('8998','2013-04-20','09:00:00',1.45),('8998','2013-04-20','09:05:00',1.56),('8998','2013-04-20','09:10:00',1.82),('8998','2013-04-20','09:15:00',2.05),('8998','2013-04-20','09:20:00',1.57),('8998','2013-04-20','09:25:00',1.81),('8998','2013-04-20','09:30:00',2.63),('8998','2013-04-20','09:35:00',2.61),('8998','2013-04-20','09:40:00',2.63),('8998','2013-04-20','09:45:00',2.75),('8998','2013-04-20','09:50:00',3.1),('8998','2013-04-20','09:55:00',2.85),('8998','2013-04-20','10:00:00',2.43),('8998','2013-04-20','10:05:00',1.83),('8998','2013-04-20','10:10:00',1.55),('8998','2013-04-20','10:15:00',1.44),('8998','2013-04-20','10:20:00',2.25),('8998','2013-04-20','10:25:00',2.78),('8998','2013-04-20','10:30:00',2.37),('8998','2013-04-20','10:35:00',1.57),('8998','2013-04-20','10:40:00',2.04),('8998','2013-04-20','10:45:00',1.74),('8998','2013-04-20','10:50:00',3.06),('8998','2013-04-20','10:55:00',2.65),('8998','2013-04-20','11:00:00',3.06),('8998','2013-04-20','11:05:00',2.59),('8998','2013-04-20','11:10:00',2.98),('8998','2013-04-20','11:15:00',2.41),('8998','2013-04-20','11:20:00',2.21),('8998','2013-04-20','11:25:00',2.39),('8998','2013-04-20','11:30:00',2.1),('8998','2013-04-20','11:35:00',1.86),('8998','2013-04-20','11:40:00',2.33),('8998','2013-04-20','11:45:00',2.51),('8998','2013-04-20','11:50:00',2.18),('8998','2013-04-20','11:55:00',2.07),('8998','2013-04-20','12:00:00',1.71),('8998','2013-04-20','12:05:00',1.68),('8998','2013-04-20','12:10:00',1.69),('8998','2013-04-20','12:15:00',1.56),('8998','2013-04-20','12:20:00',1.44),('8998','2013-04-20','12:25:00',1.33),('8998','2013-04-20','12:30:00',1.46),('8998','2013-04-20','12:35:00',1.51),('8998','2013-04-20','12:40:00',1.51),('8998','2013-04-20','12:45:00',1.53),('8998','2013-04-20','12:50:00',1.41),('8998','2013-04-20','12:55:00',1.36),('8998','2013-04-20','13:00:00',1.51),('8998','2013-04-20','13:05:00',1.78),('8998','2013-04-20','13:10:00',1.83),('8998','2013-04-20','13:15:00',1.71),('8998','2013-04-20','13:20:00',1.63),('8998','2013-04-20','13:25:00',1.51),('8998','2013-04-20','13:30:00',2.2),('8998','2013-04-20','13:35:00',2.58),('8998','2013-04-20','13:40:00',1.82),('8998','2013-04-20','13:45:00',1.87),('8998','2013-04-20','13:50:00',1.71),('8998','2013-04-20','13:55:00',2.39),('8998','2013-04-20','14:00:00',2.82),('8998','2013-04-20','14:05:00',2.28),('8998','2013-04-20','14:10:00',2.33),('8998','2013-04-20','14:15:00',2.03),('8998','2013-04-20','14:20:00',2.72),('8998','2013-04-20','14:25:00',2.19),('8998','2013-04-20','14:30:00',2.27),('8998','2013-04-20','14:35:00',2.34),('8998','2013-04-20','14:40:00',2.53),('8998','2013-04-20','14:45:00',2.18),('8998','2013-04-20','14:50:00',1.24),('8998','2013-04-20','14:55:00',1.23),('8998','2013-04-20','15:00:00',1.57),('8998','2013-04-20','15:05:00',2.13),('8998','2013-04-20','15:10:00',2.2),('8998','2013-04-20','15:15:00',1.66),('8998','2013-04-20','15:20:00',1.2),('8998','2013-04-20','15:25:00',1.23),('8998','2013-04-20','15:30:00',1.15),('8998','2013-04-20','15:40:00',1.01),('8998','2013-04-19','08:00:00',1.02),('8998','2013-04-19','08:05:00',1.12),('8998','2013-04-19','08:10:00',1.24),('8998','2013-04-19','08:15:00',1.16),('8998','2013-04-19','08:20:00',1.05),('8998','2013-04-19','08:25:00',1.19),('8998','2013-04-19','08:30:00',1.32),('8998','2013-04-19','08:35:00',1.43),('8998','2013-04-19','08:40:00',1.5),('8998','2013-04-19','08:45:00',1.52),('8998','2013-04-19','08:50:00',1.55),('8998','2013-04-19','08:55:00',1.54),('8998','2013-04-19','09:00:00',1.69),('8998','2013-04-19','09:05:00',1.78),('8998','2013-04-19','09:10:00',1.71),('8998','2013-04-19','09:15:00',1.57),('8998','2013-04-19','09:20:00',1.98),('8998','2013-04-19','09:25:00',2.03),('8998','2013-04-19','09:30:00',1.85),('8998','2013-04-19','09:35:00',1.51),('8998','2013-04-19','09:45:00',1.07),('8998','2013-04-19','09:50:00',1.04),('8998','2013-04-19','10:45:00',1.2),('8998','2013-04-19','10:50:00',1.73),('8998','2013-04-19','10:55:00',1.58),('8998','2013-04-19','11:00:00',2.24),('8998','2013-04-19','11:05:00',2.09),('8998','2013-04-19','11:10:00',1.15),('8998','2013-04-19','11:15:00',3.21),('8998','2013-04-19','11:20:00',2.68),('8998','2013-04-19','11:25:00',1.36),('8998','2013-04-19','11:30:00',3.38),('8998','2013-04-19','11:35:00',2.77),('8998','2013-04-19','11:40:00',1.33),('8998','2013-04-19','11:45:00',1.92),('8998','2013-04-19','11:50:00',2.08),('8998','2013-04-19','11:55:00',2.93),('8998','2013-04-19','12:00:00',3.27),('8998','2013-04-19','12:05:00',1.84),('8998','2013-04-19','12:10:00',3.16),('8998','2013-04-19','12:15:00',2.92),('8998','2013-04-19','12:20:00',2.12),('8998','2013-04-19','12:25:00',2.5),('8998','2013-04-19','12:30:00',1.59),('8998','2013-04-19','12:35:00',2.89),('8998','2013-04-19','12:40:00',1.26),('8998','2013-04-19','12:45:00',3.01),('8998','2013-04-19','12:50:00',3.16),('8998','2013-04-19','12:55:00',3.11),('8998','2013-04-19','13:00:00',1.25),('8998','2013-04-19','13:05:00',1.86),('8998','2013-04-19','13:10:00',3.12),('8998','2013-04-19','13:15:00',2.85),('8998','2013-04-19','13:20:00',1.21),('8998','2013-04-19','13:25:00',2.38),('8998','2013-04-19','13:30:00',2.01),('8998','2013-04-19','13:35:00',1.11),('8998','2013-04-19','13:40:00',2.75),('8998','2013-04-19','13:45:00',1.4),('8998','2013-04-19','13:50:00',1.37),('8998','2013-04-19','13:55:00',1.89),('8998','2013-04-19','14:00:00',1.66),('8998','2013-04-19','14:05:00',2.52),('8998','2013-04-19','14:10:00',2.78),('8998','2013-04-19','14:15:00',2.41),('8998','2013-04-19','14:20:00',2.35),('8998','2013-04-19','14:25:00',2.36),('8998','2013-04-19','14:30:00',2.28),('8998','2013-04-19','14:35:00',2.2),('8998','2013-04-19','14:40:00',2.16),('8998','2013-04-19','14:45:00',2.13),('8998','2013-04-19','14:50:00',2.14),('8998','2013-04-19','14:55:00',2.11),('8998','2013-04-19','15:00:00',2.07),('8998','2013-04-19','15:05:00',2),('8998','2013-04-19','15:10:00',1.42),('8998','2013-04-19','15:15:00',1.38),('8998','2013-04-19','15:20:00',1.2),('8998','2013-04-19','15:25:00',1.64),('8998','2013-04-19','15:30:00',1.13),('8998','2013-04-19','16:15:00',1.11),('8998','2013-04-19','16:20:00',1.17),('8998','2013-04-19','16:25:00',1.25),('8998','2013-04-19','16:30:00',1.44),('8998','2013-04-19','16:35:00',1.4),('8998','2013-04-19','16:40:00',1.23),('8998','2013-04-19','16:45:00',1.16),('8998','2013-04-19','16:50:00',1.09),('8998','2013-04-18','08:05:00',1.18),('8998','2013-04-18','08:15:00',1.02),('8998','2013-04-18','08:20:00',1.28),('8998','2013-04-18','08:25:00',1.41),('8998','2013-04-18','08:30:00',1.33),('8998','2013-04-18','08:35:00',1.38),('8998','2013-04-18','08:40:00',1.49),('8998','2013-04-18','08:45:00',1.5),('8998','2013-04-18','08:50:00',1.56),('8998','2013-04-18','08:55:00',1.59),('8998','2013-04-18','09:00:00',1.62),('8998','2013-04-18','09:05:00',1.67),('8998','2013-04-18','09:10:00',1.62),('8998','2013-04-18','09:15:00',1.65),('8998','2013-04-18','09:20:00',1.79),('8998','2013-04-18','09:25:00',2.13),('8998','2013-04-18','09:30:00',2.29),('8998','2013-04-18','09:35:00',2.35),('8998','2013-04-18','09:40:00',2.38),('8998','2013-04-18','09:45:00',2.45),('8998','2013-04-18','09:50:00',2.43),('8998','2013-04-18','09:55:00',2.46),('8998','2013-04-18','10:00:00',2.52),('8998','2013-04-18','10:05:00',2.54),('8998','2013-04-18','10:10:00',2.56),('8998','2013-04-18','10:15:00',2.64),('8998','2013-04-18','10:20:00',1.97),('8998','2013-04-18','10:25:00',2.64),('8998','2013-04-18','10:30:00',2.33),('8998','2013-04-18','10:35:00',2.41),('8998','2013-04-18','10:40:00',2.7),('8998','2013-04-18','10:45:00',2.67),('8998','2013-04-18','10:50:00',2.72),('8998','2013-04-18','10:55:00',2.69),('8998','2013-04-18','11:00:00',2.69),('8998','2013-04-18','11:05:00',2.7),('8998','2013-04-18','11:10:00',2.71),('8998','2013-04-18','11:15:00',2.72),('8998','2013-04-18','11:20:00',2.7),('8998','2013-04-18','11:25:00',2.72),('8998','2013-04-18','11:30:00',2.73),('8998','2013-04-18','11:35:00',2.76),('8998','2013-04-18','11:40:00',2.77),('8998','2013-04-18','11:45:00',2.78),('8998','2013-04-18','11:50:00',2.79),('8998','2013-04-18','11:55:00',2.78),('8998','2013-04-18','12:00:00',2.77),('8998','2013-04-18','12:05:00',2.76),('8998','2013-04-18','12:10:00',2.76),('8998','2013-04-18','12:15:00',2.78),('8998','2013-04-18','12:20:00',2.76),('8998','2013-04-18','12:25:00',2.75),('8998','2013-04-18','12:30:00',2.69),('8998','2013-04-18','12:35:00',2.66),('8998','2013-04-18','12:40:00',2.68),('8998','2013-04-18','12:45:00',2.69),('8998','2013-04-18','12:50:00',2.68),('8998','2013-04-18','12:55:00',2.62),('8998','2013-04-18','13:00:00',2.64),('8998','2013-04-18','13:05:00',2.6),('8998','2013-04-18','13:10:00',2.6),('8998','2013-04-18','13:15:00',2.61),('8998','2013-04-18','13:20:00',2.56),('8998','2013-04-18','13:25:00',2.55),('8998','2013-04-18','13:30:00',2.58),('8998','2013-04-18','13:35:00',2.49),('8998','2013-04-18','13:40:00',2.48),('8998','2013-04-18','13:45:00',2.45),('8998','2013-04-18','13:50:00',2.41),('8998','2013-04-18','13:55:00',2.34),('8998','2013-04-18','14:00:00',2.33),('8998','2013-04-18','14:05:00',2.28),('8998','2013-04-18','14:10:00',2.29),('8998','2013-04-18','14:15:00',2.23),('8998','2013-04-18','14:20:00',2.18),('8998','2013-04-18','14:25:00',2.13),('8998','2013-04-18','14:30:00',2.14),('8998','2013-04-18','14:35:00',2.08),('8998','2013-04-18','14:40:00',2.04),('8998','2013-04-18','14:45:00',2.01),('8998','2013-04-18','14:50:00',2),('8998','2013-04-18','14:55:00',1.97),('8998','2013-04-18','15:00:00',1.91),('8998','2013-04-18','15:05:00',1.87),('8998','2013-04-18','15:10:00',1.81),('8998','2013-04-18','15:15:00',1.76),('8998','2013-04-18','15:20:00',1.69),('8998','2013-04-18','15:25:00',1.65),('8998','2013-04-18','15:30:00',1.59),('8998','2013-04-18','15:35:00',1.54),('8998','2013-04-18','15:40:00',1.5),('8998','2013-04-18','15:45:00',1.45),('8998','2013-04-18','15:50:00',1.4),('8998','2013-04-18','15:55:00',1.35),('8998','2013-04-18','16:00:00',1.3),('8998','2013-04-18','16:05:00',1.25),('8998','2013-04-18','16:10:00',1.19),('8998','2013-04-18','16:15:00',1.13),('8998','2013-04-18','16:20:00',1.08),('8998','2013-04-18','16:25:00',1.04),('8998','2013-04-17','08:10:00',1.02),('8998','2013-04-17','08:15:00',1.1),('8998','2013-04-17','08:20:00',1.13),('8998','2013-04-17','08:25:00',1.11),('8998','2013-04-17','08:30:00',1.29),('8998','2013-04-17','08:35:00',1.32),('8998','2013-04-17','08:40:00',1.26),('8998','2013-04-17','08:45:00',1.28),('8998','2013-04-17','08:50:00',1.4),('8998','2013-04-17','08:55:00',1.55),('8998','2013-04-17','09:00:00',1.49),('8998','2013-04-17','09:05:00',1.7),('8998','2013-04-17','09:10:00',1.63),('8998','2013-04-17','09:15:00',1.66),('8998','2013-04-17','09:20:00',1.82),('8998','2013-04-17','09:25:00',2.04),('8998','2013-04-17','09:30:00',2.13),('8998','2013-04-17','09:35:00',2.26),('8998','2013-04-17','09:40:00',2.62),('8998','2013-04-17','09:45:00',2.31),('8998','2013-04-17','09:50:00',2),('8998','2013-04-17','09:55:00',2.05),('8998','2013-04-17','10:00:00',2.47),('8998','2013-04-17','10:05:00',2.65),('8998','2013-04-17','10:10:00',2.67),('8998','2013-04-17','10:15:00',2.75),('8998','2013-04-17','10:20:00',2.77),('8998','2013-04-17','10:25:00',2.74),('8998','2013-04-17','10:30:00',2.79),('8998','2013-04-17','10:35:00',2.79),('8998','2013-04-17','10:40:00',2.81),('8998','2013-04-17','10:45:00',2.81),('8998','2013-04-17','10:50:00',2.82),('8998','2013-04-17','10:55:00',2.83),('8998','2013-04-17','11:00:00',2.84),('8998','2013-04-17','11:05:00',2.86),('8998','2013-04-17','11:10:00',2.86),('8998','2013-04-17','11:15:00',2.87),('8998','2013-04-17','11:20:00',2.89),('8998','2013-04-17','11:25:00',2.89),('8998','2013-04-17','11:30:00',2.88),('8998','2013-04-17','11:35:00',2.88),('8998','2013-04-17','11:40:00',2.86),('8998','2013-04-17','11:45:00',2.82),('8998','2013-04-17','11:50:00',2.81),('8998','2013-04-17','11:55:00',2.86),('8998','2013-04-17','12:00:00',2.82),('8998','2013-04-17','12:05:00',2.89),('8998','2013-04-17','12:10:00',2.89),('8998','2013-04-17','12:15:00',2.85),('8998','2013-04-17','12:20:00',2.85),('8998','2013-04-17','12:25:00',2.85),('8998','2013-04-17','12:30:00',2.83),('8998','2013-04-17','12:35:00',2.82),('8998','2013-04-17','12:40:00',2.83),('8998','2013-04-17','12:45:00',2.81),('8998','2013-04-17','12:50:00',2.79),('8998','2013-04-17','12:55:00',2.79),('8998','2013-04-17','13:00:00',2.77),('8998','2013-04-17','13:05:00',2.74),('8998','2013-04-17','13:10:00',2.72),('8998','2013-04-17','13:15:00',2.71),('8998','2013-04-17','13:20:00',2.67),('8998','2013-04-17','13:25:00',2.65),('8998','2013-04-17','13:30:00',2.64),('8998','2013-04-17','13:35:00',2.61),('8998','2013-04-17','13:40:00',2.57),('8998','2013-04-17','13:45:00',2.53),('8998','2013-04-17','13:50:00',2.53),('8998','2013-04-17','13:55:00',2.5),('8998','2013-04-17','14:00:00',2.45),('8998','2013-04-17','14:05:00',2.42),('8998','2013-04-17','14:10:00',2.39),('8998','2013-04-17','14:15:00',2.35),('8998','2013-04-17','14:20:00',2.32),('8998','2013-04-17','14:25:00',2.29),('8998','2013-04-17','14:30:00',2.24),('8998','2013-04-17','14:35:00',2.2),('8998','2013-04-17','14:40:00',2.16),('8998','2013-04-17','14:45:00',2.11),('8998','2013-04-17','14:50:00',2.06),('8998','2013-04-17','14:55:00',2.01),('8998','2013-04-17','15:00:00',1.95),('8998','2013-04-17','15:05:00',1.92),('8998','2013-04-17','15:10:00',1.87),('8998','2013-04-17','15:15:00',1.82),('8998','2013-04-17','15:20:00',1.77),('8998','2013-04-17','15:25:00',1.71),('8998','2013-04-17','15:30:00',1.66),('8998','2013-04-17','15:35:00',1.62),('8998','2013-04-17','15:40:00',1.56),('8998','2013-04-17','15:45:00',1.5),('8998','2013-04-17','15:50:00',1.45),('8998','2013-04-17','15:55:00',1.39),('8998','2013-04-17','16:00:00',1.34),('8998','2013-04-17','16:05:00',1.27),('8998','2013-04-17','16:10:00',1.23),('8998','2013-04-17','16:15:00',1.18),('8998','2013-04-17','16:20:00',1.11),('8998','2013-04-17','16:25:00',1.05),('8998','2013-04-16','07:55:00',1.01),('8998','2013-04-16','08:00:00',1.07),('8998','2013-04-16','08:05:00',1.16),('8998','2013-04-16','08:10:00',1.15),('8998','2013-04-16','08:15:00',1.39),('8998','2013-04-16','08:20:00',1.36),('8998','2013-04-16','08:25:00',1.43),('8998','2013-04-16','08:30:00',1.35),('8998','2013-04-16','08:35:00',1.38),('8998','2013-04-16','08:40:00',1.48),('8998','2013-04-16','08:45:00',1.52),('8998','2013-04-16','08:50:00',2.02),('8998','2013-04-16','08:55:00',2.07),('8998','2013-04-16','09:00:00',2.12),('8998','2013-04-16','09:05:00',2.16),('8998','2013-04-16','09:10:00',2.21),('8998','2013-04-16','09:15:00',2.29),('8998','2013-04-16','09:20:00',2.34),('8998','2013-04-16','09:25:00',2.38),('8998','2013-04-16','09:30:00',2.42),('8998','2013-04-16','09:35:00',2.46),('8998','2013-04-16','09:40:00',2.53),('8998','2013-04-16','09:45:00',2.56),('8998','2013-04-16','09:50:00',2.59),('8998','2013-04-16','09:55:00',2.61),('8998','2013-04-16','10:00:00',2.65),('8998','2013-04-16','10:05:00',2.68),('8998','2013-04-16','10:10:00',2.71),('8998','2013-04-16','10:15:00',2.73),('8998','2013-04-16','10:20:00',2.75),('8998','2013-04-16','10:25:00',2.78),('8998','2013-04-16','10:30:00',2.79),('8998','2013-04-16','10:35:00',2.81),('8998','2013-04-16','10:40:00',2.83),('8998','2013-04-16','10:45:00',2.84),('8998','2013-04-16','10:50:00',2.86),('8998','2013-04-16','10:55:00',2.87),('8998','2013-04-16','11:00:00',2.89),('8998','2013-04-16','11:05:00',2.91),('8998','2013-04-16','11:10:00',2.9),('8998','2013-04-16','11:15:00',2.9),('8998','2013-04-16','11:20:00',2.91),('8998','2013-04-16','11:25:00',2.91),('8998','2013-04-16','11:30:00',2.89),('8998','2013-04-16','11:35:00',2.89),('8998','2013-04-16','11:40:00',2.9),('8998','2013-04-16','11:45:00',2.9),('8998','2013-04-16','11:50:00',2.92),('8998','2013-04-16','11:55:00',2.9),('8998','2013-04-16','12:00:00',2.89),('8998','2013-04-16','12:05:00',2.91),('8998','2013-04-16','12:10:00',2.89),('8998','2013-04-16','12:15:00',2.88),('8998','2013-04-16','12:20:00',2.86),('8998','2013-04-16','12:25:00',2.87),('8998','2013-04-16','12:30:00',2.87),('8998','2013-04-16','12:35:00',2.84),('8998','2013-04-16','12:40:00',2.82),('8998','2013-04-16','12:45:00',2.82),('8998','2013-04-16','12:50:00',2.8),('8998','2013-04-16','12:55:00',2.79),('8998','2013-04-16','13:00:00',2.75),('8998','2013-04-16','13:05:00',2.71),('8998','2013-04-16','13:10:00',2.69),('8998','2013-04-16','13:15:00',2.69),('8998','2013-04-16','13:20:00',2.69),('8998','2013-04-16','13:25:00',2.68),('8998','2013-04-16','13:30:00',2.64),('8998','2013-04-16','13:35:00',2.57),('8998','2013-04-16','13:40:00',2.6),('8998','2013-04-16','13:45:00',2.39),('8998','2013-04-16','13:50:00',2.39),('8998','2013-04-16','13:55:00',2.58),('8998','2013-04-16','14:00:00',2.44),('8998','2013-04-16','14:05:00',2.62),('8998','2013-04-16','14:10:00',2.55),('8998','2013-04-16','14:15:00',2.24),('8998','2013-04-16','14:20:00',2.21),('8998','2013-04-16','14:25:00',2.22),('8998','2013-04-16','14:30:00',2.08),('8998','2013-04-16','14:35:00',2.41),('8998','2013-04-16','14:40:00',2.32),('8998','2013-04-16','14:45:00',1.91),('8998','2013-04-16','14:50:00',2.19),('8998','2013-04-16','14:55:00',2.21),('8998','2013-04-16','15:00:00',2.16),('8998','2013-04-16','15:05:00',2.22),('8998','2013-04-16','15:10:00',2.27),('8998','2013-04-16','15:15:00',1.99),('8998','2013-04-16','15:25:00',1.06),('8998','2013-04-16','15:30:00',1.65),('8998','2013-04-16','15:35:00',1.74),('8998','2013-04-16','15:40:00',1.73),('8998','2013-04-16','15:45:00',1.75),('8998','2013-04-16','15:50:00',1.74),('8998','2013-04-16','15:55:00',1.75),('8998','2013-04-16','16:00:00',1.65),('8998','2013-04-16','16:05:00',1.2),('8998','2013-04-16','16:10:00',1.43),('8998','2013-04-16','16:15:00',1.33),('8998','2013-04-16','16:20:00',1.23),('8998','2013-04-16','16:25:00',1.16),('8998','2013-04-16','16:30:00',1.11),('8998','2013-04-16','16:35:00',1.09),('8998','2013-04-15','08:05:00',1.06),('8998','2013-04-15','08:10:00',1.05),('8998','2013-04-15','09:10:00',1.3),('8998','2013-04-15','09:15:00',1.6),('8998','2013-04-15','09:20:00',1.18),('8998','2013-04-15','09:25:00',1.5),('8998','2013-04-15','09:30:00',1.36),('8998','2013-04-15','09:35:00',1.16),('8998','2013-04-15','09:40:00',1.08),('8998','2013-04-15','09:45:00',1.07),('8998','2013-04-15','09:50:00',1.02),('8998','2013-04-15','10:15:00',1.06),('8998','2013-04-15','10:20:00',1.09),('8998','2013-04-15','10:25:00',1.12),('8998','2013-04-15','10:30:00',1.13),('8998','2013-04-15','10:35:00',1.14),('8998','2013-04-15','10:40:00',1.09),('8998','2013-04-15','10:45:00',1.04),('8998','2013-04-15','10:50:00',1.06),('8998','2013-04-15','10:55:00',1.14),('8998','2013-04-15','11:00:00',1.25),('8998','2013-04-15','11:05:00',1.28),('8998','2013-04-15','11:10:00',1.29),('8998','2013-04-15','11:15:00',1.33),('8998','2013-04-15','11:20:00',1.37),('8998','2013-04-15','11:25:00',1.36),('8998','2013-04-15','11:30:00',1.33),('8998','2013-04-15','11:35:00',1.33),('8998','2013-04-15','11:40:00',1.48),('8998','2013-04-15','11:45:00',1.72),('8998','2013-04-15','11:50:00',1.83),('8998','2013-04-15','11:55:00',1.89),('8998','2013-04-15','12:00:00',2.13),('8998','2013-04-15','12:05:00',2.76),('8998','2013-04-15','12:10:00',2.9),('8998','2013-04-15','12:15:00',3.39),('8998','2013-04-15','12:20:00',2.49),('8998','2013-04-15','12:25:00',2.14),('8998','2013-04-15','12:30:00',2.5),('8998','2013-04-15','12:35:00',2.79),('8998','2013-04-15','12:40:00',2.9),('8998','2013-04-15','12:45:00',2.38),('8998','2013-04-15','12:50:00',2.04),('8998','2013-04-15','12:55:00',2.71),('8998','2013-04-15','13:00:00',2.78),('8998','2013-04-15','13:05:00',2.61),('8998','2013-04-15','13:10:00',2.62),('8998','2013-04-15','13:15:00',2.62),('8998','2013-04-15','13:20:00',2.63),('8998','2013-04-15','13:25:00',2.62),('8998','2013-04-15','13:30:00',2.6),('8998','2013-04-15','13:35:00',2.58),('8998','2013-04-15','13:40:00',2.53),('8998','2013-04-15','13:45:00',2.47),('8998','2013-04-15','13:50:00',2.44),('8998','2013-04-15','13:55:00',2.33),('8998','2013-04-15','14:00:00',2.33),('8998','2013-04-15','14:05:00',2.36),('8998','2013-04-15','14:10:00',2.34),('8998','2013-04-15','14:15:00',2.23),('8998','2013-04-15','14:20:00',2.24),('8998','2013-04-15','14:25:00',1.74),('8998','2013-04-15','14:30:00',1.82),('8998','2013-04-15','14:35:00',1.81),('8998','2013-04-15','14:40:00',2.03),('8998','2013-04-15','14:45:00',2.09),('8998','2013-04-15','14:50:00',1.98),('8998','2013-04-15','14:55:00',1.9),('8998','2013-04-15','15:00:00',1.94),('8998','2013-04-15','15:05:00',1.89),('8998','2013-04-15','15:10:00',1.85),('8998','2013-04-15','15:15:00',1.82),('8998','2013-04-15','15:20:00',1.77),('8998','2013-04-15','15:25:00',1.67),('8998','2013-04-15','15:30:00',1.58),('8998','2013-04-15','15:35:00',1.57),('8998','2013-04-15','15:40:00',1.53),('8998','2013-04-15','15:45:00',1.48),('8998','2013-04-15','15:50:00',1.45),('8998','2013-04-15','15:55:00',1.39),('8998','2013-04-15','16:00:00',1.28),('8998','2013-04-15','16:05:00',1.28),('8998','2013-04-15','16:10:00',1.23),('8998','2013-04-15','16:15:00',1.16),('8998','2013-04-15','16:20:00',1.14),('8998','2013-04-15','16:25:00',1.1),('8998','2013-04-15','16:30:00',1.07),('8998','2013-04-15','16:35:00',1.07),('8998','2013-04-15','16:40:00',1.17),('8998','2013-04-15','16:45:00',1.16),('8998','2013-04-14','08:00:00',1.14),('8998','2013-04-14','08:05:00',1.13),('8998','2013-04-14','08:10:00',1.15),('8998','2013-04-14','08:15:00',1.22),('8998','2013-04-14','08:20:00',1.26),('8998','2013-04-14','08:25:00',1.45),('8998','2013-04-14','08:30:00',1.35),('8998','2013-04-14','08:35:00',1.63),('8998','2013-04-14','08:40:00',1.5),('8998','2013-04-14','08:45:00',1.52),('8998','2013-04-14','08:50:00',2.05),('8998','2013-04-14','08:55:00',2.11),('8998','2013-04-14','09:00:00',2.15),('8998','2013-04-14','09:05:00',2.2),('8998','2013-04-14','09:10:00',2.29),('8998','2013-04-14','09:15:00',2.33),('8998','2013-04-14','09:20:00',2.37),('8998','2013-04-14','09:25:00',2.4),('8998','2013-04-14','09:30:00',2.43),('8998','2013-04-14','09:35:00',2.46),('8998','2013-04-14','09:40:00',2.54),('8998','2013-04-14','09:45:00',2.57),('8998','2013-04-14','09:50:00',2.59),('8998','2013-04-14','09:55:00',2.62),('8998','2013-04-14','10:00:00',2.65),('8998','2013-04-14','10:05:00',2.67),('8998','2013-04-14','10:10:00',2.7),('8998','2013-04-14','10:15:00',2.73),('8998','2013-04-14','10:20:00',2.74),('8998','2013-04-14','10:25:00',2.75),('8998','2013-04-14','10:30:00',2.78),('8998','2013-04-14','10:35:00',2.8),('8998','2013-04-14','10:40:00',2.81),('8998','2013-04-14','10:45:00',2.83),('8998','2013-04-14','10:50:00',2.84),('8998','2013-04-14','10:55:00',2.86),('8998','2013-04-14','11:00:00',2.87),('8998','2013-04-14','11:05:00',2.89),('8998','2013-04-14','11:10:00',2.89),('8998','2013-04-14','11:15:00',2.91),('8998','2013-04-14','11:20:00',2.89),('8998','2013-04-14','11:25:00',2.89),('8998','2013-04-14','11:30:00',2.9),('8998','2013-04-14','11:35:00',2.9),('8998','2013-04-14','11:40:00',2.89),('8998','2013-04-14','11:45:00',2.9),('8998','2013-04-14','11:50:00',2.9),('8998','2013-04-14','11:55:00',2.89),('8998','2013-04-14','12:00:00',2.89),('8998','2013-04-14','12:05:00',2.86),('8998','2013-04-14','12:10:00',2.86),('8998','2013-04-14','12:15:00',2.88),('8998','2013-04-14','12:20:00',2.85),('8998','2013-04-14','12:25:00',2.82),('8998','2013-04-14','12:30:00',2.82),('8998','2013-04-14','12:35:00',2.81),('8998','2013-04-14','12:40:00',2.8),('8998','2013-04-14','12:45:00',2.77),('8998','2013-04-14','12:50:00',2.76),('8998','2013-04-14','12:55:00',2.74),('8998','2013-04-14','13:00:00',2.72),('8998','2013-04-14','13:05:00',2.7),('8998','2013-04-14','13:10:00',2.72),('8998','2013-04-14','13:15:00',2.71),('8998','2013-04-14','13:20:00',2.66),('8998','2013-04-14','13:25:00',2.62),('8998','2013-04-14','13:30:00',2.59),('8998','2013-04-14','13:35:00',2.59),('8998','2013-04-14','13:40:00',2.58),('8998','2013-04-14','13:45:00',2.51),('8998','2013-04-14','13:50:00',2.48),('8998','2013-04-14','13:55:00',2.47),('8998','2013-04-14','14:00:00',2.45),('8998','2013-04-14','14:05:00',2.41),('8998','2013-04-14','14:10:00',2.38),('8998','2013-04-14','14:15:00',2.36),('8998','2013-04-14','14:20:00',2.33),('8998','2013-04-14','14:25:00',2.28),('8998','2013-04-14','14:30:00',2.24),('8998','2013-04-14','14:35:00',2.19),('8998','2013-04-14','14:40:00',2.15),('8998','2013-04-14','14:45:00',2.11),('8998','2013-04-14','14:50:00',2.07),('8998','2013-04-14','14:55:00',2.02),('8998','2013-04-14','15:00:00',1.97),('8998','2013-04-14','15:05:00',1.93),('8998','2013-04-14','15:10:00',1.88),('8998','2013-04-14','15:15:00',1.82),('8998','2013-04-14','15:20:00',1.78),('8998','2013-04-14','15:25:00',1.72),('8998','2013-04-14','15:30:00',1.67),('8998','2013-04-14','15:35:00',1.62),('8998','2013-04-14','15:40:00',1.56),('8998','2013-04-14','15:45:00',1.5),('8998','2013-04-14','15:50:00',1.45),('8998','2013-04-14','15:55:00',1.39),('8998','2013-04-14','16:00:00',1.33),('8998','2013-04-14','16:05:00',1.27),('8998','2013-04-14','16:10:00',1.22),('8998','2013-04-14','16:15:00',1.16),('8998','2013-04-14','16:20:00',1.1),('8998','2013-04-14','16:25:00',1.04),('8998','2013-04-13','08:05:00',1.01),('8998','2013-04-13','08:10:00',1.11),('8998','2013-04-13','08:15:00',1.17),('8998','2013-04-13','08:20:00',1.22),('8998','2013-04-13','08:25:00',1.42),('8998','2013-04-13','08:30:00',1.34),('8998','2013-04-13','08:35:00',1.32),('8998','2013-04-13','08:40:00',1.41),('8998','2013-04-13','08:45:00',1.45),('8998','2013-04-13','08:50:00',1.58),('8998','2013-04-13','08:55:00',1.77),('8998','2013-04-13','09:00:00',1.97),('8998','2013-04-13','09:05:00',2.07),('8998','2013-04-13','09:10:00',2.12),('8998','2013-04-13','09:15:00',2.16),('8998','2013-04-13','09:20:00',2.21),('8998','2013-04-13','09:25:00',2.26),('8998','2013-04-13','09:30:00',2.29),('8998','2013-04-13','09:35:00',2.34),('8998','2013-04-13','09:40:00',2.43),('8998','2013-04-13','09:45:00',2.46),('8998','2013-04-13','09:50:00',2.5),('8998','2013-04-13','09:55:00',2.53),('8998','2013-04-13','10:00:00',2.57),('8998','2013-04-13','10:05:00',2.61),('8998','2013-04-13','10:10:00',2.63),('8998','2013-04-13','10:15:00',2.65),('8998','2013-04-13','10:20:00',2.67),('8998','2013-04-13','10:25:00',2.69),('8998','2013-04-13','10:30:00',2.71),('8998','2013-04-13','10:35:00',2.73),('8998','2013-04-13','10:40:00',2.74),('8998','2013-04-13','10:45:00',2.76),('8998','2013-04-13','10:50:00',2.78),('8998','2013-04-13','10:55:00',2.79),('8998','2013-04-13','11:00:00',2.82),('8998','2013-04-13','11:05:00',2.82),('8998','2013-04-13','11:10:00',2.85),('8998','2013-04-13','11:15:00',2.85),('8998','2013-04-13','11:20:00',2.84),('8998','2013-04-13','11:25:00',2.82),('8998','2013-04-13','11:30:00',2.83),('8998','2013-04-13','11:35:00',2.86),('8998','2013-04-13','11:40:00',2.87),('8998','2013-04-13','11:45:00',2.86),('8998','2013-04-13','11:50:00',2.83),('8998','2013-04-13','11:55:00',2.84),('8998','2013-04-13','12:00:00',2.81),('8998','2013-04-13','12:05:00',2.8),('8998','2013-04-13','12:10:00',2.83),('8998','2013-04-13','12:15:00',2.81),('8998','2013-04-13','12:20:00',2.82),('8998','2013-04-13','12:25:00',2.79),('8998','2013-04-13','12:30:00',2.78),('8998','2013-04-13','12:35:00',2.79),('8998','2013-04-13','12:40:00',2.81),('8998','2013-04-13','12:45:00',2.82),('8998','2013-04-13','12:50:00',2.83),('8998','2013-04-13','12:55:00',2.88),('8998','2013-04-13','13:00:00',2.11),('8998','2013-04-13','13:05:00',2.2),('8998','2013-04-13','13:10:00',2.84),('8998','2013-04-13','13:15:00',2.8),('8998','2013-04-13','13:20:00',2.75),('8998','2013-04-13','13:25:00',2.71),('8998','2013-04-13','13:30:00',2.61),('8998','2013-04-13','13:35:00',2.6),('8998','2013-04-13','13:40:00',2.56),('8998','2013-04-13','13:45:00',2.52),('8998','2013-04-13','13:50:00',2.47),('8998','2013-04-13','13:55:00',2.42),('8998','2013-04-13','14:00:00',2.37),('8998','2013-04-13','14:05:00',2.39),('8998','2013-04-13','14:10:00',2.38),('8998','2013-04-13','14:15:00',2.34),('8998','2013-04-13','14:20:00',2.29),('8998','2013-04-13','14:25:00',2.24),('8998','2013-04-13','14:30:00',2.22),('8998','2013-04-13','14:35:00',2.23),('8998','2013-04-13','14:40:00',2.24),('8998','2013-04-13','14:45:00',2.27),('8998','2013-04-13','14:50:00',2.25),('8998','2013-04-13','14:55:00',2.12),('8998','2013-04-13','15:00:00',2.08),('8998','2013-04-13','15:05:00',2.04),('8998','2013-04-13','15:10:00',1.91),('8998','2013-04-13','15:15:00',1.81),('8998','2013-04-13','15:20:00',1.64),('8998','2013-04-13','15:25:00',1.48),('8998','2013-04-13','15:30:00',1.72),('8998','2013-04-13','15:35:00',1.76),('8998','2013-04-13','15:40:00',1.77),('8998','2013-04-13','15:45:00',1.65),('8998','2013-04-13','15:50:00',1.54),('8998','2013-04-13','16:00:00',1.36),('8998','2013-04-13','16:05:00',1.29),('8998','2013-04-13','16:10:00',1.24),('8998','2013-04-13','16:15:00',1.13),('8998','2013-04-13','16:20:00',1.08),('8998','2013-04-13','16:25:00',1.06),('8998','2013-04-12','08:05:00',1.09),('8998','2013-04-12','08:10:00',1.05),('8998','2013-04-12','09:00:00',1),('8998','2013-04-12','09:05:00',1.49),('8998','2013-04-12','09:10:00',1.54),('8998','2013-04-12','09:15:00',2.02),('8998','2013-04-12','09:20:00',2.09),('8998','2013-04-12','09:25:00',1.89),('8998','2013-04-12','09:30:00',2.34),('8998','2013-04-12','09:35:00',2.31),('8998','2013-04-12','09:40:00',2.12),('8998','2013-04-12','09:45:00',2.47),('8998','2013-04-12','09:50:00',2.49),('8998','2013-04-12','09:55:00',2.57),('8998','2013-04-12','10:00:00',2.61),('8998','2013-04-12','10:05:00',2.62),('8998','2013-04-12','10:10:00',2.72),('8998','2013-04-12','10:15:00',2.9),('8998','2013-04-12','10:20:00',2.9),('8998','2013-04-12','10:25:00',2.37),('8998','2013-04-12','10:30:00',2.63),('8998','2013-04-12','10:35:00',1.75),('8998','2013-04-12','10:40:00',1.69),('8998','2013-04-12','10:45:00',2.57),('8998','2013-04-12','10:50:00',1.16),('8998','2013-04-12','10:55:00',2.06),('8998','2013-04-12','11:00:00',1.8),('8998','2013-04-12','11:05:00',1.84),('8998','2013-04-12','11:10:00',1.53),('8998','2013-04-12','11:15:00',2.03),('8998','2013-04-12','11:20:00',2.74),('8998','2013-04-12','11:25:00',1.36),('8998','2013-04-12','11:30:00',1.03),('8998','2013-04-12','11:35:00',3.3),('8998','2013-04-12','11:40:00',2.89),('8998','2013-04-12','11:45:00',2.31),('8998','2013-04-12','11:50:00',3.16),('8998','2013-04-12','11:55:00',1.78),('8998','2013-04-12','12:00:00',3.17),('8998','2013-04-12','12:05:00',3.07),('8998','2013-04-12','12:10:00',3.12),('8998','2013-04-12','12:15:00',3.09),('8998','2013-04-12','12:20:00',2.95),('8998','2013-04-12','12:25:00',2.92),('8998','2013-04-12','12:30:00',2.62),('8998','2013-04-12','12:35:00',2.96),('8998','2013-04-12','12:40:00',2.96),('8998','2013-04-12','12:45:00',2.88),('8998','2013-04-12','12:50:00',2.8),('8998','2013-04-12','12:55:00',2.82),('8998','2013-04-12','13:00:00',2.6),('8998','2013-04-12','13:05:00',2.84),('8998','2013-04-12','13:10:00',2.89),('8998','2013-04-12','13:15:00',2.75),('8998','2013-04-12','13:20:00',2.52),('8998','2013-04-12','13:25:00',2.72),('8998','2013-04-12','13:30:00',2.7),('8998','2013-04-12','13:35:00',1.5),('8998','2013-04-12','13:40:00',1.3),('8998','2013-04-12','13:45:00',2.28),('8998','2013-04-12','13:50:00',1.91),('8998','2013-04-12','13:55:00',1.23),('8998','2013-04-12','14:00:00',1.35),('8998','2013-04-12','14:05:00',1.58),('8998','2013-04-12','14:10:00',1.05),('8998','2013-04-12','14:15:00',1.1),('8998','2013-04-12','14:20:00',2.04),('8998','2013-04-12','14:25:00',2.24),('8998','2013-04-12','14:30:00',2.16),('8998','2013-04-12','14:35:00',2.28),('8998','2013-04-12','14:40:00',2.14),('8998','2013-04-12','14:45:00',2.1),('8998','2013-04-12','14:50:00',1.99),('8998','2013-04-12','14:55:00',1.98),('8998','2013-04-12','15:00:00',1.83),('8998','2013-04-12','15:05:00',1.61),('8998','2013-04-12','15:10:00',1.47),('8998','2013-04-12','15:15:00',1.65),('8998','2013-04-12','15:20:00',1.57),('8998','2013-04-12','15:25:00',1.47),('8998','2013-04-12','15:30:00',1.48),('8998','2013-04-12','15:35:00',1.42),('8998','2013-04-12','15:40:00',1.44),('8998','2013-04-12','15:45:00',1.44),('8998','2013-04-12','15:50:00',1.39),('8998','2013-04-12','15:55:00',1.33),('8998','2013-04-12','16:00:00',1.32),('8998','2013-04-12','16:05:00',1.25),('8998','2013-04-12','16:10:00',1.16),('8998','2013-04-12','16:15:00',1.17),('8998','2013-04-12','16:20:00',1.11),('8998','2013-04-12','16:25:00',1.05),('8998','2013-04-12','16:30:00',1),('8998','2013-04-11','08:05:00',1.03),('8998','2013-04-11','08:10:00',1.23),('8998','2013-04-11','08:35:00',1.05),('8998','2013-04-11','08:45:00',1.03),('8998','2013-04-11','08:55:00',1),('8998','2013-04-11','09:00:00',1.62),('8998','2013-04-11','09:05:00',1.58),('8998','2013-04-11','09:10:00',1),('8998','2013-04-11','09:15:00',1.96),('8998','2013-04-11','09:20:00',1.66),('8998','2013-04-11','09:25:00',1.45),('8998','2013-04-11','09:30:00',1.62),('8998','2013-04-11','09:35:00',1.05),('8998','2013-04-11','09:40:00',1.39),('8998','2013-04-11','09:45:00',1.15),('8998','2013-04-11','09:50:00',1.08),('8998','2013-04-11','10:20:00',1.05),('8998','2013-04-11','10:25:00',1.26),('8998','2013-04-11','10:40:00',1.09),('8998','2013-04-11','10:45:00',2.88),('8998','2013-04-11','10:50:00',2.33),('8998','2013-04-11','10:55:00',3.49),('8998','2013-04-11','11:00:00',1.44),('8998','2013-04-11','11:05:00',1.04),('8998','2013-04-11','11:10:00',1.28),('8998','2013-04-11','11:15:00',1.75),('8998','2013-04-11','11:20:00',3.46),('8998','2013-04-11','11:25:00',3.32),('8998','2013-04-11','11:30:00',2.44),('8998','2013-04-11','11:35:00',2.82),('8998','2013-04-11','11:40:00',3.21),('8998','2013-04-11','11:45:00',2.56),('8998','2013-04-11','11:50:00',2.37),('8998','2013-04-11','11:55:00',3.16),('8998','2013-04-11','12:00:00',3.07),('8998','2013-04-11','12:05:00',2.9),('8998','2013-04-11','12:10:00',2.84),('8998','2013-04-11','12:15:00',2.96),('8998','2013-04-11','12:20:00',3.03),('8998','2013-04-11','12:25:00',2.99),('8998','2013-04-11','12:30:00',2.96),('8998','2013-04-11','12:35:00',2.89),('8998','2013-04-11','12:40:00',2.79),('8998','2013-04-11','12:45:00',2.77),('8998','2013-04-11','12:50:00',2.74),('8998','2013-04-11','12:55:00',2.85),('8998','2013-04-11','13:00:00',2.88),('8998','2013-04-11','13:05:00',2.82),('8998','2013-04-11','13:10:00',2.8),('8998','2013-04-11','13:15:00',2.76),('8998','2013-04-11','13:20:00',2.76),('8998','2013-04-11','13:25:00',2.72),('8998','2013-04-11','13:30:00',2.69),('8998','2013-04-11','13:35:00',2.68),('8998','2013-04-11','13:40:00',2.62),('8998','2013-04-11','13:45:00',2.62),('8998','2013-04-11','13:50:00',2.58),('8998','2013-04-11','13:55:00',2.54),('8998','2013-04-11','14:00:00',2.51),('8998','2013-04-11','14:05:00',2.48),('8998','2013-04-11','14:10:00',2.44),('8998','2013-04-11','14:15:00',2.39),('8998','2013-04-11','14:20:00',2.34),('8998','2013-04-11','14:25:00',2.3),('8998','2013-04-11','14:30:00',2.25),('8998','2013-04-11','14:35:00',2.21),('8998','2013-04-11','14:40:00',2.16),('8998','2013-04-11','14:45:00',2.12),('8998','2013-04-11','14:50:00',2.07),('8998','2013-04-11','14:55:00',2.02),('8998','2013-04-11','15:00:00',1.97),('8998','2013-04-11','15:05:00',1.93),('8998','2013-04-11','15:10:00',1.86),('8998','2013-04-11','15:15:00',1.81),('8998','2013-04-11','15:20:00',1.76),('8998','2013-04-11','15:25:00',1.7),('8998','2013-04-11','15:30:00',1.65),('8998','2013-04-11','15:35:00',1.59),('8998','2013-04-11','15:40:00',1.54),('8998','2013-04-11','15:45:00',1.48),('8998','2013-04-11','15:50:00',1.43),('8998','2013-04-11','15:55:00',1.37),('8998','2013-04-11','16:00:00',1.31),('8998','2013-04-11','16:05:00',1.26),('8998','2013-04-11','16:10:00',1.2),('8998','2013-04-11','16:15:00',1.06),('8998','2013-04-11','16:20:00',1.06),('8998','2013-04-11','16:25:00',1.03),('8998','2014-03-27','07:30:00',1.3),('8998','2014-03-27','07:35:00',1.42),('8998','2014-03-27','07:40:00',1.32),('8998','2014-03-27','07:45:00',1.35),('8998','2014-03-27','07:50:00',1.46),('8998','2014-03-27','07:55:00',1.57),('8998','2014-03-27','08:00:00',1.77),('8998','2014-03-27','08:05:00',1.88),('8998','2014-03-27','08:10:00',2.02),('8998','2014-03-27','08:15:00',2.17),('8998','2014-03-27','08:20:00',2.26),('8998','2014-03-27','08:25:00',2.29),('8998','2014-03-27','08:30:00',2.32),('8998','2014-03-27','08:35:00',2.36),('8998','2014-03-27','08:40:00',2.41),('8998','2014-03-27','08:45:00',2.42),('8998','2014-03-27','08:50:00',2.47),('8998','2014-03-27','08:55:00',2.52),('8998','2014-03-27','09:00:00',2.5),('8998','2014-03-27','09:05:00',2.62),('8998','2014-03-27','09:10:00',2.71),('8998','2014-03-27','09:15:00',2.61),('8998','2014-03-27','09:20:00',2.3),('8998','2014-03-27','09:25:00',2.61),('8998','2014-03-27','09:30:00',2.74),('8998','2014-03-27','09:35:00',2.29),('8998','2014-03-27','09:40:00',1.82),('8998','2014-03-27','09:45:00',1.41),('8998','2014-03-27','09:50:00',1.7),('8998','2014-03-27','09:55:00',2.75),('8998','2014-03-27','10:00:00',3),('8998','2014-03-27','10:05:00',2.84),('8998','2014-03-27','10:10:00',2.14),('8998','2014-03-27','10:15:00',2.19),('8998','2014-03-27','10:20:00',2.11),('8998','2014-03-27','10:25:00',2.84),('8998','2014-03-27','10:30:00',2.82),('8998','2014-03-27','10:35:00',2.64),('8998','2014-03-27','10:40:00',2.68),('8998','2014-03-27','10:45:00',2.06),('8998','2014-03-27','10:50:00',2.85),('8998','2014-03-27','10:55:00',2.95),('8998','2014-03-27','11:00:00',2.6),('8998','2014-03-27','11:05:00',2.95),('8998','2014-03-27','11:10:00',2.68),('8998','2014-03-27','11:15:00',2.48),('8998','2014-03-27','11:20:00',2.88),('8998','2014-03-27','11:25:00',2.08),('8998','2014-03-27','11:30:00',1.2),('8998','2014-03-27','11:35:00',2.74),('8998','2014-03-27','11:40:00',1.06),('8998','2014-03-27','11:45:00',1.27),('8998','2014-03-27','11:55:00',1.39),('8998','2014-03-27','12:00:00',2.63),('8998','2014-03-27','12:05:00',2.98),('8998','2014-03-27','12:10:00',3.01),('8998','2014-03-27','12:15:00',3.15),('8998','2014-03-27','12:20:00',2.82),('8998','2014-03-27','12:35:00',3.12),('8998','2014-03-27','12:40:00',1.99),('8998','2014-03-27','12:45:00',2.72),('8998','2014-03-27','12:50:00',2.62),('8998','2014-03-27','12:55:00',2.9),('8998','2014-03-27','13:00:00',2.13),('8998','2014-03-27','13:05:00',2.14),('8998','2014-03-27','13:15:00',1.22),('8998','2014-03-27','13:20:00',2.75),('8998','2014-03-27','13:25:00',1.14),('8998','2014-03-27','13:30:00',1.89),('8998','2014-03-27','13:35:00',2.3),('8998','2014-03-27','13:40:00',2.08),('8998','2014-03-27','13:45:00',2.22),('8998','2014-03-27','13:50:00',2.1),('8998','2014-03-27','13:55:00',1.99),('8998','2014-03-27','14:00:00',1.99),('8998','2014-03-27','14:05:00',1.9),('8998','2014-03-27','14:10:00',1.81),('8998','2014-03-27','14:15:00',1.8),('8998','2014-03-27','14:20:00',1.75),('8998','2014-03-27','14:25:00',1.69),('8998','2014-03-27','14:30:00',1.63),('8998','2014-03-27','14:35:00',1.57),('8998','2014-03-27','14:40:00',1.52),('8998','2014-03-27','14:45:00',1.46),('8998','2014-03-27','14:50:00',1.41),('8998','2014-03-27','14:55:00',1.36),('8998','2014-03-27','15:00:00',1.33),('8998','2014-03-27','15:05:00',1.22),('8998','2014-03-27','15:10:00',1.12),('8998','2014-03-27','15:15:00',1.08),('8998','2013-04-10','08:05:00',1.04),('8998','2013-04-10','08:10:00',1.1),('8998','2013-04-10','08:15:00',1.14),('8998','2013-04-10','08:20:00',1.16),('8998','2013-04-10','08:25:00',1.39),('8998','2013-04-10','08:30:00',1.34),('8998','2013-04-10','08:35:00',1.36),('8998','2013-04-10','08:40:00',1.34),('8998','2013-04-10','08:45:00',1.41),('8998','2013-04-10','08:50:00',1.77),('8998','2013-04-10','08:55:00',1.96),('8998','2013-04-10','09:00:00',2.08),('8998','2013-04-10','09:05:00',2.13),('8998','2013-04-10','09:10:00',2.16),('8998','2013-04-10','09:15:00',2.21),('8998','2013-04-10','09:20:00',2.25),('8998','2013-04-10','09:25:00',2.3),('8998','2013-04-10','09:30:00',2.28),('8998','2013-04-10','09:35:00',2.36),('8998','2013-04-10','09:40:00',2.42),('8998','2013-04-10','09:45:00',2.47),('8998','2013-04-10','09:50:00',2.54),('8998','2013-04-10','09:55:00',2.12),('8998','2013-04-10','10:00:00',1.48),('8998','2013-04-10','10:10:00',1.61),('8998','2013-04-10','10:15:00',1.94),('8998','2013-04-10','10:20:00',2.82),('8998','2013-04-10','10:25:00',2.75),('8998','2013-04-10','10:30:00',2.78),('8998','2013-04-10','10:35:00',2.94),('8998','2013-04-10','10:40:00',2.97),('8998','2013-04-10','10:45:00',3.13),('8998','2013-04-10','10:50:00',1.52),('8998','2013-04-10','11:05:00',2.91),('8998','2013-04-10','11:10:00',3.03),('8998','2013-04-10','11:15:00',3.03),('8998','2013-04-10','11:20:00',2.38),('8998','2013-04-10','11:25:00',1.17),('8998','2013-04-10','11:30:00',2.34),('8998','2013-04-10','11:35:00',3.14),('8998','2013-04-10','11:40:00',1.31),('8998','2013-04-10','11:55:00',1.33),('8998','2013-04-10','12:00:00',2.83),('8998','2013-04-10','12:05:00',3.21),('8998','2013-04-10','12:10:00',3.15),('8998','2013-04-10','12:15:00',1.23),('8998','2013-04-10','12:20:00',1.51),('8998','2013-04-10','12:25:00',3.25),('8998','2013-04-10','12:30:00',3.17),('8998','2013-04-10','12:35:00',3.15),('8998','2013-04-10','12:40:00',3.14),('8998','2013-04-10','12:45:00',3.11),('8998','2013-04-10','12:50:00',3.01),('8998','2013-04-10','12:55:00',2.5),('8998','2013-04-10','13:00:00',2.61),('8998','2013-04-10','13:05:00',2.79),('8998','2013-04-10','13:10:00',2.34),('8998','2013-04-10','13:15:00',2.9),('8998','2013-04-10','13:20:00',1.99),('8998','2013-04-10','13:25:00',2.5),('8998','2013-04-10','13:30:00',2.79),('8998','2013-04-10','13:35:00',2.72),('8998','2013-04-10','13:40:00',2.72),('8998','2013-04-10','13:45:00',2.65),('8998','2013-04-10','13:50:00',2.59),('8998','2013-04-10','13:55:00',2.62),('8998','2013-04-10','14:00:00',2.57),('8998','2013-04-10','14:05:00',2.54),('8998','2013-04-10','14:10:00',2.53),('8998','2013-04-10','14:15:00',2.48),('8998','2013-04-10','14:20:00',2.45),('8998','2013-04-10','14:25:00',2.38),('8998','2013-04-10','14:30:00',2.31),('8998','2013-04-10','14:35:00',2.05),('8998','2013-04-10','14:40:00',2.26),('8998','2013-04-10','14:45:00',2.29),('8998','2013-04-10','14:50:00',2.19),('8998','2013-04-10','14:55:00',2.11),('8998','2013-04-10','15:00:00',2.05),('8998','2013-04-10','15:05:00',1.99),('8998','2013-04-10','15:10:00',1.91),('8998','2013-04-10','15:15:00',1.85),('8998','2013-04-10','15:20:00',1.79),('8998','2013-04-10','15:25:00',1.73),('8998','2013-04-10','15:30:00',1.68),('8998','2013-04-10','15:35:00',1.63),('8998','2013-04-10','15:40:00',1.56),('8998','2013-04-10','15:45:00',1.5),('8998','2013-04-10','15:50:00',1.43),('8998','2013-04-10','15:55:00',1.38),('8998','2013-04-10','16:00:00',1.33),('8998','2013-04-10','16:05:00',1.27),('8998','2013-04-10','16:10:00',1.21),('8998','2013-04-10','16:15:00',1.14),('8998','2013-04-10','16:20:00',1.09),('8998','2013-04-10','16:25:00',1.03),('8998','2013-04-09','08:55:00',1.61),('8998','2013-04-09','09:00:00',2.06),('8998','2013-04-09','09:05:00',2.16),('8998','2013-04-09','09:10:00',2.22),('8998','2013-04-09','09:15:00',2.17),('8998','2013-04-09','09:20:00',2.13),('8998','2013-04-09','09:25:00',2.35),('8998','2013-04-09','09:30:00',2.44),('8998','2013-04-09','09:35:00',2.53),('8998','2013-04-09','09:40:00',2.55),('8998','2013-04-09','09:45:00',2.6),('8998','2013-04-09','09:50:00',2.66),('8998','2013-04-09','09:55:00',2.73),('8998','2013-04-09','10:00:00',2.75),('8998','2013-04-09','10:05:00',2.84),('8998','2013-04-09','10:10:00',2.97),('8998','2013-04-09','10:15:00',3.03),('8998','2013-04-09','10:20:00',3.02),('8998','2013-04-09','10:25:00',3.02),('8998','2013-04-09','10:30:00',3.02),('8998','2013-04-09','10:35:00',3.01),('8998','2013-04-09','10:40:00',3.01),('8998','2013-04-09','10:45:00',3.06),('8998','2013-04-09','10:50:00',2.87),('8998','2013-04-09','10:55:00',2.83),('8998','2013-04-09','11:00:00',2.8),('8998','2013-04-09','11:05:00',2.76),('8998','2013-04-09','11:10:00',2.82),('8998','2013-04-09','11:15:00',2.62),('8998','2013-04-09','11:20:00',2.94),('8998','2013-04-09','11:25:00',3.02),('8998','2013-04-09','11:30:00',2.98),('8998','2013-04-09','11:35:00',3),('8998','2013-04-09','11:40:00',2.92),('8998','2013-04-09','11:45:00',3.03),('8998','2013-04-09','11:50:00',2.98),('8998','2013-04-09','11:55:00',2.7),('8998','2013-04-09','12:00:00',3.03),('8998','2013-04-09','12:05:00',3.01),('8998','2013-04-09','12:10:00',3),('8998','2013-04-09','12:15:00',3.02),('8998','2013-04-09','12:20:00',3.01),('8998','2013-04-09','12:25:00',3.04),('8998','2013-04-09','12:30:00',3.05),('8998','2013-04-09','12:35:00',3.04),('8998','2013-04-09','12:40:00',2.97),('8998','2013-04-09','12:45:00',2.94),('8998','2013-04-09','12:50:00',2.96),('8998','2013-04-09','12:55:00',2.77),('8998','2013-04-09','13:00:00',2.89),('8998','2013-04-09','13:05:00',2.86),('8998','2013-04-09','13:10:00',2.96),('8998','2013-04-09','13:15:00',2.04),('8998','2013-04-09','13:20:00',3.41),('8998','2013-04-09','13:25:00',1.69),('8998','2013-04-09','13:30:00',1.95),('8998','2013-04-09','13:35:00',2.67),('8998','2013-04-09','13:40:00',2.2),('8998','2013-04-09','13:45:00',2.9),('8998','2013-04-09','13:50:00',2.18),('8998','2013-04-09','13:55:00',2.23),('8998','2013-04-09','14:00:00',2.02),('8998','2013-04-09','14:05:00',2.62),('8998','2013-04-09','14:10:00',2.61),('8998','2013-04-09','14:15:00',2.53),('8998','2013-04-09','14:20:00',2.49),('8998','2013-04-09','14:25:00',2.45),('8998','2013-04-09','14:30:00',2.41),('8998','2013-04-09','14:35:00',2.38),('8998','2013-04-09','14:40:00',2.35),('8998','2013-04-09','14:45:00',2.15),('8998','2013-04-09','14:50:00',2.16),('8998','2013-04-09','14:55:00',2.06),('8998','2013-04-09','15:00:00',2.21),('8998','2013-04-09','15:05:00',2.19),('8998','2013-04-09','15:10:00',2.12),('8998','2013-04-09','15:15:00',1.65),('8998','2013-04-09','15:20:00',1.49),('8998','2013-04-09','15:25:00',1.92),('8998','2013-04-09','15:30:00',1.72),('8998','2013-04-09','15:35:00',1.49),('8998','2013-04-09','15:40:00',1.65),('8998','2013-04-09','15:45:00',1.59),('8998','2013-04-09','15:50:00',1.68),('8998','2013-04-09','15:55:00',1.38),('8998','2013-04-09','16:00:00',1.47),('8998','2013-04-09','16:05:00',1.19),('8998','2013-04-09','16:10:00',1.31),('8998','2013-04-09','16:15:00',1.22),('8998','2013-04-09','16:20:00',1.26),('8998','2013-04-09','16:25:00',1.01),('8998','2013-04-09','16:30:00',1.06),('8998','2013-04-08','08:00:00',1.01),('8998','2013-04-08','08:20:00',1.42),('8998','2013-04-08','09:30:00',1.03),('8998','2013-04-08','09:50:00',1.45),('8998','2013-04-08','09:55:00',2.7),('8998','2013-04-08','10:00:00',1.63),('8998','2013-04-08','10:10:00',1.16),('8998','2013-04-08','10:15:00',1.63),('8998','2013-04-08','10:20:00',1.39),('8998','2013-04-08','10:35:00',2.59),('8998','2013-04-08','10:40:00',1.62),('8998','2013-04-08','10:45:00',2.57),('8998','2013-04-08','10:50:00',3.39),('8998','2013-04-08','10:55:00',2.7),('8998','2013-04-08','11:00:00',2.54),('8998','2013-04-08','11:05:00',2.82),('8998','2013-04-08','11:10:00',3.19),('8998','2013-04-08','11:15:00',1.77),('8998','2013-04-08','11:25:00',2.89),('8998','2013-04-08','11:30:00',3.53),('8998','2013-04-08','11:35:00',2.63),('8998','2013-04-08','11:45:00',2.28),('8998','2013-04-08','11:50:00',3.22),('8998','2013-04-08','11:55:00',1.76),('8998','2013-04-08','12:00:00',3.45),('8998','2013-04-08','12:05:00',3.23),('8998','2013-04-08','12:10:00',3.19),('8998','2013-04-08','12:15:00',3.17),('8998','2013-04-08','12:20:00',2.15),('8998','2013-04-08','12:25:00',2.83),('8998','2013-04-08','12:30:00',3.05),('8998','2013-04-08','12:35:00',2.75),('8998','2013-04-08','12:40:00',3.04),('8998','2013-04-08','12:45:00',2.97),('8998','2013-04-08','12:50:00',3.07),('8998','2013-04-08','12:55:00',3.02),('8998','2013-04-08','13:00:00',3.01),('8998','2013-04-08','13:05:00',3.04),('8998','2013-04-08','13:10:00',3.15),('8998','2013-04-08','13:15:00',3.09),('8998','2013-04-08','13:20:00',1.82),('8998','2013-04-08','13:25:00',2.78),('8998','2013-04-08','13:30:00',2.41),('8998','2013-04-08','13:40:00',1.46),('8998','2013-04-08','13:45:00',1.06),('8998','2013-04-08','13:50:00',2.08),('8998','2013-04-08','13:55:00',2.69),('8998','2013-04-08','14:00:00',2.53),('8998','2013-04-08','14:05:00',2.28),('8998','2013-04-08','14:10:00',1.92),('8998','2013-04-08','14:15:00',2.21),('8998','2013-04-08','14:20:00',1.29),('8998','2013-04-08','14:25:00',1.64),('8998','2013-04-08','14:30:00',2.13),('8998','2013-04-08','14:35:00',2.18),('8998','2013-04-08','14:40:00',2.28),('8998','2013-04-08','14:45:00',2.09),('8998','2013-04-08','14:50:00',2.02),('8998','2013-04-08','14:55:00',1.98),('8998','2013-04-08','15:00:00',1.63),('8998','2013-04-08','15:05:00',1.7),('8998','2013-04-08','15:10:00',2.15),('8998','2013-04-08','15:15:00',1.47),('8998','2013-04-08','15:20:00',1.95),('8998','2013-04-08','15:25:00',2.01),('8998','2013-04-08','15:30:00',1.72),('8998','2013-04-08','15:35:00',1.26),('8998','2013-04-08','15:40:00',1.82),('8998','2013-04-08','15:45:00',1.39),('8998','2013-04-08','15:50:00',1.58),('8998','2013-04-08','15:55:00',1.39),('8998','2013-04-08','16:00:00',1.25),('8998','2013-04-08','16:05:00',1.33),('8998','2013-04-08','16:10:00',1.34),('8998','2013-04-07','08:40:00',1.03),('8998','2013-04-07','08:45:00',1.1),('8998','2013-04-07','08:50:00',1.3),('8998','2013-04-07','08:55:00',1.09),('8998','2013-04-07','09:00:00',1.29),('8998','2013-04-07','09:05:00',1.41),('8998','2013-04-07','09:10:00',1.94),('8998','2013-04-07','09:15:00',1.79),('8998','2013-04-07','09:20:00',1.93),('8998','2013-04-07','09:25:00',1.84),('8998','2013-04-07','09:30:00',2.41),('8998','2013-04-07','09:35:00',2.6),('8998','2013-04-07','09:40:00',2.67),('8998','2013-04-07','09:45:00',2.65),('8998','2013-04-07','09:50:00',1.93),('8998','2013-04-07','09:55:00',1.31),('8998','2013-04-07','10:00:00',2.73),('8998','2013-04-07','10:05:00',2.86),('8998','2013-04-07','10:10:00',2.74),('8998','2013-04-07','10:15:00',2.8),('8998','2013-04-07','10:20:00',2.76),('8998','2013-04-07','10:25:00',2.73),('8998','2013-04-07','10:30:00',2.74),('8998','2013-04-07','10:35:00',2.6),('8998','2013-04-07','10:40:00',2.79),('8998','2013-04-07','10:45:00',2.88),('8998','2013-04-07','10:50:00',2.91),('8998','2013-04-07','10:55:00',2.74),('8998','2013-04-07','11:00:00',2.86),('8998','2013-04-07','11:05:00',2.51),('8998','2013-04-07','11:10:00',2.08),('8998','2013-04-07','11:15:00',2.12),('8998','2013-04-07','11:20:00',1.73),('8998','2013-04-07','11:25:00',1.46),('8998','2013-04-07','11:30:00',1.59),('8998','2013-04-07','11:35:00',2.08),('8998','2013-04-07','11:40:00',2.35),('8998','2013-04-07','11:45:00',2.11),('8998','2013-04-07','11:50:00',2),('8998','2013-04-07','11:55:00',1.7),('8998','2013-04-07','12:00:00',1.64),('8998','2013-04-07','12:05:00',1.53),('8998','2013-04-07','12:10:00',1.62),('8998','2013-04-07','12:15:00',1.92),('8998','2013-04-07','12:20:00',1.94),('8998','2013-04-07','12:25:00',1.96),('8998','2013-04-07','12:30:00',2.11),('8998','2013-04-07','12:35:00',2),('8998','2013-04-07','12:40:00',1.51),('8998','2013-04-07','12:45:00',1.62),('8998','2013-04-07','12:50:00',1.99),('8998','2013-04-07','12:55:00',2.11),('8998','2013-04-07','13:00:00',1.45),('8998','2013-04-07','13:05:00',1.58),('8998','2013-04-07','13:10:00',1.88),('8998','2013-04-07','13:15:00',1.98),('8998','2013-04-07','13:20:00',2.48),('8998','2013-04-07','13:25:00',2.15),('8998','2013-04-07','13:30:00',1.86),('8998','2013-04-07','13:35:00',2.01),('8998','2013-04-07','13:40:00',2.3),('8998','2013-04-07','13:45:00',1.84),('8998','2013-04-07','13:50:00',1.91),('8998','2013-04-07','13:55:00',2.45),('8998','2013-04-07','14:00:00',2.44),('8998','2013-04-07','14:05:00',1.99),('8998','2013-04-07','14:10:00',2.05),('8998','2013-04-07','14:15:00',2.27),('8998','2013-04-07','14:20:00',2.06),('8998','2013-04-07','14:25:00',2.36),('8998','2013-04-07','14:30:00',2.26),('8998','2013-04-07','14:35:00',2.13),('8998','2013-04-07','14:40:00',2.07),('8998','2013-04-07','14:45:00',2.1),('8998','2013-04-07','14:50:00',2.05),('8998','2013-04-07','14:55:00',2.12),('8998','2013-04-07','15:00:00',1.68),('8998','2013-04-07','15:05:00',1.67),('8998','2013-04-07','15:10:00',1.59),('8998','2013-04-07','15:15:00',1.66),('8998','2013-04-07','15:20:00',1.39),('8998','2013-04-07','15:25:00',1.82),('8998','2013-04-07','15:30:00',1.84),('8998','2013-04-07','15:35:00',1.71),('8998','2013-04-07','15:40:00',1.61),('8998','2013-04-07','15:45:00',1.52),('8998','2013-04-07','15:50:00',1.45),('8998','2013-04-07','15:55:00',1.39),('8998','2013-04-07','16:00:00',1.32),('8998','2013-04-07','16:05:00',1.23),('8998','2013-04-07','16:10:00',1.11),('8998','2013-04-07','16:15:00',1.17),('8998','2013-04-07','16:20:00',1.13),('8998','2013-04-07','16:25:00',1.03),('8998','2013-04-06','08:35:00',1.04),('8998','2013-04-06','08:40:00',1.19),('8998','2013-04-06','08:45:00',1.3),('8998','2013-04-06','08:50:00',1.34),('8998','2013-04-06','08:55:00',1.4),('8998','2013-04-06','09:00:00',1.36),('8998','2013-04-06','09:05:00',1.38),('8998','2013-04-06','09:10:00',1.47),('8998','2013-04-06','09:15:00',1.44),('8998','2013-04-06','09:20:00',1.53),('8998','2013-04-06','09:25:00',1.5),('8998','2013-04-06','09:30:00',1.43),('8998','2013-04-06','09:35:00',1.32),('8998','2013-04-06','09:40:00',1.37),('8998','2013-04-06','09:45:00',1.75),('8998','2013-04-06','09:50:00',1.86),('8998','2013-04-06','09:55:00',2.05),('8998','2013-04-06','10:00:00',2.36),('8998','2013-04-06','10:05:00',2.4),('8998','2013-04-06','10:10:00',2.37),('8998','2013-04-06','10:15:00',2.41),('8998','2013-04-06','10:20:00',2.46),('8998','2013-04-06','10:25:00',2.39),('8998','2013-04-06','10:30:00',2.08),('8998','2013-04-06','10:35:00',2.31),('8998','2013-04-06','10:40:00',2.25),('8998','2013-04-06','10:45:00',2.2),('8998','2013-04-06','10:50:00',2.13),('8998','2013-04-06','10:55:00',1.89),('8998','2013-04-06','11:00:00',1.68),('8998','2013-04-06','11:05:00',1.44),('8998','2013-04-06','11:10:00',1.72),('8998','2013-04-06','11:15:00',2.36),('8998','2013-04-06','11:20:00',2.67),('8998','2013-04-06','11:25:00',2.9),('8998','2013-04-06','11:30:00',2.73),('8998','2013-04-06','11:35:00',2.55),('8998','2013-04-06','11:40:00',2.27),('8998','2013-04-06','11:45:00',1.8),('8998','2013-04-06','11:50:00',1.71),('8998','2013-04-06','11:55:00',1.81),('8998','2013-04-06','12:00:00',1.87),('8998','2013-04-06','12:05:00',1.8),('8998','2013-04-06','12:10:00',1.95),('8998','2013-04-06','12:15:00',1.87),('8998','2013-04-06','12:20:00',2.02),('8998','2013-04-06','12:25:00',2.22),('8998','2013-04-06','12:30:00',1.87),('8998','2013-04-06','12:35:00',2.02),('8998','2013-04-06','12:40:00',1.96),('8998','2013-04-06','12:45:00',1.69),('8998','2013-04-06','12:50:00',1.76),('8998','2013-04-06','12:55:00',1.88),('8998','2013-04-06','13:00:00',2.18),('8998','2013-04-06','13:05:00',2.38),('8998','2013-04-06','13:10:00',2.3),('8998','2013-04-06','13:15:00',2.02),('8998','2013-04-06','13:20:00',1.87),('8998','2013-04-06','13:25:00',2.14),('8998','2013-04-06','13:30:00',2.19),('8998','2013-04-06','13:35:00',1.97),('8998','2013-04-06','13:40:00',2.08),('8998','2013-04-06','13:45:00',2.27),('8998','2013-04-06','13:50:00',2.07),('8998','2013-04-06','13:55:00',1.92),('8998','2013-04-06','14:00:00',2.26),('8998','2013-04-06','14:05:00',2.03),('8998','2013-04-06','14:10:00',1.57),('8998','2013-04-06','14:15:00',1.43),('8998','2013-04-06','14:20:00',1.29),('8998','2013-04-06','14:25:00',1.5),('8998','2013-04-06','14:30:00',1.57),('8998','2013-04-06','14:35:00',1.45),('8998','2013-04-06','14:40:00',1.26),('8998','2013-04-06','14:45:00',1.28),('8998','2013-04-06','14:50:00',1.38),('8998','2013-04-06','14:55:00',1.33),('8998','2013-04-06','15:00:00',1.33),('8998','2013-04-06','15:05:00',1.65),('8998','2013-04-06','15:10:00',1.62),('8998','2013-04-06','15:15:00',1.59),('8998','2013-04-06','15:20:00',1.59),('8998','2013-04-06','15:25:00',1.66),('8998','2013-04-06','15:30:00',1.58),('8998','2013-04-06','15:35:00',1.45),('8998','2013-04-06','15:40:00',1.47),('8998','2013-04-06','15:45:00',1.38),('8998','2013-04-06','15:50:00',1.29),('8998','2013-04-06','15:55:00',1.32),('8998','2013-04-06','16:00:00',1.21),('8998','2013-04-06','16:05:00',1.09),('8998','2013-04-05','08:15:00',1.25),('8998','2013-04-05','08:20:00',1.34),('8998','2013-04-05','08:25:00',1.26),('8998','2013-04-05','08:30:00',1.19),('8998','2013-04-05','08:35:00',1.31),('8998','2013-04-05','08:40:00',1.41),('8998','2013-04-05','08:45:00',1.69),('8998','2013-04-05','08:50:00',1.84),('8998','2013-04-05','08:55:00',1.92),('8998','2013-04-05','09:00:00',1.98),('8998','2013-04-05','09:05:00',2.08),('8998','2013-04-05','09:10:00',2.14),('8998','2013-04-05','09:15:00',2.22),('8998','2013-04-05','09:20:00',2.3),('8998','2013-04-05','09:25:00',2.34),('8998','2013-04-05','09:30:00',2.37),('8998','2013-04-05','09:35:00',2.36),('8998','2013-04-05','09:40:00',2.43),('8998','2013-04-05','09:45:00',2.45),('8998','2013-04-05','09:50:00',2.47),('8998','2013-04-05','09:55:00',2.52),('8998','2013-04-05','10:00:00',2.57),('8998','2013-04-05','10:05:00',2.57),('8998','2013-04-05','10:10:00',2.58),('8998','2013-04-05','10:15:00',2.56),('8998','2013-04-05','10:20:00',2.6),('8998','2013-04-05','10:25:00',2.69),('8998','2013-04-05','10:30:00',2.72),('8998','2013-04-05','10:35:00',2.72),('8998','2013-04-05','10:40:00',2.74),('8998','2013-04-05','10:45:00',2.74),('8998','2013-04-05','10:50:00',2.76),('8998','2013-04-05','10:55:00',2.78),('8998','2013-04-05','11:00:00',2.81),('8998','2013-04-05','11:05:00',2.84),('8998','2013-04-05','11:10:00',2.86),('8998','2013-04-05','11:15:00',2.84),('8998','2013-04-05','11:20:00',2.87),('8998','2013-04-05','11:25:00',2.92),('8998','2013-04-05','11:30:00',2.89),('8998','2013-04-05','11:35:00',2.9),('8998','2013-04-05','11:40:00',2.91),('8998','2013-04-05','11:45:00',2.9),('8998','2013-04-05','11:50:00',2.89),('8998','2013-04-05','11:55:00',2.9),('8998','2013-04-05','12:00:00',2.86),('8998','2013-04-05','12:05:00',2.87),('8998','2013-04-05','12:10:00',2.85),('8998','2013-04-05','12:15:00',2.84),('8998','2013-04-05','12:20:00',2.5),('8998','2013-04-05','12:25:00',2.41),('8998','2013-04-05','12:30:00',2.67),('8998','2013-04-05','12:35:00',2.9),('8998','2013-04-05','12:40:00',2.85),('8998','2013-04-05','12:45:00',2.85),('8998','2013-04-05','12:50:00',2.83),('8998','2013-04-05','12:55:00',2.82),('8998','2013-04-05','13:00:00',2.78),('8998','2013-04-05','13:05:00',2.77),('8998','2013-04-05','13:10:00',2.47),('8998','2013-04-05','13:15:00',1.95),('8998','2013-04-05','13:20:00',1.45),('8998','2013-04-05','13:30:00',1.42),('8998','2013-04-05','13:35:00',2.74),('8998','2013-04-05','13:40:00',2.99),('8998','2013-04-05','13:45:00',2.98),('8998','2013-04-05','13:50:00',2.76),('8998','2013-04-05','13:55:00',2.6),('8998','2013-04-05','14:00:00',2.09),('8998','2013-04-05','14:05:00',2.57),('8998','2013-04-05','14:15:00',2.55),('8998','2013-04-05','14:20:00',1.23),('8998','2013-04-05','14:25:00',1.77),('8998','2013-04-05','14:30:00',1.92),('8998','2013-04-05','14:35:00',2.24),('8998','2013-04-05','14:40:00',2.25),('8998','2013-04-05','14:45:00',2.1),('8998','2013-04-05','14:50:00',2.09),('8998','2013-04-05','14:55:00',1.96),('8998','2013-04-05','15:00:00',2.05),('8998','2013-04-05','15:05:00',1.98),('8998','2013-04-05','15:10:00',1.73),('8998','2013-04-05','15:15:00',1.78),('8998','2013-04-05','15:20:00',1.72),('8998','2013-04-05','15:25:00',1.67),('8998','2013-04-05','15:30:00',1.57),('8998','2013-04-05','15:35:00',1.51),('8998','2013-04-05','15:40:00',1.49),('8998','2013-04-05','15:45:00',1.32),('8998','2013-04-05','15:50:00',1.27),('8998','2013-04-05','15:55:00',1.36),('8998','2013-04-05','16:00:00',1.21),('8998','2013-04-05','16:05:00',1.26),('8998','2013-04-05','16:10:00',1.25),('8998','2013-04-05','16:15:00',1.13),('8998','2013-04-04','08:20:00',1.12),('8998','2013-04-04','08:55:00',1.33),('8998','2013-04-04','09:05:00',2.31),('8998','2013-04-04','09:10:00',1.35),('8998','2013-04-04','09:15:00',2.36),('8998','2013-04-04','09:20:00',1.87),('8998','2013-04-04','09:35:00',1.11),('8998','2013-04-04','09:40:00',1.88),('8998','2013-04-04','09:45:00',1.9),('8998','2013-04-04','10:00:00',1.01),('8998','2013-04-04','10:10:00',1.82),('8998','2013-04-04','10:15:00',2.73),('8998','2013-04-04','10:20:00',1.03),('8998','2013-04-04','10:25:00',2.07),('8998','2013-04-04','10:30:00',2.06),('8998','2013-04-04','10:35:00',1.86),('8998','2013-04-04','10:40:00',2.81),('8998','2013-04-04','10:45:00',1.69),('8998','2013-04-04','10:50:00',1.71),('8998','2013-04-04','10:55:00',1.92),('8998','2013-04-04','11:00:00',1.93),('8998','2013-04-04','11:05:00',2.57),('8998','2013-04-04','11:10:00',3.21),('8998','2013-04-04','11:15:00',3.15),('8998','2013-04-04','11:20:00',2.17),('8998','2013-04-04','11:25:00',2.49),('8998','2013-04-04','11:30:00',2.35),('8998','2013-04-04','11:35:00',3.18),('8998','2013-04-04','11:40:00',2.93),('8998','2013-04-04','11:45:00',2.8),('8998','2013-04-04','11:50:00',2.18),('8998','2013-04-04','11:55:00',2.68),('8998','2013-04-04','12:00:00',3.23),('8998','2013-04-04','12:05:00',2.47),('8998','2013-04-04','12:10:00',2.44),('8998','2013-04-04','12:15:00',1.34),('8998','2013-04-04','12:20:00',1.09),('8998','2013-04-04','12:25:00',1.4),('8998','2013-04-04','12:40:00',1.12),('8998','2013-04-04','12:45:00',2.44),('8998','2013-04-04','12:50:00',2.96),('8998','2013-04-04','12:55:00',3),('8998','2013-04-04','13:00:00',1.88),('8998','2013-04-04','13:05:00',2.6),('8998','2013-04-04','13:10:00',1.77),('8998','2013-04-04','13:15:00',1.71),('8998','2013-04-04','13:20:00',1.51),('8998','2013-04-04','13:25:00',2.05),('8998','2013-04-04','13:30:00',1.64),('8998','2013-04-04','13:35:00',2.11),('8998','2013-04-04','13:40:00',2.83),('8998','2013-04-04','13:45:00',1.79),('8998','2013-04-04','13:50:00',2.89),('8998','2013-04-04','13:55:00',2.55),('8998','2013-04-04','14:00:00',1.7),('8998','2013-04-04','14:05:00',2.96),('8998','2013-04-04','14:10:00',2.28),('8998','2013-04-04','14:15:00',2.08),('8998','2013-04-04','14:20:00',2.44),('8998','2013-04-04','14:25:00',2.41),('8998','2013-04-04','14:30:00',2.47),('8998','2013-04-04','14:35:00',2.28),('8998','2013-04-04','14:40:00',2.29),('8998','2013-04-04','14:45:00',2.11),('8998','2013-04-04','14:50:00',1.32),('8998','2013-04-04','14:55:00',2.58),('8998','2013-04-04','15:00:00',2.19),('8998','2013-04-04','15:05:00',2.06),('8998','2013-04-04','15:10:00',1.98),('8998','2013-04-04','15:15:00',1.15),('8998','2013-04-04','15:20:00',1.17),('8998','2013-04-04','15:25:00',1.35),('8998','2013-04-04','15:30:00',1.15),('8998','2013-04-04','15:35:00',1.01),('8998','2013-04-04','15:50:00',1.12),('8998','2013-04-04','15:55:00',1.08),('8998','2013-04-04','16:00:00',1.15),('8998','2013-04-04','16:05:00',1.04),('8998','2013-04-04','16:15:00',1.32),('8998','2013-04-04','16:20:00',1.13),('8998','2013-04-04','16:25:00',1.12),('8998','2013-04-04','16:45:00',1.03),('8998','2013-04-04','16:50:00',1.35),('8998','2013-04-03','08:55:00',1.08),('8998','2013-04-03','09:00:00',1.82),('8998','2013-04-03','09:05:00',1.22),('8998','2013-04-03','09:20:00',1.1),('8998','2013-04-03','09:30:00',1.18),('8998','2013-04-03','09:35:00',2.18),('8998','2013-04-03','09:40:00',1.99),('8998','2013-04-03','09:45:00',1.67),('8998','2013-04-03','10:00:00',1.39),('8998','2013-04-03','10:05:00',1.99),('8998','2013-04-03','10:10:00',1.92),('8998','2013-04-03','10:15:00',1.28),('8998','2013-04-03','10:20:00',1.29),('8998','2013-04-03','10:25:00',2.67),('8998','2013-04-03','10:30:00',2.64),('8998','2013-04-03','10:35:00',1.59),('8998','2013-04-03','10:40:00',3.14),('8998','2013-04-03','10:45:00',1.73),('8998','2013-04-03','10:50:00',1.82),('8998','2013-04-03','10:55:00',2.82),('8998','2013-04-03','11:00:00',1.7),('8998','2013-04-03','11:15:00',1),('8998','2013-04-03','11:20:00',1.02),('8998','2013-04-03','11:35:00',1.09),('8998','2013-04-03','11:40:00',1.99),('8998','2013-04-03','11:45:00',2.47),('8998','2013-04-03','11:50:00',2.85),('8998','2013-04-03','11:55:00',2.96),('8998','2013-04-03','12:00:00',2.94),('8998','2013-04-03','12:05:00',2.83),('8998','2013-04-03','12:10:00',2.9),('8998','2013-04-03','12:15:00',2.82),('8998','2013-04-03','12:20:00',2.57),('8998','2013-04-03','12:25:00',2.1),('8998','2013-04-03','12:30:00',2.06),('8998','2013-04-03','12:35:00',1.5),('8998','2013-04-03','12:40:00',2.54),('8998','2013-04-03','12:45:00',1.8),('8998','2013-04-03','12:50:00',2.55),('8998','2013-04-03','12:55:00',2.68),('8998','2013-04-03','13:00:00',2.58),('8998','2013-04-03','13:05:00',2.67),('8998','2013-04-03','13:10:00',2.75),('8998','2013-04-03','13:15:00',2.84),('8998','2013-04-03','13:20:00',2.71),('8998','2013-04-03','13:25:00',2.76),('8998','2013-04-03','13:30:00',2.68),('8998','2013-04-03','13:35:00',2.45),('8998','2013-04-03','13:40:00',2.02),('8998','2013-04-03','13:45:00',2.03),('8998','2013-04-03','13:50:00',2.01),('8998','2013-04-03','13:55:00',1.58),('8998','2013-04-03','14:00:00',1.67),('8998','2013-04-03','14:05:00',2.21),('8998','2013-04-03','14:10:00',2.5),('8998','2013-04-03','14:15:00',2.43),('8998','2013-04-03','14:20:00',2.31),('8998','2013-04-03','14:25:00',2.2),('8998','2013-04-03','14:30:00',2.16),('8998','2013-04-03','14:35:00',2.12),('8998','2013-04-03','14:40:00',2.1),('8998','2013-04-03','14:45:00',2.05),('8998','2013-04-03','14:50:00',1.99),('8998','2013-04-03','14:55:00',1.96),('8998','2013-04-03','15:00:00',1.9),('8998','2013-04-03','15:05:00',1.81),('8998','2013-04-03','15:10:00',1.71),('8998','2013-04-03','15:15:00',1.66),('8998','2013-04-03','15:20:00',1.67),('8998','2013-04-03','15:25:00',1.67),('8998','2013-04-03','15:30:00',1.64),('8998','2013-04-03','15:35:00',1.58),('8998','2013-04-03','15:40:00',1.52),('8998','2013-04-03','15:45:00',1.48),('8998','2013-04-03','15:50:00',1.39),('8998','2013-04-03','15:55:00',1.33),('8998','2013-04-03','16:00:00',1.27),('8998','2013-04-03','16:05:00',1.22),('8998','2013-04-03','16:10:00',1.13),('8998','2013-04-03','16:15:00',1.13),('8998','2013-04-03','16:20:00',1.07),('8998','2013-04-03','16:25:00',1.05),('8998','2013-04-02','08:15:00',1.01),('8998','2013-04-02','08:20:00',1.02),('8998','2013-04-02','08:25:00',1.39),('8998','2013-04-02','08:30:00',1.63),('8998','2013-04-02','08:35:00',1.88),('8998','2013-04-02','08:40:00',1.82),('8998','2013-04-02','08:45:00',1.93),('8998','2013-04-02','09:00:00',1.55),('8998','2013-04-02','09:05:00',2.28),('8998','2013-04-02','09:10:00',2.37),('8998','2013-04-02','09:15:00',2.44),('8998','2013-04-02','09:20:00',2.45),('8998','2013-04-02','09:25:00',1.34),('8998','2013-04-02','09:30:00',1.76),('8998','2013-04-02','09:35:00',1.37),('8998','2013-04-02','09:40:00',2.84),('8998','2013-04-02','09:45:00',1.91),('8998','2013-04-02','09:50:00',2.81),('8998','2013-04-02','09:55:00',2.89),('8998','2013-04-02','10:00:00',2.99),('8998','2013-04-02','10:15:00',1.18),('8998','2013-04-02','10:20:00',2.45),('8998','2013-04-02','10:25:00',2.82),('8998','2013-04-02','10:30:00',1.88),('8998','2013-04-02','10:35:00',1.67),('8998','2013-04-02','10:40:00',1.34),('8998','2013-04-02','10:45:00',1.3),('8998','2013-04-02','10:50:00',1.34),('8998','2013-04-02','10:55:00',2.43),('8998','2013-04-02','11:00:00',1.34),('8998','2013-04-02','11:05:00',3.52),('8998','2013-04-02','11:10:00',1.76),('8998','2013-04-02','11:15:00',2.17),('8998','2013-04-02','11:20:00',1.59),('8998','2013-04-02','11:25:00',1.98),('8998','2013-04-02','11:30:00',1.34),('8998','2013-04-02','11:35:00',1.04),('8998','2013-04-02','11:40:00',1.65),('8998','2013-04-02','11:50:00',1.84),('8998','2013-04-02','11:55:00',1.62),('8998','2013-04-02','12:00:00',2.8),('8998','2013-04-02','12:05:00',2.16),('8998','2013-04-02','12:10:00',3.34),('8998','2013-04-02','12:15:00',1.19),('8998','2013-04-02','12:20:00',2.46),('8998','2013-04-02','12:25:00',2.28),('8998','2013-04-02','12:30:00',2.91),('8998','2013-04-02','12:35:00',2.46),('8998','2013-04-02','12:40:00',2.67),('8998','2013-04-02','12:45:00',2.97),('8998','2013-04-02','12:50:00',3.11),('8998','2013-04-02','12:55:00',2.94),('8998','2013-04-02','13:00:00',2.99),('8998','2013-04-02','13:05:00',2.02),('8998','2013-04-02','13:10:00',1.58),('8998','2013-04-02','13:15:00',2.95),('8998','2013-04-02','13:20:00',2.09),('8998','2013-04-02','13:25:00',1.78),('8998','2013-04-02','13:30:00',1.7),('8998','2013-04-02','13:35:00',2.44),('8998','2013-04-02','13:40:00',2.18),('8998','2013-04-02','13:45:00',2.52),('8998','2013-04-02','13:50:00',2.16),('8998','2013-04-02','13:55:00',2.69),('8998','2013-04-02','14:00:00',2.7),('8998','2013-04-02','14:05:00',1.76),('8998','2013-04-02','14:10:00',1.62),('8998','2013-04-02','14:15:00',2.11),('8998','2013-04-02','14:20:00',1.51),('8998','2013-04-02','14:25:00',2.13),('8998','2013-04-02','14:30:00',1.94),('8998','2013-04-02','14:35:00',2.32),('8998','2013-04-02','14:40:00',2.31),('8998','2013-04-02','14:45:00',1.91),('8998','2013-04-02','14:55:00',1.29),('8998','2013-04-02','15:00:00',2.5),('8998','2013-04-02','15:05:00',2.19),('8998','2013-04-02','15:10:00',2.31),('8998','2013-04-02','15:15:00',2.21),('8998','2013-04-02','15:20:00',2.11),('8998','2013-04-02','15:25:00',2.05),('8998','2013-04-02','15:30:00',1.91),('8998','2013-04-02','15:35:00',1.84),('8998','2013-04-02','15:40:00',1.85),('8998','2013-04-02','15:45:00',1.54),('8998','2013-04-02','15:50:00',1.62),('8998','2013-04-02','15:55:00',1.45),('8998','2013-04-02','16:00:00',1.51),('8998','2013-04-02','16:05:00',1.38),('8998','2013-04-02','16:10:00',1.3),('8998','2013-04-02','16:15:00',1.21),('8998','2013-04-02','16:20:00',1.12),('8998','2013-04-02','16:25:00',1.05),('8998','2013-04-01','08:40:00',1.38),('8998','2013-04-01','08:45:00',1.8),('8998','2013-04-01','08:50:00',1.44),('8998','2013-04-01','09:00:00',2.08),('8998','2013-04-01','09:05:00',2.15),('8998','2013-04-01','09:10:00',2.26),('8998','2013-04-01','09:15:00',2.39),('8998','2013-04-01','09:20:00',2.06),('8998','2013-04-01','09:30:00',2.67),('8998','2013-04-01','09:35:00',2.55),('8998','2013-04-01','09:40:00',1.84),('8998','2013-04-01','09:45:00',2.53),('8998','2013-04-01','09:50:00',1.74),('8998','2013-04-01','09:55:00',1.64),('8998','2013-04-01','10:00:00',1.83),('8998','2013-04-01','10:05:00',1.34),('8998','2013-04-01','10:10:00',1.34),('8998','2013-04-01','10:20:00',1.61),('8998','2013-04-01','10:25:00',1.47),('8998','2013-04-01','10:35:00',1.04),('8998','2013-04-01','10:40:00',1.1),('8998','2013-04-01','10:45:00',2.45),('8998','2013-04-01','10:50:00',3.13),('8998','2013-04-01','10:55:00',1.29),('8998','2013-04-01','11:05:00',1.93),('8998','2013-04-01','11:10:00',1.86),('8998','2013-04-01','11:35:00',1.17),('8998','2013-04-01','11:45:00',1.1),('8998','2013-04-01','11:50:00',1.31),('8998','2013-04-01','11:55:00',1.17),('8998','2013-04-01','12:05:00',1.57),('8998','2013-04-01','12:10:00',1.68),('8998','2013-04-01','12:15:00',2.06),('8998','2013-04-01','12:35:00',1.15),('8998','2013-04-01','12:40:00',1.77),('8998','2013-04-01','12:45:00',1.46),('8998','2013-04-01','12:50:00',1.55),('8998','2013-04-01','12:55:00',1.49),('8998','2013-04-01','13:00:00',1.53),('8998','2013-04-01','13:05:00',1.64),('8998','2013-04-01','13:10:00',2.29),('8998','2013-04-01','13:15:00',1.76),('8998','2013-04-01','13:20:00',1.38),('8998','2013-04-01','13:25:00',2.22),('8998','2013-04-01','13:30:00',2.02),('8998','2013-04-01','13:35:00',1.42),('8998','2013-04-01','13:40:00',1.64),('8998','2013-04-01','13:45:00',1.77),('8998','2013-04-01','13:50:00',1.51),('8998','2013-04-01','13:55:00',1.12),('8998','2013-04-01','14:00:00',1.65),('8998','2013-04-01','14:05:00',1.44),('8998','2013-04-01','14:10:00',2.24),('8998','2013-04-01','14:15:00',1.72),('8998','2013-04-01','14:20:00',2.53),('8998','2013-04-01','14:25:00',3.02),('8998','2013-04-01','14:30:00',2.22),('8998','2013-04-01','14:35:00',1.27),('8998','2013-04-01','14:40:00',1.5),('8998','2013-04-01','14:45:00',1.54),('8998','2013-04-01','14:50:00',1.4),('8998','2013-04-01','14:55:00',1.14),('8998','2013-04-01','15:00:00',1.13),('8998','2014-05-01','07:40:00',1.24),('8998','2014-05-01','07:45:00',1.14),('8998','2014-05-01','07:50:00',1.22),('8998','2014-05-01','08:00:00',1.47),('8998','2014-05-01','08:05:00',1.55),('8998','2014-05-01','08:15:00',1.34),('8998','2014-05-01','08:20:00',2.15),('8998','2014-05-01','08:25:00',1.08),('8998','2014-05-01','08:30:00',1.08),('8998','2014-05-01','09:25:00',1.04),('8998','2014-05-01','09:30:00',1.41),('8998','2014-05-01','09:35:00',1.45),('8998','2014-05-01','09:40:00',1.05),('8998','2014-05-01','09:45:00',1.04),('8998','2014-05-01','09:50:00',1.12),('8998','2014-05-01','09:55:00',1.02),('8998','2014-05-01','10:00:00',1.34),('8998','2014-05-01','10:05:00',1.23),('8998','2014-05-01','10:10:00',1.4),('8998','2014-05-01','10:15:00',1.2),('8998','2014-05-01','10:20:00',1.15),('8998','2014-05-01','12:50:00',1.09),('8998','2014-05-01','12:55:00',1.17),('8998','2014-05-01','13:05:00',1.16),('8998','2014-05-01','13:10:00',1.29),('8998','2014-05-01','13:15:00',1.5),('8998','2014-05-01','13:20:00',2.14),('8998','2014-05-01','13:25:00',1.93),('8998','2014-05-01','13:30:00',1.7),('8998','2014-05-01','13:35:00',1.58),('8998','2014-05-01','13:40:00',1.76),('8998','2014-05-01','13:45:00',1.42),('8998','2014-05-01','13:50:00',1.11),('8998','2014-05-01','14:10:00',1.09),('8998','2014-05-01','14:40:00',2.16),('8998','2014-05-01','14:45:00',1.64),('8998','2014-05-01','14:50:00',1.01),('8998','2014-05-01','14:55:00',1.22),('8998','2014-05-01','15:00:00',1.52),('8998','2014-05-01','15:05:00',1.34),('8998','2014-05-01','15:10:00',2.03),('8998','2014-05-01','15:15:00',2.83),('8998','2014-05-01','15:20:00',1.35),('8998','2014-05-01','15:25:00',1.19),('8998','2014-05-01','15:35:00',1.36),('8998','2014-05-01','15:40:00',2.02),('8998','2014-05-01','15:45:00',1.04),('8998','2014-05-01','16:05:00',1.23),('8998','2014-05-01','16:20:00',1.54),('8998','2014-03-26','08:00:00',1),('8998','2014-03-26','10:20:00',1.05),('8998','2014-03-26','10:25:00',1.33),('8998','2014-03-26','10:30:00',1.63),('8998','2014-03-26','10:35:00',1.34),('8998','2014-03-26','10:40:00',1.74),('8998','2014-03-26','10:45:00',1.17),('8998','2014-03-26','11:10:00',1.7),('8998','2014-03-26','11:15:00',2.19),('8998','2014-03-26','11:20:00',1.81),('8998','2014-03-26','12:10:00',1.12),('8998','2014-03-26','13:15:00',1.28),('8998','2014-03-26','13:20:00',1.48),('8998','2014-03-26','13:25:00',1.62),('8998','2014-03-26','13:30:00',1.47),('8998','2014-03-26','13:35:00',1.33),('8998','2014-03-26','13:40:00',1.25),('8998','2014-03-26','13:45:00',1.13),('8998','2014-03-26','13:50:00',1.28),('8998','2014-03-26','13:55:00',1.64),('8998','2014-03-26','14:00:00',1.42),('8998','2014-03-26','14:15:00',1.29),('8998','2014-03-26','14:20:00',2.1),('8998','2014-03-26','14:25:00',1.92),('8998','2014-03-26','14:30:00',2.04),('8998','2014-03-26','14:35:00',1.39),('8998','2014-03-26','14:40:00',1.16),('8998','2014-03-26','14:45:00',1.1),('8998','2014-03-26','14:50:00',1.38),('8998','2014-03-26','14:55:00',1.56),('8998','2014-03-26','15:00:00',1.27),('8998','2014-03-26','15:25:00',1.37),('8998','2014-03-26','15:30:00',1.36),('8998','2013-03-31','08:25:00',1.12),('8998','2013-03-31','08:30:00',1.56),('8998','2013-03-31','08:35:00',1.77),('8998','2013-03-31','08:40:00',1.94),('8998','2013-03-31','08:50:00',1.22),('8998','2013-03-31','08:55:00',1.69),('8998','2013-03-31','09:00:00',2.08),('8998','2013-03-31','09:05:00',2.14),('8998','2013-03-31','09:10:00',2.28),('8998','2013-03-31','09:15:00',2.32),('8998','2013-03-31','09:20:00',1.88),('8998','2013-03-31','09:25:00',2.11),('8998','2013-03-31','09:30:00',2.4),('8998','2013-03-31','09:35:00',1.2),('8998','2013-03-31','09:40:00',2.49),('8998','2013-03-31','09:45:00',1.81),('8998','2013-03-31','09:50:00',2.33),('8998','2013-03-31','09:55:00',2.37),('8998','2013-03-31','10:00:00',2.54),('8998','2013-03-31','10:05:00',2.65),('8998','2013-03-31','10:10:00',2.34),('8998','2013-03-31','10:15:00',1.95),('8998','2013-03-31','10:20:00',2.5),('8998','2013-03-31','10:25:00',2.36),('8998','2013-03-31','10:30:00',1.97),('8998','2013-03-31','10:35:00',1.07),('8998','2013-03-31','10:40:00',1.73),('8998','2013-03-31','10:45:00',2.99),('8998','2013-03-31','10:50:00',1.97),('8998','2013-03-31','11:00:00',1.15),('8998','2013-03-31','11:10:00',1.72),('8998','2013-03-31','11:15:00',2.55),('8998','2013-03-31','11:20:00',1.91),('8998','2013-03-31','11:25:00',2.02),('8998','2013-03-31','11:30:00',1.19),('8998','2013-03-31','11:35:00',1.36),('8998','2013-03-31','11:40:00',2.2),('8998','2013-03-31','11:45:00',2.35),('8998','2013-03-31','11:50:00',1.94),('8998','2013-03-31','11:55:00',1.58),('8998','2013-03-31','12:00:00',2.15),('8998','2013-03-31','12:05:00',1.4),('8998','2013-03-31','12:10:00',1.62),('8998','2013-03-31','12:15:00',1.55),('8998','2013-03-31','12:20:00',1.29),('8998','2013-03-31','12:25:00',1.33),('8998','2013-03-31','12:30:00',1.78),('8998','2013-03-31','12:35:00',1.66),('8998','2013-03-31','12:40:00',1.63),('8998','2013-03-31','12:45:00',1.84),('8998','2013-03-31','12:50:00',1.93),('8998','2013-03-31','12:55:00',2.17),('8998','2013-03-31','13:00:00',2.07),('8998','2013-03-31','13:05:00',2.27),('8998','2013-03-31','13:10:00',2.11),('8998','2013-03-31','13:15:00',2),('8998','2013-03-31','13:20:00',1.93),('8998','2013-03-31','13:25:00',1.76),('8998','2013-03-31','13:30:00',2.04),('8998','2013-03-31','13:35:00',1.77),('8998','2013-03-31','13:40:00',2.07),('8998','2013-03-31','13:45:00',2.37),('8998','2013-03-31','13:50:00',2.65),('8998','2013-03-31','13:55:00',2.79),('8998','2013-03-31','14:00:00',1.66),('8998','2013-03-31','14:05:00',1.25),('8998','2013-03-31','14:10:00',1.49),('8998','2013-03-31','14:15:00',1.69),('8998','2013-03-31','14:20:00',1.7),('8998','2013-03-31','14:25:00',2.6),('8998','2013-03-31','14:30:00',1.88),('8998','2013-03-31','14:35:00',1.43),('8998','2013-03-31','14:40:00',1.3),('8998','2013-03-31','14:45:00',1.24),('8998','2013-03-31','14:50:00',1.34),('8998','2013-03-31','14:55:00',1.47),('8998','2013-03-31','15:00:00',1.33),('8998','2013-03-31','15:05:00',1.33),('8998','2013-03-31','15:10:00',1.35),('8998','2013-03-31','15:15:00',1.43),('8998','2013-03-31','15:20:00',1.43),('8998','2013-03-31','15:25:00',1.39),('8998','2013-03-31','15:30:00',1.17),('8998','2013-03-31','15:35:00',1.43),('8998','2013-03-31','15:40:00',1.38),('8998','2013-03-31','15:45:00',1.4),('8998','2013-03-31','15:50:00',1.58),('8998','2013-03-31','15:55:00',1.31),('8998','2013-03-31','16:00:00',1.18),('8998','2013-03-31','16:05:00',1),('8998','2013-03-30','08:45:00',1.1),('8998','2013-03-30','09:20:00',2.06),('8998','2013-03-30','09:25:00',2.74),('8998','2013-03-30','09:30:00',2.18),('8998','2013-03-30','09:35:00',2.03),('8998','2013-03-30','09:40:00',1.29),('8998','2013-03-30','09:45:00',2.52),('8998','2013-03-30','09:50:00',1.11),('8998','2013-03-30','09:55:00',1.5),('8998','2013-03-30','10:00:00',2.16),('8998','2013-03-30','10:20:00',1.54),('8998','2013-03-30','10:25:00',2.31),('8998','2013-03-30','10:30:00',1.92),('8998','2013-03-30','10:35:00',2.12),('8998','2013-03-30','10:50:00',1.38),('8998','2013-03-30','10:55:00',1.02),('8998','2013-03-30','11:25:00',1.1),('8998','2013-03-30','11:35:00',1.05),('8998','2013-03-30','11:40:00',1.26),('8998','2013-03-30','11:45:00',1.07),('8998','2013-03-30','11:50:00',1.07),('8998','2013-03-30','11:55:00',1.17),('8998','2013-03-30','12:00:00',1.06),('8998','2013-03-30','12:30:00',1.16),('8998','2013-03-30','12:35:00',1.95),('8998','2013-03-30','12:40:00',2.39),('8998','2013-03-30','12:45:00',1.32),('8998','2013-03-30','12:50:00',1.08),('8998','2013-03-30','12:55:00',1.32),('8998','2013-03-30','13:00:00',1.64),('8998','2013-03-30','13:05:00',1.42),('8998','2013-03-30','13:10:00',1.79),('8998','2013-03-30','13:15:00',2.03),('8998','2013-03-30','13:20:00',2.68),('8998','2013-03-30','13:25:00',2.16),('8998','2013-03-30','13:45:00',1.37),('8998','2013-03-30','13:50:00',1.26),('8998','2013-03-30','13:55:00',1.03),('8998','2013-03-30','14:00:00',1.3),('8998','2013-03-30','14:05:00',2.23),('8998','2013-03-30','14:10:00',1.5),('8998','2013-03-30','14:15:00',1.89),('8998','2013-03-30','14:20:00',1.17),('8998','2013-03-30','14:25:00',1.11),('8998','2013-03-30','14:30:00',1.34),('8998','2013-03-30','14:35:00',2.4),('8998','2013-03-30','14:40:00',2.53),('8998','2013-03-30','14:45:00',2.12),('8998','2013-03-30','14:50:00',2.17),('8998','2013-03-30','14:55:00',1.55),('8998','2013-03-30','15:00:00',1.75),('8998','2013-03-30','15:05:00',1.23),('8998','2013-03-30','15:10:00',1.89),('8998','2013-03-30','15:15:00',1.51),('8998','2013-03-30','15:20:00',2.15),('8998','2013-03-30','15:25:00',1.68),('8998','2013-03-30','15:30:00',1.52),('8998','2013-03-30','15:35:00',1.39),('8998','2013-03-30','15:40:00',1.87),('8998','2013-03-30','15:45:00',1.39),('8998','2013-03-30','16:00:00',1.12),('8998','2013-03-30','16:15:00',1.08),('8998','2013-03-30','16:20:00',1.23),('8998','2013-03-30','16:25:00',1.05),('8998','2013-03-30','17:05:00',1.01),('8998','2013-03-29','09:05:00',1.53),('8998','2013-03-29','09:10:00',1.12),('8998','2013-03-29','09:15:00',1.08),('8998','2013-03-29','09:20:00',2.76),('8998','2013-03-29','09:25:00',2.12),('8998','2013-03-29','09:30:00',1.04),('8998','2013-03-29','09:35:00',1.38),('8998','2013-03-29','09:40:00',1.08),('8998','2013-03-29','10:00:00',1.02),('8998','2013-03-29','10:05:00',1.06),('8998','2013-03-29','10:10:00',1.3),('8998','2013-03-29','10:15:00',1.29),('8998','2013-03-29','10:20:00',1.09),('8998','2013-03-29','10:25:00',1.03),('8998','2013-03-29','10:30:00',1.16),('8998','2013-03-29','10:35:00',1.39),('8998','2013-03-29','10:40:00',1.77),('8998','2013-03-29','10:45:00',2.53),('8998','2013-03-29','10:50:00',2.6),('8998','2013-03-29','10:55:00',1.71),('8998','2013-03-29','11:00:00',2.31),('8998','2013-03-29','11:05:00',2.99),('8998','2013-03-29','11:10:00',3.41),('8998','2013-03-29','11:15:00',3.06),('8998','2013-03-29','11:20:00',3.76),('8998','2013-03-29','11:25:00',3.42),('8998','2013-03-29','11:30:00',2.26),('8998','2013-03-29','11:35:00',2.01),('8998','2013-03-29','11:40:00',1.33),('8998','2013-03-29','11:45:00',2.14),('8998','2013-03-29','11:50:00',2.86),('8998','2013-03-29','11:55:00',2.41),('8998','2013-03-29','12:00:00',3.39),('8998','2013-03-29','12:05:00',1.83),('8998','2013-03-29','12:10:00',1.44),('8998','2013-03-29','12:15:00',1.35),('8998','2013-03-29','12:20:00',1.4),('8998','2013-03-29','12:25:00',1.04),('8998','2013-03-29','13:15:00',1.53),('8998','2013-03-29','13:20:00',2.27),('8998','2013-03-29','13:50:00',1.54),('8998','2013-03-29','13:55:00',1.96),('8998','2013-03-29','14:00:00',1.82),('8998','2013-03-29','14:05:00',1.63),('8998','2013-03-29','14:20:00',1.39),('8998','2013-03-29','14:25:00',1.01),('8998','2013-03-29','14:30:00',1.1),('8998','2013-03-29','14:35:00',1.16),('8998','2013-03-29','14:50:00',1.07),('8998','2013-03-28','07:25:00',1.06),('8998','2013-03-28','07:30:00',1.17),('8998','2013-03-28','07:35:00',1.28),('8998','2013-03-28','07:40:00',1.5),('8998','2013-03-28','07:45:00',1.72),('8998','2013-03-28','07:50:00',1.61),('8998','2013-03-28','08:00:00',1.28),('8998','2013-03-28','08:05:00',1.77),('8998','2013-03-28','08:10:00',2.1),('8998','2013-03-28','08:15:00',2.12),('8998','2013-03-28','08:20:00',2.17),('8998','2013-03-28','08:25:00',2.2),('8998','2013-03-28','08:30:00',2.25),('8998','2013-03-28','08:35:00',2.32),('8998','2013-03-28','08:40:00',2.36),('8998','2013-03-28','08:45:00',2.33),('8998','2013-03-28','08:50:00',2.28),('8998','2013-03-28','08:55:00',2.24),('8998','2013-03-28','09:00:00',2.16),('8998','2013-03-28','09:05:00',2.32),('8998','2013-03-28','09:10:00',2.39),('8998','2013-03-28','09:15:00',2.65),('8998','2013-03-28','09:20:00',2.76),('8998','2013-03-28','09:25:00',2.53),('8998','2013-03-28','09:30:00',2.81),('8998','2013-03-28','09:35:00',2.83),('8998','2013-03-28','09:40:00',2.66),('8998','2013-03-28','09:45:00',2.53),('8998','2013-03-28','09:50:00',2.76),('8998','2013-03-28','09:55:00',2.65),('8998','2013-03-28','10:00:00',2.69),('8998','2013-03-28','10:05:00',2.31),('8998','2013-03-28','10:10:00',2.1),('8998','2013-03-28','10:15:00',2.61),('8998','2013-03-28','10:20:00',2.39),('8998','2013-03-28','10:25:00',2.41),('8998','2013-03-28','10:30:00',2.38),('8998','2013-03-28','10:35:00',2.05),('8998','2013-03-28','10:40:00',2.33),('8998','2013-03-28','10:45:00',1.52),('8998','2013-03-28','10:50:00',2.18),('8998','2013-03-28','10:55:00',2.07),('8998','2013-03-28','11:00:00',2.94),('8998','2013-03-28','11:05:00',2.91),('8998','2013-03-28','11:10:00',3.24),('8998','2013-03-28','11:15:00',2.29),('8998','2013-03-28','11:20:00',1.42),('8998','2013-03-28','11:25:00',1.68),('8998','2013-03-28','11:30:00',3.26),('8998','2013-03-28','11:35:00',2.32),('8998','2013-03-28','11:40:00',2.99),('8998','2013-03-28','11:45:00',2.92),('8998','2013-03-28','11:50:00',2.9),('8998','2013-03-28','11:55:00',2.88),('8998','2013-03-28','12:00:00',2.86),('8998','2013-03-28','12:05:00',2.93),('8998','2013-03-28','12:10:00',2.88),('8998','2013-03-28','12:15:00',2.66),('8998','2013-03-28','12:20:00',2.82),('8998','2013-03-28','12:25:00',2.64),('8998','2013-03-28','12:30:00',2.46),('8998','2013-03-28','12:35:00',2.58),('8998','2013-03-28','12:40:00',2.72),('8998','2013-03-28','12:45:00',2.36),('8998','2013-03-28','12:50:00',2.18),('8998','2013-03-28','12:55:00',1.93),('8998','2013-03-28','13:00:00',2.42),('8998','2013-03-28','13:05:00',1.65),('8998','2013-03-28','13:10:00',2.41),('8998','2013-03-28','13:15:00',2.11),('8998','2013-03-28','13:20:00',2.17),('8998','2013-03-28','13:25:00',2.64),('8998','2013-03-28','13:30:00',2.33),('8998','2013-03-28','13:35:00',1.98),('8998','2013-03-28','13:40:00',2.01),('8998','2013-03-28','13:45:00',1.92),('8998','2013-03-28','13:50:00',2.01),('8998','2013-03-28','13:55:00',1.97),('8998','2013-03-28','14:00:00',1.98),('8998','2013-03-28','14:05:00',1.72),('8998','2013-03-28','14:10:00',1.38),('8998','2013-03-28','14:15:00',1.4),('8998','2013-03-28','14:20:00',1.4),('8998','2013-03-28','14:25:00',1.41),('8998','2013-03-28','14:30:00',1.26),('8998','2013-03-28','14:35:00',1.27),('8998','2013-03-28','14:40:00',1.24),('8998','2013-03-28','14:45:00',1.2),('8998','2013-03-28','14:50:00',1.15),('8998','2013-03-28','14:55:00',1.12),('8998','2013-03-28','15:00:00',1.04),('8998','2013-03-28','15:05:00',1.03),('8998','2013-03-27','09:10:00',1.03),('8998','2013-03-27','09:15:00',2.42),('8998','2013-03-27','09:20:00',1.3),('8998','2013-03-27','09:25:00',1.15),('8998','2013-03-27','11:40:00',1.23),('8998','2013-03-27','11:55:00',1.35),('8998','2013-03-27','12:00:00',1.22),('8998','2013-03-27','12:45:00',1.11),('8998','2013-03-27','12:50:00',1.95),('8998','2013-03-27','12:55:00',2.32),('8998','2013-03-27','13:00:00',2.13),('8998','2013-03-27','13:05:00',2.72),('8998','2013-03-27','13:10:00',2.01),('8998','2013-03-27','13:15:00',2.11),('8998','2013-03-27','13:20:00',2.25),('8998','2013-03-27','13:25:00',1.97),('8998','2013-03-27','13:30:00',2.17),('8998','2013-03-27','13:35:00',1.67),('8998','2013-03-27','13:40:00',1.46),('8998','2013-03-27','13:45:00',1.33),('8998','2013-03-27','13:50:00',2.05),('8998','2013-03-27','13:55:00',1.09),('8998','2013-03-27','14:00:00',1.24),('8998','2013-03-27','14:05:00',1.64),('8998','2013-03-27','14:10:00',1.31),('8998','2013-03-27','14:15:00',1.04),('8998','2013-03-27','14:30:00',1.19),('8998','2013-03-27','14:35:00',1.17),('8998','2013-03-27','15:10:00',1.2),('8998','2013-03-27','15:15:00',1.44),('8998','2013-03-27','15:20:00',1.04),('8998','2013-03-27','15:25:00',1.07),('8998','2013-03-27','15:35:00',1.01),('8998','2013-03-27','15:55:00',1.11),('8998','2013-03-26','07:30:00',1.02),('8998','2013-03-26','07:35:00',1.21),('8998','2013-03-26','07:40:00',1.28),('8998','2013-03-26','07:55:00',1.14),('8998','2013-03-26','08:00:00',1.14),('8998','2013-03-26','08:05:00',1.37),('8998','2013-03-26','08:10:00',1.12),('8998','2013-03-26','08:15:00',1.25),('8998','2013-03-26','08:20:00',1.11),('8998','2013-03-26','08:25:00',1.28),('8998','2013-03-26','08:30:00',1.73),('8998','2013-03-26','08:35:00',1.7),('8998','2013-03-26','08:40:00',1.27),('8998','2013-03-26','08:45:00',1.09),('8998','2013-03-26','08:50:00',1.47),('8998','2013-03-26','08:55:00',1.11),('8998','2013-03-26','09:00:00',1.16),('8998','2013-03-26','09:15:00',1.23),('8998','2013-03-26','09:20:00',1.64),('8998','2013-03-26','09:45:00',1.09),('8998','2013-03-26','09:50:00',1.73),('8998','2013-03-26','09:55:00',1.49),('8998','2013-03-26','10:00:00',1.07),('8998','2013-03-26','10:15:00',1.33),('8998','2013-03-26','10:20:00',1.12),('8998','2013-03-26','10:25:00',1.31),('8998','2013-03-26','10:30:00',1.65),('8998','2013-03-26','10:35:00',1.34),('8998','2013-03-26','10:40:00',1.3),('8998','2013-03-26','10:45:00',1.63),('8998','2013-03-26','10:50:00',1.41),('8998','2013-03-26','10:55:00',1.35),('8998','2013-03-26','11:00:00',1.13),('8998','2013-03-26','11:05:00',1.11),('8998','2013-03-26','11:10:00',1.23),('8998','2013-03-26','11:15:00',1.29),('8998','2013-03-26','11:20:00',1.35),('8998','2013-03-26','11:25:00',1.24),('8998','2013-03-26','11:30:00',1.41),('8998','2013-03-26','11:35:00',1.36),('8998','2013-03-26','11:40:00',1.36),('8998','2013-03-26','11:45:00',1.24),('8998','2013-03-26','11:50:00',1.2),('8998','2013-03-26','11:55:00',1.76),('8998','2013-03-26','12:00:00',1.99),('8998','2013-03-26','12:05:00',1.94),('8998','2013-03-26','12:10:00',1.78),('8998','2013-03-26','12:15:00',1.33),('8998','2013-03-26','12:20:00',1.3),('8998','2013-03-26','12:25:00',1.18),('8998','2013-03-26','12:30:00',1.98),('8998','2013-03-26','12:35:00',3.11),('8998','2013-03-26','12:40:00',2.61),('8998','2013-03-26','12:45:00',3.33),('8998','2013-03-26','12:50:00',1.85),('8998','2013-03-26','12:55:00',1.74),('8998','2013-03-26','13:00:00',1.21),('8998','2013-03-26','13:05:00',1.16),('8998','2013-03-26','13:10:00',1.44),('8998','2013-03-26','13:15:00',1.26),('8998','2013-03-26','13:20:00',1.07),('8998','2013-03-26','13:30:00',1.17),('8998','2013-03-26','13:35:00',1.41),('8998','2013-03-26','13:40:00',1.31),('8998','2013-03-26','13:45:00',1.45),('8998','2013-03-26','13:50:00',1.61),('8998','2013-03-26','13:55:00',1.61),('8998','2013-03-26','14:00:00',1.23),('8998','2013-03-26','14:05:00',1.04),('8998','2013-03-26','14:10:00',1.09),('8998','2013-03-26','14:15:00',1.22),('8998','2013-03-26','14:20:00',1.43),('8998','2013-03-26','14:25:00',1.18),('8998','2013-03-26','14:30:00',1.04),('8998','2013-03-26','14:35:00',1.04),('8998','2013-03-26','14:40:00',1.3),('8998','2013-03-26','14:45:00',1.3),('8998','2013-03-26','15:10:00',1.11),('8998','2013-03-25','07:50:00',1.28),('8998','2013-03-25','07:55:00',1.76),('8998','2013-03-25','08:40:00',1.07),('8998','2013-03-25','09:55:00',1.89),('8998','2013-03-25','10:00:00',1.25),('8998','2013-03-25','11:10:00',1.77),('8998','2013-03-25','11:15:00',1.24),('8998','2013-03-25','11:20:00',1.1),('8998','2013-03-25','12:20:00',1.07),('8998','2013-03-25','12:25:00',1.67),('8998','2013-03-25','12:30:00',1.6),('8998','2013-03-25','12:35:00',1.94),('8998','2013-03-25','12:40:00',1.24),('8998','2013-03-25','12:45:00',1.95),('8998','2013-03-25','12:50:00',1.49),('8998','2013-03-25','13:05:00',1.61),('8998','2013-03-25','13:10:00',1.48),('8998','2013-03-25','13:15:00',1.48),('8998','2013-03-25','13:20:00',1.08),('8998','2013-03-25','13:25:00',1.48),('8998','2013-03-25','13:30:00',1.12),('8998','2013-03-25','13:35:00',1.29),('8998','2013-03-25','13:40:00',1.48),('8998','2013-03-25','13:45:00',1.35),('8998','2013-03-25','13:50:00',1.23),('8998','2013-03-25','13:55:00',1.12),('8998','2013-03-25','14:00:00',1.1),('8998','2013-03-25','14:05:00',1.05),('8998','2013-03-25','14:10:00',1.08),('8998','2013-03-25','14:15:00',1.03),('8998','2013-03-24','08:25:00',1.64),('8998','2013-03-24','08:30:00',1.08),('8998','2013-03-24','09:20:00',1.9),('8998','2013-03-24','09:25:00',2.59),('8998','2013-03-24','09:30:00',1.34),('8998','2013-03-24','09:50:00',2.24),('8998','2013-03-24','09:55:00',3.08),('8998','2013-03-24','10:00:00',1.92),('8998','2013-03-24','10:25:00',1.66),('8998','2013-03-24','10:30:00',1.89),('8998','2013-03-24','10:40:00',1.23),('8998','2013-03-24','10:45:00',1.76),('8998','2013-03-24','10:50:00',1.48),('8998','2013-03-24','10:55:00',1.72),('8998','2013-03-24','11:00:00',1.61),('8998','2013-03-24','11:05:00',1.39),('8998','2013-03-24','11:10:00',1.36),('8998','2013-03-24','11:15:00',1.34),('8998','2013-03-24','11:20:00',2.78),('8998','2013-03-24','11:25:00',2.56),('8998','2013-03-24','11:30:00',2.11),('8998','2013-03-24','11:35:00',1.78),('8998','2013-03-24','11:40:00',1.11),('8998','2013-03-24','11:45:00',1.24),('8998','2013-03-24','11:50:00',1.24),('8998','2013-03-24','11:55:00',1.87),('8998','2013-03-24','12:00:00',3.1),('8998','2013-03-24','12:05:00',2.54),('8998','2013-03-24','12:10:00',2.61),('8998','2013-03-24','12:15:00',2.88),('8998','2013-03-24','12:20:00',2.03),('8998','2013-03-24','12:25:00',2.47),('8998','2013-03-24','12:30:00',2.6),('8998','2013-03-24','12:35:00',2.07),('8998','2013-03-24','12:40:00',1.66),('8998','2013-03-24','12:45:00',1.78),('8998','2013-03-24','12:50:00',1.98),('8998','2013-03-24','12:55:00',1.94),('8998','2013-03-24','13:00:00',1.57),('8998','2013-03-24','13:05:00',2.8),('8998','2013-03-24','13:10:00',2.39),('8998','2013-03-24','13:15:00',2.31),('8998','2013-03-24','13:20:00',2.6),('8998','2013-03-24','13:25:00',1.69),('8998','2013-03-24','13:30:00',1.33),('8998','2013-03-24','13:45:00',1.23),('8998','2013-03-24','13:50:00',1.47),('8998','2013-03-24','13:55:00',1.31),('8998','2013-03-24','14:10:00',1.63),('8998','2013-03-24','14:15:00',1.39),('8998','2013-03-24','14:20:00',1.36),('8998','2013-03-24','14:25:00',1.74),('8998','2013-03-24','14:30:00',1.94),('8998','2013-03-24','14:35:00',1.34),('8998','2013-03-24','14:55:00',1.35),('8998','2013-03-24','15:00:00',1.25),('8998','2013-03-24','15:05:00',1.17),('8998','2013-03-24','15:10:00',1.09),('8998','2013-03-24','15:15:00',1.02),('8998','2013-03-24','15:20:00',1.24),('8998','2013-03-24','15:25:00',1.45),('8998','2013-03-24','15:30:00',1.12),('8998','2013-03-24','15:35:00',1.28),('8998','2013-03-23','07:45:00',1.04),('8998','2013-03-23','07:50:00',1.3),('8998','2013-03-23','07:55:00',1.48),('8998','2013-03-23','08:00:00',1.77),('8998','2013-03-23','08:05:00',1.84),('8998','2013-03-23','08:10:00',1.85),('8998','2013-03-23','08:15:00',1.97),('8998','2013-03-23','08:20:00',2.04),('8998','2013-03-23','08:25:00',2.13),('8998','2013-03-23','08:30:00',2.17),('8998','2013-03-23','08:35:00',2.21),('8998','2013-03-23','08:40:00',2.25),('8998','2013-03-23','08:45:00',2.27),('8998','2013-03-23','08:50:00',2.28),('8998','2013-03-23','08:55:00',2.31),('8998','2013-03-23','09:00:00',2.34),('8998','2013-03-23','09:05:00',2.4),('8998','2013-03-23','09:10:00',2.45),('8998','2013-03-23','09:15:00',2.47),('8998','2013-03-23','09:20:00',2.5),('8998','2013-03-23','09:25:00',2.52),('8998','2013-03-23','09:30:00',2.53),('8998','2013-03-23','09:35:00',2.55),('8998','2013-03-23','09:40:00',2.57),('8998','2013-03-23','09:45:00',2.59),('8998','2013-03-23','09:50:00',2.63),('8998','2013-03-23','09:55:00',2.63),('8998','2013-03-23','10:00:00',2.65),('8998','2013-03-23','10:05:00',2.68),('8998','2013-03-23','10:10:00',2.7),('8998','2013-03-23','10:15:00',2.71),('8998','2013-03-23','10:20:00',2.71),('8998','2013-03-23','10:25:00',2.71),('8998','2013-03-23','10:30:00',2.71),('8998','2013-03-23','10:35:00',2.71),('8998','2013-03-23','10:40:00',2.7),('8998','2013-03-23','10:45:00',2.7),('8998','2013-03-23','10:50:00',2.7),('8998','2013-03-23','10:55:00',2.7),('8998','2013-03-23','11:00:00',2.69),('8998','2013-03-23','11:05:00',2.69),('8998','2013-03-23','11:10:00',2.7),('8998','2013-03-23','11:15:00',2.69),('8998','2013-03-23','11:20:00',2.68),('8998','2013-03-23','11:25:00',2.68),('8998','2013-03-23','11:30:00',2.68),('8998','2013-03-23','11:35:00',2.66),('8998','2013-03-23','11:40:00',2.64),('8998','2013-03-23','11:45:00',2.62),('8998','2013-03-23','11:50:00',2.62),('8998','2013-03-23','11:55:00',2.6),('8998','2013-03-23','12:00:00',2.6),('8998','2013-03-23','12:05:00',2.58),('8998','2013-03-23','12:10:00',2.58),('8998','2013-03-23','12:15:00',2.58),('8998','2013-03-23','12:20:00',2.58),('8998','2013-03-23','12:25:00',2.58),('8998','2013-03-23','12:30:00',2.56),('8998','2013-03-23','12:35:00',2.55),('8998','2013-03-23','12:40:00',2.51),('8998','2013-03-23','12:45:00',2.49),('8998','2013-03-23','12:50:00',2.47),('8998','2013-03-23','12:55:00',2.43),('8998','2013-03-23','13:00:00',2.38),('8998','2013-03-23','13:05:00',2.37),('8998','2013-03-23','13:10:00',2.32),('8998','2013-03-23','13:15:00',2.29),('8998','2013-03-23','13:20:00',2.26),('8998','2013-03-23','13:25:00',2.2),('8998','2013-03-23','13:30:00',2.15),('8998','2013-03-23','13:35:00',2.11),('8998','2013-03-23','13:40:00',2.08),('8998','2013-03-23','13:45:00',2.02),('8998','2013-03-23','13:50:00',1.98),('8998','2013-03-23','13:55:00',1.93),('8998','2013-03-23','14:00:00',1.88),('8998','2013-03-23','14:05:00',1.82),('8998','2013-03-23','14:10:00',1.75),('8998','2013-03-23','14:15:00',1.71),('8998','2013-03-23','14:20:00',1.65),('8998','2013-03-23','14:25:00',1.59),('8998','2013-03-23','14:30:00',1.53),('8998','2013-03-23','14:35:00',1.44),('8998','2013-03-23','14:40:00',1.4),('8998','2013-03-23','14:45:00',1.35),('8998','2013-03-23','14:50:00',1.28),('8998','2013-03-23','14:55:00',1.24),('8998','2013-03-23','15:00:00',1.17),('8998','2013-03-23','15:05:00',1.1),('8998','2013-03-23','15:10:00',1.02),('8998','2013-03-23','15:15:00',1.08),('8998','2013-03-23','15:20:00',1.03),('8998','2013-03-22','07:40:00',1.07),('8998','2013-03-22','07:45:00',1.23),('8998','2013-03-22','07:50:00',1.51),('8998','2013-03-22','07:55:00',1.67),('8998','2013-03-22','08:00:00',1.78),('8998','2013-03-22','08:05:00',1.91),('8998','2013-03-22','08:10:00',1.94),('8998','2013-03-22','08:15:00',2.03),('8998','2013-03-22','08:20:00',2.07),('8998','2013-03-22','08:25:00',2.12),('8998','2013-03-22','08:30:00',2.13),('8998','2013-03-22','08:35:00',2.19),('8998','2013-03-22','08:40:00',2.26),('8998','2013-03-22','08:45:00',2.31),('8998','2013-03-22','08:50:00',2.33),('8998','2013-03-22','08:55:00',2.44),('8998','2013-03-22','09:00:00',2.46),('8998','2013-03-22','09:05:00',2.5),('8998','2013-03-22','09:10:00',2.48),('8998','2013-03-22','09:15:00',2.56),('8998','2013-03-22','09:20:00',2.52),('8998','2013-03-22','09:25:00',2.59),('8998','2013-03-22','09:30:00',2.66),('8998','2013-03-22','09:35:00',2.65),('8998','2013-03-22','09:40:00',2.5),('8998','2013-03-22','09:45:00',2.65),('8998','2013-03-22','09:50:00',2.66),('8998','2013-03-22','09:55:00',2.72),('8998','2013-03-22','10:00:00',2.73),('8998','2013-03-22','10:05:00',2.74),('8998','2013-03-22','10:10:00',2.77),('8998','2013-03-22','10:15:00',2.71),('8998','2013-03-22','10:20:00',2.69),('8998','2013-03-22','10:25:00',2.65),('8998','2013-03-22','10:30:00',2.81),('8998','2013-03-22','10:35:00',2.81),('8998','2013-03-22','10:40:00',2.77),('8998','2013-03-22','10:45:00',2.74),('8998','2013-03-22','10:50:00',2.72),('8998','2013-03-22','10:55:00',2.6),('8998','2013-03-22','11:00:00',2.52),('8998','2013-03-22','11:05:00',2.35),('8998','2013-03-22','11:10:00',1.97),('8998','2013-03-22','11:15:00',2.09),('8998','2013-03-22','11:20:00',2.62),('8998','2013-03-22','11:25:00',2.61),('8998','2013-03-22','11:30:00',2.6),('8998','2013-03-22','11:35:00',2.7),('8998','2013-03-22','11:40:00',2.68),('8998','2013-03-22','11:45:00',2.67),('8998','2013-03-22','11:50:00',2.54),('8998','2013-03-22','11:55:00',2.65),('8998','2013-03-22','12:00:00',2.63),('8998','2013-03-22','12:05:00',2.59),('8998','2013-03-22','12:10:00',2.56),('8998','2013-03-22','12:15:00',2.58),('8998','2013-03-22','12:20:00',2.58),('8998','2013-03-22','12:25:00',2.54),('8998','2013-03-22','12:30:00',2.56),('8998','2013-03-22','12:35:00',2.53),('8998','2013-03-22','12:40:00',2.37),('8998','2013-03-22','12:45:00',2.41),('8998','2013-03-22','12:50:00',2.43),('8998','2013-03-22','12:55:00',2.37),('8998','2013-03-22','13:00:00',1.77),('8998','2013-03-22','13:05:00',2.3),('8998','2013-03-22','13:10:00',2.3),('8998','2013-03-22','13:15:00',2.16),('8998','2013-03-22','13:20:00',2.19),('8998','2013-03-22','13:25:00',2.16),('8998','2013-03-22','13:30:00',2.04),('8998','2013-03-22','13:35:00',1.85),('8998','2013-03-22','13:40:00',1.99),('8998','2013-03-22','13:45:00',1.54),('8998','2013-03-22','13:50:00',1.94),('8998','2013-03-22','13:55:00',1.89),('8998','2013-03-22','14:00:00',1.83),('8998','2013-03-22','14:05:00',1.8),('8998','2013-03-22','14:10:00',1.74),('8998','2013-03-22','14:15:00',1.67),('8998','2013-03-22','14:20:00',1.68),('8998','2013-03-22','14:25:00',1.63),('8998','2013-03-22','14:30:00',1.59),('8998','2013-03-22','14:35:00',1.51),('8998','2013-03-22','14:40:00',1.44),('8998','2013-03-22','14:45:00',1.32),('8998','2013-03-22','14:50:00',1.28),('8998','2013-03-22','14:55:00',1.25),('8998','2013-03-22','15:00:00',1.11),('8998','2013-03-22','15:05:00',1.08),('8998','2013-03-22','15:10:00',1.06),('8998','2014-03-25','07:35:00',1.32),('8998','2014-03-25','07:40:00',1.31),('8998','2014-03-25','07:45:00',1.2),('8998','2014-03-25','07:50:00',1.34),('8998','2014-03-25','07:55:00',1.47),('8998','2014-03-25','08:00:00',1.61),('8998','2014-03-25','08:05:00',1.66),('8998','2014-03-25','08:10:00',1.77),('8998','2014-03-25','08:15:00',2.02),('8998','2014-03-25','08:20:00',2.44),('8998','2014-03-25','08:25:00',1.56),('8998','2014-03-25','08:50:00',1.05),('8998','2014-03-25','09:00:00',1.04),('8998','2014-03-25','09:05:00',1.02),('8998','2014-03-25','09:10:00',1.19),('8998','2014-03-25','09:30:00',2.67),('8998','2014-03-25','09:35:00',2.82),('8998','2014-03-25','09:40:00',2.79),('8998','2014-03-25','09:45:00',2.8),('8998','2014-03-25','09:50:00',2.8),('8998','2014-03-25','09:55:00',2.69),('8998','2014-03-25','10:00:00',2.89),('8998','2014-03-25','10:05:00',2.21),('8998','2014-03-25','10:10:00',3.01),('8998','2014-03-25','10:15:00',3.05),('8998','2014-03-25','10:20:00',2.96),('8998','2014-03-25','10:25:00',3.06),('8998','2014-03-25','10:30:00',3.03),('8998','2014-03-25','10:35:00',2.31),('8998','2014-03-25','10:45:00',1.97),('8998','2014-03-25','10:50:00',2.76),('8998','2014-03-25','10:55:00',1.91),('8998','2014-03-25','11:00:00',2.71),('8998','2014-03-25','11:05:00',1.27),('8998','2014-03-25','11:10:00',1.48),('8998','2014-03-25','11:15:00',3.18),('8998','2014-03-25','11:20:00',2.39),('8998','2014-03-25','11:30:00',1.08),('8998','2014-03-25','11:35:00',1.33),('8998','2014-03-25','11:40:00',1.65),('8998','2014-03-25','11:45:00',1.34),('8998','2014-03-25','11:50:00',2.28),('8998','2014-03-25','11:55:00',2.45),('8998','2014-03-25','12:00:00',3.32),('8998','2014-03-25','12:05:00',2.47),('8998','2014-03-25','12:10:00',3.04),('8998','2014-03-25','12:15:00',1.06),('8998','2014-03-25','12:20:00',1.18),('8998','2014-03-25','12:25:00',1.24),('8998','2014-03-25','12:30:00',1.16),('8998','2014-03-25','12:35:00',1.21),('8998','2014-03-25','12:40:00',1.2),('8998','2014-03-25','12:45:00',1.46),('8998','2014-03-25','12:50:00',1.15),('8998','2014-03-25','13:25:00',2.42),('8998','2014-03-25','13:30:00',2.23),('8998','2014-03-25','13:35:00',1.19),('8998','2014-03-25','13:40:00',1.25),('8998','2014-03-25','14:05:00',1.36),('8998','2014-03-25','14:10:00',2.54),('8998','2014-03-25','14:15:00',1.77),('8998','2014-03-25','14:50:00',1.59),('8998','2014-03-25','14:55:00',1.57),('8998','2014-03-25','15:00:00',1.42),('8998','2014-03-25','15:05:00',1.37),('8998','2014-03-25','15:10:00',1.36),('8998','2014-03-25','15:15:00',1.41),('8998','2014-03-25','15:20:00',1.33),('8998','2014-03-25','15:25:00',1.3),('8998','2014-03-25','15:30:00',1.24),('8998','2014-03-25','15:35:00',1.15),('8998','2013-03-21','07:40:00',1.47),('8998','2013-03-21','07:45:00',1.62),('8998','2013-03-21','07:50:00',1.68),('8998','2013-03-21','07:55:00',1.73),('8998','2013-03-21','08:00:00',1.78),('8998','2013-03-21','08:05:00',1.84),('8998','2013-03-21','08:10:00',1.91),('8998','2013-03-21','08:15:00',2),('8998','2013-03-21','08:20:00',2.07),('8998','2013-03-21','08:25:00',2.15),('8998','2013-03-21','08:30:00',2.22),('8998','2013-03-21','08:35:00',2.27),('8998','2013-03-21','08:40:00',2.32),('8998','2013-03-21','08:45:00',2.35),('8998','2013-03-21','08:50:00',2.38),('8998','2013-03-21','08:55:00',2.41),('8998','2013-03-21','09:00:00',2.44),('8998','2013-03-21','09:05:00',2.47),('8998','2013-03-21','09:10:00',2.51),('8998','2013-03-21','09:15:00',2.54),('8998','2013-03-21','09:20:00',2.53),('8998','2013-03-21','09:25:00',2.58),('8998','2013-03-21','09:30:00',2.6),('8998','2013-03-21','09:35:00',2.64),('8998','2013-03-21','09:40:00',2.68),('8998','2013-03-21','09:45:00',2.68),('8998','2013-03-21','09:50:00',2.73),('8998','2013-03-21','09:55:00',2.7),('8998','2013-03-21','10:00:00',2.73),('8998','2013-03-21','10:05:00',2.7),('8998','2013-03-21','10:10:00',2.74),('8998','2013-03-21','10:15:00',2.75),('8998','2013-03-21','10:20:00',2.72),('8998','2013-03-21','10:25:00',2.77),('8998','2013-03-21','10:30:00',2.82),('8998','2013-03-21','10:35:00',2.83),('8998','2013-03-21','10:40:00',2.86),('8998','2013-03-21','10:45:00',2.85),('8998','2013-03-21','10:50:00',2.86),('8998','2013-03-21','10:55:00',2.85),('8998','2013-03-21','11:00:00',2.84),('8998','2013-03-21','11:05:00',2.84),('8998','2013-03-21','11:10:00',2.84),('8998','2013-03-21','11:15:00',2.83),('8998','2013-03-21','11:20:00',2.82),('8998','2013-03-21','11:25:00',2.8),('8998','2013-03-21','11:30:00',2.8),('8998','2013-03-21','11:35:00',2.8),('8998','2013-03-21','11:40:00',2.76),('8998','2013-03-21','11:45:00',2.8),('8998','2013-03-21','11:50:00',2.77),('8998','2013-03-21','11:55:00',2.76),('8998','2013-03-21','12:00:00',2.74),('8998','2013-03-21','12:05:00',2.72),('8998','2013-03-21','12:10:00',2.7),('8998','2013-03-21','12:15:00',2.67),('8998','2013-03-21','12:20:00',2.66),('8998','2013-03-21','12:25:00',2.62),('8998','2013-03-21','12:30:00',2.6),('8998','2013-03-21','12:35:00',2.58),('8998','2013-03-21','12:40:00',2.57),('8998','2013-03-21','12:45:00',2.53),('8998','2013-03-21','12:50:00',2.43),('8998','2013-03-21','12:55:00',2.25),('8998','2013-03-21','13:00:00',2.46),('8998','2013-03-21','13:05:00',2.34),('8998','2013-03-21','13:10:00',2.39),('8998','2013-03-21','13:15:00',2.35),('8998','2013-03-21','13:20:00',2.29),('8998','2013-03-21','13:25:00',2.15),('8998','2013-03-21','13:30:00',2.09),('8998','2013-03-21','13:35:00',2.13),('8998','2013-03-21','13:40:00',1.74),('8998','2013-03-21','13:45:00',1.8),('8998','2013-03-21','13:50:00',2.06),('8998','2013-03-21','13:55:00',1.99),('8998','2013-03-21','14:00:00',1.91),('8998','2013-03-21','14:05:00',1.86),('8998','2013-03-21','14:10:00',1.81),('8998','2013-03-21','14:15:00',1.75),('8998','2013-03-21','14:20:00',1.7),('8998','2013-03-21','14:25:00',1.62),('8998','2013-03-21','14:30:00',1.58),('8998','2013-03-21','14:35:00',1.51),('8998','2013-03-21','14:40:00',1.44),('8998','2013-03-21','14:45:00',1.39),('8998','2013-03-21','14:50:00',1.32),('8998','2013-03-21','14:55:00',1.22),('8998','2013-03-21','15:00:00',1.18),('8998','2013-03-21','15:05:00',1.11),('8998','2013-03-20','07:45:00',1.36),('8998','2013-03-20','07:50:00',1.84),('8998','2013-03-20','08:10:00',1.31),('8998','2013-03-20','08:15:00',2.16),('8998','2013-03-20','08:20:00',2.18),('8998','2013-03-20','08:25:00',2.09),('8998','2013-03-20','08:30:00',2.29),('8998','2013-03-20','08:35:00',2.36),('8998','2013-03-20','08:40:00',2.35),('8998','2013-03-20','08:45:00',2.38),('8998','2013-03-20','08:50:00',2.46),('8998','2013-03-20','08:55:00',2.44),('8998','2013-03-20','09:00:00',2.57),('8998','2013-03-20','09:05:00',2.66),('8998','2013-03-20','09:10:00',2.92),('8998','2013-03-20','09:15:00',1.99),('8998','2013-03-20','09:20:00',2.43),('8998','2013-03-20','09:25:00',2.82),('8998','2013-03-20','09:30:00',2.81),('8998','2013-03-20','09:35:00',2.79),('8998','2013-03-20','09:40:00',2.84),('8998','2013-03-20','09:45:00',2.87),('8998','2013-03-20','09:50:00',2.45),('8998','2013-03-20','09:55:00',2.96),('8998','2013-03-20','10:00:00',2.98),('8998','2013-03-20','10:05:00',2.97),('8998','2013-03-20','10:10:00',2.98),('8998','2013-03-20','10:15:00',2.97),('8998','2013-03-20','10:20:00',2.98),('8998','2013-03-20','10:25:00',2.96),('8998','2013-03-20','10:30:00',2.96),('8998','2013-03-20','10:35:00',2.98),('8998','2013-03-20','10:40:00',2.99),('8998','2013-03-20','10:45:00',2.96),('8998','2013-03-20','10:50:00',2.93),('8998','2013-03-20','10:55:00',2.12),('8998','2013-03-20','11:00:00',3.01),('8998','2013-03-20','11:05:00',2.99),('8998','2013-03-20','11:10:00',2.98),('8998','2013-03-20','11:15:00',2.97),('8998','2013-03-20','11:20:00',2.96),('8998','2013-03-20','11:25:00',2.96),('8998','2013-03-20','11:30:00',2.95),('8998','2013-03-20','11:35:00',2.94),('8998','2013-03-20','11:40:00',2.93),('8998','2013-03-20','11:45:00',2.92),('8998','2013-03-20','11:50:00',2.91),('8998','2013-03-20','11:55:00',2.89),('8998','2013-03-20','12:00:00',2.88),('8998','2013-03-20','12:05:00',2.86),('8998','2013-03-20','12:10:00',2.84),('8998','2013-03-20','12:15:00',2.8),('8998','2013-03-20','12:20:00',2.77),('8998','2013-03-20','12:25:00',2.74),('8998','2013-03-20','12:30:00',2.72),('8998','2013-03-20','12:35:00',2.7),('8998','2013-03-20','12:40:00',2.67),('8998','2013-03-20','12:45:00',2.63),('8998','2013-03-20','12:50:00',2.59),('8998','2013-03-20','12:55:00',2.54),('8998','2013-03-20','13:00:00',2.5),('8998','2013-03-20','13:05:00',2.45),('8998','2013-03-20','13:10:00',2.41),('8998','2013-03-20','13:15:00',2.37),('8998','2013-03-20','13:20:00',2.33),('8998','2013-03-20','13:25:00',2.28),('8998','2013-03-20','13:30:00',2.25),('8998','2013-03-20','13:35:00',2.21),('8998','2013-03-20','13:40:00',2.16),('8998','2013-03-20','13:45:00',2.11),('8998','2013-03-20','13:50:00',2.06),('8998','2013-03-20','13:55:00',2),('8998','2013-03-20','14:00:00',1.95),('8998','2013-03-20','14:05:00',1.88),('8998','2013-03-20','14:10:00',1.82),('8998','2013-03-20','14:15:00',1.76),('8998','2013-03-20','14:20:00',1.7),('8998','2013-03-20','14:25:00',1.65),('8998','2013-03-20','14:30:00',1.58),('8998','2013-03-20','14:35:00',1.52),('8998','2013-03-20','14:40:00',1.45),('8998','2013-03-20','14:45:00',1.38),('8998','2013-03-20','14:50:00',1.29),('8998','2013-03-20','14:55:00',1.25),('8998','2013-03-20','15:00:00',1.17),('8998','2013-03-20','15:05:00',1.1),('8998','2013-03-20','15:10:00',1.04),('8998','2013-03-19','07:40:00',1.02),('8998','2013-03-19','07:45:00',1.43),('8998','2013-03-19','07:50:00',1.48),('8998','2013-03-19','07:55:00',1.61),('8998','2013-03-19','08:00:00',1.56),('8998','2013-03-19','08:05:00',1.54),('8998','2013-03-19','08:10:00',1.89),('8998','2013-03-19','08:15:00',1.98),('8998','2013-03-19','08:20:00',2.03),('8998','2013-03-19','08:25:00',2.09),('8998','2013-03-19','08:30:00',2.16),('8998','2013-03-19','08:35:00',2.14),('8998','2013-03-19','08:40:00',2.06),('8998','2013-03-19','08:45:00',2.19),('8998','2013-03-19','08:50:00',2.27),('8998','2013-03-19','08:55:00',2.2),('8998','2013-03-19','09:00:00',2.08),('8998','2013-03-19','09:05:00',2.69),('8998','2013-03-19','09:10:00',2.2),('8998','2013-03-19','09:15:00',2.49),('8998','2013-03-19','09:20:00',2.47),('8998','2013-03-19','09:25:00',2.49),('8998','2013-03-19','09:30:00',2.64),('8998','2013-03-19','09:35:00',2.55),('8998','2013-03-19','09:40:00',2.65),('8998','2013-03-19','09:45:00',2.68),('8998','2013-03-19','09:50:00',2.67),('8998','2013-03-19','09:55:00',2.63),('8998','2013-03-19','10:00:00',2.71),('8998','2013-03-19','10:05:00',2.68),('8998','2013-03-19','10:10:00',2.55),('8998','2013-03-19','10:15:00',1.97),('8998','2013-03-19','10:20:00',2.1),('8998','2013-03-19','10:25:00',1.81),('8998','2013-03-19','10:30:00',2.43),('8998','2013-03-19','10:35:00',2.74),('8998','2013-03-19','10:40:00',2.43),('8998','2013-03-19','10:45:00',1.7),('8998','2013-03-19','10:50:00',2.5),('8998','2013-03-19','10:55:00',2.19),('8998','2013-03-19','11:00:00',2.06),('8998','2013-03-19','11:05:00',2.23),('8998','2013-03-19','11:10:00',2.03),('8998','2013-03-19','11:15:00',1.69),('8998','2013-03-19','11:20:00',1.91),('8998','2013-03-19','11:25:00',1.86),('8998','2013-03-19','11:30:00',1.71),('8998','2013-03-19','11:35:00',1.89),('8998','2013-03-19','11:40:00',1.56),('8998','2013-03-19','11:45:00',1.44),('8998','2013-03-19','11:50:00',1.37),('8998','2013-03-19','11:55:00',1.55),('8998','2013-03-19','12:00:00',1.48),('8998','2013-03-19','12:05:00',1.67),('8998','2013-03-19','12:10:00',1.39),('8998','2013-03-19','12:15:00',1.22),('8998','2013-03-19','12:20:00',1.16),('8998','2013-03-19','12:55:00',1.08),('8998','2013-03-19','13:00:00',1.28),('8998','2013-03-19','13:30:00',1.04),('8998','2013-03-19','13:40:00',1.14),('8998','2013-03-19','13:45:00',1.39),('8998','2013-03-19','13:50:00',1.2),('8998','2013-03-19','13:55:00',1.09),('8998','2013-03-19','14:00:00',1.12),('8998','2013-03-19','14:15:00',1.09),('8998','2013-03-19','14:20:00',1.35),('8998','2013-03-19','14:25:00',1.29),('8998','2013-03-19','14:30:00',1.14),('8998','2013-03-18','07:40:00',1.06),('8998','2013-03-18','07:45:00',1.27),('8998','2013-03-18','07:50:00',1.6),('8998','2013-03-18','07:55:00',1.62),('8998','2013-03-18','08:00:00',1.15),('8998','2013-03-18','08:05:00',1.52),('8998','2013-03-18','08:10:00',1.79),('8998','2013-03-18','08:15:00',1.99),('8998','2013-03-18','08:20:00',2.03),('8998','2013-03-18','08:25:00',2.06),('8998','2013-03-18','08:30:00',1.88),('8998','2013-03-18','08:35:00',2.19),('8998','2013-03-18','08:40:00',2.25),('8998','2013-03-18','08:45:00',2.34),('8998','2013-03-18','08:50:00',2.41),('8998','2013-03-18','08:55:00',2.43),('8998','2013-03-18','09:00:00',2.47),('8998','2013-03-18','09:05:00',2.38),('8998','2013-03-18','09:10:00',2.57),('8998','2013-03-18','09:15:00',2.44),('8998','2013-03-18','09:20:00',2.05),('8998','2013-03-18','09:25:00',2.4),('8998','2013-03-18','09:30:00',2.7),('8998','2013-03-18','09:35:00',2.71),('8998','2013-03-18','09:40:00',2.78),('8998','2013-03-18','09:45:00',2.86),('8998','2013-03-18','09:50:00',2.83),('8998','2013-03-18','09:55:00',2.2),('8998','2013-03-18','10:00:00',3.02),('8998','2013-03-18','10:05:00',2.46),('8998','2013-03-18','10:10:00',2.77),('8998','2013-03-18','10:15:00',2.87),('8998','2013-03-18','10:20:00',2.89),('8998','2013-03-18','10:25:00',2.93),('8998','2013-03-18','10:30:00',2.92),('8998','2013-03-18','10:35:00',2.91),('8998','2013-03-18','10:40:00',2.92),('8998','2013-03-18','10:45:00',2.91),('8998','2013-03-18','10:50:00',2.94),('8998','2013-03-18','10:55:00',2.87),('8998','2013-03-18','11:00:00',2.96),('8998','2013-03-18','11:05:00',2.94),('8998','2013-03-18','11:10:00',2.87),('8998','2013-03-18','11:15:00',2.93),('8998','2013-03-18','11:20:00',2.91),('8998','2013-03-18','11:25:00',2.9),('8998','2013-03-18','11:30:00',2.85),('8998','2013-03-18','11:35:00',1.83),('8998','2013-03-18','11:40:00',2.47),('8998','2013-03-18','11:45:00',2.65),('8998','2013-03-18','11:50:00',2.81),('8998','2013-03-18','11:55:00',2.88),('8998','2013-03-18','12:00:00',2.81),('8998','2013-03-18','12:05:00',2.73),('8998','2013-03-18','12:10:00',2.75),('8998','2013-03-18','12:15:00',2.6),('8998','2013-03-18','12:20:00',2.7),('8998','2013-03-18','12:25:00',2.63),('8998','2013-03-18','12:30:00',2.62),('8998','2013-03-18','12:35:00',2.59),('8998','2013-03-18','12:40:00',2.57),('8998','2013-03-18','12:45:00',2.56),('8998','2013-03-18','12:50:00',2.44),('8998','2013-03-18','12:55:00',2.38),('8998','2013-03-18','13:00:00',2.43),('8998','2013-03-18','13:05:00',2.39),('8998','2013-03-18','13:10:00',2.33),('8998','2013-03-18','13:15:00',2.3),('8998','2013-03-18','13:20:00',2.25),('8998','2013-03-18','13:25:00',2.21),('8998','2013-03-18','13:30:00',2.18),('8998','2013-03-18','13:35:00',2.12),('8998','2013-03-18','13:40:00',2.06),('8998','2013-03-18','13:45:00',2.04),('8998','2013-03-18','13:50:00',1.99),('8998','2013-03-18','13:55:00',1.93),('8998','2013-03-18','14:00:00',1.88),('8998','2013-03-18','14:05:00',1.82),('8998','2013-03-18','14:10:00',1.78),('8998','2013-03-18','14:15:00',1.73),('8998','2013-03-18','14:20:00',1.66),('8998','2013-03-18','14:25:00',1.6),('8998','2013-03-18','14:30:00',1.53),('8998','2013-03-18','14:35:00',1.47),('8998','2013-03-18','14:40:00',1.4),('8998','2013-03-18','14:45:00',1.32),('8998','2013-03-18','14:50:00',1.22),('8998','2013-03-18','14:55:00',1.17),('8998','2013-03-18','15:00:00',1.11),('8998','2013-03-18','15:05:00',1.05),('8998','2013-03-17','10:05:00',1.01),('8998','2013-03-17','10:10:00',1.02),('8998','2013-03-17','10:20:00',1.09),('8998','2013-03-17','10:25:00',1.39),('8998','2013-03-17','10:30:00',1.34),('8998','2013-03-17','10:35:00',1.04),('8998','2013-03-17','11:10:00',1.07),('8998','2013-03-17','11:15:00',1.16),('8998','2013-03-17','11:20:00',1.2),('8998','2013-03-17','11:25:00',1.25),('8998','2013-03-17','11:30:00',1.55),('8998','2013-03-17','11:35:00',1.35),('8998','2013-03-17','11:40:00',1.21),('8998','2013-03-17','11:45:00',1.04),('8998','2013-03-17','12:00:00',1.01),('8998','2013-03-17','12:05:00',1.7),('8998','2013-03-17','12:10:00',1.63),('8998','2013-03-17','12:15:00',1.92),('8998','2013-03-17','12:20:00',1.89),('8998','2013-03-17','12:25:00',1.25),('8998','2013-03-17','12:30:00',2.15),('8998','2013-03-17','12:35:00',2.27),('8998','2013-03-17','12:40:00',2.03),('8998','2013-03-17','12:45:00',1.66),('8998','2013-03-17','12:50:00',2.32),('8998','2013-03-17','12:55:00',2.44),('8998','2013-03-17','13:00:00',1.64),('8998','2013-03-17','13:25:00',1.08),('8998','2013-03-17','13:40:00',1.1),('8998','2013-03-17','13:45:00',1.1),('8998','2013-03-17','13:50:00',1.1),('8998','2013-03-17','13:55:00',1.07),('8998','2013-03-17','14:00:00',1.09),('8998','2013-03-17','14:05:00',1.59),('8998','2013-03-17','14:10:00',1.57),('8998','2013-03-17','14:25:00',1.05),('8998','2013-03-16','08:20:00',1.11),('8998','2013-03-16','08:25:00',1.34),('8998','2013-03-16','08:30:00',1.27),('8998','2013-03-16','08:45:00',1.15),('8998','2013-03-16','08:50:00',1.16),('8998','2013-03-16','08:55:00',1.07),('8998','2013-03-16','09:00:00',1.01),('8998','2013-03-16','09:05:00',1.18),('8998','2013-03-16','09:10:00',1.35),('8998','2013-03-16','09:15:00',1.51),('8998','2013-03-16','09:20:00',1.27),('8998','2013-03-16','09:25:00',1.05),('8998','2013-03-16','09:30:00',1.08),('8998','2013-03-16','09:35:00',1.3),('8998','2013-03-16','09:40:00',1.16),('8998','2013-03-16','09:45:00',1.16),('8998','2013-03-16','09:50:00',1.3),('8998','2013-03-16','09:55:00',1.41),('8998','2013-03-16','10:00:00',1.55),('8998','2013-03-16','10:05:00',1.3),('8998','2013-03-16','10:10:00',1.24),('8998','2013-03-16','10:15:00',1.36),('8998','2013-03-16','10:20:00',1.36),('8998','2013-03-16','10:25:00',1.43),('8998','2013-03-16','10:30:00',1.4),('8998','2013-03-16','10:35:00',1.32),('8998','2013-03-16','10:40:00',1.25),('8998','2013-03-16','10:45:00',1.31),('8998','2013-03-16','10:50:00',1.31),('8998','2013-03-16','10:55:00',1.15),('8998','2013-03-16','11:00:00',1.19),('8998','2013-03-16','11:05:00',1.04),('8998','2013-03-16','11:20:00',1.14),('8998','2013-03-16','11:25:00',1.21),('8998','2013-03-16','11:30:00',1.08),('8998','2013-03-16','11:35:00',1.07),('8998','2013-03-16','11:40:00',1.01),('8998','2013-03-16','12:15:00',1.25),('8998','2013-03-16','12:20:00',1.56),('8998','2013-03-16','12:25:00',2.29),('8998','2013-03-16','12:30:00',2.63),('8998','2013-03-16','12:35:00',1.83),('8998','2013-03-16','12:40:00',1.97),('8998','2013-03-16','12:45:00',1.74),('8998','2013-03-16','12:50:00',1.54),('8998','2013-03-16','12:55:00',1.2),('8998','2013-03-16','13:00:00',1.31),('8998','2013-03-16','13:05:00',1.47),('8998','2013-03-16','13:10:00',1.59),('8998','2013-03-16','13:15:00',1.57),('8998','2013-03-16','13:20:00',1.35),('8998','2013-03-16','13:25:00',1.21),('8998','2013-03-16','13:30:00',1.66),('8998','2013-03-16','13:35:00',1.94),('8998','2013-03-16','13:40:00',1.35),('8998','2013-03-16','13:45:00',1.3),('8998','2013-03-16','13:55:00',1.31),('8998','2013-03-16','14:00:00',1.42),('8998','2013-03-16','14:05:00',1.32),('8998','2013-03-16','14:10:00',1.52),('8998','2013-03-16','14:15:00',1.58),('8998','2013-03-16','14:20:00',1.42),('8998','2013-03-16','14:25:00',1.42),('8998','2013-03-16','14:30:00',1.39),('8998','2013-03-16','14:35:00',1.18),('8998','2013-03-16','15:10:00',1.12),('8998','2013-03-15','08:15:00',1.2),('8998','2013-03-15','08:20:00',1.67),('8998','2013-03-15','08:25:00',1.89),('8998','2013-03-15','08:30:00',2.04),('8998','2013-03-15','08:35:00',2.29),('8998','2013-03-15','08:40:00',2.36),('8998','2013-03-15','08:45:00',2.1),('8998','2013-03-15','08:50:00',2.47),('8998','2013-03-15','08:55:00',2.6),('8998','2013-03-15','09:00:00',2.47),('8998','2013-03-15','09:05:00',2.01),('8998','2013-03-15','09:10:00',1.98),('8998','2013-03-15','09:15:00',2.66),('8998','2013-03-15','09:20:00',2.73),('8998','2013-03-15','09:25:00',2.66),('8998','2013-03-15','09:30:00',2.75),('8998','2013-03-15','09:35:00',2.86),('8998','2013-03-15','09:40:00',2.89),('8998','2013-03-15','09:45:00',2.94),('8998','2013-03-15','09:50:00',2.92),('8998','2013-03-15','09:55:00',2.95),('8998','2013-03-15','10:00:00',2.29),('8998','2013-03-15','10:05:00',1.44),('8998','2013-03-15','10:10:00',2.22),('8998','2013-03-15','10:15:00',2.03),('8998','2013-03-15','10:20:00',1.4),('8998','2013-03-15','10:25:00',1.79),('8998','2013-03-15','10:30:00',1.5),('8998','2013-03-15','10:35:00',1.18),('8998','2013-03-15','10:40:00',2.13),('8998','2013-03-15','10:45:00',3.03),('8998','2013-03-15','10:50:00',2.99),('8998','2013-03-15','10:55:00',2.83),('8998','2013-03-15','11:00:00',2.97),('8998','2013-03-15','11:05:00',2.96),('8998','2013-03-15','11:10:00',2.95),('8998','2013-03-15','11:15:00',2.95),('8998','2013-03-15','11:20:00',2.92),('8998','2013-03-15','11:25:00',2.91),('8998','2013-03-15','11:30:00',2.89),('8998','2013-03-15','11:35:00',2.86),('8998','2013-03-15','11:40:00',2.87),('8998','2013-03-15','11:45:00',2.85),('8998','2013-03-15','11:50:00',2.84),('8998','2013-03-15','11:55:00',2.81),('8998','2013-03-15','12:00:00',2.8),('8998','2013-03-15','12:05:00',2.76),('8998','2013-03-15','12:10:00',2.73),('8998','2013-03-15','12:15:00',2.71),('8998','2013-03-15','12:20:00',2.69),('8998','2013-03-15','12:25:00',2.68),('8998','2013-03-15','12:30:00',2.65),('8998','2013-03-15','12:35:00',2.61),('8998','2013-03-15','12:40:00',2.57),('8998','2013-03-15','12:45:00',2.54),('8998','2013-03-15','12:50:00',2.49),('8998','2013-03-15','12:55:00',2.46),('8998','2013-03-15','13:00:00',2.42),('8998','2013-03-15','13:05:00',2.38),('8998','2013-03-15','13:10:00',2.35),('8998','2013-03-15','13:15:00',2.32),('8998','2013-03-15','13:20:00',1.01),('8998','2013-03-15','13:30:00',1.03),('8998','2013-03-15','13:35:00',2.25),('8998','2013-03-15','13:40:00',2.17),('8998','2013-03-15','13:45:00',2.1),('8998','2013-03-15','13:50:00',2.08),('8998','2013-03-15','13:55:00',1.71),('8998','2013-03-15','14:00:00',2.01),('8998','2013-03-15','14:05:00',1.94),('8998','2013-03-15','14:15:00',1.43),('8998','2013-03-15','14:20:00',1.17),('8998','2013-03-15','14:30:00',1.62),('8998','2013-03-15','14:35:00',1.49),('8998','2013-03-14','10:45:00',1.01),('8998','2013-03-14','10:55:00',1.06),('8998','2013-03-14','11:00:00',1.02),('8998','2013-03-14','11:25:00',1.02),('8998','2013-03-14','11:30:00',1.14),('8998','2013-03-14','11:35:00',1.34),('8998','2013-03-14','11:40:00',1.61),('8998','2013-03-14','11:45:00',1.5),('8998','2013-03-14','11:50:00',1.43),('8998','2013-03-14','11:55:00',1.46),('8998','2013-03-14','12:00:00',1.29),('8998','2013-03-14','12:05:00',1.33),('8998','2013-03-14','12:10:00',1.37),('8998','2013-03-14','12:15:00',1.21),('8998','2013-03-14','12:20:00',1.23),('8998','2013-03-14','12:25:00',1.21),('8998','2013-03-14','12:30:00',1.24),('8998','2013-03-14','12:35:00',1.38),('8998','2013-03-14','12:40:00',1.3),('8998','2013-03-14','12:45:00',1.16),('8998','2013-03-14','12:50:00',1.09),('8998','2013-03-14','12:55:00',1.02),('8998','2013-03-14','13:20:00',1.04),('8998','2013-03-14','13:25:00',1.14),('8998','2013-03-14','13:30:00',1.12),('8998','2013-03-14','13:35:00',1.04),('8998','2013-03-14','13:40:00',1.07),('8998','2013-03-14','13:45:00',1.12),('8998','2013-03-13','13:45:00',1.17),('8998','2013-03-13','13:50:00',1.36),('8998','2013-03-13','13:55:00',1.56),('8998','2013-03-13','14:00:00',1.34),('8998','2013-03-13','14:05:00',1.32),('8998','2013-03-13','14:10:00',1.05),('8998','2013-03-12','10:15:00',1.68),('8998','2013-03-12','10:20:00',1.29),('8998','2013-03-12','10:25:00',1.28),('8998','2013-03-12','10:30:00',2.75),('8998','2013-03-12','10:35:00',1.9),('8998','2013-03-12','10:40:00',2.06),('8998','2013-03-12','10:45:00',1.1),('8998','2014-03-24','07:20:00',1.03),('8998','2014-03-24','07:30:00',1.2),('8998','2014-03-24','07:35:00',1.02),('8998','2014-03-24','07:50:00',1.03),('8998','2014-03-24','07:55:00',1.06),('8998','2014-03-24','08:00:00',1.01),('8998','2014-03-24','08:05:00',1.04),('8998','2014-03-24','08:10:00',1.1),('8998','2014-03-24','08:15:00',1.17),('8998','2014-03-24','08:20:00',1.03),('8998','2014-03-24','08:45:00',1.51),('8998','2014-03-24','08:50:00',1.55),('8998','2014-03-24','08:55:00',1.63),('8998','2014-03-24','09:00:00',1.44),('8998','2014-03-24','09:05:00',1.39),('8998','2014-03-24','09:10:00',1.42),('8998','2014-03-24','09:15:00',1.91),('8998','2014-03-24','09:20:00',1.99),('8998','2014-03-24','09:25:00',1.72),('8998','2014-03-24','09:30:00',1.51),('8998','2014-03-24','09:35:00',1.38),('8998','2014-03-24','09:40:00',1.41),('8998','2014-03-24','09:45:00',1.32),('8998','2014-03-24','09:50:00',1.37),('8998','2014-03-24','09:55:00',1.54),('8998','2014-03-24','10:00:00',1.82),('8998','2014-03-24','10:05:00',1.92),('8998','2014-03-24','10:10:00',2.07),('8998','2014-03-24','10:15:00',2.17),('8998','2014-03-24','10:20:00',2.03),('8998','2014-03-24','10:25:00',2.09),('8998','2014-03-24','10:30:00',2.01),('8998','2014-03-24','10:35:00',1.8),('8998','2014-03-24','10:40:00',1.48),('8998','2014-03-24','10:45:00',1.36),('8998','2014-03-24','10:50:00',1.31),('8998','2014-03-24','10:55:00',1.31),('8998','2014-03-24','11:00:00',1.43),('8998','2014-03-24','11:05:00',1.64),('8998','2014-03-24','11:10:00',1.85),('8998','2014-03-24','11:15:00',2.09),('8998','2014-03-24','11:20:00',2.11),('8998','2014-03-24','11:25:00',2.1),('8998','2014-03-24','11:30:00',2.02),('8998','2014-03-24','11:35:00',2.01),('8998','2014-03-24','11:40:00',1.67),('8998','2014-03-24','11:45:00',1.42),('8998','2014-03-24','11:50:00',1.41),('8998','2014-03-24','11:55:00',1.46),('8998','2014-03-24','12:00:00',1.01),('8998','2013-03-11','08:20:00',1.03),('8998','2013-03-11','08:25:00',1.24),('8998','2013-03-11','08:30:00',1.5),('8998','2013-03-11','08:35:00',1.67),('8998','2013-03-11','08:40:00',1.95),('8998','2013-03-11','08:45:00',2.2),('8998','2013-03-11','08:50:00',1.5),('8998','2013-03-11','09:00:00',1.31),('8998','2013-03-11','09:05:00',2.41),('8998','2013-03-11','09:10:00',2.43),('8998','2013-03-11','09:15:00',2.43),('8998','2013-03-11','09:20:00',2.44),('8998','2013-03-11','09:25:00',2.47),('8998','2013-03-11','09:30:00',2.51),('8998','2013-03-11','09:35:00',2.54),('8998','2013-03-11','09:40:00',2.58),('8998','2013-03-11','09:45:00',2.61),('8998','2013-03-11','09:50:00',1.69),('8998','2013-03-11','09:55:00',2.82),('8998','2013-03-11','10:00:00',2.58),('8998','2013-03-11','10:05:00',2.67),('8998','2013-03-11','10:10:00',2.12),('8998','2013-03-11','10:15:00',2.04),('8998','2013-03-11','10:20:00',2.52),('8998','2013-03-11','10:25:00',2.61),('8998','2013-03-11','10:30:00',2.93),('8998','2013-03-11','10:35:00',1.79),('8998','2013-03-11','10:40:00',2.17),('8998','2013-03-11','10:45:00',1.48),('8998','2013-03-11','10:50:00',2.55),('8998','2013-03-11','10:55:00',2.64),('8998','2013-03-11','11:00:00',2.52),('8998','2013-03-11','11:05:00',3.13),('8998','2013-03-11','11:10:00',2.22),('8998','2013-03-11','11:15:00',2.4),('8998','2013-03-11','11:20:00',2.99),('8998','2013-03-11','11:25:00',1.39),('8998','2013-03-11','11:30:00',1.1),('8998','2013-03-11','11:35:00',1.22),('8998','2013-03-11','11:40:00',1.48),('8998','2013-03-11','11:45:00',1.59),('8998','2013-03-11','11:50:00',1.87),('8998','2013-03-11','11:55:00',2.94),('8998','2013-03-11','12:10:00',2.39),('8998','2013-03-11','12:15:00',2.63),('8998','2013-03-11','12:20:00',1.18),('8998','2013-03-11','12:25:00',2.34),('8998','2013-03-11','12:30:00',3.2),('8998','2013-03-11','12:35:00',2.09),('8998','2013-03-11','12:40:00',2.45),('8998','2013-03-11','12:50:00',1.08),('8998','2013-03-11','12:55:00',1.31),('8998','2013-03-11','13:00:00',2.16),('8998','2013-03-11','13:05:00',1.41),('8998','2013-03-11','13:10:00',1.53),('8998','2013-03-11','13:15:00',1.33),('8998','2013-03-11','13:20:00',1.85),('8998','2013-03-11','13:25:00',1.29),('8998','2013-03-11','13:35:00',1.07),('8998','2013-03-11','13:55:00',1.01),('8998','2013-03-11','14:00:00',1.2),('8998','2013-03-11','14:05:00',1.36),('8998','2013-03-11','14:10:00',1.39),('8998','2013-03-10','08:10:00',1.08),('8998','2013-03-10','08:15:00',1.8),('8998','2013-03-10','08:20:00',1.86),('8998','2013-03-10','08:25:00',1.91),('8998','2013-03-10','08:30:00',1.96),('8998','2013-03-10','08:35:00',2.02),('8998','2013-03-10','08:40:00',2.06),('8998','2013-03-10','08:45:00',2.13),('8998','2013-03-10','08:50:00',2.19),('8998','2013-03-10','08:55:00',2.22),('8998','2013-03-10','09:00:00',2.24),('8998','2013-03-10','09:05:00',2.3),('8998','2013-03-10','09:10:00',2.3),('8998','2013-03-10','09:15:00',2.37),('8998','2013-03-10','09:20:00',1.97),('8998','2013-03-10','09:25:00',1.72),('8998','2013-03-10','09:35:00',2.05),('8998','2013-03-10','09:40:00',2.74),('8998','2013-03-10','09:45:00',2.43),('8998','2013-03-10','09:50:00',1.01),('8998','2013-03-10','10:25:00',1.02),('8998','2013-03-10','10:35:00',1.03),('8998','2013-03-10','10:40:00',1.46),('8998','2013-03-10','10:45:00',1.8),('8998','2013-03-10','10:50:00',2.15),('8998','2013-03-10','10:55:00',1.24),('8998','2013-03-10','11:00:00',1.06),('8998','2013-03-10','11:10:00',1.12),('8998','2013-03-10','11:15:00',1.21),('8998','2013-03-10','11:20:00',1.04),('8998','2013-03-10','11:30:00',1.69),('8998','2013-03-10','11:35:00',1.93),('8998','2013-03-10','11:40:00',1.49),('8998','2013-03-10','11:45:00',1.73),('8998','2013-03-10','11:50:00',1.79),('8998','2013-03-10','11:55:00',1.29),('8998','2013-03-10','12:00:00',1.16),('8998','2013-03-10','12:05:00',1.15),('8998','2013-03-10','12:10:00',1.19),('8998','2013-03-10','12:50:00',1.36),('8998','2013-03-10','12:55:00',2.61),('8998','2013-03-10','13:00:00',1.67),('8998','2013-03-10','13:05:00',1.33),('8998','2013-03-10','13:10:00',1.77),('8998','2013-03-10','13:15:00',2.26),('8998','2013-03-10','13:20:00',2.15),('8998','2013-03-10','13:25:00',2.25),('8998','2013-03-10','13:30:00',2.19),('8998','2013-03-10','13:35:00',2.06),('8998','2013-03-10','13:40:00',1.98),('8998','2013-03-10','13:45:00',1.64),('8998','2013-03-10','13:50:00',1.2),('8998','2013-03-10','13:55:00',1.29),('8998','2013-03-10','14:25:00',1.03),('8998','2013-03-09','08:00:00',1.51),('8998','2013-03-09','08:05:00',1.63),('8998','2013-03-09','08:10:00',1.72),('8998','2013-03-09','08:15:00',1.64),('8998','2013-03-09','08:20:00',1.85),('8998','2013-03-09','08:25:00',1.9),('8998','2013-03-09','08:30:00',1.94),('8998','2013-03-09','08:35:00',2),('8998','2013-03-09','08:40:00',2.03),('8998','2013-03-09','08:45:00',2.13),('8998','2013-03-09','08:50:00',2.17),('8998','2013-03-09','08:55:00',2.23),('8998','2013-03-09','09:00:00',2.26),('8998','2013-03-09','09:05:00',2.3),('8998','2013-03-09','09:10:00',2.33),('8998','2013-03-09','09:15:00',2.35),('8998','2013-03-09','09:20:00',2.38),('8998','2013-03-09','09:25:00',2.4),('8998','2013-03-09','09:30:00',2.44),('8998','2013-03-09','09:35:00',2.47),('8998','2013-03-09','09:40:00',2.53),('8998','2013-03-09','09:45:00',2.5),('8998','2013-03-09','09:50:00',1.52),('8998','2013-03-09','09:55:00',2.84),('8998','2013-03-09','10:00:00',1.41),('8998','2013-03-09','10:05:00',2.06),('8998','2013-03-09','10:10:00',1.74),('8998','2013-03-09','10:15:00',1.71),('8998','2013-03-09','10:20:00',2.43),('8998','2013-03-09','10:25:00',2.42),('8998','2013-03-09','10:30:00',2.61),('8998','2013-03-09','10:35:00',2.42),('8998','2013-03-09','10:40:00',2.28),('8998','2013-03-09','10:45:00',2.79),('8998','2013-03-09','10:50:00',2.6),('8998','2013-03-09','10:55:00',1.79),('8998','2013-03-09','11:00:00',2.45),('8998','2013-03-09','11:05:00',2.21),('8998','2013-03-09','11:10:00',2.36),('8998','2013-03-09','11:15:00',1.86),('8998','2013-03-09','11:20:00',1.39),('8998','2013-03-09','11:25:00',2.05),('8998','2013-03-09','11:30:00',1.73),('8998','2013-03-09','11:35:00',1.18),('8998','2013-03-09','11:40:00',1.09),('8998','2013-03-09','11:45:00',1.1),('8998','2013-03-09','11:50:00',1.89),('8998','2013-03-09','11:55:00',2.53),('8998','2013-03-09','12:00:00',2.53),('8998','2013-03-09','12:05:00',2.61),('8998','2013-03-09','12:10:00',2.15),('8998','2013-03-09','12:15:00',2.41),('8998','2013-03-09','12:20:00',1.24),('8998','2013-03-09','12:25:00',2.32),('8998','2013-03-09','12:35:00',1.19),('8998','2013-03-09','12:40:00',1.05),('8998','2013-03-09','12:45:00',2.76),('8998','2013-03-09','12:50:00',2.52),('8998','2013-03-09','12:55:00',2.53),('8998','2013-03-09','13:00:00',2.34),('8998','2013-03-09','13:05:00',2.23),('8998','2013-03-09','13:10:00',2.1),('8998','2013-03-09','13:15:00',2.25),('8998','2013-03-09','13:20:00',2.19),('8998','2013-03-09','13:25:00',1.94),('8998','2013-03-09','13:30:00',1.91),('8998','2013-03-09','13:35:00',1.67),('8998','2013-03-09','13:40:00',1.04),('8998','2013-03-09','13:45:00',1.22),('8998','2013-03-09','13:50:00',1.11),('8998','2013-03-09','13:55:00',1.11),('8998','2013-03-09','14:00:00',1.03),('8998','2013-03-09','14:05:00',1.12),('8998','2013-03-09','14:10:00',1.27),('8998','2013-03-09','14:15:00',1.52),('8998','2013-03-09','14:20:00',1.38),('8998','2013-03-09','14:25:00',1.04),('8998','2013-03-09','14:35:00',1.57),('8998','2013-03-09','14:40:00',1.45),('8998','2013-03-09','14:45:00',1.02),('8998','2013-03-08','08:05:00',1.74),('8998','2013-03-08','08:10:00',1.32),('8998','2013-03-08','08:15:00',1.77),('8998','2013-03-08','08:20:00',1.77),('8998','2013-03-08','08:25:00',1.86),('8998','2013-03-08','08:30:00',1.93),('8998','2013-03-08','08:35:00',1.99),('8998','2013-03-08','08:40:00',1.84),('8998','2013-03-08','08:45:00',1.04),('8998','2013-03-08','08:55:00',1.78),('8998','2013-03-08','09:30:00',1.63),('8998','2013-03-08','09:35:00',2.06),('8998','2013-03-08','09:40:00',2.78),('8998','2013-03-08','09:45:00',2.94),('8998','2013-03-08','09:50:00',2.11),('8998','2013-03-08','09:55:00',1.86),('8998','2013-03-08','10:00:00',1.31),('8998','2013-03-08','10:20:00',1.55),('8998','2013-03-08','10:40:00',1.21),('8998','2013-03-08','10:45:00',1.44),('8998','2013-03-08','10:50:00',2.43),('8998','2013-03-08','10:55:00',3),('8998','2013-03-08','11:00:00',1.94),('8998','2013-03-08','11:05:00',2.81),('8998','2013-03-08','11:10:00',2.95),('8998','2013-03-08','11:15:00',2.91),('8998','2013-03-08','11:20:00',2.87),('8998','2013-03-08','11:25:00',2.24),('8998','2013-03-08','11:30:00',2.82),('8998','2013-03-08','11:35:00',2.76),('8998','2013-03-08','11:40:00',2.73),('8998','2013-03-08','11:45:00',2.76),('8998','2013-03-08','11:50:00',2.64),('8998','2013-03-08','11:55:00',2.63),('8998','2013-03-08','12:00:00',2.51),('8998','2013-03-08','12:05:00',1.31),('8998','2013-03-08','12:25:00',1.12),('8998','2013-03-08','12:30:00',1.01),('8998','2013-03-08','12:35:00',1.01),('8998','2013-03-08','12:45:00',1.24),('8998','2013-03-08','12:50:00',1.52),('8998','2013-03-08','12:55:00',1.76),('8998','2013-03-08','13:00:00',2.42),('8998','2013-03-08','13:05:00',2.29),('8998','2013-03-08','13:10:00',2.24),('8998','2013-03-08','13:15:00',2.23),('8998','2013-03-08','13:20:00',2.27),('8998','2013-03-08','13:25:00',1.51),('8998','2013-03-08','13:30:00',2.01),('8998','2013-03-08','13:35:00',1.51),('8998','2013-03-08','13:40:00',1.83),('8998','2013-03-08','13:45:00',2.03),('8998','2013-03-08','13:50:00',1.95),('8998','2013-03-08','14:10:00',1.85),('8998','2013-03-08','14:15:00',1.53),('8998','2013-03-08','14:20:00',1.49),('8998','2013-03-08','14:25:00',1.38),('8998','2013-03-08','14:30:00',1.29),('8998','2013-03-08','14:35:00',1.24),('8998','2013-03-08','14:40:00',1.18),('8998','2013-03-08','14:45:00',1.07),('8998','2013-03-07','08:15:00',1.01),('8998','2013-03-07','08:35:00',1.26),('8998','2013-03-07','09:30:00',1.07),('8998','2013-03-07','09:35:00',1.62),('8998','2013-03-07','09:40:00',1.16),('8998','2013-03-07','09:45:00',1.87),('8998','2013-03-07','09:50:00',2.12),('8998','2013-03-07','09:55:00',1.64),('8998','2013-03-07','10:10:00',1.6),('8998','2013-03-07','10:15:00',1.51),('8998','2013-03-07','10:20:00',1.69),('8998','2013-03-07','10:25:00',1.28),('8998','2013-03-07','10:30:00',1.06),('8998','2013-03-07','10:35:00',1.53),('8998','2013-03-07','10:40:00',1.4),('8998','2013-03-07','11:40:00',1.41),('8998','2013-03-07','11:45:00',1.13),('8998','2013-03-07','12:00:00',1.51),('8998','2013-03-07','12:35:00',1.06),('8998','2013-03-07','12:40:00',1.39),('8998','2013-03-07','12:45:00',1.58),('8998','2013-03-07','12:50:00',1.55),('8998','2013-03-07','12:55:00',1.3),('8998','2013-03-07','13:00:00',1.4),('8998','2013-03-07','13:05:00',1.38),('8998','2013-03-07','13:10:00',1.03),('8998','2013-03-07','13:30:00',1.11),('8998','2013-03-06','11:05:00',1.11),('8998','2013-03-06','11:35:00',1.19),('8998','2013-03-06','11:40:00',1.32),('8998','2013-03-06','11:45:00',1.71),('8998','2013-03-06','11:50:00',1.44),('8998','2013-03-06','11:55:00',1.17),('8998','2013-03-06','12:45:00',1.38),('8998','2013-03-06','12:50:00',1.27),('8998','2013-03-06','12:55:00',1.15),('8998','2013-03-06','13:00:00',1.13),('8998','2013-03-06','13:05:00',1.18),('8998','2013-03-06','13:15:00',1.14),('8998','2013-03-06','13:20:00',1.31),('8998','2013-03-06','13:25:00',1.24),('8998','2013-03-06','13:30:00',1.05),('8998','2013-03-04','08:15:00',1.35),('8998','2013-03-04','08:20:00',1.3),('8998','2013-03-04','08:25:00',1.37),('8998','2013-03-04','08:30:00',2.01),('8998','2013-03-04','08:35:00',1.74),('8998','2013-03-04','08:40:00',1.73),('8998','2013-03-04','08:45:00',1.34),('8998','2013-03-04','08:50:00',1.32),('8998','2013-03-04','08:55:00',1.21),('8998','2013-03-04','09:00:00',1.31),('8998','2013-03-04','09:05:00',1.3),('8998','2013-03-04','09:10:00',1.25),('8998','2013-03-04','09:15:00',1.16),('8998','2013-03-04','09:20:00',1.14),('8998','2013-03-04','09:25:00',1.09),('8998','2013-03-04','09:30:00',1.14),('8998','2013-03-04','09:35:00',1.26),('8998','2013-03-04','09:40:00',1.31),('8998','2013-03-04','09:45:00',1.32),('8998','2013-03-04','09:50:00',1.37),('8998','2013-03-04','09:55:00',1.28),('8998','2013-03-04','10:00:00',1.23),('8998','2013-03-04','10:05:00',1.34),('8998','2013-03-04','10:10:00',1.41),('8998','2013-03-04','10:15:00',1.36),('8998','2013-03-04','10:20:00',1.53),('8998','2013-03-04','10:25:00',1.47),('8998','2013-03-04','10:30:00',1.37),('8998','2013-03-04','10:35:00',1.61),('8998','2013-03-04','10:40:00',1.65),('8998','2013-03-04','10:45:00',1.74),('8998','2013-03-04','10:50:00',1.88),('8998','2013-03-04','10:55:00',1.93),('8998','2013-03-04','11:00:00',1.83),('8998','2013-03-04','11:05:00',1.88),('8998','2013-03-04','11:10:00',1.93),('8998','2013-03-04','11:15:00',1.88),('8998','2013-03-04','11:20:00',1.8),('8998','2013-03-04','11:25:00',1.75),('8998','2013-03-04','11:30:00',1.77),('8998','2013-03-04','11:35:00',1.94),('8998','2013-03-04','11:40:00',2.15),('8998','2013-03-04','11:45:00',2.06),('8998','2013-03-04','11:50:00',2.09),('8998','2013-03-04','11:55:00',2.09),('8998','2013-03-04','12:00:00',2.11),('8998','2013-03-04','12:05:00',2.17),('8998','2013-03-04','12:10:00',2.19),('8998','2013-03-04','12:15:00',1.78),('8998','2013-03-04','12:20:00',1.98),('8998','2013-03-04','12:25:00',2),('8998','2013-03-04','12:30:00',1.67),('8998','2013-03-04','12:35:00',1.78),('8998','2013-03-04','12:40:00',1.65),('8998','2013-03-04','12:45:00',1.66),('8998','2013-03-04','12:50:00',1.47),('8998','2013-03-04','12:55:00',1.38),('8998','2013-03-04','13:00:00',1.17),('8998','2013-03-04','13:05:00',1.11),('8998','2013-03-04','13:10:00',1.17),('8998','2013-03-04','13:15:00',1.25),('8998','2013-03-04','13:20:00',1.23),('8998','2013-03-04','13:25:00',1.12),('8998','2013-03-04','13:30:00',1.03),('8998','2013-03-03','08:05:00',1.05),('8998','2013-03-03','08:10:00',1.45),('8998','2013-03-03','08:15:00',1.57),('8998','2013-03-03','08:20:00',1.63),('8998','2013-03-03','08:25:00',1.69),('8998','2013-03-03','08:30:00',1.74),('8998','2013-03-03','08:35:00',1.79),('8998','2013-03-03','08:40:00',1.84),('8998','2013-03-03','08:45:00',1.9),('8998','2013-03-03','08:50:00',1.97),('8998','2013-03-03','08:55:00',2.02),('8998','2013-03-03','09:00:00',2.05),('8998','2013-03-03','09:05:00',2.09),('8998','2013-03-03','09:10:00',2.13),('8998','2013-03-03','09:15:00',2.16),('8998','2013-03-03','09:20:00',2.2),('8998','2013-03-03','09:25:00',2.24),('8998','2013-03-03','09:30:00',2.28),('8998','2013-03-03','09:35:00',2.32),('8998','2013-03-03','09:40:00',2.34),('8998','2013-03-03','09:45:00',2.38),('8998','2013-03-03','09:50:00',2.41),('8998','2013-03-03','09:55:00',2.42),('8998','2013-03-03','10:00:00',2.45),('8998','2013-03-03','10:05:00',2.47),('8998','2013-03-03','10:10:00',2.48),('8998','2013-03-03','10:15:00',2.48),('8998','2013-03-03','10:20:00',2.51),('8998','2013-03-03','10:25:00',2.51),('8998','2013-03-03','10:30:00',2.53),('8998','2013-03-03','10:35:00',2.52),('8998','2013-03-03','10:40:00',2.51),('8998','2013-03-03','10:45:00',2.52),('8998','2013-03-03','10:50:00',2.52),('8998','2013-03-03','10:55:00',2.53),('8998','2013-03-03','11:00:00',2.49),('8998','2013-03-03','11:05:00',2.46),('8998','2013-03-03','11:10:00',2.51),('8998','2013-03-03','11:15:00',2.54),('8998','2013-03-03','11:20:00',2.53),('8998','2013-03-03','11:25:00',2.5),('8998','2013-03-03','11:30:00',2.47),('8998','2013-03-03','11:35:00',2.47),('8998','2013-03-03','11:40:00',2.49),('8998','2013-03-03','11:45:00',2.48),('8998','2013-03-03','11:50:00',2.4),('8998','2013-03-03','11:55:00',2.37),('8998','2013-03-03','12:00:00',2.39),('8998','2013-03-03','12:05:00',2.3),('8998','2013-03-03','12:10:00',2.29),('8998','2013-03-03','12:15:00',2.33),('8998','2013-03-03','12:20:00',2.34),('8998','2013-03-03','12:25:00',2.33),('8998','2013-03-03','12:30:00',2.3),('8998','2013-03-03','12:35:00',2.25),('8998','2013-03-03','12:40:00',2.19),('8998','2013-03-03','12:45:00',2.18),('8998','2013-03-03','12:50:00',2.16),('8998','2013-03-03','12:55:00',2.11),('8998','2013-03-03','13:00:00',2.07),('8998','2013-03-03','13:05:00',2.02),('8998','2013-03-03','13:10:00',2.01),('8998','2013-03-03','13:15:00',1.97),('8998','2013-03-03','13:20:00',1.94),('8998','2013-03-03','13:25:00',1.93),('8998','2013-03-03','13:30:00',1.52),('8998','2013-03-03','13:35:00',1.27),('8998','2013-03-03','13:40:00',1.56),('8998','2013-03-03','13:45:00',1.56),('8998','2013-03-03','13:50:00',1.65),('8998','2013-03-03','13:55:00',1.65),('8998','2013-03-03','14:00:00',1.58),('8998','2013-03-03','14:05:00',1.52),('8998','2013-03-03','14:10:00',1.45),('8998','2013-03-03','14:15:00',1.24),('8998','2013-03-03','14:20:00',1.17),('8998','2013-03-03','14:25:00',1.13),('8998','2013-03-03','14:30:00',1.08),('8998','2013-03-03','14:35:00',1.02),('8998','2013-03-02','08:10:00',1.52),('8998','2013-03-02','08:15:00',1.67),('8998','2013-03-02','08:20:00',1.75),('8998','2013-03-02','08:25:00',1.81),('8998','2013-03-02','08:30:00',1.87),('8998','2013-03-02','08:35:00',1.93),('8998','2013-03-02','08:40:00',1.98),('8998','2013-03-02','08:45:00',2.05),('8998','2013-03-02','08:50:00',2.11),('8998','2013-03-02','08:55:00',2.15),('8998','2013-03-02','09:00:00',2.19),('8998','2013-03-02','09:05:00',2.23),('8998','2013-03-02','09:10:00',2.26),('8998','2013-03-02','09:15:00',2.28),('8998','2013-03-02','09:20:00',2.32),('8998','2013-03-02','09:25:00',2.35),('8998','2013-03-02','09:30:00',2.38),('8998','2013-03-02','09:35:00',2.41),('8998','2013-03-02','09:40:00',2.42),('8998','2013-03-02','09:45:00',2.46),('8998','2013-03-02','09:50:00',2.51),('8998','2013-03-02','09:55:00',2.57),('8998','2013-03-02','10:00:00',2.6),('8998','2013-03-02','10:05:00',2.6),('8998','2013-03-02','10:10:00',2.62),('8998','2013-03-02','10:15:00',2.63),('8998','2013-03-02','10:20:00',2.65),('8998','2013-03-02','10:25:00',2.67),('8998','2013-03-02','10:30:00',2.67),('8998','2013-03-02','10:35:00',2.68),('8998','2013-03-02','10:40:00',2.68),('8998','2013-03-02','10:45:00',2.67),('8998','2013-03-02','10:50:00',2.66),('8998','2013-03-02','10:55:00',2.65),('8998','2013-03-02','11:00:00',2.65),('8998','2013-03-02','11:05:00',2.64),('8998','2013-03-02','11:10:00',2.63),('8998','2013-03-02','11:15:00',2.61),('8998','2013-03-02','11:20:00',2.61),('8998','2013-03-02','11:25:00',2.61),('8998','2013-03-02','11:30:00',2.59),('8998','2013-03-02','11:35:00',2.58),('8998','2013-03-02','11:40:00',2.58),('8998','2013-03-02','11:45:00',2.56),('8998','2013-03-02','11:50:00',2.54),('8998','2013-03-02','11:55:00',2.51),('8998','2013-03-02','12:00:00',2.5),('8998','2013-03-02','12:05:00',2.47),('8998','2013-03-02','12:10:00',2.44),('8998','2013-03-02','12:15:00',2.43),('8998','2013-03-02','12:20:00',2.41),('8998','2013-03-02','12:25:00',2.39),('8998','2013-03-02','12:30:00',2.36),('8998','2013-03-02','12:35:00',2.32),('8998','2013-03-02','12:40:00',2.3),('8998','2013-03-02','12:45:00',2.26),('8998','2013-03-02','12:50:00',2.24),('8998','2013-03-02','12:55:00',2.19),('8998','2013-03-02','13:00:00',2.16),('8998','2013-03-02','13:05:00',2.14),('8998','2013-03-02','13:10:00',2.1),('8998','2013-03-02','13:15:00',2.06),('8998','2013-03-02','13:20:00',2.01),('8998','2013-03-02','13:25:00',1.97),('8998','2013-03-02','13:30:00',1.92),('8998','2013-03-02','13:35:00',1.88),('8998','2013-03-02','13:40:00',1.82),('8998','2013-03-02','13:45:00',1.77),('8998','2013-03-02','13:50:00',1.73),('8998','2013-03-02','13:55:00',1.68),('8998','2013-03-02','14:00:00',1.62),('8998','2013-03-02','14:05:00',1.55),('8998','2013-03-02','14:10:00',1.46),('8998','2013-03-02','14:15:00',1.33),('8998','2013-03-02','14:20:00',1.27),('8998','2013-03-02','14:25:00',1.27),('8998','2013-03-02','14:30:00',1.21),('8998','2013-03-02','14:35:00',1.13),('8998','2014-03-23','08:55:00',1.21),('8998','2014-03-23','09:00:00',1.57),('8998','2014-03-23','09:05:00',1),('8998','2014-03-23','09:20:00',1.42),('8998','2014-03-23','09:30:00',1.13),('8998','2014-03-23','09:40:00',1.01),('8998','2014-03-23','10:00:00',1.64),('8998','2014-03-23','10:05:00',2.06),('8998','2014-03-23','10:10:00',2.43),('8998','2014-03-23','10:15:00',2.52),('8998','2014-03-23','10:50:00',3.45),('8998','2014-03-23','10:55:00',3.19),('8998','2014-03-23','11:00:00',1.28),('8998','2014-03-23','11:05:00',1.84),('8998','2014-03-23','11:10:00',1.57),('8998','2014-03-23','11:15:00',2.25),('8998','2014-03-23','11:20:00',1.76),('8998','2014-03-23','11:25:00',1.78),('8998','2014-03-23','11:30:00',2.52),('8998','2014-03-23','11:35:00',1.44),('8998','2014-03-23','12:35:00',1.27),('8998','2014-03-23','12:40:00',1.43),('8998','2014-03-23','12:45:00',1.27),('8998','2014-03-23','12:50:00',1.08),('8998','2014-03-23','12:55:00',1.02),('8998','2014-03-23','13:00:00',1.03),('8998','2014-03-23','13:05:00',1.02),('8998','2014-03-23','14:15:00',1.01),('8998','2014-03-23','14:20:00',1.32),('8998','2014-03-23','14:25:00',1.33),('8998','2014-03-23','14:30:00',1.16),('8998','2014-03-23','14:35:00',1.25),('8998','2014-03-23','14:40:00',1.62),('8998','2014-03-23','14:45:00',1.71),('8998','2014-03-23','14:50:00',1.82),('8998','2014-03-23','14:55:00',1.53),('8998','2014-03-23','15:00:00',1.32),('8998','2014-03-23','15:05:00',1.11),('8998','2014-03-23','15:10:00',1.11),('8998','2013-02-28','08:20:00',1.08),('8998','2013-02-28','08:25:00',1.08),('8998','2013-02-28','08:30:00',1.14),('8998','2013-02-28','08:35:00',1.21),('8998','2013-02-28','08:40:00',1.29),('8998','2013-02-28','08:45:00',1.4),('8998','2013-02-28','08:50:00',1.47),('8998','2013-02-28','08:55:00',1.55),('8998','2013-02-28','09:00:00',1.64),('8998','2013-02-28','09:05:00',1.84),('8998','2013-02-28','09:10:00',1.82),('8998','2013-02-28','09:15:00',1.8),('8998','2013-02-28','09:20:00',1.82),('8998','2013-02-28','09:25:00',1.83),('8998','2013-02-28','09:30:00',2.05),('8998','2013-02-28','09:35:00',1.92),('8998','2013-02-28','09:40:00',1.97),('8998','2013-02-28','09:45:00',2.09),('8998','2013-02-28','09:50:00',2.09),('8998','2013-02-28','09:55:00',2),('8998','2013-02-28','10:00:00',2.03),('8998','2013-02-28','10:05:00',2),('8998','2013-02-28','10:10:00',1.95),('8998','2013-02-28','10:15:00',1.73),('8998','2013-02-28','10:20:00',1.56),('8998','2013-02-28','10:25:00',1.64),('8998','2013-02-28','10:30:00',1.79),('8998','2013-02-28','10:35:00',2.04),('8998','2013-02-28','10:40:00',1.8),('8998','2013-02-28','10:45:00',1.69),('8998','2013-02-28','10:50:00',1.58),('8998','2013-02-28','10:55:00',1.49),('8998','2013-02-28','11:00:00',1.31),('8998','2013-02-28','11:05:00',1.13),('8998','2013-02-28','11:10:00',1.05),('8998','2013-02-28','11:15:00',1.14),('8998','2013-02-28','11:20:00',1.22),('8998','2013-02-28','11:25:00',1.23),('8998','2013-02-28','11:30:00',1.23),('8998','2013-02-28','11:35:00',1.26),('8998','2013-02-28','11:40:00',1.21),('8998','2013-02-28','11:45:00',1.16),('8998','2013-02-28','11:50:00',1.14),('8998','2013-02-28','11:55:00',1.1),('8998','2013-02-28','12:00:00',1.06),('8998','2013-02-28','12:05:00',1.01),('8998','2013-02-28','13:20:00',1.01),('8998','2013-02-28','13:25:00',1.1),('8998','2013-02-28','13:30:00',1.11),('8998','2013-02-28','13:35:00',1.05),('8998','2013-02-27','08:30:00',1.13),('8998','2013-02-27','08:35:00',1.36),('8998','2013-02-27','08:40:00',1.59),('8998','2013-02-27','08:45:00',1.74),('8998','2013-02-27','08:50:00',1.81),('8998','2013-02-27','08:55:00',1.87),('8998','2013-02-27','09:00:00',1.91),('8998','2013-02-27','09:05:00',1.94),('8998','2013-02-27','09:10:00',1.97),('8998','2013-02-27','09:15:00',1.99),('8998','2013-02-27','09:20:00',2.05),('8998','2013-02-27','09:25:00',2.07),('8998','2013-02-27','09:30:00',2.11),('8998','2013-02-27','09:35:00',2.15),('8998','2013-02-27','09:40:00',2.17),('8998','2013-02-27','09:45:00',2.21),('8998','2013-02-27','09:50:00',2.07),('8998','2013-02-27','09:55:00',2.25),('8998','2013-02-27','10:00:00',2.29),('8998','2013-02-27','10:05:00',2.31),('8998','2013-02-27','10:10:00',2.29),('8998','2013-02-27','10:15:00',2.31),('8998','2013-02-27','10:20:00',2.33),('8998','2013-02-27','10:25:00',2.33),('8998','2013-02-27','10:30:00',2.29),('8998','2013-02-27','10:35:00',2.37),('8998','2013-02-27','10:40:00',2.37),('8998','2013-02-27','10:45:00',2.37),('8998','2013-02-27','10:50:00',2.37),('8998','2013-02-27','10:55:00',2.38),('8998','2013-02-27','11:00:00',2.42),('8998','2013-02-27','11:05:00',2.43),('8998','2013-02-27','11:10:00',2.41),('8998','2013-02-27','11:15:00',2.4),('8998','2013-02-27','11:20:00',2.41),('8998','2013-02-27','11:25:00',2.45),('8998','2013-02-27','11:30:00',2.43),('8998','2013-02-27','11:35:00',2.41),('8998','2013-02-27','11:40:00',2.4),('8998','2013-02-27','11:45:00',2.38),('8998','2013-02-27','11:50:00',2.38),('8998','2013-02-27','11:55:00',2.36),('8998','2013-02-27','12:00:00',2.28),('8998','2013-02-27','12:05:00',2.24),('8998','2013-02-27','12:10:00',2.28),('8998','2013-02-27','12:15:00',2.27),('8998','2013-02-27','12:20:00',2.24),('8998','2013-02-27','12:25:00',2.19),('8998','2013-02-27','12:30:00',2.19),('8998','2013-02-27','12:35:00',2.18),('8998','2013-02-27','12:40:00',2.16),('8998','2013-02-27','12:45:00',2.07),('8998','2013-02-27','12:50:00',2.04),('8998','2013-02-27','12:55:00',2.06),('8998','2013-02-27','13:00:00',1.95),('8998','2013-02-27','13:05:00',2.02),('8998','2013-02-27','13:10:00',1.97),('8998','2013-02-27','13:15:00',1.97),('8998','2013-02-27','13:20:00',1.98),('8998','2013-02-27','13:25:00',1.95),('8998','2013-02-27','13:30:00',1.83),('8998','2013-02-27','13:35:00',1.77),('8998','2013-02-27','13:40:00',1.53),('8998','2013-02-27','13:45:00',1.64),('8998','2013-02-27','13:50:00',1.76),('8998','2013-02-27','13:55:00',1.68),('8998','2013-02-27','14:00:00',1.63),('8998','2013-02-27','14:05:00',1.54),('8998','2013-02-27','14:10:00',1.37),('8998','2013-02-27','14:15:00',1.28),('8998','2013-02-27','14:30:00',1),('8998','2013-02-26','08:20:00',1.35),('8998','2013-02-26','08:25:00',1.44),('8998','2013-02-26','08:30:00',1.5),('8998','2013-02-26','08:35:00',1.55),('8998','2013-02-26','08:40:00',1.59),('8998','2013-02-26','08:45:00',1.67),('8998','2013-02-26','08:50:00',1.75),('8998','2013-02-26','08:55:00',1.8),('8998','2013-02-26','09:00:00',1.84),('8998','2013-02-26','09:05:00',1.9),('8998','2013-02-26','09:10:00',1.94),('8998','2013-02-26','09:15:00',1.99),('8998','2013-02-26','09:20:00',2.03),('8998','2013-02-26','09:25:00',2.06),('8998','2013-02-26','09:30:00',2.1),('8998','2013-02-26','09:35:00',2.12),('8998','2013-02-26','09:40:00',2.15),('8998','2013-02-26','09:45:00',2.19),('8998','2013-02-26','09:50:00',2.2),('8998','2013-02-26','09:55:00',2.24),('8998','2013-02-26','10:00:00',2.26),('8998','2013-02-26','10:05:00',2.28),('8998','2013-02-26','10:10:00',2.3),('8998','2013-02-26','10:15:00',2.34),('8998','2013-02-26','10:20:00',2.35),('8998','2013-02-26','10:25:00',2.34),('8998','2013-02-26','10:30:00',2.34),('8998','2013-02-26','10:35:00',2.39),('8998','2013-02-26','10:40:00',2.38),('8998','2013-02-26','10:45:00',2.38),('8998','2013-02-26','10:50:00',2.43),('8998','2013-02-26','10:55:00',2.42),('8998','2013-02-26','11:00:00',2.44),('8998','2013-02-26','11:05:00',2.46),('8998','2013-02-26','11:10:00',2.44),('8998','2013-02-26','11:15:00',2.41),('8998','2013-02-26','11:20:00',2.36),('8998','2013-02-26','11:25:00',2.43),('8998','2013-02-26','11:30:00',2.1),('8998','2013-02-26','11:35:00',1.93),('8998','2013-02-26','11:40:00',1.96),('8998','2013-02-26','11:45:00',2.37),('8998','2013-02-26','11:50:00',2.45),('8998','2013-02-26','11:55:00',2.42),('8998','2013-02-26','12:00:00',2.4),('8998','2013-02-26','12:05:00',2.37),('8998','2013-02-26','12:10:00',2.38),('8998','2013-02-26','12:15:00',2.45),('8998','2013-02-26','12:20:00',2.41),('8998','2013-02-26','12:25:00',2.3),('8998','2013-02-26','12:30:00',2.21),('8998','2013-02-26','12:35:00',2.21),('8998','2013-02-26','12:40:00',2.21),('8998','2013-02-26','12:45:00',2.19),('8998','2013-02-26','12:50:00',2.13),('8998','2013-02-26','12:55:00',2.07),('8998','2013-02-26','13:00:00',2.06),('8998','2013-02-26','13:05:00',2.08),('8998','2013-02-26','13:10:00',2.04),('8998','2013-02-26','13:15:00',1.9),('8998','2013-02-26','13:20:00',1.05),('8998','2013-02-26','13:30:00',1.66),('8998','2013-02-26','13:35:00',1.84),('8998','2013-02-26','13:40:00',1.73),('8998','2013-02-26','13:45:00',1.7),('8998','2013-02-26','13:50:00',1.33),('8998','2013-02-26','13:55:00',1.06),('8998','2013-02-26','14:00:00',1.18),('8998','2013-02-26','14:10:00',1.14),('8998','2013-02-26','14:20:00',1.07),('8998','2013-02-26','14:25:00',1),('8998','2013-02-25','09:30:00',1.03),('8998','2013-02-25','09:35:00',1.3),('8998','2013-02-25','09:40:00',1.46),('8998','2013-02-25','09:45:00',1.45),('8998','2013-02-25','09:50:00',1.47),('8998','2013-02-25','09:55:00',1.64),('8998','2013-02-25','10:00:00',1.54),('8998','2013-02-25','10:05:00',1.55),('8998','2013-02-25','10:10:00',1.84),('8998','2013-02-25','10:15:00',2.11),('8998','2013-02-25','10:20:00',2.44),('8998','2013-02-25','10:25:00',2.62),('8998','2013-02-25','10:30:00',2.48),('8998','2013-02-25','10:35:00',2.21),('8998','2013-02-25','10:40:00',1.54),('8998','2013-02-25','10:50:00',1.17),('8998','2013-02-25','10:55:00',1.26),('8998','2013-02-25','11:00:00',1.38),('8998','2013-02-25','11:05:00',1.52),('8998','2013-02-25','11:10:00',1.53),('8998','2013-02-25','11:15:00',1.42),('8998','2013-02-25','11:20:00',1.13),('8998','2013-02-25','11:25:00',1.07),('8998','2013-02-25','11:30:00',1.04),('8998','2013-02-25','11:35:00',1.02),('8998','2013-02-25','11:40:00',1.12),('8998','2013-02-25','11:45:00',1.06),('8998','2013-02-25','11:50:00',1.27),('8998','2013-02-25','11:55:00',1.22),('8998','2013-02-25','12:00:00',1.24),('8998','2013-02-25','12:05:00',1.2),('8998','2013-02-25','12:10:00',1.22),('8998','2013-02-25','12:15:00',1.07),('8998','2013-02-25','12:20:00',1.06),('8998','2013-02-24','08:50:00',1.07),('8998','2013-02-24','09:00:00',1.09),('8998','2013-02-24','09:30:00',1.12),('8998','2013-02-24','09:35:00',1.12),('8998','2013-02-24','10:45:00',1.08),('8998','2013-02-24','10:50:00',2.07),('8998','2013-02-24','10:55:00',2.9),('8998','2013-02-24','11:00:00',3.31),('8998','2013-02-24','11:05:00',1.88),('8998','2013-02-24','11:10:00',1.35),('8998','2013-02-24','11:15:00',1.15),('8998','2013-02-24','11:30:00',1.24),('8998','2013-02-24','11:45:00',1.04),('8998','2013-02-24','11:50:00',1.3),('8998','2013-02-24','11:55:00',3.08),('8998','2013-02-24','12:00:00',1.92),('8998','2013-02-24','12:05:00',1.44),('8998','2013-02-24','12:10:00',1.18),('8998','2013-02-24','12:15:00',1.58),('8998','2013-02-24','12:20:00',2.51),('8998','2013-02-24','12:25:00',2.69),('8998','2013-02-24','12:30:00',2.39),('8998','2013-02-24','12:35:00',1.68),('8998','2013-02-24','12:40:00',2.45),('8998','2013-02-24','12:45:00',2.3),('8998','2013-02-24','12:50:00',2.17),('8998','2013-02-24','12:55:00',2.11),('8998','2013-02-24','13:00:00',2.21),('8998','2013-02-24','13:05:00',1.66),('8998','2013-02-24','13:10:00',1.99),('8998','2013-02-24','13:15:00',1.44),('8998','2013-02-24','13:20:00',1.23),('8998','2013-02-24','13:30:00',1.07),('8998','2013-02-23','13:05:00',1.12),('8998','2013-02-23','13:10:00',1.06),('8998','2013-02-23','14:05:00',1.02),('8998','2013-02-23','14:10:00',1.03),('8998','2013-02-22','08:15:00',1.13),('8998','2013-02-22','09:00:00',1.02),('8998','2013-02-22','09:05:00',1.06),('8998','2014-03-22','08:35:00',1.01),('8998','2014-03-22','08:55:00',1.38),('8998','2014-03-22','09:05:00',1.27),('8998','2014-03-22','09:10:00',2.11),('8998','2014-03-22','09:15:00',2.11),('8998','2014-03-22','09:20:00',1.49),('8998','2014-03-22','10:55:00',1.06),('8998','2014-03-22','11:40:00',2.64),('8998','2014-03-22','13:45:00',1.35),('8998','2014-03-22','13:50:00',1.27),('8998','2014-03-22','15:15:00',1.15),('8998','2014-03-22','15:25:00',1.24),('8998','2013-02-19','08:25:00',1.11),('8998','2013-02-19','08:30:00',1.54),('8998','2013-02-19','08:35:00',1.6),('8998','2013-02-19','08:40:00',1.66),('8998','2013-02-19','08:45:00',1.74),('8998','2013-02-19','08:50:00',1.79),('8998','2013-02-19','08:55:00',1.84),('8998','2013-02-19','09:00:00',1.88),('8998','2013-02-19','09:05:00',1.28),('8998','2013-02-19','09:10:00',1.08),('8998','2013-02-19','09:15:00',1.38),('8998','2013-02-19','09:20:00',1.01),('8998','2013-02-19','09:25:00',1.39),('8998','2013-02-19','09:30:00',2.2),('8998','2013-02-19','09:35:00',1.61),('8998','2013-02-19','09:50:00',1.15),('8998','2013-02-19','09:55:00',1.8),('8998','2013-02-19','10:00:00',1.07),('8998','2013-02-19','10:10:00',1.49),('8998','2013-02-19','10:50:00',2.1),('8998','2013-02-19','10:55:00',2.51),('8998','2013-02-19','11:10:00',2.6),('8998','2013-02-19','11:15:00',2.58),('8998','2013-02-19','11:20:00',1.12),('8998','2013-02-19','11:25:00',2.2),('8998','2013-02-19','11:30:00',1.5),('8998','2013-02-19','11:35:00',2.14),('8998','2013-02-19','11:40:00',2.73),('8998','2013-02-19','11:45:00',2.53),('8998','2013-02-19','11:50:00',2.85),('8998','2013-02-19','11:55:00',1.73),('8998','2013-02-19','12:00:00',2.32),('8998','2013-02-19','12:05:00',1.15),('8998','2013-02-19','12:10:00',2),('8998','2013-02-19','12:15:00',1.63),('8998','2013-02-19','12:25:00',1.41),('8998','2013-02-19','12:30:00',2.91),('8998','2013-02-19','12:35:00',2.16),('8998','2013-02-19','12:40:00',1.67),('8998','2013-02-19','13:00:00',1.12),('8998','2013-02-19','13:05:00',2.18),('8998','2013-02-19','13:10:00',1.8),('8998','2013-02-19','13:15:00',2.4),('8998','2013-02-19','13:20:00',1.41),('8998','2013-02-19','13:30:00',1.65),('8998','2013-02-18','08:25:00',1.31),('8998','2013-02-18','08:30:00',1.5),('8998','2013-02-18','08:35:00',1.57),('8998','2013-02-18','08:40:00',1.62),('8998','2013-02-18','08:45:00',1.7),('8998','2013-02-18','08:50:00',1.76),('8998','2013-02-18','08:55:00',1.8),('8998','2013-02-18','09:00:00',1.84),('8998','2013-02-18','09:05:00',1.88),('8998','2013-02-18','09:10:00',1.92),('8998','2013-02-18','09:15:00',1.97),('8998','2013-02-18','09:20:00',2.01),('8998','2013-02-18','09:25:00',2.05),('8998','2013-02-18','09:30:00',2.08),('8998','2013-02-18','09:35:00',2.1),('8998','2013-02-18','09:40:00',2.11),('8998','2013-02-18','09:45:00',2.15),('8998','2013-02-18','09:50:00',2.17),('8998','2013-02-18','09:55:00',2.2),('8998','2013-02-18','10:00:00',2.22),('8998','2013-02-18','10:05:00',2.24),('8998','2013-02-18','10:10:00',2.26),('8998','2013-02-18','10:15:00',2.29),('8998','2013-02-18','10:20:00',2.3),('8998','2013-02-18','10:25:00',2.32),('8998','2013-02-18','10:30:00',2.33),('8998','2013-02-18','10:35:00',2.34),('8998','2013-02-18','10:40:00',2.35),('8998','2013-02-18','10:45:00',2.34),('8998','2013-02-18','10:50:00',2.35),('8998','2013-02-18','10:55:00',2.33),('8998','2013-02-18','11:00:00',2.35),('8998','2013-02-18','11:05:00',2.38),('8998','2013-02-18','11:10:00',2.36),('8998','2013-02-18','11:15:00',2.37),('8998','2013-02-18','11:20:00',2.38),('8998','2013-02-18','11:25:00',2.38),('8998','2013-02-18','11:30:00',2.35),('8998','2013-02-18','11:35:00',2.36),('8998','2013-02-18','11:40:00',2.34),('8998','2013-02-18','11:45:00',2.32),('8998','2013-02-18','11:50:00',2.32),('8998','2013-02-18','11:55:00',2.29),('8998','2013-02-18','12:00:00',2.26),('8998','2013-02-18','12:05:00',2.26),('8998','2013-02-18','12:10:00',2.22),('8998','2013-02-18','12:15:00',2.18),('8998','2013-02-18','12:20:00',2.16),('8998','2013-02-18','12:25:00',2.14),('8998','2013-02-18','12:30:00',2.12),('8998','2013-02-18','12:35:00',2.09),('8998','2013-02-18','12:40:00',2.08),('8998','2013-02-18','12:45:00',2.05),('8998','2013-02-18','12:50:00',2.03),('8998','2013-02-18','12:55:00',2),('8998','2013-02-18','13:00:00',1.96),('8998','2013-02-18','13:05:00',1.94),('8998','2013-02-18','13:10:00',1.88),('8998','2013-02-18','13:15:00',1.83),('8998','2013-02-18','13:20:00',1.76),('8998','2013-02-18','13:25:00',1.77),('8998','2013-02-18','13:30:00',1.73),('8998','2013-02-18','13:35:00',1.7),('8998','2013-02-18','13:40:00',1.64),('8998','2013-02-18','13:45:00',1.6),('8998','2013-02-18','13:50:00',1.56),('8998','2013-02-18','13:55:00',1.44),('8998','2013-02-18','14:00:00',1.28),('8998','2013-02-18','14:05:00',1.18),('8998','2013-02-18','14:10:00',1.11),('8998','2013-02-18','14:15:00',1.04),('8998','2013-02-17','08:35:00',1.37),('8998','2013-02-17','08:40:00',1.53),('8998','2013-02-17','08:45:00',1.59),('8998','2013-02-17','08:50:00',1.6),('8998','2013-02-17','08:55:00',1.66),('8998','2013-02-17','09:00:00',1.69),('8998','2013-02-17','09:05:00',1.75),('8998','2013-02-17','09:10:00',1.8),('8998','2013-02-17','09:15:00',1.81),('8998','2013-02-17','09:20:00',2.04),('8998','2013-02-17','09:25:00',2.13),('8998','2013-02-17','09:30:00',1.97),('8998','2013-02-17','09:35:00',1.1),('8998','2013-02-17','09:50:00',1.21),('8998','2013-02-17','10:10:00',1.04),('8998','2013-02-17','11:25:00',1.08),('8998','2013-02-17','11:55:00',1.05),('8998','2013-02-17','12:00:00',1.12),('8998','2013-02-17','12:05:00',1.07),('8998','2013-02-17','12:10:00',1.01),('8998','2013-02-17','12:45:00',1.05),('8998','2013-02-17','12:50:00',1.1),('8998','2013-02-17','12:55:00',1),('8998','2013-02-17','13:05:00',1),('8998','2013-02-17','13:15:00',1.15),('8998','2013-02-17','13:25:00',1.18),('8998','2013-02-17','13:30:00',1.07),('8998','2013-02-17','14:00:00',1.04),('8998','2013-02-16','08:30:00',1.33),('8998','2013-02-16','08:35:00',1.47),('8998','2013-02-16','08:40:00',1.6),('8998','2013-02-16','08:45:00',1.53),('8998','2013-02-16','08:50:00',1.36),('8998','2013-02-16','08:55:00',1.5),('8998','2013-02-16','09:00:00',1.64),('8998','2013-02-16','09:05:00',1.64),('8998','2013-02-16','09:10:00',1.73),('8998','2013-02-16','09:15:00',1.78),('8998','2013-02-16','09:20:00',1.87),('8998','2013-02-16','09:25:00',1.9),('8998','2013-02-16','09:30:00',1.91),('8998','2013-02-16','09:35:00',1.95),('8998','2013-02-16','09:40:00',1.98),('8998','2013-02-16','09:45:00',2.02),('8998','2013-02-16','09:50:00',2.05),('8998','2013-02-16','09:55:00',2.08),('8998','2013-02-16','10:00:00',2.12),('8998','2013-02-16','10:05:00',2.14),('8998','2013-02-16','10:10:00',2.14),('8998','2013-02-16','10:15:00',2.17),('8998','2013-02-16','10:20:00',2.2),('8998','2013-02-16','10:25:00',2.2),('8998','2013-02-16','10:30:00',2.23),('8998','2013-02-16','10:35:00',2.24),('8998','2013-02-16','10:40:00',2.25),('8998','2013-02-16','10:45:00',2.24),('8998','2013-02-16','10:50:00',2.26),('8998','2013-02-16','10:55:00',2.26),('8998','2013-02-16','11:00:00',2.25),('8998','2013-02-16','11:05:00',2.26),('8998','2013-02-16','11:10:00',2.25),('8998','2013-02-16','11:15:00',2.26),('8998','2013-02-16','11:20:00',2.25),('8998','2013-02-16','11:25:00',2.23),('8998','2013-02-16','11:30:00',2.23),('8998','2013-02-16','11:35:00',2.22),('8998','2013-02-16','11:40:00',2.21),('8998','2013-02-16','11:45:00',2.19),('8998','2013-02-16','11:50:00',2.18),('8998','2013-02-16','11:55:00',2.18),('8998','2013-02-16','12:00:00',2.16),('8998','2013-02-16','12:05:00',2.15),('8998','2013-02-16','12:10:00',2.15),('8998','2013-02-16','12:15:00',2.13),('8998','2013-02-16','12:20:00',2.11),('8998','2013-02-16','12:25:00',2.08),('8998','2013-02-16','12:30:00',2.05),('8998','2013-02-16','12:35:00',2.03),('8998','2013-02-16','12:40:00',1.99),('8998','2013-02-16','12:45:00',1.93),('8998','2013-02-16','12:50:00',1.87),('8998','2013-02-16','12:55:00',1.85),('8998','2013-02-16','13:00:00',1.85),('8998','2013-02-16','13:05:00',1.82),('8998','2013-02-16','13:10:00',1.77),('8998','2013-02-16','13:15:00',1.73),('8998','2013-02-16','13:20:00',1.66),('8998','2013-02-16','13:25:00',1.65),('8998','2013-02-16','13:30:00',1.63),('8998','2013-02-16','13:35:00',1.58),('8998','2013-02-16','13:40:00',1.51),('8998','2013-02-16','13:45:00',1.45),('8998','2013-02-16','13:50:00',1.33),('8998','2013-02-16','13:55:00',1.27),('8998','2013-02-16','14:15:00',1.07),('8998','2013-02-15','08:35:00',1.33),('8998','2013-02-15','08:40:00',1.49),('8998','2013-02-15','08:45:00',1.49),('8998','2013-02-15','09:15:00',1.95),('8998','2013-02-15','09:20:00',1.98),('8998','2013-02-15','09:25:00',1.99),('8998','2013-02-15','09:30:00',2.02),('8998','2013-02-15','09:35:00',2.05),('8998','2013-02-15','09:40:00',2.06),('8998','2013-02-15','09:45:00',2.09),('8998','2013-02-15','09:50:00',2.15),('8998','2013-02-15','09:55:00',2.15),('8998','2013-02-15','10:00:00',2.14),('8998','2013-02-15','10:05:00',2.17),('8998','2013-02-15','10:10:00',2.22),('8998','2013-02-15','10:15:00',2.21),('8998','2013-02-15','10:20:00',2.25),('8998','2013-02-15','10:25:00',2.25),('8998','2013-02-15','10:30:00',2.3),('8998','2013-02-15','10:35:00',2.35),('8998','2013-02-15','10:40:00',2.41),('8998','2013-02-15','10:45:00',2.41),('8998','2013-02-15','10:50:00',2.38),('8998','2013-02-15','10:55:00',2.36),('8998','2013-02-15','11:00:00',2.33),('8998','2013-02-15','11:05:00',2.29),('8998','2013-02-15','11:10:00',2.36),('8998','2013-02-15','11:15:00',2.37),('8998','2013-02-15','11:20:00',2.23),('8998','2013-02-15','11:25:00',2.27),('8998','2013-02-15','11:30:00',2.31),('8998','2013-02-15','11:35:00',2.31),('8998','2013-02-15','11:40:00',2.29),('8998','2013-02-15','11:45:00',2.3),('8998','2013-02-15','11:50:00',2.3),('8998','2013-02-15','11:55:00',2.28),('8998','2013-02-15','12:00:00',2.25),('8998','2013-02-15','12:05:00',2.21),('8998','2013-02-15','12:10:00',2.2),('8998','2013-02-15','12:15:00',2.17),('8998','2013-02-15','12:20:00',2.15),('8998','2013-02-15','12:25:00',2.12),('8998','2013-02-15','12:30:00',2.09),('8998','2013-02-15','12:35:00',2.07),('8998','2013-02-15','12:40:00',2.05),('8998','2013-02-15','12:45:00',2.03),('8998','2013-02-15','12:50:00',2.01),('8998','2013-02-15','12:55:00',1.97),('8998','2013-02-15','13:00:00',1.93),('8998','2013-02-15','13:05:00',1.89),('8998','2013-02-15','13:10:00',1.84),('8998','2013-02-15','13:15:00',1.8),('8998','2013-02-15','13:20:00',1.76),('8998','2013-02-15','13:25:00',1.72),('8998','2013-02-15','13:30:00',1.68),('8998','2013-02-15','13:35:00',1.64),('8998','2013-02-15','13:40:00',1.61),('8998','2013-02-15','13:45:00',1.56),('8998','2013-02-15','13:50:00',1.45),('8998','2013-02-15','13:55:00',1.43),('8998','2013-02-15','14:00:00',1.31),('8998','2013-02-15','14:05:00',1.23),('8998','2013-02-15','14:10:00',1.17),('8998','2013-02-15','14:15:00',1.14),('8998','2013-02-14','09:25:00',1.3),('8998','2013-02-14','09:30:00',1.14),('8998','2013-02-14','10:00:00',1.23),('8998','2013-02-14','10:05:00',1.36),('8998','2013-02-14','10:10:00',1.13),('8998','2013-02-14','10:15:00',1.01),('8998','2013-02-14','10:25:00',1.74),('8998','2013-02-14','10:30:00',1.35),('8998','2013-02-14','10:35:00',2.06),('8998','2013-02-14','10:40:00',2.11),('8998','2013-02-14','10:45:00',2.13),('8998','2013-02-14','10:50:00',2.29),('8998','2013-02-14','10:55:00',1.42),('8998','2013-02-14','11:00:00',1.29),('8998','2013-02-14','11:05:00',1.36),('8998','2013-02-14','11:10:00',1.56),('8998','2013-02-14','11:15:00',1.85),('8998','2013-02-14','11:20:00',2.42),('8998','2013-02-14','11:25:00',2.42),('8998','2013-02-14','11:30:00',2.39),('8998','2013-02-14','11:35:00',1.92),('8998','2013-02-14','11:40:00',1.31),('8998','2013-02-14','11:45:00',1.31),('8998','2013-02-14','11:50:00',2.31),('8998','2013-02-14','11:55:00',2.22),('8998','2013-02-14','12:00:00',1.84),('8998','2013-02-14','12:05:00',1.78),('8998','2013-02-14','12:10:00',1.91),('8998','2013-02-14','12:15:00',1.84),('8998','2013-02-14','12:20:00',2.43),('8998','2013-02-14','12:25:00',2.07),('8998','2013-02-14','12:30:00',2.11),('8998','2013-02-14','12:35:00',2.13),('8998','2013-02-14','12:40:00',2.07),('8998','2013-02-14','12:45:00',2.04),('8998','2013-02-14','12:50:00',1.99),('8998','2013-02-14','12:55:00',1.96),('8998','2013-02-14','13:00:00',1.9),('8998','2013-02-14','13:05:00',1.86),('8998','2013-02-14','13:10:00',1.83),('8998','2013-02-14','13:15:00',1.79),('8998','2013-02-14','13:20:00',1.63),('8998','2013-02-14','13:25:00',1.47),('8998','2013-02-14','13:30:00',1.27),('8998','2013-02-14','13:35:00',1.38),('8998','2013-02-14','13:40:00',1.76),('8998','2013-02-14','13:45:00',1.42),('8998','2013-02-14','13:50:00',1.43),('8998','2013-02-14','13:55:00',1.52),('8998','2013-02-14','14:00:00',1.1),('8998','2013-02-14','14:05:00',1.24),('8998','2013-02-14','14:10:00',1.47),('8998','2013-02-14','14:15:00',1.07),('8998','2013-02-14','14:20:00',1.08),('8998','2013-02-13','08:30:00',1.02),('8998','2013-02-13','08:35:00',1.49),('8998','2013-02-13','08:40:00',1.63),('8998','2013-02-13','08:45:00',1.69),('8998','2013-02-13','08:50:00',1.74),('8998','2013-02-13','08:55:00',1.79),('8998','2013-02-13','09:00:00',1.84),('8998','2013-02-13','09:05:00',1.88),('8998','2013-02-13','09:10:00',1.93),('8998','2013-02-13','09:15:00',1.97),('8998','2013-02-13','09:20:00',2.01),('8998','2013-02-13','09:25:00',2.05),('8998','2013-02-13','09:30:00',2.09),('8998','2013-02-13','09:35:00',2.12),('8998','2013-02-13','09:40:00',2.15),('8998','2013-02-13','09:45:00',2.18),('8998','2013-02-13','09:50:00',2.2),('8998','2013-02-13','09:55:00',2.24),('8998','2013-02-13','10:00:00',2.26),('8998','2013-02-13','10:05:00',2.29),('8998','2013-02-13','10:10:00',2.32),('8998','2013-02-13','10:15:00',2.33),('8998','2013-02-13','10:20:00',2.34),('8998','2013-02-13','10:25:00',2.36),('8998','2013-02-13','10:30:00',2.36),('8998','2013-02-13','10:35:00',2.37),('8998','2013-02-13','10:40:00',2.38),('8998','2013-02-13','10:45:00',2.39),('8998','2013-02-13','10:50:00',2.4),('8998','2013-02-13','10:55:00',2.4),('8998','2013-02-13','11:00:00',2.4),('8998','2013-02-13','11:05:00',2.4),('8998','2013-02-13','11:10:00',2.39),('8998','2013-02-13','11:15:00',2.39),('8998','2013-02-13','11:20:00',2.38),('8998','2013-02-13','11:25:00',2.37),('8998','2013-02-13','11:30:00',2.36),('8998','2013-02-13','11:35:00',2.35),('8998','2013-02-13','11:40:00',2.32),('8998','2013-02-13','11:45:00',2.32),('8998','2013-02-13','11:50:00',2.31),('8998','2013-02-13','11:55:00',2.3),('8998','2013-02-13','12:00:00',2.27),('8998','2013-02-13','12:05:00',2.25),('8998','2013-02-13','12:10:00',2.22),('8998','2013-02-13','12:15:00',2.2),('8998','2013-02-13','12:20:00',2.18),('8998','2013-02-13','12:25:00',2.16),('8998','2013-02-13','12:30:00',2.12),('8998','2013-02-13','12:35:00',2.09),('8998','2013-02-13','12:40:00',2.06),('8998','2013-02-13','12:45:00',2.02),('8998','2013-02-13','12:50:00',1.98),('8998','2013-02-13','12:55:00',1.95),('8998','2013-02-13','13:00:00',1.91),('8998','2013-02-13','13:05:00',1.87),('8998','2013-02-13','13:10:00',1.84),('8998','2013-02-13','13:15:00',1.81),('8998','2013-02-13','13:20:00',1.76),('8998','2013-02-13','13:25:00',1.71),('8998','2013-02-13','13:30:00',1.66),('8998','2013-02-13','13:35:00',1.62),('8998','2013-02-13','13:40:00',1.58),('8998','2013-02-13','13:45:00',1.52),('8998','2013-02-13','13:50:00',1.45),('8998','2013-02-13','13:55:00',1.36),('8998','2013-02-13','14:00:00',1.28),('8998','2013-02-13','14:05:00',1.17),('8998','2013-02-13','14:10:00',1.13),('8998','2013-02-13','14:15:00',1.07),('8998','2013-02-12','09:05:00',1.09),('8998','2013-02-12','09:10:00',1.17),('8998','2013-02-12','09:15:00',1.1),('8998','2013-02-12','09:20:00',1.09),('8998','2013-02-12','09:25:00',1.07),('8998','2013-02-12','09:30:00',1.18),('8998','2013-02-12','09:35:00',1.4),('8998','2013-02-12','09:40:00',1.89),('8998','2013-02-12','09:45:00',2.09),('8998','2013-02-12','09:50:00',2.06),('8998','2013-02-12','09:55:00',2.06),('8998','2013-02-12','10:00:00',1.86),('8998','2013-02-12','10:05:00',2.05),('8998','2013-02-12','10:10:00',2.15),('8998','2013-02-12','10:15:00',2.26),('8998','2013-02-12','10:20:00',2.26),('8998','2013-02-12','10:25:00',2.36),('8998','2013-02-12','10:30:00',2.39),('8998','2013-02-12','10:35:00',2.36),('8998','2013-02-12','10:40:00',2.43),('8998','2013-02-12','10:45:00',2.54),('8998','2013-02-12','10:50:00',2.53),('8998','2013-02-12','10:55:00',2.47),('8998','2013-02-12','11:00:00',2.46),('8998','2013-02-12','11:05:00',2.34),('8998','2013-02-12','11:10:00',2.36),('8998','2013-02-12','11:15:00',2.36),('8998','2013-02-12','11:20:00',2.31),('8998','2013-02-12','11:25:00',1.98),('8998','2013-02-12','11:30:00',1.77),('8998','2013-02-12','11:35:00',1.49),('8998','2013-02-12','11:50:00',1.27),('8998','2013-02-12','12:15:00',1.68),('8998','2013-02-12','12:20:00',1.1),('8998','2013-02-12','12:25:00',1.36),('8998','2013-02-12','12:50:00',1.26),('8998','2013-02-12','12:55:00',1.38),('8998','2013-02-12','13:00:00',1.51),('8998','2013-02-12','13:05:00',1.57),('8998','2013-02-12','13:10:00',1.34),('8998','2013-02-12','13:15:00',1.08),('8998','2013-02-12','13:20:00',1.83),('8998','2013-02-12','13:25:00',1.83),('8998','2013-02-12','13:30:00',1.86),('8998','2013-02-12','13:35:00',1.77),('8998','2013-02-12','13:40:00',1.59),('8998','2013-02-12','13:45:00',1.43),('8998','2013-02-12','13:50:00',1.19),('8998','2013-02-12','13:55:00',1.2),('8998','2013-02-12','14:00:00',1.35),('8998','2013-02-12','14:05:00',1.26),('8998','2013-02-12','14:10:00',1.02),('8998','2013-02-10','14:30:00',1.17),('8998','2014-03-21','07:40:00',1.15),('8998','2014-03-21','07:50:00',1.13),('8998','2014-03-21','08:15:00',1.22),('8998','2014-03-21','08:20:00',1.59),('8998','2014-03-21','08:25:00',1.61),('8998','2014-03-21','08:30:00',1.82),('8998','2014-03-21','08:40:00',1.84),('8998','2014-03-21','08:45:00',2.13),('8998','2014-03-21','08:50:00',1.43),('8998','2014-03-21','08:55:00',1.16),('8998','2014-03-21','09:00:00',1.78),('8998','2014-03-21','09:05:00',1.03),('8998','2014-03-21','09:10:00',1.05),('8998','2014-03-21','09:25:00',1.28),('8998','2014-03-21','09:30:00',2),('8998','2014-03-21','09:35:00',1.7),('8998','2014-03-21','09:40:00',2.11),('8998','2014-03-21','09:45:00',2.53),('8998','2014-03-21','09:50:00',2.42),('8998','2014-03-21','09:55:00',2.46),('8998','2014-03-21','10:00:00',2.52),('8998','2014-03-21','10:05:00',2.52),('8998','2014-03-21','10:10:00',2.79),('8998','2014-03-21','10:15:00',1.41),('8998','2014-03-21','10:35:00',1.02),('8998','2014-03-21','10:40:00',1.59),('8998','2014-03-21','10:45:00',1.91),('8998','2014-03-21','10:50:00',2.72),('8998','2014-03-21','10:55:00',1.18),('8998','2014-03-21','11:20:00',2.21),('8998','2014-03-21','11:25:00',2.9),('8998','2014-03-21','11:30:00',2.98),('8998','2014-03-21','11:35:00',1.08),('8998','2014-03-21','11:40:00',1.72),('8998','2014-03-21','11:45:00',1.36),('8998','2014-03-21','11:50:00',1.53),('8998','2014-03-21','11:55:00',2.25),('8998','2014-03-21','12:00:00',2.37),('8998','2014-03-21','12:05:00',1.21),('8998','2014-03-21','12:15:00',1.09),('8998','2014-03-21','12:20:00',1.98),('8998','2014-03-21','12:25:00',2.49),('8998','2014-03-21','12:30:00',1.2),('8998','2014-03-21','12:35:00',1.89),('8998','2014-03-21','12:40:00',1.08),('8998','2014-03-21','12:45:00',2.56),('8998','2014-03-21','12:50:00',1.63),('8998','2014-03-21','12:55:00',1.78),('8998','2014-03-21','13:00:00',1.53),('8998','2014-03-21','13:10:00',2.42),('8998','2014-03-21','13:15:00',1.51),('8998','2014-03-21','13:20:00',1.9),('8998','2014-03-21','13:25:00',2.02),('8998','2014-03-21','13:30:00',1.7),('8998','2014-03-21','13:35:00',2.02),('8998','2014-03-21','13:40:00',1.34),('8998','2014-03-21','13:45:00',2.37),('8998','2014-03-21','13:50:00',1.25),('8998','2014-03-21','13:55:00',1.19),('8998','2014-03-21','14:00:00',1.32),('8998','2014-03-21','14:10:00',1.75),('8998','2014-03-21','14:15:00',1.49),('8998','2014-03-21','14:20:00',1.5),('8998','2014-03-21','14:25:00',1.54),('8998','2014-03-21','14:30:00',1.45),('8998','2014-03-21','14:35:00',1.37),('8998','2014-03-21','14:40:00',1.31),('8998','2014-03-21','14:45:00',1.25),('8998','2014-03-21','14:50:00',1.16),('8998','2014-03-21','14:55:00',1.13),('8998','2014-03-21','15:00:00',1.07),('8998','2014-03-21','15:05:00',1),('8998','2013-02-09','09:45:00',1.03),('8998','2013-02-09','09:50:00',1.17),('8998','2013-02-09','10:00:00',1.98),('8998','2013-02-09','10:05:00',2.29),('8998','2013-02-09','10:10:00',2.22),('8998','2013-02-09','10:15:00',2.27),('8998','2013-02-09','10:20:00',2.28),('8998','2013-02-09','10:25:00',2.29),('8998','2013-02-09','10:30:00',2.3),('8998','2013-02-09','10:35:00',2.3),('8998','2013-02-09','10:40:00',2.3),('8998','2013-02-09','10:45:00',2.32),('8998','2013-02-09','10:50:00',2.33),('8998','2013-02-09','10:55:00',2.33),('8998','2013-02-09','11:00:00',2.33),('8998','2013-02-09','11:05:00',2.32),('8998','2013-02-09','11:10:00',2.31),('8998','2013-02-09','11:15:00',2.3),('8998','2013-02-09','11:20:00',2.29),('8998','2013-02-09','11:25:00',2.27),('8998','2013-02-09','11:30:00',2.27),('8998','2013-02-09','11:35:00',2.26),('8998','2013-02-09','11:40:00',2.25),('8998','2013-02-09','11:45:00',2.24),('8998','2013-02-09','11:50:00',2.23),('8998','2013-02-09','11:55:00',2.23),('8998','2013-02-09','12:00:00',2.23),('8998','2013-02-09','12:05:00',2.2),('8998','2013-02-09','12:10:00',2.2),('8998','2013-02-09','12:15:00',2.18),('8998','2013-02-09','12:20:00',2.14),('8998','2013-02-09','12:25:00',2.11),('8998','2013-02-09','12:30:00',2.08),('8998','2013-02-09','12:35:00',2.05),('8998','2013-02-09','12:40:00',2.01),('8998','2013-02-09','12:45:00',1.98),('8998','2013-02-09','12:50:00',1.97),('8998','2013-02-09','12:55:00',1.93),('8998','2013-02-09','13:00:00',1.87),('8998','2013-02-09','13:05:00',1.82),('8998','2013-02-09','13:10:00',1.78),('8998','2013-02-09','13:15:00',1.74),('8998','2013-02-09','13:20:00',1.71),('8998','2013-02-09','13:25:00',1.67),('8998','2013-02-09','13:30:00',1.61),('8998','2013-02-09','13:35:00',1.55),('8998','2013-02-09','13:40:00',1.49),('8998','2013-02-09','13:45:00',1.41),('8998','2013-02-09','13:50:00',1.34),('8998','2013-02-09','13:55:00',1.24),('8998','2013-02-09','14:00:00',1.12),('8998','2013-02-08','13:10:00',1.1),('8998','2013-02-08','13:15:00',1.19),('8998','2013-02-08','13:20:00',1.27),('8998','2013-02-08','13:25:00',1.32),('8998','2013-02-08','13:30:00',1.51),('8998','2013-02-08','13:35:00',1.48),('8998','2013-02-08','13:40:00',1.5),('8998','2013-02-08','13:45:00',1.55),('8998','2013-02-08','13:50:00',1.61),('8998','2013-02-08','13:55:00',1.51),('8998','2013-02-08','14:00:00',1.43),('8998','2013-02-08','14:05:00',1.26),('8998','2013-02-08','14:10:00',1.02),('8998','2013-02-08','14:15:00',1.25),('8998','2013-02-08','14:20:00',1.39),('8998','2013-02-08','14:25:00',1.37),('8998','2013-02-08','14:30:00',1.07),('8998','2013-02-07','09:35:00',1.75),('8998','2013-02-07','09:40:00',2.19),('8998','2013-02-07','09:45:00',2.11),('8998','2013-02-07','09:50:00',2.49),('8998','2013-02-07','09:55:00',2.49),('8998','2013-02-07','10:00:00',2.59),('8998','2013-02-07','10:05:00',2.72),('8998','2013-02-07','10:10:00',2.77),('8998','2013-02-07','10:15:00',2.85),('8998','2013-02-07','10:20:00',2.71),('8998','2013-02-07','10:25:00',2.64),('8998','2013-02-07','10:30:00',2.74),('8998','2013-02-07','10:35:00',1.32),('8998','2013-02-07','10:40:00',1.94),('8998','2013-02-07','10:45:00',2.56),('8998','2013-02-07','10:50:00',2.65),('8998','2013-02-07','10:55:00',2.58),('8998','2013-02-07','11:00:00',2.49),('8998','2013-02-07','11:05:00',2.44),('8998','2013-02-07','11:10:00',2.42),('8998','2013-02-07','11:15:00',2.38),('8998','2013-02-07','11:20:00',2.37),('8998','2013-02-07','11:25:00',2.35),('8998','2013-02-07','11:30:00',2.33),('8998','2013-02-07','11:35:00',2.3),('8998','2013-02-07','11:40:00',2.29),('8998','2013-02-07','11:45:00',2.27),('8998','2013-02-07','11:50:00',2.24),('8998','2013-02-07','11:55:00',2.23),('8998','2013-02-07','12:00:00',2.2),('8998','2013-02-07','12:05:00',2.19),('8998','2013-02-07','12:10:00',2.16),('8998','2013-02-07','12:15:00',2.13),('8998','2013-02-07','12:20:00',2.12),('8998','2013-02-07','12:25:00',2.09),('8998','2013-02-07','12:30:00',2.07),('8998','2013-02-07','12:35:00',2.04),('8998','2013-02-07','12:40:00',2.06),('8998','2013-02-07','12:45:00',2),('8998','2013-02-07','12:50:00',1.61),('8998','2013-02-07','12:55:00',1.17),('8998','2013-02-07','13:00:00',1.14),('8998','2013-02-07','13:05:00',1.09),('8998','2013-02-07','13:10:00',1.21),('8998','2013-02-07','13:15:00',1.18),('8998','2013-02-07','13:20:00',1.21),('8998','2013-02-07','13:25:00',1.14),('8998','2013-02-07','13:30:00',1.07),('8998','2013-02-07','13:35:00',1.36),('8998','2013-02-07','13:40:00',1.2),('8998','2013-02-07','13:45:00',1.01),('8998','2013-02-07','13:50:00',1),('8998','2013-02-07','13:55:00',1),('8998','2013-02-07','14:40:00',1.2),('8998','2013-02-07','14:45:00',1.21),('8998','2013-02-07','14:55:00',1.03),('8998','2013-02-06','10:45:00',1.13),('8998','2013-02-06','11:00:00',1.55),('8998','2013-02-06','12:25:00',1.61),('8998','2013-02-06','12:30:00',1.47),('8998','2013-02-06','14:05:00',1.02),('8998','2013-02-06','14:10:00',1.41),('8998','2013-02-06','14:15:00',1.37),('8998','2013-02-06','14:20:00',1.25),('8998','2013-02-05','08:50:00',1.31),('8998','2013-02-05','09:05:00',1.13),('8998','2013-02-05','09:10:00',1.43),('8998','2013-02-05','09:30:00',1.26),('8998','2013-02-05','09:40:00',1.37),('8998','2013-02-05','09:55:00',1.22),('8998','2013-02-05','10:05:00',1.33),('8998','2013-02-05','10:10:00',1.14),('8998','2013-02-05','10:15:00',1.01),('8998','2013-02-05','10:25:00',1.2),('8998','2013-02-05','10:30:00',1.05),('8998','2013-02-05','10:35:00',1.38),('8998','2013-02-05','10:40:00',1.01),('8998','2013-02-05','10:50:00',1.15),('8998','2013-02-05','10:55:00',1.64),('8998','2013-02-05','11:00:00',1.34),('8998','2013-02-05','11:10:00',1.12),('8998','2013-02-05','11:15:00',1.01),('8998','2013-02-05','11:20:00',1.3),('8998','2013-02-05','11:25:00',1.79),('8998','2013-02-05','11:30:00',1.18),('8998','2013-02-05','11:35:00',1.03),('8998','2013-02-05','11:40:00',1.11),('8998','2013-02-05','11:45:00',1.15),('8998','2013-02-05','11:50:00',1.18),('8998','2013-02-05','11:55:00',1.14),('8998','2013-02-05','12:00:00',1),('8998','2013-02-05','14:35:00',1.09),('8998','2013-02-04','08:40:00',1.06),('8998','2013-02-04','08:45:00',1.39),('8998','2013-02-04','08:50:00',1.47),('8998','2013-02-04','08:55:00',1.51),('8998','2013-02-04','09:00:00',1.55),('8998','2013-02-04','09:05:00',1.59),('8998','2013-02-04','09:10:00',1.63),('8998','2013-02-04','09:15:00',1.69),('8998','2013-02-04','09:20:00',1.73),('8998','2013-02-04','09:25:00',1.78),('8998','2013-02-04','09:30:00',1.79),('8998','2013-02-04','09:35:00',1.84),('8998','2013-02-04','09:40:00',1.88),('8998','2013-02-04','09:45:00',1.9),('8998','2013-02-04','09:50:00',1.92),('8998','2013-02-04','09:55:00',1.95),('8998','2013-02-04','10:00:00',1.94),('8998','2013-02-04','10:05:00',1.96),('8998','2013-02-04','10:10:00',1.83),('8998','2013-02-04','10:15:00',1.84),('8998','2013-02-04','10:20:00',2.03),('8998','2013-02-04','10:25:00',2.06),('8998','2013-02-04','10:30:00',2.07),('8998','2013-02-04','10:35:00',2.07),('8998','2013-02-04','10:40:00',2.08),('8998','2013-02-04','10:45:00',2.07),('8998','2013-02-04','10:50:00',2.05),('8998','2013-02-04','10:55:00',2.04),('8998','2013-02-04','11:00:00',2.04),('8998','2013-02-04','11:05:00',2.03),('8998','2013-02-04','11:10:00',2.06),('8998','2013-02-04','11:15:00',2.05),('8998','2013-02-04','11:20:00',2.03),('8998','2013-02-04','11:25:00',2.03),('8998','2013-02-04','11:30:00',1.97),('8998','2013-02-04','11:35:00',1.87),('8998','2013-02-04','11:40:00',1.62),('8998','2013-02-04','11:45:00',1.47),('8998','2013-02-04','11:50:00',1.19),('8998','2013-02-04','11:55:00',1.03),('8998','2013-02-04','12:10:00',1.46),('8998','2013-02-04','12:15:00',1.07),('8998','2013-02-04','12:40:00',1.11),('8998','2013-02-04','12:45:00',1.21),('8998','2013-02-04','12:50:00',1.43),('8998','2013-02-04','14:30:00',1.03),('8998','2013-02-03','08:40:00',1.08),('8998','2013-02-03','08:45:00',1.45),('8998','2013-02-03','08:50:00',1.56),('8998','2013-02-03','08:55:00',1.39),('8998','2013-02-03','09:00:00',1.68),('8998','2013-02-03','09:05:00',1.76),('8998','2013-02-03','09:10:00',1.83),('8998','2013-02-03','09:15:00',1.85),('8998','2013-02-03','09:20:00',1.8),('8998','2013-02-03','09:25:00',1.77),('8998','2013-02-03','09:30:00',1.89),('8998','2013-02-03','09:35:00',1.86),('8998','2013-02-03','09:40:00',1.89),('8998','2013-02-03','09:45:00',1.67),('8998','2013-02-03','09:50:00',1.97),('8998','2013-02-03','09:55:00',2.1),('8998','2013-02-03','10:00:00',2.13),('8998','2013-02-03','10:05:00',2.15),('8998','2013-02-03','10:10:00',2.21),('8998','2013-02-03','10:15:00',2.24),('8998','2013-02-03','10:20:00',2.1),('8998','2013-02-03','10:25:00',2.19),('8998','2013-02-03','10:30:00',2.06),('8998','2013-02-03','10:35:00',1.92),('8998','2013-02-03','10:40:00',2.03),('8998','2013-02-03','10:45:00',2.19),('8998','2013-02-03','10:50:00',2.22),('8998','2013-02-03','10:55:00',2.18),('8998','2013-02-03','11:00:00',2.18),('8998','2013-02-03','11:05:00',2.2),('8998','2013-02-03','11:10:00',2.2),('8998','2013-02-03','11:15:00',2.19),('8998','2013-02-03','11:20:00',2.18),('8998','2013-02-03','11:25:00',2.17),('8998','2013-02-03','11:30:00',2.17),('8998','2013-02-03','11:35:00',2.14),('8998','2013-02-03','11:40:00',2.14),('8998','2013-02-03','11:45:00',2.12),('8998','2013-02-03','11:50:00',2.11),('8998','2013-02-03','11:55:00',2.08),('8998','2013-02-03','12:00:00',2.07),('8998','2013-02-03','12:05:00',2.06),('8998','2013-02-03','12:10:00',2.04),('8998','2013-02-03','12:15:00',2),('8998','2013-02-03','12:20:00',1.98),('8998','2013-02-03','12:25:00',1.95),('8998','2013-02-03','12:30:00',1.93),('8998','2013-02-03','12:35:00',1.9),('8998','2013-02-03','12:40:00',1.88),('8998','2013-02-03','12:45:00',1.84),('8998','2013-02-03','12:50:00',1.79),('8998','2013-02-03','12:55:00',1.77),('8998','2013-02-03','13:00:00',1.75),('8998','2013-02-03','13:05:00',1.71),('8998','2013-02-03','13:10:00',1.67),('8998','2013-02-03','13:15:00',1.63),('8998','2013-02-03','13:20:00',1.58),('8998','2013-02-03','13:25:00',1.53),('8998','2013-02-03','13:30:00',1.5),('8998','2013-02-03','13:35:00',1.45),('8998','2013-02-03','13:40:00',1.39),('8998','2013-02-03','13:45:00',1.27),('8998','2013-02-03','13:50:00',1.22),('8998','2013-02-03','13:55:00',1.12),('8998','2013-02-02','09:45:00',1.17),('8998','2013-02-02','09:50:00',1.2),('8998','2013-02-02','10:00:00',1.5),('8998','2013-02-01','10:40:00',1.04),('8998','2013-02-01','10:45:00',1.13),('8998','2013-02-01','10:55:00',1.25),('8998','2013-02-01','11:00:00',1.45),('8998','2013-02-01','11:05:00',1.29),('8998','2013-02-01','11:10:00',1.35),('8998','2013-02-01','11:15:00',1.31),('8998','2013-02-01','11:20:00',1.3),('8998','2013-02-01','11:25:00',1.39),('8998','2013-02-01','11:30:00',1.38),('8998','2013-02-01','11:35:00',1.2),('8998','2013-02-01','11:40:00',1.2),('8998','2013-02-01','12:55:00',1.27),('8998','2013-02-01','13:00:00',1.12),('8998','2013-02-01','13:05:00',1.18),('8998','2013-02-01','13:10:00',1.06),('8998','2013-02-01','13:15:00',1.22),('8998','2013-02-01','13:20:00',1.09),('8998','2013-02-01','13:25:00',1.02),('8998','2013-02-01','13:35:00',1.18),('8998','2013-02-01','13:40:00',1.41),('8998','2013-02-01','13:45:00',1.15),('8998','2013-02-01','13:50:00',1.13),('8998','2013-01-31','09:00:00',1.36),('8998','2013-01-31','09:05:00',1.49),('8998','2013-01-31','09:10:00',1.64),('8998','2013-01-31','09:25:00',1.42),('8998','2013-01-31','09:30:00',1.03),('8998','2013-01-31','09:40:00',1.36),('8998','2013-01-31','09:45:00',1.06),('8998','2013-01-31','10:00:00',1.34),('8998','2013-01-31','10:20:00',1.42),('8998','2013-01-31','10:25:00',1.21),('8998','2013-01-31','10:35:00',1.05),('8998','2013-01-31','10:50:00',1.6),('8998','2013-01-31','10:55:00',2.37),('8998','2013-01-31','11:00:00',2.18),('8998','2013-01-31','11:05:00',1.95),('8998','2013-01-31','11:10:00',2.04),('8998','2013-01-31','11:15:00',1.29),('8998','2013-01-31','11:20:00',1.62),('8998','2013-01-31','11:25:00',1.21),('8998','2013-01-31','11:35:00',1.08),('8998','2013-01-31','11:40:00',1.88),('8998','2013-01-31','11:45:00',1.12),('8998','2013-01-31','11:50:00',1.11),('8998','2013-01-31','12:10:00',1.07),('8998','2013-01-31','12:15:00',1.25),('8998','2013-01-31','12:20:00',2.28),('8998','2013-01-31','12:25:00',1.98),('8998','2013-01-31','12:40:00',1.58),('8998','2013-01-31','12:45:00',1.62),('8998','2013-01-31','12:50:00',1.79),('8998','2013-01-31','12:55:00',2.03),('8998','2013-01-31','13:00:00',1.89),('8998','2013-01-31','13:05:00',1.11),('8998','2013-01-31','13:10:00',1.65),('8998','2013-01-31','13:15:00',1.54),('8998','2013-01-31','13:20:00',1.47),('8998','2013-01-31','13:25:00',1.12),('8998','2013-01-31','13:30:00',1.15),('8998','2013-01-31','13:35:00',1.21),('8998','2013-01-31','13:40:00',1.13),('8998','2013-01-31','13:45:00',1.16),('8998','2014-03-20','07:45:00',1.05),('8998','2014-03-20','07:50:00',1.07),('8998','2014-03-20','07:55:00',1.1),('8998','2014-03-20','08:00:00',1.13),('8998','2014-03-20','08:05:00',1.12),('8998','2014-03-20','08:10:00',1.56),('8998','2014-03-20','08:15:00',1.71),('8998','2014-03-20','08:20:00',1.76),('8998','2014-03-20','08:25:00',1.83),('8998','2014-03-20','08:30:00',1.95),('8998','2014-03-20','08:35:00',2),('8998','2014-03-20','08:40:00',2.05),('8998','2014-03-20','08:45:00',2.07),('8998','2014-03-20','08:50:00',2.11),('8998','2014-03-20','08:55:00',2.17),('8998','2014-03-20','09:00:00',2.21),('8998','2014-03-20','09:05:00',2.2),('8998','2014-03-20','09:10:00',2.27),('8998','2014-03-20','09:15:00',2.32),('8998','2014-03-20','09:20:00',2.37),('8998','2014-03-20','09:25:00',2.26),('8998','2014-03-20','09:30:00',2.41),('8998','2014-03-20','09:35:00',2.41),('8998','2014-03-20','09:40:00',2.43),('8998','2014-03-20','09:45:00',2.44),('8998','2014-03-20','09:50:00',2.45),('8998','2014-03-20','09:55:00',2.47),('8998','2014-03-20','10:00:00',2.49),('8998','2014-03-20','10:05:00',2.47),('8998','2014-03-20','10:10:00',2.43),('8998','2014-03-20','10:15:00',2.43),('8998','2014-03-20','10:20:00',2.47),('8998','2014-03-20','10:25:00',2.56),('8998','2014-03-20','10:30:00',2.6),('8998','2014-03-20','10:35:00',2.55),('8998','2014-03-20','10:40:00',2.56),('8998','2014-03-20','10:45:00',2.55),('8998','2014-03-20','10:50:00',2.53),('8998','2014-03-20','10:55:00',2.51),('8998','2014-03-20','11:00:00',2.49),('8998','2014-03-20','11:05:00',2.49),('8998','2014-03-20','11:10:00',2.48),('8998','2014-03-20','11:15:00',2.43),('8998','2014-03-20','11:20:00',2.41),('8998','2014-03-20','11:25:00',2.47),('8998','2014-03-20','11:30:00',1.98),('8998','2014-03-20','11:35:00',1.04),('8998','2014-03-20','11:50:00',1.09),('8998','2014-03-20','11:55:00',2.78),('8998','2014-03-20','12:00:00',2.09),('8998','2014-03-20','12:05:00',2.05),('8998','2014-03-20','12:10:00',2.27),('8998','2014-03-20','12:15:00',2.59),('8998','2014-03-20','12:20:00',2.53),('8998','2014-03-20','12:25:00',2.43),('8998','2014-03-20','12:30:00',2.38),('8998','2014-03-20','12:35:00',2.35),('8998','2014-03-20','12:40:00',2.33),('8998','2014-03-20','12:45:00',2.3),('8998','2014-03-20','12:50:00',2.26),('8998','2014-03-20','12:55:00',2.23),('8998','2014-03-20','13:00:00',2.18),('8998','2014-03-20','13:05:00',2.17),('8998','2014-03-20','13:10:00',2.14),('8998','2014-03-20','13:15:00',2.1),('8998','2014-03-20','13:20:00',2.08),('8998','2014-03-20','13:25:00',2.02),('8998','2014-03-20','13:30:00',2),('8998','2014-03-20','13:35:00',1.93),('8998','2014-03-20','13:40:00',1.88),('8998','2014-03-20','13:45:00',1.85),('8998','2014-03-20','13:50:00',1.8),('8998','2014-03-20','13:55:00',1.74),('8998','2014-03-20','14:00:00',1.71),('8998','2014-03-20','14:05:00',1.67),('8998','2014-03-20','14:10:00',1.63),('8998','2014-03-20','14:15:00',1.57),('8998','2014-03-20','14:20:00',1.51),('8998','2014-03-20','14:25:00',1.46),('8998','2014-03-20','14:30:00',1.39),('8998','2014-03-20','14:35:00',1.24),('8998','2014-03-20','14:40:00',1.22),('8998','2014-03-20','14:45:00',1.17),('8998','2014-03-20','15:10:00',1.03),('8998','2014-03-20','15:15:00',1.14),('8998','2014-03-20','15:20:00',1.1),('8998','2014-03-20','15:25:00',1.07),('8998','2014-03-20','15:30:00',1.1),('8998','2013-01-30','09:20:00',1.11),('8998','2013-01-30','09:25:00',1.58),('8998','2013-01-30','09:30:00',1.8),('8998','2013-01-30','09:35:00',1.71),('8998','2013-01-30','09:40:00',1.74),('8998','2013-01-30','09:45:00',1.54),('8998','2013-01-30','09:50:00',1.71),('8998','2013-01-30','09:55:00',1.86),('8998','2013-01-30','10:00:00',1.85),('8998','2013-01-30','10:05:00',1.84),('8998','2013-01-30','10:10:00',1.83),('8998','2013-01-30','10:15:00',1.88),('8998','2013-01-30','10:20:00',1.92),('8998','2013-01-30','10:25:00',1.85),('8998','2013-01-30','10:30:00',1.73),('8998','2013-01-30','10:35:00',2.06),('8998','2013-01-30','10:40:00',2.1),('8998','2013-01-30','10:45:00',2.07),('8998','2013-01-30','10:50:00',1.92),('8998','2013-01-30','11:00:00',1.86),('8998','2013-01-30','11:05:00',2.29),('8998','2013-01-30','11:10:00',2.27),('8998','2013-01-30','11:15:00',2.2),('8998','2013-01-30','11:20:00',2.19),('8998','2013-01-30','11:25:00',2.04),('8998','2013-01-30','11:30:00',1.94),('8998','2013-01-30','11:35:00',1.98),('8998','2013-01-30','11:40:00',1.95),('8998','2013-01-30','11:45:00',1.93),('8998','2013-01-30','11:50:00',1.91),('8998','2013-01-30','11:55:00',1.87),('8998','2013-01-30','12:00:00',1.85),('8998','2013-01-30','12:05:00',1.86),('8998','2013-01-30','12:10:00',1.52),('8998','2013-01-30','12:15:00',1.75),('8998','2013-01-30','12:20:00',1.79),('8998','2013-01-30','12:25:00',1.77),('8998','2013-01-30','12:30:00',1.74),('8998','2013-01-30','12:35:00',1.72),('8998','2013-01-30','12:40:00',1.69),('8998','2013-01-30','12:45:00',1.66),('8998','2013-01-30','12:50:00',1.63),('8998','2013-01-30','12:55:00',1.58),('8998','2013-01-30','13:00:00',1.56),('8998','2013-01-30','13:05:00',1.54),('8998','2013-01-30','13:10:00',1.5),('8998','2013-01-30','13:15:00',1.44),('8998','2013-01-30','13:20:00',1.38),('8998','2013-01-30','13:25:00',1.35),('8998','2013-01-30','13:30:00',1.3),('8998','2013-01-30','13:35:00',1.27),('8998','2013-01-30','13:40:00',1.19),('8998','2013-01-30','13:45:00',1.14),('8998','2013-01-30','13:50:00',1.09),('8998','2013-01-30','13:55:00',1),('8998','2013-01-29','10:10:00',1.13),('8998','2013-01-29','10:20:00',1.18),('8998','2013-01-29','10:25:00',1.17),('8998','2013-01-29','10:30:00',1.08),('8998','2013-01-29','10:40:00',1.08),('8998','2013-01-29','10:45:00',1.49),('8998','2013-01-29','10:50:00',1.92),('8998','2013-01-29','10:55:00',1.87),('8998','2013-01-29','11:00:00',1.96),('8998','2013-01-29','11:05:00',1.89),('8998','2013-01-29','11:10:00',1.89),('8998','2013-01-29','11:15:00',1.9),('8998','2013-01-29','11:20:00',1.89),('8998','2013-01-29','11:25:00',1.92),('8998','2013-01-29','11:30:00',1.91),('8998','2013-01-29','11:35:00',1.88),('8998','2013-01-29','11:40:00',1.59),('8998','2013-01-29','11:45:00',1.92),('8998','2013-01-29','11:50:00',1.91),('8998','2013-01-29','11:55:00',1.83),('8998','2013-01-29','12:00:00',1.89),('8998','2013-01-29','12:05:00',1.87),('8998','2013-01-29','12:10:00',1.16),('8998','2013-01-29','12:15:00',1.57),('8998','2013-01-29','12:20:00',1.19),('8998','2013-01-29','12:40:00',1.1),('8998','2013-01-29','12:55:00',1.93),('8998','2013-01-29','13:00:00',1.86),('8998','2013-01-29','13:05:00',1.86),('8998','2013-01-29','13:10:00',1.73),('8998','2013-01-29','13:15:00',1.57),('8998','2013-01-29','13:20:00',1.6),('8998','2013-01-29','13:25:00',1.62),('8998','2013-01-29','13:30:00',1.43),('8998','2013-01-29','13:35:00',1.47),('8998','2013-01-29','13:50:00',1.17),('8998','2013-01-29','13:55:00',1.02),('8998','2013-01-29','14:00:00',1.08),('8998','2013-01-29','14:10:00',1.13),('8998','2013-01-28','08:30:00',1.04),('8998','2013-01-28','08:35:00',1.1),('8998','2013-01-28','08:40:00',1.14),('8998','2013-01-28','08:45:00',1.2),('8998','2013-01-28','08:50:00',1.08),('8998','2013-01-28','08:55:00',1.38),('8998','2013-01-28','09:00:00',1.43),('8998','2013-01-28','09:05:00',1.48),('8998','2013-01-28','09:10:00',1.53),('8998','2013-01-28','09:15:00',1.57),('8998','2013-01-28','09:20:00',1.6),('8998','2013-01-28','09:25:00',1.64),('8998','2013-01-28','09:30:00',1.67),('8998','2013-01-28','09:35:00',1.7),('8998','2013-01-28','09:40:00',1.74),('8998','2013-01-28','09:45:00',1.78),('8998','2013-01-28','09:50:00',1.8),('8998','2013-01-28','09:55:00',1.83),('8998','2013-01-28','10:00:00',1.85),('8998','2013-01-28','10:05:00',1.89),('8998','2013-01-28','10:10:00',1.92),('8998','2013-01-28','10:15:00',1.95),('8998','2013-01-28','10:20:00',1.97),('8998','2013-01-28','10:25:00',2),('8998','2013-01-28','10:30:00',2.01),('8998','2013-01-28','10:35:00',2.02),('8998','2013-01-28','10:40:00',2.04),('8998','2013-01-28','10:45:00',2.03),('8998','2013-01-28','10:50:00',2.04),('8998','2013-01-28','10:55:00',2.03),('8998','2013-01-28','11:00:00',2),('8998','2013-01-28','11:05:00',2),('8998','2013-01-28','11:10:00',2),('8998','2013-01-28','11:15:00',2.01),('8998','2013-01-28','11:20:00',2.01),('8998','2013-01-28','11:25:00',1.97),('8998','2013-01-28','11:30:00',1.93),('8998','2013-01-28','11:35:00',1.98),('8998','2013-01-28','11:40:00',2),('8998','2013-01-28','11:45:00',1.98),('8998','2013-01-28','11:50:00',1.96),('8998','2013-01-28','11:55:00',1.93),('8998','2013-01-28','12:00:00',1.88),('8998','2013-01-28','12:05:00',1.87),('8998','2013-01-28','12:10:00',1.88),('8998','2013-01-28','12:15:00',1.84),('8998','2013-01-28','12:20:00',1.82),('8998','2013-01-28','12:25:00',1.81),('8998','2013-01-28','12:30:00',1.77),('8998','2013-01-28','12:35:00',1.72),('8998','2013-01-28','12:40:00',1.69),('8998','2013-01-28','12:45:00',1.64),('8998','2013-01-28','12:50:00',1.61),('8998','2013-01-28','12:55:00',1.61),('8998','2013-01-28','13:00:00',1.58),('8998','2013-01-28','13:05:00',1.53),('8998','2013-01-28','13:10:00',1.49),('8998','2013-01-28','13:15:00',1.44),('8998','2013-01-28','13:20:00',1.41),('8998','2013-01-28','13:25:00',1.38),('8998','2013-01-28','13:30:00',1.33),('8998','2013-01-28','13:35:00',1.29),('8998','2013-01-28','13:40:00',1.21),('8998','2013-01-28','13:45:00',1.06),('8998','2013-01-26','08:55:00',1.28),('8998','2013-01-26','09:00:00',1.36),('8998','2013-01-26','09:05:00',1.41),('8998','2013-01-26','09:10:00',1.44),('8998','2013-01-26','09:15:00',1.49),('8998','2013-01-26','09:20:00',1.54),('8998','2013-01-26','09:25:00',1.59),('8998','2013-01-26','09:30:00',1.62),('8998','2013-01-26','09:35:00',1.66),('8998','2013-01-26','09:40:00',1.7),('8998','2013-01-26','09:45:00',1.73),('8998','2013-01-26','09:50:00',1.76),('8998','2013-01-26','09:55:00',1.8),('8998','2013-01-26','10:00:00',1.81),('8998','2013-01-26','10:05:00',1.84),('8998','2013-01-26','10:10:00',1.85),('8998','2013-01-26','10:15:00',1.88),('8998','2013-01-26','10:20:00',1.89),('8998','2013-01-26','10:25:00',1.9),('8998','2013-01-26','10:30:00',1.92),('8998','2013-01-26','10:35:00',1.93),('8998','2013-01-26','10:40:00',1.93),('8998','2013-01-26','10:45:00',1.94),('8998','2013-01-26','10:50:00',1.95),('8998','2013-01-26','10:55:00',1.96),('8998','2013-01-26','11:00:00',1.95),('8998','2013-01-26','11:05:00',1.96),('8998','2013-01-26','11:10:00',1.96),('8998','2013-01-26','11:15:00',1.96),('8998','2013-01-26','11:20:00',1.96),('8998','2013-01-26','11:25:00',1.95),('8998','2013-01-26','11:30:00',1.93),('8998','2013-01-26','11:35:00',1.92),('8998','2013-01-26','11:40:00',1.91),('8998','2013-01-26','11:45:00',1.9),('8998','2013-01-26','11:50:00',1.88),('8998','2013-01-26','11:55:00',1.88),('8998','2013-01-26','12:00:00',1.86),('8998','2013-01-26','12:05:00',1.84),('8998','2013-01-26','12:10:00',1.82),('8998','2013-01-26','12:15:00',1.81),('8998','2013-01-26','12:20:00',1.79),('8998','2013-01-26','12:25:00',1.75),('8998','2013-01-26','12:30:00',1.72),('8998','2013-01-26','12:35:00',1.69),('8998','2013-01-26','12:40:00',1.65),('8998','2013-01-26','12:45:00',1.6),('8998','2013-01-26','12:50:00',1.6),('8998','2013-01-26','12:55:00',1.59),('8998','2013-01-26','13:00:00',1.56),('8998','2013-01-26','13:05:00',1.52),('8998','2013-01-26','13:10:00',1.48),('8998','2013-01-26','13:15:00',1.43),('8998','2013-01-26','13:20:00',1.37),('8998','2013-01-26','13:25:00',1.33),('8998','2013-01-26','13:30:00',1.29),('8998','2013-01-26','13:35:00',1.22),('8998','2013-01-26','13:40:00',1.06),('8998','2013-01-25','09:05:00',1.11),('8998','2013-01-25','09:20:00',1.16),('8998','2013-01-24','08:35:00',1),('8998','2013-01-24','08:40:00',1.23),('8998','2013-01-24','08:45:00',1.28),('8998','2013-01-24','08:50:00',1.27),('8998','2013-01-24','08:55:00',1.09),('8998','2013-01-24','09:00:00',1.54),('8998','2013-01-24','09:05:00',1.28),('8998','2013-01-24','09:10:00',1.29),('8998','2013-01-24','09:15:00',1.57),('8998','2013-01-24','09:20:00',1.66),('8998','2013-01-24','09:25:00',1.74),('8998','2013-01-24','09:30:00',1.8),('8998','2013-01-24','09:35:00',1.74),('8998','2013-01-24','09:40:00',1.6),('8998','2013-01-24','09:45:00',1.65),('8998','2013-01-24','09:50:00',1.96),('8998','2013-01-24','09:55:00',2.03),('8998','2013-01-24','10:00:00',2.05),('8998','2013-01-24','10:05:00',2.07),('8998','2013-01-24','10:10:00',2.01),('8998','2013-01-24','10:15:00',2),('8998','2013-01-24','10:20:00',2.02),('8998','2013-01-24','10:25:00',2.05),('8998','2013-01-24','10:30:00',1.99),('8998','2013-01-24','10:35:00',1.56),('8998','2013-01-24','10:40:00',2.16),('8998','2013-01-24','10:45:00',1.91),('8998','2013-01-24','10:50:00',1.5),('8998','2013-01-24','10:55:00',2.16),('8998','2013-01-24','11:00:00',1.2),('8998','2013-01-24','11:05:00',1.88),('8998','2013-01-24','11:10:00',1.99),('8998','2013-01-24','11:15:00',2.06),('8998','2013-01-24','11:20:00',2.01),('8998','2013-01-24','11:25:00',1.98),('8998','2013-01-24','11:30:00',1.98),('8998','2013-01-24','11:35:00',1.99),('8998','2013-01-24','11:40:00',1.97),('8998','2013-01-24','11:45:00',1.96),('8998','2013-01-24','11:50:00',1.97),('8998','2013-01-24','11:55:00',1.94),('8998','2013-01-24','12:00:00',1.9),('8998','2013-01-24','12:05:00',1.88),('8998','2013-01-24','12:10:00',1.88),('8998','2013-01-24','12:15:00',1.87),('8998','2013-01-24','12:20:00',1.85),('8998','2013-01-24','12:25:00',1.83),('8998','2013-01-24','12:30:00',1.81),('8998','2013-01-24','12:35:00',1.53),('8998','2013-01-24','12:40:00',1.54),('8998','2013-01-24','12:45:00',1.61),('8998','2013-01-24','12:50:00',1.64),('8998','2013-01-24','12:55:00',1.58),('8998','2013-01-24','13:00:00',1.57),('8998','2013-01-24','13:05:00',1.52),('8998','2013-01-24','13:10:00',1.48),('8998','2013-01-24','13:15:00',1.46),('8998','2013-01-24','13:20:00',1.43),('8998','2013-01-24','13:25:00',1.41),('8998','2013-01-24','13:30:00',1.4),('8998','2013-01-24','13:35:00',1.35),('8998','2013-01-24','13:40:00',1.25),('8998','2013-01-24','13:45:00',1.16),('8998','2013-01-24','13:50:00',1.07),('8998','2013-01-24','13:55:00',1.01),('8998','2013-01-23','09:45:00',1.12),('8998','2013-01-23','09:50:00',1.08),('8998','2013-01-23','09:55:00',1.81),('8998','2013-01-23','10:00:00',1.86),('8998','2013-01-23','10:05:00',1.9),('8998','2013-01-23','10:10:00',2.06),('8998','2013-01-23','10:15:00',2.01),('8998','2013-01-23','10:20:00',2.04),('8998','2013-01-23','10:25:00',2.02),('8998','2013-01-23','10:30:00',2.02),('8998','2013-01-23','10:35:00',2.02),('8998','2013-01-23','10:40:00',2.02),('8998','2013-01-23','10:45:00',2.05),('8998','2013-01-23','10:50:00',2.09),('8998','2013-01-23','10:55:00',1.95),('8998','2013-01-23','11:00:00',1.1),('8998','2013-01-23','14:25:00',1.08),('8998','2013-01-22','09:55:00',1.27),('8998','2013-01-22','10:30:00',1.52),('8998','2013-01-22','10:35:00',2.11),('8998','2013-01-22','10:45:00',1.33),('8998','2013-01-22','10:50:00',1.69),('8998','2013-01-22','10:55:00',1.47),('8998','2013-01-21','08:45:00',1.04),('8998','2013-01-21','08:50:00',1.11),('8998','2013-01-21','09:05:00',1.17),('8998','2013-01-21','09:30:00',1.6),('8998','2013-01-21','09:35:00',1.8),('8998','2013-01-21','09:40:00',1.32),('8998','2013-01-21','09:45:00',2.17),('8998','2013-01-21','09:50:00',1.44),('8998','2013-01-21','09:55:00',1.56),('8998','2013-01-21','10:00:00',1.08),('8998','2013-01-21','10:05:00',1.85),('8998','2013-01-21','10:10:00',1.96),('8998','2013-01-21','10:15:00',1.84),('8998','2013-01-21','10:20:00',1.71),('8998','2013-01-21','10:25:00',1.83),('8998','2013-01-21','10:30:00',2.04),('8998','2013-01-21','10:35:00',2.09),('8998','2013-01-21','10:40:00',2.33),('8998','2013-01-21','10:45:00',1.93),('8998','2013-01-21','10:50:00',1.6),('8998','2013-01-21','11:15:00',1.28),('8998','2013-01-21','11:20:00',1.23),('8998','2013-01-21','11:50:00',1.53),('8998','2013-01-21','12:10:00',1.45),('8998','2013-01-21','12:15:00',1.6),('8998','2013-01-21','12:20:00',1.03),('8998','2013-01-21','12:25:00',1.61),('8998','2013-01-21','12:40:00',1.85),('8998','2013-01-21','13:00:00',1.36),('8998','2013-01-21','13:05:00',1.68),('8998','2013-01-21','13:10:00',1.13),('8998','2013-01-21','13:20:00',1.36),('8998','2014-03-19','07:50:00',1.11),('8998','2014-03-19','07:55:00',1.2),('8998','2014-03-19','08:00:00',1.19),('8998','2014-03-19','08:05:00',1.37),('8998','2014-03-19','08:10:00',1.63),('8998','2014-03-19','08:15:00',1.7),('8998','2014-03-19','08:20:00',1.73),('8998','2014-03-19','08:25:00',1.79),('8998','2014-03-19','08:30:00',1.89),('8998','2014-03-19','08:35:00',1.97),('8998','2014-03-19','08:40:00',2.07),('8998','2014-03-19','08:45:00',2.15),('8998','2014-03-19','08:50:00',2.17),('8998','2014-03-19','08:55:00',2.18),('8998','2014-03-19','09:00:00',2.19),('8998','2014-03-19','09:05:00',2.25),('8998','2014-03-19','09:10:00',2.31),('8998','2014-03-19','09:15:00',2.29),('8998','2014-03-19','09:20:00',2.35),('8998','2014-03-19','09:25:00',2.37),('8998','2014-03-19','09:30:00',2.38),('8998','2014-03-19','09:35:00',2.43),('8998','2014-03-19','09:40:00',2.42),('8998','2014-03-19','09:45:00',2.42),('8998','2014-03-19','09:50:00',2.39),('8998','2014-03-19','09:55:00',2.42),('8998','2014-03-19','10:00:00',2.5),('8998','2014-03-19','10:05:00',2.57),('8998','2014-03-19','10:10:00',2.58),('8998','2014-03-19','10:15:00',2.52),('8998','2014-03-19','10:20:00',2.53),('8998','2014-03-19','10:25:00',2.52),('8998','2014-03-19','10:30:00',2.54),('8998','2014-03-19','10:35:00',2.45),('8998','2014-03-19','10:40:00',2.4),('8998','2014-03-19','10:45:00',2.37),('8998','2014-03-19','10:50:00',2.5),('8998','2014-03-19','10:55:00',2.63),('8998','2014-03-19','11:00:00',2.65),('8998','2014-03-19','11:05:00',2.61),('8998','2014-03-19','11:10:00',2.56),('8998','2014-03-19','11:15:00',2.41),('8998','2014-03-19','11:20:00',2.46),('8998','2014-03-19','11:25:00',2.5),('8998','2014-03-19','11:30:00',2.52),('8998','2014-03-19','11:35:00',2.61),('8998','2014-03-19','11:40:00',2.55),('8998','2014-03-19','11:45:00',2.55),('8998','2014-03-19','11:50:00',2.47),('8998','2014-03-19','11:55:00',2.46),('8998','2014-03-19','12:00:00',2.17),('8998','2014-03-19','12:05:00',2.29),('8998','2014-03-19','12:10:00',2.47),('8998','2014-03-19','12:15:00',2.5),('8998','2014-03-19','12:20:00',2.41),('8998','2014-03-19','12:25:00',2.24),('8998','2014-03-19','12:30:00',2.29),('8998','2014-03-19','12:35:00',2.32),('8998','2014-03-19','12:40:00',2.27),('8998','2014-03-19','12:45:00',2.33),('8998','2014-03-19','12:50:00',2.29),('8998','2014-03-19','12:55:00',2.24),('8998','2014-03-19','13:00:00',2.2),('8998','2014-03-19','13:05:00',2.16),('8998','2014-03-19','13:10:00',2.09),('8998','2014-03-19','13:15:00',2.06),('8998','2014-03-19','13:20:00',2.04),('8998','2014-03-19','13:25:00',1.96),('8998','2014-03-19','13:30:00',1.96),('8998','2014-03-19','13:35:00',1.89),('8998','2014-03-19','13:40:00',1.72),('8998','2014-03-19','13:45:00',1.64),('8998','2014-03-19','13:50:00',1.56),('8998','2014-03-19','13:55:00',1.49),('8998','2014-03-19','14:00:00',1.45),('8998','2014-03-19','14:05:00',1.55),('8998','2014-03-19','14:10:00',1.5),('8998','2014-03-19','14:15:00',1.43),('8998','2014-03-19','14:20:00',1.39),('8998','2014-03-19','14:25:00',1.38),('8998','2014-03-19','14:30:00',1.2),('8998','2014-03-19','14:35:00',1.03),('8998','2014-03-19','14:40:00',1.1),('8998','2014-03-19','14:45:00',1.08),('8998','2013-01-20','11:55:00',2.23),('8998','2013-01-20','12:00:00',1.83),('8998','2013-01-20','12:05:00',1.75),('8998','2013-01-20','12:10:00',1.81),('8998','2013-01-20','12:15:00',1.54),('8998','2013-01-20','13:05:00',1.19),('8998','2013-01-20','13:10:00',1.06),('8998','2013-01-20','13:30:00',1.26),('8998','2013-01-20','13:35:00',1.48),('8998','2013-01-20','13:40:00',1.03),('8998','2013-01-20','14:00:00',1.09),('8998','2013-01-20','14:05:00',1.12),('8998','2013-01-19','11:15:00',1.16),('8998','2013-01-19','11:30:00',1.53),('8998','2013-01-19','11:35:00',1.26),('8998','2013-01-18','09:15:00',1.13),('8998','2013-01-18','09:20:00',1.17),('8998','2013-01-18','09:55:00',1.15),('8998','2013-01-18','10:00:00',1.02),('8998','2013-01-18','10:50:00',1.02),('8998','2013-01-17','10:15:00',1.76),('8998','2013-01-17','10:20:00',1.81),('8998','2013-01-17','10:25:00',1.11),('8998','2013-01-17','12:45:00',1),('8998','2013-01-17','12:50:00',1.37),('8998','2013-01-17','12:55:00',1.34),('8998','2013-01-17','13:00:00',1.4),('8998','2013-01-17','13:05:00',1.27),('8998','2013-01-17','13:10:00',1.21),('8998','2013-01-17','13:15:00',1.41),('8998','2013-01-17','13:20:00',1.18),('8998','2013-01-17','13:25:00',1),('8998','2013-01-17','13:35:00',1.01),('8998','2013-01-17','13:40:00',1.22),('8998','2013-01-17','13:45:00',1.27),('8998','2013-01-17','13:50:00',1.42),('8998','2013-01-17','13:55:00',1.32),('8998','2013-01-17','14:00:00',1.1),('8998','2013-01-17','14:05:00',1.19),('8998','2013-01-17','14:10:00',1.12),('8998','2013-01-16','09:50:00',1.06),('8998','2013-01-16','10:25:00',1.18),('8998','2013-01-16','10:30:00',1.28),('8998','2013-01-16','10:35:00',1.15),('8998','2013-01-16','10:40:00',1.08),('8998','2013-01-16','10:45:00',1.17),('8998','2013-01-16','10:50:00',1.08),('8998','2013-01-16','10:55:00',1.27),('8998','2013-01-16','11:00:00',1.13),('8998','2013-01-16','11:05:00',1.11),('8998','2013-01-16','11:10:00',1.31),('8998','2013-01-16','11:15:00',1.27),('8998','2013-01-16','11:20:00',1.2),('8998','2013-01-16','11:25:00',1.05),('8998','2013-01-16','11:40:00',1.03),('8998','2013-01-16','11:55:00',1.05),('8998','2013-01-16','12:00:00',1.17),('8998','2013-01-16','12:05:00',1.15),('8998','2013-01-16','12:10:00',1.07),('8998','2013-01-16','12:15:00',1.27),('8998','2013-01-16','12:20:00',1.12),('8998','2013-01-16','12:25:00',1.05),('8998','2013-01-16','12:35:00',1.05),('8998','2013-01-16','12:40:00',1.14),('8998','2013-01-16','13:40:00',1.04),('8998','2013-01-16','13:45:00',1.08),('8998','2013-01-15','09:15:00',1.01),('8998','2013-01-15','09:25:00',1.46),('8998','2013-01-15','09:30:00',1.55),('8998','2013-01-15','09:35:00',1.6),('8998','2013-01-15','09:40:00',1.68),('8998','2013-01-15','10:35:00',1.34),('8998','2013-01-15','10:40:00',1.6),('8998','2013-01-15','10:45:00',1.73),('8998','2013-01-15','10:55:00',1.49),('8998','2013-01-15','11:25:00',1.04),('8998','2013-01-15','12:10:00',1.02),('8998','2013-01-15','12:15:00',2.09),('8998','2013-01-15','12:20:00',1.94),('8998','2013-01-15','13:10:00',1.98),('8998','2013-01-15','13:15:00',2.05),('8998','2013-01-15','13:20:00',1.52),('8998','2013-01-15','13:25:00',1.1),('8998','2013-01-15','14:00:00',1.15),('8998','2013-01-14','10:55:00',1.06),('8998','2013-01-14','11:00:00',1.01),('8998','2013-01-14','11:05:00',1.04),('8998','2013-01-14','11:10:00',1.06),('8998','2013-01-14','11:15:00',1),('8998','2013-01-14','11:20:00',1.05),('8998','2013-01-14','11:25:00',1.04),('8998','2013-01-14','14:20:00',1.06),('8998','2013-01-12','09:15:00',1.38),('8998','2013-01-12','09:20:00',1.5),('8998','2013-01-12','09:25:00',1.45),('8998','2013-01-12','09:30:00',1.5),('8998','2013-01-12','09:35:00',1.56),('8998','2013-01-12','09:40:00',1.09),('8998','2013-01-12','09:50:00',1.17),('8998','2013-01-12','09:55:00',1.45),('8998','2013-01-12','10:00:00',1.48),('8998','2013-01-12','10:05:00',1.53),('8998','2013-01-12','10:10:00',1.07),('8998','2013-01-12','10:20:00',1.07),('8998','2013-01-12','10:25:00',1.06),('8998','2013-01-12','10:30:00',1.32),('8998','2013-01-11','08:45:00',1.03),('8998','2013-01-11','08:50:00',1.07),('8998','2013-01-11','09:00:00',1.19),('8998','2013-01-11','09:05:00',1.25),('8998','2013-01-11','09:10:00',1.28),('8998','2013-01-11','09:15:00',1.3),('8998','2013-01-11','09:20:00',1.34),('8998','2013-01-11','09:25:00',1.38),('8998','2013-01-11','09:30:00',1.41),('8998','2013-01-11','09:35:00',1.43),('8998','2013-01-11','09:40:00',1.48),('8998','2013-01-11','09:45:00',1.5),('8998','2013-01-11','09:50:00',1.55),('8998','2013-01-11','09:55:00',1.57),('8998','2013-01-11','10:00:00',1.6),('8998','2013-01-11','10:05:00',1.63),('8998','2013-01-11','10:10:00',1.62),('8998','2013-01-11','10:15:00',1.61),('8998','2013-01-11','10:20:00',1.62),('8998','2013-01-11','10:25:00',1.65),('8998','2013-01-11','10:30:00',1.67),('8998','2013-01-11','10:35:00',1.67),('8998','2013-01-11','10:40:00',1.69),('8998','2013-01-11','10:45:00',1.69),('8998','2013-01-11','10:50:00',1.69),('8998','2013-01-11','10:55:00',1.68),('8998','2013-01-11','11:00:00',1.66),('8998','2013-01-11','11:05:00',1.7),('8998','2013-01-11','11:10:00',1.68),('8998','2013-01-11','11:15:00',1.67),('8998','2013-01-11','11:20:00',1.66),('8998','2013-01-11','11:25:00',1.67),('8998','2013-01-11','11:30:00',1.65),('8998','2013-01-11','11:35:00',1.64),('8998','2013-01-11','11:40:00',1.63),('8998','2013-01-11','11:45:00',1.62),('8998','2013-01-11','11:50:00',1.61),('8998','2013-01-11','11:55:00',1.6),('8998','2013-01-11','12:00:00',1.57),('8998','2013-01-11','12:05:00',1.55),('8998','2013-01-11','12:10:00',1.51),('8998','2013-01-11','12:15:00',1.5),('8998','2013-01-11','12:20:00',1.47),('8998','2013-01-11','12:25:00',1.43),('8998','2013-01-11','12:30:00',1.42),('8998','2013-01-11','12:35:00',1.16),('8998','2013-01-11','12:40:00',1.06),('8998','2013-01-11','12:50:00',1.01),('8998','2013-01-11','13:00:00',1.15),('8998','2013-01-11','13:05:00',1.18),('8998','2013-01-11','13:10:00',1.03),('8998','2014-03-18','09:10:00',1),('8998','2014-03-18','09:15:00',1.26),('8998','2014-03-18','09:20:00',1.37),('8998','2014-03-18','09:25:00',1.43),('8998','2014-03-18','09:30:00',2.28),('8998','2014-03-18','09:35:00',1.99),('8998','2014-03-18','09:40:00',2.62),('8998','2014-03-18','09:45:00',2.62),('8998','2014-03-18','09:50:00',2.29),('8998','2014-03-18','09:55:00',2.25),('8998','2014-03-18','10:00:00',1.26),('8998','2014-03-18','10:35:00',1.03),('8998','2014-03-18','10:40:00',1.68),('8998','2014-03-18','10:45:00',2.13),('8998','2014-03-18','10:50:00',2.3),('8998','2014-03-18','10:55:00',1.37),('8998','2014-03-18','11:00:00',1.15),('8998','2014-03-18','11:05:00',1.88),('8998','2014-03-18','11:10:00',1.45),('8998','2014-03-18','11:15:00',1.19),('8998','2014-03-18','11:20:00',1.28),('8998','2014-03-18','11:25:00',1.28),('8998','2014-03-18','11:30:00',1.64),('8998','2014-03-18','11:35:00',1.5),('8998','2014-03-18','11:40:00',1.18),('8998','2014-03-18','11:45:00',1.19),('8998','2014-03-18','11:50:00',1.12),('8998','2014-03-18','11:55:00',1.06),('8998','2014-03-18','12:00:00',1.4),('8998','2014-03-18','12:05:00',2.88),('8998','2014-03-18','12:10:00',2.84),('8998','2014-03-18','12:15:00',2.84),('8998','2014-03-18','12:20:00',2.17),('8998','2014-03-18','12:25:00',1.46),('8998','2014-03-18','12:30:00',1.39),('8998','2014-03-18','12:35:00',1.76),('8998','2014-03-18','12:40:00',2.7),('8998','2014-03-18','12:45:00',2.53),('8998','2014-03-18','12:50:00',1.88),('8998','2014-03-18','12:55:00',1.33),('8998','2014-03-18','13:00:00',1.97),('8998','2014-03-18','13:05:00',2.25),('8998','2014-03-18','13:10:00',2.28),('8998','2014-03-18','13:15:00',2.16),('8998','2014-03-18','13:20:00',1.95),('8998','2014-03-18','13:25:00',1.85),('8998','2014-03-18','13:30:00',2),('8998','2014-03-18','13:35:00',1.98),('8998','2014-03-18','13:40:00',1.91),('8998','2014-03-18','13:45:00',1.85),('8998','2014-03-18','13:50:00',1.78),('8998','2014-03-18','13:55:00',1.77),('8998','2014-03-18','14:00:00',1.7),('8998','2014-03-18','14:05:00',1.67),('8998','2014-03-18','14:10:00',1.63),('8998','2014-03-18','14:15:00',1.59),('8998','2014-03-18','14:20:00',1.5),('8998','2014-03-18','14:25:00',1.44),('8998','2014-03-18','14:30:00',1.36),('8998','2014-03-18','14:35:00',1.33),('8998','2014-03-18','14:40:00',1.25),('8998','2014-03-18','14:45:00',1.17),('8998','2014-03-18','14:50:00',1.13),('8998','2014-03-18','14:55:00',1.07),('8998','2014-03-18','15:00:00',1.03),('8998','2013-01-10','10:05:00',1.07),('8998','2013-01-10','10:10:00',1.12),('8998','2013-01-10','10:15:00',1.39),('8998','2013-01-10','10:25:00',1.71),('8998','2013-01-10','10:30:00',1.65),('8998','2013-01-10','10:35:00',1.65),('8998','2013-01-10','10:40:00',1.64),('8998','2013-01-10','10:45:00',1.65),('8998','2013-01-10','10:50:00',1.66),('8998','2013-01-10','10:55:00',1.65),('8998','2013-01-10','11:00:00',1.67),('8998','2013-01-10','11:05:00',1.66),('8998','2013-01-10','11:10:00',1.64),('8998','2013-01-10','11:15:00',1.6),('8998','2013-01-10','11:20:00',1.59),('8998','2013-01-10','11:25:00',1.19),('8998','2013-01-10','11:35:00',1.04),('8998','2013-01-10','11:45:00',1.05),('8998','2013-01-08','11:15:00',1.38),('8998','2013-01-08','11:20:00',1.15),('8998','2013-01-08','13:10:00',1.18),('8998','2013-01-07','08:40:00',1.16),('8998','2013-01-07','08:45:00',1.23),('8998','2013-01-07','08:50:00',1.24),('8998','2013-01-07','08:55:00',1.08),('8998','2013-01-07','09:00:00',1.42),('8998','2013-01-07','09:05:00',1.39),('8998','2013-01-07','09:15:00',1.11),('8998','2013-01-07','09:20:00',1.35),('8998','2013-01-07','09:25:00',1.42),('8998','2013-01-07','09:30:00',1.23),('8998','2013-01-07','09:40:00',1.42),('8998','2013-01-07','09:45:00',1.63),('8998','2013-01-07','09:50:00',1.68),('8998','2013-01-07','09:55:00',1.61),('8998','2013-01-07','10:00:00',1.44),('8998','2013-01-07','10:05:00',1.41),('8998','2013-01-07','10:10:00',1.45),('8998','2013-01-07','10:15:00',1.48),('8998','2013-01-07','10:20:00',1.39),('8998','2013-01-07','10:25:00',1.5),('8998','2013-01-07','10:30:00',1.5),('8998','2013-01-07','10:35:00',1.64),('8998','2013-01-07','10:40:00',1.75),('8998','2013-01-07','10:45:00',1.68),('8998','2013-01-07','10:50:00',1.71),('8998','2013-01-07','10:55:00',1.72),('8998','2013-01-07','11:00:00',1.65),('8998','2013-01-07','11:05:00',1.69),('8998','2013-01-07','11:10:00',1.67),('8998','2013-01-07','11:15:00',1.66),('8998','2013-01-07','11:20:00',1.65),('8998','2013-01-07','11:25:00',1.65),('8998','2013-01-07','11:30:00',1.66),('8998','2013-01-07','11:35:00',1.65),('8998','2013-01-07','11:40:00',1.62),('8998','2013-01-07','11:45:00',2),('8998','2013-01-07','11:50:00',1.52),('8998','2013-01-07','11:55:00',1.17),('8998','2013-01-07','12:00:00',1.04),('8998','2013-01-07','12:10:00',1.02),('8998','2013-01-07','12:50:00',1.15),('8998','2013-01-06','08:55:00',1.08),('8998','2013-01-06','09:10:00',1.08),('8998','2013-01-06','09:20:00',1.23),('8998','2013-01-06','09:25:00',1.32),('8998','2013-01-06','09:30:00',1.35),('8998','2013-01-06','09:35:00',1.37),('8998','2013-01-06','09:40:00',1.38),('8998','2013-01-06','09:45:00',1.45),('8998','2013-01-06','09:50:00',1.46),('8998','2013-01-06','09:55:00',1.51),('8998','2013-01-06','10:00:00',1.54),('8998','2013-01-06','10:05:00',1.59),('8998','2013-01-06','10:10:00',1.64),('8998','2013-01-06','10:15:00',1.66),('8998','2013-01-06','10:20:00',1.64),('8998','2013-01-06','10:25:00',1.68),('8998','2013-01-06','10:30:00',1.66),('8998','2013-01-06','10:35:00',1.67),('8998','2013-01-06','10:40:00',1.69),('8998','2013-01-06','10:45:00',1.68),('8998','2013-01-06','10:50:00',1.66),('8998','2013-01-06','10:55:00',1.62),('8998','2013-01-06','11:00:00',1.63),('8998','2013-01-06','11:05:00',1.6),('8998','2013-01-06','11:10:00',1.62),('8998','2013-01-06','11:15:00',1.64),('8998','2013-01-06','11:20:00',1.62),('8998','2013-01-06','11:25:00',1.62),('8998','2013-01-06','11:30:00',1.61),('8998','2013-01-06','11:35:00',1.59),('8998','2013-01-06','11:40:00',1.58),('8998','2013-01-06','11:45:00',1.56),('8998','2013-01-06','11:50:00',1.56),('8998','2013-01-06','11:55:00',1.55),('8998','2013-01-06','12:00:00',1.53),('8998','2013-01-06','12:05:00',1.51),('8998','2013-01-06','12:10:00',1.49),('8998','2013-01-06','12:15:00',1.47),('8998','2013-01-06','12:20:00',1.44),('8998','2013-01-06','12:25:00',1.42),('8998','2013-01-06','12:30:00',1.39),('8998','2013-01-06','12:35:00',1.35),('8998','2013-01-06','12:40:00',1.33),('8998','2013-01-06','12:45:00',1.31),('8998','2013-01-06','12:50:00',1.26),('8998','2013-01-06','12:55:00',1.23),('8998','2013-01-06','13:00:00',1.18),('8998','2013-01-06','13:05:00',1.09),('8998','2013-01-05','08:45:00',1.02),('8998','2013-01-05','08:50:00',1.07),('8998','2013-01-05','08:55:00',1.14),('8998','2013-01-05','09:05:00',1.25),('8998','2013-01-05','09:10:00',1.29),('8998','2013-01-05','09:15:00',1.33),('8998','2013-01-05','09:20:00',1.36),('8998','2013-01-05','09:25:00',1.39),('8998','2013-01-05','09:30:00',1.43),('8998','2013-01-05','09:35:00',1.46),('8998','2013-01-05','09:40:00',1.49),('8998','2013-01-05','09:45:00',1.51),('8998','2013-01-05','09:50:00',1.54),('8998','2013-01-05','09:55:00',1.54),('8998','2013-01-05','10:00:00',1.57),('8998','2013-01-05','10:05:00',1.57),('8998','2013-01-05','10:10:00',1.6),('8998','2013-01-05','10:15:00',1.62),('8998','2013-01-05','10:20:00',1.6),('8998','2013-01-05','10:25:00',1.64),('8998','2013-01-05','10:30:00',1.65),('8998','2013-01-05','10:35:00',1.66),('8998','2013-01-05','10:40:00',1.67),('8998','2013-01-05','10:45:00',1.67),('8998','2013-01-05','10:50:00',1.68),('8998','2013-01-05','10:55:00',1.67),('8998','2013-01-05','11:00:00',1.66),('8998','2013-01-05','11:05:00',1.66),('8998','2013-01-05','11:10:00',1.66),('8998','2013-01-05','11:15:00',1.64),('8998','2013-01-05','11:20:00',1.64),('8998','2013-01-05','11:25:00',1.64),('8998','2013-01-05','11:30:00',1.63),('8998','2013-01-05','11:35:00',1.61),('8998','2013-01-05','11:40:00',1.59),('8998','2013-01-05','11:45:00',1.58),('8998','2013-01-05','11:50:00',1.57),('8998','2013-01-05','11:55:00',1.55),('8998','2013-01-05','12:00:00',1.54),('8998','2013-01-05','12:05:00',1.53),('8998','2013-01-05','12:10:00',1.5),('8998','2013-01-05','12:15:00',1.47),('8998','2013-01-05','12:20:00',1.44),('8998','2013-01-05','12:25:00',1.39),('8998','2013-01-05','12:30:00',1.38),('8998','2013-01-05','12:35:00',1.34),('8998','2013-01-05','12:40:00',1.31),('8998','2013-01-05','12:45:00',1.28),('8998','2013-01-05','12:50:00',1.26),('8998','2013-01-05','12:55:00',1.22),('8998','2013-01-05','13:00:00',1.17),('8998','2013-01-05','13:05:00',1.12),('8998','2013-01-05','13:10:00',1.08),('8998','2013-01-05','13:15:00',1.01),('8998','2013-01-04','10:55:00',1.5),('8998','2013-01-04','11:00:00',1.26),('8998','2013-01-04','11:05:00',1.51),('8998','2013-01-04','11:10:00',1.44),('8998','2013-01-04','11:15:00',1.23),('8998','2013-01-04','11:20:00',1.59),('8998','2013-01-04','11:25:00',1.65),('8998','2013-01-04','11:30:00',1.65),('8998','2013-01-04','11:35:00',1.51),('8998','2013-01-04','11:40:00',1.36),('8998','2013-01-04','11:45:00',1.35),('8998','2013-01-04','11:50:00',1.19),('8998','2013-01-04','11:55:00',1.07),('8998','2013-01-04','12:00:00',1.01),('8998','2013-01-04','12:35:00',1.04),('8998','2013-01-04','12:40:00',1.22),('8998','2013-01-04','12:45:00',1.33),('8998','2013-01-03','08:50:00',1.04),('8998','2013-01-03','09:05:00',1.13),('8998','2013-01-03','09:10:00',1.18),('8998','2013-01-03','09:20:00',1.16),('8998','2013-01-03','09:25:00',1.07),('8998','2013-01-03','09:30:00',1.03),('8998','2013-01-03','09:40:00',1.04),('8998','2013-01-03','09:45:00',1.02),('8998','2013-01-03','09:50:00',1.06),('8998','2013-01-03','09:55:00',1.41),('8998','2013-01-03','10:00:00',1.63),('8998','2013-01-03','10:05:00',1.65),('8998','2013-01-03','10:10:00',1.37),('8998','2013-01-03','10:15:00',1.62),('8998','2013-01-03','10:20:00',1.3),('8998','2013-01-03','10:25:00',1.63),('8998','2013-01-03','10:30:00',1.68),('8998','2013-01-03','10:35:00',1.7),('8998','2013-01-03','10:40:00',1.74),('8998','2013-01-03','10:45:00',1.81),('8998','2013-01-03','10:50:00',1.88),('8998','2013-01-03','10:55:00',1.88),('8998','2013-01-03','11:00:00',1.62),('8998','2013-01-03','11:45:00',1.07),('8998','2013-01-03','11:50:00',1.57),('8998','2013-01-03','11:55:00',1.8),('8998','2013-01-03','12:00:00',1.79),('8998','2013-01-03','12:05:00',1.53),('8998','2013-01-03','12:10:00',1.22),('8998','2013-01-03','12:30:00',1.04),('8998','2013-01-03','12:40:00',1.31),('8998','2013-01-03','12:45:00',1.38),('8998','2013-01-03','12:50:00',1.37),('8998','2013-01-03','12:55:00',1.31),('8998','2013-01-03','13:00:00',1.17),('8998','2013-01-03','13:05:00',1),('8998','2013-01-02','08:50:00',1.02),('8998','2013-01-02','08:55:00',1.05),('8998','2013-01-02','09:05:00',1.2),('8998','2013-01-02','09:10:00',1.25),('8998','2013-01-02','09:15:00',1.3),('8998','2013-01-02','09:20:00',1.34),('8998','2013-01-02','09:25:00',1.38),('8998','2013-01-02','09:30:00',1.42),('8998','2013-01-02','09:35:00',1.46),('8998','2013-01-02','09:40:00',1.54),('8998','2013-01-02','09:45:00',1.65),('8998','2013-01-02','09:50:00',1.75),('8998','2013-01-02','09:55:00',1.83),('8998','2013-01-02','10:00:00',1.9),('8998','2013-01-02','10:05:00',1.82),('8998','2013-01-02','10:10:00',1.9),('8998','2013-01-02','10:15:00',2.04),('8998','2013-01-02','10:20:00',1.57),('8998','2013-01-02','10:25:00',1.52),('8998','2013-01-02','10:30:00',1.38),('8998','2013-01-02','10:35:00',1.46),('8998','2013-01-02','10:40:00',1.3),('8998','2013-01-02','10:45:00',1.18),('8998','2013-01-02','10:50:00',1.12),('8998','2013-01-02','10:55:00',1.04),('8998','2013-01-02','11:00:00',1.12),('8998','2013-01-02','11:05:00',1.06),('8998','2013-01-02','11:35:00',1.46),('8998','2013-01-02','11:40:00',1.68),('8998','2013-01-02','11:45:00',1.65),('8998','2013-01-02','11:50:00',1.6),('8998','2013-01-02','11:55:00',1.56),('8998','2013-01-02','12:00:00',1.53),('8998','2013-01-02','12:05:00',1.51),('8998','2013-01-02','12:10:00',1.48),('8998','2013-01-02','12:15:00',1.45),('8998','2013-01-02','12:20:00',1.43),('8998','2013-01-02','12:25:00',1.41),('8998','2013-01-02','12:30:00',1.38),('8998','2013-01-02','12:35:00',1.36),('8998','2013-01-02','12:40:00',1.32),('8998','2013-01-02','12:45:00',1.29),('8998','2013-01-02','12:50:00',1.24),('8998','2013-01-02','12:55:00',1.2),('8998','2013-01-02','13:00:00',1.14),('8998','2013-01-02','13:05:00',1.1),('8998','2013-01-02','13:10:00',1.05),('8998','2014-03-17','07:55:00',1.09),('8998','2014-03-17','08:00:00',1.13),('8998','2014-03-17','08:55:00',1.87),('8998','2014-03-17','09:00:00',2.11),('8998','2014-03-17','09:05:00',1.54),('8998','2014-03-17','09:10:00',1.13),('8998','2014-03-17','09:15:00',1.57),('8998','2014-03-17','09:20:00',2.2),('8998','2014-03-17','09:25:00',2.75),('8998','2014-03-17','09:30:00',1.7),('8998','2014-03-17','09:35:00',1.59),('8998','2014-03-17','09:40:00',2.06),('8998','2014-03-17','09:45:00',1.45),('8998','2014-03-17','09:50:00',1.9),('8998','2014-03-17','09:55:00',1.15),('8998','2014-03-17','10:00:00',1.48),('8998','2014-03-17','10:05:00',2.33),('8998','2014-03-17','10:10:00',1.62),('8998','2014-03-17','10:15:00',2.86),('8998','2014-03-17','10:20:00',2.61),('8998','2014-03-17','10:25:00',2.68),('8998','2014-03-17','10:30:00',2.14),('8998','2014-03-17','10:35:00',2.73),('8998','2014-03-17','10:40:00',2.34),('8998','2014-03-17','10:45:00',2.2),('8998','2014-03-17','10:50:00',1.53),('8998','2014-03-17','10:55:00',1.31),('8998','2014-03-17','11:00:00',2.89),('8998','2014-03-17','11:05:00',2.24),('8998','2014-03-17','11:10:00',1.55),('8998','2014-03-17','11:15:00',1.72),('8998','2014-03-17','11:25:00',1.07),('8998','2014-03-17','11:30:00',1.26),('8998','2014-03-17','11:35:00',1.66),('8998','2014-03-17','11:40:00',1.86),('8998','2014-03-17','11:45:00',2.18),('8998','2014-03-17','11:50:00',1.76),('8998','2014-03-17','11:55:00',1.22),('8998','2014-03-17','12:00:00',1.13),('8998','2014-03-17','12:05:00',1.19),('8998','2014-03-17','12:10:00',1.31),('8998','2014-03-17','12:15:00',1.6),('8998','2014-03-17','12:20:00',2.22),('8998','2014-03-17','12:25:00',1.85),('8998','2014-03-17','12:30:00',1.7),('8998','2014-03-17','12:35:00',2.59),('8998','2014-03-17','12:40:00',1.99),('8998','2014-03-17','12:45:00',2.21),('8998','2014-03-17','12:50:00',1.52),('8998','2014-03-17','12:55:00',2.16),('8998','2014-03-17','13:00:00',2.02),('8998','2014-03-17','13:05:00',2.32),('8998','2014-03-17','13:10:00',2.29),('8998','2014-03-17','13:15:00',2.2),('8998','2014-03-17','13:20:00',2.14),('8998','2014-03-17','13:25:00',1.95),('8998','2014-03-17','13:30:00',1.97),('8998','2014-03-17','13:35:00',1.96),('8998','2014-03-17','13:40:00',1.92),('8998','2014-03-17','13:45:00',1.84),('8998','2014-03-17','13:50:00',1.78),('8998','2014-03-17','13:55:00',1.76),('8998','2014-03-17','14:00:00',1.74),('8998','2014-03-17','14:05:00',1.68),('8998','2014-03-17','14:10:00',1.62),('8998','2014-03-17','14:15:00',1.57),('8998','2014-03-17','14:20:00',1.52),('8998','2014-03-17','14:25:00',1.46),('8998','2014-03-17','14:30:00',1.38),('8998','2014-03-17','14:35:00',1.31),('8998','2014-03-17','14:40:00',1.22),('8998','2014-03-17','14:45:00',1.18),('8998','2014-03-17','14:50:00',1.1),('8998','2014-03-17','14:55:00',1.04),('8998','2012-12-31','09:00:00',1.06),('8998','2012-12-31','09:05:00',1.16),('8998','2012-12-31','09:10:00',1.2),('8998','2012-12-31','09:15:00',1.23),('8998','2012-12-31','09:20:00',1.26),('8998','2012-12-31','09:25:00',1.29),('8998','2012-12-31','09:30:00',1.32),('8998','2012-12-31','09:35:00',1.35),('8998','2012-12-31','09:40:00',1.37),('8998','2012-12-31','09:45:00',1.4),('8998','2012-12-31','09:50:00',1.43),('8998','2012-12-31','09:55:00',1.45),('8998','2012-12-31','10:00:00',1.45),('8998','2012-12-31','10:05:00',1.47),('8998','2012-12-31','10:10:00',1.49),('8998','2012-12-31','10:15:00',1.51),('8998','2012-12-31','10:20:00',1.53),('8998','2012-12-31','10:25:00',1.54),('8998','2012-12-31','10:30:00',1.55),('8998','2012-12-31','10:35:00',1.56),('8998','2012-12-31','10:40:00',1.58),('8998','2012-12-31','10:45:00',1.48),('8998','2012-12-31','10:50:00',1.45),('8998','2012-12-31','11:05:00',1.63),('8998','2012-12-31','11:10:00',1.7),('8998','2012-12-31','11:15:00',1.69),('8998','2012-12-31','11:20:00',1.23),('8998','2012-12-31','11:25:00',1.48),('8998','2012-12-31','11:30:00',1.89),('8998','2012-12-31','11:45:00',1.41),('8998','2012-12-31','11:50:00',1.52),('8998','2012-12-31','11:55:00',1.45),('8998','2012-12-30','09:15:00',1.14),('8998','2012-12-30','09:20:00',1.4),('8998','2012-12-30','09:25:00',1.51),('8998','2012-12-30','09:30:00',1.29),('8998','2012-12-30','10:10:00',1.3),('8998','2012-12-30','10:15:00',1.74),('8998','2012-12-30','10:20:00',1.75),('8998','2012-12-30','10:25:00',1.72),('8998','2012-12-30','10:30:00',1.72),('8998','2012-12-30','10:35:00',1.72),('8998','2012-12-30','10:40:00',1.72),('8998','2012-12-30','10:45:00',1.68),('8998','2012-12-30','10:50:00',1.65),('8998','2012-12-30','10:55:00',1.66),('8998','2012-12-30','11:00:00',1.67),('8998','2012-12-30','11:05:00',1.66),('8998','2012-12-30','11:10:00',1.6),('8998','2012-12-30','11:15:00',1.58),('8998','2012-12-30','11:20:00',1.63),('8998','2012-12-30','11:25:00',1.64),('8998','2012-12-30','11:30:00',1.63),('8998','2012-12-30','11:35:00',1.63),('8998','2012-12-30','11:40:00',1.62),('8998','2012-12-30','11:45:00',1.59),('8998','2012-12-30','11:50:00',1.58),('8998','2012-12-30','11:55:00',1.56),('8998','2012-12-30','12:00:00',1.56),('8998','2012-12-30','12:05:00',1.55),('8998','2012-12-30','12:10:00',1.53),('8998','2012-12-30','12:15:00',1.5),('8998','2012-12-30','12:20:00',1.47),('8998','2012-12-30','12:25:00',1.44),('8998','2012-12-30','12:30:00',1.41),('8998','2012-12-30','12:35:00',1.38),('8998','2012-12-30','12:40:00',1.34),('8998','2012-12-30','12:45:00',1.31),('8998','2012-12-30','12:50:00',1.26),('8998','2012-12-30','12:55:00',1.19),('8998','2012-12-30','13:00:00',1.13),('8998','2012-12-30','13:05:00',1.07),('8998','2012-12-29','08:45:00',1.01),('8998','2012-12-29','08:50:00',1.06),('8998','2012-12-29','09:00:00',1.17),('8998','2012-12-29','09:05:00',1.22),('8998','2012-12-29','09:10:00',1.26),('8998','2012-12-29','09:15:00',1.3),('8998','2012-12-29','09:20:00',1.34),('8998','2012-12-29','09:25:00',1.38),('8998','2012-12-29','09:30:00',1.4),('8998','2012-12-29','09:35:00',1.44),('8998','2012-12-29','09:40:00',1.46),('8998','2012-12-29','09:45:00',1.48),('8998','2012-12-29','09:50:00',1.49),('8998','2012-12-29','09:55:00',1.51),('8998','2012-12-29','10:00:00',1.55),('8998','2012-12-29','10:05:00',1.57),('8998','2012-12-29','10:10:00',1.59),('8998','2012-12-29','10:15:00',1.61),('8998','2012-12-29','10:20:00',1.63),('8998','2012-12-29','10:25:00',1.63),('8998','2012-12-29','10:30:00',1.65),('8998','2012-12-29','10:35:00',1.66),('8998','2012-12-29','10:40:00',1.66),('8998','2012-12-29','10:45:00',1.66),('8998','2012-12-29','10:50:00',1.66),('8998','2012-12-29','10:55:00',1.66),('8998','2012-12-29','11:00:00',1.65),('8998','2012-12-29','11:05:00',1.65),('8998','2012-12-29','11:10:00',1.66),('8998','2012-12-29','11:15:00',1.65),('8998','2012-12-29','11:20:00',1.64),('8998','2012-12-29','11:25:00',1.62),('8998','2012-12-29','11:30:00',1.62),('8998','2012-12-29','11:35:00',1.61),('8998','2012-12-29','11:40:00',1.58),('8998','2012-12-29','11:45:00',1.58),('8998','2012-12-29','11:50:00',1.56),('8998','2012-12-29','11:55:00',1.54),('8998','2012-12-29','12:00:00',1.51),('8998','2012-12-29','12:05:00',1.49),('8998','2012-12-29','12:10:00',1.47),('8998','2012-12-29','12:15:00',1.45),('8998','2012-12-29','12:20:00',1.42),('8998','2012-12-29','12:25:00',1.4),('8998','2012-12-29','12:30:00',1.37),('8998','2012-12-29','12:35:00',1.33),('8998','2012-12-29','12:40:00',1.3),('8998','2012-12-29','12:45:00',1.25),('8998','2012-12-29','12:50:00',1.2),('8998','2012-12-29','12:55:00',1.15),('8998','2012-12-29','13:00:00',1.12),('8998','2012-12-29','13:05:00',1.08),('8998','2012-12-29','13:10:00',1.04),('8998','2012-12-28','08:45:00',1.07),('8998','2012-12-28','08:50:00',1.12),('8998','2012-12-28','08:55:00',1.16),('8998','2012-12-28','09:00:00',1.03),('8998','2012-12-28','09:05:00',1.24),('8998','2012-12-28','09:10:00',1.29),('8998','2012-12-28','09:15:00',1.33),('8998','2012-12-28','09:20:00',1.36),('8998','2012-12-28','09:25:00',1.39),('8998','2012-12-28','09:30:00',1.41),('8998','2012-12-28','09:35:00',1.44),('8998','2012-12-28','09:40:00',1.47),('8998','2012-12-28','09:45:00',1.51),('8998','2012-12-28','09:50:00',1.55),('8998','2012-12-28','09:55:00',1.57),('8998','2012-12-28','10:00:00',1.6),('8998','2012-12-28','10:05:00',1.62),('8998','2012-12-28','10:10:00',1.63),('8998','2012-12-28','10:15:00',1.65),('8998','2012-12-28','10:20:00',1.66),('8998','2012-12-28','10:25:00',1.68),('8998','2012-12-28','10:30:00',1.69),('8998','2012-12-28','10:35:00',1.69),('8998','2012-12-28','10:40:00',1.7),('8998','2012-12-28','10:45:00',1.7),('8998','2012-12-28','10:50:00',1.71),('8998','2012-12-28','10:55:00',1.71),('8998','2012-12-28','11:00:00',1.7),('8998','2012-12-28','11:05:00',1.7),('8998','2012-12-28','11:10:00',1.69),('8998','2012-12-28','11:15:00',1.69),('8998','2012-12-28','11:20:00',1.68),('8998','2012-12-28','11:25:00',1.67),('8998','2012-12-28','11:30:00',1.65),('8998','2012-12-28','11:35:00',1.64),('8998','2012-12-28','11:40:00',1.61),('8998','2012-12-28','11:45:00',1.6),('8998','2012-12-28','11:50:00',1.58),('8998','2012-12-28','11:55:00',1.56),('8998','2012-12-28','12:00:00',1.55),('8998','2012-12-28','12:05:00',1.53),('8998','2012-12-28','12:10:00',1.52),('8998','2012-12-28','12:15:00',1.47),('8998','2012-12-28','12:20:00',1.44),('8998','2012-12-28','12:25:00',1.4),('8998','2012-12-28','12:30:00',1.37),('8998','2012-12-28','12:35:00',1.36),('8998','2012-12-28','12:40:00',1.34),('8998','2012-12-28','12:45:00',1.28),('8998','2012-12-28','12:50:00',1.22),('8998','2012-12-28','12:55:00',1.16),('8998','2012-12-28','13:00:00',1.13),('8998','2012-12-28','13:05:00',1.08),('8998','2012-12-28','13:10:00',1.04),('8998','2012-12-27','08:55:00',1.03),('8998','2012-12-27','09:00:00',1.09),('8998','2012-12-27','09:10:00',1.17),('8998','2012-12-27','09:15:00',1.22),('8998','2012-12-27','09:20:00',1.24),('8998','2012-12-27','09:25:00',1.25),('8998','2012-12-27','09:30:00',1.29),('8998','2012-12-27','09:35:00',1.32),('8998','2012-12-27','09:40:00',1.35),('8998','2012-12-27','09:45:00',1.38),('8998','2012-12-27','09:50:00',1.33),('8998','2012-12-27','09:55:00',1.41),('8998','2012-12-27','10:00:00',1.43),('8998','2012-12-27','10:05:00',1.46),('8998','2012-12-27','10:10:00',1.49),('8998','2012-12-27','10:15:00',1.54),('8998','2012-12-27','10:20:00',1.54),('8998','2012-12-27','10:25:00',1.56),('8998','2012-12-27','10:30:00',1.59),('8998','2012-12-27','10:35:00',1.6),('8998','2012-12-27','10:40:00',1.58),('8998','2012-12-27','10:45:00',1.6),('8998','2012-12-27','10:50:00',1.6),('8998','2012-12-27','10:55:00',1.6),('8998','2012-12-27','11:00:00',1.6),('8998','2012-12-27','11:05:00',1.63),('8998','2012-12-27','11:10:00',1.56),('8998','2012-12-27','11:15:00',1.36),('8998','2012-12-27','11:20:00',1.59),('8998','2012-12-27','11:25:00',1.59),('8998','2012-12-27','11:30:00',1.58),('8998','2012-12-27','11:35:00',1.58),('8998','2012-12-27','11:40:00',1.57),('8998','2012-12-27','11:45:00',1.57),('8998','2012-12-27','11:50:00',1.49),('8998','2012-12-27','11:55:00',1.53),('8998','2012-12-27','12:00:00',1.5),('8998','2012-12-27','12:05:00',1.49),('8998','2012-12-27','12:10:00',1.46),('8998','2012-12-27','12:15:00',1.43),('8998','2012-12-27','12:20:00',1.39),('8998','2012-12-27','12:25:00',1.36),('8998','2012-12-27','12:30:00',1.33),('8998','2012-12-27','12:35:00',1.29),('8998','2012-12-27','12:40:00',1.09),('8998','2012-12-27','12:45:00',1.24),('8998','2012-12-27','12:50:00',1.23),('8998','2012-12-27','12:55:00',1.08),('8998','2012-12-26','09:35:00',1.22),('8998','2012-12-26','09:40:00',1.44),('8998','2012-12-26','09:45:00',1.46),('8998','2012-12-26','09:50:00',1.48),('8998','2012-12-26','09:55:00',1.03),('8998','2012-12-26','10:15:00',1.23),('8998','2012-12-26','10:20:00',1.46),('8998','2012-12-26','10:25:00',1.47),('8998','2012-12-26','10:30:00',1.43),('8998','2012-12-26','10:35:00',1.48),('8998','2012-12-26','10:40:00',1.49),('8998','2012-12-26','10:45:00',1.5),('8998','2012-12-26','10:50:00',1.5),('8998','2012-12-26','10:55:00',1.43),('8998','2012-12-26','11:00:00',1.42),('8998','2012-12-26','11:05:00',1.27),('8998','2012-12-26','11:55:00',1.41),('8998','2012-12-26','12:00:00',1.47),('8998','2012-12-26','12:05:00',1.56),('8998','2012-12-26','12:10:00',1.65),('8998','2012-12-26','12:15:00',1.51),('8998','2012-12-26','12:25:00',1.28),('8998','2012-12-26','12:30:00',1.35),('8998','2012-12-26','12:35:00',1.35),('8998','2012-12-26','12:40:00',1.3),('8998','2012-12-26','12:45:00',1.34),('8998','2012-12-26','12:55:00',1.18),('8998','2012-12-26','13:00:00',1.18),('8998','2012-12-25','09:15:00',1.04),('8998','2012-12-25','09:20:00',1.31),('8998','2012-12-25','09:25:00',1.33),('8998','2012-12-25','09:30:00',1.34),('8998','2012-12-25','09:35:00',1.35),('8998','2012-12-25','09:40:00',1.39),('8998','2012-12-25','09:45:00',1.4),('8998','2012-12-25','09:50:00',1.43),('8998','2012-12-25','09:55:00',1.46),('8998','2012-12-25','10:00:00',1.48),('8998','2012-12-25','10:05:00',1.49),('8998','2012-12-25','10:10:00',1.51),('8998','2012-12-25','10:15:00',1.51),('8998','2012-12-25','10:20:00',1.52),('8998','2012-12-25','10:25:00',1.52),('8998','2012-12-25','10:30:00',1.52),('8998','2012-12-25','10:35:00',1.53),('8998','2012-12-25','10:40:00',1.53),('8998','2012-12-25','10:45:00',1.52),('8998','2012-12-25','10:50:00',1.51),('8998','2012-12-25','10:55:00',1.52),('8998','2012-12-25','11:00:00',1.51),('8998','2012-12-25','11:05:00',1.52),('8998','2012-12-25','11:10:00',1.51),('8998','2012-12-25','11:15:00',1.5),('8998','2012-12-25','11:20:00',1.49),('8998','2012-12-25','11:25:00',1.49),('8998','2012-12-25','11:30:00',1.46),('8998','2012-12-25','11:35:00',1.45),('8998','2012-12-25','11:40:00',1.45),('8998','2012-12-25','11:45:00',1.44),('8998','2012-12-25','11:50:00',1.43),('8998','2012-12-25','11:55:00',1.44),('8998','2012-12-25','12:00:00',1.46),('8998','2012-12-25','12:05:00',1.46),('8998','2012-12-25','12:10:00',1.42),('8998','2012-12-25','12:15:00',1.42),('8998','2012-12-25','12:20:00',1.41),('8998','2012-12-25','12:25:00',1.41),('8998','2012-12-25','12:30:00',1.37),('8998','2012-12-25','12:35:00',1.33),('8998','2012-12-25','12:40:00',1.34),('8998','2012-12-25','12:45:00',1.29),('8998','2012-12-25','12:50:00',1.2),('8998','2012-12-25','12:55:00',1.15),('8998','2012-12-25','13:00:00',1.15),('8998','2012-12-25','13:05:00',1.09),('8998','2012-12-25','13:10:00',1.08),('8998','2012-12-25','13:15:00',1.03),('8998','2012-12-25','13:20:00',1.05),('8998','2012-12-25','13:25:00',1.05),('8998','2012-12-25','13:30:00',1.17),('8998','2012-12-25','13:35:00',1.09),('8998','2012-12-25','13:40:00',1.03),('8998','2012-12-22','08:45:00',1.03),('8998','2012-12-22','08:50:00',1.07),('8998','2012-12-22','09:00:00',1.21),('8998','2012-12-22','09:05:00',1.26),('8998','2012-12-22','09:10:00',1.28),('8998','2012-12-22','09:15:00',1.28),('8998','2012-12-22','09:20:00',1.31),('8998','2012-12-22','09:25:00',1.36),('8998','2012-12-22','09:30:00',1.35),('8998','2012-12-22','09:35:00',1.4),('8998','2012-12-22','09:40:00',1.42),('8998','2012-12-22','09:45:00',1.44),('8998','2012-12-22','09:50:00',1.45),('8998','2012-12-22','09:55:00',1.45),('8998','2012-12-22','10:00:00',1.46),('8998','2012-12-22','10:05:00',1.5),('8998','2012-12-22','10:10:00',1.51),('8998','2012-12-22','10:15:00',1.52),('8998','2012-12-22','10:20:00',1.54),('8998','2012-12-22','10:25:00',1.54),('8998','2012-12-22','10:30:00',1.52),('8998','2012-12-22','10:35:00',1.56),('8998','2012-12-22','10:40:00',1.56),('8998','2012-12-22','10:45:00',1.58),('8998','2012-12-22','10:50:00',1.56),('8998','2012-12-22','10:55:00',1.46),('8998','2012-12-22','11:00:00',1.56),('8998','2012-12-22','11:05:00',1.55),('8998','2012-12-22','11:10:00',1.54),('8998','2012-12-22','11:15:00',1.54),('8998','2012-12-22','11:20:00',1.57),('8998','2012-12-22','11:25:00',1.41),('8998','2012-12-22','11:30:00',1.48),('8998','2012-12-22','11:35:00',1.55),('8998','2012-12-22','11:40:00',1.53),('8998','2012-12-22','11:45:00',1.5),('8998','2012-12-22','11:50:00',1.53),('8998','2012-12-22','11:55:00',1.41),('8998','2012-12-22','12:00:00',1.31),('8998','2012-12-22','12:05:00',1.31),('8998','2012-12-22','12:10:00',1.3),('8998','2012-12-22','12:15:00',1.05),('8998','2012-12-22','12:55:00',1.05),('8998','2012-12-22','13:00:00',1.07),('8998','2012-12-22','13:10:00',1.07),('8998','2014-04-30','07:45:00',1.09),('8998','2014-04-30','07:50:00',1.31),('8998','2014-04-30','07:55:00',1.42),('8998','2014-04-30','08:00:00',1.23),('8998','2014-04-30','08:05:00',1.57),('8998','2014-04-30','08:10:00',1.69),('8998','2014-04-30','08:15:00',1.69),('8998','2014-04-30','08:20:00',1.3),('8998','2014-04-30','08:25:00',1.78),('8998','2014-04-30','08:30:00',2.03),('8998','2014-04-30','08:35:00',2.1),('8998','2014-04-30','08:40:00',2.18),('8998','2014-04-30','08:45:00',2.16),('8998','2014-04-30','08:50:00',2.2),('8998','2014-04-30','08:55:00',2.42),('8998','2014-04-30','09:00:00',1.25),('8998','2014-04-30','09:05:00',1.18),('8998','2014-04-30','09:10:00',1.83),('8998','2014-04-30','09:15:00',1.57),('8998','2014-04-30','09:25:00',1.82),('8998','2014-04-30','09:30:00',2.66),('8998','2014-04-30','09:35:00',2.44),('8998','2014-04-30','09:40:00',1.13),('8998','2014-04-30','09:45:00',1.81),('8998','2014-04-30','09:50:00',1.29),('8998','2014-04-30','09:55:00',1.4),('8998','2014-04-30','10:00:00',1.37),('8998','2014-04-30','10:05:00',2.37),('8998','2014-04-30','10:10:00',2.34),('8998','2014-04-30','10:15:00',2.59),('8998','2014-04-30','10:20:00',2.43),('8998','2014-04-30','10:25:00',2.92),('8998','2014-04-30','10:30:00',2.08),('8998','2014-04-30','10:35:00',1.23),('8998','2014-04-30','10:40:00',1.06),('8998','2014-04-30','10:45:00',3.41),('8998','2014-04-30','10:50:00',3.38),('8998','2014-04-30','10:55:00',2.59),('8998','2014-04-30','11:00:00',2.86),('8998','2014-04-30','11:05:00',1.19),('8998','2014-04-30','11:10:00',1.19),('8998','2014-04-30','11:15:00',2.42),('8998','2014-04-30','11:20:00',3.69),('8998','2014-04-30','11:25:00',2.57),('8998','2014-04-30','11:30:00',3.46),('8998','2014-04-30','11:35:00',2.54),('8998','2014-04-30','11:40:00',2.74),('8998','2014-04-30','11:45:00',3.24),('8998','2014-04-30','11:50:00',1.57),('8998','2014-04-30','11:55:00',3.3),('8998','2014-04-30','12:00:00',2.66),('8998','2014-04-30','12:05:00',3.53),('8998','2014-04-30','12:10:00',2.79),('8998','2014-04-30','12:15:00',2.25),('8998','2014-04-30','12:20:00',1.96),('8998','2014-04-30','12:25:00',2.97),('8998','2014-04-30','12:30:00',3.43),('8998','2014-04-30','12:35:00',3.43),('8998','2014-04-30','12:40:00',3.38),('8998','2014-04-30','12:45:00',3.26),('8998','2014-04-30','12:50:00',3.25),('8998','2014-04-30','12:55:00',3.23),('8998','2014-04-30','13:00:00',3.28),('8998','2014-04-30','13:05:00',3.2),('8998','2014-04-30','13:10:00',3.24),('8998','2014-04-30','13:15:00',3.12),('8998','2014-04-30','13:25:00',2.89),('8998','2014-04-30','13:30:00',3.34),('8998','2014-04-30','13:35:00',3.19),('8998','2014-04-30','13:40:00',2.74),('8998','2014-04-30','13:45:00',2.33),('8998','2014-04-30','13:50:00',1.64),('8998','2014-04-30','14:00:00',1.04),('8998','2014-04-30','14:10:00',3.13),('8998','2014-04-30','14:15:00',3.01),('8998','2014-04-30','14:20:00',2.67),('8998','2014-04-30','14:25:00',2.9),('8998','2014-04-30','14:30:00',2.63),('8998','2014-04-30','14:35:00',2.56),('8998','2014-04-30','14:40:00',2.67),('8998','2014-04-30','14:45:00',2.27),('8998','2014-04-30','14:50:00',2.34),('8998','2014-04-30','14:55:00',2.51),('8998','2014-04-30','15:00:00',2.37),('8998','2014-04-30','15:05:00',2.56),('8998','2014-04-30','15:10:00',1.83),('8998','2014-04-30','15:15:00',2.23),('8998','2014-04-30','15:20:00',2.19),('8998','2014-04-30','15:25:00',2.12),('8998','2014-04-30','15:30:00',2.01),('8998','2014-04-30','15:35:00',1.94),('8998','2014-04-30','15:40:00',1.89),('8998','2014-04-30','15:45:00',1.86),('8998','2014-04-30','15:50:00',1.74),('8998','2014-04-30','15:55:00',1.67),('8998','2014-04-30','16:00:00',1.6),('8998','2014-04-30','16:05:00',1.57),('8998','2014-04-30','16:10:00',1.48),('8998','2014-04-30','16:15:00',1.43),('8998','2014-04-30','16:20:00',1.36),('8998','2014-04-30','16:25:00',1.2),('8998','2014-04-30','16:30:00',1.23),('8998','2014-04-30','16:35:00',1.19),('8998','2014-04-30','16:40:00',1.09),('8998','2014-03-16','09:30:00',1.14),('8998','2014-03-16','09:35:00',1.34),('8998','2014-03-16','09:40:00',1.08),('8998','2014-03-16','09:50:00',1.07),('8998','2014-03-16','09:55:00',1.42),('8998','2014-03-16','10:00:00',1.43),('8998','2014-03-16','10:05:00',1.33),('8998','2014-03-16','10:10:00',1.22),('8998','2014-03-16','10:15:00',1.27),('8998','2014-03-16','10:20:00',1.6),('8998','2014-03-16','10:25:00',1.35),('8998','2014-03-16','10:35:00',1.03),('8998','2014-03-16','10:40:00',1.23),('8998','2014-03-16','10:45:00',1.2),('8998','2014-03-16','10:50:00',1.11),('8998','2014-03-16','11:00:00',1.05),('8998','2014-03-16','11:05:00',1.09),('8998','2014-03-16','11:10:00',1.08),('8998','2014-03-16','11:15:00',1.23),('8998','2014-03-16','11:20:00',1.13),('8998','2014-03-16','11:50:00',1.05),('8998','2014-03-16','11:55:00',1.13),('8998','2014-03-16','12:00:00',1.7),('8998','2014-03-16','12:05:00',1.44),('8998','2014-03-16','12:10:00',1.19),('8998','2014-03-16','12:15:00',1.2),('8998','2014-03-16','12:20:00',1.08),('8998','2014-03-16','12:25:00',1.77),('8998','2014-03-16','12:30:00',1.08),('8998','2014-03-16','12:35:00',1.2),('8998','2014-03-16','12:40:00',2.35),('8998','2014-03-16','12:45:00',2.62),('8998','2014-03-16','12:50:00',2.55),('8998','2014-03-16','12:55:00',2.46),('8998','2014-03-16','13:00:00',2.37),('8998','2014-03-16','13:05:00',1.85),('8998','2014-03-16','13:10:00',2.1),('8998','2014-03-16','13:15:00',2.21),('8998','2014-03-16','13:20:00',2.19),('8998','2014-03-16','13:25:00',2.17),('8998','2014-03-16','13:30:00',2.04),('8998','2014-03-16','13:35:00',2.08),('8998','2014-03-16','13:40:00',2.07),('8998','2014-03-16','13:45:00',2.09),('8998','2014-03-16','13:50:00',1.92),('8998','2014-03-16','13:55:00',1.84),('8998','2014-03-16','14:00:00',1.34),('8998','2014-03-16','14:05:00',1.92),('8998','2014-03-16','14:10:00',1.53),('8998','2014-03-16','14:20:00',1.38),('8998','2014-03-16','14:25:00',1.56),('8998','2014-03-16','14:35:00',1.12),('8998','2014-03-16','14:40:00',1.26),('8998','2014-03-16','14:45:00',1.01),('8998','2014-03-16','14:55:00',1.07),('8998','2012-12-21','10:25:00',1.5),('8998','2012-12-21','10:30:00',1.84),('8998','2012-12-21','10:35:00',1.94),('8998','2012-12-21','10:40:00',1.86),('8998','2012-12-21','10:45:00',1.81),('8998','2012-12-21','10:50:00',1.77),('8998','2012-12-21','10:55:00',1.77),('8998','2012-12-21','11:00:00',1.12),('8998','2012-12-21','11:50:00',1.34),('8998','2012-12-21','12:00:00',1.24),('8998','2012-12-21','13:05:00',1.32),('8998','2012-12-21','13:10:00',1.35),('8998','2012-12-21','13:15:00',1.24),('8998','2012-12-21','13:20:00',1.21),('8998','2012-12-21','13:25:00',1.13),('8998','2014-03-15','08:05:00',1),('8998','2014-03-15','08:10:00',1),('8998','2014-03-15','08:15:00',1.08),('8998','2014-03-15','08:20:00',1.21),('8998','2014-03-15','08:25:00',1.3),('8998','2014-03-15','08:30:00',1.45),('8998','2014-03-15','08:35:00',1.61),('8998','2014-03-15','08:40:00',1.67),('8998','2014-03-15','08:45:00',1.74),('8998','2014-03-15','08:50:00',1.81),('8998','2014-03-15','08:55:00',1.81),('8998','2014-03-15','09:00:00',1.78),('8998','2014-03-15','09:05:00',1.84),('8998','2014-03-15','09:10:00',1.94),('8998','2014-03-15','09:15:00',2.07),('8998','2014-03-15','09:20:00',2.06),('8998','2014-03-15','09:25:00',2.05),('8998','2014-03-15','09:30:00',2.07),('8998','2014-03-15','09:35:00',2.06),('8998','2014-03-15','09:40:00',2.04),('8998','2014-03-15','09:45:00',2.2),('8998','2014-03-15','09:50:00',2.32),('8998','2014-03-15','09:55:00',2.31),('8998','2014-03-15','10:00:00',2.28),('8998','2014-03-15','10:05:00',2.28),('8998','2014-03-15','10:10:00',2.35),('8998','2014-03-15','10:15:00',2.39),('8998','2014-03-15','10:20:00',2.37),('8998','2014-03-15','10:25:00',2.34),('8998','2014-03-15','10:30:00',2.3),('8998','2014-03-15','10:35:00',2.31),('8998','2014-03-15','10:40:00',2.43),('8998','2014-03-15','10:45:00',2.44),('8998','2014-03-15','10:50:00',2.45),('8998','2014-03-15','10:55:00',2.45),('8998','2014-03-15','11:00:00',2.39),('8998','2014-03-15','11:05:00',2.33),('8998','2014-03-15','11:10:00',2.23),('8998','2014-03-15','11:15:00',2.14),('8998','2014-03-15','11:20:00',2.41),('8998','2014-03-15','11:25:00',2.43),('8998','2014-03-15','11:30:00',2.43),('8998','2014-03-15','11:35:00',2.41),('8998','2014-03-15','11:40:00',2.43),('8998','2014-03-15','11:45:00',2.41),('8998','2014-03-15','11:50:00',2.43),('8998','2014-03-15','11:55:00',2.35),('8998','2014-03-15','12:00:00',2.32),('8998','2014-03-15','12:05:00',2.29),('8998','2014-03-15','12:10:00',2.28),('8998','2014-03-15','12:15:00',2.3),('8998','2014-03-15','12:20:00',2.27),('8998','2014-03-15','12:25:00',2.17),('8998','2014-03-15','12:30:00',2.15),('8998','2014-03-15','12:35:00',2.17),('8998','2014-03-15','12:40:00',2.17),('8998','2014-03-15','12:45:00',2.16),('8998','2014-03-15','12:50:00',2.12),('8998','2014-03-15','12:55:00',2.03),('8998','2014-03-15','13:00:00',2),('8998','2014-03-15','13:05:00',1.99),('8998','2014-03-15','13:10:00',1.96),('8998','2014-03-15','13:15:00',1.95),('8998','2014-03-15','13:20:00',1.89),('8998','2014-03-15','13:25:00',1.9),('8998','2014-03-15','13:30:00',1.87),('8998','2014-03-15','13:35:00',1.82),('8998','2014-03-15','13:40:00',1.88),('8998','2014-03-15','13:45:00',1.8),('8998','2014-03-15','13:50:00',1.74),('8998','2014-03-15','13:55:00',1.71),('8998','2014-03-15','14:00:00',1.66),('8998','2014-03-15','14:05:00',1.59),('8998','2014-03-15','14:10:00',1.52),('8998','2014-03-15','14:15:00',1.46),('8998','2014-03-15','14:20:00',1.43),('8998','2014-03-15','14:25:00',1.37),('8998','2014-03-15','14:30:00',1.3),('8998','2014-03-15','14:35:00',1.18),('8998','2014-03-15','14:40:00',1.12),('8998','2014-03-15','14:45:00',1.08),('8998','2014-03-14','07:55:00',1.02),('8998','2014-03-14','08:00:00',1.12),('8998','2014-03-14','08:05:00',1.19),('8998','2014-03-14','08:10:00',1.24),('8998','2014-03-14','08:15:00',1.34),('8998','2014-03-14','08:20:00',1.41),('8998','2014-03-14','08:25:00',1.47),('8998','2014-03-14','08:30:00',1.51),('8998','2014-03-14','08:35:00',1.56),('8998','2014-03-14','08:40:00',1.64),('8998','2014-03-14','08:45:00',1.68),('8998','2014-03-14','08:50:00',1.72),('8998','2014-03-14','08:55:00',1.77),('8998','2014-03-14','09:00:00',1.82),('8998','2014-03-14','09:05:00',1.86),('8998','2014-03-14','09:10:00',1.9),('8998','2014-03-14','09:15:00',1.95),('8998','2014-03-14','09:20:00',2.01),('8998','2014-03-14','09:25:00',2.05),('8998','2014-03-14','09:30:00',2.08),('8998','2014-03-14','09:35:00',2.12),('8998','2014-03-14','09:40:00',2.14),('8998','2014-03-14','09:45:00',2.14),('8998','2014-03-14','09:50:00',2.16),('8998','2014-03-14','09:55:00',2.18),('8998','2014-03-14','10:00:00',2.2),('8998','2014-03-14','10:05:00',2.21),('8998','2014-03-14','10:10:00',2.22),('8998','2014-03-14','10:15:00',2.22),('8998','2014-03-14','10:20:00',2.26),('8998','2014-03-14','10:25:00',2.29),('8998','2014-03-14','10:30:00',2.32),('8998','2014-03-14','10:35:00',2.32),('8998','2014-03-14','10:40:00',2.33),('8998','2014-03-14','10:45:00',2.34),('8998','2014-03-14','10:50:00',2.32),('8998','2014-03-14','10:55:00',2.31),('8998','2014-03-14','11:00:00',2.27),('8998','2014-03-14','11:05:00',2.28),('8998','2014-03-14','11:10:00',2.3),('8998','2014-03-14','11:15:00',2.32),('8998','2014-03-14','11:20:00',2.41),('8998','2014-03-14','11:25:00',2.33),('8998','2014-03-14','11:30:00',2.41),('8998','2014-03-14','11:35:00',2.36),('8998','2014-03-14','11:40:00',2.36),('8998','2014-03-14','11:45:00',2.36),('8998','2014-03-14','11:50:00',2.34),('8998','2014-03-14','11:55:00',2.35),('8998','2014-03-14','12:00:00',2.34),('8998','2014-03-14','12:05:00',2.3),('8998','2014-03-14','12:10:00',2.25),('8998','2014-03-14','12:15:00',2.28),('8998','2014-03-14','12:20:00',2.25),('8998','2014-03-14','12:25:00',2.21),('8998','2014-03-14','12:30:00',2.2),('8998','2014-03-14','12:35:00',2.22),('8998','2014-03-14','12:40:00',2.21),('8998','2014-03-14','12:45:00',2.18),('8998','2014-03-14','12:50:00',2.14),('8998','2014-03-14','12:55:00',2.11),('8998','2014-03-14','13:00:00',2.05),('8998','2014-03-14','13:05:00',2.04),('8998','2014-03-14','13:10:00',2.03),('8998','2014-03-14','13:15:00',1.98),('8998','2014-03-14','13:20:00',1.94),('8998','2014-03-14','13:25:00',1.91),('8998','2014-03-14','13:30:00',1.89),('8998','2014-03-14','13:35:00',1.84),('8998','2014-03-14','13:40:00',1.81),('8998','2014-03-14','13:45:00',1.76),('8998','2014-03-14','13:50:00',1.73),('8998','2014-03-14','13:55:00',1.68),('8998','2014-03-14','14:00:00',1.64),('8998','2014-03-14','14:05:00',1.61),('8998','2014-03-14','14:10:00',1.55),('8998','2014-03-14','14:15:00',1.5),('8998','2014-03-14','14:20:00',1.44),('8998','2014-03-14','14:25:00',1.38),('8998','2014-03-14','14:30:00',1.32),('8998','2014-03-14','14:35:00',1.26),('8998','2014-03-14','14:40:00',1.19),('8998','2014-03-14','14:45:00',1.05),('8998','2014-03-14','14:50:00',1.03),('8998','2014-03-13','08:30:00',1.05),('8998','2014-03-13','08:35:00',1.08),('8998','2014-03-13','08:40:00',1.05),('8998','2014-03-13','09:10:00',1.12),('8998','2014-03-13','09:15:00',1.15),('8998','2014-03-13','09:20:00',1.12),('8998','2014-03-13','09:25:00',1.21),('8998','2014-03-13','09:30:00',1.22),('8998','2014-03-13','09:35:00',1.45),('8998','2014-03-13','09:40:00',1.83),('8998','2014-03-13','09:45:00',2.12),('8998','2014-03-13','09:50:00',2.49),('8998','2014-03-13','09:55:00',2.62),('8998','2014-03-13','10:00:00',2.75),('8998','2014-03-13','10:05:00',2.73),('8998','2014-03-13','10:10:00',2.67),('8998','2014-03-13','10:15:00',2.61),('8998','2014-03-13','10:20:00',2.53),('8998','2014-03-13','10:25:00',2.45),('8998','2014-03-13','10:30:00',2.37),('8998','2014-03-13','10:35:00',2.45),('8998','2014-03-13','10:40:00',2.53),('8998','2014-03-13','10:45:00',2.3),('8998','2014-03-13','10:50:00',1.46),('8998','2014-03-13','10:55:00',1.78),('8998','2014-03-13','11:00:00',2.37),('8998','2014-03-13','11:05:00',2.46),('8998','2014-03-13','11:10:00',2.63),('8998','2014-03-13','11:15:00',2.66),('8998','2014-03-13','11:20:00',2.53),('8998','2014-03-13','11:25:00',2.46),('8998','2014-03-13','11:30:00',2.43),('8998','2014-03-13','11:35:00',2.46),('8998','2014-03-13','11:40:00',2.45),('8998','2014-03-13','11:45:00',2.44),('8998','2014-03-13','11:50:00',2.43),('8998','2014-03-13','11:55:00',2.42),('8998','2014-03-13','12:00:00',2.43),('8998','2014-03-13','12:05:00',2.46),('8998','2014-03-13','12:10:00',2.29),('8998','2014-03-13','12:15:00',2.19),('8998','2014-03-13','12:20:00',1.96),('8998','2014-03-13','12:25:00',1.56),('8998','2014-03-13','12:30:00',1.37),('8998','2014-03-13','12:35:00',1.22),('8998','2014-03-13','12:40:00',1.4),('8998','2014-03-13','12:45:00',1.46),('8998','2014-03-13','12:50:00',1.76),('8998','2014-03-13','12:55:00',1.73),('8998','2014-03-13','13:00:00',1.32),('8998','2014-03-13','13:05:00',1.14),('8998','2014-03-13','13:10:00',1.37),('8998','2014-03-13','13:15:00',1.61),('8998','2014-03-13','13:20:00',1.69),('8998','2014-03-13','13:25:00',1.56),('8998','2014-03-13','13:30:00',1.42),('8998','2014-03-13','13:35:00',1.31),('8998','2014-03-13','13:40:00',1.16),('8998','2014-03-13','13:45:00',1.2),('8998','2014-03-13','13:50:00',1.11),('8998','2014-03-13','13:55:00',1.16),('8998','2014-03-13','14:00:00',1.26),('8998','2014-03-13','14:05:00',1.4),('8998','2014-03-13','14:10:00',1.46),('8998','2014-03-13','14:15:00',1.48),('8998','2014-03-13','14:20:00',1.46),('8998','2014-03-13','14:25:00',1.46),('8998','2014-03-13','14:30:00',1.35),('8998','2014-03-13','14:35:00',1.24),('8998','2014-03-13','14:40:00',1.1),('8998','2014-03-12','07:55:00',1.4),('8998','2014-03-12','08:00:00',1.53),('8998','2014-03-12','08:05:00',1.6),('8998','2014-03-12','08:10:00',1.66),('8998','2014-03-12','08:15:00',1.74),('8998','2014-03-12','08:20:00',1.8),('8998','2014-03-12','08:25:00',1.85),('8998','2014-03-12','08:30:00',1.9),('8998','2014-03-12','08:35:00',1.96),('8998','2014-03-12','08:40:00',2.01),('8998','2014-03-12','08:45:00',2.09),('8998','2014-03-12','08:50:00',2.13),('8998','2014-03-12','08:55:00',2.17),('8998','2014-03-12','09:00:00',2.23),('8998','2014-03-12','09:05:00',2.25),('8998','2014-03-12','09:10:00',2.28),('8998','2014-03-12','09:15:00',2.32),('8998','2014-03-12','09:20:00',2.35),('8998','2014-03-12','09:25:00',2.37),('8998','2014-03-12','09:30:00',2.41),('8998','2014-03-12','09:35:00',2.44),('8998','2014-03-12','09:40:00',2.46),('8998','2014-03-12','09:45:00',2.49),('8998','2014-03-12','09:50:00',2.53),('8998','2014-03-12','09:55:00',2.56),('8998','2014-03-12','10:00:00',2.57),('8998','2014-03-12','10:05:00',2.58),('8998','2014-03-12','10:10:00',2.6),('8998','2014-03-12','10:15:00',2.6),('8998','2014-03-12','10:20:00',2.6),('8998','2014-03-12','10:25:00',2.6),('8998','2014-03-12','10:30:00',2.61),('8998','2014-03-12','10:35:00',2.62),('8998','2014-03-12','10:40:00',2.62),('8998','2014-03-12','10:45:00',2.62),('8998','2014-03-12','10:50:00',2.62),('8998','2014-03-12','10:55:00',2.61),('8998','2014-03-12','11:00:00',2.61),('8998','2014-03-12','11:05:00',2.61),('8998','2014-03-12','11:10:00',2.6),('8998','2014-03-12','11:15:00',2.6),('8998','2014-03-12','11:20:00',2.6),('8998','2014-03-12','11:25:00',2.58),('8998','2014-03-12','11:30:00',2.56),('8998','2014-03-12','11:35:00',2.54),('8998','2014-03-12','11:40:00',2.55),('8998','2014-03-12','11:45:00',2.54),('8998','2014-03-12','11:50:00',2.54),('8998','2014-03-12','11:55:00',2.53),('8998','2014-03-12','12:00:00',2.48),('8998','2014-03-12','12:05:00',2.47),('8998','2014-03-12','12:10:00',2.46),('8998','2014-03-12','12:15:00',2.42),('8998','2014-03-12','12:20:00',2.4),('8998','2014-03-12','12:25:00',2.36),('8998','2014-03-12','12:30:00',2.34),('8998','2014-03-12','12:35:00',2.3),('8998','2014-03-12','12:40:00',2.26),('8998','2014-03-12','12:45:00',2.23),('8998','2014-03-12','12:50:00',2.19),('8998','2014-03-12','12:55:00',2.15),('8998','2014-03-12','13:00:00',2.11),('8998','2014-03-12','13:05:00',2.08),('8998','2014-03-12','13:10:00',2.05),('8998','2014-03-12','13:15:00',1.99),('8998','2014-03-12','13:20:00',1.96),('8998','2014-03-12','13:25:00',1.92),('8998','2014-03-12','13:30:00',1.91),('8998','2014-03-12','13:35:00',1.88),('8998','2014-03-12','13:40:00',1.82),('8998','2014-03-12','13:45:00',1.77),('8998','2014-03-12','13:50:00',1.72),('8998','2014-03-12','13:55:00',1.67),('8998','2014-03-12','14:00:00',1.61),('8998','2014-03-12','14:05:00',1.56),('8998','2014-03-12','14:10:00',1.51),('8998','2014-03-12','14:15:00',1.46),('8998','2014-03-12','14:20:00',1.38),('8998','2014-03-12','14:25:00',1.32),('8998','2014-03-12','14:30:00',1.28),('8998','2014-03-12','14:35:00',1.22),('8998','2014-03-12','14:40:00',1.07),('8998','2014-03-11','07:55:00',1.35),('8998','2014-03-11','08:00:00',1.5),('8998','2014-03-11','08:05:00',1.58),('8998','2014-03-11','08:10:00',1.66),('8998','2014-03-11','08:15:00',1.75),('8998','2014-03-11','08:20:00',1.8),('8998','2014-03-11','08:25:00',1.86),('8998','2014-03-11','08:30:00',1.91),('8998','2014-03-11','08:35:00',1.96),('8998','2014-03-11','08:40:00',2.03),('8998','2014-03-11','08:45:00',2.1),('8998','2014-03-11','08:50:00',2.15),('8998','2014-03-11','08:55:00',2.18),('8998','2014-03-11','09:00:00',2.21),('8998','2014-03-11','09:05:00',2.24),('8998','2014-03-11','09:10:00',2.28),('8998','2014-03-11','09:15:00',2.32),('8998','2014-03-11','09:20:00',2.35),('8998','2014-03-11','09:25:00',2.38),('8998','2014-03-11','09:30:00',2.39),('8998','2014-03-11','09:35:00',2.41),('8998','2014-03-11','09:40:00',2.43),('8998','2014-03-11','09:45:00',2.46),('8998','2014-03-11','09:50:00',2.48),('8998','2014-03-11','09:55:00',2.51),('8998','2014-03-11','10:00:00',2.53),('8998','2014-03-11','10:05:00',2.55),('8998','2014-03-11','10:10:00',2.55),('8998','2014-03-11','10:15:00',2.57),('8998','2014-03-11','10:20:00',2.58),('8998','2014-03-11','10:25:00',2.6),('8998','2014-03-11','10:30:00',2.61),('8998','2014-03-11','10:35:00',2.64),('8998','2014-03-11','10:40:00',2.65),('8998','2014-03-11','10:45:00',2.67),('8998','2014-03-11','10:50:00',2.68),('8998','2014-03-11','10:55:00',2.67),('8998','2014-03-11','11:00:00',2.68),('8998','2014-03-11','11:05:00',2.69),('8998','2014-03-11','11:10:00',2.68),('8998','2014-03-11','11:15:00',2.68),('8998','2014-03-11','11:20:00',2.68),('8998','2014-03-11','11:25:00',2.67),('8998','2014-03-11','11:30:00',2.65),('8998','2014-03-11','11:35:00',2.65),('8998','2014-03-11','11:40:00',2.65),('8998','2014-03-11','11:45:00',2.62),('8998','2014-03-11','11:50:00',2.6),('8998','2014-03-11','11:55:00',2.58),('8998','2014-03-11','12:00:00',2.56),('8998','2014-03-11','12:05:00',2.53),('8998','2014-03-11','12:10:00',2.5),('8998','2014-03-11','12:15:00',2.49),('8998','2014-03-11','12:20:00',2.45),('8998','2014-03-11','12:25:00',2.42),('8998','2014-03-11','12:30:00',2.4),('8998','2014-03-11','12:35:00',2.37),('8998','2014-03-11','12:40:00',2.33),('8998','2014-03-11','12:45:00',2.31),('8998','2014-03-11','12:50:00',2.28),('8998','2014-03-11','12:55:00',2.23),('8998','2014-03-11','13:00:00',2.22),('8998','2014-03-11','13:05:00',2.17),('8998','2014-03-11','13:10:00',2.13),('8998','2014-03-11','13:15:00',2.1),('8998','2014-03-11','13:20:00',2.06),('8998','2014-03-11','13:25:00',2.01),('8998','2014-03-11','13:30:00',1.95),('8998','2014-03-11','13:35:00',1.92),('8998','2014-03-11','13:40:00',1.87),('8998','2014-03-11','13:45:00',1.82),('8998','2014-03-11','13:50:00',1.78),('8998','2014-03-11','13:55:00',1.73),('8998','2014-03-11','14:00:00',1.69),('8998','2014-03-11','14:05:00',1.64),('8998','2014-03-11','14:10:00',1.58),('8998','2014-03-11','14:15:00',1.52),('8998','2014-03-11','14:20:00',1.39),('8998','2014-03-11','14:25:00',1.39),('8998','2014-03-11','14:30:00',1.33),('8998','2014-03-11','14:35:00',1.23),('8998','2014-03-11','14:40:00',1.04),('8998','2014-03-10','13:50:00',1.07),('8998','2014-03-10','13:55:00',1.22),('8998','2014-03-10','14:00:00',1.26),('8998','2014-03-10','14:05:00',1.31),('8998','2014-03-10','14:10:00',1.73),('8998','2014-03-10','14:15:00',1.5),('8998','2014-03-10','14:20:00',1.26),('8998','2014-03-10','14:25:00',1.14),('8998','2014-03-10','15:05:00',1.02),('8998','2014-03-10','15:10:00',1.03),('8998','2014-03-09','13:10:00',1.03),('8998','2014-03-09','13:15:00',1.14),('8998','2014-03-09','13:20:00',1.07),('8998','2014-03-09','14:05:00',1.08),('8998','2014-03-09','14:10:00',1.41),('8998','2014-03-09','14:15:00',1.69),('8998','2014-03-09','14:20:00',1.2),('8998','2014-03-09','14:25:00',1.02),('8998','2014-03-09','14:35:00',1.08),('8998','2014-03-09','14:40:00',1.14),('8998','2014-03-09','14:45:00',1.04),('8998','2014-03-08','08:00:00',1.09),('8998','2014-03-08','08:05:00',1.46),('8998','2014-03-08','08:10:00',1.58),('8998','2014-03-08','08:15:00',1.67),('8998','2014-03-08','08:20:00',1.62),('8998','2014-03-08','08:25:00',1.2),('8998','2014-03-08','08:30:00',1.33),('8998','2014-03-08','08:35:00',1.16),('8998','2014-03-08','08:40:00',1.47),('8998','2014-03-08','08:45:00',1.11),('8998','2014-03-08','08:50:00',1.26),('8998','2014-03-08','08:55:00',1.63),('8998','2014-03-08','09:00:00',1.99),('8998','2014-03-08','09:05:00',1.1),('8998','2014-03-08','09:15:00',1.79),('8998','2014-03-08','09:20:00',2.38),('8998','2014-03-08','09:25:00',2.52),('8998','2014-03-08','09:30:00',1.81),('8998','2014-03-08','09:35:00',2.57),('8998','2014-03-08','09:40:00',2.68),('8998','2014-03-08','09:45:00',2.72),('8998','2014-03-08','09:50:00',2.72),('8998','2014-03-08','09:55:00',2.68),('8998','2014-03-08','10:00:00',2.67),('8998','2014-03-08','10:05:00',2.68),('8998','2014-03-08','10:10:00',2.72),('8998','2014-03-08','10:15:00',2.69),('8998','2014-03-08','10:20:00',2.52),('8998','2014-03-08','10:25:00',2.69),('8998','2014-03-08','10:30:00',2.69),('8998','2014-03-08','10:35:00',2.7),('8998','2014-03-08','10:40:00',2.71),('8998','2014-03-08','10:45:00',2.73),('8998','2014-03-08','10:50:00',2.76),('8998','2014-03-08','10:55:00',2.76),('8998','2014-03-08','11:00:00',2.99),('8998','2014-03-08','11:05:00',3.04),('8998','2014-03-08','11:10:00',3.13),('8998','2014-03-08','11:15:00',2.99),('8998','2014-03-08','11:20:00',3),('8998','2014-03-08','11:25:00',3.01),('8998','2014-03-08','11:30:00',2.28),('8998','2014-03-08','11:35:00',2.35),('8998','2014-03-08','11:40:00',2.38),('8998','2014-03-08','11:45:00',2.32),('8998','2014-03-08','11:50:00',2.06),('8998','2014-03-08','11:55:00',3.04),('8998','2014-03-08','12:00:00',2.96),('8998','2014-03-08','12:05:00',3.01),('8998','2014-03-08','12:10:00',2.91),('8998','2014-03-08','12:15:00',2.85),('8998','2014-03-08','12:20:00',2.82),('8998','2014-03-08','12:25:00',2.75),('8998','2014-03-08','12:30:00',2.76),('8998','2014-03-08','12:35:00',2.8),('8998','2014-03-08','12:40:00',2.64),('8998','2014-03-08','12:45:00',2.55),('8998','2014-03-08','12:50:00',2.57),('8998','2014-03-08','12:55:00',2.58),('8998','2014-03-08','13:00:00',2.6),('8998','2014-03-08','13:05:00',2.59),('8998','2014-03-08','13:10:00',2.51),('8998','2014-03-08','13:15:00',2.29),('8998','2014-03-08','13:20:00',2.09),('8998','2014-03-08','13:25:00',2.22),('8998','2014-03-08','13:30:00',2.15),('8998','2014-03-08','13:35:00',1.49),('8998','2014-03-08','13:45:00',1.57),('8998','2014-03-08','13:50:00',1.96),('8998','2014-03-08','13:55:00',1.88),('8998','2014-03-08','14:00:00',1.84),('8998','2014-03-08','14:05:00',1.73),('8998','2014-03-08','14:10:00',1.67),('8998','2014-03-08','14:15:00',1.56),('8998','2014-03-08','14:20:00',1.32),('8998','2014-03-08','14:40:00',1.09),('8998','2014-03-08','14:45:00',1.22),('8998','2014-03-08','14:50:00',1.11),('8998','2014-03-08','14:55:00',1.02),('8998','2014-03-07','08:00:00',1.09),('8998','2014-03-07','08:05:00',1.47),('8998','2014-03-07','08:10:00',1.58),('8998','2014-03-07','08:15:00',1.66),('8998','2014-03-07','08:20:00',1.73),('8998','2014-03-07','08:25:00',1.78),('8998','2014-03-07','08:30:00',1.84),('8998','2014-03-07','08:35:00',1.89),('8998','2014-03-07','08:40:00',1.94),('8998','2014-03-07','08:45:00',2.02),('8998','2014-03-07','08:50:00',2.08),('8998','2014-03-07','08:55:00',2.13),('8998','2014-03-07','09:00:00',2.18),('8998','2014-03-07','09:05:00',2.21),('8998','2014-03-07','09:10:00',2.26),('8998','2014-03-07','09:15:00',2.29),('8998','2014-03-07','09:20:00',2.33),('8998','2014-03-07','09:25:00',2.36),('8998','2014-03-07','09:30:00',2.39),('8998','2014-03-07','09:35:00',2.41),('8998','2014-03-07','09:40:00',2.43),('8998','2014-03-07','09:45:00',2.46),('8998','2014-03-07','09:50:00',2.49),('8998','2014-03-07','09:55:00',2.51),('8998','2014-03-07','10:00:00',2.53),('8998','2014-03-07','10:05:00',2.55),('8998','2014-03-07','10:10:00',2.55),('8998','2014-03-07','10:15:00',2.57),('8998','2014-03-07','10:20:00',2.6),('8998','2014-03-07','10:25:00',2.61),('8998','2014-03-07','10:30:00',2.63),('8998','2014-03-07','10:35:00',2.66),('8998','2014-03-07','10:40:00',2.65),('8998','2014-03-07','10:45:00',2.65),('8998','2014-03-07','10:50:00',2.66),('8998','2014-03-07','10:55:00',2.64),('8998','2014-03-07','11:00:00',2.65),('8998','2014-03-07','11:05:00',2.65),('8998','2014-03-07','11:10:00',2.65),('8998','2014-03-07','11:15:00',2.67),('8998','2014-03-07','11:20:00',2.73),('8998','2014-03-07','11:25:00',2.78),('8998','2014-03-07','11:30:00',2.68),('8998','2014-03-07','11:35:00',1.77),('8998','2014-03-07','11:50:00',1.27),('8998','2014-03-07','11:55:00',2.9),('8998','2014-03-07','12:00:00',1.15),('8998','2014-03-07','12:20:00',1.02),('8998','2014-03-07','12:25:00',1.08),('8998','2014-03-07','12:30:00',1.31),('8998','2014-03-07','12:35:00',2.14),('8998','2014-03-07','12:40:00',1.28),('8998','2014-03-07','12:45:00',1.2),('8998','2014-03-07','12:50:00',1.26),('8998','2014-03-07','12:55:00',2.02),('8998','2014-03-07','13:00:00',1.11),('8998','2014-03-07','13:05:00',1.08),('8998','2014-03-07','13:30:00',1.31),('8998','2014-03-07','13:35:00',1.01),('8998','2014-03-07','13:40:00',1.54),('8998','2014-03-07','13:45:00',1.58),('8998','2014-03-07','13:50:00',1.1),('8998','2014-04-29','07:40:00',1.13),('8998','2014-04-29','07:45:00',1.27),('8998','2014-04-29','07:50:00',1.35),('8998','2014-04-29','07:55:00',1.32),('8998','2014-04-29','08:00:00',1.3),('8998','2014-04-29','08:05:00',1.3),('8998','2014-04-29','08:10:00',1.43),('8998','2014-04-29','08:15:00',1.55),('8998','2014-04-29','08:20:00',1.43),('8998','2014-04-29','08:25:00',1.57),('8998','2014-04-29','08:30:00',1.81),('8998','2014-04-29','08:35:00',1.8),('8998','2014-04-29','08:40:00',1.64),('8998','2014-04-29','08:45:00',1.56),('8998','2014-04-29','08:50:00',1.69),('8998','2014-04-29','08:55:00',2.14),('8998','2014-04-29','09:00:00',2.21),('8998','2014-04-29','09:05:00',2.34),('8998','2014-04-29','09:10:00',2.47),('8998','2014-04-29','09:15:00',2.63),('8998','2014-04-29','09:20:00',1.82),('8998','2014-04-29','09:25:00',2.09),('8998','2014-04-29','09:30:00',1.47),('8998','2014-04-29','09:35:00',2.56),('8998','2014-04-29','09:40:00',2.18),('8998','2014-04-29','09:45:00',2.88),('8998','2014-04-29','09:50:00',1.69),('8998','2014-04-29','09:55:00',1.93),('8998','2014-04-29','10:00:00',3.09),('8998','2014-04-29','10:05:00',2.9),('8998','2014-04-29','10:10:00',1.88),('8998','2014-04-29','10:15:00',2.39),('8998','2014-04-29','10:20:00',1.5),('8998','2014-04-29','10:25:00',1.32),('8998','2014-04-29','10:30:00',1.19),('8998','2014-04-29','10:35:00',1.66),('8998','2014-04-29','10:40:00',1.66),('8998','2014-04-29','10:45:00',1.28),('8998','2014-04-29','10:55:00',2.83),('8998','2014-04-29','11:00:00',2.01),('8998','2014-04-29','11:05:00',3.09),('8998','2014-04-29','11:10:00',2.05),('8998','2014-04-29','11:15:00',2.09),('8998','2014-04-29','11:20:00',1.22),('8998','2014-04-29','11:25:00',1.84),('8998','2014-04-29','11:30:00',1.52),('8998','2014-04-29','11:35:00',1.46),('8998','2014-04-29','11:40:00',1.44),('8998','2014-04-29','11:45:00',1.56),('8998','2014-04-29','11:50:00',2.38),('8998','2014-04-29','11:55:00',1.64),('8998','2014-04-29','12:00:00',2.36),('8998','2014-04-29','12:05:00',1.11),('8998','2014-04-29','12:15:00',1.22),('8998','2014-04-29','12:20:00',1.63),('8998','2014-04-29','12:25:00',1.04),('8998','2014-04-29','12:45:00',1.39),('8998','2014-04-29','12:50:00',1.18),('8998','2014-04-29','12:55:00',2.6),('8998','2014-04-29','13:00:00',3.27),('8998','2014-04-29','13:05:00',2.7),('8998','2014-04-29','13:10:00',3.43),('8998','2014-04-29','13:15:00',1.54),('8998','2014-04-29','13:20:00',1.23),('8998','2014-04-29','13:25:00',1.56),('8998','2014-04-29','13:30:00',1.48),('8998','2014-04-29','13:35:00',1.2),('8998','2014-04-29','13:40:00',2.29),('8998','2014-04-29','13:45:00',1.96),('8998','2014-04-29','13:50:00',2.9),('8998','2014-04-29','13:55:00',3.55),('8998','2014-04-29','14:00:00',1.47),('8998','2014-04-29','14:05:00',1.29),('8998','2014-04-29','14:10:00',1.13),('8998','2014-04-29','14:15:00',1.27),('8998','2014-04-29','14:20:00',2.06),('8998','2014-04-29','14:25:00',2),('8998','2014-04-29','14:30:00',2.71),('8998','2014-04-29','14:35:00',2.95),('8998','2014-04-29','14:40:00',1.54),('8998','2014-04-29','14:45:00',1.01),('8998','2014-04-29','14:50:00',1.12),('8998','2014-04-29','14:55:00',1.27),('8998','2014-04-29','15:00:00',1.01),('8998','2014-04-29','15:30:00',1.24),('8998','2014-04-29','15:35:00',1.51),('8998','2014-04-29','15:40:00',2.31),('8998','2014-04-29','15:45:00',2.23),('8998','2014-04-29','15:50:00',1.58),('8998','2014-04-29','15:55:00',1.74),('8998','2014-04-29','16:05:00',1.19),('8998','2014-04-29','16:15:00',1.1),('8998','2014-04-29','16:20:00',1),('8998','2014-04-29','16:25:00',1),('8998','2014-04-29','16:30:00',1.33),('8998','2014-04-29','16:40:00',1.17),('8998','2014-04-29','16:45:00',1.26),('8998','2014-04-29','16:50:00',1.33),('8998','2014-04-29','16:55:00',1.13),('8998','2014-04-29','17:05:00',1.18),('8998','2014-03-06','11:45:00',1.12),('8998','2014-03-06','11:50:00',1.08),('8998','2014-03-06','11:55:00',2.53),('8998','2014-03-06','12:00:00',3.15),('8998','2014-03-06','12:05:00',1.9),('8998','2014-03-06','12:10:00',3.05),('8998','2014-03-06','12:15:00',2.83),('8998','2014-03-06','12:20:00',2.84),('8998','2014-03-06','12:25:00',2.74),('8998','2014-03-06','12:30:00',2.73),('8998','2014-03-06','12:35:00',2.57),('8998','2014-03-06','12:40:00',1.94),('8998','2014-03-06','12:45:00',2.11),('8998','2014-03-06','12:50:00',1.19),('8998','2014-03-06','13:15:00',1.01),('8998','2014-03-06','13:20:00',1.13),('8998','2014-03-06','13:25:00',1.28),('8998','2014-03-06','13:30:00',1.19),('8998','2014-03-06','13:35:00',1.48),('8998','2014-03-06','13:40:00',1.73),('8998','2014-03-06','13:45:00',1.31),('8998','2014-03-06','15:00:00',1.09),('8998','2014-03-06','15:05:00',1.21),('8998','2014-03-06','15:10:00',1.16),('8998','2014-03-06','15:15:00',1.12),('8998','2014-03-06','15:20:00',1.08),('8998','2014-03-06','15:25:00',1.04),('8998','2014-03-06','15:30:00',1.07),('8998','2014-03-05','08:10:00',1.08),('8998','2014-03-05','08:15:00',1.7),('8998','2014-03-05','08:20:00',1.24),('8998','2014-03-05','08:35:00',1.11),('8998','2014-03-05','08:40:00',1),('8998','2014-03-05','09:35:00',1),('8998','2014-03-05','09:40:00',1.24),('8998','2014-03-05','09:45:00',1.39),('8998','2014-03-05','09:50:00',1.44),('8998','2014-03-05','09:55:00',1.43),('8998','2014-03-05','10:00:00',1.44),('8998','2014-03-05','10:05:00',1.79),('8998','2014-03-05','10:10:00',2.32),('8998','2014-03-05','10:15:00',2.64),('8998','2014-03-05','10:20:00',2.16),('8998','2014-03-05','10:25:00',1.75),('8998','2014-03-05','10:30:00',1.02),('8998','2014-03-05','10:40:00',1.26),('8998','2014-03-05','10:45:00',1.06),('8998','2014-03-05','10:55:00',1.21),('8998','2014-03-05','11:00:00',1.61),('8998','2014-03-05','11:05:00',2.71),('8998','2014-03-05','11:10:00',1.45),('8998','2014-03-05','11:15:00',1.74),('8998','2014-03-05','11:20:00',1.05),('8998','2014-03-05','11:25:00',1.25),('8998','2014-03-05','11:30:00',1.12),('8998','2014-03-05','11:40:00',1.28),('8998','2014-03-05','11:45:00',2.17),('8998','2014-03-05','11:50:00',1.77),('8998','2014-03-05','11:55:00',1.94),('8998','2014-03-05','12:00:00',1.01),('8998','2014-03-05','12:05:00',2.2),('8998','2014-03-05','12:10:00',3.04),('8998','2014-03-05','12:15:00',3.04),('8998','2014-03-05','12:20:00',1.93),('8998','2014-03-05','12:25:00',2.7),('8998','2014-03-05','12:30:00',2.86),('8998','2014-03-05','12:35:00',1.66),('8998','2014-03-05','12:40:00',1.13),('8998','2014-03-05','13:15:00',1.2),('8998','2014-03-04','07:50:00',1.01),('8998','2014-03-04','07:55:00',1.02),('8998','2014-03-04','08:00:00',1.01),('8998','2014-03-04','08:05:00',1.27),('8998','2014-03-04','08:10:00',1.35),('8998','2014-03-04','08:15:00',1.41),('8998','2014-03-04','08:30:00',2.07),('8998','2014-03-04','08:35:00',2.26),('8998','2014-03-04','08:40:00',2.07),('8998','2014-03-04','08:45:00',1.71),('8998','2014-03-04','09:00:00',1.92),('8998','2014-03-04','09:10:00',1.17),('8998','2014-03-04','09:15:00',2.07),('8998','2014-03-04','09:20:00',2.47),('8998','2014-03-04','09:25:00',2.42),('8998','2014-03-04','09:30:00',2.44),('8998','2014-03-04','09:35:00',2.48),('8998','2014-03-04','09:40:00',2.49),('8998','2014-03-04','09:45:00',2.5),('8998','2014-03-04','09:50:00',2.51),('8998','2014-03-04','09:55:00',2.54),('8998','2014-03-04','10:00:00',2.56),('8998','2014-03-04','10:05:00',2.58),('8998','2014-03-04','10:10:00',2.6),('8998','2014-03-04','10:15:00',2.58),('8998','2014-03-04','10:20:00',2.6),('8998','2014-03-04','10:25:00',2.61),('8998','2014-03-04','10:30:00',2.6),('8998','2014-03-04','10:35:00',2.61),('8998','2014-03-04','10:40:00',2.61),('8998','2014-03-04','10:45:00',2.61),('8998','2014-03-04','10:50:00',2.62),('8998','2014-03-04','10:55:00',2.63),('8998','2014-03-04','11:00:00',2.66),('8998','2014-03-04','11:05:00',2.69),('8998','2014-03-04','11:10:00',2.68),('8998','2014-03-04','11:15:00',2.7),('8998','2014-03-04','11:20:00',2.67),('8998','2014-03-04','11:25:00',2.67),('8998','2014-03-04','11:30:00',2.74),('8998','2014-03-04','11:35:00',2.82),('8998','2014-03-04','11:40:00',2.78),('8998','2014-03-04','11:45:00',2.72),('8998','2014-03-04','11:50:00',2.66),('8998','2014-03-04','11:55:00',2.37),('8998','2014-03-04','12:00:00',2.29),('8998','2014-03-04','12:05:00',1.69),('8998','2014-03-04','12:35:00',1.03),('8998','2014-03-04','12:50:00',1.09),('8998','2014-03-04','12:55:00',1.5),('8998','2014-03-04','13:00:00',1.28),('8998','2014-03-04','13:05:00',1.94),('8998','2014-03-04','13:10:00',2.33),('8998','2014-03-04','13:15:00',1.59),('8998','2014-03-04','13:20:00',1.51),('8998','2014-03-04','13:25:00',1.27),('8998','2014-03-04','13:40:00',1.01),('8998','2014-03-03','09:10:00',1.22),('8998','2014-03-03','09:15:00',1.51),('8998','2014-03-03','09:20:00',2.51),('8998','2014-03-03','09:45:00',1.28),('8998','2014-03-03','09:55:00',1.21),('8998','2014-03-03','10:00:00',1.31),('8998','2014-03-03','10:25:00',2.05),('8998','2014-03-03','10:30:00',2.13),('8998','2014-03-03','10:35:00',2.5),('8998','2014-03-03','10:40:00',3.09),('8998','2014-03-03','10:45:00',3.01),('8998','2014-03-03','10:50:00',1.07),('8998','2014-03-03','10:55:00',1.73),('8998','2014-03-03','11:00:00',2.3),('8998','2014-03-03','11:05:00',1.54),('8998','2014-03-03','11:10:00',2.35),('8998','2014-03-03','11:15:00',3.41),('8998','2014-03-03','11:20:00',2.62),('8998','2014-03-03','11:45:00',1.1),('8998','2014-03-03','11:50:00',3.25),('8998','2014-03-03','11:55:00',2.88),('8998','2014-03-03','12:00:00',2.69),('8998','2014-03-03','12:05:00',2.61),('8998','2014-03-03','12:10:00',2.55),('8998','2014-03-03','12:15:00',2.49),('8998','2014-03-03','12:20:00',2.46),('8998','2014-03-03','12:25:00',2.45),('8998','2014-03-03','12:30:00',2.41),('8998','2014-03-03','12:35:00',2.35),('8998','2014-03-03','12:40:00',2.32),('8998','2014-03-03','12:45:00',1.97),('8998','2014-03-03','12:50:00',2.13),('8998','2014-03-03','12:55:00',1.62),('8998','2014-03-03','13:00:00',1.84),('8998','2014-03-03','13:05:00',1.87),('8998','2014-03-03','13:10:00',2.41),('8998','2014-03-03','13:15:00',2.17),('8998','2014-03-03','14:10:00',1.63),('8998','2014-03-03','14:15:00',1.32),('8998','2014-03-03','14:25:00',1.55),('8998','2014-03-03','14:30:00',1.31),('8998','2014-03-03','14:35:00',1.14),('8998','2014-03-03','14:40:00',1.05),('8998','2014-03-02','08:10:00',1.22),('8998','2014-03-02','08:15:00',1.7),('8998','2014-03-02','08:20:00',1.75),('8998','2014-03-02','08:25:00',1.79),('8998','2014-03-02','08:30:00',1.86),('8998','2014-03-02','08:35:00',1.89),('8998','2014-03-02','08:40:00',1.97),('8998','2014-03-02','08:45:00',2),('8998','2014-03-02','08:50:00',1.96),('8998','2014-03-02','08:55:00',2.14),('8998','2014-03-02','09:00:00',2.14),('8998','2014-03-02','09:05:00',2.13),('8998','2014-03-02','09:10:00',2.06),('8998','2014-03-02','09:15:00',2.06),('8998','2014-03-02','09:20:00',2.22),('8998','2014-03-02','09:25:00',2.32),('8998','2014-03-02','09:30:00',2.25),('8998','2014-03-02','09:35:00',1.99),('8998','2014-03-02','09:40:00',1.91),('8998','2014-03-02','09:45:00',1.82),('8998','2014-03-02','09:50:00',1.94),('8998','2014-03-02','09:55:00',2.16),('8998','2014-03-02','10:00:00',2.39),('8998','2014-03-02','10:05:00',2.48),('8998','2014-03-02','10:10:00',2.48),('8998','2014-03-02','10:15:00',2.48),('8998','2014-03-02','10:20:00',2.5),('8998','2014-03-02','10:25:00',2.51),('8998','2014-03-02','10:30:00',2.51),('8998','2014-03-02','10:35:00',2.52),('8998','2014-03-02','10:40:00',2.53),('8998','2014-03-02','10:45:00',2.55),('8998','2014-03-02','10:50:00',2.51),('8998','2014-03-02','10:55:00',2.52),('8998','2014-03-02','11:00:00',2.53),('8998','2014-03-02','11:05:00',2.52),('8998','2014-03-02','11:10:00',2.51),('8998','2014-03-02','11:15:00',2.5),('8998','2014-03-02','11:20:00',2.5),('8998','2014-03-02','11:25:00',2.51),('8998','2014-03-02','11:30:00',2.51),('8998','2014-03-02','11:35:00',2.57),('8998','2014-03-02','11:40:00',2.44),('8998','2014-03-02','11:45:00',2.52),('8998','2014-03-02','11:50:00',2.53),('8998','2014-03-02','11:55:00',2.51),('8998','2014-03-02','12:00:00',2.49),('8998','2014-03-02','12:05:00',2.47),('8998','2014-03-02','12:10:00',2.45),('8998','2014-03-02','12:15:00',2.42),('8998','2014-03-02','12:20:00',2.41),('8998','2014-03-02','12:25:00',2.38),('8998','2014-03-02','12:30:00',2.34),('8998','2014-03-02','12:35:00',2.31),('8998','2014-03-02','12:40:00',2.29),('8998','2014-03-02','12:45:00',2.24),('8998','2014-03-02','12:50:00',2.22),('8998','2014-03-02','12:55:00',2.18),('8998','2014-03-02','13:00:00',2.16),('8998','2014-03-02','13:05:00',2.11),('8998','2014-03-02','13:10:00',2.09),('8998','2014-03-02','13:15:00',2.04),('8998','2014-03-02','13:20:00',2),('8998','2014-03-02','13:25:00',1.96),('8998','2014-03-02','13:30:00',1.94),('8998','2014-03-02','13:35:00',1.89),('8998','2014-03-02','13:40:00',1.83),('8998','2014-03-02','13:45:00',1.78),('8998','2014-03-02','13:50:00',1.73),('8998','2014-03-02','13:55:00',1.69),('8998','2014-03-02','14:00:00',1.6),('8998','2014-03-02','14:05:00',1.44),('8998','2014-03-02','14:10:00',1.48),('8998','2014-03-02','14:15:00',1.48),('8998','2014-03-02','14:20:00',1.39),('8998','2014-03-02','14:25:00',1.19),('8998','2014-03-02','14:30:00',1.16),('8998','2014-03-02','14:35:00',1.12),('8998','2014-03-02','14:40:00',1.01),('8998','2014-03-01','08:10:00',1.18),('8998','2014-03-01','08:15:00',1.76),('8998','2014-03-01','08:20:00',2.08),('8998','2014-03-01','08:25:00',1.9),('8998','2014-03-01','08:30:00',1.78),('8998','2014-03-01','08:35:00',1.86),('8998','2014-03-01','08:40:00',1.92),('8998','2014-03-01','08:45:00',2),('8998','2014-03-01','08:50:00',2.06),('8998','2014-03-01','08:55:00',2.1),('8998','2014-03-01','09:00:00',2.13),('8998','2014-03-01','09:05:00',2.18),('8998','2014-03-01','09:10:00',2.26),('8998','2014-03-01','09:15:00',2.31),('8998','2014-03-01','09:20:00',1.76),('8998','2014-03-01','09:25:00',2.01),('8998','2014-03-01','09:30:00',2.42),('8998','2014-03-01','09:35:00',2.43),('8998','2014-03-01','09:40:00',1.9),('8998','2014-03-01','09:45:00',1.17),('8998','2014-03-01','10:05:00',1.13),('8998','2014-03-01','10:10:00',1.15),('8998','2014-03-01','10:30:00',1.06),('8998','2014-03-01','10:35:00',1.25),('8998','2014-03-01','10:40:00',2.46),('8998','2014-03-01','10:45:00',1.27),('8998','2014-03-01','11:00:00',1.2),('8998','2014-03-01','11:05:00',3.06),('8998','2014-03-01','11:10:00',1.34),('8998','2014-03-01','11:25:00',1.4),('8998','2014-03-01','11:30:00',1.33),('8998','2014-03-01','11:35:00',2.07),('8998','2014-03-01','11:40:00',2.64),('8998','2014-03-01','11:45:00',2.35),('8998','2014-03-01','11:50:00',3.22),('8998','2014-03-01','11:55:00',3.06),('8998','2014-03-01','12:00:00',2.07),('8998','2014-03-01','12:05:00',1.34),('8998','2014-03-01','12:10:00',1.28),('8998','2014-03-01','12:15:00',1.98),('8998','2014-03-01','12:20:00',1.51),('8998','2014-03-01','12:25:00',1.21),('8998','2014-03-01','13:00:00',1.05),('8998','2014-03-01','13:05:00',1.13),('8998','2014-03-01','13:10:00',1.16),('8998','2014-03-01','13:15:00',1.14),('8998','2014-03-01','13:20:00',1.1),('8998','2014-02-27','08:00:00',1),('8998','2014-02-27','08:20:00',1.88),('8998','2014-02-27','08:25:00',1.57),('8998','2014-02-27','08:35:00',1.41),('8998','2014-02-27','09:30:00',1.52),('8998','2014-02-27','09:35:00',1.08),('8998','2014-02-27','09:40:00',1.73),('8998','2014-02-27','09:45:00',2.37),('8998','2014-02-27','09:50:00',2.79),('8998','2014-02-27','09:55:00',2.28),('8998','2014-02-27','10:10:00',1.14),('8998','2014-02-27','10:20:00',1.29),('8998','2014-02-27','10:25:00',2.57),('8998','2014-02-27','10:30:00',2.8),('8998','2014-02-27','10:35:00',1.76),('8998','2014-02-27','12:05:00',1.32),('8998','2014-02-27','12:10:00',1.62),('8998','2014-02-27','12:30:00',1.57),('8998','2014-02-27','12:35:00',1.9),('8998','2014-02-27','12:40:00',2.38),('8998','2014-02-27','12:50:00',1.74),('8998','2014-02-27','12:55:00',1.77),('8998','2014-02-27','13:00:00',1.53),('8998','2014-02-27','13:05:00',1.17),('8998','2014-02-27','13:10:00',1.15),('8998','2014-02-27','13:50:00',1.72),('8998','2014-02-27','13:55:00',2.06),('8998','2014-02-27','14:00:00',1.05),('8998','2014-02-27','14:25:00',1.01),('8998','2014-02-27','14:30:00',1.04),('8998','2014-02-26','11:00:00',1.1),('8998','2014-02-26','11:05:00',1.22),('8998','2014-02-26','11:10:00',1.13),('8998','2014-02-26','11:15:00',1.09),('8998','2014-02-26','11:20:00',1.03),('8998','2014-02-26','11:25:00',1.05),('8998','2014-02-26','11:30:00',1.31),('8998','2014-02-26','11:35:00',1.32),('8998','2014-02-26','11:40:00',1.12),('8998','2014-02-26','13:35:00',1.09),('8998','2014-02-26','13:40:00',1.1),('8998','2014-02-26','13:45:00',1.08),('8998','2014-02-26','13:50:00',1.05),('8998','2014-02-26','13:55:00',1.18),('8998','2014-02-26','14:00:00',1.18),('8998','2014-02-26','14:05:00',1.05),('8998','2014-02-25','08:15:00',1.32),('8998','2014-02-25','08:20:00',1.52),('8998','2014-02-25','08:25:00',1.59),('8998','2014-02-25','08:30:00',1.61),('8998','2014-02-25','08:35:00',1.71),('8998','2014-02-25','08:40:00',1.77),('8998','2014-02-25','08:45:00',1.91),('8998','2014-02-25','08:50:00',1.72),('8998','2014-02-25','08:55:00',1.7),('8998','2014-02-25','09:00:00',1.93),('8998','2014-02-25','09:05:00',1.92),('8998','2014-02-25','09:10:00',1.92),('8998','2014-02-25','09:15:00',2.04),('8998','2014-02-25','09:20:00',2.05),('8998','2014-02-25','09:25:00',2.1),('8998','2014-02-25','09:30:00',1.64),('8998','2014-02-25','09:35:00',1.93),('8998','2014-02-25','09:40:00',1.45),('8998','2014-02-25','09:45:00',1.64),('8998','2014-02-25','09:50:00',1.46),('8998','2014-02-25','09:55:00',1.24),('8998','2014-02-25','10:00:00',1.1),('8998','2014-02-25','12:05:00',1.12),('8998','2014-02-25','12:10:00',1.11),('8998','2014-02-25','12:30:00',1.04),('8998','2014-02-25','12:35:00',1.57),('8998','2014-02-25','12:40:00',1.11),('8998','2014-02-25','12:45:00',2.02),('8998','2014-02-25','12:50:00',2.1),('8998','2014-02-25','12:55:00',2.2),('8998','2014-02-25','13:00:00',2.1),('8998','2014-02-25','13:05:00',1.64),('8998','2014-02-25','13:10:00',1.78),('8998','2014-02-25','13:15:00',1.78),('8998','2014-02-25','13:20:00',1.61),('8998','2014-02-25','13:25:00',1.35),('8998','2014-02-25','13:30:00',1.77),('8998','2014-02-25','13:35:00',1.48),('8998','2014-02-25','13:45:00',1.4),('8998','2014-02-25','14:00:00',1.64),('8998','2014-02-25','14:05:00',1.49),('8998','2014-02-25','14:20:00',1.3),('8998','2014-02-25','14:25:00',1.53),('8998','2014-04-28','10:05:00',1.48),('8998','2014-04-28','10:10:00',2.25),('8998','2014-04-28','10:15:00',3.2),('8998','2014-04-28','10:20:00',3.3),('8998','2014-04-28','10:25:00',3.28),('8998','2014-04-28','10:30:00',3.33),('8998','2014-04-28','10:35:00',3.22),('8998','2014-04-28','10:40:00',3.21),('8998','2014-04-28','10:45:00',3.21),('8998','2014-04-28','10:50:00',3.22),('8998','2014-04-28','10:55:00',3),('8998','2014-04-28','11:00:00',3.14),('8998','2014-04-28','11:05:00',3.09),('8998','2014-04-28','11:10:00',3.01),('8998','2014-04-28','11:15:00',2.99),('8998','2014-04-28','11:20:00',2.87),('8998','2014-04-28','11:25:00',3.31),('8998','2014-04-28','11:30:00',3.36),('8998','2014-04-28','11:35:00',2.89),('8998','2014-04-28','11:40:00',2.64),('8998','2014-04-28','11:45:00',1.82),('8998','2014-04-28','11:50:00',1.92),('8998','2014-04-28','12:05:00',2.17),('8998','2014-04-28','12:10:00',1.74),('8998','2014-04-28','12:15:00',1.61),('8998','2014-04-28','12:20:00',1.22),('8998','2014-04-28','12:25:00',3.22),('8998','2014-04-28','12:30:00',2.15),('8998','2014-04-28','12:35:00',1.28),('8998','2014-04-28','12:40:00',1.57),('8998','2014-04-28','12:45:00',1.94),('8998','2014-04-28','12:50:00',1.95),('8998','2014-04-28','12:55:00',2.2),('8998','2014-04-28','13:00:00',1.35),('8998','2014-04-28','13:05:00',1.25),('8998','2014-04-28','13:10:00',1.21),('8998','2014-04-28','13:15:00',2),('8998','2014-04-28','13:20:00',1.73),('8998','2014-04-28','13:25:00',2.85),('8998','2014-04-28','13:30:00',1.31),('8998','2014-04-28','13:35:00',1.89),('8998','2014-04-28','13:40:00',1.04),('8998','2014-02-24','08:20:00',1.43),('8998','2014-02-24','08:25:00',1.54),('8998','2014-02-24','08:30:00',1.6),('8998','2014-02-24','08:35:00',1.64),('8998','2014-02-24','08:40:00',1.69),('8998','2014-02-24','08:45:00',1.76),('8998','2014-02-24','08:50:00',1.82),('8998','2014-02-24','08:55:00',1.86),('8998','2014-02-24','09:00:00',1.91),('8998','2014-02-24','09:05:00',1.96),('8998','2014-02-24','09:10:00',2),('8998','2014-02-24','09:15:00',2.03),('8998','2014-02-24','09:20:00',2.07),('8998','2014-02-24','09:25:00',2.1),('8998','2014-02-24','09:30:00',2.13),('8998','2014-02-24','09:35:00',2.15),('8998','2014-02-24','09:40:00',2.17),('8998','2014-02-24','09:45:00',2.19),('8998','2014-02-24','09:50:00',2.21),('8998','2014-02-24','09:55:00',2.26),('8998','2014-02-24','10:00:00',2.27),('8998','2014-02-24','10:05:00',2.29),('8998','2014-02-24','10:10:00',2.3),('8998','2014-02-24','10:15:00',2.32),('8998','2014-02-24','10:20:00',2.35),('8998','2014-02-24','10:25:00',2.35),('8998','2014-02-24','10:30:00',2.36),('8998','2014-02-24','10:35:00',2.38),('8998','2014-02-24','10:40:00',2.37),('8998','2014-02-24','10:45:00',2.37),('8998','2014-02-24','10:50:00',2.36),('8998','2014-02-24','10:55:00',2.36),('8998','2014-02-24','11:00:00',2.35),('8998','2014-02-24','11:05:00',2.35),('8998','2014-02-24','11:10:00',2.36),('8998','2014-02-24','11:15:00',2.35),('8998','2014-02-24','11:20:00',2.33),('8998','2014-02-24','11:25:00',2.32),('8998','2014-02-24','11:30:00',2.31),('8998','2014-02-24','11:35:00',2.3),('8998','2014-02-24','11:40:00',2.29),('8998','2014-02-24','11:45:00',2.27),('8998','2014-02-24','11:50:00',2.26),('8998','2014-02-24','11:55:00',2.26),('8998','2014-02-24','12:00:00',2.25),('8998','2014-02-24','12:05:00',2.2),('8998','2014-02-24','12:10:00',2.2),('8998','2014-02-24','12:15:00',2.21),('8998','2014-02-24','12:20:00',2.1),('8998','2014-02-24','12:25:00',2.08),('8998','2014-02-24','12:30:00',2.12),('8998','2014-02-24','12:35:00',2.09),('8998','2014-02-24','12:40:00',2.09),('8998','2014-02-24','12:45:00',2.1),('8998','2014-02-24','12:50:00',2.07),('8998','2014-02-24','12:55:00',1.99),('8998','2014-02-24','13:00:00',1.94),('8998','2014-02-24','13:05:00',1.92),('8998','2014-02-24','13:10:00',1.89),('8998','2014-02-24','13:15:00',1.85),('8998','2014-02-24','13:20:00',1.41),('8998','2014-02-24','14:30:00',1.2),('8998','2014-02-24','14:40:00',1.18),('8998','2014-02-24','14:45:00',1.08),('8998','2014-02-23','08:20:00',1.61),('8998','2014-02-23','08:25:00',1.77),('8998','2014-02-23','08:30:00',1.85),('8998','2014-02-23','08:35:00',1.93),('8998','2014-02-23','08:40:00',1.88),('8998','2014-02-23','08:45:00',2.01),('8998','2014-02-23','08:50:00',1.92),('8998','2014-02-23','08:55:00',1.91),('8998','2014-02-23','09:00:00',1.93),('8998','2014-02-23','09:05:00',1.96),('8998','2014-02-23','09:10:00',2),('8998','2014-02-23','09:15:00',2.03),('8998','2014-02-23','09:20:00',2.07),('8998','2014-02-23','09:25:00',2.12),('8998','2014-02-23','09:30:00',2.14),('8998','2014-02-23','09:35:00',2.17),('8998','2014-02-23','09:40:00',2.2),('8998','2014-02-23','09:45:00',2.22),('8998','2014-02-23','09:50:00',2.26),('8998','2014-02-23','09:55:00',2.26),('8998','2014-02-23','10:00:00',2.29),('8998','2014-02-23','10:05:00',2.32),('8998','2014-02-23','10:10:00',2.35),('8998','2014-02-23','10:15:00',2.37),('8998','2014-02-23','10:20:00',2.39),('8998','2014-02-23','10:25:00',2.4),('8998','2014-02-23','10:30:00',2.41),('8998','2014-02-23','10:35:00',2.42),('8998','2014-02-23','10:40:00',2.42),('8998','2014-02-23','10:45:00',2.43),('8998','2014-02-23','10:50:00',2.44),('8998','2014-02-23','10:55:00',2.44),('8998','2014-02-23','11:00:00',2.42),('8998','2014-02-23','11:05:00',2.44),('8998','2014-02-23','11:10:00',2.44),('8998','2014-02-23','11:15:00',2.42),('8998','2014-02-23','11:20:00',2.45),('8998','2014-02-23','11:25:00',2.58),('8998','2014-02-23','11:30:00',2.62),('8998','2014-02-23','11:35:00',2.13),('8998','2014-02-23','11:40:00',1.68),('8998','2014-02-23','11:45:00',2.33),('8998','2014-02-23','11:50:00',2.28),('8998','2014-02-23','11:55:00',2.4),('8998','2014-02-23','12:00:00',1.76),('8998','2014-02-23','12:05:00',1.9),('8998','2014-02-23','12:15:00',1.56),('8998','2014-02-23','12:20:00',2.11),('8998','2014-02-23','12:25:00',2.44),('8998','2014-02-23','12:30:00',2.51),('8998','2014-02-23','12:35:00',2.01),('8998','2014-02-23','12:40:00',2.47),('8998','2014-02-23','12:45:00',2.2),('8998','2014-02-23','12:50:00',2.19),('8998','2014-02-23','12:55:00',2.17),('8998','2014-02-23','13:00:00',2.24),('8998','2014-02-23','13:05:00',2.1),('8998','2014-02-23','13:10:00',2.56),('8998','2014-02-23','13:15:00',2.36),('8998','2014-02-22','08:20:00',1.06),('8998','2014-02-22','08:25:00',1.51),('8998','2014-02-22','08:30:00',1.58),('8998','2014-02-22','08:35:00',1.64),('8998','2014-02-22','08:40:00',1.69),('8998','2014-02-22','08:45:00',1.75),('8998','2014-02-22','08:50:00',1.81),('8998','2014-02-22','08:55:00',1.84),('8998','2014-02-22','09:00:00',1.88),('8998','2014-02-22','09:05:00',1.93),('8998','2014-02-22','09:10:00',1.97),('8998','2014-02-22','09:15:00',2.01),('8998','2014-02-22','09:20:00',2.07),('8998','2014-02-22','09:25:00',2.06),('8998','2014-02-22','09:30:00',1.93),('8998','2014-02-22','09:35:00',2.15),('8998','2014-02-22','09:40:00',2.17),('8998','2014-02-22','09:45:00',2.18),('8998','2014-02-22','09:50:00',2.17),('8998','2014-02-22','09:55:00',2.2),('8998','2014-02-22','10:00:00',2.22),('8998','2014-02-22','10:05:00',2.24),('8998','2014-02-22','10:10:00',2.2),('8998','2014-02-22','10:15:00',2.26),('8998','2014-02-22','10:20:00',2.29),('8998','2014-02-22','10:25:00',2.31),('8998','2014-02-22','10:30:00',2.34),('8998','2014-02-22','10:35:00',2.34),('8998','2014-02-22','10:40:00',2.35),('8998','2014-02-22','10:45:00',2.35),('8998','2014-02-22','10:50:00',2.33),('8998','2014-02-22','10:55:00',1.77),('8998','2014-02-22','11:00:00',2.43),('8998','2014-02-22','11:05:00',2.42),('8998','2014-02-22','11:10:00',2.41),('8998','2014-02-22','11:15:00',2.18),('8998','2014-02-22','11:20:00',2.39),('8998','2014-02-22','11:25:00',2.38),('8998','2014-02-22','11:30:00',2.44),('8998','2014-02-22','11:35:00',2.43),('8998','2014-02-22','11:40:00',2.49),('8998','2014-02-22','11:45:00',2.42),('8998','2014-02-22','11:50:00',2.4),('8998','2014-02-22','11:55:00',2.05),('8998','2014-02-22','12:00:00',2.45),('8998','2014-02-22','12:05:00',2.45),('8998','2014-02-22','12:10:00',1.67),('8998','2014-02-22','12:15:00',2.41),('8998','2014-02-22','12:20:00',2.26),('8998','2014-02-22','12:25:00',1.28),('8998','2014-02-22','12:30:00',1.61),('8998','2014-02-22','12:35:00',2.39),('8998','2014-02-22','12:40:00',1.56),('8998','2014-02-22','12:45:00',1.44),('8998','2014-02-22','12:50:00',1.04),('8998','2014-02-22','12:55:00',1.5),('8998','2014-02-22','13:00:00',1.7),('8998','2014-02-22','13:05:00',2.06),('8998','2014-02-22','13:10:00',2),('8998','2014-02-22','13:15:00',1.95),('8998','2014-02-22','13:20:00',1.91),('8998','2014-02-22','13:25:00',1.86),('8998','2014-02-22','13:30:00',1.78),('8998','2014-02-22','13:40:00',1.64),('8998','2014-02-22','13:45:00',1.56),('8998','2014-02-22','14:00:00',1.4),('8998','2014-02-22','14:05:00',1.38),('8998','2014-02-22','14:10:00',1.5),('8998','2014-02-22','14:15:00',1.2),('8998','2014-02-22','14:20:00',1.18),('8998','2014-02-22','14:25:00',1.51),('8998','2014-02-22','14:30:00',1.27),('8998','2014-02-21','10:05:00',1.59),('8998','2014-02-21','10:10:00',1.47),('8998','2014-02-21','10:15:00',1.5),('8998','2014-02-21','10:25:00',1.25),('8998','2014-02-21','10:30:00',1.85),('8998','2014-02-21','10:35:00',1.32),('8998','2014-02-21','10:40:00',1.38),('8998','2014-02-21','10:45:00',2.37),('8998','2014-02-21','10:50:00',2.58),('8998','2014-02-21','12:10:00',1.04),('8998','2014-02-21','12:15:00',1.35),('8998','2014-02-21','12:20:00',1.04),('8998','2014-02-21','12:25:00',1.3),('8998','2014-02-21','12:45:00',2.19),('8998','2014-02-21','12:50:00',1.85),('8998','2014-02-21','13:05:00',1.22),('8998','2014-02-21','13:10:00',2.55),('8998','2014-02-21','13:15:00',1.62),('8998','2014-02-21','13:20:00',1.03),('8998','2014-02-21','13:35:00',1.04),('8998','2014-02-21','13:40:00',1),('8998','2014-02-21','13:45:00',1.07),('8998','2014-02-21','13:55:00',1.54),('8998','2014-02-21','14:00:00',1.68),('8998','2014-02-21','14:05:00',1.55),('8998','2014-02-21','14:10:00',1.45),('8998','2014-02-21','14:15:00',1.2),('8998','2014-02-21','14:20:00',1.11),('8998','2014-02-21','14:25:00',1.01),('8998','2014-02-21','14:30:00',1.11),('8998','2014-02-20','10:05:00',1.07),('8998','2014-02-20','10:10:00',1.05),('8998','2014-02-20','10:15:00',1.08),('8998','2014-02-20','10:20:00',1.47),('8998','2014-02-20','10:25:00',1.84),('8998','2014-02-20','10:30:00',2.14),('8998','2014-02-20','10:35:00',1.75),('8998','2014-02-20','10:40:00',1.42),('8998','2014-02-20','10:45:00',1.37),('8998','2014-02-20','10:50:00',1.12),('8998','2014-02-20','10:55:00',1.58),('8998','2014-02-20','11:00:00',1.45),('8998','2014-02-20','11:05:00',1.21),('8998','2014-02-20','11:10:00',1.04),('8998','2014-02-20','11:15:00',1.17),('8998','2014-02-20','11:20:00',1.17),('8998','2014-02-20','11:25:00',1.33),('8998','2014-02-20','11:30:00',2.85),('8998','2014-02-20','11:35:00',2.75),('8998','2014-02-20','11:40:00',1.9),('8998','2014-02-20','11:45:00',2.56),('8998','2014-02-20','11:50:00',1.61),('8998','2014-02-20','11:55:00',1.68),('8998','2014-02-20','12:00:00',2.95),('8998','2014-02-20','12:05:00',2.82),('8998','2014-02-20','12:10:00',2.62),('8998','2014-02-20','12:15:00',1.27),('8998','2014-02-20','12:30:00',1.01),('8998','2014-02-18','09:45:00',1.14),('8998','2014-02-18','09:50:00',1.06),('8998','2014-02-18','10:15:00',1.04),('8998','2014-02-18','10:30:00',1.03),('8998','2014-02-18','10:35:00',1.06),('8998','2014-02-18','10:40:00',1.23),('8998','2014-02-18','10:45:00',1.38),('8998','2014-02-18','10:50:00',1.27),('8998','2014-02-18','10:55:00',1.12),('8998','2014-02-18','11:05:00',1.03),('8998','2014-02-18','11:10:00',1.19),('8998','2014-02-18','11:15:00',1.17),('8998','2014-02-18','11:20:00',1.26),('8998','2014-02-18','11:25:00',1.21),('8998','2014-02-18','11:30:00',1.12),('8998','2014-02-18','11:35:00',1.06),('8998','2014-02-18','11:40:00',1.02),('8998','2014-02-18','12:05:00',1.09),('8998','2014-02-18','12:10:00',1.09),('8998','2014-02-18','12:15:00',1.03),('8998','2014-02-18','12:30:00',1.1),('8998','2014-02-18','13:35:00',1.1),('8998','2014-02-18','13:40:00',1.08),('8998','2014-02-18','13:45:00',1.12),('8998','2014-02-18','13:50:00',1.22),('8998','2014-02-18','13:55:00',1.1),('8998','2014-02-18','14:00:00',1.01),('8998','2014-02-18','14:05:00',1.09),('8998','2014-02-18','14:20:00',1.2),('8998','2014-02-17','08:25:00',1.04),('8998','2014-02-17','08:30:00',1.41),('8998','2014-02-17','08:35:00',1.48),('8998','2014-02-17','08:40:00',1.53),('8998','2014-02-17','08:45:00',1.6),('8998','2014-02-17','08:50:00',1.6),('8998','2014-02-17','08:55:00',1.7),('8998','2014-02-17','09:00:00',1.74),('8998','2014-02-17','09:05:00',1.76),('8998','2014-02-17','09:10:00',1.81),('8998','2014-02-17','09:15:00',1.85),('8998','2014-02-17','09:20:00',1.89),('8998','2014-02-17','09:25:00',1.92),('8998','2014-02-17','09:30:00',1.97),('8998','2014-02-17','09:35:00',1.99),('8998','2014-02-17','09:40:00',2.01),('8998','2014-02-17','09:45:00',2.03),('8998','2014-02-17','09:50:00',2.07),('8998','2014-02-17','09:55:00',2.1),('8998','2014-02-17','10:00:00',2.11),('8998','2014-02-17','10:05:00',2.12),('8998','2014-02-17','10:10:00',2.14),('8998','2014-02-17','10:15:00',2.15),('8998','2014-02-17','10:20:00',2.16),('8998','2014-02-17','10:25:00',2.16),('8998','2014-02-17','10:30:00',2.19),('8998','2014-02-17','10:35:00',2.19),('8998','2014-02-17','10:40:00',2.19),('8998','2014-02-17','10:45:00',2.2),('8998','2014-02-17','10:50:00',2.2),('8998','2014-02-17','10:55:00',2.21),('8998','2014-02-17','11:00:00',2.22),('8998','2014-02-17','11:05:00',1.91),('8998','2014-02-17','11:10:00',1.82),('8998','2014-02-17','11:15:00',1.76),('8998','2014-02-17','11:20:00',1.91),('8998','2014-02-17','11:25:00',2.17),('8998','2014-02-17','11:30:00',1.94),('8998','2014-02-17','11:35:00',1.79),('8998','2014-02-17','11:40:00',1.44),('8998','2014-02-17','11:45:00',1.37),('8998','2014-02-17','11:50:00',1.2),('8998','2014-02-17','11:55:00',1.04),('8998','2014-02-17','12:00:00',1.02),('8998','2014-02-17','12:05:00',1.03),('8998','2014-02-17','12:10:00',1.15),('8998','2014-02-17','12:15:00',1.26),('8998','2014-02-17','12:20:00',1.22),('8998','2014-02-17','12:25:00',1.4),('8998','2014-02-17','12:30:00',1.54),('8998','2014-02-17','12:35:00',1.22),('8998','2014-02-17','12:40:00',1.09),('8998','2014-02-17','12:45:00',1.06),('8998','2014-02-17','12:50:00',1.09),('8998','2014-02-17','12:55:00',1.21),('8998','2014-02-17','13:15:00',1.16),('8998','2014-02-17','13:20:00',1.28),('8998','2014-02-17','13:25:00',1.5),('8998','2014-02-17','13:30:00',1.15),('8998','2014-02-17','13:40:00',1.08),('8998','2014-02-17','13:45:00',1.28),('8998','2014-02-17','13:50:00',1.02),('8998','2014-02-17','14:00:00',1.08),('8998','2014-02-17','14:05:00',1.38),('8998','2014-02-16','08:30:00',1.2),('8998','2014-02-16','08:35:00',1.29),('8998','2014-02-16','08:40:00',1.33),('8998','2014-02-16','08:45:00',1.41),('8998','2014-02-16','08:50:00',1.45),('8998','2014-02-16','08:55:00',1.49),('8998','2014-02-16','09:00:00',1.52),('8998','2014-02-16','09:05:00',1.57),('8998','2014-02-16','09:10:00',1.64),('8998','2014-02-16','09:15:00',1.68),('8998','2014-02-16','09:20:00',1.72),('8998','2014-02-16','09:25:00',1.77),('8998','2014-02-16','09:30:00',1.81),('8998','2014-02-16','09:35:00',1.84),('8998','2014-02-16','09:40:00',1.87),('8998','2014-02-16','09:45:00',1.9),('8998','2014-02-16','09:50:00',1.9),('8998','2014-02-16','09:55:00',1.93),('8998','2014-02-16','10:00:00',1.96),('8998','2014-02-16','10:05:00',1.98),('8998','2014-02-16','10:10:00',1.99),('8998','2014-02-16','10:15:00',1.99),('8998','2014-02-16','10:20:00',1.98),('8998','2014-02-16','10:25:00',1.99),('8998','2014-02-16','10:30:00',2.01),('8998','2014-02-16','10:35:00',2),('8998','2014-02-16','10:40:00',2),('8998','2014-02-16','10:45:00',2),('8998','2014-02-16','10:50:00',1.99),('8998','2014-02-16','10:55:00',1.99),('8998','2014-02-16','11:00:00',1.99),('8998','2014-02-16','11:05:00',1.98),('8998','2014-02-16','11:10:00',1.98),('8998','2014-02-16','11:15:00',2),('8998','2014-02-16','11:20:00',2.01),('8998','2014-02-16','11:25:00',2.04),('8998','2014-02-16','11:30:00',2.06),('8998','2014-02-16','11:35:00',2.08),('8998','2014-02-16','11:40:00',2.09),('8998','2014-02-16','11:45:00',2.08),('8998','2014-02-16','11:50:00',2.05),('8998','2014-02-16','11:55:00',2.03),('8998','2014-02-16','12:00:00',2.03),('8998','2014-02-16','12:05:00',2.02),('8998','2014-02-16','12:10:00',2),('8998','2014-02-16','12:15:00',1.97),('8998','2014-02-16','12:20:00',1.95),('8998','2014-02-16','12:25:00',1.94),('8998','2014-02-16','12:30:00',1.91),('8998','2014-02-16','12:35:00',1.89),('8998','2014-02-16','12:40:00',1.86),('8998','2014-02-16','12:45:00',1.83),('8998','2014-02-16','12:50:00',1.8),('8998','2014-02-16','12:55:00',1.76),('8998','2014-02-16','13:00:00',1.73),('8998','2014-02-16','13:05:00',1.69),('8998','2014-02-16','13:10:00',1.65),('8998','2014-02-16','13:15:00',1.61),('8998','2014-02-16','13:20:00',1.58),('8998','2014-02-16','13:25:00',1.55),('8998','2014-02-16','13:30:00',1.52),('8998','2014-02-16','13:35:00',1.48),('8998','2014-02-16','13:40:00',1.44),('8998','2014-02-16','13:45:00',1.37),('8998','2014-02-16','13:50:00',1.32),('8998','2014-02-16','13:55:00',1.27),('8998','2014-02-16','14:00:00',1.2),('8998','2014-02-16','14:05:00',1.15),('8998','2014-02-16','14:10:00',1.06),('8998','2014-02-15','08:30:00',1.36),('8998','2014-02-15','08:35:00',1.52),('8998','2014-02-15','08:40:00',1.47),('8998','2014-02-15','08:45:00',1.66),('8998','2014-02-15','08:50:00',1.54),('8998','2014-02-15','08:55:00',1.75),('8998','2014-02-15','09:00:00',1.83),('8998','2014-02-15','09:05:00',1.86),('8998','2014-02-15','09:10:00',1.77),('8998','2014-02-15','09:15:00',1.48),('8998','2014-02-15','09:20:00',1.83),('8998','2014-02-15','09:25:00',1.83),('8998','2014-02-15','09:30:00',1.88),('8998','2014-02-15','09:35:00',1.6),('8998','2014-02-15','09:40:00',1.93),('8998','2014-02-15','09:45:00',2.03),('8998','2014-02-15','09:50:00',2.06),('8998','2014-02-15','09:55:00',1.98),('8998','2014-02-15','10:00:00',1.91),('8998','2014-02-15','10:05:00',2.13),('8998','2014-02-15','10:10:00',2.16),('8998','2014-02-15','10:15:00',2.16),('8998','2014-02-15','10:20:00',2.2),('8998','2014-02-15','10:25:00',2.18),('8998','2014-02-15','10:30:00',2.22),('8998','2014-02-15','10:35:00',2.23),('8998','2014-02-15','10:40:00',2.28),('8998','2014-02-15','10:45:00',2.27),('8998','2014-02-15','10:50:00',2.07),('8998','2014-02-15','10:55:00',1.91),('8998','2014-02-15','11:00:00',2.22),('8998','2014-02-15','11:05:00',2.24),('8998','2014-02-15','11:10:00',2.15),('8998','2014-02-15','11:15:00',2.18),('8998','2014-02-15','11:20:00',2.17),('8998','2014-02-15','11:25:00',2.01),('8998','2014-02-15','11:30:00',2.05),('8998','2014-02-15','11:35:00',2.17),('8998','2014-02-15','11:40:00',2.14),('8998','2014-02-15','11:45:00',1.89),('8998','2014-02-15','11:50:00',2.11),('8998','2014-02-15','11:55:00',1.86),('8998','2014-02-15','12:00:00',2.12),('8998','2014-02-15','12:05:00',2.07),('8998','2014-02-15','12:10:00',2.06),('8998','2014-02-15','12:15:00',2.03),('8998','2014-02-15','12:20:00',2.02),('8998','2014-02-15','12:25:00',1.94),('8998','2014-02-15','12:30:00',1.98),('8998','2014-02-15','12:35:00',1.93),('8998','2014-02-15','12:40:00',1.91),('8998','2014-02-15','12:45:00',1.86),('8998','2014-02-15','12:50:00',1.84),('8998','2014-02-15','12:55:00',1.81),('8998','2014-02-15','13:00:00',1.77),('8998','2014-02-15','13:05:00',1.73),('8998','2014-02-15','13:10:00',1.67),('8998','2014-02-15','13:15:00',1.7),('8998','2014-02-15','13:20:00',1.65),('8998','2014-02-15','13:25:00',1.59),('8998','2014-02-15','13:30:00',1.55),('8998','2014-02-15','13:35:00',1.51),('8998','2014-02-15','13:40:00',1.46),('8998','2014-02-15','13:45:00',1.43),('8998','2014-02-15','13:50:00',1.31),('8998','2014-02-15','13:55:00',1.26),('8998','2014-02-15','14:00:00',1.21),('8998','2014-02-15','14:05:00',1.14),('8998','2014-02-15','14:10:00',1.06),('8998','2014-02-15','14:15:00',1.03),('8998','2014-04-27','08:15:00',1.86),('8998','2014-04-27','08:20:00',1.87),('8998','2014-04-27','08:25:00',1.53),('8998','2014-04-27','08:30:00',1.13),('8998','2014-04-27','08:35:00',1.07),('8998','2014-04-27','08:45:00',1.09),('8998','2014-04-27','08:50:00',1.26),('8998','2014-04-27','08:55:00',1.19),('8998','2014-04-27','09:00:00',1.06),('8998','2014-04-27','09:10:00',1.34),('8998','2014-04-27','09:15:00',2.08),('8998','2014-04-27','09:20:00',2.32),('8998','2014-04-27','09:25:00',1.46),('8998','2014-04-27','09:30:00',2.49),('8998','2014-04-27','09:35:00',1.58),('8998','2014-04-27','09:40:00',1.54),('8998','2014-04-27','09:45:00',1.85),('8998','2014-04-27','09:50:00',2.96),('8998','2014-04-27','09:55:00',1.39),('8998','2014-04-27','10:00:00',1.06),('8998','2014-04-27','10:05:00',1.48),('8998','2014-04-27','10:10:00',1.72),('8998','2014-04-27','10:15:00',1.71),('8998','2014-04-27','10:20:00',1.6),('8998','2014-04-27','10:25:00',1.23),('8998','2014-04-27','10:50:00',1.37),('8998','2014-04-27','10:55:00',1.44),('8998','2014-04-27','11:00:00',1.26),('8998','2014-04-27','11:05:00',1.67),('8998','2014-04-27','11:10:00',1.88),('8998','2014-04-27','11:15:00',1.7),('8998','2014-04-27','11:20:00',1.82),('8998','2014-04-27','11:25:00',1.27),('8998','2014-04-27','11:30:00',1.27),('8998','2014-04-27','11:35:00',1.3),('8998','2014-04-27','11:40:00',1.1),('8998','2014-04-27','11:45:00',1.18),('8998','2014-04-27','11:50:00',1.26),('8998','2014-04-27','11:55:00',1.32),('8998','2014-04-27','12:00:00',1.26),('8998','2014-04-27','12:10:00',1.21),('8998','2014-04-27','12:15:00',1.99),('8998','2014-04-27','12:20:00',2.13),('8998','2014-04-27','12:25:00',2),('8998','2014-04-27','12:30:00',1.86),('8998','2014-04-27','12:35:00',1.72),('8998','2014-04-27','12:40:00',1.54),('8998','2014-04-27','12:45:00',1.33),('8998','2014-04-27','12:50:00',1.55),('8998','2014-04-27','12:55:00',1.58),('8998','2014-04-27','13:00:00',1.63),('8998','2014-04-27','13:05:00',1.85),('8998','2014-04-27','13:10:00',2.48),('8998','2014-04-27','13:15:00',1.72),('8998','2014-04-27','13:20:00',1.53),('8998','2014-04-27','13:25:00',1.83),('8998','2014-04-27','13:30:00',3.1),('8998','2014-04-27','13:35:00',2.24),('8998','2014-04-27','13:40:00',2.92),('8998','2014-04-27','13:45:00',1.38),('8998','2014-04-27','13:50:00',3.1),('8998','2014-04-27','13:55:00',2.6),('8998','2014-04-27','14:00:00',2.13),('8998','2014-04-27','14:05:00',1.36),('8998','2014-04-27','14:10:00',3.08),('8998','2014-04-27','14:15:00',2.66),('8998','2014-04-27','14:20:00',2.19),('8998','2014-04-27','14:25:00',1.93),('8998','2014-04-27','14:30:00',2.17),('8998','2014-04-27','14:35:00',2.6),('8998','2014-04-27','14:40:00',1.92),('8998','2014-04-27','14:45:00',1.66),('8998','2014-04-27','14:50:00',1.33),('8998','2014-04-27','14:55:00',1.73),('8998','2014-04-27','15:00:00',1.49),('8998','2014-04-27','15:05:00',1.85),('8998','2014-04-27','15:10:00',1.72),('8998','2014-04-27','15:15:00',1.72),('8998','2014-04-27','15:20:00',1.84),('8998','2014-04-27','15:25:00',1.32),('8998','2014-04-27','15:30:00',1),('8998','2014-04-27','15:35:00',1.15),('8998','2014-04-27','15:40:00',1.65),('8998','2014-04-27','15:50:00',1.94),('8998','2014-04-27','16:00:00',1.9),('8998','2014-04-27','16:05:00',1.89),('8998','2014-04-27','16:10:00',1.58),('8998','2014-04-27','16:20:00',1.47),('8998','2014-04-27','16:25:00',1.04),('8998','2014-04-27','16:30:00',1.32),('8998','2014-04-27','16:35:00',1.01),('8998','2014-02-14','08:30:00',1.05),('8998','2014-02-14','08:35:00',1.35),('8998','2014-02-14','08:40:00',1.42),('8998','2014-02-14','08:45:00',1.48),('8998','2014-02-14','08:50:00',1.54),('8998','2014-02-14','08:55:00',1.59),('8998','2014-02-14','09:00:00',1.64),('8998','2014-02-14','09:05:00',1.67),('8998','2014-02-14','09:10:00',1.72),('8998','2014-02-14','09:15:00',1.74),('8998','2014-02-14','09:20:00',1.79),('8998','2014-02-14','09:25:00',1.84),('8998','2014-02-14','09:30:00',1.88),('8998','2014-02-14','09:35:00',1.91),('8998','2014-02-14','09:40:00',1.95),('8998','2014-02-14','09:45:00',1.98),('8998','2014-02-14','09:50:00',1.98),('8998','2014-02-14','09:55:00',2.01),('8998','2014-02-14','10:00:00',2.04),('8998','2014-02-14','10:05:00',2.05),('8998','2014-02-14','10:10:00',2.08),('8998','2014-02-14','10:15:00',2.08),('8998','2014-02-14','10:20:00',2.09),('8998','2014-02-14','10:25:00',2.1),('8998','2014-02-14','10:30:00',2.08),('8998','2014-02-14','10:35:00',2.08),('8998','2014-02-14','10:40:00',2.1),('8998','2014-02-14','10:45:00',2.11),('8998','2014-02-14','10:50:00',2.07),('8998','2014-02-14','10:55:00',2.12),('8998','2014-02-14','11:00:00',2.07),('8998','2014-02-14','11:05:00',2.2),('8998','2014-02-14','11:10:00',1.97),('8998','2014-02-14','11:15:00',2.24),('8998','2014-02-14','11:20:00',1.53),('8998','2014-02-14','11:35:00',1.62),('8998','2014-02-14','11:40:00',1.51),('8998','2014-02-14','11:45:00',2.36),('8998','2014-02-14','11:50:00',2.24),('8998','2014-02-14','11:55:00',2.31),('8998','2014-02-14','12:00:00',1.74),('8998','2014-02-14','12:05:00',1.49),('8998','2014-02-14','12:10:00',1.06),('8998','2014-02-14','12:15:00',1.84),('8998','2014-02-14','12:20:00',2.51),('8998','2014-02-14','12:25:00',2.24),('8998','2014-02-14','12:30:00',1.13),('8998','2014-02-14','12:35:00',2),('8998','2014-02-14','12:45:00',1.55),('8998','2014-02-14','12:50:00',2.23),('8998','2014-02-14','12:55:00',2.16),('8998','2014-02-14','13:00:00',1.87),('8998','2014-02-14','13:05:00',2.06),('8998','2014-02-14','13:10:00',2.04),('8998','2014-02-14','13:15:00',1.94),('8998','2014-02-14','13:20:00',1.65),('8998','2014-02-14','13:25:00',1.62),('8998','2014-02-14','13:30:00',1.42),('8998','2014-02-14','13:35:00',1.56),('8998','2014-02-14','13:40:00',1.5),('8998','2014-02-14','13:45:00',1.39),('8998','2014-02-14','13:50:00',1.27),('8998','2014-02-14','13:55:00',1.28),('8998','2014-02-14','14:00:00',1.19),('8998','2014-02-14','14:05:00',1.12),('8998','2014-02-14','14:10:00',1.04),('8998','2014-02-13','08:40:00',1.05),('8998','2014-02-13','08:50:00',1.54),('8998','2014-02-13','08:55:00',1.6),('8998','2014-02-13','09:00:00',1.63),('8998','2014-02-13','09:05:00',1.73),('8998','2014-02-13','09:10:00',1.52),('8998','2014-02-13','09:25:00',1.68),('8998','2014-02-13','09:30:00',1.73),('8998','2014-02-13','09:50:00',1.96),('8998','2014-02-13','09:55:00',1.41),('8998','2014-02-13','10:00:00',1.74),('8998','2014-02-13','10:05:00',2.22),('8998','2014-02-13','10:10:00',1.95),('8998','2014-02-13','10:15:00',1.77),('8998','2014-02-13','10:20:00',2.22),('8998','2014-02-13','10:25:00',1.46),('8998','2014-02-13','10:30:00',2.25),('8998','2014-02-13','10:35:00',2.17),('8998','2014-02-13','10:40:00',2.03),('8998','2014-02-13','10:45:00',2.29),('8998','2014-02-13','10:50:00',2.25),('8998','2014-02-13','10:55:00',2.26),('8998','2014-02-13','11:00:00',2.25),('8998','2014-02-13','11:05:00',2.25),('8998','2014-02-13','11:10:00',2.25),('8998','2014-02-13','11:15:00',2.24),('8998','2014-02-13','11:20:00',2.25),('8998','2014-02-13','11:25:00',2.26),('8998','2014-02-13','11:30:00',2.26),('8998','2014-02-13','11:35:00',2.26),('8998','2014-02-13','11:40:00',2.28),('8998','2014-02-13','11:45:00',2.11),('8998','2014-02-13','11:50:00',2.01),('8998','2014-02-13','11:55:00',2.19),('8998','2014-02-13','12:00:00',2.17),('8998','2014-02-13','12:05:00',2.16),('8998','2014-02-13','12:10:00',1.99),('8998','2014-02-13','12:15:00',2.1),('8998','2014-02-13','12:20:00',2.08),('8998','2014-02-13','12:25:00',2.04),('8998','2014-02-13','12:30:00',2.01),('8998','2014-02-13','12:35:00',2),('8998','2014-02-13','12:40:00',1.97),('8998','2014-02-13','12:45:00',1.93),('8998','2014-02-13','12:50:00',1.89),('8998','2014-02-13','12:55:00',1.86),('8998','2014-02-13','13:00:00',1.83),('8998','2014-02-13','13:05:00',1.78),('8998','2014-02-13','13:10:00',1.76),('8998','2014-02-13','13:15:00',1.72),('8998','2014-02-13','13:20:00',1.67),('8998','2014-02-13','13:25:00',1.62),('8998','2014-02-13','13:30:00',1.59),('8998','2014-02-13','13:35:00',1.53),('8998','2014-02-13','13:40:00',1.5),('8998','2014-02-13','13:45:00',1.4),('8998','2014-02-13','13:50:00',1.33),('8998','2014-02-13','13:55:00',1.25),('8998','2014-02-13','14:00:00',1.19),('8998','2014-02-13','14:05:00',1.13),('8998','2014-02-13','14:10:00',1.03),('8998','2014-02-12','08:35:00',1.24),('8998','2014-02-12','08:40:00',1.42),('8998','2014-02-12','08:45:00',1.53),('8998','2014-02-12','08:50:00',1.61),('8998','2014-02-12','08:55:00',1.67),('8998','2014-02-12','09:00:00',1.72),('8998','2014-02-12','09:05:00',1.76),('8998','2014-02-12','09:10:00',1.8),('8998','2014-02-12','09:15:00',1.84),('8998','2014-02-12','09:20:00',1.85),('8998','2014-02-12','09:25:00',1.89),('8998','2014-02-12','09:30:00',1.92),('8998','2014-02-12','09:35:00',1.95),('8998','2014-02-12','09:40:00',1.97),('8998','2014-02-12','09:45:00',1.99),('8998','2014-02-12','09:50:00',2),('8998','2014-02-12','09:55:00',2.04),('8998','2014-02-12','10:00:00',2.07),('8998','2014-02-12','10:05:00',2.08),('8998','2014-02-12','10:10:00',2.09),('8998','2014-02-12','10:15:00',2.1),('8998','2014-02-12','10:20:00',2.11),('8998','2014-02-12','10:25:00',2.11),('8998','2014-02-12','10:30:00',2.13),('8998','2014-02-12','10:35:00',2.14),('8998','2014-02-12','10:40:00',2.15),('8998','2014-02-12','10:45:00',2.13),('8998','2014-02-12','10:50:00',2.16),('8998','2014-02-12','10:55:00',2.13),('8998','2014-02-12','11:00:00',2.15),('8998','2014-02-12','11:05:00',2.14),('8998','2014-02-12','11:10:00',1.74),('8998','2014-02-12','11:15:00',2.21),('8998','2014-02-12','11:20:00',2.21),('8998','2014-02-12','11:25:00',2.3),('8998','2014-02-12','11:30:00',1.3),('8998','2014-02-12','11:35:00',1.66),('8998','2014-02-12','11:40:00',1.77),('8998','2014-02-12','11:45:00',1.85),('8998','2014-02-12','11:50:00',1.78),('8998','2014-02-12','12:00:00',1.13),('8998','2014-02-12','12:10:00',1.01),('8998','2014-02-12','12:30:00',2.29),('8998','2014-02-12','12:35:00',2.41),('8998','2014-02-12','12:40:00',2.36),('8998','2014-02-12','12:45:00',1.03),('8998','2014-02-12','12:50:00',1.5),('8998','2014-02-12','12:55:00',1.99),('8998','2014-02-12','13:00:00',1.99),('8998','2014-02-12','13:05:00',1.89),('8998','2014-02-12','13:10:00',1.83),('8998','2014-02-12','13:15:00',1.76),('8998','2014-02-12','13:20:00',1.68),('8998','2014-02-12','13:25:00',1.65),('8998','2014-02-12','13:30:00',1.62),('8998','2014-02-12','13:35:00',1.56),('8998','2014-02-12','13:40:00',1.52),('8998','2014-02-12','13:45:00',1.44),('8998','2014-02-12','13:50:00',1.36),('8998','2014-02-12','13:55:00',1.3),('8998','2014-02-12','14:00:00',1.2),('8998','2014-02-12','14:05:00',1.12),('8998','2014-02-12','14:10:00',1.03),('8998','2014-02-11','08:45:00',1.43),('8998','2014-02-11','08:50:00',1.58),('8998','2014-02-11','08:55:00',1.67),('8998','2014-02-11','09:00:00',1.17),('8998','2014-02-11','09:10:00',1.04),('8998','2014-02-11','09:15:00',1.89),('8998','2014-02-11','09:20:00',1.95),('8998','2014-02-11','09:25:00',1.56),('8998','2014-02-11','09:40:00',1.14),('8998','2014-02-11','09:45:00',1.86),('8998','2014-02-11','09:50:00',1.23),('8998','2014-02-11','09:55:00',1.15),('8998','2014-02-11','10:05:00',1.31),('8998','2014-02-11','10:30:00',1.03),('8998','2014-02-11','10:35:00',1.18),('8998','2014-02-11','10:45:00',1.25),('8998','2014-02-11','10:50:00',1.03),('8998','2014-02-11','10:55:00',1.06),('8998','2014-02-11','11:00:00',1.01),('8998','2014-02-11','11:05:00',1.71),('8998','2014-02-11','11:10:00',1.18),('8998','2014-02-11','11:15:00',1.13),('8998','2014-02-11','11:20:00',1.24),('8998','2014-02-11','11:25:00',1.19),('8998','2014-02-11','11:30:00',1.42),('8998','2014-02-11','11:35:00',1.56),('8998','2014-02-11','12:45:00',1.02),('8998','2014-02-11','12:50:00',1.14),('8998','2014-02-11','12:55:00',1.18),('8998','2014-02-11','13:00:00',1.22),('8998','2014-02-11','13:05:00',1.01),('8998','2014-02-11','13:10:00',1.23),('8998','2014-02-11','13:30:00',1.36),('8998','2014-02-11','13:35:00',1.68),('8998','2014-02-11','13:40:00',2.09),('8998','2014-02-11','13:45:00',1.46),('8998','2014-02-11','13:50:00',1.44),('8998','2014-02-11','13:55:00',1.2),('8998','2014-02-11','14:00:00',1.5),('8998','2014-02-11','14:05:00',1.42),('8998','2014-02-11','14:10:00',1.19),('8998','2014-02-11','14:15:00',1.15),('8998','2014-02-11','14:20:00',1.04),('8998','2014-02-10','09:25:00',1.01),('8998','2014-02-10','09:55:00',1.02),('8998','2014-02-10','10:10:00',1.05),('8998','2014-02-10','10:15:00',1.25),('8998','2014-02-10','10:20:00',1.44),('8998','2014-02-10','10:25:00',1.51),('8998','2014-02-10','10:30:00',1.59),('8998','2014-02-10','10:35:00',1.8),('8998','2014-02-10','10:40:00',1.83),('8998','2014-02-10','10:45:00',1.61),('8998','2014-02-10','10:50:00',1.71),('8998','2014-02-10','10:55:00',1.45),('8998','2014-02-10','11:00:00',1.56),('8998','2014-02-10','11:05:00',1.48),('8998','2014-02-10','11:10:00',1.66),('8998','2014-02-10','11:15:00',1.4),('8998','2014-02-10','11:20:00',1.3),('8998','2014-02-10','11:25:00',1.7),('8998','2014-02-10','11:30:00',1.67),('8998','2014-02-10','11:35:00',1.13),('8998','2014-02-10','11:45:00',1.18),('8998','2014-02-10','11:50:00',1.47),('8998','2014-02-10','11:55:00',1),('8998','2014-02-10','12:05:00',1.11),('8998','2014-02-10','12:10:00',1.24),('8998','2014-02-10','12:15:00',1.07),('8998','2014-02-10','12:20:00',1.13),('8998','2014-02-10','12:25:00',1.51),('8998','2014-02-10','12:30:00',1.4),('8998','2014-02-10','12:35:00',1.25),('8998','2014-02-10','12:45:00',1.13),('8998','2014-02-10','12:55:00',1.1),('8998','2014-02-10','13:00:00',1.16),('8998','2014-02-10','13:05:00',1.34),('8998','2014-02-10','13:10:00',1.59),('8998','2014-02-10','13:15:00',1.48),('8998','2014-02-10','13:20:00',1.73),('8998','2014-02-10','13:25:00',1.57),('8998','2014-02-10','13:30:00',1.39),('8998','2014-02-10','13:35:00',1.33),('8998','2014-02-10','13:40:00',1.51),('8998','2014-02-10','13:45:00',1.23),('8998','2014-02-10','14:00:00',1.05),('8998','2014-02-10','14:05:00',1.13),('8998','2014-02-10','14:15:00',1.1),('8998','2014-02-08','12:30:00',1.04),('8998','2014-02-08','13:00:00',1.8),('8998','2014-02-08','13:05:00',1.28),('8998','2014-02-08','13:10:00',1.19),('8998','2014-02-08','13:15:00',1.12),('8998','2014-02-08','13:45:00',1.42),('8998','2014-02-08','14:05:00',1.02),('8998','2014-02-07','09:50:00',1.13),('8998','2014-02-07','09:55:00',1.25),('8998','2014-02-07','10:15:00',1.15),('8998','2014-02-07','10:20:00',1.28),('8998','2014-02-07','10:30:00',1.19),('8998','2014-02-07','10:35:00',1.64),('8998','2014-02-07','10:40:00',1.22),('8998','2014-02-07','10:45:00',1.22),('8998','2014-02-07','10:50:00',1.33),('8998','2014-02-07','10:55:00',1.87),('8998','2014-02-07','11:00:00',1.62),('8998','2014-02-07','11:05:00',2.29),('8998','2014-02-07','11:10:00',1.86),('8998','2014-02-07','11:15:00',1.5),('8998','2014-02-07','11:20:00',2.14),('8998','2014-02-07','11:30:00',1.1),('8998','2014-02-07','11:35:00',2.4),('8998','2014-02-07','11:40:00',1.7),('8998','2014-02-07','11:55:00',2.49),('8998','2014-02-07','12:00:00',1.17),('8998','2014-02-07','12:15:00',2.24),('8998','2014-02-07','12:25:00',1.06),('8998','2014-02-07','12:30:00',2.34),('8998','2014-02-07','12:35:00',1.94),('8998','2014-02-07','12:40:00',1.33),('8998','2014-02-07','12:45:00',1.78),('8998','2014-02-07','12:50:00',2.25),('8998','2014-02-07','12:55:00',2.09),('8998','2014-02-07','13:00:00',1.39),('8998','2014-02-07','13:15:00',2.04),('8998','2014-02-07','13:20:00',1.96),('8998','2014-02-07','13:25:00',1.53),('8998','2014-02-07','13:30:00',1.4),('8998','2014-02-07','13:35:00',1.58),('8998','2014-02-07','13:40:00',1.31),('8998','2014-02-07','13:45:00',1.66),('8998','2014-02-07','13:50:00',1.43),('8998','2014-02-07','13:55:00',1.29),('8998','2014-02-07','14:00:00',1.21),('8998','2014-02-07','14:05:00',1.09),('8998','2014-02-07','14:10:00',1.03),('8998','2014-02-06','08:40:00',1.02),('8998','2014-02-06','08:45:00',1.47),('8998','2014-02-06','08:50:00',1.51),('8998','2014-02-06','08:55:00',1.56),('8998','2014-02-06','09:00:00',1.61),('8998','2014-02-06','09:05:00',1.64),('8998','2014-02-06','09:10:00',1.68),('8998','2014-02-06','09:15:00',1.72),('8998','2014-02-06','09:20:00',1.75),('8998','2014-02-06','09:25:00',1.78),('8998','2014-02-06','09:30:00',1.8),('8998','2014-02-06','09:35:00',1.83),('8998','2014-02-06','09:40:00',1.85),('8998','2014-02-06','09:45:00',1.87),('8998','2014-02-06','09:50:00',1.89),('8998','2014-02-06','09:55:00',1.9),('8998','2014-02-06','10:00:00',1.91),('8998','2014-02-06','10:05:00',1.93),('8998','2014-02-06','10:10:00',1.95),('8998','2014-02-06','10:15:00',1.96),('8998','2014-02-06','10:20:00',1.98),('8998','2014-02-06','10:25:00',2.01),('8998','2014-02-06','10:30:00',2.05),('8998','2014-02-06','10:35:00',2.04),('8998','2014-02-06','10:40:00',2.11),('8998','2014-02-06','10:45:00',2.17),('8998','2014-02-06','10:50:00',2.12),('8998','2014-02-06','10:55:00',1.54),('8998','2014-02-06','11:00:00',2.02),('8998','2014-02-06','11:05:00',1.28),('8998','2014-02-06','11:10:00',1.89),('8998','2014-02-06','11:15:00',2.26),('8998','2014-02-06','11:20:00',2.26),('8998','2014-02-06','11:25:00',2.37),('8998','2014-02-06','11:30:00',2.23),('8998','2014-02-06','11:35:00',2.19),('8998','2014-02-06','11:40:00',2.05),('8998','2014-02-06','11:45:00',2.2),('8998','2014-02-06','11:50:00',1.97),('8998','2014-02-06','11:55:00',2.38),('8998','2014-02-06','12:00:00',2.36),('8998','2014-02-06','12:05:00',2.22),('8998','2014-02-06','12:10:00',2.05),('8998','2014-02-06','12:15:00',2.22),('8998','2014-02-06','12:25:00',2.14),('8998','2014-02-06','12:30:00',1.09),('8998','2014-02-06','12:55:00',1.78),('8998','2014-02-06','13:00:00',1.51),('8998','2014-02-06','13:05:00',1.06),('8998','2014-02-06','13:10:00',1.99),('8998','2014-02-06','13:15:00',1.21),('8998','2014-02-06','13:20:00',1.38),('8998','2014-02-06','13:25:00',1.12),('8998','2014-02-06','13:30:00',1.24),('8998','2014-02-06','13:35:00',1.09),('8998','2014-02-06','13:45:00',1.44),('8998','2014-02-06','13:50:00',1.25),('8998','2014-02-06','13:55:00',1.04),('8998','2014-02-06','14:00:00',1.12),('8998','2014-02-06','14:05:00',1.16),('8998','2014-02-06','14:10:00',1.11),('8998','2014-02-06','14:20:00',1.05),('8998','2014-02-05','08:40:00',1.07),('8998','2014-02-05','08:45:00',1.29),('8998','2014-02-05','08:50:00',1.49),('8998','2014-02-05','08:55:00',1.48),('8998','2014-02-05','09:00:00',1.91),('8998','2014-02-05','09:05:00',2),('8998','2014-02-05','09:10:00',1.36),('8998','2014-02-05','09:15:00',1.16),('8998','2014-02-05','09:30:00',1.74),('8998','2014-02-05','09:35:00',1.92),('8998','2014-02-05','09:40:00',1.93),('8998','2014-02-05','09:45:00',1.95),('8998','2014-02-05','09:50:00',1.96),('8998','2014-02-05','09:55:00',1.96),('8998','2014-02-05','10:00:00',1.97),('8998','2014-02-05','10:05:00',2),('8998','2014-02-05','10:10:00',2.03),('8998','2014-02-05','10:15:00',2.04),('8998','2014-02-05','10:20:00',2.06),('8998','2014-02-05','10:25:00',2.07),('8998','2014-02-05','10:30:00',2.02),('8998','2014-02-05','10:35:00',2.03),('8998','2014-02-05','10:40:00',1.23),('8998','2014-02-05','10:45:00',1.08),('8998','2014-02-05','10:50:00',1.37),('8998','2014-02-05','10:55:00',1.45),('8998','2014-02-05','11:00:00',2.22),('8998','2014-02-05','11:10:00',1.75),('8998','2014-02-05','11:15:00',1.39),('8998','2014-02-05','11:25:00',1.94),('8998','2014-02-05','11:30:00',1.9),('8998','2014-02-05','11:35:00',2.14),('8998','2014-02-05','11:40:00',2.13),('8998','2014-02-05','11:45:00',2.11),('8998','2014-02-05','11:50:00',2.1),('8998','2014-02-05','11:55:00',2.11),('8998','2014-02-05','12:00:00',2.12),('8998','2014-02-05','12:05:00',2.18),('8998','2014-02-05','12:10:00',2.17),('8998','2014-02-05','12:15:00',2.06),('8998','2014-02-05','12:20:00',2.01),('8998','2014-02-05','12:25:00',1.99),('8998','2014-02-05','12:30:00',1.98),('8998','2014-02-05','12:35:00',1.99),('8998','2014-02-05','12:40:00',1.85),('8998','2014-02-05','12:45:00',1.64),('8998','2014-02-05','12:50:00',1.81),('8998','2014-02-05','12:55:00',1.78),('8998','2014-02-05','13:00:00',1.76),('8998','2014-02-05','13:05:00',1.76),('8998','2014-02-05','13:10:00',1.78),('8998','2014-02-05','13:15:00',1.78),('8998','2014-02-05','13:20:00',1.8),('8998','2014-02-05','13:25:00',1.8),('8998','2014-02-05','13:30:00',1.19),('8998','2014-02-05','13:35:00',1.55),('8998','2014-02-05','13:40:00',1.48),('8998','2014-02-05','13:45:00',1.19),('8998','2014-02-05','13:50:00',1.22),('8998','2014-02-05','14:00:00',1.15),('8998','2014-02-05','14:05:00',1.13),('8998','2014-04-26','11:10:00',1.11),('8998','2014-04-26','11:15:00',1.05),('8998','2014-04-26','11:40:00',1.1),('8998','2014-04-26','11:45:00',2.24),('8998','2014-04-26','11:50:00',2.14),('8998','2014-04-26','11:55:00',1.73),('8998','2014-04-26','12:00:00',1.81),('8998','2014-04-26','12:05:00',1.93),('8998','2014-04-26','12:10:00',2.2),('8998','2014-04-26','12:15:00',2.18),('8998','2014-04-26','12:20:00',1.98),('8998','2014-04-26','12:25:00',2.04),('8998','2014-04-26','12:30:00',1.86),('8998','2014-04-26','12:35:00',1.86),('8998','2014-04-26','12:40:00',1.69),('8998','2014-04-26','12:45:00',1.81),('8998','2014-04-26','12:50:00',1.65),('8998','2014-04-26','12:55:00',1.17),('8998','2014-04-26','13:00:00',1.34),('8998','2014-04-26','13:05:00',1.46),('8998','2014-04-26','13:10:00',1.25),('8998','2014-04-26','13:15:00',1.21),('8998','2014-04-26','13:20:00',1.61),('8998','2014-04-26','13:25:00',1.59),('8998','2014-04-26','13:30:00',1.41),('8998','2014-04-26','13:35:00',1.24),('8998','2014-04-26','13:40:00',1.14),('8998','2014-04-26','13:45:00',1.08),('8998','2014-04-26','14:00:00',1.12),('8998','2014-04-26','14:05:00',1.59),('8998','2014-04-26','14:10:00',1.23),('8998','2014-04-26','14:15:00',1.02),('8998','2014-04-26','14:20:00',1.17),('8998','2014-04-26','14:25:00',1.45),('8998','2014-04-26','14:30:00',1.57),('8998','2014-04-26','14:35:00',1.53),('8998','2014-04-26','14:40:00',1.58),('8998','2014-04-26','14:45:00',1.44),('8998','2014-04-26','14:50:00',1.34),('8998','2014-04-26','14:55:00',1.39),('8998','2014-04-26','15:00:00',1.44),('8998','2014-04-26','15:05:00',1.88),('8998','2014-04-26','15:10:00',2.4),('8998','2014-04-26','15:15:00',1.91),('8998','2014-04-26','15:20:00',1.32),('8998','2014-02-04','10:15:00',1.07),('8998','2014-02-04','10:20:00',1.95),('8998','2014-02-04','10:25:00',2.29),('8998','2014-02-04','11:15:00',2.14),('8998','2014-02-04','11:20:00',2.23),('8998','2014-02-04','11:25:00',2.28),('8998','2014-02-04','13:25:00',1.02),('8998','2014-02-04','13:30:00',1.02),('8998','2014-02-04','13:35:00',1.19),('8998','2014-02-04','13:40:00',1.21),('8998','2014-02-04','13:45:00',1.29),('8998','2014-02-04','13:50:00',1.05),('8998','2014-02-04','14:35:00',1.02),('8998','2014-02-03','09:20:00',1.16),('8998','2014-02-03','09:25:00',1.58),('8998','2014-02-03','09:30:00',1.72),('8998','2014-02-03','09:35:00',2.23),('8998','2014-02-03','09:40:00',2.07),('8998','2014-02-03','09:45:00',1.94),('8998','2014-02-03','09:50:00',1.88),('8998','2014-02-03','09:55:00',1.9),('8998','2014-02-03','10:00:00',2.12),('8998','2014-02-03','10:05:00',1.88),('8998','2014-02-03','10:10:00',1.11),('8998','2014-02-03','10:15:00',1.71),('8998','2014-02-03','10:20:00',1),('8998','2014-02-03','10:45:00',1.01),('8998','2014-02-03','10:50:00',1.55),('8998','2014-02-03','10:55:00',2.11),('8998','2014-02-03','11:00:00',1.06),('8998','2014-02-03','11:55:00',1.83),('8998','2014-02-03','12:00:00',2.22),('8998','2014-02-03','12:05:00',1.16),('8998','2014-02-03','12:15:00',1.03),('8998','2014-02-03','12:25:00',1),('8998','2014-01-31','11:20:00',1.45),('8998','2014-01-31','11:30:00',1.39),('8998','2014-01-31','11:35:00',1.38),('8998','2014-01-31','11:55:00',1.15),('8998','2014-01-31','12:00:00',1.25),('8998','2014-01-31','12:10:00',1.5),('8998','2014-01-31','12:20:00',1.42),('8998','2014-01-31','12:25:00',1.01),('8998','2014-01-31','12:40:00',1.03),('8998','2014-01-31','12:45:00',1.39),('8998','2014-01-31','12:50:00',1.28),('8998','2014-01-29','09:55:00',1.71),('8998','2014-01-29','10:00:00',1.66),('8998','2014-01-29','10:05:00',1.48),('8998','2014-01-29','10:10:00',1.57),('8998','2014-01-29','10:15:00',1.86),('8998','2014-01-29','10:20:00',1.59),('8998','2014-01-29','10:25:00',1.77),('8998','2014-01-29','10:30:00',1.92),('8998','2014-01-29','10:35:00',1.89),('8998','2014-01-29','10:40:00',1.89),('8998','2014-01-29','10:45:00',1.66),('8998','2014-01-29','10:50:00',1.95),('8998','2014-01-29','10:55:00',2.26),('8998','2014-01-29','11:00:00',2.25),('8998','2014-01-29','11:05:00',2.11),('8998','2014-01-29','11:10:00',2.05),('8998','2014-01-29','11:15:00',1.94),('8998','2014-01-29','11:20:00',1.82),('8998','2014-01-29','11:25:00',1.95),('8998','2014-01-29','11:30:00',1.66),('8998','2014-01-29','11:35:00',1.76),('8998','2014-01-29','11:40:00',1.02),('8998','2014-01-29','11:45:00',1.68),('8998','2014-01-29','11:55:00',2.16),('8998','2014-01-29','12:00:00',1.25),('8998','2014-01-29','12:05:00',1.76),('8998','2014-01-29','12:10:00',1.25),('8998','2014-01-29','12:15:00',1.06),('8998','2014-01-29','12:20:00',1.57),('8998','2014-01-29','12:25:00',1.69),('8998','2014-01-29','12:30:00',1.29),('8998','2014-01-29','12:35:00',1.35),('8998','2014-01-29','12:40:00',1.44),('8998','2014-01-29','12:45:00',1.54),('8998','2014-01-29','12:50:00',1.49),('8998','2014-01-29','12:55:00',1.46),('8998','2014-01-29','13:05:00',1.34),('8998','2014-01-29','13:15:00',1.42),('8998','2014-01-29','13:20:00',1.13),('8998','2014-01-29','13:25:00',1.44),('8998','2014-01-29','13:30:00',1.18),('8998','2014-01-29','13:35:00',1.01),('8998','2014-01-29','13:40:00',1.14),('8998','2014-01-29','13:45:00',1.28),('8998','2014-01-29','13:50:00',1.12),('8998','2014-01-28','09:20:00',1.34),('8998','2014-01-28','09:30:00',1.1),('8998','2014-01-28','09:35:00',1.45),('8998','2014-01-28','09:40:00',1.39),('8998','2014-01-28','09:45:00',1.51),('8998','2014-01-28','09:50:00',1.27),('8998','2014-01-28','09:55:00',1.36),('8998','2014-01-28','10:00:00',1.16),('8998','2014-01-28','10:05:00',1.11),('8998','2014-01-28','10:10:00',1.19),('8998','2014-01-28','10:15:00',1.21),('8998','2014-01-28','10:25:00',1.81),('8998','2014-01-28','10:30:00',1.84),('8998','2014-01-28','10:35:00',1.56),('8998','2014-01-28','10:40:00',1.39),('8998','2014-01-28','10:45:00',1.38),('8998','2014-01-28','10:50:00',1.31),('8998','2014-01-28','10:55:00',1.23),('8998','2014-01-28','11:00:00',1.24),('8998','2014-01-28','11:05:00',1.41),('8998','2014-01-28','11:10:00',1.28),('8998','2014-01-28','11:15:00',1.27),('8998','2014-01-28','11:20:00',1.35),('8998','2014-01-28','11:25:00',1.32),('8998','2014-01-28','11:30:00',1.74),('8998','2014-01-28','11:35:00',1.61),('8998','2014-01-28','11:40:00',1.4),('8998','2014-01-28','12:50:00',1.46),('8998','2014-01-28','12:55:00',1.76),('8998','2014-01-28','13:00:00',1.63),('8998','2014-01-28','13:40:00',1.49),('8998','2014-01-27','09:10:00',1.16),('8998','2014-01-27','09:15:00',1.24),('8998','2014-01-27','09:20:00',1.21),('8998','2014-01-27','09:25:00',1.23),('8998','2014-01-27','09:30:00',1.17),('8998','2014-01-27','09:35:00',1.33),('8998','2014-01-27','09:40:00',1.16),('8998','2014-01-27','09:45:00',1.25),('8998','2014-01-27','09:50:00',1.57),('8998','2014-01-27','09:55:00',1.68),('8998','2014-01-27','10:00:00',1.84),('8998','2014-01-27','10:05:00',1.79),('8998','2014-01-27','10:10:00',1.75),('8998','2014-01-27','10:15:00',1.76),('8998','2014-01-27','10:20:00',1.8),('8998','2014-01-27','10:25:00',1.89),('8998','2014-01-27','10:30:00',1.86),('8998','2014-01-27','10:35:00',1.91),('8998','2014-01-27','10:40:00',1.93),('8998','2014-01-27','10:45:00',1.62),('8998','2014-01-27','10:50:00',1.84),('8998','2014-01-27','10:55:00',1.84),('8998','2014-01-27','11:00:00',1.88),('8998','2014-01-27','11:10:00',1.17),('8998','2014-01-27','11:15:00',1.51),('8998','2014-01-27','11:30:00',1.5),('8998','2014-01-27','11:35:00',1.37),('8998','2014-01-27','11:40:00',1.93),('8998','2014-01-27','11:45:00',1.44),('8998','2014-01-27','11:50:00',1.26),('8998','2014-01-27','12:00:00',1.43),('8998','2014-01-27','12:05:00',1.47),('8998','2014-01-27','12:10:00',1.2),('8998','2014-01-27','12:15:00',1.63),('8998','2014-01-27','12:20:00',1.31),('8998','2014-01-27','12:40:00',1.12),('8998','2014-01-27','12:45:00',1.1),('8998','2014-01-27','12:50:00',1.98),('8998','2014-01-27','12:55:00',1.67),('8998','2014-01-27','13:00:00',1.83),('8998','2014-01-27','13:05:00',2),('8998','2014-01-27','13:10:00',1.5),('8998','2014-01-27','13:15:00',1.37),('8998','2014-01-27','13:20:00',1.33),('8998','2014-01-27','13:25:00',1.44),('8998','2014-01-27','13:30:00',1.41),('8998','2014-01-27','13:35:00',1.5),('8998','2014-01-27','13:40:00',1.38),('8998','2014-01-27','13:45:00',1.25),('8998','2014-01-27','13:50:00',1.1),('8998','2014-01-27','13:55:00',1.02),('9303','2014-05-05','07:50:00',1.02),('9303','2014-05-05','07:55:00',1.13),('9303','2014-05-05','08:00:00',1.23),('9303','2014-05-05','08:05:00',1.33),('9303','2014-05-05','08:10:00',1.44),('9303','2014-05-05','08:15:00',1.54),('9303','2014-05-05','08:20:00',1.66),('9303','2014-05-05','08:25:00',1.77),('9303','2014-05-05','08:30:00',1.87),('9303','2014-05-05','08:35:00',1.97),('9303','2014-05-05','08:40:00',2.06),('9303','2014-05-05','08:45:00',2.15),('9303','2014-05-05','08:50:00',2.25),('9303','2014-05-05','08:55:00',2.31),('9303','2014-05-05','09:00:00',2.38),('9303','2014-05-05','09:05:00',2.44),('9303','2014-05-05','09:10:00',2.49),('9303','2014-05-05','09:15:00',2.61),('9303','2014-05-05','09:20:00',2.66),('9303','2014-05-05','09:25:00',2.76),('9303','2014-05-05','09:30:00',2.86),('9303','2014-05-05','09:35:00',2.92),('9303','2014-05-05','09:40:00',2.99),('9303','2014-05-05','09:45:00',3.08),('9303','2014-05-05','09:50:00',3.15),('9303','2014-05-05','09:55:00',3.21),('9303','2014-05-05','10:00:00',3.28),('9303','2014-05-05','10:05:00',3.38),('9303','2014-05-05','10:10:00',3.43),('9303','2014-05-05','10:15:00',3.45),('9303','2014-05-05','10:20:00',3.46),('9303','2014-05-05','10:25:00',3.54),('9303','2014-05-05','10:30:00',3.6),('9303','2014-05-05','10:35:00',3.66),('9303','2014-05-05','10:40:00',3.67),('9303','2014-05-05','10:45:00',3.7),('9303','2014-05-05','10:50:00',3.78),('9303','2014-05-05','10:55:00',3.79),('9303','2014-05-05','11:00:00',3.85),('9303','2014-05-05','11:05:00',3.85),('9303','2014-05-05','11:10:00',3.89),('9303','2014-05-05','11:15:00',3.92),('9303','2014-05-05','11:20:00',3.93),('9303','2014-05-05','11:25:00',3.78),('9303','2014-05-05','11:30:00',3.98),('9303','2014-05-05','11:35:00',3.99),('9303','2014-05-05','11:40:00',4.05),('9303','2014-05-05','11:45:00',4.11),('9303','2014-05-05','11:50:00',4.12),('9303','2014-05-05','11:55:00',4.31),('9303','2014-05-05','12:00:00',4.35),('9303','2014-05-05','12:05:00',2.75),('9303','2014-05-05','12:10:00',2.32),('9303','2014-05-05','12:15:00',2.08),('9303','2014-05-05','12:20:00',2.08),('9303','2014-05-05','12:25:00',3.53),('9303','2014-05-05','12:30:00',3.77),('9303','2014-05-05','12:35:00',1.96),('9303','2014-05-05','12:40:00',1.46),('9303','2014-05-05','12:45:00',4.18),('9303','2014-05-05','12:50:00',4.07),('9303','2014-05-05','12:55:00',2.22),('9303','2014-05-05','13:00:00',3.48),('9303','2014-05-05','13:05:00',3.81),('9303','2014-05-05','13:10:00',4.47),('9303','2014-05-05','13:15:00',4.43),('9303','2014-05-05','13:20:00',4.39),('9303','2014-05-05','13:25:00',4.32),('9303','2014-05-05','13:30:00',4.31),('9303','2014-05-05','13:35:00',4.36),('9303','2014-05-05','13:40:00',4.35),('9303','2014-05-05','13:45:00',4.37),('9303','2014-05-05','13:50:00',4.35),('9303','2014-05-05','13:55:00',4.34),('9303','2014-05-05','14:00:00',4.29),('9303','2014-05-05','14:05:00',4.43),('9303','2014-05-05','14:10:00',4.53),('9303','2014-05-05','14:15:00',4.59),('9303','2014-05-05','14:20:00',4.82),('9303','2014-05-05','14:25:00',4.09),('9303','2014-05-05','14:30:00',2.1),('9303','2014-05-05','14:35:00',1.99),('9303','2014-05-05','14:40:00',1.39),('9303','2014-05-05','14:45:00',1.21),('9303','2014-05-05','14:50:00',1.24),('9303','2014-05-05','14:55:00',1.69),('9303','2014-05-05','15:00:00',1.86),('9303','2014-05-05','15:05:00',1.59),('9303','2014-05-05','15:10:00',1.39),('9303','2014-05-05','15:15:00',1.26),('9303','2014-05-05','15:20:00',1.33),('9303','2014-05-05','15:25:00',2.88),('9303','2014-05-05','15:30:00',4.08),('9303','2014-05-05','15:35:00',2.14),('9303','2014-05-05','15:40:00',2.48),('9303','2014-05-05','15:45:00',2.24),('9303','2014-05-05','15:50:00',1.28),('9303','2014-05-05','15:55:00',1.35),('9303','2014-05-05','16:00:00',1.6),('9303','2014-05-05','16:05:00',2.65),('9303','2014-05-05','16:10:00',1.19),('9303','2014-05-05','16:15:00',1.35),('9303','2014-05-05','16:20:00',1.16),('9303','2014-05-05','16:40:00',1.66),('9303','2014-05-05','16:45:00',2.33),('9303','2014-05-05','16:50:00',2.12),('9303','2014-05-05','16:55:00',2.6),('9303','2014-05-05','17:00:00',2.44),('9303','2014-05-05','17:05:00',2.18),('9303','2014-05-05','17:10:00',2.27),('9303','2014-05-05','17:15:00',2.21),('9303','2014-05-05','17:20:00',2.14),('9303','2014-05-05','17:25:00',1.96),('9303','2014-05-05','17:30:00',1.82),('9303','2014-05-05','17:35:00',1.74),('9303','2014-05-05','17:40:00',1.65),('9303','2014-05-05','17:45:00',1.53),('9303','2014-05-05','17:50:00',1.45),('9303','2014-05-05','17:55:00',1.36),('9303','2014-05-05','18:00:00',1.23),('9303','2014-05-05','18:05:00',1.14),('9303','2014-05-05','18:10:00',1.06),('9303','2014-04-26','09:55:00',1.36),('9303','2014-04-26','10:00:00',1.36),('9303','2014-04-26','10:05:00',1.25),('9303','2014-04-26','10:10:00',1.22),('9303','2014-04-26','10:15:00',1.26),('9303','2014-04-26','10:20:00',1.34),('9303','2014-04-26','10:25:00',1.45),('9303','2014-04-26','10:30:00',1.93),('9303','2014-04-26','10:35:00',1.91),('9303','2014-04-26','10:40:00',1.68),('9303','2014-04-26','10:45:00',1.81),('9303','2014-04-26','10:50:00',2.43),('9303','2014-04-26','10:55:00',3.04),('9303','2014-04-26','11:00:00',3.54),('9303','2014-04-26','11:05:00',2.57),('9303','2014-04-26','11:10:00',3.32),('9303','2014-04-26','11:15:00',3.26),('9303','2014-04-26','11:20:00',3.12),('9303','2014-04-26','11:25:00',3),('9303','2014-04-26','11:30:00',2.99),('9303','2014-04-26','11:35:00',2.99),('9303','2014-04-26','11:40:00',2.86),('9303','2014-04-26','11:45:00',3.14),('9303','2014-04-26','11:50:00',3.16),('9303','2014-04-26','11:55:00',2.72),('9303','2014-04-26','12:00:00',3.1),('9303','2014-04-26','12:05:00',2.96),('9303','2014-04-26','12:10:00',3.22),('9303','2014-04-26','12:15:00',3.05),('9303','2014-04-26','12:20:00',2.8),('9303','2014-04-26','12:25:00',1.8),('9303','2014-04-26','12:30:00',2.29),('9303','2014-04-26','12:35:00',3.24),('9303','2014-04-26','12:40:00',3.35),('9303','2014-04-26','12:45:00',3.06),('9303','2014-04-26','12:50:00',4.08),('9303','2014-04-26','12:55:00',4.28),('9303','2014-04-26','13:00:00',4.14),('9303','2014-04-26','13:05:00',3.34),('9303','2014-04-26','13:10:00',3.09),('9303','2014-04-26','13:15:00',4.43),('9303','2014-04-26','13:20:00',4.37),('9303','2014-04-26','13:25:00',2.77),('9303','2014-04-26','13:30:00',1.42),('9303','2014-04-26','13:35:00',2.38),('9303','2014-04-26','13:40:00',4.48),('9303','2014-04-26','13:45:00',4.17),('9303','2014-04-26','13:50:00',4.2),('9303','2014-04-26','13:55:00',4.47),('9303','2014-04-26','14:00:00',2.68),('9303','2014-04-26','14:10:00',3.2),('9303','2014-04-26','14:35:00',1.85),('9303','2014-04-26','14:40:00',2.16),('9303','2014-01-26','09:05:00',1.01),('9303','2014-01-26','09:30:00',1.31),('9303','2014-01-26','09:35:00',1.4),('9303','2014-01-26','09:45:00',1.15),('9303','2014-01-26','09:50:00',1.35),('9303','2014-01-26','10:10:00',1.55),('9303','2014-01-26','10:15:00',2.13),('9303','2014-01-26','10:20:00',1.02),('9303','2014-01-26','12:20:00',1.1),('9303','2014-01-26','12:25:00',1.21),('9303','2014-01-26','12:30:00',2.09),('9303','2014-01-26','12:35:00',1.95),('9303','2014-01-26','12:40:00',1.16),('9303','2014-01-26','12:45:00',1.02),('9303','2014-01-26','13:05:00',1.05),('9303','2014-01-26','13:10:00',1.15),('9303','2014-01-26','13:15:00',1.48),('9303','2014-01-26','13:20:00',1.45),('9303','2014-01-26','13:25:00',1.09),('9303','2014-01-26','15:45:00',1.1),('9303','2014-01-25','09:05:00',1.08),('9303','2014-01-25','09:20:00',1.04),('9303','2014-01-25','09:50:00',1.06),('9303','2014-01-25','09:55:00',1.35),('9303','2014-01-25','10:00:00',1.29),('9303','2014-01-25','10:05:00',1.69),('9303','2014-01-25','10:10:00',2.22),('9303','2014-01-25','10:15:00',2.32),('9303','2014-01-25','10:20:00',2.16),('9303','2014-01-25','10:25:00',1.42),('9303','2014-01-25','10:30:00',1.39),('9303','2014-01-25','10:35:00',1.44),('9303','2014-01-25','10:40:00',1.62),('9303','2014-01-25','10:45:00',1.45),('9303','2014-01-25','10:50:00',1.61),('9303','2014-01-25','10:55:00',1.43),('9303','2014-01-25','11:00:00',1.25),('9303','2014-01-25','11:05:00',1.18),('9303','2014-01-25','11:20:00',1.03),('9303','2014-01-25','11:25:00',1.32),('9303','2014-01-25','11:30:00',3.13),('9303','2014-01-25','11:35:00',3.04),('9303','2014-01-25','11:40:00',1.65),('9303','2014-01-25','11:45:00',1.35),('9303','2014-01-25','11:50:00',1.45),('9303','2014-01-25','11:55:00',1.45),('9303','2014-01-25','12:00:00',1.44),('9303','2014-01-25','12:05:00',1.54),('9303','2014-01-25','12:10:00',1.66),('9303','2014-01-25','12:15:00',1.56),('9303','2014-01-25','12:20:00',1.65),('9303','2014-01-25','12:25:00',1.7),('9303','2014-01-25','12:30:00',1.64),('9303','2014-01-25','12:35:00',1.44),('9303','2014-01-25','12:40:00',1.54),('9303','2014-01-25','12:45:00',1.87),('9303','2014-01-25','12:50:00',1.97),('9303','2014-01-25','12:55:00',2.3),('9303','2014-01-25','13:00:00',2.3),('9303','2014-01-25','13:05:00',2.57),('9303','2014-01-25','13:10:00',2.48),('9303','2014-01-25','13:15:00',1.88),('9303','2014-01-25','13:20:00',1.17),('9303','2014-01-25','13:25:00',1.08),('9303','2014-01-25','13:30:00',1.59),('9303','2014-01-25','13:35:00',1.08),('9303','2014-01-25','13:45:00',1.4),('9303','2014-01-25','13:50:00',1.23),('9303','2014-01-25','14:00:00',1.49),('9303','2014-01-25','14:05:00',1.76),('9303','2014-01-25','14:10:00',1.76),('9303','2014-01-25','14:15:00',1.4),('9303','2014-01-25','14:20:00',1.91),('9303','2014-01-25','14:25:00',1.99),('9303','2014-01-25','14:30:00',2.29),('9303','2014-01-25','14:35:00',1.83),('9303','2014-01-25','14:40:00',2.2),('9303','2014-01-25','14:45:00',2.2),('9303','2014-01-25','14:50:00',2.08),('9303','2014-01-25','14:55:00',1.91),('9303','2014-01-25','15:00:00',1.72),('9303','2014-01-25','15:05:00',1.58),('9303','2014-01-25','15:10:00',1.48),('9303','2014-01-25','15:15:00',1.38),('9303','2014-01-25','15:20:00',1.29),('9303','2014-01-25','15:25:00',1.2),('9303','2014-01-25','15:30:00',1.1),('9303','2014-01-25','15:35:00',1.02),('9303','2014-01-24','10:10:00',1.07),('9303','2014-01-24','10:15:00',1.39),('9303','2014-01-24','10:30:00',1.43),('9303','2014-01-24','10:35:00',1.02),('9303','2014-01-24','10:40:00',1.65),('9303','2014-01-24','10:45:00',1.55),('9303','2014-01-24','11:30:00',1.13),('9303','2014-01-24','11:35:00',1.5),('9303','2014-01-24','11:45:00',1.1),('9303','2014-01-24','11:50:00',2.53),('9303','2014-01-24','11:55:00',2.39),('9303','2014-01-24','12:00:00',1.59),('9303','2014-01-24','12:05:00',1.49),('9303','2014-01-24','12:25:00',1.51),('9303','2014-01-24','12:30:00',1.24),('9303','2014-01-24','12:35:00',2.43),('9303','2014-01-24','12:40:00',2.47),('9303','2014-01-24','12:45:00',1.72),('9303','2014-01-24','12:50:00',1.24),('9303','2014-01-24','12:55:00',1.23),('9303','2014-01-24','13:00:00',1.46),('9303','2014-01-24','13:05:00',1.68),('9303','2014-01-24','13:10:00',1.19),('9303','2014-01-24','13:35:00',1.27),('9303','2014-01-24','13:40:00',1.14),('9303','2014-01-24','14:00:00',1.11),('9303','2014-01-24','14:10:00',2.07),('9303','2014-01-24','14:15:00',2.38),('9303','2014-01-24','14:20:00',2.11),('9303','2014-01-24','14:25:00',2.14),('9303','2014-01-24','14:45:00',1.12),('9303','2014-01-23','11:15:00',1),('9303','2014-01-22','13:15:00',1.09),('9303','2014-01-21','10:00:00',1.11),('9303','2014-01-21','10:05:00',1.1),('9303','2014-01-21','10:55:00',1.45),('9303','2014-01-21','11:00:00',2.1),('9303','2014-01-21','11:05:00',1.08),('9303','2014-01-21','11:50:00',1.02),('9303','2014-01-21','11:55:00',1.05),('9303','2014-01-21','12:05:00',1.55),('9303','2014-01-21','12:10:00',1.93),('9303','2014-01-21','12:15:00',1.61),('9303','2014-01-21','12:20:00',1.1),('9303','2014-01-21','12:25:00',1.16),('9303','2014-01-21','12:30:00',2.04),('9303','2014-01-21','12:35:00',1.35),('9303','2014-01-21','12:40:00',1.27),('9303','2014-01-21','12:45:00',1.32),('9303','2014-01-21','12:50:00',1.67),('9303','2014-01-21','13:20:00',1.1),('9303','2014-01-21','14:05:00',1.22),('9303','2014-01-21','14:10:00',1.12),('9303','2014-01-20','11:20:00',1.27),('9303','2014-01-20','11:25:00',1.65),('9303','2014-01-20','11:30:00',1.75),('9303','2014-01-20','11:35:00',1.71),('9303','2014-01-20','11:40:00',2.42),('9303','2014-01-20','11:45:00',2.62),('9303','2014-01-20','11:50:00',1.44),('9303','2014-01-20','13:20:00',3.25),('9303','2014-01-20','13:25:00',2.97),('9303','2014-01-20','13:30:00',2.59),('9303','2014-01-20','13:35:00',2.46),('9303','2014-01-20','13:40:00',2.01),('9303','2014-01-20','13:45:00',1.82),('9303','2014-01-20','13:50:00',1.07),('9303','2014-01-20','13:55:00',1.02),('9303','2014-01-20','14:00:00',2.57),('9303','2014-01-20','14:05:00',1.86),('9303','2014-01-20','14:10:00',1.37),('9303','2014-01-19','13:10:00',1.03),('9303','2014-01-19','14:20:00',1.13),('9303','2014-01-19','14:25:00',1.48),('9303','2014-01-19','14:30:00',1.73),('9303','2014-01-19','14:35:00',1.13),('9303','2014-01-18','10:00:00',1.08),('9303','2014-01-18','10:05:00',1.33),('9303','2014-01-18','10:10:00',1.75),('9303','2014-01-18','10:15:00',1.96),('9303','2014-01-18','10:20:00',1.74),('9303','2014-01-18','10:25:00',1.26),('9303','2014-01-18','10:30:00',1.42),('9303','2014-01-18','10:50:00',1.09),('9303','2014-01-18','10:55:00',1.04),('9303','2014-01-18','11:05:00',1.01),('9303','2014-01-18','11:10:00',1.44),('9303','2014-01-18','11:15:00',2.14),('9303','2014-01-18','11:20:00',2.04),('9303','2014-01-18','11:25:00',1.97),('9303','2014-01-18','11:30:00',2),('9303','2014-01-18','11:35:00',2.04),('9303','2014-01-18','11:40:00',2.1),('9303','2014-01-18','11:45:00',2.37),('9303','2014-01-18','11:50:00',2.24),('9303','2014-01-18','11:55:00',2.57),('9303','2014-01-18','12:00:00',2.37),('9303','2014-01-18','12:05:00',1.95),('9303','2014-01-18','12:10:00',2.22),('9303','2014-01-18','12:15:00',2.11),('9303','2014-01-18','12:20:00',2.13),('9303','2014-01-18','12:25:00',2.18),('9303','2014-01-18','12:30:00',2.24),('9303','2014-01-18','12:35:00',2.27),('9303','2014-01-18','12:40:00',2.33),('9303','2014-01-18','12:45:00',2.31),('9303','2014-01-18','12:50:00',2.17),('9303','2014-01-18','12:55:00',2.51),('9303','2014-01-18','13:00:00',1.79),('9303','2014-01-18','13:05:00',1.43),('9303','2014-01-18','13:10:00',1.93),('9303','2014-01-18','13:15:00',2.32),('9303','2014-01-18','13:20:00',1.54),('9303','2014-01-18','13:25:00',1.11),('9303','2014-01-18','13:30:00',2.1),('9303','2014-01-18','13:35:00',1.32),('9303','2014-01-18','13:40:00',1.76),('9303','2014-01-18','13:45:00',2.07),('9303','2014-01-18','13:50:00',1.52),('9303','2014-01-18','13:55:00',1.99),('9303','2014-01-18','14:00:00',1.94),('9303','2014-01-18','14:05:00',1.84),('9303','2014-01-18','14:10:00',1.7),('9303','2014-01-18','14:15:00',1.63),('9303','2014-01-18','14:20:00',1.68),('9303','2014-01-18','14:25:00',1.62),('9303','2014-01-18','14:30:00',1.54),('9303','2014-01-18','14:35:00',1.52),('9303','2014-01-18','14:40:00',1.46),('9303','2014-01-18','14:45:00',1.44),('9303','2014-01-18','14:50:00',1.39),('9303','2014-01-18','14:55:00',1),('9303','2014-01-17','09:35:00',1.07),('9303','2014-01-17','09:40:00',1.29),('9303','2014-01-17','09:45:00',1.42),('9303','2014-01-17','09:50:00',1.01),('9303','2014-01-17','11:30:00',1.38),('9303','2014-01-17','11:35:00',1.45),('9303','2014-01-17','11:40:00',1.15),('9303','2014-01-17','12:00:00',1.03),('9303','2014-01-17','12:05:00',1.45),('9303','2014-01-17','12:10:00',1.39),('9303','2014-01-17','12:45:00',1.03),('9303','2014-04-25','07:55:00',1.01),('9303','2014-04-25','08:00:00',1.15),('9303','2014-04-25','08:05:00',1.13),('9303','2014-04-25','08:10:00',1.19),('9303','2014-04-25','08:15:00',1.25),('9303','2014-04-25','08:20:00',1.38),('9303','2014-04-25','08:25:00',1.47),('9303','2014-04-25','08:30:00',1.54),('9303','2014-04-25','08:35:00',1.63),('9303','2014-04-25','08:40:00',1.71),('9303','2014-04-25','08:45:00',1.79),('9303','2014-04-25','08:50:00',1.86),('9303','2014-04-25','08:55:00',2.04),('9303','2014-04-25','09:00:00',2.23),('9303','2014-04-25','09:05:00',2.05),('9303','2014-04-25','09:10:00',2.43),('9303','2014-04-25','09:15:00',1.15),('9303','2014-04-25','09:20:00',1.19),('9303','2014-04-25','09:25:00',1.44),('9303','2014-04-25','09:30:00',1.29),('9303','2014-04-25','09:35:00',1.15),('9303','2014-04-25','10:00:00',1.18),('9303','2014-04-25','10:05:00',1.11),('9303','2014-04-25','10:10:00',1.04),('9303','2014-04-25','10:15:00',1.1),('9303','2014-04-25','10:20:00',1.13),('9303','2014-04-25','10:25:00',1.27),('9303','2014-04-25','10:30:00',1.31),('9303','2014-04-25','10:35:00',2.77),('9303','2014-04-25','10:40:00',3.38),('9303','2014-04-25','10:45:00',3.04),('9303','2014-04-25','10:50:00',2.98),('9303','2014-04-25','10:55:00',2.38),('9303','2014-04-25','11:00:00',3.64),('9303','2014-04-25','11:05:00',1.42),('9303','2014-04-25','11:10:00',1.07),('9303','2014-04-25','11:15:00',2.52),('9303','2014-04-25','11:20:00',3.96),('9303','2014-04-25','11:25:00',3.46),('9303','2014-04-25','11:30:00',3.7),('9303','2014-04-25','11:35:00',2.25),('9303','2014-04-25','11:40:00',4.03),('9303','2014-04-25','11:45:00',1.47),('9303','2014-04-25','11:50:00',1.22),('9303','2014-04-25','11:55:00',1.42),('9303','2014-04-25','12:00:00',1.94),('9303','2014-04-25','12:05:00',1.53),('9303','2014-04-25','12:10:00',2.21),('9303','2014-04-25','12:15:00',4.54),('9303','2014-04-25','12:20:00',3.69),('9303','2014-04-25','12:25:00',1.99),('9303','2014-04-25','12:30:00',1.39),('9303','2014-04-25','12:35:00',3.17),('9303','2014-04-25','12:40:00',3.35),('9303','2014-04-25','12:45:00',4.79),('9303','2014-04-25','12:50:00',1.98),('9303','2014-04-25','12:55:00',1.47),('9303','2014-04-25','13:00:00',2.48),('9303','2014-04-25','13:05:00',2.49),('9303','2014-04-25','13:10:00',2.7),('9303','2014-04-25','13:15:00',1.59),('9303','2014-04-25','13:20:00',1.33),('9303','2014-04-25','13:25:00',1.47),('9303','2014-04-25','13:30:00',2.5),('9303','2014-04-25','13:35:00',1.01),('9303','2014-04-25','13:40:00',3.5),('9303','2014-04-25','13:45:00',1.34),('9303','2014-04-25','13:50:00',1.17),('9303','2014-04-25','13:55:00',1.4),('9303','2014-04-25','14:00:00',1.28),('9303','2014-04-25','14:05:00',1.7),('9303','2014-04-25','14:10:00',1.28),('9303','2014-04-25','14:15:00',1.29),('9303','2014-04-25','14:20:00',3.95),('9303','2014-04-25','14:25:00',3.7),('9303','2014-04-25','14:30:00',2.73),('9303','2014-04-25','14:35:00',4.15),('9303','2014-04-25','14:40:00',3.85),('9303','2014-04-25','14:45:00',3.85),('9303','2014-04-25','14:50:00',3.87),('9303','2014-04-25','14:55:00',3.79),('9303','2014-04-25','15:00:00',3.73),('9303','2014-04-25','15:05:00',3.67),('9303','2014-04-25','15:10:00',3.6),('9303','2014-04-25','15:15:00',3.6),('9303','2014-04-25','15:20:00',3.45),('9303','2014-04-25','15:25:00',3.42),('9303','2014-04-25','15:30:00',3.3),('9303','2014-04-25','15:35:00',3.35),('9303','2014-04-25','15:40:00',3.33),('9303','2014-04-25','15:45:00',3.23),('9303','2014-04-25','15:50:00',3.17),('9303','2014-04-25','15:55:00',3.16),('9303','2014-04-25','16:00:00',3.11),('9303','2014-04-25','16:05:00',2.95),('9303','2014-04-25','16:10:00',2.88),('9303','2014-04-25','16:15:00',2.76),('9303','2014-04-25','16:20:00',2.52),('9303','2014-04-25','16:25:00',2.55),('9303','2014-04-25','16:30:00',2.67),('9303','2014-04-25','16:35:00',2.65),('9303','2014-04-25','16:40:00',2.67),('9303','2014-04-25','16:45:00',2.54),('9303','2014-04-25','16:50:00',2.3),('9303','2014-04-25','16:55:00',1.94),('9303','2014-04-25','17:00:00',1.74),('9303','2014-04-25','17:05:00',1.96),('9303','2014-04-25','17:10:00',1.75),('9303','2014-04-25','17:15:00',1.68),('9303','2014-04-25','17:20:00',1.3),('9303','2014-01-16','09:25:00',1.03),('9303','2014-01-16','09:30:00',1.15),('9303','2014-01-16','09:35:00',1.26),('9303','2014-01-16','09:40:00',1.46),('9303','2014-01-16','09:45:00',1.41),('9303','2014-01-16','09:50:00',1.19),('9303','2014-01-16','10:10:00',1),('9303','2014-01-16','10:15:00',1.1),('9303','2014-01-16','10:20:00',1.12),('9303','2014-01-16','10:25:00',1.2),('9303','2014-01-16','10:30:00',1.51),('9303','2014-01-16','10:35:00',1.88),('9303','2014-01-16','10:40:00',1.81),('9303','2014-01-16','10:45:00',1.4),('9303','2014-01-16','10:50:00',1.46),('9303','2014-01-16','10:55:00',1.61),('9303','2014-01-16','11:00:00',1.61),('9303','2014-01-16','11:05:00',1.63),('9303','2014-01-16','11:10:00',1.7),('9303','2014-01-16','11:15:00',1.75),('9303','2014-01-16','11:20:00',1.58),('9303','2014-01-16','11:25:00',1.66),('9303','2014-01-16','11:30:00',1.49),('9303','2014-01-16','11:35:00',1.45),('9303','2014-01-16','11:40:00',1.36),('9303','2014-01-16','11:45:00',1.45),('9303','2014-01-16','11:50:00',1.46),('9303','2014-01-16','11:55:00',1.32),('9303','2014-01-16','12:00:00',1.34),('9303','2014-01-16','12:05:00',1.39),('9303','2014-01-16','12:10:00',1.55),('9303','2014-01-16','12:15:00',1.45),('9303','2014-01-16','12:20:00',1.35),('9303','2014-01-16','12:25:00',1.31),('9303','2014-01-16','12:30:00',1.34),('9303','2014-01-16','12:35:00',1.59),('9303','2014-01-16','12:40:00',1.71),('9303','2014-01-16','12:45:00',1.78),('9303','2014-01-16','12:50:00',1.91),('9303','2014-01-16','12:55:00',1.94),('9303','2014-01-16','13:00:00',1.97),('9303','2014-01-16','13:05:00',2.04),('9303','2014-01-16','13:10:00',1.84),('9303','2014-01-16','13:15:00',1.93),('9303','2014-01-16','13:20:00',1.85),('9303','2014-01-16','13:25:00',1.8),('9303','2014-01-16','13:35:00',1.28),('9303','2014-01-16','13:40:00',1.04),('9303','2014-01-16','13:45:00',2.05),('9303','2014-01-16','13:50:00',2.07),('9303','2014-01-16','13:55:00',1.6),('9303','2014-01-15','10:15:00',1.18),('9303','2014-01-15','10:20:00',1.54),('9303','2014-01-15','10:25:00',1.73),('9303','2014-01-15','10:30:00',1.75),('9303','2014-01-15','10:35:00',1.17),('9303','2014-01-15','10:40:00',1.12),('9303','2014-01-15','10:45:00',1.58),('9303','2014-01-15','10:50:00',1.03),('9303','2014-01-15','10:55:00',1.08),('9303','2014-01-15','11:00:00',1.13),('9303','2014-01-15','11:05:00',1.39),('9303','2014-01-15','11:10:00',1.93),('9303','2014-01-15','11:15:00',1.89),('9303','2014-01-15','11:20:00',1.94),('9303','2014-01-15','11:25:00',1.85),('9303','2014-01-15','11:30:00',1.82),('9303','2014-01-15','11:35:00',1.37),('9303','2014-01-15','11:40:00',1.62),('9303','2014-01-15','11:45:00',1.91),('9303','2014-01-15','11:50:00',1.86),('9303','2014-01-15','11:55:00',1.65),('9303','2014-01-15','12:00:00',1.49),('9303','2014-01-15','12:05:00',1.41),('9303','2014-01-15','12:10:00',1.42),('9303','2014-01-15','12:15:00',1.57),('9303','2014-01-15','12:20:00',2.01),('9303','2014-01-15','12:25:00',1.83),('9303','2014-01-15','12:30:00',1.28),('9303','2014-01-15','12:35:00',1.42),('9303','2014-01-15','12:40:00',1.29),('9303','2014-01-15','12:45:00',1.19),('9303','2014-01-15','12:50:00',1.42),('9303','2014-01-15','12:55:00',1.25),('9303','2014-01-15','13:00:00',1.22),('9303','2014-01-15','13:05:00',1.31),('9303','2014-01-15','13:10:00',1.49),('9303','2014-01-15','13:15:00',2.31),('9303','2014-01-15','13:20:00',2.44),('9303','2014-01-15','13:25:00',2.32),('9303','2014-01-15','13:30:00',2.18),('9303','2014-01-15','13:35:00',2.09),('9303','2014-01-15','13:40:00',2.03),('9303','2014-01-15','13:45:00',1.98),('9303','2014-01-15','13:50:00',1.93),('9303','2014-01-15','13:55:00',1.84),('9303','2014-01-15','14:00:00',1.76),('9303','2014-01-15','14:05:00',1.73),('9303','2014-01-15','14:10:00',1.69),('9303','2014-01-15','14:15:00',1.67),('9303','2014-01-15','14:20:00',1.64),('9303','2014-01-15','14:25:00',1.63),('9303','2014-01-15','14:30:00',1.63),('9303','2014-01-15','14:35:00',1.62),('9303','2014-01-15','14:40:00',1.69),('9303','2014-01-15','14:45:00',1.72),('9303','2014-01-15','14:50:00',1.65),('9303','2014-01-15','14:55:00',1.6),('9303','2014-01-15','15:00:00',1.55),('9303','2014-01-15','15:05:00',1.45),('9303','2014-01-15','15:10:00',1.39),('9303','2014-01-15','15:15:00',1.33),('9303','2014-01-15','15:20:00',1.18),('9303','2014-01-14','10:25:00',1.08),('9303','2014-01-14','10:30:00',2.14),('9303','2014-01-14','10:35:00',2.24),('9303','2014-01-14','10:40:00',1.93),('9303','2014-01-14','10:45:00',1.87),('9303','2014-01-14','10:50:00',1.32),('9303','2014-01-14','10:55:00',1.11),('9303','2014-01-14','11:00:00',1.4),('9303','2014-01-14','11:05:00',1.05),('9303','2014-01-14','11:35:00',1.02),('9303','2014-01-14','11:40:00',1.19),('9303','2014-01-13','09:40:00',1.02),('9303','2014-01-13','09:45:00',1.14),('9303','2014-01-13','09:50:00',1.25),('9303','2014-01-13','09:55:00',1.32),('9303','2014-01-13','10:00:00',1.38),('9303','2014-01-13','10:05:00',1.38),('9303','2014-01-13','10:10:00',1.42),('9303','2014-01-13','10:15:00',1.48),('9303','2014-01-13','10:20:00',1.52),('9303','2014-01-13','10:25:00',1.55),('9303','2014-01-13','10:30:00',1.57),('9303','2014-01-13','10:35:00',1.62),('9303','2014-01-13','10:40:00',1.6),('9303','2014-01-13','10:45:00',1.63),('9303','2014-01-13','10:50:00',1.71),('9303','2014-01-13','10:55:00',1.73),('9303','2014-01-13','11:00:00',1.77),('9303','2014-01-13','11:05:00',1.79),('9303','2014-01-13','11:10:00',1.83),('9303','2014-01-13','11:15:00',1.87),('9303','2014-01-13','11:20:00',1.85),('9303','2014-01-13','11:25:00',1.89),('9303','2014-01-13','11:30:00',1.91),('9303','2014-01-13','11:35:00',1.96),('9303','2014-01-13','11:40:00',1.98),('9303','2014-01-13','11:45:00',1.94),('9303','2014-01-13','11:50:00',1.96),('9303','2014-01-13','11:55:00',1.92),('9303','2014-01-13','12:00:00',1.89),('9303','2014-01-13','12:05:00',1.9),('9303','2014-01-13','12:10:00',1.94),('9303','2014-01-13','12:15:00',1.9),('9303','2014-01-13','12:20:00',1.97),('9303','2014-01-13','12:25:00',1.97),('9303','2014-01-13','12:30:00',1.98),('9303','2014-01-13','12:35:00',2),('9303','2014-01-13','12:40:00',2.04),('9303','2014-01-13','12:45:00',2.06),('9303','2014-01-13','12:50:00',2.02),('9303','2014-01-13','12:55:00',1.99),('9303','2014-01-13','13:00:00',1.98),('9303','2014-01-13','13:05:00',1.89),('9303','2014-01-13','13:10:00',1.85),('9303','2014-01-13','13:15:00',1.78),('9303','2014-01-13','13:20:00',1.75),('9303','2014-01-13','13:25:00',1.84),('9303','2014-01-13','13:30:00',1.87),('9303','2014-01-13','13:35:00',1.8),('9303','2014-01-13','13:40:00',1.73),('9303','2014-01-13','13:45:00',1.59),('9303','2014-01-13','13:50:00',1.61),('9303','2014-01-13','13:55:00',1.62),('9303','2014-01-13','14:00:00',1.55),('9303','2014-01-13','14:05:00',1.56),('9303','2014-01-13','14:10:00',1.47),('9303','2014-01-13','14:15:00',1.49),('9303','2014-01-13','14:20:00',1.43),('9303','2014-01-13','14:25:00',1.4),('9303','2014-01-13','14:30:00',1.36),('9303','2014-01-13','14:35:00',1.31),('9303','2014-01-13','14:40:00',1.29),('9303','2014-01-13','14:45:00',1.28),('9303','2014-01-13','14:50:00',1.24),('9303','2014-01-13','14:55:00',1.15),('9303','2014-01-13','15:00:00',1.11),('9303','2014-01-13','15:05:00',1.06),('9303','2014-01-12','10:35:00',1.06),('9303','2014-01-12','10:40:00',1.19),('9303','2014-01-12','10:45:00',1.24),('9303','2014-01-12','10:50:00',1.31),('9303','2014-01-12','10:55:00',1.42),('9303','2014-01-12','11:00:00',1.43),('9303','2014-01-12','11:05:00',1.4),('9303','2014-01-12','11:10:00',1.68),('9303','2014-01-12','11:15:00',1.49),('9303','2014-01-12','11:20:00',1.47),('9303','2014-01-12','11:25:00',1.36),('9303','2014-01-12','11:30:00',1.47),('9303','2014-01-12','11:35:00',1.27),('9303','2014-01-12','11:40:00',1.45),('9303','2014-01-12','11:45:00',1.56),('9303','2014-01-12','11:50:00',1.64),('9303','2014-01-12','11:55:00',1.71),('9303','2014-01-12','12:00:00',1.34),('9303','2014-01-12','12:05:00',1.36),('9303','2014-01-12','12:10:00',1.16),('9303','2014-01-12','12:20:00',1.14),('9303','2014-01-12','12:25:00',1.08),('9303','2014-01-12','12:30:00',1.12),('9303','2014-01-12','12:35:00',1.12),('9303','2014-01-12','12:40:00',1.24),('9303','2014-01-12','12:45:00',1.18),('9303','2014-01-12','12:50:00',1.2),('9303','2014-01-12','12:55:00',1.19),('9303','2014-01-12','13:00:00',1.19),('9303','2014-01-12','13:05:00',1.08),('9303','2014-01-12','13:10:00',1.04),('9303','2014-01-12','13:15:00',1.01),('9303','2014-01-12','13:20:00',1.05),('9303','2014-01-12','13:25:00',1.06),('9303','2014-01-12','13:30:00',1.28),('9303','2014-01-12','13:35:00',1.17),('9303','2014-01-12','13:40:00',1.07),('9303','2014-01-11','09:55:00',1.14),('9303','2014-01-11','10:00:00',1.28),('9303','2014-01-11','10:05:00',1.02),('9303','2014-01-11','10:10:00',1.01),('9303','2014-01-11','10:15:00',1.07),('9303','2014-01-11','10:20:00',1.03),('9303','2014-01-11','10:25:00',1.18),('9303','2014-01-11','10:30:00',1.2),('9303','2014-01-11','10:35:00',1.19),('9303','2014-01-11','10:40:00',1.46),('9303','2014-01-11','10:45:00',1.72),('9303','2014-01-11','10:50:00',1.79),('9303','2014-01-11','10:55:00',1.75),('9303','2014-01-11','11:00:00',1.72),('9303','2014-01-11','11:05:00',1.66),('9303','2014-01-11','11:10:00',1.81),('9303','2014-01-11','11:15:00',1.68),('9303','2014-01-11','11:20:00',1.41),('9303','2014-01-11','11:25:00',1.52),('9303','2014-01-11','11:30:00',1.5),('9303','2014-01-11','11:35:00',1.41),('9303','2014-01-11','11:40:00',1.33),('9303','2014-01-11','11:45:00',1.36),('9303','2014-01-11','11:50:00',1.5),('9303','2014-01-11','11:55:00',1.51),('9303','2014-01-11','12:00:00',1.49),('9303','2014-01-11','12:05:00',1.63),('9303','2014-01-11','12:10:00',1.56),('9303','2014-01-11','12:15:00',1.57),('9303','2014-01-11','12:20:00',1.55),('9303','2014-01-11','12:25:00',1.47),('9303','2014-01-11','12:30:00',1.38),('9303','2014-01-11','12:35:00',1.35),('9303','2014-01-11','12:40:00',1.21),('9303','2014-01-11','12:45:00',1.27),('9303','2014-01-11','12:50:00',1.7),('9303','2014-01-11','12:55:00',1.85),('9303','2014-01-11','13:00:00',1.85),('9303','2014-01-11','13:05:00',1.72),('9303','2014-01-11','13:10:00',1.68),('9303','2014-01-11','13:15:00',1.77),('9303','2014-01-11','13:20:00',1.61),('9303','2014-01-11','13:25:00',1.35),('9303','2014-01-11','13:30:00',1.17),('9303','2014-01-11','13:35:00',1.18),('9303','2014-01-11','13:40:00',1.04),('9303','2014-01-11','13:45:00',1.09),('9303','2014-01-11','14:00:00',1.26),('9303','2014-01-11','14:05:00',1.37),('9303','2014-01-11','14:10:00',1.21),('9303','2014-01-09','09:35:00',1.15),('9303','2014-01-09','09:40:00',1.15),('9303','2014-01-09','09:45:00',1.44),('9303','2014-01-09','09:50:00',1.51),('9303','2014-01-09','09:55:00',1.49),('9303','2014-01-09','10:00:00',1.52),('9303','2014-01-09','10:05:00',1.44),('9303','2014-01-09','10:10:00',1.28),('9303','2014-01-09','10:15:00',1.34),('9303','2014-01-09','10:20:00',1.36),('9303','2014-01-09','10:25:00',1.38),('9303','2014-01-09','10:30:00',1.45),('9303','2014-01-09','10:35:00',1.47),('9303','2014-01-09','10:40:00',1.59),('9303','2014-01-09','10:45:00',1.66),('9303','2014-01-09','10:50:00',1.67),('9303','2014-01-09','10:55:00',1.1),('9303','2014-01-09','11:00:00',1.08),('9303','2014-01-09','11:05:00',1.08),('9303','2014-01-09','11:10:00',1.1),('9303','2014-01-09','11:15:00',1.01),('9303','2014-01-09','11:20:00',1.13),('9303','2014-01-09','11:25:00',1.24),('9303','2014-01-09','11:30:00',1.08),('9303','2014-01-09','11:35:00',1.11),('9303','2014-01-09','11:40:00',1.42),('9303','2014-01-09','11:45:00',1.31),('9303','2014-01-09','13:15:00',1.01),('9303','2014-01-08','09:45:00',1.08),('9303','2014-01-08','09:50:00',1.17),('9303','2014-01-08','09:55:00',1.26),('9303','2014-01-08','10:00:00',1.32),('9303','2014-01-08','10:05:00',1.28),('9303','2014-01-08','10:10:00',1.34),('9303','2014-01-08','10:15:00',1.41),('9303','2014-01-08','10:20:00',1.5),('9303','2014-01-08','10:25:00',1.57),('9303','2014-01-08','10:30:00',1.57),('9303','2014-01-08','10:35:00',1.47),('9303','2014-01-08','10:40:00',1.45),('9303','2014-01-08','10:45:00',1.6),('9303','2014-01-08','10:50:00',1.7),('9303','2014-01-08','10:55:00',1.71),('9303','2014-01-08','11:00:00',1.76),('9303','2014-01-08','11:05:00',1.78),('9303','2014-01-08','11:10:00',1.84),('9303','2014-01-08','11:15:00',1.83),('9303','2014-01-08','11:20:00',1.84),('9303','2014-01-08','11:25:00',1.88),('9303','2014-01-08','11:30:00',1.89),('9303','2014-01-08','11:35:00',2),('9303','2014-01-08','11:40:00',2.02),('9303','2014-01-08','11:45:00',1.98),('9303','2014-01-08','11:50:00',1.98),('9303','2014-01-08','11:55:00',1.95),('9303','2014-01-08','12:00:00',1.97),('9303','2014-01-08','12:05:00',1.9),('9303','2014-01-08','12:10:00',1.96),('9303','2014-01-08','12:15:00',1.95),('9303','2014-01-08','12:20:00',1.98),('9303','2014-01-08','12:25:00',2.05),('9303','2014-01-08','12:30:00',2.05),('9303','2014-01-08','12:35:00',2.04),('9303','2014-01-08','12:40:00',2.02),('9303','2014-01-08','12:45:00',1.96),('9303','2014-01-08','12:50:00',1.91),('9303','2014-01-08','12:55:00',1.98),('9303','2014-01-08','13:00:00',1.94),('9303','2014-01-08','13:05:00',1.94),('9303','2014-01-08','13:10:00',1.87),('9303','2014-01-08','13:15:00',1.88),('9303','2014-01-08','13:20:00',1.79),('9303','2014-01-08','13:25:00',1.8),('9303','2014-01-08','13:30:00',1.74),('9303','2014-01-08','13:35:00',1.72),('9303','2014-01-08','13:40:00',1.72),('9303','2014-01-08','13:45:00',1.64),('9303','2014-01-08','13:50:00',1.59),('9303','2014-01-08','13:55:00',1.58),('9303','2014-01-08','14:00:00',1.54),('9303','2014-01-08','14:05:00',1.54),('9303','2014-01-08','14:10:00',1.49),('9303','2014-01-08','14:15:00',1.46),('9303','2014-01-08','14:20:00',1.46),('9303','2014-01-08','14:25:00',1.42),('9303','2014-01-08','14:30:00',1.45),('9303','2014-01-08','14:35:00',1.42),('9303','2014-01-08','14:40:00',1.31),('9303','2014-01-08','14:45:00',1.25),('9303','2014-01-08','14:50:00',1.21),('9303','2014-01-08','14:55:00',1.04),('9303','2014-01-07','09:40:00',1.07),('9303','2014-01-07','09:45:00',1.16),('9303','2014-01-07','09:50:00',1.27),('9303','2014-01-07','09:55:00',1.35),('9303','2014-01-07','10:00:00',1.36),('9303','2014-01-07','10:05:00',1.38),('9303','2014-01-07','10:10:00',1.44),('9303','2014-01-07','10:15:00',1.5),('9303','2014-01-07','10:20:00',1.53),('9303','2014-01-07','10:25:00',1.59),('9303','2014-01-07','10:30:00',1.63),('9303','2014-01-07','10:35:00',1.64),('9303','2014-01-07','10:40:00',1.67),('9303','2014-01-07','10:45:00',1.7),('9303','2014-01-07','10:50:00',1.76),('9303','2014-01-07','10:55:00',1.74),('9303','2014-01-07','11:00:00',1.8),('9303','2014-01-07','11:05:00',1.82),('9303','2014-01-07','11:10:00',1.87),('9303','2014-01-07','11:15:00',1.87),('9303','2014-01-07','11:20:00',1.89),('9303','2014-01-07','11:25:00',1.94),('9303','2014-01-07','11:30:00',1.95),('9303','2014-01-07','11:35:00',2),('9303','2014-01-07','11:40:00',1.98),('9303','2014-01-07','11:45:00',1.99),('9303','2014-01-07','11:50:00',2.01),('9303','2014-01-07','11:55:00',2.01),('9303','2014-01-07','12:00:00',2.04),('9303','2014-01-07','12:05:00',2.03),('9303','2014-01-07','12:10:00',2.08),('9303','2014-01-07','12:15:00',2.05),('9303','2014-01-07','12:20:00',2.08),('9303','2014-01-07','12:25:00',2.09),('9303','2014-01-07','12:30:00',2.1),('9303','2014-01-07','12:35:00',2.08),('9303','2014-01-07','12:40:00',2.07),('9303','2014-01-07','12:45:00',2.15),('9303','2014-01-07','12:50:00',2.11),('9303','2014-01-07','12:55:00',2.03),('9303','2014-01-07','13:00:00',1.96),('9303','2014-01-07','13:05:00',1.96),('9303','2014-01-07','13:10:00',1.92),('9303','2014-01-07','13:15:00',1.9),('9303','2014-01-07','13:20:00',1.83),('9303','2014-01-07','13:25:00',1.79),('9303','2014-01-07','13:30:00',1.73),('9303','2014-01-07','13:35:00',1.69),('9303','2014-01-07','13:40:00',1.71),('9303','2014-01-07','13:45:00',1.73),('9303','2014-01-07','13:50:00',1.74),('9303','2014-01-07','13:55:00',1.69),('9303','2014-01-07','14:00:00',1.68),('9303','2014-01-07','14:05:00',1.57),('9303','2014-01-07','14:10:00',1.5),('9303','2014-01-07','14:15:00',1.48),('9303','2014-01-07','14:20:00',1.48),('9303','2014-01-07','14:25:00',1.42),('9303','2014-01-07','14:30:00',1.37),('9303','2014-01-07','14:35:00',1.35),('9303','2014-01-07','14:40:00',1.36),('9303','2014-01-07','14:45:00',1.27),('9303','2014-01-07','14:50:00',1.26),('9303','2014-01-07','14:55:00',1.23),('9303','2014-01-07','15:00:00',1.14),('9303','2014-01-07','15:05:00',1.08),('9303','2014-04-24','08:05:00',1.1),('9303','2014-04-24','08:10:00',1.18),('9303','2014-04-24','08:15:00',1.28),('9303','2014-04-24','08:20:00',1.39),('9303','2014-04-24','08:25:00',1.49),('9303','2014-04-24','08:30:00',1.59),('9303','2014-04-24','08:35:00',1.69),('9303','2014-04-24','08:40:00',1.78),('9303','2014-04-24','08:45:00',1.87),('9303','2014-04-24','08:50:00',1.94),('9303','2014-04-24','08:55:00',2.02),('9303','2014-04-24','09:00:00',2.1),('9303','2014-04-24','09:05:00',2.19),('9303','2014-04-24','09:10:00',2.26),('9303','2014-04-24','09:15:00',2.32),('9303','2014-04-24','09:20:00',2.4),('9303','2014-04-24','09:25:00',2.48),('9303','2014-04-24','09:30:00',2.54),('9303','2014-04-24','09:35:00',2.63),('9303','2014-04-24','09:40:00',2.71),('9303','2014-04-24','09:45:00',2.78),('9303','2014-04-24','09:50:00',2.83),('9303','2014-04-24','09:55:00',2.88),('9303','2014-04-24','10:00:00',2.96),('9303','2014-04-24','10:05:00',3.02),('9303','2014-04-24','10:10:00',3.07),('9303','2014-04-24','10:15:00',3.12),('9303','2014-04-24','10:20:00',3.13),('9303','2014-04-24','10:25:00',3.17),('9303','2014-04-24','10:30:00',3.23),('9303','2014-04-24','10:35:00',3.3),('9303','2014-04-24','10:40:00',3.37),('9303','2014-04-24','10:45:00',3.4),('9303','2014-04-24','10:50:00',3.44),('9303','2014-04-24','10:55:00',3.49),('9303','2014-04-24','11:00:00',3.57),('9303','2014-04-24','11:05:00',3.58),('9303','2014-04-24','11:10:00',3.56),('9303','2014-04-24','11:15:00',3.59),('9303','2014-04-24','11:20:00',3.62),('9303','2014-04-24','11:25:00',3.63),('9303','2014-04-24','11:30:00',3.66),('9303','2014-04-24','11:35:00',3.68),('9303','2014-04-24','11:40:00',3.67),('9303','2014-04-24','11:45:00',3.74),('9303','2014-04-24','11:50:00',3.8),('9303','2014-04-24','11:55:00',3.8),('9303','2014-04-24','12:00:00',3.82),('9303','2014-04-24','12:05:00',3.91),('9303','2014-04-24','12:10:00',3.99),('9303','2014-04-24','12:15:00',4.06),('9303','2014-04-24','12:20:00',4.03),('9303','2014-04-24','12:25:00',3.95),('9303','2014-04-24','12:30:00',4.04),('9303','2014-04-24','12:35:00',3.98),('9303','2014-04-24','12:40:00',3.92),('9303','2014-04-24','12:45:00',4.1),('9303','2014-04-24','12:50:00',4.14),('9303','2014-04-24','12:55:00',4.08),('9303','2014-04-24','13:00:00',4.01),('9303','2014-04-24','13:05:00',4.14),('9303','2014-04-24','13:10:00',4.17),('9303','2014-04-24','13:15:00',4.25),('9303','2014-04-24','13:20:00',4.24),('9303','2014-04-24','13:25:00',4.13),('9303','2014-04-24','13:30:00',4.16),('9303','2014-04-24','13:35:00',3.4),('9303','2014-04-24','13:40:00',1.2),('9303','2014-04-24','13:45:00',4.13),('9303','2014-04-24','13:50:00',4.59),('9303','2014-04-24','13:55:00',3.32),('9303','2014-04-24','14:00:00',1.56),('9303','2014-04-24','14:05:00',3.25),('9303','2014-04-24','14:10:00',3.91),('9303','2014-04-24','14:15:00',3.17),('9303','2014-04-24','14:20:00',3.4),('9303','2014-04-24','14:25:00',3.37),('9303','2014-04-24','14:30:00',4.43),('9303','2014-04-24','14:35:00',4.25),('9303','2014-04-24','14:40:00',3.31),('9303','2014-04-24','14:45:00',2.32),('9303','2014-04-24','14:50:00',1.5),('9303','2014-04-24','14:55:00',3.94),('9303','2014-04-24','15:00:00',4.52),('9303','2014-04-24','15:05:00',4.42),('9303','2014-04-24','15:10:00',3.86),('9303','2014-04-24','15:15:00',3.83),('9303','2014-04-24','15:20:00',2.35),('9303','2014-04-24','15:25:00',2.03),('9303','2014-04-24','15:30:00',3.03),('9303','2014-04-24','15:35:00',2.48),('9303','2014-04-24','15:40:00',2.03),('9303','2014-04-24','15:45:00',1.94),('9303','2014-04-24','15:50:00',2.2),('9303','2014-04-24','15:55:00',2.52),('9303','2014-04-24','16:00:00',3.78),('9303','2014-04-24','16:05:00',3.49),('9303','2014-04-24','16:10:00',2.64),('9303','2014-04-24','16:15:00',3.35),('9303','2014-04-24','16:20:00',2.86),('9303','2014-04-24','16:25:00',2.79),('9303','2014-04-24','16:30:00',3.23),('9303','2014-04-24','16:35:00',1.73),('9303','2014-04-24','16:40:00',1.83),('9303','2014-04-24','16:45:00',1.92),('9303','2014-04-24','16:50:00',1.41),('9303','2014-04-24','16:55:00',1.43),('9303','2014-04-24','17:00:00',1.31),('9303','2014-04-24','17:05:00',1.17),('9303','2014-04-24','17:10:00',1.1),('9303','2014-04-24','17:15:00',1),('9303','2014-01-06','11:35:00',1.02),('9303','2014-01-06','11:40:00',1.84),('9303','2014-01-06','11:45:00',2.02),('9303','2014-01-06','11:50:00',2.1),('9303','2014-01-06','11:55:00',2.04),('9303','2014-01-06','12:00:00',2.12),('9303','2014-01-06','12:05:00',2.07),('9303','2014-01-06','12:10:00',2.03),('9303','2014-01-06','12:15:00',1.99),('9303','2014-01-06','12:20:00',2.04),('9303','2014-01-06','12:25:00',2.08),('9303','2014-01-06','12:30:00',2.09),('9303','2014-01-06','12:35:00',2.1),('9303','2014-01-06','12:40:00',2.13),('9303','2014-01-06','12:45:00',2.18),('9303','2014-01-06','12:50:00',2.16),('9303','2014-01-06','12:55:00',2.11),('9303','2014-01-06','13:00:00',2.08),('9303','2014-01-06','13:05:00',2.03),('9303','2014-01-06','13:10:00',2.03),('9303','2014-01-06','13:15:00',2.04),('9303','2014-01-06','13:20:00',2.01),('9303','2014-01-06','13:25:00',2.01),('9303','2014-01-06','13:30:00',1.85),('9303','2014-01-06','13:35:00',1.83),('9303','2014-01-06','13:40:00',1.78),('9303','2014-01-06','13:45:00',1.69),('9303','2014-01-06','13:50:00',1.71),('9303','2014-01-06','13:55:00',1.67),('9303','2014-01-06','14:00:00',1.22),('9303','2014-01-06','14:15:00',1.1),('9303','2014-01-06','14:20:00',1.68),('9303','2014-01-06','14:35:00',1.02),('9303','2014-01-06','14:40:00',1.52),('9303','2014-01-06','14:45:00',1.71),('9303','2014-01-06','14:50:00',1.4),('9303','2014-01-06','15:05:00',1),('9303','2014-01-03','09:40:00',1.24),('9303','2014-01-03','09:45:00',1.18),('9303','2014-01-03','10:00:00',1.23),('9303','2014-01-03','10:05:00',1.29),('9303','2014-01-03','10:20:00',1.41),('9303','2014-01-03','10:45:00',1.17),('9303','2014-01-03','10:50:00',1.14),('9303','2014-01-03','11:45:00',1.08),('9303','2014-01-03','11:50:00',1.04),('9303','2014-01-03','11:55:00',1.04),('9303','2014-01-03','12:00:00',1.14),('9303','2014-01-03','12:05:00',1.58),('9303','2014-01-03','12:10:00',1.65),('9303','2014-01-03','12:15:00',1.28),('9303','2014-01-03','12:20:00',1.62),('9303','2014-01-03','12:25:00',1.05),('9303','2014-01-03','12:30:00',1.2),('9303','2014-01-03','12:35:00',1.46),('9303','2014-01-03','12:40:00',1.61),('9303','2014-01-03','12:45:00',1.64),('9303','2014-01-03','12:50:00',1.26),('9303','2014-01-03','12:55:00',1.94),('9303','2014-01-03','13:00:00',1.16),('9303','2014-01-03','13:05:00',1.2),('9303','2014-01-03','13:10:00',1.81),('9303','2014-01-03','13:15:00',1.1),('9303','2014-01-03','13:30:00',1.05),('9303','2014-01-03','13:35:00',1.32),('9303','2014-01-03','13:40:00',1.36),('9303','2014-01-03','13:45:00',1.19),('9303','2014-01-02','09:45:00',1.09),('9303','2014-01-02','09:50:00',1.19),('9303','2014-01-02','09:55:00',1.26),('9303','2014-01-02','10:00:00',1.33),('9303','2014-01-02','10:05:00',1.37),('9303','2014-01-02','10:10:00',1.43),('9303','2014-01-02','10:15:00',1.48),('9303','2014-01-02','10:20:00',1.51),('9303','2014-01-02','10:25:00',1.54),('9303','2014-01-02','10:30:00',1.56),('9303','2014-01-02','10:35:00',1.53),('9303','2014-01-02','10:40:00',1.55),('9303','2014-01-02','10:45:00',1.59),('9303','2014-01-02','10:50:00',1.66),('9303','2014-01-02','10:55:00',1.7),('9303','2014-01-02','11:00:00',1.77),('9303','2014-01-02','11:05:00',1.81),('9303','2014-01-02','11:10:00',1.39),('9303','2014-01-02','11:15:00',1.17),('9303','2014-01-02','11:20:00',1.03),('9303','2014-01-02','11:25:00',1.27),('9303','2014-01-02','11:30:00',1.45),('9303','2014-01-02','11:35:00',1.51),('9303','2014-01-02','11:40:00',1.48),('9303','2014-01-02','11:45:00',1.46),('9303','2014-01-02','11:50:00',1.27),('9303','2014-01-02','11:55:00',1.13),('9303','2014-01-02','12:00:00',1.05),('9303','2014-01-02','12:05:00',1.11),('9303','2014-01-02','12:10:00',1.12),('9303','2014-01-02','12:50:00',1.65),('9303','2014-01-02','12:55:00',2.12),('9303','2014-01-02','13:35:00',1.05),('9303','2014-01-02','13:40:00',1.7),('9303','2014-01-02','13:45:00',1.1),('9303','2014-01-01','09:45:00',1.12),('9303','2014-01-01','09:50:00',1.45),('9303','2014-01-01','09:55:00',1.14),('9303','2014-01-01','10:00:00',1.02),('9303','2014-01-01','12:10:00',1.05),('9303','2014-01-01','12:15:00',1.09),('9303','2014-01-01','12:20:00',1.12),('9303','2014-01-01','12:25:00',1.13),('9303','2014-01-01','12:30:00',1.19),('9303','2014-01-01','12:35:00',1.23),('9303','2014-01-01','12:40:00',1.08),('9303','2014-01-01','12:45:00',1.05),('9303','2014-01-01','12:50:00',1.1),('9303','2014-01-01','12:55:00',1.08),('9303','2014-01-01','13:00:00',1.1),('9303','2014-01-01','13:25:00',1.06),('9303','2014-01-01','13:30:00',1.42),('9303','2014-01-01','13:35:00',2.49),('9303','2014-01-01','13:40:00',1.91),('9303','2014-01-01','13:45:00',1.08),('9303','2014-01-01','13:50:00',1.07),('9303','2014-01-01','13:55:00',1.11),('9303','2014-01-01','14:00:00',1.51),('9303','2014-01-01','14:15:00',1.07),('9303','2014-01-01','15:10:00',1.12),('9303','2013-12-31','09:50:00',1.43),('9303','2013-12-31','10:50:00',1.03),('9303','2013-12-31','10:55:00',1.18),('9303','2013-12-31','11:05:00',1.11),('9303','2013-12-31','11:10:00',1.65),('9303','2013-12-31','11:15:00',2.05),('9303','2013-12-31','11:20:00',1.42),('9303','2013-12-31','11:25:00',1.21),('9303','2013-12-31','11:30:00',1.7),('9303','2013-12-31','11:40:00',1.64),('9303','2013-12-31','11:50:00',1.16),('9303','2013-12-31','11:55:00',1.7),('9303','2013-12-31','12:00:00',2.12),('9303','2013-12-31','12:05:00',2.1),('9303','2013-12-31','12:10:00',2.05),('9303','2013-12-31','12:15:00',2.09),('9303','2013-12-31','12:20:00',2.1),('9303','2013-12-31','12:25:00',2.13),('9303','2013-12-31','12:30:00',2.14),('9303','2013-12-31','12:35:00',2.12),('9303','2013-12-31','12:40:00',2.18),('9303','2013-12-31','12:45:00',2.17),('9303','2013-12-31','12:50:00',2.13),('9303','2013-12-31','12:55:00',2.1),('9303','2013-12-31','13:00:00',2.07),('9303','2013-12-31','13:05:00',2.02),('9303','2013-12-31','13:10:00',1.96),('9303','2013-12-31','13:15:00',1.92),('9303','2013-12-31','13:20:00',1.9),('9303','2013-12-31','13:25:00',1.89),('9303','2013-12-31','13:30:00',1.86),('9303','2013-12-31','13:35:00',1.84),('9303','2013-12-31','13:40:00',1.78),('9303','2013-12-31','13:45:00',1.74),('9303','2013-12-31','13:50:00',1.7),('9303','2013-12-31','13:55:00',1.64),('9303','2013-12-31','14:00:00',1.59),('9303','2013-12-31','14:05:00',1.56),('9303','2013-12-31','14:10:00',1.51),('9303','2013-12-31','14:15:00',1.47),('9303','2013-12-31','14:20:00',1.44),('9303','2013-12-31','14:25:00',1.4),('9303','2013-12-31','14:30:00',1.36),('9303','2013-12-31','14:35:00',1.32),('9303','2013-12-31','14:40:00',1.28),('9303','2013-12-31','14:45:00',1.21),('9303','2013-12-31','14:50:00',1.15),('9303','2013-12-31','14:55:00',1.08),('9303','2013-12-29','09:45:00',1.14),('9303','2013-12-29','09:50:00',1.15),('9303','2013-12-29','10:00:00',1.11),('9303','2013-12-29','10:05:00',1.29),('9303','2013-12-29','10:10:00',1.16),('9303','2013-12-29','10:15:00',1.55),('9303','2013-12-29','10:20:00',1.69),('9303','2013-12-29','10:25:00',1.5),('9303','2013-12-29','10:30:00',1.9),('9303','2013-12-29','10:35:00',1.99),('9303','2013-12-29','10:40:00',1.93),('9303','2013-12-29','10:45:00',1.1),('9303','2013-12-29','11:00:00',1.02),('9303','2013-12-28','09:45:00',1.12),('9303','2013-12-28','09:50:00',1.23),('9303','2013-12-28','09:55:00',1.31),('9303','2013-12-28','10:00:00',1.38),('9303','2013-12-28','10:05:00',1.43),('9303','2013-12-28','10:10:00',1.49),('9303','2013-12-28','10:15:00',1.49),('9303','2013-12-28','10:20:00',1.55),('9303','2013-12-28','10:25:00',1.57),('9303','2013-12-28','10:30:00',1.58),('9303','2013-12-28','10:35:00',1.6),('9303','2013-12-28','10:40:00',1.61),('9303','2013-12-28','10:45:00',1.68),('9303','2013-12-28','10:50:00',1.69),('9303','2013-12-28','10:55:00',1.79),('9303','2013-12-28','11:00:00',1.81),('9303','2013-12-28','11:05:00',1.85),('9303','2013-12-28','11:10:00',1.85),('9303','2013-12-28','11:15:00',1.86),('9303','2013-12-28','11:20:00',1.92),('9303','2013-12-28','11:25:00',1.93),('9303','2013-12-28','11:30:00',1.96),('9303','2013-12-28','11:35:00',1.98),('9303','2013-12-28','11:40:00',1.97),('9303','2013-12-28','11:45:00',2),('9303','2013-12-28','11:50:00',2),('9303','2013-12-28','11:55:00',2.01),('9303','2013-12-28','12:00:00',1.97),('9303','2013-12-28','12:05:00',2.01),('9303','2013-12-28','12:10:00',1.98),('9303','2013-12-28','12:15:00',2.04),('9303','2013-12-28','12:20:00',2.06),('9303','2013-12-28','12:25:00',2.07),('9303','2013-12-28','12:30:00',2.05),('9303','2013-12-28','12:35:00',2.08),('9303','2013-12-28','12:40:00',2.09),('9303','2013-12-28','12:45:00',2.05),('9303','2013-12-28','12:50:00',2.03),('9303','2013-12-28','12:55:00',1.98),('9303','2013-12-28','13:00:00',1.94),('9303','2013-12-28','13:05:00',1.9),('9303','2013-12-28','13:10:00',1.86),('9303','2013-12-28','13:15:00',1.82),('9303','2013-12-28','13:20:00',1.81),('9303','2013-12-28','13:25:00',1.73),('9303','2013-12-28','13:30:00',1.72),('9303','2013-12-28','13:35:00',1.69),('9303','2013-12-28','13:40:00',1.64),('9303','2013-12-28','13:45:00',1.6),('9303','2013-12-28','13:50:00',1.56),('9303','2013-12-28','13:55:00',1.52),('9303','2013-12-28','14:00:00',1.48),('9303','2013-12-28','14:05:00',1.29),('9303','2013-12-28','14:15:00',1.34),('9303','2013-12-28','14:20:00',1.3),('9303','2013-12-28','14:25:00',1.28),('9303','2013-12-28','14:30:00',1.22),('9303','2013-12-28','14:35:00',1.19),('9303','2013-12-28','14:40:00',1.15),('9303','2013-12-28','14:45:00',1),('9303','2014-04-23','13:15:00',1.08),('9303','2014-04-23','13:20:00',1.13),('9303','2014-04-23','13:25:00',1.21),('9303','2014-04-23','13:30:00',1.3),('9303','2014-04-23','13:35:00',1.37),('9303','2014-04-23','13:40:00',1.46),('9303','2014-04-23','13:45:00',1.51),('9303','2014-04-23','13:50:00',1.49),('9303','2014-04-23','13:55:00',1.47),('9303','2014-04-23','14:00:00',1.38),('9303','2014-04-23','14:05:00',1.4),('9303','2014-04-23','14:10:00',1.32),('9303','2014-04-23','14:15:00',1.11),('9303','2014-04-23','14:45:00',1.06),('9303','2014-04-23','14:50:00',1.3),('9303','2014-04-23','14:55:00',1.5),('9303','2014-04-23','15:00:00',1.63),('9303','2014-04-23','15:05:00',1.65),('9303','2014-04-23','15:10:00',1.62),('9303','2014-04-23','15:15:00',1.61),('9303','2014-04-23','15:20:00',1.37),('9303','2014-04-23','15:25:00',1.3),('9303','2014-04-23','15:30:00',1.29),('9303','2014-04-23','15:35:00',1.22),('9303','2014-04-23','15:40:00',1.2),('9303','2014-04-23','15:45:00',1.19),('9303','2013-12-27','12:10:00',1.39),('9303','2013-12-27','12:15:00',1.91),('9303','2013-12-27','12:20:00',1.51),('9303','2013-12-27','12:25:00',1.29),('9303','2013-12-27','12:35:00',1.07),('9303','2013-12-27','12:40:00',1.35),('9303','2013-12-27','12:45:00',1.71),('9303','2013-12-27','12:50:00',1.96),('9303','2013-12-27','12:55:00',2),('9303','2013-12-27','13:00:00',1.98),('9303','2013-12-27','13:05:00',1.78),('9303','2013-12-27','13:10:00',1.08),('9303','2013-12-27','13:15:00',1.11),('9303','2013-12-27','13:20:00',1.19),('9303','2013-12-27','13:25:00',1.24),('9303','2013-12-27','13:30:00',1.94),('9303','2013-12-27','13:35:00',1.93),('9303','2013-12-27','13:40:00',1.3),('9303','2013-12-27','13:45:00',1.22),('9303','2013-12-27','13:50:00',1.03),('9303','2013-12-27','14:15:00',1.03),('9303','2013-12-27','14:20:00',1.03),('9303','2013-12-27','14:30:00',1.02),('9303','2013-12-27','14:35:00',1.09),('9303','2013-12-27','14:40:00',1.11),('9303','2013-12-25','10:30:00',1.31),('9303','2013-12-25','10:35:00',1.42),('9303','2013-12-25','10:40:00',1.31),('9303','2013-12-25','10:45:00',1.28),('9303','2013-12-25','10:50:00',1.33),('9303','2013-12-25','11:15:00',1.28),('9303','2013-12-25','11:20:00',1.45),('9303','2013-12-25','11:25:00',1.16),('9303','2013-12-25','11:30:00',1.35),('9303','2013-12-25','11:40:00',1.48),('9303','2013-12-25','11:45:00',1.66),('9303','2013-12-25','11:50:00',1.01),('9303','2013-12-25','11:55:00',1.77),('9303','2013-12-25','12:00:00',1.51),('9303','2013-12-25','12:15:00',1.05),('9303','2013-12-25','12:20:00',1.38),('9303','2013-12-25','12:25:00',1.62),('9303','2013-12-24','09:45:00',1.08),('9303','2013-12-24','09:50:00',1.17),('9303','2013-12-24','09:55:00',1.23),('9303','2013-12-24','10:00:00',1.25),('9303','2013-12-24','10:05:00',1.32),('9303','2013-12-24','10:10:00',1.4),('9303','2013-12-24','10:15:00',1.4),('9303','2013-12-24','10:20:00',1.43),('9303','2013-12-24','10:25:00',1.43),('9303','2013-12-24','10:30:00',1.44),('9303','2013-12-24','10:35:00',1.46),('9303','2013-12-24','10:40:00',1.5),('9303','2013-12-24','10:45:00',1.49),('9303','2013-12-24','10:50:00',1.56),('9303','2013-12-24','10:55:00',1.63),('9303','2013-12-24','11:00:00',1.65),('9303','2013-12-24','11:05:00',1.68),('9303','2013-12-24','11:10:00',1.66),('9303','2013-12-24','11:15:00',1.68),('9303','2013-12-24','11:20:00',1.74),('9303','2013-12-24','11:25:00',1.76),('9303','2013-12-24','11:30:00',1.8),('9303','2013-12-24','11:35:00',1.79),('9303','2013-12-24','11:40:00',1.81),('9303','2013-12-24','11:45:00',1.84),('9303','2013-12-24','11:50:00',1.83),('9303','2013-12-24','11:55:00',1.81),('9303','2013-12-24','12:00:00',1.8),('9303','2013-12-24','12:05:00',1.77),('9303','2013-12-24','12:10:00',1.76),('9303','2013-12-24','12:15:00',1.81),('9303','2013-12-24','12:20:00',1.84),('9303','2013-12-24','12:25:00',1.86),('9303','2013-12-24','12:30:00',1.83),('9303','2013-12-24','12:35:00',1.87),('9303','2013-12-24','12:40:00',1.85),('9303','2013-12-24','12:45:00',1.83),('9303','2013-12-24','12:50:00',1.81),('9303','2013-12-24','12:55:00',1.75),('9303','2013-12-24','13:00:00',1.72),('9303','2013-12-24','13:05:00',1.66),('9303','2013-12-24','13:10:00',1.65),('9303','2013-12-24','13:15:00',1.62),('9303','2013-12-24','13:20:00',1.59),('9303','2013-12-24','13:25:00',1.55),('9303','2013-12-24','13:30:00',1.54),('9303','2013-12-24','13:35:00',1.5),('9303','2013-12-24','13:40:00',1.45),('9303','2013-12-24','13:45:00',1.4),('9303','2013-12-24','13:50:00',1.35),('9303','2013-12-24','13:55:00',1.3),('9303','2013-12-24','14:00:00',1.27),('9303','2013-12-24','14:05:00',1.25),('9303','2013-12-24','14:10:00',1.23),('9303','2013-12-24','14:15:00',1.21),('9303','2013-12-24','14:20:00',1.15),('9303','2013-12-24','14:25:00',1.07),('9303','2013-12-24','14:30:00',1.01),('9303','2013-12-23','09:55:00',1.17),('9303','2013-12-23','10:00:00',1.41),('9303','2013-12-23','10:05:00',1.57),('9303','2013-12-23','10:10:00',1.58),('9303','2013-12-23','10:15:00',1.51),('9303','2013-12-23','10:20:00',1.58),('9303','2013-12-23','10:25:00',1.51),('9303','2013-12-23','10:30:00',1.37),('9303','2013-12-23','10:35:00',1.38),('9303','2013-12-23','10:40:00',1.42),('9303','2013-12-23','10:45:00',1.44),('9303','2013-12-23','10:50:00',1.49),('9303','2013-12-23','10:55:00',1.59),('9303','2013-12-23','11:00:00',1.84),('9303','2013-12-23','11:05:00',1.92),('9303','2013-12-23','11:10:00',1.92),('9303','2013-12-23','11:15:00',1.94),('9303','2013-12-23','11:20:00',1.89),('9303','2013-12-23','11:25:00',1.91),('9303','2013-12-23','11:30:00',1.88),('9303','2013-12-23','11:35:00',1.94),('9303','2013-12-23','11:40:00',1.9),('9303','2013-12-23','11:45:00',1.67),('9303','2013-12-23','11:50:00',1.79),('9303','2013-12-23','11:55:00',1.81),('9303','2013-12-23','12:00:00',1.86),('9303','2013-12-23','12:05:00',1.86),('9303','2013-12-23','12:10:00',1.88),('9303','2013-12-23','12:15:00',1.91),('9303','2013-12-23','12:20:00',1.91),('9303','2013-12-23','12:25:00',1.89),('9303','2013-12-23','12:30:00',1.99),('9303','2013-12-23','12:35:00',2.07),('9303','2013-12-23','12:40:00',2.05),('9303','2013-12-23','12:45:00',2.03),('9303','2013-12-23','12:50:00',1.99),('9303','2013-12-23','12:55:00',1.97),('9303','2013-12-23','13:00:00',1.94),('9303','2013-12-23','13:05:00',1.89),('9303','2013-12-23','13:10:00',1.83),('9303','2013-12-23','13:15:00',1.8),('9303','2013-12-23','13:20:00',1.64),('9303','2013-12-23','13:25:00',1.46),('9303','2013-12-23','13:30:00',1.65),('9303','2013-12-23','13:40:00',1.25),('9303','2013-12-23','13:45:00',1.02),('9303','2013-12-23','13:50:00',1.13),('9303','2013-12-23','13:55:00',1.3),('9303','2013-12-23','14:00:00',1.5),('9303','2013-12-23','14:05:00',1.45),('9303','2013-12-23','14:10:00',1.4),('9303','2013-12-23','14:15:00',1.37),('9303','2013-12-23','14:20:00',1.32),('9303','2013-12-23','14:25:00',1.25),('9303','2013-12-23','14:30:00',1.14),('9303','2013-12-23','14:35:00',1.18),('9303','2013-12-23','14:40:00',1.1),('9303','2013-12-23','14:45:00',1.02),('9303','2013-12-22','09:40:00',1.3),('9303','2013-12-22','09:45:00',1.55),('9303','2013-12-22','09:50:00',1.65),('9303','2013-12-22','09:55:00',1.64),('9303','2013-12-22','10:00:00',1.68),('9303','2013-12-22','10:05:00',1.69),('9303','2013-12-22','10:10:00',1.72),('9303','2013-12-22','10:15:00',1.71),('9303','2013-12-22','10:20:00',1.65),('9303','2013-12-22','10:25:00',1.62),('9303','2013-12-22','10:30:00',1.63),('9303','2013-12-22','10:35:00',1.55),('9303','2013-12-22','10:40:00',1.5),('9303','2013-12-22','10:45:00',1.58),('9303','2013-12-22','10:50:00',1.69),('9303','2013-12-22','10:55:00',1.6),('9303','2013-12-22','11:00:00',1.47),('9303','2013-12-22','11:05:00',1.43),('9303','2013-12-22','11:10:00',1.88),('9303','2013-12-22','11:15:00',1.86),('9303','2013-12-22','11:20:00',1.71),('9303','2013-12-22','11:25:00',1.74),('9303','2013-12-22','11:30:00',1.65),('9303','2013-12-22','11:35:00',1.64),('9303','2013-12-22','11:40:00',1.78),('9303','2013-12-22','11:45:00',1.69),('9303','2013-12-22','11:50:00',1.26),('9303','2013-12-22','12:20:00',1.01),('9303','2013-12-22','12:25:00',1.11),('9303','2013-12-22','12:30:00',1.33),('9303','2013-12-22','12:35:00',1.54),('9303','2013-12-22','12:40:00',1.53),('9303','2013-12-22','12:45:00',1.44),('9303','2013-12-22','12:50:00',1.72),('9303','2013-12-22','12:55:00',2.07),('9303','2013-12-22','13:00:00',2),('9303','2013-12-22','13:05:00',2.33),('9303','2013-12-22','13:10:00',2.34),('9303','2013-12-22','13:15:00',1.8),('9303','2013-12-22','13:20:00',1.73),('9303','2013-12-22','13:25:00',1.72),('9303','2013-12-22','13:30:00',1.58),('9303','2013-12-22','13:35:00',1.48),('9303','2013-12-22','13:40:00',1.2),('9303','2013-12-22','13:45:00',1.34),('9303','2013-12-22','13:50:00',1.29),('9303','2013-12-22','13:55:00',1.14),('9303','2013-12-22','14:00:00',1.06),('9303','2013-12-22','14:05:00',1.13),('9303','2013-12-22','14:10:00',1.29),('9303','2013-12-22','14:40:00',1.05),('9303','2013-12-22','14:45:00',1),('9303','2013-12-21','09:45:00',1.11),('9303','2013-12-21','09:50:00',1.18),('9303','2013-12-21','09:55:00',1.27),('9303','2013-12-21','10:00:00',1.34),('9303','2013-12-21','10:05:00',1.4),('9303','2013-12-21','10:10:00',1.42),('9303','2013-12-21','10:15:00',1.45),('9303','2013-12-21','10:20:00',1.47),('9303','2013-12-21','10:25:00',1.47),('9303','2013-12-21','10:30:00',1.49),('9303','2013-12-21','10:35:00',1.51),('9303','2013-12-21','10:40:00',1.57),('9303','2013-12-21','10:45:00',1.55),('9303','2013-12-21','10:50:00',1.63),('9303','2013-12-21','10:55:00',1.7),('9303','2013-12-21','11:00:00',1.75),('9303','2013-12-21','11:05:00',1.77),('9303','2013-12-21','11:10:00',1.78),('9303','2013-12-21','11:15:00',1.82),('9303','2013-12-21','11:20:00',1.87),('9303','2013-12-21','11:25:00',1.89),('9303','2013-12-21','11:30:00',1.93),('9303','2013-12-21','11:35:00',1.91),('9303','2013-12-21','11:40:00',1.96),('9303','2013-12-21','11:45:00',1.97),('9303','2013-12-21','11:50:00',1.97),('9303','2013-12-21','11:55:00',1.97),('9303','2013-12-21','12:00:00',1.99),('9303','2013-12-21','12:05:00',1.97),('9303','2013-12-21','12:10:00',1.99),('9303','2013-12-21','12:15:00',2.02),('9303','2013-12-21','12:20:00',2.04),('9303','2013-12-21','12:25:00',2.06),('9303','2013-12-21','12:30:00',2.06),('9303','2013-12-21','12:35:00',2.12),('9303','2013-12-21','12:40:00',2.1),('9303','2013-12-21','12:45:00',2.07),('9303','2013-12-21','12:50:00',2.04),('9303','2013-12-21','12:55:00',2.01),('9303','2013-12-21','13:00:00',1.95),('9303','2013-12-21','13:05:00',1.89),('9303','2013-12-21','13:10:00',1.86),('9303','2013-12-21','13:15:00',1.85),('9303','2013-12-21','13:20:00',1.81),('9303','2013-12-21','13:25:00',1.76),('9303','2013-12-21','13:30:00',1.74),('9303','2013-12-21','13:35:00',1.68),('9303','2013-12-21','13:40:00',1.64),('9303','2013-12-21','13:45:00',1.61),('9303','2013-12-21','13:50:00',1.55),('9303','2013-12-21','13:55:00',1.52),('9303','2013-12-21','14:00:00',1.48),('9303','2013-12-21','14:05:00',1.42),('9303','2013-12-21','14:10:00',1.38),('9303','2013-12-21','14:15:00',1.38),('9303','2013-12-21','14:20:00',1.35),('9303','2013-12-21','14:25:00',1.28),('9303','2013-12-21','14:30:00',1.25),('9303','2013-12-21','14:35:00',1.2),('9303','2013-12-21','14:40:00',1.15),('9303','2013-12-21','14:45:00',1.08),('9303','2013-12-20','09:45:00',1.08),('9303','2013-12-20','09:50:00',1.15),('9303','2013-12-20','09:55:00',1.21),('9303','2013-12-20','10:00:00',1.27),('9303','2013-12-20','10:05:00',1.35),('9303','2013-12-20','10:10:00',1.36),('9303','2013-12-20','10:15:00',1.38),('9303','2013-12-20','10:20:00',1.4),('9303','2013-12-20','10:25:00',1.41),('9303','2013-12-20','10:30:00',1.39),('9303','2013-12-20','10:35:00',1.42),('9303','2013-12-20','10:40:00',1.49),('9303','2013-12-20','10:45:00',1.5),('9303','2013-12-20','10:50:00',1.58),('9303','2013-12-20','10:55:00',1.64),('9303','2013-12-20','11:00:00',1.67),('9303','2013-12-20','11:05:00',1.69),('9303','2013-12-20','11:10:00',1.7),('9303','2013-12-20','11:15:00',1.73),('9303','2013-12-20','11:20:00',1.76),('9303','2013-12-20','11:25:00',1.77),('9303','2013-12-20','11:30:00',1.8),('9303','2013-12-20','11:35:00',1.77),('9303','2013-12-20','11:40:00',1.83),('9303','2013-12-20','11:45:00',1.86),('9303','2013-12-20','11:50:00',1.85),('9303','2013-12-20','11:55:00',1.85),('9303','2013-12-20','12:00:00',1.89),('9303','2013-12-20','12:05:00',1.82),('9303','2013-12-20','12:10:00',1.88),('9303','2013-12-20','12:15:00',1.89),('9303','2013-12-20','12:20:00',1.92),('9303','2013-12-20','12:25:00',1.9),('9303','2013-12-20','12:30:00',1.94),('9303','2013-12-20','12:35:00',1.97),('9303','2013-12-20','12:40:00',1.95),('9303','2013-12-20','12:45:00',1.91),('9303','2013-12-20','12:50:00',1.87),('9303','2013-12-20','12:55:00',1.83),('9303','2013-12-20','13:00:00',1.8),('9303','2013-12-20','13:05:00',1.77),('9303','2013-12-20','13:10:00',1.73),('9303','2013-12-20','13:15:00',1.71),('9303','2013-12-20','13:20:00',1.65),('9303','2013-12-20','13:25:00',1.6),('9303','2013-12-20','13:30:00',1.56),('9303','2013-12-20','13:35:00',1.52),('9303','2013-12-20','13:40:00',1.48),('9303','2013-12-20','13:45:00',1.46),('9303','2013-12-20','13:50:00',1.41),('9303','2013-12-20','13:55:00',1.34),('9303','2013-12-20','14:00:00',1.21),('9303','2013-12-20','14:05:00',1),('9303','2013-12-19','09:35:00',1.03),('9303','2013-12-19','09:50:00',1.09),('9303','2013-12-19','09:55:00',1.5),('9303','2013-12-19','10:00:00',1.38),('9303','2013-12-19','10:05:00',1.53),('9303','2013-12-19','10:10:00',1.66),('9303','2013-12-19','10:15:00',1.7),('9303','2013-12-19','10:20:00',1.3),('9303','2013-12-19','10:30:00',1.04),('9303','2013-12-19','10:40:00',1.01),('9303','2013-12-19','10:45:00',1.44),('9303','2013-12-19','10:50:00',1.7),('9303','2013-12-19','11:15:00',1.56),('9303','2013-12-19','11:20:00',1.4),('9303','2013-12-19','14:30:00',1),('9303','2013-12-19','14:35:00',1.36),('9303','2013-12-19','14:40:00',1.17),('9303','2013-12-18','09:40:00',1.07),('9303','2013-12-18','09:45:00',1.18),('9303','2013-12-18','09:50:00',1.25),('9303','2013-12-18','09:55:00',1.31),('9303','2013-12-18','10:00:00',1.38),('9303','2013-12-18','10:05:00',1.42),('9303','2013-12-18','10:10:00',1.46),('9303','2013-12-18','10:15:00',1.49),('9303','2013-12-18','10:20:00',1.51),('9303','2013-12-18','10:25:00',1.52),('9303','2013-12-18','10:30:00',1.51),('9303','2013-12-18','10:35:00',1.55),('9303','2013-12-18','10:40:00',1.61),('9303','2013-12-18','10:45:00',1.6),('9303','2013-12-18','10:50:00',1.71),('9303','2013-12-18','10:55:00',1.73),('9303','2013-12-18','11:00:00',1.78),('9303','2013-12-18','11:05:00',1.78),('9303','2013-12-18','11:10:00',1.8),('9303','2013-12-18','11:15:00',1.85),('9303','2013-12-18','11:20:00',1.84),('9303','2013-12-18','11:25:00',1.85),('9303','2013-12-18','11:30:00',1.87),('9303','2013-12-18','11:35:00',1.87),('9303','2013-12-18','11:40:00',1.91),('9303','2013-12-18','11:45:00',1.9),('9303','2013-12-18','11:50:00',1.9),('9303','2013-12-18','11:55:00',1.89),('9303','2013-12-18','12:00:00',1.94),('9303','2013-12-18','12:05:00',1.9),('9303','2013-12-18','12:10:00',1.95),('9303','2013-12-18','12:15:00',1.98),('9303','2013-12-18','12:20:00',2),('9303','2013-12-18','12:25:00',1.99),('9303','2013-12-18','12:30:00',2.01),('9303','2013-12-18','12:35:00',2.04),('9303','2013-12-18','12:40:00',2.02),('9303','2013-12-18','12:45:00',2.02),('9303','2013-12-18','12:50:00',1.96),('9303','2013-12-18','12:55:00',1.93),('9303','2013-12-18','13:00:00',1.85),('9303','2013-12-18','13:05:00',1.78),('9303','2013-12-18','13:10:00',1.81),('9303','2013-12-18','13:15:00',1.79),('9303','2013-12-18','13:20:00',1.73),('9303','2013-12-18','13:25:00',1.7),('9303','2013-12-18','13:30:00',1.65),('9303','2013-12-18','13:35:00',1.62),('9303','2013-12-18','13:40:00',1.57),('9303','2013-12-18','13:45:00',1.5),('9303','2013-12-18','13:50:00',1.47),('9303','2013-12-18','13:55:00',1.43),('9303','2013-12-18','14:00:00',1.4),('9303','2013-12-18','14:05:00',1.33),('9303','2013-12-18','14:10:00',1.31),('9303','2013-12-18','14:15:00',1.31),('9303','2013-12-18','14:20:00',1.23),('9303','2013-12-18','14:25:00',1.23),('9303','2013-12-18','14:30:00',1.2),('9303','2013-12-18','14:35:00',1.15),('9303','2013-12-18','14:40:00',1.09),('9303','2013-12-18','14:45:00',1),('9303','2014-04-22','08:05:00',1.04),('9303','2014-04-22','08:10:00',1.16),('9303','2014-04-22','08:15:00',1.25),('9303','2014-04-22','08:20:00',1.36),('9303','2014-04-22','08:25:00',1.44),('9303','2014-04-22','08:30:00',1.54),('9303','2014-04-22','08:35:00',1.63),('9303','2014-04-22','08:40:00',1.75),('9303','2014-04-22','08:45:00',1.81),('9303','2014-04-22','08:50:00',1.89),('9303','2014-04-22','08:55:00',1.9),('9303','2014-04-22','09:00:00',2.01),('9303','2014-04-22','09:05:00',2.21),('9303','2014-04-22','09:10:00',2.09),('9303','2014-04-22','09:15:00',2.11),('9303','2014-04-22','09:20:00',2.33),('9303','2014-04-22','09:25:00',2.52),('9303','2014-04-22','09:30:00',2.36),('9303','2014-04-22','09:35:00',2.3),('9303','2014-04-22','09:40:00',2.62),('9303','2014-04-22','09:45:00',2.87),('9303','2014-04-22','09:50:00',2.36),('9303','2014-04-22','09:55:00',1.39),('9303','2014-04-22','10:00:00',1.27),('9303','2014-04-22','10:05:00',1.35),('9303','2014-04-22','10:10:00',1.73),('9303','2014-04-22','10:15:00',1.82),('9303','2014-04-22','10:20:00',2.87),('9303','2014-04-22','10:25:00',2.1),('9303','2014-04-22','10:30:00',3.23),('9303','2014-04-22','10:35:00',3.48),('9303','2014-04-22','10:40:00',3.2),('9303','2014-04-22','10:45:00',3.54),('9303','2014-04-22','10:50:00',3.88),('9303','2014-04-22','10:55:00',2.86),('9303','2014-04-22','11:00:00',1.87),('9303','2014-04-22','11:05:00',2.1),('9303','2014-04-22','11:10:00',1.55),('9303','2014-04-22','11:15:00',1.3),('9303','2014-04-22','11:20:00',1.11),('9303','2014-04-22','11:25:00',1.13),('9303','2014-04-22','11:35:00',1.06),('9303','2014-04-22','12:05:00',1.08),('9303','2014-04-22','12:10:00',1.12),('9303','2014-04-22','12:15:00',1.13),('9303','2014-04-22','12:20:00',1.18),('9303','2014-04-22','12:25:00',1.26),('9303','2014-04-22','12:30:00',1.48),('9303','2014-04-22','12:35:00',1.31),('9303','2014-04-22','13:15:00',1.18),('9303','2014-04-22','13:20:00',1.9),('9303','2014-04-22','13:25:00',2.36),('9303','2014-04-22','13:30:00',2.69),('9303','2014-04-22','13:35:00',2.48),('9303','2014-04-22','13:40:00',3.07),('9303','2014-04-22','13:45:00',3.12),('9303','2014-04-22','13:50:00',2.66),('9303','2014-04-22','13:55:00',1.48),('9303','2014-04-22','14:00:00',1.28),('9303','2014-04-22','14:05:00',1.51),('9303','2014-04-22','14:10:00',3.5),('9303','2014-04-22','14:15:00',3.13),('9303','2014-04-22','14:20:00',3.6),('9303','2014-04-22','14:25:00',2.7),('9303','2014-04-22','14:30:00',1.88),('9303','2014-04-22','14:35:00',2.19),('9303','2014-04-22','14:40:00',3.14),('9303','2014-04-22','14:45:00',3.8),('9303','2014-04-22','14:50:00',3.45),('9303','2014-04-22','14:55:00',2.74),('9303','2014-04-22','15:00:00',1.28),('9303','2014-04-22','15:05:00',1.21),('9303','2014-04-22','15:10:00',1.12),('9303','2014-04-22','15:15:00',1.08),('9303','2014-04-22','15:20:00',1.21),('9303','2014-04-22','15:25:00',1.32),('9303','2014-04-22','15:30:00',1.64),('9303','2014-04-22','15:35:00',2.43),('9303','2014-04-22','15:40:00',2.12),('9303','2014-04-22','15:45:00',1.79),('9303','2014-04-22','15:50:00',2.1),('9303','2014-04-22','15:55:00',1.7),('9303','2014-04-22','16:00:00',2.02),('9303','2014-04-22','16:05:00',1.42),('9303','2014-04-22','16:10:00',1.34),('9303','2014-04-22','16:15:00',1.27),('9303','2014-04-22','16:20:00',1.5),('9303','2014-04-22','16:25:00',1.45),('9303','2014-04-22','16:30:00',1.2),('9303','2014-04-22','16:35:00',1.28),('9303','2014-04-22','16:40:00',1.7),('9303','2014-04-22','16:45:00',1.57),('9303','2014-04-22','16:50:00',1.22),('9303','2014-04-22','16:55:00',1.07),('9303','2014-04-22','17:00:00',1.12),('9303','2014-04-22','17:05:00',1.33),('9303','2014-04-22','17:10:00',1.04),('9303','2013-12-17','09:40:00',1.1),('9303','2013-12-17','09:45:00',1.22),('9303','2013-12-17','09:50:00',1.31),('9303','2013-12-17','09:55:00',1.38),('9303','2013-12-17','10:00:00',1.43),('9303','2013-12-17','10:05:00',1.49),('9303','2013-12-17','10:10:00',1.5),('9303','2013-12-17','10:15:00',1.54),('9303','2013-12-17','10:20:00',1.56),('9303','2013-12-17','10:25:00',1.57),('9303','2013-12-17','10:30:00',1.57),('9303','2013-12-17','10:35:00',1.6),('9303','2013-12-17','10:40:00',1.66),('9303','2013-12-17','10:45:00',1.65),('9303','2013-12-17','10:50:00',1.76),('9303','2013-12-17','10:55:00',1.79),('9303','2013-12-17','11:00:00',1.84),('9303','2013-12-17','11:05:00',1.82),('9303','2013-12-17','11:10:00',1.86),('9303','2013-12-17','11:15:00',1.91),('9303','2013-12-17','11:20:00',1.92),('9303','2013-12-17','11:25:00',1.95),('9303','2013-12-17','11:30:00',1.97),('9303','2013-12-17','11:35:00',1.97),('9303','2013-12-17','11:40:00',2.01),('9303','2013-12-17','11:45:00',2.02),('9303','2013-12-17','11:50:00',2.04),('9303','2013-12-17','11:55:00',2.02),('9303','2013-12-17','12:00:00',2.03),('9303','2013-12-17','12:05:00',2),('9303','2013-12-17','12:10:00',2.05),('9303','2013-12-17','12:15:00',2.09),('9303','2013-12-17','12:20:00',2.11),('9303','2013-12-17','12:25:00',2.1),('9303','2013-12-17','12:30:00',2.13),('9303','2013-12-17','12:35:00',2.17),('9303','2013-12-17','12:40:00',2.15),('9303','2013-12-17','12:45:00',2.09),('9303','2013-12-17','12:50:00',2.06),('9303','2013-12-17','12:55:00',2),('9303','2013-12-17','13:00:00',1.95),('9303','2013-12-17','13:05:00',1.92),('9303','2013-12-17','13:10:00',1.88),('9303','2013-12-17','13:15:00',1.85),('9303','2013-12-17','13:20:00',1.79),('9303','2013-12-17','13:25:00',1.77),('9303','2013-12-17','13:30:00',1.74),('9303','2013-12-17','13:35:00',1.72),('9303','2013-12-17','13:40:00',1.67),('9303','2013-12-17','13:45:00',1.62),('9303','2013-12-17','13:50:00',1.57),('9303','2013-12-17','13:55:00',1.51),('9303','2013-12-17','14:00:00',1.49),('9303','2013-12-17','14:05:00',1.39),('9303','2013-12-17','14:10:00',1.38),('9303','2013-12-17','14:15:00',1.36),('9303','2013-12-17','14:20:00',1.32),('9303','2013-12-17','14:25:00',1.28),('9303','2013-12-17','14:30:00',1.24),('9303','2013-12-17','14:35:00',1.2),('9303','2013-12-17','14:40:00',1.15),('9303','2013-12-17','14:45:00',1.06),('9303','2013-12-16','09:40:00',1.12),('9303','2013-12-16','09:45:00',1.23),('9303','2013-12-16','09:50:00',1.28),('9303','2013-12-16','09:55:00',1.34),('9303','2013-12-16','10:00:00',1.4),('9303','2013-12-16','10:05:00',1.44),('9303','2013-12-16','10:10:00',1.46),('9303','2013-12-16','10:15:00',1.51),('9303','2013-12-16','10:20:00',1.5),('9303','2013-12-16','10:25:00',1.49),('9303','2013-12-16','10:30:00',1.47),('9303','2013-12-16','10:35:00',1.52),('9303','2013-12-16','10:40:00',1.6),('9303','2013-12-16','10:45:00',1.62),('9303','2013-12-16','10:50:00',1.7),('9303','2013-12-16','10:55:00',1.74),('9303','2013-12-16','11:00:00',1.78),('9303','2013-12-16','11:05:00',1.77),('9303','2013-12-16','11:10:00',1.79),('9303','2013-12-16','11:15:00',1.85),('9303','2013-12-16','11:20:00',1.85),('9303','2013-12-16','11:25:00',1.91),('9303','2013-12-16','11:30:00',1.9),('9303','2013-12-16','11:35:00',1.92),('9303','2013-12-16','11:40:00',1.95),('9303','2013-12-16','11:45:00',1.95),('9303','2013-12-16','11:50:00',1.96),('9303','2013-12-16','11:55:00',1.95),('9303','2013-12-16','12:00:00',1.99),('9303','2013-12-16','12:05:00',1.98),('9303','2013-12-16','12:10:00',2.03),('9303','2013-12-16','12:15:00',2.07),('9303','2013-12-16','12:20:00',2.09),('9303','2013-12-16','12:25:00',2.1),('9303','2013-12-16','12:30:00',2.13),('9303','2013-12-16','12:35:00',2.14),('9303','2013-12-16','12:40:00',2.12),('9303','2013-12-16','12:45:00',2.1),('9303','2013-12-16','12:50:00',2.07),('9303','2013-12-16','12:55:00',2.01),('9303','2013-12-16','13:00:00',1.96),('9303','2013-12-16','13:05:00',1.95),('9303','2013-12-16','13:10:00',1.89),('9303','2013-12-16','13:15:00',1.88),('9303','2013-12-16','13:20:00',1.8),('9303','2013-12-16','13:25:00',1.78),('9303','2013-12-16','13:30:00',1.75),('9303','2013-12-16','13:35:00',1.7),('9303','2013-12-16','13:40:00',1.64),('9303','2013-12-16','13:45:00',1.6),('9303','2013-12-16','13:50:00',1.58),('9303','2013-12-16','13:55:00',1.51),('9303','2013-12-16','14:00:00',1.45),('9303','2013-12-16','14:05:00',1.41),('9303','2013-12-16','14:10:00',1.4),('9303','2013-12-16','14:15:00',1.38),('9303','2013-12-16','14:20:00',1.32),('9303','2013-12-16','14:25:00',1.28),('9303','2013-12-16','14:30:00',1.25),('9303','2013-12-16','14:35:00',1.19),('9303','2013-12-16','14:40:00',1.13),('9303','2013-12-16','14:45:00',1.05),('9303','2013-12-15','10:20:00',1.08),('9303','2013-12-15','10:25:00',1.07),('9303','2013-12-15','10:30:00',1.02),('9303','2013-12-15','10:35:00',1.15),('9303','2013-12-15','10:40:00',1.17),('9303','2013-12-15','10:45:00',1.14),('9303','2013-12-14','09:35:00',1),('9303','2013-12-14','09:40:00',1.14),('9303','2013-12-14','09:45:00',1.25),('9303','2013-12-14','09:50:00',1.3),('9303','2013-12-14','09:55:00',1.37),('9303','2013-12-14','10:00:00',1.4),('9303','2013-12-14','10:05:00',1.43),('9303','2013-12-14','10:10:00',1.46),('9303','2013-12-14','10:15:00',1.52),('9303','2013-12-14','10:20:00',1.52),('9303','2013-12-14','10:25:00',1.51),('9303','2013-12-14','10:30:00',1.52),('9303','2013-12-14','10:35:00',1.57),('9303','2013-12-14','10:40:00',1.62),('9303','2013-12-14','10:45:00',1.63),('9303','2013-12-14','10:50:00',1.7),('9303','2013-12-14','10:55:00',1.72),('9303','2013-12-14','11:00:00',1.75),('9303','2013-12-14','11:05:00',1.74),('9303','2013-12-14','11:10:00',1.77),('9303','2013-12-14','11:15:00',1.82),('9303','2013-12-14','11:20:00',1.81),('9303','2013-12-14','11:25:00',1.85),('9303','2013-12-14','11:30:00',1.83),('9303','2013-12-14','11:35:00',1.88),('9303','2013-12-14','11:40:00',1.92),('9303','2013-12-14','11:45:00',1.87),('9303','2013-12-14','11:50:00',1.85),('9303','2013-12-14','11:55:00',1.86),('9303','2013-12-14','12:00:00',1.85),('9303','2013-12-14','12:05:00',1.85),('9303','2013-12-14','12:10:00',1.92),('9303','2013-12-14','12:15:00',1.94),('9303','2013-12-14','12:20:00',1.93),('9303','2013-12-14','12:25:00',1.92),('9303','2013-12-14','12:30:00',1.96),('9303','2013-12-14','12:35:00',1.96),('9303','2013-12-14','12:40:00',1.92),('9303','2013-12-14','12:45:00',1.9),('9303','2013-12-14','12:50:00',1.94),('9303','2013-12-14','12:55:00',1.89),('9303','2013-12-14','13:00:00',1.81),('9303','2013-12-14','13:05:00',1.82),('9303','2013-12-14','13:10:00',1.79),('9303','2013-12-14','13:15:00',1.77),('9303','2013-12-14','13:20:00',1.76),('9303','2013-12-14','13:25:00',1.74),('9303','2013-12-14','13:30:00',1.66),('9303','2013-12-14','13:35:00',1.66),('9303','2013-12-14','13:40:00',1.65),('9303','2013-12-14','13:45:00',1.6),('9303','2013-12-14','13:50:00',1.54),('9303','2013-12-14','13:55:00',1.49),('9303','2013-12-14','14:00:00',1.45),('9303','2013-12-14','14:05:00',1.42),('9303','2013-12-14','14:10:00',1.38),('9303','2013-12-14','14:15:00',1.37),('9303','2013-12-14','14:20:00',1.3),('9303','2013-12-14','14:25:00',1.27),('9303','2013-12-14','14:30:00',1.23),('9303','2013-12-14','14:35:00',1.18),('9303','2013-12-14','14:40:00',1.11),('9303','2013-12-14','14:45:00',1.03),('9303','2013-12-13','09:40:00',1.06),('9303','2013-12-13','09:45:00',1.16),('9303','2013-12-13','09:50:00',1.21),('9303','2013-12-13','09:55:00',1.28),('9303','2013-12-13','10:00:00',1.32),('9303','2013-12-13','10:05:00',1.35),('9303','2013-12-13','10:10:00',1.37),('9303','2013-12-13','10:15:00',1.43),('9303','2013-12-13','10:20:00',1.43),('9303','2013-12-13','10:25:00',1.44),('9303','2013-12-13','10:30:00',1.43),('9303','2013-12-13','10:35:00',1.5),('9303','2013-12-13','10:40:00',1.56),('9303','2013-12-13','10:45:00',1.58),('9303','2013-12-13','10:50:00',1.61),('9303','2013-12-13','10:55:00',1.63),('9303','2013-12-13','11:00:00',1.68),('9303','2013-12-13','11:05:00',1.7),('9303','2013-12-13','11:10:00',1.7),('9303','2013-12-13','11:15:00',1.77),('9303','2013-12-13','11:20:00',1.74),('9303','2013-12-13','11:25:00',1.78),('9303','2013-12-13','11:30:00',1.75),('9303','2013-12-13','11:35:00',1.78),('9303','2013-12-13','11:40:00',1.82),('9303','2013-12-13','11:45:00',1.82),('9303','2013-12-13','11:50:00',1.84),('9303','2013-12-13','11:55:00',1.86),('9303','2013-12-13','12:00:00',1.85),('9303','2013-12-13','12:05:00',1.83),('9303','2013-12-13','12:10:00',1.84),('9303','2013-12-13','12:15:00',1.86),('9303','2013-12-13','12:20:00',1.87),('9303','2013-12-13','12:25:00',1.92),('9303','2013-12-13','12:30:00',1.96),('9303','2013-12-13','12:35:00',1.94),('9303','2013-12-13','12:40:00',1.93),('9303','2013-12-13','12:45:00',1.94),('9303','2013-12-13','12:50:00',1.88),('9303','2013-12-13','12:55:00',1.8),('9303','2013-12-13','13:00:00',1.81),('9303','2013-12-13','13:05:00',1.77),('9303','2013-12-13','13:10:00',1.74),('9303','2013-12-13','13:15:00',1.73),('9303','2013-12-13','13:20:00',1.65),('9303','2013-12-13','13:25:00',1.72),('9303','2013-12-13','13:30:00',1.69),('9303','2013-12-13','13:35:00',1.64),('9303','2013-12-13','13:40:00',1.59),('9303','2013-12-13','13:45:00',1.54),('9303','2013-12-13','13:50:00',1.5),('9303','2013-12-13','13:55:00',1.45),('9303','2013-12-13','14:00:00',1.43),('9303','2013-12-13','14:05:00',1.4),('9303','2013-12-13','14:10:00',1.38),('9303','2013-12-13','14:15:00',1.36),('9303','2013-12-13','14:20:00',1.31),('9303','2013-12-13','14:25:00',1.29),('9303','2013-12-13','14:30:00',1.23),('9303','2013-12-13','14:35:00',1.19),('9303','2013-12-13','14:40:00',1.12),('9303','2013-12-13','14:45:00',1.05),('9303','2013-12-12','09:35:00',1.06),('9303','2013-12-12','09:40:00',1.19),('9303','2013-12-12','09:45:00',1.26),('9303','2013-12-12','09:50:00',1.3),('9303','2013-12-12','09:55:00',1.35),('9303','2013-12-12','10:00:00',1.39),('9303','2013-12-12','10:05:00',1.44),('9303','2013-12-12','10:10:00',1.48),('9303','2013-12-12','10:15:00',1.53),('9303','2013-12-12','10:20:00',1.52),('9303','2013-12-12','10:25:00',1.51),('9303','2013-12-12','10:30:00',1.52),('9303','2013-12-12','10:35:00',1.58),('9303','2013-12-12','10:40:00',1.63),('9303','2013-12-12','10:45:00',1.65),('9303','2013-12-12','10:50:00',1.7),('9303','2013-12-12','10:55:00',1.73),('9303','2013-12-12','11:00:00',1.73),('9303','2013-12-12','11:05:00',1.74),('9303','2013-12-12','11:10:00',1.77),('9303','2013-12-12','11:15:00',1.82),('9303','2013-12-12','11:20:00',1.82),('9303','2013-12-12','11:25:00',1.85),('9303','2013-12-12','11:30:00',1.82),('9303','2013-12-12','11:35:00',1.86),('9303','2013-12-12','11:40:00',1.88),('9303','2013-12-12','11:45:00',1.86),('9303','2013-12-12','11:50:00',1.84),('9303','2013-12-12','11:55:00',1.87),('9303','2013-12-12','12:00:00',1.84),('9303','2013-12-12','12:05:00',1.88),('9303','2013-12-12','12:10:00',1.92),('9303','2013-12-12','12:15:00',1.95),('9303','2013-12-12','12:20:00',1.98),('9303','2013-12-12','12:25:00',1.97),('9303','2013-12-12','12:30:00',2.02),('9303','2013-12-12','12:35:00',2.03),('9303','2013-12-12','12:40:00',2.01),('9303','2013-12-12','12:45:00',1.99),('9303','2013-12-12','12:50:00',1.91),('9303','2013-12-12','12:55:00',1.85),('9303','2013-12-12','13:00:00',1.79),('9303','2013-12-12','13:05:00',1.74),('9303','2013-12-12','13:10:00',1.76),('9303','2013-12-12','13:15:00',1.8),('9303','2013-12-12','13:20:00',1.73),('9303','2013-12-12','13:25:00',1.68),('9303','2013-12-12','13:30:00',1.67),('9303','2013-12-12','13:35:00',1.65),('9303','2013-12-12','13:40:00',1.6),('9303','2013-12-12','13:45:00',1.54),('9303','2013-12-12','13:50:00',1.52),('9303','2013-12-12','13:55:00',1.48),('9303','2013-12-12','14:00:00',1.42),('9303','2013-12-12','14:05:00',1.39),('9303','2013-12-12','14:10:00',1.33),('9303','2013-12-12','14:15:00',1.29),('9303','2013-12-12','14:20:00',1.25),('9303','2013-12-12','14:25:00',1.19),('9303','2013-12-12','14:30:00',1.15),('9303','2013-12-12','14:35:00',1.12),('9303','2013-12-12','14:40:00',1.06),('9303','2013-12-11','09:40:00',1.07),('9303','2013-12-11','09:45:00',1.12),('9303','2013-12-11','09:50:00',1.17),('9303','2013-12-11','09:55:00',1.34),('9303','2013-12-11','10:00:00',1.4),('9303','2013-12-11','10:05:00',1.43),('9303','2013-12-11','10:10:00',1.48),('9303','2013-12-11','10:15:00',1.55),('9303','2013-12-11','10:20:00',1.56),('9303','2013-12-11','10:25:00',1.56),('9303','2013-12-11','10:30:00',1.6),('9303','2013-12-11','10:35:00',1.68),('9303','2013-12-11','10:40:00',1.7),('9303','2013-12-11','10:45:00',1.71),('9303','2013-12-11','10:50:00',1.74),('9303','2013-12-11','10:55:00',1.79),('9303','2013-12-11','11:00:00',1.83),('9303','2013-12-11','11:05:00',1.84),('9303','2013-12-11','11:10:00',1.87),('9303','2013-12-11','11:15:00',1.9),('9303','2013-12-11','11:20:00',1.91),('9303','2013-12-11','11:25:00',1.92),('9303','2013-12-11','11:30:00',1.87),('9303','2013-12-11','11:35:00',1.92),('9303','2013-12-11','11:40:00',1.97),('9303','2013-12-11','11:45:00',1.96),('9303','2013-12-11','11:50:00',1.98),('9303','2013-12-11','11:55:00',2.02),('9303','2013-12-11','12:00:00',1.99),('9303','2013-12-11','12:05:00',2.01),('9303','2013-12-11','12:10:00',2.05),('9303','2013-12-11','12:15:00',2.09),('9303','2013-12-11','12:20:00',2.1),('9303','2013-12-11','12:25:00',2.02),('9303','2013-12-11','12:30:00',2.06),('9303','2013-12-11','12:35:00',2.07),('9303','2013-12-11','12:40:00',2.06),('9303','2013-12-11','12:45:00',2.03),('9303','2013-12-11','12:50:00',1.99),('9303','2013-12-11','12:55:00',1.95),('9303','2013-12-11','13:00:00',1.94),('9303','2013-12-11','13:05:00',1.89),('9303','2013-12-11','13:10:00',1.84),('9303','2013-12-11','13:15:00',1.8),('9303','2013-12-11','13:20:00',1.77),('9303','2013-12-11','13:25:00',1.76),('9303','2013-12-11','13:30:00',1.73),('9303','2013-12-11','13:35:00',1.69),('9303','2013-12-11','13:40:00',1.65),('9303','2013-12-11','13:45:00',1.59),('9303','2013-12-11','13:50:00',1.53),('9303','2013-12-11','13:55:00',1.5),('9303','2013-12-11','14:00:00',1.46),('9303','2013-12-11','14:05:00',1.42),('9303','2013-12-11','14:10:00',1.39),('9303','2013-12-11','14:15:00',1.35),('9303','2013-12-11','14:20:00',1.32),('9303','2013-12-11','14:25:00',1.29),('9303','2013-12-11','14:30:00',1.25),('9303','2013-12-11','14:35:00',1.2),('9303','2013-12-11','14:40:00',1.12),('9303','2013-12-11','14:45:00',1.04),('9303','2013-12-10','09:35:00',1.14),('9303','2013-12-10','09:40:00',1.25),('9303','2013-12-10','09:45:00',1.29),('9303','2013-12-10','09:50:00',1.32),('9303','2013-12-10','09:55:00',1.38),('9303','2013-12-10','10:00:00',1.44),('9303','2013-12-10','10:05:00',1.49),('9303','2013-12-10','10:10:00',1.54),('9303','2013-12-10','10:15:00',1.57),('9303','2013-12-10','10:20:00',1.57),('9303','2013-12-10','10:25:00',1.56),('9303','2013-12-10','10:30:00',1.61),('9303','2013-12-10','10:35:00',1.68),('9303','2013-12-10','10:40:00',1.67),('9303','2013-12-10','10:45:00',1.74),('9303','2013-12-10','10:50:00',1.78),('9303','2013-12-10','10:55:00',1.81),('9303','2013-12-10','11:00:00',1.83),('9303','2013-12-10','11:05:00',1.84),('9303','2013-12-10','11:10:00',1.88),('9303','2013-12-10','11:15:00',1.9),('9303','2013-12-10','11:20:00',1.93),('9303','2013-12-10','11:25:00',1.96),('9303','2013-12-10','11:30:00',1.95),('9303','2013-12-10','11:35:00',2),('9303','2013-12-10','11:40:00',2.02),('9303','2013-12-10','11:45:00',2.01),('9303','2013-12-10','11:50:00',1.99),('9303','2013-12-10','11:55:00',2.03),('9303','2013-12-10','12:00:00',1.99),('9303','2013-12-10','12:05:00',2.01),('9303','2013-12-10','12:10:00',2.04),('9303','2013-12-10','12:15:00',2.07),('9303','2013-12-10','12:20:00',2.07),('9303','2013-12-10','12:25:00',2.07),('9303','2013-12-10','12:30:00',2.1),('9303','2013-12-10','12:35:00',2.07),('9303','2013-12-10','12:40:00',2.03),('9303','2013-12-10','12:45:00',2.03),('9303','2013-12-10','12:50:00',1.97),('9303','2013-12-10','12:55:00',1.9),('9303','2013-12-10','13:00:00',1.82),('9303','2013-12-10','13:05:00',1.84),('9303','2013-12-10','13:10:00',1.81),('9303','2013-12-10','13:15:00',1.77),('9303','2013-12-10','13:20:00',1.73),('9303','2013-12-10','13:25:00',1.72),('9303','2013-12-10','13:30:00',1.69),('9303','2013-12-10','13:35:00',1.69),('9303','2013-12-10','13:40:00',1.68),('9303','2013-12-10','13:45:00',1.61),('9303','2013-12-10','13:50:00',1.58),('9303','2013-12-10','13:55:00',1.52),('9303','2013-12-10','14:00:00',1.5),('9303','2013-12-10','14:05:00',1.44),('9303','2013-12-10','14:10:00',1.4),('9303','2013-12-10','14:15:00',1.37),('9303','2013-12-10','14:20:00',1.35),('9303','2013-12-10','14:25:00',1.32),('9303','2013-12-10','14:30:00',1.28),('9303','2013-12-10','14:35:00',1.23),('9303','2013-12-10','14:40:00',1.16),('9303','2013-12-10','14:45:00',1.07),('9303','2013-12-09','09:35:00',1.06),('9303','2013-12-09','09:40:00',1.16),('9303','2013-12-09','09:45:00',1.18),('9303','2013-12-09','09:50:00',1.2),('9303','2013-12-09','09:55:00',1.27),('9303','2013-12-09','10:00:00',1.31),('9303','2013-12-09','10:05:00',1.48),('9303','2013-12-09','10:10:00',1.9),('9303','2013-12-09','10:15:00',1.91),('9303','2013-12-09','10:20:00',2.12),('9303','2013-12-09','10:25:00',1.28),('9303','2013-12-09','12:30:00',1.72),('9303','2013-12-09','12:35:00',1.15),('9303','2013-12-09','12:40:00',1.13),('9303','2013-12-09','12:45:00',1.4),('9303','2013-12-09','12:50:00',1.21),('9303','2013-12-09','12:55:00',1.74),('9303','2013-12-09','13:00:00',2.04),('9303','2013-12-09','13:05:00',1.7),('9303','2013-12-09','13:10:00',1.46),('9303','2013-12-09','13:15:00',1.3),('9303','2013-12-09','13:20:00',1.58),('9303','2013-12-09','13:25:00',1.1),('9303','2013-12-09','13:50:00',1.05),('9303','2013-12-09','13:55:00',1.1),('9303','2013-12-08','10:50:00',1.01),('9303','2013-12-08','10:55:00',1.01),('9303','2013-12-08','11:00:00',1.2),('9303','2013-12-08','11:05:00',1.12),('9303','2013-12-08','11:10:00',1.18),('9303','2013-12-08','11:15:00',1.4),('9303','2013-12-08','11:20:00',1.2),('9303','2013-12-08','13:00:00',1.09),('9303','2013-12-08','13:05:00',1.03),('9303','2013-12-08','13:10:00',1.09),('9303','2013-12-08','13:15:00',1.6),('9303','2013-12-08','13:20:00',1.26),('9303','2013-12-08','13:25:00',1.25),('9303','2014-04-21','09:20:00',1.33),('9303','2014-04-21','09:25:00',1.39),('9303','2014-04-21','10:00:00',1.28),('9303','2014-04-21','10:05:00',3.07),('9303','2014-04-21','10:10:00',2.99),('9303','2014-04-21','10:15:00',3.28),('9303','2014-04-21','10:20:00',3.18),('9303','2014-04-21','10:25:00',3.21),('9303','2014-04-21','10:30:00',3.2),('9303','2014-04-21','10:35:00',3.26),('9303','2014-04-21','10:40:00',3.29),('9303','2014-04-21','10:45:00',3.35),('9303','2014-04-21','10:50:00',3.37),('9303','2014-04-21','10:55:00',3.38),('9303','2014-04-21','11:00:00',3.41),('9303','2014-04-21','11:05:00',3.48),('9303','2014-04-21','11:10:00',3.51),('9303','2014-04-21','11:15:00',3.53),('9303','2014-04-21','11:20:00',3.58),('9303','2014-04-21','11:25:00',3.62),('9303','2014-04-21','11:30:00',3.67),('9303','2014-04-21','11:35:00',3.7),('9303','2014-04-21','11:40:00',3.73),('9303','2014-04-21','11:45:00',3.79),('9303','2014-04-21','11:50:00',3.83),('9303','2014-04-21','11:55:00',3.89),('9303','2014-04-21','12:00:00',3.89),('9303','2014-04-21','12:05:00',3.88),('9303','2014-04-21','12:10:00',3.94),('9303','2014-04-21','12:15:00',3.96),('9303','2014-04-21','12:20:00',4.01),('9303','2014-04-21','12:25:00',4.03),('9303','2014-04-21','12:30:00',4.04),('9303','2014-04-21','12:35:00',4.05),('9303','2014-04-21','12:40:00',4.11),('9303','2014-04-21','12:45:00',4.09),('9303','2014-04-21','12:50:00',4.11),('9303','2014-04-21','12:55:00',4.11),('9303','2014-04-21','13:00:00',4.1),('9303','2014-04-21','13:05:00',4.1),('9303','2014-04-21','13:10:00',4.11),('9303','2014-04-21','13:15:00',4.09),('9303','2014-04-21','13:20:00',4.11),('9303','2014-04-21','13:25:00',4.11),('9303','2014-04-21','13:30:00',4.09),('9303','2014-04-21','13:35:00',4.07),('9303','2014-04-21','13:40:00',4.04),('9303','2014-04-21','13:45:00',4.09),('9303','2014-04-21','13:50:00',4.1),('9303','2014-04-21','13:55:00',4.08),('9303','2014-04-21','14:00:00',4.06),('9303','2014-04-21','14:05:00',4.03),('9303','2014-04-21','14:10:00',4.01),('9303','2014-04-21','14:15:00',4.01),('9303','2014-04-21','14:20:00',3.99),('9303','2014-04-21','14:25:00',3.96),('9303','2014-04-21','14:30:00',3.95),('9303','2014-04-21','14:35:00',3.9),('9303','2014-04-21','14:40:00',3.85),('9303','2014-04-21','14:45:00',3.82),('9303','2014-04-21','14:50:00',3.79),('9303','2014-04-21','14:55:00',3.76),('9303','2014-04-21','15:00:00',3.72),('9303','2014-04-21','15:05:00',3.68),('9303','2014-04-21','15:10:00',3.65),('9303','2014-04-21','15:15:00',3.59),('9303','2014-04-21','15:20:00',3.53),('9303','2014-04-21','15:25:00',3.48),('9303','2014-04-21','15:30:00',3.43),('9303','2014-04-21','15:35:00',3.38),('9303','2014-04-21','15:40:00',3.32),('9303','2014-04-21','15:45:00',3.26),('9303','2014-04-21','15:50:00',3.2),('9303','2014-04-21','15:55:00',3.16),('9303','2014-04-21','16:00:00',3.1),('9303','2014-04-21','16:05:00',3.05),('9303','2014-04-21','16:10:00',3.01),('9303','2014-04-21','16:15:00',2.35),('9303','2014-04-21','16:20:00',2.91),('9303','2014-04-21','16:25:00',2.71),('9303','2014-04-21','16:30:00',2.45),('9303','2014-04-21','16:35:00',2.66),('9303','2014-04-21','16:40:00',2.6),('9303','2014-04-21','16:45:00',2.54),('9303','2014-04-21','16:50:00',2.42),('9303','2014-04-21','16:55:00',2.27),('9303','2014-04-21','17:00:00',2.16),('9303','2014-04-21','17:05:00',2.1),('9303','2014-04-21','17:10:00',2.02),('9303','2014-04-21','17:15:00',1.93),('9303','2014-04-21','17:20:00',1.87),('9303','2014-04-21','17:25:00',1.79),('9303','2014-04-21','17:30:00',1.72),('9303','2014-04-21','17:35:00',1.62),('9303','2014-04-21','17:40:00',1.46),('9303','2014-04-21','17:45:00',1.43),('9303','2014-04-21','17:50:00',1.35),('9303','2014-04-21','17:55:00',1.25),('9303','2014-04-21','18:00:00',1.16),('9303','2014-04-21','18:05:00',1.04),('9303','2013-12-07','09:30:00',1.03),('9303','2013-12-07','09:35:00',1.23),('9303','2013-12-07','09:40:00',1.35),('9303','2013-12-07','09:45:00',1.36),('9303','2013-12-07','09:50:00',1.36),('9303','2013-12-07','09:55:00',1.41),('9303','2013-12-07','10:00:00',1.5),('9303','2013-12-07','10:05:00',1.52),('9303','2013-12-07','10:10:00',1.56),('9303','2013-12-07','10:15:00',1.61),('9303','2013-12-07','10:20:00',1.62),('9303','2013-12-07','10:25:00',1.63),('9303','2013-12-07','10:30:00',1.64),('9303','2013-12-07','10:35:00',1.71),('9303','2013-12-07','10:40:00',1.7),('9303','2013-12-07','10:45:00',1.74),('9303','2013-12-07','10:50:00',1.74),('9303','2013-12-07','10:55:00',1.77),('9303','2013-12-07','11:00:00',1.77),('9303','2013-12-07','11:05:00',1.8),('9303','2013-12-07','11:10:00',1.85),('9303','2013-12-07','11:15:00',1.86),('9303','2013-12-07','11:20:00',1.91),('9303','2013-12-07','11:25:00',1.9),('9303','2013-12-07','11:30:00',1.91),('9303','2013-12-07','11:35:00',1.93),('9303','2013-12-07','11:40:00',1.9),('9303','2013-12-07','11:45:00',1.92),('9303','2013-12-07','11:50:00',1.9),('9303','2013-12-07','11:55:00',1.91),('9303','2013-12-07','12:00:00',1.89),('9303','2013-12-07','12:05:00',1.94),('9303','2013-12-07','12:10:00',1.98),('9303','2013-12-07','12:15:00',2.02),('9303','2013-12-07','12:20:00',2.02),('9303','2013-12-07','12:25:00',2.04),('9303','2013-12-07','12:30:00',2.06),('9303','2013-12-07','12:35:00',2.05),('9303','2013-12-07','12:40:00',2),('9303','2013-12-07','12:45:00',2),('9303','2013-12-07','12:50:00',1.95),('9303','2013-12-07','12:55:00',1.86),('9303','2013-12-07','13:00:00',1.87),('9303','2013-12-07','13:05:00',1.85),('9303','2013-12-07','13:10:00',1.84),('9303','2013-12-07','13:15:00',1.8),('9303','2013-12-07','13:20:00',1.79),('9303','2013-12-07','13:25:00',1.74),('9303','2013-12-07','13:30:00',1.7),('9303','2013-12-07','13:35:00',1.68),('9303','2013-12-07','13:40:00',1.66),('9303','2013-12-07','13:45:00',1.62),('9303','2013-12-07','13:50:00',1.57),('9303','2013-12-07','13:55:00',1.5),('9303','2013-12-07','14:00:00',1.45),('9303','2013-12-07','14:05:00',1.42),('9303','2013-12-07','14:10:00',1.4),('9303','2013-12-07','14:15:00',1.34),('9303','2013-12-07','14:20:00',1.3),('9303','2013-12-07','14:25:00',1.25),('9303','2013-12-07','14:30:00',1.2),('9303','2013-12-07','14:35:00',1.15),('9303','2013-12-07','14:40:00',1.08),('9303','2013-12-07','14:45:00',1.02),('9303','2013-12-06','10:10:00',1.02),('9303','2013-12-06','11:35:00',1.1),('9303','2013-12-06','11:40:00',1.61),('9303','2013-12-06','11:45:00',1.35),('9303','2013-12-06','11:50:00',1.51),('9303','2013-12-06','11:55:00',1.43),('9303','2013-12-06','12:00:00',1.47),('9303','2013-12-06','12:05:00',1.37),('9303','2013-12-06','12:10:00',1.45),('9303','2013-12-06','12:15:00',1.13),('9303','2013-12-06','12:20:00',1.61),('9303','2013-12-06','12:25:00',1.15),('9303','2013-12-06','12:30:00',1.25),('9303','2013-12-06','12:35:00',1.74),('9303','2013-12-06','12:40:00',1.7),('9303','2013-12-06','14:40:00',1.06),('9303','2013-12-05','09:25:00',1.08),('9303','2013-12-05','09:30:00',1.17),('9303','2013-12-05','09:35:00',1.27),('9303','2013-12-05','09:40:00',1.36),('9303','2013-12-05','09:45:00',1.36),('9303','2013-12-05','09:50:00',1.41),('9303','2013-12-05','09:55:00',1.47),('9303','2013-12-05','10:00:00',1.53),('9303','2013-12-05','10:05:00',1.56),('9303','2013-12-05','10:10:00',1.61),('9303','2013-12-05','10:15:00',1.65),('9303','2013-12-05','10:20:00',1.66),('9303','2013-12-05','10:25:00',1.68),('9303','2013-12-05','10:30:00',1.71),('9303','2013-12-05','10:35:00',1.76),('9303','2013-12-05','10:40:00',1.75),('9303','2013-12-05','10:45:00',1.78),('9303','2013-12-05','10:50:00',1.8),('9303','2013-12-05','10:55:00',1.86),('9303','2013-12-05','11:00:00',1.84),('9303','2013-12-05','11:05:00',1.86),('9303','2013-12-05','11:10:00',1.86),('9303','2013-12-05','11:15:00',1.92),('9303','2013-12-05','11:20:00',1.95),('9303','2013-12-05','11:25:00',1.94),('9303','2013-12-05','11:30:00',1.96),('9303','2013-12-05','11:35:00',1.99),('9303','2013-12-05','11:40:00',1.99),('9303','2013-12-05','11:45:00',1.97),('9303','2013-12-05','11:50:00',1.97),('9303','2013-12-05','11:55:00',1.99),('9303','2013-12-05','12:00:00',2),('9303','2013-12-05','12:05:00',2.04),('9303','2013-12-05','12:10:00',2.05),('9303','2013-12-05','12:15:00',2.03),('9303','2013-12-05','12:20:00',2.08),('9303','2013-12-05','12:25:00',2.02),('9303','2013-12-05','12:30:00',2.11),('9303','2013-12-05','12:35:00',2.09),('9303','2013-12-05','12:40:00',2.04),('9303','2013-12-05','12:45:00',1.97),('9303','2013-12-05','12:50:00',1.72),('9303','2013-12-05','12:55:00',1.72),('9303','2013-12-05','13:00:00',1.47),('9303','2013-12-05','13:05:00',1.22),('9303','2013-12-05','13:10:00',1.9),('9303','2013-12-05','13:15:00',1.89),('9303','2013-12-05','13:20:00',1.75),('9303','2013-12-05','13:25:00',1.67),('9303','2013-12-05','13:30:00',1.02),('9303','2013-12-05','13:35:00',1.62),('9303','2013-12-05','13:40:00',1.64),('9303','2013-12-05','13:45:00',1.59),('9303','2013-12-05','13:50:00',1.55),('9303','2013-12-05','13:55:00',1.47),('9303','2013-12-05','14:00:00',1.45),('9303','2013-12-05','14:05:00',1.45),('9303','2013-12-05','14:10:00',1.39),('9303','2013-12-05','14:15:00',1.32),('9303','2013-12-05','14:20:00',1.31),('9303','2013-12-05','14:25:00',1.28),('9303','2013-12-05','14:30:00',1.24),('9303','2013-12-05','14:35:00',1.18),('9303','2013-12-05','14:40:00',1.13),('9303','2013-12-05','14:45:00',1.03),('9303','2013-12-04','11:40:00',1.01),('9303','2013-12-04','11:45:00',1.04),('9303','2013-12-04','11:50:00',1.03),('9303','2013-12-04','11:55:00',1.03),('9303','2013-12-04','12:00:00',1.04),('9303','2013-12-04','12:05:00',1.04),('9303','2013-12-04','12:10:00',1.03),('9303','2013-12-04','12:15:00',1.02),('9303','2013-12-04','12:20:00',1.01),('9303','2013-12-04','13:25:00',1.11),('9303','2013-12-04','13:30:00',1.56),('9303','2013-12-04','13:35:00',1.45),('9303','2013-12-04','13:40:00',1.64),('9303','2013-12-04','13:45:00',1.6),('9303','2013-12-04','13:50:00',1.63),('9303','2013-12-04','13:55:00',1.6),('9303','2013-12-04','14:00:00',1.55),('9303','2013-12-04','14:05:00',1.52),('9303','2013-12-04','14:10:00',1.49),('9303','2013-12-04','14:15:00',1.45),('9303','2013-12-04','14:20:00',1.4),('9303','2013-12-04','14:25:00',1.36),('9303','2013-12-04','14:30:00',1.33),('9303','2013-12-04','14:35:00',1.3),('9303','2013-12-04','14:40:00',1.25),('9303','2013-12-04','14:45:00',1.15),('9303','2013-12-04','14:50:00',1.07),('9303','2013-12-03','11:10:00',1.01),('9303','2013-12-03','11:15:00',1.02),('9303','2013-12-03','11:20:00',1.04),('9303','2013-12-03','11:25:00',1.05),('9303','2013-12-03','11:30:00',1.06),('9303','2013-12-03','11:35:00',1.07),('9303','2013-12-03','11:40:00',1.1),('9303','2013-12-03','11:45:00',1.13),('9303','2013-12-03','11:50:00',1.14),('9303','2013-12-03','11:55:00',1.16),('9303','2013-12-03','12:00:00',1.17),('9303','2013-12-03','12:05:00',1.18),('9303','2013-12-03','12:10:00',1.18),('9303','2013-12-03','12:15:00',1.19),('9303','2013-12-03','12:20:00',1.2),('9303','2013-12-03','12:25:00',1.22),('9303','2013-12-03','12:30:00',1.25),('9303','2013-12-03','12:35:00',1.29),('9303','2013-12-03','12:40:00',1.32),('9303','2013-12-03','12:45:00',1.36),('9303','2013-12-03','12:50:00',1.43),('9303','2013-12-03','12:55:00',1.52),('9303','2013-12-03','13:00:00',1.57),('9303','2013-12-03','13:05:00',1.58);
INSERT INTO `solarlog` VALUES ('9303','2013-12-03','13:10:00',1.54),('9303','2013-12-03','13:15:00',1.47),('9303','2013-12-03','13:20:00',1.4),('9303','2013-12-03','13:25:00',1.28),('9303','2013-12-03','13:30:00',1.12),('9303','2013-12-01','11:55:00',1.14),('9303','2013-12-01','12:00:00',1.02),('9303','2013-12-01','12:05:00',1.1),('9303','2013-12-01','12:10:00',1.4),('9303','2013-12-01','12:15:00',1.03),('9303','2013-11-30','09:35:00',1.01),('9303','2013-11-30','09:40:00',1.09),('9303','2013-11-30','09:45:00',1.02),('9303','2013-11-30','10:00:00',1.01),('9303','2013-11-30','10:20:00',1.09),('9303','2013-11-30','10:25:00',1.06),('9303','2013-11-30','10:30:00',1.12),('9303','2013-11-30','10:35:00',1.21),('9303','2013-11-30','10:40:00',1.31),('9303','2013-11-30','10:45:00',1.24),('9303','2013-11-30','10:50:00',1.19),('9303','2013-11-30','10:55:00',1.05),('9303','2013-11-30','11:05:00',1.17),('9303','2013-11-30','11:10:00',1.29),('9303','2013-11-30','11:15:00',1.24),('9303','2013-11-30','11:20:00',1.11),('9303','2013-11-30','11:25:00',1.18),('9303','2013-11-30','11:30:00',1.08),('9303','2013-11-29','10:50:00',1.04),('9303','2013-11-29','10:55:00',1.08),('9303','2013-11-29','11:00:00',1.11),('9303','2013-11-29','11:05:00',1.15),('9303','2013-11-29','11:10:00',1.16),('9303','2013-11-29','11:15:00',1.2),('9303','2013-11-29','11:20:00',1.24),('9303','2013-11-29','11:25:00',1.26),('9303','2013-11-29','11:30:00',1.29),('9303','2013-11-29','11:35:00',1.3),('9303','2013-11-29','11:40:00',1.31),('9303','2013-11-29','11:45:00',1.31),('9303','2013-11-29','11:50:00',1.32),('9303','2013-11-29','11:55:00',1.32),('9303','2013-11-29','12:00:00',1.33),('9303','2013-11-29','12:05:00',1.32),('9303','2013-11-29','12:10:00',1.31),('9303','2013-11-29','12:15:00',1.3),('9303','2013-11-29','12:20:00',1.29),('9303','2013-11-29','12:25:00',1.27),('9303','2013-11-29','12:30:00',1.23),('9303','2013-11-29','12:35:00',1.19),('9303','2013-11-29','12:40:00',1.14),('9303','2013-11-29','12:45:00',1.11),('9303','2013-11-29','12:50:00',1.07),('9303','2013-11-29','12:55:00',1.03),('9303','2014-04-20','08:10:00',1.06),('9303','2014-04-20','08:15:00',1.27),('9303','2014-04-20','08:20:00',1.45),('9303','2014-04-20','08:25:00',2.09),('9303','2014-04-20','08:30:00',2.21),('9303','2014-04-20','08:35:00',2.19),('9303','2014-04-20','08:40:00',1.22),('9303','2014-04-20','08:45:00',1.31),('9303','2014-04-20','08:50:00',1.71),('9303','2014-04-20','09:00:00',1.96),('9303','2014-04-20','09:10:00',1.61),('9303','2014-04-20','09:15:00',2.51),('9303','2014-04-20','09:20:00',2.59),('9303','2014-04-20','09:25:00',2.86),('9303','2014-04-20','09:30:00',3.32),('9303','2014-04-20','09:35:00',2.88),('9303','2014-04-20','09:40:00',2.04),('9303','2014-04-20','09:45:00',1.38),('9303','2014-04-20','09:50:00',1.41),('9303','2014-04-20','09:55:00',1.74),('9303','2014-04-20','10:00:00',2.11),('9303','2014-04-20','10:05:00',2.91),('9303','2014-04-20','10:10:00',2.51),('9303','2014-04-20','10:15:00',2.75),('9303','2014-04-20','10:20:00',2.72),('9303','2014-04-20','10:25:00',2.54),('9303','2014-04-20','10:30:00',2.37),('9303','2014-04-20','10:35:00',2.53),('9303','2014-04-20','10:40:00',2.41),('9303','2014-04-20','10:45:00',2.48),('9303','2014-04-20','10:50:00',2.85),('9303','2014-04-20','10:55:00',2.93),('9303','2014-04-20','11:00:00',3.31),('9303','2014-04-20','11:05:00',3.28),('9303','2014-04-20','11:10:00',3.17),('9303','2014-04-20','11:15:00',3.8),('9303','2014-04-20','11:20:00',2.47),('9303','2014-04-20','11:25:00',2.77),('9303','2014-04-20','11:30:00',3.78),('9303','2014-04-20','11:35:00',4.15),('9303','2014-04-20','11:40:00',3.83),('9303','2014-04-20','11:45:00',4.05),('9303','2014-04-20','11:50:00',3.22),('9303','2014-04-20','12:00:00',3.02),('9303','2014-04-20','12:05:00',4.43),('9303','2014-04-20','12:10:00',4.57),('9303','2014-04-20','12:15:00',2.82),('9303','2014-04-20','12:20:00',1.29),('9303','2014-04-20','12:25:00',4.67),('9303','2014-04-20','12:30:00',4.4),('9303','2014-04-20','12:35:00',4.2),('9303','2014-04-20','12:40:00',4.15),('9303','2014-04-20','12:45:00',4.2),('9303','2014-04-20','12:50:00',4.22),('9303','2014-04-20','12:55:00',4.27),('9303','2014-04-20','13:00:00',4.28),('9303','2014-04-20','13:05:00',4.31),('9303','2014-04-20','13:10:00',4.39),('9303','2014-04-20','13:15:00',4.37),('9303','2014-04-20','13:20:00',4.21),('9303','2014-04-20','13:25:00',4.16),('9303','2014-04-20','13:30:00',4.19),('9303','2014-04-20','13:35:00',4.2),('9303','2014-04-20','13:40:00',4.2),('9303','2014-04-20','13:45:00',4.16),('9303','2014-04-20','13:50:00',4.15),('9303','2014-04-20','13:55:00',4.15),('9303','2014-04-20','14:00:00',4.12),('9303','2014-04-20','14:05:00',4.12),('9303','2014-04-20','14:10:00',4.1),('9303','2014-04-20','14:15:00',4.27),('9303','2014-04-20','14:20:00',3.39),('9303','2014-04-20','14:25:00',2.92),('9303','2014-04-20','14:30:00',2.92),('9303','2014-04-20','14:35:00',2.34),('9303','2014-04-20','14:40:00',2.31),('9303','2014-04-20','14:45:00',2.49),('9303','2014-04-20','14:50:00',2.37),('9303','2014-04-20','14:55:00',2.7),('9303','2014-04-20','15:00:00',3.6),('9303','2014-04-20','15:05:00',3.61),('9303','2014-04-20','15:10:00',3.49),('9303','2014-04-20','15:15:00',3.73),('9303','2014-04-20','15:20:00',3.56),('9303','2014-04-20','15:25:00',3.55),('9303','2014-04-20','15:30:00',3.5),('9303','2014-04-20','15:35:00',3.45),('9303','2014-04-20','15:40:00',3.46),('9303','2014-04-20','15:45:00',3.14),('9303','2014-04-20','15:50:00',2.37),('9303','2014-04-20','15:55:00',3.31),('9303','2014-04-20','16:00:00',3.2),('9303','2014-04-20','16:05:00',3.13),('9303','2014-04-20','16:10:00',3.09),('9303','2014-04-20','16:15:00',3.04),('9303','2014-04-20','16:20:00',3.05),('9303','2014-04-20','16:25:00',2.45),('9303','2014-04-20','16:30:00',2.94),('9303','2014-04-20','16:35:00',2.7),('9303','2014-04-20','16:40:00',2.63),('9303','2014-04-20','16:45:00',2.41),('9303','2014-04-20','16:50:00',2.34),('9303','2014-04-20','16:55:00',2.45),('9303','2014-04-20','17:00:00',2.27),('9303','2014-04-20','17:05:00',2.17),('9303','2014-04-20','17:10:00',2.06),('9303','2014-04-20','17:15:00',1.96),('9303','2014-04-20','17:20:00',1.88),('9303','2014-04-20','17:25:00',1.79),('9303','2014-04-20','17:30:00',1.71),('9303','2014-04-20','17:35:00',1.61),('9303','2014-04-20','17:40:00',1.51),('9303','2014-04-20','17:45:00',1.4),('9303','2014-04-20','17:50:00',1.3),('9303','2014-04-20','17:55:00',1.22),('9303','2014-04-20','18:00:00',1.13),('9303','2014-04-20','18:05:00',1.03),('9303','2013-11-27','10:00:00',1.04),('9303','2013-11-27','10:05:00',1.14),('9303','2013-11-27','10:10:00',1.13),('9303','2013-11-27','10:15:00',1.11),('9303','2013-11-27','10:20:00',1.04),('9303','2013-11-27','10:35:00',1.01),('9303','2013-11-27','10:40:00',1.11),('9303','2013-11-27','10:45:00',1.3),('9303','2013-11-27','10:50:00',1.24),('9303','2013-11-27','10:55:00',1.19),('9303','2013-11-27','11:00:00',1.22),('9303','2013-11-27','11:05:00',1.26),('9303','2013-11-27','11:10:00',1.45),('9303','2013-11-27','11:15:00',1.33),('9303','2013-11-27','11:20:00',1.26),('9303','2013-11-27','11:25:00',1.19),('9303','2013-11-27','11:30:00',1.74),('9303','2013-11-27','11:35:00',1.74),('9303','2013-11-27','11:40:00',1.42),('9303','2013-11-27','11:45:00',1.42),('9303','2013-11-27','11:50:00',1.57),('9303','2013-11-27','11:55:00',1.87),('9303','2013-11-27','12:00:00',1.82),('9303','2013-11-27','12:05:00',1.45),('9303','2013-11-27','12:15:00',1.53),('9303','2013-11-27','12:20:00',1.79),('9303','2013-11-27','12:25:00',1.07),('9303','2013-11-27','12:30:00',1.21),('9303','2013-11-27','12:35:00',1.49),('9303','2013-11-27','12:40:00',1.11),('9303','2013-11-26','09:55:00',1.01),('9303','2013-11-26','10:00:00',1.05),('9303','2013-11-26','10:05:00',1.11),('9303','2013-11-26','10:30:00',1.06),('9303','2013-11-26','10:35:00',1.11),('9303','2013-11-26','10:40:00',1.18),('9303','2013-11-26','10:45:00',1.25),('9303','2013-11-26','10:50:00',1.3),('9303','2013-11-26','10:55:00',1.35),('9303','2013-11-26','11:00:00',1.58),('9303','2013-11-26','11:05:00',1.32),('9303','2013-11-26','11:10:00',1.79),('9303','2013-11-26','11:15:00',2.06),('9303','2013-11-26','11:20:00',1.71),('9303','2013-11-26','11:25:00',1.84),('9303','2013-11-26','11:30:00',1.92),('9303','2013-11-26','11:35:00',1.99),('9303','2013-11-26','11:40:00',2.12),('9303','2013-11-26','11:45:00',2.14),('9303','2013-11-26','11:50:00',2.09),('9303','2013-11-26','11:55:00',1.33),('9303','2013-11-26','12:05:00',1.03),('9303','2013-11-26','12:20:00',1.56),('9303','2013-11-26','12:25:00',1.52),('9303','2013-11-26','12:30:00',1.46),('9303','2013-11-26','12:35:00',1.45),('9303','2013-11-26','12:40:00',1.43),('9303','2013-11-26','12:45:00',1.32),('9303','2013-11-26','12:50:00',1.29),('9303','2013-11-26','12:55:00',1.23),('9303','2013-11-26','13:00:00',1.19),('9303','2013-11-26','13:05:00',1.13),('9303','2013-11-26','13:10:00',1.07),('9303','2013-11-26','13:15:00',1.01),('9303','2013-11-26','14:15:00',1.05),('9303','2013-11-25','09:20:00',1.01),('9303','2013-11-25','09:25:00',1.04),('9303','2013-11-25','10:20:00',1.01),('9303','2013-11-25','10:25:00',1.13),('9303','2013-11-25','10:30:00',1.57),('9303','2013-11-25','10:35:00',1.83),('9303','2013-11-25','10:40:00',1.91),('9303','2013-11-25','10:45:00',1.56),('9303','2013-11-25','10:50:00',1.34),('9303','2013-11-25','10:55:00',1.39),('9303','2013-11-25','11:00:00',1.52),('9303','2013-11-25','11:05:00',1.72),('9303','2013-11-25','11:10:00',2.15),('9303','2013-11-25','11:15:00',1.7),('9303','2013-11-25','11:20:00',1.04),('9303','2013-11-25','11:25:00',1.07),('9303','2013-11-25','11:30:00',1.13),('9303','2013-11-25','11:35:00',1.02),('9303','2013-11-25','11:50:00',1.14),('9303','2013-11-25','11:55:00',1.17),('9303','2013-11-25','12:05:00',1.03),('9303','2013-11-25','12:10:00',1.45),('9303','2013-11-25','12:15:00',1.29),('9303','2013-11-25','12:20:00',1.24),('9303','2013-11-25','12:25:00',1.27),('9303','2013-11-25','12:30:00',1.12),('9303','2013-11-25','12:40:00',1.83),('9303','2013-11-25','12:45:00',1.73),('9303','2013-11-25','12:50:00',1.29),('9303','2013-11-25','12:55:00',1.52),('9303','2013-11-25','13:00:00',1.97),('9303','2013-11-25','13:05:00',2.02),('9303','2013-11-25','13:10:00',1.49),('9303','2013-11-25','13:15:00',1.44),('9303','2013-11-25','13:20:00',1.73),('9303','2013-11-25','13:25:00',1.21),('9303','2013-11-24','09:55:00',1.03),('9303','2013-11-24','10:00:00',1.29),('9303','2013-11-24','10:05:00',1.41),('9303','2013-11-24','10:10:00',1.47),('9303','2013-11-24','10:15:00',1.31),('9303','2013-11-24','10:20:00',1.13),('9303','2013-11-24','10:25:00',1.47),('9303','2013-11-24','10:30:00',1.45),('9303','2013-11-24','10:35:00',1.04),('9303','2013-11-24','10:55:00',1.06),('9303','2013-11-24','11:00:00',1.09),('9303','2013-11-24','11:05:00',1.11),('9303','2013-11-24','11:10:00',1.18),('9303','2013-11-24','11:15:00',1.21),('9303','2013-11-24','11:20:00',1.37),('9303','2013-11-24','11:25:00',1.48),('9303','2013-11-24','11:30:00',1.28),('9303','2013-11-24','11:35:00',1.08),('9303','2013-11-24','11:50:00',1.11),('9303','2013-11-24','13:05:00',1.03),('9303','2013-11-24','13:10:00',1.15),('9303','2013-11-24','13:15:00',1.1),('9303','2013-11-23','10:25:00',1.08),('9303','2013-11-23','10:30:00',1.21),('9303','2013-11-23','10:40:00',1.72),('9303','2013-11-23','13:35:00',1.17),('9303','2013-11-23','13:40:00',1.09),('9303','2013-11-21','09:45:00',1.04),('9303','2013-11-21','09:50:00',1.05),('9303','2013-11-21','10:05:00',1.14),('9303','2013-11-21','10:10:00',1.08),('9303','2013-11-21','10:15:00',1.29),('9303','2013-11-21','10:20:00',1.41),('9303','2013-11-21','10:30:00',1.29),('9303','2013-11-21','10:35:00',1.42),('9303','2013-11-21','10:40:00',1.62),('9303','2013-11-21','10:45:00',1.34),('9303','2013-11-21','11:25:00',1.34),('9303','2013-11-21','11:30:00',1.79),('9303','2013-11-21','11:35:00',1.08),('9303','2013-11-21','11:40:00',1.66),('9303','2013-11-21','11:45:00',1.48),('9303','2013-11-21','11:50:00',1.77),('9303','2013-11-21','11:55:00',1.77),('9303','2013-11-21','12:00:00',1.04),('9303','2013-11-21','12:05:00',1.76),('9303','2013-11-21','12:10:00',1.84),('9303','2013-11-21','12:15:00',1.81),('9303','2013-11-21','12:20:00',1.82),('9303','2013-11-21','12:25:00',1.9),('9303','2013-11-21','12:30:00',2.05),('9303','2013-11-21','12:35:00',2.13),('9303','2013-11-21','12:40:00',2.22),('9303','2013-11-21','12:45:00',2.04),('9303','2013-11-21','12:50:00',1.96),('9303','2013-11-21','12:55:00',2.18),('9303','2013-11-21','13:00:00',2.08),('9303','2013-11-21','13:05:00',1.79),('9303','2013-11-21','13:10:00',1.02),('9303','2013-11-21','13:15:00',1.71),('9303','2013-11-21','13:20:00',1.65),('9303','2013-11-21','13:25:00',1.18),('9303','2013-11-21','13:45:00',1.12),('9303','2013-11-21','13:55:00',1.12),('9303','2013-11-20','09:30:00',1.04),('9303','2013-11-20','10:00:00',1.22),('9303','2013-11-20','10:15:00',1.22),('9303','2013-11-20','11:25:00',1.18),('9303','2013-11-20','11:30:00',1.13),('9303','2013-11-20','11:35:00',1.06),('9303','2013-11-20','11:40:00',1.07),('9303','2013-11-20','11:45:00',2.8),('9303','2013-11-20','11:50:00',2.55),('9303','2013-11-20','11:55:00',1.26),('9303','2013-11-20','12:20:00',1.97),('9303','2013-11-20','12:25:00',1.26),('9303','2013-11-20','12:50:00',1.09),('9303','2013-11-20','12:55:00',1.28),('9303','2013-11-20','13:00:00',1.63),('9303','2013-11-20','13:05:00',1.28),('9303','2013-11-20','13:20:00',1.21),('9303','2013-11-20','13:45:00',1.06),('9303','2013-11-20','13:50:00',1.39),('9303','2013-11-20','13:55:00',1.01),('9303','2013-11-19','10:05:00',1.05),('9303','2013-11-19','10:50:00',1.39),('9303','2013-11-19','11:20:00',1.98),('9303','2013-11-19','11:25:00',1.54),('9303','2013-11-19','11:30:00',1.33),('9303','2013-11-19','11:35:00',1.85),('9303','2013-11-19','11:40:00',1.7),('9303','2013-11-19','11:45:00',1.77),('9303','2013-11-19','11:50:00',1.78),('9303','2013-11-19','11:55:00',1.74),('9303','2013-11-19','12:00:00',1.5),('9303','2013-11-19','12:05:00',1.81),('9303','2013-11-19','12:10:00',1.79),('9303','2013-11-19','12:15:00',1.8),('9303','2013-11-19','12:20:00',1.11),('9303','2013-11-19','12:30:00',1.28),('9303','2013-11-19','12:45:00',1.68),('9303','2013-11-19','12:50:00',1.17),('9303','2013-11-19','12:55:00',2.21),('9303','2013-11-19','13:00:00',1.2),('9303','2013-11-19','13:10:00',1.04),('9303','2013-11-19','13:15:00',1.62),('9303','2013-11-19','13:20:00',1.57),('9303','2013-11-18','09:35:00',1.11),('9303','2013-11-18','10:00:00',1.05),('9303','2013-11-18','10:05:00',1.17),('9303','2013-11-18','10:10:00',1.28),('9303','2013-11-18','10:15:00',1.38),('9303','2013-11-18','10:20:00',1.23),('9303','2013-11-18','10:25:00',1.14),('9303','2013-11-18','10:30:00',1.12),('9303','2013-11-18','10:35:00',1.1),('9303','2013-11-18','10:40:00',1.15),('9303','2013-11-18','10:45:00',1.18),('9303','2013-11-18','10:50:00',1.12),('9303','2013-11-18','11:35:00',1.01),('9303','2013-11-18','11:40:00',1.06),('9303','2013-11-18','11:45:00',1.1),('9303','2013-11-18','11:50:00',1.15),('9303','2013-11-18','11:55:00',1.22),('9303','2013-11-18','12:00:00',1.28),('9303','2013-11-18','12:05:00',1.33),('9303','2013-11-18','12:10:00',1.33),('9303','2013-11-18','12:15:00',1.37),('9303','2013-11-18','12:20:00',1.44),('9303','2013-11-18','12:25:00',1.51),('9303','2013-11-18','12:30:00',1.38),('9303','2013-11-18','12:35:00',1.21),('9303','2013-11-18','12:40:00',1.04),('9303','2013-11-18','13:40:00',1.05),('9303','2014-04-19','07:55:00',1.36),('9303','2014-04-19','08:00:00',1.16),('9303','2014-04-19','08:10:00',1.36),('9303','2014-04-19','08:15:00',1.03),('9303','2014-04-19','08:20:00',1.1),('9303','2014-04-19','08:25:00',1.36),('9303','2014-04-19','08:30:00',1.75),('9303','2014-04-19','08:35:00',2.16),('9303','2014-04-19','08:40:00',1.89),('9303','2014-04-19','08:45:00',1.7),('9303','2014-04-19','08:50:00',1.41),('9303','2014-04-19','09:25:00',1.26),('9303','2014-04-19','09:30:00',1.97),('9303','2014-04-19','09:35:00',2.01),('9303','2014-04-19','09:40:00',1.18),('9303','2014-04-19','10:40:00',1.11),('9303','2014-04-19','10:45:00',1.08),('9303','2014-04-19','10:50:00',1.12),('9303','2014-04-19','10:55:00',1.42),('9303','2014-04-19','11:00:00',1.5),('9303','2014-04-19','11:05:00',1.19),('9303','2014-04-19','11:10:00',1.12),('9303','2014-04-19','11:15:00',1.64),('9303','2014-04-19','11:20:00',3.07),('9303','2014-04-19','11:25:00',2.6),('9303','2014-04-19','11:30:00',2.51),('9303','2014-04-19','11:35:00',2.27),('9303','2014-04-19','11:40:00',2.72),('9303','2014-04-19','11:45:00',1.85),('9303','2014-04-19','11:50:00',1.54),('9303','2014-04-19','13:15:00',1.14),('9303','2014-04-19','13:20:00',1.17),('9303','2014-04-19','14:30:00',1.21),('9303','2014-04-19','14:35:00',1.4),('9303','2014-04-19','14:40:00',1.61),('9303','2014-04-19','14:45:00',1.71),('9303','2014-04-19','14:50:00',1.14),('9303','2014-04-19','15:00:00',1.27),('9303','2014-04-19','15:05:00',1.21),('9303','2014-04-19','15:30:00',1.06),('9303','2014-04-19','15:50:00',2.68),('9303','2014-04-19','15:55:00',3.1),('9303','2014-04-19','16:00:00',1.89),('9303','2014-04-19','16:05:00',1.84),('9303','2014-04-19','16:10:00',1.65),('9303','2014-04-19','16:15:00',1.51),('9303','2014-04-19','16:20:00',1.75),('9303','2014-04-19','16:25:00',1.8),('9303','2014-04-19','16:30:00',2.64),('9303','2014-04-19','16:35:00',1.49),('9303','2014-04-19','16:40:00',1.06),('9303','2014-04-19','17:20:00',1.58),('9303','2014-04-19','17:25:00',1.21),('9303','2014-04-19','17:30:00',1.01),('9303','2013-11-17','09:50:00',1.01),('9303','2013-11-17','09:55:00',1.09),('9303','2013-11-17','10:00:00',1.17),('9303','2013-11-17','10:05:00',1.24),('9303','2013-11-17','10:10:00',1.3),('9303','2013-11-17','10:15:00',1.38),('9303','2013-11-17','10:20:00',1.44),('9303','2013-11-17','10:25:00',1.45),('9303','2013-11-17','10:30:00',1.51),('9303','2013-11-17','10:35:00',1.47),('9303','2013-11-17','10:40:00',1.56),('9303','2013-11-17','10:45:00',1.56),('9303','2013-11-17','10:50:00',1.62),('9303','2013-11-17','10:55:00',1.68),('9303','2013-11-17','11:00:00',1.66),('9303','2013-11-17','11:05:00',1.75),('9303','2013-11-17','11:10:00',1.78),('9303','2013-11-17','11:15:00',1.78),('9303','2013-11-17','11:20:00',1.83),('9303','2013-11-17','11:25:00',1.82),('9303','2013-11-17','11:30:00',1.85),('9303','2013-11-17','11:35:00',1.83),('9303','2013-11-17','11:40:00',1.85),('9303','2013-11-17','11:45:00',1.89),('9303','2013-11-17','11:50:00',1.88),('9303','2013-11-17','11:55:00',1.93),('9303','2013-11-17','12:00:00',1.91),('9303','2013-11-17','12:05:00',1.91),('9303','2013-11-17','12:10:00',1.92),('9303','2013-11-17','12:15:00',1.92),('9303','2013-11-17','12:20:00',1.91),('9303','2013-11-17','12:25:00',1.89),('9303','2013-11-17','12:30:00',1.8),('9303','2013-11-17','12:35:00',1.77),('9303','2013-11-17','12:40:00',1.71),('9303','2013-11-17','12:45:00',1.71),('9303','2013-11-17','12:50:00',1.66),('9303','2013-11-17','12:55:00',1.61),('9303','2013-11-17','13:00:00',1.57),('9303','2013-11-17','13:05:00',1.48),('9303','2013-11-17','13:10:00',1.46),('9303','2013-11-17','13:15:00',1.39),('9303','2013-11-17','13:20:00',1.32),('9303','2013-11-17','13:35:00',1.19),('9303','2013-11-15','09:15:00',1.05),('9303','2013-11-15','09:30:00',1.01),('9303','2013-11-15','09:35:00',1.1),('9303','2013-11-15','10:15:00',1.15),('9303','2013-11-15','10:20:00',1.2),('9303','2013-11-15','10:55:00',1.25),('9303','2013-11-15','11:00:00',1.29),('9303','2013-11-15','11:05:00',1.15),('9303','2013-11-15','11:10:00',1.09),('9303','2013-11-15','11:15:00',1.15),('9303','2013-11-15','11:20:00',1.44),('9303','2013-11-15','11:25:00',2.02),('9303','2013-11-15','11:30:00',1.54),('9303','2013-11-15','11:35:00',1.54),('9303','2013-11-15','11:40:00',1.74),('9303','2013-11-15','11:45:00',1.41),('9303','2013-11-15','11:50:00',1.26),('9303','2013-11-15','11:55:00',1.14),('9303','2013-11-15','12:00:00',1.17),('9303','2013-11-15','12:05:00',1.2),('9303','2013-11-15','12:10:00',1.07),('9303','2013-11-15','12:15:00',1.12),('9303','2013-11-15','12:20:00',1.14),('9303','2013-11-15','12:25:00',1.54),('9303','2013-11-15','12:30:00',1.39),('9303','2013-11-15','12:35:00',1.16),('9303','2013-11-15','12:40:00',1.09),('9303','2013-11-15','12:45:00',1.03),('9303','2013-11-15','12:50:00',1.27),('9303','2013-11-15','12:55:00',1.36),('9303','2013-11-15','13:00:00',1.25),('9303','2013-11-15','13:05:00',1.16),('9303','2013-11-15','13:10:00',1.09),('9303','2013-11-15','13:45:00',1.19),('9303','2013-11-15','13:50:00',1.35),('9303','2013-11-14','09:20:00',1.05),('9303','2013-11-14','09:25:00',1.1),('9303','2013-11-14','09:30:00',1.18),('9303','2013-11-14','09:35:00',1.19),('9303','2013-11-14','09:40:00',1.29),('9303','2013-11-14','09:45:00',1.36),('9303','2013-11-14','09:50:00',1.17),('9303','2013-11-14','10:05:00',1.1),('9303','2013-11-14','10:10:00',1.18),('9303','2013-11-14','10:15:00',1.66),('9303','2013-11-14','10:20:00',1.65),('9303','2013-11-14','10:25:00',1.7),('9303','2013-11-14','10:30:00',1.68),('9303','2013-11-14','10:35:00',1.6),('9303','2013-11-14','10:40:00',1.65),('9303','2013-11-14','10:45:00',1.8),('9303','2013-11-14','10:50:00',1.82),('9303','2013-11-14','10:55:00',1.83),('9303','2013-11-14','11:00:00',1.87),('9303','2013-11-14','11:05:00',1.91),('9303','2013-11-14','11:10:00',2.02),('9303','2013-11-14','11:15:00',2.07),('9303','2013-11-14','11:20:00',2),('9303','2013-11-14','11:25:00',2.15),('9303','2013-11-14','11:30:00',2.11),('9303','2013-11-14','11:35:00',2.01),('9303','2013-11-14','11:40:00',1.88),('9303','2013-11-14','11:45:00',1.29),('9303','2013-11-14','11:50:00',1.13),('9303','2013-11-14','11:55:00',1.37),('9303','2013-11-14','12:00:00',1.93),('9303','2013-11-14','12:05:00',1.17),('9303','2013-11-14','12:10:00',1.24),('9303','2013-11-14','12:15:00',1.38),('9303','2013-11-14','12:20:00',1.21),('9303','2013-11-14','12:25:00',1.03),('9303','2013-11-14','12:35:00',1.02),('9303','2013-11-14','12:45:00',1.02),('9303','2013-11-14','12:50:00',1.09),('9303','2013-11-14','12:55:00',1.06),('9303','2013-11-14','13:00:00',1.05),('9303','2013-11-13','10:20:00',1.59),('9303','2013-11-13','10:25:00',1.92),('9303','2013-11-13','10:30:00',2),('9303','2013-11-13','10:35:00',2.55),('9303','2013-11-13','10:40:00',2.41),('9303','2013-11-13','10:45:00',2.11),('9303','2013-11-13','10:50:00',2.67),('9303','2013-11-13','10:55:00',2.53),('9303','2013-11-13','11:00:00',2.24),('9303','2013-11-13','11:50:00',1.14),('9303','2013-11-13','11:55:00',1.02),('9303','2013-11-13','13:00:00',1.03),('9303','2013-11-13','13:05:00',1.3),('9303','2013-11-13','13:10:00',1.14),('9303','2013-11-13','13:15:00',1.15),('9303','2013-11-13','13:55:00',1.13),('9303','2013-11-13','14:00:00',1.23),('9303','2013-11-13','14:05:00',1.14),('9303','2013-11-13','14:10:00',1.09),('9303','2013-11-13','14:15:00',1.11),('9303','2013-11-13','14:20:00',1.01),('9303','2013-11-13','14:25:00',1.09),('9303','2013-11-12','11:25:00',1.16),('9303','2013-11-12','11:35:00',1),('9303','2013-11-12','11:40:00',2.11),('9303','2013-11-12','11:45:00',1.26),('9303','2013-11-12','11:50:00',1.24),('9303','2013-11-12','12:00:00',2.46),('9303','2013-11-12','12:05:00',1.08),('9303','2013-11-12','12:30:00',2.95),('9303','2013-11-12','12:35:00',2.67),('9303','2013-11-12','12:40:00',1.87),('9303','2013-11-12','12:45:00',1.8),('9303','2013-11-12','12:50:00',1.48),('9303','2013-11-12','12:55:00',1.88),('9303','2013-11-12','13:00:00',1.84),('9303','2013-11-12','13:05:00',2.09),('9303','2013-11-12','13:10:00',2.36),('9303','2013-11-12','13:15:00',2.98),('9303','2013-11-12','13:20:00',2.5),('9303','2013-11-12','13:25:00',2.66),('9303','2013-11-12','13:30:00',1.83),('9303','2013-11-12','13:35:00',1.95),('9303','2013-11-12','13:40:00',2.64),('9303','2013-11-12','13:45:00',1.52),('9303','2013-11-12','13:50:00',1.05),('9303','2013-11-12','13:55:00',1.21),('9303','2013-11-12','14:00:00',1.25),('9303','2013-11-12','14:05:00',1.04),('9303','2013-11-12','14:10:00',1.36),('9303','2013-11-12','14:15:00',1.61),('9303','2013-11-12','14:20:00',1.53),('9303','2013-11-12','14:25:00',1.23),('9303','2013-11-12','14:30:00',1),('9303','2013-11-11','09:50:00',1.16),('9303','2013-11-11','09:55:00',1.25),('9303','2013-11-11','10:10:00',1.03),('9303','2013-11-11','10:15:00',1.59),('9303','2013-11-11','10:20:00',2.3),('9303','2013-11-11','10:25:00',1.37),('9303','2013-11-11','11:05:00',1.07),('9303','2013-11-11','11:10:00',2.18),('9303','2013-11-11','11:15:00',1.99),('9303','2013-11-11','11:20:00',1.22),('9303','2013-11-11','11:25:00',2.47),('9303','2013-11-11','11:30:00',1.43),('9303','2013-11-11','11:35:00',2.35),('9303','2013-11-11','11:40:00',3.11),('9303','2013-11-11','11:45:00',2.87),('9303','2013-11-11','11:50:00',3.06),('9303','2013-11-11','11:55:00',2.91),('9303','2013-11-11','12:00:00',2.7),('9303','2013-11-11','12:05:00',2.66),('9303','2013-11-11','12:10:00',2.57),('9303','2013-11-11','12:15:00',2.59),('9303','2013-11-11','12:20:00',2.6),('9303','2013-11-11','12:25:00',2.24),('9303','2013-11-11','12:30:00',2.17),('9303','2013-11-11','12:35:00',1.18),('9303','2013-11-11','12:40:00',1.78),('9303','2013-11-11','12:45:00',1.34),('9303','2013-11-11','13:10:00',2.15),('9303','2013-11-11','13:15:00',1.39),('9303','2013-11-11','13:35:00',1.08),('9303','2013-11-11','13:40:00',1.23),('9303','2013-11-11','14:15:00',1.02),('9303','2013-11-11','14:20:00',1.16),('9303','2013-11-11','14:25:00',1.05),('9303','2013-11-10','08:50:00',1.04),('9303','2013-11-10','08:55:00',1.17),('9303','2013-11-10','09:00:00',1.03),('9303','2013-11-10','09:15:00',1),('9303','2013-11-10','09:20:00',1.24),('9303','2013-11-10','09:25:00',1.42),('9303','2013-11-10','09:30:00',1.23),('9303','2013-11-10','09:35:00',1.21),('9303','2013-11-10','09:40:00',1.3),('9303','2013-11-10','09:45:00',1.48),('9303','2013-11-10','09:50:00',1.55),('9303','2013-11-10','09:55:00',1.6),('9303','2013-11-10','10:00:00',1.69),('9303','2013-11-10','10:05:00',1.82),('9303','2013-11-10','10:10:00',1.94),('9303','2013-11-10','10:15:00',2),('9303','2013-11-10','10:20:00',1.94),('9303','2013-11-10','10:25:00',2.16),('9303','2013-11-10','10:30:00',2.4),('9303','2013-11-10','10:35:00',2.27),('9303','2013-11-10','10:40:00',2.06),('9303','2013-11-10','10:45:00',1.6),('9303','2013-11-10','10:50:00',2.26),('9303','2013-11-10','10:55:00',2.1),('9303','2013-11-10','11:00:00',2.01),('9303','2013-11-10','11:05:00',1.59),('9303','2013-11-10','11:10:00',1.2),('9303','2013-11-10','11:25:00',1.16),('9303','2013-11-10','11:35:00',1.01),('9303','2013-11-10','11:40:00',1.17),('9303','2013-11-10','11:45:00',1.56),('9303','2013-11-10','11:50:00',1.21),('9303','2013-11-10','11:55:00',1.22),('9303','2013-11-10','12:05:00',1.38),('9303','2013-11-10','12:10:00',1.48),('9303','2013-11-10','12:15:00',2.55),('9303','2013-11-10','12:20:00',2.57),('9303','2013-11-10','12:25:00',2.5),('9303','2013-11-10','12:30:00',1.65),('9303','2013-11-10','12:35:00',1.6),('9303','2013-11-10','12:40:00',2.42),('9303','2013-11-10','12:45:00',2.7),('9303','2013-11-10','12:50:00',2.88),('9303','2013-11-10','12:55:00',1.24),('9303','2013-11-10','13:00:00',1.04),('9303','2013-11-10','13:50:00',1.73),('9303','2013-11-10','13:55:00',1.58),('9303','2013-11-09','09:40:00',1.9),('9303','2013-11-09','09:45:00',1.38),('9303','2013-11-09','09:50:00',1.98),('9303','2013-11-09','09:55:00',1.98),('9303','2013-11-09','10:00:00',1.84),('9303','2013-11-09','10:05:00',1.76),('9303','2013-11-09','10:10:00',1.69),('9303','2013-11-09','10:15:00',1.66),('9303','2013-11-09','10:20:00',1.78),('9303','2013-11-09','10:25:00',2.04),('9303','2013-11-09','10:30:00',1.09),('9303','2013-11-09','10:35:00',1.26),('9303','2013-11-09','10:40:00',1.25),('9303','2013-11-09','10:45:00',1.26),('9303','2013-11-09','10:50:00',1.26),('9303','2013-11-09','10:55:00',1.95),('9303','2013-11-09','11:00:00',1.92),('9303','2013-11-09','11:05:00',2.81),('9303','2013-11-09','11:10:00',2.66),('9303','2013-11-09','11:15:00',2.94),('9303','2013-11-09','11:20:00',2.19),('9303','2013-11-09','11:25:00',1.22),('9303','2013-11-09','11:30:00',1.79),('9303','2013-11-09','11:35:00',1.82),('9303','2013-11-09','11:40:00',1.97),('9303','2013-11-09','11:45:00',1.35),('9303','2013-11-09','11:50:00',1.76),('9303','2013-11-09','11:55:00',2.06),('9303','2013-11-09','12:00:00',2.16),('9303','2013-11-09','12:05:00',2.55),('9303','2013-11-09','12:10:00',1.8),('9303','2013-11-09','12:15:00',1.8),('9303','2013-11-09','12:20:00',1.02),('9303','2013-11-09','12:25:00',1.35),('9303','2013-11-09','12:30:00',2.28),('9303','2013-11-09','12:35:00',2.66),('9303','2013-11-09','12:40:00',1.93),('9303','2013-11-09','12:45:00',1.44),('9303','2013-11-09','12:50:00',1.98),('9303','2013-11-09','12:55:00',1.71),('9303','2013-11-09','13:00:00',2.71),('9303','2013-11-09','13:05:00',2.31),('9303','2013-11-09','13:10:00',2.46),('9303','2013-11-09','13:15:00',2.32),('9303','2013-11-09','13:20:00',1.4),('9303','2013-11-09','13:25:00',1.94),('9303','2013-11-09','13:30:00',2.08),('9303','2013-11-09','13:35:00',1.98),('9303','2013-11-09','13:40:00',1.79),('9303','2013-11-09','13:45:00',1.71),('9303','2013-11-09','13:50:00',1.66),('9303','2013-11-09','13:55:00',1.59),('9303','2013-11-09','14:00:00',1.5),('9303','2013-11-09','14:05:00',1.33),('9303','2013-11-09','14:20:00',1.45),('9303','2013-11-09','14:25:00',1.08),('9303','2013-11-08','09:15:00',1.01),('9303','2013-11-08','09:20:00',1.6),('9303','2013-11-08','09:25:00',1.63),('9303','2013-11-08','09:30:00',1.89),('9303','2013-11-08','09:35:00',1.97),('9303','2013-11-08','09:40:00',1.08),('9303','2013-11-08','09:50:00',1.53),('9303','2013-11-08','10:00:00',1.22),('9303','2013-11-08','10:05:00',1.32),('9303','2013-11-08','10:10:00',1.62),('9303','2013-11-08','10:45:00',1.02),('9303','2013-11-08','10:50:00',2.25),('9303','2013-11-08','10:55:00',1.39),('9303','2013-11-08','11:20:00',1.09),('9303','2013-11-08','11:25:00',2.8),('9303','2013-11-08','11:30:00',2.95),('9303','2013-11-08','11:35:00',2.86),('9303','2013-11-08','11:40:00',2.82),('9303','2013-11-08','11:45:00',2.69),('9303','2013-11-08','11:50:00',2.89),('9303','2013-11-08','11:55:00',2.27),('9303','2013-11-08','12:00:00',2.34),('9303','2013-11-08','12:05:00',2.6),('9303','2013-11-08','12:10:00',2.59),('9303','2013-11-08','12:15:00',1.76),('9303','2013-11-08','12:20:00',1.47),('9303','2013-11-08','12:40:00',2.34),('9303','2013-11-08','12:45:00',1.01),('9303','2013-11-08','12:50:00',2.42),('9303','2013-11-08','12:55:00',2.52),('9303','2013-11-08','13:00:00',2.48),('9303','2013-11-08','13:05:00',2.28),('9303','2013-11-08','13:10:00',2.39),('9303','2013-11-08','13:15:00',2.39),('9303','2013-11-08','13:20:00',1.48),('9303','2013-11-08','13:25:00',1.7),('9303','2013-11-08','13:30:00',1.07),('9303','2013-11-08','13:35:00',1.94),('9303','2013-11-08','13:40:00',1.91),('9303','2013-11-08','13:45:00',1.75),('9303','2013-11-08','13:50:00',1.68),('9303','2013-11-08','13:55:00',1.61),('9303','2013-11-08','14:00:00',1.56),('9303','2013-11-08','14:05:00',1.41),('9303','2013-11-08','14:10:00',1.32),('9303','2013-11-08','14:25:00',1.05),('9303','2013-11-08','14:35:00',1.08),('9303','2014-04-18','08:05:00',1.46),('9303','2014-04-18','08:10:00',1.33),('9303','2014-04-18','08:40:00',1.41),('9303','2014-04-18','08:45:00',1.29),('9303','2014-04-18','08:50:00',1.01),('9303','2014-04-18','09:00:00',1.12),('9303','2014-04-18','09:05:00',2.38),('9303','2014-04-18','09:10:00',3.08),('9303','2014-04-18','09:15:00',2.83),('9303','2014-04-18','09:20:00',2.6),('9303','2014-04-18','09:25:00',1.83),('9303','2014-04-18','09:30:00',2.97),('9303','2014-04-18','09:35:00',1.65),('9303','2014-04-18','09:40:00',1.07),('9303','2014-04-18','09:45:00',1.72),('9303','2014-04-18','09:50:00',2.78),('9303','2014-04-18','09:55:00',2.89),('9303','2014-04-18','10:00:00',2.44),('9303','2014-04-18','10:05:00',1.54),('9303','2014-04-18','10:10:00',1.41),('9303','2014-04-18','10:15:00',1.57),('9303','2014-04-18','10:20:00',1.38),('9303','2014-04-18','10:25:00',1.44),('9303','2014-04-18','10:30:00',1.2),('9303','2014-04-18','10:35:00',1.09),('9303','2014-04-18','10:40:00',1.28),('9303','2014-04-18','10:45:00',2.49),('9303','2014-04-18','10:50:00',3),('9303','2014-04-18','10:55:00',2.85),('9303','2014-04-18','11:00:00',1.74),('9303','2014-04-18','11:05:00',1.55),('9303','2014-04-18','11:10:00',2.02),('9303','2014-04-18','11:15:00',2.52),('9303','2014-04-18','11:20:00',1.72),('9303','2014-04-18','11:25:00',1.3),('9303','2014-04-18','11:30:00',1.6),('9303','2014-04-18','11:35:00',1.5),('9303','2014-04-18','11:40:00',1.58),('9303','2014-04-18','11:45:00',1.5),('9303','2014-04-18','11:50:00',1.71),('9303','2014-04-18','11:55:00',1.67),('9303','2014-04-18','12:00:00',1.72),('9303','2014-04-18','12:05:00',2.69),('9303','2014-04-18','12:10:00',3.09),('9303','2014-04-18','12:15:00',3.1),('9303','2014-04-18','12:20:00',3.85),('9303','2014-04-18','12:25:00',2.81),('9303','2014-04-18','12:30:00',4.41),('9303','2014-04-18','12:35:00',4.16),('9303','2014-04-18','12:40:00',4.3),('9303','2014-04-18','12:45:00',3.67),('9303','2014-04-18','12:50:00',3.61),('9303','2014-04-18','12:55:00',2.64),('9303','2014-04-18','13:00:00',4.44),('9303','2014-04-18','13:05:00',2.84),('9303','2014-04-18','13:10:00',2.49),('9303','2014-04-18','13:15:00',2.37),('9303','2014-04-18','13:20:00',2.18),('9303','2014-04-18','13:25:00',1.56),('9303','2014-04-18','13:30:00',1.33),('9303','2014-04-18','13:35:00',1.32),('9303','2014-04-18','13:40:00',1.19),('9303','2014-04-18','13:45:00',1.02),('9303','2014-04-18','13:50:00',1.31),('9303','2014-04-18','13:55:00',2.15),('9303','2014-04-18','14:00:00',1.88),('9303','2014-04-18','14:05:00',1.55),('9303','2014-04-18','14:10:00',1.37),('9303','2014-04-18','14:15:00',1.23),('9303','2014-04-18','14:20:00',1.45),('9303','2014-04-18','14:25:00',1.89),('9303','2014-04-18','14:30:00',2.14),('9303','2014-04-18','14:35:00',2.43),('9303','2014-04-18','14:40:00',2.19),('9303','2014-04-18','14:45:00',2.74),('9303','2014-04-18','14:50:00',3.18),('9303','2014-04-18','14:55:00',2.23),('9303','2014-04-18','15:00:00',4.18),('9303','2014-04-18','15:05:00',2.32),('9303','2014-04-18','15:10:00',1.89),('9303','2014-04-18','15:15:00',2.2),('9303','2014-04-18','15:20:00',1.91),('9303','2014-04-18','15:25:00',2.16),('9303','2014-04-18','15:30:00',3.15),('9303','2014-04-18','15:35:00',3.29),('9303','2014-04-18','15:40:00',2.37),('9303','2014-04-18','15:45:00',2.26),('9303','2014-04-18','15:50:00',2.67),('9303','2014-04-18','15:55:00',2.51),('9303','2014-04-18','16:00:00',2.13),('9303','2014-04-18','16:05:00',1.67),('9303','2014-04-18','16:10:00',1.29),('9303','2014-04-18','16:15:00',1.14),('9303','2014-04-18','16:20:00',1.23),('9303','2014-04-18','16:25:00',1.78),('9303','2014-04-18','16:30:00',1.99),('9303','2014-04-18','16:35:00',2.01),('9303','2014-04-18','16:40:00',2.97),('9303','2014-04-18','16:45:00',2.72),('9303','2014-04-18','16:50:00',2.61),('9303','2014-04-18','16:55:00',1.84),('9303','2014-04-18','17:00:00',2.03),('9303','2014-04-18','17:05:00',2.5),('9303','2014-04-18','17:10:00',2.02),('9303','2014-04-18','17:15:00',1.78),('9303','2014-04-18','17:20:00',1.8),('9303','2014-04-18','17:25:00',1.85),('9303','2014-04-18','17:30:00',1.71),('9303','2014-04-18','17:35:00',1.6),('9303','2014-04-18','17:40:00',1.51),('9303','2014-04-18','17:45:00',1.42),('9303','2014-04-18','17:50:00',1.33),('9303','2014-04-18','17:55:00',1.25),('9303','2014-04-18','18:00:00',1.17),('9303','2014-04-18','18:05:00',1.03),('9303','2013-11-07','09:05:00',1),('9303','2013-11-07','09:10:00',1.1),('9303','2013-11-07','09:15:00',1.15),('9303','2013-11-07','09:20:00',1.27),('9303','2013-11-07','09:25:00',1.33),('9303','2013-11-07','09:30:00',1.41),('9303','2013-11-07','09:35:00',1.38),('9303','2013-11-07','09:40:00',1.47),('9303','2013-11-07','09:45:00',1.6),('9303','2013-11-07','09:50:00',1.59),('9303','2013-11-07','09:55:00',1.66),('9303','2013-11-07','10:00:00',1.75),('9303','2013-11-07','10:05:00',1.78),('9303','2013-11-07','10:10:00',1.86),('9303','2013-11-07','10:15:00',1.88),('9303','2013-11-07','10:20:00',1.98),('9303','2013-11-07','10:25:00',1.95),('9303','2013-11-07','10:30:00',2.06),('9303','2013-11-07','10:35:00',2.06),('9303','2013-11-07','10:40:00',2.12),('9303','2013-11-07','10:45:00',2.16),('9303','2013-11-07','10:50:00',2.2),('9303','2013-11-07','10:55:00',2.16),('9303','2013-11-07','11:00:00',2.23),('9303','2013-11-07','11:05:00',2.27),('9303','2013-11-07','11:10:00',2.27),('9303','2013-11-07','11:15:00',2.32),('9303','2013-11-07','11:20:00',2.32),('9303','2013-11-07','11:25:00',2.31),('9303','2013-11-07','11:30:00',2.27),('9303','2013-11-07','11:35:00',2.29),('9303','2013-11-07','11:40:00',2.33),('9303','2013-11-07','11:45:00',2.38),('9303','2013-11-07','11:50:00',2.36),('9303','2013-11-07','11:55:00',2.38),('9303','2013-11-07','12:00:00',2.41),('9303','2013-11-07','12:05:00',2.4),('9303','2013-11-07','12:10:00',2.42),('9303','2013-11-07','12:15:00',2.4),('9303','2013-11-07','12:20:00',2.4),('9303','2013-11-07','12:25:00',2.3),('9303','2013-11-07','12:30:00',2.22),('9303','2013-11-07','12:35:00',2.23),('9303','2013-11-07','12:40:00',2.16),('9303','2013-11-07','12:45:00',2.13),('9303','2013-11-07','12:50:00',2.09),('9303','2013-11-07','12:55:00',2),('9303','2013-11-07','13:00:00',2.14),('9303','2013-11-07','13:05:00',1.9),('9303','2013-11-07','13:15:00',1.33),('9303','2013-11-07','13:20:00',1.01),('9303','2013-11-07','13:35:00',1.64),('9303','2013-11-07','13:40:00',2.32),('9303','2013-11-07','13:45:00',1.63),('9303','2013-11-07','13:50:00',1.72),('9303','2013-11-07','13:55:00',1.65),('9303','2013-11-07','14:00:00',1.05),('9303','2013-11-07','14:05:00',1.47),('9303','2013-11-07','14:25:00',1.17),('9303','2013-11-06','09:20:00',1.27),('9303','2013-11-06','09:25:00',1.38),('9303','2013-11-06','09:30:00',1.53),('9303','2013-11-06','09:35:00',1.54),('9303','2013-11-06','09:40:00',1.6),('9303','2013-11-06','09:45:00',1.67),('9303','2013-11-06','09:50:00',1.71),('9303','2013-11-06','09:55:00',1.69),('9303','2013-11-06','10:00:00',1.84),('9303','2013-11-06','10:05:00',1.9),('9303','2013-11-06','10:10:00',1.98),('9303','2013-11-06','10:15:00',2.02),('9303','2013-11-06','10:20:00',2.12),('9303','2013-11-06','10:25:00',2.13),('9303','2013-11-06','10:30:00',2.25),('9303','2013-11-06','10:35:00',2.25),('9303','2013-11-06','10:40:00',2.33),('9303','2013-11-06','10:45:00',2.37),('9303','2013-11-06','10:50:00',2.4),('9303','2013-11-06','10:55:00',2.43),('9303','2013-11-06','11:00:00',2.49),('9303','2013-11-06','11:05:00',2.53),('9303','2013-11-06','11:10:00',2.52),('9303','2013-11-06','11:15:00',2.58),('9303','2013-11-06','11:20:00',2.61),('9303','2013-11-06','11:25:00',2.62),('9303','2013-11-06','11:30:00',2.62),('9303','2013-11-06','11:35:00',2.62),('9303','2013-11-06','11:40:00',2.74),('9303','2013-11-06','11:45:00',2.75),('9303','2013-11-06','11:50:00',2.75),('9303','2013-11-06','11:55:00',2.77),('9303','2013-11-06','12:00:00',2.78),('9303','2013-11-06','12:05:00',2.78),('9303','2013-11-06','12:10:00',2.77),('9303','2013-11-06','12:15:00',2.75),('9303','2013-11-06','12:20:00',2.68),('9303','2013-11-06','12:25:00',2.63),('9303','2013-11-06','12:30:00',2.57),('9303','2013-11-06','12:35:00',2.48),('9303','2013-11-06','12:40:00',2.45),('9303','2013-11-06','12:45:00',2.37),('9303','2013-11-06','12:50:00',2.37),('9303','2013-11-06','12:55:00',2.33),('9303','2013-11-06','13:00:00',2.3),('9303','2013-11-06','13:05:00',2.25),('9303','2013-11-06','13:10:00',2.16),('9303','2013-11-06','13:15:00',2.14),('9303','2013-11-06','13:20:00',2.07),('9303','2013-11-06','13:25:00',2.05),('9303','2013-11-06','13:30:00',1.97),('9303','2013-11-06','13:35:00',1.78),('9303','2013-11-06','13:40:00',1.79),('9303','2013-11-06','13:45:00',1.75),('9303','2013-11-06','13:50:00',1.72),('9303','2013-11-06','13:55:00',1.63),('9303','2013-11-06','14:00:00',1.6),('9303','2013-11-06','14:10:00',1.26),('9303','2013-11-06','14:15:00',1.3),('9303','2013-11-06','14:20:00',1.25),('9303','2013-11-06','14:25:00',1.18),('9303','2013-11-06','14:30:00',1.06),('9303','2013-11-05','08:35:00',1.05),('9303','2013-11-05','08:40:00',1.12),('9303','2013-11-05','10:20:00',1.21),('9303','2013-11-05','10:25:00',1.85),('9303','2013-11-05','10:30:00',1.56),('9303','2013-11-05','10:35:00',2.06),('9303','2013-11-05','10:40:00',1.64),('9303','2013-11-05','10:45:00',1.71),('9303','2013-11-05','10:50:00',1.53),('9303','2013-11-05','10:55:00',1.28),('9303','2013-11-05','11:00:00',1),('9303','2013-11-05','11:40:00',1.3),('9303','2013-11-05','11:45:00',1.35),('9303','2013-11-05','11:50:00',1.26),('9303','2013-11-05','11:55:00',1.08),('9303','2013-11-05','12:10:00',1.17),('9303','2013-11-05','12:15:00',1.3),('9303','2013-11-05','12:20:00',1.71),('9303','2013-11-05','12:25:00',1.72),('9303','2013-11-05','12:30:00',1.13),('9303','2013-11-05','13:35:00',1.89),('9303','2013-11-05','13:40:00',2.08),('9303','2013-11-05','13:45:00',2),('9303','2013-11-05','13:50:00',1.25),('9303','2013-11-05','13:55:00',1.22),('9303','2013-11-05','14:00:00',1.88),('9303','2013-11-05','14:05:00',2.12),('9303','2013-11-05','14:10:00',2.19),('9303','2013-11-05','14:15:00',1.33),('9303','2013-11-05','14:30:00',1.06),('9303','2013-11-05','14:35:00',1.12),('9303','2013-11-04','09:10:00',1.37),('9303','2013-11-04','09:15:00',1.69),('9303','2013-11-04','09:20:00',1.65),('9303','2013-11-04','09:25:00',2.22),('9303','2013-11-04','09:30:00',1.33),('9303','2013-11-04','10:05:00',2.08),('9303','2013-11-04','10:10:00',2.12),('9303','2013-11-04','10:15:00',2.24),('9303','2013-11-04','10:20:00',2.32),('9303','2013-11-04','10:25:00',2.52),('9303','2013-11-04','10:30:00',2.82),('9303','2013-11-04','10:35:00',2.27),('9303','2013-11-04','10:40:00',2.7),('9303','2013-11-04','10:45:00',2.17),('9303','2013-11-04','10:50:00',1.61),('9303','2013-11-04','10:55:00',1.62),('9303','2013-11-04','11:00:00',2.04),('9303','2013-11-04','11:05:00',3.31),('9303','2013-11-04','11:10:00',1.09),('9303','2013-11-04','11:15:00',2.29),('9303','2013-11-04','11:20:00',1.12),('9303','2013-11-04','11:30:00',2.03),('9303','2013-11-04','11:35:00',2.55),('9303','2013-11-04','11:40:00',1.83),('9303','2013-11-04','11:45:00',2.43),('9303','2013-11-04','11:50:00',3.65),('9303','2013-11-04','11:55:00',3.2),('9303','2013-11-04','12:00:00',2.96),('9303','2013-11-04','12:05:00',2.99),('9303','2013-11-04','12:10:00',2.98),('9303','2013-11-04','12:15:00',2.47),('9303','2013-11-04','12:20:00',2.58),('9303','2013-11-04','12:25:00',2.75),('9303','2013-11-04','12:30:00',2.73),('9303','2013-11-04','12:35:00',2.65),('9303','2013-11-04','12:40:00',2.62),('9303','2013-11-04','12:45:00',2.55),('9303','2013-11-04','12:50:00',2.49),('9303','2013-11-04','12:55:00',2.43),('9303','2013-11-04','13:00:00',2.4),('9303','2013-11-04','13:05:00',2.34),('9303','2013-11-04','13:10:00',2.32),('9303','2013-11-04','13:15:00',2.3),('9303','2013-11-04','13:20:00',1.87),('9303','2013-11-04','13:25:00',2.24),('9303','2013-11-04','13:30:00',2.14),('9303','2013-11-04','13:35:00',2.16),('9303','2013-11-04','13:40:00',1.82),('9303','2013-11-04','13:45:00',2.1),('9303','2013-11-04','13:50:00',1.98),('9303','2013-11-04','13:55:00',1.7),('9303','2013-11-04','14:00:00',1.42),('9303','2013-11-04','14:05:00',1.45),('9303','2013-11-04','14:10:00',1.75),('9303','2013-11-04','14:15:00',1.87),('9303','2013-11-04','14:20:00',1.74),('9303','2013-11-04','14:35:00',1.49),('9303','2013-11-04','14:40:00',1.24),('9303','2013-11-03','08:55:00',1.11),('9303','2013-11-03','09:40:00',1.97),('9303','2013-11-03','09:45:00',1.46),('9303','2013-11-03','10:10:00',1.57),('9303','2013-11-03','10:20:00',2.15),('9303','2013-11-03','10:25:00',2.17),('9303','2013-11-03','10:30:00',2.42),('9303','2013-11-03','10:35:00',1.88),('9303','2013-11-03','11:20:00',1.49),('9303','2013-11-03','11:25:00',1.74),('9303','2013-11-03','11:30:00',1.6),('9303','2013-11-03','11:35:00',2.62),('9303','2013-11-03','11:40:00',3.04),('9303','2013-11-03','11:45:00',3.19),('9303','2013-11-03','11:50:00',3.28),('9303','2013-11-03','11:55:00',2.57),('9303','2013-11-03','12:00:00',2.14),('9303','2013-11-03','12:05:00',2.46),('9303','2013-11-03','12:10:00',2.31),('9303','2013-11-03','12:15:00',1.16),('9303','2013-11-03','12:20:00',1.19),('9303','2013-11-03','12:25:00',1.54),('9303','2013-11-03','12:30:00',1.36),('9303','2013-11-03','12:40:00',1.3),('9303','2013-11-03','12:45:00',1.07),('9303','2013-11-03','13:40:00',1.25),('9303','2013-11-03','13:45:00',1.72),('9303','2013-11-03','13:50:00',1.03),('9303','2013-11-03','13:55:00',1.01),('9303','2013-11-03','14:00:00',1.06),('9303','2013-11-03','14:05:00',1.93),('9303','2013-11-03','14:10:00',1.69),('9303','2013-11-03','14:15:00',1.96),('9303','2013-11-03','14:20:00',1.54),('9303','2013-11-03','14:25:00',1.64),('9303','2013-11-03','14:30:00',1.03),('9303','2013-11-03','14:35:00',1.13),('9303','2013-11-03','14:40:00',1.42),('9303','2013-11-03','14:45:00',1.16),('9303','2013-11-02','08:50:00',1.07),('9303','2013-11-02','08:55:00',1.16),('9303','2013-11-02','09:00:00',1.27),('9303','2013-11-02','09:05:00',1.43),('9303','2013-11-02','09:10:00',1.56),('9303','2013-11-02','09:20:00',1.42),('9303','2013-11-02','09:25:00',1.72),('9303','2013-11-02','09:30:00',1.7),('9303','2013-11-02','09:35:00',1.68),('9303','2013-11-02','09:40:00',1.76),('9303','2013-11-02','09:45:00',1.45),('9303','2013-11-02','09:50:00',2.07),('9303','2013-11-02','09:55:00',2.06),('9303','2013-11-02','10:00:00',2.36),('9303','2013-11-02','10:05:00',2.4),('9303','2013-11-02','10:10:00',1.09),('9303','2013-11-02','10:15:00',1.03),('9303','2013-11-02','11:00:00',1.04),('9303','2013-11-02','11:05:00',1.25),('9303','2013-11-02','11:10:00',1.13),('9303','2013-11-02','11:55:00',1.53),('9303','2013-11-02','12:00:00',3.34),('9303','2013-11-02','12:05:00',3.33),('9303','2013-11-02','12:10:00',2.99),('9303','2013-11-02','12:15:00',3.17),('9303','2013-11-02','12:20:00',3.37),('9303','2013-11-02','12:25:00',3.24),('9303','2013-11-02','12:30:00',3.37),('9303','2013-11-02','12:35:00',3.18),('9303','2013-11-02','12:40:00',2.61),('9303','2013-11-02','12:45:00',2.06),('9303','2013-11-02','12:50:00',2.47),('9303','2013-11-02','12:55:00',2.81),('9303','2013-11-02','13:00:00',2.18),('9303','2013-11-02','13:05:00',2.58),('9303','2013-11-02','13:10:00',3.01),('9303','2013-11-02','13:15:00',1.69),('9303','2013-11-02','13:30:00',1.01),('9303','2013-11-02','13:35:00',1.66),('9303','2013-11-02','13:40:00',2.57),('9303','2013-11-02','13:45:00',2.25),('9303','2013-11-02','13:50:00',2.76),('9303','2013-11-02','13:55:00',2.57),('9303','2013-11-02','14:00:00',2.35),('9303','2013-11-02','14:05:00',2),('9303','2013-11-02','14:10:00',1.78),('9303','2013-11-02','14:15:00',1.67),('9303','2013-11-02','14:20:00',1.58),('9303','2013-11-02','14:25:00',1.48),('9303','2013-11-02','14:30:00',1.4),('9303','2013-11-02','14:35:00',1.28),('9303','2013-11-02','14:40:00',1.18),('9303','2013-11-02','14:45:00',1.06),('9303','2013-11-01','08:45:00',1.01),('9303','2013-11-01','08:50:00',1.02),('9303','2013-11-01','08:55:00',1.13),('9303','2013-11-01','09:00:00',1.23),('9303','2013-11-01','09:05:00',1.39),('9303','2013-11-01','09:10:00',1.49),('9303','2013-11-01','09:15:00',1.55),('9303','2013-11-01','09:20:00',1.63),('9303','2013-11-01','09:25:00',1.7),('9303','2013-11-01','09:30:00',1.77),('9303','2013-11-01','09:35:00',1.79),('9303','2013-11-01','09:40:00',1.85),('9303','2013-11-01','09:45:00',1.86),('9303','2013-11-01','09:50:00',1.99),('9303','2013-11-01','09:55:00',2.04),('9303','2013-11-01','10:00:00',2.17),('9303','2013-11-01','10:05:00',2.24),('9303','2013-11-01','10:10:00',2.29),('9303','2013-11-01','10:15:00',2.3),('9303','2013-11-01','10:20:00',2.4),('9303','2013-11-01','10:25:00',2.4),('9303','2013-11-01','10:30:00',2.4),('9303','2013-11-01','10:35:00',2.43),('9303','2013-11-01','10:40:00',2.48),('9303','2013-11-01','10:45:00',2.44),('9303','2013-11-01','10:50:00',2.47),('9303','2013-11-01','10:55:00',2.44),('9303','2013-11-01','11:00:00',2.53),('9303','2013-11-01','11:05:00',2.39),('9303','2013-11-01','11:10:00',2.12),('9303','2013-11-01','11:15:00',2.1),('9303','2013-11-01','11:20:00',2.59),('9303','2013-11-01','11:25:00',2.77),('9303','2013-11-01','11:30:00',2.77),('9303','2013-11-01','11:35:00',2.64),('9303','2013-11-01','11:40:00',2.46),('9303','2013-11-01','11:45:00',2.45),('9303','2013-11-01','11:50:00',2.81),('9303','2013-11-01','11:55:00',2.89),('9303','2013-11-01','12:00:00',2.93),('9303','2013-11-01','12:05:00',2.8),('9303','2013-11-01','12:10:00',2.61),('9303','2013-11-01','12:15:00',2.54),('9303','2013-11-01','12:20:00',2.09),('9303','2013-11-01','12:25:00',2.42),('9303','2013-11-01','12:30:00',2.41),('9303','2013-11-01','12:35:00',2.07),('9303','2013-11-01','13:20:00',1.14),('9303','2013-11-01','13:30:00',1.07),('9303','2013-11-01','13:35:00',1.11),('9303','2013-11-01','13:40:00',1.13),('9303','2013-11-01','13:45:00',1.06),('9303','2013-10-31','08:40:00',1.22),('9303','2013-10-31','08:45:00',1.24),('9303','2013-10-31','08:50:00',1.33),('9303','2013-10-31','08:55:00',1.06),('9303','2013-10-31','09:00:00',1.18),('9303','2013-10-31','09:05:00',1.24),('9303','2013-10-31','09:15:00',1.1),('9303','2013-10-31','09:20:00',1.12),('9303','2013-10-31','09:35:00',1.5),('9303','2013-10-31','09:40:00',1.39),('9303','2013-10-31','09:45:00',1.55),('9303','2013-10-31','09:50:00',1.61),('9303','2013-10-31','09:55:00',1.59),('9303','2013-10-31','10:00:00',1.63),('9303','2013-10-31','10:05:00',1.63),('9303','2013-10-31','10:10:00',1.39),('9303','2013-10-31','10:15:00',1.29),('9303','2013-10-31','10:20:00',1.33),('9303','2013-10-31','10:25:00',1.5),('9303','2013-10-31','10:30:00',1.5),('9303','2013-10-31','10:35:00',1.57),('9303','2013-10-31','10:40:00',1.75),('9303','2013-10-31','10:45:00',1.58),('9303','2013-10-31','10:50:00',1.61),('9303','2013-10-31','10:55:00',1.78),('9303','2013-10-31','11:00:00',2.21),('9303','2013-10-31','11:05:00',2.5),('9303','2013-10-31','11:10:00',2.48),('9303','2013-10-31','11:15:00',1.85),('9303','2013-10-31','11:20:00',2.44),('9303','2013-10-31','11:25:00',2.25),('9303','2013-10-31','11:30:00',2.3),('9303','2013-10-31','11:35:00',2.29),('9303','2013-10-31','11:40:00',2.49),('9303','2013-10-31','11:45:00',2.66),('9303','2013-10-31','11:50:00',2.65),('9303','2013-10-31','11:55:00',2.67),('9303','2013-10-31','12:00:00',2.64),('9303','2013-10-31','12:05:00',2.55),('9303','2013-10-31','12:10:00',2.63),('9303','2013-10-31','12:15:00',2.69),('9303','2013-10-31','12:20:00',2.54),('9303','2013-10-31','12:25:00',2.51),('9303','2013-10-31','12:30:00',2.44),('9303','2013-10-31','12:35:00',2.31),('9303','2013-10-31','12:40:00',2.44),('9303','2013-10-31','12:45:00',2.43),('9303','2013-10-31','12:50:00',2.51),('9303','2013-10-31','12:55:00',2.55),('9303','2013-10-31','13:00:00',2.48),('9303','2013-10-31','13:05:00',2.41),('9303','2013-10-31','13:10:00',2.34),('9303','2013-10-31','13:15:00',2.28),('9303','2013-10-31','13:20:00',2.26),('9303','2013-10-31','13:25:00',2.19),('9303','2013-10-31','13:30:00',2.13),('9303','2013-10-31','13:35:00',2.03),('9303','2013-10-31','13:40:00',1.83),('9303','2013-10-31','13:45:00',1.83),('9303','2013-10-31','13:50:00',1.48),('9303','2013-10-31','13:55:00',1.25),('9303','2013-10-31','14:00:00',1.79),('9303','2013-10-31','14:05:00',1.77),('9303','2013-10-31','14:10:00',1.68),('9303','2013-10-31','14:15:00',1.51),('9303','2013-10-31','14:20:00',1.34),('9303','2013-10-31','14:25:00',1.47),('9303','2013-10-31','14:30:00',1.12),('9303','2013-10-30','08:40:00',1.06),('9303','2013-10-30','08:45:00',1.16),('9303','2013-10-30','08:50:00',1.22),('9303','2013-10-30','08:55:00',1.23),('9303','2013-10-30','09:00:00',1.32),('9303','2013-10-30','09:05:00',1.42),('9303','2013-10-30','09:10:00',1.54),('9303','2013-10-30','09:15:00',1.61),('9303','2013-10-30','09:20:00',1.64),('9303','2013-10-30','09:25:00',1.68),('9303','2013-10-30','09:30:00',1.76),('9303','2013-10-30','09:35:00',1.84),('9303','2013-10-30','09:40:00',1.89),('9303','2013-10-30','09:45:00',1.88),('9303','2013-10-30','09:50:00',1.99),('9303','2013-10-30','09:55:00',1.88),('9303','2013-10-30','10:00:00',1.77),('9303','2013-10-30','10:05:00',1.85),('9303','2013-10-30','10:10:00',2.06),('9303','2013-10-30','10:15:00',2.22),('9303','2013-10-30','10:20:00',2.22),('9303','2013-10-30','10:25:00',2.05),('9303','2013-10-30','10:30:00',2.15),('9303','2013-10-30','10:35:00',2.18),('9303','2013-10-30','10:40:00',2.19),('9303','2013-10-30','10:45:00',1.98),('9303','2013-10-30','10:50:00',1.79),('9303','2013-10-30','10:55:00',1.07),('9303','2013-10-30','11:00:00',2.33),('9303','2013-10-30','11:05:00',2.03),('9303','2013-10-30','11:10:00',2.61),('9303','2013-10-30','11:15:00',2.61),('9303','2013-10-30','11:20:00',2.12),('9303','2013-10-30','11:30:00',1.09),('9303','2013-10-30','11:50:00',2.29),('9303','2013-10-30','11:55:00',1.42),('9303','2013-10-30','12:10:00',1.03),('9303','2013-10-30','12:15:00',1.3),('9303','2013-10-30','12:20:00',1.16),('9303','2013-10-30','12:25:00',2.35),('9303','2013-10-30','12:30:00',1.86),('9303','2013-10-30','12:35:00',1.2),('9303','2013-10-30','12:40:00',1.3),('9303','2013-10-30','12:45:00',1.77),('9303','2013-10-30','12:50:00',1.65),('9303','2013-10-30','12:55:00',2.37),('9303','2013-10-30','13:00:00',1.72),('9303','2013-10-30','13:15:00',1.23),('9303','2013-10-30','13:20:00',1.15),('9303','2013-10-30','13:25:00',1.37),('9303','2013-10-30','13:30:00',1.76),('9303','2013-10-30','13:40:00',1.32),('9303','2013-10-30','13:45:00',1.98),('9303','2013-10-30','13:50:00',1.32),('9303','2013-10-30','14:00:00',1.51),('9303','2013-10-30','14:05:00',1.94),('9303','2013-10-30','14:10:00',2.08),('9303','2013-10-30','14:15:00',1.35),('9303','2013-10-30','14:40:00',1.39),('9303','2013-10-30','14:45:00',1.23),('9303','2013-10-30','14:50:00',1.13),('9303','2013-10-29','08:50:00',1.33),('9303','2013-10-29','08:55:00',1.42),('9303','2013-10-29','09:00:00',1.49),('9303','2013-10-29','09:05:00',1.6),('9303','2013-10-29','09:10:00',1.56),('9303','2013-10-29','09:15:00',1.72),('9303','2013-10-29','09:20:00',1.77),('9303','2013-10-29','09:25:00',1.87),('9303','2013-10-29','09:30:00',1.92),('9303','2013-10-29','09:35:00',1.92),('9303','2013-10-29','09:40:00',1.99),('9303','2013-10-29','09:45:00',1.96),('9303','2013-10-29','09:50:00',1.98),('9303','2013-10-29','09:55:00',1.97),('9303','2013-10-29','10:00:00',2.09),('9303','2013-10-29','10:10:00',2.22),('9303','2013-10-29','10:15:00',2.13),('9303','2013-10-29','10:20:00',2.24),('9303','2013-10-29','10:25:00',2.61),('9303','2013-10-29','10:30:00',2.72),('9303','2013-10-29','10:35:00',2.67),('9303','2013-10-29','10:40:00',2.75),('9303','2013-10-29','10:45:00',2.8),('9303','2013-10-29','10:50:00',2.79),('9303','2013-10-29','10:55:00',2.13),('9303','2013-10-29','11:00:00',2.39),('9303','2013-10-29','11:05:00',1.63),('9303','2013-10-29','11:10:00',1.75),('9303','2013-10-29','11:15:00',1.93),('9303','2013-10-29','11:20:00',1.47),('9303','2013-10-29','11:25:00',2.47),('9303','2013-10-29','11:30:00',2.8),('9303','2013-10-29','11:35:00',2.8),('9303','2013-10-29','11:40:00',2.85),('9303','2013-10-29','11:45:00',2.77),('9303','2013-10-29','11:50:00',2.79),('9303','2013-10-29','11:55:00',2.77),('9303','2013-10-29','12:00:00',2.7),('9303','2013-10-29','12:05:00',2.77),('9303','2013-10-29','12:10:00',2.75),('9303','2013-10-29','12:15:00',2.75),('9303','2013-10-29','12:20:00',2.65),('9303','2013-10-29','12:25:00',2.61),('9303','2013-10-29','12:30:00',2.59),('9303','2013-10-29','12:35:00',2.48),('9303','2013-10-29','12:40:00',2.59),('9303','2013-10-29','12:45:00',2.59),('9303','2013-10-29','12:50:00',2.48),('9303','2013-10-29','12:55:00',2.47),('9303','2013-10-29','13:00:00',2.34),('9303','2013-10-29','13:05:00',2.24),('9303','2013-10-29','13:10:00',2.33),('9303','2013-10-29','13:15:00',2.28),('9303','2013-10-29','13:20:00',2.21),('9303','2013-10-29','13:25:00',2.14),('9303','2013-10-29','13:30:00',2.14),('9303','2013-10-29','13:35:00',2.14),('9303','2013-10-29','13:40:00',2.01),('9303','2013-10-29','13:45:00',1.91),('9303','2013-10-29','13:50:00',1.45),('9303','2013-10-29','13:55:00',1.76),('9303','2013-10-29','14:00:00',1.65),('9303','2013-10-29','14:05:00',1.83),('9303','2013-10-29','14:10:00',1.84),('9303','2013-10-29','14:15:00',1.77),('9303','2013-10-29','14:20:00',1.71),('9303','2013-10-29','14:25:00',1.6),('9303','2013-10-29','14:30:00',1.48),('9303','2013-10-29','14:35:00',1.43),('9303','2013-10-29','14:40:00',1.34),('9303','2013-10-29','14:45:00',1.27),('9303','2013-10-29','14:50:00',1.18),('9303','2013-10-29','14:55:00',1.08),('9303','2014-04-17','08:05:00',1.11),('9303','2014-04-17','08:10:00',1.22),('9303','2014-04-17','08:15:00',1.33),('9303','2014-04-17','08:20:00',1.37),('9303','2014-04-17','08:25:00',1.52),('9303','2014-04-17','08:30:00',1.63),('9303','2014-04-17','08:35:00',1.7),('9303','2014-04-17','08:40:00',1.81),('9303','2014-04-17','08:45:00',1.92),('9303','2014-04-17','08:50:00',2.04),('9303','2014-04-17','08:55:00',1.79),('9303','2014-04-17','09:00:00',1.82),('9303','2014-04-17','09:05:00',2.13),('9303','2014-04-17','09:10:00',2.33),('9303','2014-04-17','09:15:00',2.37),('9303','2014-04-17','09:20:00',2.56),('9303','2014-04-17','09:25:00',2.65),('9303','2014-04-17','09:30:00',2.73),('9303','2014-04-17','09:35:00',2.81),('9303','2014-04-17','09:40:00',2.9),('9303','2014-04-17','09:45:00',2.97),('9303','2014-04-17','09:50:00',3.04),('9303','2014-04-17','09:55:00',3.14),('9303','2014-04-17','10:00:00',3.28),('9303','2014-04-17','10:05:00',3.54),('9303','2014-04-17','10:10:00',3.34),('9303','2014-04-17','10:15:00',2.92),('9303','2014-04-17','10:20:00',3.5),('9303','2014-04-17','10:25:00',3.84),('9303','2014-04-17','10:30:00',4.04),('9303','2014-04-17','10:35:00',4.23),('9303','2014-04-17','10:40:00',3.88),('9303','2014-04-17','10:45:00',3.18),('9303','2014-04-17','10:50:00',2.47),('9303','2014-04-17','10:55:00',2.44),('9303','2014-04-17','11:00:00',2.45),('9303','2014-04-17','11:05:00',3.34),('9303','2014-04-17','11:10:00',3.05),('9303','2014-04-17','11:15:00',2.81),('9303','2014-04-17','11:20:00',3.31),('9303','2014-04-17','11:25:00',3.41),('9303','2014-04-17','11:30:00',2.32),('9303','2014-04-17','11:35:00',2.58),('9303','2014-04-17','11:40:00',2.63),('9303','2014-04-17','11:45:00',3.56),('9303','2014-04-17','11:50:00',2.51),('9303','2014-04-17','11:55:00',1.92),('9303','2014-04-17','12:00:00',2.33),('9303','2014-04-17','12:05:00',2.8),('9303','2014-04-17','12:10:00',2.63),('9303','2014-04-17','12:15:00',2.3),('9303','2014-04-17','12:20:00',2.19),('9303','2014-04-17','12:25:00',2.47),('9303','2014-04-17','12:30:00',3.06),('9303','2014-04-17','12:35:00',3.79),('9303','2014-04-17','12:40:00',4.26),('9303','2014-04-17','12:45:00',4.2),('9303','2014-04-17','12:50:00',4.37),('9303','2014-04-17','12:55:00',4.43),('9303','2014-04-17','13:00:00',3.69),('9303','2014-04-17','13:05:00',1.11),('9303','2014-04-17','13:10:00',1.62),('9303','2014-04-17','13:20:00',2.72),('9303','2014-04-17','13:25:00',4.98),('9303','2014-04-17','13:30:00',3.8),('9303','2014-04-17','13:50:00',1.05),('9303','2014-04-17','13:55:00',1.12),('9303','2014-04-17','14:00:00',1.02),('9303','2014-04-17','14:05:00',1.09),('9303','2014-04-17','14:10:00',2.9),('9303','2014-04-17','14:15:00',1.34),('9303','2014-04-17','14:20:00',1.4),('9303','2014-04-17','14:25:00',2.12),('9303','2014-04-17','14:30:00',1.48),('9303','2014-04-17','14:35:00',1.79),('9303','2014-04-17','14:40:00',3.43),('9303','2014-04-17','14:45:00',1.16),('9303','2014-04-17','15:25:00',1.08),('9303','2014-04-17','15:30:00',1.71),('9303','2014-04-17','15:35:00',2.1),('9303','2014-04-17','15:40:00',1.55),('9303','2014-04-17','15:45:00',1.15),('9303','2014-04-17','15:50:00',1.11),('9303','2014-04-17','15:55:00',1.29),('9303','2014-04-17','16:00:00',1.07),('9303','2014-04-17','16:15:00',1),('9303','2014-04-17','16:25:00',1.1),('9303','2014-04-17','16:30:00',1.13),('9303','2014-04-17','16:35:00',1.03),('9303','2014-04-17','16:40:00',1.18),('9303','2014-04-17','16:45:00',1.41),('9303','2014-04-17','16:50:00',1.38),('9303','2014-04-17','16:55:00',1.09),('9303','2013-10-28','08:50:00',1.05),('9303','2013-10-28','08:55:00',1.47),('9303','2013-10-28','09:00:00',1.63),('9303','2013-10-28','09:05:00',1.88),('9303','2013-10-28','09:10:00',1.95),('9303','2013-10-28','09:15:00',1.45),('9303','2013-10-28','09:20:00',1.14),('9303','2013-10-28','09:25:00',2.09),('9303','2013-10-28','09:30:00',2.18),('9303','2013-10-28','09:35:00',1.39),('9303','2013-10-28','09:40:00',1.22),('9303','2013-10-28','09:45:00',1.77),('9303','2013-10-28','09:50:00',2.15),('9303','2013-10-28','09:55:00',1.11),('9303','2013-10-28','10:50:00',2.67),('9303','2013-10-28','10:55:00',2.7),('9303','2013-10-28','11:00:00',2.73),('9303','2013-10-28','11:05:00',2.72),('9303','2013-10-28','11:10:00',2.73),('9303','2013-10-28','11:15:00',2.75),('9303','2013-10-28','11:20:00',2.78),('9303','2013-10-28','11:25:00',2.75),('9303','2013-10-28','11:30:00',2.77),('9303','2013-10-28','11:35:00',2.78),('9303','2013-10-28','11:40:00',2.77),('9303','2013-10-28','11:45:00',2.79),('9303','2013-10-28','11:50:00',2.81),('9303','2013-10-28','11:55:00',2.69),('9303','2013-10-28','12:00:00',2.45),('9303','2013-10-28','12:05:00',2.68),('9303','2013-10-28','12:10:00',2.04),('9303','2013-10-28','12:15:00',3),('9303','2013-10-28','12:20:00',3.01),('9303','2013-10-28','12:25:00',2.96),('9303','2013-10-28','12:30:00',2.82),('9303','2013-10-28','12:35:00',3.13),('9303','2013-10-28','12:40:00',2.99),('9303','2013-10-28','12:45:00',2.94),('9303','2013-10-28','12:50:00',2.98),('9303','2013-10-28','12:55:00',2.78),('9303','2013-10-28','13:00:00',2.65),('9303','2013-10-28','13:05:00',2.57),('9303','2013-10-28','13:10:00',2.56),('9303','2013-10-28','13:15:00',2.47),('9303','2013-10-28','13:20:00',2.35),('9303','2013-10-28','13:25:00',2.4),('9303','2013-10-28','13:30:00',2.34),('9303','2013-10-28','13:35:00',2.31),('9303','2013-10-28','13:40:00',2.18),('9303','2013-10-28','13:45:00',1.7),('9303','2013-10-28','13:50:00',2.16),('9303','2013-10-28','13:55:00',2.16),('9303','2013-10-28','14:00:00',2.17),('9303','2013-10-28','14:05:00',1.66),('9303','2013-10-28','14:10:00',2.11),('9303','2013-10-28','14:15:00',2.04),('9303','2013-10-28','14:20:00',1.98),('9303','2013-10-28','14:25:00',2.06),('9303','2013-10-28','14:30:00',1.78),('9303','2013-10-28','14:35:00',1.69),('9303','2013-10-28','14:40:00',1.25),('9303','2013-10-28','14:45:00',1.56),('9303','2013-10-28','14:50:00',1.39),('9303','2013-10-28','14:55:00',1.23),('9303','2013-10-28','15:00:00',1.09),('9303','2013-10-28','15:05:00',1.01),('9303','2013-10-27','10:10:00',1.01),('9303','2013-10-27','10:15:00',1.06),('9303','2013-10-27','10:20:00',1.16),('9303','2013-10-27','10:25:00',1.14),('9303','2013-10-27','10:30:00',1.13),('9303','2013-10-27','10:35:00',1.14),('9303','2013-10-27','10:40:00',1.14),('9303','2013-10-27','10:45:00',1.25),('9303','2013-10-27','10:50:00',1.36),('9303','2013-10-27','10:55:00',1.17),('9303','2013-10-27','11:00:00',1.15),('9303','2013-10-27','11:35:00',1.22),('9303','2013-10-27','11:40:00',2.24),('9303','2013-10-27','11:45:00',2.77),('9303','2013-10-27','11:50:00',1.59),('9303','2013-10-27','11:55:00',1.1),('9303','2013-10-27','12:00:00',1.09),('9303','2013-10-27','12:05:00',1.18),('9303','2013-10-27','12:10:00',1.09),('9303','2013-10-27','12:15:00',1.18),('9303','2013-10-27','12:20:00',2.28),('9303','2013-10-27','12:25:00',2.5),('9303','2013-10-27','12:30:00',2.11),('9303','2013-10-27','12:35:00',2.72),('9303','2013-10-27','12:40:00',1.72),('9303','2013-10-27','12:45:00',1.49),('9303','2013-10-27','12:50:00',1.54),('9303','2013-10-27','12:55:00',1.53),('9303','2013-10-27','13:00:00',1.55),('9303','2013-10-27','13:05:00',1),('9303','2013-10-27','13:10:00',2.06),('9303','2013-10-27','13:15:00',1.13),('9303','2013-10-27','13:20:00',1.02),('9303','2013-10-27','13:25:00',1.87),('9303','2013-10-27','13:30:00',2.37),('9303','2013-10-27','13:35:00',1.85),('9303','2013-10-27','13:40:00',1.75),('9303','2013-10-27','14:00:00',1.01),('9303','2013-10-27','14:05:00',1.04),('9303','2013-10-27','14:20:00',1.01),('9303','2013-10-27','14:30:00',1.55),('9303','2013-10-27','14:35:00',1.56),('9303','2013-10-27','14:40:00',1.69),('9303','2013-10-27','14:45:00',1.39),('9303','2013-10-27','14:50:00',1.03),('9303','2013-10-27','14:55:00',1.05),('9303','2013-10-27','15:00:00',1.09),('9303','2013-10-26','09:30:00',1.1),('9303','2013-10-26','09:35:00',1.22),('9303','2013-10-26','09:40:00',1.29),('9303','2013-10-26','09:45:00',1.39),('9303','2013-10-26','09:50:00',1.5),('9303','2013-10-26','09:55:00',1.62),('9303','2013-10-26','10:00:00',1.69),('9303','2013-10-26','10:05:00',1.79),('9303','2013-10-26','10:10:00',1.83),('9303','2013-10-26','10:15:00',1.89),('9303','2013-10-26','10:20:00',1.92),('9303','2013-10-26','10:25:00',2),('9303','2013-10-26','10:30:00',2.03),('9303','2013-10-26','10:35:00',2.06),('9303','2013-10-26','10:40:00',2.12),('9303','2013-10-26','10:45:00',2.15),('9303','2013-10-26','10:50:00',2.23),('9303','2013-10-26','10:55:00',2.29),('9303','2013-10-26','11:00:00',2.32),('9303','2013-10-26','11:05:00',2.39),('9303','2013-10-26','11:10:00',2.42),('9303','2013-10-26','11:15:00',2.42),('9303','2013-10-26','11:20:00',2.46),('9303','2013-10-26','11:25:00',2.51),('9303','2013-10-26','11:30:00',2.51),('9303','2013-10-26','11:35:00',2.53),('9303','2013-10-26','11:40:00',2.59),('9303','2013-10-26','11:45:00',2.59),('9303','2013-10-26','11:50:00',2.59),('9303','2013-10-26','11:55:00',2.63),('9303','2013-10-26','12:00:00',2.61),('9303','2013-10-26','12:05:00',2.65),('9303','2013-10-26','12:10:00',2.69),('9303','2013-10-26','12:15:00',2.69),('9303','2013-10-26','12:20:00',2.64),('9303','2013-10-26','12:25:00',2.64),('9303','2013-10-26','12:30:00',2.76),('9303','2013-10-26','12:35:00',2.69),('9303','2013-10-26','12:40:00',2.73),('9303','2013-10-26','12:45:00',2.77),('9303','2013-10-26','12:50:00',2.77),('9303','2013-10-26','12:55:00',2.71),('9303','2013-10-26','13:00:00',2.69),('9303','2013-10-26','13:05:00',2.62),('9303','2013-10-26','13:10:00',2.54),('9303','2013-10-26','13:15:00',2.49),('9303','2013-10-26','13:20:00',2.57),('9303','2013-10-26','13:25:00',2.6),('9303','2013-10-26','13:30:00',2.25),('9303','2013-10-26','13:35:00',2.67),('9303','2013-10-26','13:40:00',2.65),('9303','2013-10-26','13:45:00',2.51),('9303','2013-10-26','13:50:00',2.41),('9303','2013-10-26','13:55:00',2.5),('9303','2013-10-26','14:00:00',2.42),('9303','2013-10-26','14:05:00',2.11),('9303','2013-10-26','14:10:00',2.31),('9303','2013-10-26','14:15:00',2.18),('9303','2013-10-26','14:20:00',1.96),('9303','2013-10-26','14:25:00',1.04),('9303','2013-10-26','14:35:00',1.9),('9303','2013-10-26','14:40:00',1.97),('9303','2013-10-26','14:45:00',2.02),('9303','2013-10-26','14:50:00',2.01),('9303','2013-10-26','14:55:00',1.97),('9303','2013-10-26','15:00:00',1.86),('9303','2013-10-26','15:05:00',1.81),('9303','2013-10-26','15:10:00',1.77),('9303','2013-10-26','15:15:00',1.72),('9303','2013-10-26','15:20:00',1.15),('9303','2013-10-26','15:25:00',1.34),('9303','2013-10-26','15:30:00',1.5),('9303','2013-10-26','15:35:00',1.63),('9303','2013-10-26','15:40:00',1.56),('9303','2013-10-26','15:45:00',1.41),('9303','2013-10-26','15:50:00',1.43),('9303','2013-10-26','15:55:00',1.16),('9303','2013-10-26','16:00:00',1.01),('9303','2013-10-25','09:25:00',1.09),('9303','2013-10-25','09:30:00',1.16),('9303','2013-10-25','09:35:00',1.21),('9303','2013-10-25','09:40:00',1.29),('9303','2013-10-25','09:45:00',1.35),('9303','2013-10-25','09:50:00',1.4),('9303','2013-10-25','09:55:00',1.46),('9303','2013-10-25','10:00:00',1.68),('9303','2013-10-25','10:05:00',1.86),('9303','2013-10-25','10:10:00',1.9),('9303','2013-10-25','10:15:00',1.96),('9303','2013-10-25','10:20:00',1.97),('9303','2013-10-25','10:25:00',2.05),('9303','2013-10-25','10:30:00',2.13),('9303','2013-10-25','10:35:00',2.13),('9303','2013-10-25','10:40:00',2.17),('9303','2013-10-25','10:45:00',2.2),('9303','2013-10-25','10:50:00',2.26),('9303','2013-10-25','10:55:00',2.34),('9303','2013-10-25','11:00:00',2.32),('9303','2013-10-25','11:05:00',2.41),('9303','2013-10-25','11:10:00',2.46),('9303','2013-10-25','11:15:00',2.43),('9303','2013-10-25','11:20:00',2.5),('9303','2013-10-25','11:25:00',2.52),('9303','2013-10-25','11:30:00',2.58),('9303','2013-10-25','11:35:00',2.6),('9303','2013-10-25','11:40:00',2.6),('9303','2013-10-25','11:45:00',2.63),('9303','2013-10-25','11:50:00',2.71),('9303','2013-10-25','11:55:00',2.76),('9303','2013-10-25','12:00:00',2.79),('9303','2013-10-25','12:05:00',2.82),('9303','2013-10-25','12:10:00',2.79),('9303','2013-10-25','12:15:00',2.82),('9303','2013-10-25','12:20:00',2.84),('9303','2013-10-25','12:25:00',2.82),('9303','2013-10-25','12:30:00',2.83),('9303','2013-10-25','12:35:00',2.84),('9303','2013-10-25','12:40:00',2.88),('9303','2013-10-25','12:45:00',2.87),('9303','2013-10-25','12:50:00',2.86),('9303','2013-10-25','12:55:00',2.9),('9303','2013-10-25','13:00:00',2.92),('9303','2013-10-25','13:05:00',2.94),('9303','2013-10-25','13:10:00',2.94),('9303','2013-10-25','13:15:00',2.82),('9303','2013-10-25','13:20:00',2.66),('9303','2013-10-25','13:25:00',2.65),('9303','2013-10-25','13:30:00',2.68),('9303','2013-10-25','13:35:00',2.73),('9303','2013-10-25','13:40:00',2.72),('9303','2013-10-25','13:45:00',2.64),('9303','2013-10-25','13:50:00',2.67),('9303','2013-10-25','13:55:00',2.65),('9303','2013-10-25','14:00:00',2.63),('9303','2013-10-25','14:05:00',2.6),('9303','2013-10-25','14:10:00',2.57),('9303','2013-10-25','14:15:00',2.5),('9303','2013-10-25','14:20:00',2.43),('9303','2013-10-25','14:25:00',2.38),('9303','2013-10-25','14:30:00',2.36),('9303','2013-10-25','14:35:00',2.38),('9303','2013-10-25','14:40:00',2.3),('9303','2013-10-25','14:45:00',2.25),('9303','2013-10-25','14:50:00',2.19),('9303','2013-10-25','14:55:00',2.22),('9303','2013-10-25','15:00:00',2.16),('9303','2013-10-25','15:05:00',2.15),('9303','2013-10-25','15:10:00',2.1),('9303','2013-10-25','15:15:00',1.97),('9303','2013-10-25','15:20:00',1.94),('9303','2013-10-25','15:25:00',1.89),('9303','2013-10-25','15:30:00',1.77),('9303','2013-10-25','15:35:00',1.66),('9303','2013-10-25','15:40:00',1.62),('9303','2013-10-25','15:45:00',1.56),('9303','2013-10-25','15:50:00',1.46),('9303','2013-10-25','15:55:00',1.36),('9303','2013-10-25','16:00:00',1.23),('9303','2013-10-25','16:05:00',1.12),('9303','2013-10-25','16:10:00',1.03),('9303','2013-10-24','09:15:00',1.17),('9303','2013-10-24','09:20:00',1.07),('9303','2013-10-24','09:40:00',1.01),('9303','2013-10-24','09:45:00',1.04),('9303','2013-10-24','09:50:00',1.05),('9303','2013-10-24','09:55:00',1.01),('9303','2013-10-24','10:35:00',1.36),('9303','2013-10-24','10:40:00',1.27),('9303','2013-10-24','10:45:00',2.12),('9303','2013-10-24','10:50:00',1.71),('9303','2013-10-24','10:55:00',2.07),('9303','2013-10-24','11:00:00',2.52),('9303','2013-10-24','11:05:00',2.64),('9303','2013-10-24','11:10:00',2.61),('9303','2013-10-24','11:15:00',1.59),('9303','2013-10-24','11:20:00',1.32),('9303','2013-10-24','11:25:00',2.18),('9303','2013-10-24','11:30:00',1.6),('9303','2013-10-24','11:35:00',1.05),('9303','2013-10-24','11:40:00',1.04),('9303','2013-10-24','11:45:00',1.1),('9303','2013-10-24','11:50:00',1.68),('9303','2013-10-24','11:55:00',2.81),('9303','2013-10-24','12:00:00',1.63),('9303','2013-10-24','12:05:00',1.29),('9303','2013-10-24','12:10:00',1.21),('9303','2013-10-24','12:15:00',1.2),('9303','2013-10-24','12:20:00',1.25),('9303','2013-10-24','12:25:00',1.4),('9303','2013-10-24','12:30:00',1.47),('9303','2013-10-24','12:35:00',1.59),('9303','2013-10-24','12:40:00',1.82),('9303','2013-10-24','12:45:00',1.97),('9303','2013-10-24','12:50:00',1.91),('9303','2013-10-24','12:55:00',2.09),('9303','2013-10-24','13:00:00',2.68),('9303','2013-10-24','13:05:00',3.06),('9303','2013-10-24','13:10:00',2.74),('9303','2013-10-24','13:15:00',2.1),('9303','2013-10-24','13:20:00',2.35),('9303','2013-10-24','13:25:00',2.01),('9303','2013-10-24','13:30:00',1.26),('9303','2013-10-24','13:35:00',1.2),('9303','2013-10-24','13:40:00',1.2),('9303','2013-10-24','13:45:00',1.26),('9303','2013-10-24','13:50:00',1.45),('9303','2013-10-24','13:55:00',1.82),('9303','2013-10-24','14:00:00',2.04),('9303','2013-10-24','14:05:00',1.68),('9303','2013-10-24','14:10:00',1.29),('9303','2013-10-24','14:15:00',1.28),('9303','2013-10-24','14:20:00',1.34),('9303','2013-10-24','14:25:00',1.42),('9303','2013-10-24','14:30:00',1.41),('9303','2013-10-24','14:35:00',1.74),('9303','2013-10-24','14:40:00',1.78),('9303','2013-10-24','14:45:00',1.86),('9303','2013-10-24','14:50:00',1.96),('9303','2013-10-24','15:05:00',1.13),('9303','2013-10-24','15:10:00',2.17),('9303','2013-10-24','15:15:00',1.35),('9303','2013-10-24','15:20:00',1.04),('9303','2013-10-24','15:25:00',1.16),('9303','2013-10-24','15:30:00',1.02),('9303','2013-10-24','15:35:00',2.11),('9303','2013-10-24','15:40:00',2.14),('9303','2013-10-24','15:45:00',1.67),('9303','2013-10-24','15:50:00',1.19),('9303','2013-10-23','10:40:00',1.13),('9303','2013-10-23','10:45:00',1.03),('9303','2013-10-23','10:50:00',1.64),('9303','2013-10-23','10:55:00',1.21),('9303','2013-10-23','11:00:00',1.49),('9303','2013-10-23','11:05:00',1.43),('9303','2013-10-23','11:10:00',1.33),('9303','2013-10-23','11:15:00',1.42),('9303','2013-10-23','11:20:00',2.37),('9303','2013-10-23','11:25:00',2.51),('9303','2013-10-23','11:30:00',2.44),('9303','2013-10-23','11:35:00',2.47),('9303','2013-10-23','11:40:00',2.52),('9303','2013-10-23','11:45:00',2.59),('9303','2013-10-23','11:50:00',2.63),('9303','2013-10-23','11:55:00',2.69),('9303','2013-10-23','12:00:00',2.67),('9303','2013-10-23','12:05:00',2.61),('9303','2013-10-23','12:10:00',2.58),('9303','2013-10-23','12:15:00',2.43),('9303','2013-10-23','12:20:00',2.44),('9303','2013-10-23','12:25:00',2.62),('9303','2013-10-23','12:30:00',2.56),('9303','2013-10-23','12:35:00',2.6),('9303','2013-10-23','12:40:00',2.6),('9303','2013-10-23','12:45:00',2.41),('9303','2013-10-23','12:50:00',1.81),('9303','2013-10-23','12:55:00',2.09),('9303','2013-10-23','13:00:00',2.65),('9303','2013-10-23','13:05:00',2.58),('9303','2013-10-23','13:10:00',2.71),('9303','2013-10-23','13:15:00',2.71),('9303','2013-10-23','13:20:00',2.65),('9303','2013-10-23','13:25:00',2.55),('9303','2013-10-23','13:30:00',2.53),('9303','2013-10-23','13:35:00',2.48),('9303','2013-10-23','13:40:00',2.55),('9303','2013-10-23','13:45:00',2.47),('9303','2013-10-23','13:50:00',2.19),('9303','2013-10-23','13:55:00',2.08),('9303','2013-10-23','14:00:00',2.26),('9303','2013-10-23','14:05:00',2.27),('9303','2013-10-23','14:10:00',2.3),('9303','2013-10-23','14:15:00',2.36),('9303','2013-10-23','14:20:00',2.23),('9303','2013-10-23','14:25:00',2.19),('9303','2013-10-23','14:32:00',2.17),('9303','2013-10-23','14:35:00',2.19),('9303','2013-10-23','14:40:00',2.14),('9303','2013-10-23','14:45:00',1.91),('9303','2013-10-23','14:50:00',1.66),('9303','2013-10-23','14:55:00',1.73),('9303','2013-10-23','15:00:00',1.81),('9303','2013-10-23','15:05:00',2.06),('9303','2013-10-23','15:10:00',2.04),('9303','2013-10-23','15:15:00',2.01),('9303','2013-10-23','15:20:00',1.98),('9303','2013-10-23','15:25:00',1.99),('9303','2013-10-23','15:30:00',1.9),('9303','2013-10-23','15:35:00',1.76),('9303','2013-10-23','15:40:00',1.85),('9303','2013-10-23','15:45:00',1.77),('9303','2013-10-23','15:50:00',1.57),('9303','2013-10-23','15:55:00',1.1),('9303','2013-10-22','09:15:00',1),('9303','2013-10-22','09:20:00',1.09),('9303','2013-10-22','09:25:00',1.19),('9303','2013-10-22','09:30:00',1.28),('9303','2013-10-22','09:35:00',1.39),('9303','2013-10-22','09:40:00',1.5),('9303','2013-10-22','09:45:00',1.59),('9303','2013-10-22','09:50:00',1.68),('9303','2013-10-22','09:55:00',1.77),('9303','2013-10-22','10:00:00',1.81),('9303','2013-10-22','10:05:00',1.85),('9303','2013-10-22','10:10:00',1.89),('9303','2013-10-22','10:15:00',1.94),('9303','2013-10-22','10:20:00',1.97),('9303','2013-10-22','10:25:00',1.96),('9303','2013-10-22','10:30:00',2.08),('9303','2013-10-22','10:35:00',2.09),('9303','2013-10-22','10:40:00',2.13),('9303','2013-10-22','10:45:00',2.19),('9303','2013-10-22','10:50:00',2.21),('9303','2013-10-22','10:55:00',2.3),('9303','2013-10-22','11:00:00',2.3),('9303','2013-10-22','11:05:00',2.37),('9303','2013-10-22','11:10:00',2.39),('9303','2013-10-22','11:15:00',2.43),('9303','2013-10-22','11:20:00',2.41),('9303','2013-10-22','11:25:00',2.45),('9303','2013-10-22','11:30:00',2.48),('9303','2013-10-22','11:35:00',2.48),('9303','2013-10-22','11:40:00',2.47),('9303','2013-10-22','11:45:00',2.46),('9303','2013-10-22','11:50:00',2.51),('9303','2013-10-22','11:55:00',2.59),('9303','2013-10-22','12:00:00',2.6),('9303','2013-10-22','12:05:00',2.6),('9303','2013-10-22','12:10:00',2.53),('9303','2013-10-22','12:15:00',2.59),('9303','2013-10-22','12:20:00',2.68),('9303','2013-10-22','12:25:00',2.65),('9303','2013-10-22','12:30:00',2.63),('9303','2013-10-22','12:35:00',2.66),('9303','2013-10-22','12:40:00',2.73),('9303','2013-10-22','12:45:00',2.7),('9303','2013-10-22','12:50:00',2.61),('9303','2013-10-22','12:55:00',2.75),('9303','2013-10-22','13:00:00',2.74),('9303','2013-10-22','13:05:00',2.68),('9303','2013-10-22','13:10:00',2.65),('9303','2013-10-22','13:15:00',2.67),('9303','2013-10-22','13:20:00',2.64),('9303','2013-10-22','13:25:00',2.64),('9303','2013-10-22','13:30:00',2.55),('9303','2013-10-22','13:35:00',2.56),('9303','2013-10-22','13:40:00',2.56),('9303','2013-10-22','13:45:00',2.51),('9303','2013-10-22','13:50:00',2.48),('9303','2013-10-22','13:55:00',2.41),('9303','2013-10-22','14:00:00',2.34),('9303','2013-10-22','14:05:00',1.83),('9303','2013-10-22','14:10:00',2.31),('9303','2013-10-22','14:15:00',2.34),('9303','2013-10-22','14:20:00',2.34),('9303','2013-10-22','14:25:00',2.22),('9303','2013-10-22','14:30:00',1.41),('9303','2013-10-22','14:45:00',1.43),('9303','2013-10-22','14:50:00',2.01),('9303','2013-10-22','14:55:00',2.07),('9303','2013-10-22','15:00:00',1.91),('9303','2013-10-22','15:05:00',1.97),('9303','2013-10-22','15:10:00',1.96),('9303','2013-10-22','15:15:00',1.54),('9303','2013-10-22','15:20:00',1.75),('9303','2013-10-22','15:25:00',1.8),('9303','2013-10-22','15:30:00',1.77),('9303','2013-10-22','15:35:00',1.76),('9303','2013-10-22','15:40:00',1.76),('9303','2013-10-22','15:45:00',1.68),('9303','2013-10-22','15:50:00',1.59),('9303','2013-10-22','15:55:00',1.42),('9303','2013-10-22','16:00:00',1.31),('9303','2013-10-22','16:05:00',1.17),('9303','2013-10-22','16:10:00',1.15),('9303','2013-10-22','16:15:00',1.05),('9303','2013-10-21','09:15:00',1.04),('9303','2013-10-21','09:20:00',1.25),('9303','2013-10-21','09:25:00',1.35),('9303','2013-10-21','09:30:00',1.3),('9303','2013-10-21','09:35:00',1.26),('9303','2013-10-21','09:40:00',1.56),('9303','2013-10-21','09:45:00',1.38),('9303','2013-10-21','09:50:00',1.51),('9303','2013-10-21','09:55:00',1.68),('9303','2013-10-21','10:00:00',1.67),('9303','2013-10-21','10:05:00',1.87),('9303','2013-10-21','10:10:00',1.99),('9303','2013-10-21','10:15:00',2.05),('9303','2013-10-21','10:20:00',2.02),('9303','2013-10-21','10:25:00',1.97),('9303','2013-10-21','10:30:00',2.04),('9303','2013-10-21','10:35:00',2.06),('9303','2013-10-21','10:40:00',2.01),('9303','2013-10-21','10:45:00',2.13),('9303','2013-10-21','10:50:00',2.22),('9303','2013-10-21','10:55:00',2.26),('9303','2013-10-21','11:00:00',2.4),('9303','2013-10-21','11:05:00',2.2),('9303','2013-10-21','11:10:00',2.03),('9303','2013-10-21','11:15:00',2.51),('9303','2013-10-21','11:20:00',2.52),('9303','2013-10-21','11:25:00',2.5),('9303','2013-10-21','11:30:00',2.63),('9303','2013-10-21','11:35:00',2.67),('9303','2013-10-21','11:40:00',2.6),('9303','2013-10-21','11:45:00',2.71),('9303','2013-10-21','11:50:00',2.71),('9303','2013-10-21','11:55:00',2.74),('9303','2013-10-21','12:00:00',2.78),('9303','2013-10-21','12:05:00',2.81),('9303','2013-10-21','12:10:00',2.85),('9303','2013-10-21','12:15:00',2.85),('9303','2013-10-21','12:20:00',2.85),('9303','2013-10-21','12:25:00',2.87),('9303','2013-10-21','12:30:00',2.71),('9303','2013-10-21','12:35:00',2.76),('9303','2013-10-21','12:40:00',2.91),('9303','2013-10-21','12:45:00',2.92),('9303','2013-10-21','12:50:00',2.9),('9303','2013-10-21','12:55:00',2.95),('9303','2013-10-21','13:00:00',2.9),('9303','2013-10-21','13:05:00',2.83),('9303','2013-10-21','13:10:00',2.76),('9303','2013-10-21','13:15:00',2.81),('9303','2013-10-21','13:20:00',2.69),('9303','2013-10-21','13:25:00',2.68),('9303','2013-10-21','13:30:00',2.8),('9303','2013-10-21','13:35:00',2.79),('9303','2013-10-21','13:40:00',2.72),('9303','2013-10-21','13:45:00',2.72),('9303','2013-10-21','13:50:00',2.65),('9303','2013-10-21','13:55:00',2.57),('9303','2013-10-21','14:00:00',2.54),('9303','2013-10-21','14:05:00',2.62),('9303','2013-10-21','14:10:00',2.59),('9303','2013-10-21','14:15:00',2.54),('9303','2013-10-21','14:20:00',2.44),('9303','2013-10-21','14:25:00',2.36),('9303','2013-10-21','14:30:00',2.33),('9303','2013-10-21','14:35:00',2.38),('9303','2013-10-21','14:40:00',2.27),('9303','2013-10-21','14:45:00',2.2),('9303','2013-10-21','14:50:00',2.18),('9303','2013-10-21','14:55:00',2.17),('9303','2013-10-21','15:00:00',2.2),('9303','2013-10-21','15:05:00',2.15),('9303','2013-10-21','15:10:00',2.11),('9303','2013-10-21','15:15:00',2.09),('9303','2013-10-21','15:20:00',2.03),('9303','2013-10-21','15:25:00',2),('9303','2013-10-21','15:30:00',1.86),('9303','2013-10-21','15:35:00',1.81),('9303','2013-10-21','15:40:00',1.84),('9303','2013-10-21','15:45:00',1.78),('9303','2013-10-21','15:50:00',1.7),('9303','2013-10-21','15:55:00',1.58),('9303','2013-10-21','16:00:00',1.47),('9303','2013-10-21','16:05:00',1.36),('9303','2013-10-21','16:10:00',1.29),('9303','2013-10-21','16:15:00',1.18),('9303','2013-10-21','16:20:00',1.08),('9303','2013-10-20','09:15:00',1.07),('9303','2013-10-20','09:20:00',1.15),('9303','2013-10-20','09:25:00',1.23),('9303','2013-10-20','09:30:00',1.42),('9303','2013-10-20','09:35:00',1.59),('9303','2013-10-20','09:40:00',1.7),('9303','2013-10-20','09:45:00',1.79),('9303','2013-10-20','09:50:00',1.83),('9303','2013-10-20','09:55:00',1.9),('9303','2013-10-20','10:00:00',1.99),('9303','2013-10-20','10:05:00',2.04),('9303','2013-10-20','10:10:00',2.08),('9303','2013-10-20','10:15:00',2.12),('9303','2013-10-20','10:20:00',2.17),('9303','2013-10-20','10:25:00',2.2),('9303','2013-10-20','10:30:00',2.26),('9303','2013-10-20','10:35:00',2.28),('9303','2013-10-20','10:40:00',2.28),('9303','2013-10-20','10:45:00',2.36),('9303','2013-10-20','10:50:00',2.38),('9303','2013-10-20','10:55:00',2.47),('9303','2013-10-20','11:00:00',2.46),('9303','2013-10-20','11:05:00',2.53),('9303','2013-10-20','11:10:00',2.57),('9303','2013-10-20','11:15:00',2.59),('9303','2013-10-20','11:20:00',2.64),('9303','2013-10-20','11:25:00',2.65),('9303','2013-10-20','11:30:00',2.71),('9303','2013-10-20','11:35:00',2.74),('9303','2013-10-20','11:40:00',2.73),('9303','2013-10-20','11:45:00',2.77),('9303','2013-10-20','11:55:00',2.55),('9303','2013-10-20','12:00:00',2.87),('9303','2013-10-20','12:05:00',2.84),('9303','2013-10-20','12:10:00',2.7),('9303','2013-10-20','12:15:00',2.53),('9303','2013-10-20','12:20:00',2.33),('9303','2013-10-20','12:30:00',3),('9303','2013-10-20','12:35:00',2),('9303','2013-10-20','12:40:00',2.16),('9303','2013-10-20','12:45:00',1.51),('9303','2013-10-20','12:50:00',2.01),('9303','2013-10-20','12:55:00',2.04),('9303','2013-10-20','13:00:00',2.1),('9303','2013-10-20','13:05:00',2.89),('9303','2013-10-20','13:10:00',3.5),('9303','2013-10-20','13:15:00',1.43),('9303','2013-10-20','13:25:00',1.48),('9303','2013-10-20','13:30:00',1.67),('9303','2013-10-20','13:35:00',2.15),('9303','2013-10-20','13:40:00',1.13),('9303','2013-10-20','13:45:00',2.35),('9303','2013-10-20','13:50:00',1.17),('9303','2013-10-20','13:55:00',2.14),('9303','2013-10-20','14:00:00',1.08),('9303','2013-10-20','14:10:00',1.6),('9303','2013-10-19','09:10:00',1),('9303','2013-10-19','09:15:00',1.57),('9303','2013-10-19','09:20:00',1.68),('9303','2013-10-19','09:25:00',1.74),('9303','2013-10-19','09:30:00',1.79),('9303','2013-10-19','09:35:00',1.87),('9303','2013-10-19','09:40:00',1.95),('9303','2013-10-19','09:45:00',2.06),('9303','2013-10-19','09:50:00',2.18),('9303','2013-10-19','09:55:00',2.29),('9303','2013-10-19','10:00:00',2.26),('9303','2013-10-19','10:05:00',2.14),('9303','2013-10-19','10:10:00',2.29),('9303','2013-10-19','10:15:00',2.25),('9303','2013-10-19','10:20:00',2.42),('9303','2013-10-19','10:25:00',2.51),('9303','2013-10-19','10:30:00',2.55),('9303','2013-10-19','10:35:00',2.56),('9303','2013-10-19','10:40:00',2.55),('9303','2013-10-19','10:45:00',2.57),('9303','2013-10-19','10:50:00',2.61),('9303','2013-10-19','10:55:00',2.72),('9303','2013-10-19','11:00:00',2.68),('9303','2013-10-19','11:05:00',2.44),('9303','2013-10-19','11:10:00',1.4),('9303','2013-10-19','11:15:00',1.04),('9303','2013-10-19','11:20:00',2.09),('9303','2013-10-19','11:25:00',3.07),('9303','2013-10-19','11:30:00',3.03),('9303','2013-10-19','11:35:00',3.01),('9303','2013-10-19','11:40:00',2.87),('9303','2013-10-19','11:45:00',2.99),('9303','2013-10-19','11:50:00',2.96),('9303','2013-10-19','11:55:00',2.98),('9303','2013-10-19','12:00:00',3.15),('9303','2013-10-19','12:05:00',3.15),('9303','2013-10-19','12:10:00',3.11),('9303','2013-10-19','12:15:00',3.1),('9303','2013-10-19','12:20:00',3.15),('9303','2013-10-19','12:25:00',2.83),('9303','2013-10-19','12:30:00',3.09),('9303','2013-10-19','12:35:00',3.16),('9303','2013-10-19','12:40:00',3.28),('9303','2013-10-19','12:45:00',3.33),('9303','2013-10-19','12:50:00',3.38),('9303','2013-10-19','12:55:00',3.4),('9303','2013-10-19','13:00:00',3.58),('9303','2013-10-19','13:05:00',2.69),('9303','2013-10-19','13:10:00',3.1),('9303','2013-10-19','13:15:00',3.04),('9303','2013-10-19','13:20:00',2.91),('9303','2013-10-19','13:25:00',3.23),('9303','2013-10-19','13:30:00',3.27),('9303','2013-10-19','13:35:00',2.58),('9303','2013-10-19','13:40:00',2.22),('9303','2013-10-19','13:45:00',2.39),('9303','2013-10-19','13:50:00',2.52),('9303','2013-10-19','13:55:00',3.35),('9303','2013-10-19','14:00:00',2.53),('9303','2013-10-19','14:05:00',2.16),('9303','2013-10-19','14:10:00',1.69),('9303','2013-10-19','14:15:00',2.08),('9303','2013-10-19','14:20:00',1.87),('9303','2013-10-19','14:25:00',1.74),('9303','2013-10-19','14:30:00',2.09),('9303','2013-10-19','14:35:00',2.82),('9303','2013-10-19','14:40:00',2.14),('9303','2013-10-19','14:45:00',1.81),('9303','2013-10-19','14:50:00',2.74),('9303','2013-10-19','14:55:00',2.66),('9303','2013-10-19','15:00:00',2.57),('9303','2013-10-19','15:05:00',2.48),('9303','2013-10-19','15:10:00',2.46),('9303','2013-10-19','15:15:00',2.4),('9303','2013-10-19','15:20:00',2.24),('9303','2013-10-19','15:25:00',2.21),('9303','2013-10-19','15:30:00',2.1),('9303','2013-10-19','15:35:00',2.1),('9303','2013-10-19','15:40:00',1.93),('9303','2013-10-19','15:45:00',1.66),('9303','2013-10-19','15:50:00',1.79),('9303','2013-10-19','15:55:00',1.95),('9303','2013-10-19','16:00:00',1.57),('9303','2013-10-19','16:05:00',1.61),('9303','2013-10-19','16:10:00',1.52),('9303','2013-10-19','16:15:00',1.59),('9303','2013-10-19','16:20:00',1.41),('9303','2013-10-19','16:30:00',1.19),('9303','2013-10-19','16:35:00',1.17),('9303','2013-10-19','16:40:00',1.07),('9303','2014-05-04','07:50:00',1.09),('9303','2014-05-04','07:55:00',1.17),('9303','2014-05-04','08:00:00',1.28),('9303','2014-05-04','08:05:00',1.39),('9303','2014-05-04','08:10:00',1.49),('9303','2014-05-04','08:15:00',1.6),('9303','2014-05-04','08:20:00',1.74),('9303','2014-05-04','08:25:00',1.87),('9303','2014-05-04','08:30:00',2.08),('9303','2014-05-04','08:35:00',1.86),('9303','2014-05-04','08:40:00',1.68),('9303','2014-05-04','08:45:00',1.25),('9303','2014-05-04','08:50:00',1.66),('9303','2014-05-04','08:55:00',1.12),('9303','2014-05-04','09:00:00',1.25),('9303','2014-05-04','09:05:00',2.01),('9303','2014-05-04','09:10:00',1.95),('9303','2014-05-04','09:15:00',2.26),('9303','2014-05-04','09:20:00',3.52),('9303','2014-05-04','09:25:00',2.91),('9303','2014-05-04','09:30:00',1.26),('9303','2014-05-04','09:35:00',1.17),('9303','2014-05-04','09:40:00',1.52),('9303','2014-05-04','09:45:00',2.18),('9303','2014-05-04','09:50:00',2.39),('9303','2014-05-04','09:55:00',2.49),('9303','2014-05-04','10:00:00',3.7),('9303','2014-05-04','10:05:00',3.14),('9303','2014-05-04','10:10:00',3.55),('9303','2014-05-04','10:15:00',2.47),('9303','2014-05-04','10:20:00',1.83),('9303','2014-05-04','10:25:00',1.8),('9303','2014-05-04','10:30:00',1.86),('9303','2014-05-04','10:35:00',1.97),('9303','2014-05-04','10:40:00',2.05),('9303','2014-05-04','10:45:00',3.36),('9303','2014-05-04','10:50:00',3.81),('9303','2014-05-04','10:55:00',2.47),('9303','2014-05-04','11:00:00',2.37),('9303','2014-05-04','11:05:00',3.53),('9303','2014-05-04','11:10:00',4.6),('9303','2014-05-04','11:15:00',3.98),('9303','2014-05-04','11:20:00',4.27),('9303','2014-05-04','11:25:00',3.53),('9303','2014-05-04','11:30:00',4.03),('9303','2014-05-04','11:35:00',3.85),('9303','2014-05-04','11:40:00',2.7),('9303','2014-05-04','11:45:00',4.47),('9303','2014-05-04','11:50:00',2.78),('9303','2014-05-04','11:55:00',3.29),('9303','2014-05-04','12:00:00',3),('9303','2014-05-04','12:05:00',3.66),('9303','2014-05-04','12:10:00',2.37),('9303','2014-05-04','12:15:00',1.5),('9303','2014-05-04','12:20:00',1.63),('9303','2014-05-04','12:25:00',1.84),('9303','2014-05-04','12:30:00',4.91),('9303','2014-05-04','12:35:00',4.7),('9303','2014-05-04','12:40:00',4.04),('9303','2014-05-04','12:45:00',4.48),('9303','2014-05-04','12:50:00',2.67),('9303','2014-05-04','12:55:00',3.19),('9303','2014-05-04','13:00:00',2.13),('9303','2014-05-04','13:05:00',3.07),('9303','2014-05-04','13:10:00',3.67),('9303','2014-05-04','13:15:00',2.01),('9303','2014-05-04','13:20:00',1.67),('9303','2014-05-04','13:25:00',1.45),('9303','2014-05-04','13:30:00',1.51),('9303','2014-05-04','13:35:00',1.6),('9303','2014-05-04','13:40:00',1.54),('9303','2014-05-04','13:45:00',1.34),('9303','2014-05-04','13:50:00',1.3),('9303','2014-05-04','13:55:00',1.29),('9303','2014-05-04','14:00:00',1.34),('9303','2014-05-04','14:05:00',1.38),('9303','2014-05-04','14:10:00',1.33),('9303','2014-05-04','14:15:00',1.2),('9303','2014-05-04','14:50:00',1.13),('9303','2014-05-04','14:55:00',1.66),('9303','2014-05-04','15:00:00',1.8),('9303','2014-05-04','15:05:00',2.63),('9303','2014-05-04','15:10:00',3.3),('9303','2014-05-04','15:15:00',2.42),('9303','2014-05-04','15:20:00',1.52),('9303','2014-05-04','15:25:00',1.25),('9303','2014-05-04','15:50:00',1.09),('9303','2014-05-04','15:55:00',1.1),('9303','2014-05-04','16:10:00',1.19),('9303','2014-05-04','16:15:00',1.15),('9303','2014-04-16','08:05:00',1.05),('9303','2014-04-16','08:10:00',1.16),('9303','2014-04-16','08:15:00',1.3),('9303','2014-04-16','08:20:00',1.41),('9303','2014-04-16','08:25:00',1.5),('9303','2014-04-16','08:30:00',1.08),('9303','2014-04-16','08:40:00',1.1),('9303','2014-04-16','08:45:00',1.77),('9303','2014-04-16','08:50:00',1.99),('9303','2014-04-16','08:55:00',2.12),('9303','2014-04-16','09:00:00',2.19),('9303','2014-04-16','09:05:00',2.29),('9303','2014-04-16','09:10:00',2.38),('9303','2014-04-16','09:15:00',2.45),('9303','2014-04-16','09:20:00',2.54),('9303','2014-04-16','09:25:00',2.66),('9303','2014-04-16','09:30:00',1.44),('9303','2014-04-16','09:50:00',1.78),('9303','2014-04-16','09:55:00',3.34),('9303','2014-04-16','10:00:00',3.23),('9303','2014-04-16','10:05:00',3.31),('9303','2014-04-16','10:10:00',3.4),('9303','2014-04-16','10:15:00',3.48),('9303','2014-04-16','10:20:00',3.54),('9303','2014-04-16','10:25:00',3.6),('9303','2014-04-16','10:30:00',3.65),('9303','2014-04-16','10:35:00',3.7),('9303','2014-04-16','10:40:00',3.75),('9303','2014-04-16','10:45:00',3.84),('9303','2014-04-16','10:50:00',3.99),('9303','2014-04-16','10:55:00',3.69),('9303','2014-04-16','11:00:00',3.98),('9303','2014-04-16','11:05:00',2.74),('9303','2014-04-16','11:10:00',1.49),('9303','2014-04-16','11:15:00',2.24),('9303','2014-04-16','11:20:00',4.38),('9303','2014-04-16','11:25:00',2.6),('9303','2014-04-16','11:30:00',3.76),('9303','2014-04-16','11:35:00',2.38),('9303','2014-04-16','11:40:00',4.08),('9303','2014-04-16','11:45:00',4.12),('9303','2014-04-16','11:50:00',4.82),('9303','2014-04-16','11:55:00',4.68),('9303','2014-04-16','12:00:00',4.84),('9303','2014-04-16','12:05:00',2.31),('9303','2014-04-16','12:10:00',4.56),('9303','2014-04-16','12:15:00',4.48),('9303','2014-04-16','12:20:00',3.24),('9303','2014-04-16','12:25:00',1.51),('9303','2014-04-16','12:30:00',2.2),('9303','2014-04-16','12:35:00',4.65),('9303','2014-04-16','12:40:00',4.81),('9303','2014-04-16','12:45:00',4.67),('9303','2014-04-16','12:50:00',4.58),('9303','2014-04-16','12:55:00',1.36),('9303','2014-04-16','13:00:00',2.86),('9303','2014-04-16','13:05:00',1.32),('9303','2014-04-16','13:20:00',1.23),('9303','2014-04-16','13:35:00',1.5),('9303','2014-04-16','13:40:00',2.32),('9303','2014-04-16','13:45:00',4.91),('9303','2014-04-16','13:50:00',4.01),('9303','2014-04-16','13:55:00',2.65),('9303','2014-04-16','14:00:00',1.71),('9303','2014-04-16','14:05:00',3.64),('9303','2014-04-16','14:10:00',4.97),('9303','2014-04-16','14:15:00',4.97),('9303','2014-04-16','14:20:00',4.18),('9303','2014-04-16','14:25:00',4.18),('9303','2014-04-16','14:30:00',4.31),('9303','2014-04-16','14:35:00',4.35),('9303','2014-04-16','14:40:00',4.28),('9303','2014-04-16','14:45:00',3.82),('9303','2014-04-16','14:50:00',3.7),('9303','2014-04-16','14:55:00',1.08),('9303','2014-04-16','15:00:00',1.71),('9303','2014-04-16','15:05:00',3.88),('9303','2014-04-16','15:10:00',4.76),('9303','2014-04-16','15:15:00',2.49),('9303','2014-04-16','15:25:00',1.09),('9303','2014-04-16','15:30:00',3.05),('9303','2014-04-16','15:35:00',3.66),('9303','2014-04-16','15:40:00',3.92),('9303','2014-04-16','15:45:00',3.81),('9303','2014-04-16','15:50:00',3.72),('9303','2014-04-16','15:55:00',3.62),('9303','2014-04-16','16:00:00',3.48),('9303','2014-04-16','16:05:00',3.38),('9303','2014-04-16','16:10:00',3.3),('9303','2014-04-16','16:15:00',3.24),('9303','2014-04-16','16:20:00',3.19),('9303','2014-04-16','16:25:00',3.09),('9303','2014-04-16','16:30:00',3.04),('9303','2014-04-16','16:35:00',2.96),('9303','2014-04-16','16:40:00',2.87),('9303','2014-04-16','16:45:00',2.79),('9303','2014-04-16','16:50:00',2.63),('9303','2014-04-16','16:55:00',2.49),('9303','2014-04-16','17:00:00',2.4),('9303','2014-04-16','17:05:00',2.29),('9303','2014-04-16','17:10:00',2.21),('9303','2014-04-16','17:15:00',2.14),('9303','2014-04-16','17:20:00',2.03),('9303','2014-04-16','17:25:00',1.92),('9303','2014-04-16','17:30:00',1.85),('9303','2014-04-16','17:35:00',1.75),('9303','2014-04-16','17:40:00',1.62),('9303','2014-04-16','17:45:00',1.56),('9303','2014-04-16','17:50:00',1.51),('9303','2014-04-16','17:55:00',1.48),('9303','2014-04-16','18:00:00',1.34),('9303','2014-04-16','18:05:00',1.23),('9303','2014-04-16','18:10:00',1.07),('9303','2013-10-18','09:05:00',1.07),('9303','2013-10-18','09:10:00',1.24),('9303','2013-10-18','09:15:00',1.41),('9303','2013-10-18','09:20:00',1.61),('9303','2013-10-18','09:25:00',1.66),('9303','2013-10-18','09:30:00',1.79),('9303','2013-10-18','09:35:00',1.89),('9303','2013-10-18','09:40:00',1.97),('9303','2013-10-18','09:45:00',2.06),('9303','2013-10-18','09:50:00',2.13),('9303','2013-10-18','09:55:00',2.19),('9303','2013-10-18','10:00:00',2.24),('9303','2013-10-18','10:05:00',2.26),('9303','2013-10-18','10:10:00',2.32),('9303','2013-10-18','10:15:00',2.32),('9303','2013-10-18','10:20:00',2.38),('9303','2013-10-18','10:25:00',2.4),('9303','2013-10-18','10:30:00',2.45),('9303','2013-10-18','10:35:00',2.47),('9303','2013-10-18','10:40:00',2.52),('9303','2013-10-18','10:45:00',2.59),('9303','2013-10-18','10:50:00',2.6),('9303','2013-10-18','10:55:00',2.68),('9303','2013-10-18','11:00:00',2.63),('9303','2013-10-18','11:05:00',2.67),('9303','2013-10-18','11:10:00',2.62),('9303','2013-10-18','11:15:00',2.52),('9303','2013-10-18','11:20:00',2.79),('9303','2013-10-18','11:25:00',2.62),('9303','2013-10-18','11:30:00',2.88),('9303','2013-10-18','11:35:00',2.9),('9303','2013-10-18','11:40:00',2.98),('9303','2013-10-18','11:45:00',2.93),('9303','2013-10-18','11:50:00',2.94),('9303','2013-10-18','11:55:00',3.07),('9303','2013-10-18','12:00:00',2.9),('9303','2013-10-18','12:05:00',3.02),('9303','2013-10-18','12:10:00',3.06),('9303','2013-10-18','12:15:00',2.96),('9303','2013-10-18','12:20:00',2.97),('9303','2013-10-18','12:25:00',3.07),('9303','2013-10-18','12:30:00',3.04),('9303','2013-10-18','12:35:00',2.97),('9303','2013-10-18','12:40:00',3.08),('9303','2013-10-18','12:45:00',3.01),('9303','2013-10-18','12:50:00',3.03),('9303','2013-10-18','12:55:00',3.15),('9303','2013-10-18','13:00:00',3.13),('9303','2013-10-18','13:05:00',3.04),('9303','2013-10-18','13:10:00',3.01),('9303','2013-10-18','13:15:00',3.09),('9303','2013-10-18','13:20:00',3.07),('9303','2013-10-18','13:25:00',3.11),('9303','2013-10-18','13:30:00',3.08),('9303','2013-10-18','13:35:00',3.01),('9303','2013-10-18','13:40:00',3.06),('9303','2013-10-18','13:45:00',2.99),('9303','2013-10-18','13:50:00',2.92),('9303','2013-10-18','13:55:00',2.9),('9303','2013-10-18','14:00:00',2.67),('9303','2013-10-18','14:05:00',2.74),('9303','2013-10-18','14:10:00',2.74),('9303','2013-10-18','14:15:00',2.76),('9303','2013-10-18','14:20:00',2.63),('9303','2013-10-18','14:25:00',2.61),('9303','2013-10-18','14:30:00',2.58),('9303','2013-10-18','14:35:00',2.5),('9303','2013-10-18','14:40:00',2.53),('9303','2013-10-18','14:45:00',2.52),('9303','2013-10-18','14:50:00',2.42),('9303','2013-10-18','14:55:00',2.47),('9303','2013-10-18','15:00:00',2.16),('9303','2013-10-18','15:05:00',1.92),('9303','2013-10-18','15:10:00',2.12),('9303','2013-10-18','15:15:00',2.12),('9303','2013-10-18','15:20:00',2.23),('9303','2013-10-18','15:25:00',2.16),('9303','2013-10-18','15:30:00',2.07),('9303','2013-10-18','15:35:00',2.06),('9303','2013-10-18','15:40:00',1.98),('9303','2013-10-18','15:45:00',1.79),('9303','2013-10-18','15:50:00',1.8),('9303','2013-10-18','15:55:00',1.63),('9303','2013-10-18','16:00:00',1.66),('9303','2013-10-18','16:05:00',1.53),('9303','2013-10-18','16:10:00',1.45),('9303','2013-10-18','16:15:00',1.27),('9303','2013-10-18','16:20:00',1.17),('9303','2013-10-18','16:25:00',1),('9303','2013-10-17','09:00:00',1.03),('9303','2013-10-17','09:05:00',1.19),('9303','2013-10-17','09:10:00',1.42),('9303','2013-10-17','09:15:00',1.52),('9303','2013-10-17','09:20:00',1.62),('9303','2013-10-17','09:25:00',1.7),('9303','2013-10-17','09:30:00',1.79),('9303','2013-10-17','09:35:00',1.88),('9303','2013-10-17','09:40:00',1.96),('9303','2013-10-17','09:45:00',2.06),('9303','2013-10-17','09:50:00',2.14),('9303','2013-10-17','09:55:00',2.2),('9303','2013-10-17','10:00:00',2.27),('9303','2013-10-17','10:05:00',2.29),('9303','2013-10-17','10:10:00',2.34),('9303','2013-10-17','10:15:00',2.36),('9303','2013-10-17','10:20:00',2.41),('9303','2013-10-17','10:25:00',2.44),('9303','2013-10-17','10:30:00',2.5),('9303','2013-10-17','10:35:00',2.53),('9303','2013-10-17','10:40:00',2.57),('9303','2013-10-17','10:45:00',2.64),('9303','2013-10-17','10:50:00',2.65),('9303','2013-10-17','10:55:00',2.73),('9303','2013-10-17','11:00:00',2.74),('9303','2013-10-17','11:05:00',2.83),('9303','2013-10-17','11:10:00',2.84),('9303','2013-10-17','11:15:00',2.85),('9303','2013-10-17','11:20:00',2.91),('9303','2013-10-17','11:25:00',2.93),('9303','2013-10-17','11:30:00',3.02),('9303','2013-10-17','11:35:00',3.04),('9303','2013-10-17','11:40:00',3.06),('9303','2013-10-17','11:45:00',3.08),('9303','2013-10-17','11:50:00',3.09),('9303','2013-10-17','11:55:00',3.11),('9303','2013-10-17','12:00:00',3.1),('9303','2013-10-17','12:05:00',3.13),('9303','2013-10-17','12:10:00',3.17),('9303','2013-10-17','12:15:00',3.16),('9303','2013-10-17','12:20:00',3.18),('9303','2013-10-17','12:25:00',3.22),('9303','2013-10-17','12:30:00',3.15),('9303','2013-10-17','12:35:00',3.16),('9303','2013-10-17','12:40:00',3.24),('9303','2013-10-17','12:45:00',3.24),('9303','2013-10-17','12:50:00',3.25),('9303','2013-10-17','12:55:00',3.29),('9303','2013-10-17','13:00:00',3.28),('9303','2013-10-17','13:05:00',3.25),('9303','2013-10-17','13:10:00',3.31),('9303','2013-10-17','13:15:00',3.34),('9303','2013-10-17','13:20:00',3.26),('9303','2013-10-17','13:25:00',3.19),('9303','2013-10-17','13:30:00',3.18),('9303','2013-10-17','13:35:00',3.15),('9303','2013-10-17','13:40:00',3.13),('9303','2013-10-17','13:45:00',3.12),('9303','2013-10-17','13:50:00',3.12),('9303','2013-10-17','13:55:00',3.13),('9303','2013-10-17','14:00:00',3.05),('9303','2013-10-17','14:05:00',2.99),('9303','2013-10-17','14:10:00',2.97),('9303','2013-10-17','14:15:00',2.92),('9303','2013-10-17','14:20:00',2.82),('9303','2013-10-17','14:25:00',2.74),('9303','2013-10-17','14:30:00',2.72),('9303','2013-10-17','14:35:00',2.72),('9303','2013-10-17','14:40:00',2.72),('9303','2013-10-17','14:45:00',2.72),('9303','2013-10-17','14:50:00',2.67),('9303','2013-10-17','14:55:00',2.62),('9303','2013-10-17','15:00:00',2.56),('9303','2013-10-17','15:05:00',2.51),('9303','2013-10-17','15:10:00',2.47),('9303','2013-10-17','15:15:00',2.43),('9303','2013-10-17','15:20:00',2.36),('9303','2013-10-17','15:25:00',2.34),('9303','2013-10-17','15:30:00',2.32),('9303','2013-10-17','15:35:00',2.27),('9303','2013-10-17','15:40:00',2.22),('9303','2013-10-17','15:45:00',2.16),('9303','2013-10-17','15:50:00',2.08),('9303','2013-10-17','15:55:00',2.01),('9303','2013-10-17','16:00:00',1.88),('9303','2013-10-17','16:05:00',1.77),('9303','2013-10-17','16:10:00',1.7),('9303','2013-10-17','16:15:00',1.62),('9303','2013-10-17','16:20:00',1.54),('9303','2013-10-17','16:25:00',1.44),('9303','2013-10-17','16:30:00',1.31),('9303','2013-10-17','16:35:00',1.19),('9303','2013-10-17','16:40:00',1.08),('9303','2013-10-16','09:45:00',1.24),('9303','2013-10-16','09:50:00',1.34),('9303','2013-10-16','11:15:00',1.33),('9303','2013-10-16','11:55:00',1.04),('9303','2013-10-16','12:15:00',2.22),('9303','2013-10-16','12:20:00',2.53),('9303','2013-10-16','12:25:00',1.1),('9303','2013-10-16','12:35:00',1.48),('9303','2013-10-16','12:40:00',3.58),('9303','2013-10-16','12:45:00',3.28),('9303','2013-10-16','12:50:00',2.97),('9303','2013-10-16','12:55:00',2.69),('9303','2013-10-16','13:00:00',2.61),('9303','2013-10-16','13:05:00',3.29),('9303','2013-10-16','13:10:00',2.3),('9303','2013-10-16','13:15:00',2.56),('9303','2013-10-16','13:20:00',2.7),('9303','2013-10-16','13:25:00',3.34),('9303','2013-10-16','13:30:00',3.08),('9303','2013-10-16','13:35:00',3.2),('9303','2013-10-16','13:40:00',3.23),('9303','2013-10-16','13:45:00',3.14),('9303','2013-10-16','13:50:00',3.05),('9303','2013-10-16','13:55:00',3.3),('9303','2013-10-16','14:00:00',2.75),('9303','2013-10-16','14:05:00',2.09),('9303','2013-10-16','14:10:00',2.75),('9303','2013-10-16','14:15:00',2.65),('9303','2013-10-16','14:20:00',2.81),('9303','2013-10-16','14:25:00',1.74),('9303','2013-10-16','14:30:00',2.2),('9303','2013-10-16','14:35:00',1.88),('9303','2013-10-16','14:40:00',2.47),('9303','2013-10-16','14:45:00',2.83),('9303','2013-10-16','14:50:00',2.72),('9303','2013-10-16','14:55:00',2.32),('9303','2013-10-16','15:00:00',2.56),('9303','2013-10-16','15:05:00',2.57),('9303','2013-10-16','15:10:00',2.61),('9303','2013-10-16','15:15:00',2.49),('9303','2013-10-16','15:20:00',2.42),('9303','2013-10-16','15:25:00',1.75),('9303','2013-10-16','15:35:00',2.04),('9303','2013-10-16','15:40:00',2.38),('9303','2013-10-16','15:45:00',2.17),('9303','2013-10-16','15:50:00',2.1),('9303','2013-10-16','15:55:00',2.03),('9303','2013-10-16','16:00:00',1.92),('9303','2013-10-16','16:05:00',1.8),('9303','2013-10-16','16:10:00',1.68),('9303','2013-10-16','16:15:00',1.63),('9303','2013-10-16','16:20:00',1.55),('9303','2013-10-16','16:25:00',1.45),('9303','2013-10-16','16:30:00',1.31),('9303','2013-10-16','16:35:00',1.23),('9303','2013-10-16','16:40:00',1.14),('9303','2013-10-16','16:45:00',1),('9303','2013-10-15','09:25:00',1.03),('9303','2013-10-15','09:30:00',1.47),('9303','2013-10-15','09:40:00',1.34),('9303','2013-10-15','09:45:00',1.84),('9303','2013-10-15','09:50:00',2.06),('9303','2013-10-15','09:55:00',2.16),('9303','2013-10-15','10:00:00',2.15),('9303','2013-10-15','10:05:00',2.3),('9303','2013-10-15','10:10:00',1.78),('9303','2013-10-15','10:15:00',1.13),('9303','2013-10-15','10:20:00',1.08),('9303','2013-10-15','10:25:00',1.2),('9303','2013-10-15','10:30:00',1.7),('9303','2013-10-15','10:35:00',1.35),('9303','2013-10-15','10:40:00',1.77),('9303','2013-10-15','10:45:00',2.02),('9303','2013-10-15','10:50:00',1.96),('9303','2013-10-15','10:55:00',1.67),('9303','2013-10-15','11:00:00',1.7),('9303','2013-10-15','11:05:00',1.77),('9303','2013-10-15','11:10:00',2.4),('9303','2013-10-15','11:15:00',2.57),('9303','2013-10-15','11:20:00',2.62),('9303','2013-10-15','11:25:00',2.47),('9303','2013-10-15','11:30:00',2.52),('9303','2013-10-15','11:35:00',2.13),('9303','2013-10-15','11:40:00',1.71),('9303','2013-10-15','11:45:00',1.43),('9303','2013-10-15','11:50:00',1.37),('9303','2013-10-15','11:55:00',1.34),('9303','2013-10-15','12:00:00',1.39),('9303','2013-10-15','12:05:00',1.39),('9303','2013-10-15','12:10:00',1.4),('9303','2013-10-15','12:15:00',1.39),('9303','2013-10-15','12:20:00',1.46),('9303','2013-10-15','12:25:00',1.34),('9303','2013-10-15','12:30:00',1.21),('9303','2013-10-15','12:35:00',1.19),('9303','2013-10-15','12:40:00',1.16),('9303','2013-10-15','12:45:00',1.29),('9303','2013-10-15','12:50:00',1.21),('9303','2013-10-15','12:55:00',1.08),('9303','2013-10-15','13:00:00',1.08),('9303','2013-10-15','13:05:00',1.39),('9303','2013-10-15','13:10:00',1.73),('9303','2013-10-15','13:15:00',1.76),('9303','2013-10-15','13:20:00',2.49),('9303','2013-10-15','13:25:00',2.85),('9303','2013-10-15','13:30:00',1.78),('9303','2013-10-15','13:35:00',1.56),('9303','2013-10-15','13:40:00',1.43),('9303','2013-10-15','13:45:00',1.5),('9303','2013-10-15','13:50:00',1.34),('9303','2013-10-15','13:55:00',1.21),('9303','2013-10-15','14:00:00',1.09),('9303','2013-10-15','14:05:00',1.07),('9303','2013-10-15','14:10:00',1.18),('9303','2013-10-15','14:15:00',1.61),('9303','2013-10-15','14:20:00',1.87),('9303','2013-10-15','14:25:00',2.03),('9303','2013-10-15','14:30:00',1.94),('9303','2013-10-15','14:35:00',1.29),('9303','2013-10-15','14:40:00',1.82),('9303','2013-10-15','14:45:00',2),('9303','2013-10-15','14:50:00',2.16),('9303','2013-10-15','14:55:00',1.9),('9303','2013-10-15','15:00:00',1.23),('9303','2013-10-15','15:05:00',1.25),('9303','2013-10-15','15:10:00',1.32),('9303','2013-10-15','15:15:00',1.19),('9303','2013-10-15','15:20:00',1.06),('9303','2013-10-15','16:30:00',1.01),('9303','2013-10-15','16:35:00',1.06),('9303','2013-10-14','08:55:00',1.09),('9303','2013-10-14','09:05:00',1.03),('9303','2013-10-14','09:25:00',1.53),('9303','2013-10-14','09:30:00',1.74),('9303','2013-10-14','09:35:00',1.69),('9303','2013-10-14','09:40:00',1.45),('9303','2013-10-14','09:45:00',1.29),('9303','2013-10-14','09:50:00',1.6),('9303','2013-10-14','09:55:00',1.92),('9303','2013-10-14','10:00:00',1.87),('9303','2013-10-14','10:05:00',2.03),('9303','2013-10-14','10:10:00',2.14),('9303','2013-10-14','10:15:00',2.23),('9303','2013-10-14','10:20:00',2.26),('9303','2013-10-14','10:25:00',2.28),('9303','2013-10-14','10:30:00',2.32),('9303','2013-10-14','10:35:00',2.32),('9303','2013-10-14','10:40:00',2.28),('9303','2013-10-14','10:45:00',2.37),('9303','2013-10-14','10:50:00',2.47),('9303','2013-10-14','10:55:00',2.52),('9303','2013-10-14','11:00:00',2.57),('9303','2013-10-14','11:05:00',2.58),('9303','2013-10-14','11:10:00',2.68),('9303','2013-10-14','11:15:00',2.68),('9303','2013-10-14','11:20:00',2.69),('9303','2013-10-14','11:25:00',2.76),('9303','2013-10-14','11:30:00',2.84),('9303','2013-10-14','11:35:00',2.79),('9303','2013-10-14','11:40:00',2.82),('9303','2013-10-14','11:45:00',2.78),('9303','2013-10-14','11:50:00',2.81),('9303','2013-10-14','11:55:00',2.87),('9303','2013-10-14','12:00:00',2.86),('9303','2013-10-14','12:05:00',2.87),('9303','2013-10-14','12:10:00',2.97),('9303','2013-10-14','12:15:00',2.9),('9303','2013-10-14','12:20:00',2.73),('9303','2013-10-14','12:25:00',2.87),('9303','2013-10-14','12:30:00',2.99),('9303','2013-10-14','12:35:00',2.97),('9303','2013-10-14','12:40:00',3.03),('9303','2013-10-14','12:45:00',3.02),('9303','2013-10-14','12:50:00',2.99),('9303','2013-10-14','12:55:00',3.06),('9303','2013-10-14','13:00:00',3.08),('9303','2013-10-14','13:05:00',3.07),('9303','2013-10-14','13:10:00',3.11),('9303','2013-10-14','13:15:00',3.09),('9303','2013-10-14','13:20:00',3),('9303','2013-10-14','13:25:00',2.96),('9303','2013-10-14','13:30:00',2.94),('9303','2013-10-14','13:35:00',2.92),('9303','2013-10-14','13:40:00',2.92),('9303','2013-10-14','13:45:00',2.92),('9303','2013-10-14','13:50:00',2.91),('9303','2013-10-14','13:55:00',2.88),('9303','2013-10-14','14:00:00',2.85),('9303','2013-10-14','14:05:00',2.83),('9303','2013-10-14','14:10:00',2.8),('9303','2013-10-14','14:15:00',2.78),('9303','2013-10-14','14:20:00',2.69),('9303','2013-10-14','14:25:00',2.64),('9303','2013-10-14','14:30:00',2.57),('9303','2013-10-14','14:35:00',2.56),('9303','2013-10-14','14:40:00',2.61),('9303','2013-10-14','14:45:00',2.59),('9303','2013-10-14','14:50:00',2.53),('9303','2013-10-14','14:55:00',2.46),('9303','2013-10-14','15:00:00',2.39),('9303','2013-10-14','15:05:00',2.33),('9303','2013-10-14','15:10:00',2.28),('9303','2013-10-14','15:15:00',2.26),('9303','2013-10-14','15:20:00',2.21),('9303','2013-10-14','15:25:00',2.16),('9303','2013-10-14','15:30:00',2.1),('9303','2013-10-14','15:35:00',2.05),('9303','2013-10-14','15:40:00',1.79),('9303','2013-10-14','15:45:00',1.59),('9303','2013-10-14','15:50:00',1.4),('9303','2013-10-14','15:55:00',1.08),('9303','2013-10-14','16:00:00',1.33),('9303','2013-10-14','16:05:00',1.05),('9303','2013-10-13','09:00:00',1.01),('9303','2013-10-13','09:05:00',1.05),('9303','2013-10-13','09:15:00',1.53),('9303','2013-10-13','09:20:00',1.68),('9303','2013-10-13','09:25:00',1.56),('9303','2013-10-13','09:30:00',1.09),('9303','2013-10-13','09:35:00',1.35),('9303','2013-10-13','09:40:00',1.79),('9303','2013-10-13','09:45:00',2.58),('9303','2013-10-13','09:50:00',2.49),('9303','2013-10-13','09:55:00',2.57),('9303','2013-10-13','10:00:00',2.01),('9303','2013-10-13','10:05:00',1.43),('9303','2013-10-13','10:10:00',1.86),('9303','2013-10-13','10:15:00',2.14),('9303','2013-10-13','10:20:00',1.77),('9303','2013-10-13','10:25:00',1.89),('9303','2013-10-13','10:30:00',2.22),('9303','2013-10-13','10:35:00',2.74),('9303','2013-10-13','10:40:00',2.92),('9303','2013-10-13','10:45:00',2.97),('9303','2013-10-13','10:50:00',2.74),('9303','2013-10-13','10:55:00',1.98),('9303','2013-10-13','11:00:00',2.6),('9303','2013-10-13','11:05:00',2.71),('9303','2013-10-13','11:10:00',2.88),('9303','2013-10-13','11:15:00',2.96),('9303','2013-10-13','11:20:00',2.84),('9303','2013-10-13','11:25:00',2.78),('9303','2013-10-13','11:30:00',2.87),('9303','2013-10-13','11:35:00',2.84),('9303','2013-10-13','11:40:00',2.86),('9303','2013-10-13','11:45:00',2.88),('9303','2013-10-13','11:50:00',2.91),('9303','2013-10-13','11:55:00',2.94),('9303','2013-10-13','12:00:00',2.93),('9303','2013-10-13','12:05:00',2.95),('9303','2013-10-13','12:10:00',2.99),('9303','2013-10-13','12:15:00',2.99),('9303','2013-10-13','12:20:00',2.99),('9303','2013-10-13','12:25:00',2.92),('9303','2013-10-13','12:30:00',3.01),('9303','2013-10-13','12:35:00',3.05),('9303','2013-10-13','12:40:00',3.08),('9303','2013-10-13','12:45:00',3.03),('9303','2013-10-13','12:50:00',3),('9303','2013-10-13','12:55:00',3.07),('9303','2013-10-13','13:00:00',3.08),('9303','2013-10-13','13:05:00',3.06),('9303','2013-10-13','13:10:00',3.13),('9303','2013-10-13','13:15:00',3.17),('9303','2013-10-13','13:20:00',3.15),('9303','2013-10-13','13:25:00',2.76),('9303','2013-10-13','13:30:00',2.26),('9303','2013-10-13','13:35:00',2.75),('9303','2013-10-13','13:40:00',1.72),('9303','2013-10-13','13:45:00',1.94),('9303','2013-10-13','13:50:00',2.1),('9303','2013-10-13','13:55:00',2.23),('9303','2013-10-13','14:00:00',2.88),('9303','2013-10-13','14:05:00',2.94),('9303','2013-10-13','14:10:00',2.91),('9303','2013-10-13','14:15:00',2.7),('9303','2013-10-13','14:20:00',2.91),('9303','2013-10-13','14:25:00',2.88),('9303','2013-10-13','14:30:00',2.65),('9303','2013-10-13','14:35:00',1.93),('9303','2013-10-13','14:40:00',2.5),('9303','2013-10-13','14:45:00',2.08),('9303','2013-10-13','14:50:00',1.6),('9303','2013-10-13','14:55:00',1.92),('9303','2013-10-13','15:00:00',2.3),('9303','2013-10-13','15:05:00',2.22),('9303','2013-10-13','15:10:00',1.54),('9303','2013-10-13','15:15:00',1.64),('9303','2013-10-13','15:20:00',1.95),('9303','2013-10-13','15:25:00',2.08),('9303','2013-10-13','15:30:00',1.6),('9303','2013-10-13','15:35:00',1.44),('9303','2013-10-13','15:40:00',1.42),('9303','2013-10-13','15:45:00',1.32),('9303','2013-10-13','15:50:00',1.28),('9303','2013-10-13','15:55:00',1.21),('9303','2013-10-13','16:00:00',1.32),('9303','2013-10-13','16:05:00',1.58),('9303','2013-10-13','16:10:00',1.32),('9303','2013-10-13','16:15:00',1.12),('9303','2013-10-13','16:20:00',1.17),('9303','2013-10-13','16:25:00',1.56),('9303','2013-10-13','16:30:00',1.55),('9303','2013-10-13','16:35:00',1.26),('9303','2013-10-12','11:25:00',1.08),('9303','2013-10-12','11:30:00',1.26),('9303','2013-10-12','11:35:00',1.72),('9303','2013-10-12','11:40:00',2.79),('9303','2013-10-12','11:45:00',1.49),('9303','2013-10-12','11:50:00',1.33),('9303','2013-10-12','11:55:00',1.16),('9303','2013-10-12','12:20:00',1.67),('9303','2013-10-12','12:25:00',3.32),('9303','2013-10-12','12:30:00',2.41),('9303','2013-10-12','12:35:00',2.83),('9303','2013-10-12','12:40:00',2.87),('9303','2013-10-12','12:45:00',2.74),('9303','2013-10-12','12:50:00',2.78),('9303','2013-10-12','12:55:00',2.44),('9303','2013-10-12','13:00:00',2.11),('9303','2013-10-12','13:05:00',1.14),('9303','2013-10-12','13:20:00',1.27),('9303','2013-10-12','13:25:00',1.36),('9303','2013-10-12','13:30:00',3.11),('9303','2013-10-12','13:35:00',1.49),('9303','2013-10-12','16:00:00',1.05),('9303','2013-10-12','16:10:00',1.02),('9303','2013-10-12','16:15:00',1.62),('9303','2013-10-12','16:20:00',1.37),('9303','2013-10-11','09:20:00',1.06),('9303','2013-10-11','09:25:00',1.17),('9303','2013-10-11','09:35:00',1.33),('9303','2013-10-11','09:45:00',2.14),('9303','2013-10-11','09:50:00',2.19),('9303','2013-10-11','09:55:00',2.25),('9303','2013-10-11','10:00:00',2.29),('9303','2013-10-11','10:05:00',2.33),('9303','2013-10-11','10:10:00',2.38),('9303','2013-10-11','10:15:00',2.08),('9303','2013-10-11','10:20:00',2.13),('9303','2013-10-11','10:25:00',1.84),('9303','2013-10-11','10:30:00',2.56),('9303','2013-10-11','10:35:00',2.79),('9303','2013-10-11','10:40:00',1.54),('9303','2013-10-11','11:05:00',2.17),('9303','2013-10-11','11:10:00',2.13),('9303','2013-10-11','11:15:00',1),('9303','2013-10-11','11:35:00',1.16),('9303','2013-10-11','11:40:00',1.78),('9303','2013-10-11','11:45:00',1.64),('9303','2013-10-11','11:50:00',1.85),('9303','2013-10-11','11:55:00',1.71),('9303','2013-10-11','12:00:00',2.42),('9303','2013-10-11','12:05:00',3.76),('9303','2013-10-11','12:10:00',1.57),('9303','2013-10-11','12:15:00',1.09),('9303','2013-10-11','12:25:00',1.04),('9303','2013-10-11','12:30:00',1.76),('9303','2013-10-11','13:05:00',2.66),('9303','2013-10-11','13:10:00',1.43),('9303','2013-10-11','13:15:00',1.11),('9303','2013-10-11','13:20:00',1.4),('9303','2013-10-11','13:25:00',3.9),('9303','2013-10-11','13:30:00',1.46),('9303','2013-10-11','13:40:00',2.34),('9303','2013-10-11','13:45:00',3),('9303','2013-10-11','13:50:00',1.18),('9303','2013-10-11','15:40:00',1.17),('9303','2013-10-11','15:45:00',1.12),('9303','2013-10-11','16:00:00',2.14),('9303','2013-10-11','16:35:00',1.24),('9303','2013-10-10','08:50:00',1.16),('9303','2013-10-10','08:55:00',1.32),('9303','2013-10-10','09:00:00',1.1),('9303','2013-10-10','09:10:00',1.51),('9303','2013-10-10','09:15:00',1.67),('9303','2013-10-10','09:20:00',1.72),('9303','2013-10-10','09:25:00',1.74),('9303','2013-10-10','09:30:00',1.82),('9303','2013-10-10','09:35:00',1.51),('9303','2013-10-10','09:40:00',1.82),('9303','2013-10-10','09:45:00',1.41),('9303','2013-10-10','10:00:00',1.1),('9303','2013-10-10','10:10:00',1.14),('9303','2013-10-10','10:15:00',2.46),('9303','2013-10-10','10:20:00',2.42),('9303','2013-10-10','10:25:00',2.37),('9303','2013-10-10','10:30:00',2.21),('9303','2013-10-10','10:40:00',1.29),('9303','2013-10-10','10:45:00',1.57),('9303','2013-10-10','10:50:00',2.17),('9303','2013-10-10','10:55:00',1.5),('9303','2013-10-10','11:05:00',1.62),('9303','2013-10-10','11:25:00',2.65),('9303','2013-10-10','11:30:00',2.12),('9303','2013-10-10','11:50:00',1.25),('9303','2013-10-10','11:55:00',3.25),('9303','2013-10-10','12:00:00',3.43),('9303','2013-10-10','12:05:00',3.41),('9303','2013-10-10','12:10:00',1.6),('9303','2013-10-10','12:25:00',3.2),('9303','2013-10-10','12:35:00',2.58),('9303','2013-10-10','12:40:00',3.76),('9303','2013-10-10','12:45:00',3.08),('9303','2013-10-10','12:50:00',1.8),('9303','2013-10-10','12:55:00',1.41),('9303','2013-10-10','13:00:00',3.66),('9303','2013-10-10','13:05:00',3.89),('9303','2013-10-10','13:10:00',3.6),('9303','2013-10-10','13:15:00',3.04),('9303','2013-10-10','13:20:00',1.57),('9303','2013-10-10','13:25:00',2.21),('9303','2013-10-10','13:30:00',2.89),('9303','2013-10-10','13:35:00',1.69),('9303','2013-10-10','13:40:00',1.16),('9303','2013-10-10','13:45:00',3.95),('9303','2013-10-10','13:50:00',3.54),('9303','2013-10-10','13:55:00',3.43),('9303','2013-10-10','14:00:00',3.33),('9303','2013-10-10','14:05:00',2.93),('9303','2013-10-10','14:10:00',2.26),('9303','2013-10-10','14:15:00',1.88),('9303','2013-10-10','14:20:00',3.04),('9303','2013-10-10','14:25:00',3.31),('9303','2013-10-10','14:30:00',3.37),('9303','2013-10-10','14:35:00',2.86),('9303','2013-10-10','14:40:00',3.21),('9303','2013-10-10','14:45:00',3.04),('9303','2013-10-10','14:50:00',2.96),('9303','2013-10-10','14:55:00',2.92),('9303','2013-10-10','15:00:00',2.24),('9303','2013-10-10','15:05:00',3),('9303','2013-10-10','15:10:00',2.83),('9303','2013-10-10','15:15:00',2.29),('9303','2013-10-10','15:20:00',1.87),('9303','2013-10-10','15:25:00',1.7),('9303','2013-10-10','15:30:00',2.4),('9303','2013-10-10','15:35:00',1.55),('9303','2013-10-10','15:40:00',1.12),('9303','2013-10-10','15:45:00',1.01),('9303','2013-10-10','16:15:00',1.2),('9303','2013-10-10','16:20:00',1.33),('9303','2013-10-10','16:25:00',1.36),('9303','2013-10-10','16:30:00',1.34),('9303','2013-10-10','16:45:00',1.38),('9303','2013-10-10','16:50:00',1.22),('9303','2013-10-10','16:55:00',1.18),('9303','2013-10-10','17:00:00',1.08),('9303','2013-10-09','08:40:00',1.06),('9303','2013-10-09','08:45:00',1.11),('9303','2013-10-09','08:50:00',1.21),('9303','2013-10-09','08:55:00',1.29),('9303','2013-10-09','09:00:00',1.39),('9303','2013-10-09','09:05:00',1.49),('9303','2013-10-09','09:10:00',1.58),('9303','2013-10-09','09:15:00',1.55),('9303','2013-10-09','09:20:00',1.48),('9303','2013-10-09','09:25:00',1.85),('9303','2013-10-09','09:30:00',1.93),('9303','2013-10-09','09:35:00',2),('9303','2013-10-09','09:40:00',2.12),('9303','2013-10-09','09:45:00',2.2),('9303','2013-10-09','09:50:00',2.26),('9303','2013-10-09','09:55:00',2.36),('9303','2013-10-09','10:00:00',2.51),('9303','2013-10-09','10:05:00',2.51),('9303','2013-10-09','10:10:00',2.47),('9303','2013-10-09','10:15:00',1.27),('9303','2013-10-09','10:30:00',1.25),('9303','2013-10-09','10:35:00',1.56),('9303','2013-10-09','10:40:00',1.24),('9303','2013-10-09','10:45:00',1.77),('9303','2013-10-09','10:50:00',3.48),('9303','2013-10-09','10:55:00',2.45),('9303','2013-10-09','11:00:00',2.48),('9303','2013-10-09','11:05:00',3.34),('9303','2013-10-09','11:10:00',3.58),('9303','2013-10-09','11:15:00',3.54),('9303','2013-10-09','11:20:00',3.3),('9303','2013-10-09','11:25:00',2.75),('9303','2013-10-09','11:30:00',3.46),('9303','2013-10-09','11:35:00',3.68),('9303','2013-10-09','11:40:00',3.48),('9303','2013-10-09','11:45:00',3.02),('9303','2013-10-09','11:50:00',2.87),('9303','2013-10-09','11:55:00',3.15),('9303','2013-10-09','12:00:00',2.38),('9303','2013-10-09','12:05:00',1.09),('9303','2013-10-09','12:10:00',2.18),('9303','2013-10-09','12:15:00',3.69),('9303','2013-10-09','12:20:00',3.92),('9303','2013-10-09','12:25:00',3),('9303','2013-10-09','12:30:00',1.3),('9303','2013-10-09','12:35:00',1.5),('9303','2013-10-09','12:40:00',1.34),('9303','2013-10-09','13:15:00',1.43),('9303','2013-10-09','13:20:00',1.66),('9303','2013-10-09','13:25:00',2.38),('9303','2013-10-09','13:30:00',2.5),('9303','2013-10-09','13:35:00',1.75),('9303','2013-10-09','13:40:00',3.08),('9303','2013-10-09','13:45:00',2.57),('9303','2013-10-09','13:50:00',2.65),('9303','2013-10-09','13:55:00',2.81),('9303','2013-10-09','14:00:00',3.57),('9303','2013-10-09','14:05:00',1.63),('9303','2013-10-09','14:10:00',1.7),('9303','2013-10-09','14:55:00',2.56),('9303','2013-10-09','15:00:00',1.11),('9303','2013-10-09','15:05:00',3),('9303','2013-10-09','15:10:00',2.97),('9303','2013-10-09','15:15:00',2.78),('9303','2013-10-09','15:20:00',2.59),('9303','2013-10-09','15:25:00',2.56),('9303','2013-10-09','15:30:00',2.31),('9303','2013-10-09','15:35:00',1.4),('9303','2013-10-09','15:40:00',1.79),('9303','2013-10-09','15:45:00',1.2),('9303','2013-10-09','15:50:00',1.47),('9303','2013-10-09','16:15:00',1.22),('9303','2013-10-09','16:20:00',1.42),('9303','2013-10-09','16:25:00',1.47),('9303','2013-10-09','16:30:00',2.14),('9303','2013-10-09','16:35:00',1.22),('9303','2013-10-09','16:40:00',1.64),('9303','2014-04-15','09:00:00',1.79),('9303','2014-04-15','09:05:00',2.05),('9303','2014-04-15','09:10:00',1.11),('9303','2014-04-15','09:15:00',2.11),('9303','2014-04-15','09:20:00',2.24),('9303','2014-04-15','09:25:00',2.54),('9303','2014-04-15','09:30:00',2.19),('9303','2014-04-15','09:45:00',1.02),('9303','2014-04-15','09:50:00',2.84),('9303','2014-04-15','10:00:00',1.16),('9303','2014-04-15','10:05:00',1.24),('9303','2014-04-15','10:10:00',1.57),('9303','2014-04-15','10:15:00',1.96),('9303','2014-04-15','10:20:00',1.65),('9303','2014-04-15','10:25:00',1.34),('9303','2014-04-15','10:30:00',2.46),('9303','2014-04-15','10:35:00',2.6),('9303','2014-04-15','10:40:00',2.18),('9303','2014-04-15','10:45:00',2.99),('9303','2014-04-15','10:50:00',2.63),('9303','2014-04-15','10:55:00',1.5),('9303','2014-04-15','11:00:00',1.38),('9303','2014-04-15','11:05:00',3.55),('9303','2014-04-15','11:10:00',2.39),('9303','2014-04-15','11:15:00',1.34),('9303','2014-04-15','11:25:00',1.4),('9303','2014-04-15','11:30:00',1.05),('9303','2014-04-15','11:50:00',1.27),('9303','2014-04-15','12:15:00',1.56),('9303','2014-04-15','12:20:00',1.67),('9303','2014-04-15','13:10:00',1.41),('9303','2014-04-15','13:15:00',1.74),('9303','2014-04-15','13:20:00',2.55),('9303','2014-04-15','13:25:00',1.6),('9303','2014-04-15','13:30:00',2.73),('9303','2014-04-15','13:35:00',2.64),('9303','2014-04-15','13:40:00',1.99),('9303','2014-04-15','13:45:00',1.05),('9303','2014-04-15','14:00:00',2.22),('9303','2014-04-15','14:05:00',2.09),('9303','2014-04-15','14:10:00',1.57),('9303','2014-04-15','14:15:00',3.75),('9303','2014-04-15','14:20:00',3.01),('9303','2014-04-15','14:25:00',3.38),('9303','2014-04-15','14:30:00',2.29),('9303','2014-04-15','14:35:00',1.66),('9303','2014-04-15','14:40:00',1.68),('9303','2014-04-15','14:45:00',2.11),('9303','2014-04-15','14:50:00',2.07),('9303','2014-04-15','14:55:00',1.57),('9303','2014-04-15','15:10:00',1.03),('9303','2014-04-15','15:15:00',1.82),('9303','2014-04-15','15:20:00',1.65),('9303','2014-04-15','15:25:00',2.13),('9303','2014-04-15','15:30:00',1.48),('9303','2014-04-15','15:35:00',1.39),('9303','2014-04-15','15:40:00',1.38),('9303','2014-04-15','15:45:00',1.28),('9303','2014-04-15','15:50:00',1.33),('9303','2014-04-15','15:55:00',1.32),('9303','2014-04-15','16:00:00',1.3),('9303','2014-04-15','16:05:00',1.28),('9303','2013-10-08','08:20:00',1.01),('9303','2013-10-08','10:00:00',1.07),('9303','2013-10-08','11:00:00',1.87),('9303','2013-10-08','11:05:00',1.14),('9303','2013-10-08','11:10:00',1.94),('9303','2013-10-08','11:15:00',3.56),('9303','2013-10-08','11:20:00',3.48),('9303','2013-10-08','11:25:00',1.83),('9303','2013-10-08','11:30:00',3),('9303','2013-10-08','11:35:00',1.71),('9303','2013-10-08','11:40:00',1.47),('9303','2013-10-08','11:45:00',1.36),('9303','2013-10-08','12:20:00',1.04),('9303','2013-10-08','12:25:00',1.39),('9303','2013-10-08','12:30:00',2.87),('9303','2013-10-08','12:35:00',1.87),('9303','2013-10-08','12:40:00',3.8),('9303','2013-10-08','12:45:00',3.54),('9303','2013-10-08','12:50:00',3.56),('9303','2013-10-08','12:55:00',3.73),('9303','2013-10-08','13:00:00',3.54),('9303','2013-10-08','13:05:00',3.16),('9303','2013-10-08','13:10:00',1.9),('9303','2013-10-08','13:15:00',3.53),('9303','2013-10-08','13:20:00',1.59),('9303','2013-10-08','13:25:00',2.71),('9303','2013-10-08','13:30:00',1.55),('9303','2013-10-08','13:35:00',1.17),('9303','2013-10-08','13:40:00',1.08),('9303','2013-10-08','14:05:00',1.38),('9303','2013-10-08','14:10:00',1.96),('9303','2013-10-08','14:15:00',2.13),('9303','2013-10-08','14:20:00',2.56),('9303','2013-10-08','14:25:00',2.59),('9303','2013-10-08','14:30:00',2.53),('9303','2013-10-08','14:35:00',1.12),('9303','2013-10-08','14:40:00',1.34),('9303','2013-10-08','14:45:00',2.85),('9303','2013-10-08','14:50:00',2.95),('9303','2013-10-08','14:55:00',2.95),('9303','2013-10-08','15:00:00',2.84),('9303','2013-10-08','15:05:00',2.72),('9303','2013-10-08','15:10:00',2.6),('9303','2013-10-08','15:15:00',2.82),('9303','2013-10-08','15:20:00',2.02),('9303','2013-10-08','15:25:00',2.97),('9303','2013-10-08','15:30:00',3.29),('9303','2013-10-08','15:35:00',2.94),('9303','2013-10-08','15:40:00',2.29),('9303','2013-10-08','15:45:00',1.47),('9303','2013-10-08','15:50:00',2.16),('9303','2013-10-08','15:55:00',1.38),('9303','2013-10-07','08:35:00',1.07),('9303','2013-10-07','08:40:00',1.3),('9303','2013-10-07','09:00:00',1.77),('9303','2013-10-07','09:05:00',1.72),('9303','2013-10-07','09:10:00',1.66),('9303','2013-10-07','09:15:00',1.72),('9303','2013-10-07','09:20:00',1.78),('9303','2013-10-07','09:25:00',1.84),('9303','2013-10-07','09:30:00',1.93),('9303','2013-10-07','09:35:00',1.98),('9303','2013-10-07','09:40:00',2.08),('9303','2013-10-07','09:45:00',2.14),('9303','2013-10-07','09:50:00',2.22),('9303','2013-10-07','09:55:00',2.27),('9303','2013-10-07','10:00:00',2.33),('9303','2013-10-07','10:05:00',2.39),('9303','2013-10-07','10:10:00',2.3),('9303','2013-10-07','10:15:00',2.19),('9303','2013-10-07','10:20:00',2.38),('9303','2013-10-07','10:25:00',2.5),('9303','2013-10-07','10:30:00',2.55),('9303','2013-10-07','10:35:00',2.68),('9303','2013-10-07','10:40:00',2.68),('9303','2013-10-07','10:45:00',2.74),('9303','2013-10-07','10:50:00',2.73),('9303','2013-10-07','10:55:00',2.21),('9303','2013-10-07','11:00:00',2.65),('9303','2013-10-07','11:05:00',2.84),('9303','2013-10-07','11:10:00',1.99),('9303','2013-10-07','11:15:00',2.07),('9303','2013-10-07','11:20:00',2.94),('9303','2013-10-07','11:25:00',3.06),('9303','2013-10-07','11:30:00',3.03),('9303','2013-10-07','11:35:00',3.07),('9303','2013-10-07','11:40:00',3.13),('9303','2013-10-07','11:45:00',3.11),('9303','2013-10-07','11:50:00',3.13),('9303','2013-10-07','11:55:00',3.2),('9303','2013-10-07','12:00:00',3.16),('9303','2013-10-07','12:05:00',3.23),('9303','2013-10-07','12:10:00',2.5),('9303','2013-10-07','12:15:00',2.44),('9303','2013-10-07','12:20:00',2.84),('9303','2013-10-07','12:25:00',3.27),('9303','2013-10-07','12:30:00',3.63),('9303','2013-10-07','12:35:00',3.42),('9303','2013-10-07','12:40:00',3.48),('9303','2013-10-07','12:45:00',3.51),('9303','2013-10-07','12:50:00',3.48),('9303','2013-10-07','12:55:00',3.66),('9303','2013-10-07','13:00:00',3.64),('9303','2013-10-07','13:05:00',3.57),('9303','2013-10-07','13:10:00',3.67),('9303','2013-10-07','13:15:00',2.06),('9303','2013-10-07','13:20:00',3.89),('9303','2013-10-07','13:25:00',3.37),('9303','2013-10-07','13:30:00',1.98),('9303','2013-10-07','13:35:00',1.34),('9303','2013-10-07','13:40:00',2.14),('9303','2013-10-07','13:45:00',2.03),('9303','2013-10-07','13:50:00',1.18),('9303','2013-10-07','13:55:00',3.92),('9303','2013-10-07','14:00:00',3.99),('9303','2013-10-07','14:05:00',2.27),('9303','2013-10-07','14:10:00',1.68),('9303','2013-10-07','14:20:00',1.03),('9303','2013-10-07','14:25:00',2.53),('9303','2013-10-07','14:35:00',3.22),('9303','2013-10-07','14:40:00',2.42),('9303','2013-10-07','14:45:00',3.48),('9303','2013-10-07','14:50:00',2.92),('9303','2013-10-07','14:55:00',3.47),('9303','2013-10-07','15:00:00',3.15),('9303','2013-10-07','15:05:00',1.75),('9303','2013-10-07','15:10:00',2.76),('9303','2013-10-07','15:15:00',1.36),('9303','2013-10-07','15:20:00',1.34),('9303','2013-10-07','15:25:00',2.31),('9303','2013-10-07','15:30:00',1.95),('9303','2013-10-07','15:35:00',1.78),('9303','2013-10-07','15:40:00',1.28),('9303','2013-10-07','15:45:00',2.91),('9303','2013-10-07','15:50:00',2.66),('9303','2013-10-07','15:55:00',1.37),('9303','2013-10-07','16:00:00',1.31),('9303','2013-10-07','16:05:00',1.67),('9303','2013-10-07','16:10:00',2.27),('9303','2013-10-07','16:15:00',2.1),('9303','2013-10-07','16:20:00',1.88),('9303','2013-10-07','16:25:00',1.13),('9303','2013-10-07','16:30:00',1.85),('9303','2013-10-07','16:35:00',1.27),('9303','2013-10-07','16:40:00',1.49),('9303','2013-10-07','16:45:00',1.53),('9303','2013-10-07','16:50:00',1.41),('9303','2013-10-07','16:55:00',1.29),('9303','2013-10-07','17:00:00',1.12),('9303','2013-10-06','09:05:00',1.02),('9303','2013-10-06','09:30:00',1.1),('9303','2013-10-06','09:35:00',1.52),('9303','2013-10-06','09:40:00',1.34),('9303','2013-10-06','09:45:00',1.1),('9303','2013-10-06','09:50:00',2.01),('9303','2013-10-06','09:55:00',2.36),('9303','2013-10-06','10:00:00',2.76),('9303','2013-10-06','10:05:00',2.8),('9303','2013-10-06','10:10:00',2.67),('9303','2013-10-06','10:15:00',2.45),('9303','2013-10-06','10:20:00',2.49),('9303','2013-10-06','10:25:00',2.77),('9303','2013-10-06','10:30:00',2.67),('9303','2013-10-06','10:35:00',2.66),('9303','2013-10-06','10:40:00',2.26),('9303','2013-10-06','10:45:00',1.84),('9303','2013-10-06','10:50:00',2.02),('9303','2013-10-06','10:55:00',2.19),('9303','2013-10-06','11:00:00',2.29),('9303','2013-10-06','11:05:00',2.54),('9303','2013-10-06','11:10:00',2.66),('9303','2013-10-06','11:15:00',2.64),('9303','2013-10-06','11:20:00',2.62),('9303','2013-10-06','11:25:00',2.75),('9303','2013-10-06','11:30:00',2.67),('9303','2013-10-06','11:35:00',2.61),('9303','2013-10-06','11:40:00',2.58),('9303','2013-10-06','11:45:00',2.05),('9303','2013-10-06','11:50:00',1.77),('9303','2013-10-06','11:55:00',2.43),('9303','2013-10-06','12:00:00',2.41),('9303','2013-10-06','12:05:00',2.49),('9303','2013-10-06','12:10:00',3.15),('9303','2013-10-06','12:15:00',2.98),('9303','2013-10-06','12:20:00',2.95),('9303','2013-10-06','12:25:00',2.52),('9303','2013-10-06','12:30:00',2.38),('9303','2013-10-06','12:35:00',2.49),('9303','2013-10-06','12:40:00',2.4),('9303','2013-10-06','12:45:00',2.4),('9303','2013-10-06','12:50:00',2.66),('9303','2013-10-06','12:55:00',3.06),('9303','2013-10-06','13:00:00',2.91),('9303','2013-10-06','13:05:00',2.87),('9303','2013-10-06','13:10:00',2.66),('9303','2013-10-06','13:15:00',3.39),('9303','2013-10-06','13:20:00',3.02),('9303','2013-10-06','13:45:00',1.05),('9303','2013-10-06','13:50:00',3.06),('9303','2013-10-06','13:55:00',2.6),('9303','2013-10-06','14:00:00',1.92),('9303','2013-10-06','14:05:00',2.57),('9303','2013-10-06','14:10:00',2.98),('9303','2013-10-06','14:15:00',1.93),('9303','2013-10-06','14:20:00',1.66),('9303','2013-10-06','14:25:00',1.57),('9303','2013-10-06','14:30:00',1.77),('9303','2013-10-06','14:35:00',1.47),('9303','2013-10-06','14:40:00',1.29),('9303','2013-10-06','14:45:00',1.57),('9303','2013-10-06','14:50:00',1.62),('9303','2013-10-06','14:55:00',2.18),('9303','2013-10-06','15:00:00',1.91),('9303','2013-10-06','15:05:00',1.45),('9303','2013-10-06','15:10:00',1.17),('9303','2013-10-06','15:15:00',1.06),('9303','2013-10-05','16:05:00',1.12),('9303','2013-10-05','16:10:00',1.12),('9303','2013-10-04','09:40:00',1.02),('9303','2013-10-04','09:45:00',1.03),('9303','2013-10-04','09:50:00',1.26),('9303','2013-10-04','09:55:00',2.62),('9303','2013-10-04','10:00:00',1.96),('9303','2013-10-04','10:05:00',1.41),('9303','2013-10-04','10:10:00',1.45),('9303','2013-10-04','10:15:00',1.76),('9303','2013-10-04','10:20:00',1.39),('9303','2013-10-04','10:25:00',1.94),('9303','2013-10-04','10:30:00',1.99),('9303','2013-10-04','10:35:00',1.6),('9303','2013-10-04','10:40:00',2.5),('9303','2013-10-04','10:45:00',1.99),('9303','2013-10-04','10:50:00',1.74),('9303','2013-10-04','10:55:00',2.71),('9303','2013-10-04','11:00:00',2.24),('9303','2013-10-04','11:05:00',1.6),('9303','2013-10-04','11:10:00',1.61),('9303','2013-10-04','11:15:00',2.88),('9303','2013-10-04','11:20:00',2.91),('9303','2013-10-04','11:25:00',2.89),('9303','2013-10-04','11:30:00',3.49),('9303','2013-10-04','11:35:00',3.35),('9303','2013-10-04','11:40:00',3.42),('9303','2013-10-04','11:45:00',3.35),('9303','2013-10-04','11:50:00',3.3),('9303','2013-10-04','11:55:00',3.31),('9303','2013-10-04','12:00:00',3.35),('9303','2013-10-04','12:05:00',3.35),('9303','2013-10-04','12:10:00',3.4),('9303','2013-10-04','12:15:00',3.16),('9303','2013-10-04','12:20:00',3.34),('9303','2013-10-04','12:25:00',3.46),('9303','2013-10-04','12:30:00',3.37),('9303','2013-10-04','12:35:00',3.02),('9303','2013-10-04','12:40:00',3.37),('9303','2013-10-04','12:45:00',3.43),('9303','2013-10-04','12:50:00',3.32),('9303','2013-10-04','12:55:00',3.34),('9303','2013-10-04','13:00:00',3.44),('9303','2013-10-04','13:05:00',3.5),('9303','2013-10-04','13:10:00',3.52),('9303','2013-10-04','13:15:00',3.73),('9303','2013-10-04','13:20:00',3.62),('9303','2013-10-04','13:25:00',3.38),('9303','2013-10-04','13:30:00',3.61),('9303','2013-10-04','13:35:00',2.95),('9303','2013-10-04','13:40:00',3.42),('9303','2013-10-04','13:45:00',3.36),('9303','2013-10-04','13:50:00',3.31),('9303','2013-10-04','13:55:00',3.32),('9303','2013-10-04','14:00:00',3.34),('9303','2013-10-04','14:05:00',3.25),('9303','2013-10-04','14:10:00',2.94),('9303','2013-10-04','14:15:00',2.64),('9303','2013-10-04','14:20:00',2.92),('9303','2013-10-04','14:25:00',3.13),('9303','2013-10-04','14:30:00',2.74),('9303','2013-10-04','14:35:00',1.91),('9303','2013-10-04','14:40:00',1.59),('9303','2013-10-04','14:45:00',1.76),('9303','2013-10-04','14:50:00',2.35),('9303','2013-10-04','14:55:00',2.41),('9303','2013-10-04','15:00:00',2.09),('9303','2013-10-04','15:05:00',2.3),('9303','2013-10-04','15:10:00',2),('9303','2013-10-04','15:15:00',1.55),('9303','2013-10-04','15:20:00',1.39),('9303','2013-10-04','15:25:00',1.99),('9303','2013-10-04','15:30:00',2.54),('9303','2013-10-04','15:35:00',1.41),('9303','2013-10-04','16:05:00',1.01),('9303','2013-10-03','08:30:00',1),('9303','2013-10-03','08:35:00',1.11),('9303','2013-10-03','08:40:00',1.2),('9303','2013-10-03','08:45:00',1.3),('9303','2013-10-03','08:50:00',1.41),('9303','2013-10-03','08:55:00',1.5),('9303','2013-10-03','09:00:00',1.62),('9303','2013-10-03','09:05:00',1.7),('9303','2013-10-03','09:10:00',1.8),('9303','2013-10-03','09:15:00',1.89),('9303','2013-10-03','09:20:00',1.98),('9303','2013-10-03','09:25:00',2.06),('9303','2013-10-03','09:30:00',2.14),('9303','2013-10-03','09:35:00',2.23),('9303','2013-10-03','09:40:00',2.31),('9303','2013-10-03','09:45:00',2.39),('9303','2013-10-03','09:50:00',2.46),('9303','2013-10-03','09:55:00',2.52),('9303','2013-10-03','10:00:00',2.6),('9303','2013-10-03','10:05:00',2.68),('9303','2013-10-03','10:10:00',2.74),('9303','2013-10-03','10:15:00',2.76),('9303','2013-10-03','10:20:00',2.81),('9303','2013-10-03','10:25:00',2.83),('9303','2013-10-03','10:30:00',2.88),('9303','2013-10-03','10:35:00',2.9),('9303','2013-10-03','10:40:00',2.99),('9303','2013-10-03','10:45:00',3.01),('9303','2013-10-03','10:50:00',3.08),('9303','2013-10-03','10:55:00',3.09),('9303','2013-10-03','11:00:00',3.16),('9303','2013-10-03','11:05:00',3.17),('9303','2013-10-03','11:10:00',3.24),('9303','2013-10-03','11:15:00',3.3),('9303','2013-10-03','11:20:00',3.33),('9303','2013-10-03','11:25:00',3.37),('9303','2013-10-03','11:30:00',3.4),('9303','2013-10-03','11:35:00',3.45),('9303','2013-10-03','11:40:00',3.47),('9303','2013-10-03','11:45:00',3.49),('9303','2013-10-03','11:50:00',3.53),('9303','2013-10-03','11:55:00',3.57),('9303','2013-10-03','12:00:00',3.61),('9303','2013-10-03','12:05:00',3.58),('9303','2013-10-03','12:10:00',3.62),('9303','2013-10-03','12:15:00',3.63),('9303','2013-10-03','12:20:00',3.6),('9303','2013-10-03','12:25:00',3.62),('9303','2013-10-03','12:30:00',3.66),('9303','2013-10-03','12:35:00',3.65),('9303','2013-10-03','12:40:00',3.67),('9303','2013-10-03','12:45:00',3.71),('9303','2013-10-03','12:50:00',3.71),('9303','2013-10-03','12:55:00',3.73),('9303','2013-10-03','13:00:00',3.76),('9303','2013-10-03','13:05:00',3.69),('9303','2013-10-03','13:10:00',3.73),('9303','2013-10-03','13:15:00',3.73),('9303','2013-10-03','13:20:00',3.72),('9303','2013-10-03','13:25:00',3.7),('9303','2013-10-03','13:30:00',3.71),('9303','2013-10-03','13:35:00',3.69),('9303','2013-10-03','13:40:00',3.66),('9303','2013-10-03','13:45:00',3.65),('9303','2013-10-03','13:50:00',3.63),('9303','2013-10-03','13:55:00',3.62),('9303','2013-10-03','14:00:00',3.61),('9303','2013-10-03','14:05:00',3.59),('9303','2013-10-03','14:10:00',3.55),('9303','2013-10-03','14:15:00',3.51),('9303','2013-10-03','14:20:00',3.48),('9303','2013-10-03','14:25:00',3.45),('9303','2013-10-03','14:30:00',3.41),('9303','2013-10-03','14:35:00',3.34),('9303','2013-10-03','14:40:00',3.29),('9303','2013-10-03','14:45:00',3.23),('9303','2013-10-03','14:50:00',3.19),('9303','2013-10-03','14:55:00',3.14),('9303','2013-10-03','15:00:00',3.08),('9303','2013-10-03','15:05:00',3.03),('9303','2013-10-03','15:10:00',2.97),('9303','2013-10-03','15:15:00',2.92),('9303','2013-10-03','15:20:00',2.9),('9303','2013-10-03','15:25:00',2.87),('9303','2013-10-03','15:30:00',2.79),('9303','2013-10-03','15:35:00',2.72),('9303','2013-10-03','15:40:00',2.65),('9303','2013-10-03','15:45:00',2.59),('9303','2013-10-03','15:50:00',2.51),('9303','2013-10-03','15:55:00',2.45),('9303','2013-10-03','16:00:00',2.39),('9303','2013-10-03','16:05:00',2.3),('9303','2013-10-03','16:10:00',2.19),('9303','2013-10-03','16:15:00',2.07),('9303','2013-10-03','16:20:00',1.97),('9303','2013-10-03','16:25:00',1.87),('9303','2013-10-03','16:30:00',1.81),('9303','2013-10-03','16:35:00',1.72),('9303','2013-10-03','16:40:00',1.62),('9303','2013-10-03','16:45:00',1.53),('9303','2013-10-03','16:50:00',1.45),('9303','2013-10-03','16:55:00',1.36),('9303','2013-10-03','17:00:00',1.27),('9303','2013-10-03','17:05:00',1.18),('9303','2013-10-03','17:10:00',1.09),('9303','2013-10-02','08:35:00',1.03),('9303','2013-10-02','08:40:00',1.1),('9303','2013-10-02','08:45:00',1.19),('9303','2013-10-02','08:50:00',1.31),('9303','2013-10-02','08:55:00',1.41),('9303','2013-10-02','09:00:00',1.52),('9303','2013-10-02','09:05:00',1.59),('9303','2013-10-02','09:10:00',1.69),('9303','2013-10-02','09:15:00',1.79),('9303','2013-10-02','09:20:00',1.87),('9303','2013-10-02','09:25:00',1.95),('9303','2013-10-02','09:30:00',2.03),('9303','2013-10-02','09:35:00',2.11),('9303','2013-10-02','09:40:00',2.18),('9303','2013-10-02','09:45:00',2.25),('9303','2013-10-02','09:50:00',2.31),('9303','2013-10-02','09:55:00',2.38),('9303','2013-10-02','10:00:00',2.39),('9303','2013-10-02','10:05:00',2.49),('9303','2013-10-02','10:10:00',2.55),('9303','2013-10-02','10:15:00',2.57),('9303','2013-10-02','10:20:00',2.63),('9303','2013-10-02','10:25:00',2.65),('9303','2013-10-02','10:30:00',2.68),('9303','2013-10-02','10:35:00',2.76),('9303','2013-10-02','10:40:00',2.85),('9303','2013-10-02','10:45:00',2.9),('9303','2013-10-02','10:50:00',2.96),('9303','2013-10-02','10:55:00',3.01),('9303','2013-10-02','11:00:00',3.05),('9303','2013-10-02','11:05:00',3.1),('9303','2013-10-02','11:10:00',3.14),('9303','2013-10-02','11:15:00',3.2),('9303','2013-10-02','11:20:00',3.21),('9303','2013-10-02','11:25:00',3.24),('9303','2013-10-02','11:30:00',3.3),('9303','2013-10-02','11:35:00',3.29),('9303','2013-10-02','11:40:00',3.35),('9303','2013-10-02','11:45:00',3.37),('9303','2013-10-02','11:50:00',3.38),('9303','2013-10-02','11:55:00',3.45),('9303','2013-10-02','12:00:00',3.44),('9303','2013-10-02','12:05:00',3.43),('9303','2013-10-02','12:10:00',3.48),('9303','2013-10-02','12:15:00',3.47),('9303','2013-10-02','12:20:00',3.48),('9303','2013-10-02','12:25:00',3.52),('9303','2013-10-02','12:30:00',3.5),('9303','2013-10-02','12:35:00',3.49),('9303','2013-10-02','12:40:00',3.55),('9303','2013-10-02','12:45:00',3.56),('9303','2013-10-02','12:50:00',3.58),('9303','2013-10-02','12:55:00',3.63),('9303','2013-10-02','13:00:00',3.64),('9303','2013-10-02','13:05:00',3.64),('9303','2013-10-02','13:10:00',3.63),('9303','2013-10-02','13:15:00',3.63),('9303','2013-10-02','13:20:00',3.62),('9303','2013-10-02','13:25:00',3.63),('9303','2013-10-02','13:30:00',3.61),('9303','2013-10-02','13:35:00',3.6),('9303','2013-10-02','13:40:00',3.58),('9303','2013-10-02','13:45:00',3.54),('9303','2013-10-02','13:50:00',3.53),('9303','2013-10-02','13:55:00',3.49),('9303','2013-10-02','14:00:00',3.48),('9303','2013-10-02','14:05:00',3.45),('9303','2013-10-02','14:10:00',3.43),('9303','2013-10-02','14:15:00',3.41),('9303','2013-10-02','14:20:00',3.36),('9303','2013-10-02','14:25:00',3.35),('9303','2013-10-02','14:30:00',3.31),('9303','2013-10-02','14:35:00',3.27),('9303','2013-10-02','14:40:00',3.24),('9303','2013-10-02','14:45:00',3.2),('9303','2013-10-02','14:50:00',3.16),('9303','2013-10-02','14:55:00',3.13),('9303','2013-10-02','15:00:00',3.06),('9303','2013-10-02','15:05:00',2.98),('9303','2013-10-02','15:10:00',2.92),('9303','2013-10-02','15:15:00',2.89),('9303','2013-10-02','15:20:00',2.86),('9303','2013-10-02','15:25:00',2.78),('9303','2013-10-02','15:30:00',2.72),('9303','2013-10-02','15:35:00',2.67),('9303','2013-10-02','15:40:00',2.62),('9303','2013-10-02','15:45:00',2.55),('9303','2013-10-02','15:50:00',2.48),('9303','2013-10-02','15:55:00',2.39),('9303','2013-10-02','16:00:00',2.33),('9303','2013-10-02','16:05:00',2.26),('9303','2013-10-02','16:10:00',2.15),('9303','2013-10-02','16:15:00',2.03),('9303','2013-10-02','16:20:00',1.92),('9303','2013-10-02','16:25:00',1.83),('9303','2013-10-02','16:30:00',1.77),('9303','2013-10-02','16:35:00',1.69),('9303','2013-10-02','16:40:00',1.59),('9303','2013-10-02','16:45:00',1.49),('9303','2013-10-02','16:50:00',1.41),('9303','2013-10-02','16:55:00',1.33),('9303','2013-10-02','17:00:00',1.24),('9303','2013-10-02','17:05:00',1.16),('9303','2013-10-02','17:10:00',1.06),('9303','2013-10-01','08:40:00',1.1),('9303','2013-10-01','08:45:00',1.27),('9303','2013-10-01','08:50:00',1.37),('9303','2013-10-01','08:55:00',1.45),('9303','2013-10-01','09:00:00',1.55),('9303','2013-10-01','09:05:00',1.63),('9303','2013-10-01','09:10:00',1.71),('9303','2013-10-01','09:15:00',1.78),('9303','2013-10-01','09:20:00',1.86),('9303','2013-10-01','09:25:00',1.92),('9303','2013-10-01','09:30:00',2),('9303','2013-10-01','09:35:00',2.06),('9303','2013-10-01','09:40:00',2.13),('9303','2013-10-01','09:45:00',2.19),('9303','2013-10-01','09:50:00',2.25),('9303','2013-10-01','09:55:00',2.32),('9303','2013-10-01','10:00:00',2.4),('9303','2013-10-01','10:05:00',2.46),('9303','2013-10-01','10:10:00',2.52),('9303','2013-10-01','10:15:00',2.57),('9303','2013-10-01','10:20:00',2.62),('9303','2013-10-01','10:25:00',2.65),('9303','2013-10-01','10:30:00',2.69),('9303','2013-10-01','10:35:00',2.73),('9303','2013-10-01','10:40:00',2.82),('9303','2013-10-01','10:45:00',2.8),('9303','2013-10-01','10:50:00',2.87),('9303','2013-10-01','10:55:00',2.89),('9303','2013-10-01','11:00:00',3.02),('9303','2013-10-01','11:05:00',3.2),('9303','2013-10-01','11:10:00',2.26),('9303','2013-10-01','11:15:00',1.56),('9303','2013-10-01','11:20:00',2.64),('9303','2013-10-01','11:25:00',3.47),('9303','2013-10-01','11:30:00',2.55),('9303','2013-10-01','11:35:00',1.24),('9303','2013-10-01','11:40:00',3.63),('9303','2013-10-01','11:45:00',3.64),('9303','2013-10-01','11:50:00',3.6),('9303','2013-10-01','11:55:00',3.63),('9303','2013-10-01','12:00:00',3.54),('9303','2013-10-01','12:05:00',2.73),('9303','2013-10-01','12:10:00',3.46),('9303','2013-10-01','12:15:00',3.62),('9303','2013-10-01','12:20:00',3.72),('9303','2013-10-01','12:25:00',3.73),('9303','2013-10-01','12:30:00',3.82),('9303','2013-10-01','12:35:00',3.72),('9303','2013-10-01','12:40:00',1.36),('9303','2013-10-01','12:45:00',3.89),('9303','2013-10-01','12:50:00',3.65),('9303','2013-10-01','12:55:00',3.65),('9303','2013-10-01','13:00:00',3.68),('9303','2013-10-01','13:05:00',3.37),('9303','2013-10-01','13:15:00',2.49),('9303','2013-10-01','13:20:00',3.92),('9303','2013-10-01','13:25:00',3.94),('9303','2013-10-01','13:30:00',3.99),('9303','2013-10-01','13:35:00',2.97),('9303','2013-10-01','13:40:00',2.18),('9303','2013-10-01','13:45:00',3.21),('9303','2013-10-01','13:55:00',2.46),('9303','2013-10-01','14:00:00',3.49),('9303','2013-10-01','14:05:00',3.41),('9303','2013-10-01','14:10:00',3.35),('9303','2013-10-01','14:15:00',3.33),('9303','2013-10-01','14:20:00',3.33),('9303','2013-10-01','14:25:00',3.27),('9303','2013-10-01','14:30:00',3.23),('9303','2013-10-01','14:35:00',3.18),('9303','2013-10-01','14:40:00',3.21),('9303','2013-10-01','14:45:00',3.22),('9303','2013-10-01','14:50:00',3.22),('9303','2013-10-01','14:55:00',3.17),('9303','2013-10-01','15:00:00',3.15),('9303','2013-10-01','15:05:00',2.99),('9303','2013-10-01','15:10:00',2.91),('9303','2013-10-01','15:15:00',2.87),('9303','2013-10-01','15:20:00',2.83),('9303','2013-10-01','15:25:00',2.77),('9303','2013-10-01','15:30:00',2.72),('9303','2013-10-01','15:35:00',2.65),('9303','2013-10-01','15:40:00',2.59),('9303','2013-10-01','15:45:00',2.52),('9303','2013-10-01','15:50:00',2.46),('9303','2013-10-01','15:55:00',2.39),('9303','2013-10-01','16:00:00',2.32),('9303','2013-10-01','16:05:00',2.26),('9303','2013-10-01','16:10:00',2.15),('9303','2013-10-01','16:15:00',2.04),('9303','2013-10-01','16:20:00',1.94),('9303','2013-10-01','16:25:00',1.85),('9303','2013-10-01','16:30:00',1.76),('9303','2013-10-01','16:35:00',1.68),('9303','2013-10-01','16:40:00',1.59),('9303','2013-10-01','16:45:00',1.49),('9303','2013-10-01','16:50:00',1.41),('9303','2013-10-01','16:55:00',1.34),('9303','2013-10-01','17:00:00',1.26),('9303','2013-10-01','17:05:00',1.17),('9303','2013-10-01','17:10:00',1.08),('9303','2013-09-30','09:50:00',1.21),('9303','2013-09-30','09:55:00',1.01),('9303','2013-09-30','10:25:00',1.19),('9303','2013-09-30','10:30:00',1.39),('9303','2013-09-30','10:35:00',1.59),('9303','2013-09-30','10:40:00',2.02),('9303','2013-09-30','10:45:00',3.03),('9303','2013-09-30','10:50:00',3.15),('9303','2013-09-30','10:55:00',2.9),('9303','2013-09-30','11:00:00',2.49),('9303','2013-09-30','11:05:00',3.02),('9303','2013-09-30','11:10:00',3.07),('9303','2013-09-30','11:15:00',2.52),('9303','2013-09-30','11:20:00',2.92),('9303','2013-09-30','11:25:00',2.34),('9303','2013-09-30','11:30:00',1.91),('9303','2013-09-30','11:35:00',1.49),('9303','2013-09-30','11:40:00',3.57),('9303','2013-09-30','11:45:00',1.85),('9303','2013-09-30','11:50:00',1.65),('9303','2013-09-30','11:55:00',1.23),('9303','2013-09-30','12:00:00',1.86),('9303','2013-09-30','12:05:00',2.88),('9303','2013-09-30','12:10:00',2.72),('9303','2013-09-30','12:15:00',3.77),('9303','2013-09-30','12:20:00',3.9),('9303','2013-09-30','12:25:00',3.85),('9303','2013-09-30','12:30:00',3.66),('9303','2013-09-30','12:35:00',3.61),('9303','2013-09-30','12:40:00',3.43),('9303','2013-09-30','12:45:00',3.06),('9303','2013-09-30','12:50:00',3.79),('9303','2013-09-30','12:55:00',3.76),('9303','2013-09-30','13:00:00',3.43),('9303','2013-09-30','13:05:00',3.57),('9303','2013-09-30','13:10:00',3.84),('9303','2013-09-30','13:15:00',3.36),('9303','2013-09-30','13:20:00',4.2),('9303','2013-09-30','13:25:00',4.32),('9303','2013-09-30','13:30:00',4.18),('9303','2013-09-30','13:35:00',3.29),('9303','2013-09-30','13:40:00',2.53),('9303','2013-09-30','13:45:00',1.34),('9303','2013-09-30','13:50:00',3.22),('9303','2013-09-30','13:55:00',2.18),('9303','2013-09-30','14:00:00',1.28),('9303','2013-09-30','14:05:00',1.22),('9303','2013-09-30','14:10:00',1.22),('9303','2013-09-30','14:15:00',1.14),('9303','2013-09-30','14:25:00',1.07),('9303','2013-09-30','14:30:00',2.32),('9303','2013-09-30','14:35:00',2.75),('9303','2013-09-30','14:40:00',3.64),('9303','2013-09-30','14:45:00',2.58),('9303','2013-09-30','14:50:00',3.52),('9303','2013-09-30','14:55:00',1.65),('9303','2013-09-30','15:00:00',2.89),('9303','2013-09-30','15:05:00',2.48),('9303','2013-09-30','15:10:00',2.82),('9303','2013-09-30','15:15:00',1.52),('9303','2013-09-30','15:20:00',1.3),('9303','2013-09-30','15:25:00',3.04),('9303','2013-09-30','15:30:00',1.82),('9303','2013-09-30','15:35:00',2.23),('9303','2013-09-30','15:40:00',3.14),('9303','2013-09-30','15:45:00',1.66),('9303','2013-09-30','16:10:00',1.47),('9303','2013-09-30','16:15:00',1.75),('9303','2013-09-30','16:20:00',1.13),('9303','2013-09-29','08:50:00',1.11),('9303','2013-09-29','08:55:00',1.02),('9303','2013-09-29','09:15:00',1.18),('9303','2013-09-29','10:00:00',1.19),('9303','2013-09-29','10:05:00',1.62),('9303','2013-09-29','10:10:00',1.86),('9303','2013-09-29','10:15:00',2.36),('9303','2013-09-29','10:20:00',1.98),('9303','2013-09-29','10:25:00',1.86),('9303','2013-09-29','10:30:00',2.22),('9303','2013-09-29','10:35:00',2.41),('9303','2013-09-29','10:40:00',2.64),('9303','2013-09-29','10:45:00',2.53),('9303','2013-09-29','10:50:00',2.66),('9303','2013-09-29','10:55:00',2.67),('9303','2013-09-29','11:00:00',2.71),('9303','2013-09-29','11:05:00',2.59),('9303','2013-09-29','11:10:00',2.59),('9303','2013-09-29','11:15:00',2.82),('9303','2013-09-29','11:20:00',2.82),('9303','2013-09-29','11:25:00',2.66),('9303','2013-09-29','11:30:00',2.84),('9303','2013-09-29','11:35:00',2.87),('9303','2013-09-29','11:40:00',2.96),('9303','2013-09-29','11:45:00',2.95),('9303','2013-09-29','11:50:00',3.15),('9303','2013-09-29','11:55:00',3.1),('9303','2013-09-29','12:00:00',2.84),('9303','2013-09-29','12:05:00',3.14),('9303','2013-09-29','12:10:00',3.18),('9303','2013-09-29','12:15:00',3.53),('9303','2013-09-29','12:20:00',2.54),('9303','2013-09-29','12:25:00',1.85),('9303','2013-09-29','12:30:00',1.86),('9303','2013-09-29','12:35:00',1.76),('9303','2013-09-29','12:40:00',1.5),('9303','2013-09-29','12:45:00',1.31),('9303','2013-09-29','12:50:00',1.31),('9303','2013-09-29','12:55:00',1.14),('9303','2013-09-29','13:00:00',1.11),('9303','2013-09-29','13:25:00',1.22),('9303','2013-09-29','13:30:00',1.84),('9303','2013-09-29','13:35:00',1.61),('9303','2013-09-29','13:40:00',1.52),('9303','2013-09-29','13:45:00',1.41),('9303','2013-09-29','13:50:00',1.5),('9303','2013-09-29','13:55:00',2.05),('9303','2013-09-29','14:00:00',1.86),('9303','2013-09-29','14:05:00',2.34),('9303','2013-09-29','14:10:00',1.38),('9303','2013-09-29','14:15:00',1.59),('9303','2013-09-29','14:20:00',2.17),('9303','2013-09-29','14:25:00',1.24),('9303','2013-09-29','14:30:00',1.05),('9303','2013-09-29','14:35:00',1.05),('9303','2013-09-29','15:00:00',1.22),('9303','2014-04-14','08:10:00',1.08),('9303','2014-04-14','08:15:00',1.17),('9303','2014-04-14','08:20:00',1.26),('9303','2014-04-14','08:25:00',1.37),('9303','2014-04-14','08:30:00',1.5),('9303','2014-04-14','08:35:00',1.57),('9303','2014-04-14','08:40:00',1.67),('9303','2014-04-14','08:45:00',1.78),('9303','2014-04-14','08:50:00',1.87),('9303','2014-04-14','08:55:00',1.97),('9303','2014-04-14','09:00:00',2.06),('9303','2014-04-14','09:05:00',2.15),('9303','2014-04-14','09:10:00',2.22),('9303','2014-04-14','09:15:00',2.28),('9303','2014-04-14','09:20:00',2.37),('9303','2014-04-14','09:25:00',2.45),('9303','2014-04-14','09:30:00',2.52),('9303','2014-04-14','09:35:00',2.59),('9303','2014-04-14','09:40:00',2.64),('9303','2014-04-14','09:45:00',2.73),('9303','2014-04-14','09:50:00',2.82),('9303','2014-04-14','09:55:00',2.89),('9303','2014-04-14','10:00:00',2.96),('9303','2014-04-14','10:05:00',3.03),('9303','2014-04-14','10:10:00',3.11),('9303','2014-04-14','10:15:00',3.16),('9303','2014-04-14','10:20:00',3.24),('9303','2014-04-14','10:25:00',3.3),('9303','2014-04-14','10:30:00',3.36),('9303','2014-04-14','10:35:00',3.39),('9303','2014-04-14','10:40:00',3.45),('9303','2014-04-14','10:45:00',3.5),('9303','2014-04-14','10:50:00',3.56),('9303','2014-04-14','10:55:00',3.62),('9303','2014-04-14','11:00:00',3.64),('9303','2014-04-14','11:05:00',3.66),('9303','2014-04-14','11:10:00',3.73),('9303','2014-04-14','11:15:00',3.77),('9303','2014-04-14','11:20:00',3.77),('9303','2014-04-14','11:25:00',3.79),('9303','2014-04-14','11:30:00',3.84),('9303','2014-04-14','11:35:00',3.87),('9303','2014-04-14','11:40:00',3.88),('9303','2014-04-14','11:45:00',3.9),('9303','2014-04-14','11:50:00',3.94),('9303','2014-04-14','11:55:00',3.97),('9303','2014-04-14','12:00:00',3.97),('9303','2014-04-14','12:05:00',4.02),('9303','2014-04-14','12:10:00',4.07),('9303','2014-04-14','12:15:00',4.13),('9303','2014-04-14','12:20:00',4.13),('9303','2014-04-14','12:25:00',4.17),('9303','2014-04-14','12:30:00',4.18),('9303','2014-04-14','12:35:00',4.15),('9303','2014-04-14','12:40:00',4.18),('9303','2014-04-14','12:45:00',4.17),('9303','2014-04-14','12:50:00',4.16),('9303','2014-04-14','12:55:00',4.16),('9303','2014-04-14','13:00:00',4.17),('9303','2014-04-14','13:05:00',4.21),('9303','2014-04-14','13:10:00',4.21),('9303','2014-04-14','13:15:00',4.15),('9303','2014-04-14','13:20:00',4.21),('9303','2014-04-14','13:25:00',4.2),('9303','2014-04-14','13:30:00',4.2),('9303','2014-04-14','13:35:00',4.2),('9303','2014-04-14','13:40:00',4.19),('9303','2014-04-14','13:45:00',4.18),('9303','2014-04-14','13:50:00',4.16),('9303','2014-04-14','13:55:00',4.18),('9303','2014-04-14','14:00:00',4.18),('9303','2014-04-14','14:05:00',4.14),('9303','2014-04-14','14:10:00',4.15),('9303','2014-04-14','14:15:00',4.14),('9303','2014-04-14','14:20:00',4.09),('9303','2014-04-14','14:25:00',4.08),('9303','2014-04-14','14:30:00',4.05),('9303','2014-04-14','14:35:00',4.02),('9303','2014-04-14','14:40:00',3.99),('9303','2014-04-14','14:45:00',3.93),('9303','2014-04-14','14:50:00',3.89),('9303','2014-04-14','14:55:00',3.85),('9303','2014-04-14','15:00:00',3.81),('9303','2014-04-14','15:05:00',3.79),('9303','2014-04-14','15:10:00',3.73),('9303','2014-04-14','15:15:00',3.71),('9303','2014-04-14','15:20:00',3.64),('9303','2014-04-14','15:25:00',3.59),('9303','2014-04-14','15:30:00',3.56),('9303','2014-04-14','15:35:00',3.5),('9303','2014-04-14','15:40:00',3.45),('9303','2014-04-14','15:45:00',3.38),('9303','2014-04-14','15:50:00',3.32),('9303','2014-04-14','15:55:00',3.24),('9303','2014-04-14','16:00:00',3.18),('9303','2014-04-14','16:05:00',3.14),('9303','2014-04-14','16:10:00',3.06),('9303','2014-04-14','16:15:00',3),('9303','2014-04-14','16:20:00',2.92),('9303','2014-04-14','16:25:00',2.84),('9303','2014-04-14','16:30:00',2.76),('9303','2014-04-14','16:35:00',2.7),('9303','2014-04-14','16:40:00',2.63),('9303','2014-04-14','16:45:00',2.53),('9303','2014-04-14','16:50:00',2.39),('9303','2014-04-14','16:55:00',2.28),('9303','2014-04-14','17:00:00',2.19),('9303','2014-04-14','17:05:00',2.11),('9303','2014-04-14','17:10:00',2.02),('9303','2014-04-14','17:15:00',1.93),('9303','2014-04-14','17:20:00',1.85),('9303','2014-04-14','17:25:00',1.77),('9303','2014-04-14','17:30:00',1.67),('9303','2014-04-14','17:35:00',1.52),('9303','2014-04-14','17:40:00',1.46),('9303','2014-04-14','17:45:00',1.38),('9303','2014-04-14','17:50:00',1.24),('9303','2014-04-14','17:55:00',1.15),('9303','2014-04-14','18:00:00',1.04),('9303','2013-09-28','08:35:00',1),('9303','2013-09-28','08:40:00',1.07),('9303','2013-09-28','08:45:00',1.17),('9303','2013-09-28','08:50:00',1.23),('9303','2013-09-28','08:55:00',1.32),('9303','2013-09-28','09:00:00',1.39),('9303','2013-09-28','09:05:00',1.48),('9303','2013-09-28','09:10:00',1.59),('9303','2013-09-28','09:15:00',1.68),('9303','2013-09-28','09:20:00',1.74),('9303','2013-09-28','09:25:00',1.82),('9303','2013-09-28','09:30:00',1.92),('9303','2013-09-28','09:35:00',1.98),('9303','2013-09-28','09:40:00',2.04),('9303','2013-09-28','09:45:00',2.14),('9303','2013-09-28','09:50:00',2.25),('9303','2013-09-28','09:55:00',2.08),('9303','2013-09-28','10:00:00',1.66),('9303','2013-09-28','10:05:00',1.21),('9303','2013-09-28','10:15:00',1.27),('9303','2013-09-28','10:25:00',1.11),('9303','2013-09-28','10:30:00',1.63),('9303','2013-09-28','10:35:00',2.27),('9303','2013-09-28','10:40:00',1.99),('9303','2013-09-28','10:45:00',1.98),('9303','2013-09-28','10:50:00',3.19),('9303','2013-09-28','10:55:00',2.93),('9303','2013-09-28','11:15:00',1.36),('9303','2013-09-28','11:20:00',3.31),('9303','2013-09-28','11:25:00',3.61),('9303','2013-09-28','11:30:00',3.52),('9303','2013-09-28','11:35:00',2.31),('9303','2013-09-28','11:40:00',1.9),('9303','2013-09-28','11:50:00',1.37),('9303','2013-09-28','11:55:00',1.24),('9303','2013-09-28','12:00:00',1.98),('9303','2013-09-28','12:05:00',3.71),('9303','2013-09-28','12:10:00',3.59),('9303','2013-09-28','12:15:00',3.47),('9303','2013-09-28','12:20:00',2.88),('9303','2013-09-28','12:25:00',2.47),('9303','2013-09-28','12:30:00',2.3),('9303','2013-09-28','12:35:00',2.07),('9303','2013-09-28','12:40:00',2.68),('9303','2013-09-28','12:45:00',2.64),('9303','2013-09-28','12:50:00',3.02),('9303','2013-09-28','12:55:00',2.79),('9303','2013-09-28','13:00:00',3.96),('9303','2013-09-28','13:05:00',2.95),('9303','2013-09-28','13:10:00',1.01),('9303','2013-09-28','13:15:00',1.2),('9303','2013-09-28','13:20:00',1.33),('9303','2013-09-28','13:25:00',1.56),('9303','2013-09-28','13:30:00',3.83),('9303','2013-09-28','13:35:00',1.41),('9303','2013-09-28','13:40:00',1.32),('9303','2013-09-28','13:45:00',1.5),('9303','2013-09-28','13:50:00',1.52),('9303','2013-09-28','13:55:00',1.32),('9303','2013-09-28','14:00:00',1.31),('9303','2013-09-28','14:05:00',1.26),('9303','2013-09-28','14:10:00',1.54),('9303','2013-09-28','14:15:00',1.96),('9303','2013-09-28','14:20:00',1.89),('9303','2013-09-28','14:25:00',3.79),('9303','2013-09-28','14:30:00',2.69),('9303','2013-09-28','14:35:00',3.05),('9303','2013-09-28','14:40:00',3.63),('9303','2013-09-28','14:45:00',3.5),('9303','2013-09-28','14:50:00',2.47),('9303','2013-09-28','14:55:00',1.85),('9303','2013-09-28','15:00:00',3.32),('9303','2013-09-28','15:05:00',2.81),('9303','2013-09-28','15:10:00',2.65),('9303','2013-09-28','15:15:00',3.06),('9303','2013-09-28','15:20:00',3.11),('9303','2013-09-28','15:25:00',3.06),('9303','2013-09-28','15:30:00',3),('9303','2013-09-28','15:35:00',2.77),('9303','2013-09-28','15:40:00',2.73),('9303','2013-09-28','15:45:00',2.32),('9303','2013-09-28','15:50:00',2.19),('9303','2013-09-28','15:55:00',1.66),('9303','2013-09-28','16:00:00',2.44),('9303','2013-09-28','16:05:00',2.43),('9303','2013-09-28','16:10:00',2.43),('9303','2013-09-28','16:15:00',2.16),('9303','2013-09-28','16:20:00',1.17),('9303','2013-09-28','16:25:00',1.78),('9303','2013-09-28','16:30:00',1.69),('9303','2013-09-28','16:35:00',1.66),('9303','2013-09-28','16:40:00',1.58),('9303','2013-09-28','16:45:00',1.47),('9303','2013-09-28','16:50:00',1.4),('9303','2013-09-28','16:55:00',1.33),('9303','2013-09-28','17:00:00',1.23),('9303','2013-09-28','17:05:00',1.16),('9303','2013-09-28','17:10:00',1.07),('9303','2013-09-27','08:35:00',1.08),('9303','2013-09-27','08:40:00',1.11),('9303','2013-09-27','08:45:00',1.2),('9303','2013-09-27','08:50:00',1.18),('9303','2013-09-27','08:55:00',1.52),('9303','2013-09-27','09:00:00',1.16),('9303','2013-09-27','09:15:00',1.1),('9303','2013-09-27','09:50:00',1.08),('9303','2013-09-27','09:55:00',1.36),('9303','2013-09-27','10:00:00',1.46),('9303','2013-09-27','10:05:00',2.21),('9303','2013-09-27','10:10:00',1.85),('9303','2013-09-27','10:15:00',1.37),('9303','2013-09-27','10:20:00',2.22),('9303','2013-09-27','10:25:00',1.75),('9303','2013-09-27','10:30:00',1.74),('9303','2013-09-27','10:35:00',1.16),('9303','2013-09-27','10:45:00',1.71),('9303','2013-09-27','10:50:00',2.48),('9303','2013-09-27','10:55:00',2.83),('9303','2013-09-27','11:00:00',2.95),('9303','2013-09-27','11:05:00',2.87),('9303','2013-09-27','11:10:00',2.31),('9303','2013-09-27','11:15:00',3.04),('9303','2013-09-27','11:20:00',3.19),('9303','2013-09-27','11:25:00',2.87),('9303','2013-09-27','11:30:00',2.83),('9303','2013-09-27','11:35:00',1.2),('9303','2013-09-27','11:45:00',1.82),('9303','2013-09-27','11:50:00',1.13),('9303','2013-09-27','11:55:00',1.51),('9303','2013-09-27','12:00:00',2.89),('9303','2013-09-27','12:05:00',1.8),('9303','2013-09-27','12:10:00',2.92),('9303','2013-09-27','12:15:00',2.17),('9303','2013-09-27','12:45:00',2.94),('9303','2013-09-27','12:50:00',3.34),('9303','2013-09-27','12:55:00',3.48),('9303','2013-09-27','13:00:00',3.44),('9303','2013-09-27','13:05:00',3.35),('9303','2013-09-27','13:10:00',3.14),('9303','2013-09-27','13:15:00',1.56),('9303','2013-09-27','13:20:00',3.44),('9303','2013-09-27','13:25:00',2.35),('9303','2013-09-27','13:40:00',1.72),('9303','2013-09-27','13:45:00',2.9),('9303','2013-09-27','13:50:00',1.34),('9303','2013-09-27','13:55:00',1.05),('9303','2013-09-27','14:00:00',1.44),('9303','2013-09-27','14:05:00',3.74),('9303','2013-09-27','14:10:00',2.81),('9303','2013-09-27','14:15:00',2.85),('9303','2013-09-27','14:20:00',3.5),('9303','2013-09-27','14:25:00',3.38),('9303','2013-09-27','14:30:00',3.25),('9303','2013-09-27','14:35:00',3.23),('9303','2013-09-27','14:40:00',3.25),('9303','2013-09-27','14:45:00',3.11),('9303','2013-09-27','14:50:00',2.82),('9303','2013-09-27','14:55:00',3),('9303','2013-09-27','15:00:00',2.33),('9303','2013-09-27','15:05:00',2.02),('9303','2013-09-27','15:10:00',2.25),('9303','2013-09-27','15:15:00',2.92),('9303','2013-09-27','15:20:00',1.59),('9303','2013-09-27','15:25:00',2.39),('9303','2013-09-27','15:30:00',2.84),('9303','2013-09-27','15:35:00',2.38),('9303','2013-09-27','15:40:00',2.61),('9303','2013-09-27','15:45:00',1.23),('9303','2013-09-27','15:50:00',2.23),('9303','2013-09-27','15:55:00',2.47),('9303','2013-09-27','16:00:00',1.68),('9303','2013-09-27','16:05:00',1.8),('9303','2013-09-27','16:15:00',1.53),('9303','2013-09-27','16:20:00',2.01),('9303','2013-09-27','16:25:00',1.89),('9303','2013-09-27','16:30:00',1.54),('9303','2013-09-27','16:35:00',1.71),('9303','2013-09-27','16:40:00',1.6),('9303','2013-09-27','16:45:00',1.55),('9303','2013-09-27','16:50:00',1.44),('9303','2013-09-27','16:55:00',1.17),('9303','2013-09-27','17:10:00',1.12),('9303','2013-09-27','17:15:00',1.18),('9303','2013-09-27','17:20:00',1.02),('9303','2013-09-26','08:40:00',1.14),('9303','2013-09-26','08:45:00',1.27),('9303','2013-09-26','08:50:00',1.36),('9303','2013-09-26','08:55:00',1.47),('9303','2013-09-26','09:00:00',1.57),('9303','2013-09-26','09:05:00',1.65),('9303','2013-09-26','09:10:00',1.73),('9303','2013-09-26','09:15:00',1.81),('9303','2013-09-26','09:20:00',1.88),('9303','2013-09-26','09:25:00',1.96),('9303','2013-09-26','09:30:00',2.02),('9303','2013-09-26','09:35:00',2.09),('9303','2013-09-26','09:40:00',2.16),('9303','2013-09-26','09:45:00',2.23),('9303','2013-09-26','09:50:00',2.28),('9303','2013-09-26','09:55:00',2.33),('9303','2013-09-26','10:00:00',2.4),('9303','2013-09-26','10:05:00',2.48),('9303','2013-09-26','10:10:00',2.51),('9303','2013-09-26','10:15:00',2.54),('9303','2013-09-26','10:20:00',2.55),('9303','2013-09-26','10:25:00',2.63),('9303','2013-09-26','10:30:00',2.71),('9303','2013-09-26','10:35:00',2.76),('9303','2013-09-26','10:40:00',2.72),('9303','2013-09-26','10:45:00',2.6),('9303','2013-09-26','10:50:00',2.9),('9303','2013-09-26','10:55:00',2.95),('9303','2013-09-26','11:00:00',2.93),('9303','2013-09-26','11:05:00',2.91),('9303','2013-09-26','11:10:00',3.01),('9303','2013-09-26','11:15:00',3),('9303','2013-09-26','11:20:00',3.08),('9303','2013-09-26','11:25:00',3.19),('9303','2013-09-26','11:30:00',3.16),('9303','2013-09-26','11:35:00',2.98),('9303','2013-09-26','11:40:00',1.64),('9303','2013-09-26','11:45:00',3.11),('9303','2013-09-26','11:50:00',3.37),('9303','2013-09-26','11:55:00',1.5),('9303','2013-09-26','12:00:00',3.07),('9303','2013-09-26','12:05:00',2.47),('9303','2013-09-26','12:15:00',1.18),('9303','2013-09-26','12:20:00',1.73),('9303','2013-09-26','12:25:00',1.18),('9303','2013-09-26','12:30:00',1.34),('9303','2013-09-26','12:35:00',1.37),('9303','2013-09-26','12:40:00',1.5),('9303','2013-09-26','12:45:00',1.59),('9303','2013-09-26','12:50:00',1.49),('9303','2013-09-26','12:55:00',2.45),('9303','2013-09-26','13:00:00',3.23),('9303','2013-09-26','13:05:00',2.2),('9303','2013-09-26','13:10:00',1.55),('9303','2013-09-26','13:15:00',3.24),('9303','2013-09-26','13:20:00',3.9),('9303','2013-09-26','13:25:00',2.92),('9303','2013-09-26','13:30:00',1.99),('9303','2013-09-26','13:35:00',2.2),('9303','2013-09-26','13:40:00',1.86),('9303','2013-09-26','13:45:00',1.25),('9303','2013-09-26','13:50:00',1.25),('9303','2013-09-26','13:55:00',1.78),('9303','2013-09-26','14:00:00',2.39),('9303','2013-09-26','14:05:00',2.49),('9303','2013-09-26','14:10:00',3.71),('9303','2013-09-26','14:15:00',3.42),('9303','2013-09-26','14:20:00',3.49),('9303','2013-09-26','14:25:00',1.4),('9303','2013-09-26','14:30:00',1.6),('9303','2013-09-26','14:35:00',1.82),('9303','2013-09-26','14:40:00',1.75),('9303','2013-09-26','14:45:00',3.29),('9303','2013-09-26','14:50:00',3.61),('9303','2013-09-26','14:55:00',1.65),('9303','2013-09-26','15:00:00',1.06),('9303','2013-09-26','15:05:00',1.36),('9303','2013-09-26','15:10:00',1.28),('9303','2013-09-26','15:20:00',1.52),('9303','2013-09-26','15:25:00',2.35),('9303','2013-09-26','15:35:00',1.73),('9303','2013-09-26','15:45:00',2.54),('9303','2013-09-26','15:50:00',2.71),('9303','2013-09-26','15:55:00',2.46),('9303','2013-09-26','16:00:00',2.39),('9303','2013-09-26','16:05:00',2.27),('9303','2013-09-26','16:10:00',2.25),('9303','2013-09-26','16:15:00',2.1),('9303','2013-09-26','16:20:00',2.02),('9303','2013-09-26','16:25:00',1.96),('9303','2013-09-26','16:30:00',1.84),('9303','2013-09-26','16:35:00',1.74),('9303','2013-09-26','16:40:00',1.66),('9303','2013-09-26','16:45:00',1.57),('9303','2013-09-26','16:50:00',1.46),('9303','2013-09-26','16:55:00',1.4),('9303','2013-09-26','17:00:00',1.31),('9303','2013-09-26','17:05:00',1.25),('9303','2013-09-26','17:10:00',1.22),('9303','2013-09-26','17:15:00',1.08),('9303','2013-09-26','17:20:00',1.03),('9303','2013-09-25','08:45:00',1.13),('9303','2013-09-25','09:10:00',1.96),('9303','2013-09-25','09:15:00',1.63),('9303','2013-09-25','09:25:00',1.22),('9303','2013-09-25','09:30:00',1.84),('9303','2013-09-25','09:35:00',1.84),('9303','2013-09-25','09:40:00',2.14),('9303','2013-09-25','09:50:00',1.49),('9303','2013-09-25','09:55:00',1.11),('9303','2013-09-25','10:00:00',2.02),('9303','2013-09-25','10:40:00',1.28),('9303','2013-09-25','10:45:00',3.18),('9303','2013-09-25','10:50:00',3.53),('9303','2013-09-25','10:55:00',3.46),('9303','2013-09-25','11:00:00',2.36),('9303','2013-09-25','11:10:00',1.69),('9303','2013-09-25','11:15:00',2.14),('9303','2013-09-25','11:20:00',1.07),('9303','2013-09-25','11:25:00',2.89),('9303','2013-09-25','11:30:00',3.41),('9303','2013-09-25','11:35:00',2.91),('9303','2013-09-25','11:40:00',2.68),('9303','2013-09-25','11:45:00',3.48),('9303','2013-09-25','11:50:00',2.81),('9303','2013-09-25','11:55:00',2.08),('9303','2013-09-25','12:00:00',1.14),('9303','2013-09-25','12:15:00',3.56),('9303','2013-09-25','12:20:00',3.73),('9303','2013-09-25','12:25:00',2.54),('9303','2013-09-25','12:30:00',3.02),('9303','2013-09-25','12:35:00',3.13),('9303','2013-09-25','12:40:00',3.45),('9303','2013-09-25','13:00:00',1.48),('9303','2013-09-25','13:05:00',1.52),('9303','2013-09-25','13:10:00',1.73),('9303','2013-09-25','13:30:00',2.08),('9303','2013-09-25','13:35:00',2.78),('9303','2013-09-25','13:40:00',3.27),('9303','2013-09-25','13:45:00',4.02),('9303','2013-09-25','13:50:00',4.1),('9303','2013-09-25','13:55:00',3.58),('9303','2013-09-25','14:00:00',1.05),('9303','2013-09-25','14:10:00',1.06),('9303','2013-09-25','14:30:00',1.66),('9303','2013-09-25','14:35:00',1.25),('9303','2013-09-25','14:40:00',3.15),('9303','2013-09-25','14:45:00',2.53),('9303','2013-09-25','14:50:00',2.62),('9303','2013-09-25','14:55:00',3.42),('9303','2013-09-25','15:00:00',3.04),('9303','2013-09-25','15:05:00',3.45),('9303','2013-09-25','15:10:00',3.25),('9303','2013-09-25','15:15:00',3.17),('9303','2013-09-25','15:20:00',3.1),('9303','2013-09-25','15:25:00',2.91),('9303','2013-09-25','15:30:00',2.47),('9303','2013-09-25','15:35:00',2.9),('9303','2013-09-25','15:40:00',3.05),('9303','2013-09-25','15:45:00',2.72),('9303','2013-09-25','15:50:00',2.72),('9303','2013-09-25','15:55:00',2.64),('9303','2013-09-25','16:00:00',2.58),('9303','2013-09-25','16:05:00',2.49),('9303','2013-09-25','16:10:00',2.41),('9303','2013-09-25','16:15:00',2.31),('9303','2013-09-25','16:20:00',2.16),('9303','2013-09-25','16:30:00',1.95),('9303','2013-09-25','16:35:00',1.91),('9303','2013-09-25','16:40:00',1.58),('9303','2013-09-25','16:45:00',1.7),('9303','2013-09-25','16:50:00',1.59),('9303','2013-09-25','16:55:00',1.51),('9303','2013-09-25','17:00:00',1.43),('9303','2013-09-25','17:05:00',1.35),('9303','2013-09-25','17:10:00',1.26),('9303','2013-09-25','17:15:00',1.17),('9303','2013-09-25','17:20:00',1.08),('9303','2013-09-24','08:30:00',1.07),('9303','2013-09-24','08:35:00',1.18),('9303','2013-09-24','08:40:00',1.28),('9303','2013-09-24','08:45:00',1.37),('9303','2013-09-24','08:50:00',1.45),('9303','2013-09-24','08:55:00',1.56),('9303','2013-09-24','09:00:00',1.65),('9303','2013-09-24','09:05:00',1.72),('9303','2013-09-24','09:10:00',1.82),('9303','2013-09-24','09:15:00',1.89),('9303','2013-09-24','09:20:00',1.97),('9303','2013-09-24','09:25:00',2.05),('9303','2013-09-24','09:30:00',2.13),('9303','2013-09-24','09:35:00',2.2),('9303','2013-09-24','09:40:00',2.27),('9303','2013-09-24','09:45:00',2.33),('9303','2013-09-24','09:50:00',2.39),('9303','2013-09-24','09:55:00',2.44),('9303','2013-09-24','10:00:00',2.52),('9303','2013-09-24','10:05:00',2.59),('9303','2013-09-24','10:10:00',2.65),('9303','2013-09-24','10:15:00',2.71),('9303','2013-09-24','10:20:00',2.79),('9303','2013-09-24','10:25:00',2.83),('9303','2013-09-24','10:30:00',2.88),('9303','2013-09-24','10:35:00',2.92),('9303','2013-09-24','10:40:00',2.96),('9303','2013-09-24','10:45:00',3),('9303','2013-09-24','10:50:00',3.06),('9303','2013-09-24','10:55:00',3.13),('9303','2013-09-24','11:00:00',3.16),('9303','2013-09-24','11:05:00',3.19),('9303','2013-09-24','11:10:00',3.21),('9303','2013-09-24','11:15:00',3.2),('9303','2013-09-24','11:20:00',3.26),('9303','2013-09-24','11:25:00',3.32),('9303','2013-09-24','11:30:00',3.33),('9303','2013-09-24','11:35:00',3.37),('9303','2013-09-24','11:40:00',3.38),('9303','2013-09-24','11:45:00',3.41),('9303','2013-09-24','11:50:00',3.43),('9303','2013-09-24','11:55:00',3.42),('9303','2013-09-24','12:00:00',3.44),('9303','2013-09-24','12:05:00',3.45),('9303','2013-09-24','12:10:00',3.51),('9303','2013-09-24','12:15:00',3.52),('9303','2013-09-24','12:20:00',3.5),('9303','2013-09-24','12:25:00',3.5),('9303','2013-09-24','12:30:00',3.49),('9303','2013-09-24','12:35:00',3.57),('9303','2013-09-24','12:40:00',3.6),('9303','2013-09-24','12:45:00',3.59),('9303','2013-09-24','12:50:00',3.59),('9303','2013-09-24','12:55:00',3.56),('9303','2013-09-24','13:00:00',3.59),('9303','2013-09-24','13:05:00',3.58),('9303','2013-09-24','13:10:00',3.6),('9303','2013-09-24','13:15:00',3.61),('9303','2013-09-24','13:20:00',3.59),('9303','2013-09-24','13:25:00',3.6),('9303','2013-09-24','13:30:00',3.55),('9303','2013-09-24','13:35:00',3.52),('9303','2013-09-24','13:40:00',3.54),('9303','2013-09-24','13:45:00',3.56),('9303','2013-09-24','13:50:00',3.52),('9303','2013-09-24','13:55:00',3.51),('9303','2013-09-24','14:00:00',3.48),('9303','2013-09-24','14:05:00',3.48),('9303','2013-09-24','14:10:00',3.43),('9303','2013-09-24','14:15:00',3.41),('9303','2013-09-24','14:20:00',3.37),('9303','2013-09-24','14:25:00',3.34),('9303','2013-09-24','14:30:00',3.31),('9303','2013-09-24','14:35:00',3.28),('9303','2013-09-24','14:40:00',3.26),('9303','2013-09-24','14:45:00',3.24),('9303','2013-09-24','14:50:00',3.17),('9303','2013-09-24','14:55:00',3.14),('9303','2013-09-24','15:00:00',3.06),('9303','2013-09-24','15:05:00',3.05),('9303','2013-09-24','15:10:00',3.01),('9303','2013-09-24','15:15:00',2.96),('9303','2013-09-24','15:20:00',2.94),('9303','2013-09-24','15:25:00',2.91),('9303','2013-09-24','15:30:00',2.86),('9303','2013-09-24','15:35:00',2.8),('9303','2013-09-24','15:40:00',2.74),('9303','2013-09-24','15:45:00',2.68),('9303','2013-09-24','15:50:00',2.62),('9303','2013-09-24','15:55:00',2.54),('9303','2013-09-24','16:00:00',2.48),('9303','2013-09-24','16:05:00',2.4),('9303','2013-09-24','16:10:00',2.34),('9303','2013-09-24','16:15:00',2.28),('9303','2013-09-24','16:20:00',2.17),('9303','2013-09-24','16:25:00',2.05),('9303','2013-09-24','16:30:00',1.94),('9303','2013-09-24','16:35:00',1.86),('9303','2013-09-24','16:40:00',1.78),('9303','2013-09-24','16:45:00',1.7),('9303','2013-09-24','16:50:00',1.62),('9303','2013-09-24','16:55:00',1.54),('9303','2013-09-24','17:00:00',1.47),('9303','2013-09-24','17:05:00',1.38),('9303','2013-09-24','17:10:00',1.29),('9303','2013-09-24','17:15:00',1.2),('9303','2013-09-24','17:20:00',1.1),('9303','2013-09-24','17:25:00',1.01),('9303','2013-09-23','08:25:00',1.03),('9303','2013-09-23','08:30:00',1.13),('9303','2013-09-23','08:35:00',1.22),('9303','2013-09-23','08:40:00',1.32),('9303','2013-09-23','08:45:00',1.43),('9303','2013-09-23','08:50:00',1.49),('9303','2013-09-23','08:55:00',1.61),('9303','2013-09-23','09:00:00',1.7),('9303','2013-09-23','09:05:00',1.79),('9303','2013-09-23','09:10:00',1.88),('9303','2013-09-23','09:15:00',1.95),('9303','2013-09-23','09:20:00',2.03),('9303','2013-09-23','09:25:00',2.11),('9303','2013-09-23','09:30:00',2.18),('9303','2013-09-23','09:35:00',2.25),('9303','2013-09-23','09:40:00',2.32),('9303','2013-09-23','09:45:00',2.4),('9303','2013-09-23','09:50:00',2.46),('9303','2013-09-23','09:55:00',2.53),('9303','2013-09-23','10:00:00',2.6),('9303','2013-09-23','10:05:00',2.67),('9303','2013-09-23','10:10:00',2.72),('9303','2013-09-23','10:15:00',2.78),('9303','2013-09-23','10:20:00',2.83),('9303','2013-09-23','10:25:00',2.88),('9303','2013-09-23','10:30:00',2.91),('9303','2013-09-23','10:35:00',2.97),('9303','2013-09-23','10:40:00',3.02),('9303','2013-09-23','10:45:00',3.07),('9303','2013-09-23','10:50:00',3.15),('9303','2013-09-23','10:55:00',3.18),('9303','2013-09-23','11:00:00',3.2),('9303','2013-09-23','11:05:00',3.27),('9303','2013-09-23','11:10:00',3.34),('9303','2013-09-23','11:15:00',3.4),('9303','2013-09-23','11:20:00',3.43),('9303','2013-09-23','11:25:00',3.47),('9303','2013-09-23','11:30:00',3.49),('9303','2013-09-23','11:35:00',3.52),('9303','2013-09-23','11:40:00',3.52),('9303','2013-09-23','11:45:00',3.55),('9303','2013-09-23','11:50:00',3.58),('9303','2013-09-23','11:55:00',3.59),('9303','2013-09-23','12:00:00',3.63),('9303','2013-09-23','12:05:00',3.67),('9303','2013-09-23','12:10:00',3.71),('9303','2013-09-23','12:15:00',3.74),('9303','2013-09-23','12:20:00',3.73),('9303','2013-09-23','12:25:00',3.7),('9303','2013-09-23','12:30:00',3.69),('9303','2013-09-23','12:35:00',3.69),('9303','2013-09-23','12:40:00',3.68),('9303','2013-09-23','12:45:00',3.7),('9303','2013-09-23','12:50:00',3.7),('9303','2013-09-23','12:55:00',3.72),('9303','2013-09-23','13:00:00',3.74),('9303','2013-09-23','13:05:00',3.69),('9303','2013-09-23','13:10:00',3.7),('9303','2013-09-23','13:15:00',3.69),('9303','2013-09-23','13:20:00',3.65),('9303','2013-09-23','13:25:00',3.65),('9303','2013-09-23','13:30:00',3.63),('9303','2013-09-23','13:35:00',3.6),('9303','2013-09-23','13:40:00',3.61),('9303','2013-09-23','13:45:00',3.59),('9303','2013-09-23','13:50:00',3.57),('9303','2013-09-23','13:55:00',3.53),('9303','2013-09-23','14:00:00',3.46),('9303','2013-09-23','14:05:00',3.41),('9303','2013-09-23','14:10:00',3.4),('9303','2013-09-23','14:15:00',3.42),('9303','2013-09-23','14:20:00',3.4),('9303','2013-09-23','14:25:00',3.42),('9303','2013-09-23','14:30:00',3.46),('9303','2013-09-23','14:35:00',3.36),('9303','2013-09-23','14:40:00',3.31),('9303','2013-09-23','14:45:00',3.24),('9303','2013-09-23','14:50:00',3.16),('9303','2013-09-23','14:55:00',3.18),('9303','2013-09-23','15:00:00',3.18),('9303','2013-09-23','15:05:00',3.04),('9303','2013-09-23','15:10:00',2.01),('9303','2013-09-23','15:15:00',3.01),('9303','2013-09-23','15:20:00',2.93),('9303','2013-09-23','15:25:00',2.88),('9303','2013-09-23','15:30:00',2.83),('9303','2013-09-23','15:35:00',2.8),('9303','2013-09-23','15:40:00',2.73),('9303','2013-09-23','15:45:00',2.68),('9303','2013-09-23','15:50:00',2.47),('9303','2013-09-23','15:55:00',1.86),('9303','2013-09-23','16:00:00',2.32),('9303','2013-09-23','16:05:00',2.39),('9303','2013-09-23','16:10:00',2.21),('9303','2013-09-23','16:15:00',2.2),('9303','2013-09-23','16:20:00',1.92),('9303','2013-09-23','16:25:00',1.83),('9303','2013-09-23','16:30:00',1.81),('9303','2013-09-23','16:35:00',1.79),('9303','2013-09-23','16:40:00',1.75),('9303','2013-09-23','16:45:00',1.67),('9303','2013-09-23','16:50:00',1.58),('9303','2013-09-23','16:55:00',1.49),('9303','2013-09-23','17:00:00',1.42),('9303','2013-09-23','17:05:00',1.34),('9303','2013-09-23','17:10:00',1.27),('9303','2013-09-23','17:15:00',1.19),('9303','2013-09-23','17:20:00',1.09),('9303','2013-09-22','08:25:00',1.02),('9303','2013-09-22','08:30:00',1.09),('9303','2013-09-22','08:35:00',1.18),('9303','2013-09-22','08:40:00',1.27),('9303','2013-09-22','08:45:00',1.37),('9303','2013-09-22','08:50:00',1.45),('9303','2013-09-22','08:55:00',1.58),('9303','2013-09-22','09:00:00',1.66),('9303','2013-09-22','09:05:00',1.76),('9303','2013-09-22','09:10:00',1.86),('9303','2013-09-22','09:15:00',1.95),('9303','2013-09-22','09:20:00',2.02),('9303','2013-09-22','09:25:00',2.11),('9303','2013-09-22','09:30:00',2.18),('9303','2013-09-22','09:35:00',2.25),('9303','2013-09-22','09:40:00',2.3),('9303','2013-09-22','09:45:00',2.37),('9303','2013-09-22','09:50:00',2.44),('9303','2013-09-22','09:55:00',2.53),('9303','2013-09-22','10:00:00',2.6),('9303','2013-09-22','10:05:00',2.68),('9303','2013-09-22','10:10:00',2.75),('9303','2013-09-22','10:15:00',2.8),('9303','2013-09-22','10:20:00',2.87),('9303','2013-09-22','10:25:00',2.93),('9303','2013-09-22','10:30:00',3.01),('9303','2013-09-22','10:35:00',3.05),('9303','2013-09-22','10:40:00',3.09),('9303','2013-09-22','10:45:00',3.15),('9303','2013-09-22','10:50:00',3.17),('9303','2013-09-22','10:55:00',3.22),('9303','2013-09-22','11:00:00',3.26),('9303','2013-09-22','11:05:00',3.29),('9303','2013-09-22','11:10:00',3.32),('9303','2013-09-22','11:15:00',3.36),('9303','2013-09-22','11:20:00',3.42),('9303','2013-09-22','11:25:00',3.49),('9303','2013-09-22','11:30:00',3.52),('9303','2013-09-22','11:35:00',3.58),('9303','2013-09-22','11:40:00',3.61),('9303','2013-09-22','11:45:00',3.63),('9303','2013-09-22','11:50:00',3.66),('9303','2013-09-22','11:55:00',3.71),('9303','2013-09-22','12:00:00',3.73),('9303','2013-09-22','12:05:00',3.73),('9303','2013-09-22','12:10:00',3.73),('9303','2013-09-22','12:15:00',3.75),('9303','2013-09-22','12:20:00',3.77),('9303','2013-09-22','12:25:00',3.82),('9303','2013-09-22','12:30:00',3.8),('9303','2013-09-22','12:35:00',3.81),('9303','2013-09-22','12:40:00',3.83),('9303','2013-09-22','12:45:00',3.73),('9303','2013-09-22','12:50:00',3.87),('9303','2013-09-22','12:55:00',3.91),('9303','2013-09-22','13:00:00',3.86),('9303','2013-09-22','13:05:00',3.83),('9303','2013-09-22','13:10:00',3.85),('9303','2013-09-22','13:15:00',3.81),('9303','2013-09-22','13:20:00',3.78),('9303','2013-09-22','13:25:00',3.76),('9303','2013-09-22','13:30:00',3.76),('9303','2013-09-22','13:35:00',3.74),('9303','2013-09-22','13:40:00',3.73),('9303','2013-09-22','13:45:00',3.74),('9303','2013-09-22','13:50:00',3.75),('9303','2013-09-22','13:55:00',3.34),('9303','2013-09-22','14:00:00',3.68),('9303','2013-09-22','14:05:00',3.71),('9303','2013-09-22','14:10:00',3.63),('9303','2013-09-22','14:15:00',3.74),('9303','2013-09-22','14:20:00',2.08),('9303','2013-09-22','14:25:00',3.15),('9303','2013-09-22','14:30:00',2.27),('9303','2013-09-22','14:35:00',3.61),('9303','2013-09-22','14:40:00',2.59),('9303','2013-09-22','14:45:00',2.9),('9303','2013-09-22','14:50:00',3.41),('9303','2013-09-22','14:55:00',3.37),('9303','2013-09-22','15:00:00',3.41),('9303','2013-09-22','15:05:00',3.48),('9303','2013-09-22','15:10:00',3.34),('9303','2013-09-22','15:15:00',3.53),('9303','2013-09-22','15:20:00',3.49),('9303','2013-09-22','15:25:00',1.66),('9303','2013-09-22','15:40:00',2.61),('9303','2013-09-22','15:45:00',2.97),('9303','2013-09-22','15:50:00',2.81),('9303','2013-09-22','15:55:00',2.81),('9303','2013-09-22','16:00:00',3.02),('9303','2013-09-22','16:05:00',2.93),('9303','2013-09-22','16:10:00',3.23),('9303','2013-09-22','16:15:00',2.65),('9303','2013-09-22','16:20:00',1.73),('9303','2013-09-22','16:25:00',1.37),('9303','2013-09-22','16:30:00',1.01),('9303','2013-09-22','16:45:00',1.92),('9303','2013-09-22','16:50:00',1.66),('9303','2013-09-22','16:55:00',1.28),('9303','2013-09-22','17:05:00',1.59),('9303','2013-09-21','08:25:00',1.03),('9303','2013-09-21','08:30:00',1.12),('9303','2013-09-21','08:35:00',1.2),('9303','2013-09-21','08:40:00',1.29),('9303','2013-09-21','08:45:00',1.38),('9303','2013-09-21','08:50:00',1.46),('9303','2013-09-21','08:55:00',1.57),('9303','2013-09-21','09:00:00',1.65),('9303','2013-09-21','09:05:00',1.73),('9303','2013-09-21','09:10:00',1.81),('9303','2013-09-21','09:15:00',1.88),('9303','2013-09-21','09:20:00',1.97),('9303','2013-09-21','09:25:00',2.04),('9303','2013-09-21','09:30:00',2.11),('9303','2013-09-21','09:35:00',2.2),('9303','2013-09-21','09:40:00',2.27),('9303','2013-09-21','09:45:00',2.34),('9303','2013-09-21','09:50:00',2.4),('9303','2013-09-21','09:55:00',2.47),('9303','2013-09-21','10:00:00',2.54),('9303','2013-09-21','10:05:00',2.6),('9303','2013-09-21','10:10:00',2.66),('9303','2013-09-21','10:15:00',2.72),('9303','2013-09-21','10:20:00',2.78),('9303','2013-09-21','10:25:00',2.86),('9303','2013-09-21','10:30:00',2.89),('9303','2013-09-21','10:35:00',2.94),('9303','2013-09-21','10:40:00',2.99),('9303','2013-09-21','10:45:00',3.05),('9303','2013-09-21','10:50:00',3.09),('9303','2013-09-21','10:55:00',3.15),('9303','2013-09-21','11:00:00',3.18),('9303','2013-09-21','11:05:00',3.22),('9303','2013-09-21','11:10:00',3.28),('9303','2013-09-21','11:15:00',3.31),('9303','2013-09-21','11:20:00',3.33),('9303','2013-09-21','11:25:00',3.39),('9303','2013-09-21','11:30:00',3.39),('9303','2013-09-21','11:35:00',3.44),('9303','2013-09-21','11:40:00',3.49),('9303','2013-09-21','11:45:00',3.52),('9303','2013-09-21','11:50:00',3.54),('9303','2013-09-21','11:55:00',3.44),('9303','2013-09-21','12:00:00',3.57),('9303','2013-09-21','12:05:00',3.65),('9303','2013-09-21','12:10:00',3.66),('9303','2013-09-21','12:15:00',3.65),('9303','2013-09-21','12:20:00',3.64),('9303','2013-09-21','12:25:00',3.3),('9303','2013-09-21','12:30:00',3.76),('9303','2013-09-21','12:35:00',3.67),('9303','2013-09-21','12:40:00',3.32),('9303','2013-09-21','12:45:00',3.46),('9303','2013-09-21','12:50:00',3.71),('9303','2013-09-21','12:55:00',3.73),('9303','2013-09-21','13:00:00',3.71),('9303','2013-09-21','13:05:00',3.57),('9303','2013-09-21','13:10:00',3.73),('9303','2013-09-21','13:15:00',3.79),('9303','2013-09-21','13:20:00',3.05),('9303','2013-09-21','13:25:00',3.4),('9303','2013-09-21','13:30:00',3.48),('9303','2013-09-21','13:35:00',3.59),('9303','2013-09-21','13:40:00',3.16),('9303','2013-09-21','13:45:00',3.11),('9303','2013-09-21','13:50:00',3.25),('9303','2013-09-21','13:55:00',3.3),('9303','2013-09-21','14:00:00',3.28),('9303','2013-09-21','14:05:00',3.45),('9303','2013-09-21','14:10:00',3.31),('9303','2013-09-21','14:15:00',3.49),('9303','2013-09-21','14:20:00',3.54),('9303','2013-09-21','14:25:00',3.47),('9303','2013-09-21','14:30:00',3.41),('9303','2013-09-21','14:35:00',3.38),('9303','2013-09-21','14:40:00',3.34),('9303','2013-09-21','14:45:00',3.27),('9303','2013-09-21','14:50:00',3.25),('9303','2013-09-21','14:55:00',3.19),('9303','2013-09-21','15:00:00',3.15),('9303','2013-09-21','15:05:00',3.1),('9303','2013-09-21','15:10:00',2.97),('9303','2013-09-21','15:15:00',2.99),('9303','2013-09-21','15:20:00',2.97),('9303','2013-09-21','15:25:00',2.91),('9303','2013-09-21','15:30:00',2.87),('9303','2013-09-21','15:35:00',2.82),('9303','2013-09-21','15:40:00',2.56),('9303','2013-09-21','15:45:00',2.01),('9303','2013-09-21','15:50:00',2.32),('9303','2013-09-21','15:55:00',2.6),('9303','2013-09-21','16:00:00',2.04),('9303','2013-09-21','16:05:00',1.24),('9303','2013-09-21','16:10:00',1.6),('9303','2013-09-21','16:15:00',1.35),('9303','2013-09-21','16:20:00',1.64),('9303','2013-09-21','16:30:00',1.13),('9303','2013-09-21','16:35:00',1.33),('9303','2013-09-21','17:15:00',1.05),('9303','2013-09-20','08:35:00',1.24),('9303','2013-09-20','08:40:00',1.57),('9303','2013-09-20','08:45:00',1.38),('9303','2013-09-20','09:00:00',1.01),('9303','2013-09-20','09:05:00',1.2),('9303','2013-09-20','09:15:00',1.02),('9303','2013-09-20','09:20:00',1.48),('9303','2013-09-20','09:25:00',1.95),('9303','2013-09-20','09:30:00',1.2),('9303','2013-09-20','09:35:00',1.11),('9303','2013-09-20','09:40:00',1.13),('9303','2013-09-20','09:45:00',1.16),('9303','2013-09-20','09:50:00',1.19),('9303','2013-09-20','09:55:00',1.3),('9303','2013-09-20','10:00:00',1.43),('9303','2013-09-20','10:05:00',2.22),('9303','2013-09-20','10:10:00',2.48),('9303','2013-09-20','10:15:00',2.2),('9303','2013-09-20','10:20:00',3.01),('9303','2013-09-20','10:25:00',1.71),('9303','2013-09-20','10:30:00',1.87),('9303','2013-09-20','10:35:00',2.11),('9303','2013-09-20','10:40:00',2.04),('9303','2013-09-20','10:45:00',2.01),('9303','2013-09-20','10:50:00',2.5),('9303','2013-09-20','10:55:00',2.25),('9303','2013-09-20','11:00:00',2.18),('9303','2013-09-20','11:05:00',1.81),('9303','2013-09-20','11:10:00',1.96),('9303','2013-09-20','11:15:00',2.06),('9303','2013-09-20','11:20:00',2.54),('9303','2013-09-20','11:25:00',2.42),('9303','2013-09-20','11:30:00',2.69),('9303','2013-09-20','11:35:00',3.02),('9303','2013-09-20','11:40:00',2.69),('9303','2013-09-20','11:45:00',3.59),('9303','2013-09-20','11:50:00',3.81),('9303','2013-09-20','11:55:00',3.71),('9303','2013-09-20','12:00:00',3.59),('9303','2013-09-20','12:05:00',3.58),('9303','2013-09-20','12:10:00',3.62),('9303','2013-09-20','12:15:00',3.68),('9303','2013-09-20','12:20:00',3.77),('9303','2013-09-20','12:25:00',3.8),('9303','2013-09-20','12:30:00',3.13),('9303','2013-09-20','12:35:00',3.51),('9303','2013-09-20','12:40:00',3.03),('9303','2013-09-20','12:45:00',3.47),('9303','2013-09-20','12:50:00',3.37),('9303','2013-09-20','12:55:00',3.79),('9303','2013-09-20','13:00:00',3.28),('9303','2013-09-20','13:05:00',3.42),('9303','2013-09-20','13:10:00',3.82),('9303','2013-09-20','13:15:00',3.22),('9303','2013-09-20','13:20:00',3.54),('9303','2013-09-20','13:25:00',3.93),('9303','2013-09-20','13:30:00',3.74),('9303','2013-09-20','13:35:00',2.37),('9303','2013-09-20','13:40:00',3.17),('9303','2013-09-20','13:45:00',3.56),('9303','2013-09-20','13:50:00',3.64),('9303','2013-09-20','13:55:00',3.34),('9303','2013-09-20','14:00:00',3.6),('9303','2013-09-20','14:05:00',3.66),('9303','2013-09-20','14:10:00',3.65),('9303','2013-09-20','14:15:00',3.58),('9303','2013-09-20','14:20:00',1.62),('9303','2013-09-20','14:25:00',1.5),('9303','2013-09-20','14:30:00',3.49),('9303','2013-09-20','14:35:00',3.66),('9303','2013-09-20','14:40:00',3.06),('9303','2013-09-20','14:45:00',3.43),('9303','2013-09-20','14:50:00',3.52),('9303','2013-09-20','14:55:00',3.46),('9303','2013-09-20','15:00:00',2.96),('9303','2013-09-20','15:05:00',1.56),('9303','2013-09-20','15:10:00',2.92),('9303','2013-09-20','15:15:00',2.26),('9303','2013-09-20','15:20:00',1.28),('9303','2013-09-20','15:25:00',2.35),('9303','2013-09-20','15:30:00',1.62),('9303','2013-09-20','15:35:00',1.38),('9303','2013-09-20','15:40:00',1.04),('9303','2013-09-20','15:45:00',2.96),('9303','2013-09-20','15:50:00',2.87),('9303','2013-09-20','15:55:00',2.93),('9303','2013-09-20','16:00:00',2.27),('9303','2013-09-20','16:05:00',1.59),('9303','2013-09-20','16:10:00',2.42),('9303','2013-09-20','16:15:00',2.22),('9303','2013-09-20','16:20:00',1.06),('9303','2013-09-20','16:25:00',1.07),('9303','2013-09-20','16:45:00',1.01),('9303','2013-09-20','16:50:00',1.05),('9303','2013-09-20','16:55:00',1.02),('9303','2013-09-20','17:00:00',1.71),('9303','2013-09-20','17:05:00',2.01),('9303','2013-09-20','17:10:00',1.97),('9303','2013-09-20','17:15:00',1.81),('9303','2013-09-20','17:20:00',1.71),('9303','2013-09-20','17:25:00',1.39),('9303','2013-09-20','17:30:00',1.16),('9303','2013-09-20','17:35:00',1.01),('9303','2013-09-19','08:30:00',1.13),('9303','2013-09-19','08:35:00',1.18),('9303','2013-09-19','08:45:00',1.3),('9303','2013-09-19','08:50:00',1.14),('9303','2013-09-19','09:00:00',1.06),('9303','2013-09-19','09:10:00',1.26),('9303','2013-09-19','09:15:00',1.81),('9303','2013-09-19','09:20:00',1.08),('9303','2013-09-19','10:05:00',1.94),('9303','2013-09-19','10:10:00',2.22),('9303','2013-09-19','10:15:00',2.52),('9303','2013-09-19','10:25:00',1.11),('9303','2013-09-19','10:35:00',2.55),('9303','2013-09-19','10:40:00',3.31),('9303','2013-09-19','10:45:00',1.97),('9303','2013-09-19','10:50:00',1.41),('9303','2013-09-19','10:55:00',2.43),('9303','2013-09-19','11:00:00',3.44),('9303','2013-09-19','11:05:00',3.23),('9303','2013-09-19','11:10:00',1.59),('9303','2013-09-19','11:15:00',1.77),('9303','2013-09-19','11:20:00',2.32),('9303','2013-09-19','11:25:00',1.65),('9303','2013-09-19','11:30:00',4.5),('9303','2013-09-19','11:35:00',2.5),('9303','2013-09-19','11:40:00',3.16),('9303','2013-09-19','11:45:00',2.6),('9303','2013-09-19','11:50:00',3.63),('9303','2013-09-19','11:55:00',3.41),('9303','2013-09-19','12:00:00',3.05),('9303','2013-09-19','12:05:00',2.08),('9303','2013-09-19','12:10:00',3.17),('9303','2013-09-19','12:15:00',2.48),('9303','2013-09-19','12:20:00',3.65),('9303','2013-09-19','12:25:00',4.33),('9303','2013-09-19','12:30:00',4.14),('9303','2013-09-19','12:35:00',3.81),('9303','2013-09-19','12:40:00',3.43),('9303','2013-09-19','12:45:00',2.07),('9303','2013-09-19','12:50:00',4.11),('9303','2013-09-19','12:55:00',4),('9303','2013-09-19','13:00:00',4.04),('9303','2013-09-19','13:05:00',4.05),('9303','2013-09-19','13:10:00',4.21),('9303','2013-09-19','13:15:00',3.72),('9303','2013-09-19','13:20:00',3.62),('9303','2013-09-19','13:25:00',1.87),('9303','2013-09-19','13:30:00',4.06),('9303','2013-09-19','13:35:00',4.06),('9303','2013-09-19','13:40:00',4.02),('9303','2013-09-19','13:45:00',3.63),('9303','2013-09-19','13:50:00',1.21),('9303','2013-09-19','14:00:00',1.18),('9303','2013-09-19','14:05:00',2.83),('9303','2013-09-19','14:10:00',3.7),('9303','2013-09-19','14:15:00',3.72),('9303','2013-09-19','14:20:00',3.66),('9303','2013-09-19','14:25:00',3.33),('9303','2013-09-19','14:30:00',3.56),('9303','2013-09-19','14:35:00',3.49),('9303','2013-09-19','14:40:00',3.45),('9303','2013-09-19','14:45:00',3.31),('9303','2013-09-19','14:50:00',3.21),('9303','2013-09-19','14:55:00',3.05),('9303','2013-09-19','15:00:00',3.43),('9303','2013-09-19','15:05:00',3.31),('9303','2013-09-19','15:10:00',2.55),('9303','2013-09-19','15:15:00',3.19),('9303','2013-09-19','15:20:00',3.18),('9303','2013-09-19','15:25:00',2.61),('9303','2013-09-19','15:30:00',2.27),('9303','2013-09-19','15:35:00',1.5),('9303','2013-09-19','15:40:00',2.86),('9303','2013-09-19','15:45:00',2.65),('9303','2013-09-19','15:50:00',2.79),('9303','2013-09-19','15:55:00',2.55),('9303','2013-09-19','16:00:00',2.64),('9303','2013-09-19','16:05:00',2.46),('9303','2013-09-19','16:10:00',1.47),('9303','2013-09-19','16:15:00',2.04),('9303','2013-09-19','16:20:00',2.47),('9303','2013-09-19','16:25:00',2.16),('9303','2013-09-19','16:30:00',1.87),('9303','2013-09-19','16:35:00',1.12),('9303','2013-09-19','16:40:00',1.17),('9303','2013-09-19','16:45:00',1.1),('9303','2013-09-19','16:50:00',1.15),('9303','2013-09-19','16:55:00',1.39),('9303','2013-09-19','17:00:00',1.55),('9303','2013-09-19','17:05:00',1.5),('9303','2013-09-19','17:10:00',1.41),('9303','2013-09-19','17:15:00',1.32),('9303','2013-09-19','17:20:00',1.24),('9303','2013-09-19','17:25:00',1.07),('9303','2014-04-13','09:05:00',1.16),('9303','2014-04-13','09:10:00',1.44),('9303','2014-04-13','09:15:00',1.23),('9303','2014-04-13','09:20:00',1.45),('9303','2014-04-13','09:25:00',1.79),('9303','2014-04-13','09:30:00',1.73),('9303','2014-04-13','09:35:00',1.38),('9303','2014-04-13','09:40:00',2.26),('9303','2014-04-13','09:45:00',1.66),('9303','2014-04-13','09:50:00',1.49),('9303','2014-04-13','09:55:00',1.51),('9303','2014-04-13','10:00:00',2.62),('9303','2014-04-13','10:05:00',3.45),('9303','2014-04-13','10:10:00',1.99),('9303','2014-04-13','10:15:00',2.44),('9303','2014-04-13','10:20:00',3.3),('9303','2014-04-13','10:25:00',1.69),('9303','2014-04-13','10:30:00',3.69),('9303','2014-04-13','10:35:00',3.39),('9303','2014-04-13','10:40:00',3.29),('9303','2014-04-13','10:45:00',3.53),('9303','2014-04-13','10:50:00',3.56),('9303','2014-04-13','10:55:00',3.54),('9303','2014-04-13','11:00:00',3.59),('9303','2014-04-13','11:05:00',3.66),('9303','2014-04-13','11:10:00',3.56),('9303','2014-04-13','11:15:00',3.88),('9303','2014-04-13','11:20:00',4.52),('9303','2014-04-13','11:25:00',2.94),('9303','2014-04-13','11:30:00',1.96),('9303','2014-04-13','11:35:00',3.81),('9303','2014-04-13','11:40:00',3.93),('9303','2014-04-13','11:45:00',3.63),('9303','2014-04-13','11:50:00',3.75),('9303','2014-04-13','11:55:00',2.55),('9303','2014-04-13','12:00:00',2.61),('9303','2014-04-13','12:05:00',1.55),('9303','2014-04-13','12:10:00',1.39),('9303','2014-04-13','12:15:00',1.25),('9303','2014-04-13','12:20:00',1.06),('9303','2014-04-13','13:05:00',1.23),('9303','2014-04-13','13:10:00',1.87),('9303','2014-04-13','13:15:00',1.83),('9303','2014-04-13','13:20:00',2.27),('9303','2014-04-13','13:25:00',2.67),('9303','2014-04-13','13:30:00',4.21),('9303','2014-04-13','13:35:00',3.9),('9303','2014-04-13','13:40:00',3.62),('9303','2014-04-13','13:45:00',2),('9303','2014-04-13','13:50:00',2.93),('9303','2014-04-13','13:55:00',3.26),('9303','2014-04-13','14:00:00',4.02),('9303','2014-04-13','14:05:00',3.2),('9303','2014-04-13','14:10:00',3.82),('9303','2014-04-13','14:15:00',3.5),('9303','2014-04-13','14:20:00',1.91),('9303','2014-04-13','14:25:00',1.53),('9303','2014-04-13','14:30:00',1.51),('9303','2014-04-13','14:35:00',1.5),('9303','2014-04-13','14:40:00',1.28),('9303','2014-04-13','14:45:00',2.5),('9303','2014-04-13','14:50:00',2.73),('9303','2014-04-13','14:55:00',2.31),('9303','2014-04-13','15:00:00',3.12),('9303','2014-04-13','15:05:00',3.58),('9303','2014-04-13','15:10:00',3.71),('9303','2014-04-13','15:15:00',3.29),('9303','2014-04-13','15:20:00',3.28),('9303','2014-04-13','15:25:00',3.28),('9303','2014-04-13','15:30:00',3.18),('9303','2014-04-13','15:35:00',2.25),('9303','2014-04-13','15:40:00',1.24),('9303','2014-04-13','15:45:00',1.42),('9303','2014-04-13','15:50:00',1.63),('9303','2014-04-13','15:55:00',2.15),('9303','2014-04-13','16:00:00',3.36),('9303','2014-04-13','16:05:00',2.24),('9303','2014-04-13','16:10:00',1.26),('9303','2014-04-13','16:15:00',1.56),('9303','2014-04-13','16:20:00',1.36),('9303','2014-04-13','16:25:00',1.38),('9303','2014-04-13','16:30:00',1.29),('9303','2014-04-13','16:35:00',1.78),('9303','2014-04-13','16:40:00',2.74),('9303','2014-04-13','16:45:00',2.96),('9303','2014-04-13','16:50:00',1.71),('9303','2014-04-13','16:55:00',2.45),('9303','2014-04-13','17:00:00',2.22),('9303','2014-04-13','17:05:00',1.33),('9303','2014-04-13','17:15:00',1.12),('9303','2014-04-13','17:20:00',1.53),('9303','2014-04-13','17:25:00',1.1),('9303','2014-04-13','17:55:00',1.03),('9303','2013-09-18','08:45:00',1.03),('9303','2013-09-18','08:55:00',1),('9303','2013-09-18','09:00:00',1.06),('9303','2013-09-18','09:05:00',1.58),('9303','2013-09-18','09:15:00',1.18),('9303','2013-09-18','09:20:00',2.17),('9303','2013-09-18','09:25:00',1.84),('9303','2013-09-18','09:30:00',1.5),('9303','2013-09-18','09:35:00',1.48),('9303','2013-09-18','09:40:00',2.48),('9303','2013-09-18','09:45:00',1.29),('9303','2013-09-18','09:55:00',1.47),('9303','2013-09-18','10:00:00',2.06),('9303','2013-09-18','10:05:00',3.03),('9303','2013-09-18','10:10:00',2.85),('9303','2013-09-18','10:15:00',2.7),('9303','2013-09-18','10:20:00',2.7),('9303','2013-09-18','10:25:00',2.78),('9303','2013-09-18','10:30:00',2.82),('9303','2013-09-18','10:35:00',2.88),('9303','2013-09-18','10:40:00',2.93),('9303','2013-09-18','10:45:00',2.97),('9303','2013-09-18','10:50:00',2.77),('9303','2013-09-18','10:55:00',1.74),('9303','2013-09-18','11:00:00',3.42),('9303','2013-09-18','11:05:00',2.29),('9303','2013-09-18','11:10:00',2.96),('9303','2013-09-18','11:15:00',3.56),('9303','2013-09-18','11:20:00',2.47),('9303','2013-09-18','11:25:00',3.69),('9303','2013-09-18','11:30:00',3.78),('9303','2013-09-18','11:35:00',3.17),('9303','2013-09-18','11:40:00',2.13),('9303','2013-09-18','11:45:00',1.6),('9303','2013-09-18','11:50:00',3.76),('9303','2013-09-18','11:55:00',3.81),('9303','2013-09-18','12:00:00',3.63),('9303','2013-09-18','12:05:00',2.6),('9303','2013-09-18','12:10:00',3.96),('9303','2013-09-18','12:15:00',4),('9303','2013-09-18','12:20:00',3.87),('9303','2013-09-18','12:25:00',3.91),('9303','2013-09-18','12:30:00',2.46),('9303','2013-09-18','12:35:00',2.38),('9303','2013-09-18','12:40:00',4.03),('9303','2013-09-18','12:45:00',4.05),('9303','2013-09-18','12:50:00',4.02),('9303','2013-09-18','12:55:00',4.01),('9303','2013-09-18','13:00:00',3.25),('9303','2013-09-18','13:05:00',2.59),('9303','2013-09-18','13:10:00',4.05),('9303','2013-09-18','13:15:00',2.85),('9303','2013-09-18','13:20:00',3.99),('9303','2013-09-18','13:25:00',3.29),('9303','2013-09-18','13:30:00',3.94),('9303','2013-09-18','13:35:00',3.85),('9303','2013-09-18','13:40:00',3.81),('9303','2013-09-18','13:45:00',3.82),('9303','2013-09-18','13:50:00',2.92),('9303','2013-09-18','13:55:00',2.91),('9303','2013-09-18','14:00:00',3.9),('9303','2013-09-18','14:05:00',3.6),('9303','2013-09-18','14:10:00',3.74),('9303','2013-09-18','14:15:00',3.69),('9303','2013-09-18','14:20:00',3.67),('9303','2013-09-18','14:25:00',3.62),('9303','2013-09-18','14:30:00',3.53),('9303','2013-09-18','14:35:00',3.52),('9303','2013-09-18','14:40:00',3.51),('9303','2013-09-18','14:45:00',3.44),('9303','2013-09-18','14:50:00',3.48),('9303','2013-09-18','14:55:00',3.24),('9303','2013-09-18','15:00:00',3.33),('9303','2013-09-18','15:05:00',3.38),('9303','2013-09-18','15:10:00',1.7),('9303','2013-09-18','15:15:00',1.86),('9303','2013-09-18','15:20:00',3.3),('9303','2013-09-18','15:25:00',3.24),('9303','2013-09-18','15:30:00',3.18),('9303','2013-09-18','15:35:00',3.18),('9303','2013-09-18','15:40:00',3.06),('9303','2013-09-18','15:45:00',2.59),('9303','2013-09-18','15:50:00',2.27),('9303','2013-09-18','15:55:00',2.26),('9303','2013-09-18','16:00:00',2.14),('9303','2013-09-18','16:05:00',2.1),('9303','2013-09-18','16:10:00',2.81),('9303','2013-09-18','16:15:00',2.59),('9303','2013-09-18','16:20:00',2.4),('9303','2013-09-18','16:25:00',2.05),('9303','2013-09-18','16:30:00',1.91),('9303','2013-09-18','16:35:00',1.75),('9303','2013-09-18','16:40:00',1.77),('9303','2013-09-18','16:45:00',1.75),('9303','2013-09-18','16:50:00',1.58),('9303','2013-09-18','16:55:00',1.55),('9303','2013-09-18','17:00:00',1.59),('9303','2013-09-18','17:05:00',1.37),('9303','2013-09-18','17:10:00',1.36),('9303','2013-09-18','17:15:00',1.34),('9303','2013-09-18','17:20:00',1.27),('9303','2013-09-18','17:25:00',1.07),('9303','2013-09-18','17:30:00',1.1),('9303','2013-09-17','09:20:00',1.05),('9303','2013-09-17','09:40:00',1.28),('9303','2013-09-17','09:45:00',2.17),('9303','2013-09-17','09:50:00',1.29),('9303','2013-09-17','09:55:00',1.37),('9303','2013-09-17','10:00:00',1.97),('9303','2013-09-17','10:05:00',1.56),('9303','2013-09-17','10:10:00',1.79),('9303','2013-09-17','10:25:00',1.76),('9303','2013-09-17','10:30:00',2.7),('9303','2013-09-17','10:35:00',1.43),('9303','2013-09-17','10:40:00',1.62),('9303','2013-09-17','10:45:00',2.6),('9303','2013-09-17','10:50:00',3.68),('9303','2013-09-17','10:55:00',2.62),('9303','2013-09-17','11:00:00',1.99),('9303','2013-09-17','11:05:00',1.45),('9303','2013-09-17','11:10:00',3.2),('9303','2013-09-17','11:15:00',2.59),('9303','2013-09-17','11:20:00',2.22),('9303','2013-09-17','11:25:00',1.74),('9303','2013-09-17','11:30:00',1.65),('9303','2013-09-17','11:35:00',3.08),('9303','2013-09-17','11:40:00',3.3),('9303','2013-09-17','11:45:00',3.31),('9303','2013-09-17','11:50:00',3.24),('9303','2013-09-17','11:55:00',2.93),('9303','2013-09-17','12:00:00',3.35),('9303','2013-09-17','12:05:00',3.3),('9303','2013-09-17','12:10:00',1.71),('9303','2013-09-17','12:15:00',2.21),('9303','2013-09-17','12:20:00',2.08),('9303','2013-09-17','12:25:00',3.92),('9303','2013-09-17','12:30:00',3.35),('9303','2013-09-17','12:35:00',1.95),('9303','2013-09-17','12:40:00',3.31),('9303','2013-09-17','12:45:00',3.42),('9303','2013-09-17','12:50:00',2.76),('9303','2013-09-17','12:55:00',2.3),('9303','2013-09-17','13:00:00',2.33),('9303','2013-09-17','13:05:00',1.33),('9303','2013-09-17','13:10:00',2.2),('9303','2013-09-17','13:15:00',3.05),('9303','2013-09-17','13:20:00',2.14),('9303','2013-09-17','13:25:00',1.91),('9303','2013-09-17','13:30:00',1.67),('9303','2013-09-17','13:35:00',1.65),('9303','2013-09-17','13:40:00',2.54),('9303','2013-09-17','13:45:00',1.83),('9303','2013-09-17','13:55:00',1.13),('9303','2013-09-17','14:00:00',1.56),('9303','2013-09-17','14:05:00',1.06),('9303','2013-09-17','14:15:00',1.22),('9303','2013-09-17','14:25:00',1.82),('9303','2013-09-17','14:35:00',1.05),('9303','2013-09-17','14:55:00',3.05),('9303','2013-09-17','15:00:00',3.32),('9303','2013-09-17','15:05:00',2.67),('9303','2013-09-17','15:10:00',2.63),('9303','2013-09-17','15:15:00',2.45),('9303','2013-09-17','15:20:00',2.78),('9303','2013-09-17','15:25:00',2.71),('9303','2013-09-17','15:30:00',2.08),('9303','2013-09-17','15:45:00',1.33),('9303','2013-09-17','15:50:00',1.79),('9303','2013-09-17','15:55:00',2.17),('9303','2013-09-17','16:00:00',1.26),('9303','2013-09-17','16:05:00',1.68),('9303','2013-09-17','16:10:00',1.65),('9303','2013-09-17','16:15:00',1.75),('9303','2013-09-17','16:20:00',1.01),('9303','2013-09-17','16:40:00',1.03),('9303','2013-09-17','16:45:00',1.05),('9303','2013-09-17','16:50:00',1.06),('9303','2013-09-17','17:00:00',1.34),('9303','2013-09-17','17:05:00',1.43),('9303','2013-09-17','17:10:00',1.33),('9303','2013-09-17','17:15:00',1.41),('9303','2013-09-17','17:20:00',1.2),('9303','2013-09-17','17:25:00',1.12),('9303','2013-09-17','17:30:00',1.1),('9303','2013-09-16','08:25:00',1.05),('9303','2013-09-16','08:30:00',1.14),('9303','2013-09-16','08:35:00',1.23),('9303','2013-09-16','08:40:00',1.37),('9303','2013-09-16','08:50:00',1.34),('9303','2013-09-16','08:55:00',1.01),('9303','2013-09-16','09:05:00',1.69),('9303','2013-09-16','09:10:00',1.97),('9303','2013-09-16','09:15:00',1.66),('9303','2013-09-16','09:20:00',1.72),('9303','2013-09-16','09:25:00',1.94),('9303','2013-09-16','09:30:00',1.99),('9303','2013-09-16','09:35:00',2.19),('9303','2013-09-16','09:40:00',2.26),('9303','2013-09-16','09:45:00',2.33),('9303','2013-09-16','09:50:00',2.44),('9303','2013-09-16','09:55:00',2.53),('9303','2013-09-16','10:00:00',2.62),('9303','2013-09-16','10:05:00',2.69),('9303','2013-09-16','10:10:00',2.63),('9303','2013-09-16','10:15:00',1.34),('9303','2013-09-16','10:20:00',1.9),('9303','2013-09-16','10:25:00',1.72),('9303','2013-09-16','10:30:00',3.08),('9303','2013-09-16','10:35:00',3.42),('9303','2013-09-16','10:40:00',3.6),('9303','2013-09-16','10:45:00',3.77),('9303','2013-09-16','10:50:00',1.83),('9303','2013-09-16','11:05:00',2.76),('9303','2013-09-16','11:10:00',1.02),('9303','2013-09-16','11:15:00',2.36),('9303','2013-09-16','11:20:00',1.75),('9303','2013-09-16','11:25:00',1.49),('9303','2013-09-16','11:30:00',3.82),('9303','2013-09-16','11:35:00',3.73),('9303','2013-09-16','11:40:00',3.81),('9303','2013-09-16','11:45:00',2.23),('9303','2013-09-16','11:50:00',2.66),('9303','2013-09-16','11:55:00',3.87),('9303','2013-09-16','12:00:00',3.92),('9303','2013-09-16','12:05:00',3.81),('9303','2013-09-16','12:10:00',3.2),('9303','2013-09-16','12:15:00',4.04),('9303','2013-09-16','12:20:00',3.85),('9303','2013-09-16','12:25:00',3.83),('9303','2013-09-16','12:30:00',3.82),('9303','2013-09-16','12:35:00',3.84),('9303','2013-09-16','12:40:00',4),('9303','2013-09-16','12:45:00',4.16),('9303','2013-09-16','12:50:00',2.69),('9303','2013-09-16','12:55:00',2.6),('9303','2013-09-16','13:00:00',1.54),('9303','2013-09-16','13:05:00',3.95),('9303','2013-09-16','13:10:00',3.7),('9303','2013-09-16','13:15:00',4),('9303','2013-09-16','13:20:00',3.92),('9303','2013-09-16','13:25:00',3.87),('9303','2013-09-16','13:30:00',3.79),('9303','2013-09-16','13:35:00',3.88),('9303','2013-09-16','13:40:00',3.85),('9303','2013-09-16','13:45:00',3.79),('9303','2013-09-16','13:50:00',3.86),('9303','2013-09-16','13:55:00',3.99),('9303','2013-09-16','14:00:00',3.25),('9303','2013-09-16','14:05:00',3.73),('9303','2013-09-16','14:10:00',3.7),('9303','2013-09-16','14:15:00',3.63),('9303','2013-09-16','14:20:00',3.59),('9303','2013-09-16','14:25:00',3.6),('9303','2013-09-16','14:30:00',3.6),('9303','2013-09-16','14:35:00',3.55),('9303','2013-09-16','14:40:00',3.5),('9303','2013-09-16','14:45:00',3.47),('9303','2013-09-16','14:50:00',3.44),('9303','2013-09-16','14:55:00',3.4),('9303','2013-09-16','15:00:00',3.36),('9303','2013-09-16','15:05:00',3.32),('9303','2013-09-16','15:10:00',3.28),('9303','2013-09-16','15:15:00',3.24),('9303','2013-09-16','15:20:00',3.19),('9303','2013-09-16','15:25:00',3.13),('9303','2013-09-16','15:30:00',3.07),('9303','2013-09-16','15:35:00',3.02),('9303','2013-09-16','15:40:00',2.98),('9303','2013-09-16','15:45:00',2.91),('9303','2013-09-16','15:50:00',2.85),('9303','2013-09-16','15:55:00',2.77),('9303','2013-09-16','16:00:00',2.71),('9303','2013-09-16','16:05:00',1.01),('9303','2013-09-16','16:10:00',2.67),('9303','2013-09-16','16:15:00',2.54),('9303','2013-09-16','16:20:00',2.47),('9303','2013-09-16','16:25:00',2.38),('9303','2013-09-16','16:30:00',2.27),('9303','2013-09-16','16:35:00',2.14),('9303','2013-09-16','16:40:00',2.04),('9303','2013-09-16','16:45:00',1.97),('9303','2013-09-16','16:50:00',1.89),('9303','2013-09-16','16:55:00',1.8),('9303','2013-09-16','17:00:00',1.7),('9303','2013-09-16','17:05:00',1.6),('9303','2013-09-16','17:10:00',1.52),('9303','2013-09-16','17:15:00',1.43),('9303','2013-09-16','17:20:00',1.33),('9303','2013-09-16','17:25:00',1.24),('9303','2013-09-16','17:30:00',1.16),('9303','2013-09-16','17:35:00',1.05),('9303','2013-09-15','08:20:00',1.01),('9303','2013-09-15','08:25:00',1.11),('9303','2013-09-15','08:30:00',1.21),('9303','2013-09-15','08:35:00',1.32),('9303','2013-09-15','08:40:00',1.46),('9303','2013-09-15','08:45:00',1.54),('9303','2013-09-15','08:50:00',1.58),('9303','2013-09-15','08:55:00',1.53),('9303','2013-09-15','09:00:00',1.68),('9303','2013-09-15','09:05:00',1.72),('9303','2013-09-15','09:10:00',1.87),('9303','2013-09-15','09:15:00',2.06),('9303','2013-09-15','09:20:00',2),('9303','2013-09-15','09:25:00',2.09),('9303','2013-09-15','09:30:00',2.15),('9303','2013-09-15','09:35:00',2.28),('9303','2013-09-15','09:40:00',2.34),('9303','2013-09-15','09:45:00',2.38),('9303','2013-09-15','09:50:00',2.47),('9303','2013-09-15','09:55:00',2.49),('9303','2013-09-15','10:00:00',2.62),('9303','2013-09-15','10:05:00',2.66),('9303','2013-09-15','10:10:00',2.7),('9303','2013-09-15','10:15:00',2.59),('9303','2013-09-15','10:20:00',2.72),('9303','2013-09-15','10:25:00',2.81),('9303','2013-09-15','10:30:00',2.65),('9303','2013-09-15','10:35:00',2.34),('9303','2013-09-15','10:40:00',1.09),('9303','2013-09-15','10:55:00',2.42),('9303','2013-09-15','11:00:00',2.97),('9303','2013-09-15','11:05:00',3.61),('9303','2013-09-15','11:10:00',2.67),('9303','2013-09-15','11:15:00',1.73),('9303','2013-09-15','11:20:00',1.16),('9303','2013-09-15','11:25:00',1.15),('9303','2013-09-15','11:30:00',1.12),('9303','2013-09-15','11:35:00',2.54),('9303','2013-09-15','11:40:00',1.34),('9303','2013-09-15','11:45:00',1.34),('9303','2013-09-15','11:50:00',3.22),('9303','2013-09-15','11:55:00',1.41),('9303','2013-09-15','12:00:00',1.07),('9303','2013-09-15','12:05:00',1.03),('9303','2013-09-15','12:10:00',1),('9303','2013-09-15','12:15:00',1.04),('9303','2013-09-15','12:20:00',1.27),('9303','2013-09-15','12:25:00',1.56),('9303','2013-09-15','12:30:00',1.55),('9303','2013-09-15','12:35:00',1.41),('9303','2013-09-15','12:40:00',1.34),('9303','2013-09-15','12:45:00',1.01),('9303','2013-09-15','12:50:00',1.14),('9303','2013-09-15','12:55:00',1.25),('9303','2013-09-15','13:00:00',1.18),('9303','2013-09-15','13:05:00',1.05),('9303','2013-09-15','13:35:00',1.13),('9303','2013-09-15','13:40:00',1.3),('9303','2013-09-15','13:45:00',2.32),('9303','2013-09-15','13:50:00',2.61),('9303','2013-09-15','13:55:00',1.1),('9303','2013-09-15','14:00:00',1.6),('9303','2013-09-15','14:05:00',1.51),('9303','2013-09-15','14:10:00',1.42),('9303','2013-09-15','14:15:00',1.32),('9303','2013-09-15','14:20:00',1.21),('9303','2013-09-15','14:25:00',1.2),('9303','2013-09-15','14:30:00',1.18),('9303','2013-09-15','14:40:00',1.05),('9303','2013-09-15','15:00:00',1.02),('9303','2013-09-15','15:05:00',1.08),('9303','2013-09-15','15:10:00',1.2),('9303','2013-09-15','15:15:00',2.36),('9303','2013-09-15','15:20:00',1.96),('9303','2013-09-15','15:25:00',1.39),('9303','2013-09-15','15:30:00',1.03),('9303','2013-09-15','15:35:00',1),('9303','2013-09-14','08:25:00',1.06),('9303','2013-09-14','08:30:00',1.17),('9303','2013-09-14','08:35:00',1.27),('9303','2013-09-14','08:40:00',1.37),('9303','2013-09-14','08:45:00',1.45),('9303','2013-09-14','08:50:00',1.54),('9303','2013-09-14','08:55:00',1.63),('9303','2013-09-14','09:00:00',1.73),('9303','2013-09-14','09:05:00',1.81),('9303','2013-09-14','09:10:00',1.89),('9303','2013-09-14','09:15:00',1.96),('9303','2013-09-14','09:20:00',2.05),('9303','2013-09-14','09:25:00',2.12),('9303','2013-09-14','09:30:00',2.2),('9303','2013-09-14','09:35:00',2.27),('9303','2013-09-14','09:40:00',2.34),('9303','2013-09-14','09:45:00',2.4),('9303','2013-09-14','09:50:00',2.43),('9303','2013-09-14','09:55:00',2.54),('9303','2013-09-14','10:00:00',2.6),('9303','2013-09-14','10:05:00',2.39),('9303','2013-09-14','10:10:00',2.42),('9303','2013-09-14','10:15:00',2.47),('9303','2013-09-14','10:20:00',2.71),('9303','2013-09-14','10:25:00',2.85),('9303','2013-09-14','10:30:00',2.86),('9303','2013-09-14','10:35:00',2.98),('9303','2013-09-14','10:40:00',3.1),('9303','2013-09-14','10:45:00',3),('9303','2013-09-14','10:50:00',3.61),('9303','2013-09-14','10:55:00',3.66),('9303','2013-09-14','11:00:00',3.41),('9303','2013-09-14','11:05:00',1.08),('9303','2013-09-14','11:15:00',1.48),('9303','2013-09-14','11:20:00',1.54),('9303','2013-09-14','11:25:00',2.04),('9303','2013-09-14','11:30:00',3.69),('9303','2013-09-14','11:35:00',3.73),('9303','2013-09-14','11:40:00',3.81),('9303','2013-09-14','11:45:00',3.8),('9303','2013-09-14','11:50:00',3.82),('9303','2013-09-14','11:55:00',2.73),('9303','2013-09-14','12:00:00',1.01),('9303','2013-09-14','12:10:00',1.31),('9303','2013-09-14','12:15:00',1.92),('9303','2013-09-14','12:20:00',1.08),('9303','2013-09-14','12:35:00',1.38),('9303','2013-09-14','12:40:00',2.52),('9303','2013-09-14','13:10:00',1.04),('9303','2013-09-14','13:15:00',4.14),('9303','2013-09-14','13:20:00',4.06),('9303','2013-09-14','13:25:00',3.96),('9303','2013-09-14','13:30:00',4.1),('9303','2013-09-14','13:35:00',2.87),('9303','2013-09-14','13:40:00',1.68),('9303','2013-09-14','13:45:00',2.95),('9303','2013-09-14','13:50:00',2.57),('9303','2013-09-14','13:55:00',3.46),('9303','2013-09-14','14:00:00',4.06),('9303','2013-09-14','14:05:00',3.85),('9303','2013-09-14','14:10:00',3.75),('9303','2013-09-14','14:15:00',3.72),('9303','2013-09-14','14:20:00',3.67),('9303','2013-09-14','14:25:00',3.53),('9303','2013-09-14','14:30:00',3.61),('9303','2013-09-14','14:35:00',3.59),('9303','2013-09-14','14:40:00',3.52),('9303','2013-09-14','14:45:00',3.49),('9303','2013-09-14','14:50:00',3.43),('9303','2013-09-14','14:55:00',3.4),('9303','2013-09-14','15:00:00',3.25),('9303','2013-09-14','15:05:00',3.29),('9303','2013-09-14','15:10:00',3.23),('9303','2013-09-14','15:15:00',3.19),('9303','2013-09-14','15:20:00',3.14),('9303','2013-09-14','15:25:00',3.12),('9303','2013-09-14','15:30:00',3.09),('9303','2013-09-14','15:35:00',3),('9303','2013-09-14','15:40:00',2.98),('9303','2013-09-14','15:45:00',2.91),('9303','2013-09-14','15:50:00',2.81),('9303','2013-09-14','15:55:00',2.78),('9303','2013-09-14','16:00:00',2.7),('9303','2013-09-14','16:05:00',2.63),('9303','2013-09-14','16:10:00',2.54),('9303','2013-09-14','16:15:00',2.45),('9303','2013-09-14','16:20:00',2.41),('9303','2013-09-14','16:25:00',2.34),('9303','2013-09-14','16:30:00',2.26),('9303','2013-09-14','16:35:00',2.14),('9303','2013-09-14','16:40:00',2.04),('9303','2013-09-14','16:45:00',1.95),('9303','2013-09-14','16:50:00',1.88),('9303','2013-09-14','16:55:00',1.81),('9303','2013-09-14','17:00:00',1.73),('9303','2013-09-14','17:05:00',1.63),('9303','2013-09-14','17:10:00',1.56),('9303','2013-09-14','17:15:00',1.48),('9303','2013-09-14','17:20:00',1.25),('9303','2013-09-14','17:25:00',1.26),('9303','2013-09-14','17:30:00',1.16),('9303','2013-09-14','17:35:00',1.05),('9303','2013-09-13','09:25:00',1.01),('9303','2013-09-13','09:30:00',1.09),('9303','2013-09-13','09:35:00',1.21),('9303','2013-09-13','09:40:00',1.39),('9303','2013-09-13','09:45:00',1.24),('9303','2013-09-13','09:50:00',1.35),('9303','2013-09-13','09:55:00',1.73),('9303','2013-09-13','10:00:00',2.78),('9303','2013-09-13','10:05:00',1.3),('9303','2013-09-13','10:10:00',2.02),('9303','2013-09-13','10:15:00',3.43),('9303','2013-09-13','10:20:00',2.88),('9303','2013-09-13','10:25:00',1.41),('9303','2013-09-13','10:30:00',2.43),('9303','2013-09-13','10:35:00',3.3),('9303','2013-09-13','10:40:00',3.08),('9303','2013-09-13','10:45:00',3.14),('9303','2013-09-13','10:50:00',3.2),('9303','2013-09-13','10:55:00',3.24),('9303','2013-09-13','11:00:00',3.27),('9303','2013-09-13','11:05:00',3.3),('9303','2013-09-13','11:10:00',3.32),('9303','2013-09-13','11:15:00',3.37),('9303','2013-09-13','11:20:00',3.42),('9303','2013-09-13','11:25:00',3.43),('9303','2013-09-13','11:30:00',3.49),('9303','2013-09-13','11:35:00',3.52),('9303','2013-09-13','11:40:00',3.51),('9303','2013-09-13','11:45:00',3.56),('9303','2013-09-13','11:50:00',3.61),('9303','2013-09-13','11:55:00',3.63),('9303','2013-09-13','12:00:00',3.65),('9303','2013-09-13','12:05:00',3.69),('9303','2013-09-13','12:10:00',3.66),('9303','2013-09-13','12:15:00',3.66),('9303','2013-09-13','12:20:00',3.67),('9303','2013-09-13','12:25:00',1.63),('9303','2013-09-13','12:35:00',2.77),('9303','2013-09-13','12:40:00',3.99),('9303','2013-09-13','12:45:00',3.94),('9303','2013-09-13','12:50:00',3.92),('9303','2013-09-13','12:55:00',3.86),('9303','2013-09-13','13:00:00',3.83),('9303','2013-09-13','13:05:00',3.78),('9303','2013-09-13','13:10:00',3.74),('9303','2013-09-13','13:15:00',3.81),('9303','2013-09-13','13:20:00',3.83),('9303','2013-09-13','13:25:00',3.76),('9303','2013-09-13','13:30:00',3.73),('9303','2013-09-13','13:35:00',3.71),('9303','2013-09-13','13:40:00',3.71),('9303','2013-09-13','13:45:00',3.72),('9303','2013-09-13','13:50:00',3.67),('9303','2013-09-13','13:55:00',3.67),('9303','2013-09-13','14:00:00',3.69),('9303','2013-09-13','14:05:00',3.65),('9303','2013-09-13','14:10:00',3.59),('9303','2013-09-13','14:15:00',3.6),('9303','2013-09-13','14:20:00',3.59),('9303','2013-09-13','14:25:00',3.6),('9303','2013-09-13','14:30:00',3.55),('9303','2013-09-13','14:35:00',3.51),('9303','2013-09-13','14:40:00',3.41),('9303','2013-09-13','14:45:00',3.46),('9303','2013-09-13','14:50:00',3.44),('9303','2013-09-13','14:55:00',3.39),('9303','2013-09-13','15:00:00',3.09),('9303','2013-09-13','15:05:00',3.29),('9303','2013-09-13','15:10:00',3.28),('9303','2013-09-13','15:15:00',3.28),('9303','2013-09-13','15:20:00',3.18),('9303','2013-09-13','15:25:00',3.14),('9303','2013-09-13','15:30:00',3.07),('9303','2013-09-13','15:35:00',3.04),('9303','2013-09-13','15:40:00',2.96),('9303','2013-09-13','15:45:00',2.93),('9303','2013-09-13','15:50:00',2.86),('9303','2013-09-13','15:55:00',2.82),('9303','2013-09-13','16:00:00',2.75),('9303','2013-09-13','16:05:00',2.66),('9303','2013-09-13','16:10:00',2.58),('9303','2013-09-13','16:15:00',2.53),('9303','2013-09-13','16:20:00',2.47),('9303','2013-09-13','16:25:00',2.4),('9303','2013-09-13','16:30:00',2.28),('9303','2013-09-13','16:35:00',2.18),('9303','2013-09-13','16:40:00',2.06),('9303','2013-09-13','16:45:00',1.97),('9303','2013-09-13','16:50:00',1.9),('9303','2013-09-13','16:55:00',1.82),('9303','2013-09-13','17:00:00',1.72),('9303','2013-09-13','17:05:00',1.63),('9303','2013-09-13','17:10:00',1.53),('9303','2013-09-13','17:15:00',1.44),('9303','2013-09-13','17:20:00',1.35),('9303','2013-09-13','17:25:00',1.27),('9303','2013-09-13','17:30:00',1.18),('9303','2013-09-13','17:35:00',1.07),('9303','2013-09-13','17:40:00',1),('9303','2013-09-12','08:15:00',1.08),('9303','2013-09-12','08:20:00',1.1),('9303','2013-09-12','08:25:00',1.32),('9303','2013-09-12','08:30:00',1.48),('9303','2013-09-12','08:35:00',1.33),('9303','2013-09-12','08:55:00',1.38),('9303','2013-09-12','09:00:00',1.71),('9303','2013-09-12','09:05:00',1.64),('9303','2013-09-12','09:10:00',1.18),('9303','2013-09-12','09:15:00',1.85),('9303','2013-09-12','09:20:00',1.9),('9303','2013-09-12','09:25:00',2.15),('9303','2013-09-12','09:30:00',2.31),('9303','2013-09-12','09:35:00',2.16),('9303','2013-09-12','09:40:00',1.86),('9303','2013-09-12','09:45:00',2.23),('9303','2013-09-12','09:50:00',1.83),('9303','2013-09-12','09:55:00',1.2),('9303','2013-09-12','10:05:00',1.26),('9303','2013-09-12','10:10:00',1.57),('9303','2013-09-12','10:15:00',1.61),('9303','2013-09-12','10:20:00',1.23),('9303','2013-09-12','10:30:00',1.79),('9303','2013-09-12','10:35:00',1.67),('9303','2013-09-12','10:55:00',1.69),('9303','2013-09-12','11:00:00',2.31),('9303','2013-09-12','11:05:00',3.37),('9303','2013-09-12','11:10:00',2.57),('9303','2013-09-12','11:15:00',2.58),('9303','2013-09-12','11:40:00',1.04),('9303','2013-09-12','11:45:00',1.65),('9303','2013-09-12','11:50:00',1.48),('9303','2013-09-12','11:55:00',3.31),('9303','2013-09-12','12:00:00',3.15),('9303','2013-09-12','12:05:00',3.74),('9303','2013-09-12','12:10:00',3.43),('9303','2013-09-12','12:15:00',3.53),('9303','2013-09-12','12:20:00',1.4),('9303','2013-09-12','12:25:00',1.57),('9303','2013-09-12','12:30:00',1.54),('9303','2013-09-12','12:35:00',2.67),('9303','2013-09-12','12:40:00',3.64),('9303','2013-09-12','12:45:00',1.07),('9303','2013-09-12','12:50:00',3),('9303','2013-09-12','12:55:00',1.57),('9303','2013-09-12','13:00:00',4.31),('9303','2013-09-12','13:05:00',2.88),('9303','2013-09-12','13:10:00',2.73),('9303','2013-09-12','13:15:00',3.53),('9303','2013-09-12','13:20:00',4.12),('9303','2013-09-12','13:25:00',4.55),('9303','2013-09-12','13:30:00',3.88),('9303','2013-09-12','13:35:00',3.03),('9303','2013-09-12','13:40:00',3.07),('9303','2013-09-12','13:45:00',3.65),('9303','2013-09-12','13:50:00',4.01),('9303','2013-09-12','13:55:00',3.86),('9303','2013-09-12','14:00:00',3.88),('9303','2013-09-12','14:05:00',3.4),('9303','2013-09-12','14:10:00',2.67),('9303','2013-09-12','14:15:00',3.86),('9303','2013-09-12','14:20:00',3.74),('9303','2013-09-12','14:25:00',3.82),('9303','2013-09-12','14:30:00',3.83),('9303','2013-09-12','14:35:00',2.81),('9303','2013-09-12','14:40:00',2.91),('9303','2013-09-12','14:45:00',3.63),('9303','2013-09-12','14:50:00',3.54),('9303','2013-09-12','14:55:00',3.5),('9303','2013-09-12','15:00:00',3.42),('9303','2013-09-12','15:05:00',3.33),('9303','2013-09-12','15:10:00',2.37),('9303','2013-09-12','15:15:00',3.18),('9303','2013-09-12','15:20:00',3.24),('9303','2013-09-12','15:25:00',2.89),('9303','2013-09-12','15:30:00',3.16),('9303','2013-09-12','15:35:00',3.1),('9303','2013-09-12','15:40:00',2.96),('9303','2013-09-12','15:45:00',3.01),('9303','2013-09-12','15:50:00',2.78),('9303','2013-09-12','15:55:00',2.82),('9303','2013-09-12','16:00:00',2.87),('9303','2013-09-12','16:05:00',1.88),('9303','2013-09-12','16:10:00',2.49),('9303','2013-09-12','16:15:00',2.54),('9303','2013-09-12','16:20:00',1.87),('9303','2013-09-12','16:25:00',1.74),('9303','2013-09-12','16:30:00',1.19),('9303','2013-09-12','16:40:00',1.51),('9303','2013-09-12','16:45:00',2.25),('9303','2013-09-12','16:50:00',1.13),('9303','2013-09-12','16:55:00',1.57),('9303','2013-09-12','17:00:00',1.08),('9303','2013-09-12','17:05:00',1.78),('9303','2013-09-12','17:10:00',1.35),('9303','2013-09-12','17:15:00',1.66),('9303','2013-09-12','17:20:00',1.18),('9303','2013-09-12','17:25:00',1.02),('9303','2013-09-12','17:30:00',1.3),('9303','2013-09-12','17:35:00',1.22),('9303','2013-09-12','17:40:00',1.07),('9303','2013-09-12','17:45:00',1.03),('9303','2013-09-11','09:00:00',1.58),('9303','2013-09-11','09:05:00',1.99),('9303','2013-09-11','09:10:00',2.02),('9303','2013-09-11','09:15:00',1.9),('9303','2013-09-11','09:20:00',2.51),('9303','2013-09-11','09:25:00',1.71),('9303','2013-09-11','09:30:00',1.33),('9303','2013-09-11','09:35:00',1.33),('9303','2013-09-11','09:40:00',1.33),('9303','2013-09-11','10:05:00',1.9),('9303','2013-09-11','10:10:00',1.11),('9303','2013-09-11','10:15:00',1.95),('9303','2013-09-11','10:20:00',2.93),('9303','2013-09-11','10:25:00',2.15),('9303','2013-09-11','10:30:00',3.15),('9303','2013-09-11','10:35:00',2.84),('9303','2013-09-11','10:40:00',2.38),('9303','2013-09-11','10:45:00',1.36),('9303','2013-09-11','10:50:00',2.55),('9303','2013-09-11','10:55:00',1.61),('9303','2013-09-11','11:00:00',1.31),('9303','2013-09-11','11:05:00',1.98),('9303','2013-09-11','11:10:00',2.85),('9303','2013-09-11','11:15:00',2.68),('9303','2013-09-11','11:20:00',3.36),('9303','2013-09-11','11:25:00',2.75),('9303','2013-09-11','11:35:00',2.47),('9303','2013-09-11','11:40:00',3.01),('9303','2013-09-11','11:45:00',3.78),('9303','2013-09-11','11:50:00',3.83),('9303','2013-09-11','11:55:00',3.53),('9303','2013-09-11','12:00:00',2.12),('9303','2013-09-11','12:05:00',3.81),('9303','2013-09-11','12:10:00',2.89),('9303','2013-09-11','12:15:00',1.74),('9303','2013-09-11','12:20:00',2.99),('9303','2013-09-11','12:25:00',2.89),('9303','2013-09-11','12:30:00',3.39),('9303','2013-09-11','12:35:00',2.91),('9303','2013-09-11','12:45:00',1.61),('9303','2013-09-11','12:50:00',3.96),('9303','2013-09-11','12:55:00',1.89),('9303','2013-09-11','13:00:00',2.77),('9303','2013-09-11','13:05:00',4.07),('9303','2013-09-11','13:10:00',3.8),('9303','2013-09-11','13:15:00',3.91),('9303','2013-09-11','13:20:00',3.21),('9303','2013-09-11','13:25:00',3.78),('9303','2013-09-11','13:30:00',3.74),('9303','2013-09-11','13:35:00',1.67),('9303','2013-09-11','13:40:00',2.89),('9303','2013-09-11','13:45:00',2.22),('9303','2013-09-11','13:50:00',3.7),('9303','2013-09-11','13:55:00',2.62),('9303','2013-09-11','14:00:00',2.69),('9303','2013-09-11','14:05:00',3.98),('9303','2013-09-11','14:10:00',3.44),('9303','2013-09-11','14:15:00',3.84),('9303','2013-09-11','14:20:00',2.25),('9303','2013-09-11','14:25:00',3.45),('9303','2013-09-11','14:30:00',2.63),('9303','2013-09-11','14:35:00',3.47),('9303','2013-09-11','14:40:00',1.39),('9303','2013-09-11','14:45:00',3.13),('9303','2013-09-11','14:50:00',3.86),('9303','2013-09-11','14:55:00',3.46),('9303','2013-09-11','15:00:00',1.59),('9303','2013-09-11','15:05:00',3.73),('9303','2013-09-11','15:10:00',1.66),('9303','2013-09-11','15:15:00',3.55),('9303','2013-09-11','15:20:00',2.3),('9303','2013-09-11','15:25:00',3.22),('9303','2013-09-11','15:30:00',2.92),('9303','2013-09-11','15:35:00',1.35),('9303','2013-09-11','15:40:00',1.57),('9303','2013-09-11','15:45:00',2.57),('9303','2013-09-11','15:50:00',3.08),('9303','2013-09-11','15:55:00',1.91),('9303','2013-09-11','16:00:00',2.27),('9303','2013-09-11','16:05:00',2.98),('9303','2013-09-11','16:10:00',2.59),('9303','2013-09-11','16:15:00',2.66),('9303','2013-09-11','16:20:00',2.57),('9303','2013-09-11','16:25:00',2.4),('9303','2013-09-11','16:30:00',1.1),('9303','2013-09-11','16:35:00',2.07),('9303','2013-09-11','16:45:00',2.19),('9303','2013-09-11','16:50:00',1.94),('9303','2013-09-11','16:55:00',1.84),('9303','2013-09-11','17:00:00',1.72),('9303','2013-09-11','17:05:00',1.71),('9303','2013-09-11','17:10:00',1.63),('9303','2013-09-11','17:15:00',1.51),('9303','2013-09-11','17:20:00',1.41),('9303','2013-09-11','17:25:00',1.33),('9303','2013-09-11','17:30:00',1.24),('9303','2013-09-11','17:35:00',1.14),('9303','2013-09-11','17:40:00',1.07),('9303','2013-09-10','08:55:00',1.31),('9303','2013-09-10','09:00:00',1.65),('9303','2013-09-10','09:05:00',1.53),('9303','2013-09-10','09:10:00',2.13),('9303','2013-09-10','09:15:00',1.78),('9303','2013-09-10','09:20:00',1.44),('9303','2013-09-10','09:25:00',1.41),('9303','2013-09-10','09:30:00',2.33),('9303','2013-09-10','09:35:00',2.59),('9303','2013-09-10','09:40:00',1.45),('9303','2013-09-10','09:45:00',1.22),('9303','2013-09-10','09:50:00',1.11),('9303','2013-09-10','10:35:00',1.01),('9303','2013-09-10','10:40:00',1.35),('9303','2013-09-10','10:45:00',1.95),('9303','2013-09-10','10:50:00',1.17),('9303','2013-09-10','10:55:00',1.16),('9303','2013-09-10','11:00:00',1.47),('9303','2013-09-10','11:05:00',1.27),('9303','2013-09-10','11:10:00',1.29),('9303','2013-09-10','11:15:00',1.1),('9303','2013-09-10','11:20:00',1.17),('9303','2013-09-10','11:25:00',1.42),('9303','2013-09-10','11:30:00',1.01),('9303','2013-09-10','11:45:00',1.09),('9303','2013-09-10','11:50:00',1.17),('9303','2013-09-10','11:55:00',1.47),('9303','2013-09-10','12:00:00',1.31),('9303','2013-09-10','13:40:00',1.61),('9303','2013-09-10','13:45:00',2.59),('9303','2013-09-10','13:50:00',1.72),('9303','2013-09-10','13:55:00',1.47),('9303','2013-09-10','14:00:00',1.03),('9303','2013-09-10','14:05:00',1.21),('9303','2013-09-10','14:10:00',1.23),('9303','2013-09-10','14:15:00',1.5),('9303','2013-09-10','14:20:00',1.5),('9303','2013-09-10','14:25:00',2.06),('9303','2013-09-10','14:30:00',1.9),('9303','2013-09-10','14:35:00',1.34),('9303','2013-09-10','14:40:00',1.62),('9303','2013-09-10','14:45:00',1.7),('9303','2013-09-10','14:50:00',2.01),('9303','2013-09-10','14:55:00',1.84),('9303','2013-09-10','15:00:00',2.29),('9303','2013-09-10','15:05:00',2.17),('9303','2013-09-10','15:10:00',1.62),('9303','2013-09-10','15:15:00',1.44),('9303','2013-09-10','15:20:00',1.93),('9303','2013-09-10','15:25:00',1.69),('9303','2013-09-10','15:30:00',1.95),('9303','2013-09-10','15:35:00',1.79),('9303','2013-09-10','15:40:00',1.1),('9303','2013-09-10','16:05:00',1.03),('9303','2013-09-10','16:10:00',1.21),('9303','2013-09-10','16:15:00',1.36),('9303','2013-09-09','08:55:00',1.08),('9303','2013-09-09','09:00:00',1.14),('9303','2013-09-09','09:05:00',1.01),('9303','2013-09-09','10:00:00',1.06),('9303','2013-09-09','10:05:00',1.52),('9303','2013-09-09','10:10:00',1.59),('9303','2013-09-09','10:15:00',1.43),('9303','2013-09-09','10:20:00',1.25),('9303','2013-09-09','10:25:00',1.16),('9303','2013-09-09','10:30:00',1.3),('9303','2013-09-09','10:37:00',1.47),('9303','2013-09-09','10:40:00',1.65),('9303','2013-09-09','10:47:00',1.99),('9303','2013-09-09','10:50:00',2.55),('9303','2013-09-09','10:56:00',2.51),('9303','2013-09-09','11:00:00',2.57),('9303','2013-09-09','11:05:00',2.02),('9303','2013-09-09','11:10:00',1.51),('9303','2013-09-09','11:15:00',2),('9303','2013-09-09','11:20:00',2.32),('9303','2013-09-09','11:25:00',2.54),('9303','2013-09-09','11:30:00',2.01),('9303','2013-09-09','11:35:00',1.92),('9303','2013-09-09','11:40:00',2.89),('9303','2013-09-09','11:45:00',2.91),('9303','2013-09-09','11:50:00',2.21),('9303','2013-09-09','11:55:00',2.79),('9303','2013-09-09','12:00:00',2.19),('9303','2013-09-09','12:05:00',3.03),('9303','2013-09-09','12:10:00',2.81),('9303','2013-09-09','12:15:00',2.25),('9303','2013-09-09','12:20:00',1.59),('9303','2013-09-09','12:25:00',1.12),('9303','2013-09-09','12:40:00',1.11),('9303','2013-09-09','12:45:00',1.44),('9303','2013-09-09','12:50:00',1.14),('9303','2013-09-09','12:55:00',1.29),('9303','2013-09-09','13:00:00',1.25),('9303','2013-09-09','13:05:00',2.16),('9303','2013-09-09','13:10:00',2.06),('9303','2013-09-09','13:15:00',2.97),('9303','2013-09-09','13:20:00',2.83),('9303','2013-09-09','13:25:00',2.34),('9303','2013-09-09','13:30:00',3.01),('9303','2013-09-09','13:35:00',3.65),('9303','2013-09-09','13:40:00',3.21),('9303','2013-09-09','13:45:00',3.67),('9303','2013-09-09','13:50:00',3.64),('9303','2013-09-09','13:55:00',3.61),('9303','2013-09-09','14:00:00',3.46),('9303','2013-09-09','14:05:00',3.33),('9303','2013-09-09','14:10:00',3.77),('9303','2013-09-09','14:15:00',2.48),('9303','2013-09-09','14:20:00',1.97),('9303','2013-09-09','14:25:00',1.54),('9303','2013-09-09','14:30:00',1.49),('9303','2013-09-09','14:35:00',3.6),('9303','2013-09-09','14:40:00',3.53),('9303','2013-09-09','14:45:00',2.24),('9303','2013-09-09','14:50:00',2.78),('9303','2013-09-09','14:55:00',2.97),('9303','2013-09-09','15:00:00',2.43),('9303','2013-09-09','15:05:00',2.36),('9303','2013-09-09','15:10:00',2.69),('9303','2013-09-09','15:15:00',1.33),('9303','2013-09-09','15:20:00',1.93),('9303','2013-09-09','15:25:00',1.03),('9303','2013-09-09','15:30:00',2.78),('9303','2013-09-09','15:35:00',2.02),('9303','2013-09-09','15:40:00',2.51),('9303','2013-09-09','15:45:00',1.04),('9303','2013-09-09','15:50:00',1.09),('9303','2013-09-09','15:55:00',1.16),('9303','2013-09-09','16:00:00',1.36),('9303','2013-09-09','16:05:00',1.23),('9303','2013-09-09','16:10:00',1.44),('9303','2013-09-09','16:15:00',2.1),('9303','2013-09-09','16:20:00',1.57),('9303','2013-09-09','16:35:00',1.06),('9303','2013-09-09','16:40:00',1.23),('9303','2013-09-09','16:45:00',1.89),('9303','2014-04-12','09:15:00',1.3),('9303','2014-04-12','09:20:00',1.93),('9303','2014-04-12','09:25:00',2.37),('9303','2014-04-12','09:30:00',1.73),('9303','2014-04-12','09:35:00',1.51),('9303','2014-04-12','09:40:00',1.32),('9303','2014-04-12','09:45:00',1.22),('9303','2014-04-12','09:50:00',1.27),('9303','2014-04-12','09:55:00',1.29),('9303','2014-04-12','10:00:00',1.29),('9303','2014-04-12','10:05:00',1.31),('9303','2014-04-12','10:10:00',1.42),('9303','2014-04-12','10:15:00',1.51),('9303','2014-04-12','10:20:00',1.69),('9303','2014-04-12','10:25:00',1.87),('9303','2014-04-12','10:30:00',1.93),('9303','2014-04-12','10:35:00',2.23),('9303','2014-04-12','10:40:00',2.16),('9303','2014-04-12','10:45:00',2.35),('9303','2014-04-12','10:50:00',2.63),('9303','2014-04-12','10:55:00',1.83),('9303','2014-04-12','11:00:00',1.63),('9303','2014-04-12','11:05:00',3.09),('9303','2014-04-12','11:10:00',3.04),('9303','2014-04-12','11:15:00',4.07),('9303','2014-04-12','11:20:00',3.84),('9303','2014-04-12','11:25:00',2.76),('9303','2014-04-12','11:30:00',3.27),('9303','2014-04-12','11:35:00',3.45),('9303','2014-04-12','11:40:00',3.68),('9303','2014-04-12','11:45:00',3.69),('9303','2014-04-12','11:50:00',3.16),('9303','2014-04-12','11:55:00',3.04),('9303','2014-04-12','12:00:00',2.4),('9303','2014-04-12','12:05:00',1.78),('9303','2014-04-12','12:10:00',3.08),('9303','2014-04-12','12:15:00',2.36),('9303','2014-04-12','12:20:00',1.97),('9303','2014-04-12','12:25:00',2.77),('9303','2014-04-12','12:30:00',2.5),('9303','2014-04-12','12:35:00',2.59),('9303','2014-04-12','12:40:00',2.85),('9303','2014-04-12','12:45:00',3.28),('9303','2014-04-12','12:50:00',2.15),('9303','2014-04-12','12:55:00',1.53),('9303','2014-04-12','13:00:00',1.62),('9303','2014-04-12','13:05:00',2.68),('9303','2014-04-12','13:10:00',2.77),('9303','2014-04-12','13:15:00',3.76),('9303','2014-04-12','13:20:00',4.06),('9303','2014-04-12','13:25:00',2.61),('9303','2014-04-12','13:30:00',4.39),('9303','2014-04-12','13:35:00',3.01),('9303','2014-04-12','13:40:00',1.49),('9303','2014-04-12','13:45:00',1.85),('9303','2014-04-12','13:50:00',4.38),('9303','2014-04-12','13:55:00',2.11),('9303','2014-04-12','14:00:00',2.47),('9303','2014-04-12','14:05:00',2.71),('9303','2014-04-12','14:10:00',3.99),('9303','2014-04-12','14:15:00',4.13),('9303','2014-04-12','14:20:00',3.03),('9303','2014-04-12','14:25:00',3.74),('9303','2014-04-12','14:30:00',3.19),('9303','2014-04-12','14:35:00',1.76),('9303','2014-04-12','14:40:00',1.46),('9303','2014-04-12','14:45:00',1.91),('9303','2014-04-12','14:50:00',3.27),('9303','2014-04-12','14:55:00',3.06),('9303','2014-04-12','15:00:00',3),('9303','2014-04-12','15:05:00',3.48),('9303','2014-04-12','15:10:00',3.47),('9303','2014-04-12','15:15:00',3.29),('9303','2014-04-12','15:20:00',2.79),('9303','2014-04-12','15:25:00',2.53),('9303','2014-04-12','15:30:00',1.81),('9303','2014-04-12','15:35:00',2.46),('9303','2014-04-12','15:40:00',2.9),('9303','2014-04-12','15:45:00',3.08),('9303','2014-04-12','15:50:00',3.38),('9303','2014-04-12','15:55:00',3.3),('9303','2014-04-12','16:00:00',3.27),('9303','2014-04-12','16:05:00',3.21),('9303','2014-04-12','16:10:00',3.17),('9303','2014-04-12','16:15:00',2.96),('9303','2014-04-12','16:20:00',3.13),('9303','2014-04-12','16:25:00',2.84),('9303','2014-04-12','16:30:00',2.75),('9303','2014-04-12','16:35:00',2.62),('9303','2014-04-12','16:40:00',2.12),('9303','2014-04-12','16:45:00',2.04),('9303','2014-04-12','16:50:00',1.28),('9303','2014-04-12','16:55:00',1.89),('9303','2014-04-12','17:00:00',2.08),('9303','2014-04-12','17:05:00',1.98),('9303','2014-04-12','17:10:00',1.95),('9303','2014-04-12','17:15:00',1.83),('9303','2014-04-12','17:20:00',1.47),('9303','2014-04-12','17:25:00',1.4),('9303','2014-04-12','17:30:00',1.52),('9303','2014-04-12','17:35:00',1.3),('9303','2014-04-12','17:40:00',1.22),('9303','2014-04-12','17:45:00',1.55),('9303','2014-04-12','17:50:00',1.45),('9303','2014-04-12','17:55:00',1.18),('9303','2013-09-08','09:15:00',1.06),('9303','2013-09-08','09:20:00',1.62),('9303','2013-09-08','09:25:00',2.31),('9303','2013-09-08','09:30:00',2.36),('9303','2013-09-08','09:35:00',2.2),('9303','2013-09-08','09:40:00',2.2),('9303','2013-09-08','09:45:00',2.23),('9303','2013-09-08','09:50:00',2.24),('9303','2013-09-08','09:55:00',2.29),('9303','2013-09-08','10:00:00',2.36),('9303','2013-09-08','10:05:00',2.41),('9303','2013-09-08','10:10:00',2.53),('9303','2013-09-08','10:15:00',2.55),('9303','2013-09-08','10:20:00',2.58),('9303','2013-09-08','10:25:00',2.64),('9303','2013-09-08','10:30:00',2.66),('9303','2013-09-08','10:35:00',2.76),('9303','2013-09-08','10:40:00',2.79),('9303','2013-09-08','10:45:00',2.87),('9303','2013-09-08','10:50:00',2.93),('9303','2013-09-08','10:55:00',2.96),('9303','2013-09-08','11:00:00',3.02),('9303','2013-09-08','11:05:00',3),('9303','2013-09-08','11:10:00',2.98),('9303','2013-09-08','11:15:00',2.89),('9303','2013-09-08','11:20:00',3.01),('9303','2013-09-08','11:25:00',2.98),('9303','2013-09-08','11:30:00',3.12),('9303','2013-09-08','11:35:00',3.19),('9303','2013-09-08','11:40:00',3.16),('9303','2013-09-08','11:45:00',3.12),('9303','2013-09-08','11:50:00',3.19),('9303','2013-09-08','11:55:00',3.22),('9303','2013-09-08','12:00:00',3.21),('9303','2013-09-08','12:05:00',3.21),('9303','2013-09-08','12:10:00',3.21),('9303','2013-09-08','12:15:00',3.36),('9303','2013-09-08','12:20:00',3.37),('9303','2013-09-08','12:25:00',3.23),('9303','2013-09-08','12:30:00',3.43),('9303','2013-09-08','12:35:00',3.43),('9303','2013-09-08','12:40:00',3.31),('9303','2013-09-08','12:45:00',3.32),('9303','2013-09-08','12:50:00',3.35),('9303','2013-09-08','12:55:00',3.4),('9303','2013-09-08','13:00:00',3.36),('9303','2013-09-08','13:05:00',3.43),('9303','2013-09-08','13:10:00',3.45),('9303','2013-09-08','13:15:00',3.34),('9303','2013-09-08','13:20:00',3.33),('9303','2013-09-08','13:25:00',3.14),('9303','2013-09-08','13:30:00',3),('9303','2013-09-08','13:35:00',3.01),('9303','2013-09-08','13:40:00',2.3),('9303','2013-09-08','13:45:00',2),('9303','2013-09-08','13:50:00',2.33),('9303','2013-09-08','13:55:00',2.47),('9303','2013-09-08','14:00:00',3.07),('9303','2013-09-08','14:05:00',3.13),('9303','2013-09-08','14:10:00',3.27),('9303','2013-09-08','14:15:00',3.05),('9303','2013-09-08','14:20:00',2.92),('9303','2013-09-08','14:25:00',3.66),('9303','2013-09-08','14:30:00',3.21),('9303','2013-09-08','14:35:00',3.45),('9303','2013-09-08','14:40:00',3.33),('9303','2013-09-08','14:45:00',3.34),('9303','2013-09-08','14:50:00',3.28),('9303','2013-09-08','14:55:00',3.23),('9303','2013-09-08','15:00:00',3.21),('9303','2013-09-08','15:05:00',2.69),('9303','2013-09-08','15:10:00',1.71),('9303','2013-09-08','15:15:00',2.41),('9303','2013-09-08','15:20:00',3),('9303','2013-09-08','15:25:00',3.04),('9303','2013-09-08','15:30:00',3.06),('9303','2013-09-08','15:35:00',2.96),('9303','2013-09-08','15:40:00',2.75),('9303','2013-09-08','15:45:00',2.76),('9303','2013-09-08','15:50:00',2.77),('9303','2013-09-08','15:55:00',2.21),('9303','2013-09-08','16:00:00',2.3),('9303','2013-09-08','16:05:00',2.26),('9303','2013-09-08','16:10:00',2.07),('9303','2013-09-08','16:15:00',2.27),('9303','2013-09-08','16:20:00',2.18),('9303','2013-09-08','16:25:00',2.12),('9303','2013-09-08','16:30:00',2.11),('9303','2013-09-08','16:35:00',1.98),('9303','2013-09-08','16:40:00',1.64),('9303','2013-09-08','16:45:00',1.02),('9303','2013-09-08','16:50:00',1.09),('9303','2013-09-08','17:00:00',1.07),('9303','2013-09-08','17:05:00',1.74),('9303','2013-09-08','17:10:00',1.65),('9303','2013-09-08','17:15:00',1.5),('9303','2013-09-08','17:20:00',1.3),('9303','2013-09-08','17:25:00',1.24),('9303','2013-09-08','17:30:00',1.14),('9303','2013-09-07','08:25:00',1.06),('9303','2013-09-07','08:30:00',1.14),('9303','2013-09-07','08:35:00',1.23),('9303','2013-09-07','08:40:00',1.32),('9303','2013-09-07','08:45:00',1.39),('9303','2013-09-07','08:50:00',1.49),('9303','2013-09-07','08:55:00',1.57),('9303','2013-09-07','09:00:00',1.66),('9303','2013-09-07','09:05:00',1.74),('9303','2013-09-07','09:10:00',1.82),('9303','2013-09-07','09:15:00',1.9),('9303','2013-09-07','09:20:00',1.95),('9303','2013-09-07','09:25:00',2.04),('9303','2013-09-07','09:30:00',2.12),('9303','2013-09-07','09:35:00',2.17),('9303','2013-09-07','09:40:00',2.22),('9303','2013-09-07','09:45:00',2.29),('9303','2013-09-07','09:50:00',2.36),('9303','2013-09-07','09:55:00',2.42),('9303','2013-09-07','10:00:00',2.48),('9303','2013-09-07','10:05:00',2.55),('9303','2013-09-07','10:10:00',2.6),('9303','2013-09-07','10:15:00',2.61),('9303','2013-09-07','10:20:00',2.66),('9303','2013-09-07','10:25:00',2.72),('9303','2013-09-07','10:30:00',2.78),('9303','2013-09-07','10:35:00',2.84),('9303','2013-09-07','10:40:00',2.86),('9303','2013-09-07','10:45:00',2.91),('9303','2013-09-07','10:50:00',2.96),('9303','2013-09-07','10:55:00',3.01),('9303','2013-09-07','11:00:00',3.03),('9303','2013-09-07','11:05:00',3.07),('9303','2013-09-07','11:10:00',3.12),('9303','2013-09-07','11:15:00',3.12),('9303','2013-09-07','11:20:00',3.24),('9303','2013-09-07','11:25:00',3.3),('9303','2013-09-07','11:30:00',3.34),('9303','2013-09-07','11:35:00',3.34),('9303','2013-09-07','11:40:00',3.38),('9303','2013-09-07','11:45:00',3.43),('9303','2013-09-07','11:50:00',3.44),('9303','2013-09-07','11:55:00',3.43),('9303','2013-09-07','12:00:00',3.45),('9303','2013-09-07','12:05:00',3.45),('9303','2013-09-07','12:10:00',3.44),('9303','2013-09-07','12:15:00',3.46),('9303','2013-09-07','12:20:00',3.52),('9303','2013-09-07','12:25:00',3.53),('9303','2013-09-07','12:30:00',3.55),('9303','2013-09-07','12:35:00',3.57),('9303','2013-09-07','12:40:00',3.52),('9303','2013-09-07','12:45:00',3.54),('9303','2013-09-07','12:50:00',3.57),('9303','2013-09-07','12:55:00',3.57),('9303','2013-09-07','13:00:00',3.64),('9303','2013-09-07','13:05:00',3.56),('9303','2013-09-07','13:10:00',3.53),('9303','2013-09-07','13:15:00',3.56),('9303','2013-09-07','13:20:00',3.52),('9303','2013-09-07','13:25:00',3.43),('9303','2013-09-07','13:30:00',3.56),('9303','2013-09-07','13:35:00',3.61),('9303','2013-09-07','13:40:00',3.53),('9303','2013-09-07','13:45:00',3.59),('9303','2013-09-07','13:50:00',3.58),('9303','2013-09-07','13:55:00',3.17),('9303','2013-09-07','14:00:00',1.84),('9303','2013-09-07','14:05:00',3.63),('9303','2013-09-07','14:10:00',3.6),('9303','2013-09-07','14:15:00',3.55),('9303','2013-09-07','14:20:00',3.43),('9303','2013-09-07','14:25:00',3.39),('9303','2013-09-07','14:30:00',3.42),('9303','2013-09-07','14:35:00',3.42),('9303','2013-09-07','14:40:00',3.41),('9303','2013-09-07','14:45:00',3.37),('9303','2013-09-07','14:50:00',3.32),('9303','2013-09-07','14:55:00',3.3),('9303','2013-09-07','15:00:00',3.28),('9303','2013-09-07','15:05:00',3.25),('9303','2013-09-07','15:10:00',3.16),('9303','2013-09-07','15:15:00',3.15),('9303','2013-09-07','15:20:00',3.09),('9303','2013-09-07','15:25:00',3.05),('9303','2013-09-07','15:30:00',3),('9303','2013-09-07','15:35:00',2.95),('9303','2013-09-07','15:40:00',2.86),('9303','2013-09-07','15:45:00',2.81),('9303','2013-09-07','15:50:00',2.76),('9303','2013-09-07','15:55:00',2.7),('9303','2013-09-07','16:00:00',2.65),('9303','2013-09-07','16:05:00',2.58),('9303','2013-09-07','16:10:00',2.51),('9303','2013-09-07','16:15:00',2.45),('9303','2013-09-07','16:20:00',2.37),('9303','2013-09-07','16:25:00',2.28),('9303','2013-09-07','16:30:00',2.23),('9303','2013-09-07','16:35:00',2.14),('9303','2013-09-07','16:40:00',2.02),('9303','2013-09-07','16:45:00',1.92),('9303','2013-09-07','16:50:00',1.83),('9303','2013-09-07','16:55:00',1.76),('9303','2013-09-07','17:00:00',1.69),('9303','2013-09-07','17:05:00',1.62),('9303','2013-09-07','17:10:00',1.54),('9303','2013-09-07','17:15:00',1.46),('9303','2013-09-07','17:20:00',1.37),('9303','2013-09-07','17:25:00',1.27),('9303','2013-09-07','17:30:00',1.18),('9303','2013-09-07','17:35:00',1.13),('9303','2013-09-07','17:40:00',1.03),('9303','2013-09-06','08:20:00',1),('9303','2013-09-06','08:25:00',1.09),('9303','2013-09-06','08:30:00',1.17),('9303','2013-09-06','08:35:00',1.28),('9303','2013-09-06','08:40:00',1.37),('9303','2013-09-06','08:45:00',1.46),('9303','2013-09-06','08:50:00',1.55),('9303','2013-09-06','08:55:00',1.64),('9303','2013-09-06','09:00:00',1.73),('9303','2013-09-06','09:05:00',1.8),('9303','2013-09-06','09:10:00',1.86),('9303','2013-09-06','09:15:00',1.93),('9303','2013-09-06','09:20:00',2),('9303','2013-09-06','09:25:00',2.05),('9303','2013-09-06','09:30:00',2.13),('9303','2013-09-06','09:35:00',2.19),('9303','2013-09-06','09:40:00',2.25),('9303','2013-09-06','09:45:00',2.32),('9303','2013-09-06','09:50:00',2.4),('9303','2013-09-06','09:55:00',2.46),('9303','2013-09-06','10:00:00',2.52),('9303','2013-09-06','10:05:00',2.57),('9303','2013-09-06','10:10:00',2.62),('9303','2013-09-06','10:15:00',2.68),('9303','2013-09-06','10:20:00',2.75),('9303','2013-09-06','10:25:00',2.81),('9303','2013-09-06','10:30:00',2.87),('9303','2013-09-06','10:35:00',2.91),('9303','2013-09-06','10:40:00',2.97),('9303','2013-09-06','10:45:00',2.99),('9303','2013-09-06','10:50:00',3.05),('9303','2013-09-06','10:55:00',3.09),('9303','2013-09-06','11:00:00',3.15),('9303','2013-09-06','11:05:00',3.16),('9303','2013-09-06','11:10:00',3.19),('9303','2013-09-06','11:15:00',3.22),('9303','2013-09-06','11:20:00',3.26),('9303','2013-09-06','11:25:00',3.3),('9303','2013-09-06','11:30:00',3.32),('9303','2013-09-06','11:35:00',3.35),('9303','2013-09-06','11:40:00',3.36),('9303','2013-09-06','11:45:00',3.41),('9303','2013-09-06','11:50:00',3.42),('9303','2013-09-06','11:55:00',3.45),('9303','2013-09-06','12:00:00',3.47),('9303','2013-09-06','12:05:00',3.44),('9303','2013-09-06','12:10:00',3.48),('9303','2013-09-06','12:15:00',3.52),('9303','2013-09-06','12:20:00',3.55),('9303','2013-09-06','12:25:00',3.59),('9303','2013-09-06','12:30:00',3.58),('9303','2013-09-06','12:35:00',3.61),('9303','2013-09-06','12:40:00',3.58),('9303','2013-09-06','12:45:00',3.53),('9303','2013-09-06','12:50:00',3.55),('9303','2013-09-06','12:55:00',3.61),('9303','2013-09-06','13:00:00',3.63),('9303','2013-09-06','13:05:00',3.61),('9303','2013-09-06','13:10:00',3.58),('9303','2013-09-06','13:15:00',3.56),('9303','2013-09-06','13:20:00',3.57),('9303','2013-09-06','13:25:00',3.55),('9303','2013-09-06','13:30:00',3.54),('9303','2013-09-06','13:35:00',3.51),('9303','2013-09-06','13:40:00',3.49),('9303','2013-09-06','13:45:00',3.5),('9303','2013-09-06','13:50:00',3.5),('9303','2013-09-06','13:55:00',3.48),('9303','2013-09-06','14:00:00',3.46),('9303','2013-09-06','14:05:00',3.44),('9303','2013-09-06','14:10:00',3.42),('9303','2013-09-06','14:15:00',3.4),('9303','2013-09-06','14:20:00',3.37),('9303','2013-09-06','14:25:00',3.35),('9303','2013-09-06','14:30:00',3.34),('9303','2013-09-06','14:35:00',3.21),('9303','2013-09-06','14:40:00',3.19),('9303','2013-09-06','14:45:00',3.26),('9303','2013-09-06','14:50:00',3.29),('9303','2013-09-06','14:55:00',3.26),('9303','2013-09-06','15:00:00',3.22),('9303','2013-09-06','15:05:00',3.12),('9303','2013-09-06','15:10:00',3.09),('9303','2013-09-06','15:15:00',3.06),('9303','2013-09-06','15:20:00',3.03),('9303','2013-09-06','15:25:00',3),('9303','2013-09-06','15:30:00',2.95),('9303','2013-09-06','15:35:00',2.88),('9303','2013-09-06','15:40:00',2.84),('9303','2013-09-06','15:45:00',2.78),('9303','2013-09-06','15:50:00',2.73),('9303','2013-09-06','15:55:00',2.69),('9303','2013-09-06','16:00:00',2.63),('9303','2013-09-06','16:05:00',2.54),('9303','2013-09-06','16:10:00',2.48),('9303','2013-09-06','16:15:00',2.41),('9303','2013-09-06','16:20:00',2.35),('9303','2013-09-06','16:25:00',2.32),('9303','2013-09-06','16:30:00',2.24),('9303','2013-09-06','16:35:00',2.16),('9303','2013-09-06','16:40:00',2.05),('9303','2013-09-06','16:45:00',1.96),('9303','2013-09-06','16:50:00',1.85),('9303','2013-09-06','16:55:00',1.77),('9303','2013-09-06','17:00:00',1.72),('9303','2013-09-06','17:05:00',1.61),('9303','2013-09-06','17:10:00',1.56),('9303','2013-09-06','17:15:00',1.48),('9303','2013-09-06','17:20:00',1.39),('9303','2013-09-06','17:25:00',1.28),('9303','2013-09-06','17:30:00',1.17),('9303','2013-09-06','17:35:00',1.11),('9303','2013-09-06','17:40:00',1.04),('9303','2013-09-05','08:15:00',1.02),('9303','2013-09-05','08:20:00',1.11),('9303','2013-09-05','08:25:00',1.21),('9303','2013-09-05','08:30:00',1.31),('9303','2013-09-05','08:35:00',1.4),('9303','2013-09-05','08:40:00',1.49),('9303','2013-09-05','08:45:00',1.58),('9303','2013-09-05','08:50:00',1.67),('9303','2013-09-05','08:55:00',1.74),('9303','2013-09-05','09:00:00',1.83),('9303','2013-09-05','09:05:00',1.92),('9303','2013-09-05','09:10:00',2),('9303','2013-09-05','09:15:00',2.07),('9303','2013-09-05','09:20:00',2.14),('9303','2013-09-05','09:25:00',2.21),('9303','2013-09-05','09:30:00',2.29),('9303','2013-09-05','09:35:00',2.35),('9303','2013-09-05','09:40:00',2.4),('9303','2013-09-05','09:45:00',2.47),('9303','2013-09-05','09:50:00',2.54),('9303','2013-09-05','09:55:00',2.61),('9303','2013-09-05','10:00:00',2.67),('9303','2013-09-05','10:05:00',2.72),('9303','2013-09-05','10:10:00',2.75),('9303','2013-09-05','10:15:00',2.8),('9303','2013-09-05','10:20:00',2.86),('9303','2013-09-05','10:25:00',2.91),('9303','2013-09-05','10:30:00',2.95),('9303','2013-09-05','10:35:00',2.99),('9303','2013-09-05','10:40:00',3.05),('9303','2013-09-05','10:45:00',3.11),('9303','2013-09-05','10:50:00',3.14),('9303','2013-09-05','10:55:00',3.16),('9303','2013-09-05','11:00:00',3.24),('9303','2013-09-05','11:05:00',3.27),('9303','2013-09-05','11:10:00',3.29),('9303','2013-09-05','11:15:00',3.33),('9303','2013-09-05','11:20:00',3.37),('9303','2013-09-05','11:25:00',3.42),('9303','2013-09-05','11:30:00',3.43),('9303','2013-09-05','11:35:00',3.47),('9303','2013-09-05','11:40:00',3.45),('9303','2013-09-05','11:45:00',3.42),('9303','2013-09-05','11:50:00',3.51),('9303','2013-09-05','11:55:00',3.56),('9303','2013-09-05','12:00:00',3.56),('9303','2013-09-05','12:05:00',3.59),('9303','2013-09-05','12:10:00',3.61),('9303','2013-09-05','12:15:00',3.64),('9303','2013-09-05','12:20:00',3.65),('9303','2013-09-05','12:25:00',3.62),('9303','2013-09-05','12:30:00',3.62),('9303','2013-09-05','12:35:00',3.64),('9303','2013-09-05','12:40:00',3.68),('9303','2013-09-05','12:45:00',3.67),('9303','2013-09-05','12:50:00',3.68),('9303','2013-09-05','12:55:00',3.7),('9303','2013-09-05','13:00:00',3.72),('9303','2013-09-05','13:05:00',3.7),('9303','2013-09-05','13:10:00',3.69),('9303','2013-09-05','13:15:00',3.69),('9303','2013-09-05','13:20:00',3.69),('9303','2013-09-05','13:25:00',3.67),('9303','2013-09-05','13:30:00',3.68),('9303','2013-09-05','13:35:00',3.7),('9303','2013-09-05','13:40:00',3.67),('9303','2013-09-05','13:45:00',3.61),('9303','2013-09-05','13:50:00',3.63),('9303','2013-09-05','13:55:00',3.6),('9303','2013-09-05','14:00:00',3.59),('9303','2013-09-05','14:05:00',3.59),('9303','2013-09-05','14:10:00',3.55),('9303','2013-09-05','14:15:00',3.56),('9303','2013-09-05','14:20:00',3.54),('9303','2013-09-05','14:25:00',3.48),('9303','2013-09-05','14:30:00',3.44),('9303','2013-09-05','14:35:00',3.41),('9303','2013-09-05','14:40:00',3.32),('9303','2013-09-05','14:45:00',3.29),('9303','2013-09-05','14:50:00',3.28),('9303','2013-09-05','14:55:00',3.31),('9303','2013-09-05','15:00:00',3.29),('9303','2013-09-05','15:05:00',3.29),('9303','2013-09-05','15:10:00',3.25),('9303','2013-09-05','15:15:00',3.2),('9303','2013-09-05','15:20:00',3.15),('9303','2013-09-05','15:25:00',3.1),('9303','2013-09-05','15:30:00',3.05),('9303','2013-09-05','15:35:00',2.99),('9303','2013-09-05','15:40:00',2.95),('9303','2013-09-05','15:45:00',2.89),('9303','2013-09-05','15:50:00',2.81),('9303','2013-09-05','15:55:00',2.79),('9303','2013-09-05','16:00:00',2.74),('9303','2013-09-05','16:05:00',2.69),('9303','2013-09-05','16:10:00',2.63),('9303','2013-09-05','16:15:00',2.57),('9303','2013-09-05','16:20:00',2.51),('9303','2013-09-05','16:25:00',2.44),('9303','2013-09-05','16:30:00',2.37),('9303','2013-09-05','16:35:00',2.33),('9303','2013-09-05','16:40:00',2.24),('9303','2013-09-05','16:45:00',2.17),('9303','2013-09-05','16:50:00',1.88),('9303','2013-09-05','16:55:00',1.5),('9303','2013-09-05','17:00:00',1.14),('9303','2013-09-05','17:05:00',1.2),('9303','2013-09-05','17:10:00',1.27),('9303','2013-09-05','17:15:00',1.08),('9303','2013-09-05','17:20:00',1.21),('9303','2013-09-05','17:25:00',1.22),('9303','2013-09-05','17:30:00',1.17),('9303','2013-09-05','17:35:00',1.2),('9303','2013-09-05','17:40:00',1.29),('9303','2013-09-05','17:45:00',1.18),('9303','2013-09-05','17:50:00',1.03),('9303','2013-09-04','08:15:00',1),('9303','2013-09-04','08:20:00',1.11),('9303','2013-09-04','08:25:00',1.2),('9303','2013-09-04','08:30:00',1.3),('9303','2013-09-04','08:35:00',1.39),('9303','2013-09-04','08:40:00',1.48),('9303','2013-09-04','08:45:00',1.57),('9303','2013-09-04','08:50:00',1.67),('9303','2013-09-04','08:55:00',1.75),('9303','2013-09-04','09:00:00',1.84),('9303','2013-09-04','09:05:00',1.92),('9303','2013-09-04','09:10:00',2),('9303','2013-09-04','09:15:00',2.09),('9303','2013-09-04','09:20:00',2.17),('9303','2013-09-04','09:25:00',2.26),('9303','2013-09-04','09:30:00',2.33),('9303','2013-09-04','09:35:00',2.41),('9303','2013-09-04','09:40:00',2.47),('9303','2013-09-04','09:45:00',2.55),('9303','2013-09-04','09:50:00',2.61),('9303','2013-09-04','09:55:00',2.69),('9303','2013-09-04','10:00:00',2.76),('9303','2013-09-04','10:05:00',2.82),('9303','2013-09-04','10:10:00',2.87),('9303','2013-09-04','10:15:00',2.91),('9303','2013-09-04','10:20:00',2.96),('9303','2013-09-04','10:25:00',3),('9303','2013-09-04','10:30:00',3.06),('9303','2013-09-04','10:35:00',3.13),('9303','2013-09-04','10:40:00',3.16),('9303','2013-09-04','10:45:00',3.2),('9303','2013-09-04','10:50:00',3.25),('9303','2013-09-04','10:55:00',3.31),('9303','2013-09-04','11:00:00',3.35),('9303','2013-09-04','11:05:00',3.39),('9303','2013-09-04','11:10:00',3.43),('9303','2013-09-04','11:15:00',3.49),('9303','2013-09-04','11:20:00',3.51),('9303','2013-09-04','11:25:00',3.54),('9303','2013-09-04','11:30:00',3.54),('9303','2013-09-04','11:35:00',3.57),('9303','2013-09-04','11:40:00',3.63),('9303','2013-09-04','11:45:00',3.66),('9303','2013-09-04','11:50:00',3.7),('9303','2013-09-04','11:55:00',3.72),('9303','2013-09-04','12:00:00',3.76),('9303','2013-09-04','12:05:00',3.76),('9303','2013-09-04','12:10:00',3.79),('9303','2013-09-04','12:15:00',3.8),('9303','2013-09-04','12:20:00',3.82),('9303','2013-09-04','12:25:00',3.84),('9303','2013-09-04','12:30:00',3.84),('9303','2013-09-04','12:35:00',3.86),('9303','2013-09-04','12:40:00',3.84),('9303','2013-09-04','12:45:00',3.83),('9303','2013-09-04','12:50:00',3.85),('9303','2013-09-04','12:55:00',3.86),('9303','2013-09-04','13:00:00',3.84),('9303','2013-09-04','13:05:00',3.82),('9303','2013-09-04','13:10:00',3.84),('9303','2013-09-04','13:15:00',3.83),('9303','2013-09-04','13:20:00',3.82),('9303','2013-09-04','13:25:00',3.83),('9303','2013-09-04','13:30:00',3.83),('9303','2013-09-04','13:35:00',3.82),('9303','2013-09-04','13:40:00',3.82),('9303','2013-09-04','13:45:00',3.79),('9303','2013-09-04','13:50:00',3.78),('9303','2013-09-04','13:55:00',3.78),('9303','2013-09-04','14:00:00',3.75),('9303','2013-09-04','14:05:00',3.74),('9303','2013-09-04','14:10:00',3.71),('9303','2013-09-04','14:15:00',3.69),('9303','2013-09-04','14:20:00',3.66),('9303','2013-09-04','14:25:00',3.65),('9303','2013-09-04','14:30:00',3.63),('9303','2013-09-04','14:35:00',3.6),('9303','2013-09-04','14:40:00',3.56),('9303','2013-09-04','14:45:00',3.52),('9303','2013-09-04','14:50:00',3.49),('9303','2013-09-04','14:55:00',3.44),('9303','2013-09-04','15:00:00',3.4),('9303','2013-09-04','15:05:00',3.37),('9303','2013-09-04','15:10:00',3.33),('9303','2013-09-04','15:15:00',3.3),('9303','2013-09-04','15:20:00',3.25),('9303','2013-09-04','15:25:00',3.19),('9303','2013-09-04','15:30:00',3.14),('9303','2013-09-04','15:35:00',3.07),('9303','2013-09-04','15:40:00',3.02),('9303','2013-09-04','15:45:00',2.96),('9303','2013-09-04','15:50:00',2.91),('9303','2013-09-04','15:55:00',2.84),('9303','2013-09-04','16:00:00',2.78),('9303','2013-09-04','16:05:00',2.71),('9303','2013-09-04','16:10:00',2.65),('9303','2013-09-04','16:15:00',2.6),('9303','2013-09-04','16:20:00',2.53),('9303','2013-09-04','16:25:00',2.46),('9303','2013-09-04','16:30:00',2.41),('9303','2013-09-04','16:35:00',2.33),('9303','2013-09-04','16:40:00',2.23),('9303','2013-09-04','16:45:00',2.11),('9303','2013-09-04','16:50:00',2),('9303','2013-09-04','16:55:00',1.92),('9303','2013-09-04','17:00:00',1.84),('9303','2013-09-04','17:05:00',1.76),('9303','2013-09-04','17:10:00',1.68),('9303','2013-09-04','17:15:00',1.61),('9303','2013-09-04','17:20:00',1.54),('9303','2013-09-04','17:25:00',1.45),('9303','2013-09-04','17:30:00',1.35),('9303','2013-09-04','17:35:00',1.26),('9303','2013-09-04','17:40:00',1.17),('9303','2013-09-04','17:45:00',1.08),('9303','2013-09-03','08:25:00',1.07),('9303','2013-09-03','08:30:00',1.17),('9303','2013-09-03','08:35:00',1.27),('9303','2013-09-03','08:40:00',1.33),('9303','2013-09-03','08:45:00',1.44),('9303','2013-09-03','08:50:00',1.53),('9303','2013-09-03','08:55:00',1.61),('9303','2013-09-03','09:00:00',1.69),('9303','2013-09-03','09:05:00',1.77),('9303','2013-09-03','09:10:00',1.86),('9303','2013-09-03','09:15:00',1.92),('9303','2013-09-03','09:20:00',2.02),('9303','2013-09-03','09:25:00',2.1),('9303','2013-09-03','09:30:00',2.17),('9303','2013-09-03','09:35:00',2.24),('9303','2013-09-03','09:40:00',2.3),('9303','2013-09-03','09:45:00',2.36),('9303','2013-09-03','09:50:00',2.43),('9303','2013-09-03','09:55:00',2.5),('9303','2013-09-03','10:00:00',2.55),('9303','2013-09-03','10:05:00',2.62),('9303','2013-09-03','10:10:00',2.67),('9303','2013-09-03','10:15:00',2.74),('9303','2013-09-03','10:20:00',2.8),('9303','2013-09-03','10:25:00',2.85),('9303','2013-09-03','10:30:00',2.93),('9303','2013-09-03','10:35:00',3.01),('9303','2013-09-03','10:40:00',3.09),('9303','2013-09-03','10:45:00',3.13),('9303','2013-09-03','10:50:00',3.16),('9303','2013-09-03','10:55:00',3.17),('9303','2013-09-03','11:00:00',3.2),('9303','2013-09-03','11:05:00',3.23),('9303','2013-09-03','11:10:00',3.3),('9303','2013-09-03','11:15:00',3.34),('9303','2013-09-03','11:20:00',3.38),('9303','2013-09-03','11:25:00',3.42),('9303','2013-09-03','11:30:00',3.44),('9303','2013-09-03','11:35:00',3.46),('9303','2013-09-03','11:40:00',3.48),('9303','2013-09-03','11:45:00',3.51),('9303','2013-09-03','11:50:00',3.56),('9303','2013-09-03','11:55:00',3.58),('9303','2013-09-03','12:00:00',3.57),('9303','2013-09-03','12:05:00',3.62),('9303','2013-09-03','12:10:00',3.64),('9303','2013-09-03','12:15:00',3.68),('9303','2013-09-03','12:20:00',3.71),('9303','2013-09-03','12:25:00',3.73),('9303','2013-09-03','12:30:00',3.75),('9303','2013-09-03','12:35:00',3.75),('9303','2013-09-03','12:40:00',3.77),('9303','2013-09-03','12:45:00',3.75),('9303','2013-09-03','12:50:00',3.75),('9303','2013-09-03','12:55:00',3.78),('9303','2013-09-03','13:00:00',3.78),('9303','2013-09-03','13:05:00',3.81),('9303','2013-09-03','13:10:00',3.82),('9303','2013-09-03','13:15:00',3.8),('9303','2013-09-03','13:20:00',3.76),('9303','2013-09-03','13:25:00',3.73),('9303','2013-09-03','13:30:00',3.75),('9303','2013-09-03','13:35:00',3.77),('9303','2013-09-03','13:40:00',3.7),('9303','2013-09-03','13:45:00',3.74),('9303','2013-09-03','13:50:00',3.73),('9303','2013-09-03','13:55:00',3.68),('9303','2013-09-03','14:00:00',3.6),('9303','2013-09-03','14:05:00',3.58),('9303','2013-09-03','14:10:00',3.61),('9303','2013-09-03','14:15:00',3.57),('9303','2013-09-03','14:20:00',3.56),('9303','2013-09-03','14:25:00',3.56),('9303','2013-09-03','14:30:00',3.57),('9303','2013-09-03','14:35:00',3.56),('9303','2013-09-03','14:40:00',3.54),('9303','2013-09-03','14:45:00',3.5),('9303','2013-09-03','14:50:00',3.51),('9303','2013-09-03','14:55:00',3.45),('9303','2013-09-03','15:00:00',3.35),('9303','2013-09-03','15:05:00',3.31),('9303','2013-09-03','15:10:00',3.27),('9303','2013-09-03','15:15:00',3.25),('9303','2013-09-03','15:20:00',3.19),('9303','2013-09-03','15:25:00',3.15),('9303','2013-09-03','15:30:00',3.07),('9303','2013-09-03','15:35:00',3.02),('9303','2013-09-03','15:40:00',2.94),('9303','2013-09-03','15:45:00',2.89),('9303','2013-09-03','15:50:00',2.85),('9303','2013-09-03','15:55:00',2.8),('9303','2013-09-03','16:00:00',2.78),('9303','2013-09-03','16:05:00',2.71),('9303','2013-09-03','16:10:00',2.62),('9303','2013-09-03','16:15:00',2.54),('9303','2013-09-03','16:20:00',2.49),('9303','2013-09-03','16:25:00',2.43),('9303','2013-09-03','16:30:00',2.35),('9303','2013-09-03','16:35:00',2.29),('9303','2013-09-03','16:40:00',2.19),('9303','2013-09-03','16:45:00',2.09),('9303','2013-09-03','16:50:00',1.99),('9303','2013-09-03','16:55:00',1.91),('9303','2013-09-03','17:00:00',1.84),('9303','2013-09-03','17:05:00',1.77),('9303','2013-09-03','17:10:00',1.7),('9303','2013-09-03','17:15:00',1.62),('9303','2013-09-03','17:20:00',1.55),('9303','2013-09-03','17:25:00',1.47),('9303','2013-09-03','17:30:00',1.37),('9303','2013-09-03','17:35:00',1.29),('9303','2013-09-03','17:40:00',1.21),('9303','2013-09-03','17:45:00',1.11),('9303','2013-09-03','17:50:00',1.03),('9303','2013-09-02','08:20:00',1.05),('9303','2013-09-02','08:25:00',1.12),('9303','2013-09-02','08:30:00',1.21),('9303','2013-09-02','08:35:00',1.31),('9303','2013-09-02','08:40:00',1.4),('9303','2013-09-02','08:45:00',1.5),('9303','2013-09-02','08:50:00',1.59),('9303','2013-09-02','08:55:00',1.67),('9303','2013-09-02','09:00:00',1.75),('9303','2013-09-02','09:05:00',1.83),('9303','2013-09-02','09:10:00',1.92),('9303','2013-09-02','09:15:00',2),('9303','2013-09-02','09:20:00',2.07),('9303','2013-09-02','09:25:00',2.15),('9303','2013-09-02','09:30:00',2.23),('9303','2013-09-02','09:35:00',2.3),('9303','2013-09-02','09:40:00',2.36),('9303','2013-09-02','09:45:00',2.44),('9303','2013-09-02','09:50:00',2.49),('9303','2013-09-02','09:55:00',2.53),('9303','2013-09-02','10:00:00',2.6),('9303','2013-09-02','10:05:00',2.67),('9303','2013-09-02','10:10:00',2.75),('9303','2013-09-02','10:15:00',2.83),('9303','2013-09-02','10:20:00',2.86),('9303','2013-09-02','10:25:00',2.92),('9303','2013-09-02','10:30:00',2.97),('9303','2013-09-02','10:35:00',3.02),('9303','2013-09-02','10:40:00',3.06),('9303','2013-09-02','10:45:00',3.08),('9303','2013-09-02','10:50:00',3.11),('9303','2013-09-02','10:55:00',3.17),('9303','2013-09-02','11:00:00',3.22),('9303','2013-09-02','11:05:00',3.25),('9303','2013-09-02','11:10:00',3.3),('9303','2013-09-02','11:15:00',3.34),('9303','2013-09-02','11:20:00',3.39),('9303','2013-09-02','11:25:00',3.39),('9303','2013-09-02','11:30:00',3.41),('9303','2013-09-02','11:35:00',3.43),('9303','2013-09-02','11:40:00',3.47),('9303','2013-09-02','11:45:00',3.49),('9303','2013-09-02','11:50:00',3.5),('9303','2013-09-02','11:55:00',3.52),('9303','2013-09-02','12:00:00',3.58),('9303','2013-09-02','12:05:00',3.61),('9303','2013-09-02','12:10:00',3.69),('9303','2013-09-02','12:15:00',3.67),('9303','2013-09-02','12:20:00',3.65),('9303','2013-09-02','12:25:00',3.62),('9303','2013-09-02','12:30:00',3.64),('9303','2013-09-02','12:35:00',3.67),('9303','2013-09-02','12:40:00',3.65),('9303','2013-09-02','12:45:00',3.64),('9303','2013-09-02','12:50:00',3.67),('9303','2013-09-02','12:55:00',3.72),('9303','2013-09-02','13:00:00',3.72),('9303','2013-09-02','13:05:00',3.71),('9303','2013-09-02','13:10:00',3.71),('9303','2013-09-02','13:15:00',3.68),('9303','2013-09-02','13:20:00',3.68),('9303','2013-09-02','13:25:00',3.69),('9303','2013-09-02','13:30:00',3.65),('9303','2013-09-02','13:35:00',3.67),('9303','2013-09-02','13:40:00',3.6),('9303','2013-09-02','13:45:00',2.61),('9303','2013-09-02','13:50:00',1.49),('9303','2013-09-02','13:55:00',3.79),('9303','2013-09-02','14:00:00',3.72),('9303','2013-09-02','14:05:00',3.42),('9303','2013-09-02','14:10:00',3.65),('9303','2013-09-02','14:15:00',3.67),('9303','2013-09-02','14:20:00',3.62),('9303','2013-09-02','14:25:00',3.61),('9303','2013-09-02','14:30:00',3.55),('9303','2013-09-02','14:35:00',3.5),('9303','2013-09-02','14:40:00',3.57),('9303','2013-09-02','14:45:00',3.56),('9303','2013-09-02','14:50:00',3.42),('9303','2013-09-02','15:00:00',2.49),('9303','2013-09-02','15:05:00',3),('9303','2013-09-02','15:10:00',3.32),('9303','2013-09-02','15:15:00',2.97),('9303','2013-09-02','15:25:00',3.01),('9303','2013-09-02','15:30:00',2.36),('9303','2013-09-02','15:35:00',1.67),('9303','2013-09-02','15:40:00',2.99),('9303','2013-09-02','15:45:00',3),('9303','2013-09-02','15:50:00',2.98),('9303','2013-09-02','15:55:00',2.91),('9303','2013-09-02','16:00:00',2.81),('9303','2013-09-02','16:05:00',2.7),('9303','2013-09-02','16:10:00',2.66),('9303','2013-09-02','16:15:00',2.65),('9303','2013-09-02','16:20:00',2.62),('9303','2013-09-02','16:25:00',2.51),('9303','2013-09-02','16:30:00',2.43),('9303','2013-09-02','16:35:00',2.34),('9303','2013-09-02','16:40:00',2.22),('9303','2013-09-02','16:45:00',2.1),('9303','2013-09-02','16:50:00',1.97),('9303','2013-09-02','16:55:00',1.84),('9303','2013-09-02','17:00:00',1.77),('9303','2013-09-02','17:06:00',1.71),('9303','2013-09-02','17:10:00',1.63),('9303','2013-09-02','17:15:00',1.56),('9303','2013-09-02','17:20:00',1.49),('9303','2013-09-02','17:25:00',1.41),('9303','2013-09-02','17:30:00',1.3),('9303','2013-09-02','17:35:00',1.22),('9303','2013-09-02','17:40:00',1.15),('9303','2013-09-02','17:45:00',1.06),('9303','2013-09-01','08:15:00',1.01),('9303','2013-09-01','08:20:00',1.11),('9303','2013-09-01','08:25:00',1.19),('9303','2013-09-01','08:30:00',1.24),('9303','2013-09-01','08:35:00',1.37),('9303','2013-09-01','08:40:00',1.47),('9303','2013-09-01','08:45:00',1.57),('9303','2013-09-01','08:50:00',1.65),('9303','2013-09-01','08:55:00',1.75),('9303','2013-09-01','09:00:00',1.81),('9303','2013-09-01','09:05:00',1.88),('9303','2013-09-01','09:10:00',1.97),('9303','2013-09-01','09:15:00',2.05),('9303','2013-09-01','09:20:00',2.13),('9303','2013-09-01','09:25:00',2.2),('9303','2013-09-01','09:30:00',2.27),('9303','2013-09-01','09:35:00',2.35),('9303','2013-09-01','09:40:00',2.42),('9303','2013-09-01','09:45:00',2.48),('9303','2013-09-01','09:50:00',2.56),('9303','2013-09-01','09:55:00',2.6),('9303','2013-09-01','10:00:00',2.67),('9303','2013-09-01','10:05:00',2.72),('9303','2013-09-01','10:10:00',2.77),('9303','2013-09-01','10:15:00',2.82),('9303','2013-09-01','10:20:00',2.87),('9303','2013-09-01','10:25:00',2.91),('9303','2013-09-01','10:30:00',2.99),('9303','2013-09-01','10:35:00',3.02),('9303','2013-09-01','10:40:00',3.08),('9303','2013-09-01','10:45:00',3.14),('9303','2013-09-01','10:50:00',3.17),('9303','2013-09-01','10:55:00',3.22),('9303','2013-09-01','11:00:00',3.27),('9303','2013-09-01','11:05:00',3.32),('9303','2013-09-01','11:10:00',3.35),('9303','2013-09-01','11:15:00',3.36),('9303','2013-09-01','11:20:00',3.38),('9303','2013-09-01','11:25:00',3.4),('9303','2013-09-01','11:30:00',3.44),('9303','2013-09-01','11:35:00',3.46),('9303','2013-09-01','11:40:00',3.55),('9303','2013-09-01','11:45:00',3.57),('9303','2013-09-01','11:50:00',3.59),('9303','2013-09-01','11:55:00',3.62),('9303','2013-09-01','12:00:00',3.63),('9303','2013-09-01','12:05:00',3.6),('9303','2013-09-01','12:10:00',3.63),('9303','2013-09-01','12:15:00',3.67),('9303','2013-09-01','12:20:00',3.69),('9303','2013-09-01','12:25:00',3.61),('9303','2013-09-01','12:30:00',3.7),('9303','2013-09-01','12:35:00',3.66),('9303','2013-09-01','12:40:00',3.69),('9303','2013-09-01','12:45:00',3.68),('9303','2013-09-01','12:50:00',3.69),('9303','2013-09-01','12:55:00',3.69),('9303','2013-09-01','13:00:00',3.75),('9303','2013-09-01','13:05:00',3.7),('9303','2013-09-01','13:10:00',3.72),('9303','2013-09-01','13:15:00',3.63),('9303','2013-09-01','13:20:00',3.79),('9303','2013-09-01','13:25:00',3.81),('9303','2013-09-01','13:30:00',3.86),('9303','2013-09-01','13:35:00',3.77),('9303','2013-09-01','13:40:00',3.76),('9303','2013-09-01','13:45:00',3.59),('9303','2013-09-01','13:50:00',3.13),('9303','2013-09-01','13:55:00',3.38),('9303','2013-09-01','14:00:00',2.89),('9303','2013-09-01','14:05:00',2.94),('9303','2013-09-01','14:10:00',3.31),('9303','2013-09-01','14:15:00',3.33),('9303','2013-09-01','14:20:00',3.01),('9303','2013-09-01','14:25:00',3.11),('9303','2013-09-01','14:30:00',3.16),('9303','2013-09-01','14:35:00',3.14),('9303','2013-09-01','14:40:00',3.12),('9303','2013-09-01','14:45:00',3.16),('9303','2013-09-01','14:50:00',3.17),('9303','2013-09-01','14:55:00',3.02),('9303','2013-09-01','15:00:00',3.02),('9303','2013-09-01','15:05:00',3.02),('9303','2013-09-01','15:10:00',3),('9303','2013-09-01','15:15:00',2.95),('9303','2013-09-01','15:20:00',2.82),('9303','2013-09-01','15:25:00',2.56),('9303','2013-09-01','15:30:00',2.1),('9303','2013-09-01','15:35:00',2.29),('9303','2013-09-01','15:40:00',2.63),('9303','2013-09-01','15:45:00',2.42),('9303','2013-09-01','15:50:00',1.9),('9303','2013-09-01','15:55:00',1.94),('9303','2013-09-01','16:00:00',2.45),('9303','2013-09-01','16:05:00',2.52),('9303','2013-09-01','16:10:00',2.64),('9303','2013-09-01','16:15:00',2.5),('9303','2013-09-01','16:20:00',2.38),('9303','2013-09-01','16:25:00',2.34),('9303','2013-09-01','16:30:00',2.51),('9303','2013-09-01','16:35:00',2.39),('9303','2013-09-01','16:40:00',2.32),('9303','2013-09-01','16:45:00',2.13),('9303','2013-09-01','16:50:00',1.98),('9303','2013-09-01','16:55:00',1.77),('9303','2013-09-01','17:00:00',1.48),('9303','2013-09-01','17:05:00',1.42),('9303','2013-09-01','17:10:00',1.22),('9303','2013-09-01','17:15:00',1.22),('9303','2013-09-01','17:20:00',1.35),('9303','2013-09-01','17:25:00',1.3),('9303','2013-09-01','17:30:00',1.16),('9303','2013-09-01','17:35:00',1.11),('9303','2013-09-01','17:40:00',1.15),('9303','2013-08-31','08:25:00',1.07),('9303','2013-08-31','08:30:00',1.31),('9303','2013-08-31','08:35:00',1.39),('9303','2013-08-31','08:40:00',1.51),('9303','2013-08-31','08:45:00',1.64),('9303','2013-08-31','08:50:00',1.81),('9303','2013-08-31','08:55:00',1.95),('9303','2013-08-31','09:00:00',2.06),('9303','2013-08-31','09:05:00',1.88),('9303','2013-08-31','09:10:00',1.54),('9303','2013-08-31','09:15:00',1.88),('9303','2013-08-31','09:20:00',2.13),('9303','2013-08-31','09:25:00',2.34),('9303','2013-08-31','09:30:00',2.39),('9303','2013-08-31','09:35:00',2.48),('9303','2013-08-31','09:40:00',2.52),('9303','2013-08-31','09:45:00',2.37),('9303','2013-08-31','09:50:00',2.44),('9303','2013-08-31','09:55:00',2.64),('9303','2013-08-31','10:00:00',2.79),('9303','2013-08-31','10:05:00',2.76),('9303','2013-08-31','10:10:00',2.89),('9303','2013-08-31','10:15:00',2.91),('9303','2013-08-31','10:20:00',2.98),('9303','2013-08-31','10:25:00',3.03),('9303','2013-08-31','10:30:00',3.09),('9303','2013-08-31','10:35:00',3.15),('9303','2013-08-31','10:40:00',3.16),('9303','2013-08-31','10:45:00',3.24),('9303','2013-08-31','10:50:00',3.33),('9303','2013-08-31','10:55:00',3.38),('9303','2013-08-31','11:00:00',3.42),('9303','2013-08-31','11:05:00',3.46),('9303','2013-08-31','11:10:00',3.49),('9303','2013-08-31','11:15:00',3.52),('9303','2013-08-31','11:20:00',3.57),('9303','2013-08-31','11:25:00',3.6),('9303','2013-08-31','11:30:00',3.64),('9303','2013-08-31','11:35:00',3.69),('9303','2013-08-31','11:40:00',3.73),('9303','2013-08-31','11:45:00',3.73),('9303','2013-08-31','11:50:00',3.75),('9303','2013-08-31','11:55:00',3.79),('9303','2013-08-31','12:00:00',3.8),('9303','2013-08-31','12:05:00',3.56),('9303','2013-08-31','12:10:00',3.82),('9303','2013-08-31','12:15:00',3.76),('9303','2013-08-31','12:20:00',3.75),('9303','2013-08-31','12:25:00',3.83),('9303','2013-08-31','12:30:00',3.82),('9303','2013-08-31','12:35:00',3.81),('9303','2013-08-31','12:40:00',3.82),('9303','2013-08-31','12:45:00',3.78),('9303','2013-08-31','12:50:00',3.81),('9303','2013-08-31','12:55:00',3.88),('9303','2013-08-31','13:00:00',3.86),('9303','2013-08-31','13:05:00',3.9),('9303','2013-08-31','13:10:00',3.86),('9303','2013-08-31','13:15:00',3.86),('9303','2013-08-31','13:20:00',3.82),('9303','2013-08-31','13:25:00',3.81),('9303','2013-08-31','13:30:00',3.79),('9303','2013-08-31','13:35:00',3.79),('9303','2013-08-31','13:40:00',3.76),('9303','2013-08-31','13:45:00',3.76),('9303','2013-08-31','13:50:00',3.77),('9303','2013-08-31','13:55:00',3.71),('9303','2013-08-31','14:00:00',3.72),('9303','2013-08-31','14:05:00',3.7),('9303','2013-08-31','14:10:00',3.68),('9303','2013-08-31','14:15:00',3.64),('9303','2013-08-31','14:20:00',3.56),('9303','2013-08-31','14:25:00',3.55),('9303','2013-08-31','14:30:00',3.56),('9303','2013-08-31','14:35:00',3.37),('9303','2013-08-31','14:40:00',3.4),('9303','2013-08-31','14:45:00',3.38),('9303','2013-08-31','14:50:00',3.42),('9303','2013-08-31','14:55:00',3.3),('9303','2013-08-31','15:00:00',3.26),('9303','2013-08-31','15:05:00',3.26),('9303','2013-08-31','15:10:00',3.24),('9303','2013-08-31','15:15:00',3.21),('9303','2013-08-31','15:20:00',3.12),('9303','2013-08-31','15:25:00',3.07),('9303','2013-08-31','15:30:00',3.05),('9303','2013-08-31','15:35:00',2.95),('9303','2013-08-31','15:40:00',2.95),('9303','2013-08-31','15:45:00',2.91),('9303','2013-08-31','15:50:00',2.85),('9303','2013-08-31','15:55:00',2.77),('9303','2013-08-31','16:00:00',2.71),('9303','2013-08-31','16:05:00',2.67),('9303','2013-08-31','16:10:00',2.62),('9303','2013-08-31','16:15:00',2.57),('9303','2013-08-31','16:20:00',2.49),('9303','2013-08-31','16:25:00',2.45),('9303','2013-08-31','16:30:00',2.34),('9303','2013-08-31','16:35:00',2.34),('9303','2013-08-31','16:40:00',2.24),('9303','2013-08-31','16:45:00',2.08),('9303','2013-08-31','16:50:00',1.98),('9303','2013-08-31','16:55:00',1.9),('9303','2013-08-31','17:00:00',1.82),('9303','2013-08-31','17:05:00',1.8),('9303','2013-08-31','17:10:00',1.75),('9303','2013-08-31','17:15:00',1.63),('9303','2013-08-31','17:20:00',1.54),('9303','2013-08-31','17:25:00',1.47),('9303','2013-08-31','17:30:00',1.36),('9303','2013-08-31','17:35:00',1.23),('9303','2013-08-31','17:40:00',1.19),('9303','2013-08-31','17:45:00',1.06),('9303','2013-08-31','17:50:00',1.02),('9303','2013-08-30','08:10:00',1.11),('9303','2013-08-30','08:15:00',1.06),('9303','2013-08-30','08:20:00',1.17),('9303','2013-08-30','08:25:00',1.21),('9303','2013-08-30','08:30:00',1.27),('9303','2013-08-30','08:35:00',1.35),('9303','2013-08-30','08:40:00',1.4),('9303','2013-08-30','08:45:00',1.26),('9303','2013-08-30','08:50:00',1.16),('9303','2013-08-30','08:55:00',1.15),('9303','2013-08-30','09:00:00',1.35),('9303','2013-08-30','09:05:00',1.47),('9303','2013-08-30','09:10:00',1.3),('9303','2013-08-30','09:15:00',1.21),('9303','2013-08-30','09:20:00',1.1),('9303','2013-08-30','09:25:00',1.17),('9303','2013-08-30','09:30:00',1.53),('9303','2013-08-30','09:35:00',1.61),('9303','2013-08-30','09:40:00',1.66),('9303','2013-08-30','09:45:00',1.69),('9303','2013-08-30','09:50:00',1.7),('9303','2013-08-30','09:55:00',1.77),('9303','2013-08-30','10:00:00',1.82),('9303','2013-08-30','10:05:00',1.78),('9303','2013-08-30','10:10:00',1.8),('9303','2013-08-30','10:15:00',1.92),('9303','2013-08-30','10:20:00',2),('9303','2013-08-30','10:25:00',1.85),('9303','2013-08-30','10:30:00',2.07),('9303','2013-08-30','10:35:00',1.98),('9303','2013-08-30','10:40:00',1.87),('9303','2013-08-30','10:45:00',1.8),('9303','2013-08-30','10:50:00',1.92),('9303','2013-08-30','10:55:00',1.82),('9303','2013-08-30','11:00:00',1.88),('9303','2013-08-30','11:05:00',2.02),('9303','2013-08-30','11:10:00',2.16),('9303','2013-08-30','11:15:00',2.19),('9303','2013-08-30','11:20:00',2.2),('9303','2013-08-30','11:25:00',2.28),('9303','2013-08-30','11:30:00',2.41),('9303','2013-08-30','11:35:00',2.3),('9303','2013-08-30','11:40:00',2.51),('9303','2013-08-30','11:45:00',2.46),('9303','2013-08-30','11:50:00',2.88),('9303','2013-08-30','11:55:00',2.5),('9303','2013-08-30','12:00:00',2.24),('9303','2013-08-30','12:05:00',1.89),('9303','2013-08-30','12:10:00',2.1),('9303','2013-08-30','12:15:00',2.28),('9303','2013-08-30','12:20:00',2.45),('9303','2013-08-30','12:25:00',2.86),('9303','2013-08-30','12:30:00',3.1),('9303','2013-08-30','12:35:00',2.98),('9303','2013-08-30','12:40:00',2.89),('9303','2013-08-30','12:45:00',3),('9303','2013-08-30','12:50:00',2.92),('9303','2013-08-30','12:55:00',2.74),('9303','2013-08-30','13:00:00',2.66),('9303','2013-08-30','13:05:00',2.63),('9303','2013-08-30','13:10:00',2.66),('9303','2013-08-30','13:15:00',2.69),('9303','2013-08-30','13:20:00',2.98),('9303','2013-08-30','13:25:00',3.52),('9303','2013-08-30','13:30:00',3.81),('9303','2013-08-30','13:35:00',3.54),('9303','2013-08-30','13:40:00',3.75),('9303','2013-08-30','13:45:00',3.38),('9303','2013-08-30','13:50:00',3.39),('9303','2013-08-30','13:55:00',3.67),('9303','2013-08-30','14:00:00',3.8),('9303','2013-08-30','14:05:00',3.64),('9303','2013-08-30','14:10:00',3.69),('9303','2013-08-30','14:15:00',3.6),('9303','2013-08-30','14:20:00',3.7),('9303','2013-08-30','14:25:00',3.65),('9303','2013-08-30','14:30:00',3.62),('9303','2013-08-30','14:35:00',3.64),('9303','2013-08-30','14:40:00',3.48),('9303','2013-08-30','14:45:00',2.91),('9303','2013-08-30','14:50:00',2.43),('9303','2013-08-30','14:55:00',2.71),('9303','2013-08-30','15:00:00',2.38),('9303','2013-08-30','15:05:00',2.18),('9303','2013-08-30','15:10:00',2.15),('9303','2013-08-30','15:15:00',2.72),('9303','2013-08-30','15:20:00',2.35),('9303','2013-08-30','15:25:00',2.13),('9303','2013-08-30','15:30:00',1.92),('9303','2013-08-30','15:35:00',1.67),('9303','2013-08-30','15:40:00',1.78),('9303','2013-08-30','15:45:00',2.09),('9303','2013-08-30','15:50:00',2.24),('9303','2013-08-30','15:55:00',2.18),('9303','2013-08-30','16:00:00',2.05),('9303','2013-08-30','16:05:00',1.81),('9303','2013-08-30','16:10:00',1.48),('9303','2013-08-30','16:15:00',1.37),('9303','2013-08-30','16:20:00',1.54),('9303','2013-08-30','16:25:00',1.55),('9303','2013-08-30','16:30:00',1.62),('9303','2013-08-30','16:35:00',1.77),('9303','2013-08-30','16:40:00',1.88),('9303','2013-08-30','16:45:00',1.84),('9303','2013-08-30','16:50:00',2),('9303','2013-08-30','16:55:00',1.32),('9303','2013-08-30','17:00:00',1.31),('9303','2013-08-30','17:05:00',1.15),('9303','2013-08-30','17:10:00',1.45),('9303','2013-08-30','17:15:00',1.25),('9303','2013-08-30','17:20:00',1.09),('9303','2013-08-30','17:25:00',1.09),('9303','2013-08-30','17:30:00',1.16),('9303','2013-08-30','17:35:00',1.31),('9303','2013-08-30','17:40:00',1.03),('9303','2013-08-30','17:45:00',1.19),('9303','2013-08-30','17:55:00',1.18),('9303','2014-04-11','08:30:00',1.16),('9303','2014-04-11','08:35:00',1.44),('9303','2014-04-11','08:40:00',1.68),('9303','2014-04-11','08:45:00',1.8),('9303','2014-04-11','08:50:00',1.86),('9303','2014-04-11','08:55:00',1.93),('9303','2014-04-11','09:00:00',1.98),('9303','2014-04-11','09:05:00',2.03),('9303','2014-04-11','09:10:00',2.1),('9303','2014-04-11','09:15:00',2.16),('9303','2014-04-11','09:20:00',2.26),('9303','2014-04-11','09:25:00',2.37),('9303','2014-04-11','09:30:00',2.43),('9303','2014-04-11','09:35:00',2.51),('9303','2014-04-11','09:40:00',2.54),('9303','2014-04-11','09:45:00',2.64),('9303','2014-04-11','09:50:00',2.69),('9303','2014-04-11','09:55:00',2.78),('9303','2014-04-11','10:00:00',2.88),('9303','2014-04-11','10:05:00',2.94),('9303','2014-04-11','10:10:00',3.02),('9303','2014-04-11','10:15:00',3.1),('9303','2014-04-11','10:20:00',3.13),('9303','2014-04-11','10:25:00',3.2),('9303','2014-04-11','10:30:00',3.25),('9303','2014-04-11','10:35:00',3.27),('9303','2014-04-11','10:40:00',3.34),('9303','2014-04-11','10:45:00',3.41),('9303','2014-04-11','10:50:00',3.49),('9303','2014-04-11','10:55:00',3.56),('9303','2014-04-11','11:00:00',3.62),('9303','2014-04-11','11:05:00',3.64),('9303','2014-04-11','11:10:00',3.68),('9303','2014-04-11','11:15:00',3.67),('9303','2014-04-11','11:20:00',3.79),('9303','2014-04-11','11:25:00',3.84),('9303','2014-04-11','11:30:00',3.85),('9303','2014-04-11','11:35:00',3.92),('9303','2014-04-11','11:40:00',3.84),('9303','2014-04-11','11:45:00',3.95),('9303','2014-04-11','11:50:00',3.99),('9303','2014-04-11','11:55:00',4.1),('9303','2014-04-11','12:00:00',4.28),('9303','2014-04-11','12:05:00',3.55),('9303','2014-04-11','12:10:00',3.17),('9303','2014-04-11','12:15:00',4.36),('9303','2014-04-11','12:20:00',3.98),('9303','2014-04-11','12:25:00',3.04),('9303','2014-04-11','12:30:00',4.32),('9303','2014-04-11','12:35:00',4.36),('9303','2014-04-11','12:40:00',2.65),('9303','2014-04-11','12:45:00',4.72),('9303','2014-04-11','12:50:00',4.57),('9303','2014-04-11','12:55:00',4.35),('9303','2014-04-11','13:00:00',3.85),('9303','2014-04-11','13:05:00',1.84),('9303','2014-04-11','13:10:00',2.64),('9303','2014-04-11','13:15:00',4.24),('9303','2014-04-11','13:20:00',3.32),('9303','2014-04-11','13:25:00',4.6),('9303','2014-04-11','13:30:00',2.22),('9303','2014-04-11','13:35:00',4.27),('9303','2014-04-11','13:40:00',4.43),('9303','2014-04-11','13:45:00',4.12),('9303','2014-04-11','13:50:00',3.76),('9303','2014-04-11','13:55:00',3.69),('9303','2014-04-11','14:00:00',2.99),('9303','2014-04-11','14:05:00',3.82),('9303','2014-04-11','14:10:00',3.75),('9303','2014-04-11','14:15:00',3.84),('9303','2014-04-11','14:20:00',3.48),('9303','2014-04-11','14:25:00',3.23),('9303','2014-04-11','14:30:00',4.15),('9303','2014-04-11','14:35:00',3.45),('9303','2014-04-11','14:40:00',4.09),('9303','2014-04-11','14:45:00',3.5),('9303','2014-04-11','14:50:00',4.27),('9303','2014-04-11','14:55:00',3.5),('9303','2014-04-11','15:00:00',3.45),('9303','2014-04-11','15:05:00',4.16),('9303','2014-04-11','15:10:00',3.96),('9303','2014-04-11','15:15:00',3.35),('9303','2014-04-11','15:20:00',3.51),('9303','2014-04-11','15:25:00',3.71),('9303','2014-04-11','15:30:00',3.54),('9303','2014-04-11','15:35:00',3.16),('9303','2014-04-11','15:40:00',2.76),('9303','2014-04-11','15:45:00',3.31),('9303','2014-04-11','15:50:00',3.28),('9303','2014-04-11','15:55:00',3.28),('9303','2014-04-11','16:00:00',3.15),('9303','2014-04-11','16:05:00',3.07),('9303','2014-04-11','16:10:00',3.02),('9303','2014-04-11','16:15:00',2.91),('9303','2014-04-11','16:20:00',2.81),('9303','2014-04-11','16:25:00',2.78),('9303','2014-04-11','16:30:00',2.73),('9303','2014-04-11','16:35:00',2.35),('9303','2014-04-11','16:40:00',2.37),('9303','2014-04-11','16:45:00',2.31),('9303','2014-04-11','16:50:00',1.57),('9303','2014-04-11','16:55:00',1.05),('9303','2014-04-11','17:00:00',2.29),('9303','2014-04-11','17:05:00',1.88),('9303','2014-04-11','17:10:00',2.06),('9303','2014-04-11','17:15:00',1.82),('9303','2014-04-11','17:20:00',1.77),('9303','2014-04-11','17:25:00',1.73),('9303','2014-04-11','17:30:00',1.75),('9303','2014-04-11','17:35:00',1.69),('9303','2014-04-11','17:40:00',1.6),('9303','2014-04-11','17:45:00',1.4),('9303','2014-04-11','17:50:00',1.24),('9303','2014-04-11','17:55:00',1.13),('9303','2014-04-11','18:00:00',1.01),('9303','2013-08-29','08:10:00',1.02),('9303','2013-08-29','08:15:00',1.12),('9303','2013-08-29','08:20:00',1.29),('9303','2013-08-29','08:25:00',1.46),('9303','2013-08-29','08:30:00',1.69),('9303','2013-08-29','08:35:00',1.67),('9303','2013-08-29','08:40:00',1.29),('9303','2013-08-29','08:50:00',1.16),('9303','2013-08-29','08:55:00',1.45),('9303','2013-08-29','09:00:00',1.47),('9303','2013-08-29','09:05:00',1.42),('9303','2013-08-29','09:10:00',1.39),('9303','2013-08-29','09:15:00',1.5),('9303','2013-08-29','09:20:00',1.5),('9303','2013-08-29','09:25:00',1.39),('9303','2013-08-29','09:30:00',1.43),('9303','2013-08-29','09:35:00',1.58),('9303','2013-08-29','09:40:00',1.63),('9303','2013-08-29','09:45:00',1.4),('9303','2013-08-29','09:50:00',1.34),('9303','2013-08-29','09:55:00',1.4),('9303','2013-08-29','10:00:00',1.49),('9303','2013-08-29','10:05:00',1.43),('9303','2013-08-29','10:10:00',1.4),('9303','2013-08-29','10:15:00',1.4),('9303','2013-08-29','10:20:00',1.41),('9303','2013-08-29','10:25:00',1.41),('9303','2013-08-29','10:30:00',1.45),('9303','2013-08-29','10:35:00',1.36),('9303','2013-08-29','10:40:00',1.25),('9303','2013-08-29','10:45:00',1.17),('9303','2013-08-29','10:50:00',1.14),('9303','2013-08-29','10:55:00',1.27),('9303','2013-08-29','11:00:00',1.37),('9303','2013-08-29','11:05:00',1.37),('9303','2013-08-29','11:10:00',2.02),('9303','2013-08-29','11:15:00',2.32),('9303','2013-08-29','11:20:00',2.18),('9303','2013-08-29','11:25:00',1.65),('9303','2013-08-29','11:30:00',1.46),('9303','2013-08-29','11:35:00',1.28),('9303','2013-08-29','11:40:00',1.44),('9303','2013-08-29','11:45:00',1.68),('9303','2013-08-29','11:50:00',1.76),('9303','2013-08-29','11:55:00',1.68),('9303','2013-08-29','12:00:00',1.66),('9303','2013-08-29','12:05:00',1.89),('9303','2013-08-29','12:10:00',2.36),('9303','2013-08-29','12:15:00',2.82),('9303','2013-08-29','12:20:00',2.52),('9303','2013-08-29','12:25:00',2.59),('9303','2013-08-29','12:30:00',2.49),('9303','2013-08-29','12:35:00',3.08),('9303','2013-08-29','12:40:00',4.16),('9303','2013-08-29','12:45:00',4.41),('9303','2013-08-29','12:50:00',2.68),('9303','2013-08-29','12:55:00',3.1),('9303','2013-08-29','13:00:00',2.63),('9303','2013-08-29','13:05:00',2.37),('9303','2013-08-29','13:10:00',2.35),('9303','2013-08-29','13:15:00',2.24),('9303','2013-08-29','13:20:00',2.25),('9303','2013-08-29','13:25:00',1.92),('9303','2013-08-29','13:30:00',1.73),('9303','2013-08-29','13:35:00',1.63),('9303','2013-08-29','13:40:00',1.56),('9303','2013-08-29','13:45:00',1.45),('9303','2013-08-29','13:50:00',1.41),('9303','2013-08-29','13:55:00',1.63),('9303','2013-08-29','14:00:00',2.18),('9303','2013-08-29','14:05:00',1.57),('9303','2013-08-29','14:10:00',1.42),('9303','2013-08-29','14:15:00',1.19),('9303','2013-08-29','14:50:00',1.08),('9303','2013-08-29','14:55:00',1.26),('9303','2013-08-29','15:00:00',1.41),('9303','2013-08-29','15:05:00',1.6),('9303','2013-08-29','15:10:00',1.3),('9303','2013-08-29','15:15:00',1.08),('9303','2013-08-29','15:20:00',1.18),('9303','2013-08-29','15:25:00',1.38),('9303','2013-08-29','15:30:00',2.2),('9303','2013-08-29','15:35:00',2.22),('9303','2013-08-29','15:40:00',2.06),('9303','2013-08-29','15:45:00',2.17),('9303','2013-08-29','15:50:00',2.75),('9303','2013-08-29','15:55:00',3.24),('9303','2013-08-29','16:00:00',3.1),('9303','2013-08-29','16:05:00',3.19),('9303','2013-08-29','16:10:00',3.13),('9303','2013-08-29','16:15:00',2.87),('9303','2013-08-29','16:20:00',2.72),('9303','2013-08-29','16:25:00',2.61),('9303','2013-08-29','16:30:00',2.48),('9303','2013-08-29','16:35:00',2.47),('9303','2013-08-29','16:40:00',2.38),('9303','2013-08-29','16:45:00',2.28),('9303','2013-08-29','16:50:00',2.16),('9303','2013-08-29','16:55:00',2.06),('9303','2013-08-29','17:00:00',1.98),('9303','2013-08-29','17:05:00',1.91),('9303','2013-08-29','17:10:00',1.83),('9303','2013-08-29','17:15:00',1.74),('9303','2013-08-29','17:20:00',1.64),('9303','2013-08-29','17:25:00',1.58),('9303','2013-08-29','17:30:00',1.51),('9303','2013-08-29','17:35:00',1.39),('9303','2013-08-29','17:40:00',1.3),('9303','2013-08-29','17:45:00',1.2),('9303','2013-08-29','17:50:00',1.1),('9303','2013-08-29','17:55:00',1.03),('9303','2013-08-28','08:15:00',1.05),('9303','2013-08-28','08:20:00',1.14),('9303','2013-08-28','08:25:00',1.15),('9303','2013-08-28','08:30:00',1.31),('9303','2013-08-28','08:35:00',1.48),('9303','2013-08-28','08:40:00',1.44),('9303','2013-08-28','08:45:00',1.4),('9303','2013-08-28','08:50:00',1.07),('9303','2013-08-28','08:55:00',1.03),('9303','2013-08-28','09:00:00',1.35),('9303','2013-08-28','09:05:00',1.17),('9303','2013-08-28','09:10:00',1.18),('9303','2013-08-28','09:15:00',1.51),('9303','2013-08-28','09:20:00',1.1),('9303','2013-08-28','09:30:00',1.21),('9303','2013-08-28','09:35:00',2.45),('9303','2013-08-28','09:40:00',2.47),('9303','2013-08-28','09:45:00',2.5),('9303','2013-08-28','09:50:00',2.58),('9303','2013-08-28','09:55:00',2.6),('9303','2013-08-28','10:00:00',2.67),('9303','2013-08-28','10:05:00',2.35),('9303','2013-08-28','10:10:00',2.05),('9303','2013-08-28','10:15:00',2.58),('9303','2013-08-28','10:20:00',3.13),('9303','2013-08-28','10:25:00',2.08),('9303','2013-08-28','10:30:00',2.55),('9303','2013-08-28','10:35:00',1.96),('9303','2013-08-28','10:40:00',2.63),('9303','2013-08-28','10:45:00',2.87),('9303','2013-08-28','10:50:00',3.18),('9303','2013-08-28','10:55:00',3.44),('9303','2013-08-28','11:00:00',2.35),('9303','2013-08-28','11:05:00',2.99),('9303','2013-08-28','11:10:00',2.07),('9303','2013-08-28','11:15:00',2.68),('9303','2013-08-28','11:20:00',2.77),('9303','2013-08-28','11:25:00',3.79),('9303','2013-08-28','11:30:00',3.87),('9303','2013-08-28','11:35:00',3.59),('9303','2013-08-28','11:40:00',4),('9303','2013-08-28','11:45:00',2.88),('9303','2013-08-28','11:50:00',2.62),('9303','2013-08-28','11:55:00',3.03),('9303','2013-08-28','12:00:00',2.37),('9303','2013-08-28','12:05:00',2.87),('9303','2013-08-28','12:10:00',3.78),('9303','2013-08-28','12:15:00',4.06),('9303','2013-08-28','12:20:00',3.72),('9303','2013-08-28','12:25:00',3.9),('9303','2013-08-28','12:30:00',3.97),('9303','2013-08-28','12:35:00',3.95),('9303','2013-08-28','12:40:00',3.95),('9303','2013-08-28','12:45:00',4.11),('9303','2013-08-28','12:50:00',4.08),('9303','2013-08-28','12:55:00',4),('9303','2013-08-28','13:00:00',4.06),('9303','2013-08-28','13:05:00',3.18),('9303','2013-08-28','13:10:00',3.98),('9303','2013-08-28','13:15:00',4.2),('9303','2013-08-28','13:20:00',4.01),('9303','2013-08-28','13:25:00',4.05),('9303','2013-08-28','13:30:00',4.06),('9303','2013-08-28','13:35:00',3.94),('9303','2013-08-28','13:40:00',4.05),('9303','2013-08-28','13:45:00',3.43),('9303','2013-08-28','13:50:00',3.83),('9303','2013-08-28','13:55:00',3.63),('9303','2013-08-28','14:00:00',4.08),('9303','2013-08-28','14:05:00',3.97),('9303','2013-08-28','14:10:00',3.94),('9303','2013-08-28','14:15:00',3.96),('9303','2013-08-28','14:20:00',3.88),('9303','2013-08-28','14:25:00',3.84),('9303','2013-08-28','14:30:00',3.85),('9303','2013-08-28','14:35:00',3.26),('9303','2013-08-28','14:40:00',2.99),('9303','2013-08-28','14:45:00',3.84),('9303','2013-08-28','14:50:00',3.66),('9303','2013-08-28','14:55:00',3.66),('9303','2013-08-28','15:00:00',3.57),('9303','2013-08-28','15:05:00',3.54),('9303','2013-08-28','15:10:00',3.58),('9303','2013-08-28','15:15:00',3.53),('9303','2013-08-28','15:20:00',3.49),('9303','2013-08-28','15:25:00',3.34),('9303','2013-08-28','15:30:00',2.57),('9303','2013-08-28','15:35:00',2.15),('9303','2013-08-28','15:40:00',2.29),('9303','2013-08-28','15:45:00',2.17),('9303','2013-08-28','15:50:00',3.11),('9303','2013-08-28','15:55:00',2.25),('9303','2013-08-28','16:00:00',2.91),('9303','2013-08-28','16:05:00',3.23),('9303','2013-08-28','16:10:00',3.12),('9303','2013-08-28','16:15:00',2.8),('9303','2013-08-28','16:20:00',1.76),('9303','2013-08-28','16:25:00',2.96),('9303','2013-08-28','16:30:00',2.74),('9303','2013-08-28','16:35:00',2.3),('9303','2013-08-28','16:40:00',2.61),('9303','2013-08-28','16:45:00',2.42),('9303','2013-08-28','16:50:00',2.25),('9303','2013-08-28','16:55:00',2.06),('9303','2013-08-28','17:00:00',2.08),('9303','2013-08-28','17:05:00',1.95),('9303','2013-08-28','17:10:00',1.02),('9303','2013-08-28','17:15:00',1.24),('9303','2013-08-28','17:20:00',1.22),('9303','2013-08-28','17:25:00',1),('9303','2013-08-28','17:30:00',1.14),('9303','2013-08-28','17:35:00',1.12),('9303','2013-08-28','17:40:00',1.01),('9303','2013-08-27','08:20:00',1.02),('9303','2013-08-27','08:25:00',1.36),('9303','2013-08-27','08:30:00',1.36),('9303','2013-08-27','08:45:00',1.11),('9303','2013-08-27','09:10:00',1.06),('9303','2013-08-27','09:15:00',1.25),('9303','2013-08-27','09:20:00',1.44),('9303','2013-08-27','09:25:00',1.91),('9303','2013-08-27','09:30:00',2.14),('9303','2013-08-27','09:35:00',1.26),('9303','2013-08-27','09:45:00',1.01),('9303','2013-08-27','09:50:00',1.06),('9303','2013-08-27','09:55:00',1.37),('9303','2013-08-27','10:00:00',1.81),('9303','2013-08-27','10:05:00',2.19),('9303','2013-08-27','10:10:00',2.66),('9303','2013-08-27','10:15:00',2.74),('9303','2013-08-27','10:20:00',2.88),('9303','2013-08-27','10:25:00',2.91),('9303','2013-08-27','10:30:00',2.94),('9303','2013-08-27','10:35:00',3.01),('9303','2013-08-27','10:40:00',3),('9303','2013-08-27','10:45:00',3.09),('9303','2013-08-27','10:50:00',3.13),('9303','2013-08-27','10:55:00',3.16),('9303','2013-08-27','11:00:00',3.2),('9303','2013-08-27','11:05:00',3.09),('9303','2013-08-27','11:10:00',3.13),('9303','2013-08-27','11:15:00',3.25),('9303','2013-08-27','11:20:00',2.49),('9303','2013-08-27','11:25:00',3.31),('9303','2013-08-27','11:30:00',3.28),('9303','2013-08-27','11:35:00',3.36),('9303','2013-08-27','11:40:00',3.29),('9303','2013-08-27','11:45:00',3.82),('9303','2013-08-27','11:50:00',3.63),('9303','2013-08-27','11:55:00',3.71),('9303','2013-08-27','12:00:00',3.93),('9303','2013-08-27','12:05:00',3.9),('9303','2013-08-27','12:10:00',3.13),('9303','2013-08-27','12:15:00',3.36),('9303','2013-08-27','12:20:00',3.6),('9303','2013-08-27','12:25:00',3.7),('9303','2013-08-27','12:30:00',3.44),('9303','2013-08-27','12:35:00',3.85),('9303','2013-08-27','12:40:00',3.74),('9303','2013-08-27','12:45:00',2.96),('9303','2013-08-27','12:50:00',2.37),('9303','2013-08-27','12:55:00',1.93),('9303','2013-08-27','13:00:00',1.32),('9303','2013-08-27','13:05:00',1.54),('9303','2013-08-27','13:10:00',2.12),('9303','2013-08-27','13:15:00',1.56),('9303','2013-08-27','13:20:00',1.81),('9303','2013-08-27','13:25:00',1.88),('9303','2013-08-27','13:30:00',2.5),('9303','2013-08-27','13:35:00',1.81),('9303','2013-08-27','13:40:00',1.76),('9303','2013-08-27','13:45:00',1.85),('9303','2013-08-27','13:50:00',3.59),('9303','2013-08-27','13:55:00',2.97),('9303','2013-08-27','14:00:00',2.86),('9303','2013-08-27','14:05:00',2.45),('9303','2013-08-27','14:10:00',2.14),('9303','2013-08-27','14:15:00',3.33),('9303','2013-08-27','14:20:00',2.25),('9303','2013-08-27','14:25:00',1.36),('9303','2013-08-27','14:30:00',1.08),('9303','2013-08-27','14:35:00',1.05),('9303','2013-08-27','14:40:00',1.15),('9303','2013-08-27','14:45:00',1.2),('9303','2013-08-27','15:55:00',1.07),('9303','2013-08-27','16:00:00',1.35),('9303','2013-08-27','16:05:00',1.37),('9303','2013-08-27','16:10:00',3.07),('9303','2013-08-27','16:15:00',2.98),('9303','2013-08-27','16:20:00',1.34),('9303','2013-08-27','16:25:00',1.82),('9303','2013-08-27','16:35:00',1.19),('9303','2013-08-27','16:40:00',1.03),('9303','2013-08-27','16:45:00',1.11),('9303','2013-08-27','16:50:00',2.32),('9303','2013-08-27','16:55:00',1.3),('9303','2013-08-27','17:10:00',2.29),('9303','2013-08-27','17:15:00',1.27),('9303','2013-08-27','17:45:00',1.18),('9303','2013-08-27','17:50:00',1.28),('9303','2013-08-27','17:55:00',1.23),('9303','2013-08-27','18:00:00',1.05),('9303','2013-08-26','08:05:00',1.16),('9303','2013-08-26','08:10:00',1.12),('9303','2013-08-26','08:20:00',1.25),('9303','2013-08-26','08:25:00',1.04),('9303','2013-08-26','08:30:00',1.44),('9303','2013-08-26','08:35:00',1.23),('9303','2013-08-26','08:40:00',1.49),('9303','2013-08-26','08:45:00',1.58),('9303','2013-08-26','08:50:00',1.65),('9303','2013-08-26','08:55:00',1.73),('9303','2013-08-26','09:00:00',1.82),('9303','2013-08-26','09:05:00',1.89),('9303','2013-08-26','09:10:00',1.96),('9303','2013-08-26','09:15:00',2.03),('9303','2013-08-26','09:20:00',2.12),('9303','2013-08-26','09:25:00',2.17),('9303','2013-08-26','09:30:00',2.25),('9303','2013-08-26','09:35:00',2.31),('9303','2013-08-26','09:40:00',2.36),('9303','2013-08-26','09:45:00',2.43),('9303','2013-08-26','09:50:00',2.52),('9303','2013-08-26','09:55:00',2.57),('9303','2013-08-26','10:00:00',2.59),('9303','2013-08-26','10:05:00',2.68),('9303','2013-08-26','10:10:00',2.7),('9303','2013-08-26','10:15:00',2.76),('9303','2013-08-26','10:20:00',2.87),('9303','2013-08-26','10:25:00',2.96),('9303','2013-08-26','10:30:00',2.97),('9303','2013-08-26','10:35:00',3.02),('9303','2013-08-26','10:40:00',3.04),('9303','2013-08-26','10:45:00',3.08),('9303','2013-08-26','10:50:00',3.14),('9303','2013-08-26','10:55:00',3.2),('9303','2013-08-26','11:00:00',3.25),('9303','2013-08-26','11:05:00',3.29),('9303','2013-08-26','11:10:00',3.33),('9303','2013-08-26','11:15:00',3.37),('9303','2013-08-26','11:20:00',3.4),('9303','2013-08-26','11:25:00',3.39),('9303','2013-08-26','11:30:00',3.45),('9303','2013-08-26','11:35:00',3.53),('9303','2013-08-26','11:40:00',3.54),('9303','2013-08-26','11:45:00',3.53),('9303','2013-08-26','11:50:00',3.02),('9303','2013-08-26','11:55:00',3.57),('9303','2013-08-26','12:00:00',3.62),('9303','2013-08-26','12:05:00',3.66),('9303','2013-08-26','12:10:00',3.71),('9303','2013-08-26','12:15:00',3.71),('9303','2013-08-26','12:20:00',3.69),('9303','2013-08-26','12:25:00',3.66),('9303','2013-08-26','12:30:00',3.65),('9303','2013-08-26','12:35:00',3.68),('9303','2013-08-26','12:40:00',3.73),('9303','2013-08-26','12:45:00',3.74),('9303','2013-08-26','12:50:00',3.75),('9303','2013-08-26','12:55:00',3.74),('9303','2013-08-26','13:00:00',3.95),('9303','2013-08-26','13:05:00',4.37),('9303','2013-08-26','13:10:00',3.88),('9303','2013-08-26','13:15:00',3.38),('9303','2013-08-26','13:20:00',2.7),('9303','2013-08-26','13:25:00',2.75),('9303','2013-08-26','13:30:00',2.7),('9303','2013-08-26','13:35:00',3.58),('9303','2013-08-26','13:40:00',3.72),('9303','2013-08-26','13:45:00',3.75),('9303','2013-08-26','13:50:00',3.88),('9303','2013-08-26','13:55:00',3.24),('9303','2013-08-26','14:00:00',2.97),('9303','2013-08-26','14:05:00',3.72),('9303','2013-08-26','14:10:00',2.41),('9303','2013-08-26','14:15:00',3.8),('9303','2013-08-26','14:20:00',3.62),('9303','2013-08-26','14:25:00',3.55),('9303','2013-08-26','14:30:00',3.53),('9303','2013-08-26','14:35:00',3.43),('9303','2013-08-26','14:40:00',3.14),('9303','2013-08-26','14:45:00',2.44),('9303','2013-08-26','14:50:00',2),('9303','2013-08-26','14:55:00',1.83),('9303','2013-08-26','15:00:00',1.72),('9303','2013-08-26','15:05:00',1.33),('9303','2013-08-26','15:40:00',1.42),('9303','2013-08-26','15:45:00',1.55),('9303','2013-08-26','15:50:00',1.55),('9303','2013-08-26','15:55:00',1.44),('9303','2013-08-26','16:00:00',1.93),('9303','2013-08-26','16:05:00',3.12),('9303','2013-08-26','16:10:00',2.76),('9303','2013-08-26','16:15:00',2.57),('9303','2013-08-26','16:20:00',2.55),('9303','2013-08-26','16:25:00',2.44),('9303','2013-08-26','16:30:00',2.38),('9303','2013-08-26','16:35:00',2.32),('9303','2013-08-26','16:40:00',2.25),('9303','2013-08-26','16:45:00',2.2),('9303','2013-08-26','16:50:00',2),('9303','2013-08-26','16:55:00',1.91),('9303','2013-08-26','17:00:00',1.87),('9303','2013-08-26','17:05:00',1.7),('9303','2013-08-26','17:10:00',1.7),('9303','2013-08-26','17:15:00',1.63),('9303','2013-08-26','17:20:00',1.29),('9303','2013-08-26','17:30:00',1.17),('9303','2013-08-26','17:45:00',1.04),('9303','2013-08-26','17:50:00',1.2),('9303','2013-08-26','17:55:00',1.16),('9303','2013-08-26','18:00:00',1),('9303','2013-08-25','08:10:00',1.03),('9303','2013-08-25','08:15:00',1.03),('9303','2013-08-25','08:25:00',1.01),('9303','2013-08-25','08:30:00',1.06),('9303','2013-08-25','08:40:00',1.12),('9303','2013-08-25','08:45:00',1.56),('9303','2013-08-25','09:20:00',2.16),('9303','2013-08-25','09:25:00',1.85),('9303','2013-08-25','09:30:00',1.87),('9303','2013-08-25','09:35:00',1.47),('9303','2013-08-25','09:40:00',2.65),('9303','2013-08-25','09:45:00',3.01),('9303','2013-08-25','09:50:00',2.8),('9303','2013-08-25','09:55:00',3.11),('9303','2013-08-25','10:00:00',2.14),('9303','2013-08-25','10:05:00',1.49),('9303','2013-08-25','15:15:00',1.09),('9303','2013-08-25','15:20:00',1.3),('9303','2013-08-25','15:25:00',1.44),('9303','2013-08-25','15:30:00',2.04),('9303','2013-08-25','15:35:00',3.04),('9303','2013-08-25','15:40:00',3.37),('9303','2013-08-25','15:45:00',3.41),('9303','2013-08-25','15:50:00',2.63),('9303','2013-08-25','15:55:00',1.92),('9303','2013-08-25','16:00:00',3.26),('9303','2013-08-25','16:05:00',3.03),('9303','2013-08-25','16:10:00',2.87),('9303','2013-08-25','16:15:00',2.77),('9303','2013-08-25','16:20:00',2.69),('9303','2013-08-25','16:25:00',2.64),('9303','2013-08-25','16:30:00',2.58),('9303','2013-08-25','16:35:00',2.45),('9303','2013-08-25','16:40:00',1.92),('9303','2013-08-25','16:45:00',1.39),('9303','2013-08-25','16:50:00',1.75),('9303','2013-08-25','16:55:00',1.91),('9303','2013-08-25','17:00:00',2.15),('9303','2013-08-25','17:05:00',2.01),('9303','2013-08-25','17:10:00',1.92),('9303','2013-08-25','17:15:00',1.77),('9303','2013-08-25','17:20:00',1.66),('9303','2013-08-25','17:25:00',1.57),('9303','2013-08-25','17:30:00',1.49),('9303','2013-08-25','17:35:00',1.2),('9303','2013-08-25','17:40:00',1.05),('9303','2013-08-25','17:45:00',1.27),('9303','2013-08-25','17:50:00',1.12),('9303','2013-08-24','08:25:00',1.13),('9303','2013-08-24','08:30:00',1.19),('9303','2013-08-24','08:35:00',1.33),('9303','2013-08-24','08:40:00',1.44),('9303','2013-08-24','08:45:00',1.47),('9303','2013-08-24','08:50:00',1.59),('9303','2013-08-24','08:55:00',1.67),('9303','2013-08-24','09:00:00',1.76),('9303','2013-08-24','09:05:00',1.81),('9303','2013-08-24','09:10:00',1.72),('9303','2013-08-24','09:15:00',1.37),('9303','2013-08-24','09:20:00',1.9),('9303','2013-08-24','09:25:00',1.8),('9303','2013-08-24','09:30:00',2.05),('9303','2013-08-24','09:35:00',1.64),('9303','2013-08-24','09:40:00',2.01),('9303','2013-08-24','09:45:00',1.83),('9303','2013-08-24','09:50:00',2.02),('9303','2013-08-24','09:55:00',2.37),('9303','2013-08-24','10:00:00',2.7),('9303','2013-08-24','10:05:00',2.71),('9303','2013-08-24','10:10:00',2.77),('9303','2013-08-24','10:15:00',2.81),('9303','2013-08-24','10:20:00',2.86),('9303','2013-08-24','10:25:00',2.91),('9303','2013-08-24','10:30:00',2.94),('9303','2013-08-24','10:35:00',2.95),('9303','2013-08-24','10:40:00',3.03),('9303','2013-08-24','10:45:00',3.1),('9303','2013-08-24','10:50:00',2.14),('9303','2013-08-24','10:55:00',3.27),('9303','2013-08-24','11:00:00',3.25),('9303','2013-08-24','11:05:00',3.29),('9303','2013-08-24','11:10:00',3.33),('9303','2013-08-24','11:15:00',3.36),('9303','2013-08-24','11:20:00',3.42),('9303','2013-08-24','11:25:00',3.4),('9303','2013-08-24','11:30:00',3.37),('9303','2013-08-24','11:35:00',3.47),('9303','2013-08-24','11:40:00',3.48),('9303','2013-08-24','11:45:00',3.51),('9303','2013-08-24','11:50:00',3.6),('9303','2013-08-24','11:55:00',3.58),('9303','2013-08-24','12:00:00',3.59),('9303','2013-08-24','12:05:00',3.58),('9303','2013-08-24','12:10:00',3.6),('9303','2013-08-24','12:15:00',3.67),('9303','2013-08-24','12:20:00',3.67),('9303','2013-08-24','12:25:00',3.69),('9303','2013-08-24','12:30:00',3.67),('9303','2013-08-24','12:35:00',3.69),('9303','2013-08-24','12:40:00',3.74),('9303','2013-08-24','12:45:00',3.76),('9303','2013-08-24','12:50:00',3.75),('9303','2013-08-24','12:55:00',3.72),('9303','2013-08-24','13:00:00',3.63),('9303','2013-08-24','13:05:00',3.71),('9303','2013-08-24','13:10:00',3.76),('9303','2013-08-24','13:15:00',3.75),('9303','2013-08-24','13:20:00',3.75),('9303','2013-08-24','13:25:00',3.76),('9303','2013-08-24','13:30:00',3.76),('9303','2013-08-24','13:35:00',3.76),('9303','2013-08-24','13:40:00',3.77),('9303','2013-08-24','13:45:00',3.77),('9303','2013-08-24','13:50:00',3.77),('9303','2013-08-24','13:55:00',3.74),('9303','2013-08-24','14:00:00',3.68),('9303','2013-08-24','14:05:00',3.67),('9303','2013-08-24','14:10:00',3.65),('9303','2013-08-24','14:15:00',3.66),('9303','2013-08-24','14:20:00',3.65),('9303','2013-08-24','14:25:00',3.61),('9303','2013-08-24','14:30:00',3.59),('9303','2013-08-24','14:35:00',3.56),('9303','2013-08-24','14:40:00',3.5),('9303','2013-08-24','14:45:00',3.45),('9303','2013-08-24','14:50:00',3.45),('9303','2013-08-24','14:55:00',3.43),('9303','2013-08-24','15:00:00',3.39),('9303','2013-08-24','15:05:00',3.37),('9303','2013-08-24','15:10:00',3.32),('9303','2013-08-24','15:15:00',3.29),('9303','2013-08-24','15:20:00',3.23),('9303','2013-08-24','15:25:00',3.2),('9303','2013-08-24','15:30:00',3.15),('9303','2013-08-24','15:35:00',3.11),('9303','2013-08-24','15:40:00',3.05),('9303','2013-08-24','15:45:00',2.99),('9303','2013-08-24','15:50:00',2.93),('9303','2013-08-24','15:55:00',2.89),('9303','2013-08-24','16:00:00',2.83),('9303','2013-08-24','16:05:00',2.78),('9303','2013-08-24','16:10:00',2.72),('9303','2013-08-24','16:15:00',2.64),('9303','2013-08-24','16:20:00',2.61),('9303','2013-08-24','16:25:00',2.52),('9303','2013-08-24','16:30:00',2.45),('9303','2013-08-24','16:35:00',2.4),('9303','2013-08-24','16:40:00',2.33),('9303','2013-08-24','16:45:00',2.26),('9303','2013-08-24','16:50:00',2.16),('9303','2013-08-24','16:55:00',2.06),('9303','2013-08-24','17:00:00',1.91),('9303','2013-08-24','17:05:00',1.86),('9303','2013-08-24','17:10:00',1.79),('9303','2013-08-24','17:15:00',1.73),('9303','2013-08-24','17:20:00',1.66),('9303','2013-08-24','17:25:00',1.59),('9303','2013-08-24','17:30:00',1.51),('9303','2013-08-24','17:35:00',1.43),('9303','2013-08-24','17:40:00',1.32),('9303','2013-08-24','17:45:00',1.25),('9303','2013-08-24','17:50:00',1.17),('9303','2013-08-24','17:55:00',1.07),('9303','2013-08-23','08:25:00',1.08),('9303','2013-08-23','08:30:00',1.17),('9303','2013-08-23','08:35:00',1.23),('9303','2013-08-23','08:40:00',1.29),('9303','2013-08-23','08:45:00',1.42),('9303','2013-08-23','08:50:00',1.49),('9303','2013-08-23','08:55:00',1.54),('9303','2013-08-23','09:00:00',1.59),('9303','2013-08-23','09:05:00',1.66),('9303','2013-08-23','09:10:00',1.76),('9303','2013-08-23','09:15:00',1.84),('9303','2013-08-23','09:20:00',1.92),('9303','2013-08-23','09:25:00',1.98),('9303','2013-08-23','09:30:00',2.04),('9303','2013-08-23','09:35:00',2.09),('9303','2013-08-23','09:40:00',2.15),('9303','2013-08-23','09:45:00',2.22),('9303','2013-08-23','09:50:00',2.3),('9303','2013-08-23','09:55:00',2.34),('9303','2013-08-23','10:00:00',2.39),('9303','2013-08-23','10:05:00',2.45),('9303','2013-08-23','10:10:00',2.49),('9303','2013-08-23','10:15:00',2.56),('9303','2013-08-23','10:20:00',2.61),('9303','2013-08-23','10:25:00',2.67),('9303','2013-08-23','10:30:00',2.68),('9303','2013-08-23','10:35:00',2.74),('9303','2013-08-23','10:40:00',2.1),('9303','2013-08-23','10:45:00',2.25),('9303','2013-08-23','10:50:00',2.78),('9303','2013-08-23','10:55:00',2.82),('9303','2013-08-23','11:00:00',2.92),('9303','2013-08-23','11:05:00',3.15),('9303','2013-08-23','11:10:00',3.04),('9303','2013-08-23','11:15:00',1.32),('9303','2013-08-23','11:20:00',1.23),('9303','2013-08-23','11:25:00',2.33),('9303','2013-08-23','11:30:00',3.26),('9303','2013-08-23','11:35:00',2.93),('9303','2013-08-23','11:40:00',2.91),('9303','2013-08-23','11:45:00',3.4),('9303','2013-08-23','11:50:00',3.38),('9303','2013-08-23','11:55:00',2.8),('9303','2013-08-23','12:00:00',1.25),('9303','2013-08-23','12:05:00',1.4),('9303','2013-08-23','12:10:00',1.35),('9303','2013-08-23','12:15:00',2.83),('9303','2013-08-23','12:40:00',1.11),('9303','2013-08-23','12:45:00',1.34),('9303','2013-08-23','12:55:00',1.17),('9303','2013-08-23','13:00:00',1.08),('9303','2013-08-23','13:05:00',1.25),('9303','2013-08-23','13:10:00',1.57),('9303','2013-08-23','13:15:00',2.77),('9303','2013-08-23','13:20:00',1.23),('9303','2013-08-23','13:25:00',3.6),('9303','2013-08-23','13:30:00',2.9),('9303','2013-08-23','13:35:00',3.34),('9303','2013-08-23','13:40:00',2.68),('9303','2013-08-23','13:45:00',2.99),('9303','2013-08-23','13:50:00',1.99),('9303','2013-08-23','13:55:00',3.41),('9303','2013-08-23','14:00:00',4.03),('9303','2013-08-23','14:05:00',3.72),('9303','2013-08-23','14:10:00',3.73),('9303','2013-08-23','14:15:00',3.78),('9303','2013-08-23','14:20:00',3.39),('9303','2013-08-23','14:25:00',3.31),('9303','2013-08-23','14:30:00',3.68),('9303','2013-08-23','14:35:00',3.54),('9303','2013-08-23','14:40:00',3.6),('9303','2013-08-23','14:45:00',3.55),('9303','2013-08-23','14:50:00',3.46),('9303','2013-08-23','14:55:00',3.29),('9303','2013-08-23','15:00:00',3.28),('9303','2013-08-23','15:05:00',3.14),('9303','2013-08-23','15:10:00',3.23),('9303','2013-08-23','15:15:00',3.18),('9303','2013-08-23','15:20:00',3.16),('9303','2013-08-23','15:25:00',3.16),('9303','2013-08-23','15:30:00',3.25),('9303','2013-08-23','15:35:00',3),('9303','2013-08-23','15:40:00',2.96),('9303','2013-08-23','15:45:00',2.96),('9303','2013-08-23','15:50:00',2.74),('9303','2013-08-23','15:55:00',2.83),('9303','2013-08-23','16:00:00',2.71),('9303','2013-08-23','16:05:00',2.54),('9303','2013-08-23','16:10:00',2.26),('9303','2013-08-23','16:15:00',2.38),('9303','2013-08-23','16:20:00',2.72),('9303','2013-08-23','16:25:00',2.48),('9303','2013-08-23','16:30:00',2.4),('9303','2013-08-23','16:35:00',2.51),('9303','2013-08-23','16:40:00',2.45),('9303','2013-08-23','16:45:00',2.36),('9303','2013-08-23','16:50:00',2.25),('9303','2013-08-23','16:55:00',2.09),('9303','2013-08-23','17:00:00',1.97),('9303','2013-08-23','17:05:00',1.86),('9303','2013-08-23','17:10:00',1.77),('9303','2013-08-23','17:15:00',1.69),('9303','2013-08-23','17:20:00',1.61),('9303','2013-08-23','17:25:00',1.53),('9303','2013-08-23','17:30:00',1.45),('9303','2013-08-23','17:35:00',1.38),('9303','2013-08-23','17:40:00',1.29),('9303','2013-08-23','17:45:00',1.21),('9303','2013-08-23','17:50:00',1.13),('9303','2013-08-23','17:55:00',1.05),('9303','2013-08-22','08:20:00',1.06),('9303','2013-08-22','08:25:00',1.13),('9303','2013-08-22','08:30:00',1.23),('9303','2013-08-22','08:35:00',1.31),('9303','2013-08-22','08:40:00',1.39),('9303','2013-08-22','08:45:00',1.49),('9303','2013-08-22','08:50:00',1.57),('9303','2013-08-22','08:55:00',1.67),('9303','2013-08-22','09:00:00',1.76),('9303','2013-08-22','09:05:00',1.91),('9303','2013-08-22','09:10:00',2),('9303','2013-08-22','09:15:00',2.09),('9303','2013-08-22','09:20:00',2.24),('9303','2013-08-22','09:25:00',2.29),('9303','2013-08-22','09:30:00',1.87),('9303','2013-08-22','09:35:00',1.16),('9303','2013-08-22','09:40:00',1.34),('9303','2013-08-22','09:45:00',1.77),('9303','2013-08-22','09:50:00',2.34),('9303','2013-08-22','09:55:00',1.92),('9303','2013-08-22','10:00:00',2.78),('9303','2013-08-22','10:05:00',2.8),('9303','2013-08-22','10:10:00',2.83),('9303','2013-08-22','10:15:00',2.81),('9303','2013-08-22','10:20:00',2.81),('9303','2013-08-22','10:25:00',2.86),('9303','2013-08-22','10:30:00',2.93),('9303','2013-08-22','10:35:00',2.95),('9303','2013-08-22','10:40:00',3),('9303','2013-08-22','10:45:00',3.03),('9303','2013-08-22','10:50:00',3.07),('9303','2013-08-22','10:55:00',3.12),('9303','2013-08-22','11:00:00',3.16),('9303','2013-08-22','11:05:00',3.2),('9303','2013-08-22','11:10:00',3.24),('9303','2013-08-22','11:15:00',3.28),('9303','2013-08-22','11:20:00',3.28),('9303','2013-08-22','11:25:00',3.3),('9303','2013-08-22','11:30:00',3.35),('9303','2013-08-22','11:35:00',3.37),('9303','2013-08-22','11:40:00',3.39),('9303','2013-08-22','11:45:00',3.42),('9303','2013-08-22','11:50:00',3.47),('9303','2013-08-22','11:55:00',3.47),('9303','2013-08-22','12:00:00',3.5),('9303','2013-08-22','12:05:00',3.51),('9303','2013-08-22','12:10:00',3.51),('9303','2013-08-22','12:15:00',3.54),('9303','2013-08-22','12:20:00',3.57),('9303','2013-08-22','12:25:00',3.59),('9303','2013-08-22','12:30:00',3.59),('9303','2013-08-22','12:35:00',3.61),('9303','2013-08-22','12:40:00',3.62),('9303','2013-08-22','12:45:00',3.61),('9303','2013-08-22','12:50:00',3.61),('9303','2013-08-22','12:55:00',3.58),('9303','2013-08-22','13:00:00',3.51),('9303','2013-08-22','13:05:00',3.45),('9303','2013-08-22','13:10:00',3.49),('9303','2013-08-22','13:15:00',3.51),('9303','2013-08-22','13:20:00',3.57),('9303','2013-08-22','13:25:00',3.61),('9303','2013-08-22','13:30:00',3.62),('9303','2013-08-22','13:35:00',3.56),('9303','2013-08-22','13:40:00',3.59),('9303','2013-08-22','13:45:00',3.58),('9303','2013-08-22','13:50:00',3.58),('9303','2013-08-22','13:55:00',3.58),('9303','2013-08-22','14:00:00',3.54),('9303','2013-08-22','14:05:00',3.57),('9303','2013-08-22','14:10:00',3.55),('9303','2013-08-22','14:15:00',3.53),('9303','2013-08-22','14:20:00',3.51),('9303','2013-08-22','14:25:00',3.47),('9303','2013-08-22','14:30:00',2.72),('9303','2013-08-22','14:35:00',3.19),('9303','2013-08-22','14:40:00',3.49),('9303','2013-08-22','14:45:00',3.4),('9303','2013-08-22','14:50:00',3.29),('9303','2013-08-22','14:55:00',3.28),('9303','2013-08-22','15:00:00',3.24),('9303','2013-08-22','15:05:00',3.23),('9303','2013-08-22','15:10:00',3.21),('9303','2013-08-22','15:15:00',3.17),('9303','2013-08-22','15:20:00',3.11),('9303','2013-08-22','15:25:00',3.06),('9303','2013-08-22','15:30:00',3),('9303','2013-08-22','15:35:00',2.96),('9303','2013-08-22','15:40:00',2.95),('9303','2013-08-22','15:45:00',2.91),('9303','2013-08-22','15:50:00',2.86),('9303','2013-08-22','15:55:00',2.8),('9303','2013-08-22','16:00:00',2.76),('9303','2013-08-22','16:05:00',2.65),('9303','2013-08-22','16:10:00',2.61),('9303','2013-08-22','16:15:00',2.56),('9303','2013-08-22','16:20:00',2.49),('9303','2013-08-22','16:25:00',2.43),('9303','2013-08-22','16:30:00',2.36),('9303','2013-08-22','16:35:00',2.3),('9303','2013-08-22','16:40:00',2.23),('9303','2013-08-22','16:45:00',2.14),('9303','2013-08-22','16:50:00',2.05),('9303','2013-08-22','16:55:00',1.97),('9303','2013-08-22','17:00:00',1.86),('9303','2013-08-22','17:05:00',1.78),('9303','2013-08-22','17:10:00',1.69),('9303','2013-08-22','17:15:00',1.6),('9303','2013-08-22','17:20:00',1.54),('9303','2013-08-22','17:25:00',1.48),('9303','2013-08-22','17:30:00',1.41),('9303','2013-08-22','17:35:00',1.34),('9303','2013-08-22','17:40:00',1.25),('9303','2013-08-22','17:45:00',1.13),('9303','2013-08-22','17:50:00',1.07),('9303','2013-08-22','17:55:00',1.02),('9303','2013-08-21','09:05:00',1.28),('9303','2013-08-21','09:10:00',1.29),('9303','2013-08-21','09:15:00',2.19),('9303','2013-08-21','09:20:00',2.49),('9303','2013-08-21','09:25:00',1.25),('9303','2013-08-21','09:45:00',1.12),('9303','2013-08-21','09:50:00',2.57),('9303','2013-08-21','09:55:00',3.33),('9303','2013-08-21','10:00:00',3.1),('9303','2013-08-21','10:05:00',2.6),('9303','2013-08-21','10:10:00',2.13),('9303','2013-08-21','10:15:00',2.39),('9303','2013-08-21','10:20:00',1.94),('9303','2013-08-21','10:25:00',1.79),('9303','2013-08-21','10:30:00',1.79),('9303','2013-08-21','10:35:00',3.17),('9303','2013-08-21','10:40:00',2.82),('9303','2013-08-21','10:45:00',2.1),('9303','2013-08-21','10:50:00',2.07),('9303','2013-08-21','10:55:00',1.65),('9303','2013-08-21','11:00:00',2.13),('9303','2013-08-21','11:05:00',1.82),('9303','2013-08-21','11:10:00',1.58),('9303','2013-08-21','11:15:00',1.95),('9303','2013-08-21','11:20:00',3.32),('9303','2013-08-21','11:25:00',2.39),('9303','2013-08-21','11:30:00',2.47),('9303','2013-08-21','11:35:00',3.66),('9303','2013-08-21','11:40:00',3.9),('9303','2013-08-21','11:45:00',3.81),('9303','2013-08-21','11:50:00',3.25),('9303','2013-08-21','11:55:00',3.5),('9303','2013-08-21','12:00:00',3.86),('9303','2013-08-21','12:05:00',3.87),('9303','2013-08-21','12:10:00',3.86),('9303','2013-08-21','12:15:00',3.87),('9303','2013-08-21','12:20:00',3.76),('9303','2013-08-21','12:25:00',2.28),('9303','2013-08-21','12:30:00',3.05),('9303','2013-08-21','12:35:00',2.67),('9303','2013-08-21','12:40:00',3.1),('9303','2013-08-21','12:45:00',3.64),('9303','2013-08-21','12:50:00',3.61),('9303','2013-08-21','12:55:00',3.45),('9303','2013-08-21','13:00:00',3.61),('9303','2013-08-21','13:05:00',3.69),('9303','2013-08-21','13:10:00',3.71),('9303','2013-08-21','13:15:00',3.77),('9303','2013-08-21','13:20:00',3.8),('9303','2013-08-21','13:25:00',3.77),('9303','2013-08-21','13:30:00',3.79),('9303','2013-08-21','13:35:00',3.77),('9303','2013-08-21','13:40:00',3.67),('9303','2013-08-21','13:45:00',3.39),('9303','2013-08-21','13:50:00',3.61),('9303','2013-08-21','13:55:00',3.55),('9303','2013-08-21','14:00:00',3.63),('9303','2013-08-21','14:05:00',3.64),('9303','2013-08-21','14:10:00',3.69),('9303','2013-08-21','14:15:00',3.73),('9303','2013-08-21','14:20:00',3.44),('9303','2013-08-21','14:25:00',2.92),('9303','2013-08-21','14:30:00',3.23),('9303','2013-08-21','14:35:00',3.19),('9303','2013-08-21','14:40:00',3.25),('9303','2013-08-21','14:45:00',3.25),('9303','2013-08-21','14:50:00',3.13),('9303','2013-08-21','14:55:00',3.12),('9303','2013-08-21','15:00:00',3.19),('9303','2013-08-21','15:05:00',3.21),('9303','2013-08-21','15:10:00',3.08),('9303','2013-08-21','15:15:00',3.04),('9303','2013-08-21','15:20:00',2.99),('9303','2013-08-21','15:25:00',2.97),('9303','2013-08-21','15:30:00',2.84),('9303','2013-08-21','15:35:00',2.75),('9303','2013-08-21','15:40:00',2.57),('9303','2013-08-21','15:45:00',2.66),('9303','2013-08-21','15:50:00',2.71),('9303','2013-08-21','15:55:00',2.5),('9303','2013-08-21','16:00:00',2.37),('9303','2013-08-21','16:05:00',2.33),('9303','2013-08-21','16:10:00',2.27),('9303','2013-08-21','16:15:00',2.36),('9303','2013-08-21','16:20:00',2.43),('9303','2013-08-21','16:25:00',2.41),('9303','2013-08-21','16:30:00',2.5),('9303','2013-08-21','16:35:00',2.4),('9303','2013-08-21','16:40:00',2.32),('9303','2013-08-21','16:45:00',2.26),('9303','2013-08-21','16:50:00',2.18),('9303','2013-08-21','16:55:00',2.07),('9303','2013-08-21','17:00:00',1.99),('9303','2013-08-21','17:05:00',1.91),('9303','2013-08-21','17:10:00',1.89),('9303','2013-08-21','17:15:00',1.83),('9303','2013-08-21','17:20:00',1.81),('9303','2013-08-21','17:25:00',1.72),('9303','2013-08-21','17:30:00',1.64),('9303','2013-08-21','17:35:00',1.58),('9303','2013-08-21','17:40:00',1.51),('9303','2013-08-21','17:45:00',1.43),('9303','2013-08-21','17:50:00',1.39),('9303','2013-08-21','17:55:00',1.3),('9303','2013-08-21','18:00:00',1.22),('9303','2013-08-21','18:05:00',1.14),('9303','2013-08-21','18:10:00',1.03),('9303','2013-08-20','08:55:00',1.03),('9303','2013-08-20','09:00:00',1.03),('9303','2013-08-20','09:05:00',1.04),('9303','2013-08-20','09:20:00',1.11),('9303','2013-08-20','09:25:00',1.71),('9303','2013-08-20','09:30:00',2.33),('9303','2013-08-20','09:35:00',2.31),('9303','2013-08-20','09:40:00',2.43),('9303','2013-08-20','09:45:00',2.1),('9303','2013-08-20','09:50:00',2.52),('9303','2013-08-20','09:55:00',2.34),('9303','2013-08-20','10:00:00',3.43),('9303','2013-08-20','10:05:00',1.3),('9303','2013-08-20','10:10:00',1.12),('9303','2013-08-20','10:15:00',2.83),('9303','2013-08-20','10:20:00',2.63),('9303','2013-08-20','10:25:00',1.17),('9303','2013-08-20','10:45:00',1.06),('9303','2013-08-20','10:50:00',1.73),('9303','2013-08-20','10:55:00',2.5),('9303','2013-08-20','11:15:00',2),('9303','2013-08-20','11:20:00',3.79),('9303','2013-08-20','11:25:00',3.47),('9303','2013-08-20','11:30:00',1.69),('9303','2013-08-20','11:35:00',1.24),('9303','2013-08-20','11:40:00',3.9),('9303','2013-08-20','11:45:00',3.78),('9303','2013-08-20','11:50:00',4.24),('9303','2013-08-20','11:55:00',4.21),('9303','2013-08-20','12:00:00',1.98),('9303','2013-08-20','12:05:00',1.09),('9303','2013-08-20','12:10:00',1.08),('9303','2013-08-20','12:30:00',1.12),('9303','2013-08-20','12:35:00',1.35),('9303','2013-08-20','12:40:00',1.6),('9303','2013-08-20','12:45:00',1.64),('9303','2013-08-20','12:50:00',1.86),('9303','2013-08-20','12:55:00',1.72),('9303','2013-08-20','13:00:00',1.68),('9303','2013-08-20','13:05:00',1.52),('9303','2013-08-20','13:10:00',1.46),('9303','2013-08-20','13:15:00',1.48),('9303','2013-08-20','13:20:00',1.55),('9303','2013-08-20','13:25:00',1.63),('9303','2013-08-20','13:30:00',1.78),('9303','2013-08-20','13:35:00',2.37),('9303','2013-08-20','13:40:00',3.56),('9303','2013-08-20','13:45:00',3.4),('9303','2013-08-20','13:50:00',3.95),('9303','2013-08-20','13:55:00',3.95),('9303','2013-08-20','14:00:00',3.89),('9303','2013-08-20','14:05:00',3.84),('9303','2013-08-20','14:10:00',3.4),('9303','2013-08-20','14:15:00',3.77),('9303','2013-08-20','14:20:00',3.78),('9303','2013-08-20','14:25:00',3.39),('9303','2013-08-20','14:30:00',2.95),('9303','2013-08-20','14:35:00',3.09),('9303','2013-08-20','14:40:00',3.84),('9303','2013-08-20','14:45:00',3.64),('9303','2013-08-20','14:50:00',3.61),('9303','2013-08-20','14:55:00',3.46),('9303','2013-08-20','15:00:00',3.38),('9303','2013-08-20','15:05:00',3.83),('9303','2013-08-20','15:10:00',3.69),('9303','2013-08-20','15:15:00',3.69),('9303','2013-08-20','15:20:00',3.56),('9303','2013-08-20','15:25:00',3.54),('9303','2013-08-20','15:30:00',3.52),('9303','2013-08-20','15:35:00',3.49),('9303','2013-08-20','15:40:00',3.54),('9303','2013-08-20','15:45:00',3.66),('9303','2013-08-20','15:50:00',3.83),('9303','2013-08-20','15:55:00',3.9),('9303','2013-08-20','16:00:00',3.64),('9303','2013-08-20','16:05:00',3.56),('9303','2013-08-20','16:10:00',3.49),('9303','2013-08-20','16:15:00',3.45),('9303','2013-08-20','16:20:00',3.4),('9303','2013-08-20','16:25:00',3.18),('9303','2013-08-20','16:30:00',2.85),('9303','2013-08-20','16:35:00',2.94),('9303','2013-08-20','16:40:00',3.06),('9303','2013-08-20','16:45:00',2.89),('9303','2013-08-20','16:50:00',2.67),('9303','2013-08-20','16:55:00',2.48),('9303','2013-08-20','17:00:00',2.27),('9303','2013-08-20','17:05:00',2.1),('9303','2013-08-20','17:10:00',2),('9303','2013-08-20','17:15:00',1.86),('9303','2013-08-20','17:20:00',1.84),('9303','2013-08-20','17:25:00',1.74),('9303','2013-08-20','17:30:00',1.65),('9303','2013-08-20','17:35:00',1.58),('9303','2013-08-20','17:40:00',1.47),('9303','2013-08-20','17:45:00',1.42),('9303','2013-08-20','17:50:00',1.29),('9303','2013-08-20','17:55:00',1.15),('9303','2013-08-20','18:00:00',1.04),('9303','2013-08-20','18:05:00',1.04),('9303','2013-08-20','18:10:00',1.01),('9303','2014-04-10','08:10:00',1.04),('9303','2014-04-10','08:15:00',1.15),('9303','2014-04-10','08:20:00',1.26),('9303','2014-04-10','08:25:00',1.36),('9303','2014-04-10','08:30:00',1.47),('9303','2014-04-10','08:35:00',1.58),('9303','2014-04-10','08:40:00',1.7),('9303','2014-04-10','08:45:00',1.81),('9303','2014-04-10','08:50:00',1.91),('9303','2014-04-10','08:55:00',1.99),('9303','2014-04-10','09:00:00',2.06),('9303','2014-04-10','09:05:00',2.18),('9303','2014-04-10','09:10:00',2.25),('9303','2014-04-10','09:15:00',2.29),('9303','2014-04-10','09:20:00',2.31),('9303','2014-04-10','09:25:00',2.49),('9303','2014-04-10','09:30:00',2.6),('9303','2014-04-10','09:35:00',2.67),('9303','2014-04-10','09:40:00',2.71),('9303','2014-04-10','09:45:00',2.77),('9303','2014-04-10','09:50:00',2.87),('9303','2014-04-10','09:55:00',2.95),('9303','2014-04-10','10:00:00',3),('9303','2014-04-10','10:05:00',3.06),('9303','2014-04-10','10:10:00',3.14),('9303','2014-04-10','10:15:00',3.15),('9303','2014-04-10','10:20:00',3.21),('9303','2014-04-10','10:25:00',3.26),('9303','2014-04-10','10:30:00',3.31),('9303','2014-04-10','10:35:00',3.45),('9303','2014-04-10','10:40:00',3.48),('9303','2014-04-10','10:45:00',3.5),('9303','2014-04-10','10:50:00',3.47),('9303','2014-04-10','10:55:00',3.55),('9303','2014-04-10','11:00:00',3.61),('9303','2014-04-10','11:05:00',3.71),('9303','2014-04-10','11:10:00',3.64),('9303','2014-04-10','11:15:00',3.78),('9303','2014-04-10','11:20:00',3.9),('9303','2014-04-10','11:25:00',3.95),('9303','2014-04-10','11:30:00',3.94),('9303','2014-04-10','11:35:00',3.96),('9303','2014-04-10','11:40:00',3.86),('9303','2014-04-10','11:45:00',3.97),('9303','2014-04-10','11:50:00',3.87),('9303','2014-04-10','11:55:00',4.07),('9303','2014-04-10','12:00:00',4.02),('9303','2014-04-10','12:05:00',3.8),('9303','2014-04-10','12:10:00',3.97),('9303','2014-04-10','12:15:00',4.02),('9303','2014-04-10','12:20:00',4.1),('9303','2014-04-10','12:25:00',3.9),('9303','2014-04-10','12:30:00',3.97),('9303','2014-04-10','12:35:00',4.12),('9303','2014-04-10','12:40:00',4.05),('9303','2014-04-10','12:45:00',4.1),('9303','2014-04-10','12:50:00',4.01),('9303','2014-04-10','12:55:00',3.95),('9303','2014-04-10','13:00:00',3.93),('9303','2014-04-10','13:05:00',3.79),('9303','2014-04-10','13:10:00',3.87),('9303','2014-04-10','13:15:00',3.93),('9303','2014-04-10','13:20:00',3.82),('9303','2014-04-10','13:25:00',4.18),('9303','2014-04-10','13:30:00',4.06),('9303','2014-04-10','13:35:00',4.13),('9303','2014-04-10','13:40:00',4.04),('9303','2014-04-10','13:45:00',4.16),('9303','2014-04-10','13:50:00',4.09),('9303','2014-04-10','13:55:00',4.09),('9303','2014-04-10','14:00:00',4.1),('9303','2014-04-10','14:05:00',4.08),('9303','2014-04-10','14:10:00',4.05),('9303','2014-04-10','14:15:00',4.02),('9303','2014-04-10','14:20:00',4),('9303','2014-04-10','14:25:00',3.94),('9303','2014-04-10','14:30:00',3.89),('9303','2014-04-10','14:35:00',3.9),('9303','2014-04-10','14:40:00',3.88),('9303','2014-04-10','14:45:00',3.54),('9303','2014-04-10','14:50:00',3.87),('9303','2014-04-10','14:55:00',3.78),('9303','2014-04-10','15:00:00',3.73),('9303','2014-04-10','15:05:00',3.69),('9303','2014-04-10','15:10:00',3.62),('9303','2014-04-10','15:15:00',3.61),('9303','2014-04-10','15:20:00',3.6),('9303','2014-04-10','15:25:00',3.57),('9303','2014-04-10','15:30:00',3.23),('9303','2014-04-10','15:35:00',3.17),('9303','2014-04-10','15:40:00',3.19),('9303','2014-04-10','15:45:00',3.11),('9303','2014-04-10','15:50:00',3.15),('9303','2014-04-10','15:55:00',3.11),('9303','2014-04-10','16:00:00',3),('9303','2014-04-10','16:05:00',3.08),('9303','2014-04-10','16:10:00',3.05),('9303','2014-04-10','16:15:00',3.1),('9303','2014-04-10','16:20:00',2.89),('9303','2014-04-10','16:25:00',2.92),('9303','2014-04-10','16:30:00',2.83),('9303','2014-04-10','16:35:00',2.77),('9303','2014-04-10','16:40:00',2.73),('9303','2014-04-10','16:45:00',2.66),('9303','2014-04-10','16:50:00',2.47),('9303','2014-04-10','16:55:00',2.33),('9303','2014-04-10','17:00:00',2.22),('9303','2014-04-10','17:05:00',2.16),('9303','2014-04-10','17:10:00',2.03),('9303','2014-04-10','17:15:00',1.94),('9303','2014-04-10','17:20:00',1.88),('9303','2014-04-10','17:25:00',1.77),('9303','2014-04-10','17:30:00',1.65),('9303','2014-04-10','17:35:00',1.54),('9303','2014-04-10','17:40:00',1.45),('9303','2014-04-10','17:45:00',1.34),('9303','2014-04-10','17:50:00',1.24),('9303','2014-04-10','17:55:00',1.13),('9303','2014-04-10','18:00:00',1.02),('9303','2013-08-19','08:15:00',1.06),('9303','2013-08-19','08:20:00',1.14),('9303','2013-08-19','08:25:00',1.25),('9303','2013-08-19','08:30:00',1.31),('9303','2013-08-19','08:35:00',1.38),('9303','2013-08-19','08:40:00',1.48),('9303','2013-08-19','08:45:00',1.57),('9303','2013-08-19','08:50:00',1.67),('9303','2013-08-19','08:55:00',1.76),('9303','2013-08-19','09:00:00',1.84),('9303','2013-08-19','09:05:00',1.91),('9303','2013-08-19','09:10:00',1.99),('9303','2013-08-19','09:15:00',2.05),('9303','2013-08-19','09:20:00',2.13),('9303','2013-08-19','09:25:00',2.21),('9303','2013-08-19','09:30:00',2.25),('9303','2013-08-19','09:35:00',2.32),('9303','2013-08-19','09:40:00',2.4),('9303','2013-08-19','09:45:00',2.45),('9303','2013-08-19','09:50:00',2.53),('9303','2013-08-19','09:55:00',2.58),('9303','2013-08-19','10:00:00',2.64),('9303','2013-08-19','10:05:00',2.68),('9303','2013-08-19','10:10:00',2.74),('9303','2013-08-19','10:15:00',2.8),('9303','2013-08-19','10:20:00',2.88),('9303','2013-08-19','10:25:00',2.93),('9303','2013-08-19','10:30:00',2.99),('9303','2013-08-19','10:35:00',3.01),('9303','2013-08-19','10:40:00',3.05),('9303','2013-08-19','10:45:00',3.08),('9303','2013-08-19','10:50:00',3.11),('9303','2013-08-19','10:55:00',3.15),('9303','2013-08-19','11:00:00',3.17),('9303','2013-08-19','11:05:00',3.21),('9303','2013-08-19','11:10:00',3.25),('9303','2013-08-19','11:15:00',3.27),('9303','2013-08-19','11:20:00',3.3),('9303','2013-08-19','11:25:00',3.35),('9303','2013-08-19','11:30:00',3.38),('9303','2013-08-19','11:35:00',3.42),('9303','2013-08-19','11:40:00',3.43),('9303','2013-08-19','11:45:00',3.44),('9303','2013-08-19','11:50:00',3.48),('9303','2013-08-19','11:55:00',3.49),('9303','2013-08-19','12:00:00',3.41),('9303','2013-08-19','12:05:00',3.51),('9303','2013-08-19','12:10:00',3.6),('9303','2013-08-19','12:15:00',3.62),('9303','2013-08-19','12:20:00',3.64),('9303','2013-08-19','12:25:00',3.65),('9303','2013-08-19','12:30:00',3.66),('9303','2013-08-19','12:35:00',3.67),('9303','2013-08-19','12:40:00',3.68),('9303','2013-08-19','12:45:00',3.71),('9303','2013-08-19','12:50:00',3.73),('9303','2013-08-19','12:55:00',3.74),('9303','2013-08-19','13:00:00',3.73),('9303','2013-08-19','13:05:00',3.78),('9303','2013-08-19','13:10:00',3.77),('9303','2013-08-19','13:15:00',3.76),('9303','2013-08-19','13:20:00',3.77),('9303','2013-08-19','13:25:00',3.74),('9303','2013-08-19','13:30:00',3.77),('9303','2013-08-19','13:35:00',3.78),('9303','2013-08-19','13:40:00',3.76),('9303','2013-08-19','13:45:00',3.76),('9303','2013-08-19','13:50:00',3.74),('9303','2013-08-19','13:55:00',3.75),('9303','2013-08-19','14:00:00',3.73),('9303','2013-08-19','14:05:00',3.72),('9303','2013-08-19','14:10:00',3.71),('9303','2013-08-19','14:15:00',3.67),('9303','2013-08-19','14:20:00',3.63),('9303','2013-08-19','14:25:00',3.63),('9303','2013-08-19','14:30:00',3.63),('9303','2013-08-19','14:35:00',3.61),('9303','2013-08-19','14:40:00',3.57),('9303','2013-08-19','14:45:00',3.56),('9303','2013-08-19','14:50:00',3.51),('9303','2013-08-19','14:55:00',3.5),('9303','2013-08-19','15:00:00',3.47),('9303','2013-08-19','15:05:00',3.45),('9303','2013-08-19','15:10:00',3.43),('9303','2013-08-19','15:15:00',3.37),('9303','2013-08-19','15:20:00',3.3),('9303','2013-08-19','15:25:00',3.29),('9303','2013-08-19','15:30:00',3.23),('9303','2013-08-19','15:35:00',3.22),('9303','2013-08-19','15:40:00',3.15),('9303','2013-08-19','15:45:00',3.13),('9303','2013-08-19','15:50:00',3.08),('9303','2013-08-19','15:55:00',3.04),('9303','2013-08-19','16:00:00',2.98),('9303','2013-08-19','16:05:00',2.88),('9303','2013-08-19','16:10:00',2.81),('9303','2013-08-19','16:15:00',2.74),('9303','2013-08-19','16:20:00',2.73),('9303','2013-08-19','16:25:00',2.67),('9303','2013-08-19','16:30:00',2.6),('9303','2013-08-19','16:35:00',2.53),('9303','2013-08-19','16:40:00',2.46),('9303','2013-08-19','16:45:00',2.39),('9303','2013-08-19','16:50:00',2.32),('9303','2013-08-19','16:55:00',2.22),('9303','2013-08-19','17:00:00',2.11),('9303','2013-08-19','17:05:00',2),('9303','2013-08-19','17:10:00',1.91),('9303','2013-08-19','17:15:00',1.84),('9303','2013-08-19','17:20:00',1.77),('9303','2013-08-19','17:25:00',1.7),('9303','2013-08-19','17:30:00',1.61),('9303','2013-08-19','17:35:00',1.53),('9303','2013-08-19','17:40:00',1.47),('9303','2013-08-19','17:45:00',1.37),('9303','2013-08-19','17:50:00',1.29),('9303','2013-08-19','17:55:00',1.21),('9303','2013-08-19','18:00:00',1.11),('9303','2013-08-19','18:05:00',1.03),('9303','2013-08-18','08:10:00',1.03),('9303','2013-08-18','08:15:00',1.13),('9303','2013-08-18','08:20:00',1.21),('9303','2013-08-18','08:25:00',1.31),('9303','2013-08-18','08:30:00',1.39),('9303','2013-08-18','08:35:00',1.48),('9303','2013-08-18','08:40:00',1.58),('9303','2013-08-18','08:45:00',1.66),('9303','2013-08-18','08:50:00',1.73),('9303','2013-08-18','08:55:00',1.8),('9303','2013-08-18','09:00:00',1.88),('9303','2013-08-18','09:05:00',1.96),('9303','2013-08-18','09:10:00',2.03),('9303','2013-08-18','09:15:00',2.12),('9303','2013-08-18','09:20:00',2.19),('9303','2013-08-18','09:25:00',2.26),('9303','2013-08-18','09:30:00',2.34),('9303','2013-08-18','09:35:00',2.4),('9303','2013-08-18','09:40:00',2.52),('9303','2013-08-18','09:45:00',2.34),('9303','2013-08-18','09:50:00',2.58),('9303','2013-08-18','09:55:00',1.9),('9303','2013-08-18','10:00:00',2.66),('9303','2013-08-18','10:05:00',2.21),('9303','2013-08-18','10:10:00',2.49),('9303','2013-08-18','10:15:00',2.86),('9303','2013-08-18','10:20:00',2.9),('9303','2013-08-18','10:25:00',2.93),('9303','2013-08-18','10:30:00',2.97),('9303','2013-08-18','10:35:00',3.01),('9303','2013-08-18','10:40:00',3.06),('9303','2013-08-18','10:45:00',3.09),('9303','2013-08-18','10:50:00',3.12),('9303','2013-08-18','10:55:00',3.12),('9303','2013-08-18','11:00:00',3.12),('9303','2013-08-18','11:05:00',3.23),('9303','2013-08-18','11:10:00',3.28),('9303','2013-08-18','11:15:00',3.31),('9303','2013-08-18','11:20:00',3.35),('9303','2013-08-18','11:25:00',3.34),('9303','2013-08-18','11:30:00',3.37),('9303','2013-08-18','11:35:00',3.38),('9303','2013-08-18','11:40:00',3.41),('9303','2013-08-18','11:45:00',3.47),('9303','2013-08-18','11:50:00',3.49),('9303','2013-08-18','11:55:00',3.49),('9303','2013-08-18','12:00:00',3.48),('9303','2013-08-18','12:05:00',3.5),('9303','2013-08-18','12:10:00',3.45),('9303','2013-08-18','12:15:00',3.23),('9303','2013-08-18','12:20:00',3.72),('9303','2013-08-18','12:25:00',3.74),('9303','2013-08-18','12:30:00',3.61),('9303','2013-08-18','12:35:00',2.61),('9303','2013-08-18','12:40:00',3.38),('9303','2013-08-18','12:45:00',3.25),('9303','2013-08-18','12:50:00',3.52),('9303','2013-08-18','12:55:00',1.23),('9303','2013-08-18','13:00:00',1.06),('9303','2013-08-18','13:05:00',3.59),('9303','2013-08-18','13:10:00',3.97),('9303','2013-08-18','13:15:00',3.73),('9303','2013-08-18','13:20:00',3.76),('9303','2013-08-18','13:25:00',3.86),('9303','2013-08-18','13:30:00',3.49),('9303','2013-08-18','13:35:00',3.74),('9303','2013-08-18','13:40:00',3.81),('9303','2013-08-18','13:45:00',3.74),('9303','2013-08-18','13:50:00',3.76),('9303','2013-08-18','13:55:00',3.67),('9303','2013-08-18','14:00:00',3.79),('9303','2013-08-18','14:05:00',3.75),('9303','2013-08-18','14:10:00',3.72),('9303','2013-08-18','14:15:00',3.69),('9303','2013-08-18','14:20:00',3.68),('9303','2013-08-18','14:25:00',3.63),('9303','2013-08-18','14:30:00',3.64),('9303','2013-08-18','14:35:00',3.63),('9303','2013-08-18','14:40:00',3.61),('9303','2013-08-18','14:45:00',3.57),('9303','2013-08-18','14:50:00',3.53),('9303','2013-08-18','14:55:00',3.51),('9303','2013-08-18','15:00:00',3.47),('9303','2013-08-18','15:05:00',3.44),('9303','2013-08-18','15:10:00',3.4),('9303','2013-08-18','15:15:00',3.35),('9303','2013-08-18','15:20:00',3.29),('9303','2013-08-18','15:25:00',3.25),('9303','2013-08-18','15:30:00',3.22),('9303','2013-08-18','15:35:00',3.18),('9303','2013-08-18','15:40:00',3.14),('9303','2013-08-18','15:45:00',3.1),('9303','2013-08-18','15:50:00',3.05),('9303','2013-08-18','15:55:00',2.99),('9303','2013-08-18','16:00:00',2.95),('9303','2013-08-18','16:05:00',2.89),('9303','2013-08-18','16:10:00',2.81),('9303','2013-08-18','16:15:00',2.76),('9303','2013-08-18','16:20:00',2.71),('9303','2013-08-18','16:25:00',2.65),('9303','2013-08-18','16:30:00',2.58),('9303','2013-08-18','16:35:00',2.53),('9303','2013-08-18','16:40:00',2.45),('9303','2013-08-18','16:45:00',2.38),('9303','2013-08-18','16:50:00',2.32),('9303','2013-08-18','16:55:00',2.21),('9303','2013-08-18','17:00:00',2.12),('9303','2013-08-18','17:05:00',2.02),('9303','2013-08-18','17:10:00',1.93),('9303','2013-08-18','17:15:00',1.87),('9303','2013-08-18','17:20:00',1.79),('9303','2013-08-18','17:25:00',1.72),('9303','2013-08-18','17:30:00',1.64),('9303','2013-08-18','17:35:00',1.56),('9303','2013-08-18','17:40:00',1.48),('9303','2013-08-18','17:45:00',1.37),('9303','2013-08-18','17:50:00',1.29),('9303','2013-08-18','17:55:00',1.21),('9303','2013-08-18','18:00:00',1.11),('9303','2013-08-18','18:05:00',1.04),('9303','2013-08-17','08:15:00',1.06),('9303','2013-08-17','08:20:00',1.16),('9303','2013-08-17','08:25:00',1.25),('9303','2013-08-17','08:30:00',1.33),('9303','2013-08-17','08:35:00',1.43),('9303','2013-08-17','08:40:00',1.53),('9303','2013-08-17','08:45:00',1.62),('9303','2013-08-17','08:50:00',1.7),('9303','2013-08-17','08:55:00',1.79),('9303','2013-08-17','09:00:00',1.87),('9303','2013-08-17','09:05:00',1.95),('9303','2013-08-17','09:10:00',2.01),('9303','2013-08-17','09:15:00',2.07),('9303','2013-08-17','09:20:00',2.15),('9303','2013-08-17','09:25:00',2.24),('9303','2013-08-17','09:30:00',2.3),('9303','2013-08-17','09:35:00',2.37),('9303','2013-08-17','09:40:00',2.44),('9303','2013-08-17','09:45:00',2.51),('9303','2013-08-17','09:50:00',2.56),('9303','2013-08-17','09:55:00',2.62),('9303','2013-08-17','10:00:00',2.68),('9303','2013-08-17','10:05:00',2.73),('9303','2013-08-17','10:10:00',2.77),('9303','2013-08-17','10:15:00',2.81),('9303','2013-08-17','10:20:00',2.87),('9303','2013-08-17','10:25:00',2.94),('9303','2013-08-17','10:30:00',2.95),('9303','2013-08-17','10:35:00',3.02),('9303','2013-08-17','10:40:00',3.06),('9303','2013-08-17','10:45:00',3.11),('9303','2013-08-17','10:50:00',3.17),('9303','2013-08-17','10:55:00',3.2),('9303','2013-08-17','11:00:00',3.25),('9303','2013-08-17','11:05:00',3.27),('9303','2013-08-17','11:10:00',3.3),('9303','2013-08-17','11:15:00',3.32),('9303','2013-08-17','11:20:00',3.34),('9303','2013-08-17','11:25:00',3.39),('9303','2013-08-17','11:30:00',3.43),('9303','2013-08-17','11:35:00',3.45),('9303','2013-08-17','11:40:00',3.52),('9303','2013-08-17','11:45:00',3.53),('9303','2013-08-17','11:50:00',3.6),('9303','2013-08-17','11:55:00',3.59),('9303','2013-08-17','12:00:00',3.54),('9303','2013-08-17','12:05:00',3.6),('9303','2013-08-17','12:10:00',3.63),('9303','2013-08-17','12:15:00',3.59),('9303','2013-08-17','12:20:00',3.3),('9303','2013-08-17','12:25:00',3.67),('9303','2013-08-17','12:30:00',3.73),('9303','2013-08-17','12:35:00',2.58),('9303','2013-08-17','12:40:00',3.25),('9303','2013-08-17','12:45:00',3.75),('9303','2013-08-17','12:50:00',3.81),('9303','2013-08-17','12:55:00',3.76),('9303','2013-08-17','13:00:00',3.78),('9303','2013-08-17','13:05:00',3.75),('9303','2013-08-17','13:10:00',3.88),('9303','2013-08-17','13:15:00',3.84),('9303','2013-08-17','13:20:00',3.83),('9303','2013-08-17','13:25:00',3.87),('9303','2013-08-17','13:30:00',3.8),('9303','2013-08-17','13:35:00',3.29),('9303','2013-08-17','13:45:00',1.47),('9303','2013-08-17','13:50:00',1.26),('9303','2013-08-17','14:00:00',2.77),('9303','2013-08-17','14:05:00',3.29),('9303','2013-08-17','14:10:00',3.69),('9303','2013-08-17','14:15:00',3.66),('9303','2013-08-17','14:20:00',3.8),('9303','2013-08-17','14:25:00',3.74),('9303','2013-08-17','14:30:00',3.63),('9303','2013-08-17','14:35:00',3.63),('9303','2013-08-17','14:40:00',3.52),('9303','2013-08-17','14:45:00',3.57),('9303','2013-08-17','14:50:00',3.61),('9303','2013-08-17','14:55:00',3.5),('9303','2013-08-17','15:00:00',3.45),('9303','2013-08-17','15:05:00',3.42),('9303','2013-08-17','15:10:00',3.37),('9303','2013-08-17','15:15:00',3.33),('9303','2013-08-17','15:20:00',3.35),('9303','2013-08-17','15:25:00',3.28),('9303','2013-08-17','15:30:00',3.26),('9303','2013-08-17','15:35:00',3.23),('9303','2013-08-17','15:40:00',3.15),('9303','2013-08-17','15:45:00',3.09),('9303','2013-08-17','15:50:00',3.06),('9303','2013-08-17','15:55:00',3.01),('9303','2013-08-17','16:00:00',2.97),('9303','2013-08-17','16:05:00',2.89),('9303','2013-08-17','16:10:00',2.84),('9303','2013-08-17','16:15:00',2.79),('9303','2013-08-17','16:20:00',2.74),('9303','2013-08-17','16:25:00',2.68),('9303','2013-08-17','16:30:00',2.64),('9303','2013-08-17','16:35:00',2.58),('9303','2013-08-17','16:40:00',2.5),('9303','2013-08-17','16:45:00',2.41),('9303','2013-08-17','16:50:00',2.31),('9303','2013-08-17','16:55:00',2.29),('9303','2013-08-17','17:00:00',2.18),('9303','2013-08-17','17:05:00',2.06),('9303','2013-08-17','17:10:00',1.95),('9303','2013-08-17','17:15:00',1.67),('9303','2013-08-17','17:20:00',1.79),('9303','2013-08-17','17:25:00',1.77),('9303','2013-08-17','17:30:00',1.75),('9303','2013-08-17','17:35:00',1.67),('9303','2013-08-17','17:40:00',1.59),('9303','2013-08-17','17:45:00',1.49),('9303','2013-08-17','17:50:00',1.38),('9303','2013-08-17','17:55:00',1.31),('9303','2013-08-17','18:00:00',1.21),('9303','2013-08-17','18:05:00',1.12),('9303','2013-08-17','18:10:00',1.03),('9303','2013-08-16','08:10:00',1.02),('9303','2013-08-16','08:15:00',1.11),('9303','2013-08-16','08:20:00',1.21),('9303','2013-08-16','08:25:00',1.32),('9303','2013-08-16','08:30:00',1.4),('9303','2013-08-16','08:35:00',1.49),('9303','2013-08-16','08:40:00',1.59),('9303','2013-08-16','08:45:00',1.67),('9303','2013-08-16','08:50:00',1.75),('9303','2013-08-16','08:55:00',1.83),('9303','2013-08-16','09:00:00',1.92),('9303','2013-08-16','09:05:00',2),('9303','2013-08-16','09:10:00',2.09),('9303','2013-08-16','09:15:00',2.16),('9303','2013-08-16','09:20:00',2.25),('9303','2013-08-16','09:25:00',2.32),('9303','2013-08-16','09:30:00',2.4),('9303','2013-08-16','09:35:00',2.48),('9303','2013-08-16','09:40:00',2.53),('9303','2013-08-16','09:45:00',2.6),('9303','2013-08-16','09:50:00',2.67),('9303','2013-08-16','09:55:00',2.74),('9303','2013-08-16','10:00:00',2.79),('9303','2013-08-16','10:05:00',2.85),('9303','2013-08-16','10:10:00',2.91),('9303','2013-08-16','10:15:00',2.97),('9303','2013-08-16','10:20:00',3.01),('9303','2013-08-16','10:25:00',3.06),('9303','2013-08-16','10:30:00',3.12),('9303','2013-08-16','10:35:00',3.16),('9303','2013-08-16','10:40:00',3.22),('9303','2013-08-16','10:45:00',3.24),('9303','2013-08-16','10:50:00',3.3),('9303','2013-08-16','10:55:00',3.36),('9303','2013-08-16','11:00:00',3.4),('9303','2013-08-16','11:05:00',3.42),('9303','2013-08-16','11:10:00',3.45),('9303','2013-08-16','11:15:00',3.47),('9303','2013-08-16','11:20:00',3.49),('9303','2013-08-16','11:25:00',3.52),('9303','2013-08-16','11:30:00',3.54),('9303','2013-08-16','11:35:00',3.58),('9303','2013-08-16','11:40:00',3.57),('9303','2013-08-16','11:45:00',3.61),('9303','2013-08-16','11:50:00',3.63),('9303','2013-08-16','11:55:00',3.62),('9303','2013-08-16','12:00:00',3.69),('9303','2013-08-16','12:05:00',3.71),('9303','2013-08-16','12:10:00',3.75),('9303','2013-08-16','12:15:00',3.75),('9303','2013-08-16','12:20:00',3.8),('9303','2013-08-16','12:25:00',3.78),('9303','2013-08-16','12:30:00',3.78),('9303','2013-08-16','12:35:00',3.74),('9303','2013-08-16','12:40:00',3.76),('9303','2013-08-16','12:45:00',3.79),('9303','2013-08-16','12:50:00',3.75),('9303','2013-08-16','12:55:00',3.76),('9303','2013-08-16','13:00:00',3.75),('9303','2013-08-16','13:05:00',3.77),('9303','2013-08-16','13:10:00',3.76),('9303','2013-08-16','13:15:00',3.78),('9303','2013-08-16','13:20:00',3.78),('9303','2013-08-16','13:25:00',3.75),('9303','2013-08-16','13:30:00',3.75),('9303','2013-08-16','13:35:00',3.75),('9303','2013-08-16','13:40:00',3.76),('9303','2013-08-16','13:45:00',3.77),('9303','2013-08-16','13:50:00',3.78),('9303','2013-08-16','13:55:00',3.74),('9303','2013-08-16','14:00:00',3.72),('9303','2013-08-16','14:05:00',3.66),('9303','2013-08-16','14:10:00',3.68),('9303','2013-08-16','14:15:00',3.63),('9303','2013-08-16','14:20:00',3.63),('9303','2013-08-16','14:25:00',3.61),('9303','2013-08-16','14:30:00',3.58),('9303','2013-08-16','14:35:00',3.55),('9303','2013-08-16','14:40:00',3.51),('9303','2013-08-16','14:45:00',3.48),('9303','2013-08-16','14:50:00',3.5),('9303','2013-08-16','14:55:00',3.47),('9303','2013-08-16','15:00:00',3.42),('9303','2013-08-16','15:05:00',3.33),('9303','2013-08-16','15:10:00',3.33),('9303','2013-08-16','15:15:00',3.31),('9303','2013-08-16','15:20:00',3.25),('9303','2013-08-16','15:25:00',3.24),('9303','2013-08-16','15:30:00',3.24),('9303','2013-08-16','15:35:00',3.19),('9303','2013-08-16','15:40:00',3.13),('9303','2013-08-16','15:45:00',3.1),('9303','2013-08-16','15:50:00',3.03),('9303','2013-08-16','15:55:00',3),('9303','2013-08-16','16:00:00',2.95),('9303','2013-08-16','16:05:00',2.91),('9303','2013-08-16','16:10:00',2.85),('9303','2013-08-16','16:15:00',2.79),('9303','2013-08-16','16:20:00',2.72),('9303','2013-08-16','16:25:00',2.67),('9303','2013-08-16','16:30:00',2.6),('9303','2013-08-16','16:35:00',2.55),('9303','2013-08-16','16:40:00',2.49),('9303','2013-08-16','16:45:00',2.43),('9303','2013-08-16','16:50:00',2.35),('9303','2013-08-16','16:55:00',2.26),('9303','2013-08-16','17:00:00',2.15),('9303','2013-08-16','17:05:00',2.04),('9303','2013-08-16','17:10:00',1.94),('9303','2013-08-16','17:15:00',1.86),('9303','2013-08-16','17:20:00',1.78),('9303','2013-08-16','17:25:00',1.71),('9303','2013-08-16','17:30:00',1.63),('9303','2013-08-16','17:35:00',1.56),('9303','2013-08-16','17:40:00',1.48),('9303','2013-08-16','17:45:00',1.39),('9303','2013-08-16','17:50:00',1.3),('9303','2013-08-16','17:55:00',1.21),('9303','2013-08-16','18:00:00',1.13),('9303','2013-08-16','18:05:00',1.05),('9303','2013-08-15','08:10:00',1.01),('9303','2013-08-15','08:20:00',1.25),('9303','2013-08-15','08:25:00',1.37),('9303','2013-08-15','08:30:00',1.44),('9303','2013-08-15','08:35:00',1.53),('9303','2013-08-15','08:40:00',1.61),('9303','2013-08-15','08:45:00',1.71),('9303','2013-08-15','08:50:00',1.79),('9303','2013-08-15','08:55:00',1.87),('9303','2013-08-15','09:00:00',2.03),('9303','2013-08-15','09:05:00',1.92),('9303','2013-08-15','09:10:00',1.84),('9303','2013-08-15','09:15:00',1.57),('9303','2013-08-15','09:20:00',2.23),('9303','2013-08-15','09:25:00',2.25),('9303','2013-08-15','09:30:00',2.39),('9303','2013-08-15','09:35:00',2.46),('9303','2013-08-15','09:40:00',2.54),('9303','2013-08-15','09:45:00',2.61),('9303','2013-08-15','09:50:00',2.67),('9303','2013-08-15','09:55:00',2.74),('9303','2013-08-15','10:00:00',2.79),('9303','2013-08-15','10:05:00',2.85),('9303','2013-08-15','10:10:00',2.92),('9303','2013-08-15','10:15:00',2.97),('9303','2013-08-15','10:20:00',3.04),('9303','2013-08-15','10:25:00',3.08),('9303','2013-08-15','10:30:00',3.15),('9303','2013-08-15','10:35:00',3.18),('9303','2013-08-15','10:40:00',3.23),('9303','2013-08-15','10:45:00',3.29),('9303','2013-08-15','10:50:00',3.22),('9303','2013-08-15','10:55:00',2.93),('9303','2013-08-15','11:00:00',3.24),('9303','2013-08-15','11:05:00',3.11),('9303','2013-08-15','11:10:00',2.26),('9303','2013-08-15','11:15:00',2.46),('9303','2013-08-15','11:20:00',2.78),('9303','2013-08-15','11:25:00',3.15),('9303','2013-08-15','11:30:00',3.58),('9303','2013-08-15','11:35:00',3.76),('9303','2013-08-15','11:40:00',3.85),('9303','2013-08-15','11:45:00',3.92),('9303','2013-08-15','11:50:00',3.96),('9303','2013-08-15','11:55:00',3.98),('9303','2013-08-15','12:00:00',3.98),('9303','2013-08-15','12:05:00',3.95),('9303','2013-08-15','12:10:00',3.91),('9303','2013-08-15','12:15:00',3.94),('9303','2013-08-15','12:20:00',3.97),('9303','2013-08-15','12:25:00',3.96),('9303','2013-08-15','12:30:00',3.93),('9303','2013-08-15','12:35:00',3.99),('9303','2013-08-15','12:40:00',3.97),('9303','2013-08-15','12:45:00',3.97),('9303','2013-08-15','12:50:00',3.92),('9303','2013-08-15','12:55:00',3.73),('9303','2013-08-15','13:00:00',3.69),('9303','2013-08-15','13:05:00',3.78),('9303','2013-08-15','13:10:00',3.74),('9303','2013-08-15','13:15:00',3.69),('9303','2013-08-15','13:20:00',3.71),('9303','2013-08-15','13:25:00',3.77),('9303','2013-08-15','13:30:00',3.86),('9303','2013-08-15','13:35:00',3.88),('9303','2013-08-15','13:40:00',3.86),('9303','2013-08-15','13:45:00',3.84),('9303','2013-08-15','13:50:00',3.81),('9303','2013-08-15','13:55:00',3.71),('9303','2013-08-15','14:00:00',3.73),('9303','2013-08-15','14:05:00',3.74),('9303','2013-08-15','14:10:00',3.74),('9303','2013-08-15','14:15:00',3.75),('9303','2013-08-15','14:20:00',3.73),('9303','2013-08-15','14:25:00',3.64),('9303','2013-08-15','14:30:00',3.57),('9303','2013-08-15','14:35:00',3.64),('9303','2013-08-15','14:40:00',3.61),('9303','2013-08-15','14:45:00',3.55),('9303','2013-08-15','14:50:00',2.99),('9303','2013-08-15','14:55:00',3.45),('9303','2013-08-15','15:00:00',3.42),('9303','2013-08-15','15:05:00',3.38),('9303','2013-08-15','15:10:00',3.36),('9303','2013-08-15','15:15:00',3.31),('9303','2013-08-15','15:20:00',3.25),('9303','2013-08-15','15:25:00',3.19),('9303','2013-08-15','15:30:00',3.19),('9303','2013-08-15','15:35:00',3.14),('9303','2013-08-15','15:40:00',3.08),('9303','2013-08-15','15:45:00',3.02),('9303','2013-08-15','15:50:00',2.97),('9303','2013-08-15','15:55:00',2.95),('9303','2013-08-15','16:00:00',2.88),('9303','2013-08-15','16:05:00',2.78),('9303','2013-08-15','16:10:00',2.64),('9303','2013-08-15','16:15:00',2.69),('9303','2013-08-15','16:20:00',2.68),('9303','2013-08-15','16:25:00',2.56),('9303','2013-08-15','16:30:00',2.46),('9303','2013-08-15','16:35:00',2.43),('9303','2013-08-15','16:40:00',2.37),('9303','2013-08-15','16:45:00',2.31),('9303','2013-08-15','16:50:00',2.23),('9303','2013-08-15','16:55:00',2.12),('9303','2013-08-15','17:00:00',2.04),('9303','2013-08-15','17:05:00',1.96),('9303','2013-08-15','17:10:00',1.87),('9303','2013-08-15','17:15:00',1.82),('9303','2013-08-15','17:20:00',1.76),('9303','2013-08-15','17:25:00',1.63),('9303','2013-08-15','17:30:00',1.6),('9303','2013-08-15','17:35:00',1.52),('9303','2013-08-15','17:40:00',1.44),('9303','2013-08-15','17:45:00',1.37),('9303','2013-08-15','17:50:00',1.27),('9303','2013-08-15','17:55:00',1.2),('9303','2013-08-15','18:00:00',1.13),('9303','2013-08-15','18:05:00',1.04),('9303','2013-08-14','08:10:00',1),('9303','2013-08-14','08:15:00',1.11),('9303','2013-08-14','08:20:00',1.19),('9303','2013-08-14','08:25:00',1.21),('9303','2013-08-14','08:30:00',1.33),('9303','2013-08-14','08:35:00',1.45),('9303','2013-08-14','08:40:00',1.6),('9303','2013-08-14','08:45:00',1.76),('9303','2013-08-14','08:50:00',1.67),('9303','2013-08-14','08:55:00',1.72),('9303','2013-08-14','09:00:00',1.83),('9303','2013-08-14','09:05:00',1.93),('9303','2013-08-14','09:10:00',2.03),('9303','2013-08-14','09:15:00',2.13),('9303','2013-08-14','09:20:00',2.2),('9303','2013-08-14','09:25:00',2.14),('9303','2013-08-14','09:30:00',2.35),('9303','2013-08-14','09:35:00',2.49),('9303','2013-08-14','09:40:00',2.23),('9303','2013-08-14','09:55:00',1.05),('9303','2013-08-14','10:00:00',2.49),('9303','2013-08-14','10:05:00',2.73),('9303','2013-08-14','10:10:00',2.62),('9303','2013-08-14','10:15:00',2.01),('9303','2013-08-14','10:20:00',2.57),('9303','2013-08-14','10:25:00',2.74),('9303','2013-08-14','10:30:00',3.22),('9303','2013-08-14','10:35:00',3.34),('9303','2013-08-14','10:40:00',3.33),('9303','2013-08-14','10:45:00',2.06),('9303','2013-08-14','10:50:00',1.36),('9303','2013-08-14','10:55:00',1.12),('9303','2013-08-14','11:00:00',1.98),('9303','2013-08-14','11:05:00',2.76),('9303','2013-08-14','11:10:00',2.51),('9303','2013-08-14','11:15:00',3.29),('9303','2013-08-14','11:20:00',3.18),('9303','2013-08-14','11:25:00',3.02),('9303','2013-08-14','11:30:00',3.68),('9303','2013-08-14','11:35:00',3.6),('9303','2013-08-14','11:40:00',3.61),('9303','2013-08-14','11:45:00',2.21),('9303','2013-08-14','11:50:00',1.36),('9303','2013-08-14','11:55:00',1.74),('9303','2013-08-14','12:00:00',1.43),('9303','2013-08-14','12:05:00',2.95),('9303','2013-08-14','12:10:00',2.26),('9303','2013-08-14','12:15:00',1.28),('9303','2013-08-14','12:20:00',1.15),('9303','2013-08-14','12:25:00',3.11),('9303','2013-08-14','12:30:00',3.04),('9303','2013-08-14','12:35:00',1.93),('9303','2013-08-14','12:40:00',1.11),('9303','2013-08-14','12:45:00',1.03),('9303','2013-08-14','12:50:00',1.13),('9303','2013-08-14','12:55:00',1.95),('9303','2013-08-14','13:00:00',2.01),('9303','2013-08-14','13:25:00',1.23),('9303','2013-08-14','13:30:00',2.3),('9303','2013-08-14','13:35:00',1.78),('9303','2013-08-14','13:40:00',1.65),('9303','2013-08-14','13:45:00',4.18),('9303','2013-08-14','13:50:00',4.21),('9303','2013-08-14','13:55:00',2.38),('9303','2013-08-14','14:00:00',2.31),('9303','2013-08-14','14:05:00',4.1),('9303','2013-08-14','14:10:00',4.07),('9303','2013-08-14','14:15:00',3.93),('9303','2013-08-14','14:20:00',3.94),('9303','2013-08-14','14:25:00',3.86),('9303','2013-08-14','14:30:00',3.25),('9303','2013-08-14','14:35:00',3.82),('9303','2013-08-14','14:40:00',3.72),('9303','2013-08-14','14:45:00',3.68),('9303','2013-08-14','14:50:00',3.69),('9303','2013-08-14','14:55:00',3.49),('9303','2013-08-14','15:00:00',3.52),('9303','2013-08-14','15:05:00',3.47),('9303','2013-08-14','15:10:00',3.43),('9303','2013-08-14','15:15:00',3.06),('9303','2013-08-14','15:20:00',3.5),('9303','2013-08-14','15:25:00',3.4),('9303','2013-08-14','15:30:00',3.27),('9303','2013-08-14','15:35:00',3.2),('9303','2013-08-14','15:40:00',3.18),('9303','2013-08-14','15:45:00',3.13),('9303','2013-08-14','15:50:00',3.1),('9303','2013-08-14','15:55:00',3.04),('9303','2013-08-14','16:00:00',3),('9303','2013-08-14','16:05:00',2.96),('9303','2013-08-14','16:10:00',2.92),('9303','2013-08-14','16:15:00',2.86),('9303','2013-08-14','16:20:00',2.82),('9303','2013-08-14','16:25:00',2.73),('9303','2013-08-14','16:30:00',2.65),('9303','2013-08-14','16:35:00',2.61),('9303','2013-08-14','16:40:00',2.55),('9303','2013-08-14','16:45:00',2.47),('9303','2013-08-14','16:50:00',2.41),('9303','2013-08-14','16:55:00',2.34),('9303','2013-08-14','17:00:00',2.21),('9303','2013-08-14','17:05:00',2.09),('9303','2013-08-14','17:10:00',1.99),('9303','2013-08-14','17:15:00',1.93),('9303','2013-08-14','17:20:00',1.84),('9303','2013-08-14','17:25:00',1.78),('9303','2013-08-14','17:30:00',1.71),('9303','2013-08-14','17:35:00',1.62),('9303','2013-08-14','17:40:00',1.55),('9303','2013-08-14','17:45:00',1.47),('9303','2013-08-14','17:50:00',1.37),('9303','2013-08-14','17:55:00',1.28),('9303','2013-08-14','18:00:00',1.2),('9303','2013-08-14','18:05:00',1.1),('9303','2013-08-14','18:10:00',1.02),('9303','2013-08-13','08:10:00',1.02),('9303','2013-08-13','08:15:00',1.12),('9303','2013-08-13','08:20:00',1.22),('9303','2013-08-13','08:25:00',1.31),('9303','2013-08-13','08:30:00',1.4),('9303','2013-08-13','08:35:00',1.52),('9303','2013-08-13','08:40:00',1.59),('9303','2013-08-13','08:45:00',1.67),('9303','2013-08-13','08:50:00',1.75),('9303','2013-08-13','08:55:00',1.83),('9303','2013-08-13','09:00:00',1.9),('9303','2013-08-13','09:05:00',1.99),('9303','2013-08-13','09:10:00',2.07),('9303','2013-08-13','09:15:00',2.14),('9303','2013-08-13','09:20:00',2.17),('9303','2013-08-13','09:25:00',2.22),('9303','2013-08-13','09:30:00',1.3),('9303','2013-08-13','09:35:00',2.36),('9303','2013-08-13','09:40:00',2.5),('9303','2013-08-13','09:45:00',2.56),('9303','2013-08-13','09:50:00',2.62),('9303','2013-08-13','09:55:00',2.67),('9303','2013-08-13','10:00:00',2.65),('9303','2013-08-13','10:05:00',2.82),('9303','2013-08-13','10:10:00',2.87),('9303','2013-08-13','10:15:00',2.9),('9303','2013-08-13','10:20:00',2.96),('9303','2013-08-13','10:25:00',2.99),('9303','2013-08-13','10:30:00',3.1),('9303','2013-08-13','10:35:00',3.12),('9303','2013-08-13','10:40:00',3.12),('9303','2013-08-13','10:45:00',3.16),('9303','2013-08-13','10:50:00',3.18),('9303','2013-08-13','10:55:00',3.2),('9303','2013-08-13','11:00:00',3.27),('9303','2013-08-13','11:05:00',3.3),('9303','2013-08-13','11:10:00',3.35),('9303','2013-08-13','11:15:00',3.37),('9303','2013-08-13','11:20:00',3.39),('9303','2013-08-13','11:25:00',3.41),('9303','2013-08-13','11:30:00',3.44),('9303','2013-08-13','11:35:00',3.42),('9303','2013-08-13','11:40:00',3.43),('9303','2013-08-13','11:45:00',3.47),('9303','2013-08-13','11:50:00',3.54),('9303','2013-08-13','11:55:00',3.64),('9303','2013-08-13','12:00:00',3.7),('9303','2013-08-13','12:05:00',3.73),('9303','2013-08-13','12:10:00',3.76),('9303','2013-08-13','12:15:00',3.88),('9303','2013-08-13','12:20:00',3.84),('9303','2013-08-13','12:25:00',3.96),('9303','2013-08-13','12:30:00',2.97),('9303','2013-08-13','12:35:00',3.99),('9303','2013-08-13','12:40:00',4.03),('9303','2013-08-13','12:45:00',2.82),('9303','2013-08-13','12:50:00',4.17),('9303','2013-08-13','12:55:00',2.25),('9303','2013-08-13','13:00:00',1.1),('9303','2013-08-13','13:05:00',1.14),('9303','2013-08-13','13:10:00',1.28),('9303','2013-08-13','13:15:00',1.18),('9303','2013-08-13','13:20:00',3.69),('9303','2013-08-13','13:25:00',4.27),('9303','2013-08-13','13:30:00',4.17),('9303','2013-08-13','13:35:00',4.09),('9303','2013-08-13','13:40:00',4.08),('9303','2013-08-13','13:45:00',4.12),('9303','2013-08-13','13:50:00',3.69),('9303','2013-08-13','13:55:00',3.54),('9303','2013-08-13','14:00:00',3.5),('9303','2013-08-13','14:05:00',4.06),('9303','2013-08-13','14:10:00',4.05),('9303','2013-08-13','14:15:00',4.03),('9303','2013-08-13','14:20:00',3.82),('9303','2013-08-13','14:25:00',3.25),('9303','2013-08-13','14:30:00',1.47),('9303','2013-08-13','14:35:00',4.24),('9303','2013-08-13','14:40:00',2.71),('9303','2013-08-13','14:45:00',3.87),('9303','2013-08-13','14:50:00',3.89),('9303','2013-08-13','14:55:00',3.83),('9303','2013-08-13','15:00:00',3.52),('9303','2013-08-13','15:05:00',3.49),('9303','2013-08-13','15:10:00',2.51),('9303','2013-08-13','15:15:00',3),('9303','2013-08-13','15:20:00',3.46),('9303','2013-08-13','15:25:00',3.4),('9303','2013-08-13','15:30:00',3.31),('9303','2013-08-13','15:35:00',3.28),('9303','2013-08-13','15:40:00',3.22),('9303','2013-08-13','15:45:00',3.18),('9303','2013-08-13','15:50:00',3.1),('9303','2013-08-13','15:55:00',3.04),('9303','2013-08-13','16:00:00',3),('9303','2013-08-13','16:05:00',2.91),('9303','2013-08-13','16:10:00',2.85),('9303','2013-08-13','16:15:00',2.8),('9303','2013-08-13','16:20:00',2.78),('9303','2013-08-13','16:25:00',2.7),('9303','2013-08-13','16:30:00',2.63),('9303','2013-08-13','16:35:00',2.58),('9303','2013-08-13','16:40:00',2.52),('9303','2013-08-13','16:45:00',2.45),('9303','2013-08-13','16:50:00',2.39),('9303','2013-08-13','16:55:00',2.31),('9303','2013-08-13','17:00:00',2.2),('9303','2013-08-13','17:05:00',2.1),('9303','2013-08-13','17:10:00',2),('9303','2013-08-13','17:15:00',1.91),('9303','2013-08-13','17:20:00',1.83),('9303','2013-08-13','17:25:00',1.76),('9303','2013-08-13','17:30:00',1.68),('9303','2013-08-13','17:35:00',1.6),('9303','2013-08-13','17:40:00',1.54),('9303','2013-08-13','17:45:00',1.46),('9303','2013-08-13','17:50:00',1.36),('9303','2013-08-13','17:55:00',1.28),('9303','2013-08-13','18:00:00',1.2),('9303','2013-08-13','18:05:00',1.1),('9303','2013-08-13','18:10:00',1.02),('9303','2013-08-10','08:10:00',1.07),('9303','2013-08-10','08:15:00',1.17),('9303','2013-08-10','08:20:00',1.27),('9303','2013-08-10','08:25:00',1.38),('9303','2013-08-10','08:30:00',1.48),('9303','2013-08-10','08:35:00',1.58),('9303','2013-08-10','08:40:00',1.65),('9303','2013-08-10','08:45:00',1.72),('9303','2013-08-10','08:50:00',1.8),('9303','2013-08-10','08:55:00',1.88),('9303','2013-08-10','09:00:00',1.96),('9303','2013-08-10','09:05:00',2.04),('9303','2013-08-10','09:10:00',2.12),('9303','2013-08-10','09:15:00',2.21),('9303','2013-08-10','09:20:00',2.28),('9303','2013-08-10','09:25:00',2.35),('9303','2013-08-10','09:30:00',2.42),('9303','2013-08-10','09:35:00',2.47),('9303','2013-08-10','09:40:00',2.52),('9303','2013-08-10','09:45:00',2.59),('9303','2013-08-10','09:50:00',2.65),('9303','2013-08-10','09:55:00',2.71),('9303','2013-08-10','10:00:00',2.77),('9303','2013-08-10','10:05:00',2.82),('9303','2014-04-09','08:20:00',1.05),('9303','2014-04-09','09:50:00',1.7),('9303','2014-04-09','09:55:00',2.84),('9303','2014-04-09','10:00:00',2.81),('9303','2014-04-09','10:05:00',2.82),('9303','2014-04-09','10:10:00',2.96),('9303','2014-04-09','10:15:00',3.16),('9303','2014-04-09','10:20:00',3.18),('9303','2014-04-09','10:25:00',2.82),('9303','2014-04-09','10:30:00',2.16),('9303','2014-04-09','10:35:00',3.42),('9303','2014-04-09','10:40:00',1.79),('9303','2014-04-09','10:45:00',1.16),('9303','2014-04-09','10:50:00',1.09),('9303','2014-04-09','10:55:00',1.24),('9303','2014-04-09','11:00:00',2.77),('9303','2014-04-09','11:05:00',4.1),('9303','2014-04-09','11:10:00',4.19),('9303','2014-04-09','11:15:00',3.93),('9303','2014-04-09','11:20:00',2.25),('9303','2014-04-09','11:35:00',1.26),('9303','2014-04-09','11:40:00',4.27),('9303','2014-04-09','11:45:00',3.31),('9303','2014-04-09','11:50:00',2.09),('9303','2014-04-09','11:55:00',4.38),('9303','2014-04-09','12:00:00',3.87),('9303','2014-04-09','12:05:00',3.62),('9303','2014-04-09','12:10:00',1.71),('9303','2014-04-09','12:15:00',1.41),('9303','2014-04-09','12:20:00',1.13),('9303','2014-04-09','13:20:00',1.44),('9303','2014-04-09','13:25:00',1.63),('9303','2014-04-09','13:30:00',1.35),('9303','2014-04-09','13:35:00',1.31),('9303','2014-04-09','13:40:00',1.17),('9303','2014-04-09','13:45:00',1.01),('9303','2014-04-09','14:05:00',1.27),('9303','2014-04-09','14:10:00',2.84),('9303','2014-04-09','14:15:00',2.49),('9303','2014-04-09','14:20:00',1.86),('9303','2014-04-09','14:25:00',1.8),('9303','2014-04-09','14:30:00',2.67),('9303','2014-04-09','14:35:00',3.73),('9303','2014-04-09','14:40:00',2.08),('9303','2014-04-09','14:45:00',2.05),('9303','2014-04-09','14:50:00',1.93),('9303','2014-04-09','14:55:00',2.11),('9303','2014-04-09','15:00:00',1.92),('9303','2014-04-09','15:05:00',4.36),('9303','2014-04-09','15:10:00',3.24),('9303','2014-04-09','15:15:00',3.71),('9303','2014-04-09','15:20:00',3.75),('9303','2014-04-09','15:25:00',1.85),('9303','2014-04-09','15:30:00',2.87),('9303','2014-04-09','15:35:00',1.65),('9303','2014-04-09','15:40:00',2.23),('9303','2014-04-09','15:45:00',2.08),('9303','2014-04-09','15:50:00',1.36),('9303','2014-04-09','15:55:00',1.29),('9303','2014-04-09','16:00:00',1.1),('9303','2014-04-09','16:05:00',1.96),('9303','2014-04-09','16:10:00',3),('9303','2014-04-09','16:15:00',3),('9303','2014-04-09','16:20:00',3.02),('9303','2014-04-09','16:25:00',2.85),('9303','2014-04-09','16:30:00',1.94),('9303','2014-04-09','16:35:00',1.33),('9303','2014-04-09','16:40:00',1.4),('9303','2014-04-09','16:45:00',1.61),('9303','2014-04-09','16:50:00',1.4),('9303','2014-04-09','16:55:00',1.44),('9303','2014-04-09','17:00:00',1.86),('9303','2014-04-09','17:05:00',2.18),('9303','2014-04-09','17:10:00',2.05),('9303','2014-04-09','17:15:00',1.84),('9303','2014-04-09','17:20:00',1.78),('9303','2014-04-09','17:25:00',1.77),('9303','2014-04-09','17:30:00',1.11),('9303','2014-04-09','17:45:00',1.09),('9303','2014-04-09','17:55:00',1.05),('9303','2013-08-09','08:40:00',1.31),('9303','2013-08-09','08:45:00',1.51),('9303','2013-08-09','08:50:00',1.6),('9303','2013-08-09','08:55:00',1.68),('9303','2013-08-09','09:00:00',1.67),('9303','2013-08-09','09:05:00',1.84),('9303','2013-08-09','09:10:00',1.91),('9303','2013-08-09','09:15:00',1.79),('9303','2013-08-09','09:20:00',1.59),('9303','2013-08-09','09:25:00',1.64),('9303','2013-08-09','09:30:00',2.04),('9303','2013-08-09','09:35:00',2.36),('9303','2013-08-09','09:40:00',1.89),('9303','2013-08-09','09:45:00',2.45),('9303','2013-08-09','09:50:00',2.46),('9303','2013-08-09','09:55:00',1.46),('9303','2013-08-09','10:00:00',1.76),('9303','2013-08-09','10:05:00',1.81),('9303','2013-08-09','10:10:00',2.02),('9303','2013-08-09','10:15:00',2.64),('9303','2013-08-09','10:20:00',2.6),('9303','2013-08-09','10:25:00',2.7),('9303','2013-08-09','10:30:00',2.79),('9303','2013-08-09','10:35:00',2.78),('9303','2013-08-09','10:40:00',2.89),('9303','2013-08-09','10:45:00',2.89),('9303','2013-08-09','10:50:00',2.93),('9303','2013-08-09','10:55:00',2.99),('9303','2013-08-09','11:00:00',3.02),('9303','2013-08-09','11:05:00',3.06),('9303','2013-08-09','11:10:00',3.11),('9303','2013-08-09','11:15:00',3.18),('9303','2013-08-09','11:20:00',3.2),('9303','2013-08-09','11:25:00',3.22),('9303','2013-08-09','11:30:00',3.24),('9303','2013-08-09','11:35:00',3.22),('9303','2013-08-09','11:40:00',3.25),('9303','2013-08-09','11:45:00',3.28),('9303','2013-08-09','11:50:00',3.34),('9303','2013-08-09','11:55:00',3.38),('9303','2013-08-09','12:00:00',3.41),('9303','2013-08-09','12:05:00',3.41),('9303','2013-08-09','12:10:00',3.44),('9303','2013-08-09','12:15:00',3.51),('9303','2013-08-09','12:20:00',3.61),('9303','2013-08-09','12:25:00',3.16),('9303','2013-08-09','12:30:00',2.45),('9303','2013-08-09','12:35:00',3.15),('9303','2013-08-09','12:40:00',3.56),('9303','2013-08-09','12:45:00',2.69),('9303','2013-08-09','12:50:00',2.81),('9303','2013-08-09','12:55:00',2.52),('9303','2013-08-09','13:00:00',1.35),('9303','2013-08-09','13:20:00',1.27),('9303','2013-08-09','13:25:00',1.94),('9303','2013-08-09','13:30:00',1.92),('9303','2013-08-09','13:35:00',1.36),('9303','2013-08-09','13:40:00',1.38),('9303','2013-08-09','13:45:00',1.28),('9303','2013-08-09','13:50:00',1.35),('9303','2013-08-09','13:55:00',1.18),('9303','2013-08-09','14:00:00',1.1),('9303','2013-08-09','14:05:00',1.2),('9303','2013-08-09','14:10:00',1.41),('9303','2013-08-09','15:05:00',1.11),('9303','2013-08-09','15:10:00',2.47),('9303','2013-08-09','15:15:00',2.4),('9303','2013-08-09','15:20:00',1.37),('9303','2013-08-09','15:25:00',1.12),('9303','2013-08-09','15:30:00',1.03),('9303','2013-08-09','15:35:00',1.84),('9303','2013-08-09','15:40:00',1.42),('9303','2013-08-09','15:45:00',2.74),('9303','2013-08-09','15:50:00',1.84),('9303','2013-08-09','15:55:00',1.84),('9303','2013-08-09','16:00:00',1.05),('9303','2013-08-09','16:50:00',1.37),('9303','2013-08-09','16:55:00',2.13),('9303','2013-08-09','17:00:00',1.21),('9303','2013-08-09','17:05:00',1.7),('9303','2013-08-08','08:15:00',1.03),('9303','2013-08-08','08:20:00',1.12),('9303','2013-08-08','08:25:00',1.2),('9303','2013-08-08','08:30:00',1.3),('9303','2013-08-08','08:35:00',1.38),('9303','2013-08-08','08:40:00',1.45),('9303','2013-08-08','08:45:00',1.51),('9303','2013-08-08','08:50:00',1.61),('9303','2013-08-08','08:55:00',1.68),('9303','2013-08-08','09:00:00',1.76),('9303','2013-08-08','09:05:00',1.82),('9303','2013-08-08','09:10:00',1.9),('9303','2013-08-08','09:15:00',1.97),('9303','2013-08-08','09:20:00',2.03),('9303','2013-08-08','09:25:00',2.1),('9303','2013-08-08','09:30:00',2.17),('9303','2013-08-08','09:35:00',2.24),('9303','2013-08-08','09:40:00',2.31),('9303','2013-08-08','09:45:00',2.37),('9303','2013-08-08','09:50:00',2.42),('9303','2013-08-08','09:55:00',2.47),('9303','2013-08-08','10:00:00',2.52),('9303','2013-08-08','10:05:00',2.58),('9303','2013-08-08','10:10:00',2.63),('9303','2013-08-08','10:15:00',2.69),('9303','2013-08-08','10:20:00',2.73),('9303','2013-08-08','10:25:00',2.78),('9303','2013-08-08','10:30:00',2.82),('9303','2013-08-08','10:35:00',2.86),('9303','2013-08-08','10:40:00',2.92),('9303','2013-08-08','10:45:00',2.94),('9303','2013-08-08','10:50:00',2.99),('9303','2013-08-08','10:55:00',3.04),('9303','2013-08-08','11:00:00',3.06),('9303','2013-08-08','11:05:00',3.11),('9303','2013-08-08','11:10:00',3.13),('9303','2013-08-08','11:15:00',3.15),('9303','2013-08-08','11:20:00',3.17),('9303','2013-08-08','11:25:00',3.19),('9303','2013-08-08','11:30:00',3.19),('9303','2013-08-08','11:35:00',3.25),('9303','2013-08-08','11:40:00',3.28),('9303','2013-08-08','11:45:00',3.29),('9303','2013-08-08','11:50:00',3.3),('9303','2013-08-08','11:55:00',3.35),('9303','2013-08-08','12:00:00',3.41),('9303','2013-08-08','12:05:00',3.39),('9303','2013-08-08','12:10:00',3.42),('9303','2013-08-08','12:15:00',3.46),('9303','2013-08-08','12:20:00',3.46),('9303','2013-08-08','12:25:00',3.47),('9303','2013-08-08','12:30:00',3.46),('9303','2013-08-08','12:35:00',3.53),('9303','2013-08-08','12:40:00',3.52),('9303','2013-08-08','12:45:00',3.54),('9303','2013-08-08','12:50:00',3.59),('9303','2013-08-08','12:55:00',3.62),('9303','2013-08-08','13:00:00',3.58),('9303','2013-08-08','13:05:00',3.63),('9303','2013-08-08','13:10:00',3.62),('9303','2013-08-08','13:15:00',3.62),('9303','2013-08-08','13:20:00',3.63),('9303','2013-08-08','13:25:00',3.62),('9303','2013-08-08','13:30:00',3.61),('9303','2013-08-08','13:35:00',3.61),('9303','2013-08-08','13:40:00',3.56),('9303','2013-08-08','13:45:00',3.53),('9303','2013-08-08','13:50:00',3.58),('9303','2013-08-08','13:55:00',3.54),('9303','2013-08-08','14:00:00',3.56),('9303','2013-08-08','14:05:00',3.51),('9303','2013-08-08','14:10:00',3.47),('9303','2013-08-08','14:15:00',3.44),('9303','2013-08-08','14:20:00',3.43),('9303','2013-08-08','14:25:00',3.41),('9303','2013-08-08','14:30:00',3.41),('9303','2013-08-08','14:35:00',3.41),('9303','2013-08-08','14:40:00',3.37),('9303','2013-08-08','14:45:00',3.34),('9303','2013-08-08','14:50:00',3.3),('9303','2013-08-08','14:55:00',3.26),('9303','2013-08-08','15:00:00',3.23),('9303','2013-08-08','15:05:00',3.18),('9303','2013-08-08','15:10:00',3.15),('9303','2013-08-08','15:15:00',3.14),('9303','2013-08-08','15:20:00',3.07),('9303','2013-08-08','15:25:00',3.04),('9303','2013-08-08','15:30:00',2.98),('9303','2013-08-08','15:35:00',2.95),('9303','2013-08-08','15:40:00',2.92),('9303','2013-08-08','15:45:00',2.89),('9303','2013-08-08','15:50:00',2.84),('9303','2013-08-08','15:55:00',2.78),('9303','2013-08-08','16:00:00',2.74),('9303','2013-08-08','16:05:00',2.69),('9303','2013-08-08','16:10:00',2.65),('9303','2013-08-08','16:15:00',2.62),('9303','2013-08-08','16:20:00',2.58),('9303','2013-08-08','16:25:00',2.54),('9303','2013-08-08','16:30:00',2.48),('9303','2013-08-08','16:35:00',2.42),('9303','2013-08-08','16:40:00',2.37),('9303','2013-08-08','16:45:00',2.29),('9303','2013-08-08','16:50:00',2.22),('9303','2013-08-08','16:55:00',2.16),('9303','2013-08-08','17:00:00',2.09),('9303','2013-08-08','17:05:00',1.97),('9303','2013-08-08','17:10:00',1.87),('9303','2013-08-08','17:15:00',1.78),('9303','2013-08-08','17:20:00',1.71),('9303','2013-08-08','17:25:00',1.63),('9303','2013-08-08','17:30:00',1.56),('9303','2013-08-08','17:35:00',1.49),('9303','2013-08-08','17:40:00',1.42),('9303','2013-08-08','17:45:00',1.35),('9303','2013-08-08','17:50:00',1.3),('9303','2013-08-08','17:55:00',1.19),('9303','2013-08-08','18:00:00',1.13),('9303','2013-08-08','18:05:00',1.06),('9303','2013-08-07','08:10:00',1.01),('9303','2013-08-07','08:15:00',1.08),('9303','2013-08-07','08:20:00',1.17),('9303','2013-08-07','08:25:00',1.25),('9303','2013-08-07','08:30:00',1.35),('9303','2013-08-07','08:35:00',1.43),('9303','2013-08-07','08:40:00',1.52),('9303','2013-08-07','08:45:00',1.6),('9303','2013-08-07','08:50:00',1.67),('9303','2013-08-07','08:55:00',1.73),('9303','2013-08-07','09:00:00',1.8),('9303','2013-08-07','09:05:00',1.87),('9303','2013-08-07','09:10:00',1.95),('9303','2013-08-07','09:15:00',2.01),('9303','2013-08-07','09:20:00',2.08),('9303','2013-08-07','09:25:00',2.15),('9303','2013-08-07','09:30:00',2.21),('9303','2013-08-07','09:35:00',2.31),('9303','2013-08-07','09:40:00',2.36),('9303','2013-08-07','09:45:00',2.41),('9303','2013-08-07','09:50:00',2.45),('9303','2013-08-07','09:55:00',2.48),('9303','2013-08-07','10:00:00',2.57),('9303','2013-08-07','10:05:00',2.64),('9303','2013-08-07','10:10:00',2.67),('9303','2013-08-07','10:15:00',2.72),('9303','2013-08-07','10:20:00',2.78),('9303','2013-08-07','10:25:00',2.81),('9303','2013-08-07','10:30:00',2.83),('9303','2013-08-07','10:35:00',2.88),('9303','2013-08-07','10:40:00',2.96),('9303','2013-08-07','10:45:00',2.99),('9303','2013-08-07','10:50:00',3.03),('9303','2013-08-07','10:55:00',3.05),('9303','2013-08-07','11:00:00',3.09),('9303','2013-08-07','11:05:00',3.12),('9303','2013-08-07','11:10:00',3.17),('9303','2013-08-07','11:15:00',3.21),('9303','2013-08-07','11:20:00',3.25),('9303','2013-08-07','11:25:00',3.29),('9303','2013-08-07','11:30:00',3.29),('9303','2013-08-07','11:35:00',3.34),('9303','2013-08-07','11:40:00',3.33),('9303','2013-08-07','11:45:00',3.33),('9303','2013-08-07','11:50:00',3.35),('9303','2013-08-07','11:55:00',3.37),('9303','2013-08-07','12:00:00',3.42),('9303','2013-08-07','12:05:00',3.43),('9303','2013-08-07','12:10:00',3.48),('9303','2013-08-07','12:15:00',3.48),('9303','2013-08-07','12:20:00',3.47),('9303','2013-08-07','12:25:00',3.45),('9303','2013-08-07','12:30:00',3.48),('9303','2013-08-07','12:35:00',3.44),('9303','2013-08-07','12:40:00',3.46),('9303','2013-08-07','12:45:00',3.45),('9303','2013-08-07','12:50:00',3.5),('9303','2013-08-07','12:55:00',3.56),('9303','2013-08-07','13:00:00',3.55),('9303','2013-08-07','13:05:00',3.5),('9303','2013-08-07','13:10:00',3.51),('9303','2013-08-07','13:15:00',3.55),('9303','2013-08-07','13:20:00',3.54),('9303','2013-08-07','13:25:00',3.53),('9303','2013-08-07','13:30:00',3.58),('9303','2013-08-07','13:35:00',3.57),('9303','2013-08-07','13:40:00',3.62),('9303','2013-08-07','13:45:00',3.58),('9303','2013-08-07','13:50:00',3.55),('9303','2013-08-07','13:55:00',3.6),('9303','2013-08-07','14:00:00',3.54),('9303','2013-08-07','14:05:00',3.61),('9303','2013-08-07','14:10:00',3.53),('9303','2013-08-07','14:15:00',3.48),('9303','2013-08-07','14:20:00',3.46),('9303','2013-08-07','14:25:00',3.43),('9303','2013-08-07','14:30:00',3.4),('9303','2013-08-07','14:35:00',3.35),('9303','2013-08-07','14:40:00',3.39),('9303','2013-08-07','14:45:00',3.39),('9303','2013-08-07','14:50:00',3.38),('9303','2013-08-07','14:55:00',3.34),('9303','2013-08-07','15:00:00',3.31),('9303','2013-08-07','15:05:00',3.26),('9303','2013-08-07','15:10:00',3.24),('9303','2013-08-07','15:15:00',3.18),('9303','2013-08-07','15:20:00',3.18),('9303','2013-08-07','15:25:00',3.12),('9303','2013-08-07','15:30:00',3.1),('9303','2013-08-07','15:35:00',3.04),('9303','2013-08-07','15:40:00',2.97),('9303','2013-08-07','15:45:00',2.95),('9303','2013-08-07','15:50:00',2.89),('9303','2013-08-07','15:55:00',2.87),('9303','2013-08-07','16:00:00',2.76),('9303','2013-08-07','16:05:00',2.73),('9303','2013-08-07','16:10:00',2.68),('9303','2013-08-07','16:15:00',2.64),('9303','2013-08-07','16:20:00',2.62),('9303','2013-08-07','16:25:00',2.57),('9303','2013-08-07','16:30:00',2.51),('9303','2013-08-07','16:35:00',2.45),('9303','2013-08-07','16:40:00',2.39),('9303','2013-08-07','16:45:00',2.32),('9303','2013-08-07','16:50:00',2.28),('9303','2013-08-07','16:55:00',2.21),('9303','2013-08-07','17:00:00',2.12),('9303','2013-08-07','17:05:00',2.01),('9303','2013-08-07','17:10:00',1.9),('9303','2013-08-07','17:15:00',1.8),('9303','2013-08-07','17:20:00',1.74),('9303','2013-08-07','17:25:00',1.68),('9303','2013-08-07','17:30:00',1.61),('9303','2013-08-07','17:35:00',1.53),('9303','2013-08-07','17:40:00',1.44),('9303','2013-08-07','17:45:00',1.38),('9303','2013-08-07','17:50:00',1.32),('9303','2013-08-07','17:55:00',1.22),('9303','2013-08-07','18:00:00',1.16),('9303','2013-08-07','18:05:00',1.06),('9303','2013-08-06','08:15:00',1.07),('9303','2013-08-06','08:20:00',1.16),('9303','2013-08-06','08:25:00',1.23),('9303','2013-08-06','08:30:00',1.33),('9303','2013-08-06','08:35:00',1.42),('9303','2013-08-06','08:40:00',1.49),('9303','2013-08-06','08:45:00',1.57),('9303','2013-08-06','08:50:00',1.64),('9303','2013-08-06','08:55:00',1.71),('9303','2013-08-06','09:00:00',1.78),('9303','2013-08-06','09:05:00',1.86),('9303','2013-08-06','09:10:00',1.94),('9303','2013-08-06','09:15:00',1.99),('9303','2013-08-06','09:20:00',2.05),('9303','2013-08-06','09:25:00',2.13),('9303','2013-08-06','09:30:00',2.2),('9303','2013-08-06','09:35:00',2.24),('9303','2013-08-06','09:40:00',2.3),('9303','2013-08-06','09:45:00',2.37),('9303','2013-08-06','09:50:00',2.44),('9303','2013-08-06','09:55:00',2.5),('9303','2013-08-06','10:00:00',2.53),('9303','2013-08-06','10:05:00',2.59),('9303','2013-08-06','10:10:00',2.64),('9303','2013-08-06','10:15:00',2.7),('9303','2013-08-06','10:20:00',2.76),('9303','2013-08-06','10:25:00',2.8),('9303','2013-08-06','10:30:00',2.82),('9303','2013-08-06','10:35:00',2.87),('9303','2013-08-06','10:40:00',2.91),('9303','2013-08-06','10:45:00',2.96),('9303','2013-08-06','10:50:00',3.01),('9303','2013-08-06','10:55:00',3.03),('9303','2013-08-06','11:00:00',3.08),('9303','2013-08-06','11:05:00',3.12),('9303','2013-08-06','11:10:00',3.14),('9303','2013-08-06','11:15:00',3.24),('9303','2013-08-06','11:20:00',3.25),('9303','2013-08-06','11:25:00',3.28),('9303','2013-08-06','11:30:00',3.27),('9303','2013-08-06','11:35:00',3.32),('9303','2013-08-06','11:40:00',3.36),('9303','2013-08-06','11:45:00',3.35),('9303','2013-08-06','11:50:00',3.39),('9303','2013-08-06','11:55:00',3.42),('9303','2013-08-06','12:00:00',3.46),('9303','2013-08-06','12:05:00',3.46),('9303','2013-08-06','12:10:00',3.48),('9303','2013-08-06','12:15:00',3.49),('9303','2013-08-06','12:20:00',3.43),('9303','2013-08-06','12:25:00',3.42),('9303','2013-08-06','12:30:00',3.46),('9303','2013-08-06','12:35:00',3.5),('9303','2013-08-06','12:40:00',3.51),('9303','2013-08-06','12:45:00',3.48),('9303','2013-08-06','12:50:00',3.5),('9303','2013-08-06','12:55:00',3.54),('9303','2013-08-06','13:00:00',3.53),('9303','2013-08-06','13:05:00',3.55),('9303','2013-08-06','13:10:00',3.59),('9303','2013-08-06','13:15:00',3.6),('9303','2013-08-06','13:20:00',3.59),('9303','2013-08-06','13:25:00',3.61),('9303','2013-08-06','13:30:00',3.59),('9303','2013-08-06','13:35:00',3.64),('9303','2013-08-06','13:40:00',3.68),('9303','2013-08-06','13:45:00',3.65),('9303','2013-08-06','13:50:00',3.67),('9303','2013-08-06','13:55:00',3.66),('9303','2013-08-06','14:00:00',3.66),('9303','2013-08-06','14:05:00',3.64),('9303','2013-08-06','14:10:00',3.65),('9303','2013-08-06','14:15:00',3.65),('9303','2013-08-06','14:20:00',3.62),('9303','2013-08-06','14:25:00',3.6),('9303','2013-08-06','14:30:00',3.58),('9303','2013-08-06','14:35:00',3.56),('9303','2013-08-06','14:40:00',3.52),('9303','2013-08-06','14:45:00',3.48),('9303','2013-08-06','14:50:00',3.46),('9303','2013-08-06','14:55:00',3.45),('9303','2013-08-06','15:00:00',3.43),('9303','2013-08-06','15:05:00',3.39),('9303','2013-08-06','15:10:00',3.35),('9303','2013-08-06','15:15:00',3.31),('9303','2013-08-06','15:20:00',3.28),('9303','2013-08-06','15:25:00',3.23),('9303','2013-08-06','15:30:00',3.19),('9303','2013-08-06','15:35:00',3.15),('9303','2013-08-06','15:40:00',3.11),('9303','2013-08-06','15:45:00',3.07),('9303','2013-08-06','15:50:00',3.03),('9303','2013-08-06','15:55:00',2.97),('9303','2013-08-06','16:00:00',2.91),('9303','2013-08-06','16:05:00',2.84),('9303','2013-08-06','16:10:00',2.79),('9303','2013-08-06','16:15:00',2.75),('9303','2013-08-06','16:20:00',2.69),('9303','2013-08-06','16:25:00',2.64),('9303','2013-08-06','16:30:00',2.58),('9303','2013-08-06','16:35:00',2.51),('9303','2013-08-06','16:40:00',2.45),('9303','2013-08-06','16:45:00',2.4),('9303','2013-08-06','16:50:00',2.33),('9303','2013-08-06','16:55:00',2.27),('9303','2013-08-06','17:00:00',2.19),('9303','2013-08-06','17:05:00',2.1),('9303','2013-08-06','17:10:00',1.99),('9303','2013-08-06','17:15:00',1.87),('9303','2013-08-06','17:20:00',1.79),('9303','2013-08-06','17:25:00',1.71),('9303','2013-08-06','17:30:00',1.64),('9303','2013-08-06','17:35:00',1.58),('9303','2013-08-06','17:40:00',1.49),('9303','2013-08-06','17:45:00',1.42),('9303','2013-08-06','17:50:00',1.35),('9303','2013-08-06','17:55:00',1.27),('9303','2013-08-06','18:00:00',1.19),('9303','2013-08-06','18:05:00',1.1),('9303','2013-08-06','18:10:00',1.02),('9303','2013-08-05','08:10:00',1.04),('9303','2013-08-05','08:15:00',1.12),('9303','2013-08-05','08:20:00',1.2),('9303','2013-08-05','08:25:00',1.28),('9303','2013-08-05','08:30:00',1.37),('9303','2013-08-05','08:35:00',1.46),('9303','2013-08-05','08:40:00',1.55),('9303','2013-08-05','08:45:00',1.62),('9303','2013-08-05','08:50:00',1.7),('9303','2013-08-05','08:55:00',1.77),('9303','2013-08-05','09:00:00',1.84),('9303','2013-08-05','09:05:00',1.91),('9303','2013-08-05','09:10:00',1.97),('9303','2013-08-05','09:15:00',2.02),('9303','2013-08-05','09:20:00',2.09),('9303','2013-08-05','09:25:00',2.16),('9303','2013-08-05','09:30:00',2.22),('9303','2013-08-05','09:35:00',2.28),('9303','2013-08-05','09:40:00',2.33),('9303','2013-08-05','09:45:00',2.4),('9303','2013-08-05','09:50:00',2.47),('9303','2013-08-05','09:55:00',2.54),('9303','2013-08-05','10:00:00',2.6),('9303','2013-08-05','10:05:00',2.64),('9303','2013-08-05','10:10:00',2.7),('9303','2013-08-05','10:15:00',2.74),('9303','2013-08-05','10:20:00',2.83),('9303','2013-08-05','10:25:00',2.87),('9303','2013-08-05','10:30:00',2.9),('9303','2013-08-05','10:35:00',2.95),('9303','2013-08-05','10:40:00',2.99),('9303','2013-08-05','10:45:00',3.06),('9303','2013-08-05','10:50:00',3.12),('9303','2013-08-05','10:55:00',3.14),('9303','2013-08-05','11:00:00',3.19),('9303','2013-08-05','11:05:00',3.23),('9303','2013-08-05','11:10:00',3.26),('9303','2013-08-05','11:15:00',3.3),('9303','2013-08-05','11:20:00',3.37),('9303','2013-08-05','11:25:00',3.36),('9303','2013-08-05','11:30:00',3.38),('9303','2013-08-05','11:35:00',3.41),('9303','2013-08-05','11:40:00',3.42),('9303','2013-08-05','11:45:00',3.47),('9303','2013-08-05','11:50:00',3.49),('9303','2013-08-05','11:55:00',3.5),('9303','2013-08-05','12:00:00',3.54),('9303','2013-08-05','12:05:00',3.55),('9303','2013-08-05','12:10:00',3.57),('9303','2013-08-05','12:15:00',3.57),('9303','2013-08-05','12:20:00',3.59),('9303','2013-08-05','12:25:00',3.59),('9303','2013-08-05','12:30:00',3.56),('9303','2013-08-05','12:35:00',3.61),('9303','2013-08-05','12:40:00',3.65),('9303','2013-08-05','12:45:00',3.61),('9303','2013-08-05','12:50:00',3.62),('9303','2013-08-05','12:55:00',3.63),('9303','2013-08-05','13:00:00',3.66),('9303','2013-08-05','13:05:00',3.64),('9303','2013-08-05','13:10:00',3.61),('9303','2013-08-05','13:15:00',3.66),('9303','2013-08-05','13:20:00',3.65),('9303','2013-08-05','13:25:00',3.63),('9303','2013-08-05','13:30:00',3.67),('9303','2013-08-05','13:35:00',3.64),('9303','2013-08-05','13:40:00',3.63),('9303','2013-08-05','13:45:00',3.58),('9303','2013-08-05','13:50:00',3.5),('9303','2013-08-05','13:55:00',3.56),('9303','2013-08-05','14:00:00',3.59),('9303','2013-08-05','14:05:00',3.61),('9303','2013-08-05','14:10:00',3.55),('9303','2013-08-05','14:15:00',3.53),('9303','2013-08-05','14:20:00',3.51),('9303','2013-08-05','14:25:00',3.48),('9303','2013-08-05','14:30:00',3.49),('9303','2013-08-05','14:35:00',3.46),('9303','2013-08-05','14:40:00',3.46),('9303','2013-08-05','14:45:00',3.41),('9303','2013-08-05','14:50:00',3.39),('9303','2013-08-05','14:55:00',3.34),('9303','2013-08-05','15:00:00',3.32),('9303','2013-08-05','15:05:00',3.31),('9303','2013-08-05','15:10:00',3.3),('9303','2013-08-05','15:15:00',3.25),('9303','2013-08-05','15:20:00',3.2),('9303','2013-08-05','15:25:00',3.19),('9303','2013-08-05','15:30:00',3.17),('9303','2013-08-05','15:35:00',3.13),('9303','2013-08-05','15:40:00',3.07),('9303','2013-08-05','15:45:00',3),('9303','2013-08-05','15:50:00',2.95),('9303','2013-08-05','15:55:00',2.92),('9303','2013-08-05','16:00:00',2.88),('9303','2013-08-05','16:05:00',2.85),('9303','2013-08-05','16:10:00',2.79),('9303','2013-08-05','16:15:00',2.73),('9303','2013-08-05','16:20:00',2.66),('9303','2013-08-05','16:25:00',2.59),('9303','2013-08-05','16:30:00',2.55),('9303','2013-08-05','16:35:00',2.51),('9303','2013-08-05','16:40:00',2.44),('9303','2013-08-05','16:45:00',2.38),('9303','2013-08-05','16:50:00',2.31),('9303','2013-08-05','16:55:00',2.23),('9303','2013-08-05','17:00:00',2.16),('9303','2013-08-05','17:05:00',2.07),('9303','2013-08-05','17:10:00',1.96),('9303','2013-08-05','17:15:00',1.86),('9303','2013-08-05','17:20:00',1.79),('9303','2013-08-05','17:25:00',1.71),('9303','2013-08-05','17:30:00',1.64),('9303','2013-08-05','17:35:00',1.56),('9303','2013-08-05','17:40:00',1.5),('9303','2013-08-05','17:45:00',1.43),('9303','2013-08-05','17:50:00',1.36),('9303','2013-08-05','17:55:00',1.27),('9303','2013-08-05','18:00:00',1.17),('9303','2013-08-05','18:05:00',1.07),('9303','2013-08-04','08:05:00',1.01),('9303','2013-08-04','08:10:00',1.09),('9303','2013-08-04','08:15:00',1.19),('9303','2013-08-04','08:20:00',1.29),('9303','2013-08-04','08:25:00',1.36),('9303','2013-08-04','08:30:00',1.47),('9303','2013-08-04','08:35:00',1.57),('9303','2013-08-04','08:40:00',1.64),('9303','2013-08-04','08:45:00',1.73),('9303','2013-08-04','08:50:00',1.81),('9303','2013-08-04','08:55:00',1.88),('9303','2013-08-04','09:00:00',1.95),('9303','2013-08-04','09:05:00',2.02),('9303','2013-08-04','09:10:00',2.09),('9303','2013-08-04','09:15:00',2.16),('9303','2013-08-04','09:20:00',2.22),('9303','2013-08-04','09:25:00',2.3),('9303','2013-08-04','09:30:00',2.35),('9303','2013-08-04','09:35:00',2.43),('9303','2013-08-04','09:40:00',2.5),('9303','2013-08-04','09:45:00',2.55),('9303','2013-08-04','09:50:00',2.6),('9303','2013-08-04','09:55:00',2.67),('9303','2013-08-04','10:00:00',2.72),('9303','2013-08-04','10:05:00',2.77),('9303','2013-08-04','10:10:00',2.83),('9303','2013-08-04','10:15:00',2.87),('9303','2013-08-04','10:20:00',2.92),('9303','2013-08-04','10:25:00',2.97),('9303','2013-08-04','10:30:00',3.01),('9303','2013-08-04','10:35:00',3.05),('9303','2013-08-04','10:40:00',3.09),('9303','2013-08-04','10:45:00',3.13),('9303','2013-08-04','10:50:00',3.16),('9303','2013-08-04','10:55:00',3.18),('9303','2013-08-04','11:00:00',3.23),('9303','2013-08-04','11:05:00',3.29),('9303','2013-08-04','11:10:00',3.3),('9303','2013-08-04','11:15:00',3.32),('9303','2013-08-04','11:20:00',3.38),('9303','2013-08-04','11:25:00',3.45),('9303','2013-08-04','11:30:00',3.49),('9303','2013-08-04','11:35:00',3.51),('9303','2013-08-04','11:40:00',3.53),('9303','2013-08-04','11:45:00',3.53),('9303','2013-08-04','11:50:00',3.58),('9303','2013-08-04','11:55:00',3.61),('9303','2013-08-04','12:00:00',3.63),('9303','2013-08-04','12:05:00',3.65),('9303','2013-08-04','12:10:00',3.65),('9303','2013-08-04','12:15:00',3.64),('9303','2013-08-04','12:20:00',3.66),('9303','2013-08-04','12:25:00',3.68),('9303','2013-08-04','12:30:00',3.7),('9303','2013-08-04','12:35:00',3.71),('9303','2013-08-04','12:40:00',3.73),('9303','2013-08-04','12:45:00',3.74),('9303','2013-08-04','12:50:00',3.72),('9303','2013-08-04','12:55:00',3.72),('9303','2013-08-04','13:00:00',3.77),('9303','2013-08-04','13:05:00',3.72),('9303','2013-08-04','13:10:00',3.69),('9303','2013-08-04','13:15:00',3.73),('9303','2013-08-04','13:20:00',3.67),('9303','2013-08-04','13:25:00',3.66),('9303','2013-08-04','13:30:00',3.68),('9303','2013-08-04','13:35:00',3.76),('9303','2013-08-04','13:40:00',3.78),('9303','2013-08-04','13:45:00',3.8),('9303','2013-08-04','13:50:00',3.76),('9303','2013-08-04','13:55:00',3.76),('9303','2013-08-04','14:00:00',3.76),('9303','2013-08-04','14:05:00',3.75),('9303','2013-08-04','14:10:00',3.71),('9303','2013-08-04','14:15:00',3.69),('9303','2013-08-04','14:20:00',3.67),('9303','2013-08-04','14:25:00',3.65),('9303','2013-08-04','14:30:00',3.64),('9303','2013-08-04','14:35:00',3.64),('9303','2013-08-04','14:40:00',3.62),('9303','2013-08-04','14:45:00',3.55),('9303','2013-08-04','14:50:00',2.99),('9303','2013-08-04','14:55:00',3.53),('9303','2013-08-04','15:00:00',3.5),('9303','2013-08-04','15:05:00',3.45),('9303','2013-08-04','15:10:00',3.45),('9303','2013-08-04','15:15:00',3.4),('9303','2013-08-04','15:20:00',3.36),('9303','2013-08-04','15:25:00',3.29),('9303','2013-08-04','15:30:00',3.21),('9303','2013-08-04','15:35:00',3.24),('9303','2013-08-04','15:40:00',3.17),('9303','2013-08-04','15:45:00',3.14),('9303','2013-08-04','15:50:00',3.07),('9303','2013-08-04','15:55:00',3.01),('9303','2013-08-04','16:00:00',2.97),('9303','2013-08-04','16:05:00',2.91),('9303','2013-08-04','16:10:00',2.86),('9303','2013-08-04','16:15:00',2.82),('9303','2013-08-04','16:20:00',2.79),('9303','2013-08-04','16:25:00',2.72),('9303','2013-08-04','16:30:00',2.65),('9303','2013-08-04','16:35:00',2.58),('9303','2013-08-04','16:40:00',2.53),('9303','2013-08-04','16:45:00',2.44),('9303','2013-08-04','16:50:00',2.37),('9303','2013-08-04','16:55:00',2.32),('9303','2013-08-04','17:00:00',2.24),('9303','2013-08-04','17:05:00',2.17),('9303','2013-08-04','17:10:00',2.07),('9303','2013-08-04','17:15:00',1.95),('9303','2013-08-04','17:20:00',1.86),('9303','2013-08-04','17:25:00',1.78),('9303','2013-08-04','17:30:00',1.71),('9303','2013-08-04','17:35:00',1.63),('9303','2013-08-04','17:40:00',1.55),('9303','2013-08-04','17:45:00',1.48),('9303','2013-08-04','17:50:00',1.41),('9303','2013-08-04','17:55:00',1.31),('9303','2013-08-04','18:00:00',1.22),('9303','2013-08-04','18:05:00',1.12),('9303','2013-08-04','18:10:00',1.04),('9303','2013-08-03','08:05:00',1.01),('9303','2013-08-03','08:10:00',1.09),('9303','2013-08-03','08:15:00',1.17),('9303','2013-08-03','08:20:00',1.27),('9303','2013-08-03','08:25:00',1.35),('9303','2013-08-03','08:30:00',1.44),('9303','2013-08-03','08:35:00',1.54),('9303','2013-08-03','08:40:00',1.62),('9303','2013-08-03','08:45:00',1.7),('9303','2013-08-03','08:50:00',1.77),('9303','2013-08-03','08:55:00',1.85),('9303','2013-08-03','09:00:00',1.94),('9303','2013-08-03','09:05:00',2.01),('9303','2013-08-03','09:10:00',2.07),('9303','2013-08-03','09:15:00',2.15),('9303','2013-08-03','09:20:00',2.22),('9303','2013-08-03','09:25:00',2.28),('9303','2013-08-03','09:30:00',2.35),('9303','2013-08-03','09:35:00',2.41),('9303','2013-08-03','09:40:00',2.46),('9303','2013-08-03','09:45:00',2.53),('9303','2013-08-03','09:50:00',2.59),('9303','2013-08-03','09:55:00',2.65),('9303','2013-08-03','10:00:00',2.71),('9303','2013-08-03','10:05:00',2.76),('9303','2013-08-03','10:10:00',2.82),('9303','2013-08-03','10:15:00',2.84),('9303','2013-08-03','10:20:00',2.85),('9303','2013-08-03','10:25:00',2.94),('9303','2013-08-03','10:30:00',2.98),('9303','2013-08-03','10:35:00',3.06),('9303','2013-08-03','10:40:00',3.13),('9303','2013-08-03','10:45:00',3.14),('9303','2013-08-03','10:50:00',3.18),('9303','2013-08-03','10:55:00',3.23),('9303','2013-08-03','11:00:00',3.29),('9303','2013-08-03','11:05:00',3.3),('9303','2013-08-03','11:10:00',3.36),('9303','2013-08-03','11:15:00',3.36),('9303','2013-08-03','11:20:00',3.38),('9303','2013-08-03','11:25:00',3.43),('9303','2013-08-03','11:30:00',3.45),('9303','2013-08-03','11:35:00',3.46),('9303','2013-08-03','11:40:00',3.47),('9303','2013-08-03','11:45:00',3.5),('9303','2013-08-03','11:50:00',3.57),('9303','2013-08-03','11:55:00',3.58),('9303','2013-08-03','12:00:00',3.58),('9303','2013-08-03','12:05:00',3.61),('9303','2013-08-03','12:10:00',3.6),('9303','2013-08-03','12:15:00',3.65),('9303','2013-08-03','12:20:00',3.62),('9303','2013-08-03','12:25:00',3.63),('9303','2013-08-03','12:30:00',3.62),('9303','2013-08-03','12:35:00',3.62),('9303','2013-08-03','12:40:00',3.62),('9303','2013-08-03','12:45:00',3.67),('9303','2013-08-03','12:50:00',3.73),('9303','2013-08-03','12:55:00',3.69),('9303','2013-08-03','13:00:00',3.67),('9303','2013-08-03','13:05:00',3.63),('9303','2013-08-03','13:10:00',3.68),('9303','2013-08-03','13:15:00',3.64),('9303','2013-08-03','13:20:00',3.57),('9303','2013-08-03','13:25:00',3.61),('9303','2013-08-03','13:30:00',3.57),('9303','2013-08-03','13:35:00',3.53),('9303','2013-08-03','13:40:00',3.59),('9303','2013-08-03','13:45:00',3.63),('9303','2013-08-03','13:50:00',3.65),('9303','2013-08-03','13:55:00',3.69),('9303','2013-08-03','14:00:00',3.73),('9303','2013-08-03','14:05:00',3.71),('9303','2013-08-03','14:10:00',3.57),('9303','2013-08-03','14:15:00',3.45),('9303','2013-08-03','14:20:00',3.45),('9303','2013-08-03','14:25:00',3.41),('9303','2013-08-03','14:30:00',3.48),('9303','2013-08-03','14:35:00',3.57),('9303','2013-08-03','14:40:00',3.52),('9303','2013-08-03','14:45:00',3.53),('9303','2013-08-03','14:50:00',3.51),('9303','2013-08-03','14:55:00',3.5),('9303','2013-08-03','15:00:00',3.48),('9303','2013-08-03','15:05:00',3.42),('9303','2013-08-03','15:10:00',3.38),('9303','2013-08-03','15:15:00',3.32),('9303','2013-08-03','15:20:00',3.31),('9303','2013-08-03','15:25:00',3.31),('9303','2013-08-03','15:30:00',3.24),('9303','2013-08-03','15:35:00',3.22),('9303','2013-08-03','15:40:00',3.17),('9303','2013-08-03','15:45:00',3.12),('9303','2013-08-03','15:50:00',3.1),('9303','2013-08-03','15:55:00',3.03),('9303','2013-08-03','16:00:00',2.95),('9303','2013-08-03','16:05:00',2.91),('9303','2013-08-03','16:10:00',2.84),('9303','2013-08-03','16:15:00',2.76),('9303','2013-08-03','16:20:00',2.71),('9303','2013-08-03','16:25:00',2.66),('9303','2013-08-03','16:30:00',2.62),('9303','2013-08-03','16:35:00',2.55),('9303','2013-08-03','16:40:00',2.5),('9303','2013-08-03','16:45:00',2.44),('9303','2013-08-03','16:50:00',2.38),('9303','2013-08-03','16:55:00',2.32),('9303','2013-08-03','17:00:00',2.24),('9303','2013-08-03','17:05:00',2.16),('9303','2013-08-03','17:10:00',2.04),('9303','2013-08-03','17:15:00',1.94),('9303','2013-08-03','17:20:00',1.86),('9303','2013-08-03','17:25:00',1.79),('9303','2013-08-03','17:30:00',1.72),('9303','2013-08-03','17:35:00',1.66),('9303','2013-08-03','17:40:00',1.57),('9303','2013-08-03','17:45:00',1.5),('9303','2013-08-03','17:50:00',1.42),('9303','2013-08-03','17:55:00',1.34),('9303','2013-08-03','18:00:00',1.24),('9303','2013-08-03','18:05:00',1.14),('9303','2013-08-03','18:10:00',1.07),('9303','2013-08-02','08:05:00',1.07),('9303','2013-08-02','08:10:00',1.15),('9303','2013-08-02','08:15:00',1.25),('9303','2013-08-02','08:20:00',1.33),('9303','2013-08-02','08:25:00',1.42),('9303','2013-08-02','08:30:00',1.52),('9303','2013-08-02','08:35:00',1.61),('9303','2013-08-02','08:40:00',1.71),('9303','2013-08-02','08:45:00',1.79),('9303','2013-08-02','08:50:00',1.85),('9303','2013-08-02','08:55:00',1.93),('9303','2013-08-02','09:00:00',2.01),('9303','2013-08-02','09:05:00',2.08),('9303','2013-08-02','09:10:00',2.14),('9303','2013-08-02','09:15:00',2.23),('9303','2013-08-02','09:20:00',2.3),('9303','2013-08-02','09:25:00',2.36),('9303','2013-08-02','09:30:00',2.42),('9303','2013-08-02','09:35:00',2.49),('9303','2013-08-02','09:40:00',2.53),('9303','2013-08-02','09:45:00',2.59),('9303','2013-08-02','09:50:00',2.65),('9303','2013-08-02','09:55:00',2.7),('9303','2013-08-02','10:00:00',2.74),('9303','2013-08-02','10:05:00',2.8),('9303','2013-08-02','10:10:00',2.86),('9303','2013-08-02','10:15:00',2.92),('9303','2013-08-02','10:20:00',2.98),('9303','2013-08-02','10:25:00',3.02),('9303','2013-08-02','10:30:00',3.05),('9303','2013-08-02','10:35:00',3.11),('9303','2013-08-02','10:40:00',3.16),('9303','2013-08-02','10:45:00',3.19),('9303','2013-08-02','10:50:00',3.23),('9303','2013-08-02','10:55:00',3.28),('9303','2013-08-02','11:00:00',3.3),('9303','2013-08-02','11:05:00',3.34),('9303','2013-08-02','11:10:00',3.35),('9303','2013-08-02','11:15:00',3.39),('9303','2013-08-02','11:20:00',3.42),('9303','2013-08-02','11:25:00',3.5),('9303','2013-08-02','11:30:00',3.54),('9303','2013-08-02','11:35:00',3.54),('9303','2013-08-02','11:40:00',3.52),('9303','2013-08-02','11:45:00',3.61),('9303','2013-08-02','11:50:00',3.61),('9303','2013-08-02','11:55:00',3.69),('9303','2013-08-02','12:00:00',3.71),('9303','2013-08-02','12:05:00',3.72),('9303','2013-08-02','12:10:00',3.72),('9303','2013-08-02','12:15:00',3.69),('9303','2013-08-02','12:20:00',3.67),('9303','2013-08-02','12:25:00',3.69),('9303','2013-08-02','12:30:00',3.7),('9303','2013-08-02','12:35:00',3.71),('9303','2013-08-02','12:40:00',3.72),('9303','2013-08-02','12:45:00',3.72),('9303','2013-08-02','12:50:00',3.72),('9303','2013-08-02','12:55:00',3.7),('9303','2013-08-02','13:00:00',3.73),('9303','2013-08-02','13:05:00',3.78),('9303','2013-08-02','13:10:00',3.81),('9303','2013-08-02','13:15:00',3.8),('9303','2013-08-02','13:20:00',3.79),('9303','2013-08-02','13:25:00',3.78),('9303','2013-08-02','13:30:00',3.8),('9303','2013-08-02','13:35:00',3.8),('9303','2013-08-02','13:40:00',3.76),('9303','2013-08-02','13:45:00',3.71),('9303','2013-08-02','13:50:00',3.74),('9303','2013-08-02','13:55:00',3.74),('9303','2013-08-02','14:00:00',3.7),('9303','2013-08-02','14:05:00',3.67),('9303','2013-08-02','14:10:00',3.68),('9303','2013-08-02','14:15:00',3.64),('9303','2013-08-02','14:20:00',3.62),('9303','2013-08-02','14:25:00',3.57),('9303','2013-08-02','14:30:00',3.62),('9303','2013-08-02','14:35:00',3.64),('9303','2013-08-02','14:40:00',3.6),('9303','2013-08-02','14:45:00',3.6),('9303','2013-08-02','14:50:00',3.58),('9303','2013-08-02','14:55:00',3.55),('9303','2013-08-02','15:00:00',3.52),('9303','2013-08-02','15:05:00',3.51),('9303','2013-08-02','15:10:00',3.42),('9303','2013-08-02','15:15:00',3.34),('9303','2013-08-02','15:20:00',3.34),('9303','2013-08-02','15:25:00',3.33),('9303','2013-08-02','15:30:00',3.32),('9303','2013-08-02','15:35:00',3.28),('9303','2013-08-02','15:40:00',3.23),('9303','2013-08-02','15:45:00',3.2),('9303','2013-08-02','15:50:00',3.15),('9303','2013-08-02','15:55:00',3.06),('9303','2013-08-02','16:00:00',3),('9303','2013-08-02','16:05:00',2.96),('9303','2013-08-02','16:10:00',2.91),('9303','2013-08-02','16:15:00',2.84),('9303','2013-08-02','16:20:00',2.79),('9303','2013-08-02','16:25:00',2.72),('9303','2013-08-02','16:30:00',2.69),('9303','2013-08-02','16:35:00',2.64),('9303','2013-08-02','16:40:00',2.58),('9303','2013-08-02','16:45:00',2.52),('9303','2013-08-02','16:50:00',2.46),('9303','2013-08-02','16:55:00',2.37),('9303','2013-08-02','17:00:00',2.28),('9303','2013-08-02','17:05:00',2.19),('9303','2013-08-02','17:10:00',2.09),('9303','2013-08-02','17:15:00',2.01),('9303','2013-08-02','17:20:00',1.92),('9303','2013-08-02','17:25:00',1.86),('9303','2013-08-02','17:30:00',1.77),('9303','2013-08-02','17:35:00',1.69),('9303','2013-08-02','17:40:00',1.63),('9303','2013-08-02','17:45:00',1.54),('9303','2013-08-02','17:50:00',1.45),('9303','2013-08-02','17:55:00',1.38),('9303','2013-08-02','18:00:00',1.27),('9303','2013-08-02','18:05:00',1.19),('9303','2013-08-02','18:10:00',1.12),('9303','2013-08-02','18:15:00',1.02),('9303','2013-08-01','08:05:00',1.08),('9303','2013-08-01','08:10:00',1.16),('9303','2013-08-01','08:15:00',1.25),('9303','2013-08-01','08:20:00',1.35),('9303','2013-08-01','08:25:00',1.45),('9303','2013-08-01','08:30:00',1.55),('9303','2013-08-01','08:35:00',1.64),('9303','2013-08-01','08:40:00',1.75),('9303','2013-08-01','08:45:00',1.82),('9303','2013-08-01','08:50:00',1.91),('9303','2013-08-01','08:55:00',1.99),('9303','2013-08-01','09:00:00',2.06),('9303','2013-08-01','09:05:00',2.13),('9303','2013-08-01','09:10:00',2.21),('9303','2013-08-01','09:15:00',2.28),('9303','2013-08-01','09:20:00',2.36),('9303','2013-08-01','09:25:00',2.43),('9303','2013-08-01','09:30:00',2.49),('9303','2013-08-01','09:35:00',2.55),('9303','2013-08-01','09:40:00',2.62),('9303','2013-08-01','09:45:00',2.69),('9303','2013-08-01','09:50:00',2.76),('9303','2013-08-01','09:55:00',2.82),('9303','2013-08-01','10:00:00',2.9),('9303','2013-08-01','10:05:00',2.98),('9303','2013-08-01','10:10:00',3.05),('9303','2013-08-01','10:15:00',3.08),('9303','2013-08-01','10:20:00',3.12),('9303','2013-08-01','10:25:00',3.16),('9303','2013-08-01','10:30:00',3.22),('9303','2013-08-01','10:35:00',3.27),('9303','2013-08-01','10:40:00',3.31),('9303','2013-08-01','10:45:00',3.37),('9303','2013-08-01','10:50:00',3.43),('9303','2013-08-01','10:55:00',3.46),('9303','2013-08-01','11:00:00',3.5),('9303','2013-08-01','11:05:00',3.56),('9303','2013-08-01','11:10:00',3.6),('9303','2013-08-01','11:15:00',3.63),('9303','2013-08-01','11:20:00',3.66),('9303','2013-08-01','11:25:00',3.72),('9303','2013-08-01','11:30:00',3.73),('9303','2013-08-01','11:35:00',3.75),('9303','2013-08-01','11:40:00',3.8),('9303','2013-08-01','11:45:00',3.82),('9303','2013-08-01','11:50:00',3.85),('9303','2013-08-01','11:55:00',3.86),('9303','2013-08-01','12:00:00',3.9),('9303','2013-08-01','12:05:00',3.91),('9303','2013-08-01','12:10:00',3.91),('9303','2013-08-01','12:15:00',3.97),('9303','2013-08-01','12:20:00',3.96),('9303','2013-08-01','12:25:00',3.97),('9303','2013-08-01','12:30:00',3.97),('9303','2013-08-01','12:35:00',4.01),('9303','2013-08-01','12:40:00',4.02),('9303','2013-08-01','12:45:00',4.02),('9303','2013-08-01','12:50:00',4.05),('9303','2013-08-01','12:55:00',4.05),('9303','2013-08-01','13:00:00',4.03),('9303','2013-08-01','13:05:00',4.01),('9303','2013-08-01','13:10:00',4.01),('9303','2013-08-01','13:15:00',3.98),('9303','2013-08-01','13:20:00',4.02),('9303','2013-08-01','13:25:00',4.05),('9303','2013-08-01','13:30:00',3.92),('9303','2013-08-01','13:35:00',4.02),('9303','2013-08-01','13:40:00',4.06),('9303','2013-08-01','13:45:00',4.07),('9303','2013-08-01','13:50:00',4.08),('9303','2013-08-01','13:55:00',3.96),('9303','2013-08-01','14:00:00',4.02),('9303','2013-08-01','14:05:00',3.94),('9303','2013-08-01','14:10:00',3.9),('9303','2013-08-01','14:15:00',3.91),('9303','2013-08-01','14:20:00',3.86),('9303','2013-08-01','14:25:00',3.82),('9303','2013-08-01','14:30:00',3.78),('9303','2013-08-01','14:35:00',3.11),('9303','2013-08-01','14:40:00',3.16),('9303','2013-08-01','14:45:00',3.48),('9303','2013-08-01','14:50:00',2.27),('9303','2013-08-01','14:55:00',3.68),('9303','2013-08-01','15:00:00',3.62),('9303','2013-08-01','15:05:00',3.63),('9303','2013-08-01','15:10:00',3.36),('9303','2013-08-01','15:15:00',3.41),('9303','2013-08-01','15:20:00',3.6),('9303','2013-08-01','15:25:00',3.53),('9303','2013-08-01','15:30:00',3.43),('9303','2013-08-01','15:35:00',3.17),('9303','2013-08-01','15:40:00',2.04),('9303','2013-08-01','15:45:00',3.31),('9303','2013-08-01','15:50:00',3.26),('9303','2013-08-01','15:55:00',3.22),('9303','2013-08-01','16:00:00',3.19),('9303','2013-08-01','16:05:00',3.13),('9303','2013-08-01','16:10:00',3.03),('9303','2013-08-01','16:15:00',2.95),('9303','2013-08-01','16:20:00',2.93),('9303','2013-08-01','16:25:00',2.86),('9303','2013-08-01','16:30:00',2.78),('9303','2013-08-01','16:35:00',2.72),('9303','2013-08-01','16:40:00',2.64),('9303','2013-08-01','16:45:00',2.58),('9303','2013-08-01','16:50:00',2.51),('9303','2013-08-01','16:55:00',2.45),('9303','2013-08-01','17:00:00',2.37),('9303','2013-08-01','17:05:00',2.29),('9303','2013-08-01','17:10:00',2.17),('9303','2013-08-01','17:15:00',2.06),('9303','2013-08-01','17:20:00',1.96),('9303','2013-08-01','17:25:00',1.88),('9303','2013-08-01','17:30:00',1.83),('9303','2013-08-01','17:35:00',1.74),('9303','2013-08-01','17:40:00',1.67),('9303','2013-08-01','17:45:00',1.59),('9303','2013-08-01','17:50:00',1.52),('9303','2013-08-01','17:55:00',1.44),('9303','2013-08-01','18:00:00',1.3),('9303','2013-08-01','18:05:00',1.24),('9303','2013-08-01','18:10:00',1.15),('9303','2013-08-01','18:15:00',1.07),('9303','2013-07-31','08:00:00',1.01),('9303','2013-07-31','08:05:00',1.11),('9303','2013-07-31','08:10:00',1.2),('9303','2013-07-31','08:15:00',1.3),('9303','2013-07-31','08:20:00',1.39),('9303','2013-07-31','08:25:00',1.48),('9303','2013-07-31','08:30:00',1.57),('9303','2013-07-31','08:35:00',1.67),('9303','2013-07-31','08:40:00',1.77),('9303','2013-07-31','08:45:00',1.86),('9303','2013-07-31','08:50:00',1.93),('9303','2013-07-31','08:55:00',2.01),('9303','2013-07-31','09:00:00',2.09),('9303','2013-07-31','09:05:00',2.16),('9303','2013-07-31','09:10:00',2.25),('9303','2013-07-31','09:15:00',2.31),('9303','2013-07-31','09:20:00',2.38),('9303','2013-07-31','09:25:00',2.44),('9303','2013-07-31','09:30:00',2.51),('9303','2013-07-31','09:35:00',2.59),('9303','2013-07-31','09:40:00',2.64),('9303','2013-07-31','09:45:00',2.71),('9303','2013-07-31','09:50:00',2.77),('9303','2013-07-31','09:55:00',2.84),('9303','2013-07-31','10:00:00',2.88),('9303','2013-07-31','10:05:00',2.94),('9303','2013-07-31','10:10:00',2.99),('9303','2013-07-31','10:15:00',3.08),('9303','2013-07-31','10:20:00',3.11),('9303','2013-07-31','10:25:00',3.13),('9303','2013-07-31','10:30:00',3.19),('9303','2013-07-31','10:35:00',3.27),('9303','2013-07-31','10:40:00',3.34),('9303','2013-07-31','10:45:00',3.38),('9303','2013-07-31','10:50:00',3.43),('9303','2013-07-31','10:55:00',3.46),('9303','2013-07-31','11:00:00',3.52),('9303','2013-07-31','11:05:00',3.56),('9303','2013-07-31','11:10:00',3.61),('9303','2013-07-31','11:15:00',3.63),('9303','2013-07-31','11:20:00',3.66),('9303','2013-07-31','11:25:00',3.7),('9303','2013-07-31','11:30:00',3.72),('9303','2013-07-31','11:35:00',3.76),('9303','2013-07-31','11:40:00',3.8),('9303','2013-07-31','11:45:00',3.83),('9303','2013-07-31','11:50:00',3.89),('9303','2013-07-31','11:55:00',3.91),('9303','2013-07-31','12:00:00',3.9),('9303','2013-07-31','12:05:00',3.91),('9303','2013-07-31','12:10:00',3.9),('9303','2013-07-31','12:15:00',3.93),('9303','2013-07-31','12:20:00',3.95),('9303','2013-07-31','12:25:00',4.03),('9303','2013-07-31','12:30:00',4.03),('9303','2013-07-31','12:35:00',4.02),('9303','2013-07-31','12:40:00',4.05),('9303','2013-07-31','12:45:00',3.28),('9303','2013-07-31','12:50:00',2.59),('9303','2013-07-31','12:55:00',4.02),('9303','2013-07-31','13:00:00',1.86),('9303','2013-07-31','13:05:00',3.86),('9303','2013-07-31','13:10:00',3.99),('9303','2013-07-31','13:15:00',4.12),('9303','2013-07-31','13:20:00',4.02),('9303','2013-07-31','13:25:00',3.89),('9303','2013-07-31','13:30:00',4.08),('9303','2013-07-31','13:35:00',4.05),('9303','2013-07-31','13:40:00',4.13),('9303','2013-07-31','13:45:00',4.21),('9303','2013-07-31','13:50:00',3.64),('9303','2013-07-31','13:55:00',2.17),('9303','2013-07-31','14:00:00',3.68),('9303','2013-07-31','14:05:00',4.11),('9303','2013-07-31','14:10:00',3.41),('9303','2013-07-31','14:15:00',4.08),('9303','2013-07-31','14:20:00',3.43),('9303','2013-07-31','14:25:00',4.01),('9303','2013-07-31','14:30:00',3.89),('9303','2013-07-31','14:35:00',3.83),('9303','2013-07-31','14:40:00',3.86),('9303','2013-07-31','14:45:00',3.83),('9303','2013-07-31','14:50:00',3.35),('9303','2013-07-31','14:55:00',1.85),('9303','2013-07-31','15:00:00',1.62),('9303','2013-07-31','15:05:00',3.84),('9303','2013-07-31','15:10:00',3.13),('9303','2013-07-31','15:15:00',2.4),('9303','2013-07-31','15:20:00',3.28),('9303','2013-07-31','15:25:00',2.55),('9303','2013-07-31','15:30:00',3.5),('9303','2013-07-31','15:35:00',3.14),('9303','2013-07-31','15:40:00',3.43),('9303','2013-07-31','15:45:00',3.35),('9303','2013-07-31','15:50:00',3.26),('9303','2013-07-31','15:55:00',3.18),('9303','2013-07-31','16:00:00',3.11),('9303','2013-07-31','16:05:00',3.11),('9303','2013-07-31','16:10:00',3.1),('9303','2013-07-31','16:15:00',3.05),('9303','2013-07-31','16:20:00',3.03),('9303','2013-07-31','16:25:00',3),('9303','2013-07-31','16:30:00',2.42),('9303','2013-07-31','16:35:00',2.08),('9303','2013-07-31','16:40:00',2.65),('9303','2013-07-31','16:45:00',2.56),('9303','2013-07-31','16:50:00',2.53),('9303','2013-07-31','16:55:00',2.46),('9303','2013-07-31','17:00:00',2.23),('9303','2013-07-31','17:05:00',2.32),('9303','2013-07-31','17:10:00',2.15),('9303','2013-07-31','17:15:00',1.8),('9303','2013-07-31','17:20:00',1.88),('9303','2013-07-31','17:25:00',1.91),('9303','2013-07-31','17:30:00',1.79),('9303','2013-07-31','17:35:00',1.71),('9303','2013-07-31','17:40:00',1.67),('9303','2013-07-31','17:45:00',1.57),('9303','2013-07-31','17:50:00',1.52),('9303','2013-07-31','17:55:00',1.42),('9303','2013-07-31','18:00:00',1.3),('9303','2013-07-31','18:05:00',1.25),('9303','2013-07-31','18:10:00',1.17),('9303','2013-07-31','18:15:00',1.09),('9303','2013-07-31','18:20:00',1.02),('9303','2014-04-08','08:15:00',1.15),('9303','2014-04-08','08:20:00',1.23),('9303','2014-04-08','08:25:00',1.05),('9303','2014-04-08','08:35:00',1.19),('9303','2014-04-08','08:40:00',1.41),('9303','2014-04-08','08:45:00',1.53),('9303','2014-04-08','08:50:00',1.6),('9303','2014-04-08','08:55:00',1.72),('9303','2014-04-08','09:00:00',1.82),('9303','2014-04-08','09:05:00',1.88),('9303','2014-04-08','09:10:00',1.96),('9303','2014-04-08','09:15:00',2.05),('9303','2014-04-08','09:20:00',2.13),('9303','2014-04-08','09:25:00',2.21),('9303','2014-04-08','09:30:00',2.28),('9303','2014-04-08','09:35:00',2.36),('9303','2014-04-08','09:40:00',2.39),('9303','2014-04-08','09:45:00',2.46),('9303','2014-04-08','09:50:00',2.53),('9303','2014-04-08','09:55:00',2.55),('9303','2014-04-08','10:00:00',2.59),('9303','2014-04-08','10:05:00',2.62),('9303','2014-04-08','10:10:00',2.66),('9303','2014-04-08','10:15:00',2.87),('9303','2014-04-08','10:20:00',2.92),('9303','2014-04-08','10:25:00',2.99),('9303','2014-04-08','10:30:00',3.03),('9303','2014-04-08','10:35:00',3.05),('9303','2014-04-08','10:40:00',3.06),('9303','2014-04-08','10:45:00',3.16),('9303','2014-04-08','10:50:00',3.29),('9303','2014-04-08','10:55:00',3.27),('9303','2014-04-08','11:00:00',3.23),('9303','2014-04-08','11:05:00',3.33),('9303','2014-04-08','11:10:00',3.45),('9303','2014-04-08','11:15:00',3.39),('9303','2014-04-08','11:20:00',3.56),('9303','2014-04-08','11:25:00',3.63),('9303','2014-04-08','11:30:00',3.62),('9303','2014-04-08','11:35:00',3.39),('9303','2014-04-08','11:40:00',3.62),('9303','2014-04-08','11:45:00',3.7),('9303','2014-04-08','11:50:00',3.54),('9303','2014-04-08','11:55:00',3.67),('9303','2014-04-08','12:00:00',3.79),('9303','2014-04-08','12:05:00',3.66),('9303','2014-04-08','12:10:00',3.46),('9303','2014-04-08','12:15:00',3.43),('9303','2014-04-08','12:20:00',3.5),('9303','2014-04-08','12:25:00',3.41),('9303','2014-04-08','12:30:00',4.2),('9303','2014-04-08','12:35:00',3.93),('9303','2014-04-08','12:40:00',3.4),('9303','2014-04-08','12:45:00',2.97),('9303','2014-04-08','12:50:00',3.52),('9303','2014-04-08','12:55:00',3.91),('9303','2014-04-08','13:00:00',3.69),('9303','2014-04-08','13:05:00',4),('9303','2014-04-08','13:10:00',4.02),('9303','2014-04-08','13:15:00',4.08),('9303','2014-04-08','13:20:00',4.02),('9303','2014-04-08','13:25:00',4.02),('9303','2014-04-08','13:30:00',4.07),('9303','2014-04-08','13:35:00',4.04),('9303','2014-04-08','13:40:00',4.04),('9303','2014-04-08','13:45:00',3.97),('9303','2014-04-08','13:50:00',4.02),('9303','2014-04-08','13:55:00',4.02),('9303','2014-04-08','14:00:00',3.97),('9303','2014-04-08','14:05:00',3.93),('9303','2014-04-08','14:10:00',3.92),('9303','2014-04-08','14:15:00',3.95),('9303','2014-04-08','14:20:00',3.73),('9303','2014-04-08','14:25:00',3.77),('9303','2014-04-08','14:30:00',3.87),('9303','2014-04-08','14:35:00',3.59),('9303','2014-04-08','14:40:00',3.45),('9303','2014-04-08','14:45:00',3.2),('9303','2014-04-08','14:50:00',3.64),('9303','2014-04-08','14:55:00',3.74),('9303','2014-04-08','15:00:00',3.65),('9303','2014-04-08','15:05:00',3.56),('9303','2014-04-08','15:10:00',3.58),('9303','2014-04-08','15:15:00',3.51),('9303','2014-04-08','15:20:00',3.41),('9303','2014-04-08','15:25:00',3.39),('9303','2014-04-08','15:30:00',3.23),('9303','2014-04-08','15:35:00',3.27),('9303','2014-04-08','15:40:00',3.21),('9303','2014-04-08','15:45:00',3.01),('9303','2014-04-08','15:50:00',3.08),('9303','2014-04-08','15:55:00',3.05),('9303','2014-04-08','16:00:00',2.92),('9303','2014-04-08','16:05:00',2.85),('9303','2014-04-08','16:10:00',2.72),('9303','2014-04-08','16:15:00',2.59),('9303','2014-04-08','16:20:00',2.34),('9303','2014-04-08','16:25:00',2.57),('9303','2014-04-08','16:30:00',2.63),('9303','2014-04-08','16:35:00',2.6),('9303','2014-04-08','16:40:00',2.4),('9303','2014-04-08','16:45:00',2.24),('9303','2014-04-08','16:50:00',2.1),('9303','2014-04-08','16:55:00',1.96),('9303','2014-04-08','17:00:00',1.85),('9303','2014-04-08','17:05:00',1.95),('9303','2014-04-08','17:10:00',1.82),('9303','2014-04-08','17:15:00',1.76),('9303','2014-04-08','17:20:00',1.68),('9303','2014-04-08','17:25:00',1.56),('9303','2014-04-08','17:30:00',1.42),('9303','2014-04-08','17:35:00',1.23),('9303','2014-04-08','17:40:00',1.22),('9303','2014-04-08','17:45:00',1.1),('9303','2014-04-08','17:50:00',1.07),('9303','2013-07-30','08:05:00',1.08),('9303','2013-07-30','08:10:00',1.19),('9303','2013-07-30','08:15:00',1.27),('9303','2013-07-30','08:20:00',1.44),('9303','2013-07-30','08:25:00',1.52),('9303','2013-07-30','08:30:00',1.56),('9303','2013-07-30','08:35:00',1.64),('9303','2013-07-30','08:40:00',1.71),('9303','2013-07-30','08:45:00',1.8),('9303','2013-07-30','08:50:00',1.88),('9303','2013-07-30','08:55:00',1.97),('9303','2013-07-30','09:00:00',2.06),('9303','2013-07-30','09:05:00',2.16),('9303','2013-07-30','09:10:00',2.22),('9303','2013-07-30','09:15:00',2.34),('9303','2013-07-30','09:20:00',2.5),('9303','2013-07-30','09:25:00',2.55),('9303','2013-07-30','09:30:00',2.58),('9303','2013-07-30','09:35:00',2.66),('9303','2013-07-30','09:40:00',2.75),('9303','2013-07-30','09:45:00',2.7),('9303','2013-07-30','09:50:00',2.73),('9303','2013-07-30','09:55:00',2.89),('9303','2013-07-30','10:00:00',2.62),('9303','2013-07-30','10:05:00',2.94),('9303','2013-07-30','10:10:00',3.07),('9303','2013-07-30','10:15:00',2.95),('9303','2013-07-30','10:20:00',3.08),('9303','2013-07-30','10:25:00',3.23),('9303','2013-07-30','10:30:00',3.21),('9303','2013-07-30','10:35:00',3.26),('9303','2013-07-30','10:40:00',3.29),('9303','2013-07-30','10:45:00',3.35),('9303','2013-07-30','10:50:00',3.33),('9303','2013-07-30','10:55:00',3.34),('9303','2013-07-30','11:00:00',3.43),('9303','2013-07-30','11:05:00',3.53),('9303','2013-07-30','11:10:00',3.34),('9303','2013-07-30','11:15:00',2.5),('9303','2013-07-30','11:20:00',2.76),('9303','2013-07-30','11:25:00',3.55),('9303','2013-07-30','11:30:00',3.67),('9303','2013-07-30','11:35:00',1.76),('9303','2013-07-30','11:40:00',3.41),('9303','2013-07-30','11:45:00',3.79),('9303','2013-07-30','11:50:00',3.87),('9303','2013-07-30','11:55:00',3.86),('9303','2013-07-30','12:00:00',3.77),('9303','2013-07-30','12:05:00',3.75),('9303','2013-07-30','12:10:00',3.72),('9303','2013-07-30','12:15:00',3.69),('9303','2013-07-30','12:20:00',3.72),('9303','2013-07-30','12:25:00',3.79),('9303','2013-07-30','12:30:00',3.9),('9303','2013-07-30','12:35:00',3.99),('9303','2013-07-30','12:40:00',2.73),('9303','2013-07-30','12:45:00',3.01),('9303','2013-07-30','12:50:00',4.06),('9303','2013-07-30','12:55:00',4.16),('9303','2013-07-30','13:00:00',2.18),('9303','2013-07-30','13:05:00',4.24),('9303','2013-07-30','13:10:00',4.05),('9303','2013-07-30','13:15:00',4.19),('9303','2013-07-30','13:20:00',3.78),('9303','2013-07-30','13:25:00',2.79),('9303','2013-07-30','13:30:00',3.7),('9303','2013-07-30','13:35:00',4.01),('9303','2013-07-30','13:40:00',4.15),('9303','2013-07-30','13:45:00',4.01),('9303','2013-07-30','13:50:00',4.12),('9303','2013-07-30','13:55:00',3.81),('9303','2013-07-30','14:00:00',3.99),('9303','2013-07-30','14:05:00',3.89),('9303','2013-07-30','14:10:00',3.46),('9303','2013-07-30','14:15:00',3.84),('9303','2013-07-30','14:20:00',3.76),('9303','2013-07-30','14:25:00',3.87),('9303','2013-07-30','14:30:00',3.9),('9303','2013-07-30','14:35:00',3.74),('9303','2013-07-30','14:40:00',3.47),('9303','2013-07-30','14:45:00',3.67),('9303','2013-07-30','14:50:00',3.67),('9303','2013-07-30','14:55:00',3.62),('9303','2013-07-30','15:00:00',3.56),('9303','2013-07-30','15:05:00',3.51),('9303','2013-07-30','15:10:00',3.36),('9303','2013-07-30','15:15:00',3.4),('9303','2013-07-30','15:20:00',3.42),('9303','2013-07-30','15:25:00',3.25),('9303','2013-07-30','15:30:00',3.31),('9303','2013-07-30','15:35:00',3.28),('9303','2013-07-30','15:40:00',3.22),('9303','2013-07-30','15:45:00',3.15),('9303','2013-07-30','15:50:00',3.11),('9303','2013-07-30','15:55:00',3.06),('9303','2013-07-30','16:00:00',3.02),('9303','2013-07-30','16:05:00',2.97),('9303','2013-07-30','16:10:00',2.91),('9303','2013-07-30','16:15:00',2.86),('9303','2013-07-30','16:20:00',2.81),('9303','2013-07-30','16:25:00',2.75),('9303','2013-07-30','16:30:00',2.66),('9303','2013-07-30','16:35:00',2.63),('9303','2013-07-30','16:40:00',2.6),('9303','2013-07-30','16:45:00',2.51),('9303','2013-07-30','16:50:00',2.43),('9303','2013-07-30','16:55:00',2.37),('9303','2013-07-30','17:00:00',2.32),('9303','2013-07-30','17:05:00',2.23),('9303','2013-07-30','17:10:00',2.1),('9303','2013-07-30','17:15:00',2.01),('9303','2013-07-30','17:20:00',1.93),('9303','2013-07-30','17:25:00',1.86),('9303','2013-07-30','17:30:00',1.78),('9303','2013-07-30','17:35:00',1.71),('9303','2013-07-30','17:40:00',1.64),('9303','2013-07-30','17:45:00',1.57),('9303','2013-07-30','17:50:00',1.46),('9303','2013-07-30','17:55:00',1.35),('9303','2013-07-30','18:00:00',1.27),('9303','2013-07-30','18:05:00',1.2),('9303','2013-07-30','18:10:00',1.13),('9303','2013-07-30','18:15:00',1.03),('9303','2013-07-29','08:05:00',1),('9303','2013-07-29','08:10:00',1.07),('9303','2013-07-29','08:15:00',1.15),('9303','2013-07-29','08:20:00',1.21),('9303','2013-07-29','08:25:00',1.3),('9303','2013-07-29','08:30:00',1.37),('9303','2013-07-29','08:35:00',1.45),('9303','2013-07-29','08:40:00',1.54),('9303','2013-07-29','08:45:00',1.62),('9303','2013-07-29','08:50:00',1.69),('9303','2013-07-29','08:55:00',1.76),('9303','2013-07-29','09:00:00',1.84),('9303','2013-07-29','09:05:00',1.91),('9303','2013-07-29','09:10:00',1.99),('9303','2013-07-29','09:15:00',2.06),('9303','2013-07-29','09:20:00',2.12),('9303','2013-07-29','09:25:00',2.19),('9303','2013-07-29','09:30:00',2.25),('9303','2013-07-29','09:35:00',2.31),('9303','2013-07-29','09:40:00',2.4),('9303','2013-07-29','09:45:00',2.48),('9303','2013-07-29','09:50:00',2.53),('9303','2013-07-29','09:55:00',2.6),('9303','2013-07-29','10:00:00',2.65),('9303','2013-07-29','10:05:00',2.7),('9303','2013-07-29','10:10:00',2.78),('9303','2013-07-29','10:15:00',2.81),('9303','2013-07-29','10:20:00',2.86),('9303','2013-07-29','10:25:00',2.95),('9303','2013-07-29','10:30:00',2.95),('9303','2013-07-29','10:35:00',2.99),('9303','2013-07-29','10:40:00',3.03),('9303','2013-07-29','10:45:00',3.09),('9303','2013-07-29','10:50:00',3.13),('9303','2013-07-29','10:55:00',3.16),('9303','2013-07-29','11:00:00',3.21),('9303','2013-07-29','11:05:00',3.2),('9303','2013-07-29','11:10:00',3.23),('9303','2013-07-29','11:15:00',3.28),('9303','2013-07-29','11:20:00',3.3),('9303','2013-07-29','11:25:00',3.35),('9303','2013-07-29','11:30:00',3.36),('9303','2013-07-29','11:35:00',3.36),('9303','2013-07-29','11:40:00',3.38),('9303','2013-07-29','11:45:00',3.4),('9303','2013-07-29','11:50:00',3.41),('9303','2013-07-29','11:55:00',3.46),('9303','2013-07-29','12:00:00',3.44),('9303','2013-07-29','12:05:00',3.47),('9303','2013-07-29','12:10:00',3.54),('9303','2013-07-29','12:15:00',3.57),('9303','2013-07-29','12:20:00',3.61),('9303','2013-07-29','12:25:00',3.59),('9303','2013-07-29','12:30:00',3.58),('9303','2013-07-29','12:35:00',3.64),('9303','2013-07-29','12:40:00',3.65),('9303','2013-07-29','12:45:00',3.64),('9303','2013-07-29','12:50:00',3.63),('9303','2013-07-29','12:55:00',3.64),('9303','2013-07-29','13:00:00',3.62),('9303','2013-07-29','13:05:00',3.69),('9303','2013-07-29','13:10:00',3.75),('9303','2013-07-29','13:15:00',3.75),('9303','2013-07-29','13:20:00',3.78),('9303','2013-07-29','13:25:00',3.78),('9303','2013-07-29','13:30:00',3.78),('9303','2013-07-29','13:35:00',3.78),('9303','2013-07-29','13:40:00',3.81),('9303','2013-07-29','13:45:00',3.83),('9303','2013-07-29','13:50:00',3.79),('9303','2013-07-29','13:55:00',3.79),('9303','2013-07-29','14:00:00',3.78),('9303','2013-07-29','14:05:00',3.74),('9303','2013-07-29','14:10:00',3.72),('9303','2013-07-29','14:15:00',3.72),('9303','2013-07-29','14:20:00',3.72),('9303','2013-07-29','14:25:00',3.67),('9303','2013-07-29','14:30:00',3.64),('9303','2013-07-29','14:35:00',3.6),('9303','2013-07-29','14:40:00',3.58),('9303','2013-07-29','14:45:00',3.57),('9303','2013-07-29','14:50:00',3.55),('9303','2013-07-29','14:55:00',3.52),('9303','2013-07-29','15:00:00',3.49),('9303','2013-07-29','15:05:00',3.46),('9303','2013-07-29','15:10:00',3.39),('9303','2013-07-29','15:15:00',3.39),('9303','2013-07-29','15:20:00',3.35),('9303','2013-07-29','15:25:00',3.31),('9303','2013-07-29','15:30:00',3.26),('9303','2013-07-29','15:35:00',3.24),('9303','2013-07-29','15:40:00',3.26),('9303','2013-07-29','15:45:00',3.25),('9303','2013-07-29','15:50:00',2.8),('9303','2013-07-29','15:55:00',1.78),('9303','2013-07-29','16:00:00',1.57),('9303','2013-07-29','16:05:00',2.52),('9303','2013-07-29','16:10:00',2.59),('9303','2013-07-29','16:15:00',2.64),('9303','2013-07-29','16:20:00',2.38),('9303','2013-07-29','16:25:00',2.23),('9303','2013-07-29','16:30:00',2.84),('9303','2013-07-29','16:35:00',2.62),('9303','2013-07-29','16:40:00',2.16),('9303','2013-07-29','16:45:00',2.72),('9303','2013-07-29','16:50:00',2.53),('9303','2013-07-29','16:55:00',1.45),('9303','2013-07-29','17:00:00',1.15),('9303','2013-07-29','17:05:00',1.63),('9303','2013-07-29','17:10:00',1.24),('9303','2013-07-29','17:20:00',1.82),('9303','2013-07-29','17:25:00',1.78),('9303','2013-07-29','17:30:00',1.08),('9303','2013-07-29','17:45:00',1.61),('9303','2013-07-29','17:50:00',1.48),('9303','2013-07-29','17:55:00',1.32),('9303','2013-07-28','08:10:00',1.09),('9303','2013-07-28','08:15:00',1.18),('9303','2013-07-28','08:20:00',1.25),('9303','2013-07-28','08:25:00',1.35),('9303','2013-07-28','08:30:00',1.43),('9303','2013-07-28','08:35:00',1.52),('9303','2013-07-28','08:40:00',1.6),('9303','2013-07-28','08:45:00',1.68),('9303','2013-07-28','08:50:00',1.75),('9303','2013-07-28','08:55:00',1.83),('9303','2013-07-28','09:00:00',1.91),('9303','2013-07-28','09:05:00',1.98),('9303','2013-07-28','09:10:00',2.06),('9303','2013-07-28','09:15:00',2.14),('9303','2013-07-28','09:20:00',2.19),('9303','2013-07-28','09:25:00',2.25),('9303','2013-07-28','09:30:00',2.32),('9303','2013-07-28','09:35:00',2.37),('9303','2013-07-28','09:40:00',2.43),('9303','2013-07-28','09:45:00',2.5),('9303','2013-07-28','09:50:00',2.51),('9303','2013-07-28','09:55:00',2.59),('9303','2013-07-28','10:00:00',2.65),('9303','2013-07-28','10:05:00',2.69),('9303','2013-07-28','10:10:00',2.76),('9303','2013-07-28','10:15:00',2.82),('9303','2013-07-28','10:20:00',2.87),('9303','2013-07-28','10:25:00',2.93),('9303','2013-07-28','10:30:00',2.94),('9303','2013-07-28','10:35:00',2.96),('9303','2013-07-28','10:40:00',3.03),('9303','2013-07-28','10:45:00',3.07),('9303','2013-07-28','10:50:00',3.09),('9303','2013-07-28','10:55:00',3.09),('9303','2013-07-28','11:00:00',3.13),('9303','2013-07-28','11:05:00',3.2),('9303','2013-07-28','11:10:00',3.25),('9303','2013-07-28','11:15:00',3.32),('9303','2013-07-28','11:20:00',3.34),('9303','2013-07-28','11:25:00',3.36),('9303','2013-07-28','11:30:00',3.36),('9303','2013-07-28','11:35:00',3.39),('9303','2013-07-28','11:40:00',3.41),('9303','2013-07-28','11:45:00',3.42),('9303','2013-07-28','11:50:00',3.45),('9303','2013-07-28','11:55:00',3.5),('9303','2013-07-28','12:00:00',3.49),('9303','2013-07-28','12:05:00',3.49),('9303','2013-07-28','12:10:00',3.52),('9303','2013-07-28','12:15:00',3.49),('9303','2013-07-28','12:20:00',3.51),('9303','2013-07-28','12:25:00',3.54),('9303','2013-07-28','12:30:00',3.66),('9303','2013-07-28','12:35:00',3.71),('9303','2013-07-28','12:40:00',3.67),('9303','2013-07-28','12:45:00',3.64),('9303','2013-07-28','12:50:00',3.61),('9303','2013-07-28','12:55:00',3.66),('9303','2013-07-28','13:00:00',3.63),('9303','2013-07-28','13:05:00',3.62),('9303','2013-07-28','13:10:00',3.69),('9303','2013-07-28','13:15:00',3.78),('9303','2013-07-28','13:20:00',3.83),('9303','2013-07-28','13:25:00',3.79),('9303','2013-07-28','13:30:00',3.78),('9303','2013-07-28','13:35:00',3.7),('9303','2013-07-28','13:40:00',3.66),('9303','2013-07-28','13:45:00',3.78),('9303','2013-07-28','13:50:00',3.79),('9303','2013-07-28','13:55:00',3.79),('9303','2013-07-28','14:00:00',3.76),('9303','2013-07-28','14:05:00',3.74),('9303','2013-07-28','14:10:00',3.71),('9303','2013-07-28','14:15:00',3.67),('9303','2013-07-28','14:20:00',3.65),('9303','2013-07-28','14:25:00',3.61),('9303','2013-07-28','14:30:00',3.59),('9303','2013-07-28','14:35:00',3.59),('9303','2013-07-28','14:40:00',3.62),('9303','2013-07-28','14:45:00',3.56),('9303','2013-07-28','14:50:00',3.54),('9303','2013-07-28','14:55:00',3.5),('9303','2013-07-28','15:00:00',3.45),('9303','2013-07-28','15:05:00',3.39),('9303','2013-07-28','15:10:00',3.4),('9303','2013-07-28','15:15:00',3.38),('9303','2013-07-28','15:20:00',3.32),('9303','2013-07-28','15:25:00',3.25),('9303','2013-07-28','15:30:00',3.25),('9303','2013-07-28','15:35:00',3.2),('9303','2013-07-28','15:40:00',3.16),('9303','2013-07-28','15:45:00',3.12),('9303','2013-07-28','15:50:00',3.09),('9303','2013-07-28','15:55:00',3.03),('9303','2013-07-28','16:00:00',3),('9303','2013-07-28','16:05:00',2.98),('9303','2013-07-28','16:10:00',2.95),('9303','2013-07-28','16:15:00',2.9),('9303','2013-07-28','16:20:00',2.85),('9303','2013-07-28','16:25:00',2.8),('9303','2013-07-28','16:30:00',2.73),('9303','2013-07-28','16:35:00',2.68),('9303','2013-07-28','16:40:00',2.61),('9303','2013-07-28','16:45:00',2.54),('9303','2013-07-28','16:50:00',2.47),('9303','2013-07-28','16:55:00',2.42),('9303','2013-07-28','17:00:00',2.34),('9303','2013-07-28','17:05:00',2.27),('9303','2013-07-28','17:10:00',2.18),('9303','2013-07-28','17:15:00',2.07),('9303','2013-07-28','17:20:00',1.97),('9303','2013-07-28','17:25:00',1.89),('9303','2013-07-28','17:30:00',1.82),('9303','2013-07-28','17:35:00',1.75),('9303','2013-07-28','17:40:00',1.68),('9303','2013-07-28','17:45:00',1.6),('9303','2013-07-28','17:50:00',1.52),('9303','2013-07-28','17:55:00',1.41),('9303','2013-07-28','18:00:00',1.32),('9303','2013-07-28','18:05:00',1.24),('9303','2013-07-28','18:10:00',1.17),('9303','2013-07-28','18:15:00',1.09),('9303','2013-07-28','18:20:00',1),('9303','2013-07-27','08:05:00',1.02),('9303','2013-07-27','08:10:00',1.11),('9303','2013-07-27','08:15:00',1.2),('9303','2013-07-27','08:20:00',1.28),('9303','2013-07-27','08:25:00',1.38),('9303','2013-07-27','08:30:00',1.46),('9303','2013-07-27','08:35:00',1.54),('9303','2013-07-27','08:40:00',1.61),('9303','2013-07-27','08:45:00',1.7),('9303','2013-07-27','08:50:00',1.78),('9303','2013-07-27','08:55:00',1.85),('9303','2013-07-27','09:00:00',1.93),('9303','2013-07-27','09:05:00',1.99),('9303','2013-07-27','09:10:00',2.08),('9303','2013-07-27','09:15:00',2.16),('9303','2013-07-27','09:20:00',2.21),('9303','2013-07-27','09:25:00',2.3),('9303','2013-07-27','09:30:00',2.36),('9303','2013-07-27','09:35:00',2.44),('9303','2013-07-27','09:40:00',2.51),('9303','2013-07-27','09:45:00',2.55),('9303','2013-07-27','09:50:00',2.61),('9303','2013-07-27','09:55:00',2.68),('9303','2013-07-27','10:00:00',2.73),('9303','2013-07-27','10:05:00',2.78),('9303','2013-07-27','10:10:00',2.84),('9303','2013-07-27','10:15:00',2.91),('9303','2013-07-27','10:20:00',2.95),('9303','2013-07-27','10:25:00',3),('9303','2013-07-27','10:30:00',3.09),('9303','2013-07-27','10:35:00',3.12),('9303','2013-07-27','10:40:00',3.12),('9303','2013-07-27','10:45:00',3.17),('9303','2013-07-27','10:50:00',3.21),('9303','2013-07-27','10:55:00',3.23),('9303','2013-07-27','11:00:00',3.28),('9303','2013-07-27','11:05:00',3.32),('9303','2013-07-27','11:10:00',3.38),('9303','2013-07-27','11:15:00',3.38),('9303','2013-07-27','11:20:00',3.41),('9303','2013-07-27','11:25:00',3.5),('9303','2013-07-27','11:30:00',3.52),('9303','2013-07-27','11:35:00',3.52),('9303','2013-07-27','11:40:00',3.51),('9303','2013-07-27','11:45:00',3.57),('9303','2013-07-27','11:50:00',3.61),('9303','2013-07-27','11:55:00',3.62),('9303','2013-07-27','12:00:00',3.62),('9303','2013-07-27','12:05:00',3.69),('9303','2013-07-27','12:10:00',3.72),('9303','2013-07-27','12:15:00',3.65),('9303','2013-07-27','12:20:00',3.75),('9303','2013-07-27','12:25:00',3.76),('9303','2013-07-27','12:30:00',3.74),('9303','2013-07-27','12:35:00',3.76),('9303','2013-07-27','12:40:00',3.79),('9303','2013-07-27','12:45:00',3.71),('9303','2013-07-27','12:50:00',3.71),('9303','2013-07-27','12:55:00',3.77),('9303','2013-07-27','13:00:00',3.8),('9303','2013-07-27','13:05:00',3.87),('9303','2013-07-27','13:10:00',3.9),('9303','2013-07-27','13:15:00',3.8),('9303','2013-07-27','13:20:00',3.86),('9303','2013-07-27','13:25:00',3.92),('9303','2013-07-27','13:30:00',3.9),('9303','2013-07-27','13:35:00',3.81),('9303','2013-07-27','13:40:00',3.61),('9303','2013-07-27','13:45:00',3.85),('9303','2013-07-27','13:50:00',3.83),('9303','2013-07-27','13:55:00',3.84),('9303','2013-07-27','14:00:00',3.33),('9303','2013-07-27','14:05:00',3.38),('9303','2013-07-27','14:10:00',1.86),('9303','2013-07-27','14:15:00',3.79),('9303','2013-07-27','14:20:00',3.78),('9303','2013-07-27','14:25:00',3.67),('9303','2013-07-27','14:30:00',3.65),('9303','2013-07-27','14:35:00',3.65),('9303','2013-07-27','14:40:00',3.63),('9303','2013-07-27','14:45:00',3.55),('9303','2013-07-27','14:50:00',3.54),('9303','2013-07-27','14:55:00',3.52),('9303','2013-07-27','15:00:00',3.45),('9303','2013-07-27','15:05:00',3.41),('9303','2013-07-27','15:10:00',3.45),('9303','2013-07-27','15:15:00',3.37),('9303','2013-07-27','15:20:00',3.33),('9303','2013-07-27','15:25:00',3.31),('9303','2013-07-27','15:30:00',3.29),('9303','2013-07-27','15:35:00',3.26),('9303','2013-07-27','15:40:00',3.22),('9303','2013-07-27','15:45:00',3.17),('9303','2013-07-27','15:50:00',3.12),('9303','2013-07-27','15:55:00',3.05),('9303','2013-07-27','16:00:00',3.02),('9303','2013-07-27','16:05:00',2.99),('9303','2013-07-27','16:10:00',2.92),('9303','2013-07-27','16:15:00',2.86),('9303','2013-07-27','16:20:00',2.82),('9303','2013-07-27','16:25:00',2.77),('9303','2013-07-27','16:30:00',2.7),('9303','2013-07-27','16:35:00',2.65),('9303','2013-07-27','16:40:00',2.58),('9303','2013-07-27','16:45:00',2.52),('9303','2013-07-27','16:50:00',2.46),('9303','2013-07-27','16:55:00',2.4),('9303','2013-07-27','17:00:00',2.34),('9303','2013-07-27','17:05:00',2.27),('9303','2013-07-27','17:10:00',2.17),('9303','2013-07-27','17:15:00',2.06),('9303','2013-07-27','17:20:00',1.96),('9303','2013-07-27','17:25:00',1.89),('9303','2013-07-27','17:30:00',1.81),('9303','2013-07-27','17:35:00',1.74),('9303','2013-07-27','17:40:00',1.66),('9303','2013-07-27','17:45:00',1.58),('9303','2013-07-27','17:50:00',1.52),('9303','2013-07-27','17:55:00',1.41),('9303','2013-07-27','18:00:00',1.35),('9303','2013-07-27','18:05:00',1.27),('9303','2013-07-27','18:10:00',1.19),('9303','2013-07-27','18:15:00',1.1),('9303','2013-07-27','18:20:00',1.01),('9303','2013-07-26','08:10:00',1.1),('9303','2013-07-26','08:15:00',1.17),('9303','2013-07-26','08:20:00',1.22),('9303','2013-07-26','08:25:00',1.32),('9303','2013-07-26','08:30:00',1.43),('9303','2013-07-26','08:35:00',1.5),('9303','2013-07-26','08:40:00',1.56),('9303','2013-07-26','08:45:00',1.65),('9303','2013-07-26','08:50:00',1.74),('9303','2013-07-26','08:55:00',1.82),('9303','2013-07-26','09:00:00',1.9),('9303','2013-07-26','09:05:00',1.97),('9303','2013-07-26','09:10:00',2.04),('9303','2013-07-26','09:15:00',2.12),('9303','2013-07-26','09:20:00',2.22),('9303','2013-07-26','09:25:00',2.26),('9303','2013-07-26','09:30:00',2.32),('9303','2013-07-26','09:35:00',2.33),('9303','2013-07-26','09:40:00',2.44),('9303','2013-07-26','09:45:00',2.45),('9303','2013-07-26','09:50:00',2.56),('9303','2013-07-26','09:55:00',2.62),('9303','2013-07-26','10:00:00',2.65),('9303','2013-07-26','10:05:00',2.71),('9303','2013-07-26','10:10:00',2.76),('9303','2013-07-26','10:15:00',2.86),('9303','2013-07-26','10:20:00',2.87),('9303','2013-07-26','10:25:00',2.93),('9303','2013-07-26','10:30:00',2.96),('9303','2013-07-26','10:35:00',3.01),('9303','2013-07-26','10:40:00',3.04),('9303','2013-07-26','10:45:00',3.11),('9303','2013-07-26','10:50:00',3.14),('9303','2013-07-26','10:55:00',3.24),('9303','2013-07-26','11:00:00',3.27),('9303','2013-07-26','11:05:00',3.33),('9303','2013-07-26','11:10:00',3.38),('9303','2013-07-26','11:15:00',3.33),('9303','2013-07-26','11:20:00',3.38),('9303','2013-07-26','11:25:00',3.35),('9303','2013-07-26','11:30:00',3.05),('9303','2013-07-26','11:35:00',3.36),('9303','2013-07-26','11:40:00',3.58),('9303','2013-07-26','11:45:00',3.54),('9303','2013-07-26','11:50:00',3.54),('9303','2013-07-26','11:55:00',3.59),('9303','2013-07-26','12:00:00',3.57),('9303','2013-07-26','12:05:00',3.62),('9303','2013-07-26','12:10:00',2.93),('9303','2013-07-26','12:15:00',2.77),('9303','2013-07-26','12:20:00',3.82),('9303','2013-07-26','12:25:00',3.79),('9303','2013-07-26','12:30:00',3.84),('9303','2013-07-26','12:35:00',3.73),('9303','2013-07-26','12:40:00',3.89),('9303','2013-07-26','12:45:00',4.02),('9303','2013-07-26','12:50:00',3.97),('9303','2013-07-26','12:55:00',2.21),('9303','2013-07-26','13:00:00',1.59),('9303','2013-07-26','13:05:00',2.36),('9303','2013-07-26','13:10:00',1.43),('9303','2013-07-26','13:15:00',2.89),('9303','2013-07-26','13:20:00',4.1),('9303','2013-07-26','13:25:00',4.08),('9303','2013-07-26','13:30:00',4.11),('9303','2013-07-26','13:35:00',3.92),('9303','2013-07-26','13:40:00',3.91),('9303','2013-07-26','13:45:00',4.01),('9303','2013-07-26','13:50:00',2.43),('9303','2013-07-26','13:55:00',2.52),('9303','2013-07-26','14:00:00',4.08),('9303','2013-07-26','14:05:00',3.91),('9303','2013-07-26','14:10:00',3.72),('9303','2013-07-26','14:15:00',3.83),('9303','2013-07-26','14:20:00',3.83),('9303','2013-07-26','14:25:00',3.77),('9303','2013-07-26','14:30:00',3.73),('9303','2013-07-26','14:35:00',3.68),('9303','2013-07-26','14:40:00',3.68),('9303','2013-07-26','14:45:00',3.6),('9303','2013-07-26','14:50:00',3.62),('9303','2013-07-26','14:55:00',3.57),('9303','2013-07-26','15:00:00',3.58),('9303','2013-07-26','15:05:00',3.47),('9303','2013-07-26','15:10:00',3.45),('9303','2013-07-26','15:15:00',3.41),('9303','2013-07-26','15:20:00',3.35),('9303','2013-07-26','15:25:00',3.31),('9303','2013-07-26','15:30:00',3.29),('9303','2013-07-26','15:35:00',3.26),('9303','2013-07-26','15:40:00',3.24),('9303','2013-07-26','15:45:00',3.21),('9303','2013-07-26','15:50:00',3.17),('9303','2013-07-26','15:55:00',3.12),('9303','2013-07-26','16:00:00',3.06),('9303','2013-07-26','16:05:00',3.02),('9303','2013-07-26','16:10:00',2.94),('9303','2013-07-26','16:15:00',2.89),('9303','2013-07-26','16:20:00',2.83),('9303','2013-07-26','16:25:00',2.8),('9303','2013-07-26','16:30:00',2.73),('9303','2013-07-26','16:35:00',2.67),('9303','2013-07-26','16:40:00',2.61),('9303','2013-07-26','16:45:00',2.56),('9303','2013-07-26','16:50:00',2.48),('9303','2013-07-26','16:55:00',2.42),('9303','2013-07-26','17:00:00',2.35),('9303','2013-07-26','17:05:00',2.27),('9303','2013-07-26','17:10:00',2.19),('9303','2013-07-26','17:15:00',2.05),('9303','2013-07-26','17:20:00',1.97),('9303','2013-07-26','17:25:00',1.88),('9303','2013-07-26','17:30:00',1.77),('9303','2013-07-26','17:35:00',1.72),('9303','2013-07-26','17:40:00',1.65),('9303','2013-07-26','17:45:00',1.56),('9303','2013-07-26','17:50:00',1.45),('9303','2013-07-26','17:55:00',1.34),('9303','2013-07-26','18:00:00',1.26),('9303','2013-07-26','18:05:00',1.18),('9303','2013-07-26','18:10:00',1.14),('9303','2013-07-26','18:15:00',1.05),('9303','2013-07-25','08:05:00',1.03),('9303','2013-07-25','08:10:00',1.1),('9303','2013-07-25','08:15:00',1.18),('9303','2013-07-25','08:20:00',1.26),('9303','2013-07-25','08:25:00',1.35),('9303','2013-07-25','08:30:00',1.42),('9303','2013-07-25','08:35:00',1.48),('9303','2013-07-25','08:40:00',1.59),('9303','2013-07-25','08:45:00',1.66),('9303','2013-07-25','08:50:00',1.71),('9303','2013-07-25','08:55:00',1.81),('9303','2013-07-25','09:00:00',1.93),('9303','2013-07-25','09:05:00',2),('9303','2013-07-25','09:10:00',2.07),('9303','2013-07-25','09:15:00',2.24),('9303','2013-07-25','09:20:00',2.17),('9303','2013-07-25','09:25:00',1.59),('9303','2013-07-25','09:30:00',1.68),('9303','2013-07-25','09:35:00',1.69),('9303','2013-07-25','09:40:00',1.16),('9303','2013-07-25','09:45:00',1.25),('9303','2013-07-25','09:50:00',1.82),('9303','2013-07-25','09:55:00',1.03),('9303','2013-07-25','10:00:00',2.17),('9303','2013-07-25','10:05:00',2.2),('9303','2013-07-25','10:10:00',2.89),('9303','2013-07-25','10:15:00',2.92),('9303','2013-07-25','10:20:00',2.95),('9303','2013-07-25','10:25:00',2.93),('9303','2013-07-25','10:30:00',3),('9303','2013-07-25','10:35:00',1.67),('9303','2013-07-25','10:40:00',1.86),('9303','2013-07-25','10:45:00',2.53),('9303','2013-07-25','10:50:00',3.29),('9303','2013-07-25','10:55:00',3.4),('9303','2013-07-25','11:00:00',3.32),('9303','2013-07-25','11:05:00',3.15),('9303','2013-07-25','11:10:00',3.49),('9303','2013-07-25','11:15:00',3.2),('9303','2013-07-25','11:20:00',2.1),('9303','2013-07-25','11:25:00',3.42),('9303','2013-07-25','11:30:00',3.12),('9303','2013-07-25','11:35:00',3.44),('9303','2013-07-25','11:40:00',3.65),('9303','2013-07-25','11:45:00',3.94),('9303','2013-07-25','11:50:00',3.92),('9303','2013-07-25','11:55:00',2.05),('9303','2013-07-25','12:00:00',3.69),('9303','2013-07-25','12:05:00',3.78),('9303','2013-07-25','12:10:00',3.76),('9303','2013-07-25','12:15:00',2.21),('9303','2013-07-25','12:20:00',3.61),('9303','2013-07-25','12:25:00',2.38),('9303','2013-07-25','12:30:00',1.51),('9303','2013-07-25','12:35:00',1.78),('9303','2013-07-25','12:40:00',1.25),('9303','2013-07-25','12:45:00',1.13),('9303','2013-07-25','12:50:00',1.74),('9303','2013-07-25','12:55:00',1.53),('9303','2013-07-25','13:00:00',3.7),('9303','2013-07-25','13:05:00',2.89),('9303','2013-07-25','13:10:00',3.48),('9303','2013-07-25','13:15:00',4.15),('9303','2013-07-25','13:20:00',4.06),('9303','2013-07-25','13:25:00',4.08),('9303','2013-07-25','13:30:00',4.03),('9303','2013-07-25','13:35:00',3.84),('9303','2013-07-25','13:40:00',3.98),('9303','2013-07-25','13:45:00',3.92),('9303','2013-07-25','13:50:00',3.94),('9303','2013-07-25','13:55:00',3.95),('9303','2013-07-25','14:00:00',3.98),('9303','2013-07-25','14:05:00',3.96),('9303','2013-07-25','14:10:00',3.94),('9303','2013-07-25','14:15:00',3.92),('9303','2013-07-25','14:20:00',3.95),('9303','2013-07-25','14:25:00',3.92),('9303','2013-07-25','14:30:00',3.87),('9303','2013-07-25','14:35:00',3.84),('9303','2013-07-25','14:40:00',3.78),('9303','2013-07-25','14:45:00',3.72),('9303','2013-07-25','14:50:00',3.69),('9303','2013-07-25','14:55:00',3.7),('9303','2013-07-25','15:00:00',3.65),('9303','2013-07-25','15:05:00',3.63),('9303','2013-07-25','15:10:00',3.59),('9303','2013-07-25','15:15:00',3.57),('9303','2013-07-25','15:20:00',3.53),('9303','2013-07-25','15:25:00',3.48),('9303','2013-07-25','15:30:00',3.45),('9303','2013-07-25','15:35:00',3.41),('9303','2013-07-25','15:40:00',3.4),('9303','2013-07-25','15:45:00',3.35),('9303','2013-07-25','15:50:00',3.31),('9303','2013-07-25','15:55:00',3.26),('9303','2013-07-25','16:00:00',3.18),('9303','2013-07-25','16:05:00',3.11),('9303','2013-07-25','16:10:00',3.06),('9303','2013-07-25','16:15:00',2.99),('9303','2013-07-25','16:20:00',2.95),('9303','2013-07-25','16:25:00',2.89),('9303','2013-07-25','16:30:00',2.82),('9303','2013-07-25','16:35:00',2.8),('9303','2013-07-25','16:40:00',2.74),('9303','2013-07-25','16:45:00',2.66),('9303','2013-07-25','16:50:00',2.61),('9303','2013-07-25','16:55:00',2.54),('9303','2013-07-25','17:00:00',2.45),('9303','2013-07-25','17:05:00',2.4),('9303','2013-07-25','17:10:00',2.3),('9303','2013-07-25','17:15:00',2.17),('9303','2013-07-25','17:20:00',2.06),('9303','2013-07-25','17:25:00',1.96),('9303','2013-07-25','17:30:00',1.89),('9303','2013-07-25','17:35:00',1.82),('9303','2013-07-25','17:40:00',1.74),('9303','2013-07-25','17:45:00',1.68),('9303','2013-07-25','17:50:00',1.59),('9303','2013-07-25','17:55:00',1.47),('9303','2013-07-25','18:00:00',1.41),('9303','2013-07-25','18:05:00',1.31),('9303','2013-07-25','18:10:00',1.23),('9303','2013-07-25','18:15:00',1.15),('9303','2013-07-25','18:20:00',1.06),('9303','2013-07-24','08:20:00',1.32),('9303','2013-07-24','08:25:00',1.01),('9303','2013-07-24','08:45:00',1.01),('9303','2013-07-24','08:50:00',1.49),('9303','2013-07-24','08:55:00',1.23),('9303','2013-07-24','09:00:00',1.13),('9303','2013-07-24','09:05:00',1.44),('9303','2013-07-24','09:10:00',1.87),('9303','2013-07-24','09:15:00',2.1),('9303','2013-07-24','09:20:00',1.27),('9303','2013-07-24','09:25:00',1.54),('9303','2013-07-24','09:30:00',1.15),('9303','2013-07-24','09:35:00',2.09),('9303','2013-07-24','09:40:00',1.64),('9303','2013-07-24','09:45:00',1.48),('9303','2013-07-24','09:50:00',1.7),('9303','2013-07-24','09:55:00',1.25),('9303','2013-07-24','10:15:00',1.42),('9303','2013-07-24','10:20:00',1.2),('9303','2013-07-24','10:25:00',2.73),('9303','2013-07-24','10:30:00',3.05),('9303','2013-07-24','10:35:00',3.26),('9303','2013-07-24','10:40:00',3.5),('9303','2013-07-24','10:45:00',2.82),('9303','2013-07-24','10:50:00',1.72),('9303','2013-07-24','10:55:00',2.27),('9303','2013-07-24','11:00:00',1.3),('9303','2013-07-24','11:05:00',2.45),('9303','2013-07-24','11:10:00',3.44),('9303','2013-07-24','11:15:00',3.66),('9303','2013-07-24','11:20:00',3.66),('9303','2013-07-24','11:25:00',3.65),('9303','2013-07-24','11:30:00',3.53),('9303','2013-07-24','11:35:00',3.76),('9303','2013-07-24','11:40:00',3.68),('9303','2013-07-24','11:45:00',3.59),('9303','2013-07-24','11:50:00',3.62),('9303','2013-07-24','11:55:00',3.68),('9303','2013-07-24','12:00:00',3.93),('9303','2013-07-24','12:05:00',3.73),('9303','2013-07-24','12:10:00',1.86),('9303','2013-07-24','12:15:00',1.93),('9303','2013-07-24','12:20:00',4.07),('9303','2013-07-24','12:25:00',3.74),('9303','2013-07-24','12:30:00',2.44),('9303','2013-07-24','12:35:00',1.06),('9303','2013-07-24','12:40:00',3.43),('9303','2013-07-24','12:45:00',3.55),('9303','2013-07-24','12:50:00',1.31),('9303','2013-07-24','12:55:00',2.45),('9303','2013-07-24','13:00:00',3.87),('9303','2013-07-24','13:05:00',3.26),('9303','2013-07-24','13:10:00',2.3),('9303','2013-07-24','13:15:00',3.98),('9303','2013-07-24','13:20:00',2.7),('9303','2013-07-24','13:25:00',3.15),('9303','2013-07-24','13:30:00',2.74),('9303','2013-07-24','13:35:00',4.27),('9303','2013-07-24','13:40:00',4.11),('9303','2013-07-24','13:45:00',4.17),('9303','2013-07-24','13:50:00',2.73),('9303','2013-07-24','13:55:00',4.23),('9303','2013-07-24','14:00:00',4.17),('9303','2013-07-24','14:05:00',4.11),('9303','2013-07-24','14:10:00',4.1),('9303','2013-07-24','14:15:00',3.69),('9303','2013-07-24','14:20:00',4.08),('9303','2013-07-24','14:25:00',4.07),('9303','2013-07-24','14:30:00',4.14),('9303','2013-07-24','14:35:00',1.91),('9303','2013-07-24','14:40:00',3.77),('9303','2013-07-24','14:45:00',4),('9303','2013-07-24','14:50:00',3.93),('9303','2013-07-24','14:55:00',3.89),('9303','2013-07-24','15:00:00',3.76),('9303','2013-07-24','15:05:00',3.76),('9303','2013-07-24','15:10:00',3.69),('9303','2013-07-24','15:15:00',3.65),('9303','2013-07-24','15:20:00',3.6),('9303','2013-07-24','15:25:00',3.56),('9303','2013-07-24','15:30:00',3.38),('9303','2013-07-24','15:35:00',3.32),('9303','2013-07-24','15:40:00',3.39),('9303','2013-07-24','15:45:00',3.31),('9303','2013-07-24','15:50:00',3.23),('9303','2013-07-24','15:55:00',3.29),('9303','2013-07-24','16:00:00',3.18),('9303','2013-07-24','16:05:00',3.12),('9303','2013-07-24','16:10:00',2.99),('9303','2013-07-24','16:15:00',2.88),('9303','2013-07-24','16:20:00',3.06),('9303','2013-07-24','16:25:00',2.99),('9303','2013-07-24','16:30:00',2.98),('9303','2013-07-24','16:35:00',2.75),('9303','2013-07-24','16:40:00',2.82),('9303','2013-07-24','16:45:00',2.64),('9303','2013-07-24','16:50:00',2.66),('9303','2013-07-24','16:55:00',2.72),('9303','2013-07-24','17:00:00',2.63),('9303','2013-07-24','17:05:00',2.3),('9303','2013-07-24','17:10:00',1.58),('9303','2013-07-24','17:15:00',2.25),('9303','2013-07-24','17:20:00',2.13),('9303','2013-07-24','17:25:00',2.02),('9303','2013-07-24','17:30:00',1.9),('9303','2013-07-24','17:35:00',1.82),('9303','2013-07-24','17:40:00',1.74),('9303','2013-07-24','17:45:00',1.66),('9303','2013-07-24','17:50:00',1.55),('9303','2013-07-24','17:55:00',1.41),('9303','2013-07-24','18:00:00',1.37),('9303','2013-07-24','18:05:00',1.28),('9303','2013-07-24','18:10:00',1.22),('9303','2013-07-24','18:15:00',1.1),('9303','2013-07-24','18:20:00',1.03),('9303','2013-07-23','08:00:00',1.03),('9303','2013-07-23','08:05:00',1.16),('9303','2013-07-23','08:10:00',1.26),('9303','2013-07-23','08:15:00',1.33),('9303','2013-07-23','08:20:00',1.42),('9303','2013-07-23','08:25:00',1.51),('9303','2013-07-23','08:30:00',1.59),('9303','2013-07-23','08:35:00',1.67),('9303','2013-07-23','08:40:00',1.75),('9303','2013-07-23','08:45:00',1.82),('9303','2013-07-23','08:50:00',1.92),('9303','2013-07-23','08:55:00',2.02),('9303','2013-07-23','09:00:00',2.09),('9303','2013-07-23','09:05:00',2.16),('9303','2013-07-23','09:10:00',2.22),('9303','2013-07-23','09:15:00',2.28),('9303','2013-07-23','09:20:00',2.34),('9303','2013-07-23','09:25:00',2.39),('9303','2013-07-23','09:30:00',2.45),('9303','2013-07-23','09:35:00',2.51),('9303','2013-07-23','09:40:00',2.56),('9303','2013-07-23','09:45:00',2.6),('9303','2013-07-23','09:50:00',2.65),('9303','2013-07-23','09:55:00',2.67),('9303','2013-07-23','10:00:00',2.73),('9303','2013-07-23','10:05:00',2.81),('9303','2013-07-23','10:10:00',2.85),('9303','2013-07-23','10:15:00',2.89),('9303','2013-07-23','10:20:00',2.95),('9303','2013-07-23','10:25:00',3.05),('9303','2013-07-23','10:30:00',3.09),('9303','2013-07-23','10:35:00',3.17),('9303','2013-07-23','10:40:00',3.22),('9303','2013-07-23','10:45:00',3.26),('9303','2013-07-23','10:50:00',3.27),('9303','2013-07-23','10:55:00',3.32),('9303','2013-07-23','11:00:00',3.37),('9303','2013-07-23','11:05:00',3.39),('9303','2013-07-23','11:10:00',3.41),('9303','2013-07-23','11:15:00',3.5),('9303','2013-07-23','11:20:00',3.5),('9303','2013-07-23','11:25:00',3.54),('9303','2013-07-23','11:30:00',3.63),('9303','2013-07-23','11:35:00',3.62),('9303','2013-07-23','11:40:00',3.66),('9303','2013-07-23','11:45:00',3.66),('9303','2013-07-23','11:50:00',3.64),('9303','2013-07-23','11:55:00',3.7),('9303','2013-07-23','12:00:00',3.78),('9303','2013-07-23','12:05:00',3.8),('9303','2013-07-23','12:10:00',3.83),('9303','2013-07-23','12:15:00',3.85),('9303','2013-07-23','12:20:00',3.9),('9303','2013-07-23','12:25:00',3.92),('9303','2013-07-23','12:30:00',3.87),('9303','2013-07-23','12:35:00',3.89),('9303','2013-07-23','12:40:00',3.31),('9303','2013-07-23','12:45:00',2.84),('9303','2013-07-23','12:50:00',3.21),('9303','2013-07-23','12:55:00',3.09),('9303','2013-07-23','13:10:00',2.88),('9303','2013-07-23','13:15:00',2.62),('9303','2013-07-23','13:30:00',2.36),('9303','2013-07-23','13:35:00',4.18),('9303','2013-07-23','13:40:00',4.04),('9303','2013-07-23','13:55:00',2.22),('9303','2013-07-23','14:00:00',4.09),('9303','2013-07-23','14:05:00',3.18),('9303','2013-07-23','14:10:00',1.16),('9303','2013-07-23','14:35:00',2.61),('9303','2013-07-23','14:40:00',4.02),('9303','2013-07-23','14:45:00',4.1),('9303','2013-07-23','14:50:00',3.89),('9303','2013-07-23','14:55:00',4.12),('9303','2013-07-23','15:00:00',3.82),('9303','2013-07-23','15:05:00',4.08),('9303','2013-07-23','15:10:00',3.77),('9303','2013-07-23','15:15:00',3.57),('9303','2013-07-23','15:20:00',3.59),('9303','2013-07-23','15:25:00',3.5),('9303','2013-07-23','15:30:00',3.39),('9303','2013-07-23','15:35:00',3.06),('9303','2013-07-23','15:40:00',3.28),('9303','2013-07-23','15:45:00',3.23),('9303','2013-07-23','15:50:00',3.21),('9303','2013-07-23','15:55:00',3.18),('9303','2013-07-23','16:00:00',3.13),('9303','2013-07-23','16:05:00',3.07),('9303','2013-07-23','16:10:00',3.03),('9303','2013-07-23','16:15:00',2.94),('9303','2013-07-23','16:20:00',2.94),('9303','2013-07-23','16:25:00',2.85),('9303','2013-07-23','16:30:00',2.83),('9303','2013-07-23','16:35:00',2.73),('9303','2013-07-23','16:40:00',2.69),('9303','2013-07-23','16:45:00',2.59),('9303','2013-07-23','16:50:00',2.53),('9303','2013-07-23','16:55:00',2.48),('9303','2013-07-23','17:00:00',2.41),('9303','2013-07-23','17:05:00',2.34),('9303','2013-07-23','17:10:00',2.29),('9303','2013-07-23','17:15:00',2.19),('9303','2013-07-23','17:20:00',2.09),('9303','2013-07-23','17:25:00',2),('9303','2013-07-23','17:30:00',1.92),('9303','2013-07-23','17:35:00',1.86),('9303','2013-07-23','17:40:00',1.79),('9303','2013-07-23','17:45:00',1.7),('9303','2013-07-23','17:50:00',1.61),('9303','2013-07-23','17:55:00',1.53),('9303','2013-07-23','18:00:00',1.46),('9303','2013-07-23','18:05:00',1.35),('9303','2013-07-23','18:10:00',1.28),('9303','2013-07-23','18:15:00',1.22),('9303','2013-07-23','18:20:00',1.13),('9303','2013-07-23','18:25:00',1.03),('9303','2013-07-22','08:00:00',1.04),('9303','2013-07-22','08:05:00',1.13),('9303','2013-07-22','08:10:00',1.22),('9303','2013-07-22','08:15:00',1.3),('9303','2013-07-22','08:20:00',1.39),('9303','2013-07-22','08:25:00',1.49),('9303','2013-07-22','08:30:00',1.57),('9303','2013-07-22','08:35:00',1.65),('9303','2013-07-22','08:40:00',1.73),('9303','2013-07-22','08:45:00',1.81),('9303','2013-07-22','08:50:00',1.9),('9303','2013-07-22','08:55:00',1.99),('9303','2013-07-22','09:00:00',2.06),('9303','2013-07-22','09:05:00',2.13),('9303','2013-07-22','09:10:00',2.2),('9303','2013-07-22','09:15:00',2.27),('9303','2013-07-22','09:20:00',2.33),('9303','2013-07-22','09:25:00',2.38),('9303','2013-07-22','09:30:00',2.46),('9303','2013-07-22','09:35:00',2.52),('9303','2013-07-22','09:40:00',2.57),('9303','2013-07-22','09:45:00',2.64),('9303','2013-07-22','09:50:00',2.72),('9303','2013-07-22','09:55:00',2.81),('9303','2013-07-22','10:00:00',2.85),('9303','2013-07-22','10:05:00',2.9),('9303','2013-07-22','10:10:00',2.97),('9303','2013-07-22','10:15:00',3.02),('9303','2013-07-22','10:20:00',3.06),('9303','2013-07-22','10:25:00',3.12),('9303','2013-07-22','10:30:00',3.17),('9303','2013-07-22','10:35:00',3.23),('9303','2013-07-22','10:40:00',3.27),('9303','2013-07-22','10:45:00',3.31),('9303','2013-07-22','10:50:00',3.32),('9303','2013-07-22','10:55:00',3.37),('9303','2013-07-22','11:00:00',3.38),('9303','2013-07-22','11:05:00',3.4),('9303','2013-07-22','11:10:00',3.44),('9303','2013-07-22','11:15:00',3.45),('9303','2013-07-22','11:20:00',3.49),('9303','2013-07-22','11:25:00',3.52),('9303','2013-07-22','11:30:00',3.57),('9303','2013-07-22','11:35:00',3.59),('9303','2013-07-22','11:40:00',3.58),('9303','2013-07-22','11:45:00',3.58),('9303','2013-07-22','11:50:00',3.57),('9303','2013-07-22','11:55:00',3.6),('9303','2013-07-22','12:00:00',3.64),('9303','2013-07-22','12:05:00',3.71),('9303','2013-07-22','12:10:00',3.75),('9303','2013-07-22','12:15:00',3.77),('9303','2013-07-22','12:20:00',3.77),('9303','2013-07-22','12:25:00',3.86),('9303','2013-07-22','12:30:00',3.89),('9303','2013-07-22','12:35:00',3.85),('9303','2013-07-22','12:40:00',3.82),('9303','2013-07-22','12:45:00',3.83),('9303','2013-07-22','12:50:00',3.84),('9303','2013-07-22','12:55:00',3.85),('9303','2013-07-22','13:00:00',3.9),('9303','2013-07-22','13:05:00',3.9),('9303','2013-07-22','13:10:00',3.9),('9303','2013-07-22','13:15:00',3.9),('9303','2013-07-22','13:20:00',3.91),('9303','2013-07-22','13:25:00',3.89),('9303','2013-07-22','13:30:00',3.91),('9303','2013-07-22','13:35:00',3.91),('9303','2013-07-22','13:40:00',3.98),('9303','2013-07-22','13:45:00',3.97),('9303','2013-07-22','13:50:00',3.95),('9303','2013-07-22','13:55:00',3.88),('9303','2013-07-22','14:00:00',3.86),('9303','2013-07-22','14:05:00',3.78),('9303','2013-07-22','14:10:00',3.75),('9303','2013-07-22','14:15:00',3.74),('9303','2013-07-22','14:20:00',3.79),('9303','2013-07-22','14:25:00',3.78),('9303','2013-07-22','14:30:00',3.72),('9303','2013-07-22','14:35:00',3.7),('9303','2013-07-22','14:40:00',3.66),('9303','2013-07-22','14:45:00',3.63),('9303','2013-07-22','14:50:00',3.58),('9303','2013-07-22','14:55:00',3.51),('9303','2013-07-22','15:00:00',3.24),('9303','2013-07-22','15:05:00',3.01),('9303','2013-07-22','15:10:00',2.3),('9303','2013-07-22','15:15:00',3.47),('9303','2013-07-22','15:20:00',3.47),('9303','2013-07-22','15:25:00',3.04),('9303','2013-07-22','15:40:00',2.4),('9303','2013-07-22','15:45:00',3.5),('9303','2013-07-22','15:50:00',3.48),('9303','2013-07-22','15:55:00',3.54),('9303','2013-07-22','16:00:00',3.51),('9303','2013-07-22','16:05:00',2.95),('9303','2013-07-22','16:10:00',1.65),('9303','2013-07-22','16:15:00',3.15),('9303','2013-07-22','16:20:00',3.26),('9303','2013-07-22','16:25:00',3.09),('9303','2013-07-22','16:30:00',2.92),('9303','2013-07-22','16:35:00',2.83),('9303','2013-07-22','16:40:00',2.66),('9303','2013-07-22','16:45:00',2.59),('9303','2013-07-22','16:50:00',2.52),('9303','2013-07-22','16:55:00',2.43),('9303','2013-07-22','17:00:00',2.4),('9303','2013-07-22','17:05:00',2.37),('9303','2013-07-22','17:10:00',2.29),('9303','2013-07-22','17:15:00',2.15),('9303','2013-07-22','17:20:00',2.06),('9303','2013-07-22','17:25:00',1.92),('9303','2013-07-22','17:30:00',1.89),('9303','2013-07-22','17:35:00',1.84),('9303','2013-07-22','17:40:00',1.75),('9303','2013-07-22','17:45:00',1.5),('9303','2013-07-22','17:50:00',1.51),('9303','2013-07-22','17:55:00',1.45),('9303','2013-07-22','18:00:00',1.42),('9303','2013-07-22','18:05:00',1.31),('9303','2013-07-22','18:10:00',1.18),('9303','2013-07-22','18:15:00',1.09),('9303','2013-07-22','18:20:00',1.01),('9303','2013-07-21','08:05:00',1.04),('9303','2013-07-21','08:10:00',1.15),('9303','2013-07-21','08:15:00',1.22),('9303','2013-07-21','08:20:00',1.3),('9303','2013-07-21','08:25:00',1.39),('9303','2013-07-21','08:30:00',1.47),('9303','2013-07-21','08:35:00',1.55),('9303','2013-07-21','08:40:00',1.62),('9303','2013-07-21','08:45:00',1.68),('9303','2013-07-21','08:50:00',1.77),('9303','2013-07-21','08:55:00',1.87),('9303','2013-07-21','09:00:00',1.97),('9303','2013-07-21','09:05:00',2.03),('9303','2013-07-21','09:10:00',2.11),('9303','2013-07-21','09:15:00',2.16),('9303','2013-07-21','09:20:00',2.21),('9303','2013-07-21','09:25:00',2.29),('9303','2013-07-21','09:30:00',2.37),('9303','2013-07-21','09:35:00',2.42),('9303','2013-07-21','09:40:00',2.49),('9303','2013-07-21','09:45:00',2.55),('9303','2013-07-21','09:50:00',2.6),('9303','2013-07-21','09:55:00',2.67),('9303','2013-07-21','10:00:00',2.73),('9303','2013-07-21','10:05:00',2.79),('9303','2013-07-21','10:10:00',2.83),('9303','2013-07-21','10:15:00',2.88),('9303','2013-07-21','10:20:00',2.95),('9303','2013-07-21','10:25:00',3),('9303','2013-07-21','10:30:00',3.02),('9303','2013-07-21','10:35:00',3.06),('9303','2013-07-21','10:40:00',3.14),('9303','2013-07-21','10:45:00',3.2),('9303','2013-07-21','10:50:00',3.26),('9303','2013-07-21','10:55:00',3.28),('9303','2013-07-21','11:00:00',3.29),('9303','2013-07-21','11:05:00',3.3),('9303','2013-07-21','11:10:00',3.34),('9303','2013-07-21','11:15:00',3.39),('9303','2013-07-21','11:20:00',3.46),('9303','2013-07-21','11:25:00',3.49),('9303','2013-07-21','11:30:00',3.52),('9303','2013-07-21','11:35:00',3.57),('9303','2013-07-21','11:40:00',3.72),('9303','2013-07-21','11:45:00',3.48),('9303','2013-07-21','11:50:00',3.73),('9303','2013-07-21','11:55:00',3.72),('9303','2013-07-21','12:00:00',3.69),('9303','2013-07-21','12:05:00',3.77),('9303','2013-07-21','12:10:00',3.74),('9303','2013-07-21','12:15:00',3.99),('9303','2013-07-21','12:20:00',4.1),('9303','2013-07-21','12:25:00',4.22),('9303','2013-07-21','12:30:00',4.36),('9303','2013-07-21','12:35:00',4.44),('9303','2013-07-21','12:40:00',4.25),('9303','2013-07-21','12:45:00',3.37),('9303','2013-07-21','12:50:00',2.61),('9303','2013-07-21','12:55:00',4.68),('9303','2013-07-21','13:00:00',4.35),('9303','2013-07-21','13:05:00',4.48),('9303','2013-07-21','13:10:00',3.77),('9303','2013-07-21','13:15:00',3.23),('9303','2013-07-21','13:20:00',3.5),('9303','2013-07-21','13:25:00',4.22),('9303','2013-07-21','13:30:00',4.22),('9303','2013-07-21','13:35:00',2.98),('9303','2013-07-21','13:40:00',2.31),('9303','2013-07-21','13:45:00',1.79),('9303','2013-07-21','14:20:00',1.06),('9303','2013-07-21','14:25:00',1.17),('9303','2013-07-21','14:30:00',1.1),('9303','2013-07-21','14:35:00',1.18),('9303','2013-07-21','14:40:00',1.11),('9303','2013-07-21','14:45:00',2.15),('9303','2013-07-21','14:50:00',3.15),('9303','2013-07-21','14:55:00',1.53),('9303','2013-07-21','15:00:00',1.97),('9303','2013-07-21','15:05:00',1.37),('9303','2013-07-21','15:10:00',1.41),('9303','2013-07-21','15:15:00',2.81),('9303','2013-07-21','15:20:00',3.99),('9303','2013-07-21','15:25:00',1.44),('9303','2013-07-21','15:30:00',1.29),('9303','2013-07-21','15:35:00',1.45),('9303','2013-07-21','15:40:00',3.35),('9303','2013-07-21','15:45:00',2.23),('9303','2013-07-21','15:50:00',2.43),('9303','2013-07-21','15:55:00',1.97),('9303','2013-07-21','16:00:00',1.27),('9303','2013-07-21','17:00:00',1.05),('9303','2013-07-21','17:05:00',1.16),('9303','2013-07-21','17:10:00',1.13),('9303','2014-04-07','08:30:00',1.07),('9303','2014-04-07','08:35:00',1.48),('9303','2014-04-07','08:40:00',1.52),('9303','2014-04-07','08:45:00',1.58),('9303','2014-04-07','08:50:00',1.33),('9303','2014-04-07','08:55:00',1.09),('9303','2014-04-07','09:00:00',1.08),('9303','2014-04-07','09:05:00',1.12),('9303','2014-04-07','09:10:00',1.27),('9303','2014-04-07','09:15:00',1.36),('9303','2014-04-07','09:20:00',1.25),('9303','2014-04-07','11:00:00',1.11),('9303','2014-04-07','11:05:00',1.81),('9303','2014-04-07','11:10:00',2.09),('9303','2014-04-07','11:15:00',2.26),('9303','2014-04-07','11:20:00',2.05),('9303','2014-04-07','11:25:00',1.87),('9303','2014-04-07','11:30:00',1.92),('9303','2014-04-07','11:35:00',1.89),('9303','2014-04-07','11:40:00',1.8),('9303','2014-04-07','16:05:00',1.71),('9303','2014-04-07','16:10:00',3.03),('9303','2014-04-07','16:15:00',2.78),('9303','2014-04-07','16:20:00',2.59),('9303','2014-04-07','16:25:00',2.53),('9303','2014-04-07','16:30:00',2.43),('9303','2014-04-07','16:35:00',1.97),('9303','2014-04-07','16:40:00',1.02),('9303','2014-04-07','16:45:00',2.12),('9303','2014-04-07','16:50:00',2.24),('9303','2014-04-07','16:55:00',2.17),('9303','2014-04-07','17:00:00',2.32),('9303','2014-04-07','17:05:00',2.1),('9303','2014-04-07','17:10:00',1.31),('9303','2014-04-07','17:15:00',1.55),('9303','2013-07-20','08:00:00',1.03),('9303','2013-07-20','08:05:00',1.13),('9303','2013-07-20','08:10:00',1.22),('9303','2013-07-20','08:15:00',1.28),('9303','2013-07-20','08:20:00',1.38),('9303','2013-07-20','08:25:00',1.46),('9303','2013-07-20','08:30:00',1.55),('9303','2013-07-20','08:35:00',1.64),('9303','2013-07-20','08:40:00',1.71),('9303','2013-07-20','08:45:00',1.8),('9303','2013-07-20','08:50:00',1.91),('9303','2013-07-20','08:55:00',2.01),('9303','2013-07-20','09:00:00',2.09),('9303','2013-07-20','09:05:00',2.17),('9303','2013-07-20','09:10:00',2.29),('9303','2013-07-20','09:15:00',2.37),('9303','2013-07-20','09:20:00',2.42),('9303','2013-07-20','09:25:00',2.39),('9303','2013-07-20','09:30:00',2.41),('9303','2013-07-20','09:35:00',2.43),('9303','2013-07-20','09:40:00',2.43),('9303','2013-07-20','09:45:00',2.61),('9303','2013-07-20','09:50:00',2.58),('9303','2013-07-20','09:55:00',2.62),('9303','2013-07-20','10:00:00',2.77),('9303','2013-07-20','10:05:00',2.85),('9303','2013-07-20','10:10:00',2.89),('9303','2013-07-20','10:15:00',2.98),('9303','2013-07-20','10:20:00',3.04),('9303','2013-07-20','10:25:00',3.06),('9303','2013-07-20','10:30:00',3.07),('9303','2013-07-20','10:35:00',3.14),('9303','2013-07-20','10:40:00',3.18),('9303','2013-07-20','10:45:00',3.25),('9303','2013-07-20','10:50:00',3.29),('9303','2013-07-20','10:55:00',3.32),('9303','2013-07-20','11:00:00',3.36),('9303','2013-07-20','11:05:00',3.37),('9303','2013-07-20','11:10:00',3.42),('9303','2013-07-20','11:15:00',3.48),('9303','2013-07-20','11:20:00',3.47),('9303','2013-07-20','11:25:00',3.52),('9303','2013-07-20','11:30:00',3.56),('9303','2013-07-20','11:35:00',3.59),('9303','2013-07-20','11:40:00',3.61),('9303','2013-07-20','11:45:00',3.65),('9303','2013-07-20','11:50:00',3.68),('9303','2013-07-20','11:55:00',3.72),('9303','2013-07-20','12:00:00',3.83),('9303','2013-07-20','12:05:00',3.85),('9303','2013-07-20','12:10:00',3.88),('9303','2013-07-20','12:15:00',3.8),('9303','2013-07-20','12:20:00',3.17),('9303','2013-07-20','12:25:00',3.86),('9303','2013-07-20','12:30:00',3.85),('9303','2013-07-20','12:35:00',3.89),('9303','2013-07-20','12:40:00',3.97),('9303','2013-07-20','12:45:00',4.05),('9303','2013-07-20','12:50:00',4.04),('9303','2013-07-20','12:55:00',4.11),('9303','2013-07-20','13:00:00',4.06),('9303','2013-07-20','13:05:00',3.49),('9303','2013-07-20','13:10:00',2.54),('9303','2013-07-20','13:15:00',2.17),('9303','2013-07-20','13:20:00',2.76),('9303','2013-07-20','13:25:00',3.83),('9303','2013-07-20','13:30:00',4.14),('9303','2013-07-20','13:35:00',4.1),('9303','2013-07-20','13:40:00',4.2),('9303','2013-07-20','13:45:00',4.06),('9303','2013-07-20','13:50:00',1.62),('9303','2013-07-20','14:00:00',3.44),('9303','2013-07-20','14:05:00',4.22),('9303','2013-07-20','14:10:00',4.04),('9303','2013-07-20','14:15:00',3.16),('9303','2013-07-20','14:20:00',3.43),('9303','2013-07-20','14:25:00',4.05),('9303','2013-07-20','14:30:00',3.99),('9303','2013-07-20','14:35:00',4),('9303','2013-07-20','14:40:00',2.97),('9303','2013-07-20','14:45:00',1.9),('9303','2013-07-20','14:50:00',2.23),('9303','2013-07-20','14:55:00',1.06),('9303','2013-07-20','15:00:00',2.51),('9303','2013-07-20','15:05:00',3.84),('9303','2013-07-20','15:10:00',3.75),('9303','2013-07-20','15:15:00',3.63),('9303','2013-07-20','15:20:00',3.55),('9303','2013-07-20','15:25:00',3.49),('9303','2013-07-20','15:30:00',3.44),('9303','2013-07-20','15:35:00',3.41),('9303','2013-07-20','15:40:00',3.35),('9303','2013-07-20','15:45:00',3.28),('9303','2013-07-20','15:50:00',3.2),('9303','2013-07-20','15:55:00',3.19),('9303','2013-07-20','16:00:00',3.16),('9303','2013-07-20','16:05:00',3.08),('9303','2013-07-20','16:10:00',3.03),('9303','2013-07-20','16:15:00',3.01),('9303','2013-07-20','16:20:00',2.96),('9303','2013-07-20','16:25:00',2.89),('9303','2013-07-20','16:30:00',2.82),('9303','2013-07-20','16:35:00',2.76),('9303','2013-07-20','16:40:00',2.69),('9303','2013-07-20','16:45:00',2.61),('9303','2013-07-20','16:50:00',2.54),('9303','2013-07-20','16:55:00',2.46),('9303','2013-07-20','17:00:00',2.37),('9303','2013-07-20','17:05:00',2.33),('9303','2013-07-20','17:10:00',2.26),('9303','2013-07-20','17:15:00',2.15),('9303','2013-07-20','17:20:00',2.05),('9303','2013-07-20','17:25:00',1.95),('9303','2013-07-20','17:30:00',1.88),('9303','2013-07-20','17:35:00',1.83),('9303','2013-07-20','17:40:00',1.74),('9303','2013-07-20','17:45:00',1.64),('9303','2013-07-20','17:50:00',1.57),('9303','2013-07-20','17:55:00',1.49),('9303','2013-07-20','18:00:00',1.43),('9303','2013-07-20','18:05:00',1.32),('9303','2013-07-20','18:10:00',1.23),('9303','2013-07-20','18:15:00',1.16),('9303','2013-07-20','18:20:00',1.07),('9303','2013-07-19','08:00:00',1.01),('9303','2013-07-19','08:05:00',1.09),('9303','2013-07-19','08:10:00',1.18),('9303','2013-07-19','08:15:00',1.26),('9303','2013-07-19','08:20:00',1.35),('9303','2013-07-19','08:25:00',1.42),('9303','2013-07-19','08:30:00',1.48),('9303','2013-07-19','08:35:00',1.57),('9303','2013-07-19','08:40:00',1.65),('9303','2013-07-19','08:45:00',1.73),('9303','2013-07-19','08:50:00',1.82),('9303','2013-07-19','08:55:00',1.92),('9303','2013-07-19','09:00:00',1.97),('9303','2013-07-19','09:05:00',2.04),('9303','2013-07-19','09:10:00',2.1),('9303','2013-07-19','09:15:00',2.16),('9303','2013-07-19','09:20:00',2.22),('9303','2013-07-19','09:25:00',2.3),('9303','2013-07-19','09:30:00',2.36),('9303','2013-07-19','09:35:00',2.42),('9303','2013-07-19','09:40:00',2.47),('9303','2013-07-19','09:45:00',2.53),('9303','2013-07-19','09:50:00',2.59),('9303','2013-07-19','09:55:00',2.63),('9303','2013-07-19','10:00:00',2.69),('9303','2013-07-19','10:05:00',2.72),('9303','2013-07-19','10:10:00',2.78),('9303','2013-07-19','10:15:00',2.85),('9303','2013-07-19','10:20:00',2.88),('9303','2013-07-19','10:25:00',3),('9303','2013-07-19','10:30:00',2.97),('9303','2013-07-19','10:35:00',3.08),('9303','2013-07-19','10:40:00',3.12),('9303','2013-07-19','10:45:00',3.13),('9303','2013-07-19','10:50:00',3.16),('9303','2013-07-19','10:55:00',3.19),('9303','2013-07-19','11:00:00',3.22),('9303','2013-07-19','11:05:00',3.21),('9303','2013-07-19','11:10:00',3.23),('9303','2013-07-19','11:15:00',3.28),('9303','2013-07-19','11:20:00',3.3),('9303','2013-07-19','11:25:00',3.35),('9303','2013-07-19','11:30:00',3.39),('9303','2013-07-19','11:35:00',3.37),('9303','2013-07-19','11:40:00',3.49),('9303','2013-07-19','11:45:00',3.6),('9303','2013-07-19','11:50:00',3.51),('9303','2013-07-19','11:55:00',3.1),('9303','2013-07-19','12:00:00',2.54),('9303','2013-07-19','12:05:00',3.35),('9303','2013-07-19','12:10:00',3.66),('9303','2013-07-19','12:15:00',3.76),('9303','2013-07-19','12:20:00',3.75),('9303','2013-07-19','12:25:00',3.8),('9303','2013-07-19','12:30:00',3.74),('9303','2013-07-19','12:35:00',3.7),('9303','2013-07-19','12:40:00',3.69),('9303','2013-07-19','12:45:00',3.72),('9303','2013-07-19','12:50:00',3.78),('9303','2013-07-19','12:55:00',3.46),('9303','2013-07-19','13:00:00',3.57),('9303','2013-07-19','13:05:00',3.97),('9303','2013-07-19','13:10:00',4),('9303','2013-07-19','13:15:00',2.61),('9303','2013-07-19','13:20:00',4.1),('9303','2013-07-19','13:25:00',4.18),('9303','2013-07-19','13:30:00',4.04),('9303','2013-07-19','13:35:00',4.03),('9303','2013-07-19','13:40:00',4.01),('9303','2013-07-19','13:45:00',3.99),('9303','2013-07-19','13:50:00',4.03),('9303','2013-07-19','13:55:00',4.03),('9303','2013-07-19','14:00:00',4.03),('9303','2013-07-19','14:05:00',3.99),('9303','2013-07-19','14:10:00',3.33),('9303','2013-07-19','14:15:00',3.74),('9303','2013-07-19','14:20:00',3.86),('9303','2013-07-19','14:25:00',3.51),('9303','2013-07-19','14:30:00',3.86),('9303','2013-07-19','14:35:00',3.85),('9303','2013-07-19','14:40:00',3.8),('9303','2013-07-19','14:45:00',3.79),('9303','2013-07-19','14:50:00',3.77),('9303','2013-07-19','14:55:00',3.76),('9303','2013-07-19','15:00:00',3.37),('9303','2013-07-19','15:05:00',3.73),('9303','2013-07-19','15:10:00',3.61),('9303','2013-07-19','15:15:00',3.14),('9303','2013-07-19','15:20:00',2.61),('9303','2013-07-19','15:25:00',2.96),('9303','2013-07-19','15:30:00',3.66),('9303','2013-07-19','15:35:00',3.32),('9303','2013-07-19','15:40:00',2.72),('9303','2013-07-19','15:45:00',3.45),('9303','2013-07-19','15:50:00',3.12),('9303','2013-07-19','15:55:00',3.31),('9303','2013-07-19','16:00:00',3.22),('9303','2013-07-19','16:05:00',3.17),('9303','2013-07-19','16:10:00',3.1),('9303','2013-07-19','16:15:00',3.07),('9303','2013-07-19','16:20:00',3.05),('9303','2013-07-19','16:25:00',3.01),('9303','2013-07-19','16:30:00',2.97),('9303','2013-07-19','16:35:00',2.92),('9303','2013-07-19','16:40:00',2.87),('9303','2013-07-19','16:45:00',2.82),('9303','2013-07-19','16:50:00',2.62),('9303','2013-07-19','16:55:00',2.57),('9303','2013-07-19','17:00:00',2.16),('9303','2013-07-19','17:05:00',2.62),('9303','2013-07-19','17:10:00',2.64),('9303','2013-07-19','17:15:00',2.04),('9303','2013-07-19','17:20:00',1.85),('9303','2013-07-19','17:25:00',1.71),('9303','2013-07-19','17:30:00',1.71),('9303','2013-07-19','17:35:00',1.91),('9303','2013-07-19','17:40:00',1.44),('9303','2013-07-19','17:45:00',1.19),('9303','2013-07-18','07:55:00',1),('9303','2013-07-18','08:00:00',1.07),('9303','2013-07-18','08:05:00',1.17),('9303','2013-07-18','08:10:00',1.26),('9303','2013-07-18','08:15:00',1.34),('9303','2013-07-18','08:20:00',1.44),('9303','2013-07-18','08:25:00',1.51),('9303','2013-07-18','08:30:00',1.58),('9303','2013-07-18','08:35:00',1.67),('9303','2013-07-18','08:40:00',1.74),('9303','2013-07-18','08:45:00',1.81),('9303','2013-07-18','08:50:00',1.88),('9303','2013-07-18','08:55:00',2),('9303','2013-07-18','09:00:00',2.06),('9303','2013-07-18','09:05:00',2.13),('9303','2013-07-18','09:10:00',2.2),('9303','2013-07-18','09:15:00',2.26),('9303','2013-07-18','09:20:00',2.33),('9303','2013-07-18','09:25:00',2.4),('9303','2013-07-18','09:30:00',2.48),('9303','2013-07-18','09:35:00',2.54),('9303','2013-07-18','09:40:00',2.6),('9303','2013-07-18','09:45:00',2.66),('9303','2013-07-18','09:50:00',2.71),('9303','2013-07-18','09:55:00',2.76),('9303','2013-07-18','10:00:00',2.82),('9303','2013-07-18','10:05:00',2.88),('9303','2013-07-18','10:10:00',2.94),('9303','2013-07-18','10:15:00',2.96),('9303','2013-07-18','10:20:00',3.02),('9303','2013-07-18','10:25:00',3.05),('9303','2013-07-18','10:30:00',3.12),('9303','2013-07-18','10:35:00',3.2),('9303','2013-07-18','10:40:00',3.25),('9303','2013-07-18','10:45:00',3.3),('9303','2013-07-18','10:50:00',3.36),('9303','2013-07-18','10:55:00',3.38),('9303','2013-07-18','11:00:00',3.37),('9303','2013-07-18','11:05:00',3.39),('9303','2013-07-18','11:10:00',3.44),('9303','2013-07-18','11:15:00',3.49),('9303','2013-07-18','11:20:00',3.52),('9303','2013-07-18','11:25:00',3.53),('9303','2013-07-18','11:30:00',3.54),('9303','2013-07-18','11:35:00',3.58),('9303','2013-07-18','11:40:00',3.59),('9303','2013-07-18','11:45:00',3.64),('9303','2013-07-18','11:50:00',3.65),('9303','2013-07-18','11:55:00',3.73),('9303','2013-07-18','12:00:00',3.76),('9303','2013-07-18','12:05:00',3.68),('9303','2013-07-18','12:10:00',3.72),('9303','2013-07-18','12:15:00',3.74),('9303','2013-07-18','12:20:00',3.79),('9303','2013-07-18','12:25:00',3.74),('9303','2013-07-18','12:30:00',3.83),('9303','2013-07-18','12:35:00',3.94),('9303','2013-07-18','12:40:00',4.05),('9303','2013-07-18','12:45:00',2.14),('9303','2013-07-18','12:50:00',3.42),('9303','2013-07-18','12:55:00',3.99),('9303','2013-07-18','13:00:00',3.97),('9303','2013-07-18','13:05:00',3.99),('9303','2013-07-18','13:10:00',3.9),('9303','2013-07-18','13:15:00',3.82),('9303','2013-07-18','13:20:00',3.87),('9303','2013-07-18','13:25:00',4.07),('9303','2013-07-18','13:30:00',4.02),('9303','2013-07-18','13:35:00',3.98),('9303','2013-07-18','13:40:00',4.15),('9303','2013-07-18','13:45:00',4.07),('9303','2013-07-18','13:50:00',2.47),('9303','2013-07-18','13:55:00',3.68),('9303','2013-07-18','14:00:00',3.94),('9303','2013-07-18','14:05:00',3.85),('9303','2013-07-18','14:10:00',3.85),('9303','2013-07-18','14:15:00',3.92),('9303','2013-07-18','14:20:00',3.89),('9303','2013-07-18','14:25:00',3.85),('9303','2013-07-18','14:30:00',3.76),('9303','2013-07-18','14:35:00',3.79),('9303','2013-07-18','14:40:00',3.75),('9303','2013-07-18','14:45:00',3.72),('9303','2013-07-18','14:50:00',3.7),('9303','2013-07-18','14:55:00',3.6),('9303','2013-07-18','15:00:00',3.6),('9303','2013-07-18','15:05:00',3.61),('9303','2013-07-18','15:10:00',3.57),('9303','2013-07-18','15:15:00',3.49),('9303','2013-07-18','15:20:00',3.46),('9303','2013-07-18','15:25:00',3.45),('9303','2013-07-18','15:30:00',3.41),('9303','2013-07-18','15:35:00',3.35),('9303','2013-07-18','15:40:00',3.31),('9303','2013-07-18','15:45:00',3.25),('9303','2013-07-18','15:50:00',3.22),('9303','2013-07-18','15:55:00',3.16),('9303','2013-07-18','16:00:00',3.12),('9303','2013-07-18','16:05:00',3.05),('9303','2013-07-18','16:10:00',3.01),('9303','2013-07-18','16:15:00',2.94),('9303','2013-07-18','16:20:00',2.89),('9303','2013-07-18','16:25:00',2.82),('9303','2013-07-18','16:30:00',2.76),('9303','2013-07-18','16:35:00',2.72),('9303','2013-07-18','16:40:00',2.65),('9303','2013-07-18','16:45:00',2.58),('9303','2013-07-18','16:50:00',2.5),('9303','2013-07-18','16:55:00',2.43),('9303','2013-07-18','17:00:00',2.32),('9303','2013-07-18','17:05:00',2.27),('9303','2013-07-18','17:10:00',2.16),('9303','2013-07-18','17:15:00',2.04),('9303','2013-07-18','17:20:00',1.84),('9303','2013-07-18','17:25:00',1.9),('9303','2013-07-18','17:30:00',1.79),('9303','2013-07-18','17:35:00',1.73),('9303','2013-07-18','17:40:00',1.55),('9303','2013-07-18','17:45:00',1.4),('9303','2013-07-18','17:50:00',1.35),('9303','2013-07-18','17:55:00',1.43),('9303','2013-07-18','18:00:00',1.3),('9303','2013-07-18','18:05:00',1.22),('9303','2013-07-18','18:10:00',1.13),('9303','2013-07-18','18:15:00',1.07),('9303','2013-07-17','07:55:00',1.01),('9303','2013-07-17','08:00:00',1.09),('9303','2013-07-17','08:05:00',1.21),('9303','2013-07-17','08:10:00',1.31),('9303','2013-07-17','08:15:00',1.38),('9303','2013-07-17','08:20:00',1.49),('9303','2013-07-17','08:25:00',1.59),('9303','2013-07-17','08:30:00',1.66),('9303','2013-07-17','08:35:00',1.75),('9303','2013-07-17','08:40:00',1.83),('9303','2013-07-17','08:45:00',1.91),('9303','2013-07-17','08:50:00',1.99),('9303','2013-07-17','08:55:00',2.08),('9303','2013-07-17','09:00:00',2.17),('9303','2013-07-17','09:05:00',2.26),('9303','2013-07-17','09:10:00',2.34),('9303','2013-07-17','09:15:00',2.43),('9303','2013-07-17','09:20:00',2.49),('9303','2013-07-17','09:25:00',2.55),('9303','2013-07-17','09:30:00',2.6),('9303','2013-07-17','09:35:00',2.66),('9303','2013-07-17','09:40:00',2.72),('9303','2013-07-17','09:45:00',2.8),('9303','2013-07-17','09:50:00',2.84),('9303','2013-07-17','09:55:00',2.89),('9303','2013-07-17','10:00:00',2.93),('9303','2013-07-17','10:05:00',3),('9303','2013-07-17','10:10:00',3.05),('9303','2013-07-17','10:15:00',3.09),('9303','2013-07-17','10:20:00',3.14),('9303','2013-07-17','10:25:00',3.19),('9303','2013-07-17','10:30:00',3.24),('9303','2013-07-17','10:35:00',3.28),('9303','2013-07-17','10:40:00',3.32),('9303','2013-07-17','10:45:00',3.39),('9303','2013-07-17','10:50:00',3.44),('9303','2013-07-17','10:55:00',3.48),('9303','2013-07-17','11:00:00',3.53),('9303','2013-07-17','11:05:00',3.6),('9303','2013-07-17','11:10:00',3.61),('9303','2013-07-17','11:15:00',3.62),('9303','2013-07-17','11:20:00',3.67),('9303','2013-07-17','11:25:00',3.71),('9303','2013-07-17','11:30:00',3.72),('9303','2013-07-17','11:35:00',3.78),('9303','2013-07-17','11:40:00',3.79),('9303','2013-07-17','11:45:00',3.83),('9303','2013-07-17','11:50:00',3.84),('9303','2013-07-17','11:55:00',3.87),('9303','2013-07-17','12:00:00',3.92),('9303','2013-07-17','12:05:00',3.91),('9303','2013-07-17','12:10:00',3.95),('9303','2013-07-17','12:15:00',3.92),('9303','2013-07-17','12:20:00',3.91),('9303','2013-07-17','12:25:00',3.95),('9303','2013-07-17','12:30:00',3.94),('9303','2013-07-17','12:35:00',3.91),('9303','2013-07-17','12:40:00',3.9),('9303','2013-07-17','12:45:00',3.93),('9303','2013-07-17','12:50:00',3.96),('9303','2013-07-17','12:55:00',4.02),('9303','2013-07-17','13:00:00',4.03),('9303','2013-07-17','13:05:00',4.02),('9303','2013-07-17','13:10:00',4),('9303','2013-07-17','13:15:00',3.98),('9303','2013-07-17','13:20:00',3.95),('9303','2013-07-17','13:25:00',3.94),('9303','2013-07-17','13:30:00',3.95),('9303','2013-07-17','13:35:00',3.91),('9303','2013-07-17','13:40:00',3.91),('9303','2013-07-17','13:45:00',3.92),('9303','2013-07-17','13:50:00',3.91),('9303','2013-07-17','13:55:00',3.95),('9303','2013-07-17','14:00:00',3.96),('9303','2013-07-17','14:05:00',3.9),('9303','2013-07-17','14:10:00',3.86),('9303','2013-07-17','14:15:00',3.83),('9303','2013-07-17','14:20:00',3.8),('9303','2013-07-17','14:25:00',3.8),('9303','2013-07-17','14:30:00',3.77),('9303','2013-07-17','14:35:00',3.77),('9303','2013-07-17','14:40:00',3.92),('9303','2013-07-17','14:45:00',3.8),('9303','2013-07-17','14:50:00',3.71),('9303','2013-07-17','14:55:00',3.69),('9303','2013-07-17','15:00:00',3.56),('9303','2013-07-17','15:05:00',2.57),('9303','2013-07-17','15:10:00',2.81),('9303','2013-07-17','15:15:00',3.68),('9303','2013-07-17','15:20:00',3.61),('9303','2013-07-17','15:25:00',3.4),('9303','2013-07-17','15:30:00',3.46),('9303','2013-07-17','15:35:00',3.43),('9303','2013-07-17','15:40:00',2.56),('9303','2013-07-17','15:45:00',3.37),('9303','2013-07-17','15:50:00',3.08),('9303','2013-07-17','15:55:00',3.28),('9303','2013-07-17','16:00:00',3.2),('9303','2013-07-17','16:05:00',3.15),('9303','2013-07-17','16:10:00',3.11),('9303','2013-07-17','16:15:00',3.03),('9303','2013-07-17','16:20:00',2.97),('9303','2013-07-17','16:25:00',2.89),('9303','2013-07-17','16:30:00',2.81),('9303','2013-07-17','16:35:00',2.75),('9303','2013-07-17','16:40:00',2.73),('9303','2013-07-17','16:45:00',2.72),('9303','2013-07-17','16:50:00',2.6),('9303','2013-07-17','16:55:00',2.51),('9303','2013-07-17','17:00:00',2.13),('9303','2013-07-17','17:05:00',2.37),('9303','2013-07-17','17:10:00',2.4),('9303','2013-07-17','17:15:00',2.24),('9303','2013-07-17','17:20:00',2.11),('9303','2013-07-17','17:25:00',1.96),('9303','2013-07-17','17:30:00',1.88),('9303','2013-07-17','17:35:00',1.8),('9303','2013-07-17','17:40:00',1.7),('9303','2013-07-17','17:45:00',1.66),('9303','2013-07-17','17:50:00',1.59),('9303','2013-07-17','17:55:00',1.49),('9303','2013-07-17','18:00:00',1.43),('9303','2013-07-17','18:05:00',1.35),('9303','2013-07-17','18:10:00',1.27),('9303','2013-07-17','18:15:00',1.19),('9303','2013-07-17','18:20:00',1.1),('9303','2013-07-16','07:55:00',1.03),('9303','2013-07-16','08:00:00',1.08),('9303','2013-07-16','08:05:00',1.18),('9303','2013-07-16','08:10:00',1.27),('9303','2013-07-16','08:15:00',1.35),('9303','2013-07-16','08:20:00',1.44),('9303','2013-07-16','08:25:00',1.54),('9303','2013-07-16','08:30:00',1.61),('9303','2013-07-16','08:35:00',1.67),('9303','2013-07-16','08:40:00',1.7),('9303','2013-07-16','08:45:00',1.8),('9303','2013-07-16','08:50:00',1.89),('9303','2013-07-16','08:55:00',1.99),('9303','2013-07-16','09:00:00',2.06),('9303','2013-07-16','09:05:00',2.13),('9303','2013-07-16','09:10:00',2.21),('9303','2013-07-16','09:15:00',2.26),('9303','2013-07-16','09:20:00',2.33),('9303','2013-07-16','09:25:00',2.4),('9303','2013-07-16','09:30:00',2.47),('9303','2013-07-16','09:35:00',2.53),('9303','2013-07-16','09:40:00',2.6),('9303','2013-07-16','09:45:00',2.68),('9303','2013-07-16','09:50:00',2.77),('9303','2013-07-16','09:55:00',2.83),('9303','2013-07-16','10:00:00',2.89),('9303','2013-07-16','10:05:00',2.96),('9303','2013-07-16','10:10:00',3.02),('9303','2013-07-16','10:15:00',3.07),('9303','2013-07-16','10:20:00',3.1),('9303','2013-07-16','10:25:00',3.15),('9303','2013-07-16','10:30:00',3.18),('9303','2013-07-16','10:35:00',3.24),('9303','2013-07-16','10:40:00',3.31),('9303','2013-07-16','10:45:00',3.33),('9303','2013-07-16','10:50:00',3.35),('9303','2013-07-16','10:55:00',3.4),('9303','2013-07-16','11:00:00',3.43),('9303','2013-07-16','11:05:00',3.46),('9303','2013-07-16','11:10:00',3.53),('9303','2013-07-16','11:15:00',3.55),('9303','2013-07-16','11:20:00',3.59),('9303','2013-07-16','11:25:00',3.64),('9303','2013-07-16','11:30:00',3.65),('9303','2013-07-16','11:35:00',3.67),('9303','2013-07-16','11:40:00',3.72),('9303','2013-07-16','11:45:00',3.77),('9303','2013-07-16','11:50:00',3.84),('9303','2013-07-16','11:55:00',3.86),('9303','2013-07-16','12:00:00',3.88),('9303','2013-07-16','12:05:00',3.9),('9303','2013-07-16','12:10:00',3.93),('9303','2013-07-16','12:15:00',3.98),('9303','2013-07-16','12:20:00',3.96),('9303','2013-07-16','12:25:00',3.95),('9303','2013-07-16','12:30:00',3.93),('9303','2013-07-16','12:35:00',3.93),('9303','2013-07-16','12:40:00',3.93),('9303','2013-07-16','12:45:00',3.9),('9303','2013-07-16','12:50:00',3.9),('9303','2013-07-16','12:55:00',3.9),('9303','2013-07-16','13:00:00',3.95),('9303','2013-07-16','13:05:00',3.99),('9303','2013-07-16','13:10:00',3.96),('9303','2013-07-16','13:15:00',4.03),('9303','2013-07-16','13:20:00',3.98),('9303','2013-07-16','13:25:00',4),('9303','2013-07-16','13:30:00',3.97),('9303','2013-07-16','13:35:00',3.95),('9303','2013-07-16','13:40:00',3.98),('9303','2013-07-16','13:45:00',4.07),('9303','2013-07-16','13:50:00',3.99),('9303','2013-07-16','13:55:00',3.75),('9303','2013-07-16','14:00:00',3.9),('9303','2013-07-16','14:05:00',3.94),('9303','2013-07-16','14:10:00',3.25),('9303','2013-07-16','14:15:00',3.23),('9303','2013-07-16','14:20:00',1.98),('9303','2013-07-16','14:25:00',3.98),('9303','2013-07-16','14:30:00',3.9),('9303','2013-07-16','14:35:00',3.89),('9303','2013-07-16','14:40:00',3.84),('9303','2013-07-16','14:45:00',3.78),('9303','2013-07-16','14:50:00',3.78),('9303','2013-07-16','14:55:00',3.78),('9303','2013-07-16','15:00:00',3.71),('9303','2013-07-16','15:05:00',3.64),('9303','2013-07-16','15:10:00',3.54),('9303','2013-07-16','15:15:00',3.51),('9303','2013-07-16','15:20:00',3.54),('9303','2013-07-16','15:25:00',3.52),('9303','2013-07-16','15:30:00',3.5),('9303','2013-07-16','15:35:00',3.42),('9303','2013-07-16','15:40:00',2.98),('9303','2013-07-16','15:45:00',2.18),('9303','2013-07-16','15:50:00',3.33),('9303','2013-07-16','15:55:00',3.27),('9303','2013-07-16','16:00:00',1.87),('9303','2013-07-16','16:05:00',1.67),('9303','2013-07-16','16:10:00',3.12),('9303','2013-07-16','16:15:00',2.51),('9303','2013-07-16','16:20:00',1.71),('9303','2013-07-16','16:25:00',1.11),('9303','2013-07-16','16:30:00',1.02),('9303','2013-07-16','16:45:00',1.2),('9303','2013-07-16','16:50:00',1.16),('9303','2013-07-16','16:55:00',1.64),('9303','2013-07-16','17:00:00',2.64),('9303','2013-07-16','17:05:00',2.71),('9303','2013-07-16','17:10:00',2.57),('9303','2013-07-16','17:15:00',2.48),('9303','2013-07-16','17:20:00',1.56),('9303','2013-07-16','17:25:00',1.24),('9303','2013-07-16','17:30:00',1.31),('9303','2013-07-16','17:35:00',1.74),('9303','2013-07-16','17:40:00',1.73),('9303','2013-07-16','17:45:00',1.81),('9303','2013-07-16','17:50:00',1.7),('9303','2013-07-16','17:55:00',1.24),('9303','2013-07-16','18:15:00',1.17),('9303','2013-07-16','18:20:00',1.05),('9303','2013-07-15','07:55:00',1.04),('9303','2013-07-15','08:00:00',1.13),('9303','2013-07-15','08:05:00',1.23),('9303','2013-07-15','08:10:00',1.31),('9303','2013-07-15','08:15:00',1.4),('9303','2013-07-15','08:20:00',1.51),('9303','2013-07-15','08:25:00',1.58),('9303','2013-07-15','08:30:00',1.67),('9303','2013-07-15','08:35:00',1.75),('9303','2013-07-15','08:40:00',1.83),('9303','2013-07-15','08:45:00',1.91),('9303','2013-07-15','08:50:00',1.99),('9303','2013-07-15','08:55:00',2.07),('9303','2013-07-15','09:00:00',2.16),('9303','2013-07-15','09:05:00',2.24),('9303','2013-07-15','09:10:00',2.28),('9303','2013-07-15','09:15:00',2.39),('9303','2013-07-15','09:20:00',2.45),('9303','2013-07-15','09:25:00',2.53),('9303','2013-07-15','09:30:00',2.59),('9303','2013-07-15','09:35:00',2.65),('9303','2013-07-15','09:40:00',2.72),('9303','2013-07-15','09:45:00',2.76),('9303','2013-07-15','09:50:00',2.83),('9303','2013-07-15','09:55:00',2.9),('9303','2013-07-15','10:00:00',2.92),('9303','2013-07-15','10:05:00',2.96),('9303','2013-07-15','10:10:00',3.02),('9303','2013-07-15','10:15:00',3.07),('9303','2013-07-15','10:20:00',3.08),('9303','2013-07-15','10:25:00',3.16),('9303','2013-07-15','10:30:00',3.19),('9303','2013-07-15','10:35:00',3.23),('9303','2013-07-15','10:40:00',3.27),('9303','2013-07-15','10:45:00',3.31),('9303','2013-07-15','10:50:00',3.36),('9303','2013-07-15','10:55:00',3.41),('9303','2013-07-15','11:00:00',3.46),('9303','2013-07-15','11:05:00',3.46),('9303','2013-07-15','11:10:00',3.49),('9303','2013-07-15','11:15:00',3.52),('9303','2013-07-15','11:20:00',3.55),('9303','2013-07-15','11:25:00',3.61),('9303','2013-07-15','11:30:00',3.67),('9303','2013-07-15','11:35:00',3.72),('9303','2013-07-15','11:40:00',3.75),('9303','2013-07-15','11:45:00',3.75),('9303','2013-07-15','11:50:00',3.71),('9303','2013-07-15','11:55:00',3.81),('9303','2013-07-15','12:00:00',3.84),('9303','2013-07-15','12:05:00',3.79),('9303','2013-07-15','12:10:00',3.82),('9303','2013-07-15','12:15:00',3.92),('9303','2013-07-15','12:20:00',3.94),('9303','2013-07-15','12:25:00',3.95),('9303','2013-07-15','12:30:00',3.94),('9303','2013-07-15','12:35:00',3.9),('9303','2013-07-15','12:40:00',3.88),('9303','2013-07-15','12:45:00',3.84),('9303','2013-07-15','12:50:00',3.9),('9303','2013-07-15','12:55:00',3.95),('9303','2013-07-15','13:00:00',3.47),('9303','2013-07-15','13:05:00',2.32),('9303','2013-07-15','13:10:00',3.45),('9303','2013-07-15','13:15:00',4.05),('9303','2013-07-15','13:20:00',3.93),('9303','2013-07-15','13:25:00',4.14),('9303','2013-07-15','13:30:00',4.18),('9303','2013-07-15','13:35:00',3.07),('9303','2013-07-15','13:40:00',1.15),('9303','2013-07-15','13:45:00',3.96),('9303','2013-07-15','13:50:00',4.27),('9303','2013-07-15','13:55:00',4.26),('9303','2013-07-15','14:00:00',4.22),('9303','2013-07-15','14:05:00',3.79),('9303','2013-07-15','14:20:00',4.01),('9303','2013-07-15','14:25:00',4.07),('9303','2013-07-15','14:30:00',3.97),('9303','2013-07-15','14:35:00',3.94),('9303','2013-07-15','14:40:00',3.97),('9303','2013-07-15','14:45:00',3.91),('9303','2013-07-15','14:50:00',3.89),('9303','2013-07-15','14:55:00',3.89),('9303','2013-07-15','15:00:00',3.81),('9303','2013-07-15','15:05:00',3.74),('9303','2013-07-15','15:10:00',3.63),('9303','2013-07-15','15:15:00',3.58),('9303','2013-07-15','15:20:00',1.71),('9303','2013-07-15','15:25:00',2.62),('9303','2013-07-15','15:30:00',3.56),('9303','2013-07-15','15:35:00',3.48),('9303','2013-07-15','15:40:00',3.48),('9303','2013-07-15','15:45:00',3.26),('9303','2013-07-15','15:50:00',3.42),('9303','2013-07-15','15:55:00',3.22),('9303','2013-07-15','16:00:00',3.16),('9303','2013-07-15','16:05:00',3.13),('9303','2013-07-15','16:10:00',3.1),('9303','2013-07-15','16:15:00',3.05),('9303','2013-07-15','16:20:00',2.89),('9303','2013-07-15','16:25:00',2.8),('9303','2013-07-15','16:30:00',2.79),('9303','2013-07-15','16:35:00',2.76),('9303','2013-07-15','16:40:00',2.67),('9303','2013-07-15','16:45:00',2.61),('9303','2013-07-15','16:50:00',2.54),('9303','2013-07-15','16:55:00',2.49),('9303','2013-07-15','17:00:00',2.43),('9303','2013-07-15','17:05:00',2.36),('9303','2013-07-15','17:10:00',2.28),('9303','2013-07-15','17:15:00',2.17),('9303','2013-07-15','17:20:00',2.08),('9303','2013-07-15','17:25:00',2),('9303','2013-07-15','17:30:00',1.9),('9303','2013-07-15','17:35:00',1.82),('9303','2013-07-15','17:40:00',1.72),('9303','2013-07-15','17:45:00',1.63),('9303','2013-07-15','17:50:00',1.56),('9303','2013-07-15','17:55:00',1.48),('9303','2013-07-15','18:00:00',1.4),('9303','2013-07-15','18:05:00',1.32),('9303','2013-07-15','18:10:00',1.23),('9303','2013-07-15','18:15:00',1.14),('9303','2013-07-15','18:20:00',1.05),('9303','2013-07-14','07:55:00',1.16),('9303','2013-07-14','08:05:00',1.33),('9303','2013-07-14','08:10:00',1.56),('9303','2013-07-14','08:15:00',1.66),('9303','2013-07-14','08:20:00',1.94),('9303','2013-07-14','08:25:00',1.26),('9303','2013-07-14','08:35:00',1.07),('9303','2013-07-14','08:50:00',1.05),('9303','2013-07-14','08:55:00',1.12),('9303','2013-07-14','09:00:00',1.19),('9303','2013-07-14','09:05:00',1.4),('9303','2013-07-14','09:10:00',1.24),('9303','2013-07-14','09:15:00',1.32),('9303','2013-07-14','09:20:00',1.73),('9303','2013-07-14','09:25:00',2.2),('9303','2013-07-14','09:30:00',2),('9303','2013-07-14','09:35:00',1.69),('9303','2013-07-14','09:40:00',1.54),('9303','2013-07-14','09:45:00',1.54),('9303','2013-07-14','09:50:00',1.47),('9303','2013-07-14','09:55:00',1.62),('9303','2013-07-14','10:00:00',1.54),('9303','2013-07-14','10:05:00',1.62),('9303','2013-07-14','10:10:00',1.61),('9303','2013-07-14','10:15:00',1.65),('9303','2013-07-14','10:20:00',2.18),('9303','2013-07-14','10:25:00',2.45),('9303','2013-07-14','10:30:00',2.42),('9303','2013-07-14','10:35:00',3.18),('9303','2013-07-14','10:40:00',3.18),('9303','2013-07-14','10:45:00',3.09),('9303','2013-07-14','10:50:00',3.66),('9303','2013-07-14','10:55:00',3.01),('9303','2013-07-14','11:00:00',3.65),('9303','2013-07-14','11:05:00',3.57),('9303','2013-07-14','11:10:00',3.32),('9303','2013-07-14','11:15:00',1.74),('9303','2013-07-14','11:20:00',2.18),('9303','2013-07-14','11:25:00',3.1),('9303','2013-07-14','11:30:00',2.53),('9303','2013-07-14','11:35:00',2.97),('9303','2013-07-14','11:40:00',3.72),('9303','2013-07-14','11:45:00',4.06),('9303','2013-07-14','11:50:00',2.19),('9303','2013-07-14','11:55:00',4.05),('9303','2013-07-14','12:00:00',2.78),('9303','2013-07-14','12:05:00',3.68),('9303','2013-07-14','12:10:00',3.93),('9303','2013-07-14','12:15:00',3.2),('9303','2013-07-14','12:20:00',2.33),('9303','2013-07-14','12:25:00',3),('9303','2013-07-14','12:30:00',1.26),('9303','2013-07-14','12:35:00',2.01),('9303','2013-07-14','12:40:00',3.22),('9303','2013-07-14','12:45:00',3.79),('9303','2013-07-14','12:50:00',3.19),('9303','2013-07-14','12:55:00',3.61),('9303','2013-07-14','13:00:00',4.34),('9303','2013-07-14','13:05:00',4.38),('9303','2013-07-14','13:10:00',4.2),('9303','2013-07-14','13:15:00',4.18),('9303','2013-07-14','13:20:00',4.22),('9303','2013-07-14','13:25:00',4.15),('9303','2013-07-14','13:30:00',4.14),('9303','2013-07-14','13:35:00',4.11),('9303','2013-07-14','13:40:00',4.07),('9303','2013-07-14','13:45:00',4.08),('9303','2013-07-14','13:50:00',4.13),('9303','2013-07-14','13:55:00',4.1),('9303','2013-07-14','14:00:00',4.1),('9303','2013-07-14','14:05:00',4.09),('9303','2013-07-14','14:10:00',4.07),('9303','2013-07-14','14:15:00',4.03),('9303','2013-07-14','14:20:00',4),('9303','2013-07-14','14:25:00',3.98),('9303','2013-07-14','14:30:00',3.95),('9303','2013-07-14','14:35:00',3.85),('9303','2013-07-14','14:40:00',3.81),('9303','2013-07-14','14:45:00',3.77),('9303','2013-07-14','14:50:00',3.75),('9303','2013-07-14','14:55:00',3.75),('9303','2013-07-14','15:00:00',3.71),('9303','2013-07-14','15:05:00',3.67),('9303','2013-07-14','15:10:00',3.63),('9303','2013-07-14','15:15:00',3.58),('9303','2013-07-14','15:20:00',3.54),('9303','2013-07-14','15:25:00',3.51),('9303','2013-07-14','15:30:00',3.47),('9303','2013-07-14','15:35:00',3.43),('9303','2013-07-14','15:40:00',3.35),('9303','2013-07-14','15:45:00',3.3),('9303','2013-07-14','15:50:00',3.26),('9303','2013-07-14','15:55:00',3.26),('9303','2013-07-14','16:00:00',3.18),('9303','2013-07-14','16:05:00',3.1),('9303','2013-07-14','16:10:00',3.11),('9303','2013-07-14','16:15:00',3.07),('9303','2013-07-14','16:20:00',2.89),('9303','2013-07-14','16:25:00',2.54),('9303','2013-07-14','16:30:00',2.69),('9303','2013-07-14','16:35:00',2.36),('9303','2013-07-14','16:40:00',2.89),('9303','2013-07-14','16:45:00',2.5),('9303','2013-07-14','16:50:00',2.83),('9303','2013-07-14','16:55:00',2.7),('9303','2013-07-14','17:00:00',2.14),('9303','2013-07-14','17:05:00',1.76),('9303','2013-07-14','17:10:00',2.11),('9303','2013-07-14','17:15:00',1.34),('9303','2013-07-14','17:20:00',1.23),('9303','2013-07-14','17:25:00',1.44),('9303','2013-07-14','17:30:00',1.83),('9303','2013-07-14','17:35:00',1.95),('9303','2013-07-14','17:40:00',1.34),('9303','2013-07-14','17:55:00',1.63),('9303','2013-07-13','08:00:00',1),('9303','2013-07-13','08:05:00',1.09),('9303','2013-07-13','08:10:00',1.21),('9303','2013-07-13','08:15:00',1.32),('9303','2013-07-13','08:20:00',1.41),('9303','2013-07-13','08:25:00',1.5),('9303','2013-07-13','08:30:00',1.58),('9303','2013-07-13','08:35:00',1.65),('9303','2013-07-13','08:40:00',1.7),('9303','2013-07-13','08:45:00',1.78),('9303','2013-07-13','08:50:00',1.85),('9303','2013-07-13','08:55:00',1.95),('9303','2013-07-13','09:00:00',2.06),('9303','2013-07-13','09:05:00',2.14),('9303','2013-07-13','09:10:00',2.2),('9303','2013-07-13','09:15:00',2.28),('9303','2013-07-13','09:20:00',2.34),('9303','2013-07-13','09:25:00',2.37),('9303','2013-07-13','09:30:00',2.46),('9303','2013-07-13','09:35:00',2.46),('9303','2013-07-13','09:40:00',2.49),('9303','2013-07-13','09:45:00',2.53),('9303','2013-07-13','09:50:00',2.71),('9303','2013-07-13','09:55:00',2.74),('9303','2013-07-13','10:00:00',2.83),('9303','2013-07-13','10:05:00',2.86),('9303','2013-07-13','10:10:00',2.88),('9303','2013-07-13','10:15:00',2.9),('9303','2013-07-13','10:20:00',3.01),('9303','2013-07-13','10:25:00',3.22),('9303','2013-07-13','10:30:00',3.22),('9303','2013-07-13','10:35:00',3),('9303','2013-07-13','10:40:00',3.17),('9303','2013-07-13','10:45:00',3.33),('9303','2013-07-13','10:50:00',3.41),('9303','2013-07-13','10:55:00',3.27),('9303','2013-07-13','11:00:00',3.53),('9303','2013-07-13','11:05:00',3.54),('9303','2013-07-13','11:10:00',3.78),('9303','2013-07-13','11:15:00',3.01),('9303','2013-07-13','11:20:00',1.58),('9303','2013-07-13','11:25:00',2.86),('9303','2013-07-13','11:30:00',2.73),('9303','2013-07-13','11:35:00',3.37),('9303','2013-07-13','11:40:00',1.92),('9303','2013-07-13','11:45:00',2.27),('9303','2013-07-13','11:50:00',4.09),('9303','2013-07-13','11:55:00',3.42),('9303','2013-07-13','12:00:00',2.04),('9303','2013-07-13','12:05:00',3.55),('9303','2013-07-13','12:10:00',3.17),('9303','2013-07-13','12:15:00',1.15),('9303','2013-07-13','12:20:00',2.83),('9303','2013-07-13','12:25:00',1.86),('9303','2013-07-13','12:30:00',1.94),('9303','2013-07-13','12:35:00',4.3),('9303','2013-07-13','12:40:00',4.17),('9303','2013-07-13','12:45:00',2.27),('9303','2013-07-13','12:50:00',4.16),('9303','2013-07-13','12:55:00',4.06),('9303','2013-07-13','13:00:00',4.17),('9303','2013-07-13','13:05:00',4.09),('9303','2013-07-13','13:10:00',3.27),('9303','2013-07-13','13:15:00',4.15),('9303','2013-07-13','13:20:00',4.12),('9303','2013-07-13','13:25:00',4.05),('9303','2013-07-13','13:30:00',4.05),('9303','2013-07-13','13:35:00',4.05),('9303','2013-07-13','13:40:00',4.06),('9303','2013-07-13','13:45:00',4.02),('9303','2013-07-13','13:50:00',4.03),('9303','2013-07-13','13:55:00',4.02),('9303','2013-07-13','14:00:00',3.99),('9303','2013-07-13','14:05:00',4),('9303','2013-07-13','14:10:00',3.96),('9303','2013-07-13','14:15:00',3.96),('9303','2013-07-13','14:20:00',3.93),('9303','2013-07-13','14:25:00',3.91),('9303','2013-07-13','14:30:00',3.92),('9303','2013-07-13','14:35:00',3.9),('9303','2013-07-13','14:40:00',3.87),('9303','2013-07-13','14:45:00',3.85),('9303','2013-07-13','14:50:00',3.82),('9303','2013-07-13','14:55:00',3.81),('9303','2013-07-13','15:00:00',3.79),('9303','2013-07-13','15:05:00',3.76),('9303','2013-07-13','15:10:00',3.71),('9303','2013-07-13','15:15:00',3.7),('9303','2013-07-13','15:20:00',3.53),('9303','2013-07-13','15:25:00',3.7),('9303','2013-07-13','15:30:00',3.58),('9303','2013-07-13','15:35:00',3.58),('9303','2013-07-13','15:40:00',3.5),('9303','2013-07-13','15:45:00',3.46),('9303','2013-07-13','15:50:00',3.4),('9303','2013-07-13','15:55:00',3.36),('9303','2013-07-13','16:00:00',3.32),('9303','2013-07-13','16:05:00',3.27),('9303','2013-07-13','16:10:00',3.21),('9303','2013-07-13','16:15:00',3.12),('9303','2013-07-13','16:20:00',2.99),('9303','2013-07-13','16:25:00',3.05),('9303','2013-07-13','16:30:00',2.98),('9303','2013-07-13','16:35:00',2.92),('9303','2013-07-13','16:40:00',2.84),('9303','2013-07-13','16:45:00',2.76),('9303','2013-07-13','16:50:00',2.66),('9303','2013-07-13','16:55:00',2.6),('9303','2013-07-13','17:00:00',2.54),('9303','2013-07-13','17:05:00',2.42),('9303','2013-07-13','17:10:00',2.4),('9303','2013-07-13','17:15:00',2.3),('9303','2013-07-13','17:20:00',2.1),('9303','2013-07-13','17:25:00',2.09),('9303','2013-07-13','17:30:00',1.95),('9303','2013-07-13','17:35:00',1.86),('9303','2013-07-13','17:40:00',1.77),('9303','2013-07-13','17:45:00',1.71),('9303','2013-07-13','17:50:00',1.62),('9303','2013-07-13','17:55:00',1.64),('9303','2013-07-13','18:00:00',1.5),('9303','2013-07-13','18:05:00',1.41),('9303','2013-07-13','18:10:00',1.34),('9303','2013-07-13','18:15:00',1.25),('9303','2013-07-13','18:20:00',1.15),('9303','2013-07-13','18:25:00',1.02),('9303','2013-07-12','08:15:00',1.42),('9303','2013-07-12','08:20:00',1.65),('9303','2013-07-12','08:45:00',1.19),('9303','2013-07-12','09:10:00',1.38),('9303','2013-07-12','09:15:00',1.53),('9303','2013-07-12','09:20:00',2.12),('9303','2013-07-12','09:25:00',2.23),('9303','2013-07-12','09:30:00',1.53),('9303','2013-07-12','09:35:00',1.5),('9303','2013-07-12','09:40:00',1.74),('9303','2013-07-12','09:45:00',2.59),('9303','2013-07-12','09:50:00',2.73),('9303','2013-07-12','09:55:00',2.79),('9303','2013-07-12','10:00:00',2.85),('9303','2013-07-12','10:05:00',2.89),('9303','2013-07-12','10:10:00',2.36),('9303','2013-07-12','10:15:00',2.98),('9303','2013-07-12','10:20:00',1.88),('9303','2013-07-12','10:25:00',1.5),('9303','2013-07-12','10:30:00',1.91),('9303','2013-07-12','10:50:00',1.25),('9303','2013-07-12','10:55:00',2.5),('9303','2013-07-12','11:00:00',3.3),('9303','2013-07-12','11:05:00',1.03),('9303','2013-07-12','11:10:00',1.05),('9303','2013-07-12','11:15:00',2.49),('9303','2013-07-12','11:20:00',1.3),('9303','2013-07-12','11:25:00',3.4),('9303','2013-07-12','11:30:00',2.79),('9303','2013-07-12','11:35:00',4.04),('9303','2013-07-12','11:40:00',2.66),('9303','2013-07-12','11:45:00',3.39),('9303','2013-07-12','11:50:00',2.99),('9303','2013-07-12','11:55:00',4.11),('9303','2013-07-12','12:00:00',4.13),('9303','2013-07-12','12:05:00',2.62),('9303','2013-07-12','12:10:00',2.85),('9303','2013-07-12','12:15:00',3.27),('9303','2013-07-12','12:20:00',3.99),('9303','2013-07-12','12:25:00',3.78),('9303','2013-07-12','12:30:00',4.18),('9303','2013-07-12','12:35:00',3.45),('9303','2013-07-12','12:40:00',2.86),('9303','2013-07-12','12:45:00',3.02),('9303','2013-07-12','12:50:00',2.99),('9303','2013-07-12','12:55:00',4.26),('9303','2013-07-12','13:00:00',4.17),('9303','2013-07-12','13:05:00',4.14),('9303','2013-07-12','13:10:00',4.18),('9303','2013-07-12','13:15:00',4.15),('9303','2013-07-12','13:20:00',4.09),('9303','2013-07-12','13:25:00',4.13),('9303','2013-07-12','13:30:00',4.17),('9303','2013-07-12','13:35:00',4.13),('9303','2013-07-12','13:40:00',4.08),('9303','2013-07-12','13:45:00',4.05),('9303','2013-07-12','13:50:00',4.08),('9303','2013-07-12','13:55:00',4.11),('9303','2013-07-12','14:00:00',3.97),('9303','2013-07-12','14:05:00',3.49),('9303','2013-07-12','14:10:00',2.42),('9303','2013-07-12','14:15:00',4.42),('9303','2013-07-12','14:20:00',3.94),('9303','2013-07-12','14:25:00',3.94),('9303','2013-07-12','14:30:00',3.4),('9303','2013-07-12','14:35:00',3.95),('9303','2013-07-12','14:40:00',3.79),('9303','2013-07-12','14:45:00',3.82),('9303','2013-07-12','14:50:00',3.78),('9303','2013-07-12','14:55:00',3.77),('9303','2013-07-12','15:00:00',3.41),('9303','2013-07-12','15:05:00',3.68),('9303','2013-07-12','15:10:00',3.37),('9303','2013-07-12','15:15:00',3.46),('9303','2013-07-12','15:20:00',3.59),('9303','2013-07-12','15:25:00',3.52),('9303','2013-07-12','15:30:00',3.57),('9303','2013-07-12','15:35:00',3.34),('9303','2013-07-12','15:40:00',3.24),('9303','2013-07-12','15:45:00',3.02),('9303','2013-07-12','15:50:00',3.29),('9303','2013-07-12','15:55:00',3.24),('9303','2013-07-12','16:00:00',3.17),('9303','2013-07-12','16:05:00',3.12),('9303','2013-07-12','16:10:00',3.03),('9303','2013-07-12','16:15:00',3.01),('9303','2013-07-12','16:20:00',2.93),('9303','2013-07-12','16:25:00',2.91),('9303','2013-07-12','16:30:00',2.84),('9303','2013-07-12','16:35:00',2.76),('9303','2013-07-12','16:40:00',2.73),('9303','2013-07-12','16:45:00',2.67),('9303','2013-07-12','16:50:00',2.6),('9303','2013-07-12','16:55:00',2.53),('9303','2013-07-12','17:00:00',2.46),('9303','2013-07-12','17:05:00',2.41),('9303','2013-07-12','17:10:00',2.33),('9303','2013-07-12','17:15:00',2.2),('9303','2013-07-12','17:20:00',2.08),('9303','2013-07-12','17:25:00',1.97),('9303','2013-07-12','17:30:00',1.9),('9303','2013-07-12','17:35:00',1.81),('9303','2013-07-12','17:40:00',1.7),('9303','2013-07-12','17:45:00',1.65),('9303','2013-07-12','17:50:00',1.59),('9303','2013-07-12','17:55:00',1.52),('9303','2013-07-12','18:00:00',1.45),('9303','2013-07-12','18:05:00',1.37),('9303','2013-07-12','18:10:00',1.25),('9303','2013-07-12','18:15:00',1.16),('9303','2013-07-12','18:20:00',1.05),('9303','2013-07-11','07:55:00',1.01),('9303','2013-07-11','08:00:00',1.1),('9303','2013-07-11','08:05:00',1.17),('9303','2013-07-11','08:10:00',1.23),('9303','2013-07-11','08:15:00',1.34),('9303','2013-07-11','08:20:00',1.43),('9303','2013-07-11','08:25:00',1.52),('9303','2013-07-11','08:30:00',1.58),('9303','2013-07-11','08:35:00',1.65),('9303','2013-07-11','08:40:00',1.74),('9303','2013-07-11','08:45:00',1.82),('9303','2013-07-11','08:50:00',1.93),('9303','2013-07-11','08:55:00',1.98),('9303','2013-07-11','09:00:00',2.09),('9303','2013-07-11','09:05:00',2.13),('9303','2013-07-11','09:10:00',2.2),('9303','2013-07-11','09:15:00',2.34),('9303','2013-07-11','09:20:00',2.38),('9303','2013-07-11','09:25:00',2.6),('9303','2013-07-11','09:30:00',2.62),('9303','2013-07-11','09:35:00',2.41),('9303','2013-07-11','09:40:00',1.75),('9303','2013-07-11','09:45:00',2.7),('9303','2013-07-11','09:50:00',2.56),('9303','2013-07-11','09:55:00',1.68),('9303','2013-07-11','10:00:00',1.85),('9303','2013-07-11','10:10:00',1.55),('9303','2013-07-11','10:15:00',3.16),('9303','2013-07-11','10:20:00',3.21),('9303','2013-07-11','10:25:00',3.34),('9303','2013-07-11','10:30:00',2.9),('9303','2013-07-11','10:35:00',1.19),('9303','2013-07-11','10:40:00',1.19),('9303','2013-07-11','10:45:00',3.13),('9303','2013-07-11','10:50:00',3.5),('9303','2013-07-11','10:55:00',3.72),('9303','2013-07-11','11:00:00',3.23),('9303','2013-07-11','11:05:00',2.81),('9303','2013-07-11','11:10:00',3.31),('9303','2013-07-11','11:15:00',3.28),('9303','2013-07-11','11:20:00',3.1),('9303','2013-07-11','11:25:00',1.42),('9303','2013-07-11','11:30:00',2.97),('9303','2013-07-11','11:35:00',3.35),('9303','2013-07-11','11:40:00',4.18),('9303','2013-07-11','11:45:00',3.84),('9303','2013-07-11','11:50:00',1.98),('9303','2013-07-11','11:55:00',2.65),('9303','2013-07-11','12:00:00',2.31),('9303','2013-07-11','12:10:00',1.13),('9303','2013-07-11','12:15:00',3.19),('9303','2013-07-11','12:20:00',4.26),('9303','2013-07-11','12:25:00',4.29),('9303','2013-07-11','12:30:00',3.86),('9303','2013-07-11','12:35:00',4.1),('9303','2013-07-11','12:40:00',3.96),('9303','2013-07-11','12:45:00',2.23),('9303','2013-07-11','12:50:00',3.05),('9303','2013-07-11','12:55:00',3.32),('9303','2013-07-11','13:00:00',4.34),('9303','2013-07-11','13:05:00',4.27),('9303','2013-07-11','13:10:00',4.2),('9303','2013-07-11','13:15:00',4.21),('9303','2013-07-11','13:20:00',4.11),('9303','2013-07-11','13:25:00',4.17),('9303','2013-07-11','13:30:00',4.27),('9303','2013-07-11','13:35:00',3.88),('9303','2013-07-11','13:40:00',3.53),('9303','2013-07-11','13:45:00',3.11),('9303','2013-07-11','13:50:00',2.95),('9303','2013-07-11','13:55:00',2.9),('9303','2013-07-11','14:00:00',3.64),('9303','2013-07-11','14:05:00',4.11),('9303','2013-07-11','14:10:00',3.92),('9303','2013-07-11','14:15:00',4.11),('9303','2013-07-11','14:20:00',3.66),('9303','2013-07-11','14:25:00',3.95),('9303','2013-07-11','14:30:00',4.16),('9303','2013-07-11','14:35:00',3.96),('9303','2013-07-11','14:40:00',3.8),('9303','2013-07-11','14:45:00',3.91),('9303','2013-07-11','14:50:00',3.89),('9303','2013-07-11','14:55:00',3.2),('9303','2013-07-11','15:00:00',3.77),('9303','2013-07-11','15:05:00',2.19),('9303','2013-07-11','15:10:00',2.06),('9303','2013-07-11','15:15:00',3.45),('9303','2013-07-11','15:20:00',3.13),('9303','2013-07-11','15:25:00',3.09),('9303','2013-07-11','15:30:00',2.97),('9303','2013-07-11','15:35:00',3.59),('9303','2013-07-11','15:40:00',2.82),('9303','2013-07-11','15:45:00',3.28),('9303','2013-07-11','15:50:00',2.72),('9303','2013-07-11','15:55:00',2.45),('9303','2013-07-11','16:00:00',3.51),('9303','2013-07-11','16:05:00',1.68),('9303','2013-07-11','16:10:00',2.64),('9303','2013-07-11','16:15:00',1.6),('9303','2013-07-11','16:20:00',1.81),('9303','2013-07-11','16:25:00',2.77),('9303','2013-07-11','16:30:00',2.25),('9303','2013-07-11','16:35:00',1.73),('9303','2013-07-11','16:40:00',2.77),('9303','2013-07-11','16:45:00',2.65),('9303','2013-07-11','16:50:00',2.76),('9303','2013-07-11','16:55:00',2.7),('9303','2013-07-11','17:00:00',2.5),('9303','2013-07-11','17:05:00',2.02),('9303','2013-07-11','17:10:00',1.48),('9303','2013-07-11','17:15:00',1.21),('9303','2013-07-11','17:20:00',1.62),('9303','2013-07-11','17:25:00',1.69),('9303','2013-07-11','17:30:00',1.91),('9303','2013-07-11','17:35:00',1.94),('9303','2013-07-11','17:40:00',1.81),('9303','2013-07-11','17:45:00',1.58),('9303','2013-07-11','17:50:00',1.52),('9303','2013-07-11','17:55:00',1.23),('9303','2013-07-11','18:00:00',1.12),('9303','2013-07-11','18:05:00',1.71),('9303','2013-07-11','18:10:00',1.52),('9303','2013-07-11','18:15:00',1.24),('9303','2013-07-11','18:20:00',1.08),('9303','2013-07-11','18:25:00',1.24),('9303','2013-07-11','18:30:00',1.04),('9303','2014-05-03','07:50:00',1.06),('9303','2014-05-03','07:55:00',1.16),('9303','2014-05-03','08:00:00',1.3),('9303','2014-05-03','08:05:00',1.47),('9303','2014-05-03','08:10:00',1.76),('9303','2014-05-03','08:15:00',1.86),('9303','2014-05-03','08:20:00',1.27),('9303','2014-05-03','08:25:00',1.04),('9303','2014-05-03','08:30:00',1.28),('9303','2014-05-03','08:40:00',1),('9303','2014-05-03','08:45:00',1.46),('9303','2014-05-03','08:50:00',2.02),('9303','2014-05-03','08:55:00',2.63),('9303','2014-05-03','09:00:00',3.12),('9303','2014-05-03','09:05:00',2.92),('9303','2014-05-03','09:10:00',1.52),('9303','2014-05-03','09:15:00',1.82),('9303','2014-05-03','09:20:00',2.42),('9303','2014-05-03','09:25:00',3.26),('9303','2014-05-03','09:30:00',1.76),('9303','2014-05-03','09:35:00',2.38),('9303','2014-05-03','09:40:00',2.06),('9303','2014-05-03','09:45:00',3.13),('9303','2014-05-03','09:50:00',1.28),('9303','2014-05-03','09:55:00',2.61),('9303','2014-05-03','10:00:00',3.47),('9303','2014-05-03','10:05:00',3.49),('9303','2014-05-03','10:10:00',3.57),('9303','2014-05-03','10:15:00',3.86),('9303','2014-05-03','10:20:00',3.14),('9303','2014-05-03','10:25:00',4.35),('9303','2014-05-03','10:30:00',2.71),('9303','2014-05-03','10:35:00',1.01),('9303','2014-05-03','10:45:00',1.22),('9303','2014-05-03','10:50:00',1.04),('9303','2014-05-03','10:55:00',1.47),('9303','2014-05-03','11:00:00',1.12),('9303','2014-05-03','11:05:00',2.2),('9303','2014-05-03','11:10:00',3.69),('9303','2014-05-03','11:15:00',4.2),('9303','2014-05-03','11:20:00',3.02),('9303','2014-05-03','11:25:00',3.9),('9303','2014-05-03','11:30:00',4.57),('9303','2014-05-03','11:35:00',3.13),('9303','2014-05-03','11:40:00',2.73),('9303','2014-05-03','11:45:00',2.64),('9303','2014-05-03','11:50:00',2.25),('9303','2014-05-03','11:55:00',2.52),('9303','2014-05-03','12:00:00',2.02),('9303','2014-05-03','12:05:00',1.61),('9303','2014-05-03','12:10:00',1.46),('9303','2014-05-03','12:15:00',1.33),('9303','2014-05-03','12:20:00',1.19),('9303','2014-05-03','12:25:00',1.23),('9303','2014-05-03','12:30:00',1.59),('9303','2014-05-03','12:35:00',1.95),('9303','2014-05-03','12:40:00',1.78),('9303','2014-05-03','12:45:00',1.85),('9303','2014-05-03','12:50:00',1.82),('9303','2014-05-03','12:55:00',1.82),('9303','2014-05-03','13:00:00',1.91),('9303','2014-05-03','13:05:00',1.9),('9303','2014-05-03','13:10:00',3.19),('9303','2014-05-03','13:15:00',3.04),('9303','2014-05-03','13:20:00',2.19),('9303','2014-05-03','13:25:00',2.87),('9303','2014-05-03','13:30:00',3.09),('9303','2014-05-03','13:35:00',2.47),('9303','2014-05-03','13:40:00',1.84),('9303','2014-05-03','13:45:00',1.75),('9303','2014-05-03','13:50:00',1.74),('9303','2014-05-03','13:55:00',1.75),('9303','2014-05-03','14:00:00',1.7),('9303','2014-05-03','14:05:00',1.7),('9303','2014-05-03','14:10:00',1.84),('9303','2014-05-03','14:15:00',2.06),('9303','2014-05-03','14:20:00',2.39),('9303','2014-05-03','14:25:00',2.86),('9303','2014-05-03','14:30:00',2.24),('9303','2014-05-03','14:35:00',1.59),('9303','2014-05-03','14:40:00',1.32),('9303','2014-04-06','08:15:00',1.01),('9303','2014-04-06','08:20:00',1.12),('9303','2014-04-06','08:25:00',1.25),('9303','2014-04-06','08:30:00',1.33),('9303','2014-04-06','08:35:00',1.44),('9303','2014-04-06','08:40:00',1.57),('9303','2014-04-06','08:45:00',1.63),('9303','2014-04-06','08:50:00',1.45),('9303','2014-04-06','08:55:00',1.31),('9303','2014-04-06','09:05:00',1.65),('9303','2014-04-06','09:10:00',2.22),('9303','2014-04-06','09:15:00',2.3),('9303','2014-04-06','09:20:00',2.01),('9303','2014-04-06','09:25:00',1.85),('9303','2014-04-06','09:30:00',1.63),('9303','2014-04-06','09:35:00',2.36),('9303','2014-04-06','09:40:00',2.42),('9303','2014-04-06','09:45:00',3.23),('9303','2014-04-06','09:50:00',3.48),('9303','2014-04-06','09:55:00',3.49),('9303','2014-04-06','10:00:00',2.53),('9303','2014-04-06','10:05:00',3.13),('9303','2014-04-06','10:10:00',3.11),('9303','2014-04-06','10:15:00',3.64),('9303','2014-04-06','10:20:00',2.65),('9303','2014-04-06','10:25:00',1.19),('9303','2014-04-06','10:30:00',1.28),('9303','2014-04-06','10:35:00',1.41),('9303','2014-04-06','10:40:00',1.54),('9303','2014-04-06','10:45:00',2.53),('9303','2014-04-06','10:50:00',2.26),('9303','2014-04-06','10:55:00',1.61),('9303','2014-04-06','11:00:00',1.57),('9303','2014-04-06','11:05:00',1.74),('9303','2014-04-06','11:10:00',3.39),('9303','2014-04-06','11:15:00',3.75),('9303','2014-04-06','11:20:00',3.99),('9303','2014-04-06','11:25:00',3.98),('9303','2014-04-06','11:30:00',4.18),('9303','2014-04-06','11:35:00',4.48),('9303','2014-04-06','11:40:00',4.39),('9303','2014-04-06','11:45:00',4.28),('9303','2014-04-06','11:50:00',3.75),('9303','2014-04-06','11:55:00',4.35),('9303','2014-04-06','12:00:00',4.27),('9303','2014-04-06','12:05:00',4.09),('9303','2014-04-06','12:10:00',4.13),('9303','2014-04-06','12:15:00',4.28),('9303','2014-04-06','12:20:00',3.77),('9303','2014-04-06','12:25:00',2.79),('9303','2014-04-06','12:30:00',2.79),('9303','2014-04-06','12:35:00',2.98),('9303','2014-04-06','12:40:00',2.1),('9303','2014-04-06','12:45:00',2.04),('9303','2014-04-06','12:50:00',2.53),('9303','2014-04-06','12:55:00',4.48),('9303','2014-04-06','13:00:00',3.98),('9303','2014-04-06','13:05:00',3.54),('9303','2014-04-06','13:10:00',4.11),('9303','2014-04-06','13:15:00',4.19),('9303','2014-04-06','13:20:00',2.37),('9303','2014-04-06','13:25:00',1.36),('9303','2014-04-06','13:30:00',4.61),('9303','2014-04-06','13:35:00',2.16),('9303','2014-04-06','13:40:00',1.99),('9303','2014-04-06','13:45:00',4.61),('9303','2014-04-06','13:50:00',4.17),('9303','2014-04-06','13:55:00',4.31),('9303','2014-04-06','14:00:00',4.2),('9303','2014-04-06','14:05:00',4.04),('9303','2014-04-06','14:10:00',4.27),('9303','2014-04-06','14:15:00',3.4),('9303','2014-04-06','14:20:00',2.61),('9303','2014-04-06','14:25:00',1.62),('9303','2014-04-06','14:30:00',1.03),('9303','2014-04-06','14:35:00',1.24),('9303','2014-04-06','14:40:00',2.96),('9303','2014-04-06','14:45:00',4.81),('9303','2014-04-06','14:50:00',3.98),('9303','2014-04-06','14:55:00',2.27),('9303','2014-04-06','15:00:00',1.58),('9303','2014-04-06','15:05:00',1.26),('9303','2014-04-06','15:10:00',3.35),('9303','2014-04-06','15:15:00',2.34),('9303','2014-04-06','15:20:00',1.73),('9303','2014-04-06','15:50:00',1.62),('9303','2014-04-06','15:55:00',3.55),('9303','2014-04-06','16:00:00',3.05),('9303','2014-04-06','16:05:00',1.5),('9303','2014-04-06','16:10:00',1.95),('9303','2014-04-06','16:35:00',1.43),('9303','2014-04-06','16:40:00',2.49),('9303','2014-04-06','16:45:00',2.96),('9303','2014-04-06','16:50:00',2.67),('9303','2014-04-06','16:55:00',1.76),('9303','2014-04-06','17:25:00',1.76),('9303','2014-04-06','17:30:00',1.7),('9303','2014-04-06','17:35:00',1.09),('9303','2014-04-06','17:45:00',1.03),('9303','2014-04-06','17:50:00',1.32),('9303','2014-04-06','17:55:00',1.18),('9303','2014-04-06','18:00:00',1.05),('9303','2013-07-10','07:30:00',1.03),('9303','2013-07-10','07:35:00',1.15),('9303','2013-07-10','07:40:00',1.3),('9303','2013-07-10','07:45:00',1.41),('9303','2013-07-10','07:50:00',1.53),('9303','2013-07-10','07:55:00',1.64),('9303','2013-07-10','08:00:00',1.76),('9303','2013-07-10','08:05:00',1.36),('9303','2013-07-10','08:10:00',1.42),('9303','2013-07-10','08:15:00',1.5),('9303','2013-07-10','08:20:00',1.57),('9303','2013-07-10','08:25:00',2.07),('9303','2013-07-10','08:30:00',2.04),('9303','2013-07-10','08:35:00',2.22),('9303','2013-07-10','08:40:00',2.29),('9303','2013-07-10','08:45:00',2.1),('9303','2013-07-10','08:50:00',2.14),('9303','2013-07-10','08:55:00',2.11),('9303','2013-07-10','09:00:00',2.18),('9303','2013-07-10','09:05:00',2.27),('9303','2013-07-10','09:10:00',2.35),('9303','2013-07-10','09:15:00',2.51),('9303','2013-07-10','09:20:00',2.48),('9303','2013-07-10','09:25:00',2.51),('9303','2013-07-10','09:30:00',2.51),('9303','2013-07-10','09:35:00',2.63),('9303','2013-07-10','09:40:00',2.66),('9303','2013-07-10','09:45:00',2.71),('9303','2013-07-10','09:50:00',2.77),('9303','2013-07-10','09:55:00',2.62),('9303','2013-07-10','10:00:00',2.66),('9303','2013-07-10','10:05:00',2.96),('9303','2013-07-10','10:10:00',2.99),('9303','2013-07-10','10:15:00',3.01),('9303','2013-07-10','10:20:00',3.06),('9303','2013-07-10','10:25:00',3.12),('9303','2013-07-10','10:30:00',3.2),('9303','2013-07-10','10:35:00',3.21),('9303','2013-07-10','10:40:00',3.26),('9303','2013-07-10','10:45:00',3.3),('9303','2013-07-10','10:50:00',3.33),('9303','2013-07-10','10:55:00',3.4),('9303','2013-07-10','11:00:00',3.51),('9303','2013-07-10','11:05:00',3.53),('9303','2013-07-10','11:10:00',3.54),('9303','2013-07-10','11:15:00',3.56),('9303','2013-07-10','11:20:00',3.58),('9303','2013-07-10','11:25:00',3.59),('9303','2013-07-10','11:30:00',3.63),('9303','2013-07-10','11:35:00',3.6),('9303','2013-07-10','11:40:00',3.59),('9303','2013-07-10','11:45:00',3.64),('9303','2013-07-10','11:50:00',3.71),('9303','2013-07-10','11:55:00',3.74),('9303','2013-07-10','12:00:00',3.79),('9303','2013-07-10','12:05:00',3.81),('9303','2013-07-10','12:10:00',3.78),('9303','2013-07-10','12:15:00',3.84),('9303','2013-07-10','12:20:00',3.91),('9303','2013-07-10','12:25:00',3.94),('9303','2013-07-10','12:30:00',3.94),('9303','2013-07-10','12:35:00',3.9),('9303','2013-07-10','12:40:00',3.86),('9303','2013-07-10','12:45:00',3.98),('9303','2013-07-10','12:50:00',3.99),('9303','2013-07-10','12:55:00',3.99),('9303','2013-07-10','13:00:00',4),('9303','2013-07-10','13:05:00',4.04),('9303','2013-07-10','13:10:00',4.03),('9303','2013-07-10','13:15:00',4.01),('9303','2013-07-10','13:20:00',4.03),('9303','2013-07-10','13:25:00',4.04),('9303','2013-07-10','13:30:00',4.03),('9303','2013-07-10','13:35:00',3.99),('9303','2013-07-10','13:40:00',3.97),('9303','2013-07-10','13:45:00',4.02),('9303','2013-07-10','13:50:00',4.04),('9303','2013-07-10','13:55:00',3.99),('9303','2013-07-10','14:00:00',4),('9303','2013-07-10','14:05:00',3.99),('9303','2013-07-10','14:10:00',3.99),('9303','2013-07-10','14:15:00',3.96),('9303','2013-07-10','14:20:00',3.95),('9303','2013-07-10','14:25:00',3.91),('9303','2013-07-10','14:30:00',3.89),('9303','2013-07-10','14:35:00',3.91),('9303','2013-07-10','14:40:00',3.89),('9303','2013-07-10','14:45:00',3.84),('9303','2013-07-10','14:50:00',3.81),('9303','2013-07-10','14:55:00',3.82),('9303','2013-07-10','15:00:00',3.78),('9303','2013-07-10','15:05:00',3.74),('9303','2013-07-10','15:10:00',3.68),('9303','2013-07-10','15:15:00',3.65),('9303','2013-07-10','15:20:00',3.63),('9303','2013-07-10','15:25:00',3.61),('9303','2013-07-10','15:30:00',3.55),('9303','2013-07-10','15:35:00',3.51),('9303','2013-07-10','15:40:00',2.92),('9303','2013-07-10','15:45:00',3.37),('9303','2013-07-10','15:50:00',3.32),('9303','2013-07-10','15:55:00',3.27),('9303','2013-07-10','16:00:00',3.25),('9303','2013-07-10','16:05:00',3.21),('9303','2013-07-10','16:10:00',3.12),('9303','2013-07-10','16:15:00',3.01),('9303','2013-07-10','16:20:00',2.98),('9303','2013-07-10','16:25:00',2.94),('9303','2013-07-10','16:30:00',2.84),('9303','2013-07-10','16:35:00',2.79),('9303','2013-07-10','16:40:00',2.73),('9303','2013-07-10','16:45:00',2.67),('9303','2013-07-10','16:50:00',2.63),('9303','2013-07-10','16:55:00',2.64),('9303','2013-07-10','17:00:00',2.67),('9303','2013-07-10','17:05:00',2.44),('9303','2013-07-10','17:10:00',2.22),('9303','2013-07-10','17:15:00',1.39),('9303','2013-07-10','17:20:00',1.17),('9303','2013-07-10','17:35:00',2),('9303','2013-07-10','17:40:00',1.83),('9303','2013-07-10','17:45:00',1.22),('9303','2013-07-10','17:50:00',1.62),('9303','2013-07-10','17:55:00',1.48),('9303','2013-07-10','18:00:00',1.5),('9303','2013-07-09','07:50:00',1.01),('9303','2013-07-09','07:55:00',1.07),('9303','2013-07-09','08:00:00',1.15),('9303','2013-07-09','08:05:00',1.23),('9303','2013-07-09','08:10:00',1.3),('9303','2013-07-09','08:15:00',1.4),('9303','2013-07-09','08:20:00',1.48),('9303','2013-07-09','08:25:00',1.55),('9303','2013-07-09','08:30:00',1.63),('9303','2013-07-09','08:35:00',1.72),('9303','2013-07-09','08:40:00',1.79),('9303','2013-07-09','08:45:00',1.86),('9303','2013-07-09','08:50:00',1.93),('9303','2013-07-09','08:55:00',2.01),('9303','2013-07-09','09:00:00',2.09),('9303','2013-07-09','09:05:00',2.17),('9303','2013-07-09','09:10:00',2.21),('9303','2013-07-09','09:15:00',2.3),('9303','2013-07-09','09:20:00',2.38),('9303','2013-07-09','09:25:00',2.44),('9303','2013-07-09','09:30:00',2.52),('9303','2013-07-09','09:35:00',2.57),('9303','2013-07-09','09:40:00',2.63),('9303','2013-07-09','09:45:00',2.7),('9303','2013-07-09','09:50:00',2.75),('9303','2013-07-09','09:55:00',2.81),('9303','2013-07-09','10:00:00',2.84),('9303','2013-07-09','10:05:00',2.89),('9303','2013-07-09','10:10:00',2.98),('9303','2013-07-09','10:15:00',3.04),('9303','2013-07-09','10:20:00',3.1),('9303','2013-07-09','10:25:00',3.12),('9303','2013-07-09','10:30:00',3.16),('9303','2013-07-09','10:35:00',3.2),('9303','2013-07-09','10:40:00',3.23),('9303','2013-07-09','10:45:00',3.25),('9303','2013-07-09','10:50:00',3.33),('9303','2013-07-09','10:55:00',3.39),('9303','2013-07-09','11:00:00',3.43),('9303','2013-07-09','11:05:00',3.42),('9303','2013-07-09','11:10:00',3.29),('9303','2013-07-09','11:15:00',3.01),('9303','2013-07-09','11:20:00',3.13),('9303','2013-07-09','11:25:00',3.17),('9303','2013-07-09','11:30:00',2.06),('9303','2013-07-09','11:35:00',1.92),('9303','2013-07-09','11:40:00',2.46),('9303','2013-07-09','11:45:00',3.18),('9303','2013-07-09','11:50:00',4.22),('9303','2013-07-09','11:55:00',4.16),('9303','2013-07-09','12:00:00',4.15),('9303','2013-07-09','12:05:00',4.08),('9303','2013-07-09','12:10:00',3.3),('9303','2013-07-09','12:15:00',3.91),('9303','2013-07-09','12:20:00',3.89),('9303','2013-07-09','12:25:00',3.84),('9303','2013-07-09','12:30:00',3.79),('9303','2013-07-09','12:35:00',3.8),('9303','2013-07-09','12:40:00',3.84),('9303','2013-07-09','12:45:00',3.82),('9303','2013-07-09','12:50:00',3.88),('9303','2013-07-09','12:55:00',3.92),('9303','2013-07-09','13:00:00',3.97),('9303','2013-07-09','13:05:00',4.04),('9303','2013-07-09','13:10:00',4.01),('9303','2013-07-09','13:15:00',3.99),('9303','2013-07-09','13:20:00',4.02),('9303','2013-07-09','13:25:00',4.03),('9303','2013-07-09','13:30:00',4.18),('9303','2013-07-09','13:35:00',3.94),('9303','2013-07-09','13:40:00',3.92),('9303','2013-07-09','13:45:00',3.24),('9303','2013-07-09','13:50:00',3.01),('9303','2013-07-09','13:55:00',3.12),('9303','2013-07-09','14:00:00',3.02),('9303','2013-07-09','14:05:00',3),('9303','2013-07-09','14:10:00',3.3),('9303','2013-07-09','14:15:00',3.33),('9303','2013-07-09','14:20:00',2.42),('9303','2013-07-09','14:25:00',1.9),('9303','2013-07-09','14:30:00',1.26),('9303','2013-07-08','07:40:00',1.06),('9303','2013-07-08','07:45:00',1.01),('9303','2013-07-08','08:10:00',1.17),('9303','2013-07-08','08:15:00',1.35),('9303','2013-07-08','08:20:00',1.48),('9303','2013-07-08','08:25:00',1.56),('9303','2013-07-08','08:30:00',1.65),('9303','2013-07-08','08:35:00',1.72),('9303','2013-07-08','08:40:00',1.79),('9303','2013-07-08','08:45:00',1.84),('9303','2013-07-08','08:50:00',1.9),('9303','2013-07-08','08:55:00',1.99),('9303','2013-07-08','09:00:00',2.08),('9303','2013-07-08','09:05:00',2.17),('9303','2013-07-08','09:10:00',2.23),('9303','2013-07-08','09:15:00',2.29),('9303','2013-07-08','09:20:00',2.37),('9303','2013-07-08','09:25:00',2.39),('9303','2013-07-08','09:30:00',2.5),('9303','2013-07-08','09:35:00',2.64),('9303','2013-07-08','09:40:00',2.69),('9303','2013-07-08','09:45:00',2.72),('9303','2013-07-08','09:50:00',2.72),('9303','2013-07-08','09:55:00',2.81),('9303','2013-07-08','10:00:00',2.88),('9303','2013-07-08','10:05:00',2.92),('9303','2013-07-08','10:10:00',2.94),('9303','2013-07-08','10:15:00',3.03),('9303','2013-07-08','10:20:00',3.09),('9303','2013-07-08','10:25:00',3.15),('9303','2013-07-08','10:30:00',3.09),('9303','2013-07-08','10:35:00',3.27),('9303','2013-07-08','10:40:00',3.25),('9303','2013-07-08','10:45:00',3.25),('9303','2013-07-08','10:50:00',3.28),('9303','2013-07-08','10:55:00',3.3),('9303','2013-07-08','11:00:00',3.35),('9303','2013-07-08','11:05:00',3.39),('9303','2013-07-08','11:10:00',3.47),('9303','2013-07-08','11:15:00',3.55),('9303','2013-07-08','11:20:00',3.62),('9303','2013-07-08','11:25:00',3.65),('9303','2013-07-08','11:30:00',3.72),('9303','2013-07-08','11:35:00',3.74),('9303','2013-07-08','11:40:00',3.47),('9303','2013-07-08','11:45:00',3.78),('9303','2013-07-08','11:50:00',3.79),('9303','2013-07-08','11:55:00',3.77),('9303','2013-07-08','12:00:00',3.8),('9303','2013-07-08','12:05:00',3.88),('9303','2013-07-08','12:10:00',3.95),('9303','2013-07-08','12:15:00',3.98),('9303','2013-07-08','12:20:00',4.1),('9303','2013-07-08','12:25:00',4.02),('9303','2013-07-08','12:30:00',3.79),('9303','2013-07-08','12:35:00',3.98),('9303','2013-07-08','12:40:00',3.95),('9303','2013-07-08','12:45:00',3.98),('9303','2013-07-08','12:50:00',4),('9303','2013-07-08','12:55:00',4.11),('9303','2013-07-08','13:00:00',3.82),('9303','2013-07-08','13:05:00',3.9),('9303','2013-07-08','13:10:00',4.51),('9303','2013-07-08','13:15:00',3.97),('9303','2013-07-08','13:20:00',2.07),('9303','2013-07-08','13:25:00',1.08),('9303','2013-07-08','14:35:00',1.03),('9303','2013-07-08','14:40:00',1.04),('9303','2013-07-07','07:50:00',1.04),('9303','2013-07-07','07:55:00',1.14),('9303','2013-07-07','08:00:00',1.23),('9303','2013-07-07','08:05:00',1.32),('9303','2013-07-07','08:10:00',1.41),('9303','2013-07-07','08:15:00',1.33),('9303','2013-07-07','08:20:00',1.22),('9303','2013-07-07','08:25:00',1.3),('9303','2013-07-07','08:30:00',1.69),('9303','2013-07-07','08:35:00',1.76),('9303','2013-07-07','08:50:00',1.81),('9303','2013-07-07','08:55:00',2.24),('9303','2013-07-07','09:00:00',2.23),('9303','2013-07-07','09:05:00',2.02),('9303','2013-07-07','09:10:00',2.04),('9303','2013-07-07','09:15:00',2.08),('9303','2013-07-07','09:20:00',1.61),('9303','2013-07-07','09:25:00',2.07),('9303','2013-07-07','09:30:00',2.58),('9303','2013-07-07','09:35:00',2.65),('9303','2013-07-07','09:40:00',2.47),('9303','2013-07-07','09:45:00',2.97),('9303','2013-07-07','09:50:00',2.97),('9303','2013-07-07','09:55:00',3.07),('9303','2013-07-07','10:00:00',3.07),('9303','2013-07-07','10:05:00',2.9),('9303','2013-07-07','10:10:00',3.03),('9303','2013-07-07','10:15:00',2.85),('9303','2013-07-07','10:20:00',3.07),('9303','2013-07-07','10:25:00',3.08),('9303','2013-07-07','10:30:00',2.88),('9303','2013-07-07','10:35:00',3.45),('9303','2013-07-07','10:40:00',3.16),('9303','2013-07-07','10:45:00',3.42),('9303','2013-07-07','10:50:00',3.5),('9303','2013-07-07','10:55:00',3.49),('9303','2013-07-07','11:00:00',3.51),('9303','2013-07-07','11:05:00',3.56),('9303','2013-07-07','11:10:00',3.62),('9303','2013-07-07','11:15:00',3.53),('9303','2013-07-07','11:20:00',3.36),('9303','2013-07-07','11:25:00',3.08),('9303','2013-07-07','11:30:00',3.22),('9303','2013-07-07','11:35:00',3.16),('9303','2013-07-07','11:40:00',3.21),('9303','2013-07-07','11:45:00',2.78),('9303','2013-07-07','11:50:00',2.68),('9303','2013-07-07','11:55:00',1.96),('9303','2013-07-07','12:00:00',2.77),('9303','2013-07-07','12:05:00',3.72),('9303','2013-07-07','12:10:00',3.74),('9303','2013-07-07','12:15:00',3.99),('9303','2013-07-07','12:20:00',3.89),('9303','2013-07-07','12:25:00',3.66),('9303','2013-07-07','12:30:00',3.74),('9303','2013-07-07','12:35:00',3.91),('9303','2013-07-07','12:40:00',4.05),('9303','2013-07-07','12:45:00',4.05),('9303','2013-07-07','12:50:00',3.94),('9303','2013-07-07','12:55:00',4.14),('9303','2013-07-07','13:00:00',4.02),('9303','2013-07-07','13:05:00',4.03),('9303','2013-07-07','13:10:00',4.06),('9303','2013-07-07','13:15:00',4.04),('9303','2013-07-07','13:20:00',4.03),('9303','2013-07-07','13:25:00',3.97),('9303','2013-07-07','13:30:00',3.77),('9303','2013-07-07','13:35:00',4.1),('9303','2013-07-07','13:40:00',2.48),('9303','2013-07-07','13:45:00',4.39),('9303','2013-07-07','13:50:00',4.44),('9303','2013-07-07','13:55:00',3.56),('9303','2013-07-07','14:00:00',3.23),('9303','2013-07-07','14:05:00',3.53),('9303','2013-07-07','14:10:00',2.16),('9303','2013-07-07','14:15:00',1.91),('9303','2013-07-07','14:20:00',1.15),('9303','2013-07-07','15:05:00',1.02),('9303','2013-07-06','07:50:00',1),('9303','2013-07-06','07:55:00',1.1),('9303','2013-07-06','08:00:00',1.18),('9303','2013-07-06','08:05:00',1.27),('9303','2013-07-06','08:10:00',1.35),('9303','2013-07-06','08:15:00',1.45),('9303','2013-07-06','08:20:00',1.52),('9303','2013-07-06','08:25:00',1.61),('9303','2013-07-06','08:30:00',1.69),('9303','2013-07-06','08:35:00',1.77),('9303','2013-07-06','08:40:00',1.84),('9303','2013-07-06','08:45:00',1.9),('9303','2013-07-06','08:50:00',1.98),('9303','2013-07-06','08:55:00',2.05),('9303','2013-07-06','09:00:00',2.13),('9303','2013-07-06','09:05:00',2.23),('9303','2013-07-06','09:10:00',2.32),('9303','2013-07-06','09:15:00',2.38),('9303','2013-07-06','09:20:00',2.46),('9303','2013-07-06','09:25:00',2.51),('9303','2013-07-06','09:30:00',2.57),('9303','2013-07-06','09:35:00',2.61),('9303','2013-07-06','09:40:00',2.68),('9303','2013-07-06','09:45:00',2.74),('9303','2013-07-06','09:50:00',2.81),('9303','2013-07-06','09:55:00',2.91),('9303','2013-07-06','10:00:00',2.97),('9303','2013-07-06','10:05:00',3.03),('9303','2013-07-06','10:10:00',3.09),('9303','2013-07-06','10:15:00',3.12),('9303','2013-07-06','10:20:00',3.16),('9303','2013-07-06','10:25:00',3.21),('9303','2013-07-06','10:30:00',3.26),('9303','2013-07-06','10:35:00',3.28),('9303','2013-07-06','10:40:00',3.36),('9303','2013-07-06','10:45:00',3.41),('9303','2013-07-06','10:50:00',3.46),('9303','2013-07-06','10:55:00',3.51),('9303','2013-07-06','11:00:00',3.55),('9303','2013-07-06','11:05:00',3.57),('9303','2013-07-06','11:10:00',3.59),('9303','2013-07-06','11:15:00',3.57),('9303','2013-07-06','11:20:00',3.62),('9303','2013-07-06','11:25:00',3.67),('9303','2013-07-06','11:30:00',3.71),('9303','2013-07-06','11:35:00',3.75),('9303','2013-07-06','11:40:00',3.74),('9303','2013-07-06','11:45:00',3.78),('9303','2013-07-06','11:50:00',3.8),('9303','2013-07-06','11:55:00',3.82),('9303','2013-07-06','12:00:00',3.87),('9303','2013-07-06','12:05:00',3.92),('9303','2013-07-06','12:10:00',3.98),('9303','2013-07-06','12:15:00',3.96),('9303','2013-07-06','12:20:00',4),('9303','2013-07-06','12:25:00',3.98),('9303','2013-07-06','12:30:00',4.09),('9303','2013-07-06','12:35:00',4.01),('9303','2013-07-06','12:40:00',4.05),('9303','2013-07-06','12:45:00',4.05),('9303','2013-07-06','12:50:00',4.04),('9303','2013-07-06','12:55:00',4.07),('9303','2013-07-06','13:00:00',3.45),('9303','2013-07-06','13:05:00',4.08),('9303','2013-07-06','13:10:00',4.1),('9303','2013-07-06','13:15:00',4.1),('9303','2013-07-06','13:20:00',4.1),('9303','2013-07-06','13:25:00',4.09),('9303','2013-07-06','13:30:00',4.12),('9303','2013-07-06','13:35:00',3.76),('9303','2013-07-06','13:40:00',4.1),('9303','2013-07-06','13:45:00',4.13),('9303','2013-07-06','13:50:00',4.03),('9303','2013-07-06','13:55:00',4.03),('9303','2013-07-06','14:00:00',4.05),('9303','2013-07-06','14:05:00',4.08),('9303','2013-07-06','14:10:00',4),('9303','2013-07-06','14:15:00',4.07),('9303','2013-07-06','14:20:00',4.1),('9303','2013-07-06','14:25:00',3.99),('9303','2013-07-06','14:30:00',3.92),('9303','2013-07-06','14:35:00',3.93),('9303','2013-07-06','14:40:00',3.29),('9303','2013-07-06','14:45:00',3.85),('9303','2013-07-06','14:50:00',3.79),('9303','2013-07-06','14:55:00',3.36),('9303','2013-07-06','15:00:00',3.95),('9303','2013-07-06','15:05:00',3.9),('9303','2013-07-06','15:10:00',3.76),('9303','2013-07-06','15:15:00',3.68),('9303','2013-07-06','15:20:00',3.69),('9303','2013-07-06','15:25:00',3.68),('9303','2013-07-06','15:30:00',3.65),('9303','2013-07-06','15:35:00',1.66),('9303','2013-07-06','16:55:00',1.16),('9303','2013-07-06','17:15:00',1.07),('9303','2013-07-05','07:50:00',1.02),('9303','2013-07-05','07:55:00',1.11),('9303','2013-07-05','08:00:00',1.21),('9303','2013-07-05','08:05:00',1.3),('9303','2013-07-05','08:10:00',1.38),('9303','2013-07-05','08:15:00',1.47),('9303','2013-07-05','08:20:00',1.53),('9303','2013-07-05','08:25:00',1.61),('9303','2013-07-05','08:30:00',1.7),('9303','2013-07-05','08:35:00',1.78),('9303','2013-07-05','08:40:00',1.84),('9303','2013-07-05','08:45:00',1.9),('9303','2013-07-05','08:50:00',1.97),('9303','2013-07-05','08:55:00',2.05),('9303','2013-07-05','09:00:00',2.12),('9303','2013-07-05','09:05:00',2.21),('9303','2013-07-05','09:10:00',2.28),('9303','2013-07-05','09:15:00',2.35),('9303','2013-07-05','09:20:00',2.44),('9303','2013-07-05','09:25:00',2.52),('9303','2013-07-05','09:30:00',2.58),('9303','2013-07-05','09:35:00',2.65),('9303','2013-07-05','09:40:00',2.71),('9303','2013-07-05','09:45:00',2.76),('9303','2013-07-05','09:50:00',2.8),('9303','2013-07-05','09:55:00',2.87),('9303','2013-07-05','10:00:00',2.92),('9303','2013-07-05','10:05:00',2.96),('9303','2013-07-05','10:10:00',3.03),('9303','2013-07-05','10:15:00',3.08),('9303','2013-07-05','10:20:00',3.13),('9303','2013-07-05','10:25:00',3.17),('9303','2013-07-05','10:30:00',3.24),('9303','2013-07-05','10:35:00',3.26),('9303','2013-07-05','10:40:00',3.3),('9303','2013-07-05','10:45:00',3.34),('9303','2013-07-05','10:50:00',3.37),('9303','2013-07-05','10:55:00',3.42),('9303','2013-07-05','11:00:00',3.45),('9303','2013-07-05','11:05:00',3.5),('9303','2013-07-05','11:10:00',3.54),('9303','2013-07-05','11:15:00',3.56),('9303','2013-07-05','11:20:00',3.6),('9303','2013-07-05','11:25:00',3.64),('9303','2013-07-05','11:30:00',3.68),('9303','2013-07-05','11:35:00',3.7),('9303','2013-07-05','11:40:00',3.72),('9303','2013-07-05','11:45:00',3.7),('9303','2013-07-05','11:50:00',3.8),('9303','2013-07-05','11:55:00',3.77),('9303','2013-07-05','12:00:00',3.78),('9303','2013-07-05','12:05:00',3.85),('9303','2013-07-05','12:10:00',3.85),('9303','2013-07-05','12:15:00',3.89),('9303','2013-07-05','12:20:00',3.9),('9303','2013-07-05','12:25:00',2.7),('9303','2013-07-05','12:30:00',3.72),('9303','2013-07-05','12:35:00',2.94),('9303','2013-07-05','12:40:00',3.96),('9303','2013-07-05','12:45:00',4.04),('9303','2013-07-05','12:50:00',4.03),('9303','2013-07-05','12:55:00',3.92),('9303','2013-07-05','13:00:00',3.73),('9303','2013-07-05','13:05:00',2.92),('9303','2013-07-05','13:10:00',4.23),('9303','2013-07-05','13:15:00',3.93),('9303','2013-07-05','13:20:00',3.3),('9303','2013-07-05','13:25:00',4.07),('9303','2013-07-05','13:30:00',3.74),('9303','2013-07-05','13:35:00',4.05),('9303','2013-07-05','13:40:00',4.18),('9303','2013-07-05','13:45:00',4.12),('9303','2013-07-05','13:50:00',4.07),('9303','2013-07-05','13:55:00',4.09),('9303','2013-07-05','14:00:00',4.09),('9303','2013-07-05','14:05:00',3.35),('9303','2013-07-05','14:10:00',3.28),('9303','2013-07-05','14:15:00',4.03),('9303','2013-07-05','14:20:00',3.92),('9303','2013-07-05','14:25:00',3.93),('9303','2013-07-05','14:30:00',3.87),('9303','2013-07-05','14:35:00',3.85),('9303','2013-07-05','14:40:00',3.88),('9303','2013-07-05','14:45:00',3.04),('9303','2013-07-05','14:50:00',3.82),('9303','2013-07-05','14:55:00',3.79),('9303','2013-07-05','15:00:00',3.77),('9303','2013-07-05','15:05:00',3.15),('9303','2013-07-05','15:10:00',3.8),('9303','2013-07-05','15:15:00',3.71),('9303','2013-07-05','15:20:00',2.34),('9303','2013-07-05','15:25:00',3.37),('9303','2013-07-05','15:30:00',3.42),('9303','2013-07-05','15:35:00',3.6),('9303','2013-07-05','15:40:00',3.51),('9303','2013-07-05','15:45:00',3.5),('9303','2013-07-05','15:50:00',3.43),('9303','2013-07-05','15:55:00',3.3),('9303','2013-07-05','16:00:00',3.22),('9303','2013-07-05','16:05:00',3.2),('9303','2013-07-05','16:10:00',3.11),('9303','2013-07-05','16:15:00',3.07),('9303','2013-07-05','16:20:00',3.07),('9303','2013-07-05','16:25:00',3),('9303','2013-07-05','16:30:00',2.93),('9303','2013-07-05','16:35:00',2.84),('9303','2013-07-05','16:40:00',2.79),('9303','2013-07-05','16:45:00',2.76),('9303','2013-07-05','16:50:00',2.63),('9303','2013-07-05','16:55:00',2.52),('9303','2013-07-05','17:00:00',2.48),('9303','2013-07-05','17:05:00',2.42),('9303','2013-07-05','17:10:00',2.4),('9303','2013-07-05','17:15:00',2.34),('9303','2013-07-05','17:20:00',2.23),('9303','2013-07-05','17:25:00',2.1),('9303','2013-07-05','17:30:00',1.98),('9303','2013-07-05','17:35:00',1.8),('9303','2013-07-05','17:40:00',1.73),('9303','2013-07-05','17:45:00',1.65),('9303','2013-07-05','17:50:00',1.59),('9303','2013-07-05','17:55:00',1.53),('9303','2013-07-05','18:00:00',1.5),('9303','2013-07-05','18:05:00',1.39),('9303','2013-07-04','11:15:00',1.02),('9303','2013-07-04','11:30:00',1.06),('9303','2013-07-04','11:35:00',1.21),('9303','2013-07-04','11:40:00',1.37),('9303','2013-07-04','11:45:00',1.54),('9303','2013-07-04','11:50:00',1.62),('9303','2013-07-04','11:55:00',1.48),('9303','2013-07-04','12:00:00',1.46),('9303','2013-07-04','12:05:00',1.53),('9303','2013-07-04','12:10:00',2.09),('9303','2013-07-04','12:15:00',2.88),('9303','2013-07-04','12:20:00',2.34),('9303','2013-07-04','12:25:00',2.78),('9303','2013-07-04','12:30:00',2.61),('9303','2013-07-04','12:35:00',2.2),('9303','2013-07-04','12:40:00',1.54),('9303','2013-07-04','12:45:00',1.23),('9303','2013-07-04','13:05:00',1),('9303','2013-07-04','13:10:00',1.31),('9303','2013-07-04','13:15:00',1.53),('9303','2013-07-04','13:20:00',1.71),('9303','2013-07-04','13:25:00',2.03),('9303','2013-07-04','13:30:00',1.84),('9303','2013-07-04','13:35:00',1.97),('9303','2013-07-04','13:40:00',2.52),('9303','2013-07-04','13:45:00',2.1),('9303','2013-07-04','13:50:00',2.79),('9303','2013-07-04','13:55:00',2.52),('9303','2013-07-04','14:00:00',2.15),('9303','2013-07-04','14:05:00',2.08),('9303','2013-07-04','14:10:00',2.03),('9303','2013-07-04','14:15:00',2.04),('9303','2013-07-04','14:20:00',2.21),('9303','2013-07-04','14:25:00',1.78),('9303','2013-07-04','14:30:00',1.7),('9303','2013-07-04','14:35:00',1.74),('9303','2013-07-04','14:40:00',2.88),('9303','2013-07-04','14:45:00',3.23),('9303','2013-07-04','14:50:00',2.41),('9303','2013-07-04','14:55:00',2.09),('9303','2013-07-04','15:00:00',3.14),('9303','2013-07-04','15:05:00',4.02),('9303','2013-07-04','15:10:00',2.82),('9303','2013-07-04','15:15:00',4.29),('9303','2013-07-04','15:20:00',4.04),('9303','2013-07-04','15:25:00',3.89),('9303','2013-07-04','15:30:00',2.4),('9303','2013-07-04','15:35:00',2.97),('9303','2013-07-04','15:40:00',2.62),('9303','2013-07-04','15:45:00',2.93),('9303','2013-07-04','15:50:00',2.09),('9303','2013-07-04','15:55:00',2.14),('9303','2013-07-04','16:00:00',2.43),('9303','2013-07-04','16:05:00',2.2),('9303','2013-07-04','16:10:00',1.92),('9303','2013-07-04','16:15:00',1.6),('9303','2013-07-04','16:20:00',1.71),('9303','2013-07-04','16:25:00',1.79),('9303','2013-07-04','16:30:00',1.79),('9303','2013-07-04','16:35:00',1.75),('9303','2013-07-04','16:40:00',1.45),('9303','2013-07-04','16:45:00',1.35),('9303','2013-07-04','16:50:00',1.43),('9303','2013-07-04','16:55:00',1.36),('9303','2013-07-04','17:00:00',1.19),('9303','2013-07-04','17:05:00',1.13),('9303','2013-07-04','17:10:00',1.69),('9303','2013-07-04','17:15:00',2.39),('9303','2013-07-04','17:20:00',2.21),('9303','2013-07-04','17:25:00',2.39),('9303','2013-07-04','17:30:00',1.85),('9303','2013-07-04','17:35:00',1.3),('9303','2013-07-04','17:40:00',2.06),('9303','2013-07-04','17:45:00',1.94),('9303','2013-07-04','17:50:00',1.86),('9303','2013-07-04','17:55:00',1.8),('9303','2013-07-04','18:00:00',1.75),('9303','2013-07-04','18:05:00',1.7),('9303','2013-07-04','18:10:00',1.57),('9303','2013-07-04','18:15:00',1.43),('9303','2013-07-04','18:20:00',1.37),('9303','2013-07-04','18:25:00',1.19),('9303','2013-07-03','07:45:00',1),('9303','2013-07-03','07:50:00',1.08),('9303','2013-07-03','07:55:00',1.18),('9303','2013-07-03','08:00:00',1.27),('9303','2013-07-03','08:05:00',1.35),('9303','2013-07-03','08:10:00',1.44),('9303','2013-07-03','08:15:00',1.53),('9303','2013-07-03','08:20:00',1.6),('9303','2013-07-03','08:25:00',1.68),('9303','2013-07-03','08:30:00',1.76),('9303','2013-07-03','08:35:00',1.85),('9303','2013-07-03','08:40:00',1.94),('9303','2013-07-03','08:45:00',2.01),('9303','2013-07-03','08:50:00',2.07),('9303','2013-07-03','08:55:00',2.16),('9303','2013-07-03','09:00:00',2.24),('9303','2013-07-03','09:05:00',2.32),('9303','2013-07-03','09:10:00',2.36),('9303','2013-07-03','09:15:00',2.43),('9303','2013-07-03','09:20:00',2.5),('9303','2013-07-03','09:25:00',2.56),('9303','2013-07-03','09:30:00',2.6),('9303','2013-07-03','09:35:00',2.66),('9303','2013-07-03','09:40:00',2.77),('9303','2013-07-03','09:45:00',2.8),('9303','2013-07-03','09:50:00',2.83),('9303','2013-07-03','09:55:00',2.9),('9303','2013-07-03','10:00:00',2.96),('9303','2013-07-03','10:05:00',2.99),('9303','2013-07-03','10:10:00',3.07),('9303','2013-07-03','10:15:00',3.08),('9303','2013-07-03','10:20:00',3.13),('9303','2013-07-03','10:25:00',3.18),('9303','2013-07-03','10:30:00',3.24),('9303','2013-07-03','10:35:00',3.26),('9303','2013-07-03','10:40:00',3.35),('9303','2013-07-03','10:45:00',3.37),('9303','2013-07-03','10:50:00',3.41),('9303','2013-07-03','10:55:00',3.45),('9303','2013-07-03','11:00:00',3.47),('9303','2013-07-03','11:05:00',3.53),('9303','2013-07-03','11:10:00',3.51),('9303','2013-07-03','11:15:00',3.62),('9303','2013-07-03','11:20:00',3.7),('9303','2013-07-03','11:25:00',3.71),('9303','2013-07-03','11:30:00',3.7),('9303','2013-07-03','11:35:00',3.7),('9303','2013-07-03','11:40:00',3.75),('9303','2013-07-03','11:45:00',3.88),('9303','2013-07-03','11:50:00',3.88),('9303','2013-07-03','11:55:00',3.94),('9303','2013-07-03','12:00:00',3.98),('9303','2013-07-03','12:05:00',3.98),('9303','2013-07-03','12:10:00',3.98),('9303','2013-07-03','12:15:00',4.02),('9303','2013-07-03','12:20:00',4.02),('9303','2013-07-03','12:25:00',4.01),('9303','2013-07-03','12:30:00',4.05),('9303','2013-07-03','12:35:00',4.09),('9303','2013-07-03','12:40:00',4.08),('9303','2013-07-03','12:45:00',4.06),('9303','2013-07-03','12:50:00',4.11),('9303','2013-07-03','12:55:00',4.1),('9303','2013-07-03','13:00:00',4.13),('9303','2013-07-03','13:05:00',4.12),('9303','2013-07-03','13:10:00',4.14),('9303','2013-07-03','13:15:00',4.17),('9303','2013-07-03','13:20:00',4.13),('9303','2013-07-03','13:25:00',4.09),('9303','2013-07-03','13:30:00',4.08),('9303','2013-07-03','13:35:00',4.06),('9303','2013-07-03','13:40:00',4.05),('9303','2013-07-03','13:45:00',4.07),('9303','2013-07-03','13:50:00',4.08),('9303','2013-07-03','13:55:00',4.05),('9303','2013-07-03','14:00:00',4.05),('9303','2013-07-03','14:05:00',4.04),('9303','2013-07-03','14:10:00',4.04),('9303','2013-07-03','14:15:00',4.02),('9303','2013-07-03','14:20:00',4.03),('9303','2013-07-03','14:25:00',4.01),('9303','2013-07-03','14:30:00',4),('9303','2013-07-03','14:35:00',3.92),('9303','2013-07-03','14:40:00',3.92),('9303','2013-07-03','14:45:00',3.94),('9303','2013-07-03','14:50:00',3.9),('9303','2013-07-03','14:55:00',3.87),('9303','2013-07-03','15:00:00',3.84),('9303','2013-07-03','15:05:00',3.82),('9303','2013-07-03','15:10:00',3.77),('9303','2013-07-03','15:15:00',3.73),('9303','2013-07-03','15:20:00',3.67),('9303','2013-07-03','15:25:00',3.67),('9303','2013-07-03','15:30:00',3.64),('9303','2013-07-03','15:35:00',3.61),('9303','2013-07-03','15:40:00',3.56),('9303','2013-07-03','15:45:00',3.52),('9303','2013-07-03','15:50:00',3.45),('9303','2013-07-03','15:55:00',3.43),('9303','2013-07-03','16:00:00',3.34),('9303','2013-07-03','16:05:00',3.28),('9303','2013-07-03','16:10:00',3.24),('9303','2013-07-03','16:15:00',3.18),('9303','2013-07-03','16:20:00',3.13),('9303','2013-07-03','16:25:00',3.06),('9303','2013-07-03','16:30:00',3.01),('9303','2013-07-03','16:35:00',2.96),('9303','2013-07-03','16:40:00',2.89),('9303','2013-07-03','16:45:00',2.83),('9303','2013-07-03','16:50:00',2.75),('9303','2013-07-03','16:55:00',2.69),('9303','2013-07-03','17:00:00',2.61),('9303','2013-07-03','17:05:00',2.55),('9303','2013-07-03','17:10:00',2.48),('9303','2013-07-03','17:15:00',2.39),('9303','2013-07-03','17:20:00',2.28),('9303','2013-07-03','17:25:00',2.17),('9303','2013-07-03','17:30:00',2.05),('9303','2013-07-03','17:35:00',1.88),('9303','2013-07-03','17:40:00',1.88),('9303','2013-07-03','17:45:00',1.82),('9303','2013-07-03','17:50:00',1.74),('9303','2013-07-03','17:55:00',1.67),('9303','2013-07-03','18:00:00',1.6),('9303','2013-07-03','18:05:00',1.47),('9303','2013-07-03','18:10:00',1.37),('9303','2013-07-03','18:15:00',1.28),('9303','2013-07-03','18:20:00',1.17),('9303','2013-07-03','18:25:00',1.07),('9303','2013-07-02','07:50:00',1.06),('9303','2013-07-02','07:55:00',1.15),('9303','2013-07-02','08:00:00',1.23),('9303','2013-07-02','08:05:00',1.32),('9303','2013-07-02','08:10:00',1.42),('9303','2013-07-02','08:15:00',1.52),('9303','2013-07-02','08:20:00',1.6),('9303','2013-07-02','08:25:00',1.68),('9303','2013-07-02','08:30:00',1.76),('9303','2013-07-02','08:35:00',1.82),('9303','2013-07-02','08:40:00',1.89),('9303','2013-07-02','08:45:00',1.97),('9303','2013-07-02','08:50:00',2.05),('9303','2013-07-02','08:55:00',2.09),('9303','2013-07-02','09:00:00',2.17),('9303','2013-07-02','09:05:00',2.3),('9303','2013-07-02','09:10:00',2.37),('9303','2013-07-02','09:15:00',2.42),('9303','2013-07-02','09:20:00',2.49),('9303','2013-07-02','09:25:00',2.55),('9303','2013-07-02','09:30:00',2.62),('9303','2013-07-02','09:35:00',2.67),('9303','2013-07-02','09:40:00',2.75),('9303','2013-07-02','09:45:00',2.8),('9303','2013-07-02','09:50:00',2.84),('9303','2013-07-02','09:55:00',2.89),('9303','2013-07-02','10:00:00',2.95),('9303','2013-07-02','10:05:00',2.99),('9303','2013-07-02','10:10:00',3.04),('9303','2013-07-02','10:15:00',3.08),('9303','2013-07-02','10:20:00',3.14),('9303','2013-07-02','10:25:00',3.15),('9303','2013-07-02','10:30:00',3.2),('9303','2013-07-02','10:35:00',3.24),('9303','2013-07-02','10:40:00',3.28),('9303','2013-07-02','10:45:00',3.33),('9303','2013-07-02','10:50:00',3.39),('9303','2013-07-02','10:55:00',3.4),('9303','2013-07-02','11:00:00',3.4),('9303','2013-07-02','11:05:00',3.42),('9303','2013-07-02','11:10:00',3.5),('9303','2013-07-02','11:15:00',3.53),('9303','2013-07-02','11:20:00',3.53),('9303','2013-07-02','11:25:00',3.58),('9303','2013-07-02','11:30:00',3.6),('9303','2013-07-02','11:35:00',3.65),('9303','2013-07-02','11:40:00',3.64),('9303','2013-07-02','11:45:00',3.63),('9303','2013-07-02','11:50:00',3.65),('9303','2013-07-02','11:55:00',3.75),('9303','2013-07-02','12:00:00',3.68),('9303','2013-07-02','12:05:00',3.69),('9303','2013-07-02','12:10:00',3.84),('9303','2013-07-02','12:15:00',3.77),('9303','2013-07-02','12:20:00',3.81),('9303','2013-07-02','12:25:00',3.9),('9303','2013-07-02','12:30:00',3.94),('9303','2013-07-02','12:35:00',3.96),('9303','2013-07-02','12:40:00',3.93),('9303','2013-07-02','12:45:00',3.99),('9303','2013-07-02','12:50:00',3.92),('9303','2013-07-02','12:55:00',1.14),('9303','2013-07-02','13:00:00',3.09),('9303','2013-07-02','13:05:00',2.03),('9303','2013-07-02','13:10:00',3.24),('9303','2013-07-02','13:15:00',4.28),('9303','2013-07-02','13:20:00',4.16),('9303','2013-07-02','13:25:00',4.18),('9303','2013-07-02','13:30:00',4.18),('9303','2013-07-02','13:35:00',4.12),('9303','2013-07-02','13:40:00',4.09),('9303','2013-07-02','13:45:00',3.93),('9303','2013-07-02','13:50:00',3.91),('9303','2013-07-02','13:55:00',3.94),('9303','2013-07-02','14:00:00',3.91),('9303','2013-07-02','14:05:00',3.89),('9303','2013-07-02','14:10:00',3.87),('9303','2013-07-02','14:15:00',3.88),('9303','2013-07-02','14:20:00',3.92),('9303','2013-07-02','14:25:00',3.91),('9303','2013-07-02','14:30:00',3.87),('9303','2013-07-02','14:35:00',3.86),('9303','2013-07-02','14:40:00',3.81),('9303','2013-07-02','14:45:00',3.79),('9303','2013-07-02','14:50:00',3.74),('9303','2013-07-02','14:55:00',3.76),('9303','2013-07-02','15:00:00',3.75),('9303','2013-07-02','15:05:00',3.75),('9303','2013-07-02','15:10:00',3.69),('9303','2013-07-02','15:15:00',3.62),('9303','2013-07-02','15:20:00',3.62),('9303','2013-07-02','15:25:00',3.57),('9303','2013-07-02','15:30:00',3.54),('9303','2013-07-02','15:35:00',3.51),('9303','2013-07-02','15:40:00',3.46),('9303','2013-07-02','15:45:00',3.4),('9303','2013-07-02','15:50:00',3.34),('9303','2013-07-02','15:55:00',3.29),('9303','2013-07-02','16:00:00',3.26),('9303','2013-07-02','16:05:00',3.21),('9303','2013-07-02','16:10:00',3.14),('9303','2013-07-02','16:15:00',3.08),('9303','2013-07-02','16:20:00',3.03),('9303','2013-07-02','16:25:00',2.96),('9303','2013-07-02','16:30:00',2.88),('9303','2013-07-02','16:35:00',2.83),('9303','2013-07-02','16:40:00',2.78),('9303','2013-07-02','16:45:00',2.71),('9303','2013-07-02','16:50:00',2.66),('9303','2013-07-02','16:55:00',2.59),('9303','2013-07-02','17:00:00',2.55),('9303','2013-07-02','17:05:00',2.48),('9303','2013-07-02','17:10:00',2.39),('9303','2013-07-02','17:15:00',2.29),('9303','2013-07-02','17:20:00',2.18),('9303','2013-07-02','17:25:00',2.07),('9303','2013-07-02','17:30:00',1.95),('9303','2013-07-02','17:35:00',1.83),('9303','2013-07-02','17:40:00',1.81),('9303','2013-07-02','17:45:00',1.71),('9303','2013-07-02','17:50:00',1.64),('9303','2013-07-02','17:55:00',1.58),('9303','2013-07-02','18:00:00',1.5),('9303','2013-07-02','18:05:00',1.41),('9303','2013-07-02','18:10:00',1.31),('9303','2013-07-02','18:15:00',1.2),('9303','2013-07-02','18:20:00',1.1),('9303','2013-07-02','18:25:00',1.01),('9303','2013-07-01','07:50:00',1.07),('9303','2013-07-01','07:55:00',1.16),('9303','2013-07-01','08:00:00',1.25),('9303','2013-07-01','08:05:00',1.34),('9303','2013-07-01','08:10:00',1.43),('9303','2013-07-01','08:15:00',1.52),('9303','2013-07-01','08:20:00',1.61),('9303','2013-07-01','08:25:00',1.7),('9303','2013-07-01','08:30:00',1.77),('9303','2013-07-01','08:35:00',1.85),('9303','2013-07-01','08:40:00',1.93),('9303','2013-07-01','08:45:00',2),('9303','2013-07-01','08:50:00',2.07),('9303','2013-07-01','08:55:00',2.15),('9303','2013-07-01','09:00:00',2.22),('9303','2013-07-01','09:05:00',2.34),('9303','2013-07-01','09:10:00',2.43),('9303','2013-07-01','09:15:00',2.5),('9303','2013-07-01','09:20:00',2.59),('9303','2013-07-01','09:25:00',2.65),('9303','2013-07-01','09:30:00',2.71),('9303','2013-07-01','09:35:00',2.78),('9303','2013-07-01','09:40:00',2.82),('9303','2013-07-01','09:45:00',2.86),('9303','2013-07-01','09:50:00',2.91),('9303','2013-07-01','09:55:00',2.97),('9303','2013-07-01','10:00:00',3.03),('9303','2013-07-01','10:05:00',3.09),('9303','2013-07-01','10:10:00',3.13),('9303','2013-07-01','10:15:00',3.21),('9303','2013-07-01','10:20:00',3.26),('9303','2013-07-01','10:25:00',3.31),('9303','2013-07-01','10:30:00',3.36),('9303','2013-07-01','10:35:00',3.39),('9303','2013-07-01','10:40:00',3.44),('9303','2013-07-01','10:45:00',3.5),('9303','2013-07-01','10:50:00',3.57),('9303','2013-07-01','10:55:00',3.62),('9303','2013-07-01','11:00:00',3.65),('9303','2013-07-01','11:05:00',3.67),('9303','2013-07-01','11:10:00',3.71),('9303','2013-07-01','11:15:00',3.74),('9303','2013-07-01','11:20:00',3.74),('9303','2013-07-01','11:25:00',3.77),('9303','2013-07-01','11:30:00',3.79),('9303','2013-07-01','11:35:00',3.83),('9303','2013-07-01','11:40:00',3.83),('9303','2013-07-01','11:45:00',3.84),('9303','2013-07-01','11:50:00',3.85),('9303','2013-07-01','11:55:00',3.86),('9303','2013-07-01','12:00:00',3.88),('9303','2013-07-01','12:05:00',3.86),('9303','2013-07-01','12:10:00',3.88),('9303','2013-07-01','12:15:00',3.94),('9303','2013-07-01','12:20:00',4),('9303','2013-07-01','12:25:00',4.02),('9303','2013-07-01','12:30:00',4.02),('9303','2013-07-01','12:35:00',4.02),('9303','2013-07-01','12:40:00',3.99),('9303','2013-07-01','12:45:00',3.98),('9303','2013-07-01','12:50:00',4.01),('9303','2013-07-01','12:55:00',4.1),('9303','2013-07-01','13:00:00',4.13),('9303','2013-07-01','13:05:00',4.11),('9303','2013-07-01','13:10:00',4.14),('9303','2013-07-01','13:15:00',4.14),('9303','2013-07-01','13:20:00',4.13),('9303','2013-07-01','13:25:00',4.15),('9303','2013-07-01','13:30:00',4.13),('9303','2013-07-01','13:35:00',4.11),('9303','2013-07-01','13:40:00',4.04),('9303','2013-07-01','13:45:00',4.04),('9303','2013-07-01','13:50:00',4.05),('9303','2013-07-01','13:55:00',4.01),('9303','2013-07-01','14:00:00',3.97),('9303','2013-07-01','14:05:00',4.04),('9303','2013-07-01','14:10:00',4.02),('9303','2013-07-01','14:15:00',4.02),('9303','2013-07-01','14:20:00',3.99),('9303','2013-07-01','14:25:00',3.92),('9303','2013-07-01','14:30:00',3.88),('9303','2013-07-01','14:35:00',3.88),('9303','2013-07-01','14:40:00',3.86),('9303','2013-07-01','14:45:00',3.83),('9303','2013-07-01','14:50:00',3.78),('9303','2013-07-01','14:55:00',3.75),('9303','2013-07-01','15:00:00',3.71),('9303','2013-07-01','15:05:00',3.66),('9303','2013-07-01','15:10:00',3.64),('9303','2013-07-01','15:15:00',3.59),('9303','2013-07-01','15:20:00',3.59),('9303','2013-07-01','15:25:00',3.54),('9303','2013-07-01','15:30:00',3.49),('9303','2013-07-01','15:35:00',3.46),('9303','2013-07-01','15:40:00',3.41),('9303','2013-07-01','15:45:00',3.39),('9303','2013-07-01','15:50:00',3.34),('9303','2013-07-01','15:55:00',3.26),('9303','2013-07-01','16:00:00',3.23),('9303','2013-07-01','16:05:00',3.16),('9303','2013-07-01','16:10:00',3.14),('9303','2013-07-01','16:15:00',3.07),('9303','2013-07-01','16:20:00',2.98),('9303','2013-07-01','16:25:00',2.94),('9303','2013-07-01','16:30:00',2.86),('9303','2013-07-01','16:35:00',2.78),('9303','2013-07-01','16:40:00',2.73),('9303','2013-07-01','16:45:00',2.68),('9303','2013-07-01','16:50:00',2.64),('9303','2013-07-01','16:55:00',2.57),('9303','2013-07-01','17:00:00',2.52),('9303','2013-07-01','17:05:00',2.45),('9303','2013-07-01','17:10:00',2.38),('9303','2013-07-01','17:15:00',2.28),('9303','2013-07-01','17:20:00',2.16),('9303','2013-07-01','17:25:00',2.05),('9303','2013-07-01','17:30:00',1.91),('9303','2013-07-01','17:35:00',1.76),('9303','2013-07-01','17:40:00',1.78),('9303','2013-07-01','17:45:00',1.72),('9303','2013-07-01','17:50:00',1.65),('9303','2013-07-01','17:55:00',1.58),('9303','2013-07-01','18:00:00',1.39),('9303','2013-07-01','18:05:00',1.37),('9303','2013-07-01','18:10:00',1.29),('9303','2013-07-01','18:15:00',1.05),('9303','2013-07-01','18:20:00',1.07),('9303','2013-07-01','18:25:00',1.09),('9303','2013-07-01','18:30:00',1.03),('9303','2014-04-05','09:15:00',1.08),('9303','2014-04-05','09:20:00',1.47),('9303','2014-04-05','09:25:00',2.49),('9303','2014-04-05','09:30:00',3.44),('9303','2014-04-05','09:35:00',3.34),('9303','2014-04-05','09:40:00',3.2),('9303','2014-04-05','09:45:00',2.31),('9303','2014-04-05','09:50:00',1.47),('9303','2014-04-05','09:55:00',2.32),('9303','2014-04-05','10:00:00',2.05),('9303','2014-04-05','10:05:00',1.98),('9303','2014-04-05','10:10:00',2.04),('9303','2014-04-05','10:15:00',1.51),('9303','2014-04-05','10:20:00',2.47),('9303','2014-04-05','10:25:00',2.57),('9303','2014-04-05','10:30:00',2.49),('9303','2014-04-05','10:35:00',2.8),('9303','2014-04-05','10:40:00',2.97),('9303','2014-04-05','10:45:00',2.92),('9303','2014-04-05','10:50:00',2.59),('9303','2014-04-05','10:55:00',2.84),('9303','2014-04-05','11:00:00',3.28),('9303','2014-04-05','11:05:00',3.56),('9303','2014-04-05','11:10:00',3.83),('9303','2014-04-05','11:15:00',4.04),('9303','2014-04-05','11:20:00',4.05),('9303','2014-04-05','11:25:00',2.88),('9303','2014-04-05','11:30:00',2.2),('9303','2014-04-05','11:35:00',2.47),('9303','2014-04-05','11:40:00',3.43),('9303','2014-04-05','11:45:00',3.89),('9303','2014-04-05','11:50:00',4.18),('9303','2014-04-05','11:55:00',3.94),('9303','2014-04-05','12:00:00',3.33),('9303','2014-04-05','12:05:00',2.95),('9303','2014-04-05','12:10:00',3.06),('9303','2014-04-05','12:15:00',2.98),('9303','2014-04-05','12:20:00',3.47),('9303','2014-04-05','12:25:00',3),('9303','2014-04-05','12:30:00',2.43),('9303','2014-04-05','12:35:00',2.15),('9303','2014-04-05','12:40:00',3.64),('9303','2014-04-05','12:45:00',4.54),('9303','2014-04-05','12:50:00',4.63),('9303','2014-04-05','12:55:00',3.86),('9303','2014-04-05','13:00:00',3.34),('9303','2014-04-05','13:05:00',2.95),('9303','2014-04-05','13:10:00',3.71),('9303','2014-04-05','13:15:00',2.52),('9303','2014-04-05','13:20:00',4.39),('9303','2014-04-05','13:25:00',3.34),('9303','2014-04-05','13:30:00',3.88),('9303','2014-04-05','13:35:00',4.59),('9303','2014-04-05','13:40:00',4.61),('9303','2014-04-05','13:45:00',4.03),('9303','2014-04-05','13:50:00',4.45),('9303','2014-04-05','13:55:00',3.76),('9303','2014-04-05','14:00:00',3.45),('9303','2014-04-05','14:05:00',4.93),('9303','2014-04-05','14:10:00',2.33),('9303','2014-04-05','14:25:00',1.08),('9303','2014-04-05','14:30:00',1.23),('9303','2014-04-05','14:50:00',2.42),('9303','2014-04-05','14:55:00',4.24),('9303','2014-04-05','15:00:00',3.54),('9303','2014-04-05','15:05:00',3.95),('9303','2014-04-05','15:10:00',1.28),('9303','2014-04-05','15:15:00',2.88),('9303','2014-04-05','15:20:00',4.38),('9303','2014-04-05','15:25:00',2.66),('9303','2014-04-05','15:30:00',1.36),('9303','2014-04-05','15:35:00',1.57),('9303','2014-04-05','15:40:00',2.28),('9303','2014-04-05','15:45:00',2.01),('9303','2014-04-05','15:50:00',1.84),('9303','2014-04-05','15:55:00',1.14),('9303','2014-04-05','16:00:00',1.22),('9303','2014-04-05','16:05:00',1.27),('9303','2014-04-05','16:10:00',1.21),('9303','2014-04-05','16:15:00',2.13),('9303','2014-04-05','16:20:00',3.21),('9303','2014-04-05','16:25:00',3.39),('9303','2014-04-05','16:30:00',1.95),('9303','2014-04-05','16:35:00',2.28),('9303','2014-04-05','16:40:00',1.54),('9303','2014-04-05','16:45:00',1.72),('9303','2014-04-05','16:50:00',1.67),('9303','2014-04-05','16:55:00',2.07),('9303','2014-04-05','17:00:00',1.74),('9303','2014-04-05','17:05:00',1.98),('9303','2014-04-05','17:10:00',1.72),('9303','2014-04-05','17:15:00',1.1),('9303','2014-04-05','17:20:00',1.29),('9303','2014-04-05','17:25:00',1.32),('9303','2014-04-05','17:30:00',1.2),('9303','2014-04-05','17:50:00',1.03),('9303','2014-04-05','17:55:00',1.03),('9303','2014-04-05','18:00:00',1.02),('9303','2013-06-30','07:45:00',1.07),('9303','2013-06-30','07:50:00',1.15),('9303','2013-06-30','07:55:00',1.24),('9303','2013-06-30','08:00:00',1.32),('9303','2013-06-30','08:05:00',1.41),('9303','2013-06-30','08:10:00',1.5),('9303','2013-06-30','08:15:00',1.6),('9303','2013-06-30','08:20:00',1.68),('9303','2013-06-30','08:25:00',1.77),('9303','2013-06-30','08:30:00',1.86),('9303','2013-06-30','08:35:00',1.94),('9303','2013-06-30','08:40:00',2.02),('9303','2013-06-30','08:45:00',2.1),('9303','2013-06-30','08:50:00',2.17),('9303','2013-06-30','08:55:00',2.24),('9303','2013-06-30','09:00:00',2.31),('9303','2013-06-30','09:05:00',2.43),('9303','2013-06-30','09:10:00',2.5),('9303','2013-06-30','09:15:00',2.56),('9303','2013-06-30','09:20:00',2.62),('9303','2013-06-30','09:25:00',2.7),('9303','2013-06-30','09:30:00',2.77),('9303','2013-06-30','09:35:00',2.82),('9303','2013-06-30','09:40:00',2.89),('9303','2013-06-30','09:45:00',2.95),('9303','2013-06-30','09:50:00',3),('9303','2013-06-30','09:55:00',3.06),('9303','2013-06-30','10:00:00',3.12),('9303','2013-06-30','10:05:00',3.19),('9303','2013-06-30','10:10:00',3.24),('9303','2013-06-30','10:15:00',3.3),('9303','2013-06-30','10:20:00',3.32),('9303','2013-06-30','10:25:00',3.34),('9303','2013-06-30','10:30:00',3.43),('9303','2013-06-30','10:35:00',3.47),('9303','2013-06-30','10:40:00',3.56),('9303','2013-06-30','10:45:00',3.56),('9303','2013-06-30','10:50:00',3.58),('9303','2013-06-30','10:55:00',3.6),('9303','2013-06-30','11:00:00',3.62),('9303','2013-06-30','11:05:00',3.64),('9303','2013-06-30','11:10:00',3.67),('9303','2013-06-30','11:15:00',3.71),('9303','2013-06-30','11:20:00',3.75),('9303','2013-06-30','11:25:00',3.78),('9303','2013-06-30','11:30:00',3.8),('9303','2013-06-30','11:35:00',3.82),('9303','2013-06-30','11:40:00',3.84),('9303','2013-06-30','11:45:00',3.87),('9303','2013-06-30','11:50:00',3.89),('9303','2013-06-30','11:55:00',3.92),('9303','2013-06-30','12:00:00',3.92),('9303','2013-06-30','12:05:00',4.01),('9303','2013-06-30','12:10:00',4.03),('9303','2013-06-30','12:15:00',4.03),('9303','2013-06-30','12:20:00',4.03),('9303','2013-06-30','12:25:00',4.04),('9303','2013-06-30','12:30:00',4.07),('9303','2013-06-30','12:35:00',4.09),('9303','2013-06-30','12:40:00',4.11),('9303','2013-06-30','12:45:00',4.14),('9303','2013-06-30','12:50:00',4.2),('9303','2013-06-30','12:55:00',4.16),('9303','2013-06-30','13:00:00',4.15),('9303','2013-06-30','13:05:00',4.12),('9303','2013-06-30','13:10:00',4.11),('9303','2013-06-30','13:15:00',4.19),('9303','2013-06-30','13:20:00',4.22),('9303','2013-06-30','13:25:00',4.24),('9303','2013-06-30','13:30:00',4.19),('9303','2013-06-30','13:35:00',4.13),('9303','2013-06-30','13:40:00',4.06),('9303','2013-06-30','13:45:00',4.14),('9303','2013-06-30','13:50:00',4.18),('9303','2013-06-30','13:55:00',3.76),('9303','2013-06-30','14:00:00',4.23),('9303','2013-06-30','14:05:00',4.2),('9303','2013-06-30','14:10:00',4.16),('9303','2013-06-30','14:15:00',4.01),('9303','2013-06-30','14:20:00',4.02),('9303','2013-06-30','14:25:00',4.02),('9303','2013-06-30','14:30:00',4),('9303','2013-06-30','14:35:00',4.01),('9303','2013-06-30','14:40:00',4.01),('9303','2013-06-30','14:45:00',3.97),('9303','2013-06-30','14:50:00',3.94),('9303','2013-06-30','14:55:00',3.9),('9303','2013-06-30','15:00:00',3.83),('9303','2013-06-30','15:05:00',3.79),('9303','2013-06-30','15:10:00',3.76),('9303','2013-06-30','15:15:00',3.72),('9303','2013-06-30','15:20:00',3.75),('9303','2013-06-30','15:25:00',3.67),('9303','2013-06-30','15:30:00',3.65),('9303','2013-06-30','15:35:00',3.63),('9303','2013-06-30','15:40:00',3.58),('9303','2013-06-30','15:45:00',3.54),('9303','2013-06-30','15:50:00',3.51),('9303','2013-06-30','15:55:00',3.44),('9303','2013-06-30','16:00:00',3.39),('9303','2013-06-30','16:05:00',3.33),('9303','2013-06-30','16:10:00',3.32),('9303','2013-06-30','16:15:00',3.27),('9303','2013-06-30','16:20:00',3.3),('9303','2013-06-30','16:25:00',3.31),('9303','2013-06-30','16:30:00',2.78),('9303','2013-06-30','16:35:00',3.02),('9303','2013-06-30','16:40:00',2.83),('9303','2013-06-30','16:45:00',2.81),('9303','2013-06-30','16:50:00',2.75),('9303','2013-06-30','16:55:00',2.64),('9303','2013-06-30','17:00:00',2.53),('9303','2013-06-30','17:05:00',2.48),('9303','2013-06-30','17:10:00',2.44),('9303','2013-06-30','17:15:00',2.32),('9303','2013-06-30','17:20:00',2.19),('9303','2013-06-30','17:25:00',2.08),('9303','2013-06-30','17:30:00',1.91),('9303','2013-06-30','17:35:00',1.75),('9303','2013-06-30','17:40:00',1.71),('9303','2013-06-30','17:45:00',1.72),('9303','2013-06-30','17:50:00',1.66),('9303','2013-06-30','17:55:00',1.58),('9303','2013-06-30','18:00:00',1.5),('9303','2013-06-30','18:05:00',1.39),('9303','2013-06-30','18:10:00',1.3),('9303','2013-06-30','18:15:00',1.2),('9303','2013-06-30','18:20:00',1.11),('9303','2013-06-30','18:25:00',1.02),('9303','2013-06-29','07:35:00',1.22),('9303','2013-06-29','07:40:00',1.29),('9303','2013-06-29','07:45:00',1.32),('9303','2013-06-29','07:50:00',1.39),('9303','2013-06-29','07:55:00',1.47),('9303','2013-06-29','08:00:00',1.75),('9303','2013-06-29','08:05:00',1.9),('9303','2013-06-29','08:10:00',1.99),('9303','2013-06-29','08:15:00',1.79),('9303','2013-06-29','08:20:00',1.13),('9303','2013-06-29','08:25:00',1.56),('9303','2013-06-29','08:30:00',1.95),('9303','2013-06-29','08:35:00',2.02),('9303','2013-06-29','08:40:00',1.1),('9303','2013-06-29','08:45:00',2.02),('9303','2013-06-29','08:50:00',2.18),('9303','2013-06-29','08:55:00',2.24),('9303','2013-06-29','09:00:00',2.3),('9303','2013-06-29','09:05:00',2.4),('9303','2013-06-29','09:10:00',2.45),('9303','2013-06-29','09:15:00',2.52),('9303','2013-06-29','09:20:00',2.58),('9303','2013-06-29','09:25:00',2.64),('9303','2013-06-29','09:30:00',2.71),('9303','2013-06-29','09:35:00',2.8),('9303','2013-06-29','09:40:00',2.86),('9303','2013-06-29','09:45:00',2.88),('9303','2013-06-29','09:50:00',2.96),('9303','2013-06-29','09:55:00',3.02),('9303','2013-06-29','10:00:00',3.1),('9303','2013-06-29','10:05:00',3.16),('9303','2013-06-29','10:10:00',3.19),('9303','2013-06-29','10:15:00',3.2),('9303','2013-06-29','10:20:00',3.28),('9303','2013-06-29','10:25:00',3.34),('9303','2013-06-29','10:30:00',3.38),('9303','2013-06-29','10:35:00',3.42),('9303','2013-06-29','10:40:00',3.41),('9303','2013-06-29','10:45:00',3.49),('9303','2013-06-29','10:50:00',3.58),('9303','2013-06-29','10:55:00',2.87),('9303','2013-06-29','11:00:00',3.39),('9303','2013-06-29','11:05:00',3.82),('9303','2013-06-29','11:10:00',3.87),('9303','2013-06-29','11:15:00',3.34),('9303','2013-06-29','11:20:00',2.75),('9303','2013-06-29','11:25:00',4.22),('9303','2013-06-29','11:30:00',3.49),('9303','2013-06-29','11:35:00',3.15),('9303','2013-06-29','11:40:00',4.04),('9303','2013-06-29','11:45:00',1.19),('9303','2013-06-29','11:50:00',4.03),('9303','2013-06-29','11:55:00',3.71),('9303','2013-06-29','12:00:00',3.14),('9303','2013-06-29','12:05:00',4.27),('9303','2013-06-29','12:10:00',4.35),('9303','2013-06-29','12:15:00',2.39),('9303','2013-06-29','12:25:00',4.42),('9303','2013-06-29','12:30:00',4.37),('9303','2013-06-29','12:35:00',4.34),('9303','2013-06-29','12:40:00',4.41),('9303','2013-06-29','12:45:00',4.47),('9303','2013-06-29','12:50:00',1.58),('9303','2013-06-29','12:55:00',4.16),('9303','2013-06-29','13:00:00',3.82),('9303','2013-06-29','13:05:00',4.18),('9303','2013-06-29','13:10:00',4.48),('9303','2013-06-29','13:15:00',3.8),('9303','2013-06-29','13:20:00',1.69),('9303','2013-06-29','13:25:00',3.01),('9303','2013-06-29','13:30:00',1.79),('9303','2013-06-29','13:45:00',2.63),('9303','2013-06-29','13:50:00',2.53),('9303','2013-06-29','13:55:00',4.94),('9303','2013-06-29','14:00:00',4.55),('9303','2013-06-29','14:05:00',4.3),('9303','2013-06-29','14:10:00',4.63),('9303','2013-06-29','14:15:00',4.71),('9303','2013-06-29','14:20:00',3.6),('9303','2013-06-29','14:25:00',2.97),('9303','2013-06-29','14:30:00',4.71),('9303','2013-06-29','14:35:00',4.43),('9303','2013-06-29','14:40:00',4.41),('9303','2013-06-29','14:45:00',4.49),('9303','2013-06-29','14:50:00',4.56),('9303','2013-06-29','14:55:00',1.4),('9303','2013-06-29','15:00:00',2.56),('9303','2013-06-29','15:05:00',3.63),('9303','2013-06-29','15:10:00',2.31),('9303','2013-06-29','15:15:00',1.44),('9303','2013-06-29','16:40:00',1.11),('9303','2013-06-29','16:45:00',1.47),('9303','2013-06-29','16:50:00',2.27),('9303','2013-06-29','17:05:00',1.06),('9303','2013-06-29','17:20:00',1.04),('9303','2013-06-29','17:25:00',1.27),('9303','2013-06-29','17:30:00',2.19),('9303','2013-06-29','17:35:00',1.57),('9303','2013-06-29','17:45:00',1.82),('9303','2013-06-29','17:50:00',1.76),('9303','2013-06-29','17:55:00',1.68),('9303','2013-06-29','18:00:00',1.56),('9303','2013-06-29','18:05:00',1.46),('9303','2013-06-29','18:10:00',1.32),('9303','2013-06-29','18:15:00',1.24),('9303','2013-06-29','18:20:00',1.13),('9303','2013-06-29','18:25:00',1.11),('9303','2013-06-29','18:35:00',1.03),('9303','2013-06-28','07:45:00',1.09),('9303','2013-06-28','07:50:00',1.14),('9303','2013-06-28','07:55:00',1.22),('9303','2013-06-28','08:00:00',1.28),('9303','2013-06-28','08:05:00',1.33),('9303','2013-06-28','08:10:00',1.35),('9303','2013-06-28','08:15:00',1.53),('9303','2013-06-28','08:20:00',1.62),('9303','2013-06-28','08:25:00',1.57),('9303','2013-06-28','08:30:00',1.77),('9303','2013-06-28','08:35:00',1.88),('9303','2013-06-28','08:40:00',1.94),('9303','2013-06-28','08:45:00',2.01),('9303','2013-06-28','08:50:00',2.07),('9303','2013-06-28','08:55:00',2.16),('9303','2013-06-28','09:00:00',2.2),('9303','2013-06-28','09:05:00',2.31),('9303','2013-06-28','09:10:00',2.48),('9303','2013-06-28','09:15:00',2.37),('9303','2013-06-28','09:20:00',1.38),('9303','2013-06-28','09:30:00',1.29),('9303','2013-06-28','09:35:00',2.94),('9303','2013-06-28','09:40:00',2.96),('9303','2013-06-28','09:45:00',2.54),('9303','2013-06-28','09:50:00',3),('9303','2013-06-28','09:55:00',3.15),('9303','2013-06-28','10:00:00',2.05),('9303','2013-06-28','10:05:00',1.69),('9303','2013-06-28','10:10:00',3.44),('9303','2013-06-28','10:15:00',3.55),('9303','2013-06-28','10:20:00',2.88),('9303','2013-06-28','10:25:00',2.57),('9303','2013-06-28','10:30:00',1.26),('9303','2013-06-28','10:35:00',3.78),('9303','2013-06-28','10:40:00',4.16),('9303','2013-06-28','10:45:00',3.97),('9303','2013-06-28','10:50:00',3.16),('9303','2013-06-28','10:55:00',2.44),('9303','2013-06-28','11:00:00',2.81),('9303','2013-06-28','11:05:00',4.13),('9303','2013-06-28','11:10:00',1.72),('9303','2013-06-28','11:15:00',1.46),('9303','2013-06-28','11:20:00',1.87),('9303','2013-06-28','11:25:00',2.7),('9303','2013-06-28','11:30:00',4.18),('9303','2013-06-28','11:35:00',3.74),('9303','2013-06-28','11:40:00',4.07),('9303','2013-06-28','11:45:00',4.01),('9303','2013-06-28','11:50:00',4.43),('9303','2013-06-28','11:55:00',2.24),('9303','2013-06-28','12:00:00',2.61),('9303','2013-06-28','12:05:00',2.39),('9303','2013-06-28','12:10:00',2.63),('9303','2013-06-28','12:15:00',4.47),('9303','2013-06-28','12:20:00',4.27),('9303','2013-06-28','12:25:00',4.34),('9303','2013-06-28','12:30:00',4.22),('9303','2013-06-28','12:35:00',4.23),('9303','2013-06-28','12:40:00',2),('9303','2013-06-28','12:45:00',3.75),('9303','2013-06-28','12:50:00',4.43),('9303','2013-06-28','12:55:00',4.31),('9303','2013-06-28','13:00:00',4.31),('9303','2013-06-28','13:05:00',4.27),('9303','2013-06-28','13:10:00',4),('9303','2013-06-28','13:15:00',4.4),('9303','2013-06-28','13:20:00',4.3),('9303','2013-06-28','13:25:00',4.22),('9303','2013-06-28','13:30:00',4.3),('9303','2013-06-28','13:35:00',4.31),('9303','2013-06-28','13:40:00',4.31),('9303','2013-06-28','13:45:00',4.35),('9303','2013-06-28','13:50:00',4.19),('9303','2013-06-28','13:55:00',4.46),('9303','2013-06-28','14:00:00',3.95),('9303','2013-06-28','14:05:00',3.98),('9303','2013-06-28','14:10:00',3.83),('9303','2013-06-28','14:15:00',3.93),('9303','2013-06-28','14:20:00',4.37),('9303','2013-06-28','14:25:00',3.53),('9303','2013-06-28','14:30:00',3.12),('9303','2013-06-28','14:35:00',3.41),('9303','2013-06-28','14:40:00',4.04),('9303','2013-06-28','14:45:00',3.53),('9303','2013-06-28','14:50:00',4.03),('9303','2013-06-28','14:55:00',4.12),('9303','2013-06-28','15:00:00',2.85),('9303','2013-06-28','15:05:00',3.92),('9303','2013-06-28','15:10:00',3.71),('9303','2013-06-28','15:15:00',3.93),('9303','2013-06-28','15:20:00',4.01),('9303','2013-06-28','15:25:00',3.85),('9303','2013-06-28','15:30:00',2.11),('9303','2013-06-28','15:35:00',2.09),('9303','2013-06-28','15:40:00',3.65),('9303','2013-06-28','15:45:00',2.22),('9303','2013-06-28','15:50:00',3.98),('9303','2013-06-28','15:55:00',3.59),('9303','2013-06-28','16:00:00',3.13),('9303','2013-06-28','16:05:00',3.79),('9303','2013-06-28','16:10:00',2),('9303','2013-06-28','16:15:00',3.63),('9303','2013-06-28','16:20:00',3.23),('9303','2013-06-28','16:25:00',2.26),('9303','2013-06-28','16:30:00',1.64),('9303','2013-06-28','16:35:00',2.05),('9303','2013-06-28','16:40:00',2.22),('9303','2013-06-28','16:50:00',1.21),('9303','2013-06-28','16:55:00',2.23),('9303','2013-06-28','17:00:00',2.06),('9303','2013-06-28','17:05:00',2.58),('9303','2013-06-28','17:10:00',2.45),('9303','2013-06-28','17:15:00',2.32),('9303','2013-06-28','17:20:00',2.18),('9303','2013-06-28','17:25:00',2.05),('9303','2013-06-28','17:30:00',1.59),('9303','2013-06-28','17:35:00',1.76),('9303','2013-06-28','17:40:00',1.82),('9303','2013-06-28','17:45:00',1.76),('9303','2013-06-28','17:50:00',1.7),('9303','2013-06-28','17:55:00',1.62),('9303','2013-06-28','18:00:00',1.54),('9303','2013-06-28','18:05:00',1.45),('9303','2013-06-28','18:10:00',1.32),('9303','2013-06-28','18:15:00',1.22),('9303','2013-06-28','18:20:00',1.15),('9303','2013-06-28','18:25:00',1.08),('9303','2013-06-27','07:45:00',1.04),('9303','2013-06-27','07:50:00',1.14),('9303','2013-06-27','07:55:00',1.23),('9303','2013-06-27','08:00:00',1.31),('9303','2013-06-27','08:05:00',1.39),('9303','2013-06-27','08:10:00',1.51),('9303','2013-06-27','08:15:00',1.58),('9303','2013-06-27','08:20:00',1.66),('9303','2013-06-27','08:25:00',1.74),('9303','2013-06-27','08:30:00',1.8),('9303','2013-06-27','08:35:00',1.85),('9303','2013-06-27','08:40:00',1.94),('9303','2013-06-27','08:45:00',2.03),('9303','2013-06-27','08:50:00',2.08),('9303','2013-06-27','08:55:00',2.19),('9303','2013-06-27','09:00:00',2.28),('9303','2013-06-27','09:05:00',2.37),('9303','2013-06-27','09:10:00',2.43),('9303','2013-06-27','09:15:00',2.51),('9303','2013-06-27','09:20:00',2.6),('9303','2013-06-27','09:25:00',2.65),('9303','2013-06-27','09:30:00',2.73),('9303','2013-06-27','09:35:00',2.78),('9303','2013-06-27','09:40:00',2.85),('9303','2013-06-27','09:45:00',2.89),('9303','2013-06-27','09:50:00',3.01),('9303','2013-06-27','09:55:00',3.06),('9303','2013-06-27','10:00:00',3.13),('9303','2013-06-27','10:05:00',3.31),('9303','2013-06-27','10:10:00',2.83),('9303','2013-06-27','10:15:00',2.38),('9303','2013-06-27','10:20:00',2.4),('9303','2013-06-27','10:25:00',3.39),('9303','2013-06-27','10:30:00',3.45),('9303','2013-06-27','10:35:00',3.56),('9303','2013-06-27','10:40:00',3.67),('9303','2013-06-27','10:45:00',3.81),('9303','2013-06-27','10:50:00',3.84),('9303','2013-06-27','10:55:00',3.82),('9303','2013-06-27','11:00:00',3.82),('9303','2013-06-27','11:05:00',3.91),('9303','2013-06-27','11:10:00',3.97),('9303','2013-06-27','11:15:00',3.92),('9303','2013-06-27','11:20:00',3.89),('9303','2013-06-27','11:25:00',3.92),('9303','2013-06-27','11:30:00',3.95),('9303','2013-06-27','11:35:00',4.03),('9303','2013-06-27','11:40:00',3.01),('9303','2013-06-27','11:45:00',3.61),('9303','2013-06-27','11:50:00',2.81),('9303','2013-06-27','11:55:00',1.41),('9303','2013-06-27','12:00:00',2.5),('9303','2013-06-27','12:05:00',1.22),('9303','2013-06-27','12:10:00',1.59),('9303','2013-06-27','12:15:00',1.03),('9303','2013-06-27','12:20:00',1.09),('9303','2013-06-27','12:25:00',1.77),('9303','2013-06-27','12:30:00',1.72),('9303','2013-06-27','12:35:00',2.41),('9303','2013-06-27','12:40:00',2.16),('9303','2013-06-27','12:45:00',1.39),('9303','2013-06-27','12:50:00',1.14),('9303','2013-06-27','12:55:00',1.04),('9303','2013-06-27','13:05:00',1.05),('9303','2013-06-27','13:10:00',1.39),('9303','2013-06-27','13:15:00',2.89),('9303','2013-06-27','13:20:00',2.82),('9303','2013-06-27','13:25:00',2.46),('9303','2013-06-27','13:30:00',2.05),('9303','2013-06-27','13:35:00',3.14),('9303','2013-06-27','13:40:00',1.22),('9303','2013-06-27','13:45:00',1.12),('9303','2013-06-27','13:50:00',1.25),('9303','2013-06-27','13:55:00',1.48),('9303','2013-06-27','14:00:00',1.34),('9303','2013-06-27','14:05:00',1.24),('9303','2013-06-27','14:10:00',1.46),('9303','2013-06-27','14:15:00',2.91),('9303','2013-06-27','14:20:00',1.67),('9303','2013-06-27','14:25:00',2.32),('9303','2013-06-27','14:30:00',4.4),('9303','2013-06-27','14:35:00',4.12),('9303','2013-06-27','14:40:00',4.03),('9303','2013-06-27','14:45:00',2.5),('9303','2013-06-27','14:50:00',3.28),('9303','2013-06-27','14:55:00',3.9),('9303','2013-06-27','15:00:00',3.77),('9303','2013-06-27','15:05:00',3.72),('9303','2013-06-27','15:10:00',3.68),('9303','2013-06-27','15:15:00',3.64),('9303','2013-06-27','15:20:00',3.58),('9303','2013-06-27','15:25:00',3.6),('9303','2013-06-27','15:30:00',3.58),('9303','2013-06-27','15:35:00',3.53),('9303','2013-06-27','15:40:00',3.47),('9303','2013-06-27','15:45:00',3.42),('9303','2013-06-27','15:50:00',3.36),('9303','2013-06-27','15:55:00',3.29),('9303','2013-06-27','16:00:00',3.19),('9303','2013-06-27','16:05:00',3.12),('9303','2013-06-27','16:10:00',3.1),('9303','2013-06-27','16:15:00',3.03),('9303','2013-06-27','16:20:00',2.99),('9303','2013-06-27','16:25:00',2.95),('9303','2013-06-27','16:30:00',2.91),('9303','2013-06-27','16:35:00',2.63),('9303','2013-06-27','16:40:00',2.7),('9303','2013-06-27','16:45:00',2.7),('9303','2013-06-27','16:50:00',2.62),('9303','2013-06-27','16:55:00',2.56),('9303','2013-06-27','17:00:00',2.5),('9303','2013-06-27','17:05:00',2.43),('9303','2013-06-27','17:10:00',2.3),('9303','2013-06-27','17:15:00',2.16),('9303','2013-06-27','17:20:00',2.14),('9303','2013-06-27','17:25:00',2.07),('9303','2013-06-27','17:30:00',1.94),('9303','2013-06-27','17:35:00',1.84),('9303','2013-06-27','17:40:00',1.02),('9303','2013-06-27','17:50:00',1.57),('9303','2013-06-27','17:55:00',1.55),('9303','2013-06-27','18:00:00',1.45),('9303','2013-06-27','18:05:00',1.36),('9303','2013-06-27','18:10:00',1.23),('9303','2013-06-27','18:15:00',1.11),('9303','2013-06-27','18:20:00',1.03),('9303','2013-06-27','18:25:00',1.01),('9303','2013-06-26','07:45:00',1.07),('9303','2013-06-26','07:50:00',1.17),('9303','2013-06-26','07:55:00',1.24),('9303','2013-06-26','08:00:00',1.3),('9303','2013-06-26','08:05:00',1.39),('9303','2013-06-26','08:10:00',1.49),('9303','2013-06-26','08:15:00',1.58),('9303','2013-06-26','08:20:00',1.64),('9303','2013-06-26','08:25:00',1.72),('9303','2013-06-26','08:30:00',1.8),('9303','2013-06-26','08:35:00',1.87),('9303','2013-06-26','08:40:00',1.93),('9303','2013-06-26','08:45:00',2),('9303','2013-06-26','08:50:00',2.07),('9303','2013-06-26','08:55:00',2.15),('9303','2013-06-26','09:00:00',2.21),('9303','2013-06-26','09:05:00',2.32),('9303','2013-06-26','09:10:00',2.38),('9303','2013-06-26','09:15:00',2.45),('9303','2013-06-26','09:20:00',2.51),('9303','2013-06-26','09:25:00',2.59),('9303','2013-06-26','09:30:00',2.66),('9303','2013-06-26','09:35:00',2.72),('9303','2013-06-26','09:40:00',2.8),('9303','2013-06-26','09:45:00',2.83),('9303','2013-06-26','09:50:00',2.88),('9303','2013-06-26','09:55:00',2.94),('9303','2013-06-26','10:00:00',3.03),('9303','2013-06-26','10:05:00',3.11),('9303','2013-06-26','10:10:00',3.14),('9303','2013-06-26','10:15:00',3.19),('9303','2013-06-26','10:20:00',3.24),('9303','2013-06-26','10:25:00',3.23),('9303','2013-06-26','10:30:00',3.29),('9303','2013-06-26','10:35:00',3.33),('9303','2013-06-26','10:40:00',3.42),('9303','2013-06-26','10:45:00',3.46),('9303','2013-06-26','10:50:00',3.5),('9303','2013-06-26','10:55:00',3.52),('9303','2013-06-26','11:00:00',3.59),('9303','2013-06-26','11:05:00',3.62),('9303','2013-06-26','11:10:00',3.64),('9303','2013-06-26','11:15:00',3.65),('9303','2013-06-26','11:20:00',3.67),('9303','2013-06-26','11:25:00',3.66),('9303','2013-06-26','11:30:00',3.66),('9303','2013-06-26','11:35:00',3.71),('9303','2013-06-26','11:40:00',3.78),('9303','2013-06-26','11:45:00',3.87),('9303','2013-06-26','11:50:00',3.9),('9303','2013-06-26','11:55:00',3.89),('9303','2013-06-26','12:00:00',3.91),('9303','2013-06-26','12:05:00',3.95),('9303','2013-06-26','12:10:00',3.98),('9303','2013-06-26','12:15:00',3.94),('9303','2013-06-26','12:20:00',3.83),('9303','2013-06-26','12:25:00',3.84),('9303','2013-06-26','12:30:00',3.92),('9303','2013-06-26','12:35:00',4.09),('9303','2013-06-26','12:40:00',4.07),('9303','2013-06-26','12:45:00',4.15),('9303','2013-06-26','12:50:00',2.29),('9303','2013-06-26','13:10:00',1.06),('9303','2013-06-26','13:15:00',2.78),('9303','2013-06-26','13:20:00',4.57),('9303','2013-06-26','13:25:00',4.52),('9303','2013-06-26','13:30:00',1.66),('9303','2013-06-26','13:45:00',1.1),('9303','2013-06-26','13:50:00',1.41),('9303','2013-06-26','13:55:00',1.52),('9303','2013-06-26','14:00:00',2.91),('9303','2013-06-26','14:10:00',1.6),('9303','2013-06-26','14:15:00',4.42),('9303','2013-06-26','14:20:00',4.17),('9303','2013-06-26','14:25:00',4.06),('9303','2013-06-26','14:30:00',4.16),('9303','2013-06-26','14:35:00',4.15),('9303','2013-06-26','14:40:00',2.08),('9303','2013-06-26','14:45:00',3.25),('9303','2013-06-26','14:50:00',4.21),('9303','2013-06-26','14:55:00',4.02),('9303','2013-06-26','15:00:00',3.76),('9303','2013-06-26','15:05:00',3.76),('9303','2013-06-26','15:10:00',3.69),('9303','2013-06-26','15:15:00',3.68),('9303','2013-06-26','15:20:00',3.64),('9303','2013-06-26','15:25:00',3.59),('9303','2013-06-26','15:30:00',3.56),('9303','2013-06-26','15:35:00',3.55),('9303','2013-06-26','15:40:00',3.48),('9303','2013-06-26','15:45:00',3.46),('9303','2013-06-26','15:50:00',3.45),('9303','2013-06-26','15:55:00',3.31),('9303','2013-06-26','16:00:00',3.27),('9303','2013-06-26','16:05:00',3.22),('9303','2013-06-26','16:10:00',3.18),('9303','2013-06-26','16:15:00',3.13),('9303','2013-06-26','16:20:00',3.08),('9303','2013-06-26','16:25:00',3),('9303','2013-06-26','16:30:00',2.93),('9303','2013-06-26','16:35:00',2.86),('9303','2013-06-26','16:40:00',2.77),('9303','2013-06-26','16:45:00',2.72),('9303','2013-06-26','16:50:00',2.66),('9303','2013-06-26','16:55:00',2.6),('9303','2013-06-26','17:00:00',2.55),('9303','2013-06-26','17:05:00',2.48),('9303','2013-06-26','17:10:00',2.43),('9303','2013-06-26','17:15:00',2.3),('9303','2013-06-26','17:20:00',2.19),('9303','2013-06-26','17:25:00',2.06),('9303','2013-06-26','17:30:00',1.91),('9303','2013-06-26','17:35:00',1.72),('9303','2013-06-26','17:40:00',1.79),('9303','2013-06-26','17:45:00',1.73),('9303','2013-06-26','17:50:00',1.66),('9303','2013-06-26','17:55:00',1.58),('9303','2013-06-26','18:00:00',1.5),('9303','2013-06-26','18:05:00',1.51),('9303','2013-06-26','18:10:00',1.63),('9303','2013-06-26','18:15:00',1.04),('9303','2013-06-25','07:45:00',1.09),('9303','2013-06-25','08:05:00',1.45),('9303','2013-06-25','08:20:00',1.69),('9303','2013-06-25','08:30:00',1.53),('9303','2013-06-25','08:35:00',1.92),('9303','2013-06-25','08:40:00',1.98),('9303','2013-06-25','08:45:00',2.06),('9303','2013-06-25','08:50:00',2.14),('9303','2013-06-25','08:55:00',2.2),('9303','2013-06-25','09:00:00',2.3),('9303','2013-06-25','09:05:00',2.38),('9303','2013-06-25','09:10:00',2.43),('9303','2013-06-25','09:15:00',2.51),('9303','2013-06-25','09:20:00',2.63),('9303','2013-06-25','09:25:00',2.74),('9303','2013-06-25','09:30:00',2.77),('9303','2013-06-25','09:35:00',2.76),('9303','2013-06-25','09:40:00',2.28),('9303','2013-06-25','09:45:00',2.51),('9303','2013-06-25','09:50:00',3.26),('9303','2013-06-25','09:55:00',2.19),('9303','2013-06-25','10:00:00',3.22),('9303','2013-06-25','10:05:00',3.57),('9303','2013-06-25','10:10:00',3.28),('9303','2013-06-25','10:15:00',3.66),('9303','2013-06-25','10:20:00',3.65),('9303','2013-06-25','10:25:00',3.7),('9303','2013-06-25','10:30:00',3.71),('9303','2013-06-25','10:35:00',3.69),('9303','2013-06-25','10:40:00',3.77),('9303','2013-06-25','10:45:00',3.77),('9303','2013-06-25','10:50:00',3.64),('9303','2013-06-25','10:55:00',1.62),('9303','2013-06-25','11:10:00',1.52),('9303','2013-06-25','11:20:00',1.06),('9303','2013-06-25','11:25:00',1.03),('9303','2013-06-25','11:30:00',1.07),('9303','2013-06-25','11:35:00',2.52),('9303','2013-06-25','11:40:00',3.05),('9303','2013-06-25','11:45:00',3.97),('9303','2013-06-25','11:50:00',2.99),('9303','2013-06-25','11:55:00',3.62),('9303','2013-06-25','12:00:00',4.67),('9303','2013-06-25','12:05:00',1.91),('9303','2013-06-25','12:10:00',1.61),('9303','2013-06-25','12:15:00',1.43),('9303','2013-06-25','12:20:00',1.89),('9303','2013-06-25','12:25:00',1.02),('9303','2013-06-25','12:35:00',1),('9303','2013-06-25','12:40:00',1.31),('9303','2013-06-25','12:45:00',2.72),('9303','2013-06-25','12:50:00',1.16),('9303','2013-06-25','12:55:00',1.89),('9303','2013-06-25','13:00:00',4.56),('9303','2013-06-25','13:05:00',4.43),('9303','2013-06-25','13:10:00',4.49),('9303','2013-06-25','13:15:00',4.41),('9303','2013-06-25','13:20:00',4.31),('9303','2013-06-25','13:25:00',4.29),('9303','2013-06-25','13:30:00',4.38),('9303','2013-06-25','13:35:00',4.24),('9303','2013-06-25','13:40:00',4.01),('9303','2013-06-25','13:45:00',4.48),('9303','2013-06-25','13:50:00',4.08),('9303','2013-06-25','13:55:00',3.23),('9303','2013-06-25','14:00:00',3.47),('9303','2013-06-25','14:05:00',4.28),('9303','2013-06-25','14:10:00',4.31),('9303','2013-06-25','14:15:00',2.94),('9303','2013-06-25','14:20:00',3.69),('9303','2013-06-25','14:25:00',4.12),('9303','2013-06-25','14:30:00',4.04),('9303','2013-06-25','14:35:00',3.99),('9303','2013-06-25','14:40:00',4),('9303','2013-06-25','14:45:00',4.01),('9303','2013-06-25','14:50:00',3.97),('9303','2013-06-25','14:55:00',3.88),('9303','2013-06-25','15:00:00',3.85),('9303','2013-06-25','15:05:00',3.8),('9303','2013-06-25','15:10:00',3.76),('9303','2013-06-25','15:15:00',3.74),('9303','2013-06-25','15:20:00',3.68),('9303','2013-06-25','15:25:00',3.62),('9303','2013-06-25','15:30:00',3.56),('9303','2013-06-25','15:35:00',3.49),('9303','2013-06-25','15:40:00',3.44),('9303','2013-06-25','15:45:00',3.41),('9303','2013-06-25','15:50:00',3.34),('9303','2013-06-25','15:55:00',3.29),('9303','2013-06-25','16:00:00',3.26),('9303','2013-06-25','16:05:00',3.22),('9303','2013-06-25','16:10:00',3.15),('9303','2013-06-25','16:15:00',3.07),('9303','2013-06-25','16:20:00',3.03),('9303','2013-06-25','16:25:00',2.97),('9303','2013-06-25','16:30:00',2.9),('9303','2013-06-25','16:35:00',2.83),('9303','2013-06-25','16:40:00',2.77),('9303','2013-06-25','16:45:00',2.72),('9303','2013-06-25','16:50:00',2.66),('9303','2013-06-25','16:55:00',2.58),('9303','2013-06-25','17:00:00',2.51),('9303','2013-06-25','17:05:00',2.46),('9303','2013-06-25','17:10:00',2.37),('9303','2013-06-25','17:15:00',2.27),('9303','2013-06-25','17:20:00',2.18),('9303','2013-06-25','17:25:00',2.04),('9303','2013-06-25','17:30:00',1.88),('9303','2013-06-25','17:35:00',1.8),('9303','2013-06-25','17:40:00',1.79),('9303','2013-06-25','17:45:00',1.7),('9303','2013-06-25','17:50:00',1.63),('9303','2013-06-25','17:55:00',1.57),('9303','2013-06-25','18:00:00',1.48),('9303','2013-06-25','18:05:00',1.38),('9303','2013-06-25','18:10:00',1.25),('9303','2013-06-25','18:15:00',1.16),('9303','2013-06-25','18:20:00',1.12),('9303','2013-06-25','18:25:00',1.03),('9303','2013-06-24','08:45:00',1.97),('9303','2013-06-24','08:50:00',2.27),('9303','2013-06-24','08:55:00',2.39),('9303','2013-06-24','09:00:00',1.79),('9303','2013-06-24','09:05:00',2.14),('9303','2013-06-24','09:10:00',1.12),('9303','2013-06-24','09:15:00',2.16),('9303','2013-06-24','09:20:00',2.66),('9303','2013-06-24','09:25:00',2.84),('9303','2013-06-24','09:30:00',2.47),('9303','2013-06-24','09:40:00',2.74),('9303','2013-06-24','09:45:00',2.74),('9303','2013-06-24','09:50:00',2.31),('9303','2013-06-24','09:55:00',3.16),('9303','2013-06-24','10:00:00',3.23),('9303','2013-06-24','10:05:00',3.28),('9303','2013-06-24','10:10:00',3.44),('9303','2013-06-24','10:15:00',3.71),('9303','2013-06-24','10:20:00',2.86),('9303','2013-06-24','10:25:00',3.81),('9303','2013-06-24','10:30:00',1.77),('9303','2013-06-24','10:35:00',2.92),('9303','2013-06-24','10:40:00',1.73),('9303','2013-06-24','10:45:00',2.12),('9303','2013-06-24','10:50:00',3.77),('9303','2013-06-24','10:55:00',2.77),('9303','2013-06-24','11:00:00',4.26),('9303','2013-06-24','11:05:00',3.38),('9303','2013-06-24','11:10:00',3.16),('9303','2013-06-24','11:15:00',2.47),('9303','2013-06-24','11:20:00',3.28),('9303','2013-06-24','11:25:00',1.33),('9303','2013-06-24','11:30:00',1.74),('9303','2013-06-24','11:35:00',1.23),('9303','2013-06-24','11:40:00',1.26),('9303','2013-06-24','11:45:00',1.65),('9303','2013-06-24','11:50:00',2.27),('9303','2013-06-24','11:55:00',4.06),('9303','2013-06-24','12:00:00',3.05),('9303','2013-06-24','12:05:00',3.99),('9303','2013-06-24','12:10:00',4.19),('9303','2013-06-24','12:15:00',3.35),('9303','2013-06-24','12:20:00',3.71),('9303','2013-06-24','12:25:00',2.64),('9303','2013-06-24','12:30:00',2.71),('9303','2013-06-24','12:35:00',4.78),('9303','2013-06-24','12:40:00',4.7),('9303','2013-06-24','12:45:00',2.48),('9303','2013-06-24','12:50:00',4.82),('9303','2013-06-24','12:55:00',4.81),('9303','2013-06-24','13:00:00',4.7),('9303','2013-06-24','13:05:00',4.9),('9303','2013-06-24','13:10:00',3.66),('9303','2013-06-24','13:15:00',3.09),('9303','2013-06-24','13:20:00',3),('9303','2013-06-24','13:25:00',3.84),('9303','2013-06-24','13:30:00',4.19),('9303','2013-06-24','13:35:00',3.9),('9303','2013-06-24','13:40:00',4.33),('9303','2013-06-24','13:45:00',4.47),('9303','2013-06-24','13:50:00',4.35),('9303','2013-06-24','13:55:00',4.28),('9303','2013-06-24','14:00:00',4.28),('9303','2013-06-24','14:05:00',4.29),('9303','2013-06-24','14:10:00',4.24),('9303','2013-06-24','14:15:00',4.23),('9303','2013-06-24','14:20:00',4.22),('9303','2013-06-24','14:25:00',4.22),('9303','2013-06-24','14:30:00',4.19),('9303','2013-06-24','14:35:00',4.15),('9303','2013-06-24','14:40:00',4.16),('9303','2013-06-24','14:45:00',4.13),('9303','2013-06-24','14:50:00',4.14),('9303','2013-06-24','14:55:00',4.22),('9303','2013-06-24','15:00:00',4.35),('9303','2013-06-24','15:05:00',2.7),('9303','2013-06-24','15:10:00',1.77),('9303','2013-06-24','15:15:00',4.21),('9303','2013-06-24','15:20:00',4.02),('9303','2013-06-24','15:25:00',3.77),('9303','2013-06-24','15:30:00',2.96),('9303','2013-06-24','15:35:00',2.88),('9303','2013-06-24','15:40:00',2.31),('9303','2013-06-24','15:45:00',3.29),('9303','2013-06-24','15:50:00',2.62),('9303','2013-06-24','15:55:00',3.03),('9303','2013-06-24','16:00:00',3.42),('9303','2013-06-24','16:05:00',3.53),('9303','2013-06-24','16:10:00',3.64),('9303','2013-06-24','16:15:00',3.68),('9303','2013-06-24','16:20:00',2.53),('9303','2013-06-24','16:25:00',2.59),('9303','2013-06-24','16:30:00',2.93),('9303','2013-06-24','16:35:00',2.68),('9303','2013-06-24','16:40:00',2.09),('9303','2013-06-24','16:45:00',2.35),('9303','2013-06-24','16:50:00',1.88),('9303','2013-06-24','16:55:00',1.11),('9303','2013-06-24','17:00:00',1.51),('9303','2013-06-24','17:05:00',2.01),('9303','2013-06-24','17:10:00',2.23),('9303','2013-06-24','17:15:00',2.64),('9303','2013-06-24','17:20:00',2.31),('9303','2013-06-24','17:25:00',1.5),('9303','2013-06-24','17:30:00',1.96),('9303','2013-06-24','17:50:00',1.73),('9303','2013-06-24','18:00:00',1.78),('9303','2013-06-24','18:05:00',1.61),('9303','2013-06-24','18:10:00',1.05),('9303','2013-06-24','18:15:00',1.38),('9303','2013-06-24','18:20:00',1.33),('9303','2013-06-24','18:25:00',1.18),('9303','2013-06-24','18:35:00',1.04),('9303','2013-06-23','08:50:00',1.34),('9303','2013-06-23','09:00:00',1.53),('9303','2013-06-23','09:05:00',1.36),('9303','2013-06-23','09:20:00',1.41),('9303','2013-06-23','09:25:00',2.45),('9303','2013-06-23','09:30:00',2.77),('9303','2013-06-23','09:35:00',2.81),('9303','2013-06-23','09:40:00',3.22),('9303','2013-06-23','09:45:00',2),('9303','2013-06-23','09:50:00',1.06),('9303','2013-06-23','09:55:00',1.57),('9303','2013-06-23','10:00:00',2.97),('9303','2013-06-23','10:05:00',2.92),('9303','2013-06-23','10:10:00',1.47),('9303','2013-06-23','10:15:00',1.75),('9303','2013-06-23','10:20:00',1.66),('9303','2013-06-23','10:35:00',1.01),('9303','2013-06-23','10:40:00',2.3),('9303','2013-06-23','10:45:00',3.54),('9303','2013-06-23','10:50:00',3.57),('9303','2013-06-23','10:55:00',3.44),('9303','2013-06-23','11:00:00',3.27),('9303','2013-06-23','11:05:00',3.47),('9303','2013-06-23','11:10:00',3.6),('9303','2013-06-23','11:15:00',3.66),('9303','2013-06-23','11:20:00',3.64),('9303','2013-06-23','11:25:00',3.69),('9303','2013-06-23','11:30:00',3.7),('9303','2013-06-23','11:35:00',3.7),('9303','2013-06-23','11:40:00',3.72),('9303','2013-06-23','11:45:00',3.74),('9303','2013-06-23','11:50:00',3.87),('9303','2013-06-23','11:55:00',3.85),('9303','2013-06-23','12:00:00',2.76),('9303','2013-06-23','12:05:00',3.43),('9303','2013-06-23','12:10:00',4.06),('9303','2013-06-23','12:15:00',4.05),('9303','2013-06-23','12:20:00',4.05),('9303','2013-06-23','12:25:00',3.54),('9303','2013-06-23','12:30:00',4.09),('9303','2013-06-23','12:35:00',4.07),('9303','2013-06-23','12:40:00',4.09),('9303','2013-06-23','12:45:00',4.07),('9303','2013-06-23','12:50:00',4.08),('9303','2013-06-23','12:55:00',4.11),('9303','2013-06-23','13:00:00',4.14),('9303','2013-06-23','13:05:00',4.14),('9303','2013-06-23','13:10:00',4.12),('9303','2013-06-23','13:15:00',4.12),('9303','2013-06-23','13:20:00',4.09),('9303','2013-06-23','13:25:00',4.12),('9303','2013-06-23','13:30:00',4.11),('9303','2013-06-23','13:35:00',4.12),('9303','2013-06-23','13:40:00',4.12),('9303','2013-06-23','13:45:00',4.13),('9303','2013-06-23','13:50:00',4.11),('9303','2013-06-23','13:55:00',4.1),('9303','2013-06-23','14:00:00',4.09),('9303','2013-06-23','14:05:00',4.09),('9303','2013-06-23','14:10:00',4.05),('9303','2013-06-23','14:15:00',4.01),('9303','2013-06-23','14:20:00',4.01),('9303','2013-06-23','14:25:00',4.03),('9303','2013-06-23','14:30:00',4),('9303','2013-06-23','14:35:00',3.98),('9303','2013-06-23','14:40:00',3.96),('9303','2013-06-23','14:45:00',3.94),('9303','2013-06-23','14:50:00',3.91),('9303','2013-06-23','14:55:00',3.89),('9303','2013-06-23','15:00:00',3.88),('9303','2013-06-23','15:05:00',3.85),('9303','2013-06-23','15:10:00',3.81),('9303','2013-06-23','15:15:00',3.77),('9303','2013-06-23','15:20:00',3.73),('9303','2013-06-23','15:25:00',3.69),('9303','2013-06-23','15:30:00',3.6),('9303','2013-06-23','15:35:00',3.55),('9303','2013-06-23','15:40:00',3.51),('9303','2013-06-23','15:45:00',3.51),('9303','2013-06-23','15:50:00',3.46),('9303','2013-06-23','15:55:00',3.37),('9303','2013-06-23','16:00:00',3.3),('9303','2013-06-23','16:05:00',3.28),('9303','2013-06-23','16:10:00',3.19),('9303','2013-06-23','16:15:00',3.11),('9303','2013-06-23','16:20:00',3.05),('9303','2013-06-23','16:25:00',3),('9303','2013-06-23','16:30:00',2.96),('9303','2013-06-23','16:35:00',2.89),('9303','2013-06-23','16:40:00',2.86),('9303','2013-06-23','16:45:00',2.76),('9303','2013-06-23','16:50:00',2.71),('9303','2013-06-23','16:55:00',2.63),('9303','2013-06-23','17:00:00',2.57),('9303','2013-06-23','17:05:00',2.51),('9303','2013-06-23','17:10:00',2.45),('9303','2013-06-23','17:15:00',2.32),('9303','2013-06-23','17:20:00',2.06),('9303','2013-06-23','17:25:00',1.77),('9303','2013-06-23','17:30:00',1.91),('9303','2013-06-23','17:35:00',1.89),('9303','2013-06-23','17:40:00',1.84),('9303','2013-06-23','17:45:00',1.53),('9303','2013-06-23','17:50:00',1.73),('9303','2013-06-23','17:55:00',1.64),('9303','2013-06-23','18:00:00',1.53),('9303','2013-06-23','18:05:00',1.42),('9303','2013-06-23','18:10:00',1.32),('9303','2013-06-23','18:15:00',1.21),('9303','2013-06-23','18:20:00',1.12),('9303','2013-06-22','07:50:00',1.05),('9303','2013-06-22','07:55:00',1.12),('9303','2013-06-22','08:00:00',1.2),('9303','2013-06-22','08:05:00',1.27),('9303','2013-06-22','08:10:00',1.36),('9303','2013-06-22','08:15:00',1.43),('9303','2013-06-22','08:20:00',1.52),('9303','2013-06-22','08:25:00',1.61),('9303','2013-06-22','08:30:00',1.69),('9303','2013-06-22','08:35:00',1.78),('9303','2013-06-22','08:40:00',1.86),('9303','2013-06-22','08:45:00',1.92),('9303','2013-06-22','08:50:00',1.97),('9303','2013-06-22','08:55:00',2.06),('9303','2013-06-22','09:00:00',2.13),('9303','2013-06-22','09:05:00',2.21),('9303','2013-06-22','09:10:00',2.29),('9303','2013-06-22','09:15:00',2.36),('9303','2013-06-22','09:20:00',2.42),('9303','2013-06-22','09:25:00',2.46),('9303','2013-06-22','09:30:00',2.53),('9303','2013-06-22','09:35:00',2.6),('9303','2013-06-22','09:40:00',2.66),('9303','2013-06-22','09:45:00',2.7),('9303','2013-06-22','09:50:00',2.76),('9303','2013-06-22','09:55:00',2.82),('9303','2013-06-22','10:00:00',2.9),('9303','2013-06-22','10:05:00',2.97),('9303','2013-06-22','10:10:00',3.02),('9303','2013-06-22','10:15:00',3.07),('9303','2013-06-22','10:20:00',3.14),('9303','2013-06-22','10:25:00',3.18),('9303','2013-06-22','10:30:00',3.2),('9303','2013-06-22','10:35:00',3.24),('9303','2013-06-22','10:40:00',3.33),('9303','2013-06-22','10:45:00',3.4),('9303','2013-06-22','10:50:00',3.41),('9303','2013-06-22','10:55:00',3.45),('9303','2013-06-22','11:00:00',3.48),('9303','2013-06-22','11:05:00',3.52),('9303','2013-06-22','11:10:00',3.56),('9303','2013-06-22','11:15:00',3.61),('9303','2013-06-22','11:20:00',3.63),('9303','2013-06-22','11:25:00',3.65),('9303','2013-06-22','11:30:00',3.68),('9303','2013-06-22','11:35:00',3.7),('9303','2013-06-22','11:40:00',3.72),('9303','2013-06-22','11:45:00',3.73),('9303','2013-06-22','11:50:00',3.72),('9303','2013-06-22','11:55:00',3.75),('9303','2013-06-22','12:00:00',3.8),('9303','2013-06-22','12:05:00',3.75),('9303','2013-06-22','12:10:00',3.69),('9303','2013-06-22','12:15:00',3.86),('9303','2013-06-22','12:20:00',3.84),('9303','2013-06-22','12:25:00',3.79),('9303','2013-06-22','12:30:00',3.87),('9303','2013-06-22','12:35:00',3.89),('9303','2013-06-22','12:40:00',3.91),('9303','2013-06-22','12:45:00',3.86),('9303','2013-06-22','12:50:00',3.8),('9303','2013-06-22','12:55:00',3.8),('9303','2013-06-22','13:00:00',3.75),('9303','2013-06-22','13:05:00',3.78),('9303','2013-06-22','13:10:00',3.75),('9303','2013-06-22','13:15:00',3.73),('9303','2013-06-22','13:20:00',3.62),('9303','2013-06-22','13:25:00',3.83),('9303','2013-06-22','13:30:00',4.09),('9303','2013-06-22','13:35:00',4.12),('9303','2013-06-22','13:40:00',3.74),('9303','2013-06-22','13:45:00',3.86),('9303','2013-06-22','13:50:00',4.08),('9303','2013-06-22','13:55:00',3.08),('9303','2013-06-22','14:00:00',2.21),('9303','2013-06-22','14:05:00',4.36),('9303','2013-06-22','14:10:00',4.18),('9303','2013-06-22','14:15:00',4.1),('9303','2013-06-22','14:20:00',3.31),('9303','2013-06-22','14:25:00',4.07),('9303','2013-06-22','14:30:00',2.81),('9303','2013-06-22','14:35:00',2.23),('9303','2013-06-22','14:40:00',1.64),('9303','2013-06-22','14:45:00',1.98),('9303','2013-06-22','14:50:00',3.1),('9303','2013-06-22','14:55:00',3.84),('9303','2013-06-22','15:00:00',3.67),('9303','2013-06-22','15:05:00',3.16),('9303','2013-06-22','15:10:00',3.51),('9303','2013-06-22','15:15:00',3.86),('9303','2013-06-22','15:20:00',3.53),('9303','2013-06-22','15:25:00',3.33),('9303','2013-06-22','15:30:00',2.28),('9303','2013-06-22','15:35:00',1.96),('9303','2013-06-22','15:40:00',2.04),('9303','2013-06-22','15:45:00',2.6),('9303','2013-06-22','15:50:00',2.44),('9303','2013-06-22','15:55:00',2.33),('9303','2013-06-22','16:00:00',1.86),('9303','2013-06-22','16:05:00',1.17),('9303','2013-06-22','16:10:00',1.13),('9303','2013-06-22','16:15:00',1.41),('9303','2013-06-22','16:20:00',1.74),('9303','2013-06-22','16:25:00',1.22),('9303','2013-06-22','16:55:00',1.04),('9303','2013-06-22','17:00:00',1.38),('9303','2013-06-22','17:05:00',1.32),('9303','2013-06-22','17:10:00',1.7),('9303','2013-06-22','17:15:00',2.57),('9303','2013-06-22','17:20:00',2.45),('9303','2013-06-22','17:25:00',2.32),('9303','2013-06-22','17:30:00',2.01),('9303','2013-06-22','17:35:00',1.52),('9303','2013-06-22','17:40:00',1.82),('9303','2013-06-22','17:45:00',1.82),('9303','2013-06-22','17:50:00',1.66),('9303','2013-06-22','17:55:00',1.63),('9303','2013-06-22','18:00:00',1.5),('9303','2013-06-22','18:05:00',1.21),('9303','2013-06-21','07:50:00',1.06),('9303','2013-06-21','07:55:00',1.14),('9303','2013-06-21','08:00:00',1.21),('9303','2013-06-21','08:05:00',1.28),('9303','2013-06-21','08:10:00',1.38),('9303','2013-06-21','08:15:00',1.45),('9303','2013-06-21','08:20:00',1.52),('9303','2013-06-21','08:25:00',1.59),('9303','2013-06-21','08:30:00',1.67),('9303','2013-06-21','08:35:00',1.76),('9303','2013-06-21','08:40:00',1.83),('9303','2013-06-21','08:45:00',1.88),('9303','2013-06-21','08:50:00',1.94),('9303','2013-06-21','08:55:00',2.01),('9303','2013-06-21','09:00:00',2.07),('9303','2013-06-21','09:05:00',2.17),('9303','2013-06-21','09:10:00',2.23),('9303','2013-06-21','09:15:00',2.26),('9303','2013-06-21','09:20:00',2.32),('9303','2013-06-21','09:25:00',2.4),('9303','2013-06-21','09:30:00',2.44),('9303','2013-06-21','09:35:00',2.51),('9303','2013-06-21','09:40:00',2.53),('9303','2013-06-21','09:45:00',2.57),('9303','2013-06-21','09:50:00',2.63),('9303','2013-06-21','09:55:00',2.68),('9303','2013-06-21','10:00:00',2.68),('9303','2013-06-21','10:05:00',2.75),('9303','2013-06-21','10:10:00',2.8),('9303','2013-06-21','10:15:00',2.86),('9303','2013-06-21','10:20:00',2.95),('9303','2013-06-21','10:25:00',2.97),('9303','2013-06-21','10:30:00',3),('9303','2013-06-21','10:35:00',2.98),('9303','2013-06-21','10:40:00',3.02),('9303','2013-06-21','10:45:00',3.07),('9303','2013-06-21','10:50:00',3.15),('9303','2013-06-21','10:55:00',3.22),('9303','2013-06-21','11:00:00',3.22),('9303','2013-06-21','11:05:00',3.24),('9303','2013-06-21','11:10:00',3.24),('9303','2013-06-21','11:15:00',3.29),('9303','2013-06-21','11:20:00',3.37),('9303','2013-06-21','11:25:00',3.43),('9303','2013-06-21','11:30:00',3.44),('9303','2013-06-21','11:35:00',3.45),('9303','2013-06-21','11:40:00',3.5),('9303','2013-06-21','11:45:00',3.49),('9303','2013-06-21','11:50:00',3.54),('9303','2013-06-21','11:55:00',3.6),('9303','2013-06-21','12:00:00',3.61),('9303','2013-06-21','12:05:00',3.6),('9303','2013-06-21','12:10:00',3.59),('9303','2013-06-21','12:15:00',3.61),('9303','2013-06-21','12:20:00',3.57),('9303','2013-06-21','12:25:00',3.64),('9303','2013-06-21','12:30:00',3.65),('9303','2013-06-21','12:35:00',3.6),('9303','2013-06-21','12:40:00',3.58),('9303','2013-06-21','12:45:00',3.63),('9303','2013-06-21','12:50:00',3.59),('9303','2013-06-21','12:55:00',3.61),('9303','2013-06-21','13:00:00',3.61),('9303','2013-06-21','13:05:00',3.54),('9303','2013-06-21','13:10:00',3.61),('9303','2013-06-21','13:15:00',3.62),('9303','2013-06-21','13:20:00',3.62),('9303','2013-06-21','13:25:00',3.7),('9303','2013-06-21','13:30:00',3.71),('9303','2013-06-21','13:35:00',3.74),('9303','2013-06-21','13:40:00',3.7),('9303','2013-06-21','13:45:00',3.68),('9303','2013-06-21','13:50:00',3.73),('9303','2013-06-21','13:55:00',3.71),('9303','2013-06-21','14:00:00',3.69),('9303','2013-06-21','14:05:00',3.73),('9303','2013-06-21','14:10:00',3.75),('9303','2013-06-21','14:15:00',3.74),('9303','2013-06-21','14:20:00',3.74),('9303','2013-06-21','14:25:00',3.75),('9303','2013-06-21','14:30:00',3.75),('9303','2013-06-21','14:35:00',3.72),('9303','2013-06-21','14:40:00',3.7),('9303','2013-06-21','14:45:00',3.7),('9303','2013-06-21','14:50:00',3.67),('9303','2013-06-21','14:55:00',3.66),('9303','2013-06-21','15:00:00',3.63),('9303','2013-06-21','15:05:00',3.57),('9303','2013-06-21','15:10:00',3.52),('9303','2013-06-21','15:15:00',3.5),('9303','2013-06-21','15:20:00',3.47),('9303','2013-06-21','15:25:00',3.41),('9303','2013-06-21','15:30:00',3.4),('9303','2013-06-21','15:35:00',3.34),('9303','2013-06-21','15:40:00',3.3),('9303','2013-06-21','15:45:00',3.26),('9303','2013-06-21','15:50:00',3.21),('9303','2013-06-21','15:55:00',3.16),('9303','2013-06-21','16:00:00',3.11),('9303','2013-06-21','16:05:00',3.07),('9303','2013-06-21','16:10:00',3.02),('9303','2013-06-21','16:15:00',2.97),('9303','2013-06-21','16:20:00',2.91),('9303','2013-06-21','16:25:00',2.86),('9303','2013-06-21','16:30:00',2.8),('9303','2013-06-21','16:35:00',2.74),('9303','2013-06-21','16:40:00',2.67),('9303','2013-06-21','16:45:00',2.63),('9303','2013-06-21','16:50:00',2.56),('9303','2013-06-21','16:55:00',2.49),('9303','2013-06-21','17:00:00',2.42),('9303','2013-06-21','17:05:00',2.36),('9303','2013-06-21','17:10:00',2.3),('9303','2013-06-21','17:15:00',2.2),('9303','2013-06-21','17:20:00',2.09),('9303','2013-06-21','17:25:00',1.97),('9303','2013-06-21','17:30:00',1.8),('9303','2013-06-21','17:35:00',1.76),('9303','2013-06-21','17:40:00',1.74),('9303','2013-06-21','17:45:00',1.66),('9303','2013-06-21','17:50:00',1.59),('9303','2013-06-21','17:55:00',1.5),('9303','2013-06-21','18:00:00',1.41),('9303','2013-06-21','18:05:00',1.33),('9303','2013-06-21','18:10:00',1.25),('9303','2013-06-21','18:15:00',1.17),('9303','2013-06-21','18:20:00',1.08),('9303','2014-04-04','09:05:00',1.08),('9303','2014-04-04','09:10:00',1.41),('9303','2014-04-04','09:15:00',1.26),('9303','2014-04-04','13:20:00',1.61),('9303','2014-04-04','13:25:00',2.34),('9303','2014-04-04','13:30:00',1.81),('9303','2014-04-04','13:35:00',2.42),('9303','2014-04-04','13:40:00',2.64),('9303','2014-04-04','13:45:00',2.96),('9303','2014-04-04','13:50:00',3.18),('9303','2014-04-04','13:55:00',2.52),('9303','2014-04-04','14:00:00',1.99),('9303','2014-04-04','14:05:00',4.5),('9303','2014-04-04','14:10:00',3.46),('9303','2014-04-04','14:15:00',3.71),('9303','2014-04-04','14:20:00',3),('9303','2014-04-04','14:25:00',3.38),('9303','2014-04-04','14:30:00',1.19),('9303','2014-04-04','14:35:00',2.34),('9303','2014-04-04','14:40:00',1.96),('9303','2014-04-04','14:45:00',1.31),('9303','2014-04-04','14:50:00',2.59),('9303','2014-04-04','14:55:00',3.3),('9303','2014-04-04','15:00:00',4.02),('9303','2014-04-04','15:05:00',4.01),('9303','2014-04-04','15:10:00',3.69),('9303','2014-04-04','15:15:00',3.29),('9303','2014-04-04','15:20:00',2.35),('9303','2014-04-04','15:25:00',1.9),('9303','2014-04-04','15:30:00',1.31),('9303','2014-04-04','15:35:00',1.83),('9303','2014-04-04','15:40:00',2.06),('9303','2014-04-04','15:45:00',2.13),('9303','2014-04-04','15:50:00',1.67),('9303','2014-04-04','15:55:00',2.71),('9303','2014-04-04','16:00:00',3.14),('9303','2014-04-04','16:05:00',2.37),('9303','2014-04-04','16:10:00',3.25),('9303','2014-04-04','16:15:00',1.48),('9303','2014-04-04','16:20:00',1.04),('9303','2014-04-04','16:30:00',1.87),('9303','2014-04-04','16:35:00',1.49),('9303','2014-04-04','16:40:00',1.23),('9303','2014-04-04','16:45:00',2.47),('9303','2014-04-04','16:50:00',2.95),('9303','2014-04-04','16:55:00',1.81),('9303','2014-04-04','17:00:00',1.82),('9303','2014-04-04','17:05:00',1.87),('9303','2014-04-04','17:10:00',1.9),('9303','2014-04-04','17:15:00',1.83),('9303','2014-04-04','17:20:00',1.67),('9303','2014-04-04','17:25:00',1.78),('9303','2014-04-04','17:30:00',1.95),('9303','2014-04-04','17:35:00',1.76),('9303','2014-04-04','17:40:00',1.24),('9303','2014-04-04','17:45:00',1.4),('9303','2014-04-04','17:50:00',1.34),('9303','2014-04-04','17:55:00',1.16),('9303','2014-04-04','18:00:00',1.01),('9303','2013-06-20','07:55:00',1.07),('9303','2013-06-20','08:00:00',1.16),('9303','2013-06-20','08:05:00',1.25),('9303','2013-06-20','08:10:00',1.36),('9303','2013-06-20','08:15:00',1.45),('9303','2013-06-20','08:20:00',1.54),('9303','2013-06-20','08:25:00',1.6),('9303','2013-06-20','08:30:00',1.68),('9303','2013-06-20','08:35:00',1.77),('9303','2013-06-20','08:40:00',1.84),('9303','2013-06-20','08:45:00',1.91),('9303','2013-06-20','08:50:00',1.98),('9303','2013-06-20','08:55:00',2.04),('9303','2013-06-20','09:00:00',2.1),('9303','2013-06-20','09:05:00',2.2),('9303','2013-06-20','09:10:00',2.27),('9303','2013-06-20','09:15:00',2.33),('9303','2013-06-20','09:20:00',2.39),('9303','2013-06-20','09:25:00',2.46),('9303','2013-06-20','09:30:00',2.52),('9303','2013-06-20','09:35:00',2.59),('9303','2013-06-20','09:40:00',2.63),('9303','2013-06-20','09:45:00',2.68),('9303','2013-06-20','09:50:00',2.74),('9303','2013-06-20','09:55:00',2.79),('9303','2013-06-20','10:00:00',2.86),('9303','2013-06-20','10:05:00',2.89),('9303','2013-06-20','10:10:00',2.96),('9303','2013-06-20','10:15:00',3.01),('9303','2013-06-20','10:20:00',3.06),('9303','2013-06-20','10:25:00',3.11),('9303','2013-06-20','10:30:00',3.16),('9303','2013-06-20','10:35:00',3.16),('9303','2013-06-20','10:40:00',3.23),('9303','2013-06-20','10:45:00',3.24),('9303','2013-06-20','10:50:00',3.25),('9303','2013-06-20','10:55:00',3.27),('9303','2013-06-20','11:00:00',3.27),('9303','2013-06-20','11:05:00',3.32),('9303','2013-06-20','11:10:00',3.39),('9303','2013-06-20','11:15:00',3.39),('9303','2013-06-20','11:20:00',3.42),('9303','2013-06-20','11:25:00',3.42),('9303','2013-06-20','11:30:00',3.45),('9303','2013-06-20','11:35:00',3.46),('9303','2013-06-20','11:40:00',3.51),('9303','2013-06-20','11:45:00',3.58),('9303','2013-06-20','11:50:00',3.57),('9303','2013-06-20','11:55:00',3.51),('9303','2013-06-20','12:00:00',3.56),('9303','2013-06-20','12:05:00',3.56),('9303','2013-06-20','12:10:00',3.62),('9303','2013-06-20','12:15:00',3.55),('9303','2013-06-20','12:20:00',3.51),('9303','2013-06-20','12:25:00',3.59),('9303','2013-06-20','12:30:00',3.65),('9303','2013-06-20','12:35:00',3.87),('9303','2013-06-20','12:40:00',3.9),('9303','2013-06-20','12:45:00',3.83),('9303','2013-06-20','12:50:00',3.78),('9303','2013-06-20','12:55:00',3.2),('9303','2013-06-20','13:00:00',2.81),('9303','2013-06-20','13:05:00',3.65),('9303','2013-06-20','13:10:00',3.97),('9303','2013-06-20','13:15:00',3.82),('9303','2013-06-20','13:20:00',3.61),('9303','2013-06-20','13:25:00',3.51),('9303','2013-06-20','13:30:00',3.18),('9303','2013-06-20','13:35:00',3.83),('9303','2013-06-20','13:40:00',3.8),('9303','2013-06-20','13:45:00',3.79),('9303','2013-06-20','13:50:00',3.83),('9303','2013-06-20','13:55:00',3.82),('9303','2013-06-20','14:00:00',3.86),('9303','2013-06-20','14:05:00',3.91),('9303','2013-06-20','14:10:00',3.87),('9303','2013-06-20','14:15:00',3.87),('9303','2013-06-20','14:20:00',3.85),('9303','2013-06-20','14:25:00',3.83),('9303','2013-06-20','14:30:00',3.81),('9303','2013-06-20','14:35:00',3.86),('9303','2013-06-20','14:40:00',3.85),('9303','2013-06-20','14:45:00',3.81),('9303','2013-06-20','14:50:00',3.83),('9303','2013-06-20','14:55:00',3.76),('9303','2013-06-20','15:00:00',3.71),('9303','2013-06-20','15:05:00',3.68),('9303','2013-06-20','15:10:00',3.64),('9303','2013-06-20','15:15:00',3.59),('9303','2013-06-20','15:20:00',3.54),('9303','2013-06-20','15:25:00',3.51),('9303','2013-06-20','15:30:00',3.48),('9303','2013-06-20','15:35:00',3.42),('9303','2013-06-20','15:40:00',3.35),('9303','2013-06-20','15:45:00',3.32),('9303','2013-06-20','15:50:00',3.26),('9303','2013-06-20','15:55:00',3.22),('9303','2013-06-20','16:00:00',3.18),('9303','2013-06-20','16:05:00',3.13),('9303','2013-06-20','16:10:00',3.08),('9303','2013-06-20','16:15:00',3.01),('9303','2013-06-20','16:20:00',2.95),('9303','2013-06-20','16:25:00',2.9),('9303','2013-06-20','16:30:00',2.85),('9303','2013-06-20','16:35:00',2.78),('9303','2013-06-20','16:40:00',2.71),('9303','2013-06-20','16:45:00',2.62),('9303','2013-06-20','16:50:00',2.58),('9303','2013-06-20','16:55:00',2.53),('9303','2013-06-20','17:00:00',2.48),('9303','2013-06-20','17:05:00',2.41),('9303','2013-06-20','17:10:00',2.33),('9303','2013-06-20','17:15:00',2.22),('9303','2013-06-20','17:20:00',2.12),('9303','2013-06-20','17:25:00',2),('9303','2013-06-20','17:30:00',1.87),('9303','2013-06-20','17:35:00',1.84),('9303','2013-06-20','17:40:00',1.77),('9303','2013-06-20','17:45:00',1.69),('9303','2013-06-20','17:50:00',1.61),('9303','2013-06-20','17:55:00',1.54),('9303','2013-06-20','18:00:00',1.46),('9303','2013-06-20','18:05:00',1.37),('9303','2013-06-20','18:10:00',1.25),('9303','2013-06-20','18:15:00',1.15),('9303','2013-06-20','18:20:00',1.05),('9303','2013-06-19','07:50:00',1.02),('9303','2013-06-19','07:55:00',1.09),('9303','2013-06-19','08:00:00',1.18),('9303','2013-06-19','08:05:00',1.26),('9303','2013-06-19','08:10:00',1.36),('9303','2013-06-19','08:15:00',1.42),('9303','2013-06-19','08:20:00',1.5),('9303','2013-06-19','08:25:00',1.58),('9303','2013-06-19','08:30:00',1.65),('9303','2013-06-19','08:35:00',1.72),('9303','2013-06-19','08:40:00',1.78),('9303','2013-06-19','08:45:00',1.85),('9303','2013-06-19','08:50:00',1.93),('9303','2013-06-19','08:55:00',2.01),('9303','2013-06-19','09:00:00',2.07),('9303','2013-06-19','09:05:00',2.16),('9303','2013-06-19','09:10:00',2.24),('9303','2013-06-19','09:15:00',2.3),('9303','2013-06-19','09:20:00',2.36),('9303','2013-06-19','09:25:00',2.43),('9303','2013-06-19','09:30:00',2.48),('9303','2013-06-19','09:35:00',2.54),('9303','2013-06-19','09:40:00',2.57),('9303','2013-06-19','09:45:00',2.63),('9303','2013-06-19','09:50:00',2.68),('9303','2013-06-19','09:55:00',2.73),('9303','2013-06-19','10:00:00',2.78),('9303','2013-06-19','10:05:00',2.83),('9303','2013-06-19','10:10:00',2.88),('9303','2013-06-19','10:15:00',2.93),('9303','2013-06-19','10:20:00',2.97),('9303','2013-06-19','10:25:00',2.99),('9303','2013-06-19','10:30:00',3.02),('9303','2013-06-19','10:35:00',3.06),('9303','2013-06-19','10:40:00',3.11),('9303','2013-06-19','10:45:00',3.15),('9303','2013-06-19','10:50:00',3.17),('9303','2013-06-19','10:55:00',3.21),('9303','2013-06-19','11:00:00',3.25),('9303','2013-06-19','11:05:00',3.27),('9303','2013-06-19','11:10:00',3.27),('9303','2013-06-19','11:15:00',3.34),('9303','2013-06-19','11:20:00',3.33),('9303','2013-06-19','11:25:00',3.41),('9303','2013-06-19','11:30:00',3.42),('9303','2013-06-19','11:35:00',3.41),('9303','2013-06-19','11:40:00',3.43),('9303','2013-06-19','11:45:00',3.45),('9303','2013-06-19','11:50:00',3.48),('9303','2013-06-19','11:55:00',3.52),('9303','2013-06-19','12:00:00',3.51),('9303','2013-06-19','12:05:00',3.54),('9303','2013-06-19','12:10:00',3.58),('9303','2013-06-19','12:15:00',3.54),('9303','2013-06-19','12:20:00',3.52),('9303','2013-06-19','12:25:00',3.56),('9303','2013-06-19','12:30:00',3.67),('9303','2013-06-19','12:35:00',3.67),('9303','2013-06-19','12:40:00',3.66),('9303','2013-06-19','12:45:00',3.74),('9303','2013-06-19','12:50:00',3.78),('9303','2013-06-19','12:55:00',3.73),('9303','2013-06-19','13:00:00',3.7),('9303','2013-06-19','13:05:00',3.7),('9303','2013-06-19','13:10:00',3.7),('9303','2013-06-19','13:15:00',3.66),('9303','2013-06-19','13:20:00',3.7),('9303','2013-06-19','13:25:00',3.79),('9303','2013-06-19','13:30:00',3.78),('9303','2013-06-19','13:35:00',3.79),('9303','2013-06-19','13:40:00',3.79),('9303','2013-06-19','13:45:00',3.78),('9303','2013-06-19','13:50:00',3.74),('9303','2013-06-19','13:55:00',3.8),('9303','2013-06-19','14:00:00',3.8),('9303','2013-06-19','14:05:00',3.79),('9303','2013-06-19','14:10:00',3.75),('9303','2013-06-19','14:15:00',3.71),('9303','2013-06-19','14:20:00',3.7),('9303','2013-06-19','14:25:00',3.67),('9303','2013-06-19','14:30:00',3.64),('9303','2013-06-19','14:35:00',3.62),('9303','2013-06-19','14:40:00',3.59),('9303','2013-06-19','14:45:00',3.55),('9303','2013-06-19','14:50:00',3.52),('9303','2013-06-19','14:55:00',3.51),('9303','2013-06-19','15:00:00',3.49),('9303','2013-06-19','15:05:00',3.47),('9303','2013-06-19','15:10:00',3.44),('9303','2013-06-19','15:15:00',3.42),('9303','2013-06-19','15:20:00',3.39),('9303','2013-06-19','15:25:00',3.32),('9303','2013-06-19','15:30:00',3.29),('9303','2013-06-19','15:35:00',3.23),('9303','2013-06-19','15:40:00',3.2),('9303','2013-06-19','15:45:00',3.15),('9303','2013-06-19','15:50:00',3.08),('9303','2013-06-19','15:55:00',3.01),('9303','2013-06-19','16:00:00',2.98),('9303','2013-06-19','16:05:00',2.93),('9303','2013-06-19','16:10:00',2.88),('9303','2013-06-19','16:15:00',2.83),('9303','2013-06-19','16:20:00',2.79),('9303','2013-06-19','16:25:00',2.72),('9303','2013-06-19','16:30:00',2.67),('9303','2013-06-19','16:35:00',2.6),('9303','2013-06-19','16:40:00',2.55),('9303','2013-06-19','16:45:00',2.49),('9303','2013-06-19','16:50:00',2.46),('9303','2013-06-19','16:55:00',2.39),('9303','2013-06-19','17:00:00',2.33),('9303','2013-06-19','17:05:00',2.28),('9303','2013-06-19','17:10:00',2.23),('9303','2013-06-19','17:15:00',2.14),('9303','2013-06-19','17:20:00',2.05),('9303','2013-06-19','17:25:00',1.94),('9303','2013-06-19','17:30:00',1.79),('9303','2013-06-19','17:35:00',1.76),('9303','2013-06-19','17:40:00',1.7),('9303','2013-06-19','17:45:00',1.62),('9303','2013-06-19','17:50:00',1.55),('9303','2013-06-19','17:55:00',1.48),('9303','2013-06-19','18:00:00',1.38),('9303','2013-06-19','18:05:00',1.29),('9303','2013-06-19','18:10:00',1.17),('9303','2013-06-19','18:15:00',1.08),('9303','2013-06-18','07:50:00',1.02),('9303','2013-06-18','07:55:00',1.09),('9303','2013-06-18','08:00:00',1.17),('9303','2013-06-18','08:05:00',1.25),('9303','2013-06-18','08:10:00',1.34),('9303','2013-06-18','08:15:00',1.42),('9303','2013-06-18','08:20:00',1.48),('9303','2013-06-18','08:25:00',1.55),('9303','2013-06-18','08:30:00',1.63),('9303','2013-06-18','08:35:00',1.71),('9303','2013-06-18','08:40:00',1.77),('9303','2013-06-18','08:45:00',1.83),('9303','2013-06-18','08:50:00',1.91),('9303','2013-06-18','08:55:00',1.97),('9303','2013-06-18','09:00:00',2.05),('9303','2013-06-18','09:05:00',2.13),('9303','2013-06-18','09:10:00',2.2),('9303','2013-06-18','09:15:00',2.27),('9303','2013-06-18','09:20:00',2.32),('9303','2013-06-18','09:25:00',2.38),('9303','2013-06-18','09:30:00',2.44),('9303','2013-06-18','09:35:00',2.5),('9303','2013-06-18','09:40:00',2.56),('9303','2013-06-18','09:45:00',2.62),('9303','2013-06-18','09:50:00',2.65),('9303','2013-06-18','09:55:00',2.7),('9303','2013-06-18','10:00:00',2.79),('9303','2013-06-18','10:05:00',2.81),('9303','2013-06-18','10:10:00',2.88),('9303','2013-06-18','10:15:00',2.92),('9303','2013-06-18','10:20:00',2.95),('9303','2013-06-18','10:25:00',2.97),('9303','2013-06-18','10:30:00',2.99),('9303','2013-06-18','10:35:00',3.01),('9303','2013-06-18','10:40:00',3.04),('9303','2013-06-18','10:45:00',3.1),('9303','2013-06-18','10:50:00',3.2),('9303','2013-06-18','10:55:00',3.24),('9303','2013-06-18','11:00:00',3.24),('9303','2013-06-18','11:05:00',3.31),('9303','2013-06-18','11:10:00',3.3),('9303','2013-06-18','11:15:00',3.31),('9303','2013-06-18','11:20:00',3.36),('9303','2013-06-18','11:25:00',3.44),('9303','2013-06-18','11:30:00',3.43),('9303','2013-06-18','11:35:00',3.45),('9303','2013-06-18','11:40:00',3.43),('9303','2013-06-18','11:45:00',3.45),('9303','2013-06-18','11:50:00',3.48),('9303','2013-06-18','11:55:00',3.48),('9303','2013-06-18','12:00:00',3.51),('9303','2013-06-18','12:05:00',3.55),('9303','2013-06-18','12:10:00',3.57),('9303','2013-06-18','12:15:00',3.49),('9303','2013-06-18','12:20:00',3.53),('9303','2013-06-18','12:25:00',3.52),('9303','2013-06-18','12:30:00',3.47),('9303','2013-06-18','12:35:00',3.58),('9303','2013-06-18','12:40:00',3.3),('9303','2013-06-18','12:45:00',2.6),('9303','2013-06-18','12:55:00',2.34),('9303','2013-06-18','13:00:00',3.29),('9303','2013-06-18','13:05:00',3.02),('9303','2013-06-18','13:10:00',2.52),('9303','2013-06-18','13:15:00',3.83),('9303','2013-06-18','13:20:00',3.88),('9303','2013-06-18','13:25:00',3.76),('9303','2013-06-18','13:30:00',3.26),('9303','2013-06-18','13:35:00',3.55),('9303','2013-06-18','13:40:00',3.78),('9303','2013-06-18','13:45:00',3.76),('9303','2013-06-18','13:50:00',3.81),('9303','2013-06-18','13:55:00',3.84),('9303','2013-06-18','14:00:00',3.79),('9303','2013-06-18','14:05:00',3.78),('9303','2013-06-18','14:10:00',3.75),('9303','2013-06-18','14:15:00',3.74),('9303','2013-06-18','14:20:00',3.69),('9303','2013-06-18','14:25:00',3.63),('9303','2013-06-18','14:30:00',3.67),('9303','2013-06-18','14:35:00',3.66),('9303','2013-06-18','14:40:00',3.75),('9303','2013-06-18','14:45:00',3.72),('9303','2013-06-18','14:50:00',3.69),('9303','2013-06-18','14:55:00',3.65),('9303','2013-06-18','15:00:00',3.63),('9303','2013-06-18','15:05:00',3.53),('9303','2013-06-18','15:10:00',3.53),('9303','2013-06-18','15:15:00',3.46),('9303','2013-06-18','15:20:00',3.42),('9303','2013-06-18','15:25:00',3.38),('9303','2013-06-18','15:30:00',3.33),('9303','2013-06-18','15:35:00',3.31),('9303','2013-06-18','15:40:00',3.3),('9303','2013-06-18','15:45:00',3.26),('9303','2013-06-18','15:50:00',3.22),('9303','2013-06-18','15:55:00',3.19),('9303','2013-06-18','16:00:00',3.16),('9303','2013-06-18','16:05:00',3.12),('9303','2013-06-18','16:10:00',3.09),('9303','2013-06-18','16:15:00',3.06),('9303','2013-06-18','16:20:00',3.01),('9303','2013-06-18','16:25:00',2.86),('9303','2013-06-18','16:30:00',2.72),('9303','2013-06-18','16:35:00',2.68),('9303','2013-06-18','16:40:00',2.67),('9303','2013-06-18','16:45:00',2.57),('9303','2013-06-18','16:50:00',2.51),('9303','2013-06-18','16:55:00',2.45),('9303','2013-06-18','17:00:00',2.39),('9303','2013-06-18','17:05:00',2.33),('9303','2013-06-18','17:10:00',2.26),('9303','2013-06-18','17:15:00',2.15),('9303','2013-06-18','17:20:00',2.05),('9303','2013-06-18','17:25:00',1.91),('9303','2013-06-18','17:30:00',1.73),('9303','2013-06-18','17:35:00',1.69),('9303','2013-06-18','17:40:00',1.69),('9303','2013-06-18','17:45:00',1.63),('9303','2013-06-18','17:50:00',1.57),('9303','2013-06-18','17:55:00',1.49),('9303','2013-06-18','18:00:00',1.4),('9303','2013-06-18','18:05:00',1.32),('9303','2013-06-18','18:10:00',1.2),('9303','2013-06-18','18:15:00',1.11),('9303','2013-06-18','18:20:00',1.05),('9303','2013-06-17','07:50:00',1.07),('9303','2013-06-17','07:55:00',1.15),('9303','2013-06-17','08:00:00',1.23),('9303','2013-06-17','08:05:00',1.31),('9303','2013-06-17','08:10:00',1.41),('9303','2013-06-17','08:15:00',1.48),('9303','2013-06-17','08:20:00',1.56),('9303','2013-06-17','08:25:00',1.64),('9303','2013-06-17','08:30:00',1.72),('9303','2013-06-17','08:35:00',1.79),('9303','2013-06-17','08:40:00',1.87),('9303','2013-06-17','08:45:00',1.94),('9303','2013-06-17','08:50:00',2.01),('9303','2013-06-17','08:55:00',2.09),('9303','2013-06-17','09:00:00',2.16),('9303','2013-06-17','09:05:00',2.25),('9303','2013-06-17','09:10:00',2.31),('9303','2013-06-17','09:15:00',2.38),('9303','2013-06-17','09:20:00',2.45),('9303','2013-06-17','09:25:00',2.49),('9303','2013-06-17','09:30:00',2.57),('9303','2013-06-17','09:35:00',2.63),('9303','2013-06-17','09:40:00',2.7),('9303','2013-06-17','09:45:00',2.74),('9303','2013-06-17','09:50:00',2.79),('9303','2013-06-17','09:55:00',2.84),('9303','2013-06-17','10:00:00',2.88),('9303','2013-06-17','10:05:00',2.89),('9303','2013-06-17','10:10:00',2.96),('9303','2013-06-17','10:15:00',3.02),('9303','2013-06-17','10:20:00',3.05),('9303','2013-06-17','10:25:00',3.09),('9303','2013-06-17','10:30:00',3.15),('9303','2013-06-17','10:35:00',3.21),('9303','2013-06-17','10:40:00',3.27),('9303','2013-06-17','10:45:00',3.34),('9303','2013-06-17','10:50:00',3.33),('9303','2013-06-17','10:55:00',3.35),('9303','2013-06-17','11:00:00',3.38),('9303','2013-06-17','11:05:00',3.42),('9303','2013-06-17','11:10:00',3.45),('9303','2013-06-17','11:15:00',3.47),('9303','2013-06-17','11:20:00',3.51),('9303','2013-06-17','11:25:00',3.51),('9303','2013-06-17','11:30:00',3.54),('9303','2013-06-17','11:35:00',3.59),('9303','2013-06-17','11:40:00',3.6),('9303','2013-06-17','11:45:00',3.56),('9303','2013-06-17','11:50:00',3.59),('9303','2013-06-17','11:55:00',3.57),('9303','2013-06-17','12:00:00',3.62),('9303','2013-06-17','12:05:00',3.61),('9303','2013-06-17','12:10:00',3.63),('9303','2013-06-17','12:15:00',3.64),('9303','2013-06-17','12:20:00',3.64),('9303','2013-06-17','12:25:00',3.66),('9303','2013-06-17','12:30:00',3.66),('9303','2013-06-17','12:35:00',3.67),('9303','2013-06-17','12:40:00',3.71),('9303','2013-06-17','12:45:00',3.72),('9303','2013-06-17','12:50:00',3.8),('9303','2013-06-17','12:55:00',3.81),('9303','2013-06-17','13:00:00',3.89),('9303','2013-06-17','13:05:00',3.93),('9303','2013-06-17','13:10:00',3.9),('9303','2013-06-17','13:15:00',3.9),('9303','2013-06-17','13:20:00',3.87),('9303','2013-06-17','13:25:00',3.86),('9303','2013-06-17','13:30:00',3.88),('9303','2013-06-17','13:35:00',3.86),('9303','2013-06-17','13:40:00',3.84),('9303','2013-06-17','13:45:00',3.82),('9303','2013-06-17','13:50:00',3.81),('9303','2013-06-17','13:55:00',3.81),('9303','2013-06-17','14:00:00',3.79),('9303','2013-06-17','14:05:00',3.77),('9303','2013-06-17','14:10:00',3.8),('9303','2013-06-17','14:15:00',3.75),('9303','2013-06-17','14:20:00',3.78),('9303','2013-06-17','14:25:00',3.74),('9303','2013-06-17','14:30:00',3.72),('9303','2013-06-17','14:35:00',3.71),('9303','2013-06-17','14:40:00',3.69),('9303','2013-06-17','14:45:00',3.65),('9303','2013-06-17','14:50:00',3.6),('9303','2013-06-17','14:55:00',3.58),('9303','2013-06-17','15:00:00',3.55),('9303','2013-06-17','15:05:00',3.5),('9303','2013-06-17','15:10:00',3.47),('9303','2013-06-17','15:15:00',3.43),('9303','2013-06-17','15:20:00',3.41),('9303','2013-06-17','15:25:00',3.37),('9303','2013-06-17','15:30:00',3.33),('9303','2013-06-17','15:35:00',3.31),('9303','2013-06-17','15:40:00',3.27),('9303','2013-06-17','15:45:00',3.21),('9303','2013-06-17','15:50:00',3.16),('9303','2013-06-17','15:55:00',3.11),('9303','2013-06-17','16:00:00',3.08),('9303','2013-06-17','16:05:00',3.03),('9303','2013-06-17','16:10:00',2.98),('9303','2013-06-17','16:15:00',2.93),('9303','2013-06-17','16:20:00',2.88),('9303','2013-06-17','16:25:00',2.82),('9303','2013-06-17','16:30:00',2.78),('9303','2013-06-17','16:35:00',2.73),('9303','2013-06-17','16:40:00',2.66),('9303','2013-06-17','16:45:00',2.59),('9303','2013-06-17','16:50:00',2.54),('9303','2013-06-17','16:55:00',2.47),('9303','2013-06-17','17:00:00',2.42),('9303','2013-06-17','17:05:00',2.36),('9303','2013-06-17','17:10:00',2.28),('9303','2013-06-17','17:15:00',2.18),('9303','2013-06-17','17:20:00',2.08),('9303','2013-06-17','17:25:00',1.96),('9303','2013-06-17','17:30:00',1.81),('9303','2013-06-17','17:35:00',1.8),('9303','2013-06-17','17:40:00',1.75),('9303','2013-06-17','17:45:00',1.69),('9303','2013-06-17','17:50:00',1.61),('9303','2013-06-17','17:55:00',1.53),('9303','2013-06-17','18:00:00',1.45),('9303','2013-06-17','18:05:00',1.36),('9303','2013-06-17','18:10:00',1.23),('9303','2013-06-17','18:15:00',1.15),('9303','2013-06-17','18:20:00',1.07),('9303','2013-06-16','07:45:00',1.03),('9303','2013-06-16','07:50:00',1.11),('9303','2013-06-16','07:55:00',1.19),('9303','2013-06-16','08:00:00',1.26),('9303','2013-06-16','08:05:00',1.35),('9303','2013-06-16','08:10:00',1.45),('9303','2013-06-16','08:15:00',1.52),('9303','2013-06-16','08:20:00',1.59),('9303','2013-06-16','08:25:00',1.67),('9303','2013-06-16','08:30:00',1.76),('9303','2013-06-16','08:35:00',1.84),('9303','2013-06-16','08:40:00',1.9),('9303','2013-06-16','08:45:00',1.98),('9303','2013-06-16','08:50:00',2.06),('9303','2013-06-16','08:55:00',2.14),('9303','2013-06-16','09:00:00',2.22),('9303','2013-06-16','09:05:00',2.32),('9303','2013-06-16','09:10:00',2.36),('9303','2013-06-16','09:15:00',2.44),('9303','2013-06-16','09:20:00',2.51),('9303','2013-06-16','09:25:00',2.58),('9303','2013-06-16','09:30:00',2.62),('9303','2013-06-16','09:35:00',2.69),('9303','2013-06-16','09:40:00',2.73),('9303','2013-06-16','09:45:00',2.77),('9303','2013-06-16','09:50:00',2.82),('9303','2013-06-16','09:55:00',2.83),('9303','2013-06-16','10:00:00',2.91),('9303','2013-06-16','10:05:00',2.96),('9303','2013-06-16','10:10:00',3.01),('9303','2013-06-16','10:15:00',3.08),('9303','2013-06-16','10:20:00',3.15),('9303','2013-06-16','10:25:00',3.18),('9303','2013-06-16','10:30:00',3.23),('9303','2013-06-16','10:35:00',3.27),('9303','2013-06-16','10:40:00',3.33),('9303','2013-06-16','10:45:00',3.38),('9303','2013-06-16','10:50:00',3.4),('9303','2013-06-16','10:55:00',3.41),('9303','2013-06-16','11:00:00',3.43),('9303','2013-06-16','11:05:00',3.48),('9303','2013-06-16','11:10:00',3.51),('9303','2013-06-16','11:15:00',3.56),('9303','2013-06-16','11:20:00',3.59),('9303','2013-06-16','11:25:00',3.6),('9303','2013-06-16','11:30:00',3.6),('9303','2013-06-16','11:35:00',3.65),('9303','2013-06-16','11:40:00',3.7),('9303','2013-06-16','11:45:00',3.75),('9303','2013-06-16','11:50:00',3.79),('9303','2013-06-16','11:55:00',3.82),('9303','2013-06-16','12:00:00',3.82),('9303','2013-06-16','12:05:00',3.81),('9303','2013-06-16','12:10:00',3.82),('9303','2013-06-16','12:15:00',3.82),('9303','2013-06-16','12:20:00',3.85),('9303','2013-06-16','12:25:00',3.86),('9303','2013-06-16','12:30:00',3.87),('9303','2013-06-16','12:35:00',3.83),('9303','2013-06-16','12:40:00',3.82),('9303','2013-06-16','12:45:00',3.82),('9303','2013-06-16','12:50:00',3.89),('9303','2013-06-16','12:55:00',3.95),('9303','2013-06-16','13:00:00',3.97),('9303','2013-06-16','13:05:00',4),('9303','2013-06-16','13:10:00',4),('9303','2013-06-16','13:15:00',4),('9303','2013-06-16','13:20:00',3.97),('9303','2013-06-16','13:25:00',3.99),('9303','2013-06-16','13:30:00',3.98),('9303','2013-06-16','13:35:00',4.01),('9303','2013-06-16','13:40:00',3.98),('9303','2013-06-16','13:45:00',3.97),('9303','2013-06-16','13:50:00',3.97),('9303','2013-06-16','13:55:00',3.96),('9303','2013-06-16','14:00:00',3.98),('9303','2013-06-16','14:05:00',3.95),('9303','2013-06-16','14:10:00',3.93),('9303','2013-06-16','14:15:00',3.92),('9303','2013-06-16','14:20:00',3.87),('9303','2013-06-16','14:25:00',3.87),('9303','2013-06-16','14:30:00',3.82),('9303','2013-06-16','14:35:00',3.79),('9303','2013-06-16','14:40:00',3.73),('9303','2013-06-16','14:45:00',3.72),('9303','2013-06-16','14:50:00',3.69),('9303','2013-06-16','14:55:00',3.67),('9303','2013-06-16','15:00:00',3.63),('9303','2013-06-16','15:05:00',3.63),('9303','2013-06-16','15:10:00',3.6),('9303','2013-06-16','15:15:00',3.57),('9303','2013-06-16','15:20:00',3.54),('9303','2013-06-16','15:25:00',3.49),('9303','2013-06-16','15:30:00',3.45),('9303','2013-06-16','15:35:00',3.41),('9303','2013-06-16','15:40:00',3.37),('9303','2013-06-16','15:45:00',3.31),('9303','2013-06-16','15:50:00',3.26),('9303','2013-06-16','15:55:00',3.21),('9303','2013-06-16','16:00:00',3.15),('9303','2013-06-16','16:05:00',3.1),('9303','2013-06-16','16:10:00',3.06),('9303','2013-06-16','16:15:00',2.99),('9303','2013-06-16','16:20:00',2.95),('9303','2013-06-16','16:25:00',2.89),('9303','2013-06-16','16:30:00',2.83),('9303','2013-06-16','16:35:00',2.77),('9303','2013-06-16','16:40:00',2.72),('9303','2013-06-16','16:45:00',2.65),('9303','2013-06-16','16:50:00',2.59),('9303','2013-06-16','16:55:00',2.52),('9303','2013-06-16','17:00:00',2.44),('9303','2013-06-16','17:05:00',2.38),('9303','2013-06-16','17:10:00',2.31),('9303','2013-06-16','17:15:00',2.19),('9303','2013-06-16','17:20:00',2.08),('9303','2013-06-16','17:25:00',1.94),('9303','2013-06-16','17:30:00',1.79),('9303','2013-06-16','17:35:00',1.8),('9303','2013-06-16','17:40:00',1.73),('9303','2013-06-16','17:45:00',1.66),('9303','2013-06-16','17:50:00',1.58),('9303','2013-06-16','17:55:00',1.5),('9303','2013-06-16','18:00:00',1.41),('9303','2013-06-16','18:05:00',1.32),('9303','2013-06-16','18:10:00',1.2),('9303','2013-06-16','18:15:00',1.1),('9303','2013-06-16','18:20:00',1.01),('9303','2013-06-15','07:50:00',1.07),('9303','2013-06-15','07:55:00',1.13),('9303','2013-06-15','08:00:00',1.21),('9303','2013-06-15','08:05:00',1.3),('9303','2013-06-15','08:10:00',1.4),('9303','2013-06-15','08:15:00',1.49),('9303','2013-06-15','08:20:00',1.57),('9303','2013-06-15','08:25:00',1.68),('9303','2013-06-15','08:30:00',1.77),('9303','2013-06-15','08:35:00',1.8),('9303','2013-06-15','08:40:00',1.85),('9303','2013-06-15','08:45:00',1.94),('9303','2013-06-15','08:50:00',1.76),('9303','2013-06-15','08:55:00',1.96),('9303','2013-06-15','09:00:00',2.06),('9303','2013-06-15','09:05:00',2.29),('9303','2013-06-15','09:10:00',2.3),('9303','2013-06-15','09:15:00',2.29),('9303','2013-06-15','09:20:00',1.96),('9303','2013-06-15','09:25:00',2.51),('9303','2013-06-15','09:30:00',2.57),('9303','2013-06-15','09:35:00',1.82),('9303','2013-06-15','09:40:00',2.69),('9303','2013-06-15','09:45:00',2.82),('9303','2013-06-15','09:50:00',2.84),('9303','2013-06-15','09:55:00',2.83),('9303','2013-06-15','10:00:00',1.96),('9303','2013-06-15','10:10:00',2.56),('9303','2013-06-15','10:15:00',3.07),('9303','2013-06-15','10:20:00',3.23),('9303','2013-06-15','10:25:00',3.13),('9303','2013-06-15','10:30:00',3.23),('9303','2013-06-15','10:35:00',3.22),('9303','2013-06-15','10:40:00',3.18),('9303','2013-06-15','10:45:00',3.48),('9303','2013-06-15','10:50:00',3.5),('9303','2013-06-15','10:55:00',3.18),('9303','2013-06-15','11:00:00',1.72),('9303','2013-06-15','11:05:00',2.52),('9303','2013-06-15','11:10:00',1.65),('9303','2013-06-15','11:15:00',2.97),('9303','2013-06-15','11:20:00',3.49),('9303','2013-06-15','11:25:00',2.77),('9303','2013-06-15','11:30:00',3.41),('9303','2013-06-15','11:35:00',3.74),('9303','2013-06-15','11:40:00',2.61),('9303','2013-06-15','11:45:00',2.88),('9303','2013-06-15','11:50:00',4.08),('9303','2013-06-15','11:55:00',3.94),('9303','2013-06-15','12:00:00',3.08),('9303','2013-06-15','12:05:00',3.94),('9303','2013-06-15','12:10:00',4.03),('9303','2013-06-15','12:15:00',4.02),('9303','2013-06-15','12:20:00',3.99),('9303','2013-06-15','12:25:00',3.99),('9303','2013-06-15','12:30:00',3.96),('9303','2013-06-15','12:35:00',4.02),('9303','2013-06-15','12:40:00',3.99),('9303','2013-06-15','12:45:00',3.98),('9303','2013-06-15','12:50:00',3.99),('9303','2013-06-15','12:55:00',3.99),('9303','2013-06-15','13:00:00',4.02),('9303','2013-06-15','13:05:00',4),('9303','2013-06-15','13:10:00',4.02),('9303','2013-06-15','13:15:00',4.05),('9303','2013-06-15','13:20:00',4),('9303','2013-06-15','13:25:00',3.97),('9303','2013-06-15','13:30:00',3.98),('9303','2013-06-15','13:35:00',3.95),('9303','2013-06-15','13:40:00',3.99),('9303','2013-06-15','13:45:00',4),('9303','2013-06-15','13:50:00',3.98),('9303','2013-06-15','13:55:00',3.95),('9303','2013-06-15','14:00:00',3.92),('9303','2013-06-15','14:05:00',3.88),('9303','2013-06-15','14:10:00',3.88),('9303','2013-06-15','14:15:00',3.87),('9303','2013-06-15','14:20:00',3.86),('9303','2013-06-15','14:25:00',3.83),('9303','2013-06-15','14:30:00',3.76),('9303','2013-06-15','14:35:00',3.68),('9303','2013-06-15','14:40:00',3.73),('9303','2013-06-15','14:45:00',3.71),('9303','2013-06-15','14:50:00',3.62),('9303','2013-06-15','14:55:00',3.66),('9303','2013-06-15','15:00:00',3.63),('9303','2013-06-15','15:05:00',3.63),('9303','2013-06-15','15:10:00',3.61),('9303','2013-06-15','15:15:00',3.57),('9303','2013-06-15','15:20:00',3.53),('9303','2013-06-15','15:25:00',3.51),('9303','2013-06-15','15:30:00',3.48),('9303','2013-06-15','15:35:00',3.43),('9303','2013-06-15','15:40:00',3.37),('9303','2013-06-15','15:45:00',3.33),('9303','2013-06-15','15:50:00',3.24),('9303','2013-06-15','15:55:00',3.21),('9303','2013-06-15','16:00:00',3.16),('9303','2013-06-15','16:05:00',3.11),('9303','2013-06-15','16:10:00',3.05),('9303','2013-06-15','16:15:00',2.99),('9303','2013-06-15','16:20:00',2.94),('9303','2013-06-15','16:25:00',2.88),('9303','2013-06-15','16:30:00',2.81),('9303','2013-06-15','16:35:00',2.76),('9303','2013-06-15','16:40:00',2.68),('9303','2013-06-15','16:45:00',2.63),('9303','2013-06-15','16:50:00',2.56),('9303','2013-06-15','16:55:00',2.5),('9303','2013-06-15','17:00:00',2.43),('9303','2013-06-15','17:05:00',2.36),('9303','2013-06-15','17:10:00',2.27),('9303','2013-06-15','17:15:00',2.15),('9303','2013-06-15','17:20:00',2.04),('9303','2013-06-15','17:25:00',1.91),('9303','2013-06-15','17:30:00',1.74),('9303','2013-06-15','17:35:00',1.77),('9303','2013-06-15','17:40:00',1.7),('9303','2013-06-15','17:45:00',1.61),('9303','2013-06-15','17:50:00',1.54),('9303','2013-06-15','17:55:00',1.45),('9303','2013-06-15','18:00:00',1.37),('9303','2013-06-15','18:05:00',1.28),('9303','2013-06-15','18:10:00',1.15),('9303','2013-06-15','18:15:00',1.08),('9303','2013-06-14','07:40:00',1.02),('9303','2013-06-14','07:45:00',1.1),('9303','2013-06-14','07:50:00',1.18),('9303','2013-06-14','07:55:00',1.27),('9303','2013-06-14','08:00:00',1.35),('9303','2013-06-14','08:05:00',1.44),('9303','2013-06-14','08:10:00',1.55),('9303','2013-06-14','08:15:00',1.62),('9303','2013-06-14','08:20:00',1.7),('9303','2013-06-14','08:25:00',1.77),('9303','2013-06-14','08:30:00',1.85),('9303','2013-06-14','08:35:00',1.93),('9303','2013-06-14','08:40:00',2.01),('9303','2013-06-14','08:45:00',2.09),('9303','2013-06-14','08:50:00',2.16),('9303','2013-06-14','08:55:00',2.23),('9303','2013-06-14','09:00:00',2.31),('9303','2013-06-14','09:05:00',2.39),('9303','2013-06-14','09:10:00',2.47),('9303','2013-06-14','09:15:00',2.53),('9303','2013-06-14','09:20:00',2.59),('9303','2013-06-14','09:25:00',2.67),('9303','2013-06-14','09:30:00',2.73),('9303','2013-06-14','09:35:00',2.81),('9303','2013-06-14','09:40:00',2.87),('9303','2013-06-14','09:45:00',2.93),('9303','2013-06-14','09:50:00',3.01),('9303','2013-06-14','09:55:00',3.07),('9303','2013-06-14','10:00:00',3.12),('9303','2013-06-14','10:05:00',3.12),('9303','2013-06-14','10:10:00',3.14),('9303','2013-06-14','10:15:00',3.19),('9303','2013-06-14','10:20:00',3.26),('9303','2013-06-14','10:25:00',3.28),('9303','2013-06-14','10:30:00',3.34),('9303','2013-06-14','10:35:00',3.45),('9303','2013-06-14','10:40:00',3.46),('9303','2013-06-14','10:45:00',3.48),('9303','2013-06-14','10:50:00',3.51),('9303','2013-06-14','10:55:00',3.51),('9303','2013-06-14','11:00:00',3.5),('9303','2013-06-14','11:05:00',3.54),('9303','2013-06-14','11:10:00',3.63),('9303','2013-06-14','11:15:00',3.69),('9303','2013-06-14','11:20:00',3.66),('9303','2013-06-14','11:25:00',3.62),('9303','2013-06-14','11:30:00',3.79),('9303','2013-06-14','11:35:00',3.81),('9303','2013-06-14','11:40:00',3.85),('9303','2013-06-14','11:45:00',3.84),('9303','2013-06-14','11:50:00',3.83),('9303','2013-06-14','11:55:00',3.83),('9303','2013-06-14','12:00:00',3.82),('9303','2013-06-14','12:05:00',3.82),('9303','2013-06-14','12:10:00',3.87),('9303','2013-06-14','12:15:00',3.9),('9303','2013-06-14','12:20:00',3.95),('9303','2013-06-14','12:25:00',3.94),('9303','2013-06-14','12:30:00',3.98),('9303','2013-06-14','12:35:00',3.92),('9303','2013-06-14','12:40:00',3.87),('9303','2013-06-14','12:45:00',3.94),('9303','2013-06-14','12:50:00',3.88),('9303','2013-06-14','12:55:00',3.89),('9303','2013-06-14','13:00:00',3.9),('9303','2013-06-14','13:05:00',3.91),('9303','2013-06-14','13:10:00',3.16),('9303','2013-06-14','13:15:00',3.29),('9303','2013-06-14','13:20:00',3.92),('9303','2013-06-14','13:25:00',1.97),('9303','2013-06-14','13:30:00',3.79),('9303','2013-06-14','13:35:00',3.97),('9303','2013-06-14','13:40:00',3.93),('9303','2013-06-14','13:45:00',3.92),('9303','2013-06-14','13:50:00',3.94),('9303','2013-06-14','13:55:00',3.93),('9303','2013-06-14','14:00:00',3.86),('9303','2013-06-14','14:05:00',4),('9303','2013-06-14','14:10:00',3.99),('9303','2013-06-14','14:15:00',3.92),('9303','2013-06-14','14:20:00',3.89),('9303','2013-06-14','14:25:00',3.87),('9303','2013-06-14','14:30:00',3.85),('9303','2013-06-14','14:35:00',3.85),('9303','2013-06-14','14:40:00',3.8),('9303','2013-06-14','14:45:00',3.75),('9303','2013-06-14','14:50:00',3.74),('9303','2013-06-14','14:55:00',3.72),('9303','2013-06-14','15:00:00',3.68),('9303','2013-06-14','15:05:00',3.66),('9303','2013-06-14','15:10:00',3.68),('9303','2013-06-14','15:15:00',3.63),('9303','2013-06-14','15:20:00',3.59),('9303','2013-06-14','15:25:00',3.56),('9303','2013-06-14','15:30:00',3.51),('9303','2013-06-14','15:35:00',3.48),('9303','2013-06-14','15:40:00',3.44),('9303','2013-06-14','15:45:00',3.42),('9303','2013-06-14','15:50:00',3.35),('9303','2013-06-14','15:55:00',3.29),('9303','2013-06-14','16:00:00',3.21),('9303','2013-06-14','16:05:00',3.17),('9303','2013-06-14','16:10:00',3.12),('9303','2013-06-14','16:15:00',3.06),('9303','2013-06-14','16:20:00',3),('9303','2013-06-14','16:25:00',2.93),('9303','2013-06-14','16:30:00',2.87),('9303','2013-06-14','16:35:00',2.81),('9303','2013-06-14','16:40:00',2.73),('9303','2013-06-14','16:45:00',2.68),('9303','2013-06-14','16:50:00',2.62),('9303','2013-06-14','16:55:00',2.54),('9303','2013-06-14','17:00:00',2.5),('9303','2013-06-14','17:05:00',2.36),('9303','2013-06-14','17:10:00',2.31),('9303','2013-06-14','17:15:00',2.26),('9303','2013-06-14','17:20:00',2.11),('9303','2013-06-14','17:25:00',1.96),('9303','2013-06-14','17:30:00',1.77),('9303','2013-06-14','17:35:00',1.54),('9303','2013-06-14','17:40:00',1.66),('9303','2013-06-14','17:45:00',1.7),('9303','2013-06-14','17:50:00',1.63),('9303','2013-06-14','17:55:00',1.54),('9303','2013-06-14','18:00:00',1.45),('9303','2013-06-14','18:05:00',1.35),('9303','2013-06-14','18:10:00',1.23),('9303','2013-06-14','18:15:00',1.14),('9303','2013-06-14','18:20:00',1.05),('9303','2013-06-13','07:40:00',1.03),('9303','2013-06-13','07:45:00',1.11),('9303','2013-06-13','07:50:00',1.2),('9303','2013-06-13','07:55:00',1.29),('9303','2013-06-13','08:00:00',1.38),('9303','2013-06-13','08:05:00',1.47),('9303','2013-06-13','08:10:00',1.57),('9303','2013-06-13','08:15:00',1.65),('9303','2013-06-13','08:20:00',1.72),('9303','2013-06-13','08:25:00',1.79),('9303','2013-06-13','08:30:00',1.86),('9303','2013-06-13','08:35:00',1.93),('9303','2013-06-13','08:40:00',2.01),('9303','2013-06-13','08:45:00',2.09),('9303','2013-06-13','08:50:00',2.16),('9303','2013-06-13','08:55:00',2.23),('9303','2013-06-13','09:00:00',2.32),('9303','2013-06-13','09:05:00',2.42),('9303','2013-06-13','09:10:00',2.49),('9303','2013-06-13','09:15:00',2.56),('9303','2013-06-13','09:20:00',2.66),('9303','2013-06-13','09:25:00',2.75),('9303','2013-06-13','09:30:00',2.83),('9303','2013-06-13','09:35:00',2.9),('9303','2013-06-13','09:40:00',2.96),('9303','2013-06-13','09:45:00',3.02),('9303','2013-06-13','09:50:00',3.08),('9303','2013-06-13','09:55:00',3.14),('9303','2013-06-13','10:00:00',3.18),('9303','2013-06-13','10:05:00',3.25),('9303','2013-06-13','10:10:00',3.29),('9303','2013-06-13','10:15:00',3.34),('9303','2013-06-13','10:20:00',3.38),('9303','2013-06-13','10:25:00',3.44),('9303','2013-06-13','10:30:00',3.48),('9303','2013-06-13','10:35:00',3.51),('9303','2013-06-13','10:40:00',3.53),('9303','2013-06-13','10:45:00',3.6),('9303','2013-06-13','10:50:00',3.65),('9303','2013-06-13','10:55:00',3.7),('9303','2013-06-13','11:00:00',3.74),('9303','2013-06-13','11:05:00',3.74),('9303','2013-06-13','11:10:00',3.75),('9303','2013-06-13','11:15:00',3.79),('9303','2013-06-13','11:20:00',3.84),('9303','2013-06-13','11:25:00',3.89),('9303','2013-06-13','11:30:00',3.92),('9303','2013-06-13','11:35:00',3.96),('9303','2013-06-13','11:40:00',3.96),('9303','2013-06-13','11:45:00',4.02),('9303','2013-06-13','11:50:00',4.03),('9303','2013-06-13','11:55:00',4.04),('9303','2013-06-13','12:00:00',4.05),('9303','2013-06-13','12:05:00',4.09),('9303','2013-06-13','12:10:00',4.1),('9303','2013-06-13','12:15:00',4.1),('9303','2013-06-13','12:20:00',4.11),('9303','2013-06-13','12:25:00',4.1),('9303','2013-06-13','12:30:00',4.14),('9303','2013-06-13','12:35:00',4.13),('9303','2013-06-13','12:40:00',4.15),('9303','2013-06-13','12:45:00',4.16),('9303','2013-06-13','12:50:00',4.17),('9303','2013-06-13','12:55:00',4.18),('9303','2013-06-13','13:00:00',4.16),('9303','2013-06-13','13:05:00',4.15),('9303','2013-06-13','13:10:00',4.16),('9303','2013-06-13','13:15:00',4.22),('9303','2013-06-13','13:20:00',4.19),('9303','2013-06-13','13:25:00',4.15),('9303','2013-06-13','13:30:00',4.16),('9303','2013-06-13','13:35:00',4.16),('9303','2013-06-13','13:40:00',4.17),('9303','2013-06-13','13:45:00',4.14),('9303','2013-06-13','13:50:00',4.13),('9303','2013-06-13','13:55:00',4.11),('9303','2013-06-13','14:00:00',4.08),('9303','2013-06-13','14:05:00',4.09),('9303','2013-06-13','14:10:00',4.12),('9303','2013-06-13','14:15:00',4.14),('9303','2013-06-13','14:20:00',4.07),('9303','2013-06-13','14:25:00',4.11),('9303','2013-06-13','14:30:00',2.39),('9303','2013-06-13','14:35:00',3.33),('9303','2013-06-13','14:40:00',4.05),('9303','2013-06-13','14:45:00',3.95),('9303','2013-06-13','14:50:00',3.86),('9303','2013-06-13','14:55:00',3.81),('9303','2013-06-13','15:00:00',3.77),('9303','2013-06-13','15:05:00',3.72),('9303','2013-06-13','15:10:00',3.66),('9303','2013-06-13','15:15:00',3.63),('9303','2013-06-13','15:20:00',3.58),('9303','2013-06-13','15:25:00',3.56),('9303','2013-06-13','15:30:00',3.51),('9303','2013-06-13','15:35:00',3.47),('9303','2013-06-13','15:40:00',3.44),('9303','2013-06-13','15:45:00',3.38),('9303','2013-06-13','15:50:00',3.35),('9303','2013-06-13','15:55:00',3.3),('9303','2013-06-13','16:00:00',3.24),('9303','2013-06-13','16:05:00',3.16),('9303','2013-06-13','16:10:00',3.11),('9303','2013-06-13','16:15:00',3.04),('9303','2013-06-13','16:20:00',2.97),('9303','2013-06-13','16:25:00',2.9),('9303','2013-06-13','16:30:00',2.88),('9303','2013-06-13','16:35:00',2.79),('9303','2013-06-13','16:40:00',2.75),('9303','2013-06-13','16:45:00',2.69),('9303','2013-06-13','16:50:00',2.6),('9303','2013-06-13','16:55:00',2.55),('9303','2013-06-13','17:00:00',2.45),('9303','2013-06-13','17:05:00',2.39),('9303','2013-06-13','17:10:00',2.32),('9303','2013-06-13','17:15:00',2.23),('9303','2013-06-13','17:20:00',2.13),('9303','2013-06-13','17:25:00',1.98),('9303','2013-06-13','17:30:00',1.91),('9303','2013-06-13','17:35:00',1.85),('9303','2013-06-13','17:40:00',1.76),('9303','2013-06-13','17:45:00',1.67),('9303','2013-06-13','17:50:00',1.61),('9303','2013-06-13','17:55:00',1.51),('9303','2013-06-13','18:00:00',1.41),('9303','2013-06-13','18:05:00',1.32),('9303','2013-06-13','18:10:00',1.21),('9303','2013-06-13','18:15:00',1.12),('9303','2013-06-13','18:20:00',1.04),('9303','2013-06-12','07:40:00',1.03),('9303','2013-06-12','07:45:00',1.12),('9303','2013-06-12','07:50:00',1.21),('9303','2013-06-12','07:55:00',1.3),('9303','2013-06-12','08:00:00',1.39),('9303','2013-06-12','08:05:00',1.49),('9303','2013-06-12','08:10:00',1.59),('9303','2013-06-12','08:15:00',1.67),('9303','2013-06-12','08:20:00',1.75),('9303','2013-06-12','08:25:00',1.83),('9303','2013-06-12','08:30:00',1.92),('9303','2013-06-12','08:35:00',2),('9303','2013-06-12','08:40:00',2.08),('9303','2013-06-12','08:45:00',2.14),('9303','2013-06-12','08:50:00',2.24),('9303','2013-06-12','08:55:00',2.31),('9303','2013-06-12','09:00:00',2.41),('9303','2013-06-12','09:05:00',2.5),('9303','2013-06-12','09:10:00',2.58),('9303','2013-06-12','09:15:00',2.66),('9303','2013-06-12','09:20:00',2.71),('9303','2013-06-12','09:25:00',2.77),('9303','2013-06-12','09:30:00',2.84),('9303','2013-06-12','09:35:00',2.9),('9303','2013-06-12','09:40:00',2.97),('9303','2013-06-12','09:45:00',3.02),('9303','2013-06-12','09:50:00',3.08),('9303','2013-06-12','09:55:00',3.14),('9303','2013-06-12','10:00:00',3.16),('9303','2013-06-12','10:05:00',3.22),('9303','2013-06-12','10:10:00',3.26),('9303','2013-06-12','10:15:00',3.33),('9303','2013-06-12','10:20:00',3.42),('9303','2013-06-12','10:25:00',3.45),('9303','2013-06-12','10:30:00',3.48),('9303','2013-06-12','10:35:00',3.49),('9303','2013-06-12','10:40:00',3.54),('9303','2013-06-12','10:45:00',3.62),('9303','2013-06-12','10:50:00',3.69),('9303','2013-06-12','10:55:00',3.77),('9303','2013-06-12','11:00:00',3.8),('9303','2013-06-12','11:05:00',3.84),('9303','2013-06-12','11:10:00',3.9),('9303','2013-06-12','11:15:00',3.92),('9303','2013-06-12','11:20:00',3.91),('9303','2013-06-12','11:25:00',3.92),('9303','2013-06-12','11:30:00',3.95),('9303','2013-06-12','11:35:00',4),('9303','2013-06-12','11:40:00',4.01),('9303','2013-06-12','11:45:00',4.02),('9303','2013-06-12','11:50:00',4.03),('9303','2013-06-12','11:55:00',4.09),('9303','2013-06-12','12:00:00',4.09),('9303','2013-06-12','12:05:00',4.1),('9303','2013-06-12','12:10:00',4.12),('9303','2013-06-12','12:15:00',4.2),('9303','2013-06-12','12:20:00',4.21),('9303','2013-06-12','12:25:00',3.14),('9303','2013-06-12','12:30:00',3.55),('9303','2013-06-12','12:35:00',4.08),('9303','2013-06-12','12:40:00',1.76),('9303','2013-06-12','12:45:00',2.91),('9303','2013-06-12','12:50:00',4.49),('9303','2013-06-12','12:55:00',4.04),('9303','2013-06-12','13:00:00',3.08),('9303','2013-06-12','13:05:00',3.83),('9303','2013-06-12','13:10:00',4.25),('9303','2013-06-12','13:15:00',4.16),('9303','2013-06-12','13:20:00',4.12),('9303','2013-06-12','13:25:00',4.09),('9303','2013-06-12','13:30:00',4.18),('9303','2013-06-12','13:35:00',4.21),('9303','2013-06-12','13:40:00',4.19),('9303','2013-06-12','13:45:00',4.19),('9303','2013-06-12','13:50:00',4.16),('9303','2013-06-12','13:55:00',4.27),('9303','2013-06-12','14:00:00',4.04),('9303','2013-06-12','14:05:00',2.04),('9303','2013-06-12','14:10:00',3.25),('9303','2013-06-12','14:15:00',4.35),('9303','2013-06-12','14:20:00',2.01),('9303','2013-06-12','14:25:00',1.96),('9303','2013-06-12','14:30:00',4.27),('9303','2013-06-12','14:35:00',3.01),('9303','2013-06-12','14:40:00',3.88),('9303','2013-06-12','14:45:00',3.62),('9303','2013-06-12','14:50:00',4.13),('9303','2013-06-12','14:55:00',4.11),('9303','2013-06-12','15:00:00',4),('9303','2013-06-12','15:05:00',3.95),('9303','2013-06-12','15:10:00',3.89),('9303','2013-06-12','15:15:00',3.44),('9303','2013-06-12','15:20:00',3.83),('9303','2013-06-12','15:25:00',3.66),('9303','2013-06-12','15:30:00',3.62),('9303','2013-06-12','15:35:00',3.63),('9303','2013-06-12','15:40:00',3.58),('9303','2013-06-12','15:45:00',3.52),('9303','2013-06-12','15:50:00',3.44),('9303','2013-06-12','15:55:00',3.47),('9303','2013-06-12','16:00:00',3.36),('9303','2013-06-12','16:05:00',3.21),('9303','2013-06-12','16:10:00',3.28),('9303','2013-06-12','16:15:00',3.21),('9303','2013-06-12','16:20:00',3.1),('9303','2013-06-12','16:25:00',3.08),('9303','2013-06-12','16:30:00',3.02),('9303','2013-06-12','16:35:00',2.93),('9303','2013-06-12','16:40:00',2.86),('9303','2013-06-12','16:45:00',2.78),('9303','2013-06-12','16:50:00',2.74),('9303','2013-06-12','16:55:00',2.47),('9303','2013-06-12','17:00:00',2.53),('9303','2013-06-12','17:05:00',2.5),('9303','2013-06-12','17:10:00',2.41),('9303','2013-06-12','17:15:00',2.28),('9303','2013-06-12','17:20:00',2.15),('9303','2013-06-12','17:25:00',2.01),('9303','2013-06-12','17:30:00',1.85),('9303','2013-06-12','17:35:00',1.78),('9303','2013-06-12','17:40:00',1.85),('9303','2013-06-12','17:45:00',1.35),('9303','2013-06-12','18:05:00',1.44),('9303','2013-06-12','18:10:00',1.33),('9303','2013-06-12','18:15:00',1.28),('9303','2013-06-12','18:20:00',1.17),('9303','2013-06-11','08:10:00',1.04),('9303','2013-06-11','08:15:00',1.85),('9303','2013-06-11','08:20:00',1.95),('9303','2013-06-11','08:25:00',1.96),('9303','2013-06-11','08:30:00',2.01),('9303','2013-06-11','08:35:00',1.99),('9303','2013-06-11','08:40:00',2.22),('9303','2013-06-11','08:45:00',2.2),('9303','2013-06-11','08:50:00',2.35),('9303','2013-06-11','08:55:00',2.47),('9303','2013-06-11','09:00:00',2.52),('9303','2013-06-11','09:05:00',2.61),('9303','2013-06-11','09:10:00',2.68),('9303','2013-06-11','09:15:00',2.76),('9303','2013-06-11','09:20:00',2.84),('9303','2013-06-11','09:25:00',3.02),('9303','2013-06-11','09:30:00',2.46),('9303','2013-06-11','09:35:00',1.75),('9303','2013-06-11','09:40:00',1.25),('9303','2013-06-11','09:45:00',1.46),('9303','2013-06-11','09:50:00',3.09),('9303','2013-06-11','09:55:00',2.99),('9303','2013-06-11','10:00:00',2.54),('9303','2013-06-11','10:05:00',3.06),('9303','2013-06-11','10:10:00',2.61),('9303','2013-06-11','10:15:00',3.46),('9303','2013-06-11','10:20:00',3.52),('9303','2013-06-11','10:25:00',2.59),('9303','2013-06-11','10:30:00',3.67),('9303','2013-06-11','10:35:00',2.38),('9303','2013-06-11','10:40:00',2.25),('9303','2013-06-11','10:45:00',2.61),('9303','2013-06-11','10:50:00',3.88),('9303','2013-06-11','10:55:00',3.91),('9303','2013-06-11','11:00:00',4.01),('9303','2013-06-11','11:05:00',3.95),('9303','2013-06-11','11:10:00',3.39),('9303','2013-06-11','11:15:00',4.18),('9303','2013-06-11','11:20:00',4),('9303','2013-06-11','11:25:00',3.07),('9303','2013-06-11','11:30:00',3.97),('9303','2013-06-11','11:35:00',4.02),('9303','2013-06-11','11:40:00',4.05),('9303','2013-06-11','11:45:00',4.09),('9303','2013-06-11','11:50:00',4.12),('9303','2013-06-11','11:55:00',4.15),('9303','2013-06-11','12:00:00',3.76),('9303','2013-06-11','12:05:00',3.64),('9303','2013-06-11','12:10:00',4.26),('9303','2013-06-11','12:15:00',4.19),('9303','2013-06-11','12:20:00',4.03),('9303','2013-06-11','12:25:00',4.28),('9303','2013-06-11','12:30:00',4.3),('9303','2013-06-11','12:35:00',4.29),('9303','2013-06-11','12:40:00',4.27),('9303','2013-06-11','12:45:00',4.28),('9303','2013-06-11','12:50:00',4.32),('9303','2013-06-11','12:55:00',4.35),('9303','2013-06-11','13:00:00',4.36),('9303','2013-06-11','13:05:00',4.35),('9303','2013-06-11','13:10:00',4.36),('9303','2013-06-11','13:15:00',4.38),('9303','2013-06-11','13:20:00',4.34),('9303','2013-06-11','13:25:00',4.34),('9303','2013-06-11','13:30:00',4.36),('9303','2013-06-11','13:35:00',4.36),('9303','2013-06-11','13:40:00',4.31),('9303','2013-06-11','13:45:00',4.39),('9303','2013-06-11','13:50:00',4.35),('9303','2013-06-11','13:55:00',4.22),('9303','2013-06-11','14:00:00',4.32),('9303','2013-06-11','14:05:00',4.26),('9303','2013-06-11','14:10:00',4.2),('9303','2013-06-11','14:15:00',4.17),('9303','2013-06-11','14:20:00',4.14),('9303','2013-06-11','14:25:00',4.1),('9303','2013-06-11','14:30:00',4.08),('9303','2013-06-11','14:35:00',4.06),('9303','2013-06-11','14:40:00',4.05),('9303','2013-06-11','14:45:00',4),('9303','2013-06-11','14:50:00',3.97),('9303','2013-06-11','14:55:00',3.95),('9303','2013-06-11','15:00:00',3.91),('9303','2013-06-11','15:05:00',3.85),('9303','2013-06-11','15:10:00',3.82),('9303','2013-06-11','15:15:00',3.77),('9303','2013-06-11','15:20:00',3.75),('9303','2013-06-11','15:25:00',3.67),('9303','2013-06-11','15:30:00',3.64),('9303','2013-06-11','15:35:00',3.62),('9303','2013-06-11','15:40:00',3.7),('9303','2013-06-11','15:45:00',2.57),('9303','2013-06-11','15:50:00',3.17),('9303','2013-06-11','15:55:00',3.25),('9303','2013-06-11','16:00:00',3.45),('9303','2013-06-11','16:05:00',3.36),('9303','2013-06-11','16:10:00',3.3),('9303','2013-06-11','16:15:00',3.22),('9303','2013-06-11','16:20:00',3.15),('9303','2013-06-11','16:25:00',3.08),('9303','2013-06-11','16:30:00',3.04),('9303','2013-06-11','16:35:00',3),('9303','2013-06-11','16:40:00',3.04),('9303','2013-06-11','16:45:00',3.15),('9303','2013-06-11','16:50:00',3.16),('9303','2013-06-11','16:55:00',3.03),('9303','2013-06-11','17:00:00',2.8),('9303','2013-06-11','17:05:00',2.01),('9303','2014-04-03','08:55:00',1.02),('9303','2014-04-03','09:00:00',1.13),('9303','2014-04-03','09:05:00',1.23),('9303','2014-04-03','09:10:00',1.2),('9303','2014-04-03','09:15:00',1.09),('9303','2014-04-03','09:20:00',1.09),('9303','2014-04-03','09:25:00',1.17),('9303','2014-04-03','09:30:00',1.32),('9303','2014-04-03','09:35:00',1.65),('9303','2014-04-03','09:40:00',1.77),('9303','2014-04-03','09:45:00',1.73),('9303','2014-04-03','09:50:00',1.65),('9303','2014-04-03','09:55:00',1.72),('9303','2014-04-03','10:00:00',2.11),('9303','2014-04-03','10:05:00',2.47),('9303','2014-04-03','10:10:00',2.63),('9303','2014-04-03','10:15:00',3.01),('9303','2014-04-03','10:20:00',3.08),('9303','2014-04-03','10:25:00',2.85),('9303','2014-04-03','10:30:00',2.52),('9303','2014-04-03','10:35:00',2.86),('9303','2014-04-03','10:40:00',2.2),('9303','2014-04-03','10:45:00',2.37),('9303','2014-04-03','10:50:00',2),('9303','2014-04-03','10:55:00',2.08),('9303','2014-04-03','11:00:00',1.94),('9303','2014-04-03','11:05:00',1.59),('9303','2014-04-03','11:10:00',1.53),('9303','2014-04-03','11:15:00',1.41),('9303','2014-04-03','11:20:00',1.34),('9303','2014-04-03','11:25:00',1.23),('9303','2014-04-03','11:30:00',1.21),('9303','2014-04-03','11:35:00',1.29),('9303','2014-04-03','11:40:00',1.43),('9303','2014-04-03','11:45:00',1.62),('9303','2014-04-03','11:50:00',1.99),('9303','2014-04-03','11:55:00',2.25),('9303','2014-04-03','12:00:00',2.14),('9303','2014-04-03','12:05:00',2.17),('9303','2014-04-03','12:10:00',2.09),('9303','2014-04-03','12:15:00',2.04),('9303','2014-04-03','12:20:00',2.25),('9303','2014-04-03','12:25:00',2.8),('9303','2014-04-03','12:30:00',3.68),('9303','2014-04-03','12:35:00',3.55),('9303','2014-04-03','12:40:00',3.94),('9303','2014-04-03','12:45:00',2.32),('9303','2014-04-03','12:50:00',2.55),('9303','2014-04-03','12:55:00',2.61),('9303','2014-04-03','13:00:00',2.41),('9303','2014-04-03','13:05:00',3),('9303','2014-04-03','13:10:00',2.17),('9303','2014-04-03','13:15:00',4.1),('9303','2014-04-03','13:20:00',2.82),('9303','2014-04-03','13:25:00',2.69),('9303','2014-04-03','13:30:00',2.71),('9303','2014-04-03','13:35:00',4.44),('9303','2014-04-03','13:40:00',4.05),('9303','2014-04-03','13:45:00',2.15),('9303','2014-04-03','13:50:00',2.05),('9303','2014-04-03','13:55:00',2.36),('9303','2014-04-03','14:00:00',3.59),('9303','2014-04-03','14:05:00',3.56),('9303','2014-04-03','14:10:00',2.74),('9303','2014-04-03','14:15:00',3.37),('9303','2014-04-03','14:20:00',3.66),('9303','2014-04-03','14:25:00',3.73),('9303','2014-04-03','14:30:00',3.75),('9303','2014-04-03','14:35:00',3.87),('9303','2014-04-03','14:40:00',3.75),('9303','2014-04-03','14:45:00',3.65),('9303','2014-04-03','14:50:00',3.59),('9303','2014-04-03','14:55:00',3.53),('9303','2014-04-03','15:00:00',3.48),('9303','2014-04-03','15:05:00',3.48),('9303','2014-04-03','15:10:00',3.4),('9303','2014-04-03','15:15:00',3.38),('9303','2014-04-03','15:20:00',3.39),('9303','2014-04-03','15:25:00',3.37),('9303','2014-04-03','15:30:00',3.33),('9303','2014-04-03','15:35:00',3.28),('9303','2014-04-03','15:40:00',3.21),('9303','2014-04-03','15:45:00',3.16),('9303','2014-04-03','15:50:00',3.12),('9303','2014-04-03','15:55:00',3.09),('9303','2014-04-03','16:00:00',3.08),('9303','2014-04-03','16:05:00',2.97),('9303','2014-04-03','16:10:00',2.97),('9303','2014-04-03','16:15:00',2.85),('9303','2014-04-03','16:20:00',2.8),('9303','2014-04-03','16:25:00',2.69),('9303','2014-04-03','16:30:00',2.61),('9303','2014-04-03','16:35:00',2.56),('9303','2014-04-03','16:40:00',2.45),('9303','2014-04-03','16:45:00',2.2),('9303','2014-04-03','16:50:00',1.7),('9303','2014-04-03','16:55:00',1.39),('9303','2014-04-03','17:50:00',1.17),('9303','2014-04-03','17:55:00',1.01),('9303','2013-06-10','07:35:00',1.31),('9303','2013-06-10','08:05:00',1.35),('9303','2013-06-10','08:10:00',1.71),('9303','2013-06-10','08:15:00',1.66),('9303','2013-06-10','08:20:00',1.77),('9303','2013-06-10','08:25:00',1.12),('9303','2013-06-10','08:30:00',1.17),('9303','2013-06-10','09:00:00',1.12),('9303','2013-06-10','09:10:00',1.47),('9303','2013-06-10','09:20:00',1.79),('9303','2013-06-10','09:25:00',2.06),('9303','2013-06-10','09:30:00',2.25),('9303','2013-06-10','09:35:00',3.08),('9303','2013-06-10','09:40:00',2.22),('9303','2013-06-10','09:45:00',3.56),('9303','2013-06-10','09:50:00',1.9),('9303','2013-06-10','09:55:00',1.66),('9303','2013-06-10','10:00:00',2.01),('9303','2013-06-10','10:05:00',2.38),('9303','2013-06-10','10:10:00',2.87),('9303','2013-06-10','10:15:00',2.75),('9303','2013-06-10','10:20:00',1.73),('9303','2013-06-10','10:25:00',1.46),('9303','2013-06-10','10:30:00',1.59),('9303','2013-06-10','10:35:00',1.54),('9303','2013-06-10','10:40:00',1.59),('9303','2013-06-10','10:45:00',1.16),('9303','2013-06-10','10:50:00',2),('9303','2013-06-10','10:55:00',2.53),('9303','2013-06-10','11:00:00',3.4),('9303','2013-06-10','11:05:00',2.77),('9303','2013-06-10','11:10:00',2.12),('9303','2013-06-10','11:15:00',3.88),('9303','2013-06-10','11:20:00',4.07),('9303','2013-06-10','11:25:00',4.26),('9303','2013-06-10','11:30:00',4.06),('9303','2013-06-10','11:35:00',4.28),('9303','2013-06-10','11:40:00',2.32),('9303','2013-06-10','11:45:00',3.23),('9303','2013-06-10','11:50:00',2.36),('9303','2013-06-10','11:55:00',3.45),('9303','2013-06-10','12:00:00',4.51),('9303','2013-06-10','12:05:00',1.36),('9303','2013-06-10','12:10:00',2.46),('9303','2013-06-10','12:15:00',2.89),('9303','2013-06-10','12:20:00',3.45),('9303','2013-06-10','12:25:00',4.64),('9303','2013-06-10','12:30:00',4.6),('9303','2013-06-10','12:35:00',4.26),('9303','2013-06-10','12:40:00',4.2),('9303','2013-06-10','12:45:00',4.2),('9303','2013-06-10','12:50:00',2.58),('9303','2013-06-10','12:55:00',3.64),('9303','2013-06-10','13:00:00',4.95),('9303','2013-06-10','13:05:00',3.68),('9303','2013-06-10','13:10:00',3.64),('9303','2013-06-10','13:15:00',3.16),('9303','2013-06-10','13:20:00',1.61),('9303','2013-06-10','13:25:00',2.27),('9303','2013-06-10','13:30:00',1.7),('9303','2013-06-10','13:35:00',3.81),('9303','2013-06-10','13:40:00',3.87),('9303','2013-06-10','13:45:00',4.78),('9303','2013-06-10','13:50:00',4.86),('9303','2013-06-10','13:55:00',3.79),('9303','2013-06-10','14:00:00',4.47),('9303','2013-06-10','14:05:00',4.42),('9303','2013-06-10','14:10:00',4.31),('9303','2013-06-10','14:15:00',4.33),('9303','2013-06-10','14:20:00',3.74),('9303','2013-06-10','14:25:00',4.06),('9303','2013-06-10','14:30:00',4.12),('9303','2013-06-10','14:35:00',4.11),('9303','2013-06-10','14:40:00',4.08),('9303','2013-06-10','14:45:00',4.09),('9303','2013-06-10','14:50:00',4.02),('9303','2013-06-10','14:55:00',3.97),('9303','2013-06-10','15:00:00',3.92),('9303','2013-06-10','15:05:00',3.89),('9303','2013-06-10','15:10:00',3.86),('9303','2013-06-10','15:15:00',3.84),('9303','2013-06-10','15:20:00',3.83),('9303','2013-06-10','15:25:00',3.75),('9303','2013-06-10','15:30:00',3.69),('9303','2013-06-10','15:35:00',3.7),('9303','2013-06-10','15:40:00',3.68),('9303','2013-06-10','15:45:00',3.62),('9303','2013-06-10','15:50:00',3.54),('9303','2013-06-10','15:55:00',3.51),('9303','2013-06-10','16:00:00',3.45),('9303','2013-06-10','16:05:00',3.38),('9303','2013-06-10','16:10:00',3.31),('9303','2013-06-10','16:15:00',3.26),('9303','2013-06-10','16:20:00',3.2),('9303','2013-06-10','16:25:00',3.12),('9303','2013-06-10','16:30:00',3.08),('9303','2013-06-10','16:35:00',3.02),('9303','2013-06-10','16:40:00',2.93),('9303','2013-06-10','16:45:00',2.85),('9303','2013-06-10','16:50:00',2.8),('9303','2013-06-10','16:55:00',2.74),('9303','2013-06-10','17:00:00',2.67),('9303','2013-06-10','17:05:00',2.57),('9303','2013-06-10','17:10:00',2.48),('9303','2013-06-10','17:15:00',2.37),('9303','2013-06-10','17:20:00',2.26),('9303','2013-06-10','17:25:00',2.13),('9303','2013-06-10','17:30:00',2.03),('9303','2013-06-10','17:35:00',1.97),('9303','2013-06-10','17:40:00',1.89),('9303','2013-06-10','17:45:00',1.81),('9303','2013-06-10','17:50:00',1.74),('9303','2013-06-10','17:55:00',1.64),('9303','2013-06-10','18:00:00',1.55),('9303','2013-06-10','18:05:00',1.42),('9303','2013-06-10','18:10:00',1.32),('9303','2013-06-10','18:15:00',1.21),('9303','2013-06-10','18:20:00',1.1),('9303','2013-06-09','07:35:00',1.07),('9303','2013-06-09','07:55:00',1.3),('9303','2013-06-09','08:00:00',1.36),('9303','2013-06-09','08:05:00',1.45),('9303','2013-06-09','08:10:00',1.45),('9303','2013-06-09','08:15:00',1.66),('9303','2013-06-09','08:20:00',1.64),('9303','2013-06-09','08:25:00',1.76),('9303','2013-06-09','08:30:00',1.81),('9303','2013-06-09','08:35:00',1.89),('9303','2013-06-09','08:40:00',1.95),('9303','2013-06-09','08:45:00',1.99),('9303','2013-06-09','08:50:00',2.11),('9303','2013-06-09','08:55:00',2.17),('9303','2013-06-09','09:00:00',2.26),('9303','2013-06-09','09:05:00',2.36),('9303','2013-06-09','09:10:00',2.41),('9303','2013-06-09','09:15:00',2.49),('9303','2013-06-09','09:20:00',2.58),('9303','2013-06-09','09:25:00',2.61),('9303','2013-06-09','09:30:00',2.64),('9303','2013-06-09','09:35:00',2.72),('9303','2013-06-09','09:40:00',2.82),('9303','2013-06-09','09:45:00',2.88),('9303','2013-06-09','09:50:00',2.93),('9303','2013-06-09','09:55:00',2.94),('9303','2013-06-09','10:00:00',2.98),('9303','2013-06-09','10:05:00',3.05),('9303','2013-06-09','10:10:00',3.07),('9303','2013-06-09','10:15:00',3.13),('9303','2013-06-09','10:20:00',3.2),('9303','2013-06-09','10:25:00',3.23),('9303','2013-06-09','10:30:00',3.24),('9303','2013-06-09','10:35:00',3.37),('9303','2013-06-09','10:40:00',3.37),('9303','2013-06-09','10:45:00',3.39),('9303','2013-06-09','10:50:00',3.45),('9303','2013-06-09','10:55:00',3.47),('9303','2013-06-09','11:00:00',3.52),('9303','2013-06-09','11:05:00',3.57),('9303','2013-06-09','11:10:00',3.58),('9303','2013-06-09','11:15:00',3.55),('9303','2013-06-09','11:20:00',3.62),('9303','2013-06-09','11:25:00',3.66),('9303','2013-06-09','11:30:00',3.68),('9303','2013-06-09','11:35:00',3.67),('9303','2013-06-09','11:40:00',3.69),('9303','2013-06-09','11:45:00',3.77),('9303','2013-06-09','11:50:00',3.83),('9303','2013-06-09','11:55:00',3.83),('9303','2013-06-09','12:00:00',3.82),('9303','2013-06-09','12:05:00',3.85),('9303','2013-06-09','12:10:00',3.7),('9303','2013-06-09','12:15:00',3.63),('9303','2013-06-09','12:20:00',3.89),('9303','2013-06-09','12:25:00',3.89),('9303','2013-06-09','12:30:00',3.94),('9303','2013-06-09','12:35:00',3.94),('9303','2013-06-09','12:40:00',3.96),('9303','2013-06-09','12:45:00',3.86),('9303','2013-06-09','12:50:00',3.36),('9303','2013-06-09','12:55:00',3.55),('9303','2013-06-09','13:00:00',3.86),('9303','2013-06-09','13:05:00',3.48),('9303','2013-06-09','13:10:00',4.37),('9303','2013-06-09','13:15:00',3.35),('9303','2013-06-09','13:20:00',3.81),('9303','2013-06-09','13:25:00',4.38),('9303','2013-06-09','13:30:00',4.22),('9303','2013-06-09','13:35:00',4.16),('9303','2013-06-09','13:40:00',4.24),('9303','2013-06-09','13:45:00',4.29),('9303','2013-06-09','13:50:00',4.46),('9303','2013-06-09','13:55:00',4.01),('9303','2013-06-09','14:00:00',4.39),('9303','2013-06-09','14:05:00',4.22),('9303','2013-06-09','14:10:00',4.33),('9303','2013-06-09','14:15:00',2.86),('9303','2013-06-09','14:20:00',2.02),('9303','2013-06-09','14:25:00',1.09),('9303','2013-06-09','14:30:00',1.28),('9303','2013-06-09','14:35:00',3.34),('9303','2013-06-09','14:40:00',3.65),('9303','2013-06-09','14:45:00',3.61),('9303','2013-06-09','14:50:00',3.8),('9303','2013-06-09','14:55:00',3.89),('9303','2013-06-09','15:00:00',3.84),('9303','2013-06-09','15:05:00',3.68),('9303','2013-06-09','15:10:00',3.71),('9303','2013-06-09','15:15:00',3.58),('9303','2013-06-09','15:20:00',3.57),('9303','2013-06-09','15:25:00',3.6),('9303','2013-06-09','15:30:00',3.45),('9303','2013-06-09','15:35:00',3.58),('9303','2013-06-09','15:40:00',2.83),('9303','2013-06-09','15:45:00',2.84),('9303','2013-06-09','15:50:00',3.12),('9303','2013-06-09','15:55:00',3.48),('9303','2013-06-09','16:00:00',2.39),('9303','2013-06-09','16:05:00',3.01),('9303','2013-06-09','16:10:00',3.09),('9303','2013-06-09','16:15:00',1.72),('9303','2013-06-09','16:20:00',1.39),('9303','2013-06-09','16:25:00',2.12),('9303','2013-06-09','16:30:00',1.33),('9303','2013-06-09','18:10:00',1.01),('9303','2013-06-08','07:45:00',1.07),('9303','2013-06-08','07:50:00',1.15),('9303','2013-06-08','07:55:00',1.22),('9303','2013-06-08','08:00:00',1.3),('9303','2013-06-08','08:05:00',1.39),('9303','2013-06-08','08:10:00',1.48),('9303','2013-06-08','08:15:00',1.58),('9303','2013-06-08','08:20:00',1.66),('9303','2013-06-08','08:25:00',1.73),('9303','2013-06-08','08:30:00',1.82),('9303','2013-06-08','08:35:00',1.9),('9303','2013-06-08','08:40:00',1.97),('9303','2013-06-08','08:45:00',2.06),('9303','2013-06-08','08:50:00',2.13),('9303','2013-06-08','08:55:00',2.19),('9303','2013-06-08','09:00:00',2.29),('9303','2013-06-08','09:05:00',2.38),('9303','2013-06-08','09:10:00',2.47),('9303','2013-06-08','09:15:00',2.54),('9303','2013-06-08','09:20:00',2.55),('9303','2013-06-08','09:25:00',2.6),('9303','2013-06-08','09:30:00',2.69),('9303','2013-06-08','09:35:00',2.78),('9303','2013-06-08','09:40:00',2.83),('9303','2013-06-08','09:45:00',2.85),('9303','2013-06-08','09:50:00',2.88),('9303','2013-06-08','09:55:00',2.93),('9303','2013-06-08','10:00:00',3.01),('9303','2013-06-08','10:05:00',3.15),('9303','2013-06-08','10:10:00',3.24),('9303','2013-06-08','10:15:00',3.29),('9303','2013-06-08','10:20:00',3.28),('9303','2013-06-08','10:25:00',3.28),('9303','2013-06-08','10:30:00',3.33),('9303','2013-06-08','10:35:00',3.33),('9303','2013-06-08','10:40:00',3.04),('9303','2013-06-08','10:45:00',2.91),('9303','2013-06-08','10:50:00',3.42),('9303','2013-06-08','10:55:00',3.67),('9303','2013-06-08','11:00:00',3.27),('9303','2013-06-08','11:05:00',2.13),('9303','2013-06-08','11:10:00',4.04),('9303','2013-06-08','11:15:00',4.18),('9303','2013-06-08','11:20:00',4.17),('9303','2013-06-08','11:25:00',4.21),('9303','2013-06-08','11:30:00',2.34),('9303','2013-06-08','11:35:00',3.57),('9303','2013-06-08','11:40:00',4.12),('9303','2013-06-08','11:45:00',4.08),('9303','2013-06-08','11:50:00',4.19),('9303','2013-06-08','11:55:00',2.74),('9303','2013-06-08','12:00:00',1.92),('9303','2013-06-08','12:05:00',2.09),('9303','2013-06-08','12:15:00',4.04),('9303','2013-06-08','12:20:00',2.94),('9303','2013-06-08','12:25:00',2.56),('9303','2013-06-08','12:30:00',3.66),('9303','2013-06-08','12:35:00',3.91),('9303','2013-06-08','12:40:00',4.15),('9303','2013-06-08','12:45:00',4.26),('9303','2013-06-08','12:50:00',4.24),('9303','2013-06-08','12:55:00',3.55),('9303','2013-06-08','13:00:00',2.56),('9303','2013-06-08','13:05:00',4.31),('9303','2013-06-08','13:10:00',4.39),('9303','2013-06-08','13:15:00',4.39),('9303','2013-06-08','13:20:00',4.15),('9303','2013-06-08','13:25:00',4.26),('9303','2013-06-08','13:30:00',4.45),('9303','2013-06-08','13:35:00',4.33),('9303','2013-06-08','13:40:00',4.29),('9303','2013-06-08','13:45:00',4.18),('9303','2013-06-08','13:50:00',4.22),('9303','2013-06-08','13:55:00',4.19),('9303','2013-06-08','14:00:00',4.13),('9303','2013-06-08','14:05:00',4.13),('9303','2013-06-08','14:10:00',4.15),('9303','2013-06-08','14:15:00',4.11),('9303','2013-06-08','14:20:00',4.06),('9303','2013-06-08','14:25:00',4.06),('9303','2013-06-08','14:30:00',4.02),('9303','2013-06-08','14:35:00',3.97),('9303','2013-06-08','14:40:00',4),('9303','2013-06-08','14:45:00',3.96),('9303','2013-06-08','14:50:00',3.98),('9303','2013-06-08','14:55:00',3.89),('9303','2013-06-08','15:00:00',3.91),('9303','2013-06-08','15:05:00',3.77),('9303','2013-06-08','15:10:00',3.5),('9303','2013-06-08','15:15:00',3.65),('9303','2013-06-08','15:20:00',3.76),('9303','2013-06-08','15:25:00',3.51),('9303','2013-06-08','15:30:00',3.6),('9303','2013-06-08','15:35:00',3.73),('9303','2013-06-08','15:40:00',3.62),('9303','2013-06-08','15:45:00',3.34),('9303','2013-06-08','15:50:00',3.5),('9303','2013-06-08','15:55:00',3.34),('9303','2013-06-08','16:00:00',3.41),('9303','2013-06-08','16:05:00',3.37),('9303','2013-06-08','16:10:00',3.3),('9303','2013-06-08','16:15:00',3.38),('9303','2013-06-08','16:20:00',3.26),('9303','2013-06-08','16:25:00',3.13),('9303','2013-06-08','16:30:00',2.97),('9303','2013-06-08','16:35:00',2.87),('9303','2013-06-08','16:40:00',2.81),('9303','2013-06-08','16:45:00',2.77),('9303','2013-06-08','16:50:00',2.35),('9303','2013-06-08','16:55:00',2.43),('9303','2013-06-08','17:00:00',2.55),('9303','2013-06-08','17:05:00',1.95),('9303','2013-06-08','17:10:00',2.64),('9303','2013-06-08','17:15:00',2.55),('9303','2013-06-08','17:20:00',2.37),('9303','2013-06-08','17:25:00',2.15),('9303','2013-06-08','17:30:00',1.32),('9303','2013-06-08','17:40:00',1.64),('9303','2013-06-08','17:45:00',1.82),('9303','2013-06-08','17:50:00',1.63),('9303','2013-06-08','17:55:00',1.73),('9303','2013-06-08','18:00:00',1.34),('9303','2013-06-08','18:05:00',1.24),('9303','2013-06-07','07:40:00',1.03),('9303','2013-06-07','07:45:00',1.12),('9303','2013-06-07','07:50:00',1.22),('9303','2013-06-07','07:55:00',1.31),('9303','2013-06-07','08:00:00',1.39),('9303','2013-06-07','08:05:00',1.46),('9303','2013-06-07','08:10:00',1.59),('9303','2013-06-07','08:15:00',1.68),('9303','2013-06-07','08:20:00',1.77),('9303','2013-06-07','08:25:00',1.85),('9303','2013-06-07','08:30:00',1.94),('9303','2013-06-07','08:35:00',2.01),('9303','2013-06-07','08:40:00',2.11),('9303','2013-06-07','08:45:00',2.19),('9303','2013-06-07','08:50:00',2.27),('9303','2013-06-07','08:55:00',2.35),('9303','2013-06-07','09:00:00',2.43),('9303','2013-06-07','09:05:00',2.53),('9303','2013-06-07','09:10:00',2.61),('9303','2013-06-07','09:15:00',2.68),('9303','2013-06-07','09:20:00',2.74),('9303','2013-06-07','09:25:00',2.82),('9303','2013-06-07','09:30:00',2.89),('9303','2013-06-07','09:35:00',2.95),('9303','2013-06-07','09:40:00',3.04),('9303','2013-06-07','09:45:00',3.11),('9303','2013-06-07','09:50:00',3.17),('9303','2013-06-07','09:55:00',3.23),('9303','2013-06-07','10:00:00',3.26),('9303','2013-06-07','10:05:00',3.3),('9303','2013-06-07','10:10:00',3.37),('9303','2013-06-07','10:15:00',3.44),('9303','2013-06-07','10:20:00',3.49),('9303','2013-06-07','10:25:00',3.54),('9303','2013-06-07','10:30:00',3.57),('9303','2013-06-07','10:35:00',3.59),('9303','2013-06-07','10:40:00',3.66),('9303','2013-06-07','10:45:00',3.69),('9303','2013-06-07','10:50:00',3.73),('9303','2013-06-07','10:55:00',3.76),('9303','2013-06-07','11:00:00',3.8),('9303','2013-06-07','11:05:00',3.83),('9303','2013-06-07','11:10:00',3.88),('9303','2013-06-07','11:15:00',3.9),('9303','2013-06-07','11:20:00',3.96),('9303','2013-06-07','11:25:00',3.99),('9303','2013-06-07','11:30:00',4),('9303','2013-06-07','11:35:00',4.03),('9303','2013-06-07','11:40:00',4.07),('9303','2013-06-07','11:45:00',4.08),('9303','2013-06-07','11:50:00',4.07),('9303','2013-06-07','11:55:00',4.11),('9303','2013-06-07','12:00:00',4.15),('9303','2013-06-07','12:05:00',4.16),('9303','2013-06-07','12:10:00',4.17),('9303','2013-06-07','12:15:00',4.2),('9303','2013-06-07','12:20:00',4.19),('9303','2013-06-07','12:25:00',4.22),('9303','2013-06-07','12:30:00',4.25),('9303','2013-06-07','12:35:00',4.27),('9303','2013-06-07','12:40:00',4.28),('9303','2013-06-07','12:45:00',4.24),('9303','2013-06-07','12:50:00',4.23),('9303','2013-06-07','12:55:00',4.21),('9303','2013-06-07','13:00:00',4.21),('9303','2013-06-07','13:05:00',4.21),('9303','2013-06-07','13:10:00',4.19),('9303','2013-06-07','13:15:00',4.17),('9303','2013-06-07','13:20:00',4.19),('9303','2013-06-07','13:25:00',4.17),('9303','2013-06-07','13:30:00',4.19),('9303','2013-06-07','13:35:00',4.15),('9303','2013-06-07','13:40:00',4.11),('9303','2013-06-07','13:45:00',4.09),('9303','2013-06-07','13:50:00',4.1),('9303','2013-06-07','13:55:00',4.07),('9303','2013-06-07','14:00:00',4.07),('9303','2013-06-07','14:05:00',4.05),('9303','2013-06-07','14:10:00',3.99),('9303','2013-06-07','14:15:00',3.95),('9303','2013-06-07','14:20:00',3.92),('9303','2013-06-07','14:25:00',3.92),('9303','2013-06-07','14:30:00',3.95),('9303','2013-06-07','14:35:00',3.96),('9303','2013-06-07','14:40:00',3.94),('9303','2013-06-07','14:45:00',3.91),('9303','2013-06-07','14:50:00',3.88),('9303','2013-06-07','14:55:00',3.8),('9303','2013-06-07','15:00:00',3.78),('9303','2013-06-07','15:05:00',3.78),('9303','2013-06-07','15:10:00',3.77),('9303','2013-06-07','15:15:00',3.7),('9303','2013-06-07','15:20:00',3.6),('9303','2013-06-07','15:25:00',3.62),('9303','2013-06-07','15:30:00',3.62),('9303','2013-06-07','15:35:00',3.59),('9303','2013-06-07','15:40:00',3.5),('9303','2013-06-07','15:45:00',3.45),('9303','2013-06-07','15:50:00',3.41),('9303','2013-06-07','15:55:00',3.37),('9303','2013-06-07','16:00:00',3.32),('9303','2013-06-07','16:05:00',3.25),('9303','2013-06-07','16:10:00',3.16),('9303','2013-06-07','16:15:00',3.01),('9303','2013-06-07','16:20:00',2.99),('9303','2013-06-07','16:25:00',2.97),('9303','2013-06-07','16:30:00',2.89),('9303','2013-06-07','16:35:00',2.86),('9303','2013-06-07','16:40:00',2.82),('9303','2013-06-07','16:45:00',2.77),('9303','2013-06-07','16:50:00',2.67),('9303','2013-06-07','16:55:00',2.63),('9303','2013-06-07','17:00:00',2.56),('9303','2013-06-07','17:05:00',2.46),('9303','2013-06-07','17:10:00',2.35),('9303','2013-06-07','17:15:00',2.22),('9303','2013-06-07','17:20:00',2.1),('9303','2013-06-07','17:25:00',2.01),('9303','2013-06-07','17:30:00',1.87),('9303','2013-06-07','17:35:00',1.84),('9303','2013-06-07','17:40:00',1.85),('9303','2013-06-07','17:45:00',1.82),('9303','2013-06-07','17:50:00',1.73),('9303','2013-06-07','17:55:00',1.62),('9303','2013-06-07','18:00:00',1.49),('9303','2013-06-07','18:05:00',1.37),('9303','2013-06-07','18:10:00',1.26),('9303','2013-06-07','18:15:00',1.15),('9303','2013-06-07','18:20:00',1.04),('9303','2013-06-06','07:50:00',1.11),('9303','2013-06-06','07:55:00',1.37),('9303','2013-06-06','08:00:00',1.52),('9303','2013-06-06','08:05:00',1.19),('9303','2013-06-06','08:10:00',1.39),('9303','2013-06-06','08:15:00',1.28),('9303','2013-06-06','08:20:00',1.54),('9303','2013-06-06','08:25:00',1.85),('9303','2013-06-06','08:30:00',1.9),('9303','2013-06-06','08:35:00',1.96),('9303','2013-06-06','08:40:00',2.02),('9303','2013-06-06','08:45:00',2.08),('9303','2013-06-06','08:50:00',2.19),('9303','2013-06-06','08:55:00',2.27),('9303','2013-06-06','09:00:00',2.38),('9303','2013-06-06','09:05:00',2.46),('9303','2013-06-06','09:10:00',2.52),('9303','2013-06-06','09:15:00',2.58),('9303','2013-06-06','09:20:00',2.67),('9303','2013-06-06','09:25:00',2.73),('9303','2013-06-06','09:30:00',2.81),('9303','2013-06-06','09:35:00',2.89),('9303','2013-06-06','09:40:00',2.95),('9303','2013-06-06','09:45:00',3),('9303','2013-06-06','09:50:00',3.02),('9303','2013-06-06','09:55:00',3.06),('9303','2013-06-06','10:00:00',3.13),('9303','2013-06-06','10:05:00',3.21),('9303','2013-06-06','10:10:00',3.31),('9303','2013-06-06','10:15:00',3.34),('9303','2013-06-06','10:20:00',3.37),('9303','2013-06-06','10:25:00',3.4),('9303','2013-06-06','10:30:00',3.5),('9303','2013-06-06','10:35:00',3.5),('9303','2013-06-06','10:40:00',3.53),('9303','2013-06-06','10:45:00',3.64),('9303','2013-06-06','10:50:00',3.6),('9303','2013-06-06','10:55:00',3.62),('9303','2013-06-06','11:00:00',3.69),('9303','2013-06-06','11:05:00',3.75),('9303','2013-06-06','11:10:00',3.75),('9303','2013-06-06','11:15:00',3.81),('9303','2013-06-06','11:20:00',3.85),('9303','2013-06-06','11:25:00',3.87),('9303','2013-06-06','11:30:00',3.83),('9303','2013-06-06','11:35:00',3.88),('9303','2013-06-06','11:40:00',3.97),('9303','2013-06-06','11:45:00',4.02),('9303','2013-06-06','11:50:00',3.97),('9303','2013-06-06','11:55:00',4),('9303','2013-06-06','12:00:00',3.69),('9303','2013-06-06','12:05:00',3.76),('9303','2013-06-06','12:10:00',4.05),('9303','2013-06-06','12:15:00',4.02),('9303','2013-06-06','12:20:00',4.04),('9303','2013-06-06','12:25:00',4.07),('9303','2013-06-06','12:30:00',4.13),('9303','2013-06-06','12:35:00',4.13),('9303','2013-06-06','12:40:00',4.12),('9303','2013-06-06','12:45:00',4.12),('9303','2013-06-06','12:50:00',4.13),('9303','2013-06-06','12:55:00',4.14),('9303','2013-06-06','13:00:00',4.18),('9303','2013-06-06','13:05:00',4.16),('9303','2013-06-06','13:10:00',4.18),('9303','2013-06-06','13:15:00',4.18),('9303','2013-06-06','13:20:00',4.19),('9303','2013-06-06','13:25:00',4.15),('9303','2013-06-06','13:30:00',4.16),('9303','2013-06-06','13:35:00',4.1),('9303','2013-06-06','13:40:00',4.15),('9303','2013-06-06','13:45:00',3.46),('9303','2013-06-06','13:50:00',2.8),('9303','2013-06-06','13:55:00',3.49),('9303','2013-06-06','14:00:00',4.16),('9303','2013-06-06','14:05:00',4.29),('9303','2013-06-06','14:10:00',4.31),('9303','2013-06-06','14:15:00',4.21),('9303','2013-06-06','14:20:00',4.3),('9303','2013-06-06','14:25:00',3.17),('9303','2013-06-06','14:30:00',4.24),('9303','2013-06-06','14:35:00',4.04),('9303','2013-06-06','14:40:00',3.6),('9303','2013-06-06','14:45:00',3.3),('9303','2013-06-06','14:50:00',4),('9303','2013-06-06','14:55:00',4.12),('9303','2013-06-06','15:00:00',3.96),('9303','2013-06-06','15:05:00',3.94),('9303','2013-06-06','15:10:00',3.84),('9303','2013-06-06','15:15:00',3.67),('9303','2013-06-06','15:20:00',3.76),('9303','2013-06-06','15:25:00',3.61),('9303','2013-06-06','15:30:00',3.52),('9303','2013-06-06','15:35:00',3.55),('9303','2013-06-06','15:40:00',3.48),('9303','2013-06-06','15:45:00',3.44),('9303','2013-06-06','15:50:00',3.38),('9303','2013-06-06','15:55:00',3.24),('9303','2013-06-06','16:00:00',3.15),('9303','2013-06-06','16:05:00',3.24),('9303','2013-06-06','16:10:00',3.1),('9303','2013-06-06','16:15:00',2.97),('9303','2013-06-06','16:20:00',2.9),('9303','2013-06-06','16:25:00',2.93),('9303','2013-06-06','16:30:00',2.92),('9303','2013-06-06','16:35:00',2.9),('9303','2013-06-06','16:40:00',2.82),('9303','2013-06-06','16:45:00',2.68),('9303','2013-06-06','16:50:00',2.61),('9303','2013-06-06','16:55:00',2.53),('9303','2013-06-06','17:00:00',2.44),('9303','2013-06-06','17:05:00',2.36),('9303','2013-06-06','17:10:00',2.26),('9303','2013-06-06','17:15:00',2.13),('9303','2013-06-06','17:20:00',2.06),('9303','2013-06-06','17:25:00',1.95),('9303','2013-06-06','17:30:00',1.82),('9303','2013-06-06','17:35:00',1.81),('9303','2013-06-06','17:40:00',1.73),('9303','2013-06-06','17:45:00',1.64),('9303','2013-06-06','17:50:00',1.56),('9303','2013-06-06','17:55:00',1.46),('9303','2013-06-06','18:00:00',1.39),('9303','2013-06-06','18:05:00',1.28),('9303','2013-06-06','18:10:00',1.19),('9303','2013-06-06','18:15:00',1.08),('9303','2013-06-05','07:50:00',1.16),('9303','2013-06-05','07:55:00',1.47),('9303','2013-06-05','08:00:00',1.1),('9303','2013-06-05','08:10:00',1.23),('9303','2013-06-05','08:15:00',1.52),('9303','2013-06-05','08:20:00',1.72),('9303','2013-06-05','08:25:00',1.82),('9303','2013-06-05','08:30:00',1.89),('9303','2013-06-05','08:35:00',1.97),('9303','2013-06-05','08:40:00',2.07),('9303','2013-06-05','08:45:00',2.14),('9303','2013-06-05','08:50:00',2.17),('9303','2013-06-05','08:55:00',2.26),('9303','2013-06-05','09:00:00',2.4),('9303','2013-06-05','09:05:00',2.02),('9303','2013-06-05','09:10:00',2.45),('9303','2013-06-05','09:15:00',2.73),('9303','2013-06-05','09:20:00',2.95),('9303','2013-06-05','09:25:00',2.84),('9303','2013-06-05','09:30:00',2.94),('9303','2013-06-05','09:35:00',3.19),('9303','2013-06-05','09:40:00',3.46),('9303','2013-06-05','09:45:00',3.1),('9303','2013-06-05','09:50:00',2.38),('9303','2013-06-05','09:55:00',1.19),('9303','2013-06-05','10:00:00',3.04),('9303','2013-06-05','10:05:00',2.88),('9303','2013-06-05','10:10:00',1.28),('9303','2013-06-05','10:15:00',1.26),('9303','2013-06-05','10:20:00',1.71),('9303','2013-06-05','10:25:00',3.18),('9303','2013-06-05','10:30:00',1.93),('9303','2013-06-05','10:35:00',1.96),('9303','2013-06-05','10:40:00',3.17),('9303','2013-06-05','10:45:00',3.52),('9303','2013-06-05','10:50:00',3.87),('9303','2013-06-05','10:55:00',3.89),('9303','2013-06-05','11:00:00',3.98),('9303','2013-06-05','11:05:00',4.14),('9303','2013-06-05','11:10:00',1.26),('9303','2013-06-05','11:15:00',1.23),('9303','2013-06-05','11:20:00',1.23),('9303','2013-06-05','11:25:00',1.02),('9303','2013-06-05','11:30:00',1.13),('9303','2013-06-05','11:35:00',2.2),('9303','2013-06-05','11:40:00',4.4),('9303','2013-06-05','11:45:00',4.29),('9303','2013-06-05','11:50:00',2.09),('9303','2013-06-05','11:55:00',3.42),('9303','2013-06-05','12:00:00',1.42),('9303','2013-06-05','12:05:00',3.72),('9303','2013-06-05','12:10:00',4.71),('9303','2013-06-05','12:15:00',4.72),('9303','2013-06-05','12:20:00',4.81),('9303','2013-06-05','12:25:00',4.71),('9303','2013-06-05','12:30:00',4.82),('9303','2013-06-05','12:35:00',4.54),('9303','2013-06-05','12:40:00',4.91),('9303','2013-06-05','12:45:00',4.91),('9303','2013-06-05','12:50:00',2.45),('9303','2013-06-05','12:55:00',1.53),('9303','2013-06-05','13:00:00',2.17),('9303','2013-06-05','13:05:00',3.17),('9303','2013-06-05','13:10:00',2.46),('9303','2013-06-05','13:15:00',3.37),('9303','2013-06-05','13:20:00',3.03),('9303','2013-06-05','13:25:00',3.84),('9303','2013-06-05','13:30:00',1.91),('9303','2013-06-05','13:35:00',4.44),('9303','2013-06-05','13:40:00',4.7),('9303','2013-06-05','13:45:00',4.54),('9303','2013-06-05','13:50:00',4.4),('9303','2013-06-05','13:55:00',4.36),('9303','2013-06-05','14:00:00',4.32),('9303','2013-06-05','14:05:00',4.29),('9303','2013-06-05','14:10:00',4.25),('9303','2013-06-05','14:15:00',4.23),('9303','2013-06-05','14:20:00',4.23),('9303','2013-06-05','14:25:00',4.13),('9303','2013-06-05','14:30:00',4.14),('9303','2013-06-05','14:35:00',3.93),('9303','2013-06-05','14:40:00',4.08),('9303','2013-06-05','14:45:00',4.09),('9303','2013-06-05','14:50:00',4.04),('9303','2013-06-05','14:55:00',4),('9303','2013-06-05','15:00:00',3.9),('9303','2013-06-05','15:05:00',3.85),('9303','2013-06-05','15:10:00',3.79),('9303','2013-06-05','15:15:00',3.7),('9303','2013-06-05','15:20:00',3.78),('9303','2013-06-05','15:25:00',3.77),('9303','2013-06-05','15:30:00',3.77),('9303','2013-06-05','15:35:00',3.71),('9303','2013-06-05','15:40:00',3.73),('9303','2013-06-05','15:45:00',3.64),('9303','2013-06-05','15:50:00',3.57),('9303','2013-06-05','15:55:00',3.48),('9303','2013-06-05','16:00:00',3.39),('9303','2013-06-05','16:05:00',3.16),('9303','2013-06-05','16:10:00',3.3),('9303','2013-06-05','16:15:00',3.25),('9303','2013-06-05','16:20:00',3.17),('9303','2013-06-05','16:25:00',3.05),('9303','2013-06-05','16:30:00',2.91),('9303','2013-06-05','16:35:00',2.96),('9303','2013-06-05','16:40:00',2.9),('9303','2013-06-05','16:45:00',2.83),('9303','2013-06-05','16:50:00',2.77),('9303','2013-06-05','16:55:00',2.71),('9303','2013-06-05','17:00:00',2.38),('9303','2013-06-05','17:05:00',1.71),('9303','2013-06-05','17:10:00',1.62),('9303','2013-06-05','17:15:00',2.07),('9303','2013-06-05','17:25:00',1.92),('9303','2013-06-05','17:30:00',2.02),('9303','2013-06-05','17:35:00',1.79),('9303','2013-06-05','17:40:00',1.54),('9303','2013-06-05','17:45:00',1.6),('9303','2013-06-05','17:50:00',1.49),('9303','2013-06-05','17:55:00',1.56),('9303','2013-06-05','18:00:00',1.46),('9303','2013-06-05','18:05:00',1.34),('9303','2013-06-04','07:40:00',1.12),('9303','2013-06-04','07:45:00',1.29),('9303','2013-06-04','07:50:00',1.45),('9303','2013-06-04','07:55:00',1.58),('9303','2013-06-04','08:00:00',1.75),('9303','2013-06-04','08:05:00',1.88),('9303','2013-06-04','08:10:00',1.96),('9303','2013-06-04','08:15:00',2.02),('9303','2013-06-04','08:20:00',2),('9303','2013-06-04','08:25:00',1.89),('9303','2013-06-04','08:30:00',1.88),('9303','2013-06-04','08:35:00',2.12),('9303','2013-06-04','08:40:00',1.95),('9303','2013-06-04','08:45:00',1.77),('9303','2013-06-04','08:50:00',1.27),('9303','2013-06-04','08:55:00',1.34),('9303','2013-06-04','09:00:00',1.56),('9303','2013-06-04','09:05:00',2.03),('9303','2013-06-04','09:10:00',1.96),('9303','2013-06-04','09:15:00',2.77),('9303','2013-06-04','09:20:00',3.11),('9303','2013-06-04','09:25:00',3.5),('9303','2013-06-04','09:30:00',2.78),('9303','2013-06-04','09:35:00',2.39),('9303','2013-06-04','09:40:00',1.53),('9303','2013-06-04','09:45:00',1.56),('9303','2013-06-04','09:50:00',1.6),('9303','2013-06-04','09:55:00',1.5),('9303','2013-06-04','10:00:00',1.88),('9303','2013-06-04','10:05:00',2.07),('9303','2013-06-04','10:10:00',2.74),('9303','2013-06-04','10:15:00',2.29),('9303','2013-06-04','10:20:00',1.77),('9303','2013-06-04','10:25:00',1.68),('9303','2013-06-04','10:30:00',1.57),('9303','2013-06-04','10:35:00',1.61),('9303','2013-06-04','10:40:00',1.71),('9303','2013-06-04','10:45:00',2.02),('9303','2013-06-04','10:50:00',2.6),('9303','2013-06-04','10:55:00',3.16),('9303','2013-06-04','11:00:00',1.98),('9303','2013-06-04','11:05:00',2.51),('9303','2013-06-04','11:10:00',3.3),('9303','2013-06-04','11:15:00',2.98),('9303','2013-06-04','11:20:00',2.03),('9303','2013-06-04','11:25:00',2.75),('9303','2013-06-04','11:30:00',3.23),('9303','2013-06-04','11:35:00',2.91),('9303','2013-06-04','11:40:00',3.1),('9303','2013-06-04','11:45:00',3.9),('9303','2013-06-04','11:50:00',4.4),('9303','2013-06-04','11:55:00',4),('9303','2013-06-04','12:00:00',2.34),('9303','2013-06-04','12:05:00',2.48),('9303','2013-06-04','12:10:00',2.44),('9303','2013-06-04','12:15:00',2.23),('9303','2013-06-04','12:20:00',1.61),('9303','2013-06-04','12:25:00',1.77),('9303','2013-06-04','12:30:00',2.42),('9303','2013-06-04','12:35:00',3.73),('9303','2013-06-04','12:40:00',2.42),('9303','2013-06-04','12:45:00',2.65),('9303','2013-06-04','12:50:00',1.86),('9303','2013-06-04','12:55:00',1.9),('9303','2013-06-04','13:00:00',2.07),('9303','2013-06-04','13:05:00',1.37),('9303','2013-06-04','13:10:00',1.27),('9303','2013-06-04','13:15:00',1.19),('9303','2013-06-04','13:20:00',1.09),('9303','2013-06-04','13:25:00',1.43),('9303','2013-06-04','13:30:00',1.83),('9303','2013-06-04','13:35:00',4.45),('9303','2013-06-04','13:40:00',4.37),('9303','2013-06-04','13:45:00',4.45),('9303','2013-06-04','13:50:00',4.65),('9303','2013-06-04','13:55:00',2.15),('9303','2013-06-04','14:00:00',2.04),('9303','2013-06-04','14:05:00',3.31),('9303','2013-06-04','14:10:00',4.87),('9303','2013-06-04','14:15:00',3.45),('9303','2013-06-04','14:20:00',3.64),('9303','2013-06-04','14:25:00',1.83),('9303','2013-06-04','14:30:00',1.25),('9303','2013-06-04','14:35:00',1.66),('9303','2013-06-04','14:40:00',2.27),('9303','2013-06-04','14:45:00',1.06),('9303','2013-06-04','14:50:00',1),('9303','2013-06-04','14:55:00',3.83),('9303','2013-06-04','15:00:00',5),('9303','2013-06-04','15:05:00',4.86),('9303','2013-06-04','15:10:00',1.46),('9303','2013-06-04','15:15:00',1.05),('9303','2013-06-03','07:45:00',1.13),('9303','2013-06-03','07:50:00',1.21),('9303','2013-06-03','07:55:00',1.34),('9303','2013-06-03','08:00:00',1.42),('9303','2013-06-03','08:05:00',1.48),('9303','2013-06-03','08:10:00',1.58),('9303','2013-06-03','08:15:00',1.66),('9303','2013-06-03','08:20:00',1.73),('9303','2013-06-03','08:25:00',1.82),('9303','2013-06-03','08:30:00',1.91),('9303','2013-06-03','08:35:00',1.98),('9303','2013-06-03','08:40:00',2.05),('9303','2013-06-03','08:45:00',2.12),('9303','2013-06-03','08:50:00',2.21),('9303','2013-06-03','08:55:00',2.27),('9303','2013-06-03','09:00:00',2.33),('9303','2013-06-03','09:05:00',2.33),('9303','2013-06-03','09:10:00',2.59),('9303','2013-06-03','09:15:00',2.62),('9303','2013-06-03','09:20:00',2.44),('9303','2013-06-03','09:25:00',2.37),('9303','2013-06-03','09:30:00',2.07),('9303','2013-06-03','09:35:00',1.71),('9303','2013-06-03','09:40:00',2.31),('9303','2013-06-03','09:45:00',2.24),('9303','2013-06-03','09:50:00',3.19),('9303','2013-06-03','09:55:00',3.45),('9303','2013-06-03','10:00:00',3.77),('9303','2013-06-03','10:05:00',3.96),('9303','2013-06-03','10:10:00',3.94),('9303','2013-06-03','10:15:00',1.89),('9303','2013-06-03','10:20:00',1.06),('9303','2013-06-03','10:25:00',1.01),('9303','2013-06-03','10:30:00',1.03),('9303','2013-06-03','10:35:00',1.07),('9303','2013-06-03','10:40:00',1.23),('9303','2013-06-03','10:45:00',1.42),('9303','2013-06-03','10:50:00',1.63),('9303','2013-06-03','10:55:00',2.56),('9303','2013-06-03','11:00:00',2.7),('9303','2013-06-03','11:05:00',2.26),('9303','2013-06-03','11:10:00',1.42),('9303','2013-06-03','11:15:00',1.23),('9303','2013-06-03','11:20:00',1.52),('9303','2013-06-03','11:25:00',1.54),('9303','2013-06-03','11:30:00',1.35),('9303','2013-06-03','11:35:00',1.23),('9303','2013-06-03','11:40:00',1.28),('9303','2013-06-03','11:45:00',2.94),('9303','2013-06-03','11:50:00',1.47),('9303','2013-06-03','11:55:00',1.46),('9303','2013-06-03','12:00:00',1.51),('9303','2013-06-03','12:05:00',1.64),('9303','2013-06-03','12:10:00',1.68),('9303','2013-06-03','12:15:00',1.36),('9303','2013-06-03','12:20:00',1.45),('9303','2013-06-03','12:25:00',1.32),('9303','2013-06-03','12:30:00',1.76),('9303','2013-06-03','12:35:00',1.62),('9303','2013-06-03','12:40:00',3.41),('9303','2013-06-03','12:45:00',2.19),('9303','2013-06-03','12:50:00',2.4),('9303','2013-06-03','12:55:00',3.15),('9303','2013-06-03','13:00:00',2.06),('9303','2013-06-03','13:05:00',1.73),('9303','2013-06-03','13:10:00',1.79),('9303','2013-06-03','13:15:00',2.3),('9303','2013-06-03','13:20:00',3.86),('9303','2013-06-03','13:25:00',3.2),('9303','2013-06-03','13:30:00',3.43),('9303','2013-06-03','13:35:00',2.99),('9303','2013-06-03','13:40:00',4.72),('9303','2013-06-03','13:45:00',2.44),('9303','2013-06-03','13:50:00',3.84),('9303','2013-06-03','13:55:00',3.01),('9303','2013-06-03','14:00:00',4.02),('9303','2013-06-03','14:05:00',4.11),('9303','2013-06-03','14:10:00',2.38),('9303','2013-06-03','14:15:00',2.07),('9303','2013-06-03','14:20:00',2.18),('9303','2013-06-03','14:25:00',2.44),('9303','2013-06-03','14:30:00',4.49),('9303','2013-06-03','14:35:00',4.6),('9303','2013-06-03','14:40:00',3.49),('9303','2013-06-03','14:45:00',3.26),('9303','2013-06-03','14:50:00',3.37),('9303','2013-06-03','14:55:00',3.38),('9303','2013-06-03','15:00:00',3.69),('9303','2013-06-03','15:05:00',2.99),('9303','2013-06-03','15:10:00',3.88),('9303','2013-06-03','15:15:00',3.17),('9303','2013-06-03','15:20:00',2.93),('9303','2013-06-03','15:25:00',3.83),('9303','2013-06-03','15:30:00',3.71),('9303','2013-06-03','15:35:00',3.68),('9303','2013-06-03','15:40:00',3.6),('9303','2013-06-03','15:45:00',3.55),('9303','2013-06-03','15:50:00',3.51),('9303','2013-06-03','15:55:00',3.45),('9303','2013-06-03','16:00:00',3.39),('9303','2013-06-03','16:05:00',3.34),('9303','2013-06-03','16:10:00',3.34),('9303','2013-06-03','16:15:00',3.16),('9303','2013-06-03','16:20:00',3.08),('9303','2013-06-03','16:25:00',3.05),('9303','2013-06-03','16:30:00',3.21),('9303','2013-06-03','16:35:00',2.97),('9303','2013-06-03','16:40:00',3.02),('9303','2013-06-03','16:45:00',2.51),('9303','2013-06-03','16:50:00',1.88),('9303','2013-06-03','16:55:00',1.69),('9303','2013-06-03','17:00:00',2.35),('9303','2013-06-03','17:05:00',2.54),('9303','2013-06-03','17:10:00',2.62),('9303','2013-06-03','17:15:00',2.14),('9303','2013-06-03','17:20:00',1.85),('9303','2013-06-03','17:25:00',1.25),('9303','2013-06-02','08:50:00',1.03),('9303','2013-06-02','09:10:00',1.06),('9303','2013-06-02','09:15:00',1.1),('9303','2013-06-02','09:20:00',2.22),('9303','2013-06-02','09:25:00',3.15),('9303','2013-06-02','09:30:00',3.05),('9303','2013-06-02','09:35:00',3.03),('9303','2013-06-02','09:40:00',3.03),('9303','2013-06-02','09:45:00',3.06),('9303','2013-06-02','09:50:00',3.12),('9303','2013-06-02','09:55:00',3.07),('9303','2013-06-02','10:00:00',3.22),('9303','2013-06-02','10:05:00',3.31),('9303','2013-06-02','10:10:00',3.37),('9303','2013-06-02','10:15:00',3.42),('9303','2013-06-02','10:20:00',3.47),('9303','2013-06-02','10:25:00',3.57),('9303','2013-06-02','10:30:00',3.69),('9303','2013-06-02','10:35:00',3.98),('9303','2013-06-02','10:40:00',4.12),('9303','2013-06-02','10:45:00',1.86),('9303','2013-06-02','10:50:00',2.22),('9303','2013-06-02','10:55:00',2.41),('9303','2013-06-02','11:00:00',4.09),('9303','2013-06-02','11:05:00',4.22),('9303','2013-06-02','11:10:00',4.12),('9303','2013-06-02','11:15:00',2.2),('9303','2013-06-02','11:20:00',3.3),('9303','2013-06-02','11:25:00',3.25),('9303','2013-06-02','11:30:00',4.31),('9303','2013-06-02','11:35:00',1.56),('9303','2013-06-02','11:40:00',1.52),('9303','2013-06-02','11:45:00',1.19),('9303','2013-06-02','11:50:00',2.49),('9303','2013-06-02','11:55:00',4.16),('9303','2013-06-02','12:00:00',2.62),('9303','2013-06-02','12:05:00',1.94),('9303','2013-06-02','12:10:00',2.75),('9303','2013-06-02','12:15:00',4.05),('9303','2013-06-02','12:20:00',2.74),('9303','2013-06-02','12:25:00',2.13),('9303','2013-06-02','12:30:00',4.87),('9303','2013-06-02','12:35:00',4.76),('9303','2013-06-02','12:40:00',2.74),('9303','2013-06-02','12:45:00',4.4),('9303','2013-06-02','12:50:00',1.46),('9303','2013-06-02','12:55:00',1.87),('9303','2013-06-02','13:00:00',2.94),('9303','2013-06-02','13:05:00',3.64),('9303','2013-06-02','13:10:00',2.75),('9303','2013-06-02','13:15:00',4.72),('9303','2013-06-02','13:20:00',4.51),('9303','2013-06-02','13:25:00',4.4),('9303','2013-06-02','13:30:00',4.33),('9303','2013-06-02','13:35:00',4.32),('9303','2013-06-02','13:40:00',4.31),('9303','2013-06-02','13:45:00',4.3),('9303','2013-06-02','13:50:00',4.29),('9303','2013-06-02','13:55:00',4.28),('9303','2013-06-02','14:00:00',4.26),('9303','2013-06-02','14:05:00',4.23),('9303','2013-06-02','14:10:00',4.24),('9303','2013-06-02','14:15:00',4.22),('9303','2013-06-02','14:20:00',4.08),('9303','2013-06-02','14:25:00',4.18),('9303','2013-06-02','14:30:00',4.15),('9303','2013-06-02','14:35:00',4.07),('9303','2013-06-02','14:40:00',4.07),('9303','2013-06-02','14:45:00',4.02),('9303','2013-06-02','14:50:00',3.98),('9303','2013-06-02','14:55:00',3.98),('9303','2013-06-02','15:00:00',3.94),('9303','2013-06-02','15:05:00',3.91),('9303','2013-06-02','15:10:00',3.89),('9303','2013-06-02','15:15:00',3.85),('9303','2013-06-02','15:20:00',3.84),('9303','2013-06-02','15:25:00',3.31),('9303','2013-06-02','15:30:00',3.86),('9303','2013-06-02','15:35:00',3.07),('9303','2013-06-02','15:40:00',2.32),('9303','2013-06-02','15:45:00',2.66),('9303','2013-06-02','15:50:00',3.54),('9303','2013-06-02','15:55:00',2.68),('9303','2013-06-02','16:00:00',3.47),('9303','2013-06-02','16:05:00',3.37),('9303','2013-06-02','16:10:00',3.43),('9303','2013-06-02','16:15:00',3.43),('9303','2013-06-02','16:20:00',3.05),('9303','2013-06-02','16:25:00',3.25),('9303','2013-06-02','16:30:00',3.08),('9303','2013-06-02','16:35:00',3.02),('9303','2013-06-02','16:40:00',3.01),('9303','2013-06-02','16:45:00',2.73),('9303','2013-06-02','16:50:00',2.82),('9303','2013-06-02','16:55:00',2.72),('9303','2013-06-02','17:00:00',2.65),('9303','2013-06-02','17:05:00',2.04),('9303','2013-06-02','17:10:00',2.46),('9303','2013-06-02','17:15:00',2.01),('9303','2013-06-02','17:20:00',2.18),('9303','2013-06-02','17:25:00',2.1),('9303','2013-06-02','17:30:00',1.88),('9303','2013-06-02','17:35:00',1.85),('9303','2013-06-02','17:40:00',1.2),('9303','2013-06-01','07:40:00',1.07),('9303','2013-06-01','07:45:00',1.19),('9303','2013-06-01','07:55:00',1.3),('9303','2013-06-01','08:15:00',1.16),('9303','2013-06-01','08:20:00',1.1),('9303','2013-06-01','08:35:00',1.69),('9303','2013-06-01','10:35:00',1.07),('9303','2013-06-01','10:40:00',1.13),('9303','2013-06-01','10:50:00',1.92),('9303','2013-06-01','10:55:00',1.9),('9303','2013-06-01','11:50:00',1.22),('9303','2013-06-01','11:55:00',1.65),('9303','2013-06-01','12:00:00',2.08),('9303','2013-06-01','12:05:00',2.97),('9303','2013-06-01','12:10:00',3.19),('9303','2013-06-01','12:15:00',1.4),('9303','2013-06-01','12:25:00',1.1),('9303','2013-06-01','12:30:00',1.1),('9303','2013-06-01','12:45:00',1.48),('9303','2013-06-01','12:50:00',1.81),('9303','2013-06-01','12:55:00',1.79),('9303','2013-06-01','13:00:00',1.98),('9303','2013-06-01','13:05:00',2.15),('9303','2013-06-01','13:10:00',2.35),('9303','2013-06-01','13:15:00',2.42),('9303','2013-06-01','13:20:00',2.16),('9303','2013-06-01','13:25:00',1.71),('9303','2013-06-01','13:30:00',1.53),('9303','2013-06-01','13:35:00',1.18),('9303','2013-06-01','13:40:00',1.02),('9303','2013-06-01','13:45:00',1.1),('9303','2013-06-01','13:50:00',1.2),('9303','2013-06-01','13:55:00',1.37),('9303','2013-06-01','14:00:00',1.73),('9303','2013-06-01','14:05:00',2.25),('9303','2013-06-01','14:10:00',2.27),('9303','2013-06-01','14:15:00',2.38),('9303','2013-06-01','14:20:00',2.64),('9303','2013-06-01','14:25:00',1.62),('9303','2013-06-01','14:30:00',1.28),('9303','2013-06-01','14:35:00',1.32),('9303','2013-06-01','14:40:00',1.24),('9303','2013-06-01','14:45:00',1.15),('9303','2013-06-01','14:50:00',1.05),('9303','2014-04-02','08:50:00',1.03),('9303','2014-04-02','08:55:00',1.93),('9303','2014-04-02','09:55:00',2.25),('9303','2014-04-02','10:00:00',2.35),('9303','2014-04-02','10:05:00',2.56),('9303','2014-04-02','10:10:00',3.06),('9303','2014-04-02','10:15:00',3.24),('9303','2014-04-02','10:20:00',3.33),('9303','2014-04-02','10:25:00',3.23),('9303','2014-04-02','10:30:00',1.27),('9303','2014-04-02','10:45:00',1.31),('9303','2014-04-02','10:50:00',2.83),('9303','2014-04-02','10:55:00',3.7),('9303','2014-04-02','11:00:00',3.54),('9303','2014-04-02','11:05:00',2.92),('9303','2014-04-02','11:10:00',1.33),('9303','2014-04-02','11:15:00',2.91),('9303','2014-04-02','11:20:00',3),('9303','2014-04-02','11:25:00',4.03),('9303','2014-04-02','11:30:00',3.02),('9303','2014-04-02','11:35:00',2.52),('9303','2014-04-02','11:40:00',1.85),('9303','2014-04-02','11:45:00',3.03),('9303','2014-04-02','11:50:00',4.13),('9303','2014-04-02','11:55:00',4.09),('9303','2014-04-02','12:00:00',4.24),('9303','2014-04-02','12:05:00',2.36),('9303','2014-04-02','12:10:00',1.62),('9303','2014-04-02','12:15:00',3.3),('9303','2014-04-02','12:20:00',4.36),('9303','2014-04-02','12:25:00',4.16),('9303','2014-04-02','12:30:00',4.32),('9303','2014-04-02','12:35:00',4.04),('9303','2014-04-02','12:40:00',3.47),('9303','2014-04-02','12:45:00',3.43),('9303','2014-04-02','12:50:00',3.58),('9303','2014-04-02','12:55:00',2.56),('9303','2014-04-02','13:00:00',4.39),('9303','2014-04-02','13:05:00',1.47),('9303','2014-04-02','13:10:00',3.44),('9303','2014-04-02','13:15:00',1.92),('9303','2014-04-02','13:20:00',2.55),('9303','2014-04-02','13:25:00',2.94),('9303','2014-04-02','13:30:00',3.01),('9303','2014-04-02','13:35:00',4.42),('9303','2014-04-02','13:40:00',4.23),('9303','2014-04-02','13:45:00',4.31),('9303','2014-04-02','13:50:00',4.14),('9303','2014-04-02','13:55:00',4.26),('9303','2014-04-02','14:00:00',4.2),('9303','2014-04-02','14:05:00',4.04),('9303','2014-04-02','14:10:00',4.19),('9303','2014-04-02','14:15:00',4.08),('9303','2014-04-02','14:20:00',4.04),('9303','2014-04-02','14:25:00',4.08),('9303','2014-04-02','14:30:00',3.93),('9303','2014-04-02','14:35:00',3.87),('9303','2014-04-02','14:40:00',3.94),('9303','2014-04-02','14:45:00',3.89),('9303','2014-04-02','14:50:00',3.36),('9303','2014-04-02','14:55:00',3.09),('9303','2014-04-02','15:00:00',3.61),('9303','2014-04-02','15:05:00',3.61),('9303','2014-04-02','15:10:00',3.38),('9303','2014-04-02','15:15:00',3.38),('9303','2014-04-02','15:20:00',3.39),('9303','2014-04-02','15:25:00',3.31),('9303','2014-04-02','15:30:00',3.12),('9303','2014-04-02','15:35:00',3.03),('9303','2014-04-02','15:40:00',3.23),('9303','2014-04-02','15:45:00',3.24),('9303','2014-04-02','15:50:00',3.18),('9303','2014-04-02','15:55:00',2.79),('9303','2014-04-02','16:00:00',2.92),('9303','2014-04-02','16:05:00',2.9),('9303','2014-04-02','16:10:00',2.82),('9303','2014-04-02','16:15:00',2.78),('9303','2014-04-02','16:20:00',2.65),('9303','2014-04-02','16:25:00',2.62),('9303','2014-04-02','16:30:00',2.59),('9303','2014-04-02','16:35:00',2.46),('9303','2014-04-02','16:40:00',2.38),('9303','2014-04-02','16:45:00',2.26),('9303','2014-04-02','16:50:00',2.03),('9303','2014-04-02','16:55:00',1.98),('9303','2014-04-02','17:00:00',2.07),('9303','2014-04-02','17:05:00',1.86),('9303','2014-04-02','17:10:00',1.77),('9303','2014-04-02','17:15:00',1.58),('9303','2014-04-02','17:20:00',1.58),('9303','2014-04-02','17:25:00',1.48),('9303','2014-04-02','17:30:00',1.3),('9303','2014-04-02','17:35:00',1.28),('9303','2014-04-02','17:50:00',1.11),('9303','2013-05-31','07:40:00',1.09),('9303','2013-05-31','07:45:00',1.16),('9303','2013-05-31','07:50:00',1.26),('9303','2013-05-31','07:55:00',1.39),('9303','2013-05-31','08:00:00',1.5),('9303','2013-05-31','08:05:00',1.55),('9303','2013-05-31','08:10:00',1.65),('9303','2013-05-31','08:15:00',1.73),('9303','2013-05-31','08:20:00',1.8),('9303','2013-05-31','08:25:00',1.93),('9303','2013-05-31','08:30:00',1.79),('9303','2013-05-31','08:35:00',1.46),('9303','2013-05-31','08:40:00',2.47),('9303','2013-05-31','08:45:00',2.45),('9303','2013-05-31','08:50:00',2.89),('9303','2013-05-31','08:55:00',1.53),('9303','2013-05-31','09:10:00',1.17),('9303','2013-05-31','09:15:00',1.91),('9303','2013-05-31','09:30:00',1.04),('9303','2013-05-31','09:35:00',1.69),('9303','2013-05-31','09:40:00',1.89),('9303','2013-05-31','09:45:00',3.36),('9303','2013-05-31','09:50:00',3.51),('9303','2013-05-31','09:55:00',3.65),('9303','2013-05-31','10:00:00',3.37),('9303','2013-05-31','10:05:00',2.97),('9303','2013-05-31','10:10:00',2.11),('9303','2013-05-31','10:15:00',2.37),('9303','2013-05-31','10:20:00',3.1),('9303','2013-05-31','10:25:00',1.01),('9303','2013-05-31','10:30:00',1.27),('9303','2013-05-31','10:35:00',2.09),('9303','2013-05-31','10:40:00',3.56),('9303','2013-05-31','10:45:00',4.33),('9303','2013-05-31','10:50:00',2.27),('9303','2013-05-31','10:55:00',3.12),('9303','2013-05-31','11:00:00',1.52),('9303','2013-05-31','11:05:00',1.92),('9303','2013-05-31','11:10:00',4.1),('9303','2013-05-31','11:15:00',3.77),('9303','2013-05-31','11:20:00',1.39),('9303','2013-05-31','11:25:00',3.21),('9303','2013-05-31','11:30:00',4.69),('9303','2013-05-31','11:35:00',1.74),('9303','2013-05-31','11:45:00',3.76),('9303','2013-05-31','11:50:00',3.61),('9303','2013-05-31','11:55:00',2.72),('9303','2013-05-31','12:00:00',2.56),('9303','2013-05-31','12:05:00',4.65),('9303','2013-05-31','12:10:00',3.82),('9303','2013-05-31','12:15:00',1.52),('9303','2013-05-31','12:20:00',1.6),('9303','2013-05-31','12:25:00',3.73),('9303','2013-05-31','12:30:00',1.64),('9303','2013-05-31','12:35:00',1.57),('9303','2013-05-31','12:40:00',4.6),('9303','2013-05-31','12:45:00',2.39),('9303','2013-05-31','12:55:00',1.5),('9303','2013-05-31','13:00:00',4.67),('9303','2013-05-31','13:05:00',2.08),('9303','2013-05-31','13:20:00',1.09),('9303','2013-05-31','13:25:00',1.84),('9303','2013-05-31','13:30:00',3.39),('9303','2013-05-31','13:35:00',4.45),('9303','2013-05-31','13:40:00',2.65),('9303','2013-05-31','13:45:00',1.53),('9303','2013-05-31','14:00:00',2.27),('9303','2013-05-31','15:05:00',1.54),('9303','2013-05-31','15:10:00',1.66),('9303','2013-05-31','15:15:00',2.45),('9303','2013-05-31','15:20:00',4.16),('9303','2013-05-31','15:25:00',3.49),('9303','2013-05-31','15:30:00',2.8),('9303','2013-05-31','15:35:00',2.03),('9303','2013-05-31','15:40:00',1.69),('9303','2013-05-31','15:45:00',1.51),('9303','2013-05-31','15:50:00',2.18),('9303','2013-05-31','15:55:00',2.17),('9303','2013-05-31','16:00:00',1.5),('9303','2013-05-31','16:05:00',1.22),('9303','2013-05-31','16:25:00',1.2),('9303','2013-05-31','16:30:00',1.11),('9303','2013-05-31','16:40:00',1.06),('9303','2013-05-31','16:45:00',1.14),('9303','2013-05-30','08:25:00',1.07),('9303','2013-05-30','08:40:00',2.26),('9303','2013-05-30','08:45:00',2.33),('9303','2013-05-30','08:50:00',2.4),('9303','2013-05-30','08:55:00',2.47),('9303','2013-05-30','09:00:00',2.57),('9303','2013-05-30','09:05:00',2.6),('9303','2013-05-30','09:10:00',2.71),('9303','2013-05-30','09:15:00',2.76),('9303','2013-05-30','09:20:00',2.9),('9303','2013-05-30','09:25:00',2.92),('9303','2013-05-30','09:30:00',3.19),('9303','2013-05-30','09:35:00',3.15),('9303','2013-05-30','09:40:00',3.28),('9303','2013-05-30','09:45:00',3.05),('9303','2013-05-30','09:50:00',3.79),('9303','2013-05-30','09:55:00',2.33),('9303','2013-05-30','10:05:00',1.44),('9303','2013-05-30','10:10:00',3.52),('9303','2013-05-30','10:15:00',1.16),('9303','2013-05-30','10:20:00',3.96),('9303','2013-05-30','10:25:00',1.25),('9303','2013-05-30','10:40:00',1.54),('9303','2013-05-30','10:45:00',4.14),('9303','2013-05-30','10:50:00',4.43),('9303','2013-05-30','10:55:00',4.46),('9303','2013-05-30','11:00:00',4.13),('9303','2013-05-30','11:05:00',3.75),('9303','2013-05-30','11:10:00',1.85),('9303','2013-05-30','11:15:00',1.88),('9303','2013-05-30','11:20:00',4.11),('9303','2013-05-30','11:25:00',2.36),('9303','2013-05-30','11:30:00',2.74),('9303','2013-05-30','11:35:00',4.15),('9303','2013-05-30','11:40:00',4.7),('9303','2013-05-30','11:45:00',3.22),('9303','2013-05-30','11:50:00',4.9),('9303','2013-05-30','12:00:00',3.23),('9303','2013-05-30','12:05:00',4.96),('9303','2013-05-30','12:10:00',3.67),('9303','2013-05-30','12:15:00',3.65),('9303','2013-05-30','12:20:00',4.93),('9303','2013-05-30','12:25:00',3.95),('9303','2013-05-30','12:30:00',3.34),('9303','2013-05-30','12:35:00',3.25),('9303','2013-05-30','12:40:00',4.01),('9303','2013-05-30','12:45:00',2.07),('9303','2013-05-30','12:50:00',3.1),('9303','2013-05-30','12:55:00',4.63),('9303','2013-05-30','13:00:00',3.71),('9303','2013-05-30','13:05:00',2.06),('9303','2013-05-30','13:10:00',1.85),('9303','2013-05-30','13:15:00',2.46),('9303','2013-05-30','13:20:00',2.48),('9303','2013-05-30','13:25:00',1.71),('9303','2013-05-30','13:30:00',2.41),('9303','2013-05-30','13:35:00',1.54),('9303','2013-05-30','13:40:00',3.98),('9303','2013-05-30','13:45:00',3.73),('9303','2013-05-30','13:50:00',1.8),('9303','2013-05-30','13:55:00',1.53),('9303','2013-05-30','14:00:00',4.63),('9303','2013-05-30','14:05:00',4.97),('9303','2013-05-30','14:10:00',3.82),('9303','2013-05-30','14:15:00',1.78),('9303','2013-05-30','14:20:00',3.93),('9303','2013-05-30','14:25:00',2.53),('9303','2013-05-30','14:30:00',4.54),('9303','2013-05-30','14:35:00',3.55),('9303','2013-05-30','14:40:00',4.54),('9303','2013-05-30','14:45:00',4.46),('9303','2013-05-30','14:50:00',4.33),('9303','2013-05-30','14:55:00',4.35),('9303','2013-05-30','15:00:00',4.34),('9303','2013-05-30','15:05:00',4.38),('9303','2013-05-30','15:10:00',1.14),('9303','2013-05-30','15:15:00',4.42),('9303','2013-05-30','15:20:00',4.25),('9303','2013-05-30','15:25:00',4.16),('9303','2013-05-30','15:30:00',4.2),('9303','2013-05-30','15:35:00',4.27),('9303','2013-05-30','15:40:00',4.17),('9303','2013-05-30','15:45:00',3.28),('9303','2013-05-30','15:50:00',3.8),('9303','2013-05-30','15:55:00',3.05),('9303','2013-05-30','16:00:00',3.56),('9303','2013-05-30','16:05:00',3.68),('9303','2013-05-30','16:10:00',3.75),('9303','2013-05-30','16:15:00',3.56),('9303','2013-05-30','16:20:00',3.19),('9303','2013-05-30','16:25:00',2.41),('9303','2013-05-30','16:30:00',1.38),('9303','2013-05-30','16:35:00',1.35),('9303','2013-05-30','16:45:00',2),('9303','2013-05-30','16:50:00',2.46),('9303','2013-05-30','16:55:00',2.39),('9303','2013-05-30','17:00:00',1.15),('9303','2013-05-30','17:05:00',1.77),('9303','2013-05-30','18:45:00',1.06),('9303','2013-05-29','07:40:00',1.03),('9303','2013-05-29','07:45:00',1.11),('9303','2013-05-29','07:50:00',1.2),('9303','2013-05-29','07:55:00',1.31),('9303','2013-05-29','08:00:00',1.4),('9303','2013-05-29','08:05:00',1.5),('9303','2013-05-29','08:10:00',1.61),('9303','2013-05-29','08:15:00',1.69),('9303','2013-05-29','08:20:00',1.77),('9303','2013-05-29','08:25:00',1.85),('9303','2013-05-29','08:30:00',1.97),('9303','2013-05-29','08:35:00',2.05),('9303','2013-05-29','08:40:00',2.11),('9303','2013-05-29','08:45:00',2.2),('9303','2013-05-29','08:50:00',2.32),('9303','2013-05-29','08:55:00',2.4),('9303','2013-05-29','09:00:00',2.5),('9303','2013-05-29','09:05:00',2.58),('9303','2013-05-29','09:10:00',2.66),('9303','2013-05-29','09:15:00',2.74),('9303','2013-05-29','09:20:00',2.78),('9303','2013-05-29','09:25:00',2.85),('9303','2013-05-29','09:30:00',2.91),('9303','2013-05-29','09:35:00',2.99),('9303','2013-05-29','09:40:00',3.06),('9303','2013-05-29','09:45:00',3.13),('9303','2013-05-29','09:50:00',3.2),('9303','2013-05-29','09:55:00',3.24),('9303','2013-05-29','10:00:00',3.28),('9303','2013-05-29','10:05:00',3.37),('9303','2013-05-29','10:10:00',3.39),('9303','2013-05-29','10:15:00',3.44),('9303','2013-05-29','10:20:00',3.53),('9303','2013-05-29','10:25:00',3.6),('9303','2013-05-29','10:30:00',3.67),('9303','2013-05-29','10:35:00',3.74),('9303','2013-05-29','10:40:00',3.77),('9303','2013-05-29','10:45:00',3.85),('9303','2013-05-29','10:50:00',3.87),('9303','2013-05-29','10:55:00',3.96),('9303','2013-05-29','11:00:00',3.98),('9303','2013-05-29','11:05:00',4.05),('9303','2013-05-29','11:10:00',4.14),('9303','2013-05-29','11:15:00',2.79),('9303','2013-05-29','11:20:00',3.79),('9303','2013-05-29','11:25:00',2.93),('9303','2013-05-29','11:30:00',4.72),('9303','2013-05-29','11:35:00',4.58),('9303','2013-05-29','11:40:00',3.37),('9303','2013-05-29','11:45:00',3.8),('9303','2013-05-29','11:50:00',3.94),('9303','2013-05-29','11:55:00',3.88),('9303','2013-05-29','12:00:00',4.58),('9303','2013-05-29','12:05:00',3.44),('9303','2013-05-29','12:10:00',3.7),('9303','2013-05-29','12:15:00',3.91),('9303','2013-05-29','12:20:00',4.58),('9303','2013-05-29','12:25:00',4.44),('9303','2013-05-29','12:30:00',4.49),('9303','2013-05-29','12:35:00',4.49),('9303','2013-05-29','12:40:00',4.42),('9303','2013-05-29','12:45:00',4.49),('9303','2013-05-29','12:50:00',4.3),('9303','2013-05-29','12:55:00',4.42),('9303','2013-05-29','13:00:00',4.53),('9303','2013-05-29','13:05:00',4.64),('9303','2013-05-29','13:10:00',4.11),('9303','2013-05-29','13:15:00',4.64),('9303','2013-05-29','13:20:00',4.92),('9303','2013-05-29','13:25:00',4.97),('9303','2013-05-29','13:30:00',4.81),('9303','2013-05-29','13:35:00',3.81),('9303','2013-05-29','13:40:00',4.4),('9303','2013-05-29','13:45:00',4.27),('9303','2013-05-29','13:50:00',3.9),('9303','2013-05-29','13:55:00',3.72),('9303','2013-05-29','14:00:00',4.44),('9303','2013-05-29','14:05:00',4.29),('9303','2013-05-29','14:10:00',4.22),('9303','2013-05-29','14:15:00',4.34),('9303','2013-05-29','14:20:00',4.37),('9303','2013-05-29','14:25:00',3.68),('9303','2013-05-29','14:30:00',4.36),('9303','2013-05-29','14:35:00',3.96),('9303','2013-05-29','14:40:00',4.48),('9303','2013-05-29','14:45:00',4.36),('9303','2013-05-29','14:50:00',3.85),('9303','2013-05-29','14:55:00',4.03),('9303','2013-05-29','15:00:00',4.36),('9303','2013-05-29','15:05:00',4.39),('9303','2013-05-29','15:10:00',3.99),('9303','2013-05-29','15:15:00',2.65),('9303','2013-05-29','15:20:00',3),('9303','2013-05-29','15:25:00',2.54),('9303','2013-05-29','15:30:00',2.77),('9303','2013-05-29','15:35:00',3.03),('9303','2013-05-29','15:40:00',2.87),('9303','2013-05-29','15:45:00',2.83),('9303','2013-05-29','15:50:00',2.72),('9303','2013-05-29','15:55:00',2.81),('9303','2013-05-29','16:00:00',2.51),('9303','2013-05-29','16:05:00',2.5),('9303','2013-05-29','16:10:00',2.09),('9303','2013-05-29','16:15:00',1.98),('9303','2013-05-29','16:20:00',1.91),('9303','2013-05-29','16:25:00',2.05),('9303','2013-05-29','16:30:00',1.8),('9303','2013-05-29','16:35:00',1.72),('9303','2013-05-29','16:40:00',2.04),('9303','2013-05-29','16:45:00',1.78),('9303','2013-05-29','16:50:00',1.45),('9303','2013-05-29','16:55:00',1.37),('9303','2013-05-29','17:00:00',1.29),('9303','2013-05-29','17:40:00',1.44),('9303','2013-05-29','17:45:00',1.04),('9303','2013-05-29','18:05:00',1.03),('9303','2013-05-29','18:10:00',1),('9303','2013-05-29','18:15:00',1.61),('9303','2013-05-29','18:20:00',1.25),('9303','2013-05-28','07:45:00',1.04),('9303','2013-05-28','07:50:00',1.05),('9303','2013-05-28','07:55:00',1.03),('9303','2013-05-28','08:00:00',1.09),('9303','2013-05-28','08:05:00',1.17),('9303','2013-05-28','08:10:00',1.32),('9303','2013-05-28','08:15:00',1.59),('9303','2013-05-28','08:20:00',1.69),('9303','2013-05-28','08:25:00',1.5),('9303','2013-05-28','08:30:00',1.7),('9303','2013-05-28','08:35:00',1.57),('9303','2013-05-28','08:40:00',1.4),('9303','2013-05-28','08:45:00',1.33),('9303','2013-05-28','08:50:00',1.58),('9303','2013-05-28','08:55:00',1.41),('9303','2013-05-28','09:00:00',1.53),('9303','2013-05-28','09:05:00',1.7),('9303','2013-05-28','09:10:00',1.56),('9303','2013-05-28','09:15:00',1.48),('9303','2013-05-28','09:20:00',1.71),('9303','2013-05-28','09:25:00',1.98),('9303','2013-05-28','09:30:00',2.12),('9303','2013-05-28','09:35:00',2.21),('9303','2013-05-28','09:40:00',2.14),('9303','2013-05-28','09:45:00',1.97),('9303','2013-05-28','09:50:00',2),('9303','2013-05-28','09:55:00',2.1),('9303','2013-05-28','10:00:00',1.94),('9303','2013-05-28','10:05:00',2.1),('9303','2013-05-28','10:10:00',2.36),('9303','2013-05-28','10:15:00',2.45),('9303','2013-05-28','10:20:00',2.58),('9303','2013-05-28','10:25:00',2.54),('9303','2013-05-28','10:30:00',2.84),('9303','2013-05-28','10:35:00',2.91),('9303','2013-05-28','10:40:00',2.72),('9303','2013-05-28','10:45:00',2.44),('9303','2013-05-28','10:50:00',2.68),('9303','2013-05-28','10:55:00',2.29),('9303','2013-05-28','11:00:00',2.33),('9303','2013-05-28','11:05:00',2.2),('9303','2013-05-28','11:10:00',2.37),('9303','2013-05-28','11:15:00',1.95),('9303','2013-05-28','11:20:00',2.11),('9303','2013-05-28','11:25:00',1.98),('9303','2013-05-28','11:30:00',3.86),('9303','2013-05-28','11:35:00',3.09),('9303','2013-05-28','11:40:00',3.57),('9303','2013-05-28','11:45:00',3.44),('9303','2013-05-28','11:50:00',1.07),('9303','2013-05-28','11:55:00',1.54),('9303','2013-05-28','12:00:00',1.49),('9303','2013-05-28','12:05:00',1.72),('9303','2013-05-28','12:10:00',2.44),('9303','2013-05-28','12:15:00',2.49),('9303','2013-05-28','12:20:00',2.14),('9303','2013-05-28','12:25:00',2.19),('9303','2013-05-28','12:30:00',2.51),('9303','2013-05-28','12:35:00',2.45),('9303','2013-05-28','12:40:00',2.46),('9303','2013-05-28','12:45:00',2.8),('9303','2013-05-28','12:50:00',2.5),('9303','2013-05-28','12:55:00',2.53),('9303','2013-05-28','13:00:00',2.61),('9303','2013-05-28','13:05:00',2.8),('9303','2013-05-28','13:10:00',2.95),('9303','2013-05-28','13:15:00',2.47),('9303','2013-05-28','13:20:00',3.27),('9303','2013-05-28','13:25:00',1.73),('9303','2013-05-28','13:30:00',2),('9303','2013-05-28','13:35:00',1.67),('9303','2013-05-28','13:40:00',1.86),('9303','2013-05-28','13:45:00',1.77),('9303','2013-05-28','13:50:00',2.49),('9303','2013-05-28','13:55:00',2.47),('9303','2013-05-28','14:00:00',2.51),('9303','2013-05-28','14:05:00',2.61),('9303','2013-05-28','14:10:00',3.85),('9303','2013-05-28','14:15:00',3.96),('9303','2013-05-28','14:20:00',2.35),('9303','2013-05-28','14:25:00',2.69),('9303','2013-05-28','14:30:00',3.34),('9303','2013-05-28','14:35:00',2.73),('9303','2013-05-28','14:40:00',3.03),('9303','2013-05-28','14:45:00',3.73),('9303','2013-05-28','14:50:00',2.85),('9303','2013-05-28','14:55:00',2.49),('9303','2013-05-28','15:00:00',2.19),('9303','2013-05-28','15:05:00',3.59),('9303','2013-05-28','15:10:00',1.66),('9303','2013-05-28','15:15:00',2.29),('9303','2013-05-28','15:20:00',3.02),('9303','2013-05-28','15:25:00',2.11),('9303','2013-05-28','15:30:00',1.41),('9303','2013-05-28','15:35:00',1.42),('9303','2013-05-28','15:40:00',2.07),('9303','2013-05-28','15:45:00',3.56),('9303','2013-05-28','15:50:00',3.04),('9303','2013-05-28','15:55:00',2.33),('9303','2013-05-28','16:00:00',1.52),('9303','2013-05-28','16:05:00',1.19),('9303','2013-05-28','16:10:00',1.31),('9303','2013-05-28','16:15:00',1.39),('9303','2013-05-28','16:20:00',2.12),('9303','2013-05-28','16:25:00',2.09),('9303','2013-05-28','16:30:00',2.06),('9303','2013-05-28','16:35:00',2.95),('9303','2013-05-28','16:40:00',2.73),('9303','2013-05-28','16:45:00',2.65),('9303','2013-05-28','16:50:00',2.57),('9303','2013-05-28','16:55:00',2.48),('9303','2013-05-28','17:00:00',2.42),('9303','2013-05-28','17:05:00',2.32),('9303','2013-05-28','17:10:00',2.18),('9303','2013-05-28','17:15:00',2.1),('9303','2013-05-28','17:20:00',2.01),('9303','2013-05-28','17:25:00',1.91),('9303','2013-05-28','17:30:00',1.8),('9303','2013-05-28','17:35:00',1.7),('9303','2013-05-28','17:40:00',1.61),('9303','2013-05-28','17:45:00',1.56),('9303','2013-05-28','17:50:00',1.5),('9303','2013-05-28','17:55:00',1.43),('9303','2013-05-28','18:00:00',1.39),('9303','2013-05-28','18:05:00',1.3),('9303','2013-05-27','07:35:00',1.01),('9303','2013-05-27','07:40:00',1.06),('9303','2013-05-27','07:45:00',1.18),('9303','2013-05-27','07:50:00',1.04),('9303','2013-05-27','08:00:00',1.28),('9303','2013-05-27','08:05:00',1.55),('9303','2013-05-27','08:10:00',1.8),('9303','2013-05-27','08:15:00',1.48),('9303','2013-05-27','08:20:00',1.69),('9303','2013-05-27','08:25:00',1.84),('9303','2013-05-27','08:30:00',1.97),('9303','2013-05-27','08:35:00',2.07),('9303','2013-05-27','08:40:00',2.15),('9303','2013-05-27','08:45:00',2.43),('9303','2013-05-27','08:50:00',2.48),('9303','2013-05-27','08:55:00',1.81),('9303','2013-05-27','09:00:00',2.54),('9303','2013-05-27','09:05:00',2.97),('9303','2013-05-27','09:10:00',2.79),('9303','2013-05-27','09:15:00',1.74),('9303','2013-05-27','09:20:00',2.06),('9303','2013-05-27','09:25:00',2.85),('9303','2013-05-27','09:30:00',3.11),('9303','2013-05-27','09:35:00',3.11),('9303','2013-05-27','09:40:00',3.17),('9303','2013-05-27','09:45:00',3.26),('9303','2013-05-27','09:50:00',2.27),('9303','2013-05-27','09:55:00',2.7),('9303','2013-05-27','10:00:00',3.57),('9303','2013-05-27','10:05:00',3.52),('9303','2013-05-27','10:10:00',3.61),('9303','2013-05-27','10:15:00',3.71),('9303','2013-05-27','10:20:00',2.66),('9303','2013-05-27','10:25:00',2.14),('9303','2013-05-27','10:30:00',2.45),('9303','2013-05-27','10:35:00',1.01),('9303','2013-05-27','10:40:00',1.58),('9303','2013-05-27','10:45:00',2.45),('9303','2013-05-27','10:50:00',2.07),('9303','2013-05-27','10:55:00',2.93),('9303','2013-05-27','11:00:00',2.93),('9303','2013-05-27','11:05:00',3.3),('9303','2013-05-27','11:10:00',2.57),('9303','2013-05-27','11:15:00',1.71),('9303','2013-05-27','11:20:00',3.16),('9303','2013-05-27','11:25:00',3.65),('9303','2013-05-27','11:30:00',2.24),('9303','2013-05-27','11:35:00',2.89),('9303','2013-05-27','11:40:00',3.29),('9303','2013-05-27','11:45:00',4.1),('9303','2013-05-27','11:50:00',1.89),('9303','2013-05-27','11:55:00',1.73),('9303','2013-05-27','12:00:00',4.79),('9303','2013-05-27','12:05:00',3.6),('9303','2013-05-27','12:10:00',2.95),('9303','2013-05-27','12:15:00',2.94),('9303','2013-05-27','12:20:00',3.28),('9303','2013-05-27','12:25:00',3.71),('9303','2013-05-27','12:30:00',4.41),('9303','2013-05-27','12:35:00',1.98),('9303','2013-05-27','12:40:00',3.69),('9303','2013-05-27','12:45:00',4.75),('9303','2013-05-27','12:50:00',4.74),('9303','2013-05-27','12:55:00',4.07),('9303','2013-05-27','13:00:00',3.43),('9303','2013-05-27','13:05:00',2.95),('9303','2013-05-27','13:10:00',4.76),('9303','2013-05-27','13:15:00',3.64),('9303','2013-05-27','13:20:00',4.55),('9303','2013-05-27','13:25:00',3.89),('9303','2013-05-27','13:30:00',4.72),('9303','2013-05-27','13:35:00',3.22),('9303','2013-05-27','13:40:00',4.91),('9303','2013-05-27','13:45:00',4.72),('9303','2013-05-27','13:50:00',3.28),('9303','2013-05-27','13:55:00',4.01),('9303','2013-05-27','14:00:00',4.39),('9303','2013-05-27','14:05:00',4.43),('9303','2013-05-27','14:10:00',4.3),('9303','2013-05-27','14:15:00',3.53),('9303','2013-05-27','14:20:00',3.61),('9303','2013-05-27','14:25:00',4),('9303','2013-05-27','14:30:00',4.25),('9303','2013-05-27','14:35:00',4.06),('9303','2013-05-27','14:40:00',1.15),('9303','2013-05-27','14:45:00',4.75),('9303','2013-05-27','14:50:00',4.42),('9303','2013-05-27','14:55:00',3.24),('9303','2013-05-27','15:00:00',2.69),('9303','2013-05-27','15:05:00',2.6),('9303','2013-05-27','15:10:00',4.12),('9303','2013-05-27','15:15:00',2.9),('9303','2013-05-27','15:20:00',3.32),('9303','2013-05-27','15:25:00',3.22),('9303','2013-05-27','15:30:00',3.46),('9303','2013-05-27','15:35:00',3.94),('9303','2013-05-27','15:40:00',3.18),('9303','2013-05-27','15:45:00',2.88),('9303','2013-05-27','15:50:00',3.54),('9303','2013-05-27','15:55:00',2.36),('9303','2013-05-27','16:00:00',2.98),('9303','2013-05-27','16:05:00',2.13),('9303','2013-05-27','16:10:00',2.52),('9303','2013-05-27','16:15:00',2.2),('9303','2013-05-27','16:20:00',3.56),('9303','2013-05-27','16:25:00',3.44),('9303','2013-05-27','16:30:00',3.14),('9303','2013-05-27','16:35:00',2.89),('9303','2013-05-27','16:40:00',1.34),('9303','2013-05-27','16:45:00',1.16),('9303','2013-05-27','16:50:00',1.16),('9303','2013-05-27','16:55:00',1.26),('9303','2013-05-27','17:00:00',1.32),('9303','2013-05-27','17:05:00',1.37),('9303','2013-05-27','17:10:00',1.67),('9303','2013-05-27','17:15:00',1.37),('9303','2013-05-27','17:20:00',1.19),('9303','2013-05-27','17:25:00',1.08),('9303','2013-05-27','17:30:00',1.06),('9303','2013-05-27','18:25:00',1.27),('9303','2013-05-27','18:30:00',1.11),('9303','2013-05-26','07:40:00',1.02),('9303','2013-05-26','07:45:00',1.24),('9303','2013-05-26','07:50:00',1.72),('9303','2013-05-26','08:05:00',1.92),('9303','2013-05-26','08:10:00',1.78),('9303','2013-05-26','08:20:00',1.13),('9303','2013-05-26','08:25:00',1.48),('9303','2013-05-26','08:30:00',2.08),('9303','2013-05-26','08:35:00',2.16),('9303','2013-05-26','08:40:00',2.31),('9303','2013-05-26','08:45:00',2.18),('9303','2013-05-26','08:50:00',2.13),('9303','2013-05-26','09:00:00',2.3),('9303','2013-05-26','09:10:00',1.83),('9303','2013-05-26','09:15:00',2.37),('9303','2013-05-26','09:25:00',1.27),('9303','2013-05-26','09:45:00',2),('9303','2013-05-26','10:00:00',1.08),('9303','2013-05-26','10:05:00',3.19),('9303','2013-05-26','10:10:00',3.89),('9303','2013-05-26','10:15:00',2.56),('9303','2013-05-26','10:20:00',3.34),('9303','2013-05-26','10:25:00',3.06),('9303','2013-05-26','10:30:00',3.32),('9303','2013-05-26','10:35:00',3.11),('9303','2013-05-26','10:40:00',3.92),('9303','2013-05-26','10:45:00',3.96),('9303','2013-05-26','10:50:00',4.11),('9303','2013-05-26','10:55:00',4.06),('9303','2013-05-26','11:00:00',3.99),('9303','2013-05-26','11:05:00',4.21),('9303','2013-05-26','11:10:00',4.23),('9303','2013-05-26','11:15:00',4.23),('9303','2013-05-26','11:20:00',4.3),('9303','2013-05-26','11:25:00',4.33),('9303','2013-05-26','11:30:00',4.5),('9303','2013-05-26','11:35:00',3.91),('9303','2013-05-26','11:40:00',4.48),('9303','2013-05-26','11:45:00',4.53),('9303','2013-05-26','11:50:00',4.55),('9303','2013-05-26','11:55:00',4.48),('9303','2013-05-26','12:00:00',4.5),('9303','2013-05-26','12:05:00',4.61),('9303','2013-05-26','12:10:00',4.55),('9303','2013-05-26','12:15:00',3.81),('9303','2013-05-26','12:20:00',4.23),('9303','2013-05-26','12:25:00',4.24),('9303','2013-05-26','12:30:00',4.78),('9303','2013-05-26','12:35:00',4.73),('9303','2013-05-26','12:40:00',4.25),('9303','2013-05-26','12:45:00',3.3),('9303','2013-05-26','12:50:00',4.77),('9303','2013-05-26','12:55:00',4.76),('9303','2013-05-26','13:00:00',4.79),('9303','2013-05-26','13:05:00',4.72),('9303','2013-05-26','13:10:00',4.67),('9303','2013-05-26','13:15:00',4.46),('9303','2013-05-26','13:20:00',4.79),('9303','2013-05-26','13:25:00',4.67),('9303','2013-05-26','13:30:00',4.67),('9303','2013-05-26','13:35:00',4.65),('9303','2013-05-26','13:40:00',4.62),('9303','2013-05-26','13:45:00',4.65),('9303','2013-05-26','13:50:00',4.08),('9303','2013-05-26','13:55:00',4.58),('9303','2013-05-26','14:00:00',4.54),('9303','2013-05-26','14:05:00',4.53),('9303','2013-05-26','14:10:00',4.45),('9303','2013-05-26','14:15:00',4.42),('9303','2013-05-26','14:20:00',4.42),('9303','2013-05-26','14:25:00',4.38),('9303','2013-05-26','14:30:00',4.38),('9303','2013-05-26','14:35:00',4.37),('9303','2013-05-26','14:40:00',4.3),('9303','2013-05-26','14:45:00',4.27),('9303','2013-05-26','14:50:00',4.27),('9303','2013-05-26','14:55:00',4.23),('9303','2013-05-26','15:00:00',4.16),('9303','2013-05-26','15:05:00',4.14),('9303','2013-05-26','15:10:00',4.12),('9303','2013-05-26','15:15:00',4.08),('9303','2013-05-26','15:20:00',4.03),('9303','2013-05-26','15:25:00',3.95),('9303','2013-05-26','15:30:00',3.89),('9303','2013-05-26','15:35:00',3.83),('9303','2013-05-26','15:40:00',3.81),('9303','2013-05-26','15:45:00',3.75),('9303','2013-05-26','15:50:00',3.69),('9303','2013-05-26','15:55:00',3.63),('9303','2013-05-26','16:00:00',3.6),('9303','2013-05-26','16:05:00',3.54),('9303','2013-05-26','16:10:00',3.49),('9303','2013-05-26','16:15:00',3.41),('9303','2013-05-26','16:20:00',3.34),('9303','2013-05-26','16:25:00',3.26),('9303','2013-05-26','16:30:00',3.19),('9303','2013-05-26','16:35:00',3.1),('9303','2013-05-26','16:40:00',3.04),('9303','2013-05-26','16:45:00',2.96),('9303','2013-05-26','16:50:00',2.89),('9303','2013-05-26','16:55:00',2.8),('9303','2013-05-26','17:00:00',2.73),('9303','2013-05-26','17:05:00',2.63),('9303','2013-05-26','17:10:00',2.5),('9303','2013-05-26','17:15:00',2.39),('9303','2013-05-26','17:20:00',2.27),('9303','2013-05-26','17:25:00',2.19),('9303','2013-05-26','17:30:00',2.09),('9303','2013-05-26','17:35:00',1.96),('9303','2013-05-26','17:40:00',1.91),('9303','2013-05-26','17:45:00',1.83),('9303','2013-05-26','17:50:00',1.75),('9303','2013-05-26','17:55:00',1.66),('9303','2013-05-26','18:00:00',1.54),('9303','2013-05-26','18:05:00',1.45),('9303','2013-05-26','18:10:00',1.35),('9303','2013-05-26','18:15:00',1.21),('9303','2013-05-26','18:20:00',1.1),('9303','2013-05-26','18:25:00',1.01),('9303','2013-05-25','07:35:00',1.29),('9303','2013-05-25','07:40:00',1.1),('9303','2013-05-25','07:55:00',1.48),('9303','2013-05-25','08:00:00',1.86),('9303','2013-05-25','08:05:00',1.92),('9303','2013-05-25','08:10:00',1.49),('9303','2013-05-25','08:20:00',1.21),('9303','2013-05-25','08:25:00',2.27),('9303','2013-05-25','08:30:00',2.34),('9303','2013-05-25','08:35:00',1.24),('9303','2013-05-25','08:40:00',1.43),('9303','2013-05-25','08:45:00',1.25),('9303','2013-05-25','08:50:00',1.78),('9303','2013-05-25','08:55:00',2.54),('9303','2013-05-25','09:00:00',2.08),('9303','2013-05-25','09:05:00',2.9),('9303','2013-05-25','09:10:00',2.01),('9303','2013-05-25','09:15:00',3.08),('9303','2013-05-25','09:20:00',1.51),('9303','2013-05-25','09:25:00',1.53),('9303','2013-05-25','09:30:00',1.14),('9303','2013-05-25','09:35:00',2.24),('9303','2013-05-25','09:40:00',3.5),('9303','2013-05-25','09:45:00',2.79),('9303','2013-05-25','09:50:00',3.31),('9303','2013-05-25','09:55:00',2.25),('9303','2013-05-25','10:15:00',1.19),('9303','2013-05-25','10:40:00',1.3),('9303','2013-05-25','10:45:00',1.33),('9303','2013-05-25','10:50:00',1.32),('9303','2013-05-25','11:05:00',1.79),('9303','2013-05-25','11:10:00',3.86),('9303','2013-05-25','11:15:00',3.54),('9303','2013-05-25','11:20:00',3.24),('9303','2013-05-25','11:35:00',1.44),('9303','2013-05-25','11:40:00',2.32),('9303','2013-05-25','11:45:00',2.21),('9303','2013-05-25','11:50:00',1.66),('9303','2013-05-25','11:55:00',1.9),('9303','2013-05-25','12:00:00',1.43),('9303','2013-05-25','12:05:00',1.25),('9303','2013-05-25','12:10:00',1.58),('9303','2013-05-25','12:15:00',1.04),('9303','2013-05-25','12:20:00',1.25),('9303','2013-05-25','12:25:00',1.83),('9303','2013-05-25','12:30:00',1.29),('9303','2013-05-25','12:35:00',1.38),('9303','2013-05-25','12:40:00',1.69),('9303','2013-05-25','12:45:00',1.74),('9303','2013-05-25','12:50:00',1.24),('9303','2013-05-25','12:55:00',1.7),('9303','2013-05-25','13:05:00',1.9),('9303','2013-05-25','13:10:00',1.33),('9303','2013-05-25','13:15:00',1.73),('9303','2013-05-25','13:20:00',2.58),('9303','2013-05-25','13:25:00',2.56),('9303','2013-05-25','13:30:00',1.96),('9303','2013-05-25','13:35:00',1.24),('9303','2013-05-25','13:40:00',1.94),('9303','2013-05-25','13:45:00',2.15),('9303','2013-05-25','13:50:00',2.27),('9303','2013-05-25','13:55:00',3.59),('9303','2013-05-25','14:00:00',3.98),('9303','2013-05-25','14:05:00',4.07),('9303','2013-05-25','14:10:00',4.41),('9303','2013-05-25','14:15:00',4.42),('9303','2013-05-25','14:20:00',3.71),('9303','2013-05-25','14:25:00',1.85),('9303','2013-05-25','14:30:00',2.58),('9303','2013-05-25','14:35:00',2.3),('9303','2013-05-25','14:40:00',2.17),('9303','2013-05-25','14:45:00',2.18),('9303','2013-05-25','14:50:00',2.85),('9303','2013-05-25','14:55:00',1.99),('9303','2013-05-25','15:00:00',3.55),('9303','2013-05-25','15:05:00',3.41),('9303','2013-05-25','15:10:00',1.85),('9303','2013-05-25','15:15:00',2.47),('9303','2013-05-25','15:20:00',1.61),('9303','2013-05-25','15:25:00',2.59),('9303','2013-05-25','15:30:00',3.43),('9303','2013-05-25','15:35:00',4.17),('9303','2013-05-25','15:40:00',4.15),('9303','2013-05-25','15:45:00',3.72),('9303','2013-05-25','15:50:00',3.68),('9303','2013-05-25','15:55:00',3.42),('9303','2013-05-25','16:00:00',2.95),('9303','2013-05-25','16:05:00',1.81),('9303','2013-05-25','16:10:00',1.75),('9303','2013-05-25','16:15:00',1.39),('9303','2013-05-25','16:20:00',1.9),('9303','2013-05-25','16:25:00',1.45),('9303','2013-05-25','16:30:00',3.15),('9303','2013-05-25','16:35:00',2.99),('9303','2013-05-25','16:40:00',3.29),('9303','2013-05-25','16:45:00',1.71),('9303','2013-05-25','16:50:00',1.47),('9303','2013-05-25','17:05:00',1.06),('9303','2013-05-25','17:10:00',2.72),('9303','2013-05-25','17:15:00',2.47),('9303','2013-05-25','17:20:00',2.05),('9303','2013-05-25','17:35:00',1.41),('9303','2013-05-25','17:40:00',1.43),('9303','2013-05-25','17:50:00',1.12),('9303','2013-05-24','08:05:00',1.66),('9303','2013-05-24','08:10:00',1.77),('9303','2013-05-24','08:15:00',1.78),('9303','2013-05-24','08:25:00',1.26),('9303','2013-05-24','08:30:00',2),('9303','2013-05-24','08:35:00',1.67),('9303','2013-05-24','08:45:00',2.33),('9303','2013-05-24','08:50:00',2.38),('9303','2013-05-24','08:55:00',2.48),('9303','2013-05-24','09:00:00',2.63),('9303','2013-05-24','09:05:00',2.91),('9303','2013-05-24','09:20:00',1.68),('9303','2013-05-24','09:25:00',1.37),('9303','2013-05-24','09:30:00',2.63),('9303','2013-05-24','09:40:00',1.42),('9303','2013-05-24','09:50:00',1.25),('9303','2013-05-24','09:55:00',2.36),('9303','2013-05-24','10:00:00',2.81),('9303','2013-05-24','10:25:00',1.85),('9303','2013-05-24','10:30:00',3.52),('9303','2013-05-24','10:35:00',3.8),('9303','2013-05-24','10:40:00',4.03),('9303','2013-05-24','10:45:00',3.81),('9303','2013-05-24','10:50:00',3.68),('9303','2013-05-24','10:55:00',4.43),('9303','2013-05-24','11:00:00',3.87),('9303','2013-05-24','11:05:00',3.65),('9303','2013-05-24','11:10:00',3.86),('9303','2013-05-24','11:15:00',3.69),('9303','2013-05-24','11:20:00',4.39),('9303','2013-05-24','11:25:00',4.51),('9303','2013-05-24','11:30:00',3.41),('9303','2013-05-24','11:35:00',1.54),('9303','2013-05-24','11:45:00',2.63),('9303','2013-05-24','11:50:00',4.7),('9303','2013-05-24','11:55:00',3.61),('9303','2013-05-24','12:00:00',1.99),('9303','2013-05-24','12:05:00',2.48),('9303','2013-05-24','12:10:00',4.28),('9303','2013-05-24','12:15:00',2.97),('9303','2013-05-24','12:20:00',2.02),('9303','2013-05-24','12:25:00',3.49),('9303','2013-05-24','12:30:00',4.52),('9303','2013-05-24','12:35:00',1.98),('9303','2013-05-24','12:40:00',2.55),('9303','2013-05-24','12:45:00',2.6),('9303','2013-05-24','12:50:00',3.17),('9303','2013-05-24','12:55:00',2.63),('9303','2013-05-24','13:00:00',2.42),('9303','2013-05-24','13:05:00',1.94),('9303','2013-05-24','13:10:00',2.3),('9303','2013-05-24','13:15:00',2.9),('9303','2013-05-24','13:20:00',3.23),('9303','2013-05-24','13:25:00',2.33),('9303','2013-05-24','13:30:00',1.74),('9303','2013-05-24','13:35:00',3.33),('9303','2013-05-24','13:40:00',2.4),('9303','2013-05-24','13:45:00',1.16),('9303','2013-05-24','13:50:00',1.04),('9303','2013-05-24','13:55:00',2.44),('9303','2013-05-24','14:00:00',2.23),('9303','2013-05-24','14:05:00',2.07),('9303','2013-05-24','14:10:00',1.29),('9303','2013-05-24','14:15:00',4.08),('9303','2013-05-24','14:20:00',3.21),('9303','2013-05-24','14:25:00',2.39),('9303','2013-05-24','14:30:00',2.7),('9303','2013-05-24','14:35:00',3.3),('9303','2013-05-24','14:40:00',2.83),('9303','2013-05-24','14:45:00',2.63),('9303','2013-05-24','14:50:00',1.4),('9303','2013-05-24','14:55:00',1.76),('9303','2013-05-24','15:00:00',2.31),('9303','2013-05-24','15:05:00',3.23),('9303','2013-05-24','15:10:00',2.52),('9303','2013-05-24','15:15:00',2.45),('9303','2013-05-24','15:20:00',4.78),('9303','2013-05-24','15:25:00',3.31),('9303','2013-05-24','15:30:00',3.73),('9303','2013-05-24','15:35:00',3.05),('9303','2013-05-24','15:40:00',3.16),('9303','2013-05-24','15:45:00',4.04),('9303','2013-05-24','15:50:00',4.64),('9303','2013-05-24','15:55:00',4.22),('9303','2013-05-24','16:00:00',2.39),('9303','2013-05-24','16:05:00',2.01),('9303','2013-05-24','16:10:00',2.17),('9303','2013-05-24','16:15:00',2.61),('9303','2013-05-24','16:20:00',2.14),('9303','2013-05-24','16:25:00',2.86),('9303','2013-05-24','16:30:00',3.14),('9303','2013-05-24','16:35:00',1.69),('9303','2013-05-24','16:50:00',1.14),('9303','2013-05-24','16:55:00',1.46),('9303','2013-05-24','17:00:00',1.25),('9303','2013-05-24','17:30:00',1.01),('9303','2013-05-24','17:35:00',1.01),('9303','2013-05-23','08:05:00',1.46),('9303','2013-05-23','08:10:00',1.47),('9303','2013-05-23','08:30:00',1.33),('9303','2013-05-23','08:35:00',1.72),('9303','2013-05-23','08:40:00',2.22),('9303','2013-05-23','08:45:00',2.26),('9303','2013-05-23','08:50:00',1.64),('9303','2013-05-23','09:00:00',2.69),('9303','2013-05-23','09:05:00',1.37),('9303','2013-05-23','09:20:00',2.3),('9303','2013-05-23','09:25:00',3.04),('9303','2013-05-23','09:30:00',3.49),('9303','2013-05-23','09:35:00',2.13),('9303','2013-05-23','09:40:00',2.31),('9303','2013-05-23','09:45:00',1.51),('9303','2013-05-23','09:50:00',3.4),('9303','2013-05-23','09:55:00',1.72),('9303','2013-05-23','10:00:00',1.23),('9303','2013-05-23','10:05:00',3.85),('9303','2013-05-23','10:10:00',2.59),('9303','2013-05-23','10:15:00',3.78),('9303','2013-05-23','10:20:00',2.31),('9303','2013-05-23','10:25:00',3.72),('9303','2013-05-23','10:30:00',3.29),('9303','2013-05-23','10:35:00',3.89),('9303','2013-05-23','10:40:00',3.77),('9303','2013-05-23','10:45:00',4.15),('9303','2013-05-23','10:50:00',3.44),('9303','2013-05-23','10:55:00',3.11),('9303','2013-05-23','11:00:00',2.49),('9303','2013-05-23','11:05:00',2.95),('9303','2013-05-23','11:10:00',3.21),('9303','2013-05-23','11:15:00',2.69),('9303','2013-05-23','11:20:00',2.27),('9303','2013-05-23','11:25:00',2.86),('9303','2013-05-23','11:30:00',2.74),('9303','2013-05-23','11:35:00',3.36),('9303','2013-05-23','11:40:00',4.55),('9303','2013-05-23','11:45:00',3.46),('9303','2013-05-23','11:50:00',2.31),('9303','2013-05-23','11:55:00',3.61),('9303','2013-05-23','12:00:00',4.33),('9303','2013-05-23','12:05:00',4.6),('9303','2013-05-23','12:10:00',4.67),('9303','2013-05-23','12:15:00',4.22),('9303','2013-05-23','12:20:00',3.22),('9303','2013-05-23','12:25:00',3.16),('9303','2013-05-23','12:30:00',3.69),('9303','2013-05-23','12:35:00',2.11),('9303','2013-05-23','12:40:00',4.28),('9303','2013-05-23','12:45:00',3.05),('9303','2013-05-23','12:50:00',3.62),('9303','2013-05-23','12:55:00',3.59),('9303','2013-05-23','13:00:00',4.73),('9303','2013-05-23','13:05:00',3.13),('9303','2013-05-23','13:10:00',4.51),('9303','2013-05-23','13:15:00',4.28),('9303','2013-05-23','13:20:00',3.38),('9303','2013-05-23','13:25:00',4.48),('9303','2013-05-23','13:30:00',4.15),('9303','2013-05-23','13:35:00',2.35),('9303','2013-05-23','13:40:00',2.05),('9303','2013-05-23','13:45:00',2.81),('9303','2013-05-23','13:50:00',3.36),('9303','2013-05-23','13:55:00',3.97),('9303','2013-05-23','14:00:00',4.34),('9303','2013-05-23','14:05:00',4.49),('9303','2013-05-23','14:10:00',3.05),('9303','2013-05-23','14:15:00',3.92),('9303','2013-05-23','14:20:00',4.38),('9303','2013-05-23','14:25:00',2.39),('9303','2013-05-23','14:30:00',1.84),('9303','2013-05-23','14:35:00',4.83),('9303','2013-05-23','14:40:00',3.27),('9303','2013-05-23','14:45:00',2.25),('9303','2013-05-23','14:50:00',2.18),('9303','2013-05-23','14:55:00',3.72),('9303','2013-05-23','15:00:00',4.27),('9303','2013-05-23','15:05:00',3.77),('9303','2013-05-23','15:10:00',1.27),('9303','2013-05-23','15:15:00',1.48),('9303','2013-05-23','15:20:00',3.31),('9303','2013-05-23','15:25:00',1.71),('9303','2013-05-23','15:30:00',2.54),('9303','2013-05-23','15:35:00',3.47),('9303','2013-05-23','15:40:00',1.74),('9303','2013-05-23','15:45:00',2.93),('9303','2013-05-23','15:50:00',1.18),('9303','2013-05-23','15:55:00',1.33),('9303','2013-05-23','16:00:00',3),('9303','2013-05-23','16:05:00',4.01),('9303','2013-05-23','16:10:00',2.58),('9303','2013-05-23','16:15:00',2.1),('9303','2013-05-23','16:20:00',3.13),('9303','2013-05-23','16:25:00',1.98),('9303','2013-05-23','16:30:00',2.99),('9303','2013-05-23','16:35:00',1.12),('9303','2013-05-23','16:40:00',1.31),('9303','2013-05-23','16:45:00',2),('9303','2013-05-23','17:10:00',2.15),('9303','2013-05-23','17:15:00',1.57),('9303','2013-05-23','17:35:00',1.26),('9303','2013-05-23','17:40:00',1.03),('9303','2013-05-23','17:55:00',1.14),('9303','2013-05-23','18:00:00',1.5),('9303','2013-05-23','18:05:00',1.99),('9303','2013-05-22','08:05:00',1.38),('9303','2013-05-22','08:10:00',1.04),('9303','2013-05-22','08:15:00',1.94),('9303','2013-05-22','08:20:00',1.9),('9303','2013-05-22','08:25:00',1.64),('9303','2013-05-22','08:30:00',2.06),('9303','2013-05-22','08:35:00',2.44),('9303','2013-05-22','08:40:00',1.48),('9303','2013-05-22','08:45:00',1.5),('9303','2013-05-22','09:30:00',2.77),('9303','2013-05-22','09:35:00',2.86),('9303','2013-05-22','09:40:00',2.84),('9303','2013-05-22','09:45:00',2.86),('9303','2013-05-22','09:50:00',2.93),('9303','2013-05-22','09:55:00',3.01),('9303','2013-05-22','10:00:00',3.08),('9303','2013-05-22','10:05:00',3.12),('9303','2013-05-22','10:10:00',3.2),('9303','2013-05-22','10:15:00',3.24),('9303','2013-05-22','10:20:00',3.14),('9303','2013-05-22','10:25:00',3.34),('9303','2013-05-22','10:30:00',3.4),('9303','2013-05-22','10:35:00',3.44),('9303','2013-05-22','10:40:00',3.62),('9303','2013-05-22','10:45:00',3.6),('9303','2013-05-22','10:50:00',3.56),('9303','2013-05-22','10:55:00',3.58),('9303','2013-05-22','11:00:00',3.65),('9303','2013-05-22','11:05:00',3.75),('9303','2013-05-22','11:10:00',3.19),('9303','2013-05-22','11:15:00',3.54),('9303','2013-05-22','11:20:00',3.9),('9303','2013-05-22','11:25:00',4.06),('9303','2013-05-22','11:30:00',3.15),('9303','2013-05-22','11:35:00',3.38),('9303','2013-05-22','11:40:00',3.08),('9303','2013-05-22','11:45:00',4.19),('9303','2013-05-22','11:50:00',2.71),('9303','2013-05-22','11:55:00',1.91),('9303','2013-05-22','12:00:00',2.73),('9303','2013-05-22','12:05:00',2.18),('9303','2013-05-22','12:10:00',2.09),('9303','2013-05-22','12:15:00',2.7),('9303','2013-05-22','12:20:00',3.59),('9303','2013-05-22','12:25:00',3.24),('9303','2013-05-22','12:30:00',2.2),('9303','2013-05-22','12:35:00',2.2),('9303','2013-05-22','12:40:00',1.61),('9303','2013-05-22','13:05:00',3.81),('9303','2013-05-22','13:10:00',2.41),('9303','2013-05-22','13:15:00',2.34),('9303','2013-05-22','13:20:00',2.55),('9303','2013-05-22','13:25:00',1.04),('9303','2013-05-22','13:30:00',1.58),('9303','2013-05-22','13:35:00',3.59),('9303','2013-05-22','13:40:00',2.93),('9303','2013-05-22','13:45:00',2.4),('9303','2013-05-22','13:50:00',2.01),('9303','2013-05-22','13:55:00',1.86),('9303','2013-05-22','14:00:00',2.65),('9303','2013-05-22','14:05:00',3.79),('9303','2013-05-22','14:10:00',4.18),('9303','2013-05-22','14:15:00',4.18),('9303','2013-05-22','14:20:00',4.07),('9303','2013-05-22','14:25:00',3.99),('9303','2013-05-22','14:30:00',3.96),('9303','2013-05-22','14:35:00',3.97),('9303','2013-05-22','14:40:00',3.93),('9303','2013-05-22','14:45:00',3.88),('9303','2013-05-22','14:50:00',3.85),('9303','2013-05-22','14:55:00',3.81),('9303','2013-05-22','15:00:00',3.76),('9303','2013-05-22','15:05:00',3.72),('9303','2013-05-22','15:10:00',3.67),('9303','2013-05-22','15:15:00',3.58),('9303','2013-05-22','15:20:00',3.16),('9303','2013-05-22','15:25:00',2.22),('9303','2013-05-22','15:30:00',1.56),('9303','2013-05-22','15:35:00',2.12),('9303','2013-05-22','15:40:00',2.15),('9303','2013-05-22','15:45:00',2.49),('9303','2013-05-22','15:50:00',3.33),('9303','2013-05-22','15:55:00',3.25),('9303','2013-05-22','16:00:00',3.17),('9303','2013-05-22','16:05:00',3.08),('9303','2013-05-22','16:10:00',3),('9303','2013-05-22','16:15:00',2.99),('9303','2013-05-22','16:20:00',2.89),('9303','2013-05-22','16:25:00',2.83),('9303','2013-05-22','16:30:00',2.76),('9303','2013-05-22','16:35:00',2.67),('9303','2013-05-22','16:40:00',2.62),('9303','2013-05-22','16:45:00',1.95),('9303','2013-05-22','16:50:00',1.3),('9303','2013-05-22','17:20:00',1.23),('9303','2013-05-22','17:25:00',1.63),('9303','2013-05-22','17:30:00',1.26),('9303','2013-05-22','17:35:00',1.32),('9303','2013-05-22','17:55:00',1.08),('9303','2013-05-22','18:00:00',1.34),('9303','2014-04-01','08:25:00',1.05),('9303','2014-04-01','08:30:00',1.14),('9303','2014-04-01','08:35:00',1.24),('9303','2014-04-01','08:40:00',1.34),('9303','2014-04-01','08:45:00',1.45),('9303','2014-04-01','08:50:00',1.54),('9303','2014-04-01','08:55:00',1.65),('9303','2014-04-01','09:00:00',1.76),('9303','2014-04-01','09:05:00',1.86),('9303','2014-04-01','09:10:00',1.95),('9303','2014-04-01','09:15:00',2.02),('9303','2014-04-01','09:20:00',2.09),('9303','2014-04-01','09:25:00',2.16),('9303','2014-04-01','09:30:00',2.24),('9303','2014-04-01','09:35:00',2.32),('9303','2014-04-01','09:40:00',2.39),('9303','2014-04-01','09:45:00',2.49),('9303','2014-04-01','09:50:00',2.54),('9303','2014-04-01','09:55:00',2.62),('9303','2014-04-01','10:00:00',2.71),('9303','2014-04-01','10:05:00',2.73),('9303','2014-04-01','10:10:00',2.76),('9303','2014-04-01','10:15:00',2.94),('9303','2014-04-01','10:20:00',3.07),('9303','2014-04-01','10:25:00',3.18),('9303','2014-04-01','10:30:00',2.74),('9303','2014-04-01','10:35:00',3.05),('9303','2014-04-01','10:40:00',2.99),('9303','2014-04-01','10:45:00',1.72),('9303','2014-04-01','10:50:00',3.33),('9303','2014-04-01','10:55:00',3.51),('9303','2014-04-01','11:00:00',3.49),('9303','2014-04-01','11:05:00',3.54),('9303','2014-04-01','11:10:00',3.52),('9303','2014-04-01','11:15:00',3.57),('9303','2014-04-01','11:20:00',3.6),('9303','2014-04-01','11:25:00',3.59),('9303','2014-04-01','11:30:00',3.76),('9303','2014-04-01','11:35:00',3.77),('9303','2014-04-01','11:40:00',3.8),('9303','2014-04-01','11:45:00',3.85),('9303','2014-04-01','11:50:00',3.92),('9303','2014-04-01','11:55:00',3.9),('9303','2014-04-01','12:00:00',3.97),('9303','2014-04-01','12:05:00',3.92),('9303','2014-04-01','12:10:00',3.99),('9303','2014-04-01','12:15:00',4),('9303','2014-04-01','12:20:00',4.05),('9303','2014-04-01','12:25:00',4.1),('9303','2014-04-01','12:30:00',4.13),('9303','2014-04-01','12:35:00',4.16),('9303','2014-04-01','12:40:00',4.15),('9303','2014-04-01','12:45:00',4.19),('9303','2014-04-01','12:50:00',4.22),('9303','2014-04-01','12:55:00',4.2),('9303','2014-04-01','13:00:00',4.23),('9303','2014-04-01','13:05:00',4.36),('9303','2014-04-01','13:10:00',4.19),('9303','2014-04-01','13:15:00',3.41),('9303','2014-04-01','13:20:00',4.26),('9303','2014-04-01','13:25:00',4.18),('9303','2014-04-01','13:30:00',4.21),('9303','2014-04-01','13:35:00',4.21),('9303','2014-04-01','13:40:00',4.23),('9303','2014-04-01','13:45:00',4.04),('9303','2014-04-01','13:50:00',4.06),('9303','2014-04-01','13:55:00',4.08),('9303','2014-04-01','14:00:00',4.16),('9303','2014-04-01','14:05:00',4.14),('9303','2014-04-01','14:10:00',4.11),('9303','2014-04-01','14:15:00',4.11),('9303','2014-04-01','14:20:00',4.03),('9303','2014-04-01','14:25:00',3.93),('9303','2014-04-01','14:30:00',3.07),('9303','2014-04-01','14:35:00',3.6),('9303','2014-04-01','14:40:00',4.09),('9303','2014-04-01','14:45:00',4.12),('9303','2014-04-01','14:50:00',3.27),('9303','2014-04-01','14:55:00',3.87),('9303','2014-04-01','15:00:00',3.47),('9303','2014-04-01','15:05:00',3.47),('9303','2014-04-01','15:10:00',3.77),('9303','2014-04-01','15:15:00',2.95),('9303','2014-04-01','15:20:00',3.12),('9303','2014-04-01','15:25:00',3.76),('9303','2014-04-01','15:30:00',3.72),('9303','2014-04-01','15:35:00',2.8),('9303','2014-04-01','15:40:00',2.44),('9303','2014-04-01','15:45:00',3.56),('9303','2014-04-01','15:50:00',3.33),('9303','2014-04-01','15:55:00',2.18),('9303','2014-04-01','16:00:00',2.77),('9303','2014-04-01','16:05:00',2.53),('9303','2014-04-01','16:10:00',2.64),('9303','2014-04-01','16:15:00',2.64),('9303','2014-04-01','16:20:00',2.63),('9303','2014-04-01','16:25:00',1.49),('9303','2014-04-01','16:30:00',2.49),('9303','2014-04-01','16:35:00',2.18),('9303','2014-04-01','16:40:00',1.42),('9303','2014-04-01','16:45:00',2.08),('9303','2014-04-01','16:50:00',1.9),('9303','2014-04-01','16:55:00',1.8),('9303','2014-04-01','17:00:00',2.12),('9303','2014-04-01','17:05:00',1.95),('9303','2014-04-01','17:10:00',1.96),('9303','2014-04-01','17:15:00',1.75),('9303','2014-04-01','17:20:00',1.74),('9303','2014-04-01','17:25:00',1.56),('9303','2014-04-01','17:30:00',1.55),('9303','2014-04-01','17:35:00',1.43),('9303','2014-04-01','17:40:00',1.3),('9303','2014-04-01','17:45:00',1.2),('9303','2014-04-01','17:50:00',1.12),('9303','2014-04-01','17:55:00',1.01),('9303','2013-05-21','07:35:00',1.14),('9303','2013-05-21','07:40:00',1.32),('9303','2013-05-21','07:45:00',1.14),('9303','2013-05-21','08:00:00',1.12),('9303','2013-05-21','08:10:00',1.35),('9303','2013-05-21','08:15:00',1.76),('9303','2013-05-21','08:20:00',1.34),('9303','2013-05-21','08:25:00',1.82),('9303','2013-05-21','08:30:00',1.27),('9303','2013-05-21','08:35:00',1.19),('9303','2013-05-21','08:40:00',1.38),('9303','2013-05-21','08:45:00',1.19),('9303','2013-05-21','08:50:00',1.25),('9303','2013-05-21','08:55:00',1.65),('9303','2013-05-21','09:00:00',1.39),('9303','2013-05-21','09:05:00',1.24),('9303','2013-05-21','09:10:00',1.39),('9303','2013-05-21','09:15:00',1.55),('9303','2013-05-21','09:20:00',1.99),('9303','2013-05-21','09:25:00',2.34),('9303','2013-05-21','09:30:00',1.86),('9303','2013-05-21','09:35:00',1.8),('9303','2013-05-21','09:40:00',1.84),('9303','2013-05-21','09:45:00',1.61),('9303','2013-05-21','09:50:00',1.54),('9303','2013-05-21','09:55:00',1.76),('9303','2013-05-21','10:00:00',1.88),('9303','2013-05-21','10:05:00',1.93),('9303','2013-05-21','10:10:00',2.16),('9303','2013-05-21','10:15:00',2.22),('9303','2013-05-21','10:20:00',2.02),('9303','2013-05-21','10:25:00',1.86),('9303','2013-05-21','10:30:00',1.71),('9303','2013-05-21','10:35:00',1.73),('9303','2013-05-21','10:40:00',1.92),('9303','2013-05-21','10:45:00',2.96),('9303','2013-05-21','10:50:00',2.05),('9303','2013-05-21','10:55:00',1.55),('9303','2013-05-21','11:00:00',1.74),('9303','2013-05-21','11:05:00',1.63),('9303','2013-05-21','11:10:00',2.66),('9303','2013-05-21','11:15:00',3.85),('9303','2013-05-21','11:20:00',3.06),('9303','2013-05-21','11:25:00',3.93),('9303','2013-05-21','11:30:00',2.9),('9303','2013-05-21','11:35:00',2.32),('9303','2013-05-21','11:40:00',2.51),('9303','2013-05-21','11:45:00',3.42),('9303','2013-05-21','11:50:00',2.79),('9303','2013-05-21','11:55:00',3.59),('9303','2013-05-21','12:00:00',2.81),('9303','2013-05-21','12:05:00',3.6),('9303','2013-05-21','12:10:00',2.79),('9303','2013-05-21','12:15:00',2.93),('9303','2013-05-21','12:20:00',2.17),('9303','2013-05-21','12:25:00',2.92),('9303','2013-05-21','12:30:00',4.08),('9303','2013-05-21','12:35:00',2.38),('9303','2013-05-21','12:40:00',3.88),('9303','2013-05-21','12:45:00',3.9),('9303','2013-05-21','12:50:00',2.45),('9303','2013-05-21','12:55:00',4.48),('9303','2013-05-21','13:00:00',3.83),('9303','2013-05-21','13:05:00',4.22),('9303','2013-05-21','13:10:00',2.45),('9303','2013-05-21','13:15:00',3.59),('9303','2013-05-21','13:20:00',2.9),('9303','2013-05-21','13:25:00',3.03),('9303','2013-05-21','13:30:00',2.88),('9303','2013-05-21','13:35:00',1.43),('9303','2013-05-21','14:10:00',1.62),('9303','2013-05-21','14:15:00',1.86),('9303','2013-05-21','14:20:00',1.66),('9303','2013-05-21','14:25:00',2.31),('9303','2013-05-21','14:30:00',2.43),('9303','2013-05-21','14:35:00',1.92),('9303','2013-05-21','14:40:00',1.79),('9303','2013-05-21','14:45:00',1.54),('9303','2013-05-21','15:20:00',1.41),('9303','2013-05-21','15:25:00',1.45),('9303','2013-05-21','15:30:00',2.16),('9303','2013-05-21','15:35:00',1.5),('9303','2013-05-21','15:40:00',1.22),('9303','2013-05-21','15:45:00',1.3),('9303','2013-05-21','15:50:00',1.17),('9303','2013-05-21','15:55:00',1.15),('9303','2013-05-21','16:00:00',1.12),('9303','2013-05-21','16:05:00',1.1),('9303','2013-05-21','16:10:00',1.24),('9303','2013-05-21','16:15:00',1.06),('9303','2013-05-21','16:25:00',1.15),('9303','2013-05-21','16:30:00',1.7),('9303','2013-05-21','16:35:00',1.93),('9303','2013-05-21','16:40:00',1.87),('9303','2013-05-21','16:45:00',1.79),('9303','2013-05-21','16:50:00',1.06),('9303','2013-05-20','07:40:00',1.02),('9303','2013-05-20','07:45:00',1.14),('9303','2013-05-20','07:50:00',1.16),('9303','2013-05-20','07:55:00',1.25),('9303','2013-05-20','08:00:00',1.43),('9303','2013-05-20','08:05:00',1.2),('9303','2013-05-20','08:10:00',1.47),('9303','2013-05-20','08:15:00',1.25),('9303','2013-05-20','08:20:00',1.24),('9303','2013-05-20','08:45:00',1.25),('9303','2013-05-20','08:50:00',2.97),('9303','2013-05-20','08:55:00',2.72),('9303','2013-05-20','09:00:00',2.83),('9303','2013-05-20','09:05:00',2.3),('9303','2013-05-20','09:10:00',3.13),('9303','2013-05-20','09:15:00',2.11),('9303','2013-05-20','09:20:00',1.64),('9303','2013-05-20','09:25:00',1.52),('9303','2013-05-20','09:30:00',1.16),('9303','2013-05-20','09:35:00',1.85),('9303','2013-05-20','09:40:00',1.13),('9303','2013-05-20','09:45:00',1.17),('9303','2013-05-20','09:50:00',3.12),('9303','2013-05-20','10:05:00',1.07),('9303','2013-05-20','10:10:00',1.42),('9303','2013-05-20','10:15:00',1.13),('9303','2013-05-20','10:25:00',1.35),('9303','2013-05-20','10:30:00',2.78),('9303','2013-05-20','10:35:00',2.97),('9303','2013-05-20','10:45:00',1.54),('9303','2013-05-20','10:50:00',1.48),('9303','2013-05-20','10:55:00',1.62),('9303','2013-05-20','11:00:00',3.12),('9303','2013-05-20','11:05:00',3.55),('9303','2013-05-20','11:10:00',4.06),('9303','2013-05-20','11:15:00',2.48),('9303','2013-05-20','11:20:00',3.01),('9303','2013-05-20','11:25:00',3.24),('9303','2013-05-20','11:30:00',3.35),('9303','2013-05-20','11:35:00',4.09),('9303','2013-05-20','11:40:00',1.45),('9303','2013-05-20','11:45:00',2.11),('9303','2013-05-20','11:50:00',1.96),('9303','2013-05-20','11:55:00',3.94),('9303','2013-05-20','12:00:00',2.6),('9303','2013-05-20','12:05:00',3.78),('9303','2013-05-20','12:10:00',3.23),('9303','2013-05-20','12:15:00',2.29),('9303','2013-05-20','12:20:00',3.44),('9303','2013-05-20','12:25:00',1.59),('9303','2013-05-20','12:30:00',2.27),('9303','2013-05-20','12:35:00',2.83),('9303','2013-05-20','12:40:00',2.77),('9303','2013-05-20','12:45:00',4.21),('9303','2013-05-20','12:50:00',1.97),('9303','2013-05-20','12:55:00',1.89),('9303','2013-05-20','13:00:00',1.77),('9303','2013-05-20','13:05:00',3.72),('9303','2013-05-20','13:10:00',2.74),('9303','2013-05-20','13:15:00',2.38),('9303','2013-05-20','13:20:00',4.56),('9303','2013-05-20','13:25:00',4.01),('9303','2013-05-20','13:30:00',3.14),('9303','2013-05-20','13:35:00',2.89),('9303','2013-05-20','13:40:00',2.36),('9303','2013-05-20','13:45:00',2.6),('9303','2013-05-20','13:50:00',4.89),('9303','2013-05-20','13:55:00',3.31),('9303','2013-05-20','14:00:00',4.66),('9303','2013-05-20','14:05:00',2.5),('9303','2013-05-20','14:10:00',1.37),('9303','2013-05-20','14:15:00',4.11),('9303','2013-05-20','14:20:00',3.04),('9303','2013-05-20','14:25:00',2.49),('9303','2013-05-20','14:30:00',4.53),('9303','2013-05-20','14:35:00',3.43),('9303','2013-05-20','14:40:00',1.76),('9303','2013-05-20','14:45:00',3.79),('9303','2013-05-20','14:50:00',4.53),('9303','2013-05-20','14:55:00',4.23),('9303','2013-05-20','15:00:00',3.27),('9303','2013-05-20','15:05:00',1.18),('9303','2013-05-20','15:10:00',4.24),('9303','2013-05-20','15:15:00',3.35),('9303','2013-05-20','15:20:00',3.05),('9303','2013-05-20','15:25:00',4.25),('9303','2013-05-20','15:30:00',4.09),('9303','2013-05-20','15:35:00',4.2),('9303','2013-05-20','15:40:00',2.26),('9303','2013-05-20','15:45:00',2.05),('9303','2013-05-20','15:50:00',2.82),('9303','2013-05-20','15:55:00',1.64),('9303','2013-05-20','16:00:00',2.1),('9303','2013-05-20','16:05:00',3.49),('9303','2013-05-20','16:10:00',3.61),('9303','2013-05-20','16:15:00',3.59),('9303','2013-05-20','16:20:00',3.31),('9303','2013-05-20','16:25:00',3.25),('9303','2013-05-20','16:30:00',3.14),('9303','2013-05-20','16:35:00',3.02),('9303','2013-05-20','16:40:00',2.96),('9303','2013-05-20','16:45:00',2.71),('9303','2013-05-20','16:50:00',2.68),('9303','2013-05-20','16:55:00',2.62),('9303','2013-05-20','17:00:00',2.45),('9303','2013-05-20','17:05:00',2.45),('9303','2013-05-20','17:10:00',1.85),('9303','2013-05-20','17:15:00',1.13),('9303','2013-05-20','17:20:00',1.86),('9303','2013-05-20','17:25:00',2.37),('9303','2013-05-20','17:30:00',2.34),('9303','2013-05-20','17:35:00',1.93),('9303','2013-05-20','17:40:00',1.71),('9303','2013-05-20','17:45:00',1.62),('9303','2013-05-20','17:50:00',1.58),('9303','2013-05-20','17:55:00',1.47),('9303','2013-05-20','18:00:00',1.42),('9303','2013-05-20','18:05:00',1.41),('9303','2013-05-20','18:10:00',1.05),('9303','2013-05-20','18:15:00',1.31),('9303','2013-05-20','18:20:00',1.08),('9303','2013-05-19','08:35:00',1.1),('9303','2013-05-19','08:50:00',1.13),('9303','2013-05-19','08:55:00',1.52),('9303','2013-05-19','09:00:00',1.39),('9303','2013-05-19','09:05:00',1.09),('9303','2013-05-19','09:10:00',1.2),('9303','2013-05-19','09:15:00',1.28),('9303','2013-05-19','09:20:00',1.02),('9303','2013-05-19','09:45:00',1.11),('9303','2013-05-19','10:00:00',1.32),('9303','2013-05-19','10:05:00',1.44),('9303','2013-05-19','10:10:00',1.91),('9303','2013-05-19','10:15:00',2.89),('9303','2013-05-19','10:20:00',3.14),('9303','2013-05-19','10:25:00',2.2),('9303','2013-05-19','10:30:00',2.78),('9303','2013-05-19','10:35:00',2.37),('9303','2013-05-19','10:40:00',2.32),('9303','2013-05-19','10:45:00',3.39),('9303','2013-05-19','10:50:00',2.1),('9303','2013-05-19','10:55:00',3.07),('9303','2013-05-19','11:00:00',2.05),('9303','2013-05-19','11:05:00',2.49),('9303','2013-05-19','11:10:00',2.04),('9303','2013-05-19','11:15:00',4.24),('9303','2013-05-19','11:20:00',4.4),('9303','2013-05-19','11:25:00',4.3),('9303','2013-05-19','11:30:00',4.31),('9303','2013-05-19','11:35:00',4.28),('9303','2013-05-19','11:40:00',4.39),('9303','2013-05-19','11:45:00',4.42),('9303','2013-05-19','11:50:00',4.4),('9303','2013-05-19','11:55:00',4.47),('9303','2013-05-19','12:00:00',4.48),('9303','2013-05-19','12:05:00',4.43),('9303','2013-05-19','12:10:00',4.48),('9303','2013-05-19','12:15:00',4.53),('9303','2013-05-19','12:20:00',4.77),('9303','2013-05-19','12:25:00',4.58),('9303','2013-05-19','12:30:00',3.83),('9303','2013-05-19','12:35:00',4.54),('9303','2013-05-19','12:40:00',4.53),('9303','2013-05-19','12:45:00',4.68),('9303','2013-05-19','12:50:00',3.46),('9303','2013-05-19','12:55:00',2.72),('9303','2013-05-19','13:00:00',4.33),('9303','2013-05-19','13:05:00',4.33),('9303','2013-05-19','13:10:00',4.03),('9303','2013-05-19','13:15:00',3.81),('9303','2013-05-19','13:20:00',4.25),('9303','2013-05-19','13:25:00',4.03),('9303','2013-05-19','13:30:00',4.43),('9303','2013-05-19','13:35:00',4.47),('9303','2013-05-19','13:40:00',4.43),('9303','2013-05-19','13:45:00',4.37),('9303','2013-05-19','13:50:00',4.37),('9303','2013-05-19','13:55:00',4.42),('9303','2013-05-19','14:00:00',4.38),('9303','2013-05-19','14:05:00',4.37),('9303','2013-05-19','14:10:00',4.33),('9303','2013-05-19','14:15:00',4.29),('9303','2013-05-19','14:20:00',4.29),('9303','2013-05-19','14:25:00',4.26),('9303','2013-05-19','14:30:00',4.25),('9303','2013-05-19','14:35:00',4.21),('9303','2013-05-19','14:40:00',4.21),('9303','2013-05-19','14:45:00',4.17),('9303','2013-05-19','14:50:00',4.12),('9303','2013-05-19','14:55:00',4.08),('9303','2013-05-19','15:00:00',4.08),('9303','2013-05-19','15:05:00',4.04),('9303','2013-05-19','15:10:00',4),('9303','2013-05-19','15:15:00',3.97),('9303','2013-05-19','15:20:00',3.89),('9303','2013-05-19','15:25:00',3.84),('9303','2013-05-19','15:30:00',3.79),('9303','2013-05-19','15:35:00',3.75),('9303','2013-05-19','15:40:00',3.69),('9303','2013-05-19','15:45:00',3.65),('9303','2013-05-19','15:50:00',3.59),('9303','2013-05-19','15:55:00',3.55),('9303','2013-05-19','16:00:00',3.48),('9303','2013-05-19','16:05:00',3.38),('9303','2013-05-19','16:10:00',3.33),('9303','2013-05-19','16:15:00',3.26),('9303','2013-05-19','16:20:00',3.2),('9303','2013-05-19','16:25:00',3.15),('9303','2013-05-19','16:30:00',3.07),('9303','2013-05-19','16:35:00',3.02),('9303','2013-05-19','16:40:00',2.96),('9303','2013-05-19','16:45:00',2.9),('9303','2013-05-19','16:50:00',2.81),('9303','2013-05-19','16:55:00',2.75),('9303','2013-05-19','17:00:00',2.64),('9303','2013-05-19','17:05:00',2.53),('9303','2013-05-19','17:10:00',2.42),('9303','2013-05-19','17:15:00',2.3),('9303','2013-05-19','17:20:00',2.22),('9303','2013-05-19','17:25:00',2.13),('9303','2013-05-19','17:30:00',2.03),('9303','2013-05-19','17:35:00',1.96),('9303','2013-05-19','17:40:00',1.84),('9303','2013-05-19','17:45:00',1.76),('9303','2013-05-19','17:50:00',1.69),('9303','2013-05-19','17:55:00',1.57),('9303','2013-05-19','18:00:00',1.49),('9303','2013-05-19','18:05:00',1.4),('9303','2013-05-19','18:10:00',1.3),('9303','2013-05-19','18:15:00',1.2),('9303','2013-05-19','18:20:00',1.1),('9303','2013-05-18','07:40:00',1.02),('9303','2013-05-18','07:45:00',1.11),('9303','2013-05-18','07:50:00',1),('9303','2013-05-18','07:55:00',1.46),('9303','2013-05-18','08:00:00',1.73),('9303','2013-05-18','08:05:00',1.75),('9303','2013-05-18','08:20:00',1.16),('9303','2013-05-18','08:25:00',2.29),('9303','2013-05-18','08:30:00',2.06),('9303','2013-05-18','08:35:00',1.89),('9303','2013-05-18','08:40:00',2.11),('9303','2013-05-18','08:45:00',2.16),('9303','2013-05-18','08:50:00',2.24),('9303','2013-05-18','08:55:00',2.32),('9303','2013-05-18','09:00:00',2.4),('9303','2013-05-18','09:05:00',2.4),('9303','2013-05-18','09:10:00',2.57),('9303','2013-05-18','09:15:00',2.65),('9303','2013-05-18','09:20:00',2.71),('9303','2013-05-18','09:25:00',2.76),('9303','2013-05-18','09:30:00',2.83),('9303','2013-05-18','09:35:00',2.88),('9303','2013-05-18','09:40:00',2.92),('9303','2013-05-18','09:45:00',2.98),('9303','2013-05-18','09:50:00',3.07),('9303','2013-05-18','09:55:00',3.14),('9303','2013-05-18','10:00:00',3.18),('9303','2013-05-18','10:05:00',3.22),('9303','2013-05-18','10:10:00',3.31),('9303','2013-05-18','10:15:00',3.34),('9303','2013-05-18','10:20:00',3.42),('9303','2013-05-18','10:25:00',3.47),('9303','2013-05-18','10:30:00',3.51),('9303','2013-05-18','10:35:00',3.51),('9303','2013-05-18','10:40:00',3.57),('9303','2013-05-18','10:45:00',3.6),('9303','2013-05-18','10:50:00',3.65),('9303','2013-05-18','10:55:00',3.51),('9303','2013-05-18','11:00:00',3.88),('9303','2013-05-18','11:05:00',3.65),('9303','2013-05-18','11:10:00',3.18),('9303','2013-05-18','11:15:00',4.18),('9303','2013-05-18','11:20:00',4),('9303','2013-05-18','11:25:00',4.02),('9303','2013-05-18','11:30:00',3.92),('9303','2013-05-18','11:35:00',3.73),('9303','2013-05-18','11:40:00',3.96),('9303','2013-05-18','11:45:00',3.91),('9303','2013-05-18','11:50:00',3.86),('9303','2013-05-18','11:55:00',3.95),('9303','2013-05-18','12:00:00',3.8),('9303','2013-05-18','12:05:00',3.98),('9303','2013-05-18','12:10:00',3.98),('9303','2013-05-18','12:15:00',3.97),('9303','2013-05-18','12:20:00',3.99),('9303','2013-05-18','12:25:00',4.04),('9303','2013-05-18','12:30:00',3.21),('9303','2013-05-18','12:35:00',4.11),('9303','2013-05-18','12:40:00',4.08),('9303','2013-05-18','12:45:00',3.9),('9303','2013-05-18','12:50:00',4.1),('9303','2013-05-18','12:55:00',4.09),('9303','2013-05-18','13:00:00',4.08),('9303','2013-05-18','13:05:00',4.08),('9303','2013-05-17','07:45:00',1.06),('9303','2013-05-17','07:50:00',1.09),('9303','2013-05-17','08:00:00',1.2),('9303','2013-05-17','08:15:00',1.46),('9303','2013-05-17','08:20:00',2.11),('9303','2013-05-17','08:25:00',1.43),('9303','2013-05-17','08:30:00',1.08),('9303','2013-05-17','09:25:00',1.06),('9303','2013-05-17','10:25:00',1.18),('9303','2013-05-17','10:30:00',1.51),('9303','2013-05-17','10:35:00',1.19),('9303','2013-05-17','10:40:00',1.29),('9303','2013-05-17','10:45:00',1.44),('9303','2013-05-17','10:50:00',2.63),('9303','2013-05-17','10:55:00',3.41),('9303','2013-05-17','11:00:00',2.31),('9303','2013-05-17','11:05:00',1.96),('9303','2013-05-17','11:10:00',1.33),('9303','2013-05-17','11:15:00',2.14),('9303','2013-05-17','11:20:00',1.99),('9303','2013-05-17','11:25:00',1.64),('9303','2013-05-17','11:30:00',1.53),('9303','2013-05-17','11:35:00',2.27),('9303','2013-05-17','11:40:00',1.43),('9303','2013-05-17','11:45:00',1.51),('9303','2013-05-17','11:50:00',3.63),('9303','2013-05-17','11:55:00',2.13),('9303','2013-05-17','12:00:00',3.09),('9303','2013-05-17','12:05:00',2.86),('9303','2013-05-17','12:10:00',3.56),('9303','2013-05-17','12:15:00',2.45),('9303','2013-05-17','12:20:00',2.59),('9303','2013-05-17','12:25:00',2.8),('9303','2013-05-17','12:30:00',2.1),('9303','2013-05-17','12:35:00',2.95),('9303','2013-05-17','12:40:00',4.15),('9303','2013-05-17','12:45:00',4.82),('9303','2013-05-17','12:50:00',4.69),('9303','2013-05-17','12:55:00',4.33),('9303','2013-05-17','13:00:00',3.29),('9303','2013-05-17','13:05:00',4.19),('9303','2013-05-17','13:10:00',3.59),('9303','2013-05-17','13:15:00',3.83),('9303','2013-05-17','13:20:00',4.57),('9303','2013-05-17','13:25:00',4.29),('9303','2013-05-17','13:30:00',3.03),('9303','2013-05-17','13:35:00',4.54),('9303','2013-05-17','13:40:00',3.81),('9303','2013-05-17','13:45:00',3.92),('9303','2013-05-17','13:50:00',4.02),('9303','2013-05-17','13:55:00',4.64),('9303','2013-05-17','14:00:00',2.84),('9303','2013-05-17','14:05:00',2.93),('9303','2013-05-17','14:10:00',4.14),('9303','2013-05-17','14:15:00',4.11),('9303','2013-05-17','14:20:00',4.24),('9303','2013-05-17','14:25:00',3.83),('9303','2013-05-17','14:30:00',3.8),('9303','2013-05-17','14:35:00',3.88),('9303','2013-05-17','14:40:00',2.76),('9303','2013-05-17','14:45:00',3.07),('9303','2013-05-17','14:50:00',3.47),('9303','2013-05-17','14:55:00',2.1),('9303','2013-05-17','15:00:00',4.27),('9303','2013-05-17','15:05:00',2.85),('9303','2013-05-17','15:10:00',1.44),('9303','2013-05-17','15:15:00',2.61),('9303','2013-05-17','15:20:00',3.54),('9303','2013-05-17','15:25:00',3.18),('9303','2013-05-17','15:30:00',1.54),('9303','2013-05-17','15:35:00',2.1),('9303','2013-05-17','15:40:00',3.72),('9303','2013-05-17','15:45:00',1.36),('9303','2013-05-17','15:50:00',2.6),('9303','2013-05-17','15:55:00',3.11),('9303','2013-05-17','16:00:00',4.11),('9303','2013-05-17','16:05:00',1.65),('9303','2013-05-17','16:10:00',1.94),('9303','2013-05-17','16:15:00',2.8),('9303','2013-05-17','16:20:00',2.66),('9303','2013-05-17','16:25:00',3.13),('9303','2013-05-17','16:30:00',3.26),('9303','2013-05-17','16:35:00',2.78),('9303','2013-05-17','16:40:00',3.1),('9303','2013-05-17','16:45:00',2.99),('9303','2013-05-17','16:50:00',2.73),('9303','2013-05-17','16:55:00',2.59),('9303','2013-05-17','17:00:00',2.49),('9303','2013-05-17','17:05:00',2.36),('9303','2013-05-17','17:10:00',2.24),('9303','2013-05-17','17:15:00',2.16),('9303','2013-05-17','17:20:00',2.09),('9303','2013-05-17','17:25:00',2.02),('9303','2013-05-17','17:30:00',1.96),('9303','2013-05-17','17:35:00',1.87),('9303','2013-05-17','17:40:00',1.78),('9303','2013-05-17','17:45:00',1.68),('9303','2013-05-17','17:50:00',1.61),('9303','2013-05-17','17:55:00',1.51),('9303','2013-05-17','18:00:00',1.42),('9303','2013-05-17','18:05:00',1.36),('9303','2013-05-17','18:10:00',1.24),('9303','2013-05-17','18:15:00',1.15),('9303','2013-05-17','18:20:00',1.04),('9303','2013-05-16','09:20:00',1.03),('9303','2013-05-16','09:25:00',1.46),('9303','2013-05-16','09:30:00',1.48),('9303','2013-05-16','09:35:00',1.69),('9303','2013-05-16','09:40:00',1.94),('9303','2013-05-16','09:45:00',2.39),('9303','2013-05-16','09:50:00',1.24),('9303','2013-05-16','09:55:00',1.07),('9303','2013-05-16','10:00:00',1.39),('9303','2013-05-16','10:05:00',1.19),('9303','2013-05-16','10:10:00',1.07),('9303','2013-05-16','10:15:00',1.39),('9303','2013-05-16','10:20:00',1.84),('9303','2013-05-16','10:25:00',1.85),('9303','2013-05-16','10:30:00',1.76),('9303','2013-05-16','10:35:00',1.26),('9303','2013-05-16','10:40:00',1.29),('9303','2013-05-16','10:45:00',1.21),('9303','2013-05-16','10:50:00',1.4),('9303','2013-05-16','10:55:00',1.57),('9303','2013-05-16','11:00:00',4.04),('9303','2013-05-16','11:05:00',3.53),('9303','2013-05-16','11:10:00',3.13),('9303','2013-05-16','11:15:00',2.17),('9303','2013-05-16','11:20:00',1.08),('9303','2013-05-16','11:25:00',1.17),('9303','2013-05-16','11:30:00',1.4),('9303','2013-05-16','11:35:00',2.84),('9303','2013-05-16','11:40:00',3.6),('9303','2013-05-16','11:45:00',3.5),('9303','2013-05-16','11:50:00',3.66),('9303','2013-05-16','11:55:00',2.51),('9303','2013-05-16','12:00:00',1.68),('9303','2013-05-16','12:05:00',1.51),('9303','2013-05-16','12:10:00',1.56),('9303','2013-05-16','12:15:00',2.68),('9303','2013-05-16','12:20:00',1.83),('9303','2013-05-16','12:25:00',2.02),('9303','2013-05-16','12:30:00',3.15),('9303','2013-05-16','12:35:00',3.23),('9303','2013-05-16','12:40:00',4.01),('9303','2013-05-16','12:45:00',3.57),('9303','2013-05-16','12:50:00',2.7),('9303','2013-05-16','12:55:00',4.13),('9303','2013-05-16','13:00:00',4.12),('9303','2013-05-16','13:05:00',3.92),('9303','2013-05-16','13:10:00',4),('9303','2013-05-16','13:15:00',3.61),('9303','2013-05-16','13:20:00',3.06),('9303','2013-05-16','13:25:00',4.04),('9303','2013-05-16','13:30:00',3.95),('9303','2013-05-16','13:35:00',3.95),('9303','2013-05-16','13:40:00',3.9),('9303','2013-05-16','13:45:00',3.87),('9303','2013-05-16','13:50:00',3.9),('9303','2013-05-16','13:55:00',3.86),('9303','2013-05-16','14:00:00',3.83),('9303','2013-05-16','14:05:00',3.8),('9303','2013-05-16','14:10:00',3.79),('9303','2013-05-16','14:20:00',3.4),('9303','2013-05-16','14:25:00',3.65),('9303','2013-05-16','14:30:00',3.69),('9303','2013-05-16','14:35:00',3.62),('9303','2013-05-16','14:40:00',3.6),('9303','2013-05-16','14:45:00',3.57),('9303','2013-05-16','14:50:00',3.37),('9303','2013-05-16','14:55:00',2.98),('9303','2013-05-16','15:00:00',3.47),('9303','2013-05-16','15:05:00',3.42),('9303','2013-05-16','15:10:00',3.43),('9303','2013-05-16','15:15:00',3.05),('9303','2013-05-16','15:20:00',3.19),('9303','2013-05-16','15:25:00',3.25),('9303','2013-05-16','15:30:00',3.16),('9303','2013-05-16','15:35:00',3.07),('9303','2013-05-16','15:40:00',3.14),('9303','2013-05-16','15:45:00',3.01),('9303','2013-05-16','15:50:00',3.02),('9303','2013-05-16','15:55:00',3),('9303','2013-05-16','16:00:00',2.96),('9303','2013-05-16','16:05:00',2.78),('9303','2013-05-16','16:10:00',2.77),('9303','2013-05-16','16:15:00',2.58),('9303','2013-05-16','16:20:00',2.77),('9303','2013-05-16','16:25:00',2.63),('9303','2013-05-16','16:30:00',2.61),('9303','2013-05-16','16:35:00',2.51),('9303','2013-05-16','16:40:00',1.52),('9303','2013-05-16','16:45:00',1.3),('9303','2013-05-16','16:50:00',1.67),('9303','2013-05-16','16:55:00',1.46),('9303','2013-05-16','17:00:00',1.51),('9303','2013-05-16','17:15:00',1.1),('9303','2013-05-16','17:20:00',1.26),('9303','2013-05-16','17:25:00',1.2),('9303','2013-05-16','17:30:00',1.42),('9303','2013-05-16','17:35:00',1.52),('9303','2013-05-16','17:40:00',1.22),('9303','2013-05-15','07:45:00',1.14),('9303','2013-05-15','07:50:00',1.2),('9303','2013-05-15','07:55:00',1.17),('9303','2013-05-15','08:00:00',1.23),('9303','2013-05-15','08:05:00',1.23),('9303','2013-05-15','08:10:00',1.46),('9303','2013-05-15','08:15:00',1.6),('9303','2013-05-15','08:20:00',1.66),('9303','2013-05-15','08:25:00',1.72),('9303','2013-05-15','08:30:00',1.75),('9303','2013-05-15','08:35:00',1.93),('9303','2013-05-15','08:40:00',2.04),('9303','2013-05-15','08:45:00',2.11),('9303','2013-05-15','08:50:00',2.19),('9303','2013-05-15','08:55:00',2.28),('9303','2013-05-15','09:00:00',2.23),('9303','2013-05-15','09:05:00',2.39),('9303','2013-05-15','09:10:00',2.39),('9303','2013-05-15','09:15:00',2.46),('9303','2013-05-15','09:20:00',2.43),('9303','2013-05-15','09:25:00',2.54),('9303','2013-05-15','09:30:00',2.71),('9303','2013-05-15','09:35:00',2.76),('9303','2013-05-15','09:40:00',2.77),('9303','2013-05-15','09:45:00',2.89),('9303','2013-05-15','09:50:00',2.96),('9303','2013-05-15','09:55:00',2.97),('9303','2013-05-15','10:00:00',3.08),('9303','2013-05-15','10:05:00',3.15),('9303','2013-05-15','10:10:00',3.2),('9303','2013-05-15','10:15:00',3.17),('9303','2013-05-15','10:20:00',3.3),('9303','2013-05-15','10:25:00',3.39),('9303','2013-05-15','10:30:00',3.32),('9303','2013-05-15','10:35:00',3.4),('9303','2013-05-15','10:40:00',3.44),('9303','2013-05-15','10:45:00',3.52),('9303','2013-05-15','10:50:00',3.54),('9303','2013-05-15','10:55:00',3.47),('9303','2013-05-15','11:00:00',3.47),('9303','2013-05-15','11:05:00',3.49),('9303','2013-05-15','11:10:00',3.68),('9303','2013-05-15','11:15:00',3.76),('9303','2013-05-15','11:20:00',3.59),('9303','2013-05-15','11:25:00',3.77),('9303','2013-05-15','11:30:00',3.63),('9303','2013-05-15','11:35:00',3.57),('9303','2013-05-15','11:40:00',3.17),('9303','2013-05-15','11:45:00',2.89),('9303','2013-05-15','11:50:00',2.48),('9303','2013-05-15','11:55:00',1.86),('9303','2013-05-15','12:00:00',2.04),('9303','2013-05-15','12:05:00',2.99),('9303','2013-05-15','12:10:00',4.22),('9303','2013-05-15','12:15:00',4.41),('9303','2013-05-15','12:20:00',3.13),('9303','2013-05-15','12:25:00',3.45),('9303','2013-05-15','12:30:00',2.51),('9303','2013-05-15','12:35:00',2.79),('9303','2013-05-15','12:40:00',4.39),('9303','2013-05-15','12:45:00',2.29),('9303','2013-05-15','12:50:00',2.29),('9303','2013-05-15','12:55:00',2.52),('9303','2013-05-15','13:00:00',2.59),('9303','2013-05-15','13:05:00',3.21),('9303','2013-05-15','13:10:00',2.8),('9303','2013-05-15','13:15:00',2.22),('9303','2013-05-15','13:20:00',2.55),('9303','2013-05-15','13:25:00',2.49),('9303','2013-05-15','13:30:00',2.52),('9303','2013-05-15','13:35:00',2.22),('9303','2013-05-15','13:40:00',2.31),('9303','2013-05-15','13:45:00',2.43),('9303','2013-05-15','13:50:00',1.97),('9303','2013-05-15','13:55:00',1.94),('9303','2013-05-15','14:00:00',1.71),('9303','2013-05-15','14:05:00',1.51),('9303','2013-05-15','14:10:00',1.55),('9303','2013-05-15','14:15:00',1.55),('9303','2013-05-15','14:20:00',1.6),('9303','2013-05-15','14:25:00',1.54),('9303','2013-05-15','14:30:00',1.36),('9303','2013-05-15','14:35:00',1.32),('9303','2013-05-15','14:40:00',1.43),('9303','2013-05-15','14:45:00',1.34),('9303','2013-05-15','14:50:00',1.37),('9303','2013-05-15','14:55:00',1.36),('9303','2013-05-15','15:00:00',1.36),('9303','2013-05-15','15:05:00',1.06),('9303','2013-05-15','15:50:00',1.29),('9303','2013-05-15','15:55:00',1.76),('9303','2013-05-15','16:00:00',1.78),('9303','2013-05-15','16:05:00',1.67),('9303','2013-05-15','16:10:00',1.52),('9303','2013-05-15','16:15:00',1.35),('9303','2013-05-15','16:20:00',1.46),('9303','2013-05-15','16:25:00',1.5),('9303','2013-05-15','16:30:00',1.34),('9303','2013-05-15','16:35:00',1.23),('9303','2013-05-15','16:40:00',1.14),('9303','2013-05-15','16:45:00',1.09),('9303','2013-05-15','16:50:00',1.1),('9303','2013-05-15','16:55:00',1.25),('9303','2013-05-15','17:00:00',1.51),('9303','2013-05-15','17:05:00',1.81),('9303','2013-05-15','17:10:00',1.93),('9303','2013-05-15','17:15:00',2.44),('9303','2013-05-15','17:20:00',1.45),('9303','2013-05-14','07:45:00',1.07),('9303','2013-05-14','07:50:00',1.18),('9303','2013-05-14','07:55:00',1.28),('9303','2013-05-14','08:00:00',1.38),('9303','2013-05-14','08:05:00',1.48),('9303','2013-05-14','08:10:00',1.57),('9303','2013-05-14','08:15:00',1.68),('9303','2013-05-14','08:20:00',1.79),('9303','2013-05-14','08:25:00',1.88),('9303','2013-05-14','08:30:00',1.99),('9303','2013-05-14','08:35:00',2.09),('9303','2013-05-14','08:40:00',2.17),('9303','2013-05-14','08:45:00',2.25),('9303','2013-05-14','08:50:00',2.32),('9303','2013-05-14','08:55:00',2.41),('9303','2013-05-14','09:00:00',2.5),('9303','2013-05-14','09:05:00',2.58),('9303','2013-05-14','09:10:00',2.65),('9303','2013-05-14','09:15:00',2.7),('9303','2013-05-14','09:20:00',2.78),('9303','2013-05-14','09:25:00',2.84),('9303','2013-05-14','09:30:00',2.9),('9303','2013-05-14','09:35:00',2.97),('9303','2013-05-14','09:40:00',3),('9303','2013-05-14','09:45:00',3.05),('9303','2013-05-14','09:50:00',3.12),('9303','2013-05-14','09:55:00',3.22),('9303','2013-05-14','10:00:00',3.27),('9303','2013-05-14','10:05:00',3.33),('9303','2013-05-14','10:10:00',3.4),('9303','2013-05-14','10:15:00',3.46),('9303','2013-05-14','10:20:00',3.47),('9303','2013-05-14','10:25:00',3.51),('9303','2013-05-14','10:30:00',3.59),('9303','2013-05-14','10:35:00',3.63),('9303','2013-05-14','10:40:00',3.68),('9303','2013-05-14','10:45:00',3.7),('9303','2013-05-14','10:50:00',3.73),('9303','2013-05-14','10:55:00',3.75),('9303','2013-05-14','11:00:00',3.8),('9303','2013-05-14','11:05:00',3.85),('9303','2013-05-14','11:10:00',3.9),('9303','2013-05-14','11:15:00',3.89),('9303','2013-05-14','11:20:00',3.91),('9303','2013-05-14','11:25:00',3.9),('9303','2013-05-14','11:30:00',3.95),('9303','2013-05-14','11:35:00',3.96),('9303','2013-05-14','11:40:00',3.99),('9303','2013-05-14','11:45:00',4),('9303','2013-05-14','11:50:00',4),('9303','2013-05-14','11:55:00',4.01),('9303','2013-05-14','12:00:00',4.05),('9303','2013-05-14','12:05:00',4.07),('9303','2013-05-14','12:10:00',4.09),('9303','2013-05-14','12:15:00',4.16),('9303','2013-05-14','12:20:00',4.26),('9303','2013-05-14','12:25:00',4.23),('9303','2013-05-14','12:30:00',4.23),('9303','2013-05-14','12:35:00',4.19),('9303','2013-05-14','12:40:00',4.18),('9303','2013-05-14','12:45:00',4.16),('9303','2013-05-14','12:50:00',4.23),('9303','2013-05-14','12:55:00',4.21),('9303','2013-05-14','13:00:00',4.17),('9303','2013-05-14','13:05:00',4.17),('9303','2013-05-14','13:10:00',4.26),('9303','2013-05-14','13:15:00',4.22),('9303','2013-05-14','13:20:00',4.17),('9303','2013-05-14','13:25:00',4.15),('9303','2013-05-14','13:30:00',4.21),('9303','2013-05-14','13:35:00',4.24),('9303','2013-05-14','13:40:00',4.2),('9303','2013-05-14','13:45:00',4.12),('9303','2013-05-14','13:50:00',4.14),('9303','2013-05-14','13:55:00',4.13),('9303','2013-05-14','14:00:00',4.11),('9303','2013-05-14','14:05:00',4.06),('9303','2013-05-14','14:10:00',4.05),('9303','2013-05-14','14:15:00',4.02),('9303','2013-05-14','14:20:00',3.95),('9303','2013-05-14','14:25:00',3.92),('9303','2013-05-14','14:30:00',3.91),('9303','2013-05-14','14:35:00',3.83),('9303','2013-05-14','14:40:00',3.82),('9303','2013-05-14','14:45:00',3.84),('9303','2013-05-14','14:50:00',3.87),('9303','2013-05-14','14:55:00',3.91),('9303','2013-05-14','15:00:00',3.89),('9303','2013-05-14','15:05:00',3.86),('9303','2013-05-14','15:10:00',3.82),('9303','2013-05-14','15:15:00',3.78),('9303','2013-05-14','15:20:00',3.73),('9303','2013-05-14','15:25:00',3.71),('9303','2013-05-14','15:30:00',3.66),('9303','2013-05-14','15:35:00',3.61),('9303','2013-05-14','15:40:00',3.55),('9303','2013-05-14','15:45:00',3.48),('9303','2013-05-14','15:50:00',3.44),('9303','2013-05-14','15:55:00',3.4),('9303','2013-05-14','16:00:00',3.34),('9303','2013-05-14','16:05:00',3.27),('9303','2013-05-14','16:10:00',3.21),('9303','2013-05-14','16:15:00',3.15),('9303','2013-05-14','16:20:00',3.08),('9303','2013-05-14','16:25:00',3.03),('9303','2013-05-14','16:30:00',2.95),('9303','2013-05-14','16:35:00',2.87),('9303','2013-05-14','16:40:00',2.8),('9303','2013-05-14','16:45:00',2.73),('9303','2013-05-14','16:50:00',2.65),('9303','2013-05-14','16:55:00',2.55),('9303','2013-05-14','17:00:00',2.45),('9303','2013-05-14','17:05:00',2.33),('9303','2013-05-14','17:10:00',2.23),('9303','2013-05-14','17:15:00',2.14),('9303','2013-05-14','17:20:00',2.05),('9303','2013-05-14','17:25:00',1.97),('9303','2013-05-14','17:30:00',1.9),('9303','2013-05-14','17:35:00',1.81),('9303','2013-05-14','17:40:00',1.73),('9303','2013-05-14','17:45:00',1.62),('9303','2013-05-14','17:50:00',1.51),('9303','2013-05-14','17:55:00',1.42),('9303','2013-05-14','18:00:00',1.34),('9303','2013-05-14','18:05:00',1.24),('9303','2013-05-14','18:10:00',1.16),('9303','2013-05-14','18:15:00',1.08),('9303','2013-05-13','08:00:00',1.22),('9303','2013-05-13','08:05:00',1.33),('9303','2013-05-13','08:10:00',1.43),('9303','2013-05-13','08:15:00',1.55),('9303','2013-05-13','08:20:00',1.65),('9303','2013-05-13','08:25:00',1.71),('9303','2013-05-13','08:30:00',1.8),('9303','2013-05-13','08:35:00',1.9),('9303','2013-05-13','08:40:00',2),('9303','2013-05-13','08:45:00',2.06),('9303','2013-05-13','08:50:00',2.13),('9303','2013-05-13','08:55:00',2.23),('9303','2013-05-13','09:00:00',2.29),('9303','2013-05-13','09:05:00',2.36),('9303','2013-05-13','09:10:00',2.46),('9303','2013-05-13','09:15:00',2.52),('9303','2013-05-13','09:20:00',2.49),('9303','2013-05-13','09:25:00',2.67),('9303','2013-05-13','09:30:00',2.72),('9303','2013-05-13','09:35:00',2.81),('9303','2013-05-13','09:40:00',2.86),('9303','2013-05-13','09:45:00',2.97),('9303','2013-05-13','09:50:00',2.49),('9303','2013-05-13','09:55:00',3.23),('9303','2013-05-13','10:00:00',3.18),('9303','2013-05-13','10:05:00',2.95),('9303','2013-05-13','10:10:00',3.23),('9303','2013-05-13','10:15:00',3.5),('9303','2013-05-13','10:20:00',2.58),('9303','2013-05-13','10:25:00',2.19),('9303','2013-05-13','10:30:00',2.97),('9303','2013-05-13','10:45:00',2.91),('9303','2013-05-13','10:50:00',4.04),('9303','2013-05-13','10:55:00',2.67),('9303','2013-05-13','11:00:00',2.14),('9303','2013-05-13','11:05:00',2.27),('9303','2013-05-13','11:10:00',1.82),('9303','2013-05-13','11:15:00',1.85),('9303','2013-05-13','11:20:00',1.42),('9303','2013-05-13','11:25:00',1.95),('9303','2013-05-13','11:30:00',1.73),('9303','2013-05-13','11:35:00',1.75),('9303','2013-05-13','11:40:00',2.43),('9303','2013-05-13','11:45:00',2.91),('9303','2013-05-13','11:50:00',1.68),('9303','2013-05-13','11:55:00',1.8),('9303','2013-05-13','12:00:00',1.62),('9303','2013-05-13','12:05:00',1.59),('9303','2013-05-13','12:10:00',3.04),('9303','2013-05-13','12:15:00',2.3),('9303','2013-05-13','12:20:00',1.21),('9303','2013-05-13','12:25:00',1.54),('9303','2013-05-13','12:30:00',2.45),('9303','2013-05-13','12:35:00',3.9),('9303','2013-05-13','12:40:00',3.73),('9303','2013-05-13','12:45:00',1.39),('9303','2013-05-13','12:50:00',4.1),('9303','2013-05-13','12:55:00',4.55),('9303','2013-05-13','13:00:00',4.78),('9303','2013-05-13','13:05:00',4.83),('9303','2013-05-13','13:10:00',4.07),('9303','2013-05-13','13:15:00',4.5),('9303','2013-05-13','13:20:00',4.7),('9303','2013-05-13','13:25:00',4.74),('9303','2013-05-13','13:30:00',4.8),('9303','2013-05-13','13:35:00',4.66),('9303','2013-05-13','13:40:00',3.3),('9303','2013-05-13','13:45:00',2.85),('9303','2013-05-13','13:50:00',1.22),('9303','2013-05-13','13:55:00',1.17),('9303','2013-05-13','14:00:00',1.58),('9303','2013-05-13','14:05:00',4.62),('9303','2013-05-13','14:10:00',4.69),('9303','2013-05-13','14:15:00',4.54),('9303','2013-05-13','14:20:00',4.2),('9303','2013-05-13','14:25:00',2.68),('9303','2013-05-13','14:30:00',3.46),('9303','2013-05-13','14:35:00',4.15),('9303','2013-05-13','14:40:00',4.23),('9303','2013-05-13','14:45:00',2.54),('9303','2013-05-13','14:50:00',2.1),('9303','2013-05-13','14:55:00',4.47),('9303','2013-05-13','15:00:00',2.21),('9303','2013-05-13','15:05:00',1.97),('9303','2013-05-13','15:10:00',1.05),('9303','2013-05-13','15:20:00',1.16),('9303','2013-05-13','16:00:00',1.31),('9303','2013-05-13','16:05:00',1.48),('9303','2013-05-13','16:10:00',1.49),('9303','2013-05-13','16:15:00',1.11),('9303','2013-05-13','16:20:00',1.24),('9303','2013-05-13','16:25:00',1.21),('9303','2013-05-13','16:30:00',1.76),('9303','2013-05-13','16:35:00',1.33),('9303','2013-05-13','16:40:00',1.84),('9303','2013-05-13','16:45:00',2.14),('9303','2013-05-13','16:50:00',3.27),('9303','2013-05-13','16:55:00',2.97),('9303','2013-05-13','17:00:00',2.75),('9303','2013-05-13','17:05:00',2.39),('9303','2013-05-13','17:10:00',1.69),('9303','2013-05-13','17:15:00',2.79),('9303','2013-05-13','17:20:00',2.8),('9303','2013-05-13','17:25:00',2.59),('9303','2013-05-13','17:30:00',2.36),('9303','2013-05-13','17:35:00',2.23),('9303','2013-05-13','17:40:00',2.03),('9303','2013-05-13','17:45:00',1.98),('9303','2013-05-13','17:50:00',1.44),('9303','2013-05-12','08:10:00',1.11),('9303','2013-05-12','08:15:00',1.55),('9303','2013-05-12','08:20:00',1.32),('9303','2013-05-12','08:25:00',1.4),('9303','2013-05-12','08:40:00',1.03),('9303','2013-05-12','08:45:00',1.39),('9303','2013-05-12','08:50:00',1.61),('9303','2013-05-12','09:00:00',1.08),('9303','2013-05-12','09:05:00',1.06),('9303','2013-05-12','09:15:00',1.14),('9303','2013-05-12','09:20:00',1.17),('9303','2013-05-12','09:25:00',1.11),('9303','2013-05-12','09:30:00',1.88),('9303','2013-05-12','09:35:00',2.06),('9303','2013-05-12','09:40:00',1.24),('9303','2013-05-12','09:45:00',2.76),('9303','2013-05-12','09:50:00',3.12),('9303','2013-05-12','09:55:00',3.54),('9303','2013-05-12','10:00:00',3.46),('9303','2013-05-12','10:05:00',1.93),('9303','2013-05-12','10:10:00',1.32),('9303','2013-05-12','10:30:00',2.6),('9303','2013-05-12','10:35:00',1.21),('9303','2013-05-12','10:40:00',2.34),('9303','2013-05-12','10:45:00',3.5),('9303','2013-05-12','10:50:00',2.39),('9303','2013-05-12','10:55:00',3.15),('9303','2013-05-12','11:00:00',4.04),('9303','2013-05-12','11:05:00',1.05),('9303','2013-05-12','11:10:00',2.72),('9303','2013-05-12','11:15:00',4.29),('9303','2013-05-12','11:20:00',4.28),('9303','2013-05-12','11:25:00',4.41),('9303','2013-05-12','11:30:00',4.55),('9303','2013-05-12','11:35:00',4.35),('9303','2013-05-12','11:40:00',3.7),('9303','2013-05-12','11:45:00',3.92),('9303','2013-05-12','11:50:00',2.4),('9303','2013-05-12','11:55:00',3.8),('9303','2013-05-12','12:00:00',3.25),('9303','2013-05-12','12:05:00',3.93),('9303','2013-05-12','12:10:00',4.24),('9303','2013-05-12','12:15:00',1.86),('9303','2013-05-12','12:20:00',1),('9303','2013-05-12','12:25:00',1.02),('9303','2013-05-12','12:30:00',1.22),('9303','2013-05-12','12:35:00',2.28),('9303','2013-05-12','12:40:00',2.3),('9303','2013-05-12','12:45:00',3.43),('9303','2013-05-12','12:50:00',4.32),('9303','2013-05-12','12:55:00',4.5),('9303','2013-05-12','13:00:00',1.98),('9303','2013-05-12','13:05:00',1.69),('9303','2013-05-12','13:10:00',3.93),('9303','2013-05-12','13:15:00',3.32),('9303','2013-05-12','13:20:00',2.59),('9303','2013-05-12','13:25:00',2.7),('9303','2013-05-12','13:30:00',4.36),('9303','2013-05-12','13:35:00',3.85),('9303','2013-05-12','13:40:00',4.53),('9303','2013-05-12','13:45:00',3.99),('9303','2013-05-12','13:50:00',4.03),('9303','2013-05-12','13:55:00',3.31),('9303','2013-05-12','14:00:00',3.74),('9303','2013-05-12','14:05:00',3.85),('9303','2013-05-12','14:10:00',2.97),('9303','2013-05-12','14:15:00',4.59),('9303','2013-05-12','14:20:00',4.25),('9303','2013-05-12','14:25:00',4.01),('9303','2013-05-12','14:30:00',4.39),('9303','2013-05-12','14:35:00',4.32),('9303','2013-05-12','14:40:00',4.25),('9303','2013-05-12','14:45:00',4.14),('9303','2013-05-12','14:50:00',4.18),('9303','2013-05-12','14:55:00',4.13),('9303','2013-05-12','15:00:00',3.63),('9303','2013-05-12','15:05:00',4.1),('9303','2013-05-12','15:10:00',3.91),('9303','2013-05-12','15:15:00',2.94),('9303','2013-05-12','15:20:00',3.29),('9303','2013-05-12','15:25:00',3.53),('9303','2013-05-12','15:30:00',3.71),('9303','2013-05-12','15:35:00',3.65),('9303','2013-05-12','15:40:00',3.6),('9303','2013-05-12','15:45:00',3.52),('9303','2013-05-12','15:50:00',3.44),('9303','2013-05-12','15:55:00',3.34),('9303','2013-05-12','16:00:00',3.28),('9303','2013-05-12','16:05:00',3.15),('9303','2013-05-12','16:10:00',3.14),('9303','2013-05-12','16:15:00',3.08),('9303','2013-05-12','16:20:00',3.02),('9303','2013-05-12','16:25:00',2.93),('9303','2013-05-12','16:30:00',2.89),('9303','2013-05-12','16:35:00',2.87),('9303','2013-05-12','16:40:00',2.92),('9303','2013-05-12','16:45:00',3.09),('9303','2013-05-12','16:50:00',2.73),('9303','2013-05-12','16:55:00',2.94),('9303','2013-05-12','17:00:00',3.18),('9303','2013-05-12','17:05:00',2.57),('9303','2013-05-12','17:10:00',2.7),('9303','2013-05-12','17:15:00',2.67),('9303','2013-05-12','17:20:00',2.55),('9303','2013-05-12','17:25:00',2.06),('9303','2013-05-12','17:30:00',2.08),('9303','2013-05-12','17:35:00',1.79),('9303','2013-05-12','17:40:00',1.3),('9303','2013-05-12','17:45:00',1.27),('9303','2013-05-12','18:00:00',1.16),('9303','2013-05-12','18:05:00',1.5),('9303','2013-05-12','18:10:00',1.54),('9303','2013-05-12','18:15:00',1.18),('9303','2013-05-12','18:25:00',1.13),('9303','2013-05-12','18:30:00',1.11),('9303','2013-05-12','18:35:00',1.13),('9303','2014-03-31','08:25:00',1.08),('9303','2014-03-31','08:30:00',1.17),('9303','2014-03-31','08:35:00',1.28),('9303','2014-03-31','08:40:00',1.36),('9303','2014-03-31','08:45:00',1.48),('9303','2014-03-31','08:50:00',1.56),('9303','2014-03-31','08:55:00',1.66),('9303','2014-03-31','09:00:00',1.77),('9303','2014-03-31','09:05:00',1.86),('9303','2014-03-31','09:10:00',1.94),('9303','2014-03-31','09:15:00',2.02),('9303','2014-03-31','09:20:00',2.1),('9303','2014-03-31','09:25:00',2.19),('9303','2014-03-31','09:30:00',2.28),('9303','2014-03-31','09:35:00',2.35),('9303','2014-03-31','09:40:00',2.4),('9303','2014-03-31','09:45:00',2.48),('9303','2014-03-31','09:50:00',2.54),('9303','2014-03-31','09:55:00',2.6),('9303','2014-03-31','10:00:00',2.68),('9303','2014-03-31','10:05:00',2.74),('9303','2014-03-31','10:10:00',2.8),('9303','2014-03-31','10:15:00',2.85),('9303','2014-03-31','10:20:00',2.94),('9303','2014-03-31','10:25:00',2.99),('9303','2014-03-31','10:30:00',3.04),('9303','2014-03-31','10:35:00',3.13),('9303','2014-03-31','10:40:00',3.16),('9303','2014-03-31','10:45:00',3.2),('9303','2014-03-31','10:50:00',3.25),('9303','2014-03-31','10:55:00',3.33),('9303','2014-03-31','11:00:00',3.39),('9303','2014-03-31','11:05:00',3.41),('9303','2014-03-31','11:10:00',3.44),('9303','2014-03-31','11:15:00',3.51),('9303','2014-03-31','11:20:00',3.51),('9303','2014-03-31','11:25:00',3.57),('9303','2014-03-31','11:30:00',3.62),('9303','2014-03-31','11:35:00',3.65),('9303','2014-03-31','11:40:00',3.64),('9303','2014-03-31','11:45:00',3.66),('9303','2014-03-31','11:50:00',3.71),('9303','2014-03-31','11:55:00',3.76),('9303','2014-03-31','12:00:00',3.79),('9303','2014-03-31','12:05:00',3.76),('9303','2014-03-31','12:10:00',3.77),('9303','2014-03-31','12:15:00',3.82),('9303','2014-03-31','12:20:00',3.9),('9303','2014-03-31','12:25:00',3.89),('9303','2014-03-31','12:30:00',3.88),('9303','2014-03-31','12:35:00',3.88),('9303','2014-03-31','12:40:00',3.89),('9303','2014-03-31','12:45:00',3.9),('9303','2014-03-31','12:50:00',3.84),('9303','2014-03-31','12:55:00',3.84),('9303','2014-03-31','13:00:00',3.88),('9303','2014-03-31','13:05:00',3.92),('9303','2014-03-31','13:10:00',3.95),('9303','2014-03-31','13:15:00',3.95),('9303','2014-03-31','13:20:00',3.96),('9303','2014-03-31','13:25:00',3.98),('9303','2014-03-31','13:30:00',3.94),('9303','2014-03-31','13:35:00',3.99),('9303','2014-03-31','13:40:00',3.99),('9303','2014-03-31','13:45:00',4),('9303','2014-03-31','13:50:00',3.98),('9303','2014-03-31','13:55:00',3.97),('9303','2014-03-31','14:00:00',3.97),('9303','2014-03-31','14:05:00',3.97),('9303','2014-03-31','14:10:00',3.93),('9303','2014-03-31','14:15:00',3.93),('9303','2014-03-31','14:20:00',3.91),('9303','2014-03-31','14:25:00',3.88),('9303','2014-03-31','14:30:00',3.84),('9303','2014-03-31','14:35:00',3.81),('9303','2014-03-31','14:40:00',3.8),('9303','2014-03-31','14:45:00',3.76),('9303','2014-03-31','14:50:00',3.7),('9303','2014-03-31','14:55:00',3.68),('9303','2014-03-31','15:00:00',3.62),('9303','2014-03-31','15:05:00',3.59),('9303','2014-03-31','15:10:00',3.57),('9303','2014-03-31','15:15:00',3.49),('9303','2014-03-31','15:20:00',3.45),('9303','2014-03-31','15:25:00',3.41),('9303','2014-03-31','15:30:00',3.36),('9303','2014-03-31','15:35:00',3.28),('9303','2014-03-31','15:40:00',3.22),('9303','2014-03-31','15:45:00',3.17),('9303','2014-03-31','15:50:00',3.09),('9303','2014-03-31','15:55:00',3.04),('9303','2014-03-31','16:00:00',2.96),('9303','2014-03-31','16:05:00',2.9),('9303','2014-03-31','16:10:00',2.82),('9303','2014-03-31','16:15:00',2.75),('9303','2014-03-31','16:20:00',2.68),('9303','2014-03-31','16:25:00',2.6),('9303','2014-03-31','16:30:00',2.53),('9303','2014-03-31','16:35:00',2.46),('9303','2014-03-31','16:40:00',2.34),('9303','2014-03-31','16:45:00',2.21),('9303','2014-03-31','16:50:00',2.11),('9303','2014-03-31','16:55:00',2.03),('9303','2014-03-31','17:00:00',1.94),('9303','2014-03-31','17:05:00',1.87),('9303','2014-03-31','17:10:00',1.79),('9303','2014-03-31','17:15:00',1.7),('9303','2014-03-31','17:20:00',1.6),('9303','2014-03-31','17:25:00',1.49),('9303','2014-03-31','17:30:00',1.39),('9303','2014-03-31','17:35:00',1.32),('9303','2014-03-31','17:40:00',1.23),('9303','2014-03-31','17:45:00',1.14),('9303','2014-03-31','17:50:00',1.04),('9303','2013-05-11','07:50:00',1.15),('9303','2013-05-11','07:55:00',1.31),('9303','2013-05-11','08:00:00',1.23),('9303','2013-05-11','08:05:00',1.3),('9303','2013-05-11','08:15:00',1.16),('9303','2013-05-11','08:20:00',1.17),('9303','2013-05-11','09:10:00',1.23),('9303','2013-05-11','09:15:00',1.22),('9303','2013-05-11','09:20:00',1.81),('9303','2013-05-11','09:25:00',1.28),('9303','2013-05-11','09:30:00',2.31),('9303','2013-05-11','09:35:00',1.95),('9303','2013-05-11','09:40:00',1.43),('9303','2013-05-11','09:45:00',1.91),('9303','2013-05-11','09:50:00',1.56),('9303','2013-05-11','09:55:00',2.12),('9303','2013-05-11','10:00:00',1.62),('9303','2013-05-11','10:05:00',1.55),('9303','2013-05-11','10:30:00',1.06),('9303','2013-05-11','10:35:00',1.13),('9303','2013-05-11','10:50:00',1.09),('9303','2013-05-11','10:55:00',2.54),('9303','2013-05-11','11:00:00',3.74),('9303','2013-05-11','11:05:00',2.67),('9303','2013-05-11','11:10:00',1.21),('9303','2013-05-11','11:30:00',1.3),('9303','2013-05-11','11:35:00',2.8),('9303','2013-05-11','11:40:00',1.87),('9303','2013-05-11','11:45:00',3.7),('9303','2013-05-11','11:50:00',2.52),('9303','2013-05-11','12:00:00',1.17),('9303','2013-05-11','12:05:00',1.8),('9303','2013-05-11','12:10:00',1.41),('9303','2013-05-11','12:15:00',1.41),('9303','2013-05-11','12:20:00',2.06),('9303','2013-05-11','12:25:00',4.78),('9303','2013-05-11','12:30:00',3.19),('9303','2013-05-11','12:35:00',2.23),('9303','2013-05-11','12:40:00',1.91),('9303','2013-05-11','12:45:00',1.76),('9303','2013-05-11','12:50:00',1.59),('9303','2013-05-11','12:55:00',1.46),('9303','2013-05-11','13:00:00',1.33),('9303','2013-05-11','13:05:00',1.4),('9303','2013-05-11','13:10:00',1.02),('9303','2013-05-11','13:35:00',1.11),('9303','2013-05-11','14:00:00',1.92),('9303','2013-05-11','14:05:00',3.21),('9303','2013-05-11','14:10:00',2.7),('9303','2013-05-11','14:15:00',2.82),('9303','2013-05-11','14:20:00',4.45),('9303','2013-05-11','14:25:00',3.26),('9303','2013-05-11','14:30:00',2.72),('9303','2013-05-11','14:35:00',2.88),('9303','2013-05-11','14:40:00',2.22),('9303','2013-05-11','14:45:00',3.82),('9303','2013-05-11','14:50:00',4.41),('9303','2013-05-11','14:55:00',4.26),('9303','2013-05-11','15:00:00',4.04),('9303','2013-05-11','15:05:00',3.85),('9303','2013-05-11','15:10:00',4.1),('9303','2013-05-11','15:15:00',3.95),('9303','2013-05-11','15:20:00',3.92),('9303','2013-05-11','15:25:00',3.79),('9303','2013-05-11','15:30:00',3.78),('9303','2013-05-11','15:35:00',3.46),('9303','2013-05-11','15:40:00',3.73),('9303','2013-05-11','15:45:00',3.64),('9303','2013-05-11','15:50:00',2.82),('9303','2013-05-11','15:55:00',3.48),('9303','2013-05-11','16:00:00',3.54),('9303','2013-05-11','16:05:00',3.39),('9303','2013-05-11','16:10:00',3.31),('9303','2013-05-11','16:15:00',2.85),('9303','2013-05-11','16:20:00',3.29),('9303','2013-05-11','16:25:00',3.18),('9303','2013-05-11','16:30:00',2.84),('9303','2013-05-11','16:35:00',2.64),('9303','2013-05-11','16:40:00',2.88),('9303','2013-05-11','16:45:00',2.79),('9303','2013-05-11','16:50:00',1.94),('9303','2013-05-11','16:55:00',2.7),('9303','2013-05-11','17:00:00',2.55),('9303','2013-05-11','17:05:00',2.2),('9303','2013-05-11','17:10:00',2.26),('9303','2013-05-11','17:15:00',1.72),('9303','2013-05-11','17:20:00',1.98),('9303','2013-05-11','17:25:00',2.06),('9303','2013-05-11','17:30:00',1.76),('9303','2013-05-11','17:35:00',1.65),('9303','2013-05-11','17:40:00',1.55),('9303','2013-05-11','17:45:00',1.86),('9303','2013-05-11','17:50:00',1.14),('9303','2013-05-11','17:55:00',1.37),('9303','2013-05-11','18:05:00',1.04),('9303','2013-05-11','18:10:00',1.34),('9303','2013-05-11','18:15:00',1.01),('9303','2013-05-11','18:25:00',1.06),('9303','2013-05-10','07:55:00',1.16),('9303','2013-05-10','08:00:00',1.22),('9303','2013-05-10','08:05:00',1.81),('9303','2013-05-10','08:10:00',1.85),('9303','2013-05-10','08:15:00',1.92),('9303','2013-05-10','08:20:00',1.79),('9303','2013-05-10','08:25:00',1.71),('9303','2013-05-10','08:30:00',1.8),('9303','2013-05-10','08:35:00',1.81),('9303','2013-05-10','09:00:00',1.36),('9303','2013-05-10','09:05:00',2.25),('9303','2013-05-10','09:10:00',2.53),('9303','2013-05-10','09:15:00',2.63),('9303','2013-05-10','09:20:00',2.53),('9303','2013-05-10','09:25:00',2.21),('9303','2013-05-10','09:30:00',2.32),('9303','2013-05-10','09:35:00',2.85),('9303','2013-05-10','09:40:00',2.53),('9303','2013-05-10','09:45:00',2.78),('9303','2013-05-10','09:50:00',2.84),('9303','2013-05-10','09:55:00',2.12),('9303','2013-05-10','10:00:00',1.42),('9303','2013-05-10','10:05:00',2.34),('9303','2013-05-10','10:10:00',1.35),('9303','2013-05-10','10:15:00',1.98),('9303','2013-05-10','10:20:00',1.29),('9303','2013-05-10','10:25:00',2.38),('9303','2013-05-10','10:30:00',1.77),('9303','2013-05-10','10:35:00',1.79),('9303','2013-05-10','10:40:00',2.75),('9303','2013-05-10','10:45:00',3.86),('9303','2013-05-10','10:50:00',3.55),('9303','2013-05-10','10:55:00',3.25),('9303','2013-05-10','11:00:00',3.92),('9303','2013-05-10','11:05:00',3.94),('9303','2013-05-10','11:10:00',3.89),('9303','2013-05-10','11:15:00',3.59),('9303','2013-05-10','11:20:00',4.19),('9303','2013-05-10','11:25:00',3.81),('9303','2013-05-10','11:30:00',3.54),('9303','2013-05-10','11:35:00',3.4),('9303','2013-05-10','11:40:00',3.47),('9303','2013-05-10','11:45:00',2.17),('9303','2013-05-10','11:50:00',3.39),('9303','2013-05-10','11:55:00',4.19),('9303','2013-05-10','12:00:00',3.52),('9303','2013-05-10','12:05:00',2.55),('9303','2013-05-10','12:10:00',1.88),('9303','2013-05-10','12:15:00',2.08),('9303','2013-05-10','12:20:00',2.26),('9303','2013-05-10','12:25:00',2.18),('9303','2013-05-10','12:30:00',2.32),('9303','2013-05-10','12:35:00',2.59),('9303','2013-05-10','12:40:00',2.66),('9303','2013-05-10','12:45:00',4.46),('9303','2013-05-10','12:50:00',3.68),('9303','2013-05-10','12:55:00',3.1),('9303','2013-05-10','13:00:00',4.05),('9303','2013-05-10','13:05:00',3.65),('9303','2013-05-10','13:10:00',4.47),('9303','2013-05-10','13:15:00',4.61),('9303','2013-05-10','13:20:00',3.12),('9303','2013-05-10','13:25:00',2.84),('9303','2013-05-10','13:30:00',3.14),('9303','2013-05-10','13:35:00',3.56),('9303','2013-05-10','13:40:00',4.3),('9303','2013-05-10','13:45:00',3.88),('9303','2013-05-10','13:50:00',2.28),('9303','2013-05-10','13:55:00',2.02),('9303','2013-05-10','14:00:00',1.83),('9303','2013-05-10','14:05:00',1.9),('9303','2013-05-10','14:10:00',2.33),('9303','2013-05-10','14:15:00',2.42),('9303','2013-05-10','14:20:00',2.44),('9303','2013-05-10','14:25:00',2.45),('9303','2013-05-10','14:30:00',2.45),('9303','2013-05-10','14:35:00',3.05),('9303','2013-05-10','14:40:00',2.64),('9303','2013-05-10','14:45:00',1.91),('9303','2013-05-10','14:50:00',1.41),('9303','2013-05-10','14:55:00',1.22),('9303','2013-05-10','15:00:00',1.15),('9303','2013-05-10','15:05:00',1.25),('9303','2013-05-10','15:10:00',1.71),('9303','2013-05-10','15:15:00',3.17),('9303','2013-05-10','15:20:00',2.6),('9303','2013-05-10','15:25:00',1.9),('9303','2013-05-10','15:30:00',1.8),('9303','2013-05-10','15:35:00',1.84),('9303','2013-05-10','15:40:00',1.91),('9303','2013-05-10','15:45:00',1.82),('9303','2013-05-10','15:50:00',1.67),('9303','2013-05-10','15:55:00',1.58),('9303','2013-05-10','16:00:00',1.52),('9303','2013-05-10','16:05:00',1.49),('9303','2013-05-10','16:10:00',1.47),('9303','2013-05-10','16:15:00',1.36),('9303','2013-05-10','16:20:00',1.22),('9303','2013-05-10','16:25:00',1.22),('9303','2013-05-10','16:30:00',1.29),('9303','2013-05-10','16:35:00',1.37),('9303','2013-05-10','16:40:00',1.3),('9303','2013-05-10','16:45:00',1.32),('9303','2013-05-10','16:50:00',1.27),('9303','2013-05-10','16:55:00',1.07),('9303','2013-05-10','17:10:00',1.04),('9303','2013-05-10','17:15:00',1.33),('9303','2013-05-10','17:20:00',1.78),('9303','2013-05-10','17:25:00',1.71),('9303','2013-05-10','17:30:00',1.52),('9303','2013-05-10','17:35:00',1.49),('9303','2013-05-10','17:40:00',1.23),('9303','2013-05-10','17:45:00',1.1),('9303','2013-05-09','07:50:00',1.06),('9303','2013-05-09','07:55:00',1.16),('9303','2013-05-09','08:00:00',1.25),('9303','2013-05-09','08:05:00',1.35),('9303','2013-05-09','08:10:00',1.45),('9303','2013-05-09','08:15:00',1.53),('9303','2013-05-09','08:20:00',1.64),('9303','2013-05-09','08:25:00',1.73),('9303','2013-05-09','08:30:00',1.83),('9303','2013-05-09','08:35:00',1.92),('9303','2013-05-09','08:40:00',2),('9303','2013-05-09','08:45:00',2.1),('9303','2013-05-09','08:50:00',2.16),('9303','2013-05-09','08:55:00',2.24),('9303','2013-05-09','09:00:00',2.32),('9303','2013-05-09','09:05:00',2.41),('9303','2013-05-09','09:10:00',2.49),('9303','2013-05-09','09:15:00',2.57),('9303','2013-05-09','09:20:00',2.63),('9303','2013-05-09','09:25:00',2.73),('9303','2013-05-09','09:30:00',2.8),('9303','2013-05-09','09:35:00',2.87),('9303','2013-05-09','09:40:00',2.91),('9303','2013-05-09','09:45:00',2.98),('9303','2013-05-09','09:50:00',3.06),('9303','2013-05-09','09:55:00',3.13),('9303','2013-05-09','10:00:00',3.19),('9303','2013-05-09','10:05:00',3.24),('9303','2013-05-09','10:10:00',3.3),('9303','2013-05-09','10:15:00',3.35),('9303','2013-05-09','10:20:00',3.39),('9303','2013-05-09','10:25:00',3.44),('9303','2013-05-09','10:30:00',3.49),('9303','2013-05-09','10:35:00',3.51),('9303','2013-05-09','10:40:00',3.55),('9303','2013-05-09','10:45:00',3.6),('9303','2013-05-09','10:50:00',3.65),('9303','2013-05-09','10:55:00',3.71),('9303','2013-05-09','11:00:00',3.72),('9303','2013-05-09','11:05:00',3.76),('9303','2013-05-09','11:10:00',3.78),('9303','2013-05-09','11:15:00',3.8),('9303','2013-05-09','11:20:00',3.83),('9303','2013-05-09','11:25:00',3.82),('9303','2013-05-09','11:30:00',3.84),('9303','2013-05-09','11:35:00',3.91),('9303','2013-05-09','11:40:00',3.91),('9303','2013-05-09','11:45:00',3.88),('9303','2013-05-09','11:50:00',3.88),('9303','2013-05-09','11:55:00',4),('9303','2013-05-09','12:00:00',4.02),('9303','2013-05-09','12:05:00',4.07),('9303','2013-05-09','12:10:00',4.1),('9303','2013-05-09','12:15:00',4.08),('9303','2013-05-09','12:20:00',4.05),('9303','2013-05-09','12:25:00',4.08),('9303','2013-05-09','12:30:00',4.13),('9303','2013-05-09','12:35:00',4.03),('9303','2013-05-09','12:40:00',4.22),('9303','2013-05-09','12:45:00',4.22),('9303','2013-05-09','12:50:00',4.28),('9303','2013-05-09','12:55:00',4.2),('9303','2013-05-09','13:00:00',4.14),('9303','2013-05-09','13:05:00',4.15),('9303','2013-05-09','13:10:00',4.17),('9303','2013-05-09','13:15:00',4.19),('9303','2013-05-09','13:20:00',4.22),('9303','2013-05-09','13:25:00',4.17),('9303','2013-05-09','13:30:00',4.2),('9303','2013-05-09','13:35:00',4.22),('9303','2013-05-09','13:40:00',4.21),('9303','2013-05-09','13:45:00',4.21),('9303','2013-05-09','13:50:00',4.18),('9303','2013-05-09','13:55:00',4.17),('9303','2013-05-09','14:00:00',2.54),('9303','2013-05-09','14:05:00',4.16),('9303','2013-05-09','14:10:00',3.11),('9303','2013-05-09','14:15:00',2.39),('9303','2013-05-09','14:20:00',2.49),('9303','2013-05-09','14:25:00',4.21),('9303','2013-05-09','14:30:00',3.73),('9303','2013-05-09','14:35:00',3.93),('9303','2013-05-09','14:40:00',3.93),('9303','2013-05-09','14:45:00',3.9),('9303','2013-05-09','14:50:00',3.82),('9303','2013-05-09','14:55:00',3.84),('9303','2013-05-09','15:00:00',3.84),('9303','2013-05-09','15:05:00',3.76),('9303','2013-05-09','15:10:00',3.71),('9303','2013-05-09','15:15:00',3.67),('9303','2013-05-09','15:20:00',3.6),('9303','2013-05-09','15:25:00',3.55),('9303','2013-05-09','15:30:00',3.54),('9303','2013-05-09','15:35:00',3.5),('9303','2013-05-09','15:40:00',3.44),('9303','2013-05-09','15:45:00',3.41),('9303','2013-05-09','15:50:00',3.36),('9303','2013-05-09','15:55:00',3.3),('9303','2013-05-09','16:00:00',3.23),('9303','2013-05-09','16:05:00',3.17),('9303','2013-05-09','16:10:00',3.13),('9303','2013-05-09','16:15:00',3.06),('9303','2013-05-09','16:20:00',2.98),('9303','2013-05-09','16:25:00',2.89),('9303','2013-05-09','16:30:00',2.84),('9303','2013-05-09','16:35:00',2.76),('9303','2013-05-09','16:40:00',2.7),('9303','2013-05-09','16:45:00',2.62),('9303','2013-05-09','16:50:00',2.54),('9303','2013-05-09','16:55:00',2.44),('9303','2013-05-09','17:00:00',2.33),('9303','2013-05-09','17:05:00',2.22),('9303','2013-05-09','17:10:00',2.12),('9303','2013-05-09','17:15:00',2.03),('9303','2013-05-09','17:20:00',1.98),('9303','2013-05-09','17:25:00',1.91),('9303','2013-05-09','17:30:00',1.82),('9303','2013-05-09','17:35:00',1.73),('9303','2013-05-09','17:40:00',1.63),('9303','2013-05-09','17:45:00',1.54),('9303','2013-05-09','17:50:00',1.43),('9303','2013-05-09','17:55:00',1.34),('9303','2013-05-09','18:00:00',1.25),('9303','2013-05-09','18:05:00',1.16),('9303','2013-05-09','18:10:00',1.07),('9303','2013-05-08','08:05:00',1.4),('9303','2013-05-08','08:10:00',1.56),('9303','2013-05-08','08:15:00',1.61),('9303','2013-05-08','08:20:00',1.67),('9303','2013-05-08','08:25:00',1.76),('9303','2013-05-08','08:30:00',1.8),('9303','2013-05-08','08:35:00',1.86),('9303','2013-05-08','08:40:00',2.02),('9303','2013-05-08','08:45:00',2.24),('9303','2013-05-08','08:50:00',2.15),('9303','2013-05-08','08:55:00',2.17),('9303','2013-05-08','09:00:00',1.98),('9303','2013-05-08','09:05:00',1.62),('9303','2013-05-08','09:10:00',2.05),('9303','2013-05-08','09:15:00',1.05),('9303','2013-05-08','09:40:00',2.38),('9303','2013-05-08','09:45:00',1.89),('9303','2013-05-08','09:50:00',1.56),('9303','2013-05-08','09:55:00',2.26),('9303','2013-05-08','10:05:00',1.82),('9303','2013-05-08','10:10:00',2.57),('9303','2013-05-08','10:15:00',1.24),('9303','2013-05-08','11:00:00',1.63),('9303','2013-05-08','11:05:00',4.33),('9303','2013-05-08','11:10:00',4.21),('9303','2013-05-08','11:15:00',4.09),('9303','2013-05-08','11:20:00',3.98),('9303','2013-05-08','11:25:00',4.09),('9303','2013-05-08','11:30:00',4.22),('9303','2013-05-08','11:35:00',2.88),('9303','2013-05-08','11:40:00',4.02),('9303','2013-05-08','11:45:00',1.63),('9303','2013-05-08','11:50:00',1.52),('9303','2013-05-08','11:55:00',1.5),('9303','2013-05-08','12:00:00',2.76),('9303','2013-05-08','12:05:00',2.81),('9303','2013-05-08','12:20:00',2.67),('9303','2013-05-08','12:25:00',4.42),('9303','2013-05-08','12:30:00',2.31),('9303','2013-05-08','12:35:00',1.01),('9303','2013-05-08','12:40:00',1.1),('9303','2013-05-08','12:45:00',1.34),('9303','2013-05-08','12:50:00',1.35),('9303','2013-05-08','12:55:00',3.15),('9303','2013-05-08','13:00:00',3.33),('9303','2013-05-08','13:05:00',4.97),('9303','2013-05-08','13:10:00',4.9),('9303','2013-05-08','13:15:00',2.56),('9303','2013-05-08','13:20:00',1),('9303','2013-05-08','13:25:00',1.26),('9303','2013-05-08','13:40:00',1.59),('9303','2013-05-08','13:45:00',4.79),('9303','2013-05-08','13:50:00',4.67),('9303','2013-05-08','13:55:00',4.59),('9303','2013-05-08','14:00:00',3.11),('9303','2013-05-08','14:05:00',4.51),('9303','2013-05-08','14:10:00',2.84),('9303','2013-05-08','14:15:00',1.35),('9303','2013-05-08','14:20:00',1.68),('9303','2013-05-08','14:25:00',1.34),('9303','2013-05-08','14:30:00',1.54),('9303','2013-05-08','14:35:00',2.04),('9303','2013-05-08','14:40:00',4.67),('9303','2013-05-08','14:45:00',1.83),('9303','2013-05-08','14:50:00',3.5),('9303','2013-05-08','14:55:00',3.84),('9303','2013-05-08','15:00:00',2.83),('9303','2013-05-08','15:05:00',3.92),('9303','2013-05-08','15:10:00',3.92),('9303','2013-05-08','15:15:00',3.84),('9303','2013-05-08','15:20:00',3.75),('9303','2013-05-08','15:25:00',3.71),('9303','2013-05-08','15:30:00',3.64),('9303','2013-05-08','15:35:00',3.53),('9303','2013-05-08','15:40:00',3.45),('9303','2013-05-08','15:45:00',3.44),('9303','2013-05-08','15:50:00',3.36),('9303','2013-05-08','15:55:00',3.34),('9303','2013-05-08','16:00:00',3.31),('9303','2013-05-08','16:05:00',3.23),('9303','2013-05-08','16:10:00',3.19),('9303','2013-05-08','16:15:00',3.12),('9303','2013-05-08','16:20:00',3.02),('9303','2013-05-08','16:25:00',2.95),('9303','2013-05-08','16:30:00',3.02),('9303','2013-05-08','16:35:00',2.95),('9303','2013-05-08','16:40:00',2.52),('9303','2013-05-08','16:45:00',1.26),('9303','2013-05-08','16:50:00',2.7),('9303','2013-05-08','16:55:00',2.62),('9303','2013-05-08','17:00:00',2.61),('9303','2013-05-08','17:05:00',2.3),('9303','2013-05-08','17:10:00',2.47),('9303','2013-05-08','17:15:00',2.34),('9303','2013-05-08','17:20:00',1.98),('9303','2013-05-08','17:25:00',2.07),('9303','2013-05-08','17:30:00',2.17),('9303','2013-05-08','17:35:00',2.1),('9303','2013-05-08','17:40:00',2.07),('9303','2013-05-08','17:45:00',2.06),('9303','2013-05-08','17:50:00',2),('9303','2013-05-08','17:55:00',1.49),('9303','2013-05-08','18:15:00',1.29),('9303','2013-05-08','18:20:00',1.22),('9303','2013-05-08','18:25:00',1.09),('9303','2013-05-07','07:50:00',1.03),('9303','2013-05-07','07:55:00',1.13),('9303','2013-05-07','08:00:00',1.22),('9303','2013-05-07','08:05:00',1.33),('9303','2013-05-07','08:10:00',1.42),('9303','2013-05-07','08:15:00',1.52),('9303','2013-05-07','08:20:00',1.62),('9303','2013-05-07','08:25:00',1.74),('9303','2013-05-07','08:30:00',1.84),('9303','2013-05-07','08:35:00',1.92),('9303','2013-05-07','08:40:00',2),('9303','2013-05-07','08:45:00',1.74),('9303','2013-05-07','08:50:00',2.27),('9303','2013-05-07','08:55:00',2.42),('9303','2013-05-07','09:00:00',2.42),('9303','2013-05-07','09:05:00',2.39),('9303','2013-05-07','09:10:00',1.38),('9303','2013-05-07','09:15:00',1.54),('9303','2013-05-07','09:20:00',1.42),('9303','2013-05-07','09:35:00',1.2),('9303','2013-05-07','09:40:00',1.29),('9303','2013-05-07','09:45:00',1.61),('9303','2013-05-07','09:50:00',1.91),('9303','2013-05-07','09:55:00',1.09),('9303','2013-05-07','11:00:00',1.05),('9303','2013-05-07','11:05:00',1.2),('9303','2013-05-07','11:10:00',1.21),('9303','2013-05-07','11:15:00',1.24),('9303','2013-05-07','11:20:00',1.67),('9303','2013-05-07','11:25:00',2.58),('9303','2013-05-07','11:30:00',1.06),('9303','2013-05-07','12:00:00',1.77),('9303','2013-05-07','12:05:00',4.53),('9303','2013-05-07','12:10:00',2.2),('9303','2013-05-07','12:15:00',4.84),('9303','2013-05-07','12:20:00',3.06),('9303','2013-05-07','12:25:00',4.43),('9303','2013-05-07','12:30:00',3.34),('9303','2013-05-07','13:25:00',1.09),('9303','2013-05-07','13:30:00',1.4),('9303','2013-05-07','13:35:00',2.26),('9303','2013-05-07','13:40:00',3.32),('9303','2013-05-07','13:45:00',4.48),('9303','2013-05-07','13:50:00',4.6),('9303','2013-05-07','13:55:00',4.52),('9303','2013-05-07','14:00:00',4.54),('9303','2013-05-07','14:05:00',3.95),('9303','2013-05-07','14:10:00',4.41),('9303','2013-05-07','14:15:00',4.5),('9303','2013-05-07','14:20:00',4.05),('9303','2013-05-07','14:25:00',1.02),('9303','2013-05-07','14:30:00',3.47),('9303','2013-05-07','14:35:00',2.32),('9303','2013-05-07','14:40:00',4.81),('9303','2013-05-07','14:45:00',3.54),('9303','2013-05-07','14:50:00',3.68),('9303','2013-05-07','14:55:00',3.55),('9303','2013-05-07','15:00:00',2.8),('9303','2013-05-07','15:05:00',4.21),('9303','2013-05-07','15:10:00',3.08),('9303','2013-05-07','15:15:00',3.81),('9303','2013-05-07','15:20:00',3.55),('9303','2013-05-07','15:25:00',2.41),('9303','2013-05-07','15:30:00',2.01),('9303','2013-05-07','15:35:00',2.86),('9303','2013-05-07','15:40:00',2.3),('9303','2013-05-07','15:45:00',2.14),('9303','2013-05-07','15:50:00',1.79),('9303','2013-05-07','15:55:00',1.88),('9303','2013-05-07','16:00:00',3.14),('9303','2013-05-07','16:05:00',1.91),('9303','2013-05-07','16:10:00',1.12),('9303','2013-05-07','16:15:00',2.2),('9303','2013-05-07','16:20:00',4.11),('9303','2013-05-07','16:25:00',3.83),('9303','2013-05-07','16:30:00',3.61),('9303','2013-05-07','16:35:00',3.5),('9303','2013-05-07','16:40:00',3.6),('9303','2013-05-07','16:45:00',2.5),('9303','2013-05-07','16:50:00',2.56),('9303','2013-05-07','16:55:00',2.36),('9303','2013-05-07','17:00:00',2.69),('9303','2013-05-07','17:05:00',2.63),('9303','2013-05-07','17:10:00',1.89),('9303','2013-05-07','17:15:00',1.13),('9303','2013-05-07','17:20:00',1.08),('9303','2013-05-07','17:25:00',1.12),('9303','2013-05-06','08:25:00',1.02),('9303','2013-05-06','08:30:00',1.19),('9303','2013-05-06','08:35:00',1.03),('9303','2013-05-06','08:55:00',1.74),('9303','2013-05-06','09:00:00',2.06),('9303','2013-05-06','09:05:00',1.34),('9303','2013-05-06','09:10:00',1.39),('9303','2013-05-06','09:15:00',1.31),('9303','2013-05-06','09:20:00',1.19),('9303','2013-05-06','09:25:00',1.03),('9303','2013-05-06','10:00:00',1.59),('9303','2013-05-06','10:05:00',1.11),('9303','2013-05-06','10:10:00',1.06),('9303','2013-05-06','10:15:00',1.28),('9303','2013-05-06','10:20:00',1.92),('9303','2013-05-06','10:25:00',1.59),('9303','2013-05-06','10:30:00',1.62),('9303','2013-05-06','10:35:00',1.63),('9303','2013-05-06','10:40:00',1.57),('9303','2013-05-06','10:45:00',2.13),('9303','2013-05-06','10:50:00',2.47),('9303','2013-05-06','10:55:00',1.88),('9303','2013-05-06','11:00:00',1.77),('9303','2013-05-06','11:05:00',1.89),('9303','2013-05-06','11:10:00',1.79),('9303','2013-05-06','11:15:00',1.61),('9303','2013-05-06','11:20:00',1.93),('9303','2013-05-06','11:25:00',1.99),('9303','2013-05-06','11:30:00',1.72),('9303','2013-05-06','11:35:00',1.35),('9303','2013-05-06','11:40:00',2.42),('9303','2013-05-06','11:45:00',4.18),('9303','2013-05-06','11:50:00',2.6),('9303','2013-05-06','11:55:00',1.61),('9303','2013-05-06','12:00:00',1.64),('9303','2013-05-06','12:05:00',1.82),('9303','2013-05-06','12:10:00',4.24),('9303','2013-05-06','12:15:00',2.9),('9303','2013-05-06','12:20:00',2.39),('9303','2013-05-06','12:25:00',2.89),('9303','2013-05-06','12:30:00',3.93),('9303','2013-05-06','12:35:00',4.28),('9303','2013-05-06','12:40:00',2.71),('9303','2013-05-06','12:45:00',2.02),('9303','2013-05-06','12:50:00',2.7),('9303','2013-05-06','12:55:00',3.51),('9303','2013-05-06','13:00:00',2.05),('9303','2013-05-06','13:05:00',3.03),('9303','2013-05-06','13:10:00',3.94),('9303','2013-05-06','13:15:00',3.62),('9303','2013-05-06','13:20:00',3.43),('9303','2013-05-06','13:25:00',2.63),('9303','2013-05-06','13:30:00',3.46),('9303','2013-05-06','13:35:00',2.79),('9303','2013-05-06','13:40:00',3.48),('9303','2013-05-06','13:45:00',4.59),('9303','2013-05-06','13:50:00',3.64),('9303','2013-05-06','13:55:00',4.52),('9303','2013-05-06','14:00:00',3.07),('9303','2013-05-06','14:05:00',4.4),('9303','2013-05-06','14:10:00',2.54),('9303','2013-05-06','14:15:00',3.09),('9303','2013-05-06','14:20:00',4.12),('9303','2013-05-06','14:25:00',2.22),('9303','2013-05-06','14:30:00',3.53),('9303','2013-05-06','14:35:00',3.58),('9303','2013-05-06','14:40:00',1.92),('9303','2013-05-06','14:45:00',3.32),('9303','2013-05-06','14:50:00',1.93),('9303','2013-05-06','14:55:00',3.49),('9303','2013-05-06','15:00:00',3.91),('9303','2013-05-06','15:05:00',3.08),('9303','2013-05-06','15:10:00',3.65),('9303','2013-05-06','15:15:00',2.1),('9303','2013-05-06','15:20:00',1.88),('9303','2013-05-06','15:25:00',3.14),('9303','2013-05-06','15:30:00',1.66),('9303','2013-05-06','15:35:00',1.5),('9303','2013-05-06','15:40:00',1.52),('9303','2013-05-06','15:45:00',1.27),('9303','2013-05-06','15:50:00',2.08),('9303','2013-05-06','15:55:00',1.8),('9303','2013-05-06','16:00:00',2.12),('9303','2013-05-06','16:05:00',1.37),('9303','2013-05-06','16:10:00',1.24),('9303','2013-05-06','16:15:00',1.68),('9303','2013-05-06','16:20:00',1.54),('9303','2013-05-06','16:25:00',1.65),('9303','2013-05-06','16:30:00',2.06),('9303','2013-05-06','16:35:00',1.47),('9303','2013-05-06','16:40:00',2.46),('9303','2013-05-06','16:45:00',2.82),('9303','2013-05-06','16:50:00',2.3),('9303','2013-05-06','16:55:00',2.73),('9303','2013-05-06','17:00:00',1.17),('9303','2013-05-06','17:35:00',1.09),('9303','2013-05-06','17:40:00',1.38),('9303','2013-05-06','17:50:00',1.06),('9303','2013-05-06','18:00:00',1.31),('9303','2013-05-06','18:05:00',1.42),('9303','2013-05-06','18:20:00',1.24),('9303','2013-05-06','18:25:00',1.01),('9303','2013-05-05','08:00:00',1.04),('9303','2013-05-05','08:05:00',1.19),('9303','2013-05-05','08:10:00',1.31),('9303','2013-05-05','08:15:00',1.43),('9303','2013-05-05','08:20:00',1.67),('9303','2013-05-05','08:25:00',2.03),('9303','2013-05-05','08:30:00',2.13),('9303','2013-05-05','08:35:00',1.83),('9303','2013-05-05','08:40:00',2.01),('9303','2013-05-05','08:45:00',1.64),('9303','2013-05-05','08:50:00',1.28),('9303','2013-05-05','08:55:00',1.17),('9303','2013-05-05','09:00:00',1.32),('9303','2013-05-05','09:05:00',1.46),('9303','2013-05-05','09:10:00',1.51),('9303','2013-05-05','09:15:00',1.63),('9303','2013-05-05','09:20:00',1.23),('9303','2013-05-05','09:25:00',1.4),('9303','2013-05-05','09:30:00',1.76),('9303','2013-05-05','09:35:00',1.31),('9303','2013-05-05','09:40:00',2.07),('9303','2013-05-05','09:45:00',2.67),('9303','2013-05-05','09:50:00',2.6),('9303','2013-05-05','09:55:00',3.23),('9303','2013-05-05','10:00:00',2.56),('9303','2013-05-05','10:05:00',2.47),('9303','2013-05-05','10:10:00',2.23),('9303','2013-05-05','10:15:00',2.2),('9303','2013-05-05','10:20:00',3.66),('9303','2013-05-05','10:25:00',2.24),('9303','2013-05-05','10:30:00',2.46),('9303','2013-05-05','10:35:00',2.52),('9303','2013-05-05','10:40:00',2.23),('9303','2013-05-05','10:45:00',2.35),('9303','2013-05-05','10:50:00',1.69),('9303','2013-05-05','10:55:00',1.47),('9303','2013-05-05','11:00:00',1.38),('9303','2013-05-05','11:05:00',1.63),('9303','2013-05-05','11:10:00',1.53),('9303','2013-05-05','11:15:00',1.55),('9303','2013-05-05','11:20:00',2.26),('9303','2013-05-05','11:25:00',3.33),('9303','2013-05-05','11:30:00',2.55),('9303','2013-05-05','11:35:00',3.72),('9303','2013-05-05','11:40:00',2.67),('9303','2013-05-05','11:45:00',2.64),('9303','2013-05-05','11:50:00',2.73),('9303','2013-05-05','11:55:00',3.42),('9303','2013-05-05','12:00:00',2.67),('9303','2013-05-05','12:05:00',2.34),('9303','2013-05-05','12:10:00',2.4),('9303','2013-05-05','12:15:00',2.94),('9303','2013-05-05','12:20:00',2.69),('9303','2013-05-05','12:25:00',4.05),('9303','2013-05-05','12:30:00',3.88),('9303','2013-05-05','12:35:00',3.39),('9303','2013-05-05','12:40:00',3.82),('9303','2013-05-05','12:45:00',3.96),('9303','2013-05-05','12:50:00',3.91),('9303','2013-05-05','12:55:00',4.08),('9303','2013-05-05','13:00:00',4.26),('9303','2013-05-05','13:05:00',4.23),('9303','2013-05-05','13:10:00',4.33),('9303','2013-05-05','13:15:00',4.35),('9303','2013-05-05','13:20:00',3.38),('9303','2013-05-05','13:25:00',1.84),('9303','2013-05-05','13:30:00',1.53),('9303','2013-05-05','13:35:00',3.58),('9303','2013-05-05','13:40:00',4.27),('9303','2013-05-05','13:45:00',4.22),('9303','2013-05-05','13:50:00',4.26),('9303','2013-05-05','13:55:00',4.28),('9303','2013-05-05','14:00:00',4.35),('9303','2013-05-05','14:05:00',4.24),('9303','2013-05-05','14:10:00',3.28),('9303','2013-05-05','14:15:00',3.17),('9303','2013-05-05','14:20:00',3.84),('9303','2013-05-05','14:25:00',3.86),('9303','2013-05-05','14:30:00',3.76),('9303','2013-05-05','14:35:00',3.73),('9303','2013-05-05','14:40:00',3.64),('9303','2013-05-05','14:45:00',3.6),('9303','2013-05-05','14:50:00',3.56),('9303','2013-05-05','14:55:00',3.56),('9303','2013-05-05','15:00:00',3.52),('9303','2013-05-05','15:05:00',3.49),('9303','2013-05-05','15:10:00',3.45),('9303','2013-05-05','15:15:00',3.44),('9303','2013-05-05','15:20:00',3.37),('9303','2013-05-05','15:25:00',3.34),('9303','2013-05-05','15:30:00',3.28),('9303','2013-05-05','15:35:00',3.23),('9303','2013-05-05','15:40:00',3.2),('9303','2013-05-05','15:45:00',3.17),('9303','2013-05-05','15:50:00',3.11),('9303','2013-05-05','15:55:00',3.06),('9303','2013-05-05','16:00:00',3),('9303','2013-05-05','16:05:00',2.94),('9303','2013-05-05','16:10:00',2.89),('9303','2013-05-05','16:15:00',2.84),('9303','2013-05-05','16:20:00',2.78),('9303','2013-05-05','16:25:00',2.71),('9303','2013-05-05','16:30:00',2.65),('9303','2013-05-05','16:35:00',2.56),('9303','2013-05-05','16:40:00',2.5),('9303','2013-05-05','16:45:00',2.43),('9303','2013-05-05','16:50:00',2.36),('9303','2013-05-05','16:55:00',2.24),('9303','2013-05-05','17:00:00',2.11),('9303','2013-05-05','17:05:00',2.02),('9303','2013-05-05','17:10:00',1.94),('9303','2013-05-05','17:15:00',1.88),('9303','2013-05-05','17:20:00',1.8),('9303','2013-05-05','17:25:00',1.71),('9303','2013-05-05','17:30:00',1.63),('9303','2013-05-05','17:35:00',1.56),('9303','2013-05-05','17:40:00',1.48),('9303','2013-05-05','17:45:00',1.4),('9303','2013-05-05','17:50:00',1.3),('9303','2013-05-05','17:55:00',1.21),('9303','2013-05-05','18:00:00',1.11),('9303','2013-05-05','18:05:00',1.03),('9303','2013-05-04','08:00:00',1.12),('9303','2013-05-04','08:05:00',1.19),('9303','2013-05-04','08:10:00',1.28),('9303','2013-05-04','08:15:00',1.36),('9303','2013-05-04','08:20:00',1.46),('9303','2013-05-04','08:25:00',1.53),('9303','2013-05-04','08:30:00',1.61),('9303','2013-05-04','08:35:00',1.69),('9303','2013-05-04','08:40:00',1.75),('9303','2013-05-04','08:45:00',1.85),('9303','2013-05-04','08:50:00',1.92),('9303','2013-05-04','08:55:00',2),('9303','2013-05-04','09:00:00',2.06),('9303','2013-05-04','09:05:00',2.15),('9303','2013-05-04','09:10:00',2.23),('9303','2013-05-04','09:15:00',2.24),('9303','2013-05-04','09:20:00',2.35),('9303','2013-05-04','09:25:00',2.41),('9303','2013-05-04','09:30:00',2.45),('9303','2013-05-04','09:35:00',2.55),('9303','2013-05-04','09:40:00',2.65),('9303','2013-05-04','09:45:00',2.71),('9303','2013-05-04','09:50:00',2.76),('9303','2013-05-04','09:55:00',2.83),('9303','2013-05-04','10:00:00',2.91),('9303','2013-05-04','10:05:00',2.95),('9303','2013-05-04','10:10:00',3.01),('9303','2013-05-04','10:15:00',3.06),('9303','2013-05-04','10:20:00',3.14),('9303','2013-05-04','10:25:00',3.19),('9303','2013-05-04','10:30:00',3.22),('9303','2013-05-04','10:35:00',3.26),('9303','2013-05-04','10:40:00',3.23),('9303','2013-05-04','10:45:00',3.27),('9303','2013-05-04','10:50:00',3.21),('9303','2013-05-04','10:55:00',3.23),('9303','2013-05-04','11:00:00',3.26),('9303','2013-05-04','11:05:00',3.29),('9303','2013-05-04','11:10:00',3.14),('9303','2013-05-04','11:15:00',3.02),('9303','2013-05-04','11:20:00',3.24),('9303','2013-05-04','11:25:00',3.32),('9303','2013-05-04','11:30:00',3.16),('9303','2013-05-04','11:35:00',3.28),('9303','2013-05-04','11:40:00',3.19),('9303','2013-05-04','11:45:00',3.26),('9303','2013-05-04','11:50:00',3.31),('9303','2013-05-04','11:55:00',3.3),('9303','2013-05-04','12:00:00',3.27),('9303','2013-05-04','12:05:00',3.36),('9303','2013-05-04','12:10:00',3.41),('9303','2013-05-04','12:15:00',3.51),('9303','2013-05-04','12:20:00',3.55),('9303','2013-05-04','12:25:00',3.64),('9303','2013-05-04','12:30:00',3.67),('9303','2013-05-04','12:35:00',3.68),('9303','2013-05-04','12:40:00',3.64),('9303','2013-05-04','12:45:00',3.69),('9303','2013-05-04','12:50:00',3.6),('9303','2013-05-04','12:55:00',3.55),('9303','2013-05-04','13:00:00',3.53),('9303','2013-05-04','13:05:00',3.18),('9303','2013-05-04','13:10:00',3.35),('9303','2013-05-04','13:15:00',3.82),('9303','2013-05-04','13:20:00',3.88),('9303','2013-05-04','13:25:00',3.65),('9303','2013-05-04','13:30:00',3.65),('9303','2013-05-04','13:35:00',3.48),('9303','2013-05-04','13:40:00',3.59),('9303','2013-05-04','13:45:00',3.61),('9303','2013-05-04','13:50:00',3.16),('9303','2013-05-04','13:55:00',3.32),('9303','2013-05-04','14:00:00',3.46),('9303','2013-05-04','14:05:00',3.48),('9303','2013-05-04','14:10:00',3.35),('9303','2013-05-04','14:15:00',3.39),('9303','2013-05-04','14:20:00',3.43),('9303','2013-05-04','14:25:00',3.14),('9303','2013-05-04','14:30:00',3.34),('9303','2013-05-04','14:35:00',3.13),('9303','2013-05-04','14:40:00',3.25),('9303','2013-05-04','14:45:00',3.21),('9303','2013-05-04','14:50:00',3.03),('9303','2013-05-04','14:55:00',3.18),('9303','2013-05-04','15:00:00',3.19),('9303','2013-05-04','15:05:00',3.27),('9303','2013-05-04','15:10:00',3.08),('9303','2013-05-04','15:15:00',3.16),('9303','2013-05-04','15:20:00',3.19),('9303','2013-05-04','15:25:00',3.19),('9303','2013-05-04','15:30:00',3.14),('9303','2013-05-04','15:35:00',3),('9303','2013-05-04','15:40:00',2.99),('9303','2013-05-04','15:45:00',3.05),('9303','2013-05-04','15:50:00',2.98),('9303','2013-05-04','15:55:00',2.94),('9303','2013-05-04','16:00:00',2.89),('9303','2013-05-04','16:05:00',2.83),('9303','2013-05-04','16:10:00',2.75),('9303','2013-05-04','16:15:00',2.7),('9303','2013-05-04','16:20:00',2.62),('9303','2013-05-04','16:25:00',2.58),('9303','2013-05-04','16:30:00',2.51),('9303','2013-05-04','16:35:00',2.45),('9303','2013-05-04','16:40:00',2.37),('9303','2013-05-04','16:45:00',2.29),('9303','2013-05-04','16:50:00',2.21),('9303','2013-05-04','16:55:00',2.12),('9303','2013-05-04','17:00:00',2.02),('9303','2013-05-04','17:05:00',1.88),('9303','2013-05-04','17:10:00',1.44),('9303','2013-05-04','17:15:00',1.64),('9303','2013-05-04','17:20:00',1.72),('9303','2013-05-04','17:25:00',1.65),('9303','2013-05-04','17:30:00',1.56),('9303','2013-05-04','17:35:00',1.43),('9303','2013-05-04','17:40:00',1.33),('9303','2013-05-04','17:45:00',1.26),('9303','2013-05-04','17:50:00',1.26),('9303','2013-05-04','17:55:00',1.19),('9303','2013-05-04','18:00:00',1.09),('9303','2013-05-04','18:05:00',1.01),('9303','2013-05-03','08:05:00',1.16),('9303','2013-05-03','08:10:00',1.37),('9303','2013-05-03','08:15:00',1.59),('9303','2013-05-03','08:20:00',1.57),('9303','2013-05-03','08:25:00',1.73),('9303','2013-05-03','08:30:00',1.81),('9303','2013-05-03','08:35:00',1.86),('9303','2013-05-03','08:40:00',1.89),('9303','2013-05-03','08:45:00',1.97),('9303','2013-05-03','08:50:00',1.94),('9303','2013-05-03','08:55:00',1.96),('9303','2013-05-03','09:00:00',2.1),('9303','2013-05-03','09:05:00',2.21),('9303','2013-05-03','09:10:00',2.27),('9303','2013-05-03','09:15:00',2.35),('9303','2013-05-03','09:20:00',2.41),('9303','2013-05-03','09:25:00',2.48),('9303','2013-05-03','09:30:00',2.57),('9303','2013-05-03','09:35:00',2.66),('9303','2013-05-03','09:40:00',2.74),('9303','2013-05-03','09:45:00',2.81),('9303','2013-05-03','09:50:00',2.87),('9303','2013-05-03','09:55:00',2.93),('9303','2013-05-03','10:00:00',2.99),('9303','2013-05-03','10:05:00',3.05),('9303','2013-05-03','10:10:00',3.1),('9303','2013-05-03','10:15:00',3.14),('9303','2013-05-03','10:20:00',3.2),('9303','2013-05-03','10:25:00',3.26),('9303','2013-05-03','10:30:00',3.32),('9303','2013-05-03','10:35:00',3.34),('9303','2013-05-03','10:40:00',3.36),('9303','2013-05-03','10:45:00',3.37),('9303','2013-05-03','10:50:00',3.4),('9303','2013-05-03','10:55:00',3.45),('9303','2013-05-03','11:00:00',3.5),('9303','2013-05-03','11:05:00',3.54),('9303','2013-05-03','11:10:00',3.61),('9303','2013-05-03','11:15:00',3.65),('9303','2013-05-03','11:20:00',3.65),('9303','2013-05-03','11:25:00',3.68),('9303','2013-05-03','11:30:00',3.73),('9303','2013-05-03','11:35:00',3.76),('9303','2013-05-03','11:40:00',3.83),('9303','2013-05-03','11:45:00',3.8),('9303','2013-05-03','11:50:00',3.8),('9303','2013-05-03','11:55:00',3.81),('9303','2013-05-03','12:00:00',3.82),('9303','2013-05-03','12:05:00',3.83),('9303','2013-05-03','12:10:00',3.86),('9303','2013-05-03','12:15:00',3.88),('9303','2013-05-03','12:20:00',3.88),('9303','2013-05-03','12:25:00',3.91),('9303','2013-05-03','12:30:00',3.89),('9303','2013-05-03','12:35:00',3.9),('9303','2013-05-03','12:40:00',3.87),('9303','2013-05-03','12:45:00',3.85),('9303','2013-05-03','12:50:00',3.9),('9303','2013-05-03','12:55:00',3.95),('9303','2013-05-03','13:00:00',3.95),('9303','2013-05-03','13:05:00',3.92),('9303','2013-05-03','13:10:00',3.9),('9303','2013-05-03','13:15:00',3.92),('9303','2013-05-03','13:20:00',3.94),('9303','2013-05-03','13:25:00',3.94),('9303','2013-05-03','13:30:00',3.9),('9303','2013-05-03','13:35:00',3.83),('9303','2013-05-03','13:40:00',3.67),('9303','2013-05-03','13:45:00',3.73),('9303','2013-05-03','13:50:00',3.71),('9303','2013-05-03','13:55:00',3.72),('9303','2013-05-03','14:00:00',3.71),('9303','2013-05-03','14:05:00',3.54),('9303','2013-05-03','14:10:00',3.62),('9303','2013-05-03','14:15:00',3.54),('9303','2013-05-03','14:20:00',3.61),('9303','2013-05-03','14:25:00',3.58),('9303','2013-05-03','14:30:00',3.61),('9303','2013-05-03','14:35:00',3.65),('9303','2013-05-03','14:40:00',3.57),('9303','2013-05-03','14:45:00',3.53),('9303','2013-05-03','14:50:00',3.49),('9303','2013-05-03','14:55:00',3.48),('9303','2013-05-03','15:00:00',3.45),('9303','2013-05-03','15:05:00',3.43),('9303','2013-05-03','15:10:00',3.44),('9303','2013-05-03','15:15:00',3.43),('9303','2013-05-03','15:20:00',3.36),('9303','2013-05-03','15:25:00',3.31),('9303','2013-05-03','15:30:00',3.28),('9303','2013-05-03','15:35:00',3.26),('9303','2013-05-03','15:40:00',3.19),('9303','2013-05-03','15:45:00',3.15),('9303','2013-05-03','15:50:00',3.07),('9303','2013-05-03','15:55:00',3.01),('9303','2013-05-03','16:00:00',2.97),('9303','2013-05-03','16:05:00',2.92),('9303','2013-05-03','16:10:00',2.87),('9303','2013-05-03','16:15:00',2.78),('9303','2013-05-03','16:20:00',2.68),('9303','2013-05-03','16:25:00',2.61),('9303','2013-05-03','16:30:00',2.6),('9303','2013-05-03','16:35:00',2.52),('9303','2013-05-03','16:40:00',2.46),('9303','2013-05-03','16:45:00',2.38),('9303','2013-05-03','16:50:00',2.31),('9303','2013-05-03','16:55:00',2.19),('9303','2013-05-03','17:00:00',2.09),('9303','2013-05-03','17:05:00',1.99),('9303','2013-05-03','17:10:00',1.91),('9303','2013-05-03','17:15:00',1.83),('9303','2013-05-03','17:20:00',1.71),('9303','2013-05-03','17:25:00',1.6),('9303','2013-05-03','17:30:00',1.53),('9303','2013-05-03','17:35:00',1.46),('9303','2013-05-03','17:40:00',1.37),('9303','2013-05-03','17:45:00',1.27),('9303','2013-05-03','17:50:00',1.2),('9303','2013-05-03','17:55:00',1.13),('9303','2013-05-03','18:00:00',1.05),('9303','2013-05-02','08:55:00',1.05),('9303','2013-05-02','09:00:00',1.75),('9303','2013-05-02','09:05:00',1.61),('9303','2013-05-02','09:25:00',1.66),('9303','2013-05-02','09:30:00',2.09),('9303','2013-05-02','09:35:00',1.88),('9303','2013-05-02','09:40:00',1.36),('9303','2013-05-02','09:45:00',2.45),('9303','2013-05-02','09:50:00',1.23),('9303','2013-05-02','10:05:00',1.38),('9303','2013-05-02','10:10:00',1.34),('9303','2013-05-02','10:15:00',1.35),('9303','2013-05-02','10:20:00',1.39),('9303','2013-05-02','10:25:00',1.63),('9303','2013-05-02','10:30:00',2.69),('9303','2013-05-02','10:35:00',2.53),('9303','2013-05-02','10:40:00',3.09),('9303','2013-05-02','10:45:00',2.96),('9303','2013-05-02','10:50:00',3.27),('9303','2013-05-02','10:55:00',3.76),('9303','2013-05-02','11:00:00',3.8),('9303','2013-05-02','11:05:00',3.39),('9303','2013-05-02','11:10:00',2.85),('9303','2013-05-02','11:15:00',2.68),('9303','2013-05-02','11:20:00',2.41),('9303','2013-05-02','11:25:00',3.69),('9303','2013-05-02','11:30:00',3.86),('9303','2013-05-02','11:35:00',3.79),('9303','2013-05-02','11:40:00',3.74),('9303','2013-05-02','11:45:00',3.76),('9303','2013-05-02','11:50:00',3.76),('9303','2013-05-02','11:55:00',3.74),('9303','2013-05-02','12:00:00',3.75),('9303','2013-05-02','12:05:00',3.72),('9303','2013-05-02','12:10:00',3.72),('9303','2013-05-02','12:15:00',3.74),('9303','2013-05-02','12:20:00',3.78),('9303','2013-05-02','12:25:00',3.76),('9303','2013-05-02','12:30:00',3.8),('9303','2013-05-02','12:35:00',3.84),('9303','2013-05-02','12:40:00',3.88),('9303','2013-05-02','12:45:00',3.9),('9303','2013-05-02','12:50:00',3.93),('9303','2013-05-02','12:55:00',3.94),('9303','2013-05-02','13:00:00',3.98),('9303','2013-05-02','13:05:00',4.02),('9303','2013-05-02','13:10:00',4),('9303','2013-05-02','13:15:00',4.04),('9303','2013-05-02','13:20:00',4.03),('9303','2013-05-02','13:25:00',4.03),('9303','2013-05-02','13:30:00',4.02),('9303','2013-05-02','13:35:00',4.05),('9303','2013-05-02','13:40:00',4.04),('9303','2013-05-02','13:45:00',4.03),('9303','2013-05-02','13:50:00',3.99),('9303','2013-05-02','13:55:00',3.98),('9303','2013-05-02','14:00:00',3.96),('9303','2013-05-02','14:05:00',3.88),('9303','2013-05-02','14:10:00',3.85),('9303','2013-05-02','14:15:00',3.84),('9303','2013-05-02','14:20:00',3.83),('9303','2013-05-02','14:25:00',3.79),('9303','2013-05-02','14:30:00',3.76),('9303','2013-05-02','14:35:00',3.73),('9303','2013-05-02','14:40:00',3.69),('9303','2013-05-02','14:45:00',3.66),('9303','2013-05-02','14:50:00',3.64),('9303','2013-05-02','14:55:00',3.58),('9303','2013-05-02','15:00:00',3.57),('9303','2013-05-02','15:05:00',3.51),('9303','2013-05-02','15:10:00',3.46),('9303','2013-05-02','15:15:00',3.42),('9303','2013-05-02','15:20:00',3.35),('9303','2013-05-02','15:25:00',3.3),('9303','2013-05-02','15:30:00',3.24),('9303','2013-05-02','15:35:00',3.16),('9303','2013-05-02','15:40:00',3.14),('9303','2013-05-02','15:45:00',3.07),('9303','2013-05-02','15:50:00',3.08),('9303','2013-05-02','15:55:00',3.02),('9303','2013-05-02','16:00:00',2.96),('9303','2013-05-02','16:05:00',2.92),('9303','2013-05-02','16:10:00',2.86),('9303','2013-05-02','16:15:00',2.8),('9303','2013-05-02','16:20:00',2.73),('9303','2013-05-02','16:25:00',2.64),('9303','2013-05-02','16:30:00',2.57),('9303','2013-05-02','16:35:00',2.5),('9303','2013-05-02','16:40:00',2.44),('9303','2013-05-02','16:45:00',2.36),('9303','2013-05-02','16:50:00',2.29),('9303','2013-05-02','16:55:00',2.18),('9303','2013-05-02','17:00:00',2.07),('9303','2013-05-02','17:05:00',1.98),('9303','2013-05-02','17:10:00',1.91),('9303','2013-05-02','17:15:00',1.85),('9303','2013-05-02','17:20:00',1.78),('9303','2013-05-02','17:25:00',1.71),('9303','2013-05-02','17:30:00',1.63),('9303','2013-05-02','17:35:00',1.55),('9303','2013-05-02','17:40:00',1.48),('9303','2013-05-02','17:45:00',1.38),('9303','2013-05-02','17:50:00',1.3),('9303','2013-05-02','17:55:00',1.22),('9303','2013-05-02','18:00:00',1.12),('9303','2013-05-02','18:05:00',1.03),('9303','2014-03-30','08:25:00',1.1),('9303','2014-03-30','08:30:00',1.18),('9303','2014-03-30','08:35:00',1.26),('9303','2014-03-30','08:40:00',1.28),('9303','2014-03-30','08:45:00',1.3),('9303','2014-03-30','08:50:00',1.28),('9303','2014-03-30','08:55:00',1.35),('9303','2014-03-30','09:00:00',1.44),('9303','2014-03-30','09:05:00',1.41),('9303','2014-03-30','09:10:00',1.42),('9303','2014-03-30','09:15:00',1.33),('9303','2014-03-30','09:20:00',1.58),('9303','2014-03-30','09:25:00',1.73),('9303','2014-03-30','09:30:00',1.93),('9303','2014-03-30','09:35:00',2.12),('9303','2014-03-30','09:40:00',2.17),('9303','2014-03-30','09:45:00',2.29),('9303','2014-03-30','09:50:00',2.32),('9303','2014-03-30','09:55:00',2.35),('9303','2014-03-30','10:00:00',2.27),('9303','2014-03-30','10:05:00',2.52),('9303','2014-03-30','10:10:00',2.65),('9303','2014-03-30','10:15:00',2.67),('9303','2014-03-30','10:20:00',2.59),('9303','2014-03-30','10:25:00',2.72),('9303','2014-03-30','10:30:00',2.91),('9303','2014-03-30','10:35:00',2.99),('9303','2014-03-30','10:40:00',3.04),('9303','2014-03-30','10:45:00',3.03),('9303','2014-03-30','10:50:00',3.04),('9303','2014-03-30','10:55:00',3.07),('9303','2014-03-30','11:00:00',3.07),('9303','2014-03-30','11:05:00',3.07),('9303','2014-03-30','11:10:00',3.09),('9303','2014-03-30','11:15:00',2.97),('9303','2014-03-30','11:20:00',2.88),('9303','2014-03-30','11:25:00',2.98),('9303','2014-03-30','11:30:00',3.27),('9303','2014-03-30','11:35:00',3.29),('9303','2014-03-30','11:40:00',3.48),('9303','2014-03-30','11:45:00',3.57),('9303','2014-03-30','11:50:00',3.61),('9303','2014-03-30','11:55:00',3.67),('9303','2014-03-30','12:00:00',3.73),('9303','2014-03-30','12:05:00',3.91),('9303','2014-03-30','12:10:00',3.95),('9303','2014-03-30','12:15:00',4.06),('9303','2014-03-30','12:20:00',4),('9303','2014-03-30','12:25:00',3.96),('9303','2014-03-30','12:30:00',3.8),('9303','2014-03-30','12:35:00',3.67),('9303','2014-03-30','12:40:00',3.89),('9303','2014-03-30','12:45:00',3.85),('9303','2014-03-30','12:50:00',3.88),('9303','2014-03-30','12:55:00',3.88),('9303','2014-03-30','13:00:00',3.99),('9303','2014-03-30','13:05:00',4.06),('9303','2014-03-30','13:10:00',4.09),('9303','2014-03-30','13:15:00',4.06),('9303','2014-03-30','13:20:00',4.05),('9303','2014-03-30','13:25:00',4.04),('9303','2014-03-30','13:30:00',4.11),('9303','2014-03-30','13:35:00',4.15),('9303','2014-03-30','13:40:00',4.08),('9303','2014-03-30','13:45:00',4.08),('9303','2014-03-30','13:50:00',4.08),('9303','2014-03-30','13:55:00',4.01),('9303','2014-03-30','14:00:00',3.98),('9303','2014-03-30','14:05:00',3.98),('9303','2014-03-30','14:10:00',3.93),('9303','2014-03-30','14:15:00',3.78),('9303','2014-03-30','14:20:00',3.89),('9303','2014-03-30','14:25:00',3.96),('9303','2014-03-30','14:30:00',4),('9303','2014-03-30','14:35:00',3.85),('9303','2014-03-30','14:40:00',3.48),('9303','2014-03-30','14:45:00',3.34),('9303','2014-03-30','14:50:00',2.99),('9303','2014-03-30','14:55:00',2.45),('9303','2014-03-30','15:00:00',1.69),('9303','2014-03-30','15:05:00',1.58),('9303','2014-03-30','15:10:00',1.54),('9303','2014-03-30','15:15:00',1.64),('9303','2014-03-30','15:20:00',1.84),('9303','2014-03-30','15:25:00',2.91),('9303','2014-03-30','15:30:00',3.17),('9303','2014-03-30','15:35:00',3.13),('9303','2014-03-30','15:40:00',3.15),('9303','2014-03-30','15:45:00',3.13),('9303','2014-03-30','15:50:00',3.11),('9303','2014-03-30','15:55:00',3),('9303','2014-03-30','16:00:00',2.82),('9303','2014-03-30','16:05:00',2.44),('9303','2014-03-30','16:10:00',2.43),('9303','2014-03-30','16:15:00',2.32),('9303','2014-03-30','16:20:00',2.67),('9303','2014-03-30','16:25:00',2.72),('9303','2014-03-30','16:30:00',2.6),('9303','2014-03-30','16:35:00',2.64),('9303','2014-03-30','16:40:00',2.38),('9303','2014-03-30','16:45:00',2.2),('9303','2014-03-30','16:50:00',1.93),('9303','2014-03-30','16:55:00',1.71),('9303','2014-03-30','17:00:00',1.7),('9303','2014-03-30','17:05:00',1.89),('9303','2014-03-30','17:10:00',1.92),('9303','2014-03-30','17:15:00',1.91),('9303','2014-03-30','17:20:00',1.75),('9303','2014-03-30','17:25:00',1.53),('9303','2014-03-30','17:30:00',1.48),('9303','2014-03-30','17:35:00',1.44),('9303','2014-03-30','17:40:00',1.25),('9303','2014-03-30','17:45:00',1.23),('9303','2014-03-30','17:50:00',1.09),('9303','2013-05-01','08:05:00',1.03),('9303','2013-05-01','08:10:00',1.08),('9303','2013-05-01','08:15:00',1.18),('9303','2013-05-01','08:20:00',1.29),('9303','2013-05-01','08:25:00',1.41),('9303','2013-05-01','08:30:00',1.49),('9303','2013-05-01','08:35:00',1.59),('9303','2013-05-01','08:40:00',1.66),('9303','2013-05-01','08:45:00',1.74),('9303','2013-05-01','08:50:00',1.84),('9303','2013-05-01','08:55:00',1.91),('9303','2013-05-01','09:00:00',2.02),('9303','2013-05-01','09:05:00',2.09),('9303','2013-05-01','09:10:00',2.15),('9303','2013-05-01','09:15:00',2.2),('9303','2013-05-01','09:20:00',2.24),('9303','2013-05-01','09:25:00',2.29),('9303','2013-05-01','09:30:00',2.33),('9303','2013-05-01','09:35:00',2.39),('9303','2013-05-01','09:40:00',2.46),('9303','2013-05-01','09:45:00',2.52),('9303','2013-05-01','09:50:00',2.58),('9303','2013-05-01','09:55:00',2.63),('9303','2013-05-01','10:00:00',2.66),('9303','2013-05-01','10:05:00',2.69),('9303','2013-05-01','10:10:00',2.78),('9303','2013-05-01','10:15:00',2.88),('9303','2013-05-01','10:20:00',2.91),('9303','2013-05-01','10:25:00',2.96),('9303','2013-05-01','10:30:00',3.03),('9303','2013-05-01','10:35:00',3.06),('9303','2013-05-01','10:40:00',3.22),('9303','2013-05-01','10:45:00',3.36),('9303','2013-05-01','10:50:00',3.4),('9303','2013-05-01','10:55:00',3.4),('9303','2013-05-01','11:00:00',3.43),('9303','2013-05-01','11:05:00',3.49),('9303','2013-05-01','11:10:00',3.48),('9303','2013-05-01','11:15:00',3.27),('9303','2013-05-01','11:20:00',3.34),('9303','2013-05-01','11:25:00',3.31),('9303','2013-05-01','11:30:00',3.25),('9303','2013-05-01','11:35:00',3.3),('9303','2013-05-01','11:40:00',2.65),('9303','2013-05-01','11:45:00',2.42),('9303','2013-05-01','11:50:00',3.05),('9303','2013-05-01','11:55:00',3.75),('9303','2013-05-01','12:00:00',3.7),('9303','2013-05-01','12:05:00',3.67),('9303','2013-05-01','12:10:00',3.69),('9303','2013-05-01','12:15:00',3.69),('9303','2013-05-01','12:20:00',3.7),('9303','2013-05-01','12:25:00',3.76),('9303','2013-05-01','12:30:00',3.77),('9303','2013-05-01','12:35:00',3.8),('9303','2013-05-01','12:40:00',3.9),('9303','2013-05-01','12:45:00',3.57),('9303','2013-05-01','12:50:00',2.95),('9303','2013-05-01','12:55:00',1.5),('9303','2013-05-01','13:00:00',1.42),('9303','2013-05-01','13:05:00',1.65),('9303','2013-05-01','13:10:00',1.99),('9303','2013-05-01','13:15:00',3.31),('9303','2013-05-01','13:20:00',4.5),('9303','2013-05-01','13:25:00',3.79),('9303','2013-05-01','13:30:00',2.45),('9303','2013-05-01','13:35:00',3.17),('9303','2013-05-01','13:40:00',3.92),('9303','2013-05-01','13:45:00',4.21),('9303','2013-05-01','13:50:00',3.96),('9303','2013-05-01','13:55:00',3.81),('9303','2013-05-01','14:00:00',3.72),('9303','2013-05-01','14:05:00',3.65),('9303','2013-05-01','14:10:00',3.66),('9303','2013-05-01','14:15:00',3.16),('9303','2013-05-01','14:20:00',3.83),('9303','2013-05-01','14:25:00',3.83),('9303','2013-05-01','14:30:00',3.85),('9303','2013-05-01','14:35:00',3.73),('9303','2013-05-01','14:40:00',3.33),('9303','2013-05-01','14:45:00',3.46),('9303','2013-05-01','14:50:00',3),('9303','2013-05-01','14:55:00',2.77),('9303','2013-05-01','15:00:00',2.84),('9303','2013-05-01','15:05:00',3.31),('9303','2013-05-01','15:10:00',3.34),('9303','2013-05-01','15:15:00',3.2),('9303','2013-05-01','15:20:00',3.07),('9303','2013-05-01','15:25:00',3.11),('9303','2013-05-01','15:30:00',2.61),('9303','2013-05-01','15:35:00',2.24),('9303','2013-05-01','15:40:00',2.24),('9303','2013-05-01','15:45:00',2.18),('9303','2013-05-01','15:50:00',1.64),('9303','2013-05-01','15:55:00',1.54),('9303','2013-05-01','16:00:00',1.89),('9303','2013-05-01','16:05:00',1.84),('9303','2013-05-01','16:10:00',1.65),('9303','2013-05-01','16:15:00',1.5),('9303','2013-05-01','16:20:00',1.33),('9303','2013-05-01','16:25:00',1.03),('9303','2013-05-01','16:35:00',1),('9303','2013-05-01','16:40:00',1.09),('9303','2013-05-01','16:45:00',1.02),('9303','2013-04-30','08:55:00',1.4),('9303','2013-04-30','09:00:00',1.66),('9303','2013-04-30','09:05:00',1.43),('9303','2013-04-30','09:10:00',1.95),('9303','2013-04-30','09:15:00',2.45),('9303','2013-04-30','09:20:00',2.45),('9303','2013-04-30','09:25:00',2.66),('9303','2013-04-30','09:30:00',2.59),('9303','2013-04-30','09:35:00',2.19),('9303','2013-04-30','09:40:00',1.56),('9303','2013-04-30','09:45:00',1.82),('9303','2013-04-30','09:50:00',2.42),('9303','2013-04-30','09:55:00',2.74),('9303','2013-04-30','10:00:00',3.14),('9303','2013-04-30','10:05:00',3.25),('9303','2013-04-30','10:10:00',2.67),('9303','2013-04-30','10:15:00',2.17),('9303','2013-04-30','10:20:00',1.99),('9303','2013-04-30','10:25:00',2.42),('9303','2013-04-30','10:30:00',1.94),('9303','2013-04-30','10:35:00',1.78),('9303','2013-04-30','10:40:00',1.54),('9303','2013-04-30','10:45:00',1.22),('9303','2013-04-30','10:50:00',1.32),('9303','2013-04-30','10:55:00',1.41),('9303','2013-04-30','11:00:00',1.44),('9303','2013-04-30','11:05:00',1.62),('9303','2013-04-30','11:10:00',1.67),('9303','2013-04-30','11:15:00',1.71),('9303','2013-04-30','11:20:00',2.02),('9303','2013-04-30','11:25:00',1.82),('9303','2013-04-30','11:30:00',1.81),('9303','2013-04-30','11:35:00',1.92),('9303','2013-04-30','11:40:00',1.88),('9303','2013-04-30','11:45:00',1.54),('9303','2013-04-30','11:50:00',1.57),('9303','2013-04-30','11:55:00',1.6),('9303','2013-04-30','12:00:00',1.63),('9303','2013-04-30','12:05:00',1.66),('9303','2013-04-30','12:10:00',1.61),('9303','2013-04-30','12:15:00',1.48),('9303','2013-04-30','12:20:00',1.33),('9303','2013-04-30','12:25:00',1.22),('9303','2013-04-30','12:30:00',1.23),('9303','2013-04-30','12:35:00',2.13),('9303','2013-04-30','12:40:00',4.04),('9303','2013-04-30','12:45:00',4.34),('9303','2013-04-30','12:50:00',4.17),('9303','2013-04-30','12:55:00',3.65),('9303','2013-04-30','13:00:00',4),('9303','2013-04-30','13:05:00',3.93),('9303','2013-04-30','13:10:00',3.97),('9303','2013-04-30','13:15:00',3.9),('9303','2013-04-30','13:20:00',3.88),('9303','2013-04-30','13:25:00',3.86),('9303','2013-04-30','13:30:00',3.82),('9303','2013-04-30','13:35:00',3.8),('9303','2013-04-30','13:40:00',3.77),('9303','2013-04-30','13:45:00',3.76),('9303','2013-04-30','13:50:00',3.71),('9303','2013-04-30','13:55:00',3.72),('9303','2013-04-30','14:00:00',3.69),('9303','2013-04-30','14:05:00',3.66),('9303','2013-04-30','14:10:00',3.65),('9303','2013-04-30','14:15:00',3.6),('9303','2013-04-30','14:20:00',3.58),('9303','2013-04-30','14:25:00',3.59),('9303','2013-04-30','14:30:00',3.55),('9303','2013-04-30','14:35:00',3.55),('9303','2013-04-30','14:40:00',3.49),('9303','2013-04-30','14:45:00',3.44),('9303','2013-04-30','14:50:00',3.37),('9303','2013-04-30','14:55:00',3.32),('9303','2013-04-30','15:00:00',3.26),('9303','2013-04-30','15:05:00',3.18),('9303','2013-04-30','15:10:00',3.12),('9303','2013-04-30','15:15:00',3.07),('9303','2013-04-30','15:20:00',3.07),('9303','2013-04-30','15:25:00',3.03),('9303','2013-04-30','15:30:00',2.98),('9303','2013-04-30','15:35:00',2.98),('9303','2013-04-30','15:40:00',2.95),('9303','2013-04-30','15:45:00',2.89),('9303','2013-04-30','15:50:00',2.8),('9303','2013-04-30','15:55:00',2.73),('9303','2013-04-30','16:00:00',2.69),('9303','2013-04-30','16:05:00',2.63),('9303','2013-04-30','16:10:00',2.58),('9303','2013-04-30','16:15:00',2.52),('9303','2013-04-30','16:20:00',2.45),('9303','2013-04-30','16:25:00',2.39),('9303','2013-04-30','16:30:00',2.33),('9303','2013-04-30','16:35:00',2.21),('9303','2013-04-30','16:40:00',1.87),('9303','2013-04-30','16:45:00',2.05),('9303','2013-04-30','16:50:00',1.57),('9303','2013-04-30','16:55:00',1.8),('9303','2013-04-30','17:00:00',1.72),('9303','2013-04-30','17:05:00',1.7),('9303','2013-04-30','17:10:00',1.51),('9303','2013-04-30','17:20:00',1.2),('9303','2013-04-30','17:25:00',1.41),('9303','2013-04-30','17:30:00',1.34),('9303','2013-04-30','17:35:00',1.3),('9303','2013-04-30','17:40:00',1.24),('9303','2013-04-30','17:45:00',1.14),('9303','2013-04-30','17:50:00',1.05),('9303','2013-04-29','08:00:00',1.1),('9303','2013-04-29','08:05:00',1.17),('9303','2013-04-29','08:10:00',1.12),('9303','2013-04-29','08:15:00',1.16),('9303','2013-04-29','08:20:00',1.26),('9303','2013-04-29','08:25:00',1.47),('9303','2013-04-29','08:30:00',1.68),('9303','2013-04-29','08:35:00',1.89),('9303','2013-04-29','08:40:00',1.92),('9303','2013-04-29','08:45:00',1.87),('9303','2013-04-29','08:50:00',2.01),('9303','2013-04-29','08:55:00',2.02),('9303','2013-04-29','09:00:00',1.54),('9303','2013-04-29','09:05:00',2.1),('9303','2013-04-29','09:10:00',2.35),('9303','2013-04-29','09:15:00',2.48),('9303','2013-04-29','09:20:00',2.36),('9303','2013-04-29','09:25:00',2.28),('9303','2013-04-29','09:30:00',2.31),('9303','2013-04-29','09:35:00',2.46),('9303','2013-04-29','09:40:00',2.47),('9303','2013-04-29','09:45:00',2.55),('9303','2013-04-29','09:50:00',2.72),('9303','2013-04-29','09:55:00',2.54),('9303','2013-04-29','10:00:00',2.65),('9303','2013-04-29','10:05:00',2.65),('9303','2013-04-29','10:10:00',2.66),('9303','2013-04-29','10:15:00',2.18),('9303','2013-04-29','10:20:00',2.17),('9303','2013-04-29','10:25:00',2.63),('9303','2013-04-29','10:30:00',2.61),('9303','2013-04-29','10:35:00',3.07),('9303','2013-04-29','10:40:00',3.11),('9303','2013-04-29','10:45:00',3.2),('9303','2013-04-29','10:50:00',3.07),('9303','2013-04-29','10:55:00',2.84),('9303','2013-04-29','11:00:00',3.19),('9303','2013-04-29','11:05:00',3.11),('9303','2013-04-29','11:10:00',2.97),('9303','2013-04-29','11:15:00',2.79),('9303','2013-04-29','11:20:00',3.29),('9303','2013-04-29','11:25:00',3.34),('9303','2013-04-29','11:30:00',3.49),('9303','2013-04-29','11:35:00',3.33),('9303','2013-04-29','11:40:00',3.39),('9303','2013-04-29','11:45:00',3.28),('9303','2013-04-29','11:50:00',3.61),('9303','2013-04-29','11:55:00',3.61),('9303','2013-04-29','12:00:00',3.71),('9303','2013-04-29','12:05:00',3.72),('9303','2013-04-29','12:10:00',3.61),('9303','2013-04-29','12:15:00',3.65),('9303','2013-04-29','12:20:00',3.71),('9303','2013-04-29','12:25:00',3.57),('9303','2013-04-29','12:30:00',3.65),('9303','2013-04-29','12:35:00',3.73),('9303','2013-04-29','12:40:00',3.81),('9303','2013-04-29','12:45:00',3.83),('9303','2013-04-29','12:50:00',3.8),('9303','2013-04-29','12:55:00',3.71),('9303','2013-04-29','13:00:00',3.82),('9303','2013-04-29','13:05:00',3.76),('9303','2013-04-29','13:10:00',3.67),('9303','2013-04-29','13:15:00',3.41),('9303','2013-04-29','13:20:00',3.66),('9303','2013-04-29','13:25:00',3.86),('9303','2013-04-29','13:30:00',3.78),('9303','2013-04-29','13:35:00',3.65),('9303','2013-04-29','13:40:00',3.8),('9303','2013-04-29','13:45:00',3.75),('9303','2013-04-29','13:50:00',3.51),('9303','2013-04-29','13:55:00',3.98),('9303','2013-04-29','14:00:00',3.61),('9303','2013-04-29','14:05:00',3.56),('9303','2013-04-29','14:10:00',3.7),('9303','2013-04-29','14:15:00',3.79),('9303','2013-04-29','14:20:00',3.78),('9303','2013-04-29','14:25:00',3.62),('9303','2013-04-29','14:30:00',3.45),('9303','2013-04-29','14:35:00',3.39),('9303','2013-04-29','14:40:00',3.22),('9303','2013-04-29','14:45:00',3.46),('9303','2013-04-29','14:50:00',3.36),('9303','2013-04-29','14:55:00',3.4),('9303','2013-04-29','15:00:00',3.27),('9303','2013-04-29','15:05:00',3.46),('9303','2013-04-29','15:10:00',3.07),('9303','2013-04-29','15:15:00',2.99),('9303','2013-04-29','15:20:00',3.12),('9303','2013-04-29','15:25:00',3.31),('9303','2013-04-29','15:30:00',3.22),('9303','2013-04-29','15:35:00',2.84),('9303','2013-04-29','15:40:00',2.6),('9303','2013-04-29','15:45:00',2.52),('9303','2013-04-29','15:50:00',2.57),('9303','2013-04-29','15:55:00',2.73),('9303','2013-04-29','16:00:00',2.64),('9303','2013-04-29','16:05:00',2.85),('9303','2013-04-29','16:10:00',2.69),('9303','2013-04-29','16:15:00',3.09),('9303','2013-04-29','16:20:00',3.01),('9303','2013-04-29','16:25:00',2.3),('9303','2013-04-29','16:30:00',2.39),('9303','2013-04-29','16:35:00',2.4),('9303','2013-04-29','16:40:00',2.56),('9303','2013-04-29','16:45:00',2.5),('9303','2013-04-29','16:50:00',2.57),('9303','2013-04-29','16:55:00',2.52),('9303','2013-04-29','17:00:00',2.35),('9303','2013-04-29','17:05:00',1.98),('9303','2013-04-29','17:10:00',2.07),('9303','2013-04-29','17:15:00',1.76),('9303','2013-04-29','17:20:00',1.43),('9303','2013-04-29','17:25:00',1.42),('9303','2013-04-29','17:30:00',1.32),('9303','2013-04-29','17:35:00',1.24),('9303','2013-04-29','17:40:00',1.04),('9303','2013-04-29','17:50:00',1.11),('9303','2013-04-29','17:55:00',1.26),('9303','2013-04-29','18:00:00',1.21),('9303','2013-04-29','18:05:00',1.31),('9303','2013-04-29','18:10:00',1.16),('9303','2013-04-29','18:15:00',1.09),('9303','2013-04-28','08:00:00',1.05),('9303','2013-04-28','08:05:00',1.18),('9303','2013-04-28','08:10:00',1.29),('9303','2013-04-28','08:15:00',1.39),('9303','2013-04-28','08:20:00',1.5),('9303','2013-04-28','08:25:00',1.6),('9303','2013-04-28','08:30:00',1.69),('9303','2013-04-28','08:35:00',1.76),('9303','2013-04-28','08:40:00',1.84),('9303','2013-04-28','08:45:00',1.93),('9303','2013-04-28','08:50:00',2),('9303','2013-04-28','08:55:00',2.08),('9303','2013-04-28','09:00:00',2.15),('9303','2013-04-28','09:05:00',2.24),('9303','2013-04-28','09:10:00',2.32),('9303','2013-04-28','09:15:00',2.4),('9303','2013-04-28','09:20:00',2.48),('9303','2013-04-28','09:25:00',2.16),('9303','2013-04-28','09:30:00',2.61),('9303','2013-04-28','09:35:00',2.67),('9303','2013-04-28','09:40:00',2.75),('9303','2013-04-28','09:45:00',2.82),('9303','2013-04-28','09:50:00',2.89),('9303','2013-04-28','09:55:00',2.93),('9303','2013-04-28','10:00:00',3.01),('9303','2013-04-28','10:05:00',3.01),('9303','2013-04-28','10:10:00',3.1),('9303','2013-04-28','10:15:00',3.07),('9303','2013-04-28','10:20:00',3.18),('9303','2013-04-28','10:25:00',3.31),('9303','2013-04-28','10:30:00',3.24),('9303','2013-04-28','10:35:00',3.3),('9303','2013-04-28','10:40:00',3.07),('9303','2013-04-28','10:45:00',3.47),('9303','2013-04-28','10:50:00',3.49),('9303','2013-04-28','10:55:00',3.49),('9303','2013-04-28','11:00:00',3.52),('9303','2013-04-28','11:05:00',3.57),('9303','2013-04-28','11:10:00',3.65),('9303','2013-04-28','11:15:00',3.7),('9303','2013-04-28','11:20:00',3.71),('9303','2013-04-28','11:25:00',3.78),('9303','2013-04-28','11:30:00',3.78),('9303','2013-04-28','11:35:00',3.7),('9303','2013-04-28','11:40:00',3.74),('9303','2013-04-28','11:45:00',3.61),('9303','2013-04-28','11:50:00',3.63),('9303','2013-04-28','11:55:00',3.76),('9303','2013-04-28','12:00:00',3.33),('9303','2013-04-28','12:05:00',3.27),('9303','2013-04-28','12:10:00',3.6),('9303','2013-04-28','12:15:00',3.76),('9303','2013-04-28','12:20:00',3.71),('9303','2013-04-28','12:25:00',3.35),('9303','2013-04-28','12:30:00',3.17),('9303','2013-04-28','12:35:00',2.93),('9303','2013-04-28','12:40:00',2.83),('9303','2013-04-28','12:45:00',3.59),('9303','2013-04-28','12:50:00',3.86),('9303','2013-04-28','12:55:00',3.66),('9303','2013-04-28','13:00:00',3.77),('9303','2013-04-28','13:05:00',4.02),('9303','2013-04-28','13:10:00',3.98),('9303','2013-04-28','13:15:00',3.67),('9303','2013-04-28','13:20:00',3.68),('9303','2013-04-28','13:25:00',3.61),('9303','2013-04-28','13:30:00',3.89),('9303','2013-04-28','13:35:00',3.85),('9303','2013-04-28','13:40:00',4.03),('9303','2013-04-28','13:45:00',3.96),('9303','2013-04-28','13:50:00',3.21),('9303','2013-04-28','13:55:00',1.83),('9303','2013-04-28','14:00:00',3.91),('9303','2013-04-28','14:05:00',3.96),('9303','2013-04-28','14:10:00',3.81),('9303','2013-04-28','14:15:00',3.86),('9303','2013-04-28','14:20:00',2.91),('9303','2013-04-28','14:25:00',3.15),('9303','2013-04-28','14:30:00',3.71),('9303','2013-04-28','14:35:00',3.7),('9303','2013-04-28','14:40:00',3.65),('9303','2013-04-28','14:45:00',3.59),('9303','2013-04-28','14:50:00',3.55),('9303','2013-04-28','14:55:00',3.5),('9303','2013-04-28','15:00:00',3.49),('9303','2013-04-28','15:05:00',3.46),('9303','2013-04-28','15:10:00',3.43),('9303','2013-04-28','15:15:00',3.39),('9303','2013-04-28','15:20:00',3.34),('9303','2013-04-28','15:25:00',3.27),('9303','2013-04-28','15:30:00',3.23),('9303','2013-04-28','15:35:00',3.21),('9303','2013-04-28','15:40:00',3.15),('9303','2013-04-28','15:45:00',3.1),('9303','2013-04-28','15:50:00',3.05),('9303','2013-04-28','15:55:00',2.99),('9303','2013-04-28','16:00:00',2.93),('9303','2013-04-28','16:05:00',2.88),('9303','2013-04-28','16:10:00',2.83),('9303','2013-04-28','16:15:00',2.76),('9303','2013-04-28','16:20:00',2.68),('9303','2013-04-28','16:25:00',2.62),('9303','2013-04-28','16:30:00',2.57),('9303','2013-04-28','16:35:00',2.51),('9303','2013-04-28','16:40:00',2.43),('9303','2013-04-28','16:45:00',2.37),('9303','2013-04-28','16:50:00',2.28),('9303','2013-04-28','16:55:00',2.18),('9303','2013-04-28','17:00:00',2.07),('9303','2013-04-28','17:05:00',1.92),('9303','2013-04-28','17:10:00',1.8),('9303','2013-04-28','17:15:00',1.86),('9303','2013-04-28','17:20:00',1.75),('9303','2013-04-28','17:25:00',1.71),('9303','2013-04-28','17:30:00',1.46),('9303','2013-04-28','17:35:00',1.44),('9303','2013-04-28','17:40:00',1.32),('9303','2013-04-28','17:45:00',1.32),('9303','2013-04-28','17:50:00',1.27),('9303','2013-04-28','17:55:00',1.08),('9303','2013-04-28','18:00:00',1.05),('9303','2013-04-27','12:55:00',1.21),('9303','2013-04-27','13:00:00',1.37),('9303','2013-04-27','13:05:00',1.05),('9303','2013-04-27','13:10:00',1.08),('9303','2013-04-27','13:15:00',1.3),('9303','2013-04-27','13:20:00',1.37),('9303','2013-04-27','13:25:00',1.08),('9303','2013-04-27','13:30:00',1.05),('9303','2013-04-27','13:35:00',1.32),('9303','2013-04-27','13:40:00',1.55),('9303','2013-04-27','13:45:00',1.01),('9303','2013-04-27','13:50:00',1),('9303','2013-04-27','14:25:00',1.09),('9303','2013-04-27','14:30:00',2.02),('9303','2013-04-27','14:35:00',1.86),('9303','2013-04-27','14:40:00',1.19),('9303','2013-04-27','14:45:00',1.15),('9303','2013-04-27','15:05:00',1.2),('9303','2013-04-27','15:10:00',1.11),('9303','2013-04-27','15:15:00',1.01),('9303','2013-04-27','16:45:00',1.08),('9303','2013-04-27','16:50:00',1.98),('9303','2013-04-27','16:55:00',1.67),('9303','2013-04-27','17:00:00',2.18),('9303','2013-04-27','17:05:00',1.61),('9303','2013-04-26','08:10:00',1.09),('9303','2013-04-26','08:15:00',1.21),('9303','2013-04-26','08:20:00',1.25),('9303','2013-04-26','08:25:00',1.34),('9303','2013-04-26','08:30:00',1.41),('9303','2013-04-26','08:35:00',1.54),('9303','2013-04-26','08:40:00',1.6),('9303','2013-04-26','08:45:00',1.69),('9303','2013-04-26','08:50:00',1.65),('9303','2013-04-26','08:55:00',1.43),('9303','2013-04-26','09:00:00',1.1),('9303','2013-04-26','09:05:00',1.56),('9303','2013-04-26','09:10:00',1.83),('9303','2013-04-26','09:15:00',1.11),('9303','2013-04-26','09:20:00',1.05),('9303','2013-04-26','09:25:00',1.21),('9303','2013-04-26','09:30:00',1.56),('9303','2013-04-26','09:35:00',1.75),('9303','2013-04-26','09:40:00',1.86),('9303','2013-04-26','09:45:00',2.51),('9303','2013-04-26','09:50:00',2.16),('9303','2013-04-26','09:55:00',1.57),('9303','2013-04-26','10:00:00',1.79),('9303','2013-04-26','10:05:00',2.2),('9303','2013-04-26','10:10:00',2.81),('9303','2013-04-26','10:15:00',3.05),('9303','2013-04-26','10:20:00',3.07),('9303','2013-04-26','10:25:00',2.45),('9303','2013-04-26','10:30:00',3.15),('9303','2013-04-26','10:35:00',3.33),('9303','2013-04-26','10:40:00',3.18),('9303','2013-04-26','10:45:00',2.98),('9303','2013-04-26','10:50:00',2.12),('9303','2013-04-26','10:55:00',2.23),('9303','2013-04-26','11:00:00',3.03),('9303','2013-04-26','11:05:00',3.26),('9303','2013-04-26','11:10:00',3.05),('9303','2013-04-26','11:15:00',3.45),('9303','2013-04-26','11:20:00',2.49),('9303','2013-04-26','11:25:00',2.8),('9303','2013-04-26','11:30:00',2.91),('9303','2013-04-26','11:35:00',3.17),('9303','2013-04-26','11:40:00',3.36),('9303','2013-04-26','11:45:00',3.1),('9303','2013-04-26','11:50:00',2.36),('9303','2013-04-26','11:55:00',2.57),('9303','2013-04-26','12:00:00',2.68),('9303','2013-04-26','12:05:00',2.64),('9303','2013-04-26','12:10:00',2.12),('9303','2013-04-26','12:15:00',2.5),('9303','2013-04-26','12:20:00',2.21),('9303','2013-04-26','12:25:00',1.78),('9303','2013-04-26','12:30:00',1.69),('9303','2013-04-26','12:35:00',2.05),('9303','2013-04-26','12:40:00',3.07),('9303','2013-04-26','12:45:00',3.33),('9303','2013-04-26','12:50:00',2.02),('9303','2013-04-26','12:55:00',1.85),('9303','2013-04-26','13:00:00',1.31),('9303','2013-04-26','13:05:00',1.22),('9303','2013-04-26','13:10:00',1.47),('9303','2013-04-26','13:15:00',2.08),('9303','2013-04-26','13:20:00',1.52),('9303','2013-04-26','13:25:00',1.82),('9303','2013-04-26','13:30:00',2.29),('9303','2013-04-26','13:35:00',2.13),('9303','2013-04-26','13:40:00',2.42),('9303','2013-04-26','13:45:00',1.95),('9303','2013-04-26','13:50:00',2.95),('9303','2013-04-26','13:55:00',2.31),('9303','2013-04-26','14:00:00',2.82),('9303','2013-04-26','14:05:00',3.62),('9303','2013-04-26','14:10:00',2.93),('9303','2013-04-26','14:15:00',3.4),('9303','2013-04-26','14:20:00',3.45),('9303','2013-04-26','14:25:00',3.3),('9303','2013-04-26','14:30:00',3.75),('9303','2013-04-26','14:35:00',2.76),('9303','2013-04-26','14:40:00',1.7),('9303','2013-04-26','14:45:00',1.52),('9303','2013-04-26','14:50:00',3.4),('9303','2013-04-26','14:55:00',3.88),('9303','2013-04-26','15:00:00',3.67),('9303','2013-04-26','15:05:00',2.79),('9303','2013-04-26','15:10:00',1.27),('9303','2013-04-26','15:15:00',1.9),('9303','2013-04-26','15:20:00',1.33),('9303','2013-04-26','15:25:00',1.43),('9303','2013-04-26','15:30:00',2.01),('9303','2013-04-26','15:35:00',1.73),('9303','2013-04-26','15:40:00',1.82),('9303','2013-04-26','15:45:00',2.01),('9303','2013-04-26','15:50:00',1.63),('9303','2013-04-25','08:10:00',1.01),('9303','2013-04-25','08:15:00',1.25),('9303','2013-04-25','08:20:00',1.01),('9303','2013-04-25','08:40:00',1.04),('9303','2013-04-25','08:45:00',1.2),('9303','2013-04-25','08:50:00',1.82),('9303','2013-04-25','08:55:00',2.25),('9303','2013-04-25','09:00:00',1.89),('9303','2013-04-25','09:05:00',1.35),('9303','2013-04-25','09:10:00',1.23),('9303','2013-04-25','09:15:00',1.15),('9303','2013-04-25','09:20:00',1.2),('9303','2013-04-25','09:25:00',1.42),('9303','2013-04-25','09:30:00',1.34),('9303','2013-04-25','09:35:00',1.48),('9303','2013-04-25','09:40:00',2.16),('9303','2013-04-25','09:45:00',2.56),('9303','2013-04-25','09:50:00',2.93),('9303','2013-04-25','09:55:00',2.96),('9303','2013-04-25','10:00:00',2.98),('9303','2013-04-25','10:05:00',2.81),('9303','2013-04-25','10:10:00',2.57),('9303','2013-04-25','10:15:00',2.72),('9303','2013-04-25','10:20:00',3.1),('9303','2013-04-25','10:25:00',3.2),('9303','2013-04-25','10:30:00',3.31),('9303','2013-04-25','10:35:00',3.34),('9303','2013-04-25','10:40:00',3.36),('9303','2013-04-25','10:45:00',3.23),('9303','2013-04-25','10:50:00',3.47),('9303','2013-04-25','10:55:00',3.47),('9303','2013-04-25','11:00:00',3.57),('9303','2013-04-25','11:05:00',3.61),('9303','2013-04-25','11:10:00',3.64),('9303','2013-04-25','11:15:00',3.66),('9303','2013-04-25','11:20:00',3.68),('9303','2013-04-25','11:25:00',3.71),('9303','2013-04-25','11:30:00',3.74),('9303','2013-04-25','11:35:00',3.81),('9303','2013-04-25','11:40:00',3.85),('9303','2013-04-25','11:45:00',3.89),('9303','2013-04-25','11:50:00',3.92),('9303','2013-04-25','11:55:00',3.87),('9303','2013-04-25','12:00:00',3.78),('9303','2013-04-25','12:05:00',3.81),('9303','2013-04-25','12:10:00',3.86),('9303','2013-04-25','12:15:00',3.92),('9303','2013-04-25','12:20:00',3.97),('9303','2013-04-25','12:25:00',3.97),('9303','2013-04-25','12:30:00',3.96),('9303','2013-04-25','12:35:00',3.97),('9303','2013-04-25','12:40:00',3.93),('9303','2013-04-25','12:45:00',3.93),('9303','2013-04-25','12:50:00',3.95),('9303','2013-04-25','12:55:00',3.98),('9303','2013-04-25','13:00:00',4.01),('9303','2013-04-25','13:05:00',4.09),('9303','2013-04-25','13:10:00',3.73),('9303','2013-04-25','13:15:00',3.76),('9303','2013-04-25','13:20:00',3.84),('9303','2013-04-25','13:25:00',3.86),('9303','2013-04-25','13:30:00',2.88),('9303','2013-04-25','13:35:00',2.62),('9303','2013-04-25','13:40:00',2.23),('9303','2013-04-25','13:45:00',2.06),('9303','2013-04-25','13:50:00',1.92),('9303','2013-04-25','13:55:00',2.01),('9303','2013-04-25','14:00:00',2.13),('9303','2013-04-25','14:05:00',1.98),('9303','2013-04-25','14:10:00',2.14),('9303','2013-04-25','14:15:00',2.28),('9303','2013-04-25','14:20:00',2.35),('9303','2013-04-25','14:25:00',2.45),('9303','2013-04-25','14:30:00',2.85),('9303','2013-04-25','14:35:00',3.49),('9303','2013-04-25','14:40:00',3.19),('9303','2013-04-25','14:45:00',3.26),('9303','2013-04-25','14:50:00',3.03),('9303','2013-04-25','14:55:00',3.17),('9303','2013-04-25','15:00:00',3.04),('9303','2013-04-25','15:05:00',2.77),('9303','2013-04-25','15:10:00',2.71),('9303','2013-04-25','15:15:00',3.09),('9303','2013-04-25','15:20:00',3.29),('9303','2013-04-25','15:25:00',3.35),('9303','2013-04-25','15:30:00',3.29),('9303','2013-04-25','15:35:00',3.12),('9303','2013-04-25','15:40:00',2.91),('9303','2013-04-25','15:45:00',2.76),('9303','2013-04-25','15:50:00',2.61),('9303','2013-04-25','15:55:00',2.52),('9303','2013-04-25','16:00:00',2.54),('9303','2013-04-25','16:05:00',2.17),('9303','2013-04-25','16:10:00',2.14),('9303','2013-04-25','16:15:00',2.07),('9303','2013-04-25','16:20:00',2.18),('9303','2013-04-25','16:25:00',1.99),('9303','2013-04-25','16:30:00',1.82),('9303','2013-04-25','16:35:00',2.3),('9303','2013-04-25','16:40:00',1.92),('9303','2013-04-25','16:45:00',2.07),('9303','2013-04-25','16:50:00',1.71),('9303','2013-04-25','16:55:00',1.7),('9303','2013-04-25','17:00:00',1.64),('9303','2013-04-25','17:05:00',1.88),('9303','2013-04-25','17:10:00',2.07),('9303','2013-04-25','17:15:00',1.88),('9303','2013-04-25','17:20:00',1.89),('9303','2013-04-25','17:25:00',1.58),('9303','2013-04-25','17:30:00',1.31),('9303','2013-04-25','17:35:00',1.19),('9303','2013-04-25','17:40:00',1.22),('9303','2013-04-25','17:45:00',1.02),('9303','2013-04-24','08:05:00',1.01),('9303','2013-04-24','08:10:00',1.17),('9303','2013-04-24','08:15:00',1.35),('9303','2013-04-24','08:20:00',1.43),('9303','2013-04-24','08:25:00',1.56),('9303','2013-04-24','08:30:00',1.59),('9303','2013-04-24','08:35:00',1.54),('9303','2013-04-24','08:40:00',1.61),('9303','2013-04-24','08:45:00',1.67),('9303','2013-04-24','08:50:00',1.73),('9303','2013-04-24','08:55:00',1.88),('9303','2013-04-24','09:00:00',2.05),('9303','2013-04-24','09:05:00',2.28),('9303','2013-04-24','09:10:00',2.38),('9303','2013-04-24','09:15:00',2.2),('9303','2013-04-24','09:20:00',1.79),('9303','2013-04-24','09:25:00',2.08),('9303','2013-04-24','09:30:00',2.49),('9303','2013-04-24','09:35:00',2.59),('9303','2013-04-24','09:40:00',2.61),('9303','2013-04-24','09:45:00',2.52),('9303','2013-04-24','09:50:00',2.72),('9303','2013-04-24','09:55:00',3.09),('9303','2013-04-24','10:00:00',3.1),('9303','2013-04-24','10:05:00',3.18),('9303','2013-04-24','10:10:00',3.21),('9303','2013-04-24','10:15:00',3.2),('9303','2013-04-24','10:20:00',3.18),('9303','2013-04-24','10:25:00',3.16),('9303','2013-04-24','10:30:00',3.14),('9303','2013-04-24','10:35:00',3.09),('9303','2013-04-24','10:40:00',3.41),('9303','2013-04-24','10:45:00',3.53),('9303','2013-04-24','10:50:00',3.55),('9303','2013-04-24','10:55:00',3.64),('9303','2013-04-24','11:00:00',3.7),('9303','2013-04-24','11:05:00',3.59),('9303','2013-04-24','11:10:00',3.84),('9303','2013-04-24','11:15:00',3.94),('9303','2013-04-24','11:20:00',4.01),('9303','2013-04-24','11:25:00',4.1),('9303','2013-04-24','11:30:00',3.92),('9303','2013-04-24','11:35:00',3.25),('9303','2013-04-24','11:40:00',2.3),('9303','2013-04-24','11:45:00',2.61),('9303','2013-04-24','11:50:00',1.92),('9303','2013-04-24','11:55:00',2.54),('9303','2013-04-24','12:00:00',3.2),('9303','2013-04-24','12:05:00',2.3),('9303','2013-04-24','12:10:00',2.75),('9303','2013-04-24','12:15:00',3.67),('9303','2013-04-24','12:20:00',4.46),('9303','2013-04-24','12:25:00',3.77),('9303','2013-04-24','12:30:00',3.73),('9303','2013-04-24','12:35:00',3.78),('9303','2013-04-24','12:40:00',3.49),('9303','2013-04-24','12:45:00',3.75),('9303','2013-04-24','12:50:00',4.03),('9303','2013-04-24','12:55:00',3.86),('9303','2013-04-24','13:00:00',3.67),('9303','2013-04-24','13:05:00',3.23),('9303','2013-04-24','13:10:00',4.3),('9303','2013-04-24','13:15:00',3.68),('9303','2013-04-24','13:20:00',3.68),('9303','2013-04-24','13:25:00',3.74),('9303','2013-04-24','13:30:00',3.49),('9303','2013-04-24','13:35:00',3.37),('9303','2013-04-24','13:40:00',4.26),('9303','2013-04-24','13:45:00',3.4),('9303','2013-04-24','13:50:00',2.6),('9303','2013-04-24','13:55:00',3.9),('9303','2013-04-24','14:00:00',3.81),('9303','2013-04-24','14:05:00',2.77),('9303','2013-04-24','14:10:00',2.7),('9303','2013-04-24','14:15:00',3.93),('9303','2013-04-24','14:20:00',3.46),('9303','2013-04-24','14:25:00',3.67),('9303','2013-04-24','14:30:00',3.48),('9303','2013-04-24','14:35:00',3.05),('9303','2013-04-24','14:40:00',2.84),('9303','2013-04-24','14:45:00',2.82),('9303','2013-04-24','14:50:00',2.44),('9303','2013-04-24','14:55:00',2.2),('9303','2013-04-24','15:00:00',2.47),('9303','2013-04-24','15:05:00',2.27),('9303','2013-04-24','15:10:00',2.08),('9303','2013-04-24','15:15:00',2.21),('9303','2013-04-24','15:20:00',2.31),('9303','2013-04-24','15:25:00',1.93),('9303','2013-04-24','15:30:00',1.67),('9303','2013-04-24','15:35:00',1.61),('9303','2013-04-24','15:40:00',1.59),('9303','2013-04-24','15:45:00',1.6),('9303','2013-04-24','15:50:00',1.63),('9303','2013-04-24','15:55:00',2.02),('9303','2013-04-24','16:00:00',2.48),('9303','2013-04-24','16:05:00',2.61),('9303','2013-04-24','16:10:00',2.59),('9303','2013-04-24','16:15:00',2.47),('9303','2013-04-24','16:20:00',3.35),('9303','2013-04-24','16:25:00',2.4),('9303','2013-04-24','16:30:00',2),('9303','2013-04-24','16:35:00',1.67),('9303','2013-04-24','16:40:00',2.27),('9303','2013-04-24','16:45:00',2.41),('9303','2013-04-24','16:50:00',2.12),('9303','2013-04-24','16:55:00',2.49),('9303','2013-04-24','17:00:00',2.43),('9303','2013-04-24','17:05:00',2.29),('9303','2013-04-24','17:10:00',2.21),('9303','2013-04-24','17:15:00',1.61),('9303','2013-04-24','17:20:00',1.53),('9303','2013-04-24','17:25:00',1.43),('9303','2013-04-24','17:55:00',1.2),('9303','2013-04-23','07:55:00',1),('9303','2013-04-23','08:00:00',1.11),('9303','2013-04-23','08:05:00',1.21),('9303','2013-04-23','08:10:00',1.32),('9303','2013-04-23','08:15:00',1.41),('9303','2013-04-23','08:20:00',1.53),('9303','2013-04-23','08:25:00',1.62),('9303','2013-04-23','08:30:00',1.72),('9303','2013-04-23','08:35:00',1.83),('9303','2013-04-23','08:40:00',1.91),('9303','2013-04-23','08:45:00',1.99),('9303','2013-04-23','08:50:00',2.08),('9303','2013-04-23','08:55:00',2.17),('9303','2013-04-23','09:00:00',2.24),('9303','2013-04-23','09:05:00',2.33),('9303','2013-04-23','09:10:00',2.4),('9303','2013-04-23','09:15:00',2.51),('9303','2013-04-23','09:20:00',2.59),('9303','2013-04-23','09:25:00',2.67),('9303','2013-04-23','09:30:00',2.73),('9303','2013-04-23','09:35:00',2.8),('9303','2013-04-23','09:40:00',2.68),('9303','2013-04-23','09:45:00',2.53),('9303','2013-04-23','09:50:00',3.06),('9303','2013-04-23','09:55:00',3.12),('9303','2013-04-23','10:00:00',3.16),('9303','2013-04-23','10:05:00',3.21),('9303','2013-04-23','10:10:00',3.27),('9303','2013-04-23','10:15:00',3.3),('9303','2013-04-23','10:20:00',3.37),('9303','2013-04-23','10:25:00',3.43),('9303','2013-04-23','10:30:00',3.48),('9303','2013-04-23','10:35:00',3.54),('9303','2013-04-23','10:40:00',3.54),('9303','2013-04-23','10:45:00',3.49),('9303','2013-04-23','10:50:00',3.57),('9303','2013-04-23','10:55:00',3.65),('9303','2013-04-23','11:00:00',3.68),('9303','2013-04-23','11:05:00',3.72),('9303','2013-04-23','11:10:00',3.77),('9303','2013-04-23','11:15:00',3.83),('9303','2013-04-23','11:20:00',3.88),('9303','2013-04-23','11:25:00',3.91),('9303','2013-04-23','11:30:00',3.94),('9303','2013-04-23','11:35:00',3.94),('9303','2013-04-23','11:40:00',3.95),('9303','2013-04-23','11:45:00',3.97),('9303','2013-04-23','11:50:00',3.99),('9303','2013-04-23','11:55:00',4.01),('9303','2013-04-23','12:00:00',4.04),('9303','2013-04-23','12:05:00',4.05),('9303','2013-04-23','12:10:00',4.05),('9303','2013-04-23','12:15:00',4.01),('9303','2013-04-23','12:20:00',4.01),('9303','2013-04-23','12:25:00',4.02),('9303','2013-04-23','12:30:00',2.87),('9303','2013-04-23','12:35:00',1.91),('9303','2013-04-23','12:40:00',4.21),('9303','2013-04-23','12:45:00',3.12),('9303','2013-04-23','12:50:00',1.71),('9303','2013-04-23','12:55:00',3.42),('9303','2013-04-23','13:00:00',3.13),('9303','2013-04-23','13:05:00',3.54),('9303','2013-04-23','13:10:00',2.07),('9303','2013-04-23','13:15:00',2.65),('9303','2013-04-23','13:20:00',4.38),('9303','2013-04-23','13:25:00',4.32),('9303','2013-04-23','13:30:00',4.16),('9303','2013-04-23','13:35:00',4.22),('9303','2013-04-23','13:40:00',4.38),('9303','2013-04-23','13:45:00',3.08),('9303','2013-04-23','13:50:00',3.75),('9303','2013-04-23','13:55:00',4.19),('9303','2013-04-23','14:00:00',2.81),('9303','2013-04-23','14:05:00',3.54),('9303','2013-04-23','14:10:00',2.72),('9303','2013-04-23','14:15:00',3.31),('9303','2013-04-23','14:20:00',3.77),('9303','2013-04-23','14:25:00',3.44),('9303','2013-04-23','14:30:00',3.99),('9303','2013-04-23','14:35:00',3.87),('9303','2013-04-23','14:40:00',3.83),('9303','2013-04-23','14:45:00',3.33),('9303','2013-04-23','14:50:00',2.11),('9303','2013-04-23','14:55:00',2.17),('9303','2013-04-23','15:00:00',2.19),('9303','2013-04-23','15:05:00',2.27),('9303','2013-04-23','15:10:00',2.79),('9303','2013-04-23','15:15:00',2.86),('9303','2013-04-23','15:20:00',2.61),('9303','2013-04-23','15:25:00',2.38),('9303','2013-04-23','15:30:00',2.33),('9303','2013-04-23','15:35:00',2.25),('9303','2013-04-23','15:40:00',1.94),('9303','2013-04-23','15:45:00',2.34),('9303','2013-04-23','15:50:00',1.81),('9303','2013-04-23','15:55:00',1.49),('9303','2013-04-23','16:00:00',1.55),('9303','2013-04-23','16:05:00',1.65),('9303','2013-04-23','16:10:00',1.67),('9303','2013-04-23','16:15:00',1.87),('9303','2013-04-23','16:20:00',1.25),('9303','2013-04-23','16:25:00',1.23),('9303','2013-04-23','16:30:00',1.12),('9303','2013-04-23','16:35:00',1.04),('9303','2013-04-23','16:40:00',1),('9303','2013-04-23','16:45:00',1.12),('9303','2013-04-23','17:05:00',1.02),('9303','2013-04-23','17:10:00',1.39),('9303','2013-04-23','17:15:00',1.45),('9303','2013-04-23','17:25:00',1.15),('9303','2013-04-23','17:30:00',1.3),('9303','2013-04-23','17:35:00',1.1),('9303','2013-04-23','17:45:00',1.14),('9303','2013-04-22','09:30:00',1.08),('9303','2013-04-22','10:35:00',1.46),('9303','2013-04-22','10:40:00',2.68),('9303','2013-04-22','10:45:00',4.58),('9303','2013-04-22','10:50:00',2.03),('9303','2013-04-22','10:55:00',2.1),('9303','2013-04-22','11:00:00',2.02),('9303','2013-04-22','11:05:00',1.67),('9303','2013-04-22','11:10:00',2.38),('9303','2013-04-22','11:15:00',1.35),('9303','2013-04-22','11:20:00',1.3),('9303','2013-04-22','11:25:00',1.76),('9303','2013-04-22','11:30:00',2.75),('9303','2013-04-22','11:35:00',3.37),('9303','2013-04-22','11:40:00',4.11),('9303','2013-04-22','11:45:00',1.87),('9303','2013-04-22','11:50:00',1.58),('9303','2013-04-22','11:55:00',2.7),('9303','2013-04-22','12:00:00',3.6),('9303','2013-04-22','12:05:00',4.17),('9303','2013-04-22','12:10:00',2.61),('9303','2013-04-22','12:15:00',3),('9303','2013-04-22','12:20:00',3.44),('9303','2013-04-22','12:25:00',2.72),('9303','2013-04-22','12:30:00',2.31),('9303','2013-04-22','12:35:00',1.78),('9303','2013-04-22','12:40:00',3.56),('9303','2013-04-22','12:45:00',3.74),('9303','2013-04-22','12:50:00',4.55),('9303','2013-04-22','12:55:00',4.5),('9303','2013-04-22','13:00:00',4.5),('9303','2013-04-22','13:05:00',3.81),('9303','2013-04-22','13:10:00',2.89),('9303','2013-04-22','13:15:00',3.6),('9303','2013-04-22','13:20:00',4.76),('9303','2013-04-22','13:25:00',3.34),('9303','2013-04-22','13:30:00',1.68),('9303','2013-04-22','13:35:00',2.15),('9303','2013-04-22','13:40:00',2.03),('9303','2013-04-22','13:45:00',2.04),('9303','2013-04-22','13:50:00',1.05),('9303','2013-04-22','13:55:00',2.71),('9303','2013-04-22','14:00:00',1.32),('9303','2013-04-22','14:05:00',1.49),('9303','2013-04-22','14:10:00',2.56),('9303','2013-04-22','14:15:00',2.27),('9303','2013-04-22','14:20:00',3.51),('9303','2013-04-22','14:25:00',2.39),('9303','2013-04-22','14:30:00',4.58),('9303','2013-04-22','14:35:00',2.38),('9303','2013-04-22','14:40:00',4.52),('9303','2013-04-22','14:45:00',4.32),('9303','2013-04-22','14:50:00',4.29),('9303','2013-04-22','14:55:00',4.38),('9303','2013-04-22','15:00:00',1.18),('9303','2013-04-22','15:05:00',2.22),('9303','2013-04-22','15:10:00',1.48),('9303','2013-04-22','15:15:00',1.22),('9303','2013-04-22','15:25:00',2.34),('9303','2013-04-22','15:30:00',2.08),('9303','2013-04-22','15:35:00',1.38),('9303','2013-04-22','15:40:00',1.56),('9303','2013-04-22','15:45:00',3.14),('9303','2013-04-22','15:50:00',2.98),('9303','2013-04-22','15:55:00',1.55),('9303','2013-04-22','16:45:00',1.37),('9303','2014-03-29','07:30:00',1.05),('9303','2014-03-29','07:35:00',1.14),('9303','2014-03-29','07:40:00',1.26),('9303','2014-03-29','07:45:00',1.35),('9303','2014-03-29','07:50:00',1.46),('9303','2014-03-29','07:55:00',1.56),('9303','2014-03-29','08:00:00',1.69),('9303','2014-03-29','08:05:00',1.79),('9303','2014-03-29','08:10:00',1.89),('9303','2014-03-29','08:15:00',1.95),('9303','2014-03-29','08:20:00',2.04),('9303','2014-03-29','08:25:00',2.13),('9303','2014-03-29','08:30:00',2.2),('9303','2014-03-29','08:35:00',2.28),('9303','2014-03-29','08:40:00',2.35),('9303','2014-03-29','08:45:00',2.42),('9303','2014-03-29','08:50:00',2.51),('9303','2014-03-29','08:55:00',2.55),('9303','2014-03-29','09:00:00',2.59),('9303','2014-03-29','09:05:00',2.64),('9303','2014-03-29','09:10:00',2.71),('9303','2014-03-29','09:15:00',2.8),('9303','2014-03-29','09:20:00',2.88),('9303','2014-03-29','09:25:00',2.96),('9303','2014-03-29','09:30:00',3),('9303','2014-03-29','09:35:00',3.07),('9303','2014-03-29','09:40:00',3.14),('9303','2014-03-29','09:45:00',3.19),('9303','2014-03-29','09:50:00',3.27),('9303','2014-03-29','09:55:00',3.37),('9303','2014-03-29','10:00:00',3.42),('9303','2014-03-29','10:05:00',3.45),('9303','2014-03-29','10:10:00',3.52),('9303','2014-03-29','10:15:00',3.57),('9303','2014-03-29','10:20:00',3.61),('9303','2014-03-29','10:25:00',3.67),('9303','2014-03-29','10:30:00',3.68),('9303','2014-03-29','10:35:00',3.72),('9303','2014-03-29','10:40:00',3.76),('9303','2014-03-29','10:45:00',3.8),('9303','2014-03-29','10:50:00',3.83),('9303','2014-03-29','10:55:00',3.84),('9303','2014-03-29','11:00:00',3.87),('9303','2014-03-29','11:05:00',3.85),('9303','2014-03-29','11:10:00',3.87),('9303','2014-03-29','11:15:00',3.9),('9303','2014-03-29','11:20:00',3.91),('9303','2014-03-29','11:25:00',3.96),('9303','2014-03-29','11:30:00',3.98),('9303','2014-03-29','11:35:00',3.93),('9303','2014-03-29','11:40:00',3.85),('9303','2014-03-29','11:45:00',4.01),('9303','2014-03-29','11:50:00',4),('9303','2014-03-29','11:55:00',3.98),('9303','2014-03-29','12:00:00',3.99),('9303','2014-03-29','12:05:00',3.97),('9303','2014-03-29','12:10:00',3.97),('9303','2014-03-29','12:15:00',4.02),('9303','2014-03-29','12:20:00',4.05),('9303','2014-03-29','12:25:00',4.02),('9303','2014-03-29','12:30:00',4.03),('9303','2014-03-29','12:35:00',4.05),('9303','2014-03-29','12:40:00',4.01),('9303','2014-03-29','12:45:00',4.01),('9303','2014-03-29','12:50:00',3.98),('9303','2014-03-29','12:55:00',3.96),('9303','2014-03-29','13:00:00',3.91),('9303','2014-03-29','13:05:00',3.96),('9303','2014-03-29','13:10:00',3.89),('9303','2014-03-29','13:15:00',3.87),('9303','2014-03-29','13:20:00',3.83),('9303','2014-03-29','13:25:00',3.79),('9303','2014-03-29','13:30:00',3.75),('9303','2014-03-29','13:35:00',3.71),('9303','2014-03-29','13:40:00',3.64),('9303','2014-03-29','13:45:00',3.6),('9303','2014-03-29','13:50:00',3.56),('9303','2014-03-29','13:55:00',3.52),('9303','2014-03-29','14:00:00',3.49),('9303','2014-03-29','14:05:00',3.45),('9303','2014-03-29','14:10:00',3.42),('9303','2014-03-29','14:15:00',3.38),('9303','2014-03-29','14:20:00',3.32),('9303','2014-03-29','14:25:00',3.24),('9303','2014-03-29','14:30:00',3.18),('9303','2014-03-29','14:35:00',2.78),('9303','2014-03-29','14:40:00',2.41),('9303','2014-03-29','14:45:00',2.8),('9303','2014-03-29','14:50:00',3),('9303','2014-03-29','14:55:00',3),('9303','2014-03-29','15:00:00',2.91),('9303','2014-03-29','15:05:00',2.82),('9303','2014-03-29','15:10:00',2.71),('9303','2014-03-29','15:15:00',2.66),('9303','2014-03-29','15:20:00',2.62),('9303','2014-03-29','15:25:00',2.52),('9303','2014-03-29','15:30:00',2.42),('9303','2014-03-29','15:35:00',2.31),('9303','2014-03-29','15:40:00',2.24),('9303','2014-03-29','15:45:00',2.13),('9303','2014-03-29','15:50:00',2),('9303','2014-03-29','15:55:00',1.93),('9303','2014-03-29','16:00:00',1.86),('9303','2014-03-29','16:05:00',1.77),('9303','2014-03-29','16:10:00',1.67),('9303','2014-03-29','16:15:00',1.6),('9303','2014-03-29','16:20:00',1.39),('9303','2014-03-29','16:25:00',1.38),('9303','2014-03-29','16:30:00',1.31),('9303','2014-03-29','16:35:00',1.18),('9303','2013-04-21','08:15:00',1.06),('9303','2013-04-21','08:20:00',1),('9303','2013-04-21','08:25:00',1.01),('9303','2013-04-21','08:30:00',1.01),('9303','2013-04-21','08:35:00',1.29),('9303','2013-04-21','08:40:00',1.32),('9303','2013-04-21','08:45:00',1.25),('9303','2013-04-21','08:50:00',2.15),('9303','2013-04-21','08:55:00',2.07),('9303','2013-04-21','09:00:00',1.74),('9303','2013-04-21','09:05:00',1.97),('9303','2013-04-21','09:10:00',1.85),('9303','2013-04-21','09:15:00',1.89),('9303','2013-04-21','09:20:00',1.7),('9303','2013-04-21','09:25:00',2.02),('9303','2013-04-21','09:30:00',2.72),('9303','2013-04-21','09:35:00',2.78),('9303','2013-04-21','09:40:00',2.82),('9303','2013-04-21','09:45:00',2.75),('9303','2013-04-21','09:50:00',3.31),('9303','2013-04-21','09:55:00',3.51),('9303','2013-04-21','10:00:00',3.05),('9303','2013-04-21','10:05:00',1.98),('9303','2013-04-21','10:10:00',1.76),('9303','2013-04-21','10:15:00',1.84),('9303','2013-04-21','10:20:00',3.28),('9303','2013-04-21','10:25:00',3.14),('9303','2013-04-21','10:30:00',2.7),('9303','2013-04-21','10:35:00',1.77),('9303','2013-04-21','10:40:00',2.45),('9303','2013-04-21','10:45:00',2.35),('9303','2013-04-21','10:50:00',3.41),('9303','2013-04-21','10:55:00',2.64),('9303','2013-04-21','11:00:00',3.6),('9303','2013-04-21','11:05:00',3.45),('9303','2013-04-21','11:10:00',3.99),('9303','2013-04-21','11:15:00',3.02),('9303','2013-04-21','11:20:00',2.6),('9303','2013-04-21','11:25:00',2.75),('9303','2013-04-21','11:30:00',2.62),('9303','2013-04-21','11:35:00',2.57),('9303','2013-04-21','11:40:00',2.62),('9303','2013-04-21','11:45:00',2.95),('9303','2013-04-21','11:50:00',3.07),('9303','2013-04-21','11:55:00',2.8),('9303','2013-04-21','12:00:00',2.26),('9303','2013-04-21','12:05:00',2.37),('9303','2013-04-21','12:10:00',2.33),('9303','2013-04-21','12:15:00',2.03),('9303','2013-04-21','12:20:00',1.83),('9303','2013-04-21','12:25:00',1.73),('9303','2013-04-21','12:30:00',1.88),('9303','2013-04-21','12:35:00',1.94),('9303','2013-04-21','12:40:00',1.98),('9303','2013-04-21','12:45:00',1.99),('9303','2013-04-21','12:50:00',1.87),('9303','2013-04-21','12:55:00',1.79),('9303','2013-04-21','13:00:00',2.04),('9303','2013-04-21','13:05:00',2.42),('9303','2013-04-21','13:10:00',2.51),('9303','2013-04-21','13:15:00',2.29),('9303','2013-04-21','13:20:00',2.15),('9303','2013-04-21','13:25:00',2.02),('9303','2013-04-21','13:30:00',2.97),('9303','2013-04-21','13:35:00',3.6),('9303','2013-04-21','13:40:00',2.51),('9303','2013-04-21','13:45:00',2.83),('9303','2013-04-21','13:50:00',2.57),('9303','2013-04-21','13:55:00',3.56),('9303','2013-04-21','14:00:00',4.08),('9303','2013-04-21','14:05:00',4.14),('9303','2013-04-21','14:10:00',3.86),('9303','2013-04-21','14:15:00',3.76),('9303','2013-04-21','14:20:00',4.5),('9303','2013-04-21','14:25:00',3.94),('9303','2013-04-21','14:30:00',4),('9303','2013-04-21','14:35:00',4.1),('9303','2013-04-21','14:40:00',4.46),('9303','2013-04-21','14:45:00',3.55),('9303','2013-04-21','14:50:00',2.02),('9303','2013-04-21','14:55:00',1.87),('9303','2013-04-21','15:00:00',2.09),('9303','2013-04-21','15:05:00',3.72),('9303','2013-04-21','15:10:00',3.85),('9303','2013-04-21','15:15:00',3),('9303','2013-04-21','15:20:00',1.9),('9303','2013-04-21','15:25:00',1.85),('9303','2013-04-21','15:30:00',1.58),('9303','2013-04-21','15:35:00',1.29),('9303','2013-04-21','15:40:00',1.39),('9303','2013-04-21','15:45:00',1.17),('9303','2013-04-20','08:05:00',1.03),('9303','2013-04-20','08:10:00',1.16),('9303','2013-04-20','08:15:00',1.03),('9303','2013-04-20','08:25:00',1.15),('9303','2013-04-20','08:30:00',1.34),('9303','2013-04-20','08:35:00',1.51),('9303','2013-04-20','08:40:00',1.64),('9303','2013-04-20','08:45:00',1.7),('9303','2013-04-20','08:50:00',1.68),('9303','2013-04-20','08:55:00',1.67),('9303','2013-04-20','09:00:00',1.95),('9303','2013-04-20','09:05:00',2.08),('9303','2013-04-20','09:10:00',1.95),('9303','2013-04-20','09:15:00',1.93),('9303','2013-04-20','09:20:00',2.42),('9303','2013-04-20','09:25:00',2.25),('9303','2013-04-20','09:30:00',2.01),('9303','2013-04-20','09:35:00',1.49),('9303','2013-04-20','09:45:00',1.04),('9303','2013-04-20','09:50:00',1.13),('9303','2013-04-20','10:40:00',1.04),('9303','2013-04-20','10:45:00',3.13),('9303','2013-04-20','10:50:00',3.28),('9303','2013-04-20','10:55:00',1.78),('9303','2013-04-20','11:00:00',2.76),('9303','2013-04-20','11:05:00',2.91),('9303','2013-04-20','11:10:00',3.06),('9303','2013-04-20','11:15:00',4.14),('9303','2013-04-20','11:20:00',3.08),('9303','2013-04-20','11:25:00',1.87),('9303','2013-04-20','11:30:00',4.19),('9303','2013-04-20','11:35:00',3.33),('9303','2013-04-20','11:40:00',1.24),('9303','2013-04-20','11:45:00',2.59),('9303','2013-04-20','11:50:00',3.98),('9303','2013-04-20','11:55:00',4.17),('9303','2013-04-20','12:00:00',4.21),('9303','2013-04-20','12:05:00',3.97),('9303','2013-04-20','12:10:00',4.08),('9303','2013-04-20','12:15:00',3.68),('9303','2013-04-20','12:20:00',3.05),('9303','2013-04-20','12:25:00',2.91),('9303','2013-04-20','12:30:00',3.2),('9303','2013-04-20','12:35:00',2.45),('9303','2013-04-20','12:40:00',1.55),('9303','2013-04-20','12:45:00',3.85),('9303','2013-04-20','12:50:00',4.32),('9303','2013-04-20','12:55:00',4.41),('9303','2013-04-20','13:00:00',3.86),('9303','2013-04-20','13:05:00',3.29),('9303','2013-04-20','13:10:00',4.19),('9303','2013-04-20','13:15:00',3.85),('9303','2013-04-20','13:20:00',2.67),('9303','2013-04-20','13:25:00',3.81),('9303','2013-04-20','13:30:00',2.09),('9303','2013-04-20','13:35:00',1.78),('9303','2013-04-20','13:40:00',3.65),('9303','2013-04-20','13:45:00',2.1),('9303','2013-04-20','13:50:00',1.87),('9303','2013-04-20','13:55:00',2.63),('9303','2013-04-20','14:00:00',2.81),('9303','2013-04-20','14:05:00',3.96),('9303','2013-04-20','14:10:00',3.43),('9303','2013-04-20','14:15:00',4.04),('9303','2013-04-20','14:20:00',3.89),('9303','2013-04-20','14:25:00',3.86),('9303','2013-04-20','14:30:00',3.74),('9303','2013-04-20','14:35:00',3.67),('9303','2013-04-20','14:40:00',3.64),('9303','2013-04-20','14:45:00',3.64),('9303','2013-04-20','14:50:00',3.64),('9303','2013-04-20','14:55:00',3.65),('9303','2013-04-20','15:00:00',3.63),('9303','2013-04-20','15:05:00',3.58),('9303','2013-04-20','15:10:00',2.33),('9303','2013-04-20','15:15:00',2.5),('9303','2013-04-20','15:20:00',1.99),('9303','2013-04-20','15:25:00',3.07),('9303','2013-04-20','15:30:00',1.91),('9303','2013-04-20','16:10:00',1.28),('9303','2013-04-20','16:15:00',2.02),('9303','2013-04-20','16:20:00',2.02),('9303','2013-04-20','16:25:00',2.21),('9303','2013-04-20','16:30:00',2.64),('9303','2013-04-20','16:35:00',2.58),('9303','2013-04-20','16:40:00',2.43),('9303','2013-04-20','16:45:00',2.64),('9303','2013-04-20','16:50:00',2.39),('9303','2013-04-20','16:55:00',2.26),('9303','2013-04-20','17:00:00',2.1),('9303','2013-04-20','17:05:00',1.99),('9303','2013-04-20','17:10:00',1.92),('9303','2013-04-20','17:15:00',1.72),('9303','2013-04-20','17:20:00',1.52),('9303','2013-04-20','17:25:00',1.66),('9303','2013-04-20','17:30:00',1.73),('9303','2013-04-20','17:35:00',1.75),('9303','2013-04-20','17:40:00',1.56),('9303','2013-04-20','17:55:00',1.35),('9303','2013-04-20','18:00:00',1.01),('9303','2013-04-20','18:05:00',1.09),('9303','2013-04-20','18:10:00',1.05),('9303','2013-04-19','08:20:00',1.19),('9303','2013-04-19','08:25:00',1.26),('9303','2013-04-19','08:30:00',1.11),('9303','2013-04-19','08:35:00',1.49),('9303','2013-04-19','08:40:00',1.58),('9303','2013-04-19','08:45:00',1.66),('9303','2013-04-19','08:50:00',1.75),('9303','2013-04-19','08:55:00',1.83),('9303','2013-04-19','09:00:00',1.89),('9303','2013-04-19','09:05:00',1.96),('9303','2013-04-19','09:10:00',2.02),('9303','2013-04-19','09:15:00',2.08),('9303','2013-04-19','09:20:00',2.16),('9303','2013-04-19','09:25:00',2.24),('9303','2013-04-19','09:30:00',2.31),('9303','2013-04-19','09:35:00',2.4),('9303','2013-04-19','09:40:00',2.46),('9303','2013-04-19','09:45:00',2.49),('9303','2013-04-19','09:50:00',2.55),('9303','2013-04-19','09:55:00',2.61),('9303','2013-04-19','10:00:00',2.66),('9303','2013-04-19','10:05:00',2.74),('9303','2013-04-19','10:10:00',2.78),('9303','2013-04-19','10:15:00',2.91),('9303','2013-04-19','10:20:00',2.78),('9303','2013-04-19','10:25:00',2.98),('9303','2013-04-19','10:30:00',2.27),('9303','2013-04-19','10:35:00',2.18),('9303','2013-04-19','10:40:00',3.16),('9303','2013-04-19','10:45:00',3.22),('9303','2013-04-19','10:50:00',3.2),('9303','2013-04-19','10:55:00',3.19),('9303','2013-04-19','11:00:00',3.21),('9303','2013-04-19','11:05:00',3.26),('9303','2013-04-19','11:10:00',3.3),('9303','2013-04-19','11:15:00',3.31),('9303','2013-04-19','11:20:00',3.38),('9303','2013-04-19','11:25:00',3.42),('9303','2013-04-19','11:30:00',3.48),('9303','2013-04-19','11:35:00',3.5),('9303','2013-04-19','11:40:00',3.55),('9303','2013-04-19','11:45:00',3.57),('9303','2013-04-19','11:50:00',3.59),('9303','2013-04-19','11:55:00',3.61),('9303','2013-04-19','12:00:00',3.63),('9303','2013-04-19','12:05:00',3.63),('9303','2013-04-19','12:10:00',3.68),('9303','2013-04-19','12:15:00',3.76),('9303','2013-04-19','12:20:00',3.75),('9303','2013-04-19','12:25:00',3.7),('9303','2013-04-19','12:30:00',3.68),('9303','2013-04-19','12:35:00',3.76),('9303','2013-04-19','12:40:00',3.73),('9303','2013-04-19','12:45:00',3.8),('9303','2013-04-19','12:50:00',3.76),('9303','2013-04-19','12:55:00',3.74),('9303','2013-04-19','13:00:00',3.75),('9303','2013-04-19','13:05:00',3.81),('9303','2013-04-19','13:10:00',3.84),('9303','2013-04-19','13:15:00',3.83),('9303','2013-04-19','13:20:00',3.79),('9303','2013-04-19','13:25:00',3.84),('9303','2013-04-19','13:30:00',3.89),('9303','2013-04-19','13:35:00',3.8),('9303','2013-04-19','13:40:00',3.85),('9303','2013-04-19','13:45:00',3.81),('9303','2013-04-19','13:50:00',3.74),('9303','2013-04-19','13:55:00',3.7),('9303','2013-04-19','14:00:00',3.72),('9303','2013-04-19','14:05:00',3.64),('9303','2013-04-19','14:10:00',3.67),('9303','2013-04-19','14:15:00',3.58),('9303','2013-04-19','14:20:00',3.58),('9303','2013-04-19','14:25:00',3.58),('9303','2013-04-19','14:30:00',3.52),('9303','2013-04-19','14:35:00',3.5),('9303','2013-04-19','14:40:00',3.46),('9303','2013-04-19','14:45:00',3.46),('9303','2013-04-19','14:50:00',3.47),('9303','2013-04-19','14:55:00',3.41),('9303','2013-04-19','15:00:00',3.43),('9303','2013-04-19','15:05:00',3.37),('9303','2013-04-19','15:10:00',3.3),('9303','2013-04-19','15:15:00',3.22),('9303','2013-04-19','15:20:00',3.15),('9303','2013-04-19','15:25:00',3.14),('9303','2013-04-19','15:30:00',3.08),('9303','2013-04-19','15:35:00',3),('9303','2013-04-19','15:40:00',2.98),('9303','2013-04-19','15:45:00',2.93),('9303','2013-04-19','15:50:00',2.88),('9303','2013-04-19','15:55:00',2.82),('9303','2013-04-19','16:00:00',2.76),('9303','2013-04-19','16:05:00',2.7),('9303','2013-04-19','16:10:00',2.62),('9303','2013-04-19','16:15:00',2.54),('9303','2013-04-19','16:20:00',2.49),('9303','2013-04-19','16:25:00',2.45),('9303','2013-04-19','16:30:00',2.36),('9303','2013-04-19','16:35:00',2.28),('9303','2013-04-19','16:40:00',2.21),('9303','2013-04-19','16:45:00',2.14),('9303','2013-04-19','16:50:00',2.02),('9303','2013-04-19','16:55:00',1.91),('9303','2013-04-19','17:00:00',1.81),('9303','2013-04-19','17:05:00',1.72),('9303','2013-04-19','17:10:00',1.63),('9303','2013-04-19','17:15:00',1.57),('9303','2013-04-19','17:20:00',1.48),('9303','2013-04-19','17:25:00',1.42),('9303','2013-04-19','17:30:00',1.36),('9303','2013-04-19','17:35:00',1.27),('9303','2013-04-19','17:40:00',1.18),('9303','2013-04-19','17:45:00',1.1),('9303','2013-04-18','08:15:00',1.02),('9303','2013-04-18','08:20:00',1.06),('9303','2013-04-18','08:25:00',1.07),('9303','2013-04-18','08:30:00',1.22),('9303','2013-04-18','08:35:00',1.25),('9303','2013-04-18','08:40:00',1.24),('9303','2013-04-18','08:45:00',1.29),('9303','2013-04-18','08:50:00',1.42),('9303','2013-04-18','08:55:00',1.63),('9303','2013-04-18','09:00:00',1.58),('9303','2013-04-18','09:05:00',1.77),('9303','2013-04-18','09:10:00',1.87),('9303','2013-04-18','09:15:00',1.9),('9303','2013-04-18','09:20:00',1.99),('9303','2013-04-18','09:25:00',2.05),('9303','2013-04-18','09:30:00',2.14),('9303','2013-04-18','09:35:00',2.31),('9303','2013-04-18','09:40:00',2.74),('9303','2013-04-18','09:45:00',2.48),('9303','2013-04-18','09:50:00',2.14),('9303','2013-04-18','09:55:00',2.13),('9303','2013-04-18','10:00:00',2.56),('9303','2013-04-18','10:05:00',2.83),('9303','2013-04-18','10:10:00',2.9),('9303','2013-04-18','10:15:00',2.59),('9303','2013-04-18','10:20:00',3.07),('9303','2013-04-18','10:25:00',3.06),('9303','2013-04-18','10:30:00',3.18),('9303','2013-04-18','10:35:00',3.2),('9303','2013-04-18','10:40:00',3.27),('9303','2013-04-18','10:45:00',3.31),('9303','2013-04-18','10:50:00',3.37),('9303','2013-04-18','10:55:00',3.41),('9303','2013-04-18','11:00:00',3.45),('9303','2013-04-18','11:05:00',3.51),('9303','2013-04-18','11:10:00',3.56),('9303','2013-04-18','11:15:00',3.61),('9303','2013-04-18','11:20:00',3.64),('9303','2013-04-18','11:25:00',3.64),('9303','2013-04-18','11:30:00',3.67),('9303','2013-04-18','11:35:00',3.68),('9303','2013-04-18','11:40:00',3.71),('9303','2013-04-18','11:45:00',3.71),('9303','2013-04-18','11:50:00',3.75),('9303','2013-04-18','11:55:00',3.81),('9303','2013-04-18','12:00:00',3.79),('9303','2013-04-18','12:05:00',3.9),('9303','2013-04-18','12:10:00',3.92),('9303','2013-04-18','12:15:00',3.91),('9303','2013-04-18','12:20:00',3.95),('9303','2013-04-18','12:25:00',3.94),('9303','2013-04-18','12:30:00',3.93),('9303','2013-04-18','12:35:00',3.95),('9303','2013-04-18','12:40:00',3.99),('9303','2013-04-18','12:45:00',3.96),('9303','2013-04-18','12:50:00',4),('9303','2013-04-18','12:55:00',4.01),('9303','2013-04-18','13:00:00',4.02),('9303','2013-04-18','13:05:00',4.02),('9303','2013-04-18','13:10:00',4.05),('9303','2013-04-18','13:15:00',4.04),('9303','2013-04-18','13:20:00',4.06),('9303','2013-04-18','13:25:00',4.05),('9303','2013-04-18','13:30:00',4.03),('9303','2013-04-18','13:35:00',4.01),('9303','2013-04-18','13:40:00',3.94),('9303','2013-04-18','13:45:00',3.94),('9303','2013-04-18','13:50:00',3.97),('9303','2013-04-18','13:55:00',3.97),('9303','2013-04-18','14:00:00',3.92),('9303','2013-04-18','14:05:00',3.92),('9303','2013-04-18','14:10:00',3.87),('9303','2013-04-18','14:15:00',3.86),('9303','2013-04-18','14:20:00',3.85),('9303','2013-04-18','14:25:00',3.83),('9303','2013-04-18','14:30:00',3.79),('9303','2013-04-18','14:35:00',3.75),('9303','2013-04-18','14:40:00',3.72),('9303','2013-04-18','14:45:00',3.68),('9303','2013-04-18','14:50:00',3.64),('9303','2013-04-18','14:55:00',3.59),('9303','2013-04-18','15:00:00',3.54),('9303','2013-04-18','15:05:00',3.51),('9303','2013-04-18','15:10:00',3.47),('9303','2013-04-18','15:15:00',3.42),('9303','2013-04-18','15:20:00',3.36),('9303','2013-04-18','15:25:00',3.31),('9303','2013-04-18','15:30:00',3.25),('9303','2013-04-18','15:35:00',3.22),('9303','2013-04-18','15:40:00',3.16),('9303','2013-04-18','15:45:00',3.08),('9303','2013-04-18','15:50:00',3.03),('9303','2013-04-18','15:55:00',2.96),('9303','2013-04-18','16:00:00',2.9),('9303','2013-04-18','16:05:00',2.81),('9303','2013-04-18','16:10:00',2.78),('9303','2013-04-18','16:15:00',2.71),('9303','2013-04-18','16:20:00',2.62),('9303','2013-04-18','16:25:00',2.55),('9303','2013-04-18','16:30:00',2.49),('9303','2013-04-18','16:35:00',2.4),('9303','2013-04-18','16:40:00',2.34),('9303','2013-04-18','16:45:00',2.26),('9303','2013-04-18','16:50:00',2.16),('9303','2013-04-18','16:55:00',2.05),('9303','2013-04-18','17:00:00',1.92),('9303','2013-04-18','17:05:00',1.83),('9303','2013-04-18','17:10:00',1.77),('9303','2013-04-18','17:15:00',1.7),('9303','2013-04-18','17:20:00',1.61),('9303','2013-04-18','17:25:00',1.53),('9303','2013-04-18','17:30:00',1.46),('9303','2013-04-18','17:35:00',1.38),('9303','2013-04-18','17:40:00',1.27),('9303','2013-04-18','17:45:00',1.21),('9303','2013-04-18','17:50:00',1.14),('9303','2013-04-18','17:55:00',1.05),('9303','2013-04-17','08:10:00',1.07),('9303','2013-04-17','08:15:00',1.17),('9303','2013-04-17','08:20:00',1.26),('9303','2013-04-17','08:25:00',1.36),('9303','2013-04-17','08:30:00',1.45),('9303','2013-04-17','08:35:00',1.54),('9303','2013-04-17','08:40:00',1.64),('9303','2013-04-17','08:45:00',1.72),('9303','2013-04-17','08:50:00',1.81),('9303','2013-04-17','08:55:00',1.89),('9303','2013-04-17','09:00:00',1.97),('9303','2013-04-17','09:05:00',2.05),('9303','2013-04-17','09:10:00',2.12),('9303','2013-04-17','09:15:00',2.21),('9303','2013-04-17','09:20:00',2.29),('9303','2013-04-17','09:25:00',2.37),('9303','2013-04-17','09:30:00',2.44),('9303','2013-04-17','09:35:00',2.51),('9303','2013-04-17','09:40:00',2.58),('9303','2013-04-17','09:45:00',2.64),('9303','2013-04-17','09:50:00',2.72),('9303','2013-04-17','09:55:00',2.78),('9303','2013-04-17','10:00:00',2.86),('9303','2013-04-17','10:05:00',2.94),('9303','2013-04-17','10:10:00',3),('9303','2013-04-17','10:15:00',3.04),('9303','2013-04-17','10:20:00',3.09),('9303','2013-04-17','10:25:00',3.18),('9303','2013-04-17','10:30:00',3.21),('9303','2013-04-17','10:35:00',3.27),('9303','2013-04-17','10:40:00',3.32),('9303','2013-04-17','10:45:00',3.36),('9303','2013-04-17','10:50:00',3.39),('9303','2013-04-17','10:55:00',3.46),('9303','2013-04-17','11:00:00',3.52),('9303','2013-04-17','11:05:00',3.55),('9303','2013-04-17','11:10:00',3.58),('9303','2013-04-17','11:15:00',3.58),('9303','2013-04-17','11:20:00',3.65),('9303','2013-04-17','11:25:00',3.71),('9303','2013-04-17','11:30:00',3.71),('9303','2013-04-17','11:35:00',3.74),('9303','2013-04-17','11:40:00',3.75),('9303','2013-04-17','11:45:00',3.75),('9303','2013-04-17','11:50:00',3.83),('9303','2013-04-17','11:55:00',3.83),('9303','2013-04-17','12:00:00',3.84),('9303','2013-04-17','12:05:00',3.83),('9303','2013-04-17','12:10:00',3.89),('9303','2013-04-17','12:15:00',3.91),('9303','2013-04-17','12:20:00',3.89),('9303','2013-04-17','12:25:00',3.94),('9303','2013-04-17','12:30:00',3.96),('9303','2013-04-17','12:35:00',3.96),('9303','2013-04-17','12:40:00',3.95),('9303','2013-04-17','12:45:00',4),('9303','2013-04-17','12:50:00',4.01),('9303','2013-04-17','12:55:00',4.02),('9303','2013-04-17','13:00:00',3.97),('9303','2013-04-17','13:05:00',3.94),('9303','2013-04-17','13:10:00',3.98),('9303','2013-04-17','13:15:00',4.02),('9303','2013-04-17','13:20:00',4.06),('9303','2013-04-17','13:25:00',4.03),('9303','2013-04-17','13:30:00',4.04),('9303','2013-04-17','13:35:00',3.98),('9303','2013-04-17','13:40:00',4.06),('9303','2013-04-17','13:45:00',3.81),('9303','2013-04-17','13:50:00',3.79),('9303','2013-04-17','13:55:00',4.05),('9303','2013-04-17','14:00:00',3.83),('9303','2013-04-17','14:05:00',4.22),('9303','2013-04-17','14:10:00',4.14),('9303','2013-04-17','14:15:00',3.7),('9303','2013-04-17','14:20:00',3.61),('9303','2013-04-17','14:25:00',3.49),('9303','2013-04-17','14:30:00',3.57),('9303','2013-04-17','14:35:00',4.09),('9303','2013-04-17','14:40:00',3.85),('9303','2013-04-17','14:45:00',3.41),('9303','2013-04-17','14:50:00',3.81),('9303','2013-04-17','14:55:00',3.94),('9303','2013-04-17','15:00:00',3.87),('9303','2013-04-17','15:05:00',3.98),('9303','2013-04-17','15:10:00',4.1),('9303','2013-04-17','15:15:00',3.76),('9303','2013-04-17','15:20:00',1.92),('9303','2013-04-17','15:25:00',2),('9303','2013-04-17','15:30:00',3.13),('9303','2013-04-17','15:35:00',3.39),('9303','2013-04-17','15:40:00',3.4),('9303','2013-04-17','15:45:00',3.39),('9303','2013-04-17','15:50:00',3.38),('9303','2013-04-17','15:55:00',3.35),('9303','2013-04-17','16:00:00',3.18),('9303','2013-04-17','16:05:00',2.29),('9303','2013-04-17','16:10:00',3.03),('9303','2013-04-17','16:15:00',2.92),('9303','2013-04-17','16:20:00',2.8),('9303','2013-04-17','16:25:00',2.73),('9303','2013-04-17','16:30:00',2.65),('9303','2013-04-17','16:35:00',2.63),('9303','2013-04-17','16:40:00',2.37),('9303','2013-04-17','16:45:00',2.49),('9303','2013-04-17','16:50:00',2.24),('9303','2013-04-17','16:55:00',2.11),('9303','2013-04-17','17:00:00',1.98),('9303','2013-04-17','17:05:00',1.89),('9303','2013-04-17','17:10:00',1.81),('9303','2013-04-17','17:15:00',1.73),('9303','2013-04-17','17:20:00',1.65),('9303','2013-04-17','17:25:00',1.57),('9303','2013-04-17','17:30:00',1.49),('9303','2013-04-17','17:35:00',1.39),('9303','2013-04-17','17:40:00',1.3),('9303','2013-04-17','17:45:00',1.22),('9303','2013-04-17','17:50:00',1.13),('9303','2013-04-17','17:55:00',1.05),('9303','2013-04-16','08:55:00',1.03),('9303','2013-04-16','09:00:00',1.01),('9303','2013-04-16','09:10:00',1.13),('9303','2013-04-16','09:15:00',1.2),('9303','2013-04-16','09:20:00',1.16),('9303','2013-04-16','09:25:00',1.58),('9303','2013-04-16','09:30:00',1.55),('9303','2013-04-16','09:35:00',1.5),('9303','2013-04-16','09:40:00',1.25),('9303','2013-04-16','09:45:00',1.28),('9303','2013-04-16','09:50:00',1.24),('9303','2013-04-16','09:55:00',1.19),('9303','2013-04-16','10:00:00',1.13),('9303','2013-04-16','10:05:00',1.13),('9303','2013-04-16','10:10:00',1.22),('9303','2013-04-16','10:15:00',1.31),('9303','2013-04-16','10:20:00',1.36),('9303','2013-04-16','10:25:00',1.39),('9303','2013-04-16','10:30:00',1.41),('9303','2013-04-16','10:35:00',1.44),('9303','2013-04-16','10:40:00',1.4),('9303','2013-04-16','10:45:00',1.34),('9303','2013-04-16','10:50:00',1.35),('9303','2013-04-16','10:55:00',1.45),('9303','2013-04-16','11:00:00',1.58),('9303','2013-04-16','11:05:00',1.62),('9303','2013-04-16','11:10:00',1.62),('9303','2013-04-16','11:15:00',1.67),('9303','2013-04-16','11:20:00',1.72),('9303','2013-04-16','11:25:00',1.69),('9303','2013-04-16','11:30:00',1.65),('9303','2013-04-16','11:35:00',1.61),('9303','2013-04-16','11:40:00',1.8),('9303','2013-04-16','11:45:00',2.1),('9303','2013-04-16','11:50:00',2.26),('9303','2013-04-16','11:55:00',2.33),('9303','2013-04-16','12:00:00',2.37),('9303','2013-04-16','12:05:00',2.64),('9303','2013-04-16','12:10:00',2.69),('9303','2013-04-16','12:15:00',2.99),('9303','2013-04-16','12:20:00',2.88),('9303','2013-04-16','12:25:00',2.85),('9303','2013-04-16','12:30:00',3.09),('9303','2013-04-16','12:35:00',3.96),('9303','2013-04-16','12:40:00',3.75),('9303','2013-04-16','12:45:00',3.62),('9303','2013-04-16','12:50:00',2.76),('9303','2013-04-16','12:55:00',3.83),('9303','2013-04-16','13:00:00',3.92),('9303','2013-04-16','13:05:00',3.78),('9303','2013-04-16','13:10:00',3.8),('9303','2013-04-16','13:15:00',3.85),('9303','2013-04-16','13:20:00',3.88),('9303','2013-04-16','13:25:00',3.92),('9303','2013-04-16','13:30:00',3.88),('9303','2013-04-16','13:35:00',3.87),('9303','2013-04-16','13:40:00',3.84),('9303','2013-04-16','13:45:00',3.75),('9303','2013-04-16','13:50:00',3.74),('9303','2013-04-16','13:55:00',3.61),('9303','2013-04-16','14:00:00',3.71),('9303','2013-04-16','14:05:00',3.78),('9303','2013-04-16','14:10:00',3.8),('9303','2013-04-16','14:15:00',3.77),('9303','2013-04-16','14:20:00',3.72),('9303','2013-04-16','14:25:00',2.87),('9303','2013-04-16','14:30:00',3.15),('9303','2013-04-16','14:35:00',3.01),('9303','2013-04-16','14:40:00',3.47),('9303','2013-04-16','14:45:00',3.64),('9303','2013-04-16','14:50:00',3.46),('9303','2013-04-16','14:55:00',3.36),('9303','2013-04-16','15:00:00',3.49),('9303','2013-04-16','15:05:00',3.46),('9303','2013-04-16','15:10:00',3.43),('9303','2013-04-16','15:15:00',3.38),('9303','2013-04-16','15:20:00',3.33),('9303','2013-04-16','15:25:00',3.21),('9303','2013-04-16','15:30:00',3.11),('9303','2013-04-16','15:35:00',3.12),('9303','2013-04-16','15:40:00',3.08),('9303','2013-04-16','15:45:00',3.03),('9303','2013-04-16','15:50:00',3.01),('9303','2013-04-16','15:55:00',2.93),('9303','2013-04-16','16:00:00',2.77),('9303','2013-04-16','16:05:00',2.79),('9303','2013-04-16','16:10:00',2.71),('9303','2013-04-16','16:15:00',2.63),('9303','2013-04-16','16:20:00',2.63),('9303','2013-04-16','16:25:00',2.55),('9303','2013-04-16','16:30:00',2.5),('9303','2013-04-16','16:35:00',2.47),('9303','2013-04-16','16:40:00',2.6),('9303','2013-04-16','16:45:00',2.63),('9303','2013-04-16','16:50:00',2.3),('9303','2013-04-16','16:55:00',1.93),('9303','2013-04-16','17:00:00',1.97),('9303','2013-04-16','17:05:00',1.98),('9303','2013-04-16','17:10:00',2),('9303','2013-04-16','17:15:00',1.92),('9303','2013-04-16','17:20:00',1.84),('9303','2013-04-16','17:25:00',1.81),('9303','2013-04-16','17:30:00',1.73),('9303','2013-04-16','17:35:00',1.69),('9303','2013-04-16','17:40:00',1.56),('9303','2013-04-16','17:45:00',1.43),('9303','2013-04-16','17:50:00',1.28),('9303','2013-04-16','17:55:00',1.08),('9303','2013-04-15','08:10:00',1.08),('9303','2013-04-15','08:15:00',1.16),('9303','2013-04-15','08:20:00',1.26),('9303','2013-04-15','08:25:00',1.35),('9303','2013-04-15','08:30:00',1.46),('9303','2013-04-15','08:35:00',1.53),('9303','2013-04-15','08:40:00',1.66),('9303','2013-04-15','08:45:00',1.73),('9303','2013-04-15','08:50:00',1.83),('9303','2013-04-15','08:55:00',1.91),('9303','2013-04-15','09:00:00',1.99),('9303','2013-04-15','09:05:00',2.09),('9303','2013-04-15','09:10:00',2.16),('9303','2013-04-15','09:15:00',2.24),('9303','2013-04-15','09:20:00',2.32),('9303','2013-04-15','09:25:00',2.39),('9303','2013-04-15','09:30:00',2.46),('9303','2013-04-15','09:35:00',2.52),('9303','2013-04-15','09:40:00',2.59),('9303','2013-04-15','09:45:00',2.66),('9303','2013-04-15','09:50:00',2.73),('9303','2013-04-15','09:55:00',2.8),('9303','2013-04-15','10:00:00',2.87),('9303','2013-04-15','10:05:00',2.94),('9303','2013-04-15','10:10:00',3.01),('9303','2013-04-15','10:15:00',3.07),('9303','2013-04-15','10:20:00',3.12),('9303','2013-04-15','10:25:00',3.16),('9303','2013-04-15','10:30:00',3.23),('9303','2013-04-15','10:35:00',3.28),('9303','2013-04-15','10:40:00',3.33),('9303','2013-04-15','10:45:00',3.38),('9303','2013-04-15','10:50:00',3.42),('9303','2013-04-15','10:55:00',3.48),('9303','2013-04-15','11:00:00',3.51),('9303','2013-04-15','11:05:00',3.54),('9303','2013-04-15','11:10:00',3.59),('9303','2013-04-15','11:15:00',3.62),('9303','2013-04-15','11:20:00',3.65),('9303','2013-04-15','11:25:00',3.7),('9303','2013-04-15','11:30:00',3.74),('9303','2013-04-15','11:35:00',3.76),('9303','2013-04-15','11:40:00',3.77),('9303','2013-04-15','11:45:00',3.77),('9303','2013-04-15','11:50:00',3.78),('9303','2013-04-15','11:55:00',3.8),('9303','2013-04-15','12:00:00',3.81),('9303','2013-04-15','12:05:00',3.82),('9303','2013-04-15','12:10:00',3.82),('9303','2013-04-15','12:15:00',3.88),('9303','2013-04-15','12:20:00',3.9),('9303','2013-04-15','12:25:00',3.91),('9303','2013-04-15','12:30:00',3.94),('9303','2013-04-15','12:35:00',3.95),('9303','2013-04-15','12:40:00',3.91),('9303','2013-04-15','12:45:00',3.91),('9303','2013-04-15','12:50:00',3.88),('9303','2013-04-15','12:55:00',3.88),('9303','2013-04-15','13:00:00',3.91),('9303','2013-04-15','13:05:00',3.99),('9303','2013-04-15','13:10:00',4.01),('9303','2013-04-15','13:15:00',3.99),('9303','2013-04-15','13:20:00',3.96),('9303','2013-04-15','13:25:00',3.92),('9303','2013-04-15','13:30:00',3.93),('9303','2013-04-15','13:35:00',3.96),('9303','2013-04-15','13:40:00',3.92),('9303','2013-04-15','13:45:00',3.83),('9303','2013-04-15','13:50:00',3.86),('9303','2013-04-15','13:55:00',3.96),('9303','2013-04-15','14:00:00',3.95),('9303','2013-04-15','14:05:00',3.91),('9303','2013-04-15','14:10:00',3.9),('9303','2013-04-15','14:15:00',3.9),('9303','2013-04-15','14:20:00',3.9),('9303','2013-04-15','14:25:00',3.88),('9303','2013-04-15','14:30:00',3.82),('9303','2013-04-15','14:35:00',3.79),('9303','2013-04-15','14:40:00',3.76),('9303','2013-04-15','14:45:00',3.72),('9303','2013-04-15','14:50:00',3.69),('9303','2013-04-15','14:55:00',3.64),('9303','2013-04-15','15:00:00',3.61),('9303','2013-04-15','15:05:00',3.56),('9303','2013-04-15','15:10:00',3.53),('9303','2013-04-15','15:15:00',3.49),('9303','2013-04-15','15:20:00',3.45),('9303','2013-04-15','15:25:00',3.41),('9303','2013-04-15','15:30:00',3.35),('9303','2013-04-15','15:35:00',3.3),('9303','2013-04-15','15:40:00',3.23),('9303','2013-04-15','15:45:00',3.17),('9303','2013-04-15','15:50:00',3.1),('9303','2013-04-15','15:55:00',3.05),('9303','2013-04-15','16:00:00',2.99),('9303','2013-04-15','16:05:00',2.92),('9303','2013-04-15','16:10:00',2.84),('9303','2013-04-15','16:15:00',2.77),('9303','2013-04-15','16:20:00',2.7),('9303','2013-04-15','16:25:00',2.63),('9303','2013-04-15','16:30:00',2.56),('9303','2013-04-15','16:35:00',2.48),('9303','2013-04-15','16:40:00',2.4),('9303','2013-04-15','16:45:00',2.28),('9303','2013-04-15','16:50:00',2.18),('9303','2013-04-15','16:55:00',2.07),('9303','2013-04-15','17:00:00',1.96),('9303','2013-04-15','17:05:00',1.89),('9303','2013-04-15','17:10:00',1.82),('9303','2013-04-15','17:15:00',1.73),('9303','2013-04-15','17:20:00',1.65),('9303','2013-04-15','17:25:00',1.58),('9303','2013-04-15','17:30:00',1.49),('9303','2013-04-15','17:35:00',1.39),('9303','2013-04-15','17:40:00',1.31),('9303','2013-04-15','17:45:00',1.23),('9303','2013-04-15','17:50:00',1.13),('9303','2013-04-15','17:55:00',1.05),('9303','2013-04-14','08:15:00',1.09),('9303','2013-04-14','08:20:00',1.18),('9303','2013-04-14','08:25:00',1.27),('9303','2013-04-14','08:30:00',1.37),('9303','2013-04-14','08:35:00',1.45),('9303','2013-04-14','08:40:00',1.53),('9303','2013-04-14','08:45:00',1.63),('9303','2013-04-14','08:50:00',1.73),('9303','2013-04-14','08:55:00',1.82),('9303','2013-04-14','09:00:00',1.89),('9303','2013-04-14','09:05:00',1.98),('9303','2013-04-14','09:10:00',2.03),('9303','2013-04-14','09:15:00',2.11),('9303','2013-04-14','09:20:00',2.19),('9303','2013-04-14','09:25:00',2.25),('9303','2013-04-14','09:30:00',2.32),('9303','2013-04-14','09:35:00',2.41),('9303','2013-04-14','09:40:00',2.48),('9303','2013-04-14','09:45:00',2.54),('9303','2013-04-14','09:50:00',2.62),('9303','2013-04-14','09:55:00',2.7),('9303','2013-04-14','10:00:00',2.74),('9303','2013-04-14','10:05:00',2.82),('9303','2013-04-14','10:10:00',2.88),('9303','2013-04-14','10:15:00',2.94),('9303','2013-04-14','10:20:00',3.01),('9303','2013-04-14','10:25:00',3.08),('9303','2013-04-14','10:30:00',3.12),('9303','2013-04-14','10:35:00',3.16),('9303','2013-04-14','10:40:00',3.18),('9303','2013-04-14','10:45:00',3.24),('9303','2013-04-14','10:50:00',3.31),('9303','2013-04-14','10:55:00',3.36),('9303','2013-04-14','11:00:00',3.42),('9303','2013-04-14','11:05:00',3.47),('9303','2013-04-14','11:10:00',3.52),('9303','2013-04-14','11:15:00',3.55),('9303','2013-04-14','11:20:00',3.55),('9303','2013-04-14','11:25:00',3.56),('9303','2013-04-14','11:30:00',3.59),('9303','2013-04-14','11:35:00',3.63),('9303','2013-04-14','11:40:00',3.72),('9303','2013-04-14','11:45:00',3.7),('9303','2013-04-14','11:50:00',3.69),('9303','2013-04-14','11:55:00',3.71),('9303','2013-04-14','12:00:00',3.72),('9303','2013-04-14','12:05:00',3.73),('9303','2013-04-14','12:10:00',3.77),('9303','2013-04-14','12:15:00',3.8),('9303','2013-04-14','12:20:00',3.85),('9303','2013-04-14','12:25:00',3.84),('9303','2013-04-14','12:30:00',3.82),('9303','2013-04-14','12:35:00',3.82),('9303','2013-04-14','12:40:00',3.92),('9303','2013-04-14','12:45:00',4.01),('9303','2013-04-14','12:50:00',4.03),('9303','2013-04-14','12:55:00',4.1),('9303','2013-04-14','13:00:00',4.15),('9303','2013-04-14','13:05:00',3.96),('9303','2013-04-14','13:10:00',4.06),('9303','2013-04-14','13:15:00',4.03),('9303','2013-04-14','13:20:00',4.05),('9303','2013-04-14','13:25:00',4.05),('9303','2013-04-14','13:30:00',3.96),('9303','2013-04-14','13:35:00',3.91),('9303','2013-04-14','13:40:00',3.88),('9303','2013-04-14','13:45:00',3.86),('9303','2013-04-14','13:50:00',3.8),('9303','2013-04-14','13:55:00',3.79),('9303','2013-04-14','14:00:00',3.84),('9303','2013-04-14','14:05:00',3.86),('9303','2013-04-14','14:10:00',3.85),('9303','2013-04-14','14:15:00',3.8),('9303','2013-04-14','14:20:00',3.75),('9303','2013-04-14','14:25:00',3.71),('9303','2013-04-14','14:30:00',3.67),('9303','2013-04-14','14:35:00',3.72),('9303','2013-04-14','14:40:00',3.82),('9303','2013-04-14','14:45:00',3.89),('9303','2013-04-14','14:50:00',3.86),('9303','2013-04-14','14:55:00',3.71),('9303','2013-04-14','15:00:00',3.58),('9303','2013-04-14','15:05:00',3.63),('9303','2013-04-14','15:10:00',3.61),('9303','2013-04-14','15:15:00',3.44),('9303','2013-04-14','15:20:00',3.2),('9303','2013-04-14','15:25:00',2.34),('9303','2013-04-14','15:30:00',3.3),('9303','2013-04-14','15:35:00',3.36),('9303','2013-04-14','15:40:00',3.36),('9303','2013-04-14','15:45:00',3.31),('9303','2013-04-14','15:50:00',3.17),('9303','2013-04-14','15:55:00',2.43),('9303','2013-04-14','16:00:00',2.67),('9303','2013-04-14','16:05:00',2.82),('9303','2013-04-14','16:10:00',2.82),('9303','2013-04-14','16:15:00',2.65),('9303','2013-04-14','16:20:00',2.58),('9303','2013-04-14','16:25:00',2.6),('9303','2013-04-14','16:30:00',2.51),('9303','2013-04-14','16:35:00',2.4),('9303','2013-04-14','16:40:00',2.3),('9303','2013-04-14','16:45:00',2.19),('9303','2013-04-14','16:50:00',2.13),('9303','2013-04-14','16:55:00',1.99),('9303','2013-04-14','17:00:00',1.89),('9303','2013-04-14','17:05:00',1.83),('9303','2013-04-14','17:10:00',1.76),('9303','2013-04-14','17:15:00',1.67),('9303','2013-04-14','17:20:00',1.6),('9303','2013-04-14','17:25:00',1.51),('9303','2013-04-14','17:30:00',1.44),('9303','2013-04-14','17:35:00',1.34),('9303','2013-04-14','17:40:00',1.25),('9303','2013-04-14','17:45:00',1.18),('9303','2013-04-14','17:50:00',1.09),('9303','2013-04-14','17:55:00',1),('9303','2013-04-13','08:55:00',1.05),('9303','2013-04-13','09:05:00',1.5),('9303','2013-04-13','09:10:00',1.56),('9303','2013-04-13','09:15:00',1.94),('9303','2013-04-13','09:20:00',1.66),('9303','2013-04-13','09:25:00',1.68),('9303','2013-04-13','09:30:00',2.44),('9303','2013-04-13','09:35:00',2.32),('9303','2013-04-13','09:40:00',2.19),('9303','2013-04-13','09:45:00',2.59),('9303','2013-04-13','09:50:00',2.6),('9303','2013-04-13','09:55:00',2.66),('9303','2013-04-13','10:00:00',2.78),('9303','2013-04-13','10:05:00',2.87),('9303','2013-04-13','10:10:00',3.03),('9303','2013-04-13','10:15:00',3.15),('9303','2013-04-13','10:20:00',2.75),('9303','2013-04-13','10:25:00',1.19),('9303','2013-04-13','10:30:00',3.38),('9303','2013-04-13','10:35:00',2.06),('9303','2013-04-13','10:40:00',2.46),('9303','2013-04-13','10:45:00',3.23),('9303','2013-04-13','10:50:00',1.5),('9303','2013-04-13','10:55:00',3.39),('9303','2013-04-13','11:00:00',1.88),('9303','2013-04-13','11:05:00',3.1),('9303','2013-04-13','11:10:00',1.88),('9303','2013-04-13','11:15:00',2.14),('9303','2013-04-13','11:20:00',2.91),('9303','2013-04-13','11:25:00',1.4),('9303','2013-04-13','11:30:00',2.72),('9303','2013-04-13','11:35:00',3.97),('9303','2013-04-13','11:40:00',3.17),('9303','2013-04-13','11:45:00',4.12),('9303','2013-04-13','11:50:00',3.11),('9303','2013-04-13','11:55:00',2.95),('9303','2013-04-13','12:00:00',4.21),('9303','2013-04-13','12:05:00',4.09),('9303','2013-04-13','12:10:00',4.15),('9303','2013-04-13','12:15:00',4.09),('9303','2013-04-13','12:20:00',3.59),('9303','2013-04-13','12:25:00',2.84),('9303','2013-04-13','12:30:00',3.47),('9303','2013-04-13','12:35:00',4.1),('9303','2013-04-13','12:40:00',4.14),('9303','2013-04-13','12:45:00',4.01),('9303','2013-04-13','12:50:00',3.97),('9303','2013-04-13','12:55:00',3.96),('9303','2013-04-13','13:00:00',3.82),('9303','2013-04-13','13:05:00',4.06),('9303','2013-04-13','13:10:00',4.17),('9303','2013-04-13','13:15:00',4.03),('9303','2013-04-13','13:20:00',3.96),('9303','2013-04-13','13:25:00',4.03),('9303','2013-04-13','13:30:00',3.71),('9303','2013-04-13','13:35:00',2.92),('9303','2013-04-13','13:40:00',2.01),('9303','2013-04-13','13:45:00',3.47),('9303','2013-04-13','13:50:00',2.52),('9303','2013-04-13','13:55:00',1.74),('9303','2013-04-13','14:00:00',1.95),('9303','2013-04-13','14:05:00',2.29),('9303','2013-04-13','14:10:00',1.48),('9303','2013-04-13','14:15:00',1.91),('9303','2013-04-13','14:20:00',3.29),('9303','2013-04-13','14:25:00',3.42),('9303','2013-04-13','14:30:00',3.5),('9303','2013-04-13','14:35:00',3.58),('9303','2013-04-13','14:40:00',3.44),('9303','2013-04-13','14:45:00',3.47),('9303','2013-04-13','14:50:00',3.31),('9303','2013-04-13','14:55:00',3.37),('9303','2013-04-13','15:00:00',3.1),('9303','2013-04-13','15:05:00',2.65),('9303','2013-04-13','15:10:00',2.77),('9303','2013-04-13','15:15:00',2.82),('9303','2013-04-13','15:20:00',2.68),('9303','2013-04-13','15:25:00',2.49),('9303','2013-04-13','15:30:00',2.56),('9303','2013-04-13','15:35:00',2.47),('9303','2013-04-13','15:40:00',2.59),('9303','2013-04-13','15:45:00',2.63),('9303','2013-04-13','15:50:00',2.57),('9303','2013-04-13','15:55:00',2.5),('9303','2013-04-13','16:00:00',2.49),('9303','2013-04-13','16:05:00',2.36),('9303','2013-04-13','16:10:00',2.17),('9303','2013-04-13','16:15:00',2.2),('9303','2013-04-13','16:20:00',2.12),('9303','2013-04-13','16:25:00',1.95),('9303','2013-04-13','16:30:00',1.92),('9303','2013-04-13','16:35:00',1.77),('9303','2013-04-13','16:40:00',1.68),('9303','2013-04-13','16:45:00',1.6),('9303','2013-04-13','16:50:00',1.62),('9303','2013-04-13','16:55:00',1.32),('9303','2013-04-13','17:00:00',1.11),('9303','2013-04-13','17:05:00',1.07),('9303','2013-04-13','17:10:00',1.52),('9303','2013-04-13','17:15:00',1.71),('9303','2013-04-13','17:20:00',1.42),('9303','2013-04-13','17:25:00',1.62),('9303','2013-04-13','17:30:00',1.38),('9303','2013-04-13','17:35:00',1.39),('9303','2013-04-13','17:40:00',1.26),('9303','2013-04-13','17:45:00',1.12),('9303','2013-04-13','17:55:00',1.05),('9303','2013-04-12','08:10:00',1.06),('9303','2013-04-12','08:35:00',1.11),('9303','2013-04-12','08:40:00',1.04),('9303','2013-04-12','08:45:00',1.08),('9303','2013-04-12','08:55:00',1.08),('9303','2013-04-12','09:00:00',2.02),('9303','2013-04-12','09:05:00',1.27),('9303','2013-04-12','09:10:00',1.2),('9303','2013-04-12','09:15:00',1.81),('9303','2013-04-12','09:20:00',1.86),('9303','2013-04-12','09:25:00',1.97),('9303','2013-04-12','09:30:00',1.74),('9303','2013-04-12','09:40:00',1.25),('9303','2013-04-12','09:45:00',1.92),('9303','2013-04-12','09:50:00',1.3),('9303','2013-04-12','10:20:00',1.83),('9303','2013-04-12','10:25:00',2.29),('9303','2013-04-12','10:30:00',1.22),('9303','2013-04-12','10:35:00',1.62),('9303','2013-04-12','10:40:00',3.55),('9303','2013-04-12','10:45:00',3.9),('9303','2013-04-12','10:50:00',4.18),('9303','2013-04-12','10:55:00',2.67),('9303','2013-04-12','11:00:00',1.2),('9303','2013-04-12','11:05:00',1.32),('9303','2013-04-12','11:10:00',1.68),('9303','2013-04-12','11:15:00',2.78),('9303','2013-04-12','11:20:00',3.66),('9303','2013-04-12','11:25:00',3.89),('9303','2013-04-12','11:30:00',3.32),('9303','2013-04-12','11:35:00',4.05),('9303','2013-04-12','11:40:00',3.08),('9303','2013-04-12','11:45:00',3.37),('9303','2013-04-12','11:50:00',2.86),('9303','2013-04-12','11:55:00',3.91),('9303','2013-04-12','12:00:00',4.08),('9303','2013-04-12','12:05:00',3.85),('9303','2013-04-12','12:10:00',3.83),('9303','2013-04-12','12:15:00',3.96),('9303','2013-04-12','12:20:00',4.11),('9303','2013-04-12','12:25:00',4.06),('9303','2013-04-12','12:30:00',3.82),('9303','2013-04-12','12:35:00',4.01),('9303','2013-04-12','12:40:00',3.87),('9303','2013-04-12','12:45:00',3.89),('9303','2013-04-12','12:50:00',3.74),('9303','2013-04-12','12:55:00',3.27),('9303','2013-04-12','13:00:00',4.11),('9303','2013-04-12','13:05:00',4.06),('9303','2013-04-12','13:10:00',4.07),('9303','2013-04-12','13:15:00',4.04),('9303','2013-04-12','13:20:00',4.04),('9303','2013-04-12','13:25:00',4),('9303','2013-04-12','13:30:00',4.01),('9303','2013-04-12','13:35:00',4.05),('9303','2013-04-12','13:40:00',3.95),('9303','2013-04-12','13:45:00',3.98),('9303','2013-04-12','13:50:00',3.97),('9303','2013-04-12','13:55:00',3.96),('9303','2013-04-12','14:00:00',3.96),('9303','2013-04-12','14:05:00',3.93),('9303','2013-04-12','14:10:00',3.9),('9303','2013-04-12','14:15:00',3.86),('9303','2013-04-12','14:20:00',3.84),('9303','2013-04-12','14:25:00',3.81),('9303','2013-04-12','14:30:00',3.76),('9303','2013-04-12','14:35:00',3.74),('9303','2013-04-12','14:40:00',3.7),('9303','2013-04-12','14:45:00',3.66),('9303','2013-04-12','14:50:00',3.64),('9303','2013-04-12','14:55:00',3.58),('9303','2013-04-12','15:00:00',3.54),('9303','2013-04-12','15:05:00',3.5),('9303','2013-04-12','15:10:00',3.43),('9303','2013-04-12','15:15:00',3.36),('9303','2013-04-12','15:20:00',3.35),('9303','2013-04-12','15:25:00',3.3),('9303','2013-04-12','15:30:00',3.25),('9303','2013-04-12','15:35:00',3.19),('9303','2013-04-12','15:40:00',3.15),('9303','2013-04-12','15:45:00',3.12),('9303','2013-04-12','15:50:00',3.06),('9303','2013-04-12','15:55:00',2.98),('9303','2013-04-12','16:00:00',2.92),('9303','2013-04-12','16:05:00',2.87),('9303','2013-04-12','16:10:00',2.82),('9303','2013-04-12','16:15:00',2.46),('9303','2013-04-12','16:20:00',2.6),('9303','2013-04-12','16:25:00',2.6),('9303','2013-04-12','16:30:00',1.57),('9303','2013-04-12','16:35:00',1.25),('9303','2013-04-12','16:40:00',1.43),('9303','2013-04-12','16:45:00',2.32),('9303','2013-04-12','16:50:00',2.12),('9303','2013-04-12','16:55:00',2.03),('9303','2013-04-12','17:00:00',1.93),('9303','2013-04-12','17:05:00',1.86),('9303','2013-04-12','17:10:00',1.76),('9303','2013-04-12','17:15:00',1.7),('9303','2013-04-12','17:20:00',1.62),('9303','2013-04-12','17:25:00',1.53),('9303','2013-04-12','17:30:00',1.47),('9303','2013-04-12','17:35:00',1.36),('9303','2013-04-12','17:40:00',1.28),('9303','2013-04-12','17:45:00',1.18),('9303','2013-04-12','17:50:00',1.08),('9303','2013-04-12','17:55:00',1.01),('9303','2014-03-28','07:30:00',1.06),('9303','2014-03-28','07:35:00',1.2),('9303','2014-03-28','07:40:00',1.27),('9303','2014-03-28','07:45:00',1.43),('9303','2014-03-28','07:50:00',1.54),('9303','2014-03-28','07:55:00',1.6),('9303','2014-03-28','08:00:00',1.7),('9303','2014-03-28','08:05:00',1.82),('9303','2014-03-28','08:10:00',1.93),('9303','2014-03-28','08:15:00',2.03),('9303','2014-03-28','08:20:00',2.14),('9303','2014-03-28','08:25:00',2.21),('9303','2014-03-28','08:30:00',2.29),('9303','2014-03-28','08:35:00',2.37),('9303','2014-03-28','08:40:00',2.45),('9303','2014-03-28','08:45:00',2.52),('9303','2014-03-28','08:50:00',2.63),('9303','2014-03-28','08:55:00',2.73),('9303','2014-03-28','09:00:00',2.73),('9303','2014-03-28','09:05:00',2.93),('9303','2014-03-28','09:10:00',3.07),('9303','2014-03-28','09:15:00',3),('9303','2014-03-28','09:20:00',2.68),('9303','2014-03-28','09:25:00',3.14),('9303','2014-03-28','09:30:00',3.35),('9303','2014-03-28','09:35:00',2.72),('9303','2014-03-28','09:40:00',1.99),('9303','2014-03-28','09:45:00',1.75),('9303','2014-03-28','09:50:00',2.12),('9303','2014-03-28','09:55:00',3.49),('9303','2014-03-28','10:00:00',3.66),('9303','2014-03-28','10:05:00',3.56),('9303','2014-03-28','10:10:00',2.79),('9303','2014-03-28','10:15:00',2.76),('9303','2014-03-28','10:20:00',2.62),('9303','2014-03-28','10:25:00',3.69),('9303','2014-03-28','10:30:00',3.7),('9303','2014-03-28','10:35:00',3.51),('9303','2014-03-28','10:40:00',3.44),('9303','2014-03-28','10:45:00',2.61),('9303','2014-03-28','10:50:00',3.9),('9303','2014-03-28','10:55:00',3.99),('9303','2014-03-28','11:00:00',3.42),('9303','2014-03-28','11:05:00',4.02),('9303','2014-03-28','11:10:00',4.06),('9303','2014-03-28','11:15:00',3.29),('9303','2014-03-28','11:20:00',2.63),('9303','2014-03-28','11:25:00',2.95),('9303','2014-03-28','11:30:00',2.01),('9303','2014-03-28','11:35:00',1.73),('9303','2014-03-28','11:40:00',1.36),('9303','2014-03-28','11:45:00',2.17),('9303','2014-03-28','11:50:00',1.32),('9303','2014-03-28','11:55:00',1.19),('9303','2014-03-28','12:00:00',3.32),('9303','2014-03-28','12:05:00',4.44),('9303','2014-03-28','12:10:00',4.41),('9303','2014-03-28','12:15:00',4.61),('9303','2014-03-28','12:20:00',3.27),('9303','2014-03-28','12:35:00',4.22),('9303','2014-03-28','12:40:00',3.83),('9303','2014-03-28','12:45:00',4.26),('9303','2014-03-28','12:50:00',4.29),('9303','2014-03-28','12:55:00',4.59),('9303','2014-03-28','13:00:00',4.17),('9303','2014-03-28','13:05:00',3.16),('9303','2014-03-28','13:10:00',1.49),('9303','2014-03-28','13:15:00',2.75),('9303','2014-03-28','13:20:00',2.65),('9303','2014-03-28','13:25:00',1.69),('9303','2014-03-28','13:30:00',3.51),('9303','2014-03-28','13:35:00',3.73),('9303','2014-03-28','13:40:00',3.77),('9303','2014-03-28','13:45:00',3.99),('9303','2014-03-28','13:50:00',3.8),('9303','2014-03-28','13:55:00',3.72),('9303','2014-03-28','14:00:00',3.78),('9303','2014-03-28','14:05:00',3.73),('9303','2014-03-28','14:10:00',3.56),('9303','2014-03-28','14:15:00',3.61),('9303','2014-03-28','14:20:00',3.56),('9303','2014-03-28','14:25:00',3.51),('9303','2014-03-28','14:30:00',3.46),('9303','2014-03-28','14:35:00',3.41),('9303','2014-03-28','14:40:00',3.36),('9303','2014-03-28','14:45:00',3.27),('9303','2014-03-28','14:50:00',3.23),('9303','2014-03-28','14:55:00',3.19),('9303','2014-03-28','15:00:00',3.18),('9303','2014-03-28','15:05:00',3.08),('9303','2014-03-28','15:10:00',2.99),('9303','2014-03-28','15:15:00',2.9),('9303','2014-03-28','15:20:00',2.83),('9303','2014-03-28','15:25:00',2.74),('9303','2014-03-28','15:30:00',2.7),('9303','2014-03-28','15:35:00',2.63),('9303','2014-03-28','15:40:00',2.51),('9303','2014-03-28','15:45:00',2.47),('9303','2014-03-28','15:50:00',2.35),('9303','2014-03-28','15:55:00',2.3),('9303','2014-03-28','16:00:00',2.36),('9303','2014-03-28','16:05:00',2.4),('9303','2014-03-28','16:10:00',2.3),('9303','2014-03-28','16:15:00',2.15),('9303','2014-03-28','16:20:00',1.84),('9303','2014-03-28','16:25:00',1.6),('9303','2014-03-28','16:30:00',1.26),('9303','2014-03-28','16:45:00',1.01),('9303','2013-04-11','08:15:00',1.05),('9303','2013-04-11','08:20:00',1.14),('9303','2013-04-11','08:25:00',1.25),('9303','2013-04-11','08:30:00',1.34),('9303','2013-04-11','08:35:00',1.44),('9303','2013-04-11','08:40:00',1.51),('9303','2013-04-11','08:45:00',1.62),('9303','2013-04-11','08:50:00',1.7),('9303','2013-04-11','08:55:00',1.79),('9303','2013-04-11','09:00:00',1.88),('9303','2013-04-11','09:05:00',1.96),('9303','2013-04-11','09:10:00',2.03),('9303','2013-04-11','09:15:00',2.1),('9303','2013-04-11','09:20:00',2.17),('9303','2013-04-11','09:25:00',2.25),('9303','2013-04-11','09:30:00',2.3),('9303','2013-04-11','09:35:00',2.37),('9303','2013-04-11','09:40:00',2.46),('9303','2013-04-11','09:45:00',2.6),('9303','2013-04-11','09:50:00',2.64),('9303','2013-04-11','09:55:00',1.82),('9303','2013-04-11','10:00:00',1.45),('9303','2013-04-11','10:05:00',1.62),('9303','2013-04-11','10:10:00',1.6),('9303','2013-04-11','10:15:00',2.92),('9303','2013-04-11','10:20:00',3),('9303','2013-04-11','10:25:00',3.14),('9303','2013-04-11','10:30:00',3.28),('9303','2013-04-11','10:35:00',3.51),('9303','2013-04-11','10:40:00',3.43),('9303','2013-04-11','10:45:00',3.11),('9303','2013-04-11','10:50:00',1.77),('9303','2013-04-11','11:05:00',2.81),('9303','2013-04-11','11:10:00',3.64),('9303','2013-04-11','11:15:00',3.84),('9303','2013-04-11','11:20:00',2.48),('9303','2013-04-11','11:25:00',1.91),('9303','2013-04-11','11:30:00',4.31),('9303','2013-04-11','11:35:00',3.35),('9303','2013-04-11','11:40:00',1.1),('9303','2013-04-11','11:45:00',1.11),('9303','2013-04-11','11:55:00',3.21),('9303','2013-04-11','12:00:00',3.97),('9303','2013-04-11','12:05:00',4.3),('9303','2013-04-11','12:10:00',3.26),('9303','2013-04-11','12:15:00',2.16),('9303','2013-04-11','12:20:00',1.79),('9303','2013-04-11','12:25:00',4.38),('9303','2013-04-11','12:30:00',4.31),('9303','2013-04-11','12:35:00',3.65),('9303','2013-04-11','12:40:00',4.35),('9303','2013-04-11','12:45:00',4.36),('9303','2013-04-11','12:50:00',4.25),('9303','2013-04-11','12:55:00',3.2),('9303','2013-04-11','13:00:00',4.35),('9303','2013-04-11','13:05:00',3.67),('9303','2013-04-11','13:10:00',4.13),('9303','2013-04-11','13:15:00',4.03),('9303','2013-04-11','13:20:00',2.23),('9303','2013-04-11','13:25:00',4.29),('9303','2013-04-11','13:30:00',4.17),('9303','2013-04-11','13:35:00',3.96),('9303','2013-04-11','13:40:00',4.04),('9303','2013-04-11','13:45:00',4.07),('9303','2013-04-11','13:50:00',3.98),('9303','2013-04-11','13:55:00',4.03),('9303','2013-04-11','14:00:00',4.04),('9303','2013-04-11','14:05:00',4.07),('9303','2013-04-11','14:10:00',4.08),('9303','2013-04-11','14:15:00',4.03),('9303','2013-04-11','14:20:00',3.97),('9303','2013-04-11','14:25:00',3.91),('9303','2013-04-11','14:30:00',3.85),('9303','2013-04-11','14:35:00',3.15),('9303','2013-04-11','14:40:00',3.56),('9303','2013-04-11','14:45:00',3.86),('9303','2013-04-11','14:50:00',3.74),('9303','2013-04-11','14:55:00',3.69),('9303','2013-04-11','15:00:00',3.65),('9303','2013-04-11','15:05:00',3.56),('9303','2013-04-11','15:10:00',3.5),('9303','2013-04-11','15:15:00',3.46),('9303','2013-04-11','15:20:00',3.43),('9303','2013-04-11','15:25:00',3.39),('9303','2013-04-11','15:30:00',3.32),('9303','2013-04-11','15:35:00',3.27),('9303','2013-04-11','15:40:00',3.22),('9303','2013-04-11','15:45:00',3.14),('9303','2013-04-11','15:50:00',3.08),('9303','2013-04-11','15:55:00',3.03),('9303','2013-04-11','16:00:00',2.97),('9303','2013-04-11','16:05:00',2.9),('9303','2013-04-11','16:10:00',2.85),('9303','2013-04-11','16:15:00',2.77),('9303','2013-04-11','16:20:00',2.71),('9303','2013-04-11','16:25:00',2.64),('9303','2013-04-11','16:30:00',2.58),('9303','2013-04-11','16:35:00',2.5),('9303','2013-04-11','16:40:00',2.42),('9303','2013-04-11','16:45:00',2.32),('9303','2013-04-11','16:50:00',2.18),('9303','2013-04-11','16:55:00',2.09),('9303','2013-04-11','17:00:00',1.99),('9303','2013-04-11','17:05:00',1.9),('9303','2013-04-11','17:10:00',1.83),('9303','2013-04-11','17:15:00',1.75),('9303','2013-04-11','17:20:00',1.66),('9303','2013-04-11','17:25:00',1.58),('9303','2013-04-11','17:30:00',1.5),('9303','2013-04-11','17:35:00',1.4),('9303','2013-04-11','17:40:00',1.32),('9303','2013-04-11','17:45:00',1.23),('9303','2013-04-11','17:50:00',1.14),('9303','2013-04-11','17:55:00',1.05),('9303','2013-04-10','08:55:00',1.61),('9303','2013-04-10','09:00:00',1.86),('9303','2013-04-10','09:05:00',2),('9303','2013-04-10','09:10:00',2.08),('9303','2013-04-10','09:15:00',2.13),('9303','2013-04-10','09:20:00',2.11),('9303','2013-04-10','09:25:00',2.08),('9303','2013-04-10','09:30:00',2.2),('9303','2013-04-10','09:35:00',2.44),('9303','2013-04-10','09:40:00',2.53),('9303','2013-04-10','09:45:00',2.59),('9303','2013-04-10','09:50:00',2.7),('9303','2013-04-10','09:55:00',2.8),('9303','2013-04-10','10:00:00',2.84),('9303','2013-04-10','10:05:00',2.96),('9303','2013-04-10','10:10:00',3.14),('9303','2013-04-10','10:15:00',2.91),('9303','2013-04-10','10:20:00',3.25),('9303','2013-04-10','10:25:00',3.31),('9303','2013-04-10','10:30:00',3.33),('9303','2013-04-10','10:35:00',3.36),('9303','2013-04-10','10:40:00',3.4),('9303','2013-04-10','10:45:00',3.51),('9303','2013-04-10','10:50:00',3.35),('9303','2013-04-10','10:55:00',3.33),('9303','2013-04-10','11:00:00',3.25),('9303','2013-04-10','11:05:00',3.31),('9303','2013-04-10','11:10:00',3.39),('9303','2013-04-10','11:15:00',3.33),('9303','2013-04-10','11:20:00',3.58),('9303','2013-04-10','11:25:00',3.76),('9303','2013-04-10','11:30:00',3.71),('9303','2013-04-10','11:35:00',3.8),('9303','2013-04-10','11:40:00',3.81),('9303','2013-04-10','11:45:00',3.86),('9303','2013-04-10','11:50:00',3.92),('9303','2013-04-10','11:55:00',3.94),('9303','2013-04-10','12:00:00',3.97),('9303','2013-04-10','12:05:00',4.01),('9303','2013-04-10','12:10:00',4.01),('9303','2013-04-10','12:15:00',4.04),('9303','2013-04-10','12:20:00',4.1),('9303','2013-04-10','12:25:00',4.13),('9303','2013-04-10','12:30:00',4.19),('9303','2013-04-10','12:35:00',4.16),('9303','2013-04-10','12:40:00',4.12),('9303','2013-04-10','12:45:00',4.13),('9303','2013-04-10','12:50:00',3.67),('9303','2013-04-10','12:55:00',3.7),('9303','2013-04-10','13:00:00',3.61),('9303','2013-04-10','13:05:00',3.04),('9303','2013-04-10','13:10:00',2.5),('9303','2013-04-10','13:15:00',2.29),('9303','2013-04-10','13:20:00',3.32),('9303','2013-04-10','13:25:00',3.49),('9303','2013-04-10','13:30:00',3.13),('9303','2013-04-10','13:35:00',4.64),('9303','2013-04-10','13:40:00',2.68),('9303','2013-04-10','13:45:00',2.97),('9303','2013-04-10','13:50:00',3.51),('9303','2013-04-10','13:55:00',4.19),('9303','2013-04-10','14:00:00',3.89),('9303','2013-04-10','14:05:00',4.01),('9303','2013-04-10','14:10:00',4.08),('9303','2013-04-10','14:15:00',4.05),('9303','2013-04-10','14:20:00',4.02),('9303','2013-04-10','14:25:00',4.05),('9303','2013-04-10','14:30:00',4.03),('9303','2013-04-10','14:35:00',3.98),('9303','2013-04-10','14:40:00',3.94),('9303','2013-04-10','14:45:00',3.97),('9303','2013-04-10','14:50:00',3.99),('9303','2013-04-10','14:55:00',3.86),('9303','2013-04-10','15:00:00',3.87),('9303','2013-04-10','15:05:00',3.88),('9303','2013-04-10','15:10:00',3.09),('9303','2013-04-10','15:15:00',3.64),('9303','2013-04-10','15:20:00',3.58),('9303','2013-04-10','15:25:00',3.54),('9303','2013-04-10','15:30:00',3.38),('9303','2013-04-10','15:35:00',3.32),('9303','2013-04-10','15:40:00',2.97),('9303','2013-04-10','15:45:00',3.23),('9303','2013-04-10','15:50:00',3.34),('9303','2013-04-10','15:55:00',2.7),('9303','2013-04-10','16:00:00',3.04),('9303','2013-04-10','16:05:00',1.99),('9303','2013-04-10','16:10:00',2.99),('9303','2013-04-10','16:15:00',2.49),('9303','2013-04-10','16:20:00',2.58),('9303','2013-04-10','16:25:00',2.41),('9303','2013-04-10','16:30:00',2.35),('9303','2013-04-10','16:35:00',1.18),('9303','2013-04-10','16:40:00',2.43),('9303','2013-04-10','16:45:00',2.11),('9303','2013-04-10','16:50:00',2.22),('9303','2013-04-10','16:55:00',1.18),('9303','2013-04-10','17:00:00',2.14),('9303','2013-04-10','17:05:00',1.2),('9303','2013-04-10','17:10:00',1.35),('9303','2013-04-10','17:15:00',1.93),('9303','2013-04-10','17:20:00',1.78),('9303','2013-04-10','17:25:00',1.64),('9303','2013-04-10','17:30:00',1.5),('9303','2013-04-10','17:35:00',1.35),('9303','2013-04-10','17:45:00',1.09),('9303','2013-04-10','17:55:00',1.06),('9303','2013-04-09','08:20:00',1.26),('9303','2013-04-09','09:15:00',1.03),('9303','2013-04-09','09:30:00',1.17),('9303','2013-04-09','09:50:00',2.03),('9303','2013-04-09','09:55:00',3.18),('9303','2013-04-09','10:00:00',1.62),('9303','2013-04-09','10:10:00',1.47),('9303','2013-04-09','10:15:00',2.19),('9303','2013-04-09','10:20:00',1.36),('9303','2013-04-09','10:35:00',2.75),('9303','2013-04-09','10:40:00',2.13),('9303','2013-04-09','10:45:00',2.91),('9303','2013-04-09','10:50:00',4),('9303','2013-04-09','10:55:00',3.04),('9303','2013-04-09','11:00:00',3.45),('9303','2013-04-09','11:05:00',3.32),('9303','2013-04-09','11:10:00',4.03),('9303','2013-04-09','11:15:00',1.71),('9303','2013-04-09','11:25:00',4.2),('9303','2013-04-09','11:30:00',4.04),('9303','2013-04-09','11:35:00',2.99),('9303','2013-04-09','11:45:00',2.75),('9303','2013-04-09','11:50:00',4.52),('9303','2013-04-09','11:55:00',2.21),('9303','2013-04-09','12:00:00',4.51),('9303','2013-04-09','12:05:00',4.31),('9303','2013-04-09','12:10:00',4.33),('9303','2013-04-09','12:15:00',4.37),('9303','2013-04-09','12:20:00',2.78),('9303','2013-04-09','12:25:00',4.27),('9303','2013-04-09','12:30:00',4.19),('9303','2013-04-09','12:35:00',4.01),('9303','2013-04-09','12:40:00',4.35),('9303','2013-04-09','12:45:00',4),('9303','2013-04-09','12:50:00',4.45),('9303','2013-04-09','12:55:00',4.41),('9303','2013-04-09','13:00:00',4.4),('9303','2013-04-09','13:05:00',4.52),('9303','2013-04-09','13:10:00',4.61),('9303','2013-04-09','13:15:00',4.54),('9303','2013-04-09','13:20:00',3.15),('9303','2013-04-09','13:25:00',4.54),('9303','2013-04-09','13:30:00',3.24),('9303','2013-04-09','13:35:00',1.24),('9303','2013-04-09','13:40:00',2.2),('9303','2013-04-09','13:45:00',1.42),('9303','2013-04-09','13:50:00',3.57),('9303','2013-04-09','13:55:00',4.13),('9303','2013-04-09','14:00:00',3.92),('9303','2013-04-09','14:05:00',3.15),('9303','2013-04-09','14:10:00',3.02),('9303','2013-04-09','14:15:00',3.87),('9303','2013-04-09','14:20:00',1.74),('9303','2013-04-09','14:25:00',2.99),('9303','2013-04-09','14:30:00',3.78),('9303','2013-04-09','14:35:00',3.65),('9303','2013-04-09','14:40:00',3.76),('9303','2013-04-09','14:45:00',3.49),('9303','2013-04-09','14:50:00',3.39),('9303','2013-04-09','14:55:00',3.06),('9303','2013-04-09','15:00:00',2.77),('9303','2013-04-09','15:05:00',3.43),('9303','2013-04-09','15:10:00',3.8),('9303','2013-04-09','15:15:00',2.83),('9303','2013-04-09','15:20:00',3.69),('9303','2013-04-09','15:25:00',3.69),('9303','2013-04-09','15:30:00',3.01),('9303','2013-04-09','15:35:00',2.65),('9303','2013-04-09','15:40:00',3.51),('9303','2013-04-09','15:45:00',2.69),('9303','2013-04-09','15:50:00',3.17),('9303','2013-04-09','15:55:00',2.78),('9303','2013-04-09','16:00:00',2.56),('9303','2013-04-09','16:05:00',2.63),('9303','2013-04-09','16:10:00',2.9),('9303','2013-04-09','16:15:00',2.26),('9303','2013-04-09','16:20:00',1.56),('9303','2013-04-09','16:35:00',1.21),('9303','2013-04-09','16:40:00',1.27),('9303','2013-04-09','16:50:00',1.95),('9303','2013-04-09','16:55:00',1.93),('9303','2013-04-09','17:30:00',1.14),('9303','2013-04-08','08:40:00',1.07),('9303','2013-04-08','08:45:00',1.28),('9303','2013-04-08','08:50:00',1.18),('9303','2013-04-08','08:55:00',1.18),('9303','2013-04-08','09:00:00',1.19),('9303','2013-04-08','09:05:00',1.39),('9303','2013-04-08','09:10:00',1.91),('9303','2013-04-08','09:15:00',2.01),('9303','2013-04-08','09:20:00',1.97),('9303','2013-04-08','09:25:00',1.66),('9303','2013-04-08','09:30:00',2.52),('9303','2013-04-08','09:35:00',2.61),('9303','2013-04-08','09:40:00',2.7),('9303','2013-04-08','09:45:00',2.74),('9303','2013-04-08','09:50:00',1.84),('9303','2013-04-08','09:55:00',1.48),('9303','2013-04-08','10:00:00',2.9),('9303','2013-04-08','10:05:00',3.08),('9303','2013-04-08','10:10:00',2.99),('9303','2013-04-08','10:15:00',3.07),('9303','2013-04-08','10:20:00',3.09),('9303','2013-04-08','10:25:00',3.09),('9303','2013-04-08','10:30:00',3.11),('9303','2013-04-08','10:35:00',2.96),('9303','2013-04-08','10:40:00',3.27),('9303','2013-04-08','10:45:00',3.43),('9303','2013-04-08','10:50:00',3.47),('9303','2013-04-08','10:55:00',3.34),('9303','2013-04-08','11:00:00',3.52),('9303','2013-04-08','11:05:00',3.12),('9303','2013-04-08','11:10:00',2.71),('9303','2013-04-08','11:15:00',2.75),('9303','2013-04-08','11:20:00',2.25),('9303','2013-04-08','11:25:00',1.91),('9303','2013-04-08','11:30:00',2.1),('9303','2013-04-08','11:35:00',2.74),('9303','2013-04-08','11:40:00',2.96),('9303','2013-04-08','11:45:00',2.74),('9303','2013-04-08','11:50:00',2.57),('9303','2013-04-08','11:55:00',2.2),('9303','2013-04-08','12:00:00',2.09),('9303','2013-04-08','12:05:00',1.96),('9303','2013-04-08','12:10:00',2.1),('9303','2013-04-08','12:15:00',2.53),('9303','2013-04-08','12:20:00',2.55),('9303','2013-04-08','12:25:00',2.62),('9303','2013-04-08','12:30:00',2.85),('9303','2013-04-08','12:35:00',2.76),('9303','2013-04-08','12:40:00',2.24),('9303','2013-04-08','12:45:00',3.32),('9303','2013-04-08','12:50:00',3.07),('9303','2013-04-08','12:55:00',3.09),('9303','2013-04-08','13:00:00',1.81),('9303','2013-04-08','13:05:00',2.41),('9303','2013-04-08','13:10:00',2.66),('9303','2013-04-08','13:15:00',2.67),('9303','2013-04-08','13:20:00',3.48),('9303','2013-04-08','13:25:00',3.08),('9303','2013-04-08','13:30:00',2.68),('9303','2013-04-08','13:35:00',2.96),('9303','2013-04-08','13:40:00',2.95),('9303','2013-04-08','13:45:00',2.86),('9303','2013-04-08','13:50:00',2.87),('9303','2013-04-08','13:55:00',3.76),('9303','2013-04-08','14:00:00',3.67),('9303','2013-04-08','14:05:00',3.07),('9303','2013-04-08','14:10:00',3.18),('9303','2013-04-08','14:15:00',3.62),('9303','2013-04-08','14:20:00',3.22),('9303','2013-04-08','14:25:00',3.82),('9303','2013-04-08','14:30:00',3.67),('9303','2013-04-08','14:35:00',3.45),('9303','2013-04-08','14:40:00',3.43),('9303','2013-04-08','14:45:00',3.52),('9303','2013-04-08','14:50:00',3.52),('9303','2013-04-08','14:55:00',3.69),('9303','2013-04-08','15:00:00',2.88),('9303','2013-04-08','15:05:00',2.81),('9303','2013-04-08','15:10:00',2.7),('9303','2013-04-08','15:15:00',2.86),('9303','2013-04-08','15:20:00',2.44),('9303','2013-04-08','15:25:00',3.37),('9303','2013-04-08','15:30:00',3.5),('9303','2013-04-08','15:35:00',3.36),('9303','2013-04-08','15:40:00',3.29),('9303','2013-04-08','15:45:00',3.17),('9303','2013-04-08','15:50:00',3.15),('9303','2013-04-08','15:55:00',3.07),('9303','2013-04-08','16:00:00',3),('9303','2013-04-08','16:05:00',2.83),('9303','2013-04-08','16:10:00',2.62),('9303','2013-04-08','16:15:00',2.8),('9303','2013-04-08','16:20:00',2.8),('9303','2013-04-08','16:25:00',2.66),('9303','2013-04-08','16:30:00',2.57),('9303','2013-04-08','16:35:00',2.5),('9303','2013-04-08','16:40:00',2.43),('9303','2013-04-08','16:45:00',2.33),('9303','2013-04-08','16:50:00',2.23),('9303','2013-04-08','16:55:00',2.11),('9303','2013-04-08','17:00:00',2.03),('9303','2013-04-08','17:05:00',1.96),('9303','2013-04-08','17:10:00',1.83),('9303','2013-04-08','17:15:00',1.78),('9303','2013-04-08','17:20:00',1.64),('9303','2013-04-08','17:25:00',1.66),('9303','2013-04-08','17:30:00',1.53),('9303','2013-04-08','17:35:00',1.4),('9303','2013-04-08','17:40:00',1.24),('9303','2013-04-08','17:45:00',1.13),('9303','2013-04-07','08:35:00',1.08),('9303','2013-04-07','08:40:00',1.16),('9303','2013-04-07','08:45:00',1.21),('9303','2013-04-07','08:50:00',1.22),('9303','2013-04-07','08:55:00',1.28),('9303','2013-04-07','09:00:00',1.28),('9303','2013-04-07','09:05:00',1.3),('9303','2013-04-07','09:10:00',1.41),('9303','2013-04-07','09:15:00',1.42),('9303','2013-04-07','09:20:00',1.47),('9303','2013-04-07','09:25:00',1.48),('9303','2013-04-07','09:30:00',1.42),('9303','2013-04-07','09:35:00',1.32),('9303','2013-04-07','09:40:00',1.35),('9303','2013-04-07','09:45:00',1.7),('9303','2013-04-07','09:50:00',1.94),('9303','2013-04-07','09:55:00',2.09),('9303','2013-04-07','10:00:00',2.46),('9303','2013-04-07','10:05:00',2.57),('9303','2013-04-07','10:10:00',2.56),('9303','2013-04-07','10:15:00',2.68),('9303','2013-04-07','10:20:00',2.69),('9303','2013-04-07','10:25:00',2.74),('9303','2013-04-07','10:30:00',2.37),('9303','2013-04-07','10:35:00',2.58),('9303','2013-04-07','10:40:00',2.59),('9303','2013-04-07','10:45:00',2.53),('9303','2013-04-07','10:50:00',2.47),('9303','2013-04-07','10:55:00',2.19),('9303','2013-04-07','11:00:00',2.01),('9303','2013-04-07','11:05:00',1.71),('9303','2013-04-07','11:10:00',1.98),('9303','2013-04-07','11:15:00',2.72),('9303','2013-04-07','11:20:00',3.21),('9303','2013-04-07','11:25:00',3.59),('9303','2013-04-07','11:30:00',3.49),('9303','2013-04-07','11:35:00',3.26),('9303','2013-04-07','11:40:00',2.96),('9303','2013-04-07','11:45:00',2.35),('9303','2013-04-07','11:50:00',2.14),('9303','2013-04-07','11:55:00',2.31),('9303','2013-04-07','12:00:00',2.36),('9303','2013-04-07','12:05:00',2.3),('9303','2013-04-07','12:10:00',2.49),('9303','2013-04-07','12:15:00',2.42),('9303','2013-04-07','12:20:00',2.62),('9303','2013-04-07','12:25:00',2.91),('9303','2013-04-07','12:30:00',2.58),('9303','2013-04-07','12:35:00',2.72),('9303','2013-04-07','12:40:00',2.69),('9303','2013-04-07','12:45:00',2.29),('9303','2013-04-07','12:50:00',2.46),('9303','2013-04-07','12:55:00',2.52),('9303','2013-04-07','13:00:00',2.99),('9303','2013-04-07','13:05:00',3.39),('9303','2013-04-07','13:10:00',3.27),('9303','2013-04-07','13:15:00',2.91),('9303','2013-04-07','13:20:00',2.69),('9303','2013-04-07','13:25:00',3.08),('9303','2013-04-07','13:30:00',3.16),('9303','2013-04-07','13:35:00',2.92),('9303','2013-04-07','13:40:00',3.16),('9303','2013-04-07','13:45:00',3.27),('9303','2013-04-07','13:50:00',2.98),('9303','2013-04-07','13:55:00',2.75),('9303','2013-04-07','14:00:00',3.48),('9303','2013-04-07','14:05:00',3.24),('9303','2013-04-07','14:10:00',2.05),('9303','2013-04-07','14:15:00',2.33),('9303','2013-04-07','14:20:00',2.16),('9303','2013-04-07','14:25:00',2.08),('9303','2013-04-07','14:30:00',1.91),('9303','2013-04-07','14:35:00',2.26),('9303','2013-04-07','14:40:00',1.97),('9303','2013-04-07','14:45:00',1.94),('9303','2013-04-07','14:50:00',2.32),('9303','2013-04-07','14:55:00',2.15),('9303','2013-04-07','15:00:00',2.13),('9303','2013-04-07','15:05:00',2.77),('9303','2013-04-07','15:10:00',2.74),('9303','2013-04-07','15:15:00',2.79),('9303','2013-04-07','15:20:00',2.77),('9303','2013-04-07','15:25:00',2.85),('9303','2013-04-07','15:30:00',2.86),('9303','2013-04-07','15:35:00',2.83),('9303','2013-04-07','15:40:00',2.74),('9303','2013-04-07','15:45:00',2.56),('9303','2013-04-07','15:50:00',2.38),('9303','2013-04-07','15:55:00',2.36),('9303','2013-04-07','16:00:00',2.29),('9303','2013-04-07','16:05:00',1.98),('9303','2013-04-07','16:10:00',1.66),('9303','2013-04-07','16:15:00',1.48),('9303','2013-04-07','16:20:00',1.43),('9303','2013-04-07','16:25:00',1.27),('9303','2013-04-07','16:30:00',1.32),('9303','2013-04-07','16:35:00',1.57),('9303','2013-04-07','16:40:00',1.65),('9303','2013-04-07','16:45:00',1.98),('9303','2013-04-07','16:50:00',2.03),('9303','2013-04-07','16:55:00',1.96),('9303','2013-04-07','17:00:00',1.77),('9303','2013-04-07','17:05:00',1.59),('9303','2013-04-07','17:20:00',1.58),('9303','2013-04-07','17:25:00',1.73),('9303','2013-04-07','17:30:00',1.6),('9303','2013-04-07','17:35:00',1.49),('9303','2013-04-07','17:40:00',1.48),('9303','2013-04-07','17:45:00',1.38),('9303','2013-04-07','17:50:00',1.24),('9303','2013-04-07','17:55:00',1),('9303','2013-04-06','08:20:00',1.07),('9303','2013-04-06','08:25:00',1.17),('9303','2013-04-06','08:30:00',1.26),('9303','2013-04-06','08:35:00',1.36),('9303','2013-04-06','08:40:00',1.47),('9303','2013-04-06','08:45:00',1.54),('9303','2013-04-06','08:50:00',1.65),('9303','2013-04-06','08:55:00',1.76),('9303','2013-04-06','09:00:00',1.83),('9303','2013-04-06','09:05:00',1.92),('9303','2013-04-06','09:10:00',1.99),('9303','2013-04-06','09:15:00',2.08),('9303','2013-04-06','09:20:00',2.18),('9303','2013-04-06','09:25:00',2.25),('9303','2013-04-06','09:30:00',2.33),('9303','2013-04-06','09:35:00',2.34),('9303','2013-04-06','09:40:00',2.46),('9303','2013-04-06','09:45:00',2.54),('9303','2013-04-06','09:50:00',2.59),('9303','2013-04-06','09:55:00',2.68),('9303','2013-04-06','10:00:00',2.73),('9303','2013-04-06','10:05:00',2.82),('9303','2013-04-06','10:10:00',2.84),('9303','2013-04-06','10:15:00',2.94),('9303','2013-04-06','10:20:00',3.01),('9303','2013-04-06','10:25:00',3.03),('9303','2013-04-06','10:30:00',3.07),('9303','2013-04-06','10:35:00',3.14),('9303','2013-04-06','10:40:00',3.17),('9303','2013-04-06','10:45:00',3.21),('9303','2013-04-06','10:50:00',3.27),('9303','2013-04-06','10:55:00',3.31),('9303','2013-04-06','11:00:00',3.39),('9303','2013-04-06','11:05:00',3.42),('9303','2013-04-06','11:10:00',2.95),('9303','2013-04-06','11:15:00',3.52),('9303','2013-04-06','11:20:00',3.2),('9303','2013-04-06','11:25:00',3.6),('9303','2013-04-06','11:30:00',3.6),('9303','2013-04-06','11:35:00',3.64),('9303','2013-04-06','11:40:00',3.67),('9303','2013-04-06','11:45:00',3.7),('9303','2013-04-06','11:50:00',3.72),('9303','2013-04-06','11:55:00',3.77),('9303','2013-04-06','12:00:00',3.74),('9303','2013-04-06','12:05:00',3.77),('9303','2013-04-06','12:10:00',3.79),('9303','2013-04-06','12:15:00',3.86),('9303','2013-04-06','12:20:00',3.77),('9303','2013-04-06','12:25:00',3.8),('9303','2013-04-06','12:30:00',3.97),('9303','2013-04-06','12:35:00',4.02),('9303','2013-04-06','12:40:00',4),('9303','2013-04-06','12:45:00',4.02),('9303','2013-04-06','12:50:00',3.99),('9303','2013-04-06','12:55:00',4.01),('9303','2013-04-06','13:00:00',4.06),('9303','2013-04-06','13:05:00',3.58),('9303','2013-04-06','13:10:00',3.21),('9303','2013-04-06','13:15:00',4.3),('9303','2013-04-06','13:20:00',2.27),('9303','2013-04-06','13:30:00',2.29),('9303','2013-04-06','13:35:00',4.39),('9303','2013-04-06','13:40:00',4.6),('9303','2013-04-06','13:45:00',4.57),('9303','2013-04-06','13:50:00',4.29),('9303','2013-04-06','13:55:00',2.75),('9303','2013-04-06','14:00:00',1.04),('9303','2013-04-06','14:05:00',1.94),('9303','2013-04-06','14:10:00',1.05),('9303','2013-04-06','14:15:00',4.21),('9303','2013-04-06','14:20:00',2.68),('9303','2013-04-06','14:25:00',1.51),('9303','2013-04-06','14:30:00',2.62),('9303','2013-04-06','14:35:00',2.41),('9303','2013-04-06','14:40:00',3.98),('9303','2013-04-06','14:45:00',3.79),('9303','2013-04-06','14:50:00',3.72),('9303','2013-04-06','14:55:00',3.82),('9303','2013-04-06','15:00:00',3.7),('9303','2013-04-06','15:05:00',3.62),('9303','2013-04-06','15:10:00',3.4),('9303','2013-04-06','15:15:00',3.4),('9303','2013-04-06','15:20:00',3.36),('9303','2013-04-06','15:25:00',3.32),('9303','2013-04-06','15:30:00',3.15),('9303','2013-04-06','15:35:00',3.13),('9303','2013-04-06','15:40:00',3.11),('9303','2013-04-06','15:45:00',2.81),('9303','2013-04-06','15:50:00',2.81),('9303','2013-04-06','15:55:00',3),('9303','2013-04-06','16:00:00',2.74),('9303','2013-04-06','16:05:00',2.91),('9303','2013-04-06','16:10:00',2.86),('9303','2013-04-06','16:15:00',2.63),('9303','2013-04-06','16:20:00',2.15),('9303','2013-04-06','16:25:00',1.76),('9303','2013-04-06','16:30:00',2.16),('9303','2013-04-06','16:35:00',2.09),('9303','2013-04-06','16:40:00',1.65),('9303','2013-04-06','16:45:00',2.17),('9303','2013-04-06','16:50:00',2.03),('9303','2013-04-06','16:55:00',1.8),('9303','2013-04-06','17:00:00',1.78),('9303','2013-04-06','17:05:00',1.56),('9303','2013-04-06','17:10:00',1.32),('9303','2013-04-06','17:15:00',1.03),('9303','2013-04-05','08:20:00',1.14),('9303','2013-04-05','08:55:00',1.16),('9303','2013-04-05','09:05:00',2.27),('9303','2013-04-05','09:10:00',1.13),('9303','2013-04-05','09:15:00',2.35),('9303','2013-04-05','09:20:00',2.02),('9303','2013-04-05','09:35:00',1.13),('9303','2013-04-05','09:40:00',2.26),('9303','2013-04-05','09:45:00',2.02),('9303','2013-04-05','09:50:00',1.14),('9303','2013-04-05','10:00:00',1.22),('9303','2013-04-05','10:10:00',2.25),('9303','2013-04-05','10:15:00',3.18),('9303','2013-04-05','10:20:00',1.31),('9303','2013-04-05','10:25:00',2.63),('9303','2013-04-05','10:30:00',2.43),('9303','2013-04-05','10:35:00',2.16),('9303','2013-04-05','10:40:00',3.83),('9303','2013-04-05','10:45:00',1.93),('9303','2013-04-05','10:50:00',1.73),('9303','2013-04-05','10:55:00',2.69),('9303','2013-04-05','11:00:00',2.63),('9303','2013-04-05','11:05:00',3.07),('9303','2013-04-05','11:10:00',3.58),('9303','2013-04-05','11:15:00',3.7),('9303','2013-04-05','11:20:00',2.97),('9303','2013-04-05','11:25:00',2.99),('9303','2013-04-05','11:30:00',3.08),('9303','2013-04-05','11:35:00',3.16),('9303','2013-04-05','11:40:00',3.63),('9303','2013-04-05','11:45:00',3.23),('9303','2013-04-05','11:50:00',3.34),('9303','2013-04-05','11:55:00',3.62),('9303','2013-04-05','12:00:00',4),('9303','2013-04-05','12:05:00',3.31),('9303','2013-04-05','12:10:00',2.62),('9303','2013-04-05','12:15:00',1.8),('9303','2013-04-05','12:20:00',1.38),('9303','2013-04-05','12:25:00',2.02),('9303','2013-04-05','12:30:00',1.17),('9303','2013-04-05','12:35:00',1.19),('9303','2013-04-05','12:40:00',1.52),('9303','2013-04-05','12:45:00',3.2),('9303','2013-04-05','12:50:00',4.22),('9303','2013-04-05','12:55:00',4.49),('9303','2013-04-05','13:00:00',2.68),('9303','2013-04-05','13:05:00',3.92),('9303','2013-04-05','13:10:00',2.11),('9303','2013-04-05','13:15:00',2.59),('9303','2013-04-05','13:20:00',2.42),('9303','2013-04-05','13:25:00',2.82),('9303','2013-04-05','13:30:00',2.89),('9303','2013-04-05','13:35:00',3.04),('9303','2013-04-05','13:40:00',4.12),('9303','2013-04-05','13:45:00',3.03),('9303','2013-04-05','13:50:00',4.52),('9303','2013-04-05','13:55:00',3.68),('9303','2013-04-05','14:00:00',2.61),('9303','2013-04-05','14:05:00',4.55),('9303','2013-04-05','14:10:00',3.48),('9303','2013-04-05','14:15:00',3.64),('9303','2013-04-05','14:20:00',4.07),('9303','2013-04-05','14:25:00',3.52),('9303','2013-04-05','14:30:00',3.86),('9303','2013-04-05','14:35:00',4.03),('9303','2013-04-05','14:40:00',4.11),('9303','2013-04-05','14:45:00',3.31),('9303','2013-04-05','14:50:00',2.09),('9303','2013-04-05','14:55:00',4.15),('9303','2013-04-05','15:00:00',3.37),('9303','2013-04-05','15:05:00',3.44),('9303','2013-04-05','15:10:00',2.66),('9303','2013-04-05','15:15:00',1.54),('9303','2013-04-05','15:20:00',1.6),('9303','2013-04-05','15:25:00',1.79),('9303','2013-04-05','15:30:00',1.55),('9303','2013-04-05','15:35:00',1.27),('9303','2013-04-05','15:40:00',1.04),('9303','2013-04-05','15:45:00',1.29),('9303','2013-04-05','15:50:00',1.61),('9303','2013-04-05','15:55:00',1.51),('9303','2013-04-05','16:00:00',1.62),('9303','2013-04-05','16:05:00',1.48),('9303','2013-04-05','16:10:00',1.42),('9303','2013-04-05','16:15:00',2.08),('9303','2013-04-05','16:20:00',1.8),('9303','2013-04-05','16:25:00',1.51),('9303','2013-04-05','16:30:00',1.39),('9303','2013-04-05','16:35:00',1.54),('9303','2013-04-05','16:40:00',1.36),('9303','2013-04-05','16:45:00',2.03),('9303','2013-04-05','16:50:00',2.65),('9303','2013-04-05','16:55:00',1.44),('9303','2013-04-05','17:00:00',1.42),('9303','2013-04-05','17:05:00',1.02),('9303','2013-04-05','17:10:00',1.75),('9303','2013-04-05','17:15:00',1.5),('9303','2013-04-05','17:20:00',1.21),('9303','2013-04-05','17:25:00',1.04),('9303','2013-04-05','17:30:00',1.87),('9303','2013-04-05','17:35:00',1.16),('9303','2013-04-05','17:55:00',1.37),('9303','2013-04-05','18:00:00',1.15),('9303','2013-04-04','08:55:00',1.19),('9303','2013-04-04','09:00:00',1.82),('9303','2013-04-04','09:05:00',1.32),('9303','2013-04-04','09:10:00',1.17),('9303','2013-04-04','09:15:00',1.12),('9303','2013-04-04','09:20:00',1.25),('9303','2013-04-04','09:30:00',1.38),('9303','2013-04-04','09:35:00',2.33),('9303','2013-04-04','09:40:00',2.19),('9303','2013-04-04','09:45:00',1.87),('9303','2013-04-04','09:50:00',1.03),('9303','2013-04-04','09:55:00',1.1),('9303','2013-04-04','10:00:00',1.67),('9303','2013-04-04','10:05:00',2.28),('9303','2013-04-04','10:10:00',2.11),('9303','2013-04-04','10:15:00',1.49),('9303','2013-04-04','10:20:00',1.53),('9303','2013-04-04','10:25:00',2.99),('9303','2013-04-04','10:30:00',3.02),('9303','2013-04-04','10:35:00',1.85),('9303','2013-04-04','10:40:00',3.68),('9303','2013-04-04','10:45:00',2.01),('9303','2013-04-04','10:50:00',2.26),('9303','2013-04-04','10:55:00',3.39),('9303','2013-04-04','11:00:00',2.01),('9303','2013-04-04','11:05:00',1.12),('9303','2013-04-04','11:15:00',1.31),('9303','2013-04-04','11:20:00',1.27),('9303','2013-04-04','11:30:00',1.05),('9303','2013-04-04','11:35:00',1.5),('9303','2013-04-04','11:40:00',2.62),('9303','2013-04-04','11:45:00',3.21),('9303','2013-04-04','11:50:00',3.66),('9303','2013-04-04','11:55:00',3.87),('9303','2013-04-04','12:00:00',3.88),('9303','2013-04-04','12:05:00',3.76),('9303','2013-04-04','12:10:00',3.81),('9303','2013-04-04','12:15:00',3.72),('9303','2013-04-04','12:20:00',3.33),('9303','2013-04-04','12:25:00',2.94),('9303','2013-04-04','12:30:00',3.04),('9303','2013-04-04','12:35:00',1.96),('9303','2013-04-04','12:40:00',3.86),('9303','2013-04-04','12:45:00',3),('9303','2013-04-04','12:50:00',3.97),('9303','2013-04-04','12:55:00',3.67),('9303','2013-04-04','13:00:00',3.63),('9303','2013-04-04','13:05:00',3.7),('9303','2013-04-04','13:10:00',3.83),('9303','2013-04-04','13:15:00',3.98),('9303','2013-04-04','13:20:00',3.86),('9303','2013-04-04','13:25:00',3.97),('9303','2013-04-04','13:30:00',3.89),('9303','2013-04-04','13:35:00',3.59),('9303','2013-04-04','13:40:00',3.05),('9303','2013-04-04','13:45:00',3.1),('9303','2013-04-04','13:50:00',2.99),('9303','2013-04-04','13:55:00',2.31),('9303','2013-04-04','14:00:00',2.42),('9303','2013-04-04','14:05:00',3.2),('9303','2013-04-04','14:10:00',3.73),('9303','2013-04-04','14:15:00',3.71),('9303','2013-04-04','14:20:00',3.65),('9303','2013-04-04','14:25:00',3.59),('9303','2013-04-04','14:30:00',3.57),('9303','2013-04-04','14:35:00',3.53),('9303','2013-04-04','14:40:00',3.54),('9303','2013-04-04','14:45:00',3.51),('9303','2013-04-04','14:50:00',3.46),('9303','2013-04-04','14:55:00',3.43),('9303','2013-04-04','15:00:00',3.36),('9303','2013-04-04','15:05:00',3.26),('9303','2013-04-04','15:10:00',3.11),('9303','2013-04-04','15:15:00',3.06),('9303','2013-04-04','15:20:00',3.13),('9303','2013-04-04','15:25:00',3.14),('9303','2013-04-04','15:30:00',3.12),('9303','2013-04-04','15:35:00',3.04),('9303','2013-04-04','15:40:00',2.95),('9303','2013-04-04','15:45:00',2.91),('9303','2013-04-04','15:50:00',2.79),('9303','2013-04-04','15:55:00',2.74),('9303','2013-04-04','16:00:00',2.69),('9303','2013-04-04','16:05:00',2.61),('9303','2013-04-04','16:10:00',2.45),('9303','2013-04-04','16:15:00',2.35),('9303','2013-04-04','16:20:00',2.18),('9303','2013-04-04','16:25:00',2.15),('9303','2013-04-04','16:30:00',1.67),('9303','2013-04-04','16:35:00',1.78),('9303','2013-04-04','16:40:00',1.73),('9303','2013-04-04','16:45:00',1.63),('9303','2013-04-04','16:50:00',1.4),('9303','2013-04-04','16:55:00',1.67),('9303','2013-04-04','17:00:00',1.53),('9303','2013-04-04','17:05:00',1.51),('9303','2013-04-04','17:10:00',1.44),('9303','2013-04-04','17:15:00',1.27),('9303','2013-04-03','08:20:00',1.01),('9303','2013-04-03','08:25:00',1.14),('9303','2013-04-03','08:30:00',1.35),('9303','2013-04-03','08:35:00',1.58),('9303','2013-04-03','08:40:00',1.28),('9303','2013-04-03','08:45:00',1.54),('9303','2013-04-03','08:55:00',1.41),('9303','2013-04-03','09:00:00',1.76),('9303','2013-04-03','09:05:00',1.69),('9303','2013-04-03','09:10:00',2.19),('9303','2013-04-03','09:15:00',2.32),('9303','2013-04-03','09:20:00',1.81),('9303','2013-04-03','09:25:00',1.35),('9303','2013-04-03','09:30:00',2.04),('9303','2013-04-03','09:35:00',2.16),('9303','2013-04-03','09:40:00',2.6),('9303','2013-04-03','09:47:00',2.29),('9303','2013-04-03','09:50:00',3.05),('9303','2013-04-03','09:55:00',3.22),('9303','2013-04-03','10:00:00',3.03),('9303','2013-04-03','10:05:00',1.13),('9303','2013-04-03','10:10:00',1.19),('9303','2013-04-03','10:15:00',1.48),('9303','2013-04-03','10:20:00',3.12),('9303','2013-04-03','10:25:00',3.07),('9303','2013-04-03','10:30:00',2.39),('9303','2013-04-03','10:35:00',2.07),('9303','2013-04-03','10:40:00',1.64),('9303','2013-04-03','10:45:00',1.4),('9303','2013-04-03','10:50:00',1.84),('9303','2013-04-03','10:55:00',2.67),('9303','2013-04-03','11:00:00',2.41),('9303','2013-04-03','11:05:00',4.66),('9303','2013-04-03','11:10:00',1.87),('9303','2013-04-03','11:15:00',2.97),('9303','2013-04-03','11:20:00',2.73),('9303','2013-04-03','11:25:00',2.35),('9303','2013-04-03','11:30:00',1.57),('9303','2013-04-03','11:35:00',1.58),('9303','2013-04-03','11:40:00',1.87),('9303','2013-04-03','11:45:00',1.38),('9303','2013-04-03','11:50:00',2.81),('9303','2013-04-03','11:55:00',2.15),('9303','2013-04-03','12:00:00',3.73),('9303','2013-04-03','12:05:00',3.58),('9303','2013-04-03','12:10:00',3.11),('9303','2013-04-03','12:15:00',2.05),('9303','2013-04-03','12:20:00',3.57),('9303','2013-04-03','12:25:00',3.44),('9303','2013-04-03','12:30:00',3.28),('9303','2013-04-03','12:35:00',3.59),('9303','2013-04-03','12:40:00',3.23),('9303','2013-04-03','12:45:00',3.6),('9303','2013-04-03','12:50:00',4.69),('9303','2013-04-03','12:55:00',3.57),('9303','2013-04-03','13:00:00',3.87),('9303','2013-04-03','13:05:00',3.38),('9303','2013-04-03','13:10:00',2.39),('9303','2013-04-03','13:15:00',4.28),('9303','2013-04-03','13:20:00',3.04),('9303','2013-04-03','13:25:00',2.56),('9303','2013-04-03','13:30:00',2.34),('9303','2013-04-03','13:35:00',3.62),('9303','2013-04-03','13:40:00',3.42),('9303','2013-04-03','13:45:00',3.64),('9303','2013-04-03','13:50:00',2.94),('9303','2013-04-03','13:55:00',3.84),('9303','2013-04-03','14:00:00',4.29),('9303','2013-04-03','14:05:00',3.55),('9303','2013-04-03','14:10:00',2.64),('9303','2013-04-03','14:15:00',3.14),('9303','2013-04-03','14:20:00',1.98),('9303','2013-04-03','14:25:00',3.34),('9303','2013-04-03','14:30:00',3.58),('9303','2013-04-03','14:35:00',3.87),('9303','2013-04-03','14:40:00',3.83),('9303','2013-04-03','14:45:00',3.34),('9303','2013-04-03','14:50:00',1.54),('9303','2013-04-03','14:55:00',2.72),('9303','2013-04-03','15:00:00',4.09),('9303','2013-04-03','15:05:00',4.09),('9303','2013-04-03','15:10:00',3.86),('9303','2013-04-03','15:15:00',4),('9303','2013-04-03','15:20:00',3.77),('9303','2013-04-03','15:25:00',3.85),('9303','2013-04-03','15:30:00',3.61),('9303','2013-04-03','15:35:00',3.44),('9303','2013-04-03','15:40:00',3.72),('9303','2013-04-03','15:45:00',3.09),('9303','2013-04-03','15:50:00',3.35),('9303','2013-04-03','15:55:00',3.12),('9303','2013-04-03','16:00:00',3.37),('9303','2013-04-03','16:05:00',3.19),('9303','2013-04-03','16:10:00',3.07),('9303','2013-04-03','16:15:00',3.04),('9303','2013-04-03','16:20:00',2.95),('9303','2013-04-03','16:25:00',2.88),('9303','2013-04-03','16:30:00',2.66),('9303','2013-04-03','16:35:00',2.46),('9303','2013-04-03','16:40:00',2.62),('9303','2013-04-03','16:45:00',2.45),('9303','2013-04-03','16:50:00',2.33),('9303','2013-04-03','16:55:00',2.24),('9303','2013-04-03','17:00:00',2.16),('9303','2013-04-03','17:05:00',2.06),('9303','2013-04-03','17:10:00',1.97),('9303','2013-04-03','17:15:00',1.89),('9303','2013-04-03','17:20:00',1.78),('9303','2013-04-03','17:25:00',1.7),('9303','2013-04-03','17:30:00',1.57),('9303','2013-04-03','17:35:00',1.49),('9303','2013-04-03','17:40:00',1.38),('9303','2013-04-03','17:45:00',1.27),('9303','2013-04-03','17:50:00',1.18),('9303','2013-04-03','17:55:00',1.06),('9303','2013-04-02','08:40:00',1.45),('9303','2013-04-02','08:45:00',1.64),('9303','2013-04-02','08:50:00',1.48),('9303','2013-04-02','09:00:00',1.85),('9303','2013-04-02','09:05:00',1.92),('9303','2013-04-02','09:10:00',2.05),('9303','2013-04-02','09:15:00',1.89),('9303','2013-04-02','09:20:00',1.96),('9303','2013-04-02','09:30:00',2.17),('9303','2013-04-02','09:35:00',2.62),('9303','2013-04-02','09:40:00',2.26),('9303','2013-04-02','09:45:00',2.47),('9303','2013-04-02','09:50:00',2.19),('9303','2013-04-02','09:55:00',1.63),('9303','2013-04-02','10:00:00',2.17),('9303','2013-04-02','10:05:00',1.01),('9303','2013-04-02','10:10:00',1.32),('9303','2013-04-02','10:15:00',1.19),('9303','2013-04-02','10:20:00',1.84),('9303','2013-04-02','10:25:00',1.6),('9303','2013-04-02','10:35:00',2.09),('9303','2013-04-02','10:40:00',1.97),('9303','2013-04-02','10:45:00',2.67),('9303','2013-04-02','10:50:00',3.86),('9303','2013-04-02','10:55:00',1.56),('9303','2013-04-02','11:05:00',3.1),('9303','2013-04-02','11:10:00',1.82),('9303','2013-04-02','11:35:00',1.49),('9303','2013-04-02','11:45:00',1.9),('9303','2013-04-02','11:50:00',1.91),('9303','2013-04-02','11:55:00',1.29),('9303','2013-04-02','12:05:00',2.2),('9303','2013-04-02','12:10:00',1.68),('9303','2013-04-02','12:15:00',2.23),('9303','2013-04-02','12:35:00',1.52),('9303','2013-04-02','12:40:00',2.03),('9303','2013-04-02','12:45:00',1.91),('9303','2013-04-02','12:50:00',2.2),('9303','2013-04-02','12:55:00',2.18),('9303','2013-04-02','13:00:00',2.06),('9303','2013-04-02','13:05:00',2.33),('9303','2013-04-02','13:10:00',3.15),('9303','2013-04-02','13:15:00',2.39),('9303','2013-04-02','13:20:00',1.85),('9303','2013-04-02','13:25:00',3.08),('9303','2013-04-02','13:30:00',2.59),('9303','2013-04-02','13:35:00',1.8),('9303','2013-04-02','13:40:00',2.49),('9303','2013-04-02','13:45:00',2.4),('9303','2013-04-02','13:50:00',2.15),('9303','2013-04-02','13:55:00',1.54),('9303','2013-04-02','14:00:00',2.43),('9303','2013-04-02','14:05:00',2.02),('9303','2013-04-02','14:10:00',2.38),('9303','2013-04-02','14:15:00',2.14),('9303','2013-04-02','14:20:00',3.97),('9303','2013-04-02','14:25:00',4.48),('9303','2013-04-02','14:30:00',2.73),('9303','2013-04-02','14:35:00',1.73),('9303','2013-04-02','14:40:00',2.13),('9303','2013-04-02','14:45:00',2.34),('9303','2013-04-02','14:50:00',2.08),('9303','2013-04-02','14:55:00',1.61),('9303','2013-04-02','15:00:00',1.56),('9303','2013-04-02','15:45:00',1.02),('9303','2013-04-02','16:05:00',1.08),('9303','2013-04-02','16:20:00',1),('9303','2014-05-02','07:50:00',1.02),('9303','2014-05-02','07:55:00',1.03),('9303','2014-05-02','08:00:00',1.4),('9303','2014-05-02','08:05:00',1.43),('9303','2014-05-02','08:15:00',1.25),('9303','2014-05-02','08:20:00',2.3),('9303','2014-05-02','08:25:00',1.14),('9303','2014-05-02','08:50:00',1.1),('9303','2014-05-02','09:15:00',1.05),('9303','2014-05-02','09:20:00',1.29),('9303','2014-05-02','09:25:00',1.48),('9303','2014-05-02','09:30:00',1.91),('9303','2014-05-02','09:35:00',1.72),('9303','2014-05-02','09:40:00',1.44),('9303','2014-05-02','09:45:00',1.47),('9303','2014-05-02','09:50:00',1.53),('9303','2014-05-02','09:55:00',1.36),('9303','2014-05-02','10:00:00',1.78),('9303','2014-05-02','10:05:00',1.69),('9303','2014-05-02','10:10:00',1.84),('9303','2014-05-02','10:15:00',1.51),('9303','2014-05-02','10:20:00',1.47),('9303','2014-05-02','10:25:00',1.11),('9303','2014-05-02','10:45:00',1.09),('9303','2014-05-02','10:50:00',1.15),('9303','2014-05-02','12:35:00',1.17),('9303','2014-05-02','12:40:00',1.07),('9303','2014-05-02','12:45:00',1.2),('9303','2014-05-02','12:50:00',1.63),('9303','2014-05-02','12:55:00',1.5),('9303','2014-05-02','13:00:00',1.31),('9303','2014-05-02','13:05:00',1.54),('9303','2014-05-02','13:10:00',1.76),('9303','2014-05-02','13:15:00',2.06),('9303','2014-05-02','13:20:00',3.1),('9303','2014-05-02','13:25:00',2.92),('9303','2014-05-02','13:30:00',2.31),('9303','2014-05-02','13:35:00',2.52),('9303','2014-05-02','13:40:00',2.5),('9303','2014-05-02','13:45:00',1.97),('9303','2014-05-02','13:50:00',1.53),('9303','2014-05-02','13:55:00',1.24),('9303','2014-05-02','14:00:00',1.3),('9303','2014-05-02','14:05:00',1.41),('9303','2014-05-02','14:10:00',1.41),('9303','2014-05-02','14:35:00',1.2),('9303','2014-05-02','14:40:00',3.15),('9303','2014-05-02','14:45:00',1.9),('9303','2014-05-02','14:50:00',1.3),('9303','2014-05-02','14:55:00',1.72),('9303','2014-05-02','15:00:00',2.16),('9303','2014-05-02','15:05:00',1.89),('9303','2014-05-02','15:10:00',3.56),('9303','2014-05-02','15:15:00',3.57),('9303','2014-05-02','15:20:00',1.93),('9303','2014-05-02','15:25:00',2.18),('9303','2014-05-02','15:30:00',1.13),('9303','2014-05-02','15:35:00',2.29),('9303','2014-05-02','15:40:00',3.54),('9303','2014-05-02','15:45:00',1.23),('9303','2014-05-02','16:00:00',1.16),('9303','2014-05-02','16:05:00',1.83),('9303','2014-05-02','16:10:00',1.08),('9303','2014-05-02','16:20:00',2.73),('9303','2014-05-02','17:25:00',1.11),('9303','2014-03-27','07:55:00',1.02),('9303','2014-03-27','08:00:00',1.24),('9303','2014-03-27','08:05:00',1.31),('9303','2014-03-27','10:10:00',1.24),('9303','2014-03-27','10:15:00',1.03),('9303','2014-03-27','10:20:00',1.46),('9303','2014-03-27','10:25:00',1.88),('9303','2014-03-27','10:30:00',1.96),('9303','2014-03-27','10:35:00',1.63),('9303','2014-03-27','10:40:00',2.11),('9303','2014-03-27','10:45:00',1.34),('9303','2014-03-27','11:10:00',2.49),('9303','2014-03-27','11:15:00',2.64),('9303','2014-03-27','11:20:00',1.69),('9303','2014-03-27','11:55:00',1.19),('9303','2014-03-27','12:00:00',1.17),('9303','2014-03-27','12:10:00',1.36),('9303','2014-03-27','12:15:00',1),('9303','2014-03-27','13:10:00',1.36),('9303','2014-03-27','13:15:00',1.98),('9303','2014-03-27','13:20:00',2.15),('9303','2014-03-27','13:25:00',2.34),('9303','2014-03-27','13:30:00',2.02),('9303','2014-03-27','13:35:00',1.81),('9303','2014-03-27','13:40:00',1.71),('9303','2014-03-27','13:45:00',1.55),('9303','2014-03-27','13:50:00',1.88),('9303','2014-03-27','13:55:00',2.62),('9303','2014-03-27','14:00:00',1.98),('9303','2014-03-27','14:05:00',1.13),('9303','2014-03-27','14:15:00',1.81),('9303','2014-03-27','14:20:00',3.5),('9303','2014-03-27','14:25:00',3.22),('9303','2014-03-27','14:30:00',3.81),('9303','2014-03-27','14:35:00',2.06),('9303','2014-03-27','14:40:00',1.71),('9303','2014-03-27','14:45:00',1.56),('9303','2014-03-27','14:50:00',2.27),('9303','2014-03-27','14:55:00',1.91),('9303','2014-03-27','15:00:00',3.41),('9303','2014-03-27','15:05:00',1.73),('9303','2014-03-27','15:25:00',2.08),('9303','2014-03-27','15:30:00',2.56),('9303','2014-03-27','15:35:00',1.87),('9303','2014-03-27','15:40:00',1.02),('9303','2014-03-27','16:10:00',1.06),('9303','2014-03-27','16:15:00',1.06),('9303','2013-04-01','08:30:00',1.14),('9303','2013-04-01','08:35:00',1.39),('9303','2013-04-01','08:40:00',1.6),('9303','2013-04-01','08:50:00',1.06),('9303','2013-04-01','08:55:00',1.46),('9303','2013-04-01','09:00:00',1.83),('9303','2013-04-01','09:05:00',1.96),('9303','2013-04-01','09:10:00',2.12),('9303','2013-04-01','09:15:00',2.15),('9303','2013-04-01','09:20:00',1.52),('9303','2013-04-01','09:25:00',2.02),('9303','2013-04-01','09:30:00',2.48),('9303','2013-04-01','09:35:00',1.36),('9303','2013-04-01','09:40:00',2.38),('9303','2013-04-01','09:45:00',1.57),('9303','2013-04-01','09:50:00',2.72),('9303','2013-04-01','09:55:00',2.58),('9303','2013-04-01','10:00:00',2.79),('9303','2013-04-01','10:05:00',2.95),('9303','2013-04-01','10:10:00',2.27),('9303','2013-04-01','10:15:00',2.51),('9303','2013-04-01','10:20:00',2.4),('9303','2013-04-01','10:25:00',2.51),('9303','2013-04-01','10:30:00',2.12),('9303','2013-04-01','10:35:00',1.56),('9303','2013-04-01','10:40:00',1.99),('9303','2013-04-01','10:45:00',3.47),('9303','2013-04-01','10:50:00',2.52),('9303','2013-04-01','11:00:00',1.66),('9303','2013-04-01','11:05:00',1.21),('9303','2013-04-01','11:10:00',2.15),('9303','2013-04-01','11:15:00',3.4),('9303','2013-04-01','11:20:00',2.52),('9303','2013-04-01','11:25:00',2.24),('9303','2013-04-01','11:30:00',1.42),('9303','2013-04-01','11:35:00',1.71),('9303','2013-04-01','11:40:00',2.5),('9303','2013-04-01','11:45:00',3.01),('9303','2013-04-01','11:50:00',2.44),('9303','2013-04-01','11:55:00',2.05),('9303','2013-04-01','12:00:00',2.84),('9303','2013-04-01','12:05:00',1.76),('9303','2013-04-01','12:10:00',2.09),('9303','2013-04-01','12:15:00',1.91),('9303','2013-04-01','12:20:00',1.55),('9303','2013-04-01','12:25:00',1.68),('9303','2013-04-01','12:30:00',2.37),('9303','2013-04-01','12:35:00',2.2),('9303','2013-04-01','12:40:00',2.19),('9303','2013-04-01','12:45:00',2.47),('9303','2013-04-01','12:50:00',2.61),('9303','2013-04-01','12:55:00',2.9),('9303','2013-04-01','13:00:00',2.77),('9303','2013-04-01','13:05:00',3.05),('9303','2013-04-01','13:10:00',2.83),('9303','2013-04-01','13:15:00',2.75),('9303','2013-04-01','13:20:00',2.66),('9303','2013-04-01','13:25:00',2.47),('9303','2013-04-01','13:30:00',2.91),('9303','2013-04-01','13:35:00',2.47),('9303','2013-04-01','13:40:00',3.03),('9303','2013-04-01','13:45:00',3.45),('9303','2013-04-01','13:50:00',3.93),('9303','2013-04-01','13:55:00',4.12),('9303','2013-04-01','14:00:00',2.21),('9303','2013-04-01','14:05:00',1.67),('9303','2013-04-01','14:10:00',2.12),('9303','2013-04-01','14:15:00',2.41),('9303','2013-04-01','14:20:00',2.45),('9303','2013-04-01','14:25:00',4.01),('9303','2013-04-01','14:30:00',2.85),('9303','2013-04-01','14:35:00',2.12),('9303','2013-04-01','14:40:00',1.91),('9303','2013-04-01','14:45:00',1.81),('9303','2013-04-01','14:50:00',1.96),('9303','2013-04-01','14:55:00',2.12),('9303','2013-04-01','15:00:00',1.86),('9303','2013-04-01','15:05:00',1.84),('9303','2013-04-01','15:10:00',1.87),('9303','2013-04-01','15:15:00',2.03),('9303','2013-04-01','15:20:00',2.09),('9303','2013-04-01','15:25:00',2.13),('9303','2013-04-01','15:30:00',1.86),('9303','2013-04-01','15:35:00',2.38),('9303','2013-04-01','15:40:00',2.21),('9303','2013-04-01','15:45:00',2.24),('9303','2013-04-01','15:50:00',2.62),('9303','2013-04-01','15:55:00',2.04),('9303','2013-04-01','16:00:00',1.79),('9303','2013-04-01','16:05:00',1.48),('9303','2013-04-01','16:10:00',1.24),('9303','2013-03-31','08:35:00',1.03),('9303','2013-03-31','08:45:00',1.22),('9303','2013-03-31','08:55:00',1.13),('9303','2013-03-31','09:00:00',1.01),('9303','2013-03-31','09:15:00',1.03),('9303','2013-03-31','09:20:00',2.15),('9303','2013-03-31','09:25:00',2.7),('9303','2013-03-31','09:30:00',2.35),('9303','2013-03-31','09:35:00',2.2),('9303','2013-03-31','09:40:00',1.44),('9303','2013-03-31','09:45:00',2.65),('9303','2013-03-31','09:50:00',1.53),('9303','2013-03-31','09:55:00',1.79),('9303','2013-03-31','10:00:00',2.32),('9303','2013-03-31','10:20:00',1.96),('9303','2013-03-31','10:25:00',2.66),('9303','2013-03-31','10:30:00',2.3),('9303','2013-03-31','10:35:00',2.62),('9303','2013-03-31','10:50:00',1.93),('9303','2013-03-31','10:55:00',1.09),('9303','2013-03-31','11:10:00',1.22),('9303','2013-03-31','11:15:00',1.17),('9303','2013-03-31','11:20:00',1.03),('9303','2013-03-31','11:25:00',1.41),('9303','2013-03-31','11:30:00',1.09),('9303','2013-03-31','11:35:00',1.42),('9303','2013-03-31','11:40:00',1.57),('9303','2013-03-31','11:45:00',1.39),('9303','2013-03-31','11:50:00',1.44),('9303','2013-03-31','11:55:00',1.48),('9303','2013-03-31','12:00:00',1.4),('9303','2013-03-31','12:05:00',1.31),('9303','2013-03-31','12:10:00',1.16),('9303','2013-03-31','12:15:00',1.14),('9303','2013-03-31','12:20:00',1.17),('9303','2013-03-31','12:25:00',1.27),('9303','2013-03-31','12:30:00',1.63),('9303','2013-03-31','12:35:00',2.54),('9303','2013-03-31','12:40:00',3.39),('9303','2013-03-31','12:45:00',1.71),('9303','2013-03-31','12:50:00',1.53),('9303','2013-03-31','12:55:00',1.78),('9303','2013-03-31','13:00:00',2.17),('9303','2013-03-31','13:05:00',1.75),('9303','2013-03-31','13:10:00',2.54),('9303','2013-03-31','13:15:00',3.01),('9303','2013-03-31','13:20:00',3.81),('9303','2013-03-31','13:25:00',3.12),('9303','2013-03-31','13:40:00',1.15),('9303','2013-03-31','13:45:00',1.77),('9303','2013-03-31','13:50:00',1.77),('9303','2013-03-31','13:55:00',1.34),('9303','2013-03-31','14:00:00',2.14),('9303','2013-03-31','14:05:00',3.16),('9303','2013-03-31','14:10:00',2.15),('9303','2013-03-31','14:15:00',2.61),('9303','2013-03-31','14:20:00',1.92),('9303','2013-03-31','14:25:00',1.65),('9303','2013-03-31','14:30:00',1.99),('9303','2013-03-31','14:35:00',3.83),('9303','2013-03-31','14:40:00',4.33),('9303','2013-03-31','14:45:00',3.65),('9303','2013-03-31','14:50:00',3.57),('9303','2013-03-31','14:55:00',2.71),('9303','2013-03-31','15:00:00',2.98),('9303','2013-03-31','15:05:00',1.95),('9303','2013-03-31','15:10:00',3.07),('9303','2013-03-31','15:15:00',2.61),('9303','2013-03-31','15:20:00',3.67),('9303','2013-03-31','15:25:00',3.28),('9303','2013-03-31','15:30:00',2.93),('9303','2013-03-31','15:35:00',2.5),('9303','2013-03-31','15:40:00',3.76),('9303','2013-03-31','15:45:00',2.6),('9303','2013-03-31','16:00:00',2.25),('9303','2013-03-31','16:05:00',1.25),('9303','2013-03-31','16:10:00',1.19),('9303','2013-03-31','16:15:00',2.09),('9303','2013-03-31','16:20:00',1.67),('9303','2013-03-31','16:25:00',1.26),('9303','2013-03-31','16:30:00',1),('9303','2013-03-31','16:35:00',1.07),('9303','2013-03-31','16:40:00',1.05),('9303','2013-03-31','17:00:00',1.18),('9303','2013-03-31','17:05:00',2.07),('9303','2013-03-31','17:10:00',1.35),('9303','2013-03-31','17:25:00',1.08),('9303','2013-03-31','17:30:00',1.18),('9303','2013-03-31','17:35:00',1.15),('9303','2013-03-31','17:55:00',1.11),('9303','2013-03-30','08:35:00',1.02),('9303','2013-03-30','09:05:00',1.67),('9303','2013-03-30','09:10:00',1.6),('9303','2013-03-30','09:16:00',1.61),('9303','2013-03-30','09:20:00',3.09),('9303','2013-03-30','09:25:00',1.99),('9303','2013-03-30','09:30:00',1.34),('9303','2013-03-30','09:35:00',1.76),('9303','2013-03-30','09:40:00',1.43),('9303','2013-03-30','09:45:00',1.17),('9303','2013-03-30','09:55:00',1.06),('9303','2013-03-30','10:00:00',1.43),('9303','2013-03-30','10:05:00',1.46),('9303','2013-03-30','10:10:00',1.7),('9303','2013-03-30','10:15:00',1.58),('9303','2013-03-30','10:20:00',1.36),('9303','2013-03-30','10:25:00',1.31),('9303','2013-03-30','10:30:00',1.51),('9303','2013-03-30','10:35:00',1.81),('9303','2013-03-30','10:40:00',2.25),('9303','2013-03-30','10:45:00',3.24),('9303','2013-03-30','10:50:00',3.12),('9303','2013-03-30','10:55:00',2.11),('9303','2013-03-30','11:00:00',3.5),('9303','2013-03-30','11:05:00',3.83),('9303','2013-03-30','11:10:00',4.47),('9303','2013-03-30','11:15:00',4.14),('9303','2013-03-30','11:20:00',4.84),('9303','2013-03-30','11:25:00',4.31),('9303','2013-03-30','11:30:00',2.25),('9303','2013-03-30','11:35:00',2.64),('9303','2013-03-30','11:40:00',2.09),('9303','2013-03-30','11:45:00',3.18),('9303','2013-03-30','11:50:00',3.51),('9303','2013-03-30','11:55:00',3.96),('9303','2013-03-30','12:00:00',4.28),('9303','2013-03-30','12:05:00',2.63),('9303','2013-03-30','12:10:00',1.93),('9303','2013-03-30','12:15:00',1.8),('9303','2013-03-30','12:20:00',1.85),('9303','2013-03-30','12:25:00',1.18),('9303','2013-03-30','12:35:00',1.01),('9303','2013-03-30','13:10:00',1.07),('9303','2013-03-30','13:15:00',3.46),('9303','2013-03-30','13:20:00',2.92),('9303','2013-03-30','13:25:00',1.41),('9303','2013-03-30','13:45:00',1.55),('9303','2013-03-30','13:50:00',3.63),('9303','2013-03-30','13:55:00',2.34),('9303','2013-03-30','14:00:00',2.75),('9303','2013-03-30','14:05:00',2.36),('9303','2013-03-30','14:10:00',1.08),('9303','2013-03-30','14:15:00',1.18),('9303','2013-03-30','14:20:00',2.03),('9303','2013-03-30','14:25:00',1.24),('9303','2013-03-30','14:30:00',1.62),('9303','2013-03-30','14:35:00',1.77),('9303','2013-03-30','14:40:00',1.09),('9303','2013-03-30','14:45:00',1.04),('9303','2013-03-30','14:50:00',1.36),('9303','2013-03-29','07:25:00',1.05),('9303','2013-03-29','07:30:00',1.19),('9303','2013-03-29','07:35:00',1.21),('9303','2013-03-29','07:40:00',1.3),('9303','2013-03-29','07:45:00',1.42),('9303','2013-03-29','07:50:00',1.21),('9303','2013-03-29','08:00:00',1.25),('9303','2013-03-29','08:05:00',1.68),('9303','2013-03-29','08:10:00',1.97),('9303','2013-03-29','08:15:00',1.95),('9303','2013-03-29','08:20:00',2.03),('9303','2013-03-29','08:25:00',2.11),('9303','2013-03-29','08:30:00',2.22),('9303','2013-03-29','08:35:00',2.27),('9303','2013-03-29','08:40:00',2.38),('9303','2013-03-29','08:45:00',2.39),('9303','2013-03-29','08:50:00',2.33),('9303','2013-03-29','08:55:00',2.28),('9303','2013-03-29','09:00:00',2.3),('9303','2013-03-29','09:05:00',2.46),('9303','2013-03-29','09:10:00',2.6),('9303','2013-03-29','09:15:00',2.93),('9303','2013-03-29','09:20:00',3.09),('9303','2013-03-29','09:25:00',2.84),('9303','2013-03-29','09:30:00',3.28),('9303','2013-03-29','09:35:00',3.38),('9303','2013-03-29','09:40:00',3.31),('9303','2013-03-29','09:45:00',2.99),('9303','2013-03-29','09:50:00',3.27),('9303','2013-03-29','09:55:00',3.22),('9303','2013-03-29','10:00:00',3.23),('9303','2013-03-29','10:05:00',2.9),('9303','2013-03-29','10:10:00',2.58),('9303','2013-03-29','10:15:00',3.22),('9303','2013-03-29','10:20:00',2.97),('9303','2013-03-29','10:25:00',2.86),('9303','2013-03-29','10:30:00',2.99),('9303','2013-03-29','10:35:00',2.32),('9303','2013-03-29','10:40:00',3.14),('9303','2013-03-29','10:45:00',2.31),('9303','2013-03-29','10:50:00',2.48),('9303','2013-03-29','10:55:00',2.87),('9303','2013-03-29','11:00:00',3.43),('9303','2013-03-29','11:05:00',3.85),('9303','2013-03-29','11:10:00',4.34),('9303','2013-03-29','11:15:00',2.25),('9303','2013-03-29','11:20:00',2.31),('9303','2013-03-29','11:25:00',3.33),('9303','2013-03-29','11:30:00',4.33),('9303','2013-03-29','11:35:00',4.17),('9303','2013-03-29','11:40:00',4.12),('9303','2013-03-29','11:45:00',4.11),('9303','2013-03-29','11:50:00',4.14),('9303','2013-03-29','11:55:00',4.14),('9303','2013-03-29','12:00:00',4.14),('9303','2013-03-29','12:05:00',4.24),('9303','2013-03-29','12:10:00',4.17),('9303','2013-03-29','12:15:00',3.86),('9303','2013-03-29','12:20:00',4.15),('9303','2013-03-29','12:25:00',3.96),('9303','2013-03-29','12:30:00',3.7),('9303','2013-03-29','12:35:00',3.85),('9303','2013-03-29','12:40:00',3.96),('9303','2013-03-29','12:45:00',3.26),('9303','2013-03-29','12:50:00',3.64),('9303','2013-03-29','12:55:00',3.1),('9303','2013-03-29','13:00:00',3.75),('9303','2013-03-29','13:05:00',3.23),('9303','2013-03-29','13:10:00',3.72),('9303','2013-03-29','13:15:00',3.29),('9303','2013-03-29','13:20:00',3.2),('9303','2013-03-29','13:25:00',4.16),('9303','2013-03-29','13:30:00',3.6),('9303','2013-03-29','13:35:00',3.21),('9303','2013-03-29','13:40:00',3.27),('9303','2013-03-29','13:45:00',3.23),('9303','2013-03-29','13:50:00',3.25),('9303','2013-03-29','13:55:00',3.29),('9303','2013-03-29','14:00:00',3.4),('9303','2013-03-29','14:05:00',2.91),('9303','2013-03-29','14:10:00',2.36),('9303','2013-03-29','14:15:00',2.32),('9303','2013-03-29','14:20:00',2.32),('9303','2013-03-29','14:25:00',2.34),('9303','2013-03-29','14:30:00',1.97),('9303','2013-03-29','14:35:00',1.97),('9303','2013-03-29','14:40:00',1.88),('9303','2013-03-29','14:45:00',1.76),('9303','2013-03-29','14:50:00',1.67),('9303','2013-03-29','14:55:00',1.6),('9303','2013-03-29','15:00:00',1.44),('9303','2013-03-29','15:05:00',1.49),('9303','2013-03-29','15:10:00',1.39),('9303','2013-03-29','15:15:00',1.35),('9303','2013-03-29','15:20:00',1.29),('9303','2013-03-29','15:25:00',1.15),('9303','2013-03-29','15:30:00',1.06),('9303','2013-03-29','15:35:00',1),('9303','2013-03-29','15:55:00',1.11),('9303','2013-03-29','16:00:00',1.32),('9303','2013-03-29','16:05:00',1.28),('9303','2013-03-29','16:10:00',1),('9303','2013-03-28','09:10:00',1.26),('9303','2013-03-28','09:16:00',2.79),('9303','2013-03-28','09:20:00',1.47),('9303','2013-03-28','09:25:00',1.37),('9303','2013-03-28','09:30:00',1.11),('9303','2013-03-28','10:00:00',1.1),('9303','2013-03-28','11:40:00',1.49),('9303','2013-03-28','11:45:00',1.22),('9303','2013-03-28','11:55:00',1.81),('9303','2013-03-28','12:00:00',1.51),('9303','2013-03-28','12:20:00',1.05),('9303','2013-03-28','12:40:00',1.16),('9303','2013-03-28','12:45:00',1.45),('9303','2013-03-28','12:50:00',2.83),('9303','2013-03-28','12:55:00',3.31),('9303','2013-03-28','13:00:00',3.21),('9303','2013-03-28','13:05:00',4.24),('9303','2013-03-28','13:10:00',3.46),('9303','2013-03-28','13:15:00',3.88),('9303','2013-03-28','13:20:00',2.82),('9303','2013-03-28','13:25:00',3.3),('9303','2013-03-28','13:30:00',3.23),('9303','2013-03-28','13:35:00',2.55),('9303','2013-03-28','13:40:00',2.9),('9303','2013-03-28','13:45:00',2.26),('9303','2013-03-28','13:50:00',3.5),('9303','2013-03-28','13:55:00',1.47),('9303','2013-03-28','14:00:00',1.71),('9303','2013-03-28','14:05:00',2.47),('9303','2013-03-28','14:10:00',1.55),('9303','2013-03-28','14:15:00',1.33),('9303','2013-03-28','14:20:00',1.4),('9303','2013-03-28','14:25:00',1.29),('9303','2013-03-28','14:30:00',1.61),('9303','2013-03-28','14:35:00',1.57),('9303','2013-03-28','14:40:00',1.06),('9303','2013-03-28','14:45:00',1.01),('9303','2013-03-28','15:00:00',1.05),('9303','2013-03-28','15:05:00',1.15),('9303','2013-03-28','15:10:00',2.14),('9303','2013-03-28','15:15:00',2.14),('9303','2013-03-28','15:20:00',1.61),('9303','2013-03-28','15:25:00',1.52),('9303','2013-03-28','15:30:00',1.53),('9303','2013-03-28','15:35:00',2.06),('9303','2013-03-28','15:40:00',1.68),('9303','2013-03-28','15:45:00',2.02),('9303','2013-03-28','15:50:00',1.2),('9303','2013-03-28','15:55:00',2.5),('9303','2013-03-28','16:00:00',1.29),('9303','2013-03-28','16:10:00',1.35),('9303','2013-03-28','16:35:00',1.31),('9303','2013-03-28','17:00:00',1.11),('9303','2013-03-27','07:30:00',1.04),('9303','2013-03-27','07:40:00',1.15),('9303','2013-03-27','07:45:00',1.06),('9303','2013-03-27','07:55:00',1.17),('9303','2013-03-27','08:00:00',1.29),('9303','2013-03-27','08:05:00',1.43),('9303','2013-03-27','08:10:00',1.24),('9303','2013-03-27','08:15:00',1.36),('9303','2013-03-27','08:20:00',1.2),('9303','2013-03-27','08:25:00',1.38),('9303','2013-03-27','08:30:00',1.8),('9303','2013-03-27','08:35:00',1.74),('9303','2013-03-27','08:40:00',1.34),('9303','2013-03-27','08:45:00',1.2),('9303','2013-03-27','08:50:00',1.65),('9303','2013-03-27','08:55:00',1.28),('9303','2013-03-27','09:00:00',1.32),('9303','2013-03-27','09:05:00',1.01),('9303','2013-03-27','09:15:00',1.31),('9303','2013-03-27','09:20:00',1.53),('9303','2013-03-27','09:25:00',1.01),('9303','2013-03-27','09:45:00',1.28),('9303','2013-03-27','09:50:00',2.13),('9303','2013-03-27','09:55:00',1.44),('9303','2013-03-27','10:00:00',1.24),('9303','2013-03-27','10:10:00',1.15),('9303','2013-03-27','10:15:00',1.63),('9303','2013-03-27','10:20:00',1.39),('9303','2013-03-27','10:25:00',1.65),('9303','2013-03-27','10:30:00',2.18),('9303','2013-03-27','10:35:00',1.71),('9303','2013-03-27','10:40:00',1.91),('9303','2013-03-27','10:45:00',2.08),('9303','2013-03-27','10:50:00',1.94),('9303','2013-03-27','10:55:00',1.85),('9303','2013-03-27','11:00:00',1.56),('9303','2013-03-27','11:05:00',1.45),('9303','2013-03-27','11:10:00',1.59),('9303','2013-03-27','11:15:00',1.66),('9303','2013-03-27','11:20:00',1.73),('9303','2013-03-27','11:25:00',1.63),('9303','2013-03-27','11:30:00',1.85),('9303','2013-03-27','11:35:00',1.76),('9303','2013-03-27','11:40:00',1.65),('9303','2013-03-27','11:45:00',1.6),('9303','2013-03-27','11:50:00',1.56),('9303','2013-03-27','11:55:00',2.2),('9303','2013-03-27','12:00:00',2.66),('9303','2013-03-27','12:05:00',2.55),('9303','2013-03-27','12:10:00',2.16),('9303','2013-03-27','12:15:00',1.63),('9303','2013-03-27','12:20:00',1.66),('9303','2013-03-27','12:25:00',1.57),('9303','2013-03-27','12:30:00',3.14),('9303','2013-03-27','12:35:00',4.36),('9303','2013-03-27','12:40:00',3.14),('9303','2013-03-27','12:45:00',4.3),('9303','2013-03-27','12:50:00',2.73),('9303','2013-03-27','12:55:00',2.32),('9303','2013-03-27','13:00:00',1.5),('9303','2013-03-27','13:05:00',1.45),('9303','2013-03-27','13:10:00',2.18),('9303','2013-03-27','13:15:00',1.64),('9303','2013-03-27','13:20:00',1.28),('9303','2013-03-27','13:25:00',1.2),('9303','2013-03-27','13:30:00',1.6),('9303','2013-03-27','13:35:00',2.02),('9303','2013-03-27','13:40:00',1.7),('9303','2013-03-27','13:45:00',1.92),('9303','2013-03-27','13:50:00',2.27),('9303','2013-03-27','13:55:00',2.19),('9303','2013-03-27','14:00:00',1.6),('9303','2013-03-27','14:05:00',1.41),('9303','2013-03-27','14:10:00',1.47),('9303','2013-03-27','14:15:00',1.69),('9303','2013-03-27','14:20:00',2.14),('9303','2013-03-27','14:25:00',1.61),('9303','2013-03-27','14:30:00',1.35),('9303','2013-03-27','14:35:00',1.58),('9303','2013-03-27','14:40:00',2.08),('9303','2013-03-27','14:45:00',2.07),('9303','2013-03-27','14:50:00',1.49),('9303','2013-03-27','14:55:00',1.2),('9303','2013-03-27','15:00:00',1.09),('9303','2013-03-27','15:05:00',1.51),('9303','2013-03-27','15:10:00',1.46),('9303','2013-03-27','15:20:00',1.03),('9303','2013-03-27','15:25:00',1.06),('9303','2013-03-27','17:00:00',1.03),('9303','2013-03-27','17:05:00',1.19),('9303','2013-03-26','07:50:00',1.5),('9303','2013-03-26','07:55:00',1.95),('9303','2013-03-26','08:35:00',1.25),('9303','2013-03-26','08:40:00',1.36),('9303','2013-03-26','09:15:00',1.35),('9303','2013-03-26','09:20:00',1.01),('9303','2013-03-26','09:55:00',2.59),('9303','2013-03-26','10:00:00',1.28),('9303','2013-03-26','11:50:00',1.08),('9303','2013-03-26','12:00:00',1.13),('9303','2013-03-26','12:05:00',1.07),('9303','2013-03-26','12:12:00',1.17),('9303','2013-03-26','12:15:00',1.33),('9303','2013-03-26','12:22:00',1.74),('9303','2013-03-26','12:25:00',2.4),('9303','2013-03-26','12:35:00',2.37),('9303','2013-03-26','12:40:00',1.48),('9303','2013-03-26','12:47:00',2.13),('9303','2013-03-26','12:50:00',1.66),('9303','2013-03-26','12:57:00',1.21),('9303','2013-03-26','13:00:00',1.7),('9303','2013-03-26','13:10:00',2.38),('9303','2013-03-26','13:15:00',1.82),('9303','2013-03-26','13:22:00',1.58),('9303','2013-03-26','13:25:00',1.72),('9303','2013-03-26','13:32:00',1.58),('9303','2013-03-26','13:35:00',1.99),('9303','2013-03-26','13:45:00',2.21),('9303','2013-03-26','13:50:00',1.66),('9303','2013-03-26','13:57:00',1.51),('9303','2013-03-26','14:00:00',1.44),('9303','2013-03-26','14:07:00',1.43),('9303','2013-03-26','14:10:00',1.47),('9303','2013-03-26','14:20:00',1.3),('9303','2013-03-26','14:25:00',1.04),('9303','2013-03-25','08:25:00',1.87),('9303','2013-03-25','08:30:00',1.27),('9303','2013-03-25','08:55:00',1.04),('9303','2013-03-25','09:00:00',1.05),('9303','2013-03-25','09:05:00',1.01),('9303','2013-03-25','09:10:00',1.09),('9303','2013-03-25','09:15:00',1.05),('9303','2013-03-25','09:20:00',2.39),('9303','2013-03-25','09:25:00',2.82),('9303','2013-03-25','09:30:00',1.67),('9303','2013-03-25','09:50:00',3.12),('9303','2013-03-25','09:55:00',3.98),('9303','2013-03-25','10:00:00',2.11),('9303','2013-03-25','10:20:00',1.32),('9303','2013-03-25','10:25:00',2.07),('9303','2013-03-25','10:30:00',2.42),('9303','2013-03-25','10:35:00',1.29),('9303','2013-03-25','10:40:00',1.5),('9303','2013-03-25','10:45:00',2.63),('9303','2013-03-25','10:50:00',1.95),('9303','2013-03-25','10:55:00',2.48),('9303','2013-03-25','11:00:00',2.1),('9303','2013-03-25','11:05:00',1.87),('9303','2013-03-25','11:10:00',1.73),('9303','2013-03-25','11:15:00',1.83),('9303','2013-03-25','11:20:00',3.67),('9303','2013-03-25','11:25:00',3.26),('9303','2013-03-25','11:30:00',3.75),('9303','2013-03-25','11:35:00',2.96),('9303','2013-03-25','11:40:00',1.25),('9303','2013-03-25','11:45:00',1.42),('9303','2013-03-25','11:50:00',1.63),('9303','2013-03-25','11:55:00',2.57),('9303','2013-03-25','12:00:00',3.23),('9303','2013-03-25','12:05:00',3.5),('9303','2013-03-25','12:10:00',3.59),('9303','2013-03-25','12:15:00',3.17),('9303','2013-03-25','12:20:00',3),('9303','2013-03-25','12:25:00',4.31),('9303','2013-03-25','12:30:00',3.41),('9303','2013-03-25','12:35:00',3.08),('9303','2013-03-25','12:40:00',2.3),('9303','2013-03-25','12:45:00',2.36),('9303','2013-03-25','12:50:00',2.75),('9303','2013-03-25','12:55:00',3.02),('9303','2013-03-25','13:00:00',2.66),('9303','2013-03-25','13:05:00',4.17),('9303','2013-03-25','13:10:00',4.1),('9303','2013-03-25','13:15:00',4.61),('9303','2013-03-25','13:20:00',3.89),('9303','2013-03-25','13:25:00',2.22),('9303','2013-03-25','13:30:00',2.04),('9303','2013-03-25','13:35:00',1.09),('9303','2013-03-25','13:40:00',1.1),('9303','2013-03-25','13:45:00',1.93),('9303','2013-03-25','13:50:00',1.8),('9303','2013-03-25','13:55:00',1.67),('9303','2013-03-25','14:10:00',2.61),('9303','2013-03-25','14:15:00',2.18),('9303','2013-03-25','14:20:00',2.49),('9303','2013-03-25','14:25:00',3.28),('9303','2013-03-25','14:30:00',2.5),('9303','2013-03-25','14:35:00',2.11),('9303','2013-03-25','14:40:00',1.29),('9303','2013-03-25','14:45:00',2.06),('9303','2013-03-25','14:50:00',1.89),('9303','2013-03-25','14:55:00',2.73),('9303','2013-03-25','15:00:00',2.45),('9303','2013-03-25','15:05:00',2.3),('9303','2013-03-25','15:10:00',2.1),('9303','2013-03-25','15:15:00',1.98),('9303','2013-03-25','15:20:00',2.58),('9303','2013-03-25','15:25:00',3.01),('9303','2013-03-25','15:30:00',2.2),('9303','2013-03-25','15:35:00',2.56),('9303','2013-03-25','15:40:00',1.86),('9303','2013-03-25','15:45:00',1.47),('9303','2013-03-25','15:55:00',1.01),('9303','2013-03-25','16:00:00',1.53),('9303','2013-03-25','16:05:00',1.07),('9303','2013-03-25','16:10:00',1.17),('9303','2013-03-25','16:15:00',1.3),('9303','2013-03-25','16:30:00',1.02),('9303','2013-03-25','16:35:00',1.51),('9303','2013-03-25','16:40:00',1.67),('9303','2013-03-24','07:50:00',1.14),('9303','2013-03-24','07:55:00',1.3),('9303','2013-03-24','08:00:00',1.53),('9303','2013-03-24','08:05:00',1.7),('9303','2013-03-24','08:10:00',1.74),('9303','2013-03-24','08:15:00',1.87),('9303','2013-03-24','08:20:00',1.96),('9303','2013-03-24','08:25:00',2.04),('9303','2013-03-24','08:30:00',2.12),('9303','2013-03-24','08:35:00',2.19),('9303','2013-03-24','08:40:00',2.26),('9303','2013-03-24','08:45:00',2.33),('9303','2013-03-24','08:50:00',2.37),('9303','2013-03-24','08:55:00',2.43),('9303','2013-03-24','09:00:00',2.5),('9303','2013-03-24','09:05:00',2.59),('9303','2013-03-24','09:10:00',2.66),('9303','2013-03-24','09:15:00',2.72),('9303','2013-03-24','09:20:00',2.79),('9303','2013-03-24','09:25:00',2.85),('9303','2013-03-24','09:30:00',2.92),('9303','2013-03-24','09:35:00',2.98),('9303','2013-03-24','09:40:00',3),('9303','2013-03-24','09:45:00',3.07),('9303','2013-03-24','09:50:00',3.1),('9303','2013-03-24','09:55:00',3.14),('9303','2013-03-24','10:00:00',3.21),('9303','2013-03-24','10:05:00',3.27),('9303','2013-03-24','10:10:00',3.34),('9303','2013-03-24','10:15:00',3.38),('9303','2013-03-24','10:20:00',3.39),('9303','2013-03-24','10:25:00',3.44),('9303','2013-03-24','10:30:00',3.46),('9303','2013-03-24','10:35:00',3.49),('9303','2013-03-24','10:40:00',3.52),('9303','2013-03-24','10:45:00',3.51),('9303','2013-03-24','10:50:00',3.53),('9303','2013-03-24','10:55:00',3.56),('9303','2013-03-24','11:00:00',3.59),('9303','2013-03-24','11:05:00',3.62),('9303','2013-03-24','11:10:00',3.65),('9303','2013-03-24','11:15:00',3.66),('9303','2013-03-24','11:20:00',3.69),('9303','2013-03-24','11:25:00',3.7),('9303','2013-03-24','11:30:00',3.72),('9303','2013-03-24','11:35:00',3.74),('9303','2013-03-24','11:40:00',3.73),('9303','2013-03-24','11:45:00',3.74),('9303','2013-03-24','11:50:00',3.75),('9303','2013-03-24','11:55:00',3.76),('9303','2013-03-24','12:00:00',3.79),('9303','2013-03-24','12:05:00',3.79),('9303','2013-03-24','12:10:00',3.8),('9303','2013-03-24','12:15:00',3.82),('9303','2013-03-24','12:20:00',3.89),('9303','2013-03-24','12:25:00',3.93),('9303','2013-03-24','12:30:00',3.92),('9303','2013-03-24','12:35:00',3.94),('9303','2013-03-24','12:40:00',3.9),('9303','2013-03-24','12:45:00',3.91),('9303','2013-03-24','12:50:00',3.9),('9303','2013-03-24','12:55:00',3.88),('9303','2013-03-24','13:00:00',3.85),('9303','2013-03-24','13:05:00',3.85),('9303','2013-03-24','13:10:00',3.82),('9303','2013-03-24','13:15:00',3.79),('9303','2013-03-24','13:20:00',3.8),('9303','2013-03-24','13:25:00',3.73),('9303','2013-03-24','13:30:00',3.68),('9303','2013-03-24','13:35:00',3.68),('9303','2013-03-24','13:40:00',3.67),('9303','2013-03-24','13:45:00',3.63),('9303','2013-03-24','13:50:00',3.59),('9303','2013-03-24','13:55:00',3.56),('9303','2013-03-24','14:00:00',3.52),('9303','2013-03-24','14:05:00',3.46),('9303','2013-03-24','14:10:00',3.39),('9303','2013-03-24','14:15:00',3.34),('9303','2013-03-24','14:20:00',3.29),('9303','2013-03-24','14:25:00',3.24),('9303','2013-03-24','14:30:00',3.13),('9303','2013-03-24','14:35:00',3.02),('9303','2013-03-24','14:40:00',2.99),('9303','2013-03-24','14:45:00',2.94),('9303','2013-03-24','14:50:00',2.8),('9303','2013-03-24','14:55:00',2.81),('9303','2013-03-24','15:00:00',2.71),('9303','2013-03-24','15:05:00',2.64),('9303','2013-03-24','15:10:00',2.5),('9303','2013-03-24','15:15:00',2.71),('9303','2013-03-24','15:20:00',2.61),('9303','2013-03-24','15:25:00',2.44),('9303','2013-03-24','15:30:00',2.2),('9303','2013-03-24','15:35:00',2.11),('9303','2013-03-24','15:40:00',2.07),('9303','2013-03-24','15:45:00',1.73),('9303','2013-03-24','15:50:00',1.15),('9303','2013-03-24','15:55:00',1.1),('9303','2013-03-24','16:00:00',1.07),('9303','2013-03-24','16:05:00',1.16),('9303','2013-03-24','16:15:00',1.14),('9303','2013-03-24','16:20:00',1.05),('9303','2013-03-23','07:40:00',1.06),('9303','2013-03-23','07:45:00',1.1),('9303','2013-03-23','07:50:00',1.21),('9303','2013-03-23','07:55:00',1.38),('9303','2013-03-23','08:00:00',1.53),('9303','2013-03-23','08:05:00',1.71),('9303','2013-03-23','08:10:00',1.8),('9303','2013-03-23','08:15:00',1.89),('9303','2013-03-23','08:20:00',1.97),('9303','2013-03-23','08:25:00',2.04),('9303','2013-03-23','08:30:00',2.07),('9303','2013-03-23','08:35:00',2.16),('9303','2013-03-23','08:40:00',2.28),('9303','2013-03-23','08:45:00',2.35),('9303','2013-03-23','08:50:00',2.42),('9303','2013-03-23','08:55:00',2.57),('9303','2013-03-23','09:00:00',2.62),('9303','2013-03-23','09:05:00',2.7),('9303','2013-03-23','09:10:00',2.69),('9303','2013-03-23','09:15:00',2.78),('9303','2013-03-23','09:20:00',2.89),('9303','2013-03-23','09:25:00',2.89),('9303','2013-03-23','09:30:00',3.07),('9303','2013-03-23','09:35:00',3.18),('9303','2013-03-23','09:40:00',3.01),('9303','2013-03-23','09:45:00',3.16),('9303','2013-03-23','09:50:00',3.22),('9303','2013-03-23','09:55:00',3.3),('9303','2013-03-23','10:00:00',3.29),('9303','2013-03-23','10:05:00',3.33),('9303','2013-03-23','10:10:00',3.38),('9303','2013-03-23','10:15:00',3.39),('9303','2013-03-23','10:20:00',3.38),('9303','2013-03-23','10:25:00',3.42),('9303','2013-03-23','10:30:00',3.57),('9303','2013-03-23','10:35:00',3.61),('9303','2013-03-23','10:40:00',3.61),('9303','2013-03-23','10:45:00',3.61),('9303','2013-03-23','10:50:00',3.61),('9303','2013-03-23','10:55:00',3.49),('9303','2013-03-23','11:00:00',3.36),('9303','2013-03-23','11:05:00',3.26),('9303','2013-03-23','11:10:00',2.61),('9303','2013-03-23','11:15:00',2.78),('9303','2013-03-23','11:20:00',3.56),('9303','2013-03-23','11:25:00',3.58),('9303','2013-03-23','11:30:00',3.63),('9303','2013-03-23','11:35:00',3.78),('9303','2013-03-23','11:40:00',3.77),('9303','2013-03-23','11:45:00',3.78),('9303','2013-03-23','11:50:00',3.65),('9303','2013-03-23','11:55:00',3.83),('9303','2013-03-23','12:00:00',3.83),('9303','2013-03-23','12:05:00',3.78),('9303','2013-03-23','12:10:00',3.77),('9303','2013-03-23','12:15:00',3.84),('9303','2013-03-23','12:20:00',3.9),('9303','2013-03-23','12:25:00',3.85),('9303','2013-03-23','12:30:00',3.91),('9303','2013-03-23','12:35:00',3.87),('9303','2013-03-23','12:40:00',3.66),('9303','2013-03-23','12:45:00',3.77),('9303','2013-03-23','12:50:00',3.84),('9303','2013-03-23','12:55:00',3.8),('9303','2013-03-23','13:00:00',2.9),('9303','2013-03-23','13:05:00',3.73),('9303','2013-03-23','13:10:00',3.83),('9303','2013-03-23','13:15:00',3.68),('9303','2013-03-23','13:20:00',3.76),('9303','2013-03-23','13:25:00',3.71),('9303','2013-03-23','13:30:00',3.43),('9303','2013-03-23','13:35:00',3.16),('9303','2013-03-23','13:40:00',3.17),('9303','2013-03-23','13:45:00',3.17),('9303','2013-03-23','13:50:00',3.65),('9303','2013-03-23','13:55:00',3.5),('9303','2013-03-23','14:00:00',3.47),('9303','2013-03-23','14:05:00',3.48),('9303','2013-03-23','14:10:00',3.42),('9303','2013-03-23','14:15:00',3.29),('9303','2013-03-23','14:20:00',3.4),('9303','2013-03-23','14:25:00',3.31),('9303','2013-03-23','14:30:00',3.31),('9303','2013-03-23','14:35:00',3.23),('9303','2013-03-23','14:40:00',3.14),('9303','2013-03-23','14:45:00',2.92),('9303','2013-03-23','14:50:00',2.86),('9303','2013-03-23','14:55:00',2.91),('9303','2013-03-23','15:00:00',2.78),('9303','2013-03-23','15:05:00',2.65),('9303','2013-03-23','15:10:00',2.74),('9303','2013-03-23','15:15:00',2.54),('9303','2013-03-23','15:20:00',2.55),('9303','2013-03-23','15:25:00',2.54),('9303','2013-03-23','15:30:00',2.25),('9303','2013-03-23','15:35:00',2.26),('9303','2013-03-23','15:40:00',2.06),('9303','2013-03-23','15:45:00',1.89),('9303','2013-03-23','15:50:00',1.76),('9303','2013-03-23','15:55:00',1.71),('9303','2013-03-23','16:00:00',1.6),('9303','2013-03-23','16:05:00',1.4),('9303','2013-03-23','16:10:00',1.78),('9303','2013-03-23','16:15:00',1.62),('9303','2013-03-23','16:20:00',1.35),('9303','2013-03-23','16:25:00',1.33),('9303','2013-03-23','16:30:00',1.07),('9303','2013-03-23','16:35:00',1.11),('9303','2014-03-26','07:30:00',1.08),('9303','2014-03-26','07:35:00',1.18),('9303','2014-03-26','07:40:00',1.26),('9303','2014-03-26','07:45:00',1.37),('9303','2014-03-26','07:50:00',1.45),('9303','2014-03-26','07:55:00',1.57),('9303','2014-03-26','08:00:00',1.7),('9303','2014-03-26','08:05:00',1.84),('9303','2014-03-26','08:10:00',1.96),('9303','2014-03-26','08:15:00',2.12),('9303','2014-03-26','08:20:00',2.45),('9303','2014-03-26','08:25:00',1.54),('9303','2014-03-26','08:30:00',1.05),('9303','2014-03-26','08:45:00',1.06),('9303','2014-03-26','08:50:00',1.28),('9303','2014-03-26','08:55:00',1.13),('9303','2014-03-26','09:00:00',1.26),('9303','2014-03-26','09:05:00',1.22),('9303','2014-03-26','09:10:00',1.45),('9303','2014-03-26','09:15:00',1.17),('9303','2014-03-26','09:25:00',1.11),('9303','2014-03-26','09:30:00',3.08),('9303','2014-03-26','09:35:00',3.25),('9303','2014-03-26','09:40:00',3.29),('9303','2014-03-26','09:45:00',3.3),('9303','2014-03-26','09:50:00',3.36),('9303','2014-03-26','09:55:00',3.25),('9303','2014-03-26','10:00:00',3.6),('9303','2014-03-26','10:05:00',2.9),('9303','2014-03-26','10:10:00',3.22),('9303','2014-03-26','10:15:00',3.76),('9303','2014-03-26','10:20:00',3.44),('9303','2014-03-26','10:25:00',3.95),('9303','2014-03-26','10:30:00',3.96),('9303','2014-03-26','10:35:00',2.49),('9303','2014-03-26','10:45:00',2.08),('9303','2014-03-26','10:50:00',3.46),('9303','2014-03-26','10:55:00',3.64),('9303','2014-03-26','11:00:00',4.21),('9303','2014-03-26','11:05:00',1.11),('9303','2014-03-26','11:10:00',2.27),('9303','2014-03-26','11:15:00',3.23),('9303','2014-03-26','11:20:00',2.92),('9303','2014-03-26','11:25:00',1.23),('9303','2014-03-26','11:30:00',1.51),('9303','2014-03-26','11:35:00',1.73),('9303','2014-03-26','11:40:00',2.06),('9303','2014-03-26','11:45:00',1.8),('9303','2014-03-26','11:50:00',3.97),('9303','2014-03-26','11:55:00',4.14),('9303','2014-03-26','12:00:00',4.74),('9303','2014-03-26','12:05:00',3.48),('9303','2014-03-26','12:10:00',4.54),('9303','2014-03-26','12:15:00',1.5),('9303','2014-03-26','12:20:00',1.68),('9303','2014-03-26','12:25:00',1.67),('9303','2014-03-26','12:30:00',1.59),('9303','2014-03-26','12:35:00',1.58),('9303','2014-03-26','12:40:00',1.73),('9303','2014-03-26','12:45:00',1.93),('9303','2014-03-26','12:50:00',1.52),('9303','2014-03-26','12:55:00',1.2),('9303','2014-03-26','13:00:00',1.18),('9303','2014-03-26','13:05:00',1.23),('9303','2014-03-26','13:10:00',1.04),('9303','2014-03-26','13:25:00',4.35),('9303','2014-03-26','13:30:00',3),('9303','2014-03-26','13:35:00',1.52),('9303','2014-03-26','13:40:00',1.25),('9303','2014-03-26','13:55:00',1.02),('9303','2014-03-26','14:00:00',1.41),('9303','2014-03-26','14:05:00',2.48),('9303','2014-03-26','14:10:00',4.53),('9303','2014-03-26','14:15:00',2.28),('9303','2014-03-26','14:45:00',1.73),('9303','2014-03-26','14:50:00',3.13),('9303','2014-03-26','14:55:00',3.3),('9303','2014-03-26','15:00:00',2.96),('9303','2014-03-26','15:05:00',3),('9303','2014-03-26','15:10:00',3.1),('9303','2014-03-26','15:15:00',3.29),('9303','2014-03-26','15:20:00',3.1),('9303','2014-03-26','15:25:00',2.89),('9303','2014-03-26','15:30:00',3.05),('9303','2014-03-26','15:35:00',2.96),('9303','2014-03-26','15:40:00',2.34),('9303','2014-03-26','15:45:00',2.42),('9303','2014-03-26','15:50:00',2.07),('9303','2014-03-26','15:55:00',1.7),('9303','2014-03-26','16:00:00',1.26),('9303','2014-03-26','16:05:00',1.44),('9303','2014-03-26','16:10:00',1.4),('9303','2014-03-26','16:15:00',1.22),('9303','2013-03-22','07:35:00',1.05),('9303','2013-03-22','07:40:00',1.15),('9303','2013-03-22','07:45:00',1.26),('9303','2013-03-22','07:50:00',1.35),('9303','2013-03-22','07:55:00',1.45),('9303','2013-03-22','08:00:00',1.55),('9303','2013-03-22','08:05:00',1.65),('9303','2013-03-22','08:10:00',1.77),('9303','2013-03-22','08:15:00',1.87),('9303','2013-03-22','08:20:00',1.96),('9303','2013-03-22','08:25:00',2.05),('9303','2013-03-22','08:30:00',2.13),('9303','2013-03-22','08:35:00',2.22),('9303','2013-03-22','08:40:00',2.3),('9303','2013-03-22','08:45:00',2.38),('9303','2013-03-22','08:50:00',2.45),('9303','2013-03-22','08:55:00',2.51),('9303','2013-03-22','09:00:00',2.58),('9303','2013-03-22','09:05:00',2.64),('9303','2013-03-22','09:10:00',2.71),('9303','2013-03-22','09:15:00',2.77),('9303','2013-03-22','09:20:00',2.83),('9303','2013-03-22','09:25:00',2.88),('9303','2013-03-22','09:30:00',2.93),('9303','2013-03-22','09:35:00',3.04),('9303','2013-03-22','09:40:00',3.08),('9303','2013-03-22','09:45:00',3.19),('9303','2013-03-22','09:50:00',3.25),('9303','2013-03-22','09:55:00',3.26),('9303','2013-03-22','10:00:00',3.31),('9303','2013-03-22','10:05:00',3.33),('9303','2013-03-22','10:10:00',3.41),('9303','2013-03-22','10:15:00',3.46),('9303','2013-03-22','10:20:00',3.41),('9303','2013-03-22','10:25:00',3.54),('9303','2013-03-22','10:30:00',3.62),('9303','2013-03-22','10:35:00',3.68),('9303','2013-03-22','10:40:00',3.74),('9303','2013-03-22','10:45:00',3.77),('9303','2013-03-22','10:50:00',3.8),('9303','2013-03-22','10:55:00',3.82),('9303','2013-03-22','11:00:00',3.81),('9303','2013-03-22','11:05:00',3.87),('9303','2013-03-22','11:10:00',3.88),('9303','2013-03-22','11:15:00',3.91),('9303','2013-03-22','11:20:00',3.95),('9303','2013-03-22','11:25:00',3.92),('9303','2013-03-22','11:30:00',3.93),('9303','2013-03-22','11:35:00',4),('9303','2013-03-22','11:40:00',4.01),('9303','2013-03-22','11:45:00',4.04),('9303','2013-03-22','11:50:00',4),('9303','2013-03-22','11:55:00',4.07),('9303','2013-03-22','12:00:00',4.07),('9303','2013-03-22','12:05:00',4.09),('9303','2013-03-22','12:10:00',4.06),('9303','2013-03-22','12:15:00',4.1),('9303','2013-03-22','12:20:00',4.09),('9303','2013-03-22','12:25:00',4.07),('9303','2013-03-22','12:30:00',4.11),('9303','2013-03-22','12:35:00',4.07),('9303','2013-03-22','12:40:00',4.1),('9303','2013-03-22','12:45:00',4.06),('9303','2013-03-22','12:50:00',3.94),('9303','2013-03-22','12:55:00',3.74),('9303','2013-03-22','13:00:00',4.05),('9303','2013-03-22','13:05:00',3.9),('9303','2013-03-22','13:10:00',4.06),('9303','2013-03-22','13:15:00',4.02),('9303','2013-03-22','13:20:00',3.94),('9303','2013-03-22','13:25:00',3.76),('9303','2013-03-22','13:30:00',3.73),('9303','2013-03-22','13:35:00',3.8),('9303','2013-03-22','13:40:00',3.2),('9303','2013-03-22','13:45:00',3.33),('9303','2013-03-22','13:50:00',3.83),('9303','2013-03-22','13:55:00',3.77),('9303','2013-03-22','14:00:00',3.7),('9303','2013-03-22','14:05:00',3.67),('9303','2013-03-22','14:10:00',3.62),('9303','2013-03-22','14:15:00',3.57),('9303','2013-03-22','14:20:00',3.52),('9303','2013-03-22','14:25:00',3.46),('9303','2013-03-22','14:30:00',3.4),('9303','2013-03-22','14:35:00',3.34),('9303','2013-03-22','14:40:00',3.26),('9303','2013-03-22','14:45:00',3.21),('9303','2013-03-22','14:50:00',3.16),('9303','2013-03-22','14:55:00',3.12),('9303','2013-03-22','15:00:00',3.06),('9303','2013-03-22','15:05:00',2.97),('9303','2013-03-22','15:10:00',2.63),('9303','2013-03-22','15:15:00',2.17),('9303','2013-03-22','15:20:00',2.14),('9303','2013-03-22','15:25:00',2.3),('9303','2013-03-22','15:30:00',2.11),('9303','2013-03-22','15:35:00',2.31),('9303','2013-03-22','15:40:00',2.19),('9303','2013-03-22','15:45:00',1.89),('9303','2013-03-22','15:50:00',2.02),('9303','2013-03-22','15:55:00',1.68),('9303','2013-03-22','16:00:00',1.23),('9303','2013-03-22','16:05:00',1.26),('9303','2013-03-22','16:10:00',1.46),('9303','2013-03-22','16:15:00',1.71),('9303','2013-03-22','16:20:00',1.36),('9303','2013-03-22','16:25:00',1.33),('9303','2013-03-22','16:30:00',1.48),('9303','2013-03-22','16:35:00',1.4),('9303','2013-03-22','16:40:00',1.33),('9303','2013-03-22','16:45:00',1.25),('9303','2013-03-22','16:50:00',1.13),('9303','2013-03-22','16:55:00',1.05),('9303','2013-03-21','07:45:00',1.2),('9303','2013-03-21','07:50:00',1.47),('9303','2013-03-21','08:10:00',1.21),('9303','2013-03-21','08:15:00',1.99),('9303','2013-03-21','08:20:00',2.09),('9303','2013-03-21','08:25:00',2.11),('9303','2013-03-21','08:30:00',2.12),('9303','2013-03-21','08:35:00',2.32),('9303','2013-03-21','08:40:00',2.51),('9303','2013-03-21','08:45:00',2.41),('9303','2013-03-21','08:50:00',2.45),('9303','2013-03-21','08:55:00',2.29),('9303','2013-03-21','09:00:00',2.79),('9303','2013-03-21','09:05:00',2.98),('9303','2013-03-21','09:10:00',3.23),('9303','2013-03-21','09:15:00',2.11),('9303','2013-03-21','09:20:00',2.7),('9303','2013-03-21','09:25:00',3.28),('9303','2013-03-21','09:30:00',3.26),('9303','2013-03-21','09:35:00',3.26),('9303','2013-03-21','09:40:00',3.33),('9303','2013-03-21','09:45:00',3.35),('9303','2013-03-21','09:50:00',3.49),('9303','2013-03-21','09:55:00',3.55),('9303','2013-03-21','10:00:00',3.62),('9303','2013-03-21','10:05:00',3.66),('9303','2013-03-21','10:10:00',3.69),('9303','2013-03-21','10:15:00',3.7),('9303','2013-03-21','10:20:00',3.76),('9303','2013-03-21','10:25:00',3.77),('9303','2013-03-21','10:30:00',3.81),('9303','2013-03-21','10:35:00',3.88),('9303','2013-03-21','10:40:00',3.9),('9303','2013-03-21','10:45:00',3.89),('9303','2013-03-21','10:50:00',3.89),('9303','2013-03-21','10:55:00',2.93),('9303','2013-03-21','11:00:00',4.08),('9303','2013-03-21','11:05:00',4.07),('9303','2013-03-21','11:10:00',4.09),('9303','2013-03-21','11:15:00',4.13),('9303','2013-03-21','11:20:00',4.14),('9303','2013-03-21','11:25:00',4.18),('9303','2013-03-21','11:30:00',4.2),('9303','2013-03-21','11:35:00',4.22),('9303','2013-03-21','11:40:00',4.23),('9303','2013-03-21','11:45:00',4.26),('9303','2013-03-21','11:50:00',4.28),('9303','2013-03-21','11:55:00',4.3),('9303','2013-03-21','12:00:00',4.29),('9303','2013-03-21','12:05:00',4.29),('9303','2013-03-21','12:10:00',4.3),('9303','2013-03-21','12:15:00',4.3),('9303','2013-03-21','12:20:00',4.28),('9303','2013-03-21','12:25:00',4.27),('9303','2013-03-21','12:30:00',4.26),('9303','2013-03-21','12:35:00',4.29),('9303','2013-03-21','12:40:00',4.29),('9303','2013-03-21','12:45:00',4.25),('9303','2013-03-21','12:50:00',4.22),('9303','2013-03-21','12:55:00',4.19),('9303','2013-03-21','13:00:00',4.17),('9303','2013-03-21','13:05:00',4.13),('9303','2013-03-21','13:10:00',4.1),('9303','2013-03-21','13:15:00',4.07),('9303','2013-03-21','13:20:00',4.05),('9303','2013-03-21','13:25:00',4.03),('9303','2013-03-21','13:30:00',4.01),('9303','2013-03-21','13:35:00',3.98),('9303','2013-03-21','13:40:00',3.96),('9303','2013-03-21','13:45:00',3.92),('9303','2013-03-21','13:50:00',3.89),('9303','2013-03-21','13:55:00',3.83),('9303','2013-03-21','14:00:00',3.81),('9303','2013-03-21','14:05:00',3.74),('9303','2013-03-21','14:10:00',3.66),('9303','2013-03-21','14:15:00',3.58),('9303','2013-03-21','14:20:00',3.55),('9303','2013-03-21','14:25:00',3.52),('9303','2013-03-21','14:30:00',3.43),('9303','2013-03-21','14:35:00',3.38),('9303','2013-03-21','14:40:00',3.3),('9303','2013-03-21','14:45:00',3.25),('9303','2013-03-21','14:50:00',3.2),('9303','2013-03-21','14:55:00',3.15),('9303','2013-03-21','15:00:00',3.08),('9303','2013-03-21','15:05:00',3.02),('9303','2013-03-21','15:10:00',2.94),('9303','2013-03-21','15:15:00',2.87),('9303','2013-03-21','15:20:00',2.78),('9303','2013-03-21','15:25:00',2.69),('9303','2013-03-21','15:30:00',2.62),('9303','2013-03-21','15:35:00',2.52),('9303','2013-03-21','15:40:00',2.39),('9303','2013-03-21','15:45:00',2.25),('9303','2013-03-21','15:50:00',2.16),('9303','2013-03-21','15:55:00',2.07),('9303','2013-03-21','16:00:00',1.99),('9303','2013-03-21','16:05:00',1.91),('9303','2013-03-21','16:10:00',1.78),('9303','2013-03-21','16:15:00',1.7),('9303','2013-03-21','16:20:00',1.61),('9303','2013-03-21','16:25:00',1.51),('9303','2013-03-21','16:30:00',1.4),('9303','2013-03-21','16:35:00',1.27),('9303','2013-03-21','16:40:00',1.15),('9303','2013-03-21','16:45:00',1.09),('9303','2013-03-20','07:35:00',1.09),('9303','2013-03-20','07:40:00',1.14),('9303','2013-03-20','07:45:00',1.2),('9303','2013-03-20','07:50:00',1.24),('9303','2013-03-20','07:55:00',1.47),('9303','2013-03-20','08:00:00',1.42),('9303','2013-03-20','08:05:00',1.47),('9303','2013-03-20','08:10:00',1.71),('9303','2013-03-20','08:15:00',1.79),('9303','2013-03-20','08:20:00',1.88),('9303','2013-03-20','08:25:00',2.01),('9303','2013-03-20','08:30:00',2.11),('9303','2013-03-20','08:35:00',2.17),('9303','2013-03-20','08:40:00',2.02),('9303','2013-03-20','08:45:00',2.23),('9303','2013-03-20','08:50:00',2.34),('9303','2013-03-20','08:55:00',2.29),('9303','2013-03-20','09:00:00',2.25),('9303','2013-03-20','09:05:00',3.01),('9303','2013-03-20','09:10:00',2.38),('9303','2013-03-20','09:15:00',2.72),('9303','2013-03-20','09:20:00',2.7),('9303','2013-03-20','09:25:00',2.65),('9303','2013-03-20','09:30:00',3.01),('9303','2013-03-20','09:35:00',2.89),('9303','2013-03-20','09:40:00',3.06),('9303','2013-03-20','09:45:00',3.14),('9303','2013-03-20','09:50:00',3.17),('9303','2013-03-20','09:55:00',3.18),('9303','2013-03-20','10:00:00',3.26),('9303','2013-03-20','10:05:00',3.2),('9303','2013-03-20','10:10:00',3.35),('9303','2013-03-20','10:15:00',2.45),('9303','2013-03-20','10:20:00',2.41),('9303','2013-03-20','10:25:00',2.29),('9303','2013-03-20','10:30:00',2.88),('9303','2013-03-20','10:35:00',3.38),('9303','2013-03-20','10:40:00',2.98),('9303','2013-03-20','10:45:00',2.25),('9303','2013-03-20','10:50:00',3.15),('9303','2013-03-20','10:55:00',2.83),('9303','2013-03-20','11:00:00',2.71),('9303','2013-03-20','11:05:00',3.1),('9303','2013-03-20','11:10:00',2.59),('9303','2013-03-20','11:15:00',2.32),('9303','2013-03-20','11:20:00',2.58),('9303','2013-03-20','11:25:00',2.55),('9303','2013-03-20','11:30:00',2.35),('9303','2013-03-20','11:35:00',2.59),('9303','2013-03-20','11:40:00',2.08),('9303','2013-03-20','11:45:00',1.96),('9303','2013-03-20','11:50:00',1.85),('9303','2013-03-20','11:55:00',2.1),('9303','2013-03-20','12:00:00',2.02),('9303','2013-03-20','12:05:00',2.27),('9303','2013-03-20','12:10:00',1.86),('9303','2013-03-20','12:15:00',1.6),('9303','2013-03-20','12:20:00',1.48),('9303','2013-03-20','12:25:00',1.24),('9303','2013-03-20','12:35:00',1.2),('9303','2013-03-20','12:50:00',1.32),('9303','2013-03-20','12:55:00',1.52),('9303','2013-03-20','13:00:00',1.73),('9303','2013-03-20','13:05:00',1.25),('9303','2013-03-20','13:10:00',1.33),('9303','2013-03-20','13:15:00',1.06),('9303','2013-03-20','13:20:00',1.16),('9303','2013-03-20','13:25:00',1.25),('9303','2013-03-20','13:30:00',1.38),('9303','2013-03-20','13:35:00',1.3),('9303','2013-03-20','13:40:00',1.61),('9303','2013-03-20','13:45:00',1.92),('9303','2013-03-20','13:50:00',1.62),('9303','2013-03-20','13:55:00',1.5),('9303','2013-03-20','14:00:00',1.51),('9303','2013-03-20','14:05:00',1.28),('9303','2013-03-20','14:10:00',1.19),('9303','2013-03-20','14:15:00',1.57),('9303','2013-03-20','14:20:00',2.01),('9303','2013-03-20','14:25:00',1.85),('9303','2013-03-20','14:30:00',1.61),('9303','2013-03-20','14:35:00',1.31),('9303','2013-03-20','14:40:00',1.04),('9303','2013-03-20','14:45:00',1.02),('9303','2013-03-19','07:40:00',1.06),('9303','2013-03-19','07:45:00',1.16),('9303','2013-03-19','07:50:00',1.29),('9303','2013-03-19','07:55:00',1.32),('9303','2013-03-19','08:05:00',1.3),('9303','2013-03-19','08:10:00',1.59),('9303','2013-03-19','08:15:00',1.79),('9303','2013-03-19','08:20:00',1.87),('9303','2013-03-19','08:25:00',1.94),('9303','2013-03-19','08:30:00',1.87),('9303','2013-03-19','08:35:00',2.13),('9303','2013-03-19','08:40:00',2.23),('9303','2013-03-19','08:45:00',2.34),('9303','2013-03-19','08:50:00',2.44),('9303','2013-03-19','08:55:00',2.5),('9303','2013-03-19','09:00:00',2.58),('9303','2013-03-19','09:05:00',2.55),('9303','2013-03-19','09:10:00',2.75),('9303','2013-03-19','09:15:00',2.43),('9303','2013-03-19','09:20:00',2.57),('9303','2013-03-19','09:25:00',2.78),('9303','2013-03-19','09:30:00',3.05),('9303','2013-03-19','09:35:00',3.12),('9303','2013-03-19','09:40:00',3.24),('9303','2013-03-19','09:45:00',3.33),('9303','2013-03-19','09:50:00',3.4),('9303','2013-03-19','09:55:00',2.78),('9303','2013-03-19','10:00:00',3.54),('9303','2013-03-19','10:05:00',2.98),('9303','2013-03-19','10:10:00',3.28),('9303','2013-03-19','10:15:00',3.6),('9303','2013-03-19','10:20:00',3.65),('9303','2013-03-19','10:25:00',3.76),('9303','2013-03-19','10:30:00',3.77),('9303','2013-03-19','10:35:00',3.8),('9303','2013-03-19','10:40:00',3.84),('9303','2013-03-19','10:45:00',3.77),('9303','2013-03-19','10:50:00',3.93),('9303','2013-03-19','10:55:00',3.86),('9303','2013-03-19','11:00:00',4.01),('9303','2013-03-19','11:05:00',4.02),('9303','2013-03-19','11:10:00',3.96),('9303','2013-03-19','11:15:00',4.1),('9303','2013-03-19','11:20:00',4.11),('9303','2013-03-19','11:25:00',4.09),('9303','2013-03-19','11:30:00',4.11),('9303','2013-03-19','11:35:00',2.64),('9303','2013-03-19','11:40:00',3.61),('9303','2013-03-19','11:45:00',3.83),('9303','2013-03-19','11:50:00',4.16),('9303','2013-03-19','11:55:00',4.25),('9303','2013-03-19','12:00:00',4.21),('9303','2013-03-19','12:05:00',4.15),('9303','2013-03-19','12:10:00',4.16),('9303','2013-03-19','12:15:00',3.97),('9303','2013-03-19','12:20:00',4.17),('9303','2013-03-19','12:25:00',4.14),('9303','2013-03-19','12:30:00',4.15),('9303','2013-03-19','12:35:00',4.13),('9303','2013-03-19','12:40:00',4.12),('9303','2013-03-19','12:45:00',4.15),('9303','2013-03-19','12:50:00',3.97),('9303','2013-03-19','12:55:00',3.98),('9303','2013-03-19','13:00:00',4.08),('9303','2013-03-19','13:05:00',4.05),('9303','2013-03-19','13:10:00',3.99),('9303','2013-03-19','13:15:00',3.99),('9303','2013-03-19','13:20:00',3.93),('9303','2013-03-19','13:25:00',3.92),('9303','2013-03-19','13:30:00',3.92),('9303','2013-03-19','13:35:00',3.87),('9303','2013-03-19','13:40:00',3.8),('9303','2013-03-19','13:45:00',3.79),('9303','2013-03-19','13:50:00',3.76),('9303','2013-03-19','13:55:00',3.71),('9303','2013-03-19','14:00:00',3.69),('9303','2013-03-19','14:05:00',3.64),('9303','2013-03-19','14:10:00',3.63),('9303','2013-03-19','14:15:00',3.59),('9303','2013-03-19','14:20:00',3.53),('9303','2013-03-19','14:25:00',3.46),('9303','2013-03-19','14:30:00',3.38),('9303','2013-03-19','14:35:00',3.31),('9303','2013-03-19','14:40:00',3.27),('9303','2013-03-19','14:45:00',3.22),('9303','2013-03-19','14:50:00',3.13),('9303','2013-03-19','14:55:00',3.05),('9303','2013-03-19','15:00:00',2.98),('9303','2013-03-19','15:05:00',2.93),('9303','2013-03-19','15:10:00',2.86),('9303','2013-03-19','15:15:00',2.78),('9303','2013-03-19','15:20:00',2.73),('9303','2013-03-19','15:25:00',2.64),('9303','2013-03-19','15:30:00',2.56),('9303','2013-03-19','15:35:00',2.46),('9303','2013-03-19','15:40:00',2.34),('9303','2013-03-19','15:45:00',2.21),('9303','2013-03-19','15:50:00',2.13),('9303','2013-03-19','15:55:00',2.05),('9303','2013-03-19','16:00:00',1.95),('9303','2013-03-19','16:05:00',1.85),('9303','2013-03-19','16:10:00',1.73),('9303','2013-03-19','16:15:00',1.65),('9303','2013-03-19','16:20:00',1.56),('9303','2013-03-19','16:25:00',1.49),('9303','2013-03-19','16:30:00',1.4),('9303','2013-03-19','16:35:00',1.27),('9303','2013-03-19','16:40:00',1.18),('9303','2013-03-18','10:00:00',1.1),('9303','2013-03-18','10:05:00',1.36),('9303','2013-03-18','10:10:00',1.36),('9303','2013-03-18','10:15:00',1.17),('9303','2013-03-18','10:20:00',1.4),('9303','2013-03-18','10:25:00',1.8),('9303','2013-03-18','10:30:00',1.71),('9303','2013-03-18','10:35:00',1.39),('9303','2013-03-18','10:40:00',1.28),('9303','2013-03-18','10:45:00',1.33),('9303','2013-03-18','10:50:00',1.3),('9303','2013-03-18','10:55:00',1.07),('9303','2013-03-18','11:00:00',1.16),('9303','2013-03-18','11:05:00',1.29),('9303','2013-03-18','11:10:00',1.45),('9303','2013-03-18','11:15:00',1.58),('9303','2013-03-18','11:20:00',1.63),('9303','2013-03-18','11:25:00',1.71),('9303','2013-03-18','11:30:00',2.18),('9303','2013-03-18','11:35:00',1.81),('9303','2013-03-18','11:40:00',1.59),('9303','2013-03-18','11:45:00',1.33),('9303','2013-03-18','11:50:00',1.08),('9303','2013-03-18','11:55:00',1.32),('9303','2013-03-18','12:00:00',1.38),('9303','2013-03-18','12:05:00',2.37),('9303','2013-03-18','12:10:00',2.27),('9303','2013-03-18','12:15:00',2.71),('9303','2013-03-18','12:20:00',2.63),('9303','2013-03-18','12:25:00',1.81),('9303','2013-03-18','12:30:00',3.24),('9303','2013-03-18','12:35:00',3.5),('9303','2013-03-18','12:40:00',2.86),('9303','2013-03-18','12:45:00',2.46),('9303','2013-03-18','12:50:00',3.51),('9303','2013-03-18','12:55:00',3.7),('9303','2013-03-18','13:00:00',2.53),('9303','2013-03-18','13:05:00',1.39),('9303','2013-03-18','13:10:00',1.03),('9303','2013-03-18','13:25:00',1.57),('9303','2013-03-18','13:30:00',1.26),('9303','2013-03-18','13:35:00',1.05),('9303','2013-03-18','13:40:00',1.7),('9303','2013-03-18','13:45:00',1.63),('9303','2013-03-18','13:50:00',1.56),('9303','2013-03-18','13:55:00',1.42),('9303','2013-03-18','14:00:00',1.54),('9303','2013-03-18','14:05:00',2.42),('9303','2013-03-18','14:10:00',2.28),('9303','2013-03-18','14:15:00',1.12),('9303','2013-03-18','14:20:00',1.03),('9303','2013-03-18','14:25:00',1.43),('9303','2013-03-18','14:35:00',1.02),('9303','2013-03-18','14:40:00',1.1),('9303','2013-03-18','14:45:00',1),('9303','2013-03-17','08:15:00',1.11),('9303','2013-03-17','08:20:00',1.26),('9303','2013-03-17','08:25:00',1.51),('9303','2013-03-17','08:30:00',1.34),('9303','2013-03-17','08:35:00',1.12),('9303','2013-03-17','08:40:00',1.15),('9303','2013-03-17','08:45:00',1.36),('9303','2013-03-17','08:50:00',1.34),('9303','2013-03-17','08:55:00',1.25),('9303','2013-03-17','09:00:00',1.21),('9303','2013-03-17','09:05:00',1.42),('9303','2013-03-17','09:10:00',1.62),('9303','2013-03-17','09:15:00',1.76),('9303','2013-03-17','09:20:00',1.5),('9303','2013-03-17','09:25:00',1.25),('9303','2013-03-17','09:30:00',1.36),('9303','2013-03-17','09:35:00',1.57),('9303','2013-03-17','09:40:00',1.45),('9303','2013-03-17','09:45:00',1.47),('9303','2013-03-17','09:50:00',1.65),('9303','2013-03-17','09:55:00',1.79),('9303','2013-03-17','10:00:00',1.97),('9303','2013-03-17','10:05:00',1.65),('9303','2013-03-17','10:10:00',1.61),('9303','2013-03-17','10:15:00',1.76),('9303','2013-03-17','10:20:00',1.77),('9303','2013-03-17','10:25:00',1.86),('9303','2013-03-17','10:30:00',1.82),('9303','2013-03-17','10:35:00',1.73),('9303','2013-03-17','10:40:00',1.64),('9303','2013-03-17','10:45:00',1.73),('9303','2013-03-17','10:50:00',1.66),('9303','2013-03-17','10:55:00',1.48),('9303','2013-03-17','11:00:00',1.52),('9303','2013-03-17','11:05:00',1.32),('9303','2013-03-17','11:10:00',1.24),('9303','2013-03-17','11:15:00',1.33),('9303','2013-03-17','11:20:00',1.55),('9303','2013-03-17','11:25:00',1.62),('9303','2013-03-17','11:30:00',1.43),('9303','2013-03-17','11:35:00',1.41),('9303','2013-03-17','11:40:00',1.34),('9303','2013-03-17','11:45:00',1.23),('9303','2013-03-17','11:50:00',1.14),('9303','2013-03-17','11:55:00',1.02),('9303','2013-03-17','12:10:00',1.25),('9303','2013-03-17','12:15:00',1.72),('9303','2013-03-17','12:20:00',2.13),('9303','2013-03-17','12:25:00',3.3),('9303','2013-03-17','12:30:00',3.67),('9303','2013-03-17','12:35:00',2.36),('9303','2013-03-17','12:40:00',2.61),('9303','2013-03-17','12:45:00',2.38),('9303','2013-03-17','12:50:00',2.08),('9303','2013-03-17','12:55:00',1.59),('9303','2013-03-17','13:00:00',1.84),('9303','2013-03-17','13:05:00',2.07),('9303','2013-03-17','13:10:00',2.27),('9303','2013-03-17','13:15:00',2.21),('9303','2013-03-17','13:20:00',1.83),('9303','2013-03-17','13:25:00',1.63),('9303','2013-03-17','13:30:00',2.48),('9303','2013-03-17','13:35:00',2.87),('9303','2013-03-17','13:40:00',1.89),('9303','2013-03-17','13:45:00',1.71),('9303','2013-03-17','13:50:00',1.31),('9303','2013-03-17','13:55:00',1.92),('9303','2013-03-17','14:00:00',1.98),('9303','2013-03-17','14:05:00',1.92),('9303','2013-03-17','14:10:00',2.33),('9303','2013-03-17','14:15:00',2.62),('9303','2013-03-17','14:20:00',2.46),('9303','2013-03-17','14:25:00',2.41),('9303','2013-03-17','14:30:00',2.2),('9303','2013-03-17','14:35:00',1.83),('9303','2013-03-17','14:40:00',1.43),('9303','2013-03-17','14:45:00',1.26),('9303','2013-03-17','14:50:00',1.06),('9303','2013-03-17','14:55:00',1.11),('9303','2013-03-17','15:00:00',1.38),('9303','2013-03-17','15:05:00',1.54),('9303','2013-03-17','15:10:00',2),('9303','2013-03-17','15:15:00',1.83),('9303','2013-03-17','15:20:00',1.98),('9303','2013-03-17','15:25:00',1.81),('9303','2013-03-17','15:30:00',1.19),('9303','2013-03-17','15:35:00',1.49),('9303','2013-03-17','15:40:00',1.33),('9303','2013-03-17','15:45:00',1.43),('9303','2013-03-16','08:05:00',1.07),('9303','2013-03-16','08:15:00',1.49),('9303','2013-03-16','08:20:00',2.03),('9303','2013-03-16','08:25:00',2.18),('9303','2013-03-16','08:30:00',2.16),('9303','2013-03-16','08:35:00',2.25),('9303','2013-03-16','08:40:00',2.34),('9303','2013-03-16','08:45:00',2.21),('9303','2013-03-16','08:50:00',2.52),('9303','2013-03-16','08:55:00',2.71),('9303','2013-03-16','09:00:00',2.64),('9303','2013-03-16','09:05:00',1.83),('9303','2013-03-16','09:10:00',2.41),('9303','2013-03-16','09:15:00',2.93),('9303','2013-03-16','09:20:00',2.99),('9303','2013-03-16','09:25:00',2.85),('9303','2013-03-16','09:30:00',3.11),('9303','2013-03-16','09:35:00',3.32),('9303','2013-03-16','09:40:00',3.38),('9303','2013-03-16','09:45:00',3.56),('9303','2013-03-16','09:50:00',3.46),('9303','2013-03-16','09:55:00',3.57),('9303','2013-03-16','10:00:00',2.85),('9303','2013-03-16','10:05:00',1.76),('9303','2013-03-16','10:10:00',2.54),('9303','2013-03-16','10:15:00',2.49),('9303','2013-03-16','10:20:00',1.71),('9303','2013-03-16','10:25:00',2.2),('9303','2013-03-16','10:30:00',1.98),('9303','2013-03-16','10:35:00',1.69),('9303','2013-03-16','10:40:00',2.97),('9303','2013-03-16','10:45:00',3.95),('9303','2013-03-16','10:50:00',3.93),('9303','2013-03-16','10:55:00',3.81),('9303','2013-03-16','11:00:00',3.99),('9303','2013-03-16','11:05:00',4),('9303','2013-03-16','11:10:00',4.02),('9303','2013-03-16','11:15:00',4.04),('9303','2013-03-16','11:20:00',4.03),('9303','2013-03-16','11:25:00',4.05),('9303','2013-03-16','11:30:00',4.07),('9303','2013-03-16','11:35:00',4.08),('9303','2013-03-16','11:40:00',4.12),('9303','2013-03-16','11:45:00',4.13),('9303','2013-03-16','11:50:00',4.11),('9303','2013-03-16','11:55:00',4.12),('9303','2013-03-16','12:00:00',4.11),('9303','2013-03-16','12:05:00',4.09),('9303','2013-03-16','12:10:00',4.13),('9303','2013-03-16','12:15:00',4.14),('9303','2013-03-16','12:20:00',4.11),('9303','2013-03-16','12:25:00',4.12),('9303','2013-03-16','12:30:00',4.11),('9303','2013-03-16','12:35:00',4.09),('9303','2013-03-16','12:40:00',4.04),('9303','2013-03-16','12:45:00',4.03),('9303','2013-03-16','12:50:00',4.01),('9303','2013-03-16','12:55:00',3.95),('9303','2013-03-16','13:00:00',3.92),('9303','2013-03-16','13:05:00',3.92),('9303','2013-03-16','13:10:00',3.91),('9303','2013-03-16','13:15:00',3.92),('9303','2013-03-16','13:20:00',1.84),('9303','2013-03-16','13:30:00',1.22),('9303','2013-03-16','13:35:00',3.51),('9303','2013-03-16','13:40:00',3.95),('9303','2013-03-16','13:45:00',3.89),('9303','2013-03-16','13:50:00',3.81),('9303','2013-03-16','13:55:00',3.26),('9303','2013-03-16','14:00:00',3.88),('9303','2013-03-16','14:05:00',3.75),('9303','2013-03-16','14:10:00',1.16),('9303','2013-03-16','14:15:00',3.24),('9303','2013-03-16','14:20:00',1.78),('9303','2013-03-16','14:25:00',1.56),('9303','2013-03-16','14:30:00',3.65),('9303','2013-03-16','14:35:00',3.38),('9303','2013-03-16','14:40:00',1.29),('9303','2013-03-16','16:05:00',1.58),('9303','2013-03-16','16:10:00',1.45),('9303','2013-03-16','16:15:00',1.39),('9303','2013-03-15','10:40:00',1.1),('9303','2013-03-15','10:45:00',1.31),('9303','2013-03-15','10:50:00',1.32),('9303','2013-03-15','10:55:00',1.41),('9303','2013-03-15','11:00:00',1.37),('9303','2013-03-15','11:05:00',1.22),('9303','2013-03-15','11:10:00',1.15),('9303','2013-03-15','11:20:00',1.16),('9303','2013-03-15','11:25:00',1.39),('9303','2013-03-15','11:30:00',1.56),('9303','2013-03-15','11:35:00',1.88),('9303','2013-03-15','11:40:00',2.28),('9303','2013-03-15','11:45:00',2.04),('9303','2013-03-15','11:50:00',1.91),('9303','2013-03-15','11:55:00',1.97),('9303','2013-03-15','12:00:00',1.75),('9303','2013-03-15','12:05:00',1.75),('9303','2013-03-15','12:10:00',1.86),('9303','2013-03-15','12:15:00',1.64),('9303','2013-03-15','12:20:00',1.61),('9303','2013-03-15','12:25:00',1.66),('9303','2013-03-15','12:30:00',1.71),('9303','2013-03-15','12:35:00',1.93),('9303','2013-03-15','12:40:00',1.71),('9303','2013-03-15','12:45:00',1.44),('9303','2013-03-15','12:50:00',1.36),('9303','2013-03-15','12:55:00',1.3),('9303','2013-03-15','13:00:00',1.22),('9303','2013-03-15','13:05:00',1.12),('9303','2013-03-15','13:10:00',1.17),('9303','2013-03-15','13:15:00',1.29),('9303','2013-03-15','13:20:00',1.37),('9303','2013-03-15','13:25:00',1.53),('9303','2013-03-15','13:30:00',1.48),('9303','2013-03-15','13:35:00',1.36),('9303','2013-03-15','13:40:00',1.41),('9303','2013-03-15','13:45:00',1.5),('9303','2013-03-15','13:50:00',1.24),('9303','2013-03-15','13:55:00',1.07),('9303','2013-03-15','14:55:00',1.06),('9303','2013-03-15','15:00:00',1.1);
INSERT INTO `solarlog` VALUES ('9303','2013-03-15','15:05:00',1.07),('9303','2013-03-15','15:10:00',1.07),('9303','2013-03-15','15:15:00',1.16),('9303','2013-03-15','15:20:00',1.17),('9303','2013-03-15','15:25:00',1.26),('9303','2013-03-15','15:30:00',1.13),('9303','2013-03-14','13:05:00',1.07),('9303','2013-03-14','13:10:00',1.06),('9303','2013-03-14','13:15:00',1.04),('9303','2013-03-14','13:20:00',1.13),('9303','2013-03-14','13:25:00',1.12),('9303','2013-03-14','13:30:00',1.06),('9303','2013-03-14','13:35:00',1.05),('9303','2013-03-14','13:40:00',1.09),('9303','2013-03-14','13:45:00',1.5),('9303','2013-03-14','13:50:00',1.86),('9303','2013-03-14','13:55:00',2.23),('9303','2013-03-14','14:00:00',1.84),('9303','2013-03-14','14:05:00',1.93),('9303','2013-03-14','14:10:00',1.18),('9303','2013-03-14','14:15:00',1.2),('9303','2013-03-14','14:20:00',1.06),('9303','2013-03-14','14:25:00',1.05),('9303','2013-03-14','14:30:00',1),('9303','2013-03-14','15:10:00',1.2),('9303','2013-03-14','15:15:00',1.23),('9303','2013-03-14','15:20:00',1.13),('9303','2013-03-14','15:25:00',1.15),('9303','2013-03-14','15:30:00',1.12),('9303','2013-03-13','08:50:00',1.06),('9303','2013-03-13','08:55:00',1.05),('9303','2013-03-13','09:10:00',1.12),('9303','2013-03-13','10:10:00',1.02),('9303','2013-03-13','10:15:00',2.07),('9303','2013-03-13','10:20:00',1.48),('9303','2013-03-13','10:25:00',1.78),('9303','2013-03-13','10:30:00',3.41),('9303','2013-03-13','10:35:00',2.6),('9303','2013-03-13','10:40:00',3.04),('9303','2013-03-13','10:45:00',1.4),('9303','2013-03-13','10:50:00',1.16),('9303','2013-03-13','10:55:00',1.01),('9303','2013-03-13','11:00:00',1.16),('9303','2013-03-13','11:30:00',1.05),('9303','2013-03-13','11:35:00',1.09),('9303','2013-03-13','11:40:00',1.09),('9303','2013-03-13','11:45:00',1.19),('9303','2013-03-13','11:50:00',1.09),('9303','2013-03-13','12:45:00',1.02),('9303','2013-03-13','12:50:00',1.22),('9303','2013-03-13','12:55:00',1.09),('9303','2013-03-13','13:00:00',1.04),('9303','2013-03-13','13:05:00',1.02),('9303','2014-03-25','07:20:00',1.12),('9303','2014-03-25','07:25:00',1.25),('9303','2014-03-25','07:30:00',1.38),('9303','2014-03-25','07:35:00',1.1),('9303','2014-03-25','07:40:00',1.01),('9303','2014-03-25','07:45:00',1.12),('9303','2014-03-25','07:50:00',1.18),('9303','2014-03-25','07:55:00',1.22),('9303','2014-03-25','08:00:00',1.14),('9303','2014-03-25','08:05:00',1.18),('9303','2014-03-25','08:10:00',1.27),('9303','2014-03-25','08:15:00',1.35),('9303','2014-03-25','08:20:00',1.21),('9303','2014-03-25','08:25:00',1.09),('9303','2014-03-25','08:35:00',1.01),('9303','2014-03-25','08:40:00',1.22),('9303','2014-03-25','08:45:00',1.75),('9303','2014-03-25','08:50:00',1.79),('9303','2014-03-25','08:55:00',1.9),('9303','2014-03-25','09:00:00',1.71),('9303','2014-03-25','09:05:00',1.67),('9303','2014-03-25','09:10:00',1.67),('9303','2014-03-25','09:15:00',2.21),('9303','2014-03-25','09:20:00',2.38),('9303','2014-03-25','09:25:00',2.08),('9303','2014-03-25','09:30:00',1.85),('9303','2014-03-25','09:35:00',1.69),('9303','2014-03-25','09:40:00',1.73),('9303','2014-03-25','09:45:00',1.64),('9303','2014-03-25','09:50:00',1.73),('9303','2014-03-25','09:55:00',1.95),('9303','2014-03-25','10:00:00',2.28),('9303','2014-03-25','10:05:00',2.43),('9303','2014-03-25','10:10:00',2.56),('9303','2014-03-25','10:15:00',2.75),('9303','2014-03-25','10:20:00',2.51),('9303','2014-03-25','10:25:00',2.56),('9303','2014-03-25','10:30:00',2.87),('9303','2014-03-25','10:35:00',2.41),('9303','2014-03-25','10:40:00',1.96),('9303','2014-03-25','10:45:00',1.78),('9303','2014-03-25','10:50:00',1.7),('9303','2014-03-25','10:55:00',1.71),('9303','2014-03-25','11:00:00',1.9),('9303','2014-03-25','11:05:00',2.18),('9303','2014-03-25','11:10:00',2.5),('9303','2014-03-25','11:15:00',2.87),('9303','2014-03-25','11:20:00',2.67),('9303','2014-03-25','11:25:00',2.74),('9303','2014-03-25','11:30:00',2.94),('9303','2014-03-25','11:35:00',2.35),('9303','2014-03-25','11:40:00',2.2),('9303','2014-03-25','11:45:00',1.96),('9303','2014-03-25','11:50:00',2.23),('9303','2014-03-25','11:55:00',1.8),('9303','2014-03-25','12:00:00',1.19),('9303','2014-03-25','12:20:00',1.06),('9303','2014-03-25','12:25:00',1.23),('9303','2013-03-12','08:20:00',1.7),('9303','2013-03-12','08:25:00',1.79),('9303','2013-03-12','08:30:00',1.86),('9303','2013-03-12','08:35:00',1.78),('9303','2013-03-12','08:40:00',1.86),('9303','2013-03-12','08:45:00',2.32),('9303','2013-03-12','08:50:00',1.48),('9303','2013-03-12','09:00:00',1.47),('9303','2013-03-12','09:05:00',2.48),('9303','2013-03-12','09:10:00',2.55),('9303','2013-03-12','09:15:00',2.6),('9303','2013-03-12','09:20:00',2.66),('9303','2013-03-12','09:25:00',2.74),('9303','2013-03-12','09:30:00',2.83),('9303','2013-03-12','09:35:00',2.9),('9303','2013-03-12','09:40:00',2.88),('9303','2013-03-12','09:45:00',2.94),('9303','2013-03-12','09:50:00',2.49),('9303','2013-03-12','09:55:00',3.33),('9303','2013-03-12','10:00:00',3.37),('9303','2013-03-12','10:05:00',3.05),('9303','2013-03-12','10:10:00',2.57),('9303','2013-03-12','10:15:00',3.11),('9303','2013-03-12','10:20:00',3.08),('9303','2013-03-12','10:25:00',3.79),('9303','2013-03-12','10:30:00',3.53),('9303','2013-03-12','10:35:00',2.4),('9303','2013-03-12','10:40:00',3.24),('9303','2013-03-12','10:45:00',1.43),('9303','2013-03-12','10:50:00',3.94),('9303','2013-03-12','10:55:00',3.85),('9303','2013-03-12','11:00:00',3.45),('9303','2013-03-12','11:05:00',4.29),('9303','2013-03-12','11:10:00',3.02),('9303','2013-03-12','11:15:00',3.17),('9303','2013-03-12','11:20:00',4.45),('9303','2013-03-12','11:25:00',1.6),('9303','2013-03-12','11:30:00',1.66),('9303','2013-03-12','11:35:00',1.69),('9303','2013-03-12','11:40:00',2),('9303','2013-03-12','11:45:00',2.23),('9303','2013-03-12','11:50:00',2.61),('9303','2013-03-12','11:55:00',3.7),('9303','2013-03-12','12:05:00',1.22),('9303','2013-03-12','12:10:00',3.93),('9303','2013-03-12','12:15:00',3.56),('9303','2013-03-12','12:20:00',1.84),('9303','2013-03-12','12:25:00',4.07),('9303','2013-03-12','12:30:00',5),('9303','2013-03-12','12:35:00',3.05),('9303','2013-03-12','12:40:00',3.79),('9303','2013-03-12','12:50:00',1.66),('9303','2013-03-12','12:55:00',1.96),('9303','2013-03-12','13:00:00',3.97),('9303','2013-03-12','13:05:00',2.11),('9303','2013-03-12','13:10:00',2.42),('9303','2013-03-12','13:15:00',2.38),('9303','2013-03-12','13:20:00',3.06),('9303','2013-03-12','13:25:00',1.91),('9303','2013-03-12','13:30:00',1.43),('9303','2013-03-12','13:35:00',1.64),('9303','2013-03-12','13:40:00',1.61),('9303','2013-03-12','13:45:00',1.1),('9303','2013-03-12','13:50:00',1.07),('9303','2013-03-12','13:55:00',1.77),('9303','2013-03-12','14:00:00',2.53),('9303','2013-03-12','14:05:00',1.95),('9303','2013-03-12','14:10:00',2.39),('9303','2013-03-11','08:15:00',1.31),('9303','2013-03-11','08:20:00',1.39),('9303','2013-03-11','08:25:00',1.5),('9303','2013-03-11','08:30:00',1.58),('9303','2013-03-11','08:35:00',1.67),('9303','2013-03-11','08:40:00',1.76),('9303','2013-03-11','08:45:00',1.84),('9303','2013-03-11','08:50:00',1.92),('9303','2013-03-11','08:55:00',1.98),('9303','2013-03-11','09:00:00',2.03),('9303','2013-03-11','09:05:00',2.09),('9303','2013-03-11','09:10:00',2.12),('9303','2013-03-11','09:15:00',2.25),('9303','2013-03-11','09:20:00',2.02),('9303','2013-03-11','09:25:00',1.7),('9303','2013-03-11','09:35:00',2.2),('9303','2013-03-11','09:40:00',2.7),('9303','2013-03-11','09:45:00',2.51),('9303','2013-03-11','10:10:00',1.03),('9303','2013-03-11','10:15:00',1.08),('9303','2013-03-11','10:20:00',1.2),('9303','2013-03-11','10:25:00',1.31),('9303','2013-03-11','10:30:00',1.19),('9303','2013-03-11','10:35:00',1.33),('9303','2013-03-11','10:40:00',1.83),('9303','2013-03-11','10:45:00',2.1),('9303','2013-03-11','10:50:00',2.8),('9303','2013-03-11','10:55:00',1.57),('9303','2013-03-11','11:00:00',1.4),('9303','2013-03-11','11:05:00',1.18),('9303','2013-03-11','11:10:00',1.35),('9303','2013-03-11','11:15:00',1.46),('9303','2013-03-11','11:20:00',1.28),('9303','2013-03-11','11:25:00',1.15),('9303','2013-03-11','11:30:00',2.17),('9303','2013-03-11','11:35:00',2.11),('9303','2013-03-11','11:40:00',1.81),('9303','2013-03-11','11:45:00',2.4),('9303','2013-03-11','11:50:00',2.04),('9303','2013-03-11','11:55:00',1.81),('9303','2013-03-11','12:00:00',1.61),('9303','2013-03-11','12:05:00',1.6),('9303','2013-03-11','12:10:00',2.1),('9303','2013-03-11','12:35:00',1.26),('9303','2013-03-11','12:40:00',1.14),('9303','2013-03-11','12:45:00',1.15),('9303','2013-03-11','12:50:00',1.95),('9303','2013-03-11','12:55:00',3.26),('9303','2013-03-11','13:00:00',2.61),('9303','2013-03-11','13:05:00',1.8),('9303','2013-03-11','13:10:00',2.47),('9303','2013-03-11','13:15:00',3.32),('9303','2013-03-11','13:20:00',3.22),('9303','2013-03-11','13:25:00',3.48),('9303','2013-03-11','13:30:00',3.32),('9303','2013-03-11','13:35:00',3.56),('9303','2013-03-11','13:40:00',3.22),('9303','2013-03-11','13:45:00',2.43),('9303','2013-03-11','13:50:00',1.53),('9303','2013-03-11','13:55:00',1.73),('9303','2013-03-11','14:25:00',1.69),('9303','2013-03-11','14:30:00',1.1),('9303','2013-03-11','14:40:00',1.38),('9303','2013-03-11','15:25:00',1.27),('9303','2013-03-11','15:30:00',2.01),('9303','2013-03-11','15:35:00',1.47),('9303','2013-03-11','15:40:00',1.31),('9303','2013-03-11','15:45:00',2.19),('9303','2013-03-11','15:50:00',1.8),('9303','2013-03-11','15:55:00',1.7),('9303','2013-03-11','16:00:00',1.43),('9303','2013-03-11','16:05:00',1.43),('9303','2013-03-11','16:10:00',1.16),('9303','2013-03-11','16:25:00',1.02),('9303','2013-03-11','16:30:00',1),('9303','2013-03-11','16:35:00',1.01),('9303','2013-03-11','16:45:00',1.18),('9303','2013-03-10','07:55:00',1.01),('9303','2013-03-10','08:00:00',1.07),('9303','2013-03-10','08:05:00',1.14),('9303','2013-03-10','08:10:00',1.26),('9303','2013-03-10','08:15:00',1.17),('9303','2013-03-10','08:20:00',1.39),('9303','2013-03-10','08:25:00',1.44),('9303','2013-03-10','08:30:00',1.51),('9303','2013-03-10','08:35:00',1.59),('9303','2013-03-10','08:40:00',1.66),('9303','2013-03-10','08:45:00',1.72),('9303','2013-03-10','08:50:00',1.79),('9303','2013-03-10','08:55:00',1.89),('9303','2013-03-10','09:00:00',1.96),('9303','2013-03-10','09:05:00',2.03),('9303','2013-03-10','09:10:00',2.09),('9303','2013-03-10','09:15:00',2.15),('9303','2013-03-10','09:20:00',2.21),('9303','2013-03-10','09:25:00',2.27),('9303','2013-03-10','09:30:00',2.34),('9303','2013-03-10','09:35:00',2.41),('9303','2013-03-10','09:40:00',2.51),('9303','2013-03-10','09:45:00',2.22),('9303','2013-03-10','09:50:00',1.83),('9303','2013-03-10','09:55:00',2.89),('9303','2013-03-10','10:00:00',1.56),('9303','2013-03-10','10:05:00',2.26),('9303','2013-03-10','10:10:00',2.53),('9303','2013-03-10','10:15:00',2.08),('9303','2013-03-10','10:20:00',2.31),('9303','2013-03-10','10:25:00',2.95),('9303','2013-03-10','10:30:00',2.55),('9303','2013-03-10','10:35:00',2.88),('9303','2013-03-10','10:40:00',2.64),('9303','2013-03-10','10:45:00',3.13),('9303','2013-03-10','10:50:00',2.86),('9303','2013-03-10','10:55:00',2.09),('9303','2013-03-10','11:00:00',2.55),('9303','2013-03-10','11:05:00',1.69),('9303','2013-03-10','11:10:00',2.67),('9303','2013-03-10','11:15:00',2.48),('9303','2013-03-10','11:20:00',1.25),('9303','2013-03-10','11:25:00',2.69),('9303','2013-03-10','11:30:00',1.68),('9303','2013-03-10','11:35:00',1.46),('9303','2013-03-10','11:40:00',1.25),('9303','2013-03-10','11:45:00',1.32),('9303','2013-03-10','11:50:00',1.94),('9303','2013-03-10','11:55:00',3.55),('9303','2013-03-10','12:00:00',3.2),('9303','2013-03-10','12:05:00',3.35),('9303','2013-03-10','12:10:00',3.47),('9303','2013-03-10','12:15:00',2.65),('9303','2013-03-10','12:20:00',2.63),('9303','2013-03-10','12:25:00',3.02),('9303','2013-03-10','12:30:00',1.27),('9303','2013-03-10','12:35:00',1.67),('9303','2013-03-10','12:40:00',1.55),('9303','2013-03-10','12:45:00',3.66),('9303','2013-03-10','12:50:00',3.54),('9303','2013-03-10','12:55:00',3.5),('9303','2013-03-10','13:00:00',3.36),('9303','2013-03-10','13:05:00',3.25),('9303','2013-03-10','13:10:00',3.09),('9303','2013-03-10','13:15:00',3.3),('9303','2013-03-10','13:20:00',3.35),('9303','2013-03-10','13:25:00',3.07),('9303','2013-03-10','13:30:00',3),('9303','2013-03-10','13:35:00',2.79),('9303','2013-03-10','13:40:00',1.62),('9303','2013-03-10','13:45:00',1.8),('9303','2013-03-10','13:50:00',1.6),('9303','2013-03-10','13:55:00',1.56),('9303','2013-03-10','14:00:00',1.35),('9303','2013-03-10','14:05:00',1.62),('9303','2013-03-10','14:10:00',1.77),('9303','2013-03-10','14:15:00',2.41),('9303','2013-03-10','14:20:00',2.4),('9303','2013-03-10','14:25:00',1.5),('9303','2013-03-10','14:30:00',1.59),('9303','2013-03-10','14:35:00',2.55),('9303','2013-03-10','14:40:00',2.22),('9303','2013-03-10','14:45:00',1.45),('9303','2013-03-10','14:50:00',1.44),('9303','2013-03-10','14:55:00',1.34),('9303','2013-03-10','15:00:00',1.02),('9303','2013-03-10','15:05:00',1.17),('9303','2013-03-10','15:10:00',1.2),('9303','2013-03-09','08:05:00',1.31),('9303','2013-03-09','08:10:00',1.25),('9303','2013-03-09','08:15:00',1.3),('9303','2013-03-09','08:20:00',1.34),('9303','2013-03-09','08:25:00',1.44),('9303','2013-03-09','08:30:00',1.52),('9303','2013-03-09','08:35:00',1.61),('9303','2013-03-09','08:40:00',1.71),('9303','2013-03-09','08:45:00',1.16),('9303','2013-03-09','08:50:00',1.12),('9303','2013-03-09','08:55:00',1.61),('9303','2013-03-09','09:00:00',1.21),('9303','2013-03-09','09:30:00',1.62),('9303','2013-03-09','09:35:00',1.99),('9303','2013-03-09','09:40:00',2.9),('9303','2013-03-09','09:45:00',3.16),('9303','2013-03-09','09:50:00',2.04),('9303','2013-03-09','09:55:00',2.31),('9303','2013-03-09','10:00:00',1),('9303','2013-03-09','10:05:00',1.03),('9303','2013-03-09','10:10:00',1.13),('9303','2013-03-09','10:20:00',1.22),('9303','2013-03-09','10:35:00',1.2),('9303','2013-03-09','10:40:00',1.77),('9303','2013-03-09','10:45:00',1.76),('9303','2013-03-09','10:50:00',3.44),('9303','2013-03-09','10:55:00',3),('9303','2013-03-09','11:00:00',2.78),('9303','2013-03-09','11:05:00',3.41),('9303','2013-03-09','11:10:00',3.31),('9303','2013-03-09','11:15:00',3.48),('9303','2013-03-09','11:20:00',3.49),('9303','2013-03-09','11:25:00',3.25),('9303','2013-03-09','11:30:00',3.4),('9303','2013-03-09','11:35:00',3.34),('9303','2013-03-09','11:40:00',3.37),('9303','2013-03-09','11:45:00',3.41),('9303','2013-03-09','11:50:00',3.32),('9303','2013-03-09','11:55:00',3.33),('9303','2013-03-09','12:00:00',3.13),('9303','2013-03-09','12:05:00',1.67),('9303','2013-03-09','12:10:00',1.53),('9303','2013-03-09','12:20:00',1.08),('9303','2013-03-09','12:25:00',1.71),('9303','2013-03-09','12:30:00',1.28),('9303','2013-03-09','12:35:00',1.37),('9303','2013-03-09','12:40:00',1.36),('9303','2013-03-09','12:45:00',1.8),('9303','2013-03-09','12:50:00',1.69),('9303','2013-03-09','12:55:00',2.54),('9303','2013-03-09','13:00:00',3.38),('9303','2013-03-09','13:05:00',3.27),('9303','2013-03-09','13:10:00',3.25),('9303','2013-03-09','13:15:00',3.29),('9303','2013-03-09','13:20:00',3.11),('9303','2013-03-09','13:25:00',2.3),('9303','2013-03-09','13:30:00',2.95),('9303','2013-03-09','13:35:00',2.86),('9303','2013-03-09','13:40:00',3.33),('9303','2013-03-09','13:45:00',3.17),('9303','2013-03-09','13:50:00',3.12),('9303','2013-03-09','13:55:00',1.22),('9303','2013-03-09','14:00:00',1),('9303','2013-03-09','14:05:00',1.03),('9303','2013-03-09','14:10:00',3.23),('9303','2013-03-09','14:15:00',2.14),('9303','2013-03-09','14:20:00',2.79),('9303','2013-03-09','14:25:00',2.69),('9303','2013-03-09','14:30:00',2.65),('9303','2013-03-09','14:35:00',2.59),('9303','2013-03-09','14:40:00',2.52),('9303','2013-03-09','14:45:00',2.48),('9303','2013-03-09','14:50:00',2.42),('9303','2013-03-09','14:55:00',2.37),('9303','2013-03-09','15:00:00',2.32),('9303','2013-03-09','15:05:00',2.25),('9303','2013-03-09','15:10:00',2.19),('9303','2013-03-09','15:15:00',2.13),('9303','2013-03-09','15:20:00',2.06),('9303','2013-03-09','15:25:00',1.97),('9303','2013-03-09','15:30:00',1.9),('9303','2013-03-09','15:35:00',1.84),('9303','2013-03-09','15:40:00',1.75),('9303','2013-03-09','15:45:00',1.7),('9303','2013-03-09','15:50:00',1.63),('9303','2013-03-09','15:55:00',1.46),('9303','2013-03-09','16:00:00',1.31),('9303','2013-03-09','16:05:00',1.31),('9303','2013-03-09','16:10:00',1.02),('9303','2013-03-09','16:15:00',1.16),('9303','2013-03-09','16:25:00',1.09),('9303','2013-03-08','08:30:00',1.2),('9303','2013-03-08','08:35:00',1.46),('9303','2013-03-08','09:30:00',1.34),('9303','2013-03-08','09:35:00',1.61),('9303','2013-03-08','09:45:00',1.41),('9303','2013-03-08','09:50:00',1.81),('9303','2013-03-08','09:55:00',1.53),('9303','2013-03-08','10:05:00',1.03),('9303','2013-03-08','10:10:00',1.36),('9303','2013-03-08','10:15:00',2.03),('9303','2013-03-08','10:20:00',1.69),('9303','2013-03-08','10:25:00',1.16),('9303','2013-03-08','10:30:00',1.34),('9303','2013-03-08','10:35:00',1.76),('9303','2013-03-08','10:40:00',1.38),('9303','2013-03-08','10:50:00',1.02),('9303','2013-03-08','10:55:00',1.04),('9303','2013-03-08','11:00:00',1.02),('9303','2013-03-08','11:35:00',1.11),('9303','2013-03-08','11:40:00',1.54),('9303','2013-03-08','11:45:00',1.28),('9303','2013-03-08','11:50:00',1.11),('9303','2013-03-08','11:55:00',1.18),('9303','2013-03-08','12:00:00',1.74),('9303','2013-03-08','12:05:00',1.21),('9303','2013-03-08','12:20:00',1.12),('9303','2013-03-08','12:35:00',1.27),('9303','2013-03-08','12:40:00',1.62),('9303','2013-03-08','12:45:00',1.82),('9303','2013-03-08','12:50:00',1.9),('9303','2013-03-08','12:55:00',1.6),('9303','2013-03-08','13:00:00',1.7),('9303','2013-03-08','13:05:00',1.68),('9303','2013-03-08','13:10:00',1.2),('9303','2013-03-08','13:25:00',1.18),('9303','2013-03-08','13:30:00',1.5),('9303','2013-03-08','13:35:00',1.12),('9303','2013-03-08','13:40:00',1.03),('9303','2013-03-07','10:55:00',1.08),('9303','2013-03-07','11:05:00',1.42),('9303','2013-03-07','11:10:00',1.02),('9303','2013-03-07','11:30:00',1.24),('9303','2013-03-07','11:35:00',1.77),('9303','2013-03-07','11:40:00',1.77),('9303','2013-03-07','11:45:00',2.12),('9303','2013-03-07','11:50:00',2.13),('9303','2013-03-07','11:55:00',1.42),('9303','2013-03-07','12:00:00',1.15),('9303','2013-03-07','12:40:00',1.2),('9303','2013-03-07','12:45:00',1.69),('9303','2013-03-07','12:50:00',1.6),('9303','2013-03-07','12:55:00',1.41),('9303','2013-03-07','13:00:00',1.49),('9303','2013-03-07','13:05:00',1.57),('9303','2013-03-07','13:10:00',1.36),('9303','2013-03-07','13:15:00',1.5),('9303','2013-03-07','13:20:00',1.86),('9303','2013-03-07','13:25:00',1.65),('9303','2013-03-07','13:30:00',1.36),('9303','2013-03-07','13:35:00',1.22),('9303','2013-03-05','08:15:00',1.16),('9303','2013-03-05','08:20:00',1.11),('9303','2013-03-05','08:25:00',1.26),('9303','2013-03-05','08:30:00',1.79),('9303','2013-03-05','08:35:00',1.62),('9303','2013-03-05','08:40:00',1.68),('9303','2013-03-05','08:45:00',1.35),('9303','2013-03-05','08:50:00',1.41),('9303','2013-03-05','08:55:00',1.38),('9303','2013-03-05','09:00:00',1.51),('9303','2013-03-05','09:05:00',1.52),('9303','2013-03-05','09:10:00',1.44),('9303','2013-03-05','09:15:00',1.36),('9303','2013-03-05','09:20:00',1.37),('9303','2013-03-05','09:25:00',1.34),('9303','2013-03-05','09:30:00',1.41),('9303','2013-03-05','09:35:00',1.54),('9303','2013-03-05','09:40:00',1.61),('9303','2013-03-05','09:45:00',1.63),('9303','2013-03-05','09:50:00',1.65),('9303','2013-03-05','09:55:00',1.55),('9303','2013-03-05','10:00:00',1.51),('9303','2013-03-05','10:05:00',1.67),('9303','2013-03-05','10:10:00',1.75),('9303','2013-03-05','10:15:00',1.72),('9303','2013-03-05','10:20:00',1.9),('9303','2013-03-05','10:25:00',1.81),('9303','2013-03-05','10:30:00',1.7),('9303','2013-03-05','10:35:00',1.94),('9303','2013-03-05','10:40:00',2.01),('9303','2013-03-05','10:45:00',2.12),('9303','2013-03-05','10:50:00',2.26),('9303','2013-03-05','10:55:00',2.32),('9303','2013-03-05','11:00:00',2.23),('9303','2013-03-05','11:05:00',2.33),('9303','2013-03-05','11:10:00',2.38),('9303','2013-03-05','11:15:00',2.34),('9303','2013-03-05','11:20:00',2.31),('9303','2013-03-05','11:25:00',2.26),('9303','2013-03-05','11:30:00',2.31),('9303','2013-03-05','11:35:00',2.53),('9303','2013-03-05','11:40:00',2.73),('9303','2013-03-05','11:45:00',2.63),('9303','2013-03-05','11:50:00',2.7),('9303','2013-03-05','11:55:00',2.74),('9303','2013-03-05','12:00:00',2.77),('9303','2013-03-05','12:05:00',2.82),('9303','2013-03-05','12:10:00',2.96),('9303','2013-03-05','12:15:00',2.42),('9303','2013-03-05','12:20:00',2.69),('9303','2013-03-05','12:25:00',2.76),('9303','2013-03-05','12:30:00',2.32),('9303','2013-03-05','12:35:00',2.44),('9303','2013-03-05','12:40:00',2.37),('9303','2013-03-05','12:45:00',2.41),('9303','2013-03-05','12:50:00',2.12),('9303','2013-03-05','12:55:00',1.95),('9303','2013-03-05','13:00:00',1.59),('9303','2013-03-05','13:05:00',1.53),('9303','2013-03-05','13:10:00',1.62),('9303','2013-03-05','13:15:00',1.72),('9303','2013-03-05','13:20:00',1.68),('9303','2013-03-05','13:25:00',1.51),('9303','2013-03-05','13:30:00',1.38),('9303','2013-03-05','13:35:00',1.3),('9303','2013-03-05','13:40:00',1.23),('9303','2013-03-05','13:45:00',1.12),('9303','2013-03-05','13:50:00',1.02),('9303','2013-03-05','14:10:00',1.02),('9303','2013-03-05','15:45:00',1.04),('9303','2013-03-05','15:50:00',1.02),('9303','2013-03-04','08:10:00',1.06),('9303','2013-03-04','08:15:00',1.18),('9303','2013-03-04','08:20:00',1.24),('9303','2013-03-04','08:25:00',1.33),('9303','2013-03-04','08:30:00',1.44),('9303','2013-03-04','08:35:00',1.49),('9303','2013-03-04','08:40:00',1.6),('9303','2013-03-04','08:45:00',1.68),('9303','2013-03-04','08:50:00',1.75),('9303','2013-03-04','08:55:00',1.82),('9303','2013-03-04','09:00:00',1.88),('9303','2013-03-04','09:05:00',1.96),('9303','2013-03-04','09:10:00',2.03),('9303','2013-03-04','09:15:00',2.09),('9303','2013-03-04','09:20:00',2.15),('9303','2013-03-04','09:25:00',2.22),('9303','2013-03-04','09:30:00',2.31),('9303','2013-03-04','09:35:00',2.38),('9303','2013-03-04','09:40:00',2.44),('9303','2013-03-04','09:45:00',2.49),('9303','2013-03-04','09:50:00',2.5),('9303','2013-03-04','09:55:00',2.57),('9303','2013-03-04','10:00:00',2.56),('9303','2013-03-04','10:05:00',2.62),('9303','2013-03-04','10:10:00',2.61),('9303','2013-03-04','10:15:00',2.63),('9303','2013-03-04','10:20:00',2.67),('9303','2013-03-04','10:25:00',2.72),('9303','2013-03-04','10:30:00',2.79),('9303','2013-03-04','10:35:00',2.79),('9303','2013-03-04','10:40:00',2.86),('9303','2013-03-04','10:45:00',2.88),('9303','2013-03-04','10:50:00',2.87),('9303','2013-03-04','10:55:00',2.91),('9303','2013-03-04','11:00:00',2.96),('9303','2013-03-04','11:05:00',3.04),('9303','2013-03-04','11:10:00',3.07),('9303','2013-03-04','11:15:00',3.05),('9303','2013-03-04','11:20:00',3.03),('9303','2013-03-04','11:25:00',3.03),('9303','2013-03-04','11:30:00',3.08),('9303','2013-03-04','11:35:00',3.16),('9303','2013-03-04','11:40:00',3.16),('9303','2013-03-04','11:45:00',3.15),('9303','2013-03-04','11:50:00',3.05),('9303','2013-03-04','11:55:00',3.08),('9303','2013-03-04','12:00:00',3.07),('9303','2013-03-04','12:05:00',3.05),('9303','2013-03-04','12:10:00',3.16),('9303','2013-03-04','12:15:00',3.18),('9303','2013-03-04','12:20:00',3.19),('9303','2013-03-04','12:25:00',3.21),('9303','2013-03-04','12:30:00',3.21),('9303','2013-03-04','12:35:00',3.2),('9303','2013-03-04','12:40:00',3.2),('9303','2013-03-04','12:45:00',3.26),('9303','2013-03-04','12:50:00',3.23),('9303','2013-03-04','12:55:00',3.21),('9303','2013-03-04','13:00:00',3.23),('9303','2013-03-04','13:05:00',3.19),('9303','2013-03-04','13:10:00',3.11),('9303','2013-03-04','13:15:00',3.17),('9303','2013-03-04','13:20:00',3.15),('9303','2013-03-04','13:25:00',3.16),('9303','2013-03-04','13:30:00',1.58),('9303','2013-03-04','13:35:00',2.7),('9303','2013-03-04','13:40:00',2.52),('9303','2013-03-04','13:45:00',2.44),('9303','2013-03-04','13:50:00',2.85),('9303','2013-03-04','13:55:00',2.84),('9303','2013-03-04','14:00:00',2.74),('9303','2013-03-04','14:05:00',2.74),('9303','2013-03-04','14:10:00',2.66),('9303','2013-03-04','14:15:00',2.61),('9303','2013-03-04','14:20:00',2.56),('9303','2013-03-04','14:25:00',2.51),('9303','2013-03-04','14:30:00',2.35),('9303','2013-03-04','14:35:00',2.46),('9303','2013-03-04','14:40:00',2.41),('9303','2013-03-04','14:45:00',2.35),('9303','2013-03-04','14:50:00',2.3),('9303','2013-03-04','14:55:00',2.25),('9303','2013-03-04','15:00:00',2.19),('9303','2013-03-04','15:05:00',2.14),('9303','2013-03-04','15:10:00',2.04),('9303','2013-03-04','15:15:00',1.98),('9303','2013-03-04','15:20:00',1.94),('9303','2013-03-04','15:25:00',1.84),('9303','2013-03-04','15:30:00',1.8),('9303','2013-03-04','15:35:00',1.69),('9303','2013-03-04','15:40:00',1.62),('9303','2013-03-04','15:45:00',1.57),('9303','2013-03-04','15:50:00',1.45),('9303','2013-03-04','15:55:00',1.41),('9303','2013-03-04','16:00:00',1.34),('9303','2013-03-04','16:05:00',1.23),('9303','2013-03-04','16:10:00',1.16),('9303','2013-03-04','16:15:00',1.1),('9303','2013-03-04','16:20:00',1.03),('9303','2013-03-03','08:10:00',1.06),('9303','2013-03-03','08:15:00',1.18),('9303','2013-03-03','08:20:00',1.25),('9303','2013-03-03','08:25:00',1.35),('9303','2013-03-03','08:30:00',1.45),('9303','2013-03-03','08:35:00',1.5),('9303','2013-03-03','08:40:00',1.62),('9303','2013-03-03','08:45:00',1.69),('9303','2013-03-03','08:50:00',1.8),('9303','2013-03-03','08:55:00',1.87),('9303','2013-03-03','09:00:00',1.95),('9303','2013-03-03','09:05:00',2.03),('9303','2013-03-03','09:10:00',2.1),('9303','2013-03-03','09:15:00',2.15),('9303','2013-03-03','09:20:00',2.23),('9303','2013-03-03','09:25:00',2.3),('9303','2013-03-03','09:30:00',2.35),('9303','2013-03-03','09:35:00',2.42),('9303','2013-03-03','09:40:00',2.47),('9303','2013-03-03','09:45:00',2.53),('9303','2013-03-03','09:50:00',2.6),('9303','2013-03-03','09:55:00',2.67),('9303','2013-03-03','10:00:00',2.68),('9303','2013-03-03','10:05:00',2.72),('9303','2013-03-03','10:10:00',2.73),('9303','2013-03-03','10:15:00',2.78),('9303','2013-03-03','10:20:00',2.83),('9303','2013-03-03','10:25:00',2.87),('9303','2013-03-03','10:30:00',2.93),('9303','2013-03-03','10:35:00',2.94),('9303','2013-03-03','10:40:00',2.98),('9303','2013-03-03','10:45:00',3.01),('9303','2013-03-03','10:50:00',3.01),('9303','2013-03-03','10:55:00',3.05),('9303','2013-03-03','11:00:00',3.06),('9303','2013-03-03','11:05:00',3.1),('9303','2013-03-03','11:10:00',3.15),('9303','2013-03-03','11:15:00',3.09),('9303','2013-03-03','11:20:00',3.16),('9303','2013-03-03','11:25:00',3.18),('9303','2013-03-03','11:30:00',3.15),('9303','2013-03-03','11:35:00',3.21),('9303','2013-03-03','11:40:00',3.27),('9303','2013-03-03','11:45:00',3.22),('9303','2013-03-03','11:50:00',3.28),('9303','2013-03-03','11:55:00',3.26),('9303','2013-03-03','12:00:00',3.25),('9303','2013-03-03','12:05:00',3.28),('9303','2013-03-03','12:10:00',3.25),('9303','2013-03-03','12:15:00',3.25),('9303','2013-03-03','12:20:00',3.28),('9303','2013-03-03','12:25:00',3.29),('9303','2013-03-03','12:30:00',3.33),('9303','2013-03-03','12:35:00',3.34),('9303','2013-03-03','12:40:00',3.34),('9303','2013-03-03','12:45:00',3.36),('9303','2013-03-03','12:50:00',3.36),('9303','2013-03-03','12:55:00',3.34),('9303','2013-03-03','13:00:00',3.31),('9303','2013-03-03','13:05:00',3.31),('9303','2013-03-03','13:10:00',3.27),('9303','2013-03-03','13:15:00',3.21),('9303','2013-03-03','13:20:00',3.22),('9303','2013-03-03','13:25:00',3.19),('9303','2013-03-03','13:30:00',3.14),('9303','2013-03-03','13:35:00',3.12),('9303','2013-03-03','13:40:00',3.07),('9303','2013-03-03','13:45:00',3.02),('9303','2013-03-03','13:50:00',3.01),('9303','2013-03-03','13:55:00',2.94),('9303','2013-03-03','14:00:00',2.89),('9303','2013-03-03','14:05:00',2.88),('9303','2013-03-03','14:10:00',2.88),('9303','2013-03-03','14:15:00',2.84),('9303','2013-03-03','14:20:00',2.78),('9303','2013-03-03','14:25:00',2.74),('9303','2013-03-03','14:30:00',2.67),('9303','2013-03-03','14:35:00',2.64),('9303','2013-03-03','14:40:00',2.58),('9303','2013-03-03','14:45:00',2.52),('9303','2013-03-03','14:50:00',2.45),('9303','2013-03-03','14:55:00',2.36),('9303','2013-03-03','15:00:00',2.37),('9303','2013-03-03','15:05:00',2.31),('9303','2013-03-03','15:10:00',2.24),('9303','2013-03-03','15:15:00',2.18),('9303','2013-03-03','15:20:00',2.12),('9303','2013-03-03','15:25:00',2.05),('9303','2013-03-03','15:30:00',1.99),('9303','2013-03-03','15:35:00',1.88),('9303','2013-03-03','15:40:00',1.8),('9303','2013-03-03','15:45:00',1.71),('9303','2013-03-03','15:50:00',1.61),('9303','2013-03-03','15:55:00',1.54),('9303','2013-03-03','16:00:00',1.44),('9303','2013-03-03','16:05:00',1.34),('9303','2013-03-03','16:10:00',1.27),('9303','2013-03-03','16:15:00',1.19),('9303','2013-03-03','16:20:00',1.11),('9303','2013-03-03','16:25:00',1.03),('9303','2014-03-24','07:45:00',1.14),('9303','2014-03-24','08:55:00',1.41),('9303','2014-03-24','09:00:00',1.76),('9303','2014-03-24','09:20:00',1.65),('9303','2014-03-24','09:30:00',1.33),('9303','2014-03-24','09:40:00',1.29),('9303','2014-03-24','09:45:00',1.1),('9303','2014-03-24','10:00:00',1.94),('9303','2014-03-24','10:05:00',2.56),('9303','2014-03-24','10:10:00',3.17),('9303','2014-03-24','10:15:00',2.93),('9303','2014-03-24','10:35:00',1.15),('9303','2014-03-24','10:40:00',1.01),('9303','2014-03-24','10:45:00',1.35),('9303','2014-03-24','10:50:00',4.68),('9303','2014-03-24','10:55:00',4.17),('9303','2014-03-24','11:00:00',1.76),('9303','2014-03-24','11:05:00',2.54),('9303','2014-03-24','11:10:00',2.44),('9303','2014-03-24','11:15:00',3.13),('9303','2014-03-24','11:20:00',2.74),('9303','2014-03-24','11:25:00',2.74),('9303','2014-03-24','11:30:00',3.78),('9303','2014-03-24','11:35:00',1.51),('9303','2014-03-24','12:35:00',1.78),('9303','2014-03-24','12:40:00',1.93),('9303','2014-03-24','12:45:00',1.69),('9303','2014-03-24','12:50:00',1.41),('9303','2014-03-24','12:55:00',1.35),('9303','2014-03-24','13:00:00',1.36),('9303','2014-03-24','13:05:00',1.36),('9303','2014-03-24','13:10:00',1.18),('9303','2014-03-24','13:20:00',1.01),('9303','2014-03-24','13:25:00',1.2),('9303','2014-03-24','13:30:00',1.38),('9303','2014-03-24','13:35:00',1.12),('9303','2014-03-24','13:50:00',1.21),('9303','2014-03-24','13:55:00',1.25),('9303','2014-03-24','14:00:00',1.13),('9303','2014-03-24','14:05:00',1.01),('9303','2014-03-24','14:10:00',1.17),('9303','2014-03-24','14:15:00',1.48),('9303','2014-03-24','14:20:00',1.99),('9303','2014-03-24','14:25:00',1.92),('9303','2014-03-24','14:30:00',1.7),('9303','2014-03-24','14:35:00',2),('9303','2014-03-24','14:40:00',2.93),('9303','2014-03-24','14:45:00',3.15),('9303','2014-03-24','14:50:00',3.48),('9303','2014-03-24','14:55:00',3.03),('9303','2014-03-24','15:00:00',2.62),('9303','2014-03-24','15:05:00',2.31),('9303','2014-03-24','15:10:00',2.09),('9303','2014-03-24','15:15:00',1.27),('9303','2014-03-24','15:20:00',1.53),('9303','2014-03-24','15:25:00',1.31),('9303','2014-03-24','15:30:00',1.7),('9303','2014-03-24','15:35:00',1.39),('9303','2014-03-24','15:40:00',1.21),('9303','2014-03-24','15:45:00',1.11),('9303','2014-03-24','15:50:00',1.22),('9303','2014-03-24','15:55:00',1.12),('9303','2014-03-24','16:00:00',2.16),('9303','2014-03-24','16:05:00',1.16),('9303','2014-03-24','16:10:00',1.03),('9303','2013-03-02','10:50:00',1.01),('9303','2013-03-02','10:55:00',1.05),('9303','2013-03-02','11:00:00',1.13),('9303','2013-03-02','11:05:00',1.17),('9303','2013-03-02','11:10:00',1.23),('9303','2013-03-02','11:15:00',1.39),('9303','2013-03-02','11:20:00',1.23),('9303','2013-03-02','11:25:00',1.09),('9303','2013-03-02','11:30:00',1.03),('9303','2013-03-02','11:35:00',1.06),('9303','2013-03-02','11:40:00',1.21),('9303','2013-03-02','11:45:00',1.09),('9303','2013-03-02','11:50:00',1.09),('9303','2013-03-02','11:55:00',1.02),('9303','2013-03-02','12:05:00',1.12),('9303','2013-03-02','12:10:00',1.11),('9303','2013-03-02','12:15:00',1.12),('9303','2013-03-02','12:20:00',1.05),('9303','2013-03-02','12:25:00',1.13),('9303','2013-03-02','12:30:00',1.16),('9303','2013-03-02','12:35:00',1.3),('9303','2013-03-02','12:40:00',1.39),('9303','2013-03-02','12:45:00',1.37),('9303','2013-03-02','12:50:00',1.22),('9303','2013-03-02','12:55:00',1.33),('9303','2013-03-02','13:00:00',1.35),('9303','2013-03-02','13:05:00',1.16),('9303','2013-03-02','13:45:00',1.07),('9303','2013-03-02','13:50:00',1.04),('9303','2013-03-02','13:55:00',1.11),('9303','2013-03-02','14:00:00',1.24),('9303','2013-03-02','14:05:00',1.21),('9303','2013-03-02','14:10:00',1.01),('9303','2013-03-01','08:20:00',1.03),('9303','2013-03-01','08:25:00',1.04),('9303','2013-03-01','08:30:00',1.13),('9303','2013-03-01','08:35:00',1.2),('9303','2013-03-01','08:40:00',1.27),('9303','2013-03-01','08:45:00',1.39),('9303','2013-03-01','08:50:00',1.46),('9303','2013-03-01','08:55:00',1.54),('9303','2013-03-01','09:00:00',1.63),('9303','2013-03-01','09:05:00',1.82),('9303','2013-03-01','09:10:00',1.82),('9303','2013-03-01','09:15:00',1.83),('9303','2013-03-01','09:20:00',1.88),('9303','2013-03-01','09:25:00',1.91),('9303','2013-03-01','09:30:00',2.11),('9303','2013-03-01','09:35:00',1.99),('9303','2013-03-01','09:40:00',2.04),('9303','2013-03-01','09:45:00',2.18),('9303','2013-03-01','09:50:00',2.17),('9303','2013-03-01','09:55:00',2.13),('9303','2013-03-01','10:00:00',2.15),('9303','2013-03-01','10:05:00',2.14),('9303','2013-03-01','10:10:00',2.14),('9303','2013-03-01','10:15:00',1.93),('9303','2013-03-01','10:20:00',1.81),('9303','2013-03-01','10:25:00',1.9),('9303','2013-03-01','10:30:00',2.09),('9303','2013-03-01','10:35:00',2.37),('9303','2013-03-01','10:40:00',2.12),('9303','2013-03-01','10:45:00',2.02),('9303','2013-03-01','10:50:00',1.95),('9303','2013-03-01','10:55:00',1.85),('9303','2013-03-01','11:00:00',1.67),('9303','2013-03-01','11:05:00',1.47),('9303','2013-03-01','11:10:00',1.4),('9303','2013-03-01','11:15:00',1.52),('9303','2013-03-01','11:20:00',1.61),('9303','2013-03-01','11:25:00',1.61),('9303','2013-03-01','11:30:00',1.63),('9303','2013-03-01','11:35:00',1.66),('9303','2013-03-01','11:40:00',1.6),('9303','2013-03-01','11:45:00',1.53),('9303','2013-03-01','11:50:00',1.51),('9303','2013-03-01','11:55:00',1.45),('9303','2013-03-01','12:00:00',1.38),('9303','2013-03-01','12:05:00',1.31),('9303','2013-03-01','12:10:00',1.23),('9303','2013-03-01','12:15:00',1.12),('9303','2013-03-01','12:20:00',1.05),('9303','2013-03-01','12:25:00',1.04),('9303','2013-03-01','12:30:00',1.08),('9303','2013-03-01','12:35:00',1.07),('9303','2013-03-01','12:40:00',1.03),('9303','2013-03-01','12:45:00',1.03),('9303','2013-03-01','12:50:00',1.05),('9303','2013-03-01','12:55:00',1.11),('9303','2013-03-01','13:00:00',1.17),('9303','2013-03-01','13:05:00',1.19),('9303','2013-03-01','13:10:00',1.23),('9303','2013-03-01','13:15:00',1.31),('9303','2013-03-01','13:20:00',1.41),('9303','2013-03-01','13:25:00',1.55),('9303','2013-03-01','13:30:00',1.53),('9303','2013-03-01','13:35:00',1.42),('9303','2013-03-01','13:40:00',1.35),('9303','2013-03-01','13:45:00',1.33),('9303','2013-03-01','13:50:00',1.33),('9303','2013-03-01','13:55:00',1.28),('9303','2013-03-01','14:00:00',1.25),('9303','2013-03-01','14:05:00',1.19),('9303','2013-03-01','14:10:00',1.12),('9303','2013-03-01','14:15:00',1.05),('9303','2013-03-01','14:20:00',1.01),('9303','2013-03-01','14:25:00',1.01),('9303','2013-03-01','14:30:00',1.04),('9303','2013-03-01','14:35:00',1.05),('9303','2013-03-01','14:40:00',1.01),('9303','2013-02-28','08:20:00',1.08),('9303','2013-02-28','08:25:00',1.17),('9303','2013-02-28','08:30:00',1.25),('9303','2013-02-28','08:35:00',1.31),('9303','2013-02-28','08:40:00',1.42),('9303','2013-02-28','08:45:00',1.52),('9303','2013-02-28','08:50:00',1.61),('9303','2013-02-28','08:55:00',1.71),('9303','2013-02-28','09:00:00',1.79),('9303','2013-02-28','09:05:00',1.85),('9303','2013-02-28','09:10:00',1.91),('9303','2013-02-28','09:15:00',1.95),('9303','2013-02-28','09:20:00',2.04),('9303','2013-02-28','09:25:00',2.09),('9303','2013-02-28','09:30:00',2.14),('9303','2013-02-28','09:35:00',2.17),('9303','2013-02-28','09:40:00',2.2),('9303','2013-02-28','09:45:00',2.24),('9303','2013-02-28','09:50:00',2.09),('9303','2013-02-28','09:55:00',2.29),('9303','2013-02-28','10:00:00',2.33),('9303','2013-02-28','10:05:00',2.36),('9303','2013-02-28','10:10:00',2.4),('9303','2013-02-28','10:15:00',2.41),('9303','2013-02-28','10:20:00',2.53),('9303','2013-02-28','10:25:00',2.5),('9303','2013-02-28','10:30:00',2.53),('9303','2013-02-28','10:35:00',2.59),('9303','2013-02-28','10:40:00',2.64),('9303','2013-02-28','10:45:00',2.66),('9303','2013-02-28','10:50:00',2.69),('9303','2013-02-28','10:55:00',2.66),('9303','2013-02-28','11:00:00',2.78),('9303','2013-02-28','11:05:00',2.84),('9303','2013-02-28','11:10:00',2.86),('9303','2013-02-28','11:15:00',2.87),('9303','2013-02-28','11:20:00',2.96),('9303','2013-02-28','11:25:00',2.96),('9303','2013-02-28','11:30:00',2.97),('9303','2013-02-28','11:35:00',3.03),('9303','2013-02-28','11:40:00',3.01),('9303','2013-02-28','11:45:00',3.03),('9303','2013-02-28','11:50:00',3.11),('9303','2013-02-28','11:55:00',3.09),('9303','2013-02-28','12:00:00',3),('9303','2013-02-28','12:05:00',2.85),('9303','2013-02-28','12:10:00',3.05),('9303','2013-02-28','12:15:00',3.08),('9303','2013-02-28','12:20:00',3.12),('9303','2013-02-28','12:25:00',3.12),('9303','2013-02-28','12:30:00',3.15),('9303','2013-02-28','12:35:00',3.21),('9303','2013-02-28','12:40:00',3.18),('9303','2013-02-28','12:45:00',3.14),('9303','2013-02-28','12:50:00',3.05),('9303','2013-02-28','12:55:00',3),('9303','2013-02-28','13:00:00',2.88),('9303','2013-02-28','13:05:00',2.99),('9303','2013-02-28','13:10:00',2.97),('9303','2013-02-28','13:15:00',2.99),('9303','2013-02-28','13:20:00',2.99),('9303','2013-02-28','13:25:00',2.77),('9303','2013-02-28','13:30:00',2.94),('9303','2013-02-28','13:35:00',2.83),('9303','2013-02-28','13:40:00',2.82),('9303','2013-02-28','13:45:00',2.82),('9303','2013-02-28','13:50:00',2.92),('9303','2013-02-28','13:55:00',2.85),('9303','2013-02-28','14:00:00',2.84),('9303','2013-02-28','14:05:00',2.82),('9303','2013-02-28','14:10:00',2.71),('9303','2013-02-28','14:15:00',2.65),('9303','2013-02-28','14:20:00',2.5),('9303','2013-02-28','14:25:00',2.38),('9303','2013-02-28','14:30:00',2.34),('9303','2013-02-28','14:35:00',2.21),('9303','2013-02-28','14:40:00',2.27),('9303','2013-02-28','14:45:00',2.25),('9303','2013-02-28','14:50:00',2.25),('9303','2013-02-28','14:55:00',2.23),('9303','2013-02-28','15:00:00',2.14),('9303','2013-02-28','15:05:00',2.05),('9303','2013-02-28','15:10:00',1.98),('9303','2013-02-28','15:15:00',1.91),('9303','2013-02-28','15:20:00',1.87),('9303','2013-02-28','15:25:00',1.73),('9303','2013-02-28','15:30:00',1.6),('9303','2013-02-28','15:35:00',1.56),('9303','2013-02-28','15:40:00',1.5),('9303','2013-02-28','15:45:00',1.44),('9303','2013-02-28','15:50:00',1.37),('9303','2013-02-28','15:55:00',1.29),('9303','2013-02-28','16:00:00',1.21),('9303','2013-02-28','16:05:00',1.12),('9303','2013-02-28','16:10:00',1.05),('9303','2013-02-27','08:20:00',1.03),('9303','2013-02-27','08:25:00',1.11),('9303','2013-02-27','08:30:00',1.22),('9303','2013-02-27','08:35:00',1.3),('9303','2013-02-27','08:40:00',1.35),('9303','2013-02-27','08:45:00',1.43),('9303','2013-02-27','08:50:00',1.51),('9303','2013-02-27','08:55:00',1.58),('9303','2013-02-27','09:00:00',1.69),('9303','2013-02-27','09:05:00',1.76),('9303','2013-02-27','09:10:00',1.83),('9303','2013-02-27','09:15:00',1.9),('9303','2013-02-27','09:20:00',1.96),('9303','2013-02-27','09:25:00',2.03),('9303','2013-02-27','09:30:00',2.08),('9303','2013-02-27','09:35:00',2.11),('9303','2013-02-27','09:40:00',2.16),('9303','2013-02-27','09:45:00',2.19),('9303','2013-02-27','09:50:00',2.24),('9303','2013-02-27','09:55:00',2.26),('9303','2013-02-27','10:00:00',2.31),('9303','2013-02-27','10:05:00',2.33),('9303','2013-02-27','10:10:00',2.4),('9303','2013-02-27','10:15:00',2.42),('9303','2013-02-27','10:20:00',2.51),('9303','2013-02-27','10:25:00',2.51),('9303','2013-02-27','10:30:00',2.57),('9303','2013-02-27','10:35:00',2.6),('9303','2013-02-27','10:40:00',2.69),('9303','2013-02-27','10:45:00',2.74),('9303','2013-02-27','10:50:00',2.75),('9303','2013-02-27','10:55:00',2.79),('9303','2013-02-27','11:00:00',2.81),('9303','2013-02-27','11:05:00',2.84),('9303','2013-02-27','11:10:00',2.81),('9303','2013-02-27','11:15:00',2.83),('9303','2013-02-27','11:20:00',2.95),('9303','2013-02-27','11:25:00',2.94),('9303','2013-02-27','11:30:00',2.31),('9303','2013-02-27','11:35:00',1.49),('9303','2013-02-27','11:40:00',1.39),('9303','2013-02-27','11:45:00',2.2),('9303','2013-02-27','11:50:00',2.78),('9303','2013-02-27','11:55:00',3.2),('9303','2013-02-27','12:00:00',3.13),('9303','2013-02-27','12:05:00',3.15),('9303','2013-02-27','12:10:00',3.21),('9303','2013-02-27','12:15:00',3.32),('9303','2013-02-27','12:20:00',3.32),('9303','2013-02-27','12:25:00',3.21),('9303','2013-02-27','12:30:00',3.2),('9303','2013-02-27','12:35:00',3.23),('9303','2013-02-27','12:40:00',3.32),('9303','2013-02-27','12:45:00',3.23),('9303','2013-02-27','12:50:00',3.13),('9303','2013-02-27','12:55:00',2.99),('9303','2013-02-27','13:00:00',3.03),('9303','2013-02-27','13:05:00',3.14),('9303','2013-02-27','13:10:00',2.35),('9303','2013-02-27','13:15:00',2.76),('9303','2013-02-27','13:25:00',2.16),('9303','2013-02-27','13:30:00',3.13),('9303','2013-02-27','13:35:00',3.01),('9303','2013-02-27','13:40:00',2.99),('9303','2013-02-27','13:45:00',2.67),('9303','2013-02-27','13:50:00',2.12),('9303','2013-02-27','13:55:00',2.01),('9303','2013-02-27','14:00:00',2.05),('9303','2013-02-27','14:05:00',1.91),('9303','2013-02-27','14:10:00',1.68),('9303','2013-02-27','14:15:00',1.59),('9303','2013-02-27','14:20:00',2.29),('9303','2013-02-27','14:25:00',1.68),('9303','2013-02-27','14:30:00',2.39),('9303','2013-02-27','14:35:00',2.47),('9303','2013-02-27','14:40:00',2.46),('9303','2013-02-27','14:45:00',2.37),('9303','2013-02-27','14:50:00',2.18),('9303','2013-02-27','14:55:00',2.17),('9303','2013-02-27','15:00:00',2.25),('9303','2013-02-27','15:05:00',2.25),('9303','2013-02-27','15:10:00',2.06),('9303','2013-02-27','15:15:00',1.92),('9303','2013-02-27','15:20:00',1.94),('9303','2013-02-27','15:25:00',1.89),('9303','2013-02-27','15:30:00',1.78),('9303','2013-02-27','15:35:00',1.7),('9303','2013-02-27','15:40:00',1.57),('9303','2013-02-27','15:45:00',1.51),('9303','2013-02-27','15:50:00',1.45),('9303','2013-02-27','15:55:00',1.39),('9303','2013-02-27','16:00:00',1.29),('9303','2013-02-27','16:05:00',1.21),('9303','2013-02-27','16:10:00',1.14),('9303','2013-02-27','16:15:00',1.06),('9303','2013-02-26','09:25:00',1.01),('9303','2013-02-26','09:30:00',1.2),('9303','2013-02-26','09:35:00',1.5),('9303','2013-02-26','09:40:00',1.67),('9303','2013-02-26','09:45:00',1.65),('9303','2013-02-26','09:50:00',1.64),('9303','2013-02-26','09:55:00',1.77),('9303','2013-02-26','10:00:00',1.63),('9303','2013-02-26','10:05:00',1.6),('9303','2013-02-26','10:10:00',1.86),('9303','2013-02-26','10:15:00',2.21),('9303','2013-02-26','10:20:00',2.63),('9303','2013-02-26','10:25:00',2.89),('9303','2013-02-26','10:30:00',2.68),('9303','2013-02-26','10:35:00',2.27),('9303','2013-02-26','10:40:00',2.16),('9303','2013-02-26','10:45:00',1.33),('9303','2013-02-26','10:50:00',1.56),('9303','2013-02-26','10:55:00',1.66),('9303','2013-02-26','11:00:00',1.81),('9303','2013-02-26','11:05:00',1.8),('9303','2013-02-26','11:10:00',2.03),('9303','2013-02-26','11:15:00',1.67),('9303','2013-02-26','11:20:00',1.55),('9303','2013-02-26','11:25:00',1.47),('9303','2013-02-26','11:30:00',1.45),('9303','2013-02-26','11:35:00',1.4),('9303','2013-02-26','11:40:00',1.46),('9303','2013-02-26','11:45:00',1.42),('9303','2013-02-26','11:50:00',1.7),('9303','2013-02-26','11:55:00',1.59),('9303','2013-02-26','12:00:00',1.62),('9303','2013-02-26','12:05:00',1.58),('9303','2013-02-26','12:10:00',1.58),('9303','2013-02-26','12:15:00',1.37),('9303','2013-02-26','12:20:00',1.41),('9303','2013-02-26','12:25:00',1.29),('9303','2013-02-26','12:30:00',1.29),('9303','2013-02-26','12:35:00',1.18),('9303','2013-02-26','12:40:00',1.07),('9303','2013-02-25','08:50:00',1.06),('9303','2013-02-25','09:00:00',1.03),('9303','2013-02-25','09:25:00',1.26),('9303','2013-02-25','09:30:00',1.42),('9303','2013-02-25','09:35:00',1.41),('9303','2013-02-25','09:40:00',1.11),('9303','2013-02-25','10:45:00',1.47),('9303','2013-02-25','10:50:00',2.55),('9303','2013-02-25','10:55:00',3.53),('9303','2013-02-25','11:00:00',3.71),('9303','2013-02-25','11:05:00',1.9),('9303','2013-02-25','11:10:00',1.59),('9303','2013-02-25','11:15:00',1.58),('9303','2013-02-25','11:20:00',1.07),('9303','2013-02-25','11:30:00',1.34),('9303','2013-02-25','11:35:00',1.21),('9303','2013-02-25','11:40:00',1.3),('9303','2013-02-25','11:45:00',1.52),('9303','2013-02-25','11:50:00',1.89),('9303','2013-02-25','11:55:00',3.59),('9303','2013-02-25','12:00:00',2.73),('9303','2013-02-25','12:05:00',1.94),('9303','2013-02-25','12:10:00',1.7),('9303','2013-02-25','12:15:00',1.87),('9303','2013-02-25','12:20:00',3.01),('9303','2013-02-25','12:25:00',3.8),('9303','2013-02-25','12:30:00',3.23),('9303','2013-02-25','12:35:00',2.3),('9303','2013-02-25','12:40:00',3.55),('9303','2013-02-25','12:45:00',3.46),('9303','2013-02-25','12:50:00',3.23),('9303','2013-02-25','12:55:00',3.14),('9303','2013-02-25','13:00:00',3.18),('9303','2013-02-25','13:05:00',3.23),('9303','2013-02-25','13:10:00',2),('9303','2013-02-25','13:15:00',2.21),('9303','2013-02-25','13:20:00',1.71),('9303','2013-02-25','13:25:00',1.25),('9303','2013-02-25','13:30:00',1.47),('9303','2013-02-25','13:35:00',1.63),('9303','2013-02-24','10:50:00',1.15),('9303','2013-02-24','10:55:00',1.12),('9303','2013-02-24','12:40:00',1.04),('9303','2013-02-24','12:45:00',1.21),('9303','2013-02-24','12:50:00',1.02),('9303','2013-02-24','13:00:00',1.01),('9303','2013-02-24','13:05:00',1.42),('9303','2013-02-24','13:10:00',1.43),('9303','2013-02-24','13:15:00',1.18),('9303','2013-02-24','13:20:00',1.42),('9303','2013-02-24','13:35:00',1.23),('9303','2013-02-24','13:40:00',1.15),('9303','2013-02-24','13:45:00',1.22),('9303','2013-02-24','13:50:00',1.08),('9303','2013-02-24','14:00:00',1.06),('9303','2013-02-24','14:05:00',1.62),('9303','2013-02-24','14:10:00',1.63),('9303','2013-02-24','14:15:00',1.09),('9303','2013-02-24','14:30:00',1.1),('9303','2013-02-24','14:35:00',1.14),('9303','2013-02-24','15:10:00',1.85),('9303','2013-02-24','15:15:00',1.03),('9303','2013-02-24','15:20:00',1.17),('9303','2013-02-24','15:25:00',1.55),('9303','2013-02-24','15:35:00',1.23),('9303','2013-02-24','15:40:00',1.24),('9303','2013-02-24','15:45:00',1.2),('9303','2013-02-24','15:50:00',1.01),('9303','2013-02-24','15:55:00',1.22),('9303','2013-02-24','16:00:00',1.5),('9303','2013-02-24','16:05:00',1.02),('9303','2013-02-23','08:10:00',1.11),('9303','2013-02-23','08:15:00',1.37),('9303','2013-02-23','09:00:00',1.22),('9303','2013-02-23','09:05:00',1.21),('9303','2013-02-23','09:45:00',1.21),('9303','2013-02-23','09:50:00',1.27),('9303','2013-02-23','09:55:00',1.25),('9303','2013-02-23','14:05:00',1.47),('9303','2013-02-23','14:10:00',1.22),('9303','2013-02-22','14:35:00',1.2),('9303','2013-02-22','14:40:00',1.34),('9303','2013-02-22','14:45:00',1.04),('9303','2013-02-22','14:55:00',1.33),('9303','2013-02-21','11:50:00',1.07),('9303','2013-02-21','11:55:00',1.1),('9303','2013-02-21','12:00:00',1.08),('9303','2013-02-21','12:05:00',1.08),('9303','2013-02-21','12:10:00',1.13),('9303','2013-02-21','12:15:00',1.19),('9303','2013-02-21','12:20:00',1.28),('9303','2013-02-21','12:25:00',1.25),('9303','2013-02-21','12:30:00',1.17),('9303','2013-02-21','12:35:00',1.11),('9303','2013-02-21','12:40:00',1.08),('9303','2013-02-21','12:45:00',1.1),('9303','2013-02-21','12:50:00',1.1),('9303','2013-02-21','12:55:00',1.18),('9303','2013-02-21','13:00:00',1.19),('9303','2013-02-21','13:05:00',1.11),('9303','2013-02-21','13:10:00',1.07),('9303','2013-02-21','13:15:00',1.09),('9303','2013-02-21','13:20:00',1.14),('9303','2013-02-21','13:25:00',1.17),('9303','2013-02-21','13:30:00',1.19),('9303','2013-02-21','13:35:00',1.19),('9303','2013-02-21','13:40:00',1.15),('9303','2013-02-21','13:45:00',1.09),('9303','2013-02-21','13:50:00',1.09),('9303','2013-02-21','13:55:00',1.09),('9303','2013-02-21','14:00:00',1.1),('9303','2013-02-21','14:05:00',1.06),('9303','2014-03-23','08:35:00',1.07),('9303','2014-03-23','08:50:00',1.14),('9303','2014-03-23','08:55:00',1.52),('9303','2014-03-23','09:05:00',1.43),('9303','2014-03-23','09:10:00',2.45),('9303','2014-03-23','09:15:00',2.48),('9303','2014-03-23','09:20:00',1.74),('9303','2014-03-23','09:30:00',1.23),('9303','2014-03-23','09:35:00',1.29),('9303','2014-03-23','09:40:00',1.1),('9303','2014-03-23','10:25:00',1.01),('9303','2014-03-23','10:40:00',1.01),('9303','2014-03-23','10:55:00',1.39),('9303','2014-03-23','11:00:00',1.06),('9303','2014-03-23','11:10:00',1.12),('9303','2014-03-23','11:35:00',1.28),('9303','2014-03-23','11:40:00',3.46),('9303','2014-03-23','13:45:00',2.3),('9303','2014-03-23','13:50:00',1.51),('9303','2014-03-23','13:55:00',1.17),('9303','2014-03-23','14:00:00',1.01),('9303','2014-03-23','15:10:00',1.12),('9303','2014-03-23','15:15:00',1.96),('9303','2014-03-23','15:20:00',1.47),('9303','2014-03-23','15:25:00',2.13),('9303','2014-03-23','15:30:00',1.06),('9303','2013-02-20','08:25:00',1.01),('9303','2013-02-20','08:30:00',1.08),('9303','2013-02-20','08:35:00',1.19),('9303','2013-02-20','08:40:00',1.28),('9303','2013-02-20','08:45:00',1.38),('9303','2013-02-20','08:50:00',1.45),('9303','2013-02-20','08:55:00',1.54),('9303','2013-02-20','09:00:00',1.64),('9303','2013-02-20','09:05:00',1.39),('9303','2013-02-20','09:10:00',1.08),('9303','2013-02-20','09:15:00',1.43),('9303','2013-02-20','09:20:00',1.13),('9303','2013-02-20','09:25:00',1.5),('9303','2013-02-20','09:30:00',1.92),('9303','2013-02-20','09:35:00',1.32),('9303','2013-02-20','09:45:00',1.11),('9303','2013-02-20','09:50:00',1.22),('9303','2013-02-20','09:55:00',1.64),('9303','2013-02-20','10:00:00',1.31),('9303','2013-02-20','10:05:00',1),('9303','2013-02-20','10:10:00',2.06),('9303','2013-02-20','10:15:00',1.13),('9303','2013-02-20','10:50:00',2.86),('9303','2013-02-20','10:55:00',2.49),('9303','2013-02-20','11:10:00',3.41),('9303','2013-02-20','11:15:00',3.28),('9303','2013-02-20','11:20:00',2.47),('9303','2013-02-20','11:25:00',2.16),('9303','2013-02-20','11:30:00',1.18),('9303','2013-02-20','11:35:00',2.49),('9303','2013-02-20','11:40:00',3.39),('9303','2013-02-20','11:45:00',3.68),('9303','2013-02-20','11:50:00',3.66),('9303','2013-02-20','11:55:00',2.62),('9303','2013-02-20','12:00:00',2.84),('9303','2013-02-20','12:10:00',1.41),('9303','2013-02-20','12:15:00',2.73),('9303','2013-02-20','12:20:00',1.47),('9303','2013-02-20','12:25:00',2.35),('9303','2013-02-20','12:30:00',3.99),('9303','2013-02-20','12:35:00',3.25),('9303','2013-02-20','12:40:00',1.1),('9303','2013-02-20','12:45:00',1.16),('9303','2013-02-20','12:50:00',1.03),('9303','2013-02-20','12:55:00',1.1),('9303','2013-02-20','13:00:00',2.01),('9303','2013-02-20','13:05:00',2.29),('9303','2013-02-20','13:10:00',2.36),('9303','2013-02-20','13:15:00',3.48),('9303','2013-02-20','13:20:00',2.05),('9303','2013-02-20','13:25:00',3.21),('9303','2013-02-20','13:30:00',2.11),('9303','2013-02-20','13:35:00',1.22),('9303','2013-02-20','13:40:00',1.28),('9303','2013-02-20','13:45:00',1.12),('9303','2013-02-20','13:50:00',1.07),('9303','2013-02-20','13:55:00',1.06),('9303','2013-02-20','15:10:00',1.28),('9303','2013-02-20','15:15:00',1.34),('9303','2013-02-20','15:20:00',1.88),('9303','2013-02-20','15:25:00',2.2),('9303','2013-02-20','15:30:00',1.64),('9303','2013-02-20','15:35:00',1.09),('9303','2013-02-20','16:00:00',1.01),('9303','2013-02-20','16:05:00',1.42),('9303','2013-02-20','16:10:00',1.32),('9303','2013-02-20','16:15:00',1.32),('9303','2013-02-20','16:20:00',1.2),('9303','2013-02-19','08:30:00',1.07),('9303','2013-02-19','08:35:00',1.16),('9303','2013-02-19','08:40:00',1.24),('9303','2013-02-19','08:45:00',1.32),('9303','2013-02-19','08:50:00',1.4),('9303','2013-02-19','08:55:00',1.48),('9303','2013-02-19','09:00:00',1.55),('9303','2013-02-19','09:05:00',1.64),('9303','2013-02-19','09:10:00',1.72),('9303','2013-02-19','09:15:00',1.79),('9303','2013-02-19','09:20:00',1.89),('9303','2013-02-19','09:25:00',1.95),('9303','2013-02-19','09:30:00',1.96),('9303','2013-02-19','09:35:00',2.04),('9303','2013-02-19','09:40:00',2.06),('9303','2013-02-19','09:45:00',2.11),('9303','2013-02-19','09:50:00',2.11),('9303','2013-02-19','09:55:00',2.19),('9303','2013-02-19','10:00:00',2.24),('9303','2013-02-19','10:05:00',2.21),('9303','2013-02-19','10:10:00',2.31),('9303','2013-02-19','10:15:00',2.38),('9303','2013-02-19','10:20:00',2.42),('9303','2013-02-19','10:25:00',2.49),('9303','2013-02-19','10:30:00',2.47),('9303','2013-02-19','10:35:00',2.56),('9303','2013-02-19','10:40:00',2.59),('9303','2013-02-19','10:45:00',2.6),('9303','2013-02-19','10:50:00',2.66),('9303','2013-02-19','10:55:00',2.66),('9303','2013-02-19','11:00:00',2.73),('9303','2013-02-19','11:05:00',2.76),('9303','2013-02-19','11:10:00',2.78),('9303','2013-02-19','11:15:00',2.84),('9303','2013-02-19','11:20:00',2.85),('9303','2013-02-19','11:25:00',2.86),('9303','2013-02-19','11:30:00',2.87),('9303','2013-02-19','11:35:00',2.83),('9303','2013-02-19','11:40:00',2.9),('9303','2013-02-19','11:45:00',2.92),('9303','2013-02-19','11:50:00',2.92),('9303','2013-02-19','11:55:00',2.93),('9303','2013-02-19','12:00:00',2.92),('9303','2013-02-19','12:05:00',2.94),('9303','2013-02-19','12:10:00',3.02),('9303','2013-02-19','12:15:00',2.99),('9303','2013-02-19','12:20:00',3),('9303','2013-02-19','12:25:00',3.07),('9303','2013-02-19','12:30:00',3.06),('9303','2013-02-19','12:35:00',3.08),('9303','2013-02-19','12:40:00',3.12),('9303','2013-02-19','12:45:00',3.07),('9303','2013-02-19','12:50:00',2.99),('9303','2013-02-19','12:55:00',2.92),('9303','2013-02-19','13:00:00',2.91),('9303','2013-02-19','13:05:00',2.92),('9303','2013-02-19','13:10:00',2.91),('9303','2013-02-19','13:15:00',2.91),('9303','2013-02-19','13:20:00',2.87),('9303','2013-02-19','13:25:00',2.84),('9303','2013-02-19','13:30:00',2.82),('9303','2013-02-19','13:35:00',2.79),('9303','2013-02-19','13:40:00',2.72),('9303','2013-02-19','13:45:00',2.63),('9303','2013-02-19','13:50:00',2.57),('9303','2013-02-19','13:55:00',2.5),('9303','2013-02-19','14:00:00',2.46),('9303','2013-02-19','14:05:00',2.44),('9303','2013-02-19','14:10:00',2.44),('9303','2013-02-19','14:15:00',2.42),('9303','2013-02-19','14:20:00',2.35),('9303','2013-02-19','14:25:00',2.29),('9303','2013-02-19','14:30:00',2.28),('9303','2013-02-19','14:35:00',2.22),('9303','2013-02-19','14:40:00',2.08),('9303','2013-02-19','14:45:00',2.09),('9303','2013-02-19','14:50:00',2.1),('9303','2013-02-19','14:55:00',2.06),('9303','2013-02-19','15:00:00',2.03),('9303','2013-02-19','15:05:00',1.98),('9303','2013-02-19','15:10:00',1.94),('9303','2013-02-19','15:15:00',1.89),('9303','2013-02-19','15:20:00',1.83),('9303','2013-02-19','15:25:00',1.75),('9303','2013-02-19','15:30:00',1.61),('9303','2013-02-19','15:35:00',1.52),('9303','2013-02-19','15:40:00',1.46),('9303','2013-02-19','15:45:00',1.39),('9303','2013-02-19','15:50:00',1.3),('9303','2013-02-19','15:55:00',1.23),('9303','2013-02-19','16:00:00',1.14),('9303','2013-02-19','16:05:00',1.07),('9303','2013-02-18','08:35:00',1.05),('9303','2013-02-18','08:40:00',1.16),('9303','2013-02-18','08:45:00',1.21),('9303','2013-02-18','08:50:00',1.28),('9303','2013-02-18','08:55:00',1.37),('9303','2013-02-18','09:00:00',1.44),('9303','2013-02-18','09:05:00',1.54),('9303','2013-02-18','09:10:00',1.63),('9303','2013-02-18','09:15:00',1.71),('9303','2013-02-18','09:20:00',1.98),('9303','2013-02-18','09:25:00',2.15),('9303','2013-02-18','09:30:00',1.8),('9303','2013-02-18','09:35:00',1.16),('9303','2013-02-18','09:50:00',1.34),('9303','2013-02-18','11:00:00',1.13),('9303','2013-02-18','11:05:00',1.15),('9303','2013-02-18','11:10:00',1.29),('9303','2013-02-18','11:15:00',1.14),('9303','2013-02-18','11:20:00',1.32),('9303','2013-02-18','11:25:00',1.41),('9303','2013-02-18','11:30:00',1.3),('9303','2013-02-18','11:35:00',1.33),('9303','2013-02-18','11:40:00',1.31),('9303','2013-02-18','11:45:00',1.21),('9303','2013-02-18','11:50:00',1.29),('9303','2013-02-18','11:55:00',1.48),('9303','2013-02-18','12:00:00',1.59),('9303','2013-02-18','12:05:00',1.47),('9303','2013-02-18','12:10:00',1.35),('9303','2013-02-18','12:15:00',1.34),('9303','2013-02-18','12:20:00',1.29),('9303','2013-02-18','12:25:00',1.28),('9303','2013-02-18','12:30:00',1.23),('9303','2013-02-18','12:35:00',1.15),('9303','2013-02-18','12:40:00',1.19),('9303','2013-02-18','12:45:00',1.43),('9303','2013-02-18','12:50:00',1.47),('9303','2013-02-18','12:55:00',1.34),('9303','2013-02-18','13:00:00',1.35),('9303','2013-02-18','13:05:00',1.4),('9303','2013-02-18','13:10:00',1.37),('9303','2013-02-18','13:15:00',1.7),('9303','2013-02-18','13:20:00',1.41),('9303','2013-02-18','13:25:00',1.76),('9303','2013-02-18','13:30:00',1.5),('9303','2013-02-18','13:35:00',1.23),('9303','2013-02-18','13:40:00',1.17),('9303','2013-02-18','13:45:00',1.11),('9303','2013-02-18','13:50:00',1.13),('9303','2013-02-18','13:55:00',1.42),('9303','2013-02-18','14:00:00',1.43),('9303','2013-02-18','14:05:00',1.4),('9303','2013-02-18','14:10:00',1.2),('9303','2013-02-18','14:15:00',1.01),('9303','2013-02-18','14:20:00',1.13),('9303','2013-02-17','08:35:00',1.13),('9303','2013-02-17','08:40:00',1.26),('9303','2013-02-17','08:45:00',1.21),('9303','2013-02-17','08:50:00',1.09),('9303','2013-02-17','08:55:00',1.26),('9303','2013-02-17','09:00:00',1.4),('9303','2013-02-17','09:05:00',1.44),('9303','2013-02-17','09:10:00',1.53),('9303','2013-02-17','09:15:00',1.65),('9303','2013-02-17','09:20:00',1.76),('9303','2013-02-17','09:25:00',1.82),('9303','2013-02-17','09:30:00',1.83),('9303','2013-02-17','09:35:00',1.87),('9303','2013-02-17','09:40:00',1.91),('9303','2013-02-17','09:45:00',1.98),('9303','2013-02-17','09:50:00',2),('9303','2013-02-17','09:55:00',2.07),('9303','2013-02-17','10:00:00',2.11),('9303','2013-02-17','10:05:00',2.14),('9303','2013-02-17','10:10:00',2.17),('9303','2013-02-17','10:15:00',2.2),('9303','2013-02-17','10:20:00',2.27),('9303','2013-02-17','10:25:00',2.31),('9303','2013-02-17','10:30:00',2.31),('9303','2013-02-17','10:35:00',2.43),('9303','2013-02-17','10:40:00',2.48),('9303','2013-02-17','10:45:00',2.46),('9303','2013-02-17','10:50:00',2.52),('9303','2013-02-17','10:55:00',2.54),('9303','2013-02-17','11:00:00',2.57),('9303','2013-02-17','11:05:00',2.63),('9303','2013-02-17','11:10:00',2.61),('9303','2013-02-17','11:15:00',2.68),('9303','2013-02-17','11:20:00',2.71),('9303','2013-02-17','11:25:00',2.7),('9303','2013-02-17','11:30:00',2.71),('9303','2013-02-17','11:35:00',2.71),('9303','2013-02-17','11:40:00',2.75),('9303','2013-02-17','11:45:00',2.77),('9303','2013-02-17','11:50:00',2.78),('9303','2013-02-17','11:55:00',2.79),('9303','2013-02-17','12:00:00',2.79),('9303','2013-02-17','12:05:00',2.81),('9303','2013-02-17','12:10:00',2.87),('9303','2013-02-17','12:15:00',2.88),('9303','2013-02-17','12:20:00',2.9),('9303','2013-02-17','12:25:00',2.93),('9303','2013-02-17','12:30:00',2.95),('9303','2013-02-17','12:35:00',2.94),('9303','2013-02-17','12:40:00',2.95),('9303','2013-02-17','12:45:00',2.81),('9303','2013-02-17','12:50:00',2.69),('9303','2013-02-17','12:55:00',2.73),('9303','2013-02-17','13:00:00',2.74),('9303','2013-02-17','13:05:00',2.74),('9303','2013-02-17','13:10:00',2.68),('9303','2013-02-17','13:15:00',2.67),('9303','2013-02-17','13:20:00',2.42),('9303','2013-02-17','13:25:00',1.93),('9303','2013-02-17','13:30:00',2.45),('9303','2013-02-17','13:35:00',2.53),('9303','2013-02-17','13:40:00',2.48),('9303','2013-02-17','13:45:00',2.43),('9303','2013-02-17','13:50:00',2.23),('9303','2013-02-17','13:55:00',2.28),('9303','2013-02-17','14:10:00',2),('9303','2013-02-17','14:15:00',2.33),('9303','2013-02-17','14:20:00',1.21),('9303','2013-02-17','14:25:00',1.05),('9303','2013-02-17','14:30:00',2.07),('9303','2013-02-17','14:35:00',2.2),('9303','2013-02-17','14:40:00',1.98),('9303','2013-02-17','15:05:00',1.33),('9303','2013-02-17','15:10:00',2.13),('9303','2013-02-17','15:15:00',2.11),('9303','2013-02-17','15:20:00',2.08),('9303','2013-02-17','15:25:00',1.96),('9303','2013-02-17','15:30:00',1.77),('9303','2013-02-17','15:35:00',1.68),('9303','2013-02-17','15:40:00',1.68),('9303','2013-02-17','15:45:00',1.55),('9303','2013-02-17','15:50:00',1.44),('9303','2013-02-17','15:55:00',1.35),('9303','2013-02-17','16:00:00',1.24),('9303','2013-02-17','16:05:00',1.15),('9303','2013-02-16','08:35:00',1),('9303','2013-02-16','08:40:00',1.11),('9303','2013-02-16','09:15:00',1.65),('9303','2013-02-16','09:20:00',1.82),('9303','2013-02-16','09:25:00',1.88),('9303','2013-02-16','09:30:00',1.91),('9303','2013-02-16','09:35:00',1.96),('9303','2013-02-16','09:40:00',1.98),('9303','2013-02-16','09:45:00',2.01),('9303','2013-02-16','09:50:00',2.05),('9303','2013-02-16','09:55:00',2.12),('9303','2013-02-16','10:00:00',2.12),('9303','2013-02-16','10:05:00',2.15),('9303','2013-02-16','10:10:00',2.24),('9303','2013-02-16','10:15:00',2.23),('9303','2013-02-16','10:20:00',2.32),('9303','2013-02-16','10:25:00',2.35),('9303','2013-02-16','10:30:00',2.41),('9303','2013-02-16','10:35:00',2.46),('9303','2013-02-16','10:40:00',2.63),('9303','2013-02-16','10:45:00',2.62),('9303','2013-02-16','10:50:00',2.67),('9303','2013-02-16','10:55:00',2.67),('9303','2013-02-16','11:00:00',2.68),('9303','2013-02-16','11:05:00',2.6),('9303','2013-02-16','11:10:00',2.67),('9303','2013-02-16','11:15:00',2.78),('9303','2013-02-16','11:20:00',2.79),('9303','2013-02-16','11:25:00',2.75),('9303','2013-02-16','11:30:00',2.81),('9303','2013-02-16','11:35:00',2.83),('9303','2013-02-16','11:40:00',2.84),('9303','2013-02-16','11:45:00',2.89),('9303','2013-02-16','11:50:00',2.89),('9303','2013-02-16','11:55:00',2.92),('9303','2013-02-16','12:00:00',2.92),('9303','2013-02-16','12:05:00',2.9),('9303','2013-02-16','12:10:00',2.95),('9303','2013-02-16','12:15:00',2.95),('9303','2013-02-16','12:20:00',2.96),('9303','2013-02-16','12:25:00',3),('9303','2013-02-16','12:30:00',3.01),('9303','2013-02-16','12:35:00',3),('9303','2013-02-16','12:40:00',3.05),('9303','2013-02-16','12:45:00',3.01),('9303','2013-02-16','12:50:00',2.99),('9303','2013-02-16','12:55:00',2.92),('9303','2013-02-16','13:00:00',2.9),('9303','2013-02-16','13:05:00',2.85),('9303','2013-02-16','13:10:00',2.82),('9303','2013-02-16','13:15:00',2.81),('9303','2013-02-16','13:20:00',2.77),('9303','2013-02-16','13:25:00',2.74),('9303','2013-02-16','13:30:00',2.72),('9303','2013-02-16','13:35:00',2.71),('9303','2013-02-16','13:40:00',2.71),('9303','2013-02-16','13:45:00',2.66),('9303','2013-02-16','13:50:00',2.62),('9303','2013-02-16','13:55:00',2.54),('9303','2013-02-16','14:00:00',2.5),('9303','2013-02-16','14:05:00',2.48),('9303','2013-02-16','14:10:00',2.37),('9303','2013-02-16','14:15:00',2.3),('9303','2013-02-16','14:20:00',2.36),('9303','2013-02-16','14:25:00',1.75),('9303','2013-02-16','15:20:00',1.04),('9303','2013-02-16','15:25:00',1.04),('9303','2013-02-16','15:30:00',1.94),('9303','2013-02-16','15:35:00',1.89),('9303','2013-02-16','15:40:00',1.75),('9303','2013-02-16','15:45:00',1.83),('9303','2013-02-16','15:50:00',1.75),('9303','2013-02-16','15:55:00',1.16),('9303','2013-02-16','16:05:00',1.19),('9303','2013-02-15','09:20:00',1.11),('9303','2013-02-15','09:25:00',1.57),('9303','2013-02-15','09:30:00',1.31),('9303','2013-02-15','09:50:00',1.03),('9303','2013-02-15','09:55:00',1.12),('9303','2013-02-15','10:00:00',1.42),('9303','2013-02-15','10:05:00',1.41),('9303','2013-02-15','10:10:00',1.13),('9303','2013-02-15','10:15:00',1.1),('9303','2013-02-15','10:20:00',1.26),('9303','2013-02-15','10:25:00',1.86),('9303','2013-02-15','10:30:00',1.51),('9303','2013-02-15','10:35:00',2.32),('9303','2013-02-15','10:40:00',2.42),('9303','2013-02-15','10:45:00',2.41),('9303','2013-02-15','10:50:00',2.14),('9303','2013-02-15','10:55:00',1.63),('9303','2013-02-15','11:00:00',1.51),('9303','2013-02-15','11:05:00',1.61),('9303','2013-02-15','11:10:00',1.75),('9303','2013-02-15','11:15:00',2.16),('9303','2013-02-15','11:20:00',2.81),('9303','2013-02-15','11:25:00',2.83),('9303','2013-02-15','11:30:00',2.82),('9303','2013-02-15','11:35:00',2.37),('9303','2013-02-15','11:40:00',1.66),('9303','2013-02-15','11:45:00',1.78),('9303','2013-02-15','11:50:00',3.07),('9303','2013-02-15','11:55:00',2.83),('9303','2013-02-15','12:00:00',2.46),('9303','2013-02-15','12:05:00',2.38),('9303','2013-02-15','12:10:00',2.61),('9303','2013-02-15','12:15:00',2.66),('9303','2013-02-15','12:20:00',3.23),('9303','2013-02-15','12:25:00',2.9),('9303','2013-02-15','12:30:00',3.05),('9303','2013-02-15','12:35:00',3.03),('9303','2013-02-15','12:40:00',3.05),('9303','2013-02-15','12:45:00',3.04),('9303','2013-02-15','12:50:00',2.98),('9303','2013-02-15','12:55:00',2.93),('9303','2013-02-15','13:00:00',2.89),('9303','2013-02-15','13:05:00',2.84),('9303','2013-02-15','13:10:00',2.78),('9303','2013-02-15','13:15:00',2.83),('9303','2013-02-15','13:20:00',2.56),('9303','2013-02-15','13:25:00',2.38),('9303','2013-02-15','13:30:00',1.88),('9303','2013-02-15','13:35:00',2.1),('9303','2013-02-15','13:40:00',2.73),('9303','2013-02-15','13:45:00',2.21),('9303','2013-02-15','13:50:00',2.28),('9303','2013-02-15','13:55:00',2.3),('9303','2013-02-15','14:00:00',1.78),('9303','2013-02-15','14:05:00',2.19),('9303','2013-02-15','14:10:00',2.68),('9303','2013-02-15','14:15:00',1.89),('9303','2013-02-15','14:20:00',2.03),('9303','2013-02-15','14:25:00',1.49),('9303','2013-02-15','14:30:00',1.5),('9303','2013-02-15','14:35:00',2.02),('9303','2013-02-15','14:40:00',2.15),('9303','2013-02-15','14:45:00',1.8),('9303','2013-02-15','14:50:00',1.08),('9303','2013-02-15','14:55:00',1.13),('9303','2013-02-15','15:00:00',1.55),('9303','2013-02-15','15:05:00',1.06),('9303','2013-02-15','15:10:00',1.28),('9303','2013-02-15','15:15:00',1.46),('9303','2013-02-15','15:20:00',1.18),('9303','2013-02-15','15:25:00',1.41),('9303','2013-02-15','15:30:00',1.57),('9303','2013-02-15','15:35:00',1.2),('9303','2013-02-15','15:40:00',1.03),('9303','2013-02-15','15:45:00',1.01),('9303','2013-02-14','08:35:00',1.02),('9303','2013-02-14','08:40:00',1.12),('9303','2013-02-14','08:45:00',1.2),('9303','2013-02-14','08:50:00',1.29),('9303','2013-02-14','08:55:00',1.37),('9303','2013-02-14','09:00:00',1.46),('9303','2013-02-14','09:05:00',1.54),('9303','2013-02-14','09:10:00',1.62),('9303','2013-02-14','09:15:00',1.71),('9303','2013-02-14','09:20:00',1.78),('9303','2013-02-14','09:25:00',1.87),('9303','2013-02-14','09:30:00',1.93),('9303','2013-02-14','09:35:00',1.97),('9303','2013-02-14','09:40:00',2.03),('9303','2013-02-14','09:45:00',2.08),('9303','2013-02-14','09:50:00',2.12),('9303','2013-02-14','09:55:00',2.17),('9303','2013-02-14','10:00:00',2.2),('9303','2013-02-14','10:05:00',2.25),('9303','2013-02-14','10:10:00',2.3),('9303','2013-02-14','10:15:00',2.31),('9303','2013-02-14','10:20:00',2.39),('9303','2013-02-14','10:25:00',2.4),('9303','2013-02-14','10:30:00',2.47),('9303','2013-02-14','10:35:00',2.52),('9303','2013-02-14','10:40:00',2.6),('9303','2013-02-14','10:45:00',2.58),('9303','2013-02-14','10:50:00',2.67),('9303','2013-02-14','10:55:00',2.72),('9303','2013-02-14','11:00:00',2.72),('9303','2013-02-14','11:05:00',2.79),('9303','2013-02-14','11:10:00',2.77),('9303','2013-02-14','11:15:00',2.83),('9303','2013-02-14','11:20:00',2.86),('9303','2013-02-14','11:25:00',2.85),('9303','2013-02-14','11:30:00',2.89),('9303','2013-02-14','11:35:00',2.89),('9303','2013-02-14','11:40:00',2.89),('9303','2013-02-14','11:45:00',2.93),('9303','2013-02-14','11:50:00',2.92),('9303','2013-02-14','11:55:00',2.95),('9303','2013-02-14','12:00:00',2.96),('9303','2013-02-14','12:05:00',2.99),('9303','2013-02-14','12:10:00',3.03),('9303','2013-02-14','12:15:00',3.02),('9303','2013-02-14','12:20:00',3.01),('9303','2013-02-14','12:25:00',3.05),('9303','2013-02-14','12:30:00',3.06),('9303','2013-02-14','12:35:00',3.05),('9303','2013-02-14','12:40:00',3.07),('9303','2013-02-14','12:45:00',3.03),('9303','2013-02-14','12:50:00',3.01),('9303','2013-02-14','12:55:00',2.96),('9303','2013-02-14','13:00:00',2.94),('9303','2013-02-14','13:05:00',2.9),('9303','2013-02-14','13:10:00',2.87),('9303','2013-02-14','13:15:00',2.85),('9303','2013-02-14','13:20:00',2.82),('9303','2013-02-14','13:25:00',2.78),('9303','2013-02-14','13:30:00',2.75),('9303','2013-02-14','13:35:00',2.72),('9303','2013-02-14','13:40:00',2.64),('9303','2013-02-14','13:45:00',2.57),('9303','2013-02-14','13:50:00',2.49),('9303','2013-02-14','13:55:00',2.45),('9303','2013-02-14','14:00:00',2.41),('9303','2013-02-14','14:05:00',2.41),('9303','2013-02-14','14:10:00',2.32),('9303','2013-02-14','14:15:00',2.27),('9303','2013-02-14','14:20:00',2.19),('9303','2013-02-14','14:25:00',2.23),('9303','2013-02-14','14:30:00',2.18),('9303','2013-02-14','14:35:00',2.16),('9303','2013-02-14','14:40:00',2.11),('9303','2013-02-14','14:45:00',2.09),('9303','2013-02-14','14:50:00',2.04),('9303','2013-02-14','14:55:00',2.01),('9303','2013-02-14','15:00:00',1.94),('9303','2013-02-14','15:05:00',1.88),('9303','2013-02-14','15:10:00',1.84),('9303','2013-02-14','15:15:00',1.78),('9303','2013-02-14','15:20:00',1.74),('9303','2013-02-14','15:25:00',1.64),('9303','2013-02-14','15:30:00',1.57),('9303','2013-02-14','15:35:00',1.45),('9303','2013-02-14','15:40:00',1.38),('9303','2013-02-14','15:45:00',1.3),('9303','2013-02-14','15:50:00',1.22),('9303','2013-02-14','15:55:00',1.14),('9303','2013-02-14','16:00:00',1.05),('9303','2013-02-13','09:00:00',1.01),('9303','2013-02-13','09:05:00',1.16),('9303','2013-02-13','09:10:00',1.2),('9303','2013-02-13','09:15:00',1.14),('9303','2013-02-13','09:20:00',1.14),('9303','2013-02-13','09:25:00',1.15),('9303','2013-02-13','09:30:00',1.21),('9303','2013-02-13','09:35:00',1.41),('9303','2013-02-13','09:40:00',1.91),('9303','2013-02-13','09:45:00',2.04),('9303','2013-02-13','09:50:00',2.04),('9303','2013-02-13','09:55:00',1.95),('9303','2013-02-13','10:00:00',1.85),('9303','2013-02-13','10:05:00',2.06),('9303','2013-02-13','10:10:00',2.14),('9303','2013-02-13','10:15:00',2.25),('9303','2013-02-13','10:20:00',2.34),('9303','2013-02-13','10:25:00',2.4),('9303','2013-02-13','10:30:00',2.53),('9303','2013-02-13','10:35:00',2.48),('9303','2013-02-13','10:40:00',2.66),('9303','2013-02-13','10:45:00',2.74),('9303','2013-02-13','10:50:00',2.8),('9303','2013-02-13','10:55:00',2.81),('9303','2013-02-13','11:00:00',2.79),('9303','2013-02-13','11:05:00',2.79),('9303','2013-02-13','11:10:00',2.58),('9303','2013-02-13','11:15:00',2.72),('9303','2013-02-13','11:20:00',2.79),('9303','2013-02-13','11:25:00',2.29),('9303','2013-02-13','11:30:00',2.39),('9303','2013-02-13','11:35:00',1.54),('9303','2013-02-13','11:40:00',1.29),('9303','2013-02-13','11:45:00',1.23),('9303','2013-02-13','11:50:00',1.11),('9303','2013-02-13','12:10:00',1.24),('9303','2013-02-13','12:15:00',2.09),('9303','2013-02-13','12:20:00',1.48),('9303','2013-02-13','12:25:00',2.06),('9303','2013-02-13','12:35:00',1.14),('9303','2013-02-13','12:45:00',1.31),('9303','2013-02-13','12:50:00',2.18),('9303','2013-02-13','12:55:00',2.27),('9303','2013-02-13','13:00:00',2.16),('9303','2013-02-13','13:05:00',2.18),('9303','2013-02-13','13:10:00',2.13),('9303','2013-02-13','13:15:00',1.65),('9303','2013-02-13','13:20:00',2.89),('9303','2013-02-13','13:25:00',2.86),('9303','2013-02-13','13:30:00',2.89),('9303','2013-02-13','13:35:00',2.84),('9303','2013-02-13','13:40:00',2.58),('9303','2013-02-13','13:45:00',2.44),('9303','2013-02-13','13:50:00',2.03),('9303','2013-02-13','13:55:00',2.08),('9303','2013-02-13','14:00:00',2.41),('9303','2013-02-13','14:05:00',2.61),('9303','2013-02-13','14:10:00',2.05),('9303','2013-02-13','14:15:00',2.14),('9303','2013-02-13','14:20:00',1.91),('9303','2013-02-13','14:25:00',1.96),('9303','2013-02-13','14:30:00',2.1),('9303','2013-02-13','14:35:00',2.22),('9303','2013-02-13','14:40:00',2.16),('9303','2013-02-13','14:45:00',2.04),('9303','2013-02-13','14:50:00',2.07),('9303','2013-02-13','14:55:00',2.02),('9303','2013-02-13','15:00:00',1.92),('9303','2013-02-13','15:05:00',1.87),('9303','2013-02-13','15:10:00',1.82),('9303','2013-02-13','15:15:00',1.77),('9303','2013-02-13','15:20:00',1.7),('9303','2013-02-13','15:25:00',1.65),('9303','2013-02-13','15:30:00',1.56),('9303','2013-02-13','15:35:00',1.48),('9303','2013-02-13','15:40:00',1.42),('9303','2013-02-13','15:45:00',1.33),('9303','2013-02-13','15:50:00',1.22),('9303','2013-02-13','15:55:00',1.15),('9303','2013-02-13','16:00:00',1.08),('9303','2013-02-11','10:35:00',1.17),('9303','2013-02-11','10:40:00',1.06),('9303','2013-02-11','11:05:00',1.05),('9303','2013-02-11','11:10:00',1.2),('9303','2013-02-11','11:15:00',1.29),('9303','2013-02-11','11:20:00',1.04),('9303','2013-02-11','12:45:00',1),('9303','2013-02-11','14:10:00',1.11),('9303','2013-02-11','14:25:00',1.3),('9303','2013-02-11','14:30:00',1.84),('9303','2013-02-11','14:40:00',1.45),('9303','2013-02-11','14:45:00',1.14),('9303','2014-03-22','07:40:00',1.18),('9303','2014-03-22','07:45:00',1.12),('9303','2014-03-22','07:50:00',1.07),('9303','2014-03-22','08:10:00',1.09),('9303','2014-03-22','08:15:00',1.4),('9303','2014-03-22','08:20:00',1.68),('9303','2014-03-22','08:25:00',1.62),('9303','2014-03-22','08:30:00',1.78),('9303','2014-03-22','08:40:00',2.06),('9303','2014-03-22','08:45:00',2.18),('9303','2014-03-22','08:50:00',1.61),('9303','2014-03-22','08:55:00',1.39),('9303','2014-03-22','09:00:00',2.04),('9303','2014-03-22','09:05:00',1.26),('9303','2014-03-22','09:10:00',1.33),('9303','2014-03-22','09:15:00',1.15),('9303','2014-03-22','09:20:00',1.24),('9303','2014-03-22','09:25:00',1.57),('9303','2014-03-22','09:30:00',2.59),('9303','2014-03-22','09:35:00',1.9),('9303','2014-03-22','09:40:00',2.55),('9303','2014-03-22','09:45:00',2.89),('9303','2014-03-22','09:50:00',2.87),('9303','2014-03-22','09:55:00',3.01),('9303','2014-03-22','10:00:00',3.11),('9303','2014-03-22','10:05:00',3.36),('9303','2014-03-22','10:10:00',2.96),('9303','2014-03-22','10:15:00',1.64),('9303','2014-03-22','10:20:00',1.04),('9303','2014-03-22','10:35:00',1.32),('9303','2014-03-22','10:40:00',2),('9303','2014-03-22','10:45:00',2.37),('9303','2014-03-22','10:50:00',3.66),('9303','2014-03-22','10:55:00',1.29),('9303','2014-03-22','11:00:00',1.12),('9303','2014-03-22','11:10:00',1.08),('9303','2014-03-22','11:15:00',1.49),('9303','2014-03-22','11:20:00',3.55),('9303','2014-03-22','11:25:00',3.75),('9303','2014-03-22','11:30:00',3.78),('9303','2014-03-22','11:35:00',1.45),('9303','2014-03-22','11:40:00',2.7),('9303','2014-03-22','11:45:00',1.65),('9303','2014-03-22','11:50:00',2.4),('9303','2014-03-22','11:55:00',3.56),('9303','2014-03-22','12:00:00',3.11),('9303','2014-03-22','12:05:00',1.8),('9303','2014-03-22','12:10:00',1.14),('9303','2014-03-22','12:15:00',1.5),('9303','2014-03-22','12:20:00',3.49),('9303','2014-03-22','12:25:00',3.21),('9303','2014-03-22','12:30:00',1.75),('9303','2014-03-22','12:35:00',3.1),('9303','2014-03-22','12:40:00',2.75),('9303','2014-03-22','12:45:00',4.1),('9303','2014-03-22','12:50:00',2.12),('9303','2014-03-22','12:55:00',2.52),('9303','2014-03-22','13:00:00',1.87),('9303','2014-03-22','13:05:00',1.65),('9303','2014-03-22','13:10:00',4.09),('9303','2014-03-22','13:15:00',2.53),('9303','2014-03-22','13:20:00',3.18),('9303','2014-03-22','13:25:00',3.6),('9303','2014-03-22','13:30:00',2.06),('9303','2014-03-22','13:35:00',3.22),('9303','2014-03-22','13:40:00',2.44),('9303','2014-03-22','13:45:00',4.06),('9303','2014-03-22','13:50:00',3.24),('9303','2014-03-22','13:55:00',1.91),('9303','2014-03-22','14:00:00',2.12),('9303','2014-03-22','14:05:00',1.65),('9303','2014-03-22','14:10:00',3.57),('9303','2014-03-22','14:15:00',2.74),('9303','2014-03-22','14:20:00',3.06),('9303','2014-03-22','14:25:00',3.23),('9303','2014-03-22','14:30:00',3.12),('9303','2014-03-22','14:35:00',3.06),('9303','2014-03-22','14:40:00',3),('9303','2014-03-22','14:45:00',2.87),('9303','2014-03-22','14:50:00',2.86),('9303','2014-03-22','14:55:00',2.82),('9303','2014-03-22','15:00:00',2.75),('9303','2014-03-22','15:05:00',2.69),('9303','2014-03-22','15:10:00',2.55),('9303','2014-03-22','15:15:00',2.46),('9303','2014-03-22','15:20:00',2.53),('9303','2014-03-22','15:25:00',2.11),('9303','2014-03-22','15:30:00',1.28),('9303','2014-03-22','15:35:00',2.03),('9303','2014-03-22','15:40:00',2.41),('9303','2014-03-22','15:45:00',2.22),('9303','2014-03-22','15:50:00',2.42),('9303','2014-03-22','15:55:00',2.28),('9303','2014-03-22','16:00:00',2.05),('9303','2014-03-22','16:05:00',1.83),('9303','2014-03-22','16:10:00',1.64),('9303','2014-03-22','16:15:00',1.39),('9303','2014-03-22','16:20:00',1.49),('9303','2014-03-22','16:25:00',1.36),('9303','2013-02-10','09:50:00',1.08),('9303','2013-02-10','10:00:00',2.03),('9303','2013-02-10','10:05:00',2.19),('9303','2013-02-10','10:10:00',2.12),('9303','2013-02-10','10:15:00',2.17),('9303','2013-02-10','10:20:00',2.23),('9303','2013-02-10','10:25:00',2.33),('9303','2013-02-10','10:30:00',2.41),('9303','2013-02-10','10:35:00',2.47),('9303','2013-02-10','10:40:00',2.49),('9303','2013-02-10','10:45:00',2.54),('9303','2013-02-10','10:50:00',2.57),('9303','2013-02-10','10:55:00',2.6),('9303','2013-02-10','11:00:00',2.63),('9303','2013-02-10','11:05:00',2.71),('9303','2013-02-10','11:10:00',2.71),('9303','2013-02-10','11:15:00',2.75),('9303','2013-02-10','11:20:00',2.78),('9303','2013-02-10','11:25:00',2.75),('9303','2013-02-10','11:30:00',2.81),('9303','2013-02-10','11:35:00',2.84),('9303','2013-02-10','11:40:00',2.84),('9303','2013-02-10','11:45:00',2.87),('9303','2013-02-10','11:50:00',2.85),('9303','2013-02-10','11:55:00',2.89),('9303','2013-02-10','12:00:00',2.93),('9303','2013-02-10','12:05:00',2.94),('9303','2013-02-10','12:10:00',2.98),('9303','2013-02-10','12:15:00',3),('9303','2013-02-10','12:20:00',3),('9303','2013-02-10','12:25:00',3),('9303','2013-02-10','12:30:00',3.03),('9303','2013-02-10','12:35:00',3.01),('9303','2013-02-10','12:40:00',3.01),('9303','2013-02-10','12:45:00',2.99),('9303','2013-02-10','12:50:00',2.93),('9303','2013-02-10','12:55:00',2.88),('9303','2013-02-10','13:00:00',2.79),('9303','2013-02-10','13:05:00',2.67),('9303','2013-02-10','13:10:00',2.7),('9303','2013-02-10','13:15:00',2.64),('9303','2013-02-10','13:20:00',2.63),('9303','2013-02-10','13:25:00',2.62),('9303','2013-02-10','13:30:00',2.57),('9303','2013-02-10','13:35:00',2.51),('9303','2013-02-10','13:40:00',2.46),('9303','2013-02-10','13:45:00',2.39),('9303','2013-02-10','13:50:00',2.36),('9303','2013-02-10','13:55:00',2.31),('9303','2013-02-10','14:00:00',2.23),('9303','2013-02-10','14:05:00',2.19),('9303','2013-02-10','14:10:00',2.12),('9303','2013-02-10','14:15:00',2.13),('9303','2013-02-10','14:20:00',2.11),('9303','2013-02-10','14:25:00',2.07),('9303','2013-02-10','14:30:00',2.09),('9303','2013-02-10','14:35:00',1.85),('9303','2013-02-10','14:40:00',1.97),('9303','2013-02-10','14:45:00',2.02),('9303','2013-02-10','14:50:00',1.95),('9303','2013-02-10','14:55:00',1.9),('9303','2013-02-10','15:00:00',1.25),('9303','2013-02-10','15:05:00',1.16),('9303','2013-02-10','15:10:00',1.78),('9303','2013-02-10','15:20:00',1.45),('9303','2013-02-10','15:25:00',1.85),('9303','2013-02-10','15:30:00',1.15),('9303','2013-02-10','15:35:00',1.53),('9303','2013-02-09','11:05:00',1),('9303','2013-02-09','11:10:00',1.03),('9303','2013-02-09','11:15:00',1.07),('9303','2013-02-09','11:20:00',1.1),('9303','2013-02-09','11:25:00',1.12),('9303','2013-02-09','11:30:00',1.13),('9303','2013-02-09','11:35:00',1.1),('9303','2013-02-09','11:40:00',1.07),('9303','2013-02-09','11:45:00',1.08),('9303','2013-02-09','11:50:00',1.08),('9303','2013-02-09','11:55:00',1.05),('9303','2013-02-09','12:00:00',1.06),('9303','2013-02-09','12:05:00',1.06),('9303','2013-02-09','12:10:00',1.04),('9303','2013-02-09','12:15:00',1.04),('9303','2013-02-09','12:20:00',1.06),('9303','2013-02-09','12:25:00',1.07),('9303','2013-02-09','12:30:00',1.08),('9303','2013-02-09','12:35:00',1.14),('9303','2013-02-09','12:40:00',1.17),('9303','2013-02-09','12:45:00',1.18),('9303','2013-02-09','12:50:00',1.2),('9303','2013-02-09','12:55:00',1.18),('9303','2013-02-09','13:00:00',1.25),('9303','2013-02-09','13:05:00',1.42),('9303','2013-02-09','13:10:00',1.58),('9303','2013-02-09','13:15:00',1.74),('9303','2013-02-09','13:20:00',1.9),('9303','2013-02-09','13:25:00',1.97),('9303','2013-02-09','13:30:00',2.18),('9303','2013-02-09','13:35:00',2.19),('9303','2013-02-09','13:40:00',2.23),('9303','2013-02-09','13:45:00',2.26),('9303','2013-02-09','13:50:00',2.37),('9303','2013-02-09','13:55:00',2.32),('9303','2013-02-09','14:00:00',2.41),('9303','2013-02-09','14:05:00',2.23),('9303','2013-02-09','14:10:00',1.81),('9303','2013-02-09','14:15:00',2.29),('9303','2013-02-09','14:20:00',2.5),('9303','2013-02-09','14:25:00',2.72),('9303','2013-02-09','14:30:00',2.45),('9303','2013-02-09','14:35:00',2.24),('9303','2013-02-09','14:40:00',2.06),('9303','2013-02-09','14:45:00',1.96),('9303','2013-02-09','14:50:00',1.9),('9303','2013-02-09','14:55:00',1.91),('9303','2013-02-09','15:00:00',1.81),('9303','2013-02-09','15:05:00',1.75),('9303','2013-02-09','15:10:00',1.71),('9303','2013-02-09','15:15:00',1.64),('9303','2013-02-09','15:20:00',1.6),('9303','2013-02-09','15:25:00',1.42),('9303','2013-02-09','15:30:00',1.38),('9303','2013-02-09','15:35:00',1.32),('9303','2013-02-09','15:40:00',1.21),('9303','2013-02-09','15:45:00',1.04),('9303','2013-02-09','15:50:00',1.06),('9303','2013-02-08','09:35:00',2.29),('9303','2013-02-08','09:40:00',2.18),('9303','2013-02-08','09:45:00',1.66),('9303','2013-02-08','09:50:00',2.32),('9303','2013-02-08','09:55:00',2.4),('9303','2013-02-08','10:00:00',2.53),('9303','2013-02-08','10:05:00',2.63),('9303','2013-02-08','10:10:00',2.59),('9303','2013-02-08','10:15:00',2.57),('9303','2013-02-08','10:20:00',2.58),('9303','2013-02-08','10:25:00',2.57),('9303','2013-02-08','10:30:00',2.63),('9303','2013-02-08','10:35:00',1.44),('9303','2013-02-08','10:40:00',1.82),('9303','2013-02-08','10:45:00',2.53),('9303','2013-02-08','10:50:00',2.86),('9303','2013-02-08','10:55:00',2.83),('9303','2013-02-08','11:00:00',2.76),('9303','2013-02-08','11:05:00',2.75),('9303','2013-02-08','11:10:00',2.73),('9303','2013-02-08','11:15:00',2.76),('9303','2013-02-08','11:20:00',2.78),('9303','2013-02-08','11:25:00',2.77),('9303','2013-02-08','11:30:00',2.79),('9303','2013-02-08','11:35:00',2.81),('9303','2013-02-08','11:40:00',2.81),('9303','2013-02-08','11:45:00',2.84),('9303','2013-02-08','11:50:00',2.83),('9303','2013-02-08','11:55:00',2.86),('9303','2013-02-08','12:00:00',2.86),('9303','2013-02-08','12:05:00',2.85),('9303','2013-02-08','12:10:00',2.89),('9303','2013-02-08','12:15:00',2.93),('9303','2013-02-08','12:20:00',2.93),('9303','2013-02-08','12:25:00',2.95),('9303','2013-02-08','12:30:00',2.99),('9303','2013-02-08','12:35:00',3),('9303','2013-02-08','12:40:00',3.01),('9303','2013-02-08','12:45:00',3.24),('9303','2013-02-08','12:50:00',2.31),('9303','2013-02-08','12:55:00',1.9),('9303','2013-02-08','13:00:00',1.75),('9303','2013-02-08','13:05:00',1.6),('9303','2013-02-08','13:10:00',1.78),('9303','2013-02-08','13:15:00',1.7),('9303','2013-02-08','13:20:00',1.79),('9303','2013-02-08','13:25:00',1.66),('9303','2013-02-08','13:30:00',1.63),('9303','2013-02-08','13:35:00',2.24),('9303','2013-02-08','13:40:00',1.79),('9303','2013-02-08','13:45:00',1.41),('9303','2013-02-08','13:50:00',1.44),('9303','2013-02-08','13:55:00',1.48),('9303','2013-02-08','14:00:00',1.39),('9303','2013-02-08','14:05:00',1.36),('9303','2013-02-08','14:10:00',1.25),('9303','2013-02-08','14:15:00',1.12),('9303','2013-02-08','14:20:00',1.13),('9303','2013-02-08','14:25:00',1.33),('9303','2013-02-08','14:30:00',1.75),('9303','2013-02-08','14:35:00',1.65),('9303','2013-02-08','14:40:00',2.91),('9303','2013-02-08','14:45:00',2.69),('9303','2013-02-08','14:50:00',1.84),('9303','2013-02-08','14:55:00',2.18),('9303','2013-02-08','15:00:00',2.2),('9303','2013-02-08','15:05:00',2.48),('9303','2013-02-08','15:10:00',2.42),('9303','2013-02-08','15:15:00',2),('9303','2013-02-08','15:20:00',1.32),('9303','2013-02-08','15:25:00',1.7),('9303','2013-02-08','15:30:00',1.54),('9303','2013-02-08','15:35:00',1.43),('9303','2013-02-08','15:40:00',1.34),('9303','2013-02-08','15:45:00',1.25),('9303','2013-02-08','15:50:00',1.16),('9303','2013-02-08','15:55:00',1.07),('9303','2013-02-07','10:40:00',1.12),('9303','2013-02-07','10:45:00',1.25),('9303','2013-02-07','10:55:00',1.16),('9303','2013-02-07','11:00:00',1.77),('9303','2013-02-07','11:05:00',1.13),('9303','2013-02-07','12:25:00',2.34),('9303','2013-02-07','12:30:00',1.86),('9303','2013-02-07','13:15:00',1.33),('9303','2013-02-07','13:20:00',1.36),('9303','2013-02-07','13:25:00',1.18),('9303','2013-02-07','14:00:00',1.2),('9303','2013-02-07','14:05:00',1.63),('9303','2013-02-07','14:10:00',2.48),('9303','2013-02-07','14:15:00',2.34),('9303','2013-02-07','14:20:00',2.16),('9303','2013-02-07','14:25:00',1.22),('9303','2013-02-07','14:30:00',1.01),('9303','2013-02-07','14:35:00',1.55),('9303','2013-02-07','14:40:00',1.38),('9303','2013-02-07','14:45:00',1.92),('9303','2013-02-07','14:50:00',1.3),('9303','2013-02-07','15:00:00',1.44),('9303','2013-02-07','15:05:00',2.1),('9303','2013-02-07','15:10:00',2.21),('9303','2013-02-07','15:15:00',1.56),('9303','2013-02-06','08:50:00',1.15),('9303','2013-02-06','09:00:00',1.02),('9303','2013-02-06','09:05:00',1.12),('9303','2013-02-06','09:10:00',1.32),('9303','2013-02-06','09:25:00',1.03),('9303','2013-02-06','09:30:00',1.36),('9303','2013-02-06','09:35:00',1.04),('9303','2013-02-06','09:40:00',1.47),('9303','2013-02-06','09:45:00',1.1),('9303','2013-02-06','09:50:00',1.14),('9303','2013-02-06','09:55:00',1.39),('9303','2013-02-06','10:00:00',1.18),('9303','2013-02-06','10:05:00',1.46),('9303','2013-02-06','10:10:00',1.29),('9303','2013-02-06','10:15:00',1.21),('9303','2013-02-06','10:20:00',1.06),('9303','2013-02-06','10:25:00',1.31),('9303','2013-02-06','10:30:00',1.32),('9303','2013-02-06','10:35:00',1.6),('9303','2013-02-06','10:40:00',1.17),('9303','2013-02-06','10:50:00',1.41),('9303','2013-02-06','10:55:00',1.86),('9303','2013-02-06','11:00:00',1.58),('9303','2013-02-06','11:05:00',1.25),('9303','2013-02-06','11:10:00',1.45),('9303','2013-02-06','11:15:00',1.31),('9303','2013-02-06','11:20:00',1.53),('9303','2013-02-06','11:25:00',2.14),('9303','2013-02-06','11:30:00',1.44),('9303','2013-02-06','11:35:00',1.34),('9303','2013-02-06','11:40:00',1.48),('9303','2013-02-06','11:45:00',1.51),('9303','2013-02-06','11:50:00',1.55),('9303','2013-02-06','11:55:00',1.48),('9303','2013-02-06','12:00:00',1.27),('9303','2013-02-06','12:05:00',1.03),('9303','2013-02-06','12:20:00',1),('9303','2013-02-06','13:30:00',1.13),('9303','2013-02-06','13:35:00',1.26),('9303','2013-02-06','13:40:00',1.01),('9303','2013-02-06','13:50:00',1.53),('9303','2013-02-06','13:55:00',1.2),('9303','2013-02-06','14:00:00',1.32),('9303','2013-02-06','14:05:00',1.25),('9303','2013-02-06','14:30:00',1.25),('9303','2013-02-06','14:35:00',2),('9303','2013-02-06','14:40:00',1.17),('9303','2013-02-05','08:55:00',1.1),('9303','2013-02-05','09:00:00',1.2),('9303','2013-02-05','09:05:00',1.28),('9303','2013-02-05','09:10:00',1.37),('9303','2013-02-05','09:15:00',1.46),('9303','2013-02-05','09:20:00',1.53),('9303','2013-02-05','09:25:00',1.59),('9303','2013-02-05','09:30:00',1.64),('9303','2013-02-05','09:35:00',1.7),('9303','2013-02-05','09:40:00',1.77),('9303','2013-02-05','09:45:00',1.81),('9303','2013-02-05','09:50:00',1.85),('9303','2013-02-05','09:55:00',1.9),('9303','2013-02-05','10:00:00',1.9),('9303','2013-02-05','10:05:00',1.88),('9303','2013-02-05','10:10:00',1.75),('9303','2013-02-05','10:15:00',1.75),('9303','2013-02-05','10:20:00',1.94),('9303','2013-02-05','10:25:00',1.94),('9303','2013-02-05','10:30:00',2.02),('9303','2013-02-05','10:35:00',2.06),('9303','2013-02-05','10:40:00',2.11),('9303','2013-02-05','10:45:00',2.14),('9303','2013-02-05','10:50:00',2.13),('9303','2013-02-05','10:55:00',2.19),('9303','2013-02-05','11:00:00',2.21),('9303','2013-02-05','11:05:00',2.24),('9303','2013-02-05','11:10:00',2.32),('9303','2013-02-05','11:15:00',2.34),('9303','2013-02-05','11:20:00',2.34),('9303','2013-02-05','11:25:00',2.39),('9303','2013-02-05','11:30:00',2.39),('9303','2013-02-05','11:35:00',2.29),('9303','2013-02-05','11:40:00',2.11),('9303','2013-02-05','11:45:00',2),('9303','2013-02-05','11:50:00',1.53),('9303','2013-02-05','11:55:00',1.35),('9303','2013-02-05','12:00:00',1.07),('9303','2013-02-05','12:05:00',1.26),('9303','2013-02-05','12:10:00',1.56),('9303','2013-02-05','12:15:00',1.33),('9303','2013-02-05','12:20:00',1.06),('9303','2013-02-05','12:30:00',1.03),('9303','2013-02-05','12:35:00',1.17),('9303','2013-02-05','12:40:00',1.67),('9303','2013-02-05','12:45:00',1.73),('9303','2013-02-05','12:50:00',1.86),('9303','2013-02-05','13:15:00',1.2),('9303','2013-02-05','13:20:00',1.24),('9303','2013-02-05','13:25:00',1.2),('9303','2013-02-05','13:30:00',1.18),('9303','2013-02-05','13:45:00',1.2),('9303','2013-02-05','13:50:00',1.28),('9303','2013-02-05','13:55:00',1.09),('9303','2013-02-05','14:00:00',1.13),('9303','2013-02-05','14:05:00',1.17),('9303','2013-02-05','14:20:00',1.05),('9303','2013-02-05','14:25:00',1.56),('9303','2013-02-05','14:30:00',1.55),('9303','2013-02-05','14:35:00',1.41),('9303','2013-02-05','14:40:00',1.46),('9303','2013-02-04','08:50:00',1.01),('9303','2013-02-04','09:00:00',1.25),('9303','2013-02-04','09:05:00',1.37),('9303','2013-02-04','09:10:00',1.49),('9303','2013-02-04','09:15:00',1.58),('9303','2013-02-04','09:20:00',1.56),('9303','2013-02-04','09:25:00',1.58),('9303','2013-02-04','09:30:00',1.71),('9303','2013-02-04','09:35:00',1.72),('9303','2013-02-04','09:40:00',1.74),('9303','2013-02-04','09:45:00',1.54),('9303','2013-02-04','09:50:00',1.89),('9303','2013-02-04','09:55:00',2.04),('9303','2013-02-04','10:00:00',2.1),('9303','2013-02-04','10:05:00',2.07),('9303','2013-02-04','10:10:00',2.14),('9303','2013-02-04','10:15:00',2.16),('9303','2013-02-04','10:20:00',2),('9303','2013-02-04','10:25:00',2.1),('9303','2013-02-04','10:30:00',2.01),('9303','2013-02-04','10:35:00',1.92),('9303','2013-02-04','10:40:00',2.03),('9303','2013-02-04','10:45:00',2.26),('9303','2013-02-04','10:50:00',2.31),('9303','2013-02-04','10:55:00',2.31),('9303','2013-02-04','11:00:00',2.35),('9303','2013-02-04','11:05:00',2.41),('9303','2013-02-04','11:10:00',2.46),('9303','2013-02-04','11:15:00',2.51),('9303','2013-02-04','11:20:00',2.49),('9303','2013-02-04','11:25:00',2.52),('9303','2013-02-04','11:30:00',2.58),('9303','2013-02-04','11:35:00',2.59),('9303','2013-02-04','11:40:00',2.59),('9303','2013-02-04','11:45:00',2.66),('9303','2013-02-04','11:50:00',2.64),('9303','2013-02-04','11:55:00',2.67),('9303','2013-02-04','12:00:00',2.67),('9303','2013-02-04','12:05:00',2.68),('9303','2013-02-04','12:10:00',2.75),('9303','2013-02-04','12:15:00',2.78),('9303','2013-02-04','12:20:00',2.78),('9303','2013-02-04','12:25:00',2.77),('9303','2013-02-04','12:30:00',2.82),('9303','2013-02-04','12:35:00',2.79),('9303','2013-02-04','12:40:00',2.81),('9303','2013-02-04','12:45:00',2.78),('9303','2013-02-04','12:50:00',2.68),('9303','2013-02-04','12:55:00',2.71),('9303','2013-02-04','13:00:00',2.66),('9303','2013-02-04','13:05:00',2.57),('9303','2013-02-04','13:10:00',2.52),('9303','2013-02-04','13:15:00',2.47),('9303','2013-02-04','13:20:00',2.47),('9303','2013-02-04','13:25:00',2.42),('9303','2013-02-04','13:30:00',2.41),('9303','2013-02-04','13:35:00',2.38),('9303','2013-02-04','13:40:00',2.33),('9303','2013-02-04','13:45:00',2.3),('9303','2013-02-04','13:50:00',2.29),('9303','2013-02-04','13:55:00',2.23),('9303','2013-02-04','14:00:00',2.17),('9303','2013-02-04','14:05:00',2.06),('9303','2013-02-04','14:10:00',2.06),('9303','2013-02-04','14:15:00',2.03),('9303','2013-02-04','14:20:00',2.05),('9303','2013-02-04','14:25:00',2.04),('9303','2013-02-04','14:30:00',1.99),('9303','2013-02-04','14:35:00',1.96),('9303','2013-02-04','14:40:00',1.92),('9303','2013-02-04','14:45:00',1.89),('9303','2013-02-04','14:50:00',1.84),('9303','2013-02-04','14:55:00',1.79),('9303','2013-02-04','15:00:00',1.74),('9303','2013-02-04','15:05:00',1.68),('9303','2013-02-04','15:10:00',1.63),('9303','2013-02-04','15:15:00',1.57),('9303','2013-02-04','15:20:00',1.5),('9303','2013-02-04','15:25:00',1.41),('9303','2013-02-04','15:30:00',1.35),('9303','2013-02-04','15:35:00',1.27),('9303','2013-02-04','15:40:00',1.17),('9303','2013-02-04','15:45:00',1.1),('9303','2013-02-04','15:50:00',1.02),('9303','2013-02-03','09:25:00',1.18),('9303','2013-02-03','09:40:00',1.1),('9303','2013-02-03','09:45:00',1.35),('9303','2013-02-03','09:50:00',1.34),('9303','2013-02-03','09:55:00',1.15),('9303','2013-02-03','10:00:00',1.67),('9303','2013-02-03','11:20:00',1.21),('9303','2013-02-03','11:55:00',1.13),('9303','2013-02-03','12:00:00',1.19),('9303','2013-02-03','12:05:00',1.13),('9303','2013-02-03','12:10:00',1.1),('9303','2013-02-02','10:30:00',1.05),('9303','2013-02-02','10:35:00',1.18),('9303','2013-02-02','10:40:00',1.28),('9303','2013-02-02','10:45:00',1.38),('9303','2013-02-02','10:50:00',1.09),('9303','2013-02-02','10:55:00',1.52),('9303','2013-02-02','11:00:00',1.68),('9303','2013-02-02','11:05:00',1.56),('9303','2013-02-02','11:10:00',1.66),('9303','2013-02-02','11:15:00',1.6),('9303','2013-02-02','11:20:00',1.64),('9303','2013-02-02','11:25:00',1.78),('9303','2013-02-02','11:30:00',1.72),('9303','2013-02-02','11:35:00',1.62),('9303','2013-02-02','11:40:00',1.59),('9303','2013-02-02','11:45:00',1.1),('9303','2013-02-02','11:55:00',1.06),('9303','2013-02-02','12:55:00',1.74),('9303','2013-02-02','13:00:00',1.44),('9303','2013-02-02','13:05:00',1.61),('9303','2013-02-02','13:10:00',1.64),('9303','2013-02-02','13:15:00',1.94),('9303','2013-02-02','13:20:00',1.59),('9303','2013-02-02','13:25:00',1.62),('9303','2013-02-02','13:30:00',1.17),('9303','2013-02-02','13:35:00',1.73),('9303','2013-02-02','13:40:00',2.17),('9303','2013-02-02','13:45:00',1.74),('9303','2013-02-02','13:50:00',1.72),('9303','2013-02-02','13:55:00',1),('9303','2013-02-01','09:00:00',1.02),('9303','2013-02-01','09:05:00',1.26),('9303','2013-02-01','09:10:00',1.46),('9303','2013-02-01','09:25:00',1.46),('9303','2013-02-01','09:30:00',1.2),('9303','2013-02-01','09:35:00',1.34),('9303','2013-02-01','09:40:00',1.9),('9303','2013-02-01','09:45:00',1.65),('9303','2013-02-01','09:50:00',1.05),('9303','2013-02-01','09:55:00',1.33),('9303','2013-02-01','10:00:00',1.53),('9303','2013-02-01','10:05:00',1.12),('9303','2013-02-01','10:20:00',1.38),('9303','2013-02-01','10:25:00',1.15),('9303','2013-02-01','10:30:00',1.03),('9303','2013-02-01','10:50:00',1.99),('9303','2013-02-01','10:55:00',2.53),('9303','2013-02-01','11:00:00',2.44),('9303','2013-02-01','11:05:00',2.29),('9303','2013-02-01','11:10:00',1.99),('9303','2013-02-01','11:15:00',1.41),('9303','2013-02-01','11:20:00',1.91),('9303','2013-02-01','11:25:00',1.06),('9303','2013-02-01','11:35:00',1.86),('9303','2013-02-01','11:40:00',1.72),('9303','2013-02-01','11:45:00',1.71),('9303','2013-02-01','11:50:00',1.21),('9303','2013-02-01','12:00:00',1.08),('9303','2013-02-01','12:05:00',1.35),('9303','2013-02-01','12:10:00',1.45),('9303','2013-02-01','12:15:00',1.93),('9303','2013-02-01','12:20:00',2.64),('9303','2013-02-01','12:25:00',2.45),('9303','2013-02-01','12:30:00',1.12),('9303','2013-02-01','12:35:00',2.45),('9303','2013-02-01','12:40:00',2.99),('9303','2013-02-01','12:45:00',2.77),('9303','2013-02-01','12:50:00',2.82),('9303','2013-02-01','12:55:00',2.17),('9303','2013-02-01','13:00:00',2.25),('9303','2013-02-01','13:05:00',1.72),('9303','2013-02-01','13:10:00',2.6),('9303','2013-02-01','13:15:00',2.36),('9303','2013-02-01','13:20:00',2.34),('9303','2013-02-01','13:25:00',2.16),('9303','2013-02-01','13:30:00',1.58),('9303','2013-02-01','13:35:00',1.9),('9303','2013-02-01','13:40:00',1.95),('9303','2013-02-01','13:45:00',1.85),('9303','2013-02-01','13:50:00',1.46),('9303','2013-02-01','14:10:00',1.05),('9303','2013-02-01','14:15:00',2.08),('9303','2013-02-01','14:20:00',2.14),('9303','2013-02-01','14:25:00',1.89),('9303','2013-02-01','14:30:00',1.88),('9303','2013-02-01','14:35:00',1.84),('9303','2013-02-01','14:40:00',1.64),('9303','2013-02-01','15:05:00',1.04),('9303','2013-02-01','15:10:00',1.47),('9303','2013-02-01','15:15:00',1.27),('9303','2013-02-01','15:20:00',1.31),('9303','2013-02-01','15:25:00',1.22),('9303','2014-03-21','07:45:00',1.05),('9303','2014-03-21','07:50:00',1.16),('9303','2014-03-21','07:55:00',1.26),('9303','2014-03-21','08:00:00',1.33),('9303','2014-03-21','08:05:00',1.39),('9303','2014-03-21','08:10:00',1.52),('9303','2014-03-21','08:15:00',1.62),('9303','2014-03-21','08:20:00',1.67),('9303','2014-03-21','08:25:00',1.77),('9303','2014-03-21','08:30:00',1.87),('9303','2014-03-21','08:35:00',1.98),('9303','2014-03-21','08:40:00',2.06),('9303','2014-03-21','08:45:00',2.09),('9303','2014-03-21','08:50:00',2.19),('9303','2014-03-21','08:55:00',2.28),('9303','2014-03-21','09:00:00',2.34),('9303','2014-03-21','09:05:00',2.36),('9303','2014-03-21','09:10:00',2.51),('9303','2014-03-21','09:15:00',2.56),('9303','2014-03-21','09:20:00',2.68),('9303','2014-03-21','09:25:00',2.6),('9303','2014-03-21','09:30:00',2.78),('9303','2014-03-21','09:35:00',2.8),('9303','2014-03-21','09:40:00',2.86),('9303','2014-03-21','09:45:00',2.92),('9303','2014-03-21','09:50:00',2.97),('9303','2014-03-21','09:55:00',3.01),('9303','2014-03-21','10:00:00',3.06),('9303','2014-03-21','10:05:00',3.06),('9303','2014-03-21','10:10:00',3.01),('9303','2014-03-21','10:15:00',3.09),('9303','2014-03-21','10:20:00',3.14),('9303','2014-03-21','10:25:00',3.26),('9303','2014-03-21','10:30:00',3.29),('9303','2014-03-21','10:35:00',3.31),('9303','2014-03-21','10:40:00',3.38),('9303','2014-03-21','10:45:00',3.32),('9303','2014-03-21','10:50:00',3.31),('9303','2014-03-21','10:55:00',3.35),('9303','2014-03-21','11:00:00',3.37),('9303','2014-03-21','11:05:00',3.42),('9303','2014-03-21','11:10:00',3.35),('9303','2014-03-21','11:15:00',3.41),('9303','2014-03-21','11:20:00',3.41),('9303','2014-03-21','11:25:00',3.61),('9303','2014-03-21','11:30:00',2.75),('9303','2014-03-21','11:35:00',1.27),('9303','2014-03-21','11:40:00',1.61),('9303','2014-03-21','11:45:00',1.55),('9303','2014-03-21','11:50:00',1.91),('9303','2014-03-21','11:55:00',4.11),('9303','2014-03-21','12:00:00',3.43),('9303','2014-03-21','12:05:00',3.78),('9303','2014-03-21','12:10:00',3.76),('9303','2014-03-21','12:15:00',3.76),('9303','2014-03-21','12:20:00',3.76),('9303','2014-03-21','12:25:00',3.76),('9303','2014-03-21','12:30:00',3.76),('9303','2014-03-21','12:35:00',3.69),('9303','2014-03-21','12:40:00',3.7),('9303','2014-03-21','12:45:00',3.72),('9303','2014-03-21','12:50:00',3.69),('9303','2014-03-21','12:55:00',3.68),('9303','2014-03-21','13:00:00',3.63),('9303','2014-03-21','13:05:00',3.64),('9303','2014-03-21','13:10:00',3.63),('9303','2014-03-21','13:15:00',3.61),('9303','2014-03-21','13:20:00',3.6),('9303','2014-03-21','13:25:00',3.56),('9303','2014-03-21','13:30:00',3.54),('9303','2014-03-21','13:35:00',3.47),('9303','2014-03-21','13:40:00',3.46),('9303','2014-03-21','13:45:00',3.45),('9303','2014-03-21','13:50:00',3.43),('9303','2014-03-21','13:55:00',3.4),('9303','2014-03-21','14:00:00',3.4),('9303','2014-03-21','14:05:00',3.37),('9303','2014-03-21','14:10:00',3.35),('9303','2014-03-21','14:15:00',3.3),('9303','2014-03-21','14:20:00',3.27),('9303','2014-03-21','14:25:00',3.23),('9303','2014-03-21','14:30:00',3.03),('9303','2014-03-21','14:35:00',2.95),('9303','2014-03-21','14:40:00',2.98),('9303','2014-03-21','14:45:00',2.89),('9303','2014-03-21','14:50:00',2.34),('9303','2014-03-21','14:55:00',1.4),('9303','2014-03-21','15:05:00',1.32),('9303','2014-03-21','15:10:00',2.9),('9303','2014-03-21','15:15:00',3.09),('9303','2014-03-21','15:20:00',2.84),('9303','2014-03-21','15:25:00',2.78),('9303','2014-03-21','15:30:00',2.89),('9303','2014-03-21','15:35:00',2.6),('9303','2014-03-21','15:40:00',2.58),('9303','2014-03-21','15:45:00',2.45),('9303','2014-03-21','15:50:00',2.39),('9303','2014-03-21','15:55:00',2.31),('9303','2014-03-21','16:00:00',2.18),('9303','2014-03-21','16:05:00',1.99),('9303','2014-03-21','16:10:00',1.82),('9303','2014-03-21','16:15:00',1.68),('9303','2014-03-21','16:20:00',1.53),('9303','2014-03-21','16:25:00',1.4),('9303','2014-03-21','16:30:00',1.3),('9303','2014-03-21','16:35:00',1.19),('9303','2014-03-21','16:40:00',1.07),('9303','2013-01-31','09:20:00',1.07),('9303','2013-01-31','09:25:00',1.51),('9303','2013-01-31','09:30:00',1.65),('9303','2013-01-31','09:35:00',1.54),('9303','2013-01-31','09:40:00',1.6),('9303','2013-01-31','09:45:00',1.51),('9303','2013-01-31','09:50:00',1.65),('9303','2013-01-31','09:55:00',1.74),('9303','2013-01-31','10:00:00',1.71),('9303','2013-01-31','10:05:00',1.74),('9303','2013-01-31','10:10:00',1.62),('9303','2013-01-31','10:15:00',1.7),('9303','2013-01-31','10:20:00',1.75),('9303','2013-01-31','10:25:00',1.47),('9303','2013-01-31','10:30:00',1.51),('9303','2013-01-31','10:35:00',2.09),('9303','2013-01-31','10:40:00',2.17),('9303','2013-01-31','10:45:00',2.25),('9303','2013-01-31','10:50:00',2.29),('9303','2013-01-31','10:55:00',2.31),('9303','2013-01-31','11:00:00',1.95),('9303','2013-01-31','11:05:00',2.38),('9303','2013-01-31','11:10:00',2.53),('9303','2013-01-31','11:15:00',2.62),('9303','2013-01-31','11:20:00',2.59),('9303','2013-01-31','11:25:00',2.4),('9303','2013-01-31','11:30:00',2.3),('9303','2013-01-31','11:35:00',2.32),('9303','2013-01-31','11:40:00',2.34),('9303','2013-01-31','11:45:00',2.37),('9303','2013-01-31','11:50:00',2.35),('9303','2013-01-31','11:55:00',2.35),('9303','2013-01-31','12:00:00',2.35),('9303','2013-01-31','12:05:00',2.35),('9303','2013-01-31','12:10:00',2.28),('9303','2013-01-31','12:15:00',2.14),('9303','2013-01-31','12:20:00',2.42),('9303','2013-01-31','12:25:00',2.49),('9303','2013-01-31','12:30:00',2.51),('9303','2013-01-31','12:35:00',2.55),('9303','2013-01-31','12:40:00',2.53),('9303','2013-01-31','12:45:00',2.54),('9303','2013-01-31','12:50:00',2.48),('9303','2013-01-31','12:55:00',2.45),('9303','2013-01-31','13:00:00',2.4),('9303','2013-01-31','13:05:00',2.34),('9303','2013-01-31','13:10:00',2.32),('9303','2013-01-31','13:15:00',2.23),('9303','2013-01-31','13:20:00',2.15),('9303','2013-01-31','13:25:00',2.13),('9303','2013-01-31','13:30:00',2.1),('9303','2013-01-31','13:35:00',2.07),('9303','2013-01-31','13:40:00',2.01),('9303','2013-01-31','13:45:00',1.98),('9303','2013-01-31','13:50:00',2.06),('9303','2013-01-31','13:55:00',2),('9303','2013-01-31','14:00:00',1.98),('9303','2013-01-31','14:05:00',1.84),('9303','2013-01-31','14:10:00',1.75),('9303','2013-01-31','14:15:00',1.75),('9303','2013-01-31','14:20:00',1.78),('9303','2013-01-31','14:25:00',1.75),('9303','2013-01-31','14:30:00',1.68),('9303','2013-01-31','14:35:00',1.67),('9303','2013-01-31','14:40:00',1.64),('9303','2013-01-31','14:45:00',1.61),('9303','2013-01-31','14:50:00',1.54),('9303','2013-01-31','14:55:00',1.52),('9303','2013-01-31','15:00:00',1.48),('9303','2013-01-31','15:05:00',1.44),('9303','2013-01-31','15:10:00',1.4),('9303','2013-01-31','15:15:00',1.38),('9303','2013-01-31','15:20:00',1.3),('9303','2013-01-31','15:25:00',1.19),('9303','2013-01-31','15:30:00',1.17),('9303','2013-01-31','15:35:00',1.12),('9303','2013-01-31','15:40:00',1.04),('9303','2013-01-30','10:10:00',1.3),('9303','2013-01-30','10:15:00',1.06),('9303','2013-01-30','10:20:00',1.43),('9303','2013-01-30','10:25:00',1.46),('9303','2013-01-30','10:30:00',1.32),('9303','2013-01-30','10:35:00',1.21),('9303','2013-01-30','10:40:00',1.27),('9303','2013-01-30','10:45:00',1.52),('9303','2013-01-30','10:50:00',1.69),('9303','2013-01-30','10:55:00',1.81),('9303','2013-01-30','11:00:00',2.05),('9303','2013-01-30','11:05:00',1.98),('9303','2013-01-30','11:10:00',2.07),('9303','2013-01-30','11:15:00',2.04),('9303','2013-01-30','11:20:00',2.11),('9303','2013-01-30','11:25:00',2.21),('9303','2013-01-30','11:30:00',2.21),('9303','2013-01-30','11:35:00',2.22),('9303','2013-01-30','11:40:00',1.9),('9303','2013-01-30','11:45:00',2.24),('9303','2013-01-30','11:50:00',1.99),('9303','2013-01-30','11:55:00',2.3),('9303','2013-01-30','12:00:00',2.32),('9303','2013-01-30','12:05:00',1.91),('9303','2013-01-30','12:10:00',1.28),('9303','2013-01-30','12:15:00',1.61),('9303','2013-01-30','12:20:00',1.21),('9303','2013-01-30','12:40:00',1.32),('9303','2013-01-30','12:50:00',1.68),('9303','2013-01-30','12:55:00',2.98),('9303','2013-01-30','13:00:00',2.79),('9303','2013-01-30','13:05:00',2.33),('9303','2013-01-30','13:10:00',2.52),('9303','2013-01-30','13:15:00',2.49),('9303','2013-01-30','13:20:00',2.5),('9303','2013-01-30','13:25:00',2.5),('9303','2013-01-30','13:30:00',2.18),('9303','2013-01-30','13:35:00',1.98),('9303','2013-01-30','13:40:00',1.93),('9303','2013-01-30','13:45:00',1.1),('9303','2013-01-30','13:50:00',1.98),('9303','2013-01-30','13:55:00',1.98),('9303','2013-01-30','14:00:00',1.96),('9303','2013-01-30','14:05:00',1.9),('9303','2013-01-30','14:10:00',2.34),('9303','2013-01-30','14:15:00',1.8),('9303','2013-01-30','14:20:00',1.57),('9303','2013-01-30','14:25:00',1.98),('9303','2013-01-30','14:30:00',1.36),('9303','2013-01-30','14:35:00',1.67),('9303','2013-01-30','14:40:00',1.83),('9303','2013-01-30','14:45:00',1.52),('9303','2013-01-29','09:10:00',1.1),('9303','2013-01-29','09:15:00',1.17),('9303','2013-01-29','09:20:00',1.23),('9303','2013-01-29','09:25:00',1.33),('9303','2013-01-29','09:30:00',1.4),('9303','2013-01-29','09:35:00',1.47),('9303','2013-01-29','09:40:00',1.55),('9303','2013-01-29','09:45:00',1.61),('9303','2013-01-29','09:50:00',1.67),('9303','2013-01-29','09:55:00',1.72),('9303','2013-01-29','10:00:00',1.74),('9303','2013-01-29','10:05:00',1.79),('9303','2013-01-29','10:10:00',1.81),('9303','2013-01-29','10:15:00',1.84),('9303','2013-01-29','10:20:00',1.87),('9303','2013-01-29','10:25:00',1.91),('9303','2013-01-29','10:30:00',1.95),('9303','2013-01-29','10:35:00',2.01),('9303','2013-01-29','10:40:00',2.04),('9303','2013-01-29','10:45:00',2.07),('9303','2013-01-29','10:50:00',2.11),('9303','2013-01-29','10:55:00',2.12),('9303','2013-01-29','11:00:00',2.15),('9303','2013-01-29','11:05:00',2.15),('9303','2013-01-29','11:10:00',2.17),('9303','2013-01-29','11:15:00',2.25),('9303','2013-01-29','11:20:00',2.27),('9303','2013-01-29','11:25:00',2.23),('9303','2013-01-29','11:30:00',2.24),('9303','2013-01-29','11:35:00',2.34),('9303','2013-01-29','11:40:00',2.36),('9303','2013-01-29','11:45:00',2.39),('9303','2013-01-29','11:50:00',2.38),('9303','2013-01-29','11:55:00',2.39),('9303','2013-01-29','12:00:00',2.37),('9303','2013-01-29','12:05:00',2.35),('9303','2013-01-29','12:10:00',2.47),('9303','2013-01-29','12:15:00',2.44),('9303','2013-01-29','12:20:00',2.5),('9303','2013-01-29','12:25:00',2.54),('9303','2013-01-29','12:30:00',2.57),('9303','2013-01-29','12:35:00',2.57),('9303','2013-01-29','12:40:00',2.59),('9303','2013-01-29','12:45:00',2.57),('9303','2013-01-29','12:50:00',2.5),('9303','2013-01-29','12:55:00',2.47),('9303','2013-01-29','13:00:00',2.44),('9303','2013-01-29','13:05:00',2.38),('9303','2013-01-29','13:10:00',2.31),('9303','2013-01-29','13:15:00',2.26),('9303','2013-01-29','13:20:00',2.16),('9303','2013-01-29','13:25:00',2.21),('9303','2013-01-29','13:30:00',2.16),('9303','2013-01-29','13:35:00',2.13),('9303','2013-01-29','13:40:00',2.08),('9303','2013-01-29','13:45:00',2.08),('9303','2013-01-29','13:50:00',2.03),('9303','2013-01-29','13:55:00',1.96),('9303','2013-01-29','14:00:00',1.91),('9303','2013-01-29','14:05:00',1.8),('9303','2013-01-29','14:10:00',1.72),('9303','2013-01-29','14:15:00',1.78),('9303','2013-01-29','14:20:00',1.85),('9303','2013-01-29','14:25:00',1.81),('9303','2013-01-29','14:30:00',1.76),('9303','2013-01-29','14:35:00',1.71),('9303','2013-01-29','14:40:00',1.68),('9303','2013-01-29','14:45:00',1.67),('9303','2013-01-29','14:50:00',1.62),('9303','2013-01-29','14:55:00',1.58),('9303','2013-01-29','15:00:00',1.54),('9303','2013-01-29','15:05:00',1.47),('9303','2013-01-29','15:10:00',1.4),('9303','2013-01-29','15:15:00',1.35),('9303','2013-01-29','15:20:00',1.23),('9303','2013-01-29','15:25:00',1.17),('9303','2013-01-29','15:30:00',1.1),('9303','2013-01-29','15:35:00',1.02),('9303','2013-01-28','12:50:00',1.15),('9303','2013-01-28','12:55:00',1.11),('9303','2013-01-28','13:00:00',1.02),('9303','2013-01-28','13:05:00',1),('9303','2013-01-27','09:10:00',1.02),('9303','2013-01-27','09:15:00',1.08),('9303','2013-01-27','09:20:00',1.18),('9303','2013-01-27','09:25:00',1.29),('9303','2013-01-27','09:30:00',1.36),('9303','2013-01-27','09:35:00',1.46),('9303','2013-01-27','09:40:00',1.52),('9303','2013-01-27','09:45:00',1.59),('9303','2013-01-27','09:50:00',1.66),('9303','2013-01-27','09:55:00',1.72),('9303','2013-01-27','10:00:00',1.72),('9303','2013-01-27','10:05:00',1.75),('9303','2013-01-27','10:10:00',1.75),('9303','2013-01-27','10:15:00',1.79),('9303','2013-01-27','10:20:00',1.81),('9303','2013-01-27','10:25:00',1.84),('9303','2013-01-27','10:30:00',1.85),('9303','2013-01-27','10:35:00',1.63),('9303','2013-01-27','10:40:00',1.93),('9303','2013-01-27','10:45:00',2),('9303','2013-01-27','10:50:00',2.05),('9303','2013-01-27','10:55:00',2.05),('9303','2013-01-27','11:00:00',2.13),('9303','2013-01-27','11:05:00',2.15),('9303','2013-01-27','11:10:00',2.19),('9303','2013-01-27','11:15:00',2.21),('9303','2013-01-27','11:20:00',2.24),('9303','2013-01-27','11:25:00',2.23),('9303','2013-01-27','11:30:00',2.25),('9303','2013-01-27','11:35:00',2.27),('9303','2013-01-27','11:40:00',2.27),('9303','2013-01-27','11:45:00',2.32),('9303','2013-01-27','11:50:00',2.31),('9303','2013-01-27','11:55:00',2.36),('9303','2013-01-27','12:00:00',2.36),('9303','2013-01-27','12:05:00',2.36),('9303','2013-01-27','12:10:00',2.42),('9303','2013-01-27','12:15:00',2.44),('9303','2013-01-27','12:20:00',2.46),('9303','2013-01-27','12:25:00',2.5),('9303','2013-01-27','12:30:00',2.5),('9303','2013-01-27','12:35:00',2.55),('9303','2013-01-27','12:40:00',2.51),('9303','2013-01-27','12:45:00',2.53),('9303','2013-01-27','12:50:00',2.47),('9303','2013-01-27','12:55:00',2.47),('9303','2013-01-27','13:00:00',2.42),('9303','2013-01-27','13:05:00',2.37),('9303','2013-01-27','13:10:00',2.31),('9303','2013-01-27','13:15:00',2.27),('9303','2013-01-27','13:20:00',2.14),('9303','2013-01-27','13:25:00',2.14),('9303','2013-01-27','13:30:00',2.07),('9303','2013-01-27','13:35:00',2.06),('9303','2013-01-27','13:40:00',2.01),('9303','2013-01-27','13:45:00',1.97),('9303','2013-01-27','13:50:00',1.91),('9303','2013-01-27','13:55:00',1.87),('9303','2013-01-27','14:00:00',1.84),('9303','2013-01-27','14:05:00',1.79),('9303','2013-01-27','14:10:00',1.78),('9303','2013-01-27','14:15:00',1.74),('9303','2013-01-27','14:20:00',1.71),('9303','2013-01-27','14:25:00',1.69),('9303','2013-01-27','14:30:00',1.63),('9303','2013-01-27','14:35:00',1.63),('9303','2013-01-27','14:40:00',1.58),('9303','2013-01-27','14:45:00',1.55),('9303','2013-01-27','14:50:00',1.57),('9303','2013-01-27','14:55:00',1.52),('9303','2013-01-27','15:00:00',1.47),('9303','2013-01-27','15:05:00',1.4),('9303','2013-01-27','15:10:00',1.32),('9303','2013-01-27','15:15:00',1.25),('9303','2013-01-27','15:20:00',1.16),('9303','2013-01-27','15:25:00',1.1),('9303','2013-01-27','15:30:00',1.04),('9303','2013-01-26','10:20:00',1.11),('9303','2013-01-26','10:25:00',1.21),('9303','2013-01-26','10:50:00',1.04),('9303','2013-01-25','09:15:00',1.07),('9303','2013-01-25','09:20:00',1.17),('9303','2013-01-25','09:25:00',1.29),('9303','2013-01-25','09:30:00',1.46),('9303','2013-01-25','09:35:00',1.48),('9303','2013-01-25','09:40:00',1.36),('9303','2013-01-25','09:45:00',1.49),('9303','2013-01-25','09:50:00',1.84),('9303','2013-01-25','09:55:00',1.9),('9303','2013-01-25','10:00:00',1.9),('9303','2013-01-25','10:05:00',1.92),('9303','2013-01-25','10:10:00',1.87),('9303','2013-01-25','10:15:00',1.86),('9303','2013-01-25','10:20:00',1.86),('9303','2013-01-25','10:25:00',1.96),('9303','2013-01-25','10:30:00',1.9),('9303','2013-01-25','10:35:00',1.5),('9303','2013-01-25','10:40:00',2.12),('9303','2013-01-25','10:45:00',1.8),('9303','2013-01-25','10:50:00',1.51),('9303','2013-01-25','10:55:00',2.29),('9303','2013-01-25','11:00:00',1.18),('9303','2013-01-25','11:05:00',1.98),('9303','2013-01-25','11:10:00',2.07),('9303','2013-01-25','11:15:00',2.3),('9303','2013-01-25','11:20:00',2.29),('9303','2013-01-25','11:25:00',2.27),('9303','2013-01-25','11:30:00',2.31),('9303','2013-01-25','11:35:00',2.37),('9303','2013-01-25','11:40:00',2.35),('9303','2013-01-25','11:45:00',2.4),('9303','2013-01-25','11:50:00',2.43),('9303','2013-01-25','11:55:00',2.41),('9303','2013-01-25','12:00:00',2.39),('9303','2013-01-25','12:05:00',2.36),('9303','2013-01-25','12:10:00',2.46),('9303','2013-01-25','12:15:00',2.5),('9303','2013-01-25','12:20:00',2.52),('9303','2013-01-25','12:25:00',2.58),('9303','2013-01-25','12:30:00',2.59),('9303','2013-01-25','12:35:00',2.21),('9303','2013-01-25','12:40:00',2.32),('9303','2013-01-25','12:45:00',2.49),('9303','2013-01-25','12:50:00',2.51),('9303','2013-01-25','12:55:00',2.42),('9303','2013-01-25','13:00:00',2.39),('9303','2013-01-25','13:05:00',2.31),('9303','2013-01-25','13:10:00',2.29),('9303','2013-01-25','13:15:00',2.3),('9303','2013-01-25','13:20:00',2.2),('9303','2013-01-25','13:25:00',2.26),('9303','2013-01-25','13:30:00',2.24),('9303','2013-01-25','13:35:00',2.24),('9303','2013-01-25','13:40:00',2.15),('9303','2013-01-25','13:45:00',2.11),('9303','2013-01-25','13:50:00',2.06),('9303','2013-01-25','13:55:00',1.99),('9303','2013-01-25','14:00:00',1.92),('9303','2013-01-25','14:05:00',1.87),('9303','2013-01-25','14:10:00',1.74),('9303','2013-01-25','14:15:00',1.68),('9303','2013-01-25','14:20:00',1.61),('9303','2013-01-25','14:25:00',1.63),('9303','2013-01-25','14:30:00',1.55),('9303','2013-01-25','14:35:00',1.49),('9303','2013-01-25','14:40:00',1.48),('9303','2013-01-25','14:45:00',1.4),('9303','2013-01-25','14:50:00',1.41),('9303','2013-01-25','14:55:00',1.39),('9303','2013-01-25','15:00:00',1.3),('9303','2013-01-25','15:05:00',1.23),('9303','2013-01-25','15:10:00',1.2),('9303','2013-01-25','15:15:00',1.14),('9303','2013-01-25','15:20:00',1.09),('9303','2013-01-25','15:25:00',1.08),('9303','2013-01-25','15:30:00',1.05),('9303','2013-01-25','15:35:00',1.07),('9303','2013-01-25','15:40:00',1.03),('9303','2013-01-24','09:45:00',1.17),('9303','2013-01-24','09:50:00',1.48),('9303','2013-01-24','09:55:00',1.77),('9303','2013-01-24','10:00:00',1.77),('9303','2013-01-24','10:05:00',1.74),('9303','2013-01-24','10:10:00',1.94),('9303','2013-01-24','10:15:00',1.92),('9303','2013-01-24','10:20:00',1.94),('9303','2013-01-24','10:25:00',1.95),('9303','2013-01-24','10:30:00',1.94),('9303','2013-01-24','10:35:00',1.99),('9303','2013-01-24','10:40:00',2.01),('9303','2013-01-24','10:45:00',2.06),('9303','2013-01-24','10:50:00',2.11),('9303','2013-01-24','10:55:00',2.02),('9303','2013-01-24','11:00:00',1.2),('9303','2013-01-24','14:00:00',1.05),('9303','2013-01-24','14:05:00',1.08),('9303','2013-01-24','14:10:00',1.03),('9303','2013-01-24','14:15:00',1.17),('9303','2013-01-24','14:20:00',1.5),('9303','2013-01-24','14:25:00',2.43),('9303','2013-01-24','14:30:00',2.32),('9303','2013-01-24','14:35:00',1.73),('9303','2013-01-24','14:40:00',1.17),('9303','2013-01-24','14:45:00',1.62),('9303','2013-01-24','14:50:00',1.68),('9303','2013-01-24','14:55:00',1.68),('9303','2013-01-24','15:00:00',1.26),('9303','2013-01-24','15:20:00',1.06),('9303','2013-01-24','15:25:00',1.04),('9303','2013-01-24','15:30:00',1.07),('9303','2013-01-23','09:55:00',1.16),('9303','2013-01-23','10:30:00',1.89),('9303','2013-01-23','10:35:00',2.16),('9303','2013-01-23','10:40:00',1.3),('9303','2013-01-23','10:45:00',1.44),('9303','2013-01-23','10:50:00',1.78),('9303','2013-01-23','10:55:00',1.48),('9303','2013-01-22','09:00:00',1.08),('9303','2013-01-22','09:30:00',1.28),('9303','2013-01-22','09:35:00',1.5),('9303','2013-01-22','09:40:00',1.27),('9303','2013-01-22','09:45:00',2.09),('9303','2013-01-22','09:50:00',1.27),('9303','2013-01-22','09:55:00',1.45),('9303','2013-01-22','10:00:00',1),('9303','2013-01-22','10:05:00',1.72),('9303','2013-01-22','10:10:00',1.94),('9303','2013-01-22','10:15:00',1.77),('9303','2013-01-22','10:20:00',1.75),('9303','2013-01-22','10:25:00',1.83),('9303','2013-01-22','10:30:00',1.91),('9303','2013-01-22','10:35:00',2.17),('9303','2013-01-22','10:40:00',2.52),('9303','2013-01-22','10:45:00',1.97),('9303','2013-01-22','10:50:00',1.73),('9303','2013-01-22','10:55:00',1.12),('9303','2013-01-22','11:15:00',1.49),('9303','2013-01-22','11:20:00',1.44),('9303','2013-01-22','11:45:00',1.15),('9303','2013-01-22','11:50:00',1.78),('9303','2013-01-22','12:10:00',2.11),('9303','2013-01-22','12:15:00',2.1),('9303','2013-01-22','12:20:00',1.42),('9303','2013-01-22','12:25:00',2.33),('9303','2013-01-22','12:40:00',2.86),('9303','2013-01-22','13:00:00',2.32),('9303','2013-01-22','13:05:00',2.28),('9303','2013-01-22','13:10:00',1.64),('9303','2013-01-22','13:15:00',1.09),('9303','2013-01-22','13:20:00',1.88),('9303','2013-01-22','13:50:00',1.14),('9303','2013-01-22','14:10:00',1.07),('9303','2013-01-22','14:15:00',1.32),('9303','2013-01-22','14:25:00',1.64),('9303','2013-01-22','14:35:00',1.03),('9303','2013-01-22','14:40:00',1.05),('9303','2013-01-22','14:45:00',1.38),('9303','2014-03-20','07:40:00',1.03),('9303','2014-03-20','07:45:00',1.15),('9303','2014-03-20','07:50:00',1.22),('9303','2014-03-20','07:55:00',1.32),('9303','2014-03-20','08:00:00',1.41),('9303','2014-03-20','08:05:00',1.5),('9303','2014-03-20','08:10:00',1.58),('9303','2014-03-20','08:15:00',1.61),('9303','2014-03-20','08:20:00',1.68),('9303','2014-03-20','08:25:00',1.75),('9303','2014-03-20','08:30:00',1.85),('9303','2014-03-20','08:35:00',1.96),('9303','2014-03-20','08:40:00',2.09),('9303','2014-03-20','08:45:00',2.2),('9303','2014-03-20','08:50:00',2.25),('9303','2014-03-20','08:55:00',2.3),('9303','2014-03-20','09:00:00',2.34),('9303','2014-03-20','09:05:00',2.45),('9303','2014-03-20','09:10:00',2.53),('9303','2014-03-20','09:15:00',2.55),('9303','2014-03-20','09:20:00',2.65),('9303','2014-03-20','09:25:00',2.69),('9303','2014-03-20','09:30:00',2.75),('9303','2014-03-20','09:35:00',2.82),('9303','2014-03-20','09:40:00',2.87),('9303','2014-03-20','09:45:00',2.89),('9303','2014-03-20','09:50:00',2.88),('9303','2014-03-20','09:55:00',2.96),('9303','2014-03-20','10:00:00',3.07),('9303','2014-03-20','10:05:00',3.18),('9303','2014-03-20','10:10:00',3.22),('9303','2014-03-20','10:15:00',3.18),('9303','2014-03-20','10:20:00',3.21),('9303','2014-03-20','10:25:00',3.23),('9303','2014-03-20','10:30:00',3.3),('9303','2014-03-20','10:35:00',3.22),('9303','2014-03-20','10:40:00',3.18),('9303','2014-03-20','10:45:00',3.18),('9303','2014-03-20','10:50:00',3.38),('9303','2014-03-20','10:55:00',3.54),('9303','2014-03-20','11:00:00',3.59),('9303','2014-03-20','11:05:00',3.59),('9303','2014-03-20','11:10:00',3.54),('9303','2014-03-20','11:15:00',3.37),('9303','2014-03-20','11:20:00',3.49),('9303','2014-03-20','11:25:00',3.57),('9303','2014-03-20','11:30:00',3.65),('9303','2014-03-20','11:35:00',3.77),('9303','2014-03-20','11:40:00',3.7),('9303','2014-03-20','11:45:00',3.72),('9303','2014-03-20','11:50:00',3.62),('9303','2014-03-20','11:55:00',3.61),('9303','2014-03-20','12:00:00',3.24),('9303','2014-03-20','12:05:00',3.46),('9303','2014-03-20','12:10:00',3.73),('9303','2014-03-20','12:15:00',3.81),('9303','2014-03-20','12:20:00',3.7),('9303','2014-03-20','12:25:00',3.49),('9303','2014-03-20','12:30:00',3.59),('9303','2014-03-20','12:35:00',3.65),('9303','2014-03-20','12:40:00',3.63),('9303','2014-03-20','12:45:00',3.71),('9303','2014-03-20','12:50:00',3.71),('9303','2014-03-20','12:55:00',3.67),('9303','2014-03-20','13:00:00',3.68),('9303','2014-03-20','13:05:00',3.66),('9303','2014-03-20','13:10:00',3.55),('9303','2014-03-20','13:15:00',3.56),('9303','2014-03-20','13:20:00',3.57),('9303','2014-03-20','13:25:00',3.44),('9303','2014-03-20','13:30:00',3.48),('9303','2014-03-20','13:35:00',3.41),('9303','2014-03-20','13:40:00',3.22),('9303','2014-03-20','13:45:00',3.07),('9303','2014-03-20','13:50:00',2.95),('9303','2014-03-20','13:55:00',2.82),('9303','2014-03-20','14:00:00',2.81),('9303','2014-03-20','14:05:00',3.01),('9303','2014-03-20','14:10:00',2.96),('9303','2014-03-20','14:15:00',2.85),('9303','2014-03-20','14:20:00',2.83),('9303','2014-03-20','14:25:00',2.85),('9303','2014-03-20','14:30:00',2.46),('9303','2014-03-20','14:35:00',2.2),('9303','2014-03-20','14:40:00',2.45),('9303','2014-03-20','14:45:00',2.44),('9303','2014-03-20','14:50:00',2.33),('9303','2014-03-20','14:55:00',2.26),('9303','2014-03-20','15:00:00',2.06),('9303','2014-03-20','15:05:00',2.01),('9303','2014-03-20','15:10:00',2.06),('9303','2014-03-20','15:15:00',1.92),('9303','2014-03-20','15:20:00',2.03),('9303','2014-03-20','15:25:00',1.87),('9303','2014-03-20','15:30:00',1.82),('9303','2014-03-20','15:35:00',1.7),('9303','2014-03-20','15:40:00',1.52),('9303','2014-03-20','15:45:00',1.4),('9303','2014-03-20','15:50:00',1.29),('9303','2014-03-20','15:55:00',1.2),('9303','2014-03-20','16:00:00',1.03),('9303','2013-01-21','11:15:00',1.07),('9303','2013-01-21','11:50:00',1.07),('9303','2013-01-21','11:55:00',2.41),('9303','2013-01-21','12:00:00',2.01),('9303','2013-01-21','12:05:00',2.19),('9303','2013-01-21','12:10:00',2.42),('9303','2013-01-21','12:15:00',1.86),('9303','2013-01-21','12:25:00',1.21),('9303','2013-01-21','12:40:00',1.12),('9303','2013-01-21','13:05:00',1.78),('9303','2013-01-21','13:10:00',1.41),('9303','2013-01-21','13:30:00',2.11),('9303','2013-01-21','13:35:00',2.46),('9303','2013-01-21','13:40:00',1.92),('9303','2013-01-21','13:50:00',1.22),('9303','2013-01-21','13:55:00',1.85),('9303','2013-01-21','14:00:00',2.17),('9303','2013-01-21','14:05:00',2.25),('9303','2013-01-21','14:10:00',1.89),('9303','2013-01-21','14:15:00',1.53),('9303','2013-01-21','14:20:00',1.85),('9303','2013-01-21','14:25:00',2.18),('9303','2013-01-21','14:30:00',1.1),('9303','2013-01-20','11:00:00',1.05),('9303','2013-01-20','11:05:00',1.07),('9303','2013-01-20','11:10:00',1.07),('9303','2013-01-20','11:15:00',1.49),('9303','2013-01-20','11:20:00',1.22),('9303','2013-01-20','11:25:00',1.5),('9303','2013-01-20','11:30:00',1.98),('9303','2013-01-20','11:35:00',1.6),('9303','2013-01-19','09:15:00',1.01),('9303','2013-01-19','09:20:00',1.06),('9303','2013-01-19','09:55:00',1.41),('9303','2013-01-19','10:00:00',1.25),('9303','2013-01-19','10:45:00',1.15),('9303','2013-01-19','10:50:00',1.24),('9303','2013-01-19','11:20:00',1.02),('9303','2013-01-19','11:25:00',1.07),('9303','2013-01-18','10:15:00',1.77),('9303','2013-01-18','10:20:00',1.59),('9303','2013-01-18','10:25:00',1.28),('9303','2013-01-18','10:30:00',1.16),('9303','2013-01-18','11:35:00',1.08),('9303','2013-01-18','11:40:00',1.04),('9303','2013-01-18','12:35:00',1.16),('9303','2013-01-18','12:40:00',1.28),('9303','2013-01-18','12:45:00',1.4),('9303','2013-01-18','12:50:00',1.92),('9303','2013-01-18','12:55:00',1.91),('9303','2013-01-18','13:00:00',2.13),('9303','2013-01-18','13:05:00',1.93),('9303','2013-01-18','13:10:00',1.84),('9303','2013-01-18','13:15:00',2.13),('9303','2013-01-18','13:20:00',1.7),('9303','2013-01-18','13:25:00',1.43),('9303','2013-01-18','13:30:00',1.38),('9303','2013-01-18','13:35:00',1.46),('9303','2013-01-18','13:40:00',1.53),('9303','2013-01-18','13:45:00',2.18),('9303','2013-01-18','13:50:00',2.5),('9303','2013-01-18','13:55:00',2.38),('9303','2013-01-18','14:00:00',1.68),('9303','2013-01-18','14:05:00',1.78),('9303','2013-01-18','14:10:00',1.93),('9303','2013-01-18','14:15:00',1.65),('9303','2013-01-18','14:20:00',1.41),('9303','2013-01-18','14:25:00',1.33),('9303','2013-01-18','14:30:00',1.02),('9303','2013-01-17','09:50:00',1.18),('9303','2013-01-17','09:55:00',1.06),('9303','2013-01-17','10:10:00',1.01),('9303','2013-01-17','10:15:00',1.19),('9303','2013-01-17','10:20:00',1.14),('9303','2013-01-17','10:25:00',1.34),('9303','2013-01-17','10:30:00',1.4),('9303','2013-01-17','10:35:00',1.33),('9303','2013-01-17','10:40:00',1.33),('9303','2013-01-17','10:45:00',1.39),('9303','2013-01-17','10:50:00',1.3),('9303','2013-01-17','10:55:00',1.47),('9303','2013-01-17','11:00:00',1.37),('9303','2013-01-17','11:05:00',1.37),('9303','2013-01-17','11:10:00',1.52),('9303','2013-01-17','11:15:00',1.5),('9303','2013-01-17','11:20:00',1.45),('9303','2013-01-17','11:25:00',1.26),('9303','2013-01-17','11:30:00',1.14),('9303','2013-01-17','11:35:00',1.22),('9303','2013-01-17','11:40:00',1.31),('9303','2013-01-17','11:45:00',1.25),('9303','2013-01-17','11:50:00',1.31),('9303','2013-01-17','11:55:00',1.41),('9303','2013-01-17','12:00:00',1.55),('9303','2013-01-17','12:05:00',1.51),('9303','2013-01-17','12:10:00',1.47),('9303','2013-01-17','12:15:00',1.67),('9303','2013-01-17','12:20:00',1.37),('9303','2013-01-17','12:25:00',1.48),('9303','2013-01-17','12:30:00',1.25),('9303','2013-01-17','12:35:00',1.5),('9303','2013-01-17','12:40:00',1.65),('9303','2013-01-17','12:45:00',1.29),('9303','2013-01-17','13:00:00',1.4),('9303','2013-01-17','13:05:00',1.36),('9303','2013-01-17','13:15:00',1.29),('9303','2013-01-17','13:20:00',1.32),('9303','2013-01-17','13:25:00',1.17),('9303','2013-01-17','13:30:00',1.1),('9303','2013-01-17','13:35:00',1.41),('9303','2013-01-17','13:40:00',1.69),('9303','2013-01-17','13:45:00',1.85),('9303','2013-01-17','13:50:00',1.65),('9303','2013-01-17','14:00:00',1.17),('9303','2013-01-17','14:30:00',1.1),('9303','2013-01-17','14:35:00',1.47),('9303','2013-01-16','09:30:00',1.06),('9303','2013-01-16','09:35:00',1.18),('9303','2013-01-16','09:40:00',1.26),('9303','2013-01-16','10:35:00',1.39),('9303','2013-01-16','10:40:00',1.55),('9303','2013-01-16','10:45:00',1.47),('9303','2013-01-16','10:55:00',1.68),('9303','2013-01-16','11:25:00',1.11),('9303','2013-01-16','12:00:00',1.3),('9303','2013-01-16','12:05:00',1.21),('9303','2013-01-16','12:10:00',1.47),('9303','2013-01-16','12:15:00',2.83),('9303','2013-01-16','12:20:00',2.67),('9303','2013-01-16','12:25:00',1.1),('9303','2013-01-16','13:05:00',1.45),('9303','2013-01-16','13:10:00',2.94),('9303','2013-01-16','13:15:00',3.13),('9303','2013-01-16','13:20:00',2.41),('9303','2013-01-16','13:25:00',1.59),('9303','2013-01-16','13:55:00',1.93),('9303','2013-01-16','14:00:00',1.6),('9303','2013-01-16','14:05:00',1.06),('9303','2013-01-15','10:00:00',1.06),('9303','2013-01-15','10:50:00',1.22),('9303','2013-01-15','10:55:00',1.34),('9303','2013-01-15','11:00:00',1.31),('9303','2013-01-15','11:05:00',1.35),('9303','2013-01-15','11:10:00',1.39),('9303','2013-01-15','11:15:00',1.3),('9303','2013-01-15','11:20:00',1.32),('9303','2013-01-15','11:25:00',1.33),('9303','2013-01-15','11:30:00',1.31),('9303','2013-01-15','11:35:00',1.25),('9303','2013-01-15','11:40:00',1.09),('9303','2013-01-15','11:55:00',1.03),('9303','2013-01-15','12:20:00',1.15),('9303','2013-01-15','12:25:00',1.14),('9303','2013-01-15','12:30:00',1.08),('9303','2013-01-15','12:35:00',1.1),('9303','2013-01-15','12:40:00',1.21),('9303','2013-01-15','12:45:00',1.25),('9303','2013-01-15','12:50:00',1.29),('9303','2013-01-15','12:55:00',1.08),('9303','2013-01-15','13:30:00',1.02),('9303','2013-01-15','13:35:00',1.04),('9303','2013-01-15','13:40:00',1.17),('9303','2013-01-15','13:45:00',1.09),('9303','2013-01-15','13:50:00',1.06),('9303','2013-01-15','13:55:00',1.18),('9303','2013-01-15','14:00:00',1.6),('9303','2013-01-15','14:05:00',1.55),('9303','2013-01-15','14:10:00',1.56),('9303','2013-01-15','14:15:00',2.15),('9303','2013-01-15','14:20:00',2.31),('9303','2013-01-15','14:25:00',1.21),('9303','2013-01-15','14:30:00',1.52),('9303','2013-01-15','14:35:00',1.75),('9303','2013-01-15','14:40:00',1.03),('9303','2013-01-15','14:45:00',1.46),('9303','2013-01-15','14:50:00',1.43),('9303','2013-01-15','14:55:00',1.51),('9303','2013-01-15','15:00:00',1.46),('9303','2013-01-15','15:05:00',1.33),('9303','2013-01-15','15:10:00',1.14),('9303','2013-01-15','15:15:00',1.11),('9303','2013-01-14','12:50:00',1.04),('9303','2013-01-14','12:55:00',1.01),('9303','2013-01-14','13:00:00',1.08),('9303','2013-01-14','13:05:00',1.08),('9303','2013-01-13','09:15:00',1.02),('9303','2013-01-13','09:20:00',1.18),('9303','2013-01-13','09:25:00',1.14),('9303','2013-01-13','09:30:00',1.26),('9303','2013-01-13','09:35:00',1.35),('9303','2013-01-13','09:40:00',1.01),('9303','2013-01-13','09:50:00',1.19),('9303','2013-01-13','09:55:00',1.37),('9303','2013-01-13','10:00:00',1.41),('9303','2013-01-13','10:05:00',1.53),('9303','2013-01-13','10:10:00',1.16),('9303','2013-01-13','10:20:00',1.2),('9303','2013-01-13','10:25:00',1.17),('9303','2013-01-13','10:30:00',1.56),('9303','2013-01-12','09:40:00',1.11),('9303','2013-01-12','09:45:00',1.21),('9303','2013-01-12','09:50:00',1.34),('9303','2013-01-12','09:55:00',1.41),('9303','2013-01-12','10:00:00',1.43),('9303','2013-01-12','10:05:00',1.45),('9303','2013-01-12','10:10:00',1.49),('9303','2013-01-12','10:15:00',1.58),('9303','2013-01-12','10:20:00',1.55),('9303','2013-01-12','10:25:00',1.6),('9303','2013-01-12','10:30:00',1.64),('9303','2013-01-12','10:35:00',1.65),('9303','2013-01-12','10:40:00',1.66),('9303','2013-01-12','10:45:00',1.72),('9303','2013-01-12','10:50:00',1.78),('9303','2013-01-12','10:55:00',1.83),('9303','2013-01-12','11:00:00',1.84),('9303','2013-01-12','11:05:00',1.84),('9303','2013-01-12','11:10:00',1.91),('9303','2013-01-12','11:15:00',1.88),('9303','2013-01-12','11:20:00',1.93),('9303','2013-01-12','11:25:00',1.93),('9303','2013-01-12','11:30:00',2),('9303','2013-01-12','11:35:00',2.01),('9303','2013-01-12','11:40:00',1.99),('9303','2013-01-12','11:45:00',2.02),('9303','2013-01-12','11:50:00',2.03),('9303','2013-01-12','11:55:00',2.05),('9303','2013-01-12','12:00:00',2.04),('9303','2013-01-12','12:05:00',2.03),('9303','2013-01-12','12:10:00',2.01),('9303','2013-01-12','12:15:00',2.06),('9303','2013-01-12','12:20:00',2.07),('9303','2013-01-12','12:25:00',2.04),('9303','2013-01-12','12:30:00',2.06),('9303','2013-01-12','12:35:00',2.12),('9303','2013-01-12','12:40:00',1.61),('9303','2013-01-12','12:50:00',2.14),('9303','2013-01-12','12:55:00',1.76),('9303','2013-01-12','13:00:00',1.29),('9303','2013-01-12','13:05:00',1.92),('9303','2013-01-12','13:10:00',1.62),('9303','2013-01-12','13:15:00',1.2),('9303','2013-01-12','13:25:00',1.49),('9303','2013-01-12','13:30:00',1.83),('9303','2013-01-12','13:35:00',1.58),('9303','2013-01-12','13:50:00',1.14),('9303','2013-01-12','13:55:00',1.96),('9303','2013-01-12','14:00:00',1.41),('9303','2013-01-12','14:05:00',1.23),('9303','2013-01-12','14:10:00',1.41),('9303','2013-01-12','14:15:00',1.58),('9303','2013-01-12','14:20:00',1.5),('9303','2013-01-12','14:25:00',1.47),('9303','2013-01-12','14:30:00',1.42),('9303','2013-01-12','14:35:00',1.37),('9303','2013-01-12','14:40:00',1.34),('9303','2013-01-12','14:45:00',1.28),('9303','2013-01-12','14:50:00',1.23),('9303','2013-01-12','14:55:00',1.18),('9303','2013-01-12','15:00:00',1.11),('9303','2013-01-12','15:05:00',1.06),('9303','2014-03-19','09:05:00',1.06),('9303','2014-03-19','09:10:00',1.24),('9303','2014-03-19','09:15:00',1.45),('9303','2014-03-19','09:20:00',1.59),('9303','2014-03-19','09:25:00',1.79),('9303','2014-03-19','09:30:00',3.06),('9303','2014-03-19','09:35:00',2.78),('9303','2014-03-19','09:40:00',3.11),('9303','2014-03-19','09:45:00',3.21),('9303','2014-03-19','09:50:00',2.41),('9303','2014-03-19','09:55:00',2.62),('9303','2014-03-19','10:00:00',1.37),('9303','2014-03-19','10:05:00',1.07),('9303','2014-03-19','10:30:00',1.09),('9303','2014-03-19','10:35:00',1.81),('9303','2014-03-19','10:40:00',2.85),('9303','2014-03-19','10:45:00',1.76),('9303','2014-03-19','10:50:00',1.85),('9303','2014-03-19','10:55:00',1.66),('9303','2014-03-19','11:00:00',1.67),('9303','2014-03-19','11:05:00',3.08),('9303','2014-03-19','11:10:00',1.7),('9303','2014-03-19','11:15:00',1.52),('9303','2014-03-19','11:20:00',1.59),('9303','2014-03-19','11:25:00',1.64),('9303','2014-03-19','11:30:00',1.85),('9303','2014-03-19','11:35:00',1.88),('9303','2014-03-19','11:40:00',1.59),('9303','2014-03-19','11:45:00',1.53),('9303','2014-03-19','11:50:00',1.56),('9303','2014-03-19','11:55:00',1.71),('9303','2014-03-19','12:00:00',4.08),('9303','2014-03-19','12:05:00',4.21),('9303','2014-03-19','12:10:00',4),('9303','2014-03-19','12:15:00',4.13),('9303','2014-03-19','12:20:00',4.07),('9303','2014-03-19','12:25:00',2.34),('9303','2014-03-19','12:30:00',1.85),('9303','2014-03-19','12:35:00',2.61),('9303','2014-03-19','12:40:00',4.11),('9303','2014-03-19','12:45:00',3.92),('9303','2014-03-19','12:50:00',1.6),('9303','2014-03-19','12:55:00',2.28),('9303','2014-03-19','13:00:00',3.92),('9303','2014-03-19','13:05:00',3.66),('9303','2014-03-19','13:10:00',3.7),('9303','2014-03-19','13:15:00',3.67),('9303','2014-03-19','13:20:00',3.34),('9303','2014-03-19','13:25:00',3.13),('9303','2014-03-19','13:30:00',3.5),('9303','2014-03-19','13:35:00',3.53),('9303','2014-03-19','13:40:00',3.56),('9303','2014-03-19','13:45:00',3.47),('9303','2014-03-19','13:50:00',3.42),('9303','2014-03-19','13:55:00',3.37),('9303','2014-03-19','14:00:00',3.38),('9303','2014-03-19','14:05:00',3.34),('9303','2014-03-19','14:10:00',3.22),('9303','2014-03-19','14:15:00',3.17),('9303','2014-03-19','14:20:00',3.1),('9303','2014-03-19','14:25:00',3.07),('9303','2014-03-19','14:30:00',2.99),('9303','2014-03-19','14:35:00',3.04),('9303','2014-03-19','14:40:00',2.96),('9303','2014-03-19','14:45:00',2.9),('9303','2014-03-19','14:50:00',2.86),('9303','2014-03-19','14:55:00',2.78),('9303','2014-03-19','15:00:00',2.71),('9303','2014-03-19','15:05:00',2.62),('9303','2014-03-19','15:10:00',2.57),('9303','2014-03-19','15:15:00',2.57),('9303','2014-03-19','15:20:00',2.46),('9303','2014-03-19','15:25:00',2.41),('9303','2014-03-19','15:30:00',2.35),('9303','2014-03-19','15:35:00',2.17),('9303','2014-03-19','15:40:00',2.11),('9303','2014-03-19','15:45:00',2.01),('9303','2014-03-19','15:50:00',1.91),('9303','2014-03-19','15:55:00',1.84),('9303','2014-03-19','16:00:00',1.75),('9303','2014-03-19','16:05:00',1.68),('9303','2014-03-19','16:10:00',1.6),('9303','2014-03-19','16:15:00',1.5),('9303','2014-03-19','16:20:00',1.39),('9303','2014-03-19','16:25:00',1.28),('9303','2014-03-19','16:30:00',1.21),('9303','2014-03-19','16:35:00',1.03),('9303','2013-01-11','10:05:00',1.3),('9303','2013-01-11','10:10:00',1.13),('9303','2013-01-11','10:15:00',1.48),('9303','2013-01-11','10:20:00',1.12),('9303','2013-01-11','10:25:00',1.56),('9303','2013-01-11','10:30:00',1.54),('9303','2013-01-11','10:35:00',1.61),('9303','2013-01-11','10:40:00',1.62),('9303','2013-01-11','10:45:00',1.66),('9303','2013-01-11','10:50:00',1.68),('9303','2013-01-11','10:55:00',1.74),('9303','2013-01-11','11:00:00',1.74),('9303','2013-01-11','11:05:00',1.79),('9303','2013-01-11','11:10:00',1.78),('9303','2013-01-11','11:15:00',1.76),('9303','2013-01-11','11:20:00',1.78),('9303','2013-01-11','11:25:00',1.34),('9303','2013-01-11','11:30:00',1.01),('9303','2013-01-11','11:35:00',1.3),('9303','2013-01-11','11:40:00',1.25),('9303','2013-01-11','11:45:00',1.33),('9303','2013-01-11','11:50:00',1.32),('9303','2013-01-11','11:55:00',1.13),('9303','2013-01-11','12:55:00',1.28),('9303','2013-01-11','13:00:00',1.2),('9303','2013-01-11','13:10:00',1.39),('9303','2013-01-11','13:15:00',1),('9303','2013-01-11','13:35:00',1.79),('9303','2013-01-11','13:40:00',1.38),('9303','2013-01-11','13:45:00',1.71),('9303','2013-01-11','14:20:00',1.01),('9303','2013-01-11','14:25:00',1.04),('9303','2013-01-11','14:45:00',1.16),('9303','2013-01-11','14:50:00',1.47),('9303','2013-01-11','14:55:00',1.23),('9303','2013-01-11','15:00:00',1.27),('9303','2013-01-11','15:05:00',1.18),('9303','2013-01-10','11:55:00',1.07),('9303','2013-01-10','12:00:00',1.13),('9303','2013-01-10','12:05:00',1.1),('9303','2013-01-09','10:50:00',1.09),('9303','2013-01-09','10:55:00',1.2),('9303','2013-01-09','11:10:00',1.16),('9303','2013-01-09','11:15:00',1.42),('9303','2013-01-09','11:20:00',1.23),('9303','2013-01-09','11:25:00',1.12),('9303','2013-01-09','11:30:00',1.06),('9303','2013-01-09','11:35:00',1.17),('9303','2013-01-09','11:40:00',1.1),('9303','2013-01-09','11:45:00',1.04),('9303','2013-01-09','11:50:00',1.09),('9303','2013-01-09','11:55:00',1.35),('9303','2013-01-09','12:00:00',1),('9303','2013-01-09','12:05:00',1.07),('9303','2013-01-09','12:10:00',1.05),('9303','2013-01-09','12:15:00',1.03),('9303','2013-01-09','12:20:00',1.06),('9303','2013-01-09','12:55:00',1.03),('9303','2013-01-09','13:00:00',1.11),('9303','2013-01-09','13:05:00',1.21),('9303','2013-01-09','13:10:00',1.38),('9303','2013-01-09','13:15:00',1.19),('9303','2013-01-09','13:20:00',1.01),('9303','2013-01-08','09:45:00',1.37),('9303','2013-01-08','09:50:00',1.51),('9303','2013-01-08','09:55:00',1.51),('9303','2013-01-08','10:00:00',1.38),('9303','2013-01-08','10:05:00',1.35),('9303','2013-01-08','10:10:00',1.41),('9303','2013-01-08','10:15:00',1.48),('9303','2013-01-08','10:20:00',1.33),('9303','2013-01-08','10:25:00',1.48),('9303','2013-01-08','10:30:00',1.49),('9303','2013-01-08','10:35:00',1.62),('9303','2013-01-08','10:40:00',1.72),('9303','2013-01-08','10:45:00',1.72),('9303','2013-01-08','10:50:00',1.73),('9303','2013-01-08','10:55:00',1.77),('9303','2013-01-08','11:00:00',1.73),('9303','2013-01-08','11:05:00',1.83),('9303','2013-01-08','11:10:00',1.87),('9303','2013-01-08','11:15:00',1.85),('9303','2013-01-08','11:20:00',1.9),('9303','2013-01-08','11:25:00',1.93),('9303','2013-01-08','11:30:00',1.99),('9303','2013-01-08','11:35:00',1.98),('9303','2013-01-08','11:40:00',1.98),('9303','2013-01-08','11:45:00',2.43),('9303','2013-01-08','11:50:00',1.82),('9303','2013-01-08','11:55:00',1.52),('9303','2013-01-08','12:00:00',1.42),('9303','2013-01-08','12:05:00',1.37),('9303','2013-01-08','12:10:00',1.46),('9303','2013-01-08','12:15:00',1.33),('9303','2013-01-08','12:20:00',1.19),('9303','2013-01-08','12:25:00',1.16),('9303','2013-01-08','12:30:00',1.11),('9303','2013-01-08','12:35:00',1.07),('9303','2013-01-08','12:40:00',1.3),('9303','2013-01-08','12:45:00',1.58),('9303','2013-01-08','12:50:00',1.97),('9303','2013-01-08','12:55:00',1.2),('9303','2013-01-08','13:45:00',1.32),('9303','2013-01-08','13:50:00',1.23),('9303','2013-01-08','13:55:00',1.24),('9303','2013-01-07','09:45:00',1.08),('9303','2013-01-07','09:50:00',1.19),('9303','2013-01-07','09:55:00',1.23),('9303','2013-01-07','10:00:00',1.26),('9303','2013-01-07','10:05:00',1.47),('9303','2013-01-07','10:10:00',1.57),('9303','2013-01-07','10:15:00',1.61),('9303','2013-01-07','10:20:00',1.56),('9303','2013-01-07','10:25:00',1.66),('9303','2013-01-07','10:30:00',1.66),('9303','2013-01-07','10:35:00',1.65),('9303','2013-01-07','10:40:00',1.68),('9303','2013-01-07','10:45:00',1.73),('9303','2013-01-07','10:50:00',1.73),('9303','2013-01-07','10:55:00',1.75),('9303','2013-01-07','11:00:00',1.77),('9303','2013-01-07','11:05:00',1.79),('9303','2013-01-07','11:10:00',1.83),('9303','2013-01-07','11:15:00',1.84),('9303','2013-01-07','11:20:00',1.88),('9303','2013-01-07','11:25:00',1.9),('9303','2013-01-07','11:30:00',1.93),('9303','2013-01-07','11:35:00',1.94),('9303','2013-01-07','11:40:00',1.95),('9303','2013-01-07','11:45:00',1.96),('9303','2013-01-07','11:50:00',1.99),('9303','2013-01-07','11:55:00',1.99),('9303','2013-01-07','12:00:00',1.99),('9303','2013-01-07','12:05:00',2),('9303','2013-01-07','12:10:00',2),('9303','2013-01-07','12:15:00',2.04),('9303','2013-01-07','12:20:00',2.07),('9303','2013-01-07','12:25:00',2.09),('9303','2013-01-07','12:30:00',2.08),('9303','2013-01-07','12:35:00',2.12),('9303','2013-01-07','12:40:00',2.14),('9303','2013-01-07','12:45:00',2.09),('9303','2013-01-07','12:50:00',2.06),('9303','2013-01-07','12:55:00',2.03),('9303','2013-01-07','13:00:00',2.02),('9303','2013-01-07','13:05:00',1.99),('9303','2013-01-07','13:10:00',1.92),('9303','2013-01-07','13:15:00',1.87),('9303','2013-01-07','13:20:00',1.83),('9303','2013-01-07','13:25:00',1.83),('9303','2013-01-07','13:30:00',1.78),('9303','2013-01-07','13:35:00',1.73),('9303','2013-01-07','13:40:00',1.72),('9303','2013-01-07','13:45:00',1.68),('9303','2013-01-07','13:50:00',1.64),('9303','2013-01-07','13:55:00',1.59),('9303','2013-01-07','14:00:00',1.56),('9303','2013-01-07','14:05:00',1.52),('9303','2013-01-07','14:10:00',1.45),('9303','2013-01-07','14:15:00',1.47),('9303','2013-01-07','14:20:00',1.43),('9303','2013-01-07','14:25:00',1.37),('9303','2013-01-07','14:30:00',1.36),('9303','2013-01-07','14:35:00',1.29),('9303','2013-01-07','14:40:00',1.27),('9303','2013-01-07','14:45:00',1.22),('9303','2013-01-07','14:50:00',1.2),('9303','2013-01-07','14:55:00',1.11),('9303','2013-01-07','15:00:00',1.06),('9303','2013-01-06','09:40:00',1.05),('9303','2013-01-06','09:45:00',1.11),('9303','2013-01-06','09:50:00',1.29),('9303','2013-01-06','09:55:00',1.34),('9303','2013-01-06','10:00:00',1.37),('9303','2013-01-06','10:05:00',1.44),('9303','2013-01-06','10:10:00',1.5),('9303','2013-01-06','10:15:00',1.53),('9303','2013-01-06','10:20:00',1.49),('9303','2013-01-06','10:25:00',1.63),('9303','2013-01-06','10:30:00',1.65),('9303','2013-01-06','10:35:00',1.67),('9303','2013-01-06','10:40:00',1.69),('9303','2013-01-06','10:45:00',1.75),('9303','2013-01-06','10:50:00',1.77),('9303','2013-01-06','10:55:00',1.79),('9303','2013-01-06','11:00:00',1.43),('9303','2013-01-06','11:05:00',1.84),('9303','2013-01-06','11:10:00',1.87),('9303','2013-01-06','11:15:00',1.85),('9303','2013-01-06','11:20:00',1.91),('9303','2013-01-06','11:25:00',1.93),('9303','2013-01-06','11:30:00',1.97),('9303','2013-01-06','11:35:00',1.96),('9303','2013-01-06','11:40:00',1.98),('9303','2013-01-06','11:45:00',1.97),('9303','2013-01-06','11:50:00',2),('9303','2013-01-06','11:55:00',2.01),('9303','2013-01-06','12:00:00',2.02),('9303','2013-01-06','12:05:00',2.02),('9303','2013-01-06','12:10:00',2.04),('9303','2013-01-06','12:15:00',2.06),('9303','2013-01-06','12:20:00',2.07),('9303','2013-01-06','12:25:00',2.08),('9303','2013-01-06','12:30:00',2.1),('9303','2013-01-06','12:35:00',2.09),('9303','2013-01-06','12:40:00',2.13),('9303','2013-01-06','12:45:00',2.11),('9303','2013-01-06','12:50:00',2.1),('9303','2013-01-06','12:55:00',2.08),('9303','2013-01-06','13:00:00',2.06),('9303','2013-01-06','13:05:00',2.01),('9303','2013-01-06','13:10:00',1.99),('9303','2013-01-06','13:15:00',1.93),('9303','2013-01-06','13:20:00',1.89),('9303','2013-01-06','13:25:00',1.87),('9303','2013-01-06','13:30:00',1.84),('9303','2013-01-06','13:35:00',1.81),('9303','2013-01-06','13:40:00',1.77),('9303','2013-01-06','13:45:00',1.73),('9303','2013-01-06','13:50:00',1.69),('9303','2013-01-06','13:55:00',1.62),('9303','2013-01-06','14:00:00',1.61),('9303','2013-01-06','14:05:00',1.6),('9303','2013-01-06','14:10:00',1.44),('9303','2013-01-06','14:15:00',1.39),('9303','2013-01-06','14:20:00',1.41),('9303','2013-01-06','14:25:00',1.32),('9303','2013-01-06','14:30:00',1.35),('9303','2013-01-06','14:35:00',1.28),('9303','2013-01-06','14:40:00',1.22),('9303','2013-01-06','14:45:00',1.19),('9303','2013-01-06','14:50:00',1.14),('9303','2013-01-06','14:55:00',1.08),('9303','2013-01-06','15:00:00',1.02),('9303','2013-01-05','10:15:00',1.05),('9303','2013-01-05','10:40:00',1.02),('9303','2013-01-05','10:50:00',1.07),('9303','2013-01-05','10:55:00',1.57),('9303','2013-01-05','11:00:00',1.35),('9303','2013-01-05','11:05:00',1.57),('9303','2013-01-05','11:10:00',1.56),('9303','2013-01-05','11:15:00',1.33),('9303','2013-01-05','11:20:00',1.79),('9303','2013-01-05','11:25:00',1.88),('9303','2013-01-05','11:30:00',1.94),('9303','2013-01-05','11:35:00',1.8),('9303','2013-01-05','11:40:00',1.68),('9303','2013-01-05','11:45:00',1.72),('9303','2013-01-05','11:50:00',1.55),('9303','2013-01-05','11:55:00',1.43),('9303','2013-01-05','12:00:00',1.37),('9303','2013-01-05','12:05:00',1.35),('9303','2013-01-05','12:10:00',1.35),('9303','2013-01-05','12:15:00',1.36),('9303','2013-01-05','12:20:00',1.24),('9303','2013-01-05','12:25:00',1.07),('9303','2013-01-05','12:30:00',1.1),('9303','2013-01-05','12:35:00',1.48),('9303','2013-01-05','12:40:00',1.83),('9303','2013-01-05','12:45:00',2),('9303','2013-01-05','12:50:00',1.3),('9303','2013-01-05','12:55:00',1.12),('9303','2013-01-05','13:00:00',1.18),('9303','2013-01-05','13:05:00',1.09),('9303','2013-01-05','13:10:00',1.05),('9303','2013-01-05','13:30:00',1.48),('9303','2013-01-05','13:35:00',1.33),('9303','2013-01-05','13:40:00',1.01),('9303','2013-01-05','13:55:00',1.06),('9303','2013-01-05','14:05:00',1.4),('9303','2013-01-05','14:10:00',1.28),('9303','2013-01-05','14:30:00',1.03),('9303','2013-01-05','14:35:00',1.02),('9303','2013-01-05','14:40:00',1.08),('9303','2013-01-05','14:45:00',1.11),('9303','2013-01-04','09:55:00',1.22),('9303','2013-01-04','10:00:00',1.47),('9303','2013-01-04','10:05:00',1.58),('9303','2013-01-04','10:10:00',1.39),('9303','2013-01-04','10:15:00',1.58),('9303','2013-01-04','10:20:00',1.25),('9303','2013-01-04','10:25:00',1.58),('9303','2013-01-04','10:30:00',1.64),('9303','2013-01-04','10:35:00',1.69),('9303','2013-01-04','10:40:00',1.76),('9303','2013-01-04','10:45:00',1.89),('9303','2013-01-04','10:50:00',2.01),('9303','2013-01-04','10:55:00',2.05),('9303','2013-01-04','11:00:00',1.84),('9303','2013-01-04','11:05:00',1.15),('9303','2013-01-04','11:35:00',1),('9303','2013-01-04','11:45:00',1.25),('9303','2013-01-04','11:50:00',1.93),('9303','2013-01-04','11:55:00',2.36),('9303','2013-01-04','12:00:00',2.39),('9303','2013-01-04','12:05:00',2.03),('9303','2013-01-04','12:10:00',1.61),('9303','2013-01-04','12:15:00',1.14),('9303','2013-01-04','12:25:00',1.04),('9303','2013-01-04','12:30:00',1.55),('9303','2013-01-04','12:35:00',1.44),('9303','2013-01-04','12:40:00',2.19),('9303','2013-01-04','12:45:00',2.22),('9303','2013-01-04','12:50:00',2.23),('9303','2013-01-04','12:55:00',2.15),('9303','2013-01-04','13:00:00',2.07),('9303','2013-01-04','13:05:00',1.93),('9303','2013-01-04','13:10:00',1.82),('9303','2013-01-04','13:15:00',1.67),('9303','2013-01-04','13:20:00',1.83),('9303','2013-01-04','13:25:00',1.79),('9303','2013-01-04','13:30:00',1.73),('9303','2013-01-04','13:35:00',1.68),('9303','2013-01-04','13:40:00',1.64),('9303','2013-01-04','13:45:00',1.59),('9303','2013-01-04','13:50:00',1.56),('9303','2013-01-04','13:55:00',1.49),('9303','2013-01-04','14:00:00',1.43),('9303','2013-01-04','14:05:00',1.45),('9303','2013-01-04','14:10:00',1.39),('9303','2013-01-04','14:15:00',1.38),('9303','2013-01-04','14:20:00',1.32),('9303','2013-01-04','14:25:00',1.28),('9303','2013-01-04','14:30:00',1.25),('9303','2013-01-04','14:35:00',1.23),('9303','2013-01-04','14:40:00',1.18),('9303','2013-01-04','14:45:00',1.12),('9303','2013-01-04','14:50:00',1.09),('9303','2013-01-04','14:55:00',1.05),('9303','2013-01-03','09:45:00',1.27),('9303','2013-01-03','09:50:00',1.49),('9303','2013-01-03','09:55:00',1.63),('9303','2013-01-03','10:00:00',1.71),('9303','2013-01-03','10:05:00',1.81),('9303','2013-01-03','10:10:00',1.78),('9303','2013-01-03','10:15:00',2.06),('9303','2013-01-03','10:20:00',1.62),('9303','2013-01-03','10:25:00',1.59),('9303','2013-01-03','10:30:00',1.63),('9303','2013-01-03','10:35:00',1.56),('9303','2013-01-03','10:40:00',1.52),('9303','2013-01-03','10:45:00',1.44),('9303','2013-01-03','10:50:00',1.43),('9303','2013-01-03','10:55:00',1.35),('9303','2013-01-03','11:00:00',1.47),('9303','2013-01-03','11:05:00',1.39),('9303','2013-01-03','11:10:00',1.28),('9303','2013-01-03','11:15:00',1.3),('9303','2013-01-03','11:20:00',1.07),('9303','2013-01-03','11:35:00',1.58),('9303','2013-01-03','11:40:00',1.96),('9303','2013-01-03','11:45:00',2.07),('9303','2013-01-03','11:50:00',2.05),('9303','2013-01-03','11:55:00',2.01),('9303','2013-01-03','12:00:00',2.02),('9303','2013-01-03','12:05:00',2.02),('9303','2013-01-03','12:10:00',2.03),('9303','2013-01-03','12:15:00',2.06),('9303','2013-01-03','12:20:00',2.09),('9303','2013-01-03','12:25:00',2.12),('9303','2013-01-03','12:30:00',2.12),('9303','2013-01-03','12:35:00',2.15),('9303','2013-01-03','12:40:00',2.17),('9303','2013-01-03','12:45:00',2.12),('9303','2013-01-03','12:50:00',2.09),('9303','2013-01-03','12:55:00',2.04),('9303','2013-01-03','13:00:00',2.02),('9303','2013-01-03','13:05:00',1.96),('9303','2013-01-03','13:10:00',1.95),('9303','2013-01-03','13:15:00',1.89),('9303','2013-01-03','13:20:00',1.84),('9303','2013-01-03','13:25:00',1.82),('9303','2013-01-03','13:30:00',1.78),('9303','2013-01-03','13:35:00',1.76),('9303','2013-01-03','13:40:00',1.73),('9303','2013-01-03','13:45:00',1.68),('9303','2013-01-03','13:50:00',1.65),('9303','2013-01-03','13:55:00',1.58),('9303','2013-01-03','14:00:00',1.53),('9303','2013-01-03','14:05:00',1.52),('9303','2013-01-03','14:10:00',1.48),('9303','2013-01-03','14:15:00',1.46),('9303','2013-01-03','14:20:00',1.41),('9303','2013-01-03','14:25:00',1.37),('9303','2013-01-03','14:30:00',1.34),('9303','2013-01-03','14:35:00',1.28),('9303','2013-01-03','14:40:00',1.24),('9303','2013-01-03','14:45:00',1.2),('9303','2013-01-03','14:50:00',1.15),('9303','2013-01-03','14:55:00',1.1),('9303','2013-01-03','15:00:00',1.04),('9303','2014-03-18','07:55:00',1.17),('9303','2014-03-18','08:00:00',1.43),('9303','2014-03-18','08:05:00',1.19),('9303','2014-03-18','08:10:00',1.1),('9303','2014-03-18','08:20:00',1.07),('9303','2014-03-18','08:25:00',1.18),('9303','2014-03-18','08:55:00',2.39),('9303','2014-03-18','09:00:00',2.34),('9303','2014-03-18','09:05:00',1.65),('9303','2014-03-18','09:10:00',1.38),('9303','2014-03-18','09:15:00',1.63),('9303','2014-03-18','09:20:00',2.68),('9303','2014-03-18','09:25:00',3.01),('9303','2014-03-18','09:30:00',1.62),('9303','2014-03-18','09:35:00',1.85),('9303','2014-03-18','09:40:00',1.88),('9303','2014-03-18','09:45:00',1.58),('9303','2014-03-18','09:50:00',2.48),('9303','2014-03-18','09:55:00',1.12),('9303','2014-03-18','10:00:00',2.28),('9303','2014-03-18','10:05:00',2.52),('9303','2014-03-18','10:10:00',2.72),('9303','2014-03-18','10:15:00',3.62),('9303','2014-03-18','10:20:00',2.63),('9303','2014-03-18','10:25:00',2.45),('9303','2014-03-18','10:30:00',1.68),('9303','2014-03-18','10:35:00',3.61),('9303','2014-03-18','10:40:00',2.54),('9303','2014-03-18','10:45:00',2.18),('9303','2014-03-18','10:50:00',1.81),('9303','2014-03-18','10:55:00',2.1),('9303','2014-03-18','11:00:00',4.44),('9303','2014-03-18','11:05:00',2.13),('9303','2014-03-18','11:10:00',2.19),('9303','2014-03-18','11:15:00',1.39),('9303','2014-03-18','11:20:00',1.3),('9303','2014-03-18','11:25:00',1.56),('9303','2014-03-18','11:30:00',2.44),('9303','2014-03-18','11:35:00',2.79),('9303','2014-03-18','11:40:00',2.76),('9303','2014-03-18','11:45:00',2.95),('9303','2014-03-18','11:50:00',2.71),('9303','2014-03-18','11:55:00',1.5),('9303','2014-03-18','12:00:00',1.56),('9303','2014-03-18','12:05:00',1.71),('9303','2014-03-18','12:10:00',2.29),('9303','2014-03-18','12:15:00',3.68),('9303','2014-03-18','12:20:00',2.81),('9303','2014-03-18','12:25:00',2.2),('9303','2014-03-18','12:30:00',3.92),('9303','2014-03-18','12:35:00',4.08),('9303','2014-03-18','12:40:00',3.2),('9303','2014-03-18','12:45:00',3.34),('9303','2014-03-18','12:50:00',3.11),('9303','2014-03-18','12:55:00',3.83),('9303','2014-03-18','13:00:00',3.82),('9303','2014-03-18','13:05:00',3.75),('9303','2014-03-18','13:10:00',3.83),('9303','2014-03-18','13:15:00',3.75),('9303','2014-03-18','13:20:00',3.72),('9303','2014-03-18','13:25:00',3.53),('9303','2014-03-18','13:30:00',3.41),('9303','2014-03-18','13:35:00',3.57),('9303','2014-03-18','13:40:00',3.51),('9303','2014-03-18','13:45:00',3.48),('9303','2014-03-18','13:50:00',3.45),('9303','2014-03-18','13:55:00',3.46),('9303','2014-03-18','14:00:00',3.44),('9303','2014-03-18','14:05:00',3.42),('9303','2014-03-18','14:10:00',3.35),('9303','2014-03-18','14:15:00',3.32),('9303','2014-03-18','14:20:00',3.27),('9303','2014-03-18','14:25:00',3.23),('9303','2014-03-18','14:30:00',3.13),('9303','2014-03-18','14:35:00',3.08),('9303','2014-03-18','14:40:00',3.04),('9303','2014-03-18','14:45:00',2.97),('9303','2014-03-18','14:50:00',2.91),('9303','2014-03-18','14:55:00',2.84),('9303','2014-03-18','15:00:00',2.76),('9303','2014-03-18','15:05:00',2.7),('9303','2014-03-18','15:10:00',2.67),('9303','2014-03-18','15:15:00',2.61),('9303','2014-03-18','15:20:00',2.51),('9303','2014-03-18','15:25:00',2.45),('9303','2014-03-18','15:30:00',2.36),('9303','2014-03-18','15:35:00',2.25),('9303','2014-03-18','15:40:00',2.11),('9303','2014-03-18','15:45:00',1.99),('9303','2014-03-18','15:50:00',1.88),('9303','2014-03-18','15:55:00',1.81),('9303','2014-03-18','16:00:00',1.78),('9303','2014-03-18','16:05:00',1.65),('9303','2014-03-18','16:10:00',1.54),('9303','2014-03-18','16:15:00',1.51),('9303','2014-03-18','16:20:00',1.42),('9303','2014-03-18','16:25:00',1.32),('9303','2014-03-18','16:30:00',1.25),('9303','2014-03-18','16:35:00',1.11),('9303','2014-03-18','16:40:00',1.04),('9303','2013-01-01','09:45:00',1.07),('9303','2013-01-01','09:50:00',1.2),('9303','2013-01-01','09:55:00',1.29),('9303','2013-01-01','10:00:00',1.33),('9303','2013-01-01','10:05:00',1.37),('9303','2013-01-01','10:10:00',1.44),('9303','2013-01-01','10:15:00',1.43),('9303','2013-01-01','10:20:00',1.47),('9303','2013-01-01','10:25:00',1.48),('9303','2013-01-01','10:30:00',1.48),('9303','2013-01-01','10:35:00',1.51),('9303','2013-01-01','10:40:00',1.59),('9303','2013-01-01','10:45:00',1.53),('9303','2013-01-01','10:50:00',1.91),('9303','2013-01-01','10:55:00',1.08),('9303','2013-01-01','11:05:00',1.75),('9303','2013-01-01','11:10:00',1.86),('9303','2013-01-01','11:15:00',1.87),('9303','2013-01-01','11:20:00',1.22),('9303','2013-01-01','11:25:00',1.87),('9303','2013-01-01','11:30:00',2.16),('9303','2013-01-01','11:35:00',1.21),('9303','2013-01-01','11:40:00',1.25),('9303','2013-01-01','11:45:00',1.88),('9303','2013-01-01','11:50:00',1.93),('9303','2013-01-01','11:55:00',1.69),('9303','2013-01-01','12:00:00',1.23),('9303','2013-01-01','12:05:00',1.04),('9303','2013-01-01','12:10:00',1.22),('9303','2013-01-01','12:15:00',1.15),('9303','2013-01-01','12:20:00',1.3),('9303','2013-01-01','12:25:00',1.11),('9303','2013-01-01','12:40:00',1.03),('9303','2013-01-01','12:45:00',1.18),('9303','2013-01-01','12:50:00',1.01),('9303','2013-01-01','12:55:00',1.01),('9303','2012-12-31','10:10:00',1.17),('9303','2012-12-31','10:15:00',1.57),('9303','2012-12-31','10:20:00',1.66),('9303','2012-12-31','10:25:00',1.64),('9303','2012-12-31','10:30:00',1.62),('9303','2012-12-31','10:35:00',1.63),('9303','2012-12-31','10:40:00',1.69),('9303','2012-12-31','10:45:00',1.72),('9303','2012-12-31','10:50:00',1.75),('9303','2012-12-31','10:55:00',1.78),('9303','2012-12-31','11:00:00',1.81),('9303','2012-12-31','11:05:00',1.84),('9303','2012-12-31','11:10:00',1.77),('9303','2012-12-31','11:15:00',1.83),('9303','2012-12-31','11:20:00',1.91),('9303','2012-12-31','11:25:00',1.94),('9303','2012-12-31','11:30:00',2),('9303','2012-12-31','11:35:00',1.98),('9303','2012-12-31','11:40:00',2.01),('9303','2012-12-31','11:45:00',2.01),('9303','2012-12-31','11:50:00',2.02),('9303','2012-12-31','11:55:00',2.01),('9303','2012-12-31','12:00:00',2.05),('9303','2012-12-31','12:05:00',2.08),('9303','2012-12-31','12:10:00',2.11),('9303','2012-12-31','12:15:00',2.13),('9303','2012-12-31','12:20:00',2.17),('9303','2012-12-31','12:25:00',2.17),('9303','2012-12-31','12:30:00',2.16),('9303','2012-12-31','12:35:00',2.21),('9303','2012-12-31','12:40:00',2.19),('9303','2012-12-31','12:45:00',2.15),('9303','2012-12-31','12:50:00',2.12),('9303','2012-12-31','12:55:00',2.06),('9303','2012-12-31','13:00:00',2.03),('9303','2012-12-31','13:05:00',2),('9303','2012-12-31','13:10:00',1.97),('9303','2012-12-31','13:15:00',1.91),('9303','2012-12-31','13:20:00',1.89),('9303','2012-12-31','13:25:00',1.87),('9303','2012-12-31','13:30:00',1.83),('9303','2012-12-31','13:35:00',1.78),('9303','2012-12-31','13:40:00',1.76),('9303','2012-12-31','13:45:00',1.69),('9303','2012-12-31','13:50:00',1.65),('9303','2012-12-31','13:55:00',1.58),('9303','2012-12-31','14:00:00',1.56),('9303','2012-12-31','14:05:00',1.56),('9303','2012-12-31','14:10:00',1.48),('9303','2012-12-31','14:15:00',1.45),('9303','2012-12-31','14:20:00',1.39),('9303','2012-12-31','14:25:00',1.37),('9303','2012-12-31','14:30:00',1.34),('9303','2012-12-31','14:35:00',1.28),('9303','2012-12-31','14:40:00',1.25),('9303','2012-12-31','14:45:00',1.2),('9303','2012-12-31','14:50:00',1.16),('9303','2012-12-31','14:55:00',1.09),('9303','2012-12-31','15:00:00',1.01),('9303','2012-12-30','09:45:00',1.05),('9303','2012-12-30','09:50:00',1.2),('9303','2012-12-30','09:55:00',1.26),('9303','2012-12-30','10:00:00',1.35),('9303','2012-12-30','10:05:00',1.44),('9303','2012-12-30','10:10:00',1.51),('9303','2012-12-30','10:15:00',1.46),('9303','2012-12-30','10:20:00',1.54),('9303','2012-12-30','10:25:00',1.54),('9303','2012-12-30','10:30:00',1.54),('9303','2012-12-30','10:35:00',1.57),('9303','2012-12-30','10:40:00',1.6),('9303','2012-12-30','10:45:00',1.7),('9303','2012-12-30','10:50:00',1.75),('9303','2012-12-30','10:55:00',1.77),('9303','2012-12-30','11:00:00',1.81),('9303','2012-12-30','11:05:00',1.85),('9303','2012-12-30','11:10:00',1.82),('9303','2012-12-30','11:15:00',1.87),('9303','2012-12-30','11:20:00',1.91),('9303','2012-12-30','11:25:00',1.92),('9303','2012-12-30','11:30:00',1.97),('9303','2012-12-30','11:35:00',1.94),('9303','2012-12-30','11:40:00',1.98),('9303','2012-12-30','11:45:00',2),('9303','2012-12-30','11:50:00',2),('9303','2012-12-30','11:55:00',1.99),('9303','2012-12-30','12:00:00',2.01),('9303','2012-12-30','12:05:00',1.99),('9303','2012-12-30','12:10:00',2.02),('9303','2012-12-30','12:15:00',2.06),('9303','2012-12-30','12:20:00',2.1),('9303','2012-12-30','12:25:00',2.11),('9303','2012-12-30','12:30:00',2.08),('9303','2012-12-30','12:35:00',2.12),('9303','2012-12-30','12:40:00',2.1),('9303','2012-12-30','12:45:00',2.05),('9303','2012-12-30','12:50:00',2.04),('9303','2012-12-30','12:55:00',2),('9303','2012-12-30','13:00:00',1.99),('9303','2012-12-30','13:05:00',1.96),('9303','2012-12-30','13:10:00',1.95),('9303','2012-12-30','13:15:00',1.92),('9303','2012-12-30','13:20:00',1.87),('9303','2012-12-30','13:25:00',1.85),('9303','2012-12-30','13:30:00',1.81),('9303','2012-12-30','13:35:00',1.79),('9303','2012-12-30','13:40:00',1.75),('9303','2012-12-30','13:45:00',1.69),('9303','2012-12-30','13:50:00',1.64),('9303','2012-12-30','13:55:00',1.62),('9303','2012-12-30','14:00:00',1.6),('9303','2012-12-30','14:05:00',1.58),('9303','2012-12-30','14:10:00',1.51),('9303','2012-12-30','14:15:00',1.48),('9303','2012-12-30','14:20:00',1.41),('9303','2012-12-30','14:25:00',1.39),('9303','2012-12-30','14:30:00',1.33),('9303','2012-12-30','14:35:00',1.29),('9303','2012-12-30','14:40:00',1.25),('9303','2012-12-30','14:45:00',1.2),('9303','2012-12-30','14:50:00',1.14),('9303','2012-12-30','14:55:00',1.08),('9303','2012-12-29','09:45:00',1.06),('9303','2012-12-29','09:50:00',1.21),('9303','2012-12-29','09:55:00',1.29),('9303','2012-12-29','10:00:00',1.37),('9303','2012-12-29','10:05:00',1.47),('9303','2012-12-29','10:10:00',1.51),('9303','2012-12-29','10:15:00',1.48),('9303','2012-12-29','10:20:00',1.57),('9303','2012-12-29','10:25:00',1.57),('9303','2012-12-29','10:30:00',1.58),('9303','2012-12-29','10:35:00',1.57),('9303','2012-12-29','10:40:00',1.62),('9303','2012-12-29','10:45:00',1.72),('9303','2012-12-29','10:50:00',1.77),('9303','2012-12-29','10:55:00',1.82),('9303','2012-12-29','11:00:00',1.84),('9303','2012-12-29','11:05:00',1.89),('9303','2012-12-29','11:10:00',1.87),('9303','2012-12-29','11:15:00',1.93),('9303','2012-12-29','11:20:00',1.95),('9303','2012-12-29','11:25:00',1.99),('9303','2012-12-29','11:30:00',2.02),('9303','2012-12-29','11:35:00',2),('9303','2012-12-29','11:40:00',2.01),('9303','2012-12-29','11:45:00',2.02),('9303','2012-12-29','11:50:00',2.03),('9303','2012-12-29','11:55:00',2.02),('9303','2012-12-29','12:00:00',2.06),('9303','2012-12-29','12:05:00',2.07),('9303','2012-12-29','12:10:00',2.12),('9303','2012-12-29','12:15:00',2.12),('9303','2012-12-29','12:20:00',2.14),('9303','2012-12-29','12:25:00',2.11),('9303','2012-12-29','12:30:00',2.13),('9303','2012-12-29','12:35:00',2.18),('9303','2012-12-29','12:40:00',2.18),('9303','2012-12-29','12:45:00',2.12),('9303','2012-12-29','12:50:00',2.07),('9303','2012-12-29','12:55:00',2.05),('9303','2012-12-29','13:00:00',2.03),('9303','2012-12-29','13:05:00',2),('9303','2012-12-29','13:10:00',1.98),('9303','2012-12-29','13:15:00',1.94),('9303','2012-12-29','13:20:00',1.91),('9303','2012-12-29','13:25:00',1.86),('9303','2012-12-29','13:30:00',1.82),('9303','2012-12-29','13:35:00',1.78),('9303','2012-12-29','13:40:00',1.76),('9303','2012-12-29','13:45:00',1.7),('9303','2012-12-29','13:50:00',1.65),('9303','2012-12-29','13:55:00',1.65),('9303','2012-12-29','14:00:00',1.59),('9303','2012-12-29','14:05:00',1.57),('9303','2012-12-29','14:10:00',1.51),('9303','2012-12-29','14:15:00',1.48),('9303','2012-12-29','14:20:00',1.43),('9303','2012-12-29','14:25:00',1.41),('9303','2012-12-29','14:30:00',1.34),('9303','2012-12-29','14:35:00',1.29),('9303','2012-12-29','14:40:00',1.27),('9303','2012-12-29','14:45:00',1.21),('9303','2012-12-29','14:50:00',1.17),('9303','2012-12-29','14:55:00',1.09),('9303','2012-12-29','15:00:00',1.01),('9303','2012-12-28','09:45:00',1.03),('9303','2012-12-28','09:50:00',1.09),('9303','2012-12-28','09:55:00',1.13),('9303','2012-12-28','10:00:00',1.23),('9303','2012-12-28','10:05:00',1.26),('9303','2012-12-28','10:10:00',1.28),('9303','2012-12-28','10:15:00',1.36),('9303','2012-12-28','10:20:00',1.45),('9303','2012-12-28','10:25:00',1.47),('9303','2012-12-28','10:30:00',1.47),('9303','2012-12-28','10:35:00',1.47),('9303','2012-12-28','10:40:00',1.52),('9303','2012-12-28','10:45:00',1.59),('9303','2012-12-28','10:50:00',1.65),('9303','2012-12-28','10:55:00',1.6),('9303','2012-12-28','11:00:00',1.73),('9303','2012-12-28','11:05:00',1.8),('9303','2012-12-28','11:10:00',1.78),('9303','2012-12-28','11:15:00',1.85),('9303','2012-12-28','11:20:00',1.85),('9303','2012-12-28','11:25:00',1.89),('9303','2012-12-28','11:30:00',1.93),('9303','2012-12-28','11:35:00',1.91),('9303','2012-12-28','11:40:00',1.96),('9303','2012-12-28','11:45:00',1.92),('9303','2012-12-28','11:50:00',1.98),('9303','2012-12-28','11:55:00',1.97),('9303','2012-12-28','12:00:00',1.72),('9303','2012-12-28','12:05:00',1.98),('9303','2012-12-28','12:10:00',2.01),('9303','2012-12-28','12:15:00',2.05),('9303','2012-12-28','12:20:00',2.06),('9303','2012-12-28','12:25:00',2.05),('9303','2012-12-28','12:30:00',2.04),('9303','2012-12-28','12:35:00',2.03),('9303','2012-12-28','12:40:00',1.75),('9303','2012-12-28','12:45:00',2.05),('9303','2012-12-28','12:50:00',2.01),('9303','2012-12-28','12:55:00',1.97),('9303','2012-12-28','13:00:00',1.92),('9303','2012-12-28','13:05:00',1.88),('9303','2012-12-28','13:10:00',1.83),('9303','2012-12-28','13:15:00',1.78),('9303','2012-12-28','13:20:00',1.76),('9303','2012-12-28','13:25:00',1.74),('9303','2012-12-28','13:30:00',1.69),('9303','2012-12-28','13:35:00',1.64),('9303','2012-12-28','13:40:00',1.61),('9303','2012-12-28','13:45:00',1.58),('9303','2012-12-28','13:50:00',1.54),('9303','2012-12-28','13:55:00',1.53),('9303','2012-12-28','14:00:00',1.43),('9303','2012-12-28','14:05:00',1.44),('9303','2012-12-28','14:10:00',1.35),('9303','2012-12-28','14:15:00',1.3),('9303','2012-12-28','14:20:00',1.28),('9303','2012-12-28','14:25:00',1.25),('9303','2012-12-28','14:30:00',1.08),('9303','2012-12-28','14:35:00',1.12),('9303','2012-12-28','14:45:00',1.07),('9303','2012-12-28','14:50:00',1.03),('9303','2012-12-27','09:35:00',1.02),('9303','2012-12-27','09:45:00',1.12),('9303','2012-12-27','09:50:00',1.32),('9303','2012-12-27','10:15:00',1.17),('9303','2012-12-27','10:20:00',1.26),('9303','2012-12-27','10:25:00',1.25),('9303','2012-12-27','10:30:00',1.27),('9303','2012-12-27','10:35:00',1.34),('9303','2012-12-27','10:40:00',1.35),('9303','2012-12-27','10:45:00',1.56),('9303','2012-12-27','10:50:00',1.55),('9303','2012-12-27','10:55:00',1.52),('9303','2012-12-27','11:00:00',1.48),('9303','2012-12-27','11:05:00',1.02),('9303','2012-12-27','11:10:00',1.23),('9303','2012-12-27','11:50:00',1.42),('9303','2012-12-27','11:55:00',1.83),('9303','2012-12-27','12:00:00',1.91),('9303','2012-12-27','12:05:00',2.16),('9303','2012-12-27','12:10:00',2.26),('9303','2012-12-27','12:15:00',1.67),('9303','2012-12-27','12:20:00',1.13),('9303','2012-12-27','12:25:00',1.87),('9303','2012-12-27','12:30:00',2.06),('9303','2012-12-27','12:35:00',2.07),('9303','2012-12-27','12:40:00',2.08),('9303','2012-12-27','12:45:00',1.84),('9303','2012-12-27','12:50:00',1.31),('9303','2012-12-27','12:55:00',2.04),('9303','2012-12-27','13:00:00',1.89),('9303','2012-12-27','13:05:00',1.48),('9303','2012-12-27','13:10:00',1.22),('9303','2012-12-27','13:15:00',1.41),('9303','2012-12-27','13:30:00',1.26),('9303','2012-12-27','14:05:00',1.08),('9303','2012-12-27','14:10:00',1.25),('9303','2012-12-27','14:15:00',1.26),('9303','2012-12-27','14:20:00',1.3),('9303','2012-12-27','14:25:00',1.27),('9303','2012-12-27','14:30:00',1.22),('9303','2012-12-27','14:35:00',1.19),('9303','2012-12-27','14:40:00',1.12),('9303','2012-12-26','09:45:00',1.03),('9303','2012-12-26','09:50:00',1.16),('9303','2012-12-26','09:55:00',1.21),('9303','2012-12-26','10:00:00',1.29),('9303','2012-12-26','10:05:00',1.38),('9303','2012-12-26','10:10:00',1.37),('9303','2012-12-26','10:15:00',1.41),('9303','2012-12-26','10:20:00',1.44),('9303','2012-12-26','10:25:00',1.4),('9303','2012-12-26','10:30:00',1.43),('9303','2012-12-26','10:35:00',1.41),('9303','2012-12-26','10:40:00',1.5),('9303','2012-12-26','10:45:00',1.55),('9303','2012-12-26','10:50:00',1.58),('9303','2012-12-26','10:55:00',1.63),('9303','2012-12-26','11:00:00',1.66),('9303','2012-12-26','11:05:00',1.7),('9303','2012-12-26','11:10:00',1.67),('9303','2012-12-26','11:15:00',1.72),('9303','2012-12-26','11:20:00',1.74),('9303','2012-12-26','11:25:00',1.78),('9303','2012-12-26','11:30:00',1.76),('9303','2012-12-26','11:35:00',1.78),('9303','2012-12-26','11:40:00',1.81),('9303','2012-12-26','11:45:00',1.83),('9303','2012-12-26','11:50:00',1.86),('9303','2012-12-26','11:55:00',1.89),('9303','2012-12-26','12:00:00',1.94),('9303','2012-12-26','12:05:00',1.99),('9303','2012-12-26','12:10:00',1.99),('9303','2012-12-26','12:15:00',2.05),('9303','2012-12-26','12:20:00',2.07),('9303','2012-12-26','12:25:00',2.1),('9303','2012-12-26','12:30:00',2.11),('9303','2012-12-26','12:35:00',2.13),('9303','2012-12-26','12:40:00',2.14),('9303','2012-12-26','12:45:00',2.08),('9303','2012-12-26','12:50:00',1.99),('9303','2012-12-26','12:55:00',1.91),('9303','2012-12-26','13:00:00',2.03),('9303','2012-12-26','13:05:00',1.8),('9303','2012-12-26','13:10:00',2.02),('9303','2012-12-26','13:15:00',1.98),('9303','2012-12-26','13:20:00',2.09),('9303','2012-12-26','13:25:00',2.09),('9303','2012-12-26','13:30:00',2.26),('9303','2012-12-26','13:35:00',2.15),('9303','2012-12-26','13:40:00',2.11),('9303','2012-12-26','13:45:00',2.02),('9303','2012-12-26','13:50:00',1.86),('9303','2012-12-26','13:55:00',1.64),('9303','2012-12-26','14:00:00',1.55),('9303','2012-12-26','14:05:00',1.67),('9303','2012-12-23','09:45:00',1.11),('9303','2012-12-23','09:50:00',1.22),('9303','2012-12-23','09:55:00',1.27),('9303','2012-12-23','10:00:00',1.36),('9303','2012-12-23','10:05:00',1.45),('9303','2012-12-23','10:10:00',1.42),('9303','2012-12-23','10:15:00',1.45),('9303','2012-12-23','10:20:00',1.48),('9303','2012-12-23','10:25:00',1.4),('9303','2012-12-23','10:30:00',1.42),('9303','2012-12-23','10:35:00',1.43),('9303','2012-12-23','10:40:00',1.54),('9303','2012-12-23','10:45:00',1.59),('9303','2012-12-23','10:50:00',1.54),('9303','2012-12-23','10:55:00',1.57),('9303','2012-12-23','11:00:00',1.71),('9303','2012-12-23','11:05:00',1.7),('9303','2012-12-23','11:10:00',1.7),('9303','2012-12-23','11:15:00',1.77),('9303','2012-12-23','11:20:00',1.84),('9303','2012-12-23','11:25:00',1.68),('9303','2012-12-23','11:30:00',1.77),('9303','2012-12-23','11:35:00',1.93),('9303','2012-12-23','11:40:00',1.91),('9303','2012-12-23','11:45:00',1.86),('9303','2012-12-23','11:50:00',1.93),('9303','2012-12-23','11:55:00',1.82),('9303','2012-12-23','12:00:00',1.69),('9303','2012-12-23','12:05:00',1.74),('9303','2012-12-23','12:10:00',1.78),('9303','2012-12-23','12:15:00',1.48),('9303','2012-12-23','12:20:00',1.23),('9303','2012-12-23','12:30:00',1.31),('9303','2012-12-23','12:35:00',1.17),('9303','2012-12-23','12:40:00',1.23),('9303','2012-12-23','12:50:00',1.29),('9303','2012-12-23','12:55:00',1.72),('9303','2012-12-23','13:00:00',1.87),('9303','2012-12-23','13:05:00',1.5),('9303','2012-12-23','13:10:00',1.72),('9303','2012-12-23','13:15:00',1.18),('9303','2012-12-23','13:40:00',1.29),('9303','2012-12-23','13:45:00',1.26),('9303','2012-12-23','13:50:00',1.16),('9303','2012-12-23','13:55:00',1.11),('9303','2012-12-23','14:00:00',1.5),('9303','2012-12-23','14:05:00',1.3),('9303','2012-12-23','14:10:00',1.23),('9303','2012-12-23','14:15:00',1.24),('9303','2012-12-23','14:20:00',1),('9303','2012-12-23','14:40:00',1.07),('9303','2012-12-23','14:45:00',1.1),('9303','2014-05-01','07:55:00',1.11),('9303','2014-05-01','08:00:00',1.23),('9303','2014-05-01','08:05:00',1.21),('9303','2014-05-01','08:10:00',1.35),('9303','2014-05-01','08:15:00',1.5),('9303','2014-05-01','08:20:00',1.6),('9303','2014-05-01','08:25:00',1.72),('9303','2014-05-01','08:30:00',1.82),('9303','2014-05-01','08:35:00',1.9),('9303','2014-05-01','08:40:00',1.99),('9303','2014-05-01','08:45:00',2.09),('9303','2014-05-01','08:50:00',2.26),('9303','2014-05-01','08:55:00',2.25),('9303','2014-05-01','09:00:00',1.49),('9303','2014-05-01','09:05:00',1.21),('9303','2014-05-01','09:10:00',2.01),('9303','2014-05-01','09:15:00',1.71),('9303','2014-05-01','09:20:00',1.2),('9303','2014-05-01','09:25:00',2.71),('9303','2014-05-01','09:30:00',2.65),('9303','2014-05-01','09:35:00',3.02),('9303','2014-05-01','09:40:00',3.17),('9303','2014-05-01','09:45:00',2.16),('9303','2014-05-01','09:50:00',2.21),('9303','2014-05-01','09:55:00',1.93),('9303','2014-05-01','10:00:00',1.91),('9303','2014-05-01','10:05:00',3.19),('9303','2014-05-01','10:10:00',3.46),('9303','2014-05-01','10:15:00',2.6),('9303','2014-05-01','10:20:00',2.85),('9303','2014-05-01','10:25:00',2.93),('9303','2014-05-01','10:30:00',1.69),('9303','2014-05-01','10:35:00',1.37),('9303','2014-05-01','10:40:00',1.69),('9303','2014-05-01','10:45:00',4.05),('9303','2014-05-01','10:50:00',3.73),('9303','2014-05-01','10:55:00',2.64),('9303','2014-05-01','11:00:00',2.71),('9303','2014-05-01','11:05:00',1.27),('9303','2014-05-01','11:10:00',1.24),('9303','2014-05-01','11:15:00',3.73),('9303','2014-05-01','11:20:00',4.57),('9303','2014-05-01','11:25:00',2.16),('9303','2014-05-01','11:30:00',4.36),('9303','2014-05-01','11:35:00',4.35),('9303','2014-05-01','11:40:00',4.54),('9303','2014-05-01','11:45:00',2.94),('9303','2014-05-01','11:50:00',3.01),('9303','2014-05-01','11:55:00',4.35),('9303','2014-05-01','12:00:00',4.29),('9303','2014-05-01','12:05:00',3.69),('9303','2014-05-01','12:10:00',2.55),('9303','2014-05-01','12:15:00',1.64),('9303','2014-05-01','12:20:00',3.12),('9303','2014-05-01','12:25:00',3.28),('9303','2014-05-01','12:30:00',3.51),('9303','2014-05-01','12:35:00',4.76),('9303','2014-05-01','12:40:00',4.66),('9303','2014-05-01','12:45:00',4.66),('9303','2014-05-01','12:50:00',3.39),('9303','2014-05-01','12:55:00',4.77),('9303','2014-05-01','13:00:00',4.8),('9303','2014-05-01','13:05:00',4.61),('9303','2014-05-01','13:10:00',4.66),('9303','2014-05-01','13:15:00',4.05),('9303','2014-05-01','13:20:00',3.21),('9303','2014-05-01','13:25:00',4.46),('9303','2014-05-01','13:30:00',4.77),('9303','2014-05-01','13:35:00',2.9),('9303','2014-05-01','13:40:00',4.73),('9303','2014-05-01','13:45:00',4.76),('9303','2014-05-01','13:50:00',4.37),('9303','2014-05-01','13:55:00',1.68),('9303','2014-05-01','14:00:00',1.23),('9303','2014-05-01','14:05:00',2.76),('9303','2014-05-01','14:10:00',4.49),('9303','2014-05-01','14:15:00',4.58),('9303','2014-05-01','14:20:00',4.34),('9303','2014-05-01','14:25:00',4.42),('9303','2014-05-01','14:30:00',4.22),('9303','2014-05-01','14:35:00',3.56),('9303','2014-05-01','14:40:00',3.22),('9303','2014-05-01','14:45:00',3.76),('9303','2014-05-01','14:50:00',4.23),('9303','2014-05-01','14:55:00',3.66),('9303','2014-05-01','15:00:00',4.17),('9303','2014-05-01','15:05:00',4.34),('9303','2014-05-01','15:10:00',3.79),('9303','2014-05-01','15:15:00',3.87),('9303','2014-05-01','15:20:00',3.94),('9303','2014-05-01','15:25:00',3.84),('9303','2014-05-01','15:30:00',3.72),('9303','2014-05-01','15:35:00',3.63),('9303','2014-05-01','15:40:00',3.58),('9303','2014-05-01','15:45:00',3.54),('9303','2014-05-01','15:50:00',3.38),('9303','2014-05-01','15:55:00',3.36),('9303','2014-05-01','16:00:00',3.32),('9303','2014-05-01','16:05:00',3.33),('9303','2014-05-01','16:10:00',3.16),('9303','2014-05-01','16:15:00',3.13),('9303','2014-05-01','16:20:00',3.01),('9303','2014-05-01','16:25:00',2.69),('9303','2014-05-01','16:30:00',2.84),('9303','2014-05-01','16:35:00',2.81),('9303','2014-05-01','16:40:00',2.66),('9303','2014-05-01','16:45:00',2.26),('9303','2014-05-01','16:50:00',2.19),('9303','2014-05-01','16:55:00',2.27),('9303','2014-05-01','17:00:00',1.99),('9303','2014-05-01','17:05:00',2.17),('9303','2014-05-01','17:10:00',2.24),('9303','2014-05-01','17:15:00',2.08),('9303','2014-05-01','17:20:00',2.01),('9303','2014-05-01','17:25:00',1.91),('9303','2014-05-01','17:30:00',1.81),('9303','2014-05-01','17:35:00',1.75),('9303','2014-05-01','17:40:00',1.65),('9303','2014-05-01','17:45:00',1.54),('9303','2014-05-01','17:50:00',1.47),('9303','2014-05-01','17:55:00',1.41),('9303','2014-05-01','18:00:00',1.39),('9303','2014-05-01','18:05:00',1.23),('9303','2014-05-01','18:10:00',1.09),('9303','2014-03-17','09:20:00',1.07),('9303','2014-03-17','09:25:00',1.28),('9303','2014-03-17','09:30:00',1.46),('9303','2014-03-17','09:35:00',1.47),('9303','2014-03-17','09:40:00',1.21),('9303','2014-03-17','09:45:00',1.14),('9303','2014-03-17','09:50:00',1.54),('9303','2014-03-17','09:55:00',1.74),('9303','2014-03-17','10:00:00',1.78),('9303','2014-03-17','10:05:00',1.7),('9303','2014-03-17','10:10:00',1.56),('9303','2014-03-17','10:15:00',1.59),('9303','2014-03-17','10:20:00',2.01),('9303','2014-03-17','10:25:00',1.75),('9303','2014-03-17','10:30:00',1.3),('9303','2014-03-17','10:35:00',1.39),('9303','2014-03-17','10:40:00',1.35),('9303','2014-03-17','10:45:00',1.63),('9303','2014-03-17','10:50:00',1.44),('9303','2014-03-17','10:55:00',1.22),('9303','2014-03-17','11:00:00',1.37),('9303','2014-03-17','11:05:00',1.4),('9303','2014-03-17','11:10:00',1.41),('9303','2014-03-17','11:15:00',1.83),('9303','2014-03-17','11:20:00',1.44),('9303','2014-03-17','11:25:00',1.23),('9303','2014-03-17','11:30:00',1.33),('9303','2014-03-17','11:35:00',1.25),('9303','2014-03-17','11:40:00',1.15),('9303','2014-03-17','11:45:00',1.23),('9303','2014-03-17','11:50:00',1.43),('9303','2014-03-17','11:55:00',1.52),('9303','2014-03-17','12:00:00',2.59),('9303','2014-03-17','12:05:00',1.66),('9303','2014-03-17','12:10:00',1.7),('9303','2014-03-17','12:15:00',1.54),('9303','2014-03-17','12:20:00',1.81),('9303','2014-03-17','12:25:00',2.34),('9303','2014-03-17','12:30:00',1.4),('9303','2014-03-17','12:35:00',2.28),('9303','2014-03-17','12:40:00',2.93),('9303','2014-03-17','12:45:00',3.85),('9303','2014-03-17','12:50:00',4.05),('9303','2014-03-17','12:55:00',3.96),('9303','2014-03-17','13:00:00',3.77),('9303','2014-03-17','13:05:00',1.86),('9303','2014-03-17','13:10:00',3.22),('9303','2014-03-17','13:15:00',3.71),('9303','2014-03-17','13:20:00',3.68),('9303','2014-03-17','13:25:00',3.63),('9303','2014-03-17','13:30:00',3.58),('9303','2014-03-17','13:35:00',3.63),('9303','2014-03-17','13:40:00',3.79),('9303','2014-03-17','13:45:00',3.36),('9303','2014-03-17','13:50:00',3.12),('9303','2014-03-17','13:55:00',3.27),('9303','2014-03-17','14:00:00',2.97),('9303','2014-03-17','14:05:00',3.28),('9303','2014-03-17','14:10:00',2.57),('9303','2014-03-17','14:15:00',1.28),('9303','2014-03-17','14:20:00',3.3),('9303','2014-03-17','14:25:00',2.12),('9303','2014-03-17','14:30:00',1.21),('9303','2014-03-17','14:35:00',2),('9303','2014-03-17','14:40:00',2.96),('9303','2014-03-17','14:45:00',2.58),('9303','2014-03-17','14:50:00',1.58),('9303','2014-03-17','14:55:00',2.77),('9303','2014-03-17','15:00:00',2.17),('9303','2014-03-17','15:05:00',2.62),('9303','2014-03-17','15:10:00',2.37),('9303','2014-03-17','15:15:00',2.48),('9303','2014-03-17','15:20:00',2.4),('9303','2014-03-17','15:25:00',2.22),('9303','2014-03-17','15:30:00',2.23),('9303','2014-03-17','15:35:00',2.17),('9303','2014-03-17','15:40:00',1.86),('9303','2014-03-17','15:45:00',1.89),('9303','2014-03-17','15:50:00',1.8),('9303','2014-03-17','15:55:00',1.66),('9303','2014-03-17','16:00:00',1.56),('9303','2014-03-17','16:05:00',1.57),('9303','2014-03-17','16:15:00',1.2),('9303','2014-03-17','16:20:00',1.53),('9303','2014-03-17','16:25:00',1.5),('9303','2014-03-17','16:30:00',1.19),('9303','2014-03-17','16:35:00',1.11),('9303','2014-03-17','16:40:00',1.03),('9303','2012-12-22','10:25:00',1.46),('9303','2012-12-22','10:30:00',1.65),('9303','2012-12-22','10:35:00',1.81),('9303','2012-12-22','10:40:00',1.84),('9303','2012-12-22','10:45:00',1.86),('9303','2012-12-22','10:50:00',1.87),('9303','2012-12-22','10:55:00',1.99),('9303','2012-12-22','11:00:00',1.14),('9303','2012-12-22','11:40:00',1.24),('9303','2012-12-22','11:45:00',1.31),('9303','2012-12-22','11:50:00',1.7),('9303','2012-12-22','11:55:00',1.09),('9303','2012-12-22','12:00:00',1.25),('9303','2012-12-22','12:45:00',1.44),('9303','2012-12-22','12:50:00',1.65),('9303','2012-12-22','12:55:00',1.5),('9303','2012-12-22','13:00:00',1.93),('9303','2012-12-22','13:05:00',2.3),('9303','2012-12-22','13:10:00',2.45),('9303','2012-12-22','13:15:00',2.41),('9303','2012-12-22','13:20:00',2.39),('9303','2012-12-22','13:25:00',2.29),('9303','2012-12-22','13:30:00',1.99),('9303','2012-12-22','13:35:00',2.1),('9303','2012-12-22','13:40:00',1.65),('9303','2012-12-22','14:00:00',1.41),('9303','2012-12-22','14:15:00',1.17),('9303','2012-12-22','14:20:00',1.04),('9303','2012-12-22','15:00:00',1.06),('9303','2014-03-16','07:55:00',1.04),('9303','2014-03-16','08:00:00',1.17),('9303','2014-03-16','08:05:00',1.24),('9303','2014-03-16','08:10:00',1.27),('9303','2014-03-16','08:15:00',1.34),('9303','2014-03-16','08:20:00',1.44),('9303','2014-03-16','08:25:00',1.52),('9303','2014-03-16','08:30:00',1.61),('9303','2014-03-16','08:35:00',1.68),('9303','2014-03-16','08:40:00',1.73),('9303','2014-03-16','08:45:00',1.83),('9303','2014-03-16','08:50:00',1.91),('9303','2014-03-16','08:55:00',1.96),('9303','2014-03-16','09:00:00',1.93),('9303','2014-03-16','09:05:00',2.03),('9303','2014-03-16','09:10:00',2.15),('9303','2014-03-16','09:15:00',2.31),('9303','2014-03-16','09:20:00',2.36),('9303','2014-03-16','09:25:00',2.35),('9303','2014-03-16','09:30:00',2.4),('9303','2014-03-16','09:35:00',2.43),('9303','2014-03-16','09:40:00',2.48),('9303','2014-03-16','09:45:00',2.62),('9303','2014-03-16','09:50:00',2.74),('9303','2014-03-16','09:55:00',2.8),('9303','2014-03-16','10:00:00',2.83),('9303','2014-03-16','10:05:00',2.81),('9303','2014-03-16','10:10:00',2.92),('9303','2014-03-16','10:15:00',3.01),('9303','2014-03-16','10:20:00',2.99),('9303','2014-03-16','10:25:00',3.03),('9303','2014-03-16','10:30:00',3.05),('9303','2014-03-16','10:35:00',3.12),('9303','2014-03-16','10:40:00',3.2),('9303','2014-03-16','10:45:00',3.23),('9303','2014-03-16','10:50:00',3.3),('9303','2014-03-16','10:55:00',3.27),('9303','2014-03-16','11:00:00',3.21),('9303','2014-03-16','11:05:00',3.06),('9303','2014-03-16','11:10:00',2.96),('9303','2014-03-16','11:15:00',3.35),('9303','2014-03-16','11:20:00',3.44),('9303','2014-03-16','11:25:00',3.41),('9303','2014-03-16','11:30:00',3.46),('9303','2014-03-16','11:35:00',3.5),('9303','2014-03-16','11:40:00',3.55),('9303','2014-03-16','11:45:00',3.53),('9303','2014-03-16','11:50:00',3.52),('9303','2014-03-16','11:55:00',3.45),('9303','2014-03-16','12:00:00',3.49),('9303','2014-03-16','12:05:00',3.49),('9303','2014-03-16','12:10:00',3.55),('9303','2014-03-16','12:15:00',3.56),('9303','2014-03-16','12:20:00',3.42),('9303','2014-03-16','12:25:00',3.33),('9303','2014-03-16','12:30:00',3.44),('9303','2014-03-16','12:35:00',3.43),('9303','2014-03-16','12:40:00',3.48),('9303','2014-03-16','12:45:00',3.51),('9303','2014-03-16','12:50:00',3.47),('9303','2014-03-16','12:55:00',3.38),('9303','2014-03-16','13:00:00',3.33),('9303','2014-03-16','13:05:00',3.45),('9303','2014-03-16','13:10:00',3.37),('9303','2014-03-16','13:15:00',3.39),('9303','2014-03-16','13:20:00',3.31),('9303','2014-03-16','13:25:00',3.36),('9303','2014-03-16','13:30:00',3.35),('9303','2014-03-16','13:35:00',3.32),('9303','2014-03-16','13:40:00',3.39),('9303','2014-03-16','13:45:00',3.3),('9303','2014-03-16','13:50:00',3.24),('9303','2014-03-16','13:55:00',3.29),('9303','2014-03-16','14:00:00',3.17),('9303','2014-03-16','14:05:00',3.16),('9303','2014-03-16','14:10:00',3.06),('9303','2014-03-16','14:15:00',3.02),('9303','2014-03-16','14:20:00',2.98),('9303','2014-03-16','14:25:00',2.94),('9303','2014-03-16','14:30:00',2.87),('9303','2014-03-16','14:35:00',2.79),('9303','2014-03-16','14:40:00',2.75),('9303','2014-03-16','14:45:00',2.63),('9303','2014-03-16','14:50:00',2.52),('9303','2014-03-16','14:55:00',2.47),('9303','2014-03-16','15:00:00',2.63),('9303','2014-03-16','15:05:00',2.44),('9303','2014-03-16','15:10:00',2.25),('9303','2014-03-16','15:15:00',2.14),('9303','2014-03-16','15:20:00',1.79),('9303','2014-03-16','15:25:00',2.01),('9303','2014-03-16','15:30:00',1.88),('9303','2014-03-16','15:35:00',1.64),('9303','2014-03-16','15:40:00',1.29),('9303','2014-03-16','15:45:00',1.27),('9303','2014-03-16','15:50:00',1.43),('9303','2014-03-16','15:55:00',1.31),('9303','2014-03-16','16:00:00',1.16),('9303','2014-03-16','16:05:00',1.35),('9303','2014-03-16','16:10:00',1.39),('9303','2014-03-16','16:15:00',1.34),('9303','2014-03-16','16:20:00',1.2),('9303','2014-03-16','16:25:00',1.23),('9303','2014-03-16','16:30:00',1.2),('9303','2014-03-16','16:35:00',1.08),('9303','2014-03-15','08:00:00',1.03),('9303','2014-03-15','08:05:00',1.13),('9303','2014-03-15','08:10:00',1.2),('9303','2014-03-15','08:15:00',1.3),('9303','2014-03-15','08:20:00',1.38),('9303','2014-03-15','08:25:00',1.46),('9303','2014-03-15','08:30:00',1.53),('9303','2014-03-15','08:35:00',1.6),('9303','2014-03-15','08:40:00',1.66),('9303','2014-03-15','08:45:00',1.73),('9303','2014-03-15','08:50:00',1.82),('9303','2014-03-15','08:55:00',1.88),('9303','2014-03-15','09:00:00',1.95),('9303','2014-03-15','09:05:00',2.04),('9303','2014-03-15','09:10:00',2.12),('9303','2014-03-15','09:15:00',2.2),('9303','2014-03-15','09:20:00',2.27),('9303','2014-03-15','09:25:00',2.34),('9303','2014-03-15','09:30:00',2.39),('9303','2014-03-15','09:35:00',2.44),('9303','2014-03-15','09:40:00',2.5),('9303','2014-03-15','09:45:00',2.53),('9303','2014-03-15','09:50:00',2.58),('9303','2014-03-15','09:55:00',2.62),('9303','2014-03-15','10:00:00',2.68),('9303','2014-03-15','10:05:00',2.72),('9303','2014-03-15','10:10:00',2.78),('9303','2014-03-15','10:15:00',2.85),('9303','2014-03-15','10:20:00',2.9),('9303','2014-03-15','10:25:00',2.99),('9303','2014-03-15','10:30:00',3.02),('9303','2014-03-15','10:35:00',3.02),('9303','2014-03-15','10:40:00',3.06),('9303','2014-03-15','10:45:00',3.09),('9303','2014-03-15','10:50:00',3.05),('9303','2014-03-15','10:55:00',3.09),('9303','2014-03-15','11:00:00',3.07),('9303','2014-03-15','11:05:00',3.13),('9303','2014-03-15','11:10:00',3.18),('9303','2014-03-15','11:15:00',3.3),('9303','2014-03-15','11:20:00',3.39),('9303','2014-03-15','11:25:00',3.35),('9303','2014-03-15','11:30:00',3.44),('9303','2014-03-15','11:35:00',3.42),('9303','2014-03-15','11:40:00',3.44),('9303','2014-03-15','11:45:00',3.46),('9303','2014-03-15','11:50:00',3.46),('9303','2014-03-15','11:55:00',3.51),('9303','2014-03-15','12:00:00',3.52),('9303','2014-03-15','12:05:00',3.47),('9303','2014-03-15','12:10:00',3.49),('9303','2014-03-15','12:15:00',3.54),('9303','2014-03-15','12:20:00',3.47),('9303','2014-03-15','12:25:00',3.46),('9303','2014-03-15','12:30:00',3.49),('9303','2014-03-15','12:35:00',3.57),('9303','2014-03-15','12:40:00',3.6),('9303','2014-03-15','12:45:00',3.56),('9303','2014-03-15','12:50:00',3.53),('9303','2014-03-15','12:55:00',3.5),('9303','2014-03-15','13:00:00',3.49),('9303','2014-03-15','13:05:00',3.52),('9303','2014-03-15','13:10:00',3.52),('9303','2014-03-15','13:15:00',3.48),('9303','2014-03-15','13:20:00',3.45),('9303','2014-03-15','13:25:00',3.45),('9303','2014-03-15','13:30:00',3.45),('9303','2014-03-15','13:35:00',3.42),('9303','2014-03-15','13:40:00',3.41),('9303','2014-03-15','13:45:00',3.36),('9303','2014-03-15','13:50:00',3.35),('9303','2014-03-15','13:55:00',3.3),('9303','2014-03-15','14:00:00',3.28),('9303','2014-03-15','14:05:00',3.27),('9303','2014-03-15','14:10:00',3.22),('9303','2014-03-15','14:15:00',3.17),('9303','2014-03-15','14:20:00',3.11),('9303','2014-03-15','14:25:00',3.05),('9303','2014-03-15','14:30:00',3.01),('9303','2014-03-15','14:35:00',2.94),('9303','2014-03-15','14:40:00',2.87),('9303','2014-03-15','14:45:00',2.82),('9303','2014-03-15','14:50:00',2.74),('9303','2014-03-15','14:55:00',2.69),('9303','2014-03-15','15:00:00',2.62),('9303','2014-03-15','15:05:00',2.56),('9303','2014-03-15','15:10:00',2.49),('9303','2014-03-15','15:15:00',2.41),('9303','2014-03-15','15:20:00',2.32),('9303','2014-03-15','15:25:00',2.24),('9303','2014-03-15','15:30:00',2.17),('9303','2014-03-15','15:35:00',2.05),('9303','2014-03-15','15:40:00',1.93),('9303','2014-03-15','15:45:00',1.84),('9303','2014-03-15','15:50:00',1.77),('9303','2014-03-15','15:55:00',1.69),('9303','2014-03-15','16:00:00',1.58),('9303','2014-03-15','16:05:00',1.45),('9303','2014-03-15','16:10:00',1.34),('9303','2014-03-15','16:15:00',1.25),('9303','2014-03-15','16:20:00',1.17),('9303','2014-03-15','16:25:00',1.09),('9303','2014-03-15','16:30:00',1.01),('9303','2014-03-14','08:20:00',1.09),('9303','2014-03-14','08:25:00',1.13),('9303','2014-03-14','08:30:00',1.22),('9303','2014-03-14','08:35:00',1.23),('9303','2014-03-14','08:40:00',1.21),('9303','2014-03-14','08:45:00',1.04),('9303','2014-03-14','09:00:00',1.05),('9303','2014-03-14','09:05:00',1.2),('9303','2014-03-14','09:10:00',1.38),('9303','2014-03-14','09:15:00',1.42),('9303','2014-03-14','09:20:00',1.38),('9303','2014-03-14','09:25:00',1.46),('9303','2014-03-14','09:30:00',1.46),('9303','2014-03-14','09:35:00',1.71),('9303','2014-03-14','09:40:00',2.19),('9303','2014-03-14','09:45:00',2.53),('9303','2014-03-14','09:50:00',2.98),('9303','2014-03-14','09:55:00',3.19),('9303','2014-03-14','10:00:00',3.32),('9303','2014-03-14','10:05:00',3.37),('9303','2014-03-14','10:10:00',3.32),('9303','2014-03-14','10:15:00',3.24),('9303','2014-03-14','10:20:00',3.17),('9303','2014-03-14','10:25:00',3.09),('9303','2014-03-14','10:30:00',3.04),('9303','2014-03-14','10:35:00',3.16),('9303','2014-03-14','10:40:00',3.32),('9303','2014-03-14','10:45:00',3.02),('9303','2014-03-14','10:50:00',1.93),('9303','2014-03-14','10:55:00',2.35),('9303','2014-03-14','11:00:00',3.19),('9303','2014-03-14','11:05:00',3.27),('9303','2014-03-14','11:10:00',3.54),('9303','2014-03-14','11:15:00',3.66),('9303','2014-03-14','11:20:00',3.54),('9303','2014-03-14','11:25:00',3.48),('9303','2014-03-14','11:30:00',3.46),('9303','2014-03-14','11:35:00',3.54),('9303','2014-03-14','11:40:00',3.47),('9303','2014-03-14','11:45:00',3.48),('9303','2014-03-14','11:50:00',3.55),('9303','2014-03-14','11:55:00',3.61),('9303','2014-03-14','12:00:00',3.64),('9303','2014-03-14','12:05:00',3.57),('9303','2014-03-14','12:10:00',3.36),('9303','2014-03-14','12:15:00',3.3),('9303','2014-03-14','12:20:00',2.97),('9303','2014-03-14','12:25:00',2.37),('9303','2014-03-14','12:30:00',2.21),('9303','2014-03-14','12:35:00',1.83),('9303','2014-03-14','12:40:00',2.18),('9303','2014-03-14','12:45:00',2.25),('9303','2014-03-14','12:50:00',2.79),('9303','2014-03-14','12:55:00',2.85),('9303','2014-03-14','13:00:00',2.08),('9303','2014-03-14','13:05:00',1.74),('9303','2014-03-14','13:10:00',2.16),('9303','2014-03-14','13:15:00',2.5),('9303','2014-03-14','13:20:00',2.78),('9303','2014-03-14','13:25:00',2.58),('9303','2014-03-14','13:30:00',2.32),('9303','2014-03-14','13:35:00',2.09),('9303','2014-03-14','13:40:00',1.89),('9303','2014-03-14','13:45:00',1.98),('9303','2014-03-14','13:50:00',1.82),('9303','2014-03-14','13:55:00',1.88),('9303','2014-03-14','14:00:00',2.18),('9303','2014-03-14','14:05:00',2.45),('9303','2014-03-14','14:10:00',2.53),('9303','2014-03-14','14:15:00',2.68),('9303','2014-03-14','14:20:00',2.68),('9303','2014-03-14','14:25:00',2.76),('9303','2014-03-14','14:30:00',2.56),('9303','2014-03-14','14:35:00',2.38),('9303','2014-03-14','14:40:00',2.03),('9303','2014-03-14','14:45:00',1.62),('9303','2014-03-14','14:50:00',1.37),('9303','2014-03-14','14:55:00',1.26),('9303','2014-03-14','15:00:00',1.14),('9303','2014-03-14','15:05:00',1.13),('9303','2014-03-14','15:10:00',1.09),('9303','2014-03-14','15:15:00',1.1),('9303','2014-03-14','15:20:00',1.2),('9303','2014-03-14','15:25:00',1.3),('9303','2014-03-14','15:30:00',1.36),('9303','2014-03-14','15:35:00',1.47),('9303','2014-03-14','15:40:00',1.3),('9303','2014-03-14','15:45:00',1.14),('9303','2014-03-14','15:50:00',1.02),('9303','2014-03-14','15:55:00',1.04),('9303','2014-03-13','07:50:00',1.11),('9303','2014-03-13','07:55:00',1.22),('9303','2014-03-13','08:00:00',1.31),('9303','2014-03-13','08:05:00',1.42),('9303','2014-03-13','08:10:00',1.5),('9303','2014-03-13','08:15:00',1.58),('9303','2014-03-13','08:20:00',1.7),('9303','2014-03-13','08:25:00',1.78),('9303','2014-03-13','08:30:00',1.85),('9303','2014-03-13','08:35:00',1.95),('9303','2014-03-13','08:40:00',2.04),('9303','2014-03-13','08:45:00',2.12),('9303','2014-03-13','08:50:00',2.2),('9303','2014-03-13','08:55:00',2.28),('9303','2014-03-13','09:00:00',2.37),('9303','2014-03-13','09:05:00',2.43),('9303','2014-03-13','09:10:00',2.51),('9303','2014-03-13','09:15:00',2.57),('9303','2014-03-13','09:20:00',2.63),('9303','2014-03-13','09:25:00',2.7),('9303','2014-03-13','09:30:00',2.77),('9303','2014-03-13','09:35:00',2.82),('9303','2014-03-13','09:40:00',2.89),('9303','2014-03-13','09:45:00',2.96),('9303','2014-03-13','09:50:00',3.03),('9303','2014-03-13','09:55:00',3.09),('9303','2014-03-13','10:00:00',3.15),('9303','2014-03-13','10:05:00',3.18),('9303','2014-03-13','10:10:00',3.25),('9303','2014-03-13','10:15:00',3.28),('9303','2014-03-13','10:20:00',3.31),('9303','2014-03-13','10:25:00',3.34),('9303','2014-03-13','10:30:00',3.39),('9303','2014-03-13','10:35:00',3.42),('9303','2014-03-13','10:40:00',3.45),('9303','2014-03-13','10:45:00',3.48),('9303','2014-03-13','10:50:00',3.5),('9303','2014-03-13','10:55:00',3.53),('9303','2014-03-13','11:00:00',3.53),('9303','2014-03-13','11:05:00',3.58),('9303','2014-03-13','11:10:00',3.59),('9303','2014-03-13','11:15:00',3.63),('9303','2014-03-13','11:20:00',3.67),('9303','2014-03-13','11:25:00',3.67),('9303','2014-03-13','11:30:00',3.67),('9303','2014-03-13','11:35:00',3.66),('9303','2014-03-13','11:40:00',3.69),('9303','2014-03-13','11:45:00',3.71),('9303','2014-03-13','11:50:00',3.75),('9303','2014-03-13','11:55:00',3.78),('9303','2014-03-13','12:00:00',3.73),('9303','2014-03-13','12:05:00',3.74),('9303','2014-03-13','12:10:00',3.79),('9303','2014-03-13','12:15:00',3.75),('9303','2014-03-13','12:20:00',3.74),('9303','2014-03-13','12:25:00',3.73),('9303','2014-03-13','12:30:00',3.7),('9303','2014-03-13','12:35:00',3.69),('9303','2014-03-13','12:40:00',3.65),('9303','2014-03-13','12:45:00',3.65),('9303','2014-03-13','12:50:00',3.66),('9303','2014-03-13','12:55:00',3.6),('9303','2014-03-13','13:00:00',3.56),('9303','2014-03-13','13:05:00',3.56),('9303','2014-03-13','13:10:00',3.45),('9303','2014-03-13','13:15:00',3.5),('9303','2014-03-13','13:20:00',3.5),('9303','2014-03-13','13:25:00',3.5),('9303','2014-03-13','13:30:00',3.53),('9303','2014-03-13','13:35:00',3.5),('9303','2014-03-13','13:40:00',3.44),('9303','2014-03-13','13:45:00',3.39),('9303','2014-03-13','13:50:00',3.36),('9303','2014-03-13','13:55:00',3.3),('9303','2014-03-13','14:00:00',3.25),('9303','2014-03-13','14:05:00',3.2),('9303','2014-03-13','14:10:00',3.18),('9303','2014-03-13','14:15:00',3.14),('9303','2014-03-13','14:20:00',3.07),('9303','2014-03-13','14:25:00',3.02),('9303','2014-03-13','14:30:00',2.98),('9303','2014-03-13','14:35:00',2.94),('9303','2014-03-13','14:40:00',2.87),('9303','2014-03-13','14:45:00',2.81),('9303','2014-03-13','14:50:00',2.75),('9303','2014-03-13','14:55:00',2.67),('9303','2014-03-13','15:00:00',2.63),('9303','2014-03-13','15:05:00',2.55),('9303','2014-03-13','15:10:00',2.49),('9303','2014-03-13','15:15:00',2.43),('9303','2014-03-13','15:20:00',2.36),('9303','2014-03-13','15:25:00',2.29),('9303','2014-03-13','15:30:00',2.19),('9303','2014-03-13','15:35:00',2.06),('9303','2014-03-13','15:40:00',1.95),('9303','2014-03-13','15:45:00',1.87),('9303','2014-03-13','15:50:00',1.8),('9303','2014-03-13','15:55:00',1.72),('9303','2014-03-13','16:00:00',1.62),('9303','2014-03-13','16:05:00',1.51),('9303','2014-03-13','16:10:00',1.42),('9303','2014-03-13','16:15:00',1.33),('9303','2014-03-13','16:20:00',1.26),('9303','2014-03-13','16:25:00',1.19),('9303','2014-03-13','16:30:00',1.1),('9303','2014-03-13','16:35:00',1.02),('9303','2014-03-12','07:50:00',1.02),('9303','2014-03-12','07:55:00',1.13),('9303','2014-03-12','08:00:00',1.23),('9303','2014-03-12','08:05:00',1.32),('9303','2014-03-12','08:10:00',1.44),('9303','2014-03-12','08:15:00',1.54),('9303','2014-03-12','08:20:00',1.64),('9303','2014-03-12','08:25:00',1.75),('9303','2014-03-12','08:30:00',1.83),('9303','2014-03-12','08:35:00',1.93),('9303','2014-03-12','08:40:00',2.02),('9303','2014-03-12','08:45:00',2.1),('9303','2014-03-12','08:50:00',2.19),('9303','2014-03-12','08:55:00',2.25),('9303','2014-03-12','09:00:00',2.32),('9303','2014-03-12','09:05:00',2.4),('9303','2014-03-12','09:10:00',2.49),('9303','2014-03-12','09:15:00',2.56),('9303','2014-03-12','09:20:00',2.63),('9303','2014-03-12','09:25:00',2.69),('9303','2014-03-12','09:30:00',2.74),('9303','2014-03-12','09:35:00',2.82),('9303','2014-03-12','09:40:00',2.87),('9303','2014-03-12','09:45:00',2.92),('9303','2014-03-12','09:50:00',2.98),('9303','2014-03-12','09:55:00',3.05),('9303','2014-03-12','10:00:00',3.1),('9303','2014-03-12','10:05:00',3.16),('9303','2014-03-12','10:10:00',3.19),('9303','2014-03-12','10:15:00',3.25),('9303','2014-03-12','10:20:00',3.3),('9303','2014-03-12','10:25:00',3.34),('9303','2014-03-12','10:30:00',3.38),('9303','2014-03-12','10:35:00',3.44),('9303','2014-03-12','10:40:00',3.5),('9303','2014-03-12','10:45:00',3.56),('9303','2014-03-12','10:50:00',3.59),('9303','2014-03-12','10:55:00',3.62),('9303','2014-03-12','11:00:00',3.67),('9303','2014-03-12','11:05:00',3.7),('9303','2014-03-12','11:10:00',3.74),('9303','2014-03-12','11:15:00',3.76),('9303','2014-03-12','11:20:00',3.78),('9303','2014-03-12','11:25:00',3.78),('9303','2014-03-12','11:30:00',3.79),('9303','2014-03-12','11:35:00',3.82),('9303','2014-03-12','11:40:00',3.85),('9303','2014-03-12','11:45:00',3.85),('9303','2014-03-12','11:50:00',3.87),('9303','2014-03-12','11:55:00',3.87),('9303','2014-03-12','12:00:00',3.86),('9303','2014-03-12','12:05:00',3.86),('9303','2014-03-12','12:10:00',3.86),('9303','2014-03-12','12:15:00',3.86),('9303','2014-03-12','12:20:00',3.83),('9303','2014-03-12','12:25:00',3.83),('9303','2014-03-12','12:30:00',3.84),('9303','2014-03-12','12:35:00',3.82),('9303','2014-03-12','12:40:00',3.78),('9303','2014-03-12','12:45:00',3.81),('9303','2014-03-12','12:50:00',3.78),('9303','2014-03-12','12:55:00',3.74),('9303','2014-03-12','13:00:00',3.78),('9303','2014-03-12','13:05:00',3.71),('9303','2014-03-12','13:10:00',3.69),('9303','2014-03-12','13:15:00',3.69),('9303','2014-03-12','13:20:00',3.67),('9303','2014-03-12','13:25:00',3.61),('9303','2014-03-12','13:30:00',3.57),('9303','2014-03-12','13:35:00',3.54),('9303','2014-03-12','13:40:00',3.51),('9303','2014-03-12','13:45:00',3.47),('9303','2014-03-12','13:50:00',3.43),('9303','2014-03-12','13:55:00',3.38),('9303','2014-03-12','14:00:00',3.38),('9303','2014-03-12','14:05:00',3.35),('9303','2014-03-12','14:10:00',3.31),('9303','2014-03-12','14:15:00',3.24),('9303','2014-03-12','14:20:00',3.18),('9303','2014-03-12','14:25:00',3.11),('9303','2014-03-12','14:30:00',3.06),('9303','2014-03-12','14:35:00',2.97),('9303','2014-03-12','14:40:00',2.92),('9303','2014-03-12','14:45:00',2.79),('9303','2014-03-12','14:50:00',2.79),('9303','2014-03-12','14:55:00',2.62),('9303','2014-03-12','15:00:00',2.57),('9303','2014-03-12','15:05:00',2.52),('9303','2014-03-12','15:10:00',2.48),('9303','2014-03-12','15:15:00',2.36),('9303','2014-03-12','15:20:00',2.36),('9303','2014-03-12','15:25:00',2.25),('9303','2014-03-12','15:30:00',2.12),('9303','2014-03-12','15:35:00',2.03),('9303','2014-03-12','15:40:00',1.93),('9303','2014-03-12','15:45:00',1.86),('9303','2014-03-12','15:50:00',1.8),('9303','2014-03-12','15:55:00',1.72),('9303','2014-03-12','16:00:00',1.65),('9303','2014-03-12','16:05:00',1.52),('9303','2014-03-12','16:10:00',1.42),('9303','2014-03-12','16:15:00',1.35),('9303','2014-03-12','16:20:00',1.27),('9303','2014-03-12','16:25:00',1.18),('9303','2014-03-12','16:30:00',1.08),('9303','2014-03-12','16:35:00',1.01),('9303','2014-03-11','12:10:00',1.03),('9303','2014-03-11','12:15:00',1.15),('9303','2014-03-11','12:20:00',1.23),('9303','2014-03-11','12:25:00',1.11),('9303','2014-03-11','12:30:00',1.08),('9303','2014-03-11','12:35:00',1.15),('9303','2014-03-11','12:40:00',1.28),('9303','2014-03-11','12:45:00',1.24),('9303','2014-03-11','12:50:00',1.18),('9303','2014-03-11','12:55:00',1.07),('9303','2014-03-11','13:00:00',1),('9303','2014-03-11','13:05:00',1.16),('9303','2014-03-11','13:10:00',1.19),('9303','2014-03-11','13:15:00',1.18),('9303','2014-03-11','13:20:00',1.21),('9303','2014-03-11','13:25:00',1.02),('9303','2014-03-11','13:45:00',1.24),('9303','2014-03-11','13:50:00',1.47),('9303','2014-03-11','13:55:00',1.8),('9303','2014-03-11','14:00:00',1.84),('9303','2014-03-11','14:05:00',1.95),('9303','2014-03-11','14:10:00',2.31),('9303','2014-03-11','14:15:00',2.2),('9303','2014-03-11','14:20:00',1.91),('9303','2014-03-11','14:25:00',1.63),('9303','2014-03-11','14:30:00',1.26),('9303','2014-03-11','14:35:00',1.37),('9303','2014-03-11','14:40:00',1.35),('9303','2014-03-11','14:45:00',1.46),('9303','2014-03-11','14:50:00',1.3),('9303','2014-03-11','14:55:00',1.3),('9303','2014-03-11','15:00:00',1.5),('9303','2014-03-11','15:05:00',1.66),('9303','2014-03-11','15:10:00',1.71),('9303','2014-03-11','15:15:00',1.47),('9303','2014-03-11','15:20:00',1.48),('9303','2014-03-11','15:25:00',1.31),('9303','2014-03-11','15:30:00',1.23),('9303','2014-03-11','15:35:00',1.08),('9303','2014-03-11','15:40:00',1.06),('9303','2014-03-10','10:15:00',1.08),('9303','2014-03-10','10:30:00',1.04),('9303','2014-03-10','10:35:00',1.12),('9303','2014-03-10','12:50:00',1.05),('9303','2014-03-10','12:55:00',1.12),('9303','2014-03-10','13:00:00',1.17),('9303','2014-03-10','13:05:00',1.21),('9303','2014-03-10','13:10:00',1.34),('9303','2014-03-10','13:15:00',1.47),('9303','2014-03-10','13:20:00',1.43),('9303','2014-03-10','13:25:00',1.23),('9303','2014-03-10','13:30:00',1.02),('9303','2014-03-10','13:50:00',1.14),('9303','2014-03-10','13:55:00',1.06),('9303','2014-03-10','14:00:00',1.1),('9303','2014-03-10','14:05:00',1.51),('9303','2014-03-10','14:10:00',2.28),('9303','2014-03-10','14:15:00',3.13),('9303','2014-03-10','14:20:00',2.12),('9303','2014-03-10','14:25:00',1.59),('9303','2014-03-10','14:30:00',1.21),('9303','2014-03-10','14:35:00',2.03),('9303','2014-03-10','14:40:00',2.5),('9303','2014-03-10','14:45:00',2.39),('9303','2014-03-10','14:50:00',2.3),('9303','2014-03-10','14:55:00',1.34),('9303','2014-03-10','15:00:00',1.43),('9303','2014-03-10','15:05:00',1.17),('9303','2014-03-10','15:15:00',1.25),('9303','2014-03-10','15:20:00',2.13),('9303','2014-03-10','15:25:00',1.92),('9303','2014-03-10','15:30:00',1.47),('9303','2014-03-10','16:25:00',1.01),('9303','2014-03-10','16:30:00',1.11),('9303','2014-03-09','07:55:00',1.01),('9303','2014-03-09','08:00:00',1.12),('9303','2014-03-09','08:05:00',1.22),('9303','2014-03-09','08:10:00',1.36),('9303','2014-03-09','08:15:00',1.46),('9303','2014-03-09','08:20:00',1.48),('9303','2014-03-09','08:25:00',1.33),('9303','2014-03-09','08:30:00',1.32),('9303','2014-03-09','08:35:00',1.14),('9303','2014-03-09','08:40:00',1.35),('9303','2014-03-09','08:45:00',1.15),('9303','2014-03-09','08:50:00',1.09),('9303','2014-03-09','08:55:00',1.64),('9303','2014-03-09','09:00:00',2.08),('9303','2014-03-09','09:05:00',1.32),('9303','2014-03-09','09:15:00',2.12),('9303','2014-03-09','09:20:00',2.54),('9303','2014-03-09','09:25:00',2.76),('9303','2014-03-09','09:30:00',2.73),('9303','2014-03-09','09:35:00',3.03),('9303','2014-03-09','09:40:00',3.13),('9303','2014-03-09','09:45:00',3.2),('9303','2014-03-09','09:50:00',3.21),('9303','2014-03-09','09:55:00',3.16),('9303','2014-03-09','10:00:00',3.19),('9303','2014-03-09','10:05:00',3.24),('9303','2014-03-09','10:10:00',3.33),('9303','2014-03-09','10:15:00',3.33),('9303','2014-03-09','10:20:00',3.22),('9303','2014-03-09','10:25:00',3.11),('9303','2014-03-09','10:30:00',3.45),('9303','2014-03-09','10:35:00',3.49),('9303','2014-03-09','10:40:00',3.55),('9303','2014-03-09','10:45:00',3.59),('9303','2014-03-09','10:50:00',3.67),('9303','2014-03-09','10:55:00',3.78),('9303','2014-03-09','11:00:00',4.04),('9303','2014-03-09','11:05:00',4.09),('9303','2014-03-09','11:10:00',4.25),('9303','2014-03-09','11:15:00',3.69),('9303','2014-03-09','11:20:00',3.3),('9303','2014-03-09','11:25:00',3.65),('9303','2014-03-09','11:30:00',2.32),('9303','2014-03-09','11:35:00',2.51),('9303','2014-03-09','11:40:00',3.28),('9303','2014-03-09','11:45:00',2.89),('9303','2014-03-09','11:50:00',3.06),('9303','2014-03-09','11:55:00',4.23),('9303','2014-03-09','12:00:00',4.52),('9303','2014-03-09','12:05:00',4.52),('9303','2014-03-09','12:10:00',4.48),('9303','2014-03-09','12:15:00',4.45),('9303','2014-03-09','12:20:00',4.41),('9303','2014-03-09','12:25:00',4.34),('9303','2014-03-09','12:30:00',4.37),('9303','2014-03-09','12:35:00',4.43),('9303','2014-03-09','12:40:00',4.2),('9303','2014-03-09','12:45:00',4.11),('9303','2014-03-09','12:50:00',4.15),('9303','2014-03-09','12:55:00',4.21),('9303','2014-03-09','13:00:00',4.27),('9303','2014-03-09','13:05:00',4.29),('9303','2014-03-09','13:10:00',4.25),('9303','2014-03-09','13:15:00',3.97),('9303','2014-03-09','13:20:00',3.88),('9303','2014-03-09','13:25:00',3.95),('9303','2014-03-09','13:30:00',3.73),('9303','2014-03-09','13:35:00',3.05),('9303','2014-03-09','13:45:00',2),('9303','2014-03-09','13:50:00',3.9),('9303','2014-03-09','13:55:00',2.31),('9303','2014-03-09','14:00:00',3.74),('9303','2014-03-09','14:05:00',3.58),('9303','2014-03-09','14:10:00',3.52),('9303','2014-03-09','14:15:00',3.39),('9303','2014-03-09','14:20:00',2.34),('9303','2014-03-09','14:25:00',2),('9303','2014-03-09','14:35:00',1.08),('9303','2014-03-09','14:40:00',1.59),('9303','2014-03-09','14:45:00',2.98),('9303','2014-03-09','14:50:00',2.78),('9303','2014-03-09','14:55:00',2.98),('9303','2014-03-09','15:00:00',2.89),('9303','2014-03-09','15:05:00',1.97),('9303','2014-03-09','15:10:00',2.73),('9303','2014-03-09','15:15:00',2.61),('9303','2014-03-09','15:20:00',2.57),('9303','2014-03-09','15:25:00',2.54),('9303','2014-03-09','15:30:00',2.45),('9303','2014-03-09','15:35:00',2.28),('9303','2014-03-09','15:40:00',2.1),('9303','2014-03-09','15:45:00',1.65),('9303','2014-03-09','15:55:00',1.63),('9303','2014-03-09','16:00:00',1.79),('9303','2014-03-09','16:05:00',1.58),('9303','2014-03-09','16:10:00',1.29),('9303','2014-03-09','16:20:00',1.14),('9303','2014-03-09','16:25:00',1.2),('9303','2014-03-09','16:30:00',1.11),('9303','2014-03-09','16:35:00',1.06),('9303','2014-03-09','16:40:00',1.03),('9303','2014-03-08','08:00:00',1.09),('9303','2014-03-08','08:05:00',1.2),('9303','2014-03-08','08:10:00',1.3),('9303','2014-03-08','08:15:00',1.41),('9303','2014-03-08','08:20:00',1.53),('9303','2014-03-08','08:25:00',1.64),('9303','2014-03-08','08:30:00',1.72),('9303','2014-03-08','08:35:00',1.83),('9303','2014-03-08','08:40:00',1.92),('9303','2014-03-08','08:45:00',1.99),('9303','2014-03-08','08:50:00',2.09),('9303','2014-03-08','08:55:00',2.19),('9303','2014-03-08','09:00:00',2.27),('9303','2014-03-08','09:05:00',2.35),('9303','2014-03-08','09:10:00',2.42),('9303','2014-03-08','09:15:00',2.49),('9303','2014-03-08','09:20:00',2.58),('9303','2014-03-08','09:25:00',2.65),('9303','2014-03-08','09:30:00',2.71),('9303','2014-03-08','09:35:00',2.78),('9303','2014-03-08','09:40:00',2.84),('9303','2014-03-08','09:45:00',2.9),('9303','2014-03-08','09:50:00',2.93),('9303','2014-03-08','09:55:00',2.99),('9303','2014-03-08','10:00:00',2.99),('9303','2014-03-08','10:05:00',3.03),('9303','2014-03-08','10:10:00',3.11),('9303','2014-03-08','10:15:00',3.16),('9303','2014-03-08','10:20:00',3.24),('9303','2014-03-08','10:25:00',3.27),('9303','2014-03-08','10:30:00',3.35),('9303','2014-03-08','10:35:00',3.4),('9303','2014-03-08','10:40:00',3.44),('9303','2014-03-08','10:45:00',3.48),('9303','2014-03-08','10:50:00',3.51),('9303','2014-03-08','10:55:00',3.52),('9303','2014-03-08','11:00:00',3.57),('9303','2014-03-08','11:05:00',3.61),('9303','2014-03-08','11:10:00',3.62),('9303','2014-03-08','11:15:00',3.65),('9303','2014-03-08','11:20:00',3.74),('9303','2014-03-08','11:25:00',3.86),('9303','2014-03-08','11:30:00',3.92),('9303','2014-03-08','11:35:00',2.14),('9303','2014-03-08','11:40:00',1.96),('9303','2014-03-08','11:45:00',1.27),('9303','2014-03-08','11:50:00',1.42),('9303','2014-03-08','11:55:00',3.88),('9303','2014-03-08','12:00:00',1.91),('9303','2014-03-08','12:10:00',1.06),('9303','2014-03-08','12:15:00',1.13),('9303','2014-03-08','12:20:00',1.29),('9303','2014-03-08','12:25:00',1.4),('9303','2014-03-08','12:30:00',1.56),('9303','2014-03-08','12:35:00',3.41),('9303','2014-03-08','12:40:00',1.83),('9303','2014-03-08','12:45:00',1.73),('9303','2014-03-08','12:50:00',1.73),('9303','2014-03-08','12:55:00',3.03),('9303','2014-03-08','13:00:00',1.75),('9303','2014-03-08','13:05:00',1.51),('9303','2014-03-08','13:10:00',1.28),('9303','2014-03-08','13:30:00',1.71),('9303','2014-03-08','13:35:00',1.52),('9303','2014-03-08','13:40:00',2.33),('9303','2014-03-08','13:45:00',2.68),('9303','2014-03-08','13:50:00',1.8),('9303','2014-03-08','13:55:00',1.28),('9303','2014-03-08','14:00:00',1.01),('9303','2014-03-08','15:20:00',1.51),('9303','2014-03-08','15:25:00',1.76),('9303','2014-03-08','15:30:00',1.08),('9303','2014-03-08','16:05:00',1.23),('9303','2014-03-08','16:35:00',1.14),('9303','2014-04-30','07:55:00',1.03),('9303','2014-04-30','08:00:00',1.13),('9303','2014-04-30','08:05:00',1.21),('9303','2014-04-30','08:10:00',1.36),('9303','2014-04-30','08:15:00',1.46),('9303','2014-04-30','08:20:00',1.54),('9303','2014-04-30','08:25:00',1.64),('9303','2014-04-30','08:30:00',1.73),('9303','2014-04-30','08:35:00',1.81),('9303','2014-04-30','08:40:00',1.89),('9303','2014-04-30','08:45:00',1.97),('9303','2014-04-30','08:50:00',1.79),('9303','2014-04-30','08:55:00',2.12),('9303','2014-04-30','09:00:00',2.32),('9303','2014-04-30','09:05:00',2.46),('9303','2014-04-30','09:10:00',2.75),('9303','2014-04-30','09:15:00',2.81),('9303','2014-04-30','09:20:00',1.14),('9303','2014-04-30','09:25:00',1.38),('9303','2014-04-30','09:30:00',1.95),('9303','2014-04-30','09:35:00',2.46),('9303','2014-04-30','09:40:00',2.37),('9303','2014-04-30','09:45:00',3.12),('9303','2014-04-30','09:50:00',1.72),('9303','2014-04-30','09:55:00',2.66),('9303','2014-04-30','10:00:00',3.44),('9303','2014-04-30','10:05:00',3.54),('9303','2014-04-30','10:10:00',2.2),('9303','2014-04-30','10:15:00',3.41),('9303','2014-04-30','10:20:00',1.83),('9303','2014-04-30','10:25:00',1.59),('9303','2014-04-30','10:30:00',1.57),('9303','2014-04-30','10:35:00',2.16),('9303','2014-04-30','10:40:00',1.98),('9303','2014-04-30','10:45:00',1.6),('9303','2014-04-30','10:50:00',1.32),('9303','2014-04-30','10:55:00',3.58),('9303','2014-04-30','11:00:00',2.63),('9303','2014-04-30','11:05:00',4.08),('9303','2014-04-30','11:10:00',2.82),('9303','2014-04-30','11:15:00',2.82),('9303','2014-04-30','11:20:00',1.62),('9303','2014-04-30','11:25:00',2.51),('9303','2014-04-30','11:30:00',1.94),('9303','2014-04-30','11:35:00',2.02),('9303','2014-04-30','11:40:00',1.91),('9303','2014-04-30','11:45:00',2.33),('9303','2014-04-30','11:50:00',3.58),('9303','2014-04-30','11:55:00',2.45),('9303','2014-04-30','12:00:00',2.54),('9303','2014-04-30','12:05:00',1.39),('9303','2014-04-30','12:10:00',1.27),('9303','2014-04-30','12:15:00',1.79),('9303','2014-04-30','12:20:00',1.95),('9303','2014-04-30','12:25:00',1.36),('9303','2014-04-30','12:30:00',1.28),('9303','2014-04-30','12:35:00',1.32),('9303','2014-04-30','12:40:00',1.19),('9303','2014-04-30','12:45:00',1.75),('9303','2014-04-30','12:50:00',1.54),('9303','2014-04-30','12:55:00',3.97),('9303','2014-04-30','13:00:00',3.92),('9303','2014-04-30','13:05:00',3.97),('9303','2014-04-30','13:10:00',4.45),('9303','2014-04-30','13:15:00',1.87),('9303','2014-04-30','13:20:00',1.83),('9303','2014-04-30','13:25:00',2.31),('9303','2014-04-30','13:30:00',1.79),('9303','2014-04-30','13:35:00',1.79),('9303','2014-04-30','13:40:00',3.53),('9303','2014-04-30','13:45:00',2.95),('9303','2014-04-30','13:50:00',4.06),('9303','2014-04-30','13:55:00',4.65),('9303','2014-04-30','14:00:00',1.84),('9303','2014-04-30','14:05:00',1.73),('9303','2014-04-30','14:10:00',1.55),('9303','2014-04-30','14:15:00',1.8),('9303','2014-04-30','14:20:00',2.95),('9303','2014-04-30','14:25:00',3.02),('9303','2014-04-30','14:30:00',3.86),('9303','2014-04-30','14:35:00',3.88),('9303','2014-04-30','14:40:00',2.02),('9303','2014-04-30','14:45:00',1.32),('9303','2014-04-30','14:50:00',1.58),('9303','2014-04-30','14:55:00',1.77),('9303','2014-04-30','15:00:00',1.43),('9303','2014-04-30','15:05:00',1.4),('9303','2014-04-30','15:10:00',1.35),('9303','2014-04-30','15:15:00',1.23),('9303','2014-04-30','15:20:00',1.19),('9303','2014-04-30','15:25:00',1.37),('9303','2014-04-30','15:30:00',1.71),('9303','2014-04-30','15:35:00',2.36),('9303','2014-04-30','15:40:00',3.91),('9303','2014-04-30','15:45:00',3.9),('9303','2014-04-30','15:50:00',2.51),('9303','2014-04-30','15:55:00',2.63),('9303','2014-04-30','16:00:00',1.33),('9303','2014-04-30','16:05:00',2.03),('9303','2014-04-30','16:10:00',1.74),('9303','2014-04-30','16:15:00',1.85),('9303','2014-04-30','16:20:00',1.37),('9303','2014-04-30','16:25:00',1.57),('9303','2014-04-30','16:30:00',2.06),('9303','2014-04-30','16:35:00',1.32),('9303','2014-04-30','16:40:00',1.98),('9303','2014-04-30','16:45:00',2.64),('9303','2014-04-30','16:50:00',2.9),('9303','2014-04-30','16:55:00',2.43),('9303','2014-04-30','17:00:00',1.29),('9303','2014-04-30','17:05:00',2.39),('9303','2014-04-30','17:10:00',1.33),('9303','2014-04-30','17:40:00',1.01),('9303','2014-03-07','11:45:00',1.61),('9303','2014-03-07','11:50:00',1.65),('9303','2014-03-07','11:55:00',3.6),('9303','2014-03-07','12:00:00',4.65),('9303','2014-03-07','12:05:00',2.86),('9303','2014-03-07','12:10:00',4.38),('9303','2014-03-07','12:15:00',4.19),('9303','2014-03-07','12:20:00',4.23),('9303','2014-03-07','12:25:00',4.17),('9303','2014-03-07','12:30:00',4.18),('9303','2014-03-07','12:35:00',4.1),('9303','2014-03-07','12:40:00',2.77),('9303','2014-03-07','12:45:00',1.88),('9303','2014-03-07','12:50:00',1.77),('9303','2014-03-07','13:05:00',1.61),('9303','2014-03-07','13:15:00',1.21),('9303','2014-03-07','13:20:00',1.89),('9303','2014-03-07','13:25:00',2.34),('9303','2014-03-07','13:30:00',1.97),('9303','2014-03-07','13:35:00',2.61),('9303','2014-03-07','13:40:00',2.85),('9303','2014-03-07','13:45:00',2.07),('9303','2014-03-07','13:50:00',1.36),('9303','2014-03-07','13:55:00',1.1),('9303','2014-03-07','14:00:00',1.05),('9303','2014-03-07','14:10:00',1.02),('9303','2014-03-07','14:15:00',1.01),('9303','2014-03-07','14:30:00',1),('9303','2014-03-07','14:35:00',1.03),('9303','2014-03-07','14:40:00',1.08),('9303','2014-03-07','14:45:00',1.05),('9303','2014-03-07','14:50:00',1.36),('9303','2014-03-07','14:55:00',2.15),('9303','2014-03-07','15:00:00',2.62),('9303','2014-03-07','15:05:00',2.91),('9303','2014-03-07','15:10:00',2.98),('9303','2014-03-07','15:15:00',3.04),('9303','2014-03-07','15:20:00',3.16),('9303','2014-03-07','15:25:00',3.11),('9303','2014-03-07','15:30:00',2.97),('9303','2014-03-07','15:35:00',2.74),('9303','2014-03-07','15:40:00',2.51),('9303','2014-03-07','15:45:00',2.31),('9303','2014-03-07','15:50:00',1.46),('9303','2014-03-07','16:05:00',1.66),('9303','2014-03-07','16:10:00',1.67),('9303','2014-03-07','16:15:00',1.67),('9303','2014-03-07','16:20:00',1.53),('9303','2014-03-07','16:25:00',1.43),('9303','2014-03-07','16:30:00',1.28),('9303','2014-03-07','16:35:00',1.2),('9303','2014-03-07','16:40:00',1.21),('9303','2014-03-07','16:45:00',1.12),('9303','2014-03-07','16:50:00',1.03),('9303','2014-03-06','08:00:00',1.03),('9303','2014-03-06','08:10:00',1.18),('9303','2014-03-06','08:15:00',1.69),('9303','2014-03-06','08:20:00',1.34),('9303','2014-03-06','08:25:00',1.25),('9303','2014-03-06','08:45:00',1.01),('9303','2014-03-06','09:20:00',1.02),('9303','2014-03-06','09:35:00',1.12),('9303','2014-03-06','09:40:00',1.31),('9303','2014-03-06','09:45:00',1.58),('9303','2014-03-06','09:50:00',1.65),('9303','2014-03-06','09:55:00',1.8),('9303','2014-03-06','10:00:00',1.81),('9303','2014-03-06','10:05:00',2.24),('9303','2014-03-06','10:10:00',2.62),('9303','2014-03-06','10:15:00',3.01),('9303','2014-03-06','10:20:00',2.89),('9303','2014-03-06','10:25:00',1.96),('9303','2014-03-06','10:30:00',1.08),('9303','2014-03-06','10:35:00',1.27),('9303','2014-03-06','10:40:00',1.62),('9303','2014-03-06','10:45:00',1.13),('9303','2014-03-06','10:50:00',1.21),('9303','2014-03-06','10:55:00',1.58),('9303','2014-03-06','11:00:00',2.35),('9303','2014-03-06','11:05:00',3.3),('9303','2014-03-06','11:10:00',1.95),('9303','2014-03-06','11:15:00',2.55),('9303','2014-03-06','11:20:00',1.66),('9303','2014-03-06','11:25:00',1.61),('9303','2014-03-06','11:30:00',1.54),('9303','2014-03-06','11:35:00',1.18),('9303','2014-03-06','11:40:00',1.58),('9303','2014-03-06','11:45:00',3.86),('9303','2014-03-06','11:50:00',2.29),('9303','2014-03-06','11:55:00',2.84),('9303','2014-03-06','12:00:00',1.34),('9303','2014-03-06','12:05:00',3.08),('9303','2014-03-06','12:10:00',4.64),('9303','2014-03-06','12:15:00',4.43),('9303','2014-03-06','12:20:00',2.13),('9303','2014-03-06','12:25:00',4.25),('9303','2014-03-06','12:30:00',4.53),('9303','2014-03-06','12:35:00',3.36),('9303','2014-03-06','12:40:00',1.45),('9303','2014-03-06','12:45:00',1.07),('9303','2014-03-06','12:50:00',1.01),('9303','2014-03-06','12:55:00',1.19),('9303','2014-03-06','13:00:00',1.24),('9303','2014-03-06','13:05:00',1.27),('9303','2014-03-06','13:10:00',1.2),('9303','2014-03-06','13:15:00',1.41),('9303','2014-03-06','13:30:00',1.05),('9303','2014-03-06','13:35:00',1.04),('9303','2014-03-06','13:40:00',1.16),('9303','2014-03-06','14:20:00',1.08),('9303','2014-03-06','14:25:00',1.02),('9303','2014-03-06','14:35:00',1.47),('9303','2014-03-06','15:05:00',1.05),('9303','2014-03-06','15:10:00',1.19),('9303','2014-03-06','16:25:00',1.13),('9303','2014-03-06','16:30:00',1.03),('9303','2014-03-05','07:45:00',1.05),('9303','2014-03-05','07:50:00',1.14),('9303','2014-03-05','07:55:00',1.25),('9303','2014-03-05','08:00:00',1.24),('9303','2014-03-05','08:05:00',1.34),('9303','2014-03-05','08:10:00',1.32),('9303','2014-03-05','08:15:00',1.18),('9303','2014-03-05','08:30:00',1.66),('9303','2014-03-05','08:35:00',2.18),('9303','2014-03-05','08:40:00',2.16),('9303','2014-03-05','08:45:00',1.94),('9303','2014-03-05','09:00:00',2.5),('9303','2014-03-05','09:05:00',1.06),('9303','2014-03-05','09:10:00',1.29),('9303','2014-03-05','09:15:00',2.32),('9303','2014-03-05','09:20:00',2.7),('9303','2014-03-05','09:25:00',2.7),('9303','2014-03-05','09:30:00',2.75),('9303','2014-03-05','09:35:00',2.83),('9303','2014-03-05','09:40:00',2.9),('9303','2014-03-05','09:45:00',2.94),('9303','2014-03-05','09:50:00',2.93),('9303','2014-03-05','09:55:00',3),('9303','2014-03-05','10:00:00',3),('9303','2014-03-05','10:05:00',3.05),('9303','2014-03-05','10:10:00',3.08),('9303','2014-03-05','10:15:00',3.11),('9303','2014-03-05','10:20:00',3.17),('9303','2014-03-05','10:25:00',3.18),('9303','2014-03-05','10:30:00',3.24),('9303','2014-03-05','10:35:00',3.24),('9303','2014-03-05','10:40:00',3.32),('9303','2014-03-05','10:45:00',3.35),('9303','2014-03-05','10:50:00',3.37),('9303','2014-03-05','10:55:00',3.42),('9303','2014-03-05','11:00:00',3.48),('9303','2014-03-05','11:05:00',3.57),('9303','2014-03-05','11:10:00',3.58),('9303','2014-03-05','11:15:00',3.66),('9303','2014-03-05','11:20:00',3.68),('9303','2014-03-05','11:25:00',3.71),('9303','2014-03-05','11:30:00',3.81),('9303','2014-03-05','11:35:00',3.94),('9303','2014-03-05','11:40:00',3.89),('9303','2014-03-05','11:45:00',3.93),('9303','2014-03-05','11:50:00',3.82),('9303','2014-03-05','11:55:00',3.37),('9303','2014-03-05','12:00:00',3.39),('9303','2014-03-05','12:05:00',2.59),('9303','2014-03-05','12:10:00',1.47),('9303','2014-03-05','12:30:00',1.16),('9303','2014-03-05','12:35:00',1.33),('9303','2014-03-05','12:40:00',1.31),('9303','2014-03-05','12:45:00',1.23),('9303','2014-03-05','12:50:00',1.54),('9303','2014-03-05','12:55:00',2.06),('9303','2014-03-05','13:00:00',2.05),('9303','2014-03-05','13:05:00',3.09),('9303','2014-03-05','13:10:00',3.76),('9303','2014-03-05','13:15:00',2.43),('9303','2014-03-05','13:20:00',2.5),('9303','2014-03-05','13:25:00',2.12),('9303','2014-03-05','13:30:00',1.15),('9303','2014-03-05','13:35:00',1.26),('9303','2014-03-05','13:40:00',1.45),('9303','2014-03-05','13:45:00',1.33),('9303','2014-03-05','13:50:00',1.13),('9303','2014-03-05','13:55:00',1.07),('9303','2014-03-05','14:05:00',1),('9303','2014-03-05','14:10:00',1.03),('9303','2014-03-05','14:15:00',1.14),('9303','2014-03-05','14:20:00',1.19),('9303','2014-03-05','14:25:00',1.3),('9303','2014-03-05','14:30:00',1.39),('9303','2014-03-05','14:35:00',1.15),('9303','2014-03-05','14:40:00',1.37),('9303','2014-03-05','14:45:00',1.75),('9303','2014-03-05','14:50:00',1.45),('9303','2014-03-05','14:55:00',1.23),('9303','2014-03-05','15:35:00',1.11),('9303','2014-03-05','15:40:00',1.7),('9303','2014-03-05','15:45:00',1.79),('9303','2014-03-05','15:50:00',1.17),('9303','2014-03-05','15:55:00',2.07),('9303','2014-03-05','16:00:00',2.59),('9303','2014-03-05','16:05:00',2.31),('9303','2014-03-05','16:10:00',1.8),('9303','2014-03-05','16:15:00',1.11),('9303','2014-03-04','09:10:00',1.49),('9303','2014-03-04','09:15:00',2),('9303','2014-03-04','09:20:00',2.54),('9303','2014-03-04','09:40:00',1.06),('9303','2014-03-04','09:45:00',1.26),('9303','2014-03-04','09:55:00',1.36),('9303','2014-03-04','10:00:00',1.33),('9303','2014-03-04','10:25:00',2.04),('9303','2014-03-04','10:30:00',1.89),('9303','2014-03-04','10:35:00',2.73),('9303','2014-03-04','10:40:00',3.9),('9303','2014-03-04','10:45:00',3.88),('9303','2014-03-04','10:50:00',1.46),('9303','2014-03-04','10:55:00',2.59),('9303','2014-03-04','11:00:00',3.03),('9303','2014-03-04','11:05:00',1.98),('9303','2014-03-04','11:10:00',3.4),('9303','2014-03-04','11:15:00',4.49),('9303','2014-03-04','11:20:00',3.14),('9303','2014-03-04','11:45:00',1.58),('9303','2014-03-04','11:50:00',3.74),('9303','2014-03-04','11:55:00',3.75),('9303','2014-03-04','12:00:00',3.86),('9303','2014-03-04','12:05:00',3.83),('9303','2014-03-04','12:10:00',3.78),('9303','2014-03-04','12:15:00',3.75),('9303','2014-03-04','12:20:00',3.8),('9303','2014-03-04','12:25:00',3.83),('9303','2014-03-04','12:30:00',3.8),('9303','2014-03-04','12:35:00',3.77),('9303','2014-03-04','12:40:00',3.78),('9303','2014-03-04','12:45:00',2.89),('9303','2014-03-04','12:50:00',3.74),('9303','2014-03-04','12:55:00',2.56),('9303','2014-03-04','13:00:00',3.57),('9303','2014-03-04','13:05:00',2.97),('9303','2014-03-04','13:10:00',3.92),('9303','2014-03-04','13:15:00',3.16),('9303','2014-03-04','13:20:00',1.53),('9303','2014-03-04','13:50:00',1.04),('9303','2014-03-04','13:55:00',1.15),('9303','2014-03-04','14:05:00',1.37),('9303','2014-03-04','14:10:00',3.11),('9303','2014-03-04','14:15:00',3),('9303','2014-03-04','14:20:00',2.1),('9303','2014-03-04','14:25:00',3.57),('9303','2014-03-04','14:30:00',3.24),('9303','2014-03-04','14:35:00',3.12),('9303','2014-03-04','14:40:00',3.05),('9303','2014-03-04','14:45:00',2.82),('9303','2014-03-04','14:50:00',3.1),('9303','2014-03-04','14:55:00',2.11),('9303','2014-03-04','15:00:00',3.14),('9303','2014-03-04','15:05:00',2.85),('9303','2014-03-04','15:10:00',2.69),('9303','2014-03-04','15:15:00',2.44),('9303','2014-03-04','15:20:00',1.68),('9303','2014-03-04','15:25:00',1.89),('9303','2014-03-04','15:35:00',2.45),('9303','2014-03-04','15:40:00',2.34),('9303','2014-03-04','15:45:00',2.14),('9303','2014-03-04','16:25:00',1.1),('9303','2014-03-03','08:10:00',1.24),('9303','2014-03-03','08:15:00',1.38),('9303','2014-03-03','08:20:00',1.46),('9303','2014-03-03','08:25:00',1.55),('9303','2014-03-03','08:30:00',1.66),('9303','2014-03-03','08:35:00',1.73),('9303','2014-03-03','08:40:00',1.87),('9303','2014-03-03','08:45:00',1.94),('9303','2014-03-03','08:50:00',1.91),('9303','2014-03-03','08:55:00',2.21),('9303','2014-03-03','09:00:00',2.26),('9303','2014-03-03','09:05:00',2.3),('9303','2014-03-03','09:10:00',2.2),('9303','2014-03-03','09:15:00',2.23),('9303','2014-03-03','09:20:00',2.43),('9303','2014-03-03','09:25:00',2.58),('9303','2014-03-03','09:30:00',2.48),('9303','2014-03-03','09:35:00',2.22),('9303','2014-03-03','09:40:00',2.12),('9303','2014-03-03','09:45:00',2.12),('9303','2014-03-03','09:50:00',2.17),('9303','2014-03-03','09:55:00',2.52),('9303','2014-03-03','10:00:00',2.78),('9303','2014-03-03','10:05:00',2.94),('9303','2014-03-03','10:10:00',2.89),('9303','2014-03-03','10:15:00',2.95),('9303','2014-03-03','10:20:00',3),('9303','2014-03-03','10:25:00',3.03),('9303','2014-03-03','10:30:00',3.09),('9303','2014-03-03','10:35:00',3.12),('9303','2014-03-03','10:40:00',3.14),('9303','2014-03-03','10:45:00',3.17),('9303','2014-03-03','10:50:00',3.18),('9303','2014-03-03','10:55:00',3.25),('9303','2014-03-03','11:00:00',3.25),('9303','2014-03-03','11:05:00',3.3),('9303','2014-03-03','11:10:00',3.39),('9303','2014-03-03','11:15:00',3.34),('9303','2014-03-03','11:20:00',3.42),('9303','2014-03-03','11:25:00',3.46),('9303','2014-03-03','11:30:00',3.48),('9303','2014-03-03','11:35:00',3.47),('9303','2014-03-03','11:40:00',3.53),('9303','2014-03-03','11:45:00',3.59),('9303','2014-03-03','11:50:00',3.69),('9303','2014-03-03','11:55:00',3.67),('9303','2014-03-03','12:00:00',3.66),('9303','2014-03-03','12:05:00',3.72),('9303','2014-03-03','12:10:00',3.65),('9303','2014-03-03','12:15:00',3.65),('9303','2014-03-03','12:20:00',3.72),('9303','2014-03-03','12:25:00',3.72),('9303','2014-03-03','12:30:00',3.72),('9303','2014-03-03','12:35:00',3.76),('9303','2014-03-03','12:40:00',3.78),('9303','2014-03-03','12:45:00',3.75),('9303','2014-03-03','12:50:00',3.83),('9303','2014-03-03','12:55:00',3.81),('9303','2014-03-03','13:00:00',3.78),('9303','2014-03-03','13:05:00',3.69),('9303','2014-03-03','13:10:00',3.69),('9303','2014-03-03','13:15:00',3.66),('9303','2014-03-03','13:20:00',3.64),('9303','2014-03-03','13:25:00',3.63),('9303','2014-03-03','13:30:00',3.63),('9303','2014-03-03','13:35:00',3.59),('9303','2014-03-03','13:40:00',3.52),('9303','2014-03-03','13:45:00',3.51),('9303','2014-03-03','13:50:00',3.49),('9303','2014-03-03','13:55:00',3.4),('9303','2014-03-03','14:00:00',3.35),('9303','2014-03-03','14:05:00',3.33),('9303','2014-03-03','14:10:00',3.41),('9303','2014-03-03','14:15:00',3.36),('9303','2014-03-03','14:20:00',3.26),('9303','2014-03-03','14:25:00',3.03),('9303','2014-03-03','14:30:00',3.12),('9303','2014-03-03','14:35:00',3.06),('9303','2014-03-03','14:40:00',2.99),('9303','2014-03-03','14:45:00',2.89),('9303','2014-03-03','14:50:00',2.86),('9303','2014-03-03','14:55:00',2.79),('9303','2014-03-03','15:00:00',2.8),('9303','2014-03-03','15:05:00',2.68),('9303','2014-03-03','15:10:00',2.65),('9303','2014-03-03','15:15:00',2.54),('9303','2014-03-03','15:20:00',2.5),('9303','2014-03-03','15:25:00',2.42),('9303','2014-03-03','15:30:00',2.28),('9303','2014-03-03','15:35:00',2.17),('9303','2014-03-03','15:40:00',2.05),('9303','2014-03-03','15:45:00',1.97),('9303','2014-03-03','15:50:00',1.89),('9303','2014-03-03','15:55:00',1.8),('9303','2014-03-03','16:00:00',1.67),('9303','2014-03-03','16:05:00',1.58),('9303','2014-03-03','16:10:00',1.49),('9303','2014-03-03','16:15:00',1.4),('9303','2014-03-03','16:20:00',1.33),('9303','2014-03-03','16:25:00',1.22),('9303','2014-03-03','16:30:00',1.11),('9303','2014-03-03','16:35:00',1.01),('9303','2014-03-02','08:00:00',1.12),('9303','2014-03-02','08:05:00',1.23),('9303','2014-03-02','08:10:00',1.76),('9303','2014-03-02','08:15:00',1.79),('9303','2014-03-02','08:20:00',1.73),('9303','2014-03-02','08:25:00',1.6),('9303','2014-03-02','08:30:00',1.53),('9303','2014-03-02','08:35:00',1.7),('9303','2014-03-02','08:40:00',1.83),('9303','2014-03-02','08:45:00',1.94),('9303','2014-03-02','08:50:00',2.05),('9303','2014-03-02','08:55:00',2.15),('9303','2014-03-02','09:00:00',2.24),('9303','2014-03-02','09:05:00',2.32),('9303','2014-03-02','09:10:00',2.44),('9303','2014-03-02','09:15:00',2.54),('9303','2014-03-02','09:20:00',1.91),('9303','2014-03-02','09:25:00',2.5),('9303','2014-03-02','09:30:00',2.87),('9303','2014-03-02','09:35:00',2.88),('9303','2014-03-02','09:40:00',2.43),('9303','2014-03-02','09:45:00',1.19),('9303','2014-03-02','10:00:00',1.28),('9303','2014-03-02','10:05:00',1.42),('9303','2014-03-02','10:10:00',1.38),('9303','2014-03-02','10:15:00',1.15),('9303','2014-03-02','10:20:00',1.16),('9303','2014-03-02','10:25:00',1.29),('9303','2014-03-02','10:30:00',1.42),('9303','2014-03-02','10:35:00',1.88),('9303','2014-03-02','10:40:00',3.27),('9303','2014-03-02','10:45:00',1.4),('9303','2014-03-02','10:50:00',1.01),('9303','2014-03-02','10:55:00',1.16),('9303','2014-03-02','11:00:00',1.79),('9303','2014-03-02','11:05:00',3.62),('9303','2014-03-02','11:10:00',1.52),('9303','2014-03-02','11:15:00',1.13),('9303','2014-03-02','11:20:00',1.45),('9303','2014-03-02','11:25:00',1.87),('9303','2014-03-02','11:30:00',1.88),('9303','2014-03-02','11:35:00',2.62),('9303','2014-03-02','11:40:00',3.04),('9303','2014-03-02','11:45:00',3.14),('9303','2014-03-02','11:50:00',4.44),('9303','2014-03-02','11:55:00',4.27),('9303','2014-03-02','12:00:00',3.04),('9303','2014-03-02','12:05:00',1.96),('9303','2014-03-02','12:10:00',1.61),('9303','2014-03-02','12:15:00',2.9),('9303','2014-03-02','12:20:00',2.25),('9303','2014-03-02','12:25:00',1.85),('9303','2014-03-02','12:30:00',1.38),('9303','2014-03-02','12:35:00',1.08),('9303','2014-03-02','12:55:00',1.15),('9303','2014-03-02','13:00:00',1.37),('9303','2014-03-02','13:05:00',1.46),('9303','2014-03-02','13:10:00',1.47),('9303','2014-03-02','13:15:00',1.41),('9303','2014-03-02','13:20:00',1.34),('9303','2014-03-02','13:25:00',1.2),('9303','2014-03-02','13:30:00',1.06),('9303','2014-03-02','14:00:00',1.12),('9303','2014-03-02','14:05:00',1.27),('9303','2014-03-02','14:10:00',1.24),('9303','2014-03-02','14:15:00',1.2),('9303','2014-03-02','14:20:00',1.12),('9303','2014-03-02','14:25:00',1.12),('9303','2014-03-02','14:30:00',1.18),('9303','2014-03-02','14:35:00',1.18),('9303','2014-03-02','14:40:00',1.18),('9303','2014-03-02','14:45:00',1.24),('9303','2014-03-02','14:50:00',1.23),('9303','2014-03-02','14:55:00',1.2),('9303','2014-03-02','15:00:00',1.29),('9303','2014-03-02','15:05:00',1.34),('9303','2014-03-02','15:10:00',1.4),('9303','2014-03-02','15:15:00',1.33),('9303','2014-03-02','15:20:00',1.16),('9303','2014-03-02','15:25:00',1.4),('9303','2014-03-02','15:30:00',1.33),('9303','2014-03-02','15:35:00',1.24),('9303','2014-03-02','15:40:00',1.3),('9303','2014-03-02','15:45:00',1.16),('9303','2014-03-02','15:50:00',1.02),('9303','2014-02-28','08:00:00',1.15),('9303','2014-02-28','08:15:00',1.1),('9303','2014-02-28','08:20:00',1.75),('9303','2014-02-28','08:25:00',1.35),('9303','2014-02-28','08:35:00',1.44),('9303','2014-02-28','09:15:00',1),('9303','2014-02-28','09:20:00',1.02),('9303','2014-02-28','09:25:00',1.13),('9303','2014-02-28','09:30:00',1.73),('9303','2014-02-28','09:35:00',1.01),('9303','2014-02-28','09:40:00',2.11),('9303','2014-02-28','09:45:00',2.78),('9303','2014-02-28','09:50:00',3.39),('9303','2014-02-28','09:55:00',2.58),('9303','2014-02-28','10:00:00',1.17),('9303','2014-02-28','10:10:00',1.4),('9303','2014-02-28','10:15:00',1.14),('9303','2014-02-28','10:20:00',1.56),('9303','2014-02-28','10:25:00',2.72),('9303','2014-02-28','10:30:00',3.43),('9303','2014-02-28','10:35:00',2.18),('9303','2014-02-28','10:40:00',1.16),('9303','2014-02-28','11:20:00',1.23),('9303','2014-02-28','11:25:00',1.3),('9303','2014-02-28','11:30:00',1.16),('9303','2014-02-28','11:55:00',1),('9303','2014-02-28','12:00:00',1.25),('9303','2014-02-28','12:05:00',1.74),('9303','2014-02-28','12:10:00',1.87),('9303','2014-02-28','12:25:00',1.84),('9303','2014-02-28','12:30:00',2.1),('9303','2014-02-28','12:35:00',3.16),('9303','2014-02-28','12:40:00',3.21),('9303','2014-02-28','12:45:00',1.18),('9303','2014-02-28','12:50:00',3.03),('9303','2014-02-28','12:55:00',2.37),('9303','2014-02-28','13:00:00',2.5),('9303','2014-02-28','13:05:00',1.57),('9303','2014-02-28','13:10:00',1.47),('9303','2014-02-28','13:15:00',1.06),('9303','2014-02-28','13:50:00',2.81),('9303','2014-02-28','13:55:00',2.46),('9303','2014-02-28','14:00:00',1.11),('9303','2014-02-28','14:20:00',1.23),('9303','2014-02-28','14:25:00',1.64),('9303','2014-02-28','14:30:00',1.69),('9303','2014-02-28','14:35:00',1.4),('9303','2014-02-28','14:40:00',1.21),('9303','2014-02-28','14:45:00',1.21),('9303','2014-02-28','14:50:00',1.28),('9303','2014-02-28','14:55:00',1.39),('9303','2014-02-28','15:00:00',2.14),('9303','2014-02-28','15:05:00',1.55),('9303','2014-02-28','15:25:00',2.47),('9303','2014-02-28','15:30:00',1.68),('9303','2014-02-28','15:35:00',1.93),('9303','2014-02-28','15:40:00',1.86),('9303','2014-02-28','16:15:00',1.65),('9303','2014-02-28','16:20:00',1.5),('9303','2014-02-28','16:40:00',1),('9303','2014-02-28','16:45:00',1.12),('9303','2014-02-27','10:40:00',1.08),('9303','2014-02-27','10:45:00',1.19),('9303','2014-02-27','10:50:00',1.23),('9303','2014-02-27','10:55:00',1.32),('9303','2014-02-27','11:00:00',1.52),('9303','2014-02-27','11:05:00',1.66),('9303','2014-02-27','11:10:00',1.52),('9303','2014-02-27','11:15:00',1.47),('9303','2014-02-27','11:20:00',1.36),('9303','2014-02-27','11:25:00',1.45),('9303','2014-02-27','11:30:00',1.83),('9303','2014-02-27','11:35:00',1.76),('9303','2014-02-27','11:40:00',1.44),('9303','2014-02-27','11:45:00',1.24),('9303','2014-02-27','11:50:00',1.17),('9303','2014-02-27','11:55:00',1.21),('9303','2014-02-27','12:00:00',1.19),('9303','2014-02-27','12:05:00',1.19),('9303','2014-02-27','12:10:00',1.09),('9303','2014-02-27','12:15:00',1.15),('9303','2014-02-27','12:20:00',1.22),('9303','2014-02-27','12:25:00',1.25),('9303','2014-02-27','12:30:00',1.17),('9303','2014-02-27','12:35:00',1.14),('9303','2014-02-27','12:40:00',1.1),('9303','2014-02-27','12:45:00',1.08),('9303','2014-02-27','12:50:00',1.06),('9303','2014-02-27','12:55:00',1.08),('9303','2014-02-27','13:00:00',1.14),('9303','2014-02-27','13:10:00',1.02),('9303','2014-02-27','13:15:00',1.16),('9303','2014-02-27','13:20:00',1.18),('9303','2014-02-27','13:25:00',1.27),('9303','2014-02-27','13:30:00',1.44),('9303','2014-02-27','13:35:00',1.58),('9303','2014-02-27','13:40:00',1.61),('9303','2014-02-27','13:45:00',1.6),('9303','2014-02-27','13:50:00',1.66),('9303','2014-02-27','13:55:00',1.84),('9303','2014-02-27','14:00:00',1.88),('9303','2014-02-27','14:05:00',1.64),('9303','2014-02-27','14:10:00',1.48),('9303','2014-02-27','14:15:00',1.31),('9303','2014-02-27','14:20:00',1.33),('9303','2014-02-27','14:25:00',1.34),('9303','2014-02-27','14:30:00',1.46),('9303','2014-02-27','14:35:00',1.42),('9303','2014-02-27','14:40:00',1.2),('9303','2014-02-27','14:45:00',1.24),('9303','2014-02-27','14:50:00',1.17),('9303','2014-02-27','14:55:00',1.04),('9303','2014-02-27','15:00:00',1.1),('9303','2014-02-27','15:05:00',1.06),('9303','2014-02-27','15:10:00',1.08),('9303','2014-02-27','15:15:00',1.25),('9303','2014-02-27','15:20:00',1.25),('9303','2014-02-27','15:25:00',1.25),('9303','2014-02-27','15:30:00',1.22),('9303','2014-02-27','15:35:00',1.22),('9303','2014-02-26','08:15:00',1),('9303','2014-02-26','08:20:00',1.11),('9303','2014-02-26','08:25:00',1.32),('9303','2014-02-26','08:30:00',1.43),('9303','2014-02-26','08:35:00',1.58),('9303','2014-02-26','08:40:00',1.69),('9303','2014-02-26','08:45:00',1.91),('9303','2014-02-26','08:50:00',1.75),('9303','2014-02-26','08:55:00',1.69),('9303','2014-02-26','09:00:00',1.97),('9303','2014-02-26','09:05:00',1.99),('9303','2014-02-26','09:10:00',2.09),('9303','2014-02-26','09:15:00',2.25),('9303','2014-02-26','09:20:00',2.32),('9303','2014-02-26','09:25:00',2.42),('9303','2014-02-26','09:30:00',2.02),('9303','2014-02-26','09:35:00',1.93),('9303','2014-02-26','09:40:00',1.81),('9303','2014-02-26','09:45:00',1.92),('9303','2014-02-26','09:50:00',1.47),('9303','2014-02-26','09:55:00',1.49),('9303','2014-02-26','10:00:00',1.28),('9303','2014-02-26','10:05:00',1.04),('9303','2014-02-26','12:00:00',1.08),('9303','2014-02-26','12:05:00',1.42),('9303','2014-02-26','12:10:00',1.33),('9303','2014-02-26','12:15:00',1.16),('9303','2014-02-26','12:25:00',1.2),('9303','2014-02-26','12:30:00',1.69),('9303','2014-02-26','12:35:00',2.22),('9303','2014-02-26','12:40:00',2.04),('9303','2014-02-26','12:45:00',3.05),('9303','2014-02-26','12:50:00',3.77),('9303','2014-02-26','12:55:00',3.61),('9303','2014-02-26','13:00:00',3.46),('9303','2014-02-26','13:05:00',2.37),('9303','2014-02-26','13:10:00',2.92),('9303','2014-02-26','13:15:00',2.86),('9303','2014-02-26','13:20:00',2.45),('9303','2014-02-26','13:25:00',2.07),('9303','2014-02-26','13:30:00',2.32),('9303','2014-02-26','13:35:00',1.79),('9303','2014-02-26','13:40:00',1.66),('9303','2014-02-26','13:45:00',1.79),('9303','2014-02-26','13:50:00',1.46),('9303','2014-02-26','13:55:00',1.2),('9303','2014-02-26','14:00:00',3.31),('9303','2014-02-26','14:05:00',2.32),('9303','2014-02-26','14:10:00',1.03),('9303','2014-02-26','14:15:00',1.06),('9303','2014-02-26','14:20:00',3.25),('9303','2014-02-26','14:25:00',3.1),('9303','2014-02-26','14:30:00',1.68),('9303','2014-02-26','14:35:00',1.31),('9303','2014-02-26','14:40:00',3.01),('9303','2014-02-26','14:45:00',2.74),('9303','2014-02-26','14:50:00',2.54),('9303','2014-02-26','14:55:00',2.95),('9303','2014-02-26','15:00:00',2.73),('9303','2014-02-26','15:05:00',2.56),('9303','2014-02-26','15:10:00',2.57),('9303','2014-02-26','15:15:00',2.25),('9303','2014-02-26','15:20:00',1.6),('9303','2014-02-26','15:35:00',1.55),('9303','2014-02-26','15:40:00',1.54),('9303','2014-02-26','15:45:00',1.28),('9303','2014-02-26','15:50:00',1.15),('9303','2014-02-26','15:55:00',1.34),('9303','2014-02-26','16:00:00',1.48),('9303','2014-02-26','16:05:00',1.06),('9303','2014-02-26','16:10:00',1.05),('9303','2014-04-29','09:55:00',1.05),('9303','2014-04-29','10:00:00',1.06),('9303','2014-04-29','10:05:00',1.51),('9303','2014-04-29','10:10:00',2.96),('9303','2014-04-29','10:15:00',3.48),('9303','2014-04-29','10:20:00',3.29),('9303','2014-04-29','10:25:00',3.74),('9303','2014-04-29','10:30:00',3.81),('9303','2014-04-29','10:35:00',3.77),('9303','2014-04-29','10:40:00',3.74),('9303','2014-04-29','10:45:00',3.73),('9303','2014-04-29','10:50:00',3.82),('9303','2014-04-29','10:55:00',3.63),('9303','2014-04-29','11:00:00',3.86),('9303','2014-04-29','11:05:00',3.82),('9303','2014-04-29','11:10:00',3.99),('9303','2014-04-29','11:15:00',3.78),('9303','2014-04-29','11:20:00',4.15),('9303','2014-04-29','11:25:00',4.19),('9303','2014-04-29','11:30:00',4.03),('9303','2014-04-29','11:35:00',3.69),('9303','2014-04-29','11:40:00',2.93),('9303','2014-04-29','11:45:00',1.72),('9303','2014-04-29','11:50:00',1.6),('9303','2014-04-29','11:55:00',1.09),('9303','2014-04-29','12:00:00',1.31),('9303','2014-04-29','12:05:00',1.85),('9303','2014-04-29','12:10:00',1.74),('9303','2014-04-29','12:15:00',1.74),('9303','2014-04-29','12:20:00',2.18),('9303','2014-04-29','12:25:00',3.07),('9303','2014-04-29','12:30:00',2.36),('9303','2014-04-29','12:35:00',1.52),('9303','2014-04-29','12:40:00',1.82),('9303','2014-04-29','12:45:00',2.76),('9303','2014-04-29','12:50:00',3.61),('9303','2014-04-29','12:55:00',1.7),('9303','2014-04-29','13:00:00',1.83),('9303','2014-04-29','13:05:00',1.74),('9303','2014-04-29','13:10:00',1.81),('9303','2014-04-29','13:15:00',2.98),('9303','2014-04-29','13:20:00',2.03),('9303','2014-04-29','13:25:00',3.28),('9303','2014-04-29','13:30:00',1.93),('9303','2014-04-29','13:35:00',2.33),('9303','2014-04-29','13:40:00',1.54),('9303','2014-04-29','13:45:00',1.96),('9303','2014-04-29','13:50:00',1.38),('9303','2014-04-29','16:20:00',1.01),('9303','2014-04-29','16:25:00',1.07),('9303','2014-04-29','17:05:00',1.14),('9303','2014-04-29','17:10:00',1.08),('9303','2014-04-29','17:25:00',1.66),('9303','2014-04-29','17:30:00',1.91),('9303','2014-04-29','17:35:00',1.34),('9303','2014-04-29','17:40:00',1.03),('9303','2014-04-29','17:45:00',1.71),('9303','2014-02-25','08:25:00',1.13),('9303','2014-02-25','08:30:00',1.36),('9303','2014-02-25','08:35:00',1.47),('9303','2014-02-25','08:40:00',1.58),('9303','2014-02-25','08:45:00',1.66),('9303','2014-02-25','08:50:00',1.76),('9303','2014-02-25','08:55:00',1.86),('9303','2014-02-25','09:00:00',1.96),('9303','2014-02-25','09:05:00',2.04),('9303','2014-02-25','09:10:00',2.13),('9303','2014-02-25','09:15:00',2.22),('9303','2014-02-25','09:20:00',2.29),('9303','2014-02-25','09:25:00',2.37),('9303','2014-02-25','09:30:00',2.43),('9303','2014-02-25','09:35:00',2.47),('9303','2014-02-25','09:40:00',2.53),('9303','2014-02-25','09:45:00',2.55),('9303','2014-02-25','09:50:00',2.58),('9303','2014-02-25','09:55:00',2.63),('9303','2014-02-25','10:00:00',2.67),('9303','2014-02-25','10:05:00',2.68),('9303','2014-02-25','10:10:00',2.72),('9303','2014-02-25','10:15:00',2.77),('9303','2014-02-25','10:20:00',2.79),('9303','2014-02-25','10:25:00',2.87),('9303','2014-02-25','10:30:00',2.89),('9303','2014-02-25','10:35:00',2.98),('9303','2014-02-25','10:40:00',2.96),('9303','2014-02-25','10:45:00',2.96),('9303','2014-02-25','10:50:00',3.03),('9303','2014-02-25','10:55:00',3.02),('9303','2014-02-25','11:00:00',3.08),('9303','2014-02-25','11:05:00',3.12),('9303','2014-02-25','11:10:00',3.09),('9303','2014-02-25','11:15:00',3.15),('9303','2014-02-25','11:20:00',3.12),('9303','2014-02-25','11:25:00',3.19),('9303','2014-02-25','11:30:00',3.21),('9303','2014-02-25','11:35:00',3.21),('9303','2014-02-25','11:40:00',3.15),('9303','2014-02-25','11:45:00',3.23),('9303','2014-02-25','11:50:00',3.23),('9303','2014-02-25','11:55:00',3.26),('9303','2014-02-25','12:00:00',3.28),('9303','2014-02-25','12:05:00',3.29),('9303','2014-02-25','12:10:00',3.31),('9303','2014-02-25','12:15:00',3.3),('9303','2014-02-25','12:20:00',3.27),('9303','2014-02-25','12:25:00',3.38),('9303','2014-02-25','12:30:00',3.39),('9303','2014-02-25','12:35:00',3.43),('9303','2014-02-25','12:40:00',3.47),('9303','2014-02-25','12:45:00',3.5),('9303','2014-02-25','12:50:00',3.44),('9303','2014-02-25','12:55:00',3.44),('9303','2014-02-25','13:00:00',3.45),('9303','2014-02-25','13:05:00',3.33),('9303','2014-02-25','13:10:00',3.27),('9303','2014-02-25','13:15:00',3.07),('9303','2014-02-25','13:20:00',2.24),('9303','2014-02-25','13:40:00',1.41),('9303','2014-02-25','13:45:00',1.23),('9303','2014-02-25','13:50:00',1.03),('9303','2014-02-25','13:55:00',1.13),('9303','2014-02-25','14:00:00',1.27),('9303','2014-02-25','14:05:00',1.22),('9303','2014-02-25','14:10:00',1.02),('9303','2014-02-25','14:15:00',1.09),('9303','2014-02-25','14:20:00',1.11),('9303','2014-02-25','14:25:00',1.77),('9303','2014-02-25','14:30:00',2.58),('9303','2014-02-25','14:35:00',2.13),('9303','2014-02-25','14:40:00',2.81),('9303','2014-02-25','14:45:00',2.82),('9303','2014-02-25','14:50:00',2.64),('9303','2014-02-25','14:55:00',2.47),('9303','2014-02-25','15:00:00',2.4),('9303','2014-02-25','15:05:00',2.36),('9303','2014-02-25','15:10:00',2.3),('9303','2014-02-25','15:15:00',2.26),('9303','2014-02-25','15:20:00',2.16),('9303','2014-02-25','15:25:00',1.82),('9303','2014-02-25','15:30:00',1.61),('9303','2014-02-25','15:35:00',1.47),('9303','2014-02-25','15:40:00',1.56),('9303','2014-02-24','08:10:00',1.04),('9303','2014-02-24','08:15:00',1.19),('9303','2014-02-24','08:20:00',1.34),('9303','2014-02-24','08:25:00',1.49),('9303','2014-02-24','08:30:00',1.49),('9303','2014-02-24','08:35:00',1.8),('9303','2014-02-24','08:40:00',1.78),('9303','2014-02-24','08:45:00',1.69),('9303','2014-02-24','08:50:00',1.91),('9303','2014-02-24','08:55:00',1.88),('9303','2014-02-24','09:00:00',1.94),('9303','2014-02-24','09:05:00',2.01),('9303','2014-02-24','09:10:00',2.09),('9303','2014-02-24','09:15:00',2.17),('9303','2014-02-24','09:20:00',2.25),('9303','2014-02-24','09:25:00',2.38),('9303','2014-02-24','09:30:00',2.45),('9303','2014-02-24','09:35:00',2.51),('9303','2014-02-24','09:40:00',2.54),('9303','2014-02-24','09:45:00',2.58),('9303','2014-02-24','09:50:00',2.61),('9303','2014-02-24','09:55:00',2.66),('9303','2014-02-24','10:00:00',2.69),('9303','2014-02-24','10:05:00',2.74),('9303','2014-02-24','10:10:00',2.8),('9303','2014-02-24','10:15:00',2.82),('9303','2014-02-24','10:20:00',2.84),('9303','2014-02-24','10:25:00',2.91),('9303','2014-02-24','10:30:00',2.94),('9303','2014-02-24','10:35:00',3),('9303','2014-02-24','10:40:00',3.04),('9303','2014-02-24','10:45:00',3.07),('9303','2014-02-24','10:50:00',3.14),('9303','2014-02-24','10:55:00',3.12),('9303','2014-02-24','11:00:00',3.16),('9303','2014-02-24','11:05:00',3.21),('9303','2014-02-24','11:10:00',3.23),('9303','2014-02-24','11:15:00',3.27),('9303','2014-02-24','11:20:00',3.3),('9303','2014-02-24','11:25:00',3.46),('9303','2014-02-24','11:30:00',3.65),('9303','2014-02-24','11:35:00',2.69),('9303','2014-02-24','11:40:00',2.44),('9303','2014-02-24','11:45:00',3.15),('9303','2014-02-24','11:50:00',3.05),('9303','2014-02-24','11:55:00',2.96),('9303','2014-02-24','12:00:00',3.2),('9303','2014-02-24','12:05:00',3.35),('9303','2014-02-24','12:10:00',2.21),('9303','2014-02-24','12:15:00',2.13),('9303','2014-02-24','12:20:00',2.17),('9303','2014-02-24','12:25:00',3.64),('9303','2014-02-24','12:30:00',3.76),('9303','2014-02-24','12:35:00',3.29),('9303','2014-02-24','12:40:00',3.94),('9303','2014-02-24','12:45:00',3.79),('9303','2014-02-24','12:50:00',3.67),('9303','2014-02-24','12:55:00',3.45),('9303','2014-02-24','13:00:00',3.73),('9303','2014-02-24','13:05:00',2.9),('9303','2014-02-24','13:10:00',4.14),('9303','2014-02-24','13:15:00',2.41),('9303','2014-02-24','13:20:00',1.01),('9303','2014-02-24','14:45:00',1),('9303','2014-02-24','15:20:00',1.08),('9303','2014-02-24','15:25:00',1.23),('9303','2014-02-24','15:30:00',1.12),('9303','2014-02-24','15:35:00',1.94),('9303','2014-02-24','15:40:00',2.43),('9303','2014-02-24','15:45:00',2.3),('9303','2014-02-24','15:50:00',1.57),('9303','2014-02-24','15:55:00',1.82),('9303','2014-02-24','16:00:00',1.96),('9303','2014-02-24','16:05:00',1.81),('9303','2014-02-24','16:10:00',1.63),('9303','2014-02-24','16:15:00',1.42),('9303','2014-02-24','16:20:00',1.12),('9303','2014-02-23','08:25:00',1.02),('9303','2014-02-23','08:30:00',1.09),('9303','2014-02-23','08:35:00',1.17),('9303','2014-02-23','08:40:00',1.31),('9303','2014-02-23','08:45:00',1.58),('9303','2014-02-23','08:50:00',1.71),('9303','2014-02-23','08:55:00',1.8),('9303','2014-02-23','09:00:00',1.89),('9303','2014-02-23','09:05:00',2),('9303','2014-02-23','09:10:00',2.09),('9303','2014-02-23','09:15:00',2.2),('9303','2014-02-23','09:20:00',2.29),('9303','2014-02-23','09:25:00',2.3),('9303','2014-02-23','09:30:00',2.18),('9303','2014-02-23','09:35:00',2.48),('9303','2014-02-23','09:40:00',2.51),('9303','2014-02-23','09:45:00',2.55),('9303','2014-02-23','09:50:00',2.55),('9303','2014-02-23','09:55:00',2.6),('9303','2014-02-23','10:00:00',2.6),('9303','2014-02-23','10:05:00',2.63),('9303','2014-02-23','10:10:00',2.65),('9303','2014-02-23','10:15:00',2.67),('9303','2014-02-23','10:20:00',2.75),('9303','2014-02-23','10:25:00',2.8),('9303','2014-02-23','10:30:00',2.84),('9303','2014-02-23','10:35:00',2.92),('9303','2014-02-23','10:40:00',2.95),('9303','2014-02-23','10:45:00',2.91),('9303','2014-02-23','10:50:00',3.02),('9303','2014-02-23','10:55:00',3.02),('9303','2014-02-23','11:00:00',2.21),('9303','2014-02-23','11:05:00',2.44),('9303','2014-02-23','11:10:00',3.2),('9303','2014-02-23','11:15:00',3.18),('9303','2014-02-23','11:20:00',3.04),('9303','2014-02-23','11:25:00',3.31),('9303','2014-02-23','11:30:00',3.42),('9303','2014-02-23','11:35:00',3.4),('9303','2014-02-23','11:40:00',3.46),('9303','2014-02-23','11:45:00',3.5),('9303','2014-02-23','11:50:00',3.31),('9303','2014-02-23','11:55:00',2.53),('9303','2014-02-23','12:00:00',3.25),('9303','2014-02-23','12:05:00',3.63),('9303','2014-02-23','12:10:00',3.43),('9303','2014-02-23','12:15:00',3.73),('9303','2014-02-23','12:20:00',3.23),('9303','2014-02-23','12:25:00',2.02),('9303','2014-02-23','12:30:00',2.62),('9303','2014-02-23','12:35:00',3.88),('9303','2014-02-23','12:40:00',2.21),('9303','2014-02-23','12:45:00',2.14),('9303','2014-02-23','12:50:00',1.7),('9303','2014-02-23','12:55:00',2.26),('9303','2014-02-23','13:00:00',2.49),('9303','2014-02-23','13:05:00',3.52),('9303','2014-02-23','13:10:00',3.54),('9303','2014-02-23','13:15:00',3.47),('9303','2014-02-23','13:20:00',3.48),('9303','2014-02-23','13:25:00',3.45),('9303','2014-02-23','13:30:00',3.36),('9303','2014-02-23','13:35:00',2.63),('9303','2014-02-23','13:40:00',3.11),('9303','2014-02-23','13:45:00',2.75),('9303','2014-02-23','13:50:00',1.48),('9303','2014-02-23','14:00:00',2.81),('9303','2014-02-23','14:05:00',2.78),('9303','2014-02-23','14:10:00',3.22),('9303','2014-02-23','14:15:00',2.21),('9303','2014-02-23','14:20:00',2.14),('9303','2014-02-23','14:25:00',2.8),('9303','2014-02-23','14:30:00',2.93),('9303','2014-02-23','14:35:00',1.6),('9303','2014-02-23','14:45:00',1.01),('9303','2014-02-23','14:50:00',1.05),('9303','2014-02-22','09:50:00',1.03),('9303','2014-02-22','10:00:00',1.34),('9303','2014-02-22','10:05:00',1.84),('9303','2014-02-22','10:10:00',1.9),('9303','2014-02-22','10:15:00',1.92),('9303','2014-02-22','10:20:00',1.2),('9303','2014-02-22','10:25:00',1.72),('9303','2014-02-22','10:30:00',2.33),('9303','2014-02-22','10:35:00',1.63),('9303','2014-02-22','10:40:00',1.7),('9303','2014-02-22','10:45:00',3.11),('9303','2014-02-22','10:50:00',3.46),('9303','2014-02-22','10:55:00',1.08),('9303','2014-02-22','12:05:00',1.13),('9303','2014-02-22','12:10:00',1.47),('9303','2014-02-22','12:15:00',1.78),('9303','2014-02-22','12:20:00',1.49),('9303','2014-02-22','12:25:00',1.64),('9303','2014-02-22','12:30:00',1.01),('9303','2014-02-22','12:35:00',1.09),('9303','2014-02-22','12:40:00',1.27),('9303','2014-02-22','12:45:00',3.35),('9303','2014-02-22','12:50:00',2.81),('9303','2014-02-22','12:55:00',1.46),('9303','2014-02-22','13:00:00',1.35),('9303','2014-02-22','13:05:00',1.91),('9303','2014-02-22','13:10:00',4.44),('9303','2014-02-22','13:15:00',2.38),('9303','2014-02-22','13:20:00',1.57),('9303','2014-02-22','13:30:00',1.21),('9303','2014-02-22','13:35:00',1.85),('9303','2014-02-22','13:40:00',1.69),('9303','2014-02-22','13:45:00',1.98),('9303','2014-02-22','13:50:00',1.95),('9303','2014-02-22','13:55:00',2.73),('9303','2014-02-22','14:00:00',3.23),('9303','2014-02-22','14:05:00',3.25),('9303','2014-02-22','14:10:00',3.17),('9303','2014-02-22','14:15:00',3.09),('9303','2014-02-22','14:20:00',2.99),('9303','2014-02-22','14:25:00',2.54),('9303','2014-02-22','14:30:00',2.97),('9303','2014-02-22','14:35:00',2.83),('9303','2014-02-22','14:40:00',2.34),('9303','2014-02-22','14:45:00',2.87),('9303','2014-02-22','14:50:00',2.58),('9303','2014-02-22','15:00:00',1.62),('9303','2014-02-22','15:05:00',2.46),('9303','2014-02-22','15:10:00',1.99),('9303','2014-02-22','15:15:00',1.83),('9303','2014-02-22','15:20:00',1.98),('9303','2014-02-22','15:25:00',2.22),('9303','2014-02-22','15:30:00',1.18),('9303','2014-02-22','15:35:00',1.55),('9303','2014-02-22','15:45:00',1.62),('9303','2014-02-22','15:50:00',1.52),('9303','2014-02-21','09:50:00',1.11),('9303','2014-02-21','09:55:00',1.13),('9303','2014-02-21','10:00:00',1.13),('9303','2014-02-21','10:05:00',1.37),('9303','2014-02-21','10:10:00',1.28),('9303','2014-02-21','10:15:00',1.38),('9303','2014-02-21','10:20:00',1.82),('9303','2014-02-21','10:25:00',2.25),('9303','2014-02-21','10:30:00',2.58),('9303','2014-02-21','10:35:00',1.99),('9303','2014-02-21','10:40:00',1.69),('9303','2014-02-21','10:45:00',1.66),('9303','2014-02-21','10:50:00',1.43),('9303','2014-02-21','10:55:00',1.97),('9303','2014-02-21','11:00:00',1.83),('9303','2014-02-21','11:05:00',1.53),('9303','2014-02-21','11:10:00',1.39),('9303','2014-02-21','11:15:00',1.55),('9303','2014-02-21','11:20:00',1.47),('9303','2014-02-21','11:25:00',1.64),('9303','2014-02-21','11:30:00',3.25),('9303','2014-02-21','11:35:00',3.03),('9303','2014-02-21','11:40:00',2.34),('9303','2014-02-21','11:45:00',3.44),('9303','2014-02-21','11:50:00',3.43),('9303','2014-02-21','11:55:00',2.06),('9303','2014-02-21','12:00:00',3.55),('9303','2014-02-21','12:05:00',3.98),('9303','2014-02-21','12:10:00',3.78),('9303','2014-02-21','12:15:00',2.9),('9303','2014-02-21','12:20:00',1.52),('9303','2014-02-21','12:25:00',1.49),('9303','2014-02-21','12:30:00',1.46),('9303','2014-02-21','12:35:00',1.35),('9303','2014-02-21','12:40:00',1.09),('9303','2014-02-21','15:25:00',1.23),('9303','2014-02-21','15:30:00',1.82),('9303','2014-02-21','15:35:00',1.73),('9303','2014-02-21','15:40:00',1.61),('9303','2014-02-21','15:45:00',1.52),('9303','2014-02-21','15:50:00',1.38),('9303','2014-02-21','15:55:00',1.23),('9303','2014-02-21','16:00:00',1.12),('9303','2014-02-21','16:05:00',1.01),('9303','2014-02-20','11:25:00',1.08),('9303','2014-02-20','11:30:00',1.07),('9303','2014-02-20','12:40:00',1.01),('9303','2014-02-20','12:55:00',1.05),('9303','2014-02-20','13:00:00',1.33),('9303','2014-02-20','13:15:00',1.1),('9303','2014-02-20','13:20:00',1.01),('9303','2014-02-20','13:30:00',1.06),('9303','2014-02-19','09:35:00',1.12),('9303','2014-02-19','09:40:00',1.19),('9303','2014-02-19','09:45:00',1.45),('9303','2014-02-19','09:50:00',1.35),('9303','2014-02-19','09:55:00',1.24),('9303','2014-02-19','10:00:00',1.2),('9303','2014-02-19','10:05:00',1.19),('9303','2014-02-19','10:10:00',1.29),('9303','2014-02-19','10:15:00',1.35),('9303','2014-02-19','10:20:00',1.23),('9303','2014-02-19','10:25:00',1.25),('9303','2014-02-19','10:30:00',1.36),('9303','2014-02-19','10:35:00',1.42),('9303','2014-02-19','10:40:00',1.64),('9303','2014-02-19','10:45:00',1.82),('9303','2014-02-19','10:50:00',1.68),('9303','2014-02-19','10:55:00',1.48),('9303','2014-02-19','11:00:00',1.35),('9303','2014-02-19','11:05:00',1.37),('9303','2014-02-19','11:10:00',1.56),('9303','2014-02-19','11:15:00',1.56),('9303','2014-02-19','11:20:00',1.68),('9303','2014-02-19','11:25:00',1.56),('9303','2014-02-19','11:30:00',1.45),('9303','2014-02-19','11:35:00',1.37),('9303','2014-02-19','11:40:00',1.34),('9303','2014-02-19','11:45:00',1.24),('9303','2014-02-19','11:50:00',1.27),('9303','2014-02-19','11:55:00',1.14),('9303','2014-02-19','12:00:00',1.24),('9303','2014-02-19','12:05:00',1.41),('9303','2014-02-19','12:10:00',1.39),('9303','2014-02-19','12:15:00',1.35),('9303','2014-02-19','12:20:00',1.15),('9303','2014-02-19','12:25:00',1.33),('9303','2014-02-19','12:30:00',1.52),('9303','2014-02-19','12:35:00',1.3),('9303','2014-02-19','12:40:00',1.2),('9303','2014-02-19','12:45:00',1.21),('9303','2014-02-19','13:05:00',1.1),('9303','2014-02-19','13:10:00',1.02),('9303','2014-02-19','13:15:00',1.17),('9303','2014-02-19','13:20:00',1.24),('9303','2014-02-19','13:25:00',1.31),('9303','2014-02-19','13:30:00',1.34),('9303','2014-02-19','13:35:00',1.64),('9303','2014-02-19','13:40:00',1.56),('9303','2014-02-19','13:45:00',1.76),('9303','2014-02-19','13:50:00',2.02),('9303','2014-02-19','13:55:00',1.81),('9303','2014-02-19','14:00:00',1.66),('9303','2014-02-19','14:05:00',1.79),('9303','2014-02-19','14:10:00',1.44),('9303','2014-02-19','14:15:00',1.23),('9303','2014-02-19','14:20:00',1.96),('9303','2014-02-19','14:25:00',1.55),('9303','2014-02-19','14:30:00',1.5),('9303','2014-02-19','14:35:00',1.57),('9303','2014-02-19','14:40:00',1.33),('9303','2014-02-19','14:45:00',1.22),('9303','2014-02-19','14:50:00',1.62),('9303','2014-02-19','14:55:00',1.45),('9303','2014-02-19','15:00:00',1.09),('9303','2014-02-19','15:05:00',1.06),('9303','2014-02-19','15:10:00',1.11),('9303','2014-02-19','15:15:00',1.24),('9303','2014-02-19','15:25:00',1.09),('9303','2014-02-19','15:50:00',1.08),('9303','2014-02-18','08:40:00',1.1),('9303','2014-02-18','08:45:00',1.19),('9303','2014-02-18','08:50:00',1.23),('9303','2014-02-18','08:55:00',1.36),('9303','2014-02-18','09:00:00',1.42),('9303','2014-02-18','09:05:00',1.48),('9303','2014-02-18','09:10:00',1.57),('9303','2014-02-18','09:15:00',1.74),('9303','2014-02-18','09:20:00',2.02),('9303','2014-02-18','09:25:00',2.14),('9303','2014-02-18','09:30:00',2.24),('9303','2014-02-18','09:35:00',2.26),('9303','2014-02-18','09:40:00',2.32),('9303','2014-02-18','09:45:00',2.36),('9303','2014-02-18','09:50:00',2.41),('9303','2014-02-18','09:55:00',2.46),('9303','2014-02-18','10:00:00',2.48),('9303','2014-02-18','10:05:00',2.54),('9303','2014-02-18','10:10:00',2.58),('9303','2014-02-18','10:15:00',2.58),('9303','2014-02-18','10:20:00',2.6),('9303','2014-02-18','10:25:00',2.62),('9303','2014-02-18','10:30:00',2.69),('9303','2014-02-18','10:35:00',2.72),('9303','2014-02-18','10:40:00',2.76),('9303','2014-02-18','10:45:00',2.8),('9303','2014-02-18','10:50:00',2.85),('9303','2014-02-18','10:55:00',2.85),('9303','2014-02-18','11:00:00',2.92),('9303','2014-02-18','11:05:00',2.53),('9303','2014-02-18','11:10:00',2.42),('9303','2014-02-18','11:15:00',2.39),('9303','2014-02-18','11:20:00',2.58),('9303','2014-02-18','11:25:00',2.91),('9303','2014-02-18','11:30:00',2.67),('9303','2014-02-18','11:35:00',2.56),('9303','2014-02-18','11:40:00',1.99),('9303','2014-02-18','11:45:00',1.94),('9303','2014-02-18','11:50:00',1.71),('9303','2014-02-18','11:55:00',1.48),('9303','2014-02-18','12:00:00',1.41),('9303','2014-02-18','12:05:00',1.39),('9303','2014-02-18','12:10:00',1.61),('9303','2014-02-18','12:15:00',1.78),('9303','2014-02-18','12:20:00',1.74),('9303','2014-02-18','12:25:00',2.02),('9303','2014-02-18','12:30:00',2.2),('9303','2014-02-18','12:35:00',1.72),('9303','2014-02-18','12:40:00',1.52),('9303','2014-02-18','12:45:00',1.43),('9303','2014-02-18','12:50:00',1.54),('9303','2014-02-18','12:55:00',1.75),('9303','2014-02-18','13:00:00',1.34),('9303','2014-02-18','13:05:00',1.25),('9303','2014-02-18','13:10:00',1.32),('9303','2014-02-18','13:15:00',1.76),('9303','2014-02-18','13:20:00',1.96),('9303','2014-02-18','13:25:00',2.31),('9303','2014-02-18','13:30:00',1.74),('9303','2014-02-18','13:35:00',1.42),('9303','2014-02-18','13:40:00',1.78),('9303','2014-02-18','13:45:00',2.05),('9303','2014-02-18','13:50:00',1.64),('9303','2014-02-18','13:55:00',1.6),('9303','2014-02-18','14:00:00',1.8),('9303','2014-02-18','14:05:00',2.4),('9303','2014-02-18','14:10:00',1.57),('9303','2014-02-18','14:15:00',1.21),('9303','2014-02-18','14:20:00',1.07),('9303','2014-02-18','14:25:00',1.07),('9303','2014-02-18','14:30:00',1.36),('9303','2014-02-18','14:35:00',1.32),('9303','2014-02-18','14:40:00',1.07),('9303','2014-02-18','15:40:00',1.08),('9303','2014-02-18','15:45:00',1.21),('9303','2014-02-17','08:40:00',1.03),('9303','2014-02-17','08:45:00',1.1),('9303','2014-02-17','08:50:00',1.15),('9303','2014-02-17','08:55:00',1.21),('9303','2014-02-17','09:00:00',1.26),('9303','2014-02-17','09:05:00',1.34),('9303','2014-02-17','09:10:00',1.4),('9303','2014-02-17','09:15:00',1.47),('9303','2014-02-17','09:20:00',1.52),('9303','2014-02-17','09:25:00',1.6),('9303','2014-02-17','09:30:00',1.67),('9303','2014-02-17','09:35:00',1.69),('9303','2014-02-17','09:40:00',1.74),('9303','2014-02-17','09:45:00',1.76),('9303','2014-02-17','09:50:00',1.78),('9303','2014-02-17','09:55:00',1.83),('9303','2014-02-17','10:00:00',1.84),('9303','2014-02-17','10:05:00',1.89),('9303','2014-02-17','10:10:00',1.92),('9303','2014-02-17','10:15:00',1.91),('9303','2014-02-17','10:20:00',1.94),('9303','2014-02-17','10:25:00',1.96),('9303','2014-02-17','10:30:00',2),('9303','2014-02-17','10:35:00',2.03),('9303','2014-02-17','10:40:00',2.02),('9303','2014-02-17','10:45:00',2.06),('9303','2014-02-17','10:50:00',2.1),('9303','2014-02-17','10:55:00',2.12),('9303','2014-02-17','11:00:00',2.05),('9303','2014-02-17','11:05:00',2.01),('9303','2014-02-17','11:10:00',2.09),('9303','2014-02-17','11:15:00',2.18),('9303','2014-02-17','11:20:00',2.22),('9303','2014-02-17','11:25:00',2.26),('9303','2014-02-17','11:30:00',2.34),('9303','2014-02-17','11:35:00',2.4),('9303','2014-02-17','11:40:00',2.4),('9303','2014-02-17','11:45:00',2.45),('9303','2014-02-17','11:50:00',2.45),('9303','2014-02-17','11:55:00',2.45),('9303','2014-02-17','12:00:00',2.47),('9303','2014-02-17','12:05:00',2.47),('9303','2014-02-17','12:10:00',2.48),('9303','2014-02-17','12:15:00',2.46),('9303','2014-02-17','12:20:00',2.46),('9303','2014-02-17','12:25:00',2.51),('9303','2014-02-17','12:30:00',2.52),('9303','2014-02-17','12:35:00',2.52),('9303','2014-02-17','12:40:00',2.54),('9303','2014-02-17','12:45:00',2.54),('9303','2014-02-17','12:50:00',2.53),('9303','2014-02-17','12:55:00',2.55),('9303','2014-02-17','13:00:00',2.54),('9303','2014-02-17','13:05:00',2.47),('9303','2014-02-17','13:10:00',2.37),('9303','2014-02-17','13:15:00',2.34),('9303','2014-02-17','13:20:00',2.32),('9303','2014-02-17','13:25:00',2.31),('9303','2014-02-17','13:30:00',2.3),('9303','2014-02-17','13:35:00',2.28),('9303','2014-02-17','13:40:00',2.26),('9303','2014-02-17','13:45:00',2.2),('9303','2014-02-17','13:50:00',2.12),('9303','2014-02-17','13:55:00',2.1),('9303','2014-02-17','14:00:00',2.04),('9303','2014-02-17','14:05:00',2.05),('9303','2014-02-17','14:10:00',1.9),('9303','2014-02-17','14:15:00',1.92),('9303','2014-02-17','14:20:00',2.15),('9303','2014-02-17','14:25:00',2.06),('9303','2014-02-17','14:30:00',1.93),('9303','2014-02-17','14:35:00',1.6),('9303','2014-02-17','14:40:00',1.62),('9303','2014-02-17','14:45:00',1.76),('9303','2014-02-17','14:50:00',1.74),('9303','2014-02-17','14:55:00',1.74),('9303','2014-02-17','15:00:00',1.76),('9303','2014-02-17','15:05:00',1.66),('9303','2014-02-17','15:10:00',1.63),('9303','2014-02-17','15:15:00',1.61),('9303','2014-02-17','15:20:00',1.57),('9303','2014-02-17','15:25:00',1.51),('9303','2014-02-17','15:30:00',1.46),('9303','2014-02-17','15:35:00',1.33),('9303','2014-02-17','15:40:00',1.18),('9303','2014-02-17','15:45:00',1.14),('9303','2014-02-17','15:50:00',1.04),('9303','2014-02-16','08:35:00',1.07),('9303','2014-02-16','08:40:00',1.08),('9303','2014-02-16','08:45:00',1.24),('9303','2014-02-16','08:50:00',1.19),('9303','2014-02-16','08:55:00',1.38),('9303','2014-02-16','09:00:00',1.47),('9303','2014-02-16','09:05:00',1.54),('9303','2014-02-16','09:10:00',1.51),('9303','2014-02-16','09:15:00',1.29),('9303','2014-02-16','09:20:00',1.61),('9303','2014-02-16','09:25:00',1.66),('9303','2014-02-16','09:30:00',1.72),('9303','2014-02-16','09:35:00',1.46),('9303','2014-02-16','09:40:00',1.82),('9303','2014-02-16','09:45:00',1.94),('9303','2014-02-16','09:50:00',1.98),('9303','2014-02-16','09:55:00',1.9),('9303','2014-02-16','10:00:00',1.84),('9303','2014-02-16','10:05:00',2.06),('9303','2014-02-16','10:10:00',2.11),('9303','2014-02-16','10:15:00',2.11),('9303','2014-02-16','10:20:00',2.13),('9303','2014-02-16','10:25:00',2.17),('9303','2014-02-16','10:30:00',2.22),('9303','2014-02-16','10:35:00',2.28),('9303','2014-02-16','10:40:00',2.34),('9303','2014-02-16','10:45:00',2.38),('9303','2014-02-16','10:50:00',2.15),('9303','2014-02-16','10:55:00',2.04),('9303','2014-02-16','11:00:00',2.38),('9303','2014-02-16','11:05:00',2.45),('9303','2014-02-16','11:10:00',2.35),('9303','2014-02-16','11:15:00',2.43),('9303','2014-02-16','11:20:00',2.43),('9303','2014-02-16','11:25:00',2.26),('9303','2014-02-16','11:30:00',2.36),('9303','2014-02-16','11:35:00',2.55),('9303','2014-02-16','11:40:00',2.5),('9303','2014-02-16','11:45:00',2.26),('9303','2014-02-16','11:50:00',2.51),('9303','2014-02-16','11:55:00',2.21),('9303','2014-02-16','12:00:00',2.6),('9303','2014-02-16','12:05:00',2.57),('9303','2014-02-16','12:10:00',2.61),('9303','2014-02-16','12:15:00',2.59),('9303','2014-02-16','12:20:00',2.58),('9303','2014-02-16','12:25:00',2.52),('9303','2014-02-16','12:30:00',2.61),('9303','2014-02-16','12:35:00',2.61),('9303','2014-02-16','12:40:00',2.66),('9303','2014-02-16','12:45:00',2.63),('9303','2014-02-16','12:50:00',2.61),('9303','2014-02-16','12:55:00',2.61),('9303','2014-02-16','13:00:00',2.61),('9303','2014-02-16','13:05:00',2.55),('9303','2014-02-16','13:10:00',2.43),('9303','2014-02-16','13:15:00',2.48),('9303','2014-02-16','13:20:00',2.46),('9303','2014-02-16','13:25:00',2.43),('9303','2014-02-16','13:30:00',2.39),('9303','2014-02-16','13:35:00',2.36),('9303','2014-02-16','13:40:00',2.33),('9303','2014-02-16','13:45:00',2.33),('9303','2014-02-16','13:50:00',2.3),('9303','2014-02-16','13:55:00',2.27),('9303','2014-02-16','14:00:00',2.24),('9303','2014-02-16','14:05:00',2.17),('9303','2014-02-16','14:10:00',2.17),('9303','2014-02-16','14:15:00',2.16),('9303','2014-02-16','14:20:00',2.12),('9303','2014-02-16','14:25:00',2.12),('9303','2014-02-16','14:30:00',2.07),('9303','2014-02-16','14:35:00',2.01),('9303','2014-02-16','14:40:00',1.92),('9303','2014-02-16','14:45:00',1.9),('9303','2014-02-16','14:50:00',1.84),('9303','2014-02-16','14:55:00',1.78),('9303','2014-02-16','15:00:00',1.71),('9303','2014-02-16','15:05:00',1.72),('9303','2014-02-16','15:10:00',1.71),('9303','2014-02-16','15:15:00',1.66),('9303','2014-02-16','15:20:00',1.58),('9303','2014-02-16','15:25:00',1.48),('9303','2014-02-16','15:30:00',1.41),('9303','2014-02-16','15:35:00',1.24),('9303','2014-02-16','15:40:00',1.03),('9303','2014-02-16','15:45:00',1.18),('9303','2014-04-28','08:15:00',1.5),('9303','2014-04-28','08:20:00',1.69),('9303','2014-04-28','08:25:00',1.52),('9303','2014-04-28','08:30:00',1.16),('9303','2014-04-28','08:35:00',1.12),('9303','2014-04-28','08:40:00',1.05),('9303','2014-04-28','08:45:00',1.4),('9303','2014-04-28','08:50:00',1.15),('9303','2014-04-28','08:55:00',1.23),('9303','2014-04-28','09:00:00',1.03),('9303','2014-04-28','09:10:00',1.66),('9303','2014-04-28','09:15:00',2.7),('9303','2014-04-28','09:20:00',2.1),('9303','2014-04-28','09:25:00',1.41),('9303','2014-04-28','09:30:00',3.09),('9303','2014-04-28','09:35:00',1.91),('9303','2014-04-28','09:40:00',1.61),('9303','2014-04-28','09:45:00',2.43),('9303','2014-04-28','09:50:00',3.57),('9303','2014-04-28','09:55:00',1.24),('9303','2014-04-28','10:00:00',1.48),('9303','2014-04-28','10:05:00',1.94),('9303','2014-04-28','10:10:00',2.13),('9303','2014-04-28','10:15:00',2.02),('9303','2014-04-28','10:20:00',1.81),('9303','2014-04-28','10:25:00',1.2),('9303','2014-04-28','10:45:00',1.39),('9303','2014-04-28','10:50:00',1.89),('9303','2014-04-28','10:55:00',1.77),('9303','2014-04-28','11:00:00',1.71),('9303','2014-04-28','11:05:00',2.18),('9303','2014-04-28','11:10:00',2.43),('9303','2014-04-28','11:15:00',2.29),('9303','2014-04-28','11:20:00',2.32),('9303','2014-04-28','11:25:00',1.64),('9303','2014-04-28','11:30:00',1.74),('9303','2014-04-28','11:35:00',1.63),('9303','2014-04-28','11:40:00',1.43),('9303','2014-04-28','11:45:00',1.57),('9303','2014-04-28','11:50:00',1.73),('9303','2014-04-28','11:55:00',1.81),('9303','2014-04-28','12:00:00',1.68),('9303','2014-04-28','12:05:00',1.32),('9303','2014-04-28','12:10:00',1.75),('9303','2014-04-28','12:15:00',2.58),('9303','2014-04-28','12:20:00',2.73),('9303','2014-04-28','12:25:00',2.69),('9303','2014-04-28','12:30:00',2.57),('9303','2014-04-28','12:35:00',2.31),('9303','2014-04-28','12:40:00',2.04),('9303','2014-04-28','12:45:00',1.8),('9303','2014-04-28','12:50:00',2.11),('9303','2014-04-28','12:55:00',2.14),('9303','2014-04-28','13:00:00',2.24),('9303','2014-04-28','13:05:00',2.68),('9303','2014-04-28','13:10:00',3.31),('9303','2014-04-28','13:15:00',2.16),('9303','2014-04-28','13:20:00',2.22),('9303','2014-04-28','13:25:00',2.74),('9303','2014-04-28','13:30:00',4.18),('9303','2014-04-28','13:35:00',3.41),('9303','2014-04-28','13:40:00',4.25),('9303','2014-04-28','13:45:00',2.82),('9303','2014-04-28','13:50:00',4.11),('9303','2014-04-28','13:55:00',3.29),('9303','2014-04-28','14:00:00',2.97),('9303','2014-04-28','14:05:00',2.4),('9303','2014-04-28','14:10:00',4.49),('9303','2014-04-28','14:15:00',3.32),('9303','2014-04-28','14:20:00',3.55),('9303','2014-04-28','14:25:00',3.04),('9303','2014-04-28','14:30:00',3.52),('9303','2014-04-28','14:35:00',3.71),('9303','2014-04-28','14:40:00',3.22),('9303','2014-04-28','14:45:00',2.55),('9303','2014-04-28','14:50:00',1.92),('9303','2014-04-28','14:55:00',3.23),('9303','2014-04-28','15:00:00',1.92),('9303','2014-04-28','15:05:00',3.36),('9303','2014-04-28','15:10:00',2.16),('9303','2014-04-28','15:15:00',3.23),('9303','2014-04-28','15:20:00',2.92),('9303','2014-04-28','15:25:00',1.86),('9303','2014-04-28','15:30:00',1.56),('9303','2014-04-28','15:35:00',2.33),('9303','2014-04-28','15:40:00',2.2),('9303','2014-04-28','15:45:00',2.08),('9303','2014-04-28','15:50:00',3.2),('9303','2014-04-28','15:55:00',1.39),('9303','2014-04-28','16:00:00',3.49),('9303','2014-04-28','16:05:00',3.77),('9303','2014-04-28','16:10:00',3.34),('9303','2014-04-28','16:15:00',1.46),('9303','2014-04-28','16:20:00',2.66),('9303','2014-04-28','16:25:00',2.1),('9303','2014-04-28','16:30:00',2.29),('9303','2014-04-28','16:35:00',2.09),('9303','2014-04-28','16:55:00',2.59),('9303','2014-04-28','17:40:00',1.24),('9303','2014-02-15','08:40:00',1.02),('9303','2014-02-15','08:45:00',1.09),('9303','2014-02-15','08:50:00',1.16),('9303','2014-02-15','08:55:00',1.21),('9303','2014-02-15','09:00:00',1.29),('9303','2014-02-15','09:05:00',1.36),('9303','2014-02-15','09:10:00',1.43),('9303','2014-02-15','09:15:00',1.47),('9303','2014-02-15','09:20:00',1.52),('9303','2014-02-15','09:25:00',1.6),('9303','2014-02-15','09:30:00',1.66),('9303','2014-02-15','09:35:00',1.7),('9303','2014-02-15','09:40:00',1.76),('9303','2014-02-15','09:45:00',1.79),('9303','2014-02-15','09:50:00',1.82),('9303','2014-02-15','09:55:00',1.84),('9303','2014-02-15','10:00:00',1.89),('9303','2014-02-15','10:05:00',1.93),('9303','2014-02-15','10:10:00',1.95),('9303','2014-02-15','10:15:00',1.97),('9303','2014-02-15','10:20:00',2),('9303','2014-02-15','10:25:00',2.01),('9303','2014-02-15','10:30:00',2.03),('9303','2014-02-15','10:35:00',2.09),('9303','2014-02-15','10:40:00',2.1),('9303','2014-02-15','10:45:00',2.17),('9303','2014-02-15','10:50:00',2.14),('9303','2014-02-15','10:55:00',2.17),('9303','2014-02-15','11:00:00',2.2),('9303','2014-02-15','11:05:00',2.37),('9303','2014-02-15','11:10:00',1.63),('9303','2014-02-15','11:15:00',2.39),('9303','2014-02-15','11:20:00',2.49),('9303','2014-02-15','11:25:00',1.38),('9303','2014-02-15','11:30:00',1.41),('9303','2014-02-15','11:35:00',1.43),('9303','2014-02-15','11:40:00',1.86),('9303','2014-02-15','11:45:00',2.88),('9303','2014-02-15','11:50:00',2.71),('9303','2014-02-15','11:55:00',2.76),('9303','2014-02-15','12:00:00',1.86),('9303','2014-02-15','12:05:00',1.3),('9303','2014-02-15','12:15:00',2.39),('9303','2014-02-15','12:20:00',3.14),('9303','2014-02-15','12:25:00',2.75),('9303','2014-02-15','12:30:00',1.47),('9303','2014-02-15','12:35:00',2.52),('9303','2014-02-15','12:45:00',2.34),('9303','2014-02-15','12:50:00',3),('9303','2014-02-15','12:55:00',3.19),('9303','2014-02-15','13:00:00',2.77),('9303','2014-02-15','13:05:00',2.95),('9303','2014-02-15','13:10:00',2.89),('9303','2014-02-15','13:15:00',2.69),('9303','2014-02-15','13:20:00',2.49),('9303','2014-02-15','13:25:00',2.49),('9303','2014-02-15','13:30:00',2.45),('9303','2014-02-15','13:35:00',2.42),('9303','2014-02-15','13:40:00',2.35),('9303','2014-02-15','13:45:00',2.3),('9303','2014-02-15','13:50:00',2.24),('9303','2014-02-15','13:55:00',2.26),('9303','2014-02-15','14:00:00',2.14),('9303','2014-02-15','14:05:00',2.1),('9303','2014-02-15','14:10:00',2.12),('9303','2014-02-15','14:15:00',2.06),('9303','2014-02-15','14:20:00',1.99),('9303','2014-02-15','14:25:00',2.02),('9303','2014-02-15','14:30:00',1.96),('9303','2014-02-15','14:35:00',1.89),('9303','2014-02-15','14:40:00',1.88),('9303','2014-02-15','14:45:00',1.81),('9303','2014-02-15','14:50:00',1.73),('9303','2014-02-15','14:55:00',1.63),('9303','2014-02-15','15:00:00',1.64),('9303','2014-02-15','15:05:00',1.6),('9303','2014-02-15','15:10:00',1.6),('9303','2014-02-15','15:15:00',1.58),('9303','2014-02-15','15:20:00',1.53),('9303','2014-02-15','15:25:00',1.46),('9303','2014-02-15','15:30:00',1.39),('9303','2014-02-15','15:35:00',1.3),('9303','2014-02-15','15:40:00',1.24),('9303','2014-02-15','15:45:00',1.17),('9303','2014-02-15','15:50:00',1.08),('9303','2014-02-15','15:55:00',1.02),('9303','2014-02-14','08:50:00',1.17),('9303','2014-02-14','08:55:00',1.22),('9303','2014-02-14','09:00:00',1.28),('9303','2014-02-14','09:05:00',1.4),('9303','2014-02-14','09:10:00',1.24),('9303','2014-02-14','09:25:00',1.57),('9303','2014-02-14','09:30:00',1.55),('9303','2014-02-14','09:50:00',2.01),('9303','2014-02-14','09:55:00',1.22),('9303','2014-02-14','10:00:00',1.85),('9303','2014-02-14','10:05:00',2.13),('9303','2014-02-14','10:10:00',1.87),('9303','2014-02-14','10:15:00',1.58),('9303','2014-02-14','10:20:00',2.08),('9303','2014-02-14','10:25:00',1.67),('9303','2014-02-14','10:30:00',2.19),('9303','2014-02-14','10:35:00',2.1),('9303','2014-02-14','10:40:00',2),('9303','2014-02-14','10:45:00',2.35),('9303','2014-02-14','10:50:00',2.3),('9303','2014-02-14','10:55:00',2.38),('9303','2014-02-14','11:00:00',2.37),('9303','2014-02-14','11:05:00',2.44),('9303','2014-02-14','11:10:00',2.43),('9303','2014-02-14','11:15:00',2.45),('9303','2014-02-14','11:20:00',2.51),('9303','2014-02-14','11:25:00',2.52),('9303','2014-02-14','11:30:00',2.58),('9303','2014-02-14','11:35:00',2.62),('9303','2014-02-14','11:40:00',2.61),('9303','2014-02-14','11:45:00',2.64),('9303','2014-02-14','11:50:00',2.62),('9303','2014-02-14','11:55:00',2.63),('9303','2014-02-14','12:00:00',2.66),('9303','2014-02-14','12:05:00',2.66),('9303','2014-02-14','12:10:00',2.52),('9303','2014-02-14','12:15:00',2.66),('9303','2014-02-14','12:20:00',2.67),('9303','2014-02-14','12:25:00',2.71),('9303','2014-02-14','12:30:00',2.71),('9303','2014-02-14','12:35:00',2.72),('9303','2014-02-14','12:40:00',2.74),('9303','2014-02-14','12:45:00',2.72),('9303','2014-02-14','12:50:00',2.72),('9303','2014-02-14','12:55:00',2.74),('9303','2014-02-14','13:00:00',2.72),('9303','2014-02-14','13:05:00',2.62),('9303','2014-02-14','13:10:00',2.56),('9303','2014-02-14','13:15:00',2.55),('9303','2014-02-14','13:20:00',2.51),('9303','2014-02-14','13:25:00',2.49),('9303','2014-02-14','13:30:00',2.47),('9303','2014-02-14','13:35:00',2.43),('9303','2014-02-14','13:40:00',2.41),('9303','2014-02-14','13:45:00',2.37),('9303','2014-02-14','13:50:00',2.36),('9303','2014-02-14','13:55:00',2.33),('9303','2014-02-14','14:00:00',2.22),('9303','2014-02-14','14:05:00',2.18),('9303','2014-02-14','14:10:00',2.19),('9303','2014-02-14','14:15:00',2.14),('9303','2014-02-14','14:20:00',2.09),('9303','2014-02-14','14:25:00',2.08),('9303','2014-02-14','14:30:00',2.02),('9303','2014-02-14','14:35:00',1.94),('9303','2014-02-14','14:40:00',1.9),('9303','2014-02-14','14:45:00',1.87),('9303','2014-02-14','14:50:00',1.81),('9303','2014-02-14','14:55:00',1.77),('9303','2014-02-14','15:00:00',1.72),('9303','2014-02-14','15:05:00',1.67),('9303','2014-02-14','15:10:00',1.65),('9303','2014-02-14','15:15:00',1.61),('9303','2014-02-14','15:20:00',1.54),('9303','2014-02-14','15:25:00',1.48),('9303','2014-02-14','15:30:00',1.4),('9303','2014-02-14','15:35:00',1.3),('9303','2014-02-14','15:40:00',1.24),('9303','2014-02-14','15:45:00',1.16),('9303','2014-02-14','15:50:00',1.06),('9303','2014-02-14','15:55:00',1),('9303','2014-02-13','08:45:00',1.06),('9303','2014-02-13','08:50:00',1.18),('9303','2014-02-13','08:55:00',1.26),('9303','2014-02-13','09:00:00',1.34),('9303','2014-02-13','09:05:00',1.41),('9303','2014-02-13','09:10:00',1.5),('9303','2014-02-13','09:15:00',1.55),('9303','2014-02-13','09:20:00',1.62),('9303','2014-02-13','09:25:00',1.7),('9303','2014-02-13','09:30:00',1.74),('9303','2014-02-13','09:35:00',1.8),('9303','2014-02-13','09:40:00',1.83),('9303','2014-02-13','09:45:00',1.87),('9303','2014-02-13','09:50:00',1.92),('9303','2014-02-13','09:55:00',1.93),('9303','2014-02-13','10:00:00',1.99),('9303','2014-02-13','10:05:00',2.02),('9303','2014-02-13','10:10:00',2.04),('9303','2014-02-13','10:15:00',2.05),('9303','2014-02-13','10:20:00',2.07),('9303','2014-02-13','10:25:00',2.06),('9303','2014-02-13','10:30:00',2.08),('9303','2014-02-13','10:35:00',2.15),('9303','2014-02-13','10:40:00',2.13),('9303','2014-02-13','10:45:00',2.19),('9303','2014-02-13','10:50:00',2.22),('9303','2014-02-13','10:55:00',2.25),('9303','2014-02-13','11:00:00',2.31),('9303','2014-02-13','11:05:00',2.32),('9303','2014-02-13','11:10:00',2.37),('9303','2014-02-13','11:15:00',2.38),('9303','2014-02-13','11:20:00',2.55),('9303','2014-02-13','11:25:00',2.69),('9303','2014-02-13','11:30:00',1.97),('9303','2014-02-13','11:35:00',1.64),('9303','2014-02-13','11:40:00',2.09),('9303','2014-02-13','11:45:00',1.72),('9303','2014-02-13','11:55:00',1.22),('9303','2014-02-13','12:00:00',1.25),('9303','2014-02-13','12:05:00',1.04),('9303','2014-02-13','12:20:00',1.42),('9303','2014-02-13','12:25:00',1.23),('9303','2014-02-13','12:30:00',3.21),('9303','2014-02-13','12:35:00',3.15),('9303','2014-02-13','12:40:00',3.21),('9303','2014-02-13','12:45:00',1.51),('9303','2014-02-13','12:50:00',2.91),('9303','2014-02-13','12:55:00',2.68),('9303','2014-02-13','13:00:00',2.85),('9303','2014-02-13','13:05:00',2.71),('9303','2014-02-13','13:10:00',2.64),('9303','2014-02-13','13:15:00',2.57),('9303','2014-02-13','13:20:00',2.53),('9303','2014-02-13','13:25:00',2.51),('9303','2014-02-13','13:30:00',2.49),('9303','2014-02-13','13:35:00',2.45),('9303','2014-02-13','13:40:00',2.44),('9303','2014-02-13','13:45:00',2.41),('9303','2014-02-13','13:50:00',2.37),('9303','2014-02-13','13:55:00',2.35),('9303','2014-02-13','14:00:00',2.27),('9303','2014-02-13','14:05:00',2.21),('9303','2014-02-13','14:10:00',2.19),('9303','2014-02-13','14:15:00',2.16),('9303','2014-02-13','14:20:00',2.11),('9303','2014-02-13','14:25:00',2.03),('9303','2014-02-13','14:30:00',1.95),('9303','2014-02-13','14:35:00',1.97),('9303','2014-02-13','14:40:00',1.98),('9303','2014-02-13','14:45:00',1.95),('9303','2014-02-13','14:50:00',1.53),('9303','2014-02-13','14:55:00',1.21),('9303','2014-02-13','15:00:00',1.7),('9303','2014-02-13','15:05:00',1.56),('9303','2014-02-13','15:10:00',1.83),('9303','2014-02-13','15:15:00',1.62),('9303','2014-02-13','15:20:00',1.69),('9303','2014-02-13','15:25:00',1.18),('9303','2014-02-13','15:40:00',1.43),('9303','2014-02-13','15:45:00',1.27),('9303','2014-02-13','15:50:00',1.12),('9303','2014-02-12','08:50:00',1.09),('9303','2014-02-12','08:55:00',1.23),('9303','2014-02-12','09:15:00',1.52),('9303','2014-02-12','09:20:00',1.61),('9303','2014-02-12','09:25:00',1.41),('9303','2014-02-12','09:40:00',1.35),('9303','2014-02-12','09:45:00',1.75),('9303','2014-02-12','09:50:00',1.48),('9303','2014-02-12','09:55:00',1.25),('9303','2014-02-12','10:05:00',1.4),('9303','2014-02-12','10:10:00',1.18),('9303','2014-02-12','10:30:00',1.22),('9303','2014-02-12','10:35:00',1.3),('9303','2014-02-12','10:40:00',1.04),('9303','2014-02-12','10:45:00',1.42),('9303','2014-02-12','10:50:00',1.22),('9303','2014-02-12','10:55:00',1.26),('9303','2014-02-12','11:00:00',1.25),('9303','2014-02-12','11:05:00',1.96),('9303','2014-02-12','11:10:00',1.43),('9303','2014-02-12','11:15:00',1.38),('9303','2014-02-12','11:20:00',1.43),('9303','2014-02-12','11:25:00',1.38),('9303','2014-02-12','11:30:00',1.64),('9303','2014-02-12','11:35:00',1.91),('9303','2014-02-12','11:40:00',1.04),('9303','2014-02-12','12:15:00',1.07),('9303','2014-02-12','12:20:00',1.11),('9303','2014-02-12','12:25:00',1.19),('9303','2014-02-12','12:30:00',1.27),('9303','2014-02-12','12:35:00',1.23),('9303','2014-02-12','12:40:00',1.19),('9303','2014-02-12','12:45:00',1.33),('9303','2014-02-12','12:50:00',1.49),('9303','2014-02-12','12:55:00',1.54),('9303','2014-02-12','13:00:00',1.6),('9303','2014-02-12','13:05:00',1.4),('9303','2014-02-12','13:10:00',1.95),('9303','2014-02-12','13:15:00',1.23),('9303','2014-02-12','13:20:00',1.15),('9303','2014-02-12','13:25:00',1.32),('9303','2014-02-12','13:30:00',2.05),('9303','2014-02-12','13:35:00',2.2),('9303','2014-02-12','13:40:00',3.22),('9303','2014-02-12','13:45:00',2.18),('9303','2014-02-12','13:50:00',2.19),('9303','2014-02-12','13:55:00',2.14),('9303','2014-02-12','14:00:00',2.74),('9303','2014-02-12','14:05:00',2.58),('9303','2014-02-12','14:10:00',2.36),('9303','2014-02-12','14:15:00',2.4),('9303','2014-02-12','14:20:00',2.04),('9303','2014-02-12','14:25:00',1.56),('9303','2014-02-12','14:30:00',1.22),('9303','2014-02-12','14:35:00',2.1),('9303','2014-02-12','14:40:00',1.75),('9303','2014-02-12','14:45:00',1.98),('9303','2014-02-12','14:50:00',2.18),('9303','2014-02-12','14:55:00',2),('9303','2014-02-12','15:00:00',1.34),('9303','2014-02-12','15:15:00',1.05),('9303','2014-02-12','15:20:00',1.42),('9303','2014-02-12','15:25:00',1.3),('9303','2014-02-12','15:30:00',1.11),('9303','2014-02-12','15:35:00',1),('9303','2014-02-12','15:40:00',1.45),('9303','2014-02-12','15:50:00',1.43),('9303','2014-02-11','09:25:00',1.1),('9303','2014-02-11','09:30:00',1.1),('9303','2014-02-11','09:35:00',1.11),('9303','2014-02-11','09:40:00',1.09),('9303','2014-02-11','09:45:00',1.06),('9303','2014-02-11','09:50:00',1.14),('9303','2014-02-11','09:55:00',1.14),('9303','2014-02-11','10:00:00',1.01),('9303','2014-02-11','10:10:00',1.19),('9303','2014-02-11','10:15:00',1.38),('9303','2014-02-11','10:20:00',1.56),('9303','2014-02-11','10:25:00',1.62),('9303','2014-02-11','10:30:00',1.73),('9303','2014-02-11','10:35:00',1.96),('9303','2014-02-11','10:40:00',1.98),('9303','2014-02-11','10:45:00',1.86),('9303','2014-02-11','10:50:00',2),('9303','2014-02-11','10:55:00',1.8),('9303','2014-02-11','11:00:00',1.93),('9303','2014-02-11','11:05:00',1.95),('9303','2014-02-11','11:10:00',1.83),('9303','2014-02-11','11:15:00',1.95),('9303','2014-02-11','11:20:00',1.96),('9303','2014-02-11','11:25:00',1.89),('9303','2014-02-11','11:30:00',1.61),('9303','2014-02-11','11:35:00',1.44),('9303','2014-02-11','11:40:00',1.44),('9303','2014-02-11','11:45:00',1.73),('9303','2014-02-11','11:50:00',1.66),('9303','2014-02-11','11:55:00',1.2),('9303','2014-02-11','12:00:00',1.17),('9303','2014-02-11','12:05:00',1.46),('9303','2014-02-11','12:10:00',1.72),('9303','2014-02-11','12:15:00',1.46),('9303','2014-02-11','12:20:00',1.52),('9303','2014-02-11','12:25:00',2.05),('9303','2014-02-11','12:30:00',1.92),('9303','2014-02-11','12:35:00',1.72),('9303','2014-02-11','12:40:00',1.3),('9303','2014-02-11','12:45:00',1.52),('9303','2014-02-11','12:50:00',1.23),('9303','2014-02-11','12:55:00',1.49),('9303','2014-02-11','13:00:00',1.6),('9303','2014-02-11','13:05:00',1.92),('9303','2014-02-11','13:10:00',2.27),('9303','2014-02-11','13:15:00',2.15),('9303','2014-02-11','13:20:00',2.41),('9303','2014-02-11','13:25:00',2.25),('9303','2014-02-11','13:30:00',2.07),('9303','2014-02-11','13:35:00',2.02),('9303','2014-02-11','13:40:00',2.31),('9303','2014-02-11','13:45:00',1.85),('9303','2014-02-11','13:50:00',1.42),('9303','2014-02-11','13:55:00',1.23),('9303','2014-02-11','14:00:00',1.57),('9303','2014-02-11','14:05:00',1.81),('9303','2014-02-11','14:10:00',1.42),('9303','2014-02-11','14:15:00',1.89),('9303','2014-02-11','14:20:00',1.28),('9303','2014-02-11','14:25:00',1.15),('9303','2014-02-11','14:30:00',1.31),('9303','2014-02-11','14:35:00',1.24),('9303','2014-02-11','15:15:00',1.08),('9303','2014-02-11','15:20:00',1.3),('9303','2014-02-10','13:00:00',1.17),('9303','2014-02-10','14:40:00',1.02),('9303','2014-02-09','11:30:00',1.06),('9303','2014-02-09','11:35:00',1.29),('9303','2014-02-09','12:25:00',1.16),('9303','2014-02-09','12:30:00',1.29),('9303','2014-02-09','12:45:00',1.31),('9303','2014-02-09','12:55:00',1.46),('9303','2014-02-09','13:00:00',2.6),('9303','2014-02-09','13:05:00',2.11),('9303','2014-02-09','13:10:00',1.98),('9303','2014-02-09','13:15:00',1.5),('9303','2014-02-09','13:40:00',1.43),('9303','2014-02-09','13:45:00',2.46),('9303','2014-02-09','13:50:00',1.46),('9303','2014-02-09','13:55:00',1.93),('9303','2014-02-09','14:00:00',1.65),('9303','2014-02-09','14:05:00',1.97),('9303','2014-02-09','14:10:00',1.33),('9303','2014-02-09','14:15:00',1.24),('9303','2014-02-09','14:20:00',1.13),('9303','2014-02-09','14:25:00',1.51),('9303','2014-02-09','14:30:00',1.76),('9303','2014-02-09','14:35:00',1.54),('9303','2014-02-09','14:50:00',1.36),('9303','2014-02-09','15:10:00',1.39),('9303','2014-02-09','15:15:00',1.04),('9303','2014-02-09','15:20:00',1.25),('9303','2014-02-09','15:25:00',1.17),('9303','2014-02-09','15:40:00',1.05),('9303','2014-02-08','09:50:00',1.48),('9303','2014-02-08','09:55:00',1.12),('9303','2014-02-08','10:15:00',1.3),('9303','2014-02-08','10:20:00',1.13),('9303','2014-02-08','10:30:00',1.42),('9303','2014-02-08','10:35:00',1.69),('9303','2014-02-08','10:40:00',1.34),('9303','2014-02-08','10:45:00',1.48),('9303','2014-02-08','10:50:00',1.57),('9303','2014-02-08','10:55:00',2.11),('9303','2014-02-08','11:00:00',1.92),('9303','2014-02-08','11:05:00',2.54),('9303','2014-02-08','11:10:00',1.89),('9303','2014-02-08','11:15:00',1.91),('9303','2014-02-08','11:20:00',2.46),('9303','2014-02-08','11:25:00',1.02),('9303','2014-02-08','11:30:00',1.6),('9303','2014-02-08','11:35:00',2.86),('9303','2014-02-08','11:40:00',1.83),('9303','2014-02-08','11:50:00',1.21),('9303','2014-02-08','11:55:00',3.11),('9303','2014-02-08','12:00:00',1.07),('9303','2014-02-08','12:05:00',1.06),('9303','2014-02-08','12:10:00',1.64),('9303','2014-02-08','12:15:00',2.8),('9303','2014-02-08','12:25:00',1.92),('9303','2014-02-08','12:30:00',3.14),('9303','2014-02-08','12:35:00',2.58),('9303','2014-02-08','12:40:00',1.63),('9303','2014-02-08','12:45:00',2.86),('9303','2014-02-08','12:50:00',3.43),('9303','2014-02-08','12:55:00',2.89),('9303','2014-02-08','13:00:00',2.11),('9303','2014-02-08','13:10:00',1.48),('9303','2014-02-08','13:15:00',2.86),('9303','2014-02-08','13:20:00',2.8),('9303','2014-02-08','13:25:00',2.13),('9303','2014-02-08','13:30:00',2.43),('9303','2014-02-08','13:35:00',2.31),('9303','2014-02-08','13:40:00',2.32),('9303','2014-02-08','13:45:00',2.64),('9303','2014-02-08','13:50:00',2.29),('9303','2014-02-08','13:55:00',2.26),('9303','2014-02-08','14:00:00',2.22),('9303','2014-02-08','14:05:00',2.15),('9303','2014-02-08','14:10:00',2.2),('9303','2014-02-08','14:15:00',1.57),('9303','2014-02-08','14:20:00',2.04),('9303','2014-02-08','14:25:00',1.39),('9303','2014-02-08','14:30:00',1.34),('9303','2014-02-08','14:40:00',1.56),('9303','2014-02-08','14:50:00',1.43),('9303','2014-02-08','14:55:00',1.83),('9303','2014-02-08','15:00:00',1.34),('9303','2014-02-08','15:20:00',1.28),('9303','2014-02-08','15:45:00',1.13),('9303','2014-02-08','15:50:00',1.02),('9303','2014-02-07','08:55:00',1.08),('9303','2014-02-07','09:00:00',1.19),('9303','2014-02-07','09:05:00',1.26),('9303','2014-02-07','09:10:00',1.35),('9303','2014-02-07','09:15:00',1.45),('9303','2014-02-07','09:20:00',1.52),('9303','2014-02-07','09:25:00',1.54),('9303','2014-02-07','09:30:00',1.62),('9303','2014-02-07','09:35:00',1.67),('9303','2014-02-07','09:40:00',1.71),('9303','2014-02-07','09:45:00',1.75),('9303','2014-02-07','09:50:00',1.76),('9303','2014-02-07','09:55:00',1.8),('9303','2014-02-07','10:00:00',1.83),('9303','2014-02-07','10:05:00',1.86),('9303','2014-02-07','10:10:00',1.9),('9303','2014-02-07','10:15:00',1.96),('9303','2014-02-07','10:20:00',2.01),('9303','2014-02-07','10:25:00',1.94),('9303','2014-02-07','10:30:00',2.05),('9303','2014-02-07','10:35:00',2.11),('9303','2014-02-07','10:40:00',2.22),('9303','2014-02-07','10:45:00',2.33),('9303','2014-02-07','10:50:00',2.38),('9303','2014-02-07','10:55:00',2.41),('9303','2014-02-07','11:00:00',1.84),('9303','2014-02-07','11:05:00',2.68),('9303','2014-02-07','11:10:00',1.98),('9303','2014-02-07','11:15:00',2.4),('9303','2014-02-07','11:20:00',2.01),('9303','2014-02-07','11:25:00',2.74),('9303','2014-02-07','11:30:00',2.3),('9303','2014-02-07','11:35:00',2.61),('9303','2014-02-07','11:40:00',1.18),('9303','2014-02-07','11:45:00',2.31),('9303','2014-02-07','11:50:00',1.85),('9303','2014-02-07','11:55:00',2.95),('9303','2014-02-07','12:00:00',2.45),('9303','2014-02-07','12:05:00',2.78),('9303','2014-02-07','12:10:00',2.1),('9303','2014-02-07','12:15:00',1.91),('9303','2014-02-07','12:20:00',1.29),('9303','2014-02-07','12:25:00',2.31),('9303','2014-02-07','12:30:00',1.47),('9303','2014-02-07','12:45:00',1.08),('9303','2014-02-07','12:50:00',1.3),('9303','2014-02-07','12:55:00',2.56),('9303','2014-02-07','13:00:00',2.48),('9303','2014-02-07','13:05:00',1.72),('9303','2014-02-07','13:10:00',3),('9303','2014-02-07','13:15:00',1.18),('9303','2014-02-07','13:20:00',1.72),('9303','2014-02-07','13:25:00',1.04),('9303','2014-02-07','13:35:00',2.03),('9303','2014-02-07','13:45:00',1.33),('9303','2014-02-07','13:50:00',1.61),('9303','2014-02-07','13:55:00',1.92),('9303','2014-02-07','14:00:00',1.64),('9303','2014-02-07','14:05:00',1.36),('9303','2014-02-07','14:10:00',2.2),('9303','2014-02-07','14:15:00',2.02),('9303','2014-02-07','14:20:00',2.18),('9303','2014-02-07','14:25:00',1.3),('9303','2014-02-07','14:30:00',1.02),('9303','2014-02-07','14:35:00',1.54),('9303','2014-02-07','14:40:00',2.12),('9303','2014-02-07','14:45:00',1.88),('9303','2014-02-07','14:50:00',1.84),('9303','2014-02-07','14:55:00',1.77),('9303','2014-02-07','15:00:00',1.65),('9303','2014-02-07','15:05:00',1.6),('9303','2014-02-07','15:10:00',1.57),('9303','2014-02-07','15:15:00',1.5),('9303','2014-02-07','15:20:00',1.44),('9303','2014-02-07','15:25:00',1.39),('9303','2014-02-07','15:30:00',1.27),('9303','2014-02-07','15:35:00',1.2),('9303','2014-02-07','15:40:00',1.13),('9303','2014-02-07','15:45:00',1.05),('9303','2014-02-06','08:55:00',1.09),('9303','2014-02-06','09:00:00',1.57),('9303','2014-02-06','09:05:00',1.65),('9303','2014-02-06','09:10:00',1.27),('9303','2014-02-06','09:15:00',1.29),('9303','2014-02-06','09:30:00',1.5),('9303','2014-02-06','09:35:00',1.67),('9303','2014-02-06','09:40:00',1.71),('9303','2014-02-06','09:45:00',1.73),('9303','2014-02-06','09:50:00',1.74),('9303','2014-02-06','09:55:00',1.78),('9303','2014-02-06','10:00:00',1.83),('9303','2014-02-06','10:05:00',1.86),('9303','2014-02-06','10:10:00',1.89),('9303','2014-02-06','10:15:00',1.93),('9303','2014-02-06','10:20:00',1.95),('9303','2014-02-06','10:25:00',1.9),('9303','2014-02-06','10:30:00',1.97),('9303','2014-02-06','10:35:00',2.11),('9303','2014-02-06','10:40:00',1.34),('9303','2014-02-06','10:45:00',1.56),('9303','2014-02-06','10:50:00',1.67),('9303','2014-02-06','10:55:00',1.87),('9303','2014-02-06','11:00:00',2.32),('9303','2014-02-06','11:10:00',1.97),('9303','2014-02-06','11:15:00',1.72),('9303','2014-02-06','11:20:00',1.4),('9303','2014-02-06','11:25:00',2.25),('9303','2014-02-06','11:30:00',2.45),('9303','2014-02-06','11:35:00',2.6),('9303','2014-02-06','11:40:00',2.49),('9303','2014-02-06','11:45:00',2.5),('9303','2014-02-06','11:50:00',2.54),('9303','2014-02-06','11:55:00',2.52),('9303','2014-02-06','12:00:00',2.59),('9303','2014-02-06','12:05:00',2.71),('9303','2014-02-06','12:10:00',2.67),('9303','2014-02-06','12:15:00',2.63),('9303','2014-02-06','12:20:00',2.61),('9303','2014-02-06','12:25:00',2.64),('9303','2014-02-06','12:30:00',2.64),('9303','2014-02-06','12:35:00',2.47),('9303','2014-02-06','12:40:00',2.23),('9303','2014-02-06','12:45:00',2.52),('9303','2014-02-06','12:50:00',2.64),('9303','2014-02-06','12:55:00',2.65),('9303','2014-02-06','13:00:00',2.63),('9303','2014-02-06','13:05:00',2.48),('9303','2014-02-06','13:10:00',2.63),('9303','2014-02-06','13:15:00',2.51),('9303','2014-02-06','13:20:00',2.55),('9303','2014-02-06','13:25:00',2.57),('9303','2014-02-06','13:30:00',1.7),('9303','2014-02-06','13:35:00',1.86),('9303','2014-02-06','13:40:00',2.24),('9303','2014-02-06','13:45:00',2.02),('9303','2014-02-06','13:50:00',1.63),('9303','2014-02-06','13:55:00',1.65),('9303','2014-02-06','14:00:00',2.14),('9303','2014-02-06','14:05:00',1.84),('9303','2014-02-06','14:10:00',2.09),('9303','2014-02-06','14:15:00',1.95),('9303','2014-02-06','14:20:00',1.91),('9303','2014-02-06','14:25:00',1.66),('9303','2014-02-06','14:30:00',1.09),('9303','2014-02-06','14:35:00',1.95),('9303','2014-02-06','14:40:00',1.91),('9303','2014-02-06','14:45:00',1.38),('9303','2014-02-06','14:50:00',1.09),('9303','2014-02-06','14:55:00',1.69),('9303','2014-02-06','15:00:00',1.6),('9303','2014-02-06','15:05:00',1.66),('9303','2014-02-06','15:10:00',1.58),('9303','2014-02-06','15:15:00',1.54),('9303','2014-02-06','15:20:00',1.48),('9303','2014-02-06','15:25:00',1.33),('9303','2014-02-06','15:30:00',1.23),('9303','2014-02-06','15:35:00',1.17),('9303','2014-02-06','15:40:00',1.09),('9303','2014-02-06','15:45:00',1.01),('9303','2014-04-27','10:05:00',1.05),('9303','2014-04-27','10:10:00',1.13),('9303','2014-04-27','10:20:00',1.07),('9303','2014-04-27','11:05:00',1.21),('9303','2014-04-27','11:10:00',1.27),('9303','2014-04-27','11:15:00',1.19),('9303','2014-04-27','11:35:00',1.21),('9303','2014-04-27','11:40:00',1.39),('9303','2014-04-27','11:45:00',2.66),('9303','2014-04-27','11:50:00',2.96),('9303','2014-04-27','11:55:00',2.38),('9303','2014-04-27','12:00:00',2.39),('9303','2014-04-27','12:05:00',2.55),('9303','2014-04-27','12:10:00',2.87),('9303','2014-04-27','12:15:00',2.62),('9303','2014-04-27','12:20:00',2.83),('9303','2014-04-27','12:25:00',2.67),('9303','2014-04-27','12:30:00',2.41),('9303','2014-04-27','12:35:00',2.45),('9303','2014-04-27','12:40:00',2.17),('9303','2014-04-27','12:45:00',2.35),('9303','2014-04-27','12:50:00',2.11),('9303','2014-04-27','12:55:00',1.56),('9303','2014-04-27','13:00:00',1.86),('9303','2014-04-27','13:05:00',2.04),('9303','2014-04-27','13:10:00',1.71),('9303','2014-04-27','13:15:00',1.75),('9303','2014-04-27','13:20:00',2.27),('9303','2014-04-27','13:25:00',2.11),('9303','2014-04-27','13:30:00',1.87),('9303','2014-04-27','13:35:00',1.68),('9303','2014-04-27','13:40:00',1.52),('9303','2014-04-27','13:45:00',1.53),('9303','2014-04-27','13:50:00',1.46),('9303','2014-04-27','13:55:00',1.4),('9303','2014-04-27','14:00:00',1.72),('9303','2014-04-27','14:05:00',2.2),('9303','2014-04-27','14:10:00',1.61),('9303','2014-04-27','14:15:00',1.36),('9303','2014-04-27','14:20:00',1.63),('9303','2014-04-27','14:25:00',2.05),('9303','2014-04-27','14:30:00',2.17),('9303','2014-04-27','14:35:00',2.12),('9303','2014-04-27','14:40:00',2.21),('9303','2014-04-27','14:45:00',1.94),('9303','2014-04-27','14:50:00',1.8),('9303','2014-04-27','14:55:00',1.93),('9303','2014-04-27','15:00:00',2.05),('9303','2014-04-27','15:05:00',2.86),('9303','2014-04-27','15:10:00',3.63),('9303','2014-04-27','15:15:00',2.97),('9303','2014-04-27','15:20:00',1.8),('9303','2014-04-27','15:25:00',1.12),('9303','2014-04-27','15:40:00',1.04),('9303','2014-02-05','10:15:00',1.19),('9303','2014-02-05','10:20:00',2.01),('9303','2014-02-05','10:25:00',2.23),('9303','2014-02-05','10:35:00',1.08),('9303','2014-02-05','10:40:00',1.12),('9303','2014-02-05','11:15:00',1.87),('9303','2014-02-05','11:20:00',2.88),('9303','2014-02-05','11:25:00',2.54),('9303','2014-02-05','11:30:00',1.23),('9303','2014-02-05','12:55:00',1.15),('9303','2014-02-05','13:05:00',1.01),('9303','2014-02-05','13:10:00',1.09),('9303','2014-02-05','13:15:00',1.06),('9303','2014-02-05','13:20:00',1.14),('9303','2014-02-05','13:25:00',1.55),('9303','2014-02-05','13:30:00',1.55),('9303','2014-02-05','13:35:00',1.86),('9303','2014-02-05','13:40:00',1.86),('9303','2014-02-05','13:45:00',1.91),('9303','2014-02-05','13:50:00',1.47),('9303','2014-02-05','13:55:00',1.06),('9303','2014-02-05','14:30:00',1.44),('9303','2014-02-05','14:35:00',1.72),('9303','2014-02-04','09:20:00',1.32),('9303','2014-02-04','09:25:00',1.22),('9303','2014-02-04','09:30:00',1.59),('9303','2014-02-04','09:35:00',1.98),('9303','2014-02-04','09:40:00',1.89),('9303','2014-02-04','09:45:00',1.73),('9303','2014-02-04','09:50:00',1.5),('9303','2014-02-04','09:55:00',1.73),('9303','2014-02-04','10:00:00',1.8),('9303','2014-02-04','10:05:00',1.88),('9303','2014-02-04','10:15:00',1.46),('9303','2014-02-04','10:45:00',1.09),('9303','2014-02-04','10:50:00',1.35),('9303','2014-02-04','10:55:00',1.86),('9303','2014-02-04','11:00:00',1.65),('9303','2014-02-04','11:55:00',1.98),('9303','2014-02-04','12:00:00',2.58),('9303','2014-02-04','12:05:00',1.13),('9303','2014-02-04','12:10:00',1.32),('9303','2014-02-04','12:15:00',1.36),('9303','2014-02-04','12:20:00',1.27),('9303','2014-02-04','12:25:00',1.22),('9303','2014-02-04','12:30:00',1.03),('9303','2014-02-04','13:00:00',1.02),('9303','2014-02-04','13:05:00',1.15),('9303','2014-02-04','13:20:00',1.28),('9303','2014-02-04','13:25:00',1.16),('9303','2014-02-03','10:40:00',1.02),('9303','2014-02-03','10:45:00',1.02),('9303','2014-02-03','10:50:00',1.02),('9303','2014-02-03','10:55:00',1.03),('9303','2014-02-03','11:25:00',1.03),('9303','2014-02-03','11:30:00',1.12),('9303','2014-02-03','11:35:00',1.18),('9303','2014-02-03','11:40:00',1.16),('9303','2014-02-03','11:45:00',1.14),('9303','2014-02-03','11:50:00',1.09),('9303','2014-02-01','11:00:00',1.02),('9303','2014-02-01','11:20:00',1.71),('9303','2014-02-01','11:25:00',1.09),('9303','2014-02-01','11:30:00',1.53),('9303','2014-02-01','11:35:00',1.52),('9303','2014-02-01','11:55:00',1.49),('9303','2014-02-01','12:00:00',1.39),('9303','2014-02-01','12:05:00',1.15),('9303','2014-02-01','12:10:00',1.67),('9303','2014-02-01','12:15:00',1.01),('9303','2014-02-01','12:20:00',1.7),('9303','2014-02-01','12:25:00',1.35),('9303','2014-02-01','12:40:00',1.05),('9303','2014-02-01','12:45:00',1.77),('9303','2014-02-01','12:50:00',1.71),('9303','2014-02-01','12:55:00',1.33),('9303','2014-02-01','13:00:00',1.37),('9303','2014-02-01','13:05:00',1.06),('9303','2014-01-30','09:50:00',1.12),('9303','2014-01-30','09:55:00',1.76),('9303','2014-01-30','10:00:00',1.7),('9303','2014-01-30','10:05:00',1.46),('9303','2014-01-30','10:10:00',1.61),('9303','2014-01-30','10:15:00',1.92),('9303','2014-01-30','10:20:00',1.62),('9303','2014-01-30','10:25:00',1.72),('9303','2014-01-30','10:30:00',1.95),('9303','2014-01-30','10:35:00',1.96),('9303','2014-01-30','10:40:00',1.98),('9303','2014-01-30','10:45:00',1.75),('9303','2014-01-30','10:50:00',2.01),('9303','2014-01-30','10:55:00',2.49),('9303','2014-01-30','11:00:00',2.5),('9303','2014-01-30','11:05:00',2.41),('9303','2014-01-30','11:10:00',2.29),('9303','2014-01-30','11:15:00',2.15),('9303','2014-01-30','11:20:00',1.84),('9303','2014-01-30','11:25:00',1.92),('9303','2014-01-30','11:30:00',1.95),('9303','2014-01-30','11:35:00',2.09),('9303','2014-01-30','11:40:00',1.06),('9303','2014-01-30','11:45:00',2.02),('9303','2014-01-30','11:50:00',1.49),('9303','2014-01-30','11:55:00',2.63),('9303','2014-01-30','12:00:00',1.54),('9303','2014-01-30','12:05:00',2.52),('9303','2014-01-30','12:10:00',1.76),('9303','2014-01-30','12:15:00',1.99),('9303','2014-01-30','12:20:00',2.24),('9303','2014-01-30','12:25:00',2.31),('9303','2014-01-30','12:30:00',1.93),('9303','2014-01-30','12:35:00',2.21),('9303','2014-01-30','12:40:00',2.09),('9303','2014-01-30','12:45:00',2.33),('9303','2014-01-30','12:50:00',2.62),('9303','2014-01-30','12:55:00',2.55),('9303','2014-01-30','13:00:00',1.69),('9303','2014-01-30','13:05:00',2.55),('9303','2014-01-30','13:10:00',2.1),('9303','2014-01-30','13:15:00',2.13),('9303','2014-01-30','13:20:00',1.76),('9303','2014-01-30','13:25:00',2.33),('9303','2014-01-30','13:30:00',1.94),('9303','2014-01-30','13:35:00',1.71),('9303','2014-01-30','13:40:00',1.97),('9303','2014-01-30','13:45:00',2.33),('9303','2014-01-30','13:50:00',2.2),('9303','2014-01-30','13:55:00',1.93),('9303','2014-01-30','14:00:00',1.83),('9303','2014-01-30','14:05:00',1.78),('9303','2014-01-30','14:10:00',1.78),('9303','2014-01-30','14:15:00',1.59),('9303','2014-01-30','14:20:00',1.45),('9303','2014-01-30','14:25:00',1.52),('9303','2014-01-30','14:30:00',1.61),('9303','2014-01-30','14:35:00',1.54),('9303','2014-01-30','14:40:00',1.76),('9303','2014-01-30','14:45:00',1.66),('9303','2014-01-30','14:50:00',1.72),('9303','2014-01-30','14:55:00',1.66),('9303','2014-01-30','15:00:00',1.6),('9303','2014-01-30','15:05:00',1.56),('9303','2014-01-30','15:10:00',1.48),('9303','2014-01-30','15:15:00',1.32),('9303','2014-01-30','15:20:00',1.34),('9303','2014-01-30','15:25:00',1.37),('9303','2014-01-30','15:30:00',1.21),('9303','2014-01-30','15:35:00',1.17),('9303','2014-01-30','15:40:00',1.11),('9303','2014-01-29','09:20:00',1.2),('9303','2014-01-29','09:30:00',1.15),('9303','2014-01-29','09:35:00',1.5),('9303','2014-01-29','09:40:00',1.49),('9303','2014-01-29','09:45:00',1.59),('9303','2014-01-29','09:50:00',1.43),('9303','2014-01-29','09:55:00',1.52),('9303','2014-01-29','10:00:00',1.32),('9303','2014-01-29','10:05:00',1.25),('9303','2014-01-29','10:10:00',1.51),('9303','2014-01-29','10:15:00',1.51),('9303','2014-01-29','10:20:00',1.11),('9303','2014-01-29','10:25:00',1.79),('9303','2014-01-29','10:30:00',1.91),('9303','2014-01-29','10:35:00',1.84),('9303','2014-01-29','10:40:00',1.75),('9303','2014-01-29','10:45:00',1.74),('9303','2014-01-29','10:50:00',1.69),('9303','2014-01-29','10:55:00',1.63),('9303','2014-01-29','11:00:00',1.64),('9303','2014-01-29','11:05:00',1.79),('9303','2014-01-29','11:10:00',1.63),('9303','2014-01-29','11:15:00',1.67),('9303','2014-01-29','11:20:00',1.78),('9303','2014-01-29','11:25:00',1.76),('9303','2014-01-29','11:30:00',2.21),('9303','2014-01-29','11:35:00',1.9),('9303','2014-01-29','11:40:00',1.44),('9303','2014-01-29','11:45:00',1.1),('9303','2014-01-29','12:50:00',2.29),('9303','2014-01-29','12:55:00',2.81),('9303','2014-01-29','13:00:00',1.91),('9303','2014-01-29','13:05:00',1.23),('9303','2014-01-29','13:35:00',1.61),('9303','2014-01-29','13:40:00',2.2),('9303','2014-01-29','13:45:00',1.42),('9303','2014-01-29','13:50:00',1.63),('9303','2014-01-29','13:55:00',1.6),('9303','2014-01-29','14:00:00',1.28),('9303','2014-01-29','15:15:00',1.18),('9303','2014-01-28','09:15:00',1.03),('9303','2014-01-28','09:20:00',1.08),('9303','2014-01-28','09:25:00',1.13),('9303','2014-01-28','09:30:00',1.13),('9303','2014-01-28','09:35:00',1.24),('9303','2014-01-28','09:40:00',1.15),('9303','2014-01-28','09:45:00',1.21),('9303','2014-01-28','09:50:00',1.57),('9303','2014-01-28','09:55:00',1.65),('9303','2014-01-28','10:00:00',1.76),('9303','2014-01-28','10:05:00',1.71),('9303','2014-01-28','10:10:00',1.71),('9303','2014-01-28','10:15:00',1.67),('9303','2014-01-28','10:20:00',1.77),('9303','2014-01-28','10:25:00',1.87),('9303','2014-01-28','10:30:00',1.85),('9303','2014-01-28','10:35:00',1.94),('9303','2014-01-28','10:40:00',2),('9303','2014-01-28','10:45:00',1.7),('9303','2014-01-28','10:50:00',2),('9303','2014-01-28','10:55:00',2.04),('9303','2014-01-28','11:00:00',2.07),('9303','2014-01-28','11:05:00',1.07),('9303','2014-01-28','11:10:00',1.61),('9303','2014-01-28','11:15:00',1.41),('9303','2014-01-28','11:25:00',1.38),('9303','2014-01-28','11:30:00',1.82),('9303','2014-01-28','11:35:00',1.59),('9303','2014-01-28','11:40:00',2.55),('9303','2014-01-28','11:45:00',1.43),('9303','2014-01-28','12:00:00',2.24),('9303','2014-01-28','12:05:00',1.66),('9303','2014-01-28','12:10:00',1.69),('9303','2014-01-28','12:15:00',2.05),('9303','2014-01-28','12:20:00',1.67),('9303','2014-01-28','12:25:00',1.09),('9303','2014-01-28','12:30:00',1.07),('9303','2014-01-28','12:35:00',1.2),('9303','2014-01-28','12:40:00',1.66),('9303','2014-01-28','12:45:00',1.72),('9303','2014-01-28','12:50:00',2.78),('9303','2014-01-28','12:55:00',2.58),('9303','2014-01-28','13:00:00',2.94),('9303','2014-01-28','13:05:00',3.13),('9303','2014-01-28','13:10:00',2.28),('9303','2014-01-28','13:15:00',1.95),('9303','2014-01-28','13:20:00',2.03),('9303','2014-01-28','13:25:00',2.38),('9303','2014-01-28','13:30:00',2.22),('9303','2014-01-28','13:35:00',2.5),('9303','2014-01-28','13:40:00',2.4),('9303','2014-01-28','13:45:00',2.27),('9303','2014-01-28','13:50:00',2.19),('9303','2014-01-28','13:55:00',2.15),('9303','2014-01-28','14:00:00',2.1),('9303','2014-01-28','14:05:00',2.05),('9303','2014-01-28','14:10:00',1.97),('9303','2014-01-28','14:15:00',1.94),('9303','2014-01-28','14:20:00',1.74),('9303','2014-01-28','14:25:00',1.96),('9303','2014-01-28','14:30:00',1.96),('9303','2014-01-28','14:35:00',1.77),('9303','2014-01-28','14:40:00',1.64),('9303','2014-01-28','14:45:00',1.75),('9303','2014-01-28','14:50:00',1.58),('9303','2014-01-28','14:55:00',1.64),('9303','2014-01-28','15:00:00',1.61),('9303','2014-01-28','15:05:00',1.54),('9303','2014-01-28','15:10:00',1.48),('9303','2014-01-28','15:15:00',1.39),('9303','2014-01-28','15:20:00',1.28),('9303','2014-01-28','15:25:00',1.21),('9303','2014-01-28','15:30:00',1.13),('9303','2014-01-28','15:35:00',1.06),('9650','2014-05-04','08:20:00',1.02),('9650','2014-05-04','08:25:00',1.12),('9650','2014-05-04','08:30:00',1.22),('9650','2014-05-04','08:35:00',1.28),('9650','2014-05-04','08:40:00',1.32),('9650','2014-05-04','08:45:00',1.44),('9650','2014-05-04','08:50:00',1.87),('9650','2014-05-04','08:55:00',2.04),('9650','2014-05-04','09:00:00',2.15),('9650','2014-05-04','09:05:00',2.27),('9650','2014-05-04','09:10:00',2.44),('9650','2014-05-04','09:15:00',2.64),('9650','2014-05-04','09:20:00',2.78),('9650','2014-05-04','09:25:00',2.92),('9650','2014-05-04','09:30:00',3.13),('9650','2014-05-04','09:35:00',3.26),('9650','2014-05-04','09:40:00',3.38),('9650','2014-05-04','09:45:00',3.52),('9650','2014-05-04','09:50:00',3.66),('9650','2014-05-04','09:55:00',3.81),('9650','2014-05-04','10:00:00',3.92),('9650','2014-05-04','10:05:00',4.08),('9650','2014-05-04','10:10:00',4.2),('9650','2014-05-04','10:15:00',4.32),('9650','2014-05-04','10:20:00',4.41),('9650','2014-05-04','10:25:00',4.56),('9650','2014-05-04','10:30:00',4.69),('9650','2014-05-04','10:35:00',4.84),('9650','2014-05-04','10:40:00',4.92),('9650','2014-05-04','10:45:00',5.06),('9650','2014-05-04','10:50:00',5.17),('9650','2014-05-04','10:55:00',5.25),('9650','2014-05-04','11:00:00',5.38),('9650','2014-05-04','11:05:00',5.47),('9650','2014-05-04','11:10:00',5.6),('9650','2014-05-04','11:15:00',5.79),('9650','2014-05-04','11:20:00',5.77),('9650','2014-05-04','11:25:00',5.6),('9650','2014-05-04','11:30:00',5.91),('9650','2014-05-04','11:35:00',5.99),('9650','2014-05-04','11:40:00',6.1),('9650','2014-05-04','11:45:00',6.27),('9650','2014-05-04','11:50:00',6.36),('9650','2014-05-04','11:55:00',6.67),('9650','2014-05-04','12:00:00',6.68),('9650','2014-05-04','12:05:00',4.57),('9650','2014-05-04','12:10:00',1.9),('9650','2014-05-04','12:15:00',3.96),('9650','2014-05-04','12:20:00',3.11),('9650','2014-05-04','12:25:00',3.36),('9650','2014-05-04','12:30:00',5.74),('9650','2014-05-04','12:35:00',4.25),('9650','2014-05-04','12:40:00',3.52),('9650','2014-05-04','12:45:00',4.37),('9650','2014-05-04','12:50:00',7.74),('9650','2014-05-04','12:55:00',2.58),('9650','2014-05-04','13:00:00',2.18),('9650','2014-05-04','13:05:00',4.88),('9650','2014-05-04','13:10:00',7.87),('9650','2014-05-04','13:15:00',7.6),('9650','2014-05-04','13:20:00',7.49),('9650','2014-05-04','13:25:00',7.41),('9650','2014-05-04','13:30:00',7.5),('9650','2014-05-04','13:35:00',7.48),('9650','2014-05-04','13:40:00',7.58),('9650','2014-05-04','13:45:00',7.68),('9650','2014-05-04','13:50:00',7.71),('9650','2014-05-04','13:55:00',7.72),('9650','2014-05-04','14:00:00',7.66),('9650','2014-05-04','14:05:00',6.7),('9650','2014-05-04','14:10:00',6.37),('9650','2014-05-04','14:15:00',6.14),('9650','2014-05-04','14:20:00',8.64),('9650','2014-05-04','14:25:00',8.28),('9650','2014-05-04','14:30:00',6.01),('9650','2014-05-04','14:35:00',4.36),('9650','2014-05-04','14:40:00',3.75),('9650','2014-05-04','14:45:00',2.51),('9650','2014-05-04','14:50:00',2.51),('9650','2014-05-04','14:55:00',2.91),('9650','2014-05-04','15:00:00',4.18),('9650','2014-05-04','15:05:00',6.12),('9650','2014-05-04','15:10:00',4.07),('9650','2014-05-04','15:15:00',2.26),('9650','2014-05-04','15:20:00',2.32),('9650','2014-05-04','15:25:00',3.35),('9650','2014-05-04','15:30:00',4.54),('9650','2014-05-04','15:35:00',4.44),('9650','2014-05-04','15:40:00',5.83),('9650','2014-05-04','15:45:00',5.7),('9650','2014-05-04','15:50:00',2.13),('9650','2014-05-04','15:55:00',2.18),('9650','2014-05-04','16:00:00',2.37),('9650','2014-05-04','16:05:00',5.66),('9650','2014-05-04','16:10:00',2.54),('9650','2014-05-04','16:15:00',2.51),('9650','2014-05-04','16:20:00',3.27),('9650','2014-05-04','16:25:00',2.11),('9650','2014-05-04','16:30:00',2.31),('9650','2014-05-04','16:35:00',5.28),('9650','2014-05-04','16:40:00',4.13),('9650','2014-05-04','16:45:00',5.37),('9650','2014-05-04','16:50:00',6.64),('9650','2014-05-04','16:55:00',6.23),('9650','2014-05-04','17:00:00',5.75),('9650','2014-05-04','17:05:00',5.55),('9650','2014-05-04','17:10:00',5.63),('9650','2014-05-04','17:15:00',5.53),('9650','2014-05-04','17:20:00',5.4),('9650','2014-05-04','17:25:00',5.2),('9650','2014-05-04','17:30:00',4.99),('9650','2014-05-04','17:35:00',4.85),('9650','2014-05-04','17:40:00',4.79),('9650','2014-05-04','17:45:00',4.63),('9650','2014-05-04','17:50:00',4.47),('9650','2014-05-04','17:55:00',4.35),('9650','2014-05-04','18:00:00',4.16),('9650','2014-05-04','18:05:00',4.01),('9650','2014-05-04','18:10:00',3.93),('9650','2014-05-04','18:15:00',3.78),('9650','2014-05-04','18:20:00',3.59),('9650','2014-05-04','18:25:00',3.41),('9650','2014-05-04','18:30:00',3.23),('9650','2014-05-04','18:35:00',3.09),('9650','2014-05-04','18:40:00',2.91),('9650','2014-05-04','18:45:00',2.73),('9650','2014-05-04','18:50:00',2.54),('9650','2014-05-04','18:55:00',2.36),('9650','2014-05-04','19:00:00',2.13),('9650','2014-05-04','19:05:00',1.91),('9650','2014-05-04','19:10:00',1.71),('9650','2014-05-04','19:15:00',1.52),('9650','2014-05-04','19:20:00',1.29),('9650','2014-05-04','19:25:00',1.12),('9650','2014-04-25','08:05:00',1.02),('9650','2014-04-25','08:10:00',1.12),('9650','2014-04-25','08:15:00',1.15),('9650','2014-04-25','08:20:00',1.17),('9650','2014-04-25','08:25:00',1.19),('9650','2014-04-25','08:30:00',1.13),('9650','2014-04-25','08:35:00',1.17),('9650','2014-04-25','08:40:00',1.24),('9650','2014-04-25','08:45:00',1.28),('9650','2014-04-25','08:50:00',1.3),('9650','2014-04-25','08:55:00',1.31),('9650','2014-04-25','09:00:00',1.31),('9650','2014-04-25','09:05:00',1.79),('9650','2014-04-25','09:10:00',1.6),('9650','2014-04-25','09:15:00',1.41),('9650','2014-04-25','09:20:00',1.43),('9650','2014-04-25','09:25:00',1.44),('9650','2014-04-25','09:30:00',1.43),('9650','2014-04-25','09:35:00',1.55),('9650','2014-04-25','09:40:00',1.64),('9650','2014-04-25','09:45:00',1.46),('9650','2014-04-25','09:50:00',1.66),('9650','2014-04-25','09:55:00',2.35),('9650','2014-04-25','10:00:00',2.51),('9650','2014-04-25','10:05:00',2.29),('9650','2014-04-25','10:10:00',2.21),('9650','2014-04-25','10:15:00',2.31),('9650','2014-04-25','10:20:00',2.53),('9650','2014-04-25','10:25:00',2.76),('9650','2014-04-25','10:30:00',3.07),('9650','2014-04-25','10:35:00',3.41),('9650','2014-04-25','10:40:00',3.49),('9650','2014-04-25','10:45:00',3.39),('9650','2014-04-25','10:50:00',3.99),('9650','2014-04-25','10:55:00',5.2),('9650','2014-04-25','11:00:00',5.19),('9650','2014-04-25','11:05:00',4.91),('9650','2014-04-25','11:10:00',4.67),('9650','2014-04-25','11:15:00',4.61),('9650','2014-04-25','11:20:00',4.33),('9650','2014-04-25','11:25:00',4.34),('9650','2014-04-25','11:30:00',4.54),('9650','2014-04-25','11:35:00',4.43),('9650','2014-04-25','11:40:00',4.14),('9650','2014-04-25','11:45:00',4.55),('9650','2014-04-25','11:50:00',4.57),('9650','2014-04-25','11:55:00',4.3),('9650','2014-04-25','12:00:00',4.59),('9650','2014-04-25','12:05:00',4.95),('9650','2014-04-25','12:10:00',5),('9650','2014-04-25','12:15:00',4.69),('9650','2014-04-25','12:20:00',4.61),('9650','2014-04-25','12:25:00',3.9),('9650','2014-04-25','12:30:00',3.81),('9650','2014-04-25','12:35:00',5.74),('9650','2014-04-25','12:40:00',5.66),('9650','2014-04-25','12:45:00',5.98),('9650','2014-04-25','12:50:00',6.84),('9650','2014-04-25','12:55:00',6.68),('9650','2014-04-25','13:00:00',5.98),('9650','2014-04-25','13:05:00',4.94),('9650','2014-04-25','13:10:00',5.66),('9650','2014-04-25','13:15:00',7.16),('9650','2014-04-25','13:20:00',7.82),('9650','2014-04-25','13:25:00',6.37),('9650','2014-04-25','13:30:00',2.59),('9650','2014-04-25','13:35:00',3.49),('9650','2014-04-25','13:40:00',7.86),('9650','2014-04-25','13:45:00',7.29),('9650','2014-04-25','13:50:00',7.24),('9650','2014-04-25','13:55:00',7.6),('9650','2014-04-25','14:00:00',5.51),('9650','2014-04-25','14:05:00',1.26),('9650','2014-04-25','14:10:00',3.72),('9650','2014-04-25','14:15:00',3.29),('9650','2014-04-25','14:20:00',1.06),('9650','2014-04-25','14:25:00',1.68),('9650','2014-04-25','14:30:00',1.71),('9650','2014-04-25','14:35:00',2.57),('9650','2014-04-25','14:40:00',4.36),('9650','2014-04-25','14:45:00',1.44),('9650','2014-04-25','17:40:00',1.13),('9650','2014-04-25','17:45:00',1.32),('9650','2014-04-25','17:50:00',1.6),('9650','2014-04-25','17:55:00',1.48),('9650','2014-04-25','18:30:00',1.13),('9650','2014-04-25','18:35:00',1.37),('9650','2014-04-25','18:40:00',2.08),('9650','2014-04-25','18:45:00',2.59),('9650','2014-04-25','18:50:00',2.37),('9650','2014-04-25','18:55:00',1.25),('9650','2014-04-24','08:25:00',1.02),('9650','2014-04-24','08:30:00',1.11),('9650','2014-04-24','08:35:00',1.2),('9650','2014-04-24','08:40:00',1.28),('9650','2014-04-24','08:45:00',1.42),('9650','2014-04-24','08:50:00',1.6),('9650','2014-04-24','08:55:00',1.72),('9650','2014-04-24','09:00:00',1.52),('9650','2014-04-24','09:05:00',1.54),('9650','2014-04-24','09:10:00',1.88),('9650','2014-04-24','09:15:00',1.73),('9650','2014-04-24','09:20:00',1.47),('9650','2014-04-24','09:25:00',1.77),('9650','2014-04-24','09:30:00',1.69),('9650','2014-04-24','09:35:00',1.72),('9650','2014-04-24','09:40:00',1.6),('9650','2014-04-24','09:45:00',1.69),('9650','2014-04-24','09:50:00',1.68),('9650','2014-04-24','09:55:00',1.83),('9650','2014-04-24','10:00:00',2.15),('9650','2014-04-24','10:05:00',2.06),('9650','2014-04-24','10:10:00',2.17),('9650','2014-04-24','10:15:00',2.16),('9650','2014-04-24','10:20:00',2.26),('9650','2014-04-24','10:25:00',2.35),('9650','2014-04-24','10:30:00',2.51),('9650','2014-04-24','10:35:00',4.43),('9650','2014-04-24','10:40:00',3.51),('9650','2014-04-24','10:45:00',4.95),('9650','2014-04-24','10:50:00',3.48),('9650','2014-04-24','10:55:00',4.61),('9650','2014-04-24','11:00:00',4.62),('9650','2014-04-24','11:05:00',3.18),('9650','2014-04-24','11:10:00',4.04),('9650','2014-04-24','11:15:00',5.37),('9650','2014-04-24','11:20:00',4.37),('9650','2014-04-24','11:25:00',3.52),('9650','2014-04-24','11:30:00',2.49),('9650','2014-04-24','11:35:00',4.38),('9650','2014-04-24','11:40:00',4.9),('9650','2014-04-24','11:45:00',2.16),('9650','2014-04-24','11:50:00',2.4),('9650','2014-04-24','11:55:00',5.05),('9650','2014-04-24','12:00:00',4.43),('9650','2014-04-24','12:05:00',6.04),('9650','2014-04-24','12:10:00',7.11),('9650','2014-04-24','12:15:00',4.17),('9650','2014-04-24','12:20:00',5.58),('9650','2014-04-24','12:25:00',4.26),('9650','2014-04-24','12:30:00',6.27),('9650','2014-04-24','12:35:00',7.07),('9650','2014-04-24','12:40:00',7.45),('9650','2014-04-24','12:45:00',7.65),('9650','2014-04-24','12:50:00',4.06),('9650','2014-04-24','12:55:00',3.41),('9650','2014-04-24','13:00:00',4.44),('9650','2014-04-24','13:05:00',3.33),('9650','2014-04-24','13:10:00',5.72),('9650','2014-04-24','13:15:00',2.6),('9650','2014-04-24','13:20:00',2.02),('9650','2014-04-24','13:25:00',5.11),('9650','2014-04-24','13:30:00',2.2),('9650','2014-04-24','13:35:00',1.89),('9650','2014-04-24','13:40:00',2.55),('9650','2014-04-24','13:45:00',2.79),('9650','2014-04-24','13:50:00',2.19),('9650','2014-04-24','13:55:00',4.48),('9650','2014-04-24','14:00:00',2.52),('9650','2014-04-24','14:05:00',2.6),('9650','2014-04-24','14:10:00',2.13),('9650','2014-04-24','14:15:00',2.27),('9650','2014-04-24','14:20:00',6.77),('9650','2014-04-24','14:25:00',5.81),('9650','2014-04-24','14:30:00',4.58),('9650','2014-04-24','14:35:00',5.16),('9650','2014-04-24','14:40:00',7),('9650','2014-04-24','14:45:00',7.03),('9650','2014-04-24','14:50:00',7),('9650','2014-04-24','14:55:00',6.96),('9650','2014-04-24','15:00:00',6.81),('9650','2014-04-24','15:05:00',6.79),('9650','2014-04-24','15:10:00',6.77),('9650','2014-04-24','15:15:00',6.71),('9650','2014-04-24','15:20:00',6.48),('9650','2014-04-24','15:25:00',6.48),('9650','2014-04-24','15:30:00',6.36),('9650','2014-04-24','15:35:00',6.62),('9650','2014-04-24','15:40:00',6.47),('9650','2014-04-24','15:45:00',6.32),('9650','2014-04-24','15:50:00',6.28),('9650','2014-04-24','15:55:00',6.26),('9650','2014-04-24','16:00:00',6.26),('9650','2014-04-24','16:05:00',6.03),('9650','2014-04-24','16:10:00',5.86),('9650','2014-04-24','16:15:00',5.7),('9650','2014-04-24','16:20:00',5.3),('9650','2014-04-24','16:25:00',5.49),('9650','2014-04-24','16:30:00',5.75),('9650','2014-04-24','16:35:00',5.84),('9650','2014-04-24','16:40:00',5.92),('9650','2014-04-24','16:45:00',5.7),('9650','2014-04-24','16:50:00',5.22),('9650','2014-04-24','16:55:00',4.49),('9650','2014-04-24','17:00:00',4.39),('9650','2014-04-24','17:05:00',4.87),('9650','2014-04-24','17:10:00',4.17),('9650','2014-04-24','17:15:00',4.42),('9650','2014-04-24','17:20:00',3.06),('9650','2014-04-24','17:25:00',2.28),('9650','2014-04-24','17:30:00',2.41),('9650','2014-04-24','17:35:00',2.42),('9650','2014-04-24','17:40:00',2.33),('9650','2014-04-24','17:45:00',2.03),('9650','2014-04-24','17:50:00',1.78),('9650','2014-04-24','17:55:00',1.67),('9650','2014-04-24','18:00:00',1.62),('9650','2014-04-24','18:05:00',1.73),('9650','2014-04-24','18:10:00',1.76),('9650','2014-04-24','18:15:00',1.39),('9650','2014-04-24','18:20:00',1.44),('9650','2014-04-24','18:25:00',1.5),('9650','2014-04-24','18:30:00',1.4),('9650','2014-04-24','18:35:00',1.35),('9650','2014-04-24','18:40:00',1.26),('9650','2014-04-24','18:45:00',1.09),('9650','2014-04-24','18:50:00',1),('9650','2014-04-24','19:05:00',1.24),('9650','2014-04-24','19:10:00',1.76),('9650','2014-04-24','19:15:00',1.62),('9650','2014-04-24','19:20:00',1.34),('9650','2014-04-23','08:30:00',1.04),('9650','2014-04-23','08:35:00',1.14),('9650','2014-04-23','08:40:00',1.25),('9650','2014-04-23','08:45:00',1.35),('9650','2014-04-23','08:50:00',1.47),('9650','2014-04-23','08:55:00',1.59),('9650','2014-04-23','09:00:00',1.72),('9650','2014-04-23','09:05:00',1.84),('9650','2014-04-23','09:10:00',1.97),('9650','2014-04-23','09:15:00',2.11),('9650','2014-04-23','09:20:00',2.25),('9650','2014-04-23','09:25:00',2.37),('9650','2014-04-23','09:30:00',2.5),('9650','2014-04-23','09:35:00',2.63),('9650','2014-04-23','09:40:00',2.76),('9650','2014-04-23','09:45:00',2.9),('9650','2014-04-23','09:50:00',3.02),('9650','2014-04-23','09:55:00',3.15),('9650','2014-04-23','10:00:00',3.27),('9650','2014-04-23','10:05:00',3.37),('9650','2014-04-23','10:10:00',3.49),('9650','2014-04-23','10:15:00',3.6),('9650','2014-04-23','10:20:00',3.72),('9650','2014-04-23','10:25:00',3.88),('9650','2014-04-23','10:30:00',3.99),('9650','2014-04-23','10:35:00',4.09),('9650','2014-04-23','10:40:00',4.21),('9650','2014-04-23','10:45:00',4.32),('9650','2014-04-23','10:50:00',4.44),('9650','2014-04-23','10:55:00',4.56),('9650','2014-04-23','11:00:00',4.63),('9650','2014-04-23','11:05:00',4.7),('9650','2014-04-23','11:10:00',4.83),('9650','2014-04-23','11:15:00',4.91),('9650','2014-04-23','11:20:00',4.98),('9650','2014-04-23','11:25:00',5.11),('9650','2014-04-23','11:30:00',5.18),('9650','2014-04-23','11:35:00',5.24),('9650','2014-04-23','11:40:00',5.38),('9650','2014-04-23','11:45:00',5.46),('9650','2014-04-23','11:50:00',5.41),('9650','2014-04-23','11:55:00',5.44),('9650','2014-04-23','12:00:00',5.61),('9650','2014-04-23','12:05:00',5.81),('9650','2014-04-23','12:10:00',5.86),('9650','2014-04-23','12:15:00',6.05),('9650','2014-04-23','12:20:00',5.46),('9650','2014-04-23','12:25:00',6.09),('9650','2014-04-23','12:30:00',6.21),('9650','2014-04-23','12:35:00',6.33),('9650','2014-04-23','12:40:00',6.26),('9650','2014-04-23','12:45:00',6.25),('9650','2014-04-23','12:50:00',6.36),('9650','2014-04-23','12:55:00',6.52),('9650','2014-04-23','13:00:00',6.54),('9650','2014-04-23','13:05:00',6.43),('9650','2014-04-23','13:10:00',6.67),('9650','2014-04-23','13:15:00',6.87),('9650','2014-04-23','13:20:00',6.84),('9650','2014-04-23','13:25:00',6.79),('9650','2014-04-23','13:30:00',5.98),('9650','2014-04-23','13:35:00',3.66),('9650','2014-04-23','13:40:00',1.81),('9650','2014-04-23','13:45:00',1.97),('9650','2014-04-23','13:50:00',7.36),('9650','2014-04-23','13:55:00',7.43),('9650','2014-04-23','14:00:00',6.09),('9650','2014-04-23','14:05:00',7.7),('9650','2014-04-23','14:10:00',8.09),('9650','2014-04-23','14:15:00',4.91),('9650','2014-04-23','14:20:00',6.01),('9650','2014-04-23','14:25:00',6.93),('9650','2014-04-23','14:30:00',6.66),('9650','2014-04-23','14:35:00',7.53),('9650','2014-04-23','14:40:00',5.42),('9650','2014-04-23','14:45:00',3.94),('9650','2014-04-23','14:50:00',3.6),('9650','2014-04-23','14:55:00',7.86),('9650','2014-04-23','15:00:00',8.08),('9650','2014-04-23','15:05:00',7.99),('9650','2014-04-23','15:10:00',8.06),('9650','2014-04-23','15:15:00',7.87),('9650','2014-04-23','15:20:00',4.65),('9650','2014-04-23','15:25:00',3.89),('9650','2014-04-23','15:30:00',4.83),('9650','2014-04-23','15:35:00',4.71),('9650','2014-04-23','15:40:00',4.25),('9650','2014-04-23','15:45:00',3.86),('9650','2014-04-23','15:50:00',4.11),('9650','2014-04-23','15:55:00',4.65),('9650','2014-04-23','16:00:00',7.7),('9650','2014-04-23','16:05:00',7.17),('9650','2014-04-23','16:10:00',6.28),('9650','2014-04-23','16:15:00',6.8),('9650','2014-04-23','16:20:00',6.2),('9650','2014-04-23','16:25:00',6.49),('9650','2014-04-23','16:30:00',5.51),('9650','2014-04-23','16:35:00',3.5),('9650','2014-04-23','16:40:00',3.9),('9650','2014-04-23','16:45:00',3.19),('9650','2014-04-23','16:50:00',2.71),('9650','2014-04-23','16:55:00',2.73),('9650','2014-04-23','17:00:00',2.64),('9650','2014-04-23','17:05:00',2.39),('9650','2014-04-23','17:10:00',2.28),('9650','2014-04-23','17:15:00',2.04),('9650','2014-04-23','17:20:00',2.03),('9650','2014-04-23','17:25:00',2.01),('9650','2014-04-23','17:30:00',1.96),('9650','2014-04-23','17:35:00',1.77),('9650','2014-04-23','17:40:00',1.46),('9650','2014-04-22','10:40:00',1.08),('9650','2014-04-22','10:45:00',1.1),('9650','2014-04-22','10:50:00',1.04),('9650','2014-04-22','11:15:00',1.04),('9650','2014-04-22','11:20:00',1.01),('9650','2014-04-22','11:35:00',1.03),('9650','2014-04-22','11:40:00',1.12),('9650','2014-04-22','11:45:00',1.21),('9650','2014-04-22','12:50:00',1.01),('9650','2014-04-22','12:55:00',1.06),('9650','2014-04-22','13:00:00',1.13),('9650','2014-04-22','13:05:00',1.33),('9650','2014-04-22','13:10:00',1.66),('9650','2014-04-22','13:15:00',1.93),('9650','2014-04-22','13:20:00',2.14),('9650','2014-04-22','13:25:00',2.27),('9650','2014-04-22','13:30:00',2.44),('9650','2014-04-22','13:35:00',2.56),('9650','2014-04-22','13:40:00',2.75),('9650','2014-04-22','13:45:00',2.86),('9650','2014-04-22','13:50:00',2.84),('9650','2014-04-22','13:55:00',2.86),('9650','2014-04-22','14:00:00',2.7),('9650','2014-04-22','14:05:00',2.72),('9650','2014-04-22','14:10:00',2.66),('9650','2014-04-22','14:15:00',2.26),('9650','2014-04-22','14:20:00',1.96),('9650','2014-04-22','14:25:00',1.77),('9650','2014-04-22','14:30:00',1.65),('9650','2014-04-22','14:35:00',1.54),('9650','2014-04-22','14:40:00',1.54),('9650','2014-04-22','14:45:00',1.76),('9650','2014-04-22','14:50:00',2.14),('9650','2014-04-22','14:55:00',2.49),('9650','2014-04-22','15:00:00',2.84),('9650','2014-04-22','15:05:00',3.07),('9650','2014-04-22','15:10:00',2.93),('9650','2014-04-22','15:15:00',3.1),('9650','2014-04-22','15:20:00',2.56),('9650','2014-04-22','15:25:00',2.37),('9650','2014-04-22','15:30:00',2.32),('9650','2014-04-22','15:35:00',2.2),('9650','2014-04-22','15:40:00',2.17),('9650','2014-04-22','15:45:00',2.34),('9650','2014-04-22','15:50:00',1.77),('9650','2014-04-22','15:55:00',1.73),('9650','2014-04-22','16:00:00',1.45),('9650','2014-04-22','16:05:00',1.37),('9650','2014-04-22','16:10:00',1.21),('9650','2014-04-22','16:15:00',1.05),('9650','2014-04-21','08:25:00',1.05),('9650','2014-04-21','08:30:00',1.14),('9650','2014-04-21','08:35:00',1.23),('9650','2014-04-21','08:40:00',1.38),('9650','2014-04-21','08:45:00',1.55),('9650','2014-04-21','08:50:00',1.72),('9650','2014-04-21','08:55:00',1.8),('9650','2014-04-21','09:00:00',1.86),('9650','2014-04-21','09:05:00',2.18),('9650','2014-04-21','09:10:00',1.94),('9650','2014-04-21','09:15:00',2.12),('9650','2014-04-21','09:20:00',2.34),('9650','2014-04-21','09:25:00',2.46),('9650','2014-04-21','09:30:00',2.72),('9650','2014-04-21','09:35:00',2.98),('9650','2014-04-21','09:40:00',3),('9650','2014-04-21','09:45:00',3.37),('9650','2014-04-21','09:50:00',2.95),('9650','2014-04-21','09:55:00',2.21),('9650','2014-04-21','10:00:00',2.2),('9650','2014-04-21','10:05:00',2.4),('9650','2014-04-21','10:10:00',3.02),('9650','2014-04-21','10:15:00',3.06),('9650','2014-04-21','10:20:00',4.23),('9650','2014-04-21','10:25:00',3.33),('9650','2014-04-21','10:30:00',4.95),('9650','2014-04-21','10:35:00',5.03),('9650','2014-04-21','10:40:00',4.68),('9650','2014-04-21','10:45:00',5),('9650','2014-04-21','10:50:00',5.46),('9650','2014-04-21','10:55:00',4.09),('9650','2014-04-21','11:00:00',3.07),('9650','2014-04-21','11:05:00',3.44),('9650','2014-04-21','11:10:00',2.83),('9650','2014-04-21','11:15:00',2.49),('9650','2014-04-21','11:20:00',2.16),('9650','2014-04-21','11:25:00',2.05),('9650','2014-04-21','11:30:00',1.89),('9650','2014-04-21','11:35:00',1.98),('9650','2014-04-21','11:40:00',1.83),('9650','2014-04-21','11:45:00',1.59),('9650','2014-04-21','11:50:00',1.68),('9650','2014-04-21','11:55:00',1.62),('9650','2014-04-21','12:00:00',1.77),('9650','2014-04-21','12:05:00',2.14),('9650','2014-04-21','12:10:00',2.12),('9650','2014-04-21','12:15:00',2.13),('9650','2014-04-21','12:20:00',2.19),('9650','2014-04-21','12:25:00',2.35),('9650','2014-04-21','12:30:00',2.68),('9650','2014-04-21','12:35:00',2.27),('9650','2014-04-21','12:40:00',1.75),('9650','2014-04-21','12:45:00',1.48),('9650','2014-04-21','12:50:00',1.31),('9650','2014-04-21','12:55:00',1.28),('9650','2014-04-21','13:00:00',1.33),('9650','2014-04-21','13:05:00',1.46),('9650','2014-04-21','13:10:00',1.72),('9650','2014-04-21','13:15:00',2.54),('9650','2014-04-21','13:20:00',3.83),('9650','2014-04-21','13:25:00',4.38),('9650','2014-04-21','13:30:00',4.72),('9650','2014-04-21','13:35:00',4.48),('9650','2014-04-21','13:40:00',5.37),('9650','2014-04-21','13:45:00',5.44),('9650','2014-04-21','13:50:00',4.6),('9650','2014-04-21','13:55:00',2.69),('9650','2014-04-21','14:00:00',2.39),('9650','2014-04-21','14:05:00',3.17),('9650','2014-04-21','14:10:00',5.74),('9650','2014-04-21','14:15:00',5.64),('9650','2014-04-21','14:20:00',6.65),('9650','2014-04-21','14:25:00',4.24),('9650','2014-04-21','14:30:00',3.52),('9650','2014-04-21','14:35:00',4.23),('9650','2014-04-21','14:40:00',5.82),('9650','2014-04-21','14:45:00',7.24),('9650','2014-04-21','14:50:00',6.63),('9650','2014-04-21','14:55:00',5.08),('9650','2014-04-21','15:00:00',2.29),('9650','2014-04-21','15:05:00',2.23),('9650','2014-04-21','15:10:00',2.15),('9650','2014-04-21','15:15:00',2.13),('9650','2014-04-21','15:20:00',2.38),('9650','2014-04-21','15:25:00',2.56),('9650','2014-04-21','15:30:00',3.18),('9650','2014-04-21','15:35:00',4.57),('9650','2014-04-21','15:40:00',3.93),('9650','2014-04-21','15:45:00',3.56),('9650','2014-04-21','15:50:00',4.06),('9650','2014-04-21','15:55:00',3.34),('9650','2014-04-21','16:00:00',3.96),('9650','2014-04-21','16:05:00',2.69),('9650','2014-04-21','16:10:00',2.66),('9650','2014-04-21','16:15:00',2.51),('9650','2014-04-21','16:20:00',2.94),('9650','2014-04-21','16:25:00',2.78),('9650','2014-04-21','16:30:00',2.35),('9650','2014-04-21','16:35:00',2.72),('9650','2014-04-21','16:40:00',3.6),('9650','2014-04-21','16:45:00',3.14),('9650','2014-04-21','16:50:00',2.37),('9650','2014-04-21','16:55:00',2.06),('9650','2014-04-21','17:00:00',2.42),('9650','2014-04-21','17:05:00',2.64),('9650','2014-04-21','17:10:00',2.03),('9650','2014-04-21','17:15:00',1.82),('9650','2014-04-21','17:20:00',1.38),('9650','2014-04-21','17:25:00',1.16),('9650','2014-04-21','17:30:00',1.09),('9650','2014-04-21','17:35:00',1.28),('9650','2014-04-21','17:40:00',1.3),('9650','2014-04-21','17:45:00',1.11),('9650','2014-04-20','08:25:00',1.05),('9650','2014-04-20','08:30:00',1.46),('9650','2014-04-20','08:35:00',1.41),('9650','2014-04-20','08:40:00',1.57),('9650','2014-04-20','08:45:00',1.56),('9650','2014-04-20','08:50:00',1.51),('9650','2014-04-20','08:55:00',1.5),('9650','2014-04-20','09:00:00',1.71),('9650','2014-04-20','09:05:00',1.71),('9650','2014-04-20','09:10:00',1.68),('9650','2014-04-20','09:15:00',1.65),('9650','2014-04-20','09:20:00',2.11),('9650','2014-04-20','09:25:00',1.73),('9650','2014-04-20','09:35:00',1.02),('9650','2014-04-20','09:40:00',1.52),('9650','2014-04-20','09:45:00',1.66),('9650','2014-04-20','09:50:00',1.67),('9650','2014-04-20','09:55:00',1.7),('9650','2014-04-20','10:00:00',2),('9650','2014-04-20','10:05:00',3.71),('9650','2014-04-20','10:10:00',4.09),('9650','2014-04-20','10:15:00',4.07),('9650','2014-04-20','10:20:00',3.87),('9650','2014-04-20','10:25:00',3.95),('9650','2014-04-20','10:30:00',3.97),('9650','2014-04-20','10:35:00',4.04),('9650','2014-04-20','10:40:00',4.14),('9650','2014-04-20','10:45:00',4.26),('9650','2014-04-20','10:50:00',4.36),('9650','2014-04-20','10:55:00',4.46),('9650','2014-04-20','11:00:00',4.56),('9650','2014-04-20','11:05:00',4.66),('9650','2014-04-20','11:10:00',4.76),('9650','2014-04-20','11:15:00',4.82),('9650','2014-04-20','11:20:00',4.93),('9650','2014-04-20','11:25:00',5.06),('9650','2014-04-20','11:30:00',5.15),('9650','2014-04-20','11:35:00',5.22),('9650','2014-04-20','11:40:00',5.32),('9650','2014-04-20','11:45:00',5.41),('9650','2014-04-20','11:50:00',5.47),('9650','2014-04-20','11:55:00',5.55),('9650','2014-04-20','12:00:00',5.66),('9650','2014-04-20','12:05:00',5.74),('9650','2014-04-20','12:10:00',5.82),('9650','2014-04-20','12:15:00',5.94),('9650','2014-04-20','12:20:00',6.02),('9650','2014-04-20','12:25:00',6.08),('9650','2014-04-20','12:30:00',6.16),('9650','2014-04-20','12:35:00',6.2),('9650','2014-04-20','12:40:00',6.25),('9650','2014-04-20','12:45:00',6.31),('9650','2014-04-20','12:50:00',6.37),('9650','2014-04-20','12:55:00',6.42),('9650','2014-04-20','13:00:00',6.47),('9650','2014-04-20','13:05:00',6.5),('9650','2014-04-20','13:10:00',6.53),('9650','2014-04-20','13:15:00',6.59),('9650','2014-04-20','13:20:00',6.62),('9650','2014-04-20','13:25:00',6.67),('9650','2014-04-20','13:30:00',6.7),('9650','2014-04-20','13:35:00',6.67),('9650','2014-04-20','13:40:00',6.75),('9650','2014-04-20','13:45:00',6.83),('9650','2014-04-20','13:50:00',6.87),('9650','2014-04-20','13:55:00',6.89),('9650','2014-04-20','14:00:00',6.93),('9650','2014-04-20','14:05:00',6.95),('9650','2014-04-20','14:10:00',6.98),('9650','2014-04-20','14:15:00',6.99),('9650','2014-04-20','14:20:00',6.97),('9650','2014-04-20','14:25:00',6.96),('9650','2014-04-20','14:30:00',6.96),('9650','2014-04-20','14:35:00',6.96),('9650','2014-04-20','14:40:00',6.93),('9650','2014-04-20','14:45:00',6.92),('9650','2014-04-20','14:50:00',6.92),('9650','2014-04-20','14:55:00',6.91),('9650','2014-04-20','15:00:00',6.9),('9650','2014-04-20','15:05:00',6.89),('9650','2014-04-20','15:10:00',6.83),('9650','2014-04-20','15:15:00',6.79),('9650','2014-04-20','15:20:00',6.76),('9650','2014-04-20','15:25:00',6.7),('9650','2014-04-20','15:30:00',6.66),('9650','2014-04-20','15:35:00',6.61),('9650','2014-04-20','15:40:00',6.56),('9650','2014-04-20','15:45:00',6.46),('9650','2014-04-20','15:50:00',6.39),('9650','2014-04-20','15:55:00',6.32),('9650','2014-04-20','16:00:00',6.31),('9650','2014-04-20','16:05:00',6.23),('9650','2014-04-20','16:10:00',6.17),('9650','2014-04-20','16:15:00',5.77),('9650','2014-04-20','16:20:00',6.04),('9650','2014-04-20','16:25:00',5.6),('9650','2014-04-20','16:30:00',5.81),('9650','2014-04-20','16:35:00',5.83),('9650','2014-04-20','16:40:00',5.73),('9650','2014-04-20','16:45:00',5.66),('9650','2014-04-20','16:50:00',5.55),('9650','2014-04-20','16:55:00',5.39),('9650','2014-04-20','17:00:00',5.26),('9650','2014-04-20','17:05:00',5.17),('9650','2014-04-20','17:10:00',5.02),('9650','2014-04-20','17:15:00',4.92),('9650','2014-04-20','17:20:00',4.83),('9650','2014-04-20','17:25:00',4.75),('9650','2014-04-20','17:30:00',4.69),('9650','2014-04-20','17:35:00',4.62),('9650','2014-04-20','17:40:00',4.21),('9650','2014-04-20','17:45:00',4.34),('9650','2014-04-20','17:50:00',4.22),('9650','2014-04-20','17:55:00',4.08),('9650','2014-04-20','18:00:00',3.93),('9650','2014-04-20','18:05:00',3.77),('9650','2014-04-20','18:10:00',3.6),('9650','2014-04-20','18:15:00',3.46),('9650','2014-04-20','18:20:00',3.31),('9650','2014-04-20','18:25:00',3.16),('9650','2014-04-20','18:30:00',2.97),('9650','2014-04-20','18:35:00',2.74),('9650','2014-04-20','18:40:00',2.56),('9650','2014-04-20','18:45:00',2.34),('9650','2014-04-20','18:50:00',2.17),('9650','2014-04-20','18:55:00',2.02),('9650','2014-04-20','19:00:00',1.91),('9650','2014-04-20','19:05:00',1.74),('9650','2014-04-20','19:10:00',1.48),('9650','2014-04-20','19:15:00',1.21),('9650','2014-04-19','08:20:00',1.33),('9650','2014-04-19','08:25:00',2.04),('9650','2014-04-19','08:30:00',2.12),('9650','2014-04-19','08:35:00',1.85),('9650','2014-04-19','08:40:00',1.28),('9650','2014-04-19','08:45:00',1.92),('9650','2014-04-19','08:50:00',1.72),('9650','2014-04-19','08:55:00',1.37),('9650','2014-04-19','09:00:00',1.65),('9650','2014-04-19','09:05:00',1.41),('9650','2014-04-19','09:10:00',2.28),('9650','2014-04-19','09:15:00',2.27),('9650','2014-04-19','09:20:00',2.43),('9650','2014-04-19','09:25:00',2.95),('9650','2014-04-19','09:30:00',3.8),('9650','2014-04-19','09:35:00',3.52),('9650','2014-04-19','09:40:00',2.34),('9650','2014-04-19','09:45:00',1.96),('9650','2014-04-19','09:50:00',2.29),('9650','2014-04-19','09:55:00',2.57),('9650','2014-04-19','10:00:00',3.08),('9650','2014-04-19','10:05:00',3.66),('9650','2014-04-19','10:10:00',3.4),('9650','2014-04-19','10:15:00',3.95),('9650','2014-04-19','10:20:00',4.02),('9650','2014-04-19','10:25:00',3.86),('9650','2014-04-19','10:30:00',3.79),('9650','2014-04-19','10:35:00',4.03),('9650','2014-04-19','10:40:00',3.78),('9650','2014-04-19','10:45:00',3.78),('9650','2014-04-19','10:50:00',3.94),('9650','2014-04-19','10:55:00',3.79),('9650','2014-04-19','11:00:00',4.41),('9650','2014-04-19','11:05:00',4.51),('9650','2014-04-19','11:10:00',4.68),('9650','2014-04-19','11:15:00',3.93),('9650','2014-04-19','11:20:00',2.97),('9650','2014-04-19','11:25:00',5.49),('9650','2014-04-19','11:30:00',5.71),('9650','2014-04-19','11:35:00',5.64),('9650','2014-04-19','11:40:00',4.13),('9650','2014-04-19','11:45:00',2.09),('9650','2014-04-19','11:50:00',2.91),('9650','2014-04-19','11:55:00',4.23),('9650','2014-04-19','12:00:00',6.3),('9650','2014-04-19','12:05:00',6.34),('9650','2014-04-19','12:10:00',4.03),('9650','2014-04-19','12:15:00',2.07),('9650','2014-04-19','12:20:00',3.9),('9650','2014-04-19','12:25:00',6.52),('9650','2014-04-19','12:30:00',5.03),('9650','2014-04-19','12:35:00',6.69),('9650','2014-04-19','12:40:00',6.7),('9650','2014-04-19','12:45:00',6.68),('9650','2014-04-19','12:50:00',6.77),('9650','2014-04-19','12:55:00',6.76),('9650','2014-04-19','13:00:00',6.77),('9650','2014-04-19','13:05:00',6.8),('9650','2014-04-19','13:10:00',6.94),('9650','2014-04-19','13:15:00',7.09),('9650','2014-04-19','13:20:00',6.84),('9650','2014-04-19','13:25:00',6.87),('9650','2014-04-19','13:30:00',6.93),('9650','2014-04-19','13:35:00',6.97),('9650','2014-04-19','13:40:00',6.99),('9650','2014-04-19','13:45:00',6.99),('9650','2014-04-19','13:50:00',7.02),('9650','2014-04-19','13:55:00',7.05),('9650','2014-04-19','14:00:00',7.04),('9650','2014-04-19','14:05:00',7.09),('9650','2014-04-19','14:10:00',7.17),('9650','2014-04-19','14:15:00',7.61),('9650','2014-04-19','14:20:00',5.64),('9650','2014-04-19','14:25:00',5.78),('9650','2014-04-19','14:30:00',5.2),('9650','2014-04-19','14:35:00',4.31),('9650','2014-04-19','14:40:00',4.25),('9650','2014-04-19','14:45:00',4.71),('9650','2014-04-19','14:50:00',4.59),('9650','2014-04-19','14:55:00',5.21),('9650','2014-04-19','15:00:00',6.81),('9650','2014-04-19','15:05:00',6.47),('9650','2014-04-19','15:10:00',7.04),('9650','2014-04-19','15:15:00',7.06),('9650','2014-04-19','15:20:00',6.86),('9650','2014-04-19','15:25:00',6.85),('9650','2014-04-19','15:30:00',6.81),('9650','2014-04-19','15:35:00',6.67),('9650','2014-04-19','15:40:00',6.88),('9650','2014-04-19','15:45:00',5.95),('9650','2014-04-19','15:50:00',5.19),('9650','2014-04-19','15:55:00',6.61),('9650','2014-04-19','16:00:00',6.36),('9650','2014-04-19','16:05:00',6.27),('9650','2014-04-19','16:10:00',6.23),('9650','2014-04-19','16:15:00',6.21),('9650','2014-04-19','16:20:00',6.16),('9650','2014-04-19','16:25:00',5.46),('9650','2014-04-19','16:30:00',6.25),('9650','2014-04-19','16:35:00',5.91),('9650','2014-04-19','16:40:00',5.05),('9650','2014-04-19','16:45:00',4.58),('9650','2014-04-19','16:50:00',5.61),('9650','2014-04-19','16:55:00',5.64),('9650','2014-04-19','17:00:00',5.34),('9650','2014-04-19','17:05:00',5.14),('9650','2014-04-19','17:10:00',4.96),('9650','2014-04-19','17:15:00',4.86),('9650','2014-04-19','17:20:00',4.82),('9650','2014-04-19','17:25:00',4.72),('9650','2014-04-19','17:30:00',4.61),('9650','2014-04-19','17:35:00',4.55),('9650','2014-04-19','17:40:00',4.41),('9650','2014-04-19','17:45:00',4.28),('9650','2014-04-19','17:50:00',4.16),('9650','2014-04-19','17:55:00',4.02),('9650','2014-04-19','18:00:00',3.9),('9650','2014-04-19','18:05:00',3.72),('9650','2014-04-19','18:10:00',3.57),('9650','2014-04-19','18:15:00',3.27),('9650','2014-04-19','18:20:00',2.25),('9650','2014-04-19','18:25:00',1.82),('9650','2014-04-19','18:30:00',2.79),('9650','2014-04-19','18:35:00',2.8),('9650','2014-04-19','18:40:00',2.38),('9650','2014-04-19','18:45:00',1.24),('9650','2014-04-18','07:50:00',1.17),('9650','2014-04-18','07:55:00',1.71),('9650','2014-04-18','08:00:00',1.61),('9650','2014-04-18','08:05:00',1.47),('9650','2014-04-18','08:10:00',1.61),('9650','2014-04-18','08:15:00',1.61),('9650','2014-04-18','08:20:00',1.84),('9650','2014-04-18','08:25:00',2.06),('9650','2014-04-18','08:30:00',2.25),('9650','2014-04-18','08:35:00',2.3),('9650','2014-04-18','08:40:00',2.43),('9650','2014-04-18','08:45:00',2.56),('9650','2014-04-18','08:50:00',2.24),('9650','2014-04-18','08:55:00',1.47),('9650','2014-04-18','09:10:00',1.12),('9650','2014-04-18','09:15:00',1.29),('9650','2014-04-18','09:20:00',1.79),('9650','2014-04-18','09:25:00',2.41),('9650','2014-04-18','09:30:00',3.12),('9650','2014-04-18','09:35:00',2.98),('9650','2014-04-18','09:40:00',1.96),('9650','2014-04-18','09:45:00',1.48),('9650','2014-04-18','09:50:00',1.28),('9650','2014-04-18','09:55:00',1.21),('9650','2014-04-18','10:00:00',1.26),('9650','2014-04-18','10:15:00',1.11),('9650','2014-04-18','10:20:00',1.25),('9650','2014-04-18','10:25:00',1.23),('9650','2014-04-18','10:30:00',1.25),('9650','2014-04-18','10:35:00',1.63),('9650','2014-04-18','10:40:00',2.2),('9650','2014-04-18','10:45:00',2.11),('9650','2014-04-18','10:50:00',2.27),('9650','2014-04-18','10:55:00',2.88),('9650','2014-04-18','11:00:00',2.8),('9650','2014-04-18','11:05:00',2.24),('9650','2014-04-18','11:10:00',2.29),('9650','2014-04-18','11:15:00',3.24),('9650','2014-04-18','11:20:00',4.63),('9650','2014-04-18','11:25:00',3.95),('9650','2014-04-18','11:30:00',4.21),('9650','2014-04-18','11:35:00',4.37),('9650','2014-04-18','11:40:00',4.07),('9650','2014-04-18','11:45:00',3.53),('9650','2014-04-18','11:50:00',2.75),('9650','2014-04-18','11:55:00',1.8),('9650','2014-04-18','12:00:00',1.47),('9650','2014-04-18','12:05:00',1.19),('9650','2014-04-18','13:05:00',1.21),('9650','2014-04-18','13:10:00',1.13),('9650','2014-04-18','13:15:00',2.59),('9650','2014-04-18','13:20:00',2.33),('9650','2014-04-18','13:25:00',1.27),('9650','2014-04-18','13:35:00',1.54),('9650','2014-04-18','13:40:00',1.37),('9650','2014-04-18','13:45:00',1.03),('9650','2014-04-18','13:50:00',1.45),('9650','2014-04-18','13:55:00',1.6),('9650','2014-04-18','14:25:00',1.13),('9650','2014-04-18','14:30:00',2.47),('9650','2014-04-18','14:35:00',2.55),('9650','2014-04-18','14:40:00',3.05),('9650','2014-04-18','14:45:00',3.17),('9650','2014-04-18','14:50:00',1.96),('9650','2014-04-18','14:55:00',1.77),('9650','2014-04-18','15:00:00',2.46),('9650','2014-04-18','15:05:00',2.12),('9650','2014-04-18','15:10:00',1.02),('9650','2014-04-18','15:20:00',1.18),('9650','2014-04-18','15:25:00',1.92),('9650','2014-04-18','15:30:00',1.8),('9650','2014-04-18','15:35:00',1.06),('9650','2014-04-18','15:45:00',1.99),('9650','2014-04-18','15:50:00',6.53),('9650','2014-04-18','15:55:00',5.26),('9650','2014-04-18','16:00:00',4.07),('9650','2014-04-18','16:05:00',4.02),('9650','2014-04-18','16:10:00',3.41),('9650','2014-04-18','16:15:00',3.14),('9650','2014-04-18','16:20:00',3.6),('9650','2014-04-18','16:25:00',3.66),('9650','2014-04-18','16:30:00',5.69),('9650','2014-04-18','16:35:00',2.8),('9650','2014-04-18','16:40:00',2.05),('9650','2014-04-18','16:45:00',1.85),('9650','2014-04-18','16:50:00',1.33),('9650','2014-04-18','17:00:00',1.13),('9650','2014-04-18','17:05:00',1.65),('9650','2014-04-18','17:10:00',1.78),('9650','2014-04-18','17:15:00',2.1),('9650','2014-04-18','17:20:00',3.58),('9650','2014-04-18','17:25:00',2.64),('9650','2014-04-18','17:30:00',2.33),('9650','2014-04-18','17:35:00',1.86),('9650','2014-04-18','17:40:00',1.11),('9650','2013-11-08','09:15:00',1.01),('9650','2013-11-08','09:30:00',1),('9650','2013-11-08','09:35:00',1.06),('9650','2013-11-08','09:40:00',1.82),('9650','2013-11-08','09:45:00',1.65),('9650','2013-11-08','09:50:00',2.22),('9650','2013-11-08','09:55:00',2.07),('9650','2013-11-08','10:00:00',1.89),('9650','2013-11-08','10:05:00',1.9),('9650','2013-11-08','10:10:00',1.79),('9650','2013-11-08','10:15:00',1.84),('9650','2013-11-08','10:20:00',1.85),('9650','2013-11-08','10:25:00',1.77),('9650','2013-11-08','10:30:00',1.82),('9650','2013-11-08','10:35:00',2.14),('9650','2013-11-08','10:40:00',2.08),('9650','2013-11-08','10:45:00',2.1),('9650','2013-11-08','10:50:00',2.37),('9650','2013-11-08','10:55:00',2.83),('9650','2013-11-08','11:00:00',2.7),('9650','2013-11-08','11:05:00',3.53),('9650','2013-11-08','11:10:00',3.85),('9650','2013-11-08','11:15:00',4.29),('9650','2013-11-07','09:05:00',1.14),('9650','2013-11-07','09:10:00',1.42),('9650','2013-11-07','09:15:00',1.3),('9650','2013-11-07','09:20:00',1.26),('9650','2013-11-07','09:25:00',1.55),('9650','2013-11-07','09:30:00',1.85),('9650','2013-11-07','09:35:00',2.13),('9650','2013-11-07','09:40:00',1.51),('9650','2013-11-07','09:45:00',1.2),('9650','2013-11-07','09:50:00',1.83),('9650','2013-11-07','09:55:00',1.49),('9650','2013-11-07','10:00:00',1.95),('9650','2013-11-07','10:05:00',1.78),('9650','2013-11-07','10:10:00',1.68),('9650','2013-11-07','10:25:00',1.05),('9650','2013-11-07','10:40:00',1.18),('9650','2013-11-07','10:45:00',1.48),('9650','2013-11-07','10:50:00',2.59),('9650','2013-11-07','10:55:00',1.49),('9650','2013-11-07','11:00:00',1.2),('9650','2013-11-07','11:05:00',1.28),('9650','2013-11-07','11:10:00',1.28),('9650','2013-11-07','11:15:00',1.5),('9650','2013-11-07','11:20:00',1.81),('9650','2013-11-07','11:25:00',1.71),('9650','2013-11-07','11:30:00',1.75),('9650','2013-11-07','11:35:00',2.57),('9650','2013-11-07','11:40:00',3.7),('9650','2013-11-07','11:45:00',3.72),('9650','2013-11-07','11:50:00',3.69),('9650','2013-11-07','11:55:00',3.67),('9650','2013-11-07','12:00:00',2.78),('9650','2013-11-07','12:05:00',3.1),('9650','2013-11-07','12:10:00',3.25),('9650','2013-11-07','12:20:00',1.23),('9650','2013-11-07','12:35:00',2.83),('9650','2013-11-07','12:40:00',3.85),('9650','2013-11-07','12:45:00',3.91),('9650','2013-11-07','12:50:00',4.06),('9650','2013-11-07','12:55:00',4.1),('9650','2013-11-07','13:00:00',3.92),('9650','2013-11-07','13:05:00',3.85),('9650','2013-11-07','13:10:00',4.03),('9650','2013-11-07','13:15:00',2.34),('9650','2013-11-07','13:20:00',3.44),('9650','2013-11-07','13:25:00',1.94),('9650','2013-11-07','13:30:00',1.38),('9650','2013-11-07','13:35:00',3.29),('9650','2013-11-07','13:40:00',3.24),('9650','2013-11-07','13:45:00',3.12),('9650','2013-11-07','13:50:00',2.41),('9650','2013-11-07','13:55:00',3.14),('9650','2013-11-07','14:00:00',2.98),('9650','2013-11-07','14:05:00',2.85),('9650','2013-11-07','14:10:00',2.79),('9650','2013-11-07','14:15:00',2.7),('9650','2013-11-07','14:20:00',2.37),('9650','2013-11-07','14:25:00',2.51),('9650','2013-11-07','14:30:00',2.49),('9650','2013-11-07','14:35:00',2.39),('9650','2013-11-07','14:40:00',2.04),('9650','2013-11-07','14:45:00',1.97),('9650','2013-11-07','14:50:00',1.75),('9650','2013-11-07','14:55:00',1.05),('9650','2013-11-07','15:00:00',1.62),('9650','2013-11-07','15:05:00',1.71),('9650','2013-11-07','15:10:00',1.75),('9650','2013-11-07','15:15:00',1.27),('9650','2013-11-07','15:25:00',1.04),('9650','2013-11-07','15:30:00',1.13),('9650','2014-04-17','08:05:00',1.28),('9650','2014-04-17','08:10:00',1.29),('9650','2014-04-17','08:35:00',1.06),('9650','2014-04-17','08:40:00',1.59),('9650','2014-04-17','08:45:00',1.82),('9650','2014-04-17','08:50:00',1.62),('9650','2014-04-17','08:55:00',1.68),('9650','2014-04-17','09:00:00',1.84),('9650','2014-04-17','09:05:00',2.63),('9650','2014-04-17','09:10:00',3.31),('9650','2014-04-17','09:15:00',2.84),('9650','2014-04-17','09:20:00',2.73),('9650','2014-04-17','09:25:00',2.07),('9650','2014-04-17','09:30:00',3.35),('9650','2014-04-17','09:35:00',2.19),('9650','2014-04-17','09:40:00',1.53),('9650','2014-04-17','09:45:00',2.33),('9650','2014-04-17','09:50:00',3.67),('9650','2014-04-17','09:55:00',4.11),('9650','2014-04-17','10:00:00',3.64),('9650','2014-04-17','10:05:00',2.67),('9650','2014-04-17','10:10:00',2.48),('9650','2014-04-17','10:15:00',2.62),('9650','2014-04-17','10:20:00',2.53),('9650','2014-04-17','10:25:00',2.63),('9650','2014-04-17','10:30:00',2.27),('9650','2014-04-17','10:35:00',2.13),('9650','2014-04-17','10:40:00',2.38),('9650','2014-04-17','10:45:00',3.37),('9650','2014-04-17','10:50:00',3.85),('9650','2014-04-17','10:55:00',4.24),('9650','2014-04-17','11:00:00',3.1),('9650','2014-04-17','11:05:00',2.91),('9650','2014-04-17','11:10:00',3.13),('9650','2014-04-17','11:15:00',4.61),('9650','2014-04-17','11:20:00',3.15),('9650','2014-04-17','11:25:00',2.5),('9650','2014-04-17','11:30:00',2.94),('9650','2014-04-17','11:35:00',2.94),('9650','2014-04-17','11:40:00',3.07),('9650','2014-04-17','11:45:00',2.99),('9650','2014-04-17','11:50:00',3.56),('9650','2014-04-17','11:55:00',3.03),('9650','2014-04-17','12:00:00',3.21),('9650','2014-04-17','12:05:00',5.55),('9650','2014-04-17','12:10:00',5.47),('9650','2014-04-17','12:15:00',5.27),('9650','2014-04-17','12:20:00',5.77),('9650','2014-04-17','12:25:00',4.38),('9650','2014-04-17','12:30:00',6.66),('9650','2014-04-17','12:35:00',6.36),('9650','2014-04-17','12:40:00',6.78),('9650','2014-04-17','12:45:00',5.56),('9650','2014-04-17','12:50:00',5.62),('9650','2014-04-17','12:55:00',4.12),('9650','2014-04-17','13:00:00',6.92),('9650','2014-04-17','13:05:00',4.28),('9650','2014-04-17','13:10:00',4.15),('9650','2014-04-17','13:15:00',4.09),('9650','2014-04-17','13:20:00',3.97),('9650','2014-04-17','13:25:00',2.99),('9650','2014-04-17','13:30:00',2.4),('9650','2014-04-17','13:35:00',2.44),('9650','2014-04-17','13:40:00',2.38),('9650','2014-04-17','13:45:00',2.09),('9650','2014-04-17','13:50:00',2.43),('9650','2014-04-17','13:55:00',4.19),('9650','2014-04-17','14:00:00',3.63),('9650','2014-04-17','14:05:00',3.06),('9650','2014-04-17','14:10:00',2.69),('9650','2014-04-17','14:15:00',2.41),('9650','2014-04-17','14:20:00',2.8),('9650','2014-04-17','14:25:00',3.56),('9650','2014-04-17','14:30:00',3.97),('9650','2014-04-17','14:35:00',4.57),('9650','2014-04-17','14:40:00',3.96),('9650','2014-04-17','14:45:00',4.73),('9650','2014-04-17','14:50:00',5.25),('9650','2014-04-17','14:55:00',4.03),('9650','2014-04-17','15:00:00',7.75),('9650','2014-04-17','15:05:00',4.49),('9650','2014-04-17','15:10:00',3.21),('9650','2014-04-17','15:15:00',3.69),('9650','2014-04-17','15:20:00',3.22),('9650','2014-04-17','15:25:00',3.8),('9650','2014-04-17','15:30:00',6.42),('9650','2014-04-17','15:35:00',6.76),('9650','2014-04-17','15:40:00',5.88),('9650','2014-04-17','15:45:00',4.31),('9650','2014-04-17','15:50:00',5.35),('9650','2014-04-17','15:55:00',5.12),('9650','2014-04-17','16:00:00',4.36),('9650','2014-04-17','16:05:00',3.39),('9650','2014-04-17','16:10:00',2.69),('9650','2014-04-17','16:15:00',2.33),('9650','2014-04-17','16:20:00',2.46),('9650','2014-04-17','16:25:00',4.32),('9650','2014-04-17','16:30:00',4.31),('9650','2014-04-17','16:35:00',5.34),('9650','2014-04-17','16:40:00',6.18),('9650','2014-04-17','16:45:00',5.83),('9650','2014-04-17','16:50:00',5.85),('9650','2014-04-17','16:55:00',4.78),('9650','2014-04-17','17:00:00',5.28),('9650','2014-04-17','17:05:00',5.9),('9650','2014-04-17','17:10:00',5.18),('9650','2014-04-17','17:15:00',4.57),('9650','2014-04-17','17:20:00',4.66),('9650','2014-04-17','17:25:00',4.78),('9650','2014-04-17','17:30:00',4.51),('9650','2014-04-17','17:35:00',4.34),('9650','2014-04-17','17:40:00',4.37),('9650','2014-04-17','17:45:00',4.23),('9650','2014-04-17','17:50:00',4.14),('9650','2014-04-17','17:55:00',4.03),('9650','2014-04-17','18:00:00',3.93),('9650','2014-04-17','18:05:00',3.59),('9650','2014-04-17','18:10:00',3.4),('9650','2014-04-17','18:15:00',2.95),('9650','2014-04-17','18:20:00',3.08),('9650','2014-04-17','18:25:00',2.81),('9650','2014-04-17','18:30:00',2.03),('9650','2014-04-17','18:35:00',2.48),('9650','2014-04-17','18:40:00',2.3),('9650','2014-04-17','18:45:00',2.28),('9650','2014-04-17','18:50:00',2),('9650','2014-04-17','18:55:00',1.82),('9650','2014-04-17','19:00:00',1.57),('9650','2014-04-17','19:05:00',1.31),('9650','2013-11-06','09:40:00',1.05),('9650','2013-11-06','09:45:00',1.13),('9650','2013-11-06','09:50:00',1.22),('9650','2013-11-06','09:55:00',1.32),('9650','2013-11-06','10:00:00',1.4),('9650','2013-11-06','10:05:00',1.5),('9650','2013-11-06','10:10:00',1.58),('9650','2013-11-06','10:15:00',1.68),('9650','2013-11-06','10:20:00',1.76),('9650','2013-11-06','10:25:00',1.86),('9650','2013-11-06','10:30:00',1.94),('9650','2013-11-06','10:35:00',2.02),('9650','2013-11-06','10:40:00',2.11),('9650','2013-11-06','10:45:00',2.2),('9650','2013-11-06','10:50:00',2.26),('9650','2013-11-06','10:55:00',2.33),('9650','2013-11-06','11:00:00',2.4),('9650','2013-11-06','11:05:00',2.48),('9650','2013-11-06','11:10:00',2.53),('9650','2013-11-06','11:15:00',2.58),('9650','2013-11-06','11:20:00',2.64),('9650','2013-11-06','11:25:00',2.7),('9650','2013-11-06','11:30:00',2.79),('9650','2013-11-06','11:35:00',2.85),('9650','2013-11-06','11:40:00',2.87),('9650','2013-11-06','11:45:00',2.93),('9650','2013-11-06','11:50:00',2.98),('9650','2013-11-06','11:55:00',3.02),('9650','2013-11-06','12:00:00',3.02),('9650','2013-11-06','12:05:00',3.04),('9650','2013-11-06','12:10:00',3.07),('9650','2013-11-06','12:15:00',3.15),('9650','2013-11-06','12:20:00',3.17),('9650','2013-11-06','12:25:00',3.2),('9650','2013-11-06','12:30:00',3.27),('9650','2013-11-06','12:35:00',3.31),('9650','2013-11-06','12:40:00',3.3),('9650','2013-11-06','12:45:00',3.36),('9650','2013-11-06','12:50:00',3.38),('9650','2013-11-06','12:55:00',3.32),('9650','2013-11-06','13:00:00',3.84),('9650','2013-11-06','13:05:00',3.78),('9650','2013-11-06','13:10:00',3.42),('9650','2013-11-06','13:15:00',1.75),('9650','2013-11-06','13:20:00',1.66),('9650','2013-11-06','13:25:00',1.84),('9650','2013-11-06','13:30:00',2.25),('9650','2013-11-06','13:35:00',3.89),('9650','2013-11-06','13:40:00',2.85),('9650','2013-11-06','13:45:00',2.33),('9650','2013-11-06','13:50:00',3.58),('9650','2013-11-06','13:55:00',2.34),('9650','2013-11-06','14:00:00',1.8),('9650','2013-11-06','14:05:00',1.85),('9650','2013-11-06','14:10:00',2.09),('9650','2013-11-06','14:15:00',2.09),('9650','2013-11-06','14:20:00',1.97),('9650','2013-11-06','14:25:00',1.94),('9650','2013-11-06','14:30:00',2.28),('9650','2013-11-06','14:35:00',1.76),('9650','2013-11-06','14:40:00',2.01),('9650','2013-11-06','14:45:00',1.9),('9650','2013-11-06','14:50:00',1.92),('9650','2013-11-06','14:55:00',1.85),('9650','2013-11-06','15:00:00',1.79),('9650','2013-11-06','15:05:00',1.74),('9650','2013-11-06','15:10:00',1.7),('9650','2013-11-06','15:15:00',1.67),('9650','2013-11-06','15:20:00',1.58),('9650','2013-11-06','15:25:00',1.5),('9650','2013-11-06','15:30:00',1.44),('9650','2013-11-06','15:35:00',1.29),('9650','2013-11-06','15:40:00',1.22),('9650','2013-11-06','15:45:00',1.12),('9650','2013-11-05','09:40:00',1.1),('9650','2013-11-05','09:45:00',1.18),('9650','2013-11-05','09:50:00',1.24),('9650','2013-11-05','09:55:00',1.27),('9650','2013-11-05','10:00:00',1.3),('9650','2013-11-05','10:05:00',1.43),('9650','2013-11-05','10:10:00',1.67),('9650','2013-11-05','10:15:00',1.77),('9650','2013-11-05','10:20:00',1.86),('9650','2013-11-05','10:25:00',1.97),('9650','2013-11-05','10:30:00',2.06),('9650','2013-11-05','10:35:00',2.14),('9650','2013-11-05','10:40:00',2.24),('9650','2013-11-05','10:45:00',2.33),('9650','2013-11-05','10:50:00',2.42),('9650','2013-11-05','10:55:00',2.49),('9650','2013-11-05','11:00:00',2.6),('9650','2013-11-05','11:05:00',2.67),('9650','2013-11-05','11:10:00',2.74),('9650','2013-11-05','11:15:00',2.82),('9650','2013-11-05','11:20:00',2.88),('9650','2013-11-05','11:25:00',2.95),('9650','2013-11-05','11:30:00',3.02),('9650','2013-11-05','11:35:00',3.06),('9650','2013-11-05','11:40:00',3.11),('9650','2013-11-05','11:45:00',3.14),('9650','2013-11-05','11:50:00',3.19),('9650','2013-11-05','11:55:00',3.22),('9650','2013-11-05','12:00:00',3.28),('9650','2013-11-05','12:05:00',3.34),('9650','2013-11-05','12:10:00',3.35),('9650','2013-11-05','12:15:00',3.39),('9650','2013-11-05','12:20:00',3.43),('9650','2013-11-05','12:25:00',3.46),('9650','2013-11-05','12:30:00',3.48),('9650','2013-11-05','12:35:00',3.51),('9650','2013-11-05','12:40:00',3.52),('9650','2013-11-05','12:45:00',3.55),('9650','2013-11-05','12:50:00',3.56),('9650','2013-11-05','12:55:00',3.56),('9650','2013-11-05','13:00:00',3.55),('9650','2013-11-05','13:05:00',3.47),('9650','2013-11-05','13:10:00',3.37),('9650','2013-11-05','13:15:00',3.31),('9650','2013-11-05','13:20:00',3.24),('9650','2013-11-05','13:25:00',3.21),('9650','2013-11-05','13:30:00',3.16),('9650','2013-11-05','13:35:00',3.1),('9650','2013-11-05','13:40:00',3.1),('9650','2013-11-05','13:45:00',3.08),('9650','2013-11-05','13:50:00',3.1),('9650','2013-11-05','13:55:00',3.05),('9650','2013-11-05','14:00:00',2.88),('9650','2013-11-05','14:05:00',2.81),('9650','2013-11-05','14:10:00',2.83),('9650','2013-11-05','14:15:00',2.75),('9650','2013-11-05','14:20:00',2.65),('9650','2013-11-05','14:25:00',2.6),('9650','2013-11-05','14:30:00',2.39),('9650','2013-11-05','14:35:00',2.18),('9650','2013-11-05','14:40:00',2.05),('9650','2013-11-05','14:45:00',2.05),('9650','2013-11-05','14:50:00',2.03),('9650','2013-11-05','14:55:00',1.88),('9650','2013-11-05','15:00:00',1.86),('9650','2013-11-05','15:05:00',1.82),('9650','2013-11-05','15:10:00',1.79),('9650','2013-11-05','15:15:00',1.76),('9650','2013-11-05','15:20:00',1.67),('9650','2013-11-05','15:25:00',1.59),('9650','2013-11-05','15:30:00',1.45),('9650','2013-11-05','15:35:00',1.37),('9650','2013-11-05','15:40:00',1.26),('9650','2013-11-05','15:45:00',1.2),('9650','2013-11-05','15:50:00',1.07),('9650','2013-11-04','08:25:00',1.07),('9650','2013-11-04','08:30:00',1.1),('9650','2013-11-04','08:35:00',1.21),('9650','2013-11-04','08:40:00',1.26),('9650','2013-11-04','08:45:00',1.23),('9650','2013-11-04','08:50:00',1.21),('9650','2013-11-04','09:55:00',1.02),('9650','2013-11-04','10:00:00',1.31),('9650','2013-11-04','10:05:00',1.23),('9650','2013-11-04','10:10:00',1.12),('9650','2013-11-04','10:15:00',1.45),('9650','2013-11-04','10:20:00',2.18),('9650','2013-11-04','10:25:00',2.72),('9650','2013-11-04','10:30:00',2.36),('9650','2013-11-04','10:35:00',2.94),('9650','2013-11-04','10:40:00',2.34),('9650','2013-11-04','10:45:00',2.48),('9650','2013-11-04','10:50:00',2.27),('9650','2013-11-04','10:55:00',2.02),('9650','2013-11-04','11:00:00',1.71),('9650','2013-11-04','11:05:00',1.31),('9650','2013-11-04','11:10:00',1.03),('9650','2013-11-04','11:20:00',1.12),('9650','2013-11-04','11:25:00',1.34),('9650','2013-11-04','11:30:00',1.52),('9650','2013-11-04','11:35:00',1.95),('9650','2013-11-04','11:40:00',2.48),('9650','2013-11-04','11:45:00',2.4),('9650','2013-11-04','11:50:00',2.23),('9650','2013-11-04','11:55:00',1.95),('9650','2013-11-04','12:00:00',1.67),('9650','2013-11-04','12:05:00',1.9),('9650','2013-11-04','12:10:00',2.41),('9650','2013-11-04','12:15:00',2.41),('9650','2013-11-04','12:20:00',2.75),('9650','2013-11-04','12:25:00',2.51),('9650','2013-11-04','12:30:00',2.11),('9650','2013-11-04','12:35:00',1.69),('9650','2013-11-04','12:40:00',1.38),('9650','2013-11-04','12:45:00',1.18),('9650','2013-11-04','12:50:00',1.21),('9650','2013-11-04','12:55:00',1.49),('9650','2013-11-04','13:00:00',1.59),('9650','2013-11-04','13:05:00',1.27),('9650','2013-11-04','13:10:00',1.31),('9650','2013-11-04','13:20:00',1.02),('9650','2013-11-04','13:25:00',1.4),('9650','2013-11-04','13:30:00',2),('9650','2013-11-04','13:35:00',3.59),('9650','2013-11-04','13:40:00',3.63),('9650','2013-11-04','13:45:00',3.49),('9650','2013-11-04','13:50:00',1.99),('9650','2013-11-04','13:55:00',1.97),('9650','2013-11-04','14:00:00',2.75),('9650','2013-11-04','14:05:00',2.92),('9650','2013-11-04','14:10:00',4.01),('9650','2013-11-04','14:15:00',1.42),('9650','2013-11-04','14:20:00',2.62),('9650','2013-11-04','14:25:00',2.46),('9650','2013-11-04','14:30:00',2.58),('9650','2013-11-04','14:35:00',2.64),('9650','2013-11-04','14:40:00',1.1),('9650','2013-11-04','14:45:00',1.78),('9650','2013-11-04','14:50:00',1.21),('9650','2013-11-04','15:05:00',1.27),('9650','2013-11-04','15:15:00',1.26),('9650','2013-11-04','15:30:00',1.56),('9650','2013-11-04','15:35:00',1.79),('9650','2013-11-04','16:05:00',1.09),('9650','2013-11-03','09:15:00',1.33),('9650','2013-11-03','09:20:00',1.72),('9650','2013-11-03','09:25:00',2.23),('9650','2013-11-03','09:30:00',1.41),('9650','2013-11-03','10:00:00',1.2),('9650','2013-11-03','10:05:00',1.94),('9650','2013-11-03','10:10:00',2.04),('9650','2013-11-03','10:15:00',2.24),('9650','2013-11-03','10:20:00',2.35),('9650','2013-11-03','10:25:00',2.83),('9650','2013-11-03','10:30:00',3.17),('9650','2013-11-03','10:35:00',2.87),('9650','2013-11-03','10:40:00',3.29),('9650','2013-11-03','10:45:00',2.75),('9650','2013-11-03','10:50:00',2.58),('9650','2013-11-03','10:55:00',3.3),('9650','2013-11-03','11:00:00',3.3),('9650','2013-11-03','11:05:00',3.44),('9650','2013-11-03','11:10:00',1.98),('9650','2013-11-03','11:15:00',3.03),('9650','2013-11-03','11:20:00',2.03),('9650','2013-11-03','11:25:00',1.84),('9650','2013-11-03','11:30:00',3.23),('9650','2013-11-03','11:35:00',3.76),('9650','2013-11-03','11:40:00',2.96),('9650','2013-11-03','11:45:00',3.61),('9650','2013-11-03','11:50:00',4.93),('9650','2013-11-03','11:55:00',4.15),('9650','2013-11-03','12:00:00',3.91),('9650','2013-11-03','12:05:00',3.63),('9650','2013-11-03','12:10:00',3.67),('9650','2013-11-03','12:15:00',3.63),('9650','2013-11-03','12:20:00',3.24),('9650','2013-11-03','12:25:00',3.67),('9650','2013-11-03','12:30:00',3.71),('9650','2013-11-03','12:35:00',3.62),('9650','2013-11-03','12:40:00',3.77),('9650','2013-11-03','12:45:00',3.77),('9650','2013-11-03','12:50:00',3.69),('9650','2013-11-03','12:55:00',3.68),('9650','2013-11-03','13:00:00',3.65),('9650','2013-11-03','13:05:00',3.63),('9650','2013-11-03','13:10:00',3.46),('9650','2013-11-03','13:15:00',3.63),('9650','2013-11-03','13:20:00',2.71),('9650','2013-11-03','13:25:00',3.46),('9650','2013-11-03','13:30:00',3.45),('9650','2013-11-03','13:35:00',3.65),('9650','2013-11-03','13:40:00',2.94),('9650','2013-11-03','13:45:00',3.75),('9650','2013-11-03','13:50:00',3.59),('9650','2013-11-03','13:55:00',2.61),('9650','2013-11-03','14:00:00',2.14),('9650','2013-11-03','14:05:00',2.75),('9650','2013-11-03','14:10:00',3.4),('9650','2013-11-03','14:15:00',3.51),('9650','2013-11-03','14:20:00',3.41),('9650','2013-11-03','14:25:00',2.2),('9650','2013-11-03','14:30:00',2.28),('9650','2013-11-03','14:35:00',3.09),('9650','2013-11-03','14:40:00',2.61),('9650','2013-11-03','14:45:00',2.4),('9650','2013-11-03','14:50:00',2.48),('9650','2013-11-03','14:55:00',2.18),('9650','2013-11-03','15:00:00',2.18),('9650','2013-11-03','15:05:00',1.45),('9650','2013-11-03','15:10:00',1.71),('9650','2013-11-03','15:15:00',1.78),('9650','2013-11-03','15:20:00',1.82),('9650','2013-11-03','15:25:00',1.83),('9650','2013-11-03','15:30:00',1.67),('9650','2013-11-03','15:35:00',1.91),('9650','2013-11-03','15:40:00',1.84),('9650','2013-11-03','15:45:00',1.8),('9650','2013-11-03','15:50:00',1.44),('9650','2013-11-02','08:50:00',1.02),('9650','2013-11-02','08:55:00',1.13),('9650','2013-11-02','09:40:00',1.87),('9650','2013-11-02','09:45:00',1.79),('9650','2013-11-02','09:50:00',1.48),('9650','2013-11-02','10:05:00',1.12),('9650','2013-11-02','10:10:00',1.52),('9650','2013-11-02','10:20:00',2.07),('9650','2013-11-02','10:25:00',1.86),('9650','2013-11-02','10:30:00',2.22),('9650','2013-11-02','10:35:00',1.7),('9650','2013-11-02','11:10:00',1.15),('9650','2013-11-02','11:15:00',1.56),('9650','2013-11-02','11:20:00',2.3),('9650','2013-11-02','11:25:00',1.58),('9650','2013-11-02','11:30:00',2.63),('9650','2013-11-02','11:35:00',3.2),('9650','2013-11-02','11:40:00',3.83),('9650','2013-11-02','11:45:00',4.06),('9650','2013-11-02','11:50:00',4.37),('9650','2013-11-02','11:55:00',3.4),('9650','2013-11-02','12:00:00',4.46),('9650','2013-11-02','12:05:00',4.59),('9650','2013-11-02','12:10:00',4.55),('9650','2013-11-02','12:15:00',2.59),('9650','2013-11-02','12:20:00',1.37),('9650','2013-11-02','12:25:00',2.35),('9650','2013-11-02','12:30:00',1.66),('9650','2013-11-02','12:35:00',1.79),('9650','2013-11-02','12:40:00',2.2),('9650','2013-11-02','12:45:00',1.86),('9650','2013-11-02','12:50:00',1.9),('9650','2013-11-02','12:55:00',1.6),('9650','2013-11-02','13:00:00',1.45),('9650','2013-11-02','13:05:00',1.57),('9650','2013-11-02','13:10:00',1.71),('9650','2013-11-02','13:15:00',1.52),('9650','2013-11-02','13:20:00',1.64),('9650','2013-11-02','13:25:00',1.71),('9650','2013-11-02','13:30:00',1.65),('9650','2013-11-02','13:35:00',1.8),('9650','2013-11-02','13:40:00',2.3),('9650','2013-11-02','13:45:00',3.56),('9650','2013-11-02','13:50:00',1.7),('9650','2013-11-02','13:55:00',1.94),('9650','2013-11-02','14:00:00',2.33),('9650','2013-11-02','14:05:00',3.48),('9650','2013-11-02','14:10:00',3.52),('9650','2013-11-02','14:15:00',3.18),('9650','2013-11-02','14:20:00',2.92),('9650','2013-11-02','14:25:00',3.09),('9650','2013-11-02','14:30:00',2.1),('9650','2013-11-02','14:35:00',1.94),('9650','2013-11-02','14:40:00',2.73),('9650','2013-11-02','14:45:00',2.37),('9650','2013-11-02','14:50:00',1.85),('9650','2013-11-02','14:55:00',1.53),('9650','2013-11-02','15:05:00',1.25),('9650','2013-11-02','15:20:00',1.04),('9650','2013-11-01','09:10:00',1.02),('9650','2013-11-01','09:25:00',1.05),('9650','2013-11-01','09:30:00',1.11),('9650','2013-11-01','09:35:00',1.18),('9650','2013-11-01','09:40:00',1.3),('9650','2013-11-01','09:45:00',1.41),('9650','2013-11-01','09:50:00',1.8),('9650','2013-11-01','09:55:00',1.78),('9650','2013-11-01','10:00:00',2.32),('9650','2013-11-01','10:05:00',2.11),('9650','2013-11-01','10:10:00',1.91),('9650','2013-11-01','10:15:00',1.85),('9650','2013-11-01','10:20:00',1.41),('9650','2013-11-01','10:25:00',1.15),('9650','2013-11-01','10:40:00',1.11),('9650','2013-11-01','10:45:00',1.36),('9650','2013-11-01','10:50:00',1.24),('9650','2013-11-01','10:55:00',1.51),('9650','2013-11-01','11:00:00',2.02),('9650','2013-11-01','11:05:00',2.33),('9650','2013-11-01','11:10:00',2.1),('9650','2013-11-01','11:15:00',1.6),('9650','2013-11-01','11:20:00',1.16),('9650','2013-11-01','11:25:00',1.24),('9650','2013-11-01','11:30:00',1.26),('9650','2013-11-01','11:35:00',1.26),('9650','2013-11-01','11:40:00',1.49),('9650','2013-11-01','11:45:00',1.55),('9650','2013-11-01','11:50:00',1.79),('9650','2013-11-01','11:55:00',2.65),('9650','2013-11-01','12:00:00',4),('9650','2013-11-01','12:05:00',4.16),('9650','2013-11-01','12:10:00',4.18),('9650','2013-11-01','12:15:00',4.09),('9650','2013-11-01','12:20:00',4.43),('9650','2013-11-01','12:25:00',4.96),('9650','2013-11-01','12:30:00',5.29),('9650','2013-11-01','12:35:00',4.68),('9650','2013-11-01','12:40:00',4.18),('9650','2013-11-01','12:45:00',3.09),('9650','2013-11-01','12:50:00',4.23),('9650','2013-11-01','12:55:00',4.69),('9650','2013-11-01','13:00:00',3.85),('9650','2013-11-01','13:05:00',4.74),('9650','2013-11-01','13:10:00',4.93),('9650','2013-11-01','13:15:00',2.89),('9650','2013-11-01','13:20:00',1.84),('9650','2013-11-01','13:25:00',1.75),('9650','2013-11-01','13:30:00',2.47),('9650','2013-11-01','13:35:00',4.01),('9650','2013-11-01','13:40:00',4.55),('9650','2013-11-01','13:45:00',4.48),('9650','2013-11-01','13:50:00',4.76),('9650','2013-11-01','13:55:00',4.48),('9650','2013-11-01','14:00:00',3.93),('9650','2013-11-01','14:05:00',3.38),('9650','2013-11-01','14:10:00',3.08),('9650','2013-11-01','14:15:00',2.98),('9650','2013-11-01','14:20:00',2.79),('9650','2013-11-01','14:25:00',2.76),('9650','2013-11-01','14:30:00',2.67),('9650','2013-11-01','14:35:00',2.5),('9650','2013-11-01','14:40:00',2.35),('9650','2013-11-01','14:45:00',2.28),('9650','2013-11-01','14:50:00',2.32),('9650','2013-11-01','14:55:00',2.27),('9650','2013-11-01','15:00:00',2.19),('9650','2013-11-01','15:05:00',1.63),('9650','2013-11-01','15:10:00',2.11),('9650','2013-11-01','15:15:00',1.43),('9650','2013-11-01','15:40:00',1.16),('9650','2013-11-01','15:45:00',1.33),('9650','2013-11-01','15:50:00',1.35),('9650','2013-11-01','15:55:00',1.25),('9650','2014-04-16','08:45:00',1.09),('9650','2014-04-16','08:50:00',1.19),('9650','2014-04-16','08:55:00',1.15),('9650','2014-04-16','09:00:00',1.22),('9650','2014-04-16','09:05:00',1.52),('9650','2014-04-16','09:10:00',1.74),('9650','2014-04-16','09:15:00',1.88),('9650','2014-04-16','09:20:00',2.1),('9650','2014-04-16','09:25:00',2.24),('9650','2014-04-16','09:30:00',2.4),('9650','2014-04-16','09:35:00',2.57),('9650','2014-04-16','09:40:00',2.72),('9650','2014-04-16','09:45:00',2.87),('9650','2014-04-16','09:50:00',3.02),('9650','2014-04-16','09:55:00',3.19),('9650','2014-04-16','10:00:00',3.44),('9650','2014-04-16','10:05:00',3.92),('9650','2014-04-16','10:10:00',3.9),('9650','2014-04-16','10:15:00',3.2),('9650','2014-04-16','10:20:00',4.45),('9650','2014-04-16','10:25:00',4.78),('9650','2014-04-16','10:30:00',5.06),('9650','2014-04-16','10:35:00',5.45),('9650','2014-04-16','10:40:00',4.97),('9650','2014-04-16','10:45:00',4.63),('9650','2014-04-16','10:50:00',3.61),('9650','2014-04-16','10:55:00',3.5),('9650','2014-04-16','11:00:00',3.82),('9650','2014-04-16','11:05:00',4.4),('9650','2014-04-16','11:10:00',4.53),('9650','2014-04-16','11:15:00',3.82),('9650','2014-04-16','11:20:00',4.76),('9650','2014-04-16','11:25:00',5.78),('9650','2014-04-16','11:30:00',3.92),('9650','2014-04-16','11:35:00',3.82),('9650','2014-04-16','11:40:00',3.78),('9650','2014-04-16','11:45:00',5.74),('9650','2014-04-16','11:50:00',4.56),('9650','2014-04-16','11:55:00',3.57),('9650','2014-04-16','12:00:00',4.38),('9650','2014-04-16','12:05:00',4.82),('9650','2014-04-16','12:10:00',4.33),('9650','2014-04-16','12:15:00',3.73),('9650','2014-04-16','12:20:00',3.72),('9650','2014-04-16','12:25:00',3.9),('9650','2014-04-16','12:30:00',5.04),('9650','2014-04-16','12:35:00',5.49),('9650','2014-04-16','12:40:00',6.51),('9650','2014-04-16','12:45:00',6.31),('9650','2014-04-16','12:50:00',4.76),('9650','2014-04-16','12:55:00',7.09),('9650','2014-04-16','13:00:00',7.08),('9650','2014-04-16','13:05:00',5.23),('9650','2014-04-16','13:10:00',4.78),('9650','2014-04-16','13:15:00',2.95),('9650','2014-04-16','13:20:00',2.41),('9650','2014-04-16','13:25:00',7.59),('9650','2014-04-16','13:30:00',8.2),('9650','2014-04-16','13:35:00',2.61),('9650','2014-04-16','13:40:00',1.62),('9650','2014-04-16','13:45:00',1.68),('9650','2014-04-16','13:50:00',2.13),('9650','2014-04-16','13:55:00',2.29),('9650','2014-04-16','14:00:00',1.87),('9650','2014-04-16','14:05:00',2.06),('9650','2014-04-16','14:10:00',4.13),('9650','2014-04-16','14:15:00',6.16),('9650','2014-04-16','14:20:00',2.82),('9650','2014-04-16','14:25:00',3.53),('9650','2014-04-16','14:30:00',3.44),('9650','2014-04-16','14:35:00',4.41),('9650','2014-04-16','14:40:00',6.85),('9650','2014-04-16','14:45:00',2.51),('9650','2014-04-16','14:50:00',1.35),('9650','2014-04-16','14:55:00',1.22),('9650','2014-04-16','15:00:00',1.32),('9650','2014-04-16','15:05:00',1.43),('9650','2014-04-16','15:10:00',1.36),('9650','2014-04-16','15:15:00',1.4),('9650','2014-04-16','15:20:00',1.7),('9650','2014-04-16','15:25:00',2.24),('9650','2014-04-16','15:30:00',3.38),('9650','2014-04-16','15:35:00',4.49),('9650','2014-04-16','15:40:00',3.15),('9650','2014-04-16','15:45:00',2.31),('9650','2014-04-16','15:50:00',2.18),('9650','2014-04-16','15:55:00',2.45),('9650','2014-04-16','16:00:00',1.98),('9650','2014-04-16','16:05:00',1.61),('9650','2014-04-16','16:10:00',1.83),('9650','2014-04-16','16:15:00',1.84),('9650','2014-04-16','16:20:00',1.81),('9650','2014-04-16','16:25:00',2.07),('9650','2014-04-16','16:30:00',2.11),('9650','2014-04-16','16:35:00',1.9),('9650','2014-04-16','16:40:00',2.26),('9650','2014-04-16','16:45:00',3.07),('9650','2014-04-16','16:50:00',2.9),('9650','2014-04-16','16:55:00',2.18),('9650','2014-04-16','17:00:00',1.81),('9650','2014-04-16','17:05:00',1.55),('9650','2014-04-16','17:10:00',1.55),('9650','2014-04-16','17:15:00',1.87),('9650','2014-04-16','17:20:00',2.13),('9650','2014-04-16','17:25:00',1.78),('9650','2014-04-16','17:30:00',1.86),('9650','2014-04-16','17:35:00',2),('9650','2014-04-16','17:40:00',1.86),('9650','2014-04-16','17:45:00',1.71),('9650','2014-04-16','17:50:00',1.32),('9650','2014-04-16','17:55:00',1.23),('9650','2014-05-03','08:15:00',1.01),('9650','2014-05-03','08:20:00',1.16),('9650','2014-05-03','08:25:00',1.27),('9650','2014-05-03','08:30:00',1.57),('9650','2014-05-03','08:35:00',2.01),('9650','2014-05-03','08:40:00',1.79),('9650','2014-05-03','08:45:00',1.44),('9650','2014-05-03','08:50:00',1.83),('9650','2014-05-03','08:55:00',1.85),('9650','2014-05-03','09:00:00',2.08),('9650','2014-05-03','09:05:00',2.93),('9650','2014-05-03','09:10:00',3.2),('9650','2014-05-03','09:15:00',2.89),('9650','2014-05-03','09:20:00',4.3),('9650','2014-05-03','09:25:00',4),('9650','2014-05-03','09:30:00',2.31),('9650','2014-05-03','09:35:00',1.88),('9650','2014-05-03','09:40:00',2.19),('9650','2014-05-03','09:45:00',2.81),('9650','2014-05-03','09:50:00',2.71),('9650','2014-05-03','09:55:00',2.54),('9650','2014-05-03','10:00:00',4.36),('9650','2014-05-03','10:05:00',4.64),('9650','2014-05-03','10:10:00',4.61),('9650','2014-05-03','10:15:00',3.77),('9650','2014-05-03','10:20:00',3.12),('9650','2014-05-03','10:25:00',3.17),('9650','2014-05-03','10:30:00',3.38),('9650','2014-05-03','10:35:00',3.52),('9650','2014-05-03','10:40:00',3.65),('9650','2014-05-03','10:45:00',4.69),('9650','2014-05-03','10:50:00',5.34),('9650','2014-05-03','10:55:00',3.8),('9650','2014-05-03','11:00:00',3.64),('9650','2014-05-03','11:05:00',4.37),('9650','2014-05-03','11:10:00',6.61),('9650','2014-05-03','11:15:00',5.57),('9650','2014-05-03','11:20:00',6.42),('9650','2014-05-03','11:25:00',5.77),('9650','2014-05-03','11:30:00',5.37),('9650','2014-05-03','11:35:00',5.18),('9650','2014-05-03','11:40:00',4.16),('9650','2014-05-03','11:45:00',6.79),('9650','2014-05-03','11:50:00',4.37),('9650','2014-05-03','11:55:00',6.37),('9650','2014-05-03','12:00:00',4.3),('9650','2014-05-03','12:05:00',4.11),('9650','2014-05-03','12:10:00',3.23),('9650','2014-05-03','12:15:00',2.76),('9650','2014-05-03','12:20:00',2.76),('9650','2014-05-03','12:25:00',3.16),('9650','2014-05-03','12:30:00',6),('9650','2014-05-03','12:35:00',7.92),('9650','2014-05-03','12:40:00',6.49),('9650','2014-05-03','12:45:00',6.04),('9650','2014-05-03','12:50:00',5.21),('9650','2014-05-03','12:55:00',3.41),('9650','2014-05-03','13:00:00',4.71),('9650','2014-05-03','13:05:00',3.12),('9650','2014-05-03','13:10:00',3.57),('9650','2014-05-03','13:15:00',3.09),('9650','2014-05-03','13:20:00',2.85),('9650','2014-05-03','13:25:00',2.7),('9650','2014-05-03','13:30:00',2.67),('9650','2014-05-03','13:35:00',2.95),('9650','2014-05-03','13:40:00',2.9),('9650','2014-05-03','13:45:00',2.56),('9650','2014-05-03','13:50:00',2.46),('9650','2014-05-03','13:55:00',2.57),('9650','2014-05-03','14:00:00',2.63),('9650','2014-05-03','14:05:00',2.65),('9650','2014-05-03','14:10:00',2.49),('9650','2014-05-03','14:15:00',2.21),('9650','2014-05-03','14:20:00',1.66),('9650','2014-05-03','14:25:00',1.2),('9650','2014-05-03','14:30:00',1.12),('9650','2014-05-03','14:35:00',1.23),('9650','2014-05-03','14:40:00',1.46),('9650','2014-05-03','14:45:00',1.74),('9650','2014-05-03','14:50:00',2.37),('9650','2014-05-03','14:55:00',3.33),('9650','2014-05-03','15:00:00',3.61),('9650','2014-05-03','15:05:00',4.41),('9650','2014-05-03','15:10:00',5.71),('9650','2014-05-03','15:15:00',4.64),('9650','2014-05-03','15:20:00',3.4),('9650','2014-05-03','15:25:00',2.62),('9650','2014-05-03','15:30:00',2.18),('9650','2014-05-03','15:35:00',1.57),('9650','2014-05-03','15:40:00',1.41),('9650','2014-05-03','15:45:00',1.68),('9650','2014-05-03','15:50:00',2.01),('9650','2014-05-03','15:55:00',2.02),('9650','2014-05-03','16:00:00',1.73),('9650','2014-05-03','16:05:00',1.82),('9650','2014-05-03','16:10:00',2.17),('9650','2014-05-03','16:15:00',2.02),('9650','2014-05-03','16:20:00',1.66),('9650','2014-05-03','16:25:00',1.24),('9650','2014-05-03','17:20:00',1.14),('9650','2014-05-03','17:25:00',1.7),('9650','2014-05-03','17:30:00',1.82),('9650','2014-05-03','17:35:00',2.01),('9650','2014-05-03','17:40:00',2.14),('9650','2014-05-03','17:45:00',1.45),('9650','2014-05-03','17:50:00',1.12),('9650','2014-05-03','18:05:00',1.21),('9650','2014-05-03','18:10:00',1),('9650','2014-04-15','08:50:00',1.06),('9650','2014-04-15','08:55:00',1.3),('9650','2014-04-15','09:00:00',1.42),('9650','2014-04-15','09:05:00',1.56),('9650','2014-04-15','09:10:00',1.71),('9650','2014-04-15','09:15:00',1.87),('9650','2014-04-15','09:20:00',2.02),('9650','2014-04-15','09:25:00',2.25),('9650','2014-04-15','09:30:00',1.8),('9650','2014-04-15','09:35:00',1.3),('9650','2014-04-15','09:40:00',1.49),('9650','2014-04-15','09:45:00',1.46),('9650','2014-04-15','09:50:00',1.49),('9650','2014-04-15','09:55:00',3.22),('9650','2014-04-15','10:00:00',3.32),('9650','2014-04-15','10:05:00',3.44),('9650','2014-04-15','10:10:00',3.59),('9650','2014-04-15','10:15:00',3.73),('9650','2014-04-15','10:20:00',3.88),('9650','2014-04-15','10:25:00',4.02),('9650','2014-04-15','10:30:00',4.16),('9650','2014-04-15','10:35:00',4.3),('9650','2014-04-15','10:40:00',4.45),('9650','2014-04-15','10:45:00',4.66),('9650','2014-04-15','10:50:00',5.06),('9650','2014-04-15','10:55:00',4.74),('9650','2014-04-15','11:00:00',5.02),('9650','2014-04-15','11:05:00',2.97),('9650','2014-04-15','11:10:00',2.28),('9650','2014-04-15','11:15:00',3.17),('9650','2014-04-15','11:20:00',5.24),('9650','2014-04-15','11:25:00',4.64),('9650','2014-04-15','11:30:00',5.25),('9650','2014-04-15','11:35:00',4.15),('9650','2014-04-15','11:40:00',4.25),('9650','2014-04-15','11:45:00',5.61),('9650','2014-04-15','11:50:00',6.3),('9650','2014-04-15','11:55:00',7.05),('9650','2014-04-15','12:00:00',7.12),('9650','2014-04-15','12:05:00',4.59),('9650','2014-04-15','12:10:00',5.82),('9650','2014-04-15','12:15:00',6.43),('9650','2014-04-15','12:20:00',4.41),('9650','2014-04-15','12:25:00',2.23),('9650','2014-04-15','12:30:00',2.79),('9650','2014-04-15','12:35:00',7.29),('9650','2014-04-15','12:40:00',7.68),('9650','2014-04-15','12:45:00',7.42),('9650','2014-04-15','12:50:00',6.6),('9650','2014-04-15','12:55:00',1.89),('9650','2014-04-15','13:00:00',4.9),('9650','2014-04-15','13:05:00',2.61),('9650','2014-04-15','13:10:00',1.63),('9650','2014-04-15','13:15:00',1.68),('9650','2014-04-15','13:20:00',2.5),('9650','2014-04-15','13:25:00',2.09),('9650','2014-04-15','13:30:00',1.76),('9650','2014-04-15','13:35:00',3.14),('9650','2014-04-15','13:40:00',4.38),('9650','2014-04-15','13:45:00',8.54),('9650','2014-04-15','13:50:00',7.49),('9650','2014-04-15','13:55:00',5.6),('9650','2014-04-15','14:00:00',2.86),('9650','2014-04-15','14:05:00',5.45),('9650','2014-04-15','14:10:00',8.14),('9650','2014-04-15','14:15:00',8.8),('9650','2014-04-15','14:20:00',7.83),('9650','2014-04-15','14:25:00',7.44),('9650','2014-04-15','14:30:00',7.93),('9650','2014-04-15','14:35:00',7.65),('9650','2014-04-15','14:40:00',7.49),('9650','2014-04-15','14:45:00',7.72),('9650','2014-04-15','14:50:00',7.73),('9650','2014-04-15','14:55:00',2.93),('9650','2014-04-15','15:00:00',2.43),('9650','2014-04-15','15:05:00',6.39),('9650','2014-04-15','15:10:00',8.52),('9650','2014-04-15','15:15:00',4.89),('9650','2014-04-15','15:20:00',1.11),('9650','2014-04-15','15:25:00',2.21),('9650','2014-04-15','15:30:00',5.84),('9650','2014-04-15','15:35:00',7.72),('9650','2014-04-15','15:40:00',7.56),('9650','2014-04-15','15:45:00',7.41),('9650','2014-04-15','15:50:00',7.19),('9650','2014-04-15','15:55:00',7.02),('9650','2014-04-15','16:00:00',6.84),('9650','2014-04-15','16:05:00',6.68),('9650','2014-04-15','16:10:00',6.58),('9650','2014-04-15','16:15:00',6.49),('9650','2014-04-15','16:20:00',6.5),('9650','2014-04-15','16:25:00',6.34),('9650','2014-04-15','16:30:00',6.27),('9650','2014-04-15','16:35:00',6.19),('9650','2014-04-15','16:40:00',6.13),('9650','2014-04-15','16:45:00',6.03),('9650','2014-04-15','16:50:00',5.83),('9650','2014-04-15','16:55:00',5.69),('9650','2014-04-15','17:00:00',5.55),('9650','2014-04-15','17:05:00',5.35),('9650','2014-04-15','17:10:00',5.19),('9650','2014-04-15','17:15:00',5.07),('9650','2014-04-15','17:20:00',4.96),('9650','2014-04-15','17:25:00',4.91),('9650','2014-04-15','17:30:00',4.84),('9650','2014-04-15','17:35:00',4.79),('9650','2014-04-15','17:40:00',4.58),('9650','2014-04-15','17:45:00',4.49),('9650','2014-04-15','17:50:00',4.45),('9650','2014-04-15','17:55:00',4.47),('9650','2014-04-15','18:00:00',4.24),('9650','2014-04-15','18:05:00',4.08),('9650','2014-04-15','18:10:00',3.76),('9650','2014-04-15','18:15:00',3.28),('9650','2014-04-15','18:20:00',3.66),('9650','2014-04-15','18:25:00',3.27),('9650','2014-04-15','18:30:00',3.1),('9650','2014-04-15','18:35:00',2.81),('9650','2014-04-15','18:40:00',2.91),('9650','2014-04-15','18:45:00',2.94),('9650','2014-04-15','18:50:00',2.86),('9650','2014-04-15','18:55:00',2.15),('9650','2014-04-15','19:05:00',1.84),('9650','2014-04-15','19:10:00',1.55),('9650','2014-04-14','08:55:00',1.05),('9650','2014-04-14','09:00:00',1.51),('9650','2014-04-14','09:05:00',1.6),('9650','2014-04-14','09:10:00',1.52),('9650','2014-04-14','09:15:00',2.2),('9650','2014-04-14','09:20:00',2.81),('9650','2014-04-14','09:25:00',3.17),('9650','2014-04-14','09:30:00',2.54),('9650','2014-04-14','09:35:00',1.62),('9650','2014-04-14','09:40:00',1.03),('9650','2014-04-14','09:45:00',1.84),('9650','2014-04-14','09:50:00',3.24),('9650','2014-04-14','10:00:00',1.13),('9650','2014-04-14','10:05:00',2.57),('9650','2014-04-14','10:10:00',2.8),('9650','2014-04-14','10:15:00',2.74),('9650','2014-04-14','10:20:00',2.98),('9650','2014-04-14','10:25:00',3.09),('9650','2014-04-14','10:30:00',4.57),('9650','2014-04-14','10:35:00',3.07),('9650','2014-04-14','10:40:00',3.54),('9650','2014-04-14','10:45:00',3.69),('9650','2014-04-14','10:50:00',3.44),('9650','2014-04-14','10:55:00',2.81),('9650','2014-04-14','11:00:00',3.18),('9650','2014-04-14','11:05:00',5.11),('9650','2014-04-14','11:10:00',3.12),('9650','2014-04-14','11:15:00',2.25),('9650','2014-04-14','11:20:00',1.76),('9650','2014-04-14','11:25:00',2.44),('9650','2014-04-14','11:30:00',2.1),('9650','2014-04-14','11:35:00',1.73),('9650','2014-04-14','11:40:00',1.07),('9650','2014-04-14','11:45:00',1.7),('9650','2014-04-14','11:50:00',2.34),('9650','2014-04-14','11:55:00',1.78),('9650','2014-04-14','12:00:00',1.19),('9650','2014-04-14','12:05:00',1.39),('9650','2014-04-14','12:10:00',1.75),('9650','2014-04-14','12:15:00',2.8),('9650','2014-04-14','12:20:00',2.87),('9650','2014-04-14','12:25:00',1.57),('9650','2014-04-14','12:35:00',1.29),('9650','2014-04-14','12:40:00',1.04),('9650','2014-04-14','13:05:00',1.67),('9650','2014-04-14','13:10:00',2.47),('9650','2014-04-14','13:15:00',3.71),('9650','2014-04-14','13:20:00',4.37),('9650','2014-04-14','13:25:00',3.54),('9650','2014-04-14','13:30:00',4.93),('9650','2014-04-14','13:35:00',5.61),('9650','2014-04-14','13:40:00',3.14),('9650','2014-04-14','13:45:00',1.37),('9650','2014-04-14','13:50:00',1.25),('9650','2014-04-14','13:55:00',1.54),('9650','2014-04-14','14:00:00',5.62),('9650','2014-04-14','14:05:00',2.69),('9650','2014-04-14','14:10:00',5.61),('9650','2014-04-14','14:15:00',5.01),('9650','2014-04-14','14:20:00',6.38),('9650','2014-04-14','14:25:00',5.81),('9650','2014-04-14','14:30:00',4.21),('9650','2014-04-14','14:35:00',2.88),('9650','2014-04-14','14:40:00',3.64),('9650','2014-04-14','14:45:00',3.46),('9650','2014-04-14','14:50:00',3.8),('9650','2014-04-14','14:55:00',2.55),('9650','2014-04-14','15:00:00',1.59),('9650','2014-04-14','15:05:00',1.86),('9650','2014-04-14','15:10:00',2.12),('9650','2014-04-14','15:15:00',2.96),('9650','2014-04-14','15:20:00',4.11),('9650','2014-04-14','15:25:00',3.61),('9650','2014-04-14','15:30:00',2.95),('9650','2014-04-14','15:35:00',2.74),('9650','2014-04-14','15:40:00',2.7),('9650','2014-04-14','15:45:00',2.53),('9650','2014-04-14','15:50:00',2.59),('9650','2014-04-14','15:55:00',2.55),('9650','2014-04-14','16:00:00',2.83),('9650','2014-04-14','16:05:00',2.96),('9650','2014-04-14','16:10:00',1.53),('9650','2014-04-14','16:15:00',1.16),('9650','2014-04-13','08:45:00',1.04),('9650','2014-04-13','08:50:00',1.15),('9650','2014-04-13','08:55:00',1.26),('9650','2014-04-13','09:00:00',1.37),('9650','2014-04-13','09:05:00',1.48),('9650','2014-04-13','09:10:00',1.62),('9650','2014-04-13','09:15:00',1.76),('9650','2014-04-13','09:20:00',1.91),('9650','2014-04-13','09:25:00',2.04),('9650','2014-04-13','09:30:00',2.19),('9650','2014-04-13','09:35:00',2.33),('9650','2014-04-13','09:40:00',2.47),('9650','2014-04-13','09:45:00',2.62),('9650','2014-04-13','09:50:00',2.76),('9650','2014-04-13','09:55:00',2.9),('9650','2014-04-13','10:00:00',3.05),('9650','2014-04-13','10:05:00',3.18),('9650','2014-04-13','10:10:00',3.31),('9650','2014-04-13','10:15:00',3.43),('9650','2014-04-13','10:20:00',3.57),('9650','2014-04-13','10:25:00',3.71),('9650','2014-04-13','10:30:00',3.83),('9650','2014-04-13','10:35:00',3.95),('9650','2014-04-13','10:40:00',4.06),('9650','2014-04-13','10:45:00',4.19),('9650','2014-04-13','10:50:00',4.31),('9650','2014-04-13','10:55:00',4.43),('9650','2014-04-13','11:00:00',4.53),('9650','2014-04-13','11:05:00',4.6),('9650','2014-04-13','11:10:00',4.74),('9650','2014-04-13','11:15:00',4.85),('9650','2014-04-13','11:20:00',4.96),('9650','2014-04-13','11:25:00',5.07),('9650','2014-04-13','11:30:00',5.19),('9650','2014-04-13','11:35:00',5.27),('9650','2014-04-13','11:40:00',5.36),('9650','2014-04-13','11:45:00',5.46),('9650','2014-04-13','11:50:00',5.54),('9650','2014-04-13','11:55:00',5.61),('9650','2014-04-13','12:00:00',5.7),('9650','2014-04-13','12:05:00',5.79),('9650','2014-04-13','12:10:00',5.87),('9650','2014-04-13','12:15:00',5.94),('9650','2014-04-13','12:20:00',6.01),('9650','2014-04-13','12:25:00',6.11),('9650','2014-04-13','12:30:00',6.13),('9650','2014-04-13','12:35:00',6.19),('9650','2014-04-13','12:40:00',6.28),('9650','2014-04-13','12:45:00',6.34),('9650','2014-04-13','12:50:00',6.35),('9650','2014-04-13','12:55:00',6.45),('9650','2014-04-13','13:00:00',6.47),('9650','2014-04-13','13:05:00',6.5),('9650','2014-04-13','13:10:00',6.49),('9650','2014-04-13','13:15:00',6.61),('9650','2014-04-13','13:20:00',6.66),('9650','2014-04-13','13:25:00',6.67),('9650','2014-04-13','13:30:00',6.73),('9650','2014-04-13','13:35:00',6.8),('9650','2014-04-13','13:40:00',6.83),('9650','2014-04-13','13:45:00',6.85),('9650','2014-04-13','13:50:00',6.87),('9650','2014-04-13','13:55:00',6.9),('9650','2014-04-13','14:00:00',6.92),('9650','2014-04-13','14:05:00',6.95),('9650','2014-04-13','14:10:00',6.97),('9650','2014-04-13','14:15:00',6.96),('9650','2014-04-13','14:20:00',7),('9650','2014-04-13','14:25:00',7.04),('9650','2014-04-13','14:30:00',7.02),('9650','2014-04-13','14:35:00',7),('9650','2014-04-13','14:40:00',7.02),('9650','2014-04-13','14:45:00',7.02),('9650','2014-04-13','14:50:00',7),('9650','2014-04-13','14:55:00',6.99),('9650','2014-04-13','15:00:00',6.96),('9650','2014-04-13','15:05:00',6.91),('9650','2014-04-13','15:10:00',6.84),('9650','2014-04-13','15:15:00',6.75),('9650','2014-04-13','15:20:00',6.72),('9650','2014-04-13','15:25:00',6.71),('9650','2014-04-13','15:30:00',6.68),('9650','2014-04-13','15:35:00',6.62),('9650','2014-04-13','15:40:00',6.58),('9650','2014-04-13','15:45:00',6.52),('9650','2014-04-13','15:50:00',6.44),('9650','2014-04-13','15:55:00',6.3),('9650','2014-04-13','16:00:00',6.2),('9650','2014-04-13','16:05:00',6.1),('9650','2014-04-13','16:10:00',6.02),('9650','2014-04-13','16:15:00',5.95),('9650','2014-04-13','16:20:00',5.86),('9650','2014-04-13','16:25:00',5.87),('9650','2014-04-13','16:30:00',5.77),('9650','2014-04-13','16:35:00',5.72),('9650','2014-04-13','16:40:00',5.56),('9650','2014-04-13','16:45:00',5.42),('9650','2014-04-13','16:50:00',5.28),('9650','2014-04-13','16:55:00',5.17),('9650','2014-04-13','17:00:00',4.99),('9650','2014-04-13','17:05:00',4.82),('9650','2014-04-13','17:10:00',4.7),('9650','2014-04-13','17:15:00',4.61),('9650','2014-04-13','17:20:00',4.53),('9650','2014-04-13','17:25:00',4.5),('9650','2014-04-13','17:30:00',4.43),('9650','2014-04-13','17:35:00',4.27),('9650','2014-04-13','17:40:00',4.12),('9650','2014-04-13','17:45:00',4),('9650','2014-04-13','17:50:00',3.87),('9650','2014-04-13','17:55:00',3.75),('9650','2014-04-13','18:00:00',3.58),('9650','2014-04-13','18:05:00',3.41),('9650','2014-04-13','18:10:00',3.25),('9650','2014-04-13','18:15:00',3.09),('9650','2014-04-13','18:20:00',2.96),('9650','2014-04-13','18:25:00',2.84),('9650','2014-04-13','18:30:00',2.68),('9650','2014-04-13','18:35:00',2.46),('9650','2014-04-13','18:40:00',2.26),('9650','2014-04-13','18:45:00',2.03),('9650','2014-04-13','18:50:00',1.84),('9650','2014-04-13','18:55:00',1.68),('9650','2014-04-13','19:00:00',1.44),('9650','2014-04-13','19:05:00',1.22),('9650','2014-04-13','19:10:00',1.01),('9650','2014-04-12','08:30:00',1.14),('9650','2014-04-12','08:35:00',1.14),('9650','2014-04-12','08:40:00',1.19),('9650','2014-04-12','08:45:00',1.24),('9650','2014-04-12','08:50:00',1.18),('9650','2014-04-12','08:55:00',1.26),('9650','2014-04-12','09:00:00',1.59),('9650','2014-04-12','09:05:00',1.97),('9650','2014-04-12','09:10:00',2.24),('9650','2014-04-12','09:15:00',2.04),('9650','2014-04-12','09:20:00',2.2),('9650','2014-04-12','09:25:00',2.6),('9650','2014-04-12','09:30:00',2.72),('9650','2014-04-12','09:35:00',2.4),('9650','2014-04-12','09:40:00',2.98),('9650','2014-04-12','09:45:00',2.54),('9650','2014-04-12','09:50:00',2.1),('9650','2014-04-12','09:55:00',2.09),('9650','2014-04-12','10:00:00',3.28),('9650','2014-04-12','10:05:00',4.32),('9650','2014-04-12','10:10:00',3.25),('9650','2014-04-12','10:15:00',3.35),('9650','2014-04-12','10:20:00',3.92),('9650','2014-04-12','10:25:00',2.67),('9650','2014-04-12','10:30:00',3.72),('9650','2014-04-12','10:35:00',3.82),('9650','2014-04-12','10:40:00',3.81),('9650','2014-04-12','10:45:00',4.26),('9650','2014-04-12','10:50:00',4.45),('9650','2014-04-12','10:55:00',4.5),('9650','2014-04-12','11:00:00',4.58),('9650','2014-04-12','11:05:00',4.74),('9650','2014-04-12','11:10:00',4.86),('9650','2014-04-12','11:15:00',5.26),('9650','2014-04-12','11:20:00',4.61),('9650','2014-04-12','11:25:00',4.4),('9650','2014-04-12','11:30:00',3),('9650','2014-04-12','11:35:00',3.5),('9650','2014-04-12','11:40:00',5.71),('9650','2014-04-12','11:45:00',5.63),('9650','2014-04-12','11:50:00',5.94),('9650','2014-04-12','11:55:00',4.24),('9650','2014-04-12','12:00:00',3.58),('9650','2014-04-12','12:05:00',2.84),('9650','2014-04-12','12:10:00',2.51),('9650','2014-04-12','12:15:00',2.32),('9650','2014-04-12','12:20:00',2.04),('9650','2014-04-12','12:25:00',1.45),('9650','2014-04-12','12:30:00',1.02),('9650','2014-04-12','12:50:00',1.12),('9650','2014-04-12','12:55:00',1.2),('9650','2014-04-12','13:00:00',1.29),('9650','2014-04-12','13:05:00',2.37),('9650','2014-04-12','13:10:00',3.42),('9650','2014-04-12','13:15:00',3.34),('9650','2014-04-12','13:20:00',4.23),('9650','2014-04-12','13:25:00',4.49),('9650','2014-04-12','13:30:00',7.31),('9650','2014-04-12','13:35:00',6.55),('9650','2014-04-12','13:40:00',6.37),('9650','2014-04-12','13:45:00',3.43),('9650','2014-04-12','13:50:00',5.04),('9650','2014-04-12','13:55:00',4.64),('9650','2014-04-12','14:00:00',7.03),('9650','2014-04-12','14:05:00',6.97),('9650','2014-04-12','14:10:00',7.12),('9650','2014-04-12','14:15:00',6.98),('9650','2014-04-12','14:20:00',3.54),('9650','2014-04-12','14:25:00',2.82),('9650','2014-04-12','14:30:00',2.95),('9650','2014-04-12','14:35:00',2.91),('9650','2014-04-12','14:40:00',2.51),('9650','2014-04-12','14:45:00',3.36),('9650','2014-04-12','14:50:00',7.08),('9650','2014-04-12','14:55:00',5.09),('9650','2014-04-12','15:00:00',5.93),('9650','2014-04-12','15:05:00',6.68),('9650','2014-04-12','15:10:00',7),('9650','2014-04-12','15:15:00',6.06),('9650','2014-04-12','15:20:00',5.97),('9650','2014-04-12','15:25:00',6.35),('9650','2014-04-12','15:30:00',6.08),('9650','2014-04-12','15:35:00',4.13),('9650','2014-04-12','15:40:00',2.57),('9650','2014-04-12','15:45:00',2.75),('9650','2014-04-12','15:50:00',3.27),('9650','2014-04-12','15:55:00',3.34),('9650','2014-04-12','16:00:00',6.48),('9650','2014-04-12','16:05:00',4.97),('9650','2014-04-12','16:10:00',2.24),('9650','2014-04-12','16:15:00',2.36),('9650','2014-04-12','16:20:00',2.6),('9650','2014-04-12','16:25:00',2.96),('9650','2014-04-12','16:30:00',2.37),('9650','2014-04-12','16:35:00',3.04),('9650','2014-04-12','16:40:00',5.18),('9650','2014-04-12','16:45:00',5.18),('9650','2014-04-12','16:50:00',3.7),('9650','2014-04-12','16:55:00',4.67),('9650','2014-04-12','17:00:00',4.73),('9650','2014-04-12','17:05:00',2.71),('9650','2014-04-12','17:10:00',1.9),('9650','2014-04-12','17:15:00',2.33),('9650','2014-04-12','17:20:00',3.58),('9650','2014-04-12','17:25:00',2.69),('9650','2014-04-12','17:30:00',1.6),('9650','2014-04-12','17:35:00',1.42),('9650','2014-04-12','17:40:00',1.41),('9650','2014-04-12','17:45:00',1.78),('9650','2014-04-12','17:50:00',2.14),('9650','2014-04-12','17:55:00',2.76),('9650','2014-04-12','18:00:00',2.4),('9650','2014-04-12','18:05:00',1.96),('9650','2014-04-12','18:10:00',1.02),('9650','2014-04-12','18:20:00',1.01),('9650','2014-04-12','18:25:00',1.06),('9650','2014-04-12','18:30:00',1.06),('9650','2013-09-09','08:15:00',1.03),('9650','2013-09-09','08:45:00',1.05),('9650','2013-09-09','08:55:00',1.19),('9650','2013-09-09','09:00:00',1.35),('9650','2013-09-09','09:05:00',1.64),('9650','2013-09-09','09:10:00',2.24),('9650','2013-09-09','09:15:00',2.08),('9650','2013-09-09','09:20:00',1.95),('9650','2013-09-09','09:25:00',1.97),('9650','2013-09-09','09:30:00',2.84),('9650','2013-09-09','09:35:00',3.25),('9650','2013-09-09','09:40:00',2.39),('9650','2013-09-09','09:45:00',2.15),('9650','2013-09-09','09:50:00',2.05),('9650','2013-09-09','09:55:00',1.83),('9650','2013-09-09','10:00:00',1.35),('9650','2013-09-09','10:05:00',1.23),('9650','2013-09-09','10:10:00',1.07),('9650','2013-09-09','10:15:00',1.09),('9650','2013-09-09','10:20:00',1.58),('9650','2013-09-09','10:25:00',1.74),('9650','2013-09-09','10:30:00',1.7),('9650','2013-09-09','10:35:00',1.91),('9650','2013-09-09','10:40:00',2.52),('9650','2013-09-09','10:45:00',3.2),('9650','2013-09-09','10:50:00',2.11),('9650','2013-09-09','10:55:00',2.26),('9650','2013-09-09','11:00:00',2.66),('9650','2013-09-09','11:05:00',2.44),('9650','2013-09-09','11:10:00',2.36),('9650','2013-09-09','11:15:00',2.08),('9650','2013-09-09','11:20:00',2.33),('9650','2013-09-09','11:25:00',2.44),('9650','2013-09-09','11:30:00',1.85),('9650','2013-09-09','11:35:00',1.31),('9650','2013-09-09','11:40:00',1.48),('9650','2013-09-09','11:45:00',2.11),('9650','2013-09-09','11:50:00',2.3),('9650','2013-09-09','11:55:00',2.85),('9650','2013-09-09','12:00:00',2.43),('9650','2013-09-09','12:05:00',1.82),('9650','2013-09-09','12:10:00',1.87),('9650','2013-09-09','12:15:00',1.92),('9650','2013-09-09','12:20:00',1.8),('9650','2013-09-09','12:25:00',1.62),('9650','2013-09-09','12:30:00',1.47),('9650','2013-09-09','12:35:00',1.35),('9650','2013-09-09','12:40:00',1.09),('9650','2013-09-09','12:45:00',1.02),('9650','2013-09-09','12:50:00',1.02),('9650','2013-09-09','12:55:00',1.1),('9650','2013-09-09','13:00:00',1.36),('9650','2013-09-09','13:05:00',1.17),('9650','2013-09-09','13:10:00',1.2),('9650','2013-09-09','13:15:00',1.69),('9650','2013-09-09','13:20:00',1.76),('9650','2013-09-09','13:25:00',2.04),('9650','2013-09-09','13:30:00',1.86),('9650','2013-09-09','13:35:00',2.02),('9650','2013-09-09','13:40:00',3.18),('9650','2013-09-09','13:45:00',4.65),('9650','2013-09-09','13:50:00',3.2),('9650','2013-09-09','13:55:00',2.71),('9650','2013-09-09','14:00:00',2.08),('9650','2013-09-09','14:05:00',2.37),('9650','2013-09-09','14:10:00',2.43),('9650','2013-09-09','14:15:00',2.85),('9650','2013-09-09','14:20:00',2.82),('9650','2013-09-09','14:25:00',3.82),('9650','2013-09-09','14:30:00',3.31),('9650','2013-09-09','14:35:00',2.52),('9650','2013-09-09','14:40:00',3.05),('9650','2013-09-09','14:45:00',3.23),('9650','2013-09-09','14:50:00',3.79),('9650','2013-09-09','14:55:00',3.26),('9650','2013-09-09','15:00:00',4.3),('9650','2013-09-09','15:05:00',4),('9650','2013-09-09','15:10:00',3.03),('9650','2013-09-09','15:15:00',2.81),('9650','2013-09-09','15:20:00',3.48),('9650','2013-09-09','15:25:00',3.12),('9650','2013-09-09','15:30:00',3.68),('9650','2013-09-09','15:35:00',3.07),('9650','2013-09-09','15:40:00',2.16),('9650','2013-09-09','15:45:00',1.81),('9650','2013-09-09','15:50:00',1.86),('9650','2013-09-09','15:55:00',1.8),('9650','2013-09-09','16:00:00',1.74),('9650','2013-09-09','16:05:00',1.9),('9650','2013-09-09','16:10:00',2.29),('9650','2013-09-09','16:15:00',2.59),('9650','2013-09-09','16:20:00',1.79),('9650','2013-09-09','16:25:00',1.65),('9650','2013-09-09','16:30:00',1.33),('9650','2013-09-09','16:45:00',1.25),('9650','2013-09-09','16:50:00',1.55),('9650','2013-09-09','16:55:00',1.51),('9650','2013-09-09','17:00:00',1.3),('9650','2013-09-09','17:05:00',1.13),('9650','2013-09-09','17:10:00',1.17),('9650','2013-09-09','17:15:00',1.46),('9650','2013-09-09','17:20:00',1.44),('9650','2013-09-09','17:25:00',1.39),('9650','2013-09-09','17:30:00',1.28),('9650','2013-09-09','17:35:00',1.03),('9650','2013-09-09','17:40:00',1.07),('9650','2013-09-09','17:45:00',1.29),('9650','2013-09-09','17:50:00',1.52),('9650','2013-09-09','17:55:00',1.19),('9650','2013-09-08','07:40:00',1.14),('9650','2013-09-08','07:45:00',1.24),('9650','2013-09-08','07:50:00',1.2),('9650','2013-09-08','07:55:00',1.11),('9650','2013-09-08','08:00:00',1.03),('9650','2013-09-08','08:40:00',1.21),('9650','2013-09-08','08:45:00',1.52),('9650','2013-09-08','08:50:00',1.63),('9650','2013-09-08','08:55:00',1.75),('9650','2013-09-08','09:00:00',1.84),('9650','2013-09-08','09:05:00',1.82),('9650','2013-09-08','09:10:00',1.65),('9650','2013-09-08','09:15:00',1.15),('9650','2013-09-08','09:20:00',1.11),('9650','2013-09-08','09:25:00',1.03),('9650','2013-09-08','09:30:00',1.16),('9650','2013-09-08','09:35:00',1.82),('9650','2013-09-08','09:40:00',1.67),('9650','2013-09-08','09:45:00',1.02),('9650','2013-09-08','09:50:00',1.12),('9650','2013-09-08','09:55:00',1.1),('9650','2013-09-08','10:00:00',2.07),('9650','2013-09-08','10:05:00',2.73),('9650','2013-09-08','10:10:00',2.75),('9650','2013-09-08','10:15:00',2.53),('9650','2013-09-08','10:20:00',2.47),('9650','2013-09-08','10:25:00',2.29),('9650','2013-09-08','10:30:00',2.38),('9650','2013-09-08','10:35:00',2.37),('9650','2013-09-08','10:40:00',2.55),('9650','2013-09-08','10:45:00',2.84),('9650','2013-09-08','10:50:00',3.51),('9650','2013-09-08','10:55:00',3.58),('9650','2013-09-08','11:00:00',4.02),('9650','2013-09-08','11:05:00',3.3),('9650','2013-09-08','11:10:00',3.14),('9650','2013-09-08','11:15:00',3.27),('9650','2013-09-08','11:20:00',3.54),('9650','2013-09-08','11:25:00',3.78),('9650','2013-09-08','11:30:00',3.14),('9650','2013-09-08','11:35:00',3.17),('9650','2013-09-08','11:40:00',4.52),('9650','2013-09-08','11:45:00',4.8),('9650','2013-09-08','11:50:00',5.09),('9650','2013-09-08','11:55:00',4.3),('9650','2013-09-08','12:00:00',4.69),('9650','2013-09-08','12:05:00',4.36),('9650','2013-09-08','12:10:00',4.37),('9650','2013-09-08','12:15:00',3.58),('9650','2013-09-08','12:20:00',2.44),('9650','2013-09-08','12:25:00',1.9),('9650','2013-09-08','12:30:00',1.73),('9650','2013-09-08','12:35:00',1.74),('9650','2013-09-08','12:40:00',2.39),('9650','2013-09-08','12:45:00',2.52),('9650','2013-09-08','12:50:00',2.06),('9650','2013-09-08','12:55:00',2.62),('9650','2013-09-08','13:00:00',2.59),('9650','2013-09-08','13:05:00',3.92),('9650','2013-09-08','13:10:00',3.7),('9650','2013-09-08','13:15:00',4.94),('9650','2013-09-08','13:20:00',4.49),('9650','2013-09-08','13:25:00',4.05),('9650','2013-09-08','13:30:00',4.88),('9650','2013-09-08','13:35:00',5.97),('9650','2013-09-08','13:40:00',4.89),('9650','2013-09-08','13:45:00',6),('9650','2013-09-08','13:50:00',5.94),('9650','2013-09-08','13:55:00',6.26),('9650','2013-09-08','14:00:00',5.73),('9650','2013-09-08','14:05:00',5.53),('9650','2013-09-08','14:10:00',5.73),('9650','2013-09-08','14:15:00',3.93),('9650','2013-09-08','14:20:00',3.38),('9650','2013-09-08','14:25:00',2.58),('9650','2013-09-08','14:30:00',3.28),('9650','2013-09-08','14:35:00',6.16),('9650','2013-09-08','14:40:00',6.29),('9650','2013-09-08','14:45:00',4.39),('9650','2013-09-08','14:50:00',5.77),('9650','2013-09-08','14:55:00',4.98),('9650','2013-09-08','15:00:00',4.4),('9650','2013-09-08','15:05:00',4.46),('9650','2013-09-08','15:10:00',4.43),('9650','2013-09-08','15:15:00',2.29),('9650','2013-09-08','15:20:00',3.69),('9650','2013-09-08','15:25:00',2.12),('9650','2013-09-08','15:30:00',5.34),('9650','2013-09-08','15:35:00',4.34),('9650','2013-09-08','15:40:00',3.98),('9650','2013-09-08','15:45:00',2.35),('9650','2013-09-08','15:50:00',2.39),('9650','2013-09-08','15:55:00',2.62),('9650','2013-09-08','16:00:00',3.04),('9650','2013-09-08','16:05:00',2.48),('9650','2013-09-08','16:10:00',3.13),('9650','2013-09-08','16:15:00',4.36),('9650','2013-09-08','16:20:00',3.39),('9650','2013-09-08','16:25:00',2.07),('9650','2013-09-08','16:30:00',2.06),('9650','2013-09-08','16:35:00',2.23),('9650','2013-09-08','16:40:00',2.52),('9650','2013-09-08','16:45:00',3.58),('9650','2013-09-08','16:50:00',1.47),('9650','2013-09-08','16:55:00',1.31),('9650','2013-09-08','17:00:00',1.88),('9650','2013-09-08','17:05:00',1.39),('9650','2013-09-08','17:10:00',1.53),('9650','2013-09-08','17:15:00',1.01),('9650','2013-09-08','17:40:00',1.1),('9650','2013-09-08','18:05:00',1.07),('9650','2013-09-08','18:10:00',1.71),('9650','2013-09-08','18:15:00',1.83),('9650','2013-09-08','18:20:00',1.36),('9650','2013-09-08','18:25:00',1.13),('9650','2013-09-08','18:30:00',1.34),('9650','2014-04-11','09:05:00',1.21),('9650','2014-04-11','09:10:00',1.58),('9650','2014-04-11','09:15:00',2.18),('9650','2014-04-11','09:20:00',2.94),('9650','2014-04-11','09:25:00',3.13),('9650','2014-04-11','09:30:00',2.64),('9650','2014-04-11','09:35:00',2.5),('9650','2014-04-11','09:40:00',2.26),('9650','2014-04-11','09:45:00',2.26),('9650','2014-04-11','09:50:00',2.43),('9650','2014-04-11','09:55:00',2.38),('9650','2014-04-11','10:00:00',2.38),('9650','2014-04-11','10:05:00',2.43),('9650','2014-04-11','10:10:00',2.6),('9650','2014-04-11','10:15:00',2.76),('9650','2014-04-11','10:20:00',2.89),('9650','2014-04-11','10:25:00',3.04),('9650','2014-04-11','10:30:00',3.13),('9650','2014-04-11','10:35:00',3.43),('9650','2014-04-11','10:40:00',3.26),('9650','2014-04-11','10:45:00',3.65),('9650','2014-04-11','10:50:00',3.6),('9650','2014-04-11','10:55:00',4.22),('9650','2014-04-11','11:00:00',4.15),('9650','2014-04-11','11:05:00',3.81),('9650','2014-04-11','11:10:00',3.94),('9650','2014-04-11','11:15:00',3.72),('9650','2014-04-11','11:20:00',5.26),('9650','2014-04-11','11:25:00',5.3),('9650','2014-04-11','11:30:00',5.16),('9650','2014-04-11','11:35:00',5.51),('9650','2014-04-11','11:40:00',5.37),('9650','2014-04-11','11:45:00',5.76),('9650','2014-04-11','11:50:00',3.78),('9650','2014-04-11','11:55:00',4.47),('9650','2014-04-11','12:00:00',4.53),('9650','2014-04-11','12:05:00',3.01),('9650','2014-04-11','12:10:00',3.02),('9650','2014-04-11','12:15:00',3.06),('9650','2014-04-11','12:20:00',4.05),('9650','2014-04-11','12:25:00',5.11),('9650','2014-04-11','12:30:00',4.42),('9650','2014-04-11','12:35:00',4.15),('9650','2014-04-11','12:40:00',4.39),('9650','2014-04-11','12:45:00',4.28),('9650','2014-04-11','12:50:00',3.21),('9650','2014-04-11','12:55:00',2.82),('9650','2014-04-11','13:00:00',3),('9650','2014-04-11','13:05:00',4.38),('9650','2014-04-11','13:10:00',5.16),('9650','2014-04-11','13:15:00',5.77),('9650','2014-04-11','13:20:00',6.83),('9650','2014-04-11','13:25:00',5.36),('9650','2014-04-11','13:30:00',5.01),('9650','2014-04-11','13:35:00',2.46),('9650','2014-04-11','13:40:00',2.56),('9650','2014-04-11','13:45:00',6.67),('9650','2014-04-11','13:50:00',4.73),('9650','2014-04-11','13:55:00',2.66),('9650','2014-04-11','14:00:00',6.06),('9650','2014-04-11','14:05:00',6.87),('9650','2014-04-11','14:10:00',6.65),('9650','2014-04-11','14:15:00',5.02),('9650','2014-04-11','14:20:00',5.49),('9650','2014-04-11','14:25:00',3.08),('9650','2014-04-11','14:30:00',5.03),('9650','2014-04-11','14:35:00',3.67),('9650','2014-04-11','14:40:00',2.5),('9650','2014-04-11','14:45:00',5.44),('9650','2014-04-11','14:50:00',7.76),('9650','2014-04-11','14:55:00',6.67),('9650','2014-04-11','15:00:00',4.76),('9650','2014-04-11','15:05:00',6.12),('9650','2014-04-11','15:10:00',6.26),('9650','2014-04-11','15:15:00',6.3),('9650','2014-04-11','15:20:00',5.1),('9650','2014-04-11','15:25:00',3.6),('9650','2014-04-11','15:30:00',3.96),('9650','2014-04-11','15:35:00',3.83),('9650','2014-04-11','15:40:00',4.92),('9650','2014-04-11','15:45:00',5.56),('9650','2014-04-11','15:50:00',6.42),('9650','2014-04-11','15:55:00',6.2),('9650','2014-04-11','16:00:00',6.13),('9650','2014-04-11','16:05:00',6.03),('9650','2014-04-11','16:10:00',5.88),('9650','2014-04-11','16:15:00',6.19),('9650','2014-04-11','16:20:00',6.29),('9650','2014-04-11','16:25:00',5.71),('9650','2014-04-11','16:30:00',5.46),('9650','2014-04-11','16:35:00',4.95),('9650','2014-04-11','16:40:00',4.47),('9650','2014-04-11','16:45:00',4.73),('9650','2014-04-11','16:50:00',3.29),('9650','2014-04-11','16:55:00',4.88),('9650','2014-04-11','17:00:00',4.77),('9650','2014-04-11','17:05:00',4.49),('9650','2014-04-11','17:10:00',4.49),('9650','2014-04-11','17:15:00',4.33),('9650','2014-04-11','17:20:00',3.53),('9650','2014-04-11','17:25:00',4.22),('9650','2014-04-11','17:30:00',4.14),('9650','2014-04-11','17:35:00',3.02),('9650','2014-04-11','17:40:00',4),('9650','2014-04-11','17:45:00',4.42),('9650','2014-04-11','17:50:00',4.14),('9650','2014-04-11','17:55:00',3.92),('9650','2014-04-11','18:00:00',2.92),('9650','2014-04-11','18:05:00',1.75),('9650','2014-04-11','18:10:00',1.32),('9650','2014-04-11','18:15:00',1.49),('9650','2014-04-11','18:20:00',1.12),('9650','2014-04-11','18:30:00',1.12),('9650','2014-04-11','18:40:00',1.28),('9650','2014-04-11','18:45:00',1.55),('9650','2014-04-11','18:50:00',1.65),('9650','2014-04-11','18:55:00',1.42),('9650','2013-09-07','08:35:00',1.14),('9650','2013-09-07','08:40:00',1.25),('9650','2013-09-07','08:45:00',1.24),('9650','2013-09-07','08:50:00',1.26),('9650','2013-09-07','08:55:00',1.35),('9650','2013-09-07','09:00:00',1.49),('9650','2013-09-07','09:05:00',1.62),('9650','2013-09-07','09:10:00',1.67),('9650','2013-09-07','09:15:00',1.64),('9650','2013-09-07','09:20:00',1.7),('9650','2013-09-07','09:25:00',1.59),('9650','2013-09-07','09:30:00',1.86),('9650','2013-09-07','09:35:00',1.96),('9650','2013-09-07','09:40:00',1.83),('9650','2013-09-07','09:45:00',2.08),('9650','2013-09-07','09:50:00',2.09),('9650','2013-09-07','09:55:00',2.24),('9650','2013-09-07','10:00:00',2.32),('9650','2013-09-07','10:05:00',2.47),('9650','2013-09-07','10:10:00',2.6),('9650','2013-09-07','10:15:00',2.65),('9650','2013-09-07','10:20:00',2.82),('9650','2013-09-07','10:25:00',2.93),('9650','2013-09-07','10:30:00',3.05),('9650','2013-09-07','10:35:00',3.13),('9650','2013-09-07','10:40:00',3.29),('9650','2013-09-07','10:45:00',3.39),('9650','2013-09-07','10:50:00',3.45),('9650','2013-09-07','10:55:00',3.46),('9650','2013-09-07','11:00:00',3.59),('9650','2013-09-07','11:05:00',3.69),('9650','2013-09-07','11:10:00',3.85),('9650','2013-09-07','11:15:00',3.94),('9650','2013-09-07','11:20:00',4.07),('9650','2013-09-07','11:25:00',4.12),('9650','2013-09-07','11:30:00',4.15),('9650','2013-09-07','11:35:00',4.22),('9650','2013-09-07','11:40:00',4.31),('9650','2013-09-07','11:45:00',4.44),('9650','2013-09-07','11:50:00',4.53),('9650','2013-09-07','11:55:00',4.49),('9650','2013-09-07','12:00:00',4.49),('9650','2013-09-07','12:05:00',4.44),('9650','2013-09-07','12:10:00',4.46),('9650','2013-09-07','12:15:00',4.81),('9650','2013-09-07','12:20:00',4.89),('9650','2013-09-07','12:25:00',4.98),('9650','2013-09-07','12:30:00',5.04),('9650','2013-09-07','12:35:00',4.99),('9650','2013-09-07','12:40:00',4.98),('9650','2013-09-07','12:45:00',5.17),('9650','2013-09-07','12:50:00',5.15),('9650','2013-09-07','12:55:00',5.33),('9650','2013-09-07','13:00:00',5.31),('9650','2013-09-07','13:05:00',5.46),('9650','2013-09-07','13:10:00',5.37),('9650','2013-09-07','13:15:00',5.43),('9650','2013-09-07','13:20:00',5.51),('9650','2013-09-07','13:25:00',5.08),('9650','2013-09-07','13:30:00',4.97),('9650','2013-09-07','13:35:00',4.84),('9650','2013-09-07','13:40:00',3.69),('9650','2013-09-07','13:45:00',3.28),('9650','2013-09-07','13:50:00',4.24),('9650','2013-09-07','13:55:00',4.38),('9650','2013-09-07','14:00:00',5.31),('9650','2013-09-07','14:05:00',5.32),('9650','2013-09-07','14:10:00',6.06),('9650','2013-09-07','14:15:00',5.34),('9650','2013-09-07','14:20:00',5.93),('9650','2013-09-07','14:25:00',6.44),('9650','2013-09-07','14:30:00',5.59),('9650','2013-09-07','14:35:00',5.94),('9650','2013-09-07','14:40:00',5.96),('9650','2013-09-07','14:45:00',5.86),('9650','2013-09-07','14:50:00',5.93),('9650','2013-09-07','14:55:00',5.83),('9650','2013-09-07','15:00:00',5.94),('9650','2013-09-07','15:05:00',4.81),('9650','2013-09-07','15:10:00',3.33),('9650','2013-09-07','15:15:00',4.39),('9650','2013-09-07','15:20:00',5.66),('9650','2013-09-07','15:25:00',5.61),('9650','2013-09-07','15:30:00',5.72),('9650','2013-09-07','15:35:00',5.64),('9650','2013-09-07','15:40:00',5.28),('9650','2013-09-07','15:45:00',5.36),('9650','2013-09-07','15:50:00',5.18),('9650','2013-09-07','15:55:00',4.25),('9650','2013-09-07','16:00:00',4.53),('9650','2013-09-07','16:05:00',4.55),('9650','2013-09-07','16:10:00',4.21),('9650','2013-09-07','16:15:00',4.64),('9650','2013-09-07','16:20:00',4.34),('9650','2013-09-07','16:25:00',4.26),('9650','2013-09-07','16:30:00',4.38),('9650','2013-09-07','16:35:00',4.1),('9650','2013-09-07','16:40:00',3.55),('9650','2013-09-07','16:45:00',2.56),('9650','2013-09-07','16:50:00',2.54),('9650','2013-09-07','16:55:00',2.26),('9650','2013-09-07','17:00:00',2.85),('9650','2013-09-07','17:05:00',4.04),('9650','2013-09-07','17:10:00',3.93),('9650','2013-09-07','17:15:00',3.66),('9650','2013-09-07','17:20:00',3.22),('9650','2013-09-07','17:25:00',3.34),('9650','2013-09-07','17:30:00',3.13),('9650','2013-09-07','17:35:00',1.71),('9650','2013-09-07','17:40:00',1.89),('9650','2013-09-07','17:45:00',2.71),('9650','2013-09-07','17:50:00',2.71),('9650','2013-09-07','17:55:00',2.56),('9650','2013-09-07','18:00:00',2.28),('9650','2013-09-07','18:05:00',2),('9650','2013-09-07','18:10:00',1.87),('9650','2013-09-07','18:15:00',1.62),('9650','2013-09-07','18:20:00',1.54),('9650','2013-09-07','18:25:00',1.43),('9650','2013-09-07','18:30:00',1.21),('9650','2013-09-06','09:05:00',1.06),('9650','2013-09-06','09:10:00',1.16),('9650','2013-09-06','09:15:00',1.28),('9650','2013-09-06','09:20:00',1.4),('9650','2013-09-06','09:25:00',1.53),('9650','2013-09-06','09:30:00',1.65),('9650','2013-09-06','09:35:00',1.78),('9650','2013-09-06','09:40:00',1.9),('9650','2013-09-06','09:45:00',2.01),('9650','2013-09-06','09:50:00',2.13),('9650','2013-09-06','09:55:00',2.25),('9650','2013-09-06','10:00:00',2.38),('9650','2013-09-06','10:05:00',2.5),('9650','2013-09-06','10:10:00',2.61),('9650','2013-09-06','10:15:00',2.74),('9650','2013-09-06','10:20:00',2.88),('9650','2013-09-06','10:25:00',2.96),('9650','2013-09-06','10:30:00',3.08),('9650','2013-09-06','10:35:00',3.2),('9650','2013-09-06','10:40:00',3.33),('9650','2013-09-06','10:45:00',3.44),('9650','2013-09-06','10:50:00',3.54),('9650','2013-09-06','10:55:00',3.63),('9650','2013-09-06','11:00:00',3.75),('9650','2013-09-06','11:05:00',3.85),('9650','2013-09-06','11:10:00',3.96),('9650','2013-09-06','11:15:00',4.05),('9650','2013-09-06','11:20:00',4.13),('9650','2013-09-06','11:25:00',4.2),('9650','2013-09-06','11:30:00',4.33),('9650','2013-09-06','11:35:00',4.42),('9650','2013-09-06','11:40:00',4.52),('9650','2013-09-06','11:45:00',4.62),('9650','2013-09-06','11:50:00',4.7),('9650','2013-09-06','11:55:00',4.76),('9650','2013-09-06','12:00:00',4.83),('9650','2013-09-06','12:05:00',4.92),('9650','2013-09-06','12:10:00',4.98),('9650','2013-09-06','12:15:00',5.04),('9650','2013-09-06','12:20:00',5.11),('9650','2013-09-06','12:25:00',5.14),('9650','2013-09-06','12:30:00',5.15),('9650','2013-09-06','12:35:00',5.23),('9650','2013-09-06','12:40:00',5.26),('9650','2013-09-06','12:45:00',5.31),('9650','2013-09-06','12:50:00',5.36),('9650','2013-09-06','12:55:00',5.46),('9650','2013-09-06','13:00:00',5.31),('9650','2013-09-06','13:05:00',5.54),('9650','2013-09-06','13:10:00',5.47),('9650','2013-09-06','13:15:00',5.6),('9650','2013-09-06','13:20:00',5.62),('9650','2013-09-06','13:25:00',5.68),('9650','2013-09-06','13:30:00',5.84),('9650','2013-09-06','13:35:00',5.85),('9650','2013-09-06','13:40:00',5.49),('9650','2013-09-06','13:45:00',5.58),('9650','2013-09-06','13:50:00',5.76),('9650','2013-09-06','13:55:00',5.76),('9650','2013-09-06','14:00:00',5.71),('9650','2013-09-06','14:05:00',5.76),('9650','2013-09-06','14:10:00',5.98),('9650','2013-09-06','14:15:00',5.94),('9650','2013-09-06','14:20:00',5.86),('9650','2013-09-06','14:25:00',5.77),('9650','2013-09-06','14:30:00',5.84),('9650','2013-09-06','14:35:00',5.97),('9650','2013-09-06','14:40:00',5.98),('9650','2013-09-06','14:45:00',5.95),('9650','2013-09-06','14:50:00',5.9),('9650','2013-09-06','14:55:00',5.92),('9650','2013-09-06','15:00:00',5.88),('9650','2013-09-06','15:05:00',5.75),('9650','2013-09-06','15:10:00',5.7),('9650','2013-09-06','15:15:00',5.69),('9650','2013-09-06','15:20:00',5.65),('9650','2013-09-06','15:25:00',5.65),('9650','2013-09-06','15:30:00',5.6),('9650','2013-09-06','15:35:00',5.53),('9650','2013-09-06','15:40:00',5.44),('9650','2013-09-06','15:45:00',5.35),('9650','2013-09-06','15:50:00',5.27),('9650','2013-09-06','15:55:00',4.95),('9650','2013-09-06','16:00:00',4.99),('9650','2013-09-06','16:05:00',4.94),('9650','2013-09-06','16:10:00',4.87),('9650','2013-09-06','16:15:00',4.77),('9650','2013-09-06','16:20:00',4.73),('9650','2013-09-06','16:25:00',4.6),('9650','2013-09-06','16:30:00',4.51),('9650','2013-09-06','16:35:00',4.42),('9650','2013-09-06','16:40:00',4.33),('9650','2013-09-06','16:45:00',4.2),('9650','2013-09-06','16:50:00',4.09),('9650','2013-09-06','16:55:00',4.03),('9650','2013-09-06','17:00:00',3.9),('9650','2013-09-06','17:05:00',3.79),('9650','2013-09-06','17:10:00',3.67),('9650','2013-09-06','17:15:00',3.59),('9650','2013-09-06','17:20:00',3.5),('9650','2013-09-06','17:25:00',3.39),('9650','2013-09-06','17:30:00',3.24),('9650','2013-09-06','17:35:00',3.21),('9650','2013-09-06','17:40:00',3.13),('9650','2013-09-06','17:45:00',3.01),('9650','2013-09-06','17:50:00',2.84),('9650','2013-09-06','17:55:00',2.72),('9650','2013-09-06','18:00:00',2.56),('9650','2013-09-06','18:05:00',2.42),('9650','2013-09-06','18:10:00',2.3),('9650','2013-09-06','18:15:00',2.2),('9650','2013-09-06','18:20:00',2.05),('9650','2013-09-06','18:25:00',1.92),('9650','2013-09-06','18:30:00',1.74),('9650','2013-09-06','18:35:00',1.6),('9650','2013-09-06','18:40:00',1.48),('9650','2013-09-06','18:45:00',1.33),('9650','2013-09-06','18:50:00',1.12),('9650','2013-09-05','09:05:00',1.07),('9650','2013-09-05','09:10:00',1.19),('9650','2013-09-05','09:15:00',1.31),('9650','2013-09-05','09:20:00',1.43),('9650','2013-09-05','09:25:00',1.55),('9650','2013-09-05','09:30:00',1.67),('9650','2013-09-05','09:35:00',1.81),('9650','2013-09-05','09:40:00',1.94),('9650','2013-09-05','09:45:00',2.06),('9650','2013-09-05','09:50:00',2.18),('9650','2013-09-05','09:55:00',2.3),('9650','2013-09-05','10:00:00',2.42),('9650','2013-09-05','10:05:00',2.54),('9650','2013-09-05','10:10:00',2.66),('9650','2013-09-05','10:15:00',2.77),('9650','2013-09-05','10:20:00',2.89),('9650','2013-09-05','10:25:00',3),('9650','2013-09-05','10:30:00',3.14),('9650','2013-09-05','10:35:00',3.26),('9650','2013-09-05','10:40:00',3.39),('9650','2013-09-05','10:45:00',3.51),('9650','2013-09-05','10:50:00',3.58),('9650','2013-09-05','10:55:00',3.7),('9650','2013-09-05','11:00:00',3.79),('9650','2013-09-05','11:05:00',3.95),('9650','2013-09-05','11:10:00',4.05),('9650','2013-09-05','11:15:00',4.14),('9650','2013-09-05','11:20:00',4.21),('9650','2013-09-05','11:25:00',4.3),('9650','2013-09-05','11:30:00',4.44),('9650','2013-09-05','11:35:00',4.52),('9650','2013-09-05','11:40:00',4.61),('9650','2013-09-05','11:45:00',4.68),('9650','2013-09-05','11:50:00',4.76),('9650','2013-09-05','11:55:00',4.83),('9650','2013-09-05','12:00:00',4.85),('9650','2013-09-05','12:05:00',4.89),('9650','2013-09-05','12:10:00',5.04),('9650','2013-09-05','12:15:00',5.11),('9650','2013-09-05','12:20:00',5.13),('9650','2013-09-05','12:25:00',5.24),('9650','2013-09-05','12:30:00',5.31),('9650','2013-09-05','12:35:00',5.45),('9650','2013-09-05','12:40:00',5.49),('9650','2013-09-05','12:45:00',5.48),('9650','2013-09-05','12:50:00',5.47),('9650','2013-09-05','12:55:00',5.54),('9650','2013-09-05','13:00:00',5.6),('9650','2013-09-05','13:05:00',5.65),('9650','2013-09-05','13:10:00',5.72),('9650','2013-09-05','13:15:00',5.76),('9650','2013-09-05','13:20:00',5.75),('9650','2013-09-05','13:25:00',5.72),('9650','2013-09-05','13:30:00',5.81),('9650','2013-09-05','13:35:00',5.82),('9650','2013-09-05','13:40:00',5.77),('9650','2013-09-05','13:45:00',5.81),('9650','2013-09-05','13:50:00',5.85),('9650','2013-09-05','13:55:00',5.85),('9650','2013-09-05','14:00:00',5.84),('9650','2013-09-05','14:05:00',5.81),('9650','2013-09-05','14:10:00',5.83),('9650','2013-09-05','14:15:00',5.85),('9650','2013-09-05','14:20:00',5.85),('9650','2013-09-05','14:25:00',5.84),('9650','2013-09-05','14:30:00',5.79),('9650','2013-09-05','14:35:00',5.5),('9650','2013-09-05','14:40:00',5.69),('9650','2013-09-05','14:45:00',5.76),('9650','2013-09-05','14:50:00',5.81),('9650','2013-09-05','14:55:00',5.89),('9650','2013-09-05','15:00:00',5.83),('9650','2013-09-05','15:05:00',5.63),('9650','2013-09-05','15:10:00',5.55),('9650','2013-09-05','15:15:00',5.43),('9650','2013-09-05','15:20:00',5.56),('9650','2013-09-05','15:25:00',5.45),('9650','2013-09-05','15:30:00',5.38),('9650','2013-09-05','15:35:00',5.33),('9650','2013-09-05','15:40:00',5.35),('9650','2013-09-05','15:45:00',5.33),('9650','2013-09-05','15:50:00',5.25),('9650','2013-09-05','15:55:00',5.08),('9650','2013-09-05','16:00:00',4.97),('9650','2013-09-05','16:05:00',4.91),('9650','2013-09-05','16:10:00',4.81),('9650','2013-09-05','16:15:00',4.79),('9650','2013-09-05','16:20:00',4.76),('9650','2013-09-05','16:25:00',4.71),('9650','2013-09-05','16:30:00',4.65),('9650','2013-09-05','16:35:00',4.54),('9650','2013-09-05','16:40:00',4.43),('9650','2013-09-05','16:45:00',4.24),('9650','2013-09-05','16:50:00',4.15),('9650','2013-09-05','16:55:00',4.04),('9650','2013-09-05','17:00:00',4.06),('9650','2013-09-05','17:05:00',3.87),('9650','2013-09-05','17:10:00',3.76),('9650','2013-09-05','17:15:00',3.71),('9650','2013-09-05','17:20:00',3.5),('9650','2013-09-05','17:25:00',3.41),('9650','2013-09-05','17:30:00',3.27),('9650','2013-09-05','17:35:00',3.19),('9650','2013-09-05','17:40:00',3.2),('9650','2013-09-05','17:45:00',3.01),('9650','2013-09-05','17:50:00',2.78),('9650','2013-09-05','17:55:00',2.62),('9650','2013-09-05','18:00:00',2.57),('9650','2013-09-05','18:05:00',2.47),('9650','2013-09-05','18:10:00',2.39),('9650','2013-09-05','18:15:00',2.2),('9650','2013-09-05','18:20:00',2.01),('9650','2013-09-05','18:25:00',1.83),('9650','2013-09-05','18:30:00',1.6),('9650','2013-09-05','18:35:00',1.46),('9650','2013-09-05','18:40:00',1.25),('9650','2013-09-04','09:05:00',1.1),('9650','2013-09-04','09:10:00',1.21),('9650','2013-09-04','09:15:00',1.34),('9650','2013-09-04','09:20:00',1.49),('9650','2013-09-04','09:25:00',1.62),('9650','2013-09-04','09:30:00',1.74),('9650','2013-09-04','09:35:00',1.87),('9650','2013-09-04','09:40:00',2),('9650','2013-09-04','09:45:00',2.14),('9650','2013-09-04','09:50:00',2.28),('9650','2013-09-04','09:55:00',2.41),('9650','2013-09-04','10:00:00',2.53),('9650','2013-09-04','10:05:00',2.66),('9650','2013-09-04','10:10:00',2.78),('9650','2013-09-04','10:15:00',2.92),('9650','2013-09-04','10:20:00',3.03),('9650','2013-09-04','10:25:00',3.16),('9650','2013-09-04','10:30:00',3.29),('9650','2013-09-04','10:35:00',3.4),('9650','2013-09-04','10:40:00',3.53),('9650','2013-09-04','10:45:00',3.63),('9650','2013-09-04','10:50:00',3.76),('9650','2013-09-04','10:55:00',3.85),('9650','2013-09-04','11:00:00',3.97),('9650','2013-09-04','11:05:00',4.06),('9650','2013-09-04','11:10:00',4.16),('9650','2013-09-04','11:15:00',4.26),('9650','2013-09-04','11:20:00',4.35),('9650','2013-09-04','11:25:00',4.41),('9650','2013-09-04','11:30:00',4.54),('9650','2013-09-04','11:35:00',4.63),('9650','2013-09-04','11:40:00',4.62),('9650','2013-09-04','11:45:00',4.66),('9650','2013-09-04','11:50:00',4.81),('9650','2013-09-04','11:55:00',4.96),('9650','2013-09-04','12:00:00',5),('9650','2013-09-04','12:05:00',5.06),('9650','2013-09-04','12:10:00',5.19),('9650','2013-09-04','12:15:00',5.25),('9650','2013-09-04','12:20:00',5.26),('9650','2013-09-04','12:25:00',5.33),('9650','2013-09-04','12:30:00',5.42),('9650','2013-09-04','12:35:00',5.47),('9650','2013-09-04','12:40:00',5.55),('9650','2013-09-04','12:45:00',5.61),('9650','2013-09-04','12:50:00',5.66),('9650','2013-09-04','12:55:00',5.71),('9650','2013-09-04','13:00:00',5.74),('9650','2013-09-04','13:05:00',5.77),('9650','2013-09-04','13:10:00',5.83),('9650','2013-09-04','13:15:00',5.86),('9650','2013-09-04','13:20:00',5.89),('9650','2013-09-04','13:25:00',5.94),('9650','2013-09-04','13:30:00',5.99),('9650','2013-09-04','13:35:00',6.03),('9650','2013-09-04','13:40:00',6.03),('9650','2013-09-04','13:45:00',6.02),('9650','2013-09-04','13:50:00',5.94),('9650','2013-09-04','13:55:00',5.97),('9650','2013-09-04','14:00:00',5.95),('9650','2013-09-04','14:05:00',5.99),('9650','2013-09-04','14:10:00',6.04),('9650','2013-09-04','14:15:00',6.02),('9650','2013-09-04','14:20:00',5.99),('9650','2013-09-04','14:25:00',5.93),('9650','2013-09-04','14:30:00',5.95),('9650','2013-09-04','14:35:00',5.92),('9650','2013-09-04','14:40:00',5.86),('9650','2013-09-04','14:45:00',5.92),('9650','2013-09-04','14:50:00',5.91),('9650','2013-09-04','14:55:00',5.95),('9650','2013-09-04','15:00:00',5.95),('9650','2013-09-04','15:05:00',5.85),('9650','2013-09-04','15:10:00',5.8),('9650','2013-09-04','15:15:00',5.78),('9650','2013-09-04','15:20:00',5.77),('9650','2013-09-04','15:25:00',5.67),('9650','2013-09-04','15:30:00',5.6),('9650','2013-09-04','15:35:00',5.57),('9650','2013-09-04','15:40:00',5.49),('9650','2013-09-04','15:45:00',5.43),('9650','2013-09-04','15:50:00',5.39),('9650','2013-09-04','15:55:00',5.34),('9650','2013-09-04','16:00:00',5.2),('9650','2013-09-04','16:05:00',5.18),('9650','2013-09-04','16:10:00',5.05),('9650','2013-09-04','16:15:00',5.1),('9650','2013-09-04','16:20:00',5),('9650','2013-09-04','16:25:00',4.9),('9650','2013-09-04','16:30:00',4.83),('9650','2013-09-04','16:35:00',4.82),('9650','2013-09-04','16:40:00',4.79),('9650','2013-09-04','16:45:00',4.72),('9650','2013-09-04','16:50:00',3.96),('9650','2013-09-04','16:55:00',3.21),('9650','2013-09-04','17:00:00',2.58),('9650','2013-09-04','17:05:00',2.81),('9650','2013-09-04','17:10:00',2.87),('9650','2013-09-04','17:15:00',2.58),('9650','2013-09-04','17:20:00',2.97),('9650','2013-09-04','17:25:00',2.98),('9650','2013-09-04','17:30:00',3),('9650','2013-09-04','17:35:00',3.27),('9650','2013-09-04','17:40:00',3.62),('9650','2013-09-04','17:45:00',3.28),('9650','2013-09-04','17:50:00',3.03),('9650','2013-09-04','17:55:00',2.65),('9650','2013-09-04','18:00:00',2.05),('9650','2013-09-04','18:05:00',1.76),('9650','2013-09-04','18:10:00',1.73),('9650','2013-09-04','18:15:00',1.66),('9650','2013-09-04','18:20:00',2.34),('9650','2013-09-04','18:25:00',1.94),('9650','2013-09-04','18:30:00',1.37),('9650','2013-09-04','18:35:00',1.56),('9650','2013-09-04','18:40:00',1.47),('9650','2013-09-04','18:45:00',1.35),('9650','2013-09-04','18:50:00',1.24),('9650','2013-09-04','18:55:00',1.24),('9650','2013-09-03','09:05:00',1.1),('9650','2013-09-03','09:10:00',1.22),('9650','2013-09-03','09:15:00',1.35),('9650','2013-09-03','09:20:00',1.5),('9650','2013-09-03','09:25:00',1.64),('9650','2013-09-03','09:30:00',1.77),('9650','2013-09-03','09:35:00',1.92),('9650','2013-09-03','09:40:00',2.06),('9650','2013-09-03','09:45:00',2.2),('9650','2013-09-03','09:50:00',2.33),('9650','2013-09-03','09:55:00',2.46),('9650','2013-09-03','10:00:00',2.6),('9650','2013-09-03','10:05:00',2.73),('9650','2013-09-03','10:10:00',2.84),('9650','2013-09-03','10:15:00',2.96),('9650','2013-09-03','10:20:00',3.11),('9650','2013-09-03','10:25:00',3.23),('9650','2013-09-03','10:30:00',3.35),('9650','2013-09-03','10:35:00',3.48),('9650','2013-09-03','10:40:00',3.6),('9650','2013-09-03','10:45:00',3.71),('9650','2013-09-03','10:50:00',3.83),('9650','2013-09-03','10:55:00',3.94),('9650','2013-09-03','11:00:00',4.06),('9650','2013-09-03','11:05:00',4.18),('9650','2013-09-03','11:10:00',4.28),('9650','2013-09-03','11:15:00',4.37),('9650','2013-09-03','11:20:00',4.48),('9650','2013-09-03','11:25:00',4.59),('9650','2013-09-03','11:30:00',4.67),('9650','2013-09-03','11:35:00',4.77),('9650','2013-09-03','11:40:00',4.87),('9650','2013-09-03','11:45:00',4.95),('9650','2013-09-03','11:50:00',5.05),('9650','2013-09-03','11:55:00',5.13),('9650','2013-09-03','12:00:00',5.21),('9650','2013-09-03','12:05:00',5.27),('9650','2013-09-03','12:10:00',5.37),('9650','2013-09-03','12:15:00',5.39),('9650','2013-09-03','12:20:00',5.46),('9650','2013-09-03','12:25:00',5.55),('9650','2013-09-03','12:30:00',5.62),('9650','2013-09-03','12:35:00',5.69),('9650','2013-09-03','12:40:00',5.76),('9650','2013-09-03','12:45:00',5.81),('9650','2013-09-03','12:50:00',5.81),('9650','2013-09-03','12:55:00',5.88),('9650','2013-09-03','13:00:00',5.93),('9650','2013-09-03','13:05:00',5.97),('9650','2013-09-03','13:10:00',6.03),('9650','2013-09-03','13:15:00',6.06),('9650','2013-09-03','13:20:00',6.09),('9650','2013-09-03','13:25:00',6.12),('9650','2013-09-03','13:30:00',6.14),('9650','2013-09-03','13:35:00',6.19),('9650','2013-09-03','13:40:00',6.22),('9650','2013-09-03','13:45:00',6.23),('9650','2013-09-03','13:50:00',6.23),('9650','2013-09-03','13:55:00',6.23),('9650','2013-09-03','14:00:00',6.25),('9650','2013-09-03','14:05:00',6.29),('9650','2013-09-03','14:10:00',6.32),('9650','2013-09-03','14:15:00',6.32),('9650','2013-09-03','14:20:00',6.25),('9650','2013-09-03','14:25:00',6.3),('9650','2013-09-03','14:30:00',6.31),('9650','2013-09-03','14:35:00',6.31),('9650','2013-09-03','14:40:00',6.3),('9650','2013-09-03','14:45:00',6.27),('9650','2013-09-03','14:50:00',6.3),('9650','2013-09-03','14:55:00',6.27),('9650','2013-09-03','15:00:00',6.2),('9650','2013-09-03','15:05:00',6.07),('9650','2013-09-03','15:10:00',6.04),('9650','2013-09-03','15:15:00',5.97),('9650','2013-09-03','15:20:00',5.97),('9650','2013-09-03','15:25:00',5.89),('9650','2013-09-03','15:30:00',5.85),('9650','2013-09-03','15:35:00',5.8),('9650','2013-09-03','15:40:00',5.77),('9650','2013-09-03','15:45:00',5.71),('9650','2013-09-03','15:50:00',5.62),('9650','2013-09-03','15:55:00',5.53),('9650','2013-09-03','16:00:00',5.38),('9650','2013-09-03','16:05:00',5.31),('9650','2013-09-03','16:10:00',5.25),('9650','2013-09-03','16:15:00',5.18),('9650','2013-09-03','16:20:00',5.11),('9650','2013-09-03','16:25:00',5.02),('9650','2013-09-03','16:30:00',4.91),('9650','2013-09-03','16:35:00',4.82),('9650','2013-09-03','16:40:00',4.73),('9650','2013-09-03','16:45:00',4.63),('9650','2013-09-03','16:50:00',4.47),('9650','2013-09-03','16:55:00',4.43),('9650','2013-09-03','17:00:00',4.36),('9650','2013-09-03','17:05:00',4.22),('9650','2013-09-03','17:10:00',4.12),('9650','2013-09-03','17:15:00',4.03),('9650','2013-09-03','17:20:00',3.92),('9650','2013-09-03','17:25:00',3.87),('9650','2013-09-03','17:30:00',3.77),('9650','2013-09-03','17:35:00',3.68),('9650','2013-09-03','17:40:00',3.55),('9650','2013-09-03','17:45:00',3.4),('9650','2013-09-03','17:50:00',3.26),('9650','2013-09-03','17:55:00',3.09),('9650','2013-09-03','18:00:00',2.91),('9650','2013-09-03','18:05:00',2.77),('9650','2013-09-03','18:10:00',2.62),('9650','2013-09-03','18:15:00',2.46),('9650','2013-09-03','18:20:00',2.29),('9650','2013-09-03','18:25:00',2.15),('9650','2013-09-03','18:30:00',2.01),('9650','2013-09-03','18:35:00',1.85),('9650','2013-09-03','18:40:00',1.68),('9650','2013-09-03','18:45:00',1.49),('9650','2013-09-03','18:50:00',1.28),('9650','2013-09-03','18:55:00',1.05),('9650','2013-09-02','08:55:00',1.05),('9650','2013-09-02','09:00:00',1.15),('9650','2013-09-02','09:05:00',1.24),('9650','2013-09-02','09:10:00',1.35),('9650','2013-09-02','09:15:00',1.46),('9650','2013-09-02','09:20:00',1.59),('9650','2013-09-02','09:25:00',1.73),('9650','2013-09-02','09:30:00',1.85),('9650','2013-09-02','09:35:00',1.97),('9650','2013-09-02','09:40:00',2.07),('9650','2013-09-02','09:45:00',2.2),('9650','2013-09-02','09:50:00',2.33),('9650','2013-09-02','09:55:00',2.44),('9650','2013-09-02','10:00:00',2.56),('9650','2013-09-02','10:05:00',2.67),('9650','2013-09-02','10:10:00',2.79),('9650','2013-09-02','10:15:00',2.91),('9650','2013-09-02','10:20:00',3.05),('9650','2013-09-02','10:25:00',3.16),('9650','2013-09-02','10:30:00',3.27),('9650','2013-09-02','10:35:00',3.4),('9650','2013-09-02','10:40:00',3.56),('9650','2013-09-02','10:45:00',3.68),('9650','2013-09-02','10:50:00',3.79),('9650','2013-09-02','10:55:00',3.88),('9650','2013-09-02','11:00:00',3.98),('9650','2013-09-02','11:05:00',4.08),('9650','2013-09-02','11:10:00',4.17),('9650','2013-09-02','11:15:00',4.27),('9650','2013-09-02','11:20:00',4.36),('9650','2013-09-02','11:25:00',4.47),('9650','2013-09-02','11:30:00',4.55),('9650','2013-09-02','11:35:00',4.64),('9650','2013-09-02','11:40:00',4.71),('9650','2013-09-02','11:45:00',4.78),('9650','2013-09-02','11:50:00',4.9),('9650','2013-09-02','11:55:00',4.99),('9650','2013-09-02','12:00:00',5.09),('9650','2013-09-02','12:05:00',5.15),('9650','2013-09-02','12:10:00',5.24),('9650','2013-09-02','12:15:00',5.32),('9650','2013-09-02','12:20:00',5.41),('9650','2013-09-02','12:25:00',5.45),('9650','2013-09-02','12:30:00',5.53),('9650','2013-09-02','12:35:00',5.59),('9650','2013-09-02','12:40:00',5.65),('9650','2013-09-02','12:45:00',5.71),('9650','2013-09-02','12:50:00',5.73),('9650','2013-09-02','12:55:00',5.79),('9650','2013-09-02','13:00:00',5.84),('9650','2013-09-02','13:05:00',5.86),('9650','2013-09-02','13:10:00',5.93),('9650','2013-09-02','13:15:00',5.94),('9650','2013-09-02','13:20:00',5.99),('9650','2013-09-02','13:25:00',6),('9650','2013-09-02','13:30:00',6.03),('9650','2013-09-02','13:35:00',6.06),('9650','2013-09-02','13:40:00',6.08),('9650','2013-09-02','13:45:00',6.1),('9650','2013-09-02','13:50:00',6.14),('9650','2013-09-02','13:55:00',6.16),('9650','2013-09-02','14:00:00',6.09),('9650','2013-09-02','14:05:00',6.05),('9650','2013-09-02','14:10:00',6.04),('9650','2013-09-02','14:15:00',6.11),('9650','2013-09-02','14:20:00',6.12),('9650','2013-09-02','14:25:00',6.12),('9650','2013-09-02','14:30:00',6.16),('9650','2013-09-02','14:35:00',6.17),('9650','2013-09-02','14:40:00',6.18),('9650','2013-09-02','14:45:00',6.14),('9650','2013-09-02','14:50:00',6.15),('9650','2013-09-02','14:55:00',6.13),('9650','2013-09-02','15:00:00',6.09),('9650','2013-09-02','15:05:00',5.94),('9650','2013-09-02','15:10:00',5.89),('9650','2013-09-02','15:15:00',5.88),('9650','2013-09-02','15:20:00',5.86),('9650','2013-09-02','15:25:00',5.79),('9650','2013-09-02','15:30:00',5.76),('9650','2013-09-02','15:35:00',5.68),('9650','2013-09-02','15:40:00',5.64),('9650','2013-09-02','15:45:00',5.52),('9650','2013-09-02','15:50:00',5.53),('9650','2013-09-02','15:55:00',5.4),('9650','2013-09-02','16:00:00',5.36),('9650','2013-09-02','16:05:00',5.32),('9650','2013-09-02','16:10:00',5.25),('9650','2013-09-02','16:15:00',5.13),('9650','2013-09-02','16:20:00',5.08),('9650','2013-09-02','16:25:00',5.03),('9650','2013-09-02','16:30:00',4.92),('9650','2013-09-02','16:35:00',4.81),('9650','2013-09-02','16:40:00',4.67),('9650','2013-09-02','16:45:00',4.62),('9650','2013-09-02','16:50:00',4.47),('9650','2013-09-02','16:55:00',4.45),('9650','2013-09-02','17:00:00',4.31),('9650','2013-09-02','17:05:00',4.19),('9650','2013-09-02','17:10:00',4.1),('9650','2013-09-02','17:15:00',3.99),('9650','2013-09-02','17:20:00',3.95),('9650','2013-09-02','17:25:00',3.88),('9650','2013-09-02','17:30:00',3.76),('9650','2013-09-02','17:35:00',3.7),('9650','2013-09-02','17:40:00',3.59),('9650','2013-09-02','17:45:00',3.49),('9650','2013-09-02','17:50:00',3.37),('9650','2013-09-02','17:55:00',3.15),('9650','2013-09-02','18:00:00',2.74),('9650','2013-09-02','18:05:00',2.54),('9650','2013-09-02','18:10:00',2.44),('9650','2013-09-02','18:15:00',2.4),('9650','2013-09-02','18:20:00',2.29),('9650','2013-09-02','18:25:00',2.15),('9650','2013-09-02','18:30:00',1.97),('9650','2013-09-02','18:35:00',1.82),('9650','2013-09-02','18:40:00',1.69),('9650','2013-09-02','18:45:00',1.5),('9650','2013-09-02','18:50:00',1.34),('9650','2013-09-02','18:55:00',1.11),('9650','2013-09-01','08:55:00',1.04),('9650','2013-09-01','09:00:00',1.12),('9650','2013-09-01','09:05:00',1.18),('9650','2013-09-01','09:10:00',1.23),('9650','2013-09-01','09:15:00',1.25),('9650','2013-09-01','09:20:00',1.52),('9650','2013-09-01','09:25:00',1.76),('9650','2013-09-01','09:30:00',1.88),('9650','2013-09-01','09:35:00',2.02),('9650','2013-09-01','09:40:00',2.15),('9650','2013-09-01','09:45:00',2.27),('9650','2013-09-01','09:50:00',2.4),('9650','2013-09-01','09:55:00',2.52),('9650','2013-09-01','10:00:00',2.64),('9650','2013-09-01','10:05:00',2.76),('9650','2013-09-01','10:10:00',2.88),('9650','2013-09-01','10:15:00',3.01),('9650','2013-09-01','10:20:00',3.14),('9650','2013-09-01','10:25:00',3.26),('9650','2013-09-01','10:30:00',3.38),('9650','2013-09-01','10:35:00',3.49),('9650','2013-09-01','10:40:00',3.6),('9650','2013-09-01','10:45:00',3.7),('9650','2013-09-01','10:50:00',3.82),('9650','2013-09-01','10:55:00',3.93),('9650','2013-09-01','11:00:00',4.04),('9650','2013-09-01','11:05:00',4.14),('9650','2013-09-01','11:10:00',4.26),('9650','2013-09-01','11:15:00',4.35),('9650','2013-09-01','11:20:00',4.45),('9650','2013-09-01','11:25:00',4.54),('9650','2013-09-01','11:30:00',4.62),('9650','2013-09-01','11:35:00',4.72),('9650','2013-09-01','11:40:00',4.8),('9650','2013-09-01','11:45:00',4.88),('9650','2013-09-01','11:50:00',4.98),('9650','2013-09-01','11:55:00',5.02),('9650','2013-09-01','12:00:00',5.08),('9650','2013-09-01','12:05:00',5.19),('9650','2013-09-01','12:10:00',5.27),('9650','2013-09-01','12:15:00',5.37),('9650','2013-09-01','12:20:00',5.41),('9650','2013-09-01','12:25:00',5.51),('9650','2013-09-01','12:30:00',5.49),('9650','2013-09-01','12:35:00',5.54),('9650','2013-09-01','12:40:00',5.59),('9650','2013-09-01','12:45:00',5.63),('9650','2013-09-01','12:50:00',5.73),('9650','2013-09-01','12:55:00',5.79),('9650','2013-09-01','13:00:00',5.85),('9650','2013-09-01','13:05:00',5.89),('9650','2013-09-01','13:10:00',5.93),('9650','2013-09-01','13:15:00',5.94),('9650','2013-09-01','13:20:00',5.9),('9650','2013-09-01','13:25:00',5.92),('9650','2013-09-01','13:30:00',5.91),('9650','2013-09-01','13:35:00',5.87),('9650','2013-09-01','13:40:00',5.93),('9650','2013-09-01','13:45:00',2.43),('9650','2013-09-01','13:50:00',1.1),('9650','2013-09-01','13:55:00',1.11),('9650','2013-09-01','14:00:00',4.69),('9650','2013-09-01','14:05:00',6.57),('9650','2013-09-01','14:10:00',6.41),('9650','2013-09-01','14:15:00',6.32),('9650','2013-09-01','14:20:00',6.3),('9650','2013-09-01','14:25:00',6.28),('9650','2013-09-01','14:30:00',6.17),('9650','2013-09-01','14:35:00',6.13),('9650','2013-09-01','14:40:00',6.16),('9650','2013-09-01','14:45:00',6.17),('9650','2013-09-01','14:50:00',5.27),('9650','2013-09-01','14:55:00',3.77),('9650','2013-09-01','15:00:00',3.79),('9650','2013-09-01','15:05:00',6.19),('9650','2013-09-01','15:10:00',6.05),('9650','2013-09-01','15:15:00',5.15),('9650','2013-09-01','15:20:00',1.34),('9650','2013-09-01','15:25:00',4.22),('9650','2013-09-01','15:30:00',4.85),('9650','2013-09-01','15:35:00',4.71),('9650','2013-09-01','15:40:00',4.89),('9650','2013-09-01','15:45:00',5.18),('9650','2013-09-01','15:50:00',5.6),('9650','2013-09-01','15:55:00',5.47),('9650','2013-09-01','16:00:00',5.42),('9650','2013-09-01','16:05:00',5.36),('9650','2013-09-01','16:10:00',5.32),('9650','2013-09-01','16:15:00',5.33),('9650','2013-09-01','16:20:00',5.25),('9650','2013-09-01','16:25:00',5.07),('9650','2013-09-01','16:30:00',5.01),('9650','2013-09-01','16:35:00',4.92),('9650','2013-09-01','16:40:00',4.71),('9650','2013-09-01','16:45:00',4.56),('9650','2013-09-01','16:50:00',4.39),('9650','2013-09-01','16:55:00',4.21),('9650','2013-09-01','17:00:00',4.14),('9650','2013-09-01','17:05:00',4),('9650','2013-09-01','17:10:00',3.96),('9650','2013-09-01','17:15:00',3.87),('9650','2013-09-01','17:20:00',3.79),('9650','2013-09-01','17:25:00',3.68),('9650','2013-09-01','17:30:00',3.57),('9650','2013-09-01','17:35:00',3.45),('9650','2013-09-01','17:40:00',3.41),('9650','2013-09-01','17:45:00',3.3),('9650','2013-09-01','17:50:00',3.15),('9650','2013-09-01','17:55:00',3.03),('9650','2013-09-01','18:00:00',2.93),('9650','2013-09-01','18:05:00',2.78),('9650','2013-09-01','18:10:00',2.6),('9650','2013-09-01','18:15:00',2.46),('9650','2013-09-01','18:20:00',2.31),('9650','2013-09-01','18:25:00',2.16),('9650','2013-09-01','18:30:00',1.99),('9650','2013-09-01','18:35:00',1.81),('9650','2013-09-01','18:40:00',1.6),('9650','2013-09-01','18:45:00',1.43),('9650','2013-09-01','18:50:00',1.23),('9650','2013-09-01','18:55:00',1.02),('9650','2013-08-31','08:55:00',1.06),('9650','2013-08-31','09:00:00',1.18),('9650','2013-08-31','09:05:00',1.29),('9650','2013-08-31','09:10:00',1.41),('9650','2013-08-31','09:15:00',1.52),('9650','2013-08-31','09:20:00',1.65),('9650','2013-08-31','09:25:00',1.79),('9650','2013-08-31','09:30:00',1.93),('9650','2013-08-31','09:35:00',2.06),('9650','2013-08-31','09:40:00',2.19),('9650','2013-08-31','09:45:00',2.31),('9650','2013-08-31','09:50:00',2.44),('9650','2013-08-31','09:55:00',2.55),('9650','2013-08-31','10:00:00',2.66),('9650','2013-08-31','10:05:00',2.77),('9650','2013-08-31','10:10:00',2.9),('9650','2013-08-31','10:15:00',3.01),('9650','2013-08-31','10:20:00',3.16),('9650','2013-08-31','10:25:00',3.29),('9650','2013-08-31','10:30:00',3.41),('9650','2013-08-31','10:35:00',3.46),('9650','2013-08-31','10:40:00',3.6),('9650','2013-08-31','10:45:00',3.72),('9650','2013-08-31','10:50:00',3.82),('9650','2013-08-31','10:55:00',3.93),('9650','2013-08-31','11:00:00',4.03),('9650','2013-08-31','11:05:00',4.15),('9650','2013-08-31','11:10:00',4.22),('9650','2013-08-31','11:15:00',4.31),('9650','2013-08-31','11:20:00',4.4),('9650','2013-08-31','11:25:00',4.49),('9650','2013-08-31','11:30:00',4.55),('9650','2013-08-31','11:35:00',4.66),('9650','2013-08-31','11:40:00',4.78),('9650','2013-08-31','11:45:00',4.89),('9650','2013-08-31','11:50:00',4.94),('9650','2013-08-31','11:55:00',5.03),('9650','2013-08-31','12:00:00',5.09),('9650','2013-08-31','12:05:00',5.03),('9650','2013-08-31','12:10:00',5.2),('9650','2013-08-31','12:15:00',5.3),('9650','2013-08-31','12:20:00',5.41),('9650','2013-08-31','12:25:00',5.32),('9650','2013-08-31','12:30:00',5.52),('9650','2013-08-31','12:35:00',5.57),('9650','2013-08-31','12:40:00',5.63),('9650','2013-08-31','12:45:00',5.61),('9650','2013-08-31','12:50:00',5.69),('9650','2013-08-31','12:55:00',5.74),('9650','2013-08-31','13:00:00',5.88),('9650','2013-08-31','13:05:00',5.84),('9650','2013-08-31','13:10:00',5.86),('9650','2013-08-31','13:15:00',5.49),('9650','2013-08-31','13:20:00',6.07),('9650','2013-08-31','13:25:00',6.06),('9650','2013-08-31','13:30:00',6.15),('9650','2013-08-31','13:35:00',6.12),('9650','2013-08-31','13:40:00',6.18),('9650','2013-08-31','13:45:00',5.91),('9650','2013-08-31','13:50:00',5.2),('9650','2013-08-31','13:55:00',5.42),('9650','2013-08-31','14:00:00',4.81),('9650','2013-08-31','14:05:00',4.79),('9650','2013-08-31','14:10:00',5.61),('9650','2013-08-31','14:15:00',5.72),('9650','2013-08-31','14:20:00',5.17),('9650','2013-08-31','14:25:00',5.21),('9650','2013-08-31','14:30:00',5.47),('9650','2013-08-31','14:35:00',5.39),('9650','2013-08-31','14:40:00',5.5),('9650','2013-08-31','14:45:00',5.65),('9650','2013-08-31','14:50:00',5.68),('9650','2013-08-31','14:55:00',5.5),('9650','2013-08-31','15:00:00',5.56),('9650','2013-08-31','15:05:00',5.48),('9650','2013-08-31','15:10:00',5.47),('9650','2013-08-31','15:15:00',5.41),('9650','2013-08-31','15:20:00',5.13),('9650','2013-08-31','15:25:00',4.55),('9650','2013-08-31','15:30:00',3.77),('9650','2013-08-31','15:35:00',4.26),('9650','2013-08-31','15:40:00',5),('9650','2013-08-31','15:45:00',4.59),('9650','2013-08-31','15:50:00',3.36),('9650','2013-08-31','15:55:00',3.89),('9650','2013-08-31','16:00:00',4.84),('9650','2013-08-31','16:05:00',5.1),('9650','2013-08-31','16:10:00',5.14),('9650','2013-08-31','16:15:00',5.01),('9650','2013-08-31','16:20:00',4.64),('9650','2013-08-31','16:25:00',4.81),('9650','2013-08-31','16:30:00',5.13),('9650','2013-08-31','16:35:00',4.94),('9650','2013-08-31','16:40:00',4.87),('9650','2013-08-31','16:45:00',4.44),('9650','2013-08-31','16:50:00',4.33),('9650','2013-08-31','16:55:00',3.83),('9650','2013-08-31','17:00:00',3.14),('9650','2013-08-31','17:05:00',3.35),('9650','2013-08-31','17:10:00',2.71),('9650','2013-08-31','17:15:00',2.82),('9650','2013-08-31','17:20:00',3.16),('9650','2013-08-31','17:25:00',3.04),('9650','2013-08-31','17:30:00',2.69),('9650','2013-08-31','17:35:00',2.77),('9650','2013-08-31','17:40:00',2.99),('9650','2013-08-31','17:45:00',2.44),('9650','2013-08-31','17:50:00',2.13),('9650','2013-08-31','17:55:00',2.09),('9650','2013-08-31','18:00:00',2.24),('9650','2013-08-31','18:05:00',2.33),('9650','2013-08-31','18:10:00',2.57),('9650','2013-08-31','18:15:00',2.47),('9650','2013-08-31','18:20:00',2.19),('9650','2013-08-31','18:25:00',2.28),('9650','2013-08-31','18:30:00',2.22),('9650','2013-08-31','18:35:00',1.87),('9650','2013-08-31','18:40:00',2.19),('9650','2013-08-31','18:45:00',2.02),('9650','2013-08-31','18:50:00',1.79),('9650','2013-08-31','18:55:00',1.56),('9650','2013-08-31','19:00:00',1.29),('9650','2013-08-30','08:50:00',1.14),('9650','2013-08-30','08:55:00',1.38),('9650','2013-08-30','09:00:00',1.49),('9650','2013-08-30','09:05:00',1.35),('9650','2013-08-30','09:10:00',1.11),('9650','2013-08-30','09:15:00',1.39),('9650','2013-08-30','09:20:00',1.6),('9650','2013-08-30','09:25:00',1.92),('9650','2013-08-30','09:30:00',2.09),('9650','2013-08-30','09:35:00',2.27),('9650','2013-08-30','09:40:00',2.39),('9650','2013-08-30','09:45:00',2.31),('9650','2013-08-30','09:50:00',2.38),('9650','2013-08-30','09:55:00',2.6),('9650','2013-08-30','10:00:00',2.83),('9650','2013-08-30','10:05:00',2.88),('9650','2013-08-30','10:10:00',3.06),('9650','2013-08-30','10:15:00',3.13),('9650','2013-08-30','10:20:00',3.24),('9650','2013-08-30','10:25:00',3.34),('9650','2013-08-30','10:30:00',3.48),('9650','2013-08-30','10:35:00',3.64),('9650','2013-08-30','10:40:00',3.69),('9650','2013-08-30','10:45:00',3.83),('9650','2013-08-30','10:50:00',3.99),('9650','2013-08-30','10:55:00',4.09),('9650','2013-08-30','11:00:00',4.24),('9650','2013-08-30','11:05:00',4.35),('9650','2013-08-30','11:10:00',4.44),('9650','2013-08-30','11:15:00',4.55),('9650','2013-08-30','11:20:00',4.66),('9650','2013-08-30','11:25:00',4.77),('9650','2013-08-30','11:30:00',4.86),('9650','2013-08-30','11:35:00',4.96),('9650','2013-08-30','11:40:00',5.07),('9650','2013-08-30','11:45:00',5.15),('9650','2013-08-30','11:50:00',5.24),('9650','2013-08-30','11:55:00',5.32),('9650','2013-08-30','12:00:00',5.01),('9650','2013-08-30','12:05:00',3.94),('9650','2013-08-30','12:10:00',4.69),('9650','2013-08-30','12:15:00',5.18),('9650','2013-08-30','12:20:00',5.57),('9650','2013-08-30','12:25:00',5.6),('9650','2013-08-30','12:30:00',5.65),('9650','2013-08-30','12:35:00',5.73),('9650','2013-08-30','12:40:00',5.74),('9650','2013-08-30','12:45:00',5.81),('9650','2013-08-30','12:50:00',5.84),('9650','2013-08-30','12:55:00',5.95),('9650','2013-08-30','13:00:00',6),('9650','2013-08-30','13:05:00',6.05),('9650','2013-08-30','13:10:00',6.03),('9650','2013-08-30','13:15:00',6.13),('9650','2013-08-30','13:20:00',6.14),('9650','2013-08-30','13:25:00',6.16),('9650','2013-08-30','13:30:00',6.22),('9650','2013-08-30','13:35:00',6.16),('9650','2013-08-30','13:40:00',6.22),('9650','2013-08-30','13:45:00',6.17),('9650','2013-08-30','13:50:00',6.29),('9650','2013-08-30','13:55:00',6.28),('9650','2013-08-30','14:00:00',6.31),('9650','2013-08-30','14:05:00',6.35),('9650','2013-08-30','14:10:00',6.31),('9650','2013-08-30','14:15:00',6.32),('9650','2013-08-30','14:20:00',6.27),('9650','2013-08-30','14:25:00',6.23),('9650','2013-08-30','14:30:00',6.24),('9650','2013-08-30','14:35:00',5.98),('9650','2013-08-30','14:40:00',6.05),('9650','2013-08-30','14:45:00',6.12),('9650','2013-08-30','14:50:00',6.16),('9650','2013-08-30','14:55:00',6.02),('9650','2013-08-30','15:00:00',6.02),('9650','2013-08-30','15:05:00',6.01),('9650','2013-08-30','15:10:00',5.97),('9650','2013-08-30','15:15:00',5.98),('9650','2013-08-30','15:20:00',5.83),('9650','2013-08-30','15:25:00',5.84),('9650','2013-08-30','15:30:00',5.84),('9650','2013-08-30','15:35:00',5.71),('9650','2013-08-30','15:40:00',5.71),('9650','2013-08-30','15:45:00',5.64),('9650','2013-08-30','15:50:00',5.55),('9650','2013-08-30','15:55:00',5.45),('9650','2013-08-30','16:00:00',5.41),('9650','2013-08-30','16:05:00',5.34),('9650','2013-08-30','16:10:00',5.33),('9650','2013-08-30','16:15:00',5.27),('9650','2013-08-30','16:20:00',5.27),('9650','2013-08-30','16:25:00',5.12),('9650','2013-08-30','16:30:00',4.99),('9650','2013-08-30','16:35:00',5.01),('9650','2013-08-30','16:40:00',4.92),('9650','2013-08-30','16:45:00',4.66),('9650','2013-08-30','16:50:00',4.53),('9650','2013-08-30','16:55:00',4.36),('9650','2013-08-30','17:00:00',4.29),('9650','2013-08-30','17:05:00',4.31),('9650','2013-08-30','17:10:00',4.22),('9650','2013-08-30','17:15:00',4.02),('9650','2013-08-30','17:20:00',3.95),('9650','2013-08-30','17:25:00',3.85),('9650','2013-08-30','17:30:00',3.75),('9650','2013-08-30','17:35:00',3.53),('9650','2013-08-30','17:40:00',3.54),('9650','2013-08-30','17:45:00',3.3),('9650','2013-08-30','17:50:00',3.15),('9650','2013-08-30','17:55:00',2.78),('9650','2013-08-30','18:00:00',1.59),('9650','2013-08-30','18:05:00',2.05),('9650','2013-08-30','18:10:00',1.85),('9650','2013-08-30','18:15:00',1.73),('9650','2013-08-30','18:20:00',1.83),('9650','2013-08-30','18:25:00',1.65),('9650','2013-08-29','08:15:00',1.02),('9650','2013-08-29','08:20:00',1.12),('9650','2013-08-29','08:25:00',1.17),('9650','2013-08-29','08:30:00',1.21),('9650','2013-08-29','08:35:00',1.42),('9650','2013-08-29','08:40:00',1.65),('9650','2013-08-29','08:45:00',1.59),('9650','2013-08-29','08:50:00',1.56),('9650','2013-08-29','08:55:00',1.66),('9650','2013-08-29','09:00:00',1.89),('9650','2013-08-29','09:05:00',2.07),('9650','2013-08-29','09:10:00',1.97),('9650','2013-08-29','09:15:00',1.83),('9650','2013-08-29','09:20:00',1.66),('9650','2013-08-29','09:25:00',1.75),('9650','2013-08-29','09:30:00',2.1),('9650','2013-08-29','09:35:00',2.3),('9650','2013-08-29','09:40:00',2.22),('9650','2013-08-29','09:45:00',2.27),('9650','2013-08-29','09:50:00',2.39),('9650','2013-08-29','09:55:00',2.57),('9650','2013-08-29','10:00:00',2.66),('9650','2013-08-29','10:05:00',2.71),('9650','2013-08-29','10:10:00',2.75),('9650','2013-08-29','10:15:00',2.92),('9650','2013-08-29','10:20:00',3),('9650','2013-08-29','10:25:00',2.86),('9650','2013-08-29','10:30:00',3.14),('9650','2013-08-29','10:35:00',3.09),('9650','2013-08-29','10:40:00',2.99),('9650','2013-08-29','10:45:00',2.97),('9650','2013-08-29','10:50:00',3.16),('9650','2013-08-29','10:55:00',3.03),('9650','2013-08-29','11:00:00',3.15),('9650','2013-08-29','11:05:00',3.27),('9650','2013-08-29','11:10:00',3.43),('9650','2013-08-29','11:15:00',3.49),('9650','2013-08-29','11:20:00',3.54),('9650','2013-08-29','11:25:00',3.55),('9650','2013-08-29','11:30:00',3.7),('9650','2013-08-29','11:35:00',3.53),('9650','2013-08-29','11:40:00',3.88),('9650','2013-08-29','11:45:00',3.85),('9650','2013-08-29','11:50:00',4.4),('9650','2013-08-29','11:55:00',3.94),('9650','2013-08-29','12:00:00',3.64),('9650','2013-08-29','12:05:00',3.25),('9650','2013-08-29','12:10:00',3.53),('9650','2013-08-29','12:15:00',3.84),('9650','2013-08-29','12:20:00',4.05),('9650','2013-08-29','12:25:00',4.55),('9650','2013-08-29','12:30:00',4.98),('9650','2013-08-29','12:35:00',4.77),('9650','2013-08-29','12:40:00',4.67),('9650','2013-08-29','12:45:00',4.88),('9650','2013-08-29','12:50:00',4.83),('9650','2013-08-29','12:55:00',4.58),('9650','2013-08-29','13:00:00',4.55),('9650','2013-08-29','13:05:00',4.62),('9650','2013-08-29','13:10:00',4.67),('9650','2013-08-29','13:15:00',4.56),('9650','2013-08-29','13:20:00',5.2),('9650','2013-08-29','13:25:00',6.01),('9650','2013-08-29','13:30:00',6.36),('9650','2013-08-29','13:35:00',5.87),('9650','2013-08-29','13:40:00',6.21),('9650','2013-08-29','13:45:00',5.6),('9650','2013-08-29','13:50:00',5.64),('9650','2013-08-29','13:55:00',6.2),('9650','2013-08-29','14:00:00',6.49),('9650','2013-08-29','14:05:00',6.22),('9650','2013-08-29','14:10:00',6.31),('9650','2013-08-29','14:15:00',6.21),('9650','2013-08-29','14:20:00',6.4),('9650','2013-08-29','14:25:00',6.38),('9650','2013-08-29','14:30:00',6.41),('9650','2013-08-29','14:35:00',6.55),('9650','2013-08-29','14:40:00',6.28),('9650','2013-08-29','14:45:00',5.03),('9650','2013-08-29','14:50:00',4.36),('9650','2013-08-29','14:55:00',4.98),('9650','2013-08-29','15:00:00',4.28),('9650','2013-08-29','15:05:00',3.93),('9650','2013-08-29','15:10:00',4.03),('9650','2013-08-29','15:15:00',5.06),('9650','2013-08-29','15:20:00',4.31),('9650','2013-08-29','15:25:00',3.89),('9650','2013-08-29','15:30:00',3.72),('9650','2013-08-29','15:35:00',3.05),('9650','2013-08-29','15:40:00',3.36),('9650','2013-08-29','15:45:00',3.95),('9650','2013-08-29','15:50:00',4.25),('9650','2013-08-29','15:55:00',4.19),('9650','2013-08-29','16:00:00',4),('9650','2013-08-29','16:05:00',3.51),('9650','2013-08-29','16:10:00',2.89),('9650','2013-08-29','16:15:00',2.66),('9650','2013-08-29','16:20:00',3.08),('9650','2013-08-29','16:25:00',3.04),('9650','2013-08-29','16:30:00',3.44),('9650','2013-08-29','16:35:00',2.48),('9650','2013-08-29','16:40:00',4.37),('9650','2013-08-29','16:45:00',4.96),('9650','2013-08-29','16:50:00',4.73),('9650','2013-08-29','16:55:00',3.17),('9650','2013-08-29','17:00:00',3.69),('9650','2013-08-29','17:05:00',2.64),('9650','2013-08-29','17:10:00',3.13),('9650','2013-08-29','17:15:00',2.96),('9650','2013-08-29','17:20:00',2.53),('9650','2013-08-29','17:25:00',2.69),('9650','2013-08-29','17:30:00',2.89),('9650','2013-08-29','17:35:00',3.04),('9650','2013-08-29','17:40:00',2.31),('9650','2013-08-29','17:45:00',3.17),('9650','2013-08-29','17:50:00',2.37),('9650','2013-08-29','17:55:00',2.94),('9650','2013-08-29','18:00:00',2.76),('9650','2013-08-29','18:05:00',1.37),('9650','2014-04-10','08:40:00',1.17),('9650','2014-04-10','08:45:00',1.2),('9650','2014-04-10','08:50:00',1.21),('9650','2014-04-10','08:55:00',1.25),('9650','2014-04-10','09:00:00',1.3),('9650','2014-04-10','09:05:00',1.38),('9650','2014-04-10','09:10:00',1.5),('9650','2014-04-10','09:15:00',1.62),('9650','2014-04-10','09:20:00',1.74),('9650','2014-04-10','09:25:00',1.87),('9650','2014-04-10','09:30:00',2.02),('9650','2014-04-10','09:35:00',2.16),('9650','2014-04-10','09:40:00',2.29),('9650','2014-04-10','09:45:00',2.41),('9650','2014-04-10','09:50:00',2.57),('9650','2014-04-10','09:55:00',2.69),('9650','2014-04-10','10:00:00',2.84),('9650','2014-04-10','10:05:00',3),('9650','2014-04-10','10:10:00',3.12),('9650','2014-04-10','10:15:00',3.25),('9650','2014-04-10','10:20:00',3.37),('9650','2014-04-10','10:25:00',3.51),('9650','2014-04-10','10:30:00',3.63),('9650','2014-04-10','10:35:00',3.76),('9650','2014-04-10','10:40:00',3.85),('9650','2014-04-10','10:45:00',4.01),('9650','2014-04-10','10:50:00',4.14),('9650','2014-04-10','10:55:00',4.25),('9650','2014-04-10','11:00:00',4.4),('9650','2014-04-10','11:05:00',4.5),('9650','2014-04-10','11:10:00',4.55),('9650','2014-04-10','11:15:00',4.65),('9650','2014-04-10','11:20:00',4.86),('9650','2014-04-10','11:25:00',5),('9650','2014-04-10','11:30:00',5.06),('9650','2014-04-10','11:35:00',5.16),('9650','2014-04-10','11:40:00',5.17),('9650','2014-04-10','11:45:00',5.38),('9650','2014-04-10','11:50:00',5.49),('9650','2014-04-10','11:55:00',5.79),('9650','2014-04-10','12:00:00',5.93),('9650','2014-04-10','12:05:00',5.81),('9650','2014-04-10','12:10:00',6.19),('9650','2014-04-10','12:15:00',5.15),('9650','2014-04-10','12:20:00',6.12),('9650','2014-04-10','12:25:00',6.23),('9650','2014-04-10','12:30:00',6.43),('9650','2014-04-10','12:35:00',6.62),('9650','2014-04-10','12:40:00',6.7),('9650','2014-04-10','12:45:00',5.64),('9650','2014-04-10','12:50:00',7.01),('9650','2014-04-10','12:55:00',6.83),('9650','2014-04-10','13:00:00',5.8),('9650','2014-04-10','13:05:00',4.82),('9650','2014-04-10','13:10:00',5.22),('9650','2014-04-10','13:15:00',5.69),('9650','2014-04-10','13:20:00',4.65),('9650','2014-04-10','13:25:00',5.55),('9650','2014-04-10','13:30:00',3.77),('9650','2014-04-10','13:35:00',5.28),('9650','2014-04-10','13:40:00',3.44),('9650','2014-04-10','13:45:00',7.17),('9650','2014-04-10','13:50:00',5.32),('9650','2014-04-10','13:55:00',6.74),('9650','2014-04-10','14:00:00',4.46),('9650','2014-04-10','14:05:00',6.94),('9650','2014-04-10','14:10:00',4.58),('9650','2014-04-10','14:15:00',5.43),('9650','2014-04-10','14:20:00',6.49),('9650','2014-04-10','14:25:00',4.23),('9650','2014-04-10','14:30:00',7.59),('9650','2014-04-10','14:35:00',7.75),('9650','2014-04-10','14:40:00',4.31),('9650','2014-04-10','14:45:00',6.13),('9650','2014-04-10','14:50:00',7.41),('9650','2014-04-10','14:55:00',4.62),('9650','2014-04-10','15:00:00',7.25),('9650','2014-04-10','15:05:00',7.38),('9650','2014-04-10','15:10:00',6.12),('9650','2014-04-10','15:15:00',6.73),('9650','2014-04-10','15:20:00',5.76),('9650','2014-04-10','15:25:00',6.89),('9650','2014-04-10','15:30:00',6.73),('9650','2014-04-10','15:35:00',5.21),('9650','2014-04-10','15:40:00',6.47),('9650','2014-04-10','15:45:00',6.27),('9650','2014-04-10','15:50:00',6.33),('9650','2014-04-10','15:55:00',6.3),('9650','2014-04-10','16:00:00',6.08),('9650','2014-04-10','16:05:00',5.94),('9650','2014-04-10','16:10:00',4.77),('9650','2014-04-10','16:15:00',5.24),('9650','2014-04-10','16:20:00',5.62),('9650','2014-04-10','16:25:00',5.63),('9650','2014-04-10','16:30:00',5.61),('9650','2014-04-10','16:35:00',4.96),('9650','2014-04-10','16:40:00',5.3),('9650','2014-04-10','16:45:00',5.35),('9650','2014-04-10','16:50:00',4.1),('9650','2014-04-10','16:55:00',3.88),('9650','2014-04-10','17:00:00',5.08),('9650','2014-04-10','17:05:00',4.63),('9650','2014-04-10','17:10:00',4.25),('9650','2014-04-10','17:15:00',4.25),('9650','2014-04-10','17:20:00',4.44),('9650','2014-04-10','17:25:00',4.36),('9650','2014-04-10','17:30:00',4.48),('9650','2014-04-10','17:35:00',4.36),('9650','2014-04-10','17:40:00',4.09),('9650','2014-04-10','17:45:00',3.82),('9650','2014-04-10','17:50:00',3.63),('9650','2014-04-10','17:55:00',3.5),('9650','2014-04-10','18:00:00',3.28),('9650','2014-04-10','18:05:00',3.17),('9650','2014-04-10','18:10:00',3.01),('9650','2014-04-10','18:15:00',2.92),('9650','2014-04-10','18:20:00',2.8),('9650','2014-04-10','18:25:00',2.61),('9650','2014-04-10','18:30:00',2.76),('9650','2014-04-10','18:35:00',2.51),('9650','2014-04-10','18:40:00',2.18),('9650','2014-04-10','18:45:00',1.94),('9650','2014-04-10','18:50:00',1.83),('9650','2014-04-10','18:55:00',1.65),('9650','2014-04-10','19:00:00',1.36),('9650','2013-08-28','08:30:00',1.27),('9650','2013-08-28','08:35:00',1.58),('9650','2013-08-28','08:40:00',1.61),('9650','2013-08-28','08:45:00',1.6),('9650','2013-08-28','08:50:00',1.8),('9650','2013-08-28','08:55:00',2.09),('9650','2013-08-28','09:00:00',2.15),('9650','2013-08-28','09:05:00',2.16),('9650','2013-08-28','09:10:00',2.17),('9650','2013-08-28','09:15:00',2.26),('9650','2013-08-28','09:20:00',2.28),('9650','2013-08-28','09:25:00',2.23),('9650','2013-08-28','09:30:00',2.31),('9650','2013-08-28','09:35:00',2.52),('9650','2013-08-28','09:40:00',2.59),('9650','2013-08-28','09:45:00',2.42),('9650','2013-08-28','09:50:00',2.4),('9650','2013-08-28','09:55:00',2.47),('9650','2013-08-28','10:00:00',2.56),('9650','2013-08-28','10:05:00',2.52),('9650','2013-08-28','10:10:00',2.5),('9650','2013-08-28','10:15:00',2.52),('9650','2013-08-28','10:20:00',2.57),('9650','2013-08-28','10:25:00',2.6),('9650','2013-08-28','10:30:00',2.65),('9650','2013-08-28','10:35:00',2.52),('9650','2013-08-28','10:40:00',2.33),('9650','2013-08-28','10:45:00',2.22),('9650','2013-08-28','10:50:00',2.27),('9650','2013-08-28','10:55:00',2.55),('9650','2013-08-28','11:00:00',2.67),('9650','2013-08-28','11:05:00',2.7),('9650','2013-08-28','11:10:00',3.64),('9650','2013-08-28','11:15:00',4.02),('9650','2013-08-28','11:20:00',3.82),('9650','2013-08-28','11:25:00',2.95),('9650','2013-08-28','11:30:00',2.56),('9650','2013-08-28','11:35:00',2.43),('9650','2013-08-28','11:40:00',2.8),('9650','2013-08-28','11:45:00',3.19),('9650','2013-08-28','11:50:00',3.28),('9650','2013-08-28','11:55:00',3.14),('9650','2013-08-28','12:00:00',3.03),('9650','2013-08-28','12:05:00',3.32),('9650','2013-08-28','12:10:00',3.84),('9650','2013-08-28','12:15:00',4.46),('9650','2013-08-28','12:20:00',4.07),('9650','2013-08-28','12:25:00',4.21),('9650','2013-08-28','12:30:00',4.2),('9650','2013-08-28','12:35:00',4.89),('9650','2013-08-28','12:40:00',6.86),('9650','2013-08-28','12:45:00',6.79),('9650','2013-08-28','12:50:00',4.51),('9650','2013-08-28','12:55:00',6.07),('9650','2013-08-28','13:00:00',4.52),('9650','2013-08-28','13:05:00',4.39),('9650','2013-08-28','13:10:00',4.26),('9650','2013-08-28','13:15:00',4.11),('9650','2013-08-28','13:20:00',3.96),('9650','2013-08-28','13:25:00',3.48),('9650','2013-08-28','13:30:00',3.24),('9650','2013-08-28','13:35:00',3.1),('9650','2013-08-28','13:40:00',2.99),('9650','2013-08-28','13:45:00',2.82),('9650','2013-08-28','13:50:00',2.77),('9650','2013-08-28','13:55:00',3.15),('9650','2013-08-28','14:00:00',3.94),('9650','2013-08-28','14:05:00',2.89),('9650','2013-08-28','14:10:00',2.62),('9650','2013-08-28','14:15:00',2.16),('9650','2013-08-28','14:20:00',1.76),('9650','2013-08-28','14:25:00',1.61),('9650','2013-08-28','14:30:00',1.59),('9650','2013-08-28','14:35:00',1.69),('9650','2013-08-28','14:40:00',1.79),('9650','2013-08-28','14:45:00',1.99),('9650','2013-08-28','14:50:00',2.29),('9650','2013-08-28','14:55:00',2.58),('9650','2013-08-28','15:00:00',2.78),('9650','2013-08-28','15:05:00',3.06),('9650','2013-08-28','15:10:00',2.43),('9650','2013-08-28','15:15:00',2.16),('9650','2013-08-28','15:20:00',2.44),('9650','2013-08-28','15:25:00',2.83),('9650','2013-08-28','15:30:00',4.53),('9650','2013-08-28','15:35:00',4.25),('9650','2013-08-28','15:40:00',4.07),('9650','2013-08-28','15:45:00',4.43),('9650','2013-08-28','15:50:00',5.51),('9650','2013-08-28','15:55:00',5.92),('9650','2013-08-28','16:00:00',5.49),('9650','2013-08-28','16:05:00',6.28),('9650','2013-08-28','16:10:00',6.02),('9650','2013-08-28','16:15:00',5.67),('9650','2013-08-28','16:20:00',5.54),('9650','2013-08-28','16:25:00',5.38),('9650','2013-08-28','16:30:00',5.29),('9650','2013-08-28','16:35:00',5.26),('9650','2013-08-28','16:40:00',5.17),('9650','2013-08-28','16:45:00',5.05),('9650','2013-08-28','16:50:00',4.92),('9650','2013-08-28','16:55:00',4.81),('9650','2013-08-28','17:00:00',4.7),('9650','2013-08-28','17:05:00',4.59),('9650','2013-08-28','17:10:00',4.49),('9650','2013-08-28','17:15:00',4.36),('9650','2013-08-28','17:20:00',4.27),('9650','2013-08-28','17:25:00',4.1),('9650','2013-08-28','17:30:00',4.08),('9650','2013-08-28','17:35:00',3.95),('9650','2013-08-28','17:40:00',3.81),('9650','2013-08-28','17:45:00',3.65),('9650','2013-08-28','17:50:00',3.53),('9650','2013-08-28','17:55:00',3.42),('9650','2013-08-28','18:00:00',3.22),('9650','2013-08-28','18:05:00',3.1),('9650','2013-08-28','18:10:00',2.97),('9650','2013-08-28','18:15:00',2.87),('9650','2013-08-28','18:20:00',2.75),('9650','2013-08-28','18:25:00',2.61),('9650','2013-08-28','18:30:00',2.43),('9650','2013-08-28','18:35:00',2.26),('9650','2013-08-28','18:40:00',2.07),('9650','2013-08-28','18:45:00',1.89),('9650','2013-08-28','18:50:00',1.71),('9650','2013-08-28','18:55:00',1.49),('9650','2013-08-28','19:00:00',1.29),('9650','2013-08-28','19:05:00',1.07),('9650','2013-08-27','08:40:00',1.21),('9650','2013-08-27','08:45:00',1.53),('9650','2013-08-27','08:50:00',1.38),('9650','2013-08-27','08:55:00',1.07),('9650','2013-08-27','09:00:00',1.53),('9650','2013-08-27','09:05:00',1.22),('9650','2013-08-27','09:10:00',1.36),('9650','2013-08-27','09:15:00',2.18),('9650','2013-08-27','09:20:00',1.77),('9650','2013-08-27','09:25:00',1.26),('9650','2013-08-27','09:30:00',1.5),('9650','2013-08-27','09:35:00',2.11),('9650','2013-08-27','09:40:00',2.29),('9650','2013-08-27','09:45:00',2.45),('9650','2013-08-27','09:50:00',2.59),('9650','2013-08-27','09:55:00',2.66),('9650','2013-08-27','10:00:00',2.8),('9650','2013-08-27','10:05:00',2.87),('9650','2013-08-27','10:10:00',3.12),('9650','2013-08-27','10:15:00',3.45),('9650','2013-08-27','10:20:00',3.75),('9650','2013-08-27','10:25:00',2.4),('9650','2013-08-27','10:30:00',3.05),('9650','2013-08-27','10:35:00',2.51),('9650','2013-08-27','10:40:00',3.06),('9650','2013-08-27','10:45:00',4.43),('9650','2013-08-27','10:50:00',3.9),('9650','2013-08-27','10:55:00',4.27),('9650','2013-08-27','11:00:00',1.89),('9650','2013-08-27','11:05:00',4.29),('9650','2013-08-27','11:10:00',2.95),('9650','2013-08-27','11:15:00',4.87),('9650','2013-08-27','11:20:00',5.23),('9650','2013-08-27','11:25:00',5.36),('9650','2013-08-27','11:30:00',5.54),('9650','2013-08-27','11:35:00',5.59),('9650','2013-08-27','11:40:00',5.85),('9650','2013-08-27','11:45:00',3.74),('9650','2013-08-27','11:50:00',4.71),('9650','2013-08-27','11:55:00',3.53),('9650','2013-08-27','12:00:00',3.96),('9650','2013-08-27','12:05:00',4.99),('9650','2013-08-27','12:10:00',5.59),('9650','2013-08-27','12:15:00',5.62),('9650','2013-08-27','12:20:00',6),('9650','2013-08-27','12:25:00',6.08),('9650','2013-08-27','12:30:00',6.08),('9650','2013-08-27','12:35:00',6.11),('9650','2013-08-27','12:40:00',6.21),('9650','2013-08-27','12:45:00',6.46),('9650','2013-08-27','12:50:00',6.36),('9650','2013-08-27','12:55:00',6.32),('9650','2013-08-27','13:00:00',6.52),('9650','2013-08-27','13:05:00',6.13),('9650','2013-08-27','13:10:00',6.76),('9650','2013-08-27','13:15:00',6.44),('9650','2013-08-27','13:20:00',6.53),('9650','2013-08-27','13:25:00',6.59),('9650','2013-08-27','13:30:00',6.55),('9650','2013-08-27','13:35:00',6.67),('9650','2013-08-27','13:40:00',5.42),('9650','2013-08-27','13:45:00',5.96),('9650','2013-08-27','13:50:00',6.88),('9650','2013-08-27','13:55:00',5.04),('9650','2013-08-27','14:00:00',6.72),('9650','2013-08-27','14:05:00',6.67),('9650','2013-08-27','14:10:00',6.81),('9650','2013-08-27','14:15:00',6.82),('9650','2013-08-27','14:20:00',6.78),('9650','2013-08-27','14:25:00',6.82),('9650','2013-08-27','14:30:00',5.32),('9650','2013-08-27','14:35:00',6.01),('9650','2013-08-27','14:40:00',7.1),('9650','2013-08-27','14:45:00',6.84),('9650','2013-08-27','14:50:00',6.77),('9650','2013-08-27','14:55:00',6.72),('9650','2013-08-27','15:00:00',6.66),('9650','2013-08-27','15:05:00',6.38),('9650','2013-08-27','15:10:00',6.85),('9650','2013-08-27','15:15:00',6.73),('9650','2013-08-27','15:20:00',6.71),('9650','2013-08-27','15:25:00',4.95),('9650','2013-08-27','15:30:00',4.56),('9650','2013-08-27','15:35:00',5.88),('9650','2013-08-27','15:40:00',2.76),('9650','2013-08-27','15:45:00',3.5),('9650','2013-08-27','15:50:00',3.17),('9650','2013-08-27','15:55:00',5.28),('9650','2013-08-27','16:00:00',6.48),('9650','2013-08-27','16:05:00',5.3),('9650','2013-08-27','16:10:00',4.54),('9650','2013-08-27','16:15:00',4.28),('9650','2013-08-27','16:20:00',3.96),('9650','2013-08-27','16:25:00',6.1),('9650','2013-08-27','16:30:00',5.78),('9650','2013-08-27','16:35:00',5.71),('9650','2013-08-27','16:40:00',5.62),('9650','2013-08-27','16:45:00',5.31),('9650','2013-08-27','16:50:00',5.11),('9650','2013-08-27','16:55:00',5.01),('9650','2013-08-27','17:00:00',4.99),('9650','2013-08-27','17:05:00',4.77),('9650','2013-08-27','17:10:00',3.68),('9650','2013-08-27','17:15:00',4.29),('9650','2013-08-27','17:20:00',2.33),('9650','2013-08-27','17:25:00',3.95),('9650','2013-08-27','17:30:00',2.25),('9650','2013-08-27','17:35:00',3.88),('9650','2013-08-27','17:40:00',4.17),('9650','2013-08-27','17:45:00',2.44),('9650','2013-08-27','17:50:00',1.09),('9650','2013-08-27','17:55:00',3.34),('9650','2013-08-27','18:00:00',1.07),('9650','2013-08-27','18:05:00',1.61),('9650','2013-08-27','18:10:00',1.95),('9650','2013-08-27','18:15:00',3.1),('9650','2013-08-27','18:20:00',1.62),('9650','2013-08-27','18:25:00',2.63),('9650','2013-08-27','18:45:00',1.11),('9650','2013-08-27','18:50:00',1.85),('9650','2013-08-27','18:55:00',1.23),('9650','2013-08-27','19:00:00',1.5),('9650','2013-08-27','19:05:00',1.2),('9650','2013-08-26','08:10:00',1.04),('9650','2013-08-26','08:15:00',1.11),('9650','2013-08-26','08:20:00',1.17),('9650','2013-08-26','08:25:00',1.21),('9650','2013-08-26','08:30:00',1.19),('9650','2013-08-26','08:35:00',1.06),('9650','2013-08-26','09:10:00',1.13),('9650','2013-08-26','09:15:00',1.18),('9650','2013-08-26','09:20:00',1.35),('9650','2013-08-26','09:25:00',1.76),('9650','2013-08-26','09:30:00',2.04),('9650','2013-08-26','09:35:00',1.39),('9650','2013-08-26','09:40:00',1.2),('9650','2013-08-26','09:45:00',1.25),('9650','2013-08-26','09:50:00',1.29),('9650','2013-08-26','09:55:00',1.58),('9650','2013-08-26','10:00:00',1.98),('9650','2013-08-26','10:05:00',2.36),('9650','2013-08-26','10:10:00',2.98),('9650','2013-08-26','10:15:00',3.08),('9650','2013-08-26','10:20:00',3.33),('9650','2013-08-26','10:25:00',3.43),('9650','2013-08-26','10:30:00',3.49),('9650','2013-08-26','10:35:00',3.65),('9650','2013-08-26','10:40:00',3.68),('9650','2013-08-26','10:45:00',3.82),('9650','2013-08-26','10:50:00',3.94),('9650','2013-08-26','10:55:00',4),('9650','2013-08-26','11:00:00',4.21),('9650','2013-08-26','11:05:00',4.29),('9650','2013-08-26','11:10:00',4.4),('9650','2013-08-26','11:15:00',4.42),('9650','2013-08-26','11:20:00',4.46),('9650','2013-08-26','11:25:00',4.56),('9650','2013-08-26','11:30:00',4.54),('9650','2013-08-26','11:35:00',4.78),('9650','2013-08-26','11:40:00',4.79),('9650','2013-08-26','11:45:00',6.18),('9650','2013-08-26','11:50:00',4.54),('9650','2013-08-26','11:55:00',5.9),('9650','2013-08-26','12:00:00',6.28),('9650','2013-08-26','12:05:00',5.59),('9650','2013-08-26','12:10:00',4.76),('9650','2013-08-26','12:15:00',5.5),('9650','2013-08-26','12:20:00',5.91),('9650','2013-08-26','12:25:00',5.79),('9650','2013-08-26','12:30:00',6.04),('9650','2013-08-26','12:35:00',6.41),('9650','2013-08-26','12:40:00',6.68),('9650','2013-08-26','12:45:00',4.73),('9650','2013-08-26','12:50:00',3.53),('9650','2013-08-26','12:55:00',3.45),('9650','2013-08-26','13:00:00',2.34),('9650','2013-08-26','13:05:00',2.71),('9650','2013-08-26','13:10:00',3.27),('9650','2013-08-26','13:15:00',2.93),('9650','2013-08-26','13:20:00',3.6),('9650','2013-08-26','13:25:00',3.81),('9650','2013-08-26','13:30:00',4.29),('9650','2013-08-26','13:35:00',3.46),('9650','2013-08-26','13:40:00',3.28),('9650','2013-08-26','13:45:00',4.59),('9650','2013-08-26','13:50:00',6.57),('9650','2013-08-26','13:55:00',5.65),('9650','2013-08-26','14:00:00',6.68),('9650','2013-08-26','14:05:00',3.78),('9650','2013-08-26','14:10:00',3.88),('9650','2013-08-26','14:15:00',5.65),('9650','2013-08-26','14:20:00',3.49),('9650','2013-08-26','14:25:00',2.32),('9650','2013-08-26','14:30:00',2.2),('9650','2013-08-26','14:35:00',2),('9650','2013-08-26','14:40:00',2.23),('9650','2013-08-26','14:45:00',2.26),('9650','2013-08-26','14:50:00',1.77),('9650','2013-08-26','14:55:00',1.43),('9650','2013-08-26','15:00:00',1.44),('9650','2013-08-26','15:05:00',1.33),('9650','2013-08-26','15:10:00',1.22),('9650','2013-08-26','15:15:00',1.32),('9650','2013-08-26','15:20:00',1.19),('9650','2013-08-26','15:55:00',2.44),('9650','2013-08-26','16:00:00',2.72),('9650','2013-08-26','16:05:00',2.97),('9650','2013-08-26','16:10:00',6.74),('9650','2013-08-26','16:15:00',5.67),('9650','2013-08-26','16:20:00',4.07),('9650','2013-08-26','16:25:00',4.24),('9650','2013-08-26','16:30:00',1.84),('9650','2013-08-26','16:35:00',2.37),('9650','2013-08-26','16:40:00',2.53),('9650','2013-08-26','16:45:00',4.11),('9650','2013-08-26','16:50:00',5.3),('9650','2013-08-26','16:55:00',3.48),('9650','2013-08-26','17:00:00',1.35),('9650','2013-08-26','17:05:00',2.34),('9650','2013-08-26','17:10:00',5.56),('9650','2013-08-26','17:15:00',2.5),('9650','2013-08-26','17:20:00',1.55),('9650','2013-08-26','17:25:00',1.56),('9650','2013-08-26','17:30:00',1.29),('9650','2013-08-26','17:35:00',1.67),('9650','2013-08-26','17:40:00',1.44),('9650','2013-08-26','17:45:00',3.02),('9650','2013-08-26','17:50:00',3.63),('9650','2013-08-26','17:55:00',3.6),('9650','2013-08-26','18:00:00',3.23),('9650','2013-08-26','18:05:00',2.53),('9650','2013-08-25','08:50:00',1.09),('9650','2013-08-25','08:55:00',1.2),('9650','2013-08-25','09:00:00',1.32),('9650','2013-08-25','09:05:00',1.43),('9650','2013-08-25','09:10:00',1.56),('9650','2013-08-25','09:15:00',1.7),('9650','2013-08-25','09:20:00',1.82),('9650','2013-08-25','09:25:00',1.96),('9650','2013-08-25','09:30:00',2.08),('9650','2013-08-25','09:35:00',2.2),('9650','2013-08-25','09:40:00',2.36),('9650','2013-08-25','09:45:00',2.48),('9650','2013-08-25','09:50:00',2.62),('9650','2013-08-25','09:55:00',2.7),('9650','2013-08-25','10:00:00',2.83),('9650','2013-08-25','10:05:00',2.95),('9650','2013-08-25','10:10:00',3.07),('9650','2013-08-25','10:15:00',3.17),('9650','2013-08-25','10:20:00',3.34),('9650','2013-08-25','10:25:00',3.49),('9650','2013-08-25','10:30:00',3.55),('9650','2013-08-25','10:35:00',3.67),('9650','2013-08-25','10:40:00',3.82),('9650','2013-08-25','10:45:00',3.95),('9650','2013-08-25','10:50:00',4.06),('9650','2013-08-25','10:55:00',4.15),('9650','2013-08-25','11:00:00',4.27),('9650','2013-08-25','11:05:00',4.33),('9650','2013-08-25','11:10:00',4.42),('9650','2013-08-25','11:15:00',4.54),('9650','2013-08-25','11:20:00',4.61),('9650','2013-08-25','11:25:00',4.72),('9650','2013-08-25','11:30:00',4.83),('9650','2013-08-25','11:35:00',4.92),('9650','2013-08-25','11:40:00',5.02),('9650','2013-08-25','11:45:00',5.08),('9650','2013-08-25','11:50:00',1.6),('9650','2013-08-25','11:55:00',3.08),('9650','2013-08-25','12:00:00',5.27),('9650','2013-08-25','12:05:00',5.35),('9650','2013-08-25','12:10:00',5.44),('9650','2013-08-25','12:15:00',5.49),('9650','2013-08-25','12:20:00',5.52),('9650','2013-08-25','12:25:00',5.57),('9650','2013-08-25','12:30:00',5.62),('9650','2013-08-25','12:35:00',5.76),('9650','2013-08-25','12:51:00',5.8),('9650','2013-08-25','12:55:00',6.08),('9650','2013-08-25','13:10:00',5.96),('9650','2013-08-25','13:15:00',5.68),('9650','2013-08-25','13:31:00',5.16),('9650','2013-08-25','13:35:00',5.99),('9650','2013-08-25','13:47:00',6.33),('9650','2013-08-25','13:50:00',6.3),('9650','2013-08-25','14:06:00',5.53),('9650','2013-08-25','14:10:00',7.26),('9650','2013-08-25','14:22:00',6.92),('9650','2013-08-25','14:25:00',6.3),('9650','2013-08-25','14:41:00',6.06),('9650','2013-08-25','14:45:00',3.91),('9650','2013-08-25','14:57:00',3.68),('9650','2013-08-25','15:00:00',3.15),('9650','2013-08-25','15:16:00',2.66),('9650','2013-08-25','15:20:00',1.25),('9650','2013-08-25','15:32:00',1.25),('9650','2013-08-25','15:35:00',1.85),('9650','2013-08-25','15:51:00',2.64),('9650','2013-08-25','15:55:00',2.85),('9650','2013-08-25','16:07:00',4.36),('9650','2013-08-25','16:10:00',5.66),('9650','2013-08-25','16:26:00',5.36),('9650','2013-08-25','16:30:00',5.07),('9650','2013-08-25','16:42:00',5.04),('9650','2013-08-25','16:45:00',4.86),('9650','2013-08-25','17:01:00',4.66),('9650','2013-08-25','17:05:00',4.06),('9650','2013-08-25','17:17:00',4.17),('9650','2013-08-25','17:20:00',2.27),('9650','2013-08-25','17:32:00',1.59),('9650','2013-08-25','17:35:00',2.14),('9650','2013-08-25','17:40:00',2.56),('9650','2013-08-25','17:45:00',2.99),('9650','2013-08-25','17:50:00',3.51),('9650','2013-08-25','17:55:00',3.47),('9650','2013-08-25','18:00:00',3.13),('9650','2013-08-25','18:05:00',2.84),('9650','2013-08-25','18:10:00',2.62),('9650','2013-08-25','18:15:00',2.42),('9650','2013-08-25','18:20:00',2.3),('9650','2013-08-25','18:25:00',2.16),('9650','2013-08-25','18:30:00',1.96),('9650','2013-08-25','18:35:00',1.86),('9650','2013-08-25','18:40:00',1.7),('9650','2013-08-25','18:45:00',1.53),('9650','2013-08-25','18:50:00',1.29),('9650','2013-08-25','18:55:00',1.12),('9650','2013-08-24','08:10:00',1.04),('9650','2013-08-24','08:35:00',1.05),('9650','2013-08-24','08:40:00',1.37),('9650','2013-08-24','08:45:00',1.75),('9650','2013-08-24','08:50:00',1.25),('9650','2013-08-24','09:05:00',1.01),('9650','2013-08-24','09:10:00',1.18),('9650','2013-08-24','09:15:00',1.23),('9650','2013-08-24','09:20:00',2.18),('9650','2013-08-24','09:25:00',2.31),('9650','2013-08-24','09:30:00',2.23),('9650','2013-08-24','09:35:00',1.76),('9650','2013-08-24','09:40:00',3.29),('9650','2013-08-24','09:45:00',4.1),('9650','2013-08-24','09:50:00',3.98),('9650','2013-08-24','09:55:00',4.05),('9650','2013-08-24','10:00:00',3.18),('9650','2013-08-24','10:05:00',2.06),('9650','2013-08-24','10:10:00',1.37),('9650','2013-08-24','10:15:00',1.07),('9650','2013-08-24','10:20:00',1.07),('9650','2013-08-24','14:55:00',1.09),('9650','2013-08-24','15:00:00',1.51),('9650','2013-08-24','15:05:00',1.87),('9650','2013-08-24','15:10:00',2.02),('9650','2013-08-24','15:15:00',2.3),('9650','2013-08-24','15:20:00',2.66),('9650','2013-08-24','15:25:00',2.81),('9650','2013-08-24','15:30:00',3.84),('9650','2013-08-24','15:35:00',6.02),('9650','2013-08-24','15:40:00',6.48),('9650','2013-08-24','15:45:00',6.76),('9650','2013-08-24','15:50:00',4.35),('9650','2013-08-24','15:55:00',4.69),('9650','2013-08-24','16:00:00',6.46),('9650','2013-08-24','16:05:00',6.15),('9650','2013-08-24','16:10:00',5.93),('9650','2013-08-24','16:15:00',5.78),('9650','2013-08-24','16:20:00',5.68),('9650','2013-08-24','16:25:00',5.64),('9650','2013-08-24','16:30:00',5.59),('9650','2013-08-24','16:35:00',5.43),('9650','2013-08-24','16:40:00',3.95),('9650','2013-08-24','16:45:00',2.64),('9650','2013-08-24','16:50:00',3.99),('9650','2013-08-24','16:55:00',3.77),('9650','2013-08-24','17:00:00',4.8),('9650','2013-08-24','17:05:00',5),('9650','2013-08-24','17:10:00',4.77),('9650','2013-08-24','17:15:00',4.44),('9650','2013-08-24','17:20:00',4.27),('9650','2013-08-24','17:25:00',4.16),('9650','2013-08-24','17:30:00',4.06),('9650','2013-08-24','17:35:00',3.61),('9650','2013-08-24','17:40:00',3.23),('9650','2013-08-24','17:45:00',3.85),('9650','2013-08-24','17:50:00',3.49),('9650','2013-08-24','17:55:00',2.88),('9650','2013-08-24','18:00:00',2.35),('9650','2013-08-24','18:05:00',2.14),('9650','2013-08-24','18:10:00',2.62),('9650','2013-08-24','18:15:00',2.84),('9650','2013-08-24','18:20:00',2.76),('9650','2013-08-24','18:25:00',2.54),('9650','2013-08-24','18:30:00',2.12),('9650','2013-08-24','18:35:00',1.64),('9650','2013-08-24','18:40:00',1.05),('9650','2013-08-24','18:55:00',1.19),('9650','2013-08-24','19:00:00',1.09),('9650','2013-08-24','19:05:00',1.05),('9650','2013-08-23','08:35:00',1.05),('9650','2013-08-23','08:40:00',1.2),('9650','2013-08-23','08:45:00',1.24),('9650','2013-08-23','08:50:00',1.23),('9650','2013-08-23','08:55:00',1.49),('9650','2013-08-23','09:00:00',1.67),('9650','2013-08-23','09:05:00',1.92),('9650','2013-08-23','09:10:00',1.85),('9650','2013-08-23','09:15:00',1.87),('9650','2013-08-23','09:20:00',1.46),('9650','2013-08-23','09:25:00',1.88),('9650','2013-08-23','09:30:00',2.11),('9650','2013-08-23','09:35:00',2.51),('9650','2013-08-23','09:40:00',2.11),('9650','2013-08-23','09:45:00',2.52),('9650','2013-08-23','09:50:00',2.19),('9650','2013-08-23','09:55:00',2.14),('9650','2013-08-23','10:00:00',2.76),('9650','2013-08-23','10:05:00',2.92),('9650','2013-08-23','10:10:00',3.09),('9650','2013-08-23','10:15:00',3.2),('9650','2013-08-23','10:20:00',3.34),('9650','2013-08-23','10:25:00',3.42),('9650','2013-08-23','10:30:00',3.51),('9650','2013-08-23','10:35:00',3.66),('9650','2013-08-23','10:40:00',3.76),('9650','2013-08-23','10:45:00',3.63),('9650','2013-08-23','10:50:00',2.23),('9650','2013-08-23','10:55:00',4.19),('9650','2013-08-23','11:00:00',4.22),('9650','2013-08-23','11:05:00',4.36),('9650','2013-08-23','11:10:00',4.49),('9650','2013-08-23','11:15:00',4.45),('9650','2013-08-23','11:20:00',4.56),('9650','2013-08-23','11:25:00',4.66),('9650','2013-08-23','11:30:00',4.77),('9650','2013-08-23','11:35:00',4.83),('9650','2013-08-23','11:40:00',4.96),('9650','2013-08-23','11:45:00',5.04),('9650','2013-08-23','11:50:00',5.08),('9650','2013-08-23','11:55:00',5.17),('9650','2013-08-23','12:00:00',5.24),('9650','2013-08-23','12:05:00',5.34),('9650','2013-08-23','12:10:00',5.45),('9650','2013-08-23','12:15:00',5.45),('9650','2013-08-23','12:20:00',5.55),('9650','2013-08-23','12:25:00',5.56),('9650','2013-08-23','12:30:00',5.63),('9650','2013-08-23','12:35:00',5.7),('9650','2013-08-23','12:40:00',5.73),('9650','2013-08-23','12:45:00',5.76),('9650','2013-08-23','12:50:00',5.85),('9650','2013-08-23','12:55:00',5.84),('9650','2013-08-23','13:00:00',5.82),('9650','2013-08-23','13:05:00',5.97),('9650','2013-08-23','13:10:00',6.03),('9650','2013-08-23','13:15:00',6.06),('9650','2013-08-23','13:20:00',6.14),('9650','2013-08-23','13:25:00',6.15),('9650','2013-08-23','13:30:00',6.23),('9650','2013-08-23','13:35:00',6.27),('9650','2013-08-23','13:40:00',6.26),('9650','2013-08-23','13:45:00',6.33),('9650','2013-08-23','13:50:00',6.34),('9650','2013-08-23','13:55:00',6.36),('9650','2013-08-23','14:00:00',6.37),('9650','2013-08-23','14:05:00',6.38),('9650','2013-08-23','14:10:00',6.37),('9650','2013-08-23','14:15:00',6.39),('9650','2013-08-23','14:20:00',6.4),('9650','2013-08-23','14:25:00',6.39),('9650','2013-08-23','14:30:00',6.43),('9650','2013-08-23','14:35:00',6.4),('9650','2013-08-23','14:40:00',6.39),('9650','2013-08-23','14:45:00',6.37),('9650','2013-08-23','14:50:00',6.35),('9650','2013-08-23','14:55:00',6.33),('9650','2013-08-23','15:00:00',6.24),('9650','2013-08-23','15:05:00',6.23),('9650','2013-08-23','15:10:00',6.18),('9650','2013-08-23','15:15:00',6.18),('9650','2013-08-23','15:20:00',6.13),('9650','2013-08-23','15:25:00',6.13),('9650','2013-08-23','15:30:00',6.1),('9650','2013-08-23','15:35:00',6.09),('9650','2013-08-23','15:40:00',5.98),('9650','2013-08-23','15:45:00',5.91),('9650','2013-08-23','15:50:00',5.86),('9650','2013-08-23','15:55:00',5.79),('9650','2013-08-23','16:00:00',5.73),('9650','2013-08-23','16:05:00',5.69),('9650','2013-08-23','16:10:00',5.62),('9650','2013-08-23','16:15:00',5.57),('9650','2013-08-23','16:20:00',5.52),('9650','2013-08-23','16:25:00',5.46),('9650','2013-08-23','16:30:00',5.37),('9650','2013-08-23','16:35:00',5.24),('9650','2013-08-23','16:40:00',5.14),('9650','2013-08-23','16:45:00',5.02),('9650','2013-08-23','16:50:00',4.92),('9650','2013-08-23','16:55:00',4.8),('9650','2013-08-23','17:00:00',4.71),('9650','2013-08-23','17:05:00',4.61),('9650','2013-08-23','17:10:00',4.52),('9650','2013-08-23','17:15:00',4.4),('9650','2013-08-23','17:20:00',4.31),('9650','2013-08-23','17:25:00',4.22),('9650','2013-08-23','17:30:00',4.11),('9650','2013-08-23','17:35:00',3.99),('9650','2013-08-23','17:40:00',3.91),('9650','2013-08-23','17:45:00',3.79),('9650','2013-08-23','17:50:00',3.67),('9650','2013-08-23','17:55:00',3.51),('9650','2013-08-23','18:00:00',3.35),('9650','2013-08-23','18:05:00',3.21),('9650','2013-08-23','18:10:00',3.08),('9650','2013-08-23','18:15:00',2.94),('9650','2013-08-23','18:20:00',2.8),('9650','2013-08-23','18:25:00',2.64),('9650','2013-08-23','18:30:00',2.48),('9650','2013-08-23','18:35:00',2.3),('9650','2013-08-23','18:40:00',2.12),('9650','2013-08-23','18:45:00',1.92),('9650','2013-08-23','18:50:00',1.72),('9650','2013-08-23','18:55:00',1.51),('9650','2013-08-23','19:00:00',1.34),('9650','2013-08-23','19:05:00',1.15),('9650','2013-08-22','08:30:00',1.01),('9650','2013-08-22','08:35:00',1.04),('9650','2013-08-22','08:40:00',1.11),('9650','2013-08-22','08:45:00',1.22),('9650','2013-08-22','08:50:00',1.3),('9650','2013-08-22','08:55:00',1.41),('9650','2013-08-22','09:00:00',1.52),('9650','2013-08-22','09:05:00',1.64),('9650','2013-08-22','09:10:00',1.72),('9650','2013-08-22','09:15:00',1.82),('9650','2013-08-22','09:20:00',1.94),('9650','2013-08-22','09:25:00',2.03),('9650','2013-08-22','09:30:00',2.14),('9650','2013-08-22','09:35:00',2.27),('9650','2013-08-22','09:40:00',2.35),('9650','2013-08-22','09:45:00',2.46),('9650','2013-08-22','09:50:00',2.55),('9650','2013-08-22','09:55:00',2.66),('9650','2013-08-22','10:00:00',2.74),('9650','2013-08-22','10:05:00',2.87),('9650','2013-08-22','10:10:00',2.97),('9650','2013-08-22','10:15:00',3.08),('9650','2013-08-22','10:20:00',3.17),('9650','2013-08-22','10:25:00',3.3),('9650','2013-08-22','10:30:00',3.42),('9650','2013-08-22','10:35:00',3.51),('9650','2013-08-22','10:40:00',3.59),('9650','2013-08-22','10:45:00',3.62),('9650','2013-08-22','10:50:00',3.81),('9650','2013-08-22','10:55:00',3.96),('9650','2013-08-22','11:00:00',4.12),('9650','2013-08-22','11:05:00',4.13),('9650','2013-08-22','11:10:00',1.88),('9650','2013-08-22','11:15:00',1.66),('9650','2013-08-22','11:20:00',2.67),('9650','2013-08-22','11:25:00',2.68),('9650','2013-08-22','11:30:00',3.83),('9650','2013-08-22','11:35:00',5.01),('9650','2013-08-22','11:40:00',5.05),('9650','2013-08-22','11:45:00',4.68),('9650','2013-08-22','11:50:00',5.21),('9650','2013-08-22','11:55:00',3.79),('9650','2013-08-22','12:00:00',2.73),('9650','2013-08-22','12:05:00',3.31),('9650','2013-08-22','12:10:00',5.32),('9650','2013-08-22','12:15:00',2.61),('9650','2013-08-22','12:20:00',1.57),('9650','2013-08-22','12:25:00',1.65),('9650','2013-08-22','12:30:00',1.64),('9650','2013-08-22','12:35:00',3.01),('9650','2013-08-22','12:40:00',2.18),('9650','2013-08-22','12:45:00',2.15),('9650','2013-08-22','12:50:00',2.29),('9650','2013-08-22','12:55:00',1.65),('9650','2013-08-22','13:00:00',1.85),('9650','2013-08-22','13:05:00',3.13),('9650','2013-08-22','13:10:00',1.95),('9650','2013-08-22','13:15:00',4.31),('9650','2013-08-22','13:20:00',4.11),('9650','2013-08-22','13:25:00',6.87),('9650','2013-08-22','13:30:00',6.7),('9650','2013-08-22','13:35:00',4.14),('9650','2013-08-22','13:40:00',6.18),('9650','2013-08-22','13:45:00',4.85),('9650','2013-08-22','13:50:00',4.06),('9650','2013-08-22','13:55:00',6.88),('9650','2013-08-22','14:00:00',6.91),('9650','2013-08-22','14:05:00',6.68),('9650','2013-08-22','14:10:00',6.52),('9650','2013-08-22','14:15:00',6.42),('9650','2013-08-22','14:20:00',6.37),('9650','2013-08-22','14:25:00',6.03),('9650','2013-08-22','14:30:00',5.86),('9650','2013-08-22','14:35:00',6.12),('9650','2013-08-22','14:40:00',6.27),('9650','2013-08-22','14:45:00',6.19),('9650','2013-08-22','14:50:00',6.26),('9650','2013-08-22','14:55:00',5.88),('9650','2013-08-22','15:00:00',6.08),('9650','2013-08-22','15:05:00',5.72),('9650','2013-08-22','15:10:00',6.24),('9650','2013-08-22','15:15:00',6),('9650','2013-08-22','15:20:00',5.97),('9650','2013-08-22','15:25:00',6.18),('9650','2013-08-22','15:30:00',6.38),('9650','2013-08-22','15:35:00',5.89),('9650','2013-08-22','15:40:00',5.92),('9650','2013-08-22','15:45:00',5.99),('9650','2013-08-22','15:50:00',5.47),('9650','2013-08-22','15:55:00',5.82),('9650','2013-08-22','16:00:00',5.55),('9650','2013-08-22','16:05:00',5.3),('9650','2013-08-22','16:10:00',4.94),('9650','2013-08-22','16:15:00',5.28),('9650','2013-08-22','16:20:00',5.74),('9650','2013-08-22','16:25:00',5.62),('9650','2013-08-22','16:30:00',5.46),('9650','2013-08-22','16:35:00',5.46),('9650','2013-08-22','16:40:00',5.39),('9650','2013-08-22','16:45:00',5.25),('9650','2013-08-22','16:50:00',5.18),('9650','2013-08-22','16:55:00',5),('9650','2013-08-22','17:00:00',4.8),('9650','2013-08-22','17:05:00',4.64),('9650','2013-08-22','17:10:00',4.52),('9650','2013-08-22','17:15:00',4.38),('9650','2013-08-22','17:20:00',4.28),('9650','2013-08-22','17:25:00',4.16),('9650','2013-08-22','17:30:00',3.96),('9650','2013-08-22','17:35:00',3.9),('9650','2013-08-22','17:40:00',3.75),('9650','2013-08-22','17:45:00',3.68),('9650','2013-08-22','17:50:00',3.55),('9650','2013-08-22','17:55:00',3.46),('9650','2013-08-22','18:00:00',3.24),('9650','2013-08-22','18:05:00',3.07),('9650','2013-08-22','18:10:00',2.65),('9650','2013-08-22','18:15:00',2.47),('9650','2013-08-22','18:20:00',2.78),('9650','2013-08-22','18:25:00',2.72),('9650','2013-08-22','18:30:00',2.57),('9650','2013-08-22','18:35:00',2.36),('9650','2013-08-22','18:40:00',2.2),('9650','2013-08-22','18:45:00',2.02),('9650','2013-08-22','18:50:00',1.87),('9650','2013-08-22','18:55:00',1.67),('9650','2013-08-22','19:00:00',1.46),('9650','2013-08-22','19:05:00',1.25),('9650','2013-08-21','08:35:00',1.04),('9650','2013-08-21','08:40:00',1.09),('9650','2013-08-21','08:45:00',1.14),('9650','2013-08-21','08:50:00',1.18),('9650','2013-08-21','08:55:00',1.22),('9650','2013-08-21','09:00:00',1.25),('9650','2013-08-21','09:05:00',1.78),('9650','2013-08-21','09:10:00',1.98),('9650','2013-08-21','09:15:00',2.09),('9650','2013-08-21','09:20:00',2.27),('9650','2013-08-21','09:25:00',2.35),('9650','2013-08-21','09:30:00',2.46),('9650','2013-08-21','09:35:00',1.65),('9650','2013-08-21','09:40:00',1.63),('9650','2013-08-21','09:45:00',2.45),('9650','2013-08-21','09:50:00',2.77),('9650','2013-08-21','09:55:00',2.53),('9650','2013-08-21','10:00:00',3.21),('9650','2013-08-21','10:05:00',3.35),('9650','2013-08-21','10:10:00',3.39),('9650','2013-08-21','10:15:00',3.37),('9650','2013-08-21','10:20:00',3.39),('9650','2013-08-21','10:25:00',3.48),('9650','2013-08-21','10:30:00',3.62),('9650','2013-08-21','10:35:00',3.71),('9650','2013-08-21','10:40:00',3.8),('9650','2013-08-21','10:45:00',3.89),('9650','2013-08-21','10:50:00',3.98),('9650','2013-08-21','10:55:00',4.09),('9650','2013-08-21','11:00:00',4.19),('9650','2013-08-21','11:05:00',4.28),('9650','2013-08-21','11:10:00',4.36),('9650','2013-08-21','11:15:00',4.43),('9650','2013-08-21','11:20:00',4.51),('9650','2013-08-21','11:25:00',4.59),('9650','2013-08-21','11:30:00',4.71),('9650','2013-08-21','11:35:00',4.8),('9650','2013-08-21','11:40:00',4.87),('9650','2013-08-21','11:45:00',4.95),('9650','2013-08-21','11:50:00',5.02),('9650','2013-08-21','11:55:00',5.1),('9650','2013-08-21','12:00:00',5.16),('9650','2013-08-21','12:05:00',5.23),('9650','2013-08-21','12:10:00',5.29),('9650','2013-08-21','12:15:00',5.33),('9650','2013-08-21','12:20:00',5.42),('9650','2013-08-21','12:25:00',5.45),('9650','2013-08-21','12:30:00',5.51),('9650','2013-08-21','12:35:00',5.54),('9650','2013-08-21','12:40:00',5.6),('9650','2013-08-21','12:45:00',5.65),('9650','2013-08-21','12:50:00',5.68),('9650','2013-08-21','12:55:00',5.69),('9650','2013-08-21','13:00:00',5.75),('9650','2013-08-21','13:05:00',5.69),('9650','2013-08-21','13:10:00',5.68),('9650','2013-08-21','13:15:00',5.71),('9650','2013-08-21','13:20:00',5.79),('9650','2013-08-21','13:25:00',5.91),('9650','2013-08-21','13:30:00',5.93),('9650','2013-08-21','13:35:00',5.91),('9650','2013-08-21','13:40:00',5.92),('9650','2013-08-21','13:45:00',6.03),('9650','2013-08-21','13:50:00',6.04),('9650','2013-08-21','13:55:00',6.04),('9650','2013-08-21','14:00:00',6.04),('9650','2013-08-21','14:05:00',6.08),('9650','2013-08-21','14:10:00',6.1),('9650','2013-08-21','14:15:00',6.16),('9650','2013-08-21','14:20:00',6.26),('9650','2013-08-21','14:25:00',6.33),('9650','2013-08-21','14:30:00',5.06),('9650','2013-08-21','14:35:00',6.21),('9650','2013-08-21','14:40:00',6.23),('9650','2013-08-21','14:45:00',5.94),('9650','2013-08-21','14:50:00',6.14),('9650','2013-08-21','14:55:00',6.14),('9650','2013-08-21','15:00:00',6.05),('9650','2013-08-21','15:05:00',6.02),('9650','2013-08-21','15:10:00',6.05),('9650','2013-08-21','15:15:00',5.9),('9650','2013-08-21','15:20:00',5.95),('9650','2013-08-21','15:25:00',5.94),('9650','2013-08-21','15:30:00',5.9),('9650','2013-08-21','15:35:00',5.8),('9650','2013-08-21','15:40:00',5.85),('9650','2013-08-21','15:45:00',5.81),('9650','2013-08-21','15:50:00',5.75),('9650','2013-08-21','15:55:00',5.64),('9650','2013-08-21','16:00:00',5.51),('9650','2013-08-21','16:05:00',5.37),('9650','2013-08-21','16:10:00',5.34),('9650','2013-08-21','16:15:00',5.3),('9650','2013-08-21','16:20:00',5.22),('9650','2013-08-21','16:25:00',5.18),('9650','2013-08-21','16:30:00',5.11),('9650','2013-08-21','16:35:00',4.99),('9650','2013-08-21','16:40:00',4.92),('9650','2013-08-21','16:45:00',4.82),('9650','2013-08-21','16:50:00',4.73),('9650','2013-08-21','16:55:00',4.67),('9650','2013-08-21','17:00:00',4.53),('9650','2013-08-21','17:05:00',4.36),('9650','2013-08-21','17:10:00',4.25),('9650','2013-08-21','17:15:00',4.08),('9650','2013-08-21','17:20:00',4),('9650','2013-08-21','17:25:00',3.94),('9650','2013-08-21','17:30:00',3.82),('9650','2013-08-21','17:35:00',3.74),('9650','2013-08-21','17:40:00',3.61),('9650','2013-08-21','17:45:00',3.47),('9650','2013-08-21','17:50:00',3.28),('9650','2013-08-21','17:55:00',3.19),('9650','2013-08-21','18:00:00',3.11),('9650','2013-08-21','18:05:00',2.93),('9650','2013-08-21','18:10:00',2.85),('9650','2013-08-21','18:15:00',2.83),('9650','2013-08-21','18:20:00',2.35),('9650','2013-08-21','18:25:00',1.82),('9650','2013-08-21','18:30:00',1.73),('9650','2013-08-21','18:35:00',1.56),('9650','2013-08-21','18:40:00',1.7),('9650','2013-08-21','18:45:00',1.6),('9650','2013-08-21','18:50:00',1.26),('9650','2013-08-21','18:55:00',1.14),('9650','2013-08-21','19:00:00',1.17),('9650','2013-08-21','19:05:00',1),('9650','2013-08-20','08:20:00',1.04),('9650','2013-08-20','08:25:00',1.18),('9650','2013-08-20','08:30:00',1.27),('9650','2013-08-20','08:35:00',1.41),('9650','2013-08-20','08:40:00',1.41),('9650','2013-08-20','08:45:00',1.38),('9650','2013-08-20','08:50:00',1.28),('9650','2013-08-20','08:55:00',1.28),('9650','2013-08-20','09:00:00',1.43),('9650','2013-08-20','09:05:00',2.03),('9650','2013-08-20','09:10:00',2.07),('9650','2013-08-20','09:15:00',2.79),('9650','2013-08-20','09:20:00',2.86),('9650','2013-08-20','09:25:00',1.8),('9650','2013-08-20','09:30:00',1.26),('9650','2013-08-20','09:35:00',1.36),('9650','2013-08-20','09:40:00',1.61),('9650','2013-08-20','09:45:00',1.85),('9650','2013-08-20','09:50:00',3.19),('9650','2013-08-20','09:55:00',4.49),('9650','2013-08-20','10:00:00',4.22),('9650','2013-08-20','10:05:00',3.35),('9650','2013-08-20','10:10:00',2.93),('9650','2013-08-20','10:15:00',2.8),('9650','2013-08-20','10:20:00',2.64),('9650','2013-08-20','10:25:00',2.17),('9650','2013-08-20','10:30:00',3.01),('9650','2013-08-20','10:35:00',3.82),('9650','2013-08-20','10:40:00',2.85),('9650','2013-08-20','10:45:00',2.72),('9650','2013-08-20','10:50:00',2.69),('9650','2013-08-20','10:55:00',2.39),('9650','2013-08-20','11:00:00',3.34),('9650','2013-08-20','11:05:00',2.67),('9650','2013-08-20','11:10:00',2.52),('9650','2013-08-20','11:15:00',3.15),('9650','2013-08-20','11:20:00',4.11),('9650','2013-08-20','11:25:00',3.58),('9650','2013-08-20','11:30:00',4.27),('9650','2013-08-20','11:35:00',5.86),('9650','2013-08-20','11:40:00',5.64),('9650','2013-08-20','11:45:00',5.58),('9650','2013-08-20','11:50:00',4.93),('9650','2013-08-20','11:55:00',5.19),('9650','2013-08-20','12:00:00',5.63),('9650','2013-08-20','12:05:00',5.65),('9650','2013-08-20','12:10:00',5.68),('9650','2013-08-20','12:15:00',5.78),('9650','2013-08-20','12:20:00',5.56),('9650','2013-08-20','12:25:00',3.95),('9650','2013-08-20','12:30:00',3.75),('9650','2013-08-20','12:35:00',3.14),('9650','2013-08-20','12:40:00',5.28),('9650','2013-08-20','12:45:00',5.99),('9650','2013-08-20','12:50:00',5.71),('9650','2013-08-20','12:55:00',5.6),('9650','2013-08-20','13:00:00',5.91),('9650','2013-08-20','13:05:00',5.97),('9650','2013-08-20','13:10:00',6.08),('9650','2013-08-20','13:15:00',6.22),('9650','2013-08-20','13:20:00',6.25),('9650','2013-08-20','13:25:00',6.33),('9650','2013-08-20','13:30:00',6.24),('9650','2013-08-20','13:35:00',6.26),('9650','2013-08-20','13:40:00',5.94),('9650','2013-08-20','13:45:00',6.26),('9650','2013-08-20','13:50:00',5.88),('9650','2013-08-20','13:55:00',5.96),('9650','2013-08-20','14:00:00',5.65),('9650','2013-08-20','14:05:00',6.07),('9650','2013-08-20','14:10:00',6.3),('9650','2013-08-20','14:15:00',5.26),('9650','2013-08-20','14:20:00',2.68),('9650','2013-08-20','14:25:00',3.78),('9650','2013-08-20','14:30:00',5.67),('9650','2013-08-20','14:35:00',5.87),('9650','2013-08-20','14:40:00',5.95),('9650','2013-08-20','14:45:00',5.92),('9650','2013-08-20','14:50:00',5.69),('9650','2013-08-20','14:55:00',5.82),('9650','2013-08-20','15:00:00',6.05),('9650','2013-08-20','15:05:00',6.02),('9650','2013-08-20','15:10:00',5.84),('9650','2013-08-20','15:15:00',5.8),('9650','2013-08-20','15:20:00',5.73),('9650','2013-08-20','15:25:00',5.55),('9650','2013-08-20','15:30:00',5.46),('9650','2013-08-20','15:35:00',5.22),('9650','2013-08-20','15:40:00',4.98),('9650','2013-08-20','15:45:00',5.07),('9650','2013-08-20','15:50:00',5.17),('9650','2013-08-20','15:55:00',5.11),('9650','2013-08-20','16:00:00',4.84),('9650','2013-08-20','16:05:00',4.58),('9650','2013-08-20','16:10:00',4.46),('9650','2013-08-20','16:15:00',4.6),('9650','2013-08-20','16:20:00',4.99),('9650','2013-08-20','16:25:00',4.92),('9650','2013-08-20','16:30:00',5.33),('9650','2013-08-20','16:35:00',5.28),('9650','2013-08-20','16:40:00',5.11),('9650','2013-08-20','16:45:00',5.02),('9650','2013-08-20','16:50:00',4.9),('9650','2013-08-20','16:55:00',4.8),('9650','2013-08-20','17:00:00',4.77),('9650','2013-08-20','17:05:00',4.73),('9650','2013-08-20','17:10:00',4.62),('9650','2013-08-20','17:15:00',4.56),('9650','2013-08-20','17:20:00',4.56),('9650','2013-08-20','17:25:00',4.45),('9650','2013-08-20','17:30:00',4.29),('9650','2013-08-20','17:35:00',4.23),('9650','2013-08-20','17:40:00',4.13),('9650','2013-08-20','17:45:00',4.02),('9650','2013-08-20','17:50:00',4.01),('9650','2013-08-20','17:55:00',3.89),('9650','2013-08-20','18:00:00',3.75),('9650','2013-08-20','18:05:00',3.58),('9650','2013-08-20','18:10:00',3.32),('9650','2013-08-20','18:15:00',3.14),('9650','2013-08-20','18:20:00',2.93),('9650','2013-08-20','18:25:00',2.76),('9650','2013-08-20','18:30:00',2.45),('9650','2013-08-20','18:35:00',1.99),('9650','2013-08-20','18:40:00',1.81),('9650','2013-08-20','18:45:00',1.85),('9650','2013-08-20','18:50:00',1.57),('9650','2013-08-20','18:55:00',1.52),('9650','2013-08-20','19:00:00',1.32),('9650','2013-08-20','19:05:00',1.14),('9650','2013-08-19','07:40:00',1),('9650','2013-08-19','07:45:00',1.01),('9650','2013-08-19','07:50:00',1.06),('9650','2013-08-19','07:55:00',1.12),('9650','2013-08-19','08:00:00',1.07),('9650','2013-08-19','08:05:00',1.02),('9650','2013-08-19','08:10:00',1.04),('9650','2013-08-19','08:15:00',1.08),('9650','2013-08-19','08:20:00',1.15),('9650','2013-08-19','08:25:00',1.15),('9650','2013-08-19','08:30:00',1.12),('9650','2013-08-19','08:35:00',1.12),('9650','2013-08-19','08:40:00',1.15),('9650','2013-08-19','08:45:00',1.29),('9650','2013-08-19','08:50:00',1.43),('9650','2013-08-19','08:55:00',1.57),('9650','2013-08-19','09:00:00',1.51),('9650','2013-08-19','09:05:00',1.37),('9650','2013-08-19','09:10:00',1.15),('9650','2013-08-19','09:15:00',1.22),('9650','2013-08-19','09:20:00',1.42),('9650','2013-08-19','09:25:00',2.09),('9650','2013-08-19','09:30:00',2.9),('9650','2013-08-19','09:35:00',3.41),('9650','2013-08-19','09:40:00',3.88),('9650','2013-08-19','09:45:00',3.15),('9650','2013-08-19','09:50:00',3.16),('9650','2013-08-19','09:55:00',4.25),('9650','2013-08-19','10:00:00',3.94),('9650','2013-08-19','10:05:00',1.93),('9650','2013-08-19','10:10:00',2.58),('9650','2013-08-19','10:15:00',3.63),('9650','2013-08-19','10:20:00',2.92),('9650','2013-08-19','10:25:00',1.65),('9650','2013-08-19','10:30:00',1.82),('9650','2013-08-19','10:35:00',1.84),('9650','2013-08-19','10:40:00',2.1),('9650','2013-08-19','10:45:00',4.01),('9650','2013-08-19','10:50:00',4),('9650','2013-08-19','10:55:00',2.9),('9650','2013-08-19','11:00:00',1.64),('9650','2013-08-19','11:05:00',1.37),('9650','2013-08-19','11:10:00',2.59),('9650','2013-08-19','11:15:00',5.22),('9650','2013-08-19','11:20:00',5.42),('9650','2013-08-19','11:25:00',4.35),('9650','2013-08-19','11:30:00',2.58),('9650','2013-08-19','11:35:00',5.54),('9650','2013-08-19','11:40:00',5.89),('9650','2013-08-19','11:45:00',5.99),('9650','2013-08-19','11:50:00',6.84),('9650','2013-08-19','11:55:00',5.43),('9650','2013-08-19','12:00:00',2.92),('9650','2013-08-19','12:05:00',2.88),('9650','2013-08-19','12:10:00',2.13),('9650','2013-08-19','12:15:00',1.31),('9650','2013-08-19','12:20:00',1.39),('9650','2013-08-19','12:25:00',1.92),('9650','2013-08-19','12:30:00',2.58),('9650','2013-08-19','12:35:00',2.96),('9650','2013-08-19','12:40:00',3.16),('9650','2013-08-19','12:45:00',3.13),('9650','2013-08-19','12:50:00',3.14),('9650','2013-08-19','12:55:00',3.28),('9650','2013-08-19','13:00:00',3.27),('9650','2013-08-19','13:05:00',2.95),('9650','2013-08-19','13:10:00',2.85),('9650','2013-08-19','13:15:00',2.86),('9650','2013-08-19','13:20:00',2.97),('9650','2013-08-19','13:25:00',3.1),('9650','2013-08-19','13:30:00',3.45),('9650','2013-08-19','13:35:00',4.62),('9650','2013-08-19','13:40:00',6.94),('9650','2013-08-19','13:45:00',5.76),('9650','2013-08-19','13:50:00',6.92),('9650','2013-08-19','13:55:00',6.75),('9650','2013-08-19','14:00:00',6.73),('9650','2013-08-19','14:05:00',6.7),('9650','2013-08-19','14:10:00',5.91),('9650','2013-08-19','14:15:00',6.58),('9650','2013-08-19','14:20:00',6.67),('9650','2013-08-19','14:25:00',5.67),('9650','2013-08-19','14:30:00',6.04),('9650','2013-08-19','14:35:00',7.21),('9650','2013-08-19','14:40:00',7.1),('9650','2013-08-19','14:45:00',6.67),('9650','2013-08-19','14:50:00',6.64),('9650','2013-08-19','14:55:00',6.74),('9650','2013-08-19','15:00:00',6.35),('9650','2013-08-19','15:05:00',7.07),('9650','2013-08-19','15:10:00',6.92),('9650','2013-08-19','15:15:00',6.93),('9650','2013-08-19','15:20:00',6.78),('9650','2013-08-19','15:25:00',6.77),('9650','2013-08-19','15:30:00',6.82),('9650','2013-08-19','15:35:00',6.81),('9650','2013-08-19','15:40:00',7.01),('9650','2013-08-19','15:45:00',7.21),('9650','2013-08-19','15:50:00',7.32),('9650','2013-08-19','15:55:00',7.47),('9650','2013-08-19','16:00:00',7.24),('9650','2013-08-19','16:05:00',7.16),('9650','2013-08-19','16:10:00',7.11),('9650','2013-08-19','16:15:00',7.12),('9650','2013-08-19','16:20:00',7.07),('9650','2013-08-19','16:25:00',6.92),('9650','2013-08-19','16:30:00',6.44),('9650','2013-08-19','16:35:00',6.45),('9650','2013-08-19','16:40:00',6.53),('9650','2013-08-19','16:45:00',6.32),('9650','2013-08-19','16:50:00',6.09),('9650','2013-08-19','16:55:00',5.75),('9650','2013-08-19','17:00:00',5.43),('9650','2013-08-19','17:05:00',5.26),('9650','2013-08-19','17:10:00',5.13),('9650','2013-08-19','17:15:00',4.9),('9650','2013-08-19','17:20:00',4.81),('9650','2013-08-19','17:25:00',4.68),('9650','2013-08-19','17:30:00',4.61),('9650','2013-08-19','17:35:00',4.56),('9650','2013-08-19','17:40:00',4.46),('9650','2013-08-19','17:45:00',4.31),('9650','2013-08-19','17:50:00',3.93),('9650','2013-08-19','17:55:00',3.74),('9650','2013-08-19','18:00:00',3.47),('9650','2013-08-19','18:05:00',3.51),('9650','2013-08-19','18:10:00',3.55),('9650','2013-08-19','18:15:00',3.51),('9650','2013-08-19','18:20:00',3.5),('9650','2013-08-19','18:25:00',3.38),('9650','2013-08-19','18:30:00',3.38),('9650','2013-08-19','18:35:00',3.11),('9650','2013-08-19','18:40:00',2.54),('9650','2013-08-19','18:45:00',2.69),('9650','2013-08-19','18:50:00',2.18),('9650','2013-08-19','18:55:00',2.53),('9650','2013-08-19','19:00:00',2.44),('9650','2013-08-19','19:05:00',2.05),('9650','2013-08-19','19:20:00',1.23),('9650','2014-04-09','09:00:00',1.11),('9650','2014-04-09','09:05:00',1.22),('9650','2014-04-09','09:10:00',1.3),('9650','2014-04-09','09:15:00',1.34),('9650','2014-04-09','09:20:00',1.47),('9650','2014-04-09','09:25:00',1.82),('9650','2014-04-09','09:30:00',2),('9650','2014-04-09','09:35:00',2.16),('9650','2014-04-09','09:40:00',2.3),('9650','2014-04-09','09:45:00',2.43),('9650','2014-04-09','09:50:00',2.59),('9650','2014-04-09','09:55:00',2.76),('9650','2014-04-09','10:00:00',2.9),('9650','2014-04-09','10:05:00',3.02),('9650','2014-04-09','10:10:00',3.2),('9650','2014-04-09','10:15:00',3.28),('9650','2014-04-09','10:20:00',3.44),('9650','2014-04-09','10:25:00',3.56),('9650','2014-04-09','10:30:00',3.67),('9650','2014-04-09','10:35:00',3.87),('9650','2014-04-09','10:40:00',4.02),('9650','2014-04-09','10:45:00',4.11),('9650','2014-04-09','10:50:00',4.13),('9650','2014-04-09','10:55:00',4.29),('9650','2014-04-09','11:00:00',4.37),('9650','2014-04-09','11:05:00',4.58),('9650','2014-04-09','11:10:00',4.52),('9650','2014-04-09','11:15:00',4.73),('9650','2014-04-09','11:20:00',4.92),('9650','2014-04-09','11:25:00',5.09),('9650','2014-04-09','11:30:00',5.18),('9650','2014-04-09','11:35:00',5.34),('9650','2014-04-09','11:40:00',5.2),('9650','2014-04-09','11:45:00',5.41),('9650','2014-04-09','11:50:00',5.28),('9650','2014-04-09','11:55:00',5.64),('9650','2014-04-09','12:00:00',5.6),('9650','2014-04-09','12:05:00',5.3),('9650','2014-04-09','12:10:00',5.57),('9650','2014-04-09','12:15:00',5.69),('9650','2014-04-09','12:20:00',5.81),('9650','2014-04-09','12:25:00',5.58),('9650','2014-04-09','12:30:00',5.77),('9650','2014-04-09','12:35:00',6.22),('9650','2014-04-09','12:40:00',5.92),('9650','2014-04-09','12:45:00',6.18),('9650','2014-04-09','12:50:00',6.04),('9650','2014-04-09','12:55:00',6.01),('9650','2014-04-09','13:00:00',6.08),('9650','2014-04-09','13:05:00',5.88),('9650','2014-04-09','13:10:00',6.11),('9650','2014-04-09','13:15:00',6.2),('9650','2014-04-09','13:20:00',5.88),('9650','2014-04-09','13:25:00',6.43),('9650','2014-04-09','13:30:00',6.46),('9650','2014-04-09','13:35:00',6.69),('9650','2014-04-09','13:40:00',6.46),('9650','2014-04-09','13:45:00',6.62),('9650','2014-04-09','13:50:00',6.75),('9650','2014-04-09','13:55:00',6.75),('9650','2014-04-09','14:00:00',6.76),('9650','2014-04-09','14:05:00',6.69),('9650','2014-04-09','14:10:00',6.72),('9650','2014-04-09','14:15:00',6.72),('9650','2014-04-09','14:20:00',6.82),('9650','2014-04-09','14:25:00',6.8),('9650','2014-04-09','14:30:00',6.74),('9650','2014-04-09','14:35:00',6.74),('9650','2014-04-09','14:40:00',6.7),('9650','2014-04-09','14:45:00',6.09),('9650','2014-04-09','14:50:00',6.8),('9650','2014-04-09','14:55:00',6.78),('9650','2014-04-09','15:00:00',6.79),('9650','2014-04-09','15:05:00',6.7),('9650','2014-04-09','15:10:00',6.56),('9650','2014-04-09','15:15:00',6.64),('9650','2014-04-09','15:20:00',6.55),('9650','2014-04-09','15:25:00',6.45),('9650','2014-04-09','15:30:00',5.93),('9650','2014-04-09','15:35:00',5.77),('9650','2014-04-09','15:40:00',5.92),('9650','2014-04-09','15:45:00',5.96),('9650','2014-04-09','15:50:00',6),('9650','2014-04-09','15:55:00',5.96),('9650','2014-04-09','16:00:00',5.76),('9650','2014-04-09','16:05:00',5.83),('9650','2014-04-09','16:10:00',5.88),('9650','2014-04-09','16:15:00',6.04),('9650','2014-04-09','16:20:00',5.79),('9650','2014-04-09','16:25:00',5.87),('9650','2014-04-09','16:30:00',5.85),('9650','2014-04-09','16:35:00',5.69),('9650','2014-04-09','16:40:00',5.66),('9650','2014-04-09','16:45:00',5.6),('9650','2014-04-09','16:50:00',5.26),('9650','2014-04-09','16:55:00',5.07),('9650','2014-04-09','17:00:00',4.98),('9650','2014-04-09','17:05:00',4.91),('9650','2014-04-09','17:10:00',4.67),('9650','2014-04-09','17:15:00',4.47),('9650','2014-04-09','17:20:00',4.49),('9650','2014-04-09','17:25:00',4.33),('9650','2014-04-09','17:30:00',4.26),('9650','2014-04-09','17:35:00',4.14),('9650','2014-04-09','17:40:00',3.96),('9650','2014-04-09','17:45:00',3.92),('9650','2014-04-09','17:50:00',3.8),('9650','2014-04-09','17:55:00',3.65),('9650','2014-04-09','18:00:00',3.47),('9650','2014-04-09','18:05:00',3.31),('9650','2014-04-09','18:10:00',3.18),('9650','2014-04-09','18:15:00',3),('9650','2014-04-09','18:20:00',2.87),('9650','2014-04-09','18:25:00',2.7),('9650','2014-04-09','18:30:00',2.54),('9650','2014-04-09','18:35:00',2.24),('9650','2014-04-09','18:40:00',2.05),('9650','2014-04-09','18:45:00',1.78),('9650','2014-04-09','18:50:00',1.22),('9650','2013-08-18','08:40:00',1.07),('9650','2013-08-18','08:45:00',1.17),('9650','2013-08-18','08:50:00',1.29),('9650','2013-08-18','08:55:00',1.42),('9650','2013-08-18','09:00:00',1.54),('9650','2013-08-18','09:05:00',1.67),('9650','2013-08-18','09:10:00',1.77),('9650','2013-08-18','09:15:00',1.87),('9650','2013-08-18','09:20:00',2),('9650','2013-08-18','09:25:00',2.15),('9650','2013-08-18','09:30:00',2.26),('9650','2013-08-18','09:35:00',2.39),('9650','2013-08-18','09:40:00',2.53),('9650','2013-08-18','09:45:00',2.65),('9650','2013-08-18','09:50:00',2.77),('9650','2013-08-18','09:55:00',2.9),('9650','2013-08-18','10:00:00',3.02),('9650','2013-08-18','10:05:00',3.15),('9650','2013-08-18','10:10:00',3.27),('9650','2013-08-18','10:15:00',3.37),('9650','2013-08-18','10:20:00',3.47),('9650','2013-08-18','10:25:00',3.59),('9650','2013-08-18','10:30:00',3.7),('9650','2013-08-18','10:35:00',3.81),('9650','2013-08-18','10:40:00',3.91),('9650','2013-08-18','10:45:00',4.03),('9650','2013-08-18','10:50:00',4.11),('9650','2013-08-18','10:55:00',4.2),('9650','2013-08-18','11:00:00',4.26),('9650','2013-08-18','11:05:00',4.39),('9650','2013-08-18','11:10:00',4.52),('9650','2013-08-18','11:15:00',4.6),('9650','2013-08-18','11:20:00',4.72),('9650','2013-08-18','11:25:00',4.76),('9650','2013-08-18','11:30:00',4.84),('9650','2013-08-18','11:35:00',4.95),('9650','2013-08-18','11:40:00',5),('9650','2013-08-18','11:45:00',5.06),('9650','2013-08-18','11:50:00',5.03),('9650','2013-08-18','11:55:00',5.07),('9650','2013-08-18','12:00:00',5.12),('9650','2013-08-18','12:05:00',5.31),('9650','2013-08-18','12:10:00',5.36),('9650','2013-08-18','12:15:00',5.48),('9650','2013-08-18','12:20:00',5.53),('9650','2013-08-18','12:25:00',5.6),('9650','2013-08-18','12:30:00',5.65),('9650','2013-08-18','12:35:00',5.72),('9650','2013-08-18','12:40:00',5.74),('9650','2013-08-18','12:45:00',5.83),('9650','2013-08-18','12:50:00',5.88),('9650','2013-08-18','12:55:00',6.03),('9650','2013-08-18','13:00:00',6.05),('9650','2013-08-18','13:05:00',6.12),('9650','2013-08-18','13:10:00',6.15),('9650','2013-08-18','13:15:00',6.2),('9650','2013-08-18','13:20:00',6.25),('9650','2013-08-18','13:25:00',6.24),('9650','2013-08-18','13:30:00',6.26),('9650','2013-08-18','13:35:00',6.31),('9650','2013-08-18','13:40:00',6.33),('9650','2013-08-18','13:45:00',6.36),('9650','2013-08-18','13:50:00',6.41),('9650','2013-08-18','13:55:00',6.45),('9650','2013-08-18','14:00:00',6.42),('9650','2013-08-18','14:05:00',6.44),('9650','2013-08-18','14:10:00',6.5),('9650','2013-08-18','14:15:00',6.48),('9650','2013-08-18','14:20:00',6.49),('9650','2013-08-18','14:25:00',6.46),('9650','2013-08-18','14:30:00',6.5),('9650','2013-08-18','14:35:00',6.51),('9650','2013-08-18','14:40:00',6.49),('9650','2013-08-18','14:45:00',6.53),('9650','2013-08-18','14:50:00',6.51),('9650','2013-08-18','14:55:00',6.49),('9650','2013-08-18','15:00:00',6.49),('9650','2013-08-18','15:05:00',6.48),('9650','2013-08-18','15:10:00',6.45),('9650','2013-08-18','15:15:00',6.42),('9650','2013-08-18','15:20:00',6.45),('9650','2013-08-18','15:25:00',6.35),('9650','2013-08-18','15:30:00',6.31),('9650','2013-08-18','15:35:00',6.34),('9650','2013-08-18','15:40:00',6.28),('9650','2013-08-18','15:45:00',6.22),('9650','2013-08-18','15:50:00',6.15),('9650','2013-08-18','15:55:00',6.07),('9650','2013-08-18','16:00:00',6.02),('9650','2013-08-18','16:05:00',6),('9650','2013-08-18','16:10:00',5.93),('9650','2013-08-18','16:15:00',5.89),('9650','2013-08-18','16:20:00',5.71),('9650','2013-08-18','16:25:00',5.68),('9650','2013-08-18','16:30:00',5.61),('9650','2013-08-18','16:35:00',5.56),('9650','2013-08-18','16:40:00',5.46),('9650','2013-08-18','16:45:00',5.41),('9650','2013-08-18','16:50:00',5.28),('9650','2013-08-18','16:55:00',5.21),('9650','2013-08-18','17:00:00',5.11),('9650','2013-08-18','17:05:00',5.02),('9650','2013-08-18','17:10:00',4.9),('9650','2013-08-18','17:15:00',4.81),('9650','2013-08-18','17:20:00',4.7),('9650','2013-08-18','17:25:00',4.6),('9650','2013-08-18','17:30:00',4.5),('9650','2013-08-18','17:35:00',4.42),('9650','2013-08-18','17:40:00',4.32),('9650','2013-08-18','17:45:00',4.2),('9650','2013-08-18','17:50:00',4.06),('9650','2013-08-18','17:55:00',3.91),('9650','2013-08-18','18:00:00',3.78),('9650','2013-08-18','18:05:00',3.65),('9650','2013-08-18','18:10:00',3.48),('9650','2013-08-18','18:15:00',3.35),('9650','2013-08-18','18:20:00',3.22),('9650','2013-08-18','18:25:00',3.05),('9650','2013-08-18','18:30:00',2.87),('9650','2013-08-18','18:35:00',2.72),('9650','2013-08-18','18:40:00',2.59),('9650','2013-08-18','18:45:00',2.39),('9650','2013-08-18','18:50:00',2.22),('9650','2013-08-18','18:55:00',1.98),('9650','2013-08-18','19:00:00',1.78),('9650','2013-08-18','19:05:00',1.6),('9650','2013-08-18','19:10:00',1.43),('9650','2013-08-18','19:15:00',1.23),('9650','2013-08-18','19:20:00',1.01),('9650','2013-08-17','08:40:00',1.05),('9650','2013-08-17','08:45:00',1.11),('9650','2013-08-17','08:50:00',1.15),('9650','2013-08-17','08:55:00',1.19),('9650','2013-08-17','09:00:00',1.23),('9650','2013-08-17','09:05:00',1.37),('9650','2013-08-17','09:10:00',1.81),('9650','2013-08-17','09:15:00',1.94),('9650','2013-08-17','09:20:00',2.08),('9650','2013-08-17','09:25:00',2.23),('9650','2013-08-17','09:30:00',2.36),('9650','2013-08-17','09:35:00',2.51),('9650','2013-08-17','09:40:00',2.65),('9650','2013-08-17','09:45:00',2.47),('9650','2013-08-17','09:50:00',2.77),('9650','2013-08-17','09:55:00',2.29),('9650','2013-08-17','10:00:00',3.02),('9650','2013-08-17','10:05:00',2.58),('9650','2013-08-17','10:10:00',3.16),('9650','2013-08-17','10:15:00',3.43),('9650','2013-08-17','10:20:00',3.54),('9650','2013-08-17','10:25:00',3.66),('9650','2013-08-17','10:30:00',3.76),('9650','2013-08-17','10:35:00',3.87),('9650','2013-08-17','10:40:00',3.96),('9650','2013-08-17','10:45:00',4.01),('9650','2013-08-17','10:50:00',4.12),('9650','2013-08-17','10:55:00',4.13),('9650','2013-08-17','11:00:00',4.28),('9650','2013-08-17','11:05:00',4.48),('9650','2013-08-17','11:10:00',4.54),('9650','2013-08-17','11:15:00',4.62),('9650','2013-08-17','11:20:00',4.68),('9650','2013-08-17','11:25:00',4.72),('9650','2013-08-17','11:30:00',4.84),('9650','2013-08-17','11:35:00',4.94),('9650','2013-08-17','11:40:00',5.04),('9650','2013-08-17','11:45:00',5.13),('9650','2013-08-17','11:50:00',5.18),('9650','2013-08-17','11:55:00',5.19),('9650','2013-08-17','12:00:00',5.36),('9650','2013-08-17','12:05:00',5.47),('9650','2013-08-17','12:10:00',5.42),('9650','2013-08-17','12:15:00',5.64),('9650','2013-08-17','12:20:00',5.77),('9650','2013-08-17','12:25:00',5.89),('9650','2013-08-17','12:30:00',3.44),('9650','2013-08-17','12:35:00',1.48),('9650','2013-08-17','12:40:00',1.41),('9650','2013-08-17','12:45:00',4.33),('9650','2013-08-17','12:50:00',3.59),('9650','2013-08-17','12:55:00',1.69),('9650','2013-08-17','13:00:00',3.63),('9650','2013-08-17','13:05:00',6.63),('9650','2013-08-17','13:10:00',6.43),('9650','2013-08-17','13:15:00',5.98),('9650','2013-08-17','13:20:00',6.41),('9650','2013-08-17','13:25:00',6.12),('9650','2013-08-17','13:30:00',6.27),('9650','2013-08-17','13:35:00',6.28),('9650','2013-08-17','13:40:00',6.36),('9650','2013-08-17','13:45:00',6.38),('9650','2013-08-17','13:50:00',6.32),('9650','2013-08-17','13:55:00',6.25),('9650','2013-08-17','14:00:00',6.5),('9650','2013-08-17','14:05:00',6.39),('9650','2013-08-17','14:10:00',6.42),('9650','2013-08-17','14:15:00',6.44),('9650','2013-08-17','14:20:00',6.46),('9650','2013-08-17','14:25:00',6.47),('9650','2013-08-17','14:30:00',6.52),('9650','2013-08-17','14:35:00',6.58),('9650','2013-08-17','14:40:00',6.56),('9650','2013-08-17','14:45:00',6.55),('9650','2013-08-17','14:50:00',6.54),('9650','2013-08-17','14:55:00',6.51),('9650','2013-08-17','15:00:00',6.55),('9650','2013-08-17','15:05:00',6.56),('9650','2013-08-17','15:10:00',6.5),('9650','2013-08-17','15:15:00',6.47),('9650','2013-08-17','15:20:00',6.42),('9650','2013-08-17','15:25:00',6.4),('9650','2013-08-17','15:30:00',6.36),('9650','2013-08-17','15:35:00',6.32),('9650','2013-08-17','15:40:00',6.31),('9650','2013-08-17','15:45:00',6.28),('9650','2013-08-17','15:50:00',6.18),('9650','2013-08-17','15:55:00',6.02),('9650','2013-08-17','16:00:00',5.98),('9650','2013-08-17','16:05:00',5.94),('9650','2013-08-17','16:10:00',5.9),('9650','2013-08-17','16:15:00',5.83),('9650','2013-08-17','16:20:00',5.74),('9650','2013-08-17','16:25:00',5.69),('9650','2013-08-17','16:30:00',5.63),('9650','2013-08-17','16:35:00',5.54),('9650','2013-08-17','16:40:00',5.48),('9650','2013-08-17','16:45:00',5.4),('9650','2013-08-17','16:50:00',5.32),('9650','2013-08-17','16:55:00',5.22),('9650','2013-08-17','17:00:00',5.14),('9650','2013-08-17','17:05:00',5.04),('9650','2013-08-17','17:10:00',4.96),('9650','2013-08-17','17:15:00',4.86),('9650','2013-08-17','17:20:00',4.78),('9650','2013-08-17','17:25:00',4.65),('9650','2013-08-17','17:30:00',4.56),('9650','2013-08-17','17:35:00',4.45),('9650','2013-08-17','17:40:00',4.34),('9650','2013-08-17','17:45:00',4.21),('9650','2013-08-17','17:50:00',4.08),('9650','2013-08-17','17:55:00',3.94),('9650','2013-08-17','18:00:00',3.79),('9650','2013-08-17','18:05:00',3.68),('9650','2013-08-17','18:10:00',3.54),('9650','2013-08-17','18:15:00',3.41),('9650','2013-08-17','18:20:00',3.25),('9650','2013-08-17','18:25:00',3.1),('9650','2013-08-17','18:30:00',2.93),('9650','2013-08-17','18:35:00',2.78),('9650','2013-08-17','18:40:00',2.61),('9650','2013-08-17','18:45:00',2.43),('9650','2013-08-17','18:50:00',2.28),('9650','2013-08-17','18:55:00',2.07),('9650','2013-08-17','19:00:00',1.87),('9650','2013-08-17','19:05:00',1.67),('9650','2013-08-17','19:10:00',1.47),('9650','2013-08-17','19:15:00',1.26),('9650','2013-08-17','19:20:00',1.04),('9650','2013-08-16','08:40:00',1.02),('9650','2013-08-16','08:45:00',1.16),('9650','2013-08-16','08:50:00',1.27),('9650','2013-08-16','08:55:00',1.4),('9650','2013-08-16','09:00:00',1.53),('9650','2013-08-16','09:05:00',1.66),('9650','2013-08-16','09:10:00',1.77),('9650','2013-08-16','09:15:00',1.89),('9650','2013-08-16','09:20:00',2.02),('9650','2013-08-16','09:25:00',2.18),('9650','2013-08-16','09:30:00',2.31),('9650','2013-08-16','09:35:00',2.44),('9650','2013-08-16','09:40:00',2.58),('9650','2013-08-16','09:45:00',2.69),('9650','2013-08-16','09:50:00',2.81),('9650','2013-08-16','09:55:00',2.93),('9650','2013-08-16','10:00:00',3.05),('9650','2013-08-16','10:05:00',3.19),('9650','2013-08-16','10:10:00',3.3),('9650','2013-08-16','10:15:00',3.41),('9650','2013-08-16','10:20:00',3.52),('9650','2013-08-16','10:25:00',3.65),('9650','2013-08-16','10:30:00',3.78),('9650','2013-08-16','10:35:00',3.87),('9650','2013-08-16','10:40:00',3.97),('9650','2013-08-16','10:45:00',4.08),('9650','2013-08-16','10:50:00',4.2),('9650','2013-08-16','10:55:00',4.29),('9650','2013-08-16','11:00:00',4.38),('9650','2013-08-16','11:05:00',4.44),('9650','2013-08-16','11:10:00',4.57),('9650','2013-08-16','11:15:00',4.64),('9650','2013-08-16','11:20:00',4.76),('9650','2013-08-16','11:25:00',4.84),('9650','2013-08-16','11:30:00',4.94),('9650','2013-08-16','11:35:00',4.98),('9650','2013-08-16','11:40:00',5.08),('9650','2013-08-16','11:45:00',5.18),('9650','2013-08-16','11:50:00',5.26),('9650','2013-08-16','11:55:00',5.14),('9650','2013-08-16','12:00:00',5.2),('9650','2013-08-16','12:05:00',5.45),('9650','2013-08-16','12:10:00',5.46),('9650','2013-08-16','12:15:00',5.45),('9650','2013-08-16','12:20:00',5.48),('9650','2013-08-16','12:25:00',5.7),('9650','2013-08-16','12:30:00',5.73),('9650','2013-08-16','12:35:00',5.71),('9650','2013-08-16','12:40:00',5.06),('9650','2013-08-16','12:45:00',5.91),('9650','2013-08-16','12:50:00',5.91),('9650','2013-08-16','12:55:00',5.98),('9650','2013-08-16','13:00:00',6.16),('9650','2013-08-16','13:05:00',6.07),('9650','2013-08-16','13:10:00',4.68),('9650','2013-08-16','13:15:00',5.62),('9650','2013-08-16','13:20:00',6.31),('9650','2013-08-16','13:25:00',6.5),('9650','2013-08-16','13:30:00',6.5),('9650','2013-08-16','13:35:00',6.55),('9650','2013-08-16','13:40:00',1.91),('9650','2013-08-16','13:45:00',4.72),('9650','2013-08-16','13:50:00',3.21),('9650','2013-08-16','13:55:00',3.46),('9650','2013-08-16','14:00:00',5.45),('9650','2013-08-16','14:05:00',6.51),('9650','2013-08-16','14:10:00',6.55),('9650','2013-08-16','14:15:00',6.49),('9650','2013-08-16','14:20:00',6.63),('9650','2013-08-16','14:25:00',6.48),('9650','2013-08-16','14:30:00',6.41),('9650','2013-08-16','14:35:00',6.46),('9650','2013-08-16','14:40:00',6.42),('9650','2013-08-16','14:45:00',6.41),('9650','2013-08-16','14:50:00',6.5),('9650','2013-08-16','14:55:00',6.4),('9650','2013-08-16','15:00:00',6.44),('9650','2013-08-16','15:05:00',6.41),('9650','2013-08-16','15:10:00',6.36),('9650','2013-08-16','15:15:00',6.28),('9650','2013-08-16','15:20:00',6.38),('9650','2013-08-16','15:25:00',6.32),('9650','2013-08-16','15:30:00',6.28),('9650','2013-08-16','15:35:00',6.33),('9650','2013-08-16','15:40:00',6.26),('9650','2013-08-16','15:45:00',6.24),('9650','2013-08-16','15:50:00',6.16),('9650','2013-08-16','15:55:00',6.07),('9650','2013-08-16','16:00:00',6.06),('9650','2013-08-16','16:05:00',5.96),('9650','2013-08-16','16:10:00',5.87),('9650','2013-08-16','16:15:00',5.85),('9650','2013-08-16','16:20:00',5.82),('9650','2013-08-16','16:25:00',5.76),('9650','2013-08-16','16:30:00',5.74),('9650','2013-08-16','16:35:00',5.7),('9650','2013-08-16','16:40:00',5.65),('9650','2013-08-16','16:45:00',5.45),('9650','2013-08-16','16:50:00',5.32),('9650','2013-08-16','16:55:00',5.32),('9650','2013-08-16','17:00:00',5.23),('9650','2013-08-16','17:05:00',5.06),('9650','2013-08-16','17:10:00',4.79),('9650','2013-08-16','17:15:00',4.38),('9650','2013-08-16','17:20:00',4.59),('9650','2013-08-16','17:25:00',4.76),('9650','2013-08-16','17:30:00',4.77),('9650','2013-08-16','17:35:00',4.67),('9650','2013-08-16','17:40:00',4.54),('9650','2013-08-16','17:45:00',4.43),('9650','2013-08-16','17:50:00',4.23),('9650','2013-08-16','17:55:00',4.1),('9650','2013-08-16','18:00:00',3.97),('9650','2013-08-16','18:05:00',3.8),('9650','2013-08-16','18:10:00',3.65),('9650','2013-08-16','18:15:00',3.52),('9650','2013-08-16','18:20:00',3.33),('9650','2013-08-16','18:25:00',3.22),('9650','2013-08-16','18:30:00',3.07),('9650','2013-08-16','18:35:00',2.88),('9650','2013-08-16','18:40:00',2.74),('9650','2013-08-16','18:45:00',2.6),('9650','2013-08-16','18:50:00',2.4),('9650','2013-08-16','18:55:00',2.2),('9650','2013-08-16','19:00:00',2),('9650','2013-08-16','19:05:00',1.82),('9650','2013-08-16','19:10:00',1.57),('9650','2013-08-16','19:15:00',1.44),('9650','2013-08-16','19:20:00',1.2),('9650','2013-08-16','19:25:00',1.03),('9650','2013-08-15','08:40:00',1.06),('9650','2013-08-15','08:45:00',1.2),('9650','2013-08-15','08:50:00',1.31),('9650','2013-08-15','08:55:00',1.45),('9650','2013-08-15','09:00:00',1.58),('9650','2013-08-15','09:05:00',1.71),('9650','2013-08-15','09:10:00',1.83),('9650','2013-08-15','09:15:00',1.96),('9650','2013-08-15','09:20:00',2.09),('9650','2013-08-15','09:25:00',2.23),('9650','2013-08-15','09:30:00',2.36),('9650','2013-08-15','09:35:00',2.51),('9650','2013-08-15','09:40:00',2.65),('9650','2013-08-15','09:45:00',2.78),('9650','2013-08-15','09:50:00',2.91),('9650','2013-08-15','09:55:00',3.03),('9650','2013-08-15','10:00:00',3.15),('9650','2013-08-15','10:05:00',3.28),('9650','2013-08-15','10:10:00',3.39),('9650','2013-08-15','10:15:00',3.51),('9650','2013-08-15','10:20:00',3.62),('9650','2013-08-15','10:25:00',3.74),('9650','2013-08-15','10:30:00',3.86),('9650','2013-08-15','10:35:00',3.96),('9650','2013-08-15','10:40:00',4.08),('9650','2013-08-15','10:45:00',4.19),('9650','2013-08-15','10:50:00',4.3),('9650','2013-08-15','10:55:00',4.41),('9650','2013-08-15','11:00:00',4.5),('9650','2013-08-15','11:05:00',4.61),('9650','2013-08-15','11:10:00',4.7),('9650','2013-08-15','11:15:00',4.81),('9650','2013-08-15','11:20:00',4.9),('9650','2013-08-15','11:25:00',4.97),('9650','2013-08-15','11:30:00',5.06),('9650','2013-08-15','11:35:00',5.16),('9650','2013-08-15','11:40:00',5.25),('9650','2013-08-15','11:45:00',5.3),('9650','2013-08-15','11:50:00',5.38),('9650','2013-08-15','11:55:00',5.44),('9650','2013-08-15','12:00:00',5.51),('9650','2013-08-15','12:05:00',5.62),('9650','2013-08-15','12:10:00',5.67),('9650','2013-08-15','12:15:00',5.71),('9650','2013-08-15','12:20:00',5.77),('9650','2013-08-15','12:25:00',5.85),('9650','2013-08-15','12:30:00',5.9),('9650','2013-08-15','12:35:00',5.96),('9650','2013-08-15','12:40:00',5.97),('9650','2013-08-15','12:45:00',5.86),('9650','2013-08-15','12:50:00',6.04),('9650','2013-08-15','12:55:00',6.08),('9650','2013-08-15','13:00:00',6.11),('9650','2013-08-15','13:05:00',6.13),('9650','2013-08-15','13:10:00',6.16),('9650','2013-08-15','13:15:00',6.2),('9650','2013-08-15','13:20:00',6.25),('9650','2013-08-15','13:25:00',6.3),('9650','2013-08-15','13:30:00',6.3),('9650','2013-08-15','13:35:00',6.32),('9650','2013-08-15','13:40:00',6.33),('9650','2013-08-15','13:45:00',6.34),('9650','2013-08-15','13:50:00',6.4),('9650','2013-08-15','13:55:00',6.41),('9650','2013-08-15','14:00:00',6.42),('9650','2013-08-15','14:05:00',6.43),('9650','2013-08-15','14:10:00',6.47),('9650','2013-08-15','14:15:00',6.45),('9650','2013-08-15','14:20:00',6.46),('9650','2013-08-15','14:25:00',6.45),('9650','2013-08-15','14:30:00',6.44),('9650','2013-08-15','14:35:00',6.41),('9650','2013-08-15','14:40:00',6.42),('9650','2013-08-15','14:45:00',6.43),('9650','2013-08-15','14:50:00',6.41),('9650','2013-08-15','14:55:00',6.37),('9650','2013-08-15','15:00:00',6.35),('9650','2013-08-15','15:05:00',6.28),('9650','2013-08-15','15:10:00',6.3),('9650','2013-08-15','15:15:00',6.25),('9650','2013-08-15','15:20:00',6.32),('9650','2013-08-15','15:25:00',6.31),('9650','2013-08-15','15:30:00',6.29),('9650','2013-08-15','15:35:00',6.26),('9650','2013-08-15','15:40:00',6.22),('9650','2013-08-15','15:45:00',6.19),('9650','2013-08-15','15:50:00',6.15),('9650','2013-08-15','15:55:00',6.11),('9650','2013-08-15','16:00:00',6.05),('9650','2013-08-15','16:05:00',5.97),('9650','2013-08-15','16:10:00',5.95),('9650','2013-08-15','16:15:00',5.89),('9650','2013-08-15','16:20:00',5.8),('9650','2013-08-15','16:25:00',5.74),('9650','2013-08-15','16:30:00',5.73),('9650','2013-08-15','16:35:00',5.67),('9650','2013-08-15','16:40:00',5.59),('9650','2013-08-15','16:45:00',5.56),('9650','2013-08-15','16:50:00',5.45),('9650','2013-08-15','16:55:00',5.37),('9650','2013-08-15','17:00:00',5.24),('9650','2013-08-15','17:05:00',5.15),('9650','2013-08-15','17:10:00',5.05),('9650','2013-08-15','17:15:00',4.93),('9650','2013-08-15','17:20:00',4.79),('9650','2013-08-15','17:25:00',4.68),('9650','2013-08-15','17:30:00',4.6),('9650','2013-08-15','17:35:00',4.52),('9650','2013-08-15','17:40:00',4.39),('9650','2013-08-15','17:45:00',4.28),('9650','2013-08-15','17:50:00',4.14),('9650','2013-08-15','17:55:00',3.98),('9650','2013-08-15','18:00:00',3.85),('9650','2013-08-15','18:05:00',3.72),('9650','2013-08-15','18:10:00',3.61),('9650','2013-08-15','18:15:00',3.48),('9650','2013-08-15','18:20:00',3.35),('9650','2013-08-15','18:25:00',3.2),('9650','2013-08-15','18:30:00',2.87),('9650','2013-08-15','18:35:00',1.99),('9650','2013-08-15','18:40:00',1.59),('9650','2013-08-15','18:45:00',1.22),('9650','2013-08-15','18:50:00',2.27),('9650','2013-08-15','18:55:00',2.15),('9650','2013-08-15','19:00:00',1.94),('9650','2013-08-15','19:05:00',1.61),('9650','2013-08-15','19:10:00',1.31),('9650','2013-08-14','08:35:00',1),('9650','2013-08-14','08:40:00',1.07),('9650','2013-08-14','08:45:00',1.13),('9650','2013-08-14','08:50:00',1.17),('9650','2013-08-14','08:55:00',1.2),('9650','2013-08-14','09:00:00',1.68),('9650','2013-08-14','09:05:00',1.79),('9650','2013-08-14','09:10:00',1.27),('9650','2013-08-14','09:15:00',1.69),('9650','2013-08-14','09:20:00',2.29),('9650','2013-08-14','09:25:00',2.28),('9650','2013-08-14','09:30:00',2.4),('9650','2013-08-14','09:35:00',2.54),('9650','2013-08-14','09:40:00',2.69),('9650','2013-08-14','09:45:00',2.81),('9650','2013-08-14','09:50:00',2.94),('9650','2013-08-14','09:55:00',3.07),('9650','2013-08-14','10:00:00',3.2),('9650','2013-08-14','10:05:00',3.31),('9650','2013-08-14','10:10:00',3.42),('9650','2013-08-14','10:15:00',3.55),('9650','2013-08-14','10:20:00',3.68),('9650','2013-08-14','10:25:00',3.79),('9650','2013-08-14','10:30:00',3.93),('9650','2013-08-14','10:35:00',4.03),('9650','2013-08-14','10:40:00',4.13),('9650','2013-08-14','10:45:00',4.24),('9650','2013-08-14','10:50:00',4.23),('9650','2013-08-14','10:55:00',3.86),('9650','2013-08-14','11:00:00',3.59),('9650','2013-08-14','11:05:00',3.65),('9650','2013-08-14','11:10:00',2.82),('9650','2013-08-14','11:15:00',3.08),('9650','2013-08-14','11:20:00',3.69),('9650','2013-08-14','11:25:00',4.15),('9650','2013-08-14','11:30:00',4.59),('9650','2013-08-14','11:35:00',5.18),('9650','2013-08-14','11:40:00',5.54),('9650','2013-08-14','11:45:00',5.71),('9650','2013-08-14','11:50:00',5.88),('9650','2013-08-14','11:55:00',5.9),('9650','2013-08-14','12:00:00',5.99),('9650','2013-08-14','12:05:00',5.97),('9650','2013-08-14','12:10:00',5.97),('9650','2013-08-14','12:15:00',5.98),('9650','2013-08-14','12:20:00',6.06),('9650','2013-08-14','12:25:00',6.11),('9650','2013-08-14','12:30:00',6.14),('9650','2013-08-14','12:35:00',6.2),('9650','2013-08-14','12:40:00',6.22),('9650','2013-08-14','12:45:00',6.18),('9650','2013-08-14','12:50:00',6.24),('9650','2013-08-14','12:55:00',5.95),('9650','2013-08-14','13:00:00',6.02),('9650','2013-08-14','13:05:00',6.15),('9650','2013-08-14','13:10:00',6.21),('9650','2013-08-14','13:15:00',6.09),('9650','2013-08-14','13:20:00',5.93),('9650','2013-08-14','13:25:00',6.19),('9650','2013-08-14','13:30:00',6.39),('9650','2013-08-14','13:35:00',6.49),('9650','2013-08-14','13:40:00',6.54),('9650','2013-08-14','13:45:00',6.52),('9650','2013-08-14','13:50:00',6.52),('9650','2013-08-14','13:55:00',6.43),('9650','2013-08-14','14:00:00',6.48),('9650','2013-08-14','14:05:00',6.55),('9650','2013-08-14','14:10:00',6.56),('9650','2013-08-14','14:15:00',6.55),('9650','2013-08-14','14:20:00',6.58),('9650','2013-08-14','14:25:00',6.49),('9650','2013-08-14','14:30:00',6.39),('9650','2013-08-14','14:35:00',6.51),('9650','2013-08-14','14:40:00',6.49),('9650','2013-08-14','14:45:00',6.48),('9650','2013-08-14','14:50:00',6.24),('9650','2013-08-14','14:55:00',6.41),('9650','2013-08-14','15:00:00',6.34),('9650','2013-08-14','15:05:00',6.38),('9650','2013-08-14','15:10:00',6.36),('9650','2013-08-14','15:15:00',6.35),('9650','2013-08-14','15:20:00',6.26),('9650','2013-08-14','15:25:00',6.28),('9650','2013-08-14','15:30:00',6.22),('9650','2013-08-14','15:35:00',6.18),('9650','2013-08-14','15:40:00',6.14),('9650','2013-08-14','15:45:00',6.08),('9650','2013-08-14','15:50:00',5.99),('9650','2013-08-14','15:55:00',5.91),('9650','2013-08-14','16:00:00',5.86),('9650','2013-08-14','16:05:00',5.89),('9650','2013-08-14','16:10:00',5.76),('9650','2013-08-14','16:15:00',5.66),('9650','2013-08-14','16:20:00',5.69),('9650','2013-08-14','16:25:00',5.65),('9650','2013-08-14','16:30:00',5.47),('9650','2013-08-14','16:35:00',5.3),('9650','2013-08-14','16:40:00',5.31),('9650','2013-08-14','16:45:00',5.24),('9650','2013-08-14','16:50:00',5.15),('9650','2013-08-14','16:55:00',5.08),('9650','2013-08-14','17:00:00',5),('9650','2013-08-14','17:05:00',4.92),('9650','2013-08-14','17:10:00',4.76),('9650','2013-08-14','17:15:00',4.45),('9650','2013-08-14','17:20:00',4.46),('9650','2013-08-14','17:25:00',4),('9650','2013-08-14','17:30:00',4.45),('9650','2013-08-14','17:35:00',4.33),('9650','2013-08-14','17:40:00',4.19),('9650','2013-08-14','17:45:00',4.05),('9650','2013-08-14','17:50:00',3.95),('9650','2013-08-14','17:55:00',3.86),('9650','2013-08-14','18:00:00',3.7),('9650','2013-08-14','18:05:00',3.51),('9650','2013-08-14','18:10:00',3.27),('9650','2013-08-14','18:15:00',3.22),('9650','2013-08-14','18:20:00',3.12),('9650','2013-08-14','18:25:00',2.94),('9650','2013-08-14','18:30:00',2.81),('9650','2013-08-14','18:35:00',2.72),('9650','2013-08-14','18:40:00',2.6),('9650','2013-08-14','18:45:00',2.07),('9650','2013-08-14','18:50:00',1.2),('9650','2013-08-14','18:55:00',1.48),('9650','2013-08-14','19:00:00',1.49),('9650','2013-08-14','19:05:00',1.39),('9650','2013-08-13','08:35:00',1.09),('9650','2013-08-13','08:40:00',1.33),('9650','2013-08-13','08:45:00',1.35),('9650','2013-08-13','08:50:00',1.46),('9650','2013-08-13','08:55:00',1.62),('9650','2013-08-13','09:00:00',1.87),('9650','2013-08-13','09:05:00',1.8),('9650','2013-08-13','09:10:00',2.18),('9650','2013-08-13','09:15:00',2.37),('9650','2013-08-13','09:20:00',2.32),('9650','2013-08-13','09:25:00',2.33),('9650','2013-08-13','09:30:00',2.85),('9650','2013-08-13','09:35:00',2.98),('9650','2013-08-13','09:40:00',1.82),('9650','2013-08-13','09:45:00',1.61),('9650','2013-08-13','09:50:00',2.19),('9650','2013-08-13','09:55:00',3.47),('9650','2013-08-13','10:00:00',3.62),('9650','2013-08-13','10:05:00',3.38),('9650','2013-08-13','10:10:00',3.21),('9650','2013-08-13','10:15:00',1.62),('9650','2013-08-13','10:20:00',2.96),('9650','2013-08-13','10:25:00',4.6),('9650','2013-08-13','10:30:00',4.9),('9650','2013-08-13','10:35:00',4.83),('9650','2013-08-13','10:40:00',4.53),('9650','2013-08-13','10:45:00',1.75),('9650','2013-08-13','10:50:00',1.7),('9650','2013-08-13','10:55:00',1.76),('9650','2013-08-13','11:00:00',2.2),('9650','2013-08-13','11:05:00',4.35),('9650','2013-08-13','11:10:00',4.35),('9650','2013-08-13','11:15:00',4.78),('9650','2013-08-13','11:20:00',3.27),('9650','2013-08-13','11:25:00',4.86),('9650','2013-08-13','11:30:00',6.03),('9650','2013-08-13','11:35:00',5.78),('9650','2013-08-13','11:40:00',4.06),('9650','2013-08-13','11:45:00',2.45),('9650','2013-08-13','11:50:00',4.43),('9650','2013-08-13','11:55:00',5.51),('9650','2013-08-13','12:00:00',5.51),('9650','2013-08-13','12:05:00',5.13),('9650','2013-08-13','12:10:00',4.64),('9650','2013-08-13','12:15:00',2.2),('9650','2013-08-13','12:20:00',1.92),('9650','2013-08-13','12:25:00',2.54),('9650','2013-08-13','12:30:00',2.15),('9650','2013-08-13','12:35:00',2.09),('9650','2013-08-13','12:40:00',2.35),('9650','2013-08-13','12:45:00',3.46),('9650','2013-08-13','12:50:00',3.74),('9650','2013-08-13','12:55:00',3.37),('9650','2013-08-13','13:00:00',3.94),('9650','2013-08-13','13:05:00',2.06),('9650','2013-08-13','13:10:00',1.82),('9650','2013-08-13','13:15:00',2.18),('9650','2013-08-13','13:20:00',2.03),('9650','2013-08-13','13:25:00',5.34),('9650','2013-08-13','13:30:00',5.38),('9650','2013-08-13','13:35:00',4.34),('9650','2013-08-13','13:40:00',5.98),('9650','2013-08-13','13:45:00',7.01),('9650','2013-08-13','13:50:00',7.09),('9650','2013-08-13','13:55:00',3.14),('9650','2013-08-13','14:00:00',7.58),('9650','2013-08-13','14:05:00',7.44),('9650','2013-08-13','14:10:00',6.23),('9650','2013-08-13','14:15:00',7.26),('9650','2013-08-13','14:20:00',6.13),('9650','2013-08-13','14:25:00',5.44),('9650','2013-08-13','14:30:00',6.64),('9650','2013-08-13','14:35:00',7.13),('9650','2013-08-13','14:40:00',6.83),('9650','2013-08-13','14:45:00',6.8),('9650','2013-08-13','14:50:00',6.76),('9650','2013-08-13','14:55:00',6.74),('9650','2013-08-13','15:00:00',6.56),('9650','2013-08-13','15:05:00',6.12),('9650','2013-08-13','15:10:00',6.42),('9650','2013-08-13','15:15:00',6.67),('9650','2013-08-13','15:20:00',6.59),('9650','2013-08-13','15:25:00',6.52),('9650','2013-08-13','15:30:00',6.39),('9650','2013-08-13','15:35:00',6.32),('9650','2013-08-13','15:40:00',6.38),('9650','2013-08-13','15:45:00',6.3),('9650','2013-08-13','15:50:00',6.25),('9650','2013-08-13','15:55:00',6.21),('9650','2013-08-13','16:00:00',6.13),('9650','2013-08-13','16:05:00',6.07),('9650','2013-08-13','16:10:00',6.08),('9650','2013-08-13','16:15:00',6.14),('9650','2013-08-13','16:20:00',6.07),('9650','2013-08-13','16:25:00',5.97),('9650','2013-08-13','16:30:00',5.91),('9650','2013-08-13','16:35:00',5.88),('9650','2013-08-13','16:40:00',5.82),('9650','2013-08-13','16:45:00',5.71),('9650','2013-08-13','16:50:00',5.59),('9650','2013-08-13','16:55:00',5.55),('9650','2013-08-13','17:00:00',5.38),('9650','2013-08-13','17:05:00',5.28),('9650','2013-08-13','17:10:00',5.18),('9650','2013-08-13','17:15:00',5.07),('9650','2013-08-13','17:20:00',4.95),('9650','2013-08-13','17:25:00',4.86),('9650','2013-08-13','17:30:00',4.67),('9650','2013-08-13','17:35:00',4.65),('9650','2013-08-13','17:40:00',4.57),('9650','2013-08-13','17:45:00',4.33),('9650','2013-08-13','17:50:00',4.29),('9650','2013-08-13','17:55:00',4.12),('9650','2013-08-13','18:00:00',3.96),('9650','2013-08-13','18:05:00',3.85),('9650','2013-08-13','18:10:00',3.62),('9650','2013-08-13','18:15:00',3.47),('9650','2013-08-13','18:20:00',3.41),('9650','2013-08-13','18:25:00',3.45),('9650','2013-08-13','18:30:00',3.28),('9650','2013-08-13','18:35:00',3.01),('9650','2013-08-13','18:40:00',2.79),('9650','2013-08-13','18:45:00',2.84),('9650','2013-08-13','18:50:00',2.8),('9650','2013-08-13','18:55:00',2.58),('9650','2013-08-13','19:00:00',2.36),('9650','2013-08-13','19:05:00',2.02),('9650','2013-08-13','19:10:00',1.68),('9650','2013-08-13','19:15:00',1.31),('9650','2013-08-13','19:20:00',1.03),('9650','2013-08-12','08:35:00',1.08),('9650','2013-08-12','08:40:00',1.16),('9650','2013-08-12','08:45:00',1.27),('9650','2013-08-12','08:50:00',1.42),('9650','2013-08-12','08:55:00',1.56),('9650','2013-08-12','09:00:00',1.69),('9650','2013-08-12','09:05:00',1.8),('9650','2013-08-12','09:10:00',1.94),('9650','2013-08-12','09:15:00',2.09),('9650','2013-08-12','09:20:00',2.22),('9650','2013-08-12','09:25:00',2.34),('9650','2013-08-12','09:30:00',2.47),('9650','2013-08-12','09:35:00',1.23),('9650','2013-08-12','09:40:00',2.67),('9650','2013-08-12','09:45:00',2.78),('9650','2013-08-12','09:50:00',2.28),('9650','2013-08-12','09:55:00',3),('9650','2013-08-12','10:00:00',3.3),('9650','2013-08-12','10:05:00',3.41),('9650','2013-08-12','10:10:00',3.47),('9650','2013-08-12','10:15:00',3.53),('9650','2013-08-12','10:20:00',3.7),('9650','2013-08-12','10:25:00',3.8),('9650','2013-08-12','10:30:00',3.89),('9650','2013-08-12','10:35:00',4.05),('9650','2013-08-12','10:40:00',4.03),('9650','2013-08-12','10:45:00',4.14),('9650','2013-08-12','10:50:00',4.34),('9650','2013-08-12','10:55:00',4.44),('9650','2013-08-12','11:00:00',4.55),('9650','2013-08-12','11:05:00',4.66),('9650','2013-08-12','11:10:00',4.71),('9650','2013-08-12','11:15:00',4.79),('9650','2013-08-12','11:20:00',4.9),('9650','2013-08-12','11:25:00',4.94),('9650','2013-08-12','11:30:00',5.05),('9650','2013-08-12','11:35:00',5.1),('9650','2013-08-12','11:40:00',5.2),('9650','2013-08-12','11:45:00',5.31),('9650','2013-08-12','11:50:00',5.41),('9650','2013-08-12','11:55:00',5.58),('9650','2013-08-12','12:00:00',5.59),('9650','2013-08-12','12:05:00',5.65),('9650','2013-08-12','12:10:00',5.79),('9650','2013-08-12','12:15:00',5.98),('9650','2013-08-12','12:20:00',6.14),('9650','2013-08-12','12:25:00',6.29),('9650','2013-08-12','12:30:00',6.39),('9650','2013-08-12','12:35:00',6.41),('9650','2013-08-12','12:40:00',2.93),('9650','2013-08-12','12:45:00',2.25),('9650','2013-08-12','12:50:00',3.81),('9650','2013-08-12','12:55:00',3.53),('9650','2013-08-12','13:00:00',2.03),('9650','2013-08-12','13:05:00',2.3),('9650','2013-08-12','13:10:00',5.94),('9650','2013-08-12','13:15:00',6.67),('9650','2013-08-12','13:20:00',6.8),('9650','2013-08-12','13:25:00',5.88),('9650','2013-08-12','13:30:00',7.05),('9650','2013-08-12','13:35:00',7.07),('9650','2013-08-12','13:40:00',6.17),('9650','2013-08-12','13:45:00',4.02),('9650','2013-08-12','13:50:00',2.26),('9650','2013-08-12','13:55:00',5.33),('9650','2013-08-12','14:00:00',6.34),('9650','2013-08-12','14:05:00',4.41),('9650','2013-08-12','14:10:00',7.3),('9650','2013-08-12','14:15:00',6.53),('9650','2013-08-12','14:20:00',6.68),('9650','2013-08-12','14:25:00',4.93),('9650','2013-08-12','14:30:00',7.03),('9650','2013-08-12','14:35:00',6.78),('9650','2013-08-12','14:40:00',4.94),('9650','2013-08-12','14:45:00',3.65),('9650','2013-08-12','14:50:00',6.72),('9650','2013-08-12','14:55:00',6.61),('9650','2013-08-12','15:00:00',6.75),('9650','2013-08-12','15:05:00',4.84),('9650','2013-08-12','15:10:00',6.65),('9650','2013-08-12','15:15:00',5.42),('9650','2013-08-12','15:20:00',6.11),('9650','2013-08-12','15:25:00',6.66),('9650','2013-08-12','15:30:00',6.22),('9650','2013-08-12','15:35:00',6.54),('9650','2013-08-12','15:40:00',6.42),('9650','2013-08-12','15:45:00',6.46),('9650','2013-08-12','15:50:00',6.3),('9650','2013-08-12','15:55:00',6.17),('9650','2013-08-12','16:00:00',6.22),('9650','2013-08-12','16:05:00',6.16),('9650','2013-08-12','16:10:00',6.08),('9650','2013-08-12','16:15:00',6.03),('9650','2013-08-12','16:20:00',5.99),('9650','2013-08-12','16:25:00',5.94),('9650','2013-08-12','16:30:00',5.86),('9650','2013-08-12','16:35:00',5.79),('9650','2013-08-12','16:40:00',5.67),('9650','2013-08-12','16:45:00',5.59),('9650','2013-08-12','16:50:00',5.56),('9650','2013-08-12','16:55:00',5.47),('9650','2013-08-12','17:00:00',5.4),('9650','2013-08-12','17:05:00',5.28),('9650','2013-08-12','17:10:00',5.2),('9650','2013-08-12','17:15:00',5.06),('9650','2013-08-12','17:20:00',4.96),('9650','2013-08-12','17:25:00',4.85),('9650','2013-08-12','17:30:00',4.72),('9650','2013-08-12','17:35:00',4.61),('9650','2013-08-12','17:40:00',4.54),('9650','2013-08-12','17:45:00',4.37),('9650','2013-08-12','17:50:00',4.29),('9650','2013-08-12','17:55:00',4.14),('9650','2013-08-12','18:00:00',3.97),('9650','2013-08-12','18:05:00',3.85),('9650','2013-08-12','18:10:00',3.69),('9650','2013-08-12','18:15:00',3.55),('9650','2013-08-12','18:20:00',3.44),('9650','2013-08-12','18:25:00',3.26),('9650','2013-08-12','18:30:00',3.09),('9650','2013-08-12','18:35:00',2.93),('9650','2013-08-12','18:40:00',2.76),('9650','2013-08-12','18:45:00',2.59),('9650','2013-08-12','18:50:00',2.44),('9650','2013-08-12','18:55:00',2.28),('9650','2013-08-12','19:00:00',2.06),('9650','2013-08-12','19:05:00',1.89),('9650','2013-08-12','19:10:00',1.71),('9650','2013-08-12','19:15:00',1.57),('9650','2013-08-12','19:20:00',1.37),('9650','2013-08-12','19:25:00',1.17),('9650','2013-08-11','08:30:00',1.01),('9650','2013-08-11','08:35:00',1.07),('9650','2013-08-11','08:40:00',1.12),('9650','2013-08-11','08:45:00',1.17),('9650','2013-08-11','08:50:00',1.19),('9650','2013-08-11','08:55:00',1.22),('9650','2013-08-11','09:00:00',1.65),('9650','2013-08-11','09:05:00',1.82),('9650','2013-08-11','09:10:00',1.94),('9650','2013-08-11','09:15:00',2.07),('9650','2013-08-11','09:20:00',2.2),('9650','2013-08-11','09:25:00',2.34),('9650','2013-08-11','09:30:00',2.46),('9650','2013-08-11','09:35:00',2.6),('9650','2013-08-11','09:40:00',2.73),('9650','2013-08-11','09:45:00',2.86),('9650','2013-08-11','09:50:00',2.96),('9650','2013-08-11','09:55:00',3.09),('9650','2013-08-11','10:00:00',3.2),('9650','2013-08-11','10:05:00',3.31),('9650','2013-08-11','10:10:00',3.42),('9650','2013-08-11','10:15:00',3.53),('9650','2013-08-11','10:20:00',3.66),('9650','2013-08-11','10:25:00',3.76),('9650','2013-08-11','10:30:00',3.84),('9650','2013-08-11','10:35:00',3.95),('9650','2013-08-11','10:40:00',4.07),('9650','2013-08-11','10:45:00',4.17),('9650','2013-08-11','10:50:00',4.25),('9650','2013-08-11','10:55:00',4.35),('9650','2013-08-11','11:00:00',4.46),('9650','2013-08-11','11:05:00',4.54),('9650','2013-08-11','11:10:00',4.65),('9650','2013-08-11','11:15:00',4.73),('9650','2013-08-11','11:20:00',4.82),('9650','2013-08-11','11:25:00',4.95),('9650','2013-08-11','11:30:00',5.07),('9650','2013-08-11','11:35:00',5.19),('9650','2013-08-11','11:40:00',5.28),('9650','2013-08-11','11:45:00',5.37),('9650','2013-08-11','11:50:00',5.52),('9650','2013-08-11','11:55:00',5.66),('9650','2013-08-11','12:00:00',5.77),('9650','2013-08-11','12:05:00',5.86),('9650','2013-08-11','12:10:00',5.89),('9650','2013-08-11','12:15:00',5.61),('9650','2013-08-11','12:20:00',2.76),('9650','2013-08-11','12:25:00',4.99),('9650','2013-08-11','12:30:00',2.05),('9650','2013-08-11','12:35:00',4.83),('9650','2013-08-11','12:40:00',4.62),('9650','2013-08-11','12:45:00',3.39),('9650','2013-08-11','12:50:00',1.93),('9650','2013-08-11','12:55:00',3),('9650','2013-08-11','13:00:00',1.45),('9650','2013-08-11','13:05:00',1.3),('9650','2013-08-11','13:10:00',1.44),('9650','2013-08-11','13:15:00',1.72),('9650','2013-08-11','13:20:00',2.09),('9650','2013-08-11','13:25:00',2.58),('9650','2013-08-11','13:30:00',2.34),('9650','2013-08-11','13:35:00',2.27),('9650','2013-08-11','13:40:00',2.01),('9650','2013-08-11','13:45:00',2.1),('9650','2013-08-11','13:50:00',7.17),('9650','2013-08-11','13:55:00',6.27),('9650','2013-08-11','14:00:00',3.51),('9650','2013-08-11','14:05:00',4.37),('9650','2013-08-11','14:10:00',3.64),('9650','2013-08-11','14:15:00',1.98),('9650','2013-08-11','14:20:00',1.67),('9650','2013-08-11','14:25:00',1.39),('9650','2013-08-11','14:30:00',1.59),('9650','2013-08-11','14:35:00',2.04),('9650','2013-08-11','14:40:00',2.69),('9650','2013-08-11','14:45:00',2.71),('9650','2013-08-11','14:50:00',2.98),('9650','2013-08-11','14:55:00',7.69),('9650','2013-08-11','15:00:00',7.68),('9650','2013-08-11','15:05:00',6.96),('9650','2013-08-11','15:10:00',5.62),('9650','2013-08-11','15:15:00',4.22),('9650','2013-08-11','15:20:00',6.1),('9650','2013-08-11','15:25:00',6.65),('9650','2013-08-11','15:30:00',6.65),('9650','2013-08-11','15:35:00',6.41),('9650','2013-08-11','15:40:00',6.46),('9650','2013-08-11','15:45:00',6.34),('9650','2013-08-11','15:50:00',6.35),('9650','2013-08-11','15:55:00',6.2),('9650','2013-08-11','16:00:00',6.13),('9650','2013-08-11','16:05:00',6.01),('9650','2013-08-11','16:10:00',5.94),('9650','2013-08-11','16:15:00',5.87),('9650','2013-08-11','16:20:00',5.85),('9650','2013-08-11','16:25:00',5.85),('9650','2013-08-11','16:30:00',5.73),('9650','2013-08-11','16:35:00',5.7),('9650','2013-08-11','16:40:00',4.93),('9650','2013-08-11','16:45:00',5.45),('9650','2013-08-11','16:50:00',5.21),('9650','2013-08-11','16:55:00',5.42),('9650','2013-08-11','17:00:00',5.28),('9650','2013-08-11','17:05:00',5.18),('9650','2013-08-11','17:10:00',5.07),('9650','2013-08-11','17:15:00',4.94),('9650','2013-08-11','17:20:00',4.84),('9650','2013-08-11','17:25:00',4.76),('9650','2013-08-11','17:30:00',4.63),('9650','2013-08-11','17:35:00',4.52),('9650','2013-08-11','17:40:00',4.4),('9650','2013-08-11','17:45:00',4.24),('9650','2013-08-11','17:50:00',4.14),('9650','2013-08-11','17:55:00',4.05),('9650','2013-08-11','18:00:00',3.93),('9650','2013-08-11','18:05:00',3.8),('9650','2013-08-11','18:10:00',3.65),('9650','2013-08-11','18:15:00',3.51),('9650','2013-08-11','18:20:00',3.39),('9650','2013-08-11','18:25:00',3.27),('9650','2013-08-11','18:30:00',3.13),('9650','2013-08-11','18:35:00',2.95),('9650','2013-08-11','18:40:00',2.81),('9650','2013-08-11','18:45:00',2.67),('9650','2013-08-11','18:50:00',2.51),('9650','2013-08-11','18:55:00',2.32),('9650','2013-08-11','19:00:00',2.14),('9650','2013-08-11','19:05:00',1.95),('9650','2013-08-11','19:10:00',1.75),('9650','2013-08-11','19:15:00',1.57),('9650','2013-08-11','19:20:00',1.39),('9650','2013-08-11','19:25:00',1.2),('9650','2013-08-11','19:30:00',1.02),('9650','2013-08-10','08:30:00',1.02),('9650','2013-08-10','08:35:00',1.1),('9650','2013-08-10','08:40:00',1.19),('9650','2013-08-10','08:45:00',1.3),('9650','2013-08-10','08:50:00',1.46),('9650','2013-08-10','08:55:00',1.61),('9650','2013-08-10','09:00:00',1.75),('9650','2013-08-10','09:05:00',1.86),('9650','2013-08-10','09:10:00',1.99),('9650','2013-08-10','09:15:00',2.11),('9650','2013-08-10','09:20:00',2.24),('9650','2013-08-10','09:25:00',2.4),('9650','2013-08-10','09:30:00',2.52),('9650','2013-08-10','09:35:00',2.65),('9650','2013-08-10','09:40:00',2.79),('9650','2013-08-10','09:45:00',2.93),('9650','2013-08-10','09:50:00',3.04),('9650','2013-08-10','09:55:00',3.16),('9650','2013-08-10','10:00:00',3.29),('9650','2013-08-10','10:05:00',3.42),('9650','2013-08-10','10:10:00',3.53),('9650','2013-08-10','10:15:00',3.67),('9650','2013-08-10','10:20:00',3.77),('9650','2013-08-10','10:25:00',3.88),('9650','2013-08-10','10:30:00',4.01),('9650','2013-08-10','10:35:00',4.09),('9650','2013-08-10','10:40:00',4.2),('9650','2013-08-10','10:45:00',4.31),('9650','2013-08-10','10:50:00',4.42),('9650','2013-08-10','10:55:00',4.52),('9650','2013-08-10','11:00:00',4.64),('9650','2013-08-10','11:05:00',4.74),('9650','2013-08-10','11:10:00',4.86),('9650','2013-08-10','11:15:00',4.91),('9650','2013-08-10','11:20:00',5),('9650','2013-08-10','11:25:00',5.09),('9650','2013-08-10','11:30:00',5.2),('9650','2013-08-10','11:35:00',5.26),('9650','2013-08-10','11:40:00',5.35),('9650','2013-08-10','11:45:00',5.42),('9650','2013-08-10','11:50:00',5.47),('9650','2013-08-10','11:55:00',5.57),('9650','2013-08-10','12:00:00',5.65),('9650','2013-08-10','12:05:00',5.7),('9650','2013-08-10','12:10:00',5.78),('9650','2013-08-10','12:15:00',5.84),('9650','2013-08-10','12:20:00',5.9),('9650','2013-08-10','12:25:00',5.96),('9650','2013-08-10','12:30:00',6.03),('9650','2013-08-10','12:35:00',6.09),('9650','2013-08-10','12:40:00',6.1),('9650','2013-08-10','12:45:00',6.15),('9650','2013-08-10','12:50:00',6.14),('9650','2013-08-10','12:55:00',6.21),('9650','2013-08-10','13:00:00',6.24),('9650','2013-08-10','13:05:00',6.3),('9650','2013-08-10','13:10:00',6.33),('9650','2013-08-10','13:15:00',6.31),('9650','2013-08-10','13:20:00',6.3),('9650','2013-08-10','13:25:00',6.38),('9650','2013-08-10','13:30:00',6.42),('9650','2013-08-10','13:35:00',6.47),('9650','2013-08-10','13:40:00',6.5),('9650','2013-08-10','13:45:00',6.52),('9650','2013-08-10','13:50:00',6.52),('9650','2013-08-10','13:55:00',6.52),('9650','2013-08-10','14:00:00',6.52),('9650','2013-08-10','14:05:00',6.58),('9650','2013-08-10','14:10:00',6.59),('9650','2013-08-10','14:15:00',6.59),('9650','2013-08-10','14:20:00',6.46),('9650','2013-08-10','14:25:00',6.52),('9650','2013-08-10','14:30:00',6.52),('9650','2013-08-10','14:35:00',6.36),('9650','2013-08-10','14:40:00',6.54),('9650','2013-08-10','14:45:00',6.63),('9650','2013-08-10','14:50:00',6.53),('9650','2013-08-10','14:55:00',6.44),('9650','2013-08-10','15:00:00',5.2),('9650','2013-08-10','15:05:00',6.05),('9650','2013-08-10','15:10:00',6.5),('9650','2013-08-10','15:15:00',6.41),('9650','2013-08-10','15:20:00',5.75),('9650','2013-08-10','15:25:00',6.34),('9650','2013-08-10','15:30:00',5.05),('9650','2013-08-10','15:35:00',6.11),('9650','2013-08-10','15:40:00',6.24),('9650','2013-08-10','15:45:00',6.21),('9650','2013-08-10','15:50:00',6.21),('9650','2013-08-10','15:55:00',6.22),('9650','2013-08-10','16:00:00',6.15),('9650','2013-08-10','16:05:00',6.11),('9650','2013-08-10','16:10:00',6.04),('9650','2013-08-10','16:15:00',5.99),('9650','2013-08-10','16:20:00',5.9),('9650','2013-08-10','16:25:00',5.82),('9650','2013-08-10','16:30:00',5.73),('9650','2013-08-10','16:35:00',5.71),('9650','2013-08-10','16:40:00',5.62),('9650','2013-08-10','16:45:00',5.53),('9650','2013-08-10','16:50:00',5.43),('9650','2013-08-10','16:55:00',5.35),('9650','2013-08-10','17:00:00',5.26),('9650','2013-08-10','17:05:00',5.12),('9650','2013-08-10','17:10:00',5.05),('9650','2013-08-10','17:15:00',4.97),('9650','2013-08-10','17:20:00',4.86),('9650','2013-08-10','17:25:00',4.75),('9650','2013-08-10','17:30:00',4.64),('9650','2013-08-10','17:35:00',4.51),('9650','2013-08-10','17:40:00',4.42),('9650','2013-08-10','17:45:00',4.2),('9650','2013-08-10','17:50:00',4.17),('9650','2013-08-10','17:55:00',4.03),('9650','2013-08-10','18:00:00',3.89),('9650','2013-08-10','18:05:00',3.76),('9650','2013-08-10','18:10:00',3.48),('9650','2013-08-10','18:15:00',3.37),('9650','2013-08-10','18:20:00',3.31),('9650','2013-08-10','18:25:00',3.17),('9650','2013-08-10','18:30:00',3.05),('9650','2013-08-10','18:35:00',2.88),('9650','2013-08-10','18:40:00',2.72),('9650','2013-08-10','18:45:00',2.53),('9650','2013-08-10','18:50:00',2.36),('9650','2013-08-10','18:55:00',2.2),('9650','2013-08-10','19:00:00',2),('9650','2013-08-10','19:05:00',1.81),('9650','2013-08-10','19:10:00',1.59),('9650','2013-08-10','19:15:00',1.41),('9650','2013-08-10','19:20:00',1.23),('9650','2013-08-10','19:25:00',1.06),('9650','2013-08-09','08:35:00',1.06),('9650','2013-08-09','08:40:00',1.16),('9650','2013-08-09','08:45:00',1.25),('9650','2013-08-09','08:50:00',1.43),('9650','2013-08-09','08:55:00',1.6),('9650','2013-08-09','09:00:00',1.74),('9650','2013-08-09','09:05:00',1.87),('9650','2013-08-09','09:10:00',1.99),('9650','2013-08-09','09:15:00',2.13),('9650','2013-08-09','09:20:00',2.26),('9650','2013-08-09','09:25:00',2.42),('9650','2013-08-09','09:30:00',2.56),('9650','2013-08-09','09:35:00',2.68),('9650','2013-08-09','09:40:00',2.83),('9650','2013-08-09','09:45:00',2.92),('9650','2013-08-09','09:50:00',3.08),('9650','2013-08-09','09:55:00',3.18),('9650','2013-08-09','10:00:00',3.31),('9650','2013-08-09','10:05:00',3.43),('9650','2013-08-09','10:10:00',3.21),('9650','2013-08-09','10:20:00',3.26),('9650','2013-08-09','10:25:00',3.88),('9650','2013-08-09','10:30:00',4.02),('9650','2013-08-09','10:35:00',4.13),('9650','2013-08-09','10:40:00',4.23),('9650','2013-08-09','10:45:00',4.36),('9650','2013-08-09','10:50:00',4.46),('9650','2013-08-09','10:55:00',4.61),('9650','2013-08-09','11:00:00',4.81),('9650','2013-08-09','11:05:00',4.89),('9650','2013-08-09','11:10:00',5.08),('9650','2013-08-09','11:15:00',4.9),('9650','2013-08-09','11:20:00',4.49),('9650','2013-08-09','11:25:00',3.66),('9650','2013-08-09','11:30:00',4.9),('9650','2013-08-09','11:35:00',4.98),('9650','2013-08-09','11:40:00',5.46),('9650','2013-08-09','11:45:00',5.53),('9650','2013-08-09','11:50:00',5.59),('9650','2013-08-09','11:55:00',5.68),('9650','2013-08-09','12:00:00',5.76),('9650','2013-08-09','12:05:00',5.83),('9650','2013-08-09','12:10:00',5.89),('9650','2013-08-09','12:15:00',5.95),('9650','2013-08-09','12:20:00',5.95),('9650','2013-08-09','12:25:00',6.07),('9650','2013-08-09','12:30:00',6.13),('9650','2013-08-09','12:35:00',6.19),('9650','2013-08-09','12:40:00',6.29),('9650','2013-08-09','12:45:00',6.46),('9650','2013-08-09','12:50:00',6.64),('9650','2013-08-09','12:55:00',6.57),('9650','2013-08-09','13:00:00',6.55),('9650','2013-08-09','13:05:00',6.51),('9650','2013-08-09','13:10:00',6.69),('9650','2013-08-09','13:15:00',6.98),('9650','2013-08-09','13:20:00',7.12),('9650','2013-08-09','13:25:00',7.31),('9650','2013-08-09','13:30:00',7.51),('9650','2013-08-09','13:35:00',5.09),('9650','2013-08-09','13:40:00',2.03),('9650','2013-08-09','13:45:00',1.21),('9650','2013-08-09','13:50:00',6.54),('9650','2013-08-09','13:55:00',7.1),('9650','2013-08-09','14:00:00',7.44),('9650','2013-08-09','14:05:00',6.78),('9650','2013-08-09','14:10:00',8.03),('9650','2013-08-09','14:15:00',7.88),('9650','2013-08-09','14:20:00',4.83),('9650','2013-08-09','14:25:00',2.22),('9650','2013-08-09','14:30:00',2.1),('9650','2013-08-09','14:35:00',1.85),('9650','2013-08-09','14:40:00',1.69),('9650','2013-08-09','14:45:00',1.64),('9650','2013-08-09','14:50:00',1.54),('9650','2013-08-09','14:55:00',1.57),('9650','2013-08-09','15:00:00',1.79),('9650','2013-08-09','15:05:00',1.87),('9650','2013-08-09','15:10:00',1.97),('9650','2013-08-09','15:15:00',2.18),('9650','2013-08-09','15:20:00',2.12),('9650','2013-08-09','15:25:00',1.82),('9650','2013-08-09','15:30:00',1.78),('9650','2013-08-09','15:35:00',2.29),('9650','2013-08-09','15:40:00',2.23),('9650','2013-08-09','15:45:00',2.55),('9650','2013-08-09','15:50:00',3.18),('9650','2013-08-09','15:55:00',3.61),('9650','2013-08-09','16:00:00',4.46),('9650','2013-08-09','16:05:00',8.13),('9650','2013-08-09','16:10:00',4.5),('9650','2013-08-09','16:15:00',4.19),('9650','2013-08-09','16:20:00',6.84),('9650','2013-08-09','16:25:00',2.18),('9650','2013-08-09','16:30:00',3.35),('9650','2013-08-09','16:35:00',4.58),('9650','2013-08-09','16:40:00',5.68),('9650','2013-08-09','16:45:00',6.23),('9650','2013-08-09','16:50:00',5.88),('9650','2013-08-09','16:55:00',5.65),('9650','2013-08-09','17:00:00',4.94),('9650','2013-08-09','17:05:00',3.36),('9650','2013-08-09','17:10:00',2.14),('9650','2013-08-09','17:15:00',2.22),('9650','2013-08-09','17:20:00',2.96),('9650','2013-08-09','17:25:00',3.19),('9650','2013-08-09','17:30:00',1.83),('9650','2013-08-09','17:50:00',1.09),('9650','2013-08-09','17:55:00',2.33),('9650','2013-08-09','18:00:00',2.16),('9650','2013-08-09','18:25:00',1.04),('9650','2013-08-09','19:30:00',1.02),('9650','2014-04-08','08:05:00',1.11),('9650','2014-04-08','08:10:00',1.02),('9650','2014-04-08','08:30:00',1.26),('9650','2014-04-08','08:55:00',1.31),('9650','2014-04-08','09:00:00',1.39),('9650','2014-04-08','09:05:00',1.4),('9650','2014-04-08','09:10:00',1.39),('9650','2014-04-08','09:15:00',1.36),('9650','2014-04-08','09:20:00',1.41),('9650','2014-04-08','09:25:00',1.57),('9650','2014-04-08','09:30:00',1.59),('9650','2014-04-08','09:35:00',1.27),('9650','2014-04-08','09:40:00',1.07),('9650','2014-04-08','09:45:00',1.2),('9650','2014-04-08','09:50:00',1.98),('9650','2014-04-08','09:55:00',2.74),('9650','2014-04-08','10:00:00',2.84),('9650','2014-04-08','10:05:00',2.96),('9650','2014-04-08','10:10:00',3.23),('9650','2014-04-08','10:15:00',3.46),('9650','2014-04-08','10:20:00',3.7),('9650','2014-04-08','10:25:00',3.79),('9650','2014-04-08','10:30:00',4.25),('9650','2014-04-08','10:35:00',3.3),('9650','2014-04-08','10:40:00',2.19),('9650','2014-04-08','10:45:00',2.26),('9650','2014-04-08','10:50:00',2.07),('9650','2014-04-08','10:55:00',3.29),('9650','2014-04-08','11:00:00',4.61),('9650','2014-04-08','11:05:00',5.55),('9650','2014-04-08','11:10:00',5.67),('9650','2014-04-08','11:15:00',5.88),('9650','2014-04-08','11:20:00',4.94),('9650','2014-04-08','11:25:00',1.94),('9650','2014-04-08','11:30:00',1.62),('9650','2014-04-08','11:35:00',4.55),('9650','2014-04-08','11:40:00',6.24),('9650','2014-04-08','11:45:00',4.09),('9650','2014-04-08','11:50:00',6.12),('9650','2014-04-08','11:55:00',6.56),('9650','2014-04-08','12:00:00',6.83),('9650','2014-04-08','12:05:00',5.5),('9650','2014-04-08','12:10:00',4.47),('9650','2014-04-08','12:15:00',2.83),('9650','2014-04-08','12:20:00',2.13),('9650','2014-04-08','12:25:00',1.66),('9650','2014-04-08','12:30:00',1.43),('9650','2014-04-08','12:35:00',1.29),('9650','2014-04-08','12:40:00',1.21),('9650','2014-04-08','12:45:00',1.06),('9650','2014-04-08','12:50:00',1.07),('9650','2014-04-08','12:55:00',1.04),('9650','2014-04-08','13:10:00',1.2),('9650','2014-04-08','13:15:00',1.82),('9650','2014-04-08','13:20:00',2.73),('9650','2014-04-08','13:25:00',2.53),('9650','2014-04-08','13:30:00',2.17),('9650','2014-04-08','13:35:00',2.18),('9650','2014-04-08','13:40:00',1.85),('9650','2014-04-08','13:45:00',1.62),('9650','2014-04-08','13:50:00',1.58),('9650','2014-04-08','13:55:00',1.49),('9650','2014-04-08','14:00:00',1.84),('9650','2014-04-08','14:05:00',2.58),('9650','2014-04-08','14:10:00',2.89),('9650','2014-04-08','14:15:00',2.82),('9650','2014-04-08','14:20:00',2.58),('9650','2014-04-08','14:25:00',2.53),('9650','2014-04-08','14:30:00',3.09),('9650','2014-04-08','14:35:00',4.1),('9650','2014-04-08','14:40:00',3.17),('9650','2014-04-08','14:45:00',3.45),('9650','2014-04-08','14:50:00',3.67),('9650','2014-04-08','14:55:00',4.8),('9650','2014-04-08','15:00:00',5.95),('9650','2014-04-08','15:05:00',7.77),('9650','2014-04-08','15:10:00',6.74),('9650','2014-04-08','15:15:00',7.27),('9650','2014-04-08','15:20:00',7.67),('9650','2014-04-08','15:25:00',5.64),('9650','2014-04-08','15:30:00',4.21),('9650','2014-04-08','15:35:00',3.44),('9650','2014-04-08','15:40:00',4.89),('9650','2014-04-08','15:45:00',3.41),('9650','2014-04-08','15:50:00',2.4),('9650','2014-04-08','15:55:00',2.11),('9650','2014-04-08','16:00:00',2.55),('9650','2014-04-08','16:05:00',4.41),('9650','2014-04-08','16:10:00',5.85),('9650','2014-04-08','16:15:00',5.75),('9650','2014-04-08','16:20:00',5.61),('9650','2014-04-08','16:25:00',5.62),('9650','2014-04-08','16:30:00',6.21),('9650','2014-04-08','16:35:00',4.32),('9650','2014-04-08','16:40:00',4.26),('9650','2014-04-08','16:45:00',3.85),('9650','2014-04-08','16:50:00',4.88),('9650','2014-04-08','16:55:00',2.92),('9650','2014-04-08','17:00:00',3.49),('9650','2014-04-08','17:05:00',5.36),('9650','2014-04-08','17:10:00',4.29),('9650','2014-04-08','17:15:00',4.13),('9650','2014-04-08','17:20:00',4.08),('9650','2014-04-08','17:25:00',4.05),('9650','2014-04-08','17:30:00',3.11),('9650','2014-04-08','17:35:00',1.31),('9650','2014-04-08','17:40:00',1.4),('9650','2014-04-08','17:45:00',2.45),('9650','2014-04-08','17:50:00',2.29),('9650','2014-04-08','17:55:00',2.28),('9650','2014-04-08','18:00:00',1.94),('9650','2014-04-08','18:05:00',1.22),('9650','2014-04-08','18:10:00',1.6),('9650','2014-04-08','18:15:00',1.13),('9650','2013-08-08','08:00:00',1.12),('9650','2013-08-08','08:05:00',1.35),('9650','2013-08-08','08:10:00',1.24),('9650','2013-08-08','08:15:00',1.26),('9650','2013-08-08','08:20:00',1.25),('9650','2013-08-08','08:25:00',1.08),('9650','2013-08-08','08:30:00',1.03),('9650','2013-08-08','08:35:00',1.06),('9650','2013-08-08','08:40:00',1.29),('9650','2013-08-08','08:45:00',1.55),('9650','2013-08-08','08:50:00',1.68),('9650','2013-08-08','08:55:00',1.78),('9650','2013-08-08','09:00:00',1.96),('9650','2013-08-08','09:05:00',2.21),('9650','2013-08-08','09:10:00',2.21),('9650','2013-08-08','09:15:00',2.59),('9650','2013-08-08','09:20:00',2.42),('9650','2013-08-08','09:25:00',2.3),('9650','2013-08-08','09:30:00',2.63),('9650','2013-08-08','09:35:00',2.7),('9650','2013-08-08','09:40:00',2.31),('9650','2013-08-08','09:45:00',2.88),('9650','2013-08-08','09:50:00',2.59),('9650','2013-08-08','09:55:00',1.77),('9650','2013-08-08','10:00:00',2.44),('9650','2013-08-08','10:05:00',2.14),('9650','2013-08-08','10:10:00',2.59),('9650','2013-08-08','10:15:00',3.36),('9650','2013-08-08','10:20:00',3.37),('9650','2013-08-08','10:25:00',3.53),('9650','2013-08-08','10:30:00',3.14),('9650','2013-08-08','10:35:00',3.52),('9650','2013-08-08','10:40:00',3.85),('9650','2013-08-08','10:45:00',3.94),('9650','2013-08-08','10:50:00',3.98),('9650','2013-08-08','10:55:00',4.19),('9650','2013-08-08','11:00:00',4.31),('9650','2013-08-08','11:05:00',4.37),('9650','2013-08-08','11:10:00',4.45),('9650','2013-08-08','11:15:00',4.6),('9650','2013-08-08','11:20:00',4.69),('9650','2013-08-08','11:25:00',4.73),('9650','2013-08-08','11:30:00',4.81),('9650','2013-08-08','11:35:00',4.81),('9650','2013-08-08','11:40:00',4.94),('9650','2013-08-08','11:45:00',5.02),('9650','2013-08-08','11:50:00',5.01),('9650','2013-08-08','11:55:00',5.15),('9650','2013-08-08','12:00:00',5.23),('9650','2013-08-08','12:05:00',5.31),('9650','2013-08-08','12:10:00',5.31),('9650','2013-08-08','12:15:00',5.47),('9650','2013-08-08','12:20:00',5.7),('9650','2013-08-08','12:25:00',4.69),('9650','2013-08-08','12:30:00',3.72),('9650','2013-08-08','12:35:00',4.35),('9650','2013-08-08','12:40:00',5.99),('9650','2013-08-08','12:45:00',4.5),('9650','2013-08-08','12:50:00',3.93),('9650','2013-08-08','12:55:00',4.91),('9650','2013-08-08','13:00:00',2.15),('9650','2013-08-08','13:05:00',1.56),('9650','2013-08-08','13:10:00',1.47),('9650','2013-08-08','13:15:00',1.87),('9650','2013-08-08','13:20:00',2.56),('9650','2013-08-08','13:25:00',3.76),('9650','2013-08-08','13:30:00',3.21),('9650','2013-08-08','13:35:00',2.59),('9650','2013-08-08','13:40:00',2.54),('9650','2013-08-08','13:45:00',2.39),('9650','2013-08-08','13:50:00',2.56),('9650','2013-08-08','13:55:00',2.3),('9650','2013-08-08','14:00:00',2.2),('9650','2013-08-08','14:05:00',2.18),('9650','2013-08-08','14:10:00',2.51),('9650','2013-08-08','14:15:00',1.73),('9650','2013-08-08','14:20:00',1.55),('9650','2013-08-08','14:25:00',1.7),('9650','2013-08-08','14:30:00',1.76),('9650','2013-08-08','14:35:00',1.49),('9650','2013-08-08','14:40:00',1.15),('9650','2013-08-08','15:05:00',2.01),('9650','2013-08-08','15:10:00',4.92),('9650','2013-08-08','15:15:00',4.72),('9650','2013-08-08','15:20:00',2.82),('9650','2013-08-08','15:25:00',2.19),('9650','2013-08-08','15:30:00',2.21),('9650','2013-08-08','15:35:00',3.8),('9650','2013-08-08','15:40:00',3),('9650','2013-08-08','15:45:00',5.38),('9650','2013-08-08','15:50:00',3.97),('9650','2013-08-08','15:55:00',3.51),('9650','2013-08-08','16:00:00',2.16),('9650','2013-08-08','16:05:00',1.41),('9650','2013-08-08','16:10:00',1.18),('9650','2013-08-08','16:15:00',1.24),('9650','2013-08-08','16:20:00',1.26),('9650','2013-08-08','16:25:00',1.37),('9650','2013-08-08','16:35:00',1),('9650','2013-08-08','16:40:00',1.08),('9650','2013-08-08','16:45:00',1.2),('9650','2013-08-08','16:50:00',2.65),('9650','2013-08-08','16:55:00',4.86),('9650','2013-08-08','17:00:00',2.86),('9650','2013-08-08','17:05:00',3.65),('9650','2013-08-08','17:10:00',1.96),('9650','2013-08-08','17:15:00',1.42),('9650','2013-08-08','17:20:00',1.26),('9650','2013-08-08','17:25:00',1.38),('9650','2013-08-08','17:30:00',1.56),('9650','2013-08-08','17:35:00',1.6),('9650','2013-08-08','17:40:00',1.59),('9650','2013-08-08','17:45:00',1.48),('9650','2013-08-08','17:50:00',1.12),('9650','2013-08-08','18:15:00',1.02),('9650','2013-08-08','18:55:00',1.11),('9650','2013-08-08','19:00:00',1.85),('9650','2013-08-08','19:05:00',2.43),('9650','2013-08-08','19:10:00',2.46),('9650','2013-08-08','19:15:00',2.33),('9650','2013-08-08','19:20:00',2.37),('9650','2013-08-08','19:25:00',2.23),('9650','2013-08-08','19:30:00',1.01),('9650','2013-08-07','08:30:00',1.05),('9650','2013-08-07','08:35:00',1.14),('9650','2013-08-07','08:40:00',1.23),('9650','2013-08-07','08:45:00',1.29),('9650','2013-08-07','08:50:00',1.44),('9650','2013-08-07','08:55:00',1.56),('9650','2013-08-07','09:00:00',1.7),('9650','2013-08-07','09:05:00',1.82),('9650','2013-08-07','09:10:00',1.92),('9650','2013-08-07','09:15:00',2.03),('9650','2013-08-07','09:20:00',2.17),('9650','2013-08-07','09:25:00',2.31),('9650','2013-08-07','09:30:00',2.42),('9650','2013-08-07','09:35:00',2.54),('9650','2013-08-07','09:40:00',2.67),('9650','2013-08-07','09:45:00',2.79),('9650','2013-08-07','09:50:00',2.89),('9650','2013-08-07','09:55:00',3),('9650','2013-08-07','10:00:00',3.1),('9650','2013-08-07','10:05:00',3.21),('9650','2013-08-07','10:10:00',3.32),('9650','2013-08-07','10:15:00',3.44),('9650','2013-08-07','10:20:00',3.54),('9650','2013-08-07','10:25:00',3.64),('9650','2013-08-07','10:30:00',3.74),('9650','2013-08-07','10:35:00',3.85),('9650','2013-08-07','10:40:00',3.93),('9650','2013-08-07','10:45:00',4.03),('9650','2013-08-07','10:50:00',4.13),('9650','2013-08-07','10:55:00',4.24),('9650','2013-08-07','11:00:00',4.33),('9650','2013-08-07','11:05:00',4.41),('9650','2013-08-07','11:10:00',4.48),('9650','2013-08-07','11:15:00',4.58),('9650','2013-08-07','11:20:00',4.62),('9650','2013-08-07','11:25:00',4.71),('9650','2013-08-07','11:30:00',4.78),('9650','2013-08-07','11:35:00',4.84),('9650','2013-08-07','11:40:00',4.92),('9650','2013-08-07','11:45:00',4.99),('9650','2013-08-07','11:50:00',5.04),('9650','2013-08-07','11:55:00',5.1),('9650','2013-08-07','12:00:00',5.19),('9650','2013-08-07','12:05:00',5.22),('9650','2013-08-07','12:10:00',5.3),('9650','2013-08-07','12:15:00',5.28),('9650','2013-08-07','12:20:00',5.34),('9650','2013-08-07','12:25:00',5.41),('9650','2013-08-07','12:30:00',5.32),('9650','2013-08-07','12:35:00',5.54),('9650','2013-08-07','12:40:00',5.74),('9650','2013-08-07','12:45:00',5.77),('9650','2013-08-07','12:50:00',5.81),('9650','2013-08-07','12:55:00',5.81),('9650','2013-08-07','13:00:00',5.85),('9650','2013-08-07','13:05:00',5.88),('9650','2013-08-07','13:10:00',5.95),('9650','2013-08-07','13:15:00',5.96),('9650','2013-08-07','13:20:00',6.06),('9650','2013-08-07','13:25:00',6.11),('9650','2013-08-07','13:30:00',6.12),('9650','2013-08-07','13:35:00',6.16),('9650','2013-08-07','13:40:00',6.12),('9650','2013-08-07','13:45:00',6.18),('9650','2013-08-07','13:50:00',6.23),('9650','2013-08-07','13:55:00',6.21),('9650','2013-08-07','14:00:00',6.26),('9650','2013-08-07','14:05:00',6.26),('9650','2013-08-07','14:10:00',6.23),('9650','2013-08-07','14:15:00',6.22),('9650','2013-08-07','14:20:00',6.23),('9650','2013-08-07','14:25:00',6.25),('9650','2013-08-07','14:30:00',6.28),('9650','2013-08-07','14:35:00',6.25),('9650','2013-08-07','14:40:00',6.2),('9650','2013-08-07','14:45:00',6.21),('9650','2013-08-07','14:50:00',6.22),('9650','2013-08-07','14:55:00',6.18),('9650','2013-08-07','15:00:00',6.16),('9650','2013-08-07','15:05:00',6.14),('9650','2013-08-07','15:10:00',6.13),('9650','2013-08-07','15:15:00',6.1),('9650','2013-08-07','15:20:00',6.04),('9650','2013-08-07','15:25:00',5.99),('9650','2013-08-07','15:30:00',5.93),('9650','2013-08-07','15:35:00',5.93),('9650','2013-08-07','15:40:00',5.92),('9650','2013-08-07','15:45:00',5.86),('9650','2013-08-07','15:50:00',5.8),('9650','2013-08-07','15:55:00',5.75),('9650','2013-08-07','16:00:00',5.73),('9650','2013-08-07','16:05:00',5.71),('9650','2013-08-07','16:10:00',5.67),('9650','2013-08-07','16:15:00',5.63),('9650','2013-08-07','16:20:00',5.62),('9650','2013-08-07','16:25:00',5.57),('9650','2013-08-07','16:30:00',5.52),('9650','2013-08-07','16:35:00',5.49),('9650','2013-08-07','16:40:00',5.36),('9650','2013-08-07','16:45:00',5.31),('9650','2013-08-07','16:50:00',5.2),('9650','2013-08-07','16:55:00',5.15),('9650','2013-08-07','17:00:00',4.99),('9650','2013-08-07','17:05:00',4.86),('9650','2013-08-07','17:10:00',4.77),('9650','2013-08-07','17:15:00',4.69),('9650','2013-08-07','17:20:00',4.58),('9650','2013-08-07','17:25:00',4.49),('9650','2013-08-07','17:30:00',4.38),('9650','2013-08-07','17:35:00',4.25),('9650','2013-08-07','17:40:00',4.18),('9650','2013-08-07','17:45:00',4.07),('9650','2013-08-07','17:50:00',3.96),('9650','2013-08-07','17:55:00',3.86),('9650','2013-08-07','18:00:00',3.76),('9650','2013-08-07','18:05:00',3.62),('9650','2013-08-07','18:10:00',3.49),('9650','2013-08-07','18:15:00',3.34),('9650','2013-08-07','18:20:00',3.2),('9650','2013-08-07','18:25:00',3.05),('9650','2013-08-07','18:30:00',2.89),('9650','2013-08-07','18:35:00',2.73),('9650','2013-08-07','18:40:00',2.57),('9650','2013-08-07','18:45:00',2.4),('9650','2013-08-07','18:50:00',2.24),('9650','2013-08-07','18:55:00',2.07),('9650','2013-08-07','19:00:00',1.9),('9650','2013-08-07','19:05:00',1.73),('9650','2013-08-07','19:10:00',1.58),('9650','2013-08-07','19:15:00',1.4),('9650','2013-08-07','19:20:00',1.22),('9650','2013-08-07','19:25:00',1.04),('9650','2013-08-06','08:30:00',1.06),('9650','2013-08-06','08:35:00',1.14),('9650','2013-08-06','08:40:00',1.25),('9650','2013-08-06','08:45:00',1.32),('9650','2013-08-06','08:50:00',1.48),('9650','2013-08-06','08:55:00',1.6),('9650','2013-08-06','09:00:00',1.73),('9650','2013-08-06','09:05:00',1.85),('9650','2013-08-06','09:10:00',1.96),('9650','2013-08-06','09:15:00',2.07),('9650','2013-08-06','09:20:00',2.19),('9650','2013-08-06','09:25:00',2.32),('9650','2013-08-06','09:30:00',2.44),('9650','2013-08-06','09:35:00',2.55),('9650','2013-08-06','09:40:00',2.71),('9650','2013-08-06','09:45:00',2.82),('9650','2013-08-06','09:50:00',2.94),('9650','2013-08-06','09:55:00',3.05),('9650','2013-08-06','10:00:00',3.13),('9650','2013-08-06','10:05:00',3.26),('9650','2013-08-06','10:10:00',3.35),('9650','2013-08-06','10:15:00',3.48),('9650','2013-08-06','10:20:00',3.62),('9650','2013-08-06','10:25:00',3.73),('9650','2013-08-06','10:30:00',3.84),('9650','2013-08-06','10:35:00',3.94),('9650','2013-08-06','10:40:00',4.01),('9650','2013-08-06','10:45:00',4.11),('9650','2013-08-06','10:50:00',4.2),('9650','2013-08-06','10:55:00',4.3),('9650','2013-08-06','11:00:00',4.38),('9650','2013-08-06','11:05:00',4.47),('9650','2013-08-06','11:10:00',4.54),('9650','2013-08-06','11:15:00',4.64),('9650','2013-08-06','11:20:00',4.67),('9650','2013-08-06','11:25:00',4.77),('9650','2013-08-06','11:30:00',4.84),('9650','2013-08-06','11:35:00',4.9),('9650','2013-08-06','11:40:00',4.97),('9650','2013-08-06','11:45:00',5.04),('9650','2013-08-06','11:50:00',5.12),('9650','2013-08-06','11:55:00',5.18),('9650','2013-08-06','12:00:00',5.26),('9650','2013-08-06','12:05:00',5.3),('9650','2013-08-06','12:10:00',5.37),('9650','2013-08-06','12:15:00',5.38),('9650','2013-08-06','12:20:00',5.39),('9650','2013-08-06','12:25:00',5.43),('9650','2013-08-06','12:30:00',5.49),('9650','2013-08-06','12:35:00',5.6),('9650','2013-08-06','12:40:00',5.61),('9650','2013-08-06','12:45:00',5.72),('9650','2013-08-06','12:50:00',5.79),('9650','2013-08-06','12:55:00',5.84),('9650','2013-08-06','13:00:00',5.84),('9650','2013-08-06','13:05:00',6.07),('9650','2013-08-06','13:10:00',6.04),('9650','2013-08-06','13:15:00',6.09),('9650','2013-08-06','13:20:00',5.97),('9650','2013-08-06','13:25:00',6.13),('9650','2013-08-06','13:30:00',6.1),('9650','2013-08-06','13:35:00',6.08),('9650','2013-08-06','13:40:00',6.25),('9650','2013-08-06','13:45:00',6.18),('9650','2013-08-06','13:50:00',6.24),('9650','2013-08-06','13:55:00',6.36),('9650','2013-08-06','14:00:00',6.31),('9650','2013-08-06','14:05:00',6.33),('9650','2013-08-06','14:10:00',6.27),('9650','2013-08-06','14:15:00',6.2),('9650','2013-08-06','14:20:00',6.12),('9650','2013-08-06','14:25:00',6.15),('9650','2013-08-06','14:30:00',6.1),('9650','2013-08-06','14:35:00',6.08),('9650','2013-08-06','14:40:00',6.18),('9650','2013-08-06','14:45:00',6.24),('9650','2013-08-06','14:50:00',6.32),('9650','2013-08-06','14:55:00',6.24),('9650','2013-08-06','15:00:00',6.3),('9650','2013-08-06','15:05:00',6.21),('9650','2013-08-06','15:10:00',6.17),('9650','2013-08-06','15:15:00',6.2),('9650','2013-08-06','15:20:00',6.24),('9650','2013-08-06','15:25:00',6.11),('9650','2013-08-06','15:30:00',6.12),('9650','2013-08-06','15:35:00',6.1),('9650','2013-08-06','15:40:00',6.08),('9650','2013-08-06','15:45:00',6.06),('9650','2013-08-06','15:50:00',5.97),('9650','2013-08-06','15:55:00',5.93),('9650','2013-08-06','16:00:00',5.78),('9650','2013-08-06','16:05:00',5.73),('9650','2013-08-06','16:10:00',5.65),('9650','2013-08-06','16:15:00',5.63),('9650','2013-08-06','16:20:00',5.59),('9650','2013-08-06','16:25:00',5.55),('9650','2013-08-06','16:30:00',5.51),('9650','2013-08-06','16:35:00',5.5),('9650','2013-08-06','16:40:00',5.43),('9650','2013-08-06','16:45:00',5.37),('9650','2013-08-06','16:50:00',5.32),('9650','2013-08-06','16:55:00',5.27),('9650','2013-08-06','17:00:00',5.2),('9650','2013-08-06','17:05:00',5.06),('9650','2013-08-06','17:10:00',4.93),('9650','2013-08-06','17:15:00',4.85),('9650','2013-08-06','17:20:00',4.79),('9650','2013-08-06','17:25:00',4.66),('9650','2013-08-06','17:30:00',4.48),('9650','2013-08-06','17:35:00',4.41),('9650','2013-08-06','17:40:00',4.27),('9650','2013-08-06','17:45:00',4.17),('9650','2013-08-06','17:50:00',4.05),('9650','2013-08-06','17:55:00',3.93),('9650','2013-08-06','18:00:00',3.83),('9650','2013-08-06','18:05:00',3.66),('9650','2013-08-06','18:10:00',3.46),('9650','2013-08-06','18:15:00',3.37),('9650','2013-08-06','18:20:00',3.21),('9650','2013-08-06','18:25:00',3.09),('9650','2013-08-06','18:30:00',2.99),('9650','2013-08-06','18:35:00',2.86),('9650','2013-08-06','18:40:00',2.7),('9650','2013-08-06','18:45:00',2.56),('9650','2013-08-06','18:50:00',2.4),('9650','2013-08-06','18:55:00',2.23),('9650','2013-08-06','19:00:00',2.04),('9650','2013-08-06','19:05:00',1.84),('9650','2013-08-06','19:10:00',1.64),('9650','2013-08-06','19:15:00',1.46),('9650','2013-08-06','19:20:00',1.27),('9650','2013-08-06','19:25:00',1.1),('9650','2013-08-05','08:25:00',1.02),('9650','2013-08-05','08:30:00',1.07),('9650','2013-08-05','08:35:00',1.11),('9650','2013-08-05','08:40:00',1.14),('9650','2013-08-05','08:45:00',1.17),('9650','2013-08-05','08:50:00',1.2),('9650','2013-08-05','08:55:00',1.22),('9650','2013-08-05','09:00:00',1.23),('9650','2013-08-05','09:05:00',1.49),('9650','2013-08-05','09:10:00',1.96),('9650','2013-08-05','09:15:00',2.07),('9650','2013-08-05','09:20:00',2.19),('9650','2013-08-05','09:25:00',2.33),('9650','2013-08-05','09:30:00',2.45),('9650','2013-08-05','09:35:00',2.56),('9650','2013-08-05','09:40:00',2.7),('9650','2013-08-05','09:45:00',2.84),('9650','2013-08-05','09:50:00',2.93),('9650','2013-08-05','09:55:00',3.05),('9650','2013-08-05','10:00:00',3.18),('9650','2013-08-05','10:05:00',3.28),('9650','2013-08-05','10:10:00',3.39),('9650','2013-08-05','10:15:00',3.49),('9650','2013-08-05','10:20:00',3.59),('9650','2013-08-05','10:25:00',3.69),('9650','2013-08-05','10:30:00',3.8),('9650','2013-08-05','10:35:00',3.91),('9650','2013-08-05','10:40:00',3.99),('9650','2013-08-05','10:45:00',4.09),('9650','2013-08-05','10:50:00',4.18),('9650','2013-08-05','10:55:00',4.27),('9650','2013-08-05','11:00:00',4.36),('9650','2013-08-05','11:05:00',4.48),('9650','2013-08-05','11:10:00',4.56),('9650','2013-08-05','11:15:00',4.61),('9650','2013-08-05','11:20:00',4.68),('9650','2013-08-05','11:25:00',4.75),('9650','2013-08-05','11:30:00',4.87),('9650','2013-08-05','11:35:00',4.93),('9650','2013-08-05','11:40:00',4.98),('9650','2013-08-05','11:45:00',5.09),('9650','2013-08-05','11:50:00',5.13),('9650','2013-08-05','11:55:00',5.21),('9650','2013-08-05','12:00:00',5.25),('9650','2013-08-05','12:05:00',5.32),('9650','2013-08-05','12:10:00',5.33),('9650','2013-08-05','12:15:00',5.36),('9650','2013-08-05','12:20:00',5.44),('9650','2013-08-05','12:25:00',5.52),('9650','2013-08-05','12:30:00',5.51),('9650','2013-08-05','12:35:00',5.6),('9650','2013-08-05','12:40:00',5.6),('9650','2013-08-05','12:45:00',5.75),('9650','2013-08-05','12:50:00',5.8),('9650','2013-08-05','12:55:00',5.83),('9650','2013-08-05','13:00:00',5.86),('9650','2013-08-05','13:05:00',5.9),('9650','2013-08-05','13:10:00',6),('9650','2013-08-05','13:15:00',6.07),('9650','2013-08-05','13:20:00',6.05),('9650','2013-08-05','13:25:00',6),('9650','2013-08-05','13:30:00',6.16),('9650','2013-08-05','13:35:00',6.21),('9650','2013-08-05','13:40:00',6.27),('9650','2013-08-05','13:45:00',6.29),('9650','2013-08-05','13:50:00',6.32),('9650','2013-08-05','13:55:00',6.33),('9650','2013-08-05','14:00:00',6.38),('9650','2013-08-05','14:05:00',6.43),('9650','2013-08-05','14:10:00',6.46),('9650','2013-08-05','14:15:00',6.53),('9650','2013-08-05','14:20:00',6.49),('9650','2013-08-05','14:25:00',6.53),('9650','2013-08-05','14:30:00',6.52),('9650','2013-08-05','14:35:00',6.48),('9650','2013-08-05','14:40:00',6.49),('9650','2013-08-05','14:45:00',6.48),('9650','2013-08-05','14:50:00',6.48),('9650','2013-08-05','14:55:00',6.5),('9650','2013-08-05','15:00:00',6.5),('9650','2013-08-05','15:05:00',6.48),('9650','2013-08-05','15:10:00',6.46),('9650','2013-08-05','15:15:00',6.46),('9650','2013-08-05','15:20:00',6.45),('9650','2013-08-05','15:25:00',6.42),('9650','2013-08-05','15:30:00',6.4),('9650','2013-08-05','15:35:00',6.35),('9650','2013-08-05','15:40:00',6.33),('9650','2013-08-05','15:45:00',6.25),('9650','2013-08-05','15:50:00',6.19),('9650','2013-08-05','15:55:00',6.09),('9650','2013-08-05','16:00:00',6.04),('9650','2013-08-05','16:05:00',5.97),('9650','2013-08-05','16:10:00',5.94),('9650','2013-08-05','16:15:00',5.91),('9650','2013-08-05','16:20:00',5.82),('9650','2013-08-05','16:25:00',5.76),('9650','2013-08-05','16:30:00',5.7),('9650','2013-08-05','16:35:00',5.61),('9650','2013-08-05','16:40:00',5.57),('9650','2013-08-05','16:45:00',5.48),('9650','2013-08-05','16:50:00',5.41),('9650','2013-08-05','16:55:00',5.34),('9650','2013-08-05','17:00:00',5.28),('9650','2013-08-05','17:05:00',5.2),('9650','2013-08-05','17:10:00',5.06),('9650','2013-08-05','17:15:00',4.96),('9650','2013-08-05','17:20:00',4.88),('9650','2013-08-05','17:25:00',4.79),('9650','2013-08-05','17:30:00',4.68),('9650','2013-08-05','17:35:00',4.57),('9650','2013-08-05','17:40:00',4.43),('9650','2013-08-05','17:45:00',4.31),('9650','2013-08-05','17:50:00',4.22),('9650','2013-08-05','17:55:00',4.08),('9650','2013-08-05','18:00:00',3.94),('9650','2013-08-05','18:05:00',3.83),('9650','2013-08-05','18:10:00',3.71),('9650','2013-08-05','18:15:00',3.57),('9650','2013-08-05','18:20:00',3.44),('9650','2013-08-05','18:25:00',3.29),('9650','2013-08-05','18:30:00',3.19),('9650','2013-08-05','18:35:00',3.05),('9650','2013-08-05','18:40:00',2.81),('9650','2013-08-05','18:45:00',2.67),('9650','2013-08-05','18:50:00',2.46),('9650','2013-08-05','18:55:00',2.26),('9650','2013-08-05','19:00:00',2.06),('9650','2013-08-05','19:05:00',1.86),('9650','2013-08-05','19:10:00',1.66),('9650','2013-08-05','19:15:00',1.49),('9650','2013-08-05','19:20:00',1.31),('9650','2013-08-05','19:25:00',1.13),('9650','2013-08-04','08:25:00',1.06),('9650','2013-08-04','08:30:00',1.14),('9650','2013-08-04','08:35:00',1.22),('9650','2013-08-04','08:40:00',1.34),('9650','2013-08-04','08:45:00',1.43),('9650','2013-08-04','08:50:00',1.56),('9650','2013-08-04','08:55:00',1.67),('9650','2013-08-04','09:00:00',1.81),('9650','2013-08-04','09:05:00',1.91),('9650','2013-08-04','09:10:00',2.01),('9650','2013-08-04','09:15:00',2.12),('9650','2013-08-04','09:20:00',2.24),('9650','2013-08-04','09:25:00',2.37),('9650','2013-08-04','09:30:00',2.51),('9650','2013-08-04','09:35:00',2.61),('9650','2013-08-04','09:40:00',2.73),('9650','2013-08-04','09:45:00',2.85),('9650','2013-08-04','09:50:00',2.97),('9650','2013-08-04','09:55:00',3.07),('9650','2013-08-04','10:00:00',3.19),('9650','2013-08-04','10:05:00',3.32),('9650','2013-08-04','10:10:00',3.43),('9650','2013-08-04','10:15:00',3.54),('9650','2013-08-04','10:20:00',3.65),('9650','2013-08-04','10:25:00',3.76),('9650','2013-08-04','10:30:00',3.85),('9650','2013-08-04','10:35:00',3.95),('9650','2013-08-04','10:40:00',4.07),('9650','2013-08-04','10:45:00',4.17),('9650','2013-08-04','10:50:00',4.28),('9650','2013-08-04','10:55:00',4.38),('9650','2013-08-04','11:00:00',4.45),('9650','2013-08-04','11:05:00',4.59),('9650','2013-08-04','11:10:00',4.64),('9650','2013-08-04','11:15:00',4.74),('9650','2013-08-04','11:20:00',4.84),('9650','2013-08-04','11:25:00',4.9),('9650','2013-08-04','11:30:00',4.99),('9650','2013-08-04','11:35:00',5.05),('9650','2013-08-04','11:40:00',5.18),('9650','2013-08-04','11:45:00',5.2),('9650','2013-08-04','11:50:00',5.3),('9650','2013-08-04','11:55:00',5.39),('9650','2013-08-04','12:00:00',5.46),('9650','2013-08-04','12:05:00',5.54),('9650','2013-08-04','12:10:00',5.43),('9650','2013-08-04','12:15:00',5.57),('9650','2013-08-04','12:20:00',5.64),('9650','2013-08-04','12:25:00',5.7),('9650','2013-08-04','12:30:00',5.72),('9650','2013-08-04','12:35:00',5.8),('9650','2013-08-04','12:40:00',5.85),('9650','2013-08-04','12:45:00',5.88),('9650','2013-08-04','12:50:00',5.96),('9650','2013-08-04','12:55:00',5.97),('9650','2013-08-04','13:00:00',6.04),('9650','2013-08-04','13:05:00',6.03),('9650','2013-08-04','13:10:00',6.06),('9650','2013-08-04','13:15:00',6.11),('9650','2013-08-04','13:20:00',6.07),('9650','2013-08-04','13:25:00',6.18),('9650','2013-08-04','13:30:00',6.21),('9650','2013-08-04','13:35:00',6.23),('9650','2013-08-04','13:40:00',6.29),('9650','2013-08-04','13:45:00',6.17),('9650','2013-08-04','13:50:00',6.28),('9650','2013-08-04','13:55:00',6.24),('9650','2013-08-04','14:00:00',6.27),('9650','2013-08-04','14:05:00',6.36),('9650','2013-08-04','14:10:00',6.34),('9650','2013-08-04','14:15:00',6.35),('9650','2013-08-04','14:20:00',6.31),('9650','2013-08-04','14:25:00',6.29),('9650','2013-08-04','14:30:00',6.29),('9650','2013-08-04','14:35:00',6.34),('9650','2013-08-04','14:40:00',6.37),('9650','2013-08-04','14:45:00',6.37),('9650','2013-08-04','14:50:00',6.34),('9650','2013-08-04','14:55:00',6.33),('9650','2013-08-04','15:00:00',6.34),('9650','2013-08-04','15:05:00',6.37),('9650','2013-08-04','15:10:00',6.35),('9650','2013-08-04','15:15:00',6.35),('9650','2013-08-04','15:20:00',6.33),('9650','2013-08-04','15:25:00',6.33),('9650','2013-08-04','15:30:00',6.32),('9650','2013-08-04','15:35:00',6.27),('9650','2013-08-04','15:40:00',6.24),('9650','2013-08-04','15:45:00',6.22),('9650','2013-08-04','15:50:00',6.16),('9650','2013-08-04','15:55:00',6.02),('9650','2013-08-04','16:00:00',6.03),('9650','2013-08-04','16:05:00',5.98),('9650','2013-08-04','16:10:00',5.95),('9650','2013-08-04','16:15:00',5.88),('9650','2013-08-04','16:20:00',5.79),('9650','2013-08-04','16:25:00',5.7),('9650','2013-08-04','16:30:00',5.64),('9650','2013-08-04','16:35:00',5.64),('9650','2013-08-04','16:40:00',5.55),('9650','2013-08-04','16:45:00',5.47),('9650','2013-08-04','16:50:00',5.38),('9650','2013-08-04','16:55:00',5.29),('9650','2013-08-04','17:00:00',5.21),('9650','2013-08-04','17:05:00',5.13),('9650','2013-08-04','17:10:00',4.99),('9650','2013-08-04','17:15:00',4.85),('9650','2013-08-04','17:20:00',4.74),('9650','2013-08-04','17:25:00',4.63),('9650','2013-08-04','17:30:00',4.52),('9650','2013-08-04','17:35:00',4.46),('9650','2013-08-04','17:40:00',4.38),('9650','2013-08-04','17:45:00',4.24),('9650','2013-08-04','17:50:00',4.09),('9650','2013-08-04','17:55:00',3.96),('9650','2013-08-04','18:00:00',3.82),('9650','2013-08-04','18:05:00',3.68),('9650','2013-08-04','18:10:00',3.5),('9650','2013-08-04','18:15:00',3.36),('9650','2013-08-04','18:20:00',3.21),('9650','2013-08-04','18:25:00',3.07),('9650','2013-08-04','18:30:00',2.96),('9650','2013-08-04','18:35:00',2.84),('9650','2013-08-04','18:40:00',2.68),('9650','2013-08-04','18:45:00',2.54),('9650','2013-08-04','18:50:00',2.39),('9650','2013-08-04','18:55:00',2.2),('9650','2013-08-04','19:00:00',2.01),('9650','2013-08-04','19:05:00',1.86),('9650','2013-08-04','19:10:00',1.67),('9650','2013-08-04','19:15:00',1.47),('9650','2013-08-04','19:20:00',1.24),('9650','2013-08-04','19:25:00',1.08),('9650','2013-08-03','08:30:00',1.02),('9650','2013-08-03','08:35:00',1.12),('9650','2013-08-03','08:40:00',1.28),('9650','2013-08-03','08:45:00',1.38),('9650','2013-08-03','08:50:00',1.54),('9650','2013-08-03','08:55:00',1.68),('9650','2013-08-03','09:00:00',1.8),('9650','2013-08-03','09:05:00',1.92),('9650','2013-08-03','09:10:00',2.03),('9650','2013-08-03','09:15:00',2.16),('9650','2013-08-03','09:20:00',2.27),('9650','2013-08-03','09:25:00',2.44),('9650','2013-08-03','09:30:00',2.58),('9650','2013-08-03','09:35:00',2.71),('9650','2013-08-03','09:40:00',2.85),('9650','2013-08-03','09:45:00',2.98),('9650','2013-08-03','09:50:00',3.12),('9650','2013-08-03','09:55:00',3.24),('9650','2013-08-03','10:00:00',3.35),('9650','2013-08-03','10:05:00',3.47),('9650','2013-08-03','10:10:00',3.59),('9650','2013-08-03','10:15:00',3.71),('9650','2013-08-03','10:20:00',3.82),('9650','2013-08-03','10:25:00',3.92),('9650','2013-08-03','10:30:00',4.04),('9650','2013-08-03','10:35:00',4.12),('9650','2013-08-03','10:40:00',4.21),('9650','2013-08-03','10:45:00',4.32),('9650','2013-08-03','10:50:00',4.4),('9650','2013-08-03','10:55:00',4.5),('9650','2013-08-03','11:00:00',4.59),('9650','2013-08-03','11:05:00',4.66),('9650','2013-08-03','11:10:00',4.74),('9650','2013-08-03','11:15:00',4.84),('9650','2013-08-03','11:20:00',4.91),('9650','2013-08-03','11:25:00',5.05),('9650','2013-08-03','11:30:00',5.11),('9650','2013-08-03','11:35:00',5.19),('9650','2013-08-03','11:40:00',5.25),('9650','2013-08-03','11:45:00',5.38),('9650','2013-08-03','11:50:00',5.41),('9650','2013-08-03','11:55:00',5.48),('9650','2013-08-03','12:00:00',5.59),('9650','2013-08-03','12:05:00',5.57),('9650','2013-08-03','12:10:00',5.66),('9650','2013-08-03','12:15:00',5.79),('9650','2013-08-03','12:20:00',5.79),('9650','2013-08-03','12:25:00',5.86),('9650','2013-08-03','12:30:00',5.9),('9650','2013-08-03','12:35:00',5.92),('9650','2013-08-03','12:40:00',6.06),('9650','2013-08-03','12:45:00',6.07),('9650','2013-08-03','12:50:00',6.14),('9650','2013-08-03','12:55:00',6.17),('9650','2013-08-03','13:00:00',6.13),('9650','2013-08-03','13:05:00',6.1),('9650','2013-08-03','13:10:00',6.19),('9650','2013-08-03','13:15:00',6.2),('9650','2013-08-03','13:20:00',6.25),('9650','2013-08-03','13:25:00',6.32),('9650','2013-08-03','13:30:00',6.34),('9650','2013-08-03','13:35:00',6.48),('9650','2013-08-03','13:40:00',6.54),('9650','2013-08-03','13:45:00',6.57),('9650','2013-08-03','13:50:00',6.62),('9650','2013-08-03','13:55:00',6.61),('9650','2013-08-03','14:00:00',6.68),('9650','2013-08-03','14:05:00',6.69),('9650','2013-08-03','14:10:00',6.68),('9650','2013-08-03','14:15:00',6.66),('9650','2013-08-03','14:20:00',6.65),('9650','2013-08-03','14:25:00',6.69),('9650','2013-08-03','14:30:00',6.67),('9650','2013-08-03','14:35:00',6.67),('9650','2013-08-03','14:40:00',6.66),('9650','2013-08-03','14:45:00',6.67),('9650','2013-08-03','14:50:00',6.67),('9650','2013-08-03','14:55:00',6.67),('9650','2013-08-03','15:00:00',6.6),('9650','2013-08-03','15:05:00',6.65),('9650','2013-08-03','15:10:00',6.62),('9650','2013-08-03','15:15:00',6.59),('9650','2013-08-03','15:20:00',6.57),('9650','2013-08-03','15:25:00',6.51),('9650','2013-08-03','15:30:00',6.39),('9650','2013-08-03','15:35:00',6.5),('9650','2013-08-03','15:40:00',6.44),('9650','2013-08-03','15:45:00',6.34),('9650','2013-08-03','15:50:00',6.24),('9650','2013-08-03','15:55:00',6.24),('9650','2013-08-03','16:00:00',6.06),('9650','2013-08-03','16:05:00',6.15),('9650','2013-08-03','16:10:00',6.12),('9650','2013-08-03','16:15:00',6.07),('9650','2013-08-03','16:20:00',6.04),('9650','2013-08-03','16:25:00',5.94),('9650','2013-08-03','16:30:00',5.85),('9650','2013-08-03','16:35:00',5.8),('9650','2013-08-03','16:40:00',5.73),('9650','2013-08-03','16:45:00',5.65),('9650','2013-08-03','16:50:00',5.48),('9650','2013-08-03','16:55:00',5.45),('9650','2013-08-03','17:00:00',5.45),('9650','2013-08-03','17:05:00',5.39),('9650','2013-08-03','17:10:00',5.26),('9650','2013-08-03','17:15:00',5.15),('9650','2013-08-03','17:20:00',5.04),('9650','2013-08-03','17:25:00',4.89),('9650','2013-08-03','17:30:00',4.79),('9650','2013-08-03','17:35:00',4.68),('9650','2013-08-03','17:40:00',4.55),('9650','2013-08-03','17:45:00',4.46),('9650','2013-08-03','17:50:00',4.36),('9650','2013-08-03','17:55:00',4.19),('9650','2013-08-03','18:00:00',4.07),('9650','2013-08-03','18:05:00',3.9),('9650','2013-08-03','18:10:00',3.77),('9650','2013-08-03','18:15:00',3.63),('9650','2013-08-03','18:20:00',3.52),('9650','2013-08-03','18:25:00',3.34),('9650','2013-08-03','18:30:00',3.19),('9650','2013-08-03','18:35:00',3.02),('9650','2013-08-03','18:40:00',2.82),('9650','2013-08-03','18:45:00',2.55),('9650','2013-08-03','18:50:00',2.46),('9650','2013-08-03','18:55:00',2.29),('9650','2013-08-03','19:00:00',2.1),('9650','2013-08-03','19:05:00',1.48),('9650','2013-08-03','19:10:00',1.62),('9650','2013-08-03','19:15:00',1.44),('9650','2013-08-03','19:20:00',1.35),('9650','2013-08-03','19:25:00',1.19),('9650','2013-08-02','08:30:00',1.02),('9650','2013-08-02','08:35:00',1.08),('9650','2013-08-02','08:40:00',1.13),('9650','2013-08-02','08:45:00',1.16),('9650','2013-08-02','08:50:00',1.2),('9650','2013-08-02','08:55:00',1.21),('9650','2013-08-02','09:00:00',1.23),('9650','2013-08-02','09:05:00',1.45),('9650','2013-08-02','09:10:00',2.03),('9650','2013-08-02','09:15:00',2.14),('9650','2013-08-02','09:20:00',2.27),('9650','2013-08-02','09:25:00',2.42),('9650','2013-08-02','09:30:00',2.56),('9650','2013-08-02','09:35:00',2.7),('9650','2013-08-02','09:40:00',2.82),('9650','2013-08-02','09:45:00',2.96),('9650','2013-08-02','09:50:00',3.09),('9650','2013-08-02','09:55:00',3.2),('9650','2013-08-02','10:00:00',3.33),('9650','2013-08-02','10:05:00',3.44),('9650','2013-08-02','10:10:00',3.55),('9650','2013-08-02','10:15:00',3.66),('9650','2013-08-02','10:20:00',3.81),('9650','2013-08-02','10:25:00',3.92),('9650','2013-08-02','10:30:00',4.04),('9650','2013-08-02','10:35:00',4.13),('9650','2013-08-02','10:40:00',4.21),('9650','2013-08-02','10:45:00',4.35),('9650','2013-08-02','10:50:00',4.44),('9650','2013-08-02','10:55:00',4.53),('9650','2013-08-02','11:00:00',4.63),('9650','2013-08-02','11:05:00',4.72),('9650','2013-08-02','11:10:00',4.82),('9650','2013-08-02','11:15:00',4.88),('9650','2013-08-02','11:20:00',4.95),('9650','2013-08-02','11:25:00',5.01),('9650','2013-08-02','11:30:00',5.14),('9650','2013-08-02','11:35:00',5.19),('9650','2013-08-02','11:40:00',5.25),('9650','2013-08-02','11:45:00',5.32),('9650','2013-08-02','11:50:00',5.36),('9650','2013-08-02','11:55:00',5.47),('9650','2013-08-02','12:00:00',5.55),('9650','2013-08-02','12:05:00',5.63),('9650','2013-08-02','12:10:00',5.61),('9650','2013-08-02','12:15:00',5.65),('9650','2013-08-02','12:20:00',5.74),('9650','2013-08-02','12:25:00',5.76),('9650','2013-08-02','12:30:00',5.8),('9650','2013-08-02','12:35:00',5.89),('9650','2013-08-02','12:40:00',5.89),('9650','2013-08-02','12:45:00',5.95),('9650','2013-08-02','12:50:00',5.96),('9650','2013-08-02','12:55:00',5.97),('9650','2013-08-02','13:00:00',6),('9650','2013-08-02','13:05:00',6.13),('9650','2013-08-02','13:10:00',6.11),('9650','2013-08-02','13:15:00',6.12),('9650','2013-08-02','13:20:00',6.06),('9650','2013-08-02','13:25:00',6.03),('9650','2013-08-02','13:30:00',6.06),('9650','2013-08-02','13:35:00',6.15),('9650','2013-08-02','13:40:00',6.31),('9650','2013-08-02','13:45:00',6.33),('9650','2013-08-02','13:50:00',6.26),('9650','2013-08-02','13:55:00',6.27),('9650','2013-08-02','14:00:00',6.33),('9650','2013-08-02','14:05:00',6.28),('9650','2013-08-02','14:10:00',6.32),('9650','2013-08-02','14:15:00',6.21),('9650','2013-08-02','14:20:00',6.31),('9650','2013-08-02','14:25:00',6.3),('9650','2013-08-02','14:30:00',6.37),('9650','2013-08-02','14:35:00',6.52),('9650','2013-08-02','14:40:00',6.57),('9650','2013-08-02','14:45:00',6.53),('9650','2013-08-02','14:50:00',6.59),('9650','2013-08-02','14:55:00',6.62),('9650','2013-08-02','15:00:00',6.57),('9650','2013-08-02','15:05:00',6.54),('9650','2013-08-02','15:10:00',6.52),('9650','2013-08-02','15:15:00',6.48),('9650','2013-08-02','15:20:00',6.42),('9650','2013-08-02','15:25:00',6.46),('9650','2013-08-02','15:30:00',6.48),('9650','2013-08-02','15:35:00',6.42),('9650','2013-08-02','15:40:00',6.39),('9650','2013-08-02','15:45:00',6.37),('9650','2013-08-02','15:50:00',6.36),('9650','2013-08-02','15:55:00',6.23),('9650','2013-08-02','16:00:00',6.17),('9650','2013-08-02','16:05:00',6),('9650','2013-08-02','16:10:00',5.96),('9650','2013-08-02','16:15:00',5.85),('9650','2013-08-02','16:20:00',5.81),('9650','2013-08-02','16:25:00',5.77),('9650','2013-08-02','16:30:00',5.75),('9650','2013-08-02','16:35:00',5.69),('9650','2013-08-02','16:40:00',5.63),('9650','2013-08-02','16:45:00',5.56),('9650','2013-08-02','16:50:00',5.54),('9650','2013-08-02','16:55:00',5.46),('9650','2013-08-02','17:00:00',5.38),('9650','2013-08-02','17:05:00',5.24),('9650','2013-08-02','17:10:00',5.15),('9650','2013-08-02','17:15:00',5.03),('9650','2013-08-02','17:20:00',4.94),('9650','2013-08-02','17:25:00',4.83),('9650','2013-08-02','17:30:00',4.77),('9650','2013-08-02','17:35:00',4.69),('9650','2013-08-02','17:40:00',4.56),('9650','2013-08-02','17:45:00',4.44),('9650','2013-08-02','17:50:00',4.33),('9650','2013-08-02','17:55:00',4.2),('9650','2013-08-02','18:00:00',4.09),('9650','2013-08-02','18:05:00',3.95),('9650','2013-08-02','18:10:00',3.83),('9650','2013-08-02','18:15:00',3.69),('9650','2013-08-02','18:20:00',3.58),('9650','2013-08-02','18:25:00',3.44),('9650','2013-08-02','18:30:00',3.32),('9650','2013-08-02','18:35:00',3.18),('9650','2013-08-02','18:40:00',3.03),('9650','2013-08-02','18:45:00',2.89),('9650','2013-08-02','18:50:00',2.72),('9650','2013-08-02','18:55:00',2.56),('9650','2013-08-02','19:00:00',2.4),('9650','2013-08-02','19:05:00',2.24),('9650','2013-08-02','19:10:00',2.05),('9650','2013-08-02','19:15:00',1.87),('9650','2013-08-02','19:20:00',1.72),('9650','2013-08-02','19:25:00',1.54),('9650','2013-08-02','19:30:00',1.36),('9650','2013-08-02','19:35:00',1.18),('9650','2013-08-01','08:30:00',1.03),('9650','2013-08-01','08:35:00',1.16),('9650','2013-08-01','08:40:00',1.31),('9650','2013-08-01','08:45:00',1.45),('9650','2013-08-01','08:50:00',1.53),('9650','2013-08-01','08:55:00',1.72),('9650','2013-08-01','09:00:00',1.85),('9650','2013-08-01','09:05:00',1.97),('9650','2013-08-01','09:10:00',2.1),('9650','2013-08-01','09:15:00',2.22),('9650','2013-08-01','09:20:00',2.35),('9650','2013-08-01','09:25:00',2.51),('9650','2013-08-01','09:30:00',2.64),('9650','2013-08-01','09:35:00',2.78),('9650','2013-08-01','09:40:00',2.9),('9650','2013-08-01','09:45:00',3.06),('9650','2013-08-01','09:50:00',3.16),('9650','2013-08-01','09:55:00',3.29),('9650','2013-08-01','10:00:00',3.43),('9650','2013-08-01','10:05:00',3.54),('9650','2013-08-01','10:10:00',3.65),('9650','2013-08-01','10:15:00',3.76),('9650','2013-08-01','10:20:00',3.86),('9650','2013-08-01','10:25:00',3.98),('9650','2013-08-01','10:30:00',4.09),('9650','2013-08-01','10:35:00',4.2),('9650','2013-08-01','10:40:00',4.31),('9650','2013-08-01','10:45:00',4.42),('9650','2013-08-01','10:50:00',4.51),('9650','2013-08-01','10:55:00',4.58),('9650','2013-08-01','11:00:00',4.7),('9650','2013-08-01','11:05:00',4.8),('9650','2013-08-01','11:10:00',4.89),('9650','2013-08-01','11:15:00',4.97),('9650','2013-08-01','11:20:00',5.07),('9650','2013-08-01','11:25:00',5.17),('9650','2013-08-01','11:30:00',5.27),('9650','2013-08-01','11:35:00',5.32),('9650','2013-08-01','11:40:00',5.39),('9650','2013-08-01','11:45:00',5.43),('9650','2013-08-01','11:50:00',5.39),('9650','2013-08-01','11:55:00',5.63),('9650','2013-08-01','12:00:00',5.7),('9650','2013-08-01','12:05:00',5.71),('9650','2013-08-01','12:10:00',5.79),('9650','2013-08-01','12:15:00',5.89),('9650','2013-08-01','12:20:00',5.94),('9650','2013-08-01','12:25:00',5.98),('9650','2013-08-01','12:30:00',6),('9650','2013-08-01','12:35:00',6.03),('9650','2013-08-01','12:40:00',6.06),('9650','2013-08-01','12:45:00',6.11),('9650','2013-08-01','12:50:00',6.16),('9650','2013-08-01','12:55:00',6.19),('9650','2013-08-01','13:00:00',6.21),('9650','2013-08-01','13:05:00',6.28),('9650','2013-08-01','13:10:00',6.35),('9650','2013-08-01','13:15:00',6.39),('9650','2013-08-01','13:20:00',6.38),('9650','2013-08-01','13:25:00',6.41),('9650','2013-08-01','13:30:00',6.41),('9650','2013-08-01','13:35:00',6.51),('9650','2013-08-01','13:40:00',6.56),('9650','2013-08-01','13:45:00',6.57),('9650','2013-08-01','13:50:00',6.59),('9650','2013-08-01','13:55:00',6.59),('9650','2013-08-01','14:00:00',6.63),('9650','2013-08-01','14:05:00',6.66),('9650','2013-08-01','14:10:00',6.6),('9650','2013-08-01','14:15:00',6.56),('9650','2013-08-01','14:20:00',6.54),('9650','2013-08-01','14:25:00',6.51),('9650','2013-08-01','14:30:00',6.58),('9650','2013-08-01','14:35:00',6.71),('9650','2013-08-01','14:40:00',6.72),('9650','2013-08-01','14:45:00',6.75),('9650','2013-08-01','14:50:00',6.71),('9650','2013-08-01','14:55:00',6.71),('9650','2013-08-01','15:00:00',6.67),('9650','2013-08-01','15:05:00',6.66),('9650','2013-08-01','15:10:00',6.6),('9650','2013-08-01','15:15:00',6.54),('9650','2013-08-01','15:20:00',6.58),('9650','2013-08-01','15:25:00',6.6),('9650','2013-08-01','15:30:00',6.55),('9650','2013-08-01','15:35:00',6.52),('9650','2013-08-01','15:40:00',6.44),('9650','2013-08-01','15:45:00',6.45),('9650','2013-08-01','15:50:00',6.37),('9650','2013-08-01','15:55:00',6.31),('9650','2013-08-01','16:00:00',6.3),('9650','2013-08-01','16:05:00',6.24),('9650','2013-08-01','16:10:00',6.15),('9650','2013-08-01','16:15:00',6.12),('9650','2013-08-01','16:20:00',6.06),('9650','2013-08-01','16:25:00',6),('9650','2013-08-01','16:30:00',5.97),('9650','2013-08-01','16:35:00',5.92),('9650','2013-08-01','16:40:00',5.84),('9650','2013-08-01','16:45:00',5.78),('9650','2013-08-01','16:50:00',5.7),('9650','2013-08-01','16:55:00',5.59),('9650','2013-08-01','17:00:00',5.46),('9650','2013-08-01','17:05:00',5.37),('9650','2013-08-01','17:10:00',5.3),('9650','2013-08-01','17:15:00',5.26),('9650','2013-08-01','17:20:00',5.15),('9650','2013-08-01','17:25:00',5.03),('9650','2013-08-01','17:30:00',4.87),('9650','2013-08-01','17:35:00',4.79),('9650','2013-08-01','17:40:00',4.72),('9650','2013-08-01','17:45:00',4.57),('9650','2013-08-01','17:50:00',4.41),('9650','2013-08-01','17:55:00',4.27),('9650','2013-08-01','18:00:00',4.15),('9650','2013-08-01','18:05:00',4.06),('9650','2013-08-01','18:10:00',3.96),('9650','2013-08-01','18:15:00',3.82),('9650','2013-08-01','18:20:00',3.69),('9650','2013-08-01','18:25:00',3.55),('9650','2013-08-01','18:30:00',3.41),('9650','2013-08-01','18:35:00',3.25),('9650','2013-08-01','18:40:00',3.05),('9650','2013-08-01','18:45:00',2.9),('9650','2013-08-01','18:50:00',2.75),('9650','2013-08-01','18:55:00',2.63),('9650','2013-08-01','19:00:00',2.47),('9650','2013-08-01','19:05:00',2.32),('9650','2013-08-01','19:10:00',2.14),('9650','2013-08-01','19:15:00',1.95),('9650','2013-08-01','19:20:00',1.8),('9650','2013-08-01','19:25:00',1.62),('9650','2013-08-01','19:30:00',1.39),('9650','2013-08-01','19:35:00',1.26),('9650','2013-08-01','19:40:00',1.08),('9650','2013-07-31','08:30:00',1.06),('9650','2013-07-31','08:35:00',1.15),('9650','2013-07-31','08:40:00',1.29),('9650','2013-07-31','08:45:00',1.45),('9650','2013-07-31','08:50:00',1.58),('9650','2013-07-31','08:55:00',1.75),('9650','2013-07-31','09:00:00',1.88),('9650','2013-07-31','09:05:00',2.01),('9650','2013-07-31','09:10:00',2.13),('9650','2013-07-31','09:15:00',2.25),('9650','2013-07-31','09:20:00',2.4),('9650','2013-07-31','09:25:00',2.56),('9650','2013-07-31','09:30:00',2.7),('9650','2013-07-31','09:35:00',2.86),('9650','2013-07-31','09:40:00',2.99),('9650','2013-07-31','09:45:00',3.14),('9650','2013-07-31','09:50:00',3.26),('9650','2013-07-31','09:55:00',3.4),('9650','2013-07-31','10:00:00',3.52),('9650','2013-07-31','10:05:00',3.63),('9650','2013-07-31','10:10:00',3.76),('9650','2013-07-31','10:15:00',3.86),('9650','2013-07-31','10:20:00',3.95),('9650','2013-07-31','10:25:00',4.08),('9650','2013-07-31','10:30:00',4.22),('9650','2013-07-31','10:35:00',4.32),('9650','2013-07-31','10:40:00',4.42),('9650','2013-07-31','10:45:00',4.52),('9650','2013-07-31','10:50:00',4.65),('9650','2013-07-31','10:55:00',4.74),('9650','2013-07-31','11:00:00',4.84),('9650','2013-07-31','11:05:00',4.95),('9650','2013-07-31','11:10:00',5.04),('9650','2013-07-31','11:15:00',5.12),('9650','2013-07-31','11:20:00',5.22),('9650','2013-07-31','11:25:00',5.29),('9650','2013-07-31','11:30:00',5.36),('9650','2013-07-31','11:35:00',5.45),('9650','2013-07-31','11:40:00',5.6),('9650','2013-07-31','11:45:00',5.68),('9650','2013-07-31','11:50:00',5.76),('9650','2013-07-31','11:55:00',5.83),('9650','2013-07-31','12:00:00',5.87),('9650','2013-07-31','12:05:00',5.95),('9650','2013-07-31','12:10:00',5.99),('9650','2013-07-31','12:15:00',6.06),('9650','2013-07-31','12:20:00',6.13),('9650','2013-07-31','12:25:00',6.21),('9650','2013-07-31','12:30:00',6.24),('9650','2013-07-31','12:35:00',6.3),('9650','2013-07-31','12:40:00',6.38),('9650','2013-07-31','12:45:00',6.43),('9650','2013-07-31','12:50:00',6.52),('9650','2013-07-31','12:55:00',6.55),('9650','2013-07-31','13:00:00',6.54),('9650','2013-07-31','13:05:00',6.55),('9650','2013-07-31','13:10:00',6.64),('9650','2013-07-31','13:15:00',6.22),('9650','2013-07-31','13:20:00',6.75),('9650','2013-07-31','13:25:00',6.76),('9650','2013-07-31','13:30:00',6.7),('9650','2013-07-31','13:35:00',6.84),('9650','2013-07-31','13:40:00',6.84),('9650','2013-07-31','13:45:00',7),('9650','2013-07-31','13:50:00',6.85),('9650','2013-07-31','13:55:00',6.7),('9650','2013-07-31','14:00:00',6.44),('9650','2013-07-31','14:05:00',6.93),('9650','2013-07-31','14:10:00',6.83),('9650','2013-07-31','14:15:00',6.73),('9650','2013-07-31','14:20:00',6.6),('9650','2013-07-31','14:25:00',6.81),('9650','2013-07-31','14:30:00',6.81),('9650','2013-07-31','14:35:00',5.58),('9650','2013-07-31','14:40:00',6.33),('9650','2013-07-31','14:45:00',6.96),('9650','2013-07-31','14:50:00',5.18),('9650','2013-07-31','14:55:00',6.9),('9650','2013-07-31','15:00:00',6.79),('9650','2013-07-31','15:05:00',6.84),('9650','2013-07-31','15:10:00',6.9),('9650','2013-07-31','15:15:00',6.69),('9650','2013-07-31','15:20:00',6.85),('9650','2013-07-31','15:25:00',6.8),('9650','2013-07-31','15:30:00',6.72),('9650','2013-07-31','15:35:00',6.78),('9650','2013-07-31','15:40:00',4.86),('9650','2013-07-31','15:45:00',6.66),('9650','2013-07-31','15:50:00',6.53),('9650','2013-07-31','15:55:00',6.51),('9650','2013-07-31','16:00:00',6.52),('9650','2013-07-31','16:05:00',6.48),('9650','2013-07-31','16:10:00',6.33),('9650','2013-07-31','16:15:00',6.22),('9650','2013-07-31','16:20:00',6.19),('9650','2013-07-31','16:25:00',6.16),('9650','2013-07-31','16:30:00',6.05),('9650','2013-07-31','16:35:00',6.03),('9650','2013-07-31','16:40:00',6),('9650','2013-07-31','16:45:00',5.91),('9650','2013-07-31','16:50:00',5.83),('9650','2013-07-31','16:55:00',5.74),('9650','2013-07-31','17:00:00',5.66),('9650','2013-07-31','17:05:00',5.56),('9650','2013-07-31','17:10:00',5.48),('9650','2013-07-31','17:15:00',5.37),('9650','2013-07-31','17:20:00',5.26),('9650','2013-07-31','17:25:00',5.1),('9650','2013-07-31','17:30:00',5.05),('9650','2013-07-31','17:35:00',4.95),('9650','2013-07-31','17:40:00',4.83),('9650','2013-07-31','17:45:00',4.74),('9650','2013-07-31','17:50:00',4.61),('9650','2013-07-31','17:55:00',4.54),('9650','2013-07-31','18:00:00',4.42),('9650','2013-07-31','18:05:00',4.29),('9650','2013-07-31','18:10:00',4.17),('9650','2013-07-31','18:15:00',4.04),('9650','2013-07-31','18:20:00',3.93),('9650','2013-07-31','18:25:00',3.79),('9650','2013-07-31','18:30:00',3.64),('9650','2013-07-31','18:35:00',3.5),('9650','2013-07-31','18:40:00',3.35),('9650','2013-07-31','18:45:00',3.18),('9650','2013-07-31','18:50:00',3.03),('9650','2013-07-31','18:55:00',2.87),('9650','2013-07-31','19:00:00',2.7),('9650','2013-07-31','19:05:00',2.52),('9650','2013-07-31','19:10:00',2.32),('9650','2013-07-31','19:15:00',2.15),('9650','2013-07-31','19:20:00',2),('9650','2013-07-31','19:25:00',1.81),('9650','2013-07-31','19:30:00',1.6),('9650','2013-07-31','19:35:00',1.41),('9650','2013-07-31','19:40:00',1.23),('9650','2013-07-31','19:45:00',1.05),('9650','2013-07-30','08:30:00',1.05),('9650','2013-07-30','08:35:00',1.12),('9650','2013-07-30','08:40:00',1.16),('9650','2013-07-30','08:45:00',1.19),('9650','2013-07-30','08:50:00',1.22),('9650','2013-07-30','08:55:00',1.3),('9650','2013-07-30','09:00:00',1.91),('9650','2013-07-30','09:05:00',2.04),('9650','2013-07-30','09:10:00',2.17),('9650','2013-07-30','09:15:00',2.29),('9650','2013-07-30','09:20:00',2.44),('9650','2013-07-30','09:25:00',2.6),('9650','2013-07-30','09:30:00',2.72),('9650','2013-07-30','09:35:00',2.9),('9650','2013-07-30','09:40:00',3.02),('9650','2013-07-30','09:45:00',3.17),('9650','2013-07-30','09:50:00',3.31),('9650','2013-07-30','09:55:00',3.44),('9650','2013-07-30','10:00:00',3.56),('9650','2013-07-30','10:05:00',3.69),('9650','2013-07-30','10:10:00',3.77),('9650','2013-07-30','10:15:00',3.91),('9650','2013-07-30','10:20:00',4.01),('9650','2013-07-30','10:25:00',4.1),('9650','2013-07-30','10:30:00',4.24),('9650','2013-07-30','10:35:00',4.36),('9650','2013-07-30','10:40:00',4.5),('9650','2013-07-30','10:45:00',4.62),('9650','2013-07-30','10:50:00',4.73),('9650','2013-07-30','10:55:00',4.83),('9650','2013-07-30','11:00:00',4.95),('9650','2013-07-30','11:05:00',5.03),('9650','2013-07-30','11:10:00',5.13),('9650','2013-07-30','11:15:00',5.25),('9650','2013-07-30','11:20:00',5.32),('9650','2013-07-30','11:25:00',5.42),('9650','2013-07-30','11:30:00',5.49),('9650','2013-07-30','11:35:00',5.59),('9650','2013-07-30','11:40:00',5.67),('9650','2013-07-30','11:45:00',5.79),('9650','2013-07-30','11:50:00',5.88),('9650','2013-07-30','11:55:00',5.95),('9650','2013-07-30','12:00:00',5.93),('9650','2013-07-30','12:05:00',6.04),('9650','2013-07-30','12:10:00',6.15),('9650','2013-07-30','12:15:00',6.3),('9650','2013-07-30','12:20:00',6.3),('9650','2013-07-30','12:25:00',6.48),('9650','2013-07-30','12:30:00',6.44),('9650','2013-07-30','12:35:00',6.46),('9650','2013-07-30','12:40:00',6.62),('9650','2013-07-30','12:45:00',6.24),('9650','2013-07-30','12:50:00',3.3),('9650','2013-07-30','12:55:00',6.92),('9650','2013-07-30','13:00:00',2.74),('9650','2013-07-30','13:05:00',5.85),('9650','2013-07-30','13:10:00',6.58),('9650','2013-07-30','13:15:00',6.99),('9650','2013-07-30','13:20:00',6.59),('9650','2013-07-30','13:25:00',6.75),('9650','2013-07-30','13:30:00',6.55),('9650','2013-07-30','13:35:00',6.96),('9650','2013-07-30','13:40:00',7.01),('9650','2013-07-30','13:45:00',7.15),('9650','2013-07-30','13:50:00',7.28),('9650','2013-07-30','13:55:00',4.15),('9650','2013-07-30','14:00:00',6.13),('9650','2013-07-30','14:05:00',7.24),('9650','2013-07-30','14:10:00',6.79),('9650','2013-07-30','14:15:00',6.39),('9650','2013-07-30','14:20:00',7.22),('9650','2013-07-30','14:25:00',6.74),('9650','2013-07-30','14:30:00',7.12),('9650','2013-07-30','14:35:00',7.04),('9650','2013-07-30','14:40:00',7.14),('9650','2013-07-30','14:45:00',7.02),('9650','2013-07-30','14:50:00',7.27),('9650','2013-07-30','14:55:00',4.8),('9650','2013-07-30','15:00:00',1.95),('9650','2013-07-30','15:05:00',6.54),('9650','2013-07-30','15:10:00',7.26),('9650','2013-07-30','15:15:00',5.6),('9650','2013-07-30','15:20:00',6.41),('9650','2013-07-30','15:25:00',7.01),('9650','2013-07-30','15:30:00',5.39),('9650','2013-07-30','15:35:00',6.23),('9650','2013-07-30','15:40:00',7.03),('9650','2013-07-30','15:45:00',6.45),('9650','2013-07-30','15:50:00',6.67),('9650','2013-07-30','15:55:00',6.54),('9650','2013-07-30','16:00:00',6.42),('9650','2013-07-30','16:05:00',6.44),('9650','2013-07-30','16:10:00',6.5),('9650','2013-07-30','16:15:00',6.34),('9650','2013-07-30','16:20:00',6.42),('9650','2013-07-30','16:25:00',6.47),('9650','2013-07-30','16:30:00',6.38),('9650','2013-07-30','16:35:00',6.06),('9650','2013-07-30','16:40:00',5.93),('9650','2013-07-30','16:45:00',5.84),('9650','2013-07-30','16:50:00',5.85),('9650','2013-07-30','16:55:00',5.77),('9650','2013-07-30','17:00:00',5.71),('9650','2013-07-30','17:05:00',5.61),('9650','2013-07-30','17:10:00',4.92),('9650','2013-07-30','17:15:00',5.39),('9650','2013-07-30','17:20:00',4.42),('9650','2013-07-30','17:25:00',5.17),('9650','2013-07-30','17:30:00',5),('9650','2013-07-30','17:35:00',4.66),('9650','2013-07-30','17:40:00',4.83),('9650','2013-07-30','17:45:00',4.67),('9650','2013-07-30','17:50:00',4.57),('9650','2013-07-30','17:55:00',4.44),('9650','2013-07-30','18:00:00',4.34),('9650','2013-07-30','18:05:00',4.24),('9650','2013-07-30','18:10:00',4.07),('9650','2013-07-30','18:15:00',4.03),('9650','2013-07-30','18:20:00',3.92),('9650','2013-07-30','18:25:00',3.85),('9650','2013-07-30','18:30:00',3.72),('9650','2013-07-30','18:35:00',3.6),('9650','2013-07-30','18:40:00',3.46),('9650','2013-07-30','18:45:00',3.31),('9650','2013-07-30','18:50:00',3.16),('9650','2013-07-30','18:55:00',3),('9650','2013-07-30','19:00:00',2.84),('9650','2013-07-30','19:05:00',2.67),('9650','2013-07-30','19:10:00',2.49),('9650','2013-07-30','19:15:00',2.29),('9650','2013-07-30','19:20:00',2.1),('9650','2013-07-30','19:25:00',1.9),('9650','2013-07-30','19:30:00',1.7),('9650','2013-07-30','19:35:00',1.46),('9650','2013-07-30','19:40:00',1.31),('9650','2013-07-30','19:45:00',1.08),('9650','2014-04-07','08:10:00',1.01),('9650','2014-04-07','08:15:00',1.01),('9650','2014-04-07','08:20:00',1.06),('9650','2014-04-07','08:55:00',1.07),('9650','2014-04-07','09:00:00',1.14),('9650','2014-04-07','09:05:00',1.27),('9650','2014-04-07','09:10:00',1.38),('9650','2014-04-07','09:15:00',1.49),('9650','2014-04-07','09:20:00',1.62),('9650','2014-04-07','09:25:00',1.76),('9650','2014-04-07','09:30:00',1.88),('9650','2014-04-07','09:35:00',2),('9650','2014-04-07','09:40:00',2.09),('9650','2014-04-07','09:45:00',2.21),('9650','2014-04-07','09:50:00',2.33),('9650','2014-04-07','09:55:00',2.44),('9650','2014-04-07','10:00:00',2.54),('9650','2014-04-07','10:05:00',2.59),('9650','2014-04-07','10:10:00',2.76),('9650','2014-04-07','10:15:00',3.01),('9650','2014-04-07','10:20:00',3.13),('9650','2014-04-07','10:25:00',3.25),('9650','2014-04-07','10:30:00',3.41),('9650','2014-04-07','10:35:00',3.51),('9650','2014-04-07','10:40:00',3.5),('9650','2014-04-07','10:45:00',3.7),('9650','2014-04-07','10:50:00',3.81),('9650','2014-04-07','10:55:00',3.92),('9650','2014-04-07','11:00:00',4.03),('9650','2014-04-07','11:05:00',4.16),('9650','2014-04-07','11:10:00',4.34),('9650','2014-04-07','11:15:00',3.94),('9650','2014-04-07','11:20:00',4.52),('9650','2014-04-07','11:25:00',4.58),('9650','2014-04-07','11:30:00',4.63),('9650','2014-04-07','11:35:00',4.52),('9650','2014-04-07','11:40:00',4.85),('9650','2014-04-07','11:45:00',4.94),('9650','2014-04-07','11:50:00',4.99),('9650','2014-04-07','11:55:00',5.14),('9650','2014-04-07','12:00:00',5.25),('9650','2014-04-07','12:05:00',5.16),('9650','2014-04-07','12:10:00',5.15),('9650','2014-04-07','12:15:00',4.85),('9650','2014-04-07','12:20:00',5.02),('9650','2014-04-07','12:25:00',5.08),('9650','2014-04-07','12:30:00',5.92),('9650','2014-04-07','12:35:00',5.98),('9650','2014-04-07','12:40:00',4.95),('9650','2014-04-07','12:45:00',4.01),('9650','2014-04-07','12:50:00',5.15),('9650','2014-04-07','12:55:00',5.88),('9650','2014-04-07','13:00:00',5.52),('9650','2014-04-07','13:05:00',5.89),('9650','2014-04-07','13:10:00',5.78),('9650','2014-04-07','13:15:00',6.22),('9650','2014-04-07','13:20:00',6.23),('9650','2014-04-07','13:25:00',6.32),('9650','2014-04-07','13:30:00',6.38),('9650','2014-04-07','13:35:00',6.44),('9650','2014-04-07','13:40:00',6.44),('9650','2014-04-07','13:45:00',6.33),('9650','2014-04-07','13:50:00',6.44),('9650','2014-04-07','13:55:00',6.54),('9650','2014-04-07','14:00:00',6.53),('9650','2014-04-07','14:05:00',6.52),('9650','2014-04-07','14:10:00',6.56),('9650','2014-04-07','14:15:00',6.51),('9650','2014-04-07','14:20:00',6.17),('9650','2014-04-07','14:25:00',6.16),('9650','2014-04-07','14:30:00',6.67),('9650','2014-04-07','14:35:00',6.36),('9650','2014-04-07','14:40:00',5.83),('9650','2014-04-07','14:45:00',5.7),('9650','2014-04-07','14:50:00',6.34),('9650','2014-04-07','14:55:00',6.64),('9650','2014-04-07','15:00:00',6.53),('9650','2014-04-07','15:05:00',6.34),('9650','2014-04-07','15:10:00',6.19),('9650','2014-04-07','15:15:00',6.24),('9650','2014-04-07','15:20:00',6.12),('9650','2014-04-07','15:25:00',6.03),('9650','2014-04-07','15:30:00',5.55),('9650','2014-04-07','15:35:00',5.98),('9650','2014-04-07','15:40:00',5.96),('9650','2014-04-07','15:45:00',5.68),('9650','2014-04-07','15:50:00',5.8),('9650','2014-04-07','15:55:00',5.75),('9650','2014-04-07','16:00:00',5.47),('9650','2014-04-07','16:05:00',5.38),('9650','2014-04-07','16:10:00',5.3),('9650','2014-04-07','16:15:00',5.04),('9650','2014-04-07','16:20:00',4.7),('9650','2014-04-07','16:25:00',5.15),('9650','2014-04-07','16:30:00',5.45),('9650','2014-04-07','16:35:00',5.25),('9650','2014-04-07','16:40:00',4.83),('9650','2014-04-07','16:45:00',4.58),('9650','2014-04-07','16:50:00',4.71),('9650','2014-04-07','16:55:00',4.39),('9650','2014-04-07','17:00:00',4.15),('9650','2014-04-07','17:05:00',4.37),('9650','2014-04-07','17:10:00',4.15),('9650','2014-04-07','17:15:00',4.05),('9650','2014-04-07','17:20:00',3.97),('9650','2014-04-07','17:25:00',3.62),('9650','2014-04-07','17:30:00',3.47),('9650','2014-04-07','17:35:00',3.23),('9650','2014-04-07','17:40:00',3.34),('9650','2014-04-07','17:45:00',3.27),('9650','2014-04-07','17:50:00',3.17),('9650','2014-04-07','17:55:00',2.89),('9650','2014-04-07','18:00:00',2.91),('9650','2014-04-07','18:05:00',2.87),('9650','2014-04-07','18:10:00',2.68),('9650','2014-04-07','18:15:00',2.59),('9650','2014-04-07','18:20:00',2.31),('9650','2014-04-07','18:25:00',1.86),('9650','2014-04-07','18:30:00',1.55),('9650','2014-04-07','18:35:00',1.35),('9650','2014-04-07','18:40:00',1.02),('9650','2013-07-29','07:25:00',1.08),('9650','2013-07-29','08:10:00',1.05),('9650','2013-07-29','08:15:00',1.15),('9650','2013-07-29','08:20:00',1.42),('9650','2013-07-29','08:25:00',1.31),('9650','2013-07-29','08:30:00',1.3),('9650','2013-07-29','08:35:00',1.34),('9650','2013-07-29','08:40:00',1.48),('9650','2013-07-29','08:45:00',1.58),('9650','2013-07-29','08:50:00',1.73),('9650','2013-07-29','08:55:00',1.91),('9650','2013-07-29','09:00:00',2.09),('9650','2013-07-29','09:05:00',2.19),('9650','2013-07-29','09:10:00',2.3),('9650','2013-07-29','09:15:00',2.57),('9650','2013-07-29','09:20:00',2.82),('9650','2013-07-29','09:25:00',2.85),('9650','2013-07-29','09:30:00',2.81),('9650','2013-07-29','09:35:00',3.08),('9650','2013-07-29','09:40:00',3.09),('9650','2013-07-29','09:45:00',2.8),('9650','2013-07-29','09:50:00',3.3),('9650','2013-07-29','09:55:00',3.69),('9650','2013-07-29','10:00:00',3.44),('9650','2013-07-29','10:05:00',2.79),('9650','2013-07-29','10:10:00',4.19),('9650','2013-07-29','10:15:00',4.22),('9650','2013-07-29','10:20:00',4.33),('9650','2013-07-29','10:25:00',4.59),('9650','2013-07-29','10:30:00',4.63),('9650','2013-07-29','10:35:00',4.65),('9650','2013-07-29','10:40:00',4.65),('9650','2013-07-29','10:45:00',4.79),('9650','2013-07-29','10:50:00',4.75),('9650','2013-07-29','10:55:00',4.36),('9650','2013-07-29','11:00:00',4.61),('9650','2013-07-29','11:05:00',5.12),('9650','2013-07-29','11:10:00',5.29),('9650','2013-07-29','11:15:00',4.73),('9650','2013-07-29','11:20:00',2),('9650','2013-07-29','11:25:00',1.03),('9650','2013-07-29','11:30:00',3.4),('9650','2013-07-29','11:35:00',5.6),('9650','2013-07-29','11:40:00',5.95),('9650','2013-07-29','11:45:00',5.85),('9650','2013-07-29','11:50:00',4.33),('9650','2013-07-29','11:55:00',5.71),('9650','2013-07-29','12:00:00',5.87),('9650','2013-07-29','12:05:00',6.07),('9650','2013-07-29','12:10:00',5.93),('9650','2013-07-29','12:15:00',6.02),('9650','2013-07-29','12:20:00',6.18),('9650','2013-07-29','12:25:00',6.25),('9650','2013-07-29','12:30:00',6.36),('9650','2013-07-29','12:35:00',5.6),('9650','2013-07-29','12:40:00',1.37),('9650','2013-07-29','12:45:00',4.13),('9650','2013-07-29','12:50:00',7.12),('9650','2013-07-29','12:55:00',7.24),('9650','2013-07-29','13:00:00',4.8),('9650','2013-07-29','13:05:00',4.69),('9650','2013-07-29','13:10:00',7.19),('9650','2013-07-29','13:15:00',4.35),('9650','2013-07-29','13:20:00',6.38),('9650','2013-07-29','13:25:00',7.14),('9650','2013-07-29','13:30:00',7.29),('9650','2013-07-29','13:35:00',7.16),('9650','2013-07-29','13:40:00',7.13),('9650','2013-07-29','13:45:00',7.04),('9650','2013-07-29','13:50:00',7.02),('9650','2013-07-29','13:55:00',7.02),('9650','2013-07-29','14:00:00',7.1),('9650','2013-07-29','14:05:00',4.11),('9650','2013-07-29','14:10:00',3.37),('9650','2013-07-29','14:15:00',6.57),('9650','2013-07-29','14:20:00',7.13),('9650','2013-07-29','14:25:00',7.03),('9650','2013-07-29','14:30:00',7.02),('9650','2013-07-29','14:35:00',7.01),('9650','2013-07-29','14:40:00',6.88),('9650','2013-07-29','14:45:00',6.15),('9650','2013-07-29','14:50:00',6.99),('9650','2013-07-29','14:55:00',6.76),('9650','2013-07-29','15:00:00',6.9),('9650','2013-07-29','15:05:00',6.77),('9650','2013-07-29','15:10:00',6.61),('9650','2013-07-29','15:15:00',6.59),('9650','2013-07-29','15:20:00',6.49),('9650','2013-07-29','15:25:00',6.53),('9650','2013-07-29','15:30:00',6.63),('9650','2013-07-29','15:35:00',6.53),('9650','2013-07-29','15:40:00',6.47),('9650','2013-07-29','15:45:00',6.47),('9650','2013-07-29','15:50:00',6.41),('9650','2013-07-29','15:55:00',6.33),('9650','2013-07-29','16:00:00',6.33),('9650','2013-07-29','16:05:00',6.26),('9650','2013-07-29','16:10:00',6.18),('9650','2013-07-29','16:15:00',6.14),('9650','2013-07-29','16:20:00',6.11),('9650','2013-07-29','16:25:00',6.05),('9650','2013-07-29','16:30:00',5.94),('9650','2013-07-29','16:35:00',5.92),('9650','2013-07-29','16:40:00',5.9),('9650','2013-07-29','16:45:00',5.81),('9650','2013-07-29','16:50:00',5.71),('9650','2013-07-29','16:55:00',5.65),('9650','2013-07-29','17:00:00',5.55),('9650','2013-07-29','17:05:00',5.49),('9650','2013-07-29','17:10:00',5.35),('9650','2013-07-29','17:15:00',5.28),('9650','2013-07-29','17:20:00',5.22),('9650','2013-07-29','17:25:00',5.15),('9650','2013-07-29','17:30:00',5.02),('9650','2013-07-29','17:35:00',4.87),('9650','2013-07-29','17:40:00',4.79),('9650','2013-07-29','17:45:00',4.67),('9650','2013-07-29','17:50:00',4.5),('9650','2013-07-29','17:55:00',4.32),('9650','2013-07-29','18:00:00',4.23),('9650','2013-07-29','18:05:00',4.1),('9650','2013-07-29','18:10:00',3.98),('9650','2013-07-29','18:15:00',3.84),('9650','2013-07-29','18:20:00',3.75),('9650','2013-07-29','18:25:00',3.63),('9650','2013-07-29','18:30:00',3.44),('9650','2013-07-29','18:35:00',3.23),('9650','2013-07-29','18:40:00',3.1),('9650','2013-07-29','18:45:00',2.95),('9650','2013-07-29','18:50:00',2.71),('9650','2013-07-29','18:55:00',2.52),('9650','2013-07-29','19:00:00',2.43),('9650','2013-07-29','19:05:00',2.28),('9650','2013-07-29','19:10:00',2.08),('9650','2013-07-29','19:15:00',1.87),('9650','2013-07-29','19:20:00',1.7),('9650','2013-07-29','19:25:00',1.52),('9650','2013-07-29','19:30:00',1.31),('9650','2013-07-29','19:35:00',1.1),('9650','2013-07-28','08:15:00',1.06),('9650','2013-07-28','08:20:00',1.13),('9650','2013-07-28','08:25:00',1.21),('9650','2013-07-28','08:30:00',1.28),('9650','2013-07-28','08:35:00',1.36),('9650','2013-07-28','08:40:00',1.45),('9650','2013-07-28','08:45:00',1.58),('9650','2013-07-28','08:50:00',1.66),('9650','2013-07-28','08:55:00',1.8),('9650','2013-07-28','09:00:00',1.94),('9650','2013-07-28','09:05:00',2.06),('9650','2013-07-28','09:10:00',2.14),('9650','2013-07-28','09:15:00',2.25),('9650','2013-07-28','09:20:00',2.38),('9650','2013-07-28','09:25:00',2.48),('9650','2013-07-28','09:30:00',2.58),('9650','2013-07-28','09:35:00',2.72),('9650','2013-07-28','09:40:00',2.86),('9650','2013-07-28','09:45:00',3.03),('9650','2013-07-28','09:50:00',3.16),('9650','2013-07-28','09:55:00',3.27),('9650','2013-07-28','10:00:00',3.4),('9650','2013-07-28','10:05:00',3.52),('9650','2013-07-28','10:10:00',3.64),('9650','2013-07-28','10:15:00',3.74),('9650','2013-07-28','10:20:00',3.87),('9650','2013-07-28','10:25:00',4),('9650','2013-07-28','10:30:00',4.06),('9650','2013-07-28','10:35:00',4.14),('9650','2013-07-28','10:40:00',4.25),('9650','2013-07-28','10:45:00',4.38),('9650','2013-07-28','10:50:00',4.45),('9650','2013-07-28','10:55:00',4.53),('9650','2013-07-28','11:00:00',4.64),('9650','2013-07-28','11:05:00',4.73),('9650','2013-07-28','11:10:00',4.85),('9650','2013-07-28','11:15:00',4.91),('9650','2013-07-28','11:20:00',5.02),('9650','2013-07-28','11:25:00',5.08),('9650','2013-07-28','11:30:00',5.12),('9650','2013-07-28','11:35:00',5.16),('9650','2013-07-28','11:40:00',5.21),('9650','2013-07-28','11:45:00',5.3),('9650','2013-07-28','11:50:00',5.35),('9650','2013-07-28','11:55:00',5.37),('9650','2013-07-28','12:00:00',5.45),('9650','2013-07-28','12:05:00',5.55),('9650','2013-07-28','12:10:00',5.67),('9650','2013-07-28','12:15:00',5.71),('9650','2013-07-28','12:20:00',5.78),('9650','2013-07-28','12:25:00',5.83),('9650','2013-07-28','12:30:00',5.89),('9650','2013-07-28','12:35:00',5.92),('9650','2013-07-28','12:40:00',5.99),('9650','2013-07-28','12:45:00',6.02),('9650','2013-07-28','12:50:00',6.08),('9650','2013-07-28','12:55:00',5.97),('9650','2013-07-28','13:00:00',6.15),('9650','2013-07-28','13:05:00',6.16),('9650','2013-07-28','13:10:00',6.25),('9650','2013-07-28','13:15:00',6.31),('9650','2013-07-28','13:20:00',6.45),('9650','2013-07-28','13:25:00',6.49),('9650','2013-07-28','13:30:00',6.56),('9650','2013-07-28','13:35:00',6.58),('9650','2013-07-28','13:40:00',6.61),('9650','2013-07-28','13:45:00',6.68),('9650','2013-07-28','13:50:00',6.71),('9650','2013-07-28','13:55:00',6.72),('9650','2013-07-28','14:00:00',6.73),('9650','2013-07-28','14:05:00',6.73),('9650','2013-07-28','14:10:00',6.75),('9650','2013-07-28','14:15:00',6.75),('9650','2013-07-28','14:20:00',6.74),('9650','2013-07-28','14:25:00',6.73),('9650','2013-07-28','14:30:00',6.76),('9650','2013-07-28','14:35:00',6.76),('9650','2013-07-28','14:40:00',6.75),('9650','2013-07-28','14:45:00',6.72),('9650','2013-07-28','14:50:00',6.69),('9650','2013-07-28','14:55:00',6.7),('9650','2013-07-28','15:00:00',6.69),('9650','2013-07-28','15:05:00',6.67),('9650','2013-07-28','15:10:00',6.68),('9650','2013-07-28','15:15:00',6.65),('9650','2013-07-28','15:20:00',6.63),('9650','2013-07-28','15:25:00',6.63),('9650','2013-07-28','15:30:00',6.62),('9650','2013-07-28','15:35:00',6.63),('9650','2013-07-28','15:40:00',6.79),('9650','2013-07-28','15:45:00',6.94),('9650','2013-07-28','15:50:00',5.55),('9650','2013-07-28','15:55:00',3.84),('9650','2013-07-28','16:00:00',3.61),('9650','2013-07-28','16:05:00',5.53),('9650','2013-07-28','16:10:00',5.87),('9650','2013-07-28','16:15:00',4.73),('9650','2013-07-28','16:20:00',5.18),('9650','2013-07-28','16:25:00',4.92),('9650','2013-07-28','16:30:00',6.31),('9650','2013-07-28','16:35:00',5.42),('9650','2013-07-28','16:40:00',5.1),('9650','2013-07-28','16:45:00',6.28),('9650','2013-07-28','16:50:00',5.74),('9650','2013-07-28','16:55:00',4.07),('9650','2013-07-28','17:00:00',3.04),('9650','2013-07-28','17:05:00',4.42),('9650','2013-07-28','17:10:00',3.08),('9650','2013-07-28','17:15:00',2.39),('9650','2013-07-28','17:20:00',4.98),('9650','2013-07-28','17:25:00',4.88),('9650','2013-07-28','17:30:00',3.18),('9650','2013-07-28','17:35:00',2.01),('9650','2013-07-28','17:40:00',2.83),('9650','2013-07-28','17:45:00',4.72),('9650','2013-07-28','17:50:00',4.41),('9650','2013-07-28','17:55:00',4.13),('9650','2013-07-28','18:00:00',2.98),('9650','2013-07-28','18:05:00',2.27),('9650','2013-07-28','18:10:00',3.53),('9650','2013-07-28','18:15:00',2.91),('9650','2013-07-28','18:20:00',3.51),('9650','2013-07-28','18:25:00',3.34),('9650','2013-07-28','18:30:00',3.26),('9650','2013-07-28','18:35:00',2.95),('9650','2013-07-28','18:40:00',2.16),('9650','2013-07-28','18:45:00',1.17),('9650','2013-07-28','18:50:00',2.01),('9650','2013-07-28','18:55:00',2),('9650','2013-07-28','19:00:00',2.66),('9650','2013-07-28','19:05:00',2.52),('9650','2013-07-28','19:10:00',1.71),('9650','2013-07-27','08:20:00',1.05),('9650','2013-07-27','08:25:00',1.09),('9650','2013-07-27','08:30:00',1.13),('9650','2013-07-27','08:35:00',1.17),('9650','2013-07-27','08:40:00',1.19),('9650','2013-07-27','08:45:00',1.21),('9650','2013-07-27','08:50:00',1.22),('9650','2013-07-27','08:55:00',1.25),('9650','2013-07-27','09:00:00',1.74),('9650','2013-07-27','09:05:00',2.07),('9650','2013-07-27','09:10:00',2.19),('9650','2013-07-27','09:15:00',2.3),('9650','2013-07-27','09:20:00',2.44),('9650','2013-07-27','09:25:00',2.58),('9650','2013-07-27','09:30:00',2.67),('9650','2013-07-27','09:35:00',2.77),('9650','2013-07-27','09:40:00',2.93),('9650','2013-07-27','09:45:00',3.03),('9650','2013-07-27','09:50:00',3.18),('9650','2013-07-27','09:55:00',3.3),('9650','2013-07-27','10:00:00',3.42),('9650','2013-07-27','10:05:00',3.55),('9650','2013-07-27','10:10:00',3.68),('9650','2013-07-27','10:15:00',3.8),('9650','2013-07-27','10:20:00',3.89),('9650','2013-07-27','10:25:00',3.98),('9650','2013-07-27','10:30:00',4.04),('9650','2013-07-27','10:35:00',4.19),('9650','2013-07-27','10:40:00',4.31),('9650','2013-07-27','10:45:00',4.41),('9650','2013-07-27','10:50:00',4.52),('9650','2013-07-27','10:55:00',4.58),('9650','2013-07-27','11:00:00',4.66),('9650','2013-07-27','11:05:00',4.79),('9650','2013-07-27','11:10:00',4.81),('9650','2013-07-27','11:15:00',4.89),('9650','2013-07-27','11:20:00',4.99),('9650','2013-07-27','11:25:00',5.05),('9650','2013-07-27','11:30:00',5.13),('9650','2013-07-27','11:35:00',5.15),('9650','2013-07-27','11:40:00',5.24),('9650','2013-07-27','11:45:00',5.35),('9650','2013-07-27','11:50:00',5.43),('9650','2013-07-27','11:55:00',5.46),('9650','2013-07-27','12:00:00',5.53),('9650','2013-07-27','12:05:00',5.59),('9650','2013-07-27','12:10:00',5.62),('9650','2013-07-27','12:15:00',5.52),('9650','2013-07-27','12:20:00',5.72),('9650','2013-07-27','12:25:00',5.75),('9650','2013-07-27','12:30:00',5.93),('9650','2013-07-27','12:35:00',5.97),('9650','2013-07-27','12:40:00',6.08),('9650','2013-07-27','12:45:00',5.92),('9650','2013-07-27','12:50:00',6.03),('9650','2013-07-27','12:55:00',6.03),('9650','2013-07-27','13:00:00',5.94),('9650','2013-07-27','13:05:00',6.11),('9650','2013-07-27','13:10:00',6.35),('9650','2013-07-27','13:15:00',6.08),('9650','2013-07-27','13:20:00',6.23),('9650','2013-07-27','13:25:00',6.35),('9650','2013-07-27','13:30:00',6.42),('9650','2013-07-27','13:35:00',6.57),('9650','2013-07-27','13:40:00',6.52),('9650','2013-07-27','13:45:00',6.73),('9650','2013-07-27','13:50:00',6.72),('9650','2013-07-27','13:55:00',6.67),('9650','2013-07-27','14:00:00',6.67),('9650','2013-07-27','14:05:00',6.69),('9650','2013-07-27','14:10:00',6.7),('9650','2013-07-27','14:15:00',6.69),('9650','2013-07-27','14:20:00',6.69),('9650','2013-07-27','14:25:00',6.68),('9650','2013-07-27','14:30:00',6.74),('9650','2013-07-27','14:35:00',6.69),('9650','2013-07-27','14:40:00',6.66),('9650','2013-07-27','14:45:00',6.7),('9650','2013-07-27','14:50:00',6.64),('9650','2013-07-27','14:55:00',6.65),('9650','2013-07-27','15:00:00',6.68),('9650','2013-07-27','15:05:00',6.69),('9650','2013-07-27','15:10:00',6.66),('9650','2013-07-27','15:15:00',6.54),('9650','2013-07-27','15:20:00',6.49),('9650','2013-07-27','15:25:00',6.53),('9650','2013-07-27','15:30:00',6.49),('9650','2013-07-27','15:35:00',6.46),('9650','2013-07-27','15:40:00',6.51),('9650','2013-07-27','15:45:00',6.38),('9650','2013-07-27','15:50:00',6.35),('9650','2013-07-27','15:55:00',6.3),('9650','2013-07-27','16:00:00',6.27),('9650','2013-07-27','16:05:00',6.24),('9650','2013-07-27','16:10:00',6.17),('9650','2013-07-27','16:15:00',6.18),('9650','2013-07-27','16:20:00',6.14),('9650','2013-07-27','16:25:00',6.11),('9650','2013-07-27','16:30:00',6.05),('9650','2013-07-27','16:35:00',5.97),('9650','2013-07-27','16:40:00',5.89),('9650','2013-07-27','16:45:00',5.84),('9650','2013-07-27','16:50:00',5.76),('9650','2013-07-27','16:55:00',5.7),('9650','2013-07-27','17:00:00',5.61),('9650','2013-07-27','17:05:00',5.52),('9650','2013-07-27','17:10:00',5.4),('9650','2013-07-27','17:15:00',5.35),('9650','2013-07-27','17:20:00',5.25),('9650','2013-07-27','17:25:00',5.13),('9650','2013-07-27','17:30:00',5),('9650','2013-07-27','17:35:00',4.91),('9650','2013-07-27','17:40:00',4.83),('9650','2013-07-27','17:45:00',4.75),('9650','2013-07-27','17:50:00',4.63),('9650','2013-07-27','17:55:00',4.49),('9650','2013-07-27','18:00:00',4.29),('9650','2013-07-27','18:05:00',4.19),('9650','2013-07-27','18:10:00',4.04),('9650','2013-07-27','18:15:00',3.95),('9650','2013-07-27','18:20:00',3.84),('9650','2013-07-27','18:25:00',3.71),('9650','2013-07-27','18:30:00',3.55),('9650','2013-07-27','18:35:00',3.38),('9650','2013-07-27','18:40:00',3.21),('9650','2013-07-27','18:45:00',3.02),('9650','2013-07-27','18:50:00',2.87),('9650','2013-07-27','18:55:00',2.69),('9650','2013-07-27','19:00:00',2.52),('9650','2013-07-27','19:05:00',2.34),('9650','2013-07-27','19:10:00',2.16),('9650','2013-07-27','19:15:00',1.97),('9650','2013-07-27','19:20:00',1.74),('9650','2013-07-27','19:25:00',1.55),('9650','2013-07-27','19:30:00',1.4),('9650','2013-07-27','19:35:00',1.21),('9650','2013-07-27','19:40:00',1.01),('9650','2013-07-26','08:15:00',1.05),('9650','2013-07-26','08:20:00',1.12),('9650','2013-07-26','08:25:00',1.2),('9650','2013-07-26','08:30:00',1.3),('9650','2013-07-26','08:35:00',1.4),('9650','2013-07-26','08:40:00',1.52),('9650','2013-07-26','08:45:00',1.62),('9650','2013-07-26','08:50:00',1.73),('9650','2013-07-26','08:55:00',1.88),('9650','2013-07-26','09:00:00',2.01),('9650','2013-07-26','09:05:00',2.12),('9650','2013-07-26','09:10:00',2.25),('9650','2013-07-26','09:15:00',2.35),('9650','2013-07-26','09:20:00',2.5),('9650','2013-07-26','09:25:00',2.61),('9650','2013-07-26','09:30:00',2.75),('9650','2013-07-26','09:35:00',2.88),('9650','2013-07-26','09:40:00',3),('9650','2013-07-26','09:45:00',3.15),('9650','2013-07-26','09:50:00',3.28),('9650','2013-07-26','09:55:00',3.39),('9650','2013-07-26','10:00:00',3.56),('9650','2013-07-26','10:05:00',3.66),('9650','2013-07-26','10:10:00',3.79),('9650','2013-07-26','10:15:00',3.86),('9650','2013-07-26','10:20:00',3.97),('9650','2013-07-26','10:25:00',4.05),('9650','2013-07-26','10:30:00',4.15),('9650','2013-07-26','10:35:00',4.3),('9650','2013-07-26','10:40:00',4.32),('9650','2013-07-26','10:45:00',4.46),('9650','2013-07-26','10:50:00',4.6),('9650','2013-07-26','10:55:00',4.66),('9650','2013-07-26','11:00:00',4.7),('9650','2013-07-26','11:05:00',4.81),('9650','2013-07-26','11:10:00',4.97),('9650','2013-07-26','11:15:00',5.13),('9650','2013-07-26','11:20:00',5.19),('9650','2013-07-26','11:25:00',5.24),('9650','2013-07-26','11:30:00',5.29),('9650','2013-07-26','11:35:00',5.33),('9650','2013-07-26','11:40:00',5.36),('9650','2013-07-26','11:45:00',5.46),('9650','2013-07-26','11:50:00',5.6),('9650','2013-07-26','11:55:00',5.65),('9650','2013-07-26','12:00:00',5.59),('9650','2013-07-26','12:05:00',5.7),('9650','2013-07-26','12:10:00',5.78),('9650','2013-07-26','12:15:00',5.82),('9650','2013-07-26','12:20:00',5.82),('9650','2013-07-26','12:25:00',5.81),('9650','2013-07-26','12:30:00',5.93),('9650','2013-07-26','12:35:00',5.82),('9650','2013-07-26','12:40:00',5.93),('9650','2013-07-26','12:45:00',5.9),('9650','2013-07-26','12:50:00',6.17),('9650','2013-07-26','12:55:00',6.39),('9650','2013-07-26','13:00:00',6.36),('9650','2013-07-26','13:05:00',2.25),('9650','2013-07-26','13:10:00',3.9),('9650','2013-07-26','13:15:00',6.23),('9650','2013-07-26','13:20:00',6.53),('9650','2013-07-26','13:25:00',6.48),('9650','2013-07-26','13:30:00',6.51),('9650','2013-07-26','13:35:00',6.5),('9650','2013-07-26','13:40:00',6.57),('9650','2013-07-26','13:45:00',6.47),('9650','2013-07-26','13:50:00',6.55),('9650','2013-07-26','13:55:00',6.66),('9650','2013-07-26','14:00:00',6.62),('9650','2013-07-26','14:05:00',6.76),('9650','2013-07-26','14:10:00',6.8),('9650','2013-07-26','14:15:00',6.7),('9650','2013-07-26','14:20:00',6.64),('9650','2013-07-26','14:25:00',6.68),('9650','2013-07-26','14:30:00',6.6),('9650','2013-07-26','14:35:00',6.66),('9650','2013-07-26','14:40:00',6.64),('9650','2013-07-26','14:45:00',6.58),('9650','2013-07-26','14:50:00',6.71),('9650','2013-07-26','14:55:00',6.72),('9650','2013-07-26','15:00:00',6.65),('9650','2013-07-26','15:05:00',6.63),('9650','2013-07-26','15:10:00',6.65),('9650','2013-07-26','15:15:00',6.68),('9650','2013-07-26','15:20:00',6.64),('9650','2013-07-26','15:25:00',6.61),('9650','2013-07-26','15:30:00',6.59),('9650','2013-07-26','15:35:00',6.6),('9650','2013-07-26','15:40:00',6.52),('9650','2013-07-26','15:45:00',6.49),('9650','2013-07-26','15:50:00',6.43),('9650','2013-07-26','15:55:00',6.35),('9650','2013-07-26','16:00:00',6.33),('9650','2013-07-26','16:05:00',6.29),('9650','2013-07-26','16:10:00',6.23),('9650','2013-07-26','16:15:00',6.17),('9650','2013-07-26','16:20:00',6.12),('9650','2013-07-26','16:25:00',6.07),('9650','2013-07-26','16:30:00',6.08),('9650','2013-07-26','16:35:00',5.98),('9650','2013-07-26','16:40:00',5.94),('9650','2013-07-26','16:45:00',5.85),('9650','2013-07-26','16:50:00',5.78),('9650','2013-07-26','16:55:00',5.68),('9650','2013-07-26','17:00:00',5.47),('9650','2013-07-26','17:05:00',5.48),('9650','2013-07-26','17:10:00',5.42),('9650','2013-07-26','17:15:00',5.31),('9650','2013-07-26','17:20:00',5.26),('9650','2013-07-26','17:25:00',5.14),('9650','2013-07-26','17:30:00',5.03),('9650','2013-07-26','17:35:00',4.94),('9650','2013-07-26','17:40:00',4.81),('9650','2013-07-26','17:45:00',4.72),('9650','2013-07-26','17:50:00',4.62),('9650','2013-07-26','17:55:00',4.52),('9650','2013-07-26','18:00:00',4.42),('9650','2013-07-26','18:05:00',4.3),('9650','2013-07-26','18:10:00',4.18),('9650','2013-07-26','18:15:00',4.03),('9650','2013-07-26','18:20:00',3.9),('9650','2013-07-26','18:25:00',3.78),('9650','2013-07-26','18:30:00',3.66),('9650','2013-07-26','18:35:00',3.52),('9650','2013-07-26','18:40:00',3.34),('9650','2013-07-26','18:45:00',3.2),('9650','2013-07-26','18:50:00',3.02),('9650','2013-07-26','18:55:00',2.81),('9650','2013-07-26','19:00:00',2.7),('9650','2013-07-26','19:05:00',2.53),('9650','2013-07-26','19:10:00',2.37),('9650','2013-07-26','19:15:00',2.16),('9650','2013-07-26','19:20:00',1.93),('9650','2013-07-26','19:25:00',1.71),('9650','2013-07-26','19:30:00',1.49),('9650','2013-07-26','19:35:00',1.3),('9650','2013-07-26','19:40:00',1.15),('9650','2013-07-26','19:45:00',1.05),('9650','2013-07-25','08:05:00',1.01),('9650','2013-07-25','08:10:00',1.09),('9650','2013-07-25','08:15:00',1.15),('9650','2013-07-25','08:20:00',1.19),('9650','2013-07-25','08:25:00',1.28),('9650','2013-07-25','08:30:00',1.39),('9650','2013-07-25','08:35:00',1.51),('9650','2013-07-25','08:40:00',1.54),('9650','2013-07-25','08:45:00',1.71),('9650','2013-07-25','08:50:00',1.8),('9650','2013-07-25','08:55:00',1.97),('9650','2013-07-25','09:00:00',2.08),('9650','2013-07-25','09:05:00',2.17),('9650','2013-07-25','09:10:00',2.26),('9650','2013-07-25','09:15:00',2.35),('9650','2013-07-25','09:20:00',2.46),('9650','2013-07-25','09:25:00',2.62),('9650','2013-07-25','09:30:00',2.68),('9650','2013-07-25','09:35:00',2.73),('9650','2013-07-25','09:40:00',2.95),('9650','2013-07-25','09:45:00',3.09),('9650','2013-07-25','09:50:00',3.2),('9650','2013-07-25','09:55:00',3.4),('9650','2013-07-25','10:00:00',3.55),('9650','2013-07-25','10:05:00',3.67),('9650','2013-07-25','10:10:00',3.71),('9650','2013-07-25','10:15:00',3.76),('9650','2013-07-25','10:20:00',3.9),('9650','2013-07-25','10:25:00',4.01),('9650','2013-07-25','10:30:00',4.05),('9650','2013-07-25','10:35:00',4.23),('9650','2013-07-25','10:40:00',4.33),('9650','2013-07-25','10:45:00',4.47),('9650','2013-07-25','10:50:00',4.58),('9650','2013-07-25','10:55:00',4.55),('9650','2013-07-25','11:00:00',4.71),('9650','2013-07-25','11:05:00',4.48),('9650','2013-07-25','11:10:00',4.69),('9650','2013-07-25','11:15:00',5.1),('9650','2013-07-25','11:20:00',5.23),('9650','2013-07-25','11:25:00',4.96),('9650','2013-07-25','11:30:00',5.09),('9650','2013-07-25','11:35:00',5.25),('9650','2013-07-25','11:40:00',5.46),('9650','2013-07-25','11:45:00',5.48),('9650','2013-07-25','11:50:00',5.69),('9650','2013-07-25','11:55:00',5.74),('9650','2013-07-25','12:00:00',5.55),('9650','2013-07-25','12:05:00',5.71),('9650','2013-07-25','12:10:00',4.73),('9650','2013-07-25','12:15:00',4.6),('9650','2013-07-25','12:20:00',6.24),('9650','2013-07-25','12:25:00',6.09),('9650','2013-07-25','12:30:00',6.28),('9650','2013-07-25','12:35:00',6.3),('9650','2013-07-25','12:40:00',6.62),('9650','2013-07-25','12:45:00',6.63),('9650','2013-07-25','12:50:00',6.69),('9650','2013-07-25','12:55:00',3.96),('9650','2013-07-25','13:00:00',1.97),('9650','2013-07-25','13:05:00',1.89),('9650','2013-07-25','13:10:00',2.26),('9650','2013-07-25','13:15:00',6.45),('9650','2013-07-25','13:20:00',3.42),('9650','2013-07-25','13:25:00',4.55),('9650','2013-07-25','13:30:00',5.24),('9650','2013-07-25','13:35:00',6.86),('9650','2013-07-25','13:40:00',7),('9650','2013-07-25','13:45:00',7.12),('9650','2013-07-25','13:50:00',7.07),('9650','2013-07-25','13:55:00',6.79),('9650','2013-07-25','14:00:00',7),('9650','2013-07-25','14:05:00',6.88),('9650','2013-07-25','14:10:00',6.84),('9650','2013-07-25','14:15:00',6.95),('9650','2013-07-25','14:20:00',6.8),('9650','2013-07-25','14:25:00',6.79),('9650','2013-07-25','14:30:00',6.78),('9650','2013-07-25','14:35:00',6.84),('9650','2013-07-25','14:40:00',6.81),('9650','2013-07-25','14:45:00',6.83),('9650','2013-07-25','14:50:00',6.82),('9650','2013-07-25','14:55:00',6.78),('9650','2013-07-25','15:00:00',6.84),('9650','2013-07-25','15:05:00',6.81),('9650','2013-07-25','15:10:00',6.71),('9650','2013-07-25','15:15:00',6.64),('9650','2013-07-25','15:20:00',6.62),('9650','2013-07-25','15:25:00',6.59),('9650','2013-07-25','15:30:00',6.59),('9650','2013-07-25','15:35:00',6.64),('9650','2013-07-25','15:40:00',6.61),('9650','2013-07-25','15:45:00',6.61),('9650','2013-07-25','15:50:00',6.52),('9650','2013-07-25','15:55:00',6.45),('9650','2013-07-25','16:00:00',6.4),('9650','2013-07-25','16:05:00',6.36),('9650','2013-07-25','16:10:00',6.26),('9650','2013-07-25','16:15:00',6.21),('9650','2013-07-25','16:20:00',6.19),('9650','2013-07-25','16:25:00',6.15),('9650','2013-07-25','16:30:00',6.1),('9650','2013-07-25','16:35:00',5.98),('9650','2013-07-25','16:40:00',5.98),('9650','2013-07-25','16:45:00',5.96),('9650','2013-07-25','16:50:00',5.87),('9650','2013-07-25','16:55:00',5.72),('9650','2013-07-25','17:00:00',5.66),('9650','2013-07-25','17:05:00',5.56),('9650','2013-07-25','17:10:00',5.49),('9650','2013-07-25','17:15:00',5.3),('9650','2013-07-25','17:20:00',5.21),('9650','2013-07-25','17:25:00',5.13),('9650','2013-07-25','17:30:00',4.97),('9650','2013-07-25','17:35:00',4.84),('9650','2013-07-25','17:40:00',4.75),('9650','2013-07-25','17:45:00',4.62),('9650','2013-07-25','17:50:00',4.39),('9650','2013-07-25','17:55:00',4.23),('9650','2013-07-25','18:00:00',4.02),('9650','2013-07-25','18:05:00',4.02),('9650','2013-07-25','18:10:00',3.87),('9650','2013-07-25','18:15:00',3.64),('9650','2013-07-25','18:20:00',3.53),('9650','2013-07-25','18:25:00',3.52),('9650','2013-07-25','18:30:00',3.36),('9650','2013-07-25','18:35:00',3.2),('9650','2013-07-25','18:40:00',3.01),('9650','2013-07-25','18:45:00',2.84),('9650','2013-07-25','18:50:00',2.73),('9650','2013-07-25','18:55:00',2.53),('9650','2013-07-25','19:00:00',2.37),('9650','2013-07-25','19:05:00',2.21),('9650','2013-07-25','19:10:00',2.03),('9650','2013-07-25','19:15:00',1.84),('9650','2013-07-25','19:20:00',1.64),('9650','2013-07-25','19:25:00',1.48),('9650','2013-07-25','19:30:00',1.34),('9650','2013-07-25','19:35:00',1.18),('9650','2013-07-25','19:40:00',1.01),('9650','2013-07-24','08:10:00',1.05),('9650','2013-07-24','08:15:00',1.1),('9650','2013-07-24','08:20:00',1.14),('9650','2013-07-24','08:25:00',1.18),('9650','2013-07-24','08:30:00',1.2),('9650','2013-07-24','08:35:00',1.24),('9650','2013-07-24','08:40:00',1.26),('9650','2013-07-24','08:45:00',1.29),('9650','2013-07-24','08:50:00',1.81),('9650','2013-07-24','08:55:00',2),('9650','2013-07-24','09:00:00',2.05),('9650','2013-07-24','09:05:00',2.21),('9650','2013-07-24','09:10:00',2.43),('9650','2013-07-24','09:15:00',2.68),('9650','2013-07-24','09:20:00',2.43),('9650','2013-07-24','09:25:00',1.45),('9650','2013-07-24','09:30:00',1.92),('9650','2013-07-24','09:35:00',2.68),('9650','2013-07-24','09:40:00',2.18),('9650','2013-07-24','09:45:00',1.82),('9650','2013-07-24','09:50:00',1.79),('9650','2013-07-24','09:55:00',1.26),('9650','2013-07-24','10:00:00',2.54),('9650','2013-07-24','10:05:00',3.71),('9650','2013-07-24','10:10:00',3.89),('9650','2013-07-24','10:15:00',4.04),('9650','2013-07-24','10:20:00',4.19),('9650','2013-07-24','10:25:00',3.64),('9650','2013-07-24','10:30:00',2.89),('9650','2013-07-24','10:35:00',2.18),('9650','2013-07-24','10:40:00',1.95),('9650','2013-07-24','10:45:00',2.65),('9650','2013-07-24','10:50:00',4.98),('9650','2013-07-24','10:55:00',4.76),('9650','2013-07-24','11:00:00',5.06),('9650','2013-07-24','11:05:00',5.35),('9650','2013-07-24','11:10:00',5.01),('9650','2013-07-24','11:15:00',5.27),('9650','2013-07-24','11:20:00',5.27),('9650','2013-07-24','11:25:00',5.79),('9650','2013-07-24','11:30:00',5.75),('9650','2013-07-24','11:35:00',4.74),('9650','2013-07-24','11:40:00',4.88),('9650','2013-07-24','11:45:00',5.21),('9650','2013-07-24','11:50:00',4.31),('9650','2013-07-24','11:55:00',4.67),('9650','2013-07-24','12:00:00',6.12),('9650','2013-07-24','12:05:00',3.1),('9650','2013-07-24','12:10:00',4.5),('9650','2013-07-24','12:15:00',3.99),('9650','2013-07-24','12:20:00',4.61),('9650','2013-07-24','12:25:00',4.04),('9650','2013-07-24','12:30:00',5.77),('9650','2013-07-24','12:35:00',3.96),('9650','2013-07-24','12:40:00',2.79),('9650','2013-07-24','12:45:00',4.18),('9650','2013-07-24','12:50:00',4.57),('9650','2013-07-24','12:55:00',5.27),('9650','2013-07-24','13:00:00',7.07),('9650','2013-07-24','13:05:00',6.97),('9650','2013-07-24','13:10:00',6.73),('9650','2013-07-24','13:15:00',7.02),('9650','2013-07-24','13:20:00',6.86),('9650','2013-07-24','13:25:00',6.82),('9650','2013-07-24','13:30:00',6.79),('9650','2013-07-24','13:35:00',6.76),('9650','2013-07-24','13:40:00',6.92),('9650','2013-07-24','13:45:00',6.94),('9650','2013-07-24','13:50:00',7.09),('9650','2013-07-24','13:55:00',7),('9650','2013-07-24','14:00:00',6.99),('9650','2013-07-24','14:05:00',6.84),('9650','2013-07-24','14:10:00',7.11),('9650','2013-07-24','14:15:00',7.16),('9650','2013-07-24','14:20:00',7.14),('9650','2013-07-24','14:25:00',7.09),('9650','2013-07-24','14:30:00',7.12),('9650','2013-07-24','14:35:00',7.08),('9650','2013-07-24','14:40:00',7.07),('9650','2013-07-24','14:45:00',7.06),('9650','2013-07-24','14:50:00',7.08),('9650','2013-07-24','14:55:00',7.06),('9650','2013-07-24','15:00:00',7.1),('9650','2013-07-24','15:05:00',7.04),('9650','2013-07-24','15:10:00',6.84),('9650','2013-07-24','15:15:00',6.99),('9650','2013-07-24','15:20:00',7),('9650','2013-07-24','15:25:00',6.94),('9650','2013-07-24','15:30:00',6.9),('9650','2013-07-24','15:35:00',6.91),('9650','2013-07-24','15:40:00',6.91),('9650','2013-07-24','15:45:00',6.87),('9650','2013-07-24','15:50:00',6.79),('9650','2013-07-24','15:55:00',6.75),('9650','2013-07-24','16:00:00',6.72),('9650','2013-07-24','16:05:00',6.58),('9650','2013-07-24','16:10:00',6.58),('9650','2013-07-24','16:15:00',6.55),('9650','2013-07-24','16:20:00',6.47),('9650','2013-07-24','16:25:00',6.39),('9650','2013-07-24','16:30:00',6.31),('9650','2013-07-24','16:35:00',6.22),('9650','2013-07-24','16:40:00',6.26),('9650','2013-07-24','16:45:00',6.18),('9650','2013-07-24','16:50:00',6),('9650','2013-07-24','16:55:00',6.03),('9650','2013-07-24','17:00:00',5.94),('9650','2013-07-24','17:05:00',5.86),('9650','2013-07-24','17:10:00',5.71),('9650','2013-07-24','17:15:00',5.64),('9650','2013-07-24','17:20:00',5.54),('9650','2013-07-24','17:25:00',5.46),('9650','2013-07-24','17:30:00',5.37),('9650','2013-07-24','17:35:00',5.28),('9650','2013-07-24','17:40:00',5.14),('9650','2013-07-24','17:45:00',4.99),('9650','2013-07-24','17:50:00',4.86),('9650','2013-07-24','17:55:00',4.76),('9650','2013-07-24','18:00:00',4.63),('9650','2013-07-24','18:05:00',4.49),('9650','2013-07-24','18:10:00',4.39),('9650','2013-07-24','18:15:00',4.14),('9650','2013-07-24','18:20:00',4),('9650','2013-07-24','18:25:00',3.74),('9650','2013-07-24','18:30:00',3.73),('9650','2013-07-24','18:35:00',3.59),('9650','2013-07-24','18:40:00',3.45),('9650','2013-07-24','18:45:00',3.22),('9650','2013-07-24','18:50:00',3),('9650','2013-07-24','18:55:00',2.79),('9650','2013-07-24','19:00:00',2.71),('9650','2013-07-24','19:05:00',2.49),('9650','2013-07-24','19:10:00',2.34),('9650','2013-07-24','19:15:00',2.17),('9650','2013-07-24','19:20:00',1.92),('9650','2013-07-24','19:25:00',1.68),('9650','2013-07-24','19:30:00',1.48),('9650','2013-07-24','19:35:00',1.33),('9650','2013-07-24','19:40:00',1.1),('9650','2013-07-23','07:40:00',1.09),('9650','2013-07-23','07:45:00',1.08),('9650','2013-07-23','07:50:00',1.28),('9650','2013-07-23','07:55:00',1.3),('9650','2013-07-23','08:00:00',1.3),('9650','2013-07-23','08:05:00',1.3),('9650','2013-07-23','08:10:00',1.25),('9650','2013-07-23','08:15:00',1.37),('9650','2013-07-23','08:20:00',1.67),('9650','2013-07-23','08:25:00',1.63),('9650','2013-07-23','08:30:00',1.57),('9650','2013-07-23','08:35:00',1.55),('9650','2013-07-23','08:40:00',1.43),('9650','2013-07-23','08:45:00',1.75),('9650','2013-07-23','08:50:00',2.11),('9650','2013-07-23','08:55:00',2.16),('9650','2013-07-23','09:00:00',2.64),('9650','2013-07-23','09:05:00',2.25),('9650','2013-07-23','09:10:00',2.87),('9650','2013-07-23','09:15:00',2.48),('9650','2013-07-23','09:20:00',2.45),('9650','2013-07-23','09:25:00',2.18),('9650','2013-07-23','09:30:00',2.67),('9650','2013-07-23','09:35:00',2.55),('9650','2013-07-23','09:40:00',2.93),('9650','2013-07-23','09:45:00',2.78),('9650','2013-07-23','09:50:00',2.29),('9650','2013-07-23','09:55:00',2.32),('9650','2013-07-23','10:00:00',1.41),('9650','2013-07-23','10:05:00',1.23),('9650','2013-07-23','10:10:00',1.4),('9650','2013-07-23','10:15:00',1.76),('9650','2013-07-23','10:20:00',2.65),('9650','2013-07-23','10:25:00',4.56),('9650','2013-07-23','10:30:00',4.61),('9650','2013-07-23','10:35:00',5.02),('9650','2013-07-23','10:40:00',4.94),('9650','2013-07-23','10:45:00',2.47),('9650','2013-07-23','10:50:00',3.47),('9650','2013-07-23','10:55:00',3.32),('9650','2013-07-23','11:00:00',4.47),('9650','2013-07-23','11:05:00',2.89),('9650','2013-07-23','11:10:00',3.67),('9650','2013-07-23','11:15:00',5.61),('9650','2013-07-23','11:20:00',5.42),('9650','2013-07-23','11:25:00',5.1),('9650','2013-07-23','11:30:00',5.8),('9650','2013-07-23','11:35:00',5.4),('9650','2013-07-23','11:40:00',5.85),('9650','2013-07-23','11:45:00',5.95),('9650','2013-07-23','11:50:00',6.02),('9650','2013-07-23','11:55:00',6.06),('9650','2013-07-23','12:00:00',6.31),('9650','2013-07-23','12:05:00',6.32),('9650','2013-07-23','12:10:00',6.63),('9650','2013-07-23','12:15:00',6.74),('9650','2013-07-23','12:20:00',4.28),('9650','2013-07-23','12:25:00',3.12),('9650','2013-07-23','12:30:00',7.09),('9650','2013-07-23','12:35:00',3.02),('9650','2013-07-23','12:40:00',2.17),('9650','2013-07-23','12:45:00',4.84),('9650','2013-07-23','12:50:00',5.74),('9650','2013-07-23','12:55:00',7.21),('9650','2013-07-23','13:00:00',7.02),('9650','2013-07-23','13:05:00',6.97),('9650','2013-07-23','13:10:00',5.82),('9650','2013-07-23','13:15:00',2.63),('9650','2013-07-23','13:20:00',3.24),('9650','2013-07-23','13:25:00',3.33),('9650','2013-07-23','13:30:00',7.26),('9650','2013-07-23','13:35:00',6.05),('9650','2013-07-23','13:40:00',2.71),('9650','2013-07-23','13:45:00',4.95),('9650','2013-07-23','13:50:00',7.5),('9650','2013-07-23','13:55:00',7.3),('9650','2013-07-23','14:00:00',6.61),('9650','2013-07-23','14:05:00',7.32),('9650','2013-07-23','14:10:00',7.42),('9650','2013-07-23','14:15:00',7.14),('9650','2013-07-23','14:20:00',6.68),('9650','2013-07-23','14:25:00',7.44),('9650','2013-07-23','14:30:00',7.32),('9650','2013-07-23','14:35:00',7.66),('9650','2013-07-23','14:40:00',7.15),('9650','2013-07-23','14:45:00',7.29),('9650','2013-07-23','14:50:00',7.21),('9650','2013-07-23','14:55:00',7.18),('9650','2013-07-23','15:00:00',7.05),('9650','2013-07-23','15:05:00',7.06),('9650','2013-07-23','15:10:00',7.04),('9650','2013-07-23','15:15:00',7.09),('9650','2013-07-23','15:20:00',7.09),('9650','2013-07-23','15:25:00',7.09),('9650','2013-07-23','15:30:00',6.67),('9650','2013-07-23','15:35:00',6.69),('9650','2013-07-23','15:40:00',6.95),('9650','2013-07-23','15:45:00',6.76),('9650','2013-07-23','15:50:00',6.68),('9650','2013-07-23','15:55:00',6.7),('9650','2013-07-23','16:00:00',6.68),('9650','2013-07-23','16:05:00',6.47),('9650','2013-07-23','16:10:00',6.46),('9650','2013-07-23','16:15:00',6.58),('9650','2013-07-23','16:20:00',6.6),('9650','2013-07-23','16:25:00',6.57),('9650','2013-07-23','16:30:00',6.49),('9650','2013-07-23','16:35:00',6.42),('9650','2013-07-23','16:40:00',6.39),('9650','2013-07-23','16:45:00',6.13),('9650','2013-07-23','16:50:00',6.2),('9650','2013-07-23','16:55:00',6.35),('9650','2013-07-23','17:00:00',6.28),('9650','2013-07-23','17:05:00',6.08),('9650','2013-07-23','17:10:00',5.32),('9650','2013-07-23','17:15:00',5.67),('9650','2013-07-23','17:20:00',5.62),('9650','2013-07-23','17:25:00',5.44),('9650','2013-07-23','17:30:00',5.36),('9650','2013-07-23','17:35:00',5.1),('9650','2013-07-23','17:40:00',4.98),('9650','2013-07-23','17:45:00',4.85),('9650','2013-07-23','17:50:00',4.68),('9650','2013-07-23','17:55:00',4.52),('9650','2013-07-23','18:00:00',4.4),('9650','2013-07-23','18:05:00',4.18),('9650','2013-07-23','18:10:00',4.08),('9650','2013-07-23','18:15:00',3.82),('9650','2013-07-23','18:20:00',3.74),('9650','2013-07-23','18:25:00',3.71),('9650','2013-07-23','18:30:00',3.65),('9650','2013-07-23','18:35:00',3.48),('9650','2013-07-23','18:40:00',3.32),('9650','2013-07-23','18:45:00',3),('9650','2013-07-23','18:50:00',2.84),('9650','2013-07-23','18:55:00',2.42),('9650','2013-07-23','19:00:00',2.03),('9650','2013-07-23','19:05:00',2.43),('9650','2013-07-23','19:10:00',2.08),('9650','2013-07-23','19:15:00',1.8),('9650','2013-07-23','19:20:00',1.96),('9650','2013-07-23','19:25:00',1.71),('9650','2013-07-23','19:30:00',1.37),('9650','2013-07-23','19:35:00',1.01),('9650','2013-07-23','19:40:00',1.15),('9650','2013-07-23','19:45:00',1.04),('9650','2013-07-22','08:10:00',1.03),('9650','2013-07-22','08:15:00',1.09),('9650','2013-07-22','08:20:00',1.16),('9650','2013-07-22','08:25:00',1.25),('9650','2013-07-22','08:30:00',1.35),('9650','2013-07-22','08:35:00',1.5),('9650','2013-07-22','08:40:00',1.63),('9650','2013-07-22','08:45:00',1.78),('9650','2013-07-22','08:50:00',1.92),('9650','2013-07-22','08:55:00',2.07),('9650','2013-07-22','09:00:00',2.19),('9650','2013-07-22','09:05:00',2.29),('9650','2013-07-22','09:10:00',2.4),('9650','2013-07-22','09:15:00',2.52),('9650','2013-07-22','09:20:00',2.6),('9650','2013-07-22','09:25:00',2.76),('9650','2013-07-22','09:30:00',2.88),('9650','2013-07-22','09:35:00',3.01),('9650','2013-07-22','09:40:00',3.14),('9650','2013-07-22','09:45:00',3.23),('9650','2013-07-22','09:50:00',3.34),('9650','2013-07-22','09:55:00',3.49),('9650','2013-07-22','10:00:00',3.61),('9650','2013-07-22','10:05:00',3.73),('9650','2013-07-22','10:10:00',3.83),('9650','2013-07-22','10:15:00',3.93),('9650','2013-07-22','10:20:00',4.04),('9650','2013-07-22','10:25:00',4.16),('9650','2013-07-22','10:30:00',4.34),('9650','2013-07-22','10:35:00',4.47),('9650','2013-07-22','10:40:00',4.6),('9650','2013-07-22','10:45:00',4.66),('9650','2013-07-22','10:50:00',4.76),('9650','2013-07-22','10:55:00',4.91),('9650','2013-07-22','11:00:00',4.97),('9650','2013-07-22','11:05:00',5.05),('9650','2013-07-22','11:10:00',5.16),('9650','2013-07-22','11:15:00',5.27),('9650','2013-07-22','11:20:00',5.43),('9650','2013-07-22','11:25:00',5.47),('9650','2013-07-22','11:30:00',5.61),('9650','2013-07-22','11:35:00',5.65),('9650','2013-07-22','11:40:00',5.8),('9650','2013-07-22','11:45:00',5.8),('9650','2013-07-22','11:50:00',5.83),('9650','2013-07-22','11:55:00',6.03),('9650','2013-07-22','12:00:00',6.1),('9650','2013-07-22','12:05:00',6.22),('9650','2013-07-22','12:10:00',6.35),('9650','2013-07-22','12:15:00',6.41),('9650','2013-07-22','12:20:00',6.29),('9650','2013-07-22','12:25:00',6.45),('9650','2013-07-22','12:30:00',6.48),('9650','2013-07-22','12:35:00',4.95),('9650','2013-07-22','12:40:00',2.22),('9650','2013-07-22','12:45:00',3.67),('9650','2013-07-22','12:50:00',2.63),('9650','2013-07-22','12:55:00',6.57),('9650','2013-07-22','13:00:00',2.27),('9650','2013-07-22','13:05:00',1.69),('9650','2013-07-22','13:10:00',1.55),('9650','2013-07-22','13:15:00',1.18),('9650','2013-07-22','13:20:00',1.15),('9650','2013-07-22','13:25:00',1.45),('9650','2013-07-22','13:30:00',3.35),('9650','2013-07-22','13:35:00',7.57),('9650','2013-07-22','13:40:00',4.1),('9650','2013-07-22','13:45:00',1.17),('9650','2013-07-22','13:50:00',1.49),('9650','2013-07-22','13:55:00',3.65),('9650','2013-07-22','14:00:00',7.1),('9650','2013-07-22','14:05:00',6.28),('9650','2013-07-22','14:10:00',2.09),('9650','2013-07-22','14:20:00',1.08),('9650','2013-07-22','14:25:00',2.77),('9650','2013-07-22','14:30:00',2.52),('9650','2013-07-22','14:35:00',2.09),('9650','2013-07-22','14:40:00',3.03),('9650','2013-07-22','14:45:00',7.23),('9650','2013-07-22','14:50:00',3.7),('9650','2013-07-22','14:55:00',6.97),('9650','2013-07-22','15:00:00',8.26),('9650','2013-07-22','15:05:00',7.08),('9650','2013-07-22','15:10:00',6.86),('9650','2013-07-22','15:15:00',7.15),('9650','2013-07-22','15:20:00',6.96),('9650','2013-07-22','15:25:00',6.97),('9650','2013-07-22','15:30:00',6.82),('9650','2013-07-22','15:35:00',6.94),('9650','2013-07-22','15:40:00',6.64),('9650','2013-07-22','15:45:00',6.58),('9650','2013-07-22','15:50:00',6.66),('9650','2013-07-22','15:55:00',6.63),('9650','2013-07-22','16:00:00',6.61),('9650','2013-07-22','16:05:00',6.49),('9650','2013-07-22','16:10:00',6.44),('9650','2013-07-22','16:15:00',6.35),('9650','2013-07-22','16:20:00',6.37),('9650','2013-07-22','16:25:00',6.25),('9650','2013-07-22','16:30:00',6.24),('9650','2013-07-22','16:35:00',6.12),('9650','2013-07-22','16:40:00',6.07),('9650','2013-07-22','16:45:00',5.95),('9650','2013-07-22','16:50:00',5.92),('9650','2013-07-22','16:55:00',5.88),('9650','2013-07-22','17:00:00',5.77),('9650','2013-07-22','17:05:00',5.69),('9650','2013-07-22','17:10:00',5.61),('9650','2013-07-22','17:15:00',5.55),('9650','2013-07-22','17:20:00',5.47),('9650','2013-07-22','17:25:00',5.39),('9650','2013-07-22','17:30:00',5.25),('9650','2013-07-22','17:35:00',5.17),('9650','2013-07-22','17:40:00',5.05),('9650','2013-07-22','17:45:00',4.9),('9650','2013-07-22','17:50:00',4.78),('9650','2013-07-22','17:55:00',4.7),('9650','2013-07-22','18:00:00',4.6),('9650','2013-07-22','18:05:00',4.46),('9650','2013-07-22','18:10:00',4.34),('9650','2013-07-22','18:15:00',4.23),('9650','2013-07-22','18:20:00',4.15),('9650','2013-07-22','18:25:00',4.03),('9650','2013-07-22','18:30:00',3.88),('9650','2013-07-22','18:35:00',3.72),('9650','2013-07-22','18:40:00',2.85),('9650','2013-07-22','18:45:00',2.41),('9650','2013-07-22','18:50:00',2.23),('9650','2013-07-22','18:55:00',2.79),('9650','2013-07-22','19:00:00',2.71),('9650','2013-07-22','19:05:00',2.48),('9650','2013-07-22','19:10:00',2.33),('9650','2013-07-22','19:15:00',2.19),('9650','2013-07-22','19:20:00',2.01),('9650','2013-07-22','19:25:00',1.82),('9650','2013-07-22','19:30:00',1.65),('9650','2013-07-22','19:35:00',1.45),('9650','2013-07-22','19:40:00',1.19),('9650','2013-07-21','08:05:00',1),('9650','2013-07-21','08:10:00',1.07),('9650','2013-07-21','08:15:00',1.13),('9650','2013-07-21','08:20:00',1.17),('9650','2013-07-21','08:25:00',1.19),('9650','2013-07-21','08:30:00',1.24),('9650','2013-07-21','08:35:00',1.39),('9650','2013-07-21','08:40:00',1.68),('9650','2013-07-21','08:45:00',1.84),('9650','2013-07-21','08:50:00',1.98),('9650','2013-07-21','08:55:00',2.09),('9650','2013-07-21','09:00:00',2.21),('9650','2013-07-21','09:05:00',2.33),('9650','2013-07-21','09:10:00',2.45),('9650','2013-07-21','09:15:00',2.56),('9650','2013-07-21','09:20:00',2.68),('9650','2013-07-21','09:25:00',2.83),('9650','2013-07-21','09:30:00',2.96),('9650','2013-07-21','09:35:00',3.08),('9650','2013-07-21','09:40:00',3.21),('9650','2013-07-21','09:45:00',3.35),('9650','2013-07-21','09:50:00',3.47),('9650','2013-07-21','09:55:00',3.62),('9650','2013-07-21','10:00:00',3.76),('9650','2013-07-21','10:05:00',3.87),('9650','2013-07-21','10:10:00',3.97),('9650','2013-07-21','10:15:00',4.08),('9650','2013-07-21','10:20:00',4.17),('9650','2013-07-21','10:25:00',4.28),('9650','2013-07-21','10:30:00',4.38),('9650','2013-07-21','10:35:00',4.52),('9650','2013-07-21','10:40:00',4.62),('9650','2013-07-21','10:45:00',4.73),('9650','2013-07-21','10:50:00',4.81),('9650','2013-07-21','10:55:00',4.9),('9650','2013-07-21','11:00:00',5),('9650','2013-07-21','11:05:00',5.08),('9650','2013-07-21','11:10:00',5.19),('9650','2013-07-21','11:15:00',5.28),('9650','2013-07-21','11:20:00',5.36),('9650','2013-07-21','11:25:00',5.41),('9650','2013-07-21','11:30:00',5.47),('9650','2013-07-21','11:35:00',5.54),('9650','2013-07-21','11:40:00',5.66),('9650','2013-07-21','11:45:00',5.73),('9650','2013-07-21','11:50:00',5.79),('9650','2013-07-21','11:55:00',5.86),('9650','2013-07-21','12:00:00',5.91),('9650','2013-07-21','12:05:00',5.92),('9650','2013-07-21','12:10:00',5.99),('9650','2013-07-21','12:15:00',6.09),('9650','2013-07-21','12:20:00',6.19),('9650','2013-07-21','12:25:00',6.21),('9650','2013-07-21','12:30:00',6.27),('9650','2013-07-21','12:35:00',6.33),('9650','2013-07-21','12:40:00',6.39),('9650','2013-07-21','12:45:00',6.4),('9650','2013-07-21','12:50:00',6.46),('9650','2013-07-21','12:55:00',6.49),('9650','2013-07-21','13:00:00',6.52),('9650','2013-07-21','13:05:00',6.58),('9650','2013-07-21','13:10:00',6.62),('9650','2013-07-21','13:15:00',6.62),('9650','2013-07-21','13:20:00',6.69),('9650','2013-07-21','13:25:00',6.83),('9650','2013-07-21','13:30:00',6.76),('9650','2013-07-21','13:35:00',6.8),('9650','2013-07-21','13:40:00',6.88),('9650','2013-07-21','13:45:00',6.97),('9650','2013-07-21','13:50:00',6.91),('9650','2013-07-21','13:55:00',6.88),('9650','2013-07-21','14:00:00',6.83),('9650','2013-07-21','14:05:00',6.84),('9650','2013-07-21','14:10:00',6.89),('9650','2013-07-21','14:15:00',6.9),('9650','2013-07-21','14:20:00',6.95),('9650','2013-07-21','14:25:00',7.01),('9650','2013-07-21','14:30:00',6.98),('9650','2013-07-21','14:35:00',6.88),('9650','2013-07-21','14:40:00',6.89),('9650','2013-07-21','14:45:00',6.95),('9650','2013-07-21','14:50:00',6.97),('9650','2013-07-21','14:55:00',6.86),('9650','2013-07-21','15:00:00',6.84),('9650','2013-07-21','15:05:00',6.86),('9650','2013-07-21','15:10:00',6.94),('9650','2013-07-21','15:15:00',6.93),('9650','2013-07-21','15:20:00',6.92),('9650','2013-07-21','15:25:00',6.86),('9650','2013-07-21','15:30:00',1.78),('9650','2013-07-21','15:35:00',1.37),('9650','2013-07-21','15:40:00',1.93),('9650','2013-07-21','15:45:00',6.6),('9650','2013-07-21','15:50:00',7.08),('9650','2013-07-21','15:55:00',7.4),('9650','2013-07-21','16:00:00',7.32),('9650','2013-07-21','16:05:00',7.1),('9650','2013-07-21','16:10:00',5.2),('9650','2013-07-21','16:15:00',6.58),('9650','2013-07-21','16:20:00',6.9),('9650','2013-07-21','16:25:00',6.65),('9650','2013-07-21','16:30:00',6.43),('9650','2013-07-21','16:35:00',6.34),('9650','2013-07-21','16:40:00',6.01),('9650','2013-07-21','16:45:00',5.92),('9650','2013-07-21','16:50:00',5.83),('9650','2013-07-21','16:55:00',5.82),('9650','2013-07-21','17:00:00',5.76),('9650','2013-07-21','17:05:00',5.71),('9650','2013-07-21','17:10:00',5.59),('9650','2013-07-21','17:15:00',5.48),('9650','2013-07-21','17:20:00',5.39),('9650','2013-07-21','17:25:00',5.11),('9650','2013-07-21','17:30:00',4.93),('9650','2013-07-21','17:35:00',5.05),('9650','2013-07-21','17:40:00',4.92),('9650','2013-07-21','17:45:00',4.49),('9650','2013-07-21','17:50:00',4.44),('9650','2013-07-21','17:55:00',4.4),('9650','2013-07-21','18:00:00',4.48),('9650','2013-07-21','18:05:00',4.31),('9650','2013-07-21','18:10:00',4.02),('9650','2013-07-21','18:15:00',3.77),('9650','2013-07-21','18:20:00',3.67),('9650','2013-07-21','18:25:00',3.63),('9650','2013-07-21','18:30:00',3.44),('9650','2013-07-21','18:35:00',3.3),('9650','2013-07-21','18:40:00',3.02),('9650','2013-07-21','18:45:00',2.91),('9650','2013-07-21','18:50:00',2.74),('9650','2013-07-21','18:55:00',2.52),('9650','2013-07-21','19:00:00',1.92),('9650','2013-07-21','19:05:00',2.26),('9650','2013-07-21','19:10:00',2.28),('9650','2013-07-21','19:15:00',2.02),('9650','2013-07-21','19:20:00',1.68),('9650','2013-07-21','19:25:00',1.54),('9650','2013-07-21','19:30:00',1.4),('9650','2013-07-21','19:35:00',1.28),('9650','2013-07-21','19:40:00',1.04),('9650','2013-07-20','08:05:00',1.06),('9650','2013-07-20','08:10:00',1.16),('9650','2013-07-20','08:15:00',1.22),('9650','2013-07-20','08:20:00',1.28),('9650','2013-07-20','08:25:00',1.37),('9650','2013-07-20','08:30:00',1.47),('9650','2013-07-20','08:35:00',1.58),('9650','2013-07-20','08:40:00',1.68),('9650','2013-07-20','08:45:00',1.83),('9650','2013-07-20','08:50:00',1.93),('9650','2013-07-20','08:55:00',2.07),('9650','2013-07-20','09:00:00',2.18),('9650','2013-07-20','09:05:00',2.29),('9650','2013-07-20','09:10:00',2.4),('9650','2013-07-20','09:15:00',2.5),('9650','2013-07-20','09:20:00',2.61),('9650','2013-07-20','09:25:00',2.75),('9650','2013-07-20','09:30:00',2.9),('9650','2013-07-20','09:35:00',3),('9650','2013-07-20','09:40:00',3.16),('9650','2013-07-20','09:45:00',3.27),('9650','2013-07-20','09:50:00',3.37),('9650','2013-07-20','09:55:00',3.51),('9650','2013-07-20','10:00:00',3.64),('9650','2013-07-20','10:05:00',3.78),('9650','2013-07-20','10:10:00',3.87),('9650','2013-07-20','10:15:00',3.97),('9650','2013-07-20','10:20:00',4.05),('9650','2013-07-20','10:25:00',4.17),('9650','2013-07-20','10:30:00',4.26),('9650','2013-07-20','10:35:00',4.36),('9650','2013-07-20','10:40:00',4.47),('9650','2013-07-20','10:45:00',4.62),('9650','2013-07-20','10:50:00',4.71),('9650','2013-07-20','10:55:00',4.77),('9650','2013-07-20','11:00:00',4.92),('9650','2013-07-20','11:05:00',4.97),('9650','2013-07-20','11:10:00',5.07),('9650','2013-07-20','11:15:00',5.14),('9650','2013-07-20','11:20:00',5.22),('9650','2013-07-20','11:25:00',5.37),('9650','2013-07-20','11:30:00',5.45),('9650','2013-07-20','11:35:00',5.55),('9650','2013-07-20','11:40:00',5.79),('9650','2013-07-20','11:45:00',5.87),('9650','2013-07-20','11:50:00',5.82),('9650','2013-07-20','11:55:00',5.87),('9650','2013-07-20','12:00:00',5.88),('9650','2013-07-20','12:05:00',5.98),('9650','2013-07-20','12:10:00',6.28),('9650','2013-07-20','12:15:00',6.52),('9650','2013-07-20','12:20:00',6.91),('9650','2013-07-20','12:25:00',7.42),('9650','2013-07-20','12:30:00',7.39),('9650','2013-07-20','12:35:00',7.73),('9650','2013-07-20','12:40:00',7.81),('9650','2013-07-20','12:45:00',7.31),('9650','2013-07-20','12:50:00',6.9),('9650','2013-07-20','12:55:00',8.12),('9650','2013-07-20','13:00:00',5.75),('9650','2013-07-20','13:05:00',7.42),('9650','2013-07-20','13:10:00',6.63),('9650','2013-07-20','13:15:00',6.06),('9650','2013-07-20','13:20:00',5.91),('9650','2013-07-20','13:25:00',5.88),('9650','2013-07-20','13:30:00',7.73),('9650','2013-07-20','13:35:00',7.55),('9650','2013-07-20','13:40:00',7.13),('9650','2013-07-20','13:45:00',7.23),('9650','2013-07-20','13:50:00',3.36),('9650','2013-07-20','13:55:00',1.85),('9650','2013-07-20','14:00:00',2.05),('9650','2013-07-20','14:05:00',2.24),('9650','2013-07-20','14:10:00',2.12),('9650','2013-07-20','14:15:00',2.07),('9650','2013-07-20','14:20:00',2.47),('9650','2013-07-20','14:25:00',2.76),('9650','2013-07-20','14:30:00',2.37),('9650','2013-07-20','14:35:00',2.42),('9650','2013-07-20','14:40:00',2.27),('9650','2013-07-20','14:45:00',2.61),('9650','2013-07-20','14:50:00',3.14),('9650','2013-07-20','14:55:00',3.05),('9650','2013-07-20','15:00:00',3.56),('9650','2013-07-20','15:05:00',3.05),('9650','2013-07-20','15:10:00',2.89),('9650','2013-07-20','15:15:00',7.06),('9650','2013-07-20','15:20:00',8.79),('9650','2013-07-20','15:25:00',3.07),('9650','2013-07-20','15:30:00',2.57),('9650','2013-07-20','15:35:00',2.96),('9650','2013-07-20','15:40:00',4.86),('9650','2013-07-20','15:45:00',5.89),('9650','2013-07-20','15:50:00',5.49),('9650','2013-07-20','15:55:00',3.77),('9650','2013-07-20','16:00:00',2.39),('9650','2013-07-20','16:05:00',1.75),('9650','2013-07-20','16:10:00',1.53),('9650','2013-07-20','16:15:00',1.37),('9650','2013-07-20','16:20:00',1.28),('9650','2013-07-20','16:25:00',1.32),('9650','2013-07-20','16:30:00',1.39),('9650','2013-07-20','16:35:00',1.53),('9650','2013-07-20','16:40:00',1.62),('9650','2013-07-20','16:45:00',1.66),('9650','2013-07-20','16:50:00',1.73),('9650','2013-07-20','16:55:00',1.92),('9650','2013-07-20','17:00:00',2.19),('9650','2013-07-20','17:05:00',2.47),('9650','2013-07-20','17:10:00',2.57),('9650','2013-07-20','17:15:00',2.02),('9650','2013-07-20','17:20:00',1.78),('9650','2013-07-20','17:25:00',1.61),('9650','2013-07-20','17:30:00',1.51),('9650','2013-07-20','17:35:00',1.46),('9650','2013-07-20','17:40:00',1.48),('9650','2013-07-20','17:45:00',1.47),('9650','2013-07-20','17:50:00',1.5),('9650','2013-07-20','17:55:00',1.52),('9650','2013-07-20','18:00:00',1.49),('9650','2013-07-20','18:05:00',1.38),('9650','2013-07-20','18:10:00',1.18),('9650','2013-07-20','18:15:00',1.02),('9650','2014-04-06','08:15:00',1.06),('9650','2014-04-06','08:20:00',1.18),('9650','2014-04-06','08:25:00',1.29),('9650','2014-04-06','08:30:00',1.44),('9650','2014-04-06','08:35:00',1.63),('9650','2014-04-06','08:40:00',1.73),('9650','2014-04-06','08:45:00',1.74),('9650','2014-04-06','08:50:00',1.75),('9650','2014-04-06','08:55:00',1.71),('9650','2014-04-06','09:00:00',1.71),('9650','2014-04-06','09:05:00',1.76),('9650','2014-04-06','09:10:00',1.9),('9650','2014-04-06','09:15:00',2.05),('9650','2014-04-06','09:20:00',1.88),('9650','2014-04-06','09:25:00',1.85),('9650','2014-04-06','09:30:00',1.86),('9650','2014-04-06','09:35:00',1.85),('9650','2014-04-06','09:40:00',1.94),('9650','2014-04-06','09:45:00',2.04),('9650','2014-04-06','09:50:00',2.13),('9650','2014-04-06','09:55:00',2.22),('9650','2014-04-06','10:00:00',2.22),('9650','2014-04-06','10:05:00',2.2),('9650','2014-04-06','10:10:00',2.26),('9650','2014-04-06','10:15:00',2.15),('9650','2014-04-06','10:20:00',2.17),('9650','2014-04-06','10:25:00',2.22),('9650','2014-04-06','10:30:00',2.26),('9650','2014-04-06','10:35:00',2.37),('9650','2014-04-06','10:40:00',2.45),('9650','2014-04-06','10:45:00',2.55),('9650','2014-04-06','10:50:00',2.67),('9650','2014-04-06','10:55:00',2.84),('9650','2014-04-06','11:00:00',3.01),('9650','2014-04-06','11:05:00',3.1),('9650','2014-04-06','11:10:00',3.41),('9650','2014-04-06','11:15:00',3.57),('9650','2014-04-06','11:20:00',3.59),('9650','2014-04-06','11:25:00',3.2),('9650','2014-04-06','11:30:00',3.25),('9650','2014-04-06','11:35:00',3.21),('9650','2014-04-06','11:40:00',3.13),('9650','2014-04-06','11:45:00',2.96),('9650','2014-04-06','11:50:00',2.81),('9650','2014-04-06','11:55:00',2.7),('9650','2014-04-06','12:00:00',2.94),('9650','2014-04-06','12:05:00',3.53),('9650','2014-04-06','12:10:00',3.8),('9650','2014-04-06','12:15:00',4.88),('9650','2014-04-06','12:20:00',5.82),('9650','2014-04-06','12:25:00',5.7),('9650','2014-04-06','12:30:00',3.36),('9650','2014-04-06','12:35:00',3.01),('9650','2014-04-06','12:40:00',3.86),('9650','2014-04-06','12:45:00',5.66),('9650','2014-04-06','12:50:00',5.89),('9650','2014-04-06','12:55:00',5.83),('9650','2014-04-06','13:00:00',5.94),('9650','2014-04-06','13:05:00',5.95),('9650','2014-04-06','13:10:00',5.94),('9650','2014-04-06','13:15:00',5.97),('9650','2014-04-06','13:20:00',6),('9650','2014-04-06','13:25:00',6.03),('9650','2014-04-06','13:30:00',6.08),('9650','2014-04-06','13:35:00',6.07),('9650','2014-04-06','13:40:00',6.07),('9650','2014-04-06','13:45:00',6.11),('9650','2014-04-06','13:50:00',6.15),('9650','2014-04-06','13:55:00',6.24),('9650','2014-04-06','14:00:00',6.28),('9650','2014-04-06','14:05:00',6.24),('9650','2014-04-06','14:10:00',6.24),('9650','2014-04-06','14:15:00',6.17),('9650','2014-04-06','14:20:00',6.21),('9650','2014-04-06','14:25:00',6.39),('9650','2014-04-06','14:30:00',6.39),('9650','2014-04-06','14:35:00',6.28),('9650','2014-04-06','14:40:00',6.23),('9650','2014-04-06','14:45:00',5.95),('9650','2014-04-06','14:50:00',6.28),('9650','2014-04-06','14:55:00',6.03),('9650','2014-04-06','15:00:00',4.9),('9650','2014-04-06','15:05:00',6.33),('9650','2014-04-06','15:10:00',6.07),('9650','2014-04-06','15:15:00',6.34),('9650','2014-04-06','15:20:00',6.55),('9650','2014-04-06','15:25:00',6.48),('9650','2014-04-06','15:30:00',5.97),('9650','2014-04-06','15:35:00',6.09),('9650','2014-04-06','15:40:00',6.06),('9650','2014-04-06','15:45:00',6.25),('9650','2014-04-06','15:50:00',6.52),('9650','2014-04-06','15:55:00',6.42),('9650','2014-04-06','16:00:00',4.85),('9650','2014-04-06','16:05:00',2.99),('9650','2014-04-06','16:10:00',5.53),('9650','2014-04-06','16:15:00',5.44),('9650','2014-04-06','16:20:00',5.14),('9650','2014-04-06','16:25:00',5.1),('9650','2014-04-06','16:30:00',4.8),('9650','2014-04-06','16:35:00',2.99),('9650','2014-04-06','16:40:00',2.27),('9650','2014-04-06','16:45:00',3.53),('9650','2014-04-06','16:50:00',4.77),('9650','2014-04-06','16:55:00',4.82),('9650','2014-04-06','17:00:00',5.1),('9650','2014-04-06','17:05:00',4.81),('9650','2014-04-06','17:10:00',3.79),('9650','2014-04-06','17:15:00',3.87),('9650','2014-04-06','17:20:00',2.39),('9650','2014-04-06','17:25:00',1.83),('9650','2014-04-06','17:30:00',1.42),('9650','2014-04-06','17:35:00',1.2),('9650','2014-04-06','17:45:00',1.97),('9650','2014-04-06','17:50:00',1.63),('9650','2014-04-06','17:55:00',2.86),('9650','2014-04-06','18:00:00',2.66),('9650','2014-04-06','18:05:00',2.51),('9650','2014-04-06','18:10:00',2.49),('9650','2014-04-06','18:15:00',2.4),('9650','2014-04-06','18:20:00',2.17),('9650','2014-04-06','18:25:00',1.98),('9650','2014-04-06','18:30:00',1.75),('9650','2014-04-06','18:35:00',1.52),('9650','2014-04-06','18:40:00',1.32),('9650','2014-04-06','18:45:00',1.18),('9650','2014-04-06','18:50:00',1),('9650','2013-07-19','08:10:00',1.06),('9650','2013-07-19','08:15:00',1.12),('9650','2013-07-19','08:20:00',1.16),('9650','2013-07-19','08:25:00',1.21),('9650','2013-07-19','08:30:00',1.24),('9650','2013-07-19','08:35:00',1.26),('9650','2013-07-19','08:40:00',1.35),('9650','2013-07-19','08:45:00',1.89),('9650','2013-07-19','08:50:00',2.04),('9650','2013-07-19','08:55:00',2.19),('9650','2013-07-19','09:00:00',2.31),('9650','2013-07-19','09:05:00',2.45),('9650','2013-07-19','09:10:00',2.65),('9650','2013-07-19','09:15:00',2.79),('9650','2013-07-19','09:20:00',2.86),('9650','2013-07-19','09:25:00',2.86),('9650','2013-07-19','09:30:00',2.92),('9650','2013-07-19','09:35:00',2.99),('9650','2013-07-19','09:40:00',3.05),('9650','2013-07-19','09:45:00',3.38),('9650','2013-07-19','09:50:00',3.36),('9650','2013-07-19','09:55:00',3.47),('9650','2013-07-19','10:00:00',3.72),('9650','2013-07-19','10:05:00',3.82),('9650','2013-07-19','10:10:00',3.97),('9650','2013-07-19','10:15:00',4.04),('9650','2013-07-19','10:20:00',4.15),('9650','2013-07-19','10:25:00',4.27),('9650','2013-07-19','10:30:00',4.37),('9650','2013-07-19','10:35:00',4.48),('9650','2013-07-19','10:40:00',4.59),('9650','2013-07-19','10:45:00',4.65),('9650','2013-07-19','10:50:00',4.74),('9650','2013-07-19','10:55:00',4.91),('9650','2013-07-19','11:00:00',5),('9650','2013-07-19','11:05:00',5.07),('9650','2013-07-19','11:10:00',5.16),('9650','2013-07-19','11:15:00',5.19),('9650','2013-07-19','11:20:00',5.18),('9650','2013-07-19','11:25:00',5.33),('9650','2013-07-19','11:30:00',5.42),('9650','2013-07-19','11:35:00',5.56),('9650','2013-07-19','11:40:00',5.62),('9650','2013-07-19','11:45:00',5.73),('9650','2013-07-19','11:50:00',5.74),('9650','2013-07-19','11:55:00',5.89),('9650','2013-07-19','12:00:00',6.02),('9650','2013-07-19','12:05:00',6.18),('9650','2013-07-19','12:10:00',6.32),('9650','2013-07-19','12:15:00',6.24),('9650','2013-07-19','12:20:00',6.18),('9650','2013-07-19','12:25:00',6.2),('9650','2013-07-19','12:30:00',6.25),('9650','2013-07-19','12:35:00',6.4),('9650','2013-07-19','12:40:00',6.46),('9650','2013-07-19','12:45:00',6.62),('9650','2013-07-19','12:50:00',6.67),('9650','2013-07-19','12:55:00',6.72),('9650','2013-07-19','13:00:00',6.97),('9650','2013-07-19','13:05:00',6.9),('9650','2013-07-19','13:10:00',4.8),('9650','2013-07-19','13:15:00',1.57),('9650','2013-07-19','13:20:00',3.65),('9650','2013-07-19','13:25:00',6.02),('9650','2013-07-19','13:30:00',7.46),('9650','2013-07-19','13:35:00',7.22),('9650','2013-07-19','13:40:00',7.42),('9650','2013-07-19','13:45:00',6.62),('9650','2013-07-19','13:50:00',2.4),('9650','2013-07-19','13:55:00',1.36),('9650','2013-07-19','14:00:00',4.04),('9650','2013-07-19','14:05:00',7.58),('9650','2013-07-19','14:10:00',7.55),('9650','2013-07-19','14:15:00',7.57),('9650','2013-07-19','14:20:00',7.37),('9650','2013-07-19','14:25:00',7.22),('9650','2013-07-19','14:30:00',7.11),('9650','2013-07-19','14:35:00',7.23),('9650','2013-07-19','14:40:00',7.23),('9650','2013-07-19','14:45:00',7.1),('9650','2013-07-19','14:50:00',4.4),('9650','2013-07-19','14:55:00',7.1),('9650','2013-07-19','15:00:00',7.45),('9650','2013-07-19','15:05:00',7.26),('9650','2013-07-19','15:10:00',7.15),('9650','2013-07-19','15:15:00',7.03),('9650','2013-07-19','15:20:00',6.89),('9650','2013-07-19','15:25:00',6.9),('9650','2013-07-19','15:30:00',6.88),('9650','2013-07-19','15:35:00',6.84),('9650','2013-07-19','15:40:00',6.83),('9650','2013-07-19','15:45:00',6.84),('9650','2013-07-19','15:50:00',6.83),('9650','2013-07-19','15:55:00',6.66),('9650','2013-07-19','16:00:00',6.54),('9650','2013-07-19','16:05:00',6.58),('9650','2013-07-19','16:10:00',6.48),('9650','2013-07-19','16:15:00',6.47),('9650','2013-07-19','16:20:00',6.46),('9650','2013-07-19','16:25:00',6.41),('9650','2013-07-19','16:30:00',6.29),('9650','2013-07-19','16:35:00',5.95),('9650','2013-07-19','16:40:00',6.18),('9650','2013-07-19','16:45:00',6.12),('9650','2013-07-19','16:50:00',6.02),('9650','2013-07-19','16:55:00',5.84),('9650','2013-07-19','17:00:00',5.75),('9650','2013-07-19','17:05:00',5.74),('9650','2013-07-19','17:10:00',5.61),('9650','2013-07-19','17:15:00',5.49),('9650','2013-07-19','17:20:00',5.41),('9650','2013-07-19','17:25:00',5.34),('9650','2013-07-19','17:30:00',5.24),('9650','2013-07-19','17:35:00',5.17),('9650','2013-07-19','17:40:00',5.08),('9650','2013-07-19','17:45:00',4.93),('9650','2013-07-19','17:50:00',4.8),('9650','2013-07-19','17:55:00',4.68),('9650','2013-07-19','18:00:00',4.56),('9650','2013-07-19','18:05:00',4.41),('9650','2013-07-19','18:10:00',4.29),('9650','2013-07-19','18:15:00',4.15),('9650','2013-07-19','18:20:00',4.03),('9650','2013-07-19','18:25:00',3.91),('9650','2013-07-19','18:30:00',3.75),('9650','2013-07-19','18:35:00',3.59),('9650','2013-07-19','18:40:00',3.45),('9650','2013-07-19','18:45:00',3.22),('9650','2013-07-19','18:50:00',3.04),('9650','2013-07-19','18:55:00',2.88),('9650','2013-07-19','19:00:00',2.73),('9650','2013-07-19','19:05:00',2.54),('9650','2013-07-19','19:10:00',2.37),('9650','2013-07-19','19:15:00',2.22),('9650','2013-07-19','19:20:00',2.05),('9650','2013-07-19','19:25:00',1.87),('9650','2013-07-19','19:30:00',1.67),('9650','2013-07-19','19:35:00',1.45),('9650','2013-07-19','19:40:00',1.24),('9650','2013-07-19','19:45:00',1.07),('9650','2013-07-18','08:00:00',1.01),('9650','2013-07-18','08:05:00',1.09),('9650','2013-07-18','08:10:00',1.17),('9650','2013-07-18','08:15:00',1.25),('9650','2013-07-18','08:20:00',1.33),('9650','2013-07-18','08:25:00',1.4),('9650','2013-07-18','08:30:00',1.49),('9650','2013-07-18','08:35:00',1.61),('9650','2013-07-18','08:40:00',1.73),('9650','2013-07-18','08:45:00',1.9),('9650','2013-07-18','08:50:00',2.02),('9650','2013-07-18','08:55:00',2.15),('9650','2013-07-18','09:00:00',2.24),('9650','2013-07-18','09:05:00',2.34),('9650','2013-07-18','09:10:00',2.46),('9650','2013-07-18','09:15:00',2.57),('9650','2013-07-18','09:20:00',2.66),('9650','2013-07-18','09:25:00',2.77),('9650','2013-07-18','09:30:00',2.89),('9650','2013-07-18','09:35:00',3.02),('9650','2013-07-18','09:40:00',3.17),('9650','2013-07-18','09:45:00',3.29),('9650','2013-07-18','09:50:00',3.36),('9650','2013-07-18','09:55:00',3.49),('9650','2013-07-18','10:00:00',3.62),('9650','2013-07-18','10:05:00',3.72),('9650','2013-07-18','10:10:00',3.84),('9650','2013-07-18','10:15:00',3.97),('9650','2013-07-18','10:20:00',3.99),('9650','2013-07-18','10:25:00',4.14),('9650','2013-07-18','10:30:00',4.05),('9650','2013-07-18','10:35:00',4.31),('9650','2013-07-18','10:40:00',4.42),('9650','2013-07-18','10:45:00',4.53),('9650','2013-07-18','10:50:00',4.58),('9650','2013-07-18','10:55:00',4.68),('9650','2013-07-18','11:00:00',4.75),('9650','2013-07-18','11:05:00',4.83),('9650','2013-07-18','11:10:00',4.96),('9650','2013-07-18','11:15:00',5.04),('9650','2013-07-18','11:20:00',5.18),('9650','2013-07-18','11:25:00',5.26),('9650','2013-07-18','11:30:00',5.29),('9650','2013-07-18','11:35:00',5.35),('9650','2013-07-18','11:40:00',5.55),('9650','2013-07-18','11:45:00',5.63),('9650','2013-07-18','11:50:00',5.56),('9650','2013-07-18','11:55:00',5.77),('9650','2013-07-18','12:00:00',5.35),('9650','2013-07-18','12:05:00',5.88),('9650','2013-07-18','12:10:00',5.9),('9650','2013-07-18','12:15:00',6.22),('9650','2013-07-18','12:20:00',6.27),('9650','2013-07-18','12:25:00',6.36),('9650','2013-07-18','12:30:00',6.28),('9650','2013-07-18','12:35:00',6.28),('9650','2013-07-18','12:40:00',6.18),('9650','2013-07-18','12:45:00',4.92),('9650','2013-07-18','12:50:00',5.63),('9650','2013-07-18','12:55:00',6.72),('9650','2013-07-18','13:00:00',6.76),('9650','2013-07-18','13:05:00',6.63),('9650','2013-07-18','13:10:00',6.05),('9650','2013-07-18','13:15:00',2.43),('9650','2013-07-18','13:20:00',2.92),('9650','2013-07-18','13:25:00',7.39),('9650','2013-07-18','13:30:00',7.26),('9650','2013-07-18','13:35:00',7.12),('9650','2013-07-18','13:40:00',7.08),('9650','2013-07-18','13:45:00',7.09),('9650','2013-07-18','13:50:00',7.2),('9650','2013-07-18','13:55:00',7.22),('9650','2013-07-18','14:00:00',7.21),('9650','2013-07-18','14:05:00',7.15),('9650','2013-07-18','14:10:00',6.12),('9650','2013-07-18','14:15:00',6.95),('9650','2013-07-18','14:20:00',7.4),('9650','2013-07-18','14:25:00',5.67),('9650','2013-07-18','14:30:00',7.48),('9650','2013-07-18','14:35:00',6.95),('9650','2013-07-18','14:40:00',5.8),('9650','2013-07-18','14:45:00',7.27),('9650','2013-07-18','14:50:00',7.01),('9650','2013-07-18','14:55:00',7.35),('9650','2013-07-18','15:00:00',7.07),('9650','2013-07-18','15:05:00',7.29),('9650','2013-07-18','15:10:00',7.17),('9650','2013-07-18','15:15:00',4.01),('9650','2013-07-18','15:20:00',5.69),('9650','2013-07-18','15:25:00',5.88),('9650','2013-07-18','15:30:00',7.49),('9650','2013-07-18','15:35:00',7.24),('9650','2013-07-18','15:40:00',7.23),('9650','2013-07-18','15:45:00',6.94),('9650','2013-07-18','15:50:00',6.96),('9650','2013-07-18','15:55:00',6.83),('9650','2013-07-18','16:00:00',6.72),('9650','2013-07-18','16:05:00',6.68),('9650','2013-07-18','16:10:00',6.69),('9650','2013-07-18','16:15:00',6.57),('9650','2013-07-18','16:20:00',6.5),('9650','2013-07-18','16:25:00',6.51),('9650','2013-07-18','16:30:00',6.5),('9650','2013-07-18','16:35:00',6.49),('9650','2013-07-18','16:40:00',6.42),('9650','2013-07-18','16:45:00',6.32),('9650','2013-07-18','16:50:00',6.29),('9650','2013-07-18','16:55:00',6.41),('9650','2013-07-18','17:00:00',4.98),('9650','2013-07-18','17:05:00',6.5),('9650','2013-07-18','17:10:00',5.9),('9650','2013-07-18','17:15:00',5.54),('9650','2013-07-18','17:20:00',5.2),('9650','2013-07-18','17:25:00',4.3),('9650','2013-07-18','17:30:00',5.05),('9650','2013-07-18','17:35:00',5.55),('9650','2013-07-18','17:40:00',3.8),('9650','2013-07-18','17:45:00',2.83),('9650','2013-07-18','17:50:00',2.01),('9650','2013-07-18','17:55:00',1.64),('9650','2013-07-18','18:00:00',1.44),('9650','2013-07-18','18:05:00',1.25),('9650','2013-07-18','18:10:00',1.12),('9650','2013-07-18','18:40:00',1.04),('9650','2013-07-18','18:45:00',1.02),('9650','2013-07-17','08:05:00',1.02),('9650','2013-07-17','08:10:00',1.07),('9650','2013-07-17','08:15:00',1.15),('9650','2013-07-17','08:20:00',1.27),('9650','2013-07-17','08:25:00',1.37),('9650','2013-07-17','08:30:00',1.48),('9650','2013-07-17','08:35:00',1.6),('9650','2013-07-17','08:40:00',1.72),('9650','2013-07-17','08:45:00',1.89),('9650','2013-07-17','08:50:00',2),('9650','2013-07-17','08:55:00',2.13),('9650','2013-07-17','09:00:00',2.24),('9650','2013-07-17','09:05:00',2.36),('9650','2013-07-17','09:10:00',2.47),('9650','2013-07-17','09:15:00',2.58),('9650','2013-07-17','09:20:00',2.69),('9650','2013-07-17','09:25:00',2.82),('9650','2013-07-17','09:30:00',2.99),('9650','2013-07-17','09:35:00',3.13),('9650','2013-07-17','09:40:00',3.28),('9650','2013-07-17','09:45:00',3.39),('9650','2013-07-17','09:50:00',3.52),('9650','2013-07-17','09:55:00',3.62),('9650','2013-07-17','10:00:00',3.76),('9650','2013-07-17','10:05:00',3.85),('9650','2013-07-17','10:10:00',4.01),('9650','2013-07-17','10:15:00',4.08),('9650','2013-07-17','10:20:00',4.16),('9650','2013-07-17','10:25:00',4.28),('9650','2013-07-17','10:30:00',4.38),('9650','2013-07-17','10:35:00',4.54),('9650','2013-07-17','10:40:00',4.7),('9650','2013-07-17','10:45:00',4.8),('9650','2013-07-17','10:50:00',4.91),('9650','2013-07-17','10:55:00',4.96),('9650','2013-07-17','11:00:00',5.03),('9650','2013-07-17','11:05:00',5.09),('9650','2013-07-17','11:10:00',5.18),('9650','2013-07-17','11:15:00',5.27),('9650','2013-07-17','11:20:00',5.36),('9650','2013-07-17','11:25:00',5.42),('9650','2013-07-17','11:30:00',5.53),('9650','2013-07-17','11:35:00',5.61),('9650','2013-07-17','11:40:00',5.68),('9650','2013-07-17','11:45:00',5.76),('9650','2013-07-17','11:50:00',5.79),('9650','2013-07-17','11:55:00',5.87),('9650','2013-07-17','12:00:00',5.88),('9650','2013-07-17','12:05:00',5.89),('9650','2013-07-17','12:10:00',5.81),('9650','2013-07-17','12:15:00',5.62),('9650','2013-07-17','12:20:00',5.75),('9650','2013-07-17','12:25:00',6.14),('9650','2013-07-17','12:30:00',6.46),('9650','2013-07-17','12:35:00',6.37),('9650','2013-07-17','12:40:00',6.46),('9650','2013-07-17','12:45:00',6.83),('9650','2013-07-17','12:50:00',6.68),('9650','2013-07-17','12:55:00',6.57),('9650','2013-07-17','13:00:00',6.47),('9650','2013-07-17','13:05:00',5.18),('9650','2013-07-17','13:10:00',5.93),('9650','2013-07-17','13:15:00',6.7),('9650','2013-07-17','13:20:00',6.78),('9650','2013-07-17','13:25:00',6.77),('9650','2013-07-17','13:30:00',6.39),('9650','2013-07-17','13:35:00',6.7),('9650','2013-07-17','13:40:00',6.96),('9650','2013-07-17','13:45:00',6.93),('9650','2013-07-17','13:50:00',6.94),('9650','2013-07-17','13:55:00',7.11),('9650','2013-07-17','14:00:00',7.03),('9650','2013-07-17','14:05:00',6.69),('9650','2013-07-17','14:10:00',7.02),('9650','2013-07-17','14:15:00',7.12),('9650','2013-07-17','14:20:00',7.08),('9650','2013-07-17','14:25:00',7.05),('9650','2013-07-17','14:30:00',6.94),('9650','2013-07-17','14:35:00',7.06),('9650','2013-07-17','14:40:00',7),('9650','2013-07-17','14:45:00',6.98),('9650','2013-07-17','14:50:00',6.94),('9650','2013-07-17','14:55:00',6.94),('9650','2013-07-17','15:00:00',6.98),('9650','2013-07-17','15:05:00',7.04),('9650','2013-07-17','15:10:00',6.92),('9650','2013-07-17','15:15:00',6.92),('9650','2013-07-17','15:20:00',7),('9650','2013-07-17','15:25:00',6.96),('9650','2013-07-17','15:30:00',6.88),('9650','2013-07-17','15:35:00',6.78),('9650','2013-07-17','15:40:00',6.84),('9650','2013-07-17','15:45:00',6.83),('9650','2013-07-17','15:50:00',6.74),('9650','2013-07-17','15:55:00',6.72),('9650','2013-07-17','16:00:00',6.61),('9650','2013-07-17','16:05:00',6.51),('9650','2013-07-17','16:10:00',6.47),('9650','2013-07-17','16:15:00',6.37),('9650','2013-07-17','16:20:00',6.34),('9650','2013-07-17','16:25:00',6.28),('9650','2013-07-17','16:30:00',6.2),('9650','2013-07-17','16:35:00',6.16),('9650','2013-07-17','16:40:00',6.07),('9650','2013-07-17','16:45:00',6.04),('9650','2013-07-17','16:50:00',5.92),('9650','2013-07-17','16:55:00',5.83),('9650','2013-07-17','17:00:00',5.73),('9650','2013-07-17','17:05:00',5.62),('9650','2013-07-17','17:10:00',5.44),('9650','2013-07-17','17:15:00',5.39),('9650','2013-07-17','17:20:00',5.32),('9650','2013-07-17','17:25:00',5.25),('9650','2013-07-17','17:30:00',5.07),('9650','2013-07-17','17:35:00',4.9),('9650','2013-07-17','17:40:00',4.47),('9650','2013-07-17','17:45:00',4.62),('9650','2013-07-17','17:50:00',4.45),('9650','2013-07-17','17:55:00',4.36),('9650','2013-07-17','18:00:00',4.12),('9650','2013-07-17','18:05:00',3.62),('9650','2013-07-17','18:10:00',3.73),('9650','2013-07-17','18:15:00',3.61),('9650','2013-07-17','18:20:00',3.48),('9650','2013-07-17','18:25:00',3.27),('9650','2013-07-17','18:30:00',1.83),('9650','2013-07-17','18:45:00',1.98),('9650','2013-07-17','18:50:00',1.28),('9650','2013-07-17','18:55:00',2.21),('9650','2013-07-17','19:00:00',2.47),('9650','2013-07-17','19:05:00',2.01),('9650','2013-07-17','19:10:00',1.14),('9650','2013-07-17','19:15:00',1.32),('9650','2013-07-17','19:20:00',1.74),('9650','2013-07-17','19:25:00',1.54),('9650','2013-07-17','19:30:00',1.38),('9650','2013-07-17','19:40:00',1.02),('9650','2013-07-16','08:05:00',1.05),('9650','2013-07-16','08:10:00',1.1),('9650','2013-07-16','08:15:00',1.15),('9650','2013-07-16','08:20:00',1.19),('9650','2013-07-16','08:25:00',1.22),('9650','2013-07-16','08:30:00',1.24),('9650','2013-07-16','08:35:00',1.26),('9650','2013-07-16','08:40:00',1.35),('9650','2013-07-16','08:45:00',1.95),('9650','2013-07-16','08:50:00',2.07),('9650','2013-07-16','08:55:00',2.2),('9650','2013-07-16','09:00:00',2.34),('9650','2013-07-16','09:05:00',2.44),('9650','2013-07-16','09:10:00',2.58),('9650','2013-07-16','09:15:00',2.7),('9650','2013-07-16','09:20:00',2.83),('9650','2013-07-16','09:25:00',2.97),('9650','2013-07-16','09:30:00',3.13),('9650','2013-07-16','09:35:00',3.24),('9650','2013-07-16','09:40:00',3.41),('9650','2013-07-16','09:45:00',3.56),('9650','2013-07-16','09:50:00',3.67),('9650','2013-07-16','09:55:00',3.77),('9650','2013-07-16','10:00:00',3.92),('9650','2013-07-16','10:05:00',4.04),('9650','2013-07-16','10:10:00',4.16),('9650','2013-07-16','10:15:00',4.23),('9650','2013-07-16','10:20:00',4.31),('9650','2013-07-16','10:25:00',4.43),('9650','2013-07-16','10:30:00',4.55),('9650','2013-07-16','10:35:00',4.67),('9650','2013-07-16','10:40:00',4.79),('9650','2013-07-16','10:45:00',4.9),('9650','2013-07-16','10:50:00',5.03),('9650','2013-07-16','10:55:00',5.08),('9650','2013-07-16','11:00:00',5.19),('9650','2013-07-16','11:05:00',5.32),('9650','2013-07-16','11:10:00',5.38),('9650','2013-07-16','11:15:00',5.47),('9650','2013-07-16','11:20:00',5.54),('9650','2013-07-16','11:25:00',5.64),('9650','2013-07-16','11:30:00',5.73),('9650','2013-07-16','11:35:00',5.79),('9650','2013-07-16','11:40:00',5.86),('9650','2013-07-16','11:45:00',5.94),('9650','2013-07-16','11:50:00',6.01),('9650','2013-07-16','11:55:00',6.09),('9650','2013-07-16','12:00:00',6.23),('9650','2013-07-16','12:05:00',6.26),('9650','2013-07-16','12:10:00',6.32),('9650','2013-07-16','12:15:00',6.39),('9650','2013-07-16','12:20:00',6.37),('9650','2013-07-16','12:25:00',6.4),('9650','2013-07-16','12:30:00',6.48),('9650','2013-07-16','12:35:00',6.5),('9650','2013-07-16','12:40:00',6.58),('9650','2013-07-16','12:45:00',6.59),('9650','2013-07-16','12:50:00',6.61),('9650','2013-07-16','12:55:00',6.71),('9650','2013-07-16','13:00:00',6.77),('9650','2013-07-16','13:05:00',6.79),('9650','2013-07-16','13:10:00',6.83),('9650','2013-07-16','13:15:00',6.86),('9650','2013-07-16','13:20:00',6.87),('9650','2013-07-16','13:25:00',6.82),('9650','2013-07-16','13:30:00',6.88),('9650','2013-07-16','13:35:00',6.91),('9650','2013-07-16','13:40:00',6.91),('9650','2013-07-16','13:45:00',7),('9650','2013-07-16','13:50:00',6.88),('9650','2013-07-16','13:55:00',6.98),('9650','2013-07-16','14:00:00',7.08),('9650','2013-07-16','14:05:00',7.12),('9650','2013-07-16','14:10:00',7.13),('9650','2013-07-16','14:15:00',7.18),('9650','2013-07-16','14:20:00',7.13),('9650','2013-07-16','14:25:00',7.1),('9650','2013-07-16','14:30:00',7.05),('9650','2013-07-16','14:35:00',6.97),('9650','2013-07-16','14:40:00',7.32),('9650','2013-07-16','14:45:00',7.25),('9650','2013-07-16','14:50:00',7),('9650','2013-07-16','14:55:00',7.02),('9650','2013-07-16','15:00:00',6.96),('9650','2013-07-16','15:05:00',6.8),('9650','2013-07-16','15:10:00',6.12),('9650','2013-07-16','15:15:00',7.2),('9650','2013-07-16','15:20:00',7.1),('9650','2013-07-16','15:25:00',7.03),('9650','2013-07-16','15:30:00',6.97),('9650','2013-07-16','15:35:00',7.01),('9650','2013-07-16','15:40:00',5.69),('9650','2013-07-16','15:45:00',6.44),('9650','2013-07-16','15:50:00',6.33),('9650','2013-07-16','15:55:00',6.84),('9650','2013-07-16','16:00:00',6.71),('9650','2013-07-16','16:05:00',6.66),('9650','2013-07-16','16:10:00',6.65),('9650','2013-07-16','16:15:00',6.53),('9650','2013-07-16','16:20:00',6.43),('9650','2013-07-16','16:25:00',6.32),('9650','2013-07-16','16:30:00',6.15),('9650','2013-07-16','16:35:00',6),('9650','2013-07-16','16:40:00',5.88),('9650','2013-07-16','16:45:00',6.05),('9650','2013-07-16','16:50:00',5.92),('9650','2013-07-16','16:55:00',5.8),('9650','2013-07-16','17:00:00',5.8),('9650','2013-07-16','17:05:00',5.69),('9650','2013-07-16','17:10:00',5.77),('9650','2013-07-16','17:15:00',5.57),('9650','2013-07-16','17:20:00',5.46),('9650','2013-07-16','17:25:00',5.29),('9650','2013-07-16','17:30:00',5.18),('9650','2013-07-16','17:35:00',5.12),('9650','2013-07-16','17:40:00',5),('9650','2013-07-16','17:45:00',4.88),('9650','2013-07-16','17:50:00',4.86),('9650','2013-07-16','17:55:00',4.67),('9650','2013-07-16','18:00:00',4.52),('9650','2013-07-16','18:05:00',4.48),('9650','2013-07-16','18:10:00',4.35),('9650','2013-07-16','18:15:00',4.24),('9650','2013-07-16','18:20:00',4.05),('9650','2013-07-16','18:25:00',3.91),('9650','2013-07-16','18:30:00',3.79),('9650','2013-07-16','18:35:00',3.64),('9650','2013-07-16','18:40:00',3.48),('9650','2013-07-16','18:45:00',3.28),('9650','2013-07-16','18:50:00',3.15),('9650','2013-07-16','18:55:00',2.97),('9650','2013-07-16','19:00:00',2.8),('9650','2013-07-16','19:05:00',2.65),('9650','2013-07-16','19:10:00',2.45),('9650','2013-07-16','19:15:00',2.27),('9650','2013-07-16','19:20:00',2.08),('9650','2013-07-16','19:25:00',1.92),('9650','2013-07-16','19:30:00',1.78),('9650','2013-07-16','19:35:00',1.58),('9650','2013-07-16','19:40:00',1.36),('9650','2013-07-16','19:45:00',1.16),('9650','2013-07-15','08:00:00',1.02),('9650','2013-07-15','08:05:00',1.1),('9650','2013-07-15','08:10:00',1.2),('9650','2013-07-15','08:15:00',1.28),('9650','2013-07-15','08:20:00',1.38),('9650','2013-07-15','08:25:00',1.47),('9650','2013-07-15','08:30:00',1.59),('9650','2013-07-15','08:35:00',1.69),('9650','2013-07-15','08:40:00',1.84),('9650','2013-07-15','08:45:00',1.97),('9650','2013-07-15','08:50:00',2.09),('9650','2013-07-15','08:55:00',2.23),('9650','2013-07-15','09:00:00',2.34),('9650','2013-07-15','09:05:00',2.44),('9650','2013-07-15','09:10:00',2.57),('9650','2013-07-15','09:15:00',2.67),('9650','2013-07-15','09:20:00',2.76),('9650','2013-07-15','09:25:00',2.89),('9650','2013-07-15','09:30:00',3.06),('9650','2013-07-15','09:35:00',3.2),('9650','2013-07-15','09:40:00',3.36),('9650','2013-07-15','09:45:00',3.47),('9650','2013-07-15','09:50:00',3.6),('9650','2013-07-15','09:55:00',3.71),('9650','2013-07-15','10:00:00',3.87),('9650','2013-07-15','10:05:00',4),('9650','2013-07-15','10:10:00',4.12),('9650','2013-07-15','10:15:00',4.2),('9650','2013-07-15','10:20:00',4.27),('9650','2013-07-15','10:25:00',4.4),('9650','2013-07-15','10:30:00',4.53),('9650','2013-07-15','10:35:00',4.62),('9650','2013-07-15','10:40:00',4.76),('9650','2013-07-15','10:45:00',4.85),('9650','2013-07-15','10:50:00',4.96),('9650','2013-07-15','10:55:00',5.04),('9650','2013-07-15','11:00:00',5.14),('9650','2013-07-15','11:05:00',5.24),('9650','2013-07-15','11:10:00',5.33),('9650','2013-07-15','11:15:00',5.42),('9650','2013-07-15','11:20:00',5.48),('9650','2013-07-15','11:25:00',5.58),('9650','2013-07-15','11:30:00',5.64),('9650','2013-07-15','11:35:00',5.73),('9650','2013-07-15','11:40:00',5.8),('9650','2013-07-15','11:45:00',5.9),('9650','2013-07-15','11:50:00',6.01),('9650','2013-07-15','11:55:00',6.09),('9650','2013-07-15','12:00:00',6.14),('9650','2013-07-15','12:05:00',6.21),('9650','2013-07-15','12:10:00',6.28),('9650','2013-07-15','12:15:00',6.34),('9650','2013-07-15','12:20:00',6.39),('9650','2013-07-15','12:25:00',6.41),('9650','2013-07-15','12:30:00',6.45),('9650','2013-07-15','12:35:00',6.47),('9650','2013-07-15','12:40:00',6.47),('9650','2013-07-15','12:45:00',6.53),('9650','2013-07-15','12:50:00',6.52),('9650','2013-07-15','12:55:00',6.59),('9650','2013-07-15','13:00:00',6.6),('9650','2013-07-15','13:05:00',6.7),('9650','2013-07-15','13:10:00',6.69),('9650','2013-07-15','13:15:00',6.79),('9650','2013-07-15','13:20:00',6.81),('9650','2013-07-15','13:25:00',6.87),('9650','2013-07-15','13:30:00',6.91),('9650','2013-07-15','13:35:00',6.9),('9650','2013-07-15','13:40:00',7.05),('9650','2013-07-15','13:45:00',7.23),('9650','2013-07-15','13:50:00',7.43),('9650','2013-07-15','13:55:00',6.09),('9650','2013-07-15','14:00:00',7.03),('9650','2013-07-15','14:05:00',7.06),('9650','2013-07-15','14:10:00',4.86),('9650','2013-07-15','14:15:00',6.9),('9650','2013-07-15','14:20:00',2.88),('9650','2013-07-15','14:25:00',6.05),('9650','2013-07-15','14:30:00',7.22),('9650','2013-07-15','14:35:00',7.19),('9650','2013-07-15','14:40:00',7.13),('9650','2013-07-15','14:45:00',7.05),('9650','2013-07-15','14:50:00',7.09),('9650','2013-07-15','14:55:00',7.1),('9650','2013-07-15','15:00:00',7.04),('9650','2013-07-15','15:05:00',7.02),('9650','2013-07-15','15:10:00',6.96),('9650','2013-07-15','15:15:00',6.94),('9650','2013-07-15','15:20:00',6.94),('9650','2013-07-15','15:25:00',6.95),('9650','2013-07-15','15:30:00',6.98),('9650','2013-07-15','15:35:00',6.78),('9650','2013-07-15','15:40:00',6.74),('9650','2013-07-15','15:45:00',3.7),('9650','2013-07-15','15:50:00',6.69),('9650','2013-07-15','15:55:00',6.71),('9650','2013-07-15','16:00:00',6.18),('9650','2013-07-15','16:05:00',2.81),('9650','2013-07-15','16:10:00',6.57),('9650','2013-07-15','16:15:00',5.61),('9650','2013-07-15','16:20:00',3.29),('9650','2013-07-15','16:25:00',2.27),('9650','2013-07-15','16:30:00',1.98),('9650','2013-07-15','16:35:00',1.52),('9650','2013-07-15','16:40:00',1.54),('9650','2013-07-15','16:45:00',2.45),('9650','2013-07-15','16:50:00',3.06),('9650','2013-07-15','16:55:00',3.32),('9650','2013-07-15','17:00:00',6.28),('9650','2013-07-15','17:05:00',6.39),('9650','2013-07-15','17:10:00',6),('9650','2013-07-15','17:15:00',5.82),('9650','2013-07-15','17:20:00',2.98),('9650','2013-07-15','17:25:00',4.09),('9650','2013-07-15','17:30:00',3.54),('9650','2013-07-15','17:35:00',4.83),('9650','2013-07-15','17:40:00',5.2),('9650','2013-07-15','17:45:00',5.31),('9650','2013-07-15','17:50:00',4.92),('9650','2013-07-15','17:55:00',3.27),('9650','2013-07-15','18:00:00',2.35),('9650','2013-07-15','18:05:00',3.49),('9650','2013-07-15','18:10:00',3.26),('9650','2013-07-15','18:15:00',4),('9650','2013-07-15','18:20:00',3.73),('9650','2013-07-15','18:25:00',3.72),('9650','2013-07-15','18:30:00',3.58),('9650','2013-07-15','18:35:00',3.37),('9650','2013-07-15','18:40:00',3.1),('9650','2013-07-15','18:45:00',2.91),('9650','2013-07-15','18:50:00',2.73),('9650','2013-07-15','18:55:00',2.53),('9650','2013-07-15','19:00:00',2.33),('9650','2013-07-15','19:05:00',2.16),('9650','2013-07-15','19:10:00',2.08),('9650','2013-07-15','19:15:00',1.68),('9650','2013-07-15','19:20:00',1.67),('9650','2013-07-15','19:25:00',1.38),('9650','2013-07-15','19:30:00',1.24),('9650','2013-07-15','19:35:00',1.15),('9650','2013-07-14','08:00:00',1.03),('9650','2013-07-14','08:05:00',1.1),('9650','2013-07-14','08:10:00',1.19),('9650','2013-07-14','08:15:00',1.29),('9650','2013-07-14','08:20:00',1.38),('9650','2013-07-14','08:25:00',1.47),('9650','2013-07-14','08:30:00',1.61),('9650','2013-07-14','08:35:00',1.71),('9650','2013-07-14','08:40:00',1.9),('9650','2013-07-14','08:45:00',2.05),('9650','2013-07-14','08:50:00',2.15),('9650','2013-07-14','08:55:00',2.29),('9650','2013-07-14','09:00:00',2.39),('9650','2013-07-14','09:05:00',2.5),('9650','2013-07-14','09:10:00',2.64),('9650','2013-07-14','09:15:00',2.74),('9650','2013-07-14','09:20:00',2.87),('9650','2013-07-14','09:25:00',2.98),('9650','2013-07-14','09:30:00',3.11),('9650','2013-07-14','09:35:00',3.25),('9650','2013-07-14','09:40:00',3.4),('9650','2013-07-14','09:45:00',3.55),('9650','2013-07-14','09:50:00',3.66),('9650','2013-07-14','09:55:00',3.77),('9650','2013-07-14','10:00:00',3.88),('9650','2013-07-14','10:05:00',4),('9650','2013-07-14','10:10:00',4.1),('9650','2013-07-14','10:15:00',4.21),('9650','2013-07-14','10:20:00',4.26),('9650','2013-07-14','10:25:00',4.39),('9650','2013-07-14','10:30:00',4.48),('9650','2013-07-14','10:35:00',4.55),('9650','2013-07-14','10:40:00',4.68),('9650','2013-07-14','10:45:00',4.79),('9650','2013-07-14','10:50:00',4.9),('9650','2013-07-14','10:55:00',5.02),('9650','2013-07-14','11:00:00',5.13),('9650','2013-07-14','11:05:00',5.23),('9650','2013-07-14','11:10:00',5.31),('9650','2013-07-14','11:15:00',5.39),('9650','2013-07-14','11:20:00',5.48),('9650','2013-07-14','11:25:00',5.6),('9650','2013-07-14','11:30:00',5.65),('9650','2013-07-14','11:35:00',5.75),('9650','2013-07-14','11:40:00',5.81),('9650','2013-07-14','11:45:00',5.93),('9650','2013-07-14','11:50:00',5.94),('9650','2013-07-14','11:55:00',6.04),('9650','2013-07-14','12:00:00',6.15),('9650','2013-07-14','12:05:00',6.16),('9650','2013-07-14','12:10:00',6.17),('9650','2013-07-14','12:15:00',6.24),('9650','2013-07-14','12:20:00',6.39),('9650','2013-07-14','12:25:00',6.41),('9650','2013-07-14','12:30:00',6.42),('9650','2013-07-14','12:35:00',6.47),('9650','2013-07-14','12:40:00',6.49),('9650','2013-07-14','12:45:00',6.53),('9650','2013-07-14','12:50:00',6.53),('9650','2013-07-14','12:55:00',6.59),('9650','2013-07-14','13:00:00',6.81),('9650','2013-07-14','13:05:00',4.69),('9650','2013-07-14','13:10:00',4.71),('9650','2013-07-14','13:15:00',7.05),('9650','2013-07-14','13:20:00',6.94),('9650','2013-07-14','13:25:00',7.23),('9650','2013-07-14','13:30:00',7.49),('9650','2013-07-14','13:35:00',7.46),('9650','2013-07-14','13:40:00',3.16),('9650','2013-07-14','13:45:00',3.63),('9650','2013-07-14','13:50:00',4.88),('9650','2013-07-14','13:55:00',6.22),('9650','2013-07-14','14:00:00',7.89),('9650','2013-07-14','14:05:00',7.81),('9650','2013-07-14','14:10:00',3.53),('9650','2013-07-14','14:15:00',1.63),('9650','2013-07-14','14:20:00',4.32),('9650','2013-07-14','14:25:00',7.85),('9650','2013-07-14','14:30:00',7.59),('9650','2013-07-14','14:35:00',7.51),('9650','2013-07-14','14:40:00',7.37),('9650','2013-07-14','14:45:00',7.38),('9650','2013-07-14','14:50:00',7.35),('9650','2013-07-14','14:55:00',7.38),('9650','2013-07-14','15:00:00',7.4),('9650','2013-07-14','15:05:00',7.23),('9650','2013-07-14','15:10:00',7.15),('9650','2013-07-14','15:15:00',7.04),('9650','2013-07-14','15:20:00',4.49),('9650','2013-07-14','15:25:00',2.32),('9650','2013-07-14','15:30:00',7.33),('9650','2013-07-14','15:35:00',7.26),('9650','2013-07-14','15:40:00',7.21),('9650','2013-07-14','15:45:00',6.95),('9650','2013-07-14','15:50:00',6.99),('9650','2013-07-14','15:55:00',6.82),('9650','2013-07-14','16:00:00',6.59),('9650','2013-07-14','16:05:00',6.62),('9650','2013-07-14','16:10:00',6.59),('9650','2013-07-14','16:15:00',6.45),('9650','2013-07-14','16:20:00',6.31),('9650','2013-07-14','16:25:00',6.19),('9650','2013-07-14','16:30:00',6.2),('9650','2013-07-14','16:35:00',6.2),('9650','2013-07-14','16:40:00',6.11),('9650','2013-07-14','16:45:00',6.02),('9650','2013-07-14','16:50:00',5.97),('9650','2013-07-14','16:55:00',5.93),('9650','2013-07-14','17:00:00',5.84),('9650','2013-07-14','17:05:00',5.77),('9650','2013-07-14','17:10:00',5.6),('9650','2013-07-14','17:15:00',5.54),('9650','2013-07-14','17:20:00',5.43),('9650','2013-07-14','17:25:00',5.35),('9650','2013-07-14','17:30:00',5.25),('9650','2013-07-14','17:35:00',5.09),('9650','2013-07-14','17:40:00',4.93),('9650','2013-07-14','17:45:00',4.76),('9650','2013-07-14','17:50:00',4.64),('9650','2013-07-14','17:55:00',4.49),('9650','2013-07-14','18:00:00',4.35),('9650','2013-07-14','18:05:00',4.24),('9650','2013-07-14','18:10:00',4.14),('9650','2013-07-14','18:15:00',3.98),('9650','2013-07-14','18:20:00',3.8),('9650','2013-07-14','18:25:00',3.68),('9650','2013-07-14','18:30:00',3.52),('9650','2013-07-14','18:35:00',3.34),('9650','2013-07-14','18:40:00',3.24),('9650','2013-07-14','18:45:00',3.11),('9650','2013-07-14','18:50:00',2.96),('9650','2013-07-14','18:55:00',2.78),('9650','2013-07-14','19:00:00',2.69),('9650','2013-07-14','19:05:00',2.53),('9650','2013-07-14','19:10:00',2.33),('9650','2013-07-14','19:15:00',2.12),('9650','2013-07-14','19:20:00',1.94),('9650','2013-07-14','19:25:00',1.74),('9650','2013-07-14','19:30:00',1.59),('9650','2013-07-14','19:35:00',1.4),('9650','2013-07-14','19:40:00',1.12),('9650','2013-07-13','07:40:00',1.12),('9650','2013-07-13','07:45:00',1.3),('9650','2013-07-13','07:50:00',1.57),('9650','2013-07-13','07:55:00',1.86),('9650','2013-07-13','08:00:00',1.83),('9650','2013-07-13','08:05:00',1.86),('9650','2013-07-13','08:10:00',2.01),('9650','2013-07-13','08:15:00',1.83),('9650','2013-07-13','08:20:00',2.38),('9650','2013-07-13','08:25:00',1.79),('9650','2013-07-13','08:30:00',1.47),('9650','2013-07-13','08:35:00',1.7),('9650','2013-07-13','08:40:00',1.57),('9650','2013-07-13','08:45:00',1.41),('9650','2013-07-13','08:50:00',1.5),('9650','2013-07-13','08:55:00',1.57),('9650','2013-07-13','09:00:00',1.66),('9650','2013-07-13','09:05:00',1.7),('9650','2013-07-13','09:10:00',2.01),('9650','2013-07-13','09:15:00',2.01),('9650','2013-07-13','09:20:00',1.94),('9650','2013-07-13','09:25:00',2.93),('9650','2013-07-13','09:30:00',3.31),('9650','2013-07-13','09:35:00',3.06),('9650','2013-07-13','09:40:00',2.67),('9650','2013-07-13','09:45:00',2.64),('9650','2013-07-13','09:50:00',2.56),('9650','2013-07-13','09:55:00',2.59),('9650','2013-07-13','10:00:00',2.51),('9650','2013-07-13','10:05:00',2.73),('9650','2013-07-13','10:10:00',2.39),('9650','2013-07-13','10:15:00',2.46),('9650','2013-07-13','10:20:00',3.5),('9650','2013-07-13','10:25:00',3.89),('9650','2013-07-13','10:30:00',3.74),('9650','2013-07-13','10:35:00',4.72),('9650','2013-07-13','10:40:00',4.57),('9650','2013-07-13','10:45:00',4),('9650','2013-07-13','10:50:00',5.44),('9650','2013-07-13','10:55:00',4.68),('9650','2013-07-13','11:00:00',4.02),('9650','2013-07-13','11:05:00',1.75),('9650','2013-07-13','11:10:00',2.08),('9650','2013-07-13','11:15:00',2.39),('9650','2013-07-13','11:20:00',3.37),('9650','2013-07-13','11:25:00',2.15),('9650','2013-07-13','11:30:00',2.14),('9650','2013-07-13','11:35:00',4.4),('9650','2013-07-13','11:40:00',6.01),('9650','2013-07-13','11:45:00',3.87),('9650','2013-07-13','11:50:00',4.27),('9650','2013-07-13','11:55:00',3.88),('9650','2013-07-13','12:00:00',4.14),('9650','2013-07-13','12:05:00',3.02),('9650','2013-07-13','12:10:00',2.78),('9650','2013-07-13','12:15:00',4.99),('9650','2013-07-13','12:20:00',6.08),('9650','2013-07-13','12:25:00',4.16),('9650','2013-07-13','12:30:00',7.23),('9650','2013-07-13','12:35:00',7.47),('9650','2013-07-13','12:40:00',7.54),('9650','2013-07-13','12:45:00',6.99),('9650','2013-07-13','12:50:00',7.26),('9650','2013-07-13','12:55:00',5.56),('9650','2013-07-13','13:00:00',5.04),('9650','2013-07-13','13:05:00',7.82),('9650','2013-07-13','13:10:00',7.53),('9650','2013-07-13','13:15:00',7.21),('9650','2013-07-13','13:20:00',7.17),('9650','2013-07-13','13:25:00',7.14),('9650','2013-07-13','13:30:00',7.26),('9650','2013-07-13','13:35:00',7.12),('9650','2013-07-13','13:40:00',7.19),('9650','2013-07-13','13:45:00',7.19),('9650','2013-07-13','13:50:00',7.36),('9650','2013-07-13','13:55:00',7.29),('9650','2013-07-13','14:00:00',7.33),('9650','2013-07-13','14:05:00',7.39),('9650','2013-07-13','14:10:00',7.42),('9650','2013-07-13','14:15:00',7.47),('9650','2013-07-13','14:20:00',7.47),('9650','2013-07-13','14:25:00',7.36),('9650','2013-07-13','14:30:00',7.39),('9650','2013-07-13','14:35:00',7.37),('9650','2013-07-13','14:40:00',7.31),('9650','2013-07-13','14:45:00',7.19),('9650','2013-07-13','14:50:00',7.14),('9650','2013-07-13','14:55:00',7.1),('9650','2013-07-13','15:00:00',7.12),('9650','2013-07-13','15:05:00',7.16),('9650','2013-07-13','15:10:00',7.12),('9650','2013-07-13','15:15:00',7.16),('9650','2013-07-13','15:20:00',7.08),('9650','2013-07-13','15:25:00',7.02),('9650','2013-07-13','15:30:00',7.03),('9650','2013-07-13','15:35:00',7.04),('9650','2013-07-13','15:40:00',6.94),('9650','2013-07-13','15:45:00',6.89),('9650','2013-07-13','15:50:00',6.85),('9650','2013-07-13','15:55:00',6.81),('9650','2013-07-13','16:00:00',6.66),('9650','2013-07-13','16:05:00',6.38),('9650','2013-07-13','16:10:00',6.7),('9650','2013-07-13','16:15:00',6.69),('9650','2013-07-13','16:20:00',6.56),('9650','2013-07-13','16:25:00',5.11),('9650','2013-07-13','16:30:00',5.29),('9650','2013-07-13','16:35:00',6.75),('9650','2013-07-13','16:40:00',6.38),('9650','2013-07-13','16:45:00',6.02),('9650','2013-07-13','16:50:00',5.39),('9650','2013-07-13','16:55:00',4.46),('9650','2013-07-13','17:00:00',5.98),('9650','2013-07-13','17:05:00',3.86),('9650','2013-07-13','17:10:00',5.3),('9650','2013-07-13','17:15:00',5.01),('9650','2013-07-13','17:20:00',3.29),('9650','2013-07-13','17:25:00',5.07),('9650','2013-07-13','17:30:00',6.01),('9650','2013-07-13','17:35:00',5.42),('9650','2013-07-13','17:40:00',3.26),('9650','2013-07-13','17:45:00',4.47),('9650','2013-07-13','17:50:00',4.29),('9650','2013-07-13','17:55:00',4.81),('9650','2013-07-13','18:00:00',2.59),('9650','2013-07-13','18:05:00',3.41),('9650','2013-07-13','18:10:00',2.15),('9650','2013-07-13','18:40:00',1.24),('9650','2013-07-13','18:45:00',1.45),('9650','2013-07-13','18:50:00',1.28),('9650','2013-07-13','18:55:00',1.09),('9650','2013-07-13','19:05:00',1.47),('9650','2013-07-13','19:10:00',2.08),('9650','2013-07-13','19:15:00',2.02),('9650','2013-07-13','19:20:00',2.47),('9650','2013-07-13','19:25:00',2.03),('9650','2013-07-13','19:30:00',1.21),('9650','2013-07-12','07:55:00',1.02),('9650','2013-07-12','08:00:00',1.1),('9650','2013-07-12','08:05:00',1.17),('9650','2013-07-12','08:10:00',1.25),('9650','2013-07-12','08:15:00',1.32),('9650','2013-07-12','08:20:00',1.41),('9650','2013-07-12','08:25:00',1.49),('9650','2013-07-12','08:30:00',1.61),('9650','2013-07-12','08:35:00',1.72),('9650','2013-07-12','08:40:00',1.88),('9650','2013-07-12','08:45:00',1.99),('9650','2013-07-12','08:50:00',2.09),('9650','2013-07-12','08:55:00',2.19),('9650','2013-07-12','09:00:00',2.32),('9650','2013-07-12','09:05:00',2.46),('9650','2013-07-12','09:10:00',2.56),('9650','2013-07-12','09:15:00',2.66),('9650','2013-07-12','09:20:00',2.72),('9650','2013-07-12','09:25:00',2.89),('9650','2013-07-12','09:30:00',3.06),('9650','2013-07-12','09:35:00',3.19),('9650','2013-07-12','09:40:00',3.36),('9650','2013-07-12','09:45:00',3.47),('9650','2013-07-12','09:50:00',3.57),('9650','2013-07-12','09:55:00',3.71),('9650','2013-07-12','10:00:00',3.82),('9650','2013-07-12','10:05:00',3.95),('9650','2013-07-12','10:10:00',4.04),('9650','2013-07-12','10:15:00',4.14),('9650','2013-07-12','10:20:00',4.3),('9650','2013-07-12','10:25:00',4.34),('9650','2013-07-12','10:30:00',3.88),('9650','2013-07-12','10:35:00',4.08),('9650','2013-07-12','10:40:00',4.8),('9650','2013-07-12','10:45:00',4.91),('9650','2013-07-12','10:50:00',4.43),('9650','2013-07-12','10:55:00',5.33),('9650','2013-07-12','11:00:00',5.69),('9650','2013-07-12','11:05:00',5.1),('9650','2013-07-12','11:10:00',5.36),('9650','2013-07-12','11:15:00',5.85),('9650','2013-07-12','11:20:00',4.99),('9650','2013-07-12','11:25:00',3.79),('9650','2013-07-12','11:30:00',6.2),('9650','2013-07-12','11:35:00',6.39),('9650','2013-07-12','11:40:00',4.97),('9650','2013-07-12','11:45:00',1.77),('9650','2013-07-12','11:50:00',5.55),('9650','2013-07-12','11:55:00',6.55),('9650','2013-07-12','12:00:00',1.83),('9650','2013-07-12','12:05:00',4.15),('9650','2013-07-12','12:10:00',6.94),('9650','2013-07-12','12:15:00',5.63),('9650','2013-07-12','12:20:00',6.91),('9650','2013-07-12','12:25:00',6.05),('9650','2013-07-12','12:30:00',5.97),('9650','2013-07-12','12:35:00',5.12),('9650','2013-07-12','12:40:00',6.89),('9650','2013-07-12','12:45:00',6.97),('9650','2013-07-12','12:50:00',3.55),('9650','2013-07-12','12:55:00',6.25),('9650','2013-07-12','13:00:00',7.24),('9650','2013-07-12','13:05:00',7.28),('9650','2013-07-12','13:10:00',5.95),('9650','2013-07-12','13:15:00',7.2),('9650','2013-07-12','13:20:00',7.15),('9650','2013-07-12','13:25:00',6.98),('9650','2013-07-12','13:30:00',7.01),('9650','2013-07-12','13:35:00',7.12),('9650','2013-07-12','13:40:00',7.15),('9650','2013-07-12','13:45:00',7.16),('9650','2013-07-12','13:50:00',7.24),('9650','2013-07-12','13:55:00',7.19),('9650','2013-07-12','14:00:00',7.21),('9650','2013-07-12','14:05:00',7.22),('9650','2013-07-12','14:10:00',7.25),('9650','2013-07-12','14:15:00',7.25),('9650','2013-07-12','14:20:00',7.28),('9650','2013-07-12','14:25:00',7.27),('9650','2013-07-12','14:30:00',7.3),('9650','2013-07-12','14:35:00',7.34),('9650','2013-07-12','14:40:00',7.34),('9650','2013-07-12','14:45:00',7.34),('9650','2013-07-12','14:50:00',7.33),('9650','2013-07-12','14:55:00',7.31),('9650','2013-07-12','15:00:00',7.3),('9650','2013-07-12','15:05:00',7.39),('9650','2013-07-12','15:10:00',7.34),('9650','2013-07-12','15:15:00',7.36),('9650','2013-07-12','15:20:00',7),('9650','2013-07-12','15:25:00',7.3),('9650','2013-07-12','15:30:00',7.16),('9650','2013-07-12','15:35:00',7.28),('9650','2013-07-12','15:40:00',7.24),('9650','2013-07-12','15:45:00',7.16),('9650','2013-07-12','15:50:00',7.06),('9650','2013-07-12','15:55:00',7.01),('9650','2013-07-12','16:00:00',6.92),('9650','2013-07-12','16:05:00',6.89),('9650','2013-07-12','16:10:00',6.83),('9650','2013-07-12','16:15:00',6.76),('9650','2013-07-12','16:20:00',6.75),('9650','2013-07-12','16:25:00',6.78),('9650','2013-07-12','16:30:00',6.72),('9650','2013-07-12','16:35:00',6.6),('9650','2013-07-12','16:40:00',6.52),('9650','2013-07-12','16:45:00',6.39),('9650','2013-07-12','16:50:00',6.3),('9650','2013-07-12','16:55:00',6.24),('9650','2013-07-12','17:00:00',6.1),('9650','2013-07-12','17:05:00',5.93),('9650','2013-07-12','17:10:00',5.94),('9650','2013-07-12','17:15:00',5.8),('9650','2013-07-12','17:20:00',5.49),('9650','2013-07-12','17:25:00',5.63),('9650','2013-07-12','17:30:00',5.36),('9650','2013-07-12','17:35:00',5.22),('9650','2013-07-12','17:40:00',5.14),('9650','2013-07-12','17:45:00',5.08),('9650','2013-07-12','17:50:00',4.89),('9650','2013-07-12','17:55:00',4.99),('9650','2013-07-12','18:00:00',4.62),('9650','2013-07-12','18:05:00',4.39),('9650','2013-07-12','18:10:00',4.49),('9650','2013-07-12','18:15:00',4.38),('9650','2013-07-12','18:20:00',4.24),('9650','2013-07-12','18:25:00',4.14),('9650','2013-07-12','18:30:00',4),('9650','2013-07-12','18:35:00',3.76),('9650','2013-07-12','18:40:00',2.6),('9650','2013-07-12','18:45:00',1.8),('9650','2013-07-12','18:50:00',2.84),('9650','2013-07-12','18:55:00',3.31),('9650','2013-07-12','19:00:00',3.28),('9650','2013-07-12','19:05:00',3.01),('9650','2013-07-12','19:10:00',2.72),('9650','2013-07-12','19:15:00',1.68),('9650','2013-07-12','19:20:00',1.46),('9650','2013-07-12','19:25:00',1.04),('9650','2013-07-12','19:40:00',1.12),('9650','2013-07-12','19:45:00',1.4),('9650','2013-07-12','19:50:00',1.18),('9650','2013-07-11','07:50:00',1.19),('9650','2013-07-11','08:05:00',1.26),('9650','2013-07-11','08:10:00',1.89),('9650','2013-07-11','08:15:00',1.8),('9650','2013-07-11','08:20:00',1.6),('9650','2013-07-11','08:25:00',1.2),('9650','2013-07-11','08:30:00',1.23),('9650','2013-07-11','08:35:00',1.64),('9650','2013-07-11','08:40:00',1.65),('9650','2013-07-11','08:45:00',1.69),('9650','2013-07-11','08:50:00',1.4),('9650','2013-07-11','08:55:00',1.1),('9650','2013-07-11','09:00:00',1.07),('9650','2013-07-11','09:05:00',1.42),('9650','2013-07-11','09:10:00',2.3),('9650','2013-07-11','09:15:00',2.74),('9650','2013-07-11','09:20:00',3.67),('9650','2013-07-11','09:25:00',3.21),('9650','2013-07-11','09:30:00',2.09),('9650','2013-07-11','09:35:00',2.84),('9650','2013-07-11','09:40:00',2.87),('9650','2013-07-11','09:45:00',3.42),('9650','2013-07-11','09:50:00',3.63),('9650','2013-07-11','09:55:00',3.86),('9650','2013-07-11','10:00:00',3.79),('9650','2013-07-11','10:05:00',3.66),('9650','2013-07-11','10:10:00',4.07),('9650','2013-07-11','10:15:00',3.12),('9650','2013-07-11','10:20:00',3.42),('9650','2013-07-11','10:25:00',3.56),('9650','2013-07-11','10:30:00',2.94),('9650','2013-07-11','10:35:00',1.34),('9650','2013-07-11','10:40:00',1.59),('9650','2013-07-11','10:45:00',2.01),('9650','2013-07-11','10:50:00',2.99),('9650','2013-07-11','10:55:00',6.03),('9650','2013-07-11','11:00:00',3),('9650','2013-07-11','11:05:00',1.86),('9650','2013-07-11','11:10:00',2.49),('9650','2013-07-11','11:15:00',4.77),('9650','2013-07-11','11:20:00',6.13),('9650','2013-07-11','11:25:00',5.84),('9650','2013-07-11','11:30:00',5.37),('9650','2013-07-11','11:35:00',5.13),('9650','2013-07-11','11:40:00',5.94),('9650','2013-07-11','11:45:00',3.04),('9650','2013-07-11','11:50:00',5.19),('9650','2013-07-11','11:55:00',6.42),('9650','2013-07-11','12:00:00',6.6),('9650','2013-07-11','12:05:00',4.35),('9650','2013-07-11','12:10:00',5.53),('9650','2013-07-11','12:15:00',7.23),('9650','2013-07-11','12:20:00',6.56),('9650','2013-07-11','12:25:00',7.07),('9650','2013-07-11','12:30:00',7.31),('9650','2013-07-11','12:35:00',6.33),('9650','2013-07-11','12:40:00',5.79),('9650','2013-07-11','12:45:00',7.18),('9650','2013-07-11','12:50:00',6.2),('9650','2013-07-11','12:55:00',5.21),('9650','2013-07-11','13:00:00',7.22),('9650','2013-07-11','13:05:00',6.69),('9650','2013-07-11','13:10:00',7.14),('9650','2013-07-11','13:15:00',7.12),('9650','2013-07-11','13:20:00',6.96),('9650','2013-07-11','13:25:00',6.69),('9650','2013-07-11','13:30:00',7.27),('9650','2013-07-11','13:35:00',7.25),('9650','2013-07-11','13:40:00',7.32),('9650','2013-07-11','13:45:00',4.81),('9650','2013-07-11','13:50:00',7.58),('9650','2013-07-11','13:55:00',7.5),('9650','2013-07-11','14:00:00',7.64),('9650','2013-07-11','14:05:00',7.37),('9650','2013-07-11','14:10:00',4.47),('9650','2013-07-11','14:15:00',7.88),('9650','2013-07-11','14:20:00',7.92),('9650','2013-07-11','14:25:00',7.77),('9650','2013-07-11','14:30:00',7.68),('9650','2013-07-11','14:35:00',7.35),('9650','2013-07-11','14:40:00',7.23),('9650','2013-07-11','14:45:00',7.23),('9650','2013-07-11','14:50:00',7.2),('9650','2013-07-11','14:55:00',7.19),('9650','2013-07-11','15:00:00',7.09),('9650','2013-07-11','15:05:00',7.19),('9650','2013-07-11','15:10:00',7.2),('9650','2013-07-11','15:15:00',7.15),('9650','2013-07-11','15:20:00',7.1),('9650','2013-07-11','15:25:00',7.17),('9650','2013-07-11','15:30:00',7.13),('9650','2013-07-11','15:35:00',7.02),('9650','2013-07-11','15:40:00',6.98),('9650','2013-07-11','15:45:00',7.04),('9650','2013-07-11','15:50:00',6.75),('9650','2013-07-11','15:55:00',6.79),('9650','2013-07-11','16:00:00',6.73),('9650','2013-07-11','16:05:00',6.57),('9650','2013-07-11','16:10:00',6.61),('9650','2013-07-11','16:15:00',6.6),('9650','2013-07-11','16:20:00',6.47),('9650','2013-07-11','16:25:00',6.4),('9650','2013-07-11','16:30:00',6.33),('9650','2013-07-11','16:35:00',6.34),('9650','2013-07-11','16:40:00',6.29),('9650','2013-07-11','16:45:00',6.29),('9650','2013-07-11','16:50:00',6.12),('9650','2013-07-11','16:55:00',6.03),('9650','2013-07-11','17:00:00',5.9),('9650','2013-07-11','17:05:00',5.83),('9650','2013-07-11','17:10:00',5.69),('9650','2013-07-11','17:15:00',5.59),('9650','2013-07-11','17:20:00',5.42),('9650','2013-07-11','17:25:00',5.31),('9650','2013-07-11','17:30:00',5.24),('9650','2013-07-11','17:35:00',5.18),('9650','2013-07-11','17:40:00',5.06),('9650','2013-07-11','17:45:00',4.91),('9650','2013-07-11','17:50:00',4.84),('9650','2013-07-11','17:55:00',4.74),('9650','2013-07-11','18:00:00',4.58),('9650','2013-07-11','18:05:00',4.4),('9650','2013-07-11','18:10:00',4.29),('9650','2013-07-11','18:15:00',4.14),('9650','2013-07-11','18:20:00',3.9),('9650','2013-07-11','18:25:00',3.81),('9650','2013-07-11','18:30:00',3.67),('9650','2013-07-11','18:35:00',3.57),('9650','2013-07-11','18:40:00',3.41),('9650','2013-07-11','18:45:00',3.22),('9650','2013-07-11','18:50:00',3.04),('9650','2013-07-11','18:55:00',2.86),('9650','2013-07-11','19:00:00',2.71),('9650','2013-07-11','19:05:00',2.54),('9650','2013-07-11','19:10:00',2.38),('9650','2013-07-11','19:15:00',2.16),('9650','2013-07-11','19:20:00',1.58),('9650','2013-07-11','19:25:00',1.11),('9650','2013-07-11','19:30:00',1.55),('9650','2013-07-11','19:35:00',1.04),('9650','2013-07-10','07:55:00',1.05),('9650','2013-07-10','08:00:00',1.13),('9650','2013-07-10','08:05:00',1.21),('9650','2013-07-10','08:10:00',1.28),('9650','2013-07-10','08:15:00',1.36),('9650','2013-07-10','08:20:00',1.45),('9650','2013-07-10','08:25:00',1.53),('9650','2013-07-10','08:30:00',1.65),('9650','2013-07-10','08:35:00',1.74),('9650','2013-07-10','08:40:00',1.95),('9650','2013-07-10','08:45:00',2.03),('9650','2013-07-10','08:50:00',2.12),('9650','2013-07-10','08:55:00',2.28),('9650','2013-07-10','09:00:00',2.29),('9650','2013-07-10','09:05:00',2.37),('9650','2013-07-10','09:10:00',2.61),('9650','2013-07-10','09:15:00',2.82),('9650','2013-07-10','09:20:00',2.76),('9650','2013-07-10','09:25:00',2.52),('9650','2013-07-10','09:30:00',2.03),('9650','2013-07-10','09:35:00',3.63),('9650','2013-07-10','09:40:00',3.55),('9650','2013-07-10','09:45:00',3.92),('9650','2013-07-10','09:50:00',4.16),('9650','2013-07-10','09:55:00',2.36),('9650','2013-07-10','10:00:00',2.82),('9650','2013-07-10','10:05:00',2.22),('9650','2013-07-10','10:10:00',3.78),('9650','2013-07-10','10:15:00',4.79),('9650','2013-07-10','10:20:00',4.47),('9650','2013-07-10','10:25:00',4.66),('9650','2013-07-10','10:30:00',4.47),('9650','2013-07-10','10:35:00',4.04),('9650','2013-07-10','10:40:00',2.36),('9650','2013-07-10','10:45:00',5.24),('9650','2013-07-10','10:50:00',5.54),('9650','2013-07-10','10:55:00',5.59),('9650','2013-07-10','11:00:00',5.71),('9650','2013-07-10','11:05:00',4.84),('9650','2013-07-10','11:10:00',6.08),('9650','2013-07-10','11:15:00',5.34),('9650','2013-07-10','11:20:00',6.42),('9650','2013-07-10','11:25:00',5.33),('9650','2013-07-10','11:30:00',5.77),('9650','2013-07-10','11:35:00',3.75),('9650','2013-07-10','11:40:00',4.96),('9650','2013-07-10','11:45:00',3.33),('9650','2013-07-10','11:50:00',4.64),('9650','2013-07-10','11:55:00',7.31),('9650','2013-07-10','12:00:00',4.11),('9650','2013-07-10','12:05:00',3.08),('9650','2013-07-10','12:10:00',2.15),('9650','2013-07-10','12:15:00',4.23),('9650','2013-07-10','12:20:00',7.21),('9650','2013-07-10','12:25:00',7.41),('9650','2013-07-10','12:30:00',7.37),('9650','2013-07-10','12:35:00',7.19),('9650','2013-07-10','12:40:00',7.31),('9650','2013-07-10','12:45:00',7.01),('9650','2013-07-10','12:50:00',7.11),('9650','2013-07-10','12:55:00',5.26),('9650','2013-07-10','13:00:00',7.27),('9650','2013-07-10','13:05:00',7.24),('9650','2013-07-10','13:10:00',7.23),('9650','2013-07-10','13:15:00',5.87),('9650','2013-07-10','13:20:00',6.68),('9650','2013-07-10','13:25:00',6.68),('9650','2013-07-10','13:30:00',6.34),('9650','2013-07-10','13:35:00',7.03),('9650','2013-07-10','13:40:00',7.35),('9650','2013-07-10','13:45:00',6.03),('9650','2013-07-10','13:50:00',4.11),('9650','2013-07-10','13:55:00',4.32),('9650','2013-07-10','14:00:00',7.36),('9650','2013-07-10','14:05:00',7.49),('9650','2013-07-10','14:10:00',6.83),('9650','2013-07-10','14:15:00',7.56),('9650','2013-07-10','14:20:00',7.14),('9650','2013-07-10','14:25:00',7.6),('9650','2013-07-10','14:30:00',7.54),('9650','2013-07-10','14:35:00',7.21),('9650','2013-07-10','14:40:00',6.93),('9650','2013-07-10','14:45:00',7.4),('9650','2013-07-10','14:50:00',7.22),('9650','2013-07-10','14:55:00',5.38),('9650','2013-07-10','15:00:00',5.2),('9650','2013-07-10','15:05:00',4.14),('9650','2013-07-10','15:10:00',6.57),('9650','2013-07-10','15:15:00',4.44),('9650','2013-07-10','15:20:00',5.85),('9650','2013-07-10','15:25:00',4.68),('9650','2013-07-10','15:30:00',7.56),('9650','2013-07-10','15:35:00',5.42),('9650','2013-07-10','15:40:00',7.22),('9650','2013-07-10','15:45:00',6.55),('9650','2013-07-10','15:50:00',5.27),('9650','2013-07-10','15:55:00',2.17),('9650','2013-07-10','16:00:00',7.18),('9650','2013-07-10','16:05:00',3.76),('9650','2013-07-10','16:10:00',7.46),('9650','2013-07-10','16:15:00',2.88),('9650','2013-07-10','16:20:00',6.94),('9650','2013-07-10','16:25:00',3.26),('9650','2013-07-10','16:30:00',5.01),('9650','2013-07-10','16:35:00',4.73),('9650','2013-07-10','16:40:00',6.12),('9650','2013-07-10','16:45:00',6.42),('9650','2013-07-10','16:50:00',6.46),('9650','2013-07-10','16:55:00',6.36),('9650','2013-07-10','17:00:00',4.31),('9650','2013-07-10','17:05:00',4.64),('9650','2013-07-10','17:10:00',5.56),('9650','2013-07-10','17:15:00',4.97),('9650','2013-07-10','17:20:00',4.81),('9650','2013-07-10','17:25:00',4.88),('9650','2013-07-10','17:30:00',5.63),('9650','2013-07-10','17:35:00',4.77),('9650','2013-07-10','17:40:00',5.07),('9650','2013-07-10','17:45:00',4.33),('9650','2013-07-10','17:50:00',4.74),('9650','2013-07-10','17:55:00',4.84),('9650','2013-07-10','18:00:00',4.87),('9650','2013-07-10','18:05:00',3.13),('9650','2013-07-10','18:10:00',4.67),('9650','2013-07-10','18:15:00',4.57),('9650','2013-07-10','18:20:00',3.16),('9650','2013-07-10','18:25:00',3.38),('9650','2013-07-10','18:30:00',3.39),('9650','2013-07-10','18:35:00',2.31),('9650','2013-07-10','18:40:00',2.35),('9650','2013-07-10','18:45:00',1.83),('9650','2013-07-10','18:50:00',1.26),('9650','2013-07-10','18:55:00',1.4),('9650','2013-07-10','19:00:00',2.02),('9650','2013-07-10','19:05:00',1.77),('9650','2013-07-10','19:10:00',1.98),('9650','2013-07-10','19:15:00',2.3),('9650','2013-07-10','19:20:00',2.06),('9650','2013-07-10','19:25:00',1.08),('9650','2013-07-10','19:30:00',1.46),('9650','2013-07-10','19:35:00',1.42),('9650','2014-05-02','08:10:00',1.23),('9650','2014-05-02','08:15:00',1.43),('9650','2014-05-02','08:20:00',1.37),('9650','2014-05-02','08:25:00',1.3),('9650','2014-05-02','08:30:00',1.46),('9650','2014-05-02','08:35:00',1.03),('9650','2014-05-02','08:45:00',1.55),('9650','2014-05-02','08:50:00',2.17),('9650','2014-05-02','08:55:00',2.92),('9650','2014-05-02','09:00:00',3.07),('9650','2014-05-02','09:05:00',2.26),('9650','2014-05-02','09:10:00',1.9),('9650','2014-05-02','09:15:00',3.15),('9650','2014-05-02','09:20:00',3.36),('9650','2014-05-02','09:25:00',2.91),('9650','2014-05-02','09:30:00',3.16),('9650','2014-05-02','09:35:00',4.21),('9650','2014-05-02','09:40:00',3.38),('9650','2014-05-02','09:45:00',3.43),('9650','2014-05-02','09:50:00',1.91),('9650','2014-05-02','09:55:00',4.14),('9650','2014-05-02','10:00:00',4.59),('9650','2014-05-02','10:05:00',4.69),('9650','2014-05-02','10:10:00',4.97),('9650','2014-05-02','10:15:00',5.65),('9650','2014-05-02','10:20:00',4.94),('9650','2014-05-02','10:25:00',4.44),('9650','2014-05-02','10:30:00',3.02),('9650','2014-05-02','10:35:00',1.79),('9650','2014-05-02','10:40:00',1.87),('9650','2014-05-02','10:45:00',2.05),('9650','2014-05-02','10:50:00',1.88),('9650','2014-05-02','10:55:00',2.19),('9650','2014-05-02','11:00:00',1.95),('9650','2014-05-02','11:05:00',5.59),('9650','2014-05-02','11:10:00',5.27),('9650','2014-05-02','11:15:00',7.68),('9650','2014-05-02','11:20:00',5.86),('9650','2014-05-02','11:25:00',5.75),('9650','2014-05-02','11:30:00',6.71),('9650','2014-05-02','11:35:00',4.5),('9650','2014-05-02','11:40:00',4.79),('9650','2014-05-02','11:45:00',4.29),('9650','2014-05-02','11:50:00',3.89),('9650','2014-05-02','11:55:00',3.98),('9650','2014-05-02','12:00:00',3.25),('9650','2014-05-02','12:05:00',2.69),('9650','2014-05-02','12:10:00',2.44),('9650','2014-05-02','12:15:00',2.29),('9650','2014-05-02','12:20:00',2.14),('9650','2014-05-02','12:25:00',2.2),('9650','2014-05-02','12:30:00',2.8),('9650','2014-05-02','12:35:00',3.6),('9650','2014-05-02','12:40:00',3.57),('9650','2014-05-02','12:45:00',3.63),('9650','2014-05-02','12:50:00',3.27),('9650','2014-05-02','12:55:00',3.2),('9650','2014-05-02','13:00:00',3.55),('9650','2014-05-02','13:05:00',4.1),('9650','2014-05-02','13:10:00',5.91),('9650','2014-05-02','13:15:00',5.09),('9650','2014-05-02','13:20:00',3.98),('9650','2014-05-02','13:25:00',5.18),('9650','2014-05-02','13:30:00',5.95),('9650','2014-05-02','13:35:00',4.49),('9650','2014-05-02','13:40:00',3.59),('9650','2014-05-02','13:45:00',3.39),('9650','2014-05-02','13:50:00',3.38),('9650','2014-05-02','13:55:00',3.4),('9650','2014-05-02','14:00:00',3.36),('9650','2014-05-02','14:05:00',3.42),('9650','2014-05-02','14:10:00',3.71),('9650','2014-05-02','14:15:00',4.23),('9650','2014-05-02','14:20:00',4.94),('9650','2014-05-02','14:25:00',6.36),('9650','2014-05-02','14:30:00',4.41),('9650','2014-05-02','14:35:00',2.89),('9650','2014-05-02','14:40:00',2.19),('9650','2014-05-02','14:45:00',1.36),('9650','2014-05-02','14:50:00',1.15),('9650','2014-05-02','14:55:00',3.73),('9650','2014-05-02','15:00:00',3.44),('9650','2014-05-02','15:05:00',1.86),('9650','2014-05-02','15:10:00',1.49),('9650','2014-05-02','15:15:00',1.06),('9650','2014-05-02','16:30:00',1.12),('9650','2014-05-02','16:35:00',1.22),('9650','2014-05-02','16:40:00',1.28),('9650','2014-05-02','16:45:00',1.32),('9650','2014-05-02','16:50:00',1.34),('9650','2014-05-02','16:55:00',1.37),('9650','2014-05-02','17:00:00',1.36),('9650','2014-05-02','17:05:00',1.61),('9650','2014-05-02','17:10:00',1.7),('9650','2014-05-02','17:15:00',1.71),('9650','2014-05-02','17:20:00',1.73),('9650','2014-05-02','17:25:00',1.77),('9650','2014-05-02','17:30:00',1.74),('9650','2014-05-02','17:35:00',1.71),('9650','2014-05-02','17:40:00',1.78),('9650','2014-05-02','17:45:00',1.94),('9650','2014-05-02','17:50:00',2.36),('9650','2014-05-02','17:55:00',2.45),('9650','2014-05-02','18:00:00',1.94),('9650','2014-05-02','18:05:00',1.7),('9650','2014-05-02','18:10:00',1.85),('9650','2014-05-02','18:15:00',1.71),('9650','2014-05-02','18:20:00',1.22),('9650','2014-05-02','18:25:00',1.62),('9650','2014-05-02','18:30:00',1.1),('9650','2014-05-02','18:40:00',1.29),('9650','2014-05-02','18:45:00',2.1),('9650','2014-05-02','18:50:00',1.34),('9650','2014-05-02','18:55:00',1.11),('9650','2014-05-02','19:05:00',1.06),('9650','2014-05-02','19:10:00',1.26),('9650','2014-04-05','09:10:00',1.15),('9650','2014-04-05','09:15:00',1.47),('9650','2014-04-05','09:20:00',1.45),('9650','2014-04-05','09:25:00',1.47),('9650','2014-04-05','09:30:00',1.61),('9650','2014-04-05','09:35:00',2.24),('9650','2014-04-05','09:40:00',2.62),('9650','2014-04-05','09:45:00',3.27),('9650','2014-04-05','09:50:00',3.8),('9650','2014-04-05','09:55:00',3.88),('9650','2014-04-05','10:00:00',3.48),('9650','2014-04-05','10:05:00',3.05),('9650','2014-04-05','10:10:00',2.84),('9650','2014-04-05','10:15:00',3.33),('9650','2014-04-05','10:20:00',2.57),('9650','2014-04-05','10:25:00',2.06),('9650','2014-04-05','10:30:00',2.17),('9650','2014-04-05','10:35:00',2.37),('9650','2014-04-05','10:40:00',2.5),('9650','2014-04-05','10:45:00',3.61),('9650','2014-04-05','10:50:00',4.24),('9650','2014-04-05','10:55:00',2.32),('9650','2014-04-05','11:00:00',3.22),('9650','2014-04-05','11:05:00',3.44),('9650','2014-04-05','11:10:00',5.24),('9650','2014-04-05','11:15:00',2.29),('9650','2014-04-05','11:20:00',5.23),('9650','2014-04-05','11:25:00',5.16),('9650','2014-04-05','11:30:00',5.63),('9650','2014-04-05','11:35:00',6.29),('9650','2014-04-05','11:40:00',6.18),('9650','2014-04-05','11:45:00',5.93),('9650','2014-04-05','11:50:00',5.69),('9650','2014-04-05','11:55:00',5.94),('9650','2014-04-05','12:00:00',6.1),('9650','2014-04-05','12:05:00',5.93),('9650','2014-04-05','12:10:00',5.92),('9650','2014-04-05','12:15:00',6.36),('9650','2014-04-05','12:20:00',4.88),('9650','2014-04-05','12:25:00',3.74),('9650','2014-04-05','12:30:00',3.33),('9650','2014-04-05','12:35:00',3.83),('9650','2014-04-05','12:40:00',2.6),('9650','2014-04-05','12:45:00',1.75),('9650','2014-04-05','12:50:00',2.19),('9650','2014-04-05','12:55:00',3.49),('9650','2014-04-05','13:00:00',6.55),('9650','2014-04-05','13:05:00',5.05),('9650','2014-04-05','13:10:00',6.7),('9650','2014-04-05','13:15:00',5.79),('9650','2014-04-05','13:20:00',4.5),('9650','2014-04-05','13:25:00',2),('9650','2014-04-05','13:30:00',6.11),('9650','2014-04-05','13:35:00',4.78),('9650','2014-04-05','13:40:00',1.92),('9650','2014-04-05','13:45:00',6.92),('9650','2014-04-05','13:50:00',7.15),('9650','2014-04-05','13:55:00',7.13),('9650','2014-04-05','14:00:00',6.9),('9650','2014-04-05','14:05:00',6.46),('9650','2014-04-05','14:10:00',7.03),('9650','2014-04-05','14:15:00',7.12),('9650','2014-04-05','14:20:00',3.95),('9650','2014-04-05','14:25:00',2.68),('9650','2014-04-05','14:30:00',1.84),('9650','2014-04-05','14:35:00',2.14),('9650','2014-04-05','14:40:00',3.91),('9650','2014-04-05','14:45:00',8.44),('9650','2014-04-05','14:50:00',6.39),('9650','2014-04-05','14:55:00',4.85),('9650','2014-04-05','15:00:00',3.67),('9650','2014-04-05','15:05:00',2.15),('9650','2014-04-05','15:10:00',5.84),('9650','2014-04-05','15:15:00',5.3),('9650','2014-04-05','15:20:00',4.24),('9650','2014-04-05','15:25:00',1.99),('9650','2014-04-05','15:30:00',1.77),('9650','2014-04-05','15:35:00',1.09),('9650','2014-04-05','15:40:00',1.21),('9650','2014-04-05','15:45:00',1.64),('9650','2014-04-05','15:50:00',2.76),('9650','2014-04-05','15:55:00',6.78),('9650','2014-04-05','16:00:00',6.27),('9650','2014-04-05','16:05:00',2.9),('9650','2014-04-05','16:15:00',2.05),('9650','2014-04-05','16:20:00',1.19),('9650','2014-04-05','16:25:00',1.67),('9650','2014-04-05','16:30:00',1.93),('9650','2014-04-05','16:35:00',2.94),('9650','2014-04-05','16:40:00',4.88),('9650','2014-04-05','16:45:00',6),('9650','2014-04-05','16:50:00',5.93),('9650','2014-04-05','16:55:00',4.49),('9650','2014-04-05','17:00:00',1.68),('9650','2014-04-05','17:05:00',1.42),('9650','2014-04-05','17:10:00',1.14),('9650','2014-04-05','17:15:00',1.1),('9650','2014-04-05','17:20:00',1.6),('9650','2014-04-05','17:25:00',4.09),('9650','2014-04-05','17:30:00',4.34),('9650','2014-04-05','17:35:00',2.93),('9650','2014-04-05','17:40:00',1.66),('9650','2014-04-05','17:45:00',2.67),('9650','2014-04-05','17:50:00',3.84),('9650','2014-04-05','17:55:00',3.5),('9650','2014-04-05','18:00:00',3.29),('9650','2014-04-05','18:05:00',3.08),('9650','2014-04-05','18:10:00',2.97),('9650','2014-04-05','18:15:00',2.92),('9650','2014-04-05','18:20:00',2.88),('9650','2014-04-05','18:25:00',2.63),('9650','2014-04-05','18:30:00',1.43),('9650','2014-04-05','18:35:00',1.67),('9650','2014-04-05','18:40:00',1.49),('9650','2014-04-05','18:45:00',1.34),('9650','2014-04-05','18:50:00',1.04),('9650','2013-07-09','07:25:00',1.12),('9650','2013-07-09','07:30:00',1.26),('9650','2013-07-09','07:35:00',1.42),('9650','2013-07-09','07:40:00',1.56),('9650','2013-07-09','07:45:00',1.65),('9650','2013-07-09','07:50:00',1.78),('9650','2013-07-09','07:55:00',1.92),('9650','2013-07-09','08:00:00',1.93),('9650','2013-07-09','08:05:00',1.74),('9650','2013-07-09','08:10:00',2.05),('9650','2013-07-09','08:15:00',2.08),('9650','2013-07-09','08:20:00',2.04),('9650','2013-07-09','08:25:00',2.32),('9650','2013-07-09','08:30:00',2.19),('9650','2013-07-09','08:35:00',2.07),('9650','2013-07-09','08:40:00',2.61),('9650','2013-07-09','08:45:00',2.48),('9650','2013-07-09','08:50:00',2.49),('9650','2013-07-09','08:55:00',2.46),('9650','2013-07-09','09:00:00',2.5),('9650','2013-07-09','09:05:00',2.71),('9650','2013-07-09','09:10:00',2.87),('9650','2013-07-09','09:15:00',3),('9650','2013-07-09','09:20:00',3.05),('9650','2013-07-09','09:25:00',2.12),('9650','2013-07-09','09:30:00',3.03),('9650','2013-07-09','09:35:00',3.33),('9650','2013-07-09','09:40:00',3.46),('9650','2013-07-09','09:45:00',3.57),('9650','2013-07-09','09:50:00',3.6),('9650','2013-07-09','09:55:00',2.94),('9650','2013-07-09','10:00:00',3.91),('9650','2013-07-09','10:05:00',4.03),('9650','2013-07-09','10:10:00',4.12),('9650','2013-07-09','10:15:00',4.22),('9650','2013-07-09','10:20:00',4.31),('9650','2013-07-09','10:25:00',4.47),('9650','2013-07-09','10:30:00',4.56),('9650','2013-07-09','10:35:00',4.68),('9650','2013-07-09','10:40:00',4.81),('9650','2013-07-09','10:45:00',4.92),('9650','2013-07-09','10:50:00',5.03),('9650','2013-07-09','10:55:00',5.09),('9650','2013-07-09','11:00:00',5.2),('9650','2013-07-09','11:05:00',5.25),('9650','2013-07-09','11:10:00',5.35),('9650','2013-07-09','11:15:00',5.45),('9650','2013-07-09','11:20:00',5.48),('9650','2013-07-09','11:25:00',5.56),('9650','2013-07-09','11:30:00',5.6),('9650','2013-07-09','11:35:00',5.71),('9650','2013-07-09','11:40:00',5.83),('9650','2013-07-09','11:45:00',5.91),('9650','2013-07-09','11:50:00',5.99),('9650','2013-07-09','11:55:00',6.06),('9650','2013-07-09','12:00:00',6.18),('9650','2013-07-09','12:05:00',6.24),('9650','2013-07-09','12:10:00',6.19),('9650','2013-07-09','12:15:00',6.27),('9650','2013-07-09','12:20:00',6.43),('9650','2013-07-09','12:25:00',6.54),('9650','2013-07-09','12:30:00',6.59),('9650','2013-07-09','12:35:00',6.59),('9650','2013-07-09','12:40:00',6.66),('9650','2013-07-09','12:45:00',6.69),('9650','2013-07-09','12:50:00',6.71),('9650','2013-07-09','12:55:00',6.63),('9650','2013-07-09','13:00:00',6.83),('9650','2013-07-09','13:05:00',6.84),('9650','2013-07-09','13:10:00',6.94),('9650','2013-07-09','13:15:00',6.92),('9650','2013-07-09','13:20:00',6.92),('9650','2013-07-09','13:25:00',6.99),('9650','2013-07-09','13:30:00',7),('9650','2013-07-09','13:35:00',7.03),('9650','2013-07-09','13:40:00',7.11),('9650','2013-07-09','13:45:00',7.12),('9650','2013-07-09','13:50:00',7.15),('9650','2013-07-09','13:55:00',7.14),('9650','2013-07-09','14:00:00',7.21),('9650','2013-07-09','14:05:00',7.27),('9650','2013-07-09','14:10:00',7.33),('9650','2013-07-09','14:15:00',7.29),('9650','2013-07-09','14:20:00',7.29),('9650','2013-07-09','14:25:00',7.3),('9650','2013-07-09','14:30:00',7.36),('9650','2013-07-09','14:35:00',7.37),('9650','2013-07-09','14:40:00',7.37),('9650','2013-07-09','14:45:00',7.3),('9650','2013-07-09','14:50:00',7.28),('9650','2013-07-09','14:55:00',7.31),('9650','2013-07-09','15:00:00',7.32),('9650','2013-07-09','15:05:00',7.3),('9650','2013-07-09','15:10:00',7.27),('9650','2013-07-09','15:15:00',7.27),('9650','2013-07-09','15:20:00',7.22),('9650','2013-07-09','15:25:00',7.21),('9650','2013-07-09','15:30:00',7.19),('9650','2013-07-09','15:35:00',7.16),('9650','2013-07-09','15:40:00',1.06),('9650','2013-07-09','15:45:00',3.2),('9650','2013-07-09','15:50:00',6.93),('9650','2013-07-09','15:55:00',6.94),('9650','2013-07-09','16:00:00',6.83),('9650','2013-07-09','16:05:00',6.82),('9650','2013-07-09','16:10:00',6.8),('9650','2013-07-09','16:15:00',6.71),('9650','2013-07-09','16:20:00',6.69),('9650','2013-07-09','16:25:00',6.58),('9650','2013-07-09','16:30:00',6.46),('9650','2013-07-09','16:35:00',6.28),('9650','2013-07-09','16:40:00',6.28),('9650','2013-07-09','16:45:00',6.34),('9650','2013-07-09','16:50:00',6.28),('9650','2013-07-09','16:55:00',6.35),('9650','2013-07-09','17:00:00',6.49),('9650','2013-07-09','17:05:00',5.49),('9650','2013-07-09','17:10:00',5.26),('9650','2013-07-09','17:15:00',3.66),('9650','2013-07-09','17:20:00',3.52),('9650','2013-07-09','17:25:00',1.88),('9650','2013-07-09','17:30:00',1.43),('9650','2013-07-09','17:35:00',5.09),('9650','2013-07-09','17:40:00',5.14),('9650','2013-07-09','17:45:00',4.49),('9650','2013-07-09','17:50:00',5.05),('9650','2013-07-09','17:55:00',4.62),('9650','2013-07-09','18:00:00',5.01),('9650','2013-07-09','18:05:00',3.91),('9650','2013-07-09','18:10:00',3.16),('9650','2013-07-09','18:15:00',1.71),('9650','2013-07-09','18:20:00',2.37),('9650','2013-07-09','18:25:00',1.77),('9650','2013-07-09','18:30:00',1.32),('9650','2013-07-09','18:35:00',1.15),('9650','2013-07-09','18:40:00',1.14),('9650','2013-07-09','18:55:00',1.26),('9650','2013-07-09','19:00:00',1.15),('9650','2013-07-09','19:05:00',2.97),('9650','2013-07-09','19:10:00',3.01),('9650','2013-07-09','19:15:00',2.82),('9650','2013-07-09','19:20:00',2.46),('9650','2013-07-09','19:25:00',2.12),('9650','2013-07-09','19:30:00',1.85),('9650','2013-07-09','19:35:00',1.59),('9650','2013-07-08','07:55:00',1.07),('9650','2013-07-08','08:00:00',1.13),('9650','2013-07-08','08:05:00',1.2),('9650','2013-07-08','08:10:00',1.28),('9650','2013-07-08','08:15:00',1.36),('9650','2013-07-08','08:20:00',1.45),('9650','2013-07-08','08:25:00',1.55),('9650','2013-07-08','08:30:00',1.69),('9650','2013-07-08','08:35:00',1.84),('9650','2013-07-08','08:40:00',1.98),('9650','2013-07-08','08:45:00',2.08),('9650','2013-07-08','08:50:00',2.2),('9650','2013-07-08','08:55:00',2.31),('9650','2013-07-08','09:00:00',2.43),('9650','2013-07-08','09:05:00',2.54),('9650','2013-07-08','09:10:00',2.64),('9650','2013-07-08','09:15:00',2.77),('9650','2013-07-08','09:20:00',2.88),('9650','2013-07-08','09:25:00',3),('9650','2013-07-08','09:30:00',3.13),('9650','2013-07-08','09:35:00',3.3),('9650','2013-07-08','09:40:00',3.47),('9650','2013-07-08','09:45:00',3.58),('9650','2013-07-08','09:50:00',3.7),('9650','2013-07-08','09:55:00',3.82),('9650','2013-07-08','10:00:00',3.68),('9650','2013-07-08','10:05:00',3.93),('9650','2013-07-08','10:10:00',4.13),('9650','2013-07-08','10:15:00',4.22),('9650','2013-07-08','10:20:00',4.26),('9650','2013-07-08','10:25:00',4.42),('9650','2013-07-08','10:30:00',4.53),('9650','2013-07-08','10:35:00',4.65),('9650','2013-07-08','10:40:00',4.78),('9650','2013-07-08','10:45:00',4.89),('9650','2013-07-08','10:50:00',5),('9650','2013-07-08','10:55:00',5.14),('9650','2013-07-08','11:00:00',5.26),('9650','2013-07-08','11:05:00',5.31),('9650','2013-07-08','11:10:00',5.35),('9650','2013-07-08','11:15:00',5.06),('9650','2013-07-08','11:20:00',5.33),('9650','2013-07-08','11:25:00',5.46),('9650','2013-07-08','11:30:00',3.08),('9650','2013-07-08','11:35:00',3.68),('9650','2013-07-08','11:40:00',4.38),('9650','2013-07-08','11:45:00',6.32),('9650','2013-07-08','11:50:00',6.57),('9650','2013-07-08','11:55:00',6.76),('9650','2013-07-08','12:00:00',6.74),('9650','2013-07-08','12:05:00',6.69),('9650','2013-07-08','12:10:00',6.57),('9650','2013-07-08','12:15:00',6.54),('9650','2013-07-08','12:20:00',6.47),('9650','2013-07-08','12:25:00',6.46),('9650','2013-07-08','12:30:00',6.43),('9650','2013-07-08','12:35:00',6.37),('9650','2013-07-08','12:40:00',6.48),('9650','2013-07-08','12:45:00',6.62),('9650','2013-07-08','12:50:00',6.71),('9650','2013-07-08','12:55:00',6.7),('9650','2013-07-08','13:00:00',6.75),('9650','2013-07-08','13:05:00',6.96),('9650','2013-07-08','13:10:00',7.02),('9650','2013-07-08','13:15:00',6.98),('9650','2013-07-08','13:20:00',6.81),('9650','2013-07-08','13:25:00',7.07),('9650','2013-07-08','13:30:00',7.32),('9650','2013-07-08','13:35:00',7.03),('9650','2013-07-08','13:40:00',6.89),('9650','2013-07-08','13:45:00',6.09),('9650','2013-07-08','13:50:00',5.33),('9650','2013-07-08','13:55:00',5.56),('9650','2013-07-08','14:00:00',5.7),('9650','2013-07-08','14:05:00',5.39),('9650','2013-07-08','14:10:00',6.06),('9650','2013-07-08','14:15:00',6.26),('9650','2013-07-08','14:20:00',4.35),('9650','2013-07-08','14:25:00',4.73),('9650','2013-07-08','14:30:00',2.59),('9650','2013-07-08','14:35:00',1.68),('9650','2013-07-08','14:40:00',1.5),('9650','2013-07-08','14:45:00',1.21),('9650','2013-07-07','07:40:00',1.33),('9650','2013-07-07','07:45:00',1.25),('9650','2013-07-07','07:50:00',1.05),('9650','2013-07-07','07:55:00',1.03),('9650','2013-07-07','08:00:00',1.12),('9650','2013-07-07','08:05:00',1.13),('9650','2013-07-07','08:10:00',1.26),('9650','2013-07-07','08:15:00',1.39),('9650','2013-07-07','08:20:00',1.48),('9650','2013-07-07','08:25:00',1.57),('9650','2013-07-07','08:30:00',1.76),('9650','2013-07-07','08:35:00',1.89),('9650','2013-07-07','08:40:00',2),('9650','2013-07-07','08:45:00',2.12),('9650','2013-07-07','08:50:00',2.23),('9650','2013-07-07','08:55:00',2.34),('9650','2013-07-07','09:00:00',2.45),('9650','2013-07-07','09:05:00',2.56),('9650','2013-07-07','09:10:00',2.63),('9650','2013-07-07','09:15:00',2.74),('9650','2013-07-07','09:20:00',2.81),('9650','2013-07-07','09:25:00',2.85),('9650','2013-07-07','09:30:00',3.03),('9650','2013-07-07','09:35:00',3.31),('9650','2013-07-07','09:40:00',3.46),('9650','2013-07-07','09:45:00',3.59),('9650','2013-07-07','09:50:00',3.65),('9650','2013-07-07','09:55:00',3.78),('9650','2013-07-07','10:00:00',3.95),('9650','2013-07-07','10:05:00',4.03),('9650','2013-07-07','10:10:00',4.1),('9650','2013-07-07','10:15:00',4.23),('9650','2013-07-07','10:20:00',4.33),('9650','2013-07-07','10:25:00',4.49),('9650','2013-07-07','10:30:00',4.6),('9650','2013-07-07','10:35:00',4.69),('9650','2013-07-07','10:40:00',4.75),('9650','2013-07-07','10:45:00',4.88),('9650','2013-07-07','10:50:00',4.99),('9650','2013-07-07','10:55:00',5.06),('9650','2013-07-07','11:00:00',5.13),('9650','2013-07-07','11:05:00',5.27),('9650','2013-07-07','11:10:00',5.4),('9650','2013-07-07','11:15:00',5.55),('9650','2013-07-07','11:20:00',5.63),('9650','2013-07-07','11:25:00',5.75),('9650','2013-07-07','11:30:00',5.86),('9650','2013-07-07','11:35:00',5.95),('9650','2013-07-07','11:40:00',5.66),('9650','2013-07-07','11:45:00',5.98),('9650','2013-07-07','11:50:00',6.11),('9650','2013-07-07','11:55:00',6.04),('9650','2013-07-07','12:00:00',6.06),('9650','2013-07-07','12:05:00',6.35),('9650','2013-07-07','12:10:00',6.48),('9650','2013-07-07','12:15:00',6.66),('9650','2013-07-07','12:20:00',6.81),('9650','2013-07-07','12:25:00',6.79),('9650','2013-07-07','12:30:00',5.98),('9650','2013-07-07','12:35:00',6.78),('9650','2013-07-07','12:40:00',6.69),('9650','2013-07-07','12:45:00',6.71),('9650','2013-07-07','12:50:00',6.67),('9650','2013-07-07','12:55:00',6.94),('9650','2013-07-07','13:00:00',7.24),('9650','2013-07-07','13:05:00',7.46),('9650','2013-07-07','13:10:00',7.44),('9650','2013-07-07','13:15:00',7.99),('9650','2013-07-07','13:20:00',4.85),('9650','2013-07-07','13:25:00',2.15),('9650','2013-07-07','13:30:00',1.05),('9650','2013-07-07','14:00:00',1.21),('9650','2013-07-07','14:05:00',1.48),('9650','2013-07-07','14:10:00',1.58),('9650','2013-07-07','14:15:00',1.59),('9650','2013-07-07','14:20:00',1.61),('9650','2013-07-07','14:25:00',1.7),('9650','2013-07-07','14:30:00',1.87),('9650','2013-07-07','14:35:00',2.24),('9650','2013-07-07','14:40:00',2.38),('9650','2013-07-07','14:45:00',2.28),('9650','2013-07-07','14:50:00',2.27),('9650','2013-07-07','14:55:00',2.26),('9650','2013-07-07','15:00:00',2.1),('9650','2013-07-07','15:05:00',1.92),('9650','2013-07-07','15:10:00',1.74),('9650','2013-07-07','15:15:00',1.5),('9650','2013-07-07','15:20:00',1.08),('9650','2013-07-07','17:25:00',1.35),('9650','2013-07-07','17:30:00',1.65),('9650','2013-07-07','17:35:00',1.83),('9650','2013-07-07','17:40:00',1.91),('9650','2013-07-07','17:45:00',1.92),('9650','2013-07-07','17:50:00',1.97),('9650','2013-07-07','17:55:00',1.92),('9650','2013-07-07','18:00:00',1.77),('9650','2013-07-07','18:05:00',1.56),('9650','2013-07-07','18:10:00',1.48),('9650','2013-07-07','18:15:00',1.6),('9650','2013-07-07','18:20:00',1.88),('9650','2013-07-07','18:25:00',2.04),('9650','2013-07-07','18:30:00',1.81),('9650','2013-07-07','18:35:00',1.93),('9650','2013-07-07','18:40:00',3.58),('9650','2013-07-07','18:45:00',3.78),('9650','2013-07-07','18:50:00',3.35),('9650','2013-07-07','18:55:00',2.82),('9650','2013-07-07','19:00:00',2.53),('9650','2013-07-07','19:05:00',1.94),('9650','2013-07-07','19:10:00',1.32),('9650','2013-07-07','19:15:00',1.26),('9650','2013-07-07','19:20:00',1.69),('9650','2013-07-07','19:25:00',1.31),('9650','2013-07-06','08:00:00',1.03),('9650','2013-07-06','08:05:00',1.11),('9650','2013-07-06','08:10:00',1.22),('9650','2013-07-06','08:15:00',1.28),('9650','2013-07-06','08:20:00',1.11),('9650','2013-07-06','08:25:00',1.25),('9650','2013-07-06','08:30:00',1.57),('9650','2013-07-06','08:35:00',1.94),('9650','2013-07-06','08:40:00',1.51),('9650','2013-07-06','08:50:00',1.86),('9650','2013-07-06','08:55:00',2.47),('9650','2013-07-06','09:00:00',2.55),('9650','2013-07-06','09:05:00',2.41),('9650','2013-07-06','09:10:00',2.58),('9650','2013-07-06','09:15:00',2.68),('9650','2013-07-06','09:20:00',1.92),('9650','2013-07-06','09:25:00',2.48),('9650','2013-07-06','09:30:00',3.39),('9650','2013-07-06','09:35:00',3.56),('9650','2013-07-06','09:40:00',3.5),('9650','2013-07-06','09:45:00',3.86),('9650','2013-07-06','09:50:00',3.97),('9650','2013-07-06','09:55:00',4.12),('9650','2013-07-06','10:00:00',4.24),('9650','2013-07-06','10:05:00',4.01),('9650','2013-07-06','10:10:00',4.13),('9650','2013-07-06','10:15:00',4.09),('9650','2013-07-06','10:20:00',4.09),('9650','2013-07-06','10:25:00',4.41),('9650','2013-07-06','10:30:00',3.97),('9650','2013-07-06','10:35:00',5.01),('9650','2013-07-06','10:40:00',4.73),('9650','2013-07-06','10:45:00',4.94),('9650','2013-07-06','10:50:00',5.23),('9650','2013-07-06','10:55:00',5.22),('9650','2013-07-06','11:00:00',5.31),('9650','2013-07-06','11:05:00',5.4),('9650','2013-07-06','11:10:00',5.57),('9650','2013-07-06','11:15:00',5.58),('9650','2013-07-06','11:20:00',5.24),('9650','2013-07-06','11:25:00',4.78),('9650','2013-07-06','11:30:00',4.92),('9650','2013-07-06','11:35:00',4.84),('9650','2013-07-06','11:40:00',5.08),('9650','2013-07-06','11:45:00',4.22),('9650','2013-07-06','11:50:00',4.4),('9650','2013-07-06','11:55:00',3.18),('9650','2013-07-06','12:00:00',3.4),('9650','2013-07-06','12:05:00',6.01),('9650','2013-07-06','12:10:00',6.28),('9650','2013-07-06','12:15:00',6.24),('9650','2013-07-06','12:20:00',6.52),('9650','2013-07-06','12:25:00',6.21),('9650','2013-07-06','12:30:00',6.14),('9650','2013-07-06','12:35:00',6.5),('9650','2013-07-06','12:40:00',6.81),('9650','2013-07-06','12:45:00',6.91),('9650','2013-07-06','12:50:00',6.66),('9650','2013-07-06','12:55:00',7.13),('9650','2013-07-06','13:00:00',6.93),('9650','2013-07-06','13:05:00',6.92),('9650','2013-07-06','13:10:00',7.1),('9650','2013-07-06','13:15:00',7.16),('9650','2013-07-06','13:20:00',7.13),('9650','2013-07-06','13:25:00',5.44),('9650','2013-07-06','13:30:00',6.83),('9650','2013-07-06','13:35:00',7.52),('9650','2013-07-06','13:40:00',6.98),('9650','2013-07-06','13:45:00',7.66),('9650','2013-07-06','13:50:00',8.12),('9650','2013-07-06','13:55:00',6.99),('9650','2013-07-06','14:00:00',4.87),('9650','2013-07-06','14:05:00',6.36),('9650','2013-07-06','14:10:00',4.12),('9650','2013-07-06','14:15:00',2.75),('9650','2013-07-06','14:20:00',2.38),('9650','2013-07-06','14:25:00',2.13),('9650','2013-07-06','14:30:00',2.02),('9650','2013-07-06','14:35:00',1.84),('9650','2013-07-06','14:40:00',1.67),('9650','2013-07-06','14:45:00',1.51),('9650','2013-07-06','14:50:00',1.44),('9650','2013-07-06','14:55:00',1.58),('9650','2013-07-06','15:00:00',1.88),('9650','2013-07-06','15:05:00',2.13),('9650','2013-07-06','15:10:00',1.61),('9650','2013-07-06','15:15:00',1.03),('9650','2013-07-06','15:20:00',1.13),('9650','2013-07-06','16:45:00',1.06),('9650','2013-07-06','16:50:00',1.29),('9650','2013-07-06','16:55:00',1.54),('9650','2013-07-06','17:00:00',1.75),('9650','2013-07-06','17:05:00',1.86),('9650','2013-07-06','17:10:00',1.98),('9650','2013-07-06','17:15:00',2.06),('9650','2013-07-06','17:20:00',2.13),('9650','2013-07-06','17:25:00',2.14),('9650','2013-07-06','17:30:00',2.1),('9650','2013-07-06','17:35:00',1.96),('9650','2013-07-06','17:40:00',1.84),('9650','2013-07-06','17:45:00',1.78),('9650','2013-07-06','17:50:00',1.76),('9650','2013-07-06','17:55:00',1.69),('9650','2013-07-06','18:00:00',1.58),('9650','2013-07-06','18:05:00',1.54),('9650','2013-07-06','18:10:00',1.46),('9650','2013-07-06','18:15:00',1.45),('9650','2013-07-06','18:20:00',1.45),('9650','2013-07-06','18:25:00',1.41),('9650','2013-07-06','18:30:00',1.34),('9650','2013-07-06','18:35:00',1.25),('9650','2013-07-06','18:40:00',1.15),('9650','2013-07-06','18:45:00',1.08),('9650','2013-07-06','18:50:00',1.09),('9650','2013-07-06','18:55:00',1.1),('9650','2013-07-06','19:00:00',1.04),('9650','2013-07-05','08:00:00',1.05),('9650','2013-07-05','08:05:00',1.11),('9650','2013-07-05','08:10:00',1.15),('9650','2013-07-05','08:15:00',1.19),('9650','2013-07-05','08:20:00',1.22),('9650','2013-07-05','08:25:00',1.25),('9650','2013-07-05','08:30:00',1.26),('9650','2013-07-05','08:35:00',1.37),('9650','2013-07-05','08:40:00',1.97),('9650','2013-07-05','08:45:00',2.09),('9650','2013-07-05','08:50:00',2.2),('9650','2013-07-05','08:55:00',2.32),('9650','2013-07-05','09:00:00',2.44),('9650','2013-07-05','09:05:00',2.55),('9650','2013-07-05','09:10:00',2.68),('9650','2013-07-05','09:15:00',2.79),('9650','2013-07-05','09:20:00',2.94),('9650','2013-07-05','09:25:00',3.05),('9650','2013-07-05','09:30:00',3.15),('9650','2013-07-05','09:35:00',3.32),('9650','2013-07-05','09:40:00',3.49),('9650','2013-07-05','09:45:00',3.6),('9650','2013-07-05','09:50:00',3.74),('9650','2013-07-05','09:55:00',3.88),('9650','2013-07-05','10:00:00',3.99),('9650','2013-07-05','10:05:00',4.09),('9650','2013-07-05','10:10:00',4.24),('9650','2013-07-05','10:15:00',4.31),('9650','2013-07-05','10:20:00',4.38),('9650','2013-07-05','10:25:00',4.53),('9650','2013-07-05','10:30:00',4.64),('9650','2013-07-05','10:35:00',4.73),('9650','2013-07-05','10:40:00',4.83),('9650','2013-07-05','10:45:00',4.97),('9650','2013-07-05','10:50:00',5.09),('9650','2013-07-05','10:55:00',5.21),('9650','2013-07-05','11:00:00',5.31),('9650','2013-07-05','11:05:00',5.36),('9650','2013-07-05','11:10:00',5.47),('9650','2013-07-05','11:15:00',5.52),('9650','2013-07-05','11:20:00',5.61),('9650','2013-07-05','11:25:00',5.73),('9650','2013-07-05','11:30:00',5.81),('9650','2013-07-05','11:35:00',5.86),('9650','2013-07-05','11:40:00',5.92),('9650','2013-07-05','11:45:00',6.02),('9650','2013-07-05','11:50:00',6.1),('9650','2013-07-05','11:55:00',6.11),('9650','2013-07-05','12:00:00',6.12),('9650','2013-07-05','12:05:00',6.17),('9650','2013-07-05','12:10:00',6.31),('9650','2013-07-05','12:15:00',6.36),('9650','2013-07-05','12:20:00',6.5),('9650','2013-07-05','12:25:00',6.52),('9650','2013-07-05','12:30:00',6.66),('9650','2013-07-05','12:35:00',6.68),('9650','2013-07-05','12:40:00',6.66),('9650','2013-07-05','12:45:00',6.74),('9650','2013-07-05','12:50:00',6.76),('9650','2013-07-05','12:55:00',6.81),('9650','2013-07-05','13:00:00',6.93),('9650','2013-07-05','13:05:00',6.98),('9650','2013-07-05','13:10:00',7.01),('9650','2013-07-05','13:15:00',7.05),('9650','2013-07-05','13:20:00',7.11),('9650','2013-07-05','13:25:00',7.08),('9650','2013-07-05','13:30:00',7.19),('9650','2013-07-05','13:35:00',7.02),('9650','2013-07-05','13:40:00',7.23),('9650','2013-07-05','13:45:00',7.23),('9650','2013-07-05','13:50:00',7.18),('9650','2013-07-05','13:55:00',7.19),('9650','2013-07-05','14:00:00',7.22),('9650','2013-07-05','14:05:00',7.3),('9650','2013-07-05','14:10:00',7.23),('9650','2013-07-05','14:15:00',7.3),('9650','2013-07-05','14:20:00',6.65),('9650','2013-07-05','14:25:00',7.35),('9650','2013-07-05','14:30:00',7.26),('9650','2013-07-05','14:35:00',7.33),('9650','2013-07-05','14:40:00',7.3),('9650','2013-07-05','14:45:00',7.28),('9650','2013-07-05','14:50:00',6.94),('9650','2013-07-05','14:55:00',4.12),('9650','2013-07-05','15:00:00',6.72),('9650','2013-07-05','15:05:00',7.6),('9650','2013-07-05','15:10:00',7.43),('9650','2013-07-05','15:15:00',7.33),('9650','2013-07-05','15:20:00',7.29),('9650','2013-07-05','15:25:00',7.31),('9650','2013-07-05','15:30:00',7.12),('9650','2013-07-05','15:35:00',3.42),('9650','2013-07-05','15:40:00',1.43),('9650','2013-07-05','16:40:00',1.23),('9650','2013-07-05','16:45:00',1.72),('9650','2013-07-05','16:50:00',2.85),('9650','2013-07-05','16:55:00',3.5),('9650','2013-07-05','17:00:00',2.18),('9650','2013-07-05','17:05:00',1.98),('9650','2013-07-05','17:10:00',2.05),('9650','2013-07-05','17:15:00',3.59),('9650','2013-07-05','17:20:00',2.09),('9650','2013-07-05','17:25:00',2.22),('9650','2013-07-05','17:30:00',2.3),('9650','2013-07-05','17:35:00',2.14),('9650','2013-07-05','17:40:00',1.71),('9650','2013-07-05','17:45:00',1.63),('9650','2013-07-05','17:50:00',1.43),('9650','2013-07-05','17:55:00',1.36),('9650','2013-07-05','18:00:00',1.23),('9650','2013-07-05','18:05:00',1.13),('9650','2013-07-05','18:10:00',1.1),('9650','2013-07-05','18:15:00',1.05),('9650','2013-07-05','18:20:00',1.03),('9650','2013-07-05','18:25:00',1),('9650','2013-07-05','19:15:00',1.96),('9650','2013-07-05','19:20:00',1.61),('9650','2013-07-05','19:25:00',1.1),('9650','2013-07-05','19:30:00',1.11),('9650','2013-07-05','19:35:00',1.16),('9650','2013-07-05','19:40:00',1.07),('9650','2013-07-04','07:50:00',1.04),('9650','2013-07-04','07:55:00',1.09),('9650','2013-07-04','08:00:00',1.18),('9650','2013-07-04','08:05:00',1.25),('9650','2013-07-04','08:10:00',1.33),('9650','2013-07-04','08:15:00',1.41),('9650','2013-07-04','08:20:00',1.49),('9650','2013-07-04','08:25:00',1.6),('9650','2013-07-04','08:30:00',1.77),('9650','2013-07-04','08:35:00',1.91),('9650','2013-07-04','08:40:00',2.04),('9650','2013-07-04','08:45:00',2.12),('9650','2013-07-04','08:50:00',2.25),('9650','2013-07-04','08:55:00',2.36),('9650','2013-07-04','09:00:00',2.48),('9650','2013-07-04','09:05:00',2.61),('9650','2013-07-04','09:10:00',2.72),('9650','2013-07-04','09:15:00',2.83),('9650','2013-07-04','09:20:00',2.95),('9650','2013-07-04','09:25:00',3.1),('9650','2013-07-04','09:30:00',3.24),('9650','2013-07-04','09:35:00',3.4),('9650','2013-07-04','09:40:00',3.56),('9650','2013-07-04','09:45:00',3.67),('9650','2013-07-04','09:50:00',3.77),('9650','2013-07-04','09:55:00',3.89),('9650','2013-07-04','10:00:00',4.01),('9650','2013-07-04','10:05:00',4.12),('9650','2013-07-04','10:10:00',4.24),('9650','2013-07-04','10:15:00',4.33),('9650','2013-07-04','10:20:00',4.41),('9650','2013-07-04','10:25:00',4.56),('9650','2013-07-04','10:30:00',4.68),('9650','2013-07-04','10:35:00',4.77),('9650','2013-07-04','10:40:00',4.86),('9650','2013-07-04','10:45:00',4.96),('9650','2013-07-04','10:50:00',5.06),('9650','2013-07-04','10:55:00',5.17),('9650','2013-07-04','11:00:00',5.26),('9650','2013-07-04','11:05:00',5.31),('9650','2013-07-04','11:10:00',5.41),('9650','2013-07-04','11:15:00',5.49),('9650','2013-07-04','11:20:00',5.59),('9650','2013-07-04','11:25:00',5.66),('9650','2013-07-04','11:30:00',5.8),('9650','2013-07-04','11:35:00',5.87),('9650','2013-07-04','11:40:00',5.93),('9650','2013-07-04','11:45:00',5.97),('9650','2013-07-04','11:50:00',6.07),('9650','2013-07-04','11:55:00',6.18),('9650','2013-07-04','12:00:00',6.23),('9650','2013-07-04','12:05:00',6.33),('9650','2013-07-04','12:10:00',6.37),('9650','2013-07-04','12:15:00',6.42),('9650','2013-07-04','12:20:00',6.6),('9650','2013-07-04','12:25:00',4.9),('9650','2013-07-04','12:30:00',6.44),('9650','2013-07-04','12:35:00',5.9),('9650','2013-07-04','12:40:00',6.72),('9650','2013-07-04','12:45:00',6.87),('9650','2013-07-04','12:50:00',6.91),('9650','2013-07-04','12:55:00',6.95),('9650','2013-07-04','13:00:00',5.99),('9650','2013-07-04','13:05:00',4.39),('9650','2013-07-04','13:10:00',7.17),('9650','2013-07-04','13:15:00',7.18),('9650','2013-07-04','13:20:00',4.86),('9650','2013-07-04','13:25:00',6.89),('9650','2013-07-04','13:30:00',7.36),('9650','2013-07-04','13:35:00',7.31),('9650','2013-07-04','13:40:00',7.2),('9650','2013-07-04','13:45:00',7.26),('9650','2013-07-04','13:50:00',7.2),('9650','2013-07-04','13:55:00',7.28),('9650','2013-07-04','14:00:00',7.34),('9650','2013-07-04','14:05:00',6.78),('9650','2013-07-04','14:10:00',6.38),('9650','2013-07-04','14:15:00',7.31),('9650','2013-07-04','14:20:00',7.18),('9650','2013-07-04','14:25:00',7.26),('9650','2013-07-04','14:30:00',7.18),('9650','2013-07-04','14:35:00',6.14),('9650','2013-07-04','14:40:00',7.32),('9650','2013-07-04','14:45:00',4.98),('9650','2013-07-04','14:50:00',6.53),('9650','2013-07-04','14:55:00',6.85),('9650','2013-07-04','15:00:00',7.12),('9650','2013-07-04','15:05:00',5.62),('9650','2013-07-04','15:10:00',7.49),('9650','2013-07-04','15:15:00',7.1),('9650','2013-07-04','15:20:00',5.67),('9650','2013-07-04','15:25:00',5.48),('9650','2013-07-04','15:30:00',6.38),('9650','2013-07-04','15:35:00',7.27),('9650','2013-07-04','15:40:00',7.06),('9650','2013-07-04','15:45:00',7.12),('9650','2013-07-04','15:50:00',7.04),('9650','2013-07-04','15:55:00',6.84),('9650','2013-07-04','16:00:00',6.75),('9650','2013-07-04','16:05:00',6.78),('9650','2013-07-04','16:10:00',6.68),('9650','2013-07-04','16:15:00',6.62),('9650','2013-07-04','16:20:00',6.64),('9650','2013-07-04','16:25:00',6.6),('9650','2013-07-04','16:30:00',6.5),('9650','2013-07-04','16:35:00',6.41),('9650','2013-07-04','16:40:00',6.33),('9650','2013-07-04','16:45:00',6.27),('9650','2013-07-04','16:50:00',6.11),('9650','2013-07-04','16:55:00',5.99),('9650','2013-07-04','17:00:00',5.94),('9650','2013-07-04','17:05:00',5.86),('9650','2013-07-04','17:10:00',5.86),('9650','2013-07-04','17:15:00',5.84),('9650','2013-07-04','17:20:00',5.72),('9650','2013-07-04','17:25:00',5.39),('9650','2013-07-04','17:30:00',5.47),('9650','2013-07-04','17:35:00',5.27),('9650','2013-07-04','17:40:00',5.06),('9650','2013-07-04','17:45:00',4.87),('9650','2013-07-04','17:50:00',4.73),('9650','2013-07-04','17:55:00',4.69),('9650','2013-07-04','18:00:00',4.72),('9650','2013-07-04','18:05:00',4.6),('9650','2013-07-04','18:10:00',4.11),('9650','2013-07-04','18:15:00',2.32),('9650','2013-07-04','18:20:00',3.48),('9650','2013-07-04','18:25:00',1.51),('9650','2013-07-04','18:30:00',2.92),('9650','2013-07-04','18:35:00',3.48),('9650','2013-07-04','18:40:00',3.44),('9650','2013-07-04','18:45:00',3.37),('9650','2013-07-04','18:50:00',3.21),('9650','2013-07-04','18:55:00',3.03),('9650','2013-07-04','19:00:00',2.88),('9650','2013-07-04','19:05:00',2.72),('9650','2013-07-04','19:10:00',2.57),('9650','2013-07-04','19:15:00',2.43),('9650','2013-07-04','19:20:00',2.27),('9650','2013-07-04','19:25:00',2.03),('9650','2013-07-04','19:30:00',1.45),('9650','2013-07-04','19:35:00',1.27),('9650','2013-07-03','08:45:00',1.02),('9650','2013-07-03','08:50:00',1.37),('9650','2013-07-03','08:55:00',1.63),('9650','2013-07-03','09:00:00',1.55),('9650','2013-07-03','09:05:00',1.26),('9650','2013-07-03','09:10:00',1.22),('9650','2013-07-03','09:15:00',1.26),('9650','2013-07-03','09:20:00',1.23),('9650','2013-07-03','09:25:00',1.34),('9650','2013-07-03','09:30:00',1.35),('9650','2013-07-03','09:35:00',1.25),('9650','2013-07-03','09:40:00',1.03),('9650','2013-07-03','10:10:00',1.03),('9650','2013-07-03','10:15:00',1.21),('9650','2013-07-03','10:20:00',1.32),('9650','2013-07-03','10:25:00',1.35),('9650','2013-07-03','10:30:00',1.38),('9650','2013-07-03','10:35:00',1.41),('9650','2013-07-03','10:40:00',1.3),('9650','2013-07-03','10:45:00',1.13),('9650','2013-07-03','10:50:00',1.05),('9650','2013-07-03','10:55:00',1.2),('9650','2013-07-03','11:00:00',1.44),('9650','2013-07-03','11:05:00',1.66),('9650','2013-07-03','11:10:00',1.95),('9650','2013-07-03','11:15:00',1.98),('9650','2013-07-03','11:20:00',1.89),('9650','2013-07-03','11:25:00',2),('9650','2013-07-03','11:30:00',2.17),('9650','2013-07-03','11:35:00',2.51),('9650','2013-07-03','11:40:00',2.85),('9650','2013-07-03','11:45:00',3.07),('9650','2013-07-03','11:50:00',3.12),('9650','2013-07-03','11:55:00',2.89),('9650','2013-07-03','12:00:00',2.79),('9650','2013-07-03','12:05:00',3.42),('9650','2013-07-03','12:10:00',4.37),('9650','2013-07-03','12:15:00',4.75),('9650','2013-07-03','12:20:00',4.24),('9650','2013-07-03','12:25:00',5.37),('9650','2013-07-03','12:30:00',4.55),('9650','2013-07-03','12:35:00',3.8),('9650','2013-07-03','12:40:00',2.67),('9650','2013-07-03','12:45:00',2.09),('9650','2013-07-03','12:50:00',1.64),('9650','2013-07-03','12:55:00',1.55),('9650','2013-07-03','13:00:00',1.75),('9650','2013-07-03','13:05:00',2.08),('9650','2013-07-03','13:10:00',2.76),('9650','2013-07-03','13:15:00',3.21),('9650','2013-07-03','13:20:00',3.35),('9650','2013-07-03','13:25:00',4.91),('9650','2013-07-03','13:30:00',3.74),('9650','2013-07-03','13:35:00',3.91),('9650','2013-07-03','13:40:00',4.61),('9650','2013-07-03','13:45:00',6.25),('9650','2013-07-03','13:50:00',7.61),('9650','2013-07-03','13:55:00',6.59),('9650','2013-07-03','14:00:00',4.6),('9650','2013-07-03','14:05:00',4.22),('9650','2013-07-03','14:10:00',3.98),('9650','2013-07-03','14:15:00',4.02),('9650','2013-07-03','14:20:00',4.1),('9650','2013-07-03','14:25:00',3.6),('9650','2013-07-03','14:30:00',3.64),('9650','2013-07-03','14:35:00',3.69),('9650','2013-07-03','14:40:00',5.14),('9650','2013-07-03','14:45:00',5.72),('9650','2013-07-03','14:50:00',4.47),('9650','2013-07-03','14:55:00',4.03),('9650','2013-07-03','15:00:00',3.68),('9650','2013-07-03','15:05:00',4.52),('9650','2013-07-03','15:10:00',6.14),('9650','2013-07-03','15:15:00',6.66),('9650','2013-07-03','15:20:00',6.63),('9650','2013-07-03','15:25:00',4.28),('9650','2013-07-03','15:30:00',5.01),('9650','2013-07-03','15:35:00',5.24),('9650','2013-07-03','15:40:00',4.76),('9650','2013-07-03','15:45:00',6.41),('9650','2013-07-03','15:50:00',4.09),('9650','2013-07-03','15:55:00',4.28),('9650','2013-07-03','16:00:00',4.43),('9650','2013-07-03','16:05:00',4.43),('9650','2013-07-03','16:10:00',3.63),('9650','2013-07-03','16:15:00',3.38),('9650','2013-07-03','16:20:00',3.6),('9650','2013-07-03','16:25:00',4.17),('9650','2013-07-03','16:30:00',4.62),('9650','2013-07-03','16:35:00',4.59),('9650','2013-07-03','16:40:00',3.21),('9650','2013-07-03','16:45:00',3.02),('9650','2013-07-03','16:50:00',2.92),('9650','2013-07-03','16:55:00',2.82),('9650','2013-07-03','17:00:00',2.48),('9650','2013-07-03','17:05:00',2.48),('9650','2013-07-03','17:10:00',4.17),('9650','2013-07-03','17:15:00',4.97),('9650','2013-07-03','17:20:00',4.32),('9650','2013-07-03','17:25:00',6.17),('9650','2013-07-03','17:30:00',6.27),('9650','2013-07-03','17:35:00',4.49),('9650','2013-07-03','17:40:00',5.82),('9650','2013-07-03','17:45:00',5.47),('9650','2013-07-03','17:50:00',5.39),('9650','2013-07-03','17:55:00',5.03),('9650','2013-07-03','18:00:00',5.24),('9650','2013-07-03','18:05:00',5.06),('9650','2013-07-03','18:10:00',4.81),('9650','2013-07-03','18:15:00',4.73),('9650','2013-07-03','18:20:00',4.31),('9650','2013-07-03','18:25:00',3.25),('9650','2013-07-03','18:30:00',1.95),('9650','2013-07-03','18:35:00',2.18),('9650','2013-07-03','18:40:00',1.12),('9650','2013-07-02','08:00:00',1.06),('9650','2013-07-02','08:05:00',1.13),('9650','2013-07-02','08:10:00',1.17),('9650','2013-07-02','08:15:00',1.22),('9650','2013-07-02','08:20:00',1.25),('9650','2013-07-02','08:25:00',1.34),('9650','2013-07-02','08:30:00',1.77),('9650','2013-07-02','08:35:00',1.9),('9650','2013-07-02','08:40:00',2.04),('9650','2013-07-02','08:45:00',2.15),('9650','2013-07-02','08:50:00',2.27),('9650','2013-07-02','08:55:00',2.38),('9650','2013-07-02','09:00:00',2.51),('9650','2013-07-02','09:05:00',2.63),('9650','2013-07-02','09:10:00',2.74),('9650','2013-07-02','09:15:00',2.84),('9650','2013-07-02','09:20:00',2.97),('9650','2013-07-02','09:25:00',3.12),('9650','2013-07-02','09:30:00',3.24),('9650','2013-07-02','09:35:00',3.44),('9650','2013-07-02','09:40:00',3.59),('9650','2013-07-02','09:45:00',3.71),('9650','2013-07-02','09:50:00',3.8),('9650','2013-07-02','09:55:00',3.92),('9650','2013-07-02','10:00:00',4.01),('9650','2013-07-02','10:05:00',4.12),('9650','2013-07-02','10:10:00',4.19),('9650','2013-07-02','10:15:00',4.34),('9650','2013-07-02','10:20:00',4.42),('9650','2013-07-02','10:25:00',4.48),('9650','2013-07-02','10:30:00',4.55),('9650','2013-07-02','10:35:00',4.79),('9650','2013-07-02','10:40:00',4.87),('9650','2013-07-02','10:45:00',4.99),('9650','2013-07-02','10:50:00',5.08),('9650','2013-07-02','10:55:00',5.17),('9650','2013-07-02','11:00:00',5.32),('9650','2013-07-02','11:05:00',5.39),('9650','2013-07-02','11:10:00',5.52),('9650','2013-07-02','11:15:00',5.67),('9650','2013-07-02','11:20:00',5.77),('9650','2013-07-02','11:25:00',5.77),('9650','2013-07-02','11:30:00',5.8),('9650','2013-07-02','11:35:00',5.88),('9650','2013-07-02','11:40:00',5.93),('9650','2013-07-02','11:45:00',6.19),('9650','2013-07-02','11:50:00',6.15),('9650','2013-07-02','11:55:00',6.27),('9650','2013-07-02','12:00:00',6.35),('9650','2013-07-02','12:05:00',6.37),('9650','2013-07-02','12:10:00',6.4),('9650','2013-07-02','12:15:00',6.43),('9650','2013-07-02','12:20:00',6.54),('9650','2013-07-02','12:25:00',6.59),('9650','2013-07-02','12:30:00',6.74),('9650','2013-07-02','12:35:00',6.82),('9650','2013-07-02','12:40:00',6.83),('9650','2013-07-02','12:45:00',6.94),('9650','2013-07-02','12:50:00',7.03),('9650','2013-07-02','12:55:00',7.1),('9650','2013-07-02','13:00:00',7.09),('9650','2013-07-02','13:05:00',7.1),('9650','2013-07-02','13:10:00',7.13),('9650','2013-07-02','13:15:00',7.21),('9650','2013-07-02','13:20:00',7.17),('9650','2013-07-02','13:25:00',7.22),('9650','2013-07-02','13:30:00',7.25),('9650','2013-07-02','13:35:00',7.28),('9650','2013-07-02','13:40:00',7.32),('9650','2013-07-02','13:45:00',7.36),('9650','2013-07-02','13:50:00',7.36),('9650','2013-07-02','13:55:00',7.37),('9650','2013-07-02','14:00:00',7.38),('9650','2013-07-02','14:05:00',7.43),('9650','2013-07-02','14:10:00',7.42),('9650','2013-07-02','14:15:00',7.41),('9650','2013-07-02','14:20:00',7.44),('9650','2013-07-02','14:25:00',7.44),('9650','2013-07-02','14:30:00',7.46),('9650','2013-07-02','14:35:00',7.49),('9650','2013-07-02','14:40:00',7.46),('9650','2013-07-02','14:45:00',7.47),('9650','2013-07-02','14:50:00',7.48),('9650','2013-07-02','14:55:00',7.44),('9650','2013-07-02','15:00:00',7.45),('9650','2013-07-02','15:05:00',7.42),('9650','2013-07-02','15:10:00',7.44),('9650','2013-07-02','15:15:00',7.43),('9650','2013-07-02','15:20:00',7.39),('9650','2013-07-02','15:25:00',7.38),('9650','2013-07-02','15:30:00',7.36),('9650','2013-07-02','15:35:00',7.31),('9650','2013-07-02','15:40:00',7.26),('9650','2013-07-02','15:45:00',7.23),('9650','2013-07-02','15:50:00',7.15),('9650','2013-07-02','15:55:00',7.08),('9650','2013-07-02','16:00:00',7.01),('9650','2013-07-02','16:05:00',7),('9650','2013-07-02','16:10:00',6.92),('9650','2013-07-02','16:15:00',6.87),('9650','2013-07-02','16:20:00',6.84),('9650','2013-07-02','16:25:00',6.77),('9650','2013-07-02','16:30:00',6.75),('9650','2013-07-02','16:35:00',6.66),('9650','2013-07-02','16:40:00',6.59),('9650','2013-07-02','16:45:00',6.47),('9650','2013-07-02','16:50:00',6.46),('9650','2013-07-02','16:55:00',6.41),('9650','2013-07-02','17:00:00',6.3),('9650','2013-07-02','17:05:00',6.23),('9650','2013-07-02','17:10:00',6.13),('9650','2013-07-02','17:15:00',6.02),('9650','2013-07-02','17:20:00',5.92),('9650','2013-07-02','17:25:00',5.82),('9650','2013-07-02','17:30:00',5.74),('9650','2013-07-02','17:35:00',5.67),('9650','2013-07-02','17:40:00',5.57),('9650','2013-07-02','17:45:00',5.48),('9650','2013-07-02','17:50:00',5.34),('9650','2013-07-02','17:55:00',5.24),('9650','2013-07-02','18:00:00',5.04),('9650','2013-07-02','18:05:00',4.93),('9650','2013-07-02','18:10:00',4.8),('9650','2013-07-02','18:15:00',4.78),('9650','2013-07-02','18:20:00',4.62),('9650','2013-07-02','18:25:00',4.51),('9650','2013-07-02','18:30:00',4.41),('9650','2013-07-02','18:35:00',4.28),('9650','2013-07-02','18:40:00',4.11),('9650','2013-07-02','18:45:00',3.99),('9650','2013-07-02','18:50:00',3.84),('9650','2013-07-02','18:55:00',3.65),('9650','2013-07-02','19:00:00',3.49),('9650','2013-07-02','19:05:00',3.3),('9650','2013-07-02','19:10:00',3.16),('9650','2013-07-02','19:15:00',3),('9650','2013-07-02','19:20:00',2.82),('9650','2013-07-02','19:25:00',2.64),('9650','2013-07-02','19:30:00',2.45),('9650','2013-07-02','19:35:00',2.28),('9650','2013-07-02','19:40:00',2.1),('9650','2013-07-02','19:45:00',1.94),('9650','2013-07-02','19:50:00',1.74),('9650','2013-07-02','19:55:00',1.59),('9650','2013-07-02','20:00:00',1.41),('9650','2013-07-02','20:05:00',1.21),('9650','2013-07-01','07:55:00',1.01),('9650','2013-07-01','08:00:00',1.1),('9650','2013-07-01','08:05:00',1.18),('9650','2013-07-01','08:10:00',1.27),('9650','2013-07-01','08:15:00',1.37),('9650','2013-07-01','08:20:00',1.48),('9650','2013-07-01','08:25:00',1.62),('9650','2013-07-01','08:30:00',1.81),('9650','2013-07-01','08:35:00',1.93),('9650','2013-07-01','08:40:00',2.04),('9650','2013-07-01','08:45:00',2.16),('9650','2013-07-01','08:50:00',2.29),('9650','2013-07-01','08:55:00',2.41),('9650','2013-07-01','09:00:00',2.53),('9650','2013-07-01','09:05:00',2.62),('9650','2013-07-01','09:10:00',2.75),('9650','2013-07-01','09:15:00',2.89),('9650','2013-07-01','09:20:00',3),('9650','2013-07-01','09:25:00',3.13),('9650','2013-07-01','09:30:00',3.25),('9650','2013-07-01','09:35:00',3.44),('9650','2013-07-01','09:40:00',3.59),('9650','2013-07-01','09:45:00',3.71),('9650','2013-07-01','09:50:00',3.83),('9650','2013-07-01','09:55:00',3.94),('9650','2013-07-01','10:00:00',4.06),('9650','2013-07-01','10:05:00',4.15),('9650','2013-07-01','10:10:00',4.27),('9650','2013-07-01','10:15:00',4.34),('9650','2013-07-01','10:20:00',4.43),('9650','2013-07-01','10:25:00',4.57),('9650','2013-07-01','10:30:00',4.65),('9650','2013-07-01','10:35:00',4.73),('9650','2013-07-01','10:40:00',4.84),('9650','2013-07-01','10:45:00',4.97),('9650','2013-07-01','10:50:00',5.08),('9650','2013-07-01','10:55:00',5.15),('9650','2013-07-01','11:00:00',5.21),('9650','2013-07-01','11:05:00',5.3),('9650','2013-07-01','11:10:00',5.37),('9650','2013-07-01','11:15:00',5.44),('9650','2013-07-01','11:20:00',5.56),('9650','2013-07-01','11:25:00',5.67),('9650','2013-07-01','11:30:00',5.7),('9650','2013-07-01','11:35:00',5.75),('9650','2013-07-01','11:40:00',5.82),('9650','2013-07-01','11:45:00',5.89),('9650','2013-07-01','11:50:00',5.99),('9650','2013-07-01','11:55:00',6.03),('9650','2013-07-01','12:00:00',5.99),('9650','2013-07-01','12:05:00',6.29),('9650','2013-07-01','12:10:00',6.33),('9650','2013-07-01','12:15:00',6.41),('9650','2013-07-01','12:20:00',6.32),('9650','2013-07-01','12:25:00',6.38),('9650','2013-07-01','12:30:00',6.39),('9650','2013-07-01','12:35:00',6.77),('9650','2013-07-01','12:40:00',7.01),('9650','2013-07-01','12:45:00',7.16),('9650','2013-07-01','12:50:00',7.4),('9650','2013-07-01','12:55:00',4.91),('9650','2013-07-01','13:00:00',4.52),('9650','2013-07-01','13:05:00',7.39),('9650','2013-07-01','13:10:00',6.49),('9650','2013-07-01','13:15:00',6.31),('9650','2013-07-01','13:20:00',7.09),('9650','2013-07-01','13:25:00',6.99),('9650','2013-07-01','13:30:00',7.05),('9650','2013-07-01','13:35:00',7.15),('9650','2013-07-01','13:40:00',6.99),('9650','2013-07-01','13:45:00',6.97),('9650','2013-07-01','13:50:00',6.96),('9650','2013-07-01','13:55:00',7.08),('9650','2013-07-01','14:00:00',7.1),('9650','2013-07-01','14:05:00',7.07),('9650','2013-07-01','14:10:00',7.15),('9650','2013-07-01','14:15:00',7.28),('9650','2013-07-01','14:20:00',7.27),('9650','2013-07-01','14:25:00',7.26),('9650','2013-07-01','14:30:00',7.25),('9650','2013-07-01','14:35:00',7.27),('9650','2013-07-01','14:40:00',7.28),('9650','2013-07-01','14:45:00',7.29),('9650','2013-07-01','14:50:00',7.17),('9650','2013-07-01','14:55:00',7.18),('9650','2013-07-01','15:00:00',7.24),('9650','2013-07-01','15:05:00',7.25),('9650','2013-07-01','15:10:00',7.22),('9650','2013-07-01','15:15:00',7.2),('9650','2013-07-01','15:20:00',7.19),('9650','2013-07-01','15:25:00',7.16),('9650','2013-07-01','15:30:00',7.18),('9650','2013-07-01','15:35:00',7.14),('9650','2013-07-01','15:40:00',7.13),('9650','2013-07-01','15:45:00',7.05),('9650','2013-07-01','15:50:00',7.01),('9650','2013-07-01','15:55:00',6.93),('9650','2013-07-01','16:00:00',6.86),('9650','2013-07-01','16:05:00',6.85),('9650','2013-07-01','16:10:00',6.79),('9650','2013-07-01','16:15:00',6.72),('9650','2013-07-01','16:20:00',6.64),('9650','2013-07-01','16:25:00',6.6),('9650','2013-07-01','16:30:00',6.51),('9650','2013-07-01','16:35:00',6.45),('9650','2013-07-01','16:40:00',6.38),('9650','2013-07-01','16:45:00',6.32),('9650','2013-07-01','16:50:00',6.21),('9650','2013-07-01','16:55:00',6.22),('9650','2013-07-01','17:00:00',6.14),('9650','2013-07-01','17:05:00',6.05),('9650','2013-07-01','17:10:00',5.92),('9650','2013-07-01','17:15:00',5.82),('9650','2013-07-01','17:20:00',5.72),('9650','2013-07-01','17:25:00',5.64),('9650','2013-07-01','17:30:00',5.55),('9650','2013-07-01','17:35:00',5.42),('9650','2013-07-01','17:40:00',5.27),('9650','2013-07-01','17:45:00',5.12),('9650','2013-07-01','17:50:00',4.99),('9650','2013-07-01','17:55:00',4.92),('9650','2013-07-01','18:00:00',4.76),('9650','2013-07-01','18:05:00',4.65),('9650','2013-07-01','18:10:00',4.54),('9650','2013-07-01','18:15:00',4.45),('9650','2013-07-01','18:20:00',4.34),('9650','2013-07-01','18:25:00',4.17),('9650','2013-07-01','18:30:00',4.03),('9650','2013-07-01','18:35:00',3.89),('9650','2013-07-01','18:40:00',3.75),('9650','2013-07-01','18:45:00',3.61),('9650','2013-07-01','18:50:00',3.49),('9650','2013-07-01','18:55:00',3.33),('9650','2013-07-01','19:00:00',3.2),('9650','2013-07-01','19:05:00',3.02),('9650','2013-07-01','19:10:00',2.87),('9650','2013-07-01','19:15:00',2.71),('9650','2013-07-01','19:20:00',2.54),('9650','2013-07-01','19:25:00',2.35),('9650','2013-07-01','19:30:00',2.13),('9650','2013-07-01','19:35:00',1.96),('9650','2013-07-01','19:40:00',1.78),('9650','2013-07-01','19:45:00',1.57),('9650','2013-07-01','19:50:00',1.37),('9650','2013-07-01','19:55:00',1.19),('9650','2013-07-01','20:00:00',1.01),('9650','2013-06-30','07:55:00',1.05),('9650','2013-06-30','08:00:00',1.14),('9650','2013-06-30','08:05:00',1.22),('9650','2013-06-30','08:10:00',1.33),('9650','2013-06-30','08:15:00',1.43),('9650','2013-06-30','08:20:00',1.54),('9650','2013-06-30','08:25:00',1.69),('9650','2013-06-30','08:30:00',1.86),('9650','2013-06-30','08:35:00',1.99),('9650','2013-06-30','08:40:00',2.12),('9650','2013-06-30','08:45:00',2.23),('9650','2013-06-30','08:50:00',2.36),('9650','2013-06-30','08:55:00',2.47),('9650','2013-06-30','09:00:00',2.58),('9650','2013-06-30','09:05:00',2.7),('9650','2013-06-30','09:10:00',2.83),('9650','2013-06-30','09:15:00',2.97),('9650','2013-06-30','09:20:00',3.11),('9650','2013-06-30','09:25:00',3.25),('9650','2013-06-30','09:30:00',3.39),('9650','2013-06-30','09:35:00',3.58),('9650','2013-06-30','09:40:00',3.73),('9650','2013-06-30','09:45:00',3.85),('9650','2013-06-30','09:50:00',3.96),('9650','2013-06-30','09:55:00',4.06),('9650','2013-06-30','10:00:00',4.13),('9650','2013-06-30','10:05:00',4.22),('9650','2013-06-30','10:10:00',4.37),('9650','2013-06-30','10:15:00',4.44),('9650','2013-06-30','10:20:00',4.55),('9650','2013-06-30','10:25:00',4.71),('9650','2013-06-30','10:30:00',4.85),('9650','2013-06-30','10:35:00',4.93),('9650','2013-06-30','10:40:00',5.08),('9650','2013-06-30','10:45:00',5.24),('9650','2013-06-30','10:50:00',5.34),('9650','2013-06-30','10:55:00',5.44),('9650','2013-06-30','11:00:00',5.5),('9650','2013-06-30','11:05:00',5.54),('9650','2013-06-30','11:10:00',5.69),('9650','2013-06-30','11:15:00',5.84),('9650','2013-06-30','11:20:00',5.95),('9650','2013-06-30','11:25:00',6.03),('9650','2013-06-30','11:30:00',6.01),('9650','2013-06-30','11:35:00',6.11),('9650','2013-06-30','11:40:00',6.22),('9650','2013-06-30','11:45:00',6.31),('9650','2013-06-30','11:50:00',6.39),('9650','2013-06-30','11:55:00',6.41),('9650','2013-06-30','12:00:00',6.48),('9650','2013-06-30','12:05:00',6.5),('9650','2013-06-30','12:10:00',6.53),('9650','2013-06-30','12:15:00',6.62),('9650','2013-06-30','12:20:00',6.72),('9650','2013-06-30','12:25:00',6.7),('9650','2013-06-30','12:30:00',6.72),('9650','2013-06-30','12:35:00',6.79),('9650','2013-06-30','12:40:00',6.82),('9650','2013-06-30','12:45:00',6.84),('9650','2013-06-30','12:50:00',6.93),('9650','2013-06-30','12:55:00',6.99),('9650','2013-06-30','13:00:00',6.88),('9650','2013-06-30','13:05:00',7.1),('9650','2013-06-30','13:10:00',7.09),('9650','2013-06-30','13:15:00',7.11),('9650','2013-06-30','13:20:00',7.17),('9650','2013-06-30','13:25:00',7.2),('9650','2013-06-30','13:30:00',7.26),('9650','2013-06-30','13:35:00',7.37),('9650','2013-06-30','13:40:00',7.35),('9650','2013-06-30','13:45:00',7.28),('9650','2013-06-30','13:50:00',7.27),('9650','2013-06-30','13:55:00',7.3),('9650','2013-06-30','14:00:00',7.28),('9650','2013-06-30','14:05:00',7.4),('9650','2013-06-30','14:10:00',7.44),('9650','2013-06-30','14:15:00',7.39),('9650','2013-06-30','14:20:00',7.38),('9650','2013-06-30','14:25:00',7.3),('9650','2013-06-30','14:30:00',7.33),('9650','2013-06-30','14:35:00',7.3),('9650','2013-06-30','14:40:00',7.29),('9650','2013-06-30','14:45:00',7.3),('9650','2013-06-30','14:50:00',7.27),('9650','2013-06-30','14:55:00',7.27),('9650','2013-06-30','15:00:00',7.23),('9650','2013-06-30','15:05:00',7.2),('9650','2013-06-30','15:10:00',7.23),('9650','2013-06-30','15:15:00',7.22),('9650','2013-06-30','15:20:00',7.19),('9650','2013-06-30','15:25:00',7.14),('9650','2013-06-30','15:30:00',7.1),('9650','2013-06-30','15:35:00',7.04),('9650','2013-06-30','15:40:00',6.95),('9650','2013-06-30','15:45:00',7.04),('9650','2013-06-30','15:50:00',6.94),('9650','2013-06-30','15:55:00',6.82),('9650','2013-06-30','16:00:00',6.8),('9650','2013-06-30','16:05:00',6.79),('9650','2013-06-30','16:10:00',6.71),('9650','2013-06-30','16:15:00',6.63),('9650','2013-06-30','16:20:00',6.51),('9650','2013-06-30','16:25:00',6.45),('9650','2013-06-30','16:30:00',6.36),('9650','2013-06-30','16:35:00',6.32),('9650','2013-06-30','16:40:00',6.3),('9650','2013-06-30','16:45:00',6.26),('9650','2013-06-30','16:50:00',6.16),('9650','2013-06-30','16:55:00',6.15),('9650','2013-06-30','17:00:00',6.07),('9650','2013-06-30','17:05:00',5.98),('9650','2013-06-30','17:10:00',5.94),('9650','2013-06-30','17:15:00',5.8),('9650','2013-06-30','17:20:00',5.66),('9650','2013-06-30','17:25:00',5.54),('9650','2013-06-30','17:30:00',5.42),('9650','2013-06-30','17:35:00',5.31),('9650','2013-06-30','17:40:00',5.22),('9650','2013-06-30','17:45:00',5.13),('9650','2013-06-30','17:50:00',5.07),('9650','2013-06-30','17:55:00',4.94),('9650','2013-06-30','18:00:00',4.41),('9650','2013-06-30','18:05:00',4.59),('9650','2013-06-30','18:10:00',4.47),('9650','2013-06-30','18:15:00',3.67),('9650','2013-06-30','18:20:00',3.89),('9650','2013-06-30','18:25:00',4.29),('9650','2013-06-30','18:30:00',4.13),('9650','2013-06-30','18:35:00',3.9),('9650','2013-06-30','18:40:00',3.56),('9650','2013-06-30','18:45:00',3.48),('9650','2013-06-30','18:50:00',3.28),('9650','2013-06-30','18:55:00',2.96),('9650','2013-06-30','19:00:00',2.86),('9650','2013-06-30','19:05:00',2.76),('9650','2013-06-30','19:10:00',2.61),('9650','2013-06-30','19:15:00',1.94),('9650','2013-06-30','19:20:00',2.31),('9650','2013-06-30','19:25:00',2.06),('9650','2013-06-30','19:30:00',1.76),('9650','2013-06-30','19:35:00',1.5),('9650','2013-06-30','19:40:00',1.37),('9650','2013-06-30','19:45:00',1.3),('9650','2013-06-30','19:50:00',1.28),('9650','2013-06-30','19:55:00',1.14),('9650','2014-04-04','08:35:00',1.05),('9650','2014-04-04','08:40:00',1.16),('9650','2014-04-04','08:45:00',1.08),('9650','2014-04-04','09:05:00',1.16),('9650','2014-04-04','09:10:00',1.26),('9650','2014-04-04','09:15:00',1.7),('9650','2014-04-04','09:20:00',2.29),('9650','2014-04-04','09:25:00',2.68),('9650','2014-04-04','09:30:00',3.72),('9650','2014-04-04','09:35:00',3.7),('9650','2014-04-04','09:40:00',3.75),('9650','2014-04-04','09:45:00',3.41),('9650','2014-04-04','09:50:00',2.22),('9650','2014-04-04','09:55:00',2.28),('9650','2014-04-04','10:00:00',2.45),('9650','2014-04-04','10:05:00',2.62),('9650','2014-04-04','10:10:00',3.13),('9650','2014-04-04','10:15:00',2.4),('9650','2014-04-04','10:20:00',2.95),('9650','2014-04-04','10:25:00',3.06),('9650','2014-04-04','10:30:00',2.85),('9650','2014-04-04','10:35:00',3.06),('9650','2014-04-04','10:40:00',3.5),('9650','2014-04-04','10:45:00',3.68),('9650','2014-04-04','10:50:00',3.03),('9650','2014-04-04','10:55:00',3.41),('9650','2014-04-04','11:00:00',3.98),('9650','2014-04-04','11:05:00',4.19),('9650','2014-04-04','11:10:00',4.82),('9650','2014-04-04','11:15:00',5.02),('9650','2014-04-04','11:20:00',5.42),('9650','2014-04-04','11:25:00',4.69),('9650','2014-04-04','11:30:00',3.24),('9650','2014-04-04','11:35:00',3.1),('9650','2014-04-04','11:40:00',4.17),('9650','2014-04-04','11:45:00',5.38),('9650','2014-04-04','11:50:00',5.67),('9650','2014-04-04','11:55:00',5.62),('9650','2014-04-04','12:00:00',5.34),('9650','2014-04-04','12:05:00',4.46),('9650','2014-04-04','12:10:00',4.32),('9650','2014-04-04','12:15:00',5.03),('9650','2014-04-04','12:20:00',4.8),('9650','2014-04-04','12:25:00',5.12),('9650','2014-04-04','12:30:00',4.2),('9650','2014-04-04','12:35:00',3.36),('9650','2014-04-04','12:40:00',5.11),('9650','2014-04-04','12:45:00',6.79),('9650','2014-04-04','12:50:00',6.79),('9650','2014-04-04','12:55:00',6.77),('9650','2014-04-04','13:00:00',5.58),('9650','2014-04-04','13:05:00',4.92),('9650','2014-04-04','13:10:00',4.75),('9650','2014-04-04','13:15:00',2.77),('9650','2014-04-04','13:20:00',5.16),('9650','2014-04-04','13:25:00',6.96),('9650','2014-04-04','13:30:00',6.63),('9650','2014-04-04','13:35:00',6.78),('9650','2014-04-04','13:40:00',5.33),('9650','2014-04-04','13:45:00',6.44),('9650','2014-04-04','13:50:00',7.12),('9650','2014-04-04','13:55:00',5.95),('9650','2014-04-04','14:00:00',6.26),('9650','2014-04-04','14:05:00',8.17),('9650','2014-04-04','14:10:00',4.96),('9650','2014-04-04','14:15:00',1.18),('9650','2014-04-04','14:20:00',1.43),('9650','2014-04-04','14:25:00',2.06),('9650','2014-04-04','14:30:00',2.92),('9650','2014-04-04','14:35:00',1.71),('9650','2014-04-04','14:40:00',1.32),('9650','2014-04-04','14:45:00',1.28),('9650','2014-04-04','14:50:00',1.77),('9650','2014-04-04','14:55:00',6.79),('9650','2014-04-04','15:00:00',7.18),('9650','2014-04-04','15:05:00',5.59),('9650','2014-04-04','15:10:00',5),('9650','2014-04-04','15:15:00',3.27),('9650','2014-04-04','15:20:00',6.79),('9650','2014-04-04','15:25:00',4.53),('9650','2014-04-04','15:30:00',2.65),('9650','2014-04-04','15:35:00',2.69),('9650','2014-04-04','15:40:00',3.36),('9650','2014-04-04','15:45:00',3.23),('9650','2014-04-04','15:50:00',4.3),('9650','2014-04-04','15:55:00',2.25),('9650','2014-04-04','16:00:00',2.24),('9650','2014-04-04','16:05:00',2.33),('9650','2014-04-04','16:10:00',2.19),('9650','2014-04-04','16:15:00',3.45),('9650','2014-04-04','16:20:00',6.83),('9650','2014-04-04','16:25:00',4.76),('9650','2014-04-04','16:30:00',3.79),('9650','2014-04-04','16:35:00',4.63),('9650','2014-04-04','16:40:00',2.83),('9650','2014-04-04','16:45:00',4.36),('9650','2014-04-04','16:50:00',2.87),('9650','2014-04-04','16:55:00',4.77),('9650','2014-04-04','17:00:00',3.1),('9650','2014-04-04','17:05:00',4.23),('9650','2014-04-04','17:10:00',3.62),('9650','2014-04-04','17:15:00',2.28),('9650','2014-04-04','17:20:00',2.6),('9650','2014-04-04','17:25:00',2.58),('9650','2014-04-04','17:30:00',2.69),('9650','2014-04-04','17:35:00',2.26),('9650','2014-04-04','17:40:00',2.12),('9650','2014-04-04','17:45:00',2.04),('9650','2014-04-04','17:50:00',2.73),('9650','2014-04-04','17:55:00',2.83),('9650','2014-04-04','18:00:00',2.67),('9650','2014-04-04','18:05:00',2.51),('9650','2014-04-04','18:10:00',2.48),('9650','2014-04-04','18:15:00',2.71),('9650','2014-04-04','18:20:00',2.6),('9650','2014-04-04','18:25:00',1.83),('9650','2014-04-04','18:30:00',1.06),('9650','2013-06-29','07:50:00',1.01),('9650','2013-06-29','07:55:00',1.09),('9650','2013-06-29','08:00:00',1.16),('9650','2013-06-29','08:05:00',1.24),('9650','2013-06-29','08:10:00',1.34),('9650','2013-06-29','08:15:00',1.44),('9650','2013-06-29','08:20:00',1.57),('9650','2013-06-29','08:25:00',1.75),('9650','2013-06-29','08:30:00',1.92),('9650','2013-06-29','08:35:00',2.05),('9650','2013-06-29','08:40:00',2.18),('9650','2013-06-29','08:45:00',2.29),('9650','2013-06-29','08:50:00',2.44),('9650','2013-06-29','08:55:00',2.55),('9650','2013-06-29','09:00:00',2.66),('9650','2013-06-29','09:05:00',2.8),('9650','2013-06-29','09:10:00',2.92),('9650','2013-06-29','09:15:00',3.03),('9650','2013-06-29','09:20:00',3.17),('9650','2013-06-29','09:25:00',3.3),('9650','2013-06-29','09:30:00',3.45),('9650','2013-06-29','09:35:00',3.65),('9650','2013-06-29','09:40:00',3.83),('9650','2013-06-29','09:45:00',3.94),('9650','2013-06-29','09:50:00',4.08),('9650','2013-06-29','09:55:00',4.18),('9650','2013-06-29','10:00:00',4.28),('9650','2013-06-29','10:05:00',4.39),('9650','2013-06-29','10:10:00',4.55),('9650','2013-06-29','10:15:00',4.6),('9650','2013-06-29','10:20:00',4.69),('9650','2013-06-29','10:25:00',4.87),('9650','2013-06-29','10:30:00',4.98),('9650','2013-06-29','10:35:00',5.1),('9650','2013-06-29','10:40:00',5.2),('9650','2013-06-29','10:45:00',5.33),('9650','2013-06-29','10:50:00',5.44),('9650','2013-06-29','10:55:00',5.51),('9650','2013-06-29','11:00:00',5.59),('9650','2013-06-29','11:05:00',5.68),('9650','2013-06-29','11:10:00',5.76),('9650','2013-06-29','11:15:00',5.84),('9650','2013-06-29','11:20:00',5.9),('9650','2013-06-29','11:25:00',6.02),('9650','2013-06-29','11:30:00',6.09),('9650','2013-06-29','11:35:00',6.13),('9650','2013-06-29','11:40:00',6.23),('9650','2013-06-29','11:45:00',6.32),('9650','2013-06-29','11:50:00',6.36),('9650','2013-06-29','11:55:00',6.42),('9650','2013-06-29','12:00:00',6.49),('9650','2013-06-29','12:05:00',6.55),('9650','2013-06-29','12:10:00',6.64),('9650','2013-06-29','12:15:00',6.75),('9650','2013-06-29','12:20:00',6.78),('9650','2013-06-29','12:25:00',6.81),('9650','2013-06-29','12:30:00',6.89),('9650','2013-06-29','12:35:00',6.98),('9650','2013-06-29','12:40:00',7.04),('9650','2013-06-29','12:45:00',7.03),('9650','2013-06-29','12:50:00',7.16),('9650','2013-06-29','12:55:00',7.27),('9650','2013-06-29','13:00:00',7.28),('9650','2013-06-29','13:05:00',7.24),('9650','2013-06-29','13:10:00',7.26),('9650','2013-06-29','13:15:00',7.41),('9650','2013-06-29','13:20:00',7.41),('9650','2013-06-29','13:25:00',7.48),('9650','2013-06-29','13:30:00',7.49),('9650','2013-06-29','13:35:00',7.52),('9650','2013-06-29','13:40:00',6.41),('9650','2013-06-29','13:45:00',7.67),('9650','2013-06-29','13:50:00',7.8),('9650','2013-06-29','13:55:00',7.4),('9650','2013-06-29','14:00:00',7.43),('9650','2013-06-29','14:05:00',7.77),('9650','2013-06-29','14:10:00',7.7),('9650','2013-06-29','14:15:00',7.54),('9650','2013-06-29','14:20:00',7.61),('9650','2013-06-29','14:25:00',7.6),('9650','2013-06-29','14:30:00',7.5),('9650','2013-06-29','14:35:00',7.44),('9650','2013-06-29','14:40:00',7.49),('9650','2013-06-29','14:45:00',7.58),('9650','2013-06-29','14:50:00',7.48),('9650','2013-06-29','14:55:00',7.48),('9650','2013-06-29','15:00:00',7.44),('9650','2013-06-29','15:05:00',7.37),('9650','2013-06-29','15:10:00',7.4),('9650','2013-06-29','15:15:00',7.39),('9650','2013-06-29','15:20:00',7.5),('9650','2013-06-29','15:25:00',7.43),('9650','2013-06-29','15:30:00',7.45),('9650','2013-06-29','15:35:00',7.47),('9650','2013-06-29','15:40:00',7.46),('9650','2013-06-29','15:45:00',7.4),('9650','2013-06-29','15:50:00',7.34),('9650','2013-06-29','15:55:00',7.22),('9650','2013-06-29','16:00:00',7.17),('9650','2013-06-29','16:05:00',7.08),('9650','2013-06-29','16:10:00',7.13),('9650','2013-06-29','16:15:00',7.05),('9650','2013-06-29','16:20:00',7.14),('9650','2013-06-29','16:25:00',7.18),('9650','2013-06-29','16:30:00',6.76),('9650','2013-06-29','16:35:00',6.82),('9650','2013-06-29','16:40:00',6.49),('9650','2013-06-29','16:45:00',6.51),('9650','2013-06-29','16:50:00',6.45),('9650','2013-06-29','16:55:00',6.33),('9650','2013-06-29','17:00:00',6.16),('9650','2013-06-29','17:05:00',6.04),('9650','2013-06-29','17:10:00',6.03),('9650','2013-06-29','17:15:00',5.88),('9650','2013-06-29','17:20:00',5.77),('9650','2013-06-29','17:25:00',5.64),('9650','2013-06-29','17:30:00',5.49),('9650','2013-06-29','17:35:00',5.37),('9650','2013-06-29','17:40:00',5.32),('9650','2013-06-29','17:45:00',5.14),('9650','2013-06-29','17:50:00',5.04),('9650','2013-06-29','17:55:00',4.89),('9650','2013-06-29','18:00:00',4.69),('9650','2013-06-29','18:05:00',4.5),('9650','2013-06-29','18:10:00',4.5),('9650','2013-06-29','18:15:00',4.4),('9650','2013-06-29','18:20:00',4.27),('9650','2013-06-29','18:25:00',4.13),('9650','2013-06-29','18:30:00',3.94),('9650','2013-06-29','18:35:00',3.8),('9650','2013-06-29','18:40:00',3.7),('9650','2013-06-29','18:45:00',3.52),('9650','2013-06-29','18:50:00',3.39),('9650','2013-06-29','18:55:00',3.3),('9650','2013-06-29','19:00:00',3.14),('9650','2013-06-29','19:05:00',2.97),('9650','2013-06-29','19:10:00',2.82),('9650','2013-06-29','19:15:00',2.61),('9650','2013-06-29','19:20:00',2.4),('9650','2013-06-29','19:25:00',2.19),('9650','2013-06-29','19:30:00',2.02),('9650','2013-06-29','19:35:00',1.82),('9650','2013-06-29','19:40:00',1.63),('9650','2013-06-29','19:45:00',1.43),('9650','2013-06-29','19:50:00',1.28),('9650','2013-06-29','19:55:00',1.1),('9650','2013-06-28','07:30:00',1.29),('9650','2013-06-28','07:35:00',1.53),('9650','2013-06-28','07:40:00',1.58),('9650','2013-06-28','07:45:00',1.57),('9650','2013-06-28','07:50:00',1.7),('9650','2013-06-28','07:55:00',1.95),('9650','2013-06-28','08:00:00',2.21),('9650','2013-06-28','08:05:00',2.37),('9650','2013-06-28','08:10:00',2.33),('9650','2013-06-28','08:15:00',2.01),('9650','2013-06-28','08:20:00',1.49),('9650','2013-06-28','08:25:00',1.95),('9650','2013-06-28','08:30:00',2.04),('9650','2013-06-28','08:35:00',2.15),('9650','2013-06-28','08:40:00',1.36),('9650','2013-06-28','08:45:00',2.11),('9650','2013-06-28','08:50:00',2.41),('9650','2013-06-28','08:55:00',2.53),('9650','2013-06-28','09:00:00',2.63),('9650','2013-06-28','09:05:00',2.75),('9650','2013-06-28','09:10:00',2.89),('9650','2013-06-28','09:15:00',3.01),('9650','2013-06-28','09:20:00',3.15),('9650','2013-06-28','09:25:00',3.24),('9650','2013-06-28','09:30:00',3.36),('9650','2013-06-28','09:35:00',3.56),('9650','2013-06-28','09:40:00',3.75),('9650','2013-06-28','09:45:00',3.89),('9650','2013-06-28','09:50:00',4),('9650','2013-06-28','09:55:00',4.12),('9650','2013-06-28','10:00:00',4.22),('9650','2013-06-28','10:05:00',4.32),('9650','2013-06-28','10:10:00',4.49),('9650','2013-06-28','10:15:00',4.56),('9650','2013-06-28','10:20:00',4.62),('9650','2013-06-28','10:25:00',4.81),('9650','2013-06-28','10:30:00',4.88),('9650','2013-06-28','10:35:00',5.03),('9650','2013-06-28','10:40:00',5.13),('9650','2013-06-28','10:45:00',5.14),('9650','2013-06-28','10:50:00',5.23),('9650','2013-06-28','10:55:00',5.64),('9650','2013-06-28','11:00:00',5.75),('9650','2013-06-28','11:05:00',5.88),('9650','2013-06-28','11:10:00',6.08),('9650','2013-06-28','11:15:00',6.31),('9650','2013-06-28','11:20:00',6.22),('9650','2013-06-28','11:25:00',6.89),('9650','2013-06-28','11:30:00',5.92),('9650','2013-06-28','11:35:00',4.29),('9650','2013-06-28','11:40:00',6.81),('9650','2013-06-28','11:45:00',6.65),('9650','2013-06-28','11:50:00',6.85),('9650','2013-06-28','11:55:00',6.33),('9650','2013-06-28','12:00:00',4.98),('9650','2013-06-28','12:05:00',6.59),('9650','2013-06-28','12:10:00',7.15),('9650','2013-06-28','12:15:00',7.04),('9650','2013-06-28','12:20:00',3.16),('9650','2013-06-28','12:25:00',6.85),('9650','2013-06-28','12:30:00',7.59),('9650','2013-06-28','12:35:00',7.28),('9650','2013-06-28','12:40:00',6.65),('9650','2013-06-28','12:45:00',8.17),('9650','2013-06-28','12:50:00',3.68),('9650','2013-06-28','12:55:00',7.66),('9650','2013-06-28','13:00:00',5.35),('9650','2013-06-28','13:05:00',6.79),('9650','2013-06-28','13:10:00',7.1),('9650','2013-06-28','13:15:00',6.67),('9650','2013-06-28','13:20:00',3.04),('9650','2013-06-28','13:25:00',5.81),('9650','2013-06-28','13:30:00',2.16),('9650','2013-06-28','13:35:00',1.61),('9650','2013-06-28','13:40:00',1.77),('9650','2013-06-28','13:45:00',2.92),('9650','2013-06-28','13:50:00',4.05),('9650','2013-06-28','13:55:00',5.79),('9650','2013-06-28','14:00:00',7.69),('9650','2013-06-28','14:05:00',8.51),('9650','2013-06-28','14:10:00',8.63),('9650','2013-06-28','14:15:00',8.63),('9650','2013-06-28','14:20:00',7.86),('9650','2013-06-28','14:25:00',8.61),('9650','2013-06-28','14:30:00',8.39),('9650','2013-06-28','14:35:00',8.29),('9650','2013-06-28','14:40:00',8.3),('9650','2013-06-28','14:45:00',8.46),('9650','2013-06-28','14:50:00',8.91),('9650','2013-06-28','14:55:00',4.21),('9650','2013-06-28','15:00:00',5.58),('9650','2013-06-28','15:05:00',9.16),('9650','2013-06-28','15:10:00',4.34),('9650','2013-06-28','15:15:00',3.63),('9650','2013-06-28','15:20:00',2.55),('9650','2013-06-28','15:25:00',1.87),('9650','2013-06-28','15:30:00',1.19),('9650','2013-06-28','15:35:00',1.1),('9650','2013-06-28','16:25:00',1.13),('9650','2013-06-28','16:30:00',1.28),('9650','2013-06-28','16:35:00',1.84),('9650','2013-06-28','16:40:00',2.51),('9650','2013-06-28','16:45:00',3.08),('9650','2013-06-28','16:50:00',5.4),('9650','2013-06-28','16:55:00',3.11),('9650','2013-06-28','17:00:00',2.48),('9650','2013-06-28','17:05:00',3.27),('9650','2013-06-28','17:10:00',2.49),('9650','2013-06-28','17:15:00',2.31),('9650','2013-06-28','17:20:00',2.75),('9650','2013-06-28','17:25:00',3.13),('9650','2013-06-28','17:30:00',5.84),('9650','2013-06-28','17:35:00',4.8),('9650','2013-06-28','17:40:00',1.96),('9650','2013-06-28','17:45:00',5.14),('9650','2013-06-28','17:50:00',5.35),('9650','2013-06-28','17:55:00',5.27),('9650','2013-06-28','18:00:00',5.04),('9650','2013-06-28','18:05:00',4.92),('9650','2013-06-28','18:10:00',3.18),('9650','2013-06-28','18:15:00',4.59),('9650','2013-06-28','18:20:00',4.44),('9650','2013-06-28','18:25:00',4.01),('9650','2013-06-28','18:30:00',1.27),('9650','2013-06-28','18:35:00',3.45),('9650','2013-06-28','18:40:00',3.53),('9650','2013-06-28','18:45:00',1.93),('9650','2013-06-28','19:00:00',1),('9650','2013-06-28','19:05:00',2.37),('9650','2013-06-28','19:10:00',3.03),('9650','2013-06-28','19:15:00',1.62),('9650','2013-06-28','19:20:00',1.14),('9650','2013-06-28','19:25:00',1.78),('9650','2013-06-28','19:30:00',1.17),('9650','2013-06-27','07:45:00',1),('9650','2013-06-27','07:50:00',1.06),('9650','2013-06-27','07:55:00',1.13),('9650','2013-06-27','08:00:00',1.16),('9650','2013-06-27','08:05:00',1.13),('9650','2013-06-27','08:10:00',1.2),('9650','2013-06-27','08:15:00',1.27),('9650','2013-06-27','08:20:00',1.52),('9650','2013-06-27','08:25:00',1.65),('9650','2013-06-27','08:30:00',1.88),('9650','2013-06-27','08:35:00',2.04),('9650','2013-06-27','08:40:00',2.15),('9650','2013-06-27','08:45:00',2.28),('9650','2013-06-27','08:50:00',2.42),('9650','2013-06-27','08:55:00',2.61),('9650','2013-06-27','09:00:00',2.68),('9650','2013-06-27','09:05:00',2.82),('9650','2013-06-27','09:10:00',2.53),('9650','2013-06-27','09:15:00',3.38),('9650','2013-06-27','09:20:00',1.57),('9650','2013-06-27','09:25:00',1.8),('9650','2013-06-27','09:30:00',2.7),('9650','2013-06-27','09:35:00',3.91),('9650','2013-06-27','09:40:00',4.21),('9650','2013-06-27','09:45:00',4.44),('9650','2013-06-27','09:50:00',4.6),('9650','2013-06-27','09:55:00',5.11),('9650','2013-06-27','10:00:00',1.63),('9650','2013-06-27','10:05:00',2.23),('9650','2013-06-27','10:10:00',5),('9650','2013-06-27','10:15:00',5.32),('9650','2013-06-27','10:20:00',3.18),('9650','2013-06-27','10:25:00',2.37),('9650','2013-06-27','10:30:00',3.84),('9650','2013-06-27','10:35:00',6.67),('9650','2013-06-27','10:40:00',5.72),('9650','2013-06-27','10:45:00',6.55),('9650','2013-06-27','10:50:00',3.04),('9650','2013-06-27','10:55:00',3.95),('9650','2013-06-27','11:00:00',4.43),('9650','2013-06-27','11:05:00',3.61),('9650','2013-06-27','11:10:00',2.86),('9650','2013-06-27','11:15:00',3.24),('9650','2013-06-27','11:20:00',2.17),('9650','2013-06-27','11:25:00',4.38),('9650','2013-06-27','11:30:00',6.88),('9650','2013-06-27','11:35:00',5.68),('9650','2013-06-27','11:40:00',6.57),('9650','2013-06-27','11:45:00',5.89),('9650','2013-06-27','11:50:00',7.6),('9650','2013-06-27','11:55:00',4.44),('9650','2013-06-27','12:00:00',3.92),('9650','2013-06-27','12:05:00',4.94),('9650','2013-06-27','12:10:00',7.84),('9650','2013-06-27','12:15:00',7.37),('9650','2013-06-27','12:20:00',7.18),('9650','2013-06-27','12:25:00',7.34),('9650','2013-06-27','12:30:00',6.9),('9650','2013-06-27','12:35:00',6.25),('9650','2013-06-27','12:40:00',4.23),('9650','2013-06-27','12:45:00',7.43),('9650','2013-06-27','12:50:00',7.52),('9650','2013-06-27','12:55:00',7.35),('9650','2013-06-27','13:00:00',7.46),('9650','2013-06-27','13:05:00',7.56),('9650','2013-06-27','13:10:00',7.76),('9650','2013-06-27','13:15:00',7.63),('9650','2013-06-27','13:20:00',5.46),('9650','2013-06-27','13:25:00',7.52),('9650','2013-06-27','13:30:00',7.62),('9650','2013-06-27','13:35:00',7.71),('9650','2013-06-27','13:40:00',6.97),('9650','2013-06-27','13:45:00',7.66),('9650','2013-06-27','13:50:00',7.49),('9650','2013-06-27','13:55:00',7.99),('9650','2013-06-27','14:00:00',7.06),('9650','2013-06-27','14:05:00',7.29),('9650','2013-06-27','14:10:00',6.77),('9650','2013-06-27','14:15:00',7.33),('9650','2013-06-27','14:20:00',8.39),('9650','2013-06-27','14:25:00',5.5),('9650','2013-06-27','14:30:00',6.33),('9650','2013-06-27','14:35:00',7.45),('9650','2013-06-27','14:40:00',6.7),('9650','2013-06-27','14:45:00',8.1),('9650','2013-06-27','14:50:00',7.95),('9650','2013-06-27','14:55:00',7.66),('9650','2013-06-27','15:00:00',7.04),('9650','2013-06-27','15:05:00',7.67),('9650','2013-06-27','15:10:00',7.84),('9650','2013-06-27','15:15:00',7.33),('9650','2013-06-27','15:20:00',8.01),('9650','2013-06-27','15:25:00',7.99),('9650','2013-06-27','15:30:00',4.1),('9650','2013-06-27','15:35:00',6.49),('9650','2013-06-27','15:40:00',4.09),('9650','2013-06-27','15:45:00',6.37),('9650','2013-06-27','15:50:00',8.07),('9650','2013-06-27','15:55:00',6.64),('9650','2013-06-27','16:00:00',7.74),('9650','2013-06-27','16:05:00',6.84),('9650','2013-06-27','16:10:00',3.67),('9650','2013-06-27','16:15:00',6.81),('9650','2013-06-27','16:20:00',7.27),('9650','2013-06-27','16:25:00',3.83),('9650','2013-06-27','16:30:00',5.36),('9650','2013-06-27','16:35:00',1.98),('9650','2013-06-27','16:40:00',3.89),('9650','2013-06-27','16:45:00',2.41),('9650','2013-06-27','16:50:00',6.69),('9650','2013-06-27','16:55:00',5.48),('9650','2013-06-27','17:00:00',6.58),('9650','2013-06-27','17:05:00',6.19),('9650','2013-06-27','17:10:00',6.14),('9650','2013-06-27','17:15:00',6.01),('9650','2013-06-27','17:20:00',5.79),('9650','2013-06-27','17:25:00',5.82),('9650','2013-06-27','17:30:00',5.23),('9650','2013-06-27','17:35:00',5.55),('9650','2013-06-27','17:40:00',5.36),('9650','2013-06-27','17:45:00',5.31),('9650','2013-06-27','17:50:00',5.24),('9650','2013-06-27','17:55:00',5.18),('9650','2013-06-27','18:00:00',5.08),('9650','2013-06-27','18:05:00',4.93),('9650','2013-06-27','18:10:00',4.76),('9650','2013-06-27','18:15:00',4.61),('9650','2013-06-27','18:20:00',4.54),('9650','2013-06-27','18:25:00',4.47),('9650','2013-06-27','18:30:00',4.03),('9650','2013-06-27','18:35:00',2.39),('9650','2013-06-27','18:40:00',3.77),('9650','2013-06-27','18:45:00',2.7),('9650','2013-06-27','18:50:00',3.58),('9650','2013-06-27','18:55:00',3.19),('9650','2013-06-27','19:00:00',3.12),('9650','2013-06-27','19:05:00',3.06),('9650','2013-06-27','19:10:00',2.9),('9650','2013-06-27','19:15:00',2.48),('9650','2013-06-27','19:20:00',2.61),('9650','2013-06-27','19:25:00',2.51),('9650','2013-06-27','19:30:00',2.31),('9650','2013-06-27','19:35:00',2.1),('9650','2013-06-27','19:40:00',1.92),('9650','2013-06-27','19:45:00',1.78),('9650','2013-06-27','19:50:00',1.47),('9650','2013-06-27','19:55:00',1.19),('9650','2013-06-27','20:00:00',1.01),('9650','2013-06-26','07:50:00',1),('9650','2013-06-26','07:55:00',1.09),('9650','2013-06-26','08:00:00',1.17),('9650','2013-06-26','08:05:00',1.28),('9650','2013-06-26','08:10:00',1.36),('9650','2013-06-26','08:15:00',1.46),('9650','2013-06-26','08:20:00',1.61),('9650','2013-06-26','08:25:00',1.77),('9650','2013-06-26','08:30:00',1.91),('9650','2013-06-26','08:35:00',2.02),('9650','2013-06-26','08:40:00',2.13),('9650','2013-06-26','08:45:00',2.26),('9650','2013-06-26','08:50:00',2.4),('9650','2013-06-26','08:55:00',2.55),('9650','2013-06-26','09:00:00',2.69),('9650','2013-06-26','09:05:00',2.78),('9650','2013-06-26','09:10:00',2.91),('9650','2013-06-26','09:15:00',3.01),('9650','2013-06-26','09:20:00',3.21),('9650','2013-06-26','09:25:00',3.32),('9650','2013-06-26','09:30:00',3.44),('9650','2013-06-26','09:35:00',3.68),('9650','2013-06-26','09:40:00',3.81),('9650','2013-06-26','09:45:00',3.87),('9650','2013-06-26','09:50:00',4.14),('9650','2013-06-26','09:55:00',3.92),('9650','2013-06-26','10:00:00',4.3),('9650','2013-06-26','10:05:00',4.06),('9650','2013-06-26','10:10:00',4.41),('9650','2013-06-26','10:15:00',3.5),('9650','2013-06-26','10:20:00',4.77),('9650','2013-06-26','10:25:00',4.87),('9650','2013-06-26','10:30:00',5.04),('9650','2013-06-26','10:35:00',5.4),('9650','2013-06-26','10:40:00',5.78),('9650','2013-06-26','10:45:00',5.79),('9650','2013-06-26','10:50:00',5.75),('9650','2013-06-26','10:55:00',6.03),('9650','2013-06-26','11:00:00',5.93),('9650','2013-06-26','11:05:00',6.05),('9650','2013-06-26','11:10:00',6.21),('9650','2013-06-26','11:15:00',5.63),('9650','2013-06-26','11:20:00',6.29),('9650','2013-06-26','11:25:00',6.46),('9650','2013-06-26','11:30:00',6.28),('9650','2013-06-26','11:35:00',6.54),('9650','2013-06-26','11:40:00',6.93),('9650','2013-06-26','11:45:00',7.01),('9650','2013-06-26','11:50:00',2.57),('9650','2013-06-26','11:55:00',2.24),('9650','2013-06-26','12:00:00',2.39),('9650','2013-06-26','12:05:00',2.23),('9650','2013-06-26','12:10:00',2.17),('9650','2013-06-26','12:15:00',1.9),('9650','2013-06-26','12:20:00',2.03),('9650','2013-06-26','12:25:00',2.92),('9650','2013-06-26','12:30:00',2.87),('9650','2013-06-26','12:35:00',5.14),('9650','2013-06-26','12:40:00',3.06),('9650','2013-06-26','12:45:00',2.72),('9650','2013-06-26','12:50:00',2.27),('9650','2013-06-26','12:55:00',2.04),('9650','2013-06-26','13:00:00',1.79),('9650','2013-06-26','13:05:00',2.04),('9650','2013-06-26','13:10:00',2.59),('9650','2013-06-26','13:15:00',4.42),('9650','2013-06-26','13:20:00',2.74),('9650','2013-06-26','13:25:00',2.94),('9650','2013-06-26','13:30:00',2.63),('9650','2013-06-26','13:35:00',2.54),('9650','2013-06-26','13:40:00',2.3),('9650','2013-06-26','13:45:00',2.33),('9650','2013-06-26','13:50:00',3.46),('9650','2013-06-26','13:55:00',2.34),('9650','2013-06-26','14:00:00',2.47),('9650','2013-06-26','14:05:00',2.37),('9650','2013-06-26','14:10:00',5.61),('9650','2013-06-26','14:15:00',3.26),('9650','2013-06-26','14:20:00',6.62),('9650','2013-06-26','14:25:00',8.29),('9650','2013-06-26','14:30:00',6.49),('9650','2013-06-26','14:35:00',3.66),('9650','2013-06-26','14:40:00',4.83),('9650','2013-06-26','14:45:00',2.93),('9650','2013-06-26','14:50:00',3.41),('9650','2013-06-26','14:55:00',7.46),('9650','2013-06-26','15:00:00',7.46),('9650','2013-06-26','15:05:00',7.34),('9650','2013-06-26','15:10:00',7.3),('9650','2013-06-26','15:15:00',7.22),('9650','2013-06-26','15:20:00',7.24),('9650','2013-06-26','15:25:00',7.3),('9650','2013-06-26','15:30:00',7.24),('9650','2013-06-26','15:35:00',7.23),('9650','2013-06-26','15:40:00',7.17),('9650','2013-06-26','15:45:00',7.12),('9650','2013-06-26','15:50:00',7.09),('9650','2013-06-26','15:55:00',6.76),('9650','2013-06-26','16:00:00',6.82),('9650','2013-06-26','16:05:00',6.75),('9650','2013-06-26','16:10:00',6.74),('9650','2013-06-26','16:15:00',6.68),('9650','2013-06-26','16:20:00',6.64),('9650','2013-06-26','16:25:00',6.58),('9650','2013-06-26','16:30:00',6.57),('9650','2013-06-26','16:35:00',6.13),('9650','2013-06-26','16:40:00',6.27),('9650','2013-06-26','16:45:00',6.37),('9650','2013-06-26','16:50:00',6.22),('9650','2013-06-26','16:55:00',6.12),('9650','2013-06-26','17:00:00',6.07),('9650','2013-06-26','17:05:00',5.95),('9650','2013-06-26','17:10:00',5.67),('9650','2013-06-26','17:15:00',5.51),('9650','2013-06-26','17:20:00',5.73),('9650','2013-06-26','17:25:00',5.64),('9650','2013-06-26','17:30:00',5.62),('9650','2013-06-26','17:35:00',5.49),('9650','2013-06-26','17:40:00',3.58),('9650','2013-06-26','17:45:00',2.51),('9650','2013-06-26','17:50:00',4.59),('9650','2013-06-26','17:55:00',4.83),('9650','2013-06-26','18:00:00',4.67),('9650','2013-06-26','18:05:00',4.45),('9650','2013-06-26','18:10:00',4.34),('9650','2013-06-26','18:15:00',4.16),('9650','2013-06-26','18:20:00',4.03),('9650','2013-06-26','18:25:00',4.07),('9650','2013-06-26','18:30:00',3.86),('9650','2013-06-26','18:35:00',3.65),('9650','2013-06-26','18:40:00',3.28),('9650','2013-06-26','18:45:00',3.22),('9650','2013-06-26','18:50:00',3.16),('9650','2013-06-26','18:55:00',3.07),('9650','2013-06-26','19:00:00',2.87),('9650','2013-06-26','19:05:00',2.67),('9650','2013-06-26','19:10:00',2.53),('9650','2013-06-26','19:15:00',2.36),('9650','2013-06-26','19:20:00',2.17),('9650','2013-06-26','19:25:00',1.25),('9650','2013-06-25','07:50:00',1.02),('9650','2013-06-25','07:55:00',1.08),('9650','2013-06-25','08:00:00',1.15),('9650','2013-06-25','08:05:00',1.26),('9650','2013-06-25','08:10:00',1.36),('9650','2013-06-25','08:15:00',1.48),('9650','2013-06-25','08:20:00',1.6),('9650','2013-06-25','08:25:00',1.78),('9650','2013-06-25','08:30:00',1.93),('9650','2013-06-25','08:35:00',2.05),('9650','2013-06-25','08:40:00',2.14),('9650','2013-06-25','08:45:00',2.27),('9650','2013-06-25','08:50:00',2.39),('9650','2013-06-25','08:55:00',2.5),('9650','2013-06-25','09:00:00',2.62),('9650','2013-06-25','09:05:00',2.75),('9650','2013-06-25','09:10:00',2.86),('9650','2013-06-25','09:15:00',2.96),('9650','2013-06-25','09:20:00',3.1),('9650','2013-06-25','09:25:00',3.26),('9650','2013-06-25','09:30:00',3.38),('9650','2013-06-25','09:35:00',3.57),('9650','2013-06-25','09:40:00',3.71),('9650','2013-06-25','09:45:00',3.85),('9650','2013-06-25','09:50:00',3.94),('9650','2013-06-25','09:55:00',4.02),('9650','2013-06-25','10:00:00',4.14),('9650','2013-06-25','10:05:00',4.27),('9650','2013-06-25','10:10:00',4.43),('9650','2013-06-25','10:15:00',4.54),('9650','2013-06-25','10:20:00',4.62),('9650','2013-06-25','10:25:00',4.73),('9650','2013-06-25','10:30:00',4.83),('9650','2013-06-25','10:35:00',4.93),('9650','2013-06-25','10:40:00',5.06),('9650','2013-06-25','10:45:00',5.21),('9650','2013-06-25','10:50:00',5.33),('9650','2013-06-25','10:55:00',5.42),('9650','2013-06-25','11:00:00',5.5),('9650','2013-06-25','11:05:00',5.61),('9650','2013-06-25','11:10:00',5.68),('9650','2013-06-25','11:15:00',5.78),('9650','2013-06-25','11:20:00',5.84),('9650','2013-06-25','11:25:00',5.92),('9650','2013-06-25','11:30:00',5.99),('9650','2013-06-25','11:35:00',6.06),('9650','2013-06-25','11:40:00',6.15),('9650','2013-06-25','11:45:00',6.18),('9650','2013-06-25','11:50:00',6.3),('9650','2013-06-25','11:55:00',6.43),('9650','2013-06-25','12:00:00',6.52),('9650','2013-06-25','12:05:00',6.61),('9650','2013-06-25','12:10:00',6.52),('9650','2013-06-25','12:15:00',6.6),('9650','2013-06-25','12:20:00',6.5),('9650','2013-06-25','12:25:00',6.6),('9650','2013-06-25','12:30:00',5.82),('9650','2013-06-25','12:35:00',6.24),('9650','2013-06-25','12:40:00',6.04),('9650','2013-06-25','12:45:00',4.1),('9650','2013-06-25','12:50:00',1.58),('9650','2013-06-25','12:55:00',1.93),('9650','2013-06-25','13:00:00',1.6),('9650','2013-06-25','13:05:00',1.77),('9650','2013-06-25','13:10:00',4.71),('9650','2013-06-25','13:15:00',7.9),('9650','2013-06-25','13:20:00',7.99),('9650','2013-06-25','13:25:00',7.7),('9650','2013-06-25','13:30:00',5.93),('9650','2013-06-25','13:35:00',1.74),('9650','2013-06-25','13:40:00',1.91),('9650','2013-06-25','13:45:00',3.58),('9650','2013-06-25','13:50:00',3.9),('9650','2013-06-25','13:55:00',2.87),('9650','2013-06-25','14:00:00',8.3),('9650','2013-06-25','14:05:00',7.5),('9650','2013-06-25','14:10:00',2.65),('9650','2013-06-25','14:15:00',6.6),('9650','2013-06-25','14:20:00',7.91),('9650','2013-06-25','14:25:00',6.13),('9650','2013-06-25','14:30:00',7.62),('9650','2013-06-25','14:35:00',7.44),('9650','2013-06-25','14:40:00',5.64),('9650','2013-06-25','14:45:00',4.41),('9650','2013-06-25','14:50:00',7.96),('9650','2013-06-25','14:55:00',7.86),('9650','2013-06-25','15:00:00',7.53),('9650','2013-06-25','15:05:00',7.49),('9650','2013-06-25','15:10:00',7.4),('9650','2013-06-25','15:15:00',7.37),('9650','2013-06-25','15:20:00',7.37),('9650','2013-06-25','15:25:00',7.29),('9650','2013-06-25','15:30:00',7.23),('9650','2013-06-25','15:35:00',7.35),('9650','2013-06-25','15:40:00',7.24),('9650','2013-06-25','15:45:00',7.18),('9650','2013-06-25','15:50:00',7.24),('9650','2013-06-25','15:55:00',7.07),('9650','2013-06-25','16:00:00',6.93),('9650','2013-06-25','16:05:00',6.94),('9650','2013-06-25','16:10:00',6.92),('9650','2013-06-25','16:15:00',6.84),('9650','2013-06-25','16:20:00',6.79),('9650','2013-06-25','16:25:00',6.69),('9650','2013-06-25','16:30:00',6.58),('9650','2013-06-25','16:35:00',6.5),('9650','2013-06-25','16:40:00',6.35),('9650','2013-06-25','16:45:00',6.36),('9650','2013-06-25','16:50:00',6.3),('9650','2013-06-25','16:55:00',6.23),('9650','2013-06-25','17:00:00',6.2),('9650','2013-06-25','17:05:00',6.14),('9650','2013-06-25','17:10:00',6),('9650','2013-06-25','17:15:00',5.83),('9650','2013-06-25','17:20:00',5.71),('9650','2013-06-25','17:25:00',5.61),('9650','2013-06-25','17:30:00',5.49),('9650','2013-06-25','17:35:00',5.41),('9650','2013-06-25','17:40:00',5.29),('9650','2013-06-25','17:45:00',5.19),('9650','2013-06-25','17:50:00',5.06),('9650','2013-06-25','17:55:00',4.99),('9650','2013-06-25','18:00:00',4.83),('9650','2013-06-25','18:05:00',4.77),('9650','2013-06-25','18:10:00',5.1),('9650','2013-06-25','18:15:00',3.04),('9650','2013-06-25','18:20:00',1.76),('9650','2013-06-25','18:25:00',1.65),('9650','2013-06-25','18:30:00',1.07),('9650','2013-06-25','19:00:00',2.01),('9650','2013-06-25','19:05:00',1.5),('9650','2013-06-25','19:10:00',1.54),('9650','2013-06-25','19:15:00',2.38),('9650','2013-06-25','19:20:00',2.08),('9650','2013-06-25','19:25:00',1.75),('9650','2013-06-25','19:30:00',1.21),('9650','2013-06-24','07:40:00',1.09),('9650','2013-06-24','07:45:00',1.18),('9650','2013-06-24','07:50:00',1.31),('9650','2013-06-24','07:55:00',1.18),('9650','2013-06-24','08:00:00',1.93),('9650','2013-06-24','08:05:00',1.54),('9650','2013-06-24','08:10:00',1.07),('9650','2013-06-24','08:15:00',1.06),('9650','2013-06-24','08:20:00',1.33),('9650','2013-06-24','08:25:00',1.89),('9650','2013-06-24','08:30:00',1.99),('9650','2013-06-24','08:35:00',2.1),('9650','2013-06-24','08:40:00',2.21),('9650','2013-06-24','08:45:00',2.33),('9650','2013-06-24','08:50:00',2.4),('9650','2013-06-24','08:55:00',2.55),('9650','2013-06-24','09:00:00',2.69),('9650','2013-06-24','09:05:00',2.81),('9650','2013-06-24','09:10:00',2.93),('9650','2013-06-24','09:15:00',3.1),('9650','2013-06-24','09:20:00',3.26),('9650','2013-06-24','09:25:00',3.34),('9650','2013-06-24','09:30:00',3.52),('9650','2013-06-24','09:35:00',3.77),('9650','2013-06-24','09:40:00',4.07),('9650','2013-06-24','09:45:00',2.84),('9650','2013-06-24','09:50:00',3.52),('9650','2013-06-24','09:55:00',3.22),('9650','2013-06-24','10:00:00',5.02),('9650','2013-06-24','10:05:00',5.26),('9650','2013-06-24','10:10:00',5.51),('9650','2013-06-24','10:15:00',5.55),('9650','2013-06-24','10:20:00',2.6),('9650','2013-06-24','10:25:00',4.96),('9650','2013-06-24','10:30:00',5.68),('9650','2013-06-24','10:35:00',5.69),('9650','2013-06-24','10:40:00',5.73),('9650','2013-06-24','10:45:00',5.71),('9650','2013-06-24','10:50:00',3.12),('9650','2013-06-24','10:55:00',1.73),('9650','2013-06-24','11:00:00',1.57),('9650','2013-06-24','11:05:00',2.76),('9650','2013-06-24','11:10:00',2.08),('9650','2013-06-24','11:15:00',1.67),('9650','2013-06-24','11:20:00',1.81),('9650','2013-06-24','11:25:00',1.93),('9650','2013-06-24','11:30:00',2.11),('9650','2013-06-24','11:35:00',5.21),('9650','2013-06-24','11:40:00',7.92),('9650','2013-06-24','11:45:00',7.54),('9650','2013-06-24','11:50:00',7.62),('9650','2013-06-24','11:55:00',4.71),('9650','2013-06-24','12:00:00',2.09),('9650','2013-06-24','12:05:00',1.94),('9650','2013-06-24','12:10:00',2.21),('9650','2013-06-24','12:15:00',2.16),('9650','2013-06-24','12:20:00',2.24),('9650','2013-06-24','12:25:00',2.13),('9650','2013-06-24','12:30:00',2.08),('9650','2013-06-24','12:35:00',2.43),('9650','2013-06-24','12:40:00',4.46),('9650','2013-06-24','12:45:00',6.43),('9650','2013-06-24','12:50:00',3.43),('9650','2013-06-24','12:55:00',2.87),('9650','2013-06-24','13:00:00',7.76),('9650','2013-06-24','13:05:00',7.08),('9650','2013-06-24','13:10:00',6.73),('9650','2013-06-24','13:15:00',7.91),('9650','2013-06-24','13:20:00',7.74),('9650','2013-06-24','13:25:00',7.68),('9650','2013-06-24','13:30:00',7.73),('9650','2013-06-24','13:35:00',7.88),('9650','2013-06-24','13:40:00',8.05),('9650','2013-06-24','13:45:00',7.81),('9650','2013-06-24','13:50:00',7.85),('9650','2013-06-24','13:55:00',5.29),('9650','2013-06-24','14:00:00',5.65),('9650','2013-06-24','14:05:00',7.81),('9650','2013-06-24','14:10:00',7.85),('9650','2013-06-24','14:15:00',7.97),('9650','2013-06-24','14:20:00',7.77),('9650','2013-06-24','14:25:00',7.58),('9650','2013-06-24','14:30:00',7.57),('9650','2013-06-24','14:35:00',7.56),('9650','2013-06-24','14:40:00',7.52),('9650','2013-06-24','14:45:00',7.61),('9650','2013-06-24','14:50:00',7.58),('9650','2013-06-24','14:55:00',7.56),('9650','2013-06-24','15:00:00',7.51),('9650','2013-06-24','15:05:00',7.48),('9650','2013-06-24','15:10:00',7.48),('9650','2013-06-24','15:15:00',7.42),('9650','2013-06-24','15:20:00',7.38),('9650','2013-06-24','15:25:00',7.3),('9650','2013-06-24','15:30:00',7.26),('9650','2013-06-24','15:35:00',7.25),('9650','2013-06-24','15:40:00',7.23),('9650','2013-06-24','15:45:00',7.18),('9650','2013-06-24','15:50:00',7.1),('9650','2013-06-24','15:55:00',7),('9650','2013-06-24','16:00:00',6.99),('9650','2013-06-24','16:05:00',6.9),('9650','2013-06-24','16:10:00',6.81),('9650','2013-06-24','16:15:00',6.79),('9650','2013-06-24','16:20:00',6.7),('9650','2013-06-24','16:25:00',6.64),('9650','2013-06-24','16:30:00',6.64),('9650','2013-06-24','16:35:00',6.52),('9650','2013-06-24','16:40:00',6.44),('9650','2013-06-24','16:45:00',6.35),('9650','2013-06-24','16:50:00',6.32),('9650','2013-06-24','16:55:00',6.24),('9650','2013-06-24','17:00:00',6.15),('9650','2013-06-24','17:05:00',6.08),('9650','2013-06-24','17:10:00',5.96),('9650','2013-06-24','17:15:00',5.88),('9650','2013-06-24','17:20:00',5.79),('9650','2013-06-24','17:25:00',5.66),('9650','2013-06-24','17:30:00',5.55),('9650','2013-06-24','17:35:00',5.45),('9650','2013-06-24','17:40:00',5.33),('9650','2013-06-24','17:45:00',5.18),('9650','2013-06-24','17:50:00',5.07),('9650','2013-06-24','17:55:00',4.98),('9650','2013-06-24','18:00:00',4.88),('9650','2013-06-24','18:05:00',4.71),('9650','2013-06-24','18:10:00',4.55),('9650','2013-06-24','18:15:00',4.45),('9650','2013-06-24','18:20:00',4.32),('9650','2013-06-24','18:25:00',4.16),('9650','2013-06-24','18:30:00',4.06),('9650','2013-06-24','18:35:00',3.94),('9650','2013-06-24','18:40:00',3.8),('9650','2013-06-24','18:45:00',3.63),('9650','2013-06-24','18:50:00',3.43),('9650','2013-06-24','18:55:00',3.28),('9650','2013-06-24','19:00:00',3.18),('9650','2013-06-24','19:05:00',3),('9650','2013-06-24','19:10:00',2.87),('9650','2013-06-24','19:15:00',2.69),('9650','2013-06-24','19:20:00',2.5),('9650','2013-06-24','19:25:00',2.34),('9650','2013-06-24','19:30:00',2.12),('9650','2013-06-24','19:35:00',1.92),('9650','2013-06-24','19:40:00',1.72),('9650','2013-06-24','19:45:00',1.53),('9650','2013-06-24','19:50:00',1.32),('9650','2013-06-24','19:55:00',1.1),('9650','2013-06-23','07:25:00',1.17),('9650','2013-06-23','07:50:00',1.17),('9650','2013-06-23','08:40:00',1.57),('9650','2013-06-23','08:45:00',2.5),('9650','2013-06-23','08:50:00',2.57),('9650','2013-06-23','08:55:00',2.81),('9650','2013-06-23','09:00:00',2.36),('9650','2013-06-23','09:05:00',2.81),('9650','2013-06-23','09:10:00',2.29),('9650','2013-06-23','09:15:00',2.9),('9650','2013-06-23','09:20:00',3.53),('9650','2013-06-23','09:25:00',3.97),('9650','2013-06-23','09:30:00',3.94),('9650','2013-06-23','09:35:00',2.59),('9650','2013-06-23','09:40:00',3.65),('9650','2013-06-23','09:45:00',4.55),('9650','2013-06-23','09:50:00',4.47),('9650','2013-06-23','09:55:00',4.31),('9650','2013-06-23','10:00:00',4.4),('9650','2013-06-23','10:05:00',4.56),('9650','2013-06-23','10:10:00',5),('9650','2013-06-23','10:15:00',4.18),('9650','2013-06-23','10:20:00',5.28),('9650','2013-06-23','10:25:00',5.86),('9650','2013-06-23','10:30:00',4.92),('9650','2013-06-23','10:35:00',6.18),('9650','2013-06-23','10:40:00',2.23),('9650','2013-06-23','10:45:00',2.52),('9650','2013-06-23','10:50:00',6.55),('9650','2013-06-23','10:55:00',4.62),('9650','2013-06-23','11:00:00',6.06),('9650','2013-06-23','11:05:00',6.27),('9650','2013-06-23','11:10:00',2.61),('9650','2013-06-23','11:15:00',5.39),('9650','2013-06-23','11:20:00',6.06),('9650','2013-06-23','11:25:00',2.66),('9650','2013-06-23','11:30:00',3.84),('9650','2013-06-23','11:35:00',2.5),('9650','2013-06-23','11:40:00',2.39),('9650','2013-06-23','11:45:00',4.37),('9650','2013-06-23','11:50:00',3.89),('9650','2013-06-23','11:55:00',6.59),('9650','2013-06-23','12:00:00',5.02),('9650','2013-06-23','12:05:00',5.7),('9650','2013-06-23','12:10:00',6.77),('9650','2013-06-23','12:15:00',4.38),('9650','2013-06-23','12:20:00',8.09),('9650','2013-06-23','12:25:00',6.74),('9650','2013-06-23','12:30:00',5.56),('9650','2013-06-23','12:35:00',7.5),('9650','2013-06-23','12:40:00',6.67),('9650','2013-06-23','12:45:00',5.49),('9650','2013-06-23','12:50:00',7.73),('9650','2013-06-23','12:55:00',7.86),('9650','2013-06-23','13:00:00',5.95),('9650','2013-06-23','13:05:00',8.21),('9650','2013-06-23','13:10:00',6.28),('9650','2013-06-23','13:15:00',5.99),('9650','2013-06-23','13:20:00',3.2),('9650','2013-06-23','13:25:00',6.69),('9650','2013-06-23','13:30:00',8.08),('9650','2013-06-23','13:35:00',5.51),('9650','2013-06-23','13:40:00',7.62),('9650','2013-06-23','13:45:00',8.01),('9650','2013-06-23','13:50:00',7.89),('9650','2013-06-23','13:55:00',7.84),('9650','2013-06-23','14:00:00',7.54),('9650','2013-06-23','14:05:00',7.87),('9650','2013-06-23','14:10:00',7.87),('9650','2013-06-23','14:15:00',7.9),('9650','2013-06-23','14:20:00',7.89),('9650','2013-06-23','14:25:00',7.95),('9650','2013-06-23','14:30:00',7.96),('9650','2013-06-23','14:35:00',8),('9650','2013-06-23','14:40:00',8.02),('9650','2013-06-23','14:45:00',8.22),('9650','2013-06-23','14:50:00',7.35),('9650','2013-06-23','14:55:00',5.77),('9650','2013-06-23','15:00:00',7.41),('9650','2013-06-23','15:05:00',4.29),('9650','2013-06-23','15:10:00',7.39),('9650','2013-06-23','15:15:00',7.98),('9650','2013-06-23','15:20:00',7.22),('9650','2013-06-23','15:25:00',4.79),('9650','2013-06-23','15:30:00',6.48),('9650','2013-06-23','15:35:00',4.29),('9650','2013-06-23','15:40:00',5.5),('9650','2013-06-23','15:45:00',6.14),('9650','2013-06-23','15:50:00',6.17),('9650','2013-06-23','15:55:00',7.29),('9650','2013-06-23','16:00:00',8.41),('9650','2013-06-23','16:05:00',7.56),('9650','2013-06-23','16:10:00',5.91),('9650','2013-06-23','16:15:00',8.04),('9650','2013-06-23','16:20:00',4.4),('9650','2013-06-23','16:25:00',5.62),('9650','2013-06-23','16:30:00',6.86),('9650','2013-06-23','16:35:00',6.53),('9650','2013-06-23','16:40:00',4.34),('9650','2013-06-23','16:45:00',4.65),('9650','2013-06-23','16:50:00',3.96),('9650','2013-06-23','16:55:00',2.56),('9650','2013-06-23','17:00:00',2.97),('9650','2013-06-23','17:05:00',5.55),('9650','2013-06-23','17:10:00',5.69),('9650','2013-06-23','17:15:00',6.77),('9650','2013-06-23','17:20:00',4.13),('9650','2013-06-23','17:25:00',5.74),('9650','2013-06-23','17:30:00',3.77),('9650','2013-06-23','17:35:00',1.89),('9650','2013-06-23','17:40:00',1.65),('9650','2013-06-23','17:45:00',1.87),('9650','2013-06-23','17:50:00',3.62),('9650','2013-06-23','17:55:00',2.84),('9650','2013-06-23','18:00:00',5.67),('9650','2013-06-23','18:05:00',4.79),('9650','2013-06-23','18:10:00',4.05),('9650','2013-06-23','18:15:00',4.83),('9650','2013-06-23','18:20:00',4.63),('9650','2013-06-23','18:25:00',4.37),('9650','2013-06-23','18:30:00',2.88),('9650','2013-06-23','18:35:00',4.22),('9650','2013-06-23','18:40:00',2.52),('9650','2013-06-23','18:45:00',3.95),('9650','2013-06-23','18:50:00',3.6),('9650','2013-06-23','18:55:00',3.42),('9650','2013-06-23','19:00:00',3.43),('9650','2013-06-23','19:05:00',3.22),('9650','2013-06-23','19:10:00',3.1),('9650','2013-06-23','19:15:00',2.78),('9650','2013-06-23','19:20:00',2.55),('9650','2013-06-23','19:25:00',2.44),('9650','2013-06-23','19:30:00',2.27),('9650','2013-06-23','19:35:00',2.08),('9650','2013-06-23','19:40:00',1.93),('9650','2013-06-23','19:45:00',1.67),('9650','2013-06-23','19:50:00',1.43),('9650','2013-06-23','19:55:00',1.16),('9650','2013-06-22','08:35:00',1.2),('9650','2013-06-22','08:40:00',1.32),('9650','2013-06-22','08:45:00',1.56),('9650','2013-06-22','08:50:00',1.95),('9650','2013-06-22','08:55:00',1.64),('9650','2013-06-22','09:00:00',2.55),('9650','2013-06-22','09:05:00',1.85),('9650','2013-06-22','09:20:00',1.96),('9650','2013-06-22','09:25:00',3.14),('9650','2013-06-22','09:30:00',3.41),('9650','2013-06-22','09:35:00',3.73),('9650','2013-06-22','09:40:00',4.57),('9650','2013-06-22','09:45:00',3.19),('9650','2013-06-22','09:50:00',1.68),('9650','2013-06-22','09:55:00',1.27),('9650','2013-06-22','10:00:00',3.13),('9650','2013-06-22','10:05:00',3.62),('9650','2013-06-22','10:10:00',1.6),('9650','2013-06-22','10:15:00',2.17),('9650','2013-06-22','10:20:00',2.02),('9650','2013-06-22','10:25:00',2.44),('9650','2013-06-22','10:30:00',4.61),('9650','2013-06-22','10:35:00',1.58),('9650','2013-06-22','10:40:00',4.25),('9650','2013-06-22','10:45:00',4.98),('9650','2013-06-22','10:50:00',4.88),('9650','2013-06-22','10:55:00',5.12),('9650','2013-06-22','11:00:00',5.38),('9650','2013-06-22','11:05:00',5.53),('9650','2013-06-22','11:10:00',5.68),('9650','2013-06-22','11:15:00',5.6),('9650','2013-06-22','11:20:00',5.62),('9650','2013-06-22','11:25:00',5.86),('9650','2013-06-22','11:30:00',5.77),('9650','2013-06-22','11:35:00',5.66),('9650','2013-06-22','11:40:00',5.96),('9650','2013-06-22','11:45:00',6.06),('9650','2013-06-22','11:50:00',6.06),('9650','2013-06-22','11:55:00',6.13),('9650','2013-06-22','12:00:00',6.18),('9650','2013-06-22','12:05:00',6.49),('9650','2013-06-22','12:10:00',6.46),('9650','2013-06-22','12:15:00',6.52),('9650','2013-06-22','12:20:00',6.6),('9650','2013-06-22','12:25:00',6.76),('9650','2013-06-22','12:30:00',6.77),('9650','2013-06-22','12:35:00',6.8),('9650','2013-06-22','12:40:00',6.88),('9650','2013-06-22','12:45:00',6.93),('9650','2013-06-22','12:50:00',6.97),('9650','2013-06-22','12:55:00',7),('9650','2013-06-22','13:00:00',7.07),('9650','2013-06-22','13:05:00',7.13),('9650','2013-06-22','13:10:00',7.16),('9650','2013-06-22','13:15:00',7.21),('9650','2013-06-22','13:20:00',7.24),('9650','2013-06-22','13:25:00',7.3),('9650','2013-06-22','13:30:00',7.33),('9650','2013-06-22','13:35:00',7.41),('9650','2013-06-22','13:40:00',7.39),('9650','2013-06-22','13:45:00',7.44),('9650','2013-06-22','13:50:00',7.48),('9650','2013-06-22','13:55:00',7.49),('9650','2013-06-22','14:00:00',7.5),('9650','2013-06-22','14:05:00',7.5),('9650','2013-06-22','14:10:00',7.49),('9650','2013-06-22','14:15:00',7.47),('9650','2013-06-22','14:20:00',7.49),('9650','2013-06-22','14:25:00',7.57),('9650','2013-06-22','14:30:00',7.55),('9650','2013-06-22','14:35:00',7.57),('9650','2013-06-22','14:40:00',7.56),('9650','2013-06-22','14:45:00',7.61),('9650','2013-06-22','14:50:00',7.58),('9650','2013-06-22','14:55:00',7.6),('9650','2013-06-22','15:00:00',7.59),('9650','2013-06-22','15:05:00',7.55),('9650','2013-06-22','15:10:00',7.52),('9650','2013-06-22','15:15:00',7.5),('9650','2013-06-22','15:20:00',7.49),('9650','2013-06-22','15:25:00',7.42),('9650','2013-06-22','15:30:00',7.39),('9650','2013-06-22','15:35:00',7.34),('9650','2013-06-22','15:40:00',7.29),('9650','2013-06-22','15:45:00',7.27),('9650','2013-06-22','15:50:00',7.21),('9650','2013-06-22','15:55:00',7.16),('9650','2013-06-22','16:00:00',7.12),('9650','2013-06-22','16:05:00',7.04),('9650','2013-06-22','16:10:00',7),('9650','2013-06-22','16:15:00',6.88),('9650','2013-06-22','16:20:00',6.76),('9650','2013-06-22','16:25:00',6.76),('9650','2013-06-22','16:30:00',6.7),('9650','2013-06-22','16:35:00',6.64),('9650','2013-06-22','16:40:00',6.61),('9650','2013-06-22','16:45:00',6.54),('9650','2013-06-22','16:50:00',6.46),('9650','2013-06-22','16:55:00',6.36),('9650','2013-06-22','17:00:00',6.31),('9650','2013-06-22','17:05:00',6.19),('9650','2013-06-22','17:10:00',6.14),('9650','2013-06-22','17:15:00',6.06),('9650','2013-06-22','17:20:00',5.73),('9650','2013-06-22','17:25:00',5.42),('9650','2013-06-22','17:30:00',5.75),('9650','2013-06-22','17:35:00',5.57),('9650','2013-06-22','17:40:00',5.55),('9650','2013-06-22','17:45:00',5.48),('9650','2013-06-22','17:50:00',5.41),('9650','2013-06-22','17:55:00',5.25),('9650','2013-06-22','18:00:00',5.16),('9650','2013-06-22','18:05:00',5.01),('9650','2013-06-22','18:10:00',4.91),('9650','2013-06-22','18:15:00',4.67),('9650','2013-06-22','18:20:00',4.63),('9650','2013-06-22','18:25:00',4.39),('9650','2013-06-22','18:30:00',4.34),('9650','2013-06-22','18:35:00',4.17),('9650','2013-06-22','18:40:00',4.07),('9650','2013-06-22','18:45:00',3.96),('9650','2013-06-22','18:50:00',3.83),('9650','2013-06-22','18:55:00',3.56),('9650','2013-06-22','19:00:00',3.38),('9650','2013-06-22','19:05:00',3.26),('9650','2013-06-22','19:10:00',3.18),('9650','2013-06-22','19:15:00',2.71),('9650','2013-06-22','19:20:00',2.26),('9650','2013-06-22','19:25:00',2.56),('9650','2013-06-22','19:30:00',2.03),('9650','2013-06-22','19:35:00',2.26),('9650','2013-06-22','19:40:00',2.11),('9650','2013-06-22','19:45:00',1.78),('9650','2013-06-22','19:50:00',1.01),('9650','2013-06-21','07:50:00',1.02),('9650','2013-06-21','07:55:00',1.11),('9650','2013-06-21','08:00:00',1.19),('9650','2013-06-21','08:05:00',1.27),('9650','2013-06-21','08:10:00',1.34),('9650','2013-06-21','08:15:00',1.43),('9650','2013-06-21','08:20:00',1.58),('9650','2013-06-21','08:25:00',1.73),('9650','2013-06-21','08:30:00',1.85),('9650','2013-06-21','08:35:00',1.98),('9650','2013-06-21','08:40:00',2.1),('9650','2013-06-21','08:45:00',2.21),('9650','2013-06-21','08:50:00',2.32),('9650','2013-06-21','08:55:00',2.42),('9650','2013-06-21','09:00:00',2.52),('9650','2013-06-21','09:05:00',2.63),('9650','2013-06-21','09:10:00',2.75),('9650','2013-06-21','09:15:00',2.85),('9650','2013-06-21','09:20:00',2.95),('9650','2013-06-21','09:25:00',3.04),('9650','2013-06-21','09:30:00',3.21),('9650','2013-06-21','09:35:00',3.38),('9650','2013-06-21','09:40:00',3.54),('9650','2013-06-21','09:45:00',3.62),('9650','2013-06-21','09:50:00',3.72),('9650','2013-06-21','09:55:00',3.85),('9650','2013-06-21','10:00:00',3.94),('9650','2013-06-21','10:05:00',4.07),('9650','2013-06-21','10:10:00',4.23),('9650','2013-06-21','10:15:00',4.29),('9650','2013-06-21','10:20:00',4.44),('9650','2013-06-21','10:25:00',4.56),('9650','2013-06-21','10:30:00',4.61),('9650','2013-06-21','10:35:00',4.69),('9650','2013-06-21','10:40:00',4.83),('9650','2013-06-21','10:45:00',4.98),('9650','2013-06-21','10:50:00',5.13),('9650','2013-06-21','10:55:00',5.2),('9650','2013-06-21','11:00:00',5.3),('9650','2013-06-21','11:05:00',5.4),('9650','2013-06-21','11:10:00',5.47),('9650','2013-06-21','11:15:00',5.57),('9650','2013-06-21','11:20:00',5.66),('9650','2013-06-21','11:25:00',5.71),('9650','2013-06-21','11:30:00',5.81),('9650','2013-06-21','11:35:00',5.89),('9650','2013-06-21','11:40:00',5.97),('9650','2013-06-21','11:45:00',6.04),('9650','2013-06-21','11:50:00',6.08),('9650','2013-06-21','11:55:00',6.11),('9650','2013-06-21','12:00:00',6.17),('9650','2013-06-21','12:05:00',6.12),('9650','2013-06-21','12:10:00',6.09),('9650','2013-06-21','12:15:00',6.42),('9650','2013-06-21','12:20:00',6.33),('9650','2013-06-21','12:25:00',6.45),('9650','2013-06-21','12:30:00',6.58),('9650','2013-06-21','12:35:00',6.62),('9650','2013-06-21','12:40:00',6.75),('9650','2013-06-21','12:45:00',6.64),('9650','2013-06-21','12:50:00',6.58),('9650','2013-06-21','12:55:00',6.61),('9650','2013-06-21','13:00:00',6.55),('9650','2013-06-21','13:05:00',6.64),('9650','2013-06-21','13:10:00',6.56),('9650','2013-06-21','13:15:00',6.47),('9650','2013-06-21','13:20:00',6.35),('9650','2013-06-21','13:25:00',6.93),('9650','2013-06-21','13:30:00',7.37),('9650','2013-06-21','13:35:00',7.46),('9650','2013-06-21','13:40:00',6.75),('9650','2013-06-21','13:45:00',7.17),('9650','2013-06-21','13:50:00',7.43),('9650','2013-06-21','13:55:00',5.53),('9650','2013-06-21','14:00:00',4.44),('9650','2013-06-21','14:05:00',8.11),('9650','2013-06-21','14:10:00',7.78),('9650','2013-06-21','14:15:00',7.86),('9650','2013-06-21','14:20:00',6.5),('9650','2013-06-21','14:25:00',7.77),('9650','2013-06-21','14:30:00',5.52),('9650','2013-06-21','14:35:00',4.25),('9650','2013-06-21','14:40:00',3.28),('9650','2013-06-21','14:45:00',4.04),('9650','2013-06-21','14:50:00',6.79),('9650','2013-06-21','14:55:00',7.66),('9650','2013-06-21','15:00:00',7.39),('9650','2013-06-21','15:05:00',5.88),('9650','2013-06-21','15:10:00',7.35),('9650','2013-06-21','15:15:00',7.78),('9650','2013-06-21','15:20:00',7.07),('9650','2013-06-21','15:25:00',6.38),('9650','2013-06-21','15:30:00',4.38),('9650','2013-06-21','15:35:00',3.62),('9650','2013-06-21','15:40:00',4.04),('9650','2013-06-21','15:45:00',5.31),('9650','2013-06-21','15:50:00',4.82),('9650','2013-06-21','15:55:00',4.68),('9650','2013-06-21','16:00:00',3.51),('9650','2013-06-21','16:05:00',2.29),('9650','2013-06-21','16:10:00',2.36),('9650','2013-06-21','16:15:00',3.07),('9650','2013-06-21','16:20:00',3.56),('9650','2013-06-21','16:25:00',2.4),('9650','2013-06-21','16:30:00',1.95),('9650','2013-06-21','16:35:00',1.7),('9650','2013-06-21','16:40:00',1.56),('9650','2013-06-21','16:45:00',1.51),('9650','2013-06-21','16:50:00',1.7),('9650','2013-06-21','16:55:00',2.44),('9650','2013-06-21','17:00:00',3.13),('9650','2013-06-21','17:05:00',2.92),('9650','2013-06-21','17:10:00',4.25),('9650','2013-06-21','17:15:00',6.41),('9650','2013-06-21','17:20:00',6.1),('9650','2013-06-21','17:25:00',6.2),('9650','2013-06-21','17:30:00',4.93),('9650','2013-06-21','17:35:00',4.32),('9650','2013-06-21','17:40:00',5.11),('9650','2013-06-21','17:45:00',5.18),('9650','2013-06-21','17:50:00',4.78),('9650','2013-06-21','17:55:00',4.84),('9650','2013-06-21','18:00:00',4.57),('9650','2013-06-21','18:05:00',3.8),('9650','2013-06-21','18:10:00',2.53),('9650','2013-06-21','18:15:00',2.73),('9650','2013-06-21','18:20:00',2.76),('9650','2013-06-21','18:25:00',1.4),('9650','2013-06-21','18:30:00',1.06),('9650','2013-06-21','18:35:00',1.42),('9650','2013-06-21','18:40:00',1.45),('9650','2013-06-21','18:45:00',1.06),('9650','2013-06-21','18:55:00',1.31),('9650','2013-06-21','19:00:00',1.95),('9650','2013-06-21','19:05:00',1.19),('9650','2013-06-21','19:10:00',1.52),('9650','2013-06-21','19:15:00',2.52),('9650','2013-06-21','19:20:00',2.42),('9650','2013-06-21','19:25:00',2.27),('9650','2013-06-21','19:30:00',1.17),('9650','2013-06-21','19:35:00',1.16),('9650','2013-06-21','19:40:00',1.24),('9650','2013-06-20','07:50:00',1.02),('9650','2013-06-20','07:55:00',1.08),('9650','2013-06-20','08:00:00',1.13),('9650','2013-06-20','08:05:00',1.16),('9650','2013-06-20','08:10:00',1.19),('9650','2013-06-20','08:15:00',1.22),('9650','2013-06-20','08:20:00',1.28),('9650','2013-06-20','08:25:00',1.72),('9650','2013-06-20','08:30:00',1.83),('9650','2013-06-20','08:35:00',1.94),('9650','2013-06-20','08:40:00',2.05),('9650','2013-06-20','08:45:00',2.17),('9650','2013-06-20','08:50:00',2.27),('9650','2013-06-20','08:55:00',2.38),('9650','2013-06-20','09:00:00',2.46),('9650','2013-06-20','09:05:00',2.55),('9650','2013-06-20','09:10:00',2.66),('9650','2013-06-20','09:15:00',2.75),('9650','2013-06-20','09:20:00',2.85),('9650','2013-06-20','09:25:00',2.97),('9650','2013-06-20','09:30:00',3.08),('9650','2013-06-20','09:35:00',3.24),('9650','2013-06-20','09:40:00',3.37),('9650','2013-06-20','09:45:00',3.5),('9650','2013-06-20','09:50:00',3.62),('9650','2013-06-20','09:55:00',3.7),('9650','2013-06-20','10:00:00',3.72),('9650','2013-06-20','10:05:00',3.89),('9650','2013-06-20','10:10:00',4.05),('9650','2013-06-20','10:15:00',4.09),('9650','2013-06-20','10:20:00',4.14),('9650','2013-06-20','10:25:00',4.27),('9650','2013-06-20','10:30:00',4.34),('9650','2013-06-20','10:35:00',4.44),('9650','2013-06-20','10:40:00',4.51),('9650','2013-06-20','10:45:00',4.7),('9650','2013-06-20','10:50:00',4.75),('9650','2013-06-20','10:55:00',4.8),('9650','2013-06-20','11:00:00',4.93),('9650','2013-06-20','11:05:00',5.05),('9650','2013-06-20','11:10:00',5.13),('9650','2013-06-20','11:15:00',5.23),('9650','2013-06-20','11:20:00',5.33),('9650','2013-06-20','11:25:00',5.44),('9650','2013-06-20','11:30:00',5.42),('9650','2013-06-20','11:35:00',5.54),('9650','2013-06-20','11:40:00',5.57),('9650','2013-06-20','11:45:00',5.65),('9650','2013-06-20','11:50:00',5.76),('9650','2013-06-20','11:55:00',5.79),('9650','2013-06-20','12:00:00',5.86),('9650','2013-06-20','12:05:00',5.86),('9650','2013-06-20','12:10:00',5.94),('9650','2013-06-20','12:15:00',5.94),('9650','2013-06-20','12:20:00',5.98),('9650','2013-06-20','12:25:00',6.04),('9650','2013-06-20','12:30:00',6.11),('9650','2013-06-20','12:35:00',6.04),('9650','2013-06-20','12:40:00',6.17),('9650','2013-06-20','12:45:00',6.29),('9650','2013-06-20','12:50:00',6.32),('9650','2013-06-20','12:55:00',6.26),('9650','2013-06-20','13:00:00',6.3),('9650','2013-06-20','13:05:00',6.3),('9650','2013-06-20','13:10:00',6.29),('9650','2013-06-20','13:15:00',6.35),('9650','2013-06-20','13:20:00',6.54),('9650','2013-06-20','13:25:00',6.64),('9650','2013-06-20','13:30:00',6.74),('9650','2013-06-20','13:35:00',6.71),('9650','2013-06-20','13:40:00',6.69),('9650','2013-06-20','13:45:00',6.82),('9650','2013-06-20','13:50:00',6.78),('9650','2013-06-20','13:55:00',6.77),('9650','2013-06-20','14:00:00',6.89),('9650','2013-06-20','14:05:00',6.91),('9650','2013-06-20','14:10:00',6.93),('9650','2013-06-20','14:15:00',6.94),('9650','2013-06-20','14:20:00',6.98),('9650','2013-06-20','14:25:00',7.05),('9650','2013-06-20','14:30:00',7.09),('9650','2013-06-20','14:35:00',7.07),('9650','2013-06-20','14:40:00',7.07),('9650','2013-06-20','14:45:00',7.09),('9650','2013-06-20','14:50:00',7.08),('9650','2013-06-20','14:55:00',7.09),('9650','2013-06-20','15:00:00',7.06),('9650','2013-06-20','15:05:00',7.03),('9650','2013-06-20','15:10:00',7.02),('9650','2013-06-20','15:15:00',7.04),('9650','2013-06-20','15:20:00',7.02),('9650','2013-06-20','15:25:00',6.97),('9650','2013-06-20','15:30:00',6.98),('9650','2013-06-20','15:35:00',6.95),('9650','2013-06-20','15:40:00',6.91),('9650','2013-06-20','15:45:00',6.87),('9650','2013-06-20','15:50:00',6.81),('9650','2013-06-20','15:55:00',6.73),('9650','2013-06-20','16:00:00',6.67),('9650','2013-06-20','16:05:00',6.64),('9650','2013-06-20','16:10:00',6.6),('9650','2013-06-20','16:15:00',6.54),('9650','2013-06-20','16:20:00',6.5),('9650','2013-06-20','16:25:00',6.46),('9650','2013-06-20','16:30:00',6.38),('9650','2013-06-20','16:35:00',6.31),('9650','2013-06-20','16:40:00',6.22),('9650','2013-06-20','16:45:00',6.18),('9650','2013-06-20','16:50:00',6.16),('9650','2013-06-20','16:55:00',6.07),('9650','2013-06-20','17:00:00',6.01),('9650','2013-06-20','17:05:00',5.94),('9650','2013-06-20','17:10:00',5.78),('9650','2013-06-20','17:15:00',5.71),('9650','2013-06-20','17:20:00',5.6),('9650','2013-06-20','17:25:00',5.52),('9650','2013-06-20','17:30:00',5.41),('9650','2013-06-20','17:35:00',5.34),('9650','2013-06-20','17:40:00',5.25),('9650','2013-06-20','17:45:00',5.12),('9650','2013-06-20','17:50:00',5.02),('9650','2013-06-20','17:55:00',4.9),('9650','2013-06-20','18:00:00',4.81),('9650','2013-06-20','18:05:00',4.69),('9650','2013-06-20','18:10:00',4.55),('9650','2013-06-20','18:15:00',4.42),('9650','2013-06-20','18:20:00',4.27),('9650','2013-06-20','18:25:00',4.16),('9650','2013-06-20','18:30:00',4.01),('9650','2013-06-20','18:35:00',3.86),('9650','2013-06-20','18:40:00',3.68),('9650','2013-06-20','18:45:00',3.54),('9650','2013-06-20','18:50:00',3.39),('9650','2013-06-20','18:55:00',3.23),('9650','2013-06-20','19:00:00',3.08),('9650','2013-06-20','19:05:00',2.94),('9650','2013-06-20','19:10:00',2.73),('9650','2013-06-20','19:15:00',2.5),('9650','2013-06-20','19:20:00',2.33),('9650','2013-06-20','19:25:00',2.21),('9650','2013-06-20','19:30:00',2.01),('9650','2013-06-20','19:35:00',1.81),('9650','2013-06-20','19:40:00',1.59),('9650','2013-06-20','19:45:00',1.3),('9650','2013-06-20','19:50:00',1),('9650','2014-04-03','08:40:00',1.13),('9650','2014-04-03','08:45:00',1.18),('9650','2014-04-03','08:50:00',1.26),('9650','2014-04-03','08:55:00',1.28),('9650','2014-04-03','09:00:00',1.26),('9650','2014-04-03','09:05:00',1.78),('9650','2014-04-03','09:10:00',2.25),('9650','2014-04-03','09:15:00',2.13),('9650','2014-04-03','09:20:00',1.61),('9650','2014-04-03','09:25:00',1.32),('9650','2014-04-03','09:30:00',1.29),('9650','2014-04-03','09:35:00',1.31),('9650','2014-04-03','09:40:00',1.26),('9650','2014-04-03','09:45:00',1.21),('9650','2014-04-03','09:50:00',1.12),('9650','2014-04-03','11:20:00',1.14),('9650','2014-04-03','12:45:00',1),('9650','2014-04-03','12:50:00',1.08),('9650','2014-04-03','13:05:00',1.13),('9650','2014-04-03','13:10:00',2.01),('9650','2014-04-03','13:15:00',1.67),('9650','2014-04-03','13:20:00',3.14),('9650','2014-04-03','13:25:00',3.79),('9650','2014-04-03','13:30:00',3.54),('9650','2014-04-03','13:35:00',4.18),('9650','2014-04-03','13:40:00',7.09),('9650','2014-04-03','13:45:00',5.25),('9650','2014-04-03','13:50:00',7.15),('9650','2014-04-03','13:55:00',3.59),('9650','2014-04-03','14:00:00',4.68),('9650','2014-04-03','14:05:00',7.98),('9650','2014-04-03','14:10:00',6.75),('9650','2014-04-03','14:15:00',5.96),('9650','2014-04-03','14:20:00',5.13),('9650','2014-04-03','14:25:00',6.29),('9650','2014-04-03','14:30:00',2.26),('9650','2014-04-03','14:35:00',3.82),('9650','2014-04-03','14:40:00',2.44),('9650','2014-04-03','14:45:00',2.47),('9650','2014-04-03','14:50:00',5.68),('9650','2014-04-03','14:55:00',6.54),('9650','2014-04-03','15:00:00',6.98),('9650','2014-04-03','15:05:00',7.15),('9650','2014-04-03','15:10:00',5.82),('9650','2014-04-03','15:15:00',6.1),('9650','2014-04-03','15:20:00',3.91),('9650','2014-04-03','15:25:00',3.11),('9650','2014-04-03','15:30:00',2.5),('9650','2014-04-03','15:35:00',2.93),('9650','2014-04-03','15:40:00',4.29),('9650','2014-04-03','15:45:00',3.47),('9650','2014-04-03','15:50:00',3.01),('9650','2014-04-03','15:55:00',5.81),('9650','2014-04-03','16:00:00',4.88),('9650','2014-04-03','16:05:00',3.84),('9650','2014-04-03','16:10:00',6.22),('9650','2014-04-03','16:15:00',3.08),('9650','2014-04-03','16:20:00',2.14),('9650','2014-04-03','16:25:00',1.99),('9650','2014-04-03','16:30:00',3.99),('9650','2014-04-03','16:35:00',2.98),('9650','2014-04-03','16:40:00',2.65),('9650','2014-04-03','16:45:00',5.04),('9650','2014-04-03','16:50:00',5.36),('9650','2014-04-03','16:55:00',4.51),('9650','2014-04-03','17:00:00',3.88),('9650','2014-04-03','17:05:00',3.93),('9650','2014-04-03','17:10:00',4.18),('9650','2014-04-03','17:15:00',3.35),('9650','2014-04-03','17:20:00',4.35),('9650','2014-04-03','17:25:00',3.47),('9650','2014-04-03','17:30:00',4.4),('9650','2014-04-03','17:35:00',3.62),('9650','2014-04-03','17:40:00',3.9),('9650','2014-04-03','17:45:00',3.99),('9650','2014-04-03','17:50:00',3.85),('9650','2014-04-03','17:55:00',3.48),('9650','2014-04-03','18:00:00',3.29),('9650','2014-04-03','18:05:00',3.1),('9650','2014-04-03','18:10:00',2.95),('9650','2014-04-03','18:15:00',2.8),('9650','2014-04-03','18:20:00',2.52),('9650','2014-04-03','18:25:00',1.42),('9650','2014-04-03','18:30:00',2.33),('9650','2014-04-03','18:35:00',2.11),('9650','2014-04-03','18:40:00',1.58),('9650','2014-04-03','18:45:00',1.28),('9650','2014-04-03','18:50:00',1.37),('9650','2014-04-03','18:55:00',1.1),('9650','2013-06-19','07:55:00',1.01),('9650','2013-06-19','08:00:00',1.1),('9650','2013-06-19','08:05:00',1.19),('9650','2013-06-19','08:10:00',1.29),('9650','2013-06-19','08:15:00',1.39),('9650','2013-06-19','08:20:00',1.54),('9650','2013-06-19','08:25:00',1.7),('9650','2013-06-19','08:30:00',1.82),('9650','2013-06-19','08:35:00',1.93),('9650','2013-06-19','08:40:00',2.03),('9650','2013-06-19','08:45:00',2.14),('9650','2013-06-19','08:50:00',2.26),('9650','2013-06-19','08:55:00',2.36),('9650','2013-06-19','09:00:00',2.46),('9650','2013-06-19','09:05:00',2.58),('9650','2013-06-19','09:10:00',2.7),('9650','2013-06-19','09:15:00',2.81),('9650','2013-06-19','09:20:00',2.92),('9650','2013-06-19','09:25:00',3.04),('9650','2013-06-19','09:30:00',3.15),('9650','2013-06-19','09:35:00',3.32),('9650','2013-06-19','09:40:00',3.46),('9650','2013-06-19','09:45:00',3.58),('9650','2013-06-19','09:50:00',3.71),('9650','2013-06-19','09:55:00',3.81),('9650','2013-06-19','10:00:00',3.89),('9650','2013-06-19','10:05:00',3.97),('9650','2013-06-19','10:10:00',4.16),('9650','2013-06-19','10:15:00',4.19),('9650','2013-06-19','10:20:00',4.34),('9650','2013-06-19','10:25:00',4.45),('9650','2013-06-19','10:30:00',4.57),('9650','2013-06-19','10:35:00',4.68),('9650','2013-06-19','10:40:00',4.79),('9650','2013-06-19','10:45:00',4.84),('9650','2013-06-19','10:50:00',4.92),('9650','2013-06-19','10:55:00',5),('9650','2013-06-19','11:00:00',5.11),('9650','2013-06-19','11:05:00',5.21),('9650','2013-06-19','11:10:00',5.33),('9650','2013-06-19','11:15:00',5.34),('9650','2013-06-19','11:20:00',5.38),('9650','2013-06-19','11:25:00',5.37),('9650','2013-06-19','11:30:00',5.42),('9650','2013-06-19','11:35:00',5.6),('9650','2013-06-19','11:40:00',5.7),('9650','2013-06-19','11:45:00',5.71),('9650','2013-06-19','11:50:00',5.64),('9650','2013-06-19','11:55:00',5.72),('9650','2013-06-19','12:00:00',5.66),('9650','2013-06-19','12:05:00',5.81),('9650','2013-06-19','12:10:00',5.74),('9650','2013-06-19','12:15:00',5.75),('9650','2013-06-19','12:20:00',5.94),('9650','2013-06-19','12:25:00',5.61),('9650','2013-06-19','12:30:00',6.27),('9650','2013-06-19','12:35:00',6.4),('9650','2013-06-19','12:40:00',6.31),('9650','2013-06-19','12:45:00',6.33),('9650','2013-06-19','12:50:00',6.18),('9650','2013-06-19','12:55:00',5.82),('9650','2013-06-19','13:00:00',6.58),('9650','2013-06-19','13:05:00',6.68),('9650','2013-06-19','13:10:00',6.12),('9650','2013-06-19','13:15:00',4.63),('9650','2013-06-19','13:20:00',6.32),('9650','2013-06-19','13:25:00',6.48),('9650','2013-06-19','13:30:00',6.77),('9650','2013-06-19','13:35:00',6.87),('9650','2013-06-19','13:40:00',6.87),('9650','2013-06-19','13:45:00',6.93),('9650','2013-06-19','13:50:00',6.98),('9650','2013-06-19','13:55:00',6.9),('9650','2013-06-19','14:00:00',7.06),('9650','2013-06-19','14:05:00',7.14),('9650','2013-06-19','14:10:00',7.08),('9650','2013-06-19','14:15:00',7.18),('9650','2013-06-19','14:20:00',7.2),('9650','2013-06-19','14:25:00',7.22),('9650','2013-06-19','14:30:00',7.3),('9650','2013-06-19','14:35:00',7.33),('9650','2013-06-19','14:40:00',7.3),('9650','2013-06-19','14:45:00',7.36),('9650','2013-06-19','14:50:00',7.35),('9650','2013-06-19','14:55:00',7.3),('9650','2013-06-19','15:00:00',7.24),('9650','2013-06-19','15:05:00',7.24),('9650','2013-06-19','15:10:00',7.22),('9650','2013-06-19','15:15:00',7.21),('9650','2013-06-19','15:20:00',7.18),('9650','2013-06-19','15:25:00',7.15),('9650','2013-06-19','15:30:00',7.11),('9650','2013-06-19','15:35:00',7.07),('9650','2013-06-19','15:40:00',7.04),('9650','2013-06-19','15:45:00',6.96),('9650','2013-06-19','15:50:00',6.91),('9650','2013-06-19','15:55:00',6.81),('9650','2013-06-19','16:00:00',6.8),('9650','2013-06-19','16:05:00',6.77),('9650','2013-06-19','16:10:00',6.74),('9650','2013-06-19','16:15:00',6.69),('9650','2013-06-19','16:20:00',6.62),('9650','2013-06-19','16:25:00',6.57),('9650','2013-06-19','16:30:00',6.5),('9650','2013-06-19','16:35:00',6.41),('9650','2013-06-19','16:40:00',6.32),('9650','2013-06-19','16:45:00',6.26),('9650','2013-06-19','16:50:00',6.17),('9650','2013-06-19','16:55:00',6.09),('9650','2013-06-19','17:00:00',6),('9650','2013-06-19','17:05:00',5.95),('9650','2013-06-19','17:10:00',5.86),('9650','2013-06-19','17:15:00',5.73),('9650','2013-06-19','17:20:00',5.62),('9650','2013-06-19','17:25:00',5.5),('9650','2013-06-19','17:30:00',5.42),('9650','2013-06-19','17:35:00',5.36),('9650','2013-06-19','17:40:00',5.29),('9650','2013-06-19','17:45:00',5.17),('9650','2013-06-19','17:50:00',5.05),('9650','2013-06-19','17:55:00',4.98),('9650','2013-06-19','18:00:00',4.87),('9650','2013-06-19','18:05:00',4.73),('9650','2013-06-19','18:10:00',4.64),('9650','2013-06-19','18:15:00',4.54),('9650','2013-06-19','18:20:00',4.41),('9650','2013-06-19','18:25:00',4.28),('9650','2013-06-19','18:30:00',4.15),('9650','2013-06-19','18:35:00',4),('9650','2013-06-19','18:40:00',3.82),('9650','2013-06-19','18:45:00',3.63),('9650','2013-06-19','18:50:00',3.45),('9650','2013-06-19','18:55:00',3.29),('9650','2013-06-19','19:00:00',3.1),('9650','2013-06-19','19:05:00',2.93),('9650','2013-06-19','19:10:00',2.78),('9650','2013-06-19','19:15:00',2.63),('9650','2013-06-19','19:20:00',2.42),('9650','2013-06-19','19:25:00',2.2),('9650','2013-06-19','19:30:00',2.02),('9650','2013-06-19','19:35:00',1.86),('9650','2013-06-19','19:40:00',1.73),('9650','2013-06-19','19:45:00',1.57),('9650','2013-06-19','19:50:00',1.39),('9650','2013-06-19','19:55:00',1.21),('9650','2013-06-19','20:00:00',1.01),('9650','2013-06-18','07:55:00',1.05),('9650','2013-06-18','08:00:00',1.13),('9650','2013-06-18','08:05:00',1.21),('9650','2013-06-18','08:10:00',1.3),('9650','2013-06-18','08:15:00',1.39),('9650','2013-06-18','08:20:00',1.54),('9650','2013-06-18','08:25:00',1.68),('9650','2013-06-18','08:30:00',1.79),('9650','2013-06-18','08:35:00',1.9),('9650','2013-06-18','08:40:00',2.01),('9650','2013-06-18','08:45:00',2.11),('9650','2013-06-18','08:50:00',2.22),('9650','2013-06-18','08:55:00',2.33),('9650','2013-06-18','09:00:00',2.44),('9650','2013-06-18','09:05:00',2.55),('9650','2013-06-18','09:10:00',2.66),('9650','2013-06-18','09:15:00',2.78),('9650','2013-06-18','09:20:00',2.91),('9650','2013-06-18','09:25:00',3.01),('9650','2013-06-18','09:30:00',3.15),('9650','2013-06-18','09:35:00',3.31),('9650','2013-06-18','09:40:00',3.44),('9650','2013-06-18','09:45:00',3.54),('9650','2013-06-18','09:50:00',3.65),('9650','2013-06-18','09:55:00',3.75),('9650','2013-06-18','10:00:00',3.85),('9650','2013-06-18','10:05:00',3.93),('9650','2013-06-18','10:10:00',4.08),('9650','2013-06-18','10:15:00',4.13),('9650','2013-06-18','10:20:00',4.23),('9650','2013-06-18','10:25:00',4.37),('9650','2013-06-18','10:30:00',4.45),('9650','2013-06-18','10:35:00',4.5),('9650','2013-06-18','10:40:00',4.6),('9650','2013-06-18','10:45:00',4.73),('9650','2013-06-18','10:50:00',4.8),('9650','2013-06-18','10:55:00',4.88),('9650','2013-06-18','11:00:00',4.94),('9650','2013-06-18','11:05:00',5.05),('9650','2013-06-18','11:10:00',5.13),('9650','2013-06-18','11:15:00',5.16),('9650','2013-06-18','11:20:00',5.2),('9650','2013-06-18','11:25:00',5.32),('9650','2013-06-18','11:30:00',5.36),('9650','2013-06-18','11:35:00',5.49),('9650','2013-06-18','11:40:00',5.47),('9650','2013-06-18','11:45:00',5.56),('9650','2013-06-18','11:50:00',5.6),('9650','2013-06-18','11:55:00',5.67),('9650','2013-06-18','12:00:00',5.81),('9650','2013-06-18','12:05:00',5.94),('9650','2013-06-18','12:10:00',5.87),('9650','2013-06-18','12:15:00',5.96),('9650','2013-06-18','12:20:00',6),('9650','2013-06-18','12:25:00',5.97),('9650','2013-06-18','12:30:00',6.07),('9650','2013-06-18','12:35:00',6.24),('9650','2013-06-18','12:40:00',6.29),('9650','2013-06-18','12:45:00',6.28),('9650','2013-06-18','12:50:00',6.39),('9650','2013-06-18','12:55:00',6.42),('9650','2013-06-18','13:00:00',6.48),('9650','2013-06-18','13:05:00',6.56),('9650','2013-06-18','13:10:00',6.56),('9650','2013-06-18','13:15:00',6.51),('9650','2013-06-18','13:20:00',6.65),('9650','2013-06-18','13:25:00',6.75),('9650','2013-06-18','13:30:00',6.71),('9650','2013-06-18','13:35:00',6.77),('9650','2013-06-18','13:40:00',6.78),('9650','2013-06-18','13:45:00',6.8),('9650','2013-06-18','13:50:00',6.85),('9650','2013-06-18','13:55:00',6.91),('9650','2013-06-18','14:00:00',6.95),('9650','2013-06-18','14:05:00',7.01),('9650','2013-06-18','14:10:00',6.99),('9650','2013-06-18','14:15:00',6.92),('9650','2013-06-18','14:20:00',6.93),('9650','2013-06-18','14:25:00',6.96),('9650','2013-06-18','14:30:00',6.91),('9650','2013-06-18','14:35:00',6.93),('9650','2013-06-18','14:40:00',6.87),('9650','2013-06-18','14:45:00',6.86),('9650','2013-06-18','14:50:00',6.85),('9650','2013-06-18','14:55:00',6.87),('9650','2013-06-18','15:00:00',6.87),('9650','2013-06-18','15:05:00',6.84),('9650','2013-06-18','15:10:00',6.82),('9650','2013-06-18','15:15:00',6.79),('9650','2013-06-18','15:20:00',6.82),('9650','2013-06-18','15:25:00',6.84),('9650','2013-06-18','15:30:00',6.79),('9650','2013-06-18','15:35:00',6.75),('9650','2013-06-18','15:40:00',6.7),('9650','2013-06-18','15:45:00',6.65),('9650','2013-06-18','15:50:00',6.56),('9650','2013-06-18','15:55:00',6.45),('9650','2013-06-18','16:00:00',6.42),('9650','2013-06-18','16:05:00',6.37),('9650','2013-06-18','16:10:00',6.33),('9650','2013-06-18','16:15:00',6.27),('9650','2013-06-18','16:20:00',6.23),('9650','2013-06-18','16:25:00',6.19),('9650','2013-06-18','16:30:00',6.13),('9650','2013-06-18','16:35:00',6.07),('9650','2013-06-18','16:40:00',6),('9650','2013-06-18','16:45:00',5.96),('9650','2013-06-18','16:50:00',5.93),('9650','2013-06-18','16:55:00',5.87),('9650','2013-06-18','17:00:00',5.81),('9650','2013-06-18','17:05:00',5.69),('9650','2013-06-18','17:10:00',5.59),('9650','2013-06-18','17:15:00',5.23),('9650','2013-06-18','17:20:00',5.54),('9650','2013-06-18','17:25:00',5.48),('9650','2013-06-18','17:30:00',5.38),('9650','2013-06-18','17:35:00',5.27),('9650','2013-06-18','17:40:00',5.18),('9650','2013-06-18','17:45:00',5.08),('9650','2013-06-18','17:50:00',4.92),('9650','2013-06-18','17:55:00',4.84),('9650','2013-06-18','18:00:00',4.74),('9650','2013-06-18','18:05:00',4.57),('9650','2013-06-18','18:10:00',4.4),('9650','2013-06-18','18:15:00',4.23),('9650','2013-06-18','18:20:00',4.11),('9650','2013-06-18','18:25:00',4),('9650','2013-06-18','18:30:00',3.8),('9650','2013-06-18','18:35:00',3.56),('9650','2013-06-18','18:40:00',3.17),('9650','2013-06-18','18:45:00',3.11),('9650','2013-06-18','18:50:00',3.05),('9650','2013-06-18','18:55:00',3.01),('9650','2013-06-18','19:00:00',2.91),('9650','2013-06-18','19:05:00',2.79),('9650','2013-06-18','19:10:00',2.65),('9650','2013-06-18','19:15:00',2.48),('9650','2013-06-18','19:20:00',2.36),('9650','2013-06-18','19:25:00',2.15),('9650','2013-06-18','19:30:00',1.93),('9650','2013-06-18','19:35:00',1.79),('9650','2013-06-18','19:40:00',1.61),('9650','2013-06-18','19:45:00',1.42),('9650','2013-06-18','19:50:00',1.19),('9650','2013-06-18','19:55:00',1.02),('9650','2013-06-17','07:55:00',1.04),('9650','2013-06-17','08:00:00',1.09),('9650','2013-06-17','08:05:00',1.12),('9650','2013-06-17','08:20:00',1.2),('9650','2013-06-17','08:25:00',1.23),('9650','2013-06-17','08:30:00',1.24),('9650','2013-06-17','08:35:00',1.25),('9650','2013-06-17','08:40:00',1.79),('9650','2013-06-17','08:45:00',2.1),('9650','2013-06-17','08:50:00',2.22),('9650','2013-06-17','08:55:00',2.32),('9650','2013-06-17','09:00:00',2.41),('9650','2013-06-17','09:05:00',2.52),('9650','2013-06-17','09:10:00',2.61),('9650','2013-06-17','09:15:00',2.73),('9650','2013-06-17','09:20:00',2.83),('9650','2013-06-17','09:25:00',2.96),('9650','2013-06-17','09:30:00',3.1),('9650','2013-06-17','09:35:00',3.28),('9650','2013-06-17','09:40:00',3.41),('9650','2013-06-17','09:45:00',3.51),('9650','2013-06-17','09:50:00',1.39),('9650','2013-06-17','09:55:00',2.64),('9650','2013-06-17','10:00:00',3.78),('9650','2013-06-17','10:05:00',3.89),('9650','2013-06-17','10:10:00',3.97),('9650','2013-06-17','10:15:00',4.07),('9650','2013-06-17','10:20:00',4.25),('9650','2013-06-17','10:25:00',4.32),('9650','2013-06-17','10:30:00',4.37),('9650','2013-06-17','10:35:00',4.49),('9650','2013-06-17','10:40:00',4.61),('9650','2013-06-17','10:45:00',4.7),('9650','2013-06-17','10:50:00',4.79),('9650','2013-06-17','10:55:00',4.89),('9650','2013-06-17','11:00:00',5.02),('9650','2013-06-17','11:05:00',5.08),('9650','2013-06-17','11:10:00',5.12),('9650','2013-06-17','11:15:00',5.2),('9650','2013-06-17','11:20:00',5.32),('9650','2013-06-17','11:25:00',5.3),('9650','2013-06-17','11:30:00',5.39),('9650','2013-06-17','11:35:00',5.45),('9650','2013-06-17','11:40:00',5.47),('9650','2013-06-17','11:45:00',5.53),('9650','2013-06-17','11:50:00',5.42),('9650','2013-06-17','11:55:00',5.61),('9650','2013-06-17','12:00:00',5.64),('9650','2013-06-17','12:05:00',5.65),('9650','2013-06-17','12:10:00',5.69),('9650','2013-06-17','12:15:00',5.62),('9650','2013-06-17','12:20:00',5.62),('9650','2013-06-17','12:25:00',5.73),('9650','2013-06-17','12:30:00',5.83),('9650','2013-06-17','12:35:00',5.93),('9650','2013-06-17','12:40:00',5.55),('9650','2013-06-17','12:45:00',2.46),('9650','2013-06-17','12:50:00',1.76),('9650','2013-06-17','12:55:00',6.63),('9650','2013-06-17','13:00:00',6.58),('9650','2013-06-17','13:05:00',2.91),('9650','2013-06-17','13:10:00',6.11),('9650','2013-06-17','13:15:00',6.7),('9650','2013-06-17','13:20:00',6.66),('9650','2013-06-17','13:25:00',5.32),('9650','2013-06-17','13:30:00',3.36),('9650','2013-06-17','13:35:00',6.69),('9650','2013-06-17','13:40:00',5.8),('9650','2013-06-17','13:45:00',5.02),('9650','2013-06-17','13:50:00',6.2),('9650','2013-06-17','13:55:00',7.25),('9650','2013-06-17','14:00:00',6.96),('9650','2013-06-17','14:05:00',6.99),('9650','2013-06-17','14:10:00',6.98),('9650','2013-06-17','14:15:00',7.12),('9650','2013-06-17','14:20:00',7.09),('9650','2013-06-17','14:25:00',7.04),('9650','2013-06-17','14:30:00',6.98),('9650','2013-06-17','14:35:00',7.19),('9650','2013-06-17','14:40:00',7.27),('9650','2013-06-17','14:45:00',7.31),('9650','2013-06-17','14:50:00',7.19),('9650','2013-06-17','14:55:00',7.19),('9650','2013-06-17','15:00:00',7.18),('9650','2013-06-17','15:05:00',7.09),('9650','2013-06-17','15:10:00',7.03),('9650','2013-06-17','15:15:00',6.92),('9650','2013-06-17','15:20:00',6.87),('9650','2013-06-17','15:25:00',6.87),('9650','2013-06-17','15:30:00',6.78),('9650','2013-06-17','15:35:00',6.81),('9650','2013-06-17','15:40:00',6.88),('9650','2013-06-17','15:45:00',6.83),('9650','2013-06-17','15:50:00',6.76),('9650','2013-06-17','15:55:00',6.72),('9650','2013-06-17','16:00:00',6.77),('9650','2013-06-17','16:05:00',6.75),('9650','2013-06-17','16:10:00',6.72),('9650','2013-06-17','16:15:00',6.69),('9650','2013-06-17','16:20:00',6.7),('9650','2013-06-17','16:25:00',6.52),('9650','2013-06-17','16:30:00',6.41),('9650','2013-06-17','16:35:00',6.08),('9650','2013-06-17','16:40:00',6.25),('9650','2013-06-17','16:45:00',6.07),('9650','2013-06-17','16:50:00',5.99),('9650','2013-06-17','16:55:00',5.91),('9650','2013-06-17','17:00:00',5.87),('9650','2013-06-17','17:05:00',5.77),('9650','2013-06-17','17:10:00',5.65),('9650','2013-06-17','17:15:00',5.56),('9650','2013-06-17','17:20:00',5.51),('9650','2013-06-17','17:25:00',5.42),('9650','2013-06-17','17:30:00',5.32),('9650','2013-06-17','17:35:00',5.19),('9650','2013-06-17','17:40:00',5.1),('9650','2013-06-17','17:45:00',5),('9650','2013-06-17','17:50:00',4.9),('9650','2013-06-17','17:55:00',4.8),('9650','2013-06-17','18:00:00',4.64),('9650','2013-06-17','18:05:00',4.51),('9650','2013-06-17','18:10:00',4.41),('9650','2013-06-17','18:15:00',4.29),('9650','2013-06-17','18:20:00',4.21),('9650','2013-06-17','18:25:00',4.07),('9650','2013-06-17','18:30:00',3.91),('9650','2013-06-17','18:35:00',3.79),('9650','2013-06-17','18:40:00',3.6),('9650','2013-06-17','18:45:00',3.49),('9650','2013-06-17','18:50:00',3.32),('9650','2013-06-17','18:55:00',3.14),('9650','2013-06-17','19:00:00',2.99),('9650','2013-06-17','19:05:00',2.83),('9650','2013-06-17','19:10:00',2.73),('9650','2013-06-17','19:15:00',2.54),('9650','2013-06-17','19:20:00',2.38),('9650','2013-06-17','19:25:00',2.21),('9650','2013-06-17','19:30:00',2.03),('9650','2013-06-17','19:35:00',1.85),('9650','2013-06-17','19:40:00',1.67),('9650','2013-06-17','19:45:00',1.49),('9650','2013-06-17','19:50:00',1.32),('9650','2013-06-17','19:55:00',1.16),('9650','2013-06-16','07:55:00',1.03),('9650','2013-06-16','08:00:00',1.13),('9650','2013-06-16','08:05:00',1.22),('9650','2013-06-16','08:10:00',1.31),('9650','2013-06-16','08:15:00',1.41),('9650','2013-06-16','08:20:00',1.57),('9650','2013-06-16','08:25:00',1.73),('9650','2013-06-16','08:30:00',1.84),('9650','2013-06-16','08:35:00',1.96),('9650','2013-06-16','08:40:00',2.05),('9650','2013-06-16','08:45:00',2.18),('9650','2013-06-16','08:50:00',2.28),('9650','2013-06-16','08:55:00',2.39),('9650','2013-06-16','09:00:00',2.51),('9650','2013-06-16','09:05:00',2.63),('9650','2013-06-16','09:10:00',2.74),('9650','2013-06-16','09:15:00',2.89),('9650','2013-06-16','09:20:00',3),('9650','2013-06-16','09:25:00',3.12),('9650','2013-06-16','09:30:00',3.26),('9650','2013-06-16','09:35:00',3.43),('9650','2013-06-16','09:40:00',3.56),('9650','2013-06-16','09:45:00',3.68),('9650','2013-06-16','09:50:00',3.79),('9650','2013-06-16','09:55:00',3.88),('9650','2013-06-16','10:00:00',3.97),('9650','2013-06-16','10:05:00',4.07),('9650','2013-06-16','10:10:00',4.21),('9650','2013-06-16','10:15:00',4.22),('9650','2013-06-16','10:20:00',4.34),('9650','2013-06-16','10:25:00',4.48),('9650','2013-06-16','10:30:00',4.57),('9650','2013-06-16','10:35:00',4.65),('9650','2013-06-16','10:40:00',4.76),('9650','2013-06-16','10:45:00',4.87),('9650','2013-06-16','10:50:00',4.98),('9650','2013-06-16','10:55:00',5.08),('9650','2013-06-16','11:00:00',5.14),('9650','2013-06-16','11:05:00',5.24),('9650','2013-06-16','11:10:00',5.29),('9650','2013-06-16','11:15:00',5.4),('9650','2013-06-16','11:20:00',5.46),('9650','2013-06-16','11:25:00',5.53),('9650','2013-06-16','11:30:00',5.57),('9650','2013-06-16','11:35:00',5.65),('9650','2013-06-16','11:40:00',5.73),('9650','2013-06-16','11:45:00',5.72),('9650','2013-06-16','11:50:00',5.76),('9650','2013-06-16','11:55:00',5.81),('9650','2013-06-16','12:00:00',5.85),('9650','2013-06-16','12:05:00',5.9),('9650','2013-06-16','12:10:00',5.97),('9650','2013-06-16','12:15:00',6.06),('9650','2013-06-16','12:20:00',6.12),('9650','2013-06-16','12:25:00',6.18),('9650','2013-06-16','12:30:00',6.12),('9650','2013-06-16','12:35:00',6.25),('9650','2013-06-16','12:40:00',6.28),('9650','2013-06-16','12:45:00',6.38),('9650','2013-06-16','12:50:00',6.44),('9650','2013-06-16','12:55:00',6.59),('9650','2013-06-16','13:00:00',6.73),('9650','2013-06-16','13:05:00',6.69),('9650','2013-06-16','13:10:00',6.66),('9650','2013-06-16','13:15:00',6.7),('9650','2013-06-16','13:20:00',6.75),('9650','2013-06-16','13:25:00',6.83),('9650','2013-06-16','13:30:00',6.82),('9650','2013-06-16','13:35:00',6.87),('9650','2013-06-16','13:40:00',6.87),('9650','2013-06-16','13:45:00',6.9),('9650','2013-06-16','13:50:00',6.93),('9650','2013-06-16','13:55:00',6.94),('9650','2013-06-16','14:00:00',6.93),('9650','2013-06-16','14:05:00',6.96),('9650','2013-06-16','14:10:00',6.99),('9650','2013-06-16','14:15:00',6.99),('9650','2013-06-16','14:20:00',7.03),('9650','2013-06-16','14:25:00',7.03),('9650','2013-06-16','14:30:00',6.99),('9650','2013-06-16','14:35:00',6.99),('9650','2013-06-16','14:40:00',7.01),('9650','2013-06-16','14:45:00',7.01),('9650','2013-06-16','14:50:00',7),('9650','2013-06-16','14:55:00',6.98),('9650','2013-06-16','15:00:00',6.97),('9650','2013-06-16','15:05:00',6.95),('9650','2013-06-16','15:10:00',6.93),('9650','2013-06-16','15:15:00',6.93),('9650','2013-06-16','15:20:00',6.94),('9650','2013-06-16','15:25:00',6.89),('9650','2013-06-16','15:30:00',6.83),('9650','2013-06-16','15:35:00',6.82),('9650','2013-06-16','15:40:00',6.79),('9650','2013-06-16','15:45:00',6.71),('9650','2013-06-16','15:50:00',6.62),('9650','2013-06-16','15:55:00',6.56),('9650','2013-06-16','16:00:00',6.56),('9650','2013-06-16','16:05:00',6.53),('9650','2013-06-16','16:10:00',6.48),('9650','2013-06-16','16:15:00',6.45),('9650','2013-06-16','16:20:00',6.41),('9650','2013-06-16','16:25:00',6.33),('9650','2013-06-16','16:30:00',6.25),('9650','2013-06-16','16:35:00',6.17),('9650','2013-06-16','16:40:00',6.13),('9650','2013-06-16','16:45:00',6.03),('9650','2013-06-16','16:50:00',6.01),('9650','2013-06-16','16:55:00',5.92),('9650','2013-06-16','17:00:00',5.86),('9650','2013-06-16','17:05:00',5.78),('9650','2013-06-16','17:10:00',5.68),('9650','2013-06-16','17:15:00',5.59),('9650','2013-06-16','17:20:00',5.53),('9650','2013-06-16','17:25:00',5.45),('9650','2013-06-16','17:30:00',5.39),('9650','2013-06-16','17:35:00',5.29),('9650','2013-06-16','17:40:00',5.19),('9650','2013-06-16','17:45:00',5.06),('9650','2013-06-16','17:50:00',4.96),('9650','2013-06-16','17:55:00',4.87),('9650','2013-06-16','18:00:00',4.74),('9650','2013-06-16','18:05:00',4.62),('9650','2013-06-16','18:10:00',4.51),('9650','2013-06-16','18:15:00',4.33),('9650','2013-06-16','18:20:00',4.24),('9650','2013-06-16','18:25:00',3.88),('9650','2013-06-16','18:30:00',3.95),('9650','2013-06-16','18:35:00',3.47),('9650','2013-06-16','18:40:00',3.57),('9650','2013-06-16','18:45:00',3.65),('9650','2013-06-16','18:50:00',3.54),('9650','2013-06-16','18:55:00',3.45),('9650','2013-06-16','19:00:00',3.3),('9650','2013-06-16','19:05:00',3.13),('9650','2013-06-16','19:10:00',2.94),('9650','2013-06-16','19:15:00',2.74),('9650','2013-06-16','19:20:00',2.52),('9650','2013-06-16','19:25:00',2.38),('9650','2013-06-16','19:30:00',2.2),('9650','2013-06-16','19:35:00',1.99),('9650','2013-06-16','19:40:00',1.84),('9650','2013-06-16','19:45:00',1.64),('9650','2013-06-16','19:50:00',1.43),('9650','2013-06-16','19:55:00',1.23),('9650','2013-06-16','20:00:00',1.06),('9650','2013-06-15','07:55:00',1.06),('9650','2013-06-15','08:00:00',1.14),('9650','2013-06-15','08:05:00',1.23),('9650','2013-06-15','08:10:00',1.32),('9650','2013-06-15','08:15:00',1.43),('9650','2013-06-15','08:20:00',1.57),('9650','2013-06-15','08:25:00',1.75),('9650','2013-06-15','08:30:00',1.87),('9650','2013-06-15','08:35:00',1.97),('9650','2013-06-15','08:40:00',2.1),('9650','2013-06-15','08:45:00',2.23),('9650','2013-06-15','08:50:00',2.34),('9650','2013-06-15','08:55:00',2.43),('9650','2013-06-15','09:00:00',2.54),('9650','2013-06-15','09:05:00',2.69),('9650','2013-06-15','09:10:00',2.8),('9650','2013-06-15','09:15:00',2.93),('9650','2013-06-15','09:20:00',3.06),('9650','2013-06-15','09:25:00',3.19),('9650','2013-06-15','09:30:00',3.31),('9650','2013-06-15','09:35:00',3.48),('9650','2013-06-15','09:40:00',3.62),('9650','2013-06-15','09:45:00',3.73),('9650','2013-06-15','09:50:00',3.81),('9650','2013-06-15','09:55:00',3.89),('9650','2013-06-15','10:00:00',3.97),('9650','2013-06-15','10:05:00',4.12),('9650','2013-06-15','10:10:00',4.27),('9650','2013-06-15','10:15:00',4.3),('9650','2013-06-15','10:20:00',4.43),('9650','2013-06-15','10:25:00',4.56),('9650','2013-06-15','10:30:00',4.62),('9650','2013-06-15','10:35:00',4.71),('9650','2013-06-15','10:40:00',4.85),('9650','2013-06-15','10:45:00',4.99),('9650','2013-06-15','10:50:00',5.07),('9650','2013-06-15','10:55:00',5.18),('9650','2013-06-15','11:00:00',5.28),('9650','2013-06-15','11:05:00',5.34),('9650','2013-06-15','11:10:00',5.45),('9650','2013-06-15','11:15:00',5.56),('9650','2013-06-15','11:20:00',5.64),('9650','2013-06-15','11:25:00',5.74),('9650','2013-06-15','11:30:00',5.81),('9650','2013-06-15','11:35:00',5.88),('9650','2013-06-15','11:40:00',5.95),('9650','2013-06-15','11:45:00',6.01),('9650','2013-06-15','11:50:00',6.12),('9650','2013-06-15','11:55:00',6.19),('9650','2013-06-15','12:00:00',6.2),('9650','2013-06-15','12:05:00',6.29),('9650','2013-06-15','12:10:00',6.32),('9650','2013-06-15','12:15:00',6.4),('9650','2013-06-15','12:20:00',6.46),('9650','2013-06-15','12:25:00',6.49),('9650','2013-06-15','12:30:00',6.51),('9650','2013-06-15','12:35:00',6.58),('9650','2013-06-15','12:40:00',6.59),('9650','2013-06-15','12:45:00',6.66),('9650','2013-06-15','12:50:00',6.65),('9650','2013-06-15','12:55:00',6.73),('9650','2013-06-15','13:00:00',6.81),('9650','2013-06-15','13:05:00',6.93),('9650','2013-06-15','13:10:00',7.02),('9650','2013-06-15','13:15:00',7.03),('9650','2013-06-15','13:20:00',7.01),('9650','2013-06-15','13:25:00',7.08),('9650','2013-06-15','13:30:00',7.07),('9650','2013-06-15','13:35:00',7.19),('9650','2013-06-15','13:40:00',7.2),('9650','2013-06-15','13:45:00',7.06),('9650','2013-06-15','13:50:00',7.28),('9650','2013-06-15','13:55:00',7.19),('9650','2013-06-15','14:00:00',7.23),('9650','2013-06-15','14:05:00',7.21),('9650','2013-06-15','14:10:00',7.24),('9650','2013-06-15','14:15:00',7.28),('9650','2013-06-15','14:20:00',7.34),('9650','2013-06-15','14:25:00',7.3),('9650','2013-06-15','14:30:00',7.28),('9650','2013-06-15','14:35:00',7.3),('9650','2013-06-15','14:40:00',7.29),('9650','2013-06-15','14:45:00',7.22),('9650','2013-06-15','14:50:00',7.21),('9650','2013-06-15','14:55:00',7.2),('9650','2013-06-15','15:00:00',7.22),('9650','2013-06-15','15:05:00',7.25),('9650','2013-06-15','15:10:00',7.15),('9650','2013-06-15','15:15:00',7.15),('9650','2013-06-15','15:20:00',7.12),('9650','2013-06-15','15:25:00',7.11),('9650','2013-06-15','15:30:00',7.11),('9650','2013-06-15','15:35:00',7.09),('9650','2013-06-15','15:40:00',6.89),('9650','2013-06-15','15:45:00',6.98),('9650','2013-06-15','15:50:00',6.91),('9650','2013-06-15','15:55:00',6.82),('9650','2013-06-15','16:00:00',6.76),('9650','2013-06-15','16:05:00',6.72),('9650','2013-06-15','16:10:00',6.68),('9650','2013-06-15','16:15:00',6.63),('9650','2013-06-15','16:20:00',6.56),('9650','2013-06-15','16:25:00',6.52),('9650','2013-06-15','16:30:00',6.46),('9650','2013-06-15','16:35:00',6.37),('9650','2013-06-15','16:40:00',6.31),('9650','2013-06-15','16:45:00',6.24),('9650','2013-06-15','16:50:00',6.14),('9650','2013-06-15','16:55:00',6.05),('9650','2013-06-15','17:00:00',6.03),('9650','2013-06-15','17:05:00',5.93),('9650','2013-06-15','17:10:00',5.8),('9650','2013-06-15','17:15:00',5.7),('9650','2013-06-15','17:20:00',5.6),('9650','2013-06-15','17:25:00',5.49),('9650','2013-06-15','17:30:00',5.41),('9650','2013-06-15','17:35:00',5.34),('9650','2013-06-15','17:40:00',5.19),('9650','2013-06-15','17:45:00',5.06),('9650','2013-06-15','17:50:00',4.95),('9650','2013-06-15','17:55:00',4.81),('9650','2013-06-15','18:00:00',4.73),('9650','2013-06-15','18:05:00',4.61),('9650','2013-06-15','18:10:00',4.5),('9650','2013-06-15','18:15:00',4.36),('9650','2013-06-15','18:20:00',4.21),('9650','2013-06-15','18:25:00',4.12),('9650','2013-06-15','18:30:00',3.98),('9650','2013-06-15','18:35:00',3.83),('9650','2013-06-15','18:40:00',3.7),('9650','2013-06-15','18:45:00',3.58),('9650','2013-06-15','18:50:00',3.41),('9650','2013-06-15','18:55:00',3.26),('9650','2013-06-15','19:00:00',3.12),('9650','2013-06-15','19:05:00',2.96),('9650','2013-06-15','19:10:00',2.8),('9650','2013-06-15','19:15:00',2.63),('9650','2013-06-15','19:20:00',2.45),('9650','2013-06-15','19:25:00',2.26),('9650','2013-06-15','19:30:00',2.07),('9650','2013-06-15','19:35:00',1.89),('9650','2013-06-15','19:40:00',1.71),('9650','2013-06-15','19:45:00',1.55),('9650','2013-06-15','19:50:00',1.34),('9650','2013-06-15','19:55:00',1.15),('9650','2013-06-14','07:50:00',1.06),('9650','2013-06-14','07:55:00',1.12),('9650','2013-06-14','08:00:00',1.15),('9650','2013-06-14','08:05:00',1.19),('9650','2013-06-14','08:10:00',1.22),('9650','2013-06-14','08:15:00',1.25),('9650','2013-06-14','08:20:00',1.28),('9650','2013-06-14','08:25:00',1.44),('9650','2013-06-14','08:30:00',1.95),('9650','2013-06-14','08:35:00',2.05),('9650','2013-06-14','08:40:00',2.08),('9650','2013-06-14','08:45:00',1.56),('9650','2013-06-14','08:50:00',2.15),('9650','2013-06-14','08:55:00',2.51),('9650','2013-06-14','09:00:00',2.61),('9650','2013-06-14','09:05:00',2.46),('9650','2013-06-14','09:10:00',2.7),('9650','2013-06-14','09:15:00',2.91),('9650','2013-06-14','09:25:00',2.88),('9650','2013-06-14','09:30:00',3.02),('9650','2013-06-14','09:35:00',3.19),('9650','2013-06-14','09:40:00',3.8),('9650','2013-06-14','09:45:00',3.69),('9650','2013-06-14','09:50:00',3.8),('9650','2013-06-14','09:55:00',3.62),('9650','2013-06-14','10:00:00',3.52),('9650','2013-06-14','10:05:00',4.22),('9650','2013-06-14','10:10:00',3.79),('9650','2013-06-14','10:15:00',4.05),('9650','2013-06-14','10:20:00',4.14),('9650','2013-06-14','10:25:00',4.18),('9650','2013-06-14','10:30:00',4.03),('9650','2013-06-14','10:35:00',4.65),('9650','2013-06-14','10:40:00',4.11),('9650','2013-06-14','10:45:00',5.1),('9650','2013-06-14','10:50:00',3.93),('9650','2013-06-14','10:55:00',3.59),('9650','2013-06-14','11:00:00',3.17),('9650','2013-06-14','11:05:00',3.32),('9650','2013-06-14','11:10:00',5.16),('9650','2013-06-14','11:15:00',4.72),('9650','2013-06-14','11:20:00',3),('9650','2013-06-14','11:25:00',3.47),('9650','2013-06-14','11:30:00',6.48),('9650','2013-06-14','11:35:00',6.2),('9650','2013-06-14','11:40:00',6.3),('9650','2013-06-14','11:45:00',4.56),('9650','2013-06-14','11:50:00',6.17),('9650','2013-06-14','11:55:00',6.42),('9650','2013-06-14','12:00:00',6.52),('9650','2013-06-14','12:05:00',6.45),('9650','2013-06-14','12:10:00',6.55),('9650','2013-06-14','12:15:00',6.61),('9650','2013-06-14','12:20:00',6.6),('9650','2013-06-14','12:25:00',6.62),('9650','2013-06-14','12:30:00',6.59),('9650','2013-06-14','12:35:00',6.7),('9650','2013-06-14','12:40:00',6.79),('9650','2013-06-14','12:45:00',6.79),('9650','2013-06-14','12:50:00',6.83),('9650','2013-06-14','12:55:00',6.91),('9650','2013-06-14','13:00:00',6.95),('9650','2013-06-14','13:05:00',6.97),('9650','2013-06-14','13:10:00',6.98),('9650','2013-06-14','13:15:00',7.09),('9650','2013-06-14','13:20:00',7.07),('9650','2013-06-14','13:25:00',7.08),('9650','2013-06-14','13:30:00',7.09),('9650','2013-06-14','13:35:00',7.11),('9650','2013-06-14','13:40:00',7.15),('9650','2013-06-14','13:45:00',7.17),('9650','2013-06-14','13:50:00',7.17),('9650','2013-06-14','13:55:00',7.2),('9650','2013-06-14','14:00:00',7.19),('9650','2013-06-14','14:05:00',7.2),('9650','2013-06-14','14:10:00',7.2),('9650','2013-06-14','14:15:00',7.22),('9650','2013-06-14','14:20:00',7.25),('9650','2013-06-14','14:25:00',7.21),('9650','2013-06-14','14:30:00',7.11),('9650','2013-06-14','14:35:00',7.03),('9650','2013-06-14','14:40:00',7.2),('9650','2013-06-14','14:45:00',7.12),('9650','2013-06-14','14:50:00',7.05),('9650','2013-06-14','14:55:00',7.11),('9650','2013-06-14','15:00:00',7.03),('9650','2013-06-14','15:05:00',7.06),('9650','2013-06-14','15:10:00',7.08),('9650','2013-06-14','15:15:00',7.08),('9650','2013-06-14','15:20:00',7.11),('9650','2013-06-14','15:25:00',7.09),('9650','2013-06-14','15:30:00',7.11),('9650','2013-06-14','15:35:00',7.06),('9650','2013-06-14','15:40:00',7),('9650','2013-06-14','15:45:00',6.93),('9650','2013-06-14','15:50:00',6.87),('9650','2013-06-14','15:55:00',6.83),('9650','2013-06-14','16:00:00',6.77),('9650','2013-06-14','16:05:00',6.72),('9650','2013-06-14','16:10:00',6.68),('9650','2013-06-14','16:15:00',6.61),('9650','2013-06-14','16:20:00',6.52),('9650','2013-06-14','16:25:00',6.46),('9650','2013-06-14','16:30:00',6.44),('9650','2013-06-14','16:35:00',6.37),('9650','2013-06-14','16:40:00',6.29),('9650','2013-06-14','16:45:00',6.24),('9650','2013-06-14','16:50:00',6.2),('9650','2013-06-14','16:55:00',6.13),('9650','2013-06-14','17:00:00',6.05),('9650','2013-06-14','17:05:00',5.92),('9650','2013-06-14','17:10:00',5.8),('9650','2013-06-14','17:15:00',5.7),('9650','2013-06-14','17:20:00',5.6),('9650','2013-06-14','17:25:00',5.51),('9650','2013-06-14','17:30:00',5.39),('9650','2013-06-14','17:35:00',5.26),('9650','2013-06-14','17:40:00',5.15),('9650','2013-06-14','17:45:00',4.99),('9650','2013-06-14','17:50:00',4.83),('9650','2013-06-14','17:55:00',4.75),('9650','2013-06-14','18:00:00',4.64),('9650','2013-06-14','18:05:00',4.5),('9650','2013-06-14','18:10:00',4.38),('9650','2013-06-14','18:15:00',4.2),('9650','2013-06-14','18:20:00',4.08),('9650','2013-06-14','18:25:00',3.95),('9650','2013-06-14','18:30:00',3.8),('9650','2013-06-14','18:35:00',3.69),('9650','2013-06-14','18:40:00',3.57),('9650','2013-06-14','18:45:00',3.35),('9650','2013-06-14','18:50:00',3.21),('9650','2013-06-14','18:55:00',3.09),('9650','2013-06-14','19:00:00',2.94),('9650','2013-06-14','19:05:00',2.8),('9650','2013-06-14','19:10:00',2.62),('9650','2013-06-14','19:15:00',2.46),('9650','2013-06-14','19:20:00',2.29),('9650','2013-06-14','19:25:00',2.13),('9650','2013-06-14','19:30:00',1.95),('9650','2013-06-14','19:35:00',1.75),('9650','2013-06-14','19:40:00',1.54),('9650','2013-06-14','19:45:00',1.35),('9650','2013-06-14','19:50:00',1.14),('9650','2013-06-13','07:55:00',1.02),('9650','2013-06-13','08:00:00',1.1),('9650','2013-06-13','08:05:00',1.21),('9650','2013-06-13','08:10:00',1.3),('9650','2013-06-13','08:15:00',1.43),('9650','2013-06-13','08:20:00',1.6),('9650','2013-06-13','08:25:00',1.77),('9650','2013-06-13','08:30:00',1.89),('9650','2013-06-13','08:35:00',2.03),('9650','2013-06-13','08:40:00',2.15),('9650','2013-06-13','08:45:00',2.28),('9650','2013-06-13','08:50:00',2.41),('9650','2013-06-13','08:55:00',2.52),('9650','2013-06-13','09:00:00',2.63),('9650','2013-06-13','09:05:00',2.77),('9650','2013-06-13','09:10:00',2.92),('9650','2013-06-13','09:15:00',3.04),('9650','2013-06-13','09:20:00',3.15),('9650','2013-06-13','09:25:00',3.27),('9650','2013-06-13','09:30:00',3.4),('9650','2013-06-13','09:35:00',3.62),('9650','2013-06-13','09:40:00',3.77),('9650','2013-06-13','09:45:00',3.9),('9650','2013-06-13','09:50:00',4.02),('9650','2013-06-13','09:55:00',4.13),('9650','2013-06-13','10:00:00',4.2),('9650','2013-06-13','10:05:00',4.28),('9650','2013-06-13','10:10:00',4.4),('9650','2013-06-13','10:15:00',4.48),('9650','2013-06-13','10:20:00',4.61),('9650','2013-06-13','10:25:00',4.73),('9650','2013-06-13','10:30:00',4.77),('9650','2013-06-13','10:35:00',5.04),('9650','2013-06-13','10:40:00',5.14),('9650','2013-06-13','10:45:00',5.26),('9650','2013-06-13','10:50:00',5.32),('9650','2013-06-13','10:55:00',5.34),('9650','2013-06-13','11:00:00',5.37),('9650','2013-06-13','11:05:00',5.46),('9650','2013-06-13','11:10:00',5.59),('9650','2013-06-13','11:15:00',5.74),('9650','2013-06-13','11:20:00',5.74),('9650','2013-06-13','11:25:00',5.67),('9650','2013-06-13','11:30:00',6),('9650','2013-06-13','11:35:00',6.05),('9650','2013-06-13','11:40:00',6.15),('9650','2013-06-13','11:45:00',6.23),('9650','2013-06-13','11:50:00',6.28),('9650','2013-06-13','11:55:00',6.32),('9650','2013-06-13','12:00:00',6.35),('9650','2013-06-13','12:05:00',6.36),('9650','2013-06-13','12:10:00',6.4),('9650','2013-06-13','12:15:00',6.43),('9650','2013-06-13','12:20:00',6.52),('9650','2013-06-13','12:25:00',6.53),('9650','2013-06-13','12:30:00',6.61),('9650','2013-06-13','12:35:00',6.57),('9650','2013-06-13','12:40:00',6.68),('9650','2013-06-13','12:45:00',6.81),('9650','2013-06-13','12:50:00',6.8),('9650','2013-06-13','12:55:00',6.71),('9650','2013-06-13','13:00:00',6.75),('9650','2013-06-13','13:05:00',6.91),('9650','2013-06-13','13:10:00',6.98),('9650','2013-06-13','13:15:00',7.21),('9650','2013-06-13','13:20:00',7.31),('9650','2013-06-13','13:25:00',7.06),('9650','2013-06-13','13:30:00',7.08),('9650','2013-06-13','13:35:00',7.1),('9650','2013-06-13','13:40:00',7.15),('9650','2013-06-13','13:45:00',7.13),('9650','2013-06-13','13:50:00',7.22),('9650','2013-06-13','13:55:00',7.18),('9650','2013-06-13','14:00:00',7.25),('9650','2013-06-13','14:05:00',7.34),('9650','2013-06-13','14:10:00',7.46),('9650','2013-06-13','14:15:00',7.38),('9650','2013-06-13','14:20:00',7.28),('9650','2013-06-13','14:25:00',7.24),('9650','2013-06-13','14:30:00',7.23),('9650','2013-06-13','14:35:00',7.27),('9650','2013-06-13','14:40:00',7.27),('9650','2013-06-13','14:45:00',7.2),('9650','2013-06-13','14:50:00',7.25),('9650','2013-06-13','14:55:00',7.28),('9650','2013-06-13','15:00:00',7.28),('9650','2013-06-13','15:05:00',7.3),('9650','2013-06-13','15:10:00',7.31),('9650','2013-06-13','15:15:00',7.23),('9650','2013-06-13','15:20:00',7.23),('9650','2013-06-13','15:25:00',7.23),('9650','2013-06-13','15:30:00',7.19),('9650','2013-06-13','15:35:00',7.17),('9650','2013-06-13','15:40:00',7.15),('9650','2013-06-13','15:45:00',7.09),('9650','2013-06-13','15:50:00',7.03),('9650','2013-06-13','15:55:00',6.93),('9650','2013-06-13','16:00:00',6.87),('9650','2013-06-13','16:05:00',6.82),('9650','2013-06-13','16:10:00',6.75),('9650','2013-06-13','16:15:00',6.69),('9650','2013-06-13','16:20:00',6.63),('9650','2013-06-13','16:25:00',6.56),('9650','2013-06-13','16:30:00',6.48),('9650','2013-06-13','16:35:00',6.41),('9650','2013-06-13','16:40:00',6.33),('9650','2013-06-13','16:45:00',6.31),('9650','2013-06-13','16:50:00',6.26),('9650','2013-06-13','16:55:00',6.14),('9650','2013-06-13','17:00:00',6.1),('9650','2013-06-13','17:05:00',5.86),('9650','2013-06-13','17:10:00',5.85),('9650','2013-06-13','17:15:00',5.86),('9650','2013-06-13','17:20:00',5.71),('9650','2013-06-13','17:25:00',5.57),('9650','2013-06-13','17:30:00',5.32),('9650','2013-06-13','17:35:00',5.35),('9650','2013-06-13','17:40:00',5.32),('9650','2013-06-13','17:45:00',5.22),('9650','2013-06-13','17:50:00',5.13),('9650','2013-06-13','17:55:00',4.99),('9650','2013-06-13','18:00:00',4.83),('9650','2013-06-13','18:05:00',4.74),('9650','2013-06-13','18:10:00',4.63),('9650','2013-06-13','18:15:00',4.51),('9650','2013-06-13','18:20:00',4.37),('9650','2013-06-13','18:25:00',4.22),('9650','2013-06-13','18:30:00',4.11),('9650','2013-06-13','18:35:00',4),('9650','2013-06-13','18:40:00',3.88),('9650','2013-06-13','18:45:00',3.75),('9650','2013-06-13','18:50:00',3.56),('9650','2013-06-13','18:55:00',3.4),('9650','2013-06-13','19:00:00',3.27),('9650','2013-06-13','19:05:00',3.13),('9650','2013-06-13','19:10:00',2.94),('9650','2013-06-13','19:15:00',2.75),('9650','2013-06-13','19:20:00',2.57),('9650','2013-06-13','19:25:00',2.38),('9650','2013-06-13','19:30:00',2.2),('9650','2013-06-13','19:35:00',2),('9650','2013-06-13','19:40:00',1.81),('9650','2013-06-13','19:45:00',1.59),('9650','2013-06-13','19:50:00',1.37),('9650','2013-06-13','19:55:00',1.2),('9650','2013-06-13','20:00:00',1.01),('9650','2013-06-12','07:55:00',1.03),('9650','2013-06-12','08:00:00',1.12),('9650','2013-06-12','08:05:00',1.17),('9650','2013-06-12','08:10:00',1.22),('9650','2013-06-12','08:15:00',1.25),('9650','2013-06-12','08:20:00',1.28),('9650','2013-06-12','08:25:00',1.54),('9650','2013-06-12','08:30:00',1.89),('9650','2013-06-12','08:35:00',2.04),('9650','2013-06-12','08:40:00',2.14),('9650','2013-06-12','08:45:00',2.27),('9650','2013-06-12','08:50:00',2.41),('9650','2013-06-12','08:55:00',2.51),('9650','2013-06-12','09:00:00',2.65),('9650','2013-06-12','09:05:00',2.79),('9650','2013-06-12','09:10:00',2.92),('9650','2013-06-12','09:15:00',3.08),('9650','2013-06-12','09:20:00',3.19),('9650','2013-06-12','09:25:00',3.33),('9650','2013-06-12','09:30:00',3.49),('9650','2013-06-12','09:35:00',3.68),('9650','2013-06-12','09:40:00',3.82),('9650','2013-06-12','09:45:00',3.94),('9650','2013-06-12','09:50:00',4.07),('9650','2013-06-12','09:55:00',4.17),('9650','2013-06-12','10:00:00',4.24),('9650','2013-06-12','10:05:00',4.38),('9650','2013-06-12','10:10:00',4.5),('9650','2013-06-12','10:15:00',4.56),('9650','2013-06-12','10:20:00',4.72),('9650','2013-06-12','10:25:00',4.84),('9650','2013-06-12','10:30:00',4.94),('9650','2013-06-12','10:35:00',5.07),('9650','2013-06-12','10:40:00',5.17),('9650','2013-06-12','10:45:00',5.34),('9650','2013-06-12','10:50:00',5.45),('9650','2013-06-12','10:55:00',5.55),('9650','2013-06-12','11:00:00',5.59),('9650','2013-06-12','11:05:00',5.66),('9650','2013-06-12','11:10:00',5.72),('9650','2013-06-12','11:15:00',5.8),('9650','2013-06-12','11:20:00',5.9),('9650','2013-06-12','11:25:00',5.99),('9650','2013-06-12','11:30:00',6.09),('9650','2013-06-12','11:35:00',6.18),('9650','2013-06-12','11:40:00',6.25),('9650','2013-06-12','11:45:00',6.34),('9650','2013-06-12','11:50:00',6.39),('9650','2013-06-12','11:55:00',6.44),('9650','2013-06-12','12:00:00',6.51),('9650','2013-06-12','12:05:00',6.62),('9650','2013-06-12','12:10:00',6.69),('9650','2013-06-12','12:15:00',6.73),('9650','2013-06-12','12:20:00',6.77),('9650','2013-06-12','12:25:00',6.82),('9650','2013-06-12','12:30:00',6.89),('9650','2013-06-12','12:35:00',6.91),('9650','2013-06-12','12:40:00',6.96),('9650','2013-06-12','12:45:00',6.97),('9650','2013-06-12','12:50:00',7.05),('9650','2013-06-12','12:55:00',7.07),('9650','2013-06-12','13:00:00',7.14),('9650','2013-06-12','13:05:00',7.18),('9650','2013-06-12','13:10:00',7.18),('9650','2013-06-12','13:15:00',7.21),('9650','2013-06-12','13:20:00',7.17),('9650','2013-06-12','13:25:00',7.25),('9650','2013-06-12','13:30:00',7.24),('9650','2013-06-12','13:35:00',7.31),('9650','2013-06-12','13:40:00',7.33),('9650','2013-06-12','13:45:00',7.29),('9650','2013-06-12','13:50:00',7.34),('9650','2013-06-12','13:55:00',7.35),('9650','2013-06-12','14:00:00',7.39),('9650','2013-06-12','14:05:00',7.39),('9650','2013-06-12','14:10:00',7.41),('9650','2013-06-12','14:15:00',7.41),('9650','2013-06-12','14:20:00',7.46),('9650','2013-06-12','14:25:00',7.51),('9650','2013-06-12','14:30:00',5.7),('9650','2013-06-12','14:35:00',5.53),('9650','2013-06-12','14:40:00',7.64),('9650','2013-06-12','14:45:00',7.51),('9650','2013-06-12','14:50:00',7.41),('9650','2013-06-12','14:55:00',7.35),('9650','2013-06-12','15:00:00',7.39),('9650','2013-06-12','15:05:00',7.38),('9650','2013-06-12','15:10:00',7.3),('9650','2013-06-12','15:15:00',7.3),('9650','2013-06-12','15:20:00',7.24),('9650','2013-06-12','15:25:00',7.23),('9650','2013-06-12','15:30:00',7.19),('9650','2013-06-12','15:35:00',7.15),('9650','2013-06-12','15:40:00',7.13),('9650','2013-06-12','15:45:00',7.09),('9650','2013-06-12','15:50:00',7.05),('9650','2013-06-12','15:55:00',6.99),('9650','2013-06-12','16:00:00',6.94),('9650','2013-06-12','16:05:00',6.84),('9650','2013-06-12','16:10:00',6.77),('9650','2013-06-12','16:15:00',6.71),('9650','2013-06-12','16:20:00',6.61),('9650','2013-06-12','16:25:00',6.53),('9650','2013-06-12','16:30:00',6.49),('9650','2013-06-12','16:35:00',6.43),('9650','2013-06-12','16:40:00',6.34),('9650','2013-06-12','16:45:00',6.26),('9650','2013-06-12','16:50:00',6.12),('9650','2013-06-12','16:55:00',6.06),('9650','2013-06-12','17:00:00',5.94),('9650','2013-06-12','17:05:00',5.91),('9650','2013-06-12','17:10:00',5.78),('9650','2013-06-12','17:15:00',5.67),('9650','2013-06-12','17:20:00',5.63),('9650','2013-06-12','17:25:00',5.57),('9650','2013-06-12','17:30:00',5.46),('9650','2013-06-12','17:35:00',5.37),('9650','2013-06-12','17:40:00',5.25),('9650','2013-06-12','17:45:00',5.13),('9650','2013-06-12','17:50:00',5.07),('9650','2013-06-12','17:55:00',4.93),('9650','2013-06-12','18:00:00',4.79),('9650','2013-06-12','18:05:00',4.65),('9650','2013-06-12','18:10:00',4.52),('9650','2013-06-12','18:15:00',4.45),('9650','2013-06-12','18:20:00',4.35),('9650','2013-06-12','18:25:00',4.22),('9650','2013-06-12','18:30:00',4.08),('9650','2013-06-12','18:35:00',3.91),('9650','2013-06-12','18:40:00',3.78),('9650','2013-06-12','18:45:00',3.63),('9650','2013-06-12','18:50:00',3.49),('9650','2013-06-12','18:55:00',3.33),('9650','2013-06-12','19:00:00',3.17),('9650','2013-06-12','19:05:00',3.01),('9650','2013-06-12','19:10:00',2.85),('9650','2013-06-12','19:15:00',2.68),('9650','2013-06-12','19:20:00',2.53),('9650','2013-06-12','19:25:00',2.33),('9650','2013-06-12','19:30:00',2.12),('9650','2013-06-12','19:35:00',1.95),('9650','2013-06-12','19:40:00',1.77),('9650','2013-06-12','19:45:00',1.56),('9650','2013-06-12','19:50:00',1.33),('9650','2013-06-12','19:55:00',1.15),('9650','2013-06-11','07:55:00',1.08),('9650','2013-06-11','08:00:00',1.16),('9650','2013-06-11','08:05:00',1.26),('9650','2013-06-11','08:10:00',1.35),('9650','2013-06-11','08:15:00',1.46),('9650','2013-06-11','08:20:00',1.65),('9650','2013-06-11','08:25:00',1.82),('9650','2013-06-11','08:30:00',1.95),('9650','2013-06-11','08:35:00',2.08),('9650','2013-06-11','08:40:00',2.19),('9650','2013-06-11','08:45:00',2.32),('9650','2013-06-11','08:50:00',2.45),('9650','2013-06-11','08:55:00',2.57),('9650','2013-06-11','09:00:00',2.69),('9650','2013-06-11','09:05:00',2.83),('9650','2013-06-11','09:10:00',2.98),('9650','2013-06-11','09:15:00',3.09),('9650','2013-06-11','09:20:00',3.21),('9650','2013-06-11','09:25:00',3.34),('9650','2013-06-11','09:30:00',3.51),('9650','2013-06-11','09:35:00',3.67),('9650','2013-06-11','09:40:00',3.81),('9650','2013-06-11','09:45:00',3.94),('9650','2013-06-11','09:50:00',4.06),('9650','2013-06-11','09:55:00',4.14),('9650','2013-06-11','10:00:00',4.24),('9650','2013-06-11','10:05:00',4.38),('9650','2013-06-11','10:10:00',4.5),('9650','2013-06-11','10:15:00',4.57),('9650','2013-06-11','10:20:00',4.77),('9650','2013-06-11','10:25:00',4.88),('9650','2013-06-11','10:30:00',4.96),('9650','2013-06-11','10:35:00',5.06),('9650','2013-06-11','10:40:00',5.14),('9650','2013-06-11','10:45:00',5.26),('9650','2013-06-11','10:50:00',5.41),('9650','2013-06-11','10:55:00',5.52),('9650','2013-06-11','11:00:00',5.63),('9650','2013-06-11','11:05:00',5.73),('9650','2013-06-11','11:10:00',5.83),('9650','2013-06-11','11:15:00',5.92),('9650','2013-06-11','11:20:00',5.99),('9650','2013-06-11','11:25:00',6.01),('9650','2013-06-11','11:30:00',6.11),('9650','2013-06-11','11:35:00',6.16),('9650','2013-06-11','11:40:00',6.24),('9650','2013-06-11','11:45:00',6.36),('9650','2013-06-11','11:50:00',6.38),('9650','2013-06-11','11:55:00',6.43),('9650','2013-06-11','12:00:00',6.59),('9650','2013-06-11','12:05:00',6.66),('9650','2013-06-11','12:10:00',6.71),('9650','2013-06-11','12:15:00',6.82),('9650','2013-06-11','12:20:00',7.1),('9650','2013-06-11','12:25:00',5.44),('9650','2013-06-11','12:30:00',4.79),('9650','2013-06-11','12:35:00',7.43),('9650','2013-06-11','12:40:00',3.45),('9650','2013-06-11','12:45:00',2.53),('9650','2013-06-11','12:50:00',3.2),('9650','2013-06-11','12:55:00',4.54),('9650','2013-06-11','13:00:00',6.68),('9650','2013-06-11','13:05:00',3.07),('9650','2013-06-11','13:10:00',7.39),('9650','2013-06-11','13:15:00',7.48),('9650','2013-06-11','13:20:00',7.46),('9650','2013-06-11','13:25:00',6.85),('9650','2013-06-11','13:30:00',6.89),('9650','2013-06-11','13:35:00',7.49),('9650','2013-06-11','13:40:00',7.59),('9650','2013-06-11','13:45:00',7.67),('9650','2013-06-11','13:50:00',7.52),('9650','2013-06-11','13:55:00',7.76),('9650','2013-06-11','14:00:00',6.72),('9650','2013-06-11','14:05:00',4.99),('9650','2013-06-11','14:10:00',2.81),('9650','2013-06-11','14:15:00',8.3),('9650','2013-06-11','14:20:00',4.38),('9650','2013-06-11','14:25:00',5.28),('9650','2013-06-11','14:30:00',7.96),('9650','2013-06-11','14:35:00',6.27),('9650','2013-06-11','14:40:00',6.2),('9650','2013-06-11','14:45:00',7.9),('9650','2013-06-11','14:50:00',7.87),('9650','2013-06-11','14:55:00',7.91),('9650','2013-06-11','15:00:00',7.79),('9650','2013-06-11','15:05:00',7.71),('9650','2013-06-11','15:10:00',7.61),('9650','2013-06-11','15:15:00',6.92),('9650','2013-06-11','15:20:00',7.62),('9650','2013-06-11','15:25:00',7.41),('9650','2013-06-11','15:30:00',7.38),('9650','2013-06-11','15:35:00',7.44),('9650','2013-06-11','15:40:00',7.45),('9650','2013-06-11','15:45:00',7.37),('9650','2013-06-11','15:50:00',7.23),('9650','2013-06-11','15:55:00',7.32),('9650','2013-06-11','16:00:00',7.39),('9650','2013-06-11','16:05:00',7.07),('9650','2013-06-11','16:10:00',7.1),('9650','2013-06-11','16:15:00',7.02),('9650','2013-06-11','16:20:00',6.89),('9650','2013-06-11','16:25:00',6.95),('9650','2013-06-11','16:30:00',6.37),('9650','2013-06-11','16:35:00',6.6),('9650','2013-06-11','16:40:00',6.81),('9650','2013-06-11','16:45:00',6.58),('9650','2013-06-11','16:50:00',6.64),('9650','2013-06-11','16:55:00',5.88),('9650','2013-06-11','17:00:00',6.23),('9650','2013-06-11','17:05:00',6.22),('9650','2013-06-11','17:10:00',6.1),('9650','2013-06-11','17:15:00',6.01),('9650','2013-06-11','17:20:00',5.85),('9650','2013-06-11','17:25:00',5.73),('9650','2013-06-11','17:30:00',5.67),('9650','2013-06-11','17:35:00',5.68),('9650','2013-06-11','17:40:00',5.65),('9650','2013-06-11','17:45:00',3.31),('9650','2013-06-11','17:50:00',1.07),('9650','2013-06-11','17:55:00',1.96),('9650','2013-06-11','18:00:00',1.75),('9650','2013-06-11','18:05:00',4.71),('9650','2013-06-11','18:10:00',4.79),('9650','2013-06-11','18:15:00',4.69),('9650','2013-06-11','18:20:00',4.49),('9650','2013-06-11','18:25:00',4.11),('9650','2013-06-11','18:30:00',4.02),('9650','2013-06-11','18:35:00',3.87),('9650','2013-06-11','18:40:00',3.72),('9650','2013-06-11','18:45:00',3.52),('9650','2013-06-11','18:50:00',3.39),('9650','2013-06-11','18:55:00',3.34),('9650','2013-06-11','19:00:00',3.25),('9650','2013-06-11','19:05:00',3.1),('9650','2013-06-11','19:10:00',1.18),('9650','2013-06-11','19:15:00',2.18),('9650','2013-06-11','19:20:00',2.5),('9650','2013-06-11','19:25:00',2.2),('9650','2013-06-11','19:30:00',2.04),('9650','2013-06-11','19:35:00',1.83),('9650','2013-06-11','19:40:00',1.66),('9650','2013-06-11','19:45:00',1.42),('9650','2013-06-11','19:50:00',1.13),('9650','2013-06-10','08:00:00',1.4),('9650','2013-06-10','08:05:00',1.54),('9650','2013-06-10','08:10:00',1.71),('9650','2013-06-10','08:15:00',1.42),('9650','2013-06-10','08:20:00',1.06),('9650','2013-06-10','08:25:00',2.17),('9650','2013-06-10','08:30:00',2.22),('9650','2013-06-10','08:35:00',2.45),('9650','2013-06-10','08:40:00',2.14),('9650','2013-06-10','08:45:00',2.36),('9650','2013-06-10','08:50:00',1.66),('9650','2013-06-10','08:55:00',1.15),('9650','2013-06-10','09:00:00',1.89),('9650','2013-06-10','09:05:00',2.87),('9650','2013-06-10','09:10:00',3.2),('9650','2013-06-10','09:15:00',3.45),('9650','2013-06-10','09:20:00',3.62),('9650','2013-06-10','09:25:00',2.38),('9650','2013-06-10','09:30:00',1.91),('9650','2013-06-10','09:35:00',1.14),('9650','2013-06-10','09:40:00',2.5),('9650','2013-06-10','09:45:00',4.28),('9650','2013-06-10','09:50:00',4.36),('9650','2013-06-10','09:55:00',4.32),('9650','2013-06-10','10:00:00',4.04),('9650','2013-06-10','10:05:00',2.73),('9650','2013-06-10','10:10:00',4.34),('9650','2013-06-10','10:15:00',4.89),('9650','2013-06-10','10:20:00',5.16),('9650','2013-06-10','10:25:00',5.25),('9650','2013-06-10','10:30:00',5.22),('9650','2013-06-10','10:35:00',5.3),('9650','2013-06-10','10:40:00',5.27),('9650','2013-06-10','10:45:00',4.82),('9650','2013-06-10','10:50:00',5.26),('9650','2013-06-10','10:55:00',1.4),('9650','2013-06-10','11:00:00',6.31),('9650','2013-06-10','11:05:00',3.89),('9650','2013-06-10','11:10:00',3.05),('9650','2013-06-10','11:15:00',6.42),('9650','2013-06-10','11:20:00',6.19),('9650','2013-06-10','11:25:00',6.25),('9650','2013-06-10','11:30:00',6.33),('9650','2013-06-10','11:35:00',6.37),('9650','2013-06-10','11:40:00',6.43),('9650','2013-06-10','11:45:00',6.55),('9650','2013-06-10','11:50:00',6.62),('9650','2013-06-10','11:55:00',6.69),('9650','2013-06-10','12:00:00',6.4),('9650','2013-06-10','12:05:00',6.82),('9650','2013-06-10','12:10:00',6.85),('9650','2013-06-10','12:15:00',6.92),('9650','2013-06-10','12:20:00',7.02),('9650','2013-06-10','12:25:00',7.02),('9650','2013-06-10','12:30:00',7.09),('9650','2013-06-10','12:35:00',7.15),('9650','2013-06-10','12:40:00',7.21),('9650','2013-06-10','12:45:00',7.27),('9650','2013-06-10','12:50:00',7.37),('9650','2013-06-10','12:55:00',7.38),('9650','2013-06-10','13:00:00',7.43),('9650','2013-06-10','13:05:00',7.48),('9650','2013-06-10','13:10:00',7.51),('9650','2013-06-10','13:15:00',7.58),('9650','2013-06-10','13:20:00',7.58),('9650','2013-06-10','13:25:00',7.64),('9650','2013-06-10','13:30:00',7.7),('9650','2013-06-10','13:35:00',7.71),('9650','2013-06-10','13:40:00',7.79),('9650','2013-06-10','13:45:00',7.83),('9650','2013-06-10','13:50:00',6.84),('9650','2013-06-10','13:55:00',7.87),('9650','2013-06-10','14:00:00',7.85),('9650','2013-06-10','14:05:00',7.73),('9650','2013-06-10','14:10:00',7.7),('9650','2013-06-10','14:15:00',7.72),('9650','2013-06-10','14:20:00',7.73),('9650','2013-06-10','14:25:00',7.73),('9650','2013-06-10','14:30:00',7.74),('9650','2013-06-10','14:35:00',7.71),('9650','2013-06-10','14:40:00',7.73),('9650','2013-06-10','14:45:00',7.72),('9650','2013-06-10','14:50:00',7.72),('9650','2013-06-10','14:55:00',7.68),('9650','2013-06-10','15:00:00',7.66),('9650','2013-06-10','15:05:00',7.65),('9650','2013-06-10','15:10:00',7.65),('9650','2013-06-10','15:15:00',7.57),('9650','2013-06-10','15:20:00',7.54),('9650','2013-06-10','15:25:00',7.47),('9650','2013-06-10','15:30:00',7.55),('9650','2013-06-10','15:35:00',7.58),('9650','2013-06-10','15:40:00',7.34),('9650','2013-06-10','15:45:00',7.75),('9650','2013-06-10','15:50:00',7.39),('9650','2013-06-10','15:55:00',7.36),('9650','2013-06-10','16:00:00',6.85),('9650','2013-06-10','16:05:00',7.26),('9650','2013-06-10','16:10:00',7.17),('9650','2013-06-10','16:15:00',7.07),('9650','2013-06-10','16:20:00',7.06),('9650','2013-06-10','16:25:00',7),('9650','2013-06-10','16:30:00',6.98),('9650','2013-06-10','16:35:00',6.95),('9650','2013-06-10','16:40:00',7.05),('9650','2013-06-10','16:45:00',7.32),('9650','2013-06-10','16:50:00',7.35),('9650','2013-06-10','16:55:00',7.13),('9650','2013-06-10','17:00:00',6.12),('9650','2013-06-10','17:05:00',3.83),('9650','2013-06-10','17:10:00',1.55),('9650','2013-06-10','17:15:00',1.21),('9650','2013-06-10','19:15:00',1.13),('9650','2013-06-10','19:20:00',1.04),('9650','2013-06-10','19:25:00',1.13),('9650','2013-06-10','19:30:00',2.64),('9650','2013-06-10','19:35:00',1.73),('9650','2014-04-02','08:25:00',1.05),('9650','2014-04-02','08:30:00',1.12),('9650','2014-04-02','08:35:00',1.17),('9650','2014-04-02','08:40:00',1.28),('9650','2014-04-02','08:45:00',1.4),('9650','2014-04-02','08:50:00',1.44),('9650','2014-04-02','08:55:00',1.55),('9650','2014-04-02','09:00:00',1.72),('9650','2014-04-02','09:05:00',1.9),('9650','2014-04-02','09:10:00',1.87),('9650','2014-04-02','09:15:00',1.79),('9650','2014-04-02','09:20:00',1.84),('9650','2014-04-02','09:25:00',1.95),('9650','2014-04-02','09:30:00',2.14),('9650','2014-04-02','09:35:00',2.4),('9650','2014-04-02','09:40:00',2.5),('9650','2014-04-02','09:45:00',2.48),('9650','2014-04-02','09:50:00',2.36),('9650','2014-04-02','09:55:00',2.39),('9650','2014-04-02','10:00:00',2.67),('9650','2014-04-02','10:05:00',2.95),('9650','2014-04-02','10:10:00',3.08),('9650','2014-04-02','10:15:00',3.51),('9650','2014-04-02','10:20:00',3.69),('9650','2014-04-02','10:25:00',3.45),('9650','2014-04-02','10:30:00',3.38),('9650','2014-04-02','10:35:00',3.73),('9650','2014-04-02','10:40:00',3.19),('9650','2014-04-02','10:45:00',3.48),('9650','2014-04-02','10:50:00',3.24),('9650','2014-04-02','10:55:00',3.41),('9650','2014-04-02','11:00:00',3.27),('9650','2014-04-02','11:05:00',2.88),('9650','2014-04-02','11:10:00',2.76),('9650','2014-04-02','11:15:00',2.64),('9650','2014-04-02','11:20:00',2.52),('9650','2014-04-02','11:25:00',2.35),('9650','2014-04-02','11:30:00',2.32),('9650','2014-04-02','11:35:00',2.48),('9650','2014-04-02','11:40:00',2.7),('9650','2014-04-02','11:45:00',3),('9650','2014-04-02','11:50:00',3.53),('9650','2014-04-02','11:55:00',3.87),('9650','2014-04-02','12:00:00',3.76),('9650','2014-04-02','12:05:00',3.78),('9650','2014-04-02','12:10:00',3.69),('9650','2014-04-02','12:15:00',3.64),('9650','2014-04-02','12:25:00',2.58),('9650','2014-04-02','12:30:00',5.66),('9650','2014-04-02','12:35:00',5.59),('9650','2014-04-02','12:40:00',6.37),('9650','2014-04-02','12:45:00',3.82),('9650','2014-04-02','12:50:00',4.47),('9650','2014-04-02','12:55:00',4.39),('9650','2014-04-02','13:00:00',4.26),('9650','2014-04-02','13:05:00',5.34),('9650','2014-04-02','13:10:00',4.11),('9650','2014-04-02','13:15:00',7.2),('9650','2014-04-02','13:20:00',4.33),('9650','2014-04-02','13:25:00',4.56),('9650','2014-04-02','13:30:00',4.35),('9650','2014-04-02','13:35:00',7.11),('9650','2014-04-02','13:40:00',6.35),('9650','2014-04-02','13:45:00',3.56),('9650','2014-04-02','13:50:00',3.58),('9650','2014-04-02','13:55:00',4.17),('9650','2014-04-02','14:00:00',5.82),('9650','2014-04-02','14:05:00',5.65),('9650','2014-04-02','14:10:00',4.47),('9650','2014-04-02','14:15:00',5.98),('9650','2014-04-02','14:20:00',6.14),('9650','2014-04-02','14:25:00',6.35),('9650','2014-04-02','14:30:00',6.5),('9650','2014-04-02','14:35:00',6.64),('9650','2014-04-02','14:40:00',6.46),('9650','2014-04-02','14:45:00',6.37),('9650','2014-04-02','14:50:00',6.29),('9650','2014-04-02','14:55:00',6.18),('9650','2014-04-02','15:00:00',6.13),('9650','2014-04-02','15:05:00',6.02),('9650','2014-04-02','15:10:00',5.84),('9650','2014-04-02','15:15:00',5.82),('9650','2014-04-02','15:20:00',5.88),('9650','2014-04-02','15:25:00',5.9),('9650','2014-04-02','15:30:00',5.86),('9650','2014-04-02','15:35:00',5.84),('9650','2014-04-02','15:40:00',5.83),('9650','2014-04-02','15:45:00',5.82),('9650','2014-04-02','15:50:00',5.72),('9650','2014-04-02','15:55:00',5.65),('9650','2014-04-02','16:00:00',5.59),('9650','2014-04-02','16:05:00',5.37),('9650','2014-04-02','16:10:00',5.42),('9650','2014-04-02','16:15:00',5.31),('9650','2014-04-02','16:20:00',5.3),('9650','2014-04-02','16:25:00',5.19),('9650','2014-04-02','16:30:00',5.08),('9650','2014-04-02','16:35:00',4.99),('9650','2014-04-02','16:40:00',4.89),('9650','2014-04-02','16:45:00',4.6),('9650','2014-04-02','16:50:00',3.5),('9650','2014-04-02','16:55:00',2.83),('9650','2014-04-02','17:00:00',2.26),('9650','2014-04-02','17:05:00',2.09),('9650','2014-04-02','17:10:00',1.91),('9650','2014-04-02','17:15:00',1.87),('9650','2014-04-02','17:20:00',2.04),('9650','2014-04-02','17:25:00',2.26),('9650','2014-04-02','17:30:00',2.23),('9650','2014-04-02','17:35:00',1.47),('9650','2014-04-02','17:40:00',1.32),('9650','2014-04-02','17:45:00',2.73),('9650','2014-04-02','17:50:00',3.56),('9650','2014-04-02','17:55:00',3.25),('9650','2014-04-02','18:00:00',3.02),('9650','2014-04-02','18:05:00',2.87),('9650','2014-04-02','18:10:00',2.73),('9650','2014-04-02','18:15:00',2.6),('9650','2014-04-02','18:20:00',2.37),('9650','2014-04-02','18:25:00',1.86),('9650','2014-04-02','18:30:00',1.16),('9650','2014-04-02','18:35:00',1.37),('9650','2014-04-02','18:40:00',1.44),('9650','2014-04-02','18:45:00',1.46),('9650','2014-04-02','18:50:00',1.34),('9650','2013-06-09','07:25:00',1.09),('9650','2013-06-09','07:30:00',1.31),('9650','2013-06-09','07:35:00',1.73),('9650','2013-06-09','07:40:00',1.33),('9650','2013-06-09','07:45:00',1.16),('9650','2013-06-09','07:50:00',1.21),('9650','2013-06-09','07:55:00',1.26),('9650','2013-06-09','08:00:00',1.66),('9650','2013-06-09','08:05:00',1.88),('9650','2013-06-09','08:10:00',2.3),('9650','2013-06-09','08:15:00',2.17),('9650','2013-06-09','08:20:00',2.23),('9650','2013-06-09','08:25:00',2.16),('9650','2013-06-09','08:30:00',1.79),('9650','2013-06-09','08:35:00',1.66),('9650','2013-06-09','08:40:00',1.9),('9650','2013-06-09','08:45:00',1.11),('9650','2013-06-09','08:50:00',1.24),('9650','2013-06-09','08:55:00',1.73),('9650','2013-06-09','09:00:00',1.8),('9650','2013-06-09','09:05:00',1.78),('9650','2013-06-09','09:10:00',2.14),('9650','2013-06-09','09:15:00',1.82),('9650','2013-06-09','09:20:00',2),('9650','2013-06-09','09:25:00',3.12),('9650','2013-06-09','09:30:00',3.01),('9650','2013-06-09','09:35:00',4.36),('9650','2013-06-09','09:40:00',3.72),('9650','2013-06-09','09:45:00',5.23),('9650','2013-06-09','09:50:00',3.15),('9650','2013-06-09','09:55:00',2.64),('9650','2013-06-09','10:00:00',3.43),('9650','2013-06-09','10:05:00',3.71),('9650','2013-06-09','10:10:00',4.07),('9650','2013-06-09','10:15:00',3.23),('9650','2013-06-09','10:20:00',3.11),('9650','2013-06-09','10:25:00',2.59),('9650','2013-06-09','10:30:00',2.58),('9650','2013-06-09','10:35:00',2.92),('9650','2013-06-09','10:40:00',2.73),('9650','2013-06-09','10:45:00',2.15),('9650','2013-06-09','10:50:00',3.01),('9650','2013-06-09','10:55:00',5.2),('9650','2013-06-09','11:00:00',4.33),('9650','2013-06-09','11:05:00',3.85),('9650','2013-06-09','11:10:00',5.06),('9650','2013-06-09','11:15:00',6.15),('9650','2013-06-09','11:20:00',6.45),('9650','2013-06-09','11:25:00',6.12),('9650','2013-06-09','11:30:00',6.01),('9650','2013-06-09','11:35:00',7.08),('9650','2013-06-09','11:40:00',4.52),('9650','2013-06-09','11:45:00',5.33),('9650','2013-06-09','11:50:00',3.24),('9650','2013-06-09','11:55:00',5.81),('9650','2013-06-09','12:00:00',6.77),('9650','2013-06-09','12:05:00',2.39),('9650','2013-06-09','12:10:00',7.36),('9650','2013-06-09','12:15:00',6.73),('9650','2013-06-09','12:20:00',7.32),('9650','2013-06-09','12:25:00',7.62),('9650','2013-06-09','12:30:00',7.64),('9650','2013-06-09','12:35:00',7.1),('9650','2013-06-09','12:40:00',5.4),('9650','2013-06-09','12:45:00',5.99),('9650','2013-06-09','12:50:00',4.87),('9650','2013-06-09','12:55:00',5.77),('9650','2013-06-09','13:00:00',8.86),('9650','2013-06-09','13:05:00',6.35),('9650','2013-06-09','13:10:00',3.68),('9650','2013-06-09','13:15:00',7.5),('9650','2013-06-09','13:20:00',5.47),('9650','2013-06-09','13:25:00',4.72),('9650','2013-06-09','13:30:00',4.01),('9650','2013-06-09','13:35:00',7.59),('9650','2013-06-09','13:40:00',7.21),('9650','2013-06-09','13:45:00',6.33),('9650','2013-06-09','13:50:00',6.41),('9650','2013-06-09','13:55:00',8.76),('9650','2013-06-09','14:00:00',7.95),('9650','2013-06-09','14:05:00',8.33),('9650','2013-06-09','14:10:00',6.97),('9650','2013-06-09','14:15:00',7.77),('9650','2013-06-09','14:20:00',7.92),('9650','2013-06-09','14:25:00',7.85),('9650','2013-06-09','14:30:00',7.69),('9650','2013-06-09','14:35:00',7.73),('9650','2013-06-09','14:40:00',6.76),('9650','2013-06-09','14:45:00',7.79),('9650','2013-06-09','14:50:00',7.7),('9650','2013-06-09','14:55:00',7.71),('9650','2013-06-09','15:00:00',7.71),('9650','2013-06-09','15:05:00',7.68),('9650','2013-06-09','15:10:00',7.65),('9650','2013-06-09','15:15:00',7.66),('9650','2013-06-09','15:20:00',7.65),('9650','2013-06-09','15:25:00',7.62),('9650','2013-06-09','15:30:00',7.59),('9650','2013-06-09','15:35:00',7.61),('9650','2013-06-09','15:40:00',7.61),('9650','2013-06-09','15:45:00',7.55),('9650','2013-06-09','15:50:00',7.45),('9650','2013-06-09','15:55:00',7.38),('9650','2013-06-09','16:00:00',7.3),('9650','2013-06-09','16:05:00',7.24),('9650','2013-06-09','16:10:00',7.19),('9650','2013-06-09','16:15:00',7.13),('9650','2013-06-09','16:20:00',7.03),('9650','2013-06-09','16:25:00',7.03),('9650','2013-06-09','16:30:00',6.9),('9650','2013-06-09','16:35:00',6.83),('9650','2013-06-09','16:40:00',6.75),('9650','2013-06-09','16:45:00',6.69),('9650','2013-06-09','16:50:00',6.62),('9650','2013-06-09','16:55:00',6.59),('9650','2013-06-09','17:00:00',6.52),('9650','2013-06-09','17:05:00',6.43),('9650','2013-06-09','17:10:00',6.34),('9650','2013-06-09','17:15:00',6.23),('9650','2013-06-09','17:20:00',6.17),('9650','2013-06-09','17:25:00',6.04),('9650','2013-06-09','17:30:00',5.92),('9650','2013-06-09','17:35:00',5.82),('9650','2013-06-09','17:40:00',5.67),('9650','2013-06-09','17:45:00',5.53),('9650','2013-06-09','17:50:00',5.43),('9650','2013-06-09','17:55:00',5.37),('9650','2013-06-09','18:00:00',5.23),('9650','2013-06-09','18:05:00',5.11),('9650','2013-06-09','18:10:00',5),('9650','2013-06-09','18:15:00',4.85),('9650','2013-06-09','18:20:00',4.76),('9650','2013-06-09','18:25:00',4.64),('9650','2013-06-09','18:30:00',4.48),('9650','2013-06-09','18:35:00',4.31),('9650','2013-06-09','18:40:00',4.16),('9650','2013-06-09','18:45:00',3.98),('9650','2013-06-09','18:50:00',3.88),('9650','2013-06-09','18:55:00',3.69),('9650','2013-06-09','19:00:00',3.56),('9650','2013-06-09','19:05:00',3.36),('9650','2013-06-09','19:10:00',3.16),('9650','2013-06-09','19:15:00',3.01),('9650','2013-06-09','19:20:00',2.82),('9650','2013-06-09','19:25:00',2.62),('9650','2013-06-09','19:30:00',2.4),('9650','2013-06-09','19:35:00',2.19),('9650','2013-06-09','19:40:00',2.01),('9650','2013-06-09','19:45:00',1.81),('9650','2013-06-09','19:50:00',1.6),('9650','2013-06-09','19:55:00',1.38),('9650','2013-06-09','20:00:00',1.19),('9650','2013-06-08','07:10:00',1.01),('9650','2013-06-08','07:25:00',1.18),('9650','2013-06-08','07:30:00',1.16),('9650','2013-06-08','07:35:00',1.74),('9650','2013-06-08','07:40:00',1.31),('9650','2013-06-08','07:50:00',1.05),('9650','2013-06-08','07:55:00',1.4),('9650','2013-06-08','08:00:00',1.35),('9650','2013-06-08','08:05:00',1.5),('9650','2013-06-08','08:10:00',1.7),('9650','2013-06-08','08:15:00',1.45),('9650','2013-06-08','08:20:00',1.52),('9650','2013-06-08','08:25:00',1.93),('9650','2013-06-08','08:30:00',2.06),('9650','2013-06-08','08:35:00',2.16),('9650','2013-06-08','08:40:00',2.24),('9650','2013-06-08','08:45:00',2.37),('9650','2013-06-08','08:50:00',2.48),('9650','2013-06-08','08:55:00',2.57),('9650','2013-06-08','09:00:00',2.66),('9650','2013-06-08','09:05:00',2.82),('9650','2013-06-08','09:10:00',2.93),('9650','2013-06-08','09:15:00',3.03),('9650','2013-06-08','09:20:00',3.13),('9650','2013-06-08','09:25:00',3.28),('9650','2013-06-08','09:30:00',3.51),('9650','2013-06-08','09:35:00',3.59),('9650','2013-06-08','09:40:00',3.63),('9650','2013-06-08','09:45:00',3.78),('9650','2013-06-08','09:50:00',3.92),('9650','2013-06-08','09:55:00',4.02),('9650','2013-06-08','10:00:00',4.11),('9650','2013-06-08','10:05:00',4.2),('9650','2013-06-08','10:10:00',4.36),('9650','2013-06-08','10:15:00',4.4),('9650','2013-06-08','10:20:00',4.51),('9650','2013-06-08','10:25:00',4.6),('9650','2013-06-08','10:30:00',4.83),('9650','2013-06-08','10:35:00',4.92),('9650','2013-06-08','10:40:00',5.06),('9650','2013-06-08','10:45:00',5.15),('9650','2013-06-08','10:50:00',5.25),('9650','2013-06-08','10:55:00',5.27),('9650','2013-06-08','11:00:00',5.36),('9650','2013-06-08','11:05:00',5.37),('9650','2013-06-08','11:10:00',5.5),('9650','2013-06-08','11:15:00',5.65),('9650','2013-06-08','11:20:00',5.71),('9650','2013-06-08','11:25:00',5.71),('9650','2013-06-08','11:30:00',5.77),('9650','2013-06-08','11:35:00',5.86),('9650','2013-06-08','11:40:00',5.99),('9650','2013-06-08','11:45:00',6.12),('9650','2013-06-08','11:50:00',6.13),('9650','2013-06-08','11:55:00',6.18),('9650','2013-06-08','12:00:00',6.24),('9650','2013-06-08','12:05:00',6.38),('9650','2013-06-08','12:10:00',5.56),('9650','2013-06-08','12:15:00',6.31),('9650','2013-06-08','12:20:00',6.51),('9650','2013-06-08','12:25:00',6.41),('9650','2013-06-08','12:30:00',6.65),('9650','2013-06-08','12:35:00',6.62),('9650','2013-06-08','12:40:00',6.71),('9650','2013-06-08','12:45:00',5.74),('9650','2013-06-08','12:50:00',6.88),('9650','2013-06-08','12:55:00',6.84),('9650','2013-06-08','13:00:00',6.29),('9650','2013-06-08','13:05:00',6.97),('9650','2013-06-08','13:10:00',4.04),('9650','2013-06-08','13:15:00',5.22),('9650','2013-06-08','13:20:00',5.81),('9650','2013-06-08','13:25:00',7.7),('9650','2013-06-08','13:30:00',7.39),('9650','2013-06-08','13:35:00',7.52),('9650','2013-06-08','13:40:00',7.85),('9650','2013-06-08','13:45:00',7.95),('9650','2013-06-08','13:50:00',8.33),('9650','2013-06-08','13:55:00',7.26),('9650','2013-06-08','14:00:00',6.96),('9650','2013-06-08','14:05:00',7.82),('9650','2013-06-08','14:10:00',7.61),('9650','2013-06-08','14:15:00',4.98),('9650','2013-06-08','14:20:00',3.22),('9650','2013-06-08','14:25:00',2.06),('9650','2013-06-08','14:30:00',2.73),('9650','2013-06-08','14:35:00',7.01),('9650','2013-06-08','14:40:00',7.03),('9650','2013-06-08','14:45:00',7.16),('9650','2013-06-08','14:50:00',7.63),('9650','2013-06-08','14:55:00',7.78),('9650','2013-06-08','15:00:00',7.67),('9650','2013-06-08','15:05:00',7.32),('9650','2013-06-08','15:10:00',7.45),('9650','2013-06-08','15:15:00',7.25),('9650','2013-06-08','15:20:00',7.34),('9650','2013-06-08','15:25:00',7.33),('9650','2013-06-08','15:30:00',6.84),('9650','2013-06-08','15:35:00',7.31),('9650','2013-06-08','15:40:00',5.74),('9650','2013-06-08','15:45:00',5.92),('9650','2013-06-08','15:50:00',6.81),('9650','2013-06-08','15:55:00',7.37),('9650','2013-06-08','16:00:00',4.44),('9650','2013-06-08','16:05:00',6.71),('9650','2013-06-08','16:10:00',6.66),('9650','2013-06-08','16:15:00',3.51),('9650','2013-06-08','16:20:00',3.11),('9650','2013-06-08','16:25:00',4.48),('9650','2013-06-08','16:30:00',2.61),('9650','2013-06-08','16:35:00',1.76),('9650','2013-06-08','16:40:00',1.7),('9650','2013-06-08','16:45:00',1.7),('9650','2013-06-08','16:50:00',1.68),('9650','2013-06-08','16:55:00',1.56),('9650','2013-06-08','17:00:00',1.68),('9650','2013-06-08','17:05:00',1.8),('9650','2013-06-08','17:10:00',1.77),('9650','2013-06-08','17:15:00',1.38),('9650','2013-06-08','17:20:00',1.48),('9650','2013-06-08','17:25:00',1.12),('9650','2013-06-08','17:35:00',1.1),('9650','2013-06-08','17:40:00',1.38),('9650','2013-06-08','17:45:00',1.31),('9650','2013-06-08','18:00:00',1.71),('9650','2013-06-08','18:05:00',1.84),('9650','2013-06-08','18:10:00',3.96),('9650','2013-06-08','18:15:00',3.05),('9650','2013-06-08','18:20:00',2.69),('9650','2013-06-08','18:25:00',1.16),('9650','2013-06-08','18:30:00',2.55),('9650','2013-06-08','18:35:00',1.62),('9650','2013-06-08','18:40:00',1.15),('9650','2013-06-08','18:45:00',1.85),('9650','2013-06-08','18:50:00',1.94),('9650','2013-06-08','18:55:00',1.44),('9650','2013-06-08','19:30:00',1),('9650','2013-06-07','07:50:00',1.01),('9650','2013-06-07','07:55:00',1.09),('9650','2013-06-07','08:00:00',1.17),('9650','2013-06-07','08:05:00',1.25),('9650','2013-06-07','08:10:00',1.36),('9650','2013-06-07','08:15:00',1.47),('9650','2013-06-07','08:20:00',1.62),('9650','2013-06-07','08:25:00',1.78),('9650','2013-06-07','08:30:00',1.88),('9650','2013-06-07','08:35:00',2.02),('9650','2013-06-07','08:40:00',2.15),('9650','2013-06-07','08:45:00',2.28),('9650','2013-06-07','08:50:00',2.4),('9650','2013-06-07','08:55:00',2.51),('9650','2013-06-07','09:00:00',2.61),('9650','2013-06-07','09:05:00',2.73),('9650','2013-06-07','09:10:00',2.84),('9650','2013-06-07','09:15:00',3.01),('9650','2013-06-07','09:20:00',3.11),('9650','2013-06-07','09:25:00',3.2),('9650','2013-06-07','09:30:00',3.44),('9650','2013-06-07','09:35:00',3.58),('9650','2013-06-07','09:40:00',3.71),('9650','2013-06-07','09:45:00',3.81),('9650','2013-06-07','09:50:00',3.98),('9650','2013-06-07','09:55:00',4.14),('9650','2013-06-07','10:00:00',4.16),('9650','2013-06-07','10:05:00',4.37),('9650','2013-06-07','10:10:00',4.54),('9650','2013-06-07','10:15:00',4.65),('9650','2013-06-07','10:20:00',4.7),('9650','2013-06-07','10:25:00',4.69),('9650','2013-06-07','10:30:00',4.56),('9650','2013-06-07','10:35:00',4.62),('9650','2013-06-07','10:40:00',5.3),('9650','2013-06-07','10:45:00',5.36),('9650','2013-06-07','10:50:00',5.86),('9650','2013-06-07','10:55:00',4.15),('9650','2013-06-07','11:00:00',2.57),('9650','2013-06-07','11:05:00',5.04),('9650','2013-06-07','11:10:00',4.66),('9650','2013-06-07','11:15:00',6.68),('9650','2013-06-07','11:20:00',6.91),('9650','2013-06-07','11:25:00',3.12),('9650','2013-06-07','11:30:00',1.86),('9650','2013-06-07','11:35:00',5.92),('9650','2013-06-07','11:40:00',6.81),('9650','2013-06-07','11:45:00',6.5),('9650','2013-06-07','11:50:00',4.78),('9650','2013-06-07','11:55:00',2.1),('9650','2013-06-07','12:00:00',6.83),('9650','2013-06-07','12:05:00',1.84),('9650','2013-06-07','12:10:00',4.92),('9650','2013-06-07','12:15:00',5.15),('9650','2013-06-07','12:20:00',2.32),('9650','2013-06-07','12:25:00',4.71),('9650','2013-06-07','12:30:00',2.2),('9650','2013-06-07','12:35:00',4.92),('9650','2013-06-07','12:40:00',7.09),('9650','2013-06-07','12:45:00',7.3),('9650','2013-06-07','12:50:00',7.38),('9650','2013-06-07','12:55:00',7.35),('9650','2013-06-07','13:00:00',7.43),('9650','2013-06-07','13:05:00',7.34),('9650','2013-06-07','13:10:00',5.72),('9650','2013-06-07','13:15:00',3.95),('9650','2013-06-07','13:20:00',7.73),('9650','2013-06-07','13:25:00',7.61),('9650','2013-06-07','13:30:00',7.69),('9650','2013-06-07','13:35:00',7.59),('9650','2013-06-07','13:40:00',7.53),('9650','2013-06-07','13:45:00',7.44),('9650','2013-06-07','13:50:00',7.48),('9650','2013-06-07','13:55:00',7.49),('9650','2013-06-07','14:00:00',7.53),('9650','2013-06-07','14:05:00',7.54),('9650','2013-06-07','14:10:00',7.57),('9650','2013-06-07','14:15:00',7.59),('9650','2013-06-07','14:20:00',7.59),('9650','2013-06-07','14:25:00',7.59),('9650','2013-06-07','14:30:00',7.56),('9650','2013-06-07','14:35:00',7.54),('9650','2013-06-07','14:40:00',7.62),('9650','2013-06-07','14:45:00',7.56),('9650','2013-06-07','14:50:00',7.64),('9650','2013-06-07','14:55:00',7.63),('9650','2013-06-07','15:00:00',7.66),('9650','2013-06-07','15:05:00',7.45),('9650','2013-06-07','15:10:00',6.88),('9650','2013-06-07','15:15:00',7.12),('9650','2013-06-07','15:20:00',7.59),('9650','2013-06-07','15:25:00',7.14),('9650','2013-06-07','15:30:00',7.26),('9650','2013-06-07','15:35:00',7.37),('9650','2013-06-07','15:40:00',7.31),('9650','2013-06-07','15:45:00',7.27),('9650','2013-06-07','15:50:00',7.56),('9650','2013-06-07','15:55:00',6.93),('9650','2013-06-07','16:00:00',7.2),('9650','2013-06-07','16:05:00',7.27),('9650','2013-06-07','16:10:00',7.3),('9650','2013-06-07','16:15:00',7.33),('9650','2013-06-07','16:20:00',7.18),('9650','2013-06-07','16:25:00',6.95),('9650','2013-06-07','16:30:00',6.7),('9650','2013-06-07','16:35:00',6.66),('9650','2013-06-07','16:40:00',6.62),('9650','2013-06-07','16:45:00',6.58),('9650','2013-06-07','16:50:00',5.64),('9650','2013-06-07','16:55:00',5.71),('9650','2013-06-07','17:00:00',6.42),('9650','2013-06-07','17:05:00',5.98),('9650','2013-06-07','17:10:00',6.74),('9650','2013-06-07','17:15:00',6.61),('9650','2013-06-07','17:20:00',6.37),('9650','2013-06-07','17:25:00',6.09),('9650','2013-06-07','17:30:00',4.44),('9650','2013-06-07','17:35:00',3.38),('9650','2013-06-07','17:40:00',5.19),('9650','2013-06-07','17:45:00',5.57),('9650','2013-06-07','17:50:00',5.01),('9650','2013-06-07','17:55:00',5.45),('9650','2013-06-07','18:00:00',4.46),('9650','2013-06-07','18:05:00',3.99),('9650','2013-06-07','18:10:00',3.35),('9650','2013-06-07','18:15:00',3.31),('9650','2013-06-07','18:20:00',3.29),('9650','2013-06-07','18:25:00',2.87),('9650','2013-06-07','18:30:00',1.66),('9650','2013-06-07','18:35:00',1.45),('9650','2013-06-07','18:40:00',1.07),('9650','2013-06-06','07:55:00',1.01),('9650','2013-06-06','08:00:00',1.1),('9650','2013-06-06','08:05:00',1.17),('9650','2013-06-06','08:10:00',1.22),('9650','2013-06-06','08:15:00',1.25),('9650','2013-06-06','08:20:00',1.27),('9650','2013-06-06','08:25:00',1.32),('9650','2013-06-06','08:30:00',1.88),('9650','2013-06-06','08:35:00',2.05),('9650','2013-06-06','08:40:00',2.17),('9650','2013-06-06','08:45:00',2.32),('9650','2013-06-06','08:50:00',2.44),('9650','2013-06-06','08:55:00',2.57),('9650','2013-06-06','09:00:00',2.7),('9650','2013-06-06','09:05:00',2.85),('9650','2013-06-06','09:10:00',2.98),('9650','2013-06-06','09:15:00',3.13),('9650','2013-06-06','09:20:00',3.26),('9650','2013-06-06','09:25:00',3.38),('9650','2013-06-06','09:30:00',3.59),('9650','2013-06-06','09:35:00',3.76),('9650','2013-06-06','09:40:00',3.9),('9650','2013-06-06','09:45:00',4.06),('9650','2013-06-06','09:50:00',4.16),('9650','2013-06-06','09:55:00',4.28),('9650','2013-06-06','10:00:00',4.37),('9650','2013-06-06','10:05:00',4.53),('9650','2013-06-06','10:10:00',4.61),('9650','2013-06-06','10:15:00',4.71),('9650','2013-06-06','10:20:00',4.88),('9650','2013-06-06','10:25:00',4.99),('9650','2013-06-06','10:30:00',5.08),('9650','2013-06-06','10:35:00',5.19),('9650','2013-06-06','10:40:00',5.31),('9650','2013-06-06','10:45:00',5.44),('9650','2013-06-06','10:50:00',5.53),('9650','2013-06-06','10:55:00',5.63),('9650','2013-06-06','11:00:00',5.75),('9650','2013-06-06','11:05:00',5.86),('9650','2013-06-06','11:10:00',5.96),('9650','2013-06-06','11:15:00',6.01),('9650','2013-06-06','11:20:00',6.08),('9650','2013-06-06','11:25:00',6.17),('9650','2013-06-06','11:30:00',6.27),('9650','2013-06-06','11:35:00',6.35),('9650','2013-06-06','11:40:00',6.43),('9650','2013-06-06','11:45:00',6.49),('9650','2013-06-06','11:50:00',6.55),('9650','2013-06-06','11:55:00',6.65),('9650','2013-06-06','12:00:00',6.69),('9650','2013-06-06','12:05:00',6.75),('9650','2013-06-06','12:10:00',6.82),('9650','2013-06-06','12:15:00',6.87),('9650','2013-06-06','12:20:00',6.93),('9650','2013-06-06','12:25:00',6.93),('9650','2013-06-06','12:30:00',6.98),('9650','2013-06-06','12:35:00',7.01),('9650','2013-06-06','12:40:00',7.07),('9650','2013-06-06','12:45:00',7.16),('9650','2013-06-06','12:50:00',7.16),('9650','2013-06-06','12:55:00',7.22),('9650','2013-06-06','13:00:00',7.28),('9650','2013-06-06','13:05:00',7.29),('9650','2013-06-06','13:10:00',7.28),('9650','2013-06-06','13:15:00',7.31),('9650','2013-06-06','13:20:00',7.35),('9650','2013-06-06','13:25:00',7.4),('9650','2013-06-06','13:30:00',7.43),('9650','2013-06-06','13:35:00',7.43),('9650','2013-06-06','13:40:00',7.39),('9650','2013-06-06','13:45:00',7.39),('9650','2013-06-06','13:50:00',7.4),('9650','2013-06-06','13:55:00',7.44),('9650','2013-06-06','14:00:00',7.44),('9650','2013-06-06','14:05:00',7.45),('9650','2013-06-06','14:10:00',7.43),('9650','2013-06-06','14:15:00',7.41),('9650','2013-06-06','14:20:00',7.39),('9650','2013-06-06','14:25:00',7.38),('9650','2013-06-06','14:30:00',7.39),('9650','2013-06-06','14:35:00',7.31),('9650','2013-06-06','14:40:00',7.4),('9650','2013-06-06','14:45:00',7.44),('9650','2013-06-06','14:50:00',7.48),('9650','2013-06-06','14:55:00',7.41),('9650','2013-06-06','15:00:00',7.4),('9650','2013-06-06','15:05:00',7.51),('9650','2013-06-06','15:10:00',7.49),('9650','2013-06-06','15:15:00',7.38),('9650','2013-06-06','15:20:00',7.33),('9650','2013-06-06','15:25:00',7.43),('9650','2013-06-06','15:30:00',7.41),('9650','2013-06-06','15:35:00',7.35),('9650','2013-06-06','15:40:00',7.27),('9650','2013-06-06','15:45:00',7.25),('9650','2013-06-06','15:50:00',7.13),('9650','2013-06-06','15:55:00',7.07),('9650','2013-06-06','16:00:00',7.07),('9650','2013-06-06','16:05:00',7.01),('9650','2013-06-06','16:10:00',6.73),('9650','2013-06-06','16:15:00',6.47),('9650','2013-06-06','16:20:00',6.56),('9650','2013-06-06','16:25:00',6.61),('9650','2013-06-06','16:30:00',6.76),('9650','2013-06-06','16:35:00',6.7),('9650','2013-06-06','16:40:00',6.59),('9650','2013-06-06','16:45:00',6.56),('9650','2013-06-06','16:50:00',6.5),('9650','2013-06-06','16:55:00',6.45),('9650','2013-06-06','17:00:00',6.35),('9650','2013-06-06','17:05:00',6.23),('9650','2013-06-06','17:10:00',6.14),('9650','2013-06-06','17:15:00',5.88),('9650','2013-06-06','17:20:00',5.72),('9650','2013-06-06','17:25:00',5.7),('9650','2013-06-06','17:30:00',5.64),('9650','2013-06-06','17:35:00',5.5),('9650','2013-06-06','17:40:00',5.41),('9650','2013-06-06','17:45:00',5.4),('9650','2013-06-06','17:50:00',5.39),('9650','2013-06-06','17:55:00',5.19),('9650','2013-06-06','18:00:00',4.93),('9650','2013-06-06','18:05:00',4.81),('9650','2013-06-06','18:10:00',4.64),('9650','2013-06-06','18:15:00',4.43),('9650','2013-06-06','18:20:00',4.23),('9650','2013-06-06','18:25:00',3.91),('9650','2013-06-06','18:30:00',3.84),('9650','2013-06-06','18:35:00',3.79),('9650','2013-06-06','18:40:00',3.64),('9650','2013-06-06','18:45:00',3.38),('9650','2013-06-06','18:50:00',3.22),('9650','2013-06-06','18:55:00',3.11),('9650','2013-06-06','19:00:00',3),('9650','2013-06-06','19:05:00',2.33),('9650','2013-06-06','19:15:00',1.59),('9650','2013-06-06','19:20:00',2.06),('9650','2013-06-06','19:25:00',1.77),('9650','2013-06-06','19:30:00',1.33),('9650','2013-06-06','19:40:00',1.24),('9650','2013-06-06','19:45:00',1.21),('9650','2013-06-05','07:00:00',1.12),('9650','2013-06-05','07:05:00',1.25),('9650','2013-06-05','07:10:00',1.22),('9650','2013-06-05','07:15:00',1.24),('9650','2013-06-05','07:50:00',1.1),('9650','2013-06-05','07:55:00',1.41),('9650','2013-06-05','08:00:00',1.49),('9650','2013-06-05','08:05:00',1.23),('9650','2013-06-05','08:10:00',1.51),('9650','2013-06-05','08:15:00',1.27),('9650','2013-06-05','08:20:00',1.48),('9650','2013-06-05','08:25:00',1.89),('9650','2013-06-05','08:30:00',2.02),('9650','2013-06-05','08:35:00',2.13),('9650','2013-06-05','08:40:00',2.25),('9650','2013-06-05','08:45:00',2.36),('9650','2013-06-05','08:50:00',2.49),('9650','2013-06-05','08:55:00',2.6),('9650','2013-06-05','09:00:00',2.74),('9650','2013-06-05','09:05:00',2.83),('9650','2013-06-05','09:10:00',2.99),('9650','2013-06-05','09:15:00',3.09),('9650','2013-06-05','09:20:00',3.25),('9650','2013-06-05','09:25:00',3.38),('9650','2013-06-05','09:30:00',3.59),('9650','2013-06-05','09:35:00',3.73),('9650','2013-06-05','09:40:00',3.86),('9650','2013-06-05','09:45:00',4.02),('9650','2013-06-05','09:50:00',4.11),('9650','2013-06-05','09:55:00',4.22),('9650','2013-06-05','10:00:00',4.28),('9650','2013-06-05','10:05:00',4.29),('9650','2013-06-05','10:10:00',4.31),('9650','2013-06-05','10:15:00',4.59),('9650','2013-06-05','10:20:00',4.79),('9650','2013-06-05','10:25:00',4.78),('9650','2013-06-05','10:30:00',4.98),('9650','2013-06-05','10:35:00',5.05),('9650','2013-06-05','10:40:00',5.26),('9650','2013-06-05','10:45:00',5.39),('9650','2013-06-05','10:50:00',5.51),('9650','2013-06-05','10:55:00',5.61),('9650','2013-06-05','11:00:00',5.71),('9650','2013-06-05','11:05:00',5.7),('9650','2013-06-05','11:10:00',5.81),('9650','2013-06-05','11:15:00',5.87),('9650','2013-06-05','11:20:00',5.81),('9650','2013-06-05','11:25:00',6.07),('9650','2013-06-05','11:30:00',6.18),('9650','2013-06-05','11:35:00',6.22),('9650','2013-06-05','11:40:00',6.25),('9650','2013-06-05','11:45:00',6.35),('9650','2013-06-05','11:50:00',6.51),('9650','2013-06-05','11:55:00',6.58),('9650','2013-06-05','12:00:00',6.61),('9650','2013-06-05','12:05:00',6.71),('9650','2013-06-05','12:10:00',6.71),('9650','2013-06-05','12:15:00',6.7),('9650','2013-06-05','12:20:00',6.7),('9650','2013-06-05','12:25:00',6.76),('9650','2013-06-05','12:30:00',6.8),('9650','2013-06-05','12:35:00',6.86),('9650','2013-06-05','12:40:00',6.88),('9650','2013-06-05','12:45:00',6.93),('9650','2013-06-05','12:50:00',7.12),('9650','2013-06-05','12:55:00',7.15),('9650','2013-06-05','13:00:00',7.13),('9650','2013-06-05','13:05:00',7.2),('9650','2013-06-05','13:10:00',7.32),('9650','2013-06-05','13:15:00',7.41),('9650','2013-06-05','13:20:00',7.44),('9650','2013-06-05','13:25:00',7.16),('9650','2013-06-05','13:30:00',7.65),('9650','2013-06-05','13:35:00',7.66),('9650','2013-06-05','13:40:00',2.94),('9650','2013-06-05','13:45:00',1.46),('9650','2013-06-05','13:50:00',4.21),('9650','2013-06-05','13:55:00',7.54),('9650','2013-06-05','14:00:00',7.66),('9650','2013-06-05','14:05:00',7.48),('9650','2013-06-05','14:10:00',7.73),('9650','2013-06-05','14:15:00',7.5),('9650','2013-06-05','14:20:00',4.84),('9650','2013-06-05','14:25:00',6.15),('9650','2013-06-05','14:30:00',7.37),('9650','2013-06-05','14:35:00',7.48),('9650','2013-06-05','14:40:00',7.65),('9650','2013-06-05','14:45:00',5.58),('9650','2013-06-05','14:50:00',7.96),('9650','2013-06-05','14:55:00',7.56),('9650','2013-06-05','15:00:00',7.1),('9650','2013-06-05','15:05:00',7.59),('9650','2013-06-05','15:10:00',7.52),('9650','2013-06-05','15:15:00',7.29),('9650','2013-06-05','15:20:00',7.33),('9650','2013-06-05','15:25:00',5.57),('9650','2013-06-05','15:30:00',7.03),('9650','2013-06-05','15:35:00',7.28),('9650','2013-06-05','15:40:00',6.99),('9650','2013-06-05','15:45:00',7.12),('9650','2013-06-05','15:50:00',6.98),('9650','2013-06-05','15:55:00',7),('9650','2013-06-05','16:00:00',6.87),('9650','2013-06-05','16:05:00',7.04),('9650','2013-06-05','16:10:00',6.83),('9650','2013-06-05','16:15:00',6.45),('9650','2013-06-05','16:20:00',6.5),('9650','2013-06-05','16:25:00',6.47),('9650','2013-06-05','16:30:00',6.43),('9650','2013-06-05','16:35:00',6.45),('9650','2013-06-05','16:40:00',6.4),('9650','2013-06-05','16:45:00',6.24),('9650','2013-06-05','16:50:00',6.11),('9650','2013-06-05','16:55:00',5.98),('9650','2013-06-05','17:00:00',5.85),('9650','2013-06-05','17:05:00',5.74),('9650','2013-06-05','17:10:00',5.73),('9650','2013-06-05','17:15:00',5.58),('9650','2013-06-05','17:20:00',5.44),('9650','2013-06-05','17:25:00',5.4),('9650','2013-06-05','17:30:00',5.4),('9650','2013-06-05','17:35:00',5.2),('9650','2013-06-05','17:40:00',5.06),('9650','2013-06-05','17:45:00',4.98),('9650','2013-06-05','17:50:00',4.85),('9650','2013-06-05','17:55:00',4.68),('9650','2013-06-05','18:00:00',4.61),('9650','2013-06-05','18:05:00',4.55),('9650','2013-06-05','18:10:00',4.37),('9650','2013-06-05','18:15:00',4.15),('9650','2013-06-05','18:20:00',3.99),('9650','2013-06-05','18:25:00',3.84),('9650','2013-06-05','18:30:00',3.7),('9650','2013-06-05','18:35:00',3.61),('9650','2013-06-05','18:40:00',3.48),('9650','2013-06-05','18:45:00',3.29),('9650','2013-06-05','18:50:00',3.12),('9650','2013-06-05','18:55:00',2.98),('9650','2013-06-05','19:00:00',2.79),('9650','2013-06-05','19:05:00',2.62),('9650','2013-06-05','19:10:00',2.44),('9650','2013-06-05','19:15:00',2.27),('9650','2013-06-05','19:20:00',2.11),('9650','2013-06-05','19:25:00',1.89),('9650','2013-06-05','19:30:00',1.67),('9650','2013-06-05','19:35:00',1.49),('9650','2013-06-05','19:40:00',1.32),('9650','2013-06-05','19:45:00',1.12),('9650','2013-06-04','07:50:00',1.6),('9650','2013-06-04','07:55:00',1.79),('9650','2013-06-04','08:00:00',1.72),('9650','2013-06-04','08:05:00',1.39),('9650','2013-06-04','08:10:00',1.36),('9650','2013-06-04','08:15:00',1.56),('9650','2013-06-04','08:20:00',1.66),('9650','2013-06-04','08:25:00',1.83),('9650','2013-06-04','08:30:00',1.98),('9650','2013-06-04','08:35:00',2.11),('9650','2013-06-04','08:40:00',2.21),('9650','2013-06-04','08:45:00',2.35),('9650','2013-06-04','08:50:00',2.47),('9650','2013-06-04','08:55:00',2.59),('9650','2013-06-04','09:00:00',2.83),('9650','2013-06-04','09:05:00',3.02),('9650','2013-06-04','09:10:00',2.91),('9650','2013-06-04','09:15:00',3.36),('9650','2013-06-04','09:20:00',3.86),('9650','2013-06-04','09:25:00',4.16),('9650','2013-06-04','09:30:00',4.25),('9650','2013-06-04','09:35:00',2.22),('9650','2013-06-04','09:40:00',1.94),('9650','2013-06-04','09:45:00',2.71),('9650','2013-06-04','09:50:00',2.02),('9650','2013-06-04','09:55:00',2.13),('9650','2013-06-04','10:00:00',5.38),('9650','2013-06-04','10:05:00',3.2),('9650','2013-06-04','10:10:00',3.96),('9650','2013-06-04','10:15:00',2.68),('9650','2013-06-04','10:20:00',2.37),('9650','2013-06-04','10:25:00',2.38),('9650','2013-06-04','10:30:00',2.3),('9650','2013-06-04','10:35:00',2.35),('9650','2013-06-04','10:40:00',2.55),('9650','2013-06-04','10:45:00',6.12),('9650','2013-06-04','10:50:00',6.1),('9650','2013-06-04','10:55:00',5.59),('9650','2013-06-04','11:00:00',6.06),('9650','2013-06-04','11:05:00',4.2),('9650','2013-06-04','11:10:00',2.26),('9650','2013-06-04','11:15:00',1.99),('9650','2013-06-04','11:20:00',1.87),('9650','2013-06-04','11:25:00',1.9),('9650','2013-06-04','11:30:00',2.16),('9650','2013-06-04','11:35:00',6.14),('9650','2013-06-04','11:40:00',7.51),('9650','2013-06-04','11:45:00',5.31),('9650','2013-06-04','11:50:00',2.69),('9650','2013-06-04','11:55:00',7.48),('9650','2013-06-04','12:00:00',7.76),('9650','2013-06-04','12:05:00',7.62),('9650','2013-06-04','12:10:00',7.68),('9650','2013-06-04','12:15:00',7.73),('9650','2013-06-04','12:20:00',8.11),('9650','2013-06-04','12:25:00',7.97),('9650','2013-06-04','12:30:00',8.28),('9650','2013-06-04','12:35:00',3.8),('9650','2013-06-04','12:40:00',7.89),('9650','2013-06-04','12:45:00',8.85),('9650','2013-06-04','12:50:00',4.52),('9650','2013-06-04','12:55:00',4.23),('9650','2013-06-04','13:00:00',7.7),('9650','2013-06-04','13:05:00',5.06),('9650','2013-06-04','13:10:00',7.14),('9650','2013-06-04','13:15:00',5.33),('9650','2013-06-04','13:20:00',4.86),('9650','2013-06-04','13:25:00',5.24),('9650','2013-06-04','13:30:00',6.72),('9650','2013-06-04','13:35:00',8.32),('9650','2013-06-04','13:40:00',7.94),('9650','2013-06-04','13:45:00',7.92),('9650','2013-06-04','13:50:00',7.84),('9650','2013-06-04','13:55:00',7.82),('9650','2013-06-04','14:00:00',7.81),('9650','2013-06-04','14:05:00',7.84),('9650','2013-06-04','14:10:00',7.44),('9650','2013-06-04','14:15:00',7.7),('9650','2013-06-04','14:20:00',7.76),('9650','2013-06-04','14:25:00',7.74),('9650','2013-06-04','14:30:00',7.3),('9650','2013-06-04','14:35:00',7.8),('9650','2013-06-04','14:40:00',7.76),('9650','2013-06-04','14:45:00',7.8),('9650','2013-06-04','14:50:00',7.81),('9650','2013-06-04','14:55:00',7.79),('9650','2013-06-04','15:00:00',7.66),('9650','2013-06-04','15:05:00',7.67),('9650','2013-06-04','15:10:00',7.59),('9650','2013-06-04','15:15:00',7.62),('9650','2013-06-04','15:20:00',7.61),('9650','2013-06-04','15:25:00',7.62),('9650','2013-06-04','15:30:00',7.7),('9650','2013-06-04','15:35:00',7.76),('9650','2013-06-04','15:40:00',7.63),('9650','2013-06-04','15:45:00',7.53),('9650','2013-06-04','15:50:00',7.4),('9650','2013-06-04','15:55:00',7.4),('9650','2013-06-04','16:00:00',7.35),('9650','2013-06-04','16:05:00',7.17),('9650','2013-06-04','16:10:00',6.87),('9650','2013-06-04','16:15:00',7.21),('9650','2013-06-04','16:20:00',7.1),('9650','2013-06-04','16:25:00',7.04),('9650','2013-06-04','16:30:00',6.94),('9650','2013-06-04','16:35:00',6.84),('9650','2013-06-04','16:40:00',6.78),('9650','2013-06-04','16:45:00',6.79),('9650','2013-06-04','16:50:00',6.69),('9650','2013-06-04','16:55:00',6.63),('9650','2013-06-04','17:00:00',3.59),('9650','2013-06-04','17:05:00',5.15),('9650','2013-06-04','17:10:00',2.82),('9650','2013-06-04','17:15:00',5.28),('9650','2013-06-04','17:20:00',4.79),('9650','2013-06-04','17:25:00',5.85),('9650','2013-06-04','17:30:00',4.77),('9650','2013-06-04','17:35:00',3.98),('9650','2013-06-04','17:40:00',4.97),('9650','2013-06-04','17:45:00',5.39),('9650','2013-06-04','17:50:00',5.18),('9650','2013-06-04','17:55:00',4.99),('9650','2013-06-04','18:00:00',4.63),('9650','2013-06-04','18:05:00',3.86),('9650','2013-06-04','18:10:00',3.03),('9650','2013-06-04','18:15:00',2.96),('9650','2013-06-04','18:20:00',1.55),('9650','2013-06-04','18:25:00',3.52),('9650','2013-06-04','18:30:00',4.04),('9650','2013-06-04','18:35:00',3.99),('9650','2013-06-04','18:40:00',2.87),('9650','2013-06-04','18:45:00',1.4),('9650','2013-06-04','18:50:00',1.43),('9650','2013-06-04','18:55:00',2.96),('9650','2013-06-04','19:00:00',2.54),('9650','2013-06-04','19:05:00',1.79),('9650','2013-06-04','19:10:00',2.45),('9650','2013-06-04','19:25:00',1.49),('9650','2013-06-04','19:30:00',1.55),('9650','2013-06-04','19:35:00',1.69),('9650','2013-06-04','19:40:00',1.53),('9650','2013-06-04','19:45:00',1.3),('9650','2013-06-04','19:50:00',1.08),('9650','2013-06-03','07:35:00',1.03),('9650','2013-06-03','07:40:00',1.19),('9650','2013-06-03','07:45:00',1.5),('9650','2013-06-03','07:50:00',1.71),('9650','2013-06-03','07:55:00',1.89),('9650','2013-06-03','08:00:00',2.21),('9650','2013-06-03','08:05:00',2.39),('9650','2013-06-03','08:10:00',2.37),('9650','2013-06-03','08:15:00',2.4),('9650','2013-06-03','08:20:00',2.39),('9650','2013-06-03','08:25:00',2.48),('9650','2013-06-03','08:30:00',2.94),('9650','2013-06-03','08:35:00',2.98),('9650','2013-06-03','08:40:00',2.98),('9650','2013-06-03','08:45:00',2.73),('9650','2013-06-03','08:50:00',2.4),('9650','2013-06-03','08:55:00',2.52),('9650','2013-06-03','09:00:00',2.66),('9650','2013-06-03','09:05:00',2.69),('9650','2013-06-03','09:10:00',3.5),('9650','2013-06-03','09:15:00',4.25),('9650','2013-06-03','09:20:00',4.56),('9650','2013-06-03','09:25:00',4.17),('9650','2013-06-03','09:30:00',4.65),('9650','2013-06-03','09:35:00',3.41),('9650','2013-06-03','09:40:00',2.8),('9650','2013-06-03','09:45:00',3.04),('9650','2013-06-03','09:50:00',3.11),('9650','2013-06-03','09:55:00',2.98),('9650','2013-06-03','10:00:00',3.5),('9650','2013-06-03','10:05:00',4.29),('9650','2013-06-03','10:10:00',4.1),('9650','2013-06-03','10:15:00',3.14),('9650','2013-06-03','10:20:00',3.23),('9650','2013-06-03','10:25:00',3.13),('9650','2013-06-03','10:30:00',2.96),('9650','2013-06-03','10:35:00',3.03),('9650','2013-06-03','10:40:00',3.3),('9650','2013-06-03','10:45:00',3.84),('9650','2013-06-03','10:50:00',5.13),('9650','2013-06-03','10:55:00',4.62),('9650','2013-06-03','11:00:00',3.67),('9650','2013-06-03','11:05:00',4.58),('9650','2013-06-03','11:10:00',5.93),('9650','2013-06-03','11:15:00',5.07),('9650','2013-06-03','11:20:00',3.77),('9650','2013-06-03','11:25:00',4.58),('9650','2013-06-03','11:30:00',5.51),('9650','2013-06-03','11:35:00',4.89),('9650','2013-06-03','11:40:00',5.16),('9650','2013-06-03','11:45:00',6.2),('9650','2013-06-03','11:50:00',7.6),('9650','2013-06-03','11:55:00',7),('9650','2013-06-03','12:00:00',4.16),('9650','2013-06-03','12:05:00',6.88),('9650','2013-06-03','12:10:00',4.32),('9650','2013-06-03','12:15:00',4.31),('9650','2013-06-03','12:20:00',3.12),('9650','2013-06-03','12:25:00',3.34),('9650','2013-06-03','12:30:00',5.15),('9650','2013-06-03','12:35:00',6.33),('9650','2013-06-03','12:40:00',4.06),('9650','2013-06-03','12:45:00',5.27),('9650','2013-06-03','12:50:00',4.14),('9650','2013-06-03','12:55:00',3.37),('9650','2013-06-03','13:00:00',3.04),('9650','2013-06-03','13:05:00',2.44),('9650','2013-06-03','13:10:00',2.41),('9650','2013-06-03','13:15:00',2.03),('9650','2013-06-03','13:20:00',2.14),('9650','2013-06-03','13:25:00',2.69),('9650','2013-06-03','13:30:00',3.53),('9650','2013-06-03','13:35:00',4.99),('9650','2013-06-03','13:40:00',6.54),('9650','2013-06-03','13:45:00',6.12),('9650','2013-06-03','13:50:00',6.09),('9650','2013-06-03','13:55:00',7),('9650','2013-06-03','14:00:00',3.95),('9650','2013-06-03','14:05:00',6.99),('9650','2013-06-03','14:10:00',8.21),('9650','2013-06-03','14:15:00',3.73),('9650','2013-06-03','14:20:00',8.43),('9650','2013-06-03','14:25:00',3.39),('9650','2013-06-03','14:30:00',2.21),('9650','2013-06-03','14:35:00',2.93),('9650','2013-06-03','14:40:00',4.7),('9650','2013-06-03','14:45:00',2.18),('9650','2013-06-03','14:50:00',2.26),('9650','2013-06-03','14:55:00',7.42),('9650','2013-06-03','15:00:00',8.92),('9650','2013-06-03','15:05:00',7.57),('9650','2013-06-03','15:10:00',2.69),('9650','2013-06-03','15:15:00',2.67),('9650','2013-06-03','15:20:00',2.05),('9650','2013-06-03','15:25:00',1.45),('9650','2013-06-03','17:15:00',1.59),('9650','2013-06-03','17:20:00',1.44),('9650','2013-06-03','17:25:00',1.14),('9650','2013-06-03','17:35:00',1.32),('9650','2013-06-03','17:40:00',2.4),('9650','2013-06-03','17:45:00',1.22),('9650','2013-06-03','17:50:00',1.15),('9650','2013-06-03','17:55:00',1.3),('9650','2013-06-03','18:00:00',1.42),('9650','2013-06-03','18:05:00',1.71),('9650','2013-06-03','18:10:00',1.72),('9650','2013-06-03','18:15:00',1.53),('9650','2013-06-03','18:20:00',1.4),('9650','2013-06-03','18:25:00',1.25),('9650','2013-06-03','18:30:00',1.29),('9650','2013-06-03','18:35:00',1.05),('9650','2013-06-03','18:40:00',1.99),('9650','2013-06-03','18:45:00',2.28),('9650','2013-06-03','18:50:00',1.74),('9650','2013-06-03','18:55:00',1.26),('9650','2013-06-03','19:00:00',1.1),('9650','2013-06-03','19:05:00',1.07),('9650','2013-06-02','07:45:00',1.04),('9650','2013-06-02','07:50:00',1.16),('9650','2013-06-02','07:55:00',1.22),('9650','2013-06-02','08:00:00',1.27),('9650','2013-06-02','08:05:00',1.31),('9650','2013-06-02','08:10:00',1.33),('9650','2013-06-02','08:15:00',1.38),('9650','2013-06-02','08:20:00',1.69),('9650','2013-06-02','08:25:00',1.86),('9650','2013-06-02','08:30:00',2.02),('9650','2013-06-02','08:35:00',2.17),('9650','2013-06-02','08:40:00',2.3),('9650','2013-06-02','08:45:00',2.42),('9650','2013-06-02','08:50:00',2.6),('9650','2013-06-02','08:55:00',2.75),('9650','2013-06-02','09:00:00',2.87),('9650','2013-06-02','09:05:00',3),('9650','2013-06-02','09:10:00',3.24),('9650','2013-06-02','09:15:00',3.57),('9650','2013-06-02','09:20:00',4.2),('9650','2013-06-02','09:25:00',3.79),('9650','2013-06-02','09:30:00',3.22),('9650','2013-06-02','09:35:00',2.84),('9650','2013-06-02','09:40:00',4.09),('9650','2013-06-02','09:45:00',4.89),('9650','2013-06-02','09:50:00',3.99),('9650','2013-06-02','09:55:00',5.94),('9650','2013-06-02','10:00:00',5.66),('9650','2013-06-02','10:05:00',6.17),('9650','2013-06-02','10:10:00',4.01),('9650','2013-06-02','10:15:00',2.16),('9650','2013-06-02','10:20:00',1.55),('9650','2013-06-02','10:25:00',1.51),('9650','2013-06-02','10:30:00',1.78),('9650','2013-06-02','10:35:00',1.98),('9650','2013-06-02','10:40:00',2.21),('9650','2013-06-02','10:45:00',3.06),('9650','2013-06-02','10:50:00',3.73),('9650','2013-06-02','10:55:00',4.79),('9650','2013-06-02','11:00:00',4.25),('9650','2013-06-02','11:05:00',3.68),('9650','2013-06-02','11:10:00',2.55),('9650','2013-06-02','11:15:00',2.21),('9650','2013-06-02','11:20:00',2.64),('9650','2013-06-02','11:25:00',2.56),('9650','2013-06-02','11:30:00',2.8),('9650','2013-06-02','11:35:00',2.3),('9650','2013-06-02','11:40:00',2.34),('9650','2013-06-02','11:45:00',3),('9650','2013-06-02','11:50:00',2.72),('9650','2013-06-02','11:55:00',2.77),('9650','2013-06-02','12:00:00',2.89),('9650','2013-06-02','12:05:00',2.69),('9650','2013-06-02','12:10:00',2.85),('9650','2013-06-02','12:15:00',3.06),('9650','2013-06-02','12:20:00',2.93),('9650','2013-06-02','12:25:00',2.24),('9650','2013-06-02','12:30:00',2.58),('9650','2013-06-02','12:35:00',4.97),('9650','2013-06-02','12:40:00',8.07),('9650','2013-06-02','12:45:00',5.01),('9650','2013-06-02','12:50:00',3.75),('9650','2013-06-02','12:55:00',6.69),('9650','2013-06-02','13:00:00',4.29),('9650','2013-06-02','13:05:00',3.73),('9650','2013-06-02','13:10:00',3.67),('9650','2013-06-02','13:15:00',7.91),('9650','2013-06-02','13:20:00',9.48),('9650','2013-06-02','13:25:00',9.05),('9650','2013-06-02','13:30:00',6.13),('9650','2013-06-02','13:35:00',8.5),('9650','2013-06-02','13:40:00',8.24),('9650','2013-06-02','13:45:00',6.73),('9650','2013-06-02','13:50:00',7.7),('9650','2013-06-02','13:55:00',3.3),('9650','2013-06-02','14:00:00',6.76),('9650','2013-06-02','14:05:00',6.01),('9650','2013-06-02','14:10:00',3.95),('9650','2013-06-02','14:15:00',4.94),('9650','2013-06-02','14:20:00',5.13),('9650','2013-06-02','14:25:00',5.48),('9650','2013-06-02','14:30:00',8.69),('9650','2013-06-02','14:35:00',8.59),('9650','2013-06-02','14:40:00',7),('9650','2013-06-02','14:45:00',4.81),('9650','2013-06-02','14:50:00',5.15),('9650','2013-06-02','14:55:00',6.18),('9650','2013-06-02','15:00:00',7.75),('9650','2013-06-02','15:05:00',7.76),('9650','2013-06-02','15:10:00',7.39),('9650','2013-06-02','15:15:00',8.66),('9650','2013-06-02','15:20:00',6.03),('9650','2013-06-02','15:25:00',7.6),('9650','2013-06-02','15:30:00',7.75),('9650','2013-06-02','15:35:00',7.67),('9650','2013-06-02','15:40:00',7.55),('9650','2013-06-02','15:45:00',7.45),('9650','2013-06-02','15:50:00',7.45),('9650','2013-06-02','15:55:00',7.43),('9650','2013-06-02','16:00:00',7.36),('9650','2013-06-02','16:05:00',7.33),('9650','2013-06-02','16:10:00',7.41),('9650','2013-06-02','16:15:00',7.22),('9650','2013-06-02','16:20:00',6.84),('9650','2013-06-02','16:25:00',7.04),('9650','2013-06-02','16:30:00',7.49),('9650','2013-06-02','16:35:00',7.11),('9650','2013-06-02','16:40:00',7.17),('9650','2013-06-02','16:45:00',6.03),('9650','2013-06-02','16:50:00',4.9),('9650','2013-06-02','16:55:00',4.06),('9650','2013-06-02','17:00:00',5.67),('9650','2013-06-02','17:05:00',6.64),('9650','2013-06-02','17:10:00',6.64),('9650','2013-06-02','17:15:00',5.28),('9650','2013-06-02','17:20:00',4.52),('9650','2013-06-02','17:25:00',3.11),('9650','2013-06-02','17:30:00',1.54),('9650','2013-06-02','17:35:00',1.21),('9650','2013-06-02','17:40:00',1.29),('9650','2013-06-02','17:45:00',1.08),('9650','2013-06-02','17:50:00',1.13),('9650','2013-06-02','17:55:00',1.14),('9650','2013-06-01','06:55:00',1.13),('9650','2013-06-01','07:00:00',1.05),('9650','2013-06-01','08:20:00',1.04),('9650','2013-06-01','08:25:00',1.44),('9650','2013-06-01','08:30:00',1.47),('9650','2013-06-01','08:35:00',1.58),('9650','2013-06-01','08:40:00',1.57),('9650','2013-06-01','08:45:00',1.81),('9650','2013-06-01','08:50:00',1.78),('9650','2013-06-01','08:55:00',1.62),('9650','2013-06-01','09:00:00',1.66),('9650','2013-06-01','09:05:00',1.8),('9650','2013-06-01','09:10:00',1.82),('9650','2013-06-01','09:15:00',1.73),('9650','2013-06-01','09:20:00',2.42),('9650','2013-06-01','09:25:00',3.85),('9650','2013-06-01','09:30:00',3.87),('9650','2013-06-01','09:35:00',3.91),('9650','2013-06-01','09:40:00',3.84),('9650','2013-06-01','09:45:00',4.12),('9650','2013-06-01','09:50:00',4.26),('9650','2013-06-01','09:55:00',4.42),('9650','2013-06-01','10:00:00',4.49),('9650','2013-06-01','10:05:00',4.63),('9650','2013-06-01','10:10:00',4.67),('9650','2013-06-01','10:15:00',4.81),('9650','2013-06-01','10:20:00',4.96),('9650','2013-06-01','10:25:00',4.82),('9650','2013-06-01','10:30:00',2.8),('9650','2013-06-01','10:35:00',4.2),('9650','2013-06-01','10:40:00',4.06),('9650','2013-06-01','10:45:00',4.57),('9650','2013-06-01','10:50:00',2.23),('9650','2013-06-01','10:55:00',6.58),('9650','2013-06-01','11:00:00',6.84),('9650','2013-06-01','11:05:00',7.25),('9650','2013-06-01','11:10:00',3.22),('9650','2013-06-01','11:15:00',4.43),('9650','2013-06-01','11:20:00',5.76),('9650','2013-06-01','11:25:00',6.17),('9650','2013-06-01','11:30:00',3.71),('9650','2013-06-01','11:35:00',2.99),('9650','2013-06-01','11:50:00',2.6),('9650','2013-06-01','11:55:00',6.82),('9650','2013-06-01','12:00:00',3.1),('9650','2013-06-01','12:05:00',2.53),('9650','2013-06-01','12:10:00',4.41),('9650','2013-06-01','12:15:00',6.09),('9650','2013-06-01','12:20:00',3.26),('9650','2013-06-01','12:25:00',5.38),('9650','2013-06-01','12:30:00',5.64),('9650','2013-06-01','12:35:00',7.01),('9650','2013-06-01','12:40:00',4.69),('9650','2013-06-01','12:45:00',6.89),('9650','2013-06-01','12:50:00',2.45),('9650','2013-06-01','12:55:00',6.58),('9650','2013-06-01','13:00:00',3.45),('9650','2013-06-01','13:05:00',2.69),('9650','2013-06-01','13:10:00',5.34),('9650','2013-06-01','13:15:00',8.16),('9650','2013-06-01','13:20:00',7.83),('9650','2013-06-01','13:25:00',7.7),('9650','2013-06-01','13:30:00',7.69),('9650','2013-06-01','13:35:00',7.69),('9650','2013-06-01','13:40:00',7.68),('9650','2013-06-01','13:45:00',7.71),('9650','2013-06-01','13:50:00',7.71),('9650','2013-06-01','13:55:00',7.75),('9650','2013-06-01','14:00:00',7.74),('9650','2013-06-01','14:05:00',7.77),('9650','2013-06-01','14:10:00',7.92),('9650','2013-06-01','14:15:00',7.84),('9650','2013-06-01','14:20:00',7.82),('9650','2013-06-01','14:25:00',7.81),('9650','2013-06-01','14:30:00',7.83),('9650','2013-06-01','14:35:00',7.83),('9650','2013-06-01','14:40:00',7.79),('9650','2013-06-01','14:45:00',7.79),('9650','2013-06-01','14:50:00',7.8),('9650','2013-06-01','14:55:00',7.71),('9650','2013-06-01','15:00:00',7.71),('9650','2013-06-01','15:05:00',7.69),('9650','2013-06-01','15:10:00',7.68),('9650','2013-06-01','15:15:00',7.72),('9650','2013-06-01','15:20:00',6.41),('9650','2013-06-01','15:25:00',6.36),('9650','2013-06-01','15:30:00',7.35),('9650','2013-06-01','15:35:00',5.09),('9650','2013-06-01','15:40:00',5.44),('9650','2013-06-01','15:45:00',6.82),('9650','2013-06-01','15:50:00',5.01),('9650','2013-06-01','15:55:00',6.94),('9650','2013-06-01','16:00:00',7.7),('9650','2013-06-01','16:05:00',6.69),('9650','2013-06-01','16:10:00',7.14),('9650','2013-06-01','16:15:00',7.29),('9650','2013-06-01','16:20:00',7.33),('9650','2013-06-01','16:25:00',7.19),('9650','2013-06-01','16:30:00',6.98),('9650','2013-06-01','16:35:00',6.93),('9650','2013-06-01','16:40:00',6.95),('9650','2013-06-01','16:45:00',5.97),('9650','2013-06-01','16:50:00',6.66),('9650','2013-06-01','16:55:00',6.56),('9650','2013-06-01','17:00:00',6),('9650','2013-06-01','17:05:00',5.96),('9650','2013-06-01','17:10:00',6.25),('9650','2013-06-01','17:15:00',6.19),('9650','2013-06-01','17:20:00',5.86),('9650','2013-06-01','17:25:00',5.87),('9650','2013-06-01','17:30:00',4.53),('9650','2013-06-01','17:35:00',4.09),('9650','2013-06-01','17:40:00',3),('9650','2013-06-01','17:45:00',2.65),('9650','2013-06-01','17:50:00',4.07),('9650','2013-06-01','17:55:00',1.92),('9650','2013-06-01','18:00:00',1.71),('9650','2013-06-01','18:05:00',1.19),('9650','2013-06-01','18:10:00',1.52),('9650','2013-06-01','18:15:00',1.55),('9650','2013-06-01','18:20:00',1.21),('9650','2013-06-01','18:25:00',1.24),('9650','2013-06-01','18:30:00',1.5),('9650','2013-06-01','18:35:00',1.3),('9650','2013-06-01','18:40:00',1.15),('9650','2013-06-01','18:45:00',1.04),('9650','2013-06-01','18:50:00',1.01),('9650','2013-06-01','19:15:00',1.54),('9650','2013-06-01','19:20:00',2.17),('9650','2013-06-01','19:25:00',1.94),('9650','2013-06-01','19:30:00',1.55),('9650','2013-06-01','19:35:00',1.16),('9650','2013-05-31','07:45:00',1.22),('9650','2013-05-31','07:50:00',1.5),('9650','2013-05-31','07:55:00',1.92),('9650','2013-05-31','08:00:00',1.2),('9650','2013-05-31','08:05:00',1.14),('9650','2013-05-31','08:10:00',1.35),('9650','2013-05-31','08:15:00',1.84),('9650','2013-05-31','08:20:00',1.52),('9650','2013-05-31','08:25:00',1.29),('9650','2013-05-31','08:30:00',1.89),('9650','2013-05-31','08:35:00',2.1),('9650','2013-05-31','08:40:00',1.44),('9650','2013-05-31','08:45:00',1.07),('9650','2013-05-31','08:50:00',1.43),('9650','2013-05-31','08:55:00',1.3),('9650','2013-05-31','09:00:00',1.63),('9650','2013-05-31','09:05:00',1.08),('9650','2013-05-31','09:40:00',1.16),('9650','2013-05-31','09:45:00',1.57),('9650','2013-05-31','09:50:00',1.63),('9650','2013-05-31','09:55:00',1.18),('9650','2013-05-31','10:00:00',1.12),('9650','2013-05-31','10:05:00',1.29),('9650','2013-05-31','10:10:00',1.21),('9650','2013-05-31','10:30:00',1.35),('9650','2013-05-31','10:35:00',2.25),('9650','2013-05-31','10:40:00',1.99),('9650','2013-05-31','10:45:00',1.7),('9650','2013-05-31','10:50:00',4.18),('9650','2013-05-31','10:55:00',4.23),('9650','2013-05-31','11:00:00',1.15),('9650','2013-05-31','11:45:00',1.03),('9650','2013-05-31','11:50:00',2.47),('9650','2013-05-31','11:55:00',3.11),('9650','2013-05-31','12:00:00',5.45),('9650','2013-05-31','12:05:00',4.87),('9650','2013-05-31','12:10:00',5.27),('9650','2013-05-31','12:15:00',2.28),('9650','2013-05-31','12:20:00',1.6),('9650','2013-05-31','12:25:00',2.04),('9650','2013-05-31','12:30:00',1.99),('9650','2013-05-31','12:35:00',1.54),('9650','2013-05-31','12:40:00',1.86),('9650','2013-05-31','12:45:00',3.17),('9650','2013-05-31','12:50:00',3.61),('9650','2013-05-31','12:55:00',3.73),('9650','2013-05-31','13:00:00',3.92),('9650','2013-05-31','13:05:00',4.06),('9650','2013-05-31','13:10:00',4.28),('9650','2013-05-31','13:15:00',4.52),('9650','2013-05-31','13:20:00',3.84),('9650','2013-05-31','13:25:00',3.34),('9650','2013-05-31','13:30:00',2.91),('9650','2013-05-31','13:35:00',2.29),('9650','2013-05-31','13:40:00',1.98),('9650','2013-05-31','13:45:00',2.07),('9650','2013-05-31','13:50:00',2.27),('9650','2013-05-31','13:55:00',2.62),('9650','2013-05-31','14:00:00',3.65),('9650','2013-05-31','14:05:00',4.3),('9650','2013-05-31','14:10:00',4.31),('9650','2013-05-31','14:15:00',4.55),('9650','2013-05-31','14:20:00',4.38),('9650','2013-05-31','14:25:00',3.02),('9650','2013-05-31','14:30:00',2.53),('9650','2013-05-31','14:35:00',2.53),('9650','2013-05-31','14:40:00',2.3),('9650','2013-05-31','14:45:00',2.1),('9650','2013-05-31','14:50:00',2.01),('9650','2013-05-31','14:55:00',1.61),('9650','2013-05-31','15:00:00',1.61),('9650','2013-05-31','15:05:00',1.52),('9650','2013-05-31','15:10:00',1.3),('9650','2013-05-31','15:15:00',1.43),('9650','2013-05-31','15:20:00',1.34),('9650','2013-05-31','15:25:00',1.07),('9650','2013-05-31','15:45:00',1.15),('9650','2013-05-31','15:50:00',1.1),('9650','2013-05-31','15:55:00',1.2),('9650','2013-05-31','16:00:00',1.26),('9650','2013-05-31','16:05:00',1.35),('9650','2013-05-31','16:10:00',1.21),('9650','2013-05-31','16:15:00',1.36),('9650','2013-05-31','16:20:00',1.46),('9650','2013-05-31','16:25:00',1.17),('9650','2013-05-31','16:30:00',1.44),('9650','2013-05-31','16:35:00',1.54),('9650','2013-05-31','16:40:00',1.69),('9650','2013-05-31','16:45:00',1.45),('9650','2013-05-31','16:50:00',1.34),('9650','2013-05-31','16:55:00',1.15),('9650','2013-05-31','18:30:00',1.46),('9650','2013-05-31','18:35:00',1.73),('9650','2013-05-31','18:40:00',1.3),('9650','2013-05-31','18:45:00',1.28),('9650','2013-05-31','18:50:00',1.25),('9650','2013-05-31','18:55:00',2.12),('9650','2013-05-31','19:00:00',4.56),('9650','2013-05-31','19:05:00',2.35),('9650','2013-05-31','19:45:00',1.66),('9650','2013-05-31','19:50:00',1.28),('9650','2014-04-01','08:35:00',1.11),('9650','2014-04-01','08:40:00',1.23),('9650','2014-04-01','08:45:00',1.24),('9650','2014-04-01','08:50:00',1.58),('9650','2014-04-01','08:55:00',1.67),('9650','2014-04-01','09:00:00',1.22),('9650','2014-04-01','09:05:00',1.01),('9650','2014-04-01','09:10:00',1.08),('9650','2014-04-01','09:15:00',1.24),('9650','2014-04-01','09:20:00',1.18),('9650','2014-04-01','09:25:00',1.07),('9650','2014-04-01','09:30:00',1.05),('9650','2014-04-01','09:35:00',1.28),('9650','2014-04-01','09:40:00',1.25),('9650','2014-04-01','09:45:00',1.17),('9650','2014-04-01','09:50:00',1.28),('9650','2014-04-01','09:55:00',2.77),('9650','2014-04-01','10:00:00',2.57),('9650','2014-04-01','10:05:00',3.1),('9650','2014-04-01','10:10:00',3.67),('9650','2014-04-01','10:15:00',4.14),('9650','2014-04-01','10:20:00',4.07),('9650','2014-04-01','10:25:00',3.34),('9650','2014-04-01','10:30:00',2.39),('9650','2014-04-01','10:35:00',1.87),('9650','2014-04-01','10:40:00',2.08),('9650','2014-04-01','10:45:00',2.02),('9650','2014-04-01','10:50:00',3.19),('9650','2014-04-01','10:55:00',4.52),('9650','2014-04-01','11:00:00',4.36),('9650','2014-04-01','11:05:00',3.22),('9650','2014-04-01','11:10:00',1.88),('9650','2014-04-01','11:15:00',3.79),('9650','2014-04-01','11:20:00',4.52),('9650','2014-04-01','11:25:00',5.56),('9650','2014-04-01','11:30:00',5.77),('9650','2014-04-01','11:35:00',2.37),('9650','2014-04-01','11:40:00',1.98),('9650','2014-04-01','11:45:00',3.5),('9650','2014-04-01','11:50:00',5.13),('9650','2014-04-01','11:55:00',5.91),('9650','2014-04-01','12:00:00',6.73),('9650','2014-04-01','12:05:00',4.1),('9650','2014-04-01','12:10:00',2.03),('9650','2014-04-01','12:15:00',5.46),('9650','2014-04-01','12:20:00',6.25),('9650','2014-04-01','12:25:00',2.97),('9650','2014-04-01','12:30:00',5.74),('9650','2014-04-01','12:35:00',6.99),('9650','2014-04-01','12:40:00',6.28),('9650','2014-04-01','12:45:00',5.19),('9650','2014-04-01','12:50:00',6.69),('9650','2014-04-01','12:55:00',4.19),('9650','2014-04-01','13:00:00',3.81),('9650','2014-04-01','13:05:00',5.56),('9650','2014-04-01','13:10:00',6.32),('9650','2014-04-01','13:15:00',6.49),('9650','2014-04-01','13:20:00',6.43),('9650','2014-04-01','13:25:00',6.16),('9650','2014-04-01','13:30:00',6.68),('9650','2014-04-01','13:35:00',6.76),('9650','2014-04-01','13:40:00',7),('9650','2014-04-01','13:45:00',6.6),('9650','2014-04-01','13:50:00',6.6),('9650','2014-04-01','13:55:00',6.81),('9650','2014-04-01','14:00:00',6.66),('9650','2014-04-01','14:05:00',6.62),('9650','2014-04-01','14:10:00',6.59),('9650','2014-04-01','14:15:00',6.65),('9650','2014-04-01','14:20:00',6.69),('9650','2014-04-01','14:25:00',6.76),('9650','2014-04-01','14:30:00',6.68),('9650','2014-04-01','14:35:00',6.5),('9650','2014-04-01','14:40:00',6.5),('9650','2014-04-01','14:45:00',6.7),('9650','2014-04-01','14:50:00',5.95),('9650','2014-04-01','14:55:00',6.05),('9650','2014-04-01','15:00:00',6.26),('9650','2014-04-01','15:05:00',6.4),('9650','2014-04-01','15:10:00',5.8),('9650','2014-04-01','15:15:00',5.95),('9650','2014-04-01','15:20:00',6.03),('9650','2014-04-01','15:25:00',5.97),('9650','2014-04-01','15:30:00',5.66),('9650','2014-04-01','15:35:00',5.56),('9650','2014-04-01','15:40:00',5.74),('9650','2014-04-01','15:45:00',5.9),('9650','2014-04-01','15:50:00',5.76),('9650','2014-04-01','15:55:00',5.08),('9650','2014-04-01','16:00:00',5.3),('9650','2014-04-01','16:05:00',5.23),('9650','2014-04-01','16:10:00',5.25),('9650','2014-04-01','16:15:00',5.19),('9650','2014-04-01','16:20:00',5.02),('9650','2014-04-01','16:25:00',4.99),('9650','2014-04-01','16:30:00',4.95),('9650','2014-04-01','16:35:00',4.9),('9650','2014-04-01','16:40:00',4.79),('9650','2014-04-01','16:45:00',4.6),('9650','2014-04-01','16:50:00',4.2),('9650','2014-04-01','16:55:00',4.21),('9650','2014-04-01','17:00:00',4.42),('9650','2014-04-01','17:05:00',4.04),('9650','2014-04-01','17:10:00',3.92),('9650','2014-04-01','17:15:00',3.53),('9650','2014-04-01','17:20:00',3.64),('9650','2014-04-01','17:25:00',3.5),('9650','2014-04-01','17:30:00',3.22),('9650','2014-04-01','17:35:00',3.29),('9650','2014-04-01','17:40:00',2.46),('9650','2014-04-01','17:45:00',2.64),('9650','2014-04-01','17:50:00',3.27),('9650','2014-04-01','17:55:00',2.84),('9650','2014-04-01','18:00:00',2.69),('9650','2014-04-01','18:05:00',1.76),('9650','2014-04-01','18:10:00',1.59),('9650','2014-04-01','18:15:00',1.55),('9650','2014-04-01','18:20:00',1.74),('9650','2014-04-01','18:25:00',1.63),('9650','2014-04-01','18:30:00',1.25),('9650','2013-05-30','07:50:00',1.08),('9650','2013-05-30','07:55:00',1.24),('9650','2013-05-30','08:00:00',1.31),('9650','2013-05-30','08:05:00',1.3),('9650','2013-05-30','08:10:00',1.32),('9650','2013-05-30','08:15:00',1.35),('9650','2013-05-30','08:20:00',1.5),('9650','2013-05-30','08:25:00',1.89),('9650','2013-05-30','08:30:00',1.94),('9650','2013-05-30','08:35:00',2.33),('9650','2013-05-30','08:40:00',2.1),('9650','2013-05-30','08:45:00',1.82),('9650','2013-05-30','08:50:00',3.34),('9650','2013-05-30','08:55:00',1.88),('9650','2013-05-30','09:00:00',1.35),('9650','2013-05-30','09:05:00',1.16),('9650','2013-05-30','09:10:00',1.5),('9650','2013-05-30','09:15:00',2.21),('9650','2013-05-30','09:20:00',1.51),('9650','2013-05-30','09:25:00',1.61),('9650','2013-05-30','09:30:00',2.21),('9650','2013-05-30','09:35:00',3.1),('9650','2013-05-30','09:40:00',3.34),('9650','2013-05-30','09:45:00',4.36),('9650','2013-05-30','09:50:00',4.83),('9650','2013-05-30','09:55:00',4.9),('9650','2013-05-30','10:00:00',5.11),('9650','2013-05-30','10:05:00',3.85),('9650','2013-05-30','10:10:00',2.69),('9650','2013-05-30','10:15:00',5.12),('9650','2013-05-30','10:20:00',5.2),('9650','2013-05-30','10:25:00',2.25),('9650','2013-05-30','10:30:00',3.57),('9650','2013-05-30','10:35:00',2.75),('9650','2013-05-30','10:40:00',6.24),('9650','2013-05-30','10:45:00',6.66),('9650','2013-05-30','10:50:00',3.13),('9650','2013-05-30','10:55:00',6.57),('9650','2013-05-30','11:00:00',2.5),('9650','2013-05-30','11:05:00',3.14),('9650','2013-05-30','11:10:00',8.2),('9650','2013-05-30','11:15:00',7.43),('9650','2013-05-30','11:20:00',2.28),('9650','2013-05-30','11:25:00',4.3),('9650','2013-05-30','11:30:00',5.75),('9650','2013-05-30','11:35:00',4.24),('9650','2013-05-30','11:40:00',1.55),('9650','2013-05-30','11:45:00',7.23),('9650','2013-05-30','11:50:00',6.17),('9650','2013-05-30','11:55:00',5.48),('9650','2013-05-30','12:00:00',2.93),('9650','2013-05-30','12:05:00',8.2),('9650','2013-05-30','12:10:00',6.58),('9650','2013-05-30','12:15:00',2.86),('9650','2013-05-30','12:20:00',3.16),('9650','2013-05-30','12:25:00',6.03),('9650','2013-05-30','12:30:00',3),('9650','2013-05-30','12:35:00',4.19),('9650','2013-05-30','12:40:00',7.75),('9650','2013-05-30','12:45:00',3.47),('9650','2013-05-30','12:50:00',1.72),('9650','2013-05-30','12:55:00',2.74),('9650','2013-05-30','13:00:00',9.04),('9650','2013-05-30','13:05:00',3.08),('9650','2013-05-30','13:10:00',1.29),('9650','2013-05-30','13:15:00',1.44),('9650','2013-05-30','13:20:00',2.33),('9650','2013-05-30','13:25:00',3.32),('9650','2013-05-30','13:30:00',5.94),('9650','2013-05-30','13:35:00',8.24),('9650','2013-05-30','13:40:00',4.71),('9650','2013-05-30','13:45:00',2.52),('9650','2013-05-30','13:50:00',1.34),('9650','2013-05-30','13:55:00',2.4),('9650','2013-05-30','14:00:00',3.58),('9650','2013-05-30','14:05:00',1.62),('9650','2013-05-30','14:10:00',1.12),('9650','2013-05-30','14:15:00',1.09),('9650','2013-05-30','14:20:00',1.41),('9650','2013-05-30','14:25:00',1.94),('9650','2013-05-30','14:30:00',1.68),('9650','2013-05-30','14:45:00',1.31),('9650','2013-05-30','14:50:00',1.6),('9650','2013-05-30','14:55:00',1.09),('9650','2013-05-30','15:00:00',1.91),('9650','2013-05-30','15:05:00',2.91),('9650','2013-05-30','15:10:00',3.52),('9650','2013-05-30','15:15:00',5.3),('9650','2013-05-30','15:20:00',9.65),('9650','2013-05-30','15:25:00',6.78),('9650','2013-05-30','15:30:00',4.75),('9650','2013-05-30','15:35:00',3.91),('9650','2013-05-30','15:40:00',3.23),('9650','2013-05-30','15:45:00',3.02),('9650','2013-05-30','15:50:00',4.58),('9650','2013-05-30','15:55:00',4.14),('9650','2013-05-30','16:00:00',2.79),('9650','2013-05-30','16:05:00',2.29),('9650','2013-05-30','16:10:00',1.65),('9650','2013-05-30','16:15:00',1.59),('9650','2013-05-30','16:20:00',1.89),('9650','2013-05-30','16:25:00',2.41),('9650','2013-05-30','16:30:00',2.09),('9650','2013-05-30','16:35:00',1.78),('9650','2013-05-30','16:40:00',2.07),('9650','2013-05-30','16:45:00',2.16),('9650','2013-05-30','16:50:00',1.48),('9650','2013-05-30','16:55:00',1.09),('9650','2013-05-30','17:00:00',1.08),('9650','2013-05-30','17:05:00',1.08),('9650','2013-05-30','17:10:00',1.04),('9650','2013-05-30','17:15:00',1.09),('9650','2013-05-30','17:20:00',1.17),('9650','2013-05-30','17:25:00',1.23),('9650','2013-05-30','17:30:00',1.22),('9650','2013-05-30','17:35:00',1.09),('9650','2013-05-30','17:40:00',1),('9650','2013-05-30','17:45:00',1.02),('9650','2013-05-30','19:05:00',1.15),('9650','2013-05-30','19:10:00',1.13),('9650','2013-05-29','07:40:00',1.05),('9650','2013-05-29','07:45:00',1.22),('9650','2013-05-29','07:50:00',1.4),('9650','2013-05-29','07:55:00',1.28),('9650','2013-05-29','08:00:00',1.22),('9650','2013-05-29','08:10:00',1.27),('9650','2013-05-29','08:15:00',1.37),('9650','2013-05-29','08:20:00',1.51),('9650','2013-05-29','08:25:00',1.74),('9650','2013-05-29','08:30:00',1.24),('9650','2013-05-29','08:35:00',1.07),('9650','2013-05-29','08:40:00',2.3),('9650','2013-05-29','08:45:00',2.41),('9650','2013-05-29','08:50:00',2.52),('9650','2013-05-29','08:55:00',2.66),('9650','2013-05-29','09:00:00',2.8),('9650','2013-05-29','09:05:00',2.73),('9650','2013-05-29','09:10:00',3.11),('9650','2013-05-29','09:15:00',3.3),('9650','2013-05-29','09:20:00',3.53),('9650','2013-05-29','09:25:00',3.77),('9650','2013-05-29','09:30:00',3.93),('9650','2013-05-29','09:35:00',4.07),('9650','2013-05-29','09:40:00',4.48),('9650','2013-05-29','09:45:00',3.97),('9650','2013-05-29','09:50:00',5.36),('9650','2013-05-29','09:55:00',3.16),('9650','2013-05-29','10:00:00',2.19),('9650','2013-05-29','10:05:00',2.86),('9650','2013-05-29','10:10:00',4.61),('9650','2013-05-29','10:15:00',3.16),('9650','2013-05-29','10:20:00',6.12),('9650','2013-05-29','10:25:00',1.92),('9650','2013-05-29','10:30:00',2.17),('9650','2013-05-29','10:35:00',2.25),('9650','2013-05-29','10:40:00',4.33),('9650','2013-05-29','10:45:00',6.31),('9650','2013-05-29','10:50:00',5.94),('9650','2013-05-29','10:55:00',4.4),('9650','2013-05-29','11:00:00',7.24),('9650','2013-05-29','11:05:00',7.22),('9650','2013-05-29','11:10:00',2.1),('9650','2013-05-29','11:15:00',3.02),('9650','2013-05-29','11:20:00',5.71),('9650','2013-05-29','11:25:00',2.95),('9650','2013-05-29','11:30:00',6.21),('9650','2013-05-29','11:35:00',7.82),('9650','2013-05-29','11:40:00',7.42),('9650','2013-05-29','11:45:00',6.81),('9650','2013-05-29','11:50:00',7.11),('9650','2013-05-29','11:55:00',1.88),('9650','2013-05-29','12:00:00',8.09),('9650','2013-05-29','12:05:00',8.5),('9650','2013-05-29','12:10:00',3.39),('9650','2013-05-29','12:15:00',8.35),('9650','2013-05-29','12:20:00',5.47),('9650','2013-05-29','12:25:00',7.44),('9650','2013-05-29','12:30:00',6.28),('9650','2013-05-29','12:35:00',5.06),('9650','2013-05-29','12:40:00',8.32),('9650','2013-05-29','12:45:00',4.66),('9650','2013-05-29','12:50:00',6.76),('9650','2013-05-29','12:55:00',8.36),('9650','2013-05-29','13:00:00',7.49),('9650','2013-05-29','13:05:00',7.17),('9650','2013-05-29','13:10:00',3.98),('9650','2013-05-29','13:15:00',4.56),('9650','2013-05-29','13:20:00',3.55),('9650','2013-05-29','13:25:00',3.06),('9650','2013-05-29','13:30:00',3.82),('9650','2013-05-29','13:35:00',3.41),('9650','2013-05-29','13:40:00',8.24),('9650','2013-05-29','13:45:00',8.91),('9650','2013-05-29','13:50:00',3),('9650','2013-05-29','13:55:00',2.97),('9650','2013-05-29','14:00:00',7.14),('9650','2013-05-29','14:05:00',9.37),('9650','2013-05-29','14:10:00',6.65),('9650','2013-05-29','14:15:00',8.62),('9650','2013-05-29','14:20:00',6.19),('9650','2013-05-29','14:25:00',8.09),('9650','2013-05-29','14:30:00',8.65),('9650','2013-05-29','14:35:00',7.21),('9650','2013-05-29','14:40:00',8.72),('9650','2013-05-29','14:45:00',8.82),('9650','2013-05-29','14:50:00',8.73),('9650','2013-05-29','14:55:00',8.31),('9650','2013-05-29','15:00:00',8.37),('9650','2013-05-29','15:05:00',6.28),('9650','2013-05-29','15:10:00',3.66),('9650','2013-05-29','15:15:00',8.22),('9650','2013-05-29','15:20:00',8.58),('9650','2013-05-29','15:25:00',8.3),('9650','2013-05-29','15:30:00',8.23),('9650','2013-05-29','15:35:00',7.89),('9650','2013-05-29','15:40:00',8.54),('9650','2013-05-29','15:45:00',8.68),('9650','2013-05-29','15:50:00',4.92),('9650','2013-05-29','15:55:00',7.01),('9650','2013-05-29','16:00:00',7.86),('9650','2013-05-29','16:05:00',8.57),('9650','2013-05-29','16:10:00',7.97),('9650','2013-05-29','16:15:00',7.75),('9650','2013-05-29','16:20:00',7.2),('9650','2013-05-29','16:25:00',5.06),('9650','2013-05-29','16:30:00',2.5),('9650','2013-05-29','16:35:00',4.41),('9650','2013-05-29','16:40:00',2.32),('9650','2013-05-29','16:45:00',5.95),('9650','2013-05-29','16:50:00',6.05),('9650','2013-05-29','16:55:00',4.99),('9650','2013-05-29','17:00:00',3.88),('9650','2013-05-29','17:05:00',4.18),('9650','2013-05-29','17:10:00',1.49),('9650','2013-05-29','17:15:00',1.79),('9650','2013-05-29','17:20:00',2.19),('9650','2013-05-29','17:25:00',1.84),('9650','2013-05-29','17:30:00',2),('9650','2013-05-29','17:35:00',1.17),('9650','2013-05-29','18:00:00',1.55),('9650','2013-05-29','18:05:00',2.05),('9650','2013-05-29','18:10:00',3.32),('9650','2013-05-29','18:15:00',2.06),('9650','2013-05-29','18:20:00',1.57),('9650','2013-05-29','18:25:00',1.68),('9650','2013-05-29','18:30:00',1.99),('9650','2013-05-29','18:35:00',3.59),('9650','2013-05-29','18:40:00',3.44),('9650','2013-05-29','18:45:00',3.78),('9650','2013-05-29','18:50:00',3.62),('9650','2013-05-29','18:55:00',1.44),('9650','2013-05-29','19:00:00',1.03),('9650','2013-05-28','08:00:00',1.07),('9650','2013-05-28','08:05:00',1.16),('9650','2013-05-28','08:10:00',1.3),('9650','2013-05-28','08:15:00',1.41),('9650','2013-05-28','08:20:00',1.54),('9650','2013-05-28','08:25:00',1.72),('9650','2013-05-28','08:30:00',1.88),('9650','2013-05-28','08:35:00',2.06),('9650','2013-05-28','08:40:00',2.18),('9650','2013-05-28','08:45:00',2.32),('9650','2013-05-28','08:50:00',2.45),('9650','2013-05-28','08:55:00',2.6),('9650','2013-05-28','09:00:00',2.72),('9650','2013-05-28','09:05:00',2.86),('9650','2013-05-28','09:10:00',3.01),('9650','2013-05-28','09:15:00',3.16),('9650','2013-05-28','09:20:00',3.29),('9650','2013-05-28','09:25:00',3.47),('9650','2013-05-28','09:30:00',3.62),('9650','2013-05-28','09:35:00',3.78),('9650','2013-05-28','09:40:00',3.93),('9650','2013-05-28','09:45:00',4.05),('9650','2013-05-28','09:50:00',4.2),('9650','2013-05-28','09:55:00',4.36),('9650','2013-05-28','10:00:00',4.45),('9650','2013-05-28','10:05:00',4.55),('9650','2013-05-28','10:10:00',4.62),('9650','2013-05-28','10:15:00',4.8),('9650','2013-05-28','10:20:00',4.95),('9650','2013-05-28','10:25:00',5.04),('9650','2013-05-28','10:30:00',5.18),('9650','2013-05-28','10:35:00',5.37),('9650','2013-05-28','10:40:00',5.46),('9650','2013-05-28','10:45:00',5.58),('9650','2013-05-28','10:50:00',5.71),('9650','2013-05-28','10:55:00',5.83),('9650','2013-05-28','11:00:00',5.91),('9650','2013-05-28','11:05:00',5.83),('9650','2013-05-28','11:10:00',5.96),('9650','2013-05-28','11:15:00',4.91),('9650','2013-05-28','11:20:00',6.83),('9650','2013-05-28','11:25:00',7.21),('9650','2013-05-28','11:30:00',6.82),('9650','2013-05-28','11:35:00',7.14),('9650','2013-05-28','11:40:00',5.97),('9650','2013-05-28','11:45:00',5.57),('9650','2013-05-28','11:50:00',5.52),('9650','2013-05-28','11:55:00',7.09),('9650','2013-05-28','12:00:00',5.56),('9650','2013-05-28','12:05:00',4.36),('9650','2013-05-28','12:10:00',7.44),('9650','2013-05-28','12:15:00',5.27),('9650','2013-05-28','12:20:00',7.45),('9650','2013-05-28','12:25:00',7.46),('9650','2013-05-28','12:30:00',7.37),('9650','2013-05-28','12:35:00',7.39),('9650','2013-05-28','12:40:00',6.18),('9650','2013-05-28','12:45:00',7.52),('9650','2013-05-28','12:50:00',7.17),('9650','2013-05-28','12:55:00',7.5),('9650','2013-05-28','13:00:00',7.67),('9650','2013-05-28','13:05:00',7.38),('9650','2013-05-28','13:10:00',6.61),('9650','2013-05-28','13:15:00',6.66),('9650','2013-05-28','13:20:00',6.46),('9650','2013-05-28','13:25:00',8.83),('9650','2013-05-28','13:30:00',8.45),('9650','2013-05-28','13:35:00',6.64),('9650','2013-05-28','13:40:00',8.29),('9650','2013-05-28','13:45:00',7.46),('9650','2013-05-28','13:50:00',7.13),('9650','2013-05-28','13:55:00',6.44),('9650','2013-05-28','14:00:00',8.11),('9650','2013-05-28','14:05:00',7.78),('9650','2013-05-28','14:10:00',7.71),('9650','2013-05-28','14:15:00',7.98),('9650','2013-05-28','14:20:00',8.07),('9650','2013-05-28','14:25:00',7.29),('9650','2013-05-28','14:30:00',8.03),('9650','2013-05-28','14:35:00',5.59),('9650','2013-05-28','14:40:00',8.47),('9650','2013-05-28','14:45:00',8.36),('9650','2013-05-28','14:50:00',7.37),('9650','2013-05-28','14:55:00',7.58),('9650','2013-05-28','15:00:00',8.4),('9650','2013-05-28','15:05:00',8),('9650','2013-05-28','15:10:00',6.66),('9650','2013-05-28','15:15:00',5.25),('9650','2013-05-28','15:20:00',6.73),('9650','2013-05-28','15:25:00',5.41),('9650','2013-05-28','15:30:00',6.13),('9650','2013-05-28','15:35:00',6.23),('9650','2013-05-28','15:40:00',4.8),('9650','2013-05-28','15:45:00',5.8),('9650','2013-05-28','15:50:00',5.67),('9650','2013-05-28','15:55:00',5.62),('9650','2013-05-28','16:00:00',5.19),('9650','2013-05-28','16:05:00',5.21),('9650','2013-05-28','16:10:00',4.53),('9650','2013-05-28','16:15:00',4.35),('9650','2013-05-28','16:20:00',4.28),('9650','2013-05-28','16:25:00',4.39),('9650','2013-05-28','16:30:00',3.62),('9650','2013-05-28','16:35:00',3.67),('9650','2013-05-28','16:40:00',4.45),('9650','2013-05-28','16:45:00',3.9),('9650','2013-05-28','16:50:00',2.94),('9650','2013-05-28','16:55:00',2.71),('9650','2013-05-28','17:00:00',2.44),('9650','2013-05-28','17:05:00',1.31),('9650','2013-05-28','17:25:00',1.06),('9650','2013-05-28','17:30:00',1.45),('9650','2013-05-28','17:35:00',2.35),('9650','2013-05-28','17:40:00',3.47),('9650','2013-05-28','17:45:00',2.19),('9650','2013-05-28','17:50:00',1.56),('9650','2013-05-28','17:55:00',1.29),('9650','2013-05-28','18:00:00',1.98),('9650','2013-05-28','18:05:00',2.72),('9650','2013-05-28','18:10:00',3.26),('9650','2013-05-28','18:15:00',5.77),('9650','2013-05-28','18:20:00',3.54),('9650','2013-05-28','18:25:00',1.28),('9650','2013-05-28','19:05:00',2.03),('9650','2013-05-28','19:10:00',1.96),('9650','2013-05-28','19:15:00',1.85),('9650','2013-05-28','19:20:00',1.42),('9650','2013-05-28','19:25:00',1.12),('9650','2013-05-27','07:20:00',1.11),('9650','2013-05-27','07:25:00',1.17),('9650','2013-05-27','07:30:00',1.15),('9650','2013-05-27','07:35:00',1.16),('9650','2013-05-27','07:40:00',1.25),('9650','2013-05-27','07:45:00',1.31),('9650','2013-05-27','07:50:00',1.34),('9650','2013-05-27','07:55:00',1.32),('9650','2013-05-27','08:00:00',1.47),('9650','2013-05-27','08:05:00',1.63),('9650','2013-05-27','08:10:00',1.76),('9650','2013-05-27','08:15:00',1.98),('9650','2013-05-27','08:20:00',2.13),('9650','2013-05-27','08:25:00',2),('9650','2013-05-27','08:30:00',2.32),('9650','2013-05-27','08:35:00',2.32),('9650','2013-05-27','08:40:00',2.26),('9650','2013-05-27','08:45:00',2.23),('9650','2013-05-27','08:50:00',2.42),('9650','2013-05-27','08:55:00',2.41),('9650','2013-05-27','09:00:00',2.58),('9650','2013-05-27','09:05:00',2.79),('9650','2013-05-27','09:10:00',2.6),('9650','2013-05-27','09:15:00',2.51),('9650','2013-05-27','09:20:00',2.73),('9650','2013-05-27','09:25:00',2.99),('9650','2013-05-27','09:30:00',3.21),('9650','2013-05-27','09:35:00',3.31),('9650','2013-05-27','09:40:00',3.27),('9650','2013-05-27','09:45:00',3.17),('9650','2013-05-27','09:50:00',3.31),('9650','2013-05-27','09:55:00',3.61),('9650','2013-05-27','10:00:00',3.49),('9650','2013-05-27','10:05:00',3.69),('9650','2013-05-27','10:10:00',4.01),('9650','2013-05-27','10:15:00',4.19),('9650','2013-05-27','10:20:00',4.4),('9650','2013-05-27','10:25:00',4.36),('9650','2013-05-27','10:30:00',4.68),('9650','2013-05-27','10:35:00',4.77),('9650','2013-05-27','10:40:00',4.47),('9650','2013-05-27','10:45:00',4.07),('9650','2013-05-27','10:50:00',4.54),('9650','2013-05-27','10:55:00',4),('9650','2013-05-27','11:00:00',4.05),('9650','2013-05-27','11:05:00',3.89),('9650','2013-05-27','11:10:00',4.1),('9650','2013-05-27','11:15:00',3.72),('9650','2013-05-27','11:20:00',3.71),('9650','2013-05-27','11:25:00',3.79),('9650','2013-05-27','11:30:00',6.18),('9650','2013-05-27','11:35:00',4.72),('9650','2013-05-27','11:40:00',6.19),('9650','2013-05-27','11:45:00',5.34),('9650','2013-05-27','11:50:00',2.03),('9650','2013-05-27','11:55:00',3.07),('9650','2013-05-27','12:00:00',2.78),('9650','2013-05-27','12:15:00',4.13),('9650','2013-05-27','12:20:00',4.17),('9650','2013-05-27','12:25:00',4.28),('9650','2013-05-27','12:30:00',4.72),('9650','2013-05-27','12:35:00',4.58),('9650','2013-05-27','12:40:00',4.72),('9650','2013-05-27','12:45:00',5.21),('9650','2013-05-27','12:50:00',4.7),('9650','2013-05-27','12:55:00',4.85),('9650','2013-05-27','13:00:00',4.92),('9650','2013-05-27','13:05:00',5.27),('9650','2013-05-27','13:10:00',5.51),('9650','2013-05-27','13:15:00',4.67),('9650','2013-05-27','13:20:00',5.76),('9650','2013-05-27','13:25:00',3.17),('9650','2013-05-27','13:30:00',3.71),('9650','2013-05-27','13:35:00',3.22),('9650','2013-05-27','13:40:00',3.66),('9650','2013-05-27','13:45:00',3.52),('9650','2013-05-27','13:50:00',4.59),('9650','2013-05-27','13:55:00',4.53),('9650','2013-05-27','14:00:00',4.74),('9650','2013-05-27','14:05:00',5),('9650','2013-05-27','14:10:00',7.45),('9650','2013-05-27','14:15:00',7.22),('9650','2013-05-27','14:20:00',4.63),('9650','2013-05-27','14:25:00',5.04),('9650','2013-05-27','14:30:00',6.09),('9650','2013-05-27','14:35:00',5.43),('9650','2013-05-27','14:40:00',6.07),('9650','2013-05-27','14:45:00',7.06),('9650','2013-05-27','14:50:00',5.44),('9650','2013-05-27','14:55:00',4.97),('9650','2013-05-27','15:00:00',4.63),('9650','2013-05-27','15:05:00',6.91),('9650','2013-05-27','15:10:00',3.14),('9650','2013-05-27','15:15:00',4.85),('9650','2013-05-27','15:20:00',5.97),('9650','2013-05-27','15:25:00',4.38),('9650','2013-05-27','15:30:00',2.79),('9650','2013-05-27','15:35:00',2.88),('9650','2013-05-27','15:40:00',5.19),('9650','2013-05-27','15:45:00',7.44),('9650','2013-05-27','15:50:00',6.2),('9650','2013-05-27','15:55:00',4.47),('9650','2013-05-27','16:00:00',3.29),('9650','2013-05-27','16:05:00',2.71),('9650','2013-05-27','16:10:00',2.89),('9650','2013-05-27','16:15:00',3.25),('9650','2013-05-27','16:20:00',5.2),('9650','2013-05-27','16:25:00',4.77),('9650','2013-05-27','16:30:00',5.52),('9650','2013-05-27','16:35:00',6.9),('9650','2013-05-27','16:40:00',6.44),('9650','2013-05-27','16:45:00',6.19),('9650','2013-05-27','16:50:00',6.09),('9650','2013-05-27','16:55:00',6),('9650','2013-05-27','17:00:00',5.95),('9650','2013-05-27','17:05:00',5.84),('9650','2013-05-27','17:10:00',5.69),('9650','2013-05-27','17:15:00',5.63),('9650','2013-05-27','17:20:00',5.5),('9650','2013-05-27','17:25:00',5.34),('9650','2013-05-27','17:30:00',5.24),('9650','2013-05-27','17:35:00',5.06),('9650','2013-05-27','17:40:00',4.75),('9650','2013-05-27','17:45:00',4.78),('9650','2013-05-27','17:50:00',4.68),('9650','2013-05-27','17:55:00',4.59),('9650','2013-05-27','18:00:00',4.6),('9650','2013-05-27','18:05:00',4.43),('9650','2013-05-27','18:10:00',2.31),('9650','2013-05-27','18:15:00',1.63),('9650','2013-05-27','18:20:00',1.07),('9650','2013-05-27','18:25:00',1.14),('9650','2013-05-27','18:30:00',2.39),('9650','2013-05-27','18:35:00',3.64),('9650','2013-05-27','18:40:00',3.48),('9650','2013-05-27','18:45:00',3.29),('9650','2013-05-27','18:50:00',3.12),('9650','2013-05-27','18:55:00',2.96),('9650','2013-05-27','19:00:00',2.77),('9650','2013-05-27','19:05:00',2.62),('9650','2013-05-27','19:10:00',2.43),('9650','2013-05-27','19:15:00',2.16),('9650','2013-05-27','19:20:00',1.92),('9650','2013-05-27','19:25:00',1.75),('9650','2013-05-27','19:35:00',1.05),('9650','2013-05-27','19:40:00',1.18),('9650','2013-05-27','19:45:00',1.03),('9650','2013-05-26','08:00:00',1.12),('9650','2013-05-26','08:05:00',1.48),('9650','2013-05-26','08:10:00',1.71),('9650','2013-05-26','08:15:00',1.79),('9650','2013-05-26','08:20:00',1.43),('9650','2013-05-26','08:25:00',1.62),('9650','2013-05-26','08:30:00',1.91),('9650','2013-05-26','08:35:00',2.13),('9650','2013-05-26','08:40:00',2.3),('9650','2013-05-26','08:45:00',2.71),('9650','2013-05-26','08:50:00',2.89),('9650','2013-05-26','09:10:00',2.24),('9650','2013-05-26','09:15:00',3.55),('9650','2013-05-26','09:20:00',2.22),('9650','2013-05-26','09:25:00',2.75),('9650','2013-05-26','09:30:00',3.67),('9650','2013-05-26','09:35:00',3.96),('9650','2013-05-26','09:40:00',4.1),('9650','2013-05-26','09:45:00',4.3),('9650','2013-05-26','09:50:00',4.01),('9650','2013-05-26','09:55:00',4.74),('9650','2013-05-26','10:00:00',4.85),('9650','2013-05-26','10:05:00',4.7),('9650','2013-05-26','10:10:00',5.01),('9650','2013-05-26','10:15:00',5.18),('9650','2013-05-26','10:20:00',3.06),('9650','2013-05-26','10:25:00',5.15),('9650','2013-05-26','10:30:00',3.26),('9650','2013-05-26','10:35:00',2.06),('9650','2013-05-26','10:40:00',5.86),('9650','2013-05-26','10:45:00',3.39),('9650','2013-05-26','10:50:00',3.92),('9650','2013-05-26','10:55:00',2.7),('9650','2013-05-26','11:00:00',6.63),('9650','2013-05-26','11:05:00',4.45),('9650','2013-05-26','11:10:00',6.11),('9650','2013-05-26','11:15:00',3.11),('9650','2013-05-26','11:20:00',5.8),('9650','2013-05-26','11:25:00',5.56),('9650','2013-05-26','11:30:00',4.22),('9650','2013-05-26','11:35:00',2.3),('9650','2013-05-26','11:40:00',7.62),('9650','2013-05-26','11:45:00',4.17),('9650','2013-05-26','11:50:00',3.01),('9650','2013-05-26','11:55:00',4.31),('9650','2013-05-26','12:00:00',8.45),('9650','2013-05-26','12:05:00',3.23),('9650','2013-05-26','12:10:00',7.94),('9650','2013-05-26','12:15:00',7.28),('9650','2013-05-26','12:20:00',9.1),('9650','2013-05-26','12:25:00',6.53),('9650','2013-05-26','12:30:00',7.73),('9650','2013-05-26','12:35:00',5.04),('9650','2013-05-26','12:40:00',8.59),('9650','2013-05-26','12:45:00',3.99),('9650','2013-05-26','12:50:00',7.96),('9650','2013-05-26','12:55:00',6.52),('9650','2013-05-26','13:00:00',3.51),('9650','2013-05-26','13:05:00',3.75),('9650','2013-05-26','13:10:00',8.28),('9650','2013-05-26','13:15:00',2.39),('9650','2013-05-26','13:20:00',7.75),('9650','2013-05-26','13:25:00',8.27),('9650','2013-05-26','13:30:00',8.31),('9650','2013-05-26','13:35:00',5),('9650','2013-05-26','13:40:00',8.83),('9650','2013-05-26','13:45:00',7.18),('9650','2013-05-26','13:50:00',8.32),('9650','2013-05-26','13:55:00',8.17),('9650','2013-05-26','14:00:00',7.86),('9650','2013-05-26','14:05:00',8.07),('9650','2013-05-26','14:10:00',6.85),('9650','2013-05-26','14:15:00',6.84),('9650','2013-05-26','14:20:00',4.74),('9650','2013-05-26','14:25:00',8.05),('9650','2013-05-26','14:30:00',6.76),('9650','2013-05-26','14:35:00',6.84),('9650','2013-05-26','14:40:00',4.84),('9650','2013-05-26','14:45:00',8.82),('9650','2013-05-26','14:50:00',8.37),('9650','2013-05-26','14:55:00',7.17),('9650','2013-05-26','15:00:00',5.35),('9650','2013-05-26','15:05:00',5.02),('9650','2013-05-26','15:10:00',8.23),('9650','2013-05-26','15:15:00',5.67),('9650','2013-05-26','15:20:00',6.88),('9650','2013-05-26','15:25:00',6.45),('9650','2013-05-26','15:30:00',7.36),('9650','2013-05-26','15:35:00',8.27),('9650','2013-05-26','15:40:00',6.63),('9650','2013-05-26','15:45:00',6.02),('9650','2013-05-26','15:50:00',7.43),('9650','2013-05-26','15:55:00',5.05),('9650','2013-05-26','16:00:00',6.22),('9650','2013-05-26','16:05:00',4.18),('9650','2013-05-26','16:10:00',4.55),('9650','2013-05-26','16:15:00',4.61),('9650','2013-05-26','16:20:00',7.81),('9650','2013-05-26','16:25:00',7.58),('9650','2013-05-26','16:30:00',7.27),('9650','2013-05-26','16:35:00',6.27),('9650','2013-05-26','16:40:00',2.86),('9650','2013-05-26','16:45:00',2.45),('9650','2013-05-26','16:50:00',2.42),('9650','2013-05-26','16:55:00',2.54),('9650','2013-05-26','17:00:00',2.71),('9650','2013-05-26','17:05:00',2.9),('9650','2013-05-26','17:10:00',3.85),('9650','2013-05-26','17:15:00',2.88),('9650','2013-05-26','17:20:00',2.43),('9650','2013-05-26','17:25:00',2.21),('9650','2013-05-26','17:30:00',2.16),('9650','2013-05-26','17:35:00',1.99),('9650','2013-05-26','17:40:00',1.85),('9650','2013-05-26','17:45:00',1.74),('9650','2013-05-26','17:50:00',1.66),('9650','2013-05-26','17:55:00',1.69),('9650','2013-05-26','18:00:00',1.64),('9650','2013-05-26','18:05:00',1.53),('9650','2013-05-26','18:10:00',1.72),('9650','2013-05-26','18:15:00',1.97),('9650','2013-05-26','18:20:00',3.08),('9650','2013-05-26','18:25:00',5.25),('9650','2013-05-26','18:30:00',4.09),('9650','2013-05-26','18:35:00',3.03),('9650','2013-05-26','18:40:00',2.24),('9650','2013-05-26','18:45:00',3.47),('9650','2013-05-26','18:50:00',2.3),('9650','2013-05-26','18:55:00',3.2),('9650','2013-05-26','19:00:00',3.61),('9650','2013-05-26','19:05:00',3.73),('9650','2013-05-26','19:10:00',3.5),('9650','2013-05-26','19:15:00',2.43),('9650','2013-05-26','19:20:00',2.06),('9650','2013-05-26','19:25:00',2.24),('9650','2013-05-26','19:30:00',2.39),('9650','2013-05-26','19:35:00',2.01),('9650','2013-05-26','19:40:00',1.7),('9650','2013-05-26','19:45:00',1.35),('9650','2013-05-25','07:20:00',1.12),('9650','2013-05-25','07:45:00',1.16),('9650','2013-05-25','07:50:00',2.24),('9650','2013-05-25','08:05:00',2.24),('9650','2013-05-25','08:10:00',1.88),('9650','2013-05-25','08:15:00',1.29),('9650','2013-05-25','08:20:00',1.73),('9650','2013-05-25','08:25:00',1.83),('9650','2013-05-25','08:30:00',2.47),('9650','2013-05-25','08:35:00',1.99),('9650','2013-05-25','08:40:00',2.49),('9650','2013-05-25','08:45:00',3.01),('9650','2013-05-25','08:50:00',3.62),('9650','2013-05-25','08:55:00',1.56),('9650','2013-05-25','09:00:00',2.81),('9650','2013-05-25','09:05:00',1.4),('9650','2013-05-25','09:10:00',3.41),('9650','2013-05-25','09:15:00',2.26),('9650','2013-05-25','09:20:00',1.44),('9650','2013-05-25','09:25:00',2.24),('9650','2013-05-25','09:30:00',1.5),('9650','2013-05-25','09:35:00',1.14),('9650','2013-05-25','09:40:00',1.93),('9650','2013-05-25','09:45:00',3.09),('9650','2013-05-25','09:50:00',1.22),('9650','2013-05-25','09:55:00',2),('9650','2013-05-25','10:00:00',1.86),('9650','2013-05-25','10:05:00',4.3),('9650','2013-05-25','10:10:00',5.53),('9650','2013-05-25','10:15:00',3.03),('9650','2013-05-25','10:20:00',3.85),('9650','2013-05-25','10:25:00',4.02),('9650','2013-05-25','10:30:00',5.3),('9650','2013-05-25','10:35:00',5.79),('9650','2013-05-25','10:40:00',5.71),('9650','2013-05-25','10:45:00',5.71),('9650','2013-05-25','10:50:00',6.02),('9650','2013-05-25','10:55:00',5.4),('9650','2013-05-25','11:00:00',6.16),('9650','2013-05-25','11:05:00',6.28),('9650','2013-05-25','11:10:00',6.35),('9650','2013-05-25','11:15:00',6.45),('9650','2013-05-25','11:20:00',6.58),('9650','2013-05-25','11:25:00',6.68),('9650','2013-05-25','11:30:00',6.81),('9650','2013-05-25','11:35:00',6.7),('9650','2013-05-25','11:40:00',6.46),('9650','2013-05-25','11:45:00',6.88),('9650','2013-05-25','11:50:00',7.18),('9650','2013-05-25','11:55:00',7.3),('9650','2013-05-25','12:00:00',7.3),('9650','2013-05-25','12:05:00',7.44),('9650','2013-05-25','12:10:00',7.11),('9650','2013-05-25','12:15:00',5.18),('9650','2013-05-25','12:20:00',7.03),('9650','2013-05-25','12:25:00',7.12),('9650','2013-05-25','12:30:00',8),('9650','2013-05-25','12:35:00',7.91),('9650','2013-05-25','12:40:00',7.2),('9650','2013-05-25','12:45:00',7.23),('9650','2013-05-25','12:50:00',7.92),('9650','2013-05-25','12:55:00',7.94),('9650','2013-05-25','13:00:00',7.35),('9650','2013-05-25','13:05:00',7.15),('9650','2013-05-25','13:10:00',8.25),('9650','2013-05-25','13:15:00',8.18),('9650','2013-05-25','13:20:00',8.17),('9650','2013-05-25','13:25:00',8.21),('9650','2013-05-25','13:30:00',8.4),('9650','2013-05-25','13:35:00',8.08),('9650','2013-05-25','13:40:00',8.17),('9650','2013-05-25','13:45:00',8.27),('9650','2013-05-25','13:50:00',8.29),('9650','2013-05-25','13:55:00',8.15),('9650','2013-05-25','14:00:00',8.24),('9650','2013-05-25','14:05:00',8.2),('9650','2013-05-25','14:10:00',8.18),('9650','2013-05-25','14:15:00',8.18),('9650','2013-05-25','14:20:00',8.22),('9650','2013-05-25','14:25:00',8.19),('9650','2013-05-25','14:30:00',8.21),('9650','2013-05-25','14:35:00',8.18),('9650','2013-05-25','14:40:00',8.19),('9650','2013-05-25','14:45:00',8.12),('9650','2013-05-25','14:50:00',8.15),('9650','2013-05-25','14:55:00',8.15),('9650','2013-05-25','15:00:00',8.08),('9650','2013-05-25','15:05:00',8.09),('9650','2013-05-25','15:10:00',8.07),('9650','2013-05-25','15:15:00',8.06),('9650','2013-05-25','15:20:00',8.05),('9650','2013-05-25','15:25:00',8.05),('9650','2013-05-25','15:30:00',8),('9650','2013-05-25','15:35:00',7.94),('9650','2013-05-25','15:40:00',7.87),('9650','2013-05-25','15:45:00',7.81),('9650','2013-05-25','15:50:00',7.74),('9650','2013-05-25','15:55:00',7.68),('9650','2013-05-25','16:00:00',7.65),('9650','2013-05-25','16:05:00',7.58),('9650','2013-05-25','16:10:00',7.55),('9650','2013-05-25','16:15:00',7.46),('9650','2013-05-25','16:20:00',7.4),('9650','2013-05-25','16:25:00',7.33),('9650','2013-05-25','16:30:00',7.26),('9650','2013-05-25','16:35:00',7.16),('9650','2013-05-25','16:40:00',7.07),('9650','2013-05-25','16:45:00',7),('9650','2013-05-25','16:50:00',6.9),('9650','2013-05-25','16:55:00',6.87),('9650','2013-05-25','17:00:00',6.75),('9650','2013-05-25','17:05:00',6.57),('9650','2013-05-25','17:10:00',6.39),('9650','2013-05-25','17:15:00',6.28),('9650','2013-05-25','17:20:00',6.28),('9650','2013-05-25','17:25:00',6.2),('9650','2013-05-25','17:30:00',6.07),('9650','2013-05-25','17:35:00',5.69),('9650','2013-05-25','17:40:00',5.76),('9650','2013-05-25','17:45:00',5.65),('9650','2013-05-25','17:50:00',5.55),('9650','2013-05-25','17:55:00',5.41),('9650','2013-05-25','18:00:00',5.31),('9650','2013-05-25','18:05:00',5.17),('9650','2013-05-25','18:10:00',5.03),('9650','2013-05-25','18:15:00',4.91),('9650','2013-05-25','18:20:00',4.76),('9650','2013-05-25','18:25:00',4.63),('9650','2013-05-25','18:30:00',4.45),('9650','2013-05-25','18:35:00',4.3),('9650','2013-05-25','18:40:00',4.07),('9650','2013-05-25','18:45:00',3.93),('9650','2013-05-25','18:50:00',3.81),('9650','2013-05-25','18:55:00',3.65),('9650','2013-05-25','19:00:00',3.44),('9650','2013-05-25','19:05:00',3.27),('9650','2013-05-25','19:10:00',3.1),('9650','2013-05-25','19:15:00',2.88),('9650','2013-05-25','19:20:00',2.68),('9650','2013-05-25','19:25:00',2.48),('9650','2013-05-25','19:30:00',2.26),('9650','2013-05-25','19:35:00',1.98),('9650','2013-05-25','19:40:00',1.81),('9650','2013-05-25','19:45:00',1.57),('9650','2013-05-25','19:50:00',1.27),('9650','2013-05-25','19:55:00',1.05),('9650','2013-05-24','07:35:00',1.61),('9650','2013-05-24','07:40:00',1.17),('9650','2013-05-24','07:55:00',1.49),('9650','2013-05-24','08:00:00',2.18),('9650','2013-05-24','08:05:00',2.31),('9650','2013-05-24','08:10:00',1.67),('9650','2013-05-24','08:15:00',1.04),('9650','2013-05-24','08:20:00',1.65),('9650','2013-05-24','08:25:00',2.51),('9650','2013-05-24','08:30:00',3.15),('9650','2013-05-24','08:35:00',2.01),('9650','2013-05-24','08:40:00',2.04),('9650','2013-05-24','08:45:00',1.77),('9650','2013-05-24','08:50:00',2.17),('9650','2013-05-24','08:55:00',1.88),('9650','2013-05-24','09:00:00',2.46),('9650','2013-05-24','09:05:00',3.28),('9650','2013-05-24','09:10:00',3.79),('9650','2013-05-24','09:15:00',4.64),('9650','2013-05-24','09:20:00',2.41),('9650','2013-05-24','09:25:00',2.49),('9650','2013-05-24','09:30:00',1.77),('9650','2013-05-24','09:35:00',3.3),('9650','2013-05-24','09:40:00',4.84),('9650','2013-05-24','09:45:00',3.78),('9650','2013-05-24','09:50:00',5.12),('9650','2013-05-24','09:55:00',3.27),('9650','2013-05-24','10:00:00',1.41),('9650','2013-05-24','10:05:00',1.29),('9650','2013-05-24','10:10:00',2.09),('9650','2013-05-24','10:15:00',1.84),('9650','2013-05-24','10:25:00',1.58),('9650','2013-05-24','10:30:00',1.52),('9650','2013-05-24','10:35:00',1.5),('9650','2013-05-24','10:40:00',2.52),('9650','2013-05-24','10:45:00',2.37),('9650','2013-05-24','10:50:00',2.34),('9650','2013-05-24','10:55:00',1.25),('9650','2013-05-24','11:00:00',1.88),('9650','2013-05-24','11:05:00',3.16),('9650','2013-05-24','11:10:00',7.07),('9650','2013-05-24','11:15:00',6.87),('9650','2013-05-24','11:20:00',4.75),('9650','2013-05-24','11:25:00',1.71),('9650','2013-05-24','11:35:00',3.19),('9650','2013-05-24','11:40:00',3.9),('9650','2013-05-24','11:45:00',4.25),('9650','2013-05-24','11:50:00',3.34),('9650','2013-05-24','11:55:00',3.44),('9650','2013-05-24','12:00:00',3.04),('9650','2013-05-24','12:05:00',2.6),('9650','2013-05-24','12:10:00',3.17),('9650','2013-05-24','12:15:00',2.3),('9650','2013-05-24','12:20:00',2.79),('9650','2013-05-24','12:25:00',3.53),('9650','2013-05-24','12:30:00',2.46),('9650','2013-05-24','12:35:00',2.91),('9650','2013-05-24','12:40:00',3.26),('9650','2013-05-24','12:45:00',3.17),('9650','2013-05-24','12:50:00',2.33),('9650','2013-05-24','12:55:00',3.46),('9650','2013-05-24','13:00:00',1.83),('9650','2013-05-24','13:05:00',2.98),('9650','2013-05-24','13:10:00',2.63),('9650','2013-05-24','13:15:00',3.47),('9650','2013-05-24','13:20:00',4.08),('9650','2013-05-24','13:25:00',6.88),('9650','2013-05-24','13:30:00',3.29),('9650','2013-05-24','13:35:00',2.57),('9650','2013-05-24','13:40:00',3.78),('9650','2013-05-24','13:45:00',3.34),('9650','2013-05-24','13:50:00',4.17),('9650','2013-05-24','13:55:00',6.86),('9650','2013-05-24','14:00:00',6.42),('9650','2013-05-24','14:05:00',7.18),('9650','2013-05-24','14:10:00',7.83),('9650','2013-05-24','14:15:00',7.1),('9650','2013-05-24','14:20:00',8.07),('9650','2013-05-24','14:25:00',5.14),('9650','2013-05-24','14:30:00',6),('9650','2013-05-24','14:35:00',4.68),('9650','2013-05-24','14:40:00',2.35),('9650','2013-05-24','14:45:00',5.65),('9650','2013-05-24','14:50:00',2.58),('9650','2013-05-24','14:55:00',3.13),('9650','2013-05-24','15:00:00',7.27),('9650','2013-05-24','15:05:00',5.12),('9650','2013-05-24','15:10:00',4.34),('9650','2013-05-24','15:15:00',4.38),('9650','2013-05-24','15:20:00',2.63),('9650','2013-05-24','15:25:00',4.76),('9650','2013-05-24','15:30:00',5.18),('9650','2013-05-24','15:35:00',8.94),('9650','2013-05-24','15:40:00',8.59),('9650','2013-05-24','15:45:00',7.6),('9650','2013-05-24','15:50:00',8.74),('9650','2013-05-24','15:55:00',8.91),('9650','2013-05-24','16:00:00',5.19),('9650','2013-05-24','16:05:00',3.95),('9650','2013-05-24','16:10:00',4.17),('9650','2013-05-24','16:15:00',3.74),('9650','2013-05-24','16:20:00',3.61),('9650','2013-05-24','16:25:00',3.56),('9650','2013-05-24','16:30:00',5.59),('9650','2013-05-24','16:35:00',7.21),('9650','2013-05-24','16:40:00',6.94),('9650','2013-05-24','16:45:00',5.38),('9650','2013-05-24','16:50:00',3.15),('9650','2013-05-24','16:55:00',1.85),('9650','2013-05-24','17:00:00',1.88),('9650','2013-05-24','17:05:00',3.88),('9650','2013-05-24','17:10:00',7.22),('9650','2013-05-24','17:15:00',5.6),('9650','2013-05-24','17:20:00',4.92),('9650','2013-05-24','17:25:00',2.8),('9650','2013-05-24','17:30:00',1.64),('9650','2013-05-24','17:35:00',3.37),('9650','2013-05-24','17:40:00',2),('9650','2013-05-24','17:45:00',2.32),('9650','2013-05-24','17:50:00',4.22),('9650','2013-05-24','17:55:00',1.73),('9650','2013-05-24','18:00:00',1.88),('9650','2013-05-24','18:05:00',1.59),('9650','2013-05-24','18:10:00',2.31),('9650','2013-05-24','18:15:00',1.57),('9650','2013-05-24','18:20:00',2.28),('9650','2013-05-24','18:35:00',1.07),('9650','2013-05-23','07:00:00',1.03),('9650','2013-05-23','07:40:00',1.09),('9650','2013-05-23','08:00:00',1.36),('9650','2013-05-23','08:05:00',1.77),('9650','2013-05-23','08:10:00',2.33),('9650','2013-05-23','08:15:00',2.19),('9650','2013-05-23','08:20:00',1.08),('9650','2013-05-23','08:25:00',1.34),('9650','2013-05-23','08:30:00',2.21),('9650','2013-05-23','08:35:00',1.89),('9650','2013-05-23','08:40:00',1.31),('9650','2013-05-23','08:45:00',2.47),('9650','2013-05-23','08:50:00',2.53),('9650','2013-05-23','08:55:00',2.74),('9650','2013-05-23','09:00:00',3.07),('9650','2013-05-23','09:05:00',3.75),('9650','2013-05-23','09:10:00',1.06),('9650','2013-05-23','09:15:00',1.37),('9650','2013-05-23','09:20:00',3.46),('9650','2013-05-23','09:25:00',2.39),('9650','2013-05-23','09:30:00',2.57),('9650','2013-05-23','09:35:00',1.18),('9650','2013-05-23','09:40:00',2.55),('9650','2013-05-23','09:45:00',1.8),('9650','2013-05-23','09:50:00',2.39),('9650','2013-05-23','09:55:00',4.08),('9650','2013-05-23','10:00:00',2.87),('9650','2013-05-23','10:05:00',1.45),('9650','2013-05-23','10:20:00',1.94),('9650','2013-05-23','10:25:00',3.88),('9650','2013-05-23','10:30:00',5.7),('9650','2013-05-23','10:35:00',5.5),('9650','2013-05-23','10:40:00',5.1),('9650','2013-05-23','10:45:00',5.45),('9650','2013-05-23','10:50:00',4.44),('9650','2013-05-23','10:55:00',6.8),('9650','2013-05-23','11:00:00',5.17),('9650','2013-05-23','11:05:00',4.87),('9650','2013-05-23','11:10:00',6.1),('9650','2013-05-23','11:15:00',5.16),('9650','2013-05-23','11:20:00',6.94),('9650','2013-05-23','11:25:00',7.02),('9650','2013-05-23','11:30:00',4.39),('9650','2013-05-23','11:35:00',2.49),('9650','2013-05-23','11:40:00',1.64),('9650','2013-05-23','11:45:00',4.38),('9650','2013-05-23','11:50:00',8.28),('9650','2013-05-23','11:55:00',5.55),('9650','2013-05-23','12:00:00',4.03),('9650','2013-05-23','12:05:00',4.94),('9650','2013-05-23','12:10:00',7.17),('9650','2013-05-23','12:15:00',4.55),('9650','2013-05-23','12:20:00',3.81),('9650','2013-05-23','12:25:00',6.92),('9650','2013-05-23','12:30:00',8.26),('9650','2013-05-23','12:35:00',3.93),('9650','2013-05-23','12:40:00',4.93),('9650','2013-05-23','12:45:00',6.52),('9650','2013-05-23','12:50:00',5.52),('9650','2013-05-23','12:55:00',4.52),('9650','2013-05-23','13:00:00',4.35),('9650','2013-05-23','13:05:00',3.62),('9650','2013-05-23','13:10:00',4.41),('9650','2013-05-23','13:15:00',5.32),('9650','2013-05-23','13:20:00',5.58),('9650','2013-05-23','13:25:00',4.21),('9650','2013-05-23','13:30:00',3.48),('9650','2013-05-23','13:35:00',5.03),('9650','2013-05-23','13:40:00',4.1),('9650','2013-05-23','13:45:00',1.99),('9650','2013-05-23','13:50:00',2.12),('9650','2013-05-23','13:55:00',4.4),('9650','2013-05-23','14:00:00',4.06),('9650','2013-05-23','14:05:00',3.8),('9650','2013-05-23','14:10:00',2.54),('9650','2013-05-23','14:15:00',7.06),('9650','2013-05-23','14:20:00',6.35),('9650','2013-05-23','14:25:00',6.07),('9650','2013-05-23','14:30:00',4.6),('9650','2013-05-23','14:35:00',6.29),('9650','2013-05-23','14:40:00',4.67),('9650','2013-05-23','14:45:00',5.71),('9650','2013-05-23','14:50:00',2.58),('9650','2013-05-23','14:55:00',3.13),('9650','2013-05-23','15:00:00',4.86),('9650','2013-05-23','15:05:00',6.69),('9650','2013-05-23','15:10:00',4.56),('9650','2013-05-23','15:15:00',6.85),('9650','2013-05-23','15:20:00',7.73),('9650','2013-05-23','15:25:00',6.69),('9650','2013-05-23','15:30:00',8.01),('9650','2013-05-23','15:35:00',7.21),('9650','2013-05-23','15:40:00',6.31),('9650','2013-05-23','15:45:00',7.39),('9650','2013-05-23','15:50:00',8.39),('9650','2013-05-23','15:55:00',9.07),('9650','2013-05-23','16:00:00',4.13),('9650','2013-05-23','16:05:00',3.99),('9650','2013-05-23','16:10:00',4.44),('9650','2013-05-23','16:15:00',5.68),('9650','2013-05-23','16:20:00',4.26),('9650','2013-05-23','16:25:00',6.03),('9650','2013-05-23','16:30:00',6.24),('9650','2013-05-23','16:35:00',3.13),('9650','2013-05-23','16:40:00',1.25),('9650','2013-05-23','16:45:00',1.28),('9650','2013-05-23','16:50:00',3.05),('9650','2013-05-23','16:55:00',3.76),('9650','2013-05-23','17:00:00',2.68),('9650','2013-05-23','17:05:00',1.92),('9650','2013-05-23','17:10:00',1.63),('9650','2013-05-23','17:15:00',1.65),('9650','2013-05-23','17:20:00',2.09),('9650','2013-05-23','17:25:00',2.17),('9650','2013-05-23','17:30:00',2.21),('9650','2013-05-23','17:35:00',2.19),('9650','2013-05-23','17:40:00',1.9),('9650','2013-05-23','17:45:00',1.6),('9650','2013-05-23','17:50:00',1.11),('9650','2013-05-23','18:10:00',1.01),('9650','2013-05-22','07:05:00',1.05),('9650','2013-05-22','07:10:00',1.62),('9650','2013-05-22','07:45:00',1.12),('9650','2013-05-22','07:50:00',1.5),('9650','2013-05-22','07:55:00',1.66),('9650','2013-05-22','08:00:00',1.89),('9650','2013-05-22','08:05:00',2.06),('9650','2013-05-22','08:10:00',1.51),('9650','2013-05-22','08:25:00',1.32),('9650','2013-05-22','08:30:00',2.21),('9650','2013-05-22','08:35:00',2.29),('9650','2013-05-22','08:40:00',2.72),('9650','2013-05-22','08:45:00',2.75),('9650','2013-05-22','08:50:00',1.43),('9650','2013-05-22','08:55:00',1.34),('9650','2013-05-22','09:00:00',3.65),('9650','2013-05-22','09:05:00',1.67),('9650','2013-05-22','09:15:00',1.67),('9650','2013-05-22','09:20:00',2.78),('9650','2013-05-22','09:25:00',3.98),('9650','2013-05-22','09:30:00',4.57),('9650','2013-05-22','09:35:00',3.82),('9650','2013-05-22','09:40:00',4.22),('9650','2013-05-22','09:45:00',2.9),('9650','2013-05-22','09:50:00',4.54),('9650','2013-05-22','09:55:00',2.71),('9650','2013-05-22','10:00:00',1.75),('9650','2013-05-22','10:05:00',4.7),('9650','2013-05-22','10:10:00',4.99),('9650','2013-05-22','10:15:00',5.55),('9650','2013-05-22','10:20:00',3.28),('9650','2013-05-22','10:25:00',5.13),('9650','2013-05-22','10:30:00',5.19),('9650','2013-05-22','10:35:00',5.34),('9650','2013-05-22','10:40:00',5.53),('9650','2013-05-22','10:45:00',5.95),('9650','2013-05-22','10:50:00',4.37),('9650','2013-05-22','10:55:00',6.22),('9650','2013-05-22','11:00:00',3.74),('9650','2013-05-22','11:05:00',6.05),('9650','2013-05-22','11:10:00',3.25),('9650','2013-05-22','11:15:00',4.05),('9650','2013-05-22','11:20:00',3.05),('9650','2013-05-22','11:25:00',4.16),('9650','2013-05-22','11:30:00',5.51),('9650','2013-05-22','11:35:00',5.58),('9650','2013-05-22','11:40:00',7.15),('9650','2013-05-22','11:45:00',3.88),('9650','2013-05-22','11:50:00',5.68),('9650','2013-05-22','11:55:00',6.81),('9650','2013-05-22','12:00:00',7.49),('9650','2013-05-22','12:05:00',7.5),('9650','2013-05-22','12:10:00',7.7),('9650','2013-05-22','12:15:00',5.39),('9650','2013-05-22','12:20:00',5.89),('9650','2013-05-22','12:25:00',7.02),('9650','2013-05-22','12:30:00',8.34),('9650','2013-05-22','12:35:00',2.94),('9650','2013-05-22','12:40:00',9.08),('9650','2013-05-22','12:45:00',5.87),('9650','2013-05-22','12:50:00',6.14),('9650','2013-05-22','12:55:00',8.68),('9650','2013-05-22','13:00:00',8.22),('9650','2013-05-22','13:05:00',5.76),('9650','2013-05-22','13:10:00',7.15),('9650','2013-05-22','13:15:00',6.84),('9650','2013-05-22','13:20:00',6.1),('9650','2013-05-22','13:25:00',7.5),('9650','2013-05-22','13:30:00',5.29),('9650','2013-05-22','13:35:00',4.65),('9650','2013-05-22','13:40:00',4.29),('9650','2013-05-22','13:45:00',5.61),('9650','2013-05-22','13:50:00',6.47),('9650','2013-05-22','13:55:00',8.01),('9650','2013-05-22','14:00:00',8.13),('9650','2013-05-22','14:05:00',8.5),('9650','2013-05-22','14:10:00',8.7),('9650','2013-05-22','14:15:00',6.52),('9650','2013-05-22','14:20:00',7.44),('9650','2013-05-22','14:25:00',5.37),('9650','2013-05-22','14:30:00',3.16),('9650','2013-05-22','14:35:00',9.13),('9650','2013-05-22','14:40:00',6.92),('9650','2013-05-22','14:45:00',3.43),('9650','2013-05-22','14:50:00',3.71),('9650','2013-05-22','14:55:00',5.92),('9650','2013-05-22','15:00:00',6.12),('9650','2013-05-22','15:05:00',6.14),('9650','2013-05-22','15:10:00',2.43),('9650','2013-05-22','15:15:00',3.32),('9650','2013-05-22','15:20:00',6.36),('9650','2013-05-22','15:25:00',2.67),('9650','2013-05-22','15:30:00',7.45),('9650','2013-05-22','15:35:00',6.35),('9650','2013-05-22','15:40:00',2.42),('9650','2013-05-22','15:45:00',5.24),('9650','2013-05-22','15:50:00',2.1),('9650','2013-05-22','15:55:00',3.49),('9650','2013-05-22','16:00:00',4.67),('9650','2013-05-22','16:05:00',8.08),('9650','2013-05-22','16:10:00',3.82),('9650','2013-05-22','16:15:00',5.8),('9650','2013-05-22','16:20:00',6.25),('9650','2013-05-22','16:25:00',5.75),('9650','2013-05-22','16:30:00',7.04),('9650','2013-05-22','16:35:00',3.75),('9650','2013-05-22','16:40:00',2.53),('9650','2013-05-22','16:45:00',3.87),('9650','2013-05-22','16:50:00',2.66),('9650','2013-05-22','16:55:00',1.15),('9650','2013-05-22','17:00:00',1.08),('9650','2013-05-22','17:05:00',2.26),('9650','2013-05-22','17:10:00',4.9),('9650','2013-05-22','17:15:00',4.12),('9650','2013-05-22','17:20:00',2.64),('9650','2013-05-22','17:25:00',2.09),('9650','2013-05-22','17:30:00',1.8),('9650','2013-05-22','17:35:00',3.35),('9650','2013-05-22','17:40:00',2.06),('9650','2013-05-22','17:45:00',1.83),('9650','2013-05-22','17:50:00',1.72),('9650','2013-05-22','17:55:00',2.79),('9650','2013-05-22','18:00:00',4.27),('9650','2013-05-22','18:05:00',6.03),('9650','2013-05-22','18:10:00',2),('9650','2013-05-22','18:35:00',1.15),('9650','2013-05-22','18:40:00',1.52),('9650','2013-05-22','18:45:00',2.95),('9650','2013-05-22','18:50:00',3.39),('9650','2013-05-22','18:55:00',2.1),('9650','2013-05-22','19:00:00',1.27),('9650','2013-05-21','07:25:00',1.04),('9650','2013-05-21','07:40:00',1.1),('9650','2013-05-21','07:45:00',1.22),('9650','2013-05-21','07:50:00',1.44),('9650','2013-05-21','07:55:00',1.5),('9650','2013-05-21','08:00:00',1.42),('9650','2013-05-21','08:05:00',1.61),('9650','2013-05-21','08:10:00',1.6),('9650','2013-05-21','08:15:00',2.3),('9650','2013-05-21','08:20:00',2.15),('9650','2013-05-21','08:25:00',2.19),('9650','2013-05-21','08:30:00',3.02),('9650','2013-05-21','08:35:00',3.49),('9650','2013-05-21','08:40:00',2.32),('9650','2013-05-21','08:45:00',2.21),('9650','2013-05-21','08:50:00',1.28),('9650','2013-05-21','09:10:00',1.16),('9650','2013-05-21','09:15:00',1.56),('9650','2013-05-21','09:20:00',1.64),('9650','2013-05-21','09:25:00',1.89),('9650','2013-05-21','09:30:00',3.76),('9650','2013-05-21','09:35:00',3.69),('9650','2013-05-21','09:40:00',3.7),('9650','2013-05-21','09:45:00',3.79),('9650','2013-05-21','09:50:00',3.91),('9650','2013-05-21','09:55:00',4.01),('9650','2013-05-21','10:00:00',4.14),('9650','2013-05-21','10:05:00',4.26),('9650','2013-05-21','10:10:00',4.34),('9650','2013-05-21','10:15:00',4.47),('9650','2013-05-21','10:20:00',4.37),('9650','2013-05-21','10:25:00',4.81),('9650','2013-05-21','10:30:00',4.91),('9650','2013-05-21','10:35:00',5.08),('9650','2013-05-21','10:40:00',5.49),('9650','2013-05-21','10:45:00',5.49),('9650','2013-05-21','10:50:00',5.32),('9650','2013-05-21','10:55:00',5.36),('9650','2013-05-21','11:00:00',5.52),('9650','2013-05-21','11:05:00',5.72),('9650','2013-05-21','11:10:00',4.55),('9650','2013-05-21','11:15:00',5.61),('9650','2013-05-21','11:20:00',5.94),('9650','2013-05-21','11:25:00',6.18),('9650','2013-05-21','11:30:00',4.74),('9650','2013-05-21','11:35:00',4.83),('9650','2013-05-21','11:40:00',4.55),('9650','2013-05-21','11:45:00',6.31),('9650','2013-05-21','11:50:00',4.24),('9650','2013-05-21','11:55:00',3.26),('9650','2013-05-21','12:00:00',4.91),('9650','2013-05-21','12:05:00',4.01),('9650','2013-05-21','12:10:00',3.99),('9650','2013-05-21','12:15:00',4.97),('9650','2013-05-21','12:20:00',6.33),('9650','2013-05-21','12:25:00',5.18),('9650','2013-05-21','12:30:00',3.72),('9650','2013-05-21','12:35:00',4.05),('9650','2013-05-21','12:40:00',2.99),('9650','2013-05-21','12:45:00',1.47),('9650','2013-05-21','13:00:00',1.17),('9650','2013-05-21','13:05:00',5.89),('9650','2013-05-21','13:10:00',4.24),('9650','2013-05-21','13:15:00',4.35),('9650','2013-05-21','13:20:00',5.34),('9650','2013-05-21','13:25:00',1.97),('9650','2013-05-21','13:30:00',2.96),('9650','2013-05-21','13:35:00',6.7),('9650','2013-05-21','13:40:00',5.28),('9650','2013-05-21','13:45:00',4.91),('9650','2013-05-21','13:50:00',3.34),('9650','2013-05-21','13:55:00',3.36),('9650','2013-05-21','14:00:00',5.05),('9650','2013-05-21','14:05:00',6.43),('9650','2013-05-21','14:10:00',7.72),('9650','2013-05-21','14:15:00',7.6),('9650','2013-05-21','14:20:00',7.41),('9650','2013-05-21','14:25:00',7.38),('9650','2013-05-21','14:30:00',7.35),('9650','2013-05-21','14:35:00',7.29),('9650','2013-05-21','14:40:00',7.32),('9650','2013-05-21','14:45:00',7.35),('9650','2013-05-21','14:50:00',7.35),('9650','2013-05-21','14:55:00',7.18),('9650','2013-05-21','15:00:00',7.28),('9650','2013-05-21','15:05:00',7.25),('9650','2013-05-21','15:10:00',7.18),('9650','2013-05-21','15:15:00',7.16),('9650','2013-05-21','15:20:00',6.34),('9650','2013-05-21','15:25:00',4.78),('9650','2013-05-21','15:30:00',4.04),('9650','2013-05-21','15:35:00',4.27),('9650','2013-05-21','15:40:00',6.34),('9650','2013-05-21','15:45:00',5.42),('9650','2013-05-21','15:50:00',6.79),('9650','2013-05-21','15:55:00',6.75),('9650','2013-05-21','16:00:00',6.71),('9650','2013-05-21','16:05:00',6.61),('9650','2013-05-21','16:10:00',6.5),('9650','2013-05-21','16:15:00',6.45),('9650','2013-05-21','16:20:00',6.38),('9650','2013-05-21','16:25:00',6.31),('9650','2013-05-21','16:30:00',6.18),('9650','2013-05-21','16:35:00',5.93),('9650','2013-05-21','16:40:00',6.02),('9650','2013-05-21','16:45:00',5.21),('9650','2013-05-21','16:50:00',2.97),('9650','2013-05-21','16:55:00',1.59),('9650','2013-05-21','17:00:00',1.4),('9650','2013-05-21','17:05:00',1.4),('9650','2013-05-21','17:10:00',1.64),('9650','2013-05-21','17:15:00',2.27),('9650','2013-05-21','17:20:00',2.6),('9650','2013-05-21','17:25:00',3.17),('9650','2013-05-21','17:30:00',2.71),('9650','2013-05-21','17:35:00',3.21),('9650','2013-05-21','17:40:00',1.67),('9650','2013-05-21','17:55:00',3.11),('9650','2013-05-21','18:00:00',3.99),('9650','2013-05-21','18:05:00',2.17),('9650','2013-05-21','18:10:00',1.2),('9650','2013-05-21','18:15:00',1.11),('9650','2013-05-21','18:20:00',1.05),('9650','2013-05-21','18:25:00',2.26),('9650','2013-05-21','18:30:00',1.19),('9650','2013-05-21','18:40:00',1.11),('9650','2013-05-21','18:45:00',1.27),('9650','2013-05-21','19:00:00',1.33),('9650','2013-05-21','19:05:00',1.53),('9650','2013-05-21','19:10:00',1.78),('9650','2013-05-21','19:15:00',1.8),('9650','2013-05-21','19:20:00',1.59),('9650','2013-05-21','19:25:00',1.27),('9650','2013-05-21','19:30:00',1.14),('9650','2013-05-21','19:35:00',1.03),('9650','2014-03-31','09:10:00',1.07),('9650','2014-03-31','09:15:00',1.17),('9650','2014-03-31','09:20:00',1.3),('9650','2014-03-31','09:25:00',1.44),('9650','2014-03-31','09:30:00',1.54),('9650','2014-03-31','09:35:00',1.66),('9650','2014-03-31','09:40:00',1.81),('9650','2014-03-31','09:45:00',1.95),('9650','2014-03-31','09:50:00',2.03),('9650','2014-03-31','09:55:00',2.25),('9650','2014-03-31','10:00:00',2.41),('9650','2014-03-31','10:05:00',2.52),('9650','2014-03-31','10:10:00',2.71),('9650','2014-03-31','10:15:00',2.95),('9650','2014-03-31','10:20:00',3.4),('9650','2014-03-31','10:25:00',3.73),('9650','2014-03-31','10:30:00',3.87),('9650','2014-03-31','10:35:00',3.49),('9650','2014-03-31','10:40:00',3.04),('9650','2014-03-31','10:45:00',2.32),('9650','2014-03-31','10:50:00',3.82),('9650','2014-03-31','10:55:00',3.83),('9650','2014-03-31','11:00:00',3.94),('9650','2014-03-31','11:05:00',4.07),('9650','2014-03-31','11:10:00',4.15),('9650','2014-03-31','11:15:00',4.24),('9650','2014-03-31','11:20:00',4.39),('9650','2014-03-31','11:25:00',4.55),('9650','2014-03-31','11:30:00',4.63),('9650','2014-03-31','11:35:00',4.75),('9650','2014-03-31','11:40:00',4.79),('9650','2014-03-31','11:45:00',4.96),('9650','2014-03-31','11:50:00',5.03),('9650','2014-03-31','11:55:00',5.11),('9650','2014-03-31','12:00:00',5.22),('9650','2014-03-31','12:05:00',5.33),('9650','2014-03-31','12:10:00',5.38),('9650','2014-03-31','12:15:00',5.48),('9650','2014-03-31','12:20:00',5.58),('9650','2014-03-31','12:25:00',5.67),('9650','2014-03-31','12:30:00',5.77),('9650','2014-03-31','12:35:00',5.85),('9650','2014-03-31','12:40:00',5.93),('9650','2014-03-31','12:45:00',6.01),('9650','2014-03-31','12:50:00',6.07),('9650','2014-03-31','12:55:00',6.13),('9650','2014-03-31','13:00:00',6.23),('9650','2014-03-31','13:05:00',5.77),('9650','2014-03-31','13:10:00',6.41),('9650','2014-03-31','13:15:00',5.6),('9650','2014-03-31','13:20:00',5.74),('9650','2014-03-31','13:25:00',6.4),('9650','2014-03-31','13:30:00',6.45),('9650','2014-03-31','13:35:00',6.55),('9650','2014-03-31','13:40:00',6.74),('9650','2014-03-31','13:45:00',6.68),('9650','2014-03-31','13:50:00',6.6),('9650','2014-03-31','13:55:00',6.67),('9650','2014-03-31','14:00:00',6.68),('9650','2014-03-31','14:05:00',6.74),('9650','2014-03-31','14:10:00',6.4),('9650','2014-03-31','14:15:00',5.38),('9650','2014-03-31','14:20:00',5.84),('9650','2014-03-31','14:25:00',6.73),('9650','2014-03-31','14:30:00',5.43),('9650','2014-03-31','14:35:00',6.98),('9650','2014-03-31','14:40:00',5.68),('9650','2014-03-31','14:45:00',7.4),('9650','2014-03-31','14:50:00',7.12),('9650','2014-03-31','14:55:00',5.59),('9650','2014-03-31','15:00:00',6.9),('9650','2014-03-31','15:05:00',6.39),('9650','2014-03-31','15:10:00',6.01),('9650','2014-03-31','15:15:00',5.65),('9650','2014-03-31','15:20:00',4.43),('9650','2014-03-31','15:25:00',5.73),('9650','2014-03-31','15:30:00',5.73),('9650','2014-03-31','15:35:00',5.01),('9650','2014-03-31','15:40:00',6.4),('9650','2014-03-31','15:45:00',4.84),('9650','2014-03-31','15:50:00',6.09),('9650','2014-03-31','15:55:00',5.59),('9650','2014-03-31','16:00:00',3.78),('9650','2014-03-31','16:05:00',5.1),('9650','2014-03-31','16:10:00',4.85),('9650','2014-03-31','16:15:00',3.97),('9650','2014-03-31','16:20:00',2.74),('9650','2014-03-31','16:25:00',4.04),('9650','2014-03-31','16:30:00',4.49),('9650','2014-03-31','16:35:00',5.43),('9650','2014-03-31','16:40:00',5.09),('9650','2014-03-31','16:45:00',2.78),('9650','2014-03-31','16:50:00',2.93),('9650','2014-03-31','16:55:00',3.84),('9650','2014-03-31','17:00:00',4.77),('9650','2014-03-31','17:05:00',4.34),('9650','2014-03-31','17:10:00',3.63),('9650','2014-03-31','17:15:00',4.19),('9650','2014-03-31','17:20:00',4.02),('9650','2014-03-31','17:25:00',3.73),('9650','2014-03-31','17:30:00',3.76),('9650','2014-03-31','17:35:00',3.68),('9650','2014-03-31','17:40:00',3.65),('9650','2014-03-31','17:45:00',3.26),('9650','2014-03-31','17:50:00',3.33),('9650','2014-03-31','17:55:00',3.11),('9650','2014-03-31','18:00:00',2.94),('9650','2014-03-31','18:05:00',2.84),('9650','2014-03-31','18:10:00',2.66),('9650','2014-03-31','18:15:00',2.51),('9650','2014-03-31','18:20:00',2.27),('9650','2014-03-31','18:25:00',1.71),('9650','2013-05-20','07:35:00',1.26),('9650','2013-05-20','07:40:00',1.56),('9650','2013-05-20','07:45:00',1.43),('9650','2013-05-20','07:50:00',1.24),('9650','2013-05-20','07:55:00',1.39),('9650','2013-05-20','08:00:00',1.32),('9650','2013-05-20','08:05:00',1.15),('9650','2013-05-20','08:10:00',1.85),('9650','2013-05-20','08:15:00',2.41),('9650','2013-05-20','08:20:00',2.29),('9650','2013-05-20','08:25:00',2.65),('9650','2013-05-20','08:30:00',2.12),('9650','2013-05-20','08:35:00',2.13),('9650','2013-05-20','08:40:00',2.45),('9650','2013-05-20','08:45:00',2.18),('9650','2013-05-20','08:50:00',2.32),('9650','2013-05-20','08:55:00',2.77),('9650','2013-05-20','09:00:00',2.48),('9650','2013-05-20','09:05:00',2.25),('9650','2013-05-20','09:10:00',2.41),('9650','2013-05-20','09:15:00',2.57),('9650','2013-05-20','09:20:00',3.33),('9650','2013-05-20','09:25:00',3.48),('9650','2013-05-20','09:30:00',3.04),('9650','2013-05-20','09:35:00',3.15),('9650','2013-05-20','09:40:00',3.24),('9650','2013-05-20','09:45:00',2.95),('9650','2013-05-20','09:50:00',2.92),('9650','2013-05-20','09:55:00',3.15),('9650','2013-05-20','10:00:00',3.28),('9650','2013-05-20','10:05:00',3.5),('9650','2013-05-20','10:10:00',3.78),('9650','2013-05-20','10:15:00',3.87),('9650','2013-05-20','10:20:00',3.4),('9650','2013-05-20','10:25:00',3.32),('9650','2013-05-20','10:30:00',3.16),('9650','2013-05-20','10:35:00',3.28),('9650','2013-05-20','10:40:00',3.5),('9650','2013-05-20','10:45:00',4.89),('9650','2013-05-20','10:50:00',3.68),('9650','2013-05-20','10:55:00',2.97),('9650','2013-05-20','11:00:00',3.38),('9650','2013-05-20','11:05:00',3.14),('9650','2013-05-20','11:10:00',4.51),('9650','2013-05-20','11:15:00',6.07),('9650','2013-05-20','11:20:00',5.42),('9650','2013-05-20','11:25:00',6.61),('9650','2013-05-20','11:30:00',4.65),('9650','2013-05-20','11:35:00',4.16),('9650','2013-05-20','11:40:00',4.55),('9650','2013-05-20','11:45:00',5.38),('9650','2013-05-20','11:50:00',4.49),('9650','2013-05-20','11:55:00',5.91),('9650','2013-05-20','12:00:00',5.36),('9650','2013-05-20','12:05:00',6.2),('9650','2013-05-20','12:10:00',4.56),('9650','2013-05-20','12:15:00',5.37),('9650','2013-05-20','12:20:00',4.23),('9650','2013-05-20','12:25:00',5.75),('9650','2013-05-20','12:30:00',6.91),('9650','2013-05-20','12:35:00',4.87),('9650','2013-05-20','12:40:00',7.16),('9650','2013-05-20','12:45:00',6.87),('9650','2013-05-20','12:50:00',4.69),('9650','2013-05-20','12:55:00',8.15),('9650','2013-05-20','13:00:00',7.13),('9650','2013-05-20','13:05:00',7.25),('9650','2013-05-20','13:10:00',4.59),('9650','2013-05-20','13:15:00',6.53),('9650','2013-05-20','13:20:00',5.26),('9650','2013-05-20','13:25:00',5.52),('9650','2013-05-20','13:30:00',5.07),('9650','2013-05-20','13:35:00',2.55),('9650','2013-05-20','13:40:00',1.61),('9650','2013-05-20','13:45:00',1.11),('9650','2013-05-20','14:05:00',1.85),('9650','2013-05-20','14:10:00',3.02),('9650','2013-05-20','14:15:00',3.67),('9650','2013-05-20','14:20:00',3.13),('9650','2013-05-20','14:25:00',4.74),('9650','2013-05-20','14:30:00',4.58),('9650','2013-05-20','14:35:00',3.71),('9650','2013-05-20','14:40:00',3.43),('9650','2013-05-20','14:45:00',2.86),('9650','2013-05-20','14:50:00',1.7),('9650','2013-05-20','14:55:00',1.27),('9650','2013-05-20','15:05:00',1),('9650','2013-05-20','15:10:00',1.18),('9650','2013-05-20','15:15:00',2.01),('9650','2013-05-20','15:20:00',2.82),('9650','2013-05-20','15:25:00',2.91),('9650','2013-05-20','15:30:00',4.55),('9650','2013-05-20','15:35:00',3.08),('9650','2013-05-20','15:40:00',2.51),('9650','2013-05-20','15:45:00',2.64),('9650','2013-05-20','15:50:00',2.32),('9650','2013-05-20','15:55:00',2.16),('9650','2013-05-20','16:00:00',2.07),('9650','2013-05-20','16:05:00',2.12),('9650','2013-05-20','16:10:00',2.4),('9650','2013-05-20','16:15:00',1.94),('9650','2013-05-20','16:20:00',1.62),('9650','2013-05-20','16:25:00',2.23),('9650','2013-05-20','16:30:00',3.47),('9650','2013-05-20','16:35:00',4.03),('9650','2013-05-20','16:40:00',3.62),('9650','2013-05-20','16:45:00',3.48),('9650','2013-05-20','16:50:00',2.05),('9650','2013-05-20','16:55:00',1.06),('9650','2013-05-20','17:00:00',1.14),('9650','2013-05-20','17:05:00',1.37),('9650','2013-05-20','17:10:00',1.17),('9650','2013-05-19','07:45:00',1),('9650','2013-05-19','07:55:00',1.08),('9650','2013-05-19','08:00:00',1.2),('9650','2013-05-19','08:05:00',1.22),('9650','2013-05-19','08:10:00',1.42),('9650','2013-05-19','08:15:00',1.66),('9650','2013-05-19','08:20:00',2.2),('9650','2013-05-19','08:25:00',1.14),('9650','2013-05-19','08:35:00',1.07),('9650','2013-05-19','08:40:00',1.18),('9650','2013-05-19','08:45:00',2.65),('9650','2013-05-19','08:50:00',3.78),('9650','2013-05-19','08:55:00',3.22),('9650','2013-05-19','09:00:00',3.43),('9650','2013-05-19','09:05:00',3.29),('9650','2013-05-19','09:10:00',4.15),('9650','2013-05-19','09:15:00',2.38),('9650','2013-05-19','09:20:00',2.69),('9650','2013-05-19','09:25:00',1.65),('9650','2013-05-19','09:30:00',1.19),('9650','2013-05-19','09:35:00',3.62),('9650','2013-05-19','09:40:00',1.28),('9650','2013-05-19','09:45:00',2.54),('9650','2013-05-19','09:50:00',3.37),('9650','2013-05-19','09:55:00',1.4),('9650','2013-05-19','10:00:00',1.73),('9650','2013-05-19','10:05:00',2.11),('9650','2013-05-19','10:10:00',3.04),('9650','2013-05-19','10:15:00',1.52),('9650','2013-05-19','10:20:00',1.26),('9650','2013-05-19','10:25:00',2.36),('9650','2013-05-19','10:30:00',4.25),('9650','2013-05-19','10:35:00',2.5),('9650','2013-05-19','10:40:00',2.01),('9650','2013-05-19','10:45:00',2.38),('9650','2013-05-19','10:50:00',2.87),('9650','2013-05-19','10:55:00',1.93),('9650','2013-05-19','11:00:00',5.7),('9650','2013-05-19','11:05:00',5.74),('9650','2013-05-19','11:10:00',7.68),('9650','2013-05-19','11:15:00',5.78),('9650','2013-05-19','11:20:00',4.16),('9650','2013-05-19','11:25:00',5.94),('9650','2013-05-19','11:30:00',5.04),('9650','2013-05-19','11:35:00',5.83),('9650','2013-05-19','11:40:00',2.47),('9650','2013-05-19','11:45:00',2.71),('9650','2013-05-19','11:50:00',1.76),('9650','2013-05-19','11:55:00',7.11),('9650','2013-05-19','12:00:00',3.62),('9650','2013-05-19','12:05:00',6.12),('9650','2013-05-19','12:10:00',4.04),('9650','2013-05-19','12:15:00',3.02),('9650','2013-05-19','12:20:00',7.22),('9650','2013-05-19','12:25:00',3.45),('9650','2013-05-19','12:30:00',4.07),('9650','2013-05-19','12:35:00',3.17),('9650','2013-05-19','12:40:00',7.49),('9650','2013-05-19','12:45:00',7.31),('9650','2013-05-19','12:50:00',2.02),('9650','2013-05-19','12:55:00',5.38),('9650','2013-05-19','13:00:00',4.79),('9650','2013-05-19','13:05:00',6.02),('9650','2013-05-19','13:10:00',3.4),('9650','2013-05-19','13:15:00',3.45),('9650','2013-05-19','13:20:00',6.48),('9650','2013-05-19','13:25:00',7.9),('9650','2013-05-19','13:30:00',2.7),('9650','2013-05-19','13:35:00',6.91),('9650','2013-05-19','13:40:00',3.43),('9650','2013-05-19','13:45:00',7.6),('9650','2013-05-19','13:50:00',6.35),('9650','2013-05-19','13:55:00',6.9),('9650','2013-05-19','14:00:00',8.13),('9650','2013-05-19','14:05:00',2.37),('9650','2013-05-19','14:10:00',4.4),('9650','2013-05-19','14:15:00',6.35),('9650','2013-05-19','14:20:00',4.58),('9650','2013-05-19','14:25:00',6.67),('9650','2013-05-19','14:30:00',8.18),('9650','2013-05-19','14:35:00',5.3),('9650','2013-05-19','14:40:00',2.38),('9650','2013-05-19','14:45:00',8.03),('9650','2013-05-19','14:50:00',7.18),('9650','2013-05-19','14:55:00',6.44),('9650','2013-05-19','15:00:00',4.91),('9650','2013-05-19','15:05:00',3.71),('9650','2013-05-19','15:10:00',8.65),('9650','2013-05-19','15:15:00',3.96),('9650','2013-05-19','15:20:00',7.27),('9650','2013-05-19','15:25:00',7.09),('9650','2013-05-19','15:30:00',7.11),('9650','2013-05-19','15:35:00',8.36),('9650','2013-05-19','15:40:00',5),('9650','2013-05-19','15:45:00',3.08),('9650','2013-05-19','15:50:00',5.54),('9650','2013-05-19','15:55:00',3.74),('9650','2013-05-19','16:00:00',4.34),('9650','2013-05-19','16:05:00',7.4),('9650','2013-05-19','16:10:00',7.31),('9650','2013-05-19','16:15:00',6.34),('9650','2013-05-19','16:20:00',7.25),('9650','2013-05-19','16:25:00',7.18),('9650','2013-05-19','16:30:00',6.93),('9650','2013-05-19','16:35:00',6.78),('9650','2013-05-19','16:40:00',6.74),('9650','2013-05-19','16:45:00',6.38),('9650','2013-05-19','16:50:00',6.42),('9650','2013-05-19','16:55:00',6.28),('9650','2013-05-19','17:00:00',6.21),('9650','2013-05-19','17:05:00',6.17),('9650','2013-05-19','17:10:00',4.66),('9650','2013-05-19','17:15:00',3.02),('9650','2013-05-19','17:20:00',5.02),('9650','2013-05-19','17:25:00',6.19),('9650','2013-05-19','17:30:00',6.24),('9650','2013-05-19','17:35:00',5.49),('9650','2013-05-19','17:40:00',5.28),('9650','2013-05-19','17:45:00',5.11),('9650','2013-05-19','17:50:00',5.02),('9650','2013-05-19','17:55:00',4.96),('9650','2013-05-19','18:00:00',4.83),('9650','2013-05-19','18:05:00',4.65),('9650','2013-05-19','18:10:00',3.55),('9650','2013-05-19','18:15:00',4.58),('9650','2013-05-19','18:20:00',4.21),('9650','2013-05-19','18:25:00',4),('9650','2013-05-19','18:30:00',3.84),('9650','2013-05-19','18:35:00',3.72),('9650','2013-05-19','18:40:00',3.32),('9650','2013-05-19','18:45:00',3.37),('9650','2013-05-19','18:50:00',3.02),('9650','2013-05-19','18:55:00',3.02),('9650','2013-05-19','19:00:00',2.87),('9650','2013-05-19','19:05:00',2.72),('9650','2013-05-19','19:10:00',2.55),('9650','2013-05-19','19:15:00',2.31),('9650','2013-05-19','19:20:00',2.06),('9650','2013-05-19','19:25:00',1.8),('9650','2013-05-19','19:30:00',1.57),('9650','2013-05-19','19:35:00',1.11),('9650','2013-05-18','08:00:00',1.05),('9650','2013-05-18','08:10:00',1.17),('9650','2013-05-18','08:15:00',1.22),('9650','2013-05-18','08:20:00',1.16),('9650','2013-05-18','08:25:00',1.11),('9650','2013-05-18','08:30:00',1.59),('9650','2013-05-18','08:35:00',1.91),('9650','2013-05-18','08:40:00',1.66),('9650','2013-05-18','08:45:00',1.85),('9650','2013-05-18','08:50:00',2.1),('9650','2013-05-18','08:55:00',2.3),('9650','2013-05-18','09:00:00',2.21),('9650','2013-05-18','09:05:00',2.08),('9650','2013-05-18','09:10:00',2.33),('9650','2013-05-18','09:15:00',2.35),('9650','2013-05-18','09:20:00',1.73),('9650','2013-05-18','09:30:00',1.28),('9650','2013-05-18','09:35:00',1.55),('9650','2013-05-18','09:40:00',2.04),('9650','2013-05-18','09:45:00',2.23),('9650','2013-05-18','09:50:00',1.55),('9650','2013-05-18','09:55:00',1.97),('9650','2013-05-18','10:00:00',2.52),('9650','2013-05-18','10:05:00',2.8),('9650','2013-05-18','10:10:00',3.79),('9650','2013-05-18','10:15:00',4.88),('9650','2013-05-18','10:20:00',4.46),('9650','2013-05-18','10:25:00',3.81),('9650','2013-05-18','10:30:00',4.71),('9650','2013-05-18','10:35:00',4.88),('9650','2013-05-18','10:40:00',5.4),('9650','2013-05-18','10:45:00',5.84),('9650','2013-05-18','10:50:00',5.31),('9650','2013-05-18','10:55:00',6.76),('9650','2013-05-18','11:00:00',4.91),('9650','2013-05-18','11:05:00',3.68),('9650','2013-05-18','11:10:00',3.97),('9650','2013-05-18','11:15:00',6.63),('9650','2013-05-18','11:20:00',6.44),('9650','2013-05-18','11:25:00',6.57),('9650','2013-05-18','11:30:00',6.56),('9650','2013-05-18','11:35:00',6.56),('9650','2013-05-18','11:40:00',6.65),('9650','2013-05-18','11:45:00',6.72),('9650','2013-05-18','11:50:00',6.79),('9650','2013-05-18','11:55:00',6.97),('9650','2013-05-18','12:00:00',7.05),('9650','2013-05-18','12:05:00',7.02),('9650','2013-05-18','12:10:00',7.01),('9650','2013-05-18','12:15:00',7.2),('9650','2013-05-18','12:20:00',7.9),('9650','2013-05-18','12:25:00',6.26),('9650','2013-05-18','12:30:00',5.26),('9650','2013-05-18','12:35:00',5.75),('9650','2013-05-18','12:40:00',7.01),('9650','2013-05-18','12:45:00',6.86),('9650','2013-05-18','12:50:00',5.16),('9650','2013-05-18','12:55:00',4.39),('9650','2013-05-18','13:00:00',6.77),('9650','2013-05-18','13:05:00',7.47),('9650','2013-05-18','13:10:00',6.07),('9650','2013-05-18','13:15:00',5.77),('9650','2013-05-18','13:20:00',6.86),('9650','2013-05-18','13:25:00',6.92),('9650','2013-05-18','13:30:00',7.7),('9650','2013-05-18','13:35:00',7.63),('9650','2013-05-18','13:40:00',7.73),('9650','2013-05-18','13:45:00',7.77),('9650','2013-05-18','13:50:00',7.81),('9650','2013-05-18','13:55:00',7.75),('9650','2013-05-18','14:00:00',7.82),('9650','2013-05-18','14:05:00',7.78),('9650','2013-05-18','14:10:00',7.87),('9650','2013-05-18','14:15:00',7.88),('9650','2013-05-18','14:20:00',7.84),('9650','2013-05-18','14:25:00',7.91),('9650','2013-05-18','14:30:00',7.91),('9650','2013-05-18','14:35:00',7.92),('9650','2013-05-18','14:40:00',7.94),('9650','2013-05-18','14:45:00',7.93),('9650','2013-05-18','14:50:00',7.88),('9650','2013-05-18','14:55:00',7.9),('9650','2013-05-18','15:00:00',7.87),('9650','2013-05-18','15:05:00',7.86),('9650','2013-05-18','15:10:00',7.76),('9650','2013-05-18','15:15:00',7.74),('9650','2013-05-18','15:20:00',7.72),('9650','2013-05-18','15:25:00',7.73),('9650','2013-05-18','15:30:00',7.72),('9650','2013-05-18','15:35:00',7.64),('9650','2013-05-18','15:40:00',7.55),('9650','2013-05-18','15:45:00',7.48),('9650','2013-05-18','15:50:00',7.41),('9650','2013-05-18','15:55:00',7.4),('9650','2013-05-18','16:00:00',7.41),('9650','2013-05-18','16:05:00',7.32),('9650','2013-05-18','16:10:00',7.25),('9650','2013-05-18','16:15:00',7.18),('9650','2013-05-18','16:20:00',7.06),('9650','2013-05-18','16:25:00',7.05),('9650','2013-05-18','16:30:00',6.94),('9650','2013-05-18','16:35:00',6.91),('9650','2013-05-18','16:40:00',6.87),('9650','2013-05-18','16:45:00',6.8),('9650','2013-05-18','16:50:00',6.71),('9650','2013-05-18','16:55:00',6.64),('9650','2013-05-18','17:00:00',6.55),('9650','2013-05-18','17:05:00',6.43),('9650','2013-05-18','17:10:00',6.31),('9650','2013-05-18','17:15:00',6.21),('9650','2013-05-18','17:20:00',6.12),('9650','2013-05-18','17:25:00',6.03),('9650','2013-05-18','17:30:00',5.89),('9650','2013-05-18','17:35:00',5.77),('9650','2013-05-18','17:40:00',5.49),('9650','2013-05-18','17:45:00',5.53),('9650','2013-05-18','17:50:00',5.43),('9650','2013-05-18','17:55:00',5.27),('9650','2013-05-18','18:00:00',5.16),('9650','2013-05-18','18:05:00',5.04),('9650','2013-05-18','18:10:00',4.93),('9650','2013-05-18','18:15:00',4.79),('9650','2013-05-18','18:20:00',4.64),('9650','2013-05-18','18:25:00',4.5),('9650','2013-05-18','18:30:00',4.33),('9650','2013-05-18','18:35:00',4.17),('9650','2013-05-18','18:40:00',4.03),('9650','2013-05-18','18:45:00',3.84),('9650','2013-05-18','18:50:00',3.63),('9650','2013-05-18','18:55:00',3.48),('9650','2013-05-18','19:00:00',3.31),('9650','2013-05-18','19:05:00',3.1),('9650','2013-05-18','19:10:00',2.91);
INSERT INTO `solarlog` VALUES ('9650','2013-05-18','19:15:00',2.7),('9650','2013-05-18','19:20:00',2.46),('9650','2013-05-18','19:25:00',2.28),('9650','2013-05-18','19:30:00',2.04),('9650','2013-05-18','19:35:00',1.84),('9650','2013-05-18','19:40:00',1.6),('9650','2013-05-18','19:45:00',1.34),('9650','2013-05-18','19:50:00',1.08),('9650','2013-05-17','07:45:00',1.09),('9650','2013-05-17','07:50:00',1.24),('9650','2013-05-17','07:55:00',1.69),('9650','2013-05-17','08:00:00',1.96),('9650','2013-05-17','08:05:00',2.07),('9650','2013-05-17','08:10:00',1.65),('9650','2013-05-17','08:15:00',1.59),('9650','2013-05-17','08:20:00',1.9),('9650','2013-05-17','08:25:00',2.61),('9650','2013-05-17','08:30:00',2.33),('9650','2013-05-17','08:35:00',2.15),('9650','2013-05-17','08:40:00',2.23),('9650','2013-05-17','08:45:00',2.19),('9650','2013-05-17','08:50:00',2.28),('9650','2013-05-17','08:55:00',2.41),('9650','2013-05-17','09:00:00',2.55),('9650','2013-05-17','09:05:00',2.61),('9650','2013-05-17','09:10:00',2.83),('9650','2013-05-17','09:15:00',3),('9650','2013-05-17','09:20:00',3.12),('9650','2013-05-17','09:25:00',3.23),('9650','2013-05-17','09:30:00',3.39),('9650','2013-05-17','09:35:00',3.54),('9650','2013-05-17','09:40:00',3.68),('9650','2013-05-17','09:45:00',3.83),('9650','2013-05-17','09:50:00',3.96),('9650','2013-05-17','09:55:00',4.09),('9650','2013-05-17','10:00:00',4.2),('9650','2013-05-17','10:05:00',4.32),('9650','2013-05-17','10:10:00',4.44),('9650','2013-05-17','10:15:00',4.52),('9650','2013-05-17','10:20:00',4.63),('9650','2013-05-17','10:25:00',4.76),('9650','2013-05-17','10:30:00',4.88),('9650','2013-05-17','10:35:00',4.98),('9650','2013-05-17','10:40:00',5.07),('9650','2013-05-17','10:45:00',5.19),('9650','2013-05-17','10:50:00',5.33),('9650','2013-05-17','10:55:00',5.25),('9650','2013-05-17','11:00:00',5.8),('9650','2013-05-17','11:05:00',5.3),('9650','2013-05-17','11:10:00',4.85),('9650','2013-05-17','11:15:00',6.13),('9650','2013-05-17','11:20:00',5.96),('9650','2013-05-17','11:25:00',6.43),('9650','2013-05-17','11:30:00',6.21),('9650','2013-05-17','11:35:00',5.96),('9650','2013-05-17','11:40:00',6.24),('9650','2013-05-17','11:45:00',6.2),('9650','2013-05-17','11:50:00',6.06),('9650','2013-05-17','11:55:00',5.95),('9650','2013-05-17','12:00:00',6.14),('9650','2013-05-17','12:05:00',6.48),('9650','2013-05-17','12:10:00',6.5),('9650','2013-05-17','12:15:00',6.58),('9650','2013-05-17','12:20:00',6.65),('9650','2013-05-17','12:25:00',6.82),('9650','2013-05-17','12:30:00',5.51),('9650','2013-05-17','12:35:00',6.87),('9650','2013-05-17','12:40:00',6.89),('9650','2013-05-17','12:45:00',6.48),('9650','2013-05-17','12:50:00',6.91),('9650','2013-05-17','12:55:00',6.98),('9650','2013-05-17','13:00:00',6.96),('9650','2013-05-17','13:05:00',6.97),('9650','2013-05-17','13:10:00',4.54),('9650','2013-05-17','13:20:00',6.11),('9650','2013-05-17','13:25:00',7.05),('9650','2013-05-17','13:30:00',7.13),('9650','2013-05-17','13:35:00',6.47),('9650','2013-05-17','13:40:00',6.83),('9650','2013-05-17','13:45:00',7.49),('9650','2013-05-17','13:50:00',6.55),('9650','2013-05-17','13:55:00',5.86),('9650','2013-05-17','14:00:00',5.29),('9650','2013-05-17','14:05:00',5.69),('9650','2013-05-17','14:10:00',8.05),('9650','2013-05-17','14:15:00',7.81),('9650','2013-05-17','14:20:00',7.74),('9650','2013-05-17','14:25:00',7.61),('9650','2013-05-17','14:30:00',7.61),('9650','2013-05-17','14:35:00',7.45),('9650','2013-05-17','14:40:00',7.93),('9650','2013-05-17','14:45:00',7.33),('9650','2013-05-17','14:50:00',7.38),('9650','2013-05-17','14:55:00',6.51),('9650','2013-05-17','15:00:00',6.86),('9650','2013-05-17','15:05:00',6.82),('9650','2013-05-17','15:10:00',6.75),('9650','2013-05-17','15:15:00',6.74),('9650','2013-05-17','15:20:00',6.66),('9650','2013-05-17','15:25:00',6.59),('9650','2013-05-17','15:30:00',6.57),('9650','2013-05-17','15:35:00',6.56),('9650','2013-05-17','15:40:00',6.46),('9650','2013-05-17','15:45:00',6.32),('9650','2013-05-17','15:50:00',6.27),('9650','2013-05-17','15:55:00',6.22),('9650','2013-05-17','16:00:00',6.14),('9650','2013-05-17','16:05:00',6.09),('9650','2013-05-17','16:10:00',6.01),('9650','2013-05-17','16:15:00',5.9),('9650','2013-05-17','16:20:00',5.85),('9650','2013-05-17','16:25:00',5.82),('9650','2013-05-17','16:30:00',5.72),('9650','2013-05-17','16:35:00',5.66),('9650','2013-05-17','16:40:00',5.62),('9650','2013-05-17','16:45:00',5.52),('9650','2013-05-17','16:50:00',5.38),('9650','2013-05-17','16:55:00',5.32),('9650','2013-05-17','17:00:00',5.18),('9650','2013-05-17','17:05:00',5.09),('9650','2013-05-17','17:10:00',5.04),('9650','2013-05-17','17:15:00',4.92),('9650','2013-05-17','17:20:00',4.81),('9650','2013-05-17','17:25:00',4.66),('9650','2013-05-17','17:30:00',4.54),('9650','2013-05-17','17:35:00',4.41),('9650','2013-05-17','17:40:00',4.3),('9650','2013-05-17','17:45:00',4.21),('9650','2013-05-17','17:50:00',4.09),('9650','2013-05-17','17:55:00',3.96),('9650','2013-05-17','18:00:00',3.81),('9650','2013-05-17','18:05:00',3.6),('9650','2013-05-17','18:10:00',3.47),('9650','2013-05-17','18:15:00',3.3),('9650','2013-05-17','18:20:00',3.11),('9650','2013-05-17','18:25:00',2.93),('9650','2013-05-17','18:30:00',2.79),('9650','2013-05-17','18:35:00',2.61),('9650','2013-05-17','18:40:00',2.44),('9650','2013-05-17','18:45:00',2.26),('9650','2013-05-17','18:50:00',2.06),('9650','2013-05-17','18:55:00',1.89),('9650','2013-05-17','19:00:00',1.71),('9650','2013-05-17','19:05:00',1.54),('9650','2013-05-17','19:10:00',1.36),('9650','2013-05-17','19:15:00',1.17),('9650','2013-05-16','07:40:00',1.06),('9650','2013-05-16','07:45:00',1.1),('9650','2013-05-16','07:50:00',1.31),('9650','2013-05-16','07:55:00',1.39),('9650','2013-05-16','08:00:00',1.57),('9650','2013-05-16','08:05:00',1.61),('9650','2013-05-16','08:10:00',1.65),('9650','2013-05-16','08:15:00',2.25),('9650','2013-05-16','08:20:00',3.03),('9650','2013-05-16','08:25:00',2.72),('9650','2013-05-16','08:30:00',1.47),('9650','2013-05-16','09:05:00',1.1),('9650','2013-05-16','09:10:00',1.3),('9650','2013-05-16','09:15:00',1.18),('9650','2013-05-16','09:20:00',1.55),('9650','2013-05-16','09:25:00',1.84),('9650','2013-05-16','10:15:00',1.27),('9650','2013-05-16','10:20:00',1.77),('9650','2013-05-16','10:25:00',2.36),('9650','2013-05-16','10:30:00',2.89),('9650','2013-05-16','10:35:00',2.2),('9650','2013-05-16','10:40:00',2.42),('9650','2013-05-16','10:45:00',2.67),('9650','2013-05-16','10:50:00',4.63),('9650','2013-05-16','10:55:00',5.14),('9650','2013-05-16','11:00:00',3.82),('9650','2013-05-16','11:05:00',3.44),('9650','2013-05-16','11:10:00',2.55),('9650','2013-05-16','11:15:00',3.42),('9650','2013-05-16','11:20:00',3.37),('9650','2013-05-16','11:25:00',2.99),('9650','2013-05-16','11:30:00',2.72),('9650','2013-05-16','11:35:00',3.49),('9650','2013-05-16','11:40:00',2.68),('9650','2013-05-16','11:45:00',4.11),('9650','2013-05-16','11:50:00',7.44),('9650','2013-05-16','11:55:00',5.65),('9650','2013-05-16','12:00:00',5.49),('9650','2013-05-16','12:05:00',5.49),('9650','2013-05-16','12:10:00',5.36),('9650','2013-05-16','12:15:00',3.78),('9650','2013-05-16','12:20:00',5.19),('9650','2013-05-16','12:25:00',4.99),('9650','2013-05-16','12:30:00',4.77),('9650','2013-05-16','12:35:00',4.98),('9650','2013-05-16','12:40:00',6.91),('9650','2013-05-16','12:45:00',8.03),('9650','2013-05-16','12:50:00',7.87),('9650','2013-05-16','12:55:00',7.73),('9650','2013-05-16','13:00:00',6.95),('9650','2013-05-16','13:05:00',7.49),('9650','2013-05-16','13:10:00',6.39),('9650','2013-05-16','13:15:00',7.56),('9650','2013-05-16','13:20:00',7.77),('9650','2013-05-16','13:25:00',7.46),('9650','2013-05-16','13:30:00',5.68),('9650','2013-05-16','13:35:00',8.01),('9650','2013-05-16','13:40:00',6.89),('9650','2013-05-16','13:45:00',7.54),('9650','2013-05-16','13:50:00',7.48),('9650','2013-05-16','13:55:00',8.63),('9650','2013-05-16','14:00:00',5.75),('9650','2013-05-16','14:05:00',5.61),('9650','2013-05-16','14:10:00',7.12),('9650','2013-05-16','14:15:00',7.2),('9650','2013-05-16','14:20:00',7.9),('9650','2013-05-16','14:25:00',6.9),('9650','2013-05-16','14:30:00',7.66),('9650','2013-05-16','14:35:00',7.55),('9650','2013-05-16','14:40:00',5.74),('9650','2013-05-16','14:45:00',5.69),('9650','2013-05-16','14:50:00',8.39),('9650','2013-05-16','14:55:00',4.39),('9650','2013-05-16','15:00:00',7.49),('9650','2013-05-16','15:05:00',5.92),('9650','2013-05-16','15:10:00',2.68),('9650','2013-05-16','15:15:00',6.87),('9650','2013-05-16','15:20:00',4.89),('9650','2013-05-16','15:25:00',3.83),('9650','2013-05-16','15:30:00',3.48),('9650','2013-05-16','15:35:00',6.17),('9650','2013-05-16','15:40:00',6.87),('9650','2013-05-16','15:45:00',2.63),('9650','2013-05-16','15:50:00',5.82),('9650','2013-05-16','15:55:00',7.8),('9650','2013-05-16','16:00:00',8.08),('9650','2013-05-16','16:05:00',2.81),('9650','2013-05-16','16:10:00',5.86),('9650','2013-05-16','16:15:00',6.6),('9650','2013-05-16','16:20:00',5.85),('9650','2013-05-16','16:25:00',7.06),('9650','2013-05-16','16:30:00',7.46),('9650','2013-05-16','16:35:00',7.01),('9650','2013-05-16','16:40:00',7.06),('9650','2013-05-16','16:45:00',6.85),('9650','2013-05-16','16:50:00',6.49),('9650','2013-05-16','16:55:00',6.32),('9650','2013-05-16','17:00:00',6.26),('9650','2013-05-16','17:05:00',6.08),('9650','2013-05-16','17:10:00',6.02),('9650','2013-05-16','17:15:00',5.95),('9650','2013-05-16','17:20:00',5.86),('9650','2013-05-16','17:25:00',5.72),('9650','2013-05-16','17:30:00',5.64),('9650','2013-05-16','17:35:00',5.51),('9650','2013-05-16','17:40:00',5.4),('9650','2013-05-16','17:45:00',5.21),('9650','2013-05-16','17:50:00',5.17),('9650','2013-05-16','17:55:00',5.01),('9650','2013-05-16','18:00:00',4.88),('9650','2013-05-16','18:05:00',4.81),('9650','2013-05-16','18:10:00',4.61),('9650','2013-05-16','18:15:00',4.43),('9650','2013-05-16','18:20:00',4.29),('9650','2013-05-16','18:25:00',4.17),('9650','2013-05-16','18:30:00',4.02),('9650','2013-05-16','18:35:00',3.92),('9650','2013-05-16','18:40:00',3.69),('9650','2013-05-16','18:45:00',3.51),('9650','2013-05-16','18:50:00',3.32),('9650','2013-05-16','18:55:00',3.21),('9650','2013-05-15','09:15:00',1.51),('9650','2013-05-15','09:20:00',1.89),('9650','2013-05-15','09:25:00',2.5),('9650','2013-05-15','09:30:00',2.41),('9650','2013-05-15','09:35:00',2.59),('9650','2013-05-15','09:40:00',2.82),('9650','2013-05-15','09:45:00',3.23),('9650','2013-05-15','09:50:00',2.18),('9650','2013-05-15','09:55:00',2),('9650','2013-05-15','10:00:00',2.31),('9650','2013-05-15','10:05:00',2.13),('9650','2013-05-15','10:10:00',2.04),('9650','2013-05-15','10:15:00',2.6),('9650','2013-05-15','10:20:00',3.36),('9650','2013-05-15','10:25:00',3.06),('9650','2013-05-15','10:30:00',3.12),('9650','2013-05-15','10:35:00',2.37),('9650','2013-05-15','10:40:00',2.47),('9650','2013-05-15','10:45:00',2.22),('9650','2013-05-15','10:50:00',2.43),('9650','2013-05-15','10:55:00',2.72),('9650','2013-05-15','11:00:00',5.89),('9650','2013-05-15','11:05:00',5.11),('9650','2013-05-15','11:10:00',5.02),('9650','2013-05-15','11:15:00',3.77),('9650','2013-05-15','11:20:00',2.19),('9650','2013-05-15','11:25:00',2.34),('9650','2013-05-15','11:30:00',2.72),('9650','2013-05-15','11:35:00',4.08),('9650','2013-05-15','11:40:00',6.33),('9650','2013-05-15','11:45:00',5.6),('9650','2013-05-15','11:50:00',5.71),('9650','2013-05-15','11:55:00',4.3),('9650','2013-05-15','12:00:00',3.28),('9650','2013-05-15','12:05:00',2.99),('9650','2013-05-15','12:10:00',3),('9650','2013-05-15','12:15:00',3.91),('9650','2013-05-15','12:20:00',3.53),('9650','2013-05-15','12:25:00',3.7),('9650','2013-05-15','12:30:00',5.47),('9650','2013-05-15','12:35:00',5.94),('9650','2013-05-15','12:40:00',7.29),('9650','2013-05-15','12:45:00',5.54),('9650','2013-05-15','12:50:00',4.26),('9650','2013-05-15','12:55:00',6.68),('9650','2013-05-15','13:00:00',6.85),('9650','2013-05-15','13:05:00',6.75),('9650','2013-05-15','13:10:00',6.85),('9650','2013-05-15','13:15:00',5.91),('9650','2013-05-15','13:20:00',5.38),('9650','2013-05-15','13:25:00',7.04),('9650','2013-05-15','13:30:00',6.94),('9650','2013-05-15','13:35:00',6.91),('9650','2013-05-15','13:40:00',6.85),('9650','2013-05-15','13:45:00',6.87),('9650','2013-05-15','13:50:00',6.92),('9650','2013-05-15','13:55:00',6.98),('9650','2013-05-15','14:00:00',6.94),('9650','2013-05-15','14:05:00',6.99),('9650','2013-05-15','14:10:00',6.95),('9650','2013-05-15','14:15:00',6.92),('9650','2013-05-15','14:20:00',6.9),('9650','2013-05-15','14:25:00',6.79),('9650','2013-05-15','14:30:00',6.87),('9650','2013-05-15','14:35:00',6.76),('9650','2013-05-15','14:40:00',6.76),('9650','2013-05-15','14:45:00',6.76),('9650','2013-05-15','14:50:00',6.32),('9650','2013-05-15','14:55:00',5.73),('9650','2013-05-15','15:00:00',6.72),('9650','2013-05-15','15:05:00',6.67),('9650','2013-05-15','15:10:00',6.58),('9650','2013-05-15','15:15:00',6.01),('9650','2013-05-15','15:20:00',6.41),('9650','2013-05-15','15:25:00',6.5),('9650','2013-05-15','15:30:00',6.4),('9650','2013-05-15','15:35:00',6.15),('9650','2013-05-15','15:40:00',6.35),('9650','2013-05-15','15:45:00',6.17),('9650','2013-05-15','15:50:00',6.14),('9650','2013-05-15','15:55:00',6.13),('9650','2013-05-15','16:00:00',6.1),('9650','2013-05-15','16:05:00',5.78),('9650','2013-05-15','16:10:00',5.9),('9650','2013-05-15','16:15:00',5.42),('9650','2013-05-15','16:20:00',5.84),('9650','2013-05-15','16:25:00',5.63),('9650','2013-05-15','16:30:00',5.63),('9650','2013-05-15','16:35:00',5.35),('9650','2013-05-15','16:40:00',3.23),('9650','2013-05-15','16:45:00',2.74),('9650','2013-05-15','16:50:00',3.87),('9650','2013-05-15','16:55:00',3.47),('9650','2013-05-15','17:00:00',3.36),('9650','2013-05-15','17:05:00',1.52),('9650','2013-05-15','17:10:00',1.58),('9650','2013-05-15','17:15:00',2.67),('9650','2013-05-15','17:20:00',3.09),('9650','2013-05-15','17:25:00',3.15),('9650','2013-05-15','17:30:00',3.95),('9650','2013-05-15','17:35:00',3.78),('9650','2013-05-15','17:40:00',3.1),('9650','2013-05-15','17:45:00',2.1),('9650','2013-05-15','17:50:00',1.24),('9650','2013-05-15','18:20:00',1.08),('9650','2013-05-15','18:25:00',1.29),('9650','2013-05-15','18:30:00',1.61),('9650','2013-05-15','18:35:00',1.96),('9650','2013-05-15','18:40:00',2.18),('9650','2013-05-15','18:45:00',2.29),('9650','2013-05-15','18:50:00',2.25),('9650','2013-05-15','18:55:00',2.35),('9650','2013-05-15','19:00:00',2.36),('9650','2013-05-15','19:05:00',2.11),('9650','2013-05-15','19:10:00',1.71),('9650','2013-05-15','19:15:00',1.4),('9650','2013-05-15','19:20:00',1.15),('9650','2013-05-14','07:50:00',1.05),('9650','2013-05-14','07:55:00',1.04),('9650','2013-05-14','08:00:00',1.01),('9650','2013-05-14','08:10:00',1.1),('9650','2013-05-14','08:15:00',1.21),('9650','2013-05-14','08:20:00',1.29),('9650','2013-05-14','08:25:00',1.37),('9650','2013-05-14','08:30:00',1.49),('9650','2013-05-14','08:35:00',1.69),('9650','2013-05-14','08:40:00',1.85),('9650','2013-05-14','08:45:00',2.04),('9650','2013-05-14','08:50:00',2.21),('9650','2013-05-14','08:55:00',2.37),('9650','2013-05-14','09:00:00',2.35),('9650','2013-05-14','09:05:00',2.6),('9650','2013-05-14','09:10:00',2.68),('9650','2013-05-14','09:15:00',2.81),('9650','2013-05-14','09:20:00',2.85),('9650','2013-05-14','09:25:00',2.99),('9650','2013-05-14','09:30:00',3.26),('9650','2013-05-14','09:35:00',3.4),('9650','2013-05-14','09:40:00',3.48),('9650','2013-05-14','09:45:00',3.61),('9650','2013-05-14','09:50:00',3.76),('9650','2013-05-14','09:55:00',3.85),('9650','2013-05-14','10:00:00',4),('9650','2013-05-14','10:05:00',4.11),('9650','2013-05-14','10:10:00',4.23),('9650','2013-05-14','10:15:00',4.21),('9650','2013-05-14','10:20:00',4.38),('9650','2013-05-14','10:25:00',4.65),('9650','2013-05-14','10:30:00',4.6),('9650','2013-05-14','10:35:00',4.82),('9650','2013-05-14','10:40:00',5.01),('9650','2013-05-14','10:45:00',5.13),('9650','2013-05-14','10:50:00',5.18),('9650','2013-05-14','10:55:00',5.05),('9650','2013-05-14','11:00:00',5.11),('9650','2013-05-14','11:05:00',5.42),('9650','2013-05-14','11:10:00',5.53),('9650','2013-05-14','11:15:00',5.63),('9650','2013-05-14','11:20:00',5.43),('9650','2013-05-14','11:25:00',5.82),('9650','2013-05-14','11:30:00',5.78),('9650','2013-05-14','11:35:00',5.79),('9650','2013-05-14','11:40:00',4.71),('9650','2013-05-14','11:45:00',4.37),('9650','2013-05-14','11:50:00',3.63),('9650','2013-05-14','11:55:00',2.8),('9650','2013-05-14','12:00:00',3.2),('9650','2013-05-14','12:05:00',5.1),('9650','2013-05-14','12:10:00',7.22),('9650','2013-05-14','12:15:00',7.06),('9650','2013-05-14','12:20:00',4.61),('9650','2013-05-14','12:25:00',6.13),('9650','2013-05-14','12:30:00',4.82),('9650','2013-05-14','12:35:00',5.61),('9650','2013-05-14','12:40:00',7.91),('9650','2013-05-14','12:45:00',4.33),('9650','2013-05-14','12:50:00',4.33),('9650','2013-05-14','12:55:00',4.75),('9650','2013-05-14','13:00:00',4.79),('9650','2013-05-14','13:05:00',5.82),('9650','2013-05-14','13:10:00',4.95),('9650','2013-05-14','13:15:00',4.47),('9650','2013-05-14','13:20:00',4.83),('9650','2013-05-14','13:25:00',4.83),('9650','2013-05-14','13:30:00',4.89),('9650','2013-05-14','13:35:00',4.27),('9650','2013-05-14','13:40:00',4.72),('9650','2013-05-14','13:45:00',4.39),('9650','2013-05-14','13:50:00',3.75),('9650','2013-05-14','13:55:00',3.8),('9650','2013-05-14','14:00:00',3.35),('9650','2013-05-14','14:05:00',3.07),('9650','2013-05-14','14:10:00',3.2),('9650','2013-05-14','14:15:00',3.16),('9650','2013-05-14','14:20:00',3.32),('9650','2013-05-14','14:25:00',3.06),('9650','2013-05-14','14:30:00',2.68),('9650','2013-05-14','14:35:00',2.59),('9650','2013-05-14','14:40:00',2.86),('9650','2013-05-14','14:45:00',2.6),('9650','2013-05-14','14:50:00',2.55),('9650','2013-05-14','14:55:00',2.58),('9650','2013-05-14','15:00:00',2.56),('9650','2013-05-14','15:05:00',1.99),('9650','2013-05-14','15:10:00',1.55),('9650','2013-05-14','15:15:00',1.47),('9650','2013-05-14','15:20:00',1.4),('9650','2013-05-14','15:25:00',1.35),('9650','2013-05-14','15:30:00',1.47),('9650','2013-05-14','15:35:00',1.43),('9650','2013-05-14','15:40:00',1.52),('9650','2013-05-14','15:45:00',1.94),('9650','2013-05-14','15:50:00',2.72),('9650','2013-05-14','15:55:00',3.54),('9650','2013-05-14','16:00:00',3.44),('9650','2013-05-14','16:05:00',3.3),('9650','2013-05-14','16:10:00',3.01),('9650','2013-05-14','16:15:00',2.68),('9650','2013-05-14','16:20:00',2.91),('9650','2013-05-14','16:25:00',2.94),('9650','2013-05-14','16:30:00',2.58),('9650','2013-05-14','16:35:00',2.41),('9650','2013-05-14','16:40:00',2.27),('9650','2013-05-14','16:45:00',2.17),('9650','2013-05-14','16:50:00',2.22),('9650','2013-05-14','16:55:00',2.59),('9650','2013-05-14','17:00:00',3.18),('9650','2013-05-14','17:05:00',3.9),('9650','2013-05-14','17:10:00',5.15),('9650','2013-05-14','17:15:00',6.42),('9650','2013-05-14','17:20:00',4.13),('9650','2013-05-14','17:25:00',1.98),('9650','2013-05-14','17:30:00',2.09),('9650','2013-05-14','17:35:00',1.72),('9650','2013-05-14','17:40:00',1.48),('9650','2013-05-14','17:45:00',1.56),('9650','2013-05-14','17:50:00',1.57),('9650','2013-05-14','17:55:00',1.51),('9650','2013-05-14','18:00:00',1.36),('9650','2013-05-14','18:05:00',1.08),('9650','2013-05-13','08:10:00',1.03),('9650','2013-05-13','08:15:00',1.12),('9650','2013-05-13','08:20:00',1.24),('9650','2013-05-13','08:25:00',1.34),('9650','2013-05-13','08:30:00',1.59),('9650','2013-05-13','08:35:00',1.74),('9650','2013-05-13','08:40:00',1.87),('9650','2013-05-13','08:45:00',2.03),('9650','2013-05-13','08:50:00',2.19),('9650','2013-05-13','08:55:00',2.32),('9650','2013-05-13','09:00:00',2.46),('9650','2013-05-13','09:05:00',2.59),('9650','2013-05-13','09:10:00',2.77),('9650','2013-05-13','09:15:00',2.94),('9650','2013-05-13','09:20:00',3.06),('9650','2013-05-13','09:25:00',3.23),('9650','2013-05-13','09:30:00',3.4),('9650','2013-05-13','09:35:00',3.54),('9650','2013-05-13','09:40:00',3.7),('9650','2013-05-13','09:45:00',3.82),('9650','2013-05-13','09:50:00',3.93),('9650','2013-05-13','09:55:00',4.08),('9650','2013-05-13','10:00:00',4.22),('9650','2013-05-13','10:05:00',4.35),('9650','2013-05-13','10:10:00',4.49),('9650','2013-05-13','10:15:00',4.57),('9650','2013-05-13','10:20:00',4.69),('9650','2013-05-13','10:25:00',4.81),('9650','2013-05-13','10:30:00',4.91),('9650','2013-05-13','10:35:00',5.04),('9650','2013-05-13','10:40:00',5.16),('9650','2013-05-13','10:45:00',5.27),('9650','2013-05-13','10:50:00',5.36),('9650','2013-05-13','10:55:00',5.46),('9650','2013-05-13','11:00:00',5.57),('9650','2013-05-13','11:05:00',5.65),('9650','2013-05-13','11:10:00',5.74),('9650','2013-05-13','11:15:00',5.82),('9650','2013-05-13','11:20:00',5.91),('9650','2013-05-13','11:25:00',6),('9650','2013-05-13','11:30:00',6.07),('9650','2013-05-13','11:35:00',6.13),('9650','2013-05-13','11:40:00',6.2),('9650','2013-05-13','11:45:00',6.29),('9650','2013-05-13','11:50:00',6.37),('9650','2013-05-13','11:55:00',6.45),('9650','2013-05-13','12:00:00',6.49),('9650','2013-05-13','12:05:00',6.51),('9650','2013-05-13','12:10:00',6.57),('9650','2013-05-13','12:15:00',6.64),('9650','2013-05-13','12:20:00',6.73),('9650','2013-05-13','12:25:00',6.78),('9650','2013-05-13','12:30:00',6.84),('9650','2013-05-13','12:35:00',6.89),('9650','2013-05-13','12:40:00',6.97),('9650','2013-05-13','12:45:00',7),('9650','2013-05-13','12:50:00',7.05),('9650','2013-05-13','12:55:00',7.1),('9650','2013-05-13','13:00:00',7.2),('9650','2013-05-13','13:05:00',7.21),('9650','2013-05-13','13:10:00',7.23),('9650','2013-05-13','13:15:00',7.26),('9650','2013-05-13','13:20:00',7.25),('9650','2013-05-13','13:25:00',7.29),('9650','2013-05-13','13:30:00',7.29),('9650','2013-05-13','13:35:00',7.27),('9650','2013-05-13','13:40:00',7.33),('9650','2013-05-13','13:45:00',7.35),('9650','2013-05-13','13:50:00',7.34),('9650','2013-05-13','13:55:00',7.37),('9650','2013-05-13','14:00:00',7.34),('9650','2013-05-13','14:05:00',7.31),('9650','2013-05-13','14:10:00',7.34),('9650','2013-05-13','14:15:00',7.34),('9650','2013-05-13','14:20:00',7.34),('9650','2013-05-13','14:25:00',7.38),('9650','2013-05-13','14:30:00',7.35),('9650','2013-05-13','14:35:00',7.28),('9650','2013-05-13','14:40:00',7.32),('9650','2013-05-13','14:45:00',7.43),('9650','2013-05-13','14:50:00',7.46),('9650','2013-05-13','14:55:00',7.47),('9650','2013-05-13','15:00:00',7.47),('9650','2013-05-13','15:05:00',7.51),('9650','2013-05-13','15:10:00',7.49),('9650','2013-05-13','15:15:00',7.47),('9650','2013-05-13','15:20:00',7.44),('9650','2013-05-13','15:25:00',7.4),('9650','2013-05-13','15:30:00',7.38),('9650','2013-05-13','15:35:00',7.35),('9650','2013-05-13','15:40:00',7.28),('9650','2013-05-13','15:45:00',7.19),('9650','2013-05-13','15:50:00',7.18),('9650','2013-05-13','15:55:00',7.11),('9650','2013-05-13','16:00:00',7.05),('9650','2013-05-13','16:05:00',6.97),('9650','2013-05-13','16:10:00',6.92),('9650','2013-05-13','16:15:00',6.84),('9650','2013-05-13','16:20:00',6.79),('9650','2013-05-13','16:25:00',6.75),('9650','2013-05-13','16:30:00',6.66),('9650','2013-05-13','16:35:00',6.59),('9650','2013-05-13','16:40:00',6.52),('9650','2013-05-13','16:45:00',6.39),('9650','2013-05-13','16:50:00',6.29),('9650','2013-05-13','16:55:00',6.22),('9650','2013-05-13','17:00:00',6.13),('9650','2013-05-13','17:05:00',6.01),('9650','2013-05-13','17:10:00',5.88),('9650','2013-05-13','17:15:00',5.79),('9650','2013-05-13','17:20:00',5.67),('9650','2013-05-13','17:25:00',5.59),('9650','2013-05-13','17:30:00',5.45),('9650','2013-05-13','17:35:00',5.28),('9650','2013-05-13','17:40:00',5.15),('9650','2013-05-13','17:45:00',5.03),('9650','2013-05-13','17:50:00',4.92),('9650','2013-05-13','17:55:00',4.8),('9650','2013-05-13','18:00:00',4.65),('9650','2013-05-13','18:05:00',4.51),('9650','2013-05-13','18:10:00',4.39),('9650','2013-05-13','18:15:00',4.24),('9650','2013-05-13','18:20:00',4.01),('9650','2013-05-13','18:25:00',3.95),('9650','2013-05-13','18:30:00',3.77),('9650','2013-05-13','18:35:00',3.67),('9650','2013-05-13','18:40:00',3.47),('9650','2013-05-13','18:45:00',3.32),('9650','2013-05-13','18:50:00',3.13),('9650','2013-05-13','18:55:00',2.97),('9650','2013-05-13','19:00:00',2.67),('9650','2013-05-13','19:05:00',2.6),('9650','2013-05-13','19:10:00',2.37),('9650','2013-05-13','19:15:00',2.12),('9650','2013-05-13','19:20:00',1.98),('9650','2013-05-13','19:25:00',1.7),('9650','2013-05-13','19:30:00',1.57),('9650','2013-05-13','19:35:00',1.29),('9650','2013-05-12','08:00:00',1.05),('9650','2013-05-12','08:05:00',1.07),('9650','2013-05-12','08:10:00',1.17),('9650','2013-05-12','08:15:00',1.24),('9650','2013-05-12','08:20:00',1.27),('9650','2013-05-12','08:25:00',1.3),('9650','2013-05-12','08:30:00',1.32),('9650','2013-05-12','08:35:00',1.5),('9650','2013-05-12','08:40:00',1.79),('9650','2013-05-12','08:45:00',1.97),('9650','2013-05-12','08:50:00',2.14),('9650','2013-05-12','08:55:00',2.26),('9650','2013-05-12','09:00:00',2.38),('9650','2013-05-12','09:05:00',2.53),('9650','2013-05-12','09:10:00',2.66),('9650','2013-05-12','09:15:00',2.8),('9650','2013-05-12','09:20:00',2.94),('9650','2013-05-12','09:25:00',3.1),('9650','2013-05-12','09:30:00',3.26),('9650','2013-05-12','09:35:00',3.4),('9650','2013-05-12','09:40:00',3.6),('9650','2013-05-12','09:45:00',3.82),('9650','2013-05-12','09:50:00',3.62),('9650','2013-05-12','09:55:00',4.31),('9650','2013-05-12','10:00:00',4.41),('9650','2013-05-12','10:05:00',4.57),('9650','2013-05-12','10:10:00',4.49),('9650','2013-05-12','10:15:00',4.7),('9650','2013-05-12','10:20:00',4.95),('9650','2013-05-12','10:25:00',5.07),('9650','2013-05-12','10:30:00',4.52),('9650','2013-05-12','10:35:00',1.86),('9650','2013-05-12','10:40:00',1.65),('9650','2013-05-12','10:45:00',1.56),('9650','2013-05-12','10:50:00',4.29),('9650','2013-05-12','10:55:00',3.9),('9650','2013-05-12','11:00:00',4.53),('9650','2013-05-12','11:05:00',5.44),('9650','2013-05-12','11:10:00',4.76),('9650','2013-05-12','11:15:00',2.75),('9650','2013-05-12','11:20:00',2.56),('9650','2013-05-12','11:25:00',2.84),('9650','2013-05-12','11:30:00',2.89),('9650','2013-05-12','11:35:00',4.02),('9650','2013-05-12','11:40:00',5.5),('9650','2013-05-12','11:45:00',4.16),('9650','2013-05-12','11:50:00',3.34),('9650','2013-05-12','11:55:00',3.07),('9650','2013-05-12','12:00:00',3.2),('9650','2013-05-12','12:05:00',3.18),('9650','2013-05-12','12:10:00',6.16),('9650','2013-05-12','12:15:00',3.91),('9650','2013-05-12','12:20:00',2.01),('9650','2013-05-12','12:25:00',1.94),('9650','2013-05-12','12:30:00',2.3),('9650','2013-05-12','12:35:00',8.39),('9650','2013-05-12','12:40:00',7.94),('9650','2013-05-12','12:45:00',5.48),('9650','2013-05-12','12:50:00',5.86),('9650','2013-05-12','12:55:00',4.41),('9650','2013-05-12','13:00:00',7.25),('9650','2013-05-12','13:05:00',7.78),('9650','2013-05-12','13:10:00',6.73),('9650','2013-05-12','13:15:00',5.5),('9650','2013-05-12','13:20:00',8.25),('9650','2013-05-12','13:25:00',8.04),('9650','2013-05-12','13:30:00',7.86),('9650','2013-05-12','13:35:00',8.37),('9650','2013-05-12','13:40:00',8.31),('9650','2013-05-12','13:45:00',6.22),('9650','2013-05-12','13:50:00',2.92),('9650','2013-05-12','13:55:00',3.45),('9650','2013-05-12','14:00:00',2.06),('9650','2013-05-12','14:05:00',6.56),('9650','2013-05-12','14:10:00',8.62),('9650','2013-05-12','14:15:00',8.39),('9650','2013-05-12','14:20:00',8.06),('9650','2013-05-12','14:25:00',8.03),('9650','2013-05-12','14:30:00',7.03),('9650','2013-05-12','14:35:00',3.15),('9650','2013-05-12','14:40:00',6.09),('9650','2013-05-12','14:45:00',4.3),('9650','2013-05-12','14:50:00',5.34),('9650','2013-05-12','14:55:00',8.62),('9650','2013-05-12','15:00:00',6.78),('9650','2013-05-12','15:05:00',5.11),('9650','2013-05-12','15:10:00',2.25),('9650','2013-05-12','15:15:00',1.84),('9650','2013-05-12','15:20:00',1.94),('9650','2013-05-12','15:25:00',1.46),('9650','2013-05-12','15:30:00',1.44),('9650','2013-05-12','15:35:00',1.36),('9650','2013-05-12','15:40:00',2.44),('9650','2013-05-12','15:45:00',1.48),('9650','2013-05-12','15:50:00',1.34),('9650','2013-05-12','15:55:00',1.19),('9650','2013-05-12','16:00:00',2.33),('9650','2013-05-12','16:05:00',3.7),('9650','2013-05-12','16:10:00',4.05),('9650','2013-05-12','16:15:00',2.43),('9650','2013-05-12','16:20:00',2.43),('9650','2013-05-12','16:25:00',2.49),('9650','2013-05-12','16:30:00',4.58),('9650','2013-05-12','16:35:00',2.26),('9650','2013-05-12','16:40:00',2.85),('9650','2013-05-12','16:45:00',4.98),('9650','2013-05-12','16:50:00',6.35),('9650','2013-05-12','16:55:00',6.74),('9650','2013-05-12','17:00:00',6.51),('9650','2013-05-12','17:05:00',6.52),('9650','2013-05-12','17:10:00',2.83),('9650','2013-05-12','17:15:00',6.02),('9650','2013-05-12','17:20:00',7.2),('9650','2013-05-12','17:25:00',6.86),('9650','2013-05-12','17:30:00',6.62),('9650','2013-05-12','17:35:00',6.23),('9650','2013-05-12','17:40:00',5.89),('9650','2013-05-12','17:45:00',5.7),('9650','2013-05-12','17:50:00',4.73),('9650','2013-05-12','17:55:00',2.96),('9650','2013-05-12','18:00:00',4.03),('9650','2013-05-12','18:05:00',2.24),('9650','2013-05-12','18:10:00',3.32),('9650','2013-05-12','18:15:00',3.69),('9650','2013-05-12','18:20:00',2.37),('9650','2013-05-11','08:00:00',1.1),('9650','2013-05-11','08:05:00',1.36),('9650','2013-05-11','08:10:00',1.7),('9650','2013-05-11','08:15:00',2.09),('9650','2013-05-11','08:20:00',2.01),('9650','2013-05-11','08:25:00',1.94),('9650','2013-05-11','08:30:00',1.54),('9650','2013-05-11','08:35:00',1.38),('9650','2013-05-11','08:40:00',1.48),('9650','2013-05-11','08:45:00',2.35),('9650','2013-05-11','08:50:00',1.95),('9650','2013-05-11','08:55:00',1.73),('9650','2013-05-11','09:00:00',1.93),('9650','2013-05-11','09:05:00',2.43),('9650','2013-05-11','09:10:00',2.05),('9650','2013-05-11','09:15:00',2.5),('9650','2013-05-11','09:20:00',3.76),('9650','2013-05-11','09:25:00',2.59),('9650','2013-05-11','09:30:00',1.96),('9650','2013-05-11','09:35:00',1.93),('9650','2013-05-11','09:40:00',1.85),('9650','2013-05-11','09:45:00',3.99),('9650','2013-05-11','09:50:00',4.8),('9650','2013-05-11','09:55:00',4.1),('9650','2013-05-11','10:00:00',4.69),('9650','2013-05-11','10:05:00',4.53),('9650','2013-05-11','10:10:00',4.38),('9650','2013-05-11','10:15:00',1.63),('9650','2013-05-11','10:20:00',1.68),('9650','2013-05-11','10:25:00',4.24),('9650','2013-05-11','10:30:00',2.12),('9650','2013-05-11','10:35:00',1.96),('9650','2013-05-11','10:40:00',2.44),('9650','2013-05-11','10:45:00',1.78),('9650','2013-05-11','10:50:00',4.07),('9650','2013-05-11','10:55:00',5.62),('9650','2013-05-11','11:00:00',5.55),('9650','2013-05-11','11:05:00',5.86),('9650','2013-05-11','11:10:00',6.48),('9650','2013-05-11','11:15:00',6.62),('9650','2013-05-11','11:20:00',6.61),('9650','2013-05-11','11:25:00',6.75),('9650','2013-05-11','11:30:00',6.74),('9650','2013-05-11','11:35:00',6.18),('9650','2013-05-11','11:40:00',5.68),('9650','2013-05-11','11:45:00',6.09),('9650','2013-05-11','11:50:00',3.28),('9650','2013-05-11','11:55:00',2.57),('9650','2013-05-11','12:00:00',4.33),('9650','2013-05-11','12:05:00',4.69),('9650','2013-05-11','12:10:00',3.64),('9650','2013-05-11','12:15:00',2.2),('9650','2013-05-11','12:20:00',1.97),('9650','2013-05-11','12:25:00',2.02),('9650','2013-05-11','12:30:00',4),('9650','2013-05-11','12:35:00',3.36),('9650','2013-05-11','12:40:00',4.76),('9650','2013-05-11','12:45:00',7.09),('9650','2013-05-11','12:50:00',6),('9650','2013-05-11','12:55:00',4.92),('9650','2013-05-11','13:00:00',2.35),('9650','2013-05-11','13:05:00',2.77),('9650','2013-05-11','13:10:00',7.1),('9650','2013-05-11','13:15:00',2.46),('9650','2013-05-11','13:20:00',5.61),('9650','2013-05-11','13:25:00',4.99),('9650','2013-05-11','13:30:00',7.64),('9650','2013-05-11','13:35:00',7.52),('9650','2013-05-11','13:40:00',5.76),('9650','2013-05-11','13:45:00',7.13),('9650','2013-05-11','13:50:00',6.93),('9650','2013-05-11','13:55:00',3.94),('9650','2013-05-11','14:00:00',4.87),('9650','2013-05-11','14:05:00',8),('9650','2013-05-11','14:10:00',8.87),('9650','2013-05-11','14:15:00',6.79),('9650','2013-05-11','14:20:00',8.29),('9650','2013-05-11','14:25:00',7.86),('9650','2013-05-11','14:30:00',7.94),('9650','2013-05-11','14:35:00',7.94),('9650','2013-05-11','14:40:00',7.84),('9650','2013-05-11','14:45:00',7.81),('9650','2013-05-11','14:50:00',7.98),('9650','2013-05-11','14:55:00',6.96),('9650','2013-05-11','15:00:00',7.7),('9650','2013-05-11','15:05:00',7.96),('9650','2013-05-11','15:10:00',7),('9650','2013-05-11','15:15:00',8.15),('9650','2013-05-11','15:20:00',4.05),('9650','2013-05-11','15:25:00',7.61),('9650','2013-05-11','15:30:00',7.39),('9650','2013-05-11','15:35:00',7.35),('9650','2013-05-11','15:40:00',7.28),('9650','2013-05-11','15:45:00',7.25),('9650','2013-05-11','15:50:00',7.08),('9650','2013-05-11','15:55:00',6.96),('9650','2013-05-11','16:00:00',6.88),('9650','2013-05-11','16:05:00',6.62),('9650','2013-05-11','16:10:00',6.78),('9650','2013-05-11','16:15:00',6.7),('9650','2013-05-11','16:20:00',6.73),('9650','2013-05-11','16:25:00',6.58),('9650','2013-05-11','16:30:00',6.59),('9650','2013-05-11','16:35:00',6.6),('9650','2013-05-11','16:40:00',6.77),('9650','2013-05-11','16:45:00',6.84),('9650','2013-05-11','16:50:00',6.23),('9650','2013-05-11','16:55:00',7.62),('9650','2013-05-11','17:00:00',7.44),('9650','2013-05-11','17:05:00',5.91),('9650','2013-05-11','17:10:00',7.28),('9650','2013-05-11','17:15:00',6.51),('9650','2013-05-11','17:20:00',6.64),('9650','2013-05-11','17:25:00',5.32),('9650','2013-05-11','17:30:00',4.38),('9650','2013-05-11','17:35:00',5.54),('9650','2013-05-11','17:40:00',3.95),('9650','2013-05-11','17:45:00',3.36),('9650','2013-05-11','17:50:00',3),('9650','2013-05-11','17:55:00',1.87),('9650','2013-05-11','18:00:00',3.82),('9650','2013-05-11','18:05:00',4.21),('9650','2013-05-11','18:10:00',4.4),('9650','2013-05-11','18:15:00',3.37),('9650','2013-05-11','18:20:00',2.02),('9650','2013-05-11','18:25:00',3.13),('9650','2013-05-11','18:30:00',2.47),('9650','2013-05-11','18:35:00',2.98),('9650','2013-05-11','18:40:00',1.87),('9650','2013-05-11','18:45:00',1.32),('9650','2013-05-11','18:50:00',1.33),('9650','2013-05-11','18:55:00',1.43),('9650','2013-05-11','19:00:00',2.12),('9650','2013-05-11','19:05:00',1.27),('9650','2013-05-11','19:10:00',1.78),('9650','2013-05-11','19:15:00',1.37),('9650','2013-05-11','19:20:00',1.06),('9650','2014-03-30','09:10:00',1.03),('9650','2014-03-30','09:15:00',1.15),('9650','2014-03-30','09:20:00',1.25),('9650','2014-03-30','09:25:00',1.38),('9650','2014-03-30','09:30:00',1.5),('9650','2014-03-30','09:35:00',1.63),('9650','2014-03-30','09:40:00',1.76),('9650','2014-03-30','09:45:00',1.9),('9650','2014-03-30','09:50:00',2.03),('9650','2014-03-30','09:55:00',2.15),('9650','2014-03-30','10:00:00',2.3),('9650','2014-03-30','10:05:00',2.45),('9650','2014-03-30','10:10:00',2.58),('9650','2014-03-30','10:15:00',2.68),('9650','2014-03-30','10:20:00',2.82),('9650','2014-03-30','10:25:00',2.96),('9650','2014-03-30','10:30:00',3.1),('9650','2014-03-30','10:35:00',3.22),('9650','2014-03-30','10:40:00',3.33),('9650','2014-03-30','10:45:00',3.47),('9650','2014-03-30','10:50:00',3.59),('9650','2014-03-30','10:55:00',3.7),('9650','2014-03-30','11:00:00',3.81),('9650','2014-03-30','11:05:00',3.92),('9650','2014-03-30','11:10:00',4.05),('9650','2014-03-30','11:15:00',4.14),('9650','2014-03-30','11:20:00',4.25),('9650','2014-03-30','11:25:00',4.34),('9650','2014-03-30','11:30:00',4.43),('9650','2014-03-30','11:35:00',4.55),('9650','2014-03-30','11:40:00',4.6),('9650','2014-03-30','11:45:00',4.73),('9650','2014-03-30','11:50:00',4.85),('9650','2014-03-30','11:55:00',4.97),('9650','2014-03-30','12:00:00',5.03),('9650','2014-03-30','12:05:00',5.06),('9650','2014-03-30','12:10:00',5.17),('9650','2014-03-30','12:15:00',5.27),('9650','2014-03-30','12:20:00',5.33),('9650','2014-03-30','12:25:00',5.38),('9650','2014-03-30','12:30:00',5.48),('9650','2014-03-30','12:35:00',5.59),('9650','2014-03-30','12:40:00',5.64),('9650','2014-03-30','12:45:00',5.64),('9650','2014-03-30','12:50:00',5.69),('9650','2014-03-30','12:55:00',5.71),('9650','2014-03-30','13:00:00',5.81),('9650','2014-03-30','13:05:00',5.91),('9650','2014-03-30','13:10:00',5.96),('9650','2014-03-30','13:15:00',6.02),('9650','2014-03-30','13:20:00',6.05),('9650','2014-03-30','13:25:00',6.06),('9650','2014-03-30','13:30:00',6.13),('9650','2014-03-30','13:35:00',6.17),('9650','2014-03-30','13:40:00',6.24),('9650','2014-03-30','13:45:00',6.29),('9650','2014-03-30','13:50:00',6.31),('9650','2014-03-30','13:55:00',6.32),('9650','2014-03-30','14:00:00',6.34),('9650','2014-03-30','14:05:00',6.35),('9650','2014-03-30','14:10:00',6.35),('9650','2014-03-30','14:15:00',6.37),('9650','2014-03-30','14:20:00',6.38),('9650','2014-03-30','14:25:00',6.41),('9650','2014-03-30','14:30:00',6.4),('9650','2014-03-30','14:35:00',6.39),('9650','2014-03-30','14:40:00',6.42),('9650','2014-03-30','14:45:00',6.43),('9650','2014-03-30','14:50:00',6.38),('9650','2014-03-30','14:55:00',6.37),('9650','2014-03-30','15:00:00',6.38),('9650','2014-03-30','15:05:00',6.24),('9650','2014-03-30','15:10:00',6.16),('9650','2014-03-30','15:15:00',6.07),('9650','2014-03-30','15:20:00',6.03),('9650','2014-03-30','15:25:00',5.99),('9650','2014-03-30','15:30:00',5.87),('9650','2014-03-30','15:35:00',5.83),('9650','2014-03-30','15:40:00',5.8),('9650','2014-03-30','15:45:00',5.75),('9650','2014-03-30','15:50:00',5.61),('9650','2014-03-30','15:55:00',5.46),('9650','2014-03-30','16:00:00',5.3),('9650','2014-03-30','16:05:00',5.21),('9650','2014-03-30','16:10:00',5.1),('9650','2014-03-30','16:15:00',5),('9650','2014-03-30','16:20:00',4.93),('9650','2014-03-30','16:25:00',4.82),('9650','2014-03-30','16:30:00',4.77),('9650','2014-03-30','16:35:00',4.65),('9650','2014-03-30','16:40:00',4.55),('9650','2014-03-30','16:45:00',4.43),('9650','2014-03-30','16:50:00',4.29),('9650','2014-03-30','16:55:00',4.3),('9650','2014-03-30','17:00:00',4.18),('9650','2014-03-30','17:05:00',4.07),('9650','2014-03-30','17:10:00',3.95),('9650','2014-03-30','17:15:00',3.82),('9650','2014-03-30','17:20:00',3.62),('9650','2014-03-30','17:25:00',3.52),('9650','2014-03-30','17:30:00',3.5),('9650','2014-03-30','17:35:00',3.46),('9650','2014-03-30','17:40:00',3.29),('9650','2014-03-30','17:45:00',3.22),('9650','2014-03-30','17:50:00',3.11),('9650','2014-03-30','17:55:00',2.94),('9650','2014-03-30','18:00:00',2.77),('9650','2014-03-30','18:05:00',2.58),('9650','2014-03-30','18:10:00',2.46),('9650','2014-03-30','18:15:00',2.39),('9650','2014-03-30','18:20:00',2.21),('9650','2014-03-30','18:25:00',2.02),('9650','2014-03-30','18:30:00',1.82),('9650','2014-03-30','18:35:00',1.71),('9650','2014-03-30','18:40:00',1.66),('9650','2014-03-30','18:45:00',1.44),('9650','2014-03-30','18:50:00',1.16),('9650','2013-05-10','07:50:00',1.07),('9650','2013-05-10','07:55:00',1.23),('9650','2013-05-10','08:00:00',1.21),('9650','2013-05-10','08:05:00',1.39),('9650','2013-05-10','08:10:00',1.34),('9650','2013-05-10','08:15:00',1.81),('9650','2013-05-10','08:20:00',1.81),('9650','2013-05-10','08:25:00',1.32),('9650','2013-05-10','08:30:00',1.3),('9650','2013-05-10','08:35:00',1.37),('9650','2013-05-10','08:40:00',1.03),('9650','2013-05-10','08:45:00',1),('9650','2013-05-10','08:50:00',1.2),('9650','2013-05-10','08:55:00',1.23),('9650','2013-05-10','09:00:00',1.34),('9650','2013-05-10','09:05:00',2.03),('9650','2013-05-10','09:10:00',1.98),('9650','2013-05-10','09:15:00',2.24),('9650','2013-05-10','09:20:00',2.53),('9650','2013-05-10','09:25:00',2.8),('9650','2013-05-10','09:30:00',3.48),('9650','2013-05-10','09:35:00',3.22),('9650','2013-05-10','09:40:00',2.14),('9650','2013-05-10','09:45:00',2.37),('9650','2013-05-10','09:50:00',2.34),('9650','2013-05-10','09:55:00',2.91),('9650','2013-05-10','10:00:00',3.85),('9650','2013-05-10','10:05:00',2.29),('9650','2013-05-10','10:10:00',1.48),('9650','2013-05-10','10:15:00',1.42),('9650','2013-05-10','10:20:00',2),('9650','2013-05-10','10:25:00',1.8),('9650','2013-05-10','10:30:00',2.3),('9650','2013-05-10','10:35:00',2.14),('9650','2013-05-10','10:40:00',1.7),('9650','2013-05-10','10:45:00',1.6),('9650','2013-05-10','10:50:00',2.15),('9650','2013-05-10','10:55:00',5.27),('9650','2013-05-10','11:00:00',6.47),('9650','2013-05-10','11:05:00',3.23),('9650','2013-05-10','11:10:00',2.15),('9650','2013-05-10','11:15:00',1.78),('9650','2013-05-10','11:20:00',1.62),('9650','2013-05-10','11:25:00',1.93),('9650','2013-05-10','11:30:00',3.69),('9650','2013-05-10','11:35:00',4.44),('9650','2013-05-10','11:40:00',3.62),('9650','2013-05-10','11:45:00',7.76),('9650','2013-05-10','11:50:00',2.94),('9650','2013-05-10','11:55:00',1.82),('9650','2013-05-10','12:00:00',2.8),('9650','2013-05-10','12:05:00',3.6),('9650','2013-05-10','12:10:00',2.52),('9650','2013-05-10','12:15:00',2.38),('9650','2013-05-10','12:20:00',4.38),('9650','2013-05-10','12:25:00',7.72),('9650','2013-05-10','12:30:00',4.21),('9650','2013-05-10','12:35:00',3.11),('9650','2013-05-10','12:40:00',3.13),('9650','2013-05-10','12:45:00',3.59),('9650','2013-05-10','12:50:00',2.77),('9650','2013-05-10','12:55:00',2.66),('9650','2013-05-10','13:00:00',2.75),('9650','2013-05-10','13:05:00',2.5),('9650','2013-05-10','13:10:00',1.82),('9650','2013-05-10','13:15:00',1.13),('9650','2013-05-10','13:20:00',1.25),('9650','2013-05-10','13:25:00',1.65),('9650','2013-05-10','13:30:00',1.96),('9650','2013-05-10','13:35:00',2.12),('9650','2013-05-10','13:40:00',1.39),('9650','2013-05-10','13:45:00',1.02),('9650','2013-05-10','13:50:00',1.81),('9650','2013-05-10','13:55:00',1.98),('9650','2013-05-10','14:00:00',3.38),('9650','2013-05-10','14:05:00',6.3),('9650','2013-05-10','14:10:00',5.07),('9650','2013-05-10','14:15:00',5.8),('9650','2013-05-10','14:20:00',8.09),('9650','2013-05-10','14:25:00',7.42),('9650','2013-05-10','14:30:00',3.96),('9650','2013-05-10','14:35:00',5.57),('9650','2013-05-10','14:40:00',5.7),('9650','2013-05-10','14:45:00',7.6),('9650','2013-05-10','14:50:00',8.51),('9650','2013-05-10','14:55:00',7.97),('9650','2013-05-10','15:00:00',7.58),('9650','2013-05-10','15:05:00',7.74),('9650','2013-05-10','15:10:00',7.67),('9650','2013-05-10','15:15:00',7.9),('9650','2013-05-10','15:20:00',7.67),('9650','2013-05-10','15:25:00',7.71),('9650','2013-05-10','15:30:00',7.71),('9650','2013-05-10','15:35:00',6.87),('9650','2013-05-10','15:40:00',7.72),('9650','2013-05-10','15:45:00',7.22),('9650','2013-05-10','15:50:00',6.63),('9650','2013-05-10','15:55:00',6.65),('9650','2013-05-10','16:00:00',5.76),('9650','2013-05-10','16:05:00',7.21),('9650','2013-05-10','16:10:00',5.92),('9650','2013-05-10','16:15:00',6.41),('9650','2013-05-10','16:20:00',7.1),('9650','2013-05-10','16:25:00',6.97),('9650','2013-05-10','16:30:00',6.38),('9650','2013-05-10','16:35:00',4.63),('9650','2013-05-10','16:40:00',6.18),('9650','2013-05-10','16:45:00',6.6),('9650','2013-05-10','16:50:00',6.42),('9650','2013-05-10','16:55:00',6.53),('9650','2013-05-10','17:00:00',6.39),('9650','2013-05-10','17:05:00',4.7),('9650','2013-05-10','17:10:00',5.96),('9650','2013-05-10','17:15:00',3.76),('9650','2013-05-10','17:20:00',5.12),('9650','2013-05-10','17:25:00',3.86),('9650','2013-05-10','17:30:00',5.33),('9650','2013-05-10','17:35:00',4.56),('9650','2013-05-10','17:40:00',4.77),('9650','2013-05-10','17:45:00',4.8),('9650','2013-05-10','17:50:00',2.49),('9650','2013-05-10','17:55:00',3.89),('9650','2013-05-10','18:00:00',2.23),('9650','2013-05-10','18:05:00',4.25),('9650','2013-05-10','18:10:00',5.26),('9650','2013-05-10','18:15:00',3.16),('9650','2013-05-10','18:20:00',2.7),('9650','2013-05-10','18:25:00',3.16),('9650','2013-05-10','18:30:00',3.52),('9650','2013-05-10','18:35:00',2.77),('9650','2013-05-10','18:40:00',3.21),('9650','2013-05-10','18:45:00',3.11),('9650','2013-05-10','18:50:00',3.05),('9650','2013-05-10','18:55:00',3.17),('9650','2013-05-10','19:00:00',2.59),('9650','2013-05-10','19:10:00',1.57),('9650','2013-05-09','07:40:00',1.03),('9650','2013-05-09','07:45:00',1.16),('9650','2013-05-09','07:50:00',1.28),('9650','2013-05-09','07:55:00',1.65),('9650','2013-05-09','08:00:00',1.75),('9650','2013-05-09','08:05:00',2.1),('9650','2013-05-09','08:10:00',2.2),('9650','2013-05-09','08:15:00',2.35),('9650','2013-05-09','08:20:00',2.19),('9650','2013-05-09','08:25:00',2.08),('9650','2013-05-09','08:30:00',1.98),('9650','2013-05-09','08:35:00',1.92),('9650','2013-05-09','09:00:00',1.5),('9650','2013-05-09','09:05:00',2.34),('9650','2013-05-09','09:10:00',2.74),('9650','2013-05-09','09:15:00',2.97),('9650','2013-05-09','09:20:00',2.84),('9650','2013-05-09','09:25:00',2.79),('9650','2013-05-09','09:30:00',2.76),('9650','2013-05-09','09:35:00',3.51),('9650','2013-05-09','09:40:00',3.22),('9650','2013-05-09','09:45:00',3.36),('9650','2013-05-09','09:50:00',2.96),('9650','2013-05-09','09:55:00',2.23),('9650','2013-05-09','10:00:00',2.38),('9650','2013-05-09','10:05:00',2.53),('9650','2013-05-09','10:10:00',2.67),('9650','2013-05-09','10:15:00',1.58),('9650','2013-05-09','10:20:00',3.11),('9650','2013-05-09','10:25:00',1.85),('9650','2013-05-09','10:30:00',2.03),('9650','2013-05-09','10:35:00',3.6),('9650','2013-05-09','10:40:00',5.52),('9650','2013-05-09','10:45:00',5.93),('9650','2013-05-09','10:50:00',4.73),('9650','2013-05-09','10:55:00',5.73),('9650','2013-05-09','11:00:00',5.71),('9650','2013-05-09','11:05:00',5.81),('9650','2013-05-09','11:10:00',5.79),('9650','2013-05-09','11:15:00',5.74),('9650','2013-05-09','11:20:00',6.6),('9650','2013-05-09','11:25:00',5.37),('9650','2013-05-09','11:30:00',5.51),('9650','2013-05-09','11:35:00',4.94),('9650','2013-05-09','11:40:00',4.7),('9650','2013-05-09','11:45:00',4.76),('9650','2013-05-09','11:50:00',5.54),('9650','2013-05-09','11:55:00',7.06),('9650','2013-05-09','12:00:00',5.21),('9650','2013-05-09','12:05:00',3.94),('9650','2013-05-09','12:10:00',3.59),('9650','2013-05-09','12:15:00',4.7),('9650','2013-05-09','12:20:00',5.4),('9650','2013-05-09','12:25:00',3.77),('9650','2013-05-09','12:30:00',3.75),('9650','2013-05-09','12:35:00',3.18),('9650','2013-05-09','12:40:00',5.63),('9650','2013-05-09','12:45:00',7.21),('9650','2013-05-09','12:50:00',5.83),('9650','2013-05-09','12:55:00',4.32),('9650','2013-05-09','13:00:00',6.96),('9650','2013-05-09','13:05:00',6.53),('9650','2013-05-09','13:10:00',8.12),('9650','2013-05-09','13:15:00',7.78),('9650','2013-05-09','13:20:00',5.3),('9650','2013-05-09','13:25:00',4.79),('9650','2013-05-09','13:30:00',5.9),('9650','2013-05-09','13:35:00',6.94),('9650','2013-05-09','13:40:00',6.93),('9650','2013-05-09','13:45:00',6.69),('9650','2013-05-09','13:50:00',4.11),('9650','2013-05-09','13:55:00',3.81),('9650','2013-05-09','14:00:00',3.5),('9650','2013-05-09','14:05:00',3.77),('9650','2013-05-09','14:10:00',4.49),('9650','2013-05-09','14:15:00',4.97),('9650','2013-05-09','14:20:00',4.67),('9650','2013-05-09','14:25:00',4.71),('9650','2013-05-09','14:30:00',4.7),('9650','2013-05-09','14:35:00',5.61),('9650','2013-05-09','14:40:00',4.82),('9650','2013-05-09','14:45:00',3.41),('9650','2013-05-09','14:50:00',2.6),('9650','2013-05-09','14:55:00',2.34),('9650','2013-05-09','15:00:00',2.35),('9650','2013-05-09','15:05:00',2.73),('9650','2013-05-09','15:10:00',3.8),('9650','2013-05-09','15:15:00',6.38),('9650','2013-05-09','15:20:00',4.68),('9650','2013-05-09','15:25:00',3.72),('9650','2013-05-09','15:30:00',3.66),('9650','2013-05-09','15:35:00',3.7),('9650','2013-05-09','15:40:00',3.86),('9650','2013-05-09','15:45:00',3.59),('9650','2013-05-09','15:50:00',3.27),('9650','2013-05-09','15:55:00',3.1),('9650','2013-05-09','16:00:00',3.04),('9650','2013-05-09','16:05:00',2.99),('9650','2013-05-09','16:10:00',2.91),('9650','2013-05-09','16:15:00',2.64),('9650','2013-05-09','16:20:00',2.43),('9650','2013-05-09','16:25:00',2.5),('9650','2013-05-09','16:30:00',2.73),('9650','2013-05-09','16:35:00',2.87),('9650','2013-05-09','16:40:00',2.68),('9650','2013-05-09','16:45:00',2.78),('9650','2013-05-09','16:50:00',2.57),('9650','2013-05-09','16:55:00',2.12),('9650','2013-05-09','17:00:00',1.84),('9650','2013-05-09','17:05:00',2),('9650','2013-05-09','17:10:00',2.83),('9650','2013-05-09','17:15:00',3.31),('9650','2013-05-09','17:20:00',4.75),('9650','2013-05-09','17:25:00',4.36),('9650','2013-05-09','17:30:00',4.11),('9650','2013-05-09','17:35:00',4.87),('9650','2013-05-09','17:40:00',2.78),('9650','2013-05-09','17:45:00',2.8),('9650','2013-05-09','17:50:00',2.38),('9650','2013-05-09','17:55:00',1.91),('9650','2013-05-09','18:00:00',1.86),('9650','2013-05-09','18:05:00',1.82),('9650','2013-05-09','18:10:00',1.63),('9650','2013-05-09','18:15:00',1.47),('9650','2013-05-09','18:20:00',1.46),('9650','2013-05-09','18:25:00',1.29),('9650','2013-05-08','08:15:00',1.07),('9650','2013-05-08','08:20:00',1.15),('9650','2013-05-08','08:25:00',1.26),('9650','2013-05-08','08:30:00',1.45),('9650','2013-05-08','08:35:00',1.57),('9650','2013-05-08','08:40:00',1.71),('9650','2013-05-08','08:45:00',1.85),('9650','2013-05-08','08:50:00',2),('9650','2013-05-08','08:55:00',2.12),('9650','2013-05-08','09:00:00',2.26),('9650','2013-05-08','09:05:00',2.38),('9650','2013-05-08','09:10:00',2.56),('9650','2013-05-08','09:15:00',2.72),('9650','2013-05-08','09:20:00',2.88),('9650','2013-05-08','09:25:00',3.02),('9650','2013-05-08','09:30:00',3.17),('9650','2013-05-08','09:35:00',3.35),('9650','2013-05-08','09:40:00',3.48),('9650','2013-05-08','09:45:00',3.61),('9650','2013-05-08','09:50:00',3.74),('9650','2013-05-08','09:55:00',3.86),('9650','2013-05-08','10:00:00',4.01),('9650','2013-05-08','10:05:00',4.13),('9650','2013-05-08','10:10:00',4.24),('9650','2013-05-08','10:15:00',4.37),('9650','2013-05-08','10:20:00',4.48),('9650','2013-05-08','10:25:00',4.6),('9650','2013-05-08','10:30:00',4.72),('9650','2013-05-08','10:35:00',4.82),('9650','2013-05-08','10:40:00',4.95),('9650','2013-05-08','10:45:00',5.06),('9650','2013-05-08','10:50:00',5.15),('9650','2013-05-08','10:55:00',5.26),('9650','2013-05-08','11:00:00',5.36),('9650','2013-05-08','11:05:00',5.45),('9650','2013-05-08','11:10:00',5.55),('9650','2013-05-08','11:15:00',5.65),('9650','2013-05-08','11:20:00',5.75),('9650','2013-05-08','11:25:00',5.83),('9650','2013-05-08','11:30:00',5.93),('9650','2013-05-08','11:35:00',5.98),('9650','2013-05-08','11:40:00',6.04),('9650','2013-05-08','11:45:00',6.15),('9650','2013-05-08','11:50:00',6.19),('9650','2013-05-08','11:55:00',6.28),('9650','2013-05-08','12:00:00',6.3),('9650','2013-05-08','12:05:00',6.35),('9650','2013-05-08','12:10:00',6.46),('9650','2013-05-08','12:15:00',6.61),('9650','2013-05-08','12:20:00',6.71),('9650','2013-05-08','12:25:00',6.74),('9650','2013-05-08','12:30:00',6.81),('9650','2013-05-08','12:35:00',6.88),('9650','2013-05-08','12:40:00',6.92),('9650','2013-05-08','12:45:00',7.01),('9650','2013-05-08','12:50:00',7.01),('9650','2013-05-08','12:55:00',7.05),('9650','2013-05-08','13:00:00',7.06),('9650','2013-05-08','13:05:00',7.03),('9650','2013-05-08','13:10:00',7.13),('9650','2013-05-08','13:15:00',7.2),('9650','2013-05-08','13:20:00',7.23),('9650','2013-05-08','13:25:00',7.22),('9650','2013-05-08','13:30:00',7.31),('9650','2013-05-08','13:35:00',7.37),('9650','2013-05-08','13:40:00',7.51),('9650','2013-05-08','13:45:00',7.4),('9650','2013-05-08','13:50:00',7.55),('9650','2013-05-08','13:55:00',7.74),('9650','2013-05-08','14:00:00',6.43),('9650','2013-05-08','14:05:00',6.22),('9650','2013-05-08','14:10:00',6.78),('9650','2013-05-08','14:15:00',8.2),('9650','2013-05-08','14:20:00',6.74),('9650','2013-05-08','14:25:00',6.27),('9650','2013-05-08','14:30:00',7.42),('9650','2013-05-08','14:35:00',7.42),('9650','2013-05-08','14:40:00',7.38),('9650','2013-05-08','14:45:00',7.4),('9650','2013-05-08','14:50:00',7.29),('9650','2013-05-08','14:55:00',7.44),('9650','2013-05-08','15:00:00',7.38),('9650','2013-05-08','15:05:00',7.36),('9650','2013-05-08','15:10:00',7.32),('9650','2013-05-08','15:15:00',7.35),('9650','2013-05-08','15:20:00',7.28),('9650','2013-05-08','15:25:00',7.25),('9650','2013-05-08','15:30:00',7.16),('9650','2013-05-08','15:35:00',7.15),('9650','2013-05-08','15:40:00',7.1),('9650','2013-05-08','15:45:00',7.05),('9650','2013-05-08','15:50:00',7.01),('9650','2013-05-08','15:55:00',6.92),('9650','2013-05-08','16:00:00',6.84),('9650','2013-05-08','16:05:00',6.85),('9650','2013-05-08','16:10:00',6.8),('9650','2013-05-08','16:15:00',6.67),('9650','2013-05-08','16:20:00',6.62),('9650','2013-05-08','16:25:00',6.5),('9650','2013-05-08','16:30:00',6.47),('9650','2013-05-08','16:35:00',6.4),('9650','2013-05-08','16:40:00',6.26),('9650','2013-05-08','16:45:00',6.11),('9650','2013-05-08','16:50:00',6.03),('9650','2013-05-08','16:55:00',5.97),('9650','2013-05-08','17:00:00',5.86),('9650','2013-05-08','17:05:00',5.74),('9650','2013-05-08','17:10:00',5.62),('9650','2013-05-08','17:15:00',5.5),('9650','2013-05-08','17:20:00',5.43),('9650','2013-05-08','17:25:00',5.32),('9650','2013-05-08','17:30:00',5.19),('9650','2013-05-08','17:35:00',5.04),('9650','2013-05-08','17:40:00',4.94),('9650','2013-05-08','17:45:00',4.8),('9650','2013-05-08','17:50:00',4.65),('9650','2013-05-08','17:55:00',4.55),('9650','2013-05-08','18:00:00',4.38),('9650','2013-05-08','18:05:00',4.25),('9650','2013-05-08','18:10:00',4.08),('9650','2013-05-08','18:15:00',3.95),('9650','2013-05-08','18:20:00',3.8),('9650','2013-05-08','18:25:00',3.62),('9650','2013-05-08','18:30:00',3.47),('9650','2013-05-08','18:35:00',3.33),('9650','2013-05-08','18:40:00',3.12),('9650','2013-05-08','18:45:00',2.96),('9650','2013-05-08','18:50:00',2.77),('9650','2013-05-08','18:55:00',2.59),('9650','2013-05-08','19:00:00',2.42),('9650','2013-05-08','19:05:00',2.21),('9650','2013-05-08','19:10:00',2.03),('9650','2013-05-08','19:15:00',1.8),('9650','2013-05-08','19:20:00',1.42),('9650','2013-05-08','19:25:00',1.1),('9650','2013-05-07','08:10:00',1.07),('9650','2013-05-07','08:15:00',1.16),('9650','2013-05-07','08:20:00',1.26),('9650','2013-05-07','08:25:00',1.35),('9650','2013-05-07','08:30:00',1.51),('9650','2013-05-07','08:35:00',1.66),('9650','2013-05-07','08:40:00',1.77),('9650','2013-05-07','08:45:00',1.91),('9650','2013-05-07','08:50:00',1.33),('9650','2013-05-07','08:55:00',1.68),('9650','2013-05-07','09:00:00',1.58),('9650','2013-05-07','09:05:00',2.72),('9650','2013-05-07','09:10:00',1.65),('9650','2013-05-07','09:30:00',1.19),('9650','2013-05-07','09:35:00',2.78),('9650','2013-05-07','09:40:00',4.65),('9650','2013-05-07','09:45:00',3.13),('9650','2013-05-07','09:50:00',3.24),('9650','2013-05-07','09:55:00',2.23),('9650','2013-05-07','10:00:00',2.12),('9650','2013-05-07','10:05:00',4.7),('9650','2013-05-07','10:10:00',4.21),('9650','2013-05-07','10:15:00',1.8),('9650','2013-05-07','10:20:00',1.84),('9650','2013-05-07','10:25:00',1.55),('9650','2013-05-07','10:30:00',1.55),('9650','2013-05-07','10:35:00',1.55),('9650','2013-05-07','10:40:00',1.52),('9650','2013-05-07','10:45:00',1.44),('9650','2013-05-07','10:50:00',1.39),('9650','2013-05-07','10:55:00',1.79),('9650','2013-05-07','11:00:00',3.51),('9650','2013-05-07','11:05:00',5.71),('9650','2013-05-07','11:10:00',6.77),('9650','2013-05-07','11:15:00',5.24),('9650','2013-05-07','11:20:00',5.25),('9650','2013-05-07','11:25:00',6.5),('9650','2013-05-07','11:30:00',6.8),('9650','2013-05-07','11:35:00',7.03),('9650','2013-05-07','11:40:00',6.2),('9650','2013-05-07','11:45:00',4.8),('9650','2013-05-07','11:50:00',3.92),('9650','2013-05-07','11:55:00',5),('9650','2013-05-07','12:00:00',5.73),('9650','2013-05-07','12:05:00',1.87),('9650','2013-05-07','12:10:00',1.63),('9650','2013-05-07','12:15:00',1.99),('9650','2013-05-07','12:20:00',3.6),('9650','2013-05-07','12:25:00',3.2),('9650','2013-05-07','12:30:00',3.12),('9650','2013-05-07','12:35:00',2.04),('9650','2013-05-07','12:40:00',2.02),('9650','2013-05-07','12:45:00',2.27),('9650','2013-05-07','12:50:00',3.78),('9650','2013-05-07','12:55:00',6.03),('9650','2013-05-07','13:00:00',5.37),('9650','2013-05-07','13:05:00',2.76),('9650','2013-05-07','13:10:00',7.68),('9650','2013-05-07','13:15:00',5.5),('9650','2013-05-07','13:20:00',1.95),('9650','2013-05-07','13:25:00',4.16),('9650','2013-05-07','13:30:00',1.7),('9650','2013-05-07','13:35:00',1.72),('9650','2013-05-07','13:40:00',4.29),('9650','2013-05-07','13:45:00',8.8),('9650','2013-05-07','13:50:00',7.74),('9650','2013-05-07','13:55:00',8.55),('9650','2013-05-07','14:00:00',6.91),('9650','2013-05-07','14:05:00',4.69),('9650','2013-05-07','14:10:00',3.12),('9650','2013-05-07','14:15:00',4.03),('9650','2013-05-07','14:20:00',5.46),('9650','2013-05-07','14:25:00',2.87),('9650','2013-05-07','14:30:00',6),('9650','2013-05-07','14:35:00',7.14),('9650','2013-05-07','14:40:00',8.71),('9650','2013-05-07','14:45:00',6.72),('9650','2013-05-07','14:50:00',8.21),('9650','2013-05-07','14:55:00',7.47),('9650','2013-05-07','15:00:00',7.69),('9650','2013-05-07','15:05:00',7.46),('9650','2013-05-07','15:10:00',7.56),('9650','2013-05-07','15:15:00',7.49),('9650','2013-05-07','15:20:00',7.36),('9650','2013-05-07','15:25:00',7.42),('9650','2013-05-07','15:30:00',7.35),('9650','2013-05-07','15:35:00',7.17),('9650','2013-05-07','15:40:00',7.08),('9650','2013-05-07','15:45:00',7.08),('9650','2013-05-07','15:50:00',7.07),('9650','2013-05-07','15:55:00',7.06),('9650','2013-05-07','16:00:00',7.09),('9650','2013-05-07','16:05:00',6.92),('9650','2013-05-07','16:10:00',6.9),('9650','2013-05-07','16:15:00',6.72),('9650','2013-05-07','16:20:00',6.66),('9650','2013-05-07','16:25:00',6.44),('9650','2013-05-07','16:30:00',6.69),('9650','2013-05-07','16:35:00',6.56),('9650','2013-05-07','16:40:00',4.98),('9650','2013-05-07','16:45:00',5.02),('9650','2013-05-07','16:50:00',4.25),('9650','2013-05-07','16:55:00',6),('9650','2013-05-07','17:00:00',5.18),('9650','2013-05-07','17:05:00',6.3),('9650','2013-05-07','17:10:00',5.9),('9650','2013-05-07','17:15:00',5.05),('9650','2013-05-07','17:20:00',5.15),('9650','2013-05-07','17:25:00',4.25),('9650','2013-05-07','17:30:00',5.83),('9650','2013-05-07','17:35:00',5.71),('9650','2013-05-07','17:40:00',5.73),('9650','2013-05-07','17:45:00',5.85),('9650','2013-05-07','17:50:00',5.84),('9650','2013-05-07','17:55:00',5.6),('9650','2013-05-07','18:00:00',2.54),('9650','2013-05-07','18:05:00',1.68),('9650','2013-05-07','18:10:00',2.26),('9650','2013-05-07','18:15:00',4.88),('9650','2013-05-07','18:20:00',4.67),('9650','2013-05-07','18:25:00',4.33),('9650','2013-05-07','18:30:00',3.7),('9650','2013-05-07','18:35:00',3.37),('9650','2013-05-07','18:40:00',1.8),('9650','2013-05-07','18:45:00',1.17),('9650','2013-05-07','18:50:00',1.17),('9650','2013-05-07','18:55:00',1.52),('9650','2013-05-07','19:00:00',2.49),('9650','2013-05-07','19:05:00',2.25),('9650','2013-05-07','19:10:00',2.05),('9650','2013-05-07','19:15:00',1.91),('9650','2013-05-07','19:20:00',1.65),('9650','2013-05-07','19:25:00',1.48),('9650','2013-05-07','19:30:00',1.21),('9650','2013-05-06','08:15:00',1.01),('9650','2013-05-06','08:20:00',1.11),('9650','2013-05-06','08:25:00',1.21),('9650','2013-05-06','08:30:00',1.24),('9650','2013-05-06','08:35:00',1.3),('9650','2013-05-06','08:40:00',1.59),('9650','2013-05-06','08:45:00',1.85),('9650','2013-05-06','08:50:00',2.13),('9650','2013-05-06','08:55:00',2.47),('9650','2013-05-06','09:00:00',2.1),('9650','2013-05-06','09:05:00',1.09),('9650','2013-05-06','09:10:00',1.11),('9650','2013-05-06','09:15:00',1.78),('9650','2013-05-06','09:20:00',1.26),('9650','2013-05-06','09:25:00',1.2),('9650','2013-05-06','09:30:00',1.85),('9650','2013-05-06','09:35:00',3.82),('9650','2013-05-06','09:40:00',2.89),('9650','2013-05-06','09:45:00',2.53),('9650','2013-05-06','09:50:00',2.45),('9650','2013-05-06','09:55:00',1.73),('9650','2013-05-06','10:00:00',1.47),('9650','2013-05-06','10:05:00',1.27),('9650','2013-05-06','10:25:00',1.1),('9650','2013-05-06','10:30:00',1.11),('9650','2013-05-06','10:35:00',1.19),('9650','2013-05-06','10:40:00',1.25),('9650','2013-05-06','10:45:00',1.2),('9650','2013-05-06','10:50:00',1.55),('9650','2013-05-06','10:55:00',2.14),('9650','2013-05-06','11:00:00',2.4),('9650','2013-05-06','11:05:00',2.49),('9650','2013-05-06','11:10:00',2.48),('9650','2013-05-06','11:15:00',2.41),('9650','2013-05-06','11:20:00',3.76),('9650','2013-05-06','11:25:00',3.17),('9650','2013-05-06','11:30:00',1.06),('9650','2013-05-06','11:45:00',1.05),('9650','2013-05-06','11:50:00',1.26),('9650','2013-05-06','11:55:00',1.74),('9650','2013-05-06','12:00:00',2.04),('9650','2013-05-06','12:05:00',5.2),('9650','2013-05-06','12:10:00',7.63),('9650','2013-05-06','12:15:00',3.39),('9650','2013-05-06','12:20:00',8.32),('9650','2013-05-06','12:25:00',6),('9650','2013-05-06','12:30:00',2.05),('9650','2013-05-06','12:35:00',1.58),('9650','2013-05-06','12:40:00',1.79),('9650','2013-05-06','12:45:00',1.36),('9650','2013-05-06','12:50:00',1.32),('9650','2013-05-06','12:55:00',1.28),('9650','2013-05-06','13:05:00',1.42),('9650','2013-05-06','13:10:00',1.98),('9650','2013-05-06','13:15:00',2.31),('9650','2013-05-06','13:20:00',2.86),('9650','2013-05-06','13:25:00',3.83),('9650','2013-05-06','13:30:00',6.31),('9650','2013-05-06','13:35:00',8.8),('9650','2013-05-06','13:40:00',8.18),('9650','2013-05-06','13:45:00',8.5),('9650','2013-05-06','13:50:00',8.07),('9650','2013-05-06','13:55:00',5.73),('9650','2013-05-06','14:00:00',8.49),('9650','2013-05-06','14:05:00',8.5),('9650','2013-05-06','14:10:00',8.14),('9650','2013-05-06','14:15:00',8.58),('9650','2013-05-06','14:20:00',5.18),('9650','2013-05-06','14:25:00',7.1),('9650','2013-05-06','14:30:00',5.14),('9650','2013-05-06','14:35:00',8.7),('9650','2013-05-06','14:40:00',8.09),('9650','2013-05-06','14:45:00',6.24),('9650','2013-05-06','14:50:00',6.68),('9650','2013-05-06','14:55:00',6.17),('9650','2013-05-06','15:00:00',7.74),('9650','2013-05-06','15:05:00',7.54),('9650','2013-05-06','15:10:00',7.37),('9650','2013-05-06','15:15:00',7.94),('9650','2013-05-06','15:20:00',7.82),('9650','2013-05-06','15:25:00',5.41),('9650','2013-05-06','15:30:00',4.9),('9650','2013-05-06','15:35:00',5.93),('9650','2013-05-06','15:40:00',6.12),('9650','2013-05-06','15:45:00',5.66),('9650','2013-05-06','15:50:00',3.61),('9650','2013-05-06','15:55:00',4.28),('9650','2013-05-06','16:00:00',7.47),('9650','2013-05-06','16:05:00',3.59),('9650','2013-05-06','16:10:00',2.63),('9650','2013-05-06','16:15:00',6.45),('9650','2013-05-06','16:20:00',8.53),('9650','2013-05-06','16:25:00',8.21),('9650','2013-05-06','16:30:00',7.81),('9650','2013-05-06','16:35:00',7.72),('9650','2013-05-06','16:40:00',7.52),('9650','2013-05-06','16:45:00',6.68),('9650','2013-05-06','16:50:00',6.66),('9650','2013-05-06','16:55:00',5.41),('9650','2013-05-06','17:00:00',5.84),('9650','2013-05-06','17:05:00',6.56),('9650','2013-05-06','17:10:00',2.77),('9650','2013-05-06','17:15:00',2.35),('9650','2013-05-06','17:20:00',2.3),('9650','2013-05-06','17:25:00',2.24),('9650','2013-05-06','17:30:00',2.04),('9650','2013-05-06','17:35:00',2.09),('9650','2013-05-06','17:40:00',1.74),('9650','2013-05-06','17:45:00',1.52),('9650','2013-05-06','17:50:00',1.28),('9650','2013-05-06','18:35:00',1.1),('9650','2013-05-06','18:40:00',1.57),('9650','2013-05-06','18:45:00',1.9),('9650','2013-05-06','18:50:00',1.92),('9650','2013-05-05','08:15:00',1.24),('9650','2013-05-05','08:20:00',1.37),('9650','2013-05-05','08:25:00',1.86),('9650','2013-05-05','08:30:00',2.02),('9650','2013-05-05','08:35:00',1.91),('9650','2013-05-05','08:40:00',1.77),('9650','2013-05-05','08:45:00',1.44),('9650','2013-05-05','08:50:00',2.08),('9650','2013-05-05','08:55:00',3.08),('9650','2013-05-05','09:00:00',3.24),('9650','2013-05-05','09:05:00',2.49),('9650','2013-05-05','09:10:00',2.23),('9650','2013-05-05','09:15:00',2.24),('9650','2013-05-05','09:20:00',2.29),('9650','2013-05-05','09:25:00',2.1),('9650','2013-05-05','09:30:00',1.81),('9650','2013-05-05','09:35:00',1.21),('9650','2013-05-05','09:50:00',1.31),('9650','2013-05-05','09:55:00',1.85),('9650','2013-05-05','10:00:00',2.89),('9650','2013-05-05','10:05:00',1.98),('9650','2013-05-05','10:10:00',1.86),('9650','2013-05-05','10:15:00',2.42),('9650','2013-05-05','10:20:00',3.66),('9650','2013-05-05','10:25:00',3.36),('9650','2013-05-05','10:30:00',3.37),('9650','2013-05-05','10:35:00',3.32),('9650','2013-05-05','10:40:00',3.18),('9650','2013-05-05','10:45:00',4.47),('9650','2013-05-05','10:50:00',4.16),('9650','2013-05-05','10:55:00',3.33),('9650','2013-05-05','11:00:00',3.11),('9650','2013-05-05','11:05:00',3.5),('9650','2013-05-05','11:10:00',3.43),('9650','2013-05-05','11:15:00',3.11),('9650','2013-05-05','11:20:00',3.6),('9650','2013-05-05','11:25:00',3.58),('9650','2013-05-05','11:30:00',2.33),('9650','2013-05-05','11:35:00',3.16),('9650','2013-05-05','11:40:00',3.78),('9650','2013-05-05','11:45:00',6.2),('9650','2013-05-05','11:50:00',3.93),('9650','2013-05-05','11:55:00',3.01),('9650','2013-05-05','12:00:00',3.11),('9650','2013-05-05','12:05:00',2.89),('9650','2013-05-05','12:10:00',4.82),('9650','2013-05-05','12:15:00',3.91),('9650','2013-05-05','12:20:00',3.92),('9650','2013-05-05','12:25:00',6.54),('9650','2013-05-05','12:30:00',5.41),('9650','2013-05-05','12:35:00',7.73),('9650','2013-05-05','12:40:00',4.14),('9650','2013-05-05','12:45:00',3.47),('9650','2013-05-05','12:50:00',4.7),('9650','2013-05-05','12:55:00',5.12),('9650','2013-05-05','13:00:00',3.52),('9650','2013-05-05','13:05:00',5.7),('9650','2013-05-05','13:10:00',6.9),('9650','2013-05-05','13:15:00',5.14),('9650','2013-05-05','13:20:00',7.36),('9650','2013-05-05','13:25:00',5.09),('9650','2013-05-05','13:30:00',5.85),('9650','2013-05-05','13:35:00',4.75),('9650','2013-05-05','13:40:00',6.1),('9650','2013-05-05','13:45:00',6.34),('9650','2013-05-05','13:50:00',8.27),('9650','2013-05-05','13:55:00',8),('9650','2013-05-05','14:00:00',6.59),('9650','2013-05-05','14:05:00',5.64),('9650','2013-05-05','14:10:00',6.33),('9650','2013-05-05','14:15:00',8.3),('9650','2013-05-05','14:20:00',8.43),('9650','2013-05-05','14:25:00',3.54),('9650','2013-05-05','14:30:00',7.66),('9650','2013-05-05','14:35:00',7.8),('9650','2013-05-05','14:40:00',5.95),('9650','2013-05-05','14:45:00',4.17),('9650','2013-05-05','14:50:00',5.79),('9650','2013-05-05','14:55:00',7.44),('9650','2013-05-05','15:00:00',5.51),('9650','2013-05-05','15:05:00',4.38),('9650','2013-05-05','15:10:00',4.97),('9650','2013-05-05','15:15:00',5.58),('9650','2013-05-05','15:20:00',3.86),('9650','2013-05-05','15:25:00',3.95),('9650','2013-05-05','15:30:00',4.73),('9650','2013-05-05','15:35:00',5.51),('9650','2013-05-05','15:40:00',2.77),('9650','2013-05-05','15:45:00',2.53),('9650','2013-05-05','15:50:00',3.81),('9650','2013-05-05','15:55:00',3.33),('9650','2013-05-05','16:00:00',2.96),('9650','2013-05-05','16:05:00',2.76),('9650','2013-05-05','16:10:00',2.83),('9650','2013-05-05','16:15:00',2.95),('9650','2013-05-05','16:20:00',5.31),('9650','2013-05-05','16:25:00',3.78),('9650','2013-05-05','16:30:00',6.88),('9650','2013-05-05','16:35:00',4.63),('9650','2013-05-05','16:40:00',5.79),('9650','2013-05-05','16:45:00',3.59),('9650','2013-05-05','16:50:00',6.3),('9650','2013-05-05','16:55:00',5.8),('9650','2013-05-05','17:00:00',1.56),('9650','2013-05-05','17:05:00',1),('9650','2013-05-05','17:15:00',2.71),('9650','2013-05-05','17:20:00',2.12),('9650','2013-05-05','17:25:00',1.64),('9650','2013-05-05','17:30:00',1.3),('9650','2013-05-05','17:35:00',4.66),('9650','2013-05-05','17:40:00',3.38),('9650','2013-05-05','17:45:00',2.19),('9650','2013-05-05','17:50:00',3.04),('9650','2013-05-05','17:55:00',2.99),('9650','2013-05-05','18:00:00',4.33),('9650','2013-05-05','18:05:00',5.06),('9650','2013-05-05','18:10:00',2.07),('9650','2013-05-05','18:15:00',3.05),('9650','2013-05-05','18:20:00',4.58),('9650','2013-05-05','18:25:00',4.13),('9650','2013-05-05','18:30:00',3.55),('9650','2013-05-05','18:35:00',1.04),('9650','2013-05-05','19:20:00',1.08),('9650','2013-05-05','19:25:00',1.26),('9650','2013-05-05','19:35:00',1.04),('9650','2013-05-04','08:05:00',1.03),('9650','2013-05-04','08:10:00',1.13),('9650','2013-05-04','08:15:00',1.21),('9650','2013-05-04','08:20:00',1.48),('9650','2013-05-04','08:25:00',2.31),('9650','2013-05-04','08:30:00',2.65),('9650','2013-05-04','08:35:00',2.52),('9650','2013-05-04','08:40:00',2.55),('9650','2013-05-04','08:45:00',2.3),('9650','2013-05-04','08:50:00',2),('9650','2013-05-04','08:55:00',2.01),('9650','2013-05-04','09:00:00',2.17),('9650','2013-05-04','09:05:00',2.13),('9650','2013-05-04','09:10:00',2.16),('9650','2013-05-04','09:15:00',2.19),('9650','2013-05-04','09:20:00',1.88),('9650','2013-05-04','09:25:00',2.25),('9650','2013-05-04','09:30:00',2.4),('9650','2013-05-04','09:35:00',2.12),('9650','2013-05-04','09:40:00',2.82),('9650','2013-05-04','09:45:00',3.84),('9650','2013-05-04','09:50:00',4.08),('9650','2013-05-04','09:55:00',4.3),('9650','2013-05-04','10:00:00',3.83),('9650','2013-05-04','10:05:00',3.77),('9650','2013-05-04','10:10:00',3.46),('9650','2013-05-04','10:15:00',3.87),('9650','2013-05-04','10:20:00',5.23),('9650','2013-05-04','10:25:00',3.12),('9650','2013-05-04','10:30:00',3.95),('9650','2013-05-04','10:35:00',4.29),('9650','2013-05-04','10:40:00',4.13),('9650','2013-05-04','10:45:00',4.1),('9650','2013-05-04','10:50:00',2.82),('9650','2013-05-04','10:55:00',2.42),('9650','2013-05-04','11:00:00',2.44),('9650','2013-05-04','11:05:00',2.79),('9650','2013-05-04','11:10:00',2.52),('9650','2013-05-04','11:15:00',2.74),('9650','2013-05-04','11:20:00',4.24),('9650','2013-05-04','11:25:00',5.57),('9650','2013-05-04','11:30:00',4.1),('9650','2013-05-04','11:35:00',5.57),('9650','2013-05-04','11:40:00',4.38),('9650','2013-05-04','11:45:00',4.29),('9650','2013-05-04','11:50:00',4.28),('9650','2013-05-04','11:55:00',5.5),('9650','2013-05-04','12:00:00',4.7),('9650','2013-05-04','12:05:00',4.47),('9650','2013-05-04','12:10:00',3.93),('9650','2013-05-04','12:15:00',5.27),('9650','2013-05-04','12:20:00',5.3),('9650','2013-05-04','12:25:00',6.78),('9650','2013-05-04','12:30:00',4.86),('9650','2013-05-04','12:35:00',6.75),('9650','2013-05-04','12:40:00',6.76),('9650','2013-05-04','12:45:00',7.32),('9650','2013-05-04','12:50:00',6.89),('9650','2013-05-04','12:55:00',7.46),('9650','2013-05-04','13:00:00',7.46),('9650','2013-05-04','13:05:00',7.19),('9650','2013-05-04','13:10:00',7.36),('9650','2013-05-04','13:15:00',6.56),('9650','2013-05-04','13:20:00',4.81),('9650','2013-05-04','13:25:00',3.5),('9650','2013-05-04','13:30:00',3.06),('9650','2013-05-04','13:35:00',7.79),('9650','2013-05-04','13:40:00',7.74),('9650','2013-05-04','13:45:00',7.55),('9650','2013-05-04','13:50:00',7.77),('9650','2013-05-04','13:55:00',7.87),('9650','2013-05-04','14:00:00',8.01),('9650','2013-05-04','14:05:00',7.66),('9650','2013-05-04','14:10:00',5.92),('9650','2013-05-04','14:15:00',6.49),('9650','2013-05-04','14:20:00',7.31),('9650','2013-05-04','14:25:00',7.05),('9650','2013-05-04','14:30:00',6.93),('9650','2013-05-04','14:35:00',6.93),('9650','2013-05-04','14:40:00',6.91),('9650','2013-05-04','14:45:00',6.89),('9650','2013-05-04','14:50:00',6.87),('9650','2013-05-04','14:55:00',6.86),('9650','2013-05-04','15:00:00',6.84),('9650','2013-05-04','15:05:00',6.77),('9650','2013-05-04','15:10:00',6.78),('9650','2013-05-04','15:15:00',6.74),('9650','2013-05-04','15:20:00',6.67),('9650','2013-05-04','15:25:00',6.72),('9650','2013-05-04','15:30:00',6.7),('9650','2013-05-04','15:35:00',6.7),('9650','2013-05-04','15:40:00',6.59),('9650','2013-05-04','15:45:00',6.51),('9650','2013-05-04','15:50:00',6.47),('9650','2013-05-04','15:55:00',6.4),('9650','2013-05-04','16:00:00',6.39),('9650','2013-05-04','16:05:00',6.32),('9650','2013-05-04','16:10:00',6.23),('9650','2013-05-04','16:15:00',6.17),('9650','2013-05-04','16:20:00',6.11),('9650','2013-05-04','16:25:00',6.05),('9650','2013-05-04','16:30:00',5.98),('9650','2013-05-04','16:35:00',5.86),('9650','2013-05-04','16:40:00',5.8),('9650','2013-05-04','16:45:00',5.71),('9650','2013-05-04','16:50:00',5.62),('9650','2013-05-04','16:55:00',5.51),('9650','2013-05-04','17:00:00',5.38),('9650','2013-05-04','17:05:00',5.27),('9650','2013-05-04','17:10:00',5.17),('9650','2013-05-04','17:15:00',5.08),('9650','2013-05-04','17:20:00',4.96),('9650','2013-05-04','17:25:00',4.79),('9650','2013-05-04','17:30:00',4.67),('9650','2013-05-04','17:35:00',4.53),('9650','2013-05-04','17:40:00',4.43),('9650','2013-05-04','17:45:00',4.32),('9650','2013-05-04','17:50:00',4.16),('9650','2013-05-04','17:55:00',3.98),('9650','2013-05-04','18:00:00',3.82),('9650','2013-05-04','18:05:00',3.69),('9650','2013-05-04','18:10:00',3.53),('9650','2013-05-04','18:15:00',3.37),('9650','2013-05-04','18:20:00',3.23),('9650','2013-05-04','18:25:00',3.05),('9650','2013-05-04','18:30:00',2.89),('9650','2013-05-04','18:35:00',2.78),('9650','2013-05-04','18:40:00',2.59),('9650','2013-05-04','18:45:00',2.39),('9650','2013-05-04','18:50:00',2.19),('9650','2013-05-04','18:55:00',2.01),('9650','2013-05-04','19:00:00',1.83),('9650','2013-05-04','19:05:00',1.63),('9650','2013-05-04','19:10:00',1.46),('9650','2013-05-04','19:15:00',1.27),('9650','2013-05-04','19:20:00',1.07),('9650','2013-05-03','08:10:00',1.06),('9650','2013-05-03','08:15:00',1.12),('9650','2013-05-03','08:20:00',1.19),('9650','2013-05-03','08:25:00',1.29),('9650','2013-05-03','08:30:00',1.38),('9650','2013-05-03','08:35:00',1.46),('9650','2013-05-03','08:40:00',1.58),('9650','2013-05-03','08:45:00',1.72),('9650','2013-05-03','08:50:00',1.83),('9650','2013-05-03','08:55:00',1.94),('9650','2013-05-03','09:00:00',2.07),('9650','2013-05-03','09:05:00',2.19),('9650','2013-05-03','09:10:00',2.34),('9650','2013-05-03','09:15:00',2.46),('9650','2013-05-03','09:20:00',2.61),('9650','2013-05-03','09:25:00',2.73),('9650','2013-05-03','09:30:00',2.82),('9650','2013-05-03','09:35:00',3),('9650','2013-05-03','09:40:00',3.15),('9650','2013-05-03','09:45:00',3.28),('9650','2013-05-03','09:50:00',3.41),('9650','2013-05-03','09:55:00',3.5),('9650','2013-05-03','10:00:00',3.68),('9650','2013-05-03','10:05:00',3.73),('9650','2013-05-03','10:10:00',3.91),('9650','2013-05-03','10:15:00',4.01),('9650','2013-05-03','10:20:00',4.13),('9650','2013-05-03','10:25:00',4.2),('9650','2013-05-03','10:30:00',4.3),('9650','2013-05-03','10:35:00',4.4),('9650','2013-05-03','10:40:00',4.45),('9650','2013-05-03','10:45:00',4.53),('9650','2013-05-03','10:50:00',4.49),('9650','2013-05-03','10:55:00',4.53),('9650','2013-05-03','11:00:00',4.58),('9650','2013-05-03','11:05:00',4.62),('9650','2013-05-03','11:10:00',4.42),('9650','2013-05-03','11:15:00',4.35),('9650','2013-05-03','11:20:00',4.82),('9650','2013-05-03','11:25:00',4.94),('9650','2013-05-03','11:30:00',4.82),('9650','2013-05-03','11:35:00',5),('9650','2013-05-03','11:40:00',4.89),('9650','2013-05-03','11:45:00',5.11),('9650','2013-05-03','11:50:00',5.13),('9650','2013-05-03','11:55:00',5.14),('9650','2013-05-03','12:00:00',5.14),('9650','2013-05-03','12:05:00',5.43),('9650','2013-05-03','12:10:00',5.49),('9650','2013-05-03','12:15:00',5.67),('9650','2013-05-03','12:20:00',5.8),('9650','2013-05-03','12:25:00',5.97),('9650','2013-05-03','12:30:00',5.99),('9650','2013-05-03','12:35:00',6.1),('9650','2013-05-03','12:40:00',6.08),('9650','2013-05-03','12:45:00',6.1),('9650','2013-05-03','12:50:00',5.83),('9650','2013-05-03','12:55:00',5.88),('9650','2013-05-03','13:00:00',5.85),('9650','2013-05-03','13:05:00',5.18),('9650','2013-05-03','13:10:00',5.8),('9650','2013-05-03','13:15:00',6.56),('9650','2013-05-03','13:20:00',6.64),('9650','2013-05-03','13:25:00',6.35),('9650','2013-05-03','13:30:00',6.54),('9650','2013-05-03','13:35:00',6.07),('9650','2013-05-03','13:40:00',6.36),('9650','2013-05-03','13:45:00',6.33),('9650','2013-05-03','13:50:00',5.53),('9650','2013-05-03','13:55:00',5.84),('9650','2013-05-03','14:00:00',6.32),('9650','2013-05-03','14:05:00',6.31),('9650','2013-05-03','14:10:00',6.08),('9650','2013-05-03','14:15:00',6.3),('9650','2013-05-03','14:20:00',6.31),('9650','2013-05-03','14:25:00',5.92),('9650','2013-05-03','14:30:00',6.27),('9650','2013-05-03','14:35:00',5.86),('9650','2013-05-03','14:40:00',6.23),('9650','2013-05-03','14:45:00',6.09),('9650','2013-05-03','14:50:00',5.94),('9650','2013-05-03','14:55:00',6.21),('9650','2013-05-03','15:00:00',6.36),('9650','2013-05-03','15:05:00',6.51),('9650','2013-05-03','15:10:00',6.17),('9650','2013-05-03','15:15:00',6.35),('9650','2013-05-03','15:20:00',6.38),('9650','2013-05-03','15:25:00',6.44),('9650','2013-05-03','15:30:00',6.43),('9650','2013-05-03','15:35:00',6.2),('9650','2013-05-03','15:40:00',6.38),('9650','2013-05-03','15:45:00',6.32),('9650','2013-05-03','15:50:00',6.25),('9650','2013-05-03','15:55:00',6.18),('9650','2013-05-03','16:00:00',6.14),('9650','2013-05-03','16:05:00',6.07),('9650','2013-05-03','16:10:00',5.99),('9650','2013-05-03','16:15:00',5.94),('9650','2013-05-03','16:20:00',5.89),('9650','2013-05-03','16:25:00',5.78),('9650','2013-05-03','16:30:00',5.7),('9650','2013-05-03','16:35:00',5.64),('9650','2013-05-03','16:40:00',5.56),('9650','2013-05-03','16:45:00',5.43),('9650','2013-05-03','16:50:00',5.33),('9650','2013-05-03','16:55:00',5.25),('9650','2013-05-03','17:00:00',5.14),('9650','2013-05-03','17:05:00',5.01),('9650','2013-05-03','17:10:00',3.89),('9650','2013-05-03','17:15:00',4.44),('9650','2013-05-03','17:20:00',4.83),('9650','2013-05-03','17:25:00',4.7),('9650','2013-05-03','17:30:00',4.47),('9650','2013-05-03','17:35:00',4.19),('9650','2013-05-03','17:40:00',4.01),('9650','2013-05-03','17:45:00',4.02),('9650','2013-05-03','17:50:00',4.07),('9650','2013-05-03','17:55:00',3.94),('9650','2013-05-03','18:00:00',3.84),('9650','2013-05-03','18:05:00',3.68),('9650','2013-05-03','18:10:00',3.17),('9650','2013-05-03','18:15:00',2.59),('9650','2013-05-03','18:20:00',2.17),('9650','2013-05-03','18:25:00',1.8),('9650','2013-05-03','18:30:00',1.41),('9650','2013-05-03','18:35:00',1.14),('9650','2013-05-03','18:40:00',1.05),('9650','2013-05-02','08:05:00',1.12),('9650','2013-05-02','08:10:00',1.23),('9650','2013-05-02','08:15:00',1.39),('9650','2013-05-02','08:20:00',1.42),('9650','2013-05-02','08:25:00',1.55),('9650','2013-05-02','08:30:00',1.63),('9650','2013-05-02','08:35:00',1.66),('9650','2013-05-02','08:40:00',1.74),('9650','2013-05-02','08:45:00',1.83),('9650','2013-05-02','08:50:00',1.85),('9650','2013-05-02','08:55:00',1.93),('9650','2013-05-02','09:00:00',2.11),('9650','2013-05-02','09:05:00',2.25),('9650','2013-05-02','09:10:00',2.35),('9650','2013-05-02','09:15:00',2.51),('9650','2013-05-02','09:20:00',2.59),('9650','2013-05-02','09:25:00',2.74),('9650','2013-05-02','09:30:00',2.9),('9650','2013-05-02','09:35:00',3.02),('9650','2013-05-02','09:40:00',3.16),('9650','2013-05-02','09:45:00',3.29),('9650','2013-05-02','09:50:00',3.39),('9650','2013-05-02','09:55:00',3.55),('9650','2013-05-02','10:00:00',3.69),('9650','2013-05-02','10:05:00',3.8),('9650','2013-05-02','10:10:00',3.93),('9650','2013-05-02','10:15:00',4.04),('9650','2013-05-02','10:20:00',4.18),('9650','2013-05-02','10:25:00',4.25),('9650','2013-05-02','10:30:00',4.37),('9650','2013-05-02','10:35:00',4.5),('9650','2013-05-02','10:40:00',4.62),('9650','2013-05-02','10:45:00',4.74),('9650','2013-05-02','10:50:00',4.84),('9650','2013-05-02','10:55:00',4.92),('9650','2013-05-02','11:00:00',5),('9650','2013-05-02','11:05:00',5.08),('9650','2013-05-02','11:10:00',5.19),('9650','2013-05-02','11:15:00',5.25),('9650','2013-05-02','11:20:00',5.35),('9650','2013-05-02','11:25:00',5.49),('9650','2013-05-02','11:30:00',5.55),('9650','2013-05-02','11:35:00',5.68),('9650','2013-05-02','11:40:00',5.77),('9650','2013-05-02','11:45:00',5.81),('9650','2013-05-02','11:50:00',5.88),('9650','2013-05-02','11:55:00',5.96),('9650','2013-05-02','12:00:00',6.01),('9650','2013-05-02','12:05:00',6.01),('9650','2013-05-02','12:10:00',6.12),('9650','2013-05-02','12:15:00',6.2),('9650','2013-05-02','12:20:00',6.28),('9650','2013-05-02','12:25:00',6.3),('9650','2013-05-02','12:30:00',6.36),('9650','2013-05-02','12:35:00',6.38),('9650','2013-05-02','12:40:00',6.42),('9650','2013-05-02','12:45:00',6.19),('9650','2013-05-02','12:50:00',6.61),('9650','2013-05-02','12:55:00',6.65),('9650','2013-05-02','13:00:00',6.64),('9650','2013-05-02','13:05:00',6.66),('9650','2013-05-02','13:10:00',6.7),('9650','2013-05-02','13:15:00',6.72),('9650','2013-05-02','13:20:00',6.74),('9650','2013-05-02','13:25:00',6.81),('9650','2013-05-02','13:30:00',6.82),('9650','2013-05-02','13:35:00',6.66),('9650','2013-05-02','13:40:00',6.55),('9650','2013-05-02','13:45:00',6.56),('9650','2013-05-02','13:50:00',6.6),('9650','2013-05-02','13:55:00',6.65),('9650','2013-05-02','14:00:00',6.6),('9650','2013-05-02','14:05:00',6.37),('9650','2013-05-02','14:10:00',6.5),('9650','2013-05-02','14:15:00',6.41),('9650','2013-05-02','14:20:00',6.69),('9650','2013-05-02','14:25:00',6.66),('9650','2013-05-02','14:30:00',6.61),('9650','2013-05-02','14:35:00',6.7),('9650','2013-05-02','14:40:00',6.59),('9650','2013-05-02','14:45:00',6.61),('9650','2013-05-02','14:50:00',6.53),('9650','2013-05-02','14:55:00',6.69),('9650','2013-05-02','15:00:00',6.77),('9650','2013-05-02','15:05:00',6.69),('9650','2013-05-02','15:10:00',6.73),('9650','2013-05-02','15:15:00',6.79),('9650','2013-05-02','15:20:00',6.75),('9650','2013-05-02','15:25:00',6.75),('9650','2013-05-02','15:30:00',6.73),('9650','2013-05-02','15:35:00',6.65),('9650','2013-05-02','15:40:00',6.59),('9650','2013-05-02','15:45:00',6.54),('9650','2013-05-02','15:50:00',6.45),('9650','2013-05-02','15:55:00',6.4),('9650','2013-05-02','16:00:00',6.41),('9650','2013-05-02','16:05:00',6.35),('9650','2013-05-02','16:10:00',6.29),('9650','2013-05-02','16:15:00',6.17),('9650','2013-05-02','16:20:00',5.92),('9650','2013-05-02','16:25:00',5.95),('9650','2013-05-02','16:30:00',6),('9650','2013-05-02','16:35:00',5.91),('9650','2013-05-02','16:40:00',5.81),('9650','2013-05-02','16:45:00',5.73),('9650','2013-05-02','16:50:00',5.62),('9650','2013-05-02','16:55:00',5.52),('9650','2013-05-02','17:00:00',5.38),('9650','2013-05-02','17:05:00',5.27),('9650','2013-05-02','17:10:00',5.12),('9650','2013-05-02','17:15:00',5),('9650','2013-05-02','17:20:00',4.79),('9650','2013-05-02','17:25:00',4.61),('9650','2013-05-02','17:30:00',4.45),('9650','2013-05-02','17:35:00',4.31),('9650','2013-05-02','17:40:00',4.15),('9650','2013-05-02','17:45:00',3.95),('9650','2013-05-02','17:50:00',3.82),('9650','2013-05-02','17:55:00',3.75),('9650','2013-05-02','18:00:00',3.69),('9650','2013-05-02','18:05:00',3.58),('9650','2013-05-02','18:10:00',3.41),('9650','2013-05-02','18:15:00',3.26),('9650','2013-05-02','18:20:00',3.11),('9650','2013-05-02','18:25:00',2.93),('9650','2013-05-02','18:30:00',2.75),('9650','2013-05-02','18:35:00',2.57),('9650','2013-05-02','18:40:00',2.41),('9650','2013-05-02','18:45:00',2.27),('9650','2013-05-02','18:50:00',2.11),('9650','2013-05-02','18:55:00',1.91),('9650','2013-05-02','19:00:00',1.68),('9650','2013-05-02','19:05:00',1.46),('9650','2013-05-02','19:10:00',1.26),('9650','2013-05-02','19:15:00',1.08),('9650','2013-05-01','08:35:00',1.15),('9650','2013-05-01','08:40:00',1.52),('9650','2013-05-01','08:45:00',1.35),('9650','2013-05-01','08:50:00',1.39),('9650','2013-05-01','08:55:00',1.9),('9650','2013-05-01','09:00:00',2.49),('9650','2013-05-01','09:05:00',2.03),('9650','2013-05-01','09:10:00',1.45),('9650','2013-05-01','09:15:00',1.45),('9650','2013-05-01','09:20:00',1.55),('9650','2013-05-01','09:25:00',2.67),('9650','2013-05-01','09:30:00',3.25),('9650','2013-05-01','09:35:00',2.99),('9650','2013-05-01','09:40:00',2.47),('9650','2013-05-01','09:45:00',3.83),('9650','2013-05-01','09:50:00',2.41),('9650','2013-05-01','09:55:00',1.93),('9650','2013-05-01','10:00:00',1.84),('9650','2013-05-01','10:05:00',2.4),('9650','2013-05-01','10:10:00',2.36),('9650','2013-05-01','10:15:00',2.39),('9650','2013-05-01','10:20:00',2.46),('9650','2013-05-01','10:25:00',2.82),('9650','2013-05-01','10:30:00',4.15),('9650','2013-05-01','10:35:00',3.74),('9650','2013-05-01','10:40:00',4.89),('9650','2013-05-01','10:45:00',4.44),('9650','2013-05-01','10:50:00',5.36),('9650','2013-05-01','10:55:00',5.63),('9650','2013-05-01','11:00:00',5.53),('9650','2013-05-01','11:05:00',5.36),('9650','2013-05-01','11:10:00',4.5),('9650','2013-05-01','11:15:00',4.26),('9650','2013-05-01','11:20:00',3.87),('9650','2013-05-01','11:25:00',5.57),('9650','2013-05-01','11:30:00',5.88),('9650','2013-05-01','11:35:00',5.73),('9650','2013-05-01','11:40:00',5.67),('9650','2013-05-01','11:45:00',5.7),('9650','2013-05-01','11:50:00',5.74),('9650','2013-05-01','11:55:00',5.82),('9650','2013-05-01','12:00:00',5.85),('9650','2013-05-01','12:05:00',5.91),('9650','2013-05-01','12:10:00',5.91),('9650','2013-05-01','12:15:00',6),('9650','2013-05-01','12:20:00',6.06),('9650','2013-05-01','12:25:00',6.13),('9650','2013-05-01','12:30:00',6.23),('9650','2013-05-01','12:35:00',6.32),('9650','2013-05-01','12:40:00',6.42),('9650','2013-05-01','12:45:00',6.48),('9650','2013-05-01','12:50:00',6.5),('9650','2013-05-01','12:55:00',6.6),('9650','2013-05-01','13:00:00',6.66),('9650','2013-05-01','13:05:00',6.74),('9650','2013-05-01','13:10:00',6.8),('9650','2013-05-01','13:15:00',6.85),('9650','2013-05-01','13:20:00',6.87),('9650','2013-05-01','13:25:00',6.88),('9650','2013-05-01','13:30:00',6.92),('9650','2013-05-01','13:35:00',6.93),('9650','2013-05-01','13:40:00',6.97),('9650','2013-05-01','13:45:00',6.97),('9650','2013-05-01','13:50:00',6.98),('9650','2013-05-01','13:55:00',6.99),('9650','2013-05-01','14:00:00',6.96),('9650','2013-05-01','14:05:00',6.95),('9650','2013-05-01','14:10:00',6.94),('9650','2013-05-01','14:15:00',6.97),('9650','2013-05-01','14:20:00',6.94),('9650','2013-05-01','14:25:00',6.94),('9650','2013-05-01','14:30:00',6.92),('9650','2013-05-01','14:35:00',6.9),('9650','2013-05-01','14:40:00',6.88),('9650','2013-05-01','14:45:00',6.9),('9650','2013-05-01','14:50:00',6.92),('9650','2013-05-01','14:55:00',6.88),('9650','2013-05-01','15:00:00',6.9),('9650','2013-05-01','15:05:00',6.81),('9650','2013-05-01','15:10:00',6.81),('9650','2013-05-01','15:15:00',6.75),('9650','2013-05-01','15:20:00',6.71),('9650','2013-05-01','15:25:00',6.64),('9650','2013-05-01','15:30:00',6.51),('9650','2013-05-01','15:35:00',6.47),('9650','2013-05-01','15:40:00',6.39),('9650','2013-05-01','15:45:00',6.34),('9650','2013-05-01','15:50:00',6.31),('9650','2013-05-01','15:55:00',6.26),('9650','2013-05-01','16:00:00',6.23),('9650','2013-05-01','16:05:00',6.18),('9650','2013-05-01','16:10:00',6.14),('9650','2013-05-01','16:15:00',6.07),('9650','2013-05-01','16:20:00',5.97),('9650','2013-05-01','16:25:00',5.94),('9650','2013-05-01','16:30:00',5.83),('9650','2013-05-01','16:35:00',5.75),('9650','2013-05-01','16:40:00',5.68),('9650','2013-05-01','16:45:00',5.6),('9650','2013-05-01','16:50:00',5.53),('9650','2013-05-01','16:55:00',5.43),('9650','2013-05-01','17:00:00',5.34),('9650','2013-05-01','17:05:00',5.25),('9650','2013-05-01','17:10:00',5.15),('9650','2013-05-01','17:15:00',5.06),('9650','2013-05-01','17:20:00',4.92),('9650','2013-05-01','17:25:00',4.81),('9650','2013-05-01','17:30:00',4.69),('9650','2013-05-01','17:35:00',4.55),('9650','2013-05-01','17:40:00',4.43),('9650','2013-05-01','17:45:00',4.25),('9650','2013-05-01','17:50:00',4.19),('9650','2013-05-01','17:55:00',4.02),('9650','2013-05-01','18:00:00',3.91),('9650','2013-05-01','18:05:00',3.76),('9650','2013-05-01','18:10:00',3.62),('9650','2013-05-01','18:15:00',3.46),('9650','2013-05-01','18:20:00',3.32),('9650','2013-05-01','18:25:00',3.16),('9650','2013-05-01','18:30:00',2.97),('9650','2013-05-01','18:35:00',2.84),('9650','2013-05-01','18:40:00',2.65),('9650','2013-05-01','18:45:00',2.48),('9650','2013-05-01','18:50:00',2.31),('9650','2013-05-01','18:55:00',2.07),('9650','2013-05-01','19:00:00',1.84),('9650','2013-05-01','19:05:00',1.64),('9650','2013-05-01','19:10:00',1.45),('9650','2013-05-01','19:15:00',1.23),('9650','2013-05-01','19:20:00',1.05),('9650','2014-03-29','08:30:00',1.03),('9650','2014-03-29','08:35:00',1.1),('9650','2014-03-29','08:40:00',1.15),('9650','2014-03-29','08:45:00',1.19),('9650','2014-03-29','08:50:00',1.23),('9650','2014-03-29','08:55:00',1.27),('9650','2014-03-29','09:00:00',1.3),('9650','2014-03-29','09:05:00',1.32),('9650','2014-03-29','09:10:00',1.31),('9650','2014-03-29','09:15:00',1.35),('9650','2014-03-29','09:20:00',1.7),('9650','2014-03-29','09:25:00',1.81),('9650','2014-03-29','09:30:00',1.97),('9650','2014-03-29','09:35:00',2.08),('9650','2014-03-29','09:40:00',2.18),('9650','2014-03-29','09:45:00',2.28),('9650','2014-03-29','09:50:00',2.39),('9650','2014-03-29','09:55:00',2.37),('9650','2014-03-29','10:00:00',2.47),('9650','2014-03-29','10:05:00',2.75),('9650','2014-03-29','10:10:00',2.8),('9650','2014-03-29','10:15:00',2.88),('9650','2014-03-29','10:20:00',2.92),('9650','2014-03-29','10:25:00',3.13),('9650','2014-03-29','10:30:00',3.27),('9650','2014-03-29','10:35:00',3.41),('9650','2014-03-29','10:40:00',3.53),('9650','2014-03-29','10:45:00',3.6),('9650','2014-03-29','10:50:00',3.66),('9650','2014-03-29','10:55:00',3.75),('9650','2014-03-29','11:00:00',3.79),('9650','2014-03-29','11:05:00',3.79),('9650','2014-03-29','11:10:00',3.86),('9650','2014-03-29','11:15:00',3.8),('9650','2014-03-29','11:20:00',3.81),('9650','2014-03-29','11:25:00',4.05),('9650','2014-03-29','11:30:00',4.34),('9650','2014-03-29','11:35:00',4.43),('9650','2014-03-29','11:40:00',4.65),('9650','2014-03-29','11:45:00',4.85),('9650','2014-03-29','11:50:00',4.97),('9650','2014-03-29','11:55:00',5.12),('9650','2014-03-29','12:00:00',5.19),('9650','2014-03-29','12:05:00',5.39),('9650','2014-03-29','12:10:00',5.55),('9650','2014-03-29','12:15:00',5.71),('9650','2014-03-29','12:20:00',5.58),('9650','2014-03-29','12:25:00',5.62),('9650','2014-03-29','12:30:00',5.24),('9650','2014-03-29','12:35:00',5.25),('9650','2014-03-29','12:40:00',5.54),('9650','2014-03-29','12:45:00',5.54),('9650','2014-03-29','12:50:00',5.61),('9650','2014-03-29','12:55:00',5.79),('9650','2014-03-29','13:00:00',5.91),('9650','2014-03-29','13:05:00',6.09),('9650','2014-03-29','13:10:00',6.08),('9650','2014-03-29','13:15:00',6.1),('9650','2014-03-29','13:20:00',6.13),('9650','2014-03-29','13:25:00',6.16),('9650','2014-03-29','13:30:00',6.23),('9650','2014-03-29','13:35:00',6.27),('9650','2014-03-29','13:40:00',6.31),('9650','2014-03-29','13:45:00',6.35),('9650','2014-03-29','13:50:00',6.34),('9650','2014-03-29','13:55:00',6.19),('9650','2014-03-29','14:00:00',6.18),('9650','2014-03-29','14:05:00',6.26),('9650','2014-03-29','14:10:00',6.04),('9650','2014-03-29','14:15:00',6.07),('9650','2014-03-29','14:20:00',6.37),('9650','2014-03-29','14:25:00',6.55),('9650','2014-03-29','14:30:00',6.68),('9650','2014-03-29','14:35:00',6.02),('9650','2014-03-29','14:40:00',5.83),('9650','2014-03-29','14:45:00',5.46),('9650','2014-03-29','14:50:00',4.32),('9650','2014-03-29','14:55:00',4.09),('9650','2014-03-29','15:00:00',2.81),('9650','2014-03-29','15:05:00',2.44),('9650','2014-03-29','15:10:00',2.65),('9650','2014-03-29','15:15:00',3.82),('9650','2014-03-29','15:20:00',5.09),('9650','2014-03-29','15:25:00',5.46),('9650','2014-03-29','15:30:00',5.62),('9650','2014-03-29','15:35:00',5.75),('9650','2014-03-29','15:40:00',5.59),('9650','2014-03-29','15:45:00',5.8),('9650','2014-03-29','15:50:00',5.62),('9650','2014-03-29','15:55:00',5.53),('9650','2014-03-29','16:00:00',4.94),('9650','2014-03-29','16:05:00',4.49),('9650','2014-03-29','16:10:00',4.44),('9650','2014-03-29','16:15:00',4.84),('9650','2014-03-29','16:20:00',5.11),('9650','2014-03-29','16:25:00',5.15),('9650','2014-03-29','16:30:00',4.99),('9650','2014-03-29','16:35:00',5.13),('9650','2014-03-29','16:40:00',4.82),('9650','2014-03-29','16:45:00',4.36),('9650','2014-03-29','16:50:00',3.83),('9650','2014-03-29','16:55:00',3.6),('9650','2014-03-29','17:00:00',3.89),('9650','2014-03-29','17:05:00',4.19),('9650','2014-03-29','17:10:00',4.38),('9650','2014-03-29','17:15:00',4.34),('9650','2014-03-29','17:20:00',4.18),('9650','2014-03-29','17:25:00',3.68),('9650','2014-03-29','17:30:00',3.82),('9650','2014-03-29','17:35:00',3.73),('9650','2014-03-29','17:40:00',3.43),('9650','2014-03-29','17:45:00',3.43),('9650','2014-03-29','17:50:00',3.01),('9650','2014-03-29','17:55:00',2.35),('9650','2014-03-29','18:00:00',1.91),('9650','2014-03-29','18:05:00',2.15),('9650','2014-03-29','18:10:00',2.34),('9650','2014-03-29','18:15:00',2.01),('9650','2014-03-29','18:20:00',1.52),('9650','2014-03-29','18:25:00',1.31),('9650','2014-03-29','18:30:00',1.17),('9650','2013-04-30','08:00:00',1.01),('9650','2013-04-30','08:05:00',1.06),('9650','2013-04-30','08:10:00',1.1),('9650','2013-04-30','08:15:00',1.15),('9650','2013-04-30','08:20:00',1.19),('9650','2013-04-30','08:25:00',1.22),('9650','2013-04-30','08:30:00',1.24),('9650','2013-04-30','08:35:00',1.42),('9650','2013-04-30','08:40:00',1.61),('9650','2013-04-30','08:45:00',1.73),('9650','2013-04-30','08:50:00',1.85),('9650','2013-04-30','08:55:00',1.95),('9650','2013-04-30','09:00:00',2.09),('9650','2013-04-30','09:05:00',2.24),('9650','2013-04-30','09:10:00',2.34),('9650','2013-04-30','09:15:00',2.47),('9650','2013-04-30','09:20:00',2.57),('9650','2013-04-30','09:25:00',2.68),('9650','2013-04-30','09:30:00',2.78),('9650','2013-04-30','09:35:00',2.9),('9650','2013-04-30','09:40:00',3.02),('9650','2013-04-30','09:45:00',3.14),('9650','2013-04-30','09:50:00',3.24),('9650','2013-04-30','09:55:00',3.35),('9650','2013-04-30','10:00:00',3.44),('9650','2013-04-30','10:05:00',3.51),('9650','2013-04-30','10:10:00',3.67),('9650','2013-04-30','10:15:00',3.81),('9650','2013-04-30','10:20:00',3.92),('9650','2013-04-30','10:25:00',4.01),('9650','2013-04-30','10:30:00',4.1),('9650','2013-04-30','10:35:00',4.16),('9650','2013-04-30','10:40:00',4.44),('9650','2013-04-30','10:45:00',4.6),('9650','2013-04-30','10:50:00',4.7),('9650','2013-04-30','10:55:00',4.78),('9650','2013-04-30','11:00:00',4.9),('9650','2013-04-30','11:05:00',4.96),('9650','2013-04-30','11:10:00',5.07),('9650','2013-04-30','11:15:00',4.72),('9650','2013-04-30','11:20:00',4.82),('9650','2013-04-30','11:25:00',4.81),('9650','2013-04-30','11:30:00',4.75),('9650','2013-04-30','11:35:00',4.94),('9650','2013-04-30','11:40:00',3.88),('9650','2013-04-30','11:45:00',3.82),('9650','2013-04-30','11:50:00',4.93),('9650','2013-04-30','11:55:00',5.79),('9650','2013-04-30','12:00:00',5.8),('9650','2013-04-30','12:05:00',5.8),('9650','2013-04-30','12:10:00',5.87),('9650','2013-04-30','12:15:00',5.83),('9650','2013-04-30','12:20:00',5.98),('9650','2013-04-30','12:25:00',6.07),('9650','2013-04-30','12:30:00',6.18),('9650','2013-04-30','12:35:00',6.32),('9650','2013-04-30','12:40:00',6.54),('9650','2013-04-30','12:45:00',6.05),('9650','2013-04-30','12:50:00',4.42),('9650','2013-04-30','12:55:00',2.56),('9650','2013-04-30','13:00:00',2.75),('9650','2013-04-30','13:05:00',3.11),('9650','2013-04-30','13:10:00',4.02),('9650','2013-04-30','13:15:00',7.02),('9650','2013-04-30','13:20:00',7.81),('9650','2013-04-30','13:25:00',6.56),('9650','2013-04-30','13:30:00',5.65),('9650','2013-04-30','13:35:00',6.44),('9650','2013-04-30','13:40:00',7.39),('9650','2013-04-30','13:45:00',7.43),('9650','2013-04-30','13:50:00',7.03),('9650','2013-04-30','13:55:00',6.84),('9650','2013-04-30','14:00:00',6.7),('9650','2013-04-30','14:05:00',6.61),('9650','2013-04-30','14:10:00',6.61),('9650','2013-04-30','14:15:00',5.75),('9650','2013-04-30','14:20:00',6.99),('9650','2013-04-30','14:25:00',7.07),('9650','2013-04-30','14:30:00',7.12),('9650','2013-04-30','14:35:00',6.8),('9650','2013-04-30','14:40:00',6.21),('9650','2013-04-30','14:45:00',6.37),('9650','2013-04-30','14:50:00',5.59),('9650','2013-04-30','14:55:00',5.09),('9650','2013-04-30','15:00:00',5.51),('9650','2013-04-30','15:05:00',6.31),('9650','2013-04-30','15:10:00',6.5),('9650','2013-04-30','15:15:00',6.24),('9650','2013-04-30','15:20:00',6.07),('9650','2013-04-30','15:25:00',6.14),('9650','2013-04-30','15:30:00',5.02),('9650','2013-04-30','15:35:00',4.43),('9650','2013-04-30','15:40:00',4.45),('9650','2013-04-30','15:45:00',4.36),('9650','2013-04-30','15:50:00',3.2),('9650','2013-04-30','15:55:00',3.16),('9650','2013-04-30','16:00:00',3.84),('9650','2013-04-30','16:05:00',3.72),('9650','2013-04-30','16:10:00',3.41),('9650','2013-04-30','16:15:00',3.16),('9650','2013-04-30','16:20:00',2.79),('9650','2013-04-30','16:25:00',2.21),('9650','2013-04-30','16:30:00',2),('9650','2013-04-30','16:35:00',2.08),('9650','2013-04-30','16:40:00',2.2),('9650','2013-04-30','16:45:00',2.06),('9650','2013-04-30','16:50:00',1.8),('9650','2013-04-30','16:55:00',1.65),('9650','2013-04-30','17:00:00',1.63),('9650','2013-04-30','17:05:00',1.63),('9650','2013-04-30','17:10:00',1.64),('9650','2013-04-30','17:15:00',1.61),('9650','2013-04-30','17:20:00',1.44),('9650','2013-04-30','17:25:00',1.21),('9650','2013-04-30','17:30:00',1.01),('9650','2013-04-29','08:25:00',1.02),('9650','2013-04-29','08:35:00',1.1),('9650','2013-04-29','08:40:00',1.5),('9650','2013-04-29','08:45:00',1.55),('9650','2013-04-29','08:50:00',1.74),('9650','2013-04-29','08:55:00',2.05),('9650','2013-04-29','09:00:00',2.11),('9650','2013-04-29','09:05:00',2.04),('9650','2013-04-29','09:10:00',2.7),('9650','2013-04-29','09:15:00',2.99),('9650','2013-04-29','09:20:00',3.19),('9650','2013-04-29','09:25:00',3.42),('9650','2013-04-29','09:30:00',3.35),('9650','2013-04-29','09:35:00',2.8),('9650','2013-04-29','09:40:00',2.14),('9650','2013-04-29','09:45:00',2.78),('9650','2013-04-29','09:50:00',3.36),('9650','2013-04-29','09:55:00',3.76),('9650','2013-04-29','10:00:00',4.42),('9650','2013-04-29','10:05:00',4.37),('9650','2013-04-29','10:10:00',3.91),('9650','2013-04-29','10:15:00',3.32),('9650','2013-04-29','10:20:00',3.17),('9650','2013-04-29','10:25:00',4.55),('9650','2013-04-29','10:30:00',3.45),('9650','2013-04-29','10:35:00',3.17),('9650','2013-04-29','10:40:00',2.89),('9650','2013-04-29','10:45:00',2.4),('9650','2013-04-29','10:50:00',2.59),('9650','2013-04-29','10:55:00',2.79),('9650','2013-04-29','11:00:00',2.91),('9650','2013-04-29','11:05:00',3.22),('9650','2013-04-29','11:10:00',3.25),('9650','2013-04-29','11:15:00',3.36),('9650','2013-04-29','11:20:00',3.82),('9650','2013-04-29','11:25:00',3.53),('9650','2013-04-29','11:30:00',3.57),('9650','2013-04-29','11:35:00',3.77),('9650','2013-04-29','11:40:00',3.46),('9650','2013-04-29','11:45:00',2.89),('9650','2013-04-29','11:50:00',2.89),('9650','2013-04-29','11:55:00',2.98),('9650','2013-04-29','12:00:00',3.08),('9650','2013-04-29','12:05:00',3.16),('9650','2013-04-29','12:10:00',3.05),('9650','2013-04-29','12:15:00',2.81),('9650','2013-04-29','12:20:00',2.61),('9650','2013-04-29','12:25:00',2.47),('9650','2013-04-29','12:30:00',2.51),('9650','2013-04-29','12:35:00',4.46),('9650','2013-04-29','12:40:00',6.91),('9650','2013-04-29','12:45:00',7.27),('9650','2013-04-29','12:50:00',6.9),('9650','2013-04-29','12:55:00',6.12),('9650','2013-04-29','13:00:00',6.66),('9650','2013-04-29','13:05:00',6.54),('9650','2013-04-29','13:10:00',6.59),('9650','2013-04-29','13:15:00',6.55),('9650','2013-04-29','13:20:00',6.52),('9650','2013-04-29','13:25:00',6.53),('9650','2013-04-29','13:30:00',6.54),('9650','2013-04-29','13:35:00',6.52),('9650','2013-04-29','13:40:00',6.53),('9650','2013-04-29','13:45:00',6.47),('9650','2013-04-29','13:50:00',6.48),('9650','2013-04-29','13:55:00',6.48),('9650','2013-04-29','14:00:00',6.46),('9650','2013-04-29','14:05:00',6.48),('9650','2013-04-29','14:10:00',6.48),('9650','2013-04-29','14:15:00',6.48),('9650','2013-04-29','14:20:00',6.45),('9650','2013-04-29','14:25:00',6.49),('9650','2013-04-29','14:30:00',6.49),('9650','2013-04-29','14:35:00',6.44),('9650','2013-04-29','14:40:00',6.42),('9650','2013-04-29','14:45:00',6.41),('9650','2013-04-29','14:50:00',6.35),('9650','2013-04-29','14:55:00',6.33),('9650','2013-04-29','15:00:00',6.28),('9650','2013-04-29','15:05:00',6.23),('9650','2013-04-29','15:10:00',6.2),('9650','2013-04-29','15:15:00',6.15),('9650','2013-04-29','15:20:00',6.11),('9650','2013-04-29','15:25:00',6),('9650','2013-04-29','15:30:00',5.99),('9650','2013-04-29','15:35:00',5.99),('9650','2013-04-29','15:40:00',5.91),('9650','2013-04-29','15:45:00',5.82),('9650','2013-04-29','15:50:00',5.72),('9650','2013-04-29','15:55:00',5.65),('9650','2013-04-29','16:00:00',5.57),('9650','2013-04-29','16:05:00',5.51),('9650','2013-04-29','16:10:00',5.44),('9650','2013-04-29','16:15:00',5.38),('9650','2013-04-29','16:20:00',5.29),('9650','2013-04-29','16:25:00',5.23),('9650','2013-04-29','16:30:00',5.16),('9650','2013-04-29','16:35:00',4.86),('9650','2013-04-29','16:40:00',4.18),('9650','2013-04-29','16:45:00',4.2),('9650','2013-04-29','16:50:00',3.94),('9650','2013-04-29','16:55:00',4.53),('9650','2013-04-29','17:00:00',4.31),('9650','2013-04-29','17:05:00',4.31),('9650','2013-04-29','17:10:00',3.61),('9650','2013-04-29','17:15:00',1.89),('9650','2013-04-29','17:20:00',3.3),('9650','2013-04-29','17:25:00',3.82),('9650','2013-04-29','17:30:00',3.66),('9650','2013-04-29','17:35:00',3.64),('9650','2013-04-29','17:40:00',3.48),('9650','2013-04-29','17:45:00',3.35),('9650','2013-04-29','17:50:00',3.19),('9650','2013-04-29','17:55:00',3.03),('9650','2013-04-29','18:00:00',2.89),('9650','2013-04-29','18:05:00',2.72),('9650','2013-04-29','18:10:00',2.58),('9650','2013-04-29','18:15:00',2.41),('9650','2013-04-29','18:20:00',2.24),('9650','2013-04-29','18:25:00',2.09),('9650','2013-04-29','18:30:00',1.92),('9650','2013-04-29','18:35:00',1.74),('9650','2013-04-29','18:40:00',1.57),('9650','2013-04-29','18:45:00',1.42),('9650','2013-04-29','18:50:00',1.28),('9650','2013-04-29','18:55:00',1.11),('9650','2013-04-28','07:45:00',1.03),('9650','2013-04-28','07:50:00',1.11),('9650','2013-04-28','07:55:00',1.2),('9650','2013-04-28','08:00:00',1.23),('9650','2013-04-28','08:05:00',1.22),('9650','2013-04-28','08:10:00',1.19),('9650','2013-04-28','08:15:00',1.22),('9650','2013-04-28','08:20:00',1.34),('9650','2013-04-28','08:25:00',1.65),('9650','2013-04-28','08:30:00',1.86),('9650','2013-04-28','08:35:00',2.06),('9650','2013-04-28','08:40:00',2.08),('9650','2013-04-28','08:45:00',2.1),('9650','2013-04-28','08:50:00',2.22),('9650','2013-04-28','08:55:00',2.24),('9650','2013-04-28','09:00:00',1.98),('9650','2013-04-28','09:05:00',2.56),('9650','2013-04-28','09:10:00',2.8),('9650','2013-04-28','09:15:00',2.93),('9650','2013-04-28','09:20:00',2.76),('9650','2013-04-28','09:25:00',2.76),('9650','2013-04-28','09:30:00',2.87),('9650','2013-04-28','09:35:00',3.07),('9650','2013-04-28','09:40:00',3.13),('9650','2013-04-28','09:45:00',3.23),('9650','2013-04-28','09:50:00',3.5),('9650','2013-04-28','09:55:00',3.36),('9650','2013-04-28','10:00:00',3.54),('9650','2013-04-28','10:05:00',3.54),('9650','2013-04-28','10:10:00',3.56),('9650','2013-04-28','10:15:00',2.96),('9650','2013-04-28','10:20:00',3.06),('9650','2013-04-28','10:25:00',3.6),('9650','2013-04-28','10:30:00',3.82),('9650','2013-04-28','10:35:00',4.34),('9650','2013-04-28','10:40:00',4.43),('9650','2013-04-28','10:45:00',4.56),('9650','2013-04-28','10:50:00',4.45),('9650','2013-04-28','10:55:00',4.21),('9650','2013-04-28','11:00:00',4.79),('9650','2013-04-28','11:05:00',4.55),('9650','2013-04-28','11:10:00',4.43),('9650','2013-04-28','11:15:00',4.23),('9650','2013-04-28','11:20:00',4.97),('9650','2013-04-28','11:25:00',5.09),('9650','2013-04-28','11:30:00',5.37),('9650','2013-04-28','11:35:00',5.13),('9650','2013-04-28','11:40:00',5.27),('9650','2013-04-28','11:45:00',4.97),('9650','2013-04-28','11:50:00',5.7),('9650','2013-04-28','11:55:00',5.65),('9650','2013-04-28','12:00:00',5.85),('9650','2013-04-28','12:05:00',5.81),('9650','2013-04-28','12:10:00',5.7),('9650','2013-04-28','12:15:00',5.86),('9650','2013-04-28','12:20:00',5.93),('9650','2013-04-28','12:25:00',5.8),('9650','2013-04-28','12:30:00',5.96),('9650','2013-04-28','12:35:00',6.06),('9650','2013-04-28','12:40:00',6.14),('9650','2013-04-28','12:45:00',6.26),('9650','2013-04-28','12:50:00',6.26),('9650','2013-04-28','12:55:00',6.29),('9650','2013-04-28','13:00:00',6.43),('9650','2013-04-28','13:05:00',6.33),('9650','2013-04-28','13:10:00',6.15),('9650','2013-04-28','13:15:00',5.56),('9650','2013-04-28','13:20:00',6.29),('9650','2013-04-28','13:25:00',6.46),('9650','2013-04-28','13:30:00',6.45),('9650','2013-04-28','13:35:00',6.28),('9650','2013-04-28','13:40:00',6.53),('9650','2013-04-28','13:45:00',6.53),('9650','2013-04-28','13:50:00',6.24),('9650','2013-04-28','13:55:00',7.07),('9650','2013-04-28','14:00:00',6.41),('9650','2013-04-28','14:05:00',6.3),('9650','2013-04-28','14:10:00',6.54),('9650','2013-04-28','14:15:00',6.77),('9650','2013-04-28','14:20:00',6.84),('9650','2013-04-28','14:25:00',6.56),('9650','2013-04-28','14:30:00',6.29),('9650','2013-04-28','14:35:00',6.26),('9650','2013-04-28','14:40:00',5.94),('9650','2013-04-28','14:45:00',6.48),('9650','2013-04-28','14:50:00',6.37),('9650','2013-04-28','14:55:00',6.45),('9650','2013-04-28','15:00:00',6.35),('9650','2013-04-28','15:05:00',6.64),('9650','2013-04-28','15:10:00',5.89),('9650','2013-04-28','15:15:00',5.85),('9650','2013-04-28','15:20:00',6.33),('9650','2013-04-28','15:25:00',6.59),('9650','2013-04-28','15:30:00',6.42),('9650','2013-04-28','15:35:00',5.56),('9650','2013-04-28','15:40:00',5.13),('9650','2013-04-28','15:45:00',5.04),('9650','2013-04-28','15:50:00',5.23),('9650','2013-04-28','15:55:00',5.57),('9650','2013-04-28','16:00:00',5.47),('9650','2013-04-28','16:05:00',5.9),('9650','2013-04-28','16:10:00',5.58),('9650','2013-04-28','16:15:00',6.66),('9650','2013-04-28','16:20:00',6.27),('9650','2013-04-28','16:25:00',4.87),('9650','2013-04-28','16:30:00',5.2),('9650','2013-04-28','16:35:00',5.29),('9650','2013-04-28','16:40:00',5.65),('9650','2013-04-28','16:45:00',5.74),('9650','2013-04-28','16:50:00',5.97),('9650','2013-04-28','16:55:00',6.26),('9650','2013-04-28','17:00:00',5.75),('9650','2013-04-28','17:05:00',4.99),('9650','2013-04-28','17:10:00',5.26),('9650','2013-04-28','17:15:00',4.48),('9650','2013-04-28','17:20:00',3.76),('9650','2013-04-28','17:25:00',3.56),('9650','2013-04-28','17:30:00',3.48),('9650','2013-04-28','17:35:00',3.23),('9650','2013-04-28','17:40:00',2.67),('9650','2013-04-28','17:45:00',2.41),('9650','2013-04-28','17:50:00',3.22),('9650','2013-04-28','17:55:00',3.82),('9650','2013-04-28','18:00:00',3.78),('9650','2013-04-28','18:05:00',4.39),('9650','2013-04-28','18:10:00',4.07),('9650','2013-04-28','18:15:00',3.93),('9650','2013-04-28','18:20:00',3.45),('9650','2013-04-28','18:25:00',3.53),('9650','2013-04-28','18:30:00',3.31),('9650','2013-04-28','18:35:00',2.51),('9650','2013-04-28','18:40:00',2.28),('9650','2013-04-28','18:45:00',1.81),('9650','2013-04-28','18:50:00',1.14),('9650','2013-04-27','08:20:00',1.08),('9650','2013-04-27','08:25:00',1.18),('9650','2013-04-27','08:30:00',1.24),('9650','2013-04-27','08:35:00',1.35),('9650','2013-04-27','08:40:00',1.47),('9650','2013-04-27','08:45:00',1.61),('9650','2013-04-27','08:50:00',1.72),('9650','2013-04-27','08:55:00',1.84),('9650','2013-04-27','09:00:00',1.97),('9650','2013-04-27','09:05:00',2.1),('9650','2013-04-27','09:10:00',2.21),('9650','2013-04-27','09:15:00',2.37),('9650','2013-04-27','09:20:00',2.51),('9650','2013-04-27','09:25:00',2.65),('9650','2013-04-27','09:30:00',2.8),('9650','2013-04-27','09:35:00',2.93),('9650','2013-04-27','09:40:00',3.06),('9650','2013-04-27','09:45:00',3.19),('9650','2013-04-27','09:50:00',3.34),('9650','2013-04-27','09:55:00',3.45),('9650','2013-04-27','10:00:00',3.58),('9650','2013-04-27','10:05:00',3.68),('9650','2013-04-27','10:10:00',3.81),('9650','2013-04-27','10:15:00',3.91),('9650','2013-04-27','10:20:00',4.04),('9650','2013-04-27','10:25:00',4.27),('9650','2013-04-27','10:30:00',4.25),('9650','2013-04-27','10:35:00',4.44),('9650','2013-04-27','10:40:00',4.09),('9650','2013-04-27','10:45:00',4.71),('9650','2013-04-27','10:50:00',4.79),('9650','2013-04-27','10:55:00',4.88),('9650','2013-04-27','11:00:00',5),('9650','2013-04-27','11:05:00',5.11),('9650','2013-04-27','11:10:00',5.25),('9650','2013-04-27','11:15:00',5.32),('9650','2013-04-27','11:20:00',5.38),('9650','2013-04-27','11:25:00',5.53),('9650','2013-04-27','11:30:00',5.56),('9650','2013-04-27','11:35:00',5.45),('9650','2013-04-27','11:40:00',5.65),('9650','2013-04-27','11:45:00',5.42),('9650','2013-04-27','11:50:00',5.55),('9650','2013-04-27','11:55:00',5.83),('9650','2013-04-27','12:00:00',5.22),('9650','2013-04-27','12:05:00',5.18),('9650','2013-04-27','12:10:00',5.77),('9650','2013-04-27','12:15:00',5.95),('9650','2013-04-27','12:20:00',5.61),('9650','2013-04-27','12:25:00',5.31),('9650','2013-04-27','12:30:00',5.1),('9650','2013-04-27','12:35:00',4.72),('9650','2013-04-27','12:40:00',4.82),('9650','2013-04-27','12:45:00',6.31),('9650','2013-04-27','12:50:00',6.37),('9650','2013-04-27','12:55:00',5.99),('9650','2013-04-27','13:00:00',6.25),('9650','2013-04-27','13:05:00',6.75),('9650','2013-04-27','13:10:00',6.67),('9650','2013-04-27','13:15:00',6.18),('9650','2013-04-27','13:20:00',6.31),('9650','2013-04-27','13:25:00',6.17),('9650','2013-04-27','13:30:00',6.64),('9650','2013-04-27','13:35:00',6.79),('9650','2013-04-27','13:40:00',5.62),('9650','2013-04-27','13:45:00',3.17),('9650','2013-04-27','13:50:00',3.04),('9650','2013-04-27','13:55:00',2.78),('9650','2013-04-27','14:00:00',5.19),('9650','2013-04-27','14:05:00',6.76),('9650','2013-04-27','14:10:00',6.92),('9650','2013-04-27','14:15:00',6.75),('9650','2013-04-27','14:20:00',5.88),('9650','2013-04-27','14:25:00',7.08),('9650','2013-04-27','14:30:00',6.66),('9650','2013-04-27','14:35:00',6.97),('9650','2013-04-27','14:40:00',6.9),('9650','2013-04-27','14:45:00',6.85),('9650','2013-04-27','14:50:00',6.77),('9650','2013-04-27','14:55:00',6.74),('9650','2013-04-27','15:00:00',6.71),('9650','2013-04-27','15:05:00',6.71),('9650','2013-04-27','15:10:00',6.71),('9650','2013-04-27','15:15:00',6.67),('9650','2013-04-27','15:20:00',6.62),('9650','2013-04-27','15:25:00',6.56),('9650','2013-04-27','15:30:00',6.52),('9650','2013-04-27','15:35:00',6.48),('9650','2013-04-27','15:40:00',6.43),('9650','2013-04-27','15:45:00',6.35),('9650','2013-04-27','15:50:00',6.3),('9650','2013-04-27','15:55:00',6.27),('9650','2013-04-27','16:00:00',6.22),('9650','2013-04-27','16:05:00',6.17),('9650','2013-04-27','16:10:00',6.12),('9650','2013-04-27','16:15:00',6.03),('9650','2013-04-27','16:20:00',5.95),('9650','2013-04-27','16:25:00',5.87),('9650','2013-04-27','16:30:00',5.79),('9650','2013-04-27','16:35:00',5.73),('9650','2013-04-27','16:40:00',5.62),('9650','2013-04-27','16:45:00',5.58),('9650','2013-04-27','16:50:00',5.49),('9650','2013-04-27','16:55:00',5.35),('9650','2013-04-27','17:00:00',5.23),('9650','2013-04-27','17:05:00',4.86),('9650','2013-04-27','17:10:00',4.75),('9650','2013-04-27','17:15:00',4.96),('9650','2013-04-27','17:20:00',4.78),('9650','2013-04-27','17:25:00',4.7),('9650','2013-04-27','17:30:00',4.08),('9650','2013-04-27','17:35:00',4.14),('9650','2013-04-27','17:40:00',3.93),('9650','2013-04-27','17:45:00',4.07),('9650','2013-04-27','17:50:00',3.92),('9650','2013-04-27','17:55:00',3.47),('9650','2013-04-27','18:00:00',3.52),('9650','2013-04-27','18:05:00',3.36),('9650','2013-04-27','18:10:00',2.13),('9650','2013-04-27','18:15:00',2.09),('9650','2013-04-27','18:20:00',2.82),('9650','2013-04-27','18:25:00',2.81),('9650','2013-04-27','18:30:00',2.19),('9650','2013-04-27','18:35:00',2.11),('9650','2013-04-27','18:40:00',2.06),('9650','2013-04-27','18:45:00',1.66),('9650','2013-04-27','18:50:00',1.65),('9650','2013-04-27','18:55:00',1.47),('9650','2013-04-27','19:00:00',1.32),('9650','2013-04-27','19:05:00',1.22),('9650','2013-04-27','19:10:00',1.14),('9650','2013-04-26','11:50:00',1.18),('9650','2013-04-26','11:55:00',1.23),('9650','2013-04-26','12:00:00',1.31),('9650','2013-04-26','12:05:00',1.28),('9650','2013-04-26','12:10:00',1.13),('9650','2013-04-26','12:15:00',1.04),('9650','2013-04-26','12:30:00',1.1),('9650','2013-04-26','12:35:00',1.2),('9650','2013-04-26','12:40:00',1.49),('9650','2013-04-26','12:45:00',1.6),('9650','2013-04-26','12:50:00',1.85),('9650','2013-04-26','12:55:00',2.38),('9650','2013-04-26','13:00:00',2.61),('9650','2013-04-26','13:05:00',1.98),('9650','2013-04-26','13:10:00',2.21),('9650','2013-04-26','13:15:00',2.76),('9650','2013-04-26','13:20:00',2.94),('9650','2013-04-26','13:25:00',2.1),('9650','2013-04-26','13:30:00',2.14),('9650','2013-04-26','13:35:00',2.68),('9650','2013-04-26','13:40:00',2.88),('9650','2013-04-26','13:45:00',2.01),('9650','2013-04-26','13:50:00',2.01),('9650','2013-04-26','13:55:00',1.39),('9650','2013-04-26','14:05:00',1.07),('9650','2013-04-26','14:25:00',2.03),('9650','2013-04-26','14:30:00',3.7),('9650','2013-04-26','14:35:00',3.34),('9650','2013-04-26','14:40:00',2.29),('9650','2013-04-26','14:45:00',2.05),('9650','2013-04-26','14:50:00',1.16),('9650','2013-04-26','14:55:00',1.4),('9650','2013-04-26','15:00:00',1.66),('9650','2013-04-26','15:05:00',2.82),('9650','2013-04-26','15:10:00',2.27),('9650','2013-04-26','15:15:00',1.71),('9650','2013-04-26','15:20:00',1.08),('9650','2013-04-26','15:50:00',1.54),('9650','2013-04-26','16:40:00',1.77),('9650','2013-04-26','16:45:00',2.47),('9650','2013-04-26','16:50:00',3.9),('9650','2013-04-26','16:55:00',4),('9650','2013-04-26','17:00:00',5.52),('9650','2013-04-26','17:05:00',3.26),('9650','2013-04-26','17:10:00',1.42),('9650','2013-04-26','17:15:00',1.02),('9650','2013-04-26','17:20:00',2),('9650','2013-04-26','17:25:00',1.08),('9650','2013-04-26','17:35:00',1.54),('9650','2013-04-26','17:40:00',2.46),('9650','2013-04-26','17:45:00',2.52),('9650','2013-04-26','17:50:00',1.09),('9650','2013-04-25','08:10:00',1.08),('9650','2013-04-25','08:15:00',1.14),('9650','2013-04-25','08:20:00',1.18),('9650','2013-04-25','08:25:00',1.23),('9650','2013-04-25','08:30:00',1.26),('9650','2013-04-25','08:35:00',1.37),('9650','2013-04-25','08:40:00',1.6),('9650','2013-04-25','08:45:00',1.71),('9650','2013-04-25','08:50:00',1.65),('9650','2013-04-25','08:55:00',1.61),('9650','2013-04-25','09:00:00',1.66),('9650','2013-04-25','09:05:00',2.11),('9650','2013-04-25','09:10:00',2.17),('9650','2013-04-25','09:15:00',1.77),('9650','2013-04-25','09:20:00',1.73),('9650','2013-04-25','09:25:00',2.08),('9650','2013-04-25','09:30:00',2.43),('9650','2013-04-25','09:35:00',2.18),('9650','2013-04-25','09:40:00',2.22),('9650','2013-04-25','09:45:00',2.84),('9650','2013-04-25','09:50:00',3.12),('9650','2013-04-25','09:55:00',2.25),('9650','2013-04-25','10:00:00',2.9),('9650','2013-04-25','10:05:00',3.57),('9650','2013-04-25','10:10:00',3.64),('9650','2013-04-25','10:15:00',3.97),('9650','2013-04-25','10:20:00',3.9),('9650','2013-04-25','10:25:00',3.85),('9650','2013-04-25','10:30:00',4.24),('9650','2013-04-25','10:35:00',4.56),('9650','2013-04-25','10:40:00',4.45),('9650','2013-04-25','10:45:00',4.51),('9650','2013-04-25','10:50:00',3.65),('9650','2013-04-25','10:55:00',2.57),('9650','2013-04-25','11:00:00',4.48),('9650','2013-04-25','11:05:00',4.57),('9650','2013-04-25','11:10:00',4.44),('9650','2013-04-25','11:15:00',4.35),('9650','2013-04-25','11:20:00',3.42),('9650','2013-04-25','11:25:00',4.31),('9650','2013-04-25','11:30:00',4.51),('9650','2013-04-25','11:35:00',5.2),('9650','2013-04-25','11:40:00',4.83),('9650','2013-04-25','11:45:00',4.82),('9650','2013-04-25','11:50:00',4.07),('9650','2013-04-25','11:55:00',4),('9650','2013-04-25','12:00:00',4.5),('9650','2013-04-25','12:05:00',4.37),('9650','2013-04-25','12:10:00',3.93),('9650','2013-04-25','12:15:00',4.66),('9650','2013-04-25','12:20:00',4.24),('9650','2013-04-25','12:25:00',3.1),('9650','2013-04-25','12:30:00',3.05),('9650','2013-04-25','12:35:00',3.83),('9650','2013-04-25','12:40:00',5.05),('9650','2013-04-25','12:45:00',4.95),('9650','2013-04-25','12:50:00',3.5),('9650','2013-04-25','12:55:00',3.17),('9650','2013-04-25','13:00:00',2.32),('9650','2013-04-25','13:05:00',2.24),('9650','2013-04-25','13:10:00',2.77),('9650','2013-04-25','13:15:00',4.08),('9650','2013-04-25','13:20:00',3.02),('9650','2013-04-25','13:25:00',3.56),('9650','2013-04-25','13:30:00',4.87),('9650','2013-04-25','13:35:00',4.1),('9650','2013-04-25','13:40:00',4.56),('9650','2013-04-25','13:45:00',3.77),('9650','2013-04-25','13:50:00',5.64),('9650','2013-04-25','13:55:00',4.07),('9650','2013-04-25','14:00:00',5.2),('9650','2013-04-25','14:05:00',6.3),('9650','2013-04-25','14:10:00',5.24),('9650','2013-04-25','14:15:00',5.49),('9650','2013-04-25','14:20:00',6.36),('9650','2013-04-25','14:25:00',6.81),('9650','2013-04-25','14:30:00',6.46),('9650','2013-04-25','14:35:00',4.65),('9650','2013-04-25','14:40:00',2.97),('9650','2013-04-25','14:45:00',2.71),('9650','2013-04-25','14:50:00',6.71),('9650','2013-04-25','14:55:00',7.26),('9650','2013-04-25','15:00:00',6.67),('9650','2013-04-25','15:05:00',3.96),('9650','2013-04-25','15:10:00',2.6),('9650','2013-04-25','15:15:00',3.78),('9650','2013-04-25','15:20:00',2.58),('9650','2013-04-25','15:25:00',2.81),('9650','2013-04-25','15:30:00',3.85),('9650','2013-04-25','15:35:00',3.4),('9650','2013-04-25','15:40:00',3.57),('9650','2013-04-25','15:45:00',4.11),('9650','2013-04-25','15:50:00',3.32),('9650','2013-04-25','15:55:00',1.88),('9650','2013-04-24','07:50:00',1.03),('9650','2013-04-24','07:55:00',1.14),('9650','2013-04-24','08:00:00',1.25),('9650','2013-04-24','08:05:00',1.38),('9650','2013-04-24','08:10:00',1.41),('9650','2013-04-24','08:15:00',1.5),('9650','2013-04-24','08:20:00',1.36),('9650','2013-04-24','08:25:00',1.32),('9650','2013-04-24','08:30:00',1.4),('9650','2013-04-24','08:35:00',1.52),('9650','2013-04-24','08:40:00',1.64),('9650','2013-04-24','08:45:00',1.93),('9650','2013-04-24','08:50:00',2.39),('9650','2013-04-24','08:55:00',2.56),('9650','2013-04-24','09:00:00',2.25),('9650','2013-04-24','09:05:00',1.9),('9650','2013-04-24','09:10:00',1.86),('9650','2013-04-24','09:15:00',1.71),('9650','2013-04-24','09:20:00',1.77),('9650','2013-04-24','09:25:00',1.88),('9650','2013-04-24','09:30:00',1.76),('9650','2013-04-24','09:35:00',1.95),('9650','2013-04-24','09:40:00',2.55),('9650','2013-04-24','09:45:00',3.04),('9650','2013-04-24','09:50:00',3.48),('9650','2013-04-24','09:55:00',3.58),('9650','2013-04-24','10:00:00',3.65),('9650','2013-04-24','10:05:00',3.49),('9650','2013-04-24','10:10:00',3.25),('9650','2013-04-24','10:15:00',3.44),('9650','2013-04-24','10:20:00',3.87),('9650','2013-04-24','10:25:00',4.07),('9650','2013-04-24','10:30:00',4.31),('9650','2013-04-24','10:35:00',4.39),('9650','2013-04-24','10:40:00',4.43),('9650','2013-04-24','10:45:00',4.24),('9650','2013-04-24','10:50:00',4.62),('9650','2013-04-24','10:55:00',4.59),('9650','2013-04-24','11:00:00',4.87),('9650','2013-04-24','11:05:00',4.92),('9650','2013-04-24','11:10:00',5.07),('9650','2013-04-24','11:15:00',5.17),('9650','2013-04-24','11:20:00',5.27),('9650','2013-04-24','11:25:00',5.34),('9650','2013-04-24','11:30:00',5.45),('9650','2013-04-24','11:35:00',5.46),('9650','2013-04-24','11:40:00',5.66),('9650','2013-04-24','11:45:00',5.74),('9650','2013-04-24','11:50:00',5.81),('9650','2013-04-24','11:55:00',5.79),('9650','2013-04-24','12:00:00',5.73),('9650','2013-04-24','12:05:00',5.81),('9650','2013-04-24','12:10:00',6),('9650','2013-04-24','12:15:00',6.1),('9650','2013-04-24','12:20:00',6.14),('9650','2013-04-24','12:25:00',6.14),('9650','2013-04-24','12:30:00',6.22),('9650','2013-04-24','12:35:00',6.3),('9650','2013-04-24','12:40:00',6.35),('9650','2013-04-24','12:45:00',6.41),('9650','2013-04-24','12:50:00',6.41),('9650','2013-04-24','12:55:00',6.5),('9650','2013-04-24','13:00:00',6.62),('9650','2013-04-24','13:05:00',6.8),('9650','2013-04-24','13:10:00',6.22),('9650','2013-04-24','13:15:00',6.5),('9650','2013-04-24','13:20:00',6.16),('9650','2013-04-24','13:25:00',6.03),('9650','2013-04-24','13:30:00',4.58),('9650','2013-04-24','13:35:00',4.49),('9650','2013-04-24','13:40:00',4.07),('9650','2013-04-24','13:45:00',3.83),('9650','2013-04-24','13:50:00',3.64),('9650','2013-04-24','13:55:00',3.96),('9650','2013-04-24','14:00:00',4.04),('9650','2013-04-24','14:05:00',3.75),('9650','2013-04-24','14:10:00',4.06),('9650','2013-04-24','14:15:00',4.32),('9650','2013-04-24','14:20:00',4.42),('9650','2013-04-24','14:25:00',4.63),('9650','2013-04-24','14:30:00',5.49),('9650','2013-04-24','14:35:00',6.12),('9650','2013-04-24','14:40:00',5.91),('9650','2013-04-24','14:45:00',6.1),('9650','2013-04-24','14:50:00',5.52),('9650','2013-04-24','14:55:00',5.79),('9650','2013-04-24','15:00:00',5.61),('9650','2013-04-24','15:05:00',5.1),('9650','2013-04-24','15:10:00',5.11),('9650','2013-04-24','15:15:00',5.87),('9650','2013-04-24','15:20:00',6.34),('9650','2013-04-24','15:25:00',6.57),('9650','2013-04-24','15:30:00',6.4),('9650','2013-04-24','15:35:00',6.07),('9650','2013-04-24','15:40:00',5.61),('9650','2013-04-24','15:45:00',5.4),('9650','2013-04-24','15:50:00',5.06),('9650','2013-04-24','15:55:00',4.85),('9650','2013-04-24','16:00:00',5.08),('9650','2013-04-24','16:05:00',4.23),('9650','2013-04-24','16:10:00',4.24),('9650','2013-04-24','16:15:00',4.17),('9650','2013-04-24','16:20:00',4.46),('9650','2013-04-24','16:25:00',3.89),('9650','2013-04-24','16:30:00',3.87),('9650','2013-04-24','16:35:00',4.66),('9650','2013-04-24','16:40:00',4.09),('9650','2013-04-24','16:45:00',4.27),('9650','2013-04-24','16:50:00',3.57),('9650','2013-04-24','16:55:00',3.85),('9650','2013-04-24','17:00:00',3.64),('9650','2013-04-24','17:05:00',4.67),('9650','2013-04-24','17:10:00',5.07),('9650','2013-04-24','17:15:00',4.69),('9650','2013-04-24','17:20:00',4.71),('9650','2013-04-24','17:25:00',3.91),('9650','2013-04-24','17:30:00',3.1),('9650','2013-04-24','17:35:00',2.96),('9650','2013-04-24','17:40:00',3.1),('9650','2013-04-24','17:45:00',2.62),('9650','2013-04-24','17:50:00',2.12),('9650','2013-04-24','17:55:00',1.83),('9650','2013-04-24','18:00:00',1.77),('9650','2013-04-24','18:05:00',1.64),('9650','2013-04-24','18:10:00',1.47),('9650','2013-04-24','18:15:00',1.3),('9650','2013-04-24','18:20:00',1.16),('9650','2013-04-24','18:25:00',1.03),('9650','2013-04-23','08:20:00',1.05),('9650','2013-04-23','08:25:00',1.13),('9650','2013-04-23','08:30:00',1.17),('9650','2013-04-23','08:35:00',1.2),('9650','2013-04-23','08:40:00',1.26),('9650','2013-04-23','08:45:00',1.35),('9650','2013-04-23','08:50:00',1.49),('9650','2013-04-23','08:55:00',1.63),('9650','2013-04-23','09:00:00',1.89),('9650','2013-04-23','09:05:00',2.16),('9650','2013-04-23','09:10:00',2.39),('9650','2013-04-23','09:15:00',2.53),('9650','2013-04-23','09:20:00',2.48),('9650','2013-04-23','09:25:00',3.02),('9650','2013-04-23','09:30:00',3.13),('9650','2013-04-23','09:35:00',3.38),('9650','2013-04-23','09:40:00',3.3),('9650','2013-04-23','09:45:00',3.23),('9650','2013-04-23','09:50:00',3.45),('9650','2013-04-23','09:55:00',3.73),('9650','2013-04-23','10:00:00',3.79),('9650','2013-04-23','10:05:00',3.93),('9650','2013-04-23','10:10:00',4.04),('9650','2013-04-23','10:15:00',4.03),('9650','2013-04-23','10:20:00',3.98),('9650','2013-04-23','10:25:00',3.98),('9650','2013-04-23','10:30:00',3.97),('9650','2013-04-23','10:35:00',4.03),('9650','2013-04-23','10:40:00',4.49),('9650','2013-04-23','10:45:00',4.57),('9650','2013-04-23','10:50:00',4.71),('9650','2013-04-23','10:55:00',4.89),('9650','2013-04-23','11:00:00',4.94),('9650','2013-04-23','11:05:00',4.89),('9650','2013-04-23','11:10:00',5.35),('9650','2013-04-23','11:15:00',5.47),('9650','2013-04-23','11:20:00',5.7),('9650','2013-04-23','11:25:00',5.78),('9650','2013-04-23','11:30:00',5.64),('9650','2013-04-23','11:35:00',5.18),('9650','2013-04-23','11:40:00',3.98),('9650','2013-04-23','11:45:00',4.09),('9650','2013-04-23','11:50:00',3.2),('9650','2013-04-23','11:55:00',4.56),('9650','2013-04-23','12:00:00',5.24),('9650','2013-04-23','12:05:00',3.73),('9650','2013-04-23','12:10:00',4.47),('9650','2013-04-23','12:15:00',6.07),('9650','2013-04-23','12:20:00',7.05),('9650','2013-04-23','12:25:00',6.07),('9650','2013-04-23','12:30:00',6.02),('9650','2013-04-23','12:35:00',6.26),('9650','2013-04-23','12:40:00',5.93),('9650','2013-04-23','12:45:00',6.22),('9650','2013-04-23','12:50:00',6.58),('9650','2013-04-23','12:55:00',6.39),('9650','2013-04-23','13:00:00',6.26),('9650','2013-04-23','13:05:00',5.55),('9650','2013-04-23','13:10:00',7.19),('9650','2013-04-23','13:15:00',6.66),('9650','2013-04-23','13:20:00',6.31),('9650','2013-04-23','13:25:00',6.65),('9650','2013-04-23','13:30:00',6.12),('9650','2013-04-23','13:35:00',6.41),('9650','2013-04-23','13:40:00',7.33),('9650','2013-04-23','13:45:00',6.16),('9650','2013-04-23','13:50:00',4.75),('9650','2013-04-23','13:55:00',7.12),('9650','2013-04-23','14:00:00',6.91),('9650','2013-04-23','14:05:00',4.99),('9650','2013-04-23','14:10:00',5.1),('9650','2013-04-23','14:15:00',7.03),('9650','2013-04-23','14:20:00',6.45),('9650','2013-04-23','14:25:00',6.65),('9650','2013-04-23','14:30:00',6.22),('9650','2013-04-23','14:35:00',5.67),('9650','2013-04-23','14:40:00',5.26),('9650','2013-04-23','14:45:00',5.28),('9650','2013-04-23','14:50:00',4.69),('9650','2013-04-23','14:55:00',4.15),('9650','2013-04-23','15:00:00',4.64),('9650','2013-04-23','15:05:00',4.19),('9650','2013-04-23','15:10:00',3.93),('9650','2013-04-23','15:15:00',4.14),('9650','2013-04-23','15:20:00',4.28),('9650','2013-04-23','15:25:00',3.61),('9650','2013-04-23','15:30:00',3.17),('9650','2013-04-23','15:35:00',3.08),('9650','2013-04-23','15:40:00',3.06),('9650','2013-04-23','15:45:00',3.08),('9650','2013-04-23','15:50:00',3.13),('9650','2013-04-23','15:55:00',4.03),('9650','2013-04-23','16:00:00',5.04),('9650','2013-04-23','16:05:00',5.39),('9650','2013-04-23','16:10:00',5.39),('9650','2013-04-23','16:15:00',5.04),('9650','2013-04-23','16:20:00',6.66),('9650','2013-04-23','16:25:00',4.92),('9650','2013-04-23','16:30:00',4.35),('9650','2013-04-23','16:35:00',3.85),('9650','2013-04-23','16:40:00',5.21),('9650','2013-04-23','16:45:00',5.37),('9650','2013-04-23','16:50:00',4.88),('9650','2013-04-23','16:55:00',5.95),('9650','2013-04-23','17:00:00',5.93),('9650','2013-04-23','17:05:00',5.73),('9650','2013-04-23','17:10:00',5.5),('9650','2013-04-23','17:15:00',4),('9650','2013-04-23','17:20:00',4.03),('9650','2013-04-23','17:25:00',3.57),('9650','2013-04-23','17:30:00',2.19),('9650','2013-04-23','17:35:00',1.74),('9650','2013-04-23','17:40:00',1.53),('9650','2013-04-23','17:45:00',2.1),('9650','2013-04-23','17:50:00',2.66),('9650','2013-04-23','17:55:00',3.72),('9650','2013-04-23','18:00:00',2.78),('9650','2013-04-23','18:05:00',3.02),('9650','2013-04-23','18:10:00',2.34),('9650','2013-04-23','18:15:00',1.55),('9650','2013-04-23','18:20:00',2.69),('9650','2013-04-23','18:25:00',2.52),('9650','2013-04-23','18:30:00',1.71),('9650','2013-04-23','18:35:00',1.22),('9650','2013-04-23','18:40:00',1.42),('9650','2013-04-23','18:45:00',1.13),('9650','2013-04-23','18:50:00',1.08),('9650','2013-04-22','08:25:00',1.02),('9650','2013-04-22','08:30:00',1.12),('9650','2013-04-22','08:35:00',1.22),('9650','2013-04-22','08:40:00',1.32),('9650','2013-04-22','08:45:00',1.42),('9650','2013-04-22','08:50:00',1.54),('9650','2013-04-22','08:55:00',1.67),('9650','2013-04-22','09:00:00',1.82),('9650','2013-04-22','09:05:00',1.95),('9650','2013-04-22','09:10:00',2.07),('9650','2013-04-22','09:15:00',2.24),('9650','2013-04-22','09:20:00',2.4),('9650','2013-04-22','09:25:00',2.57),('9650','2013-04-22','09:30:00',2.72),('9650','2013-04-22','09:35:00',2.87),('9650','2013-04-22','09:40:00',2.8),('9650','2013-04-22','09:45:00',2.81),('9650','2013-04-22','09:50:00',3.41),('9650','2013-04-22','09:55:00',3.51),('9650','2013-04-22','10:00:00',3.63),('9650','2013-04-22','10:05:00',3.73),('9650','2013-04-22','10:10:00',3.84),('9650','2013-04-22','10:15:00',3.95),('9650','2013-04-22','10:20:00',4.07),('9650','2013-04-22','10:25:00',4.21),('9650','2013-04-22','10:30:00',4.36),('9650','2013-04-22','10:35:00',4.47),('9650','2013-04-22','10:40:00',4.6),('9650','2013-04-22','10:45:00',4.63),('9650','2013-04-22','10:50:00',4.85),('9650','2013-04-22','10:55:00',4.98),('9650','2013-04-22','11:00:00',5.04),('9650','2013-04-22','11:05:00',5.13),('9650','2013-04-22','11:10:00',5.22),('9650','2013-04-22','11:15:00',5.33),('9650','2013-04-22','11:20:00',5.44),('9650','2013-04-22','11:25:00',5.53),('9650','2013-04-22','11:30:00',5.62),('9650','2013-04-22','11:35:00',5.72),('9650','2013-04-22','11:40:00',5.79),('9650','2013-04-22','11:45:00',5.87),('9650','2013-04-22','11:50:00',5.9),('9650','2013-04-22','11:55:00',5.96),('9650','2013-04-22','12:00:00',6.03),('9650','2013-04-22','12:05:00',6.07),('9650','2013-04-22','12:10:00',6.18),('9650','2013-04-22','12:15:00',6.19),('9650','2013-04-22','12:20:00',6.27),('9650','2013-04-22','12:25:00',6.35),('9650','2013-04-22','12:30:00',6.69),('9650','2013-04-22','12:35:00',7.19),('9650','2013-04-22','12:40:00',7.53),('9650','2013-04-22','12:45:00',6.22),('9650','2013-04-22','12:50:00',2.7),('9650','2013-04-22','12:55:00',7.87),('9650','2013-04-22','13:00:00',7.55),('9650','2013-04-22','13:05:00',6.24),('9650','2013-04-22','13:10:00',2.37),('9650','2013-04-22','13:15:00',5.18),('9650','2013-04-22','13:20:00',7.86),('9650','2013-04-22','13:25:00',7.4),('9650','2013-04-22','13:30:00',7.17),('9650','2013-04-22','13:35:00',7.49),('9650','2013-04-22','13:40:00',7.43),('9650','2013-04-22','13:45:00',5.14),('9650','2013-04-22','13:50:00',6.46),('9650','2013-04-22','13:55:00',7.28),('9650','2013-04-22','14:00:00',4.62),('9650','2013-04-22','14:05:00',7.86),('9650','2013-04-22','14:10:00',6.98),('9650','2013-04-22','14:15:00',6.8),('9650','2013-04-22','14:20:00',6.73),('9650','2013-04-22','14:25:00',6.23),('9650','2013-04-22','14:30:00',7.36),('9650','2013-04-22','14:35:00',7.19),('9650','2013-04-22','14:40:00',7.12),('9650','2013-04-22','14:45:00',6),('9650','2013-04-22','14:50:00',3.59),('9650','2013-04-22','14:55:00',3.91),('9650','2013-04-22','15:00:00',4.1),('9650','2013-04-22','15:05:00',4.43),('9650','2013-04-22','15:10:00',5.62),('9650','2013-04-22','15:15:00',5.52),('9650','2013-04-22','15:20:00',4.96),('9650','2013-04-22','15:25:00',4.57),('9650','2013-04-22','15:30:00',4.58),('9650','2013-04-22','15:35:00',4.26),('9650','2013-04-22','15:40:00',4.26),('9650','2013-04-22','15:45:00',4.51),('9650','2013-04-22','15:50:00',3.81),('9650','2013-04-22','15:55:00',3.08),('9650','2013-04-22','16:00:00',3.6),('9650','2013-04-22','16:05:00',4.22),('9650','2013-04-22','16:10:00',4.24),('9650','2013-04-22','16:15:00',4.08),('9650','2013-04-22','16:20:00',2.52),('9650','2013-04-22','16:25:00',2.61),('9650','2013-04-22','16:30:00',2.23),('9650','2013-04-22','16:35:00',2.07),('9650','2013-04-22','16:40:00',2.02),('9650','2013-04-22','16:45:00',2.29),('9650','2013-04-22','16:50:00',1.96),('9650','2013-04-22','16:55:00',2.03),('9650','2013-04-22','17:00:00',2.14),('9650','2013-04-22','17:05:00',2.22),('9650','2013-04-22','17:10:00',4.17),('9650','2013-04-22','17:15:00',2.6),('9650','2013-04-22','17:20:00',2.02),('9650','2013-04-22','17:25:00',3.83),('9650','2013-04-22','17:30:00',3.52),('9650','2013-04-22','17:35:00',2.54),('9650','2013-04-22','17:40:00',1.81),('9650','2013-04-22','17:45:00',1.94),('9650','2013-04-22','17:50:00',1.59),('9650','2013-04-22','17:55:00',1.31),('9650','2013-04-22','18:00:00',1.37),('9650','2013-04-22','18:05:00',1.44),('9650','2013-04-22','18:10:00',1.13),('9650','2013-04-22','18:15:00',1.19),('9650','2013-04-22','18:20:00',1.14),('9650','2013-04-22','18:25:00',1.47),('9650','2013-04-22','18:30:00',1.48),('9650','2013-04-22','18:35:00',1.13),('9650','2013-04-22','18:40:00',1.37),('9650','2013-04-22','18:50:00',1.03),('9650','2013-04-22','18:55:00',1.24),('9650','2013-04-22','19:00:00',1.1),('9650','2013-04-21','08:45:00',1.04),('9650','2013-04-21','09:00:00',1.28),('9650','2013-04-21','09:05:00',1.34),('9650','2013-04-21','09:10:00',1.44),('9650','2013-04-21','09:15:00',1.27),('9650','2013-04-21','09:20:00',1.22),('9650','2013-04-21','09:25:00',1.45),('9650','2013-04-21','09:30:00',2.11),('9650','2013-04-21','09:35:00',1.95),('9650','2013-04-21','09:40:00',1.56),('9650','2013-04-21','09:45:00',1.17),('9650','2013-04-21','10:35:00',2.48),('9650','2013-04-21','10:40:00',4.11),('9650','2013-04-21','10:45:00',6.21),('9650','2013-04-21','10:50:00',3.67),('9650','2013-04-21','10:55:00',3.97),('9650','2013-04-21','11:00:00',3.59),('9650','2013-04-21','11:05:00',3.04),('9650','2013-04-21','11:10:00',3.9),('9650','2013-04-21','11:15:00',2.37),('9650','2013-04-21','11:20:00',2.5),('9650','2013-04-21','11:25:00',3.23),('9650','2013-04-21','11:30:00',5.03),('9650','2013-04-21','11:35:00',5.89),('9650','2013-04-21','11:40:00',5.67),('9650','2013-04-21','11:45:00',3.43),('9650','2013-04-21','11:50:00',2.65),('9650','2013-04-21','11:55:00',5.48),('9650','2013-04-21','12:00:00',6.18),('9650','2013-04-21','12:05:00',5.83),('9650','2013-04-21','12:10:00',3.3),('9650','2013-04-21','12:15:00',4.39),('9650','2013-04-21','12:20:00',4.49),('9650','2013-04-21','12:25:00',3.38),('9650','2013-04-21','12:30:00',3.13),('9650','2013-04-21','12:35:00',3.3),('9650','2013-04-21','12:40:00',5.83),('9650','2013-04-21','12:45:00',5.61),('9650','2013-04-21','12:50:00',7.27),('9650','2013-04-21','12:55:00',7.35),('9650','2013-04-21','13:00:00',7.15),('9650','2013-04-21','13:05:00',5.77),('9650','2013-04-21','13:10:00',5.49),('9650','2013-04-21','13:15:00',6.22),('9650','2013-04-21','13:20:00',8.42),('9650','2013-04-21','13:25:00',5.76),('9650','2013-04-21','13:30:00',2.75),('9650','2013-04-21','13:35:00',3.96),('9650','2013-04-21','13:40:00',4.74),('9650','2013-04-21','13:45:00',2.92),('9650','2013-04-21','13:50:00',1.96),('9650','2013-04-21','13:55:00',4.39),('9650','2013-04-21','14:00:00',2.03),('9650','2013-04-21','14:05:00',4.01),('9650','2013-04-21','14:10:00',4.54),('9650','2013-04-21','14:15:00',7.39),('9650','2013-04-21','14:20:00',8.91),('9650','2013-04-21','14:25:00',5.12),('9650','2013-04-21','14:30:00',8.09),('9650','2013-04-21','14:35:00',4.2),('9650','2013-04-21','14:40:00',8.28),('9650','2013-04-21','14:45:00',7.14),('9650','2013-04-21','14:50:00',8.05),('9650','2013-04-21','14:55:00',6.75),('9650','2013-04-21','15:00:00',2.93),('9650','2013-04-21','15:05:00',3.22),('9650','2013-04-21','15:10:00',2.81),('9650','2013-04-21','15:15:00',2.11),('9650','2013-04-21','15:20:00',3.97),('9650','2013-04-21','15:25:00',7.79),('9650','2013-04-21','15:30:00',2.42),('9650','2013-04-21','15:35:00',2.77),('9650','2013-04-21','15:40:00',4.79),('9650','2013-04-21','15:45:00',7.36),('9650','2013-04-21','15:50:00',5.03),('9650','2013-04-21','15:55:00',2.59),('9650','2013-04-21','16:00:00',1.4),('9650','2013-04-21','16:05:00',1.44),('9650','2013-04-21','16:10:00',1.38),('9650','2013-04-21','16:15:00',1.26),('9650','2013-04-21','16:20:00',1.12),('9650','2013-04-21','16:35:00',1.04),('9650','2013-04-21','16:40:00',1.29),('9650','2013-04-21','16:45:00',2.03),('9650','2013-04-21','16:50:00',1.84),('9650','2013-04-21','16:55:00',1.19),('9650','2013-04-21','17:00:00',1.03),('9650','2013-04-21','17:05:00',1.02),('9650','2013-04-21','17:10:00',1.13),('9650','2013-04-21','17:25:00',1.17),('9650','2013-04-21','17:30:00',1.55),('9650','2013-04-21','17:35:00',1.64),('9650','2013-04-21','17:40:00',1.3),('9650','2013-04-21','18:05:00',1.29),('9650','2013-04-21','18:10:00',1.1),('9650','2013-04-21','18:15:00',1.05),('9650','2013-04-21','18:20:00',1.54),('9650','2013-04-21','18:25:00',1.71),('9650','2013-04-21','18:45:00',1.77),('9650','2013-04-21','18:50:00',2.57),('9650','2013-04-21','18:55:00',1.35),('9650','2013-04-21','19:00:00',2.12),('9650','2013-04-21','19:05:00',1.92),('9650','2013-04-21','19:10:00',1.62),('9650','2013-04-21','19:15:00',1.31),('9650','2013-04-21','19:20:00',1.05),('9650','2014-03-28','08:10:00',1.03),('9650','2014-03-28','08:15:00',1.13),('9650','2014-03-28','08:20:00',1.21),('9650','2014-03-28','08:25:00',1.33),('9650','2014-03-28','08:30:00',1.43),('9650','2014-03-28','08:35:00',1.55),('9650','2014-03-28','08:40:00',1.68),('9650','2014-03-28','08:45:00',1.8),('9650','2014-03-28','08:50:00',1.94),('9650','2014-03-28','08:55:00',2.07),('9650','2014-03-28','09:00:00',2.18),('9650','2014-03-28','09:05:00',2.32),('9650','2014-03-28','09:10:00',2.47),('9650','2014-03-28','09:15:00',2.62),('9650','2014-03-28','09:20:00',2.77),('9650','2014-03-28','09:25:00',2.89),('9650','2014-03-28','09:30:00',3.01),('9650','2014-03-28','09:35:00',3.12),('9650','2014-03-28','09:40:00',3.28),('9650','2014-03-28','09:45:00',3.38),('9650','2014-03-28','09:50:00',3.53),('9650','2014-03-28','09:55:00',3.67),('9650','2014-03-28','10:00:00',3.79),('9650','2014-03-28','10:05:00',3.88),('9650','2014-03-28','10:10:00',4.02),('9650','2014-03-28','10:15:00',4.16),('9650','2014-03-28','10:20:00',4.24),('9650','2014-03-28','10:25:00',4.35),('9650','2014-03-28','10:30:00',4.45),('9650','2014-03-28','10:35:00',4.51),('9650','2014-03-28','10:40:00',4.62),('9650','2014-03-28','10:45:00',4.68),('9650','2014-03-28','10:50:00',4.82),('9650','2014-03-28','10:55:00',4.95),('9650','2014-03-28','11:00:00',5.03),('9650','2014-03-28','11:05:00',5.1),('9650','2014-03-28','11:10:00',5.17),('9650','2014-03-28','11:15:00',5.26),('9650','2014-03-28','11:20:00',5.35),('9650','2014-03-28','11:25:00',5.42),('9650','2014-03-28','11:30:00',5.46),('9650','2014-03-28','11:35:00',5.52),('9650','2014-03-28','11:40:00',5.41),('9650','2014-03-28','11:45:00',5.74),('9650','2014-03-28','11:50:00',5.77),('9650','2014-03-28','11:55:00',5.81),('9650','2014-03-28','12:00:00',5.87),('9650','2014-03-28','12:05:00',5.96),('9650','2014-03-28','12:10:00',5.99),('9650','2014-03-28','12:15:00',6),('9650','2014-03-28','12:20:00',6.14),('9650','2014-03-28','12:25:00',6.2),('9650','2014-03-28','12:30:00',6.26),('9650','2014-03-28','12:35:00',6.23),('9650','2014-03-28','12:40:00',6.23),('9650','2014-03-28','12:45:00',6.32),('9650','2014-03-28','12:50:00',6.35),('9650','2014-03-28','12:55:00',6.33),('9650','2014-03-28','13:00:00',6.26),('9650','2014-03-28','13:05:00',6.4),('9650','2014-03-28','13:10:00',6.35),('9650','2014-03-28','13:15:00',6.36),('9650','2014-03-28','13:20:00',6.38),('9650','2014-03-28','13:25:00',6.31),('9650','2014-03-28','13:30:00',6.3),('9650','2014-03-28','13:35:00',6.22),('9650','2014-03-28','13:40:00',6.23),('9650','2014-03-28','13:45:00',6.17),('9650','2014-03-28','13:50:00',6.13),('9650','2014-03-28','13:55:00',6.16),('9650','2014-03-28','14:00:00',6.12),('9650','2014-03-28','14:05:00',6.03),('9650','2014-03-28','14:10:00',5.96),('9650','2014-03-28','14:15:00',5.8),('9650','2014-03-28','14:20:00',5.75),('9650','2014-03-28','14:25:00',5.2),('9650','2014-03-28','14:30:00',5.64),('9650','2014-03-28','14:35:00',5.4),('9650','2014-03-28','14:40:00',4.6),('9650','2014-03-28','14:45:00',5.33),('9650','2014-03-28','14:50:00',5.4),('9650','2014-03-28','14:55:00',5.35),('9650','2014-03-28','15:00:00',5.22),('9650','2014-03-28','15:05:00',5.03),('9650','2014-03-28','15:10:00',4.94),('9650','2014-03-28','15:15:00',4.93),('9650','2014-03-28','15:20:00',4.9),('9650','2014-03-28','15:25:00',4.71),('9650','2014-03-28','15:30:00',4.54),('9650','2014-03-28','15:35:00',4.39),('9650','2014-03-28','15:40:00',4.34),('9650','2014-03-28','15:45:00',4.29),('9650','2014-03-28','15:50:00',4.1),('9650','2014-03-28','15:55:00',4.09),('9650','2014-03-28','16:00:00',4.01),('9650','2014-03-28','16:05:00',3.9),('9650','2014-03-28','16:10:00',3.74),('9650','2014-03-28','16:15:00',3.62),('9650','2014-03-28','16:20:00',3.32),('9650','2014-03-28','16:25:00',3.39),('9650','2014-03-28','16:30:00',3.3),('9650','2014-03-28','16:35:00',3.07),('9650','2014-03-28','16:40:00',2.76),('9650','2014-03-28','16:45:00',2.24),('9650','2014-03-28','16:50:00',2.53),('9650','2014-03-28','16:55:00',2.65),('9650','2014-03-28','17:00:00',2.53),('9650','2014-03-28','17:05:00',2.36),('9650','2014-03-28','17:10:00',2.3),('9650','2014-03-28','17:15:00',2.14),('9650','2014-03-28','17:20:00',1.94),('9650','2014-03-28','17:25:00',1.74),('9650','2014-03-28','17:30:00',1.54),('9650','2014-03-28','17:35:00',1.3),('9650','2014-03-28','17:40:00',1.02),('9650','2013-04-20','07:55:00',1.07),('9650','2013-04-20','08:00:00',1.22),('9650','2013-04-20','08:05:00',1.4),('9650','2013-04-20','08:10:00',1.46),('9650','2013-04-20','08:15:00',1.51),('9650','2013-04-20','08:20:00',1.61),('9650','2013-04-20','08:25:00',1.92),('9650','2013-04-20','08:30:00',1.97),('9650','2013-04-20','08:35:00',2.06),('9650','2013-04-20','08:40:00',2.11),('9650','2013-04-20','08:45:00',1.91),('9650','2013-04-20','08:50:00',1.9),('9650','2013-04-20','08:55:00',2.33),('9650','2013-04-20','09:00:00',2.44),('9650','2013-04-20','09:05:00',2.7),('9650','2013-04-20','09:10:00',2.77),('9650','2013-04-20','09:15:00',2.49),('9650','2013-04-20','09:20:00',2.17),('9650','2013-04-20','09:25:00',2.68),('9650','2013-04-20','09:30:00',3.2),('9650','2013-04-20','09:35:00',3.34),('9650','2013-04-20','09:40:00',3.3),('9650','2013-04-20','09:45:00',3.9),('9650','2013-04-20','09:50:00',4.49),('9650','2013-04-20','09:55:00',5.28),('9650','2013-04-20','10:00:00',4.22),('9650','2013-04-20','10:05:00',2.87),('9650','2013-04-20','10:10:00',3.19),('9650','2013-04-20','10:15:00',2.55),('9650','2013-04-20','10:20:00',5.3),('9650','2013-04-20','10:25:00',3.85),('9650','2013-04-20','10:30:00',3.68),('9650','2013-04-20','10:35:00',2.67),('9650','2013-04-20','10:40:00',3.37),('9650','2013-04-20','10:45:00',3.55),('9650','2013-04-20','10:50:00',4.21),('9650','2013-04-20','10:55:00',3.39),('9650','2013-04-20','11:00:00',5.6),('9650','2013-04-20','11:05:00',4.77),('9650','2013-04-20','11:10:00',5.29),('9650','2013-04-20','11:15:00',4.21),('9650','2013-04-20','11:20:00',4.46),('9650','2013-04-20','11:25:00',4.47),('9650','2013-04-20','11:30:00',4.61),('9650','2013-04-20','11:35:00',4.48),('9650','2013-04-20','11:40:00',4.52),('9650','2013-04-20','11:45:00',5.11),('9650','2013-04-20','11:50:00',5.24),('9650','2013-04-20','11:55:00',5.09),('9650','2013-04-20','12:00:00',4.29),('9650','2013-04-20','12:05:00',4.4),('9650','2013-04-20','12:10:00',4.33),('9650','2013-04-20','12:15:00',4),('9650','2013-04-20','12:20:00',3.66),('9650','2013-04-20','12:25:00',3.61),('9650','2013-04-20','12:30:00',3.86),('9650','2013-04-20','12:35:00',3.99),('9650','2013-04-20','12:40:00',4.09),('9650','2013-04-20','12:45:00',4.04),('9650','2013-04-20','12:50:00',3.88),('9650','2013-04-20','12:55:00',3.73),('9650','2013-04-20','13:00:00',4.19),('9650','2013-04-20','13:05:00',4.77),('9650','2013-04-20','13:10:00',4.86),('9650','2013-04-20','13:15:00',4.4),('9650','2013-04-20','13:20:00',4.18),('9650','2013-04-20','13:25:00',4.13),('9650','2013-04-20','13:30:00',6.04),('9650','2013-04-20','13:35:00',6.23),('9650','2013-04-20','13:40:00',4.76),('9650','2013-04-20','13:45:00',5.42),('9650','2013-04-20','13:50:00',5.19),('9650','2013-04-20','13:55:00',7.31),('9650','2013-04-20','14:00:00',7.59),('9650','2013-04-20','14:05:00',8.01),('9650','2013-04-20','14:10:00',7.25),('9650','2013-04-20','14:15:00',7.62),('9650','2013-04-20','14:20:00',8.68),('9650','2013-04-20','14:25:00',7.85),('9650','2013-04-20','14:30:00',7.4),('9650','2013-04-20','14:35:00',8.41),('9650','2013-04-20','14:40:00',8.42),('9650','2013-04-20','14:45:00',6.59),('9650','2013-04-20','14:50:00',3.81),('9650','2013-04-20','14:55:00',3.77),('9650','2013-04-20','15:00:00',3.89),('9650','2013-04-20','15:05:00',7.08),('9650','2013-04-20','15:10:00',7.42),('9650','2013-04-20','15:15:00',5.51),('9650','2013-04-20','15:20:00',3.28),('9650','2013-04-20','15:25:00',3.57),('9650','2013-04-20','15:30:00',3.23),('9650','2013-04-20','15:35:00',2.8),('9650','2013-04-20','15:40:00',2.95),('9650','2013-04-20','15:45:00',2.42),('9650','2013-04-20','15:50:00',1.92),('9650','2013-04-20','15:55:00',1.65),('9650','2013-04-20','16:00:00',1.48),('9650','2013-04-20','16:05:00',1.33),('9650','2013-04-20','16:10:00',1.31),('9650','2013-04-20','16:15:00',1.27),('9650','2013-04-20','16:20:00',1.04),('9650','2013-04-20','16:40:00',1.03),('9650','2013-04-20','16:55:00',1.13),('9650','2013-04-20','17:00:00',1.45),('9650','2013-04-20','17:05:00',1.47),('9650','2013-04-20','17:10:00',1.36),('9650','2013-04-20','17:15:00',1.39),('9650','2013-04-20','17:20:00',1.19),('9650','2013-04-20','17:25:00',1.06),('9650','2013-04-19','08:00:00',1.03),('9650','2013-04-19','08:05:00',1.07),('9650','2013-04-19','08:10:00',1.06),('9650','2013-04-19','08:20:00',1.02),('9650','2013-04-19','08:25:00',1.12),('9650','2013-04-19','08:30:00',1.28),('9650','2013-04-19','08:35:00',1.45),('9650','2013-04-19','08:40:00',1.64),('9650','2013-04-19','08:45:00',1.75),('9650','2013-04-19','08:50:00',1.82),('9650','2013-04-19','08:55:00',1.87),('9650','2013-04-19','09:00:00',2.17),('9650','2013-04-19','09:05:00',2.33),('9650','2013-04-19','09:10:00',2.45),('9650','2013-04-19','09:15:00',2.65),('9650','2013-04-19','09:20:00',3.12),('9650','2013-04-19','09:25:00',2.94),('9650','2013-04-19','09:30:00',2.94),('9650','2013-04-19','09:35:00',2.38),('9650','2013-04-19','09:40:00',1.73),('9650','2013-04-19','09:45:00',1.82),('9650','2013-04-19','09:50:00',1.89),('9650','2013-04-19','09:55:00',1.23),('9650','2013-04-19','10:25:00',1.08),('9650','2013-04-19','10:30:00',1.15),('9650','2013-04-19','10:35:00',1.49),('9650','2013-04-19','10:40:00',2.29),('9650','2013-04-19','10:45:00',4.19),('9650','2013-04-19','10:50:00',3.32),('9650','2013-04-19','10:55:00',4.38),('9650','2013-04-19','11:00:00',5.2),('9650','2013-04-19','11:05:00',5.31),('9650','2013-04-19','11:10:00',5.93),('9650','2013-04-19','11:15:00',6.2),('9650','2013-04-19','11:20:00',3.66),('9650','2013-04-19','11:25:00',6.17),('9650','2013-04-19','11:30:00',6.56),('9650','2013-04-19','11:35:00',2.98),('9650','2013-04-19','11:40:00',2.37),('9650','2013-04-19','11:45:00',4.18),('9650','2013-04-19','11:50:00',7.09),('9650','2013-04-19','11:55:00',7.08),('9650','2013-04-19','12:00:00',7),('9650','2013-04-19','12:05:00',6.52),('9650','2013-04-19','12:10:00',6.81),('9650','2013-04-19','12:15:00',6.99),('9650','2013-04-19','12:20:00',6.81),('9650','2013-04-19','12:25:00',6.9),('9650','2013-04-19','12:30:00',5),('9650','2013-04-19','12:35:00',2.55),('9650','2013-04-19','12:40:00',5.48),('9650','2013-04-19','12:45:00',7.54),('9650','2013-04-19','12:50:00',3.37),('9650','2013-04-19','12:55:00',7.68),('9650','2013-04-19','13:00:00',3.31),('9650','2013-04-19','13:05:00',5.21),('9650','2013-04-19','13:10:00',4.67),('9650','2013-04-19','13:15:00',6.87),('9650','2013-04-19','13:20:00',7.54),('9650','2013-04-19','13:25:00',6.03),('9650','2013-04-19','13:30:00',3.52),('9650','2013-04-19','13:35:00',5.81),('9650','2013-04-19','13:40:00',6.12),('9650','2013-04-19','13:45:00',4.04),('9650','2013-04-19','13:50:00',3.07),('9650','2013-04-19','13:55:00',5.78),('9650','2013-04-19','14:00:00',4.97),('9650','2013-04-19','14:05:00',8.13),('9650','2013-04-19','14:10:00',7.67),('9650','2013-04-19','14:15:00',7.42),('9650','2013-04-19','14:20:00',7.08),('9650','2013-04-19','14:25:00',7.11),('9650','2013-04-19','14:30:00',6.94),('9650','2013-04-19','14:35:00',6.93),('9650','2013-04-19','14:40:00',6.96),('9650','2013-04-19','14:45:00',7.02),('9650','2013-04-19','14:50:00',6.98),('9650','2013-04-19','14:55:00',7.07),('9650','2013-04-19','15:00:00',7.06),('9650','2013-04-19','15:05:00',7.08),('9650','2013-04-19','15:10:00',4.06),('9650','2013-04-19','15:15:00',4.76),('9650','2013-04-19','15:20:00',5.4),('9650','2013-04-19','15:25:00',6.28),('9650','2013-04-19','15:30:00',3.14),('9650','2013-04-19','15:35:00',1.58),('9650','2013-04-19','15:40:00',1.5),('9650','2013-04-19','15:45:00',1.52),('9650','2013-04-19','15:50:00',1.44),('9650','2013-04-19','15:55:00',1.4),('9650','2013-04-19','16:00:00',1.65),('9650','2013-04-19','16:05:00',2.19),('9650','2013-04-19','16:10:00',3.34),('9650','2013-04-19','16:15:00',4.37),('9650','2013-04-19','16:20:00',4.26),('9650','2013-04-19','16:25:00',5.26),('9650','2013-04-19','16:30:00',5.92),('9650','2013-04-19','16:35:00',5.24),('9650','2013-04-19','16:40:00',6.26),('9650','2013-04-19','16:45:00',6.39),('9650','2013-04-19','16:50:00',5.85),('9650','2013-04-19','16:55:00',5.66),('9650','2013-04-19','17:00:00',5.49),('9650','2013-04-19','17:05:00',5.35),('9650','2013-04-19','17:10:00',5.26),('9650','2013-04-19','17:15:00',4.35),('9650','2013-04-19','17:20:00',4.99),('9650','2013-04-19','17:25:00',4.73),('9650','2013-04-19','17:30:00',5.07),('9650','2013-04-19','17:35:00',5.27),('9650','2013-04-19','17:40:00',4.89),('9650','2013-04-19','17:45:00',2.25),('9650','2013-04-19','17:50:00',2.49),('9650','2013-04-19','17:55:00',4.76),('9650','2013-04-19','18:00:00',3.2),('9650','2013-04-19','18:05:00',3.43),('9650','2013-04-19','18:10:00',4.11),('9650','2013-04-19','18:15:00',3.54),('9650','2013-04-19','18:20:00',2.61),('9650','2013-04-19','18:25:00',1.01),('9650','2013-04-19','18:35:00',1.14),('9650','2013-04-19','18:40:00',1.63),('9650','2013-04-18','08:25:00',1.11),('9650','2013-04-18','08:35:00',1.12),('9650','2013-04-18','08:40:00',1.21),('9650','2013-04-18','08:45:00',1.26),('9650','2013-04-18','08:50:00',1.3),('9650','2013-04-18','08:55:00',1.33),('9650','2013-04-18','09:00:00',1.34),('9650','2013-04-18','09:05:00',1.8),('9650','2013-04-18','09:10:00',1.93),('9650','2013-04-18','09:15:00',2.05),('9650','2013-04-18','09:20:00',2.22),('9650','2013-04-18','09:25:00',2.31),('9650','2013-04-18','09:30:00',2.47),('9650','2013-04-18','09:35:00',2.63),('9650','2013-04-18','09:40:00',2.69),('9650','2013-04-18','09:45:00',2.84),('9650','2013-04-18','09:50:00',2.91),('9650','2013-04-18','09:55:00',3.05),('9650','2013-04-18','10:00:00',3.16),('9650','2013-04-18','10:05:00',3.29),('9650','2013-04-18','10:10:00',3.4),('9650','2013-04-18','10:15:00',3.61),('9650','2013-04-18','10:20:00',3.65),('9650','2013-04-18','10:25:00',3.83),('9650','2013-04-18','10:30:00',3.85),('9650','2013-04-18','10:35:00',3.09),('9650','2013-04-18','10:40:00',4.19),('9650','2013-04-18','10:45:00',4.3),('9650','2013-04-18','10:50:00',4.35),('9650','2013-04-18','10:55:00',4.39),('9650','2013-04-18','11:00:00',4.5),('9650','2013-04-18','11:05:00',4.6),('9650','2013-04-18','11:10:00',4.68),('9650','2013-04-18','11:15:00',4.78),('9650','2013-04-18','11:20:00',4.9),('9650','2013-04-18','11:25:00',5),('9650','2013-04-18','11:30:00',5.03),('9650','2013-04-18','11:35:00',5.07),('9650','2013-04-18','11:40:00',5.26),('9650','2013-04-18','11:45:00',5.29),('9650','2013-04-18','11:50:00',5.38),('9650','2013-04-18','11:55:00',5.55),('9650','2013-04-18','12:00:00',5.62),('9650','2013-04-18','12:05:00',5.64),('9650','2013-04-18','12:10:00',5.67),('9650','2013-04-18','12:15:00',5.85),('9650','2013-04-18','12:20:00',5.75),('9650','2013-04-18','12:25:00',5.76),('9650','2013-04-18','12:30:00',6.05),('9650','2013-04-18','12:35:00',5.99),('9650','2013-04-18','12:40:00',6.12),('9650','2013-04-18','12:45:00',5.95),('9650','2013-04-18','12:50:00',6.06),('9650','2013-04-18','12:55:00',6.29),('9650','2013-04-18','13:00:00',6.26),('9650','2013-04-18','13:05:00',6.29),('9650','2013-04-18','13:10:00',6.37),('9650','2013-04-18','13:15:00',6.43),('9650','2013-04-18','13:20:00',6.37),('9650','2013-04-18','13:25:00',6.53),('9650','2013-04-18','13:30:00',6.57),('9650','2013-04-18','13:35:00',6.45),('9650','2013-04-18','13:40:00',6.62),('9650','2013-04-18','13:45:00',6.56),('9650','2013-04-18','13:50:00',6.46),('9650','2013-04-18','13:55:00',6.6),('9650','2013-04-18','14:00:00',6.57),('9650','2013-04-18','14:05:00',6.6),('9650','2013-04-18','14:10:00',6.61),('9650','2013-04-18','14:15:00',6.6),('9650','2013-04-18','14:20:00',6.6),('9650','2013-04-18','14:25:00',6.62),('9650','2013-04-18','14:30:00',6.59),('9650','2013-04-18','14:35:00',6.63),('9650','2013-04-18','14:40:00',6.57),('9650','2013-04-18','14:45:00',6.59),('9650','2013-04-18','14:50:00',6.59),('9650','2013-04-18','14:55:00',6.59),('9650','2013-04-18','15:00:00',6.54),('9650','2013-04-18','15:05:00',6.49),('9650','2013-04-18','15:10:00',6.45),('9650','2013-04-18','15:15:00',6.42),('9650','2013-04-18','15:20:00',6.32),('9650','2013-04-18','15:25:00',6.38),('9650','2013-04-18','15:30:00',6.29),('9650','2013-04-18','15:35:00',6.29),('9650','2013-04-18','15:40:00',6.23),('9650','2013-04-18','15:45:00',6.2),('9650','2013-04-18','15:50:00',6.08),('9650','2013-04-18','15:55:00',6.06),('9650','2013-04-18','16:00:00',5.97),('9650','2013-04-18','16:05:00',5.9),('9650','2013-04-18','16:10:00',5.81),('9650','2013-04-18','16:15:00',5.73),('9650','2013-04-18','16:20:00',5.66),('9650','2013-04-18','16:25:00',5.63),('9650','2013-04-18','16:30:00',5.51),('9650','2013-04-18','16:35:00',5.35),('9650','2013-04-18','16:40:00',5.24),('9650','2013-04-18','16:45:00',5.12),('9650','2013-04-18','16:50:00',4.97),('9650','2013-04-18','16:55:00',4.9),('9650','2013-04-18','17:00:00',4.77),('9650','2013-04-18','17:05:00',4.65),('9650','2013-04-18','17:10:00',4.49),('9650','2013-04-18','17:15:00',4.36),('9650','2013-04-18','17:20:00',4.26),('9650','2013-04-18','17:25:00',4.12),('9650','2013-04-18','17:30:00',4.02),('9650','2013-04-18','17:35:00',3.96),('9650','2013-04-18','17:40:00',3.82),('9650','2013-04-18','17:45:00',3.68),('9650','2013-04-18','17:50:00',3.38),('9650','2013-04-18','17:55:00',3.25),('9650','2013-04-18','18:00:00',3.12),('9650','2013-04-18','18:05:00',2.98),('9650','2013-04-18','18:10:00',2.79),('9650','2013-04-18','18:15:00',2.65),('9650','2013-04-18','18:20:00',2.52),('9650','2013-04-18','18:25:00',2.4),('9650','2013-04-18','18:30:00',2.26),('9650','2013-04-18','18:35:00',2.08),('9650','2013-04-18','18:40:00',1.92),('9650','2013-04-18','18:45:00',1.71),('9650','2013-04-18','18:50:00',1.48),('9650','2013-04-18','18:55:00',1.31),('9650','2013-04-18','19:00:00',1.16),('9650','2013-04-17','08:30:00',1.01),('9650','2013-04-17','08:35:00',1.08),('9650','2013-04-17','08:40:00',1.11),('9650','2013-04-17','08:45:00',1.16),('9650','2013-04-17','08:50:00',1.3),('9650','2013-04-17','08:55:00',1.47),('9650','2013-04-17','09:00:00',1.61),('9650','2013-04-17','09:05:00',1.75),('9650','2013-04-17','09:10:00',1.86),('9650','2013-04-17','09:15:00',1.93),('9650','2013-04-17','09:20:00',2.04),('9650','2013-04-17','09:25:00',2.06),('9650','2013-04-17','09:30:00',2.26),('9650','2013-04-17','09:35:00',2.49),('9650','2013-04-17','09:40:00',2.95),('9650','2013-04-17','09:45:00',2.87),('9650','2013-04-17','09:50:00',2.53),('9650','2013-04-17','09:55:00',2.46),('9650','2013-04-17','10:00:00',2.83),('9650','2013-04-17','10:05:00',3.19),('9650','2013-04-17','10:10:00',3.45),('9650','2013-04-17','10:15:00',3.76),('9650','2013-04-17','10:20:00',3.87),('9650','2013-04-17','10:25:00',3.9),('9650','2013-04-17','10:30:00',4.04),('9650','2013-04-17','10:35:00',4.1),('9650','2013-04-17','10:40:00',4.21),('9650','2013-04-17','10:45:00',4.38),('9650','2013-04-17','10:50:00',4.49),('9650','2013-04-17','10:55:00',4.58),('9650','2013-04-17','11:00:00',4.7),('9650','2013-04-17','11:05:00',4.81),('9650','2013-04-17','11:10:00',4.9),('9650','2013-04-17','11:15:00',5.01),('9650','2013-04-17','11:20:00',5.15),('9650','2013-04-17','11:25:00',5.19),('9650','2013-04-17','11:30:00',5.27),('9650','2013-04-17','11:35:00',5.36),('9650','2013-04-17','11:40:00',5.44),('9650','2013-04-17','11:45:00',5.4),('9650','2013-04-17','11:50:00',5.58),('9650','2013-04-17','11:55:00',5.67),('9650','2013-04-17','12:00:00',5.69),('9650','2013-04-17','12:05:00',5.85),('9650','2013-04-17','12:10:00',5.95),('9650','2013-04-17','12:15:00',5.98),('9650','2013-04-17','12:20:00',6.13),('9650','2013-04-17','12:25:00',6.15),('9650','2013-04-17','12:30:00',6.26),('9650','2013-04-17','12:35:00',6.3),('9650','2013-04-17','12:40:00',6.32),('9650','2013-04-17','12:45:00',6.44),('9650','2013-04-17','12:50:00',6.46),('9650','2013-04-17','12:55:00',6.53),('9650','2013-04-17','13:00:00',6.58),('9650','2013-04-17','13:05:00',6.63),('9650','2013-04-17','13:10:00',6.65),('9650','2013-04-17','13:15:00',6.71),('9650','2013-04-17','13:20:00',6.73),('9650','2013-04-17','13:25:00',6.79),('9650','2013-04-17','13:30:00',6.82),('9650','2013-04-17','13:35:00',6.88),('9650','2013-04-17','13:40:00',6.87),('9650','2013-04-17','13:45:00',6.91),('9650','2013-04-17','13:50:00',6.96),('9650','2013-04-17','13:55:00',6.97),('9650','2013-04-17','14:00:00',6.98),('9650','2013-04-17','14:05:00',7),('9650','2013-04-17','14:10:00',7),('9650','2013-04-17','14:15:00',7.03),('9650','2013-04-17','14:20:00',7.02),('9650','2013-04-17','14:25:00',7.02),('9650','2013-04-17','14:30:00',7.03),('9650','2013-04-17','14:35:00',7.02),('9650','2013-04-17','14:40:00',7),('9650','2013-04-17','14:45:00',6.98),('9650','2013-04-17','14:50:00',6.98),('9650','2013-04-17','14:55:00',6.95),('9650','2013-04-17','15:00:00',6.91),('9650','2013-04-17','15:05:00',6.9),('9650','2013-04-17','15:10:00',6.86),('9650','2013-04-17','15:15:00',6.84),('9650','2013-04-17','15:20:00',6.79),('9650','2013-04-17','15:25:00',6.73),('9650','2013-04-17','15:30:00',6.68),('9650','2013-04-17','15:35:00',6.65),('9650','2013-04-17','15:40:00',6.61),('9650','2013-04-17','15:45:00',6.54),('9650','2013-04-17','15:50:00',6.47),('9650','2013-04-17','15:55:00',6.34),('9650','2013-04-17','16:00:00',6.23),('9650','2013-04-17','16:05:00',6.2),('9650','2013-04-17','16:10:00',6.11),('9650','2013-04-17','16:15:00',6.01),('9650','2013-04-17','16:20:00',5.96),('9650','2013-04-17','16:25:00',5.83),('9650','2013-04-17','16:30:00',5.76),('9650','2013-04-17','16:35:00',5.62),('9650','2013-04-17','16:40:00',5.54),('9650','2013-04-17','16:45:00',5.45),('9650','2013-04-17','16:50:00',5.39),('9650','2013-04-17','16:55:00',5.24),('9650','2013-04-17','17:00:00',5.07),('9650','2013-04-17','17:05:00',4.86),('9650','2013-04-17','17:10:00',4.81),('9650','2013-04-17','17:15:00',4.75),('9650','2013-04-17','17:20:00',4.64),('9650','2013-04-17','17:25:00',4.51),('9650','2013-04-17','17:30:00',4.4),('9650','2013-04-17','17:35:00',4.34),('9650','2013-04-17','17:40:00',4.23),('9650','2013-04-17','17:45:00',4.1),('9650','2013-04-17','17:50:00',3.98),('9650','2013-04-17','17:55:00',3.79),('9650','2013-04-17','18:00:00',3.61),('9650','2013-04-17','18:05:00',3.43),('9650','2013-04-17','18:10:00',3.23),('9650','2013-04-17','18:15:00',3.05),('9650','2013-04-17','18:20:00',2.87),('9650','2013-04-17','18:25:00',2.64),('9650','2013-04-17','18:30:00',2.43),('9650','2013-04-17','18:35:00',2.25),('9650','2013-04-17','18:40:00',2.06),('9650','2013-04-17','18:45:00',1.78),('9650','2013-04-17','18:50:00',1.62),('9650','2013-04-17','18:55:00',1.51),('9650','2013-04-17','19:00:00',1.36),('9650','2013-04-17','19:05:00',1.14),('9650','2013-04-16','08:45:00',1.08),('9650','2013-04-16','08:50:00',1.2),('9650','2013-04-16','08:55:00',1.34),('9650','2013-04-16','09:00:00',1.47),('9650','2013-04-16','09:05:00',1.61),('9650','2013-04-16','09:10:00',1.75),('9650','2013-04-16','09:15:00',1.91),('9650','2013-04-16','09:20:00',2.05),('9650','2013-04-16','09:25:00',2.2),('9650','2013-04-16','09:30:00',2.36),('9650','2013-04-16','09:35:00',2.52),('9650','2013-04-16','09:40:00',2.68),('9650','2013-04-16','09:45:00',2.82),('9650','2013-04-16','09:50:00',2.96),('9650','2013-04-16','09:55:00',3.09),('9650','2013-04-16','10:00:00',3.22),('9650','2013-04-16','10:05:00',3.37),('9650','2013-04-16','10:10:00',3.49),('9650','2013-04-16','10:15:00',3.63),('9650','2013-04-16','10:20:00',3.77),('9650','2013-04-16','10:25:00',3.88),('9650','2013-04-16','10:30:00',4.01),('9650','2013-04-16','10:35:00',4.15),('9650','2013-04-16','10:40:00',4.29),('9650','2013-04-16','10:45:00',4.4),('9650','2013-04-16','10:50:00',4.49),('9650','2013-04-16','10:55:00',4.62),('9650','2013-04-16','11:00:00',4.75),('9650','2013-04-16','11:05:00',4.86),('9650','2013-04-16','11:10:00',4.99),('9650','2013-04-16','11:15:00',5.09),('9650','2013-04-16','11:20:00',5.18),('9650','2013-04-16','11:25:00',5.24),('9650','2013-04-16','11:30:00',5.32),('9650','2013-04-16','11:35:00',5.42),('9650','2013-04-16','11:40:00',5.5),('9650','2013-04-16','11:45:00',5.6),('9650','2013-04-16','11:50:00',5.69),('9650','2013-04-16','11:55:00',5.82),('9650','2013-04-16','12:00:00',5.88),('9650','2013-04-16','12:05:00',5.94),('9650','2013-04-16','12:10:00',5.99),('9650','2013-04-16','12:15:00',6.07),('9650','2013-04-16','12:20:00',6.14),('9650','2013-04-16','12:25:00',6.22),('9650','2013-04-16','12:30:00',6.3),('9650','2013-04-16','12:35:00',6.38),('9650','2013-04-16','12:40:00',6.45),('9650','2013-04-16','12:45:00',6.51),('9650','2013-04-16','12:50:00',6.55),('9650','2013-04-16','12:55:00',6.6),('9650','2013-04-16','13:00:00',6.62),('9650','2013-04-16','13:05:00',6.56),('9650','2013-04-16','13:10:00',6.58),('9650','2013-04-16','13:15:00',6.74),('9650','2013-04-16','13:20:00',6.82),('9650','2013-04-16','13:25:00',6.9),('9650','2013-04-16','13:30:00',6.88),('9650','2013-04-16','13:35:00',6.88),('9650','2013-04-16','13:40:00',6.97),('9650','2013-04-16','13:45:00',6.85),('9650','2013-04-16','13:50:00',6.72),('9650','2013-04-16','13:55:00',7.23),('9650','2013-04-16','14:00:00',6.88),('9650','2013-04-16','14:05:00',7.5),('9650','2013-04-16','14:10:00',7.55),('9650','2013-04-16','14:15:00',6.73),('9650','2013-04-16','14:20:00',6.7),('9650','2013-04-16','14:25:00',6.43),('9650','2013-04-16','14:30:00',6.93),('9650','2013-04-16','14:35:00',7.58),('9650','2013-04-16','14:40:00',6.8),('9650','2013-04-16','14:45:00',6.67),('9650','2013-04-16','14:50:00',7.53),('9650','2013-04-16','14:55:00',7.53),('9650','2013-04-16','15:00:00',7.53),('9650','2013-04-16','15:05:00',7.77),('9650','2013-04-16','15:10:00',8.04),('9650','2013-04-16','15:15:00',7.16),('9650','2013-04-16','15:20:00',4.34),('9650','2013-04-16','15:25:00',3.66),('9650','2013-04-16','15:30:00',6.38),('9650','2013-04-16','15:35:00',7.01),('9650','2013-04-16','15:40:00',7.12),('9650','2013-04-16','15:45:00',7.04),('9650','2013-04-16','15:50:00',7.03),('9650','2013-04-16','15:55:00',6.82),('9650','2013-04-16','16:00:00',6.52),('9650','2013-04-16','16:05:00',4.72),('9650','2013-04-16','16:10:00',6.4),('9650','2013-04-16','16:15:00',6.37),('9650','2013-04-16','16:20:00',6.21),('9650','2013-04-16','16:25:00',6.08),('9650','2013-04-16','16:30:00',5.97),('9650','2013-04-16','16:35:00',5.97),('9650','2013-04-16','16:40:00',5.25),('9650','2013-04-16','16:45:00',5.77),('9650','2013-04-16','16:50:00',5.53),('9650','2013-04-16','16:55:00',5.35),('9650','2013-04-16','17:00:00',5.21),('9650','2013-04-16','17:05:00',5.06),('9650','2013-04-16','17:10:00',4.91),('9650','2013-04-16','17:15:00',4.77),('9650','2013-04-16','17:20:00',4.67),('9650','2013-04-16','17:25:00',4.56),('9650','2013-04-16','17:30:00',4.45),('9650','2013-04-16','17:35:00',4.35),('9650','2013-04-16','17:40:00',4.3),('9650','2013-04-16','17:45:00',4.16),('9650','2013-04-16','17:50:00',3.97),('9650','2013-04-16','17:55:00',3.77),('9650','2013-04-16','18:00:00',3.62),('9650','2013-04-16','18:05:00',3.48),('9650','2013-04-16','18:10:00',3.32),('9650','2013-04-16','18:15:00',3.19),('9650','2013-04-16','18:20:00',3),('9650','2013-04-16','18:25:00',2.84),('9650','2013-04-16','18:30:00',2.6),('9650','2013-04-16','18:35:00',2.47),('9650','2013-04-16','18:40:00',2.28),('9650','2013-04-16','18:45:00',2.11),('9650','2013-04-16','18:50:00',1.91),('9650','2013-04-16','18:55:00',1.71),('9650','2013-04-16','19:00:00',1.49),('9650','2013-04-16','19:05:00',1.28),('9650','2013-04-16','19:10:00',1.05),('9650','2013-04-15','08:25:00',1.14),('9650','2013-04-15','08:30:00',1.19),('9650','2013-04-15','08:35:00',1.2),('9650','2013-04-15','08:40:00',1.23),('9650','2013-04-15','08:45:00',1.28),('9650','2013-04-15','08:50:00',1.56),('9650','2013-04-15','08:55:00',1.46),('9650','2013-04-15','09:00:00',1.21),('9650','2013-04-15','09:10:00',1.39),('9650','2013-04-15','09:15:00',1.93),('9650','2013-04-15','09:20:00',1.63),('9650','2013-04-15','09:25:00',1.89),('9650','2013-04-15','09:30:00',2.46),('9650','2013-04-15','09:35:00',2.36),('9650','2013-04-15','09:40:00',2.34),('9650','2013-04-15','09:45:00',2.49),('9650','2013-04-15','09:50:00',2.42),('9650','2013-04-15','09:55:00',2.38),('9650','2013-04-15','10:00:00',2.3),('9650','2013-04-15','10:05:00',2.32),('9650','2013-04-15','10:10:00',2.49),('9650','2013-04-15','10:15:00',2.63),('9650','2013-04-15','10:20:00',2.74),('9650','2013-04-15','10:25:00',2.8),('9650','2013-04-15','10:30:00',2.82),('9650','2013-04-15','10:35:00',2.87),('9650','2013-04-15','10:40:00',2.85),('9650','2013-04-15','10:45:00',2.76),('9650','2013-04-15','10:50:00',2.8),('9650','2013-04-15','10:55:00',2.98),('9650','2013-04-15','11:00:00',3.18),('9650','2013-04-15','11:05:00',3.28),('9650','2013-04-15','11:10:00',3.27),('9650','2013-04-15','11:15:00',3.34),('9650','2013-04-15','11:20:00',3.42),('9650','2013-04-15','11:25:00',3.38),('9650','2013-04-15','11:30:00',3.23),('9650','2013-04-15','11:35:00',3.12),('9650','2013-04-15','11:40:00',3.42),('9650','2013-04-15','11:45:00',3.88),('9650','2013-04-15','11:50:00',4.1),('9650','2013-04-15','11:55:00',4.18),('9650','2013-04-15','12:00:00',4.16),('9650','2013-04-15','12:05:00',4.58),('9650','2013-04-15','12:10:00',4.58),('9650','2013-04-15','12:15:00',4.69),('9650','2013-04-15','12:20:00',4.96),('9650','2013-04-15','12:25:00',4.74),('9650','2013-04-15','12:30:00',3.93),('9650','2013-04-15','12:35:00',5.97),('9650','2013-04-15','12:40:00',6.27),('9650','2013-04-15','12:45:00',5.42),('9650','2013-04-15','12:50:00',4.53),('9650','2013-04-15','12:55:00',6.1),('9650','2013-04-15','13:00:00',6.37),('9650','2013-04-15','13:05:00',6.44),('9650','2013-04-15','13:10:00',6.43),('9650','2013-04-15','13:15:00',6.52),('9650','2013-04-15','13:20:00',6.62),('9650','2013-04-15','13:25:00',6.69),('9650','2013-04-15','13:30:00',6.69),('9650','2013-04-15','13:35:00',6.66),('9650','2013-04-15','13:40:00',6.7),('9650','2013-04-15','13:45:00',6.52),('9650','2013-04-15','13:50:00',6.64),('9650','2013-04-15','13:55:00',6.49),('9650','2013-04-15','14:00:00',6.63),('9650','2013-04-15','14:05:00',6.76),('9650','2013-04-15','14:10:00',6.82),('9650','2013-04-15','14:15:00',6.92),('9650','2013-04-15','14:20:00',6.89),('9650','2013-04-15','14:25:00',6.18),('9650','2013-04-15','14:30:00',5.97),('9650','2013-04-15','14:35:00',5.17),('9650','2013-04-15','14:40:00',6.53),('9650','2013-04-15','14:45:00',6.75),('9650','2013-04-15','14:50:00',6.52),('9650','2013-04-15','14:55:00',6.55),('9650','2013-04-15','15:00:00',6.75),('9650','2013-04-15','15:05:00',6.77),('9650','2013-04-15','15:10:00',6.8),('9650','2013-04-15','15:15:00',6.68),('9650','2013-04-15','15:20:00',6.57),('9650','2013-04-15','15:25:00',6.15),('9650','2013-04-15','15:30:00',6.04),('9650','2013-04-15','15:35:00',6.37),('9650','2013-04-15','15:40:00',6.35),('9650','2013-04-15','15:45:00',6.3),('9650','2013-04-15','15:50:00',6.25),('9650','2013-04-15','15:55:00',6.22),('9650','2013-04-15','16:00:00',6.04),('9650','2013-04-15','16:05:00',6.04),('9650','2013-04-15','16:10:00',5.94),('9650','2013-04-15','16:15:00',5.69),('9650','2013-04-15','16:20:00',5.86),('9650','2013-04-15','16:25:00',5.74),('9650','2013-04-15','16:30:00',5.69),('9650','2013-04-15','16:35:00',5.63),('9650','2013-04-15','16:40:00',5.85),('9650','2013-04-15','16:45:00',5.97),('9650','2013-04-15','16:50:00',5.5),('9650','2013-04-15','16:55:00',4.72),('9650','2013-04-15','17:00:00',4.78),('9650','2013-04-15','17:05:00',4.98),('9650','2013-04-15','17:10:00',5.03),('9650','2013-04-15','17:15:00',5.01),('9650','2013-04-15','17:20:00',4.88),('9650','2013-04-15','17:25:00',4.87),('9650','2013-04-15','17:30:00',4.42),('9650','2013-04-15','17:35:00',4.66),('9650','2013-04-15','17:40:00',4.45),('9650','2013-04-15','17:45:00',4.2),('9650','2013-04-15','17:50:00',3.92),('9650','2013-04-15','17:55:00',3.54),('9650','2013-04-15','18:00:00',2.19),('9650','2013-04-15','18:05:00',2.7),('9650','2013-04-15','18:10:00',2.72),('9650','2013-04-15','18:15:00',2.67),('9650','2013-04-15','18:20:00',2.29),('9650','2013-04-15','18:25:00',2.15),('9650','2013-04-15','18:30:00',2.06),('9650','2013-04-15','18:35:00',1.94),('9650','2013-04-15','18:40:00',1.81),('9650','2013-04-15','18:45:00',1.68),('9650','2013-04-15','18:50:00',1.46),('9650','2013-04-15','18:55:00',1.32),('9650','2013-04-14','08:50:00',1.1),('9650','2013-04-14','08:55:00',1.22),('9650','2013-04-14','09:00:00',1.36),('9650','2013-04-14','09:05:00',1.49),('9650','2013-04-14','09:10:00',1.64),('9650','2013-04-14','09:15:00',1.8),('9650','2013-04-14','09:20:00',1.95),('9650','2013-04-14','09:25:00',2.1),('9650','2013-04-14','09:30:00',2.26),('9650','2013-04-14','09:35:00',2.42),('9650','2013-04-14','09:40:00',2.56),('9650','2013-04-14','09:45:00',2.7),('9650','2013-04-14','09:50:00',2.85),('9650','2013-04-14','09:55:00',3.01),('9650','2013-04-14','10:00:00',3.14),('9650','2013-04-14','10:05:00',3.27),('9650','2013-04-14','10:10:00',3.4),('9650','2013-04-14','10:15:00',3.53),('9650','2013-04-14','10:20:00',3.69),('9650','2013-04-14','10:25:00',3.78),('9650','2013-04-14','10:30:00',3.92),('9650','2013-04-14','10:35:00',4.06),('9650','2013-04-14','10:40:00',4.17),('9650','2013-04-14','10:45:00',4.31),('9650','2013-04-14','10:50:00',4.42),('9650','2013-04-14','10:55:00',4.55),('9650','2013-04-14','11:00:00',4.65),('9650','2013-04-14','11:05:00',4.77),('9650','2013-04-14','11:10:00',4.87),('9650','2013-04-14','11:15:00',4.98),('9650','2013-04-14','11:20:00',5.07),('9650','2013-04-14','11:25:00',5.18),('9650','2013-04-14','11:30:00',5.28),('9650','2013-04-14','11:35:00',5.37),('9650','2013-04-14','11:40:00',5.48),('9650','2013-04-14','11:45:00',5.59),('9650','2013-04-14','11:50:00',5.65),('9650','2013-04-14','11:55:00',5.73),('9650','2013-04-14','12:00:00',5.81),('9650','2013-04-14','12:05:00',5.91),('9650','2013-04-14','12:10:00',5.98),('9650','2013-04-14','12:15:00',5.99),('9650','2013-04-14','12:20:00',6.05),('9650','2013-04-14','12:25:00',6.11),('9650','2013-04-14','12:30:00',6.14),('9650','2013-04-14','12:35:00',6.19),('9650','2013-04-14','12:40:00',6.28),('9650','2013-04-14','12:45:00',6.31),('9650','2013-04-14','12:50:00',6.32),('9650','2013-04-14','12:55:00',6.35),('9650','2013-04-14','13:00:00',6.43),('9650','2013-04-14','13:05:00',6.49),('9650','2013-04-14','13:10:00',6.55),('9650','2013-04-14','13:15:00',6.58),('9650','2013-04-14','13:20:00',6.62),('9650','2013-04-14','13:25:00',6.69),('9650','2013-04-14','13:30:00',6.72),('9650','2013-04-14','13:35:00',6.72),('9650','2013-04-14','13:40:00',6.69),('9650','2013-04-14','13:45:00',6.71),('9650','2013-04-14','13:50:00',6.81),('9650','2013-04-14','13:55:00',6.87),('9650','2013-04-14','14:00:00',6.91),('9650','2013-04-14','14:05:00',6.95),('9650','2013-04-14','14:10:00',6.99),('9650','2013-04-14','14:15:00',6.97),('9650','2013-04-14','14:20:00',6.99),('9650','2013-04-14','14:25:00',6.99),('9650','2013-04-14','14:30:00',6.97),('9650','2013-04-14','14:35:00',6.98),('9650','2013-04-14','14:40:00',7.01),('9650','2013-04-14','14:45:00',6.99),('9650','2013-04-14','14:50:00',6.99),('9650','2013-04-14','14:55:00',6.98),('9650','2013-04-14','15:00:00',6.92),('9650','2013-04-14','15:05:00',6.91),('9650','2013-04-14','15:10:00',6.89),('9650','2013-04-14','15:15:00',6.87),('9650','2013-04-14','15:20:00',6.81),('9650','2013-04-14','15:25:00',6.77),('9650','2013-04-14','15:30:00',6.73),('9650','2013-04-14','15:35:00',6.67),('9650','2013-04-14','15:40:00',6.61),('9650','2013-04-14','15:45:00',6.51),('9650','2013-04-14','15:50:00',6.42),('9650','2013-04-14','15:55:00',6.38),('9650','2013-04-14','16:00:00',6.32),('9650','2013-04-14','16:05:00',6.21),('9650','2013-04-14','16:10:00',6.13),('9650','2013-04-14','16:15:00',6.05),('9650','2013-04-14','16:20:00',5.96),('9650','2013-04-14','16:25:00',5.84),('9650','2013-04-14','16:30:00',5.55),('9650','2013-04-14','16:35:00',5.67),('9650','2013-04-14','16:40:00',5.63),('9650','2013-04-14','16:45:00',5.57),('9650','2013-04-14','16:50:00',5.41),('9650','2013-04-14','16:55:00',5.23),('9650','2013-04-14','17:00:00',5.13),('9650','2013-04-14','17:05:00',4.98),('9650','2013-04-14','17:10:00',4.85),('9650','2013-04-14','17:15:00',4.74),('9650','2013-04-14','17:20:00',4.61),('9650','2013-04-14','17:25:00',4.57),('9650','2013-04-14','17:30:00',4.46),('9650','2013-04-14','17:35:00',4.25),('9650','2013-04-14','17:40:00',4.16),('9650','2013-04-14','17:45:00',4.07),('9650','2013-04-14','17:50:00',3.92),('9650','2013-04-14','17:55:00',3.79),('9650','2013-04-14','18:00:00',3.65),('9650','2013-04-14','18:05:00',3.47),('9650','2013-04-14','18:10:00',3.34),('9650','2013-04-14','18:15:00',3.17),('9650','2013-04-14','18:20:00',3),('9650','2013-04-14','18:25:00',2.82),('9650','2013-04-14','18:30:00',2.67),('9650','2013-04-14','18:35:00',2.49),('9650','2013-04-14','18:40:00',2.32),('9650','2013-04-14','18:45:00',2.12),('9650','2013-04-14','18:50:00',1.91),('9650','2013-04-14','18:55:00',1.71),('9650','2013-04-14','19:00:00',1.49),('9650','2013-04-14','19:05:00',1.27),('9650','2013-04-14','19:10:00',1.02),('9650','2013-04-13','08:45:00',1.08),('9650','2013-04-13','08:50:00',1.2),('9650','2013-04-13','08:55:00',1.33),('9650','2013-04-13','09:00:00',1.42),('9650','2013-04-13','09:05:00',1.54),('9650','2013-04-13','09:10:00',1.7),('9650','2013-04-13','09:15:00',1.84),('9650','2013-04-13','09:20:00',2.01),('9650','2013-04-13','09:25:00',2.09),('9650','2013-04-13','09:30:00',2.23),('9650','2013-04-13','09:35:00',2.39),('9650','2013-04-13','09:40:00',2.55),('9650','2013-04-13','09:45:00',2.71),('9650','2013-04-13','09:50:00',2.84),('9650','2013-04-13','09:55:00',2.97),('9650','2013-04-13','10:00:00',3.12),('9650','2013-04-13','10:05:00',3.24),('9650','2013-04-13','10:10:00',3.36),('9650','2013-04-13','10:15:00',3.5),('9650','2013-04-13','10:20:00',3.63),('9650','2013-04-13','10:25:00',3.73),('9650','2013-04-13','10:30:00',3.84),('9650','2013-04-13','10:35:00',3.97),('9650','2013-04-13','10:40:00',4.08),('9650','2013-04-13','10:45:00',4.22),('9650','2013-04-13','10:50:00',4.29),('9650','2013-04-13','10:55:00',4.45),('9650','2013-04-13','11:00:00',4.54),('9650','2013-04-13','11:05:00',4.67),('9650','2013-04-13','11:10:00',4.78),('9650','2013-04-13','11:15:00',4.91),('9650','2013-04-13','11:20:00',5.01),('9650','2013-04-13','11:25:00',5.1),('9650','2013-04-13','11:30:00',5.17),('9650','2013-04-13','11:35:00',5.23),('9650','2013-04-13','11:40:00',5.37),('9650','2013-04-13','11:45:00',5.47),('9650','2013-04-13','11:50:00',5.53),('9650','2013-04-13','11:55:00',5.6),('9650','2013-04-13','12:00:00',5.7),('9650','2013-04-13','12:05:00',5.75),('9650','2013-04-13','12:10:00',5.82),('9650','2013-04-13','12:15:00',5.93),('9650','2013-04-13','12:20:00',6.01),('9650','2013-04-13','12:25:00',6.05),('9650','2013-04-13','12:30:00',6.04),('9650','2013-04-13','12:35:00',6.1),('9650','2013-04-13','12:40:00',5.41),('9650','2013-04-13','12:45:00',6.12),('9650','2013-04-13','12:50:00',6.44),('9650','2013-04-13','12:55:00',6.55),('9650','2013-04-13','13:00:00',5.62),('9650','2013-04-13','13:05:00',6.47),('9650','2013-04-13','13:10:00',6.66),('9650','2013-04-13','13:15:00',5.19),('9650','2013-04-13','13:20:00',6.81),('9650','2013-04-13','13:25:00',6.74),('9650','2013-04-13','13:30:00',6.83),('9650','2013-04-13','13:35:00',6.78),('9650','2013-04-13','13:40:00',6.78),('9650','2013-04-13','13:45:00',6.78),('9650','2013-04-13','13:50:00',6.72),('9650','2013-04-13','13:55:00',6.71),('9650','2013-04-13','14:00:00',6.71),('9650','2013-04-13','14:05:00',6.81),('9650','2013-04-13','14:10:00',6.8),('9650','2013-04-13','14:15:00',6.82),('9650','2013-04-13','14:20:00',6.8),('9650','2013-04-13','14:25:00',6.83),('9650','2013-04-13','14:30:00',6.88),('9650','2013-04-13','14:35:00',7.03),('9650','2013-04-13','14:40:00',7.08),('9650','2013-04-13','14:45:00',7.33),('9650','2013-04-13','14:50:00',7.46),('9650','2013-04-13','14:55:00',7.2),('9650','2013-04-13','15:00:00',7.04),('9650','2013-04-13','15:05:00',7.01),('9650','2013-04-13','15:10:00',7.01),('9650','2013-04-13','15:15:00',5.79),('9650','2013-04-13','15:20:00',6.71),('9650','2013-04-13','15:25:00',6.38),('9650','2013-04-13','15:30:00',5.03),('9650','2013-04-13','15:35:00',6.74),('9650','2013-04-13','15:40:00',6.77),('9650','2013-04-13','15:45:00',6.72),('9650','2013-04-13','15:50:00',6.5),('9650','2013-04-13','15:55:00',6.18),('9650','2013-04-13','16:00:00',5.2),('9650','2013-04-13','16:05:00',5.92),('9650','2013-04-13','16:10:00',5.85),('9650','2013-04-13','16:15:00',5.76),('9650','2013-04-13','16:20:00',5.64),('9650','2013-04-13','16:25:00',5.69),('9650','2013-04-13','16:30:00',5.61),('9650','2013-04-13','16:35:00',5.47),('9650','2013-04-13','16:40:00',5.39),('9650','2013-04-13','16:45:00',5.24),('9650','2013-04-13','16:50:00',5.16),('9650','2013-04-13','16:55:00',4.99),('9650','2013-04-13','17:00:00',4.8),('9650','2013-04-13','17:05:00',4.72),('9650','2013-04-13','17:10:00',4.62),('9650','2013-04-13','17:15:00',4.49),('9650','2013-04-13','17:20:00',4.34),('9650','2013-04-13','17:25:00',4.16),('9650','2013-04-13','17:30:00',4.2),('9650','2013-04-13','17:35:00',4.11),('9650','2013-04-13','17:40:00',3.95),('9650','2013-04-13','17:45:00',3.84),('9650','2013-04-13','17:50:00',3.69),('9650','2013-04-13','17:55:00',3.55),('9650','2013-04-13','18:00:00',3.4),('9650','2013-04-13','18:05:00',3.27),('9650','2013-04-13','18:10:00',3.1),('9650','2013-04-13','18:15:00',2.97),('9650','2013-04-13','18:20:00',2.83),('9650','2013-04-13','18:25:00',2.65),('9650','2013-04-13','18:30:00',2.48),('9650','2013-04-13','18:35:00',2.27),('9650','2013-04-13','18:40:00',2.11),('9650','2013-04-13','18:45:00',1.88),('9650','2013-04-13','18:50:00',1.7),('9650','2013-04-13','18:55:00',1.5),('9650','2013-04-13','19:00:00',1.28),('9650','2013-04-13','19:05:00',1.08),('9650','2013-04-12','08:20:00',1.09),('9650','2013-04-12','08:40:00',1.03),('9650','2013-04-12','08:45:00',1.12),('9650','2013-04-12','08:50:00',1.73),('9650','2013-04-12','08:55:00',1.9),('9650','2013-04-12','09:00:00',1.55),('9650','2013-04-12','09:05:00',1.9),('9650','2013-04-12','09:10:00',1.77),('9650','2013-04-12','09:15:00',1.34),('9650','2013-04-12','09:20:00',1.38),('9650','2013-04-12','09:25:00',1.5),('9650','2013-04-12','09:30:00',2.11),('9650','2013-04-12','09:35:00',2.18),('9650','2013-04-12','09:40:00',2.08),('9650','2013-04-12','09:45:00',2.49),('9650','2013-04-12','09:50:00',2.61),('9650','2013-04-12','09:55:00',2.79),('9650','2013-04-12','10:00:00',2.95),('9650','2013-04-12','10:05:00',3.19),('9650','2013-04-12','10:10:00',3.46),('9650','2013-04-12','10:15:00',2.99),('9650','2013-04-12','10:20:00',2.67),('9650','2013-04-12','10:25:00',3.91),('9650','2013-04-12','10:30:00',3.81),('9650','2013-04-12','10:35:00',3.14),('9650','2013-04-12','10:40:00',4.35),('9650','2013-04-12','10:45:00',3.2),('9650','2013-04-12','10:50:00',3.67),('9650','2013-04-12','10:55:00',3.93),('9650','2013-04-12','11:00:00',2.08),('9650','2013-04-12','11:05:00',4.82),('9650','2013-04-12','11:10:00',5.12),('9650','2013-04-12','11:15:00',5.6),('9650','2013-04-12','11:20:00',4.56),('9650','2013-04-12','11:30:00',1.53),('9650','2013-04-12','11:35:00',5.6),('9650','2013-04-12','11:40:00',5.58),('9650','2013-04-12','11:45:00',5.33),('9650','2013-04-12','11:50:00',3.19),('9650','2013-04-12','11:55:00',5.84),('9650','2013-04-12','12:00:00',6.14),('9650','2013-04-12','12:05:00',5.96),('9650','2013-04-12','12:10:00',6.09),('9650','2013-04-12','12:15:00',5.76),('9650','2013-04-12','12:20:00',5.94),('9650','2013-04-12','12:25:00',6.29),('9650','2013-04-12','12:30:00',6.27),('9650','2013-04-12','12:35:00',6.19),('9650','2013-04-12','12:40:00',6.16),('9650','2013-04-12','12:45:00',6.24),('9650','2013-04-12','12:50:00',6.05),('9650','2013-04-12','12:55:00',6.07),('9650','2013-04-12','13:00:00',6.17),('9650','2013-04-12','13:05:00',6.37),('9650','2013-04-12','13:10:00',6.68),('9650','2013-04-12','13:15:00',6.51),('9650','2013-04-12','13:20:00',6.55),('9650','2013-04-12','13:25:00',6.58),('9650','2013-04-12','13:30:00',5.89),('9650','2013-04-12','13:35:00',3.8),('9650','2013-04-12','13:40:00',5.33),('9650','2013-04-12','13:45:00',5.51),('9650','2013-04-12','13:50:00',3.13),('9650','2013-04-12','13:55:00',3.02),('9650','2013-04-12','14:00:00',3.42),('9650','2013-04-12','14:05:00',4),('9650','2013-04-12','14:10:00',3.47),('9650','2013-04-12','14:15:00',4.95),('9650','2013-04-12','14:20:00',6.02),('9650','2013-04-12','14:25:00',6.14),('9650','2013-04-12','14:30:00',6.19),('9650','2013-04-12','14:35:00',6.35),('9650','2013-04-12','14:40:00',6.17),('9650','2013-04-12','14:45:00',6.4),('9650','2013-04-12','14:50:00',6.14),('9650','2013-04-12','14:55:00',6.33),('9650','2013-04-12','15:00:00',5.77),('9650','2013-04-12','15:05:00',4.58),('9650','2013-04-12','15:10:00',5.57),('9650','2013-04-12','15:15:00',5.18),('9650','2013-04-12','15:20:00',5.06),('9650','2013-04-12','15:25:00',4.74),('9650','2013-04-12','15:30:00',4.87),('9650','2013-04-12','15:35:00',4.77),('9650','2013-04-12','15:40:00',5.04),('9650','2013-04-12','15:45:00',5.14),('9650','2013-04-12','15:50:00',4.98),('9650','2013-04-12','15:55:00',4.92),('9650','2013-04-12','16:00:00',4.74),('9650','2013-04-12','16:05:00',4.57),('9650','2013-04-12','16:10:00',4.38),('9650','2013-04-12','16:15:00',4.58),('9650','2013-04-12','16:20:00',4.37),('9650','2013-04-12','16:25:00',4.19),('9650','2013-04-12','16:30:00',4.18),('9650','2013-04-12','16:35:00',3.86),('9650','2013-04-12','16:40:00',3.57),('9650','2013-04-12','16:45:00',3.35),('9650','2013-04-12','16:50:00',3.42),('9650','2013-04-12','16:55:00',2.78),('9650','2013-04-12','17:00:00',2.23),('9650','2013-04-12','17:05:00',2.14),('9650','2013-04-12','17:10:00',3.25),('9650','2013-04-12','17:15:00',3.93),('9650','2013-04-12','17:20:00',3.53),('9650','2013-04-12','17:25:00',4.22),('9650','2013-04-12','17:30:00',3.75),('9650','2013-04-12','17:35:00',3.79),('9650','2013-04-12','17:40:00',3.78),('9650','2013-04-12','17:45:00',3.58),('9650','2013-04-12','17:50:00',3.25),('9650','2013-04-12','17:55:00',3.58),('9650','2013-04-12','18:00:00',2.82),('9650','2013-04-12','18:05:00',2.94),('9650','2013-04-12','18:10:00',2.67),('9650','2013-04-12','18:15:00',2.81),('9650','2013-04-12','18:20:00',2.88),('9650','2013-04-12','18:25:00',2.74),('9650','2013-04-12','18:30:00',2.62),('9650','2013-04-12','18:35:00',2.33),('9650','2013-04-12','18:40:00',2.07),('9650','2013-04-12','18:45:00',1.83),('9650','2013-04-12','18:50:00',1.55),('9650','2013-04-12','18:55:00',1.33),('9650','2013-04-12','19:00:00',1.11),('9650','2013-04-11','08:10:00',1.27),('9650','2013-04-11','08:15:00',1.28),('9650','2013-04-11','08:20:00',1.29),('9650','2013-04-11','08:25:00',1.14),('9650','2013-04-11','08:30:00',1.27),('9650','2013-04-11','08:35:00',1.31),('9650','2013-04-11','08:40:00',1.2),('9650','2013-04-11','08:45:00',1.39),('9650','2013-04-11','08:50:00',1.82),('9650','2013-04-11','08:55:00',1.97),('9650','2013-04-11','09:00:00',2.12),('9650','2013-04-11','09:05:00',1.75),('9650','2013-04-11','09:10:00',1.67),('9650','2013-04-11','09:15:00',2.44),('9650','2013-04-11','09:20:00',2.89),('9650','2013-04-11','09:25:00',2.38),('9650','2013-04-11','09:30:00',1.95),('9650','2013-04-11','09:35:00',2.06),('9650','2013-04-11','09:40:00',2.03),('9650','2013-04-11','09:45:00',2.15),('9650','2013-04-11','09:50:00',1.55),('9650','2013-04-11','09:55:00',1.59),('9650','2013-04-11','10:00:00',1.52),('9650','2013-04-11','10:05:00',1.75),('9650','2013-04-11','10:10:00',1.55),('9650','2013-04-11','10:15:00',1.62),('9650','2013-04-11','10:20:00',3.7),('9650','2013-04-11','10:25:00',3.15),('9650','2013-04-11','10:30:00',2.33),('9650','2013-04-11','10:35:00',4.05),('9650','2013-04-11','10:40:00',5.47),('9650','2013-04-11','10:45:00',5.81),('9650','2013-04-11','10:50:00',4.97),('9650','2013-04-11','10:55:00',2.9),('9650','2013-04-11','11:00:00',2.09),('9650','2013-04-11','11:05:00',3.02),('9650','2013-04-11','11:10:00',2.4),('9650','2013-04-11','11:15:00',5.42),('9650','2013-04-11','11:20:00',6.15),('9650','2013-04-11','11:25:00',6.02),('9650','2013-04-11','11:30:00',6.42),('9650','2013-04-11','11:35:00',4.39),('9650','2013-04-11','11:40:00',2.61),('9650','2013-04-11','11:45:00',2.77),('9650','2013-04-11','11:50:00',2.69),('9650','2013-04-11','11:55:00',5.72),('9650','2013-04-11','12:00:00',6.08),('9650','2013-04-11','12:05:00',5.96),('9650','2013-04-11','12:10:00',5.67),('9650','2013-04-11','12:15:00',5.94),('9650','2013-04-11','12:20:00',6.08),('9650','2013-04-11','12:25:00',5.92),('9650','2013-04-11','12:30:00',5.95),('9650','2013-04-11','12:35:00',6.04),('9650','2013-04-11','12:40:00',5.84),('9650','2013-04-11','12:45:00',6.09),('9650','2013-04-11','12:50:00',4.55),('9650','2013-04-11','12:55:00',5.87),('9650','2013-04-11','13:00:00',6.28),('9650','2013-04-11','13:05:00',6.32),('9650','2013-04-11','13:10:00',6.4),('9650','2013-04-11','13:15:00',6.46),('9650','2013-04-11','13:20:00',6.49),('9650','2013-04-11','13:25:00',6.53),('9650','2013-04-11','13:30:00',6.54),('9650','2013-04-11','13:35:00',6.65),('9650','2013-04-11','13:40:00',6.53),('9650','2013-04-11','13:45:00',6.6),('9650','2013-04-11','13:50:00',6.61),('9650','2013-04-11','13:55:00',6.66),('9650','2013-04-11','14:00:00',6.74),('9650','2013-04-11','14:05:00',6.72),('9650','2013-04-11','14:10:00',6.72),('9650','2013-04-11','14:15:00',6.67),('9650','2013-04-11','14:20:00',6.69),('9650','2013-04-11','14:25:00',6.71),('9650','2013-04-11','14:30:00',6.72),('9650','2013-04-11','14:35:00',6.66),('9650','2013-04-11','14:40:00',6.63),('9650','2013-04-11','14:45:00',6.62),('9650','2013-04-11','14:50:00',6.6),('9650','2013-04-11','14:55:00',6.58),('9650','2013-04-11','15:00:00',6.55),('9650','2013-04-11','15:05:00',6.47),('9650','2013-04-11','15:10:00',6.4),('9650','2013-04-11','15:15:00',6.39),('9650','2013-04-11','15:20:00',6.37),('9650','2013-04-11','15:25:00',6.29),('9650','2013-04-11','15:30:00',6.29),('9650','2013-04-11','15:35:00',6.24),('9650','2013-04-11','15:40:00',6.17),('9650','2013-04-11','15:45:00',6.08),('9650','2013-04-11','15:50:00',6.04),('9650','2013-04-11','15:55:00',5.96),('9650','2013-04-11','16:00:00',5.86),('9650','2013-04-11','16:05:00',5.8),('9650','2013-04-11','16:10:00',5.84),('9650','2013-04-11','16:15:00',5.27),('9650','2013-04-11','16:20:00',5.52),('9650','2013-04-11','16:25:00',5.62),('9650','2013-04-11','16:30:00',3.36),('9650','2013-04-11','16:35:00',2.5),('9650','2013-04-11','16:40:00',3.41),('9650','2013-04-11','16:45:00',5.24),('9650','2013-04-11','16:50:00',4.96),('9650','2013-04-11','16:55:00',4.86),('9650','2013-04-11','17:00:00',4.7),('9650','2013-04-11','17:05:00',4.62),('9650','2013-04-11','17:10:00',4.42),('9650','2013-04-11','17:15:00',4.37),('9650','2013-04-11','17:20:00',4.26),('9650','2013-04-11','17:25:00',4.19),('9650','2013-04-11','17:30:00',4.14),('9650','2013-04-11','17:35:00',4.01),('9650','2013-04-11','17:40:00',3.81),('9650','2013-04-11','17:45:00',3.6),('9650','2013-04-11','17:50:00',3.57),('9650','2013-04-11','17:55:00',3.45),('9650','2013-04-11','18:00:00',3.28),('9650','2013-04-11','18:05:00',3.13),('9650','2013-04-11','18:10:00',2.88),('9650','2013-04-11','18:15:00',2.6),('9650','2013-04-11','18:20:00',2.48),('9650','2013-04-11','18:25:00',2.04),('9650','2013-04-11','18:30:00',1.91),('9650','2013-04-11','18:35:00',1.89),('9650','2013-04-11','18:45:00',1.22),('9650','2013-04-11','18:50:00',1.22),('9650','2014-03-27','08:20:00',1.07),('9650','2014-03-27','08:25:00',1.18),('9650','2014-03-27','08:30:00',1.29),('9650','2014-03-27','08:35:00',1.44),('9650','2014-03-27','08:40:00',1.59),('9650','2014-03-27','08:45:00',1.74),('9650','2014-03-27','08:50:00',1.92),('9650','2014-03-27','08:55:00',2.11),('9650','2014-03-27','09:00:00',2.3),('9650','2014-03-27','09:05:00',2.56),('9650','2014-03-27','09:10:00',2.87),('9650','2014-03-27','09:15:00',3.01),('9650','2014-03-27','09:20:00',2.92),('9650','2014-03-27','09:25:00',3.6),('9650','2014-03-27','09:30:00',3.81),('9650','2014-03-27','09:35:00',3.49),('9650','2014-03-27','09:40:00',2.2),('9650','2014-03-27','09:45:00',2.02),('9650','2014-03-27','09:50:00',2.66),('9650','2014-03-27','09:55:00',3.91),('9650','2014-03-27','10:00:00',4),('9650','2014-03-27','10:05:00',4.1),('9650','2014-03-27','10:10:00',3.83),('9650','2014-03-27','10:15:00',2.9),('9650','2014-03-27','10:20:00',2.91),('9650','2014-03-27','10:25:00',4.19),('9650','2014-03-27','10:30:00',4.53),('9650','2014-03-27','10:35:00',4.48),('9650','2014-03-27','10:40:00',4.27),('9650','2014-03-27','10:45:00',3.35),('9650','2014-03-27','10:50:00',5.06),('9650','2014-03-27','10:55:00',5.11),('9650','2014-03-27','11:00:00',5.18),('9650','2014-03-27','11:05:00',5.03),('9650','2014-03-27','11:10:00',4.11),('9650','2014-03-27','11:15:00',3.56),('9650','2014-03-27','11:20:00',2.63),('9650','2014-03-27','11:25:00',3.26),('9650','2014-03-27','11:30:00',3.5),('9650','2014-03-27','11:35:00',2.54),('9650','2014-03-27','11:40:00',2.37),('9650','2014-03-27','11:45:00',4.97),('9650','2014-03-27','11:50:00',3.29),('9650','2014-03-27','11:55:00',2.62),('9650','2014-03-27','12:00:00',2.99),('9650','2014-03-27','12:05:00',6.65),('9650','2014-03-27','12:10:00',6.77),('9650','2014-03-27','12:15:00',7.23),('9650','2014-03-27','12:20:00',7.14),('9650','2014-03-27','12:25:00',1.93),('9650','2014-03-27','12:30:00',1.5),('9650','2014-03-27','12:35:00',5.01),('9650','2014-03-27','12:40:00',6.59),('9650','2014-03-27','12:45:00',6.74),('9650','2014-03-27','12:50:00',7.02),('9650','2014-03-27','12:55:00',7.49),('9650','2014-03-27','13:00:00',8.01),('9650','2014-03-27','13:05:00',4),('9650','2014-03-27','13:10:00',2.87),('9650','2014-03-27','13:15:00',2.84),('9650','2014-03-27','13:20:00',5.84),('9650','2014-03-27','13:25:00',3.06),('9650','2014-03-27','13:30:00',2.4),('9650','2014-03-27','13:35:00',6.65),('9650','2014-03-27','13:40:00',7.24),('9650','2014-03-27','13:45:00',6.82),('9650','2014-03-27','13:50:00',6.57),('9650','2014-03-27','13:55:00',6.35),('9650','2014-03-27','14:00:00',6.5),('9650','2014-03-27','14:05:00',6.29),('9650','2014-03-27','14:10:00',6.11),('9650','2014-03-27','14:15:00',6.05),('9650','2014-03-27','14:20:00',6.03),('9650','2014-03-27','14:25:00',6.02),('9650','2014-03-27','14:30:00',6.01),('9650','2014-03-27','14:35:00',6),('9650','2014-03-27','14:40:00',5.98),('9650','2014-03-27','14:45:00',5.88),('9650','2014-03-27','14:50:00',5.63),('9650','2014-03-27','14:55:00',5.58),('9650','2014-03-27','15:00:00',5.58),('9650','2014-03-27','15:05:00',5.45),('9650','2014-03-27','15:10:00',5.36),('9650','2014-03-27','15:15:00',5.3),('9650','2014-03-27','15:20:00',5.22),('9650','2014-03-27','15:25:00',5.1),('9650','2014-03-27','15:30:00',4.99),('9650','2014-03-27','15:35:00',4.93),('9650','2014-03-27','15:40:00',4.85),('9650','2014-03-27','15:45:00',4.82),('9650','2014-03-27','15:50:00',4.81),('9650','2014-03-27','15:55:00',4.24),('9650','2014-03-27','16:00:00',5.02),('9650','2014-03-27','16:05:00',5.11),('9650','2014-03-27','16:10:00',4.98),('9650','2014-03-27','16:15:00',4.81),('9650','2014-03-27','16:20:00',4.21),('9650','2014-03-27','16:25:00',3.87),('9650','2014-03-27','16:30:00',3.85),('9650','2014-03-27','16:35:00',2.38),('9650','2014-03-27','16:40:00',2.39),('9650','2014-03-27','16:45:00',2.67),('9650','2014-03-27','16:50:00',3.02),('9650','2014-03-27','16:55:00',1.52),('9650','2014-03-27','17:00:00',2.32),('9650','2014-03-27','17:05:00',2.51),('9650','2014-03-27','17:10:00',2.72),('9650','2014-03-27','17:15:00',2.78),('9650','2014-03-27','17:20:00',2.83),('9650','2014-03-27','17:25:00',1.4),('9650','2014-03-27','17:35:00',1.46),('9650','2014-03-27','17:40:00',1.37),('9650','2014-03-27','17:45:00',1.61),('9650','2014-03-27','17:50:00',1.35),('9650','2013-04-10','08:50:00',1.03),('9650','2013-04-10','08:55:00',1.15),('9650','2013-04-10','09:00:00',1.23),('9650','2013-04-10','09:05:00',1.31),('9650','2013-04-10','09:10:00',1.47),('9650','2013-04-10','09:15:00',1.62),('9650','2013-04-10','09:20:00',1.75),('9650','2013-04-10','09:25:00',1.85),('9650','2013-04-10','09:30:00',2.02),('9650','2013-04-10','09:35:00',2.17),('9650','2013-04-10','09:40:00',1.96),('9650','2013-04-10','09:45:00',2.64),('9650','2013-04-10','09:50:00',2.03),('9650','2013-04-10','09:55:00',1.52),('9650','2013-04-10','10:00:00',1.67),('9650','2013-04-10','10:05:00',2.31),('9650','2013-04-10','10:10:00',1.8),('9650','2013-04-10','10:15:00',3.31),('9650','2013-04-10','10:20:00',3.5),('9650','2013-04-10','10:25:00',3.92),('9650','2013-04-10','10:30:00',4.18),('9650','2013-04-10','10:35:00',4.58),('9650','2013-04-10','10:40:00',4.76),('9650','2013-04-10','10:45:00',4.13),('9650','2013-04-10','10:50:00',1.49),('9650','2013-04-10','11:00:00',1.2),('9650','2013-04-10','11:05:00',4.83),('9650','2013-04-10','11:10:00',4.86),('9650','2013-04-10','11:15:00',5.09),('9650','2013-04-10','11:20:00',3),('9650','2013-04-10','11:25:00',3),('9650','2013-04-10','11:30:00',6.2),('9650','2013-04-10','11:35:00',4.95),('9650','2013-04-10','11:40:00',2),('9650','2013-04-10','11:45:00',1.83),('9650','2013-04-10','11:50:00',3.69),('9650','2013-04-10','11:55:00',6.69),('9650','2013-04-10','12:00:00',6.84),('9650','2013-04-10','12:05:00',6.43),('9650','2013-04-10','12:10:00',6.59),('9650','2013-04-10','12:15:00',6.43),('9650','2013-04-10','12:20:00',4.31),('9650','2013-04-10','12:25:00',6.31),('9650','2013-04-10','12:30:00',5.65),('9650','2013-04-10','12:35:00',6.22),('9650','2013-04-10','12:40:00',5.35),('9650','2013-04-10','12:45:00',3.31),('9650','2013-04-10','12:50:00',6.62),('9650','2013-04-10','12:55:00',6.69),('9650','2013-04-10','13:00:00',6.98),('9650','2013-04-10','13:05:00',6.94),('9650','2013-04-10','13:10:00',6.51),('9650','2013-04-10','13:15:00',6.16),('9650','2013-04-10','13:20:00',5.67),('9650','2013-04-10','13:25:00',6.65),('9650','2013-04-10','13:30:00',6.6),('9650','2013-04-10','13:35:00',6.73),('9650','2013-04-10','13:40:00',6.67),('9650','2013-04-10','13:45:00',6.58),('9650','2013-04-10','13:50:00',6.62),('9650','2013-04-10','13:55:00',6.67),('9650','2013-04-10','14:00:00',6.76),('9650','2013-04-10','14:05:00',6.77),('9650','2013-04-10','14:10:00',6.89),('9650','2013-04-10','14:15:00',6.84),('9650','2013-04-10','14:20:00',6.83),('9650','2013-04-10','14:25:00',6.74),('9650','2013-04-10','14:30:00',6.71),('9650','2013-04-10','14:35:00',6.8),('9650','2013-04-10','14:40:00',6.89),('9650','2013-04-10','14:45:00',6.75),('9650','2013-04-10','14:50:00',6.64),('9650','2013-04-10','14:55:00',6.67),('9650','2013-04-10','15:00:00',6.53),('9650','2013-04-10','15:05:00',6.43),('9650','2013-04-10','15:10:00',6.47),('9650','2013-04-10','15:15:00',6.37),('9650','2013-04-10','15:20:00',6.4),('9650','2013-04-10','15:25:00',6.37),('9650','2013-04-10','15:30:00',6.33),('9650','2013-04-10','15:35:00',6.23),('9650','2013-04-10','15:40:00',6.14),('9650','2013-04-10','15:45:00',6.07),('9650','2013-04-10','15:50:00',6.03),('9650','2013-04-10','15:55:00',5.95),('9650','2013-04-10','16:00:00',5.91),('9650','2013-04-10','16:05:00',5.81),('9650','2013-04-10','16:10:00',5.73),('9650','2013-04-10','16:15:00',5.68),('9650','2013-04-10','16:20:00',5.64),('9650','2013-04-10','16:25:00',5.56),('9650','2013-04-10','16:30:00',5.49),('9650','2013-04-10','16:35:00',5.38),('9650','2013-04-10','16:40:00',5.24),('9650','2013-04-10','16:45:00',5.14),('9650','2013-04-10','16:50:00',5.04),('9650','2013-04-10','16:55:00',4.93),('9650','2013-04-10','17:00:00',4.77),('9650','2013-04-10','17:05:00',4.64),('9650','2013-04-10','17:10:00',4.52),('9650','2013-04-10','17:15:00',4.4),('9650','2013-04-10','17:20:00',4.3),('9650','2013-04-10','17:25:00',4.21),('9650','2013-04-10','17:30:00',4.14),('9650','2013-04-10','17:35:00',4.07),('9650','2013-04-10','17:40:00',3.87),('9650','2013-04-10','17:45:00',3.81),('9650','2013-04-10','17:50:00',3.77),('9650','2013-04-10','17:55:00',3.52),('9650','2013-04-10','18:00:00',3.33),('9650','2013-04-10','18:05:00',3.03),('9650','2013-04-10','18:10:00',2.72),('9650','2013-04-10','18:15:00',2.89),('9650','2013-04-10','18:20:00',2.88),('9650','2013-04-10','18:25:00',2.77),('9650','2013-04-10','18:30:00',2.46),('9650','2013-04-10','18:35:00',2.35),('9650','2013-04-10','18:40:00',2.04),('9650','2013-04-10','18:45:00',1.71),('9650','2013-04-09','08:55:00',1.2),('9650','2013-04-09','09:00:00',1.33),('9650','2013-04-09','09:05:00',1.55),('9650','2013-04-09','09:10:00',1.7),('9650','2013-04-09','09:15:00',1.78),('9650','2013-04-09','09:20:00',1.78),('9650','2013-04-09','09:25:00',1.82),('9650','2013-04-09','09:30:00',2.04),('9650','2013-04-09','09:35:00',2.13),('9650','2013-04-09','09:40:00',2.3),('9650','2013-04-09','09:45:00',2.4),('9650','2013-04-09','09:50:00',2.58),('9650','2013-04-09','09:55:00',2.76),('9650','2013-04-09','10:00:00',2.85),('9650','2013-04-09','10:05:00',3.03),('9650','2013-04-09','10:10:00',3.25),('9650','2013-04-09','10:15:00',3.42),('9650','2013-04-09','10:20:00',3.54),('9650','2013-04-09','10:25:00',3.66),('9650','2013-04-09','10:30:00',3.76),('9650','2013-04-09','10:35:00',3.87),('9650','2013-04-09','10:40:00',3.98),('9650','2013-04-09','10:45:00',4.22),('9650','2013-04-09','10:50:00',4.08),('9650','2013-04-09','10:55:00',4.03),('9650','2013-04-09','11:00:00',4.21),('9650','2013-04-09','11:05:00',4.22),('9650','2013-04-09','11:10:00',4.41),('9650','2013-04-09','11:15:00',4.39),('9650','2013-04-09','11:20:00',4.62),('9650','2013-04-09','11:25:00',4.86),('9650','2013-04-09','11:30:00',4.94),('9650','2013-04-09','11:35:00',5.11),('9650','2013-04-09','11:40:00',5.22),('9650','2013-04-09','11:45:00',5.11),('9650','2013-04-09','11:50:00',5.43),('9650','2013-04-09','11:55:00',5.53),('9650','2013-04-09','12:00:00',5.69),('9650','2013-04-09','12:05:00',5.89),('9650','2013-04-09','12:10:00',6),('9650','2013-04-09','12:15:00',6.12),('9650','2013-04-09','12:20:00',6.22),('9650','2013-04-09','12:25:00',6.35),('9650','2013-04-09','12:30:00',6.45),('9650','2013-04-09','12:35:00',5.92),('9650','2013-04-09','12:40:00',6.32),('9650','2013-04-09','12:45:00',6.36),('9650','2013-04-09','12:50:00',6.58),('9650','2013-04-09','12:55:00',6.62),('9650','2013-04-09','13:00:00',5.38),('9650','2013-04-09','13:05:00',5.36),('9650','2013-04-09','13:10:00',3.49),('9650','2013-04-09','13:15:00',5.27),('9650','2013-04-09','13:20:00',7.5),('9650','2013-04-09','13:25:00',5.2),('9650','2013-04-09','13:30:00',6.84),('9650','2013-04-09','13:35:00',6.66),('9650','2013-04-09','13:40:00',5.21),('9650','2013-04-09','13:45:00',3.13),('9650','2013-04-09','13:50:00',7.44),('9650','2013-04-09','13:55:00',4.61),('9650','2013-04-09','14:00:00',7.24),('9650','2013-04-09','14:05:00',7),('9650','2013-04-09','14:10:00',7.02),('9650','2013-04-09','14:15:00',6.91),('9650','2013-04-09','14:20:00',6.91),('9650','2013-04-09','14:25:00',6.98),('9650','2013-04-09','14:30:00',7),('9650','2013-04-09','14:35:00',6.7),('9650','2013-04-09','14:40:00',6.95),('9650','2013-04-09','14:45:00',7.11),('9650','2013-04-09','14:50:00',7.11),('9650','2013-04-09','14:55:00',6.94),('9650','2013-04-09','15:00:00',7.03),('9650','2013-04-09','15:05:00',6.81),('9650','2013-04-09','15:10:00',5.05),('9650','2013-04-09','15:15:00',6.73),('9650','2013-04-09','15:20:00',7),('9650','2013-04-09','15:25:00',6.51),('9650','2013-04-09','15:30:00',6.35),('9650','2013-04-09','15:35:00',5.9),('9650','2013-04-09','15:40:00',6.1),('9650','2013-04-09','15:45:00',6.25),('9650','2013-04-09','15:50:00',6.33),('9650','2013-04-09','15:55:00',5.98),('9650','2013-04-09','16:00:00',4.88),('9650','2013-04-09','16:05:00',5.75),('9650','2013-04-09','16:10:00',5.9),('9650','2013-04-09','16:15:00',5.84),('9650','2013-04-09','16:20:00',4.82),('9650','2013-04-09','16:25:00',5.47),('9650','2013-04-09','16:30:00',5.12),('9650','2013-04-09','16:35:00',3.62),('9650','2013-04-09','16:40:00',4.82),('9650','2013-04-09','16:45:00',5.31),('9650','2013-04-09','16:50:00',3.74),('9650','2013-04-09','16:55:00',4.64),('9650','2013-04-09','17:00:00',4.99),('9650','2013-04-09','17:05:00',3.49),('9650','2013-04-09','17:10:00',3.68),('9650','2013-04-09','17:15:00',4.25),('9650','2013-04-09','17:20:00',4.46),('9650','2013-04-09','17:25:00',3.84),('9650','2013-04-09','17:30:00',4.11),('9650','2013-04-09','17:35:00',3.39),('9650','2013-04-09','17:40:00',3.02),('9650','2013-04-09','17:45:00',3.88),('9650','2013-04-09','17:50:00',2.69),('9650','2013-04-09','17:55:00',3.53),('9650','2013-04-09','18:00:00',2.62),('9650','2013-04-09','18:05:00',2.62),('9650','2013-04-09','18:10:00',2.41),('9650','2013-04-09','18:15:00',2),('9650','2013-04-09','18:20:00',1.14),('9650','2013-04-08','08:20:00',1.1),('9650','2013-04-08','08:25:00',1.12),('9650','2013-04-08','08:30:00',1.12),('9650','2013-04-08','08:35:00',1.02),('9650','2013-04-08','09:00:00',1.04),('9650','2013-04-08','09:05:00',1.45),('9650','2013-04-08','09:10:00',1.62),('9650','2013-04-08','09:15:00',1.7),('9650','2013-04-08','09:20:00',1.52),('9650','2013-04-08','09:25:00',1.67),('9650','2013-04-08','09:30:00',1.58),('9650','2013-04-08','09:35:00',1.09),('9650','2013-04-08','09:40:00',1.24),('9650','2013-04-08','09:45:00',1.88),('9650','2013-04-08','09:50:00',2.75),('9650','2013-04-08','09:55:00',3.74),('9650','2013-04-08','10:00:00',2.37),('9650','2013-04-08','10:05:00',1.71),('9650','2013-04-08','10:10:00',2.63),('9650','2013-04-08','10:15:00',3.16),('9650','2013-04-08','10:20:00',2.23),('9650','2013-04-08','10:25:00',1.06),('9650','2013-04-08','10:30:00',1.51),('9650','2013-04-08','10:35:00',3.37),('9650','2013-04-08','10:40:00',3.68),('9650','2013-04-08','10:45:00',5.38),('9650','2013-04-08','10:50:00',4.67),('9650','2013-04-08','10:55:00',4.56),('9650','2013-04-08','11:00:00',4.65),('9650','2013-04-08','11:05:00',4.54),('9650','2013-04-08','11:10:00',4.99),('9650','2013-04-08','11:15:00',1.48),('9650','2013-04-08','11:20:00',1.89),('9650','2013-04-08','11:25:00',3.96),('9650','2013-04-08','11:30:00',5.89),('9650','2013-04-08','11:35:00',3.37),('9650','2013-04-08','11:40:00',2.25),('9650','2013-04-08','11:45:00',4.36),('9650','2013-04-08','11:50:00',6.32),('9650','2013-04-08','11:55:00',4.51),('9650','2013-04-08','12:00:00',6.45),('9650','2013-04-08','12:05:00',6.37),('9650','2013-04-08','12:10:00',6.47),('9650','2013-04-08','12:15:00',6.52),('9650','2013-04-08','12:20:00',5.56),('9650','2013-04-08','12:25:00',6.2),('9650','2013-04-08','12:30:00',6.41),('9650','2013-04-08','12:35:00',6.42),('9650','2013-04-08','12:40:00',6.4),('9650','2013-04-08','12:45:00',6.6),('9650','2013-04-08','12:50:00',6.94),('9650','2013-04-08','12:55:00',6.35),('9650','2013-04-08','13:00:00',6.77),('9650','2013-04-08','13:05:00',7.03),('9650','2013-04-08','13:10:00',7.6),('9650','2013-04-08','13:15:00',6.4),('9650','2013-04-08','13:20:00',4.15),('9650','2013-04-08','13:25:00',6.61),('9650','2013-04-08','13:30:00',2.91),('9650','2013-04-08','13:35:00',2.84),('9650','2013-04-08','13:40:00',3.56),('9650','2013-04-08','13:45:00',3.3),('9650','2013-04-08','13:50:00',7.15),('9650','2013-04-08','13:55:00',7.06),('9650','2013-04-08','14:00:00',6.59),('9650','2013-04-08','14:05:00',5.56),('9650','2013-04-08','14:10:00',4.94),('9650','2013-04-08','14:15:00',6.4),('9650','2013-04-08','14:20:00',3.71),('9650','2013-04-08','14:25:00',4.74),('9650','2013-04-08','14:30:00',4.94),('9650','2013-04-08','14:35:00',6.44),('9650','2013-04-08','14:40:00',6.43),('9650','2013-04-08','14:45:00',6.24),('9650','2013-04-08','14:50:00',5.51),('9650','2013-04-08','14:55:00',4.49),('9650','2013-04-08','15:00:00',6.74),('9650','2013-04-08','15:05:00',6.4),('9650','2013-04-08','15:10:00',6.46),('9650','2013-04-08','15:15:00',4.91),('9650','2013-04-08','15:20:00',6.91),('9650','2013-04-08','15:25:00',6.89),('9650','2013-04-08','15:30:00',3.65),('9650','2013-04-08','15:35:00',6.93),('9650','2013-04-08','15:40:00',6.6),('9650','2013-04-08','15:45:00',5.77),('9650','2013-04-08','15:50:00',6.56),('9650','2013-04-08','15:55:00',5.29),('9650','2013-04-08','16:00:00',4.83),('9650','2013-04-08','16:05:00',4.93),('9650','2013-04-08','16:10:00',3.88),('9650','2013-04-08','16:15:00',3.83),('9650','2013-04-08','16:20:00',1.24),('9650','2013-04-08','16:25:00',2.27),('9650','2013-04-08','16:30:00',1.94),('9650','2013-04-08','16:35:00',2.27),('9650','2013-04-08','16:40:00',2.24),('9650','2013-04-08','16:45:00',1.82),('9650','2013-04-08','16:50:00',5.56),('9650','2013-04-08','16:55:00',4.55),('9650','2013-04-08','17:00:00',1.48),('9650','2013-04-08','17:05:00',1.28),('9650','2013-04-08','17:10:00',1.17),('9650','2013-04-08','17:15:00',2.24),('9650','2013-04-08','17:20:00',2.57),('9650','2013-04-08','17:25:00',1.9),('9650','2013-04-08','17:30:00',2.66),('9650','2013-04-08','17:35:00',2.06),('9650','2013-04-08','17:40:00',2.14),('9650','2013-04-08','17:45:00',1.48),('9650','2013-04-08','17:50:00',1.18),('9650','2013-04-08','17:55:00',1.08),('9650','2013-04-08','18:00:00',1.2),('9650','2013-04-08','18:05:00',1.23),('9650','2013-04-08','18:10:00',1.22),('9650','2013-04-08','18:15:00',2.07),('9650','2013-04-08','18:20:00',2.27),('9650','2013-04-07','08:20:00',1.1),('9650','2013-04-07','08:25:00',1.08),('9650','2013-04-07','08:30:00',1.15),('9650','2013-04-07','08:35:00',1.06),('9650','2013-04-07','08:40:00',1.12),('9650','2013-04-07','08:45:00',1.11),('9650','2013-04-07','08:50:00',1.3),('9650','2013-04-07','08:55:00',1.21),('9650','2013-04-07','09:00:00',1.49),('9650','2013-04-07','09:05:00',1.32),('9650','2013-04-07','09:10:00',1.38),('9650','2013-04-07','09:15:00',1.71),('9650','2013-04-07','09:20:00',2.07),('9650','2013-04-07','09:25:00',2.11),('9650','2013-04-07','09:30:00',2.14),('9650','2013-04-07','09:35:00',2.4),('9650','2013-04-07','09:40:00',2.58),('9650','2013-04-07','09:45:00',2.75),('9650','2013-04-07','09:50:00',1.75),('9650','2013-04-07','09:55:00',1.8),('9650','2013-04-07','10:00:00',2.79),('9650','2013-04-07','10:05:00',3.1),('9650','2013-04-07','10:10:00',3.11),('9650','2013-04-07','10:15:00',3.22),('9650','2013-04-07','10:20:00',3.29),('9650','2013-04-07','10:25:00',3.39),('9650','2013-04-07','10:30:00',3.55),('9650','2013-04-07','10:35:00',3.45),('9650','2013-04-07','10:40:00',3.93),('9650','2013-04-07','10:45:00',4.28),('9650','2013-04-07','10:50:00',4.41),('9650','2013-04-07','10:55:00',4.4),('9650','2013-04-07','11:00:00',4.77),('9650','2013-04-07','11:05:00',4.31),('9650','2013-04-07','11:10:00',4.24),('9650','2013-04-07','11:15:00',4),('9650','2013-04-07','11:20:00',3.56),('9650','2013-04-07','11:25:00',3.2),('9650','2013-04-07','11:30:00',3.62),('9650','2013-04-07','11:35:00',4.53),('9650','2013-04-07','11:40:00',4.8),('9650','2013-04-07','11:45:00',4.36),('9650','2013-04-07','11:50:00',4.09),('9650','2013-04-07','11:55:00',3.8),('9650','2013-04-07','12:00:00',3.65),('9650','2013-04-07','12:05:00',3.55),('9650','2013-04-07','12:10:00',3.79),('9650','2013-04-07','12:15:00',4.31),('9650','2013-04-07','12:20:00',4.33),('9650','2013-04-07','12:25:00',4.25),('9650','2013-04-07','12:30:00',4.76),('9650','2013-04-07','12:35:00',4.26),('9650','2013-04-07','12:40:00',4.12),('9650','2013-04-07','12:45:00',5.75),('9650','2013-04-07','12:50:00',4.3),('9650','2013-04-07','12:55:00',3.22),('9650','2013-04-07','13:00:00',2.99),('9650','2013-04-07','13:05:00',4.12),('9650','2013-04-07','13:10:00',4.5),('9650','2013-04-07','13:15:00',5.05),('9650','2013-04-07','13:20:00',5.9),('9650','2013-04-07','13:25:00',5.26),('9650','2013-04-07','13:30:00',4.55),('9650','2013-04-07','13:35:00',3.8),('9650','2013-04-07','13:40:00',4.24),('9650','2013-04-07','13:45:00',5.04),('9650','2013-04-07','13:50:00',4.92),('9650','2013-04-07','13:55:00',6.5),('9650','2013-04-07','14:00:00',6.17),('9650','2013-04-07','14:05:00',5.5),('9650','2013-04-07','14:10:00',5.62),('9650','2013-04-07','14:15:00',6.44),('9650','2013-04-07','14:20:00',5.67),('9650','2013-04-07','14:25:00',6.79),('9650','2013-04-07','14:30:00',6.6),('9650','2013-04-07','14:35:00',6.16),('9650','2013-04-07','14:40:00',6.26),('9650','2013-04-07','14:45:00',6.53),('9650','2013-04-07','14:50:00',6.41),('9650','2013-04-07','14:55:00',6.79),('9650','2013-04-07','15:00:00',5.08),('9650','2013-04-07','15:05:00',4.99),('9650','2013-04-07','15:10:00',5.12),('9650','2013-04-07','15:15:00',5.16),('9650','2013-04-07','15:20:00',5.26),('9650','2013-04-07','15:25:00',6.25),('9650','2013-04-07','15:30:00',6.52),('9650','2013-04-07','15:35:00',6.33),('9650','2013-04-07','15:40:00',6.19),('9650','2013-04-07','15:45:00',6.16),('9650','2013-04-07','15:50:00',6.06),('9650','2013-04-07','15:55:00',5.96),('9650','2013-04-07','16:00:00',5.66),('9650','2013-04-07','16:05:00',5.55),('9650','2013-04-07','16:10:00',5.31),('9650','2013-04-07','16:15:00',5.59),('9650','2013-04-07','16:20:00',5.71),('9650','2013-04-07','16:25:00',5.52),('9650','2013-04-07','16:30:00',5.42),('9650','2013-04-07','16:35:00',5.29),('9650','2013-04-07','16:40:00',5.07),('9650','2013-04-07','16:45:00',4.95),('9650','2013-04-07','16:50:00',4.93),('9650','2013-04-07','16:55:00',4.83),('9650','2013-04-07','17:00:00',4.8),('9650','2013-04-07','17:05:00',4.68),('9650','2013-04-07','17:10:00',4.46),('9650','2013-04-07','17:15:00',4.34),('9650','2013-04-07','17:20:00',4.16),('9650','2013-04-07','17:25:00',4.33),('9650','2013-04-07','17:30:00',4.09),('9650','2013-04-07','17:35:00',3.93),('9650','2013-04-07','17:40:00',3.63),('9650','2013-04-07','17:45:00',3.47),('9650','2013-04-07','17:50:00',2.94),('9650','2013-04-07','17:55:00',2.61),('9650','2013-04-07','18:00:00',2.9),('9650','2013-04-07','18:05:00',1.87),('9650','2013-04-07','18:10:00',1.47),('9650','2013-04-07','18:15:00',2.34),('9650','2013-04-07','18:20:00',3.42),('9650','2013-04-07','18:25:00',3.03),('9650','2013-04-07','18:30:00',1.98),('9650','2013-04-07','18:40:00',1.14),('9650','2013-04-06','08:55:00',1),('9650','2013-04-06','09:00:00',1.09),('9650','2013-04-06','09:05:00',1.17),('9650','2013-04-06','09:10:00',1.25),('9650','2013-04-06','09:15:00',1.28),('9650','2013-04-06','09:20:00',1.32),('9650','2013-04-06','09:25:00',1.52),('9650','2013-04-06','09:30:00',1.54),('9650','2013-04-06','09:35:00',1.54),('9650','2013-04-06','09:40:00',1.55),('9650','2013-04-06','09:45:00',1.73),('9650','2013-04-06','09:50:00',2.08),('9650','2013-04-06','09:55:00',2.26),('9650','2013-04-06','10:00:00',2.64),('9650','2013-04-06','10:05:00',2.87),('9650','2013-04-06','10:10:00',2.93),('9650','2013-04-06','10:15:00',3.04),('9650','2013-04-06','10:20:00',3.14),('9650','2013-04-06','10:25:00',3.3),('9650','2013-04-06','10:30:00',2.92),('9650','2013-04-06','10:35:00',3.11),('9650','2013-04-06','10:40:00',3.29),('9650','2013-04-06','10:45:00',3.24),('9650','2013-04-06','10:50:00',3.23),('9650','2013-04-06','10:55:00',2.95),('9650','2013-04-06','11:00:00',2.81),('9650','2013-04-06','11:05:00',2.61),('9650','2013-04-06','11:10:00',2.84),('9650','2013-04-06','11:15:00',3.79),('9650','2013-04-06','11:20:00',4.77),('9650','2013-04-06','11:25:00',5.1),('9650','2013-04-06','11:30:00',5.2),('9650','2013-04-06','11:35:00',4.9),('9650','2013-04-06','11:40:00',4.52),('9650','2013-04-06','11:45:00',3.73),('9650','2013-04-06','11:50:00',3.43),('9650','2013-04-06','11:55:00',3.61),('9650','2013-04-06','12:00:00',3.74),('9650','2013-04-06','12:05:00',3.8),('9650','2013-04-06','12:10:00',4.11),('9650','2013-04-06','12:15:00',4.06),('9650','2013-04-06','12:20:00',4.34),('9650','2013-04-06','12:25:00',4.84),('9650','2013-04-06','12:30:00',4.47),('9650','2013-04-06','12:35:00',4.53),('9650','2013-04-06','12:40:00',4.54),('9650','2013-04-06','12:45:00',3.91),('9650','2013-04-06','12:50:00',4.19),('9650','2013-04-06','12:55:00',4.18),('9650','2013-04-06','13:00:00',5.07),('9650','2013-04-06','13:05:00',5.61),('9650','2013-04-06','13:10:00',5.35),('9650','2013-04-06','13:15:00',4.92),('9650','2013-04-06','13:20:00',4.7),('9650','2013-04-06','13:25:00',5.29),('9650','2013-04-06','13:30:00',4.82),('9650','2013-04-06','13:35:00',4.95),('9650','2013-04-06','13:40:00',5.51),('9650','2013-04-06','13:45:00',5.33),('9650','2013-04-06','13:50:00',4.68),('9650','2013-04-06','13:55:00',4.84),('9650','2013-04-06','14:00:00',5.95),('9650','2013-04-06','14:05:00',5.63),('9650','2013-04-06','14:10:00',3.38),('9650','2013-04-06','14:15:00',4.44),('9650','2013-04-06','14:20:00',4.18),('9650','2013-04-06','14:25:00',3.65),('9650','2013-04-06','14:30:00',2.91),('9650','2013-04-06','14:35:00',3.28),('9650','2013-04-06','14:40:00',3.8),('9650','2013-04-06','14:45:00',3.53),('9650','2013-04-06','14:50:00',3.7),('9650','2013-04-06','14:55:00',4.35),('9650','2013-04-06','15:00:00',3.15),('9650','2013-04-06','15:05:00',4.28),('9650','2013-04-06','15:10:00',3.71),('9650','2013-04-06','15:15:00',5.18),('9650','2013-04-06','15:20:00',5.29),('9650','2013-04-06','15:25:00',5.48),('9650','2013-04-06','15:30:00',5.43),('9650','2013-04-06','15:35:00',5.12),('9650','2013-04-06','15:40:00',4.48),('9650','2013-04-06','15:45:00',4.76),('9650','2013-04-06','15:50:00',4.84),('9650','2013-04-06','15:55:00',4.26),('9650','2013-04-06','16:00:00',4.39),('9650','2013-04-06','16:05:00',3.83),('9650','2013-04-06','16:10:00',3.39),('9650','2013-04-06','16:15:00',2.95),('9650','2013-04-06','16:20:00',2.88),('9650','2013-04-06','16:25:00',2.47),('9650','2013-04-06','16:30:00',2.71),('9650','2013-04-06','16:35:00',3.61),('9650','2013-04-06','16:40:00',3.42),('9650','2013-04-06','16:45:00',4.04),('9650','2013-04-06','16:50:00',4.46),('9650','2013-04-06','16:55:00',4.43),('9650','2013-04-06','17:00:00',4.18),('9650','2013-04-06','17:05:00',3.52),('9650','2013-04-06','17:10:00',2.87),('9650','2013-04-06','17:15:00',1.83),('9650','2013-04-06','17:20:00',3.41),('9650','2013-04-06','17:25:00',4.2),('9650','2013-04-06','17:30:00',3.86),('9650','2013-04-06','17:35:00',3.85),('9650','2013-04-06','17:40:00',3.97),('9650','2013-04-06','17:45:00',3.81),('9650','2013-04-06','17:50:00',3.63),('9650','2013-04-06','17:55:00',3.05),('9650','2013-04-06','18:00:00',2.11),('9650','2013-04-06','18:05:00',1.38),('9650','2013-04-06','18:10:00',1.44),('9650','2013-04-05','09:00:00',1.06),('9650','2013-04-05','09:05:00',1.16),('9650','2013-04-05','09:10:00',1.29),('9650','2013-04-05','09:15:00',1.42),('9650','2013-04-05','09:20:00',1.56),('9650','2013-04-05','09:25:00',1.68),('9650','2013-04-05','09:30:00',1.8),('9650','2013-04-05','09:35:00',1.9),('9650','2013-04-05','09:40:00',2.06),('9650','2013-04-05','09:45:00',2.19),('9650','2013-04-05','09:50:00',2.35),('9650','2013-04-05','09:55:00',2.45),('9650','2013-04-05','10:00:00',2.59),('9650','2013-04-05','10:05:00',2.71),('9650','2013-04-05','10:10:00',2.81),('9650','2013-04-05','10:15:00',2.98),('9650','2013-04-05','10:20:00',3.08),('9650','2013-04-05','10:25:00',3.2),('9650','2013-04-05','10:30:00',3.33),('9650','2013-04-05','10:35:00',3.42),('9650','2013-04-05','10:40:00',3.56),('9650','2013-04-05','10:45:00',3.71),('9650','2013-04-05','10:50:00',3.81),('9650','2013-04-05','10:55:00',3.94),('9650','2013-04-05','11:00:00',4.07),('9650','2013-04-05','11:05:00',4.18),('9650','2013-04-05','11:10:00',4.29),('9650','2013-04-05','11:15:00',4.4),('9650','2013-04-05','11:20:00',4.55),('9650','2013-04-05','11:25:00',4.64),('9650','2013-04-05','11:30:00',4.73),('9650','2013-04-05','11:35:00',4.82),('9650','2013-04-05','11:40:00',4.91),('9650','2013-04-05','11:45:00',4.97),('9650','2013-04-05','11:50:00',5.12),('9650','2013-04-05','11:55:00',5.18),('9650','2013-04-05','12:00:00',5.26),('9650','2013-04-05','12:05:00',5.36),('9650','2013-04-05','12:10:00',5.42),('9650','2013-04-05','12:15:00',5.52),('9650','2013-04-05','12:20:00',5.6),('9650','2013-04-05','12:25:00',5.76),('9650','2013-04-05','12:30:00',5.82),('9650','2013-04-05','12:35:00',5.88),('9650','2013-04-05','12:40:00',5.94),('9650','2013-04-05','12:45:00',6.1),('9650','2013-04-05','12:50:00',6.21),('9650','2013-04-05','12:55:00',6.39),('9650','2013-04-05','13:00:00',5.24),('9650','2013-04-05','13:05:00',6.42),('9650','2013-04-05','13:10:00',6.21),('9650','2013-04-05','13:15:00',6.78),('9650','2013-04-05','13:20:00',5.33),('9650','2013-04-05','13:25:00',2.52),('9650','2013-04-05','13:30:00',7.26),('9650','2013-04-05','13:35:00',7.28),('9650','2013-04-05','13:40:00',2.29),('9650','2013-04-05','13:45:00',5.25),('9650','2013-04-05','13:50:00',6.84),('9650','2013-04-05','13:55:00',7.64),('9650','2013-04-05','14:00:00',7.26),('9650','2013-04-05','14:05:00',6.61),('9650','2013-04-05','14:10:00',7.03),('9650','2013-04-05','14:15:00',4.1),('9650','2013-04-05','14:20:00',4.27),('9650','2013-04-05','14:25:00',1.47),('9650','2013-04-05','14:30:00',6.81),('9650','2013-04-05','14:35:00',6.94),('9650','2013-04-05','14:40:00',5.56),('9650','2013-04-05','14:45:00',5.45),('9650','2013-04-05','14:50:00',6.69),('9650','2013-04-05','14:55:00',6.78),('9650','2013-04-05','15:00:00',6.59),('9650','2013-04-05','15:05:00',6.25),('9650','2013-04-05','15:10:00',6.21),('9650','2013-04-05','15:15:00',6.15),('9650','2013-04-05','15:20:00',6.13),('9650','2013-04-05','15:25:00',6.08),('9650','2013-04-05','15:30:00',5.83),('9650','2013-04-05','15:35:00',5.88),('9650','2013-04-05','15:40:00',5.88),('9650','2013-04-05','15:45:00',5.19),('9650','2013-04-05','15:50:00',5.3),('9650','2013-04-05','15:55:00',5.54),('9650','2013-04-05','16:00:00',5.09),('9650','2013-04-05','16:05:00',5.59),('9650','2013-04-05','16:10:00',5.5),('9650','2013-04-05','16:15:00',4.88),('9650','2013-04-05','16:20:00',4.11),('9650','2013-04-05','16:25:00',3.63),('9650','2013-04-05','16:30:00',4.53),('9650','2013-04-05','16:35:00',4.2),('9650','2013-04-05','16:40:00',3.41),('9650','2013-04-05','16:45:00',4.62),('9650','2013-04-05','16:50:00',4.39),('9650','2013-04-05','16:55:00',3.98),('9650','2013-04-05','17:00:00',3.99),('9650','2013-04-05','17:05:00',3.49),('9650','2013-04-05','17:10:00',3.14),('9650','2013-04-05','17:15:00',2.34),('9650','2013-04-05','17:20:00',1.99),('9650','2013-04-05','17:25:00',2.03),('9650','2013-04-05','17:30:00',2.01),('9650','2013-04-05','17:35:00',1.69),('9650','2013-04-05','17:40:00',1.62),('9650','2013-04-05','17:45:00',1.55),('9650','2013-04-05','17:50:00',1.54),('9650','2013-04-05','17:55:00',1.4),('9650','2013-04-05','18:00:00',1.21),('9650','2013-04-05','18:05:00',1.09),('9650','2013-04-04','08:15:00',1.16),('9650','2013-04-04','08:20:00',1.39),('9650','2013-04-04','08:25:00',1.08),('9650','2013-04-04','08:55:00',1.01),('9650','2013-04-04','09:00:00',1.19),('9650','2013-04-04','09:05:00',2.32),('9650','2013-04-04','09:10:00',1.43),('9650','2013-04-04','09:15:00',2.1),('9650','2013-04-04','09:20:00',2.48),('9650','2013-04-04','09:25:00',1.7),('9650','2013-04-04','09:30:00',1.37),('9650','2013-04-04','09:35:00',1.61),('9650','2013-04-04','09:40:00',2.92),('9650','2013-04-04','09:45:00',2.47),('9650','2013-04-04','09:50:00',1.98),('9650','2013-04-04','09:55:00',1.61),('9650','2013-04-04','10:00:00',2.24),('9650','2013-04-04','10:05:00',1.79),('9650','2013-04-04','10:10:00',2.92),('9650','2013-04-04','10:15:00',3.43),('9650','2013-04-04','10:20:00',1.6),('9650','2013-04-04','10:25:00',2.66),('9650','2013-04-04','10:30:00',2.06),('9650','2013-04-04','10:35:00',1.95),('9650','2013-04-04','10:40:00',4.61),('9650','2013-04-04','10:45:00',2.36),('9650','2013-04-04','10:50:00',3.34),('9650','2013-04-04','10:55:00',3.21),('9650','2013-04-04','11:00:00',3.37),('9650','2013-04-04','11:05:00',3.7),('9650','2013-04-04','11:10:00',4.71),('9650','2013-04-04','11:15:00',4.71),('9650','2013-04-04','11:20:00',3.63),('9650','2013-04-04','11:25:00',4.35),('9650','2013-04-04','11:30:00',4.69),('9650','2013-04-04','11:35:00',5.88),('9650','2013-04-04','11:40:00',5.34),('9650','2013-04-04','11:45:00',4.69),('9650','2013-04-04','11:50:00',5.53),('9650','2013-04-04','11:55:00',5.7),('9650','2013-04-04','12:00:00',5.91),('9650','2013-04-04','12:05:00',4.37),('9650','2013-04-04','12:10:00',3.01),('9650','2013-04-04','12:15:00',5.26),('9650','2013-04-04','12:20:00',2.61),('9650','2013-04-04','12:25:00',3.67),('9650','2013-04-04','12:30:00',2.2),('9650','2013-04-04','12:35:00',2.39),('9650','2013-04-04','12:40:00',3.14),('9650','2013-04-04','12:45:00',5.55),('9650','2013-04-04','12:50:00',6.27),('9650','2013-04-04','12:55:00',5.48),('9650','2013-04-04','13:00:00',4.81),('9650','2013-04-04','13:05:00',4.76),('9650','2013-04-04','13:10:00',5.24),('9650','2013-04-04','13:15:00',6.55),('9650','2013-04-04','13:20:00',5.73),('9650','2013-04-04','13:25:00',5.86),('9650','2013-04-04','13:30:00',5.6),('9650','2013-04-04','13:35:00',5.52),('9650','2013-04-04','13:40:00',5.5),('9650','2013-04-04','13:45:00',5.52),('9650','2013-04-04','13:50:00',7.15),('9650','2013-04-04','13:55:00',6.06),('9650','2013-04-04','14:00:00',5.37),('9650','2013-04-04','14:05:00',7.7),('9650','2013-04-04','14:10:00',7.16),('9650','2013-04-04','14:15:00',6.53),('9650','2013-04-04','14:20:00',7.15),('9650','2013-04-04','14:25:00',7.02),('9650','2013-04-04','14:30:00',6.91),('9650','2013-04-04','14:35:00',6.36),('9650','2013-04-04','14:40:00',5.98),('9650','2013-04-04','14:45:00',5.76),('9650','2013-04-04','14:50:00',4.4),('9650','2013-04-04','14:55:00',7.71),('9650','2013-04-04','15:00:00',6.86),('9650','2013-04-04','15:05:00',7.01),('9650','2013-04-04','15:10:00',4.75),('9650','2013-04-04','15:15:00',2.83),('9650','2013-04-04','15:20:00',3.06),('9650','2013-04-04','15:25:00',3.49),('9650','2013-04-04','15:30:00',2.77),('9650','2013-04-04','15:35:00',2.16),('9650','2013-04-04','15:40:00',1.9),('9650','2013-04-04','15:45:00',2.38),('9650','2013-04-04','15:50:00',3.06),('9650','2013-04-04','15:55:00',2.9),('9650','2013-04-04','16:00:00',3.07),('9650','2013-04-04','16:05:00',2.88),('9650','2013-04-04','16:10:00',3.03),('9650','2013-04-04','16:15:00',3.67),('9650','2013-04-04','16:20:00',3.26),('9650','2013-04-04','16:25:00',2.86),('9650','2013-04-04','16:30:00',2.8),('9650','2013-04-04','16:35:00',3.84),('9650','2013-04-04','16:40:00',2.91),('9650','2013-04-04','16:45:00',3.95),('9650','2013-04-04','16:50:00',5.69),('9650','2013-04-04','16:55:00',2.71),('9650','2013-04-04','17:00:00',2.46),('9650','2013-04-04','17:05:00',1.97),('9650','2013-04-04','17:10:00',5.44),('9650','2013-04-04','17:15:00',4.98),('9650','2013-04-04','17:20:00',4.54),('9650','2013-04-04','17:25:00',4.8),('9650','2013-04-04','17:30:00',3.58),('9650','2013-04-04','17:35:00',4.2),('9650','2013-04-04','17:40:00',3.54),('9650','2013-04-04','17:45:00',1.01),('9650','2013-04-04','17:50:00',2.8),('9650','2013-04-04','17:55:00',4.22),('9650','2013-04-04','18:00:00',2.65),('9650','2013-04-04','18:10:00',1.09),('9650','2013-04-04','18:15:00',2.76),('9650','2013-04-04','18:20:00',2.91),('9650','2013-04-04','18:25:00',1.55),('9650','2013-04-04','18:30:00',2),('9650','2013-04-04','18:35:00',1.79),('9650','2013-04-04','18:40:00',1.95),('9650','2013-04-04','18:45:00',1.73),('9650','2013-04-04','18:50:00',1.47),('9650','2013-04-04','18:55:00',1.05),('9650','2013-04-03','08:20:00',1.01),('9650','2013-04-03','08:25:00',1.1),('9650','2013-04-03','08:30:00',1.19),('9650','2013-04-03','08:35:00',1.5),('9650','2013-04-03','08:40:00',1.31),('9650','2013-04-03','08:45:00',1.31),('9650','2013-04-03','08:50:00',1.33),('9650','2013-04-03','08:55:00',1.8),('9650','2013-04-03','09:00:00',2.11),('9650','2013-04-03','09:05:00',1.87),('9650','2013-04-03','09:10:00',1.87),('9650','2013-04-03','09:15:00',1.96),('9650','2013-04-03','09:20:00',1.85),('9650','2013-04-03','09:25:00',1.69),('9650','2013-04-03','09:30:00',2.12),('9650','2013-04-03','09:35:00',3.07),('9650','2013-04-03','09:40:00',2.98),('9650','2013-04-03','09:45:00',2.64),('9650','2013-04-03','09:50:00',1.83),('9650','2013-04-03','09:55:00',2.11),('9650','2013-04-03','10:00:00',2.69),('9650','2013-04-03','10:05:00',3.27),('9650','2013-04-03','10:10:00',2.94),('9650','2013-04-03','10:15:00',2.47),('9650','2013-04-03','10:20:00',2.69),('9650','2013-04-03','10:25:00',4.44),('9650','2013-04-03','10:30:00',3.99),('9650','2013-04-03','10:35:00',2.92),('9650','2013-04-03','10:40:00',4.93),('9650','2013-04-03','10:45:00',3.07),('9650','2013-04-03','10:50:00',3.42),('9650','2013-04-03','10:55:00',5.19),('9650','2013-04-03','11:00:00',3.36),('9650','2013-04-03','11:05:00',2.06),('9650','2013-04-03','11:10:00',1.96),('9650','2013-04-03','11:15:00',2.65),('9650','2013-04-03','11:20:00',2.31),('9650','2013-04-03','11:25:00',1.87),('9650','2013-04-03','11:30:00',2.02),('9650','2013-04-03','11:35:00',2.83),('9650','2013-04-03','11:40:00',4.33),('9650','2013-04-03','11:45:00',5),('9650','2013-04-03','11:50:00',5.63),('9650','2013-04-03','11:55:00',5.64),('9650','2013-04-03','12:00:00',5.36),('9650','2013-04-03','12:05:00',5.84),('9650','2013-04-03','12:10:00',5.87),('9650','2013-04-03','12:15:00',5.68),('9650','2013-04-03','12:20:00',5),('9650','2013-04-03','12:25:00',3.66),('9650','2013-04-03','12:30:00',3.76),('9650','2013-04-03','12:35:00',4.69),('9650','2013-04-03','12:40:00',5.35),('9650','2013-04-03','12:45:00',5.29),('9650','2013-04-03','12:50:00',6.31),('9650','2013-04-03','12:55:00',5.84),('9650','2013-04-03','13:00:00',5.87),('9650','2013-04-03','13:05:00',5.84),('9650','2013-04-03','13:10:00',6.07),('9650','2013-04-03','13:15:00',6.29),('9650','2013-04-03','13:20:00',6.16),('9650','2013-04-03','13:25:00',6.44),('9650','2013-04-03','13:30:00',6.18),('9650','2013-04-03','13:35:00',5.68),('9650','2013-04-03','13:40:00',4.8),('9650','2013-04-03','13:45:00',5.26),('9650','2013-04-03','13:50:00',5.26),('9650','2013-04-03','13:55:00',4.16),('9650','2013-04-03','14:00:00',4.52),('9650','2013-04-03','14:05:00',5.94),('9650','2013-04-03','14:10:00',6.5),('9650','2013-04-03','14:15:00',6.39),('9650','2013-04-03','14:20:00',6.37),('9650','2013-04-03','14:25:00',6.24),('9650','2013-04-03','14:30:00',6.18),('9650','2013-04-03','14:35:00',6.21),('9650','2013-04-03','14:40:00',6.32),('9650','2013-04-03','14:45:00',6.24),('9650','2013-04-03','14:50:00',6.19),('9650','2013-04-03','14:55:00',6.2),('9650','2013-04-03','15:00:00',6.17),('9650','2013-04-03','15:05:00',5.94),('9650','2013-04-03','15:10:00',5.65),('9650','2013-04-03','15:15:00',5.69),('9650','2013-04-03','15:20:00',5.8),('9650','2013-04-03','15:25:00',5.89),('9650','2013-04-03','15:30:00',5.85),('9650','2013-04-03','15:35:00',5.75),('9650','2013-04-03','15:40:00',5.66),('9650','2013-04-03','15:45:00',5.58),('9650','2013-04-03','15:50:00',5.36),('9650','2013-04-03','15:55:00',5.33),('9650','2013-04-03','16:00:00',5.15),('9650','2013-04-03','16:05:00',4.98),('9650','2013-04-03','16:10:00',4.77),('9650','2013-04-03','16:15:00',4.55),('9650','2013-04-03','16:20:00',4.39),('9650','2013-04-03','16:25:00',4.19),('9650','2013-04-03','16:30:00',3.55),('9650','2013-04-03','16:35:00',3.56),('9650','2013-04-03','16:40:00',3.73),('9650','2013-04-03','16:45:00',3.32),('9650','2013-04-03','16:50:00',2.9),('9650','2013-04-03','16:55:00',3.57),('9650','2013-04-03','17:00:00',3.34),('9650','2013-04-03','17:05:00',3.37),('9650','2013-04-03','17:10:00',3.2),('9650','2013-04-03','17:15:00',2.77),('9650','2013-04-03','17:20:00',1.92),('9650','2013-04-03','17:25:00',2.04),('9650','2013-04-03','17:30:00',1.43),('9650','2013-04-03','17:35:00',1.37),('9650','2013-04-03','17:40:00',1.61),('9650','2013-04-03','17:45:00',1.48),('9650','2013-04-03','17:50:00',1.96),('9650','2013-04-03','17:55:00',2.59),('9650','2013-04-03','18:00:00',2.07),('9650','2013-04-03','18:05:00',2),('9650','2013-04-02','09:05:00',1.12),('9650','2013-04-02','09:10:00',1.18),('9650','2013-04-02','09:15:00',1.49),('9650','2013-04-02','09:20:00',1.15),('9650','2013-04-02','09:25:00',1.96),('9650','2013-04-02','09:30:00',2.12),('9650','2013-04-02','09:35:00',1.81),('9650','2013-04-02','09:40:00',2.25),('9650','2013-04-02','09:45:00',2.29),('9650','2013-04-02','09:50:00',2.18),('9650','2013-04-02','09:55:00',2.8),('9650','2013-04-02','10:00:00',2.72),('9650','2013-04-02','10:05:00',1.83),('9650','2013-04-02','10:10:00',1.76),('9650','2013-04-02','10:15:00',2.17),('9650','2013-04-02','10:20:00',3.89),('9650','2013-04-02','10:25:00',4.01),('9650','2013-04-02','10:30:00',4.24),('9650','2013-04-02','10:35:00',3.54),('9650','2013-04-02','10:40:00',2.63),('9650','2013-04-02','10:45:00',2.07),('9650','2013-04-02','10:50:00',2.44),('9650','2013-04-02','10:55:00',2.5),('9650','2013-04-02','11:00:00',5.36),('9650','2013-04-02','11:05:00',4.27),('9650','2013-04-02','11:10:00',2.99),('9650','2013-04-02','11:15:00',5.61),('9650','2013-04-02','11:20:00',5.23),('9650','2013-04-02','11:25:00',3.22),('9650','2013-04-02','11:30:00',2.91),('9650','2013-04-02','11:35:00',3.96),('9650','2013-04-02','11:40:00',2.63),('9650','2013-04-02','11:45:00',2.9),('9650','2013-04-02','11:50:00',5.78),('9650','2013-04-02','11:55:00',3.79),('9650','2013-04-02','12:00:00',5.18),('9650','2013-04-02','12:05:00',5.83),('9650','2013-04-02','12:10:00',3.69),('9650','2013-04-02','12:15:00',4.02),('9650','2013-04-02','12:20:00',5.39),('9650','2013-04-02','12:25:00',6.73),('9650','2013-04-02','12:30:00',6.11),('9650','2013-04-02','12:35:00',5.95),('9650','2013-04-02','12:40:00',6.56),('9650','2013-04-02','12:45:00',6.66),('9650','2013-04-02','12:50:00',6.96),('9650','2013-04-02','12:55:00',3.95),('9650','2013-04-02','13:05:00',6.19),('9650','2013-04-02','13:10:00',5.38),('9650','2013-04-02','13:15:00',7.7),('9650','2013-04-02','13:20:00',5.45),('9650','2013-04-02','13:25:00',5.43),('9650','2013-04-02','13:30:00',5.84),('9650','2013-04-02','13:35:00',7.54),('9650','2013-04-02','13:40:00',5.7),('9650','2013-04-02','13:45:00',5.22),('9650','2013-04-02','13:50:00',6.01),('9650','2013-04-02','13:55:00',3.62),('9650','2013-04-02','14:00:00',7.09),('9650','2013-04-02','14:05:00',8.14),('9650','2013-04-02','14:10:00',6.78),('9650','2013-04-02','14:15:00',3.32),('9650','2013-04-02','14:20:00',5.18),('9650','2013-04-02','14:25:00',6.07),('9650','2013-04-02','14:30:00',7.09),('9650','2013-04-02','14:35:00',7.13),('9650','2013-04-02','14:40:00',3.77),('9650','2013-04-02','14:45:00',4.87),('9650','2013-04-02','14:50:00',5.62),('9650','2013-04-02','14:55:00',6.3),('9650','2013-04-02','15:00:00',5.61),('9650','2013-04-02','15:05:00',6.36),('9650','2013-04-02','15:10:00',6.6),('9650','2013-04-02','15:15:00',7.65),('9650','2013-04-02','15:20:00',5.67),('9650','2013-04-02','15:25:00',7.05),('9650','2013-04-02','15:30:00',4.04),('9650','2013-04-02','15:35:00',4.88),('9650','2013-04-02','15:40:00',5.68),('9650','2013-04-02','15:45:00',5.74),('9650','2013-04-02','15:50:00',6.98),('9650','2013-04-02','15:55:00',6.6),('9650','2013-04-02','16:00:00',6.21),('9650','2013-04-02','16:05:00',6.18),('9650','2013-04-02','16:10:00',5.78),('9650','2013-04-02','16:15:00',5.87),('9650','2013-04-02','16:20:00',5.74),('9650','2013-04-02','16:25:00',5.64),('9650','2013-04-02','16:30:00',5.6),('9650','2013-04-02','16:35:00',4.8),('9650','2013-04-02','16:40:00',5.27),('9650','2013-04-02','16:45:00',5.14),('9650','2013-04-02','16:50:00',5),('9650','2013-04-02','16:55:00',4.95),('9650','2013-04-02','17:00:00',4.9),('9650','2013-04-02','17:05:00',4.79),('9650','2013-04-02','17:10:00',4.61),('9650','2013-04-02','17:15:00',4.53),('9650','2013-04-02','17:20:00',4.37),('9650','2013-04-02','17:25:00',4.17),('9650','2013-04-02','17:30:00',4.13),('9650','2013-04-02','17:35:00',4.04),('9650','2013-04-02','17:40:00',3.93),('9650','2013-04-02','17:45:00',3.81),('9650','2013-04-02','17:50:00',3.69),('9650','2013-04-02','17:55:00',3.52),('9650','2013-04-02','18:00:00',3.36),('9650','2013-04-02','18:05:00',3.18),('9650','2013-04-02','18:10:00',2.97),('9650','2013-04-02','18:15:00',2.89),('9650','2013-04-02','18:20:00',2.73),('9650','2013-04-02','18:25:00',2.5),('9650','2013-04-02','18:30:00',2.4),('9650','2013-04-02','18:35:00',2.21),('9650','2013-04-02','18:40:00',2.02),('9650','2013-04-02','18:45:00',1.75),('9650','2013-04-02','18:50:00',1.48),('9650','2013-04-01','08:40:00',1.34),('9650','2013-04-01','08:45:00',1.67),('9650','2013-04-01','08:50:00',1.24),('9650','2013-04-01','09:10:00',1.11),('9650','2013-04-01','09:15:00',1.14),('9650','2013-04-01','09:20:00',1.26),('9650','2013-04-01','09:30:00',1.35),('9650','2013-04-01','09:35:00',2.23),('9650','2013-04-01','09:40:00',2.28),('9650','2013-04-01','09:45:00',2.46),('9650','2013-04-01','09:50:00',2.25),('9650','2013-04-01','09:55:00',2.11),('9650','2013-04-01','10:00:00',2.01),('9650','2013-04-01','10:05:00',1.72),('9650','2013-04-01','10:10:00',1.65),('9650','2013-04-01','10:15:00',2.18),('9650','2013-04-01','10:20:00',2.41),('9650','2013-04-01','10:25:00',2.21),('9650','2013-04-01','10:30:00',1.59),('9650','2013-04-01','10:35:00',3.56),('9650','2013-04-01','10:40:00',2.71),('9650','2013-04-01','10:45:00',2.9),('9650','2013-04-01','10:50:00',4.37),('9650','2013-04-01','10:55:00',1.81),('9650','2013-04-01','11:00:00',1.86),('9650','2013-04-01','11:05:00',3.91),('9650','2013-04-01','11:10:00',2.64),('9650','2013-04-01','11:15:00',1.98),('9650','2013-04-01','11:20:00',1.76),('9650','2013-04-01','11:25:00',2.04),('9650','2013-04-01','11:30:00',2.17),('9650','2013-04-01','11:35:00',2.04),('9650','2013-04-01','11:40:00',1.6),('9650','2013-04-01','11:45:00',3.68),('9650','2013-04-01','11:50:00',3.58),('9650','2013-04-01','11:55:00',1.94),('9650','2013-04-01','12:00:00',1.65),('9650','2013-04-01','12:05:00',5.09),('9650','2013-04-01','12:10:00',3.18),('9650','2013-04-01','12:15:00',3.24),('9650','2013-04-01','12:30:00',1.59),('9650','2013-04-01','12:35:00',3.06),('9650','2013-04-01','12:40:00',3.29),('9650','2013-04-01','12:45:00',3.61),('9650','2013-04-01','12:50:00',3.71),('9650','2013-04-01','12:55:00',3.76),('9650','2013-04-01','13:00:00',3.95),('9650','2013-04-01','13:05:00',4.47),('9650','2013-04-01','13:10:00',5.43),('9650','2013-04-01','13:15:00',4.31),('9650','2013-04-01','13:20:00',3.48),('9650','2013-04-01','13:25:00',5.51),('9650','2013-04-01','13:30:00',4.3),('9650','2013-04-01','13:35:00',3.36),('9650','2013-04-01','13:40:00',5),('9650','2013-04-01','13:45:00',4.59),('9650','2013-04-01','13:50:00',3.81),('9650','2013-04-01','13:55:00',3.27),('9650','2013-04-01','14:00:00',4.47),('9650','2013-04-01','14:05:00',3.49),('9650','2013-04-01','14:10:00',4.17),('9650','2013-04-01','14:15:00',3.95),('9650','2013-04-01','14:20:00',7.05),('9650','2013-04-01','14:25:00',6.95),('9650','2013-04-01','14:30:00',4.22),('9650','2013-04-01','14:35:00',3.1),('9650','2013-04-01','14:40:00',4.27),('9650','2013-04-01','14:45:00',4.64),('9650','2013-04-01','14:50:00',3.48),('9650','2013-04-01','14:55:00',3.02),('9650','2013-04-01','15:00:00',2.69),('9650','2013-04-01','15:05:00',1.43),('9650','2013-04-01','15:10:00',1.05),('9650','2013-04-01','15:15:00',1.13),('9650','2013-04-01','15:20:00',1.65),('9650','2013-04-01','15:35:00',1.37),('9650','2013-04-01','15:40:00',1.55),('9650','2013-04-01','15:45:00',2.08),('9650','2013-04-01','15:50:00',1.16),('9650','2013-04-01','15:55:00',1.23),('9650','2013-04-01','16:00:00',1.8),('9650','2013-04-01','16:05:00',2.07),('9650','2013-04-01','16:10:00',1.59),('9650','2013-04-01','16:15:00',1.86),('9650','2013-04-01','16:20:00',1.82),('9650','2013-04-01','16:25:00',1.55),('9650','2013-04-01','16:30:00',1.64),('9650','2013-04-01','16:35:00',1.63),('9650','2013-04-01','16:40:00',1.47),('9650','2013-04-01','16:45:00',1.51),('9650','2013-04-01','16:55:00',1.11),('9650','2013-04-01','17:00:00',1.34),('9650','2013-04-01','17:05:00',1.43),('9650','2013-04-01','17:40:00',1.79),('9650','2013-04-01','17:45:00',1.9),('9650','2014-05-01','08:00:00',1.28),('9650','2014-05-01','08:05:00',1.36),('9650','2014-05-01','08:10:00',1.33),('9650','2014-05-01','08:15:00',2.32),('9650','2014-05-01','08:20:00',2.6),('9650','2014-05-01','08:25:00',1.83),('9650','2014-05-01','08:30:00',1.04),('9650','2014-05-01','08:40:00',1.38),('9650','2014-05-01','08:45:00',2.05),('9650','2014-05-01','08:50:00',2.21),('9650','2014-05-01','09:05:00',1.21),('9650','2014-05-01','09:10:00',1.58),('9650','2014-05-01','09:15:00',2.16),('9650','2014-05-01','09:20:00',2.52),('9650','2014-05-01','09:25:00',2.78),('9650','2014-05-01','09:30:00',3.04),('9650','2014-05-01','09:35:00',2.88),('9650','2014-05-01','09:40:00',2.73),('9650','2014-05-01','09:45:00',2.86),('9650','2014-05-01','09:50:00',2.7),('9650','2014-05-01','09:55:00',2.6),('9650','2014-05-01','10:00:00',3.18),('9650','2014-05-01','10:05:00',3.39),('9650','2014-05-01','10:10:00',3.06),('9650','2014-05-01','10:15:00',2.67),('9650','2014-05-01','10:20:00',2.48),('9650','2014-05-01','10:25:00',2.11),('9650','2014-05-01','10:30:00',1.59),('9650','2014-05-01','10:35:00',1.62),('9650','2014-05-01','10:40:00',1.79),('9650','2014-05-01','10:45:00',2.21),('9650','2014-05-01','10:50:00',1.86),('9650','2014-05-01','10:55:00',1.37),('9650','2014-05-01','12:25:00',1.57),('9650','2014-05-01','12:30:00',1.98),('9650','2014-05-01','12:35:00',2.17),('9650','2014-05-01','12:40:00',2.14),('9650','2014-05-01','12:45:00',2.66),('9650','2014-05-01','12:50:00',3.45),('9650','2014-05-01','12:55:00',2.61),('9650','2014-05-01','13:00:00',2.88),('9650','2014-05-01','13:05:00',3.17),('9650','2014-05-01','13:10:00',3.32),('9650','2014-05-01','13:15:00',3.94),('9650','2014-05-01','13:20:00',5.16),('9650','2014-05-01','13:25:00',6.02),('9650','2014-05-01','13:30:00',5.1),('9650','2014-05-01','13:35:00',4.59),('9650','2014-05-01','13:40:00',4.8),('9650','2014-05-01','13:45:00',3.72),('9650','2014-05-01','13:50:00',3.03),('9650','2014-05-01','13:55:00',2.53),('9650','2014-05-01','14:00:00',2.68),('9650','2014-05-01','14:05:00',3.66),('9650','2014-05-01','14:10:00',1.88),('9650','2014-05-01','14:25:00',1.19),('9650','2014-05-01','14:30:00',1.88),('9650','2014-05-01','14:35:00',2.78),('9650','2014-05-01','14:40:00',5.37),('9650','2014-05-01','14:45:00',2.76),('9650','2014-05-01','14:50:00',2.36),('9650','2014-05-01','14:55:00',3.35),('9650','2014-05-01','15:00:00',4.48),('9650','2014-05-01','15:05:00',3.41),('9650','2014-05-01','15:10:00',6.74),('9650','2014-05-01','15:15:00',5.31),('9650','2014-05-01','15:20:00',4.41),('9650','2014-05-01','15:25:00',3.15),('9650','2014-05-01','15:30:00',2.32),('9650','2014-05-01','15:35:00',5.33),('9650','2014-05-01','15:40:00',6.75),('9650','2014-05-01','15:45:00',2.17),('9650','2014-05-01','15:50:00',1.48),('9650','2014-05-01','15:55:00',1.53),('9650','2014-05-01','16:00:00',2.44),('9650','2014-05-01','16:05:00',3.29),('9650','2014-05-01','16:10:00',2.03),('9650','2014-05-01','16:15:00',2.47),('9650','2014-05-01','16:20:00',4.28),('9650','2014-05-01','16:25:00',1.03),('9650','2014-05-01','16:55:00',1.2),('9650','2014-05-01','17:05:00',1.25),('9650','2014-05-01','17:10:00',1),('9650','2014-05-01','17:15:00',1.52),('9650','2014-05-01','17:20:00',1.8),('9650','2014-05-01','17:25:00',2.22),('9650','2014-05-01','17:30:00',1.64),('9650','2014-05-01','17:35:00',1.36),('9650','2014-05-01','17:40:00',1.13),('9650','2014-03-26','07:45:00',1.2),('9650','2014-03-26','07:50:00',1.27),('9650','2014-03-26','07:55:00',1.54),('9650','2014-03-26','08:00:00',2.04),('9650','2014-03-26','08:05:00',2.39),('9650','2014-03-26','08:10:00',1.33),('9650','2014-03-26','09:10:00',1.34),('9650','2014-03-26','09:15:00',1.7),('9650','2014-03-26','09:20:00',1.6),('9650','2014-03-26','09:25:00',1.48),('9650','2014-03-26','09:30:00',1.31),('9650','2014-03-26','09:55:00',1.12),('9650','2014-03-26','10:00:00',1.46),('9650','2014-03-26','10:05:00',1.86),('9650','2014-03-26','10:10:00',2.17),('9650','2014-03-26','10:15:00',2.14),('9650','2014-03-26','10:20:00',2.93),('9650','2014-03-26','10:25:00',3.42),('9650','2014-03-26','10:30:00',3.21),('9650','2014-03-26','10:35:00',2.92),('9650','2014-03-26','10:40:00',3.19),('9650','2014-03-26','10:45:00',1.79),('9650','2014-03-26','10:50:00',1.42),('9650','2014-03-26','10:55:00',1.33),('9650','2014-03-26','11:00:00',1.25),('9650','2014-03-26','11:05:00',1.15),('9650','2014-03-26','11:10:00',4.58),('9650','2014-03-26','11:15:00',3.74),('9650','2014-03-26','11:25:00',1.18),('9650','2014-03-26','11:50:00',1.96),('9650','2014-03-26','11:55:00',2.38),('9650','2014-03-26','12:00:00',2.03),('9650','2014-03-26','12:05:00',1.66),('9650','2014-03-26','12:10:00',1.99),('9650','2014-03-26','12:15:00',1.53),('9650','2014-03-26','12:20:00',1.73),('9650','2014-03-26','12:25:00',1.03),('9650','2014-03-26','12:55:00',1.23),('9650','2014-03-26','13:00:00',1.63),('9650','2014-03-26','13:05:00',2.01),('9650','2014-03-26','13:10:00',2.69),('9650','2014-03-26','13:15:00',3.7),('9650','2014-03-26','13:20:00',4.13),('9650','2014-03-26','13:25:00',4.25),('9650','2014-03-26','13:30:00',3.68),('9650','2014-03-26','13:35:00',3.3),('9650','2014-03-26','13:40:00',3.15),('9650','2014-03-26','13:45:00',2.85),('9650','2014-03-26','13:50:00',3.59),('9650','2014-03-26','13:55:00',4.73),('9650','2014-03-26','14:00:00',3.48),('9650','2014-03-26','14:05:00',2.01),('9650','2014-03-26','14:10:00',1.13),('9650','2014-03-26','14:15:00',4.08),('9650','2014-03-26','14:20:00',6.49),('9650','2014-03-26','14:25:00',6.36),('9650','2014-03-26','14:30:00',6.31),('9650','2014-03-26','14:35:00',3.89),('9650','2014-03-26','14:40:00',3.35),('9650','2014-03-26','14:45:00',3.06),('9650','2014-03-26','14:50:00',4.15),('9650','2014-03-26','14:55:00',3.11),('9650','2014-03-26','15:00:00',6.76),('9650','2014-03-26','15:05:00',2.97),('9650','2014-03-26','15:20:00',1.43),('9650','2014-03-26','15:25:00',4.32),('9650','2014-03-26','15:30:00',5),('9650','2014-03-26','15:35:00',4.51),('9650','2014-03-26','15:40:00',2.1),('9650','2014-03-26','15:45:00',1.08),('9650','2014-03-26','15:50:00',1.41),('9650','2014-03-26','15:55:00',1.47),('9650','2014-03-26','16:00:00',1.47),('9650','2014-03-26','16:05:00',1.69),('9650','2014-03-26','16:10:00',2),('9650','2014-03-26','16:15:00',1.77),('9650','2014-03-26','16:20:00',1.51),('9650','2014-03-26','16:25:00',1.89),('9650','2014-03-26','16:30:00',2.43),('9650','2014-03-26','16:35:00',1.63),('9650','2014-03-26','16:40:00',1.76),('9650','2014-03-26','16:45:00',1.94),('9650','2014-03-26','16:50:00',1.13),('9650','2014-03-26','16:55:00',1.91),('9650','2014-03-26','17:00:00',1.87),('9650','2014-03-26','17:05:00',1.66),('9650','2014-03-26','17:10:00',1.02),('9650','2013-03-31','08:40:00',1.11),('9650','2013-03-31','08:45:00',1.1),('9650','2013-03-31','08:50:00',1.07),('9650','2013-03-31','09:05:00',1.1),('9650','2013-03-31','09:10:00',1.3),('9650','2013-03-31','09:15:00',1.31),('9650','2013-03-31','09:20:00',1.37),('9650','2013-03-31','09:25:00',1.74),('9650','2013-03-31','09:30:00',2.01),('9650','2013-03-31','09:35:00',1.83),('9650','2013-03-31','09:40:00',1.82),('9650','2013-03-31','09:45:00',2.34),('9650','2013-03-31','09:50:00',2.58),('9650','2013-03-31','09:55:00',2.54),('9650','2013-03-31','10:00:00',2.83),('9650','2013-03-31','10:05:00',2.99),('9650','2013-03-31','10:10:00',2.68),('9650','2013-03-31','10:15:00',3.29),('9650','2013-03-31','10:20:00',2.76),('9650','2013-03-31','10:25:00',3.5),('9650','2013-03-31','10:30:00',3.05),('9650','2013-03-31','10:35:00',2.2),('9650','2013-03-31','10:40:00',2.65),('9650','2013-03-31','10:45:00',4.44),('9650','2013-03-31','10:50:00',2.68),('9650','2013-03-31','10:55:00',2.92),('9650','2013-03-31','11:00:00',1.99),('9650','2013-03-31','11:05:00',2.34),('9650','2013-03-31','11:10:00',3.79),('9650','2013-03-31','11:15:00',4.14),('9650','2013-03-31','11:20:00',4.96),('9650','2013-03-31','11:25:00',3.02),('9650','2013-03-31','11:30:00',2.54),('9650','2013-03-31','11:35:00',2.96),('9650','2013-03-31','11:40:00',4.48),('9650','2013-03-31','11:45:00',4.47),('9650','2013-03-31','11:50:00',3.8),('9650','2013-03-31','11:55:00',3.46),('9650','2013-03-31','12:00:00',4.27),('9650','2013-03-31','12:05:00',2.95),('9650','2013-03-31','12:10:00',3.78),('9650','2013-03-31','12:15:00',3.21),('9650','2013-03-31','12:20:00',2.71),('9650','2013-03-31','12:25:00',3.03),('9650','2013-03-31','12:30:00',4.19),('9650','2013-03-31','12:35:00',3.88),('9650','2013-03-31','12:40:00',4.01),('9650','2013-03-31','12:45:00',4.48),('9650','2013-03-31','12:50:00',4.75),('9650','2013-03-31','12:55:00',5.06),('9650','2013-03-31','13:00:00',5.01),('9650','2013-03-31','13:05:00',5.33),('9650','2013-03-31','13:10:00',4.79),('9650','2013-03-31','13:15:00',4.95),('9650','2013-03-31','13:20:00',4.75),('9650','2013-03-31','13:25:00',4.46),('9650','2013-03-31','13:30:00',4.91),('9650','2013-03-31','13:35:00',4.43),('9650','2013-03-31','13:40:00',5.72),('9650','2013-03-31','13:45:00',6.2),('9650','2013-03-31','13:50:00',6.9),('9650','2013-03-31','13:55:00',6.8),('9650','2013-03-31','14:00:00',4.1),('9650','2013-03-31','14:05:00',3.25),('9650','2013-03-31','14:10:00',4.05),('9650','2013-03-31','14:15:00',4.5),('9650','2013-03-31','14:20:00',4.76),('9650','2013-03-31','14:25:00',7.12),('9650','2013-03-31','14:30:00',4.52),('9650','2013-03-31','14:35:00',3.75),('9650','2013-03-31','14:40:00',3.29),('9650','2013-03-31','14:45:00',3.39),('9650','2013-03-31','14:50:00',3.67),('9650','2013-03-31','14:55:00',3.9),('9650','2013-03-31','15:00:00',3.51),('9650','2013-03-31','15:05:00',3.49),('9650','2013-03-31','15:10:00',3.61),('9650','2013-03-31','15:15:00',3.87),('9650','2013-03-31','15:20:00',3.98),('9650','2013-03-31','15:25:00',4.05),('9650','2013-03-31','15:30:00',3.61),('9650','2013-03-31','15:35:00',4.6),('9650','2013-03-31','15:40:00',4.28),('9650','2013-03-31','15:45:00',4.42),('9650','2013-03-31','15:50:00',5),('9650','2013-03-31','15:55:00',3.75),('9650','2013-03-31','16:00:00',3.5),('9650','2013-03-31','16:05:00',2.85),('9650','2013-03-31','16:10:00',2.39),('9650','2013-03-31','16:15:00',1.9),('9650','2013-03-31','16:20:00',1.83),('9650','2013-03-31','16:25:00',1.72),('9650','2013-03-31','16:30:00',1.39),('9650','2013-03-31','16:35:00',1.44),('9650','2013-03-31','16:40:00',1.23),('9650','2013-03-31','16:45:00',1.01),('9650','2013-03-30','08:30:00',1.48),('9650','2013-03-30','08:35:00',1.25),('9650','2013-03-30','08:40:00',1.25),('9650','2013-03-30','08:45:00',1.3),('9650','2013-03-30','08:50:00',1.27),('9650','2013-03-30','08:55:00',1.56),('9650','2013-03-30','09:00:00',1.61),('9650','2013-03-30','09:05:00',1.53),('9650','2013-03-30','09:10:00',1.67),('9650','2013-03-30','09:15:00',1.89),('9650','2013-03-30','09:20:00',2.46),('9650','2013-03-30','09:25:00',2.52),('9650','2013-03-30','09:30:00',2.1),('9650','2013-03-30','09:35:00',2.34),('9650','2013-03-30','09:40:00',1.88),('9650','2013-03-30','09:45:00',2.6),('9650','2013-03-30','09:50:00',2.12),('9650','2013-03-30','09:55:00',2.69),('9650','2013-03-30','10:00:00',2.59),('9650','2013-03-30','10:15:00',1.69),('9650','2013-03-30','10:20:00',3.18),('9650','2013-03-30','10:25:00',3.37),('9650','2013-03-30','10:30:00',3.89),('9650','2013-03-30','10:35:00',3.71),('9650','2013-03-30','10:40:00',1.51),('9650','2013-03-30','10:45:00',2.05),('9650','2013-03-30','10:50:00',3.1),('9650','2013-03-30','10:55:00',1.6),('9650','2013-03-30','11:00:00',1.38),('9650','2013-03-30','11:05:00',1.37),('9650','2013-03-30','11:10:00',2.26),('9650','2013-03-30','11:15:00',2.13),('9650','2013-03-30','11:20:00',1.97),('9650','2013-03-30','11:25:00',2.76),('9650','2013-03-30','11:30:00',2.28),('9650','2013-03-30','11:35:00',2.82),('9650','2013-03-30','11:40:00',2.72),('9650','2013-03-30','11:45:00',2.49),('9650','2013-03-30','11:50:00',2.7),('9650','2013-03-30','11:55:00',2.92),('9650','2013-03-30','12:00:00',2.72),('9650','2013-03-30','12:05:00',2.48),('9650','2013-03-30','12:10:00',2.21),('9650','2013-03-30','12:15:00',2.32),('9650','2013-03-30','12:20:00',2.13),('9650','2013-03-30','12:25:00',2.54),('9650','2013-03-30','12:30:00',3.19),('9650','2013-03-30','12:35:00',4.88),('9650','2013-03-30','12:40:00',5.18),('9650','2013-03-30','12:45:00',3.04),('9650','2013-03-30','12:50:00',3.1),('9650','2013-03-30','12:55:00',3.43),('9650','2013-03-30','13:00:00',4.15),('9650','2013-03-30','13:05:00',3.19),('9650','2013-03-30','13:10:00',4.87),('9650','2013-03-30','13:15:00',4.91),('9650','2013-03-30','13:20:00',5.88),('9650','2013-03-30','13:25:00',3.87),('9650','2013-03-30','13:30:00',1.5),('9650','2013-03-30','13:35:00',1.22),('9650','2013-03-30','13:40:00',2.61),('9650','2013-03-30','13:45:00',3.14),('9650','2013-03-30','13:50:00',3.65),('9650','2013-03-30','13:55:00',2.66),('9650','2013-03-30','14:00:00',3),('9650','2013-03-30','14:05:00',5.01),('9650','2013-03-30','14:10:00',4.1),('9650','2013-03-30','14:15:00',4.87),('9650','2013-03-30','14:20:00',2.74),('9650','2013-03-30','14:25:00',2.79),('9650','2013-03-30','14:30:00',4.49),('9650','2013-03-30','14:35:00',7.5),('9650','2013-03-30','14:40:00',7.69),('9650','2013-03-30','14:45:00',5.68),('9650','2013-03-30','14:50:00',5.51),('9650','2013-03-30','14:55:00',5.11),('9650','2013-03-30','15:00:00',5.41),('9650','2013-03-30','15:05:00',3.65),('9650','2013-03-30','15:10:00',5.61),('9650','2013-03-30','15:15:00',5.47),('9650','2013-03-30','15:20:00',7.14),('9650','2013-03-30','15:25:00',4.51),('9650','2013-03-30','15:30:00',4.29),('9650','2013-03-30','15:35:00',6.17),('9650','2013-03-30','15:40:00',7.35),('9650','2013-03-30','15:45:00',5.08),('9650','2013-03-30','15:50:00',1.79),('9650','2013-03-30','15:55:00',1.49),('9650','2013-03-30','16:00:00',5.03),('9650','2013-03-30','16:05:00',1.94),('9650','2013-03-30','16:10:00',2.64),('9650','2013-03-30','16:15:00',4.06),('9650','2013-03-30','16:20:00',3.1),('9650','2013-03-30','16:25:00',2.27),('9650','2013-03-30','16:30:00',1.87),('9650','2013-03-30','16:35:00',2.05),('9650','2013-03-30','16:40:00',2.31),('9650','2013-03-30','16:45:00',1.88),('9650','2013-03-30','16:50:00',1.65),('9650','2013-03-30','16:55:00',1.48),('9650','2013-03-30','17:00:00',2.22),('9650','2013-03-30','17:05:00',2.89),('9650','2013-03-30','17:10:00',2.3),('9650','2013-03-30','17:15:00',1.49),('9650','2013-03-30','17:20:00',1.95),('9650','2013-03-30','17:25:00',2.15),('9650','2013-03-30','17:30:00',2.43),('9650','2013-03-30','17:35:00',2.24),('9650','2013-03-30','17:40:00',1.77),('9650','2013-03-30','17:45:00',1.91),('9650','2013-03-30','17:50:00',2.09),('9650','2013-03-30','17:55:00',3.61),('9650','2013-03-30','18:00:00',2.07),('9650','2013-03-30','18:15:00',3.51),('9650','2013-03-30','18:20:00',2.38),('9650','2013-03-30','18:50:00',1.2),('9650','2013-03-29','07:50:00',1.02),('9650','2013-03-29','07:55:00',1.37),('9650','2013-03-29','08:00:00',1.21),('9650','2013-03-29','08:05:00',1.12),('9650','2013-03-29','08:10:00',1.2),('9650','2013-03-29','08:15:00',1.47),('9650','2013-03-29','08:20:00',1.41),('9650','2013-03-29','08:25:00',1.61),('9650','2013-03-29','08:30:00',1.74),('9650','2013-03-29','08:35:00',2.04),('9650','2013-03-29','08:40:00',1.91),('9650','2013-03-29','08:45:00',1.42),('9650','2013-03-29','08:50:00',1.55),('9650','2013-03-29','08:55:00',1.25),('9650','2013-03-29','09:00:00',1.5),('9650','2013-03-29','09:05:00',2.69),('9650','2013-03-29','09:10:00',2.87),('9650','2013-03-29','09:16:00',2.94),('9650','2013-03-29','09:20:00',4.98),('9650','2013-03-29','09:25:00',2.91),('9650','2013-03-29','09:30:00',2.12),('9650','2013-03-29','09:35:00',2.29),('9650','2013-03-29','09:40:00',2.32),('9650','2013-03-29','09:45:00',2.15),('9650','2013-03-29','09:50:00',1.55),('9650','2013-03-29','09:55:00',2.02),('9650','2013-03-29','10:00:00',3.04),('9650','2013-03-29','10:05:00',3),('9650','2013-03-29','10:10:00',3.3),('9650','2013-03-29','10:15:00',3),('9650','2013-03-29','10:20:00',2.65),('9650','2013-03-29','10:25:00',2.65),('9650','2013-03-29','10:30:00',3),('9650','2013-03-29','10:35:00',3.47),('9650','2013-03-29','10:40:00',3.96),('9650','2013-03-29','10:45:00',5.06),('9650','2013-03-29','10:50:00',4.69),('9650','2013-03-29','10:55:00',3.67),('9650','2013-03-29','11:00:00',5.05),('9650','2013-03-29','11:05:00',6.09),('9650','2013-03-29','11:10:00',6.61),('9650','2013-03-29','11:15:00',5.4),('9650','2013-03-29','11:20:00',7.17),('9650','2013-03-29','11:25:00',6.61),('9650','2013-03-29','11:30:00',4.19),('9650','2013-03-29','11:35:00',4.74),('9650','2013-03-29','11:40:00',4.46),('9650','2013-03-29','11:45:00',5.3),('9650','2013-03-29','11:50:00',6.08),('9650','2013-03-29','11:55:00',6.79),('9650','2013-03-29','12:00:00',6.36),('9650','2013-03-29','12:05:00',4.25),('9650','2013-03-29','12:10:00',3.52),('9650','2013-03-29','12:15:00',3.4),('9650','2013-03-29','12:20:00',3.19),('9650','2013-03-29','12:25:00',1.92),('9650','2013-03-29','12:30:00',1.71),('9650','2013-03-29','12:35:00',1.7),('9650','2013-03-29','12:45:00',1.22),('9650','2013-03-29','12:50:00',1.17),('9650','2013-03-29','13:05:00',1.03),('9650','2013-03-29','13:10:00',3.03),('9650','2013-03-29','13:15:00',6.49),('9650','2013-03-29','13:20:00',4.2),('9650','2013-03-29','13:25:00',3.34),('9650','2013-03-29','13:30:00',1.87),('9650','2013-03-29','13:35:00',1.26),('9650','2013-03-29','13:40:00',1.64),('9650','2013-03-29','13:45:00',3.56),('9650','2013-03-29','13:50:00',7.34),('9650','2013-03-29','13:55:00',3.02),('9650','2013-03-29','14:00:00',3.8),('9650','2013-03-29','14:05:00',3.5),('9650','2013-03-29','14:10:00',1.92),('9650','2013-03-29','14:15:00',1.67),('9650','2013-03-29','14:20:00',3.2),('9650','2013-03-29','14:25:00',2.36),('9650','2013-03-29','14:30:00',3.38),('9650','2013-03-29','14:35:00',3.62),('9650','2013-03-29','14:40:00',2.14),('9650','2013-03-29','14:45:00',1.79),('9650','2013-03-29','14:50:00',2.49),('9650','2013-03-29','14:55:00',1.59),('9650','2013-03-29','15:00:00',1.2),('9650','2013-03-29','15:20:00',1.5),('9650','2013-03-29','15:25:00',1.72),('9650','2013-03-29','15:30:00',1.5),('9650','2013-03-29','15:35:00',1.1),('9650','2013-03-29','15:40:00',1.31),('9650','2013-03-29','15:45:00',1.19),('9650','2013-03-29','15:50:00',1.27),('9650','2013-03-29','15:55:00',1.08),('9650','2013-03-28','07:55:00',1.17),('9650','2013-03-28','08:00:00',1.34),('9650','2013-03-28','08:05:00',1.15),('9650','2013-03-28','08:10:00',1.17),('9650','2013-03-28','08:15:00',1.12),('9650','2013-03-28','08:20:00',1.21),('9650','2013-03-28','08:25:00',1.33),('9650','2013-03-28','08:30:00',1.47),('9650','2013-03-28','08:35:00',1.64),('9650','2013-03-28','08:40:00',1.78),('9650','2013-03-28','08:45:00',1.85),('9650','2013-03-28','08:50:00',1.96),('9650','2013-03-28','08:55:00',1.89),('9650','2013-03-28','09:00:00',2.03),('9650','2013-03-28','09:05:00',2.35),('9650','2013-03-28','09:10:00',2.43),('9650','2013-03-28','09:15:00',2.9),('9650','2013-03-28','09:20:00',3.15),('9650','2013-03-28','09:25:00',3.08),('9650','2013-03-28','09:30:00',3.85),('9650','2013-03-28','09:35:00',4.02),('9650','2013-03-28','09:40:00',4.15),('9650','2013-03-28','09:45:00',3.68),('9650','2013-03-28','09:50:00',3.95),('9650','2013-03-28','09:55:00',4.1),('9650','2013-03-28','10:00:00',4.24),('9650','2013-03-28','10:05:00',4.22),('9650','2013-03-28','10:10:00',3.74),('9650','2013-03-28','10:15:00',4.44),('9650','2013-03-28','10:20:00',4.22),('9650','2013-03-28','10:25:00',4.03),('9650','2013-03-28','10:30:00',4.38),('9650','2013-03-28','10:35:00',3.42),('9650','2013-03-28','10:40:00',4.65),('9650','2013-03-28','10:45:00',4.17),('9650','2013-03-28','10:50:00',4.02),('9650','2013-03-28','10:55:00',4.56),('9650','2013-03-28','11:00:00',5.37),('9650','2013-03-28','11:05:00',5.32),('9650','2013-03-28','11:10:00',4.87),('9650','2013-03-28','11:15:00',2.5),('9650','2013-03-28','11:20:00',5.14),('9650','2013-03-28','11:25:00',6.25),('9650','2013-03-28','11:30:00',5.99),('9650','2013-03-28','11:35:00',5.76),('9650','2013-03-28','11:40:00',5.84),('9650','2013-03-28','11:45:00',5.91),('9650','2013-03-28','11:50:00',6.06),('9650','2013-03-28','11:55:00',6.12),('9650','2013-03-28','12:00:00',6.18),('9650','2013-03-28','12:05:00',6.37),('9650','2013-03-28','12:10:00',6.36),('9650','2013-03-28','12:15:00',5.91),('9650','2013-03-28','12:20:00',6.42),('9650','2013-03-28','12:25:00',6.08),('9650','2013-03-28','12:30:00',5.96),('9650','2013-03-28','12:35:00',6.23),('9650','2013-03-28','12:40:00',6.24),('9650','2013-03-28','12:45:00',5.61),('9650','2013-03-28','12:50:00',6.47),('9650','2013-03-28','12:55:00',5.45),('9650','2013-03-28','13:00:00',6.5),('9650','2013-03-28','13:05:00',5.54),('9650','2013-03-28','13:10:00',6.38),('9650','2013-03-28','13:15:00',5.55),('9650','2013-03-28','13:20:00',5.66),('9650','2013-03-28','13:25:00',6.81),('9650','2013-03-28','13:30:00',6.28),('9650','2013-03-28','13:35:00',5.75),('9650','2013-03-28','13:40:00',5.71),('9650','2013-03-28','13:45:00',6.04),('9650','2013-03-28','13:50:00',5.72),('9650','2013-03-28','13:55:00',6),('9650','2013-03-28','14:00:00',6.37),('9650','2013-03-28','14:05:00',5.15),('9650','2013-03-28','14:10:00',4.25),('9650','2013-03-28','14:15:00',4.23),('9650','2013-03-28','14:20:00',4.24),('9650','2013-03-28','14:25:00',4.37),('9650','2013-03-28','14:30:00',3.74),('9650','2013-03-28','14:35:00',3.7),('9650','2013-03-28','14:40:00',3.59),('9650','2013-03-28','14:45:00',3.31),('9650','2013-03-28','14:50:00',3.2),('9650','2013-03-28','14:55:00',3.1),('9650','2013-03-28','15:00:00',2.78),('9650','2013-03-28','15:05:00',2.83),('9650','2013-03-28','15:10:00',2.69),('9650','2013-03-28','15:15:00',2.66),('9650','2013-03-28','15:20:00',2.47),('9650','2013-03-28','15:25:00',2.21),('9650','2013-03-28','15:30:00',2.05),('9650','2013-03-28','15:35:00',1.95),('9650','2013-03-28','15:40:00',1.88),('9650','2013-03-28','15:45:00',1.86),('9650','2013-03-28','15:50:00',2.07),('9650','2013-03-28','15:55:00',2.42),('9650','2013-03-28','16:00:00',3.13),('9650','2013-03-28','16:05:00',2.92),('9650','2013-03-28','16:10:00',2.06),('9650','2013-03-28','16:15:00',1.86),('9650','2013-03-28','16:20:00',1.7),('9650','2013-03-28','16:25:00',2),('9650','2013-03-28','16:30:00',2.2),('9650','2013-03-28','16:35:00',2.38),('9650','2013-03-28','16:40:00',4.51),('9650','2013-03-28','16:45:00',3.64),('9650','2013-03-28','16:50:00',2.5),('9650','2013-03-28','16:55:00',2.03),('9650','2013-03-28','17:00:00',2.66),('9650','2013-03-28','17:05:00',1.98),('9650','2013-03-28','17:10:00',1.3),('9650','2013-03-28','17:15:00',1.35),('9650','2013-03-28','17:20:00',2.69),('9650','2013-03-28','17:25:00',2.78),('9650','2013-03-28','17:30:00',2.29),('9650','2013-03-28','17:35:00',1.68),('9650','2013-03-27','08:50:00',1.01),('9650','2013-03-27','08:55:00',1.16),('9650','2013-03-27','09:00:00',1.14),('9650','2013-03-27','09:05:00',1.45),('9650','2013-03-27','09:10:00',2.38),('9650','2013-03-27','09:15:00',3.76),('9650','2013-03-27','09:20:00',2.51),('9650','2013-03-27','09:25:00',2.54),('9650','2013-03-27','09:30:00',2.01),('9650','2013-03-27','09:35:00',1.74),('9650','2013-03-27','09:40:00',1.57),('9650','2013-03-27','09:45:00',1.87),('9650','2013-03-27','09:50:00',1.84),('9650','2013-03-27','09:55:00',1.78),('9650','2013-03-27','10:00:00',1.96),('9650','2013-03-27','10:05:00',1.71),('9650','2013-03-27','10:10:00',1.23),('9650','2013-03-27','10:15:00',1.17),('9650','2013-03-27','10:25:00',1.05),('9650','2013-03-27','10:30:00',1.09),('9650','2013-03-27','10:35:00',1.02),('9650','2013-03-27','10:55:00',1.07),('9650','2013-03-27','11:00:00',1.68),('9650','2013-03-27','11:05:00',1.24),('9650','2013-03-27','11:10:00',1.11),('9650','2013-03-27','11:25:00',1.04),('9650','2013-03-27','11:30:00',1.45),('9650','2013-03-27','11:35:00',1.87),('9650','2013-03-27','11:40:00',2.68),('9650','2013-03-27','11:45:00',2.11),('9650','2013-03-27','11:50:00',1.87),('9650','2013-03-27','11:55:00',3.62),('9650','2013-03-27','12:00:00',2.43),('9650','2013-03-27','12:05:00',1.6),('9650','2013-03-27','12:10:00',1.64),('9650','2013-03-27','12:15:00',2.01),('9650','2013-03-27','12:20:00',1.78),('9650','2013-03-27','12:25:00',1.45),('9650','2013-03-27','12:30:00',1.99),('9650','2013-03-27','12:35:00',1.56),('9650','2013-03-27','12:40:00',2.31),('9650','2013-03-27','12:45:00',2.9),('9650','2013-03-27','12:50:00',4.99),('9650','2013-03-27','12:55:00',5.69),('9650','2013-03-27','13:00:00',5.73),('9650','2013-03-27','13:05:00',8.11),('9650','2013-03-27','13:10:00',6.41),('9650','2013-03-27','13:15:00',6.23),('9650','2013-03-27','13:20:00',4.37),('9650','2013-03-27','13:25:00',3.81),('9650','2013-03-27','13:30:00',4.89),('9650','2013-03-27','13:35:00',5.07),('9650','2013-03-27','13:40:00',4.33),('9650','2013-03-27','13:45:00',4.4),('9650','2013-03-27','13:50:00',5.22),('9650','2013-03-27','13:55:00',2.93),('9650','2013-03-27','14:00:00',3.16),('9650','2013-03-27','14:05:00',3.94),('9650','2013-03-27','14:10:00',2.31),('9650','2013-03-27','14:15:00',2.4),('9650','2013-03-27','14:20:00',2.9),('9650','2013-03-27','14:25:00',2.55),('9650','2013-03-27','14:30:00',3.92),('9650','2013-03-27','14:35:00',2.86),('9650','2013-03-27','14:40:00',1.86),('9650','2013-03-27','14:45:00',1.93),('9650','2013-03-27','14:50:00',1.73),('9650','2013-03-27','14:55:00',1.49),('9650','2013-03-27','15:00:00',2.12),('9650','2013-03-27','15:05:00',2.43),('9650','2013-03-27','15:10:00',4.7),('9650','2013-03-27','15:15:00',3.49),('9650','2013-03-27','15:20:00',3.55),('9650','2013-03-27','15:25:00',1.93),('9650','2013-03-27','15:30:00',2.52),('9650','2013-03-27','15:35:00',4.11),('9650','2013-03-27','15:40:00',3.23),('9650','2013-03-27','15:45:00',3.95),('9650','2013-03-27','15:50:00',2.74),('9650','2013-03-27','15:55:00',5.35),('9650','2013-03-27','16:00:00',2.33),('9650','2013-03-27','16:05:00',1.78),('9650','2013-03-27','16:10:00',3.3),('9650','2013-03-27','16:15:00',1.12),('9650','2013-03-27','16:25:00',1.1),('9650','2013-03-27','16:30:00',1.45),('9650','2013-03-27','16:35:00',3.71),('9650','2013-03-27','16:40:00',2.47),('9650','2013-03-27','16:45:00',2.44),('9650','2013-03-27','16:50:00',1.4),('9650','2013-03-27','16:55:00',1.72),('9650','2013-03-27','17:00:00',3.59),('9650','2013-03-27','17:05:00',3.25),('9650','2013-03-27','17:10:00',3.01),('9650','2013-03-27','17:15:00',2.67),('9650','2013-03-27','17:20:00',2.34),('9650','2013-03-27','17:25:00',1.93),('9650','2013-03-27','17:30:00',1.31),('9650','2013-03-27','17:35:00',1),('9650','2013-03-26','07:55:00',1.76),('9650','2013-03-26','08:00:00',1.79),('9650','2013-03-26','08:05:00',1.7),('9650','2013-03-26','08:10:00',1.73),('9650','2013-03-26','08:15:00',1.94),('9650','2013-03-26','08:20:00',1.77),('9650','2013-03-26','08:25:00',1.81),('9650','2013-03-26','08:30:00',2.01),('9650','2013-03-26','08:35:00',1.92),('9650','2013-03-26','08:40:00',1.69),('9650','2013-03-26','08:45:00',1.6),('9650','2013-03-26','08:50:00',2.1),('9650','2013-03-26','08:55:00',1.96),('9650','2013-03-26','09:00:00',2.13),('9650','2013-03-26','09:05:00',1.67),('9650','2013-03-26','09:10:00',1.05),('9650','2013-03-26','09:15:00',2.01),('9650','2013-03-26','09:20:00',2.01),('9650','2013-03-26','09:25:00',1.41),('9650','2013-03-26','09:30:00',1.29),('9650','2013-03-26','09:35:00',1.18),('9650','2013-03-26','09:40:00',1.52),('9650','2013-03-26','09:45:00',2.34),('9650','2013-03-26','09:50:00',2.69),('9650','2013-03-26','09:55:00',2.25),('9650','2013-03-26','10:00:00',2.01),('9650','2013-03-26','10:05:00',1.37),('9650','2013-03-26','10:10:00',1.97),('9650','2013-03-26','10:15:00',2.67),('9650','2013-03-26','10:20:00',2.23),('9650','2013-03-26','10:25:00',3.02),('9650','2013-03-26','10:30:00',3.72),('9650','2013-03-26','10:35:00',3.22),('9650','2013-03-26','10:40:00',3.67),('9650','2013-03-26','10:45:00',3.51),('9650','2013-03-26','10:50:00',3.79),('9650','2013-03-26','10:55:00',3.53),('9650','2013-03-26','11:00:00',3.11),('9650','2013-03-26','11:05:00',2.75),('9650','2013-03-26','11:10:00',2.87),('9650','2013-03-26','11:15:00',3.04),('9650','2013-03-26','11:20:00',3.1),('9650','2013-03-26','11:25:00',2.87),('9650','2013-03-26','11:30:00',3.19),('9650','2013-03-26','11:35:00',3.07),('9650','2013-03-26','11:40:00',2.83),('9650','2013-03-26','11:45:00',3.03),('9650','2013-03-26','11:50:00',2.94),('9650','2013-03-26','11:55:00',4.28),('9650','2013-03-26','12:00:00',4.4),('9650','2013-03-26','12:05:00',4.13),('9650','2013-03-26','12:10:00',3.62),('9650','2013-03-26','12:15:00',2.8),('9650','2013-03-26','12:20:00',3.01),('9650','2013-03-26','12:25:00',2.82),('9650','2013-03-26','12:30:00',6.11),('9650','2013-03-26','12:35:00',7.5),('9650','2013-03-26','12:40:00',6.14),('9650','2013-03-26','12:45:00',6.57),('9650','2013-03-26','12:50:00',5.09),('9650','2013-03-26','12:55:00',3.01),('9650','2013-03-26','13:00:00',2.6),('9650','2013-03-26','13:05:00',2.69),('9650','2013-03-26','13:10:00',3.77),('9650','2013-03-26','13:15:00',2.9),('9650','2013-03-26','13:20:00',2.24),('9650','2013-03-26','13:25:00',2.37),('9650','2013-03-26','13:30:00',2.95),('9650','2013-03-26','13:35:00',3.81),('9650','2013-03-26','13:40:00',2.92),('9650','2013-03-26','13:45:00',3.46),('9650','2013-03-26','13:50:00',3.91),('9650','2013-03-26','13:55:00',3.45),('9650','2013-03-26','14:00:00',3),('9650','2013-03-26','14:05:00',2.65),('9650','2013-03-26','14:10:00',2.74),('9650','2013-03-26','14:15:00',3.13),('9650','2013-03-26','14:20:00',3.87),('9650','2013-03-26','14:25:00',3.08),('9650','2013-03-26','14:30:00',2.59),('9650','2013-03-26','14:35:00',3.02),('9650','2013-03-26','14:40:00',4.34),('9650','2013-03-26','14:45:00',3.93),('9650','2013-03-26','14:50:00',2.92),('9650','2013-03-26','14:55:00',2.18),('9650','2013-03-26','15:00:00',1.84),('9650','2013-03-26','15:05:00',2.37),('9650','2013-03-26','15:10:00',2.43),('9650','2013-03-26','15:15:00',1.83),('9650','2013-03-26','15:20:00',1.82),('9650','2013-03-26','15:25:00',1.9),('9650','2013-03-26','15:30:00',1.68),('9650','2013-03-26','15:35:00',1.52),('9650','2013-03-26','15:40:00',1.32),('9650','2013-03-26','15:55:00',1.05),('9650','2013-03-26','16:00:00',1.15),('9650','2013-03-26','16:05:00',1.44),('9650','2013-03-26','16:10:00',1.64),('9650','2013-03-26','16:15:00',1.56),('9650','2013-03-26','16:20:00',1.53),('9650','2013-03-26','16:25:00',1.64),('9650','2013-03-26','16:30:00',1.65),('9650','2013-03-26','16:35:00',1.69),('9650','2013-03-26','16:40:00',2.08),('9650','2013-03-26','16:45:00',2.51),('9650','2013-03-26','16:50:00',2.17),('9650','2013-03-26','16:55:00',2.63),('9650','2013-03-26','17:00:00',2.73),('9650','2013-03-26','17:05:00',3.55),('9650','2013-03-26','17:10:00',2.78),('9650','2013-03-26','17:15:00',1.79),('9650','2013-03-25','07:40:00',1.19),('9650','2013-03-25','07:45:00',1.41),('9650','2013-03-25','07:50:00',1.7),('9650','2013-03-25','07:55:00',1.52),('9650','2013-03-25','08:00:00',1.16),('9650','2013-03-25','08:10:00',1.09),('9650','2013-03-25','08:15:00',1.16),('9650','2013-03-25','08:20:00',1.16),('9650','2013-03-25','08:25:00',1.2),('9650','2013-03-25','08:30:00',1.65),('9650','2013-03-25','08:35:00',2.19),('9650','2013-03-25','08:40:00',2.33),('9650','2013-03-25','08:45:00',1.38),('9650','2013-03-25','08:50:00',1.24),('9650','2013-03-25','08:55:00',1.17),('9650','2013-03-25','09:00:00',1.08),('9650','2013-03-25','09:05:00',1.37),('9650','2013-03-25','09:10:00',1.93),('9650','2013-03-25','09:15:00',2.63),('9650','2013-03-25','09:20:00',1.7),('9650','2013-03-25','09:25:00',1.06),('9650','2013-03-25','09:50:00',2.01),('9650','2013-03-25','09:55:00',3.77),('9650','2013-03-25','10:00:00',1.92),('9650','2013-03-25','10:10:00',1.09),('9650','2013-03-25','10:40:00',1.02),('9650','2013-03-25','10:45:00',1.04),('9650','2013-03-25','10:50:00',1.55),('9650','2013-03-25','10:55:00',1.72),('9650','2013-03-25','11:00:00',2.07),('9650','2013-03-25','11:05:00',1.9),('9650','2013-03-25','11:10:00',3.63),('9650','2013-03-25','11:15:00',2.47),('9650','2013-03-25','11:20:00',2.54),('9650','2013-03-25','11:25:00',1.36),('9650','2013-03-25','11:45:00',1.68),('9650','2013-03-25','11:50:00',3.38),('9650','2013-03-25','11:55:00',1.81),('9650','2013-03-25','12:00:00',2.35),('9650','2013-03-25','12:05:00',2.19),('9650','2013-03-25','12:10:00',2.45),('9650','2013-03-25','12:15:00',2.59),('9650','2013-03-25','12:20:00',2.83),('9650','2013-03-25','12:25:00',3.91),('9650','2013-03-25','12:30:00',3.44),('9650','2013-03-25','12:35:00',5.02),('9650','2013-03-25','12:40:00',3.02),('9650','2013-03-25','12:45:00',4.26),('9650','2013-03-25','12:50:00',3.06),('9650','2013-03-25','12:55:00',1.93),('9650','2013-03-25','13:00:00',3.04),('9650','2013-03-25','13:05:00',4.17),('9650','2013-03-25','13:10:00',4.42),('9650','2013-03-25','13:15:00',3.14),('9650','2013-03-25','13:20:00',3.22),('9650','2013-03-25','13:25:00',3.7),('9650','2013-03-25','13:30:00',2.89),('9650','2013-03-25','13:35:00',3.68),('9650','2013-03-25','13:40:00',4.04),('9650','2013-03-25','13:45:00',3.6),('9650','2013-03-25','13:50:00',3.06),('9650','2013-03-25','13:55:00',2.77),('9650','2013-03-25','14:00:00',2.73),('9650','2013-03-25','14:05:00',2.72),('9650','2013-03-25','14:10:00',2.9),('9650','2013-03-25','14:15:00',2.66),('9650','2013-03-25','14:20:00',2.23),('9650','2013-03-25','14:25:00',2.08),('9650','2013-03-25','14:30:00',1.69),('9650','2013-03-25','14:35:00',1.56),('9650','2013-03-25','14:40:00',1.61),('9650','2013-03-25','14:45:00',1.66),('9650','2013-03-25','14:50:00',1.52),('9650','2013-03-25','14:55:00',1.49),('9650','2013-03-25','15:00:00',1.46),('9650','2013-03-25','15:05:00',1.57),('9650','2013-03-25','15:10:00',1.52),('9650','2013-03-25','15:15:00',1.36),('9650','2013-03-25','15:20:00',1.48),('9650','2013-03-25','15:25:00',1.47),('9650','2013-03-25','15:30:00',1.61),('9650','2013-03-25','15:35:00',1.72),('9650','2013-03-25','15:40:00',1.43),('9650','2013-03-24','08:15:00',1.34),('9650','2013-03-24','08:20:00',1.47),('9650','2013-03-24','08:25:00',1.59),('9650','2013-03-24','08:30:00',1.55),('9650','2013-03-24','08:40:00',1.26),('9650','2013-03-24','08:45:00',1.4),('9650','2013-03-24','08:50:00',1.65),('9650','2013-03-24','08:55:00',2.06),('9650','2013-03-24','09:00:00',1.91),('9650','2013-03-24','09:05:00',1.9),('9650','2013-03-24','09:10:00',2.17),('9650','2013-03-24','09:15:00',1.87),('9650','2013-03-24','09:20:00',3.2),('9650','2013-03-24','09:25:00',3.57),('9650','2013-03-24','09:30:00',2.45),('9650','2013-03-24','09:35:00',1.84),('9650','2013-03-24','09:40:00',1.31),('9650','2013-03-24','09:45:00',1.58),('9650','2013-03-24','09:50:00',5.46),('9650','2013-03-24','09:55:00',4.84),('9650','2013-03-24','10:00:00',1.97),('9650','2013-03-24','10:05:00',1.73),('9650','2013-03-24','10:10:00',1.99),('9650','2013-03-24','10:15:00',1.77),('9650','2013-03-24','10:20:00',2.4),('9650','2013-03-24','10:25:00',3.66),('9650','2013-03-24','10:30:00',3.36),('9650','2013-03-24','10:35:00',2.58),('9650','2013-03-24','10:40:00',2.75),('9650','2013-03-24','10:45:00',4.16),('9650','2013-03-24','10:50:00',4.42),('9650','2013-03-24','10:55:00',4.93),('9650','2013-03-24','11:00:00',3.89),('9650','2013-03-24','11:05:00',3.48),('9650','2013-03-24','11:10:00',3.75),('9650','2013-03-24','11:15:00',4.08),('9650','2013-03-24','11:20:00',6.18),('9650','2013-03-24','11:25:00',5.69),('9650','2013-03-24','11:30:00',7.01),('9650','2013-03-24','11:35:00',4.72),('9650','2013-03-24','11:40:00',2.19),('9650','2013-03-24','11:45:00',2.66),('9650','2013-03-24','11:50:00',2.98),('9650','2013-03-24','11:55:00',5.25),('9650','2013-03-24','12:00:00',6.08),('9650','2013-03-24','12:05:00',7.14),('9650','2013-03-24','12:10:00',6.33),('9650','2013-03-24','12:15:00',5.59),('9650','2013-03-24','12:20:00',4.71),('9650','2013-03-24','12:25:00',6.53),('9650','2013-03-24','12:30:00',5.28),('9650','2013-03-24','12:35:00',4.76),('9650','2013-03-24','12:40:00',4.28),('9650','2013-03-24','12:45:00',3.99),('9650','2013-03-24','12:50:00',4.64),('9650','2013-03-24','12:55:00',5.35),('9650','2013-03-24','13:00:00',5.26),('9650','2013-03-24','13:05:00',7.66),('9650','2013-03-24','13:10:00',7.33),('9650','2013-03-24','13:15:00',7.45),('9650','2013-03-24','13:20:00',6.55),('9650','2013-03-24','13:25:00',2.89),('9650','2013-03-24','13:30:00',3.3),('9650','2013-03-24','13:35:00',1.96),('9650','2013-03-24','13:40:00',2.1),('9650','2013-03-24','13:45:00',3.92),('9650','2013-03-24','13:50:00',3.45),('9650','2013-03-24','13:55:00',3.24),('9650','2013-03-24','14:00:00',1.66),('9650','2013-03-24','14:05:00',2.15),('9650','2013-03-24','14:10:00',5.96),('9650','2013-03-24','14:15:00',3.09),('9650','2013-03-24','14:20:00',3.98),('9650','2013-03-24','14:25:00',6.32),('9650','2013-03-24','14:30:00',4.39),('9650','2013-03-24','14:35:00',3.21),('9650','2013-03-24','14:40:00',2.44),('9650','2013-03-24','14:45:00',3.68),('9650','2013-03-24','14:50:00',3.09),('9650','2013-03-24','14:55:00',5.3),('9650','2013-03-24','15:00:00',5.17),('9650','2013-03-24','15:05:00',4.85),('9650','2013-03-24','15:10:00',5.65),('9650','2013-03-24','15:15:00',4.48),('9650','2013-03-24','15:20:00',3.86),('9650','2013-03-24','15:25:00',5.08),('9650','2013-03-24','15:30:00',5.03),('9650','2013-03-24','15:35:00',3.81),('9650','2013-03-24','15:40:00',5.61),('9650','2013-03-24','15:45:00',4.36),('9650','2013-03-24','15:50:00',2.51),('9650','2013-03-24','15:55:00',3.45),('9650','2013-03-24','16:00:00',4.44),('9650','2013-03-24','16:05:00',1.93),('9650','2013-03-24','16:10:00',2.74),('9650','2013-03-24','16:15:00',1.79),('9650','2013-03-24','16:20:00',1.38),('9650','2013-03-24','16:25:00',1),('9650','2013-03-24','16:30:00',2.88),('9650','2013-03-24','16:35:00',4.54),('9650','2013-03-24','16:40:00',3.96),('9650','2013-03-24','16:45:00',2.04),('9650','2013-03-24','16:50:00',1.55),('9650','2013-03-23','08:15:00',1.05),('9650','2013-03-23','08:20:00',1.13),('9650','2013-03-23','08:25:00',1.22),('9650','2013-03-23','08:30:00',1.27),('9650','2013-03-23','08:35:00',1.32),('9650','2013-03-23','08:40:00',1.39),('9650','2013-03-23','08:45:00',1.62),('9650','2013-03-23','08:50:00',1.72),('9650','2013-03-23','08:55:00',1.85),('9650','2013-03-23','09:00:00',1.97),('9650','2013-03-23','09:05:00',2.11),('9650','2013-03-23','09:10:00',2.25),('9650','2013-03-23','09:15:00',2.37),('9650','2013-03-23','09:20:00',2.5),('9650','2013-03-23','09:25:00',2.64),('9650','2013-03-23','09:30:00',2.76),('9650','2013-03-23','09:35:00',2.88),('9650','2013-03-23','09:40:00',3.01),('9650','2013-03-23','09:45:00',3.14),('9650','2013-03-23','09:50:00',3.26),('9650','2013-03-23','09:55:00',3.37),('9650','2013-03-23','10:00:00',3.51),('9650','2013-03-23','10:05:00',3.63),('9650','2013-03-23','10:10:00',3.75),('9650','2013-03-23','10:15:00',3.84),('9650','2013-03-23','10:20:00',3.95),('9650','2013-03-23','10:25:00',4.07),('9650','2013-03-23','10:30:00',4.17),('9650','2013-03-23','10:35:00',4.25),('9650','2013-03-23','10:40:00',4.35),('9650','2013-03-23','10:45:00',4.45),('9650','2013-03-23','10:50:00',4.53),('9650','2013-03-23','10:55:00',4.62),('9650','2013-03-23','11:00:00',4.7),('9650','2013-03-23','11:05:00',4.81),('9650','2013-03-23','11:10:00',4.88),('9650','2013-03-23','11:15:00',4.94),('9650','2013-03-23','11:20:00',5.03),('9650','2013-03-23','11:25:00',5.09),('9650','2013-03-23','11:30:00',5.15),('9650','2013-03-23','11:35:00',5.22),('9650','2013-03-23','11:40:00',5.3),('9650','2013-03-23','11:45:00',5.33),('9650','2013-03-23','11:50:00',5.4),('9650','2013-03-23','11:55:00',5.41),('9650','2013-03-23','12:00:00',5.47),('9650','2013-03-23','12:05:00',5.57),('9650','2013-03-23','12:10:00',5.66),('9650','2013-03-23','12:15:00',5.7),('9650','2013-03-23','12:20:00',5.8),('9650','2013-03-23','12:25:00',5.84),('9650','2013-03-23','12:30:00',5.9),('9650','2013-03-23','12:35:00',5.93),('9650','2013-03-23','12:40:00',5.95),('9650','2013-03-23','12:45:00',6.01),('9650','2013-03-23','12:50:00',6),('9650','2013-03-23','12:55:00',6.02),('9650','2013-03-23','13:00:00',6.02),('9650','2013-03-23','13:05:00',6.05),('9650','2013-03-23','13:10:00',6.08),('9650','2013-03-23','13:15:00',6.09),('9650','2013-03-23','13:20:00',6.13),('9650','2013-03-23','13:25:00',6.01),('9650','2013-03-23','13:30:00',6.11),('9650','2013-03-23','13:35:00',6.1),('9650','2013-03-23','13:40:00',6.11),('9650','2013-03-23','13:45:00',6.12),('9650','2013-03-23','13:50:00',6.08),('9650','2013-03-23','13:55:00',5.97),('9650','2013-03-23','14:00:00',5.91),('9650','2013-03-23','14:05:00',5.88),('9650','2013-03-23','14:10:00',5.72),('9650','2013-03-23','14:15:00',5.64),('9650','2013-03-23','14:20:00',5.55),('9650','2013-03-23','14:25:00',5.44),('9650','2013-03-23','14:30:00',5.38),('9650','2013-03-23','14:35:00',5.24),('9650','2013-03-23','14:40:00',5.21),('9650','2013-03-23','14:45:00',5.18),('9650','2013-03-23','14:50:00',4.93),('9650','2013-03-23','14:55:00',4.89),('9650','2013-03-23','15:00:00',4.67),('9650','2013-03-23','15:05:00',4.54),('9650','2013-03-23','15:10:00',4.27),('9650','2013-03-23','15:15:00',4.66),('9650','2013-03-23','15:20:00',4.66),('9650','2013-03-23','15:25:00',4.38),('9650','2013-03-23','15:30:00',4.04),('9650','2013-03-23','15:35:00',3.98),('9650','2013-03-23','15:40:00',3.98),('9650','2013-03-23','15:45:00',3.42),('9650','2013-03-23','15:50:00',2.33),('9650','2013-03-23','15:55:00',2.29),('9650','2013-03-23','16:00:00',2.24),('9650','2013-03-23','16:05:00',2.71),('9650','2013-03-23','16:10:00',1.99),('9650','2013-03-23','16:15:00',2.91),('9650','2013-03-23','16:20:00',2.36),('9650','2013-03-23','16:25:00',2.05),('9650','2013-03-23','16:30:00',2.44),('9650','2013-03-23','16:35:00',2.08),('9650','2013-03-23','16:40:00',1.66),('9650','2013-03-23','16:45:00',1.62),('9650','2013-03-23','16:50:00',1.25),('9650','2013-03-22','08:20:00',1.01),('9650','2013-03-22','08:25:00',1.11),('9650','2013-03-22','08:30:00',1.2),('9650','2013-03-22','08:35:00',1.32),('9650','2013-03-22','08:40:00',1.47),('9650','2013-03-22','08:45:00',1.59),('9650','2013-03-22','08:50:00',1.71),('9650','2013-03-22','08:55:00',1.9),('9650','2013-03-22','09:00:00',2.04),('9650','2013-03-22','09:05:00',2.18),('9650','2013-03-22','09:10:00',2.28),('9650','2013-03-22','09:15:00',2.41),('9650','2013-03-22','09:20:00',2.52),('9650','2013-03-22','09:25:00',2.69),('9650','2013-03-22','09:30:00',2.86),('9650','2013-03-22','09:35:00',2.96),('9650','2013-03-22','09:40:00',2.96),('9650','2013-03-22','09:45:00',3.19),('9650','2013-03-22','09:50:00',3.31),('9650','2013-03-22','09:55:00',3.51),('9650','2013-03-22','10:00:00',3.6),('9650','2013-03-22','10:05:00',3.38),('9650','2013-03-22','10:10:00',3.46),('9650','2013-03-22','10:15:00',3.98),('9650','2013-03-22','10:20:00',4.09),('9650','2013-03-22','10:25:00',4.15),('9650','2013-03-22','10:30:00',4.43),('9650','2013-03-22','10:35:00',4.58),('9650','2013-03-22','10:40:00',4.64),('9650','2013-03-22','10:45:00',4.66),('9650','2013-03-22','10:50:00',4.75),('9650','2013-03-22','10:55:00',4.64),('9650','2013-03-22','11:00:00',4.61),('9650','2013-03-22','11:05:00',4.4),('9650','2013-03-22','11:10:00',3.88),('9650','2013-03-22','11:15:00',4.38),('9650','2013-03-22','11:20:00',4.65),('9650','2013-03-22','11:25:00',4.86),('9650','2013-03-22','11:30:00',4.91),('9650','2013-03-22','11:35:00',5.26),('9650','2013-03-22','11:40:00',5.31),('9650','2013-03-22','11:45:00',5.35),('9650','2013-03-22','11:50:00',5.17),('9650','2013-03-22','11:55:00',5.44),('9650','2013-03-22','12:00:00',5.59),('9650','2013-03-22','12:05:00',5.56),('9650','2013-03-22','12:10:00',5.61),('9650','2013-03-22','12:15:00',5.91),('9650','2013-03-22','12:20:00',5.99),('9650','2013-03-22','12:25:00',5.88),('9650','2013-03-22','12:30:00',6.01),('9650','2013-03-22','12:35:00',5.92),('9650','2013-03-22','12:40:00',5.78),('9650','2013-03-22','12:45:00',5.98),('9650','2013-03-22','12:50:00',6.09),('9650','2013-03-22','12:55:00',5.96),('9650','2013-03-22','13:00:00',4.87),('9650','2013-03-22','13:05:00',6.08),('9650','2013-03-22','13:10:00',6.14),('9650','2013-03-22','13:15:00',5.96),('9650','2013-03-22','13:20:00',6.2),('9650','2013-03-22','13:25:00',5.81),('9650','2013-03-22','13:30:00',5.67),('9650','2013-03-22','13:35:00',5.94),('9650','2013-03-22','13:40:00',6.04),('9650','2013-03-22','13:45:00',6.01),('9650','2013-03-22','13:50:00',6.16),('9650','2013-03-22','13:55:00',5.9),('9650','2013-03-22','14:00:00',5.86),('9650','2013-03-22','14:05:00',5.75),('9650','2013-03-22','14:10:00',5.62),('9650','2013-03-22','14:15:00',5.45),('9650','2013-03-22','14:20:00',5.55),('9650','2013-03-22','14:25:00',5.54),('9650','2013-03-22','14:30:00',5.59),('9650','2013-03-22','14:35:00',5.5),('9650','2013-03-22','14:40:00',5.37),('9650','2013-03-22','14:45:00',5.08),('9650','2013-03-22','14:50:00',5),('9650','2013-03-22','14:55:00',4.96),('9650','2013-03-22','15:00:00',4.81),('9650','2013-03-22','15:05:00',4.52),('9650','2013-03-22','15:10:00',4.77),('9650','2013-03-22','15:15:00',4.54),('9650','2013-03-22','15:20:00',4.62),('9650','2013-03-22','15:25:00',4.59),('9650','2013-03-22','15:30:00',4.18),('9650','2013-03-22','15:35:00',4.17),('9650','2013-03-22','15:40:00',4.03),('9650','2013-03-22','15:45:00',3.78),('9650','2013-03-22','15:50:00',3.61),('9650','2013-03-22','15:55:00',3.64),('9650','2013-03-22','16:00:00',3.45),('9650','2013-03-22','16:05:00',3.17),('9650','2013-03-22','16:10:00',3.99),('9650','2013-03-22','16:15:00',3.62),('9650','2013-03-22','16:20:00',3.08),('9650','2013-03-22','16:25:00',3.24),('9650','2013-03-22','16:30:00',2.55),('9650','2013-03-22','16:35:00',2.91),('9650','2013-03-22','16:40:00',2.52),('9650','2013-03-22','16:45:00',2.57),('9650','2013-03-22','16:50:00',2.17),('9650','2013-03-22','16:55:00',2.21),('9650','2013-03-22','17:00:00',2.7),('9650','2013-03-22','17:05:00',2.87),('9650','2013-03-22','17:10:00',2.55),('9650','2013-03-22','17:15:00',2.13),('9650','2013-03-22','17:20:00',1.99),('9650','2013-03-22','17:25:00',1.87),('9650','2013-03-22','17:30:00',1.63),('9650','2013-03-22','17:35:00',1.19),('9650','2013-03-22','17:40:00',1.24),('9650','2014-03-25','08:15:00',1.05),('9650','2014-03-25','08:20:00',1.59),('9650','2014-03-25','08:25:00',1.78),('9650','2014-03-25','08:30:00',1.78),('9650','2014-03-25','08:35:00',1.54),('9650','2014-03-25','08:40:00',1.75),('9650','2014-03-25','08:45:00',1.88),('9650','2014-03-25','08:50:00',2.14),('9650','2014-03-25','08:55:00',1.86),('9650','2014-03-25','09:00:00',2),('9650','2014-03-25','09:05:00',1.9),('9650','2014-03-25','09:10:00',2.13),('9650','2014-03-25','09:15:00',1.77),('9650','2014-03-25','09:20:00',1.3),('9650','2014-03-25','09:25:00',1.77),('9650','2014-03-25','09:30:00',2.96),('9650','2014-03-25','09:35:00',3.06),('9650','2014-03-25','09:50:00',3.13),('9650','2014-03-25','09:55:00',3.6),('9650','2014-03-25','10:00:00',3.98),('9650','2014-03-25','10:05:00',3.48),('9650','2014-03-25','10:10:00',4.91),('9650','2014-03-25','10:15:00',4.89),('9650','2014-03-25','10:20:00',2.75),('9650','2014-03-25','10:25:00',4.93),('9650','2014-03-25','10:30:00',4.2),('9650','2014-03-25','10:35:00',2.55),('9650','2014-03-25','10:40:00',1.39),('9650','2014-03-25','10:45:00',2.77),('9650','2014-03-25','10:50:00',3.92),('9650','2014-03-25','10:55:00',6.8),('9650','2014-03-25','11:00:00',5.58),('9650','2014-03-25','11:05:00',1.88),('9650','2014-03-25','11:10:00',5.81),('9650','2014-03-25','11:15:00',6.91),('9650','2014-03-25','11:20:00',3.63),('9650','2014-03-25','11:25:00',2.17),('9650','2014-03-25','11:30:00',2.79),('9650','2014-03-25','11:35:00',2.92),('9650','2014-03-25','11:40:00',3.3),('9650','2014-03-25','11:45:00',4.95),('9650','2014-03-25','11:50:00',5.75),('9650','2014-03-25','11:55:00',7.42),('9650','2014-03-25','12:00:00',7.29),('9650','2014-03-25','12:05:00',6.36),('9650','2014-03-25','12:10:00',6.14),('9650','2014-03-25','12:15:00',2.71),('9650','2014-03-25','12:20:00',3.19),('9650','2014-03-25','12:25:00',3.02),('9650','2014-03-25','12:30:00',2.97),('9650','2014-03-25','12:35:00',2.86),('9650','2014-03-25','12:40:00',3.59),('9650','2014-03-25','12:45:00',3.75),('9650','2014-03-25','12:50:00',2.88),('9650','2014-03-25','12:55:00',2.2),('9650','2014-03-25','13:00:00',2.4),('9650','2014-03-25','13:05:00',2.13),('9650','2014-03-25','13:10:00',1.95),('9650','2014-03-25','13:15:00',1.43),('9650','2014-03-25','13:20:00',3.55),('9650','2014-03-25','13:25:00',7.52),('9650','2014-03-25','13:30:00',6.24),('9650','2014-03-25','13:35:00',3.66),('9650','2014-03-25','13:40:00',2.12),('9650','2014-03-25','13:45:00',1.71),('9650','2014-03-25','13:50:00',1.7),('9650','2014-03-25','13:55:00',2.24),('9650','2014-03-25','14:00:00',4.09),('9650','2014-03-25','14:05:00',7.11),('9650','2014-03-25','14:10:00',7.08),('9650','2014-03-25','14:15:00',2.47),('9650','2014-03-25','14:20:00',1.68),('9650','2014-03-25','14:25:00',1.4),('9650','2014-03-25','14:30:00',1.26),('9650','2014-03-25','14:35:00',1.1),('9650','2014-03-25','14:40:00',1.17),('9650','2014-03-25','14:45:00',3.74),('9650','2014-03-25','14:50:00',5.48),('9650','2014-03-25','14:55:00',5.95),('9650','2014-03-25','15:00:00',5.38),('9650','2014-03-25','15:05:00',5.39),('9650','2014-03-25','15:10:00',5.48),('9650','2014-03-25','15:15:00',5.6),('9650','2014-03-25','15:20:00',4.96),('9650','2014-03-25','15:25:00',5.32),('9650','2014-03-25','15:30:00',5.47),('9650','2014-03-25','15:35:00',5.29),('9650','2014-03-25','15:40:00',4.24),('9650','2014-03-25','15:45:00',4.28),('9650','2014-03-25','15:50:00',3.64),('9650','2014-03-25','15:55:00',3.02),('9650','2014-03-25','16:00:00',2.33),('9650','2014-03-25','16:05:00',2.44),('9650','2014-03-25','16:10:00',2.82),('9650','2014-03-25','16:15:00',2.96),('9650','2014-03-25','16:20:00',2.03),('9650','2014-03-25','16:25:00',1.61),('9650','2014-03-25','16:30:00',1.28),('9650','2014-03-25','16:35:00',1.25),('9650','2013-03-21','08:30:00',1.1),('9650','2013-03-21','08:35:00',1.22),('9650','2013-03-21','08:40:00',1.33),('9650','2013-03-21','08:45:00',1.45),('9650','2013-03-21','08:50:00',1.58),('9650','2013-03-21','08:55:00',1.71),('9650','2013-03-21','09:00:00',1.83),('9650','2013-03-21','09:05:00',1.97),('9650','2013-03-21','09:10:00',2.12),('9650','2013-03-21','09:15:00',2.26),('9650','2013-03-21','09:20:00',2.36),('9650','2013-03-21','09:25:00',2.51),('9650','2013-03-21','09:30:00',2.66),('9650','2013-03-21','09:35:00',2.81),('9650','2013-03-21','09:40:00',2.92),('9650','2013-03-21','09:45:00',3.09),('9650','2013-03-21','09:50:00',3.2),('9650','2013-03-21','09:55:00',3.33),('9650','2013-03-21','10:00:00',3.48),('9650','2013-03-21','10:05:00',3.63),('9650','2013-03-21','10:10:00',3.71),('9650','2013-03-21','10:15:00',3.8),('9650','2013-03-21','10:20:00',3.91),('9650','2013-03-21','10:25:00',4.11),('9650','2013-03-21','10:30:00',4.24),('9650','2013-03-21','10:35:00',4.33),('9650','2013-03-21','10:40:00',4.43),('9650','2013-03-21','10:45:00',4.52),('9650','2013-03-21','10:50:00',4.65),('9650','2013-03-21','10:55:00',4.75),('9650','2013-03-21','11:00:00',4.83),('9650','2013-03-21','11:05:00',4.94),('9650','2013-03-21','11:10:00',5.02),('9650','2013-03-21','11:15:00',5.1),('9650','2013-03-21','11:20:00',5.17),('9650','2013-03-21','11:25:00',5.22),('9650','2013-03-21','11:30:00',5.37),('9650','2013-03-21','11:35:00',5.38),('9650','2013-03-21','11:40:00',5.51),('9650','2013-03-21','11:45:00',5.6),('9650','2013-03-21','11:50:00',5.66),('9650','2013-03-21','11:55:00',5.72),('9650','2013-03-21','12:00:00',5.8),('9650','2013-03-21','12:05:00',5.86),('9650','2013-03-21','12:10:00',5.89),('9650','2013-03-21','12:15:00',5.91),('9650','2013-03-21','12:20:00',5.99),('9650','2013-03-21','12:25:00',6.04),('9650','2013-03-21','12:30:00',6.1),('9650','2013-03-21','12:35:00',6.17),('9650','2013-03-21','12:40:00',6.22),('9650','2013-03-21','12:45:00',6.25),('9650','2013-03-21','12:50:00',6.17),('9650','2013-03-21','12:55:00',6.04),('9650','2013-03-21','13:00:00',6.34),('9650','2013-03-21','13:05:00',6.26),('9650','2013-03-21','13:10:00',6.46),('9650','2013-03-21','13:15:00',6.38),('9650','2013-03-21','13:20:00',6.36),('9650','2013-03-21','13:25:00',5.99),('9650','2013-03-21','13:30:00',5.91),('9650','2013-03-21','13:35:00',6.28),('9650','2013-03-21','13:40:00',5.44),('9650','2013-03-21','13:45:00',5.7),('9650','2013-03-21','13:50:00',6.39),('9650','2013-03-21','13:55:00',6.18),('9650','2013-03-21','14:00:00',6.12),('9650','2013-03-21','14:05:00',6.15),('9650','2013-03-21','14:10:00',6.08),('9650','2013-03-21','14:15:00',5.98),('9650','2013-03-21','14:20:00',5.86),('9650','2013-03-21','14:25:00',5.79),('9650','2013-03-21','14:30:00',5.74),('9650','2013-03-21','14:35:00',5.6),('9650','2013-03-21','14:40:00',5.44),('9650','2013-03-21','14:45:00',5.35),('9650','2013-03-21','14:50:00',5.37),('9650','2013-03-21','14:55:00',5.24),('9650','2013-03-21','15:00:00',5.16),('9650','2013-03-21','15:05:00',5.04),('9650','2013-03-21','15:10:00',4.56),('9650','2013-03-21','15:15:00',3.86),('9650','2013-03-21','15:20:00',3.71),('9650','2013-03-21','15:25:00',3.93),('9650','2013-03-21','15:30:00',3.63),('9650','2013-03-21','15:35:00',4.18),('9650','2013-03-21','15:40:00',4),('9650','2013-03-21','15:45:00',3.53),('9650','2013-03-21','15:50:00',3.97),('9650','2013-03-21','15:55:00',3.6),('9650','2013-03-21','16:00:00',2.7),('9650','2013-03-21','16:05:00',2.9),('9650','2013-03-21','16:10:00',3.35),('9650','2013-03-21','16:15:00',3.99),('9650','2013-03-21','16:20:00',3.21),('9650','2013-03-21','16:25:00',3.34),('9650','2013-03-21','16:30:00',3.72),('9650','2013-03-21','16:35:00',3.79),('9650','2013-03-21','16:40:00',3.74),('9650','2013-03-21','16:45:00',3.52),('9650','2013-03-21','16:50:00',3.39),('9650','2013-03-21','16:55:00',3.28),('9650','2013-03-21','17:00:00',3.07),('9650','2013-03-21','17:05:00',2.87),('9650','2013-03-21','17:10:00',2.66),('9650','2013-03-21','17:15:00',2.46),('9650','2013-03-21','17:20:00',2.31),('9650','2013-03-21','17:25:00',1.27),('9650','2013-03-21','17:30:00',1.55),('9650','2013-03-21','17:35:00',1.5),('9650','2013-03-21','17:40:00',1.27),('9650','2013-03-20','08:25:00',1.17),('9650','2013-03-20','08:30:00',1.02),('9650','2013-03-20','08:35:00',1.24),('9650','2013-03-20','08:40:00',1.67),('9650','2013-03-20','08:45:00',1.61),('9650','2013-03-20','08:50:00',1.54),('9650','2013-03-20','08:55:00',1.71),('9650','2013-03-20','09:00:00',1.97),('9650','2013-03-20','09:05:00',2.5),('9650','2013-03-20','09:10:00',2.92),('9650','2013-03-20','09:15:00',2.26),('9650','2013-03-20','09:20:00',2.04),('9650','2013-03-20','09:25:00',1.93),('9650','2013-03-20','09:30:00',2.05),('9650','2013-03-20','09:35:00',2.85),('9650','2013-03-20','09:40:00',2.93),('9650','2013-03-20','09:45:00',3.15),('9650','2013-03-20','09:50:00',3.27),('9650','2013-03-20','09:55:00',3.41),('9650','2013-03-20','10:00:00',3.55),('9650','2013-03-20','10:05:00',3.69),('9650','2013-03-20','10:10:00',3.8),('9650','2013-03-20','10:15:00',3.95),('9650','2013-03-20','10:20:00',4.06),('9650','2013-03-20','10:25:00',4.16),('9650','2013-03-20','10:30:00',4.31),('9650','2013-03-20','10:35:00',4.44),('9650','2013-03-20','10:40:00',4.54),('9650','2013-03-20','10:45:00',4.6),('9650','2013-03-20','10:50:00',4.72),('9650','2013-03-20','10:55:00',4.21),('9650','2013-03-20','11:00:00',4.91),('9650','2013-03-20','11:05:00',5.07),('9650','2013-03-20','11:10:00',5.13),('9650','2013-03-20','11:15:00',5.25),('9650','2013-03-20','11:20:00',5.33),('9650','2013-03-20','11:25:00',5.47),('9650','2013-03-20','11:30:00',5.54),('9650','2013-03-20','11:35:00',5.64),('9650','2013-03-20','11:40:00',5.69),('9650','2013-03-20','11:45:00',5.79),('9650','2013-03-20','11:50:00',5.85),('9650','2013-03-20','11:55:00',5.94),('9650','2013-03-20','12:00:00',5.99),('9650','2013-03-20','12:05:00',6.08),('9650','2013-03-20','12:10:00',6.11),('9650','2013-03-20','12:15:00',6.16),('9650','2013-03-20','12:20:00',6.21),('9650','2013-03-20','12:25:00',6.28),('9650','2013-03-20','12:30:00',6.32),('9650','2013-03-20','12:35:00',6.36),('9650','2013-03-20','12:40:00',6.4),('9650','2013-03-20','12:45:00',6.4),('9650','2013-03-20','12:50:00',6.42),('9650','2013-03-20','12:55:00',6.48),('9650','2013-03-20','13:00:00',6.48),('9650','2013-03-20','13:05:00',6.45),('9650','2013-03-20','13:10:00',6.41),('9650','2013-03-20','13:15:00',6.46),('9650','2013-03-20','13:20:00',6.44),('9650','2013-03-20','13:25:00',6.44),('9650','2013-03-20','13:30:00',6.46),('9650','2013-03-20','13:35:00',6.47),('9650','2013-03-20','13:40:00',6.49),('9650','2013-03-20','13:45:00',6.4),('9650','2013-03-20','13:50:00',6.35),('9650','2013-03-20','13:55:00',6.25),('9650','2013-03-20','14:00:00',6.14),('9650','2013-03-20','14:05:00',6.08),('9650','2013-03-20','14:10:00',6.07),('9650','2013-03-20','14:15:00',5.99),('9650','2013-03-20','14:20:00',5.84),('9650','2013-03-20','14:25:00',5.77),('9650','2013-03-20','14:30:00',5.58),('9650','2013-03-20','14:35:00',5.52),('9650','2013-03-20','14:40:00',5.48),('9650','2013-03-20','14:45:00',5.43),('9650','2013-03-20','14:50:00',5.38),('9650','2013-03-20','14:55:00',5.26),('9650','2013-03-20','15:00:00',5.16),('9650','2013-03-20','15:05:00',5),('9650','2013-03-20','15:10:00',4.92),('9650','2013-03-20','15:15:00',4.91),('9650','2013-03-20','15:20:00',4.84),('9650','2013-03-20','15:25:00',4.75),('9650','2013-03-20','15:30:00',4.64),('9650','2013-03-20','15:35:00',4.56),('9650','2013-03-20','15:40:00',4.44),('9650','2013-03-20','15:45:00',4.31),('9650','2013-03-20','15:50:00',4.22),('9650','2013-03-20','15:55:00',4.13),('9650','2013-03-20','16:00:00',4.1),('9650','2013-03-20','16:05:00',4.05),('9650','2013-03-20','16:10:00',3.89),('9650','2013-03-20','16:15:00',3.77),('9650','2013-03-20','16:20:00',3.64),('9650','2013-03-20','16:25:00',3.51),('9650','2013-03-20','16:30:00',3.48),('9650','2013-03-20','16:35:00',3.37),('9650','2013-03-20','16:40:00',3.21),('9650','2013-03-20','16:45:00',3.17),('9650','2013-03-20','16:50:00',3.02),('9650','2013-03-20','16:55:00',2.89),('9650','2013-03-20','17:00:00',2.74),('9650','2013-03-20','17:05:00',2.65),('9650','2013-03-20','17:10:00',2.56),('9650','2013-03-20','17:15:00',2.37),('9650','2013-03-20','17:20:00',2.23),('9650','2013-03-20','17:25:00',2.03),('9650','2013-03-20','17:30:00',1.8),('9650','2013-03-20','17:35:00',1.58),('9650','2013-03-20','17:40:00',1.31),('9650','2013-03-19','08:00:00',1.07),('9650','2013-03-19','08:25:00',1.03),('9650','2013-03-19','08:30:00',1.2),('9650','2013-03-19','08:35:00',1.35),('9650','2013-03-19','08:40:00',1.34),('9650','2013-03-19','08:45:00',1.42),('9650','2013-03-19','08:50:00',1.7),('9650','2013-03-19','08:55:00',1.77),('9650','2013-03-19','09:00:00',1.98),('9650','2013-03-19','09:05:00',2.84),('9650','2013-03-19','09:10:00',2.62),('9650','2013-03-19','09:15:00',2.47),('9650','2013-03-19','09:20:00',2.79),('9650','2013-03-19','09:25:00',2.66),('9650','2013-03-19','09:30:00',2.79),('9650','2013-03-19','09:35:00',2.68),('9650','2013-03-19','09:40:00',2.91),('9650','2013-03-19','09:45:00',3.05),('9650','2013-03-19','09:50:00',3.18),('9650','2013-03-19','09:55:00',3.27),('9650','2013-03-19','10:00:00',3.49),('9650','2013-03-19','10:05:00',3.48),('9650','2013-03-19','10:10:00',3.19),('9650','2013-03-19','10:15:00',3.64),('9650','2013-03-19','10:20:00',3.12),('9650','2013-03-19','10:25:00',3.16),('9650','2013-03-19','10:30:00',3.64),('9650','2013-03-19','10:35:00',4.84),('9650','2013-03-19','10:40:00',3.95),('9650','2013-03-19','10:45:00',3.82),('9650','2013-03-19','10:50:00',4.16),('9650','2013-03-19','10:55:00',3.92),('9650','2013-03-19','11:00:00',4.34),('9650','2013-03-19','11:05:00',4.9),('9650','2013-03-19','11:10:00',3.6),('9650','2013-03-19','11:15:00',3.45),('9650','2013-03-19','11:20:00',3.94),('9650','2013-03-19','11:25:00',3.83),('9650','2013-03-19','11:30:00',3.76),('9650','2013-03-19','11:35:00',4.12),('9650','2013-03-19','11:40:00',3.41),('9650','2013-03-19','11:45:00',3.38),('9650','2013-03-19','11:50:00',3.38),('9650','2013-03-19','11:55:00',3.69),('9650','2013-03-19','12:00:00',3.63),('9650','2013-03-19','12:05:00',3.96),('9650','2013-03-19','12:10:00',3.38),('9650','2013-03-19','12:15:00',2.96),('9650','2013-03-19','12:20:00',2.74),('9650','2013-03-19','12:25:00',2.32),('9650','2013-03-19','12:30:00',1.89),('9650','2013-03-19','12:35:00',2.35),('9650','2013-03-19','12:40:00',1.73),('9650','2013-03-19','12:45:00',1.76),('9650','2013-03-19','12:50:00',2.55),('9650','2013-03-19','12:55:00',3.02),('9650','2013-03-19','13:00:00',3.23),('9650','2013-03-19','13:05:00',2.42),('9650','2013-03-19','13:10:00',2.5),('9650','2013-03-19','13:15:00',2.06),('9650','2013-03-19','13:20:00',2.21),('9650','2013-03-19','13:25:00',2.39),('9650','2013-03-19','13:30:00',2.63),('9650','2013-03-19','13:35:00',2.5),('9650','2013-03-19','13:40:00',3.11),('9650','2013-03-19','13:45:00',3.6),('9650','2013-03-19','13:50:00',3.03),('9650','2013-03-19','13:55:00',2.86),('9650','2013-03-19','14:00:00',2.84),('9650','2013-03-19','14:05:00',2.42),('9650','2013-03-19','14:10:00',2.26),('9650','2013-03-19','14:15:00',3.01),('9650','2013-03-19','14:20:00',3.78),('9650','2013-03-19','14:25:00',3.56),('9650','2013-03-19','14:30:00',3.14),('9650','2013-03-19','14:35:00',2.53),('9650','2013-03-19','14:40:00',1.99),('9650','2013-03-19','14:45:00',1.94),('9650','2013-03-19','14:50:00',1.56),('9650','2013-03-19','14:55:00',1.21),('9650','2013-03-19','15:00:00',1.36),('9650','2013-03-19','15:05:00',1.27),('9650','2013-03-19','15:10:00',1.14),('9650','2013-03-19','15:30:00',1.08),('9650','2013-03-18','08:40:00',1.12),('9650','2013-03-18','08:45:00',1.3),('9650','2013-03-18','08:50:00',1.41),('9650','2013-03-18','08:55:00',1.51),('9650','2013-03-18','09:00:00',1.65),('9650','2013-03-18','09:05:00',1.79),('9650','2013-03-18','09:10:00',1.95),('9650','2013-03-18','09:15:00',2.1),('9650','2013-03-18','09:20:00',1.68),('9650','2013-03-18','09:25:00',2.2),('9650','2013-03-18','09:30:00',2.52),('9650','2013-03-18','09:35:00',2.59),('9650','2013-03-18','09:40:00',2.84),('9650','2013-03-18','09:45:00',2.96),('9650','2013-03-18','09:50:00',2.87),('9650','2013-03-18','09:55:00',3.14),('9650','2013-03-18','10:00:00',2.91),('9650','2013-03-18','10:05:00',3.23),('9650','2013-03-18','10:10:00',3.56),('9650','2013-03-18','10:15:00',3.71),('9650','2013-03-18','10:20:00',3.87),('9650','2013-03-18','10:25:00',3.65),('9650','2013-03-18','10:30:00',4.07),('9650','2013-03-18','10:35:00',4.21),('9650','2013-03-18','10:40:00',4.31),('9650','2013-03-18','10:45:00',4.47),('9650','2013-03-18','10:50:00',4.31),('9650','2013-03-18','10:55:00',4.74),('9650','2013-03-18','11:00:00',4.8),('9650','2013-03-18','11:05:00',4.9),('9650','2013-03-18','11:10:00',4.82),('9650','2013-03-18','11:15:00',5.1),('9650','2013-03-18','11:20:00',5.14),('9650','2013-03-18','11:25:00',5.17),('9650','2013-03-18','11:30:00',5.23),('9650','2013-03-18','11:35:00',3.27),('9650','2013-03-18','11:40:00',5.01),('9650','2013-03-18','11:45:00',5.12),('9650','2013-03-18','11:50:00',5.85),('9650','2013-03-18','11:55:00',5.82),('9650','2013-03-18','12:00:00',5.79),('9650','2013-03-18','12:05:00',5.76),('9650','2013-03-18','12:10:00',5.83),('9650','2013-03-18','12:15:00',5.59),('9650','2013-03-18','12:20:00',5.97),('9650','2013-03-18','12:25:00',6),('9650','2013-03-18','12:30:00',5.93),('9650','2013-03-18','12:35:00',6.1),('9650','2013-03-18','12:40:00',6.17),('9650','2013-03-18','12:45:00',6.17),('9650','2013-03-18','12:50:00',6.21),('9650','2013-03-18','12:55:00',6.22),('9650','2013-03-18','13:00:00',6.22),('9650','2013-03-18','13:05:00',6.17),('9650','2013-03-18','13:10:00',6.19),('9650','2013-03-18','13:15:00',6.18),('9650','2013-03-18','13:20:00',6.21),('9650','2013-03-18','13:25:00',6.22),('9650','2013-03-18','13:30:00',6.18),('9650','2013-03-18','13:35:00',6.12),('9650','2013-03-18','13:40:00',6.01),('9650','2013-03-18','13:45:00',6.11),('9650','2013-03-18','13:50:00',6.13),('9650','2013-03-18','13:55:00',6.03),('9650','2013-03-18','14:00:00',5.97),('9650','2013-03-18','14:05:00',5.96),('9650','2013-03-18','14:10:00',5.91),('9650','2013-03-18','14:15:00',5.7),('9650','2013-03-18','14:20:00',5.61),('9650','2013-03-18','14:25:00',5.58),('9650','2013-03-18','14:30:00',5.46),('9650','2013-03-18','14:35:00',5.4),('9650','2013-03-18','14:40:00',5.34),('9650','2013-03-18','14:45:00',5.3),('9650','2013-03-18','14:50:00',5.14),('9650','2013-03-18','14:55:00',4.98),('9650','2013-03-18','15:00:00',4.83),('9650','2013-03-18','15:05:00',4.67),('9650','2013-03-18','15:10:00',4.65),('9650','2013-03-18','15:15:00',4.67),('9650','2013-03-18','15:20:00',4.65),('9650','2013-03-18','15:25:00',4.53),('9650','2013-03-18','15:30:00',4.28),('9650','2013-03-18','15:35:00',4.18),('9650','2013-03-18','15:40:00',4.27),('9650','2013-03-18','15:45:00',4.22),('9650','2013-03-18','15:50:00',4.14),('9650','2013-03-18','15:55:00',4.08),('9650','2013-03-18','16:00:00',4.02),('9650','2013-03-18','16:05:00',3.93),('9650','2013-03-18','16:10:00',3.81),('9650','2013-03-18','16:15:00',3.67),('9650','2013-03-18','16:20:00',3.53),('9650','2013-03-18','16:25:00',3.43),('9650','2013-03-18','16:30:00',3.43),('9650','2013-03-18','16:35:00',3.36),('9650','2013-03-18','16:40:00',3.23),('9650','2013-03-18','16:45:00',2.66),('9650','2013-03-18','16:50:00',2.13),('9650','2013-03-18','16:55:00',2.38),('9650','2013-03-18','17:00:00',1.94),('9650','2013-03-18','17:05:00',1.85),('9650','2013-03-18','17:10:00',1.82),('9650','2013-03-18','17:15:00',2.32),('9650','2013-03-18','17:20:00',2.13),('9650','2013-03-18','17:25:00',1.8),('9650','2013-03-18','17:30:00',1.43),('9650','2013-03-18','17:35:00',1.39),('9650','2013-03-17','08:20:00',1.02),('9650','2013-03-17','08:25:00',1.13),('9650','2013-03-17','08:30:00',1.23),('9650','2013-03-17','08:35:00',1.17),('9650','2013-03-17','08:40:00',1.17),('9650','2013-03-17','08:45:00',1.6),('9650','2013-03-17','08:50:00',1.39),('9650','2013-03-17','08:55:00',1.2),('9650','2013-03-17','09:35:00',1),('9650','2013-03-17','09:40:00',1.14),('9650','2013-03-17','09:45:00',1.22),('9650','2013-03-17','09:50:00',1.29),('9650','2013-03-17','09:55:00',1.79),('9650','2013-03-17','10:00:00',2.14),('9650','2013-03-17','10:05:00',2.41),('9650','2013-03-17','10:10:00',2.43),('9650','2013-03-17','10:15:00',2.19),('9650','2013-03-17','10:20:00',2.47),('9650','2013-03-17','10:25:00',2.82),('9650','2013-03-17','10:30:00',2.88),('9650','2013-03-17','10:35:00',2.57),('9650','2013-03-17','10:40:00',2.49),('9650','2013-03-17','10:45:00',2.59),('9650','2013-03-17','10:50:00',2.44),('9650','2013-03-17','10:55:00',2.05),('9650','2013-03-17','11:00:00',2.26),('9650','2013-03-17','11:05:00',2.52),('9650','2013-03-17','11:10:00',2.8),('9650','2013-03-17','11:15:00',3.03),('9650','2013-03-17','11:20:00',3.1),('9650','2013-03-17','11:25:00',3.21),('9650','2013-03-17','11:30:00',3.79),('9650','2013-03-17','11:35:00',3.34),('9650','2013-03-17','11:40:00',3.02),('9650','2013-03-17','11:45:00',2.61),('9650','2013-03-17','11:50:00',2.16),('9650','2013-03-17','11:55:00',2.54),('9650','2013-03-17','12:00:00',2.69),('9650','2013-03-17','12:05:00',4.43),('9650','2013-03-17','12:10:00',4.17),('9650','2013-03-17','12:15:00',4.82),('9650','2013-03-17','12:20:00',4.56),('9650','2013-03-17','12:25:00',3.36),('9650','2013-03-17','12:30:00',4.89),('9650','2013-03-17','12:35:00',5.98),('9650','2013-03-17','12:40:00',4.66),('9650','2013-03-17','12:45:00',4.35),('9650','2013-03-17','12:50:00',5.89),('9650','2013-03-17','12:55:00',6.26),('9650','2013-03-17','13:00:00',5.39),('9650','2013-03-17','13:05:00',2.7),('9650','2013-03-17','13:10:00',2.02),('9650','2013-03-17','13:15:00',1.56),('9650','2013-03-17','13:20:00',2.01),('9650','2013-03-17','13:25:00',3.41),('9650','2013-03-17','13:30:00',2.33),('9650','2013-03-17','13:35:00',2.06),('9650','2013-03-17','13:40:00',3.41),('9650','2013-03-17','13:45:00',3.12),('9650','2013-03-17','13:50:00',2.94),('9650','2013-03-17','13:55:00',2.58),('9650','2013-03-17','14:00:00',2.94),('9650','2013-03-17','14:05:00',4.42),('9650','2013-03-17','14:10:00',4.04),('9650','2013-03-17','14:15:00',2.1),('9650','2013-03-17','14:20:00',2.01),('9650','2013-03-17','14:25:00',2.7),('9650','2013-03-17','14:30:00',1.42),('9650','2013-03-17','14:35:00',1.96),('9650','2013-03-17','14:40:00',2.04),('9650','2013-03-17','14:45:00',1.75),('9650','2013-03-17','14:55:00',1.59),('9650','2013-03-17','15:00:00',1.87),('9650','2013-03-17','15:05:00',1.58),('9650','2013-03-17','15:10:00',1.14),('9650','2013-03-17','15:15:00',1.51),('9650','2013-03-17','15:20:00',1.1),('9650','2013-03-17','15:25:00',1.06),('9650','2013-03-17','15:30:00',1.01),('9650','2013-03-16','07:55:00',1.05),('9650','2013-03-16','08:00:00',1.09),('9650','2013-03-16','08:05:00',1.2),('9650','2013-03-16','08:10:00',1.35),('9650','2013-03-16','08:15:00',1.47),('9650','2013-03-16','08:20:00',1.57),('9650','2013-03-16','08:25:00',1.9),('9650','2013-03-16','08:30:00',1.9),('9650','2013-03-16','08:35:00',1.71),('9650','2013-03-16','08:40:00',1.76),('9650','2013-03-16','08:45:00',2),('9650','2013-03-16','08:50:00',2.03),('9650','2013-03-16','08:55:00',2.01),('9650','2013-03-16','09:00:00',2),('9650','2013-03-16','09:05:00',2.28),('9650','2013-03-16','09:10:00',2.57),('9650','2013-03-16','09:15:00',2.64),('9650','2013-03-16','09:20:00',2.42),('9650','2013-03-16','09:25:00',2.19),('9650','2013-03-16','09:30:00',2.39),('9650','2013-03-16','09:35:00',2.6),('9650','2013-03-16','09:40:00',2.57),('9650','2013-03-16','09:45:00',2.65),('9650','2013-03-16','09:50:00',2.9),('9650','2013-03-16','09:55:00',3.01),('9650','2013-03-16','10:00:00',3.27),('9650','2013-03-16','10:05:00',2.89),('9650','2013-03-16','10:10:00',2.91),('9650','2013-03-16','10:15:00',3.12),('9650','2013-03-16','10:20:00',3.16),('9650','2013-03-16','10:25:00',3.28),('9650','2013-03-16','10:30:00',3.24),('9650','2013-03-16','10:35:00',3.16),('9650','2013-03-16','10:40:00',3.02),('9650','2013-03-16','10:45:00',3.18),('9650','2013-03-16','10:50:00',2.98),('9650','2013-03-16','10:55:00',2.77),('9650','2013-03-16','11:00:00',2.74),('9650','2013-03-16','11:05:00',2.38),('9650','2013-03-16','11:10:00',2.35),('9650','2013-03-16','11:15:00',2.65),('9650','2013-03-16','11:20:00',3.02),('9650','2013-03-16','11:25:00',3.04),('9650','2013-03-16','11:30:00',2.73),('9650','2013-03-16','11:35:00',2.73),('9650','2013-03-16','11:40:00',2.63),('9650','2013-03-16','11:45:00',2.4),('9650','2013-03-16','11:50:00',2.21),('9650','2013-03-16','11:55:00',1.98),('9650','2013-03-16','12:00:00',1.87),('9650','2013-03-16','12:05:00',1.93),('9650','2013-03-16','12:10:00',2.5),('9650','2013-03-16','12:15:00',3.38),('9650','2013-03-16','12:20:00',4.07),('9650','2013-03-16','12:25:00',5.48),('9650','2013-03-16','12:30:00',5.62),('9650','2013-03-16','12:35:00',4.17),('9650','2013-03-16','12:40:00',4.46),('9650','2013-03-16','12:45:00',4.12),('9650','2013-03-16','12:50:00',3.66),('9650','2013-03-16','12:55:00',3.05),('9650','2013-03-16','13:00:00',3.54),('9650','2013-03-16','13:05:00',3.81),('9650','2013-03-16','13:10:00',4.23),('9650','2013-03-16','13:15:00',4.11),('9650','2013-03-16','13:20:00',3.44),('9650','2013-03-16','13:25:00',3.17),('9650','2013-03-16','13:30:00',4.66),('9650','2013-03-16','13:35:00',4.75),('9650','2013-03-16','13:40:00',3.48),('9650','2013-03-16','13:45:00',3.14),('9650','2013-03-16','13:50:00',2.56),('9650','2013-03-16','13:55:00',3.86),('9650','2013-03-16','14:00:00',3.67),('9650','2013-03-16','14:05:00',3.8),('9650','2013-03-16','14:10:00',4.43),('9650','2013-03-16','14:15:00',4.56),('9650','2013-03-16','14:20:00',4.88),('9650','2013-03-16','14:25:00',4.23),('9650','2013-03-16','14:30:00',4.02),('9650','2013-03-16','14:35:00',3.44),('9650','2013-03-16','14:40:00',2.6),('9650','2013-03-16','14:45:00',2.34),('9650','2013-03-16','14:50:00',2.04),('9650','2013-03-16','14:55:00',2.23),('9650','2013-03-16','15:00:00',2.88),('9650','2013-03-16','15:05:00',3.02),('9650','2013-03-16','15:10:00',3.98),('9650','2013-03-16','15:15:00',3.84),('9650','2013-03-16','15:20:00',4.46),('9650','2013-03-16','15:25:00',3.76),('9650','2013-03-16','15:30:00',2.51),('9650','2013-03-16','15:35:00',2.97),('9650','2013-03-16','15:40:00',2.92),('9650','2013-03-16','15:45:00',2.5),('9650','2013-03-16','15:50:00',1.53),('9650','2013-03-16','15:55:00',1.55),('9650','2013-03-16','16:00:00',1.21),('9650','2013-03-16','16:15:00',1.05),('9650','2013-03-16','16:20:00',1.12),('9650','2013-03-16','16:40:00',1.63),('9650','2013-03-16','16:45:00',2.61),('9650','2013-03-15','08:10:00',1.01),('9650','2013-03-15','08:15:00',1.14),('9650','2013-03-15','08:20:00',1.09),('9650','2013-03-15','08:35:00',1.07),('9650','2013-03-15','08:40:00',1.22),('9650','2013-03-15','08:45:00',1.28),('9650','2013-03-15','08:50:00',1.45),('9650','2013-03-15','08:55:00',1.72),('9650','2013-03-15','09:00:00',1.7),('9650','2013-03-15','09:05:00',1.79),('9650','2013-03-15','09:10:00',1.72),('9650','2013-03-15','09:15:00',2.02),('9650','2013-03-15','09:20:00',2.05),('9650','2013-03-15','09:25:00',1.49),('9650','2013-03-15','09:30:00',2.22),('9650','2013-03-15','09:35:00',2.79),('9650','2013-03-15','09:40:00',2.56),('9650','2013-03-15','09:45:00',2.84),('9650','2013-03-15','09:50:00',3.15),('9650','2013-03-15','09:55:00',3.44),('9650','2013-03-15','10:00:00',2.93),('9650','2013-03-15','10:05:00',2.44),('9650','2013-03-15','10:10:00',3.23),('9650','2013-03-15','10:15:00',2.74),('9650','2013-03-15','10:20:00',2.53),('9650','2013-03-15','10:25:00',3.19),('9650','2013-03-15','10:30:00',2.47),('9650','2013-03-15','10:35:00',3.36),('9650','2013-03-15','10:40:00',4.29),('9650','2013-03-15','10:45:00',4.41),('9650','2013-03-15','10:50:00',4.53),('9650','2013-03-15','10:55:00',4.59),('9650','2013-03-15','11:00:00',4.73),('9650','2013-03-15','11:05:00',4.81),('9650','2013-03-15','11:10:00',4.91),('9650','2013-03-15','11:15:00',4.98),('9650','2013-03-15','11:20:00',5.09),('9650','2013-03-15','11:25:00',5.18),('9650','2013-03-15','11:30:00',5.29),('9650','2013-03-15','11:35:00',5.34),('9650','2013-03-15','11:40:00',5.42),('9650','2013-03-15','11:45:00',5.51),('9650','2013-03-15','11:50:00',5.59),('9650','2013-03-15','11:55:00',5.64),('9650','2013-03-15','12:00:00',5.7),('9650','2013-03-15','12:05:00',5.74),('9650','2013-03-15','12:10:00',5.78),('9650','2013-03-15','12:15:00',5.87),('9650','2013-03-15','12:20:00',5.93),('9650','2013-03-15','12:25:00',5.99),('9650','2013-03-15','12:30:00',6.04),('9650','2013-03-15','12:35:00',6.05),('9650','2013-03-15','12:40:00',6.07),('9650','2013-03-15','12:45:00',6.12),('9650','2013-03-15','12:50:00',6.15),('9650','2013-03-15','12:55:00',6.17),('9650','2013-03-15','13:00:00',6.11),('9650','2013-03-15','13:05:00',6.13),('9650','2013-03-15','13:10:00',6.02),('9650','2013-03-15','13:15:00',6.07),('9650','2013-03-15','13:20:00',6.29),('9650','2013-03-15','13:25:00',2.35),('9650','2013-03-15','13:30:00',1.9),('9650','2013-03-15','13:35:00',3.28),('9650','2013-03-15','13:40:00',5.8),('9650','2013-03-15','13:45:00',5.65),('9650','2013-03-15','13:50:00',4.93),('9650','2013-03-15','13:55:00',2.91),('9650','2013-03-15','14:00:00',5.48),('9650','2013-03-15','14:05:00',5.88),('9650','2013-03-15','14:10:00',1.8),('9650','2013-03-15','14:15:00',5.64),('9650','2013-03-15','14:20:00',2.4),('9650','2013-03-15','14:25:00',1.81),('9650','2013-03-15','14:30:00',5.23),('9650','2013-03-15','14:35:00',5.29),('9650','2013-03-15','14:40:00',3.96),('9650','2013-03-15','14:45:00',1.94),('9650','2013-03-15','14:50:00',1.17),('9650','2013-03-15','14:55:00',1.14),('9650','2013-03-15','15:00:00',1.02),('9650','2013-03-15','15:05:00',1.01),('9650','2013-03-15','15:20:00',1.06),('9650','2013-03-15','15:25:00',1.06),('9650','2013-03-15','15:30:00',1.04),('9650','2013-03-15','15:35:00',1.25),('9650','2013-03-15','15:40:00',1.69),('9650','2013-03-15','15:45:00',1.7),('9650','2013-03-15','15:50:00',1.04),('9650','2013-03-15','16:00:00',3.27),('9650','2013-03-15','16:05:00',4.01),('9650','2013-03-15','16:10:00',3.87),('9650','2013-03-15','16:15:00',3.77),('9650','2013-03-15','16:20:00',2.03),('9650','2013-03-15','16:25:00',1.25),('9650','2013-03-15','16:30:00',1.32),('9650','2013-03-15','16:35:00',1.42),('9650','2013-03-15','16:40:00',1.34),('9650','2013-03-15','16:45:00',1.66),('9650','2013-03-15','16:50:00',2.12),('9650','2013-03-15','16:55:00',2.82),('9650','2013-03-15','17:00:00',2.65),('9650','2013-03-15','17:05:00',2.55),('9650','2013-03-15','17:10:00',2.29),('9650','2013-03-15','17:15:00',2.17),('9650','2013-03-15','17:20:00',2.01),('9650','2013-03-15','17:25:00',1.77),('9650','2013-03-15','17:30:00',1.5),('9650','2013-03-15','17:35:00',1.14),('9650','2013-03-14','10:00:00',1.14),('9650','2013-03-14','10:05:00',1.15),('9650','2013-03-14','10:10:00',1.13),('9650','2013-03-14','10:15:00',1.25),('9650','2013-03-14','10:20:00',1.19),('9650','2013-03-14','10:25:00',1.29),('9650','2013-03-14','10:30:00',1.69),('9650','2013-03-14','10:35:00',1.95),('9650','2013-03-14','10:40:00',2.21),('9650','2013-03-14','10:45:00',2.54),('9650','2013-03-14','10:50:00',2.6),('9650','2013-03-14','10:55:00',2.76),('9650','2013-03-14','11:00:00',2.7),('9650','2013-03-14','11:05:00',2.33),('9650','2013-03-14','11:10:00',2.3),('9650','2013-03-14','11:15:00',1.92),('9650','2013-03-14','11:20:00',2.22),('9650','2013-03-14','11:25:00',2.7),('9650','2013-03-14','11:30:00',3),('9650','2013-03-14','11:35:00',3.69),('9650','2013-03-14','11:40:00',4.11),('9650','2013-03-14','11:45:00',3.79),('9650','2013-03-14','11:50:00',3.53),('9650','2013-03-14','11:55:00',3.67),('9650','2013-03-14','12:00:00',3.33),('9650','2013-03-14','12:05:00',3.23),('9650','2013-03-14','12:10:00',3.56),('9650','2013-03-14','12:15:00',3.19),('9650','2013-03-14','12:20:00',3.13),('9650','2013-03-14','12:25:00',3.31),('9650','2013-03-14','12:30:00',3.42),('9650','2013-03-14','12:35:00',3.76),('9650','2013-03-14','12:40:00',3.21),('9650','2013-03-14','12:45:00',2.63),('9650','2013-03-14','12:50:00',2.48),('9650','2013-03-14','12:55:00',2.43),('9650','2013-03-14','13:00:00',2.3),('9650','2013-03-14','13:05:00',2.15),('9650','2013-03-14','13:10:00',2.3),('9650','2013-03-14','13:15:00',2.55),('9650','2013-03-14','13:20:00',2.75),('9650','2013-03-14','13:25:00',3.04),('9650','2013-03-14','13:30:00',2.85),('9650','2013-03-14','13:35:00',2.62),('9650','2013-03-14','13:40:00',2.67),('9650','2013-03-14','13:45:00',2.81),('9650','2013-03-14','13:50:00',2.28),('9650','2013-03-14','13:55:00',1.97),('9650','2013-03-14','14:00:00',1.83),('9650','2013-03-14','14:05:00',1.57),('9650','2013-03-14','14:10:00',1.32),('9650','2013-03-14','14:15:00',1.19),('9650','2013-03-14','14:20:00',1.07),('9650','2013-03-14','14:40:00',1.09),('9650','2013-03-14','14:45:00',1.42),('9650','2013-03-14','14:50:00',1.9),('9650','2013-03-14','14:55:00',2.15),('9650','2013-03-14','15:00:00',2.24),('9650','2013-03-14','15:05:00',2.12),('9650','2013-03-14','15:10:00',2.13),('9650','2013-03-14','15:15:00',2.29),('9650','2013-03-14','15:20:00',2.38),('9650','2013-03-14','15:25:00',2.57),('9650','2013-03-14','15:30:00',2.17),('9650','2013-03-14','15:35:00',1.82),('9650','2013-03-14','15:40:00',1.55),('9650','2013-03-14','15:45:00',1.6),('9650','2013-03-14','15:50:00',1.53),('9650','2013-03-14','15:55:00',1.48),('9650','2013-03-14','16:00:00',1.66),('9650','2013-03-14','16:05:00',1.36),('9650','2013-03-14','16:10:00',1.2),('9650','2013-03-14','16:15:00',1.25),('9650','2013-03-14','17:10:00',1.08),('9650','2013-03-14','17:15:00',2.08),('9650','2013-03-14','17:20:00',2.03),('9650','2013-03-14','17:25:00',1.72),('9650','2013-03-14','17:30:00',1.27),('9650','2013-03-13','08:20:00',1.12),('9650','2013-03-13','08:25:00',1.27),('9650','2013-03-13','08:30:00',1.06),('9650','2013-03-13','11:25:00',1.1),('9650','2013-03-13','11:30:00',1.29),('9650','2013-03-13','11:35:00',1.15),('9650','2013-03-13','11:40:00',1.33),('9650','2013-03-13','11:45:00',1.37),('9650','2013-03-13','11:50:00',1.33),('9650','2013-03-13','11:55:00',1.31),('9650','2013-03-13','12:00:00',1.2),('9650','2013-03-13','12:05:00',1.08),('9650','2013-03-13','12:10:00',1.04),('9650','2013-03-13','12:15:00',1.08),('9650','2013-03-13','12:20:00',1.17),('9650','2013-03-13','12:25:00',1.28),('9650','2013-03-13','12:30:00',1.35),('9650','2013-03-13','12:35:00',1.35),('9650','2013-03-13','12:40:00',1.48),('9650','2013-03-13','12:45:00',1.6),('9650','2013-03-13','12:50:00',1.53),('9650','2013-03-13','12:55:00',1.56),('9650','2013-03-13','13:00:00',1.51),('9650','2013-03-13','13:05:00',1.73),('9650','2013-03-13','13:10:00',2.03),('9650','2013-03-13','13:15:00',2.04),('9650','2013-03-13','13:20:00',2.03),('9650','2013-03-13','13:25:00',2.01),('9650','2013-03-13','13:30:00',2.11),('9650','2013-03-13','13:35:00',2.28),('9650','2013-03-13','13:40:00',2.01),('9650','2013-03-13','13:45:00',2.32),('9650','2013-03-13','13:50:00',2.96),('9650','2013-03-13','13:55:00',3.34),('9650','2013-03-13','14:00:00',3.08),('9650','2013-03-13','14:05:00',3.38),('9650','2013-03-13','14:10:00',2.65),('9650','2013-03-13','14:15:00',2.26),('9650','2013-03-13','14:20:00',2.14),('9650','2013-03-13','14:25:00',2.12),('9650','2013-03-13','14:30:00',1.82),('9650','2013-03-13','14:35:00',1.36),('9650','2013-03-13','14:40:00',1.03),('9650','2013-03-13','14:55:00',1.02),('9650','2013-03-13','15:00:00',1.07),('9650','2013-03-13','15:05:00',1.51),('9650','2013-03-13','15:10:00',2.24),('9650','2013-03-13','15:15:00',2.25),('9650','2013-03-13','15:20:00',2.1),('9650','2013-03-13','15:25:00',2.23),('9650','2013-03-13','15:30:00',2.17),('9650','2013-03-13','15:35:00',1.68),('9650','2013-03-13','15:40:00',1.21),('9650','2013-03-13','16:30:00',1.05),('9650','2013-03-12','08:10:00',1.11),('9650','2013-03-12','08:25:00',1.05),('9650','2013-03-12','08:40:00',1.2),('9650','2013-03-12','08:45:00',1.31),('9650','2013-03-12','08:50:00',1.84),('9650','2013-03-12','08:55:00',1.71),('9650','2013-03-12','09:00:00',1.31),('9650','2013-03-12','09:05:00',1.4),('9650','2013-03-12','09:10:00',1.79),('9650','2013-03-12','09:15:00',1.47),('9650','2013-03-12','09:20:00',1.6),('9650','2013-03-12','09:25:00',1.61),('9650','2013-03-12','09:30:00',1.56),('9650','2013-03-12','09:35:00',1.41),('9650','2013-03-12','09:40:00',1.41),('9650','2013-03-12','09:45:00',1.74),('9650','2013-03-12','09:50:00',1.4),('9650','2013-03-12','10:00:00',1.15),('9650','2013-03-12','10:05:00',1.85),('9650','2013-03-12','10:10:00',1.93),('9650','2013-03-12','10:15:00',3.2),('9650','2013-03-12','10:20:00',2.46),('9650','2013-03-12','10:25:00',3.44),('9650','2013-03-12','10:30:00',4.42),('9650','2013-03-12','10:35:00',4.97),('9650','2013-03-12','10:40:00',4.08),('9650','2013-03-12','10:45:00',2.62),('9650','2013-03-12','10:50:00',2.13),('9650','2013-03-12','10:55:00',1.75),('9650','2013-03-12','11:00:00',1.86),('9650','2013-03-12','11:05:00',1.54),('9650','2013-03-12','11:10:00',2.11),('9650','2013-03-12','11:15:00',1.9),('9650','2013-03-12','11:20:00',1.58),('9650','2013-03-12','11:25:00',1.35),('9650','2013-03-12','11:30:00',2.05),('9650','2013-03-12','11:35:00',2.19),('9650','2013-03-12','11:40:00',2.24),('9650','2013-03-12','11:45:00',2.56),('9650','2013-03-12','11:50:00',2.26),('9650','2013-03-12','11:55:00',1.71),('9650','2013-03-12','12:30:00',1.26),('9650','2013-03-12','12:35:00',1.52),('9650','2013-03-12','12:40:00',1.64),('9650','2013-03-12','12:45:00',1.97),('9650','2013-03-12','12:50:00',2.28),('9650','2013-03-12','12:55:00',2.09),('9650','2013-03-12','13:00:00',2.03),('9650','2013-03-12','13:05:00',1.99),('9650','2013-03-12','13:10:00',1.85),('9650','2013-03-12','13:15:00',1.57),('9650','2013-03-12','13:20:00',1.32),('9650','2013-03-12','13:25:00',1.26),('9650','2013-03-12','13:30:00',1.45),('9650','2013-03-12','13:35:00',1.9),('9650','2013-03-12','13:40:00',1.71),('9650','2013-03-12','13:45:00',1.58),('9650','2013-03-12','13:50:00',1.26),('9650','2013-03-12','13:55:00',1.17),('9650','2013-03-12','14:00:00',1.01),('9650','2013-03-12','14:35:00',1.02),('9650','2013-03-12','14:45:00',1.12),('9650','2013-03-12','14:50:00',1.27),('9650','2013-03-12','14:55:00',1.14),('9650','2013-03-12','15:00:00',1.22),('9650','2013-03-12','15:05:00',1.29),('9650','2013-03-12','15:10:00',1.41),('9650','2013-03-12','15:15:00',1.07),('9650','2014-03-24','07:25:00',1.04),('9650','2014-03-24','07:30:00',1.11),('9650','2014-03-24','07:35:00',1.1),('9650','2014-03-24','07:40:00',1.15),('9650','2014-03-24','07:45:00',1.3),('9650','2014-03-24','07:50:00',1.46),('9650','2014-03-24','07:55:00',1.53),('9650','2014-03-24','08:00:00',1.6),('9650','2014-03-24','08:05:00',1.69),('9650','2014-03-24','08:10:00',1.79),('9650','2014-03-24','08:15:00',1.89),('9650','2014-03-24','08:20:00',1.85),('9650','2014-03-24','08:25:00',1.81),('9650','2014-03-24','08:30:00',1.74),('9650','2014-03-24','08:35:00',1.79),('9650','2014-03-24','08:40:00',2),('9650','2014-03-24','08:45:00',2.37),('9650','2014-03-24','08:50:00',2.46),('9650','2014-03-24','08:55:00',2.55),('9650','2014-03-24','09:00:00',2.41),('9650','2014-03-24','09:05:00',2.45),('9650','2014-03-24','09:10:00',2.4),('9650','2014-03-24','09:15:00',2.89),('9650','2014-03-24','09:20:00',3.21),('9650','2014-03-24','09:25:00',3.04),('9650','2014-03-24','09:30:00',2.89),('9650','2014-03-24','09:35:00',2.78),('9650','2014-03-24','09:40:00',2.78),('9650','2014-03-24','09:45:00',2.67),('9650','2014-03-24','09:50:00',2.72),('9650','2014-03-24','09:55:00',2.9),('9650','2014-03-24','10:00:00',3.16),('9650','2014-03-24','10:05:00',3.25),('9650','2014-03-24','10:10:00',3.37),('9650','2014-03-24','10:15:00',3.66),('9650','2014-03-24','10:20:00',3.58),('9650','2014-03-24','10:25:00',3.61),('9650','2014-03-24','10:30:00',4.05),('9650','2014-03-24','10:35:00',3.67),('9650','2014-03-24','10:40:00',3.27),('9650','2014-03-24','10:45:00',3.13),('9650','2014-03-24','10:50:00',3.07),('9650','2014-03-24','10:55:00',3.13),('9650','2014-03-24','11:00:00',3.33),('9650','2014-03-24','11:05:00',3.68),('9650','2014-03-24','11:10:00',4),('9650','2014-03-24','11:15:00',4.46),('9650','2014-03-24','11:20:00',4.55),('9650','2014-03-24','11:25:00',3.97),('9650','2014-03-24','11:30:00',4.52),('9650','2014-03-24','11:35:00',3.82),('9650','2014-03-24','11:40:00',4.09),('9650','2014-03-24','11:45:00',3.22),('9650','2014-03-24','11:50:00',3.82),('9650','2014-03-24','11:55:00',2.98),('9650','2014-03-24','12:00:00',2.08),('9650','2014-03-24','12:05:00',1.38),('9650','2014-03-24','12:10:00',1.33),('9650','2014-03-24','12:15:00',1.56),('9650','2014-03-24','12:20:00',2.01),('9650','2014-03-24','12:25:00',2.26),('9650','2014-03-24','12:30:00',1.83),('9650','2014-03-24','12:35:00',1.54),('9650','2014-03-24','12:40:00',1.61),('9650','2014-03-24','12:45:00',1.52),('9650','2014-03-24','13:30:00',1.06),('9650','2014-03-24','13:35:00',1.47),('9650','2014-03-24','13:40:00',1.45),('9650','2014-03-24','13:45:00',1.26),('9650','2014-03-24','13:50:00',1.29),('9650','2014-03-24','13:55:00',1.3),('9650','2014-03-24','14:00:00',1.26),('9650','2014-03-24','14:05:00',1.33),('9650','2014-03-24','14:10:00',1.43),('9650','2014-03-24','14:15:00',1.52),('9650','2014-03-24','14:20:00',1.16),('9650','2014-03-24','14:35:00',1.13),('9650','2014-03-24','14:40:00',1.17),('9650','2014-03-24','14:45:00',1.23),('9650','2014-03-24','14:50:00',1.04),('9650','2014-03-24','15:15:00',1.1),('9650','2014-03-24','15:20:00',1.15),('9650','2013-03-11','08:45:00',1.54),('9650','2013-03-11','08:50:00',1.21),('9650','2013-03-11','09:05:00',1.37),('9650','2013-03-11','09:10:00',1.48),('9650','2013-03-11','09:15:00',1.62),('9650','2013-03-11','09:20:00',1.76),('9650','2013-03-11','09:25:00',1.86),('9650','2013-03-11','09:30:00',2.09),('9650','2013-03-11','09:35:00',2.18),('9650','2013-03-11','09:40:00',2.28),('9650','2013-03-11','09:45:00',2.07),('9650','2013-03-11','09:50:00',2.07),('9650','2013-03-11','09:55:00',2.96),('9650','2013-03-11','10:00:00',3.09),('9650','2013-03-11','10:05:00',3.38),('9650','2013-03-11','10:10:00',3.05),('9650','2013-03-11','10:15:00',2.83),('9650','2013-03-11','10:20:00',1.71),('9650','2013-03-11','10:25:00',3.15),('9650','2013-03-11','10:30:00',2.44),('9650','2013-03-11','10:35:00',2.64),('9650','2013-03-11','10:40:00',3.03),('9650','2013-03-11','10:45:00',1.87),('9650','2013-03-11','10:50:00',4.35),('9650','2013-03-11','10:55:00',4.22),('9650','2013-03-11','11:00:00',4.86),('9650','2013-03-11','11:05:00',5.27),('9650','2013-03-11','11:10:00',4.66),('9650','2013-03-11','11:15:00',4.68),('9650','2013-03-11','11:20:00',5.81),('9650','2013-03-11','11:25:00',2.43),('9650','2013-03-11','11:30:00',2.98),('9650','2013-03-11','11:35:00',3.41),('9650','2013-03-11','11:40:00',3.54),('9650','2013-03-11','11:45:00',3.88),('9650','2013-03-11','11:50:00',4.33),('9650','2013-03-11','11:55:00',4.61),('9650','2013-03-11','12:00:00',1.57),('9650','2013-03-11','12:05:00',1.51),('9650','2013-03-11','12:10:00',6.31),('9650','2013-03-11','12:15:00',3.71),('9650','2013-03-11','12:20:00',3.5),('9650','2013-03-11','12:25:00',4.52),('9650','2013-03-11','12:30:00',7.65),('9650','2013-03-11','12:35:00',4.05),('9650','2013-03-11','12:40:00',5.73),('9650','2013-03-11','12:45:00',1.98),('9650','2013-03-11','12:50:00',2.99),('9650','2013-03-11','12:55:00',4.46),('9650','2013-03-11','13:00:00',5.88),('9650','2013-03-11','13:05:00',3.82),('9650','2013-03-11','13:10:00',4.07),('9650','2013-03-11','13:15:00',3.19),('9650','2013-03-11','13:20:00',4.69),('9650','2013-03-11','13:25:00',3.3),('9650','2013-03-11','13:30:00',2.74),('9650','2013-03-11','13:35:00',3.05),('9650','2013-03-11','13:40:00',2.93),('9650','2013-03-11','13:45:00',2.26),('9650','2013-03-11','13:50:00',2.17),('9650','2013-03-11','13:55:00',2.84),('9650','2013-03-11','14:00:00',3.86),('9650','2013-03-11','14:05:00',4.53),('9650','2013-03-11','14:10:00',2.86),('9650','2013-03-11','14:15:00',2.3),('9650','2013-03-11','14:20:00',1.76),('9650','2013-03-11','14:25:00',1.05),('9650','2013-03-11','14:35:00',1.04),('9650','2013-03-11','15:00:00',1.77),('9650','2013-03-11','15:05:00',1.07),('9650','2013-03-11','15:10:00',1.77),('9650','2013-03-11','15:15:00',1.74),('9650','2013-03-11','15:20:00',1.82),('9650','2013-03-11','15:25:00',1.63),('9650','2013-03-11','15:30:00',1.04),('9650','2013-03-10','07:40:00',1.03),('9650','2013-03-10','08:50:00',1.03),('9650','2013-03-10','08:55:00',1.12),('9650','2013-03-10','09:00:00',1.19),('9650','2013-03-10','09:05:00',1.3),('9650','2013-03-10','09:10:00',1.43),('9650','2013-03-10','09:15:00',1.58),('9650','2013-03-10','09:20:00',1.62),('9650','2013-03-10','09:25:00',1.44),('9650','2013-03-10','09:30:00',1.22),('9650','2013-03-10','09:45:00',1.78),('9650','2013-03-10','09:50:00',1.31),('9650','2013-03-10','09:55:00',1.32),('9650','2013-03-10','10:00:00',1.39),('9650','2013-03-10','10:05:00',1.63),('9650','2013-03-10','10:10:00',1.95),('9650','2013-03-10','10:15:00',2.06),('9650','2013-03-10','10:20:00',2.3),('9650','2013-03-10','10:25:00',2.46),('9650','2013-03-10','10:30:00',2.33),('9650','2013-03-10','10:35:00',2.63),('9650','2013-03-10','10:40:00',3.34),('9650','2013-03-10','10:45:00',3.46),('9650','2013-03-10','10:50:00',4.36),('9650','2013-03-10','10:55:00',2.84),('9650','2013-03-10','11:00:00',2.61),('9650','2013-03-10','11:05:00',2.15),('9650','2013-03-10','11:10:00',2.39),('9650','2013-03-10','11:15:00',2.54),('9650','2013-03-10','11:20:00',2.27),('9650','2013-03-10','11:25:00',2.06),('9650','2013-03-10','11:30:00',3.41),('9650','2013-03-10','11:35:00',3.51),('9650','2013-03-10','11:40:00',3.18),('9650','2013-03-10','11:45:00',4),('9650','2013-03-10','11:50:00',3.66),('9650','2013-03-10','11:55:00',3.38),('9650','2013-03-10','12:00:00',3.02),('9650','2013-03-10','12:05:00',3),('9650','2013-03-10','12:10:00',3.49),('9650','2013-03-10','12:15:00',1.35),('9650','2013-03-10','12:20:00',1.42),('9650','2013-03-10','12:25:00',1.63),('9650','2013-03-10','12:30:00',1.91),('9650','2013-03-10','12:35:00',2.51),('9650','2013-03-10','12:40:00',1.96),('9650','2013-03-10','12:45:00',2.15),('9650','2013-03-10','12:50:00',3.61),('9650','2013-03-10','12:55:00',4.93),('9650','2013-03-10','13:00:00',3.28),('9650','2013-03-10','13:05:00',2.88),('9650','2013-03-10','13:10:00',4.78),('9650','2013-03-10','13:15:00',5.01),('9650','2013-03-10','13:20:00',6.03),('9650','2013-03-10','13:25:00',5.4),('9650','2013-03-10','13:30:00',5.48),('9650','2013-03-10','13:35:00',5.96),('9650','2013-03-10','13:40:00',4.69),('9650','2013-03-10','13:45:00',5.85),('9650','2013-03-10','13:50:00',5.5),('9650','2013-03-10','13:55:00',2.78),('9650','2013-03-10','14:00:00',1.6),('9650','2013-03-10','14:05:00',1.36),('9650','2013-03-10','14:10:00',1.38),('9650','2013-03-10','14:15:00',1.33),('9650','2013-03-10','14:20:00',2.15),('9650','2013-03-10','14:25:00',2.94),('9650','2013-03-10','14:30:00',2.1),('9650','2013-03-10','14:35:00',1.75),('9650','2013-03-10','14:40:00',2.83),('9650','2013-03-10','14:45:00',1.51),('9650','2013-03-10','14:50:00',1.19),('9650','2013-03-10','15:15:00',1.1),('9650','2013-03-10','15:20:00',1.18),('9650','2013-03-10','15:25:00',2),('9650','2013-03-10','15:30:00',4.19),('9650','2013-03-10','15:35:00',2.09),('9650','2013-03-10','15:40:00',2.68),('9650','2013-03-10','15:45:00',4.48),('9650','2013-03-10','15:50:00',3.7),('9650','2013-03-10','15:55:00',3.39),('9650','2013-03-10','16:00:00',3.4),('9650','2013-03-10','16:05:00',2.69),('9650','2013-03-10','16:10:00',2.82),('9650','2013-03-10','16:15:00',2.35),('9650','2013-03-10','16:20:00',2.76),('9650','2013-03-10','16:25:00',2.56),('9650','2013-03-10','16:30:00',3.1),('9650','2013-03-10','16:35:00',2.45),('9650','2013-03-10','16:40:00',2.58),('9650','2013-03-10','16:45:00',3.05),('9650','2013-03-10','16:50:00',2.06),('9650','2013-03-10','17:05:00',1.42),('9650','2013-03-10','17:10:00',1.18),('9650','2013-03-10','17:15:00',1.32),('9650','2013-03-10','17:20:00',1.43),('9650','2013-03-10','17:25:00',1.05),('9650','2013-03-09','08:55:00',1.06),('9650','2013-03-09','09:00:00',1.17),('9650','2013-03-09','09:05:00',1.26),('9650','2013-03-09','09:10:00',1.33),('9650','2013-03-09','09:15:00',1.42),('9650','2013-03-09','09:20:00',1.67),('9650','2013-03-09','09:25:00',1.82),('9650','2013-03-09','09:30:00',1.96),('9650','2013-03-09','09:35:00',2.12),('9650','2013-03-09','09:40:00',2.37),('9650','2013-03-09','09:45:00',2.5),('9650','2013-03-09','09:50:00',2.78),('9650','2013-03-09','09:55:00',2.64),('9650','2013-03-09','10:00:00',3.27),('9650','2013-03-09','10:05:00',1.89),('9650','2013-03-09','10:10:00',3.02),('9650','2013-03-09','10:15:00',2.53),('9650','2013-03-09','10:20:00',2.4),('9650','2013-03-09','10:25:00',3.68),('9650','2013-03-09','10:30:00',2.89),('9650','2013-03-09','10:35:00',3.01),('9650','2013-03-09','10:40:00',3.48),('9650','2013-03-09','10:45:00',3.75),('9650','2013-03-09','10:50:00',2.4),('9650','2013-03-09','10:55:00',2.1),('9650','2013-03-09','11:00:00',2.52),('9650','2013-03-09','11:05:00',3.44),('9650','2013-03-09','11:10:00',2.83),('9650','2013-03-09','11:15:00',2.37),('9650','2013-03-09','11:20:00',2.67),('9650','2013-03-09','11:25:00',4.1),('9650','2013-03-09','11:30:00',3.12),('9650','2013-03-09','11:35:00',3.73),('9650','2013-03-09','11:40:00',2.1),('9650','2013-03-09','11:45:00',2.19),('9650','2013-03-09','11:50:00',5.35),('9650','2013-03-09','11:55:00',5.35),('9650','2013-03-09','12:00:00',5.38),('9650','2013-03-09','12:05:00',5.17),('9650','2013-03-09','12:10:00',5.41),('9650','2013-03-09','12:15:00',3.7),('9650','2013-03-09','12:20:00',5.78),('9650','2013-03-09','12:25:00',4.8),('9650','2013-03-09','12:30:00',3.84),('9650','2013-03-09','12:35:00',4.44),('9650','2013-03-09','12:40:00',5.67),('9650','2013-03-09','12:45:00',6.13),('9650','2013-03-09','12:50:00',6.24),('9650','2013-03-09','12:55:00',5.93),('9650','2013-03-09','13:00:00',5.72),('9650','2013-03-09','13:05:00',5.54),('9650','2013-03-09','13:10:00',5.23),('9650','2013-03-09','13:15:00',5.5),('9650','2013-03-09','13:20:00',5.67),('9650','2013-03-09','13:25:00',5.42),('9650','2013-03-09','13:30:00',5.21),('9650','2013-03-09','13:35:00',5.25),('9650','2013-03-09','13:40:00',3.47),('9650','2013-03-09','13:45:00',3.76),('9650','2013-03-09','13:50:00',3.23),('9650','2013-03-09','13:55:00',3.04),('9650','2013-03-09','14:00:00',2.58),('9650','2013-03-09','14:05:00',3.45),('9650','2013-03-09','14:10:00',3.55),('9650','2013-03-09','14:15:00',4.92),('9650','2013-03-09','14:20:00',4.95),('9650','2013-03-09','14:25:00',3.01),('9650','2013-03-09','14:30:00',4.29),('9650','2013-03-09','14:35:00',5.21),('9650','2013-03-09','14:40:00',4.67),('9650','2013-03-09','14:45:00',2.9),('9650','2013-03-09','14:50:00',2.92),('9650','2013-03-09','14:55:00',2.54),('9650','2013-03-09','15:00:00',1.93),('9650','2013-03-09','15:05:00',2.33),('9650','2013-03-09','15:10:00',2.3),('9650','2013-03-09','15:15:00',1.55),('9650','2013-03-09','15:20:00',1.55),('9650','2013-03-09','15:35:00',1.03),('9650','2013-03-09','15:40:00',1.03),('9650','2013-03-09','15:45:00',1.05),('9650','2013-03-09','15:50:00',1.56),('9650','2013-03-09','15:55:00',1.25),('9650','2013-03-08','08:50:00',1.12),('9650','2013-03-08','08:55:00',1.25),('9650','2013-03-08','09:00:00',1.3),('9650','2013-03-08','09:05:00',1.11),('9650','2013-03-08','09:15:00',1.36),('9650','2013-03-08','09:20:00',1.1),('9650','2013-03-08','09:25:00',1.67),('9650','2013-03-08','09:30:00',2.4),('9650','2013-03-08','09:35:00',2.86),('9650','2013-03-08','09:40:00',2.78),('9650','2013-03-08','09:45:00',3.63),('9650','2013-03-08','09:50:00',2.23),('9650','2013-03-08','09:55:00',3.34),('9650','2013-03-08','10:00:00',1.47),('9650','2013-03-08','10:05:00',1.71),('9650','2013-03-08','10:10:00',1.62),('9650','2013-03-08','10:15:00',2.12),('9650','2013-03-08','10:20:00',1.74),('9650','2013-03-08','10:25:00',1.61),('9650','2013-03-08','10:30:00',1.65),('9650','2013-03-08','10:35:00',2.2),('9650','2013-03-08','10:40:00',2.39),('9650','2013-03-08','10:45:00',3.51),('9650','2013-03-08','10:50:00',4.21),('9650','2013-03-08','10:55:00',3.42),('9650','2013-03-08','11:00:00',3.93),('9650','2013-03-08','11:05:00',4.44),('9650','2013-03-08','11:10:00',4.62),('9650','2013-03-08','11:15:00',4.68),('9650','2013-03-08','11:20:00',4.79),('9650','2013-03-08','11:25:00',3.99),('9650','2013-03-08','11:30:00',4.63),('9650','2013-03-08','11:35:00',4.79),('9650','2013-03-08','11:40:00',4.91),('9650','2013-03-08','11:45:00',4.97),('9650','2013-03-08','11:50:00',4.95),('9650','2013-03-08','11:55:00',4.77),('9650','2013-03-08','12:00:00',3.52),('9650','2013-03-08','12:05:00',2.33),('9650','2013-03-08','12:10:00',2.29),('9650','2013-03-08','12:15:00',1.92),('9650','2013-03-08','12:20:00',2.71),('9650','2013-03-08','12:25:00',2.79),('9650','2013-03-08','12:30:00',2.34),('9650','2013-03-08','12:35:00',2.79),('9650','2013-03-08','12:40:00',2.62),('9650','2013-03-08','12:45:00',3.47),('9650','2013-03-08','12:50:00',3.02),('9650','2013-03-08','12:55:00',5.17),('9650','2013-03-08','13:00:00',5.7),('9650','2013-03-08','13:05:00',5.42),('9650','2013-03-08','13:10:00',5.51),('9650','2013-03-08','13:15:00',6.02),('9650','2013-03-08','13:20:00',4.81),('9650','2013-03-08','13:25:00',3.36),('9650','2013-03-08','13:30:00',5.93),('9650','2013-03-08','13:35:00',5.61),('9650','2013-03-08','13:40:00',5.61),('9650','2013-03-08','13:45:00',5.55),('9650','2013-03-08','13:50:00',4.7),('9650','2013-03-08','13:55:00',1.61),('9650','2013-03-08','14:00:00',1.67),('9650','2013-03-08','14:05:00',2.43),('9650','2013-03-08','14:10:00',5.33),('9650','2013-03-08','14:15:00',5.23),('9650','2013-03-08','14:20:00',5.08),('9650','2013-03-08','14:25:00',4.94),('9650','2013-03-08','14:30:00',4.71),('9650','2013-03-08','14:35:00',4.61),('9650','2013-03-08','14:40:00',4.56),('9650','2013-03-08','14:45:00',4.44),('9650','2013-03-08','14:50:00',4.41),('9650','2013-03-08','14:55:00',4.41),('9650','2013-03-08','15:00:00',4.15),('9650','2013-03-08','15:05:00',4.06),('9650','2013-03-08','15:10:00',4.05),('9650','2013-03-08','15:15:00',3.94),('9650','2013-03-08','15:20:00',3.84),('9650','2013-03-08','15:25:00',3.78),('9650','2013-03-08','15:30:00',3.66),('9650','2013-03-08','15:35:00',3.64),('9650','2013-03-08','15:40:00',3.64),('9650','2013-03-08','15:45:00',3.71),('9650','2013-03-08','15:50:00',3.63),('9650','2013-03-08','15:55:00',3.34),('9650','2013-03-08','16:00:00',3.09),('9650','2013-03-08','16:05:00',3.17),('9650','2013-03-08','16:10:00',2.72),('9650','2013-03-08','16:15:00',3.13),('9650','2013-03-08','16:20:00',2.58),('9650','2013-03-08','16:25:00',3.1),('9650','2013-03-08','16:30:00',2.82),('9650','2013-03-08','16:35:00',2.46),('9650','2013-03-08','16:40:00',2.28),('9650','2013-03-08','16:45:00',1.68),('9650','2013-03-08','16:50:00',1.59),('9650','2013-03-07','08:15:00',1.09),('9650','2013-03-07','08:25:00',1.16),('9650','2013-03-07','08:30:00',2),('9650','2013-03-07','08:35:00',2.41),('9650','2013-03-07','08:40:00',1.4),('9650','2013-03-07','08:45:00',1.11),('9650','2013-03-07','08:50:00',1.68),('9650','2013-03-07','08:55:00',1.38),('9650','2013-03-07','09:00:00',1.19),('9650','2013-03-07','09:10:00',1),('9650','2013-03-07','09:15:00',1.36),('9650','2013-03-07','09:20:00',1.35),('9650','2013-03-07','09:25:00',1.31),('9650','2013-03-07','09:30:00',2),('9650','2013-03-07','09:35:00',2.41),('9650','2013-03-07','09:40:00',1.57),('9650','2013-03-07','09:45:00',1.69),('9650','2013-03-07','09:50:00',2.02),('9650','2013-03-07','09:55:00',1.72),('9650','2013-03-07','10:00:00',1.53),('9650','2013-03-07','10:05:00',1.96),('9650','2013-03-07','10:10:00',2.44),('9650','2013-03-07','10:15:00',2.67),('9650','2013-03-07','10:20:00',2.29),('9650','2013-03-07','10:25:00',2.33),('9650','2013-03-07','10:30:00',2.83),('9650','2013-03-07','10:35:00',3.46),('9650','2013-03-07','10:40:00',2.37),('9650','2013-03-07','10:45:00',1.83),('9650','2013-03-07','10:50:00',2.35),('9650','2013-03-07','10:55:00',2.15),('9650','2013-03-07','11:00:00',2.03),('9650','2013-03-07','11:05:00',1.4),('9650','2013-03-07','11:10:00',1.07),('9650','2013-03-07','11:35:00',2.53),('9650','2013-03-07','11:40:00',3.38),('9650','2013-03-07','11:45:00',2.79),('9650','2013-03-07','11:50:00',2.43),('9650','2013-03-07','11:55:00',2.89),('9650','2013-03-07','12:00:00',3.5),('9650','2013-03-07','12:05:00',2.47),('9650','2013-03-07','12:10:00',1.97),('9650','2013-03-07','12:15:00',1.64),('9650','2013-03-07','12:20:00',2.31),('9650','2013-03-07','12:25:00',2.08),('9650','2013-03-07','12:30:00',1.85),('9650','2013-03-07','12:35:00',2.87),('9650','2013-03-07','12:40:00',3.36),('9650','2013-03-07','12:45:00',3.52),('9650','2013-03-07','12:50:00',4.16),('9650','2013-03-07','12:55:00',3.66),('9650','2013-03-07','13:00:00',3.55),('9650','2013-03-07','13:05:00',3.49),('9650','2013-03-07','13:10:00',2.45),('9650','2013-03-07','13:15:00',2.04),('9650','2013-03-07','13:20:00',1.96),('9650','2013-03-07','13:25:00',2.6),('9650','2013-03-07','13:30:00',3.54),('9650','2013-03-07','13:35:00',2.52),('9650','2013-03-07','13:40:00',2.23),('9650','2013-03-07','13:45:00',1.36),('9650','2013-03-07','13:50:00',1.13),('9650','2013-03-07','13:55:00',1.58),('9650','2013-03-07','14:00:00',1.08),('9650','2013-03-07','16:55:00',1.11),('9650','2013-03-07','17:05:00',1.28),('9650','2013-03-07','17:10:00',2.68),('9650','2013-03-07','17:15:00',2.01),('9650','2013-03-07','17:20:00',1.29),('9650','2013-03-06','08:35:00',1.13),('9650','2013-03-06','08:40:00',1.54),('9650','2013-03-06','08:45:00',1.59),('9650','2013-03-06','08:50:00',1.82),('9650','2013-03-06','08:55:00',1.51),('9650','2013-03-06','09:00:00',1.47),('9650','2013-03-06','09:05:00',1.53),('9650','2013-03-06','09:15:00',1.24),('9650','2013-03-06','09:20:00',1.45),('9650','2013-03-06','09:55:00',1.15),('9650','2013-03-06','10:25:00',1.15),('9650','2013-03-06','10:30:00',1.59),('9650','2013-03-06','10:50:00',1.9),('9650','2013-03-06','10:55:00',2.19),('9650','2013-03-06','11:00:00',2.07),('9650','2013-03-06','11:05:00',2.55),('9650','2013-03-06','11:10:00',1.84),('9650','2013-03-06','11:15:00',1.38),('9650','2013-03-06','11:20:00',1.09),('9650','2013-03-06','11:25:00',1.33),('9650','2013-03-06','11:30:00',2.89),('9650','2013-03-06','11:35:00',3.91),('9650','2013-03-06','11:40:00',3.75),('9650','2013-03-06','11:45:00',3.87),('9650','2013-03-06','11:50:00',5.08),('9650','2013-03-06','11:55:00',2.69),('9650','2013-03-06','12:00:00',2.21),('9650','2013-03-06','12:05:00',1.92),('9650','2013-03-06','12:10:00',1.03),('9650','2013-03-06','12:25:00',1.64),('9650','2013-03-06','12:30:00',1.69),('9650','2013-03-06','12:35:00',1.06),('9650','2013-03-06','12:40:00',2.18),('9650','2013-03-06','12:45:00',3.24),('9650','2013-03-06','12:50:00',2.98),('9650','2013-03-06','12:55:00',2.65),('9650','2013-03-06','13:00:00',3.05),('9650','2013-03-06','13:05:00',3.32),('9650','2013-03-06','13:10:00',2.92),('9650','2013-03-06','13:15:00',3.15),('9650','2013-03-06','13:20:00',3.79),('9650','2013-03-06','13:25:00',3.32),('9650','2013-03-06','13:30:00',2.8),('9650','2013-03-06','13:35:00',2.66),('9650','2013-03-06','13:40:00',1.51),('9650','2013-03-06','13:55:00',1.32),('9650','2013-03-06','14:00:00',1.32),('9650','2013-03-06','14:05:00',1.69),('9650','2013-03-06','14:10:00',1.86),('9650','2013-03-06','14:15:00',1.41),('9650','2013-03-06','14:20:00',1.39),('9650','2013-03-06','14:25:00',1.43),('9650','2013-03-06','14:45:00',1.36),('9650','2013-03-06','15:20:00',1.17),('9650','2013-03-06','15:25:00',1.56),('9650','2013-03-06','15:30:00',1.24),('9650','2013-03-06','15:35:00',1.53),('9650','2013-03-06','15:40:00',1.67),('9650','2013-03-06','15:45:00',1.19),('9650','2013-03-06','15:55:00',1.04),('9650','2013-03-06','16:05:00',1.17),('9650','2013-03-06','16:10:00',1.11),('9650','2013-03-06','16:15:00',1.05),('9650','2013-03-06','16:20:00',1.13),('9650','2013-03-06','16:35:00',1.08),('9650','2013-03-06','16:40:00',1.73),('9650','2013-03-06','16:45:00',1.21),('9650','2013-03-04','08:25:00',1.02),('9650','2013-03-04','08:30:00',1.2),('9650','2013-03-04','08:35:00',1.26),('9650','2013-03-04','08:40:00',1.43),('9650','2013-03-04','08:45:00',1.48),('9650','2013-03-04','08:50:00',1.7),('9650','2013-03-04','08:55:00',1.9),('9650','2013-03-04','09:00:00',2.1),('9650','2013-03-04','09:05:00',2.25),('9650','2013-03-04','09:10:00',2.19),('9650','2013-03-04','09:15:00',2.21),('9650','2013-03-04','09:20:00',2.29),('9650','2013-03-04','09:25:00',2.27),('9650','2013-03-04','09:30:00',2.37),('9650','2013-03-04','09:35:00',2.52),('9650','2013-03-04','09:40:00',2.64),('9650','2013-03-04','09:45:00',2.68),('9650','2013-03-04','09:50:00',2.6),('9650','2013-03-04','09:55:00',2.49),('9650','2013-03-04','10:00:00',2.36),('9650','2013-03-04','10:05:00',2.51),('9650','2013-03-04','10:10:00',2.66),('9650','2013-03-04','10:15:00',2.8),('9650','2013-03-04','10:20:00',2.92),('9650','2013-03-04','10:25:00',2.73),('9650','2013-03-04','10:30:00',2.62),('9650','2013-03-04','10:35:00',2.89),('9650','2013-03-04','10:40:00',2.97),('9650','2013-03-04','10:45:00',3.14),('9650','2013-03-04','10:50:00',3.35),('9650','2013-03-04','10:55:00',3.4),('9650','2013-03-04','11:00:00',3.21),('9650','2013-03-04','11:05:00',3.43),('9650','2013-03-04','11:10:00',3.59),('9650','2013-03-04','11:15:00',3.65),('9650','2013-03-04','11:20:00',3.64),('9650','2013-03-04','11:25:00',3.61),('9650','2013-03-04','11:30:00',3.78),('9650','2013-03-04','11:35:00',4.12),('9650','2013-03-04','11:40:00',4.39),('9650','2013-03-04','11:45:00',4.23),('9650','2013-03-04','11:50:00',4.22),('9650','2013-03-04','11:55:00',4.26),('9650','2013-03-04','12:00:00',4.36),('9650','2013-03-04','12:05:00',4.55),('9650','2013-03-04','12:10:00',4.76),('9650','2013-03-04','12:15:00',3.87),('9650','2013-03-04','12:20:00',4.39),('9650','2013-03-04','12:25:00',4.47),('9650','2013-03-04','12:30:00',3.84),('9650','2013-03-04','12:35:00',3.75),('9650','2013-03-04','12:40:00',3.84),('9650','2013-03-04','12:45:00',4.09),('9650','2013-03-04','12:50:00',3.64),('9650','2013-03-04','12:55:00',3.35),('9650','2013-03-04','13:00:00',2.9),('9650','2013-03-04','13:05:00',2.81),('9650','2013-03-04','13:10:00',2.97),('9650','2013-03-04','13:15:00',3.18),('9650','2013-03-04','13:20:00',3.03),('9650','2013-03-04','13:25:00',2.76),('9650','2013-03-04','13:30:00',2.54),('9650','2013-03-04','13:35:00',2.41),('9650','2013-03-04','13:40:00',2.28),('9650','2013-03-04','13:45:00',2.08),('9650','2013-03-04','13:50:00',1.9),('9650','2013-03-04','13:55:00',1.83),('9650','2013-03-04','14:00:00',1.85),('9650','2013-03-04','14:05:00',1.89),('9650','2013-03-04','14:10:00',1.95),('9650','2013-03-04','14:15:00',1.8),('9650','2013-03-04','14:20:00',1.71),('9650','2013-03-04','14:25:00',1.73),('9650','2013-03-04','14:30:00',1.69),('9650','2013-03-04','14:35:00',1.71),('9650','2013-03-04','14:40:00',1.75),('9650','2013-03-04','14:45:00',1.79),('9650','2013-03-04','14:50:00',1.74),('9650','2013-03-04','14:55:00',1.59),('9650','2013-03-04','15:00:00',1.44),('9650','2013-03-04','15:05:00',1.35),('9650','2013-03-04','15:10:00',1.11),('9650','2013-03-04','15:20:00',1.08),('9650','2013-03-04','15:25:00',1.22),('9650','2013-03-04','15:30:00',1.31),('9650','2013-03-04','15:35:00',1.33),('9650','2013-03-04','15:40:00',1.53),('9650','2013-03-04','15:45:00',2.09),('9650','2013-03-04','15:50:00',2.06),('9650','2013-03-04','15:55:00',1.71),('9650','2013-03-04','16:00:00',1.53),('9650','2013-03-04','16:05:00',1.36),('9650','2013-03-04','16:10:00',1.12),('9650','2013-03-03','09:00:00',1.02),('9650','2013-03-03','09:05:00',1.13),('9650','2013-03-03','09:10:00',1.25),('9650','2013-03-03','09:15:00',1.35),('9650','2013-03-03','09:20:00',1.46),('9650','2013-03-03','09:25:00',1.59),('9650','2013-03-03','09:30:00',1.7),('9650','2013-03-03','09:35:00',1.8),('9650','2013-03-03','09:40:00',1.93),('9650','2013-03-03','09:45:00',2.02),('9650','2013-03-03','09:50:00',2.16),('9650','2013-03-03','09:55:00',2.26),('9650','2013-03-03','10:00:00',2.39),('9650','2013-03-03','10:05:00',2.54),('9650','2013-03-03','10:10:00',2.64),('9650','2013-03-03','10:15:00',2.8),('9650','2013-03-03','10:20:00',2.93),('9650','2013-03-03','10:25:00',3.02),('9650','2013-03-03','10:30:00',3.12),('9650','2013-03-03','10:35:00',3.25),('9650','2013-03-03','10:40:00',3.34),('9650','2013-03-03','10:45:00',3.43),('9650','2013-03-03','10:50:00',3.52),('9650','2013-03-03','10:55:00',3.58),('9650','2013-03-03','11:00:00',3.7),('9650','2013-03-03','11:05:00',3.81),('9650','2013-03-03','11:10:00',3.9),('9650','2013-03-03','11:15:00',4.02),('9650','2013-03-03','11:20:00',4.09),('9650','2013-03-03','11:25:00',4.18),('9650','2013-03-03','11:30:00',4.27),('9650','2013-03-03','11:35:00',4.3),('9650','2013-03-03','11:40:00',4.35),('9650','2013-03-03','11:45:00',4.42),('9650','2013-03-03','11:50:00',4.47),('9650','2013-03-03','11:55:00',4.55),('9650','2013-03-03','12:00:00',4.63),('9650','2013-03-03','12:05:00',4.69),('9650','2013-03-03','12:10:00',4.8),('9650','2013-03-03','12:15:00',4.89),('9650','2013-03-03','12:20:00',4.89),('9650','2013-03-03','12:25:00',4.96),('9650','2013-03-03','12:30:00',4.95),('9650','2013-03-03','12:35:00',5.01),('9650','2013-03-03','12:40:00',5.06),('9650','2013-03-03','12:45:00',5.07),('9650','2013-03-03','12:50:00',5.1),('9650','2013-03-03','12:55:00',5.05),('9650','2013-03-03','13:00:00',5),('9650','2013-03-03','13:05:00',5),('9650','2013-03-03','13:10:00',5),('9650','2013-03-03','13:15:00',4.92),('9650','2013-03-03','13:20:00',4.8),('9650','2013-03-03','13:25:00',4.65),('9650','2013-03-03','13:30:00',4.19),('9650','2013-03-03','13:35:00',5.13),('9650','2013-03-03','13:40:00',4.79),('9650','2013-03-03','13:45:00',4.48),('9650','2013-03-03','13:50:00',4.61),('9650','2013-03-03','13:55:00',4.7),('9650','2013-03-03','14:00:00',4.72),('9650','2013-03-03','14:05:00',4.62),('9650','2013-03-03','14:10:00',4.37),('9650','2013-03-03','14:15:00',4.23),('9650','2013-03-03','14:20:00',4.36),('9650','2013-03-03','14:25:00',4.21),('9650','2013-03-03','14:30:00',4.11),('9650','2013-03-03','14:35:00',3.37),('9650','2013-03-03','14:40:00',4.08),('9650','2013-03-03','14:45:00',3.98),('9650','2013-03-03','14:50:00',3.85),('9650','2013-03-03','14:55:00',3.7),('9650','2013-03-03','15:00:00',3.73),('9650','2013-03-03','15:05:00',3.57),('9650','2013-03-03','15:10:00',3.52),('9650','2013-03-03','15:15:00',3.4),('9650','2013-03-03','15:20:00',3.31),('9650','2013-03-03','15:25:00',3.24),('9650','2013-03-03','15:30:00',3.25),('9650','2013-03-03','15:35:00',3.18),('9650','2013-03-03','15:40:00',3.1),('9650','2013-03-03','15:45:00',3.05),('9650','2013-03-03','15:50:00',2.99),('9650','2013-03-03','15:55:00',2.95),('9650','2013-03-03','16:00:00',2.9),('9650','2013-03-03','16:05:00',2.77),('9650','2013-03-03','16:10:00',2.67),('9650','2013-03-03','16:15:00',2.55),('9650','2013-03-03','16:20:00',2.48),('9650','2013-03-03','16:25:00',2.45),('9650','2013-03-03','16:30:00',2.35),('9650','2013-03-03','16:35:00',2.22),('9650','2013-03-03','16:40:00',2.12),('9650','2013-03-03','16:45:00',1.99),('9650','2013-03-03','16:50:00',1.9),('9650','2013-03-03','16:55:00',1.75),('9650','2013-03-03','17:00:00',1.55),('9650','2013-03-03','17:05:00',1.33),('9650','2013-03-03','17:10:00',1.14),('9650','2013-03-02','09:10:00',1.01),('9650','2013-03-02','09:15:00',1.12),('9650','2013-03-02','09:20:00',1.23),('9650','2013-03-02','09:25:00',1.32),('9650','2013-03-02','09:30:00',1.38),('9650','2013-03-02','09:35:00',1.61),('9650','2013-03-02','09:40:00',1.76),('9650','2013-03-02','09:45:00',1.9),('9650','2013-03-02','09:50:00',2.05),('9650','2013-03-02','09:55:00',2.18),('9650','2013-03-02','10:00:00',2.33),('9650','2013-03-02','10:05:00',2.45),('9650','2013-03-02','10:10:00',2.59),('9650','2013-03-02','10:15:00',2.73),('9650','2013-03-02','10:20:00',2.86),('9650','2013-03-02','10:25:00',3),('9650','2013-03-02','10:30:00',3.1),('9650','2013-03-02','10:35:00',3.22),('9650','2013-03-02','10:40:00',3.35),('9650','2013-03-02','10:45:00',3.46),('9650','2013-03-02','10:50:00',3.56),('9650','2013-03-02','10:55:00',3.67),('9650','2013-03-02','11:00:00',3.78),('9650','2013-03-02','11:05:00',3.87),('9650','2013-03-02','11:10:00',3.97),('9650','2013-03-02','11:15:00',4.05),('9650','2013-03-02','11:20:00',4.15),('9650','2013-03-02','11:25:00',4.23),('9650','2013-03-02','11:30:00',4.32),('9650','2013-03-02','11:35:00',4.41),('9650','2013-03-02','11:40:00',4.45),('9650','2013-03-02','11:45:00',4.55),('9650','2013-03-02','11:50:00',4.61),('9650','2013-03-02','11:55:00',4.7),('9650','2013-03-02','12:00:00',4.78),('9650','2013-03-02','12:05:00',4.81),('9650','2013-03-02','12:10:00',4.87),('9650','2013-03-02','12:15:00',4.93),('9650','2013-03-02','12:20:00',4.97),('9650','2013-03-02','12:25:00',5.02),('9650','2013-03-02','12:30:00',5.09),('9650','2013-03-02','12:35:00',5.11),('9650','2013-03-02','12:40:00',5.14),('9650','2013-03-02','12:45:00',5.21),('9650','2013-03-02','12:50:00',5.23),('9650','2013-03-02','12:55:00',5.25),('9650','2013-03-02','13:00:00',5.23),('9650','2013-03-02','13:05:00',5.22),('9650','2013-03-02','13:10:00',5.16),('9650','2013-03-02','13:15:00',5.1),('9650','2013-03-02','13:20:00',4.96),('9650','2013-03-02','13:25:00',4.92),('9650','2013-03-02','13:30:00',4.93),('9650','2013-03-02','13:35:00',4.9),('9650','2013-03-02','13:40:00',4.91),('9650','2013-03-02','13:45:00',4.88),('9650','2013-03-02','13:50:00',4.83),('9650','2013-03-02','13:55:00',4.8),('9650','2013-03-02','14:00:00',4.82),('9650','2013-03-02','14:05:00',4.86),('9650','2013-03-02','14:10:00',4.71),('9650','2013-03-02','14:15:00',4.62),('9650','2013-03-02','14:20:00',4.6),('9650','2013-03-02','14:25:00',4.58),('9650','2013-03-02','14:30:00',4.42),('9650','2013-03-02','14:35:00',4.38),('9650','2013-03-02','14:40:00',4.33),('9650','2013-03-02','14:45:00',4.25),('9650','2013-03-02','14:50:00',4.15),('9650','2013-03-02','14:55:00',4.05),('9650','2013-03-02','15:00:00',3.94),('9650','2013-03-02','15:05:00',3.73),('9650','2013-03-02','15:10:00',3.58),('9650','2013-03-02','15:15:00',3.61),('9650','2013-03-02','15:20:00',3.58),('9650','2013-03-02','15:25:00',3.51),('9650','2013-03-02','15:30:00',3.47),('9650','2013-03-02','15:40:00',1.36),('9650','2013-03-02','15:45:00',3.29),('9650','2013-03-02','15:50:00',3.29),('9650','2013-03-02','15:55:00',3.22),('9650','2013-03-02','16:00:00',3.12),('9650','2013-03-02','16:05:00',3.03),('9650','2013-03-02','16:10:00',2.96),('9650','2013-03-02','16:15:00',2.8),('9650','2013-03-02','16:20:00',2.71),('9650','2013-03-02','16:25:00',2.62),('9650','2013-03-02','16:30:00',2.52),('9650','2013-03-02','16:35:00',2.4),('9650','2013-03-02','16:40:00',2.33),('9650','2013-03-02','16:45:00',2.21),('9650','2013-03-02','16:50:00',2.07),('9650','2013-03-02','16:55:00',1.89),('9650','2013-03-02','17:00:00',1.7),('9650','2013-03-02','17:05:00',1.49),('9650','2013-03-02','17:10:00',1.25),('9650','2014-03-23','07:45:00',1.59),('9650','2014-03-23','07:50:00',1.3),('9650','2014-03-23','07:55:00',1.44),('9650','2014-03-23','08:35:00',1.3),('9650','2014-03-23','08:40:00',1.43),('9650','2014-03-23','08:45:00',1.04),('9650','2014-03-23','08:50:00',1.27),('9650','2014-03-23','08:55:00',2.11),('9650','2014-03-23','09:00:00',2.26),('9650','2014-03-23','09:05:00',1.53),('9650','2014-03-23','09:10:00',1.02),('9650','2014-03-23','09:15:00',1.12),('9650','2014-03-23','09:20:00',1.75),('9650','2014-03-23','09:25:00',1.34),('9650','2014-03-23','09:30:00',1.82),('9650','2014-03-23','09:35:00',1.4),('9650','2014-03-23','09:40:00',1.95),('9650','2014-03-23','09:45:00',1.78),('9650','2014-03-23','09:50:00',1.82),('9650','2014-03-23','09:55:00',1.13),('9650','2014-03-23','10:00:00',2.52),('9650','2014-03-23','10:05:00',3.01),('9650','2014-03-23','10:10:00',4.25),('9650','2014-03-23','10:15:00',3.58),('9650','2014-03-23','10:20:00',1.62),('9650','2014-03-23','10:25:00',1.44),('9650','2014-03-23','10:30:00',1.38),('9650','2014-03-23','10:35:00',2.12),('9650','2014-03-23','10:40:00',1.78),('9650','2014-03-23','10:45:00',2.62),('9650','2014-03-23','10:50:00',5.79),('9650','2014-03-23','10:55:00',4.77),('9650','2014-03-23','11:00:00',2.53),('9650','2014-03-23','11:05:00',3.3),('9650','2014-03-23','11:10:00',4.03),('9650','2014-03-23','11:15:00',4.63),('9650','2014-03-23','11:20:00',3.86),('9650','2014-03-23','11:25:00',4.73),('9650','2014-03-23','11:30:00',5.57),('9650','2014-03-23','11:35:00',2.65),('9650','2014-03-23','11:40:00',1.31),('9650','2014-03-23','11:45:00',1.07),('9650','2014-03-23','11:50:00',1.11),('9650','2014-03-23','11:55:00',1.29),('9650','2014-03-23','12:00:00',1.08),('9650','2014-03-23','12:20:00',1.02),('9650','2014-03-23','12:25:00',1.23),('9650','2014-03-23','12:30:00',2.08),('9650','2014-03-23','12:35:00',3.45),('9650','2014-03-23','12:40:00',3.44),('9650','2014-03-23','12:45:00',3),('9650','2014-03-23','12:50:00',2.63),('9650','2014-03-23','12:55:00',2.55),('9650','2014-03-23','13:00:00',2.59),('9650','2014-03-23','13:05:00',2.57),('9650','2014-03-23','13:10:00',2.22),('9650','2014-03-23','13:15:00',1.97),('9650','2014-03-23','13:20:00',1.99),('9650','2014-03-23','13:25:00',2.24),('9650','2014-03-23','13:30:00',2.5),('9650','2014-03-23','13:35:00',2.11),('9650','2014-03-23','13:40:00',1.41),('9650','2014-03-23','13:45:00',2),('9650','2014-03-23','13:50:00',2.39),('9650','2014-03-23','13:55:00',2.38),('9650','2014-03-23','14:00:00',2.09),('9650','2014-03-23','14:05:00',1.95),('9650','2014-03-23','14:10:00',2.31),('9650','2014-03-23','14:15:00',2.95),('9650','2014-03-23','14:20:00',3.8),('9650','2014-03-23','14:25:00',3.71),('9650','2014-03-23','14:30:00',3.4),('9650','2014-03-23','14:35:00',4.08),('9650','2014-03-23','14:40:00',5.29),('9650','2014-03-23','14:45:00',5.94),('9650','2014-03-23','14:50:00',5.96),('9650','2014-03-23','14:55:00',5.12),('9650','2014-03-23','15:00:00',4.53),('9650','2014-03-23','15:05:00',3.93),('9650','2014-03-23','15:10:00',3.59),('9650','2014-03-23','15:15:00',2.64),('9650','2014-03-23','15:20:00',3.01),('9650','2014-03-23','15:25:00',2.79),('9650','2014-03-23','15:30:00',2.99),('9650','2014-03-23','15:45:00',2.13),('9650','2014-03-23','15:50:00',2.47),('9650','2014-03-23','15:55:00',2.86),('9650','2014-03-23','16:00:00',4.8),('9650','2014-03-23','16:05:00',2.44),('9650','2014-03-23','16:10:00',1.9),('9650','2014-03-23','16:15:00',1.37),('9650','2014-03-23','17:40:00',1.24),('9650','2014-03-23','17:45:00',1.26),('9650','2014-03-23','17:50:00',1.01),('9650','2013-03-01','08:55:00',1.04),('9650','2013-03-01','09:00:00',1.12),('9650','2013-03-01','09:05:00',1.02),('9650','2013-03-01','09:40:00',1.09),('9650','2013-03-01','09:45:00',1.31),('9650','2013-03-01','09:50:00',1.39),('9650','2013-03-01','09:55:00',1.25),('9650','2013-03-01','10:00:00',1.12),('9650','2013-03-01','10:05:00',1.14),('9650','2013-03-01','10:10:00',1.05),('9650','2013-03-01','10:15:00',1.1),('9650','2013-03-01','10:20:00',1.3),('9650','2013-03-01','10:25:00',1.44),('9650','2013-03-01','10:30:00',1.58),('9650','2013-03-01','10:35:00',1.69),('9650','2013-03-01','10:40:00',1.8),('9650','2013-03-01','10:45:00',1.81),('9650','2013-03-01','10:50:00',1.96),('9650','2013-03-01','10:55:00',2.02),('9650','2013-03-01','11:00:00',2.12),('9650','2013-03-01','11:05:00',2.27),('9650','2013-03-01','11:10:00',2.3),('9650','2013-03-01','11:15:00',2.68),('9650','2013-03-01','11:20:00',2.4),('9650','2013-03-01','11:25:00',2.18),('9650','2013-03-01','11:30:00',2.04),('9650','2013-03-01','11:35:00',2.08),('9650','2013-03-01','11:40:00',2.37),('9650','2013-03-01','11:45:00',2.16),('9650','2013-03-01','11:50:00',2.19),('9650','2013-03-01','11:55:00',2.06),('9650','2013-03-01','12:00:00',2.01),('9650','2013-03-01','12:05:00',2.27),('9650','2013-03-01','12:10:00',2.22),('9650','2013-03-01','12:15:00',2.28),('9650','2013-03-01','12:20:00',2.17),('9650','2013-03-01','12:25:00',2.24),('9650','2013-03-01','12:30:00',2.42),('9650','2013-03-01','12:35:00',2.59),('9650','2013-03-01','12:40:00',3.06),('9650','2013-03-01','12:45:00',2.7),('9650','2013-03-01','12:50:00',2.46),('9650','2013-03-01','12:55:00',2.7),('9650','2013-03-01','13:00:00',2.52),('9650','2013-03-01','13:05:00',2.17),('9650','2013-03-01','13:10:00',1.78),('9650','2013-03-01','13:15:00',1.63),('9650','2013-03-01','13:20:00',1.59),('9650','2013-03-01','13:25:00',1.6),('9650','2013-03-01','13:30:00',1.81),('9650','2013-03-01','13:35:00',1.86),('9650','2013-03-01','13:40:00',1.96),('9650','2013-03-01','13:45:00',2.11),('9650','2013-03-01','13:50:00',2.03),('9650','2013-03-01','13:55:00',2.11),('9650','2013-03-01','14:00:00',2.32),('9650','2013-03-01','14:05:00',2.25),('9650','2013-03-01','14:10:00',1.94),('9650','2013-03-01','14:15:00',1.73),('9650','2013-03-01','14:20:00',1.65),('9650','2013-03-01','14:25:00',1.33),('9650','2013-03-01','14:30:00',1.01),('9650','2013-03-01','14:50:00',1.21),('9650','2013-03-01','14:55:00',1.33),('9650','2013-03-01','15:00:00',1.3),('9650','2013-03-01','15:05:00',1.49),('9650','2013-03-01','15:10:00',1.48),('9650','2013-03-01','15:15:00',1.41),('9650','2013-03-01','15:20:00',1.35),('9650','2013-03-01','15:25:00',1.29),('9650','2013-03-01','15:30:00',1.43),('9650','2013-03-01','15:35:00',1.37),('9650','2013-03-01','15:40:00',1.29),('9650','2013-03-01','15:45:00',1.49),('9650','2013-03-01','15:50:00',1.32),('9650','2013-03-01','15:55:00',1.29),('9650','2013-03-01','16:00:00',1.12),('9650','2013-02-28','08:15:00',1.04),('9650','2013-02-28','08:20:00',1.1),('9650','2013-02-28','08:25:00',1.15),('9650','2013-02-28','08:30:00',1.21),('9650','2013-02-28','08:35:00',1.28),('9650','2013-02-28','08:40:00',1.33),('9650','2013-02-28','08:45:00',1.41),('9650','2013-02-28','08:50:00',1.44),('9650','2013-02-28','08:55:00',1.5),('9650','2013-02-28','09:00:00',1.54),('9650','2013-02-28','09:05:00',1.6),('9650','2013-02-28','09:10:00',1.62),('9650','2013-02-28','09:15:00',1.66),('9650','2013-02-28','09:20:00',1.72),('9650','2013-02-28','09:25:00',1.77),('9650','2013-02-28','09:30:00',1.86),('9650','2013-02-28','09:35:00',1.87),('9650','2013-02-28','09:40:00',2.02),('9650','2013-02-28','09:45:00',2.18),('9650','2013-02-28','09:50:00',2.25),('9650','2013-02-28','09:55:00',2.34),('9650','2013-02-28','10:00:00',2.49),('9650','2013-02-28','10:05:00',2.6),('9650','2013-02-28','10:10:00',2.68),('9650','2013-02-28','10:15:00',2.53),('9650','2013-02-28','10:20:00',2.61),('9650','2013-02-28','10:25:00',2.81),('9650','2013-02-28','10:30:00',3.15),('9650','2013-02-28','10:35:00',3.34),('9650','2013-02-28','10:40:00',3.14),('9650','2013-02-28','10:45:00',3.07),('9650','2013-02-28','10:50:00',3.03),('9650','2013-02-28','10:55:00',2.97),('9650','2013-02-28','11:00:00',2.76),('9650','2013-02-28','11:05:00',2.58),('9650','2013-02-28','11:10:00',2.57),('9650','2013-02-28','11:15:00',2.78),('9650','2013-02-28','11:20:00',2.89),('9650','2013-02-28','11:25:00',2.89),('9650','2013-02-28','11:30:00',2.94),('9650','2013-02-28','11:35:00',2.96),('9650','2013-02-28','11:40:00',2.87),('9650','2013-02-28','11:45:00',2.78),('9650','2013-02-28','11:50:00',2.76),('9650','2013-02-28','11:55:00',2.66),('9650','2013-02-28','12:00:00',2.55),('9650','2013-02-28','12:05:00',2.43),('9650','2013-02-28','12:10:00',2.28),('9650','2013-02-28','12:15:00',2.1),('9650','2013-02-28','12:20:00',2.01),('9650','2013-02-28','12:25:00',2),('9650','2013-02-28','12:30:00',2.07),('9650','2013-02-28','12:35:00',2.06),('9650','2013-02-28','12:40:00',1.98),('9650','2013-02-28','12:45:00',1.98),('9650','2013-02-28','12:50:00',2.05),('9650','2013-02-28','12:55:00',2.16),('9650','2013-02-28','13:00:00',2.27),('9650','2013-02-28','13:05:00',2.28),('9650','2013-02-28','13:10:00',2.37),('9650','2013-02-28','13:15:00',2.52),('9650','2013-02-28','13:20:00',2.69),('9650','2013-02-28','13:25:00',2.92),('9650','2013-02-28','13:30:00',2.84),('9650','2013-02-28','13:35:00',2.64),('9650','2013-02-28','13:40:00',2.52),('9650','2013-02-28','13:45:00',2.5),('9650','2013-02-28','13:50:00',2.49),('9650','2013-02-28','13:55:00',2.4),('9650','2013-02-28','14:00:00',2.34),('9650','2013-02-28','14:05:00',2.24),('9650','2013-02-28','14:10:00',2.11),('9650','2013-02-28','14:15:00',2),('9650','2013-02-28','14:20:00',1.93),('9650','2013-02-28','14:25:00',1.94),('9650','2013-02-28','14:30:00',1.99),('9650','2013-02-28','14:35:00',1.97),('9650','2013-02-28','14:40:00',1.88),('9650','2013-02-28','14:45:00',1.77),('9650','2013-02-28','14:50:00',1.68),('9650','2013-02-28','14:55:00',1.66),('9650','2013-02-28','15:00:00',1.68),('9650','2013-02-28','15:05:00',1.64),('9650','2013-02-28','15:10:00',1.51),('9650','2013-02-28','15:15:00',1.38),('9650','2013-02-28','15:20:00',1.3),('9650','2013-02-28','15:25:00',1.18),('9650','2013-02-28','15:30:00',1.05),('9650','2013-02-28','15:35:00',1.05),('9650','2013-02-28','15:40:00',1.15),('9650','2013-02-28','15:45:00',1.13),('9650','2013-02-28','15:50:00',1.05),('9650','2013-02-28','15:55:00',1.01),('9650','2013-02-28','16:00:00',1.01),('9650','2013-02-28','16:05:00',1.01),('9650','2013-02-27','09:00:00',1.01),('9650','2013-02-27','09:05:00',1.1),('9650','2013-02-27','09:10:00',1.18),('9650','2013-02-27','09:15:00',1.27),('9650','2013-02-27','09:20:00',1.39),('9650','2013-02-27','09:25:00',1.5),('9650','2013-02-27','09:30:00',1.6),('9650','2013-02-27','09:35:00',1.71),('9650','2013-02-27','09:40:00',1.82),('9650','2013-02-27','09:45:00',1.94),('9650','2013-02-27','09:50:00',1.9),('9650','2013-02-27','09:55:00',2.07),('9650','2013-02-27','10:00:00',2.21),('9650','2013-02-27','10:05:00',2.34),('9650','2013-02-27','10:10:00',2.44),('9650','2013-02-27','10:15:00',2.54),('9650','2013-02-27','10:20:00',2.69),('9650','2013-02-27','10:25:00',2.79),('9650','2013-02-27','10:30:00',2.82),('9650','2013-02-27','10:35:00',2.96),('9650','2013-02-27','10:40:00',3.08),('9650','2013-02-27','10:45:00',3.19),('9650','2013-02-27','10:50:00',3.31),('9650','2013-02-27','10:55:00',3.37),('9650','2013-02-27','11:00:00',3.51),('9650','2013-02-27','11:05:00',3.63),('9650','2013-02-27','11:10:00',3.75),('9650','2013-02-27','11:15:00',3.81),('9650','2013-02-27','11:20:00',3.89),('9650','2013-02-27','11:25:00',4.1),('9650','2013-02-27','11:30:00',4.06),('9650','2013-02-27','11:35:00',4.15),('9650','2013-02-27','11:40:00',4.12),('9650','2013-02-27','11:45:00',4.04),('9650','2013-02-27','11:50:00',4.21),('9650','2013-02-27','11:55:00',4.25),('9650','2013-02-27','12:00:00',4.33),('9650','2013-02-27','12:05:00',4.25),('9650','2013-02-27','12:10:00',4.34),('9650','2013-02-27','12:15:00',4.58),('9650','2013-02-27','12:20:00',4.74),('9650','2013-02-27','12:25:00',4.7),('9650','2013-02-27','12:30:00',4.83),('9650','2013-02-27','12:35:00',4.83),('9650','2013-02-27','12:40:00',4.84),('9650','2013-02-27','12:45:00',4.8),('9650','2013-02-27','12:50:00',4.81),('9650','2013-02-27','12:55:00',4.89),('9650','2013-02-27','13:00:00',4.69),('9650','2013-02-27','13:05:00',4.88),('9650','2013-02-27','13:10:00',4.78),('9650','2013-02-27','13:15:00',4.77),('9650','2013-02-27','13:20:00',2.9),('9650','2013-02-27','13:25:00',3.23),('9650','2013-02-27','13:30:00',3.39),('9650','2013-02-27','13:35:00',4.85),('9650','2013-02-27','13:40:00',4.82),('9650','2013-02-27','13:45:00',4.84),('9650','2013-02-27','13:50:00',4.77),('9650','2013-02-27','13:55:00',4.9),('9650','2013-02-27','14:00:00',5.23),('9650','2013-02-27','14:05:00',5.08),('9650','2013-02-27','14:10:00',4.93),('9650','2013-02-27','14:15:00',4.66),('9650','2013-02-27','14:20:00',4.45),('9650','2013-02-27','14:25:00',4.31),('9650','2013-02-27','14:30:00',4.06),('9650','2013-02-27','14:35:00',3.81),('9650','2013-02-27','14:40:00',3.95),('9650','2013-02-27','14:45:00',3.88),('9650','2013-02-27','14:50:00',3.82),('9650','2013-02-27','14:55:00',3.63),('9650','2013-02-27','15:00:00',3.71),('9650','2013-02-27','15:05:00',3.48),('9650','2013-02-27','15:10:00',3.36),('9650','2013-02-27','15:15:00',3.32),('9650','2013-02-27','15:20:00',3.36),('9650','2013-02-27','15:25:00',3.11),('9650','2013-02-27','15:30:00',2.94),('9650','2013-02-27','15:35:00',2.87),('9650','2013-02-27','15:40:00',2.8),('9650','2013-02-27','15:45:00',2.82),('9650','2013-02-27','15:50:00',2.78),('9650','2013-02-27','15:55:00',2.69),('9650','2013-02-27','16:00:00',2.61),('9650','2013-02-27','16:05:00',2.47),('9650','2013-02-27','16:10:00',2.36),('9650','2013-02-27','16:15:00',2.25),('9650','2013-02-27','16:20:00',2.16),('9650','2013-02-27','16:25:00',2.08),('9650','2013-02-27','16:30:00',1.92),('9650','2013-02-27','16:35:00',1.91),('9650','2013-02-27','16:40:00',1.8),('9650','2013-02-27','16:45:00',1.68),('9650','2013-02-27','16:50:00',1.54),('9650','2013-02-27','16:55:00',1.35),('9650','2013-02-27','17:00:00',1.06),('9650','2013-02-26','09:10:00',1.06),('9650','2013-02-26','09:15:00',1.14),('9650','2013-02-26','09:20:00',1.24),('9650','2013-02-26','09:25:00',1.33),('9650','2013-02-26','09:30:00',1.43),('9650','2013-02-26','09:35:00',1.54),('9650','2013-02-26','09:40:00',1.65),('9650','2013-02-26','09:45:00',1.76),('9650','2013-02-26','09:50:00',1.86),('9650','2013-02-26','09:55:00',1.95),('9650','2013-02-26','10:00:00',2.09),('9650','2013-02-26','10:05:00',2.2),('9650','2013-02-26','10:10:00',2.3),('9650','2013-02-26','10:15:00',2.45),('9650','2013-02-26','10:20:00',2.58),('9650','2013-02-26','10:25:00',2.68),('9650','2013-02-26','10:30:00',2.8),('9650','2013-02-26','10:35:00',2.87),('9650','2013-02-26','10:40:00',2.95),('9650','2013-02-26','10:45:00',3.11),('9650','2013-02-26','10:50:00',3.21),('9650','2013-02-26','10:55:00',3.29),('9650','2013-02-26','11:00:00',3.43),('9650','2013-02-26','11:05:00',3.48),('9650','2013-02-26','11:10:00',3.51),('9650','2013-02-26','11:15:00',3.35),('9650','2013-02-26','11:20:00',3.44),('9650','2013-02-26','11:25:00',3.31),('9650','2013-02-26','11:30:00',1.37),('9650','2013-02-26','11:35:00',1.2),('9650','2013-02-26','11:40:00',1.35),('9650','2013-02-26','11:50:00',3.21),('9650','2013-02-26','11:55:00',3.67),('9650','2013-02-26','12:00:00',4.65),('9650','2013-02-26','12:05:00',4.58),('9650','2013-02-26','12:10:00',1.77),('9650','2013-02-26','12:15:00',4.55),('9650','2013-02-26','12:20:00',5),('9650','2013-02-26','12:25:00',4.91),('9650','2013-02-26','12:30:00',4.82),('9650','2013-02-26','12:35:00',4.91),('9650','2013-02-26','12:40:00',4.95),('9650','2013-02-26','12:45:00',4.97),('9650','2013-02-26','12:50:00',4.94),('9650','2013-02-26','12:55:00',4.97),('9650','2013-02-26','13:00:00',5.05),('9650','2013-02-26','13:05:00',5.02),('9650','2013-02-26','13:10:00',4.69),('9650','2013-02-26','13:15:00',4.8),('9650','2013-02-26','13:20:00',4.99),('9650','2013-02-26','13:25:00',5),('9650','2013-02-26','13:30:00',4.97),('9650','2013-02-26','13:35:00',4.82),('9650','2013-02-26','13:40:00',4.89),('9650','2013-02-26','13:45:00',4.86),('9650','2013-02-26','13:50:00',4.74),('9650','2013-02-26','13:55:00',4.75),('9650','2013-02-26','14:00:00',4.61),('9650','2013-02-26','14:05:00',4.45),('9650','2013-02-26','14:10:00',4.13),('9650','2013-02-26','14:15:00',3.63),('9650','2013-02-26','14:20:00',4.14),('9650','2013-02-26','14:25:00',1.85),('9650','2013-02-26','14:30:00',3.97),('9650','2013-02-26','14:35:00',4.2),('9650','2013-02-26','14:40:00',4.15),('9650','2013-02-26','14:45:00',4.07),('9650','2013-02-26','14:50:00',3.81),('9650','2013-02-26','14:55:00',3.62),('9650','2013-02-26','15:00:00',3.87),('9650','2013-02-26','15:05:00',3.74),('9650','2013-02-26','15:10:00',3.36),('9650','2013-02-26','15:15:00',3.04),('9650','2013-02-26','15:20:00',3.04),('9650','2013-02-26','15:25:00',3.22),('9650','2013-02-26','15:30:00',3.15),('9650','2013-02-26','15:35:00',3.13),('9650','2013-02-26','15:40:00',3.06),('9650','2013-02-26','15:45:00',3.01),('9650','2013-02-26','15:50:00',2.93),('9650','2013-02-26','15:55:00',2.91),('9650','2013-02-26','16:00:00',2.8),('9650','2013-02-26','16:05:00',2.69),('9650','2013-02-26','16:10:00',2.6),('9650','2013-02-26','16:15:00',2.46),('9650','2013-02-26','16:20:00',2.4),('9650','2013-02-26','16:25:00',2.28),('9650','2013-02-26','16:30:00',2.13),('9650','2013-02-26','16:35:00',2.01),('9650','2013-02-26','16:40:00',1.88),('9650','2013-02-26','16:45:00',1.74),('9650','2013-02-26','16:50:00',1.58),('9650','2013-02-26','16:55:00',1.31),('9650','2013-02-26','17:00:00',1.03),('9650','2013-02-25','08:50:00',1.04),('9650','2013-02-25','08:55:00',1.18),('9650','2013-02-25','09:00:00',1.27),('9650','2013-02-25','09:05:00',1.31),('9650','2013-02-25','09:10:00',1.35),('9650','2013-02-25','09:15:00',1.52),('9650','2013-02-25','09:20:00',1.62),('9650','2013-02-25','09:25:00',1.7),('9650','2013-02-25','09:30:00',1.85),('9650','2013-02-25','09:35:00',2.07),('9650','2013-02-25','09:40:00',2.16),('9650','2013-02-25','09:45:00',2.13),('9650','2013-02-25','09:50:00',2.11),('9650','2013-02-25','09:55:00',2.22),('9650','2013-02-25','10:00:00',2.12),('9650','2013-02-25','10:05:00',2),('9650','2013-02-25','10:10:00',2.19),('9650','2013-02-25','10:15:00',2.41),('9650','2013-02-25','10:20:00',2.96),('9650','2013-02-25','10:25:00',3.23),('9650','2013-02-25','10:30:00',3.29),('9650','2013-02-25','10:35:00',3.25),('9650','2013-02-25','10:40:00',2.7),('9650','2013-02-25','10:45:00',2.2),('9650','2013-02-25','10:50:00',2.56),('9650','2013-02-25','10:55:00',2.59),('9650','2013-02-25','11:00:00',2.97),('9650','2013-02-25','11:05:00',2.99),('9650','2013-02-25','11:10:00',2.93),('9650','2013-02-25','11:15:00',2.74),('9650','2013-02-25','11:20:00',2.77),('9650','2013-02-25','11:25:00',2.59),('9650','2013-02-25','11:30:00',2.52),('9650','2013-02-25','11:35:00',2.34),('9650','2013-02-25','11:40:00',2.31),('9650','2013-02-25','11:45:00',2.31),('9650','2013-02-25','11:50:00',2.47),('9650','2013-02-25','11:55:00',2.55),('9650','2013-02-25','12:00:00',2.49),('9650','2013-02-25','12:05:00',2.54),('9650','2013-02-25','12:10:00',2.7),('9650','2013-02-25','12:15:00',2.53),('9650','2013-02-25','12:20:00',2.62),('9650','2013-02-25','12:25:00',2.45),('9650','2013-02-25','12:30:00',2.45),('9650','2013-02-25','12:35:00',2.27),('9650','2013-02-25','12:40:00',2.12),('9650','2013-02-25','12:45:00',1.92),('9650','2013-02-25','12:50:00',1.78),('9650','2013-02-25','12:55:00',1.9),('9650','2013-02-25','13:00:00',1.97),('9650','2013-02-25','13:05:00',1.75),('9650','2013-02-25','13:10:00',1.6),('9650','2013-02-25','13:15:00',1.7),('9650','2013-02-25','13:20:00',1.75),('9650','2013-02-25','13:25:00',1.8),('9650','2013-02-25','13:30:00',1.84),('9650','2013-02-25','13:35:00',1.84),('9650','2013-02-25','13:40:00',1.84),('9650','2013-02-25','13:45:00',1.7),('9650','2013-02-25','13:50:00',1.52),('9650','2013-02-25','13:55:00',1.45),('9650','2013-02-25','14:00:00',1.35),('9650','2013-02-25','14:05:00',1.23),('9650','2013-02-25','14:10:00',1.16),('9650','2013-02-25','14:15:00',1.14),('9650','2013-02-24','08:35:00',1.02),('9650','2013-02-24','08:40:00',1.1),('9650','2013-02-24','08:45:00',1.25),('9650','2013-02-24','08:50:00',1.2),('9650','2013-02-24','08:55:00',1.24),('9650','2013-02-24','09:00:00',1.29),('9650','2013-02-24','09:05:00',1.27),('9650','2013-02-24','09:10:00',1.51),('9650','2013-02-24','09:15:00',1.53),('9650','2013-02-24','09:20:00',1.74),('9650','2013-02-24','09:25:00',2.2),('9650','2013-02-24','09:30:00',2.43),('9650','2013-02-24','09:35:00',2.39),('9650','2013-02-24','09:40:00',1.88),('9650','2013-02-24','09:45:00',1.48),('9650','2013-02-24','09:50:00',1.2),('9650','2013-02-24','10:40:00',1.49),('9650','2013-02-24','10:45:00',2.66),('9650','2013-02-24','10:50:00',4.09),('9650','2013-02-24','10:55:00',5.05),('9650','2013-02-24','11:00:00',4.46),('9650','2013-02-24','11:05:00',2.58),('9650','2013-02-24','11:10:00',2.42),('9650','2013-02-24','11:15:00',2.76),('9650','2013-02-24','11:20:00',1.52),('9650','2013-02-24','11:25:00',1.52),('9650','2013-02-24','11:30:00',1.84),('9650','2013-02-24','11:35:00',1.95),('9650','2013-02-24','11:40:00',2.25),('9650','2013-02-24','11:45:00',2.72),('9650','2013-02-24','11:50:00',3.84),('9650','2013-02-24','11:55:00',5.94),('9650','2013-02-24','12:00:00',4.21),('9650','2013-02-24','12:05:00',3.48),('9650','2013-02-24','12:10:00',3.02),('9650','2013-02-24','12:15:00',3.16),('9650','2013-02-24','12:20:00',5.25),('9650','2013-02-24','12:25:00',5.79),('9650','2013-02-24','12:30:00',4.81),('9650','2013-02-24','12:35:00',3.85),('9650','2013-02-24','12:40:00',5.01),('9650','2013-02-24','12:45:00',5.42),('9650','2013-02-24','12:50:00',5.14),('9650','2013-02-24','12:55:00',5.17),('9650','2013-02-24','13:00:00',3.55),('9650','2013-02-24','13:05:00',3.79),('9650','2013-02-24','13:10:00',2.52),('9650','2013-02-24','13:15:00',3.72),('9650','2013-02-24','13:20:00',2.84),('9650','2013-02-24','13:25:00',2.56),('9650','2013-02-24','13:30:00',2.84),('9650','2013-02-24','13:35:00',2.57),('9650','2013-02-24','13:40:00',2.09),('9650','2013-02-24','13:45:00',1.78),('9650','2013-02-24','13:50:00',1.61),('9650','2013-02-24','13:55:00',1.51),('9650','2013-02-24','14:00:00',1.38),('9650','2013-02-24','14:05:00',1.02),('9650','2013-02-24','14:35:00',1.11),('9650','2013-02-24','14:40:00',1.4),('9650','2013-02-24','14:45:00',1.35),('9650','2013-02-24','14:50:00',1.37),('9650','2013-02-24','14:55:00',1.37),('9650','2013-02-24','15:00:00',1.35),('9650','2013-02-24','15:05:00',1.43),('9650','2013-02-24','15:10:00',1.4),('9650','2013-02-24','15:15:00',1.32),('9650','2013-02-24','15:20:00',1.2),('9650','2013-02-24','15:55:00',1.07),('9650','2013-02-24','16:00:00',1.16),('9650','2013-02-24','16:05:00',1.1),('9650','2013-02-24','16:30:00',1.12),('9650','2013-02-24','16:35:00',1.35),('9650','2013-02-24','16:40:00',1.29),('9650','2013-02-24','16:45:00',1.27),('9650','2013-02-24','16:50:00',1.22),('9650','2013-02-24','16:55:00',1.51),('9650','2013-02-24','17:00:00',1.21),('9650','2013-02-23','08:20:00',1.15),('9650','2013-02-23','08:25:00',1.21),('9650','2013-02-23','08:45:00',1.24),('9650','2013-02-23','08:50:00',1.46),('9650','2013-02-23','08:55:00',1.35),('9650','2013-02-23','09:00:00',1.14),('9650','2013-02-23','10:30:00',1.07),('9650','2013-02-23','10:35:00',1.21),('9650','2013-02-23','10:40:00',1.48),('9650','2013-02-23','10:45:00',1.71),('9650','2013-02-23','10:50:00',2.35),('9650','2013-02-23','10:55:00',2.32),('9650','2013-02-23','11:00:00',1.88),('9650','2013-02-23','11:05:00',1.74),('9650','2013-02-23','11:10:00',1.49),('9650','2013-02-23','11:15:00',1.59),('9650','2013-02-23','11:20:00',1.55),('9650','2013-02-23','11:25:00',1.65),('9650','2013-02-23','11:30:00',1.73),('9650','2013-02-23','11:35:00',1.48),('9650','2013-02-23','11:40:00',1.6),('9650','2013-02-23','11:45:00',1.67),('9650','2013-02-23','11:50:00',1.65),('9650','2013-02-23','11:55:00',1.6),('9650','2013-02-23','12:00:00',1.45),('9650','2013-02-23','12:05:00',1.4),('9650','2013-02-23','12:10:00',1.14),('9650','2013-02-23','12:30:00',1.25),('9650','2013-02-23','12:35:00',1.75),('9650','2013-02-23','12:40:00',2.06),('9650','2013-02-23','12:45:00',2.17),('9650','2013-02-23','12:50:00',1.72),('9650','2013-02-23','12:55:00',1.64),('9650','2013-02-23','13:00:00',2.06),('9650','2013-02-23','13:05:00',2.52),('9650','2013-02-23','13:10:00',2.51),('9650','2013-02-23','13:15:00',2.3),('9650','2013-02-23','13:20:00',2.5),('9650','2013-02-23','13:25:00',1.62),('9650','2013-02-23','13:30:00',1.89),('9650','2013-02-23','13:35:00',2.33),('9650','2013-02-23','13:40:00',1.86),('9650','2013-02-23','13:45:00',2.11),('9650','2013-02-23','13:50:00',1.86),('9650','2013-02-23','13:55:00',1.82),('9650','2013-02-23','14:00:00',1.97),('9650','2013-02-23','14:05:00',2.89),('9650','2013-02-23','14:10:00',2.46),('9650','2013-02-23','14:15:00',1.91),('9650','2013-02-23','14:20:00',1.74),('9650','2013-02-23','14:25:00',1.7),('9650','2013-02-23','14:30:00',2.07),('9650','2013-02-23','14:35:00',2.06),('9650','2013-02-23','14:40:00',1.3),('9650','2013-02-23','14:45:00',1.33),('9650','2013-02-23','14:50:00',1.2),('9650','2013-02-23','14:55:00',1.14),('9650','2013-02-23','15:00:00',1.19),('9650','2013-02-23','15:05:00',1.5),('9650','2013-02-23','15:10:00',3.96),('9650','2013-02-23','15:15:00',1.65),('9650','2013-02-23','15:20:00',2.23),('9650','2013-02-23','15:25:00',2.75),('9650','2013-02-23','15:30:00',2.6),('9650','2013-02-23','15:35:00',2.28),('9650','2013-02-23','15:40:00',2.02),('9650','2013-02-23','15:45:00',2.47),('9650','2013-02-23','15:50:00',1.47),('9650','2013-02-23','15:55:00',2.76),('9650','2013-02-23','16:00:00',3.28),('9650','2013-02-23','16:05:00',1.86),('9650','2013-02-23','16:20:00',1.1),('9650','2013-02-23','16:25:00',1.11),('9650','2013-02-23','16:35:00',1.07),('9650','2013-02-23','16:40:00',1.89),('9650','2013-02-23','16:45:00',1.04),('9650','2013-02-22','08:15:00',1.19),('9650','2013-02-22','08:20:00',1.25),('9650','2013-02-22','08:25:00',1.17),('9650','2013-02-22','08:30:00',1.08),('9650','2013-02-22','08:45:00',1.02),('9650','2013-02-22','08:50:00',1.46),('9650','2013-02-22','08:55:00',1.64),('9650','2013-02-22','09:00:00',1.83),('9650','2013-02-22','09:05:00',1.94),('9650','2013-02-22','09:10:00',1.67),('9650','2013-02-22','09:15:00',1.4),('9650','2013-02-22','09:20:00',1.07),('9650','2013-02-22','09:30:00',1.02),('9650','2013-02-22','09:35:00',1.35),('9650','2013-02-22','09:40:00',1.6),('9650','2013-02-22','09:45:00',2.17),('9650','2013-02-22','09:50:00',2.33),('9650','2013-02-22','09:55:00',2.31),('9650','2013-02-22','10:00:00',1.84),('9650','2013-02-22','10:05:00',1.78),('9650','2013-02-22','10:10:00',1.58),('9650','2013-02-22','10:15:00',1.22),('9650','2013-02-22','10:20:00',1.39),('9650','2013-02-22','10:25:00',1.9),('9650','2013-02-22','10:30:00',1.86),('9650','2013-02-22','10:35:00',1.7),('9650','2013-02-22','10:40:00',1.51),('9650','2013-02-22','10:45:00',1.49),('9650','2013-02-22','10:50:00',1.78),('9650','2013-02-22','10:55:00',1.27),('9650','2013-02-22','11:00:00',1.01),('9650','2013-02-22','11:05:00',1.15),('9650','2013-02-22','11:10:00',1.12),('9650','2013-02-22','11:15:00',1.07),('9650','2013-02-22','11:20:00',1.31),('9650','2013-02-22','11:25:00',1.19),('9650','2013-02-22','11:30:00',1.17),('9650','2013-02-22','11:35:00',1.59),('9650','2013-02-22','11:40:00',1.51),('9650','2013-02-22','11:45:00',1.39),('9650','2013-02-22','11:50:00',1.19),('9650','2013-02-22','11:55:00',1.04),('9650','2013-02-22','12:05:00',1.26),('9650','2013-02-22','12:10:00',1.21),('9650','2013-02-22','12:20:00',1.03),('9650','2013-02-22','13:55:00',1.58),('9650','2013-02-22','14:00:00',1.67),('9650','2013-02-22','14:05:00',2.93),('9650','2013-02-22','14:10:00',1.93),('9650','2013-02-22','14:45:00',1.31),('9650','2013-02-22','14:50:00',1.22),('9650','2013-02-22','15:10:00',1.01),('9650','2013-02-21','09:35:00',1.38),('9650','2013-02-21','09:40:00',1.41),('9650','2013-02-21','09:50:00',1.08),('9650','2013-02-21','10:15:00',1.08),('9650','2013-02-21','11:35:00',1.13),('9650','2013-02-21','11:40:00',1.1),('9650','2013-02-21','12:00:00',1.21),('9650','2013-02-21','12:05:00',1.05),('9650','2013-02-21','12:45:00',1.14),('9650','2013-02-21','12:50:00',1.55),('9650','2013-02-21','12:55:00',1.79),('9650','2013-02-21','13:00:00',1.31),('9650','2013-02-21','14:10:00',1.3),('9650','2013-02-21','14:15:00',1.72),('9650','2013-02-21','14:20:00',1.7),('9650','2013-02-21','14:30:00',1.43),('9650','2013-02-21','14:35:00',2.26),('9650','2013-02-21','14:40:00',2.46),('9650','2013-02-21','14:45:00',1.81),('9650','2013-02-21','14:50:00',1.65),('9650','2013-02-21','14:55:00',2.22),('9650','2013-02-21','15:00:00',1.36),('9650','2013-02-21','15:50:00',1.52),('9650','2013-02-21','15:55:00',1.3),('9650','2013-02-21','16:00:00',1.26),('9650','2013-02-21','16:15:00',1.22),('9650','2013-02-21','16:20:00',2.09),('9650','2013-02-21','16:25:00',2.53),('9650','2013-02-21','16:30:00',2.19),('9650','2013-02-21','16:35:00',1.07),('9650','2013-02-20','09:40:00',1.01),('9650','2013-02-20','09:45:00',1.32),('9650','2013-02-20','09:50:00',1.39),('9650','2013-02-20','09:55:00',1.4),('9650','2013-02-20','10:00:00',1.32),('9650','2013-02-20','10:05:00',1.34),('9650','2013-02-20','10:10:00',1.39),('9650','2013-02-20','10:15:00',1.33),('9650','2013-02-20','10:20:00',1.34),('9650','2013-02-20','10:25:00',1.32),('9650','2013-02-20','10:30:00',1.35),('9650','2013-02-20','10:35:00',1.39),('9650','2013-02-20','10:40:00',1.4),('9650','2013-02-20','10:45:00',1.3),('9650','2013-02-20','10:50:00',1.31),('9650','2013-02-20','10:55:00',1.32),('9650','2013-02-20','11:00:00',1.17),('9650','2013-02-20','11:05:00',1.12),('9650','2013-02-20','11:10:00',1.14),('9650','2013-02-20','11:15:00',1.2),('9650','2013-02-20','11:20:00',1.32),('9650','2013-02-20','11:25:00',1.55),('9650','2013-02-20','11:30:00',1.74),('9650','2013-02-20','11:35:00',1.81),('9650','2013-02-20','11:40:00',1.8),('9650','2013-02-20','11:45:00',1.88),('9650','2013-02-20','11:50:00',2.07),('9650','2013-02-20','11:55:00',2.09),('9650','2013-02-20','12:00:00',2.04),('9650','2013-02-20','12:05:00',2.09),('9650','2013-02-20','12:10:00',2.15),('9650','2013-02-20','12:15:00',2.25),('9650','2013-02-20','12:20:00',2.38),('9650','2013-02-20','12:25:00',2.29),('9650','2013-02-20','12:30:00',2.15),('9650','2013-02-20','12:35:00',2.09),('9650','2013-02-20','12:40:00',2.06),('9650','2013-02-20','12:45:00',2.09),('9650','2013-02-20','12:50:00',2.08),('9650','2013-02-20','12:55:00',2.21),('9650','2013-02-20','13:00:00',2.2),('9650','2013-02-20','13:05:00',2.06),('9650','2013-02-20','13:10:00',2),('9650','2013-02-20','13:15:00',2.08),('9650','2013-02-20','13:20:00',2.2),('9650','2013-02-20','13:25:00',2.26),('9650','2013-02-20','13:30:00',2.26),('9650','2013-02-20','13:35:00',2.24),('9650','2013-02-20','13:40:00',2.14),('9650','2013-02-20','13:45:00',2.04),('9650','2013-02-20','13:50:00',2.07),('9650','2013-02-20','13:55:00',2.04),('9650','2013-02-20','14:00:00',2.06),('9650','2013-02-20','14:05:00',1.96),('9650','2013-02-20','14:10:00',1.81),('9650','2013-02-20','14:15:00',1.56),('9650','2013-02-20','14:20:00',1.4),('9650','2013-02-20','14:25:00',1.4),('9650','2013-02-20','14:30:00',1.51),('9650','2013-02-20','14:35:00',1.53),('9650','2013-02-20','14:40:00',1.49),('9650','2013-02-20','14:45:00',1.46),('9650','2013-02-20','14:50:00',1.38),('9650','2013-02-20','14:55:00',1.23),('9650','2013-02-20','15:00:00',1.12),('9650','2013-02-20','15:05:00',1.04),('9650','2013-02-20','15:10:00',1.09),('9650','2013-02-20','15:15:00',1.07),('9650','2013-02-20','15:35:00',1.04),('9650','2013-02-20','15:40:00',1.1),('9650','2013-02-20','15:45:00',1.19),('9650','2013-02-20','15:50:00',1.28),('9650','2013-02-20','15:55:00',1.43),('9650','2013-02-20','16:00:00',1.71),('9650','2013-02-20','16:05:00',1.77),('9650','2013-02-20','16:10:00',1.46),('9650','2013-02-20','16:15:00',1.59),('9650','2013-02-20','16:20:00',2.44),('9650','2013-02-20','16:25:00',2.71),('9650','2013-02-20','16:30:00',2.46),('9650','2013-02-20','16:35:00',2.08),('9650','2013-02-20','16:40:00',1.73),('9650','2013-02-20','16:45:00',1.33),('9650','2013-02-20','16:50:00',1.07),('9650','2014-03-22','08:05:00',1.12),('9650','2014-03-22','08:10:00',1.15),('9650','2014-03-22','08:15:00',1.12),('9650','2014-03-22','08:20:00',1.19),('9650','2014-03-22','08:25:00',1.25),('9650','2014-03-22','08:30:00',1.36),('9650','2014-03-22','08:35:00',1.54),('9650','2014-03-22','08:40:00',1.26),('9650','2014-03-22','08:45:00',1.21),('9650','2014-03-22','08:50:00',1.34),('9650','2014-03-22','08:55:00',1.69),('9650','2014-03-22','09:00:00',1.36),('9650','2014-03-22','09:05:00',1.9),('9650','2014-03-22','09:10:00',2.82),('9650','2014-03-22','09:15:00',3.06),('9650','2014-03-22','09:20:00',2.52),('9650','2014-03-22','09:25:00',1.79),('9650','2014-03-22','09:30:00',2.16),('9650','2014-03-22','09:35:00',2.36),('9650','2014-03-22','09:40:00',1.98),('9650','2014-03-22','09:45:00',1.61),('9650','2014-03-22','09:50:00',1.47),('9650','2014-03-22','09:55:00',1.38),('9650','2014-03-22','10:00:00',1.27),('9650','2014-03-22','10:05:00',1.23),('9650','2014-03-22','10:10:00',1.32),('9650','2014-03-22','10:20:00',1.22),('9650','2014-03-22','10:25:00',2),('9650','2014-03-22','10:30:00',1.49),('9650','2014-03-22','10:35:00',1.14),('9650','2014-03-22','10:40:00',1.98),('9650','2014-03-22','10:45:00',1.85),('9650','2014-03-22','10:50:00',2.01),('9650','2014-03-22','10:55:00',2.74),('9650','2014-03-22','11:00:00',2.02),('9650','2014-03-22','11:05:00',1.71),('9650','2014-03-22','11:10:00',2.08),('9650','2014-03-22','11:15:00',1.27),('9650','2014-03-22','11:20:00',1.36),('9650','2014-03-22','11:25:00',1.84),('9650','2014-03-22','11:30:00',1.46),('9650','2014-03-22','11:35:00',2.51),('9650','2014-03-22','11:40:00',5.34),('9650','2014-03-22','11:45:00',1.53),('9650','2014-03-22','11:55:00',1.42),('9650','2014-03-22','12:00:00',1.58),('9650','2014-03-22','12:05:00',1),('9650','2014-03-22','12:30:00',1.05),('9650','2014-03-22','12:35:00',1.16),('9650','2014-03-22','13:15:00',1),('9650','2014-03-22','13:35:00',1.04),('9650','2014-03-22','13:40:00',1.9),('9650','2014-03-22','13:45:00',4.01),('9650','2014-03-22','13:50:00',2.69),('9650','2014-03-22','13:55:00',2.28),('9650','2014-03-22','14:00:00',1.68),('9650','2014-03-22','14:15:00',1.05),('9650','2014-03-22','14:50:00',1.33),('9650','2014-03-22','14:55:00',1.45),('9650','2014-03-22','15:00:00',1.2),('9650','2014-03-22','15:05:00',1.59),('9650','2014-03-22','15:10:00',2.24),('9650','2014-03-22','15:15:00',2.56),('9650','2014-03-22','15:20:00',2.75),('9650','2014-03-22','15:25:00',3.37),('9650','2014-03-22','15:30:00',2.05),('9650','2014-03-22','15:35:00',1.55),('9650','2014-03-22','15:40:00',1.85),('9650','2013-02-19','09:10:00',1.17),('9650','2013-02-19','09:15:00',1.29),('9650','2013-02-19','09:20:00',1.16),('9650','2013-02-19','09:25:00',1.41),('9650','2013-02-19','09:30:00',1.18),('9650','2013-02-19','09:35:00',1.29),('9650','2013-02-19','09:40:00',1.41),('9650','2013-02-19','09:45:00',1.71),('9650','2013-02-19','09:50:00',1.87),('9650','2013-02-19','09:55:00',1.8),('9650','2013-02-19','10:00:00',1.4),('9650','2013-02-19','10:05:00',2.18),('9650','2013-02-19','10:10:00',2.29),('9650','2013-02-19','10:15:00',1.76),('9650','2013-02-19','10:20:00',1.42),('9650','2013-02-19','10:25:00',1.38),('9650','2013-02-19','10:30:00',1.1),('9650','2013-02-19','10:35:00',1.12),('9650','2013-02-19','10:40:00',1.43),('9650','2013-02-19','10:45:00',2.29),('9650','2013-02-19','10:50:00',3.68),('9650','2013-02-19','10:55:00',2.03),('9650','2013-02-19','11:00:00',1.26),('9650','2013-02-19','11:05:00',2.61),('9650','2013-02-19','11:10:00',4.4),('9650','2013-02-19','11:15:00',3.55),('9650','2013-02-19','11:20:00',3.58),('9650','2013-02-19','11:25:00',2.85),('9650','2013-02-19','11:30:00',1.89),('9650','2013-02-19','11:35:00',4.59),('9650','2013-02-19','11:40:00',5.29),('9650','2013-02-19','11:45:00',5.1),('9650','2013-02-19','11:50:00',4.5),('9650','2013-02-19','11:55:00',4.94),('9650','2013-02-19','12:00:00',2.9),('9650','2013-02-19','12:05:00',1.61),('9650','2013-02-19','12:10:00',3.43),('9650','2013-02-19','12:15:00',4.94),('9650','2013-02-19','12:20:00',2.67),('9650','2013-02-19','12:25:00',5.12),('9650','2013-02-19','12:30:00',5.98),('9650','2013-02-19','12:35:00',3.64),('9650','2013-02-19','12:40:00',1.57),('9650','2013-02-19','12:45:00',1.77),('9650','2013-02-19','12:50:00',1.86),('9650','2013-02-19','12:55:00',2.3),('9650','2013-02-19','13:00:00',5.23),('9650','2013-02-19','13:05:00',3.46),('9650','2013-02-19','13:10:00',5.55),('9650','2013-02-19','13:15:00',4.58),('9650','2013-02-19','13:20:00',2.24),('9650','2013-02-19','13:25:00',2.39),('9650','2013-02-19','13:30:00',3.31),('9650','2013-02-19','13:45:00',2.12),('9650','2013-02-19','13:50:00',1.98),('9650','2013-02-19','13:55:00',2.5),('9650','2013-02-19','14:00:00',2.55),('9650','2013-02-19','14:05:00',1.61),('9650','2013-02-19','14:10:00',1.59),('9650','2013-02-19','14:15:00',1.44),('9650','2013-02-19','14:20:00',1.15),('9650','2013-02-19','14:30:00',1.47),('9650','2013-02-19','14:35:00',1.6),('9650','2013-02-19','14:40:00',2.19),('9650','2013-02-19','14:45:00',1.79),('9650','2013-02-19','14:50:00',1.61),('9650','2013-02-19','14:55:00',1.53),('9650','2013-02-19','15:00:00',1.46),('9650','2013-02-19','15:05:00',1.93),('9650','2013-02-19','15:10:00',3.21),('9650','2013-02-19','15:15:00',3.98),('9650','2013-02-19','15:20:00',3.6),('9650','2013-02-19','15:25:00',3.6),('9650','2013-02-19','15:30:00',2.86),('9650','2013-02-19','15:35:00',1.5),('9650','2013-02-19','15:40:00',1.06),('9650','2013-02-19','15:45:00',1.1),('9650','2013-02-19','15:50:00',1.37),('9650','2013-02-19','15:55:00',1.54),('9650','2013-02-19','16:00:00',1.58),('9650','2013-02-19','16:05:00',3.06),('9650','2013-02-19','16:10:00',3.16),('9650','2013-02-19','16:15:00',2.98),('9650','2013-02-19','16:20:00',2.75),('9650','2013-02-19','16:25:00',2.36),('9650','2013-02-19','16:30:00',1.86),('9650','2013-02-19','16:35:00',1.49),('9650','2013-02-19','16:40:00',1.24),('9650','2013-02-19','16:45:00',1.08),('9650','2013-02-18','09:30:00',1.03),('9650','2013-02-18','09:35:00',1.13),('9650','2013-02-18','09:40:00',1.23),('9650','2013-02-18','09:45:00',1.35),('9650','2013-02-18','09:50:00',1.44),('9650','2013-02-18','09:55:00',1.55),('9650','2013-02-18','10:00:00',1.65),('9650','2013-02-18','10:05:00',1.77),('9650','2013-02-18','10:10:00',1.89),('9650','2013-02-18','10:15:00',2.01),('9650','2013-02-18','10:20:00',2.12),('9650','2013-02-18','10:25:00',2.24),('9650','2013-02-18','10:30:00',2.37),('9650','2013-02-18','10:35:00',2.5),('9650','2013-02-18','10:40:00',2.61),('9650','2013-02-18','10:45:00',2.71),('9650','2013-02-18','10:50:00',2.83),('9650','2013-02-18','10:55:00',2.93),('9650','2013-02-18','11:00:00',3.03),('9650','2013-02-18','11:05:00',3.1),('9650','2013-02-18','11:10:00',3.21),('9650','2013-02-18','11:15:00',3.35),('9650','2013-02-18','11:20:00',3.42),('9650','2013-02-18','11:25:00',3.51),('9650','2013-02-18','11:30:00',3.59),('9650','2013-02-18','11:35:00',3.64),('9650','2013-02-18','11:40:00',3.68),('9650','2013-02-18','11:45:00',3.83),('9650','2013-02-18','11:50:00',3.88),('9650','2013-02-18','11:55:00',3.95),('9650','2013-02-18','12:00:00',4.01),('9650','2013-02-18','12:05:00',4.06),('9650','2013-02-18','12:10:00',4.1),('9650','2013-02-18','12:15:00',4.16),('9650','2013-02-18','12:20:00',4.21),('9650','2013-02-18','12:25:00',4.19),('9650','2013-02-18','12:30:00',4.25),('9650','2013-02-18','12:35:00',4.36),('9650','2013-02-18','12:40:00',4.41),('9650','2013-02-18','12:45:00',4.43),('9650','2013-02-18','12:50:00',4.51),('9650','2013-02-18','12:55:00',4.54),('9650','2013-02-18','13:00:00',4.6),('9650','2013-02-18','13:05:00',4.64),('9650','2013-02-18','13:10:00',4.66),('9650','2013-02-18','13:15:00',4.7),('9650','2013-02-18','13:20:00',4.65),('9650','2013-02-18','13:25:00',4.56),('9650','2013-02-18','13:30:00',4.47),('9650','2013-02-18','13:35:00',4.36),('9650','2013-02-18','13:40:00',4.3),('9650','2013-02-18','13:45:00',4.26),('9650','2013-02-18','13:50:00',4.26),('9650','2013-02-18','13:55:00',4.27),('9650','2013-02-18','14:00:00',4.19),('9650','2013-02-18','14:05:00',4.12),('9650','2013-02-18','14:10:00',4.11),('9650','2013-02-18','14:15:00',4.01),('9650','2013-02-18','14:20:00',3.79),('9650','2013-02-18','14:25:00',3.74),('9650','2013-02-18','14:30:00',3.79),('9650','2013-02-18','14:35:00',3.72),('9650','2013-02-18','14:40:00',3.62),('9650','2013-02-18','14:45:00',3.53),('9650','2013-02-18','14:50:00',3.49),('9650','2013-02-18','14:55:00',3.43),('9650','2013-02-18','15:00:00',3.38),('9650','2013-02-18','15:05:00',3.21),('9650','2013-02-18','15:10:00',2.57),('9650','2013-02-18','15:25:00',1.11),('9650','2013-02-18','15:30:00',2.66),('9650','2013-02-18','15:35:00',2.62),('9650','2013-02-18','15:40:00',2.67),('9650','2013-02-18','15:45:00',2.64),('9650','2013-02-18','15:50:00',2.57),('9650','2013-02-18','15:55:00',2.52),('9650','2013-02-18','16:00:00',2.41),('9650','2013-02-18','16:05:00',2.34),('9650','2013-02-18','16:10:00',2.25),('9650','2013-02-18','16:15:00',2.15),('9650','2013-02-18','16:20:00',2.03),('9650','2013-02-18','16:25:00',1.91),('9650','2013-02-18','16:30:00',1.81),('9650','2013-02-18','16:35:00',1.63),('9650','2013-02-18','16:40:00',1.38),('9650','2013-02-18','16:45:00',1.17),('9650','2013-02-17','09:20:00',1.18),('9650','2013-02-17','09:25:00',1.4),('9650','2013-02-17','09:30:00',1.52),('9650','2013-02-17','09:35:00',1.78),('9650','2013-02-17','09:40:00',1.47),('9650','2013-02-17','09:45:00',1.1),('9650','2013-02-17','09:50:00',1.75),('9650','2013-02-17','09:55:00',1.35),('9650','2013-02-17','10:00:00',1.24),('9650','2013-02-17','10:05:00',1.46),('9650','2013-02-17','10:10:00',1.06),('9650','2013-02-17','10:35:00',1.14),('9650','2013-02-17','10:40:00',1.25),('9650','2013-02-17','10:45:00',1.23),('9650','2013-02-17','10:50:00',1.08),('9650','2013-02-17','10:55:00',1.46),('9650','2013-02-17','11:00:00',1.93),('9650','2013-02-17','11:05:00',1.99),('9650','2013-02-17','11:10:00',2.18),('9650','2013-02-17','11:15:00',2.06),('9650','2013-02-17','11:20:00',2.5),('9650','2013-02-17','11:25:00',2.57),('9650','2013-02-17','11:30:00',2.42),('9650','2013-02-17','11:35:00',2.49),('9650','2013-02-17','11:40:00',2.41),('9650','2013-02-17','11:45:00',2.2),('9650','2013-02-17','11:50:00',2.35),('9650','2013-02-17','11:55:00',2.9),('9650','2013-02-17','12:00:00',3.04),('9650','2013-02-17','12:05:00',2.77),('9650','2013-02-17','12:10:00',2.55),('9650','2013-02-17','12:15:00',2.5),('9650','2013-02-17','12:20:00',2.47),('9650','2013-02-17','12:25:00',2.49),('9650','2013-02-17','12:30:00',2.32),('9650','2013-02-17','12:35:00',2.2),('9650','2013-02-17','12:40:00',2.3),('9650','2013-02-17','12:45:00',2.7),('9650','2013-02-17','12:50:00',2.66),('9650','2013-02-17','12:55:00',2.47),('9650','2013-02-17','13:00:00',2.46),('9650','2013-02-17','13:05:00',2.55),('9650','2013-02-17','13:10:00',2.48),('9650','2013-02-17','13:15:00',3.02),('9650','2013-02-17','13:20:00',2.51),('9650','2013-02-17','13:25:00',2.91),('9650','2013-02-17','13:30:00',2.62),('9650','2013-02-17','13:35:00',2.22),('9650','2013-02-17','13:40:00',2.22),('9650','2013-02-17','13:45:00',2.11),('9650','2013-02-17','13:50:00',2.12),('9650','2013-02-17','13:55:00',2.58),('9650','2013-02-17','14:00:00',2.61),('9650','2013-02-17','14:05:00',2.42),('9650','2013-02-17','14:10:00',2.15),('9650','2013-02-17','14:15:00',1.9),('9650','2013-02-17','14:20:00',2.04),('9650','2013-02-17','14:25:00',1.39),('9650','2013-02-17','14:30:00',1.02),('9650','2013-02-17','14:35:00',1.03),('9650','2013-02-17','14:40:00',1.1),('9650','2013-02-17','14:45:00',1.09),('9650','2013-02-17','15:00:00',1.04),('9650','2013-02-17','15:05:00',1.18),('9650','2013-02-17','15:10:00',1.02),('9650','2013-02-17','15:35:00',1.09),('9650','2013-02-17','15:40:00',1.09),('9650','2013-02-16','09:35:00',1.06),('9650','2013-02-16','09:40:00',1.15),('9650','2013-02-16','09:45:00',1.25),('9650','2013-02-16','09:50:00',1.35),('9650','2013-02-16','09:55:00',1.46),('9650','2013-02-16','10:00:00',1.56),('9650','2013-02-16','10:05:00',1.67),('9650','2013-02-16','10:10:00',1.81),('9650','2013-02-16','10:15:00',1.91),('9650','2013-02-16','10:20:00',2),('9650','2013-02-16','10:25:00',2.12),('9650','2013-02-16','10:30:00',2.23),('9650','2013-02-16','10:35:00',2.34),('9650','2013-02-16','10:40:00',2.48),('9650','2013-02-16','10:45:00',2.59),('9650','2013-02-16','10:50:00',2.67),('9650','2013-02-16','10:55:00',2.79),('9650','2013-02-16','11:00:00',2.86),('9650','2013-02-16','11:05:00',2.97),('9650','2013-02-16','11:10:00',3.06),('9650','2013-02-16','11:15:00',3.15),('9650','2013-02-16','11:20:00',3.25),('9650','2013-02-16','11:25:00',3.34),('9650','2013-02-16','11:30:00',3.39),('9650','2013-02-16','11:35:00',3.47),('9650','2013-02-16','11:40:00',3.57),('9650','2013-02-16','11:45:00',3.68),('9650','2013-02-16','11:50:00',3.76),('9650','2013-02-16','11:55:00',3.84),('9650','2013-02-16','12:00:00',3.91),('9650','2013-02-16','12:05:00',3.99),('9650','2013-02-16','12:10:00',4.04),('9650','2013-02-16','12:15:00',4.07),('9650','2013-02-16','12:20:00',4.12),('9650','2013-02-16','12:25:00',4.14),('9650','2013-02-16','12:30:00',4.17),('9650','2013-02-16','12:35:00',4.18),('9650','2013-02-16','12:40:00',4.22),('9650','2013-02-16','12:45:00',4.22),('9650','2013-02-16','12:50:00',4.29),('9650','2013-02-16','12:55:00',4.33),('9650','2013-02-16','13:00:00',4.38),('9650','2013-02-16','13:05:00',4.42),('9650','2013-02-16','13:10:00',4.26),('9650','2013-02-16','13:15:00',3.9),('9650','2013-02-16','13:20:00',1.09),('9650','2013-02-16','13:25:00',2.72),('9650','2013-02-16','13:30:00',4.29),('9650','2013-02-16','13:35:00',2),('9650','2013-02-16','13:40:00',4),('9650','2013-02-16','13:45:00',3.71),('9650','2013-02-16','13:50:00',3.86),('9650','2013-02-16','13:55:00',3.1),('9650','2013-02-16','14:00:00',1.08),('9650','2013-02-16','14:05:00',1.26),('9650','2013-02-16','14:10:00',4.02),('9650','2013-02-16','14:15:00',3.34),('9650','2013-02-16','14:20:00',1.98),('9650','2013-02-16','14:25:00',2.56),('9650','2013-02-16','14:30:00',3.8),('9650','2013-02-16','14:35:00',3.8),('9650','2013-02-16','14:40:00',2.05),('9650','2013-02-16','14:45:00',1.1),('9650','2013-02-16','14:50:00',1.17),('9650','2013-02-16','14:55:00',1.26),('9650','2013-02-16','15:00:00',2.93),('9650','2013-02-16','15:05:00',3.4),('9650','2013-02-16','15:10:00',3.62),('9650','2013-02-16','15:15:00',3.51),('9650','2013-02-16','15:20:00',3.41),('9650','2013-02-16','15:25:00',3.12),('9650','2013-02-16','15:30:00',2.87),('9650','2013-02-16','15:35:00',2.92),('9650','2013-02-16','15:40:00',2.96),('9650','2013-02-16','15:45:00',2.8),('9650','2013-02-16','15:50:00',2.73),('9650','2013-02-16','15:55:00',2.64),('9650','2013-02-16','16:00:00',2.5),('9650','2013-02-16','16:05:00',2.37),('9650','2013-02-16','16:15:00',1.04),('9650','2013-02-16','16:20:00',1.8),('9650','2013-02-16','16:25:00',2.29),('9650','2013-02-16','16:30:00',2.18),('9650','2013-02-16','16:35:00',1.53),('9650','2013-02-15','09:35:00',1.09),('9650','2013-02-15','09:40:00',1.15),('9650','2013-02-15','09:45:00',1.21),('9650','2013-02-15','09:50:00',1.34),('9650','2013-02-15','09:55:00',1.42),('9650','2013-02-15','10:00:00',1.52),('9650','2013-02-15','10:05:00',1.62),('9650','2013-02-15','10:10:00',1.76),('9650','2013-02-15','10:15:00',1.87),('9650','2013-02-15','10:20:00',1.99),('9650','2013-02-15','10:25:00',2.13),('9650','2013-02-15','10:30:00',2.22),('9650','2013-02-15','10:35:00',2.35),('9650','2013-02-15','10:40:00',2.4),('9650','2013-02-15','10:45:00',2.72),('9650','2013-02-15','10:50:00',2.66),('9650','2013-02-15','10:55:00',2.75),('9650','2013-02-15','11:00:00',2.91),('9650','2013-02-15','11:05:00',2.88),('9650','2013-02-15','11:10:00',2.91),('9650','2013-02-15','11:15:00',2.9),('9650','2013-02-15','11:20:00',3.15),('9650','2013-02-15','11:25:00',3),('9650','2013-02-15','11:30:00',3.4),('9650','2013-02-15','11:35:00',3.49),('9650','2013-02-15','11:40:00',3.56),('9650','2013-02-15','11:45:00',3.65),('9650','2013-02-15','11:50:00',3.75),('9650','2013-02-15','11:55:00',3.82),('9650','2013-02-15','12:00:00',3.87),('9650','2013-02-15','12:05:00',3.94),('9650','2013-02-15','12:10:00',3.98),('9650','2013-02-15','12:15:00',4.03),('9650','2013-02-15','12:20:00',4.08),('9650','2013-02-15','12:25:00',4.13),('9650','2013-02-15','12:30:00',4.19),('9650','2013-02-15','12:35:00',4.26),('9650','2013-02-15','12:40:00',4.28),('9650','2013-02-15','12:45:00',4.35),('9650','2013-02-15','12:50:00',4.41),('9650','2013-02-15','12:55:00',4.4),('9650','2013-02-15','13:00:00',4.44),('9650','2013-02-15','13:05:00',4.45),('9650','2013-02-15','13:10:00',4.47),('9650','2013-02-15','13:15:00',4.5),('9650','2013-02-15','13:20:00',4.39),('9650','2013-02-15','13:25:00',4.39),('9650','2013-02-15','13:30:00',4.34),('9650','2013-02-15','13:35:00',4.27),('9650','2013-02-15','13:40:00',4.2),('9650','2013-02-15','13:45:00',4.18),('9650','2013-02-15','13:50:00',4.27),('9650','2013-02-15','13:55:00',4.14),('9650','2013-02-15','14:00:00',4.14),('9650','2013-02-15','14:05:00',4.11),('9650','2013-02-15','14:10:00',3.98),('9650','2013-02-15','14:15:00',4.1),('9650','2013-02-15','14:20:00',3.81),('9650','2013-02-15','14:25:00',1.63),('9650','2013-02-15','14:30:00',1.42),('9650','2013-02-15','14:35:00',1.45),('9650','2013-02-15','14:40:00',1.47),('9650','2013-02-15','14:45:00',1.65),('9650','2013-02-15','14:50:00',1.63),('9650','2013-02-15','14:55:00',1.77),('9650','2013-02-15','15:00:00',1.36),('9650','2013-02-15','15:05:00',1.41),('9650','2013-02-15','15:10:00',1.49),('9650','2013-02-15','15:15:00',1.71),('9650','2013-02-15','15:20:00',1.91),('9650','2013-02-15','15:25:00',1.97),('9650','2013-02-15','15:30:00',3.36),('9650','2013-02-15','15:35:00',3.38),('9650','2013-02-15','15:40:00',3.2),('9650','2013-02-15','15:45:00',3.3),('9650','2013-02-15','15:50:00',3.37),('9650','2013-02-15','15:55:00',2.57),('9650','2013-02-15','16:00:00',1.8),('9650','2013-02-15','16:05:00',2.66),('9650','2013-02-15','16:10:00',1.6),('9650','2013-02-15','16:15:00',1.12),('9650','2013-02-15','16:20:00',1.42),('9650','2013-02-15','16:25:00',1.11),('9650','2013-02-14','09:10:00',1.02),('9650','2013-02-14','09:15:00',1.31),('9650','2013-02-14','09:20:00',1.85),('9650','2013-02-14','09:25:00',1.94),('9650','2013-02-14','09:30:00',1.35),('9650','2013-02-14','09:35:00',1.16),('9650','2013-02-14','09:40:00',1.09),('9650','2013-02-14','09:45:00',1.09),('9650','2013-02-14','09:50:00',1.22),('9650','2013-02-14','09:55:00',1.5),('9650','2013-02-14','10:00:00',1.86),('9650','2013-02-14','10:05:00',1.89),('9650','2013-02-14','10:10:00',1.69),('9650','2013-02-14','10:15:00',1.7),('9650','2013-02-14','10:20:00',1.94),('9650','2013-02-14','10:25:00',2.26),('9650','2013-02-14','10:30:00',2.06),('9650','2013-02-14','10:35:00',2.75),('9650','2013-02-14','10:40:00',2.79),('9650','2013-02-14','10:45:00',3.05),('9650','2013-02-14','10:50:00',3),('9650','2013-02-14','10:55:00',2.3),('9650','2013-02-14','11:00:00',2.28),('9650','2013-02-14','11:05:00',2.33),('9650','2013-02-14','11:10:00',2.24),('9650','2013-02-14','11:15:00',2.9),('9650','2013-02-14','11:20:00',3.27),('9650','2013-02-14','11:25:00',3.32),('9650','2013-02-14','11:30:00',3.44),('9650','2013-02-14','11:35:00',2.83),('9650','2013-02-14','11:40:00',2.14),('9650','2013-02-14','11:45:00',2.74),('9650','2013-02-14','11:50:00',4.47),('9650','2013-02-14','11:55:00',3.91),('9650','2013-02-14','12:00:00',3.6),('9650','2013-02-14','12:05:00',3.41),('9650','2013-02-14','12:10:00',3.53),('9650','2013-02-14','12:15:00',3.96),('9650','2013-02-14','12:20:00',4.68),('9650','2013-02-14','12:25:00',4.25),('9650','2013-02-14','12:30:00',4.35),('9650','2013-02-14','12:35:00',4.34),('9650','2013-02-14','12:40:00',4.3),('9650','2013-02-14','12:45:00',4.35),('9650','2013-02-14','12:50:00',4.35),('9650','2013-02-14','12:55:00',4.42),('9650','2013-02-14','13:00:00',4.41),('9650','2013-02-14','13:05:00',4.43),('9650','2013-02-14','13:10:00',4.54),('9650','2013-02-14','13:15:00',4.59),('9650','2013-02-14','13:20:00',4.3),('9650','2013-02-14','13:25:00',4.1),('9650','2013-02-14','13:30:00',3.16),('9650','2013-02-14','13:35:00',3.34),('9650','2013-02-14','13:40:00',4.29),('9650','2013-02-14','13:45:00',3.45),('9650','2013-02-14','13:50:00',3.4),('9650','2013-02-14','13:55:00',3.62),('9650','2013-02-14','14:00:00',2.91),('9650','2013-02-14','14:05:00',4.46),('9650','2013-02-14','14:10:00',5.03),('9650','2013-02-14','14:15:00',3.25),('9650','2013-02-14','14:20:00',3.39),('9650','2013-02-14','14:25:00',2.59),('9650','2013-02-14','14:30:00',2.39),('9650','2013-02-14','14:35:00',3.61),('9650','2013-02-14','14:40:00',3.92),('9650','2013-02-14','14:45:00',3.06),('9650','2013-02-14','14:50:00',1.97),('9650','2013-02-14','14:55:00',1.89),('9650','2013-02-14','15:00:00',2.66),('9650','2013-02-14','15:05:00',1.91),('9650','2013-02-14','15:10:00',2.05),('9650','2013-02-14','15:15:00',2.33),('9650','2013-02-14','15:20:00',1.91),('9650','2013-02-14','15:25:00',2.31),('9650','2013-02-14','15:30:00',2.48),('9650','2013-02-14','15:35:00',2.1),('9650','2013-02-14','15:40:00',2.12),('9650','2013-02-14','15:45:00',1.99),('9650','2013-02-14','15:50:00',1.54),('9650','2013-02-14','15:55:00',1.42),('9650','2013-02-14','16:00:00',1.33),('9650','2013-02-14','16:05:00',1.26),('9650','2013-02-14','16:10:00',1.15),('9650','2013-02-14','16:15:00',1.02),('9650','2013-02-13','09:50:00',1.07),('9650','2013-02-13','09:55:00',1.17),('9650','2013-02-13','10:00:00',1.3),('9650','2013-02-13','10:05:00',1.43),('9650','2013-02-13','10:10:00',1.55),('9650','2013-02-13','10:15:00',1.68),('9650','2013-02-13','10:20:00',1.81),('9650','2013-02-13','10:25:00',1.93),('9650','2013-02-13','10:30:00',2.05),('9650','2013-02-13','10:35:00',2.18),('9650','2013-02-13','10:40:00',2.29),('9650','2013-02-13','10:45:00',2.42),('9650','2013-02-13','10:50:00',2.56),('9650','2013-02-13','10:55:00',2.67),('9650','2013-02-13','11:00:00',2.78),('9650','2013-02-13','11:05:00',2.87),('9650','2013-02-13','11:10:00',2.98),('9650','2013-02-13','11:15:00',3.07),('9650','2013-02-13','11:20:00',3.16),('9650','2013-02-13','11:25:00',3.26),('9650','2013-02-13','11:30:00',3.36),('9650','2013-02-13','11:35:00',3.43),('9650','2013-02-13','11:40:00',3.53),('9650','2013-02-13','11:45:00',3.6),('9650','2013-02-13','11:50:00',3.67),('9650','2013-02-13','11:55:00',3.77),('9650','2013-02-13','12:00:00',3.83),('9650','2013-02-13','12:05:00',3.9),('9650','2013-02-13','12:10:00',3.94),('9650','2013-02-13','12:15:00',4.01),('9650','2013-02-13','12:20:00',4.05),('9650','2013-02-13','12:25:00',4.11),('9650','2013-02-13','12:30:00',4.16),('9650','2013-02-13','12:35:00',4.22),('9650','2013-02-13','12:40:00',4.26),('9650','2013-02-13','12:45:00',4.29),('9650','2013-02-13','12:50:00',4.31),('9650','2013-02-13','12:55:00',4.35),('9650','2013-02-13','13:00:00',4.38),('9650','2013-02-13','13:05:00',4.41),('9650','2013-02-13','13:10:00',4.43),('9650','2013-02-13','13:15:00',4.47),('9650','2013-02-13','13:20:00',4.43),('9650','2013-02-13','13:25:00',4.38),('9650','2013-02-13','13:30:00',4.36),('9650','2013-02-13','13:35:00',4.26),('9650','2013-02-13','13:40:00',4.13),('9650','2013-02-13','13:45:00',4.09),('9650','2013-02-13','13:50:00',4.04),('9650','2013-02-13','13:55:00',4.01),('9650','2013-02-13','14:00:00',4.02),('9650','2013-02-13','14:05:00',4.01),('9650','2013-02-13','14:10:00',3.98),('9650','2013-02-13','14:15:00',3.93),('9650','2013-02-13','14:20:00',3.85),('9650','2013-02-13','14:25:00',3.72),('9650','2013-02-13','14:30:00',3.65),('9650','2013-02-13','14:35:00',3.61),('9650','2013-02-13','14:40:00',3.53),('9650','2013-02-13','14:45:00',3.42),('9650','2013-02-13','14:50:00',3.38),('9650','2013-02-13','14:55:00',3.33),('9650','2013-02-13','15:00:00',3.24),('9650','2013-02-13','15:05:00',3.1),('9650','2013-02-13','15:10:00',2.93),('9650','2013-02-13','15:15:00',2.84),('9650','2013-02-13','15:20:00',2.74),('9650','2013-02-13','15:25:00',2.66),('9650','2013-02-13','15:30:00',2.68),('9650','2013-02-13','15:35:00',2.53),('9650','2013-02-13','15:40:00',2.48),('9650','2013-02-13','15:45:00',2.43),('9650','2013-02-13','15:50:00',2.42),('9650','2013-02-13','15:55:00',2.32),('9650','2013-02-13','16:00:00',2.22),('9650','2013-02-13','16:05:00',2.13),('9650','2013-02-13','16:10:00',2.02),('9650','2013-02-13','16:15:00',1.96),('9650','2013-02-13','16:20:00',1.85),('9650','2013-02-13','16:25:00',1.72),('9650','2013-02-13','16:30:00',1.53),('9650','2013-02-13','16:35:00',1.37),('9650','2013-02-13','16:40:00',1.11),('9650','2013-02-12','08:40:00',1.01),('9650','2013-02-12','08:45:00',1.1),('9650','2013-02-12','08:50:00',1.16),('9650','2013-02-12','08:55:00',1.23),('9650','2013-02-12','09:00:00',1.29),('9650','2013-02-12','09:05:00',1.34),('9650','2013-02-12','09:10:00',1.34),('9650','2013-02-12','09:15:00',1.32),('9650','2013-02-12','09:20:00',1.32),('9650','2013-02-12','09:25:00',1.34),('9650','2013-02-12','09:30:00',1.32),('9650','2013-02-12','09:35:00',1.44),('9650','2013-02-12','09:40:00',1.51),('9650','2013-02-12','09:45:00',1.6),('9650','2013-02-12','09:50:00',1.67),('9650','2013-02-12','09:55:00',1.67),('9650','2013-02-12','10:00:00',1.71),('9650','2013-02-12','10:05:00',1.83),('9650','2013-02-12','10:10:00',1.98),('9650','2013-02-12','10:15:00',2.1),('9650','2013-02-12','10:20:00',2.25),('9650','2013-02-12','10:25:00',2.38),('9650','2013-02-12','10:30:00',2.57),('9650','2013-02-12','10:35:00',2.69),('9650','2013-02-12','10:40:00',2.76),('9650','2013-02-12','10:45:00',2.98),('9650','2013-02-12','10:50:00',3.17),('9650','2013-02-12','10:55:00',3.26),('9650','2013-02-12','11:00:00',3.32),('9650','2013-02-12','11:05:00',3.47),('9650','2013-02-12','11:10:00',3.38),('9650','2013-02-12','11:15:00',3.52),('9650','2013-02-12','11:20:00',3.6),('9650','2013-02-12','11:25:00',3.28),('9650','2013-02-12','11:30:00',3.72),('9650','2013-02-12','11:35:00',2.5),('9650','2013-02-12','11:40:00',2.39),('9650','2013-02-12','11:45:00',2.13),('9650','2013-02-12','11:50:00',2.79),('9650','2013-02-12','11:55:00',2.15),('9650','2013-02-12','12:00:00',1.82),('9650','2013-02-12','12:05:00',2.19),('9650','2013-02-12','12:10:00',3.27),('9650','2013-02-12','12:15:00',2.99),('9650','2013-02-12','12:20:00',3.58),('9650','2013-02-12','12:25:00',2.9),('9650','2013-02-12','12:30:00',1.73),('9650','2013-02-12','12:35:00',2.23),('9650','2013-02-12','12:40:00',1.66),('9650','2013-02-12','12:45:00',3.29),('9650','2013-02-12','12:50:00',3.67),('9650','2013-02-12','12:55:00',3.53),('9650','2013-02-12','13:00:00',3.58),('9650','2013-02-12','13:05:00',2.65),('9650','2013-02-12','13:10:00',3.85),('9650','2013-02-12','13:15:00',2.82),('9650','2013-02-12','13:20:00',4.68),('9650','2013-02-12','13:25:00',4.7),('9650','2013-02-12','13:30:00',4.77),('9650','2013-02-12','13:35:00',4.77),('9650','2013-02-12','13:40:00',4.41),('9650','2013-02-12','13:45:00',3.87),('9650','2013-02-12','13:50:00',3.63),('9650','2013-02-12','13:55:00',3.76),('9650','2013-02-12','14:00:00',4.07),('9650','2013-02-12','14:05:00',4.43),('9650','2013-02-12','14:10:00',4.01),('9650','2013-02-12','14:15:00',3.85),('9650','2013-02-12','14:20:00',3.75),('9650','2013-02-12','14:25:00',3.33),('9650','2013-02-12','14:30:00',3.63),('9650','2013-02-12','14:35:00',3.68),('9650','2013-02-12','14:40:00',3.66),('9650','2013-02-12','14:45:00',3.37),('9650','2013-02-12','14:50:00',3.45),('9650','2013-02-12','14:55:00',3.34),('9650','2013-02-12','15:00:00',3.25),('9650','2013-02-12','15:05:00',3.06),('9650','2013-02-12','15:10:00',2.88),('9650','2013-02-12','15:15:00',2.79),('9650','2013-02-12','15:20:00',2.73),('9650','2013-02-12','15:25:00',2.74),('9650','2013-02-12','15:30:00',2.61),('9650','2013-02-12','15:35:00',2.58),('9650','2013-02-12','15:40:00',2.56),('9650','2013-02-12','15:45:00',2.5),('9650','2013-02-12','15:50:00',2.38),('9650','2013-02-12','15:55:00',2.32),('9650','2013-02-12','16:00:00',2.25),('9650','2013-02-12','16:05:00',2.14),('9650','2013-02-12','16:10:00',2.08),('9650','2013-02-12','16:15:00',2),('9650','2013-02-12','16:20:00',1.86),('9650','2013-02-12','16:25:00',1.67),('9650','2013-02-12','16:30:00',1.53),('9650','2013-02-12','16:35:00',1.37),('9650','2013-02-12','16:40:00',1.12),('9650','2013-02-10','09:30:00',1.16),('9650','2013-02-10','09:35:00',1.15),('9650','2013-02-10','10:10:00',1.08),('9650','2013-02-10','10:15:00',1.48),('9650','2013-02-10','10:20:00',1.82),('9650','2013-02-10','10:25:00',1.87),('9650','2013-02-10','10:30:00',1.73),('9650','2013-02-10','10:35:00',2.08),('9650','2013-02-10','10:40:00',1.9),('9650','2013-02-10','10:45:00',1.45),('9650','2013-02-10','10:50:00',1.18),('9650','2013-02-10','10:55:00',1.05),('9650','2013-02-10','11:00:00',1.48),('9650','2013-02-10','11:05:00',1.75),('9650','2013-02-10','11:10:00',2.13),('9650','2013-02-10','11:15:00',2.4),('9650','2013-02-10','11:20:00',1.94),('9650','2013-02-10','11:25:00',1.38),('9650','2013-02-10','11:40:00',1.3),('9650','2013-02-10','11:45:00',2.09),('9650','2013-02-10','11:50:00',1.59),('9650','2013-02-10','12:40:00',1.32),('9650','2013-02-10','12:45:00',2.11),('9650','2013-02-10','12:50:00',1.15),('9650','2013-02-10','12:55:00',1.13),('9650','2013-02-10','13:55:00',1.5),('9650','2013-02-10','14:00:00',1.73),('9650','2013-02-10','14:05:00',1.83),('9650','2013-02-10','14:10:00',2.09),('9650','2013-02-10','14:15:00',1.69),('9650','2013-02-10','14:20:00',1.71),('9650','2013-02-10','14:25:00',2.46),('9650','2013-02-10','14:30:00',3.34),('9650','2013-02-10','14:35:00',1.93),('9650','2013-02-10','14:40:00',2.86),('9650','2013-02-10','14:45:00',2.37),('9650','2013-02-10','14:50:00',1.59),('9650','2013-02-10','14:55:00',1.25),('9650','2013-02-10','15:00:00',1.05),('9650','2013-02-10','15:05:00',1.34),('9650','2013-02-10','15:10:00',1.63),('9650','2013-02-10','15:15:00',1.1),('9650','2013-02-10','15:20:00',1.26),('9650','2013-02-10','15:25:00',1.19),('9650','2013-02-10','15:30:00',1.03),('9650','2013-02-10','15:35:00',1.12),('9650','2013-02-10','15:40:00',1.04),('9650','2013-02-10','15:45:00',1.24),('9650','2013-02-10','15:50:00',1.19),('9650','2014-03-21','07:35:00',1.05),('9650','2014-03-21','07:40:00',1.33),('9650','2014-03-21','07:45:00',1.32),('9650','2014-03-21','07:50:00',1.22),('9650','2014-03-21','08:20:00',1.16),('9650','2014-03-21','08:25:00',1.27),('9650','2014-03-21','08:30:00',1.34),('9650','2014-03-21','08:35:00',1.3),('9650','2014-03-21','08:40:00',2.04),('9650','2014-03-21','08:45:00',2.06),('9650','2014-03-21','08:50:00',1.98),('9650','2014-03-21','08:55:00',2.18),('9650','2014-03-21','09:00:00',2.41),('9650','2014-03-21','09:05:00',2.04),('9650','2014-03-21','09:10:00',2.18),('9650','2014-03-21','09:15:00',1.99),('9650','2014-03-21','09:20:00',2.09),('9650','2014-03-21','09:25:00',2.31),('9650','2014-03-21','09:30:00',2.67),('9650','2014-03-21','09:35:00',1.74),('9650','2014-03-21','09:40:00',2.25),('9650','2014-03-21','09:45:00',2.89),('9650','2014-03-21','09:50:00',3.04),('9650','2014-03-21','09:55:00',3.18),('9650','2014-03-21','10:00:00',3.57),('9650','2014-03-21','10:05:00',3.3),('9650','2014-03-21','10:10:00',3.05),('9650','2014-03-21','10:15:00',2.79),('9650','2014-03-21','10:20:00',1.86),('9650','2014-03-21','10:25:00',1.58),('9650','2014-03-21','10:30:00',1.7),('9650','2014-03-21','10:35:00',2.46),('9650','2014-03-21','10:40:00',3.14),('9650','2014-03-21','10:45:00',3.99),('9650','2014-03-21','10:50:00',3.3),('9650','2014-03-21','10:55:00',2.22),('9650','2014-03-21','11:00:00',1.92),('9650','2014-03-21','11:05:00',1.86),('9650','2014-03-21','11:10:00',2.29),('9650','2014-03-21','11:15:00',2.9),('9650','2014-03-21','11:20:00',5.35),('9650','2014-03-21','11:25:00',6.03),('9650','2014-03-21','11:30:00',4.91),('9650','2014-03-21','11:35:00',2.62),('9650','2014-03-21','11:40:00',4.52),('9650','2014-03-21','11:45:00',2.4),('9650','2014-03-21','11:50:00',4.5),('9650','2014-03-21','11:55:00',6.15),('9650','2014-03-21','12:00:00',3.12),('9650','2014-03-21','12:05:00',2.43),('9650','2014-03-21','12:10:00',2.16),('9650','2014-03-21','12:15:00',4.07),('9650','2014-03-21','12:20:00',5.35),('9650','2014-03-21','12:25:00',3.68),('9650','2014-03-21','12:30:00',3.14),('9650','2014-03-21','12:35:00',3.41),('9650','2014-03-21','12:40:00',5.44),('9650','2014-03-21','12:45:00',5.65),('9650','2014-03-21','12:50:00',3.99),('9650','2014-03-21','12:55:00',3.21),('9650','2014-03-21','13:00:00',2.53),('9650','2014-03-21','13:05:00',4.61),('9650','2014-03-21','13:10:00',5.94),('9650','2014-03-21','13:15:00',4.36),('9650','2014-03-21','13:20:00',5.69),('9650','2014-03-21','13:25:00',5.41),('9650','2014-03-21','13:30:00',3.89),('9650','2014-03-21','13:35:00',4.84),('9650','2014-03-21','13:40:00',5.5),('9650','2014-03-21','13:45:00',5.81),('9650','2014-03-21','13:50:00',5.02),('9650','2014-03-21','13:55:00',3.62),('9650','2014-03-21','14:00:00',5.01),('9650','2014-03-21','14:05:00',3.8),('9650','2014-03-21','14:10:00',5.21),('9650','2014-03-21','14:15:00',4.1),('9650','2014-03-21','14:20:00',5.36),('9650','2014-03-21','14:25:00',5.16),('9650','2014-03-21','14:30:00',5.17),('9650','2014-03-21','14:35:00',5.11),('9650','2014-03-21','14:40:00',5.01),('9650','2014-03-21','14:45:00',4.82),('9650','2014-03-21','14:50:00',4.71),('9650','2014-03-21','14:55:00',4.57),('9650','2014-03-21','15:00:00',4.35),('9650','2014-03-21','15:05:00',4.48),('9650','2014-03-21','15:10:00',4.2),('9650','2014-03-21','15:15:00',4.37),('9650','2014-03-21','15:20:00',4.35),('9650','2014-03-21','15:25:00',3.49),('9650','2014-03-21','15:30:00',2.45),('9650','2014-03-21','15:35:00',4.04),('9650','2014-03-21','15:40:00',4.63),('9650','2014-03-21','15:45:00',4.65),('9650','2014-03-21','15:50:00',4.84),('9650','2014-03-21','15:55:00',4.37),('9650','2014-03-21','16:00:00',4.09),('9650','2014-03-21','16:05:00',3.69),('9650','2014-03-21','16:10:00',3.45),('9650','2014-03-21','16:15:00',3.06),('9650','2014-03-21','16:20:00',2.82),('9650','2014-03-21','16:25:00',2.87),('9650','2014-03-21','16:30:00',1.75),('9650','2014-03-21','16:35:00',1.05),('9650','2014-03-21','16:40:00',1.14),('9650','2014-03-21','16:45:00',1.21),('9650','2014-03-21','16:50:00',1.72),('9650','2014-03-21','16:55:00',1.91),('9650','2014-03-21','17:00:00',2.08),('9650','2014-03-21','17:05:00',1.31),('9650','2014-03-21','17:30:00',1.05),('9650','2013-02-09','09:15:00',1),('9650','2013-02-09','10:00:00',1.15),('9650','2013-02-09','10:05:00',1.31),('9650','2013-02-09','10:10:00',1.39),('9650','2013-02-09','10:15:00',1.55),('9650','2013-02-09','10:20:00',1.67),('9650','2013-02-09','10:25:00',1.8),('9650','2013-02-09','10:30:00',1.94),('9650','2013-02-09','10:35:00',2.05),('9650','2013-02-09','10:40:00',2.16),('9650','2013-02-09','10:45:00',2.25),('9650','2013-02-09','10:50:00',2.37),('9650','2013-02-09','10:55:00',2.5),('9650','2013-02-09','11:00:00',2.62),('9650','2013-02-09','11:05:00',2.71),('9650','2013-02-09','11:10:00',2.81),('9650','2013-02-09','11:15:00',2.9),('9650','2013-02-09','11:20:00',2.99),('9650','2013-02-09','11:25:00',3.07),('9650','2013-02-09','11:30:00',3.16),('9650','2013-02-09','11:35:00',3.25),('9650','2013-02-09','11:40:00',3.34),('9650','2013-02-09','11:45:00',3.43),('9650','2013-02-09','11:50:00',3.51),('9650','2013-02-09','11:55:00',3.58),('9650','2013-02-09','12:00:00',3.69),('9650','2013-02-09','12:05:00',3.72),('9650','2013-02-09','12:10:00',3.79),('9650','2013-02-09','12:15:00',3.88),('9650','2013-02-09','12:20:00',3.93),('9650','2013-02-09','12:25:00',3.99),('9650','2013-02-09','12:30:00',4.03),('9650','2013-02-09','12:35:00',4.09),('9650','2013-02-09','12:40:00',4.11),('9650','2013-02-09','12:45:00',4.14),('9650','2013-02-09','12:50:00',4.17),('9650','2013-02-09','12:55:00',4.23),('9650','2013-02-09','13:00:00',4.24),('9650','2013-02-09','13:05:00',4.21),('9650','2013-02-09','13:10:00',4.25),('9650','2013-02-09','13:15:00',4.25),('9650','2013-02-09','13:20:00',4.27),('9650','2013-02-09','13:25:00',4.28),('9650','2013-02-09','13:30:00',4.18),('9650','2013-02-09','13:35:00',4.1),('9650','2013-02-09','13:40:00',3.98),('9650','2013-02-09','13:45:00',3.83),('9650','2013-02-09','13:50:00',3.88),('9650','2013-02-09','13:55:00',3.84),('9650','2013-02-09','14:00:00',3.77),('9650','2013-02-09','14:05:00',3.75),('9650','2013-02-09','14:10:00',3.73),('9650','2013-02-09','14:15:00',3.71),('9650','2013-02-09','14:20:00',3.72),('9650','2013-02-09','14:25:00',3.61),('9650','2013-02-09','14:30:00',3.53),('9650','2013-02-09','14:35:00',3.23),('9650','2013-02-09','14:40:00',3.44),('9650','2013-02-09','14:45:00',3.32),('9650','2013-02-09','14:50:00',3.24),('9650','2013-02-09','14:55:00',2.81),('9650','2013-02-09','15:00:00',2),('9650','2013-02-09','15:05:00',2.4),('9650','2013-02-09','15:10:00',2.8),('9650','2013-02-09','15:15:00',2.27),('9650','2013-02-09','15:20:00',2.73),('9650','2013-02-09','15:25:00',3.16),('9650','2013-02-09','15:30:00',2.51),('9650','2013-02-09','15:35:00',2.24),('9650','2013-02-09','15:40:00',1.81),('9650','2013-02-09','15:45:00',1.02),('9650','2013-02-09','16:20:00',1.02),('9650','2013-02-09','16:25:00',1.52),('9650','2013-02-09','16:30:00',1.41),('9650','2013-02-09','16:35:00',1.36),('9650','2013-02-08','09:15:00',1.03),('9650','2013-02-08','09:20:00',1.02),('9650','2013-02-08','09:25:00',1.19),('9650','2013-02-08','09:30:00',1.42),('9650','2013-02-08','09:35:00',1.41),('9650','2013-02-08','09:40:00',1.15),('9650','2013-02-08','10:30:00',1.01),('9650','2013-02-08','10:35:00',1.1),('9650','2013-02-08','10:40:00',1.25),('9650','2013-02-08','10:45:00',1.45),('9650','2013-02-08','10:50:00',1.65),('9650','2013-02-08','10:55:00',1.79),('9650','2013-02-08','11:00:00',1.91),('9650','2013-02-08','11:05:00',1.98),('9650','2013-02-08','11:10:00',2.04),('9650','2013-02-08','11:15:00',2.12),('9650','2013-02-08','11:20:00',2.17),('9650','2013-02-08','11:25:00',2.17),('9650','2013-02-08','11:30:00',2.19),('9650','2013-02-08','11:35:00',2.14),('9650','2013-02-08','11:40:00',2.09),('9650','2013-02-08','11:45:00',2.1),('9650','2013-02-08','11:50:00',2.08),('9650','2013-02-08','11:55:00',2.03),('9650','2013-02-08','12:00:00',2.06),('9650','2013-02-08','12:05:00',2.07),('9650','2013-02-08','12:10:00',2.01),('9650','2013-02-08','12:15:00',1.99),('9650','2013-02-08','12:20:00',2.01),('9650','2013-02-08','12:25:00',2.03),('9650','2013-02-08','12:30:00',2.08),('9650','2013-02-08','12:35:00',2.18),('9650','2013-02-08','12:40:00',2.22),('9650','2013-02-08','12:45:00',2.23),('9650','2013-02-08','12:50:00',2.26),('9650','2013-02-08','12:55:00',2.24),('9650','2013-02-08','13:00:00',2.38),('9650','2013-02-08','13:05:00',2.66),('9650','2013-02-08','13:10:00',2.89),('9650','2013-02-08','13:15:00',3.05),('9650','2013-02-08','13:20:00',3.31),('9650','2013-02-08','13:25:00',3.41),('9650','2013-02-08','13:30:00',3.69),('9650','2013-02-08','13:35:00',3.75),('9650','2013-02-08','13:40:00',3.75),('9650','2013-02-08','13:45:00',3.97),('9650','2013-02-08','13:50:00',4.12),('9650','2013-02-08','13:55:00',4.21),('9650','2013-02-08','14:00:00',4.02),('9650','2013-02-08','14:05:00',3.73),('9650','2013-02-08','14:15:00',1.2),('9650','2013-02-08','14:20:00',4.57),('9650','2013-02-08','14:25:00',4.57),('9650','2013-02-08','14:30:00',4.03),('9650','2013-02-08','14:35:00',3.68),('9650','2013-02-08','14:40:00',3.39),('9650','2013-02-08','14:45:00',3.22),('9650','2013-02-08','14:50:00',3.12),('9650','2013-02-08','14:55:00',3.12),('9650','2013-02-08','15:00:00',3.01),('9650','2013-02-08','15:05:00',2.87),('9650','2013-02-08','15:10:00',2.63),('9650','2013-02-08','15:15:00',2.56),('9650','2013-02-08','15:20:00',2.5),('9650','2013-02-08','15:25:00',2.24),('9650','2013-02-08','15:30:00',2.36),('9650','2013-02-08','15:35:00',2.32),('9650','2013-02-08','15:40:00',2.25),('9650','2013-02-08','15:45:00',2.12),('9650','2013-02-08','15:50:00',2.12),('9650','2013-02-08','15:55:00',1.67),('9650','2013-02-08','16:20:00',1.28),('9650','2013-02-08','16:25:00',1.26),('9650','2013-02-08','16:30:00',1.15),('9650','2013-02-08','16:35:00',1.01),('9650','2013-02-07','09:20:00',1.08),('9650','2013-02-07','09:25:00',1.16),('9650','2013-02-07','09:30:00',1.16),('9650','2013-02-07','09:35:00',1.44),('9650','2013-02-07','09:40:00',1.49),('9650','2013-02-07','09:45:00',1.33),('9650','2013-02-07','09:50:00',1.26),('9650','2013-02-07','09:55:00',1.34),('9650','2013-02-07','10:00:00',1.42),('9650','2013-02-07','10:05:00',1.74),('9650','2013-02-07','10:10:00',1.8),('9650','2013-02-07','10:15:00',1.96),('9650','2013-02-07','10:20:00',2.11),('9650','2013-02-07','10:25:00',1.97),('9650','2013-02-07','10:30:00',2.12),('9650','2013-02-07','10:35:00',1.19),('9650','2013-02-07','10:40:00',1.73),('9650','2013-02-07','10:45:00',2.55),('9650','2013-02-07','10:50:00',2.7),('9650','2013-02-07','10:55:00',2.71),('9650','2013-02-07','11:00:00',2.67),('9650','2013-02-07','11:05:00',2.68),('9650','2013-02-07','11:10:00',2.77),('9650','2013-02-07','11:15:00',2.84),('9650','2013-02-07','11:20:00',2.94),('9650','2013-02-07','11:25:00',3.02),('9650','2013-02-07','11:30:00',3.1),('9650','2013-02-07','11:35:00',3.18),('9650','2013-02-07','11:40:00',3.26),('9650','2013-02-07','11:45:00',3.34),('9650','2013-02-07','11:50:00',3.41),('9650','2013-02-07','11:55:00',3.48),('9650','2013-02-07','12:00:00',3.56),('9650','2013-02-07','12:05:00',3.62),('9650','2013-02-07','12:10:00',3.69),('9650','2013-02-07','12:15:00',3.78),('9650','2013-02-07','12:20:00',3.86),('9650','2013-02-07','12:25:00',3.96),('9650','2013-02-07','12:30:00',3.98),('9650','2013-02-07','12:35:00',4.06),('9650','2013-02-07','12:40:00',4.27),('9650','2013-02-07','12:45:00',4.97),('9650','2013-02-07','12:50:00',2.94),('9650','2013-02-07','12:55:00',3.2),('9650','2013-02-07','13:00:00',3.04),('9650','2013-02-07','13:05:00',2.71),('9650','2013-02-07','13:10:00',2.98),('9650','2013-02-07','13:15:00',2.93),('9650','2013-02-07','13:20:00',3.13),('9650','2013-02-07','13:25:00',2.91),('9650','2013-02-07','13:30:00',2.89),('9650','2013-02-07','13:35:00',3.7),('9650','2013-02-07','13:40:00',2.92),('9650','2013-02-07','13:45:00',2.33),('9650','2013-02-07','13:50:00',2.41),('9650','2013-02-07','13:55:00',2.53),('9650','2013-02-07','14:00:00',2.37),('9650','2013-02-07','14:05:00',2.39),('9650','2013-02-07','14:10:00',2.23),('9650','2013-02-07','14:15:00',2.09),('9650','2013-02-07','14:20:00',2.18),('9650','2013-02-07','14:25:00',2.71),('9650','2013-02-07','14:30:00',3.9),('9650','2013-02-07','14:35:00',3.3),('9650','2013-02-07','14:40:00',5.11),('9650','2013-02-07','14:45:00',3.83),('9650','2013-02-07','14:50:00',3.4),('9650','2013-02-07','14:55:00',3.88),('9650','2013-02-07','15:00:00',3.82),('9650','2013-02-07','15:05:00',4.13),('9650','2013-02-07','15:10:00',3.73),('9650','2013-02-07','15:15:00',3.08),('9650','2013-02-07','15:20:00',2.27),('9650','2013-02-07','15:25:00',2.59),('9650','2013-02-07','15:30:00',2.51),('9650','2013-02-07','15:35:00',2.43),('9650','2013-02-07','15:40:00',2.4),('9650','2013-02-07','15:45:00',2.33),('9650','2013-02-07','15:50:00',2.25),('9650','2013-02-07','15:55:00',2.12),('9650','2013-02-07','16:00:00',2),('9650','2013-02-07','16:05:00',1.89),('9650','2013-02-07','16:10:00',1.85),('9650','2013-02-07','16:15:00',1.49),('9650','2013-02-06','09:35:00',1.02),('9650','2013-02-06','09:40:00',1.06),('9650','2013-02-06','09:45:00',1.16),('9650','2013-02-06','09:50:00',1.18),('9650','2013-02-06','10:35:00',1.37),('9650','2013-02-06','10:40:00',1.49),('9650','2013-02-06','10:45:00',1.37),('9650','2013-02-06','10:50:00',1.12),('9650','2013-02-06','10:55:00',1.62),('9650','2013-02-06','11:00:00',2.22),('9650','2013-02-06','11:05:00',1.69),('9650','2013-02-06','11:10:00',1.41),('9650','2013-02-06','12:20:00',1.72),('9650','2013-02-06','12:25:00',3.68),('9650','2013-02-06','12:30:00',2.84),('9650','2013-02-06','12:35:00',1.54),('9650','2013-02-06','12:40:00',1.09),('9650','2013-02-06','12:45:00',1.39),('9650','2013-02-06','12:50:00',1.58),('9650','2013-02-06','12:55:00',1.21),('9650','2013-02-06','13:00:00',1.04),('9650','2013-02-06','13:05:00',1.18),('9650','2013-02-06','13:10:00',1.36),('9650','2013-02-06','13:15:00',2.79),('9650','2013-02-06','13:20:00',2.33),('9650','2013-02-06','13:25:00',2.28),('9650','2013-02-06','13:30:00',1.74),('9650','2013-02-06','13:35:00',1.46),('9650','2013-02-06','13:40:00',1.63),('9650','2013-02-06','13:45:00',1.66),('9650','2013-02-06','13:50:00',1.75),('9650','2013-02-06','13:55:00',1.99),('9650','2013-02-06','14:00:00',2.37),('9650','2013-02-06','14:05:00',3.18),('9650','2013-02-06','14:10:00',4.66),('9650','2013-02-06','14:15:00',4.23),('9650','2013-02-06','14:20:00',3.74),('9650','2013-02-06','14:25:00',1.96),('9650','2013-02-06','14:30:00',1.71),('9650','2013-02-06','14:35:00',2.92),('9650','2013-02-06','14:40:00',3.06),('9650','2013-02-06','14:45:00',2.85),('9650','2013-02-06','14:50:00',1.99),('9650','2013-02-06','14:55:00',2.34),('9650','2013-02-06','15:00:00',3.08),('9650','2013-02-06','15:05:00',3.63),('9650','2013-02-06','15:10:00',3.58),('9650','2013-02-06','15:15:00',2.74),('9650','2013-02-06','15:20:00',1.63),('9650','2013-02-06','15:25:00',1.96),('9650','2013-02-06','15:30:00',1.2),('9650','2013-02-06','15:35:00',1.4),('9650','2013-02-06','15:40:00',1.17),('9650','2013-02-06','15:50:00',1.1),('9650','2013-02-06','15:55:00',1),('9650','2013-02-05','08:40:00',1.03),('9650','2013-02-05','08:45:00',1.05),('9650','2013-02-05','08:50:00',1.18),('9650','2013-02-05','08:55:00',1.22),('9650','2013-02-05','09:00:00',1.28),('9650','2013-02-05','09:05:00',1.21),('9650','2013-02-05','09:10:00',1.24),('9650','2013-02-05','09:15:00',1.33),('9650','2013-02-05','09:20:00',1.52),('9650','2013-02-05','09:25:00',1.6),('9650','2013-02-05','09:30:00',1.72),('9650','2013-02-05','09:35:00',1.66),('9650','2013-02-05','09:40:00',1.78),('9650','2013-02-05','09:45:00',1.77),('9650','2013-02-05','09:50:00',1.82),('9650','2013-02-05','09:55:00',1.93),('9650','2013-02-05','10:00:00',1.91),('9650','2013-02-05','10:05:00',2.03),('9650','2013-02-05','10:10:00',1.99),('9650','2013-02-05','10:15:00',1.96),('9650','2013-02-05','10:20:00',1.9),('9650','2013-02-05','10:25:00',2.08),('9650','2013-02-05','10:30:00',2.03),('9650','2013-02-05','10:35:00',2.29),('9650','2013-02-05','10:40:00',1.86),('9650','2013-02-05','10:45:00',1.76),('9650','2013-02-05','10:50:00',2.38),('9650','2013-02-05','10:55:00',2.71),('9650','2013-02-05','11:00:00',2.51),('9650','2013-02-05','11:05:00',2.29),('9650','2013-02-05','11:10:00',2.42),('9650','2013-02-05','11:15:00',2.31),('9650','2013-02-05','11:20:00',2.56),('9650','2013-02-05','11:25:00',3.48),('9650','2013-02-05','11:30:00',2.32),('9650','2013-02-05','11:35:00',2.28),('9650','2013-02-05','11:40:00',2.6),('9650','2013-02-05','11:45:00',2.66),('9650','2013-02-05','11:50:00',2.78),('9650','2013-02-05','11:55:00',2.64),('9650','2013-02-05','12:00:00',2.31),('9650','2013-02-05','12:05:00',1.79),('9650','2013-02-05','12:10:00',1.41),('9650','2013-02-05','12:15:00',2.05),('9650','2013-02-05','12:20:00',1.94),('9650','2013-02-05','12:25:00',1.84),('9650','2013-02-05','12:30:00',1.59),('9650','2013-02-05','12:35:00',1.41),('9650','2013-02-05','12:40:00',1.27),('9650','2013-02-05','12:45:00',1.3),('9650','2013-02-05','12:50:00',1.28),('9650','2013-02-05','12:55:00',1.26),('9650','2013-02-05','13:00:00',1.13),('9650','2013-02-05','13:05:00',1.19),('9650','2013-02-05','13:10:00',1.36),('9650','2013-02-05','13:15:00',1.62),('9650','2013-02-05','13:20:00',1.79),('9650','2013-02-05','13:25:00',2.03),('9650','2013-02-05','13:30:00',2.33),('9650','2013-02-05','13:35:00',2.44),('9650','2013-02-05','13:40:00',2.03),('9650','2013-02-05','13:45:00',2.08),('9650','2013-02-05','13:50:00',2.71),('9650','2013-02-05','13:55:00',2.21),('9650','2013-02-05','14:00:00',2.39),('9650','2013-02-05','14:05:00',2.21),('9650','2013-02-05','14:10:00',1.2),('9650','2013-02-05','14:30:00',2.82),('9650','2013-02-05','14:35:00',3.28),('9650','2013-02-05','14:40:00',2.29),('9650','2013-02-05','14:45:00',1.02),('9650','2013-02-05','15:20:00',1.02),('9650','2013-02-05','15:25:00',1.62),('9650','2013-02-05','15:45:00',1.01),('9650','2013-02-05','15:50:00',1.26),('9650','2013-02-04','10:00:00',1.01),('9650','2013-02-04','10:05:00',1.09),('9650','2013-02-04','10:10:00',1.11),('9650','2013-02-04','10:15:00',1.14),('9650','2013-02-04','10:20:00',1.42),('9650','2013-02-04','10:25:00',1.53),('9650','2013-02-04','10:30:00',1.62),('9650','2013-02-04','10:35:00',1.71),('9650','2013-02-04','10:40:00',1.8),('9650','2013-02-04','10:45:00',1.97),('9650','2013-02-04','10:50:00',2.07),('9650','2013-02-04','10:55:00',2.18),('9650','2013-02-04','11:00:00',2.29),('9650','2013-02-04','11:05:00',2.39),('9650','2013-02-04','11:10:00',2.53),('9650','2013-02-04','11:15:00',2.62),('9650','2013-02-04','11:20:00',2.65),('9650','2013-02-04','11:25:00',2.84),('9650','2013-02-04','11:30:00',2.91),('9650','2013-02-04','11:35:00',2.83),('9650','2013-02-04','11:40:00',2.84),('9650','2013-02-04','11:45:00',3.09),('9650','2013-02-04','11:50:00',2.47),('9650','2013-02-04','11:55:00',2.2),('9650','2013-02-04','12:00:00',1.77),('9650','2013-02-04','12:05:00',2.15),('9650','2013-02-04','12:10:00',2.26),('9650','2013-02-04','12:15:00',2.35),('9650','2013-02-04','12:20:00',2.08),('9650','2013-02-04','12:25:00',2.09),('9650','2013-02-04','12:30:00',2.01),('9650','2013-02-04','12:35:00',2.61),('9650','2013-02-04','12:40:00',3.04),('9650','2013-02-04','12:45:00',3.4),('9650','2013-02-04','12:50:00',3.05),('9650','2013-02-04','12:55:00',1.52),('9650','2013-02-04','13:00:00',1.23),('9650','2013-02-04','13:05:00',1.34),('9650','2013-02-04','13:10:00',1.88),('9650','2013-02-04','13:15:00',2.32),('9650','2013-02-04','13:20:00',2.32),('9650','2013-02-04','13:25:00',2.32),('9650','2013-02-04','13:30:00',2.16),('9650','2013-02-04','13:35:00',1.72),('9650','2013-02-04','13:40:00',1.9),('9650','2013-02-04','13:45:00',2.38),('9650','2013-02-04','13:50:00',2.41),('9650','2013-02-04','13:55:00',2.11),('9650','2013-02-04','14:00:00',2.17),('9650','2013-02-04','14:05:00',2.1),('9650','2013-02-04','14:10:00',1.67),('9650','2013-02-04','14:15:00',1.9),('9650','2013-02-04','14:20:00',2.18),('9650','2013-02-04','14:25:00',2.86),('9650','2013-02-04','14:30:00',2.91),('9650','2013-02-04','14:35:00',2.34),('9650','2013-02-04','14:40:00',2.47),('9650','2013-02-04','14:45:00',1.77),('9650','2013-02-04','14:50:00',1.48),('9650','2013-02-04','14:55:00',1.23),('9650','2013-02-04','15:00:00',1.28),('9650','2013-02-04','15:05:00',1.67),('9650','2013-02-04','15:10:00',1.17),('9650','2013-02-04','15:15:00',1.01),('9650','2013-02-03','10:05:00',1.07),('9650','2013-02-03','10:10:00',1.22),('9650','2013-02-03','10:15:00',1.36),('9650','2013-02-03','10:20:00',1.36),('9650','2013-02-03','10:25:00',1.52),('9650','2013-02-03','10:30:00',1.52),('9650','2013-02-03','10:35:00',1.48),('9650','2013-02-03','10:40:00',1.61),('9650','2013-02-03','10:45:00',1.9),('9650','2013-02-03','10:50:00',2.05),('9650','2013-02-03','10:55:00',2.13),('9650','2013-02-03','11:00:00',2.22),('9650','2013-02-03','11:05:00',2.36),('9650','2013-02-03','11:10:00',2.48),('9650','2013-02-03','11:15:00',2.58),('9650','2013-02-03','11:20:00',2.69),('9650','2013-02-03','11:25:00',2.77),('9650','2013-02-03','11:30:00',2.85),('9650','2013-02-03','11:35:00',2.94),('9650','2013-02-03','11:40:00',3.02),('9650','2013-02-03','11:45:00',3.1),('9650','2013-02-03','11:50:00',3.18),('9650','2013-02-03','11:55:00',3.25),('9650','2013-02-03','12:00:00',3.33),('9650','2013-02-03','12:05:00',3.38),('9650','2013-02-03','12:10:00',3.45),('9650','2013-02-03','12:15:00',3.51),('9650','2013-02-03','12:20:00',3.56),('9650','2013-02-03','12:25:00',3.62),('9650','2013-02-03','12:30:00',3.66),('9650','2013-02-03','12:35:00',3.69),('9650','2013-02-03','12:40:00',3.73),('9650','2013-02-03','12:45:00',3.78),('9650','2013-02-03','12:50:00',3.83),('9650','2013-02-03','12:55:00',3.88),('9650','2013-02-03','13:00:00',3.92),('9650','2013-02-03','13:05:00',3.94),('9650','2013-02-03','13:10:00',3.95),('9650','2013-02-03','13:15:00',3.97),('9650','2013-02-03','13:20:00',3.98),('9650','2013-02-03','13:25:00',3.99),('9650','2013-02-03','13:30:00',3.97),('9650','2013-02-03','13:35:00',3.89),('9650','2013-02-03','13:40:00',3.77),('9650','2013-02-03','13:45:00',3.73),('9650','2013-02-03','13:50:00',3.61),('9650','2013-02-03','13:55:00',3.58),('9650','2013-02-03','14:00:00',3.51),('9650','2013-02-03','14:05:00',3.48),('9650','2013-02-03','14:10:00',3.47),('9650','2013-02-03','14:15:00',3.43),('9650','2013-02-03','14:20:00',3.43),('9650','2013-02-03','14:25:00',3.41),('9650','2013-02-03','14:30:00',3.22),('9650','2013-02-03','14:35:00',3.16),('9650','2013-02-03','14:40:00',3.11),('9650','2013-02-03','14:45:00',3.06),('9650','2013-02-03','14:50:00',2.91),('9650','2013-02-03','14:55:00',2.88),('9650','2013-02-03','15:00:00',2.76),('9650','2013-02-03','15:05:00',2.62),('9650','2013-02-03','15:10:00',2.43),('9650','2013-02-03','15:15:00',2.37),('9650','2013-02-03','15:20:00',2.36),('9650','2013-02-03','15:25:00',2.26),('9650','2013-02-03','15:30:00',2.25),('9650','2013-02-03','15:35:00',2.2),('9650','2013-02-03','15:40:00',2.15),('9650','2013-02-03','15:45:00',2.03),('9650','2013-02-03','15:50:00',1.94),('9650','2013-02-03','15:55:00',1.87),('9650','2013-02-03','16:00:00',1.78),('9650','2013-02-03','16:05:00',1.73),('9650','2013-02-03','16:10:00',1.61),('9650','2013-02-03','16:15:00',1.43),('9650','2013-02-03','16:20:00',1.32),('9650','2013-02-02','09:15:00',1.09),('9650','2013-02-02','09:20:00',1.49),('9650','2013-02-02','09:25:00',1.95),('9650','2013-02-02','09:30:00',1.54),('9650','2013-02-02','09:35:00',1.32),('9650','2013-02-02','09:40:00',1.59),('9650','2013-02-02','09:45:00',1.86),('9650','2013-02-02','09:50:00',2.06),('9650','2013-02-02','09:55:00',2.04),('9650','2013-02-02','10:00:00',1.69),('9650','2013-02-02','10:05:00',1.03),('9650','2013-02-02','10:20:00',1.55),('9650','2013-02-02','10:25:00',1.05),('9650','2013-02-02','11:15:00',1.08),('9650','2013-02-02','11:20:00',2.21),('9650','2013-02-02','11:25:00',1.45),('9650','2013-02-02','11:45:00',1.47),('9650','2013-02-02','11:50:00',1.97),('9650','2013-02-02','11:55:00',2.51),('9650','2013-02-02','12:00:00',2.32),('9650','2013-02-02','12:05:00',2.32),('9650','2013-02-02','12:10:00',2.34),('9650','2013-02-02','12:15:00',1.72),('9650','2013-02-02','12:20:00',1.35),('9650','2013-02-02','12:30:00',1.01),('9650','2013-02-01','10:15:00',1.68),('9650','2013-02-01','10:20:00',1.64),('9650','2013-02-01','10:25:00',1.68),('9650','2013-02-01','10:30:00',1.73),('9650','2013-02-01','10:35:00',1.84),('9650','2013-02-01','10:40:00',1.97),('9650','2013-02-01','10:45:00',2.08),('9650','2013-02-01','10:50:00',1.9),('9650','2013-02-01','10:55:00',2.31),('9650','2013-02-01','11:00:00',2.42),('9650','2013-02-01','11:05:00',2.28),('9650','2013-02-01','11:10:00',2.44),('9650','2013-02-01','11:15:00',2.39),('9650','2013-02-01','11:20:00',2.44),('9650','2013-02-01','11:25:00',2.85),('9650','2013-02-01','11:30:00',2.83),('9650','2013-02-01','11:35:00',2.78),('9650','2013-02-01','11:40:00',2.78),('9650','2013-02-01','11:45:00',2.1),('9650','2013-02-01','11:50:00',1.85),('9650','2013-02-01','11:55:00',1.94),('9650','2013-02-01','12:00:00',1.49),('9650','2013-02-01','12:05:00',1.1),('9650','2013-02-01','12:50:00',1.29),('9650','2013-02-01','12:55:00',2.94),('9650','2013-02-01','13:00:00',2.28),('9650','2013-02-01','13:05:00',2.43),('9650','2013-02-01','13:10:00',3.09),('9650','2013-02-01','13:15:00',3.1),('9650','2013-02-01','13:20:00',2.66),('9650','2013-02-01','13:25:00',2.69),('9650','2013-02-01','13:30:00',2.25),('9650','2013-02-01','13:35:00',3.19),('9650','2013-02-01','13:40:00',3.89),('9650','2013-02-01','13:45:00',3.17),('9650','2013-02-01','13:50:00',2.92),('9650','2013-02-01','13:55:00',1.61),('9650','2013-01-31','09:30:00',1.18),('9650','2013-01-31','09:35:00',1.45),('9650','2013-01-31','09:40:00',1.63),('9650','2013-01-31','09:45:00',1.33),('9650','2013-01-31','09:50:00',1.53),('9650','2013-01-31','09:55:00',1.72),('9650','2013-01-31','10:00:00',1.46),('9650','2013-01-31','10:05:00',1.34),('9650','2013-01-31','10:15:00',1.24),('9650','2013-01-31','10:20:00',1.33),('9650','2013-01-31','10:25:00',1.57),('9650','2013-01-31','10:30:00',1.6),('9650','2013-01-31','10:35:00',1.31),('9650','2013-01-31','10:40:00',1.26),('9650','2013-01-31','10:45:00',1.52),('9650','2013-01-31','10:50:00',3.25),('9650','2013-01-31','10:55:00',2.75),('9650','2013-01-31','11:00:00',2.82),('9650','2013-01-31','11:05:00',2.69),('9650','2013-01-31','11:10:00',2.06),('9650','2013-01-31','11:15:00',1.87),('9650','2013-01-31','11:20:00',2.48),('9650','2013-01-31','11:25:00',1.18),('9650','2013-01-31','11:30:00',2.08),('9650','2013-01-31','11:35:00',2.57),('9650','2013-01-31','11:40:00',2.35),('9650','2013-01-31','11:45:00',2.32),('9650','2013-01-31','11:50:00',2.14),('9650','2013-01-31','11:55:00',1.73),('9650','2013-01-31','12:00:00',2.15),('9650','2013-01-31','12:05:00',2.89),('9650','2013-01-31','12:10:00',2.66),('9650','2013-01-31','12:15:00',3.66),('9650','2013-01-31','12:20:00',4.24),('9650','2013-01-31','12:25:00',2.65),('9650','2013-01-31','12:30:00',3.01),('9650','2013-01-31','12:35:00',4.02),('9650','2013-01-31','12:40:00',4.01),('9650','2013-01-31','12:45:00',3.69),('9650','2013-01-31','12:50:00',4.01),('9650','2013-01-31','12:55:00',2.5),('9650','2013-01-31','13:00:00',2.45),('9650','2013-01-31','13:05:00',3.78),('9650','2013-01-31','13:10:00',3.89),('9650','2013-01-31','13:15:00',3.75),('9650','2013-01-31','13:20:00',3.96),('9650','2013-01-31','13:25:00',3.15),('9650','2013-01-31','13:30:00',4.04),('9650','2013-01-31','13:35:00',3.03),('9650','2013-01-31','13:40:00',3.15),('9650','2013-01-31','13:45:00',1.82),('9650','2013-01-31','13:50:00',1.9),('9650','2013-01-31','13:55:00',1.68),('9650','2013-01-31','14:00:00',1.62),('9650','2013-01-31','14:05:00',1.69),('9650','2013-01-31','14:10:00',3.81),('9650','2013-01-31','14:15:00',4.15),('9650','2013-01-31','14:20:00',3.22),('9650','2013-01-31','14:25:00',3.15),('9650','2013-01-31','14:30:00',3.1),('9650','2013-01-31','14:35:00',3.08),('9650','2013-01-31','14:40:00',2.32),('9650','2013-01-31','14:50:00',1.2),('9650','2013-01-31','14:55:00',1.33),('9650','2013-01-31','15:00:00',1.77),('9650','2013-01-31','15:05:00',2.45),('9650','2013-01-31','15:10:00',2.37),('9650','2013-01-31','15:15:00',2.13),('9650','2013-01-31','15:20:00',2.11),('9650','2013-01-31','15:25:00',1.84),('9650','2013-01-31','15:30:00',1.1),('9650','2013-01-31','15:40:00',1.06),('9650','2013-01-31','15:45:00',1.11),('9650','2013-01-31','15:50:00',1.65),('9650','2013-01-31','15:55:00',1.56),('9650','2014-03-20','08:30:00',1.09),('9650','2014-03-20','08:35:00',1.17),('9650','2014-03-20','08:40:00',1.27),('9650','2014-03-20','08:45:00',1.36),('9650','2014-03-20','08:50:00',1.47),('9650','2014-03-20','08:55:00',1.59),('9650','2014-03-20','09:00:00',1.71),('9650','2014-03-20','09:05:00',1.81),('9650','2014-03-20','09:10:00',1.94),('9650','2014-03-20','09:15:00',2.07),('9650','2014-03-20','09:20:00',2.21),('9650','2014-03-20','09:25:00',2.23),('9650','2014-03-20','09:30:00',2.44),('9650','2014-03-20','09:35:00',2.53),('9650','2014-03-20','09:40:00',2.69),('9650','2014-03-20','09:45:00',2.77),('9650','2014-03-20','09:50:00',2.86),('9650','2014-03-20','09:55:00',3.03),('9650','2014-03-20','10:00:00',3.14),('9650','2014-03-20','10:05:00',3.25),('9650','2014-03-20','10:10:00',3.37),('9650','2014-03-20','10:15:00',3.48),('9650','2014-03-20','10:20:00',3.57),('9650','2014-03-20','10:25:00',3.67),('9650','2014-03-20','10:30:00',3.74),('9650','2014-03-20','10:35:00',3.91),('9650','2014-03-20','10:40:00',3.96),('9650','2014-03-20','10:45:00',4.01),('9650','2014-03-20','10:50:00',4.07),('9650','2014-03-20','10:55:00',4.14),('9650','2014-03-20','11:00:00',4.26),('9650','2014-03-20','11:05:00',4.35),('9650','2014-03-20','11:10:00',4.41),('9650','2014-03-20','11:15:00',4.53),('9650','2014-03-20','11:20:00',4.69),('9650','2014-03-20','11:25:00',4.85),('9650','2014-03-20','11:30:00',3.51),('9650','2014-03-20','11:35:00',3.16),('9650','2014-03-20','11:40:00',5.07),('9650','2014-03-20','11:45:00',5.36),('9650','2014-03-20','11:50:00',5.68),('9650','2014-03-20','11:55:00',5.61),('9650','2014-03-20','12:00:00',3.65),('9650','2014-03-20','12:05:00',4.66),('9650','2014-03-20','12:10:00',5.42),('9650','2014-03-20','12:15:00',5.53),('9650','2014-03-20','12:20:00',5.5),('9650','2014-03-20','12:25:00',5.5),('9650','2014-03-20','12:30:00',5.53),('9650','2014-03-20','12:35:00',5.52),('9650','2014-03-20','12:40:00',5.53),('9650','2014-03-20','12:45:00',5.59),('9650','2014-03-20','12:50:00',5.59),('9650','2014-03-20','12:55:00',5.59),('9650','2014-03-20','13:00:00',5.67),('9650','2014-03-20','13:05:00',5.67),('9650','2014-03-20','13:10:00',5.63),('9650','2014-03-20','13:15:00',5.64),('9650','2014-03-20','13:20:00',5.63),('9650','2014-03-20','13:25:00',5.61),('9650','2014-03-20','13:30:00',5.61),('9650','2014-03-20','13:35:00',5.62),('9650','2014-03-20','13:40:00',5.59),('9650','2014-03-20','13:45:00',5.59),('9650','2014-03-20','13:50:00',5.54),('9650','2014-03-20','13:55:00',5.39),('9650','2014-03-20','14:00:00',5.44),('9650','2014-03-20','14:05:00',5.44),('9650','2014-03-20','14:10:00',5.38),('9650','2014-03-20','14:15:00',5.32),('9650','2014-03-20','14:20:00',5.22),('9650','2014-03-20','14:25:00',5.17),('9650','2014-03-20','14:30:00',4.91),('9650','2014-03-20','14:35:00',4.8),('9650','2014-03-20','14:40:00',4.88),('9650','2014-03-20','14:45:00',4.72),('9650','2014-03-20','14:50:00',3.88),('9650','2014-03-20','14:55:00',1.88),('9650','2014-03-20','15:00:00',1.47),('9650','2014-03-20','15:05:00',2.77),('9650','2014-03-20','15:10:00',4.91),('9650','2014-03-20','15:15:00',5.26),('9650','2014-03-20','15:20:00',4.65),('9650','2014-03-20','15:25:00',4.95),('9650','2014-03-20','15:30:00',4.93),('9650','2014-03-20','15:35:00',4.61),('9650','2014-03-20','15:40:00',4.71),('9650','2014-03-20','15:45:00',4.68),('9650','2014-03-20','15:50:00',4.58),('9650','2014-03-20','15:55:00',4.51),('9650','2014-03-20','16:00:00',4.31),('9650','2014-03-20','16:05:00',4.08),('9650','2014-03-20','16:10:00',3.86),('9650','2014-03-20','16:15:00',3.54),('9650','2014-03-20','16:20:00',3.37),('9650','2014-03-20','16:25:00',3.23),('9650','2014-03-20','16:30:00',3.16),('9650','2014-03-20','16:35:00',3.02),('9650','2014-03-20','16:40:00',2.9),('9650','2014-03-20','16:45:00',2.78),('9650','2014-03-20','16:50:00',2.62),('9650','2014-03-20','16:55:00',2.46),('9650','2014-03-20','17:00:00',2.17),('9650','2014-03-20','17:05:00',2.09),('9650','2014-03-20','17:10:00',1.91),('9650','2014-03-20','17:15:00',1.68),('9650','2014-03-20','17:20:00',1.54),('9650','2014-03-20','17:25:00',1.37),('9650','2014-03-20','17:30:00',1.18),('9650','2013-01-30','09:10:00',1.1),('9650','2013-01-30','09:20:00',1.03),('9650','2013-01-30','09:25:00',1.07),('9650','2013-01-30','09:30:00',1.03),('9650','2013-01-30','10:15:00',1.03),('9650','2013-01-30','10:20:00',1.1),('9650','2013-01-30','10:25:00',1.32),('9650','2013-01-30','10:30:00',1.59),('9650','2013-01-30','10:35:00',1.84),('9650','2013-01-30','10:40:00',2.07),('9650','2013-01-30','10:45:00',2.42),('9650','2013-01-30','10:50:00',2.58),('9650','2013-01-30','10:55:00',2.61),('9650','2013-01-30','11:00:00',2.34),('9650','2013-01-30','11:05:00',1.59),('9650','2013-01-30','11:10:00',2.56),('9650','2013-01-30','11:15:00',3.07),('9650','2013-01-30','11:20:00',3.3),('9650','2013-01-30','11:25:00',3.18),('9650','2013-01-30','11:30:00',2.84),('9650','2013-01-30','11:35:00',2.8),('9650','2013-01-30','11:40:00',2.72),('9650','2013-01-30','11:45:00',2.75),('9650','2013-01-30','11:50:00',2.86),('9650','2013-01-30','11:55:00',2.93),('9650','2013-01-30','12:00:00',2.98),('9650','2013-01-30','12:05:00',3.16),('9650','2013-01-30','12:10:00',3.14),('9650','2013-01-30','12:15:00',3.19),('9650','2013-01-30','12:20:00',3.31),('9650','2013-01-30','12:25:00',3.23),('9650','2013-01-30','12:30:00',3.27),('9650','2013-01-30','12:35:00',3.35),('9650','2013-01-30','12:40:00',3.36),('9650','2013-01-30','12:45:00',3.37),('9650','2013-01-30','12:50:00',3.43),('9650','2013-01-30','12:55:00',3.46),('9650','2013-01-30','13:00:00',3.49),('9650','2013-01-30','13:05:00',3.52),('9650','2013-01-30','13:10:00',3.48),('9650','2013-01-30','13:15:00',3.35),('9650','2013-01-30','13:20:00',3.49),('9650','2013-01-30','13:25:00',3.47),('9650','2013-01-30','13:30:00',3.48),('9650','2013-01-30','13:35:00',3.4),('9650','2013-01-30','13:40:00',3.32),('9650','2013-01-30','13:45:00',3.34),('9650','2013-01-30','13:50:00',3.45),('9650','2013-01-30','13:55:00',3.26),('9650','2013-01-30','14:00:00',3.13),('9650','2013-01-30','14:05:00',3.04),('9650','2013-01-30','14:10:00',2.99),('9650','2013-01-30','14:15:00',3.02),('9650','2013-01-30','14:20:00',2.99),('9650','2013-01-30','14:25:00',2.98),('9650','2013-01-30','14:30:00',2.82),('9650','2013-01-30','14:35:00',2.73),('9650','2013-01-30','14:40:00',2.72),('9650','2013-01-30','14:45:00',2.67),('9650','2013-01-30','14:50:00',2.6),('9650','2013-01-30','14:55:00',2.42),('9650','2013-01-30','15:00:00',2.31),('9650','2013-01-30','15:05:00',2.21),('9650','2013-01-30','15:10:00',2.13),('9650','2013-01-30','15:15:00',2.11),('9650','2013-01-30','15:20:00',2.08),('9650','2013-01-30','15:25:00',1.93),('9650','2013-01-30','15:30:00',1.9),('9650','2013-01-30','15:35:00',1.93),('9650','2013-01-30','15:40:00',1.82),('9650','2013-01-30','15:45:00',1.68),('9650','2013-01-30','15:50:00',1.59),('9650','2013-01-30','15:55:00',1.51),('9650','2013-01-30','16:00:00',1.3),('9650','2013-01-30','16:05:00',1.1),('9650','2013-01-30','16:10:00',1.28),('9650','2013-01-30','16:15:00',1.08),('9650','2013-01-29','09:25:00',1.08),('9650','2013-01-29','09:30:00',1.22),('9650','2013-01-29','09:35:00',1.25),('9650','2013-01-29','09:40:00',1.17),('9650','2013-01-29','10:00:00',1.68),('9650','2013-01-29','10:05:00',1.91),('9650','2013-01-29','10:10:00',1.94),('9650','2013-01-29','10:15:00',1.65),('9650','2013-01-29','10:20:00',1.94),('9650','2013-01-29','10:25:00',2.12),('9650','2013-01-29','10:30:00',2.06),('9650','2013-01-29','10:35:00',1.77),('9650','2013-01-29','10:40:00',1.54),('9650','2013-01-29','10:45:00',1.57),('9650','2013-01-29','10:50:00',1.85),('9650','2013-01-29','10:55:00',1.81),('9650','2013-01-29','11:00:00',2.02),('9650','2013-01-29','11:05:00',2.04),('9650','2013-01-29','11:10:00',2.14),('9650','2013-01-29','11:15:00',2.23),('9650','2013-01-29','11:20:00',2.34),('9650','2013-01-29','11:25:00',2.48),('9650','2013-01-29','11:30:00',2.51),('9650','2013-01-29','11:35:00',2.58),('9650','2013-01-29','11:40:00',2.32),('9650','2013-01-29','11:45:00',2.8),('9650','2013-01-29','11:50:00',2.68),('9650','2013-01-29','11:55:00',2.9),('9650','2013-01-29','12:00:00',3.19),('9650','2013-01-29','12:05:00',2.54),('9650','2013-01-29','12:10:00',1.83),('9650','2013-01-29','12:15:00',2.58),('9650','2013-01-29','12:20:00',2.12),('9650','2013-01-29','12:25:00',1.45),('9650','2013-01-29','12:30:00',1.43),('9650','2013-01-29','12:35:00',1.89),('9650','2013-01-29','12:40:00',1.81),('9650','2013-01-29','12:45:00',2.23),('9650','2013-01-29','12:50:00',4.33),('9650','2013-01-29','12:55:00',4.36),('9650','2013-01-29','13:00:00',4.36),('9650','2013-01-29','13:05:00',4.37),('9650','2013-01-29','13:10:00',3.99),('9650','2013-01-29','13:15:00',4.08),('9650','2013-01-29','13:20:00',3.96),('9650','2013-01-29','13:25:00',4.06),('9650','2013-01-29','13:30:00',4.09),('9650','2013-01-29','13:35:00',2.88),('9650','2013-01-29','13:40:00',3.21),('9650','2013-01-29','13:45:00',3.05),('9650','2013-01-29','13:50:00',4.02),('9650','2013-01-29','13:55:00',3.89),('9650','2013-01-29','14:00:00',4.01),('9650','2013-01-29','14:05:00',3.99),('9650','2013-01-29','14:10:00',2.61),('9650','2013-01-29','14:15:00',2.23),('9650','2013-01-29','14:20:00',2.71),('9650','2013-01-29','14:25:00',3.54),('9650','2013-01-29','14:30:00',3.34),('9650','2013-01-29','14:35:00',3.26),('9650','2013-01-29','14:40:00',3.47),('9650','2013-01-29','14:45:00',2.61),('9650','2013-01-29','14:50:00',1.59),('9650','2013-01-29','14:55:00',1.63),('9650','2013-01-29','15:00:00',1.87),('9650','2013-01-29','15:05:00',1.87),('9650','2013-01-29','15:10:00',1.52),('9650','2013-01-29','15:15:00',1.27),('9650','2013-01-29','15:20:00',1.11),('9650','2013-01-29','15:25:00',1.01),('9650','2013-01-29','15:30:00',1.01),('9650','2013-01-28','10:20:00',1.02),('9650','2013-01-28','10:25:00',1.14),('9650','2013-01-28','10:30:00',1.21),('9650','2013-01-28','10:35:00',1.35),('9650','2013-01-28','10:40:00',1.48),('9650','2013-01-28','10:45:00',1.58),('9650','2013-01-28','10:50:00',1.71),('9650','2013-01-28','10:55:00',1.87),('9650','2013-01-28','11:00:00',1.97),('9650','2013-01-28','11:05:00',2.07),('9650','2013-01-28','11:10:00',2.15),('9650','2013-01-28','11:15:00',2.27),('9650','2013-01-28','11:20:00',2.37),('9650','2013-01-28','11:25:00',2.41),('9650','2013-01-28','11:30:00',2.45),('9650','2013-01-28','11:35:00',2.62),('9650','2013-01-28','11:40:00',2.69),('9650','2013-01-28','11:45:00',2.76),('9650','2013-01-28','11:50:00',2.83),('9650','2013-01-28','11:55:00',2.89),('9650','2013-01-28','12:00:00',2.92),('9650','2013-01-28','12:05:00',2.97),('9650','2013-01-28','12:10:00',3.1),('9650','2013-01-28','12:15:00',3.11),('9650','2013-01-28','12:20:00',3.17),('9650','2013-01-28','12:25:00',3.24),('9650','2013-01-28','12:30:00',3.29),('9650','2013-01-28','12:35:00',3.27),('9650','2013-01-28','12:40:00',3.35),('9650','2013-01-28','12:45:00',3.31),('9650','2013-01-28','12:50:00',3.31),('9650','2013-01-28','12:55:00',3.45),('9650','2013-01-28','13:00:00',3.47),('9650','2013-01-28','13:05:00',3.48),('9650','2013-01-28','13:10:00',3.46),('9650','2013-01-28','13:15:00',3.49),('9650','2013-01-28','13:20:00',3.44),('9650','2013-01-28','13:25:00',3.51),('9650','2013-01-28','13:30:00',3.53),('9650','2013-01-28','13:35:00',3.48),('9650','2013-01-28','13:40:00',3.33),('9650','2013-01-28','13:45:00',3.31),('9650','2013-01-28','13:50:00',3.25),('9650','2013-01-28','13:55:00',3.17),('9650','2013-01-28','14:00:00',3.09),('9650','2013-01-28','14:05:00',3.04),('9650','2013-01-28','14:10:00',3),('9650','2013-01-28','14:15:00',2.88),('9650','2013-01-28','14:20:00',2.58),('9650','2013-01-28','14:25:00',3),('9650','2013-01-28','14:30:00',2.88),('9650','2013-01-28','14:35:00',2.76),('9650','2013-01-28','14:40:00',2.76),('9650','2013-01-28','14:45:00',2.69),('9650','2013-01-28','14:50:00',2.6),('9650','2013-01-28','14:55:00',2.49),('9650','2013-01-28','15:00:00',2.34),('9650','2013-01-28','15:05:00',2.17),('9650','2013-01-28','15:10:00',2.1),('9650','2013-01-28','15:15:00',2.03),('9650','2013-01-28','15:20:00',1.93),('9650','2013-01-28','15:25:00',1.89),('9650','2013-01-28','15:30:00',1.83),('9650','2013-01-28','15:35:00',1.76),('9650','2013-01-28','15:40:00',1.7),('9650','2013-01-28','15:45:00',1.58),('9650','2013-01-28','15:50:00',1.5),('9650','2013-01-28','15:55:00',1.43),('9650','2013-01-28','16:00:00',1.42),('9650','2013-01-28','16:05:00',1.37),('9650','2013-01-28','16:10:00',1.27),('9650','2013-01-28','16:15:00',1.08),('9650','2013-01-27','10:55:00',1.15),('9650','2013-01-27','11:00:00',1.34),('9650','2013-01-27','11:05:00',1.52),('9650','2013-01-27','11:10:00',1.58),('9650','2013-01-27','11:15:00',1.32),('9650','2013-01-27','11:20:00',1.33),('9650','2013-01-27','11:25:00',1.26),('9650','2013-01-27','11:30:00',1.12),('9650','2013-01-27','11:35:00',1.01),('9650','2013-01-27','11:45:00',1.01),('9650','2013-01-27','12:30:00',1.05),('9650','2013-01-27','12:35:00',1.22),('9650','2013-01-27','12:40:00',1.54),('9650','2013-01-27','12:45:00',1.9),('9650','2013-01-27','12:50:00',2.17),('9650','2013-01-27','12:55:00',2.07),('9650','2013-01-27','13:00:00',1.91),('9650','2013-01-27','13:05:00',1.9),('9650','2013-01-27','13:10:00',1.76),('9650','2013-01-27','13:15:00',1.69),('9650','2013-01-27','13:20:00',1.67),('9650','2013-01-27','13:25:00',1.67),('9650','2013-01-27','13:30:00',1.62),('9650','2013-01-27','13:35:00',1.5),('9650','2013-01-27','13:40:00',1.38),('9650','2013-01-27','13:45:00',1.29),('9650','2013-01-27','13:50:00',1.18),('9650','2013-01-27','13:55:00',1.17),('9650','2013-01-27','14:00:00',1.24),('9650','2013-01-27','14:05:00',1.27),('9650','2013-01-27','14:10:00',1.23),('9650','2013-01-27','14:15:00',1.13),('9650','2013-01-27','14:20:00',1.03),('9650','2013-01-26','10:20:00',1.01),('9650','2013-01-26','10:25:00',1.1),('9650','2013-01-26','10:30:00',1.2),('9650','2013-01-26','10:35:00',1.29),('9650','2013-01-26','10:40:00',1.38),('9650','2013-01-26','10:45:00',1.51),('9650','2013-01-26','10:50:00',1.65),('9650','2013-01-26','10:55:00',1.8),('9650','2013-01-26','11:00:00',1.91),('9650','2013-01-26','11:05:00',1.98),('9650','2013-01-26','11:10:00',2.08),('9650','2013-01-26','11:15:00',2.17),('9650','2013-01-26','11:20:00',2.26),('9650','2013-01-26','11:25:00',2.36),('9650','2013-01-26','11:30:00',2.44),('9650','2013-01-26','11:35:00',2.5),('9650','2013-01-26','11:40:00',2.59),('9650','2013-01-26','11:45:00',2.66),('9650','2013-01-26','11:50:00',2.74),('9650','2013-01-26','11:55:00',2.81),('9650','2013-01-26','12:00:00',2.87),('9650','2013-01-26','12:05:00',2.94),('9650','2013-01-26','12:10:00',3),('9650','2013-01-26','12:15:00',3.05),('9650','2013-01-26','12:20:00',3.1),('9650','2013-01-26','12:25:00',3.15),('9650','2013-01-26','12:30:00',3.18),('9650','2013-01-26','12:35:00',3.21),('9650','2013-01-26','12:40:00',3.22),('9650','2013-01-26','12:45:00',3.31),('9650','2013-01-26','12:50:00',3.36),('9650','2013-01-26','12:55:00',3.42),('9650','2013-01-26','13:00:00',3.42),('9650','2013-01-26','13:05:00',3.47),('9650','2013-01-26','13:10:00',3.51),('9650','2013-01-26','13:15:00',3.5),('9650','2013-01-26','13:20:00',3.48),('9650','2013-01-26','13:25:00',3.42),('9650','2013-01-26','13:30:00',3.39),('9650','2013-01-26','13:35:00',3.33),('9650','2013-01-26','13:40:00',3.25),('9650','2013-01-26','13:45:00',3.25),('9650','2013-01-26','13:50:00',3.11),('9650','2013-01-26','13:55:00',3.01),('9650','2013-01-26','14:00:00',2.96),('9650','2013-01-26','14:05:00',2.94),('9650','2013-01-26','14:10:00',2.93),('9650','2013-01-26','14:15:00',2.91),('9650','2013-01-26','14:20:00',2.84),('9650','2013-01-26','14:25:00',2.77),('9650','2013-01-26','14:30:00',2.68),('9650','2013-01-26','14:35:00',2.55),('9650','2013-01-26','14:40:00',2.53),('9650','2013-01-26','14:45:00',2.54),('9650','2013-01-26','14:50:00',2.47),('9650','2013-01-26','14:55:00',2.41),('9650','2013-01-26','15:00:00',2.32),('9650','2013-01-26','15:05:00',2.09),('9650','2013-01-26','15:10:00',1.9),('9650','2013-01-26','15:15:00',1.9),('9650','2013-01-26','15:20:00',1.81),('9650','2013-01-26','15:25:00',1.76),('9650','2013-01-26','15:30:00',1.67),('9650','2013-01-26','15:35:00',1.59),('9650','2013-01-26','15:40:00',1.5),('9650','2013-01-26','15:45:00',1.43),('9650','2013-01-26','15:50:00',1.32),('9650','2013-01-26','15:55:00',1.32),('9650','2013-01-26','16:00:00',1.29),('9650','2013-01-26','16:05:00',1.24),('9650','2013-01-26','16:10:00',1.03),('9650','2013-01-25','09:00:00',1.01),('9650','2013-01-25','09:05:00',1.08),('9650','2013-01-25','09:10:00',1.15),('9650','2013-01-25','09:15:00',1.15),('9650','2013-01-25','09:20:00',1.23),('9650','2013-01-25','09:25:00',1.24),('9650','2013-01-25','09:30:00',1.2),('9650','2013-01-25','09:35:00',1.22),('9650','2013-01-25','09:45:00',1.11),('9650','2013-01-25','09:50:00',1.53),('9650','2013-01-25','09:55:00',1.45),('9650','2013-01-25','10:00:00',1.28),('9650','2013-01-25','10:05:00',1.24),('9650','2013-01-25','10:10:00',1.29),('9650','2013-01-25','10:15:00',1.61),('9650','2013-01-25','10:20:00',1.67),('9650','2013-01-25','10:25:00',1.73),('9650','2013-01-25','10:30:00',1.22),('9650','2013-01-25','10:35:00',1.33),('9650','2013-01-25','10:40:00',1.52),('9650','2013-01-25','10:45:00',1.61),('9650','2013-01-25','10:50:00',1.81),('9650','2013-01-25','10:55:00',1.56),('9650','2013-01-25','11:00:00',1.41),('9650','2013-01-25','11:05:00',1.79),('9650','2013-01-25','11:10:00',1.58),('9650','2013-01-25','11:15:00',1.58),('9650','2013-01-25','11:20:00',1.54),('9650','2013-01-25','11:25:00',1.77),('9650','2013-01-25','11:30:00',1.75),('9650','2013-01-25','11:35:00',1.58),('9650','2013-01-25','11:40:00',1.64),('9650','2013-01-25','11:45:00',1.54),('9650','2013-01-25','11:50:00',1.63),('9650','2013-01-25','11:55:00',1.49),('9650','2013-01-25','12:00:00',1.29),('9650','2013-01-25','12:05:00',1.31),('9650','2013-01-25','12:10:00',1.33),('9650','2013-01-25','12:15:00',1.38),('9650','2013-01-25','12:20:00',1.42),('9650','2013-01-25','12:25:00',1.65),('9650','2013-01-25','12:30:00',1.5),('9650','2013-01-25','12:35:00',1.5),('9650','2013-01-25','12:40:00',1.42),('9650','2013-01-25','12:45:00',1.46),('9650','2013-01-25','12:50:00',1.45),('9650','2013-01-25','12:55:00',1.04),('9650','2013-01-25','13:05:00',1.2),('9650','2013-01-25','13:10:00',1.04),('9650','2013-01-25','13:35:00',1.19),('9650','2013-01-25','13:40:00',1.25),('9650','2013-01-25','13:45:00',1.17),('9650','2013-01-25','13:50:00',1.06),('9650','2013-01-25','13:55:00',1.01),('9650','2013-01-25','14:25:00',1.06),('9650','2013-01-25','14:30:00',1.02),('9650','2013-01-24','10:25:00',1.04),('9650','2013-01-24','10:30:00',1.02),('9650','2013-01-24','10:40:00',1.34),('9650','2013-01-24','10:45:00',1.43),('9650','2013-01-24','10:50:00',1.27),('9650','2013-01-24','10:55:00',1.81),('9650','2013-01-24','11:00:00',1),('9650','2013-01-24','11:05:00',1.08),('9650','2013-01-24','11:10:00',1.94),('9650','2013-01-24','11:15:00',2.17),('9650','2013-01-24','11:20:00',2.25),('9650','2013-01-24','11:25:00',2.33),('9650','2013-01-24','11:30:00',2.44),('9650','2013-01-24','11:35:00',2.56),('9650','2013-01-24','11:40:00',2.62),('9650','2013-01-24','11:45:00',2.68),('9650','2013-01-24','11:50:00',2.77),('9650','2013-01-24','11:55:00',2.82),('9650','2013-01-24','12:00:00',2.85),('9650','2013-01-24','12:05:00',2.88),('9650','2013-01-24','12:10:00',2.98),('9650','2013-01-24','12:15:00',3.04),('9650','2013-01-24','12:20:00',3.1),('9650','2013-01-24','12:25:00',3.12),('9650','2013-01-24','12:30:00',3.04),('9650','2013-01-24','12:35:00',2.72),('9650','2013-01-24','12:40:00',2.98),('9650','2013-01-24','12:45:00',3.24),('9650','2013-01-24','12:50:00',3.2),('9650','2013-01-24','12:55:00',3.27),('9650','2013-01-24','13:00:00',3.3),('9650','2013-01-24','13:05:00',3.27),('9650','2013-01-24','13:10:00',3.28),('9650','2013-01-24','13:15:00',3.35),('9650','2013-01-24','13:20:00',3.4),('9650','2013-01-24','13:25:00',3.48),('9650','2013-01-24','13:30:00',3.6),('9650','2013-01-24','13:35:00',3.58),('9650','2013-01-24','13:40:00',3.44),('9650','2013-01-24','13:55:00',3.04),('9650','2013-01-24','14:00:00',2.99),('9650','2013-01-24','14:05:00',2.86),('9650','2013-01-24','14:10:00',2.76),('9650','2013-01-24','14:15:00',2.6),('9650','2013-01-24','14:20:00',2.52),('9650','2013-01-24','14:25:00',2.56),('9650','2013-01-24','14:30:00',2.46),('9650','2013-01-24','14:35:00',2.32),('9650','2013-01-24','14:40:00',2.33),('9650','2013-01-24','14:45:00',2.24),('9650','2013-01-24','14:50:00',2.22),('9650','2013-01-24','14:55:00',2.18),('9650','2013-01-24','15:00:00',1.94),('9650','2013-01-24','15:05:00',1.76),('9650','2013-01-24','15:10:00',1.66),('9650','2013-01-24','15:15:00',1.64),('9650','2013-01-24','15:20:00',1.64),('9650','2013-01-24','15:25:00',1.62),('9650','2013-01-24','15:30:00',1.63),('9650','2013-01-24','15:35:00',1.67),('9650','2013-01-24','15:40:00',1.65),('9650','2013-01-24','15:45:00',1.69),('9650','2013-01-24','15:50:00',1.68),('9650','2013-01-24','15:55:00',1.53),('9650','2013-01-24','16:00:00',1.11),('9650','2013-01-23','09:15:00',1.01),('9650','2013-01-23','09:20:00',1.13),('9650','2013-01-23','09:25:00',1.13),('9650','2013-01-23','09:30:00',1.07),('9650','2013-01-23','10:25:00',1),('9650','2013-01-23','10:30:00',1.03),('9650','2013-01-23','10:35:00',1.11),('9650','2013-01-23','10:40:00',1.24),('9650','2013-01-23','10:45:00',1.3),('9650','2013-01-23','10:50:00',1.4),('9650','2013-01-23','10:55:00',1.45),('9650','2013-01-23','11:00:00',1),('9650','2013-01-23','12:35:00',1.21),('9650','2013-01-23','12:40:00',1.38),('9650','2013-01-23','12:45:00',1.69),('9650','2013-01-23','12:50:00',1.74),('9650','2013-01-23','12:55:00',1.7),('9650','2013-01-23','13:00:00',1.63),('9650','2013-01-23','13:05:00',1.59),('9650','2013-01-23','13:10:00',1.54),('9650','2013-01-23','13:15:00',1.49),('9650','2013-01-23','13:20:00',1.45),('9650','2013-01-23','13:25:00',1.47),('9650','2013-01-23','13:30:00',1.49),('9650','2013-01-23','13:35:00',1.46),('9650','2013-01-23','13:40:00',1.47),('9650','2013-01-23','13:45:00',1.49),('9650','2013-01-23','13:50:00',1.56),('9650','2013-01-23','13:55:00',1.69),('9650','2013-01-23','14:00:00',2.02),('9650','2013-01-23','14:05:00',1.96),('9650','2013-01-23','14:10:00',1.91),('9650','2013-01-23','14:15:00',2.11),('9650','2013-01-23','14:20:00',3.07),('9650','2013-01-23','14:25:00',4.38),('9650','2013-01-23','14:30:00',3.71),('9650','2013-01-23','14:35:00',2.71),('9650','2013-01-23','14:40:00',2.18),('9650','2013-01-23','14:45:00',2.61),('9650','2013-01-23','14:50:00',2.67),('9650','2013-01-23','14:55:00',2.64),('9650','2013-01-23','15:00:00',1.89),('9650','2013-01-23','15:05:00',1.46),('9650','2013-01-23','15:10:00',1.1),('9650','2013-01-23','15:15:00',1.15),('9650','2013-01-23','15:20:00',1.58),('9650','2013-01-23','15:25:00',1.57),('9650','2013-01-23','15:30:00',1.62),('9650','2013-01-23','15:35:00',1.42),('9650','2013-01-23','15:45:00',1.2),('9650','2013-01-23','15:50:00',1.19),('9650','2013-01-23','15:55:00',1.09),('9650','2013-01-23','16:00:00',1.03),('9650','2013-01-22','09:50:00',1.21),('9650','2013-01-22','09:55:00',1.51),('9650','2013-01-22','10:00:00',1.39),('9650','2013-01-22','10:05:00',1.21),('9650','2013-01-22','10:10:00',1.07),('9650','2013-01-22','10:15:00',1.32),('9650','2013-01-22','10:20:00',1.3),('9650','2013-01-22','10:25:00',1.65),('9650','2013-01-22','10:30:00',2.44),('9650','2013-01-22','10:35:00',2.58),('9650','2013-01-22','10:40:00',2.22),('9650','2013-01-22','10:45:00',2.1),('9650','2013-01-22','10:50:00',2.62),('9650','2013-01-22','10:55:00',1.98),('9650','2013-01-22','11:00:00',1.24),('9650','2013-01-21','08:55:00',1.05),('9650','2013-01-21','09:00:00',1.74),('9650','2013-01-21','09:40:00',1.23),('9650','2013-01-21','09:45:00',1.7),('9650','2013-01-21','10:10:00',1.28),('9650','2013-01-21','10:15:00',1.12),('9650','2013-01-21','10:20:00',1.27),('9650','2013-01-21','10:25:00',1.3),('9650','2013-01-21','10:30:00',1.37),('9650','2013-01-21','10:35:00',1.78),('9650','2013-01-21','10:40:00',2.53),('9650','2013-01-21','10:45:00',2.58),('9650','2013-01-21','10:50:00',2.14),('9650','2013-01-21','10:55:00',1.66),('9650','2013-01-21','11:00:00',1.16),('9650','2013-01-21','11:05:00',1.33),('9650','2013-01-21','11:10:00',1.49),('9650','2013-01-21','11:15:00',1.69),('9650','2013-01-21','11:20:00',1.69),('9650','2013-01-21','11:25:00',1.46),('9650','2013-01-21','11:30:00',1.34),('9650','2013-01-21','11:35:00',1.23),('9650','2013-01-21','11:45:00',1.96),('9650','2013-01-21','11:50:00',2.31),('9650','2013-01-21','11:55:00',1.39),('9650','2013-01-21','12:00:00',1.3),('9650','2013-01-21','12:05:00',1.26),('9650','2013-01-21','12:10:00',3.13),('9650','2013-01-21','12:15:00',2.82),('9650','2013-01-21','12:20:00',2.38),('9650','2013-01-21','12:25:00',2.88),('9650','2013-01-21','12:30:00',1.59),('9650','2013-01-21','12:35:00',1.55),('9650','2013-01-21','12:40:00',3.58),('9650','2013-01-21','12:45:00',1.56),('9650','2013-01-21','12:50:00',1.9),('9650','2013-01-21','12:55:00',1.59),('9650','2013-01-21','13:00:00',3.6),('9650','2013-01-21','13:05:00',4.2),('9650','2013-01-21','13:10:00',2.98),('9650','2013-01-21','13:15:00',1.86),('9650','2013-01-21','13:20:00',2.96),('9650','2013-01-21','13:25:00',1.29),('9650','2013-01-21','13:30:00',1.15),('9650','2013-01-21','13:40:00',1.66),('9650','2013-01-21','13:45:00',1.91),('9650','2013-01-21','13:50:00',1.8),('9650','2013-01-21','13:55:00',1.02),('9650','2013-01-21','14:00:00',1.31),('9650','2013-01-21','14:05:00',1.27),('9650','2013-01-21','14:10:00',2.04),('9650','2013-01-21','14:15:00',1.87),('9650','2013-01-21','14:20:00',1.56),('9650','2013-01-21','14:25:00',2.44),('9650','2013-01-21','14:35:00',2.05),('9650','2013-01-21','14:40:00',1.8),('9650','2013-01-21','14:45:00',2.41),('9650','2013-01-21','14:50:00',1.66),('9650','2013-01-21','15:00:00',1.05),('9650','2013-01-21','15:05:00',1.05),('9650','2014-03-19','08:25:00',1.03),('9650','2014-03-19','08:30:00',1.1),('9650','2014-03-19','08:35:00',1.17),('9650','2014-03-19','08:40:00',1.24),('9650','2014-03-19','08:45:00',1.29),('9650','2014-03-19','08:50:00',1.49),('9650','2014-03-19','08:55:00',1.61),('9650','2014-03-19','09:00:00',1.72),('9650','2014-03-19','09:05:00',1.85),('9650','2014-03-19','09:10:00',1.99),('9650','2014-03-19','09:15:00',2.09),('9650','2014-03-19','09:20:00',2.22),('9650','2014-03-19','09:25:00',2.31),('9650','2014-03-19','09:30:00',2.42),('9650','2014-03-19','09:35:00',2.55),('9650','2014-03-19','09:40:00',2.63),('9650','2014-03-19','09:45:00',2.72),('9650','2014-03-19','09:50:00',2.78),('9650','2014-03-19','09:55:00',2.91),('9650','2014-03-19','10:00:00',3.11),('9650','2014-03-19','10:05:00',3.27),('9650','2014-03-19','10:10:00',3.38),('9650','2014-03-19','10:15:00',3.41),('9650','2014-03-19','10:20:00',3.51),('9650','2014-03-19','10:25:00',3.62),('9650','2014-03-19','10:30:00',3.7),('9650','2014-03-19','10:35:00',3.67),('9650','2014-03-19','10:40:00',3.63),('9650','2014-03-19','10:45:00',3.75),('9650','2014-03-19','10:50:00',4.04),('9650','2014-03-19','10:55:00',4.36),('9650','2014-03-19','11:00:00',4.49),('9650','2014-03-19','11:05:00',4.49),('9650','2014-03-19','11:10:00',4.53),('9650','2014-03-19','11:15:00',4.35),('9650','2014-03-19','11:20:00',4.62),('9650','2014-03-19','11:25:00',4.71),('9650','2014-03-19','11:30:00',4.88),('9650','2014-03-19','11:35:00',5.08),('9650','2014-03-19','11:40:00',5.01),('9650','2014-03-19','11:45:00',5.07),('9650','2014-03-19','11:50:00',5.18),('9650','2014-03-19','11:55:00',4.83),('9650','2014-03-19','12:00:00',4.58),('9650','2014-03-19','12:05:00',5.03),('9650','2014-03-19','12:10:00',5.29),('9650','2014-03-19','12:15:00',5.4),('9650','2014-03-19','12:20:00',5.25),('9650','2014-03-19','12:25:00',5.03),('9650','2014-03-19','12:30:00',5.28),('9650','2014-03-19','12:35:00',5.42),('9650','2014-03-19','12:40:00',5.43),('9650','2014-03-19','12:45:00',5.63),('9650','2014-03-19','12:50:00',5.64),('9650','2014-03-19','12:55:00',5.63),('9650','2014-03-19','13:00:00',5.59),('9650','2014-03-19','13:05:00',5.55),('9650','2014-03-19','13:10:00',5.47),('9650','2014-03-19','13:15:00',5.39),('9650','2014-03-19','13:20:00',5.48),('9650','2014-03-19','13:25:00',5.37),('9650','2014-03-19','13:30:00',5.47),('9650','2014-03-19','13:35:00',5.33),('9650','2014-03-19','13:40:00',5.11),('9650','2014-03-19','13:45:00',4.84),('9650','2014-03-19','13:50:00',4.76),('9650','2014-03-19','13:55:00',4.43),('9650','2014-03-19','14:00:00',4.57),('9650','2014-03-19','14:05:00',4.99),('9650','2014-03-19','14:10:00',4.92),('9650','2014-03-19','14:15:00',4.59),('9650','2014-03-19','14:20:00',4.55),('9650','2014-03-19','14:25:00',4.62),('9650','2014-03-19','14:30:00',3.89),('9650','2014-03-19','14:35:00',3.58),('9650','2014-03-19','14:40:00',4.18),('9650','2014-03-19','14:45:00',4.05),('9650','2014-03-19','14:50:00',3.8),('9650','2014-03-19','14:55:00',3.71),('9650','2014-03-19','15:00:00',3.38),('9650','2014-03-19','15:05:00',3.38),('9650','2014-03-19','15:10:00',3.51),('9650','2014-03-19','15:15:00',3.38),('9650','2014-03-19','15:20:00',3.65),('9650','2014-03-19','15:25:00',3.31),('9650','2014-03-19','15:30:00',3.17),('9650','2014-03-19','15:35:00',3.08),('9650','2014-03-19','15:40:00',2.85),('9650','2014-03-19','15:45:00',2.96),('9650','2014-03-19','15:50:00',2.64),('9650','2014-03-19','15:55:00',2.44),('9650','2014-03-19','16:00:00',2.14),('9650','2014-03-19','16:05:00',1.96),('9650','2014-03-19','16:10:00',2),('9650','2014-03-19','16:15:00',1.95),('9650','2014-03-19','16:20:00',2.07),('9650','2014-03-19','16:25:00',2.17),('9650','2014-03-19','16:30:00',2.07),('9650','2014-03-19','16:35:00',1.94),('9650','2014-03-19','16:40:00',1.81),('9650','2014-03-19','16:45:00',1.28),('9650','2014-03-19','16:50:00',1.05),('9650','2013-01-20','10:10:00',1.14),('9650','2013-01-20','10:15:00',1.2),('9650','2013-01-20','10:20:00',1.06),('9650','2013-01-20','10:25:00',1.14),('9650','2013-01-20','10:30:00',1.11),('9650','2013-01-20','10:45:00',1.06),('9650','2013-01-20','10:50:00',1.06),('9650','2013-01-20','10:55:00',1.22),('9650','2013-01-20','11:00:00',1.5),('9650','2013-01-20','11:05:00',1.4),('9650','2013-01-20','11:10:00',1.77),('9650','2013-01-20','11:15:00',1.85),('9650','2013-01-20','11:20:00',1.69),('9650','2013-01-20','11:25:00',1.59),('9650','2013-01-20','11:30:00',1.3),('9650','2013-01-20','11:40:00',1.26),('9650','2013-01-20','11:45:00',1.41),('9650','2013-01-20','11:50:00',2.2),('9650','2013-01-20','11:55:00',3.16),('9650','2013-01-20','12:00:00',2.63),('9650','2013-01-20','12:05:00',2.71),('9650','2013-01-20','12:10:00',3.08),('9650','2013-01-20','12:15:00',2.24),('9650','2013-01-20','12:20:00',1.33),('9650','2013-01-20','12:25:00',2.25),('9650','2013-01-20','12:30:00',1.1),('9650','2013-01-20','12:35:00',1.44),('9650','2013-01-20','12:40:00',1.65),('9650','2013-01-20','12:45:00',1.29),('9650','2013-01-20','12:50:00',1.86),('9650','2013-01-20','12:55:00',1.22),('9650','2013-01-20','13:00:00',1.54),('9650','2013-01-20','13:05:00',2.86),('9650','2013-01-20','13:10:00',2.32),('9650','2013-01-20','13:15:00',1.53),('9650','2013-01-20','13:20:00',1.51),('9650','2013-01-20','13:25:00',1.53),('9650','2013-01-20','13:30:00',4.18),('9650','2013-01-20','13:35:00',4.08),('9650','2013-01-20','13:40:00',3.24),('9650','2013-01-20','13:45:00',1.33),('9650','2013-01-20','13:50:00',2.69),('9650','2013-01-20','13:55:00',3.76),('9650','2013-01-20','14:00:00',3.19),('9650','2013-01-20','14:05:00',3.59),('9650','2013-01-20','14:10:00',3.2),('9650','2013-01-20','14:15:00',2.28),('9650','2013-01-20','14:20:00',3.13),('9650','2013-01-20','14:25:00',3.12),('9650','2013-01-20','14:30:00',1.96),('9650','2013-01-20','14:35:00',1.16),('9650','2013-01-20','14:40:00',1.01),('9650','2013-01-19','10:40:00',1.12),('9650','2013-01-19','10:45:00',1.31),('9650','2013-01-19','10:50:00',1.5),('9650','2013-01-19','10:55:00',1.53),('9650','2013-01-19','11:00:00',1.68),('9650','2013-01-19','11:05:00',1.88),('9650','2013-01-19','11:10:00',1.97),('9650','2013-01-19','11:15:00',2.4),('9650','2013-01-19','11:20:00',2.04),('9650','2013-01-19','11:25:00',2.4),('9650','2013-01-19','11:30:00',2.93),('9650','2013-01-19','11:35:00',2.52),('9650','2013-01-19','11:40:00',1.73),('9650','2013-01-19','11:45:00',1.63),('9650','2013-01-19','11:50:00',1.26),('9650','2013-01-19','12:00:00',1.01),('9650','2013-01-19','12:10:00',1.17),('9650','2013-01-19','12:15:00',1.44),('9650','2013-01-19','12:20:00',1.57),('9650','2013-01-19','12:25:00',1.64),('9650','2013-01-19','12:30:00',1.49),('9650','2013-01-19','12:35:00',1.36),('9650','2013-01-19','12:40:00',1.28),('9650','2013-01-19','12:45:00',1.24),('9650','2013-01-19','12:50:00',1.23),('9650','2013-01-19','12:55:00',1.2),('9650','2013-01-19','13:00:00',1.14),('9650','2013-01-19','13:05:00',1.08),('9650','2013-01-19','13:10:00',1.11),('9650','2013-01-19','13:15:00',1.24),('9650','2013-01-19','13:20:00',1.27),('9650','2013-01-19','13:25:00',1.26),('9650','2013-01-19','13:30:00',1.19),('9650','2013-01-19','13:35:00',1.31),('9650','2013-01-19','13:40:00',1.53),('9650','2013-01-19','13:45:00',1.51),('9650','2013-01-19','13:50:00',1.45),('9650','2013-01-19','13:55:00',1.28),('9650','2013-01-19','14:00:00',1.13),('9650','2013-01-19','14:15:00',1.01),('9650','2013-01-19','14:20:00',1.2),('9650','2013-01-19','14:25:00',1.07),('9650','2013-01-18','09:10:00',1.07),('9650','2013-01-18','09:15:00',1.17),('9650','2013-01-18','09:20:00',1.17),('9650','2013-01-18','09:25:00',1.18),('9650','2013-01-18','09:30:00',1.17),('9650','2013-01-18','09:35:00',1.1),('9650','2013-01-18','09:40:00',1.03),('9650','2013-01-18','09:45:00',1.34),('9650','2013-01-18','09:50:00',1.52),('9650','2013-01-18','09:55:00',1.94),('9650','2013-01-18','10:00:00',2.05),('9650','2013-01-18','10:05:00',1.65),('9650','2013-01-18','10:10:00',1.19),('9650','2013-01-18','10:35:00',1.59),('9650','2013-01-18','10:40:00',1.69),('9650','2013-01-18','10:45:00',2.06),('9650','2013-01-18','10:50:00',1.98),('9650','2013-01-18','10:55:00',1.16),('9650','2013-01-18','11:10:00',1.49),('9650','2013-01-18','11:15:00',1.61),('9650','2013-01-18','11:20:00',1.95),('9650','2013-01-18','11:25:00',1.92),('9650','2013-01-18','11:30:00',1.56),('9650','2013-01-18','11:35:00',1.1),('9650','2013-01-18','11:45:00',1.13),('9650','2013-01-18','11:50:00',1.25),('9650','2013-01-18','11:55:00',1.19),('9650','2013-01-18','12:05:00',1.01),('9650','2013-01-18','12:10:00',1.15),('9650','2013-01-18','12:15:00',1.21),('9650','2013-01-18','12:20:00',1.11),('9650','2013-01-18','14:35:00',1.05),('9650','2013-01-17','08:45:00',1),('9650','2013-01-17','10:05:00',1.1),('9650','2013-01-17','10:10:00',1.4),('9650','2013-01-17','10:15:00',2.07),('9650','2013-01-17','10:20:00',2.07),('9650','2013-01-17','10:25:00',1.88),('9650','2013-01-17','10:30:00',1.82),('9650','2013-01-17','10:35:00',1.61),('9650','2013-01-17','10:40:00',1.37),('9650','2013-01-17','10:45:00',1.33),('9650','2013-01-17','10:50:00',1.38),('9650','2013-01-17','10:55:00',1.43),('9650','2013-01-17','11:00:00',1.5),('9650','2013-01-17','11:05:00',1.58),('9650','2013-01-17','11:10:00',1.52),('9650','2013-01-17','11:15:00',1.52),('9650','2013-01-17','11:20:00',1.36),('9650','2013-01-17','11:25:00',1.51),('9650','2013-01-17','11:30:00',1.86),('9650','2013-01-17','11:35:00',2.01),('9650','2013-01-17','11:40:00',1.88),('9650','2013-01-17','11:45:00',1.6),('9650','2013-01-17','11:50:00',1.39),('9650','2013-01-17','11:55:00',1.49),('9650','2013-01-17','12:00:00',1.6),('9650','2013-01-17','12:05:00',1.63),('9650','2013-01-17','12:10:00',1.83),('9650','2013-01-17','12:15:00',1.85),('9650','2013-01-17','12:20:00',1.84),('9650','2013-01-17','12:25:00',1.88),('9650','2013-01-17','12:30:00',1.88),('9650','2013-01-17','12:35:00',2.1),('9650','2013-01-17','12:40:00',2.22),('9650','2013-01-17','12:45:00',2.39),('9650','2013-01-17','12:50:00',2.99),('9650','2013-01-17','12:55:00',3.22),('9650','2013-01-17','13:00:00',3.75),('9650','2013-01-17','13:05:00',3.58),('9650','2013-01-17','13:10:00',3.3),('9650','2013-01-17','13:15:00',3.67),('9650','2013-01-17','13:20:00',3),('9650','2013-01-17','13:25:00',2.49),('9650','2013-01-17','13:30:00',2.29),('9650','2013-01-17','13:35:00',2.16),('9650','2013-01-17','13:40:00',2.32),('9650','2013-01-17','13:45:00',3.69),('9650','2013-01-17','13:50:00',4.14),('9650','2013-01-17','13:55:00',4.09),('9650','2013-01-17','14:00:00',3.76),('9650','2013-01-17','14:05:00',3.72),('9650','2013-01-17','14:10:00',2.69),('9650','2013-01-17','14:15:00',3.3),('9650','2013-01-17','14:20:00',2.51),('9650','2013-01-17','14:25:00',2.6),('9650','2013-01-17','14:30:00',1.93),('9650','2013-01-17','14:35:00',1.66),('9650','2013-01-17','14:40:00',1.53),('9650','2013-01-17','14:45:00',1.56),('9650','2013-01-17','14:50:00',1.61),('9650','2013-01-17','14:55:00',1.48),('9650','2013-01-17','15:00:00',1.32),('9650','2013-01-17','15:05:00',1.35),('9650','2013-01-17','15:10:00',1.29),('9650','2013-01-17','15:15:00',1.36),('9650','2013-01-17','15:20:00',1.21),('9650','2013-01-17','15:25:00',1.23),('9650','2013-01-17','15:30:00',1.13),('9650','2013-01-17','15:35:00',1),('9650','2013-01-17','15:50:00',1.05),('9650','2013-01-17','15:55:00',1.05),('9650','2013-01-16','09:10:00',1.15),('9650','2013-01-16','09:15:00',1.15),('9650','2013-01-16','09:20:00',1.07),('9650','2013-01-16','09:30:00',1.02),('9650','2013-01-16','09:35:00',1.09),('9650','2013-01-16','09:40:00',1.24),('9650','2013-01-16','09:45:00',1.32),('9650','2013-01-16','09:50:00',1.36),('9650','2013-01-16','09:55:00',1.37),('9650','2013-01-16','10:00:00',1.4),('9650','2013-01-16','10:05:00',1.51),('9650','2013-01-16','10:10:00',1.67),('9650','2013-01-16','10:15:00',1.77),('9650','2013-01-16','10:20:00',1.7),('9650','2013-01-16','10:25:00',1.82),('9650','2013-01-16','10:30:00',1.9),('9650','2013-01-16','10:35:00',1.9),('9650','2013-01-16','10:40:00',2),('9650','2013-01-16','10:45:00',2.03),('9650','2013-01-16','10:50:00',1.95),('9650','2013-01-16','10:55:00',2.11),('9650','2013-01-16','11:00:00',2.05),('9650','2013-01-16','11:05:00',2.02),('9650','2013-01-16','11:10:00',2.17),('9650','2013-01-16','11:15:00',2.11),('9650','2013-01-16','11:20:00',2.07),('9650','2013-01-16','11:25:00',1.81),('9650','2013-01-16','11:30:00',1.67),('9650','2013-01-16','11:35:00',1.79),('9650','2013-01-16','11:40:00',1.87),('9650','2013-01-16','11:45:00',1.75),('9650','2013-01-16','11:50:00',1.87),('9650','2013-01-16','11:55:00',2),('9650','2013-01-16','12:00:00',2.21),('9650','2013-01-16','12:05:00',2.24),('9650','2013-01-16','12:10:00',2.36),('9650','2013-01-16','12:15:00',2.53),('9650','2013-01-16','12:20:00',2.45),('9650','2013-01-16','12:25:00',2.25),('9650','2013-01-16','12:30:00',2.03),('9650','2013-01-16','12:35:00',2.36),('9650','2013-01-16','12:40:00',2.47),('9650','2013-01-16','12:45:00',2.12),('9650','2013-01-16','12:50:00',1.53),('9650','2013-01-16','12:55:00',1.57),('9650','2013-01-16','13:00:00',2.15),('9650','2013-01-16','13:05:00',2.11),('9650','2013-01-16','13:10:00',1.66),('9650','2013-01-16','13:15:00',2.09),('9650','2013-01-16','13:20:00',2.12),('9650','2013-01-16','13:25:00',1.81),('9650','2013-01-16','13:30:00',1.68),('9650','2013-01-16','13:35:00',2.28),('9650','2013-01-16','13:40:00',2.32),('9650','2013-01-16','13:45:00',2.18),('9650','2013-01-16','13:50:00',2.19),('9650','2013-01-16','13:55:00',1.44),('9650','2013-01-16','14:00:00',2.03),('9650','2013-01-16','14:05:00',1.6),('9650','2013-01-16','14:10:00',1.34),('9650','2013-01-16','14:20:00',1.22),('9650','2013-01-16','14:25:00',1.49),('9650','2013-01-16','14:30:00',1.92),('9650','2013-01-16','14:35:00',2.55),('9650','2013-01-16','14:40:00',1.09),('9650','2013-01-16','14:55:00',1.25),('9650','2013-01-16','15:00:00',1.25),('9650','2013-01-15','10:00:00',1.18),('9650','2013-01-15','10:35:00',1.49),('9650','2013-01-15','10:40:00',1.16),('9650','2013-01-15','10:45:00',1.2),('9650','2013-01-15','10:55:00',1.58),('9650','2013-01-15','11:00:00',1.24),('9650','2013-01-15','11:05:00',1.27),('9650','2013-01-15','11:25:00',1.88),('9650','2013-01-15','12:00:00',2.51),('9650','2013-01-15','12:05:00',2.13),('9650','2013-01-15','12:10:00',2.51),('9650','2013-01-15','12:15:00',3.83),('9650','2013-01-15','12:20:00',3.24),('9650','2013-01-15','12:25:00',1.27),('9650','2013-01-15','13:05:00',2.95),('9650','2013-01-15','13:10:00',4.77),('9650','2013-01-15','13:15:00',5.11),('9650','2013-01-15','13:20:00',3.44),('9650','2013-01-15','13:25:00',2.37),('9650','2013-01-15','13:30:00',1.04),('9650','2013-01-15','13:55:00',3.53),('9650','2013-01-15','14:00:00',2.44),('9650','2013-01-15','14:05:00',1.78),('9650','2013-01-15','15:05:00',1.42),('9650','2013-01-15','15:10:00',1.26),('9650','2013-01-14','09:55:00',1.2),('9650','2013-01-14','10:00:00',1.54),('9650','2013-01-14','10:05:00',1.2),('9650','2013-01-14','10:10:00',1.57),('9650','2013-01-14','10:15:00',1.25),('9650','2013-01-14','10:20:00',1.14),('9650','2013-01-14','10:25:00',1.26),('9650','2013-01-14','10:35:00',1.03),('9650','2013-01-14','10:40:00',1.24),('9650','2013-01-14','10:45:00',1.33),('9650','2013-01-14','10:50:00',1.7),('9650','2013-01-14','10:55:00',1.89),('9650','2013-01-14','11:00:00',1.95),('9650','2013-01-14','11:05:00',2.06),('9650','2013-01-14','11:10:00',2.12),('9650','2013-01-14','11:15:00',1.96),('9650','2013-01-14','11:20:00',1.98),('9650','2013-01-14','11:25:00',2.05),('9650','2013-01-14','11:30:00',2.07),('9650','2013-01-14','11:35:00',2.03),('9650','2013-01-14','11:40:00',1.93),('9650','2013-01-14','11:45:00',1.86),('9650','2013-01-14','11:50:00',1.81),('9650','2013-01-14','11:55:00',1.93),('9650','2013-01-14','12:00:00',1.84),('9650','2013-01-14','12:05:00',1.74),('9650','2013-01-14','12:10:00',1.67),('9650','2013-01-14','12:15:00',1.82),('9650','2013-01-14','12:20:00',2.04),('9650','2013-01-14','12:25:00',2.06),('9650','2013-01-14','12:30:00',2),('9650','2013-01-14','12:35:00',2.01),('9650','2013-01-14','12:40:00',2.18),('9650','2013-01-14','12:45:00',2.22),('9650','2013-01-14','12:50:00',2.22),('9650','2013-01-14','12:55:00',1.96),('9650','2013-01-14','13:00:00',1.7),('9650','2013-01-14','13:05:00',1.78),('9650','2013-01-14','13:10:00',1.81),('9650','2013-01-14','13:15:00',1.86),('9650','2013-01-14','13:20:00',1.88),('9650','2013-01-14','13:25:00',1.82),('9650','2013-01-14','13:30:00',1.96),('9650','2013-01-14','13:35:00',2.02),('9650','2013-01-14','13:40:00',2.22),('9650','2013-01-14','13:45:00',2.01),('9650','2013-01-14','13:50:00',1.91),('9650','2013-01-14','13:55:00',2.12),('9650','2013-01-14','14:00:00',3.19),('9650','2013-01-14','14:05:00',3.07),('9650','2013-01-14','14:10:00',2.36),('9650','2013-01-14','14:15:00',3.6),('9650','2013-01-14','14:20:00',3.8),('9650','2013-01-14','14:25:00',2.72),('9650','2013-01-14','14:30:00',2.91),('9650','2013-01-14','14:35:00',2.34),('9650','2013-01-14','14:40:00',1.74),('9650','2013-01-14','14:45:00',2.24),('9650','2013-01-14','14:50:00',2.06),('9650','2013-01-14','14:55:00',2.24),('9650','2013-01-14','15:00:00',2),('9650','2013-01-14','15:05:00',1.7),('9650','2013-01-14','15:10:00',1.38),('9650','2013-01-14','15:15:00',1.31),('9650','2013-01-14','15:20:00',1.25),('9650','2013-01-14','15:25:00',1.21),('9650','2013-01-14','15:30:00',1.21),('9650','2013-01-14','15:35:00',1.11),('9650','2013-01-14','15:40:00',1.04),('9650','2013-01-14','15:45:00',1.03),('9650','2013-01-14','15:50:00',1.03),('9650','2013-01-14','15:55:00',1.04),('9650','2013-01-14','16:00:00',1.12),('9650','2013-01-14','16:05:00',1.14),('9650','2013-01-14','16:10:00',1.07),('9650','2013-01-13','11:25:00',1.09),('9650','2013-01-13','12:20:00',1.16),('9650','2013-01-13','12:25:00',1.42),('9650','2013-01-13','12:30:00',1.46),('9650','2013-01-13','12:35:00',1.37),('9650','2013-01-13','12:40:00',1.61),('9650','2013-01-13','12:45:00',1.73),('9650','2013-01-13','12:50:00',1.9),('9650','2013-01-13','12:55:00',1.92),('9650','2013-01-13','13:00:00',2),('9650','2013-01-13','13:05:00',1.89),('9650','2013-01-13','13:10:00',1.51),('9650','2013-01-13','13:15:00',1.37),('9650','2013-01-13','13:35:00',1.16),('9650','2013-01-13','15:15:00',1.79),('9650','2013-01-13','15:20:00',1.48),('9650','2013-01-13','15:25:00',1.46),('9650','2013-01-12','09:15:00',1.24),('9650','2013-01-12','09:20:00',1.33),('9650','2013-01-12','09:25:00',1.23),('9650','2013-01-12','09:30:00',1.27),('9650','2013-01-12','09:35:00',1.2),('9650','2013-01-12','09:50:00',1.06),('9650','2013-01-12','10:05:00',1.17),('9650','2013-01-12','10:10:00',1.38),('9650','2013-01-12','10:15:00',1.25),('9650','2013-01-12','10:20:00',1.17),('9650','2013-01-12','10:25:00',1.39),('9650','2013-01-12','10:30:00',1.82),('9650','2013-01-12','10:35:00',1.45),('9650','2013-01-12','10:40:00',1.08),('9650','2013-01-12','12:20:00',1.03),('9650','2013-01-11','10:45:00',1.03),('9650','2013-01-11','10:50:00',1.1),('9650','2013-01-11','10:55:00',1.18),('9650','2013-01-11','11:00:00',1.29),('9650','2013-01-11','11:05:00',1.42),('9650','2013-01-11','11:10:00',1.53),('9650','2013-01-11','11:15:00',1.62),('9650','2013-01-11','11:20:00',1.71),('9650','2013-01-11','11:25:00',1.81),('9650','2013-01-11','11:30:00',1.89),('9650','2013-01-11','11:35:00',1.94),('9650','2013-01-11','11:40:00',2.03),('9650','2013-01-11','11:45:00',2.12),('9650','2013-01-11','11:50:00',2.19),('9650','2013-01-11','11:55:00',2.24),('9650','2013-01-11','12:00:00',2.3),('9650','2013-01-11','12:05:00',2.34),('9650','2013-01-11','12:10:00',2.35),('9650','2013-01-11','12:15:00',2.39),('9650','2013-01-11','12:20:00',2.48),('9650','2013-01-11','12:25:00',2.48),('9650','2013-01-11','12:30:00',2.51),('9650','2013-01-11','12:35:00',2.6),('9650','2013-01-11','12:40:00',1.84),('9650','2013-01-11','12:45:00',1.52),('9650','2013-01-11','12:50:00',2.47),('9650','2013-01-11','13:00:00',1.79),('9650','2013-01-11','13:05:00',2.75),('9650','2013-01-11','13:10:00',2.12),('9650','2013-01-11','13:15:00',1.58),('9650','2013-01-11','13:20:00',1.27),('9650','2013-01-11','13:25:00',2.42),('9650','2013-01-11','13:30:00',2.81),('9650','2013-01-11','13:35:00',1.81),('9650','2013-01-11','13:40:00',1.06),('9650','2013-01-11','13:45:00',1.8),('9650','2013-01-11','13:50:00',2.62),('9650','2013-01-11','13:55:00',3.34),('9650','2013-01-11','14:00:00',2.37),('9650','2013-01-11','14:05:00',2.66),('9650','2013-01-11','14:10:00',2.1),('9650','2013-01-11','14:15:00',2.1),('9650','2013-01-11','14:20:00',2.24),('9650','2013-01-11','14:25:00',2.24),('9650','2013-01-11','14:30:00',2.14),('9650','2013-01-11','14:35:00',2.06),('9650','2013-01-11','14:40:00',2.03),('9650','2013-01-11','14:45:00',1.98),('9650','2013-01-11','14:50:00',1.9),('9650','2013-01-11','14:55:00',1.82),('9650','2013-01-11','15:00:00',1.59),('9650','2013-01-11','15:05:00',1.34),('9650','2013-01-11','15:10:00',1.18),('9650','2013-01-11','15:15:00',1.17),('9650','2013-01-11','15:20:00',1.14),('9650','2013-01-11','15:25:00',1.11),('9650','2014-03-18','08:25:00',1.02),('9650','2014-03-18','08:30:00',1.11),('9650','2014-03-18','08:35:00',1.23),('9650','2014-03-18','08:40:00',1.39),('9650','2014-03-18','08:45:00',1.54),('9650','2014-03-18','08:50:00',1.61),('9650','2014-03-18','08:55:00',1.67),('9650','2014-03-18','09:00:00',1.71),('9650','2014-03-18','09:05:00',1.97),('9650','2014-03-18','09:10:00',2.15),('9650','2014-03-18','09:15:00',2.37),('9650','2014-03-18','09:20:00',2.33),('9650','2014-03-18','09:25:00',3.01),('9650','2014-03-18','09:30:00',3.52),('9650','2014-03-18','09:35:00',3.37),('9650','2014-03-18','09:40:00',3.63),('9650','2014-03-18','09:45:00',3.3),('9650','2014-03-18','09:50:00',3.14),('9650','2014-03-18','09:55:00',2.98),('9650','2014-03-18','10:00:00',2.19),('9650','2014-03-18','10:05:00',1.76),('9650','2014-03-18','10:10:00',1.56),('9650','2014-03-18','10:15:00',1.49),('9650','2014-03-18','10:20:00',1.65),('9650','2014-03-18','10:25:00',1.81),('9650','2014-03-18','10:30:00',2.18),('9650','2014-03-18','10:35:00',3.29),('9650','2014-03-18','10:40:00',2.95),('9650','2014-03-18','10:45:00',2.54),('9650','2014-03-18','10:50:00',2.64),('9650','2014-03-18','10:55:00',2.6),('9650','2014-03-18','11:00:00',4.21),('9650','2014-03-18','11:05:00',5.38),('9650','2014-03-18','11:10:00',2.98),('9650','2014-03-18','11:15:00',2.84),('9650','2014-03-18','11:20:00',2.71),('9650','2014-03-18','11:25:00',2.91),('9650','2014-03-18','11:30:00',2.76),('9650','2014-03-18','11:35:00',3.21),('9650','2014-03-18','11:40:00',2.96),('9650','2014-03-18','11:45:00',2.91),('9650','2014-03-18','11:50:00',3.4),('9650','2014-03-18','11:55:00',2.83),('9650','2014-03-18','12:00:00',4.96),('9650','2014-03-18','12:05:00',6.22),('9650','2014-03-18','12:10:00',6.23),('9650','2014-03-18','12:15:00',6.19),('9650','2014-03-18','12:20:00',6.41),('9650','2014-03-18','12:25:00',5.36),('9650','2014-03-18','12:30:00',5.44),('9650','2014-03-18','12:35:00',5.79),('9650','2014-03-18','12:40:00',5.78),('9650','2014-03-18','12:45:00',5.6),('9650','2014-03-18','12:50:00',5.44),('9650','2014-03-18','12:55:00',5.61),('9650','2014-03-18','13:00:00',5.59),('9650','2014-03-18','13:05:00',5.42),('9650','2014-03-18','13:10:00',5.61),('9650','2014-03-18','13:15:00',5.37),('9650','2014-03-18','13:20:00',4.45),('9650','2014-03-18','13:25:00',4.84),('9650','2014-03-18','13:30:00',5.55),('9650','2014-03-18','13:35:00',5.66),('9650','2014-03-18','13:40:00',5.49),('9650','2014-03-18','13:45:00',5.51),('9650','2014-03-18','13:50:00',5.26),('9650','2014-03-18','13:55:00',5.45),('9650','2014-03-18','14:00:00',5.35),('9650','2014-03-18','14:05:00',5.38),('9650','2014-03-18','14:10:00',5.38),('9650','2014-03-18','14:15:00',5.09),('9650','2014-03-18','14:20:00',4.98),('9650','2014-03-18','14:25:00',4.93),('9650','2014-03-18','14:30:00',4.76),('9650','2014-03-18','14:35:00',4.88),('9650','2014-03-18','14:40:00',4.86),('9650','2014-03-18','14:45:00',4.79),('9650','2014-03-18','14:50:00',4.61),('9650','2014-03-18','14:55:00',4.54),('9650','2014-03-18','15:00:00',4.31),('9650','2014-03-18','15:05:00',4.19),('9650','2014-03-18','15:10:00',4.21),('9650','2014-03-18','15:15:00',4.24),('9650','2014-03-18','15:20:00',4.14),('9650','2014-03-18','15:25:00',4.1),('9650','2014-03-18','15:30:00',3.86),('9650','2014-03-18','15:35:00',3.72),('9650','2014-03-18','15:40:00',3.79),('9650','2014-03-18','15:45:00',3.8),('9650','2014-03-18','15:50:00',3.71),('9650','2014-03-18','15:55:00',3.71),('9650','2014-03-18','16:00:00',3.57),('9650','2014-03-18','16:05:00',3.52),('9650','2014-03-18','16:10:00',3.42),('9650','2014-03-18','16:15:00',3.25),('9650','2014-03-18','16:20:00',3.1),('9650','2014-03-18','16:25:00',2.91),('9650','2014-03-18','16:30:00',2.88),('9650','2014-03-18','16:35:00',2.69),('9650','2014-03-18','16:40:00',2.54),('9650','2014-03-18','16:45:00',2.49),('9650','2014-03-18','16:50:00',2.15),('9650','2014-03-18','16:55:00',2.06),('9650','2014-03-18','17:00:00',1.63),('9650','2014-03-18','17:05:00',1.38),('9650','2014-03-18','17:10:00',1.29),('9650','2014-03-18','17:15:00',1.44),('9650','2014-03-18','17:20:00',1.37),('9650','2014-03-18','17:25:00',1.26),('9650','2013-01-10','10:05:00',1.32),('9650','2013-01-10','10:10:00',1.34),('9650','2013-01-10','10:15:00',1.53),('9650','2013-01-10','10:20:00',1.36),('9650','2013-01-10','10:45:00',1.01),('9650','2013-01-10','10:50:00',1.09),('9650','2013-01-10','10:55:00',1.19),('9650','2013-01-10','11:00:00',1.29),('9650','2013-01-10','11:05:00',1.4),('9650','2013-01-10','11:10:00',1.53),('9650','2013-01-10','11:15:00',1.64),('9650','2013-01-10','11:20:00',1.72),('9650','2013-01-10','11:25:00',1.53),('9650','2013-01-10','11:30:00',1.67),('9650','2013-01-10','11:35:00',1.83),('9650','2013-01-10','11:40:00',1.73),('9650','2013-01-10','11:45:00',2.05),('9650','2013-01-10','11:50:00',2.07),('9650','2013-01-10','11:55:00',1.94),('9650','2013-01-10','12:00:00',1.7),('9650','2013-01-10','12:05:00',1.25),('9650','2013-01-10','12:20:00',1.06),('9650','2013-01-10','12:55:00',2.32),('9650','2013-01-10','13:00:00',2.03),('9650','2013-01-10','13:10:00',1.75),('9650','2013-01-10','13:15:00',1.68),('9650','2013-01-10','13:20:00',1.4),('9650','2013-01-10','13:25:00',1.16),('9650','2013-01-10','13:30:00',1.74),('9650','2013-01-10','13:35:00',3.47),('9650','2013-01-10','13:40:00',2.28),('9650','2013-01-10','13:45:00',1.84),('9650','2013-01-10','14:20:00',2.16),('9650','2013-01-10','14:25:00',1.83),('9650','2013-01-10','14:30:00',1.26),('9650','2013-01-10','14:35:00',1.35),('9650','2013-01-10','14:40:00',1.27),('9650','2013-01-10','14:45:00',2.17),('9650','2013-01-10','14:50:00',2.33),('9650','2013-01-10','14:55:00',1.79),('9650','2013-01-10','15:00:00',1.91),('9650','2013-01-10','15:05:00',1.65),('9650','2013-01-10','15:45:00',1.09),('9650','2013-01-09','11:25:00',1.32),('9650','2013-01-09','11:30:00',1.77),('9650','2013-01-09','11:35:00',1.48),('9650','2013-01-09','11:50:00',1.4),('9650','2013-01-09','11:55:00',1.95),('9650','2013-01-09','12:00:00',1.98),('9650','2013-01-09','12:05:00',1.96),('9650','2013-01-09','12:10:00',1.73),('9650','2013-01-09','12:15:00',1.48),('9650','2013-01-09','12:20:00',1.13),('9650','2013-01-09','12:40:00',1.03),('9650','2013-01-09','12:45:00',1.03),('9650','2013-01-09','13:15:00',1.17),('9650','2013-01-09','13:20:00',1),('9650','2013-01-09','13:45:00',1.12),('9650','2013-01-09','13:55:00',1.1),('9650','2013-01-09','14:00:00',1.25),('9650','2013-01-09','14:05:00',1.05),('9650','2013-01-08','09:50:00',1.01),('9650','2013-01-08','09:55:00',1.09),('9650','2013-01-08','10:00:00',1.14),('9650','2013-01-08','10:05:00',1.12),('9650','2013-01-08','10:10:00',1.05),('9650','2013-01-08','10:15:00',1.03),('9650','2013-01-08','10:25:00',1.14),('9650','2013-01-08','10:30:00',1.28),('9650','2013-01-08','10:35:00',1.3),('9650','2013-01-08','10:40:00',1.31),('9650','2013-01-08','10:45:00',1.44),('9650','2013-01-08','10:50:00',1.57),('9650','2013-01-08','10:55:00',1.64),('9650','2013-01-08','11:00:00',1.41),('9650','2013-01-08','11:05:00',1.61),('9650','2013-01-08','11:10:00',1.87),('9650','2013-01-08','11:15:00',2),('9650','2013-01-08','11:20:00',1.74),('9650','2013-01-08','11:25:00',1.74),('9650','2013-01-08','11:30:00',1.76),('9650','2013-01-08','11:35:00',1.82),('9650','2013-01-08','11:40:00',1.8),('9650','2013-01-08','11:45:00',1.75),('9650','2013-01-08','11:50:00',1.84),('9650','2013-01-08','11:55:00',2.02),('9650','2013-01-08','12:00:00',1.74),('9650','2013-01-08','12:05:00',1.82),('9650','2013-01-08','12:10:00',1.85),('9650','2013-01-08','12:15:00',1.8),('9650','2013-01-08','12:20:00',1.81),('9650','2013-01-08','12:25:00',1.65),('9650','2013-01-08','12:30:00',1.64),('9650','2013-01-08','12:35:00',1.74),('9650','2013-01-08','12:40:00',1.72),('9650','2013-01-08','12:45:00',1.7),('9650','2013-01-08','12:50:00',1.79),('9650','2013-01-08','12:55:00',1.91),('9650','2013-01-08','13:00:00',1.95),('9650','2013-01-08','13:05:00',1.91),('9650','2013-01-08','13:10:00',2.3),('9650','2013-01-08','13:15:00',2.07),('9650','2013-01-08','13:20:00',1.61),('9650','2013-01-08','13:25:00',1.45),('9650','2013-01-08','13:30:00',1.39),('9650','2013-01-08','13:35:00',1.44),('9650','2013-01-08','13:40:00',1.5),('9650','2013-01-08','13:45:00',1.5),('9650','2013-01-08','13:50:00',1.34),('9650','2013-01-08','13:55:00',1.31),('9650','2013-01-08','14:00:00',1.4),('9650','2013-01-08','14:05:00',1.3),('9650','2013-01-08','14:10:00',1.23),('9650','2013-01-08','14:15:00',1.12),('9650','2013-01-08','14:20:00',1.02),('9650','2013-01-07','09:45:00',1.01),('9650','2013-01-07','09:50:00',1.15),('9650','2013-01-07','09:55:00',1.19),('9650','2013-01-07','10:00:00',1.16),('9650','2013-01-07','10:05:00',1.11),('9650','2013-01-07','10:10:00',1.03),('9650','2013-01-07','10:40:00',1),('9650','2013-01-07','10:45:00',1.04),('9650','2013-01-07','10:50:00',1.09),('9650','2013-01-07','10:55:00',1.13),('9650','2013-01-07','11:00:00',1.19),('9650','2013-01-07','11:05:00',1.32),('9650','2013-01-07','11:10:00',1.46),('9650','2013-01-07','11:15:00',1.6),('9650','2013-01-07','11:20:00',1.69),('9650','2013-01-07','11:25:00',1.81),('9650','2013-01-07','11:30:00',1.93),('9650','2013-01-07','11:35:00',2.04),('9650','2013-01-07','11:40:00',2.18),('9650','2013-01-07','11:45:00',2.72),('9650','2013-01-07','11:50:00',2.41),('9650','2013-01-07','11:55:00',2.24),('9650','2013-01-07','12:00:00',2.24),('9650','2013-01-07','12:05:00',2.23),('9650','2013-01-07','12:10:00',2.41),('9650','2013-01-07','12:15:00',2.33),('9650','2013-01-07','12:20:00',2.08),('9650','2013-01-07','12:25:00',1.99),('9650','2013-01-07','12:30:00',1.91),('9650','2013-01-07','12:35:00',1.81),('9650','2013-01-07','12:40:00',2.12),('9650','2013-01-07','12:45:00',2.35),('9650','2013-01-07','12:50:00',2.47),('9650','2013-01-07','12:55:00',1.81),('9650','2013-01-07','13:00:00',1.22),('9650','2013-01-07','13:05:00',1.3),('9650','2013-01-07','13:10:00',1.23),('9650','2013-01-07','13:15:00',1.19),('9650','2013-01-07','13:20:00',1.44),('9650','2013-01-07','13:25:00',1.5),('9650','2013-01-07','13:30:00',1.24),('9650','2013-01-07','13:35:00',1.35),('9650','2013-01-07','13:40:00',1.53),('9650','2013-01-07','13:45:00',1.83),('9650','2013-01-07','13:50:00',2.3),('9650','2013-01-07','13:55:00',3.1),('9650','2013-01-07','14:00:00',1.96),('9650','2013-01-07','14:05:00',1.98),('9650','2013-01-07','14:10:00',1.35),('9650','2013-01-07','14:15:00',1.4),('9650','2013-01-07','14:20:00',1.23),('9650','2013-01-07','14:25:00',1.39),('9650','2013-01-07','14:30:00',1.52),('9650','2013-01-07','14:35:00',1.53),('9650','2013-01-07','14:40:00',1.7),('9650','2013-01-07','14:45:00',1.19),('9650','2013-01-07','14:55:00',1.03),('9650','2013-01-07','15:05:00',1.1),('9650','2013-01-07','15:10:00',1.11),('9650','2013-01-07','15:15:00',1.3),('9650','2013-01-07','15:20:00',1.06),('9650','2013-01-07','15:35:00',1.14),('9650','2013-01-07','15:40:00',1.03),('9650','2013-01-06','10:45:00',1.07),('9650','2013-01-06','10:50:00',1.09),('9650','2013-01-06','10:55:00',1.18),('9650','2013-01-06','11:00:00',1.25),('9650','2013-01-06','11:05:00',1.34),('9650','2013-01-06','11:10:00',1.44),('9650','2013-01-06','11:15:00',1.58),('9650','2013-01-06','11:20:00',1.66),('9650','2013-01-06','11:25:00',1.75),('9650','2013-01-06','11:30:00',1.81),('9650','2013-01-06','11:35:00',1.88),('9650','2013-01-06','11:40:00',1.95),('9650','2013-01-06','11:45:00',2.02),('9650','2013-01-06','11:50:00',2.07),('9650','2013-01-06','11:55:00',2.11),('9650','2013-01-06','12:00:00',2.19),('9650','2013-01-06','12:05:00',2.23),('9650','2013-01-06','12:10:00',2.27),('9650','2013-01-06','12:15:00',2.32),('9650','2013-01-06','12:20:00',2.37),('9650','2013-01-06','12:25:00',2.42),('9650','2013-01-06','12:30:00',2.44),('9650','2013-01-06','12:35:00',2.48),('9650','2013-01-06','12:40:00',2.52),('9650','2013-01-06','12:45:00',2.53),('9650','2013-01-06','12:50:00',2.55),('9650','2013-01-06','12:55:00',2.56),('9650','2013-01-06','13:00:00',2.55),('9650','2013-01-06','13:05:00',2.59),('9650','2013-01-06','13:10:00',2.57),('9650','2013-01-06','13:15:00',2.57),('9650','2013-01-06','13:20:00',2.56),('9650','2013-01-06','13:25:00',2.58),('9650','2013-01-06','13:30:00',2.59),('9650','2013-01-06','13:35:00',2.55),('9650','2013-01-06','13:40:00',2.51),('9650','2013-01-06','13:45:00',2.45),('9650','2013-01-06','13:50:00',2.41),('9650','2013-01-06','13:55:00',2.33),('9650','2013-01-06','14:00:00',2.28),('9650','2013-01-06','14:05:00',2.22),('9650','2013-01-06','14:10:00',2.19),('9650','2013-01-06','14:15:00',2.16),('9650','2013-01-06','14:20:00',2.12),('9650','2013-01-06','14:25:00',2.07),('9650','2013-01-06','14:30:00',2),('9650','2013-01-06','14:35:00',1.9),('9650','2013-01-06','14:40:00',1.88),('9650','2013-01-06','14:45:00',1.78),('9650','2013-01-06','14:50:00',1.75),('9650','2013-01-06','14:55:00',1.58),('9650','2013-01-06','15:00:00',1.36),('9650','2013-01-06','15:05:00',1.19),('9650','2013-01-06','15:10:00',1.08),('9650','2013-01-05','10:55:00',1.06),('9650','2013-01-05','11:00:00',1.19),('9650','2013-01-05','11:05:00',1.28),('9650','2013-01-05','11:10:00',1.38),('9650','2013-01-05','11:15:00',1.52),('9650','2013-01-05','11:20:00',1.61),('9650','2013-01-05','11:25:00',1.7),('9650','2013-01-05','11:30:00',1.8),('9650','2013-01-05','11:35:00',1.86),('9650','2013-01-05','11:40:00',1.94),('9650','2013-01-05','11:45:00',2.01),('9650','2013-01-05','11:50:00',2.05),('9650','2013-01-05','11:55:00',2.11),('9650','2013-01-05','12:00:00',2.17),('9650','2013-01-05','12:05:00',2.22),('9650','2013-01-05','12:10:00',2.27),('9650','2013-01-05','12:15:00',2.29),('9650','2013-01-05','12:20:00',2.33),('9650','2013-01-05','12:25:00',2.37),('9650','2013-01-05','12:30:00',2.4),('9650','2013-01-05','12:35:00',2.39),('9650','2013-01-05','12:40:00',2.4),('9650','2013-01-05','12:45:00',2.49),('9650','2013-01-05','12:50:00',2.55),('9650','2013-01-05','12:55:00',2.58),('9650','2013-01-05','13:00:00',2.6),('9650','2013-01-05','13:05:00',2.6),('9650','2013-01-05','13:10:00',2.62),('9650','2013-01-05','13:15:00',2.62),('9650','2013-01-05','13:20:00',2.63),('9650','2013-01-05','13:25:00',2.62),('9650','2013-01-05','13:30:00',2.65),('9650','2013-01-05','13:35:00',2.62),('9650','2013-01-05','13:40:00',2.58),('9650','2013-01-05','13:45:00',2.54),('9650','2013-01-05','13:50:00',2.49),('9650','2013-01-05','13:55:00',2.4),('9650','2013-01-05','14:00:00',2.38),('9650','2013-01-05','14:05:00',2.41),('9650','2013-01-05','14:10:00',2.24),('9650','2013-01-05','14:15:00',2.23),('9650','2013-01-05','14:20:00',2.17),('9650','2013-01-05','14:25:00',2.02),('9650','2013-01-05','14:30:00',2.01),('9650','2013-01-05','14:35:00',1.9),('9650','2013-01-05','14:40:00',1.86),('9650','2013-01-05','14:45:00',1.76),('9650','2013-01-05','14:50:00',1.68),('9650','2013-01-05','14:55:00',1.58),('9650','2013-01-05','15:00:00',1.35),('9650','2013-01-05','15:05:00',1.16),('9650','2013-01-05','15:10:00',1.08),('9650','2013-01-05','15:15:00',1.04),('9650','2013-01-04','09:40:00',1.09),('9650','2013-01-04','09:45:00',1.11),('9650','2013-01-04','09:50:00',1.15),('9650','2013-01-04','09:55:00',1.24),('9650','2013-01-04','10:00:00',1.34),('9650','2013-01-04','10:05:00',1.35),('9650','2013-01-04','10:10:00',1.31),('9650','2013-01-04','10:15:00',1.33),('9650','2013-01-04','10:20:00',1.33),('9650','2013-01-04','10:25:00',1.28),('9650','2013-01-04','10:30:00',1.3),('9650','2013-01-04','10:35:00',1.38),('9650','2013-01-04','10:40:00',1.39),('9650','2013-01-04','10:45:00',1.32),('9650','2013-01-04','10:50:00',1.32),('9650','2013-01-04','10:55:00',1.72),('9650','2013-01-04','11:00:00',1.54),('9650','2013-01-04','11:05:00',1.64),('9650','2013-01-04','11:10:00',1.59),('9650','2013-01-04','11:15:00',1.41),('9650','2013-01-04','11:20:00',1.86),('9650','2013-01-04','11:25:00',2.08),('9650','2013-01-04','11:30:00',2.24),('9650','2013-01-04','11:35:00',2.28),('9650','2013-01-04','11:40:00',2.29),('9650','2013-01-04','11:45:00',2.44),('9650','2013-01-04','11:50:00',2.32),('9650','2013-01-04','11:55:00',2.19),('9650','2013-01-04','12:00:00',2.09),('9650','2013-01-04','12:05:00',2.06),('9650','2013-01-04','12:10:00',2.12),('9650','2013-01-04','12:15:00',2.2),('9650','2013-01-04','12:20:00',2.03),('9650','2013-01-04','12:25:00',1.77),('9650','2013-01-04','12:30:00',1.7),('9650','2013-01-04','12:35:00',2.08),('9650','2013-01-04','12:40:00',2.67),('9650','2013-01-04','12:45:00',3.01),('9650','2013-01-04','12:50:00',2.18),('9650','2013-01-04','12:55:00',1.92),('9650','2013-01-04','13:00:00',1.99),('9650','2013-01-04','13:05:00',1.92),('9650','2013-01-04','13:10:00',1.82),('9650','2013-01-04','13:15:00',1.55),('9650','2013-01-04','13:20:00',1.44),('9650','2013-01-04','13:25:00',1.62),('9650','2013-01-04','13:30:00',2.58),('9650','2013-01-04','13:35:00',2.13),('9650','2013-01-04','13:40:00',1.67),('9650','2013-01-04','13:45:00',1.47),('9650','2013-01-04','13:50:00',1.58),('9650','2013-01-04','13:55:00',1.83),('9650','2013-01-04','14:00:00',1.67),('9650','2013-01-04','14:05:00',2.39),('9650','2013-01-04','14:10:00',2.14),('9650','2013-01-04','14:15:00',1.82),('9650','2013-01-04','14:20:00',1.52),('9650','2013-01-04','14:25:00',1.08),('9650','2013-01-04','14:30:00',1.71),('9650','2013-01-04','14:35:00',1.67),('9650','2013-01-04','14:40:00',1.78),('9650','2013-01-04','14:45:00',1.95),('9650','2013-01-04','14:50:00',1.3),('9650','2013-01-04','14:55:00',1.15),('9650','2013-01-04','15:00:00',1.76),('9650','2013-01-04','15:05:00',1.36),('9650','2013-01-03','10:05:00',1),('9650','2013-01-03','10:35:00',1.07),('9650','2013-01-03','10:40:00',1.19),('9650','2013-01-03','10:45:00',1.34),('9650','2013-01-03','10:50:00',1.61),('9650','2013-01-03','10:55:00',1.9),('9650','2013-01-03','11:00:00',2.08),('9650','2013-01-03','11:05:00',1.9),('9650','2013-01-03','11:10:00',1.6),('9650','2013-01-03','11:15:00',1.5),('9650','2013-01-03','11:20:00',1.39),('9650','2013-01-03','11:25:00',1.17),('9650','2013-01-03','11:30:00',1.03),('9650','2013-01-03','11:35:00',1.13),('9650','2013-01-03','11:40:00',1.03),('9650','2013-01-03','11:45:00',1.4),('9650','2013-01-03','11:50:00',2.28),('9650','2013-01-03','11:55:00',2.94),('9650','2013-01-03','12:00:00',3.24),('9650','2013-01-03','12:05:00',2.88),('9650','2013-01-03','12:10:00',2.38),('9650','2013-01-03','12:15:00',1.72),('9650','2013-01-03','12:20:00',1.37),('9650','2013-01-03','12:25:00',1.37),('9650','2013-01-03','12:30:00',2.03),('9650','2013-01-03','12:35:00',1.75),('9650','2013-01-03','12:40:00',2.61),('9650','2013-01-03','12:45:00',2.7),('9650','2013-01-03','12:50:00',2.79),('9650','2013-01-03','12:55:00',2.76),('9650','2013-01-03','13:00:00',2.72),('9650','2013-01-03','13:05:00',2.58),('9650','2013-01-03','13:10:00',2.01),('9650','2013-01-03','13:15:00',2.29),('9650','2013-01-03','13:20:00',2.53),('9650','2013-01-03','13:25:00',2.47),('9650','2013-01-03','13:30:00',2.46),('9650','2013-01-03','13:35:00',2.47),('9650','2013-01-03','13:40:00',2.43),('9650','2013-01-03','13:45:00',2.4),('9650','2013-01-03','13:50:00',2.32),('9650','2013-01-03','13:55:00',2.27),('9650','2013-01-03','14:00:00',2.17),('9650','2013-01-03','14:05:00',2.12),('9650','2013-01-03','14:10:00',2.11),('9650','2013-01-03','14:15:00',2.09),('9650','2013-01-03','14:20:00',2.03),('9650','2013-01-03','14:25:00',1.97),('9650','2013-01-03','14:30:00',1.93),('9650','2013-01-03','14:35:00',1.82),('9650','2013-01-03','14:40:00',1.72),('9650','2013-01-03','14:45:00',1.66),('9650','2013-01-03','14:50:00',1.62),('9650','2013-01-03','14:55:00',1.46),('9650','2013-01-03','15:00:00',1.25),('9650','2013-01-03','15:05:00',1.12),('9650','2013-01-02','09:55:00',1.09),('9650','2013-01-02','10:00:00',1.18),('9650','2013-01-02','10:05:00',1.28),('9650','2013-01-02','10:10:00',1.31),('9650','2013-01-02','10:15:00',1.5),('9650','2013-01-02','10:20:00',1.61),('9650','2013-01-02','10:25:00',1.72),('9650','2013-01-02','10:30:00',1.73),('9650','2013-01-02','10:35:00',1.71),('9650','2013-01-02','10:40:00',1.73),('9650','2013-01-02','10:45:00',1.76),('9650','2013-01-02','10:50:00',1.83),('9650','2013-01-02','10:55:00',1.8),('9650','2013-01-02','11:00:00',1.88),('9650','2013-01-02','11:05:00',1.76),('9650','2013-01-02','11:10:00',1.69),('9650','2013-01-02','11:15:00',1.58),('9650','2013-01-02','11:20:00',1.38),('9650','2013-01-02','11:25:00',1.07),('9650','2013-01-02','11:30:00',1.05),('9650','2013-01-02','11:35:00',1.03),('9650','2013-01-02','11:40:00',1.99),('9650','2013-01-02','11:45:00',2.02),('9650','2013-01-02','11:50:00',2.06),('9650','2013-01-02','11:55:00',2.1),('9650','2013-01-02','12:00:00',2.13),('9650','2013-01-02','12:05:00',2.18),('9650','2013-01-02','12:10:00',2.23),('9650','2013-01-02','12:15:00',2.27),('9650','2013-01-02','12:20:00',2.31),('9650','2013-01-02','12:25:00',2.35),('9650','2013-01-02','12:30:00',2.38),('9650','2013-01-02','12:35:00',2.42),('9650','2013-01-02','12:40:00',2.45),('9650','2013-01-02','12:45:00',2.47),('9650','2013-01-02','12:50:00',2.48),('9650','2013-01-02','12:55:00',2.51),('9650','2013-01-02','13:00:00',2.53),('9650','2013-01-02','13:05:00',2.53),('9650','2013-01-02','13:10:00',2.55),('9650','2013-01-02','13:15:00',2.55),('9650','2013-01-02','13:20:00',2.56),('9650','2013-01-02','13:25:00',2.56),('9650','2013-01-02','13:30:00',2.54),('9650','2013-01-02','13:35:00',2.53),('9650','2013-01-02','13:40:00',2.49),('9650','2013-01-02','13:45:00',2.45),('9650','2013-01-02','13:50:00',2.41),('9650','2013-01-02','13:55:00',2.34),('9650','2013-01-02','14:00:00',2.23),('9650','2013-01-02','14:05:00',2.21),('9650','2013-01-02','14:10:00',2.17),('9650','2013-01-02','14:15:00',2.16),('9650','2013-01-02','14:20:00',2.12),('9650','2013-01-02','14:25:00',2.05),('9650','2013-01-02','14:30:00',1.97),('9650','2013-01-02','14:35:00',1.92),('9650','2013-01-02','14:40:00',1.87),('9650','2013-01-02','14:45:00',1.77),('9650','2013-01-02','14:50:00',1.7),('9650','2013-01-02','14:55:00',1.54),('9650','2013-01-02','15:00:00',1.33),('9650','2013-01-02','15:05:00',1.22),('9650','2013-01-02','15:10:00',1.13),('9650','2013-01-02','15:15:00',1.06),('9650','2013-01-01','10:00:00',1.07),('9650','2013-01-01','10:05:00',1.02),('9650','2013-01-01','11:10:00',1.1),('9650','2013-01-01','13:40:00',1.44),('9650','2013-01-01','13:45:00',1.52),('9650','2013-01-01','13:50:00',1.33),('9650','2013-01-01','13:55:00',1.25),('9650','2013-01-01','14:00:00',1.2),('9650','2014-03-17','07:55:00',1.14),('9650','2014-03-17','08:00:00',1.05),('9650','2014-03-17','08:05:00',1.04),('9650','2014-03-17','08:10:00',1.13),('9650','2014-03-17','08:15:00',1.19),('9650','2014-03-17','08:20:00',1.52),('9650','2014-03-17','08:25:00',1.46),('9650','2014-03-17','08:30:00',1.42),('9650','2014-03-17','08:40:00',1.06),('9650','2014-03-17','08:45:00',1.13),('9650','2014-03-17','08:50:00',1.74),('9650','2014-03-17','08:55:00',2.48),('9650','2014-03-17','09:00:00',2.39),('9650','2014-03-17','09:05:00',2.49),('9650','2014-03-17','09:10:00',2.11),('9650','2014-03-17','09:15:00',2.71),('9650','2014-03-17','09:20:00',2.91),('9650','2014-03-17','09:25:00',2.21),('9650','2014-03-17','09:30:00',2.24),('9650','2014-03-17','09:35:00',2.73),('9650','2014-03-17','09:40:00',2.01),('9650','2014-03-17','09:45:00',2.19),('9650','2014-03-17','09:50:00',2.29),('9650','2014-03-17','09:55:00',2.25),('9650','2014-03-17','10:00:00',2.82),('9650','2014-03-17','10:05:00',3.25),('9650','2014-03-17','10:10:00',3.98),('9650','2014-03-17','10:15:00',3.68),('9650','2014-03-17','10:20:00',3.88),('9650','2014-03-17','10:25:00',2.79),('9650','2014-03-17','10:30:00',3.55),('9650','2014-03-17','10:35:00',5.01),('9650','2014-03-17','10:40:00',3.5),('9650','2014-03-17','10:45:00',4.58),('9650','2014-03-17','10:50:00',4.93),('9650','2014-03-17','10:55:00',5.19),('9650','2014-03-17','11:00:00',3.48),('9650','2014-03-17','11:05:00',3.18),('9650','2014-03-17','11:10:00',2.37),('9650','2014-03-17','11:15:00',2.7),('9650','2014-03-17','11:20:00',4.51),('9650','2014-03-17','11:25:00',4.96),('9650','2014-03-17','11:30:00',4.67),('9650','2014-03-17','11:35:00',5.44),('9650','2014-03-17','11:40:00',4.26),('9650','2014-03-17','11:45:00',4.6),('9650','2014-03-17','11:50:00',3.79),('9650','2014-03-17','11:55:00',3.01),('9650','2014-03-17','12:00:00',2.92),('9650','2014-03-17','12:05:00',4.46),('9650','2014-03-17','12:10:00',4.54),('9650','2014-03-17','12:15:00',5.45),('9650','2014-03-17','12:20:00',2.35),('9650','2014-03-17','12:25:00',1.88),('9650','2014-03-17','12:30:00',2.23),('9650','2014-03-17','12:35:00',3.72),('9650','2014-03-17','12:40:00',2.14),('9650','2014-03-17','12:45:00',6.18),('9650','2014-03-17','12:50:00',4.44),('9650','2014-03-17','12:55:00',5.47),('9650','2014-03-17','13:00:00',5.88),('9650','2014-03-17','13:05:00',5.89),('9650','2014-03-17','13:10:00',5.79),('9650','2014-03-17','13:15:00',5.66),('9650','2014-03-17','13:20:00',5.7),('9650','2014-03-17','13:25:00',4.95),('9650','2014-03-17','13:30:00',5.43),('9650','2014-03-17','13:35:00',5.51),('9650','2014-03-17','13:40:00',5.53),('9650','2014-03-17','13:45:00',5.47),('9650','2014-03-17','13:50:00',5.44),('9650','2014-03-17','13:55:00',5.53),('9650','2014-03-17','14:00:00',5.34),('9650','2014-03-17','14:05:00',5.28),('9650','2014-03-17','14:10:00',5.31),('9650','2014-03-17','14:15:00',5.18),('9650','2014-03-17','14:20:00',5.14),('9650','2014-03-17','14:25:00',5.04),('9650','2014-03-17','14:30:00',4.95),('9650','2014-03-17','14:35:00',4.92),('9650','2014-03-17','14:40:00',4.82),('9650','2014-03-17','14:45:00',4.69),('9650','2014-03-17','14:50:00',4.66),('9650','2014-03-17','14:55:00',4.51),('9650','2014-03-17','15:00:00',4.28),('9650','2014-03-17','15:05:00',4.25),('9650','2014-03-17','15:10:00',4.19),('9650','2014-03-17','15:15:00',4.27),('9650','2014-03-17','15:20:00',4.22),('9650','2014-03-17','15:25:00',4.02),('9650','2014-03-17','15:30:00',3.92),('9650','2014-03-17','15:35:00',3.83),('9650','2014-03-17','15:40:00',3.8),('9650','2014-03-17','15:45:00',3.79),('9650','2014-03-17','15:50:00',3.63),('9650','2014-03-17','15:55:00',3.64),('9650','2014-03-17','16:00:00',3.58),('9650','2014-03-17','16:05:00',3.5),('9650','2014-03-17','16:10:00',3.39),('9650','2014-03-17','16:15:00',3.23),('9650','2014-03-17','16:20:00',3.04),('9650','2014-03-17','16:25:00',3.01),('9650','2014-03-17','16:30:00',2.98),('9650','2014-03-17','16:35:00',2.85),('9650','2014-03-17','16:40:00',2.75),('9650','2014-03-17','16:45:00',2.5),('9650','2014-03-17','16:50:00',2.43),('9650','2014-03-17','16:55:00',2.25),('9650','2014-03-17','17:00:00',2.24),('9650','2014-03-17','17:05:00',2.11),('9650','2014-03-17','17:10:00',1.89),('9650','2014-03-17','17:15:00',1.69),('9650','2014-03-17','17:20:00',1.48),('9650','2014-03-17','17:25:00',1.34),('9650','2014-03-17','17:30:00',1.14),('9650','2012-12-31','10:40:00',1),('9650','2012-12-31','10:45:00',1.3),('9650','2012-12-31','10:50:00',1.72),('9650','2012-12-31','10:55:00',1.35),('9650','2012-12-31','11:05:00',1.42),('9650','2012-12-31','11:10:00',1.54),('9650','2012-12-31','11:15:00',1.48),('9650','2012-12-31','11:20:00',1.52),('9650','2012-12-31','11:25:00',2.15),('9650','2012-12-31','11:30:00',2.78),('9650','2012-12-31','11:35:00',1.93),('9650','2012-12-31','11:40:00',1.82),('9650','2012-12-31','11:45:00',2.06),('9650','2012-12-31','11:50:00',2.05),('9650','2012-12-31','11:55:00',1.93),('9650','2012-12-31','12:00:00',1.85),('9650','2012-12-31','12:05:00',1.75),('9650','2012-12-31','12:10:00',1.98),('9650','2012-12-31','12:15:00',1.86),('9650','2012-12-31','12:20:00',2.02),('9650','2012-12-31','12:25:00',1.86),('9650','2012-12-31','12:30:00',1.58),('9650','2012-12-31','12:35:00',1.52),('9650','2012-12-31','12:40:00',1.75),('9650','2012-12-31','12:45:00',2.06),('9650','2012-12-31','12:50:00',1.91),('9650','2012-12-31','12:55:00',1.81),('9650','2012-12-31','13:00:00',1.63),('9650','2012-12-31','13:05:00',1.58),('9650','2012-12-31','13:10:00',1.31),('9650','2012-12-31','13:15:00',1.35),('9650','2012-12-31','13:20:00',1.37),('9650','2012-12-31','13:25:00',1.16),('9650','2012-12-31','13:30:00',1.02),('9650','2012-12-30','10:50:00',1.05),('9650','2012-12-30','10:55:00',1.14),('9650','2012-12-30','11:00:00',1.24),('9650','2012-12-30','11:05:00',1.31),('9650','2012-12-30','11:10:00',1.36),('9650','2012-12-30','11:15:00',1.54),('9650','2012-12-30','11:20:00',1.66),('9650','2012-12-30','11:25:00',1.76),('9650','2012-12-30','11:30:00',1.84),('9650','2012-12-30','11:35:00',1.9),('9650','2012-12-30','11:40:00',1.98),('9650','2012-12-30','11:45:00',2.05),('9650','2012-12-30','11:50:00',2.1),('9650','2012-12-30','11:55:00',2.16),('9650','2012-12-30','12:00:00',2.19),('9650','2012-12-30','12:05:00',2.27),('9650','2012-12-30','12:10:00',2.31),('9650','2012-12-30','12:15:00',2.36),('9650','2012-12-30','12:20:00',2.4),('9650','2012-12-30','12:25:00',2.43),('9650','2012-12-30','12:30:00',2.46),('9650','2012-12-30','12:35:00',2.49),('9650','2012-12-30','12:40:00',2.52),('9650','2012-12-30','12:45:00',2.56),('9650','2012-12-30','12:50:00',2.58),('9650','2012-12-30','12:55:00',2.58),('9650','2012-12-30','13:00:00',2.59),('9650','2012-12-30','13:05:00',2.61),('9650','2012-12-30','13:10:00',2.62),('9650','2012-12-30','13:15:00',2.63),('9650','2012-12-30','13:20:00',2.64),('9650','2012-12-30','13:25:00',2.62),('9650','2012-12-30','13:30:00',2.62),('9650','2012-12-30','13:35:00',2.61),('9650','2012-12-30','13:40:00',2.54),('9650','2012-12-30','13:45:00',2.5),('9650','2012-12-30','13:50:00',2.43),('9650','2012-12-30','13:55:00',2.35),('9650','2012-12-30','14:00:00',2.25),('9650','2012-12-30','14:05:00',2.2),('9650','2012-12-30','14:10:00',2.2),('9650','2012-12-30','14:15:00',2.16),('9650','2012-12-30','14:20:00',2.09),('9650','2012-12-30','14:25:00',2.05),('9650','2012-12-30','14:30:00',1.95),('9650','2012-12-30','14:35:00',1.87),('9650','2012-12-30','14:40:00',1.8),('9650','2012-12-30','14:45:00',1.73),('9650','2012-12-30','14:50:00',1.69),('9650','2012-12-30','14:55:00',1.43),('9650','2012-12-30','15:00:00',1.24),('9650','2012-12-30','15:05:00',1.12),('9650','2012-12-30','15:10:00',1.06),('9650','2012-12-29','10:55:00',1.05),('9650','2012-12-29','11:00:00',1.15),('9650','2012-12-29','11:05:00',1.24),('9650','2012-12-29','11:10:00',1.34),('9650','2012-12-29','11:15:00',1.48),('9650','2012-12-29','11:20:00',1.57),('9650','2012-12-29','11:25:00',1.68),('9650','2012-12-29','11:30:00',1.78),('9650','2012-12-29','11:35:00',1.84),('9650','2012-12-29','11:40:00',1.9),('9650','2012-12-29','11:45:00',1.98),('9650','2012-12-29','11:50:00',2.04),('9650','2012-12-29','11:55:00',2.1),('9650','2012-12-29','12:00:00',2.15),('9650','2012-12-29','12:05:00',2.19),('9650','2012-12-29','12:10:00',2.24),('9650','2012-12-29','12:15:00',2.29),('9650','2012-12-29','12:20:00',2.34),('9650','2012-12-29','12:25:00',2.35),('9650','2012-12-29','12:30:00',2.37),('9650','2012-12-29','12:35:00',2.41),('9650','2012-12-29','12:40:00',2.44),('9650','2012-12-29','12:45:00',2.44),('9650','2012-12-29','12:50:00',2.44),('9650','2012-12-29','12:55:00',2.49),('9650','2012-12-29','13:00:00',2.55),('9650','2012-12-29','13:05:00',2.58),('9650','2012-12-29','13:10:00',2.57),('9650','2012-12-29','13:15:00',2.59),('9650','2012-12-29','13:20:00',2.59),('9650','2012-12-29','13:25:00',2.59),('9650','2012-12-29','13:30:00',2.6),('9650','2012-12-29','13:35:00',2.56),('9650','2012-12-29','13:40:00',2.52),('9650','2012-12-29','13:45:00',2.49),('9650','2012-12-29','13:50:00',2.45),('9650','2012-12-29','13:55:00',2.36),('9650','2012-12-29','14:00:00',2.27),('9650','2012-12-29','14:05:00',2.22),('9650','2012-12-29','14:10:00',2.2),('9650','2012-12-29','14:15:00',2.17),('9650','2012-12-29','14:20:00',2.1),('9650','2012-12-29','14:25:00',2.02),('9650','2012-12-29','14:30:00',1.92),('9650','2012-12-29','14:35:00',1.89),('9650','2012-12-29','14:40:00',1.76),('9650','2012-12-29','14:45:00',1.69),('9650','2012-12-29','14:50:00',1.65),('9650','2012-12-29','14:55:00',1.39),('9650','2012-12-29','15:00:00',1.19),('9650','2012-12-29','15:05:00',1.1),('9650','2012-12-29','15:10:00',1.03),('9650','2012-12-28','10:55:00',1.03),('9650','2012-12-28','11:00:00',1.14),('9650','2012-12-28','11:05:00',1.21),('9650','2012-12-28','11:10:00',1.33),('9650','2012-12-28','11:15:00',1.46),('9650','2012-12-28','11:20:00',1.57),('9650','2012-12-28','11:25:00',1.67),('9650','2012-12-28','11:30:00',1.75),('9650','2012-12-28','11:35:00',1.84),('9650','2012-12-28','11:40:00',1.89),('9650','2012-12-28','11:45:00',1.96),('9650','2012-12-28','11:50:00',2.03),('9650','2012-12-28','11:55:00',2.08),('9650','2012-12-28','12:00:00',2.15),('9650','2012-12-28','12:05:00',2.2),('9650','2012-12-28','12:10:00',2.26),('9650','2012-12-28','12:15:00',2.29),('9650','2012-12-28','12:20:00',2.31),('9650','2012-12-28','12:25:00',2.35),('9650','2012-12-28','12:30:00',2.38),('9650','2012-12-28','12:35:00',2.44),('9650','2012-12-28','12:40:00',2.49),('9650','2012-12-28','12:45:00',2.49),('9650','2012-12-28','12:50:00',2.5),('9650','2012-12-28','12:55:00',2.54),('9650','2012-12-28','13:00:00',2.58),('9650','2012-12-28','13:05:00',2.6),('9650','2012-12-28','13:10:00',2.6),('9650','2012-12-28','13:15:00',2.61),('9650','2012-12-28','13:20:00',2.61),('9650','2012-12-28','13:25:00',2.61),('9650','2012-12-28','13:30:00',2.59),('9650','2012-12-28','13:35:00',2.57),('9650','2012-12-28','13:40:00',2.53),('9650','2012-12-28','13:45:00',2.5),('9650','2012-12-28','13:50:00',2.46),('9650','2012-12-28','13:55:00',2.36),('9650','2012-12-28','14:00:00',2.26),('9650','2012-12-28','14:05:00',2.22),('9650','2012-12-28','14:10:00',2.2),('9650','2012-12-28','14:15:00',2.18),('9650','2012-12-28','14:20:00',2.11),('9650','2012-12-28','14:25:00',2.07),('9650','2012-12-28','14:30:00',1.93),('9650','2012-12-28','14:35:00',1.91),('9650','2012-12-28','14:40:00',1.77),('9650','2012-12-28','14:45:00',1.74),('9650','2012-12-28','14:50:00',1.67),('9650','2012-12-28','14:55:00',1.38),('9650','2012-12-28','15:00:00',1.2),('9650','2012-12-28','15:05:00',1.12),('9650','2012-12-28','15:10:00',1.04),('9650','2012-12-27','10:55:00',1.08),('9650','2012-12-27','11:00:00',1.18),('9650','2012-12-27','11:05:00',1.25),('9650','2012-12-27','11:10:00',1.32),('9650','2012-12-27','11:15:00',1.47),('9650','2012-12-27','11:20:00',1.48),('9650','2012-12-27','11:25:00',1.67),('9650','2012-12-27','11:30:00',1.76),('9650','2012-12-27','11:35:00',1.85),('9650','2012-12-27','11:40:00',1.9),('9650','2012-12-27','11:45:00',2),('9650','2012-12-27','11:50:00',1.83),('9650','2012-12-27','11:55:00',2.06),('9650','2012-12-27','12:00:00',2.05),('9650','2012-12-27','12:05:00',2.01),('9650','2012-12-27','12:10:00',2.19),('9650','2012-12-27','12:15:00',2.21),('9650','2012-12-27','12:20:00',2.25),('9650','2012-12-27','12:25:00',2.27),('9650','2012-12-27','12:30:00',2.34),('9650','2012-12-27','12:35:00',2.34),('9650','2012-12-27','12:40:00',2.38),('9650','2012-12-27','12:45:00',2.4),('9650','2012-12-27','12:50:00',2.44),('9650','2012-12-27','12:55:00',2.27),('9650','2012-12-27','13:00:00',2.48),('9650','2012-12-27','13:05:00',2.48),('9650','2012-12-27','13:10:00',2.49),('9650','2012-12-27','13:15:00',2.49),('9650','2012-12-27','13:20:00',2.48),('9650','2012-12-27','13:25:00',2.51),('9650','2012-12-27','13:30:00',2.5),('9650','2012-12-27','13:35:00',2.48),('9650','2012-12-27','13:40:00',2.39),('9650','2012-12-27','13:45:00',2.35),('9650','2012-12-27','13:50:00',2.32),('9650','2012-12-27','13:55:00',2.16),('9650','2012-12-27','14:00:00',2.05),('9650','2012-12-27','14:05:00',1.95),('9650','2012-12-27','14:10:00',2.02),('9650','2012-12-27','14:15:00',2.02),('9650','2012-12-27','14:20:00',1.96),('9650','2012-12-27','14:25:00',1.88),('9650','2012-12-27','14:30:00',1.65),('9650','2012-12-27','14:35:00',1.16),('9650','2012-12-27','14:40:00',1.59),('9650','2012-12-27','14:45:00',1.65),('9650','2012-12-27','14:50:00',1.58),('9650','2012-12-27','14:55:00',1.32),('9650','2012-12-27','15:00:00',1.2),('9650','2012-12-27','15:05:00',1.11),('9650','2012-12-27','15:10:00',1.04),('9650','2012-12-26','09:50:00',1),('9650','2012-12-26','10:05:00',1.19),('9650','2012-12-26','10:10:00',1.02),('9650','2012-12-26','10:45:00',1.02),('9650','2012-12-26','10:50:00',1.08),('9650','2012-12-26','10:55:00',1.17),('9650','2012-12-26','11:00:00',1.23),('9650','2012-12-26','11:05:00',1.41),('9650','2012-12-26','11:10:00',1.53),('9650','2012-12-26','11:50:00',1.56),('9650','2012-12-26','11:55:00',2.07),('9650','2012-12-26','12:00:00',2.25),('9650','2012-12-26','12:05:00',2.58),('9650','2012-12-26','12:10:00',2.82),('9650','2012-12-26','12:15:00',1.39),('9650','2012-12-26','12:20:00',1.58),('9650','2012-12-26','12:25:00',2.15),('9650','2012-12-26','12:30:00',2.3),('9650','2012-12-26','12:35:00',2.35),('9650','2012-12-26','12:40:00',2.49),('9650','2012-12-26','12:45:00',2.89),('9650','2012-12-26','12:50:00',2.32),('9650','2012-12-26','12:55:00',2.57),('9650','2012-12-26','13:00:00',2.6),('9650','2012-12-26','13:05:00',2.7),('9650','2012-12-26','13:10:00',2.61),('9650','2012-12-26','13:15:00',2.85),('9650','2012-12-26','13:20:00',2.68),('9650','2012-12-26','13:25:00',2.79),('9650','2012-12-26','13:30:00',2.6),('9650','2012-12-26','13:40:00',1.36),('9650','2012-12-26','14:00:00',1.87),('9650','2012-12-26','14:05:00',2.37),('9650','2012-12-26','14:10:00',2.51),('9650','2012-12-26','14:15:00',2.17),('9650','2012-12-26','14:20:00',1.97),('9650','2012-12-26','14:25:00',1.87),('9650','2012-12-26','14:30:00',1.85),('9650','2012-12-26','14:35:00',1.85),('9650','2012-12-26','14:40:00',1.69),('9650','2012-12-26','14:45:00',1.07),('9650','2012-12-26','14:55:00',1.27),('9650','2012-12-26','15:00:00',1.4),('9650','2012-12-26','15:05:00',1.11),('9650','2012-12-25','10:50:00',1.04),('9650','2012-12-25','10:55:00',1.14),('9650','2012-12-25','11:00:00',1.19),('9650','2012-12-25','11:05:00',1.23),('9650','2012-12-25','11:10:00',1.29),('9650','2012-12-25','11:15:00',1.33),('9650','2012-12-25','11:20:00',1.48),('9650','2012-12-25','11:25:00',1.67),('9650','2012-12-25','11:30:00',1.74),('9650','2012-12-25','11:35:00',1.81),('9650','2012-12-25','11:40:00',1.89),('9650','2012-12-25','11:45:00',1.96),('9650','2012-12-25','11:50:00',2.06),('9650','2012-12-25','11:55:00',2.16),('9650','2012-12-25','12:00:00',2.26),('9650','2012-12-25','12:05:00',2.34),('9650','2012-12-25','12:10:00',2.37),('9650','2012-12-25','12:15:00',2.39),('9650','2012-12-25','12:20:00',2.42),('9650','2012-12-25','12:25:00',2.49),('9650','2012-12-25','12:30:00',2.49),('9650','2012-12-25','12:35:00',2.53),('9650','2012-12-25','12:40:00',2.6),('9650','2012-12-25','12:45:00',2.55),('9650','2012-12-25','12:50:00',2.52),('9650','2012-12-25','12:55:00',2.22),('9650','2012-12-25','13:00:00',2.74),('9650','2012-12-25','13:05:00',2.08),('9650','2012-12-25','13:10:00',2.85),('9650','2012-12-25','13:15:00',2.82),('9650','2012-12-25','13:20:00',3.07),('9650','2012-12-25','13:25:00',3.11),('9650','2012-12-25','13:30:00',3.46),('9650','2012-12-25','13:35:00',3.47),('9650','2012-12-25','13:40:00',3.46),('9650','2012-12-25','13:45:00',3.46),('9650','2012-12-25','13:50:00',3.11),('9650','2012-12-25','13:55:00',2.76),('9650','2012-12-25','14:00:00',2.6),('9650','2012-12-25','14:05:00',2.8),('9650','2012-12-25','14:10:00',1.55),('9650','2012-12-24','10:05:00',1.02),('9650','2012-12-24','10:10:00',1.13),('9650','2012-12-24','10:15:00',1.15),('9650','2012-12-24','10:20:00',1.23),('9650','2012-12-24','10:25:00',1.27),('9650','2012-12-24','10:30:00',1.3),('9650','2012-12-24','10:35:00',1.26),('9650','2012-12-24','10:40:00',1.22),('9650','2012-12-24','10:45:00',1.22),('9650','2012-12-24','10:50:00',1.22),('9650','2012-12-24','10:55:00',1.23),('9650','2012-12-24','11:00:00',1.28),('9650','2012-12-24','11:05:00',1.33),('9650','2012-12-24','11:10:00',1.4),('9650','2012-12-24','11:15:00',1.36),('9650','2012-12-24','11:20:00',1.43),('9650','2012-12-24','11:25:00',1.58),('9650','2012-12-24','11:30:00',1.53),('9650','2012-12-24','11:35:00',1.5),('9650','2012-12-24','11:40:00',1.41),('9650','2012-12-24','11:45:00',1.48),('9650','2012-12-24','11:50:00',1.48),('9650','2012-12-24','11:55:00',1.57),('9650','2012-12-24','12:00:00',1.61),('9650','2012-12-24','12:05:00',1.42),('9650','2012-12-24','12:10:00',1.35),('9650','2012-12-24','12:15:00',1.37),('9650','2012-12-24','12:20:00',1.44),('9650','2012-12-24','12:25:00',1.43),('9650','2012-12-24','12:30:00',1.33),('9650','2012-12-24','12:35:00',1.27),('9650','2012-12-24','12:40:00',1.28),('9650','2012-12-24','12:45:00',1.17),('9650','2012-12-24','12:50:00',1.26),('9650','2012-12-24','12:55:00',1.28),('9650','2012-12-24','13:00:00',1.29),('9650','2012-12-24','13:05:00',1.43),('9650','2012-12-24','13:10:00',1.52),('9650','2012-12-24','13:15:00',1.59),('9650','2012-12-24','13:20:00',1.61),('9650','2012-12-24','13:25:00',1.49),('9650','2012-12-24','13:30:00',1.3),('9650','2012-12-24','13:35:00',1.13),('9650','2012-12-24','13:40:00',1.11),('9650','2012-12-24','14:50:00',1.22),('9650','2012-12-24','14:55:00',1.15),('9650','2012-12-24','15:00:00',1.14),('9650','2012-12-24','15:10:00',1.02),('9650','2012-12-24','15:15:00',1.05),('9650','2012-12-23','11:15:00',1.04),('9650','2012-12-23','11:20:00',1.06),('9650','2012-12-23','11:25:00',1.04),('9650','2012-12-23','11:30:00',1.14),('9650','2012-12-23','11:35:00',1.18),('9650','2012-12-23','11:40:00',1.14),('9650','2012-12-23','11:45:00',1.06),('9650','2012-12-23','11:55:00',1.02),('9650','2012-12-23','12:00:00',1.15),('9650','2012-12-23','12:05:00',1.29),('9650','2012-12-23','12:10:00',1.42),('9650','2012-12-23','12:15:00',1.35),('9650','2012-12-23','12:20:00',1.31),('9650','2012-12-23','12:25:00',1.35),('9650','2012-12-23','12:40:00',1.09),('9650','2012-12-23','12:45:00',1.19),('9650','2012-12-23','12:50:00',1.11),('9650','2012-12-23','12:55:00',1.08),('9650','2012-12-23','13:00:00',1.04),('9650','2012-12-22','10:45:00',1.06),('9650','2012-12-22','10:50:00',1.1),('9650','2012-12-22','10:55:00',1.12),('9650','2012-12-22','11:00:00',1.26),('9650','2012-12-22','11:05:00',1.36),('9650','2012-12-22','11:10:00',1.43),('9650','2012-12-22','11:15:00',1.55),('9650','2012-12-22','11:20:00',1.68),('9650','2012-12-22','11:25:00',1.61),('9650','2012-12-22','11:30:00',1.79),('9650','2012-12-22','11:35:00',1.97),('9650','2012-12-22','11:40:00',2.05),('9650','2012-12-22','11:45:00',2.11),('9650','2012-12-22','11:50:00',2.24),('9650','2012-12-22','11:55:00',2.16),('9650','2012-12-22','12:00:00',2.12),('9650','2012-12-22','12:05:00',2.21),('9650','2012-12-22','12:10:00',2.28),('9650','2012-12-22','12:15:00',1.91),('9650','2012-12-22','12:20:00',1.91),('9650','2012-12-22','12:25:00',1.47),('9650','2012-12-22','12:30:00',1.66),('9650','2012-12-22','12:35:00',1.57),('9650','2012-12-22','12:40:00',1.84),('9650','2012-12-22','12:45:00',1.36),('9650','2012-12-22','12:50:00',1.82),('9650','2012-12-22','12:55:00',2.5),('9650','2012-12-22','13:00:00',2.72),('9650','2012-12-22','13:05:00',2.42),('9650','2012-12-22','13:10:00',2.72),('9650','2012-12-22','13:15:00',2.03),('9650','2012-12-22','13:20:00',1.9),('9650','2012-12-22','13:25:00',1.72),('9650','2012-12-22','13:30:00',1.56),('9650','2012-12-22','13:35:00',1.58),('9650','2012-12-22','13:40:00',1.82),('9650','2012-12-22','13:45:00',1.89),('9650','2012-12-22','13:50:00',1.9),('9650','2012-12-22','13:55:00',1.8),('9650','2012-12-22','14:00:00',2.38),('9650','2012-12-22','14:05:00',2.15),('9650','2012-12-22','14:10:00',1.99),('9650','2012-12-22','14:15:00',2.05),('9650','2012-12-22','14:20:00',1.61),('9650','2012-12-22','14:25:00',1.32),('9650','2012-12-22','14:30:00',1.25),('9650','2012-12-22','14:35:00',1.57),('9650','2012-12-22','14:40:00',1.7),('9650','2012-12-22','14:45:00',1.74),('9650','2012-12-22','14:50:00',1.27),('9650','2014-04-30','08:25:00',1.07),('9650','2014-04-30','08:30:00',1.15),('9650','2014-04-30','08:35:00',1.26),('9650','2014-04-30','08:40:00',1.44),('9650','2014-04-30','08:45:00',1.7),('9650','2014-04-30','08:50:00',2.06),('9650','2014-04-30','08:55:00',2.86),('9650','2014-04-30','09:00:00',2.4),('9650','2014-04-30','09:05:00',1.68),('9650','2014-04-30','09:10:00',2.37),('9650','2014-04-30','09:15:00',2.3),('9650','2014-04-30','09:20:00',2.12),('9650','2014-04-30','09:25:00',3.18),('9650','2014-04-30','09:30:00',3.2),('9650','2014-04-30','09:35:00',3.33),('9650','2014-04-30','09:40:00',3.71),('9650','2014-04-30','09:45:00',2.92),('9650','2014-04-30','09:50:00',3.23),('9650','2014-04-30','09:55:00',3.02),('9650','2014-04-30','10:00:00',2.74),('9650','2014-04-30','10:05:00',2.49),('9650','2014-04-30','10:10:00',4.86),('9650','2014-04-30','10:15:00',3.42),('9650','2014-04-30','10:20:00',2.36),('9650','2014-04-30','10:25:00',2.25),('9650','2014-04-30','10:30:00',4.3),('9650','2014-04-30','10:35:00',5.45),('9650','2014-04-30','10:40:00',3.64),('9650','2014-04-30','10:45:00',5.35),('9650','2014-04-30','10:50:00',5.57),('9650','2014-04-30','10:55:00',6.22),('9650','2014-04-30','11:00:00',5.4),('9650','2014-04-30','11:05:00',5.5),('9650','2014-04-30','11:10:00',4.18),('9650','2014-04-30','11:15:00',1.52),('9650','2014-04-30','11:20:00',3.72),('9650','2014-04-30','11:25:00',6.68),('9650','2014-04-30','11:30:00',6.49),('9650','2014-04-30','11:35:00',6.78),('9650','2014-04-30','11:40:00',5.47),('9650','2014-04-30','11:45:00',1.99),('9650','2014-04-30','11:50:00',6.69),('9650','2014-04-30','11:55:00',5.52),('9650','2014-04-30','12:00:00',1.72),('9650','2014-04-30','12:05:00',6.28),('9650','2014-04-30','12:10:00',5.89),('9650','2014-04-30','12:15:00',7.13),('9650','2014-04-30','12:20:00',6.23),('9650','2014-04-30','12:25:00',7.34),('9650','2014-04-30','12:30:00',7.38),('9650','2014-04-30','12:35:00',7.32),('9650','2014-04-30','12:40:00',7.59),('9650','2014-04-30','12:45:00',4.73),('9650','2014-04-30','12:50:00',4.76),('9650','2014-04-30','12:55:00',7.94),('9650','2014-04-30','13:00:00',8.12),('9650','2014-04-30','13:05:00',7.72),('9650','2014-04-30','13:10:00',7.86),('9650','2014-04-30','13:15:00',6.8),('9650','2014-04-30','13:20:00',7.91),('9650','2014-04-30','13:25:00',3.31),('9650','2014-04-30','13:30:00',5.47),('9650','2014-04-30','13:35:00',7.8),('9650','2014-04-30','13:40:00',8.08),('9650','2014-04-30','13:45:00',8.23),('9650','2014-04-30','13:50:00',8.69),('9650','2014-04-30','13:55:00',8.24),('9650','2014-04-30','14:00:00',7.87),('9650','2014-04-30','14:05:00',7.9),('9650','2014-04-30','14:10:00',7.62),('9650','2014-04-30','14:15:00',7.6),('9650','2014-04-30','14:20:00',7.46),('9650','2014-04-30','14:25:00',7.58),('9650','2014-04-30','14:30:00',7.29),('9650','2014-04-30','14:35:00',7.21),('9650','2014-04-30','14:40:00',7.51),('9650','2014-04-30','14:45:00',7.94),('9650','2014-04-30','14:50:00',7.92),('9650','2014-04-30','14:55:00',7.56),('9650','2014-04-30','15:00:00',8.04),('9650','2014-04-30','15:05:00',7.95),('9650','2014-04-30','15:10:00',6.64),('9650','2014-04-30','15:15:00',7.37),('9650','2014-04-30','15:20:00',7.47),('9650','2014-04-30','15:25:00',7.36),('9650','2014-04-30','15:30:00',7.19),('9650','2014-04-30','15:35:00',7.14),('9650','2014-04-30','15:40:00',7.08),('9650','2014-04-30','15:45:00',6.8),('9650','2014-04-30','15:50:00',7.02),('9650','2014-04-30','15:55:00',6.83),('9650','2014-04-30','16:00:00',6.81),('9650','2014-04-30','16:05:00',6.89),('9650','2014-04-30','16:10:00',6.59),('9650','2014-04-30','16:15:00',6.61),('9650','2014-04-30','16:20:00',6.13),('9650','2014-04-30','16:25:00',5.75),('9650','2014-04-30','16:30:00',6.16),('9650','2014-04-30','16:35:00',6.29),('9650','2014-04-30','16:40:00',6),('9650','2014-04-30','16:45:00',5.08),('9650','2014-04-30','16:50:00',4.73),('9650','2014-04-30','16:55:00',5.08),('9650','2014-04-30','17:00:00',5.35),('9650','2014-04-30','17:05:00',5.24),('9650','2014-04-30','17:10:00',5.74),('9650','2014-04-30','17:15:00',5.45),('9650','2014-04-30','17:20:00',5.34),('9650','2014-04-30','17:25:00',5.23),('9650','2014-04-30','17:30:00',5.1),('9650','2014-04-30','17:35:00',4.99),('9650','2014-04-30','17:40:00',4.87),('9650','2014-04-30','17:45:00',4.76),('9650','2014-04-30','17:50:00',4.6),('9650','2014-04-30','17:55:00',4.49),('9650','2014-04-30','18:00:00',4.48),('9650','2014-04-30','18:05:00',4.25),('9650','2014-04-30','18:10:00',3.9),('9650','2014-04-30','18:15:00',3.83),('9650','2014-04-30','18:20:00',3.72),('9650','2014-04-30','18:25:00',3.57),('9650','2014-04-30','18:30:00',3.41),('9650','2014-04-30','18:35:00',3.01),('9650','2014-04-30','18:40:00',2.99),('9650','2014-04-30','18:45:00',2.82),('9650','2014-04-30','18:50:00',2.63),('9650','2014-04-30','18:55:00',2.47),('9650','2014-04-30','19:00:00',2.2),('9650','2014-04-30','19:05:00',1.98),('9650','2014-04-30','19:10:00',1.79),('9650','2014-04-30','19:15:00',1.56),('9650','2014-04-30','19:20:00',1.36),('9650','2014-04-30','19:25:00',1.17),('9650','2012-12-21','09:30:00',1.01),('9650','2012-12-21','09:35:00',1.08),('9650','2012-12-21','09:40:00',1.04),('9650','2012-12-21','09:50:00',1.06),('9650','2012-12-21','09:55:00',1.13),('9650','2012-12-21','10:00:00',1.17),('9650','2012-12-21','10:05:00',1.2),('9650','2012-12-21','10:10:00',1.22),('9650','2012-12-21','10:15:00',1.19),('9650','2012-12-21','10:20:00',1.21),('9650','2012-12-21','10:25:00',1.4),('9650','2012-12-21','10:30:00',1.47),('9650','2012-12-21','10:35:00',1.56),('9650','2012-12-21','10:40:00',1.53),('9650','2012-12-21','10:45:00',1.51),('9650','2012-12-21','10:50:00',1.49),('9650','2012-12-21','10:55:00',1.55),('9650','2012-12-21','11:00:00',1.12),('9650','2012-12-21','11:20:00',1.03),('9650','2012-12-21','11:30:00',1.07),('9650','2012-12-21','11:35:00',1.43),('9650','2012-12-21','11:40:00',2.3),('9650','2012-12-21','11:45:00',2.08),('9650','2012-12-21','11:50:00',2.3),('9650','2012-12-21','11:55:00',1.86),('9650','2012-12-21','12:00:00',1.91),('9650','2012-12-21','12:05:00',1.09),('9650','2012-12-21','12:10:00',1.2),('9650','2012-12-21','12:15:00',1.23),('9650','2012-12-21','12:20:00',1.04),('9650','2012-12-21','12:25:00',1.05),('9650','2012-12-21','12:30:00',1.19),('9650','2012-12-21','12:35:00',1.3),('9650','2012-12-21','12:40:00',1.91),('9650','2012-12-21','12:45:00',3.22),('9650','2012-12-21','12:50:00',3.16),('9650','2012-12-21','12:55:00',2.88),('9650','2012-12-21','13:00:00',3.29),('9650','2012-12-21','13:05:00',3.16),('9650','2012-12-21','13:10:00',3.6),('9650','2012-12-21','13:15:00',3.81),('9650','2012-12-21','13:20:00',3.76),('9650','2012-12-21','13:25:00',3.63),('9650','2012-12-21','13:30:00',3.27),('9650','2012-12-21','13:35:00',3.37),('9650','2012-12-21','13:40:00',2.15),('9650','2012-12-21','13:45:00',1.36),('9650','2012-12-21','13:50:00',1.58),('9650','2012-12-21','13:55:00',1.48),('9650','2012-12-21','14:00:00',1.77),('9650','2012-12-21','14:05:00',1.61),('9650','2012-12-21','14:10:00',1.91),('9650','2012-12-21','14:15:00',1.97),('9650','2012-12-21','14:20:00',1.47),('9650','2012-12-21','14:55:00',1.05),('9650','2012-12-21','15:00:00',1.33),('9650','2014-03-15','08:10:00',1.02),('9650','2014-03-15','08:15:00',1.04),('9650','2014-03-15','08:20:00',1.09),('9650','2014-03-15','08:25:00',1.13),('9650','2014-03-15','08:30:00',1.18),('9650','2014-03-15','08:35:00',1.24),('9650','2014-03-15','08:40:00',1.33),('9650','2014-03-15','08:45:00',1.44),('9650','2014-03-15','08:50:00',1.54),('9650','2014-03-15','08:55:00',1.6),('9650','2014-03-15','09:00:00',1.61),('9650','2014-03-15','09:05:00',1.69),('9650','2014-03-15','09:10:00',1.85),('9650','2014-03-15','09:15:00',2.03),('9650','2014-03-15','09:20:00',2.13),('9650','2014-03-15','09:25:00',2.16),('9650','2014-03-15','09:30:00',2.23),('9650','2014-03-15','09:35:00',2.31),('9650','2014-03-15','09:40:00',2.33),('9650','2014-03-15','09:45:00',2.5),('9650','2014-03-15','09:50:00',2.64),('9650','2014-03-15','09:55:00',2.7),('9650','2014-03-15','10:00:00',2.84),('9650','2014-03-15','10:05:00',2.91),('9650','2014-03-15','10:10:00',3.04),('9650','2014-03-15','10:15:00',3.18),('9650','2014-03-15','10:20:00',3.24),('9650','2014-03-15','10:25:00',3.37),('9650','2014-03-15','10:30:00',3.43),('9650','2014-03-15','10:35:00',3.5),('9650','2014-03-15','10:40:00',3.61),('9650','2014-03-15','10:45:00',2.85),('9650','2014-03-15','10:50:00',3.51),('9650','2014-03-15','10:55:00',3.82),('9650','2014-03-15','11:00:00',4.05),('9650','2014-03-15','11:05:00',4.16),('9650','2014-03-15','11:10:00',4.28),('9650','2014-03-15','11:15:00',4.33),('9650','2014-03-15','11:20:00',4.37),('9650','2014-03-15','11:25:00',4.44),('9650','2014-03-15','11:30:00',4.54),('9650','2014-03-15','11:35:00',4.64),('9650','2014-03-15','11:40:00',4.74),('9650','2014-03-15','11:45:00',4.75),('9650','2014-03-15','11:50:00',4.74),('9650','2014-03-15','11:55:00',4.71),('9650','2014-03-15','12:00:00',4.67),('9650','2014-03-15','12:05:00',4.88),('9650','2014-03-15','12:10:00',4.9),('9650','2014-03-15','12:15:00',4.83),('9650','2014-03-15','12:20:00',4.8),('9650','2014-03-15','12:25:00',4.92),('9650','2014-03-15','12:30:00',5.05),('9650','2014-03-15','12:35:00',5.14),('9650','2014-03-15','12:40:00',5.17),('9650','2014-03-15','12:45:00',5.15),('9650','2014-03-15','12:50:00',5.18),('9650','2014-03-15','12:55:00',5.19),('9650','2014-03-15','13:00:00',5.09),('9650','2014-03-15','13:05:00',5.25),('9650','2014-03-15','13:10:00',5.05),('9650','2014-03-15','13:15:00',5.11),('9650','2014-03-15','13:20:00',5.03),('9650','2014-03-15','13:25:00',5.01),('9650','2014-03-15','13:30:00',5.16),('9650','2014-03-15','13:35:00',5.06),('9650','2014-03-15','13:40:00',5.2),('9650','2014-03-15','13:45:00',5.19),('9650','2014-03-15','13:50:00',5.16),('9650','2014-03-15','13:55:00',5.13),('9650','2014-03-15','14:00:00',4.84),('9650','2014-03-15','14:05:00',4.75),('9650','2014-03-15','14:10:00',4.74),('9650','2014-03-15','14:15:00',4.66),('9650','2014-03-15','14:20:00',4.68),('9650','2014-03-15','14:25:00',4.66),('9650','2014-03-15','14:30:00',4.63),('9650','2014-03-15','14:35:00',4.49),('9650','2014-03-15','14:40:00',4.44),('9650','2014-03-15','14:45:00',4.39),('9650','2014-03-15','14:50:00',4.13),('9650','2014-03-15','14:55:00',4.14),('9650','2014-03-15','15:00:00',4.26),('9650','2014-03-15','15:05:00',4.04),('9650','2014-03-15','15:10:00',3.74),('9650','2014-03-15','15:15:00',3.69),('9650','2014-03-15','15:20:00',3.2),('9650','2014-03-15','15:25:00',3.6),('9650','2014-03-15','15:30:00',3.35),('9650','2014-03-15','15:35:00',3.16),('9650','2014-03-15','15:40:00',2.51),('9650','2014-03-15','15:45:00',2.49),('9650','2014-03-15','15:50:00',2.81),('9650','2014-03-15','15:55:00',2.65),('9650','2014-03-15','16:00:00',2.33),('9650','2014-03-15','16:05:00',2.85),('9650','2014-03-15','16:10:00',2.98),('9650','2014-03-15','16:15:00',3),('9650','2014-03-15','16:20:00',2.75),('9650','2014-03-15','16:25:00',2.77),('9650','2014-03-15','16:30:00',2.82),('9650','2014-03-15','16:35:00',2.6),('9650','2014-03-15','16:40:00',2.31),('9650','2014-03-15','16:45:00',2.09),('9650','2014-03-15','16:50:00',1.98),('9650','2014-03-15','16:55:00',1.68),('9650','2014-03-15','17:00:00',1.36),('9650','2014-03-15','17:05:00',1.36),('9650','2014-03-15','17:10:00',1.19),('9650','2014-03-14','08:20:00',1.06),('9650','2014-03-14','08:25:00',1.11),('9650','2014-03-14','08:30:00',1.18),('9650','2014-03-14','08:35:00',1.26),('9650','2014-03-14','08:40:00',1.34),('9650','2014-03-14','08:45:00',1.42),('9650','2014-03-14','08:50:00',1.51),('9650','2014-03-14','08:55:00',1.59),('9650','2014-03-14','09:00:00',1.66),('9650','2014-03-14','09:05:00',1.75),('9650','2014-03-14','09:10:00',1.85),('9650','2014-03-14','09:15:00',1.94),('9650','2014-03-14','09:20:00',2.05),('9650','2014-03-14','09:25:00',2.14),('9650','2014-03-14','09:30:00',2.24),('9650','2014-03-14','09:35:00',2.32),('9650','2014-03-14','09:40:00',2.43),('9650','2014-03-14','09:45:00',2.51),('9650','2014-03-14','09:50:00',2.6),('9650','2014-03-14','09:55:00',2.69),('9650','2014-03-14','10:00:00',2.79),('9650','2014-03-14','10:05:00',2.88),('9650','2014-03-14','10:10:00',2.99),('9650','2014-03-14','10:15:00',3.11),('9650','2014-03-14','10:20:00',3.23),('9650','2014-03-14','10:25:00',3.3),('9650','2014-03-14','10:30:00',3.38),('9650','2014-03-14','10:35:00',3.45),('9650','2014-03-14','10:40:00',3.53),('9650','2014-03-14','10:45:00',3.68),('9650','2014-03-14','10:50:00',3.69),('9650','2014-03-14','10:55:00',3.77),('9650','2014-03-14','11:00:00',3.87),('9650','2014-03-14','11:05:00',3.96),('9650','2014-03-14','11:10:00',4.02),('9650','2014-03-14','11:15:00',4.15),('9650','2014-03-14','11:20:00',4.28),('9650','2014-03-14','11:25:00',4.43),('9650','2014-03-14','11:30:00',4.4),('9650','2014-03-14','11:35:00',4.49),('9650','2014-03-14','11:40:00',4.54),('9650','2014-03-14','11:45:00',4.72),('9650','2014-03-14','11:50:00',4.62),('9650','2014-03-14','11:55:00',4.63),('9650','2014-03-14','12:00:00',4.69),('9650','2014-03-14','12:05:00',4.73),('9650','2014-03-14','12:10:00',4.86),('9650','2014-03-14','12:15:00',4.97),('9650','2014-03-14','12:20:00',4.91),('9650','2014-03-14','12:25:00',5.02),('9650','2014-03-14','12:30:00',5.11),('9650','2014-03-14','12:35:00',5.2),('9650','2014-03-14','12:40:00',5.17),('9650','2014-03-14','12:45:00',5.18),('9650','2014-03-14','12:50:00',5.27),('9650','2014-03-14','12:55:00',5.21),('9650','2014-03-14','13:00:00',5.26),('9650','2014-03-14','13:05:00',5.26),('9650','2014-03-14','13:10:00',5.21),('9650','2014-03-14','13:15:00',5.22),('9650','2014-03-14','13:20:00',5.23),('9650','2014-03-14','13:25:00',5.25),('9650','2014-03-14','13:30:00',5.25),('9650','2014-03-14','13:35:00',5.28),('9650','2014-03-14','13:40:00',5.25),('9650','2014-03-14','13:45:00',5.23),('9650','2014-03-14','13:50:00',5.16),('9650','2014-03-14','13:55:00',5.12),('9650','2014-03-14','14:00:00',5.01),('9650','2014-03-14','14:05:00',5.01),('9650','2014-03-14','14:10:00',5),('9650','2014-03-14','14:15:00',4.94),('9650','2014-03-14','14:20:00',4.87),('9650','2014-03-14','14:25:00',4.78),('9650','2014-03-14','14:30:00',4.67),('9650','2014-03-14','14:35:00',4.57),('9650','2014-03-14','14:40:00',4.51),('9650','2014-03-14','14:45:00',4.42),('9650','2014-03-14','14:50:00',4.3),('9650','2014-03-14','14:55:00',4.25),('9650','2014-03-14','15:00:00',4.12),('9650','2014-03-14','15:05:00',4),('9650','2014-03-14','15:10:00',3.93),('9650','2014-03-14','15:15:00',3.92),('9650','2014-03-14','15:20:00',3.8),('9650','2014-03-14','15:25:00',3.75),('9650','2014-03-14','15:30:00',3.69),('9650','2014-03-14','15:35:00',3.57),('9650','2014-03-14','15:40:00',3.51),('9650','2014-03-14','15:45:00',3.48),('9650','2014-03-14','15:50:00',3.41),('9650','2014-03-14','15:55:00',3.3),('9650','2014-03-14','16:00:00',3.21),('9650','2014-03-14','16:05:00',3),('9650','2014-03-14','16:10:00',2.91),('9650','2014-03-14','16:15:00',2.73),('9650','2014-03-14','16:20:00',2.66),('9650','2014-03-14','16:25:00',2.46),('9650','2014-03-14','16:30:00',2.42),('9650','2014-03-14','16:35:00',2.27),('9650','2014-03-14','16:40:00',2.13),('9650','2014-03-14','16:45:00',2.02),('9650','2014-03-14','16:50:00',1.82),('9650','2014-03-14','16:55:00',1.71),('9650','2014-03-14','17:00:00',1.58),('9650','2014-03-14','17:05:00',1.47),('9650','2014-03-14','17:10:00',1.32),('9650','2014-03-14','17:15:00',1.17),('9650','2014-03-14','17:20:00',1.01),('9650','2014-03-13','07:50:00',1.01),('9650','2014-03-13','07:55:00',1.09),('9650','2014-03-13','08:00:00',1.16),('9650','2014-03-13','08:05:00',1.22),('9650','2014-03-13','08:10:00',1.26),('9650','2014-03-13','08:15:00',1.3),('9650','2014-03-13','08:20:00',1.33),('9650','2014-03-13','08:25:00',1.46),('9650','2014-03-13','08:30:00',1.58),('9650','2014-03-13','08:35:00',1.62),('9650','2014-03-13','08:40:00',1.62),('9650','2014-03-13','08:45:00',1.56),('9650','2014-03-13','08:50:00',1.56),('9650','2014-03-13','08:55:00',1.63),('9650','2014-03-13','09:00:00',1.74),('9650','2014-03-13','09:05:00',1.91),('9650','2014-03-13','09:10:00',2.07),('9650','2014-03-13','09:15:00',2.14),('9650','2014-03-13','09:20:00',2.13),('9650','2014-03-13','09:25:00',2.16),('9650','2014-03-13','09:30:00',2.15),('9650','2014-03-13','09:35:00',2.36),('9650','2014-03-13','09:40:00',2.74),('9650','2014-03-13','09:45:00',3.07),('9650','2014-03-13','09:50:00',3.49),('9650','2014-03-13','09:55:00',3.64),('9650','2014-03-13','10:00:00',3.75),('9650','2014-03-13','10:05:00',3.74),('9650','2014-03-13','10:10:00',3.66),('9650','2014-03-13','10:15:00',3.57),('9650','2014-03-13','10:20:00',3.53),('9650','2014-03-13','10:25:00',3.43),('9650','2014-03-13','10:30:00',3.46),('9650','2014-03-13','10:35:00',3.64),('9650','2014-03-13','10:40:00',3.82),('9650','2014-03-13','10:45:00',3.38),('9650','2014-03-13','10:50:00',2.33),('9650','2014-03-13','10:55:00',3.11),('9650','2014-03-13','11:00:00',3.93),('9650','2014-03-13','11:05:00',4.25),('9650','2014-03-13','11:10:00',4.68),('9650','2014-03-13','11:15:00',4.8),('9650','2014-03-13','11:20:00',4.7),('9650','2014-03-13','11:25:00',4.59),('9650','2014-03-13','11:30:00',4.61),('9650','2014-03-13','11:35:00',4.69),('9650','2014-03-13','11:40:00',4.68),('9650','2014-03-13','11:45:00',4.82),('9650','2014-03-13','11:50:00',4.94),('9650','2014-03-13','11:55:00',5.08),('9650','2014-03-13','12:00:00',5.14),('9650','2014-03-13','12:05:00',5.1),('9650','2014-03-13','12:10:00',4.86),('9650','2014-03-13','12:15:00',4.66),('9650','2014-03-13','12:20:00',3.94),('9650','2014-03-13','12:25:00',3.44),('9650','2014-03-13','12:30:00',3.22),('9650','2014-03-13','12:35:00',2.67),('9650','2014-03-13','12:40:00',3.25),('9650','2014-03-13','12:45:00',3.44),('9650','2014-03-13','12:50:00',4.39),('9650','2014-03-13','12:55:00',4.65),('9650','2014-03-13','13:00:00',3.12),('9650','2014-03-13','13:05:00',2.87),('9650','2014-03-13','13:20:00',3.86),('9650','2014-03-13','13:25:00',4.02),('9650','2014-03-13','13:30:00',3.7),('9650','2014-03-13','13:35:00',3.3),('9650','2014-03-13','13:40:00',3.25),('9650','2014-03-13','13:45:00',3.37),('9650','2014-03-13','13:50:00',3.4),('9650','2014-03-13','13:55:00',3.34),('9650','2014-03-13','14:00:00',3.86),('9650','2014-03-13','14:05:00',4.24),('9650','2014-03-13','14:10:00',4.21),('9650','2014-03-13','14:15:00',4.59),('9650','2014-03-13','14:20:00',4.62),('9650','2014-03-13','14:25:00',4.36),('9650','2014-03-13','14:30:00',4.21),('9650','2014-03-13','14:35:00',4),('9650','2014-03-13','14:40:00',3.36),('9650','2014-03-13','14:45:00',2.8),('9650','2014-03-13','14:50:00',2.57),('9650','2014-03-13','14:55:00',2.4),('9650','2014-03-13','15:00:00',2.21),('9650','2014-03-13','15:05:00',2.19),('9650','2014-03-13','15:10:00',2.08),('9650','2014-03-13','15:15:00',2.04),('9650','2014-03-13','15:20:00',2.16),('9650','2014-03-13','15:25:00',2.35),('9650','2014-03-13','15:30:00',2.58),('9650','2014-03-13','15:35:00',2.81),('9650','2014-03-13','15:40:00',2.6),('9650','2014-03-13','15:45:00',2.25),('9650','2014-03-13','15:50:00',1.99),('9650','2014-03-13','15:55:00',2.05),('9650','2014-03-13','16:00:00',1.94),('9650','2014-03-13','16:05:00',1.92),('9650','2014-03-13','16:10:00',1.63),('9650','2014-03-13','16:15:00',1.42),('9650','2014-03-13','16:20:00',1.25),('9650','2014-03-13','16:25:00',1.14),('9650','2014-03-13','16:30:00',1.09),('9650','2014-03-13','16:35:00',1.03),('9650','2014-03-12','08:45:00',1.02),('9650','2014-03-12','08:50:00',1.11),('9650','2014-03-12','08:55:00',1.21),('9650','2014-03-12','09:00:00',1.31),('9650','2014-03-12','09:05:00',1.43),('9650','2014-03-12','09:10:00',1.55),('9650','2014-03-12','09:15:00',1.67),('9650','2014-03-12','09:20:00',1.78),('9650','2014-03-12','09:25:00',1.91),('9650','2014-03-12','09:30:00',2.04),('9650','2014-03-12','09:35:00',2.17),('9650','2014-03-12','09:40:00',2.31),('9650','2014-03-12','09:45:00',2.44),('9650','2014-03-12','09:50:00',2.57),('9650','2014-03-12','09:55:00',2.7),('9650','2014-03-12','10:00:00',2.83),('9650','2014-03-12','10:05:00',2.95),('9650','2014-03-12','10:10:00',3.07),('9650','2014-03-12','10:15:00',3.2),('9650','2014-03-12','10:20:00',3.3),('9650','2014-03-12','10:25:00',3.4),('9650','2014-03-12','10:30:00',3.53),('9650','2014-03-12','10:35:00',3.63),('9650','2014-03-12','10:40:00',3.75),('9650','2014-03-12','10:45:00',3.84),('9650','2014-03-12','10:50:00',3.94),('9650','2014-03-12','10:55:00',4.05),('9650','2014-03-12','11:00:00',4.14),('9650','2014-03-12','11:05:00',4.22),('9650','2014-03-12','11:10:00',4.3),('9650','2014-03-12','11:15:00',4.41),('9650','2014-03-12','11:20:00',4.52),('9650','2014-03-12','11:25:00',4.6),('9650','2014-03-12','11:30:00',4.62),('9650','2014-03-12','11:35:00',4.7),('9650','2014-03-12','11:40:00',4.77),('9650','2014-03-12','11:45:00',4.83),('9650','2014-03-12','11:50:00',4.92),('9650','2014-03-12','11:55:00',4.99),('9650','2014-03-12','12:00:00',5.09),('9650','2014-03-12','12:05:00',5.13),('9650','2014-03-12','12:10:00',5.11),('9650','2014-03-12','12:15:00',5.16),('9650','2014-03-12','12:20:00',5.17),('9650','2014-03-12','12:25:00',5.19),('9650','2014-03-12','12:30:00',5.24),('9650','2014-03-12','12:35:00',5.28),('9650','2014-03-12','12:40:00',5.28),('9650','2014-03-12','12:45:00',5.32),('9650','2014-03-12','12:50:00',5.31),('9650','2014-03-12','12:55:00',5.34),('9650','2014-03-12','13:00:00',5.33),('9650','2014-03-12','13:05:00',5.28),('9650','2014-03-12','13:10:00',5.18),('9650','2014-03-12','13:15:00',5.23),('9650','2014-03-12','13:20:00',5.26),('9650','2014-03-12','13:25:00',5.2),('9650','2014-03-12','13:30:00',5.19),('9650','2014-03-12','13:35:00',5.18),('9650','2014-03-12','13:40:00',5.15),('9650','2014-03-12','13:45:00',5.16),('9650','2014-03-12','13:50:00',5.13),('9650','2014-03-12','13:55:00',5.08),('9650','2014-03-12','14:00:00',4.98),('9650','2014-03-12','14:05:00',4.78),('9650','2014-03-12','14:10:00',4.74),('9650','2014-03-12','14:15:00',4.78),('9650','2014-03-12','14:20:00',4.69),('9650','2014-03-12','14:25:00',4.61),('9650','2014-03-12','14:30:00',4.49),('9650','2014-03-12','14:35:00',4.41),('9650','2014-03-12','14:40:00',4.24),('9650','2014-03-12','14:45:00',4.18),('9650','2014-03-12','14:50:00',4.18),('9650','2014-03-12','14:55:00',4.13),('9650','2014-03-12','15:00:00',3.95),('9650','2014-03-12','15:05:00',3.82),('9650','2014-03-12','15:10:00',3.85),('9650','2014-03-12','15:15:00',3.85),('9650','2014-03-12','15:20:00',3.74),('9650','2014-03-12','15:25:00',3.66),('9650','2014-03-12','15:30:00',3.52),('9650','2014-03-12','15:35:00',3.51),('9650','2014-03-12','15:40:00',3.48),('9650','2014-03-12','15:45:00',3.39),('9650','2014-03-12','15:50:00',3.39),('9650','2014-03-12','15:55:00',3.28),('9650','2014-03-12','16:00:00',3.17),('9650','2014-03-12','16:05:00',3.03),('9650','2014-03-12','16:10:00',2.9),('9650','2014-03-12','16:15:00',2.77),('9650','2014-03-12','16:20:00',2.71),('9650','2014-03-12','16:25:00',2.65),('9650','2014-03-12','16:30:00',2.56),('9650','2014-03-12','16:35:00',2.45),('9650','2014-03-12','16:40:00',2.3),('9650','2014-03-12','16:45:00',2.18),('9650','2014-03-12','16:50:00',2.07),('9650','2014-03-12','16:55:00',1.92),('9650','2014-03-12','17:00:00',1.79),('9650','2014-03-12','17:05:00',1.65),('9650','2014-03-12','17:10:00',1.51),('9650','2014-03-12','17:15:00',1.37),('9650','2014-03-12','17:20:00',1.23),('9650','2014-04-29','08:25:00',1.08),('9650','2014-04-29','08:30:00',1.19),('9650','2014-04-29','08:35:00',1.3),('9650','2014-04-29','08:40:00',1.44),('9650','2014-04-29','08:45:00',1.57),('9650','2014-04-29','08:50:00',1.76),('9650','2014-04-29','08:55:00',2.02),('9650','2014-04-29','09:00:00',2.35),('9650','2014-04-29','09:05:00',2.53),('9650','2014-04-29','09:10:00',2.92),('9650','2014-04-29','09:15:00',2.42),('9650','2014-04-29','09:20:00',2.18),('9650','2014-04-29','09:25:00',2.5),('9650','2014-04-29','09:30:00',1.73),('9650','2014-04-29','09:35:00',3.14),('9650','2014-04-29','09:40:00',3.38),('9650','2014-04-29','09:45:00',2.88),('9650','2014-04-29','09:50:00',2.08),('9650','2014-04-29','09:55:00',3.41),('9650','2014-04-29','10:00:00',4.41),('9650','2014-04-29','10:05:00',2.96),('9650','2014-04-29','10:10:00',3.4),('9650','2014-04-29','10:15:00',3.93),('9650','2014-04-29','10:20:00',2.74),('9650','2014-04-29','10:25:00',2.69),('9650','2014-04-29','10:30:00',3.03),('9650','2014-04-29','10:35:00',3.39),('9650','2014-04-29','10:40:00',3.35),('9650','2014-04-29','10:45:00',2.71),('9650','2014-04-29','10:50:00',2.93),('9650','2014-04-29','10:55:00',5.66),('9650','2014-04-29','11:00:00',5.78),('9650','2014-04-29','11:05:00',4.95),('9650','2014-04-29','11:10:00',4.64),('9650','2014-04-29','11:15:00',3.65),('9650','2014-04-29','11:20:00',3.21),('9650','2014-04-29','11:25:00',3.88),('9650','2014-04-29','11:30:00',3.47),('9650','2014-04-29','11:35:00',5.18),('9650','2014-04-29','11:40:00',5.02),('9650','2014-04-29','11:45:00',4.18),('9650','2014-04-29','11:50:00',5.92),('9650','2014-04-29','11:55:00',5.43),('9650','2014-04-29','12:00:00',5),('9650','2014-04-29','12:05:00',2.45),('9650','2014-04-29','12:10:00',2.33),('9650','2014-04-29','12:15:00',3.15),('9650','2014-04-29','12:20:00',2.93),('9650','2014-04-29','12:25:00',2.52),('9650','2014-04-29','12:30:00',3.16),('9650','2014-04-29','12:35:00',2.66),('9650','2014-04-29','12:40:00',2.35),('9650','2014-04-29','12:45:00',2.33),('9650','2014-04-29','13:00:00',5.46),('9650','2014-04-29','13:05:00',3.88),('9650','2014-04-29','13:10:00',6.67),('9650','2014-04-29','13:15:00',3.36),('9650','2014-04-29','13:20:00',3.75),('9650','2014-04-29','13:25:00',5.3),('9650','2014-04-29','13:30:00',3.42),('9650','2014-04-29','13:35:00',3.66),('9650','2014-04-29','13:40:00',6.26),('9650','2014-04-29','13:45:00',5.74),('9650','2014-04-29','13:50:00',4.77),('9650','2014-04-29','13:55:00',6.99),('9650','2014-04-29','14:00:00',3.7),('9650','2014-04-29','14:05:00',3.31),('9650','2014-04-29','14:10:00',2.91),('9650','2014-04-29','14:15:00',3.39),('9650','2014-04-29','14:20:00',5.75),('9650','2014-04-29','14:25:00',6.67),('9650','2014-04-29','14:30:00',7.38),('9650','2014-04-29','14:35:00',6.42),('9650','2014-04-29','14:40:00',3.62),('9650','2014-04-29','14:45:00',2.45),('9650','2014-04-29','14:50:00',3.08),('9650','2014-04-29','14:55:00',3.33),('9650','2014-04-29','15:00:00',2.75),('9650','2014-04-29','15:15:00',1.9),('9650','2014-04-29','15:20:00',2.33),('9650','2014-04-29','15:25:00',2.62),('9650','2014-04-29','15:30:00',3.1),('9650','2014-04-29','15:35:00',6.39),('9650','2014-04-29','15:40:00',8.58),('9650','2014-04-29','15:45:00',6.88),('9650','2014-04-29','15:50:00',8.29),('9650','2014-04-29','15:55:00',5.32),('9650','2014-04-29','16:00:00',2.9),('9650','2014-04-29','16:05:00',4.26),('9650','2014-04-29','16:10:00',3.87),('9650','2014-04-29','16:15:00',6.13),('9650','2014-04-29','16:20:00',3.25),('9650','2014-04-29','16:25:00',3.7),('9650','2014-04-29','16:30:00',4),('9650','2014-04-29','16:35:00',2.4),('9650','2014-04-29','16:40:00',5.09),('9650','2014-04-29','16:45:00',3.21),('9650','2014-04-29','16:50:00',5.09),('9650','2014-04-29','16:55:00',6.02),('9650','2014-04-29','17:00:00',4.15),('9650','2014-04-29','17:05:00',4.34),('9650','2014-04-29','17:10:00',2.07),('9650','2014-04-29','17:15:00',2.17),('9650','2014-04-29','17:20:00',2.25),('9650','2014-04-29','17:25:00',1.36),('9650','2014-04-29','17:30:00',1.44),('9650','2014-04-29','17:35:00',1.97),('9650','2014-04-29','17:40:00',2.04),('9650','2014-04-29','17:45:00',1.39),('9650','2014-04-29','17:50:00',1.57),('9650','2014-04-29','17:55:00',1.43),('9650','2014-04-29','18:00:00',1.01),('9650','2014-04-29','18:35:00',1.2),('9650','2014-04-29','18:40:00',1.09),('9650','2014-04-29','18:45:00',1.14),('9650','2014-04-28','09:40:00',1),('9650','2014-04-28','09:45:00',1.42),('9650','2014-04-28','09:50:00',1.78),('9650','2014-04-28','09:55:00',1.86),('9650','2014-04-28','10:00:00',1.75),('9650','2014-04-28','10:05:00',2.73),('9650','2014-04-28','10:10:00',4.5),('9650','2014-04-28','10:15:00',3.76),('9650','2014-04-28','10:20:00',3.29),('9650','2014-04-28','10:25:00',4.48),('9650','2014-04-28','10:30:00',4.63),('9650','2014-04-28','10:35:00',4.85),('9650','2014-04-28','10:40:00',4.97),('9650','2014-04-28','10:45:00',5.09),('9650','2014-04-28','10:50:00',5.25),('9650','2014-04-28','10:55:00',4.98),('9650','2014-04-28','11:00:00',5.25),('9650','2014-04-28','11:05:00',5.29),('9650','2014-04-28','11:10:00',5.33),('9650','2014-04-28','11:15:00',6.72),('9650','2014-04-28','11:20:00',5.33),('9650','2014-04-28','11:25:00',5),('9650','2014-04-28','11:30:00',4.47),('9650','2014-04-28','11:35:00',4.25),('9650','2014-04-28','11:40:00',6.06),('9650','2014-04-28','11:45:00',3.31),('9650','2014-04-28','11:50:00',1.95),('9650','2014-04-28','11:55:00',1.93),('9650','2014-04-28','12:00:00',2.54),('9650','2014-04-28','12:05:00',2.91),('9650','2014-04-28','12:10:00',2.94),('9650','2014-04-28','12:15:00',2.74),('9650','2014-04-28','12:20:00',3.76),('9650','2014-04-28','12:25:00',3.91),('9650','2014-04-28','12:30:00',2.57),('9650','2014-04-28','12:35:00',3.09),('9650','2014-04-28','12:40:00',3.76),('9650','2014-04-28','12:45:00',3.81),('9650','2014-04-28','12:50:00',5.99),('9650','2014-04-28','12:55:00',2.91),('9650','2014-04-28','13:00:00',3.89),('9650','2014-04-28','13:05:00',3.46),('9650','2014-04-28','13:10:00',3.58),('9650','2014-04-28','13:15:00',3.93),('9650','2014-04-28','13:20:00',6.35),('9650','2014-04-28','13:25:00',4.66),('9650','2014-04-28','13:30:00',6.66),('9650','2014-04-28','13:35:00',2.79),('9650','2014-04-28','13:40:00',2.81),('9650','2014-04-28','13:45:00',4.43),('9650','2014-04-28','13:50:00',3.92),('9650','2014-04-28','13:55:00',1.59),('9650','2014-04-28','14:40:00',1.04),('9650','2014-04-28','15:00:00',1.18),('9650','2014-04-28','15:05:00',1.57),('9650','2014-04-28','15:10:00',1.3),('9650','2014-04-28','15:25:00',1.19),('9650','2014-04-28','15:30:00',1.28),('9650','2014-04-28','15:35:00',1.28),('9650','2014-04-28','16:05:00',1.12),('9650','2014-04-28','16:10:00',1.24),('9650','2014-04-28','16:15:00',1.41),('9650','2014-04-28','16:20:00',1.67),('9650','2014-04-28','16:25:00',1.76),('9650','2014-04-28','16:30:00',1.46),('9650','2014-04-28','16:35:00',1.24),('9650','2014-04-28','16:40:00',1.13),('9650','2014-04-28','16:45:00',1.11),('9650','2014-04-28','16:50:00',1.17),('9650','2014-04-28','16:55:00',1.29),('9650','2014-04-28','17:00:00',1.66),('9650','2014-04-28','17:05:00',2.22),('9650','2014-04-28','17:10:00',2.02),('9650','2014-04-28','17:15:00',1.65),('9650','2014-04-28','17:20:00',2.88),('9650','2014-04-28','17:25:00',2.13),('9650','2014-04-28','17:30:00',4.3),('9650','2014-04-28','17:35:00',3.6),('9650','2014-04-28','17:40:00',5.39),('9650','2014-04-28','17:45:00',5.24),('9650','2014-04-28','17:50:00',1.39),('9650','2014-04-28','17:55:00',1.01),('9650','2014-04-28','18:00:00',1.14),('9650','2014-04-28','18:05:00',1.22),('9650','2014-04-27','07:50:00',1),('9650','2014-04-27','07:55:00',1.09),('9650','2014-04-27','08:00:00',1.11),('9650','2014-04-27','08:20:00',1.33),('9650','2014-04-27','08:25:00',1.97),('9650','2014-04-27','08:30:00',1.75),('9650','2014-04-27','08:35:00',1.76),('9650','2014-04-27','08:40:00',1.84),('9650','2014-04-27','08:45:00',1.77),('9650','2014-04-27','08:50:00',1.73),('9650','2014-04-27','08:55:00',1.7),('9650','2014-04-27','09:00:00',1.41),('9650','2014-04-27','09:05:00',1.64),('9650','2014-04-27','09:10:00',2.58),('9650','2014-04-27','09:15:00',2.68),('9650','2014-04-27','09:20:00',2.18),('9650','2014-04-27','09:25:00',2.36),('9650','2014-04-27','09:30:00',2.97),('9650','2014-04-27','09:35:00',2.86),('9650','2014-04-27','09:40:00',2.78),('9650','2014-04-27','09:45:00',2.61),('9650','2014-04-27','09:50:00',2.63),('9650','2014-04-27','09:55:00',2.16),('9650','2014-04-27','10:00:00',3.26),('9650','2014-04-27','10:05:00',3.82),('9650','2014-04-27','10:10:00',3.69),('9650','2014-04-27','10:15:00',3.19),('9650','2014-04-27','10:20:00',2.69),('9650','2014-04-27','10:25:00',1.56),('9650','2014-04-27','10:35:00',1.09),('9650','2014-04-27','10:40:00',1.95),('9650','2014-04-27','10:45:00',2.91),('9650','2014-04-27','10:50:00',3.46),('9650','2014-04-27','10:55:00',3.01),('9650','2014-04-27','11:00:00',3.29),('9650','2014-04-27','11:05:00',4.05),('9650','2014-04-27','11:10:00',4.39),('9650','2014-04-27','11:15:00',4.31),('9650','2014-04-27','11:20:00',3.82),('9650','2014-04-27','11:25:00',3.13),('9650','2014-04-27','11:30:00',3.24),('9650','2014-04-27','11:35:00',2.87),('9650','2014-04-27','11:40:00',2.76),('9650','2014-04-27','11:45:00',3.09),('9650','2014-04-27','11:50:00',3.53),('9650','2014-04-27','11:55:00',3.58),('9650','2014-04-27','12:00:00',3.16),('9650','2014-04-27','12:05:00',2.66),('9650','2014-04-27','12:10:00',3.46),('9650','2014-04-27','12:15:00',4.94),('9650','2014-04-27','12:20:00',4.92),('9650','2014-04-27','12:25:00',4.8),('9650','2014-04-27','12:30:00',4.74),('9650','2014-04-27','12:35:00',4.27),('9650','2014-04-27','12:40:00',3.72),('9650','2014-04-27','12:45:00',3.45),('9650','2014-04-27','12:50:00',4.01),('9650','2014-04-27','12:55:00',4.03),('9650','2014-04-27','13:00:00',4.14),('9650','2014-04-27','13:05:00',5.46),('9650','2014-04-27','13:10:00',5.41),('9650','2014-04-27','13:15:00',3.91),('9650','2014-04-27','13:20:00',4.34),('9650','2014-04-27','13:25:00',5.59),('9650','2014-04-27','13:30:00',8.7),('9650','2014-04-27','13:35:00',6.24),('9650','2014-04-27','13:40:00',5.84),('9650','2014-04-27','13:45:00',6.72),('9650','2014-04-27','13:50:00',7.98),('9650','2014-04-27','13:55:00',5.76),('9650','2014-04-27','14:00:00',3.6),('9650','2014-04-27','14:05:00',6.43),('9650','2014-04-27','14:10:00',6.96),('9650','2014-04-27','14:15:00',4.4),('9650','2014-04-27','14:20:00',7.17),('9650','2014-04-27','14:25:00',5.46),('9650','2014-04-27','14:30:00',5.45),('9650','2014-04-27','14:35:00',4.68),('9650','2014-04-27','14:40:00',7.59),('9650','2014-04-27','14:45:00',5.91),('9650','2014-04-27','14:50:00',5.91),('9650','2014-04-27','14:55:00',7.68),('9650','2014-04-27','15:00:00',5.58),('9650','2014-04-27','15:05:00',5.76),('9650','2014-04-27','15:10:00',4.1),('9650','2014-04-27','15:15:00',4.48),('9650','2014-04-27','15:20:00',3.84),('9650','2014-04-27','15:25:00',2.45),('9650','2014-04-27','15:30:00',4.03),('9650','2014-04-27','15:35:00',5.83),('9650','2014-04-27','15:40:00',4.06),('9650','2014-04-27','15:45:00',5.89),('9650','2014-04-27','15:50:00',5.8),('9650','2014-04-27','15:55:00',3),('9650','2014-04-27','16:00:00',5.02),('9650','2014-04-27','16:05:00',5.08),('9650','2014-04-27','16:10:00',7.98),('9650','2014-04-27','16:15:00',4.99),('9650','2014-04-27','16:20:00',3.8),('9650','2014-04-27','16:25:00',3.98),('9650','2014-04-27','16:30:00',5.81),('9650','2014-04-27','16:35:00',6.84),('9650','2014-04-27','16:40:00',1.47),('9650','2014-04-27','16:45:00',1.25),('9650','2014-04-27','16:50:00',1.91),('9650','2014-04-27','16:55:00',3.8),('9650','2014-04-27','17:00:00',1.73),('9650','2014-04-27','17:05:00',1.04),('9650','2014-04-27','17:15:00',1),('9650','2014-04-27','17:20:00',1.67),('9650','2014-04-27','17:25:00',1.84),('9650','2014-04-27','17:30:00',1.59),('9650','2014-04-27','17:35:00',2.34),('9650','2014-04-27','17:40:00',3.25),('9650','2014-04-27','17:45:00',1.62),('9650','2014-04-27','17:50:00',1.42),('9650','2014-04-27','17:55:00',1.25),('9650','2014-04-27','18:10:00',1.23),('9650','2014-04-27','18:15:00',1.28),('9650','2014-04-27','18:25:00',1.04),('9650','2014-04-27','18:30:00',1),('9650','2014-04-27','18:35:00',1.12),('9650','2014-04-27','18:40:00',1.1),('9650','2014-04-26','08:50:00',1.41),('9650','2014-04-26','09:10:00',1.12),('9650','2014-04-26','09:15:00',1.63),('9650','2014-04-26','09:20:00',1.76),('9650','2014-04-26','09:25:00',1.41),('9650','2014-04-26','09:30:00',1.18),('9650','2014-04-26','09:40:00',1.09),('9650','2014-04-26','09:45:00',1.22),('9650','2014-04-26','09:50:00',1.03),('9650','2014-04-26','09:55:00',1.32),('9650','2014-04-26','10:00:00',1.93),('9650','2014-04-26','10:05:00',2.1),('9650','2014-04-26','10:10:00',2.1),('9650','2014-04-26','10:15:00',2.03),('9650','2014-04-26','10:20:00',2.14),('9650','2014-04-26','10:25:00',1.93),('9650','2014-04-26','10:30:00',1.1),('9650','2014-04-26','10:55:00',1.2),('9650','2014-04-26','11:00:00',1.83),('9650','2014-04-26','11:05:00',2.07),('9650','2014-04-26','11:10:00',1.93),('9650','2014-04-26','11:15:00',1.89),('9650','2014-04-26','11:20:00',1.46),('9650','2014-04-26','11:25:00',1.06),('9650','2014-04-26','11:30:00',1.4),('9650','2014-04-26','11:35:00',2.3),('9650','2014-04-26','11:40:00',2.58),('9650','2014-04-26','11:45:00',5.11),('9650','2014-04-26','11:50:00',4.47),('9650','2014-04-26','11:55:00',4.4),('9650','2014-04-26','12:00:00',4.21),('9650','2014-04-26','12:05:00',4.72),('9650','2014-04-26','12:10:00',5.04),('9650','2014-04-26','12:15:00',5.18),('9650','2014-04-26','12:20:00',4.78),('9650','2014-04-26','12:25:00',4.68),('9650','2014-04-26','12:30:00',4.3),('9650','2014-04-26','12:35:00',4.51),('9650','2014-04-26','12:40:00',4.1),('9650','2014-04-26','12:45:00',4.38),('9650','2014-04-26','12:50:00',3.71),('9650','2014-04-26','12:55:00',3.22),('9650','2014-04-26','13:00:00',4.18),('9650','2014-04-26','13:05:00',3.82),('9650','2014-04-26','13:10:00',3.3),('9650','2014-04-26','13:15:00',3.44),('9650','2014-04-26','13:20:00',4.26),('9650','2014-04-26','13:25:00',3.88),('9650','2014-04-26','13:30:00',3.6),('9650','2014-04-26','13:35:00',3.21),('9650','2014-04-26','13:40:00',2.91),('9650','2014-04-26','13:45:00',3.02),('9650','2014-04-26','13:50:00',3),('9650','2014-04-26','13:55:00',2.83),('9650','2014-04-26','14:00:00',3.41),('9650','2014-04-26','14:05:00',3.89),('9650','2014-04-26','14:10:00',2.81),('9650','2014-04-26','14:15:00',2.61),('9650','2014-04-26','14:20:00',3.18),('9650','2014-04-26','14:25:00',3.95),('9650','2014-04-26','14:30:00',4.08),('9650','2014-04-26','14:35:00',4.07),('9650','2014-04-26','14:40:00',4.25),('9650','2014-04-26','14:45:00',3.66),('9650','2014-04-26','14:50:00',3.43),('9650','2014-04-26','14:55:00',3.66),('9650','2014-04-26','15:00:00',3.97),('9650','2014-04-26','15:05:00',5.86),('9650','2014-04-26','15:10:00',7.75),('9650','2014-04-26','15:15:00',5.12),('9650','2014-04-26','15:20:00',3.25),('9650','2014-04-26','15:25:00',1.97),('9650','2014-04-26','15:30:00',1.6),('9650','2014-04-26','15:35:00',1.82),('9650','2014-04-26','15:40:00',1.91),('9650','2014-04-26','15:45:00',1.56),('9650','2014-04-26','15:50:00',1.58),('9650','2014-04-26','15:55:00',1.11);
/*!40000 ALTER TABLE `solarlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `solarlogmod`
--

DROP TABLE IF EXISTS `solarlogmod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `solarlogmod` (
  `user` varchar(10) NOT NULL,
  `data` date NOT NULL,
  `time` time NOT NULL,
  `power` float NOT NULL,
  KEY `idxuser` (`user`),
  KEY `idxdata` (`data`),
  KEY `idxtime` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `solarlogmod`
--

LOCK TABLES `solarlogmod` WRITE;
/*!40000 ALTER TABLE `solarlogmod` DISABLE KEYS */;
INSERT INTO `solarlogmod` VALUES ('10318','2014-05-05','07:10:00',1.03),('10318','2014-05-05','07:15:00',1.71),('10318','2014-05-05','07:20:00',2.07),('10318','2014-05-05','07:25:00',2.07),('10318','2014-05-05','07:30:00',2.46),('10318','2014-05-05','07:35:00',2.92),('10318','2014-05-05','07:40:00',1.96),('10318','2014-05-05','07:45:00',1.42),('10318','2014-05-05','07:50:00',3.67),('10318','2014-05-05','07:55:00',3.79),('10318','2014-05-05','08:00:00',4.11),('10318','2014-05-05','08:05:00',4.32),('10318','2014-05-05','08:10:00',4.54),('10318','2014-05-05','08:15:00',4.77),('10318','2014-05-05','08:20:00',4.97),('10318','2014-05-05','08:25:00',5.18),('10318','2014-05-05','08:30:00',5.38),('10318','2014-05-05','08:35:00',5.58),('10318','2014-05-05','08:40:00',5.77),('10318','2014-05-05','08:45:00',5.99),('10318','2014-05-05','08:50:00',6.2),('10318','2014-05-05','08:55:00',6.35),('10318','2014-05-05','09:00:00',6.56),('10318','2014-05-05','09:05:00',6.72),('10318','2014-05-05','09:10:00',6.83),('10318','2014-05-05','09:15:00',7.06),('10318','2014-05-05','09:20:00',7.15),('10318','2014-05-05','09:25:00',7.31),('10318','2014-05-05','09:30:00',7.12),('10318','2014-05-05','09:35:00',7.68),('10318','2014-05-05','09:40:00',7.68),('10318','2014-05-05','09:45:00',7.95),('10318','2014-05-05','09:50:00',8.07),('10318','2014-05-05','09:55:00',8.21),('10318','2014-05-05','10:00:00',8.3),('10318','2014-05-05','10:05:00',8.42),('10318','2014-05-05','10:10:00',8.58),('10318','2014-05-05','10:15:00',8.68),('10318','2014-05-05','10:20:00',8.84),('10318','2014-05-05','10:25:00',9.06),('10318','2014-05-05','10:30:00',9.14),('10318','2014-05-05','10:35:00',9.38),('10318','2014-05-05','10:40:00',9.26),('10318','2014-05-05','10:45:00',9.01),('10318','2014-05-05','10:50:00',9.4),('10318','2014-05-05','10:55:00',9.27),('10318','2014-05-05','11:00:00',9.49),('10318','2014-05-05','11:05:00',9.54),('10318','2014-05-05','11:10:00',9.6),('10318','2014-05-05','11:15:00',7.72),('10318','2014-05-05','11:20:00',9.43),('10318','2014-05-05','11:25:00',9.97),('10318','2014-05-05','11:30:00',10.35),('10318','2014-05-05','11:35:00',9.9),('10318','2014-05-05','11:40:00',9.9),('10318','2014-05-05','11:45:00',10.21),('10318','2014-05-05','11:50:00',10.48),('10318','2014-05-05','11:55:00',10.72),('10318','2014-05-05','12:00:00',10.42),('10318','2014-05-05','12:05:00',9.04),('10318','2014-05-05','12:10:00',9.1),('10318','2014-05-05','12:15:00',8.47),('10318','2014-05-05','12:20:00',10.8),('10318','2014-05-05','12:25:00',10.33),('10318','2014-05-05','12:30:00',7.95),('10318','2014-05-05','12:35:00',5.62),('10318','2014-05-05','12:40:00',5.8),('10318','2014-05-05','12:45:00',10.54),('10318','2014-05-05','12:50:00',10.47),('10318','2014-05-05','12:55:00',10.57),('10318','2014-05-05','13:00:00',9.97),('10318','2014-05-05','13:05:00',10.07),('10318','2014-05-05','13:10:00',9.92),('10318','2014-05-05','13:15:00',10),('10318','2014-05-05','13:20:00',9.4),('10318','2014-05-05','13:25:00',5.29),('10318','2014-05-05','13:30:00',1.93),('10318','2014-05-05','13:35:00',8.22),('10318','2014-05-05','13:40:00',8.37),('10318','2014-05-05','13:45:00',3.3),('10318','2014-05-05','13:50:00',5.18),('10318','2014-05-05','13:55:00',8.75),('10318','2014-05-05','14:00:00',10.27),('10318','2014-05-05','14:05:00',9.79),('10318','2014-05-05','14:10:00',8.76),('10318','2014-05-05','14:15:00',8.86),('10318','2014-05-05','14:20:00',7.94),('10318','2014-05-05','14:25:00',9.59),('10318','2014-05-05','14:30:00',6.79),('10318','2014-05-05','14:35:00',4.05),('10318','2014-05-05','14:40:00',8.69),('10318','2014-05-05','14:45:00',10.33),('10318','2014-05-05','14:50:00',6.38),('10318','2014-05-05','14:55:00',4.25),('10318','2014-05-05','15:00:00',7.59),('10318','2014-05-05','15:05:00',7.71),('10318','2014-05-05','15:10:00',7.96),('10318','2014-05-05','15:15:00',8.81),('10318','2014-05-05','15:20:00',8.7),('10318','2014-05-05','15:25:00',6.26),('10318','2014-05-05','15:30:00',8),('10318','2014-05-05','15:35:00',8.06),('10318','2014-05-05','15:40:00',8.11),('10318','2014-05-05','15:45:00',4.28),('10318','2014-05-05','15:50:00',7.74),('10318','2014-05-05','15:55:00',5.79),('10318','2014-05-05','16:00:00',6.43),('10318','2014-05-05','16:05:00',6.23),('10318','2014-05-05','16:10:00',2.76),('10318','2014-05-05','16:15:00',5.59),('10318','2014-05-05','16:20:00',4.79),('10318','2014-05-05','16:25:00',6.37),('10318','2014-05-05','16:30:00',6.42),('10318','2014-05-05','16:35:00',5.83),('10318','2014-05-05','16:40:00',5.68),('10318','2014-05-05','16:45:00',5.29),('10318','2014-05-05','16:50:00',5.16),('10318','2014-05-05','16:55:00',5.02),('10318','2014-05-05','17:00:00',4.64),('10318','2014-05-05','17:05:00',4.26),('10318','2014-05-05','17:10:00',4.27),('10318','2014-05-05','17:15:00',4.09),('10318','2014-05-05','17:20:00',3.83),('10318','2014-05-05','17:25:00',3.61),('10318','2014-05-05','17:30:00',3.35),('10318','2014-05-05','17:35:00',3.06),('10318','2014-05-05','17:40:00',2.96),('10318','2014-05-05','17:45:00',2.82),('10318','2014-05-05','17:50:00',2.62),('10318','2014-05-05','17:55:00',2.41),('10318','2014-05-05','18:00:00',2.24),('10318','2014-05-05','18:05:00',2.09),('10318','2014-05-05','18:10:00',1.91),('10318','2014-05-05','18:15:00',1.73),('10318','2014-05-05','18:20:00',1.55),('10318','2014-05-05','18:25:00',1.44),('10318','2014-05-05','18:30:00',1.31),('10318','2014-05-05','18:35:00',1.17),('10318','2014-05-05','18:40:00',1),('10318','2014-04-26','07:50:00',1.12),('10318','2014-04-26','07:55:00',1.17),('10318','2014-04-26','08:00:00',1.28),('10318','2014-04-26','08:05:00',1.33),('10318','2014-04-26','08:10:00',1.43),('10318','2014-04-26','08:15:00',1.57),('10318','2014-04-26','08:20:00',1.6),('10318','2014-04-26','08:25:00',1.62),('10318','2014-04-26','08:30:00',1.48),('10318','2014-04-26','08:35:00',1.43),('10318','2014-04-26','08:40:00',1.65),('10318','2014-04-26','08:45:00',1.83),('10318','2014-04-26','08:50:00',1.82),('10318','2014-04-26','08:55:00',2.03),('10318','2014-04-26','09:00:00',2.04),('10318','2014-04-26','09:05:00',2.14),('10318','2014-04-26','09:10:00',1.95),('10318','2014-04-26','09:15:00',1.73),('10318','2014-04-26','09:20:00',1.8),('10318','2014-04-26','09:25:00',1.81),('10318','2014-04-26','09:30:00',1.72),('10318','2014-04-26','09:35:00',1.75),('10318','2014-04-26','09:40:00',1.91),('10318','2014-04-26','09:45:00',1.84),('10318','2014-04-26','09:50:00',1.88),('10318','2014-04-26','09:55:00',2.71),('10318','2014-04-26','10:00:00',3.59),('10318','2014-04-26','10:05:00',3.61),('10318','2014-04-26','10:10:00',2.98),('10318','2014-04-26','10:15:00',3.06),('10318','2014-04-26','10:20:00',3.38),('10318','2014-04-26','10:25:00',3.66),('10318','2014-04-26','10:30:00',3.95),('10318','2014-04-26','10:35:00',4.27),('10318','2014-04-26','10:40:00',3.89),('10318','2014-04-26','10:45:00',4.19),('10318','2014-04-26','10:50:00',5.74),('10318','2014-04-26','10:55:00',8.65),('10318','2014-04-26','11:00:00',7.71),('10318','2014-04-26','11:05:00',9.25),('10318','2014-04-26','11:10:00',8.43),('10318','2014-04-26','11:15:00',8.32),('10318','2014-04-26','11:20:00',8.43),('10318','2014-04-26','11:25:00',7.84),('10318','2014-04-26','11:30:00',7.79),('10318','2014-04-26','11:35:00',7.22),('10318','2014-04-26','11:40:00',7.52),('10318','2014-04-26','11:45:00',7.64),('10318','2014-04-26','11:50:00',7.53),('10318','2014-04-26','11:55:00',8.3),('10318','2014-04-26','12:00:00',7.21),('10318','2014-04-26','12:05:00',7.55),('10318','2014-04-26','12:10:00',7.24),('10318','2014-04-26','12:15:00',4.46),('10318','2014-04-26','12:20:00',6.12),('10318','2014-04-26','12:25:00',6.65),('10318','2014-04-26','12:30:00',6),('10318','2014-04-26','12:35:00',4.74),('10318','2014-04-26','12:40:00',4.73),('10318','2014-04-26','12:45:00',6.15),('10318','2014-04-26','12:50:00',5.88),('10318','2014-04-26','12:55:00',8.23),('10318','2014-04-26','13:00:00',10.31),('10318','2014-04-26','13:05:00',7.95),('10318','2014-04-26','13:10:00',9.4),('10318','2014-04-26','13:15:00',9.34),('10318','2014-04-26','13:20:00',9.48),('10318','2014-04-26','13:25:00',8.22),('10318','2014-04-26','13:30:00',8.03),('10318','2014-04-26','13:35:00',7.32),('10318','2014-04-26','13:40:00',5.53),('10318','2014-04-26','13:45:00',5.86),('10318','2014-04-26','13:50:00',9.58),('10318','2014-04-26','13:55:00',4.41),('10318','2014-04-26','14:00:00',1.95),('10318','2014-04-26','14:05:00',1.28),('10318','2014-04-26','14:10:00',1.07),('10318','2014-04-26','14:20:00',1.6),('10318','2014-04-26','14:25:00',2.25),('10318','2014-04-26','14:30:00',1.74),('10318','2014-04-26','14:35:00',1.84),('10318','2014-04-26','14:40:00',1.67),('10318','2014-04-26','14:45:00',1.44),('10318','2014-04-26','14:50:00',1.07),('10318','2014-04-26','15:10:00',1.19),('10318','2014-04-26','15:45:00',1.07),('10318','2014-04-26','17:40:00',1.23),('10318','2014-04-26','17:45:00',1.63),('10318','2014-04-26','17:50:00',1.91),('10318','2014-04-26','17:55:00',1.71),('10318','2014-04-26','18:00:00',1.2),('10318','2014-04-26','18:25:00',1.01),('10318','2014-04-26','18:30:00',1.24),('10318','2014-04-26','18:35:00',1.48),('10318','2014-04-26','18:40:00',1.67),('10318','2014-04-26','18:45:00',1.7),('10318','2014-04-26','18:50:00',1.29),('10318','2014-04-25','07:20:00',1.05),('10318','2014-04-25','07:25:00',1.27),('10318','2014-04-25','07:30:00',1.67),('10318','2014-04-25','07:35:00',1.92),('10318','2014-04-25','07:40:00',1.87),('10318','2014-04-25','07:45:00',2.78),('10318','2014-04-25','07:50:00',2.91),('10318','2014-04-25','07:55:00',3),('10318','2014-04-25','08:00:00',3.24),('10318','2014-04-25','08:05:00',3.49),('10318','2014-04-25','08:10:00',3.67),('10318','2014-04-25','08:15:00',3.93),('10318','2014-04-25','08:20:00',4.39),('10318','2014-04-25','08:25:00',4.51),('10318','2014-04-25','08:30:00',4.69),('10318','2014-04-25','08:35:00',4.84),('10318','2014-04-25','08:40:00',5.01),('10318','2014-04-25','08:45:00',5.22),('10318','2014-04-25','08:50:00',5.45),('10318','2014-04-25','08:55:00',5.66),('10318','2014-04-25','09:00:00',6.07),('10318','2014-04-25','09:05:00',5.05),('10318','2014-04-25','09:10:00',5.43),('10318','2014-04-25','09:15:00',7.7),('10318','2014-04-25','09:20:00',7.34),('10318','2014-04-25','09:25:00',6.53),('10318','2014-04-25','09:30:00',4.49),('10318','2014-04-25','09:35:00',4.49),('10318','2014-04-25','09:40:00',3.66),('10318','2014-04-25','09:45:00',4.54),('10318','2014-04-25','09:50:00',3.27),('10318','2014-04-25','09:55:00',2.34),('10318','2014-04-25','10:00:00',2.35),('10318','2014-04-25','10:05:00',2.16),('10318','2014-04-25','10:10:00',2.07),('10318','2014-04-25','10:15:00',2.22),('10318','2014-04-25','10:20:00',2.99),('10318','2014-04-25','10:25:00',4.65),('10318','2014-04-25','10:30:00',3.48),('10318','2014-04-25','10:35:00',2.46),('10318','2014-04-25','10:40:00',2.12),('10318','2014-04-25','10:45:00',2.53),('10318','2014-04-25','10:50:00',3.14),('10318','2014-04-25','10:55:00',3.32),('10318','2014-04-25','11:00:00',6.62),('10318','2014-04-25','11:05:00',8.42),('10318','2014-04-25','11:10:00',8.18),('10318','2014-04-25','11:15:00',5.66),('10318','2014-04-25','11:20:00',8.15),('10318','2014-04-25','11:25:00',9.87),('10318','2014-04-25','11:30:00',8.11),('10318','2014-04-25','11:35:00',7.71),('10318','2014-04-25','11:40:00',8.68),('10318','2014-04-25','11:45:00',3.26),('10318','2014-04-25','11:50:00',3.73),('10318','2014-04-25','11:55:00',3.83),('10318','2014-04-25','12:00:00',4.79),('10318','2014-04-25','12:05:00',4.66),('10318','2014-04-25','12:10:00',10.41),('10318','2014-04-25','12:15:00',10.26),('10318','2014-04-25','12:20:00',6.62),('10318','2014-04-25','12:25:00',5.59),('10318','2014-04-25','12:30:00',9.7),('10318','2014-04-25','12:35:00',6.44),('10318','2014-04-25','12:40:00',5.13),('10318','2014-04-25','12:45:00',8.35),('10318','2014-04-25','12:50:00',6.31),('10318','2014-04-25','12:55:00',4.19),('10318','2014-04-25','13:00:00',5.67),('10318','2014-04-25','13:05:00',2.83),('10318','2014-04-25','13:10:00',7.41),('10318','2014-04-25','13:15:00',4.84),('10318','2014-04-25','13:20:00',5.48),('10318','2014-04-25','13:25:00',2.93),('10318','2014-04-25','13:30:00',8.36),('10318','2014-04-25','13:35:00',2.91),('10318','2014-04-25','13:40:00',4.58),('10318','2014-04-25','13:45:00',4.42),('10318','2014-04-25','13:50:00',7.93),('10318','2014-04-25','13:55:00',8.37),('10318','2014-04-25','14:00:00',3.27),('10318','2014-04-25','14:05:00',4.66),('10318','2014-04-25','14:10:00',10.25),('10318','2014-04-25','14:15:00',9.71),('10318','2014-04-25','14:20:00',9.67),('10318','2014-04-25','14:25:00',8.97),('10318','2014-04-25','14:30:00',8.79),('10318','2014-04-25','14:35:00',8.56),('10318','2014-04-25','14:40:00',8.34),('10318','2014-04-25','14:45:00',8.31),('10318','2014-04-25','14:50:00',8.22),('10318','2014-04-25','14:55:00',8.18),('10318','2014-04-25','15:00:00',8.06),('10318','2014-04-25','15:05:00',7.81),('10318','2014-04-25','15:10:00',7.77),('10318','2014-04-25','15:15:00',7.7),('10318','2014-04-25','15:20:00',7.47),('10318','2014-04-25','15:25:00',7.37),('10318','2014-04-25','15:30:00',7.13),('10318','2014-04-25','15:35:00',7.11),('10318','2014-04-25','15:40:00',6.9),('10318','2014-04-25','15:45:00',6.54),('10318','2014-04-25','15:50:00',6.51),('10318','2014-04-25','15:55:00',6.53),('10318','2014-04-25','16:00:00',6.35),('10318','2014-04-25','16:05:00',6.09),('10318','2014-04-25','16:10:00',5.75),('10318','2014-04-25','16:15:00',5.47),('10318','2014-04-25','16:20:00',4.81),('10318','2014-04-25','16:25:00',5.46),('10318','2014-04-25','16:30:00',5.32),('10318','2014-04-25','16:35:00',5.3),('10318','2014-04-25','16:40:00',5.25),('10318','2014-04-25','16:45:00',5),('10318','2014-04-25','16:50:00',4.44),('10318','2014-04-25','16:55:00',3.68),('10318','2014-04-25','17:00:00',3.85),('10318','2014-04-25','17:05:00',3.96),('10318','2014-04-25','17:10:00',3.58),('10318','2014-04-25','17:15:00',3.31),('10318','2014-04-25','17:20:00',2.45),('10318','2014-04-25','17:25:00',2.01),('10318','2014-04-25','17:30:00',2.36),('10318','2014-04-25','17:35:00',2.23),('10318','2014-04-25','17:40:00',2.1),('10318','2014-04-25','17:45:00',1.77),('10318','2014-04-25','17:50:00',1.7),('10318','2014-04-25','17:55:00',1.62),('10318','2014-04-25','18:00:00',1.52),('10318','2014-04-25','18:05:00',1.53),('10318','2014-04-25','18:10:00',1.43),('10318','2014-04-25','18:15:00',1.29),('10318','2014-04-25','18:20:00',1.29),('10318','2014-04-25','18:25:00',1.14),('10318','2014-04-25','18:30:00',1.12),('10318','2014-04-25','18:35:00',1.06),('10318','2014-04-25','18:40:00',1),('10318','2014-04-24','07:25:00',1.16),('10318','2014-04-24','07:30:00',1.83),('10318','2014-04-24','07:35:00',2.24),('10318','2014-04-24','07:40:00',2.53),('10318','2014-04-24','07:45:00',2.83),('10318','2014-04-24','07:50:00',3.1),('10318','2014-04-24','07:55:00',3.31),('10318','2014-04-24','08:00:00',3.51),('10318','2014-04-24','08:05:00',3.74),('10318','2014-04-24','08:10:00',3.91),('10318','2014-04-24','08:15:00',4.2),('10318','2014-04-24','08:20:00',4.41),('10318','2014-04-24','08:25:00',4.6),('10318','2014-04-24','08:30:00',4.77),('10318','2014-04-24','08:35:00',4.99),('10318','2014-04-24','08:40:00',5.18),('10318','2014-04-24','08:45:00',5.35),('10318','2014-04-24','08:50:00',5.54),('10318','2014-04-24','08:55:00',5.73),('10318','2014-04-24','09:00:00',5.88),('10318','2014-04-24','09:05:00',6.05),('10318','2014-04-24','09:10:00',6.21),('10318','2014-04-24','09:15:00',6.36),('10318','2014-04-24','09:20:00',6.54),('10318','2014-04-24','09:25:00',6.69),('10318','2014-04-24','09:30:00',6.85),('10318','2014-04-24','09:35:00',6.92),('10318','2014-04-24','09:40:00',7.12),('10318','2014-04-24','09:45:00',7.25),('10318','2014-04-24','09:50:00',7.39),('10318','2014-04-24','09:55:00',7.5),('10318','2014-04-24','10:00:00',7.52),('10318','2014-04-24','10:05:00',7.72),('10318','2014-04-24','10:10:00',7.81),('10318','2014-04-24','10:15:00',7.95),('10318','2014-04-24','10:20:00',8.07),('10318','2014-04-24','10:25:00',8.15),('10318','2014-04-24','10:30:00',8.19),('10318','2014-04-24','10:35:00',8.28),('10318','2014-04-24','10:40:00',8.34),('10318','2014-04-24','10:45:00',8.43),('10318','2014-04-24','10:50:00',8.54),('10318','2014-04-24','10:55:00',8.6),('10318','2014-04-24','11:00:00',8.62),('10318','2014-04-24','11:05:00',8.67),('10318','2014-04-24','11:10:00',8.78),('10318','2014-04-24','11:15:00',8.85),('10318','2014-04-24','11:20:00',8.87),('10318','2014-04-24','11:25:00',9.03),('10318','2014-04-24','11:30:00',8.96),('10318','2014-04-24','11:35:00',9.01),('10318','2014-04-24','11:40:00',8.42),('10318','2014-04-24','11:45:00',4.6),('10318','2014-04-24','11:50:00',8.92),('10318','2014-04-24','11:55:00',4.5),('10318','2014-04-24','12:00:00',8.39),('10318','2014-04-24','12:05:00',9.48),('10318','2014-04-24','12:10:00',9.71),('10318','2014-04-24','12:15:00',9.61),('10318','2014-04-24','12:20:00',9.36),('10318','2014-04-24','12:25:00',9.42),('10318','2014-04-24','12:30:00',9.53),('10318','2014-04-24','12:35:00',7.71),('10318','2014-04-24','12:40:00',2.99),('10318','2014-04-24','12:45:00',8.87),('10318','2014-04-24','12:50:00',6.28),('10318','2014-04-24','12:55:00',4.27),('10318','2014-04-24','13:00:00',2.22),('10318','2014-04-24','13:05:00',1.92),('10318','2014-04-24','13:10:00',3.03),('10318','2014-04-24','13:15:00',9.57),('10318','2014-04-24','13:20:00',5.46),('10318','2014-04-24','13:25:00',3.09),('10318','2014-04-24','13:30:00',9.08),('10318','2014-04-24','13:35:00',9.58),('10318','2014-04-24','13:40:00',3.92),('10318','2014-04-24','13:45:00',2.57),('10318','2014-04-24','13:50:00',4.64),('10318','2014-04-24','13:55:00',6.78),('10318','2014-04-24','14:00:00',9.14),('10318','2014-04-24','14:05:00',9.66),('10318','2014-04-24','14:10:00',9.71),('10318','2014-04-24','14:15:00',9.43),('10318','2014-04-24','14:20:00',9.07),('10318','2014-04-24','14:25:00',9.51),('10318','2014-04-24','14:30:00',7.19),('10318','2014-04-24','14:35:00',8.8),('10318','2014-04-24','14:40:00',6.47),('10318','2014-04-24','14:45:00',8.67),('10318','2014-04-24','14:50:00',9.76),('10318','2014-04-24','14:55:00',9.09),('10318','2014-04-24','15:00:00',8.82),('10318','2014-04-24','15:05:00',9.05),('10318','2014-04-24','15:10:00',7.19),('10318','2014-04-24','15:15:00',9.57),('10318','2014-04-24','15:20:00',5.38),('10318','2014-04-24','15:25:00',6.54),('10318','2014-04-24','15:30:00',8.82),('10318','2014-04-24','15:35:00',7.5),('10318','2014-04-24','15:40:00',7.53),('10318','2014-04-24','15:45:00',6.53),('10318','2014-04-24','15:50:00',6.11),('10318','2014-04-24','15:55:00',8.18),('10318','2014-04-24','16:00:00',6.95),('10318','2014-04-24','16:05:00',7),('10318','2014-04-24','16:10:00',5.41),('10318','2014-04-24','16:15:00',4.36),('10318','2014-04-24','16:20:00',3.86),('10318','2014-04-24','16:25:00',4.44),('10318','2014-04-24','16:30:00',4.7),('10318','2014-04-24','16:35:00',4),('10318','2014-04-24','16:40:00',6.76),('10318','2014-04-24','16:45:00',4.52),('10318','2014-04-24','16:50:00',2.85),('10318','2014-04-24','16:55:00',2.66),('10318','2014-04-24','17:00:00',2.93),('10318','2014-04-24','17:05:00',2.91),('10318','2014-04-24','17:10:00',2.77),('10318','2014-04-24','17:15:00',2.68),('10318','2014-04-24','17:20:00',2.36),('10318','2014-04-24','17:25:00',2.51),('10318','2014-04-24','17:30:00',2.29),('10318','2014-04-24','17:35:00',1.96),('10318','2014-04-24','17:40:00',1.6),('10318','2014-04-24','17:45:00',1.22),('10318','2014-04-24','17:50:00',1.06),('10318','2014-04-24','18:10:00',1.01),('10318','2014-04-23','10:20:00',1.05),('10318','2014-04-23','10:25:00',1.24),('10318','2014-04-23','10:30:00',1.16),('10318','2014-04-23','10:35:00',1.3),('10318','2014-04-23','10:40:00',1.6),('10318','2014-04-23','10:45:00',1.67),('10318','2014-04-23','10:50:00',1.72),('10318','2014-04-23','10:55:00',1.58),('10318','2014-04-23','11:00:00',1.36),('10318','2014-04-23','11:05:00',1.3),('10318','2014-04-23','11:10:00',1.22),('10318','2014-04-23','11:15:00',1.41),('10318','2014-04-23','11:20:00',1.35),('10318','2014-04-23','11:25:00',1.13),('10318','2014-04-23','11:30:00',1.05),('10318','2014-04-23','11:35:00',1.27),('10318','2014-04-23','11:40:00',1.37),('10318','2014-04-23','11:45:00',1.45),('10318','2014-04-23','11:50:00',1.28),('10318','2014-04-23','11:55:00',1.08),('10318','2014-04-23','12:20:00',1.04),('10318','2014-04-23','12:25:00',1.14),('10318','2014-04-23','12:30:00',1.11),('10318','2014-04-23','12:35:00',1.25),('10318','2014-04-23','12:40:00',1.34),('10318','2014-04-23','12:45:00',1.27),('10318','2014-04-23','12:50:00',1.29),('10318','2014-04-23','12:55:00',1.33),('10318','2014-04-23','13:00:00',1.37),('10318','2014-04-23','13:05:00',1.51),('10318','2014-04-23','13:10:00',1.76),('10318','2014-04-23','13:15:00',2.1),('10318','2014-04-23','13:20:00',2.47),('10318','2014-04-23','13:25:00',2.73),('10318','2014-04-23','13:30:00',3.09),('10318','2014-04-23','13:35:00',3.27),('10318','2014-04-23','13:40:00',3.47),('10318','2014-04-23','13:45:00',3.62),('10318','2014-04-23','13:50:00',3.61),('10318','2014-04-23','13:55:00',3.69),('10318','2014-04-23','14:00:00',3.63),('10318','2014-04-23','14:05:00',3.59),('10318','2014-04-23','14:10:00',3.47),('10318','2014-04-23','14:15:00',3.09),('10318','2014-04-23','14:20:00',2.75),('10318','2014-04-23','14:25:00',2.42),('10318','2014-04-23','14:30:00',2.22),('10318','2014-04-23','14:35:00',2.1),('10318','2014-04-23','14:40:00',2.06),('10318','2014-04-23','14:45:00',2.07),('10318','2014-04-23','14:50:00',2.26),('10318','2014-04-23','14:55:00',2.53),('10318','2014-04-23','15:00:00',2.94),('10318','2014-04-23','15:05:00',3.26),('10318','2014-04-23','15:10:00',3.41),('10318','2014-04-23','15:15:00',3.52),('10318','2014-04-23','15:20:00',3.3),('10318','2014-04-23','15:25:00',3.23),('10318','2014-04-23','15:30:00',2.99),('10318','2014-04-23','15:35:00',2.7),('10318','2014-04-23','15:40:00',2.52),('10318','2014-04-23','15:45:00',2.27),('10318','2014-04-23','15:50:00',2.13),('10318','2014-04-23','15:55:00',2.11),('10318','2014-04-23','16:00:00',1.89),('10318','2014-04-23','16:05:00',1.73),('10318','2014-04-23','16:10:00',1.64),('10318','2014-04-23','16:15:00',1.37),('10318','2014-04-23','16:20:00',1.2),('10318','2014-04-23','16:25:00',1),('10318','2014-04-22','07:20:00',1.04),('10318','2014-04-22','07:25:00',1.27),('10318','2014-04-22','07:30:00',1.6),('10318','2014-04-22','07:35:00',1.94),('10318','2014-04-22','07:40:00',2.19),('10318','2014-04-22','07:45:00',2.49),('10318','2014-04-22','07:50:00',2.77),('10318','2014-04-22','07:55:00',3.02),('10318','2014-04-22','08:00:00',3.24),('10318','2014-04-22','08:05:00',3.44),('10318','2014-04-22','08:10:00',3.7),('10318','2014-04-22','08:15:00',3.92),('10318','2014-04-22','08:20:00',4.1),('10318','2014-04-22','08:25:00',4.31),('10318','2014-04-22','08:30:00',4.51),('10318','2014-04-22','08:35:00',4.62),('10318','2014-04-22','08:40:00',4.92),('10318','2014-04-22','08:45:00',4.98),('10318','2014-04-22','08:50:00',5.08),('10318','2014-04-22','08:55:00',5.46),('10318','2014-04-22','09:00:00',5.54),('10318','2014-04-22','09:05:00',6.01),('10318','2014-04-22','09:10:00',5.39),('10318','2014-04-22','09:15:00',5.4),('10318','2014-04-22','09:20:00',6.34),('10318','2014-04-22','09:25:00',6.53),('10318','2014-04-22','09:30:00',6.4),('10318','2014-04-22','09:35:00',7.01),('10318','2014-04-22','09:40:00',6.58),('10318','2014-04-22','09:45:00',7.4),('10318','2014-04-22','09:50:00',5.26),('10318','2014-04-22','09:55:00',3.33),('10318','2014-04-22','10:00:00',3.29),('10318','2014-04-22','10:05:00',3.5),('10318','2014-04-22','10:10:00',4.66),('10318','2014-04-22','10:15:00',4.54),('10318','2014-04-22','10:20:00',7.86),('10318','2014-04-22','10:25:00',5.17),('10318','2014-04-22','10:30:00',8.49),('10318','2014-04-22','10:35:00',6.85),('10318','2014-04-22','10:40:00',6.7),('10318','2014-04-22','10:45:00',9.05),('10318','2014-04-22','10:50:00',9.32),('10318','2014-04-22','10:55:00',7.36),('10318','2014-04-22','11:00:00',5.38),('10318','2014-04-22','11:05:00',5.82),('10318','2014-04-22','11:10:00',4.02),('10318','2014-04-22','11:15:00',3.28),('10318','2014-04-22','11:20:00',3),('10318','2014-04-22','11:25:00',2.67),('10318','2014-04-22','11:30:00',2.52),('10318','2014-04-22','11:35:00',2.42),('10318','2014-04-22','11:40:00',2.19),('10318','2014-04-22','11:45:00',1.99),('10318','2014-04-22','11:50:00',2.19),('10318','2014-04-22','11:55:00',2.08),('10318','2014-04-22','12:00:00',2.37),('10318','2014-04-22','12:05:00',2.78),('10318','2014-04-22','12:10:00',2.63),('10318','2014-04-22','12:15:00',2.74),('10318','2014-04-22','12:20:00',2.81),('10318','2014-04-22','12:25:00',2.99),('10318','2014-04-22','12:30:00',3.23),('10318','2014-04-22','12:35:00',2.7),('10318','2014-04-22','12:40:00',2.18),('10318','2014-04-22','12:45:00',1.85),('10318','2014-04-22','12:50:00',1.62),('10318','2014-04-22','12:55:00',1.57),('10318','2014-04-22','13:00:00',1.63),('10318','2014-04-22','13:05:00',1.87),('10318','2014-04-22','13:10:00',2.27),('10318','2014-04-22','13:15:00',3.26),('10318','2014-04-22','13:20:00',4.27),('10318','2014-04-22','13:25:00',5.34),('10318','2014-04-22','13:30:00',5.44),('10318','2014-04-22','13:35:00',5.75),('10318','2014-04-22','13:40:00',6.84),('10318','2014-04-22','13:45:00',5.79),('10318','2014-04-22','13:50:00',4.42),('10318','2014-04-22','13:55:00',3.31),('10318','2014-04-22','14:00:00',3.16),('10318','2014-04-22','14:05:00',6.52),('10318','2014-04-22','14:10:00',8.81),('10318','2014-04-22','14:15:00',6.31),('10318','2014-04-22','14:20:00',7.37),('10318','2014-04-22','14:25:00',4.2),('10318','2014-04-22','14:30:00',4.6),('10318','2014-04-22','14:35:00',5.86),('10318','2014-04-22','14:40:00',8.75),('10318','2014-04-22','14:45:00',7.61),('10318','2014-04-22','14:50:00',6.6),('10318','2014-04-22','14:55:00',4.94),('10318','2014-04-22','15:00:00',2.71),('10318','2014-04-22','15:05:00',2.7),('10318','2014-04-22','15:10:00',2.7),('10318','2014-04-22','15:15:00',2.74),('10318','2014-04-22','15:20:00',3),('10318','2014-04-22','15:25:00',3.05),('10318','2014-04-22','15:30:00',4.08),('10318','2014-04-22','15:35:00',4.41),('10318','2014-04-22','15:40:00',4.06),('10318','2014-04-22','15:45:00',4.72),('10318','2014-04-22','15:50:00',4.59),('10318','2014-04-22','15:55:00',4.14),('10318','2014-04-22','16:00:00',4.65),('10318','2014-04-22','16:05:00',3.7),('10318','2014-04-22','16:10:00',3.31),('10318','2014-04-22','16:15:00',3.09),('10318','2014-04-22','16:20:00',3.62),('10318','2014-04-22','16:25:00',2.55),('10318','2014-04-22','16:30:00',3.16),('10318','2014-04-22','16:35:00',3.32),('10318','2014-04-22','16:40:00',3.78),('10318','2014-04-22','16:45:00',3.22),('10318','2014-04-22','16:50:00',2.74),('10318','2014-04-22','16:55:00',2.58),('10318','2014-04-22','17:00:00',3.02),('10318','2014-04-22','17:05:00',3.03),('10318','2014-04-22','17:10:00',2.63),('10318','2014-04-22','17:15:00',2.12),('10318','2014-04-22','17:20:00',1.62),('10318','2014-04-22','17:25:00',1.41),('10318','2014-04-22','17:30:00',1.35),('10318','2014-04-22','17:35:00',1.7),('10318','2014-04-22','17:40:00',1.68),('10318','2014-04-22','17:45:00',1.44),('10318','2014-04-22','17:50:00',1.23),('10318','2014-04-21','08:10:00',1.04),('10318','2014-04-21','08:15:00',1.08),('10318','2014-04-21','08:20:00',1.19),('10318','2014-04-21','08:25:00',1.42),('10318','2014-04-21','08:30:00',1.74),('10318','2014-04-21','08:35:00',1.88),('10318','2014-04-21','08:40:00',2.34),('10318','2014-04-21','08:45:00',2.37),('10318','2014-04-21','08:50:00',2.44),('10318','2014-04-21','08:55:00',2.36),('10318','2014-04-21','09:00:00',2.96),('10318','2014-04-21','09:05:00',2.75),('10318','2014-04-21','09:10:00',2.43),('10318','2014-04-21','09:15:00',3.55),('10318','2014-04-21','09:20:00',3.7),('10318','2014-04-21','09:25:00',3.34),('10318','2014-04-21','09:30:00',1.4),('10318','2014-04-21','09:35:00',1.9),('10318','2014-04-21','09:40:00',2.97),('10318','2014-04-21','09:45:00',2.48),('10318','2014-04-21','09:50:00',2.6),('10318','2014-04-21','09:55:00',2.68),('10318','2014-04-21','10:00:00',2.97),('10318','2014-04-21','10:05:00',3.95),('10318','2014-04-21','10:10:00',4.13),('10318','2014-04-21','10:15:00',7.37),('10318','2014-04-21','10:20:00',8.33),('10318','2014-04-21','10:25:00',8.13),('10318','2014-04-21','10:30:00',8.15),('10318','2014-04-21','10:35:00',8.18),('10318','2014-04-21','10:40:00',8.25),('10318','2014-04-21','10:45:00',8.33),('10318','2014-04-21','10:50:00',8.4),('10318','2014-04-21','10:55:00',8.46),('10318','2014-04-21','11:00:00',8.51),('10318','2014-04-21','11:05:00',8.57),('10318','2014-04-21','11:10:00',8.64),('10318','2014-04-21','11:15:00',8.68),('10318','2014-04-21','11:20:00',8.74),('10318','2014-04-21','11:25:00',8.79),('10318','2014-04-21','11:30:00',8.82),('10318','2014-04-21','11:35:00',8.83),('10318','2014-04-21','11:40:00',8.92),('10318','2014-04-21','11:45:00',8.99),('10318','2014-04-21','11:50:00',8.99),('10318','2014-04-21','11:55:00',9.09),('10318','2014-04-21','12:00:00',9.15),('10318','2014-04-21','12:05:00',9.16),('10318','2014-04-21','12:10:00',9.24),('10318','2014-04-21','12:15:00',9.23),('10318','2014-04-21','12:20:00',9.28),('10318','2014-04-21','12:25:00',9.3),('10318','2014-04-21','12:30:00',9.34),('10318','2014-04-21','12:35:00',9.31),('10318','2014-04-21','12:40:00',9.34),('10318','2014-04-21','12:45:00',9.34),('10318','2014-04-21','12:50:00',9.32),('10318','2014-04-21','12:55:00',9.3),('10318','2014-04-21','13:00:00',9.28),('10318','2014-04-21','13:05:00',9.26),('10318','2014-04-21','13:10:00',9.25),('10318','2014-04-21','13:15:00',9.25),('10318','2014-04-21','13:20:00',9.18),('10318','2014-04-21','13:25:00',9.11),('10318','2014-04-21','13:30:00',9.17),('10318','2014-04-21','13:35:00',9.16),('10318','2014-04-21','13:40:00',9.14),('10318','2014-04-21','13:45:00',9.06),('10318','2014-04-21','13:50:00',9.03),('10318','2014-04-21','13:55:00',8.86),('10318','2014-04-21','14:00:00',8.97),('10318','2014-04-21','14:05:00',8.92),('10318','2014-04-21','14:10:00',8.87),('10318','2014-04-21','14:15:00',8.79),('10318','2014-04-21','14:20:00',8.71),('10318','2014-04-21','14:25:00',8.62),('10318','2014-04-21','14:30:00',8.49),('10318','2014-04-21','14:35:00',8.43),('10318','2014-04-21','14:40:00',8.34),('10318','2014-04-21','14:45:00',8.24),('10318','2014-04-21','14:50:00',8.14),('10318','2014-04-21','14:55:00',8.06),('10318','2014-04-21','15:00:00',7.97),('10318','2014-04-21','15:05:00',7.85),('10318','2014-04-21','15:10:00',7.57),('10318','2014-04-21','15:15:00',7.52),('10318','2014-04-21','15:20:00',7.42),('10318','2014-04-21','15:25:00',7.29),('10318','2014-04-21','15:30:00',7.14),('10318','2014-04-21','15:35:00',7.01),('10318','2014-04-21','15:40:00',6.87),('10318','2014-04-21','15:45:00',6.75),('10318','2014-04-21','15:50:00',6.59),('10318','2014-04-21','15:55:00',6.45),('10318','2014-04-21','16:00:00',6.31),('10318','2014-04-21','16:05:00',6.19),('10318','2014-04-21','16:10:00',6.05),('10318','2014-04-21','16:15:00',6.08),('10318','2014-04-21','16:20:00',5.66),('10318','2014-04-21','16:25:00',5.56),('10318','2014-04-21','16:30:00',5.45),('10318','2014-04-21','16:35:00',5.18),('10318','2014-04-21','16:40:00',4.97),('10318','2014-04-21','16:45:00',4.79),('10318','2014-04-21','16:50:00',4.6),('10318','2014-04-21','16:55:00',4.36),('10318','2014-04-21','17:00:00',4.23),('10318','2014-04-21','17:05:00',4.07),('10318','2014-04-21','17:10:00',3.88),('10318','2014-04-21','17:15:00',3.69),('10318','2014-04-21','17:20:00',3.53),('10318','2014-04-21','17:25:00',3.34),('10318','2014-04-21','17:30:00',3.15),('10318','2014-04-21','17:35:00',2.95),('10318','2014-04-21','17:40:00',2.75),('10318','2014-04-21','17:45:00',2.58),('10318','2014-04-21','17:50:00',2.4),('10318','2014-04-21','17:55:00',2.22),('10318','2014-04-21','18:00:00',2.06),('10318','2014-04-21','18:05:00',1.9),('10318','2014-04-21','18:10:00',1.75),('10318','2014-04-21','18:15:00',1.56),('10318','2014-04-21','18:20:00',1.42),('10318','2014-04-21','18:25:00',1.26),('10318','2014-04-21','18:30:00',1.11),('10318','2014-04-20','07:40:00',2.23),('10318','2014-04-20','07:45:00',2.91),('10318','2014-04-20','07:50:00',2.79),('10318','2014-04-20','07:55:00',2.24),('10318','2014-04-20','08:00:00',3.27),('10318','2014-04-20','08:05:00',3.66),('10318','2014-04-20','08:10:00',4.33),('10318','2014-04-20','08:15:00',4.66),('10318','2014-04-20','08:20:00',3.33),('10318','2014-04-20','08:25:00',1.05),('10318','2014-04-20','08:30:00',1.14),('10318','2014-04-20','08:35:00',3.64),('10318','2014-04-20','08:40:00',1.68),('10318','2014-04-20','08:45:00',1.42),('10318','2014-04-20','08:50:00',2.48),('10318','2014-04-20','08:55:00',5.67),('10318','2014-04-20','09:00:00',5.78),('10318','2014-04-20','09:05:00',5.4),('10318','2014-04-20','09:10:00',6.76),('10318','2014-04-20','09:15:00',5.98),('10318','2014-04-20','09:20:00',6.41),('10318','2014-04-20','09:25:00',5.97),('10318','2014-04-20','09:30:00',3.7),('10318','2014-04-20','09:35:00',8.57),('10318','2014-04-20','09:40:00',6.51),('10318','2014-04-20','09:45:00',4.21),('10318','2014-04-20','09:50:00',4.22),('10318','2014-04-20','09:55:00',4.8),('10318','2014-04-20','10:00:00',5.73),('10318','2014-04-20','10:05:00',7.22),('10318','2014-04-20','10:10:00',6.18),('10318','2014-04-20','10:15:00',7.23),('10318','2014-04-20','10:20:00',8.14),('10318','2014-04-20','10:25:00',6.43),('10318','2014-04-20','10:30:00',5.76),('10318','2014-04-20','10:35:00',6.27),('10318','2014-04-20','10:40:00',6.12),('10318','2014-04-20','10:45:00',6.48),('10318','2014-04-20','10:50:00',7.62),('10318','2014-04-20','10:55:00',7.42),('10318','2014-04-20','11:00:00',8.49),('10318','2014-04-20','11:05:00',8.89),('10318','2014-04-20','11:10:00',8.66),('10318','2014-04-20','11:15:00',8.97),('10318','2014-04-20','11:20:00',9.12),('10318','2014-04-20','11:25:00',9.69),('10318','2014-04-20','11:30:00',9.85),('10318','2014-04-20','11:35:00',9.19),('10318','2014-04-20','11:40:00',9.68),('10318','2014-04-20','11:45:00',9.68),('10318','2014-04-20','11:50:00',9.79),('10318','2014-04-20','11:55:00',9.87),('10318','2014-04-20','12:00:00',9.78),('10318','2014-04-20','12:05:00',9.54),('10318','2014-04-20','12:10:00',9.91),('10318','2014-04-20','12:15:00',8.76),('10318','2014-04-20','12:20:00',10.37),('10318','2014-04-20','12:25:00',8.15),('10318','2014-04-20','12:30:00',5.89),('10318','2014-04-20','12:35:00',8.84),('10318','2014-04-20','12:40:00',8.67),('10318','2014-04-20','12:45:00',10.18),('10318','2014-04-20','12:50:00',10.41),('10318','2014-04-20','12:55:00',10.28),('10318','2014-04-20','13:00:00',9.97),('10318','2014-04-20','13:05:00',9.93),('10318','2014-04-20','13:10:00',9.72),('10318','2014-04-20','13:15:00',9.76),('10318','2014-04-20','13:20:00',9.52),('10318','2014-04-20','13:25:00',9.5),('10318','2014-04-20','13:30:00',9.52),('10318','2014-04-20','13:35:00',9.57),('10318','2014-04-20','13:40:00',9.54),('10318','2014-04-20','13:45:00',9.47),('10318','2014-04-20','13:50:00',9.41),('10318','2014-04-20','13:55:00',9.37),('10318','2014-04-20','14:00:00',9.26),('10318','2014-04-20','14:05:00',9.12),('10318','2014-04-20','14:10:00',9.22),('10318','2014-04-20','14:15:00',8.9),('10318','2014-04-20','14:20:00',6.86),('10318','2014-04-20','14:25:00',6.35),('10318','2014-04-20','14:30:00',6.15),('10318','2014-04-20','14:35:00',5.26),('10318','2014-04-20','14:40:00',5.29),('10318','2014-04-20','14:45:00',5.71),('10318','2014-04-20','14:50:00',5.67),('10318','2014-04-20','14:55:00',6.52),('10318','2014-04-20','15:00:00',8.96),('10318','2014-04-20','15:05:00',8.12),('10318','2014-04-20','15:10:00',8.16),('10318','2014-04-20','15:15:00',7.84),('10318','2014-04-20','15:20:00',7.6),('10318','2014-04-20','15:25:00',7.45),('10318','2014-04-20','15:30:00',7.35),('10318','2014-04-20','15:35:00',7.37),('10318','2014-04-20','15:40:00',7.39),('10318','2014-04-20','15:45:00',5.55),('10318','2014-04-20','15:50:00',6.4),('10318','2014-04-20','15:55:00',6.76),('10318','2014-04-20','16:00:00',6.53),('10318','2014-04-20','16:05:00',6.35),('10318','2014-04-20','16:10:00',6.21),('10318','2014-04-20','16:15:00',6.12),('10318','2014-04-20','16:20:00',6.08),('10318','2014-04-20','16:25:00',5.42),('10318','2014-04-20','16:30:00',5.15),('10318','2014-04-20','16:35:00',5.5),('10318','2014-04-20','16:40:00',4.72),('10318','2014-04-20','16:45:00',3.97),('10318','2014-04-20','16:50:00',4.89),('10318','2014-04-20','16:55:00',4.84),('10318','2014-04-20','17:00:00',4.5),('10318','2014-04-20','17:05:00',4.21),('10318','2014-04-20','17:10:00',3.95),('10318','2014-04-20','17:15:00',3.74),('10318','2014-04-20','17:20:00',3.51),('10318','2014-04-20','17:25:00',3.33),('10318','2014-04-20','17:30:00',3.12),('10318','2014-04-20','17:35:00',2.93),('10318','2014-04-20','17:40:00',2.75),('10318','2014-04-20','17:45:00',2.56),('10318','2014-04-20','17:50:00',2.38),('10318','2014-04-20','17:55:00',2.22),('10318','2014-04-20','18:00:00',2.05),('10318','2014-04-20','18:05:00',1.88),('10318','2014-04-20','18:10:00',1.72),('10318','2014-04-20','18:15:00',1.54),('10318','2014-04-20','18:20:00',1.03),('10318','2014-04-20','18:30:00',1.13),('10318','2014-04-20','18:35:00',1.16),('10318','2013-11-23','08:15:00',1.19),('10318','2013-11-23','08:20:00',1.69),('10318','2013-11-23','08:25:00',1.46),('10318','2013-11-23','08:30:00',1.01),('10318','2013-11-23','08:35:00',1.56),('10318','2013-11-23','08:40:00',1.66),('10318','2013-11-23','08:45:00',1.14),('10318','2013-11-23','09:55:00',1.18),('10318','2013-11-23','10:00:00',1.37),('10318','2013-11-23','10:05:00',1.46),('10318','2013-11-23','10:10:00',1.51),('10318','2013-11-23','10:15:00',2.7),('10318','2013-11-23','10:20:00',3),('10318','2013-11-23','10:25:00',4.73),('10318','2013-11-23','10:30:00',6.25),('10318','2013-11-23','10:35:00',5.16),('10318','2013-11-23','10:40:00',3.57),('10318','2013-11-23','11:15:00',1.03),('10318','2013-11-23','11:25:00',1.43),('10318','2013-11-23','11:30:00',1.06),('10318','2013-11-23','11:40:00',1.49),('10318','2013-11-23','11:45:00',1.43),('10318','2013-11-23','11:50:00',1.28),('10318','2013-11-22','09:20:00',1.09),('10318','2013-11-22','09:25:00',1.13),('10318','2013-11-22','09:30:00',1.26),('10318','2013-11-22','09:35:00',1.17),('10318','2013-11-22','09:40:00',1),('10318','2013-11-22','09:45:00',1.01),('10318','2013-11-22','09:55:00',1.07),('10318','2013-11-22','10:00:00',1.4),('10318','2013-11-22','10:05:00',1.34),('10318','2013-11-22','10:10:00',1.08),('10318','2013-11-22','12:15:00',1.04),('10318','2013-11-22','12:20:00',1.06),('10318','2013-11-21','08:00:00',1.54),('10318','2013-11-21','08:05:00',2.82),('10318','2013-11-21','08:10:00',3.68),('10318','2013-11-21','08:15:00',3.4),('10318','2013-11-21','09:05:00',1.66),('10318','2013-11-21','09:10:00',2.91),('10318','2013-11-21','09:15:00',2.02),('10318','2013-11-21','09:20:00',2.69),('10318','2013-11-21','09:25:00',2.8),('10318','2013-11-21','09:30:00',2.1),('10318','2013-11-21','09:35:00',2.35),('10318','2013-11-21','09:40:00',2.37),('10318','2013-11-21','09:45:00',4.41),('10318','2013-11-21','09:50:00',6.22),('10318','2013-11-21','09:55:00',4.4),('10318','2013-11-21','10:00:00',3.72),('10318','2013-11-21','10:05:00',3.67),('10318','2013-11-21','10:10:00',5.47),('10318','2013-11-21','10:15:00',6.88),('10318','2013-11-21','10:20:00',4.42),('10318','2013-11-21','10:25:00',4.09),('10318','2013-11-21','10:30:00',7.06),('10318','2013-11-21','10:35:00',7.27),('10318','2013-11-21','10:40:00',5.53),('10318','2013-11-21','10:45:00',1.94),('10318','2013-11-21','10:50:00',1.54),('10318','2013-11-21','10:55:00',1.37),('10318','2013-11-21','11:00:00',2.11),('10318','2013-11-21','11:05:00',2.33),('10318','2013-11-21','11:10:00',1.85),('10318','2013-11-21','11:15:00',4.61),('10318','2013-11-21','11:20:00',7.1),('10318','2013-11-21','11:25:00',7.46),('10318','2013-11-21','11:30:00',5.96),('10318','2013-11-21','11:35:00',6.23),('10318','2013-11-21','11:40:00',7.16),('10318','2013-11-21','11:45:00',7.02),('10318','2013-11-21','11:50:00',7.13),('10318','2013-11-21','11:55:00',4.42),('10318','2013-11-21','12:00:00',6.83),('10318','2013-11-21','12:05:00',3.99),('10318','2013-11-21','12:10:00',2.09),('10318','2013-11-21','12:15:00',5.25),('10318','2013-11-21','12:20:00',4.75),('10318','2013-11-21','12:25:00',5.99),('10318','2013-11-21','12:30:00',7.63),('10318','2013-11-21','12:35:00',7.73),('10318','2013-11-21','12:40:00',5.78),('10318','2013-11-21','12:45:00',6.04),('10318','2013-11-21','12:50:00',7.6),('10318','2013-11-21','12:55:00',6.36),('10318','2013-11-21','13:00:00',4.28),('10318','2013-11-21','13:05:00',1.47),('10318','2013-11-21','13:10:00',3.68),('10318','2013-11-21','13:15:00',2.92),('10318','2013-11-21','13:20:00',1.36),('10318','2013-11-21','13:25:00',1.04),('10318','2013-11-21','13:35:00',2.23),('10318','2013-11-21','13:40:00',5.93),('10318','2013-11-21','13:45:00',5.67),('10318','2013-11-21','13:50:00',5.88),('10318','2013-11-21','13:55:00',5.02),('10318','2013-11-21','14:00:00',1.69),('10318','2013-11-21','14:05:00',1.07),('10318','2013-11-21','14:10:00',3.67),('10318','2013-11-21','14:15:00',3.82),('10318','2013-11-21','14:20:00',1.47),('10318','2013-11-21','14:25:00',2.93),('10318','2013-11-21','14:30:00',4.03),('10318','2013-11-21','14:35:00',3.83),('10318','2013-11-21','14:40:00',3.68),('10318','2013-11-21','14:45:00',3.48),('10318','2013-11-21','14:50:00',3.37),('10318','2013-11-21','14:55:00',3.21),('10318','2013-11-21','15:00:00',3.05),('10318','2013-11-21','15:05:00',2.88),('10318','2013-11-21','15:10:00',1.8),('10318','2013-11-21','15:30:00',1.86),('10318','2013-11-21','15:35:00',2.49),('10318','2013-11-21','15:40:00',1.21),('10318','2013-11-20','08:10:00',1.6),('10318','2013-11-20','08:15:00',3.69),('10318','2013-11-20','08:20:00',1.64),('10318','2013-11-20','08:50:00',2.08),('10318','2013-11-20','08:55:00',2.01),('10318','2013-11-20','09:00:00',4.73),('10318','2013-11-20','09:05:00',5.02),('10318','2013-11-20','09:10:00',5.04),('10318','2013-11-20','09:15:00',5.12),('10318','2013-11-20','09:20:00',5.59),('10318','2013-11-20','09:25:00',3.94),('10318','2013-11-20','09:30:00',3.36),('10318','2013-11-20','09:35:00',1.86),('10318','2013-11-20','09:45:00',1.02),('10318','2013-11-20','09:50:00',1.19),('10318','2013-11-20','09:55:00',2),('10318','2013-11-20','10:00:00',1.49),('10318','2013-11-20','10:10:00',1.11),('10318','2013-11-20','10:15:00',1.02),('10318','2013-11-20','10:20:00',1.25),('10318','2013-11-20','10:25:00',1.81),('10318','2013-11-20','10:30:00',2.46),('10318','2013-11-20','10:35:00',1.55),('10318','2013-11-20','10:40:00',1.3),('10318','2013-11-20','10:45:00',1.86),('10318','2013-11-20','10:50:00',1.99),('10318','2013-11-20','10:55:00',1.46),('10318','2013-11-20','11:00:00',1.45),('10318','2013-11-20','11:05:00',1.47),('10318','2013-11-20','11:10:00',1.25),('10318','2013-11-20','11:15:00',1.51),('10318','2013-11-20','11:20:00',2.61),('10318','2013-11-20','11:25:00',3.16),('10318','2013-11-20','11:30:00',3.38),('10318','2013-11-20','11:35:00',3.36),('10318','2013-11-20','11:40:00',5.89),('10318','2013-11-20','11:45:00',3.24),('10318','2013-11-20','11:50:00',3.33),('10318','2013-11-20','11:55:00',1.34),('10318','2013-11-20','12:00:00',1.08),('10318','2013-11-20','12:05:00',1.87),('10318','2013-11-20','12:10:00',1.64),('10318','2013-11-20','12:15:00',3.2),('10318','2013-11-20','12:20:00',6.4),('10318','2013-11-20','12:25:00',3.4),('10318','2013-11-20','12:30:00',1.42),('10318','2013-11-20','12:35:00',1.4),('10318','2013-11-20','12:40:00',2.07),('10318','2013-11-20','12:45:00',3.24),('10318','2013-11-20','12:50:00',4.42),('10318','2013-11-20','12:55:00',3.13),('10318','2013-11-20','13:00:00',2.74),('10318','2013-11-20','13:05:00',3.01),('10318','2013-11-20','13:10:00',2.07),('10318','2013-11-20','13:15:00',2.73),('10318','2013-11-20','13:20:00',2.48),('10318','2013-11-20','13:25:00',2.59),('10318','2013-11-20','13:30:00',2.41),('10318','2013-11-20','13:35:00',4.73),('10318','2013-11-20','13:40:00',2.43),('10318','2013-11-20','13:45:00',2.98),('10318','2013-11-20','13:50:00',3.74),('10318','2013-11-20','13:55:00',1.89),('10318','2013-11-20','14:00:00',1.96),('10318','2013-11-20','14:05:00',1.71),('10318','2013-11-20','14:10:00',1.73),('10318','2013-11-20','14:15:00',1.89),('10318','2013-11-20','14:20:00',2.32),('10318','2013-11-20','14:25:00',1.72),('10318','2013-11-20','14:30:00',2.07),('10318','2013-11-20','14:35:00',1.42),('10318','2013-11-20','14:40:00',2.58),('10318','2013-11-20','14:45:00',1.5),('10318','2013-11-20','14:55:00',1.65),('10318','2013-11-20','15:00:00',3.47),('10318','2013-11-20','15:05:00',2.73),('10318','2013-11-20','15:10:00',1.72),('10318','2013-11-20','15:15:00',1.82),('10318','2013-11-20','15:20:00',1.13),('10318','2013-11-20','15:25:00',1.03),('10318','2013-11-20','15:30:00',1.13),('10318','2013-11-20','15:40:00',1.03),('10318','2013-11-19','08:10:00',1.56),('10318','2013-11-19','08:15:00',1.02),('10318','2013-11-19','08:30:00',1.39),('10318','2013-11-19','08:35:00',1.18),('10318','2013-11-19','09:00:00',1.35),('10318','2013-11-19','09:05:00',1.22),('10318','2013-11-19','09:15:00',1.07),('10318','2013-11-19','09:30:00',1.06),('10318','2013-11-19','09:35:00',5.5),('10318','2013-11-19','09:40:00',5.51),('10318','2013-11-19','09:45:00',5.77),('10318','2013-11-19','09:50:00',4),('10318','2013-11-19','09:55:00',3.08),('10318','2013-11-19','10:00:00',3.15),('10318','2013-11-19','10:05:00',3.9),('10318','2013-11-19','10:10:00',2.79),('10318','2013-11-19','10:15:00',2.06),('10318','2013-11-19','10:20:00',2.1),('10318','2013-11-19','10:25:00',1.16),('10318','2013-11-19','10:50:00',1),('10318','2013-11-19','10:55:00',1.05),('10318','2013-11-19','11:00:00',1.03),('10318','2013-11-19','11:05:00',1.09),('10318','2013-11-19','11:10:00',1.76),('10318','2013-11-19','11:15:00',3.09),('10318','2013-11-19','11:20:00',3.97),('10318','2013-11-19','11:25:00',7.31),('10318','2013-11-19','11:30:00',2.29),('10318','2013-11-19','11:35:00',7.43),('10318','2013-11-19','11:40:00',6.55),('10318','2013-11-19','11:45:00',6.57),('10318','2013-11-19','11:50:00',6.47),('10318','2013-11-19','11:55:00',6.42),('10318','2013-11-19','12:00:00',6.42),('10318','2013-11-19','12:05:00',6.4),('10318','2013-11-19','12:10:00',6.32),('10318','2013-11-19','12:15:00',5.39),('10318','2013-11-19','12:20:00',5.9),('10318','2013-11-19','12:25:00',1.87),('10318','2013-11-19','12:30:00',1.57),('10318','2013-11-19','12:35:00',1.45),('10318','2013-11-19','12:40:00',5.81),('10318','2013-11-19','12:45:00',5.72),('10318','2013-11-19','12:50:00',3.05),('10318','2013-11-19','12:55:00',4.81),('10318','2013-11-19','13:00:00',2.36),('10318','2013-11-19','13:05:00',1.79),('10318','2013-11-19','13:10:00',1.82),('10318','2013-11-19','13:15:00',2.38),('10318','2013-11-19','13:20:00',1.21),('10318','2013-11-19','13:30:00',1.52),('10318','2013-11-19','13:35:00',1.77),('10318','2013-11-19','14:25:00',1.18),('10318','2013-11-19','14:30:00',2.35),('10318','2013-11-19','14:35:00',2.04),('10318','2013-11-19','14:40:00',2.09),('10318','2013-11-19','14:45:00',1.45),('10318','2013-11-19','14:50:00',1.43),('10318','2013-11-19','14:55:00',1.33),('10318','2013-11-19','15:20:00',1.28),('10318','2013-11-19','15:25:00',2.74),('10318','2013-11-19','15:30:00',3.51),('10318','2013-11-19','15:35:00',2.53),('10318','2013-11-19','15:40:00',2.11),('10318','2013-11-19','15:45:00',1.83),('10318','2013-11-19','15:50:00',1.54),('10318','2013-11-19','15:55:00',1.2),('10318','2013-11-18','07:35:00',1.1),('10318','2013-11-18','07:40:00',1.16),('10318','2013-11-18','07:50:00',1.61),('10318','2013-11-18','07:55:00',1.91),('10318','2013-11-18','08:00:00',2.11),('10318','2013-11-18','08:05:00',3.4),('10318','2013-11-18','08:10:00',2.54),('10318','2013-11-18','08:15:00',2.77),('10318','2013-11-18','08:20:00',2.74),('10318','2013-11-18','08:25:00',3.07),('10318','2013-11-18','08:30:00',3.15),('10318','2013-11-18','08:35:00',3.44),('10318','2013-11-18','08:40:00',2.82),('10318','2013-11-18','08:45:00',2.77),('10318','2013-11-18','08:50:00',2.54),('10318','2013-11-18','08:55:00',2.6),('10318','2013-11-18','09:00:00',2.36),('10318','2013-11-18','09:05:00',2.1),('10318','2013-11-18','09:10:00',2.1),('10318','2013-11-18','09:15:00',3.23),('10318','2013-11-18','09:20:00',3.98),('10318','2013-11-18','09:25:00',4.48),('10318','2013-11-18','09:30:00',4.53),('10318','2013-11-18','09:35:00',5.72),('10318','2013-11-18','09:40:00',3.66),('10318','2013-11-18','09:45:00',2.69),('10318','2013-11-18','09:50:00',2.47),('10318','2013-11-18','09:55:00',2.51),('10318','2013-11-18','10:00:00',2.83),('10318','2013-11-18','10:05:00',3.54),('10318','2013-11-18','10:10:00',4.43),('10318','2013-11-18','10:15:00',4.3),('10318','2013-11-18','10:20:00',3.52),('10318','2013-11-18','10:25:00',2.92),('10318','2013-11-18','10:30:00',2.71),('10318','2013-11-18','10:35:00',2.78),('10318','2013-11-18','10:40:00',2.95),('10318','2013-11-18','10:45:00',2.99),('10318','2013-11-18','10:50:00',2.83),('10318','2013-11-18','10:55:00',2.42),('10318','2013-11-18','11:00:00',2.17),('10318','2013-11-18','11:05:00',1.97),('10318','2013-11-18','11:10:00',1.78),('10318','2013-11-18','11:15:00',1.69),('10318','2013-11-18','11:20:00',1.9),('10318','2013-11-18','11:25:00',2.24),('10318','2013-11-18','11:30:00',2.5),('10318','2013-11-18','11:35:00',2.64),('10318','2013-11-18','11:40:00',2.68),('10318','2013-11-18','11:45:00',2.75),('10318','2013-11-18','11:50:00',2.92),('10318','2013-11-18','11:55:00',3.15),('10318','2013-11-18','12:00:00',3.3),('10318','2013-11-18','12:05:00',3.36),('10318','2013-11-18','12:10:00',3.34),('10318','2013-11-18','12:15:00',3.54),('10318','2013-11-18','12:20:00',3.99),('10318','2013-11-18','12:25:00',4.42),('10318','2013-11-18','12:30:00',3.81),('10318','2013-11-18','12:35:00',3.15),('10318','2013-11-18','12:40:00',2.54),('10318','2013-11-18','12:45:00',2.26),('10318','2013-11-18','12:50:00',2.08),('10318','2013-11-18','12:55:00',2.01),('10318','2013-11-18','13:00:00',2),('10318','2013-11-18','13:05:00',2.08),('10318','2013-11-18','13:10:00',2.5),('10318','2013-11-18','13:15:00',2.08),('10318','2013-11-18','13:20:00',1.93),('10318','2013-11-18','13:25:00',1.81),('10318','2013-11-18','13:30:00',2.04),('10318','2013-11-18','13:35:00',2.41),('10318','2013-11-18','13:40:00',2.59),('10318','2013-11-18','13:45:00',2.55),('10318','2013-11-18','13:50:00',2.15),('10318','2013-11-18','13:55:00',2),('10318','2013-11-18','14:00:00',1.7),('10318','2013-11-18','14:05:00',1.44),('10318','2013-11-18','14:10:00',1.29),('10318','2013-11-18','14:15:00',1.06),('10318','2013-11-18','14:25:00',1.1),('10318','2013-11-18','14:30:00',1.08),('10318','2013-11-18','14:35:00',1.01),('10318','2013-11-18','14:40:00',1.01),('10318','2013-11-18','14:45:00',1.02),('10318','2013-11-18','14:50:00',1.02),('10318','2014-04-19','07:25:00',1.33),('10318','2014-04-19','07:30:00',1.71),('10318','2014-04-19','07:35:00',2.36),('10318','2014-04-19','07:40:00',2.29),('10318','2014-04-19','07:45:00',1.81),('10318','2014-04-19','07:50:00',3.71),('10318','2014-04-19','07:55:00',4.91),('10318','2014-04-19','08:00:00',2.54),('10318','2014-04-19','08:05:00',2.79),('10318','2014-04-19','08:10:00',3.73),('10318','2014-04-19','08:15:00',3.1),('10318','2014-04-19','08:20:00',3.43),('10318','2014-04-19','08:25:00',5.12),('10318','2014-04-19','08:30:00',4.38),('10318','2014-04-19','08:35:00',3.62),('10318','2014-04-19','08:40:00',4.92),('10318','2014-04-19','08:45:00',3.64),('10318','2014-04-19','08:50:00',2.74),('10318','2014-04-19','08:55:00',1.7),('10318','2014-04-19','09:00:00',1.25),('10318','2014-04-19','09:05:00',1.21),('10318','2014-04-19','09:10:00',1.55),('10318','2014-04-19','09:15:00',2.14),('10318','2014-04-19','09:20:00',2.84),('10318','2014-04-19','09:25:00',4.19),('10318','2014-04-19','09:30:00',6.25),('10318','2014-04-19','09:35:00',3.27),('10318','2014-04-19','09:40:00',2.16),('10318','2014-04-19','09:45:00',1.74),('10318','2014-04-19','09:50:00',1.59),('10318','2014-04-19','09:55:00',1.53),('10318','2014-04-19','10:00:00',1.43),('10318','2014-04-19','10:05:00',1.1),('10318','2014-04-19','10:10:00',1.21),('10318','2014-04-19','10:15:00',1.55),('10318','2014-04-19','10:20:00',1.67),('10318','2014-04-19','10:25:00',1.86),('10318','2014-04-19','10:30:00',2.03),('10318','2014-04-19','10:35:00',2.56),('10318','2014-04-19','10:40:00',2.91),('10318','2014-04-19','10:45:00',2.87),('10318','2014-04-19','10:50:00',3.41),('10318','2014-04-19','10:55:00',4.09),('10318','2014-04-19','11:00:00',3.22),('10318','2014-04-19','11:05:00',2.81),('10318','2014-04-19','11:10:00',3.42),('10318','2014-04-19','11:15:00',5.15),('10318','2014-04-19','11:20:00',6.53),('10318','2014-04-19','11:25:00',6.61),('10318','2014-04-19','11:30:00',4.92),('10318','2014-04-19','11:35:00',5.44),('10318','2014-04-19','11:40:00',7.34),('10318','2014-04-19','11:45:00',4.47),('10318','2014-04-19','11:50:00',3.01),('10318','2014-04-19','11:55:00',2.13),('10318','2014-04-19','12:00:00',1.83),('10318','2014-04-19','12:05:00',1.32),('10318','2014-04-19','12:10:00',1.02),('10318','2014-04-19','12:15:00',1.02),('10318','2014-04-19','13:15:00',2.05),('10318','2014-04-19','13:20:00',2.72),('10318','2014-04-19','13:25:00',1.49),('10318','2014-04-19','13:30:00',1.57),('10318','2014-04-19','13:35:00',2.3),('10318','2014-04-19','13:40:00',1.9),('10318','2014-04-19','13:45:00',1.34),('10318','2014-04-19','13:50:00',1.72),('10318','2014-04-19','13:55:00',1.88),('10318','2014-04-19','14:00:00',1.4),('10318','2014-04-19','14:10:00',1.38),('10318','2014-04-19','14:15:00',1.49),('10318','2014-04-19','14:20:00',1.11),('10318','2014-04-19','14:25:00',1.86),('10318','2014-04-19','14:30:00',3.61),('10318','2014-04-19','14:35:00',2.69),('10318','2014-04-19','14:40:00',4.04),('10318','2014-04-19','14:45:00',4.26),('10318','2014-04-19','14:50:00',2.83),('10318','2014-04-19','14:55:00',2.35),('10318','2014-04-19','15:00:00',3.6),('10318','2014-04-19','15:05:00',3.02),('10318','2014-04-19','15:10:00',1.17),('10318','2014-04-19','15:20:00',1.53),('10318','2014-04-19','15:25:00',2.76),('10318','2014-04-19','15:30:00',1.91),('10318','2014-04-19','15:35:00',1.22),('10318','2014-04-19','15:40:00',2.59),('10318','2014-04-19','15:45:00',4.14),('10318','2014-04-19','15:50:00',4.33),('10318','2014-04-19','15:55:00',5.35),('10318','2014-04-19','16:00:00',6.18),('10318','2014-04-19','16:05:00',4.46),('10318','2014-04-19','16:10:00',3.61),('10318','2014-04-19','16:15:00',4.47),('10318','2014-04-19','16:20:00',4),('10318','2014-04-19','16:25:00',4.57),('10318','2014-04-19','16:30:00',5.54),('10318','2014-04-19','16:35:00',2.88),('10318','2014-04-19','16:40:00',2.75),('10318','2014-04-19','16:45:00',2.5),('10318','2014-04-19','16:50:00',1.72),('10318','2014-04-19','16:55:00',1.36),('10318','2014-04-19','17:00:00',1.88),('10318','2014-04-19','17:05:00',2.85),('10318','2014-04-19','17:10:00',2.18),('10318','2014-04-19','17:15:00',3.44),('10318','2014-04-19','17:20:00',3.43),('10318','2014-04-19','17:25:00',2.43),('10318','2014-04-19','17:30:00',2.29),('10318','2014-04-19','17:35:00',1.91),('10318','2014-04-19','17:40:00',1.32),('10318','2014-04-19','17:45:00',1.24),('10318','2014-04-19','17:50:00',1.05),('10318','2013-11-17','08:35:00',1.29),('10318','2013-11-17','08:40:00',1.41),('10318','2013-11-17','08:45:00',1.53),('10318','2013-11-17','08:50:00',3.65),('10318','2013-11-17','08:55:00',5.87),('10318','2013-11-17','09:00:00',5.56),('10318','2013-11-17','09:05:00',5.28),('10318','2013-11-17','09:10:00',5.55),('10318','2013-11-17','09:15:00',5.02),('10318','2013-11-17','09:20:00',5.33),('10318','2013-11-17','09:25:00',4.51),('10318','2013-11-17','09:30:00',5.56),('10318','2013-11-17','09:35:00',5.96),('10318','2013-11-17','09:40:00',6.07),('10318','2013-11-17','09:45:00',6.08),('10318','2013-11-17','09:50:00',6.11),('10318','2013-11-17','09:55:00',6.2),('10318','2013-11-17','10:00:00',6.27),('10318','2013-11-17','10:05:00',6.35),('10318','2013-11-17','10:10:00',6.35),('10318','2013-11-17','10:15:00',6.49),('10318','2013-11-17','10:20:00',6.57),('10318','2013-11-17','10:25:00',6.6),('10318','2013-11-17','10:30:00',6.65),('10318','2013-11-17','10:35:00',6.67),('10318','2013-11-17','10:40:00',6.7),('10318','2013-11-17','10:45:00',6.75),('10318','2013-11-17','10:50:00',6.78),('10318','2013-11-17','10:55:00',6.8),('10318','2013-11-17','11:00:00',6.78),('10318','2013-11-17','11:05:00',6.78),('10318','2013-11-17','11:10:00',6.75),('10318','2013-11-17','11:15:00',6.82),('10318','2013-11-17','11:20:00',6.78),('10318','2013-11-17','11:25:00',6.72),('10318','2013-11-17','11:30:00',6.73),('10318','2013-11-17','11:35:00',6.73),('10318','2013-11-17','11:40:00',6.7),('10318','2013-11-17','11:45:00',6.7),('10318','2013-11-17','11:50:00',6.66),('10318','2013-11-17','11:55:00',6.59),('10318','2013-11-17','12:00:00',6.58),('10318','2013-11-17','12:05:00',6.52),('10318','2013-11-17','12:10:00',6.48),('10318','2013-11-17','12:15:00',6.37),('10318','2013-11-17','12:20:00',6.31),('10318','2013-11-17','12:25:00',6.25),('10318','2013-11-17','12:30:00',6.02),('10318','2013-11-17','12:35:00',6.1),('10318','2013-11-17','12:40:00',6.11),('10318','2013-11-17','12:45:00',6.01),('10318','2013-11-17','12:50:00',5.94),('10318','2013-11-17','12:55:00',5.88),('10318','2013-11-17','13:00:00',5.81),('10318','2013-11-17','13:05:00',5.7),('10318','2013-11-17','13:10:00',5.52),('10318','2013-11-17','13:15:00',5.54),('10318','2013-11-17','13:20:00',5.47),('10318','2013-11-17','13:25:00',5.4),('10318','2013-11-17','13:30:00',5.32),('10318','2013-11-17','13:35:00',5.23),('10318','2013-11-17','13:40:00',5.14),('10318','2013-11-17','13:45:00',5.01),('10318','2013-11-17','13:50:00',4.76),('10318','2013-11-17','13:55:00',1.07),('10318','2013-11-17','14:05:00',1.81),('10318','2013-11-17','14:10:00',4.47),('10318','2013-11-17','14:15:00',4.06),('10318','2013-11-17','14:20:00',3.88),('10318','2013-11-17','14:25:00',3.85),('10318','2013-11-17','14:30:00',3.68),('10318','2013-11-17','14:35:00',3.49),('10318','2013-11-17','14:40:00',3.33),('10318','2013-11-17','14:45:00',3.13),('10318','2013-11-17','14:50:00',1.91),('10318','2013-11-17','14:55:00',1.55),('10318','2013-11-17','15:05:00',1.01),('10318','2013-11-17','15:10:00',2.63),('10318','2013-11-17','15:15:00',2.77),('10318','2013-11-17','15:20:00',2.75),('10318','2013-11-17','15:25:00',2.56),('10318','2013-11-17','15:30:00',2.17),('10318','2013-11-17','15:35:00',1.93),('10318','2013-11-17','15:40:00',1.74),('10318','2013-11-17','15:45:00',1.57),('10318','2013-11-17','15:50:00',1.4),('10318','2013-11-17','15:55:00',1.34),('10318','2013-11-17','16:00:00',1.18),('10318','2013-11-17','16:05:00',1.04),('10318','2013-11-16','12:45:00',1.24),('10318','2013-11-16','12:50:00',1.97),('10318','2013-11-16','12:55:00',2.12),('10318','2013-11-16','13:00:00',2.42),('10318','2013-11-16','13:05:00',2.48),('10318','2013-11-16','13:10:00',2.28),('10318','2013-11-16','13:15:00',1.83),('10318','2013-11-16','13:20:00',1.49),('10318','2013-11-16','13:25:00',1.33),('10318','2013-11-16','13:30:00',1.3),('10318','2013-11-16','13:35:00',1.13),('10318','2013-11-16','13:45:00',1.03),('10318','2013-11-16','13:50:00',1.16),('10318','2013-11-16','13:55:00',1.21),('10318','2013-11-16','14:00:00',1.19),('10318','2013-11-16','14:05:00',1.09),('10318','2013-11-15','08:10:00',1.94),('10318','2013-11-15','08:15:00',1.58),('10318','2013-11-15','08:40:00',1.11),('10318','2013-11-15','08:45:00',1.3),('10318','2013-11-15','08:50:00',1.28),('10318','2013-11-15','08:55:00',1.36),('10318','2013-11-15','09:00:00',1.61),('10318','2013-11-15','09:05:00',1.87),('10318','2013-11-15','09:10:00',2.45),('10318','2013-11-15','09:15:00',3.09),('10318','2013-11-15','09:20:00',2.88),('10318','2013-11-15','09:25:00',2.39),('10318','2013-11-15','09:30:00',2.68),('10318','2013-11-15','09:35:00',3.44),('10318','2013-11-15','09:40:00',2.81),('10318','2013-11-15','09:45:00',2.21),('10318','2013-11-15','09:50:00',1.73),('10318','2013-11-15','09:55:00',1.76),('10318','2013-11-15','10:00:00',1.8),('10318','2013-11-15','10:05:00',1.91),('10318','2013-11-15','10:10:00',2.46),('10318','2013-11-15','10:15:00',3.53),('10318','2013-11-15','10:20:00',3.11),('10318','2013-11-15','10:25:00',2.62),('10318','2013-11-15','10:30:00',2.35),('10318','2013-11-15','10:35:00',1.98),('10318','2013-11-15','10:40:00',1.83),('10318','2013-11-15','10:45:00',1.74),('10318','2013-11-15','10:50:00',1.99),('10318','2013-11-15','10:55:00',2.44),('10318','2013-11-15','11:00:00',2.76),('10318','2013-11-15','11:05:00',2.88),('10318','2013-11-15','11:10:00',2.98),('10318','2013-11-15','11:15:00',2.91),('10318','2013-11-15','11:20:00',3.38),('10318','2013-11-15','11:25:00',3.51),('10318','2013-11-15','11:30:00',3.57),('10318','2013-11-15','11:35:00',3.66),('10318','2013-11-15','11:40:00',3.65),('10318','2013-11-15','11:45:00',3.38),('10318','2013-11-15','11:50:00',2.9),('10318','2013-11-15','11:55:00',2.58),('10318','2013-11-15','12:00:00',2.49),('10318','2013-11-15','12:05:00',2.44),('10318','2013-11-15','12:10:00',2.25),('10318','2013-11-15','12:15:00',2.46),('10318','2013-11-15','12:20:00',3.19),('10318','2013-11-15','12:25:00',3.56),('10318','2013-11-15','12:30:00',2.9),('10318','2013-11-15','12:35:00',2.53),('10318','2013-11-15','12:40:00',2.47),('10318','2013-11-15','12:45:00',2.4),('10318','2013-11-15','12:50:00',2.54),('10318','2013-11-15','12:55:00',2.93),('10318','2013-11-15','13:00:00',3.08),('10318','2013-11-15','13:05:00',2.74),('10318','2013-11-15','13:10:00',2.47),('10318','2013-11-15','13:15:00',2.28),('10318','2013-11-15','13:20:00',1.97),('10318','2013-11-15','13:25:00',1.91),('10318','2013-11-15','13:30:00',1.99),('10318','2013-11-15','13:35:00',2.3),('10318','2013-11-15','13:40:00',2.48),('10318','2013-11-15','13:45:00',2.43),('10318','2013-11-15','13:50:00',2.53),('10318','2013-11-15','13:55:00',3.29),('10318','2013-11-15','14:00:00',2.64),('10318','2013-11-15','14:05:00',2.26),('10318','2013-11-15','14:10:00',1.7),('10318','2013-11-15','14:15:00',1.37),('10318','2013-11-15','14:20:00',1.11),('10318','2013-11-14','08:10:00',2.89),('10318','2013-11-14','08:15:00',2.76),('10318','2013-11-14','08:20:00',1.7),('10318','2013-11-14','08:25:00',3.19),('10318','2013-11-14','08:30:00',2.06),('10318','2013-11-14','08:35:00',2.9),('10318','2013-11-14','08:40:00',2.16),('10318','2013-11-14','08:45:00',1.25),('10318','2013-11-14','08:50:00',3.12),('10318','2013-11-14','08:55:00',4.68),('10318','2013-11-14','09:00:00',4.15),('10318','2013-11-14','09:05:00',4.85),('10318','2013-11-14','09:10:00',4.07),('10318','2013-11-14','09:15:00',5.61),('10318','2013-11-14','09:20:00',5.57),('10318','2013-11-14','09:25:00',5.56),('10318','2013-11-14','09:30:00',5.56),('10318','2013-11-14','09:35:00',5.74),('10318','2013-11-14','09:40:00',5.88),('10318','2013-11-14','09:45:00',5.93),('10318','2013-11-14','09:50:00',6.02),('10318','2013-11-14','09:55:00',6.16),('10318','2013-11-14','10:00:00',6.22),('10318','2013-11-14','10:05:00',6.15),('10318','2013-11-14','10:10:00',6.3),('10318','2013-11-14','10:15:00',6.36),('10318','2013-11-14','10:20:00',6.38),('10318','2013-11-14','10:25:00',6.31),('10318','2013-11-14','10:30:00',6.41),('10318','2013-11-14','10:35:00',6.06),('10318','2013-11-14','10:40:00',6.35),('10318','2013-11-14','10:45:00',6.5),('10318','2013-11-14','10:50:00',6.58),('10318','2013-11-14','10:55:00',6.65),('10318','2013-11-14','11:00:00',6.84),('10318','2013-11-14','11:05:00',6.82),('10318','2013-11-14','11:10:00',6.97),('10318','2013-11-14','11:15:00',7.03),('10318','2013-11-14','11:20:00',7.14),('10318','2013-11-14','11:25:00',7.21),('10318','2013-11-14','11:30:00',6.73),('10318','2013-11-14','11:35:00',5.91),('10318','2013-11-14','11:40:00',5.77),('10318','2013-11-14','11:45:00',5.54),('10318','2013-11-14','11:50:00',5.41),('10318','2013-11-14','11:55:00',6.48),('10318','2013-11-14','12:00:00',3.25),('10318','2013-11-14','12:05:00',4.48),('10318','2013-11-14','12:10:00',5.34),('10318','2013-11-14','12:15:00',3.61),('10318','2013-11-14','12:20:00',2.96),('10318','2013-11-14','12:25:00',2.41),('10318','2013-11-14','12:30:00',2.58),('10318','2013-11-14','12:35:00',2.72),('10318','2013-11-14','12:40:00',2.69),('10318','2013-11-14','12:45:00',2.66),('10318','2013-11-14','12:50:00',2.56),('10318','2013-11-14','12:55:00',2.51),('10318','2013-11-14','13:00:00',2.39),('10318','2013-11-14','13:05:00',2.22),('10318','2013-11-14','13:10:00',2.1),('10318','2013-11-14','13:15:00',2.09),('10318','2013-11-14','13:20:00',1.97),('10318','2013-11-14','13:25:00',2.11),('10318','2013-11-14','13:30:00',2.46),('10318','2013-11-14','13:35:00',2.49),('10318','2013-11-14','13:40:00',2.72),('10318','2013-11-14','13:45:00',2.55),('10318','2013-11-14','13:50:00',3.3),('10318','2013-11-14','13:55:00',3.55),('10318','2013-11-14','14:00:00',3.05),('10318','2013-11-14','14:05:00',2.49),('10318','2013-11-14','14:10:00',2.29),('10318','2013-11-14','14:15:00',1.86),('10318','2013-11-14','14:20:00',1.75),('10318','2013-11-14','14:25:00',1.66),('10318','2013-11-14','14:30:00',1.49),('10318','2013-11-14','14:35:00',1.48),('10318','2013-11-14','14:40:00',1.3),('10318','2013-11-14','14:45:00',1.18),('10318','2013-11-14','14:50:00',1.2),('10318','2013-11-14','14:55:00',1.2),('10318','2013-11-14','15:00:00',1.18),('10318','2013-11-14','15:05:00',1.14),('10318','2013-11-14','15:10:00',1.04),('10318','2013-11-13','08:20:00',1.07),('10318','2013-11-13','08:25:00',1.27),('10318','2013-11-13','08:30:00',1.2),('10318','2013-11-13','08:35:00',1),('10318','2013-11-13','09:55:00',1.14),('10318','2013-11-13','10:00:00',1.84),('10318','2013-11-13','10:05:00',4.01),('10318','2013-11-13','10:10:00',2.79),('10318','2013-11-13','10:15:00',2.68),('10318','2013-11-13','10:20:00',5.9),('10318','2013-11-13','10:25:00',4.78),('10318','2013-11-13','10:30:00',6.69),('10318','2013-11-13','10:35:00',7.52),('10318','2013-11-13','10:40:00',4.47),('10318','2013-11-13','10:45:00',3.58),('10318','2013-11-13','10:50:00',2.41),('10318','2013-11-13','10:55:00',1.94),('10318','2013-11-13','11:00:00',1.67),('10318','2013-11-13','11:05:00',1.94),('10318','2013-11-13','11:10:00',2.06),('10318','2013-11-13','11:15:00',2.2),('10318','2013-11-13','11:20:00',2.42),('10318','2013-11-13','11:25:00',2.28),('10318','2013-11-13','11:30:00',2.33),('10318','2013-11-13','11:35:00',2.03),('10318','2013-11-13','11:40:00',1.95),('10318','2013-11-13','11:45:00',2.23),('10318','2013-11-13','11:50:00',2.61),('10318','2013-11-13','11:55:00',2.57),('10318','2013-11-13','12:00:00',2.33),('10318','2013-11-13','12:05:00',2.03),('10318','2013-11-13','12:10:00',2.25),('10318','2013-11-13','12:15:00',2.13),('10318','2013-11-13','12:20:00',2.13),('10318','2013-11-13','12:25:00',1.91),('10318','2013-11-13','12:30:00',1.52),('10318','2013-11-13','12:35:00',1.31),('10318','2013-11-13','12:40:00',1.58),('10318','2013-11-13','12:45:00',1.78),('10318','2013-11-13','12:50:00',1.82),('10318','2013-11-13','12:55:00',2.2),('10318','2013-11-13','13:00:00',2.45),('10318','2013-11-13','13:05:00',2.66),('10318','2013-11-13','13:10:00',2.56),('10318','2013-11-13','13:15:00',2.55),('10318','2013-11-13','13:20:00',2.17),('10318','2013-11-13','13:25:00',1.81),('10318','2013-11-13','13:30:00',1.8),('10318','2013-11-13','13:35:00',1.98),('10318','2013-11-13','13:40:00',2.3),('10318','2013-11-13','13:45:00',2.37),('10318','2013-11-13','13:50:00',2),('10318','2013-11-13','13:55:00',3.1),('10318','2013-11-13','14:00:00',3.76),('10318','2013-11-13','14:05:00',3.83),('10318','2013-11-13','14:10:00',4.02),('10318','2013-11-13','14:15:00',3.57),('10318','2013-11-13','14:20:00',3.46),('10318','2013-11-13','14:25:00',3.44),('10318','2013-11-13','14:30:00',3.69),('10318','2013-11-13','14:35:00',2.86),('10318','2013-11-13','14:40:00',2.23),('10318','2013-11-13','14:45:00',1.81),('10318','2013-11-13','14:50:00',1.59),('10318','2013-11-13','14:55:00',1.06),('10318','2013-11-13','15:00:00',1.26),('10318','2013-11-13','15:05:00',1.18),('10318','2013-11-12','09:15:00',1.18),('10318','2013-11-12','09:20:00',1.02),('10318','2013-11-12','09:30:00',1.13),('10318','2013-11-12','09:35:00',1.23),('10318','2013-11-12','09:40:00',1.18),('10318','2013-11-12','10:00:00',1.52),('10318','2013-11-12','10:05:00',1.54),('10318','2013-11-12','10:45:00',1.15),('10318','2013-11-12','10:50:00',1.32),('10318','2013-11-12','10:55:00',1.51),('10318','2013-11-12','11:00:00',1.71),('10318','2013-11-12','11:05:00',1.55),('10318','2013-11-12','11:10:00',1.8),('10318','2013-11-12','11:15:00',1.81),('10318','2013-11-12','11:20:00',1.81),('10318','2013-11-12','11:25:00',3.28),('10318','2013-11-12','11:30:00',2.02),('10318','2013-11-12','11:35:00',2.31),('10318','2013-11-12','11:40:00',5.33),('10318','2013-11-12','11:45:00',2.59),('10318','2013-11-12','11:50:00',3.54),('10318','2013-11-12','11:55:00',2.29),('10318','2013-11-12','12:00:00',5.59),('10318','2013-11-12','12:05:00',4.11),('10318','2013-11-12','12:10:00',1.79),('10318','2013-11-12','12:15:00',1.78),('10318','2013-11-12','12:20:00',2.13),('10318','2013-11-12','12:25:00',1.88),('10318','2013-11-12','12:30:00',7.76),('10318','2013-11-12','12:35:00',8.57),('10318','2013-11-12','12:40:00',5.04),('10318','2013-11-12','12:45:00',4.54),('10318','2013-11-12','12:50:00',3.88),('10318','2013-11-12','12:55:00',5.58),('10318','2013-11-12','13:00:00',4.63),('10318','2013-11-12','13:05:00',6.55),('10318','2013-11-12','13:10:00',6.15),('10318','2013-11-12','13:15:00',8.55),('10318','2013-11-12','13:20:00',7.81),('10318','2013-11-12','13:25:00',6.04),('10318','2013-11-12','13:30:00',5.4),('10318','2013-11-12','13:35:00',4.96),('10318','2013-11-12','13:40:00',6.5),('10318','2013-11-12','13:45:00',4.05),('10318','2013-11-12','13:50:00',3.3),('10318','2013-11-12','13:55:00',3.99),('10318','2013-11-12','14:00:00',5.16),('10318','2013-11-12','14:05:00',5.75),('10318','2013-11-12','14:10:00',6.61),('10318','2013-11-12','14:15:00',6.11),('10318','2013-11-12','14:20:00',3.8),('10318','2013-11-12','14:25:00',2.36),('10318','2013-11-12','14:30:00',3.43),('10318','2013-11-12','14:35:00',4.64),('10318','2013-11-12','14:40:00',4.1),('10318','2013-11-12','14:45:00',3.9),('10318','2013-11-12','14:50:00',1.57),('10318','2013-11-12','14:55:00',1.38),('10318','2013-11-12','15:00:00',1.77),('10318','2013-11-12','15:05:00',2.49),('10318','2013-11-12','15:10:00',1.9),('10318','2013-11-12','15:15:00',2.14),('10318','2013-11-12','15:20:00',1.45),('10318','2013-11-11','09:30:00',1.21),('10318','2013-11-11','09:45:00',1.01),('10318','2013-11-11','09:50:00',1.91),('10318','2013-11-11','09:55:00',2.26),('10318','2013-11-11','10:00:00',2.18),('10318','2013-11-11','10:05:00',2.15),('10318','2013-11-11','10:10:00',1.87),('10318','2013-11-11','10:15:00',2.5),('10318','2013-11-11','10:20:00',2.38),('10318','2013-11-11','10:25:00',3.86),('10318','2013-11-11','10:30:00',3.16),('10318','2013-11-11','10:35:00',2.63),('10318','2013-11-11','10:40:00',1.99),('10318','2013-11-11','10:45:00',1.43),('10318','2013-11-11','10:50:00',1.51),('10318','2013-11-11','10:55:00',1.86),('10318','2013-11-11','11:00:00',1.56),('10318','2013-11-11','11:05:00',2.95),('10318','2013-11-11','11:10:00',5.94),('10318','2013-11-11','11:15:00',9.87),('10318','2013-11-11','11:20:00',8.31),('10318','2013-11-11','11:25:00',4.71),('10318','2013-11-11','11:30:00',4.04),('10318','2013-11-11','11:35:00',6.57),('10318','2013-11-11','11:40:00',7.37),('10318','2013-11-11','11:45:00',4.96),('10318','2013-11-11','11:50:00',7.92),('10318','2013-11-11','11:55:00',9.32),('10318','2013-11-11','12:00:00',8.36),('10318','2013-11-11','12:05:00',7.92),('10318','2013-11-11','12:10:00',7.27),('10318','2013-11-11','12:15:00',7.41),('10318','2013-11-11','12:20:00',7.4),('10318','2013-11-11','12:25:00',7.77),('10318','2013-11-11','12:30:00',3.83),('10318','2013-11-11','12:35:00',5.38),('10318','2013-11-11','12:40:00',6),('10318','2013-11-11','12:45:00',6.16),('10318','2013-11-11','12:50:00',6.19),('10318','2013-11-11','12:55:00',3.66),('10318','2013-11-11','13:00:00',3.96),('10318','2013-11-11','13:05:00',5.55),('10318','2013-11-11','13:10:00',2.1),('10318','2013-11-11','13:15:00',5.73),('10318','2013-11-11','13:20:00',2.42),('10318','2013-11-11','13:25:00',1.03),('10318','2013-11-11','13:30:00',1.37),('10318','2013-11-11','13:35:00',1.71),('10318','2013-11-11','13:40:00',2.27),('10318','2013-11-11','13:45:00',5.08),('10318','2013-11-11','13:50:00',1.65),('10318','2013-11-11','13:55:00',1.48),('10318','2013-11-11','14:00:00',3.31),('10318','2013-11-11','14:05:00',6.27),('10318','2013-11-11','14:10:00',4.49),('10318','2013-11-11','14:15:00',1.76),('10318','2013-11-11','14:20:00',2.02),('10318','2013-11-11','14:25:00',4.53),('10318','2013-11-11','14:30:00',4.72),('10318','2013-11-11','14:35:00',4.26),('10318','2013-11-11','14:40:00',4.12),('10318','2013-11-11','14:45:00',2.81),('10318','2013-11-11','14:50:00',2.2),('10318','2013-11-11','14:55:00',1.85),('10318','2013-11-11','15:00:00',1.58),('10318','2013-11-11','15:05:00',1.4),('10318','2013-11-10','07:30:00',1.46),('10318','2013-11-10','07:35:00',1.94),('10318','2013-11-10','07:40:00',2.12),('10318','2013-11-10','07:45:00',2.74),('10318','2013-11-10','07:50:00',3.08),('10318','2013-11-10','07:55:00',3.3),('10318','2013-11-10','08:00:00',3.84),('10318','2013-11-10','08:05:00',2.6),('10318','2013-11-10','08:10:00',1.71),('10318','2013-11-10','08:15:00',1.96),('10318','2013-11-10','08:20:00',2.74),('10318','2013-11-10','08:25:00',3.01),('10318','2013-11-10','08:30:00',3.67),('10318','2013-11-10','08:35:00',3.67),('10318','2013-11-10','08:40:00',2.29),('10318','2013-11-10','08:45:00',3.86),('10318','2013-11-10','08:50:00',3.51),('10318','2013-11-10','08:55:00',3.06),('10318','2013-11-10','09:00:00',4.8),('10318','2013-11-10','09:05:00',3),('10318','2013-11-10','09:10:00',3.4),('10318','2013-11-10','09:15:00',4.74),('10318','2013-11-10','09:20:00',5.38),('10318','2013-11-10','09:25:00',5.87),('10318','2013-11-10','09:30:00',5.13),('10318','2013-11-10','09:35:00',5.33),('10318','2013-11-10','09:40:00',5.73),('10318','2013-11-10','09:45:00',4.2),('10318','2013-11-10','09:50:00',6.63),('10318','2013-11-10','09:55:00',6.17),('10318','2013-11-10','10:00:00',5.87),('10318','2013-11-10','10:05:00',7.44),('10318','2013-11-10','10:10:00',7.2),('10318','2013-11-10','10:15:00',6.85),('10318','2013-11-10','10:20:00',5.81),('10318','2013-11-10','10:25:00',4.44),('10318','2013-11-10','10:30:00',7.05),('10318','2013-11-10','10:35:00',7.92),('10318','2013-11-10','10:40:00',7.12),('10318','2013-11-10','10:45:00',4.19),('10318','2013-11-10','10:50:00',2.56),('10318','2013-11-10','10:55:00',5.51),('10318','2013-11-10','11:00:00',4.2),('10318','2013-11-10','11:05:00',3.97),('10318','2013-11-10','11:10:00',1.04),('10318','2013-11-10','11:15:00',1.62),('10318','2013-11-10','11:20:00',3.1),('10318','2013-11-10','11:25:00',2.36),('10318','2013-11-10','11:30:00',2.92),('10318','2013-11-10','11:35:00',2.96),('10318','2013-11-10','11:40:00',3.42),('10318','2013-11-10','11:45:00',3.5),('10318','2013-11-10','11:50:00',2),('10318','2013-11-10','11:55:00',2.99),('10318','2013-11-10','12:00:00',2.46),('10318','2013-11-10','12:05:00',5.9),('10318','2013-11-10','12:10:00',6.92),('10318','2013-11-10','12:15:00',7.13),('10318','2013-11-10','12:20:00',7.55),('10318','2013-11-10','12:25:00',5.83),('10318','2013-11-10','12:30:00',2.42),('10318','2013-11-10','12:35:00',3.61),('10318','2013-11-10','12:40:00',4.6),('10318','2013-11-10','12:45:00',7.09),('10318','2013-11-10','12:50:00',3.58),('10318','2013-11-10','12:55:00',2.52),('10318','2013-11-10','13:00:00',2.71),('10318','2013-11-10','13:05:00',2.3),('10318','2013-11-10','13:10:00',2.06),('10318','2013-11-10','13:15:00',1.32),('10318','2013-11-10','13:20:00',1),('10318','2013-11-10','13:30:00',1.73),('10318','2013-11-10','13:35:00',2.02),('10318','2013-11-10','13:40:00',1.85),('10318','2013-11-10','13:45:00',2.26),('10318','2013-11-10','13:50:00',5.38),('10318','2013-11-10','13:55:00',2.15),('10318','2013-11-10','14:15:00',1.37),('10318','2013-11-10','14:20:00',1.64),('10318','2013-11-10','14:25:00',1.29),('10318','2013-11-10','14:30:00',2.13),('10318','2013-11-10','14:50:00',1.12),('10318','2013-11-10','15:00:00',1.07),('10318','2013-11-10','15:05:00',1.08),('10318','2013-11-09','09:05:00',1.55),('10318','2013-11-09','09:10:00',2.53),('10318','2013-11-09','09:15:00',1.25),('10318','2013-11-09','09:25:00',1.78),('10318','2013-11-09','09:30:00',2.35),('10318','2013-11-09','09:35:00',1.47),('10318','2013-11-09','09:40:00',5.27),('10318','2013-11-09','09:45:00',7.82),('10318','2013-11-09','09:50:00',7.82),('10318','2013-11-09','09:55:00',7.25),('10318','2013-11-09','10:00:00',6.99),('10318','2013-11-09','10:05:00',5.24),('10318','2013-11-09','10:10:00',4.38),('10318','2013-11-09','10:15:00',5.61),('10318','2013-11-09','10:20:00',5.48),('10318','2013-11-09','10:25:00',3.53),('10318','2013-11-09','10:30:00',2.53),('10318','2013-11-09','10:35:00',2.95),('10318','2013-11-09','10:40:00',3.62),('10318','2013-11-09','10:45:00',5.59),('10318','2013-11-09','10:50:00',5.57),('10318','2013-11-09','10:55:00',5.33),('10318','2013-11-09','11:00:00',3.91),('10318','2013-11-09','11:05:00',2.52),('10318','2013-11-09','11:10:00',4.52),('10318','2013-11-09','11:15:00',3.68),('10318','2013-11-09','11:20:00',4.3),('10318','2013-11-09','11:25:00',9.17),('10318','2013-11-09','11:30:00',7.26),('10318','2013-11-09','11:35:00',5.86),('10318','2013-11-09','11:40:00',4.1),('10318','2013-11-09','11:45:00',3.36),('10318','2013-11-09','11:50:00',3.34),('10318','2013-11-09','11:55:00',5.12),('10318','2013-11-09','12:00:00',5.89),('10318','2013-11-09','12:05:00',5.88),('10318','2013-11-09','12:10:00',2.25),('10318','2013-11-09','12:15:00',3.06),('10318','2013-11-09','12:20:00',2.51),('10318','2013-11-09','12:25:00',3.95),('10318','2013-11-09','12:30:00',4.17),('10318','2013-11-09','12:35:00',3.59),('10318','2013-11-09','12:40:00',7),('10318','2013-11-09','12:45:00',5.76),('10318','2013-11-09','12:50:00',7.58),('10318','2013-11-09','12:55:00',5.56),('10318','2013-11-09','13:00:00',5.48),('10318','2013-11-09','13:05:00',3.18),('10318','2013-11-09','13:10:00',6.42),('10318','2013-11-09','13:15:00',7.14),('10318','2013-11-09','13:20:00',3.25),('10318','2013-11-09','13:25:00',4.46),('10318','2013-11-09','13:30:00',5.32),('10318','2013-11-09','13:35:00',6.23),('10318','2013-11-09','13:40:00',5.8),('10318','2013-11-09','13:45:00',5.44),('10318','2013-11-09','13:50:00',5.44),('10318','2013-11-09','13:55:00',5.35),('10318','2013-11-09','14:00:00',4.42),('10318','2013-11-09','14:05:00',2.89),('10318','2013-11-09','14:10:00',2.02),('10318','2013-11-09','14:15:00',3.86),('10318','2013-11-09','14:20:00',4.13),('10318','2013-11-09','14:25:00',3.11),('10318','2013-11-09','14:30:00',1.52),('10318','2013-11-09','14:35:00',3.33),('10318','2013-11-09','14:40:00',3.61),('10318','2013-11-09','14:45:00',2.99),('10318','2013-11-09','14:50:00',2.88),('10318','2013-11-09','15:20:00',2.49),('10318','2013-11-09','15:25:00',2.54),('10318','2013-11-09','15:30:00',2.27),('10318','2013-11-09','15:35:00',2.43),('10318','2013-11-09','15:40:00',1.94),('10318','2013-11-09','15:45:00',1.46),('10318','2013-11-09','15:50:00',1.38),('10318','2013-11-09','15:55:00',1.08),('10318','2013-11-08','08:40:00',1.04),('10318','2013-11-08','08:55:00',1.57),('10318','2013-11-08','09:00:00',2.41),('10318','2013-11-08','09:05:00',2.85),('10318','2013-11-08','09:10:00',4.06),('10318','2013-11-08','09:15:00',6.59),('10318','2013-11-08','09:20:00',3.62),('10318','2013-11-08','09:25:00',5.74),('10318','2013-11-08','09:30:00',2.27),('10318','2013-11-08','09:35:00',1.69),('10318','2013-11-08','09:40:00',4.26),('10318','2013-11-08','09:45:00',4.42),('10318','2013-11-08','09:50:00',5.13),('10318','2013-11-08','09:55:00',4.13),('10318','2013-11-08','10:00:00',1.77),('10318','2013-11-08','10:05:00',1.27),('10318','2013-11-08','10:10:00',1.15),('10318','2013-11-08','10:15:00',1.12),('10318','2013-11-08','10:20:00',4.02),('10318','2013-11-08','10:25:00',7.02),('10318','2013-11-08','10:30:00',6.95),('10318','2013-11-08','10:35:00',7.15),('10318','2013-11-08','10:40:00',4.94),('10318','2013-11-08','10:45:00',4.1),('10318','2013-11-08','10:50:00',7.07),('10318','2013-11-08','10:55:00',7.96),('10318','2013-11-08','11:00:00',7.31),('10318','2013-11-08','11:05:00',6.5),('10318','2013-11-08','11:10:00',2.41),('10318','2013-11-08','11:15:00',5.57),('10318','2013-11-08','11:20:00',8.53),('10318','2013-11-08','11:25:00',8.18),('10318','2013-11-08','11:30:00',8.07),('10318','2013-11-08','11:35:00',6.89),('10318','2013-11-08','11:40:00',2.83),('10318','2013-11-08','11:45:00',2.06),('10318','2013-11-08','11:50:00',6.75),('10318','2013-11-08','11:55:00',7.24),('10318','2013-11-08','12:00:00',7.09),('10318','2013-11-08','12:05:00',6.93),('10318','2013-11-08','12:10:00',6.85),('10318','2013-11-08','12:15:00',6.82),('10318','2013-11-08','12:20:00',6.79),('10318','2013-11-08','12:25:00',6.76),('10318','2013-11-08','12:30:00',6.73),('10318','2013-11-08','12:35:00',1.49),('10318','2013-11-08','12:40:00',1.3),('10318','2013-11-08','12:45:00',4.41),('10318','2013-11-08','12:50:00',3.13),('10318','2013-11-08','12:55:00',1.79),('10318','2013-11-08','13:00:00',4.01),('10318','2013-11-08','13:05:00',7.15),('10318','2013-11-08','13:10:00',6.99),('10318','2013-11-08','13:15:00',6.83),('10318','2013-11-08','13:20:00',6.52),('10318','2013-11-08','13:25:00',6.39),('10318','2013-11-08','13:30:00',4.51),('10318','2013-11-08','13:35:00',5.66),('10318','2013-11-08','13:40:00',3.55),('10318','2013-11-08','13:45:00',1.21),('10318','2013-11-08','13:50:00',1.35),('10318','2013-11-08','13:55:00',5.47),('10318','2013-11-08','14:00:00',5.31),('10318','2013-11-08','14:05:00',5.26),('10318','2013-11-08','14:10:00',5.12),('10318','2013-11-08','14:15:00',4.25),('10318','2013-11-08','14:20:00',3.78),('10318','2013-11-08','14:25:00',3.85),('10318','2013-11-08','14:30:00',4.39),('10318','2013-11-08','14:35:00',3.44),('10318','2013-11-08','14:40:00',3.74),('10318','2013-11-08','14:50:00',2.33),('10318','2013-11-08','14:55:00',2.4),('10318','2013-11-08','15:00:00',3.21),('10318','2013-11-08','15:05:00',2.96),('10318','2013-11-08','15:10:00',2.48),('10318','2013-11-08','15:15:00',2.67),('10318','2013-11-08','15:20:00',2.52),('10318','2013-11-08','15:25:00',2.35),('10318','2013-11-08','15:30:00',2.18),('10318','2013-11-08','15:35:00',2.09),('10318','2013-11-08','15:40:00',1.98),('10318','2013-11-08','15:45:00',1.83),('10318','2013-11-08','15:50:00',1.62),('10318','2013-11-08','15:55:00',1.42),('10318','2013-11-08','16:00:00',1.25),('10318','2013-11-08','16:05:00',1.06),('10318','2014-04-18','07:40:00',1.18),('10318','2014-04-18','07:45:00',1.39),('10318','2014-04-18','07:50:00',1.14),('10318','2014-04-18','07:55:00',1.23),('10318','2014-04-18','08:00:00',1.55),('10318','2014-04-18','08:05:00',3.49),('10318','2014-04-18','08:10:00',4.2),('10318','2014-04-18','08:15:00',2.62),('10318','2014-04-18','08:20:00',2.04),('10318','2014-04-18','08:25:00',1.7),('10318','2014-04-18','08:30:00',1.88),('10318','2014-04-18','08:35:00',2.58),('10318','2014-04-18','08:40:00',4.72),('10318','2014-04-18','08:45:00',3.21),('10318','2014-04-18','08:50:00',3.4),('10318','2014-04-18','08:55:00',2.45),('10318','2014-04-18','09:00:00',2.54),('10318','2014-04-18','09:05:00',5.51),('10318','2014-04-18','09:10:00',8.38),('10318','2014-04-18','09:15:00',7.84),('10318','2014-04-18','09:20:00',7.25),('10318','2014-04-18','09:25:00',2.93),('10318','2014-04-18','09:30:00',7.53),('10318','2014-04-18','09:35:00',3.77),('10318','2014-04-18','09:40:00',2.9),('10318','2014-04-18','09:45:00',7.2),('10318','2014-04-18','09:50:00',7.14),('10318','2014-04-18','09:55:00',7.56),('10318','2014-04-18','10:00:00',5.14),('10318','2014-04-18','10:05:00',3.39),('10318','2014-04-18','10:10:00',3.24),('10318','2014-04-18','10:15:00',3.09),('10318','2014-04-18','10:20:00',3.58),('10318','2014-04-18','10:25:00',3.97),('10318','2014-04-18','10:30:00',2.86),('10318','2014-04-18','10:35:00',2.77),('10318','2014-04-18','10:40:00',3.67),('10318','2014-04-18','10:45:00',6.67),('10318','2014-04-18','10:50:00',8.06),('10318','2014-04-18','10:55:00',8.23),('10318','2014-04-18','11:00:00',4.67),('10318','2014-04-18','11:05:00',4.12),('10318','2014-04-18','11:10:00',3.94),('10318','2014-04-18','11:15:00',5.68),('10318','2014-04-18','11:20:00',4.27),('10318','2014-04-18','11:25:00',3.36),('10318','2014-04-18','11:30:00',3.65),('10318','2014-04-18','11:35:00',3.92),('10318','2014-04-18','11:40:00',4.18),('10318','2014-04-18','11:45:00',4.24),('10318','2014-04-18','11:50:00',5.27),('10318','2014-04-18','11:55:00',4.92),('10318','2014-04-18','12:00:00',5.63),('10318','2014-04-18','12:05:00',7.29),('10318','2014-04-18','12:10:00',5.71),('10318','2014-04-18','12:15:00',8.93),('10318','2014-04-18','12:20:00',9.43),('10318','2014-04-18','12:25:00',7.18),('10318','2014-04-18','12:30:00',10.31),('10318','2014-04-18','12:35:00',10.51),('10318','2014-04-18','12:40:00',10.06),('10318','2014-04-18','12:45:00',8.06),('10318','2014-04-18','12:50:00',8.65),('10318','2014-04-18','12:55:00',8.72),('10318','2014-04-18','13:00:00',9.41),('10318','2014-04-18','13:05:00',8.85),('10318','2014-04-18','13:10:00',10.05),('10318','2014-04-18','13:15:00',9.98),('10318','2014-04-18','13:20:00',7.81),('10318','2014-04-18','13:25:00',3.6),('10318','2014-04-18','13:30:00',2.72),('10318','2014-04-18','13:35:00',3.18),('10318','2014-04-18','13:40:00',3.42),('10318','2014-04-18','13:45:00',3.04),('10318','2014-04-18','13:50:00',3.17),('10318','2014-04-18','13:55:00',4.68),('10318','2014-04-18','14:00:00',4.56),('10318','2014-04-18','14:05:00',4.07),('10318','2014-04-18','14:10:00',3.66),('10318','2014-04-18','14:15:00',3.51),('10318','2014-04-18','14:20:00',3.93),('10318','2014-04-18','14:25:00',4.69),('10318','2014-04-18','14:30:00',5.04),('10318','2014-04-18','14:35:00',5.9),('10318','2014-04-18','14:40:00',5.32),('10318','2014-04-18','14:45:00',6.49),('10318','2014-04-18','14:50:00',8.67),('10318','2014-04-18','14:55:00',8.96),('10318','2014-04-18','15:00:00',9.18),('10318','2014-04-18','15:05:00',8.12),('10318','2014-04-18','15:10:00',3.8),('10318','2014-04-18','15:15:00',4.07),('10318','2014-04-18','15:20:00',4.82),('10318','2014-04-18','15:25:00',8.81),('10318','2014-04-18','15:30:00',4.52),('10318','2014-04-18','15:35:00',6.71),('10318','2014-04-18','15:40:00',8.2),('10318','2014-04-18','15:45:00',6.28),('10318','2014-04-18','15:50:00',5.19),('10318','2014-04-18','15:55:00',5.08),('10318','2014-04-18','16:00:00',7.36),('10318','2014-04-18','16:05:00',5.79),('10318','2014-04-18','16:10:00',5.21),('10318','2014-04-18','16:15:00',3.39),('10318','2014-04-18','16:20:00',3.88),('10318','2014-04-18','16:25:00',5.38),('10318','2014-04-18','16:30:00',4.75),('10318','2014-04-18','16:35:00',6.81),('10318','2014-04-18','16:40:00',5.65),('10318','2014-04-18','16:45:00',5.23),('10318','2014-04-18','16:50:00',5.26),('10318','2014-04-18','16:55:00',6.09),('10318','2014-04-18','17:00:00',4.78),('10318','2014-04-18','17:05:00',4.2),('10318','2014-04-18','17:10:00',3.31),('10318','2014-04-18','17:15:00',1.44),('10318','2014-04-18','17:20:00',3.06),('10318','2014-04-18','17:25:00',3.51),('10318','2014-04-18','17:30:00',3.17),('10318','2014-04-18','17:35:00',2.98),('10318','2014-04-18','17:40:00',2.77),('10318','2014-04-18','17:45:00',2.59),('10318','2014-04-18','17:50:00',2.43),('10318','2014-04-18','17:55:00',2.3),('10318','2014-04-18','18:00:00',2.2),('10318','2014-04-18','18:05:00',1.86),('10318','2014-04-18','18:10:00',1.71),('10318','2014-04-18','18:15:00',1.54),('10318','2014-04-18','18:20:00',1.4),('10318','2014-04-18','18:25:00',1.17),('10318','2013-11-07','07:25:00',1.15),('10318','2013-11-07','07:30:00',1.35),('10318','2013-11-07','07:35:00',1.62),('10318','2013-11-07','07:40:00',2.16),('10318','2013-11-07','07:45:00',2.46),('10318','2013-11-07','07:50:00',2.77),('10318','2013-11-07','07:55:00',3.17),('10318','2013-11-07','08:00:00',3.37),('10318','2013-11-07','08:05:00',3.57),('10318','2013-11-07','08:10:00',3.75),('10318','2013-11-07','08:15:00',3.94),('10318','2013-11-07','08:20:00',4.11),('10318','2013-11-07','08:25:00',4.28),('10318','2013-11-07','08:30:00',4.45),('10318','2013-11-07','08:35:00',4.64),('10318','2013-11-07','08:40:00',4.79),('10318','2013-11-07','08:45:00',4.96),('10318','2013-11-07','08:50:00',5.1),('10318','2013-11-07','08:55:00',5.24),('10318','2013-11-07','09:00:00',5.37),('10318','2013-11-07','09:05:00',5.42),('10318','2013-11-07','09:10:00',5.61),('10318','2013-11-07','09:15:00',5.71),('10318','2013-11-07','09:20:00',5.83),('10318','2013-11-07','09:25:00',5.85),('10318','2013-11-07','09:30:00',5.64),('10318','2013-11-07','09:35:00',5.96),('10318','2013-11-07','09:40:00',6.12),('10318','2013-11-07','09:45:00',6.2),('10318','2013-11-07','09:50:00',6.25),('10318','2013-11-07','09:55:00',6.31),('10318','2013-11-07','10:00:00',6.32),('10318','2013-11-07','10:05:00',6.39),('10318','2013-11-07','10:10:00',6.44),('10318','2013-11-07','10:15:00',6.49),('10318','2013-11-07','10:20:00',6.53),('10318','2013-11-07','10:25:00',6.64),('10318','2013-11-07','10:30:00',6.72),('10318','2013-11-07','10:35:00',6.74),('10318','2013-11-07','10:40:00',6.74),('10318','2013-11-07','10:45:00',6.78),('10318','2013-11-07','10:50:00',6.78),('10318','2013-11-07','10:55:00',6.65),('10318','2013-11-07','11:00:00',6.78),('10318','2013-11-07','11:05:00',6.75),('10318','2013-11-07','11:10:00',6.77),('10318','2013-11-07','11:15:00',6.74),('10318','2013-11-07','11:20:00',6.7),('10318','2013-11-07','11:25:00',6.65),('10318','2013-11-07','11:30:00',6.69),('10318','2013-11-07','11:35:00',6.67),('10318','2013-11-07','11:40:00',6.64),('10318','2013-11-07','11:45:00',6.62),('10318','2013-11-07','11:50:00',6.61),('10318','2013-11-07','11:55:00',6.58),('10318','2013-11-07','12:00:00',6.56),('10318','2013-11-07','12:05:00',6.52),('10318','2013-11-07','12:10:00',6.39),('10318','2013-11-07','12:15:00',6.33),('10318','2013-11-07','12:20:00',6.26),('10318','2013-11-07','12:25:00',6.04),('10318','2013-11-07','12:30:00',6.06),('10318','2013-11-07','12:35:00',5.68),('10318','2013-11-07','12:40:00',6.13),('10318','2013-11-07','12:45:00',6.79),('10318','2013-11-07','12:50:00',4.82),('10318','2013-11-07','12:55:00',3.85),('10318','2013-11-07','13:00:00',2.35),('10318','2013-11-07','13:05:00',3.17),('10318','2013-11-07','13:10:00',3.66),('10318','2013-11-07','13:15:00',5.66),('10318','2013-11-07','13:20:00',7.07),('10318','2013-11-07','13:25:00',6.63),('10318','2013-11-07','13:30:00',6.17),('10318','2013-11-07','13:35:00',4.24),('10318','2013-11-07','13:40:00',5.49),('10318','2013-11-07','13:45:00',5.21),('10318','2013-11-07','13:50:00',5.21),('10318','2013-11-07','13:55:00',3.63),('10318','2013-11-07','14:00:00',4.94),('10318','2013-11-07','14:05:00',5.81),('10318','2013-11-07','14:10:00',5.73),('10318','2013-11-07','14:15:00',5.09),('10318','2013-11-07','14:20:00',4.57),('10318','2013-11-07','14:25:00',4.09),('10318','2013-11-07','14:30:00',4),('10318','2013-11-07','14:35:00',3.9),('10318','2013-11-07','14:40:00',3.71),('10318','2013-11-07','14:45:00',3.55),('10318','2013-11-07','14:50:00',3.39),('10318','2013-11-07','14:55:00',3.26),('10318','2013-11-07','15:00:00',3.1),('10318','2013-11-07','15:05:00',2.94),('10318','2013-11-07','15:10:00',2.82),('10318','2013-11-07','15:15:00',2.62),('10318','2013-11-07','15:20:00',2.56),('10318','2013-11-07','15:25:00',2.41),('10318','2013-11-07','15:30:00',2.26),('10318','2013-11-07','15:35:00',2.09),('10318','2013-11-07','15:40:00',1.92),('10318','2013-11-07','15:45:00',1.77),('10318','2013-11-07','15:50:00',1.6),('10318','2013-11-07','15:55:00',1.43),('10318','2013-11-07','16:00:00',1.27),('10318','2013-11-07','16:05:00',1.09),('10318','2013-11-06','07:55:00',1.48),('10318','2013-11-06','08:00:00',2.97),('10318','2013-11-06','08:05:00',2.69),('10318','2013-11-06','08:10:00',4.11),('10318','2013-11-06','08:15:00',4.52),('10318','2013-11-06','08:20:00',3.33),('10318','2013-11-06','08:25:00',1.71),('10318','2013-11-06','08:30:00',1.94),('10318','2013-11-06','08:35:00',4.89),('10318','2013-11-06','08:40:00',5),('10318','2013-11-06','08:45:00',5.16),('10318','2013-11-06','08:50:00',5.47),('10318','2013-11-06','08:55:00',4.73),('10318','2013-11-06','09:00:00',3.69),('10318','2013-11-06','09:05:00',4.22),('10318','2013-11-06','09:10:00',5.07),('10318','2013-11-06','09:15:00',5.09),('10318','2013-11-06','09:20:00',5.7),('10318','2013-11-06','09:25:00',6.17),('10318','2013-11-06','09:30:00',6.26),('10318','2013-11-06','09:35:00',6.32),('10318','2013-11-06','09:40:00',6.39),('10318','2013-11-06','09:45:00',6.43),('10318','2013-11-06','09:50:00',6.41),('10318','2013-11-06','09:55:00',6.54),('10318','2013-11-06','10:00:00',6.59),('10318','2013-11-06','10:05:00',6.72),('10318','2013-11-06','10:10:00',6.77),('10318','2013-11-06','10:15:00',6.83),('10318','2013-11-06','10:20:00',6.91),('10318','2013-11-06','10:25:00',6.9),('10318','2013-11-06','10:30:00',6.94),('10318','2013-11-06','10:35:00',6.94),('10318','2013-11-06','10:40:00',7.04),('10318','2013-11-06','10:45:00',7.06),('10318','2013-11-06','10:50:00',7.12),('10318','2013-11-06','10:55:00',7.13),('10318','2013-11-06','11:00:00',7.14),('10318','2013-11-06','11:05:00',7.11),('10318','2013-11-06','11:10:00',7.12),('10318','2013-11-06','11:15:00',7.12),('10318','2013-11-06','11:20:00',7.15),('10318','2013-11-06','11:25:00',7.16),('10318','2013-11-06','11:30:00',7.14),('10318','2013-11-06','11:35:00',7.16),('10318','2013-11-06','11:40:00',6.97),('10318','2013-11-06','11:45:00',7.1),('10318','2013-11-06','11:50:00',7.06),('10318','2013-11-06','11:55:00',7.03),('10318','2013-11-06','12:00:00',7),('10318','2013-11-06','12:05:00',6.96),('10318','2013-11-06','12:10:00',6.92),('10318','2013-11-06','12:15:00',6.86),('10318','2013-11-06','12:20:00',6.81),('10318','2013-11-06','12:25:00',6.76),('10318','2013-11-06','12:30:00',6.72),('10318','2013-11-06','12:35:00',6.63),('10318','2013-11-06','12:40:00',6.54),('10318','2013-11-06','12:45:00',6.46),('10318','2013-11-06','12:50:00',6.35),('10318','2013-11-06','12:55:00',6.27),('10318','2013-11-06','13:00:00',6.21),('10318','2013-11-06','13:05:00',6.13),('10318','2013-11-06','13:10:00',6.03),('10318','2013-11-06','13:15:00',5.95),('10318','2013-11-06','13:20:00',5.84),('10318','2013-11-06','13:25:00',5.62),('10318','2013-11-06','13:30:00',5.66),('10318','2013-11-06','13:35:00',5.55),('10318','2013-11-06','13:40:00',5.39),('10318','2013-11-06','13:45:00',5.22),('10318','2013-11-06','13:50:00',5.12),('10318','2013-11-06','13:55:00',5.03),('10318','2013-11-06','14:00:00',4.93),('10318','2013-11-06','14:05:00',4.81),('10318','2013-11-06','14:10:00',4.64),('10318','2013-11-06','14:15:00',4.51),('10318','2013-11-06','14:20:00',4.38),('10318','2013-11-06','14:25:00',4.23),('10318','2013-11-06','14:30:00',4.08),('10318','2013-11-06','14:35:00',3.93),('10318','2013-11-06','14:40:00',3.78),('10318','2013-11-06','14:45:00',3.63),('10318','2013-11-06','14:50:00',3.49),('10318','2013-11-06','14:55:00',3.34),('10318','2013-11-06','15:00:00',3.2),('10318','2013-11-06','15:05:00',3.06),('10318','2013-11-06','15:10:00',2.88),('10318','2013-11-06','15:15:00',2.72),('10318','2013-11-06','15:20:00',2.6),('10318','2013-11-06','15:25:00',2.43),('10318','2013-11-06','15:30:00',2.29),('10318','2013-11-06','15:35:00',2.13),('10318','2013-11-06','15:40:00',1.97),('10318','2013-11-06','15:45:00',1.83),('10318','2013-11-06','15:50:00',1.68),('10318','2013-11-06','15:55:00',1.47),('10318','2013-11-06','16:00:00',1.34),('10318','2013-11-06','16:05:00',1.18),('10318','2013-11-05','08:15:00',1.75),('10318','2013-11-05','08:20:00',2.02),('10318','2013-11-05','08:25:00',1.83),('10318','2013-11-05','08:30:00',3.06),('10318','2013-11-05','08:35:00',4.21),('10318','2013-11-05','08:40:00',2.7),('10318','2013-11-05','08:45:00',2.65),('10318','2013-11-05','08:50:00',1.67),('10318','2013-11-05','08:55:00',1.24),('10318','2013-11-05','09:35:00',1.02),('10318','2013-11-05','09:40:00',1.15),('10318','2013-11-05','09:45:00',1.16),('10318','2013-11-05','09:50:00',1.14),('10318','2013-11-05','09:55:00',1.25),('10318','2013-11-05','10:00:00',1.62),('10318','2013-11-05','10:05:00',1.62),('10318','2013-11-05','10:10:00',1.54),('10318','2013-11-05','10:15:00',2.11),('10318','2013-11-05','10:20:00',2.9),('10318','2013-11-05','10:25:00',3.92),('10318','2013-11-05','10:30:00',3.22),('10318','2013-11-05','10:35:00',3.27),('10318','2013-11-05','10:40:00',3.6),('10318','2013-11-05','10:45:00',3.28),('10318','2013-11-05','10:50:00',2.99),('10318','2013-11-05','10:55:00',2.35),('10318','2013-11-05','11:00:00',1.83),('10318','2013-11-05','11:05:00',1.36),('10318','2013-11-05','11:10:00',1.11),('10318','2013-11-05','11:15:00',1.22),('10318','2013-11-05','11:20:00',1.45),('10318','2013-11-05','11:25:00',1.75),('10318','2013-11-05','11:30:00',2.04),('10318','2013-11-05','11:35:00',2.66),('10318','2013-11-05','11:40:00',3.45),('10318','2013-11-05','11:45:00',3.17),('10318','2013-11-05','11:50:00',2.94),('10318','2013-11-05','11:55:00',2.59),('10318','2013-11-05','12:00:00',2.43),('10318','2013-11-05','12:05:00',3.04),('10318','2013-11-05','12:10:00',3.46),('10318','2013-11-05','12:15:00',3.71),('10318','2013-11-05','12:20:00',4.83),('10318','2013-11-05','12:25:00',4.82),('10318','2013-11-05','12:30:00',4.83),('10318','2013-11-05','12:35:00',2.48),('10318','2013-11-05','12:40:00',2.18),('10318','2013-11-05','12:45:00',2.19),('10318','2013-11-05','12:50:00',1.77),('10318','2013-11-05','12:55:00',1.74),('10318','2013-11-05','13:00:00',1.56),('10318','2013-11-05','13:05:00',1.37),('10318','2013-11-05','13:10:00',1.32),('10318','2013-11-05','13:15:00',1.38),('10318','2013-11-05','13:20:00',2.08),('10318','2013-11-05','13:25:00',2.84),('10318','2013-11-05','13:30:00',3.59),('10318','2013-11-05','13:35:00',5.82),('10318','2013-11-05','13:40:00',5.73),('10318','2013-11-05','13:45:00',4.64),('10318','2013-11-05','13:50:00',5.41),('10318','2013-11-05','13:55:00',4.63),('10318','2013-11-05','14:00:00',6.65),('10318','2013-11-05','14:05:00',4.48),('10318','2013-11-05','14:10:00',5.8),('10318','2013-11-05','14:15:00',5.21),('10318','2013-11-05','14:20:00',5.48),('10318','2013-11-05','14:25:00',3.81),('10318','2013-11-05','14:30:00',5.2),('10318','2013-11-05','14:35:00',3.68),('10318','2013-11-05','14:40:00',4.31),('10318','2013-11-05','14:45:00',3.25),('10318','2013-11-05','14:50:00',3.97),('10318','2013-11-05','14:55:00',2.06),('10318','2013-11-05','15:00:00',1.09),('10318','2013-11-05','15:05:00',1.71),('10318','2013-11-05','15:10:00',1.38),('10318','2013-11-05','15:25:00',1.79),('10318','2013-11-05','15:30:00',1.45),('10318','2013-11-05','15:40:00',1.26),('10318','2013-11-05','15:45:00',2.33),('10318','2013-11-05','15:50:00',2.05),('10318','2013-11-05','16:00:00',1.74),('10318','2013-11-05','16:05:00',1.7),('10318','2013-11-05','16:10:00',1.32),('10318','2013-11-04','07:50:00',2.32),('10318','2013-11-04','07:55:00',3.1),('10318','2013-11-04','08:00:00',3.36),('10318','2013-11-04','08:05:00',3.53),('10318','2013-11-04','08:10:00',3.63),('10318','2013-11-04','08:15:00',3.81),('10318','2013-11-04','08:20:00',3.88),('10318','2013-11-04','08:25:00',4.28),('10318','2013-11-04','08:30:00',4.33),('10318','2013-11-04','08:35:00',4.84),('10318','2013-11-04','08:40:00',5.48),('10318','2013-11-04','08:45:00',3.31),('10318','2013-11-04','08:55:00',1.25),('10318','2013-11-04','09:00:00',2.72),('10318','2013-11-04','09:05:00',5.41),('10318','2013-11-04','09:10:00',5.42),('10318','2013-11-04','09:15:00',2.44),('10318','2013-11-04','09:20:00',1.55),('10318','2013-11-04','09:45:00',3.26),('10318','2013-11-04','09:50:00',6.57),('10318','2013-11-04','09:55:00',6.8),('10318','2013-11-04','10:00:00',7.16),('10318','2013-11-04','10:05:00',7.37),('10318','2013-11-04','10:10:00',7.59),('10318','2013-11-04','10:15:00',7.77),('10318','2013-11-04','10:20:00',7.89),('10318','2013-11-04','10:25:00',8.53),('10318','2013-11-04','10:30:00',6.24),('10318','2013-11-04','10:35:00',3.23),('10318','2013-11-04','10:40:00',2.07),('10318','2013-11-04','10:45:00',2.07),('10318','2013-11-04','10:50:00',1.54),('10318','2013-11-04','10:55:00',1.39),('10318','2013-11-04','11:00:00',1.25),('10318','2013-11-04','11:05:00',1.33),('10318','2013-11-04','11:10:00',1.13),('10318','2013-11-04','11:15:00',1.17),('10318','2013-11-04','11:25:00',1.42),('10318','2013-11-04','11:30:00',4.3),('10318','2013-11-04','11:35:00',2.28),('10318','2013-11-04','11:40:00',1.99),('10318','2013-11-04','11:45:00',3.13),('10318','2013-11-04','11:50:00',6.94),('10318','2013-11-04','11:55:00',7.43),('10318','2013-11-04','12:00:00',7.93),('10318','2013-11-04','12:05:00',6.08),('10318','2013-11-04','12:10:00',6.02),('10318','2013-11-04','12:15:00',7.75),('10318','2013-11-04','12:20:00',7.31),('10318','2013-11-04','12:25:00',7.22),('10318','2013-11-04','12:30:00',7.32),('10318','2013-11-04','12:35:00',7.34),('10318','2013-11-04','12:40:00',6.18),('10318','2013-11-04','12:45:00',7),('10318','2013-11-04','12:50:00',6.71),('10318','2013-11-04','12:55:00',6.72),('10318','2013-11-04','13:00:00',6.63),('10318','2013-11-04','13:05:00',6.43),('10318','2013-11-04','13:10:00',5.77),('10318','2013-11-04','13:15:00',5.57),('10318','2013-11-04','13:20:00',3.8),('10318','2013-11-04','13:25:00',3.84),('10318','2013-11-04','13:30:00',6.09),('10318','2013-11-04','13:35:00',5.69),('10318','2013-11-04','13:40:00',2.13),('10318','2013-11-04','13:45:00',1.78),('10318','2013-11-04','13:50:00',3.03),('10318','2013-11-04','13:55:00',5.84),('10318','2013-11-04','14:00:00',4.67),('10318','2013-11-04','14:05:00',5.11),('10318','2013-11-04','14:10:00',3.6),('10318','2013-11-04','14:15:00',3),('10318','2013-11-04','14:20:00',3.02),('10318','2013-11-04','14:25:00',5.56),('10318','2013-11-04','14:30:00',4.67),('10318','2013-11-04','14:35:00',3.72),('10318','2013-11-04','14:40:00',2.58),('10318','2013-11-04','14:45:00',3.54),('10318','2013-11-04','14:50:00',3.01),('10318','2013-11-04','14:55:00',3.48),('10318','2013-11-04','15:00:00',3.39),('10318','2013-11-04','15:05:00',3.57),('10318','2013-11-04','15:10:00',3.27),('10318','2013-11-04','15:15:00',3.01),('10318','2013-11-04','15:20:00',2.73),('10318','2013-11-04','15:25:00',2.54),('10318','2013-11-04','15:30:00',2.51),('10318','2013-11-04','15:35:00',1.21),('10318','2013-11-04','15:40:00',1.31),('10318','2013-11-04','15:45:00',2.11),('10318','2013-11-04','15:50:00',1.24),('10318','2013-11-03','07:25:00',1.09),('10318','2013-11-03','07:30:00',1.89),('10318','2013-11-03','07:35:00',2.35),('10318','2013-11-03','07:40:00',2.81),('10318','2013-11-03','07:45:00',3.11),('10318','2013-11-03','07:50:00',2.98),('10318','2013-11-03','07:55:00',2.78),('10318','2013-11-03','08:00:00',1.54),('10318','2013-11-03','08:05:00',1.18),('10318','2013-11-03','08:10:00',1.11),('10318','2013-11-03','08:15:00',2.66),('10318','2013-11-03','08:20:00',2.74),('10318','2013-11-03','08:25:00',1.14),('10318','2013-11-03','08:30:00',1.64),('10318','2013-11-03','08:35:00',4.29),('10318','2013-11-03','08:40:00',1.74),('10318','2013-11-03','08:45:00',4.07),('10318','2013-11-03','08:50:00',4.25),('10318','2013-11-03','08:55:00',3.53),('10318','2013-11-03','09:00:00',3.52),('10318','2013-11-03','09:05:00',1.78),('10318','2013-11-03','09:10:00',1.07),('10318','2013-11-03','09:30:00',2.26),('10318','2013-11-03','09:35:00',5.47),('10318','2013-11-03','09:40:00',3.74),('10318','2013-11-03','09:45:00',1.71),('10318','2013-11-03','09:50:00',1.76),('10318','2013-11-03','10:00:00',1.3),('10318','2013-11-03','10:05:00',3.18),('10318','2013-11-03','10:10:00',1.17),('10318','2013-11-03','10:15:00',1.25),('10318','2013-11-03','10:20:00',1.17),('10318','2013-11-03','10:25:00',4.74),('10318','2013-11-03','10:30:00',7.19),('10318','2013-11-03','10:35:00',4.73),('10318','2013-11-03','10:40:00',1.05),('10318','2013-11-03','10:45:00',1.05),('10318','2013-11-03','10:50:00',1.12),('10318','2013-11-03','11:00:00',1.13),('10318','2013-11-03','11:05:00',1.91),('10318','2013-11-03','11:10:00',4.07),('10318','2013-11-03','11:15:00',6.56),('10318','2013-11-03','11:20:00',6.42),('10318','2013-11-03','11:25:00',1.23),('10318','2013-11-03','11:30:00',3.1),('10318','2013-11-03','11:35:00',4.6),('10318','2013-11-03','11:40:00',2.72),('10318','2013-11-03','11:45:00',4.89),('10318','2013-11-03','11:50:00',3.3),('10318','2013-11-03','11:55:00',2.88),('10318','2013-11-03','12:00:00',8.86),('10318','2013-11-03','12:05:00',8.6),('10318','2013-11-03','12:10:00',8.75),('10318','2013-11-03','12:15:00',6.29),('10318','2013-11-03','12:20:00',7.67),('10318','2013-11-03','12:25:00',7.39),('10318','2013-11-03','12:30:00',3.46),('10318','2013-11-03','12:35:00',2.37),('10318','2013-11-03','12:40:00',2.51),('10318','2013-11-03','12:45:00',2.24),('10318','2013-11-03','12:50:00',3.12),('10318','2013-11-03','12:55:00',2.8),('10318','2013-11-03','13:00:00',2.49),('10318','2013-11-03','13:05:00',2.32),('10318','2013-11-03','13:10:00',2.28),('10318','2013-11-03','13:15:00',2.31),('10318','2013-11-03','13:20:00',2.27),('10318','2013-11-03','13:25:00',2.8),('10318','2013-11-03','13:30:00',4.14),('10318','2013-11-03','13:35:00',3.55),('10318','2013-11-03','13:40:00',2.62),('10318','2013-11-03','13:45:00',1.82),('10318','2013-11-03','13:50:00',3.53),('10318','2013-11-03','13:55:00',2.74),('10318','2013-11-03','14:00:00',3.14),('10318','2013-11-03','14:05:00',3.29),('10318','2013-11-03','14:10:00',4.42),('10318','2013-11-03','14:15:00',2.79),('10318','2013-11-03','14:20:00',3.6),('10318','2013-11-03','14:25:00',3.03),('10318','2013-11-03','14:30:00',3.56),('10318','2013-11-03','14:35:00',2.65),('10318','2013-11-03','14:40:00',3.51),('10318','2013-11-03','14:45:00',1.79),('10318','2013-11-03','14:50:00',1.86),('10318','2013-11-03','14:55:00',1.91),('10318','2013-11-03','15:00:00',2.13),('10318','2013-11-03','15:05:00',1.95),('10318','2013-11-03','15:10:00',1.77),('10318','2013-11-03','15:15:00',1.39),('10318','2013-11-03','15:20:00',1.67),('10318','2013-11-03','15:25:00',1.39),('10318','2013-11-03','15:30:00',1.8),('10318','2013-11-03','15:55:00',1.01),('10318','2013-11-03','16:00:00',1.08),('10318','2013-11-02','07:45:00',1.91),('10318','2013-11-02','07:50:00',2.49),('10318','2013-11-02','07:55:00',2.78),('10318','2013-11-02','08:00:00',3.14),('10318','2013-11-02','08:05:00',3.35),('10318','2013-11-02','08:10:00',3.51),('10318','2013-11-02','08:15:00',3.72),('10318','2013-11-02','08:20:00',3.88),('10318','2013-11-02','08:25:00',4.07),('10318','2013-11-02','08:30:00',4.25),('10318','2013-11-02','08:35:00',4.35),('10318','2013-11-02','08:40:00',4.55),('10318','2013-11-02','08:45:00',4.7),('10318','2013-11-02','08:50:00',4.86),('10318','2013-11-02','08:55:00',4.9),('10318','2013-11-02','09:00:00',5.27),('10318','2013-11-02','09:05:00',5.49),('10318','2013-11-02','09:10:00',3.31),('10318','2013-11-02','09:15:00',3.21),('10318','2013-11-02','09:20:00',6.16),('10318','2013-11-02','09:25:00',5.9),('10318','2013-11-02','09:30:00',5.89),('10318','2013-11-02','09:35:00',5.44),('10318','2013-11-02','09:40:00',5.99),('10318','2013-11-02','09:45:00',4.12),('10318','2013-11-02','09:50:00',4.66),('10318','2013-11-02','09:55:00',5.57),('10318','2013-11-02','10:00:00',6.72),('10318','2013-11-02','10:05:00',6.47),('10318','2013-11-02','10:10:00',2.57),('10318','2013-11-02','10:15:00',2.12),('10318','2013-11-02','10:20:00',1.59),('10318','2013-11-02','10:25:00',1.22),('10318','2013-11-02','10:40:00',1.06),('10318','2013-11-02','10:45:00',1.39),('10318','2013-11-02','10:50:00',1.75),('10318','2013-11-02','10:55:00',2.53),('10318','2013-11-02','11:00:00',2.69),('10318','2013-11-02','11:05:00',3.7),('10318','2013-11-02','11:10:00',3.3),('10318','2013-11-02','11:15:00',2.44),('10318','2013-11-02','11:20:00',1.75),('10318','2013-11-02','11:25:00',1.62),('10318','2013-11-02','11:30:00',1.6),('10318','2013-11-02','11:35:00',1.54),('10318','2013-11-02','11:40:00',2.07),('10318','2013-11-02','11:45:00',2.2),('10318','2013-11-02','11:50:00',3.21),('10318','2013-11-02','11:55:00',8.37),('10318','2013-11-02','12:00:00',7.35),('10318','2013-11-02','12:05:00',2.86),('10318','2013-11-02','12:10:00',2.23),('10318','2013-11-02','12:15:00',8.41),('10318','2013-11-02','12:20:00',6.13),('10318','2013-11-02','12:25:00',3.51),('10318','2013-11-02','12:30:00',7.41),('10318','2013-11-02','12:35:00',8.15),('10318','2013-11-02','12:40:00',7.67),('10318','2013-11-02','12:45:00',6.89),('10318','2013-11-02','12:50:00',3.75),('10318','2013-11-02','12:55:00',3.48),('10318','2013-11-02','13:00:00',2.3),('10318','2013-11-02','13:05:00',2.96),('10318','2013-11-02','13:10:00',2.96),('10318','2013-11-02','13:15:00',3.05),('10318','2013-11-02','13:20:00',6.07),('10318','2013-11-02','13:25:00',5.12),('10318','2013-11-02','13:30:00',3.75),('10318','2013-11-02','13:35:00',4.55),('10318','2013-11-02','13:40:00',7.29),('10318','2013-11-02','13:45:00',6.5),('10318','2013-11-02','13:50:00',6.41),('10318','2013-11-02','13:55:00',4.48),('10318','2013-11-02','14:00:00',5.85),('10318','2013-11-02','14:05:00',5.22),('10318','2013-11-02','14:10:00',4.27),('10318','2013-11-02','14:15:00',3.7),('10318','2013-11-02','14:20:00',4.76),('10318','2013-11-02','14:25:00',3.6),('10318','2013-11-02','14:30:00',2.7),('10318','2013-11-02','14:35:00',4.19),('10318','2013-11-02','14:40:00',3.55),('10318','2013-11-02','14:45:00',3.8),('10318','2013-11-02','14:50:00',2.49),('10318','2013-11-02','14:55:00',1.62),('10318','2013-11-02','15:00:00',3.03),('10318','2013-11-02','15:05:00',2.93),('10318','2013-11-02','15:10:00',2.33),('10318','2013-11-02','15:15:00',1.61),('10318','2013-11-02','15:20:00',2.48),('10318','2013-11-02','15:25:00',2.82),('10318','2013-11-02','15:30:00',2.2),('10318','2013-11-02','15:35:00',1.03),('10318','2013-11-02','15:40:00',1.93),('10318','2013-11-02','15:45:00',1.3),('10318','2013-11-02','15:50:00',1.15),('10318','2013-11-02','15:55:00',1.61),('10318','2013-11-02','16:00:00',1.48),('10318','2013-11-02','16:05:00',1.16),('10318','2013-11-02','16:10:00',1.24),('10318','2013-11-02','16:15:00',1.16),('10318','2013-11-01','07:20:00',1.08),('10318','2013-11-01','07:25:00',1.24),('10318','2013-11-01','07:30:00',1.52),('10318','2013-11-01','07:35:00',1.88),('10318','2013-11-01','07:40:00',2.15),('10318','2013-11-01','07:45:00',2.47),('10318','2013-11-01','07:50:00',2.68),('10318','2013-11-01','07:55:00',2.74),('10318','2013-11-01','08:00:00',2.67),('10318','2013-11-01','08:05:00',2.59),('10318','2013-11-01','08:10:00',2.43),('10318','2013-11-01','08:15:00',3.03),('10318','2013-11-01','08:20:00',3.05),('10318','2013-11-01','08:25:00',3.58),('10318','2013-11-01','08:30:00',3.85),('10318','2013-11-01','08:35:00',4.34),('10318','2013-11-01','08:40:00',4.51),('10318','2013-11-01','08:45:00',4.23),('10318','2013-11-01','08:50:00',4.34),('10318','2013-11-01','08:55:00',4.57),('10318','2013-11-01','09:00:00',4.97),('10318','2013-11-01','09:05:00',5.27),('10318','2013-11-01','09:10:00',5.21),('10318','2013-11-01','09:15:00',5.38),('10318','2013-11-01','09:20:00',5.74),('10318','2013-11-01','09:25:00',5.85),('10318','2013-11-01','09:30:00',5.91),('10318','2013-11-01','09:35:00',6.03),('10318','2013-11-01','09:40:00',6.14),('10318','2013-11-01','09:45:00',6.24),('10318','2013-11-01','09:50:00',6.36),('10318','2013-11-01','09:55:00',6.46),('10318','2013-11-01','10:00:00',6.53),('10318','2013-11-01','10:05:00',6.62),('10318','2013-11-01','10:10:00',6.71),('10318','2013-11-01','10:15:00',6.65),('10318','2013-11-01','10:20:00',6.83),('10318','2013-11-01','10:25:00',6.88),('10318','2013-11-01','10:30:00',6.87),('10318','2013-11-01','10:35:00',6.71),('10318','2013-11-01','10:40:00',6.8),('10318','2013-11-01','10:45:00',6.63),('10318','2013-11-01','10:50:00',6.68),('10318','2013-11-01','10:55:00',6.9),('10318','2013-11-01','11:00:00',6.84),('10318','2013-11-01','11:05:00',6.55),('10318','2013-11-01','11:10:00',5.89),('10318','2013-11-01','11:15:00',6.11),('10318','2013-11-01','11:20:00',6.66),('10318','2013-11-01','11:25:00',7.05),('10318','2013-11-01','11:30:00',6.88),('10318','2013-11-01','11:35:00',6.45),('10318','2013-11-01','11:40:00',6.88),('10318','2013-11-01','11:45:00',7.33),('10318','2013-11-01','11:50:00',7.17),('10318','2013-11-01','11:55:00',6.41),('10318','2013-11-01','12:00:00',6.49),('10318','2013-11-01','12:05:00',7.16),('10318','2013-11-01','12:10:00',6.85),('10318','2013-11-01','12:15:00',6.8),('10318','2013-11-01','12:20:00',6.78),('10318','2013-11-01','12:25:00',6.43),('10318','2013-11-01','12:30:00',6.19),('10318','2013-11-01','12:35:00',3.2),('10318','2013-11-01','12:40:00',1.63),('10318','2013-11-01','12:45:00',1.51),('10318','2013-11-01','12:50:00',1.81),('10318','2013-11-01','12:55:00',1.82),('10318','2013-11-01','13:00:00',1.83),('10318','2013-11-01','13:05:00',3.34),('10318','2013-11-01','13:10:00',2.65),('10318','2013-11-01','13:15:00',3.82),('10318','2013-11-01','13:20:00',3.05),('10318','2013-11-01','13:25:00',2.24),('10318','2013-11-01','13:30:00',2),('10318','2013-11-01','13:35:00',2.78),('10318','2013-11-01','13:40:00',2.54),('10318','2013-11-01','13:45:00',1.56),('10318','2013-11-01','13:50:00',1.33),('10318','2013-11-01','13:55:00',1.28),('10318','2013-11-01','14:00:00',1.41),('10318','2013-11-01','14:05:00',1.59),('10318','2013-11-01','14:10:00',1.66),('10318','2013-11-01','14:15:00',1.67),('10318','2013-11-01','14:20:00',1.55),('10318','2013-11-01','14:25:00',1.32),('10318','2013-11-01','14:30:00',1.13),('10318','2013-10-31','08:00:00',1.46),('10318','2013-10-31','08:05:00',1.9),('10318','2013-10-31','08:10:00',2.46),('10318','2013-10-31','08:15:00',3.37),('10318','2013-10-31','08:20:00',3.46),('10318','2013-10-31','08:25:00',3.49),('10318','2013-10-31','08:30:00',3.43),('10318','2013-10-31','08:35:00',4.14),('10318','2013-10-31','08:40:00',4.7),('10318','2013-10-31','08:45:00',4.95),('10318','2013-10-31','08:50:00',5.29),('10318','2013-10-31','08:55:00',4.79),('10318','2013-10-31','09:00:00',3.78),('10318','2013-10-31','09:05:00',4.15),('10318','2013-10-31','09:10:00',3.73),('10318','2013-10-31','09:15:00',3.77),('10318','2013-10-31','09:20:00',2.47),('10318','2013-10-31','09:25:00',2.69),('10318','2013-10-31','09:30:00',2.82),('10318','2013-10-31','09:35:00',4.07),('10318','2013-10-31','09:40:00',4.82),('10318','2013-10-31','09:45:00',4.83),('10318','2013-10-31','09:50:00',5.01),('10318','2013-10-31','09:55:00',5.3),('10318','2013-10-31','10:00:00',5.38),('10318','2013-10-31','10:05:00',5.41),('10318','2013-10-31','10:10:00',5.35),('10318','2013-10-31','10:15:00',5.03),('10318','2013-10-31','10:20:00',5.07),('10318','2013-10-31','10:25:00',5),('10318','2013-10-31','10:30:00',4.81),('10318','2013-10-31','10:35:00',4.74),('10318','2013-10-31','10:40:00',5.38),('10318','2013-10-31','10:45:00',4.99),('10318','2013-10-31','10:50:00',4.64),('10318','2013-10-31','10:55:00',5),('10318','2013-10-31','11:00:00',5.3),('10318','2013-10-31','11:05:00',5.43),('10318','2013-10-31','11:10:00',6.24),('10318','2013-10-31','11:15:00',5.11),('10318','2013-10-31','11:20:00',6.56),('10318','2013-10-31','11:25:00',6.1),('10318','2013-10-31','11:30:00',5.63),('10318','2013-10-31','11:35:00',6.13),('10318','2013-10-31','11:40:00',6.37),('10318','2013-10-31','11:45:00',6.65),('10318','2013-10-31','11:50:00',6.75),('10318','2013-10-31','11:55:00',6.76),('10318','2013-10-31','12:00:00',6.73),('10318','2013-10-31','12:05:00',6.71),('10318','2013-10-31','12:10:00',6.64),('10318','2013-10-31','12:15:00',6.55),('10318','2013-10-31','12:20:00',6.44),('10318','2013-10-31','12:25:00',6.29),('10318','2013-10-31','12:30:00',6.15),('10318','2013-10-31','12:35:00',5.98),('10318','2013-10-31','12:40:00',5.96),('10318','2013-10-31','12:45:00',6.33),('10318','2013-10-31','12:50:00',6.44),('10318','2013-10-31','12:55:00',6.48),('10318','2013-10-31','13:00:00',6.32),('10318','2013-10-31','13:05:00',6.13),('10318','2013-10-31','13:10:00',6),('10318','2013-10-31','13:15:00',5.85),('10318','2013-10-31','13:20:00',5.75),('10318','2013-10-31','13:25:00',5.61),('10318','2013-10-31','13:30:00',5.47),('10318','2013-10-31','13:35:00',5.29),('10318','2013-10-31','13:40:00',5.15),('10318','2013-10-31','13:45:00',5.09),('10318','2013-10-31','13:50:00',4.88),('10318','2013-10-31','13:55:00',4.51),('10318','2013-10-31','14:00:00',4.34),('10318','2013-10-31','14:05:00',4.39),('10318','2013-10-31','14:10:00',4.27),('10318','2013-10-31','14:15:00',4.12),('10318','2013-10-31','14:20:00',3.43),('10318','2013-10-31','14:25:00',1.31),('10318','2013-10-31','14:30:00',1.03),('10318','2013-10-31','14:45:00',1.41),('10318','2013-10-31','14:50:00',2.49),('10318','2013-10-31','14:55:00',2.5),('10318','2013-10-31','15:00:00',2.51),('10318','2013-10-31','15:05:00',2.27),('10318','2013-10-31','15:10:00',2.21),('10318','2013-10-31','15:15:00',2.09),('10318','2013-10-31','15:20:00',2.03),('10318','2013-10-31','15:25:00',2),('10318','2013-10-31','15:30:00',1.88),('10318','2013-10-31','15:35:00',1.85),('10318','2013-10-31','15:40:00',1.71),('10318','2013-10-31','15:45:00',1.57),('10318','2013-10-31','15:50:00',1.49),('10318','2013-10-31','15:55:00',1.36),('10318','2013-10-31','16:00:00',1.13),('10318','2013-10-30','07:25:00',1.05),('10318','2013-10-30','07:30:00',1.2),('10318','2013-10-30','07:35:00',1.33),('10318','2013-10-30','07:40:00',1.52),('10318','2013-10-30','07:45:00',2.01),('10318','2013-10-30','07:50:00',2.24),('10318','2013-10-30','07:55:00',2.45),('10318','2013-10-30','08:00:00',2.65),('10318','2013-10-30','08:05:00',2.86),('10318','2013-10-30','08:10:00',3.02),('10318','2013-10-30','08:15:00',3.12),('10318','2013-10-30','08:20:00',3.3),('10318','2013-10-30','08:25:00',3.47),('10318','2013-10-30','08:30:00',3.52),('10318','2013-10-30','08:35:00',3.84),('10318','2013-10-30','08:40:00',4.16),('10318','2013-10-30','08:45:00',4.45),('10318','2013-10-30','08:50:00',4.52),('10318','2013-10-30','08:55:00',4.4),('10318','2013-10-30','09:00:00',4.65),('10318','2013-10-30','09:05:00',5.04),('10318','2013-10-30','09:10:00',5.16),('10318','2013-10-30','09:15:00',5.25),('10318','2013-10-30','09:20:00',5.53),('10318','2013-10-30','09:25:00',5.61),('10318','2013-10-30','09:30:00',5.76),('10318','2013-10-30','09:35:00',5.78),('10318','2013-10-30','09:40:00',5.84),('10318','2013-10-30','09:45:00',5.63),('10318','2013-10-30','09:50:00',5.63),('10318','2013-10-30','09:55:00',5.68),('10318','2013-10-30','10:00:00',5.11),('10318','2013-10-30','10:05:00',3.77),('10318','2013-10-30','10:10:00',4.32),('10318','2013-10-30','10:15:00',2.79),('10318','2013-10-30','10:20:00',3.86),('10318','2013-10-30','10:25:00',6.19),('10318','2013-10-30','10:30:00',7.06),('10318','2013-10-30','10:35:00',5.68),('10318','2013-10-30','10:40:00',4.64),('10318','2013-10-30','10:45:00',4.3),('10318','2013-10-30','10:50:00',4.83),('10318','2013-10-30','10:55:00',7.05),('10318','2013-10-30','11:00:00',6.65),('10318','2013-10-30','11:05:00',6.9),('10318','2013-10-30','11:10:00',6.94),('10318','2013-10-30','11:15:00',6.39),('10318','2013-10-30','11:20:00',5.67),('10318','2013-10-30','11:25:00',3.74),('10318','2013-10-30','11:30:00',2.2),('10318','2013-10-30','11:35:00',3.38),('10318','2013-10-30','11:40:00',4.07),('10318','2013-10-30','11:45:00',4.87),('10318','2013-10-30','11:50:00',4.9),('10318','2013-10-30','11:55:00',5.16),('10318','2013-10-30','12:00:00',6.01),('10318','2013-10-30','12:05:00',3.73),('10318','2013-10-30','12:10:00',3.7),('10318','2013-10-30','12:15:00',3.9),('10318','2013-10-30','12:20:00',6.34),('10318','2013-10-30','12:25:00',6),('10318','2013-10-30','12:30:00',3.67),('10318','2013-10-30','12:35:00',5.28),('10318','2013-10-30','12:40:00',6.65),('10318','2013-10-30','12:45:00',4.7),('10318','2013-10-30','12:50:00',2.65),('10318','2013-10-30','12:55:00',4.21),('10318','2013-10-30','13:00:00',3.63),('10318','2013-10-30','13:05:00',3.83),('10318','2013-10-30','13:10:00',3.15),('10318','2013-10-30','13:15:00',2.46),('10318','2013-10-30','13:20:00',2.33),('10318','2013-10-30','13:25:00',2.58),('10318','2013-10-30','13:30:00',4.19),('10318','2013-10-30','13:35:00',3.67),('10318','2013-10-30','13:40:00',3.27),('10318','2013-10-30','13:45:00',2.27),('10318','2013-10-30','13:50:00',4.76),('10318','2013-10-30','13:55:00',4.67),('10318','2013-10-30','14:00:00',2.08),('10318','2013-10-30','14:05:00',1.42),('10318','2013-10-30','14:10:00',1.41),('10318','2013-10-30','14:15:00',1.74),('10318','2013-10-30','14:20:00',1.91),('10318','2013-10-30','14:25:00',1.95),('10318','2013-10-30','14:30:00',1.24),('10318','2013-10-30','14:40:00',1.12),('10318','2013-10-30','14:45:00',1.11),('10318','2013-10-30','14:50:00',1.93),('10318','2013-10-30','14:55:00',3.18),('10318','2013-10-30','15:00:00',2.91),('10318','2013-10-30','15:05:00',2.3),('10318','2013-10-30','15:10:00',1.81),('10318','2013-10-30','15:15:00',1.52),('10318','2013-10-30','15:20:00',1.3),('10318','2013-10-30','15:25:00',2.06),('10318','2013-10-30','15:30:00',1.77),('10318','2013-10-30','15:35:00',1.52),('10318','2013-10-30','15:40:00',1.04),('10318','2013-10-30','15:50:00',1.24),('10318','2013-10-30','15:55:00',1.44),('10318','2013-10-30','16:00:00',1.33),('10318','2013-10-30','16:05:00',1.12),('10318','2013-10-29','07:50:00',1.13),('10318','2013-10-29','07:55:00',1.38),('10318','2013-10-29','08:00:00',1.58),('10318','2013-10-29','08:05:00',2.93),('10318','2013-10-29','08:10:00',2.38),('10318','2013-10-29','08:15:00',2.66),('10318','2013-10-29','08:20:00',2.33),('10318','2013-10-29','08:25:00',1.94),('10318','2013-10-29','08:30:00',2.24),('10318','2013-10-29','08:35:00',4.21),('10318','2013-10-29','08:40:00',4.48),('10318','2013-10-29','08:45:00',4.32),('10318','2013-10-29','08:50:00',4.79),('10318','2013-10-29','08:55:00',5),('10318','2013-10-29','09:00:00',5.2),('10318','2013-10-29','09:05:00',5.29),('10318','2013-10-29','09:10:00',5.37),('10318','2013-10-29','09:15:00',5.53),('10318','2013-10-29','09:20:00',5.64),('10318','2013-10-29','09:25:00',5.64),('10318','2013-10-29','09:30:00',5.85),('10318','2013-10-29','09:35:00',5.94),('10318','2013-10-29','09:40:00',6.17),('10318','2013-10-29','09:45:00',6.34),('10318','2013-10-29','09:50:00',5.28),('10318','2013-10-29','09:55:00',5.43),('10318','2013-10-29','10:00:00',5.77),('10318','2013-10-29','10:05:00',6.51),('10318','2013-10-29','10:10:00',6.78),('10318','2013-10-29','10:15:00',6.04),('10318','2013-10-29','10:20:00',5.09),('10318','2013-10-29','10:25:00',5.52),('10318','2013-10-29','10:30:00',7.29),('10318','2013-10-29','10:35:00',7.2),('10318','2013-10-29','10:40:00',7.06),('10318','2013-10-29','10:45:00',6.29),('10318','2013-10-29','10:50:00',6.97),('10318','2013-10-29','10:55:00',6.95),('10318','2013-10-29','11:00:00',7.13),('10318','2013-10-29','11:05:00',7.2),('10318','2013-10-29','11:10:00',7.44),('10318','2013-10-29','11:15:00',7.47),('10318','2013-10-29','11:20:00',7.24),('10318','2013-10-29','11:25:00',7.43),('10318','2013-10-29','11:30:00',7.43),('10318','2013-10-29','11:35:00',7.23),('10318','2013-10-29','11:40:00',7.25),('10318','2013-10-29','11:45:00',7.25),('10318','2013-10-29','11:50:00',7.06),('10318','2013-10-29','11:55:00',6.74),('10318','2013-10-29','12:00:00',6.42),('10318','2013-10-29','12:05:00',6.33),('10318','2013-10-29','12:10:00',6.5),('10318','2013-10-29','12:15:00',6.61),('10318','2013-10-29','12:20:00',6.6),('10318','2013-10-29','12:25:00',6.46),('10318','2013-10-29','12:30:00',6.37),('10318','2013-10-29','12:35:00',6.21),('10318','2013-10-29','12:40:00',6.04),('10318','2013-10-29','12:45:00',6.19),('10318','2013-10-29','12:50:00',6.18),('10318','2013-10-29','12:55:00',6.09),('10318','2013-10-29','13:00:00',5.81),('10318','2013-10-29','13:05:00',5.87),('10318','2013-10-29','13:10:00',5.87),('10318','2013-10-29','13:15:00',5.81),('10318','2013-10-29','13:20:00',5.69),('10318','2013-10-29','13:25:00',5.44),('10318','2013-10-29','13:30:00',5.37),('10318','2013-10-29','13:35:00',4.99),('10318','2013-10-29','13:40:00',5.17),('10318','2013-10-29','13:45:00',4.76),('10318','2013-10-29','13:50:00',4.98),('10318','2013-10-29','13:55:00',5.22),('10318','2013-10-29','14:00:00',4.91),('10318','2013-10-29','14:05:00',4.59),('10318','2013-10-29','14:10:00',4.42),('10318','2013-10-29','14:15:00',3.98),('10318','2013-10-29','14:20:00',4.17),('10318','2013-10-29','14:25:00',4.09),('10318','2013-10-29','14:30:00',3.95),('10318','2013-10-29','14:35:00',3.76),('10318','2013-10-29','14:40:00',3.62),('10318','2013-10-29','14:45:00',3.47),('10318','2013-10-29','14:50:00',3.24),('10318','2013-10-29','14:55:00',3.15),('10318','2013-10-29','15:00:00',2.98),('10318','2013-10-29','15:05:00',2.88),('10318','2013-10-29','15:10:00',2.75),('10318','2013-10-29','15:15:00',2.59),('10318','2013-10-29','15:20:00',2.37),('10318','2013-10-29','15:25:00',2.26),('10318','2013-10-29','15:30:00',2.12),('10318','2013-10-29','15:35:00',1.98),('10318','2013-10-29','15:40:00',1.82),('10318','2013-10-29','15:45:00',1.66),('10318','2013-10-29','15:50:00',1.5),('10318','2013-10-29','15:55:00',1.37),('10318','2013-10-29','16:00:00',1.21),('10318','2013-10-29','16:05:00',1.07),('10318','2014-04-17','07:50:00',2.03),('10318','2014-04-17','07:55:00',3.02),('10318','2014-04-17','08:00:00',3.66),('10318','2014-04-17','08:05:00',3.9),('10318','2014-04-17','08:10:00',4.06),('10318','2014-04-17','08:15:00',4.35),('10318','2014-04-17','08:20:00',4.47),('10318','2014-04-17','08:25:00',4.75),('10318','2014-04-17','08:30:00',4.99),('10318','2014-04-17','08:35:00',5.16),('10318','2014-04-17','08:40:00',5.4),('10318','2014-04-17','08:45:00',5.61),('10318','2014-04-17','08:50:00',5.85),('10318','2014-04-17','08:55:00',5.15),('10318','2014-04-17','09:00:00',6.08),('10318','2014-04-17','09:05:00',6.37),('10318','2014-04-17','09:10:00',6.67),('10318','2014-04-17','09:15:00',6.84),('10318','2014-04-17','09:20:00',6.97),('10318','2014-04-17','09:25:00',7.19),('10318','2014-04-17','09:30:00',7.35),('10318','2014-04-17','09:35:00',7.37),('10318','2014-04-17','09:40:00',7.69),('10318','2014-04-17','09:45:00',7.85),('10318','2014-04-17','09:50:00',8.01),('10318','2014-04-17','09:55:00',8.19),('10318','2014-04-17','10:00:00',8.39),('10318','2014-04-17','10:05:00',6.57),('10318','2014-04-17','10:10:00',5.97),('10318','2014-04-17','10:15:00',5.59),('10318','2014-04-17','10:20:00',9.02),('10318','2014-04-17','10:25:00',9.03),('10318','2014-04-17','10:30:00',9.22),('10318','2014-04-17','10:35:00',9.61),('10318','2014-04-17','10:40:00',9),('10318','2014-04-17','10:45:00',8.75),('10318','2014-04-17','10:50:00',5.9),('10318','2014-04-17','10:55:00',5.71),('10318','2014-04-17','11:00:00',8.17),('10318','2014-04-17','11:05:00',6.83),('10318','2014-04-17','11:10:00',7.51),('10318','2014-04-17','11:15:00',6.25),('10318','2014-04-17','11:20:00',7.64),('10318','2014-04-17','11:25:00',7.3),('10318','2014-04-17','11:30:00',5.16),('10318','2014-04-17','11:35:00',4.47),('10318','2014-04-17','11:40:00',5.78),('10318','2014-04-17','11:45:00',8.95),('10318','2014-04-17','11:50:00',9.77),('10318','2014-04-17','11:55:00',9.14),('10318','2014-04-17','12:00:00',7.6),('10318','2014-04-17','12:05:00',5.81),('10318','2014-04-17','12:10:00',5.55),('10318','2014-04-17','12:15:00',5.56),('10318','2014-04-17','12:20:00',6.65),('10318','2014-04-17','12:25:00',8.57),('10318','2014-04-17','12:30:00',7.04),('10318','2014-04-17','12:35:00',9.1),('10318','2014-04-17','12:40:00',10.04),('10318','2014-04-17','12:45:00',10.1),('10318','2014-04-17','12:50:00',10.2),('10318','2014-04-17','12:55:00',10.25),('10318','2014-04-17','13:00:00',10.12),('10318','2014-04-17','13:05:00',10.13),('10318','2014-04-17','13:10:00',10.21),('10318','2014-04-17','13:15:00',10.36),('10318','2014-04-17','13:20:00',10.55),('10318','2014-04-17','13:25:00',10.36),('10318','2014-04-17','13:30:00',8.55),('10318','2014-04-17','13:35:00',2.14),('10318','2014-04-17','13:40:00',3.98),('10318','2014-04-17','13:45:00',10.54),('10318','2014-04-17','13:50:00',7.93),('10318','2014-04-17','13:55:00',4.67),('10318','2014-04-17','14:00:00',7.26),('10318','2014-04-17','14:05:00',4.91),('10318','2014-04-17','14:10:00',7.21),('10318','2014-04-17','14:15:00',5.81),('10318','2014-04-17','14:20:00',4.34),('10318','2014-04-17','14:25:00',3.98),('10318','2014-04-17','14:30:00',7.03),('10318','2014-04-17','14:35:00',5.21),('10318','2014-04-17','14:40:00',3.62),('10318','2014-04-17','14:45:00',2.62),('10318','2014-04-17','14:50:00',1.71),('10318','2014-04-17','14:55:00',1.42),('10318','2014-04-17','15:00:00',1.4),('10318','2014-04-17','15:05:00',1.36),('10318','2014-04-17','15:10:00',1.36),('10318','2014-04-17','15:15:00',1.79),('10318','2014-04-17','15:20:00',2.55),('10318','2014-04-17','15:25:00',3.27),('10318','2014-04-17','15:30:00',4.9),('10318','2014-04-17','15:35:00',5.83),('10318','2014-04-17','15:40:00',4.23),('10318','2014-04-17','15:45:00',2.99),('10318','2014-04-17','15:50:00',2.96),('10318','2014-04-17','15:55:00',2.96),('10318','2014-04-17','16:00:00',2.36),('10318','2014-04-17','16:05:00',2.26),('10318','2014-04-17','16:10:00',2.23),('10318','2014-04-17','16:15:00',2.08),('10318','2014-04-17','16:20:00',2.25),('10318','2014-04-17','16:25:00',2.74),('10318','2014-04-17','16:30:00',2.38),('10318','2014-04-17','16:35:00',2.44),('10318','2014-04-17','16:40:00',3.08),('10318','2014-04-17','16:45:00',5.62),('10318','2014-04-17','16:50:00',3.58),('10318','2014-04-17','16:55:00',3.32),('10318','2014-04-17','17:00:00',2.38),('10318','2014-04-17','17:05:00',2.07),('10318','2014-04-17','17:10:00',2.03),('10318','2014-04-17','17:15:00',2.39),('10318','2014-04-17','17:20:00',2.36),('10318','2014-04-17','17:25:00',2.13),('10318','2014-04-17','17:30:00',2.62),('10318','2014-04-17','17:35:00',2.88),('10318','2014-04-17','17:40:00',2.45),('10318','2014-04-17','17:45:00',2.08),('10318','2014-04-17','17:50:00',1.65),('10318','2014-04-17','17:55:00',1.54),('10318','2014-04-17','18:00:00',1.26),('10318','2013-10-28','07:20:00',1.34),('10318','2013-10-28','07:25:00',1.23),('10318','2013-10-28','07:30:00',1.25),('10318','2013-10-28','07:35:00',1.62),('10318','2013-10-28','08:00:00',1.07),('10318','2013-10-28','08:05:00',1.39),('10318','2013-10-28','08:10:00',1.31),('10318','2013-10-28','08:15:00',1.46),('10318','2013-10-28','08:20:00',1.26),('10318','2013-10-28','08:25:00',1.28),('10318','2013-10-28','08:30:00',1.6),('10318','2013-10-28','08:35:00',1.85),('10318','2013-10-28','08:40:00',2.91),('10318','2013-10-28','08:45:00',4.74),('10318','2013-10-28','08:50:00',4.95),('10318','2013-10-28','08:55:00',5.52),('10318','2013-10-28','09:00:00',5.96),('10318','2013-10-28','09:05:00',4.15),('10318','2013-10-28','09:10:00',5.59),('10318','2013-10-28','09:15:00',5.99),('10318','2013-10-28','09:20:00',5.36),('10318','2013-10-28','09:25:00',3.75),('10318','2013-10-28','09:30:00',5.91),('10318','2013-10-28','09:35:00',2.72),('10318','2013-10-28','09:40:00',2.46),('10318','2013-10-28','09:45:00',3.61),('10318','2013-10-28','09:50:00',3.02),('10318','2013-10-28','09:55:00',2.06),('10318','2013-10-28','10:00:00',1.81),('10318','2013-10-28','10:05:00',1.81),('10318','2013-10-28','10:10:00',1.84),('10318','2013-10-28','10:15:00',1.88),('10318','2013-10-28','10:20:00',1.94),('10318','2013-10-28','10:25:00',1.93),('10318','2013-10-28','10:30:00',1.87),('10318','2013-10-28','10:35:00',1.31),('10318','2013-10-28','10:40:00',2.53),('10318','2013-10-28','10:45:00',7.46),('10318','2013-10-28','10:50:00',7.24),('10318','2013-10-28','10:55:00',7.25),('10318','2013-10-28','11:00:00',7.22),('10318','2013-10-28','11:05:00',7.22),('10318','2013-10-28','11:10:00',7.16),('10318','2013-10-28','11:15:00',7.14),('10318','2013-10-28','11:20:00',7.18),('10318','2013-10-28','11:25:00',7.14),('10318','2013-10-28','11:30:00',7.14),('10318','2013-10-28','11:35:00',7.16),('10318','2013-10-28','11:40:00',7.07),('10318','2013-10-28','11:45:00',7.11),('10318','2013-10-28','11:50:00',5.26),('10318','2013-10-28','11:55:00',7.05),('10318','2013-10-28','12:00:00',7.15),('10318','2013-10-28','12:05:00',7.16),('10318','2013-10-28','12:10:00',7.18),('10318','2013-10-28','12:15:00',7.34),('10318','2013-10-28','12:20:00',7.23),('10318','2013-10-28','12:25:00',3.55),('10318','2013-10-28','12:30:00',6.97),('10318','2013-10-28','12:35:00',6.27),('10318','2013-10-28','12:40:00',5.28),('10318','2013-10-28','12:45:00',6.74),('10318','2013-10-28','12:50:00',6.65),('10318','2013-10-28','12:55:00',6.52),('10318','2013-10-28','13:00:00',6.42),('10318','2013-10-28','13:05:00',6.3),('10318','2013-10-28','13:10:00',6.23),('10318','2013-10-28','13:15:00',6.06),('10318','2013-10-28','13:20:00',5.98),('10318','2013-10-28','13:25:00',5.85),('10318','2013-10-28','13:30:00',5.88),('10318','2013-10-28','13:35:00',5.95),('10318','2013-10-28','13:40:00',5.64),('10318','2013-10-28','13:45:00',4.63),('10318','2013-10-28','13:50:00',5.29),('10318','2013-10-28','13:55:00',2.81),('10318','2013-10-28','14:00:00',5.27),('10318','2013-10-28','14:05:00',5.04),('10318','2013-10-28','14:10:00',4.05),('10318','2013-10-28','14:15:00',4.09),('10318','2013-10-28','14:20:00',4.68),('10318','2013-10-28','14:25:00',4.29),('10318','2013-10-28','14:30:00',4.4),('10318','2013-10-28','14:35:00',2.21),('10318','2013-10-28','14:40:00',4.22),('10318','2013-10-28','14:45:00',3.66),('10318','2013-10-28','14:50:00',1.24),('10318','2013-10-28','14:55:00',3.41),('10318','2013-10-28','15:00:00',3.42),('10318','2013-10-28','15:05:00',3.28),('10318','2013-10-28','15:10:00',2.72),('10318','2013-10-28','15:15:00',2.51),('10318','2013-10-28','15:20:00',2.65),('10318','2013-10-28','15:25:00',2.78),('10318','2013-10-28','15:30:00',2.61),('10318','2013-10-28','15:35:00',1.85),('10318','2013-10-28','15:40:00',1.48),('10318','2013-10-28','15:45:00',2.08),('10318','2013-10-28','15:50:00',1.91),('10318','2013-10-28','15:55:00',1.65),('10318','2013-10-28','16:00:00',1.44),('10318','2013-10-28','16:05:00',1.26),('10318','2013-10-28','16:10:00',1.03),('10318','2013-10-27','08:10:00',1.01),('10318','2013-10-27','08:25:00',1.03),('10318','2013-10-27','08:30:00',1.22),('10318','2013-10-27','08:35:00',1.59),('10318','2013-10-27','08:40:00',1.55),('10318','2013-10-27','08:45:00',1.43),('10318','2013-10-27','08:50:00',1.31),('10318','2013-10-27','08:55:00',1.15),('10318','2013-10-27','09:00:00',1.06),('10318','2013-10-27','09:05:00',1.1),('10318','2013-10-27','09:10:00',1.07),('10318','2013-10-27','09:15:00',1.07),('10318','2013-10-27','09:20:00',1.28),('10318','2013-10-27','09:25:00',1.52),('10318','2013-10-27','09:30:00',1.75),('10318','2013-10-27','09:35:00',1.85),('10318','2013-10-27','09:40:00',1.87),('10318','2013-10-27','09:45:00',2.06),('10318','2013-10-27','09:50:00',2.22),('10318','2013-10-27','09:55:00',2.45),('10318','2013-10-27','10:00:00',2.24),('10318','2013-10-27','10:05:00',2.46),('10318','2013-10-27','10:10:00',2.7),('10318','2013-10-27','10:15:00',2.83),('10318','2013-10-27','10:20:00',2.6),('10318','2013-10-27','10:25:00',2.72),('10318','2013-10-27','10:30:00',2.79),('10318','2013-10-27','10:35:00',2.96),('10318','2013-10-27','10:40:00',3.41),('10318','2013-10-27','10:45:00',3.48),('10318','2013-10-27','10:50:00',2.9),('10318','2013-10-27','10:55:00',3.64),('10318','2013-10-27','11:00:00',2.79),('10318','2013-10-27','11:05:00',2.29),('10318','2013-10-27','11:10:00',2.04),('10318','2013-10-27','11:15:00',2.13),('10318','2013-10-27','11:20:00',2.32),('10318','2013-10-27','11:25:00',2.67),('10318','2013-10-27','11:30:00',5.34),('10318','2013-10-27','11:35:00',4.22),('10318','2013-10-27','11:40:00',3.53),('10318','2013-10-27','11:45:00',3.29),('10318','2013-10-27','11:50:00',2.72),('10318','2013-10-27','11:55:00',3.08),('10318','2013-10-27','12:00:00',2.64),('10318','2013-10-27','12:05:00',2.78),('10318','2013-10-27','12:10:00',4.9),('10318','2013-10-27','12:15:00',6.25),('10318','2013-10-27','12:20:00',4.01),('10318','2013-10-27','12:25:00',4.68),('10318','2013-10-27','12:30:00',4.35),('10318','2013-10-27','12:35:00',4.92),('10318','2013-10-27','12:40:00',2.09),('10318','2013-10-27','12:45:00',1.75),('10318','2013-10-27','12:50:00',1.9),('10318','2013-10-27','12:55:00',2.28),('10318','2013-10-27','13:00:00',4.3),('10318','2013-10-27','13:05:00',3.7),('10318','2013-10-27','13:10:00',5.64),('10318','2013-10-27','13:15:00',4.84),('10318','2013-10-27','13:20:00',4.52),('10318','2013-10-27','13:25:00',4.49),('10318','2013-10-27','13:30:00',1.95),('10318','2013-10-27','13:35:00',1.91),('10318','2013-10-27','13:40:00',1.77),('10318','2013-10-27','13:45:00',2),('10318','2013-10-27','13:50:00',3.16),('10318','2013-10-27','13:55:00',4.38),('10318','2013-10-27','14:00:00',4.67),('10318','2013-10-27','14:05:00',4.84),('10318','2013-10-27','14:10:00',2.67),('10318','2013-10-27','14:15:00',5.56),('10318','2013-10-27','14:20:00',4.63),('10318','2013-10-27','14:25:00',3.71),('10318','2013-10-27','14:30:00',2.69),('10318','2013-10-27','14:35:00',2.64),('10318','2013-10-27','14:40:00',4.15),('10318','2013-10-27','14:45:00',4.02),('10318','2013-10-27','14:50:00',4.06),('10318','2013-10-27','14:55:00',3.7),('10318','2013-10-27','15:00:00',3.4),('10318','2013-10-27','15:05:00',3),('10318','2013-10-27','15:10:00',2.89),('10318','2013-10-27','15:15:00',2.79),('10318','2013-10-27','15:20:00',2.61),('10318','2013-10-27','15:30:00',1.63),('10318','2013-10-27','15:35:00',2.04),('10318','2013-10-27','15:40:00',1.52),('10318','2013-10-27','15:50:00',1.46),('10318','2013-10-27','15:55:00',1.61),('10318','2013-10-27','16:00:00',1.44),('10318','2013-10-27','16:05:00',1.26),('10318','2013-10-27','16:10:00',1.12),('10318','2013-10-26','08:20:00',1.16),('10318','2013-10-26','08:25:00',1.42),('10318','2013-10-26','08:30:00',1.8),('10318','2013-10-26','08:35:00',2.08),('10318','2013-10-26','08:40:00',2.42),('10318','2013-10-26','08:45:00',2.78),('10318','2013-10-26','08:50:00',2.95),('10318','2013-10-26','08:55:00',3.15),('10318','2013-10-26','09:00:00',3.34),('10318','2013-10-26','09:05:00',3.52),('10318','2013-10-26','09:10:00',3.63),('10318','2013-10-26','09:15:00',3.88),('10318','2013-10-26','09:20:00',4.06),('10318','2013-10-26','09:25:00',4.24),('10318','2013-10-26','09:30:00',4.43),('10318','2013-10-26','09:35:00',4.58),('10318','2013-10-26','09:40:00',4.72),('10318','2013-10-26','09:45:00',4.87),('10318','2013-10-26','09:50:00',5.01),('10318','2013-10-26','09:55:00',5.17),('10318','2013-10-26','10:00:00',5.32),('10318','2013-10-26','10:05:00',5.46),('10318','2013-10-26','10:10:00',5.6),('10318','2013-10-26','10:15:00',5.68),('10318','2013-10-26','10:20:00',5.77),('10318','2013-10-26','10:25:00',5.86),('10318','2013-10-26','10:30:00',5.97),('10318','2013-10-26','10:35:00',6.06),('10318','2013-10-26','10:40:00',6.05),('10318','2013-10-26','10:45:00',6.24),('10318','2013-10-26','10:50:00',6.36),('10318','2013-10-26','10:55:00',6.39),('10318','2013-10-26','11:00:00',6.48),('10318','2013-10-26','11:05:00',6.57),('10318','2013-10-26','11:10:00',6.66),('10318','2013-10-26','11:15:00',6.77),('10318','2013-10-26','11:20:00',6.8),('10318','2013-10-26','11:25:00',6.82),('10318','2013-10-26','11:30:00',6.84),('10318','2013-10-26','11:35:00',6.92),('10318','2013-10-26','11:40:00',6.95),('10318','2013-10-26','11:45:00',6.97),('10318','2013-10-26','11:50:00',6.95),('10318','2013-10-26','11:55:00',6.97),('10318','2013-10-26','12:00:00',6.95),('10318','2013-10-26','12:05:00',6.89),('10318','2013-10-26','12:10:00',6.7),('10318','2013-10-26','12:15:00',6.98),('10318','2013-10-26','12:20:00',6.99),('10318','2013-10-26','12:25:00',7.02),('10318','2013-10-26','12:30:00',6.88),('10318','2013-10-26','12:35:00',6.83),('10318','2013-10-26','12:40:00',6.77),('10318','2013-10-26','12:45:00',6.94),('10318','2013-10-26','12:50:00',6.88),('10318','2013-10-26','12:55:00',6.81),('10318','2013-10-26','13:00:00',6.56),('10318','2013-10-26','13:05:00',6.92),('10318','2013-10-26','13:10:00',6.76),('10318','2013-10-26','13:15:00',6.75),('10318','2013-10-26','13:20:00',6.4),('10318','2013-10-26','13:25:00',6.45),('10318','2013-10-26','13:30:00',5.77),('10318','2013-10-26','13:35:00',6.36),('10318','2013-10-26','13:40:00',5.82),('10318','2013-10-26','13:45:00',4.29),('10318','2013-10-26','13:50:00',6.07),('10318','2013-10-26','13:55:00',6.02),('10318','2013-10-26','14:00:00',5.8),('10318','2013-10-26','14:05:00',5.83),('10318','2013-10-26','14:10:00',5.28),('10318','2013-10-26','14:15:00',5.48),('10318','2013-10-26','14:20:00',5.8),('10318','2013-10-26','14:25:00',4.8),('10318','2013-10-26','14:30:00',4.82),('10318','2013-10-26','14:35:00',5.35),('10318','2013-10-26','14:40:00',4.65),('10318','2013-10-26','14:45:00',4.55),('10318','2013-10-26','14:50:00',4.94),('10318','2013-10-26','14:55:00',4.9),('10318','2013-10-26','15:00:00',4.82),('10318','2013-10-26','15:05:00',3.44),('10318','2013-10-26','15:10:00',3.82),('10318','2013-10-26','15:15:00',4.28),('10318','2013-10-26','15:20:00',4.06),('10318','2013-10-26','15:25:00',4.14),('10318','2013-10-26','15:30:00',4.01),('10318','2013-10-26','15:35:00',4.01),('10318','2013-10-26','15:40:00',3.74),('10318','2013-10-26','15:45:00',3.42),('10318','2013-10-26','15:50:00',3.19),('10318','2013-10-26','15:55:00',3.09),('10318','2013-10-26','16:00:00',2.9),('10318','2013-10-26','16:05:00',2.88),('10318','2013-10-26','16:10:00',2.66),('10318','2013-10-26','16:15:00',2.58),('10318','2013-10-26','16:20:00',2.34),('10318','2013-10-26','16:25:00',2.3),('10318','2013-10-26','16:30:00',2.12),('10318','2013-10-26','16:35:00',1.93),('10318','2013-10-26','16:40:00',1.82),('10318','2013-10-26','16:45:00',1.68),('10318','2013-10-26','16:50:00',1.59),('10318','2013-10-26','16:55:00',1.43),('10318','2013-10-26','17:00:00',1.29),('10318','2013-10-26','17:05:00',1.14),('10318','2013-10-25','08:15:00',1.04),('10318','2013-10-25','08:20:00',1.19),('10318','2013-10-25','08:25:00',1.43),('10318','2013-10-25','08:30:00',1.79),('10318','2013-10-25','08:35:00',2.09),('10318','2013-10-25','08:40:00',2.5),('10318','2013-10-25','08:45:00',2.76),('10318','2013-10-25','08:50:00',2.91),('10318','2013-10-25','08:55:00',3.03),('10318','2013-10-25','09:00:00',3.26),('10318','2013-10-25','09:05:00',3.48),('10318','2013-10-25','09:10:00',3.68),('10318','2013-10-25','09:15:00',3.9),('10318','2013-10-25','09:20:00',4.1),('10318','2013-10-25','09:25:00',4.3),('10318','2013-10-25','09:30:00',4.55),('10318','2013-10-25','09:35:00',4.71),('10318','2013-10-25','09:40:00',4.8),('10318','2013-10-25','09:45:00',4.94),('10318','2013-10-25','09:50:00',5.07),('10318','2013-10-25','09:55:00',5.23),('10318','2013-10-25','10:00:00',5.33),('10318','2013-10-25','10:05:00',5.47),('10318','2013-10-25','10:10:00',5.57),('10318','2013-10-25','10:15:00',5.73),('10318','2013-10-25','10:20:00',5.85),('10318','2013-10-25','10:25:00',5.96),('10318','2013-10-25','10:30:00',6.07),('10318','2013-10-25','10:35:00',6.14),('10318','2013-10-25','10:40:00',6.29),('10318','2013-10-25','10:45:00',6.42),('10318','2013-10-25','10:50:00',6.4),('10318','2013-10-25','10:55:00',6.55),('10318','2013-10-25','11:00:00',6.53),('10318','2013-10-25','11:05:00',6.63),('10318','2013-10-25','11:10:00',6.84),('10318','2013-10-25','11:15:00',6.9),('10318','2013-10-25','11:20:00',6.91),('10318','2013-10-25','11:25:00',6.95),('10318','2013-10-25','11:30:00',7.02),('10318','2013-10-25','11:35:00',7.03),('10318','2013-10-25','11:40:00',7.06),('10318','2013-10-25','11:45:00',7.12),('10318','2013-10-25','11:50:00',7.12),('10318','2013-10-25','11:55:00',7.09),('10318','2013-10-25','12:00:00',7.22),('10318','2013-10-25','12:05:00',7.21),('10318','2013-10-25','12:10:00',7.19),('10318','2013-10-25','12:15:00',7.23),('10318','2013-10-25','12:20:00',7.21),('10318','2013-10-25','12:25:00',7.22),('10318','2013-10-25','12:30:00',7.21),('10318','2013-10-25','12:35:00',7.19),('10318','2013-10-25','12:40:00',7.15),('10318','2013-10-25','12:45:00',7.13),('10318','2013-10-25','12:50:00',7.09),('10318','2013-10-25','12:55:00',7.08),('10318','2013-10-25','13:00:00',7.04),('10318','2013-10-25','13:05:00',6.97),('10318','2013-10-25','13:10:00',6.81),('10318','2013-10-25','13:15:00',6.87),('10318','2013-10-25','13:20:00',6.77),('10318','2013-10-25','13:25:00',6.74),('10318','2013-10-25','13:30:00',6.69),('10318','2013-10-25','13:35:00',6.57),('10318','2013-10-25','13:40:00',6.48),('10318','2013-10-25','13:45:00',6.41),('10318','2013-10-25','13:50:00',6.36),('10318','2013-10-25','13:55:00',6.32),('10318','2013-10-25','14:00:00',6.25),('10318','2013-10-25','14:05:00',6.15),('10318','2013-10-25','14:10:00',6.05),('10318','2013-10-25','14:15:00',6.01),('10318','2013-10-25','14:20:00',5.89),('10318','2013-10-25','14:25:00',5.81),('10318','2013-10-25','14:30:00',5.75),('10318','2013-10-25','14:35:00',5.62),('10318','2013-10-25','14:40:00',5.45),('10318','2013-10-25','14:45:00',5.34),('10318','2013-10-25','14:50:00',5.21),('10318','2013-10-25','14:55:00',4.9),('10318','2013-10-25','15:00:00',4.93),('10318','2013-10-25','15:05:00',4.85),('10318','2013-10-25','15:10:00',4.58),('10318','2013-10-25','15:15:00',4.49),('10318','2013-10-25','15:20:00',4.36),('10318','2013-10-25','15:25:00',4.22),('10318','2013-10-25','15:30:00',4.08),('10318','2013-10-25','15:35:00',3.92),('10318','2013-10-25','15:40:00',3.8),('10318','2013-10-25','15:45:00',3.69),('10318','2013-10-25','15:50:00',3.54),('10318','2013-10-25','15:55:00',3.4),('10318','2013-10-25','16:00:00',3.26),('10318','2013-10-25','16:05:00',3.15),('10318','2013-10-25','16:10:00',3),('10318','2013-10-25','16:15:00',2.87),('10318','2013-10-25','16:20:00',2.74),('10318','2013-10-25','16:25:00',2.59),('10318','2013-10-25','16:30:00',2.45),('10318','2013-10-25','16:35:00',2.32),('10318','2013-10-25','16:40:00',2.16),('10318','2013-10-25','16:45:00',1.96),('10318','2013-10-25','16:50:00',1.88),('10318','2013-10-25','16:55:00',1.71),('10318','2013-10-25','17:00:00',1.56),('10318','2013-10-25','17:05:00',1.36),('10318','2013-10-25','17:10:00',1.22),('10318','2013-10-25','17:15:00',1.03),('10318','2013-10-24','08:20:00',1.28),('10318','2013-10-24','08:25:00',1.11),('10318','2013-10-24','08:45:00',1.02),('10318','2013-10-24','08:50:00',1.34),('10318','2013-10-24','08:55:00',2.27),('10318','2013-10-24','09:00:00',3.05),('10318','2013-10-24','09:05:00',3.19),('10318','2013-10-24','09:10:00',4),('10318','2013-10-24','09:15:00',4.19),('10318','2013-10-24','09:20:00',2.15),('10318','2013-10-24','09:25:00',2.17),('10318','2013-10-24','09:30:00',2.36),('10318','2013-10-24','09:35:00',2.5),('10318','2013-10-24','09:40:00',2.57),('10318','2013-10-24','09:45:00',2.68),('10318','2013-10-24','09:50:00',2.73),('10318','2013-10-24','09:55:00',2.64),('10318','2013-10-24','10:00:00',2.46),('10318','2013-10-24','10:05:00',2.38),('10318','2013-10-24','10:10:00',2.17),('10318','2013-10-24','10:15:00',2.16),('10318','2013-10-24','10:20:00',1.92),('10318','2013-10-24','10:25:00',1.68),('10318','2013-10-24','10:30:00',3.12),('10318','2013-10-24','10:35:00',4.11),('10318','2013-10-24','10:40:00',6.29),('10318','2013-10-24','10:45:00',4.52),('10318','2013-10-24','10:50:00',5.33),('10318','2013-10-24','10:55:00',5.82),('10318','2013-10-24','11:00:00',7.16),('10318','2013-10-24','11:05:00',7.52),('10318','2013-10-24','11:10:00',3.28),('10318','2013-10-24','11:15:00',3.47),('10318','2013-10-24','11:20:00',4.07),('10318','2013-10-24','11:25:00',3.19),('10318','2013-10-24','11:30:00',2.56),('10318','2013-10-24','11:35:00',2.76),('10318','2013-10-24','11:40:00',3.06),('10318','2013-10-24','11:45:00',3.74),('10318','2013-10-24','11:50:00',8.23),('10318','2013-10-24','11:55:00',4.99),('10318','2013-10-24','12:00:00',3.34),('10318','2013-10-24','12:05:00',3.03),('10318','2013-10-24','12:10:00',3.06),('10318','2013-10-24','12:15:00',3.16),('10318','2013-10-24','12:20:00',3.82),('10318','2013-10-24','12:25:00',3.84),('10318','2013-10-24','12:30:00',4.23),('10318','2013-10-24','12:35:00',4.24),('10318','2013-10-24','12:40:00',4.21),('10318','2013-10-24','12:45:00',4.35),('10318','2013-10-24','12:50:00',4.53),('10318','2013-10-24','12:55:00',6.4),('10318','2013-10-24','13:00:00',7.39),('10318','2013-10-24','13:05:00',5.32),('10318','2013-10-24','13:10:00',3.61),('10318','2013-10-24','13:15:00',4.72),('10318','2013-10-24','13:20:00',3.56),('10318','2013-10-24','13:25:00',3.04),('10318','2013-10-24','13:30:00',2.86),('10318','2013-10-24','13:35:00',2.86),('10318','2013-10-24','13:40:00',2.89),('10318','2013-10-24','13:45:00',2.99),('10318','2013-10-24','13:50:00',5.12),('10318','2013-10-24','13:55:00',4.8),('10318','2013-10-24','14:00:00',3.14),('10318','2013-10-24','14:05:00',2.95),('10318','2013-10-24','14:10:00',2.95),('10318','2013-10-24','14:15:00',3.03),('10318','2013-10-24','14:20:00',3.63),('10318','2013-10-24','14:25:00',3.88),('10318','2013-10-24','14:30:00',4.16),('10318','2013-10-24','14:35:00',4.55),('10318','2013-10-24','14:40:00',6.53),('10318','2013-10-24','14:45:00',6.65),('10318','2013-10-24','14:50:00',3.31),('10318','2013-10-24','14:55:00',1.62),('10318','2013-10-24','15:00:00',2.26),('10318','2013-10-24','15:05:00',3.43),('10318','2013-10-24','15:10:00',2.83),('10318','2013-10-24','15:15:00',2.35),('10318','2013-10-24','15:20:00',2.17),('10318','2013-10-24','15:25:00',2.18),('10318','2013-10-24','15:30:00',3.65),('10318','2013-10-24','15:35:00',4.95),('10318','2013-10-24','15:40:00',4.73),('10318','2013-10-24','15:45:00',4.65),('10318','2013-10-24','15:50:00',2.22),('10318','2013-10-24','15:55:00',1.71),('10318','2013-10-24','16:00:00',1.61),('10318','2013-10-24','16:05:00',1.57),('10318','2013-10-24','16:10:00',1.56),('10318','2013-10-24','16:15:00',1.56),('10318','2013-10-24','16:20:00',1.48),('10318','2013-10-24','16:25:00',1.23),('10318','2013-10-24','16:30:00',1.1),('10318','2013-10-23','09:35:00',1.37),('10318','2013-10-23','09:40:00',1.62),('10318','2013-10-23','09:45:00',1.46),('10318','2013-10-23','09:50:00',1.5),('10318','2013-10-23','09:55:00',1.45),('10318','2013-10-23','10:00:00',1.49),('10318','2013-10-23','10:05:00',1.62),('10318','2013-10-23','10:10:00',1.96),('10318','2013-10-23','10:15:00',2.42),('10318','2013-10-23','10:20:00',2.6),('10318','2013-10-23','10:25:00',2.37),('10318','2013-10-23','10:30:00',2.42),('10318','2013-10-23','10:35:00',2.39),('10318','2013-10-23','10:40:00',3.02),('10318','2013-10-23','10:45:00',3.74),('10318','2013-10-23','10:50:00',4.14),('10318','2013-10-23','10:55:00',4.08),('10318','2013-10-23','11:00:00',2.94),('10318','2013-10-23','11:05:00',3.86),('10318','2013-10-23','11:10:00',5.19),('10318','2013-10-23','11:15:00',7.29),('10318','2013-10-23','11:20:00',6.15),('10318','2013-10-23','11:25:00',6.89),('10318','2013-10-23','11:30:00',6.88),('10318','2013-10-23','11:35:00',7.02),('10318','2013-10-23','11:40:00',6.82),('10318','2013-10-23','11:45:00',6.82),('10318','2013-10-23','11:50:00',6.87),('10318','2013-10-23','11:55:00',6.99),('10318','2013-10-23','12:00:00',6.87),('10318','2013-10-23','12:05:00',6.7),('10318','2013-10-23','12:10:00',6.45),('10318','2013-10-23','12:15:00',6.84),('10318','2013-10-23','12:20:00',6.66),('10318','2013-10-23','12:25:00',6.72),('10318','2013-10-23','12:30:00',6.48),('10318','2013-10-23','12:35:00',6.52),('10318','2013-10-23','12:40:00',5.08),('10318','2013-10-23','12:45:00',5.66),('10318','2013-10-23','12:50:00',6.45),('10318','2013-10-23','12:55:00',6.39),('10318','2013-10-23','13:00:00',6.64),('10318','2013-10-23','13:05:00',6.72),('10318','2013-10-23','13:10:00',6.76),('10318','2013-10-23','13:15:00',6.7),('10318','2013-10-23','13:20:00',6.38),('10318','2013-10-23','13:25:00',6.37),('10318','2013-10-23','13:30:00',6.26),('10318','2013-10-23','13:35:00',6.24),('10318','2013-10-23','13:40:00',6.15),('10318','2013-10-23','13:45:00',6.09),('10318','2013-10-23','13:50:00',6.32),('10318','2013-10-23','13:55:00',6.12),('10318','2013-10-23','14:00:00',5.97),('10318','2013-10-23','14:05:00',5.9),('10318','2013-10-23','14:10:00',5.85),('10318','2013-10-23','14:15:00',5.66),('10318','2013-10-23','14:20:00',5.58),('10318','2013-10-23','14:25:00',5.56),('10318','2013-10-23','14:30:00',5.26),('10318','2013-10-23','14:35:00',5.06),('10318','2013-10-23','14:40:00',5.11),('10318','2013-10-23','14:45:00',4.75),('10318','2013-10-23','14:50:00',4.75),('10318','2013-10-23','14:55:00',4.59),('10318','2013-10-23','15:00:00',4.62),('10318','2013-10-23','15:05:00',4.43),('10318','2013-10-23','15:10:00',4.42),('10318','2013-10-23','15:15:00',4.4),('10318','2013-10-23','15:20:00',4.57),('10318','2013-10-23','15:25:00',4.38),('10318','2013-10-23','15:30:00',3.74),('10318','2013-10-23','15:35:00',3.6),('10318','2013-10-23','15:40:00',4.1),('10318','2013-10-23','15:45:00',4.02),('10318','2013-10-23','15:50:00',3.61),('10318','2013-10-23','15:55:00',2.96),('10318','2013-10-23','16:00:00',2.25),('10318','2013-10-23','16:05:00',1.82),('10318','2013-10-23','16:10:00',1.85),('10318','2013-10-23','16:15:00',1.43),('10318','2013-10-23','16:20:00',1.56),('10318','2013-10-23','16:25:00',1.97),('10318','2013-10-23','16:30:00',2.22),('10318','2013-10-23','16:35:00',2.38),('10318','2013-10-23','16:40:00',2.32),('10318','2013-10-23','16:45:00',1.99),('10318','2013-10-23','16:50:00',1.64),('10318','2013-10-23','16:55:00',1.58),('10318','2013-10-23','17:00:00',1.43),('10318','2013-10-23','17:05:00',1.17),('10318','2013-10-22','08:15:00',1.06),('10318','2013-10-22','08:20:00',1.22),('10318','2013-10-22','08:25:00',1.41),('10318','2013-10-22','08:30:00',1.6),('10318','2013-10-22','08:35:00',2.01),('10318','2013-10-22','08:40:00',2.46),('10318','2013-10-22','08:45:00',2.66),('10318','2013-10-22','08:50:00',2.85),('10318','2013-10-22','08:55:00',3.08),('10318','2013-10-22','09:00:00',3.28),('10318','2013-10-22','09:05:00',3.51),('10318','2013-10-22','09:10:00',3.69),('10318','2013-10-22','09:15:00',3.85),('10318','2013-10-22','09:20:00',4.02),('10318','2013-10-22','09:25:00',4.2),('10318','2013-10-22','09:30:00',4.39),('10318','2013-10-22','09:35:00',4.44),('10318','2013-10-22','09:40:00',4.72),('10318','2013-10-22','09:45:00',4.86),('10318','2013-10-22','09:50:00',5),('10318','2013-10-22','09:55:00',5.1),('10318','2013-10-22','10:00:00',5.24),('10318','2013-10-22','10:05:00',5.36),('10318','2013-10-22','10:10:00',5.48),('10318','2013-10-22','10:15:00',5.61),('10318','2013-10-22','10:20:00',5.73),('10318','2013-10-22','10:25:00',5.8),('10318','2013-10-22','10:30:00',5.87),('10318','2013-10-22','10:35:00',5.96),('10318','2013-10-22','10:40:00',6.05),('10318','2013-10-22','10:45:00',6.12),('10318','2013-10-22','10:50:00',6.14),('10318','2013-10-22','10:55:00',6.21),('10318','2013-10-22','11:00:00',6.28),('10318','2013-10-22','11:05:00',6.41),('10318','2013-10-22','11:10:00',6.51),('10318','2013-10-22','11:15:00',6.54),('10318','2013-10-22','11:20:00',6.51),('10318','2013-10-22','11:25:00',6.63),('10318','2013-10-22','11:30:00',6.66),('10318','2013-10-22','11:35:00',6.57),('10318','2013-10-22','11:40:00',6.63),('10318','2013-10-22','11:45:00',6.73),('10318','2013-10-22','11:50:00',6.77),('10318','2013-10-22','11:55:00',6.8),('10318','2013-10-22','12:00:00',6.82),('10318','2013-10-22','12:05:00',6.86),('10318','2013-10-22','12:10:00',6.86),('10318','2013-10-22','12:15:00',6.92),('10318','2013-10-22','12:20:00',6.87),('10318','2013-10-22','12:25:00',6.77),('10318','2013-10-22','12:30:00',6.78),('10318','2013-10-22','12:35:00',6.67),('10318','2013-10-22','12:40:00',6.83),('10318','2013-10-22','12:45:00',6.81),('10318','2013-10-22','12:50:00',6.71),('10318','2013-10-22','12:55:00',6.68),('10318','2013-10-22','13:00:00',6.62),('10318','2013-10-22','13:05:00',6.57),('10318','2013-10-22','13:10:00',6.64),('10318','2013-10-22','13:15:00',6.52),('10318','2013-10-22','13:20:00',6.55),('10318','2013-10-22','13:25:00',6.46),('10318','2013-10-22','13:30:00',6.34),('10318','2013-10-22','13:35:00',6.25),('10318','2013-10-22','13:40:00',6.11),('10318','2013-10-22','13:45:00',5.9),('10318','2013-10-22','13:50:00',5.68),('10318','2013-10-22','13:55:00',6.23),('10318','2013-10-22','14:00:00',6.14),('10318','2013-10-22','14:05:00',6.42),('10318','2013-10-22','14:10:00',6.55),('10318','2013-10-22','14:15:00',5.78),('10318','2013-10-22','14:20:00',6.35),('10318','2013-10-22','14:25:00',6.05),('10318','2013-10-22','14:30:00',5.78),('10318','2013-10-22','14:35:00',5.44),('10318','2013-10-22','14:40:00',4.92),('10318','2013-10-22','14:45:00',5.07),('10318','2013-10-22','14:50:00',4.92),('10318','2013-10-22','14:55:00',4.73),('10318','2013-10-22','15:00:00',4.75),('10318','2013-10-22','15:05:00',4.67),('10318','2013-10-22','15:10:00',4.61),('10318','2013-10-22','15:15:00',4.02),('10318','2013-10-22','15:20:00',3.85),('10318','2013-10-22','15:25:00',4.11),('10318','2013-10-22','15:30:00',4.06),('10318','2013-10-22','15:35:00',3.85),('10318','2013-10-22','15:40:00',3.81),('10318','2013-10-22','15:45:00',3.55),('10318','2013-10-22','15:50:00',3.49),('10318','2013-10-22','15:55:00',3.26),('10318','2013-10-22','16:00:00',3.15),('10318','2013-10-22','16:05:00',3.03),('10318','2013-10-22','16:10:00',2.84),('10318','2013-10-22','16:15:00',2.7),('10318','2013-10-22','16:20:00',2.57),('10318','2013-10-22','16:25:00',2.46),('10318','2013-10-22','16:30:00',2.32),('10318','2013-10-22','16:35:00',2.17),('10318','2013-10-22','16:40:00',2.04),('10318','2013-10-22','16:45:00',1.91),('10318','2013-10-22','16:50:00',1.73),('10318','2013-10-22','16:55:00',1.6),('10318','2013-10-22','17:00:00',1.47),('10318','2013-10-22','17:05:00',1.32),('10318','2013-10-22','17:10:00',1.14),('10318','2013-10-22','17:15:00',1.01),('10318','2013-10-21','08:05:00',1.11),('10318','2013-10-21','08:10:00',1.25),('10318','2013-10-21','08:15:00',1.36),('10318','2013-10-21','08:20:00',1.58),('10318','2013-10-21','08:25:00',1.67),('10318','2013-10-21','08:30:00',1.96),('10318','2013-10-21','08:35:00',1.96),('10318','2013-10-21','08:40:00',2.38),('10318','2013-10-21','08:45:00',2.36),('10318','2013-10-21','08:50:00',2.09),('10318','2013-10-21','08:55:00',2.24),('10318','2013-10-21','09:00:00',1.99),('10318','2013-10-21','09:05:00',2.69),('10318','2013-10-21','09:10:00',3.63),('10318','2013-10-21','09:15:00',4.11),('10318','2013-10-21','09:20:00',4.49),('10318','2013-10-21','09:25:00',4.25),('10318','2013-10-21','09:30:00',4.05),('10318','2013-10-21','09:35:00',4.44),('10318','2013-10-21','09:40:00',4.28),('10318','2013-10-21','09:45:00',4.25),('10318','2013-10-21','09:50:00',4.27),('10318','2013-10-21','09:55:00',4.66),('10318','2013-10-21','10:00:00',4.95),('10318','2013-10-21','10:05:00',5.64),('10318','2013-10-21','10:10:00',5.56),('10318','2013-10-21','10:15:00',5.85),('10318','2013-10-21','10:20:00',5.88),('10318','2013-10-21','10:25:00',6.12),('10318','2013-10-21','10:30:00',5.99),('10318','2013-10-21','10:35:00',5.82),('10318','2013-10-21','10:40:00',5.96),('10318','2013-10-21','10:45:00',6.07),('10318','2013-10-21','10:50:00',6.4),('10318','2013-10-21','10:55:00',6.65),('10318','2013-10-21','11:00:00',6.61),('10318','2013-10-21','11:05:00',5.65),('10318','2013-10-21','11:10:00',6.93),('10318','2013-10-21','11:15:00',6.96),('10318','2013-10-21','11:20:00',6.62),('10318','2013-10-21','11:25:00',6.78),('10318','2013-10-21','11:30:00',7.03),('10318','2013-10-21','11:35:00',6.73),('10318','2013-10-21','11:40:00',6.95),('10318','2013-10-21','11:45:00',7.05),('10318','2013-10-21','11:50:00',7.09),('10318','2013-10-21','11:55:00',7.12),('10318','2013-10-21','12:00:00',7.29),('10318','2013-10-21','12:05:00',7.34),('10318','2013-10-21','12:10:00',7.31),('10318','2013-10-21','12:15:00',7.26),('10318','2013-10-21','12:20:00',7.2),('10318','2013-10-21','12:25:00',6.97),('10318','2013-10-21','12:30:00',6.95),('10318','2013-10-21','12:35:00',6.93),('10318','2013-10-21','12:40:00',6.94),('10318','2013-10-21','12:45:00',7.07),('10318','2013-10-21','12:50:00',7.09),('10318','2013-10-21','12:55:00',7.01),('10318','2013-10-21','13:00:00',6.84),('10318','2013-10-21','13:05:00',6.48),('10318','2013-10-21','13:10:00',6.29),('10318','2013-10-21','13:15:00',6.37),('10318','2013-10-21','13:20:00',6.17),('10318','2013-10-21','13:25:00',6.69),('10318','2013-10-21','13:30:00',6.77),('10318','2013-10-21','13:35:00',6.63),('10318','2013-10-21','13:40:00',6.58),('10318','2013-10-21','13:45:00',6.37),('10318','2013-10-21','13:50:00',6.3),('10318','2013-10-21','13:55:00',5.97),('10318','2013-10-21','14:00:00',6.21),('10318','2013-10-21','14:05:00',6.2),('10318','2013-10-21','14:10:00',6.13),('10318','2013-10-21','14:15:00',6.06),('10318','2013-10-21','14:20:00',6),('10318','2013-10-21','14:25:00',5.84),('10318','2013-10-21','14:30:00',5.74),('10318','2013-10-21','14:35:00',5.67),('10318','2013-10-21','14:40:00',5.39),('10318','2013-10-21','14:45:00',5.17),('10318','2013-10-21','14:50:00',5.1),('10318','2013-10-21','14:55:00',5),('10318','2013-10-21','15:00:00',4.88),('10318','2013-10-21','15:05:00',4.74),('10318','2013-10-21','15:10:00',4.67),('10318','2013-10-21','15:15:00',4.6),('10318','2013-10-21','15:20:00',4.5),('10318','2013-10-21','15:25:00',4.13),('10318','2013-10-21','15:30:00',4),('10318','2013-10-21','15:35:00',4.06),('10318','2013-10-21','15:40:00',3.94),('10318','2013-10-21','15:45:00',3.76),('10318','2013-10-21','15:50:00',3.59),('10318','2013-10-21','15:55:00',3.42),('10318','2013-10-21','16:00:00',3.33),('10318','2013-10-21','16:05:00',3.27),('10318','2013-10-21','16:10:00',3.07),('10318','2013-10-21','16:15:00',2.91),('10318','2013-10-21','16:20:00',2.73),('10318','2013-10-21','16:25:00',2.58),('10318','2013-10-21','16:30:00',2.38),('10318','2013-10-21','16:35:00',2.29),('10318','2013-10-21','16:40:00',2.17),('10318','2013-10-21','16:45:00',2.05),('10318','2013-10-21','16:50:00',1.84),('10318','2013-10-21','16:55:00',1.61),('10318','2013-10-21','17:00:00',1.44),('10318','2013-10-21','17:05:00',1.45),('10318','2013-10-21','17:10:00',1.36),('10318','2013-10-21','17:15:00',1.22),('10318','2013-10-20','08:15:00',1.44),('10318','2013-10-20','08:20:00',1.8),('10318','2013-10-20','08:25:00',2.09),('10318','2013-10-20','08:30:00',2.24),('10318','2013-10-20','08:35:00',2.83),('10318','2013-10-20','08:40:00',2.99),('10318','2013-10-20','08:45:00',3.1),('10318','2013-10-20','08:50:00',3.28),('10318','2013-10-20','08:55:00',3.44),('10318','2013-10-20','09:00:00',3.61),('10318','2013-10-20','09:05:00',3.87),('10318','2013-10-20','09:10:00',4.09),('10318','2013-10-20','09:15:00',4.31),('10318','2013-10-20','09:20:00',4.5),('10318','2013-10-20','09:25:00',4.68),('10318','2013-10-20','09:30:00',4.81),('10318','2013-10-20','09:35:00',4.95),('10318','2013-10-20','09:40:00',5.05),('10318','2013-10-20','09:45:00',5.17),('10318','2013-10-20','09:50:00',5.41),('10318','2013-10-20','09:55:00',5.56),('10318','2013-10-20','10:00:00',5.71),('10318','2013-10-20','10:05:00',5.82),('10318','2013-10-20','10:10:00',5.94),('10318','2013-10-20','10:15:00',6.06),('10318','2013-10-20','10:20:00',6.05),('10318','2013-10-20','10:25:00',6.26),('10318','2013-10-20','10:30:00',6.4),('10318','2013-10-20','10:35:00',6.46),('10318','2013-10-20','10:40:00',6.52),('10318','2013-10-20','10:45:00',6.63),('10318','2013-10-20','10:50:00',6.71),('10318','2013-10-20','10:55:00',6.76),('10318','2013-10-20','11:00:00',6.85),('10318','2013-10-20','11:05:00',6.94),('10318','2013-10-20','11:10:00',7.01),('10318','2013-10-20','11:15:00',7.11),('10318','2013-10-20','11:20:00',7.18),('10318','2013-10-20','11:25:00',7.18),('10318','2013-10-20','11:30:00',7.2),('10318','2013-10-20','11:35:00',7.14),('10318','2013-10-20','11:40:00',7.24),('10318','2013-10-20','11:45:00',7.35),('10318','2013-10-20','11:50:00',7.37),('10318','2013-10-20','11:55:00',7.31),('10318','2013-10-20','12:00:00',7.39),('10318','2013-10-20','12:05:00',7.44),('10318','2013-10-20','12:10:00',7.39),('10318','2013-10-20','12:15:00',7.3),('10318','2013-10-20','12:20:00',4.98),('10318','2013-10-20','12:25:00',4.59),('10318','2013-10-20','12:30:00',4.2),('10318','2013-10-20','12:35:00',2.44),('10318','2013-10-20','12:40:00',3.57),('10318','2013-10-20','12:45:00',5.02),('10318','2013-10-20','12:50:00',5.12),('10318','2013-10-20','12:55:00',5.48),('10318','2013-10-20','13:00:00',8.45),('10318','2013-10-20','13:05:00',4.08),('10318','2013-10-20','13:10:00',2.27),('10318','2013-10-20','13:15:00',3.22),('10318','2013-10-20','13:20:00',3.98),('10318','2013-10-20','13:25:00',3.71),('10318','2013-10-20','13:30:00',2.73),('10318','2013-10-20','13:35:00',4.03),('10318','2013-10-20','13:40:00',2.14),('10318','2013-10-20','13:45:00',2.14),('10318','2013-10-20','13:50:00',1.94),('10318','2013-10-20','13:55:00',1.74),('10318','2013-10-20','14:00:00',1.87),('10318','2013-10-20','14:05:00',1.73),('10318','2013-10-20','14:10:00',1.31),('10318','2013-10-20','14:15:00',1.18),('10318','2013-10-20','14:20:00',1.19),('10318','2013-10-20','14:25:00',1.17),('10318','2013-10-20','14:30:00',1.03),('10318','2013-10-20','14:35:00',1.07),('10318','2013-10-20','14:40:00',1.14),('10318','2013-10-20','14:45:00',1.11),('10318','2013-10-20','14:50:00',1.17),('10318','2013-10-20','14:55:00',1.28),('10318','2013-10-20','15:00:00',1.32),('10318','2013-10-20','15:05:00',1.19),('10318','2013-10-20','15:10:00',1.14),('10318','2013-10-20','15:15:00',1.06),('10318','2013-10-20','15:35:00',1.07),('10318','2013-10-20','15:40:00',1.11),('10318','2013-10-20','15:45:00',1.21),('10318','2013-10-20','15:50:00',1.04),('10318','2013-10-20','15:55:00',1.15),('10318','2013-10-20','16:00:00',1.23),('10318','2013-10-20','16:05:00',1.25),('10318','2013-10-20','16:10:00',1.25),('10318','2013-10-20','16:15:00',3.07),('10318','2013-10-20','16:20:00',3.64),('10318','2013-10-20','16:25:00',3.87),('10318','2013-10-20','16:30:00',3.68),('10318','2013-10-20','16:35:00',3.52),('10318','2013-10-20','16:40:00',3.24),('10318','2013-10-20','16:45:00',2.95),('10318','2013-10-20','16:50:00',2.63),('10318','2013-10-20','16:55:00',2.36),('10318','2013-10-20','17:00:00',2.21),('10318','2013-10-20','17:05:00',1.86),('10318','2013-10-20','17:10:00',1.55),('10318','2013-10-20','17:15:00',1.33),('10318','2013-10-20','17:20:00',1.13),('10318','2013-10-19','08:15:00',1.05),('10318','2013-10-19','08:20:00',1.93),('10318','2013-10-19','08:25:00',2.07),('10318','2013-10-19','08:30:00',2.49),('10318','2013-10-19','08:35:00',3.29),('10318','2013-10-19','08:40:00',3.62),('10318','2013-10-19','08:45:00',3.81),('10318','2013-10-19','08:50:00',4.1),('10318','2013-10-19','08:55:00',3.55),('10318','2013-10-19','09:00:00',4.4),('10318','2013-10-19','09:05:00',3.28),('10318','2013-10-19','09:10:00',4.7),('10318','2013-10-19','09:15:00',5.23),('10318','2013-10-19','09:20:00',5.38),('10318','2013-10-19','09:25:00',5.42),('10318','2013-10-19','09:30:00',5.4),('10318','2013-10-19','09:35:00',5.63),('10318','2013-10-19','09:40:00',5.85),('10318','2013-10-19','09:45:00',5.95),('10318','2013-10-19','09:50:00',6.29),('10318','2013-10-19','09:55:00',6.35),('10318','2013-10-19','10:00:00',6.36),('10318','2013-10-19','10:05:00',6.21),('10318','2013-10-19','10:10:00',6.76),('10318','2013-10-19','10:15:00',6.85),('10318','2013-10-19','10:20:00',7.13),('10318','2013-10-19','10:25:00',7.07),('10318','2013-10-19','10:30:00',7.2),('10318','2013-10-19','10:35:00',7.23),('10318','2013-10-19','10:40:00',7.19),('10318','2013-10-19','10:45:00',7.19),('10318','2013-10-19','10:50:00',7.33),('10318','2013-10-19','10:55:00',7.55),('10318','2013-10-19','11:00:00',6.52),('10318','2013-10-19','11:05:00',5.34),('10318','2013-10-19','11:10:00',2.88),('10318','2013-10-19','11:15:00',3.86),('10318','2013-10-19','11:20:00',8.64),('10318','2013-10-19','11:25:00',8.24),('10318','2013-10-19','11:30:00',8.11),('10318','2013-10-19','11:35:00',7.73),('10318','2013-10-19','11:40:00',7.53),('10318','2013-10-19','11:45:00',7.52),('10318','2013-10-19','11:50:00',6.79),('10318','2013-10-19','11:55:00',8.21),('10318','2013-10-19','12:00:00',8.06),('10318','2013-10-19','12:05:00',7.92),('10318','2013-10-19','12:10:00',7.85),('10318','2013-10-19','12:15:00',8.03),('10318','2013-10-19','12:20:00',7.42),('10318','2013-10-19','12:25:00',7.83),('10318','2013-10-19','12:30:00',7.7),('10318','2013-10-19','12:35:00',7.99),('10318','2013-10-19','12:40:00',8.21),('10318','2013-10-19','12:45:00',8.46),('10318','2013-10-19','12:50:00',8.04),('10318','2013-10-19','12:55:00',8.6),('10318','2013-10-19','13:00:00',6.74),('10318','2013-10-19','13:05:00',6.74),('10318','2013-10-19','13:10:00',7.82),('10318','2013-10-19','13:15:00',7.11),('10318','2013-10-19','13:20:00',7.83),('10318','2013-10-19','13:25:00',8.04),('10318','2013-10-19','13:30:00',6.72),('10318','2013-10-19','13:35:00',5.86),('10318','2013-10-19','13:40:00',6.21),('10318','2013-10-19','13:45:00',7.35),('10318','2013-10-19','13:50:00',8.01),('10318','2013-10-19','13:55:00',7.7),('10318','2013-10-19','14:00:00',6.69),('10318','2013-10-19','14:05:00',6.01),('10318','2013-10-19','14:10:00',5.65),('10318','2013-10-19','14:15:00',4.34),('10318','2013-10-19','14:20:00',4.59),('10318','2013-10-19','14:25:00',6.15),('10318','2013-10-19','14:30:00',6.97),('10318','2013-10-19','14:35:00',6.66),('10318','2013-10-19','14:40:00',5.72),('10318','2013-10-19','14:45:00',6.56),('10318','2013-10-19','14:50:00',6.15),('10318','2013-10-19','14:55:00',5.91),('10318','2013-10-19','15:00:00',5.77),('10318','2013-10-19','15:05:00',5.62),('10318','2013-10-19','15:10:00',5.55),('10318','2013-10-19','15:15:00',5.14),('10318','2013-10-19','15:20:00',5.05),('10318','2013-10-19','15:25:00',4.74),('10318','2013-10-19','15:30:00',4.66),('10318','2013-10-19','15:35:00',4.38),('10318','2013-10-19','15:40:00',3.71),('10318','2013-10-19','15:45:00',3.62),('10318','2013-10-19','15:50:00',4.05),('10318','2013-10-19','15:55:00',3.4),('10318','2013-10-19','16:00:00',3.91),('10318','2013-10-19','16:05:00',3.6),('10318','2013-10-19','16:10:00',3.68),('10318','2013-10-19','16:15:00',3.61),('10318','2013-10-19','16:20:00',2.39),('10318','2013-10-19','16:25:00',2.93),('10318','2013-10-19','16:30:00',3.24),('10318','2013-10-19','16:35:00',3.11),('10318','2013-10-19','16:40:00',2.97),('10318','2013-10-19','16:45:00',2.82),('10318','2013-10-19','16:50:00',2.42),('10318','2013-10-19','16:55:00',1.46),('10318','2013-10-19','17:00:00',1.2),('10318','2013-10-19','17:05:00',1.51),('10318','2013-10-19','17:15:00',1.48),('10318','2013-10-19','17:20:00',1.3),('10318','2014-05-04','07:15:00',1.37),('10318','2014-05-04','07:20:00',1.16),('10318','2014-05-04','07:25:00',1.63),('10318','2014-05-04','07:30:00',2.79),('10318','2014-05-04','07:35:00',1.79),('10318','2014-05-04','07:40:00',2.6),('10318','2014-05-04','07:45:00',3.71),('10318','2014-05-04','07:50:00',3.87),('10318','2014-05-04','07:55:00',4.07),('10318','2014-05-04','08:00:00',4.3),('10318','2014-05-04','08:05:00',4.58),('10318','2014-05-04','08:10:00',4.72),('10318','2014-05-04','08:15:00',4.81),('10318','2014-05-04','08:20:00',5.1),('10318','2014-05-04','08:25:00',5.19),('10318','2014-05-04','08:30:00',4.64),('10318','2014-05-04','08:35:00',2.8),('10318','2014-05-04','08:40:00',4.11),('10318','2014-05-04','08:45:00',5.3),('10318','2014-05-04','08:50:00',2.33),('10318','2014-05-04','08:55:00',2.45),('10318','2014-05-04','09:00:00',2.67),('10318','2014-05-04','09:05:00',3.76),('10318','2014-05-04','09:10:00',4.53),('10318','2014-05-04','09:15:00',5.18),('10318','2014-05-04','09:20:00',4.11),('10318','2014-05-04','09:25:00',9.24),('10318','2014-05-04','09:30:00',5.85),('10318','2014-05-04','09:35:00',2.7),('10318','2014-05-04','09:40:00',3.48),('10318','2014-05-04','09:45:00',6.05),('10318','2014-05-04','09:50:00',4.44),('10318','2014-05-04','09:55:00',9.41),('10318','2014-05-04','10:00:00',8.23),('10318','2014-05-04','10:05:00',7.59),('10318','2014-05-04','10:10:00',7.51),('10318','2014-05-04','10:15:00',4.57),('10318','2014-05-04','10:20:00',3.93),('10318','2014-05-04','10:25:00',3.81),('10318','2014-05-04','10:30:00',4.35),('10318','2014-05-04','10:35:00',4.1),('10318','2014-05-04','10:40:00',4.65),('10318','2014-05-04','10:45:00',5.4),('10318','2014-05-04','10:50:00',4.85),('10318','2014-05-04','10:55:00',5.28),('10318','2014-05-04','11:00:00',4.78),('10318','2014-05-04','11:05:00',7.72),('10318','2014-05-04','11:10:00',10.45),('10318','2014-05-04','11:15:00',10.77),('10318','2014-05-04','11:20:00',10.64),('10318','2014-05-04','11:25:00',10.4),('10318','2014-05-04','11:30:00',8.41),('10318','2014-05-04','11:35:00',9.1),('10318','2014-05-04','11:40:00',7.89),('10318','2014-05-04','11:45:00',6.85),('10318','2014-05-04','11:50:00',7.81),('10318','2014-05-04','11:55:00',10.23),('10318','2014-05-04','12:00:00',6.86),('10318','2014-05-04','12:05:00',5.15),('10318','2014-05-04','12:10:00',6.81),('10318','2014-05-04','12:15:00',5.62),('10318','2014-05-04','12:20:00',6.83),('10318','2014-05-04','12:25:00',6.89),('10318','2014-05-04','12:30:00',7.89),('10318','2014-05-04','12:35:00',8.43),('10318','2014-05-04','12:40:00',8.42),('10318','2014-05-04','12:45:00',6.57),('10318','2014-05-04','12:50:00',7.53),('10318','2014-05-04','12:55:00',4.58),('10318','2014-05-04','13:00:00',2.56),('10318','2014-05-04','13:05:00',2.85),('10318','2014-05-04','13:10:00',2.54),('10318','2014-05-04','13:15:00',2.4),('10318','2014-05-04','13:20:00',2.45),('10318','2014-05-04','13:25:00',2.55),('10318','2014-05-04','13:30:00',2.72),('10318','2014-05-04','13:35:00',3.03),('10318','2014-05-04','13:40:00',3.18),('10318','2014-05-04','13:45:00',3.04),('10318','2014-05-04','13:50:00',3.08),('10318','2014-05-04','13:55:00',3.2),('10318','2014-05-04','14:00:00',3.51),('10318','2014-05-04','14:05:00',3.46),('10318','2014-05-04','14:10:00',3.27),('10318','2014-05-04','14:15:00',2),('10318','2014-05-04','14:20:00',1.44),('10318','2014-05-04','14:25:00',1.34),('10318','2014-05-04','14:30:00',1.44),('10318','2014-05-04','14:35:00',1.67),('10318','2014-05-04','14:40:00',1.86),('10318','2014-05-04','14:45:00',2.17),('10318','2014-05-04','14:50:00',3.41),('10318','2014-05-04','14:55:00',4.63),('10318','2014-05-04','15:00:00',4.94),('10318','2014-05-04','15:05:00',4.5),('10318','2014-05-04','15:10:00',5.44),('10318','2014-05-04','15:15:00',4.92),('10318','2014-05-04','15:20:00',7.66),('10318','2014-05-04','15:25:00',8.7),('10318','2014-05-04','15:30:00',3.43),('10318','2014-05-04','15:35:00',2.22),('10318','2014-05-04','15:40:00',2.06),('10318','2014-05-04','15:45:00',2.4),('10318','2014-05-04','15:50:00',2.21),('10318','2014-05-04','15:55:00',2.16),('10318','2014-05-04','16:00:00',2.21),('10318','2014-05-04','16:05:00',2.34),('10318','2014-05-04','16:10:00',2.53),('10318','2014-05-04','16:15:00',2.31),('10318','2014-05-04','16:20:00',1.86),('10318','2014-05-04','16:25:00',1.42),('10318','2014-05-04','16:30:00',1.17),('10318','2014-05-04','16:35:00',1.01),('10318','2014-05-04','16:40:00',1.03),('10318','2014-05-04','16:45:00',1.05),('10318','2014-05-04','16:50:00',1.21),('10318','2014-05-04','16:55:00',1.23),('10318','2014-05-04','17:00:00',1.04),('10318','2014-05-04','17:20:00',1.43),('10318','2014-05-04','17:25:00',2.08),('10318','2014-05-04','17:30:00',2.64),('10318','2014-05-04','17:35:00',2.4),('10318','2014-05-04','17:40:00',2.05),('10318','2014-05-04','17:45:00',1.49),('10318','2014-05-04','17:50:00',1.23),('10318','2014-05-04','17:55:00',1.08),('10318','2014-05-04','18:00:00',1.18),('10318','2014-05-04','18:05:00',1.29),('10318','2014-05-04','18:10:00',1.19),('10318','2014-05-04','18:15:00',1.03),('10318','2014-05-04','18:20:00',1.03),('10318','2014-04-16','07:35:00',1.35),('10318','2014-04-16','07:40:00',2.05),('10318','2014-04-16','07:45:00',2.65),('10318','2014-04-16','07:50:00',2.99),('10318','2014-04-16','07:55:00',3.23),('10318','2014-04-16','08:00:00',3.52),('10318','2014-04-16','08:05:00',3.79),('10318','2014-04-16','08:10:00',4.06),('10318','2014-04-16','08:15:00',4.33),('10318','2014-04-16','08:20:00',4.54),('10318','2014-04-16','08:25:00',4.27),('10318','2014-04-16','08:30:00',2.63),('10318','2014-04-16','08:35:00',2.29),('10318','2014-04-16','08:40:00',2.73),('10318','2014-04-16','08:45:00',3.34),('10318','2014-04-16','08:50:00',5.66),('10318','2014-04-16','08:55:00',6.13),('10318','2014-04-16','09:00:00',6.3),('10318','2014-04-16','09:05:00',6.32),('10318','2014-04-16','09:10:00',6.6),('10318','2014-04-16','09:15:00',6.79),('10318','2014-04-16','09:20:00',6.96),('10318','2014-04-16','09:25:00',7.1),('10318','2014-04-16','09:30:00',4.28),('10318','2014-04-16','09:35:00',4.71),('10318','2014-04-16','09:40:00',2.09),('10318','2014-04-16','09:45:00',5.94),('10318','2014-04-16','09:50:00',4.97),('10318','2014-04-16','09:55:00',8.29),('10318','2014-04-16','10:00:00',8.44),('10318','2014-04-16','10:05:00',8.52),('10318','2014-04-16','10:10:00',8.56),('10318','2014-04-16','10:15:00',8.73),('10318','2014-04-16','10:20:00',8.94),('10318','2014-04-16','10:25:00',9.1),('10318','2014-04-16','10:30:00',9.21),('10318','2014-04-16','10:35:00',9.3),('10318','2014-04-16','10:40:00',9.4),('10318','2014-04-16','10:45:00',9.57),('10318','2014-04-16','10:50:00',9.79),('10318','2014-04-16','10:55:00',8.08),('10318','2014-04-16','11:00:00',5.32),('10318','2014-04-16','11:05:00',6.28),('10318','2014-04-16','11:10:00',5.74),('10318','2014-04-16','11:15:00',4.63),('10318','2014-04-16','11:20:00',8.71),('10318','2014-04-16','11:25:00',11.09),('10318','2014-04-16','11:30:00',11.01),('10318','2014-04-16','11:35:00',9.92),('10318','2014-04-16','11:40:00',8.38),('10318','2014-04-16','11:45:00',9.8),('10318','2014-04-16','11:50:00',10.81),('10318','2014-04-16','11:55:00',10.93),('10318','2014-04-16','12:00:00',9.76),('10318','2014-04-16','12:05:00',8.84),('10318','2014-04-16','12:10:00',8.43),('10318','2014-04-16','12:15:00',9.15),('10318','2014-04-16','12:20:00',5.5),('10318','2014-04-16','12:25:00',5.35),('10318','2014-04-16','12:30:00',2.44),('10318','2014-04-16','12:35:00',2.79),('10318','2014-04-16','12:40:00',2.47),('10318','2014-04-16','12:45:00',7.03),('10318','2014-04-16','12:50:00',9.48),('10318','2014-04-16','12:55:00',10.69),('10318','2014-04-16','13:00:00',9.55),('10318','2014-04-16','13:05:00',3.25),('10318','2014-04-16','13:10:00',2.24),('10318','2014-04-16','13:15:00',2.1),('10318','2014-04-16','13:20:00',2.99),('10318','2014-04-16','13:25:00',3.71),('10318','2014-04-16','13:30:00',2.69),('10318','2014-04-16','13:35:00',4.02),('10318','2014-04-16','13:40:00',9.06),('10318','2014-04-16','13:45:00',9.78),('10318','2014-04-16','13:50:00',10.46),('10318','2014-04-16','13:55:00',8.44),('10318','2014-04-16','14:00:00',4.02),('10318','2014-04-16','14:05:00',5.96),('10318','2014-04-16','14:10:00',8.8),('10318','2014-04-16','14:15:00',7.58),('10318','2014-04-16','14:20:00',5.83),('10318','2014-04-16','14:25:00',8.2),('10318','2014-04-16','14:30:00',9.81),('10318','2014-04-16','14:35:00',9.64),('10318','2014-04-16','14:40:00',9.3),('10318','2014-04-16','14:45:00',7.84),('10318','2014-04-16','14:50:00',5.75),('10318','2014-04-16','14:55:00',3.16),('10318','2014-04-16','15:00:00',8.42),('10318','2014-04-16','15:05:00',6.5),('10318','2014-04-16','15:10:00',6.98),('10318','2014-04-16','15:15:00',3.02),('10318','2014-04-16','15:20:00',1.58),('10318','2014-04-16','15:25:00',2.91),('10318','2014-04-16','15:30:00',5.88),('10318','2014-04-16','15:35:00',8.17),('10318','2014-04-16','15:40:00',7.96),('10318','2014-04-16','15:45:00',8.18),('10318','2014-04-16','15:50:00',4.21),('10318','2014-04-16','15:55:00',6.06),('10318','2014-04-16','16:00:00',7.16),('10318','2014-04-16','16:05:00',6.82),('10318','2014-04-16','16:10:00',6.57),('10318','2014-04-16','16:15:00',6.4),('10318','2014-04-16','16:20:00',6.24),('10318','2014-04-16','16:25:00',6.04),('10318','2014-04-16','16:30:00',5.85),('10318','2014-04-16','16:35:00',5.63),('10318','2014-04-16','16:40:00',5.39),('10318','2014-04-16','16:45:00',5.2),('10318','2014-04-16','16:50:00',4.99),('10318','2014-04-16','16:55:00',4.81),('10318','2014-04-16','17:00:00',4.58),('10318','2014-04-16','17:05:00',4.34),('10318','2014-04-16','17:10:00',4.13),('10318','2014-04-16','17:15:00',3.95),('10318','2014-04-16','17:20:00',3.72),('10318','2014-04-16','17:25:00',3.43),('10318','2014-04-16','17:30:00',3.32),('10318','2014-04-16','17:35:00',3.13),('10318','2014-04-16','17:40:00',2.91),('10318','2014-04-16','17:45:00',2.75),('10318','2014-04-16','17:50:00',2.57),('10318','2014-04-16','17:55:00',2.11),('10318','2014-04-16','18:00:00',2.31),('10318','2014-04-16','18:05:00',2.13),('10318','2014-04-16','18:10:00',2.03),('10318','2014-04-16','18:15:00',1.74),('10318','2014-04-16','18:20:00',1.51),('10318','2014-04-16','18:25:00',1.06),('10318','2014-04-16','18:30:00',1.19),('10318','2014-04-16','18:35:00',1.1),('10318','2014-04-16','18:40:00',1.05),('10318','2014-04-16','18:45:00',1.09),('10318','2014-04-16','18:50:00',1.09),('10318','2013-10-18','08:00:00',1.1),('10318','2013-10-18','08:05:00',1.3),('10318','2013-10-18','08:10:00',1.45),('10318','2013-10-18','08:15:00',1.55),('10318','2013-10-18','08:20:00',1.66),('10318','2013-10-18','08:25:00',1.79),('10318','2013-10-18','08:30:00',2.28),('10318','2013-10-18','08:35:00',2.9),('10318','2013-10-18','08:40:00',3.26),('10318','2013-10-18','08:45:00',3.52),('10318','2013-10-18','08:50:00',3.55),('10318','2013-10-18','08:55:00',3.7),('10318','2013-10-18','09:00:00',4.18),('10318','2013-10-18','09:05:00',4.49),('10318','2013-10-18','09:10:00',4.74),('10318','2013-10-18','09:15:00',4.76),('10318','2013-10-18','09:20:00',5.19),('10318','2013-10-18','09:25:00',5.23),('10318','2013-10-18','09:30:00',5.51),('10318','2013-10-18','09:35:00',5.68),('10318','2013-10-18','09:40:00',5.84),('10318','2013-10-18','09:45:00',5.96),('10318','2013-10-18','09:50:00',6.11),('10318','2013-10-18','09:55:00',6.24),('10318','2013-10-18','10:00:00',6.34),('10318','2013-10-18','10:05:00',6.53),('10318','2013-10-18','10:10:00',6.6),('10318','2013-10-18','10:15:00',6.7),('10318','2013-10-18','10:20:00',6.73),('10318','2013-10-18','10:25:00',6.88),('10318','2013-10-18','10:30:00',6.94),('10318','2013-10-18','10:35:00',7.04),('10318','2013-10-18','10:40:00',7.12),('10318','2013-10-18','10:45:00',7.18),('10318','2013-10-18','10:50:00',7.22),('10318','2013-10-18','10:55:00',7.31),('10318','2013-10-18','11:00:00',7.21),('10318','2013-10-18','11:05:00',6.8),('10318','2013-10-18','11:10:00',7.12),('10318','2013-10-18','11:15:00',7.3),('10318','2013-10-18','11:20:00',7.56),('10318','2013-10-18','11:25:00',7.54),('10318','2013-10-18','11:30:00',7.51),('10318','2013-10-18','11:35:00',7.71),('10318','2013-10-18','11:40:00',7.85),('10318','2013-10-18','11:45:00',7.65),('10318','2013-10-18','11:50:00',7.7),('10318','2013-10-18','11:55:00',7.77),('10318','2013-10-18','12:00:00',7.74),('10318','2013-10-18','12:05:00',7.75),('10318','2013-10-18','12:10:00',7.73),('10318','2013-10-18','12:15:00',7.5),('10318','2013-10-18','12:20:00',7.56),('10318','2013-10-18','12:25:00',7.78),('10318','2013-10-18','12:30:00',7.78),('10318','2013-10-18','12:35:00',7.61),('10318','2013-10-18','12:40:00',7.55),('10318','2013-10-18','12:45:00',7.38),('10318','2013-10-18','12:50:00',7.46),('10318','2013-10-18','12:55:00',7.51),('10318','2013-10-18','13:00:00',7.42),('10318','2013-10-18','13:05:00',7.18),('10318','2013-10-18','13:10:00',6.97),('10318','2013-10-18','13:15:00',7.27),('10318','2013-10-18','13:20:00',7.3),('10318','2013-10-18','13:25:00',7.37),('10318','2013-10-18','13:30:00',7.32),('10318','2013-10-18','13:35:00',7.22),('10318','2013-10-18','13:40:00',7.25),('10318','2013-10-18','13:45:00',7.06),('10318','2013-10-18','13:50:00',7.04),('10318','2013-10-18','13:55:00',6.82),('10318','2013-10-18','14:00:00',6.23),('10318','2013-10-18','14:05:00',6.55),('10318','2013-10-18','14:10:00',6.44),('10318','2013-10-18','14:15:00',6.58),('10318','2013-10-18','14:20:00',6.45),('10318','2013-10-18','14:25:00',6.35),('10318','2013-10-18','14:30:00',6.2),('10318','2013-10-18','14:35:00',5.97),('10318','2013-10-18','14:40:00',5.98),('10318','2013-10-18','14:45:00',5.72),('10318','2013-10-18','14:50:00',5.63),('10318','2013-10-18','14:55:00',5.59),('10318','2013-10-18','15:00:00',4.53),('10318','2013-10-18','15:05:00',4.64),('10318','2013-10-18','15:10:00',4.92),('10318','2013-10-18','15:15:00',4.95),('10318','2013-10-18','15:20:00',4.93),('10318','2013-10-18','15:25:00',4.63),('10318','2013-10-18','15:30:00',4.55),('10318','2013-10-18','15:35:00',4.41),('10318','2013-10-18','15:40:00',4.23),('10318','2013-10-18','15:45:00',3.65),('10318','2013-10-18','15:50:00',3.74),('10318','2013-10-18','15:55:00',3.54),('10318','2013-10-18','16:00:00',3.54),('10318','2013-10-18','16:05:00',3.36),('10318','2013-10-18','16:10:00',3.13),('10318','2013-10-18','16:15:00',2.8),('10318','2013-10-18','16:20:00',2.77),('10318','2013-10-18','16:25:00',2.29),('10318','2013-10-18','16:30:00',2.19),('10318','2013-10-18','16:35:00',2.01),('10318','2013-10-18','16:40:00',1.67),('10318','2013-10-18','16:45:00',1.53),('10318','2013-10-18','16:50:00',1.51),('10318','2013-10-18','16:55:00',1.74),('10318','2013-10-18','17:00:00',1.42),('10318','2013-10-18','17:05:00',1.3),('10318','2013-10-18','17:10:00',1.36),('10318','2013-10-18','17:15:00',1.12),('10318','2013-10-17','08:05:00',1.12),('10318','2013-10-17','08:10:00',1.33),('10318','2013-10-17','08:15:00',1.49),('10318','2013-10-17','08:20:00',1.67),('10318','2013-10-17','08:25:00',1.85),('10318','2013-10-17','08:30:00',2.77),('10318','2013-10-17','08:35:00',3.29),('10318','2013-10-17','08:40:00',3.49),('10318','2013-10-17','08:45:00',3.69),('10318','2013-10-17','08:50:00',3.9),('10318','2013-10-17','08:55:00',4.12),('10318','2013-10-17','09:00:00',4.23),('10318','2013-10-17','09:05:00',4.53),('10318','2013-10-17','09:10:00',4.71),('10318','2013-10-17','09:15:00',4.92),('10318','2013-10-17','09:20:00',5.1),('10318','2013-10-17','09:25:00',5.29),('10318','2013-10-17','09:30:00',5.45),('10318','2013-10-17','09:35:00',5.62),('10318','2013-10-17','09:40:00',5.76),('10318','2013-10-17','09:45:00',5.92),('10318','2013-10-17','09:50:00',6.05),('10318','2013-10-17','09:55:00',6.18),('10318','2013-10-17','10:00:00',6.31),('10318','2013-10-17','10:05:00',6.44),('10318','2013-10-17','10:10:00',6.59),('10318','2013-10-17','10:15:00',6.72),('10318','2013-10-17','10:20:00',6.81),('10318','2013-10-17','10:25:00',6.92),('10318','2013-10-17','10:30:00',7),('10318','2013-10-17','10:35:00',7.08),('10318','2013-10-17','10:40:00',7.19),('10318','2013-10-17','10:45:00',7.12),('10318','2013-10-17','10:50:00',7.36),('10318','2013-10-17','10:55:00',7.48),('10318','2013-10-17','11:00:00',7.56),('10318','2013-10-17','11:05:00',7.62),('10318','2013-10-17','11:10:00',7.68),('10318','2013-10-17','11:15:00',7.75),('10318','2013-10-17','11:20:00',7.78),('10318','2013-10-17','11:25:00',7.79),('10318','2013-10-17','11:30:00',7.83),('10318','2013-10-17','11:35:00',7.89),('10318','2013-10-17','11:40:00',7.93),('10318','2013-10-17','11:45:00',7.95),('10318','2013-10-17','11:50:00',7.95),('10318','2013-10-17','11:55:00',7.95),('10318','2013-10-17','12:00:00',7.77),('10318','2013-10-17','12:05:00',7.95),('10318','2013-10-17','12:10:00',7.98),('10318','2013-10-17','12:15:00',7.99),('10318','2013-10-17','12:20:00',7.96),('10318','2013-10-17','12:25:00',7.95),('10318','2013-10-17','12:30:00',7.82),('10318','2013-10-17','12:35:00',7.99),('10318','2013-10-17','12:40:00',8.03),('10318','2013-10-17','12:45:00',7.92),('10318','2013-10-17','12:50:00',7.9),('10318','2013-10-17','12:55:00',7.86),('10318','2013-10-17','13:00:00',7.73),('10318','2013-10-17','13:05:00',7.67),('10318','2013-10-17','13:10:00',7.65),('10318','2013-10-17','13:15:00',7.63),('10318','2013-10-17','13:20:00',7.59),('10318','2013-10-17','13:25:00',7.58),('10318','2013-10-17','13:30:00',7.52),('10318','2013-10-17','13:35:00',7.49),('10318','2013-10-17','13:40:00',7.4),('10318','2013-10-17','13:45:00',7.21),('10318','2013-10-17','13:50:00',7.2),('10318','2013-10-17','13:55:00',7.15),('10318','2013-10-17','14:00:00',7.08),('10318','2013-10-17','14:05:00',6.98),('10318','2013-10-17','14:10:00',6.86),('10318','2013-10-17','14:15:00',6.78),('10318','2013-10-17','14:20:00',6.75),('10318','2013-10-17','14:25:00',6.57),('10318','2013-10-17','14:30:00',6.47),('10318','2013-10-17','14:35:00',6.38),('10318','2013-10-17','14:40:00',6.27),('10318','2013-10-17','14:45:00',6.15),('10318','2013-10-17','14:50:00',6.04),('10318','2013-10-17','14:55:00',5.87),('10318','2013-10-17','15:00:00',5.71),('10318','2013-10-17','15:05:00',5.57),('10318','2013-10-17','15:10:00',5.45),('10318','2013-10-17','15:15:00',5.28),('10318','2013-10-17','15:20:00',5.16),('10318','2013-10-17','15:25:00',5.03),('10318','2013-10-17','15:30:00',4.8),('10318','2013-10-17','15:35:00',4.71),('10318','2013-10-17','15:40:00',4.55),('10318','2013-10-17','15:45:00',4.37),('10318','2013-10-17','15:50:00',4.18),('10318','2013-10-17','15:55:00',4.01),('10318','2013-10-17','16:00:00',3.85),('10318','2013-10-17','16:05:00',3.71),('10318','2013-10-17','16:10:00',3.57),('10318','2013-10-17','16:15:00',3.45),('10318','2013-10-17','16:20:00',3.29),('10318','2013-10-17','16:25:00',3.11),('10318','2013-10-17','16:30:00',2.92),('10318','2013-10-17','16:35:00',2.78),('10318','2013-10-17','16:40:00',2.64),('10318','2013-10-17','16:45:00',2.5),('10318','2013-10-17','16:50:00',2.36),('10318','2013-10-17','16:55:00',2.21),('10318','2013-10-17','17:00:00',2.04),('10318','2013-10-17','17:05:00',1.89),('10318','2013-10-17','17:10:00',1.67),('10318','2013-10-17','17:15:00',1.49),('10318','2013-10-17','17:20:00',1.33),('10318','2013-10-17','17:25:00',1.17),('10318','2013-10-16','08:30:00',1.22),('10318','2013-10-16','09:30:00',1.02),('10318','2013-10-16','09:35:00',1.21),('10318','2013-10-16','09:40:00',1.73),('10318','2013-10-16','09:45:00',3.95),('10318','2013-10-16','09:50:00',1.99),('10318','2013-10-16','09:55:00',2.02),('10318','2013-10-16','10:00:00',2.21),('10318','2013-10-16','10:05:00',1.02),('10318','2013-10-16','11:00:00',1.13),('10318','2013-10-16','11:05:00',2.63),('10318','2013-10-16','11:10:00',2.59),('10318','2013-10-16','11:15:00',2.98),('10318','2013-10-16','11:20:00',1.19),('10318','2013-10-16','11:25:00',1.39),('10318','2013-10-16','11:45:00',1.28),('10318','2013-10-16','11:50:00',2.01),('10318','2013-10-16','11:55:00',3.26),('10318','2013-10-16','12:00:00',1.08),('10318','2013-10-16','12:05:00',1.45),('10318','2013-10-16','12:10:00',6.43),('10318','2013-10-16','12:15:00',4.11),('10318','2013-10-16','12:20:00',4.57),('10318','2013-10-16','12:25:00',2.05),('10318','2013-10-16','12:30:00',2.59),('10318','2013-10-16','12:35:00',6.2),('10318','2013-10-16','12:40:00',5.35),('10318','2013-10-16','12:45:00',3.15),('10318','2013-10-16','12:50:00',2.32),('10318','2013-10-16','12:55:00',3.5),('10318','2013-10-16','13:00:00',5.15),('10318','2013-10-16','13:05:00',5.04),('10318','2013-10-16','13:10:00',7.02),('10318','2013-10-16','13:15:00',8.14),('10318','2013-10-16','13:20:00',7.08),('10318','2013-10-16','13:25:00',7.03),('10318','2013-10-16','13:30:00',7.07),('10318','2013-10-16','13:35:00',7.21),('10318','2013-10-16','13:40:00',6.1),('10318','2013-10-16','13:45:00',7.28),('10318','2013-10-16','13:50:00',7.45),('10318','2013-10-16','13:55:00',7.68),('10318','2013-10-16','14:00:00',5.27),('10318','2013-10-16','14:05:00',7.67),('10318','2013-10-16','14:10:00',7.18),('10318','2013-10-16','14:15:00',6.94),('10318','2013-10-16','14:20:00',6.19),('10318','2013-10-16','14:25:00',6.48),('10318','2013-10-16','14:30:00',6.38),('10318','2013-10-16','14:35:00',6.35),('10318','2013-10-16','14:40:00',4.45),('10318','2013-10-16','14:45:00',6.46),('10318','2013-10-16','14:50:00',6.55),('10318','2013-10-16','14:55:00',6.05),('10318','2013-10-16','15:00:00',5.98),('10318','2013-10-16','15:05:00',5.88),('10318','2013-10-16','15:10:00',5.92),('10318','2013-10-16','15:15:00',5.55),('10318','2013-10-16','15:20:00',3.8),('10318','2013-10-16','15:25:00',2.49),('10318','2013-10-16','15:30:00',4.95),('10318','2013-10-16','15:35:00',4.98),('10318','2013-10-16','15:40:00',4.52),('10318','2013-10-16','15:45:00',4.42),('10318','2013-10-16','15:50:00',4.26),('10318','2013-10-16','15:55:00',4.12),('10318','2013-10-16','16:00:00',3.95),('10318','2013-10-16','16:05:00',3.73),('10318','2013-10-16','16:10:00',3.62),('10318','2013-10-16','16:15:00',3.42),('10318','2013-10-16','16:20:00',3.28),('10318','2013-10-16','16:25:00',3.12),('10318','2013-10-16','16:30:00',3.01),('10318','2013-10-16','16:35:00',2.86),('10318','2013-10-16','16:40:00',2.67),('10318','2013-10-16','16:45:00',2.51),('10318','2013-10-16','16:50:00',2.34),('10318','2013-10-16','16:55:00',2.23),('10318','2013-10-16','17:00:00',2.07),('10318','2013-10-16','17:05:00',1.92),('10318','2013-10-16','17:10:00',1.75),('10318','2013-10-16','17:15:00',1.54),('10318','2013-10-16','17:20:00',1.38),('10318','2013-10-16','17:25:00',1.23),('10318','2013-10-16','17:30:00',1.05),('10318','2013-10-15','08:20:00',1.15),('10318','2013-10-15','08:25:00',1.29),('10318','2013-10-15','08:30:00',1.36),('10318','2013-10-15','08:35:00',1.44),('10318','2013-10-15','08:40:00',1.44),('10318','2013-10-15','08:45:00',1.36),('10318','2013-10-15','08:50:00',1.21),('10318','2013-10-15','08:55:00',1.39),('10318','2013-10-15','09:00:00',2.02),('10318','2013-10-15','09:05:00',2.18),('10318','2013-10-15','09:10:00',2.33),('10318','2013-10-15','09:15:00',2.23),('10318','2013-10-15','09:20:00',2.55),('10318','2013-10-15','09:25:00',3.5),('10318','2013-10-15','09:30:00',3.48),('10318','2013-10-15','09:35:00',3.45),('10318','2013-10-15','09:40:00',3.96),('10318','2013-10-15','09:45:00',5.55),('10318','2013-10-15','09:50:00',6.24),('10318','2013-10-15','09:55:00',6.07),('10318','2013-10-15','10:00:00',6.03),('10318','2013-10-15','10:05:00',6.02),('10318','2013-10-15','10:10:00',4.19),('10318','2013-10-15','10:15:00',2.88),('10318','2013-10-15','10:20:00',3.12),('10318','2013-10-15','10:25:00',5.07),('10318','2013-10-15','10:30:00',4.71),('10318','2013-10-15','10:35:00',4.58),('10318','2013-10-15','10:40:00',5.6),('10318','2013-10-15','10:45:00',5.99),('10318','2013-10-15','10:50:00',4.62),('10318','2013-10-15','10:55:00',4.6),('10318','2013-10-15','11:00:00',4.34),('10318','2013-10-15','11:05:00',5.51),('10318','2013-10-15','11:10:00',6.87),('10318','2013-10-15','11:15:00',6.7),('10318','2013-10-15','11:20:00',6.91),('10318','2013-10-15','11:25:00',6.27),('10318','2013-10-15','11:30:00',6.43),('10318','2013-10-15','11:35:00',5.18),('10318','2013-10-15','11:40:00',3.84),('10318','2013-10-15','11:45:00',3.48),('10318','2013-10-15','11:50:00',3.44),('10318','2013-10-15','11:55:00',3.21),('10318','2013-10-15','12:00:00',3.32),('10318','2013-10-15','12:05:00',3.15),('10318','2013-10-15','12:10:00',3.18),('10318','2013-10-15','12:15:00',3.06),('10318','2013-10-15','12:20:00',3.22),('10318','2013-10-15','12:25:00',2.87),('10318','2013-10-15','12:30:00',2.88),('10318','2013-10-15','12:35:00',2.89),('10318','2013-10-15','12:40:00',3.1),('10318','2013-10-15','12:45:00',3.22),('10318','2013-10-15','12:50:00',2.92),('10318','2013-10-15','12:55:00',2.69),('10318','2013-10-15','13:00:00',2.81),('10318','2013-10-15','13:05:00',3.96),('10318','2013-10-15','13:10:00',3.97),('10318','2013-10-15','13:15:00',4.8),('10318','2013-10-15','13:20:00',6.98),('10318','2013-10-15','13:25:00',6.15),('10318','2013-10-15','13:30:00',4.27),('10318','2013-10-15','13:35:00',3.48),('10318','2013-10-15','13:40:00',3.72),('10318','2013-10-15','13:45:00',3.58),('10318','2013-10-15','13:50:00',3.22),('10318','2013-10-15','13:55:00',2.76),('10318','2013-10-15','14:00:00',2.57),('10318','2013-10-15','14:05:00',2.63),('10318','2013-10-15','14:10:00',3),('10318','2013-10-15','14:15:00',4.45),('10318','2013-10-15','14:20:00',4.44),('10318','2013-10-15','14:25:00',5.48),('10318','2013-10-15','14:30:00',3.93),('10318','2013-10-15','14:35:00',3.49),('10318','2013-10-15','14:40:00',4.92),('10318','2013-10-15','14:45:00',5.39),('10318','2013-10-15','14:50:00',5.31),('10318','2013-10-15','14:55:00',3.45),('10318','2013-10-15','15:00:00',2.86),('10318','2013-10-15','15:05:00',3.13),('10318','2013-10-15','15:10:00',3.05),('10318','2013-10-15','15:15:00',2.67),('10318','2013-10-15','15:20:00',2.37),('10318','2013-10-15','15:25:00',2.15),('10318','2013-10-15','15:30:00',2.17),('10318','2013-10-15','15:35:00',2.3),('10318','2013-10-15','15:40:00',2.37),('10318','2013-10-15','15:45:00',2.21),('10318','2013-10-15','15:50:00',1.94),('10318','2013-10-15','15:55:00',1.71),('10318','2013-10-15','16:00:00',1.6),('10318','2013-10-15','16:05:00',1.66),('10318','2013-10-15','16:10:00',1.67),('10318','2013-10-15','16:15:00',1.58),('10318','2013-10-15','16:20:00',1.7),('10318','2013-10-15','16:25:00',2.19),('10318','2013-10-15','16:30:00',2.57),('10318','2013-10-15','16:35:00',2.41),('10318','2013-10-15','16:40:00',2.08),('10318','2013-10-15','16:45:00',1.64),('10318','2013-10-15','16:50:00',1.44),('10318','2013-10-15','16:55:00',1.6),('10318','2013-10-15','17:00:00',1.4),('10318','2013-10-15','17:05:00',1.26),('10318','2013-10-15','17:10:00',1.08),('10318','2013-10-14','08:00:00',1.07),('10318','2013-10-14','08:05:00',1.39),('10318','2013-10-14','08:10:00',1.47),('10318','2013-10-14','08:15:00',1.24),('10318','2013-10-14','08:20:00',1.93),('10318','2013-10-14','08:25:00',2.21),('10318','2013-10-14','08:30:00',2.88),('10318','2013-10-14','08:35:00',3.12),('10318','2013-10-14','08:40:00',2.83),('10318','2013-10-14','08:45:00',3.41),('10318','2013-10-14','08:50:00',3.14),('10318','2013-10-14','08:55:00',3.51),('10318','2013-10-14','09:00:00',3.13),('10318','2013-10-14','09:05:00',3.49),('10318','2013-10-14','09:10:00',2.31),('10318','2013-10-14','09:15:00',2.54),('10318','2013-10-14','09:20:00',3.74),('10318','2013-10-14','09:25:00',4.85),('10318','2013-10-14','09:30:00',5.41),('10318','2013-10-14','09:35:00',4.47),('10318','2013-10-14','09:40:00',4.64),('10318','2013-10-14','09:45:00',4.16),('10318','2013-10-14','09:50:00',5.21),('10318','2013-10-14','09:55:00',5.28),('10318','2013-10-14','10:00:00',5.78),('10318','2013-10-14','10:05:00',6.07),('10318','2013-10-14','10:10:00',6.29),('10318','2013-10-14','10:15:00',6.31),('10318','2013-10-14','10:20:00',6.46),('10318','2013-10-14','10:25:00',6.55),('10318','2013-10-14','10:30:00',6.64),('10318','2013-10-14','10:35:00',6.65),('10318','2013-10-14','10:40:00',6.47),('10318','2013-10-14','10:45:00',6.71),('10318','2013-10-14','10:50:00',6.93),('10318','2013-10-14','10:55:00',7),('10318','2013-10-14','11:00:00',7.07),('10318','2013-10-14','11:05:00',7.02),('10318','2013-10-14','11:10:00',7.32),('10318','2013-10-14','11:15:00',7.1),('10318','2013-10-14','11:20:00',7.28),('10318','2013-10-14','11:25:00',7.45),('10318','2013-10-14','11:30:00',7.55),('10318','2013-10-14','11:35:00',7.47),('10318','2013-10-14','11:40:00',7.42),('10318','2013-10-14','11:45:00',7.4),('10318','2013-10-14','11:50:00',7.44),('10318','2013-10-14','11:55:00',7.42),('10318','2013-10-14','12:00:00',7.4),('10318','2013-10-14','12:05:00',7.51),('10318','2013-10-14','12:10:00',7.65),('10318','2013-10-14','12:15:00',7.35),('10318','2013-10-14','12:20:00',6.81),('10318','2013-10-14','12:25:00',7.56),('10318','2013-10-14','12:30:00',7.64),('10318','2013-10-14','12:35:00',7.56),('10318','2013-10-14','12:40:00',7.55),('10318','2013-10-14','12:45:00',7.52),('10318','2013-10-14','12:50:00',7.47),('10318','2013-10-14','12:55:00',7.46),('10318','2013-10-14','13:00:00',7.4),('10318','2013-10-14','13:05:00',7.37),('10318','2013-10-14','13:10:00',7.33),('10318','2013-10-14','13:15:00',7.3),('10318','2013-10-14','13:20:00',7.24),('10318','2013-10-14','13:25:00',7.17),('10318','2013-10-14','13:30:00',7.08),('10318','2013-10-14','13:35:00',7.01),('10318','2013-10-14','13:40:00',6.96),('10318','2013-10-14','13:45:00',6.82),('10318','2013-10-14','13:50:00',6.83),('10318','2013-10-14','13:55:00',6.75),('10318','2013-10-14','14:00:00',6.69),('10318','2013-10-14','14:05:00',6.59),('10318','2013-10-14','14:10:00',6.49),('10318','2013-10-14','14:15:00',6.38),('10318','2013-10-14','14:20:00',6.31),('10318','2013-10-14','14:25:00',6.2),('10318','2013-10-14','14:30:00',6.1),('10318','2013-10-14','14:35:00',5.96),('10318','2013-10-14','14:40:00',5.88),('10318','2013-10-14','14:45:00',5.75),('10318','2013-10-14','14:50:00',5.64),('10318','2013-10-14','14:55:00',5.52),('10318','2013-10-14','15:00:00',5.38),('10318','2013-10-14','15:05:00',5.23),('10318','2013-10-14','15:10:00',5.05),('10318','2013-10-14','15:15:00',4.91),('10318','2013-10-14','15:20:00',4.79),('10318','2013-10-14','15:25:00',4.66),('10318','2013-10-14','15:30:00',4.46),('10318','2013-10-14','15:35:00',4.36),('10318','2013-10-14','15:40:00',3.85),('10318','2013-10-14','15:45:00',3.12),('10318','2013-10-14','15:50:00',3.82),('10318','2013-10-14','15:55:00',2.71),('10318','2013-10-14','16:00:00',2.87),('10318','2013-10-14','16:05:00',2.35),('10318','2013-10-14','16:10:00',2.3),('10318','2013-10-14','16:15:00',1.91),('10318','2013-10-14','16:20:00',2.22),('10318','2013-10-14','16:25:00',2.75),('10318','2013-10-14','16:30:00',1.59),('10318','2013-10-14','16:35:00',1.16),('10318','2013-10-14','16:40:00',1.37),('10318','2013-10-14','16:45:00',2.25),('10318','2013-10-14','16:50:00',1.48),('10318','2013-10-14','17:10:00',1.16),('10318','2013-10-14','17:15:00',1.11),('10318','2013-10-13','08:10:00',1.06),('10318','2013-10-13','08:15:00',1.13),('10318','2013-10-13','08:20:00',1.26),('10318','2013-10-13','08:25:00',1.47),('10318','2013-10-13','08:30:00',1.72),('10318','2013-10-13','08:35:00',2.03),('10318','2013-10-13','08:40:00',2.14),('10318','2013-10-13','08:45:00',2.19),('10318','2013-10-13','08:50:00',2.48),('10318','2013-10-13','08:55:00',3.01),('10318','2013-10-13','09:00:00',3.25),('10318','2013-10-13','09:05:00',3.04),('10318','2013-10-13','09:10:00',3.62),('10318','2013-10-13','09:15:00',4.88),('10318','2013-10-13','09:20:00',5.07),('10318','2013-10-13','09:25:00',3.87),('10318','2013-10-13','09:30:00',2.74),('10318','2013-10-13','09:35:00',3.54),('10318','2013-10-13','09:40:00',5.17),('10318','2013-10-13','09:45:00',6.38),('10318','2013-10-13','09:50:00',6.62),('10318','2013-10-13','09:55:00',6.2),('10318','2013-10-13','10:00:00',4.19),('10318','2013-10-13','10:05:00',4.13),('10318','2013-10-13','10:10:00',5.8),('10318','2013-10-13','10:15:00',5.4),('10318','2013-10-13','10:20:00',4.43),('10318','2013-10-13','10:25:00',4.77),('10318','2013-10-13','10:30:00',6.7),('10318','2013-10-13','10:35:00',7.98),('10318','2013-10-13','10:40:00',7.95),('10318','2013-10-13','10:45:00',8.11),('10318','2013-10-13','10:50:00',7.79),('10318','2013-10-13','10:55:00',6.42),('10318','2013-10-13','11:00:00',7.51),('10318','2013-10-13','11:05:00',5.44),('10318','2013-10-13','11:10:00',7.77),('10318','2013-10-13','11:15:00',7.6),('10318','2013-10-13','11:20:00',7.52),('10318','2013-10-13','11:25:00',7.4),('10318','2013-10-13','11:30:00',7.57),('10318','2013-10-13','11:35:00',7.45),('10318','2013-10-13','11:40:00',7.42),('10318','2013-10-13','11:45:00',7.47),('10318','2013-10-13','11:50:00',7.54),('10318','2013-10-13','11:55:00',7.42),('10318','2013-10-13','12:00:00',7.6),('10318','2013-10-13','12:05:00',7.61),('10318','2013-10-13','12:10:00',7.57),('10318','2013-10-13','12:15:00',7.64),('10318','2013-10-13','12:20:00',7.57),('10318','2013-10-13','12:25:00',7.3),('10318','2013-10-13','12:30:00',7.59),('10318','2013-10-13','12:35:00',7.62),('10318','2013-10-13','12:40:00',7.58),('10318','2013-10-13','12:45:00',7.47),('10318','2013-10-13','12:50:00',7.42),('10318','2013-10-13','12:55:00',7.35),('10318','2013-10-13','13:00:00',7.3),('10318','2013-10-13','13:05:00',7.32),('10318','2013-10-13','13:10:00',7.4),('10318','2013-10-13','13:15:00',7.49),('10318','2013-10-13','13:20:00',7.43),('10318','2013-10-13','13:25:00',6.43),('10318','2013-10-13','13:30:00',6.91),('10318','2013-10-13','13:35:00',6.58),('10318','2013-10-13','13:40:00',5.33),('10318','2013-10-13','13:45:00',6.09),('10318','2013-10-13','13:50:00',7.3),('10318','2013-10-13','13:55:00',5.11),('10318','2013-10-13','14:00:00',6.72),('10318','2013-10-13','14:05:00',6.91),('10318','2013-10-13','14:10:00',7.12),('10318','2013-10-13','14:15:00',5.84),('10318','2013-10-13','14:20:00',6.11),('10318','2013-10-13','14:25:00',6.99),('10318','2013-10-13','14:30:00',6.15),('10318','2013-10-13','14:35:00',4.55),('10318','2013-10-13','14:40:00',5.67),('10318','2013-10-13','14:45:00',4.56),('10318','2013-10-13','14:50:00',4.02),('10318','2013-10-13','14:55:00',4.28),('10318','2013-10-13','15:00:00',5.69),('10318','2013-10-13','15:05:00',5.37),('10318','2013-10-13','15:10:00',4.12),('10318','2013-10-13','15:15:00',3.93),('10318','2013-10-13','15:20:00',4.8),('10318','2013-10-13','15:25:00',3.92),('10318','2013-10-13','15:30:00',3.94),('10318','2013-10-13','15:35:00',3.51),('10318','2013-10-13','15:40:00',3.09),('10318','2013-10-13','15:45:00',2.82),('10318','2013-10-13','15:50:00',3.01),('10318','2013-10-13','15:55:00',3.04),('10318','2013-10-13','16:00:00',3.53),('10318','2013-10-13','16:05:00',3.46),('10318','2013-10-13','16:10:00',3.11),('10318','2013-10-13','16:15:00',3.02),('10318','2013-10-13','16:20:00',3.27),('10318','2013-10-13','16:25:00',3.36),('10318','2013-10-13','16:30:00',3.25),('10318','2013-10-13','16:35:00',3.01),('10318','2013-10-13','16:40:00',2),('10318','2013-10-13','16:45:00',1.86),('10318','2013-10-13','16:50:00',2),('10318','2013-10-13','16:55:00',1.47),('10318','2013-10-13','17:00:00',1.13),('10318','2013-10-13','17:05:00',1.08),('10318','2013-10-13','17:15:00',1.11),('10318','2013-10-13','17:20:00',1.53),('10318','2013-10-13','17:25:00',1.73),('10318','2013-10-13','17:30:00',1.23),('10318','2013-10-13','17:35:00',1.3),('10318','2013-10-13','17:40:00',1.05),('10318','2013-10-12','10:40:00',1.13),('10318','2013-10-12','10:45:00',1.24),('10318','2013-10-12','10:50:00',1.31),('10318','2013-10-12','10:55:00',1.47),('10318','2013-10-12','11:00:00',1.67),('10318','2013-10-12','11:05:00',1.73),('10318','2013-10-12','11:10:00',1.85),('10318','2013-10-12','11:15:00',2.11),('10318','2013-10-12','11:20:00',2.47),('10318','2013-10-12','11:25:00',2.65),('10318','2013-10-12','11:30:00',3.45),('10318','2013-10-12','11:35:00',5.72),('10318','2013-10-12','11:40:00',5.45),('10318','2013-10-12','11:45:00',3.21),('10318','2013-10-12','11:50:00',3.16),('10318','2013-10-12','11:55:00',2.45),('10318','2013-10-12','12:00:00',1.66),('10318','2013-10-12','12:05:00',1.49),('10318','2013-10-12','12:10:00',1.98),('10318','2013-10-12','12:15:00',2.72),('10318','2013-10-12','12:20:00',6.14),('10318','2013-10-12','12:25:00',6.68),('10318','2013-10-12','12:30:00',5.97),('10318','2013-10-12','12:35:00',6.81),('10318','2013-10-12','12:40:00',8.24),('10318','2013-10-12','12:45:00',6.77),('10318','2013-10-12','12:50:00',7.19),('10318','2013-10-12','12:55:00',5.78),('10318','2013-10-12','13:00:00',5.31),('10318','2013-10-12','13:05:00',1.72),('10318','2013-10-12','13:10:00',1.66),('10318','2013-10-12','13:15:00',2.7),('10318','2013-10-12','13:20:00',2.88),('10318','2013-10-12','13:25:00',4.38),('10318','2013-10-12','13:30:00',7.84),('10318','2013-10-12','13:35:00',2.07),('10318','2013-10-12','13:50:00',1.06),('10318','2013-10-12','13:55:00',1.71),('10318','2013-10-12','14:00:00',1.29),('10318','2013-10-12','15:05:00',1.22),('10318','2013-10-12','15:10:00',1.32),('10318','2013-10-12','15:15:00',1.49),('10318','2013-10-12','15:20:00',1.64),('10318','2013-10-12','15:25:00',1.82),('10318','2013-10-12','15:30:00',1.86),('10318','2013-10-12','15:35:00',1.71),('10318','2013-10-12','15:40:00',1.54),('10318','2013-10-12','15:45:00',1.52),('10318','2013-10-12','15:50:00',1.71),('10318','2013-10-12','15:55:00',2.1),('10318','2013-10-12','16:00:00',2.35),('10318','2013-10-12','16:05:00',2.3),('10318','2013-10-12','16:10:00',2.44),('10318','2013-10-12','16:15:00',3.43),('10318','2013-10-12','16:20:00',3.39),('10318','2013-10-12','16:25:00',2.76),('10318','2013-10-12','16:30:00',2.17),('10318','2013-10-12','16:35:00',1.24),('10318','2013-10-12','17:00:00',1.81),('10318','2013-10-12','17:05:00',1.04),('10318','2013-10-12','17:20:00',1.03),('10318','2013-10-12','17:25:00',1.36),('10318','2013-10-11','08:05:00',1.13),('10318','2013-10-11','08:10:00',1.48),('10318','2013-10-11','08:15:00',1.63),('10318','2013-10-11','08:20:00',1.82),('10318','2013-10-11','08:25:00',2.48),('10318','2013-10-11','08:30:00',2.93),('10318','2013-10-11','08:35:00',3.29),('10318','2013-10-11','08:40:00',3.47),('10318','2013-10-11','08:45:00',2.77),('10318','2013-10-11','08:50:00',2.72),('10318','2013-10-11','08:55:00',2.67),('10318','2013-10-11','09:00:00',4.28),('10318','2013-10-11','09:05:00',4.06),('10318','2013-10-11','09:10:00',4.37),('10318','2013-10-11','09:15:00',4.73),('10318','2013-10-11','09:20:00',5),('10318','2013-10-11','09:25:00',5.18),('10318','2013-10-11','09:30:00',5.47),('10318','2013-10-11','09:35:00',5.64),('10318','2013-10-11','09:40:00',5.81),('10318','2013-10-11','09:45:00',5.97),('10318','2013-10-11','09:50:00',6.1),('10318','2013-10-11','09:55:00',6.23),('10318','2013-10-11','10:00:00',6.43),('10318','2013-10-11','10:05:00',6.21),('10318','2013-10-11','10:10:00',5.57),('10318','2013-10-11','10:15:00',5.56),('10318','2013-10-11','10:20:00',5.43),('10318','2013-10-11','10:25:00',7.08),('10318','2013-10-11','10:30:00',6.48),('10318','2013-10-11','10:35:00',8.27),('10318','2013-10-11','10:40:00',9.44),('10318','2013-10-11','10:45:00',7.64),('10318','2013-10-11','10:50:00',1.9),('10318','2013-10-11','10:55:00',1.74),('10318','2013-10-11','11:00:00',2.63),('10318','2013-10-11','11:05:00',2.17),('10318','2013-10-11','11:10:00',2.58),('10318','2013-10-11','11:15:00',1.88),('10318','2013-10-11','11:20:00',2.05),('10318','2013-10-11','11:25:00',1.37),('10318','2013-10-11','11:30:00',1.17),('10318','2013-10-11','11:35:00',1.43),('10318','2013-10-11','11:40:00',4.25),('10318','2013-10-11','11:45:00',2.93),('10318','2013-10-11','11:50:00',3.07),('10318','2013-10-11','11:55:00',3.25),('10318','2013-10-11','12:00:00',3.24),('10318','2013-10-11','12:05:00',6.2),('10318','2013-10-11','12:10:00',5.72),('10318','2013-10-11','12:15:00',3.04),('10318','2013-10-11','12:20:00',5.52),('10318','2013-10-11','12:25:00',4.94),('10318','2013-10-11','12:30:00',3.88),('10318','2013-10-11','12:35:00',1.29),('10318','2013-10-11','13:05:00',1.11),('10318','2013-10-11','13:10:00',3),('10318','2013-10-11','13:15:00',3.95),('10318','2013-10-11','13:20:00',1.83),('10318','2013-10-11','13:25:00',2.27),('10318','2013-10-11','13:30:00',6.76),('10318','2013-10-11','13:35:00',2.37),('10318','2013-10-11','13:40:00',6.48),('10318','2013-10-11','13:45:00',9.23),('10318','2013-10-11','13:50:00',2.35),('10318','2013-10-11','13:55:00',1.31),('10318','2013-10-11','14:00:00',1.03),('10318','2013-10-11','14:05:00',1.13),('10318','2013-10-11','15:25:00',1.11),('10318','2013-10-11','15:30:00',4.62),('10318','2013-10-11','15:35:00',3.24),('10318','2013-10-11','15:40:00',4.3),('10318','2013-10-11','15:45:00',2.04),('10318','2013-10-11','15:50:00',1.56),('10318','2013-10-11','15:55:00',1.84),('10318','2013-10-11','16:00:00',1.52),('10318','2013-10-11','16:05:00',1.68),('10318','2013-10-11','16:10:00',1.61),('10318','2013-10-11','16:15:00',1.73),('10318','2013-10-11','16:20:00',1.18),('10318','2013-10-11','16:30:00',1.81),('10318','2013-10-11','16:35:00',1.91),('10318','2013-10-11','16:40:00',1.03),('10318','2013-10-11','17:00:00',1.2),('10318','2013-10-11','17:05:00',2.53),('10318','2013-10-11','17:10:00',1.56),('10318','2013-10-11','17:15:00',2.45),('10318','2013-10-11','17:20:00',1.3),('10318','2013-10-10','08:00:00',1.07),('10318','2013-10-10','08:05:00',1.23),('10318','2013-10-10','08:10:00',1.36),('10318','2013-10-10','08:15:00',1.59),('10318','2013-10-10','08:20:00',1.97),('10318','2013-10-10','08:25:00',2.85),('10318','2013-10-10','08:30:00',3.25),('10318','2013-10-10','08:35:00',3.37),('10318','2013-10-10','08:40:00',1.92),('10318','2013-10-10','08:45:00',1.05),('10318','2013-10-10','08:50:00',2.03),('10318','2013-10-10','08:55:00',3.12),('10318','2013-10-10','09:00:00',4.6),('10318','2013-10-10','09:05:00',4.05),('10318','2013-10-10','09:10:00',4.85),('10318','2013-10-10','09:15:00',4.68),('10318','2013-10-10','09:20:00',5.06),('10318','2013-10-10','09:25:00',5.3),('10318','2013-10-10','09:30:00',5.43),('10318','2013-10-10','09:35:00',5.57),('10318','2013-10-10','09:40:00',5.81),('10318','2013-10-10','09:45:00',5.94),('10318','2013-10-10','09:50:00',6.09),('10318','2013-10-10','09:55:00',6.28),('10318','2013-10-10','10:00:00',6.33),('10318','2013-10-10','10:05:00',6.44),('10318','2013-10-10','10:10:00',6.92),('10318','2013-10-10','10:15:00',6.87),('10318','2013-10-10','10:20:00',7.03),('10318','2013-10-10','10:25:00',5.54),('10318','2013-10-10','10:30:00',7.36),('10318','2013-10-10','10:35:00',7.53),('10318','2013-10-10','10:40:00',7.72),('10318','2013-10-10','10:45:00',8.07),('10318','2013-10-10','10:50:00',8.22),('10318','2013-10-10','10:55:00',8.46),('10318','2013-10-10','11:00:00',8.45),('10318','2013-10-10','11:05:00',8.56),('10318','2013-10-10','11:10:00',8.15),('10318','2013-10-10','11:15:00',8.08),('10318','2013-10-10','11:20:00',3.23),('10318','2013-10-10','11:25:00',4.83),('10318','2013-10-10','11:30:00',6.53),('10318','2013-10-10','11:35:00',9.1),('10318','2013-10-10','11:40:00',8.62),('10318','2013-10-10','11:45:00',8.21),('10318','2013-10-10','11:50:00',4.66),('10318','2013-10-10','11:55:00',9.29),('10318','2013-10-10','12:00:00',9.23),('10318','2013-10-10','12:05:00',3.9),('10318','2013-10-10','12:10:00',4.69),('10318','2013-10-10','12:15:00',6.24),('10318','2013-10-10','12:20:00',9.43),('10318','2013-10-10','12:25:00',9.74),('10318','2013-10-10','12:30:00',8.28),('10318','2013-10-10','12:35:00',6.89),('10318','2013-10-10','12:40:00',9.55),('10318','2013-10-10','12:45:00',7.74),('10318','2013-10-10','12:50:00',7.69),('10318','2013-10-10','12:55:00',5.7),('10318','2013-10-10','13:00:00',2.84),('10318','2013-10-10','13:05:00',5.8),('10318','2013-10-10','13:10:00',6.44),('10318','2013-10-10','13:15:00',2.21),('10318','2013-10-10','13:20:00',4.04),('10318','2013-10-10','13:25:00',2.6),('10318','2013-10-10','13:30:00',3.68),('10318','2013-10-10','13:35:00',2.54),('10318','2013-10-10','13:40:00',6.21),('10318','2013-10-10','13:45:00',5.8),('10318','2013-10-10','13:50:00',6.86),('10318','2013-10-10','13:55:00',5.25),('10318','2013-10-10','14:00:00',5.78),('10318','2013-10-10','14:05:00',5.8),('10318','2013-10-10','14:10:00',2.02),('10318','2013-10-10','14:15:00',2.82),('10318','2013-10-10','14:20:00',4.03),('10318','2013-10-10','14:25:00',3.92),('10318','2013-10-10','14:30:00',2.23),('10318','2013-10-10','14:35:00',7.29),('10318','2013-10-10','14:40:00',6.52),('10318','2013-10-10','14:45:00',5.25),('10318','2013-10-10','14:50:00',6.89),('10318','2013-10-10','14:55:00',5.85),('10318','2013-10-10','15:00:00',2.28),('10318','2013-10-10','15:05:00',2.03),('10318','2013-10-10','15:10:00',3.24),('10318','2013-10-10','15:15:00',4.17),('10318','2013-10-10','15:20:00',1.79),('10318','2013-10-10','15:25:00',1.88),('10318','2013-10-10','15:30:00',3.47),('10318','2013-10-10','15:35:00',1.93),('10318','2013-10-10','15:40:00',3.72),('10318','2013-10-10','15:45:00',5.48),('10318','2013-10-10','15:50:00',3.76),('10318','2013-10-10','15:55:00',2.55),('10318','2013-10-10','16:00:00',3.75),('10318','2013-10-10','16:05:00',5.44),('10318','2013-10-10','16:10:00',5.28),('10318','2013-10-10','16:15:00',3.78),('10318','2013-10-10','16:20:00',1.76),('10318','2013-10-10','16:25:00',2.38),('10318','2013-10-10','16:30:00',2.01),('10318','2013-10-10','16:35:00',3.01),('10318','2013-10-10','16:40:00',1.17),('10318','2013-10-10','16:45:00',1.28),('10318','2013-10-10','16:55:00',1.39),('10318','2013-10-10','17:00:00',1.92),('10318','2013-10-10','17:15:00',1.36),('10318','2013-10-10','17:20:00',1.18),('10318','2013-10-09','08:05:00',1.1),('10318','2013-10-09','08:10:00',1.41),('10318','2013-10-09','08:20:00',1.13),('10318','2013-10-09','08:25:00',3.11),('10318','2013-10-09','08:30:00',3.44),('10318','2013-10-09','08:35:00',3.2),('10318','2013-10-09','08:40:00',3.53),('10318','2013-10-09','08:45:00',3.55),('10318','2013-10-09','08:50:00',4.13),('10318','2013-10-09','08:55:00',4.34),('10318','2013-10-09','09:00:00',4.51),('10318','2013-10-09','09:05:00',4.76),('10318','2013-10-09','09:10:00',5),('10318','2013-10-09','09:15:00',4.1),('10318','2013-10-09','09:20:00',5.24),('10318','2013-10-09','09:25:00',5.44),('10318','2013-10-09','09:30:00',5.82),('10318','2013-10-09','09:35:00',6.07),('10318','2013-10-09','09:40:00',6.36),('10318','2013-10-09','09:45:00',6.46),('10318','2013-10-09','09:50:00',6.18),('10318','2013-10-09','09:55:00',6.45),('10318','2013-10-09','10:00:00',6.88),('10318','2013-10-09','10:05:00',5.07),('10318','2013-10-09','10:10:00',2.75),('10318','2013-10-09','10:15:00',2.23),('10318','2013-10-09','10:20:00',1.99),('10318','2013-10-09','10:25:00',2.19),('10318','2013-10-09','10:30:00',2.3),('10318','2013-10-09','10:35:00',1.99),('10318','2013-10-09','10:40:00',2.48),('10318','2013-10-09','10:45:00',4.23),('10318','2013-10-09','10:50:00',4.38),('10318','2013-10-09','10:55:00',8.4),('10318','2013-10-09','11:00:00',2.42),('10318','2013-10-09','11:05:00',1.99),('10318','2013-10-09','11:10:00',3.67),('10318','2013-10-09','11:15:00',6.44),('10318','2013-10-09','11:20:00',2.6),('10318','2013-10-09','11:25:00',4.3),('10318','2013-10-09','11:30:00',2.34),('10318','2013-10-09','11:35:00',2.01),('10318','2013-10-09','11:40:00',3.09),('10318','2013-10-09','11:45:00',3.94),('10318','2013-10-09','11:50:00',7.24),('10318','2013-10-09','11:55:00',9.24),('10318','2013-10-09','12:00:00',8.28),('10318','2013-10-09','12:05:00',6.86),('10318','2013-10-09','12:10:00',5.6),('10318','2013-10-09','12:15:00',5.53),('10318','2013-10-09','12:20:00',6.24),('10318','2013-10-09','12:25:00',5.1),('10318','2013-10-09','12:30:00',4.36),('10318','2013-10-09','12:35:00',4.11),('10318','2013-10-09','12:40:00',2.66),('10318','2013-10-09','12:45:00',1.64),('10318','2013-10-09','12:50:00',1.51),('10318','2013-10-09','12:55:00',1.31),('10318','2013-10-09','13:00:00',1.35),('10318','2013-10-09','13:05:00',1.41),('10318','2013-10-09','13:10:00',1.66),('10318','2013-10-09','13:15:00',5.59),('10318','2013-10-09','13:20:00',7.75),('10318','2013-10-09','13:25:00',3.42),('10318','2013-10-09','13:30:00',2.55),('10318','2013-10-09','13:35:00',3.91),('10318','2013-10-09','13:40:00',6.54),('10318','2013-10-09','13:45:00',6.64),('10318','2013-10-09','13:50:00',4.76),('10318','2013-10-09','13:55:00',3.43),('10318','2013-10-09','14:00:00',3),('10318','2013-10-09','14:05:00',7.27),('10318','2013-10-09','14:10:00',6.73),('10318','2013-10-09','14:15:00',5.03),('10318','2013-10-09','14:20:00',1.21),('10318','2013-10-09','14:25:00',1.4),('10318','2013-10-09','14:30:00',1.6),('10318','2013-10-09','14:35:00',1.59),('10318','2013-10-09','14:40:00',1.32),('10318','2013-10-09','14:45:00',1.73),('10318','2013-10-09','14:50:00',5.72),('10318','2013-10-09','14:55:00',6.65),('10318','2013-10-09','15:00:00',7.02),('10318','2013-10-09','15:05:00',6.48),('10318','2013-10-09','15:10:00',6.54),('10318','2013-10-09','15:15:00',6.41),('10318','2013-10-09','15:20:00',6.37),('10318','2013-10-09','15:25:00',6.07),('10318','2013-10-09','15:30:00',5.12),('10318','2013-10-09','15:35:00',2.51),('10318','2013-10-09','15:40:00',1.89),('10318','2013-10-09','15:45:00',4.29),('10318','2013-10-09','15:50:00',2.67),('10318','2013-10-09','15:55:00',2.83),('10318','2013-10-09','16:00:00',3.68),('10318','2013-10-09','16:05:00',2.08),('10318','2013-10-09','16:10:00',2.11),('10318','2013-10-09','16:15:00',3.24),('10318','2013-10-09','16:20:00',2.89),('10318','2013-10-09','16:25:00',2.13),('10318','2013-10-09','16:30:00',2.76),('10318','2013-10-09','16:35:00',2.47),('10318','2013-10-09','16:40:00',3.04),('10318','2013-10-09','16:45:00',2.5),('10318','2013-10-09','17:25:00',1.23),('10318','2013-10-09','17:30:00',1.63),('10318','2013-10-09','17:35:00',1.88),('10318','2013-10-09','17:40:00',1.37),('10318','2013-10-09','17:45:00',1.31),('10318','2014-04-15','07:55:00',1.63),('10318','2014-04-15','08:00:00',1.6),('10318','2014-04-15','08:05:00',1.14),('10318','2014-04-15','08:50:00',1.44),('10318','2014-04-15','08:55:00',3.36),('10318','2014-04-15','09:00:00',3.9),('10318','2014-04-15','09:05:00',6.31),('10318','2014-04-15','09:10:00',6.47),('10318','2014-04-15','09:15:00',5.59),('10318','2014-04-15','09:20:00',6.72),('10318','2014-04-15','09:25:00',6.63),('10318','2014-04-15','09:30:00',5.16),('10318','2014-04-15','09:35:00',2.31),('10318','2014-04-15','09:40:00',1.97),('10318','2014-04-15','09:45:00',3.05),('10318','2014-04-15','09:50:00',2.18),('10318','2014-04-15','09:55:00',1.74),('10318','2014-04-15','10:00:00',2.88),('10318','2014-04-15','10:05:00',4.02),('10318','2014-04-15','10:10:00',4),('10318','2014-04-15','10:15:00',5.9),('10318','2014-04-15','10:20:00',6.05),('10318','2014-04-15','10:25:00',4.16),('10318','2014-04-15','10:30:00',7.68),('10318','2014-04-15','10:35:00',4.26),('10318','2014-04-15','10:40:00',4.44),('10318','2014-04-15','10:45:00',8.49),('10318','2014-04-15','10:50:00',5.15),('10318','2014-04-15','10:55:00',3.36),('10318','2014-04-15','11:00:00',6.37),('10318','2014-04-15','11:05:00',6.48),('10318','2014-04-15','11:10:00',5.25),('10318','2014-04-15','11:15:00',3.86),('10318','2014-04-15','11:20:00',3.33),('10318','2014-04-15','11:25:00',4.61),('10318','2014-04-15','11:30:00',2.92),('10318','2014-04-15','11:35:00',2.36),('10318','2014-04-15','11:40:00',1.56),('10318','2014-04-15','11:45:00',2.23),('10318','2014-04-15','11:50:00',2.56),('10318','2014-04-15','11:55:00',2.03),('10318','2014-04-15','12:00:00',1.34),('10318','2014-04-15','12:05:00',2.42),('10318','2014-04-15','12:10:00',3.31),('10318','2014-04-15','12:15:00',4.4),('10318','2014-04-15','12:20:00',3.09),('10318','2014-04-15','12:25:00',1.88),('10318','2014-04-15','12:30:00',1.52),('10318','2014-04-15','12:35:00',1.62),('10318','2014-04-15','12:40:00',1.28),('10318','2014-04-15','13:05:00',1.23),('10318','2014-04-15','13:10:00',2.58),('10318','2014-04-15','13:15:00',4.46),('10318','2014-04-15','13:20:00',4.34),('10318','2014-04-15','13:25:00',2.97),('10318','2014-04-15','13:30:00',2.6),('10318','2014-04-15','13:35:00',5.96),('10318','2014-04-15','13:40:00',4.48),('10318','2014-04-15','13:45:00',2.5),('10318','2014-04-15','13:50:00',3.12),('10318','2014-04-15','13:55:00',3.83),('10318','2014-04-15','14:00:00',7),('10318','2014-04-15','14:05:00',5.9),('10318','2014-04-15','14:10:00',6.59),('10318','2014-04-15','14:15:00',6.01),('10318','2014-04-15','14:20:00',5.77),('10318','2014-04-15','14:25:00',3.85),('10318','2014-04-15','14:30:00',4.28),('10318','2014-04-15','14:35:00',7.01),('10318','2014-04-15','14:40:00',7.1),('10318','2014-04-15','14:45:00',7.67),('10318','2014-04-15','14:50:00',7.13),('10318','2014-04-15','14:55:00',7.34),('10318','2014-04-15','15:00:00',4.24),('10318','2014-04-15','15:05:00',4.95),('10318','2014-04-15','15:10:00',6.83),('10318','2014-04-15','15:15:00',8.66),('10318','2014-04-15','15:20:00',8.71),('10318','2014-04-15','15:25:00',4.96),('10318','2014-04-15','15:30:00',4.55),('10318','2014-04-15','15:35:00',3.84),('10318','2014-04-15','15:40:00',3.45),('10318','2014-04-15','15:45:00',3.56),('10318','2014-04-15','15:50:00',3.8),('10318','2014-04-15','15:55:00',3.23),('10318','2014-04-15','16:00:00',3.16),('10318','2014-04-15','16:05:00',2.7),('10318','2014-04-15','16:10:00',1.89),('10318','2014-04-15','16:15:00',1.49),('10318','2014-04-15','16:20:00',1.12),('10318','2013-10-08','08:00:00',1.25),('10318','2013-10-08','08:05:00',2.07),('10318','2013-10-08','08:10:00',2.62),('10318','2013-10-08','08:15:00',2.8),('10318','2013-10-08','08:20:00',2.66),('10318','2013-10-08','08:25:00',1.54),('10318','2013-10-08','08:30:00',1.53),('10318','2013-10-08','09:25:00',1.01),('10318','2013-10-08','09:45:00',1.1),('10318','2013-10-08','09:50:00',1.26),('10318','2013-10-08','09:55:00',2.04),('10318','2013-10-08','10:00:00',2.94),('10318','2013-10-08','10:05:00',2.52),('10318','2013-10-08','10:10:00',3.63),('10318','2013-10-08','10:15:00',3.71),('10318','2013-10-08','10:20:00',1.4),('10318','2013-10-08','10:25:00',1.05),('10318','2013-10-08','10:55:00',1.4),('10318','2013-10-08','11:00:00',1.81),('10318','2013-10-08','11:05:00',1.69),('10318','2013-10-08','11:10:00',1.7),('10318','2013-10-08','11:15:00',3.13),('10318','2013-10-08','11:20:00',8.11),('10318','2013-10-08','11:25:00',8.07),('10318','2013-10-08','11:30:00',4.41),('10318','2013-10-08','11:35:00',2.48),('10318','2013-10-08','11:40:00',2.81),('10318','2013-10-08','11:45:00',1.85),('10318','2013-10-08','11:50:00',1.03),('10318','2013-10-08','12:05:00',1.02),('10318','2013-10-08','12:10:00',1.6),('10318','2013-10-08','12:15:00',1.46),('10318','2013-10-08','12:20:00',2.94),('10318','2013-10-08','12:25:00',3.58),('10318','2013-10-08','12:30:00',5.27),('10318','2013-10-08','12:35:00',3.97),('10318','2013-10-08','12:40:00',3.62),('10318','2013-10-08','12:45:00',5.97),('10318','2013-10-08','12:50:00',8.35),('10318','2013-10-08','12:55:00',9.77),('10318','2013-10-08','13:00:00',7.83),('10318','2013-10-08','13:05:00',4.67),('10318','2013-10-08','13:10:00',4.68),('10318','2013-10-08','13:15:00',2.74),('10318','2013-10-08','13:20:00',2.7),('10318','2013-10-08','13:25:00',2.92),('10318','2013-10-08','13:30:00',6.59),('10318','2013-10-08','13:35:00',4.55),('10318','2013-10-08','13:40:00',2.97),('10318','2013-10-08','13:45:00',2.75),('10318','2013-10-08','13:50:00',2),('10318','2013-10-08','13:55:00',1.63),('10318','2013-10-08','14:00:00',1.51),('10318','2013-10-08','14:05:00',1.42),('10318','2013-10-08','14:10:00',1.75),('10318','2013-10-08','14:15:00',3.48),('10318','2013-10-08','14:20:00',5),('10318','2013-10-08','14:25:00',5.26),('10318','2013-10-08','14:30:00',4.75),('10318','2013-10-08','14:35:00',4.69),('10318','2013-10-08','14:40:00',4.11),('10318','2013-10-08','14:45:00',4.97),('10318','2013-10-08','14:50:00',7.03),('10318','2013-10-08','14:55:00',6.61),('10318','2013-10-08','15:00:00',6.41),('10318','2013-10-08','15:05:00',6.34),('10318','2013-10-08','15:10:00',4.37),('10318','2013-10-08','15:15:00',5.63),('10318','2013-10-08','15:20:00',5.31),('10318','2013-10-08','15:25:00',3.86),('10318','2013-10-08','15:30:00',4.94),('10318','2013-10-08','15:35:00',3.15),('10318','2013-10-08','15:40:00',2.25),('10318','2013-10-08','15:45:00',2.22),('10318','2013-10-08','15:50:00',3.44),('10318','2013-10-08','15:55:00',3.16),('10318','2013-10-08','16:00:00',2.22),('10318','2013-10-08','16:05:00',1.04),('10318','2013-10-08','16:30:00',1.09),('10318','2013-10-08','16:35:00',1.38),('10318','2013-10-08','16:40:00',1.22),('10318','2013-10-08','16:45:00',1.19),('10318','2013-10-08','16:50:00',1.16),('10318','2013-10-07','07:55:00',1.11),('10318','2013-10-07','08:00:00',1.29),('10318','2013-10-07','08:05:00',1.44),('10318','2013-10-07','08:10:00',1.58),('10318','2013-10-07','08:15:00',1.46),('10318','2013-10-07','08:20:00',2.17),('10318','2013-10-07','08:25:00',3.06),('10318','2013-10-07','08:30:00',3.5),('10318','2013-10-07','08:35:00',2.76),('10318','2013-10-07','08:45:00',1.29),('10318','2013-10-07','08:50:00',1.21),('10318','2013-10-07','08:55:00',2.83),('10318','2013-10-07','09:00:00',2.61),('10318','2013-10-07','09:05:00',5.7),('10318','2013-10-07','09:10:00',5.22),('10318','2013-10-07','09:15:00',5.13),('10318','2013-10-07','09:20:00',5.24),('10318','2013-10-07','09:25:00',5.43),('10318','2013-10-07','09:30:00',5.58),('10318','2013-10-07','09:35:00',5.75),('10318','2013-10-07','09:40:00',5.88),('10318','2013-10-07','09:45:00',5.99),('10318','2013-10-07','09:50:00',6.1),('10318','2013-10-07','09:55:00',6.26),('10318','2013-10-07','10:00:00',6.34),('10318','2013-10-07','10:05:00',6.48),('10318','2013-10-07','10:10:00',6.62),('10318','2013-10-07','10:15:00',6.74),('10318','2013-10-07','10:20:00',6.87),('10318','2013-10-07','10:25:00',7.01),('10318','2013-10-07','10:30:00',7.09),('10318','2013-10-07','10:35:00',3.73),('10318','2013-10-07','10:40:00',7.51),('10318','2013-10-07','10:45:00',7.52),('10318','2013-10-07','10:50:00',7.5),('10318','2013-10-07','10:55:00',7.49),('10318','2013-10-07','11:00:00',6.97),('10318','2013-10-07','11:05:00',5.25),('10318','2013-10-07','11:10:00',7.8),('10318','2013-10-07','11:15:00',7.89),('10318','2013-10-07','11:20:00',7.85),('10318','2013-10-07','11:25:00',7.78),('10318','2013-10-07','11:30:00',7.97),('10318','2013-10-07','11:35:00',8.06),('10318','2013-10-07','11:40:00',7.13),('10318','2013-10-07','11:45:00',8.18),('10318','2013-10-07','11:50:00',8.24),('10318','2013-10-07','11:55:00',8.24),('10318','2013-10-07','12:00:00',7.55),('10318','2013-10-07','12:05:00',5.18),('10318','2013-10-07','12:10:00',9.24),('10318','2013-10-07','12:15:00',8.43),('10318','2013-10-07','12:20:00',7.73),('10318','2013-10-07','12:25:00',5.75),('10318','2013-10-07','12:30:00',8.76),('10318','2013-10-07','12:35:00',8.8),('10318','2013-10-07','12:40:00',7.89),('10318','2013-10-07','12:45:00',8.91),('10318','2013-10-07','12:50:00',5.25),('10318','2013-10-07','12:55:00',8.31),('10318','2013-10-07','13:00:00',8.93),('10318','2013-10-07','13:05:00',2.8),('10318','2013-10-07','13:10:00',2.67),('10318','2013-10-07','13:15:00',3.28),('10318','2013-10-07','13:20:00',3.19),('10318','2013-10-07','13:25:00',2.76),('10318','2013-10-07','13:30:00',3.15),('10318','2013-10-07','13:35:00',2.14),('10318','2013-10-07','13:40:00',2.15),('10318','2013-10-07','13:45:00',2.32),('10318','2013-10-07','13:50:00',2.22),('10318','2013-10-07','13:55:00',4.46),('10318','2013-10-07','14:00:00',5.22),('10318','2013-10-07','14:05:00',9.61),('10318','2013-10-07','14:10:00',6.94),('10318','2013-10-07','14:15:00',6.71),('10318','2013-10-07','14:20:00',3.37),('10318','2013-10-07','14:25:00',8.28),('10318','2013-10-07','14:30:00',3.74),('10318','2013-10-07','14:35:00',6.4),('10318','2013-10-07','14:40:00',6.88),('10318','2013-10-07','14:45:00',7.23),('10318','2013-10-07','14:50:00',5.57),('10318','2013-10-07','14:55:00',6.32),('10318','2013-10-07','15:00:00',5.22),('10318','2013-10-07','15:05:00',5.85),('10318','2013-10-07','15:10:00',5.26),('10318','2013-10-07','15:15:00',6.18),('10318','2013-10-07','15:20:00',6.2),('10318','2013-10-07','15:25:00',6.09),('10318','2013-10-07','15:30:00',5.99),('10318','2013-10-07','15:35:00',5.51),('10318','2013-10-07','15:40:00',2.93),('10318','2013-10-07','15:45:00',1.41),('10318','2013-10-07','15:50:00',4.23),('10318','2013-10-07','15:55:00',4.1),('10318','2013-10-07','16:00:00',3.04),('10318','2013-10-07','16:05:00',4.32),('10318','2013-10-07','16:10:00',4.14),('10318','2013-10-07','16:15:00',4.11),('10318','2013-10-07','16:20:00',2.32),('10318','2013-10-07','16:25:00',4),('10318','2013-10-07','16:30:00',3.85),('10318','2013-10-07','16:35:00',3.81),('10318','2013-10-07','16:40:00',3.62),('10318','2013-10-07','16:45:00',2.13),('10318','2013-10-07','16:50:00',2.95),('10318','2013-10-07','16:55:00',2.73),('10318','2013-10-07','17:00:00',2.47),('10318','2013-10-07','17:05:00',2.26),('10318','2013-10-07','17:10:00',2.08),('10318','2013-10-07','17:15:00',1.77),('10318','2013-10-07','17:20:00',1.71),('10318','2013-10-07','17:25:00',1.59),('10318','2013-10-07','17:30:00',1.42),('10318','2013-10-07','17:35:00',1.24),('10318','2013-10-07','17:40:00',1.08),('10318','2013-10-06','08:45:00',1.03),('10318','2013-10-06','08:50:00',1.36),('10318','2013-10-06','08:55:00',1.61),('10318','2013-10-06','09:00:00',1.8),('10318','2013-10-06','09:05:00',3.76),('10318','2013-10-06','09:10:00',2.51),('10318','2013-10-06','09:15:00',1.34),('10318','2013-10-06','09:20:00',1.5),('10318','2013-10-06','09:25:00',2.27),('10318','2013-10-06','09:30:00',4.12),('10318','2013-10-06','09:35:00',5.13),('10318','2013-10-06','09:40:00',4.57),('10318','2013-10-06','09:45:00',3.81),('10318','2013-10-06','09:50:00',5.87),('10318','2013-10-06','09:55:00',6.24),('10318','2013-10-06','10:00:00',7.27),('10318','2013-10-06','10:05:00',6.42),('10318','2013-10-06','10:10:00',5.02),('10318','2013-10-06','10:15:00',6.18),('10318','2013-10-06','10:20:00',6.49),('10318','2013-10-06','10:25:00',7.26),('10318','2013-10-06','10:30:00',6.88),('10318','2013-10-06','10:35:00',6.4),('10318','2013-10-06','10:40:00',3.5),('10318','2013-10-06','10:45:00',3.66),('10318','2013-10-06','10:50:00',5.22),('10318','2013-10-06','10:55:00',5.58),('10318','2013-10-06','11:00:00',6.68),('10318','2013-10-06','11:05:00',6.52),('10318','2013-10-06','11:10:00',7.16),('10318','2013-10-06','11:15:00',6.97),('10318','2013-10-06','11:20:00',7.04),('10318','2013-10-06','11:25:00',6.83),('10318','2013-10-06','11:30:00',6.87),('10318','2013-10-06','11:35:00',6.24),('10318','2013-10-06','11:40:00',3.88),('10318','2013-10-06','11:45:00',3.68),('10318','2013-10-06','11:50:00',5.67),('10318','2013-10-06','11:55:00',6.69),('10318','2013-10-06','12:00:00',6.56),('10318','2013-10-06','12:05:00',4.69),('10318','2013-10-06','12:10:00',8.34),('10318','2013-10-06','12:15:00',6.57),('10318','2013-10-06','12:20:00',3.91),('10318','2013-10-06','12:25:00',3.4),('10318','2013-10-06','12:30:00',6.51),('10318','2013-10-06','12:35:00',6.71),('10318','2013-10-06','12:40:00',6.76),('10318','2013-10-06','12:45:00',6.86),('10318','2013-10-06','12:50:00',7.48),('10318','2013-10-06','12:55:00',7.6),('10318','2013-10-06','13:00:00',7.58),('10318','2013-10-06','13:05:00',7.81),('10318','2013-10-06','13:10:00',6.8),('10318','2013-10-06','13:15:00',4.28),('10318','2013-10-06','13:20:00',3.27),('10318','2013-10-06','13:25:00',5.56),('10318','2013-10-06','13:30:00',2.06),('10318','2013-10-06','13:35:00',1.64),('10318','2013-10-06','13:40:00',2.01),('10318','2013-10-06','13:45:00',6.58),('10318','2013-10-06','13:50:00',8),('10318','2013-10-06','13:55:00',6.92),('10318','2013-10-06','14:00:00',7.37),('10318','2013-10-06','14:05:00',6.44),('10318','2013-10-06','14:10:00',5.1),('10318','2013-10-06','14:15:00',4.85),('10318','2013-10-06','14:20:00',4.01),('10318','2013-10-06','14:25:00',4.41),('10318','2013-10-06','14:30:00',5.16),('10318','2013-10-06','14:35:00',4.51),('10318','2013-10-06','14:40:00',5.24),('10318','2013-10-06','14:45:00',4.44),('10318','2013-10-06','14:50:00',4.33),('10318','2013-10-06','14:55:00',4.42),('10318','2013-10-06','15:00:00',4.18),('10318','2013-10-06','15:05:00',4.19),('10318','2013-10-06','15:10:00',2.91),('10318','2013-10-06','15:15:00',2.56),('10318','2013-10-06','15:20:00',2.18),('10318','2013-10-06','15:25:00',1.87),('10318','2013-10-06','15:30:00',1.84),('10318','2013-10-06','15:35:00',1.73),('10318','2013-10-06','15:40:00',1.6),('10318','2013-10-06','15:45:00',1.52),('10318','2013-10-06','15:50:00',1.4),('10318','2013-10-06','15:55:00',1.45),('10318','2013-10-06','16:00:00',1.63),('10318','2013-10-06','16:05:00',1.44),('10318','2013-10-06','16:10:00',1.19),('10318','2013-10-06','16:15:00',1.04),('10318','2013-10-06','16:20:00',1.06),('10318','2013-10-06','17:00:00',1.01),('10318','2013-10-06','17:05:00',1.12),('10318','2013-10-06','17:10:00',1.32),('10318','2013-10-06','17:15:00',1.58),('10318','2013-10-06','17:20:00',1.82),('10318','2013-10-06','17:25:00',1.37),('10318','2013-10-06','17:30:00',1.09),('10318','2013-10-06','17:35:00',1.01),('10318','2013-10-05','08:35:00',1.24),('10318','2013-10-05','08:40:00',1.18),('10318','2013-10-05','08:45:00',1.06),('10318','2013-10-05','08:50:00',1.14),('10318','2013-10-05','14:20:00',1.02),('10318','2013-10-05','14:25:00',1.07),('10318','2013-10-05','14:35:00',1.11),('10318','2013-10-05','14:40:00',1.36),('10318','2013-10-05','14:45:00',1.46),('10318','2013-10-05','14:50:00',1.28),('10318','2013-10-05','14:55:00',1.2),('10318','2013-10-05','15:00:00',1.3),('10318','2013-10-05','15:05:00',1.27),('10318','2013-10-05','15:10:00',1.23),('10318','2013-10-05','15:15:00',1.24),('10318','2013-10-05','15:20:00',1.3),('10318','2013-10-05','15:25:00',1.34),('10318','2013-10-05','15:30:00',1.36),('10318','2013-10-05','15:35:00',1.56),('10318','2013-10-05','15:40:00',1.71),('10318','2013-10-05','15:45:00',1.75),('10318','2013-10-05','15:50:00',1.84),('10318','2013-10-05','15:55:00',2.04),('10318','2013-10-05','16:00:00',2.35),('10318','2013-10-05','16:05:00',2.78),('10318','2013-10-05','16:10:00',2.5),('10318','2013-10-05','16:15:00',2.39),('10318','2013-10-05','16:20:00',2.41),('10318','2013-10-05','16:25:00',2.15),('10318','2013-10-05','16:30:00',1.95),('10318','2013-10-05','16:35:00',1.96),('10318','2013-10-05','16:40:00',2.04),('10318','2013-10-05','16:45:00',2.01),('10318','2013-10-05','16:50:00',1.97),('10318','2013-10-05','16:55:00',1.83),('10318','2013-10-05','17:00:00',1.87),('10318','2013-10-05','17:05:00',1.54),('10318','2013-10-05','17:10:00',1.5),('10318','2013-10-05','17:15:00',1.55),('10318','2013-10-05','17:20:00',1.19),('10318','2013-10-05','17:25:00',1),('10318','2013-10-04','08:15:00',1.17),('10318','2013-10-04','08:20:00',1.03),('10318','2013-10-04','08:25:00',1.1),('10318','2013-10-04','08:30:00',1.49),('10318','2013-10-04','08:35:00',1.43),('10318','2013-10-04','08:40:00',1.77),('10318','2013-10-04','08:45:00',1.93),('10318','2013-10-04','08:50:00',1.49),('10318','2013-10-04','08:55:00',1.7),('10318','2013-10-04','09:00:00',1.47),('10318','2013-10-04','09:05:00',1.6),('10318','2013-10-04','09:10:00',1.87),('10318','2013-10-04','09:15:00',1.61),('10318','2013-10-04','09:20:00',1.96),('10318','2013-10-04','09:25:00',2.51),('10318','2013-10-04','09:30:00',2.55),('10318','2013-10-04','09:35:00',2.7),('10318','2013-10-04','09:40:00',2.59),('10318','2013-10-04','09:45:00',2.9),('10318','2013-10-04','09:50:00',4.23),('10318','2013-10-04','09:55:00',5.48),('10318','2013-10-04','10:00:00',4.1),('10318','2013-10-04','10:05:00',3.35),('10318','2013-10-04','10:10:00',3.64),('10318','2013-10-04','10:15:00',3.89),('10318','2013-10-04','10:20:00',4.27),('10318','2013-10-04','10:25:00',4.91),('10318','2013-10-04','10:30:00',6.76),('10318','2013-10-04','10:35:00',5.28),('10318','2013-10-04','10:40:00',7.66),('10318','2013-10-04','10:45:00',8.64),('10318','2013-10-04','10:50:00',4.76),('10318','2013-10-04','10:55:00',5.66),('10318','2013-10-04','11:00:00',4.16),('10318','2013-10-04','11:05:00',3.81),('10318','2013-10-04','11:10:00',5.21),('10318','2013-10-04','11:15:00',6.18),('10318','2013-10-04','11:20:00',6.63),('10318','2013-10-04','11:25:00',7.59),('10318','2013-10-04','11:30:00',7.2),('10318','2013-10-04','11:35:00',7.56),('10318','2013-10-04','11:40:00',8.79),('10318','2013-10-04','11:45:00',8.38),('10318','2013-10-04','11:50:00',8.26),('10318','2013-10-04','11:55:00',8.29),('10318','2013-10-04','12:00:00',8.17),('10318','2013-10-04','12:05:00',8.34),('10318','2013-10-04','12:10:00',8.25),('10318','2013-10-04','12:15:00',7.74),('10318','2013-10-04','12:20:00',8.55),('10318','2013-10-04','12:25:00',8.5),('10318','2013-10-04','12:30:00',8.63),('10318','2013-10-04','12:35:00',8.31),('10318','2013-10-04','12:40:00',8.04),('10318','2013-10-04','12:45:00',8.08),('10318','2013-10-04','12:50:00',7.86),('10318','2013-10-04','12:55:00',7.94),('10318','2013-10-04','13:00:00',8.05),('10318','2013-10-04','13:05:00',8.05),('10318','2013-10-04','13:10:00',8.2),('10318','2013-10-04','13:15:00',8.32),('10318','2013-10-04','13:20:00',7.92),('10318','2013-10-04','13:25:00',7.74),('10318','2013-10-04','13:30:00',8.25),('10318','2013-10-04','13:35:00',7.94),('10318','2013-10-04','13:40:00',7.71),('10318','2013-10-04','13:45:00',7.48),('10318','2013-10-04','13:50:00',7.49),('10318','2013-10-04','13:55:00',7.4),('10318','2013-10-04','14:00:00',7.39),('10318','2013-10-04','14:05:00',7.11),('10318','2013-10-04','14:10:00',6.16),('10318','2013-10-04','14:15:00',5.59),('10318','2013-10-04','14:20:00',7.07),('10318','2013-10-04','14:25:00',6.54),('10318','2013-10-04','14:30:00',5.66),('10318','2013-10-04','14:35:00',3.76),('10318','2013-10-04','14:40:00',3.61),('10318','2013-10-04','14:45:00',4.61),('10318','2013-10-04','14:50:00',5.72),('10318','2013-10-04','14:55:00',4.74),('10318','2013-10-04','15:00:00',4.68),('10318','2013-10-04','15:05:00',4.88),('10318','2013-10-04','15:10:00',3.88),('10318','2013-10-04','15:15:00',3.4),('10318','2013-10-04','15:20:00',3.39),('10318','2013-10-04','15:25:00',5.41),('10318','2013-10-04','15:30:00',3.34),('10318','2013-10-04','15:35:00',2.45),('10318','2013-10-04','15:40:00',1.92),('10318','2013-10-04','15:45:00',1.72),('10318','2013-10-04','15:50:00',1.7),('10318','2013-10-04','15:55:00',2),('10318','2013-10-04','16:00:00',2.41),('10318','2013-10-04','16:05:00',2.57),('10318','2013-10-04','16:10:00',2.16),('10318','2013-10-04','16:15:00',1.91),('10318','2013-10-04','16:20:00',1.59),('10318','2013-10-04','16:25:00',1.39),('10318','2013-10-04','16:30:00',1.34),('10318','2013-10-04','16:35:00',1.36),('10318','2013-10-04','16:40:00',1.26),('10318','2013-10-04','16:45:00',1.24),('10318','2013-10-04','16:50:00',1.28),('10318','2013-10-04','16:55:00',1.14),('10318','2013-10-04','17:00:00',1.12),('10318','2013-10-04','17:05:00',1.11),('10318','2013-10-03','07:55:00',1.07),('10318','2013-10-03','08:00:00',1.27),('10318','2013-10-03','08:05:00',1.45),('10318','2013-10-03','08:10:00',1.27),('10318','2013-10-03','08:15:00',2.55),('10318','2013-10-03','08:20:00',3.11),('10318','2013-10-03','08:25:00',3.42),('10318','2013-10-03','08:30:00',3.66),('10318','2013-10-03','08:35:00',3.89),('10318','2013-10-03','08:40:00',4.11),('10318','2013-10-03','08:45:00',4.32),('10318','2013-10-03','08:50:00',4.54),('10318','2013-10-03','08:55:00',4.64),('10318','2013-10-03','09:00:00',4.96),('10318','2013-10-03','09:05:00',5.15),('10318','2013-10-03','09:10:00',5.34),('10318','2013-10-03','09:15:00',5.54),('10318','2013-10-03','09:20:00',5.75),('10318','2013-10-03','09:25:00',5.9),('10318','2013-10-03','09:30:00',6.08),('10318','2013-10-03','09:35:00',6.25),('10318','2013-10-03','09:40:00',6.42),('10318','2013-10-03','09:45:00',6.57),('10318','2013-10-03','09:50:00',6.72),('10318','2013-10-03','09:55:00',6.87),('10318','2013-10-03','10:00:00',7),('10318','2013-10-03','10:05:00',7.16),('10318','2013-10-03','10:10:00',7.3),('10318','2013-10-03','10:15:00',7.46),('10318','2013-10-03','10:20:00',7.59),('10318','2013-10-03','10:25:00',7.69),('10318','2013-10-03','10:30:00',7.8),('10318','2013-10-03','10:35:00',7.84),('10318','2013-10-03','10:40:00',7.94),('10318','2013-10-03','10:45:00',7.84),('10318','2013-10-03','10:50:00',8.11),('10318','2013-10-03','10:55:00',8.2),('10318','2013-10-03','11:00:00',8.27),('10318','2013-10-03','11:05:00',8.34),('10318','2013-10-03','11:10:00',8.4),('10318','2013-10-03','11:15:00',8.43),('10318','2013-10-03','11:20:00',8.48),('10318','2013-10-03','11:25:00',8.56),('10318','2013-10-03','11:30:00',8.61),('10318','2013-10-03','11:35:00',8.66),('10318','2013-10-03','11:40:00',8.73),('10318','2013-10-03','11:45:00',8.75),('10318','2013-10-03','11:50:00',8.77),('10318','2013-10-03','11:55:00',8.78),('10318','2013-10-03','12:00:00',8.81),('10318','2013-10-03','12:05:00',8.76),('10318','2013-10-03','12:10:00',8.8),('10318','2013-10-03','12:15:00',8.87),('10318','2013-10-03','12:20:00',8.92),('10318','2013-10-03','12:25:00',8.85),('10318','2013-10-03','12:30:00',8.65),('10318','2013-10-03','12:35:00',8.9),('10318','2013-10-03','12:40:00',8.87),('10318','2013-10-03','12:45:00',8.88),('10318','2013-10-03','12:50:00',8.86),('10318','2013-10-03','12:55:00',8.79),('10318','2013-10-03','13:00:00',8.73),('10318','2013-10-03','13:05:00',8.63),('10318','2013-10-03','13:10:00',8.68),('10318','2013-10-03','13:15:00',8.59),('10318','2013-10-03','13:20:00',8.52),('10318','2013-10-03','13:25:00',8.39),('10318','2013-10-03','13:30:00',8.42),('10318','2013-10-03','13:35:00',8.37),('10318','2013-10-03','13:40:00',8.3),('10318','2013-10-03','13:45:00',8.23),('10318','2013-10-03','13:50:00',8.14),('10318','2013-10-03','13:55:00',8.03),('10318','2013-10-03','14:00:00',8),('10318','2013-10-03','14:05:00',7.96),('10318','2013-10-03','14:10:00',7.83),('10318','2013-10-03','14:15:00',7.68),('10318','2013-10-03','14:20:00',7.65),('10318','2013-10-03','14:25:00',7.54),('10318','2013-10-03','14:30:00',7.42),('10318','2013-10-03','14:35:00',7.28),('10318','2013-10-03','14:40:00',7.13),('10318','2013-10-03','14:45:00',7.02),('10318','2013-10-03','14:50:00',6.91),('10318','2013-10-03','14:55:00',6.75),('10318','2013-10-03','15:00:00',6.59),('10318','2013-10-03','15:05:00',6.46),('10318','2013-10-03','15:10:00',6.31),('10318','2013-10-03','15:15:00',6.14),('10318','2013-10-03','15:20:00',6.01),('10318','2013-10-03','15:25:00',5.88),('10318','2013-10-03','15:30:00',5.62),('10318','2013-10-03','15:35:00',5.59),('10318','2013-10-03','15:40:00',5.39),('10318','2013-10-03','15:45:00',5.22),('10318','2013-10-03','15:50:00',5.06),('10318','2013-10-03','15:55:00',4.89),('10318','2013-10-03','16:00:00',4.71),('10318','2013-10-03','16:05:00',4.54),('10318','2013-10-03','16:10:00',4.36),('10318','2013-10-03','16:15:00',4.17),('10318','2013-10-03','16:20:00',3.99),('10318','2013-10-03','16:25:00',3.8),('10318','2013-10-03','16:30:00',3.62),('10318','2013-10-03','16:35:00',3.45),('10318','2013-10-03','16:40:00',3.28),('10318','2013-10-03','16:45:00',3.11),('10318','2013-10-03','16:50:00',2.93),('10318','2013-10-03','16:55:00',2.77),('10318','2013-10-03','17:00:00',2.61),('10318','2013-10-03','17:05:00',2.45),('10318','2013-10-03','17:10:00',2.27),('10318','2013-10-03','17:15:00',2.08),('10318','2013-10-03','17:20:00',1.95),('10318','2013-10-03','17:25:00',1.79),('10318','2013-10-03','17:30:00',1.61),('10318','2013-10-03','17:35:00',1.46),('10318','2013-10-03','17:40:00',1.3),('10318','2013-10-03','17:45:00',1.14),('10318','2013-10-02','08:15:00',1.07),('10318','2013-10-02','08:20:00',1.32),('10318','2013-10-02','08:25:00',1.31),('10318','2013-10-02','08:30:00',2.95),('10318','2013-10-02','08:35:00',3.7),('10318','2013-10-02','08:40:00',3.71),('10318','2013-10-02','08:45:00',4.05),('10318','2013-10-02','08:50:00',4.33),('10318','2013-10-02','08:55:00',4.5),('10318','2013-10-02','09:00:00',4.72),('10318','2013-10-02','09:05:00',4.9),('10318','2013-10-02','09:10:00',5.12),('10318','2013-10-02','09:15:00',5.27),('10318','2013-10-02','09:20:00',5.48),('10318','2013-10-02','09:25:00',5.63),('10318','2013-10-02','09:30:00',5.82),('10318','2013-10-02','09:35:00',5.95),('10318','2013-10-02','09:40:00',6.12),('10318','2013-10-02','09:45:00',6.25),('10318','2013-10-02','09:50:00',6.42),('10318','2013-10-02','09:55:00',6.53),('10318','2013-10-02','10:00:00',6.66),('10318','2013-10-02','10:05:00',6.76),('10318','2013-10-02','10:10:00',6.91),('10318','2013-10-02','10:15:00',6.82),('10318','2013-10-02','10:20:00',7.15),('10318','2013-10-02','10:25:00',7.25),('10318','2013-10-02','10:30:00',7.41),('10318','2013-10-02','10:35:00',7.5),('10318','2013-10-02','10:40:00',7.6),('10318','2013-10-02','10:45:00',7.65),('10318','2013-10-02','10:50:00',7.75),('10318','2013-10-02','10:55:00',7.83),('10318','2013-10-02','11:00:00',7.94),('10318','2013-10-02','11:05:00',7.99),('10318','2013-10-02','11:10:00',8.05),('10318','2013-10-02','11:15:00',8.06),('10318','2013-10-02','11:20:00',8.14),('10318','2013-10-02','11:25:00',8.22),('10318','2013-10-02','11:30:00',8.25),('10318','2013-10-02','11:35:00',8.27),('10318','2013-10-02','11:40:00',8.33),('10318','2013-10-02','11:45:00',8.36),('10318','2013-10-02','11:51:00',8.4),('10318','2013-10-02','11:55:00',8.46),('10318','2013-10-02','12:00:00',8.23),('10318','2013-10-02','12:05:00',8.52),('10318','2013-10-02','12:10:00',8.55),('10318','2013-10-02','12:15:00',8.53),('10318','2013-10-02','12:20:00',8.53),('10318','2013-10-02','12:25:00',8.54),('10318','2013-10-02','12:30:00',8.51),('10318','2013-10-02','12:35:00',8.47),('10318','2013-10-02','12:40:00',8.47),('10318','2013-10-02','12:45:00',8.48),('10318','2013-10-02','12:50:00',8.47),('10318','2013-10-02','12:55:00',8.46),('10318','2013-10-02','13:00:00',8.44),('10318','2013-10-02','13:05:00',8.36),('10318','2013-10-02','13:10:00',8.34),('10318','2013-10-02','13:15:00',8.25),('10318','2013-10-02','13:20:00',8.2),('10318','2013-10-02','13:25:00',8.16),('10318','2013-10-02','13:30:00',8.1),('10318','2013-10-02','13:35:00',8.06),('10318','2013-10-02','13:40:00',8.02),('10318','2013-10-02','13:45:00',7.77),('10318','2013-10-02','13:50:00',7.84),('10318','2013-10-02','13:55:00',7.8),('10318','2013-10-02','14:00:00',7.7),('10318','2013-10-02','14:05:00',7.59),('10318','2013-10-02','14:10:00',7.54),('10318','2013-10-02','14:15:00',7.4),('10318','2013-10-02','14:20:00',7.27),('10318','2013-10-02','14:25:00',7.18),('10318','2013-10-02','14:30:00',7.08),('10318','2013-10-02','14:35:00',6.99),('10318','2013-10-02','14:40:00',6.89),('10318','2013-10-02','14:45:00',6.8),('10318','2013-10-02','14:50:00',6.66),('10318','2013-10-02','14:55:00',6.58),('10318','2013-10-02','15:00:00',6.33),('10318','2013-10-02','15:05:00',6.32),('10318','2013-10-02','15:10:00',6.12),('10318','2013-10-02','15:15:00',6.03),('10318','2013-10-02','15:20:00',5.86),('10318','2013-10-02','15:25:00',5.72),('10318','2013-10-02','15:30:00',5.54),('10318','2013-10-02','15:35:00',5.38),('10318','2013-10-02','15:40:00',5.24),('10318','2013-10-02','15:45:00',5.11),('10318','2013-10-02','15:50:00',4.97),('10318','2013-10-02','15:55:00',4.81),('10318','2013-10-02','16:00:00',4.61),('10318','2013-10-02','16:05:00',4.42),('10318','2013-10-02','16:10:00',4.25),('10318','2013-10-02','16:15:00',4.07),('10318','2013-10-02','16:20:00',3.88),('10318','2013-10-02','16:25:00',3.72),('10318','2013-10-02','16:30:00',3.54),('10318','2013-10-02','16:35:00',3.37),('10318','2013-10-02','16:40:00',3.2),('10318','2013-10-02','16:45:00',2.96),('10318','2013-10-02','16:50:00',2.86),('10318','2013-10-02','16:55:00',2.68),('10318','2013-10-02','17:00:00',2.51),('10318','2013-10-02','17:05:00',2.36),('10318','2013-10-02','17:10:00',2.2),('10318','2013-10-02','17:15:00',1.99),('10318','2013-10-02','17:20:00',1.8),('10318','2013-10-02','17:25:00',1.57),('10318','2013-10-02','17:30:00',1.52),('10318','2013-10-02','17:35:00',1.38),('10318','2013-10-02','17:40:00',1.12),('10318','2013-10-01','08:00:00',1.38),('10318','2013-10-01','08:05:00',1.56),('10318','2013-10-01','08:10:00',1.35),('10318','2013-10-01','08:15:00',1.47),('10318','2013-10-01','08:20:00',2.96),('10318','2013-10-01','08:25:00',2.9),('10318','2013-10-01','08:30:00',3.36),('10318','2013-10-01','08:35:00',3.62),('10318','2013-10-01','08:40:00',3.89),('10318','2013-10-01','08:45:00',4.06),('10318','2013-10-01','08:50:00',4.32),('10318','2013-10-01','08:55:00',4.49),('10318','2013-10-01','09:00:00',4.71),('10318','2013-10-01','09:05:00',4.84),('10318','2013-10-01','09:10:00',5.06),('10318','2013-10-01','09:15:00',5.2),('10318','2013-10-01','09:20:00',5.32),('10318','2013-10-01','09:25:00',5.46),('10318','2013-10-01','09:30:00',5.5),('10318','2013-10-01','09:35:00',5.79),('10318','2013-10-01','09:40:00',5.93),('10318','2013-10-01','09:45:00',6.1),('10318','2013-10-01','09:50:00',6.24),('10318','2013-10-01','09:55:00',6.36),('10318','2013-10-01','10:00:00',6.42),('10318','2013-10-01','10:05:00',6.55),('10318','2013-10-01','10:10:00',6.66),('10318','2013-10-01','10:15:00',6.76),('10318','2013-10-01','10:20:00',6.9),('10318','2013-10-01','10:25:00',7.11),('10318','2013-10-01','10:30:00',7.28),('10318','2013-10-01','10:35:00',5.99),('10318','2013-10-01','10:40:00',7.65),('10318','2013-10-01','10:45:00',7.85),('10318','2013-10-01','10:50:00',8.02),('10318','2013-10-01','10:55:00',7.81),('10318','2013-10-01','11:00:00',8.01),('10318','2013-10-01','11:05:00',5.39),('10318','2013-10-01','11:10:00',3.75),('10318','2013-10-01','11:15:00',6.6),('10318','2013-10-01','11:20:00',8.23),('10318','2013-10-01','11:25:00',8.24),('10318','2013-10-01','11:30:00',7.51),('10318','2013-10-01','11:35:00',4.76),('10318','2013-10-01','11:40:00',6.94),('10318','2013-10-01','11:45:00',8.4),('10318','2013-10-01','11:50:00',8.46),('10318','2013-10-01','11:55:00',8.56),('10318','2013-10-01','12:00:00',7.77),('10318','2013-10-01','12:05:00',8.68),('10318','2013-10-01','12:10:00',7.92),('10318','2013-10-01','12:15:00',7),('10318','2013-10-01','12:20:00',9.13),('10318','2013-10-01','12:25:00',3.26),('10318','2013-10-01','12:30:00',7.16),('10318','2013-10-01','12:35:00',9.3),('10318','2013-10-01','12:40:00',2.7),('10318','2013-10-01','12:45:00',7.37),('10318','2013-10-01','12:50:00',2.08),('10318','2013-10-01','12:55:00',2.89),('10318','2013-10-01','13:00:00',8.77),('10318','2013-10-01','13:05:00',8.86),('10318','2013-10-01','13:10:00',8.99),('10318','2013-10-01','13:15:00',9.03),('10318','2013-10-01','13:20:00',5.7),('10318','2013-10-01','13:25:00',9.07),('10318','2013-10-01','13:30:00',8.95),('10318','2013-10-01','13:35:00',8.78),('10318','2013-10-01','13:40:00',8.28),('10318','2013-10-01','13:45:00',7.95),('10318','2013-10-01','13:50:00',7.76),('10318','2013-10-01','13:55:00',7.64),('10318','2013-10-01','14:00:00',7.44),('10318','2013-10-01','14:05:00',7.41),('10318','2013-10-01','14:10:00',7.51),('10318','2013-10-01','14:15:00',7.51),('10318','2013-10-01','14:20:00',7.14),('10318','2013-10-01','14:25:00',7.12),('10318','2013-10-01','14:30:00',7.03),('10318','2013-10-01','14:35:00',7.07),('10318','2013-10-01','14:40:00',7.06),('10318','2013-10-01','14:45:00',7.28),('10318','2013-10-01','14:50:00',7.31),('10318','2013-10-01','14:55:00',6.95),('10318','2013-10-01','15:00:00',6.53),('10318','2013-10-01','15:05:00',6.31),('10318','2013-10-01','15:10:00',6.12),('10318','2013-10-01','15:15:00',6.02),('10318','2013-10-01','15:20:00',5.88),('10318','2013-10-01','15:25:00',5.72),('10318','2013-10-01','15:30:00',5.52),('10318','2013-10-01','15:35:00',5.37),('10318','2013-10-01','15:40:00',5.22),('10318','2013-10-01','15:45:00',5.05),('10318','2013-10-01','15:50:00',4.89),('10318','2013-10-01','15:55:00',4.71),('10318','2013-10-01','16:00:00',4.53),('10318','2013-10-01','16:05:00',4.29),('10318','2013-10-01','16:10:00',4.23),('10318','2013-10-01','16:15:00',4.09),('10318','2013-10-01','16:20:00',3.9),('10318','2013-10-01','16:25:00',3.74),('10318','2013-10-01','16:30:00',3.55),('10318','2013-10-01','16:35:00',3.37),('10318','2013-10-01','16:40:00',3.2),('10318','2013-10-01','16:45:00',3.04),('10318','2013-09-29','08:20:00',1.09),('10318','2013-09-29','08:25:00',1.12),('10318','2013-09-29','08:30:00',1.16),('10318','2013-09-29','08:35:00',1.46),('10318','2013-09-29','08:40:00',2.13),('10318','2013-09-29','08:45:00',2.45),('10318','2013-09-29','08:50:00',2.81),('10318','2013-09-29','08:55:00',2.6),('10318','2013-09-29','09:00:00',2.18),('10318','2013-09-29','09:05:00',1.82),('10318','2013-09-29','09:10:00',2.05),('10318','2013-09-29','09:15:00',2.19),('10318','2013-09-29','09:20:00',2.03),('10318','2013-09-29','09:25:00',2.1),('10318','2013-09-29','09:30:00',1.98),('10318','2013-09-29','09:35:00',1.88),('10318','2013-09-29','09:40:00',1.94),('10318','2013-09-29','09:45:00',2.19),('10318','2013-09-29','09:50:00',2.38),('10318','2013-09-29','09:55:00',2.75),('10318','2013-09-29','10:00:00',4.12),('10318','2013-09-29','10:05:00',4.42),('10318','2013-09-29','10:10:00',5.6),('10318','2013-09-29','10:15:00',6.46),('10318','2013-09-29','10:20:00',5.3),('10318','2013-09-29','10:25:00',4.95),('10318','2013-09-29','10:30:00',6.36),('10318','2013-09-29','10:35:00',6.5),('10318','2013-09-29','10:40:00',6.67),('10318','2013-09-29','10:45:00',6.92),('10318','2013-09-29','10:50:00',6.74),('10318','2013-09-29','10:55:00',6.95),('10318','2013-09-29','11:00:00',6.83),('10318','2013-09-29','11:05:00',6.45),('10318','2013-09-29','11:10:00',6.55),('10318','2013-09-29','11:15:00',7.06),('10318','2013-09-29','11:20:00',6.87),('10318','2013-09-29','11:25:00',6.76),('10318','2013-09-29','11:30:00',7.15),('10318','2013-09-29','11:35:00',6.9),('10318','2013-09-29','11:40:00',7.24),('10318','2013-09-29','11:45:00',7.5),('10318','2013-09-29','11:50:00',7.38),('10318','2013-09-29','11:55:00',7.68),('10318','2013-09-29','12:00:00',7.79),('10318','2013-09-29','12:05:00',7.75),('10318','2013-09-29','12:10:00',8.26),('10318','2013-09-29','12:15:00',7.08),('10318','2013-09-29','12:20:00',3.28),('10318','2013-09-29','12:25:00',3.28),('10318','2013-09-29','12:30:00',3.97),('10318','2013-09-29','12:35:00',3.64),('10318','2013-09-29','12:40:00',2.6),('10318','2013-09-29','12:45:00',2.49),('10318','2013-09-29','12:50:00',2.65),('10318','2013-09-29','12:55:00',2.63),('10318','2013-09-29','13:00:00',2.25),('10318','2013-09-29','13:05:00',2.1),('10318','2013-09-29','13:10:00',1.79),('10318','2013-09-29','13:15:00',1.41),('10318','2013-09-29','13:20:00',1.97),('10318','2013-09-29','13:25:00',2.88),('10318','2013-09-29','13:30:00',3.64),('10318','2013-09-29','13:35:00',5.59),('10318','2013-09-29','13:40:00',4.6),('10318','2013-09-29','13:45:00',4.75),('10318','2013-09-29','13:50:00',5.2),('10318','2013-09-29','13:55:00',3.8),('10318','2013-09-29','14:00:00',4.86),('10318','2013-09-29','14:05:00',4.83),('10318','2013-09-29','14:10:00',2.77),('10318','2013-09-29','14:15:00',3.16),('10318','2014-04-14','07:35:00',1.12),('10318','2014-04-14','07:40:00',1.75),('10318','2014-04-14','07:45:00',2.2),('10318','2014-04-14','07:50:00',2.72),('10318','2014-04-14','07:55:00',3),('10318','2014-04-14','08:00:00',3.22),('10318','2014-04-14','08:05:00',3.56),('10318','2014-04-14','08:10:00',3.79),('10318','2014-04-14','08:15:00',4.03),('10318','2014-04-14','08:20:00',4.24),('10318','2014-04-14','08:25:00',4.39),('10318','2014-04-14','08:30:00',4.68),('10318','2014-04-14','08:35:00',4.89),('10318','2014-04-14','08:40:00',5.1),('10318','2014-04-14','08:45:00',5.3),('10318','2014-04-14','08:50:00',5.47),('10318','2014-04-14','08:55:00',5.64),('10318','2014-04-14','09:00:00',5.84),('10318','2014-04-14','09:05:00',6.04),('10318','2014-04-14','09:10:00',6.22),('10318','2014-04-14','09:15:00',6.4),('10318','2014-04-14','09:20:00',6.55),('10318','2014-04-14','09:25:00',6.69),('10318','2014-04-14','09:30:00',6.86),('10318','2014-04-14','09:35:00',7),('10318','2014-04-14','09:40:00',7.16),('10318','2014-04-14','09:45:00',7.3),('10318','2014-04-14','09:50:00',7.44),('10318','2014-04-14','09:55:00',7.57),('10318','2014-04-14','10:00:00',7.71),('10318','2014-04-14','10:05:00',7.8),('10318','2014-04-14','10:10:00',7.76),('10318','2014-04-14','10:15:00',7.98),('10318','2014-04-14','10:20:00',8.07),('10318','2014-04-14','10:25:00',8.18),('10318','2014-04-14','10:30:00',8.28),('10318','2014-04-14','10:35:00',8.45),('10318','2014-04-14','10:40:00',8.47),('10318','2014-04-14','10:45:00',8.62),('10318','2014-04-14','10:50:00',8.71),('10318','2014-04-14','10:55:00',8.77),('10318','2014-04-14','11:00:00',8.86),('10318','2014-04-14','11:05:00',8.94),('10318','2014-04-14','11:10:00',9.02),('10318','2014-04-14','11:15:00',9.17),('10318','2014-04-14','11:20:00',9.19),('10318','2014-04-14','11:25:00',9.23),('10318','2014-04-14','11:30:00',9.26),('10318','2014-04-14','11:35:00',9.31),('10318','2014-04-14','11:40:00',9.38),('10318','2014-04-14','11:45:00',9.4),('10318','2014-04-14','11:50:00',9.4),('10318','2014-04-14','11:55:00',9.36),('10318','2014-04-14','12:00:00',9.49),('10318','2014-04-14','12:05:00',9.49),('10318','2014-04-14','12:10:00',9.52),('10318','2014-04-14','12:15:00',9.58),('10318','2014-04-14','12:20:00',9.59),('10318','2014-04-14','12:25:00',9.49),('10318','2014-04-14','12:30:00',9.54),('10318','2014-04-14','12:35:00',9.54),('10318','2014-04-14','12:40:00',9.58),('10318','2014-04-14','12:45:00',9.59),('10318','2014-04-14','12:50:00',9.63),('10318','2014-04-14','12:55:00',9.6),('10318','2014-04-14','13:00:00',9.54),('10318','2014-04-14','13:05:00',9.53),('10318','2014-04-14','13:10:00',9.49),('10318','2014-04-14','13:15:00',9.54),('10318','2014-04-14','13:20:00',9.51),('10318','2014-04-14','13:25:00',9.51),('10318','2014-04-14','13:30:00',9.48),('10318','2014-04-14','13:35:00',9.39),('10318','2014-04-14','13:40:00',9.11),('10318','2014-04-14','13:45:00',9.33),('10318','2014-04-14','13:50:00',9.34),('10318','2014-04-14','13:55:00',9.28),('10318','2014-04-14','14:00:00',9.2),('10318','2014-04-14','14:05:00',9.19),('10318','2014-04-14','14:10:00',9.08),('10318','2014-04-14','14:15:00',9),('10318','2014-04-14','14:20:00',8.87),('10318','2014-04-14','14:25:00',8.85),('10318','2014-04-14','14:30:00',8.74),('10318','2014-04-14','14:35:00',8.64),('10318','2014-04-14','14:40:00',8.56),('10318','2014-04-14','14:45:00',8.5),('10318','2014-04-14','14:50:00',8.41),('10318','2014-04-14','14:55:00',8.24),('10318','2014-04-14','15:00:00',8.14),('10318','2014-04-14','15:05:00',8.04),('10318','2014-04-14','15:10:00',7.95),('10318','2014-04-14','15:15:00',7.83),('10318','2014-04-14','15:20:00',7.72),('10318','2014-04-14','15:25:00',7.52),('10318','2014-04-14','15:30:00',7.39),('10318','2014-04-14','15:35:00',7.25),('10318','2014-04-14','15:40:00',7.11),('10318','2014-04-14','15:45:00',6.96),('10318','2014-04-14','15:50:00',6.82),('10318','2014-04-14','15:55:00',6.63),('10318','2014-04-14','16:00:00',6.49),('10318','2014-04-14','16:05:00',6.32),('10318','2014-04-14','16:10:00',6.17),('10318','2014-04-14','16:15:00',5.98),('10318','2014-04-14','16:20:00',5.82),('10318','2014-04-14','16:25:00',5.62),('10318','2014-04-14','16:30:00',5.43),('10318','2014-04-14','16:35:00',5.23),('10318','2014-04-14','16:40:00',4.95),('10318','2014-04-14','16:45:00',4.84),('10318','2014-04-14','16:50:00',4.65),('10318','2014-04-14','16:55:00',4.46),('10318','2014-04-14','17:00:00',4.24),('10318','2014-04-14','17:05:00',4.04),('10318','2014-04-14','17:10:00',3.85),('10318','2014-04-14','17:15:00',3.65),('10318','2014-04-14','17:20:00',3.47),('10318','2014-04-14','17:25:00',3.27),('10318','2014-04-14','17:30:00',3.05),('10318','2014-04-14','17:35:00',2.87),('10318','2014-04-14','17:40:00',2.69),('10318','2014-04-14','17:45:00',2.51),('10318','2014-04-14','17:50:00',2.33),('10318','2014-04-14','17:55:00',2.15),('10318','2014-04-14','18:00:00',2),('10318','2014-04-14','18:05:00',1.83),('10318','2014-04-14','18:10:00',1.66),('10318','2014-04-14','18:15:00',1.49),('10318','2014-04-14','18:20:00',1.36),('10318','2014-04-14','18:25:00',1.18),('10318','2014-04-14','18:30:00',1.01),('10318','2013-09-28','07:55:00',1.12),('10318','2013-09-28','08:00:00',1.3),('10318','2013-09-28','08:05:00',1.47),('10318','2013-09-28','08:10:00',1.8),('10318','2013-09-28','08:15:00',2.08),('10318','2013-09-28','08:20:00',1.92),('10318','2013-09-28','08:25:00',1.65),('10318','2013-09-28','08:30:00',2.87),('10318','2013-09-28','08:35:00',3.29),('10318','2013-09-28','08:40:00',3.49),('10318','2013-09-28','08:45:00',3.69),('10318','2013-09-28','08:50:00',3.87),('10318','2013-09-28','08:55:00',4.09),('10318','2013-09-28','09:00:00',4.31),('10318','2013-09-28','09:05:00',4.47),('10318','2013-09-28','09:10:00',4.72),('10318','2013-09-28','09:15:00',4.91),('10318','2013-09-28','09:20:00',5.1),('10318','2013-09-28','09:25:00',5.19),('10318','2013-09-28','09:30:00',5.47),('10318','2013-09-28','09:35:00',5.67),('10318','2013-09-28','09:40:00',5.8),('10318','2013-09-28','09:45:00',5.83),('10318','2013-09-28','09:50:00',5.69),('10318','2013-09-28','09:55:00',5.22),('10318','2013-09-28','10:00:00',3.13),('10318','2013-09-28','10:05:00',4.8),('10318','2013-09-28','10:10:00',6.08),('10318','2013-09-28','10:15:00',3.79),('10318','2013-09-28','10:20:00',2.71),('10318','2013-09-28','10:25:00',3.49),('10318','2013-09-28','10:30:00',3.89),('10318','2013-09-28','10:35:00',2.31),('10318','2013-09-28','10:40:00',5.67),('10318','2013-09-28','10:45:00',2.23),('10318','2013-09-28','10:50:00',5.61),('10318','2013-09-28','10:55:00',7.78),('10318','2013-09-28','11:00:00',8.14),('10318','2013-09-28','11:05:00',6.79),('10318','2013-09-28','11:10:00',3.22),('10318','2013-09-28','11:15:00',2.29),('10318','2013-09-28','11:20:00',5.74),('10318','2013-09-28','11:25:00',8.34),('10318','2013-09-28','11:30:00',8.39),('10318','2013-09-28','11:35:00',8.64),('10318','2013-09-28','11:40:00',5.98),('10318','2013-09-28','11:45:00',3.07),('10318','2013-09-28','11:50:00',3.07),('10318','2013-09-28','11:55:00',6.09),('10318','2013-09-28','12:00:00',8.65),('10318','2013-09-28','12:05:00',8.32),('10318','2013-09-28','12:10:00',8.42),('10318','2013-09-28','12:15:00',8.49),('10318','2013-09-28','12:20:00',8.79),('10318','2013-09-28','12:25:00',9.05),('10318','2013-09-28','12:30:00',8.38),('10318','2013-09-28','12:35:00',4.71),('10318','2013-09-28','12:40:00',6.03),('10318','2013-09-28','12:45:00',8.19),('10318','2013-09-28','12:50:00',8.73),('10318','2013-09-28','12:55:00',2.84),('10318','2013-09-28','13:00:00',5.38),('10318','2013-09-28','13:05:00',9.13),('10318','2013-09-28','13:10:00',8.66),('10318','2013-09-28','13:15:00',7.14),('10318','2013-09-28','13:20:00',3.15),('10318','2013-09-28','13:25:00',3.73),('10318','2013-09-28','13:30:00',2.44),('10318','2013-09-28','13:35:00',3.02),('10318','2013-09-28','13:40:00',5.48),('10318','2013-09-28','13:45:00',8.76),('10318','2013-09-28','13:50:00',3.99),('10318','2013-09-28','13:55:00',2.77),('10318','2013-09-28','14:00:00',7.26),('10318','2013-09-28','14:05:00',5.74),('10318','2013-09-28','14:10:00',6.14),('10318','2013-09-28','14:15:00',7.75),('10318','2013-09-28','14:20:00',4.55),('10318','2013-09-28','14:25:00',5.6),('10318','2013-09-28','14:30:00',3.17),('10318','2013-09-28','14:35:00',2.67),('10318','2013-09-28','14:40:00',2.55),('10318','2013-09-28','14:45:00',3.56),('10318','2013-09-28','14:50:00',2.7),('10318','2013-09-28','14:55:00',5.91),('10318','2013-09-28','15:00:00',6.8),('10318','2013-09-28','15:05:00',6.41),('10318','2013-09-28','15:10:00',6.22),('10318','2013-09-28','15:15:00',6.11),('10318','2013-09-28','15:20:00',5.93),('10318','2013-09-28','15:25:00',5.46),('10318','2013-09-28','15:30:00',5.54),('10318','2013-09-28','15:35:00',5.3),('10318','2013-09-28','15:40:00',5.41),('10318','2013-09-28','15:45:00',5.23),('10318','2013-09-28','15:50:00',5),('10318','2013-09-28','15:55:00',4.73),('10318','2013-09-28','16:00:00',4.35),('10318','2013-09-28','16:05:00',4.52),('10318','2013-09-28','16:10:00',4.39),('10318','2013-09-28','16:15:00',4.06),('10318','2013-09-28','16:20:00',3.78),('10318','2013-09-28','16:25:00',2.85),('10318','2013-09-28','16:30:00',3.49),('10318','2013-09-28','16:35:00',3.36),('10318','2013-09-28','16:40:00',3.15),('10318','2013-09-28','16:45:00',3.01),('10318','2013-09-28','16:50:00',2.86),('10318','2013-09-27','07:55:00',1.16),('10318','2013-09-27','08:00:00',1.26),('10318','2013-09-27','08:05:00',1.44),('10318','2013-09-27','08:10:00',1.26),('10318','2013-09-27','08:15:00',1.18),('10318','2013-09-27','08:20:00',1.61),('10318','2013-09-27','08:25:00',2.3),('10318','2013-09-27','08:30:00',3.29),('10318','2013-09-27','08:35:00',3.04),('10318','2013-09-27','08:40:00',3.43),('10318','2013-09-27','08:45:00',3.43),('10318','2013-09-27','08:50:00',3.36),('10318','2013-09-27','08:55:00',2.03),('10318','2013-09-27','09:00:00',3.79),('10318','2013-09-27','09:05:00',3.15),('10318','2013-09-27','09:10:00',2.61),('10318','2013-09-27','09:15:00',2.29),('10318','2013-09-27','09:20:00',1.96),('10318','2013-09-27','09:25:00',1.77),('10318','2013-09-27','09:30:00',2.07),('10318','2013-09-27','09:35:00',2.23),('10318','2013-09-27','09:40:00',1.83),('10318','2013-09-27','09:45:00',2.46),('10318','2013-09-27','09:50:00',2.72),('10318','2013-09-27','09:55:00',2.38),('10318','2013-09-27','10:00:00',2.49),('10318','2013-09-27','10:05:00',2.63),('10318','2013-09-27','10:10:00',2.35),('10318','2013-09-27','10:15:00',4.31),('10318','2013-09-27','10:20:00',3.63),('10318','2013-09-27','10:25:00',2.58),('10318','2013-09-27','10:30:00',2.78),('10318','2013-09-27','10:35:00',2.45),('10318','2013-09-27','10:40:00',8.15),('10318','2013-09-27','10:45:00',5.22),('10318','2013-09-27','10:50:00',7.91),('10318','2013-09-27','10:55:00',7.41),('10318','2013-09-27','11:00:00',7.57),('10318','2013-09-27','11:05:00',7.59),('10318','2013-09-27','11:10:00',7.15),('10318','2013-09-27','11:15:00',6.76),('10318','2013-09-27','11:20:00',6.51),('10318','2013-09-27','11:25:00',7.46),('10318','2013-09-27','11:30:00',5.61),('10318','2013-09-27','11:35:00',4.11),('10318','2013-09-27','11:40:00',7.68),('10318','2013-09-27','11:45:00',5.05),('10318','2013-09-27','11:50:00',6.82),('10318','2013-09-27','11:55:00',3.99),('10318','2013-09-27','12:00:00',2.51),('10318','2013-09-27','12:05:00',1.56),('10318','2013-09-27','12:10:00',1.14),('10318','2013-09-27','12:15:00',1.32),('10318','2013-09-27','12:20:00',1.39),('10318','2013-09-27','12:25:00',1.34),('10318','2013-09-27','12:30:00',1.67),('10318','2013-09-27','12:35:00',2.47),('10318','2013-09-27','12:40:00',7.94),('10318','2013-09-27','12:45:00',8.38),('10318','2013-09-27','12:50:00',8.06),('10318','2013-09-27','12:55:00',6.44),('10318','2013-09-27','13:00:00',8.58),('10318','2013-09-27','13:05:00',5.99),('10318','2013-09-27','13:10:00',5.14),('10318','2013-09-27','13:15:00',2.48),('10318','2013-09-27','13:20:00',2.18),('10318','2013-09-27','13:25:00',3.42),('10318','2013-09-27','13:30:00',4.4),('10318','2013-09-27','13:35:00',9.15),('10318','2013-09-27','13:40:00',8.73),('10318','2013-09-27','13:45:00',8.28),('10318','2013-09-27','13:50:00',6.38),('10318','2013-09-27','13:55:00',7.99),('10318','2013-09-27','14:00:00',7.8),('10318','2013-09-27','14:05:00',5.09),('10318','2013-09-27','14:10:00',6.43),('10318','2013-09-27','14:15:00',4.72),('10318','2013-09-27','14:20:00',7.82),('10318','2013-09-27','14:25:00',7.39),('10318','2013-09-27','14:30:00',7.19),('10318','2013-09-27','14:35:00',7.03),('10318','2013-09-27','14:40:00',5.03),('10318','2013-09-27','14:45:00',7.03),('10318','2013-09-27','14:50:00',6.88),('10318','2013-09-27','14:55:00',6.8),('10318','2013-09-27','15:00:00',5.22),('10318','2013-09-27','15:05:00',3.64),('10318','2013-09-27','15:10:00',3.29),('10318','2013-09-27','15:15:00',1.43),('10318','2013-09-27','15:20:00',3.05),('10318','2013-09-27','15:25:00',6.22),('10318','2013-09-27','15:30:00',2.18),('10318','2013-09-27','15:35:00',2.69),('10318','2013-09-27','15:40:00',5.38),('10318','2013-09-27','15:45:00',4.93),('10318','2013-09-27','15:50:00',3.41),('10318','2013-09-27','15:55:00',3.8),('10318','2013-09-27','16:00:00',5.21),('10318','2013-09-27','16:05:00',4.78),('10318','2013-09-27','16:10:00',4.42),('10318','2013-09-27','16:15:00',4.2),('10318','2013-09-27','16:20:00',4.05),('10318','2013-09-27','16:25:00',3.71),('10318','2013-09-27','16:30:00',3.51),('10318','2013-09-27','16:35:00',3.43),('10318','2013-09-27','16:40:00',3.36),('10318','2013-09-27','16:45:00',3.12),('10318','2013-09-27','16:50:00',1.87),('10318','2013-09-27','16:55:00',3.09),('10318','2013-09-27','17:00:00',2.72),('10318','2013-09-27','17:05:00',2.49),('10318','2013-09-27','17:10:00',2.35),('10318','2013-09-27','17:15:00',2.22),('10318','2013-09-27','17:20:00',1.29),('10318','2013-09-27','17:25:00',1.8),('10318','2013-09-27','17:30:00',1.48),('10318','2013-09-26','07:55:00',1.39),('10318','2013-09-26','08:00:00',1.56),('10318','2013-09-26','08:05:00',1.52),('10318','2013-09-26','08:10:00',2.39),('10318','2013-09-26','08:15:00',2.72),('10318','2013-09-26','08:20:00',2.67),('10318','2013-09-26','08:25:00',3.24),('10318','2013-09-26','08:30:00',3.4),('10318','2013-09-26','08:35:00',3.71),('10318','2013-09-26','08:40:00',3.93),('10318','2013-09-26','08:45:00',4.09),('10318','2013-09-26','08:50:00',4.3),('10318','2013-09-26','08:55:00',4.48),('10318','2013-09-26','09:00:00',4.78),('10318','2013-09-26','09:05:00',4.96),('10318','2013-09-26','09:10:00',5.09),('10318','2013-09-26','09:15:00',5.24),('10318','2013-09-26','09:20:00',5.4),('10318','2013-09-26','09:25:00',5.51),('10318','2013-09-26','09:30:00',5.71),('10318','2013-09-26','09:35:00',5.89),('10318','2013-09-26','09:40:00',6),('10318','2013-09-26','09:45:00',6.11),('10318','2013-09-26','09:50:00',6.27),('10318','2013-09-26','09:55:00',6.4),('10318','2013-09-26','10:00:00',6.52),('10318','2013-09-26','10:05:00',6.64),('10318','2013-09-26','10:10:00',6.7),('10318','2013-09-26','10:15:00',6.73),('10318','2013-09-26','10:20:00',6.81),('10318','2013-09-26','10:25:00',6.92),('10318','2013-09-26','10:30:00',7.07),('10318','2013-09-26','10:35:00',7.12),('10318','2013-09-26','10:40:00',7.08),('10318','2013-09-26','10:45:00',7.09),('10318','2013-09-26','10:50:00',7.48),('10318','2013-09-26','10:55:00',7.25),('10318','2013-09-26','11:00:00',7.27),('10318','2013-09-26','11:05:00',7.61),('10318','2013-09-26','11:10:00',7.61),('10318','2013-09-26','11:15:00',7.53),('10318','2013-09-26','11:20:00',7.73),('10318','2013-09-26','11:25:00',7.92),('10318','2013-09-26','11:30:00',8.07),('10318','2013-09-26','11:35:00',8.26),('10318','2013-09-26','11:40:00',6.75),('10318','2013-09-26','11:45:00',4.68),('10318','2013-09-26','11:50:00',7.16),('10318','2013-09-26','11:55:00',7.8),('10318','2013-09-26','12:00:00',6.92),('10318','2013-09-26','12:05:00',6.71),('10318','2013-09-26','12:10:00',3.82),('10318','2013-09-26','12:15:00',4.71),('10318','2013-09-26','12:20:00',5.67),('10318','2013-09-26','12:25:00',6.63),('10318','2013-09-26','12:30:00',4.26),('10318','2013-09-26','12:35:00',4.26),('10318','2013-09-26','12:40:00',6.88),('10318','2013-09-26','12:45:00',5.86),('10318','2013-09-26','12:50:00',3.5),('10318','2013-09-26','12:55:00',5.96),('10318','2013-09-26','13:00:00',5.13),('10318','2013-09-26','13:05:00',6.67),('10318','2013-09-26','13:10:00',9.05),('10318','2013-09-26','13:15:00',9.34),('10318','2013-09-26','13:20:00',6.8),('10318','2013-09-26','13:25:00',6.62),('10318','2013-09-26','13:30:00',3.68),('10318','2013-09-26','13:35:00',3.26),('10318','2013-09-26','13:40:00',3.77),('10318','2013-09-26','13:45:00',5.75),('10318','2013-09-26','13:50:00',5.23),('10318','2013-09-26','13:55:00',4.09),('10318','2013-09-26','14:00:00',4.56),('10318','2013-09-26','14:05:00',5.13),('10318','2013-09-26','14:10:00',5.19),('10318','2013-09-26','14:15:00',7.9),('10318','2013-09-26','14:20:00',7.88),('10318','2013-09-26','14:25:00',7.66),('10318','2013-09-26','14:30:00',7),('10318','2013-09-26','14:35:00',4.49),('10318','2013-09-26','14:40:00',7.7),('10318','2013-09-26','14:45:00',7.98),('10318','2013-09-26','14:50:00',4.62),('10318','2013-09-26','14:55:00',3.06),('10318','2013-09-26','15:00:00',1.89),('10318','2013-09-26','15:05:00',2.18),('10318','2013-09-26','15:10:00',2.22),('10318','2013-09-26','15:15:00',6.42),('10318','2013-09-26','15:20:00',2.46),('10318','2013-09-26','15:25:00',4.36),('10318','2013-09-26','15:30:00',1.59),('10318','2013-09-26','15:35:00',5.05),('10318','2013-09-26','15:40:00',5.98),('10318','2013-09-26','15:45:00',4.28),('10318','2013-09-26','15:50:00',3.31),('10318','2013-09-26','15:55:00',4.08),('10318','2013-09-26','16:00:00',4.84),('10318','2013-09-26','16:05:00',4.49),('10318','2013-09-26','16:10:00',4.41),('10318','2013-09-26','16:15:00',3.95),('10318','2013-09-26','16:20:00',3.87),('10318','2013-09-26','16:25:00',3.94),('10318','2013-09-26','16:30:00',3.75),('10318','2013-09-26','16:35:00',3.53),('10318','2013-09-26','16:40:00',3.36),('10318','2013-09-26','16:45:00',3.18),('10318','2013-09-26','16:50:00',3.01),('10318','2013-09-26','16:55:00',2.83),('10318','2013-09-26','17:00:00',2.65),('10318','2013-09-26','17:05:00',2.54),('10318','2013-09-26','17:10:00',2.44),('10318','2013-09-26','17:15:00',1.47),('10318','2013-09-26','17:20:00',1.91),('10318','2013-09-26','17:25:00',2.08),('10318','2013-09-26','17:30:00',1.91),('10318','2013-09-26','17:35:00',1.59),('10318','2013-09-26','17:40:00',1.49),('10318','2013-09-26','17:45:00',1.31),('10318','2013-09-26','17:50:00',1.13),('10318','2013-09-25','08:00:00',1.15),('10318','2013-09-25','08:05:00',1.73),('10318','2013-09-25','08:10:00',2.43),('10318','2013-09-25','08:15:00',2.7),('10318','2013-09-25','08:20:00',2.68),('10318','2013-09-25','08:25:00',3.05),('10318','2013-09-25','08:30:00',3.13),('10318','2013-09-25','08:35:00',1.75),('10318','2013-09-25','08:40:00',2.03),('10318','2013-09-25','08:45:00',1.81),('10318','2013-09-25','08:50:00',1.98),('10318','2013-09-25','08:55:00',2.62),('10318','2013-09-25','09:00:00',2.85),('10318','2013-09-25','09:05:00',3.05),('10318','2013-09-25','09:10:00',2.71),('10318','2013-09-25','09:15:00',4.57),('10318','2013-09-25','09:20:00',3.24),('10318','2013-09-25','09:25:00',4.98),('10318','2013-09-25','09:30:00',4.75),('10318','2013-09-25','09:35:00',6.3),('10318','2013-09-25','09:40:00',4.93),('10318','2013-09-25','09:45:00',2.12),('10318','2013-09-25','09:50:00',2.7),('10318','2013-09-25','09:55:00',2.4),('10318','2013-09-25','10:00:00',2.64),('10318','2013-09-25','10:05:00',6.55),('10318','2013-09-25','10:10:00',3.62),('10318','2013-09-25','10:15:00',2.87),('10318','2013-09-25','10:20:00',2.63),('10318','2013-09-25','10:25:00',6.73),('10318','2013-09-25','10:30:00',7.48),('10318','2013-09-25','10:35:00',3.77),('10318','2013-09-25','10:40:00',4.24),('10318','2013-09-25','10:45:00',1.52),('10318','2013-09-25','10:50:00',1.13),('10318','2013-09-25','10:55:00',1.06),('10318','2013-09-25','11:00:00',1.15),('10318','2013-09-25','11:05:00',6.4),('10318','2013-09-25','11:10:00',8.42),('10318','2013-09-25','11:15:00',8.27),('10318','2013-09-25','11:20:00',8.3),('10318','2013-09-25','11:25:00',8.36),('10318','2013-09-25','11:30:00',6.83),('10318','2013-09-25','11:35:00',8.09),('10318','2013-09-25','11:40:00',2.28),('10318','2013-09-25','11:45:00',2.02),('10318','2013-09-25','11:50:00',5.98),('10318','2013-09-25','11:55:00',8.74),('10318','2013-09-25','12:00:00',9.12),('10318','2013-09-25','12:05:00',8.03),('10318','2013-09-25','12:10:00',7.25),('10318','2013-09-25','12:15:00',9.77),('10318','2013-09-25','12:20:00',8.38),('10318','2013-09-25','12:25:00',2.48),('10318','2013-09-25','12:30:00',2.13),('10318','2013-09-25','12:35:00',1.93),('10318','2013-09-25','12:40:00',2.97),('10318','2013-09-25','12:45:00',8.94),('10318','2013-09-25','12:50:00',9.3),('10318','2013-09-25','12:55:00',9.02),('10318','2013-09-25','13:00:00',4.63),('10318','2013-09-25','13:05:00',8.33),('10318','2013-09-25','13:10:00',3.88),('10318','2013-09-25','13:15:00',2.67),('10318','2013-09-25','13:20:00',2.94),('10318','2013-09-25','13:25:00',8.94),('10318','2013-09-25','13:30:00',4.88),('10318','2013-09-25','13:35:00',9.64),('10318','2013-09-25','13:40:00',9.07),('10318','2013-09-25','13:45:00',9.07),('10318','2013-09-25','13:50:00',7.57),('10318','2013-09-25','13:55:00',9.19),('10318','2013-09-25','14:00:00',8.75),('10318','2013-09-25','14:05:00',7.01),('10318','2013-09-25','14:10:00',4.8),('10318','2013-09-25','14:15:00',3.65),('10318','2013-09-25','14:20:00',2.3),('10318','2013-09-25','14:25:00',2.35),('10318','2013-09-25','14:30:00',4.93),('10318','2013-09-25','14:35:00',8.79),('10318','2013-09-25','14:40:00',7.35),('10318','2013-09-25','14:45:00',3.94),('10318','2013-09-25','14:50:00',5.1),('10318','2013-09-25','14:55:00',7.46),('10318','2013-09-25','15:00:00',7.37),('10318','2013-09-25','15:05:00',6.6),('10318','2013-09-25','15:10:00',3.59),('10318','2013-09-25','15:15:00',4.89),('10318','2013-09-25','15:20:00',6.12),('10318','2013-09-25','15:25:00',6.3),('10318','2013-09-25','15:30:00',5.66),('10318','2013-09-25','15:35:00',5.81),('10318','2013-09-25','15:40:00',3.9),('10318','2013-09-25','15:45:00',4.75),('10318','2013-09-25','15:50:00',4.58),('10318','2013-09-25','15:55:00',1.79),('10318','2013-09-25','16:00:00',5.6),('10318','2013-09-25','16:05:00',5.02),('10318','2013-09-25','16:10:00',3.4),('10318','2013-09-25','16:15:00',3.25),('10318','2013-09-25','16:20:00',3.52),('10318','2013-09-25','16:25:00',4.18),('10318','2013-09-25','16:30:00',3.95),('10318','2013-09-25','16:35:00',3.72),('10318','2013-09-25','16:40:00',3.56),('10318','2013-09-25','16:45:00',3.37),('10318','2013-09-25','16:50:00',3.23),('10318','2013-09-25','16:55:00',2.97),('10318','2013-09-25','17:00:00',2.83),('10318','2013-09-25','17:05:00',2.67),('10318','2013-09-25','17:10:00',2.49),('10318','2013-09-25','17:15:00',2.34),('10318','2013-09-25','17:20:00',2.19),('10318','2013-09-25','17:25:00',2.03),('10318','2013-09-25','17:30:00',1.82),('10318','2013-09-25','17:35:00',1.7),('10318','2013-09-25','17:40:00',1.54),('10318','2013-09-25','17:45:00',1.4),('10318','2013-09-25','17:50:00',1.25),('10318','2013-09-25','17:55:00',1.1),('10318','2013-09-24','07:50:00',1.13),('10318','2013-09-24','07:55:00',1.29),('10318','2013-09-24','08:00:00',1.45),('10318','2013-09-24','08:05:00',2.04),('10318','2013-09-24','08:10:00',2.82),('10318','2013-09-24','08:15:00',3.12),('10318','2013-09-24','08:20:00',3.41),('10318','2013-09-24','08:25:00',3.57),('10318','2013-09-24','08:30:00',3.81),('10318','2013-09-24','08:35:00',3.96),('10318','2013-09-24','08:40:00',4.18),('10318','2013-09-24','08:45:00',4.37),('10318','2013-09-24','08:50:00',4.62),('10318','2013-09-24','08:55:00',4.79),('10318','2013-09-24','09:00:00',4.99),('10318','2013-09-24','09:05:00',5.16),('10318','2013-09-24','09:10:00',5.36),('10318','2013-09-24','09:15:00',5.51),('10318','2013-09-24','09:20:00',5.71),('10318','2013-09-24','09:25:00',5.88),('10318','2013-09-24','09:30:00',6.07),('10318','2013-09-24','09:35:00',6.17),('10318','2013-09-24','09:40:00',6.34),('10318','2013-09-24','09:45:00',6.44),('10318','2013-09-24','09:50:00',6.57),('10318','2013-09-24','09:55:00',6.68),('10318','2013-09-24','10:00:00',6.79),('10318','2013-09-24','10:05:00',6.89),('10318','2013-09-24','10:10:00',7.02),('10318','2013-09-24','10:15:00',7.13),('10318','2013-09-24','10:20:00',7.24),('10318','2013-09-24','10:25:00',7.33),('10318','2013-09-24','10:30:00',7.45),('10318','2013-09-24','10:35:00',7.53),('10318','2013-09-24','10:40:00',7.59),('10318','2013-09-24','10:45:00',7.66),('10318','2013-09-24','10:50:00',7.76),('10318','2013-09-24','10:55:00',7.79),('10318','2013-09-24','11:00:00',7.86),('10318','2013-09-24','11:05:00',7.78),('10318','2013-09-24','11:10:00',7.94),('10318','2013-09-24','11:15:00',8),('10318','2013-09-24','11:20:00',8.07),('10318','2013-09-24','11:25:00',8.1),('10318','2013-09-24','11:30:00',8.16),('10318','2013-09-24','11:35:00',8.15),('10318','2013-09-24','11:40:00',8.26),('10318','2013-09-24','11:45:00',8.24),('10318','2013-09-24','11:50:00',8.29),('10318','2013-09-24','11:55:00',8.22),('10318','2013-09-24','12:00:00',8.29),('10318','2013-09-24','12:05:00',8.37),('10318','2013-09-24','12:10:00',8.38),('10318','2013-09-24','12:15:00',8.43),('10318','2013-09-24','12:20:00',8.4),('10318','2013-09-24','12:25:00',8.41),('10318','2013-09-24','12:30:00',8.46),('10318','2013-09-24','12:35:00',8.43),('10318','2013-09-24','12:40:00',8.51),('10318','2013-09-24','12:45:00',8.45),('10318','2013-09-24','12:50:00',8.33),('10318','2013-09-24','12:55:00',8.47),('10318','2013-09-24','13:00:00',8.41),('10318','2013-09-24','13:05:00',8.45),('10318','2013-09-24','13:10:00',8.33),('10318','2013-09-24','13:15:00',8.24),('10318','2013-09-24','13:20:00',8.11),('10318','2013-09-24','13:25:00',8.11),('10318','2013-09-24','13:30:00',8.13),('10318','2013-09-24','13:35:00',8.13),('10318','2013-09-24','13:40:00',8.07),('10318','2013-09-24','13:45:00',7.98),('10318','2013-09-24','13:50:00',7.94),('10318','2013-09-24','13:55:00',7.82),('10318','2013-09-24','14:00:00',7.78),('10318','2013-09-24','14:05:00',7.7),('10318','2013-09-24','14:10:00',7.67),('10318','2013-09-24','14:15:00',7.57),('10318','2013-09-24','14:20:00',7.46),('10318','2013-09-24','14:25:00',7.39),('10318','2013-09-24','14:30:00',7.31),('10318','2013-09-24','14:35:00',7.14),('10318','2013-09-24','14:40:00',7.01),('10318','2013-09-24','14:45:00',6.92),('10318','2013-09-24','14:50:00',6.9),('10318','2013-09-24','14:55:00',6.72),('10318','2013-09-24','15:00:00',6.61),('10318','2013-09-24','15:05:00',6.53),('10318','2013-09-24','15:10:00',6.35),('10318','2013-09-24','15:15:00',6.27),('10318','2013-09-24','15:20:00',6.14),('10318','2013-09-24','15:25:00',6.03),('10318','2013-09-24','15:30:00',5.92),('10318','2013-09-24','15:35:00',5.76),('10318','2013-09-24','15:40:00',5.62),('10318','2013-09-24','15:45:00',5.47),('10318','2013-09-24','15:50:00',5.28),('10318','2013-09-24','15:55:00',5.1),('10318','2013-09-24','16:00:00',4.97),('10318','2013-09-24','16:05:00',4.8),('10318','2013-09-24','16:10:00',4.61),('10318','2013-09-24','16:15:00',4.46),('10318','2013-09-24','16:20:00',4.3),('10318','2013-09-24','16:25:00',4.11),('10318','2013-09-24','16:30:00',3.98),('10318','2013-09-24','16:35:00',3.82),('10318','2013-09-24','16:40:00',3.61),('10318','2013-09-24','16:45:00',3.44),('10318','2013-09-24','16:50:00',3.24),('10318','2013-09-24','16:55:00',3.07),('10318','2013-09-24','17:00:00',2.91),('10318','2013-09-24','17:05:00',2.74),('10318','2013-09-24','17:10:00',2.58),('10318','2013-09-24','17:15:00',2.44),('10318','2013-09-24','17:20:00',2.27),('10318','2013-09-24','17:25:00',2.11),('10318','2013-09-24','17:30:00',1.94),('10318','2013-09-24','17:35:00',1.73),('10318','2013-09-24','17:40:00',1.54),('10318','2013-09-24','17:45:00',1.47),('10318','2013-09-24','17:50:00',1.32),('10318','2013-09-24','17:55:00',1.16),('10318','2013-09-24','18:00:00',1.03),('10318','2013-09-23','07:50:00',1.12),('10318','2013-09-23','07:55:00',1.27),('10318','2013-09-23','08:00:00',1.43),('10318','2013-09-23','08:05:00',2.15),('10318','2013-09-23','08:10:00',2.89),('10318','2013-09-23','08:15:00',3.16),('10318','2013-09-23','08:20:00',3.47),('10318','2013-09-23','08:25:00',3.67),('10318','2013-09-23','08:30:00',3.91),('10318','2013-09-23','08:35:00',4.09),('10318','2013-09-23','08:40:00',4.34),('10318','2013-09-23','08:45:00',4.52),('10318','2013-09-23','08:50:00',4.75),('10318','2013-09-23','08:55:00',4.91),('10318','2013-09-23','09:00:00',5.12),('10318','2013-09-23','09:05:00',5.28),('10318','2013-09-23','09:10:00',5.5),('10318','2013-09-23','09:15:00',5.62),('10318','2013-09-23','09:20:00',5.81),('10318','2013-09-23','09:25:00',5.93),('10318','2013-09-23','09:30:00',6.08),('10318','2013-09-23','09:35:00',6.21),('10318','2013-09-23','09:40:00',6.38),('10318','2013-09-23','09:45:00',6.51),('10318','2013-09-23','09:50:00',6.68),('10318','2013-09-23','09:55:00',6.81),('10318','2013-09-23','10:00:00',6.95),('10318','2013-09-23','10:05:00',7.04),('10318','2013-09-23','10:10:00',7.17),('10318','2013-09-23','10:15:00',7.25),('10318','2013-09-23','10:20:00',7.43),('10318','2013-09-23','10:25:00',7.51),('10318','2013-09-23','10:30:00',7.6),('10318','2013-09-23','10:35:00',7.66),('10318','2013-09-23','10:40:00',7.79),('10318','2013-09-23','10:45:00',7.87),('10318','2013-09-23','10:50:00',7.95),('10318','2013-09-23','10:55:00',7.98),('10318','2013-09-23','11:00:00',8.07),('10318','2013-09-23','11:05:00',7.88),('10318','2013-09-23','11:10:00',8.24),('10318','2013-09-23','11:15:00',8.31),('10318','2013-09-23','11:20:00',8.45),('10318','2013-09-23','11:25:00',8.49),('10318','2013-09-23','11:30:00',8.51),('10318','2013-09-23','11:35:00',8.51),('10318','2013-09-23','11:40:00',8.6),('10318','2013-09-23','11:45:00',8.63),('10318','2013-09-23','11:50:00',8.66),('10318','2013-09-23','11:55:00',8.61),('10318','2013-09-23','12:00:00',8.69),('10318','2013-09-23','12:05:00',8.72),('10318','2013-09-23','12:10:00',8.75),('10318','2013-09-23','12:15:00',8.79),('10318','2013-09-23','12:20:00',8.82),('10318','2013-09-23','12:25:00',8.78),('10318','2013-09-23','12:30:00',8.72),('10318','2013-09-23','12:35:00',8.73),('10318','2013-09-23','12:40:00',8.65),('10318','2013-09-23','12:45:00',8.61),('10318','2013-09-23','12:50:00',8.46),('10318','2013-09-23','12:55:00',8.58),('10318','2013-09-23','13:00:00',8.51),('10318','2013-09-23','13:05:00',8.45),('10318','2013-09-23','13:10:00',8.4),('10318','2013-09-23','13:15:00',8.34),('10318','2013-09-23','13:20:00',8.28),('10318','2013-09-23','13:25:00',8.25),('10318','2013-09-23','13:30:00',8.16),('10318','2013-09-23','13:35:00',8.11),('10318','2013-09-23','13:40:00',8.05),('10318','2013-09-23','13:45:00',8.03),('10318','2013-09-23','13:50:00',7.87),('10318','2013-09-23','13:55:00',7.86),('10318','2013-09-23','14:00:00',7.76),('10318','2013-09-23','14:05:00',7.71),('10318','2013-09-23','14:10:00',7.66),('10318','2013-09-23','14:15:00',7.7),('10318','2013-09-23','14:20:00',7.62),('10318','2013-09-23','14:25:00',7.44),('10318','2013-09-23','14:30:00',7.23),('10318','2013-09-23','14:35:00',7.11),('10318','2013-09-23','14:40:00',7.03),('10318','2013-09-23','14:45:00',6.95),('10318','2013-09-23','14:50:00',6.87),('10318','2013-09-23','14:55:00',6.81),('10318','2013-09-23','15:00:00',6.73),('10318','2013-09-23','15:05:00',6.66),('10318','2013-09-23','15:10:00',6.49),('10318','2013-09-23','15:15:00',6.32),('10318','2013-09-23','15:20:00',6.13),('10318','2013-09-23','15:25:00',6.01),('10318','2013-09-23','15:30:00',5.97),('10318','2013-09-23','15:35:00',5.78),('10318','2013-09-23','15:40:00',5.55),('10318','2013-09-23','15:45:00',5.38),('10318','2013-09-23','15:50:00',5.05),('10318','2013-09-23','15:55:00',5.06),('10318','2013-09-23','16:00:00',4.86),('10318','2013-09-23','16:05:00',4.73),('10318','2013-09-23','16:10:00',3.75),('10318','2013-09-23','16:15:00',4.45),('10318','2013-09-23','16:20:00',4.24),('10318','2013-09-23','16:25:00',4.04),('10318','2013-09-23','16:30:00',3.91),('10318','2013-09-23','16:35:00',3.7),('10318','2013-09-23','16:40:00',3.51),('10318','2013-09-23','16:45:00',3.34),('10318','2013-09-23','16:50:00',3.16),('10318','2013-09-23','16:55:00',3),('10318','2013-09-23','17:00:00',2.79),('10318','2013-09-23','17:05:00',2.64),('10318','2013-09-23','17:10:00',2.5),('10318','2013-09-23','17:15:00',2.37),('10318','2013-09-23','17:20:00',2.21),('10318','2013-09-23','17:25:00',2.05),('10318','2013-09-23','17:30:00',1.9),('10318','2013-09-23','17:35:00',1.75),('10318','2013-09-23','17:40:00',1.55),('10318','2013-09-23','17:45:00',1.42),('10318','2013-09-23','17:50:00',1.27),('10318','2013-09-23','17:55:00',1.13),('10318','2013-09-22','07:50:00',1.2),('10318','2013-09-22','07:55:00',1.36),('10318','2013-09-22','08:00:00',1.53),('10318','2013-09-22','08:05:00',1.13),('10318','2013-09-22','08:10:00',1.7),('10318','2013-09-22','08:15:00',3.12),('10318','2013-09-22','08:20:00',3.44),('10318','2013-09-22','08:25:00',3.58),('10318','2013-09-22','08:30:00',3.77),('10318','2013-09-22','08:35:00',3.93),('10318','2013-09-22','08:40:00',4.15),('10318','2013-09-22','08:45:00',4.31),('10318','2013-09-22','08:50:00',4.58),('10318','2013-09-22','08:55:00',4.75),('10318','2013-09-22','09:00:00',5),('10318','2013-09-22','09:05:00',5.16),('10318','2013-09-22','09:10:00',5.35),('10318','2013-09-22','09:15:00',5.53),('10318','2013-09-22','09:20:00',5.7),('10318','2013-09-22','09:25:00',5.87),('10318','2013-09-22','09:30:00',6.01),('10318','2013-09-22','09:35:00',6.15),('10318','2013-09-22','09:40:00',6.29),('10318','2013-09-22','09:45:00',6.48),('10318','2013-09-22','09:50:00',6.45),('10318','2013-09-22','09:55:00',6.73),('10318','2013-09-22','10:00:00',6.89),('10318','2013-09-22','10:05:00',7.05),('10318','2013-09-22','10:10:00',7.18),('10318','2013-09-22','10:15:00',7.34),('10318','2013-09-22','10:20:00',7.47),('10318','2013-09-22','10:25:00',7.57),('10318','2013-09-22','10:30:00',7.65),('10318','2013-09-22','10:35:00',7.74),('10318','2013-09-22','10:40:00',7.85),('10318','2013-09-22','10:45:00',7.94),('10318','2013-09-22','10:50:00',8),('10318','2013-09-22','10:55:00',8.04),('10318','2013-09-22','11:00:00',8.06),('10318','2013-09-22','11:05:00',8.06),('10318','2013-09-22','11:10:00',8.22),('10318','2013-09-22','11:15:00',8.47),('10318','2013-09-22','11:20:00',8.52),('10318','2013-09-22','11:25:00',8.6),('10318','2013-09-22','11:30:00',8.62),('10318','2013-09-22','11:35:00',8.67),('10318','2013-09-22','11:40:00',8.78),('10318','2013-09-22','11:45:00',8.79),('10318','2013-09-22','11:50:00',8.79),('10318','2013-09-22','11:55:00',8.78),('10318','2013-09-22','12:00:00',8.81),('10318','2013-09-22','12:05:00',8.8),('10318','2013-09-22','12:10:00',8.81),('10318','2013-09-22','12:15:00',8.89),('10318','2013-09-22','12:20:00',8.87),('10318','2013-09-22','12:25:00',8.85),('10318','2013-09-22','12:30:00',8.83),('10318','2013-09-22','12:35:00',8.81),('10318','2013-09-22','12:40:00',8.88),('10318','2013-09-22','12:45:00',8.89),('10318','2013-09-22','12:50:00',8.89),('10318','2013-09-22','12:55:00',8.71),('10318','2013-09-22','13:00:00',8.8),('10318','2013-09-22','13:05:00',8.75),('10318','2013-09-22','13:10:00',8.75),('10318','2013-09-22','13:15:00',8.66),('10318','2013-09-22','13:20:00',8.6),('10318','2013-09-22','13:25:00',8.57),('10318','2013-09-22','13:30:00',8.51),('10318','2013-09-22','13:35:00',8.47),('10318','2013-09-22','13:40:00',8.36),('10318','2013-09-22','13:45:00',8.28),('10318','2013-09-22','13:50:00',8.26),('10318','2013-09-22','13:55:00',8.34),('10318','2013-09-22','14:00:00',8.37),('10318','2013-09-22','14:05:00',8.48),('10318','2013-09-22','14:10:00',8.19),('10318','2013-09-22','14:15:00',5.99),('10318','2013-09-22','14:20:00',5.28),('10318','2013-09-22','14:25:00',4.14),('10318','2013-09-22','14:30:00',1.71),('10318','2013-09-22','14:35:00',5.99),('10318','2013-09-22','14:40:00',7.66),('10318','2013-09-22','14:45:00',6.79),('10318','2013-09-22','14:50:00',7.26),('10318','2013-09-22','14:55:00',7.1),('10318','2013-09-22','15:00:00',7.15),('10318','2013-09-22','15:05:00',7.21),('10318','2013-09-22','15:10:00',7.29),('10318','2013-09-22','15:15:00',6.4),('10318','2013-09-22','15:20:00',7.59),('10318','2013-09-22','15:25:00',3.66),('10318','2013-09-22','15:30:00',2.36),('10318','2013-09-22','15:35:00',6.38),('10318','2013-09-22','15:40:00',6.47),('10318','2013-09-22','15:45:00',5.74),('10318','2013-09-22','15:50:00',5.51),('10318','2013-09-22','15:55:00',5.59),('10318','2013-09-22','16:00:00',5.19),('10318','2013-09-22','16:05:00',6.06),('10318','2013-09-22','16:10:00',6.17),('10318','2013-09-22','16:15:00',4.59),('10318','2013-09-22','16:20:00',3.44),('10318','2013-09-22','16:25:00',2.42),('10318','2013-09-22','16:30:00',2.8),('10318','2013-09-22','16:35:00',2.13),('10318','2013-09-22','16:40:00',2.08),('10318','2013-09-22','16:45:00',2.87),('10318','2013-09-22','16:50:00',2.57),('10318','2013-09-22','16:55:00',4.16),('10318','2013-09-22','17:00:00',3.74),('10318','2013-09-22','17:05:00',2.41),('10318','2013-09-22','17:10:00',2.19),('10318','2013-09-22','17:15:00',1.1),('10318','2013-09-22','17:30:00',1.34),('10318','2013-09-22','17:35:00',1.62),('10318','2013-09-22','17:55:00',1.1),('10318','2013-09-22','18:00:00',1.09),('10318','2013-09-21','07:50:00',1.16),('10318','2013-09-21','07:55:00',1.31),('10318','2013-09-21','08:00:00',1.56),('10318','2013-09-21','08:05:00',2.32),('10318','2013-09-21','08:10:00',2.88),('10318','2013-09-21','08:15:00',3.05),('10318','2013-09-21','08:20:00',3.36),('10318','2013-09-21','08:25:00',3.58),('10318','2013-09-21','08:30:00',3.72),('10318','2013-09-21','08:35:00',4),('10318','2013-09-21','08:40:00',4.22),('10318','2013-09-21','08:45:00',4.39),('10318','2013-09-21','08:50:00',4.62),('10318','2013-09-21','08:55:00',4.78),('10318','2013-09-21','09:00:00',4.98),('10318','2013-09-21','09:05:00',5.14),('10318','2013-09-21','09:10:00',5.33),('10318','2013-09-21','09:15:00',5.46),('10318','2013-09-21','09:20:00',5.65),('10318','2013-09-21','09:25:00',5.79),('10318','2013-09-21','09:30:00',5.96),('10318','2013-09-21','09:35:00',6.1),('10318','2013-09-21','09:40:00',6.28),('10318','2013-09-21','09:45:00',6.41),('10318','2013-09-21','09:50:00',6.54),('10318','2013-09-21','09:55:00',6.67),('10318','2013-09-21','10:00:00',6.83),('10318','2013-09-21','10:05:00',6.93),('10318','2013-09-21','10:10:00',7.05),('10318','2013-09-21','10:15:00',7.13),('10318','2013-09-21','10:20:00',7.07),('10318','2013-09-21','10:25:00',7.32),('10318','2013-09-21','10:30:00',7.4),('10318','2013-09-21','10:35:00',7.5),('10318','2013-09-21','10:40:00',7.58),('10318','2013-09-21','10:45:00',7.64),('10318','2013-09-21','10:50:00',7.77),('10318','2013-09-21','10:55:00',7.86),('10318','2013-09-21','11:00:00',7.93),('10318','2013-09-21','11:05:00',7.99),('10318','2013-09-21','11:10:00',8.08),('10318','2013-09-21','11:15:00',8.14),('10318','2013-09-21','11:20:00',8.18),('10318','2013-09-21','11:25:00',8.19),('10318','2013-09-21','11:30:00',8.26),('10318','2013-09-21','11:35:00',8.37),('10318','2013-09-21','11:40:00',8.44),('10318','2013-09-21','11:45:00',8.47),('10318','2013-09-21','11:50:00',8.34),('10318','2013-09-21','11:55:00',8.33),('10318','2013-09-21','12:00:00',8.56),('10318','2013-09-21','12:05:00',8.56),('10318','2013-09-21','12:10:00',8.55),('10318','2013-09-21','12:15:00',8.67),('10318','2013-09-21','12:20:00',8.06),('10318','2013-09-21','12:25:00',8.39),('10318','2013-09-21','12:30:00',8.79),('10318','2013-09-21','12:35:00',8.33),('10318','2013-09-21','12:40:00',7.61),('10318','2013-09-21','12:45:00',8.19),('10318','2013-09-21','12:50:00',8.5),('10318','2013-09-21','12:55:00',8.6),('10318','2013-09-21','13:00:00',8.28),('10318','2013-09-21','13:05:00',8.3),('10318','2013-09-21','13:10:00',8.55),('10318','2013-09-21','13:15:00',7.55),('10318','2013-09-21','13:20:00',6.68),('10318','2013-09-21','13:25:00',8.04),('10318','2013-09-21','13:30:00',7.97),('10318','2013-09-21','13:35:00',7.63),('10318','2013-09-21','13:40:00',6.71),('10318','2013-09-21','13:45:00',7.06),('10318','2013-09-21','13:50:00',7.51),('10318','2013-09-21','13:55:00',7.34),('10318','2013-09-21','14:00:00',7.39),('10318','2013-09-21','14:05:00',7.61),('10318','2013-09-21','14:10:00',7.36),('10318','2013-09-21','14:15:00',7.65),('10318','2013-09-21','14:20:00',7.53),('10318','2013-09-21','14:25:00',7.39),('10318','2013-09-21','14:30:00',7.31),('10318','2013-09-21','14:35:00',7.25),('10318','2013-09-21','14:40:00',7.01),('10318','2013-09-21','14:45:00',7),('10318','2013-09-21','14:50:00',6.91),('10318','2013-09-21','14:55:00',6.8),('10318','2013-09-21','15:00:00',6.69),('10318','2013-09-21','15:05:00',6.44),('10318','2013-09-21','15:10:00',6.24),('10318','2013-09-21','15:15:00',6.3),('10318','2013-09-21','15:20:00',6.13),('10318','2013-09-21','15:25:00',5.91),('10318','2013-09-21','15:30:00',5.85),('10318','2013-09-21','15:35:00',5.68),('10318','2013-09-21','15:40:00',4.65),('10318','2013-09-21','15:45:00',5),('10318','2013-09-21','15:50:00',4.92),('10318','2013-09-21','15:55:00',4.87),('10318','2013-09-21','16:00:00',3.44),('10318','2013-09-21','16:05:00',2.79),('10318','2013-09-21','16:10:00',2.83),('10318','2013-09-21','16:15:00',3.45),('10318','2013-09-21','16:20:00',2.45),('10318','2013-09-21','16:25:00',1.86),('10318','2013-09-21','16:30:00',2.86),('10318','2013-09-21','16:35:00',2.6),('10318','2013-09-21','16:40:00',1.82),('10318','2013-09-21','16:45:00',1.72),('10318','2013-09-21','16:50:00',2.13),('10318','2013-09-21','16:55:00',1.75),('10318','2013-09-21','17:00:00',1.71),('10318','2013-09-21','17:05:00',2.27),('10318','2013-09-21','17:10:00',1.82),('10318','2013-09-21','17:15:00',2.1),('10318','2013-09-21','17:20:00',1.05),('10318','2013-09-21','17:25:00',1.14),('10318','2013-09-21','17:30:00',1.72),('10318','2013-09-21','17:35:00',1.56),('10318','2013-09-21','17:40:00',1.9),('10318','2013-09-21','17:45:00',1.66),('10318','2013-09-21','17:50:00',1.31),('10318','2013-09-21','17:55:00',1.23),('10318','2013-09-21','18:00:00',1.09),('10318','2013-09-20','08:10:00',1.08),('10318','2013-09-20','08:15:00',1.23),('10318','2013-09-20','08:20:00',1.35),('10318','2013-09-20','08:25:00',1.5),('10318','2013-09-20','08:30:00',2.82),('10318','2013-09-20','08:35:00',3.52),('10318','2013-09-20','08:40:00',5.2),('10318','2013-09-20','08:45:00',3.84),('10318','2013-09-20','08:50:00',2.35),('10318','2013-09-20','08:55:00',2.26),('10318','2013-09-20','09:00:00',2.45),('10318','2013-09-20','09:05:00',2.46),('10318','2013-09-20','09:10:00',2.24),('10318','2013-09-20','09:15:00',2.39),('10318','2013-09-20','09:20:00',2.68),('10318','2013-09-20','09:25:00',2.63),('10318','2013-09-20','09:30:00',2.49),('10318','2013-09-20','09:35:00',2.61),('10318','2013-09-20','09:40:00',3.22),('10318','2013-09-20','09:45:00',2.95),('10318','2013-09-20','09:50:00',3.08),('10318','2013-09-20','09:55:00',3.29),('10318','2013-09-20','10:00:00',3.62),('10318','2013-09-20','10:05:00',3.93),('10318','2013-09-20','10:10:00',4.38),('10318','2013-09-20','10:15:00',4.23),('10318','2013-09-20','10:20:00',5.68),('10318','2013-09-20','10:25:00',4.04),('10318','2013-09-20','10:30:00',3.96),('10318','2013-09-20','10:35:00',4.16),('10318','2013-09-20','10:40:00',6.67),('10318','2013-09-20','10:45:00',5.92),('10318','2013-09-20','10:50:00',4.92),('10318','2013-09-20','10:55:00',7.05),('10318','2013-09-20','11:00:00',6.44),('10318','2013-09-20','11:05:00',4.4),('10318','2013-09-20','11:10:00',4.38),('10318','2013-09-20','11:15:00',5.55),('10318','2013-09-20','11:20:00',6.67),('10318','2013-09-20','11:25:00',6.72),('10318','2013-09-20','11:30:00',9.06),('10318','2013-09-20','11:35:00',10.69),('10318','2013-09-20','11:40:00',8.71),('10318','2013-09-20','11:45:00',9.63),('10318','2013-09-20','11:50:00',8.98),('10318','2013-09-20','11:55:00',8.99),('10318','2013-09-20','12:00:00',8.74),('10318','2013-09-20','12:05:00',8.67),('10318','2013-09-20','12:10:00',8.69),('10318','2013-09-20','12:15:00',8.9),('10318','2013-09-20','12:20:00',8.83),('10318','2013-09-20','12:25:00',5.98),('10318','2013-09-20','12:30:00',7.86),('10318','2013-09-20','12:35:00',9.67),('10318','2013-09-20','12:40:00',9.52),('10318','2013-09-20','12:45:00',9.34),('10318','2013-09-20','12:50:00',8.89),('10318','2013-09-20','12:55:00',8.56),('10318','2013-09-20','13:00:00',8.5),('10318','2013-09-20','13:05:00',8.49),('10318','2013-09-20','13:10:00',8.52),('10318','2013-09-20','13:15:00',8.48),('10318','2013-09-20','13:20:00',8.37),('10318','2013-09-20','13:25:00',5.76),('10318','2013-09-20','13:30:00',7.92),('10318','2013-09-20','13:35:00',8.26),('10318','2013-09-20','13:40:00',8.02),('10318','2013-09-20','13:45:00',8.17),('10318','2013-09-20','13:50:00',7.54),('10318','2013-09-20','13:55:00',7.88),('10318','2013-09-20','14:00:00',8.02),('10318','2013-09-20','14:05:00',8.09),('10318','2013-09-20','14:10:00',8.11),('10318','2013-09-20','14:15:00',8.03),('10318','2013-09-20','14:20:00',4.64),('10318','2013-09-20','14:25:00',7.27),('10318','2013-09-20','14:30:00',4.9),('10318','2013-09-20','14:35:00',5.85),('10318','2013-09-20','14:40:00',4.06),('10318','2013-09-20','14:45:00',5.69),('10318','2013-09-20','14:50:00',7.65),('10318','2013-09-20','14:55:00',7.2),('10318','2013-09-20','15:00:00',6.17),('10318','2013-09-20','15:05:00',3.04),('10318','2013-09-20','15:10:00',4.01),('10318','2013-09-20','15:15:00',2.16),('10318','2013-09-20','15:20:00',1.86),('10318','2013-09-20','15:25:00',1.87),('10318','2013-09-20','15:30:00',5.49),('10318','2013-09-20','15:35:00',6.71),('10318','2013-09-20','15:40:00',6.02),('10318','2013-09-20','15:45:00',6.04),('10318','2013-09-20','15:50:00',6),('10318','2013-09-20','15:55:00',5.94),('10318','2013-09-20','16:00:00',5.9),('10318','2013-09-20','16:05:00',5.33),('10318','2013-09-20','16:10:00',4.36),('10318','2013-09-20','16:15:00',3.18),('10318','2013-09-20','16:20:00',2.9),('10318','2013-09-20','16:25:00',3.24),('10318','2013-09-20','16:30:00',2.06),('10318','2013-09-20','16:35:00',1.77),('10318','2013-09-20','16:40:00',1.82),('10318','2013-09-20','16:45:00',2.41),('10318','2013-09-20','16:50:00',3.1),('10318','2013-09-20','16:55:00',3.41),('10318','2013-09-20','17:00:00',3.83),('10318','2013-09-20','17:05:00',3.99),('10318','2013-09-20','17:10:00',4.16),('10318','2013-09-20','17:15:00',3.97),('10318','2013-09-20','17:20:00',3.92),('10318','2013-09-20','17:25:00',3.52),('10318','2013-09-20','17:30:00',3.29),('10318','2013-09-20','17:35:00',3.19),('10318','2013-09-20','17:40:00',2.72),('10318','2013-09-20','17:45:00',2.88),('10318','2013-09-20','17:50:00',2.58),('10318','2013-09-20','17:55:00',1.75),('10318','2013-09-20','18:00:00',1.91),('10318','2013-09-20','18:05:00',2.15),('10318','2013-09-20','18:10:00',1.86),('10318','2013-09-20','18:15:00',1.37),('10318','2013-09-20','18:20:00',1.07),('10318','2013-09-19','08:00:00',1.17),('10318','2013-09-19','08:05:00',1.38),('10318','2013-09-19','08:10:00',2.4),('10318','2013-09-19','08:15:00',2.55),('10318','2013-09-19','08:20:00',2.81),('10318','2013-09-19','08:25:00',3.2),('10318','2013-09-19','08:30:00',3.61),('10318','2013-09-19','08:35:00',3.61),('10318','2013-09-19','08:40:00',3.29),('10318','2013-09-19','08:45:00',3.67),('10318','2013-09-19','08:50:00',3.62),('10318','2013-09-19','08:55:00',3.03),('10318','2013-09-19','09:00:00',2.12),('10318','2013-09-19','09:05:00',2.4),('10318','2013-09-19','09:10:00',2.61),('10318','2013-09-19','09:15:00',2.37),('10318','2013-09-19','09:20:00',3.6),('10318','2013-09-19','09:25:00',2.31),('10318','2013-09-19','09:30:00',2.84),('10318','2013-09-19','09:35:00',2.73),('10318','2013-09-19','09:40:00',1.68),('10318','2013-09-19','09:45:00',5.19),('10318','2013-09-19','09:50:00',5.57),('10318','2013-09-19','09:55:00',4.7),('10318','2013-09-19','10:00:00',5.29),('10318','2013-09-19','10:05:00',7.78),('10318','2013-09-19','10:10:00',7.92),('10318','2013-09-19','10:15:00',5.33),('10318','2013-09-19','10:20:00',4.62),('10318','2013-09-19','10:25:00',2.47),('10318','2013-09-19','10:30:00',5.12),('10318','2013-09-19','10:35:00',3.21),('10318','2013-09-19','10:40:00',6.65),('10318','2013-09-19','10:45:00',8.98),('10318','2013-09-19','10:50:00',7.6),('10318','2013-09-19','10:55:00',5.13),('10318','2013-09-19','11:00:00',7.31),('10318','2013-09-19','11:05:00',2.46),('10318','2013-09-19','11:10:00',3.01),('10318','2013-09-19','11:15:00',8.94),('10318','2013-09-19','11:20:00',8.05),('10318','2013-09-19','11:25:00',4.32),('10318','2013-09-19','11:30:00',4.54),('10318','2013-09-19','11:35:00',3.24),('10318','2013-09-19','11:40:00',5.88),('10318','2013-09-19','11:45:00',9),('10318','2013-09-19','11:50:00',9.96),('10318','2013-09-19','11:55:00',6.76),('10318','2013-09-19','12:00:00',5.3),('10318','2013-09-19','12:05:00',6.76),('10318','2013-09-19','12:10:00',8.12),('10318','2013-09-19','12:15:00',10.1),('10318','2013-09-19','12:20:00',6.43),('10318','2013-09-19','12:25:00',5.62),('10318','2013-09-19','12:30:00',8.18),('10318','2013-09-19','12:35:00',9.3),('10318','2013-09-19','12:40:00',7.18),('10318','2013-09-19','12:45:00',9.65),('10318','2013-09-19','12:50:00',9.8),('10318','2013-09-19','12:55:00',6.64),('10318','2013-09-19','13:00:00',9.52),('10318','2013-09-19','13:05:00',6.47),('10318','2013-09-19','13:10:00',7.59),('10318','2013-09-19','13:15:00',4.08),('10318','2013-09-19','13:20:00',7.69),('10318','2013-09-19','13:25:00',7.82),('10318','2013-09-19','13:30:00',8.93),('10318','2013-09-19','13:35:00',4.18),('10318','2013-09-19','13:40:00',4.29),('10318','2013-09-19','13:45:00',4.54),('10318','2013-09-19','13:50:00',4.52),('10318','2013-09-19','13:55:00',5.5),('10318','2013-09-19','14:00:00',7.04),('10318','2013-09-19','14:05:00',8.55),('10318','2013-09-19','14:10:00',8.11),('10318','2013-09-19','14:15:00',8.19),('10318','2013-09-19','14:20:00',7.92),('10318','2013-09-19','14:25:00',7.76),('10318','2013-09-19','14:30:00',7.64),('10318','2013-09-19','14:35:00',7.56),('10318','2013-09-19','14:40:00',7.48),('10318','2013-09-19','14:45:00',6.37),('10318','2013-09-19','14:50:00',7.2),('10318','2013-09-19','14:55:00',7.06),('10318','2013-09-19','15:00:00',7.35),('10318','2013-09-19','15:05:00',7),('10318','2013-09-19','15:10:00',7.1),('10318','2013-09-19','15:15:00',7.26),('10318','2013-09-19','15:20:00',7.3),('10318','2013-09-19','15:25:00',6.17),('10318','2013-09-19','15:30:00',6.51),('10318','2013-09-19','15:35:00',6.05),('10318','2013-09-19','15:40:00',6.14),('10318','2013-09-19','15:45:00',5.21),('10318','2013-09-19','15:50:00',5.55),('10318','2013-09-19','15:55:00',5.44),('10318','2013-09-19','16:00:00',5.25),('10318','2013-09-19','16:05:00',3.47),('10318','2013-09-19','16:10:00',1.99),('10318','2013-09-19','16:15:00',3.79),('10318','2013-09-19','16:20:00',4.86),('10318','2013-09-19','16:25:00',4.58),('10318','2013-09-19','16:30:00',3.95),('10318','2013-09-19','16:35:00',3.97),('10318','2013-09-19','16:40:00',3.77),('10318','2013-09-19','16:45:00',3.69),('10318','2013-09-19','16:50:00',3.72),('10318','2013-09-19','16:55:00',3.38),('10318','2013-09-19','17:00:00',2.76),('10318','2013-09-19','17:05:00',2.89),('10318','2013-09-19','17:10:00',2.73),('10318','2013-09-19','17:15:00',2.69),('10318','2013-09-19','17:20:00',2.52),('10318','2013-09-19','17:25:00',2.26),('10318','2013-09-19','17:30:00',1.8),('10318','2013-09-19','17:35:00',1.74),('10318','2013-09-19','17:40:00',1.67),('10318','2013-09-19','17:45:00',1.62),('10318','2013-09-19','17:50:00',1.5),('10318','2013-09-19','17:55:00',1.23),('10318','2013-09-19','18:00:00',1.09),('10318','2014-04-13','08:00:00',1.05),('10318','2014-04-13','08:05:00',1.06),('10318','2014-04-13','08:15:00',1),('10318','2014-04-13','08:25:00',1.2),('10318','2014-04-13','08:30:00',1.4),('10318','2014-04-13','08:35:00',1.57),('10318','2014-04-13','08:40:00',1.7),('10318','2014-04-13','08:45:00',1.68),('10318','2014-04-13','08:50:00',1.58),('10318','2014-04-13','08:55:00',1.96),('10318','2014-04-13','09:00:00',2.3),('10318','2014-04-13','09:05:00',3.31),('10318','2014-04-13','09:10:00',2.89),('10318','2014-04-13','09:15:00',2.66),('10318','2014-04-13','09:20:00',3.1),('10318','2014-04-13','09:25:00',3.63),('10318','2014-04-13','09:30:00',4.68),('10318','2014-04-13','09:35:00',4.8),('10318','2014-04-13','09:40:00',3.61),('10318','2014-04-13','09:45:00',3.46),('10318','2014-04-13','09:50:00',3.73),('10318','2014-04-13','09:55:00',4.53),('10318','2014-04-13','10:00:00',6.12),('10318','2014-04-13','10:05:00',8.18),('10318','2014-04-13','10:10:00',6.65),('10318','2014-04-13','10:15:00',5.17),('10318','2014-04-13','10:20:00',5.62),('10318','2014-04-13','10:25:00',4.56),('10318','2014-04-13','10:30:00',7.63),('10318','2014-04-13','10:35:00',7.99),('10318','2014-04-13','10:40:00',7.95),('10318','2014-04-13','10:45:00',8.8),('10318','2014-04-13','10:50:00',6.48),('10318','2014-04-13','10:55:00',9.08),('10318','2014-04-13','11:00:00',8.76),('10318','2014-04-13','11:05:00',7.33),('10318','2014-04-13','11:10:00',9.49),('10318','2014-04-13','11:15:00',9.68),('10318','2014-04-13','11:20:00',6.27),('10318','2014-04-13','11:25:00',5.5),('10318','2014-04-13','11:30:00',8.21),('10318','2014-04-13','11:35:00',7.9),('10318','2014-04-13','11:40:00',8.99),('10318','2014-04-13','11:45:00',8.6),('10318','2014-04-13','11:50:00',7.48),('10318','2014-04-13','11:55:00',5.69),('10318','2014-04-13','12:00:00',5.25),('10318','2014-04-13','12:05:00',3.64),('10318','2014-04-13','12:10:00',3.28),('10318','2014-04-13','12:15:00',3.49),('10318','2014-04-13','12:20:00',2.96),('10318','2014-04-13','12:25:00',2.02),('10318','2014-04-13','12:30:00',1.41),('10318','2014-04-13','12:35:00',1.25),('10318','2014-04-13','12:40:00',1.15),('10318','2014-04-13','12:45:00',1.36),('10318','2014-04-13','12:50:00',1.6),('10318','2014-04-13','12:55:00',2.02),('10318','2014-04-13','13:00:00',2.74),('10318','2014-04-13','13:05:00',4.12),('10318','2014-04-13','13:10:00',5.19),('10318','2014-04-13','13:15:00',8.37),('10318','2014-04-13','13:20:00',8.8),('10318','2014-04-13','13:25:00',9.69),('10318','2014-04-13','13:30:00',9.3),('10318','2014-04-13','13:35:00',9.66),('10318','2014-04-13','13:40:00',5.38),('10318','2014-04-13','13:45:00',5.09),('10318','2014-04-13','13:50:00',8.23),('10318','2014-04-13','13:55:00',8.52),('10318','2014-04-13','14:00:00',8.01),('10318','2014-04-13','14:05:00',9.41),('10318','2014-04-13','14:10:00',8.67),('10318','2014-04-13','14:15:00',6.86),('10318','2014-04-13','14:20:00',3.5),('10318','2014-04-13','14:25:00',4.21),('10318','2014-04-13','14:30:00',5.17),('10318','2014-04-13','14:35:00',4.24),('10318','2014-04-13','14:40:00',3.82),('10318','2014-04-13','14:45:00',6.6),('10318','2014-04-13','14:50:00',8.7),('10318','2014-04-13','14:55:00',8.38),('10318','2014-04-13','15:00:00',7.46),('10318','2014-04-13','15:05:00',8.27),('10318','2014-04-13','15:10:00',7.71),('10318','2014-04-13','15:15:00',6.38),('10318','2014-04-13','15:20:00',7.39),('10318','2014-04-13','15:25:00',7.58),('10318','2014-04-13','15:30:00',5.08),('10318','2014-04-13','15:35:00',4.58),('10318','2014-04-13','15:40:00',4.83),('10318','2014-04-13','15:45:00',3.58),('10318','2014-04-13','15:50:00',4.65),('10318','2014-04-13','15:55:00',5.36),('10318','2014-04-13','16:00:00',5.36),('10318','2014-04-13','16:05:00',3.12),('10318','2014-04-13','16:10:00',2.53),('10318','2014-04-13','16:15:00',2.54),('10318','2014-04-13','16:20:00',3.6),('10318','2014-04-13','16:25:00',3.05),('10318','2014-04-13','16:30:00',3.07),('10318','2014-04-13','16:35:00',3.29),('10318','2014-04-13','16:40:00',5.67),('10318','2014-04-13','16:45:00',4.25),('10318','2014-04-13','16:50:00',3.94),('10318','2014-04-13','16:55:00',3.84),('10318','2014-04-13','17:00:00',3.16),('10318','2014-04-13','17:05:00',3.02),('10318','2014-04-13','17:10:00',2.47),('10318','2014-04-13','17:15:00',2.39),('10318','2014-04-13','17:20:00',2.19),('10318','2014-04-13','17:25:00',2.2),('10318','2014-04-13','17:30:00',2.23),('10318','2014-04-13','17:35:00',2.04),('10318','2014-04-13','17:40:00',2.23),('10318','2014-04-13','17:45:00',1.81),('10318','2014-04-13','17:50:00',1.93),('10318','2014-04-13','17:55:00',2.18),('10318','2014-04-13','18:00:00',2.22),('10318','2014-04-13','18:05:00',2.04),('10318','2014-04-13','18:10:00',1.4),('10318','2014-04-13','18:15:00',1.2),('10318','2014-04-13','18:20:00',1.11),('10318','2013-09-18','07:45:00',1.06),('10318','2013-09-18','07:50:00',1.28),('10318','2013-09-18','07:55:00',1.48),('10318','2013-09-18','08:00:00',1.79),('10318','2013-09-18','08:05:00',2.26),('10318','2013-09-18','08:10:00',2.6),('10318','2013-09-18','08:15:00',2.8),('10318','2013-09-18','08:20:00',2.94),('10318','2013-09-18','08:25:00',2.99),('10318','2013-09-18','08:30:00',2.83),('10318','2013-09-18','08:35:00',2.6),('10318','2013-09-18','08:40:00',1.66),('10318','2013-09-18','08:45:00',2.14),('10318','2013-09-18','08:50:00',2.15),('10318','2013-09-18','08:55:00',2.86),('10318','2013-09-18','09:00:00',1.85),('10318','2013-09-18','09:05:00',1.62),('10318','2013-09-18','09:10:00',2.86),('10318','2013-09-18','09:15:00',4.69),('10318','2013-09-18','09:20:00',5.17),('10318','2013-09-18','09:25:00',2.54),('10318','2013-09-18','09:30:00',4.73),('10318','2013-09-18','09:35:00',6.55),('10318','2013-09-18','09:40:00',5.78),('10318','2013-09-18','09:45:00',7.32),('10318','2013-09-18','09:50:00',6.93),('10318','2013-09-18','09:55:00',3.64),('10318','2013-09-18','10:00:00',6.89),('10318','2013-09-18','10:05:00',6.1),('10318','2013-09-18','10:10:00',6.96),('10318','2013-09-18','10:15:00',7.14),('10318','2013-09-18','10:20:00',7.24),('10318','2013-09-18','10:25:00',7.36),('10318','2013-09-18','10:30:00',7.4),('10318','2013-09-18','10:35:00',7.53),('10318','2013-09-18','10:40:00',7.64),('10318','2013-09-18','10:45:00',7.77),('10318','2013-09-18','10:50:00',7.91),('10318','2013-09-18','10:55:00',6.81),('10318','2013-09-18','11:00:00',7.22),('10318','2013-09-18','11:05:00',5.56),('10318','2013-09-18','11:10:00',8.73),('10318','2013-09-18','11:15:00',7.15),('10318','2013-09-18','11:20:00',4.84),('10318','2013-09-18','11:25:00',6.06),('10318','2013-09-18','11:30:00',7.49),('10318','2013-09-18','11:35:00',6.01),('10318','2013-09-18','11:40:00',9.05),('10318','2013-09-18','11:45:00',8.71),('10318','2013-09-18','11:50:00',8.71),('10318','2013-09-18','11:55:00',8.89),('10318','2013-09-18','12:00:00',9.07),('10318','2013-09-18','12:05:00',8.89),('10318','2013-09-18','12:10:00',7.9),('10318','2013-09-18','12:15:00',8.82),('10318','2013-09-18','12:20:00',8.61),('10318','2013-09-18','12:25:00',8.78),('10318','2013-09-18','12:30:00',5.44),('10318','2013-09-18','12:35:00',8.39),('10318','2013-09-18','12:40:00',9.67),('10318','2013-09-18','12:45:00',9.42),('10318','2013-09-18','12:50:00',8.89),('10318','2013-09-18','12:55:00',8.07),('10318','2013-09-18','13:00:00',7.72),('10318','2013-09-18','13:05:00',6.48),('10318','2013-09-18','13:10:00',9.21),('10318','2013-09-18','13:15:00',8.98),('10318','2013-09-18','13:20:00',9.1),('10318','2013-09-18','13:25:00',9.06),('10318','2013-09-18','13:30:00',8.89),('10318','2013-09-18','13:35:00',6.07),('10318','2013-09-18','13:40:00',2.29),('10318','2013-09-18','13:45:00',3.12),('10318','2013-09-18','13:50:00',5.42),('10318','2013-09-18','13:55:00',8.45),('10318','2013-09-18','14:00:00',8.71),('10318','2013-09-18','14:05:00',8.47),('10318','2013-09-18','14:10:00',8.52),('10318','2013-09-18','14:15:00',5.41),('10318','2013-09-18','14:20:00',8.19),('10318','2013-09-18','14:25:00',8.01),('10318','2013-09-18','14:30:00',7.73),('10318','2013-09-18','14:35:00',7.73),('10318','2013-09-18','14:40:00',7.67),('10318','2013-09-18','14:45:00',7.55),('10318','2013-09-18','14:50:00',4.77),('10318','2013-09-18','14:55:00',6.78),('10318','2013-09-18','15:00:00',7.36),('10318','2013-09-18','15:05:00',7.05),('10318','2013-09-18','15:10:00',6.57),('10318','2013-09-18','15:15:00',6.87),('10318','2013-09-18','15:20:00',7.18),('10318','2013-09-18','15:25:00',6.08),('10318','2013-09-18','15:30:00',6.4),('10318','2013-09-18','15:35:00',6.69),('10318','2013-09-18','15:40:00',5.24),('10318','2013-09-18','15:45:00',6),('10318','2013-09-18','15:50:00',5.31),('10318','2013-09-18','15:55:00',2.9),('10318','2013-09-18','16:00:00',4.19),('10318','2013-09-18','16:05:00',5.11),('10318','2013-09-18','16:10:00',3.47),('10318','2013-09-18','16:15:00',4.7),('10318','2013-09-18','16:20:00',4.51),('10318','2013-09-18','16:25:00',4),('10318','2013-09-18','16:30:00',4.01),('10318','2013-09-18','16:35:00',3.56),('10318','2013-09-18','16:40:00',3.81),('10318','2013-09-18','16:45:00',3.41),('10318','2013-09-18','16:50:00',3.21),('10318','2013-09-18','16:55:00',3.03),('10318','2013-09-18','17:00:00',3.04),('10318','2013-09-18','17:05:00',2.85),('10318','2013-09-18','17:10:00',2.83),('10318','2013-09-18','17:15:00',1.82),('10318','2013-09-18','17:20:00',1.85),('10318','2013-09-18','17:25:00',2.42),('10318','2013-09-18','17:30:00',2.19),('10318','2013-09-18','17:35:00',1.95),('10318','2013-09-18','17:40:00',1.83),('10318','2013-09-18','17:45:00',1.66),('10318','2013-09-18','17:50:00',1.52),('10318','2013-09-18','17:55:00',1.37),('10318','2013-09-18','18:00:00',1.05),('10318','2013-09-17','08:15:00',1.16),('10318','2013-09-17','08:25:00',1.05),('10318','2013-09-17','08:35:00',1.19),('10318','2013-09-17','08:40:00',1.56),('10318','2013-09-17','08:45:00',1.55),('10318','2013-09-17','08:50:00',1.42),('10318','2013-09-17','08:55:00',1.28),('10318','2013-09-17','09:00:00',1.62),('10318','2013-09-17','09:05:00',1.69),('10318','2013-09-17','09:10:00',1.78),('10318','2013-09-17','09:15:00',2.03),('10318','2013-09-17','09:20:00',2),('10318','2013-09-17','09:25:00',2.26),('10318','2013-09-17','09:30:00',2.21),('10318','2013-09-17','09:35:00',1.64),('10318','2013-09-17','09:40:00',4.29),('10318','2013-09-17','09:45:00',4.77),('10318','2013-09-17','09:50:00',4.63),('10318','2013-09-17','09:55:00',2.55),('10318','2013-09-17','10:00:00',3.64),('10318','2013-09-17','10:05:00',6.05),('10318','2013-09-17','10:10:00',3.27),('10318','2013-09-17','10:15:00',1.22),('10318','2013-09-17','10:20:00',3.22),('10318','2013-09-17','10:25:00',4.02),('10318','2013-09-17','10:30:00',5.71),('10318','2013-09-17','10:35:00',3.17),('10318','2013-09-17','10:40:00',2.6),('10318','2013-09-17','10:45:00',9.28),('10318','2013-09-17','10:50:00',8.02),('10318','2013-09-17','10:55:00',6.54),('10318','2013-09-17','11:00:00',5.17),('10318','2013-09-17','11:05:00',7.25),('10318','2013-09-17','11:10:00',8.53),('10318','2013-09-17','11:15:00',6.07),('10318','2013-09-17','11:20:00',5.08),('10318','2013-09-17','11:25:00',4.17),('10318','2013-09-17','11:30:00',4.69),('10318','2013-09-17','11:35:00',7.58),('10318','2013-09-17','11:40:00',7.47),('10318','2013-09-17','11:45:00',9.74),('10318','2013-09-17','11:50:00',5.37),('10318','2013-09-17','11:55:00',8.91),('10318','2013-09-17','12:00:00',8.52),('10318','2013-09-17','12:05:00',7.6),('10318','2013-09-17','12:10:00',3.59),('10318','2013-09-17','12:15:00',7.04),('10318','2013-09-17','12:20:00',8.84),('10318','2013-09-17','12:25:00',8.79),('10318','2013-09-17','12:30:00',5.2),('10318','2013-09-17','12:35:00',5.04),('10318','2013-09-17','12:40:00',7),('10318','2013-09-17','12:45:00',3.97),('10318','2013-09-17','12:50:00',5.39),('10318','2013-09-17','12:55:00',7.27),('10318','2013-09-17','13:00:00',5.56),('10318','2013-09-17','13:05:00',5.53),('10318','2013-09-17','13:10:00',5.59),('10318','2013-09-17','13:15:00',6.38),('10318','2013-09-17','13:20:00',4.3),('10318','2013-09-17','13:25:00',4.13),('10318','2013-09-17','13:30:00',6.14),('10318','2013-09-17','13:35:00',4.79),('10318','2013-09-17','13:40:00',7.01),('10318','2013-09-17','13:45:00',4.53),('10318','2013-09-17','13:50:00',3.37),('10318','2013-09-17','13:55:00',3.17),('10318','2013-09-17','14:00:00',2.78),('10318','2013-09-17','14:05:00',1.83),('10318','2013-09-17','14:10:00',2.26),('10318','2013-09-17','14:15:00',3.08),('10318','2013-09-17','14:20:00',1.71),('10318','2013-09-17','14:25:00',2.39),('10318','2013-09-17','14:30:00',2.29),('10318','2013-09-17','14:35:00',2.52),('10318','2013-09-17','14:40:00',1.74),('10318','2013-09-17','14:45:00',2.03),('10318','2013-09-17','14:50:00',2.98),('10318','2013-09-17','14:55:00',7.14),('10318','2013-09-17','15:00:00',7.1),('10318','2013-09-17','15:05:00',6.02),('10318','2013-09-17','15:10:00',5.86),('10318','2013-09-17','15:15:00',4.53),('10318','2013-09-17','15:20:00',4.8),('10318','2013-09-17','15:25:00',3.89),('10318','2013-09-17','15:30:00',3),('10318','2013-09-17','15:35:00',2.13),('10318','2013-09-17','15:40:00',1.48),('10318','2013-09-17','15:45:00',5.62),('10318','2013-09-17','15:50:00',4.3),('10318','2013-09-17','15:55:00',3.55),('10318','2013-09-17','16:00:00',4.85),('10318','2013-09-17','16:05:00',4.02),('10318','2013-09-17','16:10:00',3.65),('10318','2013-09-17','16:15:00',3.87),('10318','2013-09-17','16:20:00',1.99),('10318','2013-09-17','16:25:00',1.33),('10318','2013-09-17','16:30:00',1.15),('10318','2013-09-17','16:35:00',1.9),('10318','2013-09-17','16:40:00',2.9),('10318','2013-09-17','16:45:00',3.26),('10318','2013-09-17','16:50:00',2.49),('10318','2013-09-17','16:55:00',2.3),('10318','2013-09-17','17:00:00',3.19),('10318','2013-09-17','17:05:00',3.38),('10318','2013-09-17','17:10:00',3.18),('10318','2013-09-17','17:15:00',3.07),('10318','2013-09-17','17:20:00',2.76),('10318','2013-09-17','17:25:00',2.69),('10318','2013-09-17','17:30:00',2.65),('10318','2013-09-17','17:35:00',2.52),('10318','2013-09-17','17:40:00',1.71),('10318','2013-09-17','17:45:00',1.46),('10318','2013-09-17','17:50:00',1.5),('10318','2013-09-17','17:55:00',1.41),('10318','2013-09-17','18:00:00',1.14),('10318','2013-09-17','18:05:00',1.02),('10318','2013-09-16','08:00:00',1.28),('10318','2013-09-16','08:05:00',2.16),('10318','2013-09-16','08:10:00',2.99),('10318','2013-09-16','08:15:00',3.08),('10318','2013-09-16','08:20:00',3.3),('10318','2013-09-16','08:25:00',3.59),('10318','2013-09-16','08:30:00',3.78),('10318','2013-09-16','08:35:00',4.05),('10318','2013-09-16','08:40:00',4.23),('10318','2013-09-16','08:45:00',4.48),('10318','2013-09-16','08:50:00',4.54),('10318','2013-09-16','08:55:00',5.05),('10318','2013-09-16','09:00:00',3.92),('10318','2013-09-16','09:05:00',4.5),('10318','2013-09-16','09:10:00',2.89),('10318','2013-09-16','09:15:00',3.42),('10318','2013-09-16','09:20:00',5.42),('10318','2013-09-16','09:25:00',5.13),('10318','2013-09-16','09:30:00',6.09),('10318','2013-09-16','09:35:00',6.24),('10318','2013-09-16','09:40:00',6.35),('10318','2013-09-16','09:45:00',6.49),('10318','2013-09-16','09:50:00',6.59),('10318','2013-09-16','09:55:00',6.34),('10318','2013-09-16','10:00:00',6.35),('10318','2013-09-16','10:05:00',7.45),('10318','2013-09-16','10:10:00',2.87),('10318','2013-09-16','10:15:00',4.28),('10318','2013-09-16','10:20:00',7.5),('10318','2013-09-16','10:25:00',7.24),('10318','2013-09-16','10:30:00',8.36),('10318','2013-09-16','10:35:00',9.09),('10318','2013-09-16','10:40:00',9.16),('10318','2013-09-16','10:45:00',2.4),('10318','2013-09-16','10:50:00',1.23),('10318','2013-09-16','10:55:00',1.25),('10318','2013-09-16','11:00:00',2.96),('10318','2013-09-16','11:05:00',7.2),('10318','2013-09-16','11:10:00',3.04),('10318','2013-09-16','11:15:00',3.11),('10318','2013-09-16','11:20:00',4.02),('10318','2013-09-16','11:25:00',9.21),('10318','2013-09-16','11:30:00',7.8),('10318','2013-09-16','11:35:00',5.37),('10318','2013-09-16','11:40:00',9.64),('10318','2013-09-16','11:45:00',9.27),('10318','2013-09-16','11:50:00',8.18),('10318','2013-09-16','11:55:00',9.18),('10318','2013-09-16','12:00:00',9.26),('10318','2013-09-16','12:05:00',8.3),('10318','2013-09-16','12:10:00',4.96),('10318','2013-09-16','12:15:00',9.82),('10318','2013-09-16','12:20:00',9.32),('10318','2013-09-16','12:25:00',9.09),('10318','2013-09-16','12:30:00',9.11),('10318','2013-09-16','12:35:00',8.98),('10318','2013-09-16','12:40:00',10.11),('10318','2013-09-16','12:45:00',4.8),('10318','2013-09-16','12:50:00',6.68),('10318','2013-09-16','12:55:00',3.24),('10318','2013-09-16','13:00:00',6.38),('10318','2013-09-16','13:05:00',6.68),('10318','2013-09-16','13:10:00',9.44),('10318','2013-09-16','13:15:00',9.07),('10318','2013-09-16','13:20:00',8.85),('10318','2013-09-16','13:25:00',8.75),('10318','2013-09-16','13:30:00',8.71),('10318','2013-09-16','13:35:00',8.73),('10318','2013-09-16','13:40:00',8.76),('10318','2013-09-16','13:45:00',8.16),('10318','2013-09-16','13:50:00',4.52),('10318','2013-09-16','13:55:00',8.35),('10318','2013-09-16','14:00:00',8.44),('10318','2013-09-16','14:05:00',8.29),('10318','2013-09-16','14:10:00',8.11),('10318','2013-09-16','14:15:00',8.02),('10318','2013-09-16','14:20:00',7.79),('10318','2013-09-16','14:25:00',7.82),('10318','2013-09-16','14:30:00',7.73),('10318','2013-09-16','14:35:00',7.62),('10318','2013-09-16','14:40:00',7.48),('10318','2013-09-16','14:45:00',7.4),('10318','2013-09-16','14:50:00',7.33),('10318','2013-09-16','14:55:00',7.27),('10318','2013-09-16','15:00:00',7.19),('10318','2013-09-16','15:05:00',7.02),('10318','2013-09-16','15:10:00',6.93),('10318','2013-09-16','15:15:00',6.79),('10318','2013-09-16','15:20:00',6.62),('10318','2013-09-16','15:25:00',6.48),('10318','2013-09-16','15:30:00',6.3),('10318','2013-09-16','15:35:00',6.15),('10318','2013-09-16','15:40:00',6.01),('10318','2013-09-16','15:45:00',5.86),('10318','2013-09-16','15:50:00',5.72),('10318','2013-09-16','15:55:00',5.6),('10318','2013-09-16','16:00:00',5.7),('10318','2013-09-16','16:05:00',5.33),('10318','2013-09-16','16:10:00',5.08),('10318','2013-09-16','16:15:00',4.92),('10318','2013-09-16','16:20:00',4.76),('10318','2013-09-16','16:25:00',4.61),('10318','2013-09-16','16:30:00',4.42),('10318','2013-09-16','16:35:00',4.19),('10318','2013-09-16','16:40:00',4.02),('10318','2013-09-16','16:45:00',3.81),('10318','2013-09-16','16:50:00',3.65),('10318','2013-09-16','16:55:00',3.46),('10318','2013-09-16','17:00:00',3.25),('10318','2013-09-16','17:05:00',3.06),('10318','2013-09-16','17:10:00',2.94),('10318','2013-09-16','17:15:00',2.76),('10318','2013-09-16','17:20:00',2.56),('10318','2013-09-16','17:25:00',2.44),('10318','2013-09-16','17:30:00',2.36),('10318','2013-09-16','17:35:00',2),('10318','2013-09-16','17:40:00',1.98),('10318','2013-09-16','17:45:00',1.88),('10318','2013-09-16','17:50:00',1.61),('10318','2013-09-16','17:55:00',1.45),('10318','2013-09-16','18:00:00',1.29),('10318','2013-09-16','18:05:00',1.17),('10318','2013-09-15','07:45:00',1.16),('10318','2013-09-15','07:50:00',1.34),('10318','2013-09-15','07:55:00',1.8),('10318','2013-09-15','08:00:00',2.17),('10318','2013-09-15','08:05:00',2.73),('10318','2013-09-15','08:10:00',2.96),('10318','2013-09-15','08:15:00',3.27),('10318','2013-09-15','08:20:00',3.56),('10318','2013-09-15','08:25:00',3.8),('10318','2013-09-15','08:30:00',4),('10318','2013-09-15','08:35:00',4.24),('10318','2013-09-15','08:40:00',4.48),('10318','2013-09-15','08:45:00',4.7),('10318','2013-09-15','08:50:00',4.64),('10318','2013-09-15','08:55:00',4.55),('10318','2013-09-15','09:00:00',4.94),('10318','2013-09-15','09:05:00',5.09),('10318','2013-09-15','09:10:00',5.34),('10318','2013-09-15','09:15:00',5.8),('10318','2013-09-15','09:20:00',5.58),('10318','2013-09-15','09:25:00',5.82),('10318','2013-09-15','09:30:00',6.01),('10318','2013-09-15','09:35:00',6.22),('10318','2013-09-15','09:40:00',6.4),('10318','2013-09-15','09:45:00',6.46),('10318','2013-09-15','09:50:00',6.41),('10318','2013-09-15','09:55:00',6.86),('10318','2013-09-15','10:00:00',6.91),('10318','2013-09-15','10:05:00',7.04),('10318','2013-09-15','10:10:00',6.72),('10318','2013-09-15','10:15:00',6.82),('10318','2013-09-15','10:20:00',7.11),('10318','2013-09-15','10:25:00',7.32),('10318','2013-09-15','10:30:00',6.81),('10318','2013-09-15','10:35:00',7.15),('10318','2013-09-15','10:40:00',8.02),('10318','2013-09-15','10:45:00',7.74),('10318','2013-09-15','10:50:00',8.12),('10318','2013-09-15','10:55:00',7.94),('10318','2013-09-15','11:00:00',3.05),('10318','2013-09-15','11:05:00',4.97),('10318','2013-09-15','11:10:00',3.9),('10318','2013-09-15','11:15:00',9.04),('10318','2013-09-15','11:20:00',9.5),('10318','2013-09-15','11:25:00',6.07),('10318','2013-09-15','11:30:00',2.78),('10318','2013-09-15','11:35:00',3.15),('10318','2013-09-15','11:40:00',9.07),('10318','2013-09-15','11:45:00',4.49),('10318','2013-09-15','11:50:00',2.81),('10318','2013-09-15','11:55:00',2.56),('10318','2013-09-15','12:00:00',3.24),('10318','2013-09-15','12:05:00',4.21),('10318','2013-09-15','12:10:00',3.96),('10318','2013-09-15','12:15:00',3.99),('10318','2013-09-15','12:20:00',3.97),('10318','2013-09-15','12:25:00',4.26),('10318','2013-09-15','12:30:00',3.48),('10318','2013-09-15','12:35:00',2.96),('10318','2013-09-15','12:40:00',2.86),('10318','2013-09-15','12:45:00',2.19),('10318','2013-09-15','12:50:00',2.49),('10318','2013-09-15','12:55:00',2.4),('10318','2013-09-15','13:00:00',2.12),('10318','2013-09-15','13:05:00',1.85),('10318','2013-09-15','13:10:00',1.77),('10318','2013-09-15','13:15:00',2.28),('10318','2013-09-15','13:20:00',3.97),('10318','2013-09-15','13:25:00',3.85),('10318','2013-09-15','13:30:00',3.17),('10318','2013-09-15','13:35:00',3.06),('10318','2013-09-15','13:40:00',3.02),('10318','2013-09-15','13:45:00',6.97),('10318','2013-09-15','13:50:00',3.82),('10318','2013-09-15','13:55:00',2.93),('10318','2013-09-15','14:00:00',5.16),('10318','2013-09-15','14:05:00',4.02),('10318','2013-09-15','14:10:00',4.05),('10318','2013-09-15','14:15:00',4.06),('10318','2013-09-15','14:20:00',3.38),('10318','2013-09-15','14:25:00',3.14),('10318','2013-09-15','14:30:00',2.87),('10318','2013-09-15','14:35:00',2.48),('10318','2013-09-15','14:40:00',2.58),('10318','2013-09-15','14:45:00',2.52),('10318','2013-09-15','14:50:00',2.48),('10318','2013-09-15','14:55:00',2.41),('10318','2013-09-15','15:00:00',2.52),('10318','2013-09-15','15:05:00',2.57),('10318','2013-09-15','15:10:00',3.31),('10318','2013-09-15','15:15:00',4.81),('10318','2013-09-15','15:20:00',3.88),('10318','2013-09-15','15:25:00',2.91),('10318','2013-09-15','15:30:00',2.3),('10318','2013-09-15','15:35:00',2.39),('10318','2013-09-15','15:40:00',2.25),('10318','2013-09-15','15:45:00',2.1),('10318','2013-09-15','15:50:00',1.96),('10318','2013-09-15','15:55:00',1.83),('10318','2013-09-15','16:00:00',1.56),('10318','2013-09-15','16:05:00',1.88),('10318','2013-09-15','16:10:00',1.47),('10318','2013-09-15','16:15:00',1.17),('10318','2013-09-15','16:20:00',1.25),('10318','2013-09-15','16:25:00',1.3),('10318','2013-09-15','16:30:00',1.39),('10318','2013-09-15','16:35:00',1.42),('10318','2013-09-15','16:40:00',1.79),('10318','2013-09-15','16:45:00',1.55),('10318','2013-09-15','16:50:00',1.2),('10318','2013-09-15','16:55:00',1.04),('10318','2013-09-15','17:00:00',1.38),('10318','2013-09-15','17:05:00',1.3),('10318','2013-09-15','17:10:00',1.2),('10318','2013-09-15','17:15:00',1.42),('10318','2013-09-15','17:20:00',1.67),('10318','2013-09-15','17:25:00',1.26),('10318','2013-09-15','17:30:00',1.34),('10318','2013-09-15','17:35:00',1.11),('10318','2013-09-15','18:00:00',1.3),('10318','2013-09-14','07:45:00',1.03),('10318','2013-09-14','07:50:00',1.26),('10318','2013-09-14','07:55:00',1.74),('10318','2013-09-14','08:00:00',2.15),('10318','2013-09-14','08:05:00',2.47),('10318','2013-09-14','08:10:00',2.87),('10318','2013-09-14','08:15:00',3.12),('10318','2013-09-14','08:20:00',3.44),('10318','2013-09-14','08:25:00',3.61),('10318','2013-09-14','08:30:00',3.85),('10318','2013-09-14','08:35:00',4.08),('10318','2013-09-14','08:40:00',4.29),('10318','2013-09-14','08:45:00',4.5),('10318','2013-09-14','08:50:00',4.63),('10318','2013-09-14','08:55:00',4.81),('10318','2013-09-14','09:00:00',5.01),('10318','2013-09-14','09:05:00',5.19),('10318','2013-09-14','09:10:00',5.41),('10318','2013-09-14','09:15:00',5.56),('10318','2013-09-14','09:20:00',4.35),('10318','2013-09-14','09:25:00',4.44),('10318','2013-09-14','09:30:00',6.06),('10318','2013-09-14','09:35:00',6.22),('10318','2013-09-14','09:40:00',6.28),('10318','2013-09-14','09:45:00',6.51),('10318','2013-09-14','09:50:00',6.6),('10318','2013-09-14','09:55:00',6.81),('10318','2013-09-14','10:00:00',6.91),('10318','2013-09-14','10:05:00',6.63),('10318','2013-09-14','10:10:00',6.69),('10318','2013-09-14','10:15:00',6.8),('10318','2013-09-14','10:20:00',7.16),('10318','2013-09-14','10:25:00',7.12),('10318','2013-09-14','10:30:00',7.5),('10318','2013-09-14','10:35:00',7.5),('10318','2013-09-14','10:40:00',7.94),('10318','2013-09-14','10:45:00',6.78),('10318','2013-09-14','10:50:00',1.6),('10318','2013-09-14','10:55:00',1.2),('10318','2013-09-14','11:00:00',1.48),('10318','2013-09-14','11:05:00',6.81),('10318','2013-09-14','11:10:00',8.79),('10318','2013-09-14','11:15:00',8.38),('10318','2013-09-14','11:20:00',8.05),('10318','2013-09-14','11:25:00',8.8),('10318','2013-09-14','11:30:00',6.83),('10318','2013-09-14','11:35:00',9.01),('10318','2013-09-14','11:40:00',8.63),('10318','2013-09-14','11:45:00',6.16),('10318','2013-09-14','11:50:00',3.5),('10318','2013-09-14','11:55:00',5.43),('10318','2013-09-14','12:00:00',3.76),('10318','2013-09-14','12:05:00',9.84),('10318','2013-09-14','12:10:00',9.78),('10318','2013-09-14','12:15:00',9.57),('10318','2013-09-14','12:20:00',9.26),('10318','2013-09-14','12:25:00',9),('10318','2013-09-14','12:30:00',9.31),('10318','2013-09-14','12:35:00',4.73),('10318','2013-09-14','12:40:00',8.39),('10318','2013-09-14','12:45:00',9.21),('10318','2013-09-14','12:50:00',9.47),('10318','2013-09-14','12:55:00',9.5),('10318','2013-09-14','13:00:00',6.05),('10318','2013-09-14','13:05:00',7.77),('10318','2013-09-14','13:10:00',9.27),('10318','2013-09-14','13:15:00',9.19),('10318','2013-09-14','13:20:00',9.04),('10318','2013-09-14','13:25:00',9),('10318','2013-09-14','13:30:00',7.43),('10318','2013-09-14','13:35:00',7.84),('10318','2013-09-14','13:40:00',4.08),('10318','2013-09-14','13:45:00',8.66),('10318','2013-09-14','13:50:00',8.66),('10318','2013-09-14','13:55:00',8.99),('10318','2013-09-14','14:00:00',8.6),('10318','2013-09-14','14:05:00',8.27),('10318','2013-09-14','14:10:00',8.16),('10318','2013-09-14','14:15:00',7.97),('10318','2013-09-14','14:20:00',7.95),('10318','2013-09-14','14:25:00',7.68),('10318','2013-09-14','14:30:00',7.77),('10318','2013-09-14','14:35:00',7.71),('10318','2013-09-14','14:40:00',7.62),('10318','2013-09-14','14:45:00',7.47),('10318','2013-09-14','14:50:00',7.25),('10318','2013-09-14','14:55:00',7.21),('10318','2013-09-14','15:00:00',7.06),('10318','2013-09-14','15:05:00',6.95),('10318','2013-09-14','15:10:00',6.85),('10318','2013-09-14','15:15:00',6.71),('10318','2013-09-14','15:20:00',6.55),('10318','2013-09-14','15:25:00',6.38),('10318','2013-09-14','15:30:00',6.3),('10318','2013-09-14','15:35:00',6.05),('10318','2013-09-14','15:40:00',6.06),('10318','2013-09-14','15:45:00',5.85),('10318','2013-09-14','15:50:00',5.72),('10318','2013-09-14','15:55:00',5.54),('10318','2013-09-14','16:00:00',5.39),('10318','2013-09-14','16:05:00',5.25),('10318','2013-09-14','16:10:00',5.13),('10318','2013-09-14','16:15:00',4.91),('10318','2013-09-14','16:20:00',4.77),('10318','2013-09-14','16:25:00',4.57),('10318','2013-09-14','16:30:00',2.98),('10318','2013-09-14','16:35:00',3.71),('10318','2013-09-14','16:40:00',3.93),('10318','2013-09-14','16:45:00',3.9),('10318','2013-09-14','16:50:00',3.51),('10318','2013-09-14','16:55:00',3.17),('10318','2013-09-14','17:00:00',3.5),('10318','2013-09-14','17:05:00',3.18),('10318','2013-09-14','17:10:00',2.99),('10318','2013-09-14','17:15:00',2.82),('10318','2013-09-14','17:20:00',2.64),('10318','2013-09-14','17:25:00',2.46),('10318','2013-09-14','17:30:00',2.32),('10318','2013-09-14','17:35:00',2.12),('10318','2013-09-14','17:40:00',1.98),('10318','2013-09-14','17:45:00',1.82),('10318','2013-09-14','17:50:00',1.72),('10318','2013-09-14','17:55:00',1.55),('10318','2013-09-14','18:00:00',1.38),('10318','2013-09-14','18:05:00',1.25),('10318','2013-09-14','18:10:00',1.15),('10318','2013-09-13','08:10:00',1.1),('10318','2013-09-13','08:15:00',1.31),('10318','2013-09-13','08:20:00',1.45),('10318','2013-09-13','08:25:00',1.64),('10318','2013-09-13','08:30:00',1.53),('10318','2013-09-13','08:35:00',1.56),('10318','2013-09-13','08:40:00',1.76),('10318','2013-09-13','08:45:00',2),('10318','2013-09-13','08:50:00',2.29),('10318','2013-09-13','08:55:00',2.26),('10318','2013-09-13','09:00:00',2.13),('10318','2013-09-13','09:05:00',2.04),('10318','2013-09-13','09:10:00',1.94),('10318','2013-09-13','09:15:00',2.06),('10318','2013-09-13','09:20:00',2.29),('10318','2013-09-13','09:25:00',2.54),('10318','2013-09-13','09:30:00',2.69),('10318','2013-09-13','09:35:00',4.12),('10318','2013-09-13','09:40:00',3.07),('10318','2013-09-13','09:45:00',2.92),('10318','2013-09-13','09:50:00',3.18),('10318','2013-09-13','09:55:00',4.4),('10318','2013-09-13','10:00:00',4.58),('10318','2013-09-13','10:05:00',6.41),('10318','2013-09-13','10:10:00',8.86),('10318','2013-09-13','10:15:00',6.25),('10318','2013-09-13','10:20:00',3.09),('10318','2013-09-13','10:25:00',6.88),('10318','2013-09-13','10:30:00',5.98),('10318','2013-09-13','10:35:00',7.37),('10318','2013-09-13','10:40:00',7.7),('10318','2013-09-13','10:45:00',8.04),('10318','2013-09-13','10:50:00',8.06),('10318','2013-09-13','10:55:00',8.11),('10318','2013-09-13','11:00:00',8.17),('10318','2013-09-13','11:05:00',8.27),('10318','2013-09-13','11:10:00',8.29),('10318','2013-09-13','11:15:00',8.34),('10318','2013-09-13','11:20:00',8.4),('10318','2013-09-13','11:25:00',8.44),('10318','2013-09-13','11:30:00',8.44),('10318','2013-09-13','11:35:00',8.48),('10318','2013-09-13','11:40:00',8.59),('10318','2013-09-13','11:45:00',8.65),('10318','2013-09-13','11:50:00',8.72),('10318','2013-09-13','11:55:00',8.69),('10318','2013-09-13','12:00:00',8.58),('10318','2013-09-13','12:05:00',8.69),('10318','2013-09-13','12:10:00',8.9),('10318','2013-09-13','12:15:00',9.02),('10318','2013-09-13','12:20:00',9.03),('10318','2013-09-13','12:25:00',4.3),('10318','2013-09-13','12:30:00',8.68),('10318','2013-09-13','12:35:00',8.57),('10318','2013-09-13','12:40:00',2.97),('10318','2013-09-13','12:45:00',9.51),('10318','2013-09-13','12:50:00',9.33),('10318','2013-09-13','12:55:00',9.06),('10318','2013-09-13','13:00:00',8.96),('10318','2013-09-13','13:05:00',8.93),('10318','2013-09-13','13:10:00',8.77),('10318','2013-09-13','13:15:00',8.7),('10318','2013-09-13','13:20:00',8.72),('10318','2013-09-13','13:25:00',8.57),('10318','2013-09-13','13:30:00',8.5),('10318','2013-09-13','13:35:00',8.49),('10318','2013-09-13','13:40:00',8.49),('10318','2013-09-13','13:45:00',8.32),('10318','2013-09-13','13:50:00',8.33),('10318','2013-09-13','13:55:00',8.28),('10318','2013-09-13','14:00:00',8.26),('10318','2013-09-13','14:05:00',8.22),('10318','2013-09-13','14:10:00',8.01),('10318','2013-09-13','14:15:00',7.47),('10318','2013-09-13','14:20:00',7.77),('10318','2013-09-13','14:25:00',7.84),('10318','2013-09-13','14:30:00',7.75),('10318','2013-09-13','14:35:00',7.72),('10318','2013-09-13','14:40:00',7.45),('10318','2013-09-13','14:45:00',7.36),('10318','2013-09-13','14:50:00',7.35),('10318','2013-09-13','14:55:00',7.22),('10318','2013-09-13','15:00:00',7.12),('10318','2013-09-13','15:05:00',7.13),('10318','2013-09-13','15:10:00',6.97),('10318','2013-09-13','15:15:00',6.78),('10318','2013-09-13','15:20:00',6.67),('10318','2013-09-13','15:25:00',6.58),('10318','2013-09-13','15:30:00',6.28),('10318','2013-09-13','15:35:00',6.31),('10318','2013-09-13','15:40:00',6.14),('10318','2013-09-13','15:45:00',5.98),('10318','2013-09-13','15:50:00',5.86),('10318','2013-09-13','15:55:00',5.68),('10318','2013-09-13','16:00:00',5.51),('10318','2013-09-13','16:05:00',5.34),('10318','2013-09-13','16:10:00',5.19),('10318','2013-09-13','16:15:00',4.98),('10318','2013-09-13','16:20:00',4.78),('10318','2013-09-13','16:25:00',4.63),('10318','2013-09-13','16:30:00',4.44),('10318','2013-09-13','16:35:00',4.27),('10318','2013-09-13','16:40:00',4.09),('10318','2013-09-13','16:45:00',3.9),('10318','2013-09-13','16:50:00',3.68),('10318','2013-09-13','16:55:00',3.54),('10318','2013-09-13','17:00:00',3.37),('10318','2013-09-13','17:05:00',3.17),('10318','2013-09-13','17:10:00',2.99),('10318','2013-09-13','17:15:00',2.83),('10318','2013-09-13','17:20:00',2.63),('10318','2013-09-13','17:25:00',2.49),('10318','2013-09-13','17:30:00',2.32),('10318','2013-09-13','17:35:00',2.16),('10318','2013-09-13','17:40:00',2.02),('10318','2013-09-13','17:45:00',1.85),('10318','2013-09-13','17:50:00',1.68),('10318','2013-09-13','17:55:00',1.54),('10318','2013-09-13','18:00:00',1.39),('10318','2013-09-13','18:05:00',1.23),('10318','2013-09-13','18:10:00',1.09),('10318','2013-09-12','07:50:00',1.48),('10318','2013-09-12','07:55:00',2.02),('10318','2013-09-12','08:00:00',1.77),('10318','2013-09-12','08:05:00',1.9),('10318','2013-09-12','08:10:00',2.34),('10318','2013-09-12','08:15:00',2.29),('10318','2013-09-12','08:20:00',3.22),('10318','2013-09-12','08:25:00',4.27),('10318','2013-09-12','08:30:00',3.95),('10318','2013-09-12','08:35:00',2.42),('10318','2013-09-12','08:40:00',1.69),('10318','2013-09-12','08:45:00',1.82),('10318','2013-09-12','08:50:00',3.07),('10318','2013-09-12','08:55:00',4.73),('10318','2013-09-12','09:00:00',5.03),('10318','2013-09-12','09:05:00',3.64),('10318','2013-09-12','09:10:00',4.05),('10318','2013-09-12','09:15:00',4.86),('10318','2013-09-12','09:20:00',4.82),('10318','2013-09-12','09:25:00',5.47),('10318','2013-09-12','09:30:00',5.71),('10318','2013-09-12','09:35:00',4.51),('10318','2013-09-12','09:40:00',3.95),('10318','2013-09-12','09:45:00',4.46),('10318','2013-09-12','09:50:00',2.83),('10318','2013-09-12','09:55:00',2.16),('10318','2013-09-12','10:00:00',2.66),('10318','2013-09-12','10:05:00',4.71),('10318','2013-09-12','10:10:00',5.04),('10318','2013-09-12','10:15:00',4.56),('10318','2013-09-12','10:20:00',2.88),('10318','2013-09-12','10:25:00',3.53),('10318','2013-09-12','10:30:00',3.3),('10318','2013-09-12','10:35:00',2.52),('10318','2013-09-12','10:40:00',1.22),('10318','2013-09-12','10:45:00',2.24),('10318','2013-09-12','10:50:00',4.2),('10318','2013-09-12','10:55:00',5.89),('10318','2013-09-12','11:00:00',7.73),('10318','2013-09-12','11:05:00',9.69),('10318','2013-09-12','11:10:00',8.87),('10318','2013-09-12','11:15:00',2.62),('10318','2013-09-12','11:35:00',2.16),('10318','2013-09-12','11:40:00',3.1),('10318','2013-09-12','11:45:00',3.41),('10318','2013-09-12','11:50:00',8.13),('10318','2013-09-12','11:55:00',9.61),('10318','2013-09-12','12:00:00',8.38),('10318','2013-09-12','12:05:00',9.37),('10318','2013-09-12','12:10:00',10),('10318','2013-09-12','12:15:00',7.48),('10318','2013-09-12','12:20:00',3.56),('10318','2013-09-12','12:25:00',4.47),('10318','2013-09-12','12:30:00',7.09),('10318','2013-09-12','12:35:00',9.79),('10318','2013-09-12','12:40:00',5.21),('10318','2013-09-12','12:45:00',4.75),('10318','2013-09-12','12:50:00',7.46),('10318','2013-09-12','12:55:00',8),('10318','2013-09-12','13:00:00',9.81),('10318','2013-09-12','13:05:00',7.38),('10318','2013-09-12','13:10:00',7.59),('10318','2013-09-12','13:15:00',8.44),('10318','2013-09-12','13:20:00',8.92),('10318','2013-09-12','13:25:00',8.92),('10318','2013-09-12','13:30:00',10.02),('10318','2013-09-12','13:35:00',6.1),('10318','2013-09-12','13:40:00',9.53),('10318','2013-09-12','13:45:00',9.08),('10318','2013-09-12','13:50:00',8.45),('10318','2013-09-12','13:55:00',8.55),('10318','2013-09-12','14:00:00',7.64),('10318','2013-09-12','14:05:00',8.76),('10318','2013-09-12','14:10:00',7.95),('10318','2013-09-12','14:15:00',8.87),('10318','2013-09-12','14:20:00',8.58),('10318','2013-09-12','14:25:00',8.34),('10318','2013-09-12','14:30:00',7.85),('10318','2013-09-12','14:35:00',5.62),('10318','2013-09-12','14:40:00',7.69),('10318','2013-09-12','14:45:00',7.61),('10318','2013-09-12','14:50:00',7.78),('10318','2013-09-12','14:55:00',7.67),('10318','2013-09-12','15:00:00',6.06),('10318','2013-09-12','15:05:00',7.55),('10318','2013-09-12','15:10:00',7.19),('10318','2013-09-12','15:15:00',7.04),('10318','2013-09-12','15:20:00',6.85),('10318','2013-09-12','15:25:00',6.75),('10318','2013-09-12','15:30:00',6.59),('10318','2013-09-12','15:35:00',6.43),('10318','2013-09-12','15:40:00',6.27),('10318','2013-09-12','15:45:00',6.15),('10318','2013-09-12','15:50:00',4.88),('10318','2013-09-12','15:55:00',6.03),('10318','2013-09-12','16:00:00',5.75),('10318','2013-09-12','16:05:00',5.4),('10318','2013-09-12','16:10:00',5.74),('10318','2013-09-12','16:15:00',3.15),('10318','2013-09-12','16:20:00',4.44),('10318','2013-09-12','16:25:00',1.98),('10318','2013-09-12','16:30:00',4.43),('10318','2013-09-12','16:35:00',4.48),('10318','2013-09-12','16:40:00',3.7),('10318','2013-09-12','16:45:00',3.99),('10318','2013-09-12','16:50:00',4.14),('10318','2013-09-12','16:55:00',3.64),('10318','2013-09-12','17:00:00',4.04),('10318','2013-09-12','17:05:00',3.19),('10318','2013-09-12','17:10:00',3.48),('10318','2013-09-12','17:15:00',3.26),('10318','2013-09-12','17:20:00',2.88),('10318','2013-09-12','17:25:00',2.72),('10318','2013-09-12','17:30:00',2.46),('10318','2013-09-12','17:35:00',1.62),('10318','2013-09-12','17:40:00',1.82),('10318','2013-09-12','17:45:00',1.96),('10318','2013-09-12','17:50:00',1.79),('10318','2013-09-12','17:55:00',1.62),('10318','2013-09-12','18:00:00',1.39),('10318','2013-09-12','18:05:00',1.48),('10318','2013-09-12','18:10:00',1.37),('10318','2013-09-12','18:15:00',1.09),('10318','2013-09-11','08:00:00',2.74),('10318','2013-09-11','08:05:00',2.96),('10318','2013-09-11','08:10:00',1.93),('10318','2013-09-11','08:15:00',1.56),('10318','2013-09-11','08:20:00',1.34),('10318','2013-09-11','08:25:00',1.99),('10318','2013-09-11','08:30:00',1.85),('10318','2013-09-11','08:35:00',1.52),('10318','2013-09-11','08:40:00',1.35),('10318','2013-09-11','08:45:00',1.56),('10318','2013-09-11','08:50:00',1.77),('10318','2013-09-11','08:55:00',2.08),('10318','2013-09-11','09:00:00',3.56),('10318','2013-09-11','09:05:00',4.94),('10318','2013-09-11','09:10:00',5.66),('10318','2013-09-11','09:15:00',4.96),('10318','2013-09-11','09:20:00',4.82),('10318','2013-09-11','09:25:00',2.74),('10318','2013-09-11','09:30:00',2.72),('10318','2013-09-11','09:35:00',2.54),('10318','2013-09-11','09:40:00',1.7),('10318','2013-09-11','09:45:00',1.49),('10318','2013-09-11','09:50:00',1.73),('10318','2013-09-11','09:55:00',2.17),('10318','2013-09-11','10:00:00',2.32),('10318','2013-09-11','10:05:00',2.53),('10318','2013-09-11','10:10:00',5.57),('10318','2013-09-11','10:15:00',7.49),('10318','2013-09-11','10:20:00',7.49),('10318','2013-09-11','10:25:00',7.56),('10318','2013-09-11','10:30:00',7.87),('10318','2013-09-11','10:35:00',6.6),('10318','2013-09-11','10:40:00',8.37),('10318','2013-09-11','10:45:00',6.12),('10318','2013-09-11','10:50:00',7.18),('10318','2013-09-11','10:55:00',2.53),('10318','2013-09-11','11:00:00',2.23),('10318','2013-09-11','11:05:00',6.39),('10318','2013-09-11','11:10:00',9.39),('10318','2013-09-11','11:15:00',7.71),('10318','2013-09-11','11:20:00',8.45),('10318','2013-09-11','11:25:00',8.85),('10318','2013-09-11','11:30:00',8.28),('10318','2013-09-11','11:35:00',8.99),('10318','2013-09-11','11:40:00',8.71),('10318','2013-09-11','11:45:00',8.9),('10318','2013-09-11','11:50:00',9.15),('10318','2013-09-11','11:55:00',6.97),('10318','2013-09-11','12:00:00',9.57),('10318','2013-09-11','12:05:00',7.75),('10318','2013-09-11','12:10:00',5.23),('10318','2013-09-11','12:15:00',8.39),('10318','2013-09-11','12:20:00',8.21),('10318','2013-09-11','12:25:00',6.86),('10318','2013-09-11','12:30:00',9.04),('10318','2013-09-11','12:35:00',4.8),('10318','2013-09-11','12:40:00',2.66),('10318','2013-09-11','12:45:00',5.37),('10318','2013-09-11','12:50:00',2.46),('10318','2013-09-11','12:55:00',9.17),('10318','2013-09-11','13:00:00',8.11),('10318','2013-09-11','13:05:00',9.05),('10318','2013-09-11','13:10:00',5.29),('10318','2013-09-11','13:15:00',5.05),('10318','2013-09-11','13:20:00',8.93),('10318','2013-09-11','13:25:00',9.42),('10318','2013-09-11','13:30:00',6.53),('10318','2013-09-11','13:35:00',8.09),('10318','2013-09-11','13:40:00',5.3),('10318','2013-09-11','13:45:00',9.55),('10318','2013-09-11','13:50:00',7.95),('10318','2013-09-11','13:55:00',6.24),('10318','2013-09-11','14:00:00',8.9),('10318','2013-09-11','14:05:00',8.4),('10318','2013-09-11','14:10:00',8.37),('10318','2013-09-11','14:15:00',8.21),('10318','2013-09-11','14:20:00',8.38),('10318','2013-09-11','14:25:00',7.07),('10318','2013-09-11','14:30:00',8.36),('10318','2013-09-11','14:35:00',6.03),('10318','2013-09-11','14:40:00',4.45),('10318','2013-09-11','14:45:00',4.45),('10318','2013-09-11','14:50:00',8.12),('10318','2013-09-11','14:55:00',8.19),('10318','2013-09-11','15:00:00',3.95),('10318','2013-09-11','15:05:00',7.81),('10318','2013-09-11','15:10:00',4.31),('10318','2013-09-11','15:15:00',2.5),('10318','2013-09-11','15:20:00',8.17),('10318','2013-09-11','15:25:00',4.34),('10318','2013-09-11','15:30:00',2.13),('10318','2013-09-11','15:35:00',2.68),('10318','2013-09-11','15:40:00',4.49),('10318','2013-09-11','15:45:00',5.6),('10318','2013-09-11','15:50:00',5.2),('10318','2013-09-11','15:55:00',4.66),('10318','2013-09-11','16:00:00',3.09),('10318','2013-09-11','16:05:00',2.83),('10318','2013-09-11','16:10:00',3.12),('10318','2013-09-11','16:15:00',4.93),('10318','2013-09-11','16:20:00',5.12),('10318','2013-09-11','16:25:00',2.72),('10318','2013-09-11','16:30:00',1.75),('10318','2013-09-11','16:35:00',4.04),('10318','2013-09-11','16:40:00',1.51),('10318','2013-09-11','16:45:00',3.5),('10318','2013-09-11','16:50:00',3.62),('10318','2013-09-11','16:55:00',3.86),('10318','2013-09-11','17:00:00',2.77),('10318','2013-09-11','17:05:00',2.74),('10318','2013-09-11','17:10:00',3.11),('10318','2013-09-11','17:15:00',2.9),('10318','2013-09-11','17:20:00',2.72),('10318','2013-09-11','17:25:00',2.6),('10318','2013-09-11','17:30:00',1.3),('10318','2013-09-11','17:35:00',1.58),('10318','2013-09-11','17:40:00',1.34),('10318','2013-09-11','17:45:00',1.75),('10318','2013-09-11','17:50:00',1.87),('10318','2013-09-11','17:55:00',1.51),('10318','2013-09-11','18:00:00',1.46),('10318','2013-09-11','18:05:00',1.33),('10318','2013-09-11','18:10:00',1.13),('10318','2013-09-10','07:50:00',1.39),('10318','2013-09-10','07:55:00',1.84),('10318','2013-09-10','08:00:00',1.94),('10318','2013-09-10','08:10:00',2),('10318','2013-09-10','08:15:00',2.21),('10318','2013-09-10','08:20:00',1.87),('10318','2013-09-10','08:25:00',1.5),('10318','2013-09-10','08:30:00',1.54),('10318','2013-09-10','08:35:00',1.89),('10318','2013-09-10','08:40:00',1.51),('10318','2013-09-10','08:45:00',1.65),('10318','2013-09-10','08:50:00',3.61),('10318','2013-09-10','08:55:00',3.47),('10318','2013-09-10','09:00:00',4.66),('10318','2013-09-10','09:05:00',5.55),('10318','2013-09-10','09:10:00',6.17),('10318','2013-09-10','09:15:00',4.18),('10318','2013-09-10','09:20:00',3.99),('10318','2013-09-10','09:25:00',4.24),('10318','2013-09-10','09:30:00',7.1),('10318','2013-09-10','09:35:00',5.62),('10318','2013-09-10','09:40:00',3.32),('10318','2013-09-10','09:45:00',2.79),('10318','2013-09-10','09:50:00',2.73),('10318','2013-09-10','09:55:00',2.24),('10318','2013-09-10','10:00:00',1.52),('10318','2013-09-10','10:05:00',1.26),('10318','2013-09-10','10:10:00',1.29),('10318','2013-09-10','10:15:00',1.39),('10318','2013-09-10','10:20:00',1.99),('10318','2013-09-10','10:25:00',2.27),('10318','2013-09-10','10:30:00',2.12),('10318','2013-09-10','10:35:00',2.54),('10318','2013-09-10','10:40:00',3.53),('10318','2013-09-10','10:45:00',3.96),('10318','2013-09-10','10:50:00',2.72),('10318','2013-09-10','10:55:00',3.12),('10318','2013-09-10','11:00:00',4.17),('10318','2013-09-10','11:05:00',2.79),('10318','2013-09-10','11:10:00',2.95),('10318','2013-09-10','11:15:00',2.61),('10318','2013-09-10','11:20:00',2.7),('10318','2013-09-10','11:25:00',1.84),('10318','2013-09-10','11:30:00',2.04),('10318','2013-09-10','11:35:00',1.44),('10318','2013-09-10','11:40:00',1.87),('10318','2013-09-10','11:45:00',2.53),('10318','2013-09-10','11:50:00',2.71),('10318','2013-09-10','11:55:00',3.61),('10318','2013-09-10','12:00:00',3.53),('10318','2013-09-10','12:05:00',2.62),('10318','2013-09-10','12:10:00',2.68),('10318','2013-09-10','12:15:00',3.6),('10318','2013-09-10','12:20:00',3.27),('10318','2013-09-10','12:25:00',2.71),('10318','2013-09-10','12:30:00',2.23),('10318','2013-09-10','12:35:00',1.82),('10318','2013-09-10','12:40:00',1.26),('10318','2013-09-10','12:45:00',1.45),('10318','2013-09-10','12:50:00',1.51),('10318','2013-09-10','12:55:00',1.65),('10318','2013-09-10','13:00:00',1.8),('10318','2013-09-10','13:05:00',1.65),('10318','2013-09-10','13:10:00',1.6),('10318','2013-09-10','13:15:00',2.08),('10318','2013-09-10','13:20:00',2.08),('10318','2013-09-10','13:25:00',2.45),('10318','2013-09-10','13:30:00',2.18),('10318','2013-09-10','13:35:00',2.62),('10318','2013-09-10','13:40:00',4.37),('10318','2013-09-10','13:45:00',5.7),('10318','2013-09-10','13:50:00',4.08),('10318','2013-09-10','13:55:00',3.4),('10318','2013-09-10','14:00:00',2.66),('10318','2013-09-10','14:05:00',2.81),('10318','2013-09-10','14:10:00',2.99),('10318','2013-09-10','14:15:00',3.56),('10318','2013-09-10','14:20:00',3.67),('10318','2013-09-10','14:25:00',5.24),('10318','2013-09-10','14:30:00',4.33),('10318','2013-09-10','14:35:00',3.09),('10318','2013-09-10','14:40:00',3.54),('10318','2013-09-10','14:45:00',4.09),('10318','2013-09-10','14:50:00',4.96),('10318','2013-09-10','14:55:00',4.11),('10318','2013-09-10','15:00:00',5.53),('10318','2013-09-10','15:05:00',4.71),('10318','2013-09-10','15:10:00',4.54),('10318','2013-09-10','15:15:00',2.86),('10318','2013-09-10','15:20:00',3.92),('10318','2013-09-10','15:25:00',3.56),('10318','2013-09-10','15:30:00',4.68),('10318','2013-09-10','15:35:00',3.83),('10318','2013-09-10','15:40:00',2.68),('10318','2013-09-10','15:45:00',2.37),('10318','2013-09-10','15:50:00',2.41),('10318','2013-09-10','15:55:00',2.17),('10318','2013-09-10','16:00:00',2.03),('10318','2013-09-10','16:05:00',2.15),('10318','2013-09-10','16:10:00',2.92),('10318','2013-09-10','16:15:00',3.03),('10318','2013-09-10','16:20:00',2.09),('10318','2013-09-10','16:25:00',1.94),('10318','2013-09-10','16:30:00',1.6),('10318','2013-09-10','16:35:00',1.01),('10318','2013-09-10','16:40:00',1.05),('10318','2013-09-10','16:45:00',1.64),('10318','2013-09-10','16:50:00',1.91),('10318','2013-09-10','16:55:00',1.78),('10318','2013-09-10','17:00:00',1.54),('10318','2013-09-10','17:05:00',1.38),('10318','2013-09-10','17:10:00',1.36),('10318','2013-09-10','17:15:00',1.76),('10318','2013-09-10','17:20:00',1.68),('10318','2013-09-10','17:25:00',1.61),('10318','2013-09-10','17:30:00',1.45),('10318','2013-09-10','17:35:00',1.22),('10318','2013-09-10','17:40:00',1.28),('10318','2013-09-10','17:45:00',1.48),('10318','2013-09-10','17:50:00',1.61),('10318','2013-09-10','17:55:00',1.27),('10318','2013-09-10','18:00:00',1.09),('10318','2013-09-09','07:30:00',1.24),('10318','2013-09-09','07:35:00',1.65),('10318','2013-09-09','07:40:00',2.12),('10318','2013-09-09','07:45:00',2.22),('10318','2013-09-09','07:50:00',2.11),('10318','2013-09-09','07:55:00',2.09),('10318','2013-09-09','08:00:00',1.79),('10318','2013-09-09','08:05:00',1.23),('10318','2013-09-09','08:10:00',1.11),('10318','2013-09-09','08:15:00',1.17),('10318','2013-09-09','08:20:00',1.24),('10318','2013-09-09','08:25:00',1.28),('10318','2013-09-09','08:30:00',1.21),('10318','2013-09-09','08:35:00',1.26),('10318','2013-09-09','08:40:00',1.57),('10318','2013-09-09','08:45:00',1.94),('10318','2013-09-09','08:50:00',2.26),('10318','2013-09-09','08:55:00',2.65),('10318','2013-09-09','09:00:00',2.76),('10318','2013-09-09','09:05:00',2.43),('10318','2013-09-09','09:10:00',2.13),('10318','2013-09-09','09:15:00',1.65),('10318','2013-09-09','09:20:00',1.8),('10318','2013-09-09','09:30:00',1.62),('10318','2013-09-09','09:35:00',2.23),('10318','2013-09-09','09:40:00',1.57),('10318','2013-09-09','09:50:00',1.61),('10318','2013-09-09','09:55:00',2.44),('10318','2013-09-09','10:00:00',3.26),('10318','2013-09-09','10:05:00',3.82),('10318','2013-09-09','10:10:00',4),('10318','2013-09-09','10:15:00',3.92),('10318','2013-09-09','10:20:00',3.42),('10318','2013-09-09','10:25:00',2.81),('10318','2013-09-09','10:30:00',3.29),('10318','2013-09-09','10:35:00',4.03),('10318','2013-09-09','10:40:00',4.01),('10318','2013-09-09','10:45:00',4.03),('10318','2013-09-09','10:50:00',6.69),('10318','2013-09-09','10:55:00',5.95),('10318','2013-09-09','11:00:00',5.99),('10318','2013-09-09','11:05:00',4.09),('10318','2013-09-09','11:10:00',3.84),('10318','2013-09-09','11:15:00',4.67),('10318','2013-09-09','11:20:00',3.18),('10318','2013-09-09','11:25:00',3.06),('10318','2013-09-09','11:30:00',3.41),('10318','2013-09-09','11:35:00',5.27),('10318','2013-09-09','11:40:00',5.98),('10318','2013-09-09','11:45:00',3.08),('10318','2013-09-09','11:50:00',4.02),('10318','2013-09-09','11:55:00',7.49),('10318','2013-09-09','12:00:00',4.11),('10318','2013-09-09','12:05:00',2.8),('10318','2013-09-09','12:10:00',3.32),('10318','2013-09-09','12:15:00',2.97),('10318','2013-09-09','12:20:00',2.05),('10318','2013-09-09','12:25:00',1.83),('10318','2013-09-09','12:30:00',2.15),('10318','2013-09-09','12:35:00',2.59),('10318','2013-09-09','12:40:00',4.53),('10318','2013-09-09','12:45:00',3.23),('10318','2013-09-09','12:50:00',2.54),('10318','2013-09-09','12:55:00',2.46),('10318','2013-09-09','13:00:00',3.1),('10318','2013-09-09','13:05:00',5.88),('10318','2013-09-09','13:10:00',7.77),('10318','2013-09-09','13:15:00',6.63),('10318','2013-09-09','13:20:00',6.55),('10318','2013-09-09','13:25:00',6.24),('10318','2013-09-09','13:30:00',8.28),('10318','2013-09-09','13:35:00',8.69),('10318','2013-09-09','13:40:00',8.03),('10318','2013-09-09','13:45:00',8.7),('10318','2013-09-09','13:50:00',8.83),('10318','2013-09-09','13:55:00',6.95),('10318','2013-09-09','14:00:00',7.58),('10318','2013-09-09','14:05:00',7.58),('10318','2013-09-09','14:10:00',4.76),('10318','2013-09-09','14:15:00',5.18),('10318','2013-09-09','14:20:00',3.28),('10318','2013-09-09','14:25:00',2.91),('10318','2013-09-09','14:30:00',4.12),('10318','2013-09-09','14:35:00',5.54),('10318','2013-09-09','14:40:00',7.53),('10318','2013-09-09','14:45:00',4.56),('10318','2013-09-09','14:50:00',4.39),('10318','2013-09-09','14:55:00',5.79),('10318','2013-09-09','15:00:00',5.69),('10318','2013-09-09','15:05:00',6.2),('10318','2013-09-09','15:10:00',7.66),('10318','2013-09-09','15:15:00',6.9),('10318','2013-09-09','15:20:00',6.67),('10318','2013-09-09','15:25:00',3.6),('10318','2013-09-09','15:30:00',5.25),('10318','2013-09-09','15:35:00',4.25),('10318','2013-09-09','15:40:00',4.25),('10318','2013-09-09','15:45:00',3.1),('10318','2013-09-09','15:50:00',3.38),('10318','2013-09-09','15:55:00',2.84),('10318','2013-09-09','16:00:00',2.83),('10318','2013-09-09','16:05:00',2.75),('10318','2013-09-09','16:10:00',4.07),('10318','2013-09-09','16:15:00',3.02),('10318','2013-09-09','16:20:00',3.91),('10318','2013-09-09','16:25:00',2.2),('10318','2013-09-09','16:30:00',2.28),('10318','2013-09-09','16:35:00',2.86),('10318','2013-09-09','16:40:00',2.61),('10318','2013-09-09','16:45:00',3.06),('10318','2013-09-09','16:50:00',1.65),('10318','2013-09-09','16:55:00',1.43),('10318','2013-09-09','17:00:00',1.76),('10318','2013-09-09','17:05:00',1.72),('10318','2013-09-09','17:10:00',1.56),('10318','2013-09-09','17:15:00',1.24),('10318','2013-09-09','17:35:00',1.26),('10318','2013-09-09','17:40:00',1.23),('10318','2013-09-09','18:05:00',1.28),('10318','2013-09-09','18:10:00',1.85),('10318','2013-09-09','18:15:00',1.54),('10318','2013-09-09','18:20:00',1.33),('10318','2013-09-09','18:25:00',1.02),('10318','2014-04-12','07:20:00',1.06),('10318','2014-04-12','07:25:00',1.03),('10318','2014-04-12','07:40:00',1.07),('10318','2014-04-12','07:45:00',1.08),('10318','2014-04-12','08:30:00',1.05),('10318','2014-04-12','08:35:00',1.29),('10318','2014-04-12','08:40:00',1.49),('10318','2014-04-12','08:45:00',1.51),('10318','2014-04-12','08:50:00',1.7),('10318','2014-04-12','08:55:00',1.61),('10318','2014-04-12','09:00:00',1.68),('10318','2014-04-12','09:05:00',2.6),('10318','2014-04-12','09:10:00',3.45),('10318','2014-04-12','09:15:00',4.92),('10318','2014-04-12','09:20:00',4.96),('10318','2014-04-12','09:25:00',4.47),('10318','2014-04-12','09:30:00',4.42),('10318','2014-04-12','09:35:00',4.39),('10318','2014-04-12','09:40:00',3.8),('10318','2014-04-12','09:45:00',3.82),('10318','2014-04-12','09:50:00',3.96),('10318','2014-04-12','09:55:00',4.22),('10318','2014-04-12','10:00:00',4.47),('10318','2014-04-12','10:05:00',4.61),('10318','2014-04-12','10:10:00',4.75),('10318','2014-04-12','10:15:00',4.6),('10318','2014-04-12','10:20:00',4.81),('10318','2014-04-12','10:25:00',5.15),('10318','2014-04-12','10:30:00',4.95),('10318','2014-04-12','10:35:00',5.31),('10318','2014-04-12','10:40:00',4.69),('10318','2014-04-12','10:45:00',5.53),('10318','2014-04-12','10:50:00',5.96),('10318','2014-04-12','10:55:00',7.54),('10318','2014-04-12','11:00:00',9.25),('10318','2014-04-12','11:05:00',8.88),('10318','2014-04-12','11:10:00',6.52),('10318','2014-04-12','11:15:00',6.1),('10318','2014-04-12','11:20:00',8.51),('10318','2014-04-12','11:25:00',6.56),('10318','2014-04-12','11:30:00',8.19),('10318','2014-04-12','11:35:00',5.93),('10318','2014-04-12','11:40:00',8.39),('10318','2014-04-12','11:45:00',7.98),('10318','2014-04-12','11:50:00',3.4),('10318','2014-04-12','11:55:00',3.49),('10318','2014-04-12','12:00:00',6.64),('10318','2014-04-12','12:05:00',9.25),('10318','2014-04-12','12:10:00',7.79),('10318','2014-04-12','12:15:00',5.88),('10318','2014-04-12','12:20:00',5.47),('10318','2014-04-12','12:25:00',7.24),('10318','2014-04-12','12:30:00',6.34),('10318','2014-04-12','12:35:00',6.31),('10318','2014-04-12','12:40:00',6.85),('10318','2014-04-12','12:45:00',4.95),('10318','2014-04-12','12:50:00',9.17),('10318','2014-04-12','12:55:00',6.32),('10318','2014-04-12','13:00:00',5.14),('10318','2014-04-12','13:05:00',6.54),('10318','2014-04-12','13:10:00',5.94),('10318','2014-04-12','13:15:00',7.13),('10318','2014-04-12','13:20:00',4.06),('10318','2014-04-12','13:25:00',8.61),('10318','2014-04-12','13:30:00',5.63),('10318','2014-04-12','13:35:00',6.32),('10318','2014-04-12','13:40:00',4.18),('10318','2014-04-12','13:45:00',4.94),('10318','2014-04-12','13:50:00',4.75),('10318','2014-04-12','13:55:00',5.53),('10318','2014-04-12','14:00:00',7.72),('10318','2014-04-12','14:05:00',8.44),('10318','2014-04-12','14:10:00',7),('10318','2014-04-12','14:15:00',7.22),('10318','2014-04-12','14:20:00',7.39),('10318','2014-04-12','14:25:00',4.09),('10318','2014-04-12','14:30:00',2.8),('10318','2014-04-12','14:35:00',5.52),('10318','2014-04-12','14:40:00',7.43),('10318','2014-04-12','14:45:00',8.6),('10318','2014-04-12','14:50:00',9.08),('10318','2014-04-12','14:55:00',7.23),('10318','2014-04-12','15:00:00',7.51),('10318','2014-04-12','15:05:00',7.41),('10318','2014-04-12','15:10:00',7.72),('10318','2014-04-12','15:15:00',7.02),('10318','2014-04-12','15:20:00',6.28),('10318','2014-04-12','15:25:00',4.99),('10318','2014-04-12','15:30:00',4.85),('10318','2014-04-12','15:35:00',5.64),('10318','2014-04-12','15:40:00',6.3),('10318','2014-04-12','15:45:00',7.03),('10318','2014-04-12','15:50:00',7.03),('10318','2014-04-12','15:55:00',6.88),('10318','2014-04-12','16:00:00',6.78),('10318','2014-04-12','16:05:00',6.58),('10318','2014-04-12','16:10:00',6.24),('10318','2014-04-12','16:15:00',5.24),('10318','2014-04-12','16:20:00',4.92),('10318','2014-04-12','16:25:00',4.6),('10318','2014-04-12','16:30:00',4.84),('10318','2014-04-12','16:35:00',4.52),('10318','2014-04-12','16:40:00',5.49),('10318','2014-04-12','16:45:00',5.43),('10318','2014-04-12','16:50:00',5.5),('10318','2014-04-12','16:55:00',4.72),('10318','2014-04-12','17:00:00',4.02),('10318','2014-04-12','17:05:00',3.96),('10318','2014-04-12','17:10:00',3.87),('10318','2014-04-12','17:15:00',3.55),('10318','2014-04-12','17:20:00',3.1),('10318','2014-04-12','17:25:00',2.28),('10318','2014-04-12','17:30:00',2.67),('10318','2014-04-12','17:35:00',3.41),('10318','2014-04-12','17:40:00',3.42),('10318','2014-04-12','17:45:00',3.21),('10318','2014-04-12','17:50:00',2.33),('10318','2014-04-12','17:55:00',2.03),('10318','2014-04-12','18:00:00',2),('10318','2014-04-12','18:05:00',1.32),('10318','2014-04-12','18:10:00',1),('10318','2013-09-08','07:35:00',1.07),('10318','2013-09-08','07:40:00',1.43),('10318','2013-09-08','07:45:00',1.48),('10318','2013-09-08','07:50:00',1),('10318','2013-09-08','08:05:00',1.03),('10318','2013-09-08','08:10:00',1.48),('10318','2013-09-08','08:15:00',1.91),('10318','2013-09-08','08:20:00',2.02),('10318','2013-09-08','08:25:00',1.83),('10318','2013-09-08','08:30:00',1.79),('10318','2013-09-08','08:35:00',1.68),('10318','2013-09-08','08:40:00',1.56),('10318','2013-09-08','08:45:00',1.57),('10318','2013-09-08','08:50:00',1.57),('10318','2013-09-08','08:55:00',1.64),('10318','2013-09-08','09:00:00',1.79),('10318','2013-09-08','09:05:00',2.11),('10318','2013-09-08','09:10:00',2.7),('10318','2013-09-08','09:15:00',4.45),('10318','2013-09-08','09:20:00',5.24),('10318','2013-09-08','09:25:00',4.81),('10318','2013-09-08','09:30:00',5.4),('10318','2013-09-08','09:35:00',5.75),('10318','2013-09-08','09:40:00',5.86),('10318','2013-09-08','09:45:00',5.93),('10318','2013-09-08','09:50:00',5.96),('10318','2013-09-08','09:55:00',6.15),('10318','2013-09-08','10:00:00',6.23),('10318','2013-09-08','10:05:00',6.19),('10318','2013-09-08','10:10:00',6.55),('10318','2013-09-08','10:15:00',6.6),('10318','2013-09-08','10:20:00',6.61),('10318','2013-09-08','10:25:00',6.94),('10318','2013-09-08','10:30:00',7.11),('10318','2013-09-08','10:35:00',7.2),('10318','2013-09-08','10:40:00',7.17),('10318','2013-09-08','10:45:00',7.35),('10318','2013-09-08','10:50:00',7.38),('10318','2013-09-08','10:55:00',7.51),('10318','2013-09-08','11:00:00',7.51),('10318','2013-09-08','11:05:00',7.51),('10318','2013-09-08','11:10:00',7.61),('10318','2013-09-08','11:15:00',7.68),('10318','2013-09-08','11:20:00',7.68),('10318','2013-09-08','11:25:00',7.67),('10318','2013-09-08','11:30:00',7.64),('10318','2013-09-08','11:35:00',7.58),('10318','2013-09-08','11:40:00',7.66),('10318','2013-09-08','11:45:00',7.87),('10318','2013-09-08','11:50:00',7.79),('10318','2013-09-08','11:55:00',7.71),('10318','2013-09-08','12:00:00',7.52),('10318','2013-09-08','12:05:00',7.64),('10318','2013-09-08','12:10:00',7.69),('10318','2013-09-08','12:15:00',8.19),('10318','2013-09-08','12:20:00',8.19),('10318','2013-09-08','12:25:00',8.1),('10318','2013-09-08','12:30:00',8.1),('10318','2013-09-08','12:35:00',8.07),('10318','2013-09-08','12:40:00',7.72),('10318','2013-09-08','12:45:00',7.97),('10318','2013-09-08','12:50:00',7.95),('10318','2013-09-08','12:55:00',7.94),('10318','2013-09-08','13:00:00',8),('10318','2013-09-08','13:05:00',7.99),('10318','2013-09-08','13:10:00',7.62),('10318','2013-09-08','13:15:00',7.42),('10318','2013-09-08','13:20:00',7.72),('10318','2013-09-08','13:25:00',6.74),('10318','2013-09-08','13:30:00',7.11),('10318','2013-09-08','13:35:00',6.44),('10318','2013-09-08','13:40:00',4.57),('10318','2013-09-08','13:45:00',5.08),('10318','2013-09-08','13:50:00',5.75),('10318','2013-09-08','13:55:00',6.94),('10318','2013-09-08','14:00:00',7.14),('10318','2013-09-08','14:05:00',7.44),('10318','2013-09-08','14:10:00',7.73),('10318','2013-09-08','14:15:00',6.67),('10318','2013-09-08','14:20:00',7.6),('10318','2013-09-08','14:25:00',7.74),('10318','2013-09-08','14:30:00',7.5),('10318','2013-09-08','14:35:00',7.59),('10318','2013-09-08','14:40:00',7.32),('10318','2013-09-08','14:45:00',7.37),('10318','2013-09-08','14:50:00',7.21),('10318','2013-09-08','14:55:00',6.91),('10318','2013-09-08','15:00:00',6.93),('10318','2013-09-08','15:05:00',4.46),('10318','2013-09-08','15:10:00',4.15),('10318','2013-09-08','15:15:00',5.91),('10318','2013-09-08','15:20:00',6.57),('10318','2013-09-08','15:25:00',6.7),('10318','2013-09-08','15:30:00',6.43),('10318','2013-09-08','15:35:00',6),('10318','2013-09-08','15:40:00',5.77),('10318','2013-09-08','15:45:00',5.91),('10318','2013-09-08','15:50:00',5.15),('10318','2013-09-08','15:55:00',4.61),('10318','2013-09-08','16:00:00',4.81),('10318','2013-09-08','16:05:00',4.58),('10318','2013-09-08','16:10:00',4.24),('10318','2013-09-08','16:15:00',4.68),('10318','2013-09-08','16:20:00',4.45),('10318','2013-09-08','16:25:00',4.1),('10318','2013-09-08','16:30:00',4.25),('10318','2013-09-08','16:35:00',3.99),('10318','2013-09-08','16:40:00',2.62),('10318','2013-09-08','16:45:00',2.58),('10318','2013-09-08','16:50:00',2.22),('10318','2013-09-08','16:55:00',2.2),('10318','2013-09-08','17:00:00',2.84),('10318','2013-09-08','17:05:00',3.65),('10318','2013-09-08','17:10:00',3.31),('10318','2013-09-08','17:15:00',2.99),('10318','2013-09-08','17:20:00',2.61),('10318','2013-09-08','17:25:00',2.51),('10318','2013-09-08','17:30:00',2),('10318','2013-09-08','17:35:00',1.24),('10318','2013-09-08','17:40:00',1.62),('10318','2013-09-08','17:45:00',1.83),('10318','2013-09-08','17:50:00',1.77),('10318','2013-09-08','17:55:00',1.65),('10318','2013-09-08','18:00:00',1.43),('10318','2013-09-08','18:05:00',1.24),('10318','2013-09-08','18:10:00',1.12),('10318','2013-09-07','07:45:00',1.11),('10318','2013-09-07','07:50:00',1.51),('10318','2013-09-07','07:55:00',2.03),('10318','2013-09-07','08:00:00',2.38),('10318','2013-09-07','08:05:00',2.61),('10318','2013-09-07','08:10:00',2.87),('10318','2013-09-07','08:15:00',3.14),('10318','2013-09-07','08:20:00',3.3),('10318','2013-09-07','08:25:00',3.5),('10318','2013-09-07','08:30:00',3.7),('10318','2013-09-07','08:35:00',3.76),('10318','2013-09-07','08:40:00',4.06),('10318','2013-09-07','08:45:00',4.24),('10318','2013-09-07','08:50:00',4.43),('10318','2013-09-07','08:55:00',4.59),('10318','2013-09-07','09:00:00',4.75),('10318','2013-09-07','09:05:00',4.95),('10318','2013-09-07','09:10:00',5.16),('10318','2013-09-07','09:15:00',5.32),('10318','2013-09-07','09:20:00',5.47),('10318','2013-09-07','09:25:00',5.63),('10318','2013-09-07','09:30:00',5.76),('10318','2013-09-07','09:35:00',5.88),('10318','2013-09-07','09:40:00',6.02),('10318','2013-09-07','09:45:00',6.16),('10318','2013-09-07','09:50:00',6.25),('10318','2013-09-07','09:55:00',6.4),('10318','2013-09-07','10:00:00',6.52),('10318','2013-09-07','10:05:00',6.63),('10318','2013-09-07','10:10:00',6.74),('10318','2013-09-07','10:15:00',6.88),('10318','2013-09-07','10:20:00',7),('10318','2013-09-07','10:25:00',7.12),('10318','2013-09-07','10:30:00',7.23),('10318','2013-09-07','10:35:00',7.31),('10318','2013-09-07','10:40:00',7.39),('10318','2013-09-07','10:45:00',7.46),('10318','2013-09-07','10:50:00',7.53),('10318','2013-09-07','10:55:00',7.58),('10318','2013-09-07','11:00:00',7.6),('10318','2013-09-07','11:05:00',7.7),('10318','2013-09-07','11:10:00',7.79),('10318','2013-09-07','11:15:00',7.88),('10318','2013-09-07','11:20:00',7.84),('10318','2013-09-07','11:25:00',7.88),('10318','2013-09-07','11:30:00',7.96),('10318','2013-09-07','11:35:00',7.9),('10318','2013-09-07','11:40:00',8.05),('10318','2013-09-07','11:45:00',8.02),('10318','2013-09-07','11:50:00',8.02),('10318','2013-09-07','11:55:00',8.07),('10318','2013-09-07','12:00:00',8.12),('10318','2013-09-07','12:05:00',8.11),('10318','2013-09-07','12:10:00',8.03),('10318','2013-09-07','12:15:00',8.31),('10318','2013-09-07','12:20:00',8.36),('10318','2013-09-07','12:25:00',8.37),('10318','2013-09-07','12:30:00',8.35),('10318','2013-09-07','12:35:00',8.31),('10318','2013-09-07','12:40:00',8.2),('10318','2013-09-07','12:45:00',8.04),('10318','2013-09-07','12:50:00',8.05),('10318','2013-09-07','12:55:00',8.11),('10318','2013-09-07','13:00:00',8.23),('10318','2013-09-07','13:05:00',8.17),('10318','2013-09-07','13:10:00',8.24),('10318','2013-09-07','13:15:00',8.17),('10318','2013-09-07','13:20:00',7.95),('10318','2013-09-07','13:25:00',8.09),('10318','2013-09-07','13:30:00',7.99),('10318','2013-09-07','13:35:00',8.05),('10318','2013-09-07','13:40:00',7.99),('10318','2013-09-07','13:45:00',7.98),('10318','2013-09-07','13:50:00',7.74),('10318','2013-09-07','13:55:00',7.74),('10318','2013-09-07','14:00:00',7.81),('10318','2013-09-07','14:05:00',7.84),('10318','2013-09-07','14:10:00',7.91),('10318','2013-09-07','14:15:00',7.81),('10318','2013-09-07','14:20:00',7.76),('10318','2013-09-07','14:25:00',7.58),('10318','2013-09-07','14:30:00',7.52),('10318','2013-09-07','14:35:00',7.44),('10318','2013-09-07','14:40:00',7.38),('10318','2013-09-07','14:45:00',7.25),('10318','2013-09-07','14:50:00',7.12),('10318','2013-09-07','14:55:00',7.05),('10318','2013-09-07','15:00:00',6.91),('10318','2013-09-07','15:05:00',6.74),('10318','2013-09-07','15:10:00',6.72),('10318','2013-09-07','15:15:00',6.6),('10318','2013-09-07','15:20:00',6.51),('10318','2013-09-07','15:25:00',6.4),('10318','2013-09-07','15:30:00',6.24),('10318','2013-09-07','15:35:00',6.07),('10318','2013-09-07','15:40:00',5.94),('10318','2013-09-07','15:45:00',5.81),('10318','2013-09-07','15:50:00',5.65),('10318','2013-09-07','15:55:00',5.45),('10318','2013-09-07','16:00:00',5.29),('10318','2013-09-07','16:05:00',5.15),('10318','2013-09-07','16:10:00',5),('10318','2013-09-07','16:15:00',4.81),('10318','2013-09-07','16:20:00',4.65),('10318','2013-09-07','16:25:00',4.47),('10318','2013-09-07','16:30:00',4.32),('10318','2013-09-07','16:35:00',4.14),('10318','2013-09-07','16:40:00',3.98),('10318','2013-09-07','16:45:00',3.79),('10318','2013-09-07','16:50:00',3.54),('10318','2013-09-07','16:55:00',3.44),('10318','2013-09-07','17:00:00',3.29),('10318','2013-09-07','17:05:00',3.15),('10318','2013-09-07','17:10:00',3),('10318','2013-09-07','17:15:00',2.83),('10318','2013-09-07','17:20:00',2.65),('10318','2013-09-07','17:25:00',2.46),('10318','2013-09-07','17:30:00',2.28),('10318','2013-09-07','17:35:00',2.16),('10318','2013-09-07','17:40:00',2.03),('10318','2013-09-07','17:45:00',1.87),('10318','2013-09-07','17:50:00',1.75),('10318','2013-09-07','17:55:00',1.59),('10318','2013-09-07','18:00:00',1.44),('10318','2013-09-07','18:05:00',1.29),('10318','2013-09-07','18:10:00',1.16),('10318','2013-09-07','18:15:00',1.04),('10318','2013-09-06','07:45:00',1.11),('10318','2013-09-06','07:50:00',1.66),('10318','2013-09-06','07:55:00',2.03),('10318','2013-09-06','08:00:00',2.35),('10318','2013-09-06','08:05:00',2.64),('10318','2013-09-06','08:10:00',2.86),('10318','2013-09-06','08:15:00',3.14),('10318','2013-09-06','08:20:00',3.39),('10318','2013-09-06','08:25:00',3.6),('10318','2013-09-06','08:30:00',3.81),('10318','2013-09-06','08:35:00',4),('10318','2013-09-06','08:40:00',4.16),('10318','2013-09-06','08:45:00',4.37),('10318','2013-09-06','08:50:00',4.57),('10318','2013-09-06','08:55:00',4.75),('10318','2013-09-06','09:00:00',4.95),('10318','2013-09-06','09:05:00',5.1),('10318','2013-09-06','09:10:00',5.27),('10318','2013-09-06','09:15:00',5.4),('10318','2013-09-06','09:20:00',5.35),('10318','2013-09-06','09:25:00',5.56),('10318','2013-09-06','09:30:00',5.77),('10318','2013-09-06','09:35:00',5.97),('10318','2013-09-06','09:40:00',6.11),('10318','2013-09-06','09:45:00',6.18),('10318','2013-09-06','09:50:00',6.23),('10318','2013-09-06','09:55:00',6.41),('10318','2013-09-06','10:00:00',6.6),('10318','2013-09-06','10:05:00',6.75),('10318','2013-09-06','10:10:00',6.89),('10318','2013-09-06','10:15:00',6.98),('10318','2013-09-06','10:20:00',7.11),('10318','2013-09-06','10:25:00',7.26),('10318','2013-09-06','10:30:00',7.3),('10318','2013-09-06','10:35:00',7.4),('10318','2013-09-06','10:40:00',7.48),('10318','2013-09-06','10:45:00',7.64),('10318','2013-09-06','10:50:00',7.69),('10318','2013-09-06','10:55:00',7.75),('10318','2013-09-06','11:00:00',7.85),('10318','2013-09-06','11:05:00',7.81),('10318','2013-09-06','11:10:00',7.95),('10318','2013-09-06','11:15:00',7.97),('10318','2013-09-06','11:20:00',8.02),('10318','2013-09-06','11:25:00',8.03),('10318','2013-09-06','11:30:00',8.1),('10318','2013-09-06','11:35:00',8.18),('10318','2013-09-06','11:40:00',8.23),('10318','2013-09-06','11:45:00',8.27),('10318','2013-09-06','11:50:00',8.23),('10318','2013-09-06','11:55:00',8.33),('10318','2013-09-06','12:00:00',8.25),('10318','2013-09-06','12:05:00',8.27),('10318','2013-09-06','12:10:00',8.35),('10318','2013-09-06','12:15:00',8.39),('10318','2013-09-06','12:20:00',8.37),('10318','2013-09-06','12:25:00',8.38),('10318','2013-09-06','12:30:00',8.4),('10318','2013-09-06','12:35:00',8.38),('10318','2013-09-06','12:40:00',8.42),('10318','2013-09-06','12:45:00',8.38),('10318','2013-09-06','12:50:00',8.09),('10318','2013-09-06','12:55:00',8.37),('10318','2013-09-06','13:00:00',8.32),('10318','2013-09-06','13:05:00',8.25),('10318','2013-09-06','13:10:00',8.2),('10318','2013-09-06','13:15:00',8.13),('10318','2013-09-06','13:20:00',8.12),('10318','2013-09-06','13:25:00',8.14),('10318','2013-09-06','13:30:00',8.14),('10318','2013-09-06','13:35:00',8.12),('10318','2013-09-06','13:40:00',8.03),('10318','2013-09-06','13:45:00',7.92),('10318','2013-09-06','13:50:00',7.82),('10318','2013-09-06','13:55:00',7.73),('10318','2013-09-06','14:00:00',7.75),('10318','2013-09-06','14:05:00',7.69),('10318','2013-09-06','14:10:00',7.5),('10318','2013-09-06','14:15:00',7.4),('10318','2013-09-06','14:20:00',7.31),('10318','2013-09-06','14:25:00',6.84),('10318','2013-09-06','14:30:00',7.14),('10318','2013-09-06','14:35:00',7.01),('10318','2013-09-06','14:40:00',7.13),('10318','2013-09-06','14:45:00',6.99),('10318','2013-09-06','14:50:00',6.98),('10318','2013-09-06','14:55:00',6.93),('10318','2013-09-06','15:00:00',6.86),('10318','2013-09-06','15:05:00',6.73),('10318','2013-09-06','15:10:00',6.65),('10318','2013-09-06','15:15:00',6.5),('10318','2013-09-06','15:20:00',6.42),('10318','2013-09-06','15:25:00',6.35),('10318','2013-09-06','15:30:00',6.21),('10318','2013-09-06','15:35:00',6.01),('10318','2013-09-06','15:40:00',5.9),('10318','2013-09-06','15:45:00',5.78),('10318','2013-09-06','15:50:00',5.64),('10318','2013-09-06','15:55:00',5.51),('10318','2013-09-06','16:00:00',5.34),('10318','2013-09-06','16:05:00',5.16),('10318','2013-09-06','16:10:00',5.01),('10318','2013-09-06','16:15:00',4.8),('10318','2013-09-06','16:20:00',4.68),('10318','2013-09-06','16:25:00',4.51),('10318','2013-09-06','16:30:00',4.35),('10318','2013-09-06','16:35:00',4.24),('10318','2013-09-06','16:40:00',4.07),('10318','2013-09-06','16:45:00',3.9),('10318','2013-09-06','16:50:00',3.7),('10318','2013-09-06','16:55:00',3.54),('10318','2013-09-06','17:00:00',3.38),('10318','2013-09-06','17:05:00',3.23),('10318','2013-09-06','17:10:00',3.03),('10318','2013-09-06','17:15:00',2.86),('10318','2013-09-06','17:20:00',2.71),('10318','2013-09-06','17:25:00',2.49),('10318','2013-09-06','17:30:00',2.3),('10318','2013-09-06','17:35:00',2.16),('10318','2013-09-06','17:40:00',2.05),('10318','2013-09-06','17:45:00',1.9),('10318','2013-09-06','17:50:00',1.77),('10318','2013-09-06','17:55:00',1.61),('10318','2013-09-06','18:00:00',1.45),('10318','2013-09-06','18:05:00',1.31),('10318','2013-09-06','18:10:00',1.19),('10318','2013-09-06','18:15:00',1.08),('10318','2013-09-05','07:40:00',1.01),('10318','2013-09-05','07:45:00',1.33),('10318','2013-09-05','07:50:00',1.98),('10318','2013-09-05','07:55:00',2.35),('10318','2013-09-05','08:00:00',2.49),('10318','2013-09-05','08:05:00',2.94),('10318','2013-09-05','08:10:00',3.34),('10318','2013-09-05','08:15:00',3.59),('10318','2013-09-05','08:20:00',3.79),('10318','2013-09-05','08:25:00',3.98),('10318','2013-09-05','08:30:00',4.19),('10318','2013-09-05','08:35:00',4.39),('10318','2013-09-05','08:40:00',4.58),('10318','2013-09-05','08:45:00',4.72),('10318','2013-09-05','08:50:00',4.97),('10318','2013-09-05','08:55:00',5.16),('10318','2013-09-05','09:00:00',5.34),('10318','2013-09-05','09:05:00',5.51),('10318','2013-09-05','09:10:00',5.68),('10318','2013-09-05','09:15:00',5.82),('10318','2013-09-05','09:20:00',5.97),('10318','2013-09-05','09:25:00',6.11),('10318','2013-09-05','09:30:00',6.25),('10318','2013-09-05','09:35:00',6.35),('10318','2013-09-05','09:40:00',6.48),('10318','2013-09-05','09:45:00',6.6),('10318','2013-09-05','09:50:00',6.74),('10318','2013-09-05','09:55:00',6.85),('10318','2013-09-05','10:00:00',6.99),('10318','2013-09-05','10:05:00',7.1),('10318','2013-09-05','10:10:00',7.21),('10318','2013-09-05','10:15:00',7.3),('10318','2013-09-05','10:20:00',7.41),('10318','2013-09-05','10:25:00',7.52),('10318','2013-09-05','10:30:00',7.58),('10318','2013-09-05','10:35:00',7.68),('10318','2013-09-05','10:40:00',7.74),('10318','2013-09-05','10:45:00',7.81),('10318','2013-09-05','10:50:00',7.86),('10318','2013-09-05','10:55:00',7.95),('10318','2013-09-05','11:00:00',8.03),('10318','2013-09-05','11:05:00',8.08),('10318','2013-09-05','11:10:00',8.1),('10318','2013-09-05','11:15:00',8.14),('10318','2013-09-05','11:20:00',8.2),('10318','2013-09-05','11:25:00',8.25),('10318','2013-09-05','11:30:00',8.26),('10318','2013-09-05','11:35:00',8.32),('10318','2013-09-05','11:40:00',8.35),('10318','2013-09-05','11:45:00',8.34),('10318','2013-09-05','11:50:00',8.39),('10318','2013-09-05','11:55:00',8.46),('10318','2013-09-05','12:00:00',8.57),('10318','2013-09-05','12:05:00',8.58),('10318','2013-09-05','12:10:00',8.61),('10318','2013-09-05','12:15:00',8.61),('10318','2013-09-05','12:20:00',8.39),('10318','2013-09-05','12:25:00',8.52),('10318','2013-09-05','12:30:00',8.55),('10318','2013-09-05','12:35:00',8.57),('10318','2013-09-05','12:40:00',8.57),('10318','2013-09-05','12:45:00',8.5),('10318','2013-09-05','12:50:00',8.51),('10318','2013-09-05','12:55:00',8.54),('10318','2013-09-05','13:00:00',8.52),('10318','2013-09-05','13:05:00',8.53),('10318','2013-09-05','13:10:00',8.49),('10318','2013-09-05','13:15:00',8.44),('10318','2013-09-05','13:20:00',8.38),('10318','2013-09-05','13:25:00',8.29),('10318','2013-09-05','13:30:00',8.29),('10318','2013-09-05','13:35:00',8.14),('10318','2013-09-05','13:40:00',8.25),('10318','2013-09-05','13:45:00',8.18),('10318','2013-09-05','13:50:00',8.09),('10318','2013-09-05','13:55:00',8.03),('10318','2013-09-05','14:00:00',7.95),('10318','2013-09-05','14:05:00',7.92),('10318','2013-09-05','14:10:00',7.85),('10318','2013-09-05','14:15:00',7.77),('10318','2013-09-05','14:20:00',7.73),('10318','2013-09-05','14:25:00',7.71),('10318','2013-09-05','14:30:00',7.65),('10318','2013-09-05','14:35:00',7.45),('10318','2013-09-05','14:40:00',7.33),('10318','2013-09-05','14:45:00',7.28),('10318','2013-09-05','14:50:00',7.21),('10318','2013-09-05','14:55:00',7.11),('10318','2013-09-05','15:00:00',7.04),('10318','2013-09-05','15:05:00',6.91),('10318','2013-09-05','15:10:00',6.79),('10318','2013-09-05','15:15:00',6.73),('10318','2013-09-05','15:20:00',6.5),('10318','2013-09-05','15:25:00',6.42),('10318','2013-09-05','15:30:00',6.31),('10318','2013-09-05','15:35:00',6.18),('10318','2013-09-05','15:40:00',6.01),('10318','2013-09-05','15:45:00',5.89),('10318','2013-09-05','15:50:00',5.8),('10318','2013-09-05','15:55:00',5.67),('10318','2013-09-05','16:00:00',5.53),('10318','2013-09-05','16:05:00',5.42),('10318','2013-09-05','16:10:00',5.26),('10318','2013-09-05','16:15:00',5.11),('10318','2013-09-05','16:20:00',4.95),('10318','2013-09-05','16:25:00',4.79),('10318','2013-09-05','16:30:00',4.64),('10318','2013-09-05','16:35:00',4.52),('10318','2013-09-05','16:40:00',4.43),('10318','2013-09-05','16:45:00',4.33),('10318','2013-09-05','16:50:00',3.79),('10318','2013-09-05','16:55:00',3.04),('10318','2013-09-05','17:00:00',2.43),('10318','2013-09-05','17:05:00',2.46),('10318','2013-09-05','17:10:00',2.6),('10318','2013-09-05','17:15:00',2.25),('10318','2013-09-05','17:20:00',2.55),('10318','2013-09-05','17:25:00',2.59),('10318','2013-09-05','17:30:00',2.33),('10318','2013-09-05','17:35:00',2.63),('10318','2013-09-05','17:40:00',2.72),('10318','2013-09-05','17:45:00',2.37),('10318','2013-09-05','17:50:00',2.32),('10318','2013-09-05','17:55:00',1.86),('10318','2013-09-05','18:00:00',1.61),('10318','2013-09-05','18:05:00',1.4),('10318','2013-09-05','18:10:00',1.27),('10318','2013-09-05','18:15:00',1.24),('10318','2013-09-05','18:20:00',1.21),('10318','2013-09-05','18:25:00',1.09),('10318','2013-09-04','07:45:00',1.37),('10318','2013-09-04','07:50:00',1.94),('10318','2013-09-04','07:55:00',2.49),('10318','2013-09-04','08:00:00',2.66),('10318','2013-09-04','08:05:00',3),('10318','2013-09-04','08:10:00',3.34),('10318','2013-09-04','08:15:00',3.57),('10318','2013-09-04','08:20:00',3.77),('10318','2013-09-04','08:25:00',3.96),('10318','2013-09-04','08:30:00',4.16),('10318','2013-09-04','08:35:00',4.35),('10318','2013-09-04','08:40:00',4.55),('10318','2013-09-04','08:45:00',4.73),('10318','2013-09-04','08:50:00',4.93),('10318','2013-09-04','08:55:00',5.1),('10318','2013-09-04','09:00:00',5.29),('10318','2013-09-04','09:05:00',5.45),('10318','2013-09-04','09:10:00',5.59),('10318','2013-09-04','09:15:00',5.78),('10318','2013-09-04','09:20:00',5.97),('10318','2013-09-04','09:25:00',6.15),('10318','2013-09-04','09:30:00',6.13),('10318','2013-09-04','09:35:00',6.44),('10318','2013-09-04','09:40:00',6.6),('10318','2013-09-04','09:45:00',6.76),('10318','2013-09-04','09:50:00',6.89),('10318','2013-09-04','09:55:00',7.03),('10318','2013-09-04','10:00:00',7.15),('10318','2013-09-04','10:05:00',7.24),('10318','2013-09-04','10:10:00',7.33),('10318','2013-09-04','10:15:00',7.42),('10318','2013-09-04','10:20:00',7.52),('10318','2013-09-04','10:25:00',7.62),('10318','2013-09-04','10:30:00',7.74),('10318','2013-09-04','10:35:00',7.83),('10318','2013-09-04','10:40:00',7.89),('10318','2013-09-04','10:45:00',8.01),('10318','2013-09-04','10:50:00',8.14),('10318','2013-09-04','10:55:00',8.24),('10318','2013-09-04','11:00:00',8.35),('10318','2013-09-04','11:05:00',8.39),('10318','2013-09-04','11:10:00',8.44),('10318','2013-09-04','11:15:00',8.3),('10318','2013-09-04','11:20:00',8.49),('10318','2013-09-04','11:25:00',8.6),('10318','2013-09-04','11:30:00',8.65),('10318','2013-09-04','11:35:00',8.69),('10318','2013-09-04','11:40:00',8.73),('10318','2013-09-04','11:45:00',8.73),('10318','2013-09-04','11:50:00',8.79),('10318','2013-09-04','11:55:00',8.81),('10318','2013-09-04','12:00:00',8.79),('10318','2013-09-04','12:05:00',8.78),('10318','2013-09-04','12:10:00',8.79),('10318','2013-09-04','12:15:00',8.82),('10318','2013-09-04','12:20:00',8.82),('10318','2013-09-04','12:25:00',8.9),('10318','2013-09-04','12:30:00',8.83),('10318','2013-09-04','12:35:00',8.85),('10318','2013-09-04','12:40:00',8.8),('10318','2013-09-04','12:45:00',8.78),('10318','2013-09-04','12:50:00',8.82),('10318','2013-09-04','12:55:00',8.8),('10318','2013-09-04','13:00:00',8.71),('10318','2013-09-04','13:05:00',8.77),('10318','2013-09-04','13:10:00',8.76),('10318','2013-09-04','13:15:00',8.72),('10318','2013-09-04','13:20:00',8.72),('10318','2013-09-04','13:25:00',8.62),('10318','2013-09-04','13:30:00',8.58),('10318','2013-09-04','13:35:00',8.49),('10318','2013-09-04','13:40:00',8.46),('10318','2013-09-04','13:45:00',8.43),('10318','2013-09-04','13:50:00',8.36),('10318','2013-09-04','13:55:00',8.34),('10318','2013-09-04','14:00:00',8.32),('10318','2013-09-04','14:05:00',8.22),('10318','2013-09-04','14:10:00',8.11),('10318','2013-09-04','14:15:00',8.03),('10318','2013-09-04','14:20:00',7.86),('10318','2013-09-04','14:25:00',7.88),('10318','2013-09-04','14:30:00',7.84),('10318','2013-09-04','14:35:00',7.76),('10318','2013-09-04','14:40:00',7.68),('10318','2013-09-04','14:45:00',7.59),('10318','2013-09-04','14:50:00',7.47),('10318','2013-09-04','14:55:00',7.37),('10318','2013-09-04','15:00:00',7.23),('10318','2013-09-04','15:05:00',7.14),('10318','2013-09-04','15:10:00',7.03),('10318','2013-09-04','15:15:00',6.91),('10318','2013-09-04','15:20:00',6.75),('10318','2013-09-04','15:25:00',6.65),('10318','2013-09-04','15:30:00',6.54),('10318','2013-09-04','15:35:00',6.36),('10318','2013-09-04','15:40:00',6.21),('10318','2013-09-04','15:45:00',6.06),('10318','2013-09-04','15:50:00',5.93),('10318','2013-09-04','15:55:00',5.75),('10318','2013-09-04','16:00:00',5.56),('10318','2013-09-04','16:05:00',5.31),('10318','2013-09-04','16:10:00',5.27),('10318','2013-09-04','16:15:00',5.15),('10318','2013-09-04','16:20:00',5.05),('10318','2013-09-04','16:25:00',4.79),('10318','2013-09-04','16:30:00',4.57),('10318','2013-09-04','16:35:00',4.45),('10318','2013-09-04','16:40:00',4.28),('10318','2013-09-04','16:45:00',4.1),('10318','2013-09-04','16:50:00',3.91),('10318','2013-09-04','16:55:00',3.71),('10318','2013-09-04','17:00:00',3.52),('10318','2013-09-04','17:05:00',3.34),('10318','2013-09-04','17:10:00',3.18),('10318','2013-09-04','17:15:00',3.01),('10318','2013-09-04','17:20:00',2.84),('10318','2013-09-04','17:25:00',2.66),('10318','2013-09-04','17:30:00',2.48),('10318','2013-09-04','17:35:00',2.24),('10318','2013-09-04','17:40:00',2.08),('10318','2013-09-04','17:45:00',1.95),('10318','2013-09-04','17:50:00',1.78),('10318','2013-09-04','17:55:00',1.67),('10318','2013-09-04','18:00:00',1.54),('10318','2013-09-04','18:05:00',1.36),('10318','2013-09-04','18:10:00',1.23),('10318','2013-09-04','18:15:00',1.1),('10318','2013-09-03','07:40:00',1.06),('10318','2013-09-03','07:45:00',1.3),('10318','2013-09-03','07:50:00',1.82),('10318','2013-09-03','07:55:00',2.16),('10318','2013-09-03','08:00:00',2.4),('10318','2013-09-03','08:05:00',2.64),('10318','2013-09-03','08:10:00',2.9),('10318','2013-09-03','08:15:00',3.11),('10318','2013-09-03','08:20:00',3.3),('10318','2013-09-03','08:25:00',3.48),('10318','2013-09-03','08:30:00',3.7),('10318','2013-09-03','08:35:00',3.89),('10318','2013-09-03','08:40:00',4.1),('10318','2013-09-03','08:45:00',4.32),('10318','2013-09-03','08:50:00',4.51),('10318','2013-09-03','08:55:00',4.66),('10318','2013-09-03','09:00:00',4.79),('10318','2013-09-03','09:05:00',4.98),('10318','2013-09-03','09:10:00',5.15),('10318','2013-09-03','09:15:00',5.34),('10318','2013-09-03','09:20:00',5.53),('10318','2013-09-03','09:25:00',5.67),('10318','2013-09-03','09:30:00',5.83),('10318','2013-09-03','09:35:00',6),('10318','2013-09-03','09:40:00',6.22),('10318','2013-09-03','09:45:00',6.35),('10318','2013-09-03','09:50:00',6.48),('10318','2013-09-03','09:55:00',6.64),('10318','2013-09-03','10:00:00',6.7),('10318','2013-09-03','10:05:00',6.8),('10318','2013-09-03','10:10:00',6.95),('10318','2013-09-03','10:15:00',7.03),('10318','2013-09-03','10:20:00',7.18),('10318','2013-09-03','10:25:00',7.28),('10318','2013-09-03','10:30:00',7.41),('10318','2013-09-03','10:35:00',7.55),('10318','2013-09-03','10:40:00',7.69),('10318','2013-09-03','10:45:00',7.75),('10318','2013-09-03','10:50:00',7.81),('10318','2013-09-03','10:55:00',7.84),('10318','2013-09-03','11:00:00',7.91),('10318','2013-09-03','11:05:00',7.98),('10318','2013-09-03','11:10:00',8.07),('10318','2013-09-03','11:15:00',8.07),('10318','2013-09-03','11:20:00',8.1),('10318','2013-09-03','11:25:00',8.14),('10318','2013-09-03','11:30:00',8.3),('10318','2013-09-03','11:35:00',8.34),('10318','2013-09-03','11:40:00',8.32),('10318','2013-09-03','11:45:00',8.33),('10318','2013-09-03','11:50:00',8.46),('10318','2013-09-03','11:55:00',8.45),('10318','2013-09-03','12:00:00',8.47),('10318','2013-09-03','12:05:00',8.59),('10318','2013-09-03','12:10:00',8.62),('10318','2013-09-03','12:15:00',8.62),('10318','2013-09-03','12:20:00',8.63),('10318','2013-09-03','12:25:00',8.59),('10318','2013-09-03','12:30:00',8.62),('10318','2013-09-03','12:35:00',8.65),('10318','2013-09-03','12:40:00',8.69),('10318','2013-09-03','12:45:00',8.66),('10318','2013-09-03','12:50:00',8.61),('10318','2013-09-03','12:55:00',8.61),('10318','2013-09-03','13:00:00',8.59),('10318','2013-09-03','13:05:00',8.55),('10318','2013-09-03','13:10:00',8.55),('10318','2013-09-03','13:15:00',8.48),('10318','2013-09-03','13:20:00',8.47),('10318','2013-09-03','13:25:00',8.43),('10318','2013-09-03','13:30:00',8.28),('10318','2013-09-03','13:35:00',8.3),('10318','2013-09-03','13:40:00',8.25),('10318','2013-09-03','13:45:00',8.24),('10318','2013-09-03','13:50:00',8.06),('10318','2013-09-03','13:55:00',8.16),('10318','2013-09-03','14:00:00',8.11),('10318','2013-09-03','14:05:00',8.05),('10318','2013-09-03','14:10:00',7.93),('10318','2013-09-03','14:15:00',7.85),('10318','2013-09-03','14:20:00',7.8),('10318','2013-09-03','14:25:00',7.7),('10318','2013-09-03','14:30:00',7.69),('10318','2013-09-03','14:35:00',7.58),('10318','2013-09-03','14:40:00',7.59),('10318','2013-09-03','14:45:00',7.51),('10318','2013-09-03','14:50:00',7.33),('10318','2013-09-03','14:55:00',7.27),('10318','2013-09-03','15:00:00',7.2),('10318','2013-09-03','15:05:00',7.06),('10318','2013-09-03','15:10:00',6.91),('10318','2013-09-03','15:15:00',6.78),('10318','2013-09-03','15:20:00',6.67),('10318','2013-09-03','15:25:00',6.59),('10318','2013-09-03','15:30:00',6.46),('10318','2013-09-03','15:35:00',6.08),('10318','2013-09-03','15:40:00',6.17),('10318','2013-09-03','15:45:00',6.01),('10318','2013-09-03','15:50:00',5.83),('10318','2013-09-03','15:55:00',5.68),('10318','2013-09-03','16:00:00',5.55),('10318','2013-09-03','16:05:00',5.39),('10318','2013-09-03','16:10:00',5.3),('10318','2013-09-03','16:15:00',5.11),('10318','2013-09-03','16:20:00',4.93),('10318','2013-09-03','16:25:00',4.71),('10318','2013-09-03','16:30:00',4.57),('10318','2013-09-03','16:35:00',4.4),('10318','2013-09-03','16:40:00',4.26),('10318','2013-09-03','16:45:00',4.1),('10318','2013-09-03','16:50:00',3.91),('10318','2013-09-03','16:55:00',3.71),('10318','2013-09-03','17:00:00',3.54),('10318','2013-09-03','17:05:00',3.35),('10318','2013-09-03','17:10:00',3.2),('10318','2013-09-03','17:15:00',3.04),('10318','2013-09-03','17:20:00',2.87),('10318','2013-09-03','17:25:00',2.72),('10318','2013-09-03','17:30:00',2.55),('10318','2013-09-03','17:35:00',2.38),('10318','2013-09-03','17:40:00',2.22),('10318','2013-09-03','17:45:00',2),('10318','2013-09-03','17:50:00',1.73),('10318','2013-09-03','17:55:00',1.59),('10318','2013-09-03','18:00:00',1.48),('10318','2013-09-03','18:05:00',1.36),('10318','2013-09-03','18:10:00',1.25),('10318','2013-09-03','18:15:00',1.16),('10318','2013-09-03','18:20:00',1.03),('10318','2013-09-02','07:40:00',1.08),('10318','2013-09-02','07:45:00',1.45),('10318','2013-09-02','07:50:00',1.92),('10318','2013-09-02','07:55:00',2.22),('10318','2013-09-02','08:00:00',2.48),('10318','2013-09-02','08:05:00',2.74),('10318','2013-09-02','08:10:00',3.04),('10318','2013-09-02','08:15:00',3.26),('10318','2013-09-02','08:20:00',3.45),('10318','2013-09-02','08:25:00',3.65),('10318','2013-09-02','08:30:00',3.83),('10318','2013-09-02','08:35:00',4.09),('10318','2013-09-02','08:40:00',4.27),('10318','2013-09-02','08:45:00',4.48),('10318','2013-09-02','08:50:00',4.65),('10318','2013-09-02','08:55:00',4.82),('10318','2013-09-02','09:00:00',4.99),('10318','2013-09-02','09:05:00',5.17),('10318','2013-09-02','09:10:00',5.36),('10318','2013-09-02','09:15:00',5.52),('10318','2013-09-02','09:20:00',5.7),('10318','2013-09-02','09:25:00',5.84),('10318','2013-09-02','09:30:00',6.01),('10318','2013-09-02','09:35:00',6.15),('10318','2013-09-02','09:40:00',6.28),('10318','2013-09-02','09:45:00',6.31),('10318','2013-09-02','09:50:00',6.54),('10318','2013-09-02','09:55:00',6.66),('10318','2013-09-02','10:00:00',6.76),('10318','2013-09-02','10:05:00',6.89),('10318','2013-09-02','10:10:00',7.04),('10318','2013-09-02','10:15:00',7.17),('10318','2013-09-02','10:20:00',7.25),('10318','2013-09-02','10:25:00',7.37),('10318','2013-09-02','10:30:00',7.48),('10318','2013-09-02','10:35:00',7.61),('10318','2013-09-02','10:40:00',7.73),('10318','2013-09-02','10:45:00',7.82),('10318','2013-09-02','10:50:00',7.91),('10318','2013-09-02','10:55:00',7.95),('10318','2013-09-02','11:00:00',8.02),('10318','2013-09-02','11:05:00',8.13),('10318','2013-09-02','11:10:00',8.2),('10318','2013-09-02','11:15:00',8.22),('10318','2013-09-02','11:20:00',8.22),('10318','2013-09-02','11:25:00',8.29),('10318','2013-09-02','11:30:00',8.06),('10318','2013-09-02','11:35:00',8.39),('10318','2013-09-02','11:40:00',8.42),('10318','2013-09-02','11:45:00',8.48),('10318','2013-09-02','11:50:00',8.52),('10318','2013-09-02','11:55:00',8.57),('10318','2013-09-02','12:00:00',8.6),('10318','2013-09-02','12:05:00',8.63),('10318','2013-09-02','12:10:00',8.63),('10318','2013-09-02','12:15:00',8.69),('10318','2013-09-02','12:20:00',8.64),('10318','2013-09-02','12:25:00',8.67),('10318','2013-09-02','12:30:00',8.61),('10318','2013-09-02','12:35:00',8.59),('10318','2013-09-02','12:40:00',8.54),('10318','2013-09-02','12:45:00',8.54),('10318','2013-09-02','12:50:00',8.51),('10318','2013-09-02','12:55:00',8.47),('10318','2013-09-02','13:00:00',8.47),('10318','2013-09-02','13:05:00',8.49),('10318','2013-09-02','13:10:00',8.49),('10318','2013-09-02','13:15:00',8.3),('10318','2013-09-02','13:20:00',8.33),('10318','2013-09-02','13:25:00',8.38),('10318','2013-09-02','13:30:00',8.47),('10318','2013-09-02','13:35:00',8.41),('10318','2013-09-02','13:40:00',8.43),('10318','2013-09-02','13:45:00',8.3),('10318','2013-09-02','13:50:00',8.21),('10318','2013-09-02','13:55:00',8.03),('10318','2013-09-02','14:00:00',7.94),('10318','2013-09-02','14:05:00',7.99),('10318','2013-09-02','14:10:00',8.05),('10318','2013-09-02','14:15:00',8.01),('10318','2013-09-02','14:20:00',7.99),('10318','2013-09-02','14:25:00',8.03),('10318','2013-09-02','14:30:00',7.98),('10318','2013-09-02','14:35:00',7.64),('10318','2013-09-02','14:40:00',7.49),('10318','2013-09-02','14:45:00',7.54),('10318','2013-09-02','14:50:00',7.34),('10318','2013-09-02','14:55:00',3.67),('10318','2013-09-02','15:00:00',1.43),('10318','2013-09-02','15:05:00',5.54),('10318','2013-09-02','15:10:00',7.09),('10318','2013-09-02','15:15:00',6.88),('10318','2013-09-02','15:20:00',6.85),('10318','2013-09-02','15:25:00',6.74),('10318','2013-09-02','15:30:00',6.61),('10318','2013-09-02','15:35:00',6.51),('10318','2013-09-02','15:40:00',6.03),('10318','2013-09-02','15:45:00',5.96),('10318','2013-09-02','15:50:00',5.96),('10318','2013-09-02','15:55:00',5.79),('10318','2013-09-02','16:00:00',5.68),('10318','2013-09-02','16:05:00',5.46),('10318','2013-09-02','16:10:00',5.33),('10318','2013-09-02','16:15:00',5.09),('10318','2013-09-02','16:20:00',5.04),('10318','2013-09-02','16:25:00',4.84),('10318','2013-09-02','16:30:00',4.65),('10318','2013-09-02','16:35:00',4.47),('10318','2013-09-02','16:40:00',4.29),('10318','2013-09-02','16:45:00',4.15),('10318','2013-09-02','16:50:00',3.93),('10318','2013-09-02','16:55:00',3.7),('10318','2013-09-02','17:00:00',3.53),('10318','2013-09-02','17:05:00',3.35),('10318','2013-09-02','17:10:00',3.18),('10318','2013-09-02','17:15:00',3.05),('10318','2013-09-02','17:20:00',2.86),('10318','2013-09-02','17:25:00',2.71),('10318','2013-09-02','17:30:00',2.55),('10318','2013-09-02','17:35:00',2.39),('10318','2013-09-02','17:40:00',2.22),('10318','2013-09-02','17:45:00',2.06),('10318','2013-09-02','17:50:00',1.9),('10318','2013-09-02','17:55:00',1.76),('10318','2013-09-02','18:00:00',1.63),('10318','2013-09-02','18:05:00',1.46),('10318','2013-09-02','18:10:00',1.35),('10318','2013-09-02','18:15:00',1.21),('10318','2013-09-02','18:20:00',1.07),('10318','2013-09-01','07:40:00',1.15),('10318','2013-09-01','07:45:00',1.67),('10318','2013-09-01','07:50:00',2.13),('10318','2013-09-01','07:55:00',2.49),('10318','2013-09-01','08:00:00',2.65),('10318','2013-09-01','08:05:00',2.98),('10318','2013-09-01','08:10:00',3.25),('10318','2013-09-01','08:15:00',3.46),('10318','2013-09-01','08:20:00',3.66),('10318','2013-09-01','08:25:00',3.85),('10318','2013-09-01','08:30:00',4.02),('10318','2013-09-01','08:35:00',4.21),('10318','2013-09-01','08:40:00',4.41),('10318','2013-09-01','08:45:00',4.59),('10318','2013-09-01','08:50:00',4.75),('10318','2013-09-01','08:55:00',4.95),('10318','2013-09-01','09:00:00',5.04),('10318','2013-09-01','09:05:00',5.26),('10318','2013-09-01','09:10:00',5.46),('10318','2013-09-01','09:15:00',5.67),('10318','2013-09-01','09:20:00',5.83),('10318','2013-09-01','09:25:00',6),('10318','2013-09-01','09:30:00',6.14),('10318','2013-09-01','09:35:00',6.35),('10318','2013-09-01','09:40:00',6.47),('10318','2013-09-01','09:45:00',6.59),('10318','2013-09-01','09:50:00',6.75),('10318','2013-09-01','09:55:00',6.83),('10318','2013-09-01','10:00:00',6.98),('10318','2013-09-01','10:05:00',7.09),('10318','2013-09-01','10:10:00',7.18),('10318','2013-09-01','10:15:00',7.14),('10318','2013-09-01','10:20:00',7.36),('10318','2013-09-01','10:25:00',7.44),('10318','2013-09-01','10:30:00',7.54),('10318','2013-09-01','10:35:00',7.67),('10318','2013-09-01','10:40:00',7.77),('10318','2013-09-01','10:45:00',7.88),('10318','2013-09-01','10:50:00',7.98),('10318','2013-09-01','10:55:00',8.11),('10318','2013-09-01','11:00:00',8.2),('10318','2013-09-01','11:05:00',8.26),('10318','2013-09-01','11:10:00',8.3),('10318','2013-09-01','11:15:00',8.28),('10318','2013-09-01','11:20:00',8.31),('10318','2013-09-01','11:25:00',8.35),('10318','2013-09-01','11:30:00',8.45),('10318','2013-09-01','11:35:00',8.47),('10318','2013-09-01','11:40:00',8.54),('10318','2013-09-01','11:45:00',8.56),('10318','2013-09-01','11:50:00',8.61),('10318','2013-09-01','11:55:00',8.61),('10318','2013-09-01','12:00:00',8.53),('10318','2013-09-01','12:05:00',8.54),('10318','2013-09-01','12:10:00',8.65),('10318','2013-09-01','12:15:00',8.72),('10318','2013-09-01','12:20:00',8.73),('10318','2013-09-01','12:25:00',8.53),('10318','2013-09-01','12:30:00',8.67),('10318','2013-09-01','12:35:00',8.67),('10318','2013-09-01','12:40:00',8.72),('10318','2013-09-01','12:45:00',8.69),('10318','2013-09-01','12:50:00',8.63),('10318','2013-09-01','12:55:00',8.62),('10318','2013-09-01','13:00:00',8.58),('10318','2013-09-01','13:05:00',6.77),('10318','2013-09-01','13:10:00',8.66),('10318','2013-09-01','13:15:00',8.9),('10318','2013-09-01','13:20:00',7.57),('10318','2013-09-01','13:25:00',8.7),('10318','2013-09-01','13:30:00',8.69),('10318','2013-09-01','13:35:00',8.67),('10318','2013-09-01','13:40:00',8.45),('10318','2013-09-01','13:45:00',8.1),('10318','2013-09-01','13:50:00',7.79),('10318','2013-09-01','13:55:00',7.97),('10318','2013-09-01','14:00:00',7.61),('10318','2013-09-01','14:05:00',7.43),('10318','2013-09-01','14:10:00',6.9),('10318','2013-09-01','14:15:00',6.56),('10318','2013-09-01','14:20:00',6.78),('10318','2013-09-01','14:25:00',7.12),('10318','2013-09-01','14:30:00',6.29),('10318','2013-09-01','14:35:00',6.2),('10318','2013-09-01','14:40:00',6.87),('10318','2013-09-01','14:45:00',7.06),('10318','2013-09-01','14:50:00',6.53),('10318','2013-09-01','14:55:00',6.5),('10318','2013-09-01','15:00:00',6.48),('10318','2013-09-01','15:05:00',6.51),('10318','2013-09-01','15:10:00',6.48),('10318','2013-09-01','15:15:00',6.27),('10318','2013-09-01','15:20:00',6.2),('10318','2013-09-01','15:25:00',5.66),('10318','2013-09-01','15:30:00',4.86),('10318','2013-09-01','15:35:00',5.32),('10318','2013-09-01','15:40:00',5.46),('10318','2013-09-01','15:45:00',5.3),('10318','2013-09-01','15:50:00',4.7),('10318','2013-09-01','15:55:00',4.27),('10318','2013-09-01','16:00:00',4.86),('10318','2013-09-01','16:05:00',5.29),('10318','2013-09-01','16:10:00',5.04),('10318','2013-09-01','16:15:00',5.1),('10318','2013-09-01','16:20:00',5.13),('10318','2013-09-01','16:25:00',4.83),('10318','2013-09-01','16:30:00',4.95),('10318','2013-09-01','16:35:00',5.05),('10318','2013-09-01','16:40:00',4.55),('10318','2013-09-01','16:45:00',4.18),('10318','2013-09-01','16:50:00',3.97),('10318','2013-09-01','16:55:00',3.42),('10318','2013-09-01','17:00:00',3.22),('10318','2013-09-01','17:05:00',3.06),('10318','2013-09-01','17:10:00',2.71),('10318','2013-09-01','17:15:00',2.69),('10318','2013-09-01','17:20:00',2.73),('10318','2013-09-01','17:25:00',2.46),('10318','2013-09-01','17:30:00',2.55),('10318','2013-09-01','17:35:00',2.65),('10318','2013-09-01','17:40:00',2.45),('10318','2013-09-01','17:45:00',2.08),('10318','2013-09-01','17:50:00',2.14),('10318','2013-09-01','17:55:00',1.95),('10318','2013-09-01','18:00:00',1.94),('10318','2013-09-01','18:05:00',1.92),('10318','2013-09-01','18:10:00',1.87),('10318','2013-09-01','18:15:00',1.6),('10318','2013-09-01','18:20:00',1.45),('10318','2013-09-01','18:25:00',1.46),('10318','2013-09-01','18:30:00',1.26),('10318','2013-09-01','18:35:00',1.19),('10318','2013-09-01','18:40:00',1.13),('10318','2013-09-01','18:45:00',1.01),('10318','2013-08-31','07:25:00',1.02),('10318','2013-08-31','07:30:00',1.04),('10318','2013-08-31','07:35:00',1.01),('10318','2013-08-31','07:40:00',1.1),('10318','2013-08-31','07:45:00',1.21),('10318','2013-08-31','07:50:00',1.61),('10318','2013-08-31','07:55:00',1.9),('10318','2013-08-31','08:00:00',1.76),('10318','2013-08-31','08:05:00',1.79),('10318','2013-08-31','08:10:00',1.63),('10318','2013-08-31','08:15:00',2.54),('10318','2013-08-31','08:20:00',3.2),('10318','2013-08-31','08:25:00',3.81),('10318','2013-08-31','08:30:00',4.19),('10318','2013-08-31','08:35:00',4.3),('10318','2013-08-31','08:40:00',4.53),('10318','2013-08-31','08:45:00',4.83),('10318','2013-08-31','08:50:00',5.16),('10318','2013-08-31','08:55:00',5.55),('10318','2013-08-31','09:00:00',5.69),('10318','2013-08-31','09:05:00',4.99),('10318','2013-08-31','09:10:00',4),('10318','2013-08-31','09:15:00',5.68),('10318','2013-08-31','09:20:00',5.94),('10318','2013-08-31','09:25:00',6.39),('10318','2013-08-31','09:30:00',6.51),('10318','2013-08-31','09:35:00',6.74),('10318','2013-08-31','09:40:00',6.51),('10318','2013-08-31','09:45:00',6.26),('10318','2013-08-31','09:50:00',6.77),('10318','2013-08-31','09:55:00',6.92),('10318','2013-08-31','10:00:00',7.29),('10318','2013-08-31','10:05:00',7.15),('10318','2013-08-31','10:10:00',7.41),('10318','2013-08-31','10:15:00',7.51),('10318','2013-08-31','10:20:00',7.43),('10318','2013-08-31','10:25:00',7.56),('10318','2013-08-31','10:30:00',7.74),('10318','2013-08-31','10:35:00',7.69),('10318','2013-08-31','10:40:00',7.99),('10318','2013-08-31','10:45:00',8.09),('10318','2013-08-31','10:50:00',8.22),('10318','2013-08-31','10:55:00',8.32),('10318','2013-08-31','11:00:00',8.4),('10318','2013-08-31','11:05:00',8.43),('10318','2013-08-31','11:10:00',8.51),('10318','2013-08-31','11:15:00',8.59),('10318','2013-08-31','11:20:00',8.65),('10318','2013-08-31','11:25:00',8.72),('10318','2013-08-31','11:30:00',8.73),('10318','2013-08-31','11:35:00',8.77),('10318','2013-08-31','11:40:00',8.83),('10318','2013-08-31','11:45:00',8.88),('10318','2013-08-31','11:50:00',8.92),('10318','2013-08-31','11:55:00',8.95),('10318','2013-08-31','12:00:00',8.94),('10318','2013-08-31','12:05:00',8.94),('10318','2013-08-31','12:10:00',8.97),('10318','2013-08-31','12:15:00',8.93),('10318','2013-08-31','12:20:00',8.98),('10318','2013-08-31','12:25:00',8.71),('10318','2013-08-31','12:30:00',9.02),('10318','2013-08-31','12:35:00',8.99),('10318','2013-08-31','12:40:00',8.95),('10318','2013-08-31','12:45:00',8.91),('10318','2013-08-31','12:50:00',8.78),('10318','2013-08-31','12:55:00',8.87),('10318','2013-08-31','13:00:00',8.89),('10318','2013-08-31','13:05:00',8.71),('10318','2013-08-31','13:10:00',8.63),('10318','2013-08-31','13:15:00',8.75),('10318','2013-08-31','13:20:00',8.71),('10318','2013-08-31','13:25:00',8.63),('10318','2013-08-31','13:30:00',8.67),('10318','2013-08-31','13:35:00',8.44),('10318','2013-08-31','13:40:00',8.4),('10318','2013-08-31','13:45:00',8.33),('10318','2013-08-31','13:50:00',8.25),('10318','2013-08-31','13:55:00',8.18),('10318','2013-08-31','14:00:00',8.16),('10318','2013-08-31','14:05:00',8.11),('10318','2013-08-31','14:10:00',8.04),('10318','2013-08-31','14:15:00',7.97),('10318','2013-08-31','14:20:00',7.85),('10318','2013-08-31','14:25:00',7.79),('10318','2013-08-31','14:30:00',7.63),('10318','2013-08-31','14:35:00',7.39),('10318','2013-08-31','14:40:00',7.38),('10318','2013-08-31','14:45:00',7.31),('10318','2013-08-31','14:50:00',7.28),('10318','2013-08-31','14:55:00',7.12),('10318','2013-08-31','15:00:00',7.12),('10318','2013-08-31','15:05:00',7),('10318','2013-08-31','15:10:00',6.81),('10318','2013-08-31','15:15:00',6.69),('10318','2013-08-31','15:20:00',6.55),('10318','2013-08-31','15:25:00',6.33),('10318','2013-08-31','15:30:00',6.33),('10318','2013-08-31','15:35:00',6.19),('10318','2013-08-31','15:40:00',6.09),('10318','2013-08-31','15:45:00',5.87),('10318','2013-08-31','15:50:00',5.77),('10318','2013-08-31','15:55:00',5.57),('10318','2013-08-31','16:00:00',5.52),('10318','2013-08-31','16:05:00',5.42),('10318','2013-08-31','16:10:00',5.24),('10318','2013-08-31','16:15:00',4.99),('10318','2013-08-31','16:20:00',4.92),('10318','2013-08-31','16:25:00',4.63),('10318','2013-08-31','16:30:00',4.63),('10318','2013-08-31','16:35:00',4.51),('10318','2013-08-31','16:40:00',4.27),('10318','2013-08-31','16:45:00',4.01),('10318','2013-08-31','16:50:00',3.87),('10318','2013-08-31','16:55:00',3.62),('10318','2013-08-31','17:00:00',3.57),('10318','2013-08-31','17:05:00',3.45),('10318','2013-08-31','17:10:00',3.23),('10318','2013-08-31','17:15:00',3.12),('10318','2013-08-31','17:20:00',2.92),('10318','2013-08-31','17:25:00',2.74),('10318','2013-08-31','17:30:00',2.5),('10318','2013-08-31','17:35:00',2.35),('10318','2013-08-31','17:40:00',2.29),('10318','2013-08-31','17:45:00',2.12),('10318','2013-08-31','17:50:00',2.03),('10318','2013-08-31','17:55:00',1.55),('10318','2013-08-31','18:00:00',1.08),('10318','2013-08-31','18:05:00',1.02),('10318','2013-08-31','18:15:00',1.08),('10318','2013-08-31','18:20:00',1.09),('10318','2013-08-30','07:30:00',1.02),('10318','2013-08-30','07:35:00',1.31),('10318','2013-08-30','07:40:00',1.63),('10318','2013-08-30','07:45:00',1.88),('10318','2013-08-30','07:50:00',2.09),('10318','2013-08-30','07:55:00',2.32),('10318','2013-08-30','08:00:00',2.81),('10318','2013-08-30','08:05:00',3.32),('10318','2013-08-30','08:10:00',3.56),('10318','2013-08-30','08:15:00',3.23),('10318','2013-08-30','08:20:00',3.54),('10318','2013-08-30','08:25:00',3.61),('10318','2013-08-30','08:30:00',3.61),('10318','2013-08-30','08:35:00',3.82),('10318','2013-08-30','08:40:00',3.74),('10318','2013-08-30','08:45:00',3.29),('10318','2013-08-30','08:50:00',3.01),('10318','2013-08-30','08:55:00',3.13),('10318','2013-08-30','09:00:00',3.64),('10318','2013-08-30','09:05:00',3.7),('10318','2013-08-30','09:10:00',3.28),('10318','2013-08-30','09:15:00',2.99),('10318','2013-08-30','09:20:00',2.75),('10318','2013-08-30','09:25:00',3.23),('10318','2013-08-30','09:30:00',4.12),('10318','2013-08-30','09:35:00',4.13),('10318','2013-08-30','09:40:00',4.29),('10318','2013-08-30','09:45:00',4.25),('10318','2013-08-30','09:50:00',4.32),('10318','2013-08-30','09:55:00',4.56),('10318','2013-08-30','10:00:00',4.37),('10318','2013-08-30','10:05:00',4.36),('10318','2013-08-30','10:10:00',4.51),('10318','2013-08-30','10:15:00',4.87),('10318','2013-08-30','10:20:00',4.7),('10318','2013-08-30','10:25:00',4.65),('10318','2013-08-30','10:30:00',5.09),('10318','2013-08-30','10:35:00',4.9),('10318','2013-08-30','10:40:00',4.52),('10318','2013-08-30','10:45:00',4.46),('10318','2013-08-30','10:50:00',4.62),('10318','2013-08-30','10:55:00',4.51),('10318','2013-08-30','11:00:00',4.72),('10318','2013-08-30','11:05:00',5),('10318','2013-08-30','11:10:00',5.45),('10318','2013-08-30','11:15:00',5.33),('10318','2013-08-30','11:20:00',5.46),('10318','2013-08-30','11:25:00',5.58),('10318','2013-08-30','11:30:00',5.89),('10318','2013-08-30','11:35:00',5.7),('10318','2013-08-30','11:40:00',6.06),('10318','2013-08-30','11:45:00',5.99),('10318','2013-08-30','11:50:00',6.9),('10318','2013-08-30','11:55:00',5.87),('10318','2013-08-30','12:00:00',4.94),('10318','2013-08-30','12:05:00',4.66),('10318','2013-08-30','12:10:00',5.36),('10318','2013-08-30','12:15:00',5.48),('10318','2013-08-30','12:20:00',5.97),('10318','2013-08-30','12:25:00',7),('10318','2013-08-30','12:30:00',7.46),('10318','2013-08-30','12:35:00',6.93),('10318','2013-08-30','12:40:00',7.07),('10318','2013-08-30','12:45:00',7.01),('10318','2013-08-30','12:50:00',6.67),('10318','2013-08-30','12:55:00',6.09),('10318','2013-08-30','13:00:00',6.14),('10318','2013-08-30','13:05:00',5.93),('10318','2013-08-30','13:10:00',5.93),('10318','2013-08-30','13:15:00',6.58),('10318','2013-08-30','13:20:00',7.17),('10318','2013-08-30','13:25:00',8.44),('10318','2013-08-30','13:30:00',8.63),('10318','2013-08-30','13:35:00',8.29),('10318','2013-08-30','13:40:00',8.65),('10318','2013-08-30','13:45:00',7.92),('10318','2013-08-30','13:50:00',7.94),('10318','2013-08-30','13:55:00',8.32),('10318','2013-08-30','14:00:00',8.42),('10318','2013-08-30','14:05:00',8.22),('10318','2013-08-30','14:10:00',8.31),('10318','2013-08-30','14:15:00',7.95),('10318','2013-08-30','14:20:00',8.16),('10318','2013-08-30','14:25:00',7.97),('10318','2013-08-30','14:30:00',7.96),('10318','2013-08-30','14:35:00',8.01),('10318','2013-08-30','14:40:00',7.34),('10318','2013-08-30','14:45:00',6.48),('10318','2013-08-30','14:50:00',6.01),('10318','2013-08-30','14:55:00',5.82),('10318','2013-08-30','15:00:00',5.12),('10318','2013-08-30','15:05:00',4.7),('10318','2013-08-30','15:10:00',5.34),('10318','2013-08-30','15:15:00',5.63),('10318','2013-08-30','15:20:00',5.2),('10318','2013-08-30','15:25:00',4.61),('10318','2013-08-30','15:30:00',4.62),('10318','2013-08-30','15:35:00',3.85),('10318','2013-08-30','15:40:00',4.5),('10318','2013-08-30','15:45:00',5.01),('10318','2013-08-30','15:50:00',4.79),('10318','2013-08-30','15:55:00',4.57),('10318','2013-08-30','16:00:00',4.2),('10318','2013-08-30','16:05:00',3.66),('10318','2013-08-30','16:10:00',3.18),('10318','2013-08-30','16:15:00',3.35),('10318','2013-08-30','16:20:00',3.62),('10318','2013-08-30','16:25:00',3.51),('10318','2013-08-30','16:30:00',3.97),('10318','2013-08-30','16:35:00',4.62),('10318','2013-08-30','16:40:00',3.37),('10318','2013-08-30','16:45:00',3.51),('10318','2013-08-30','16:50:00',3.75),('10318','2013-08-30','16:55:00',4.07),('10318','2013-08-30','17:00:00',3.51),('10318','2013-08-30','17:05:00',2.48),('10318','2013-08-30','17:10:00',2.88),('10318','2013-08-30','17:15:00',2.58),('10318','2013-08-30','17:20:00',2.62),('10318','2013-08-30','17:25:00',2.63),('10318','2013-08-30','17:30:00',2.2),('10318','2013-08-30','17:35:00',2.83),('10318','2013-08-30','17:40:00',2.54),('10318','2013-08-30','17:45:00',2.34),('10318','2013-08-30','17:50:00',2.29),('10318','2013-08-30','17:55:00',2.39),('10318','2013-08-30','18:00:00',1.85),('10318','2013-08-30','18:05:00',1.04),('10318','2014-04-11','07:40:00',1.24),('10318','2014-04-11','07:45:00',1.77),('10318','2014-04-11','07:50:00',2.47),('10318','2014-04-11','07:55:00',1.87),('10318','2014-04-11','08:15:00',1.02),('10318','2014-04-11','08:20:00',1.11),('10318','2014-04-11','08:25:00',1.19),('10318','2014-04-11','08:30:00',4.33),('10318','2014-04-11','08:35:00',5.06),('10318','2014-04-11','08:40:00',5.33),('10318','2014-04-11','08:45:00',5.37),('10318','2014-04-11','08:50:00',5),('10318','2014-04-11','08:55:00',4.21),('10318','2014-04-11','09:00:00',5.56),('10318','2014-04-11','09:05:00',5.83),('10318','2014-04-11','09:10:00',6.04),('10318','2014-04-11','09:15:00',6.18),('10318','2014-04-11','09:20:00',6.39),('10318','2014-04-11','09:25:00',6.49),('10318','2014-04-11','09:30:00',6.67),('10318','2014-04-11','09:35:00',6.86),('10318','2014-04-11','09:40:00',7.02),('10318','2014-04-11','09:45:00',7.13),('10318','2014-04-11','09:50:00',7.31),('10318','2014-04-11','09:55:00',7.42),('10318','2014-04-11','10:00:00',7.59),('10318','2014-04-11','10:05:00',7.72),('10318','2014-04-11','10:10:00',7.85),('10318','2014-04-11','10:15:00',7.98),('10318','2014-04-11','10:20:00',8.14),('10318','2014-04-11','10:25:00',8.25),('10318','2014-04-11','10:30:00',8.31),('10318','2014-04-11','10:35:00',8.41),('10318','2014-04-11','10:40:00',8.48),('10318','2014-04-11','10:45:00',8.55),('10318','2014-04-11','10:50:00',8.75),('10318','2014-04-11','10:55:00',8.87),('10318','2014-04-11','11:00:00',8.97),('10318','2014-04-11','11:05:00',9.01),('10318','2014-04-11','11:10:00',9.16),('10318','2014-04-11','11:15:00',9.07),('10318','2014-04-11','11:20:00',9.22),('10318','2014-04-11','11:25:00',9.25),('10318','2014-04-11','11:30:00',9.31),('10318','2014-04-11','11:35:00',9.42),('10318','2014-04-11','11:40:00',9.51),('10318','2014-04-11','11:45:00',9.64),('10318','2014-04-11','11:50:00',9.69),('10318','2014-04-11','11:55:00',10.03),('10318','2014-04-11','12:00:00',9.96),('10318','2014-04-11','12:05:00',9.7),('10318','2014-04-11','12:10:00',9.46),('10318','2014-04-11','12:15:00',8.63),('10318','2014-04-11','12:20:00',9.56),('10318','2014-04-11','12:25:00',7.6),('10318','2014-04-11','12:30:00',6.04),('10318','2014-04-11','12:35:00',6.79),('10318','2014-04-11','12:40:00',7.28),('10318','2014-04-11','12:45:00',6.64),('10318','2014-04-11','12:50:00',4.75),('10318','2014-04-11','12:55:00',5.62),('10318','2014-04-11','13:00:00',10.27),('10318','2014-04-11','13:05:00',10.31),('10318','2014-04-11','13:10:00',10.21),('10318','2014-04-11','13:15:00',7.41),('10318','2014-04-11','13:20:00',9.04),('10318','2014-04-11','13:25:00',8.95),('10318','2014-04-11','13:30:00',9.89),('10318','2014-04-11','13:35:00',10.25),('10318','2014-04-11','13:40:00',8.21),('10318','2014-04-11','13:45:00',9.93),('10318','2014-04-11','13:50:00',9.04),('10318','2014-04-11','13:55:00',9.33),('10318','2014-04-11','14:00:00',8.55),('10318','2014-04-11','14:05:00',6.04),('10318','2014-04-11','14:10:00',6.14),('10318','2014-04-11','14:15:00',4.81),('10318','2014-04-11','14:20:00',7.03),('10318','2014-04-11','14:25:00',3.7),('10318','2014-04-11','14:30:00',7.14),('10318','2014-04-11','14:35:00',3.77),('10318','2014-04-11','14:40:00',9.64),('10318','2014-04-11','14:45:00',9.31),('10318','2014-04-11','14:50:00',8.91),('10318','2014-04-11','14:55:00',8.23),('10318','2014-04-11','15:00:00',8.4),('10318','2014-04-11','15:05:00',8.35),('10318','2014-04-11','15:10:00',8.22),('10318','2014-04-11','15:15:00',7.28),('10318','2014-04-11','15:20:00',8.05),('10318','2014-04-11','15:25:00',7.61),('10318','2014-04-11','15:30:00',7.36),('10318','2014-04-11','15:35:00',7.4),('10318','2014-04-11','15:40:00',7.12),('10318','2014-04-11','15:45:00',7.17),('10318','2014-04-11','15:50:00',6.97),('10318','2014-04-11','15:55:00',6.98),('10318','2014-04-11','16:00:00',5.74),('10318','2014-04-11','16:05:00',6.48),('10318','2014-04-11','16:10:00',6.27),('10318','2014-04-11','16:15:00',5.93),('10318','2014-04-11','16:20:00',5.57),('10318','2014-04-11','16:25:00',5.39),('10318','2014-04-11','16:30:00',5.3),('10318','2014-04-11','16:35:00',5.43),('10318','2014-04-11','16:40:00',5.08),('10318','2014-04-11','16:45:00',5.06),('10318','2014-04-11','16:50:00',5.14),('10318','2014-04-11','16:55:00',4.78),('10318','2014-04-11','17:00:00',3.45),('10318','2014-04-11','17:05:00',3.46),('10318','2014-04-11','17:10:00',3.5),('10318','2014-04-11','17:15:00',3.79),('10318','2014-04-11','17:20:00',3.5),('10318','2014-04-11','17:25:00',3.28),('10318','2014-04-11','17:30:00',3.39),('10318','2014-04-11','17:35:00',3.21),('10318','2014-04-11','17:40:00',2.61),('10318','2014-04-11','17:45:00',2.63),('10318','2014-04-11','17:50:00',2.34),('10318','2014-04-11','17:55:00',1.48),('10318','2014-04-11','18:00:00',1.88),('10318','2014-04-11','18:05:00',1.78),('10318','2014-04-11','18:10:00',1.66),('10318','2014-04-11','18:15:00',1.5),('10318','2014-04-11','18:20:00',1.38),('10318','2014-04-11','18:25:00',1.29),('10318','2014-04-11','18:30:00',1.25),('10318','2014-04-11','18:35:00',1.07),('10318','2013-08-29','07:35:00',1.26),('10318','2013-08-29','07:40:00',1.68),('10318','2013-08-29','07:45:00',2.01),('10318','2013-08-29','07:50:00',2.4),('10318','2013-08-29','07:55:00',2.72),('10318','2013-08-29','08:00:00',2.98),('10318','2013-08-29','08:05:00',3.19),('10318','2013-08-29','08:10:00',3.4),('10318','2013-08-29','08:15:00',3.75),('10318','2013-08-29','08:20:00',4.18),('10318','2013-08-29','08:25:00',4.59),('10318','2013-08-29','08:30:00',5.07),('10318','2013-08-29','08:35:00',4.38),('10318','2013-08-29','08:40:00',3.17),('10318','2013-08-29','08:45:00',2.58),('10318','2013-08-29','08:50:00',3.14),('10318','2013-08-29','08:55:00',3.59),('10318','2013-08-29','09:00:00',3.66),('10318','2013-08-29','09:05:00',3.34),('10318','2013-08-29','09:10:00',3.63),('10318','2013-08-29','09:15:00',3.71),('10318','2013-08-29','09:20:00',3.66),('10318','2013-08-29','09:25:00',3.52),('10318','2013-08-29','09:30:00',3.71),('10318','2013-08-29','09:35:00',4.13),('10318','2013-08-29','09:40:00',4.01),('10318','2013-08-29','09:45:00',3.38),('10318','2013-08-29','09:50:00',3.23),('10318','2013-08-29','09:55:00',3.33),('10318','2013-08-29','10:00:00',3.46),('10318','2013-08-29','10:05:00',3.31),('10318','2013-08-29','10:10:00',3.31),('10318','2013-08-29','10:15:00',3.34),('10318','2013-08-29','10:20:00',3.36),('10318','2013-08-29','10:25:00',3.38),('10318','2013-08-29','10:30:00',3.47),('10318','2013-08-29','10:35:00',3.19),('10318','2013-08-29','10:40:00',2.89),('10318','2013-08-29','10:45:00',2.74),('10318','2013-08-29','10:50:00',2.75),('10318','2013-08-29','10:55:00',3.16),('10318','2013-08-29','11:00:00',3.31),('10318','2013-08-29','11:05:00',3.49),('10318','2013-08-29','11:10:00',4.82),('10318','2013-08-29','11:15:00',4.72),('10318','2013-08-29','11:20:00',4.44),('10318','2013-08-29','11:25:00',3.67),('10318','2013-08-29','11:30:00',3.18),('10318','2013-08-29','11:35:00',3.03),('10318','2013-08-29','11:40:00',3.59),('10318','2013-08-29','11:45:00',4.08),('10318','2013-08-29','11:50:00',4.14),('10318','2013-08-29','11:55:00',3.85),('10318','2013-08-29','12:00:00',3.93),('10318','2013-08-29','12:05:00',4.57),('10318','2013-08-29','12:10:00',5.79),('10318','2013-08-29','12:15:00',6.27),('10318','2013-08-29','12:20:00',7.13),('10318','2013-08-29','12:25:00',6.36),('10318','2013-08-29','12:30:00',5.91),('10318','2013-08-29','12:35:00',7.34),('10318','2013-08-29','12:40:00',9.07),('10318','2013-08-29','12:45:00',8.62),('10318','2013-08-29','12:50:00',5.65),('10318','2013-08-29','12:55:00',6.62),('10318','2013-08-29','13:00:00',5.35),('10318','2013-08-29','13:05:00',5.65),('10318','2013-08-29','13:10:00',5.13),('10318','2013-08-29','13:15:00',5.21),('10318','2013-08-29','13:20:00',5.21),('10318','2013-08-29','13:25:00',4.23),('10318','2013-08-29','13:30:00',3.97),('10318','2013-08-29','13:35:00',3.8),('10318','2013-08-29','13:40:00',3.58),('10318','2013-08-29','13:45:00',3.3),('10318','2013-08-29','13:50:00',3.34),('10318','2013-08-29','13:55:00',4.47),('10318','2013-08-29','14:00:00',4.66),('10318','2013-08-29','14:05:00',3.41),('10318','2013-08-29','14:10:00',3.03),('10318','2013-08-29','14:15:00',2.52),('10318','2013-08-29','14:20:00',2.17),('10318','2013-08-29','14:25:00',1.98),('10318','2013-08-29','14:30:00',1.98),('10318','2013-08-29','14:35:00',2.04),('10318','2013-08-29','14:40:00',2.15),('10318','2013-08-29','14:45:00',2.39),('10318','2013-08-29','14:50:00',2.74),('10318','2013-08-29','14:55:00',3.21),('10318','2013-08-29','15:00:00',3.59),('10318','2013-08-29','15:05:00',3.94),('10318','2013-08-29','15:10:00',2.85),('10318','2013-08-29','15:15:00',2.62),('10318','2013-08-29','15:20:00',3.53),('10318','2013-08-29','15:25:00',4.3),('10318','2013-08-29','15:30:00',5.81),('10318','2013-08-29','15:35:00',4.36),('10318','2013-08-29','15:40:00',5.33),('10318','2013-08-29','15:45:00',4.06),('10318','2013-08-29','15:50:00',6.31),('10318','2013-08-29','15:55:00',6.08),('10318','2013-08-29','16:00:00',5.6),('10318','2013-08-29','16:05:00',7.01),('10318','2013-08-29','16:10:00',6.27),('10318','2013-08-29','16:15:00',5.78),('10318','2013-08-29','16:20:00',5.44),('10318','2013-08-29','16:25:00',5.23),('10318','2013-08-29','16:30:00',4.88),('10318','2013-08-29','16:35:00',4.81),('10318','2013-08-29','16:40:00',4.62),('10318','2013-08-29','16:45:00',4.38),('10318','2013-08-29','16:50:00',4.19),('10318','2013-08-29','16:55:00',4.03),('10318','2013-08-29','17:00:00',3.86),('10318','2013-08-29','17:05:00',3.69),('10318','2013-08-29','17:10:00',3.5),('10318','2013-08-29','17:15:00',3.3),('10318','2013-08-29','17:20:00',3.06),('10318','2013-08-29','17:25:00',2.88),('10318','2013-08-29','17:30:00',2.75),('10318','2013-08-29','17:35:00',2.57),('10318','2013-08-29','17:40:00',2.43),('10318','2013-08-29','17:45:00',2.25),('10318','2013-08-29','17:50:00',2.08),('10318','2013-08-29','17:55:00',1.93),('10318','2013-08-29','18:00:00',1.79),('10318','2013-08-29','18:05:00',1.64),('10318','2013-08-29','18:10:00',1.5),('10318','2013-08-29','18:15:00',1.36),('10318','2013-08-29','18:20:00',1.22),('10318','2013-08-29','18:25:00',1.06),('10318','2013-08-28','07:35:00',1.27),('10318','2013-08-28','07:40:00',1.43),('10318','2013-08-28','07:45:00',1.6),('10318','2013-08-28','07:50:00',1.87),('10318','2013-08-28','07:55:00',2.74),('10318','2013-08-28','08:00:00',2.59),('10318','2013-08-28','08:05:00',3.03),('10318','2013-08-28','08:10:00',3.34),('10318','2013-08-28','08:15:00',3.55),('10318','2013-08-28','08:20:00',3.7),('10318','2013-08-28','08:25:00',3.89),('10318','2013-08-28','08:30:00',4.06),('10318','2013-08-28','08:35:00',3.92),('10318','2013-08-28','08:40:00',4.18),('10318','2013-08-28','08:45:00',2.2),('10318','2013-08-28','08:50:00',2.06),('10318','2013-08-28','08:55:00',3.89),('10318','2013-08-28','09:00:00',5.17),('10318','2013-08-28','09:05:00',5.27),('10318','2013-08-28','09:10:00',5.28),('10318','2013-08-28','09:15:00',3.75),('10318','2013-08-28','09:20:00',2.9),('10318','2013-08-28','09:25:00',3.07),('10318','2013-08-28','09:30:00',6.15),('10318','2013-08-28','09:35:00',6.53),('10318','2013-08-28','09:40:00',6.6),('10318','2013-08-28','09:45:00',6.64),('10318','2013-08-28','09:50:00',6.76),('10318','2013-08-28','09:55:00',6.76),('10318','2013-08-28','10:00:00',7.03),('10318','2013-08-28','10:05:00',7.22),('10318','2013-08-28','10:10:00',7.11),('10318','2013-08-28','10:15:00',4.14),('10318','2013-08-28','10:20:00',7.76),('10318','2013-08-28','10:25:00',6.83),('10318','2013-08-28','10:30:00',3.71),('10318','2013-08-28','10:35:00',7.36),('10318','2013-08-28','10:40:00',5.87),('10318','2013-08-28','10:45:00',6.25),('10318','2013-08-28','10:50:00',8.86),('10318','2013-08-28','10:55:00',8.96),('10318','2013-08-28','11:00:00',7.32),('10318','2013-08-28','11:05:00',1.62),('10318','2013-08-28','11:10:00',6.35),('10318','2013-08-28','11:15:00',7.53),('10318','2013-08-28','11:20:00',9.29),('10318','2013-08-28','11:25:00',5.58),('10318','2013-08-28','11:30:00',8.65),('10318','2013-08-28','11:35:00',3.7),('10318','2013-08-28','11:40:00',7.63),('10318','2013-08-28','11:45:00',9.77),('10318','2013-08-28','11:50:00',7.9),('10318','2013-08-28','11:55:00',9.76),('10318','2013-08-28','12:00:00',9.84),('10318','2013-08-28','12:05:00',9.84),('10318','2013-08-28','12:10:00',9.43),('10318','2013-08-28','12:15:00',9.46),('10318','2013-08-28','12:20:00',6.55),('10318','2013-08-28','12:25:00',9.66),('10318','2013-08-28','12:30:00',9.52),('10318','2013-08-28','12:35:00',9.35),('10318','2013-08-28','12:40:00',5.06),('10318','2013-08-28','12:45:00',9.18),('10318','2013-08-28','12:50:00',9.27),('10318','2013-08-28','12:55:00',9.26),('10318','2013-08-28','13:00:00',8.43),('10318','2013-08-28','13:05:00',8.83),('10318','2013-08-28','13:10:00',9.21),('10318','2013-08-28','13:15:00',9.06),('10318','2013-08-28','13:20:00',9.21),('10318','2013-08-28','13:25:00',9.42),('10318','2013-08-28','13:30:00',8.39),('10318','2013-08-28','13:35:00',9.19),('10318','2013-08-28','13:40:00',7.63),('10318','2013-08-28','13:45:00',8.46),('10318','2013-08-28','13:50:00',9.03),('10318','2013-08-28','13:55:00',8.74),('10318','2013-08-28','14:00:00',8.53),('10318','2013-08-28','14:05:00',6.29),('10318','2013-08-28','14:10:00',8.88),('10318','2013-08-28','14:15:00',8.38),('10318','2013-08-28','14:20:00',8.55),('10318','2013-08-28','14:25:00',8.53),('10318','2013-08-28','14:30:00',8.61),('10318','2013-08-28','14:35:00',8.57),('10318','2013-08-28','14:40:00',8.28),('10318','2013-08-28','14:45:00',8.07),('10318','2013-08-28','14:50:00',7.91),('10318','2013-08-28','14:55:00',7.82),('10318','2013-08-28','15:00:00',7.73),('10318','2013-08-28','15:05:00',7.77),('10318','2013-08-28','15:10:00',7.82),('10318','2013-08-28','15:15:00',6.22),('10318','2013-08-28','15:20:00',7.57),('10318','2013-08-28','15:25:00',7.45),('10318','2013-08-28','15:30:00',5.09),('10318','2013-08-28','15:35:00',4.35),('10318','2013-08-28','15:40:00',7.01),('10318','2013-08-28','15:45:00',6.78),('10318','2013-08-28','15:50:00',6.73),('10318','2013-08-28','15:55:00',6.49),('10318','2013-08-28','16:00:00',6.33),('10318','2013-08-28','16:05:00',6.38),('10318','2013-08-28','16:10:00',6.15),('10318','2013-08-28','16:15:00',5.16),('10318','2013-08-28','16:20:00',4.79),('10318','2013-08-28','16:25:00',4.36),('10318','2013-08-28','16:30:00',5.37),('10318','2013-08-28','16:35:00',5.01),('10318','2013-08-28','16:40:00',4.82),('10318','2013-08-28','16:45:00',4.5),('10318','2013-08-28','16:50:00',4.35),('10318','2013-08-28','16:55:00',4.17),('10318','2013-08-28','17:00:00',4.01),('10318','2013-08-28','17:05:00',3.79),('10318','2013-08-28','17:10:00',3.04),('10318','2013-08-28','17:15:00',3.03),('10318','2013-08-28','17:20:00',1.29),('10318','2013-08-28','17:25:00',2.31),('10318','2013-08-28','17:30:00',2.6),('10318','2013-08-28','17:35:00',3),('10318','2013-08-28','17:40:00',2.36),('10318','2013-08-28','17:45:00',1.48),('10318','2013-08-28','17:50:00',1.51),('10318','2013-08-28','18:05:00',1.35),('10318','2013-08-28','18:10:00',1.72),('10318','2013-08-28','18:15:00',1.08),('10318','2013-08-28','18:20:00',1.45),('10318','2013-08-28','18:50:00',1.08),('10318','2013-08-27','08:00:00',1.12),('10318','2013-08-27','08:05:00',1.34),('10318','2013-08-27','08:10:00',1.62),('10318','2013-08-27','08:15:00',2.06),('10318','2013-08-27','08:20:00',2.88),('10318','2013-08-27','08:25:00',3.56),('10318','2013-08-27','08:30:00',3.41),('10318','2013-08-27','08:35:00',2.49),('10318','2013-08-27','08:40:00',2.61),('10318','2013-08-27','08:45:00',2.72),('10318','2013-08-27','08:50:00',2.47),('10318','2013-08-27','08:55:00',2.24),('10318','2013-08-27','09:00:00',2.54),('10318','2013-08-27','09:05:00',3.01),('10318','2013-08-27','09:10:00',3.71),('10318','2013-08-27','09:15:00',3.99),('10318','2013-08-27','09:20:00',4.41),('10318','2013-08-27','09:25:00',5.22),('10318','2013-08-27','09:30:00',5.82),('10318','2013-08-27','09:35:00',3.48),('10318','2013-08-27','09:40:00',2.73),('10318','2013-08-27','09:45:00',2.98),('10318','2013-08-27','09:50:00',3.33),('10318','2013-08-27','09:55:00',4.23),('10318','2013-08-27','10:00:00',5.29),('10318','2013-08-27','10:05:00',6.15),('10318','2013-08-27','10:10:00',7.06),('10318','2013-08-27','10:15:00',7.32),('10318','2013-08-27','10:20:00',7.39),('10318','2013-08-27','10:25:00',7.48),('10318','2013-08-27','10:30:00',7.52),('10318','2013-08-27','10:35:00',7.66),('10318','2013-08-27','10:40:00',7.72),('10318','2013-08-27','10:45:00',7.77),('10318','2013-08-27','10:50:00',7.8),('10318','2013-08-27','10:55:00',7.72),('10318','2013-08-27','11:00:00',7.85),('10318','2013-08-27','11:05:00',7.75),('10318','2013-08-27','11:10:00',7.46),('10318','2013-08-27','11:15:00',5.88),('10318','2013-08-27','11:20:00',8.19),('10318','2013-08-27','11:25:00',8.1),('10318','2013-08-27','11:30:00',8.18),('10318','2013-08-27','11:35:00',8.22),('10318','2013-08-27','11:40:00',7.58),('10318','2013-08-27','11:45:00',7.14),('10318','2013-08-27','11:50:00',5.89),('10318','2013-08-27','11:55:00',8.53),('10318','2013-08-27','12:00:00',8.11),('10318','2013-08-27','12:05:00',8.42),('10318','2013-08-27','12:10:00',5.05),('10318','2013-08-27','12:15:00',4.68),('10318','2013-08-27','12:20:00',8.46),('10318','2013-08-27','12:25:00',5.16),('10318','2013-08-27','12:30:00',4.32),('10318','2013-08-27','12:35:00',6.56),('10318','2013-08-27','12:40:00',9.5),('10318','2013-08-27','12:45:00',5.99),('10318','2013-08-27','12:50:00',4.44),('10318','2013-08-27','12:55:00',3.23),('10318','2013-08-27','13:00:00',2.43),('10318','2013-08-27','13:05:00',2.5),('10318','2013-08-27','13:10:00',3.75),('10318','2013-08-27','13:15:00',3.83),('10318','2013-08-27','13:20:00',4.17),('10318','2013-08-27','13:25:00',4.82),('10318','2013-08-27','13:30:00',4.79),('10318','2013-08-27','13:35:00',3.75),('10318','2013-08-27','13:40:00',3.49),('10318','2013-08-27','13:45:00',4.48),('10318','2013-08-27','13:50:00',5.13),('10318','2013-08-27','13:55:00',6.1),('10318','2013-08-27','14:00:00',7.59),('10318','2013-08-27','14:05:00',4.55),('10318','2013-08-27','14:10:00',4.52),('10318','2013-08-27','14:15:00',6.48),('10318','2013-08-27','14:20:00',5.3),('10318','2013-08-27','14:25:00',3.24),('10318','2013-08-27','14:30:00',2.64),('10318','2013-08-27','14:35:00',2.65),('10318','2013-08-27','14:40:00',3.12),('10318','2013-08-27','14:45:00',2.9),('10318','2013-08-27','14:50:00',2.34),('10318','2013-08-27','14:55:00',1.93),('10318','2013-08-27','15:00:00',2.06),('10318','2013-08-27','15:05:00',1.99),('10318','2013-08-27','15:10:00',1.91),('10318','2013-08-27','15:15:00',1.55),('10318','2013-08-27','15:20:00',1.17),('10318','2013-08-27','15:25:00',1.04),('10318','2013-08-27','15:30:00',1.36),('10318','2013-08-27','15:35:00',1.45),('10318','2013-08-27','15:40:00',1.34),('10318','2013-08-27','15:45:00',1.25),('10318','2013-08-27','15:50:00',1.72),('10318','2013-08-27','15:55:00',3.49),('10318','2013-08-27','16:00:00',5.06),('10318','2013-08-27','16:05:00',5.66),('10318','2013-08-27','16:10:00',6.96),('10318','2013-08-27','16:15:00',6.41),('10318','2013-08-27','16:20:00',3.62),('10318','2013-08-27','16:25:00',1.85),('10318','2013-08-27','16:30:00',3.29),('10318','2013-08-27','16:35:00',3.7),('10318','2013-08-27','16:40:00',2.14),('10318','2013-08-27','16:45:00',4.26),('10318','2013-08-27','16:50:00',3.41),('10318','2013-08-27','16:55:00',3.71),('10318','2013-08-27','17:00:00',1.84),('10318','2013-08-27','17:05:00',4.22),('10318','2013-08-27','17:10:00',4.02),('10318','2013-08-27','17:15:00',1.84),('10318','2013-08-27','17:20:00',2.22),('10318','2013-08-27','17:25:00',1.66),('10318','2013-08-27','17:30:00',1.45),('10318','2013-08-27','17:35:00',1.65),('10318','2013-08-27','17:40:00',1.55),('10318','2013-08-27','17:45:00',2.51),('10318','2013-08-27','17:50:00',2.44),('10318','2013-08-27','17:55:00',2.33),('10318','2013-08-27','18:00:00',2),('10318','2013-08-27','18:05:00',1.22),('10318','2013-08-26','07:25:00',1.15),('10318','2013-08-26','07:30:00',1.2),('10318','2013-08-26','07:35:00',1.36),('10318','2013-08-26','07:40:00',1.4),('10318','2013-08-26','07:45:00',1.68),('10318','2013-08-26','07:50:00',1.77),('10318','2013-08-26','07:55:00',1.52),('10318','2013-08-26','08:00:00',2.47),('10318','2013-08-26','08:05:00',3.25),('10318','2013-08-26','08:10:00',2.52),('10318','2013-08-26','08:15:00',2.72),('10318','2013-08-26','08:20:00',3.61),('10318','2013-08-26','08:25:00',2.94),('10318','2013-08-26','08:30:00',2.86),('10318','2013-08-26','08:35:00',4.33),('10318','2013-08-26','08:40:00',4.41),('10318','2013-08-26','08:45:00',4.68),('10318','2013-08-26','08:50:00',4.85),('10318','2013-08-26','08:55:00',5.02),('10318','2013-08-26','09:00:00',5.22),('10318','2013-08-26','09:05:00',5.37),('10318','2013-08-26','09:10:00',5.51),('10318','2013-08-26','09:15:00',5.64),('10318','2013-08-26','09:20:00',5.85),('10318','2013-08-26','09:25:00',6),('10318','2013-08-26','09:30:00',6.06),('10318','2013-08-26','09:35:00',6.25),('10318','2013-08-26','09:40:00',6.39),('10318','2013-08-26','09:45:00',6.5),('10318','2013-08-26','09:50:00',6.57),('10318','2013-08-26','09:55:00',6.7),('10318','2013-08-26','10:00:00',6.86),('10318','2013-08-26','10:05:00',7.01),('10318','2013-08-26','10:10:00',7.14),('10318','2013-08-26','10:15:00',7.22),('10318','2013-08-26','10:20:00',7.31),('10318','2013-08-26','10:25:00',7.43),('10318','2013-08-26','10:30:00',7.36),('10318','2013-08-26','10:35:00',7.6),('10318','2013-08-26','10:40:00',7.69),('10318','2013-08-26','10:45:00',7.77),('10318','2013-08-26','10:50:00',7.82),('10318','2013-08-26','10:55:00',7.94),('10318','2013-08-26','11:00:00',8.02),('10318','2013-08-26','11:05:00',8.11),('10318','2013-08-26','11:10:00',8.01),('10318','2013-08-26','11:15:00',8.11),('10318','2013-08-26','11:20:00',8.36),('10318','2013-08-26','11:25:00',8.39),('10318','2013-08-26','11:30:00',8.41),('10318','2013-08-26','11:35:00',8.42),('10318','2013-08-26','11:40:00',8.38),('10318','2013-08-26','11:45:00',8.53),('10318','2013-08-26','11:50:00',8.53),('10318','2013-08-26','11:55:00',8.51),('10318','2013-08-26','12:00:00',8.53),('10318','2013-08-26','12:05:00',8.61),('10318','2013-08-26','12:10:00',8.59),('10318','2013-08-26','12:15:00',8.61),('10318','2013-08-26','12:20:00',8.6),('10318','2013-08-26','12:25:00',8.53),('10318','2013-08-26','12:30:00',8.43),('10318','2013-08-26','12:35:00',8.53),('10318','2013-08-26','12:40:00',8.72),('10318','2013-08-26','12:45:00',8.75),('10318','2013-08-26','12:50:00',8.78),('10318','2013-08-26','12:55:00',8.66),('10318','2013-08-26','13:00:00',6.82),('10318','2013-08-26','13:05:00',6.74),('10318','2013-08-26','13:10:00',7.34),('10318','2013-08-26','13:15:00',7.86),('10318','2013-08-26','13:20:00',7),('10318','2013-08-26','13:25:00',7.33),('10318','2013-08-26','13:30:00',7.54),('10318','2013-08-26','13:35:00',8.22),('10318','2013-08-26','13:40:00',8.55),('10318','2013-08-26','13:45:00',8.56),('10318','2013-08-26','13:50:00',8.39),('10318','2013-08-26','13:55:00',5.4),('10318','2013-08-26','14:00:00',7.85),('10318','2013-08-26','14:05:00',7.49),('10318','2013-08-26','14:10:00',7.71),('10318','2013-08-26','14:15:00',7.58),('10318','2013-08-26','14:20:00',8.06),('10318','2013-08-26','14:25:00',7.85),('10318','2013-08-26','14:30:00',7.92),('10318','2013-08-26','14:35:00',7.75),('10318','2013-08-26','14:40:00',7.35),('10318','2013-08-26','14:45:00',5.37),('10318','2013-08-26','14:50:00',3.65),('10318','2013-08-26','14:55:00',3.65),('10318','2013-08-26','15:00:00',3.8),('10318','2013-08-26','15:05:00',2.83),('10318','2013-08-26','15:10:00',2.26),('10318','2013-08-26','15:15:00',1.99),('10318','2013-08-26','15:20:00',1.69),('10318','2013-08-26','15:25:00',1.63),('10318','2013-08-26','15:30:00',1.76),('10318','2013-08-26','15:35:00',2.28),('10318','2013-08-26','15:40:00',3.26),('10318','2013-08-26','15:45:00',3.38),('10318','2013-08-26','15:50:00',3.81),('10318','2013-08-26','15:55:00',3.11),('10318','2013-08-26','16:00:00',6.06),('10318','2013-08-26','16:05:00',6.4),('10318','2013-08-26','16:10:00',5.61),('10318','2013-08-26','16:15:00',5.37),('10318','2013-08-26','16:20:00',5.15),('10318','2013-08-26','16:25:00',4.94),('10318','2013-08-26','16:30:00',4.76),('10318','2013-08-26','16:35:00',4.69),('10318','2013-08-26','16:40:00',4.51),('10318','2013-08-26','16:45:00',4.36),('10318','2013-08-26','16:50:00',4.08),('10318','2013-08-26','16:55:00',3.93),('10318','2013-08-26','17:00:00',3.73),('10318','2013-08-26','17:05:00',3.46),('10318','2013-08-26','17:10:00',3.43),('10318','2013-08-26','17:15:00',3.22),('10318','2013-08-26','17:20:00',2.13),('10318','2013-08-26','17:25:00',1.4),('10318','2013-08-26','17:30:00',2.42),('10318','2013-08-26','17:35:00',2.03),('10318','2013-08-26','17:40:00',2.01),('10318','2013-08-26','17:45:00',2.27),('10318','2013-08-26','17:50:00',2.47),('10318','2013-08-26','17:55:00',2.36),('10318','2013-08-26','18:00:00',2.07),('10318','2013-08-26','18:05:00',1.77),('10318','2013-08-26','18:10:00',1.56),('10318','2013-08-26','18:15:00',1.39),('10318','2013-08-26','18:20:00',1.25),('10318','2013-08-26','18:25:00',1.12),('10318','2013-08-26','18:30:00',1.01),('10318','2013-08-25','07:30:00',1.02),('10318','2013-08-25','07:35:00',1.01),('10318','2013-08-25','07:40:00',1.38),('10318','2013-08-25','07:45:00',1.82),('10318','2013-08-25','07:50:00',2.19),('10318','2013-08-25','07:55:00',2.26),('10318','2013-08-25','08:00:00',2.33),('10318','2013-08-25','08:05:00',2.68),('10318','2013-08-25','08:10:00',2.48),('10318','2013-08-25','08:15:00',2.29),('10318','2013-08-25','08:20:00',3.04),('10318','2013-08-25','08:25:00',3.49),('10318','2013-08-25','08:30:00',2.83),('10318','2013-08-25','08:35:00',3.55),('10318','2013-08-25','08:40:00',3.79),('10318','2013-08-25','08:45:00',2.6),('10318','2013-08-25','08:50:00',2.74),('10318','2013-08-25','08:55:00',2.49),('10318','2013-08-25','09:05:00',2.09),('10318','2013-08-25','09:10:00',3.76),('10318','2013-08-25','09:15:00',3.99),('10318','2013-08-25','09:20:00',5.79),('10318','2013-08-25','09:25:00',5.95),('10318','2013-08-25','09:30:00',6.35),('10318','2013-08-25','09:35:00',6.62),('10318','2013-08-25','09:40:00',4.13),('10318','2013-08-25','09:45:00',3.91),('10318','2013-08-25','09:50:00',5.42),('10318','2013-08-25','09:55:00',6.29),('10318','2013-08-25','10:00:00',4.76),('10318','2013-08-25','10:05:00',2.82),('10318','2013-08-25','10:10:00',1.62),('10318','2013-08-25','10:15:00',1.43),('10318','2013-08-25','10:20:00',1.21),('10318','2013-08-25','10:25:00',1.05),('10318','2013-08-25','14:55:00',1.23),('10318','2013-08-25','15:00:00',1.68),('10318','2013-08-25','15:05:00',2.1),('10318','2013-08-25','15:10:00',2.31),('10318','2013-08-25','15:15:00',2.66),('10318','2013-08-25','15:20:00',3.17),('10318','2013-08-25','15:25:00',3.43),('10318','2013-08-25','15:30:00',5.49),('10318','2013-08-25','15:35:00',7.84),('10318','2013-08-25','15:40:00',4.98),('10318','2013-08-25','15:45:00',3.44),('10318','2013-08-25','15:50:00',4.36),('10318','2013-08-25','15:55:00',4.26),('10318','2013-08-25','16:00:00',5.55),('10318','2013-08-25','16:05:00',6.38),('10318','2013-08-25','16:10:00',6.02),('10318','2013-08-25','16:15:00',5.73),('10318','2013-08-25','16:20:00',5.5),('10318','2013-08-25','16:25:00',5.31),('10318','2013-08-25','16:30:00',5.17),('10318','2013-08-25','16:35:00',4.83),('10318','2013-08-25','16:40:00',3.54),('10318','2013-08-25','16:45:00',2.86),('10318','2013-08-25','16:50:00',4.3),('10318','2013-08-25','16:55:00',4.84),('10318','2013-08-25','17:00:00',4.25),('10318','2013-08-25','17:05:00',4.17),('10318','2013-08-25','17:10:00',3.76),('10318','2013-08-25','17:15:00',3.47),('10318','2013-08-25','17:20:00',3.28),('10318','2013-08-25','17:25:00',3.08),('10318','2013-08-25','17:30:00',2.87),('10318','2013-08-25','17:35:00',2.09),('10318','2013-08-25','17:40:00',2.25),('10318','2013-08-25','17:45:00',2.44),('10318','2013-08-25','17:50:00',2.16),('10318','2013-08-25','17:55:00',1.61),('10318','2013-08-25','18:00:00',1.52),('10318','2013-08-25','18:05:00',1.36),('10318','2013-08-25','18:10:00',1.61),('10318','2013-08-25','18:15:00',1.64),('10318','2013-08-25','18:20:00',1.49),('10318','2013-08-25','18:25:00',1.26),('10318','2013-08-24','07:30:00',1.02),('10318','2013-08-24','07:35:00',1.15),('10318','2013-08-24','07:40:00',1.59),('10318','2013-08-24','07:45:00',1.92),('10318','2013-08-24','07:50:00',2.11),('10318','2013-08-24','07:55:00',2.3),('10318','2013-08-24','08:00:00',2.53),('10318','2013-08-24','08:05:00',2.75),('10318','2013-08-24','08:10:00',2.96),('10318','2013-08-24','08:15:00',3.16),('10318','2013-08-24','08:20:00',3.27),('10318','2013-08-24','08:25:00',3.54),('10318','2013-08-24','08:30:00',3.74),('10318','2013-08-24','08:35:00',4.02),('10318','2013-08-24','08:40:00',3.61),('10318','2013-08-24','08:45:00',4.66),('10318','2013-08-24','08:50:00',4.86),('10318','2013-08-24','08:55:00',4.22),('10318','2013-08-24','09:00:00',1.63),('10318','2013-08-24','09:05:00',4.97),('10318','2013-08-24','09:10:00',5.32),('10318','2013-08-24','09:15:00',5.54),('10318','2013-08-24','09:20:00',5.49),('10318','2013-08-24','09:25:00',5.34),('10318','2013-08-24','09:30:00',5.98),('10318','2013-08-24','09:35:00',6.18),('10318','2013-08-24','09:40:00',6.2),('10318','2013-08-24','09:45:00',6.36),('10318','2013-08-24','09:50:00',6.53),('10318','2013-08-24','09:55:00',6.67),('10318','2013-08-24','10:00:00',6.08),('10318','2013-08-24','10:05:00',6.99),('10318','2013-08-24','10:10:00',7.04),('10318','2013-08-24','10:15:00',7.23),('10318','2013-08-24','10:20:00',7.34),('10318','2013-08-24','10:25:00',7.45),('10318','2013-08-24','10:30:00',7.54),('10318','2013-08-24','10:35:00',7.64),('10318','2013-08-24','10:40:00',7.71),('10318','2013-08-24','10:45:00',7.79),('10318','2013-08-24','10:50:00',7.85),('10318','2013-08-24','10:55:00',7.82),('10318','2013-08-24','11:00:00',8.03),('10318','2013-08-24','11:05:00',7.48),('10318','2013-08-24','11:10:00',8.16),('10318','2013-08-24','11:15:00',8.07),('10318','2013-08-24','11:20:00',8.18),('10318','2013-08-24','11:25:00',8.14),('10318','2013-08-24','11:30:00',8.42),('10318','2013-08-24','11:35:00',8.43),('10318','2013-08-24','11:40:00',8.44),('10318','2013-08-24','11:45:00',8.43),('10318','2013-08-24','11:50:00',8.59),('10318','2013-08-24','11:55:00',8.41),('10318','2013-08-24','12:00:00',8.31),('10318','2013-08-24','12:05:00',8.54),('10318','2013-08-24','12:10:00',8.62),('10318','2013-08-24','12:15:00',8.68),('10318','2013-08-24','12:20:00',8.69),('10318','2013-08-24','12:25:00',8.67),('10318','2013-08-24','12:30:00',8.66),('10318','2013-08-24','12:35:00',8.69),('10318','2013-08-24','12:40:00',8.66),('10318','2013-08-24','12:45:00',8.62),('10318','2013-08-24','12:50:00',8.6),('10318','2013-08-24','12:55:00',8.63),('10318','2013-08-24','13:00:00',8.54),('10318','2013-08-24','13:05:00',8.62),('10318','2013-08-24','13:10:00',8.39),('10318','2013-08-24','13:15:00',8.55),('10318','2013-08-24','13:20:00',8.5),('10318','2013-08-24','13:25:00',8.48),('10318','2013-08-24','13:30:00',8.46),('10318','2013-08-24','13:35:00',8.38),('10318','2013-08-24','13:40:00',8.38),('10318','2013-08-24','13:45:00',8.38),('10318','2013-08-24','13:50:00',8.3),('10318','2013-08-24','13:55:00',8.2),('10318','2013-08-24','14:00:00',8.17),('10318','2013-08-24','14:05:00',8.11),('10318','2013-08-24','14:10:00',8.07),('10318','2013-08-24','14:15:00',8.02),('10318','2013-08-24','14:20:00',7.94),('10318','2013-08-24','14:25:00',7.85),('10318','2013-08-24','14:30:00',7.8),('10318','2013-08-24','14:35:00',7.73),('10318','2013-08-24','14:40:00',7.69),('10318','2013-08-24','14:45:00',7.57),('10318','2013-08-24','14:50:00',7.47),('10318','2013-08-24','14:55:00',7.27),('10318','2013-08-24','15:00:00',7.31),('10318','2013-08-24','15:05:00',7.2),('10318','2013-08-24','15:10:00',7.13),('10318','2013-08-24','15:15:00',7.02),('10318','2013-08-24','15:20:00',6.88),('10318','2013-08-24','15:25:00',6.72),('10318','2013-08-24','15:30:00',6.63),('10318','2013-08-24','15:35:00',6.51),('10318','2013-08-24','15:40:00',6.38),('10318','2013-08-24','15:45:00',6.22),('10318','2013-08-24','15:50:00',6.08),('10318','2013-08-24','15:55:00',5.94),('10318','2013-08-24','16:00:00',5.8),('10318','2013-08-24','16:05:00',5.64),('10318','2013-08-24','16:10:00',5.53),('10318','2013-08-24','16:15:00',5.38),('10318','2013-08-24','16:20:00',5.21),('10318','2013-08-24','16:25:00',5.04),('10318','2013-08-24','16:30:00',4.9),('10318','2013-08-24','16:35:00',4.72),('10318','2013-08-24','16:40:00',4.42),('10318','2013-08-24','16:45:00',4.38),('10318','2013-08-24','16:50:00',4.2),('10318','2013-08-24','16:55:00',4.03),('10318','2013-08-24','17:00:00',3.87),('10318','2013-08-24','17:05:00',3.69),('10318','2013-08-24','17:10:00',3.51),('10318','2013-08-24','17:15:00',3.34),('10318','2013-08-24','17:20:00',3.17),('10318','2013-08-24','17:25:00',3),('10318','2013-08-24','17:30:00',2.83),('10318','2013-08-24','17:35:00',2.65),('10318','2013-08-24','17:40:00',2.48),('10318','2013-08-24','17:45:00',2.34),('10318','2013-08-24','17:50:00',2.18),('10318','2013-08-24','17:55:00',2.01),('10318','2013-08-24','18:00:00',1.87),('10318','2013-08-24','18:05:00',1.72),('10318','2013-08-24','18:10:00',1.58),('10318','2013-08-24','18:15:00',1.44),('10318','2013-08-24','18:20:00',1.3),('10318','2013-08-24','18:25:00',1.14),('10318','2013-08-24','18:30:00',1.05),('10318','2013-08-23','07:30:00',1.01),('10318','2013-08-23','07:35:00',1.13),('10318','2013-08-23','07:40:00',1.4),('10318','2013-08-23','07:45:00',1.64),('10318','2013-08-23','07:50:00',1.91),('10318','2013-08-23','07:55:00',2.12),('10318','2013-08-23','08:00:00',2.34),('10318','2013-08-23','08:05:00',2.5),('10318','2013-08-23','08:10:00',2.75),('10318','2013-08-23','08:15:00',2.99),('10318','2013-08-23','08:20:00',3.2),('10318','2013-08-23','08:25:00',3.07),('10318','2013-08-23','08:30:00',3.49),('10318','2013-08-23','08:35:00',3.68),('10318','2013-08-23','08:40:00',3.86),('10318','2013-08-23','08:45:00',4.05),('10318','2013-08-23','08:50:00',4.26),('10318','2013-08-23','08:55:00',4.47),('10318','2013-08-23','09:00:00',4.58),('10318','2013-08-23','09:05:00',4.75),('10318','2013-08-23','09:10:00',4.92),('10318','2013-08-23','09:15:00',5.06),('10318','2013-08-23','09:20:00',5.21),('10318','2013-08-23','09:25:00',5.31),('10318','2013-08-23','09:30:00',5.46),('10318','2013-08-23','09:35:00',5.61),('10318','2013-08-23','09:40:00',5.78),('10318','2013-08-23','09:45:00',5.89),('10318','2013-08-23','09:50:00',5.88),('10318','2013-08-23','09:55:00',6.09),('10318','2013-08-23','10:00:00',6.22),('10318','2013-08-23','10:05:00',6.36),('10318','2013-08-23','10:10:00',6.54),('10318','2013-08-23','10:15:00',6.66),('10318','2013-08-23','10:20:00',6.7),('10318','2013-08-23','10:25:00',6.72),('10318','2013-08-23','10:30:00',6.86),('10318','2013-08-23','10:35:00',6.97),('10318','2013-08-23','10:40:00',7.01),('10318','2013-08-23','10:45:00',6.9),('10318','2013-08-23','10:50:00',6.7),('10318','2013-08-23','10:55:00',3.61),('10318','2013-08-23','11:00:00',3.77),('10318','2013-08-23','11:05:00',7.68),('10318','2013-08-23','11:10:00',4.37),('10318','2013-08-23','11:15:00',6.24),('10318','2013-08-23','11:20:00',6.07),('10318','2013-08-23','11:25:00',7.86),('10318','2013-08-23','11:30:00',4.19),('10318','2013-08-23','11:35:00',3.81),('10318','2013-08-23','11:40:00',7.97),('10318','2013-08-23','11:45:00',8.74),('10318','2013-08-23','11:50:00',8.92),('10318','2013-08-23','11:55:00',4.06),('10318','2013-08-23','12:00:00',6),('10318','2013-08-23','12:05:00',9.31),('10318','2013-08-23','12:10:00',8.96),('10318','2013-08-23','12:15:00',9.09),('10318','2013-08-23','12:20:00',3.53),('10318','2013-08-23','12:25:00',6.99),('10318','2013-08-23','12:30:00',9.34),('10318','2013-08-23','12:35:00',7.43),('10318','2013-08-23','12:40:00',3.11),('10318','2013-08-23','12:45:00',6.56),('10318','2013-08-23','12:50:00',3.4),('10318','2013-08-23','12:55:00',9.43),('10318','2013-08-23','13:00:00',9.06),('10318','2013-08-23','13:05:00',8.29),('10318','2013-08-23','13:10:00',9.03),('10318','2013-08-23','13:15:00',8.33),('10318','2013-08-23','13:20:00',8.82),('10318','2013-08-23','13:25:00',8.49),('10318','2013-08-23','13:30:00',5.7),('10318','2013-08-23','13:35:00',5.27),('10318','2013-08-23','13:40:00',5.82),('10318','2013-08-23','13:45:00',9.07),('10318','2013-08-23','13:50:00',7.52),('10318','2013-08-23','13:55:00',8.66),('10318','2013-08-23','14:00:00',8.2),('10318','2013-08-23','14:05:00',8.39),('10318','2013-08-23','14:10:00',8.24),('10318','2013-08-23','14:15:00',8.18),('10318','2013-08-23','14:20:00',8.1),('10318','2013-08-23','14:25:00',8.01),('10318','2013-08-23','14:30:00',7.9),('10318','2013-08-23','14:35:00',7.82),('10318','2013-08-23','14:40:00',7.63),('10318','2013-08-23','14:45:00',7.64),('10318','2013-08-23','14:50:00',7.52),('10318','2013-08-23','14:55:00',7.37),('10318','2013-08-23','15:00:00',7.01),('10318','2013-08-23','15:05:00',7.05),('10318','2013-08-23','15:10:00',7.02),('10318','2013-08-23','15:15:00',6.76),('10318','2013-08-23','15:20:00',6.72),('10318','2013-08-23','15:25:00',6.85),('10318','2013-08-23','15:30:00',6.83),('10318','2013-08-23','15:35:00',6.13),('10318','2013-08-23','15:40:00',6.34),('10318','2013-08-23','15:45:00',5.89),('10318','2013-08-23','15:50:00',5.87),('10318','2013-08-23','15:55:00',5.74),('10318','2013-08-23','16:00:00',5.57),('10318','2013-08-23','16:05:00',4.75),('10318','2013-08-23','16:10:00',4.54),('10318','2013-08-23','16:15:00',5.3),('10318','2013-08-23','16:20:00',5.41),('10318','2013-08-23','16:25:00',4.69),('10318','2013-08-23','16:30:00',4.43),('10318','2013-08-23','16:35:00',4.98),('10318','2013-08-23','16:40:00',4.74),('10318','2013-08-23','16:45:00',4.53),('10318','2013-08-23','16:50:00',4.22),('10318','2013-08-23','16:55:00',4.08),('10318','2013-08-23','17:00:00',3.89),('10318','2013-08-23','17:05:00',3.69),('10318','2013-08-23','17:10:00',3.5),('10318','2013-08-23','17:15:00',3.37),('10318','2013-08-23','17:20:00',3.2),('10318','2013-08-23','17:25:00',3.04),('10318','2013-08-23','17:30:00',2.86),('10318','2013-08-23','17:35:00',2.65),('10318','2013-08-23','17:40:00',2.46),('10318','2013-08-23','17:45:00',2.3),('10318','2013-08-23','17:50:00',2.21),('10318','2013-08-23','17:55:00',2.06),('10318','2013-08-23','18:00:00',1.87),('10318','2013-08-23','18:05:00',1.75),('10318','2013-08-23','18:10:00',1.46),('10318','2013-08-23','18:15:00',1.4),('10318','2013-08-23','18:20:00',1.38),('10318','2013-08-23','18:25:00',1.26),('10318','2013-08-23','18:30:00',1.13),('10318','2013-08-23','18:35:00',1),('10318','2013-08-22','07:30:00',1.01),('10318','2013-08-22','07:35:00',1.25),('10318','2013-08-22','07:40:00',1.63),('10318','2013-08-22','07:45:00',1.94),('10318','2013-08-22','07:50:00',2.13),('10318','2013-08-22','07:55:00',2.34),('10318','2013-08-22','08:00:00',2.59),('10318','2013-08-22','08:05:00',2.74),('10318','2013-08-22','08:10:00',2.95),('10318','2013-08-22','08:15:00',3.09),('10318','2013-08-22','08:20:00',3.3),('10318','2013-08-22','08:25:00',3.52),('10318','2013-08-22','08:30:00',3.7),('10318','2013-08-22','08:35:00',3.89),('10318','2013-08-22','08:40:00',4.11),('10318','2013-08-22','08:45:00',4.34),('10318','2013-08-22','08:50:00',4.51),('10318','2013-08-22','08:55:00',4.74),('10318','2013-08-22','09:00:00',4.98),('10318','2013-08-22','09:05:00',5.32),('10318','2013-08-22','09:10:00',5.55),('10318','2013-08-22','09:15:00',5.75),('10318','2013-08-22','09:20:00',6.14),('10318','2013-08-22','09:25:00',6.29),('10318','2013-08-22','09:30:00',6.61),('10318','2013-08-22','09:35:00',5.16),('10318','2013-08-22','09:40:00',6.55),('10318','2013-08-22','09:45:00',6.34),('10318','2013-08-22','09:50:00',6.22),('10318','2013-08-22','09:55:00',6.39),('10318','2013-08-22','10:00:00',5.9),('10318','2013-08-22','10:05:00',7.44),('10318','2013-08-22','10:10:00',7.46),('10318','2013-08-22','10:15:00',7.28),('10318','2013-08-22','10:20:00',7.24),('10318','2013-08-22','10:25:00',7.37),('10318','2013-08-22','10:30:00',7.51),('10318','2013-08-22','10:35:00',7.54),('10318','2013-08-22','10:40:00',7.59),('10318','2013-08-22','10:45:00',7.66),('10318','2013-08-22','10:50:00',7.72),('10318','2013-08-22','10:55:00',7.77),('10318','2013-08-22','11:00:00',7.86),('10318','2013-08-22','11:05:00',7.91),('10318','2013-08-22','11:10:00',7.97),('10318','2013-08-22','11:15:00',8.09),('10318','2013-08-22','11:20:00',8.1),('10318','2013-08-22','11:25:00',8.2),('10318','2013-08-22','11:30:00',8.18),('10318','2013-08-22','11:35:00',8.12),('10318','2013-08-22','11:40:00',8.3),('10318','2013-08-22','11:45:00',8.31),('10318','2013-08-22','11:50:00',8.36),('10318','2013-08-22','11:55:00',8.4),('10318','2013-08-22','12:00:00',8.5),('10318','2013-08-22','12:05:00',8.49),('10318','2013-08-22','12:10:00',8.41),('10318','2013-08-22','12:15:00',8.44),('10318','2013-08-22','12:20:00',8.47),('10318','2013-08-22','12:25:00',8.46),('10318','2013-08-22','12:30:00',8.46),('10318','2013-08-22','12:35:00',8.42),('10318','2013-08-22','12:40:00',8.39),('10318','2013-08-22','12:45:00',8.38),('10318','2013-08-22','12:50:00',8.37),('10318','2013-08-22','12:55:00',8.38),('10318','2013-08-22','13:00:00',8.36),('10318','2013-08-22','13:05:00',8.36),('10318','2013-08-22','13:10:00',8.29),('10318','2013-08-22','13:15:00',8.22),('10318','2013-08-22','13:20:00',8.21),('10318','2013-08-22','13:25:00',8.06),('10318','2013-08-22','13:30:00',8.21),('10318','2013-08-22','13:35:00',8.15),('10318','2013-08-22','13:40:00',8.1),('10318','2013-08-22','13:45:00',8.06),('10318','2013-08-22','13:50:00',8.02),('10318','2013-08-22','13:55:00',7.91),('10318','2013-08-22','14:00:00',7.84),('10318','2013-08-22','14:05:00',7.78),('10318','2013-08-22','14:10:00',7.74),('10318','2013-08-22','14:15:00',7.76),('10318','2013-08-22','14:20:00',7.87),('10318','2013-08-22','14:25:00',7.79),('10318','2013-08-22','14:30:00',7.59),('10318','2013-08-22','14:35:00',3.88),('10318','2013-08-22','14:40:00',2.2),('10318','2013-08-22','14:45:00',2.45),('10318','2013-08-22','14:50:00',4.75),('10318','2013-08-22','14:55:00',7.47),('10318','2013-08-22','15:00:00',7.3),('10318','2013-08-22','15:05:00',7.13),('10318','2013-08-22','15:10:00',6.62),('10318','2013-08-22','15:15:00',6.83),('10318','2013-08-22','15:20:00',6.75),('10318','2013-08-22','15:25:00',6.57),('10318','2013-08-22','15:30:00',6.42),('10318','2013-08-22','15:35:00',6.26),('10318','2013-08-22','15:40:00',6.2),('10318','2013-08-22','15:45:00',6.05),('10318','2013-08-22','15:50:00',5.93),('10318','2013-08-22','15:55:00',5.8),('10318','2013-08-22','16:00:00',5.66),('10318','2013-08-22','16:05:00',5.54),('10318','2013-08-22','16:10:00',5.37),('10318','2013-08-22','16:15:00',5.22),('10318','2013-08-22','16:20:00',5.08),('10318','2013-08-22','16:25:00',4.91),('10318','2013-08-22','16:30:00',4.76),('10318','2013-08-22','16:35:00',4.6),('10318','2013-08-22','16:40:00',4.38),('10318','2013-08-22','16:45:00',4.19),('10318','2013-08-22','16:50:00',4.04),('10318','2013-08-22','16:55:00',3.85),('10318','2013-08-22','17:00:00',3.74),('10318','2013-08-22','17:05:00',3.57),('10318','2013-08-22','17:10:00',3.41),('10318','2013-08-22','17:15:00',3.24),('10318','2013-08-22','17:20:00',3.09),('10318','2013-08-22','17:25:00',2.9),('10318','2013-08-22','17:30:00',2.75),('10318','2013-08-22','17:35:00',2.62),('10318','2013-08-22','17:40:00',2.46),('10318','2013-08-22','17:45:00',2.28),('10318','2013-08-22','17:50:00',2.12),('10318','2013-08-22','17:55:00',2.01),('10318','2013-08-22','18:00:00',1.89),('10318','2013-08-22','18:05:00',1.79),('10318','2013-08-22','18:10:00',1.73),('10318','2013-08-22','18:15:00',1.74),('10318','2013-08-22','18:20:00',1.66),('10318','2013-08-22','18:25:00',1.39),('10318','2013-08-22','18:30:00',1.24),('10318','2013-08-22','18:35:00',1.05),('10318','2013-08-21','08:05:00',1.03),('10318','2013-08-21','08:10:00',1.12),('10318','2013-08-21','08:15:00',1.23),('10318','2013-08-21','08:20:00',1.45),('10318','2013-08-21','08:25:00',1.64),('10318','2013-08-21','08:30:00',1.8),('10318','2013-08-21','08:35:00',1.93),('10318','2013-08-21','08:40:00',1.9),('10318','2013-08-21','08:45:00',1.71),('10318','2013-08-21','08:50:00',1.57),('10318','2013-08-21','08:55:00',1.62),('10318','2013-08-21','09:00:00',2.17),('10318','2013-08-21','09:05:00',3.74),('10318','2013-08-21','09:10:00',4.96),('10318','2013-08-21','09:15:00',4.67),('10318','2013-08-21','09:20:00',6.06),('10318','2013-08-21','09:25:00',3.64),('10318','2013-08-21','09:30:00',1.92),('10318','2013-08-21','09:35:00',1.81),('10318','2013-08-21','09:40:00',2.13),('10318','2013-08-21','09:45:00',2.45),('10318','2013-08-21','09:50:00',3),('10318','2013-08-21','09:55:00',5.24),('10318','2013-08-21','10:00:00',8.43),('10318','2013-08-21','10:05:00',7.78),('10318','2013-08-21','10:10:00',7.47),('10318','2013-08-21','10:15:00',7.85),('10318','2013-08-21','10:20:00',7.75),('10318','2013-08-21','10:25:00',7.35),('10318','2013-08-21','10:30:00',7.69),('10318','2013-08-21','10:35:00',5.52),('10318','2013-08-21','10:40:00',5.8),('10318','2013-08-21','10:45:00',4.63),('10318','2013-08-21','10:50:00',8.1),('10318','2013-08-21','10:55:00',5.31),('10318','2013-08-21','11:00:00',4.94),('10318','2013-08-21','11:05:00',4.49),('10318','2013-08-21','11:10:00',3.74),('10318','2013-08-21','11:15:00',4.29),('10318','2013-08-21','11:20:00',5.61),('10318','2013-08-21','11:25:00',7.69),('10318','2013-08-21','11:30:00',9.03),('10318','2013-08-21','11:35:00',9.4),('10318','2013-08-21','11:40:00',9.25),('10318','2013-08-21','11:45:00',9.16),('10318','2013-08-21','11:50:00',9.16),('10318','2013-08-21','11:55:00',9.05),('10318','2013-08-21','12:00:00',9.02),('10318','2013-08-21','12:05:00',9.1),('10318','2013-08-21','12:10:00',9.04),('10318','2013-08-21','12:15:00',8.89),('10318','2013-08-21','12:20:00',8.74),('10318','2013-08-21','12:25:00',8.62),('10318','2013-08-21','12:30:00',6.71),('10318','2013-08-21','12:35:00',4.83),('10318','2013-08-21','12:40:00',7.31),('10318','2013-08-21','12:45:00',8.72),('10318','2013-08-21','12:50:00',8.06),('10318','2013-08-21','12:55:00',8.2),('10318','2013-08-21','13:00:00',8.14),('10318','2013-08-21','13:05:00',8.19),('10318','2013-08-21','13:10:00',8.44),('10318','2013-08-21','13:15:00',8.42),('10318','2013-08-21','13:20:00',8.53),('10318','2013-08-21','13:25:00',8.48),('10318','2013-08-21','13:30:00',8.28),('10318','2013-08-21','13:35:00',8.18),('10318','2013-08-21','13:40:00',7.99),('10318','2013-08-21','13:45:00',8.1),('10318','2013-08-21','13:50:00',8.22),('10318','2013-08-21','13:55:00',8),('10318','2013-08-21','14:00:00',8.18),('10318','2013-08-21','14:05:00',7.95),('10318','2013-08-21','14:10:00',7.96),('10318','2013-08-21','14:15:00',6.23),('10318','2013-08-21','14:20:00',6.74),('10318','2013-08-21','14:25:00',6.18),('10318','2013-08-21','14:30:00',5.59),('10318','2013-08-21','14:35:00',7.29),('10318','2013-08-21','14:40:00',7.24),('10318','2013-08-21','14:45:00',6.89),('10318','2013-08-21','14:50:00',6.81),('10318','2013-08-21','14:55:00',7.09),('10318','2013-08-21','15:00:00',7.05),('10318','2013-08-21','15:05:00',6.89),('10318','2013-08-21','15:10:00',6.61),('10318','2013-08-21','15:15:00',6.68),('10318','2013-08-21','15:20:00',6.6),('10318','2013-08-21','15:25:00',6.18),('10318','2013-08-21','15:30:00',5.86),('10318','2013-08-21','15:35:00',5.51),('10318','2013-08-21','15:40:00',5.76),('10318','2013-08-21','15:45:00',5.69),('10318','2013-08-21','15:50:00',5.36),('10318','2013-08-21','15:55:00',5.21),('10318','2013-08-21','16:00:00',5.11),('10318','2013-08-21','16:05:00',4.88),('10318','2013-08-21','16:10:00',4.81),('10318','2013-08-21','16:15:00',5.07),('10318','2013-08-21','16:20:00',4.96),('10318','2013-08-21','16:25:00',5.18),('10318','2013-08-21','16:30:00',5.18),('10318','2013-08-21','16:35:00',4.9),('10318','2013-08-21','16:40:00',4.73),('10318','2013-08-21','16:45:00',4.56),('10318','2013-08-21','16:50:00',4.4),('10318','2013-08-21','16:55:00',4.26),('10318','2013-08-21','17:00:00',4.18),('10318','2013-08-21','17:05:00',4.01),('10318','2013-08-21','17:10:00',3.83),('10318','2013-08-21','17:15:00',3.69),('10318','2013-08-21','17:20:00',3.6),('10318','2013-08-21','17:25:00',3.43),('10318','2013-08-21','17:30:00',3.32),('10318','2013-08-21','17:35:00',3.2),('10318','2013-08-21','17:40:00',3.05),('10318','2013-08-21','17:45:00',2.9),('10318','2013-08-21','17:50:00',2.78),('10318','2013-08-21','17:55:00',2.63),('10318','2013-08-21','18:00:00',2.49),('10318','2013-08-21','18:05:00',2.31),('10318','2013-08-21','18:10:00',2.16),('10318','2013-08-21','18:15:00',2.01),('10318','2013-08-21','18:20:00',1.83),('10318','2013-08-21','18:25:00',1.62),('10318','2013-08-21','18:30:00',1.31),('10318','2013-08-21','18:35:00',1.15),('10318','2013-08-21','18:40:00',1.1),('10318','2013-08-20','07:30:00',1.18),('10318','2013-08-20','07:35:00',1.38),('10318','2013-08-20','07:40:00',1.47),('10318','2013-08-20','07:45:00',1.54),('10318','2013-08-20','07:50:00',2.34),('10318','2013-08-20','07:55:00',3.32),('10318','2013-08-20','08:00:00',2.29),('10318','2013-08-20','08:05:00',1.56),('10318','2013-08-20','08:10:00',1.54),('10318','2013-08-20','08:15:00',1.49),('10318','2013-08-20','08:20:00',1.55),('10318','2013-08-20','08:25:00',1.62),('10318','2013-08-20','08:30:00',1.74),('10318','2013-08-20','08:35:00',1.79),('10318','2013-08-20','08:40:00',1.84),('10318','2013-08-20','08:45:00',2.06),('10318','2013-08-20','08:50:00',2.28),('10318','2013-08-20','08:55:00',2.54),('10318','2013-08-20','09:00:00',2.08),('10318','2013-08-20','09:05:00',1.88),('10318','2013-08-20','09:10:00',1.62),('10318','2013-08-20','09:15:00',2.11),('10318','2013-08-20','09:20:00',3.51),('10318','2013-08-20','09:25:00',5.66),('10318','2013-08-20','09:30:00',6.65),('10318','2013-08-20','09:35:00',5.89),('10318','2013-08-20','09:40:00',4.44),('10318','2013-08-20','09:45:00',3.83),('10318','2013-08-20','09:50:00',3.49),('10318','2013-08-20','09:55:00',4.68),('10318','2013-08-20','10:00:00',5.3),('10318','2013-08-20','10:05:00',2.81),('10318','2013-08-20','10:10:00',2.93),('10318','2013-08-20','10:15:00',2.8),('10318','2013-08-20','10:20:00',2),('10318','2013-08-20','10:25:00',2.57),('10318','2013-08-20','10:30:00',6.82),('10318','2013-08-20','10:35:00',4.9),('10318','2013-08-20','10:40:00',2.93),('10318','2013-08-20','10:45:00',3.39),('10318','2013-08-20','10:50:00',6.01),('10318','2013-08-20','10:55:00',3.12),('10318','2013-08-20','11:00:00',4.98),('10318','2013-08-20','11:05:00',3.17),('10318','2013-08-20','11:10:00',3.54),('10318','2013-08-20','11:15:00',9.72),('10318','2013-08-20','11:20:00',9.62),('10318','2013-08-20','11:25:00',9.33),('10318','2013-08-20','11:30:00',9.22),('10318','2013-08-20','11:35:00',9.46),('10318','2013-08-20','11:40:00',6.73),('10318','2013-08-20','11:45:00',3.37),('10318','2013-08-20','11:50:00',3.56),('10318','2013-08-20','11:55:00',5.76),('10318','2013-08-20','12:00:00',4.2),('10318','2013-08-20','12:05:00',3.57),('10318','2013-08-20','12:10:00',3.37),('10318','2013-08-20','12:15:00',2.74),('10318','2013-08-20','12:20:00',2.82),('10318','2013-08-20','12:25:00',3.34),('10318','2013-08-20','12:30:00',3.56),('10318','2013-08-20','12:35:00',3.91),('10318','2013-08-20','12:40:00',4.75),('10318','2013-08-20','12:45:00',4.24),('10318','2013-08-20','12:50:00',4.27),('10318','2013-08-20','12:55:00',4.56),('10318','2013-08-20','13:00:00',4.32),('10318','2013-08-20','13:05:00',3.63),('10318','2013-08-20','13:10:00',3.52),('10318','2013-08-20','13:15:00',3.57),('10318','2013-08-20','13:20:00',3.65),('10318','2013-08-20','13:25:00',3.87),('10318','2013-08-20','13:30:00',4.43),('10318','2013-08-20','13:35:00',5.27),('10318','2013-08-20','13:40:00',5.68),('10318','2013-08-20','13:45:00',5.28),('10318','2013-08-20','13:50:00',9.49),('10318','2013-08-20','13:55:00',8.96),('10318','2013-08-20','14:00:00',8.77),('10318','2013-08-20','14:05:00',8.66),('10318','2013-08-20','14:10:00',7.15),('10318','2013-08-20','14:15:00',7.32),('10318','2013-08-20','14:20:00',8.07),('10318','2013-08-20','14:25:00',5.97),('10318','2013-08-20','14:30:00',8.51),('10318','2013-08-20','14:35:00',8.24),('10318','2013-08-20','14:40:00',5.78),('10318','2013-08-20','14:45:00',8.51),('10318','2013-08-20','14:50:00',8.46),('10318','2013-08-20','14:55:00',6.8),('10318','2013-08-20','15:00:00',7.61),('10318','2013-08-20','15:05:00',7.84),('10318','2013-08-20','15:10:00',7.8),('10318','2013-08-20','15:15:00',7.67),('10318','2013-08-20','15:20:00',7.46),('10318','2013-08-20','15:25:00',7.38),('10318','2013-08-20','15:30:00',7.34),('10318','2013-08-20','15:35:00',7.41),('10318','2013-08-20','15:40:00',7.48),('10318','2013-08-20','15:45:00',7.39),('10318','2013-08-20','15:50:00',7.51),('10318','2013-08-20','15:55:00',7.43),('10318','2013-08-20','16:00:00',7.25),('10318','2013-08-20','16:05:00',7.16),('10318','2013-08-20','16:10:00',7.03),('10318','2013-08-20','16:15:00',6.96),('10318','2013-08-20','16:20:00',6.75),('10318','2013-08-20','16:25:00',6.56),('10318','2013-08-20','16:30:00',5.65),('10318','2013-08-20','16:35:00',5.44),('10318','2013-08-20','16:40:00',5.39),('10318','2013-08-20','16:45:00',5.35),('10318','2013-08-20','16:50:00',4.65),('10318','2013-08-20','16:55:00',4.71),('10318','2013-08-20','17:00:00',4.33),('10318','2013-08-20','17:05:00',4.15),('10318','2013-08-20','17:10:00',3.9),('10318','2013-08-20','17:15:00',3.67),('10318','2013-08-20','17:20:00',3.46),('10318','2013-08-20','17:25:00',3.31),('10318','2013-08-20','17:30:00',3.14),('10318','2013-08-20','17:35:00',3.03),('10318','2013-08-20','17:40:00',3.02),('10318','2013-08-20','17:45:00',2.71),('10318','2013-08-20','17:50:00',2.34),('10318','2013-08-20','17:55:00',2.12),('10318','2013-08-20','18:00:00',2.05),('10318','2013-08-20','18:05:00',1.84),('10318','2013-08-20','18:10:00',1.83),('10318','2013-08-20','18:15:00',1.87),('10318','2013-08-20','18:20:00',1.75),('10318','2013-08-20','18:25:00',1.76),('10318','2013-08-20','18:30:00',1.77),('10318','2013-08-20','18:35:00',1.52),('10318','2013-08-20','18:40:00',1.54),('10318','2013-08-20','18:45:00',1.5),('10318','2013-08-20','18:50:00',1.19),('10318','2013-08-20','18:55:00',1.27),('10318','2013-08-20','19:00:00',1.22),('10318','2013-08-20','19:05:00',1.03),('10318','2014-04-10','07:40:00',1.08),('10318','2014-04-10','07:45:00',1.65),('10318','2014-04-10','07:50:00',2.31),('10318','2014-04-10','07:55:00',2.84),('10318','2014-04-10','08:00:00',3.13),('10318','2014-04-10','08:05:00',3.48),('10318','2014-04-10','08:10:00',3.79),('10318','2014-04-10','08:15:00',4.03),('10318','2014-04-10','08:20:00',4.26),('10318','2014-04-10','08:25:00',4.5),('10318','2014-04-10','08:30:00',4.71),('10318','2014-04-10','08:35:00',4.93),('10318','2014-04-10','08:40:00',5.16),('10318','2014-04-10','08:45:00',5.37),('10318','2014-04-10','08:50:00',5.58),('10318','2014-04-10','08:55:00',5.74),('10318','2014-04-10','09:00:00',5.8),('10318','2014-04-10','09:05:00',6.16),('10318','2014-04-10','09:10:00',6.3),('10318','2014-04-10','09:15:00',6.36),('10318','2014-04-10','09:20:00',6.45),('10318','2014-04-10','09:25:00',6.85),('10318','2014-04-10','09:30:00',7.03),('10318','2014-04-10','09:35:00',7.19),('10318','2014-04-10','09:40:00',7.27),('10318','2014-04-10','09:45:00',7.43),('10318','2014-04-10','09:50:00',7.61),('10318','2014-04-10','09:55:00',7.73),('10318','2014-04-10','10:00:00',7.86),('10318','2014-04-10','10:05:00',8),('10318','2014-04-10','10:10:00',8.15),('10318','2014-04-10','10:15:00',8.14),('10318','2014-04-10','10:20:00',8.28),('10318','2014-04-10','10:25:00',8.36),('10318','2014-04-10','10:30:00',8.41),('10318','2014-04-10','10:35:00',8.75),('10318','2014-04-10','10:40:00',8.81),('10318','2014-04-10','10:45:00',8.56),('10318','2014-04-10','10:50:00',8.64),('10318','2014-04-10','10:55:00',8.92),('10318','2014-04-10','11:00:00',8.98),('10318','2014-04-10','11:05:00',9.16),('10318','2014-04-10','11:10:00',9.02),('10318','2014-04-10','11:15:00',9.13),('10318','2014-04-10','11:20:00',9.62),('10318','2014-04-10','11:25:00',9.66),('10318','2014-04-10','11:30:00',9.67),('10318','2014-04-10','11:35:00',9.77),('10318','2014-04-10','11:40:00',9.39),('10318','2014-04-10','11:45:00',9.75),('10318','2014-04-10','11:50:00',9.48),('10318','2014-04-10','11:55:00',9.71),('10318','2014-04-10','12:00:00',9.4),('10318','2014-04-10','12:05:00',8.94),('10318','2014-04-10','12:10:00',9.55),('10318','2014-04-10','12:15:00',9.48),('10318','2014-04-10','12:20:00',9.44),('10318','2014-04-10','12:25:00',8.99),('10318','2014-04-10','12:30:00',9.11),('10318','2014-04-10','12:35:00',9.76),('10318','2014-04-10','12:40:00',9.12),('10318','2014-04-10','12:45:00',9.22),('10318','2014-04-10','12:50:00',9.31),('10318','2014-04-10','12:55:00',9.42),('10318','2014-04-10','13:00:00',8.79),('10318','2014-04-10','13:05:00',9.05),('10318','2014-04-10','13:10:00',9.72),('10318','2014-04-10','13:15:00',9.18),('10318','2014-04-10','13:20:00',8.67),('10318','2014-04-10','13:25:00',9.36),('10318','2014-04-10','13:30:00',9.37),('10318','2014-04-10','13:35:00',9.47),('10318','2014-04-10','13:40:00',8.86),('10318','2014-04-10','13:45:00',9.22),('10318','2014-04-10','13:50:00',9.17),('10318','2014-04-10','13:55:00',9.12),('10318','2014-04-10','14:00:00',9.05),('10318','2014-04-10','14:05:00',8.76),('10318','2014-04-10','14:10:00',8.73),('10318','2014-04-10','14:15:00',8.85),('10318','2014-04-10','14:20:00',8.83),('10318','2014-04-10','14:25:00',8.71),('10318','2014-04-10','14:30:00',8.57),('10318','2014-04-10','14:35:00',8.56),('10318','2014-04-10','14:40:00',8.39),('10318','2014-04-10','14:45:00',7.4),('10318','2014-04-10','14:50:00',8.38),('10318','2014-04-10','14:55:00',8.19),('10318','2014-04-10','15:00:00',7.98),('10318','2014-04-10','15:05:00',7.84),('10318','2014-04-10','15:10:00',7.63),('10318','2014-04-10','15:15:00',7.56),('10318','2014-04-10','15:20:00',7.52),('10318','2014-04-10','15:25:00',7.25),('10318','2014-04-10','15:30:00',6.75),('10318','2014-04-10','15:35:00',6.34),('10318','2014-04-10','15:40:00',6.45),('10318','2014-04-10','15:45:00',6.53),('10318','2014-04-10','15:50:00',6.28),('10318','2014-04-10','15:55:00',6.27),('10318','2014-04-10','16:00:00',6.33),('10318','2014-04-10','16:05:00',6.21),('10318','2014-04-10','16:10:00',6.29),('10318','2014-04-10','16:15:00',6.22),('10318','2014-04-10','16:20:00',5.85),('10318','2014-04-10','16:25:00',5.72),('10318','2014-04-10','16:30:00',5.65),('10318','2014-04-10','16:35:00',5.31),('10318','2014-04-10','16:40:00',5.24),('10318','2014-04-10','16:45:00',5.11),('10318','2014-04-10','16:50:00',4.72),('10318','2014-04-10','16:55:00',4.58),('10318','2014-04-10','17:00:00',4.32),('10318','2014-04-10','17:05:00',4.19),('10318','2014-04-10','17:10:00',3.97),('10318','2014-04-10','17:15:00',3.71),('10318','2014-04-10','17:20:00',3.5),('10318','2014-04-10','17:25:00',3.3),('10318','2014-04-10','17:30:00',3.07),('10318','2014-04-10','17:35:00',2.85),('10318','2014-04-10','17:40:00',2.67),('10318','2014-04-10','17:45:00',2.49),('10318','2014-04-10','17:50:00',2.28),('10318','2014-04-10','17:55:00',2.12),('10318','2014-04-10','18:00:00',1.96),('10318','2014-04-10','18:05:00',1.78),('10318','2014-04-10','18:10:00',1.62),('10318','2014-04-10','18:15:00',1.45),('10318','2014-04-10','18:20:00',1.28),('10318','2014-04-10','18:25:00',1.14),('10318','2013-08-19','07:35:00',1.23),('10318','2013-08-19','07:40:00',1.81),('10318','2013-08-19','07:45:00',1.79),('10318','2013-08-19','07:50:00',1.99),('10318','2013-08-19','07:55:00',2.47),('10318','2013-08-19','08:00:00',2.75),('10318','2013-08-19','08:05:00',3.02),('10318','2013-08-19','08:10:00',3.24),('10318','2013-08-19','08:15:00',3.41),('10318','2013-08-19','08:20:00',3.59),('10318','2013-08-19','08:25:00',3.79),('10318','2013-08-19','08:30:00',4.02),('10318','2013-08-19','08:35:00',4.18),('10318','2013-08-19','08:40:00',4.36),('10318','2013-08-19','08:45:00',4.59),('10318','2013-08-19','08:50:00',4.83),('10318','2013-08-19','08:55:00',4.99),('10318','2013-08-19','09:00:00',5.15),('10318','2013-08-19','09:05:00',5.32),('10318','2013-08-19','09:10:00',5.48),('10318','2013-08-19','09:15:00',5.63),('10318','2013-08-19','09:20:00',5.8),('10318','2013-08-19','09:25:00',5.99),('10318','2013-08-19','09:30:00',6.05),('10318','2013-08-19','09:35:00',6.26),('10318','2013-08-19','09:40:00',6.34),('10318','2013-08-19','09:45:00',6.46),('10318','2013-08-19','09:50:00',6.62),('10318','2013-08-19','09:55:00',6.76),('10318','2013-08-19','10:00:00',6.88),('10318','2013-08-19','10:05:00',6.95),('10318','2013-08-19','10:10:00',7),('10318','2013-08-19','10:15:00',7.13),('10318','2013-08-19','10:20:00',7.22),('10318','2013-08-19','10:25:00',7.34),('10318','2013-08-19','10:30:00',7.51),('10318','2013-08-19','10:35:00',7.54),('10318','2013-08-19','10:40:00',7.63),('10318','2013-08-19','10:45:00',7.71),('10318','2013-08-19','10:50:00',7.84),('10318','2013-08-19','10:55:00',7.83),('10318','2013-08-19','11:00:00',7.92),('10318','2013-08-19','11:05:00',7.89),('10318','2013-08-19','11:10:00',8.04),('10318','2013-08-19','11:15:00',8.03),('10318','2013-08-19','11:20:00',8.13),('10318','2013-08-19','11:25:00',8.11),('10318','2013-08-19','11:30:00',8.16),('10318','2013-08-19','11:35:00',8.13),('10318','2013-08-19','11:40:00',8.19),('10318','2013-08-19','11:45:00',8.41),('10318','2013-08-19','11:50:00',8.54),('10318','2013-08-19','11:55:00',8.62),('10318','2013-08-19','12:00:00',8.56),('10318','2013-08-19','12:05:00',8.6),('10318','2013-08-19','12:10:00',8.57),('10318','2013-08-19','12:15:00',8.6),('10318','2013-08-19','12:20:00',8.63),('10318','2013-08-19','12:25:00',8.61),('10318','2013-08-19','12:30:00',8.66),('10318','2013-08-19','12:35:00',8.66),('10318','2013-08-19','12:40:00',8.68),('10318','2013-08-19','12:45:00',8.68),('10318','2013-08-19','12:50:00',8.76),('10318','2013-08-19','12:55:00',8.75),('10318','2013-08-19','13:00:00',8.74),('10318','2013-08-19','13:05:00',8.62),('10318','2013-08-19','13:10:00',8.78),('10318','2013-08-19','13:15:00',8.72),('10318','2013-08-19','13:20:00',8.67),('10318','2013-08-19','13:25:00',8.63),('10318','2013-08-19','13:30:00',8.58),('10318','2013-08-19','13:35:00',8.55),('10318','2013-08-19','13:40:00',8.47),('10318','2013-08-19','13:45:00',8.45),('10318','2013-08-19','13:50:00',8.38),('10318','2013-08-19','13:55:00',8.3),('10318','2013-08-19','14:00:00',8.27),('10318','2013-08-19','14:05:00',8.23),('10318','2013-08-19','14:10:00',8.22),('10318','2013-08-19','14:15:00',8.13),('10318','2013-08-19','14:20:00',8.08),('10318','2013-08-19','14:25:00',8.02),('10318','2013-08-19','14:30:00',8),('10318','2013-08-19','14:35:00',7.93),('10318','2013-08-19','14:40:00',7.87),('10318','2013-08-19','14:45:00',7.76),('10318','2013-08-19','14:50:00',7.55),('10318','2013-08-19','14:55:00',7.6),('10318','2013-08-19','15:00:00',7.52),('10318','2013-08-19','15:05:00',7.48),('10318','2013-08-19','15:10:00',7.38),('10318','2013-08-19','15:15:00',7.23),('10318','2013-08-19','15:20:00',7.05),('10318','2013-08-19','15:25:00',6.93),('10318','2013-08-19','15:30:00',6.86),('10318','2013-08-19','15:35:00',6.75),('10318','2013-08-19','15:40:00',6.61),('10318','2013-08-19','15:45:00',6.48),('10318','2013-08-19','15:50:00',6.32),('10318','2013-08-19','15:55:00',6.16),('10318','2013-08-19','16:00:00',6),('10318','2013-08-19','16:05:00',5.76),('10318','2013-08-19','16:10:00',5.74),('10318','2013-08-19','16:15:00',5.59),('10318','2013-08-19','16:20:00',5.43),('10318','2013-08-19','16:25:00',5.28),('10318','2013-08-19','16:30:00',5.11),('10318','2013-08-19','16:35:00',4.94),('10318','2013-08-19','16:40:00',4.78),('10318','2013-08-19','16:45:00',4.63),('10318','2013-08-19','16:50:00',4.46),('10318','2013-08-19','16:55:00',4.29),('10318','2013-08-19','17:00:00',4.12),('10318','2013-08-19','17:05:00',3.94),('10318','2013-08-19','17:10:00',3.77),('10318','2013-08-19','17:15:00',3.6),('10318','2013-08-19','17:20:00',3.41),('10318','2013-08-19','17:25:00',3.23),('10318','2013-08-19','17:30:00',3.06),('10318','2013-08-19','17:35:00',2.88),('10318','2013-08-19','17:40:00',2.72),('10318','2013-08-19','17:45:00',2.55),('10318','2013-08-19','17:50:00',2.31),('10318','2013-08-19','17:55:00',2.19),('10318','2013-08-19','18:00:00',2.04),('10318','2013-08-19','18:05:00',1.88),('10318','2013-08-19','18:10:00',1.74),('10318','2013-08-19','18:15:00',1.58),('10318','2013-08-19','18:20:00',1.43),('10318','2013-08-19','18:25:00',1.31),('10318','2013-08-19','18:30:00',1.17),('10318','2013-08-19','18:35:00',1.05),('10318','2013-08-18','07:30:00',1.29),('10318','2013-08-18','07:35:00',1.63),('10318','2013-08-18','07:40:00',2.05),('10318','2013-08-18','07:45:00',2.27),('10318','2013-08-18','07:50:00',2.39),('10318','2013-08-18','07:55:00',2.79),('10318','2013-08-18','08:00:00',3.01),('10318','2013-08-18','08:05:00',3.22),('10318','2013-08-18','08:10:00',3.43),('10318','2013-08-18','08:15:00',3.65),('10318','2013-08-18','08:20:00',3.83),('10318','2013-08-18','08:25:00',4.01),('10318','2013-08-18','08:30:00',4.2),('10318','2013-08-18','08:35:00',4.4),('10318','2013-08-18','08:40:00',4.57),('10318','2013-08-18','08:45:00',4.72),('10318','2013-08-18','08:50:00',4.88),('10318','2013-08-18','08:55:00',5.05),('10318','2013-08-18','09:00:00',5.22),('10318','2013-08-18','09:05:00',5.4),('10318','2013-08-18','09:10:00',5.59),('10318','2013-08-18','09:15:00',5.68),('10318','2013-08-18','09:20:00',5.93),('10318','2013-08-18','09:25:00',6.09),('10318','2013-08-18','09:30:00',6.21),('10318','2013-08-18','09:35:00',6.38),('10318','2013-08-18','09:40:00',6.39),('10318','2013-08-18','09:45:00',5.03),('10318','2013-08-18','09:50:00',6.48),('10318','2013-08-18','09:55:00',6.86),('10318','2013-08-18','10:00:00',5.65),('10318','2013-08-18','10:05:00',6.78),('10318','2013-08-18','10:10:00',7.23),('10318','2013-08-18','10:15:00',7.31),('10318','2013-08-18','10:20:00',7.39),('10318','2013-08-18','10:25:00',7.46),('10318','2013-08-18','10:30:00',7.48),('10318','2013-08-18','10:35:00',7.52),('10318','2013-08-18','10:40:00',7.56),('10318','2013-08-18','10:45:00',7.57),('10318','2013-08-18','10:50:00',7.61),('10318','2013-08-18','10:55:00',7.77),('10318','2013-08-18','11:00:00',7.75),('10318','2013-08-18','11:05:00',7.91),('10318','2013-08-18','11:10:00',7.96),('10318','2013-08-18','11:15:00',8.08),('10318','2013-08-18','11:20:00',8.17),('10318','2013-08-18','11:25:00',8.19),('10318','2013-08-18','11:30:00',8.09),('10318','2013-08-18','11:35:00',8.11),('10318','2013-08-18','11:40:00',8.3),('10318','2013-08-18','11:45:00',8.21),('10318','2013-08-18','11:50:00',7.91),('10318','2013-08-18','11:55:00',8.19),('10318','2013-08-18','12:00:00',8.58),('10318','2013-08-18','12:05:00',8.72),('10318','2013-08-18','12:10:00',7.79),('10318','2013-08-18','12:15:00',6.41),('10318','2013-08-18','12:20:00',4.8),('10318','2013-08-18','12:25:00',7.72),('10318','2013-08-18','12:30:00',3.64),('10318','2013-08-18','12:35:00',4.31),('10318','2013-08-18','12:40:00',8.55),('10318','2013-08-18','12:45:00',8.91),('10318','2013-08-18','12:50:00',9.07),('10318','2013-08-18','12:55:00',8.82),('10318','2013-08-18','13:00:00',8.68),('10318','2013-08-18','13:05:00',8.62),('10318','2013-08-18','13:10:00',8.3),('10318','2013-08-18','13:15:00',8.27),('10318','2013-08-18','13:20:00',8.54),('10318','2013-08-18','13:25:00',8.52),('10318','2013-08-18','13:30:00',8.61),('10318','2013-08-18','13:35:00',8.44),('10318','2013-08-18','13:40:00',8.46),('10318','2013-08-18','13:45:00',8.41),('10318','2013-08-18','13:50:00',8.42),('10318','2013-08-18','13:55:00',8.39),('10318','2013-08-18','14:00:00',8.31),('10318','2013-08-18','14:05:00',8.26),('10318','2013-08-18','14:10:00',8.18),('10318','2013-08-18','14:15:00',8.15),('10318','2013-08-18','14:20:00',8.09),('10318','2013-08-18','14:25:00',8.03),('10318','2013-08-18','14:30:00',7.93),('10318','2013-08-18','14:35:00',7.89),('10318','2013-08-18','14:40:00',7.83),('10318','2013-08-18','14:45:00',7.74),('10318','2013-08-18','14:50:00',7.66),('10318','2013-08-18','14:55:00',7.48),('10318','2013-08-18','15:00:00',7.39),('10318','2013-08-18','15:05:00',7.3),('10318','2013-08-18','15:10:00',7.22),('10318','2013-08-18','15:15:00',7.17),('10318','2013-08-18','15:20:00',7.1),('10318','2013-08-18','15:25:00',6.96),('10318','2013-08-18','15:30:00',6.85),('10318','2013-08-18','15:35:00',6.74),('10318','2013-08-18','15:40:00',6.59),('10318','2013-08-18','15:45:00',6.38),('10318','2013-08-18','15:50:00',6.3),('10318','2013-08-18','15:55:00',6.16),('10318','2013-08-18','16:00:00',6.06),('10318','2013-08-18','16:05:00',5.93),('10318','2013-08-18','16:10:00',5.76),('10318','2013-08-18','16:15:00',5.6),('10318','2013-08-18','16:20:00',5.33),('10318','2013-08-18','16:25:00',5.27),('10318','2013-08-18','16:30:00',5.12),('10318','2013-08-18','16:35:00',4.95),('10318','2013-08-18','16:40:00',4.79),('10318','2013-08-18','16:45:00',4.64),('10318','2013-08-18','16:50:00',4.48),('10318','2013-08-18','16:55:00',4.3),('10318','2013-08-18','17:00:00',4.12),('10318','2013-08-18','17:05:00',3.94),('10318','2013-08-18','17:10:00',3.77),('10318','2013-08-18','17:15:00',3.6),('10318','2013-08-18','17:20:00',3.42),('10318','2013-08-18','17:25:00',3.25),('10318','2013-08-18','17:30:00',3.07),('10318','2013-08-18','17:35:00',2.86),('10318','2013-08-18','17:40:00',2.72),('10318','2013-08-18','17:45:00',2.56),('10318','2013-08-18','17:50:00',2.39),('10318','2013-08-18','17:55:00',2.22),('10318','2013-08-18','18:00:00',2.06),('10318','2013-08-18','18:05:00',1.9),('10318','2013-08-18','18:10:00',1.76),('10318','2013-08-18','18:15:00',1.62),('10318','2013-08-18','18:20:00',1.48),('10318','2013-08-18','18:25:00',1.35),('10318','2013-08-18','18:30:00',1.21),('10318','2013-08-18','18:35:00',1.08),('10318','2013-08-17','07:30:00',1.41),('10318','2013-08-17','07:35:00',1.64),('10318','2013-08-17','07:40:00',2),('10318','2013-08-17','07:45:00',2.07),('10318','2013-08-17','07:50:00',2.48),('10318','2013-08-17','07:55:00',2.74),('10318','2013-08-17','08:00:00',2.95),('10318','2013-08-17','08:05:00',3.13),('10318','2013-08-17','08:10:00',3.33),('10318','2013-08-17','08:15:00',3.5),('10318','2013-08-17','08:20:00',3.7),('10318','2013-08-17','08:25:00',3.9),('10318','2013-08-17','08:30:00',4.12),('10318','2013-08-17','08:35:00',4.33),('10318','2013-08-17','08:40:00',4.53),('10318','2013-08-17','08:45:00',4.71),('10318','2013-08-17','08:50:00',4.9),('10318','2013-08-17','08:55:00',5.11),('10318','2013-08-17','09:00:00',5.14),('10318','2013-08-17','09:05:00',5.43),('10318','2013-08-17','09:10:00',5.58),('10318','2013-08-17','09:15:00',5.77),('10318','2013-08-17','09:20:00',5.92),('10318','2013-08-17','09:25:00',6.07),('10318','2013-08-17','09:30:00',6.18),('10318','2013-08-17','09:35:00',6.34),('10318','2013-08-17','09:40:00',6.46),('10318','2013-08-17','09:45:00',6.61),('10318','2013-08-17','09:50:00',6.72),('10318','2013-08-17','09:55:00',6.84),('10318','2013-08-17','10:00:00',6.96),('10318','2013-08-17','10:05:00',7.1),('10318','2013-08-17','10:10:00',7.2),('10318','2013-08-17','10:15:00',7.31),('10318','2013-08-17','10:20:00',7.41),('10318','2013-08-17','10:25:00',7.51),('10318','2013-08-17','10:30:00',7.58),('10318','2013-08-17','10:35:00',7.67),('10318','2013-08-17','10:40:00',7.76),('10318','2013-08-17','10:45:00',7.6),('10318','2013-08-17','10:50:00',7.88),('10318','2013-08-17','10:55:00',7.97),('10318','2013-08-17','11:00:00',8.03),('10318','2013-08-17','11:05:00',8.08),('10318','2013-08-17','11:10:00',8.11),('10318','2013-08-17','11:15:00',8.15),('10318','2013-08-17','11:20:00',8.17),('10318','2013-08-17','11:25:00',8.32),('10318','2013-08-17','11:30:00',8.4),('10318','2013-08-17','11:35:00',8.35),('10318','2013-08-17','11:40:00',8.43),('10318','2013-08-17','11:45:00',8.5),('10318','2013-08-17','11:50:00',8.55),('10318','2013-08-17','11:55:00',8.54),('10318','2013-08-17','12:00:00',8.32),('10318','2013-08-17','12:05:00',8.31),('10318','2013-08-17','12:10:00',8.62),('10318','2013-08-17','12:15:00',8.43),('10318','2013-08-17','12:20:00',8.48),('10318','2013-08-17','12:25:00',8.31),('10318','2013-08-17','12:30:00',8.53),('10318','2013-08-17','12:35:00',8.64),('10318','2013-08-17','12:40:00',8.58),('10318','2013-08-17','12:45:00',7.52),('10318','2013-08-17','12:50:00',5.73),('10318','2013-08-17','12:55:00',8.63),('10318','2013-08-17','13:00:00',8.73),('10318','2013-08-17','13:05:00',8.79),('10318','2013-08-17','13:10:00',8.65),('10318','2013-08-17','13:15:00',8.51),('10318','2013-08-17','13:20:00',8.62),('10318','2013-08-17','13:25:00',8.61),('10318','2013-08-17','13:30:00',8.82),('10318','2013-08-17','13:35:00',8.83),('10318','2013-08-17','13:40:00',8.53),('10318','2013-08-17','13:45:00',8.57),('10318','2013-08-17','13:50:00',8.75),('10318','2013-08-17','13:55:00',8.52),('10318','2013-08-17','14:00:00',6.47),('10318','2013-08-17','14:05:00',8.47),('10318','2013-08-17','14:10:00',8.4),('10318','2013-08-17','14:15:00',8.09),('10318','2013-08-17','14:20:00',8.1),('10318','2013-08-17','14:25:00',8.09),('10318','2013-08-17','14:30:00',7.92),('10318','2013-08-17','14:35:00',7.83),('10318','2013-08-17','14:40:00',7.84),('10318','2013-08-17','14:45:00',7.62),('10318','2013-08-17','14:50:00',7.58),('10318','2013-08-17','14:55:00',7.56),('10318','2013-08-17','15:00:00',7.46),('10318','2013-08-17','15:05:00',7.39),('10318','2013-08-17','15:10:00',7.24),('10318','2013-08-17','15:15:00',7.07),('10318','2013-08-17','15:20:00',7.06),('10318','2013-08-17','15:25:00',6.93),('10318','2013-08-17','15:30:00',6.83),('10318','2013-08-17','15:35:00',6.68),('10318','2013-08-17','15:40:00',6.55),('10318','2013-08-17','15:45:00',6.43),('10318','2013-08-17','15:50:00',6.3),('10318','2013-08-17','15:55:00',6.19),('10318','2013-08-17','16:00:00',6.11),('10318','2013-08-17','16:05:00',5.95),('10318','2013-08-17','16:10:00',5.83),('10318','2013-08-17','16:15:00',5.68),('10318','2013-08-17','16:20:00',5.52),('10318','2013-08-17','16:25:00',5.36),('10318','2013-08-17','16:30:00',5.21),('10318','2013-08-17','16:35:00',5.08),('10318','2013-08-17','16:40:00',4.91),('10318','2013-08-17','16:45:00',4.67),('10318','2013-08-17','16:50:00',4.51),('10318','2013-08-17','16:55:00',4.42),('10318','2013-08-17','17:00:00',4.26),('10318','2013-08-17','17:05:00',4.09),('10318','2013-08-17','17:10:00',3.68),('10318','2013-08-17','17:15:00',3.52),('10318','2013-08-17','17:20:00',3.46),('10318','2013-08-17','17:25:00',3.45),('10318','2013-08-17','17:30:00',3.3),('10318','2013-08-17','17:35:00',3.11),('10318','2013-08-17','17:40:00',2.93),('10318','2013-08-17','17:45:00',2.74),('10318','2013-08-17','17:50:00',2.55),('10318','2013-08-17','17:55:00',2.39),('10318','2013-08-17','18:00:00',2.22),('10318','2013-08-17','18:05:00',2.05),('10318','2013-08-17','18:10:00',1.9),('10318','2013-08-17','18:15:00',1.73),('10318','2013-08-17','18:20:00',1.59),('10318','2013-08-17','18:25:00',1.43),('10318','2013-08-17','18:30:00',1.28),('10318','2013-08-17','18:35:00',1.14),('10318','2013-08-17','18:40:00',1.01),('10318','2013-08-16','07:30:00',1.47),('10318','2013-08-16','07:35:00',1.76),('10318','2013-08-16','07:40:00',2.05),('10318','2013-08-16','07:45:00',2.28),('10318','2013-08-16','07:50:00',2.55),('10318','2013-08-16','07:55:00',2.79),('10318','2013-08-16','08:00:00',3),('10318','2013-08-16','08:05:00',3.21),('10318','2013-08-16','08:10:00',3.4),('10318','2013-08-16','08:15:00',3.59),('10318','2013-08-16','08:20:00',3.79),('10318','2013-08-16','08:25:00',4.02),('10318','2013-08-16','08:30:00',4.21),('10318','2013-08-16','08:35:00',4.44),('10318','2013-08-16','08:40:00',4.63),('10318','2013-08-16','08:45:00',4.81),('10318','2013-08-16','08:50:00',4.99),('10318','2013-08-16','08:55:00',5.11),('10318','2013-08-16','09:00:00',5.38),('10318','2013-08-16','09:05:00',5.56),('10318','2013-08-16','09:10:00',5.74),('10318','2013-08-16','09:15:00',5.94),('10318','2013-08-16','09:20:00',6.1),('10318','2013-08-16','09:25:00',6.25),('10318','2013-08-16','09:30:00',6.42),('10318','2013-08-16','09:35:00',6.57),('10318','2013-08-16','09:40:00',6.73),('10318','2013-08-16','09:45:00',6.87),('10318','2013-08-16','09:50:00',7),('10318','2013-08-16','09:55:00',7.13),('10318','2013-08-16','10:00:00',7.23),('10318','2013-08-16','10:05:00',7.36),('10318','2013-08-16','10:10:00',7.49),('10318','2013-08-16','10:15:00',7.59),('10318','2013-08-16','10:20:00',7.7),('10318','2013-08-16','10:25:00',7.78),('10318','2013-08-16','10:30:00',7.87),('10318','2013-08-16','10:35:00',7.98),('10318','2013-08-16','10:40:00',8.05),('10318','2013-08-16','10:45:00',8.07),('10318','2013-08-16','10:50:00',8.2),('10318','2013-08-16','10:55:00',8.29),('10318','2013-08-16','11:00:00',8.36),('10318','2013-08-16','11:05:00',8.41),('10318','2013-08-16','11:10:00',8.46),('10318','2013-08-16','11:15:00',8.5),('10318','2013-08-16','11:20:00',8.56),('10318','2013-08-16','11:25:00',8.6),('10318','2013-08-16','11:30:00',8.64),('10318','2013-08-16','11:35:00',8.7),('10318','2013-08-16','11:40:00',8.71),('10318','2013-08-16','11:45:00',8.72),('10318','2013-08-16','11:50:00',8.76),('10318','2013-08-16','11:55:00',8.82),('10318','2013-08-16','12:00:00',8.85),('10318','2013-08-16','12:05:00',8.87),('10318','2013-08-16','12:10:00',8.83),('10318','2013-08-16','12:15:00',8.86),('10318','2013-08-16','12:20:00',8.84),('10318','2013-08-16','12:25:00',8.83),('10318','2013-08-16','12:30:00',8.51),('10318','2013-08-16','12:35:00',8.81),('10318','2013-08-16','12:40:00',8.83),('10318','2013-08-16','12:45:00',8.81),('10318','2013-08-16','12:50:00',8.75),('10318','2013-08-16','12:55:00',8.75),('10318','2013-08-16','13:00:00',8.73),('10318','2013-08-16','13:05:00',8.74),('10318','2013-08-16','13:10:00',8.71),('10318','2013-08-16','13:15:00',8.61),('10318','2013-08-16','13:20:00',8.6),('10318','2013-08-16','13:25:00',8.56),('10318','2013-08-16','13:30:00',8.5),('10318','2013-08-16','13:35:00',8.47),('10318','2013-08-16','13:40:00',8.41),('10318','2013-08-16','13:45:00',8.4),('10318','2013-08-16','13:50:00',8.37),('10318','2013-08-16','13:55:00',8.32),('10318','2013-08-16','14:00:00',8.27),('10318','2013-08-16','14:05:00',8.22),('10318','2013-08-16','14:10:00',8.15),('10318','2013-08-16','14:15:00',8.01),('10318','2013-08-16','14:20:00',7.98),('10318','2013-08-16','14:25:00',7.93),('10318','2013-08-16','14:30:00',7.83),('10318','2013-08-16','14:35:00',7.72),('10318','2013-08-16','14:40:00',7.58),('10318','2013-08-16','14:45:00',7.47),('10318','2013-08-16','14:50:00',7.36),('10318','2013-08-16','14:55:00',7.26),('10318','2013-08-16','15:00:00',7.31),('10318','2013-08-16','15:05:00',7.27),('10318','2013-08-16','15:10:00',7.16),('10318','2013-08-16','15:15:00',7.07),('10318','2013-08-16','15:20:00',7.02),('10318','2013-08-16','15:25:00',6.97),('10318','2013-08-16','15:30:00',6.78),('10318','2013-08-16','15:35:00',6.71),('10318','2013-08-16','15:40:00',6.6),('10318','2013-08-16','15:45:00',6.46),('10318','2013-08-16','15:50:00',6.35),('10318','2013-08-16','15:55:00',6.2),('10318','2013-08-16','16:00:00',6.02),('10318','2013-08-16','16:05:00',5.91),('10318','2013-08-16','16:10:00',5.74),('10318','2013-08-16','16:15:00',5.58),('10318','2013-08-16','16:20:00',5.44),('10318','2013-08-16','16:25:00',5.29),('10318','2013-08-16','16:30:00',5.13),('10318','2013-08-16','16:35:00',4.99),('10318','2013-08-16','16:40:00',4.83),('10318','2013-08-16','16:45:00',4.66),('10318','2013-08-16','16:50:00',4.49),('10318','2013-08-16','16:55:00',4.32),('10318','2013-08-16','17:00:00',4.14),('10318','2013-08-16','17:05:00',3.96),('10318','2013-08-16','17:10:00',3.79),('10318','2013-08-16','17:15:00',3.54),('10318','2013-08-16','17:20:00',3.42),('10318','2013-08-16','17:25:00',3.26),('10318','2013-08-16','17:30:00',3.08),('10318','2013-08-16','17:35:00',2.91),('10318','2013-08-16','17:40:00',2.74),('10318','2013-08-16','17:45:00',2.55),('10318','2013-08-16','17:50:00',2.4),('10318','2013-08-16','17:55:00',2.24),('10318','2013-08-16','18:00:00',2.08),('10318','2013-08-16','18:05:00',1.92),('10318','2013-08-16','18:10:00',1.78),('10318','2013-08-16','18:15:00',1.64),('10318','2013-08-16','18:20:00',1.51),('10318','2013-08-16','18:25:00',1.36),('10318','2013-08-16','18:30:00',1.05),('10318','2013-08-15','07:45:00',1.05),('10318','2013-08-15','07:50:00',1.41),('10318','2013-08-15','07:55:00',1.57),('10318','2013-08-15','08:00:00',1.39),('10318','2013-08-15','08:05:00',1.66),('10318','2013-08-15','08:10:00',3.84),('10318','2013-08-15','08:15:00',3.75),('10318','2013-08-15','08:20:00',4.11),('10318','2013-08-15','08:25:00',4.28),('10318','2013-08-15','08:30:00',4.4),('10318','2013-08-15','08:35:00',4.56),('10318','2013-08-15','08:40:00',4.7),('10318','2013-08-15','08:45:00',4.86),('10318','2013-08-15','08:50:00',5.11),('10318','2013-08-15','08:55:00',4.83),('10318','2013-08-15','09:00:00',1.97),('10318','2013-08-15','09:05:00',3.98),('10318','2013-08-15','09:10:00',2.26),('10318','2013-08-15','09:15:00',2.87),('10318','2013-08-15','09:20:00',4.99),('10318','2013-08-15','09:25:00',6.46),('10318','2013-08-15','09:30:00',6.46),('10318','2013-08-15','09:35:00',6.57),('10318','2013-08-15','09:40:00',6.7),('10318','2013-08-15','09:45:00',6.82),('10318','2013-08-15','09:50:00',6.96),('10318','2013-08-15','09:55:00',7.11),('10318','2013-08-15','10:00:00',7.12),('10318','2013-08-15','10:05:00',7.33),('10318','2013-08-15','10:10:00',7.46),('10318','2013-08-15','10:15:00',7.54),('10318','2013-08-15','10:20:00',7.66),('10318','2013-08-15','10:25:00',7.77),('10318','2013-08-15','10:30:00',7.87),('10318','2013-08-15','10:35:00',8.03),('10318','2013-08-15','10:40:00',8.15),('10318','2013-08-15','10:45:00',8.28),('10318','2013-08-15','10:50:00',8.41),('10318','2013-08-15','10:55:00',8.54),('10318','2013-08-15','11:00:00',8.6),('10318','2013-08-15','11:05:00',8.41),('10318','2013-08-15','11:10:00',7.52),('10318','2013-08-15','11:15:00',6.66),('10318','2013-08-15','11:20:00',6.24),('10318','2013-08-15','11:25:00',5.44),('10318','2013-08-15','11:30:00',5.58),('10318','2013-08-15','11:35:00',7.18),('10318','2013-08-15','11:40:00',8.34),('10318','2013-08-15','11:45:00',8.7),('10318','2013-08-15','11:50:00',9.26),('10318','2013-08-15','11:55:00',9.24),('10318','2013-08-15','12:00:00',9.36),('10318','2013-08-15','12:05:00',9.1),('10318','2013-08-15','12:10:00',8.93),('10318','2013-08-15','12:15:00',8.95),('10318','2013-08-15','12:20:00',9.22),('10318','2013-08-15','12:25:00',9.18),('10318','2013-08-15','12:30:00',9.09),('10318','2013-08-15','12:35:00',9.13),('10318','2013-08-15','12:40:00',9.08),('10318','2013-08-15','12:45:00',8.99),('10318','2013-08-15','12:50:00',8.93),('10318','2013-08-15','12:55:00',9.01),('10318','2013-08-15','13:00:00',8.99),('10318','2013-08-15','13:05:00',8.84),('10318','2013-08-15','13:10:00',8.75),('10318','2013-08-15','13:15:00',8.76),('10318','2013-08-15','13:20:00',8.78),('10318','2013-08-15','13:25:00',8.8),('10318','2013-08-15','13:30:00',8.86),('10318','2013-08-15','13:35:00',8.78),('10318','2013-08-15','13:40:00',8.74),('10318','2013-08-15','13:45:00',8.68),('10318','2013-08-15','13:50:00',8.62),('10318','2013-08-15','13:55:00',8.54),('10318','2013-08-15','14:00:00',8.5),('10318','2013-08-15','14:05:00',8.44),('10318','2013-08-15','14:10:00',8.41),('10318','2013-08-15','14:15:00',8.33),('10318','2013-08-15','14:20:00',8.19),('10318','2013-08-15','14:25:00',8.06),('10318','2013-08-15','14:30:00',7.94),('10318','2013-08-15','14:35:00',7.91),('10318','2013-08-15','14:40:00',7.74),('10318','2013-08-15','14:45:00',7.65),('10318','2013-08-15','14:50:00',5.59),('10318','2013-08-15','14:55:00',7.45),('10318','2013-08-15','15:00:00',7.37),('10318','2013-08-15','15:05:00',7.27),('10318','2013-08-15','15:10:00',7.2),('10318','2013-08-15','15:15:00',7.07),('10318','2013-08-15','15:20:00',6.93),('10318','2013-08-15','15:25:00',6.85),('10318','2013-08-15','15:30:00',6.77),('10318','2013-08-15','15:35:00',6.65),('10318','2013-08-15','15:40:00',6.51),('10318','2013-08-15','15:45:00',6.33),('10318','2013-08-15','15:50:00',6.22),('10318','2013-08-15','15:55:00',6.06),('10318','2013-08-15','16:00:00',5.94),('10318','2013-08-15','16:05:00',5.69),('10318','2013-08-15','16:10:00',5.58),('10318','2013-08-15','16:15:00',5.44),('10318','2013-08-15','16:20:00',5.21),('10318','2013-08-15','16:25:00',5.21),('10318','2013-08-15','16:30:00',5.07),('10318','2013-08-15','16:35:00',4.93),('10318','2013-08-15','16:40:00',4.76),('10318','2013-08-15','16:45:00',4.59),('10318','2013-08-15','16:50:00',4.43),('10318','2013-08-15','16:55:00',4.27),('10318','2013-08-15','17:00:00',4.07),('10318','2013-08-15','17:05:00',3.81),('10318','2013-08-15','17:10:00',3.74),('10318','2013-08-15','17:15:00',3.63),('10318','2013-08-15','17:20:00',3.43),('10318','2013-08-15','17:25:00',3.21),('10318','2013-08-15','17:30:00',2.95),('10318','2013-08-15','17:35:00',2.89),('10318','2013-08-15','17:40:00',2.74),('10318','2013-08-15','17:45:00',2.59),('10318','2013-08-15','17:50:00',2.37),('10318','2013-08-15','17:55:00',2.26),('10318','2013-08-15','18:00:00',2.1),('10318','2013-08-15','18:05:00',1.98),('10318','2013-08-15','18:10:00',1.85),('10318','2013-08-15','18:15:00',1.72),('10318','2013-08-15','18:20:00',1.57),('10318','2013-08-15','18:25:00',1.45),('10318','2013-08-15','18:30:00',1.32),('10318','2013-08-15','18:35:00',1.2),('10318','2013-08-15','18:40:00',1.07),('10318','2013-08-14','07:25:00',1.04),('10318','2013-08-14','07:30:00',1.54),('10318','2013-08-14','07:35:00',1.8),('10318','2013-08-14','07:40:00',2.06),('10318','2013-08-14','07:45:00',2.24),('10318','2013-08-14','07:50:00',2.57),('10318','2013-08-14','07:55:00',2.79),('10318','2013-08-14','08:00:00',2.99),('10318','2013-08-14','08:05:00',3.17),('10318','2013-08-14','08:10:00',3.32),('10318','2013-08-14','08:15:00',3.55),('10318','2013-08-14','08:20:00',3.66),('10318','2013-08-14','08:25:00',3.53),('10318','2013-08-14','08:30:00',4.1),('10318','2013-08-14','08:35:00',4.26),('10318','2013-08-14','08:40:00',4.27),('10318','2013-08-14','08:45:00',4.63),('10318','2013-08-14','08:50:00',4.77),('10318','2013-08-14','08:55:00',4.94),('10318','2013-08-14','09:00:00',5.15),('10318','2013-08-14','09:05:00',5.39),('10318','2013-08-14','09:10:00',5.48),('10318','2013-08-14','09:15:00',5.7),('10318','2013-08-14','09:20:00',5.89),('10318','2013-08-14','09:25:00',5.81),('10318','2013-08-14','09:30:00',6.57),('10318','2013-08-14','09:35:00',4.21),('10318','2013-08-14','09:40:00',3.34),('10318','2013-08-14','09:45:00',2.06),('10318','2013-08-14','09:50:00',2.9),('10318','2013-08-14','09:55:00',7.42),('10318','2013-08-14','10:00:00',7.25),('10318','2013-08-14','10:05:00',6.65),('10318','2013-08-14','10:10:00',7.33),('10318','2013-08-14','10:15:00',2.7),('10318','2013-08-14','10:20:00',4.03),('10318','2013-08-14','10:25:00',6.42),('10318','2013-08-14','10:30:00',6.43),('10318','2013-08-14','10:35:00',5.78),('10318','2013-08-14','10:40:00',7.8),('10318','2013-08-14','10:45:00',8.08),('10318','2013-08-14','10:50:00',8.41),('10318','2013-08-14','10:55:00',8.15),('10318','2013-08-14','11:00:00',8.19),('10318','2013-08-14','11:05:00',8.38),('10318','2013-08-14','11:10:00',7.08),('10318','2013-08-14','11:15:00',8.04),('10318','2013-08-14','11:20:00',6.26),('10318','2013-08-14','11:25:00',3.28),('10318','2013-08-14','11:30:00',4.21),('10318','2013-08-14','11:35:00',9.39),('10318','2013-08-14','11:40:00',7),('10318','2013-08-14','11:45:00',2.96),('10318','2013-08-14','11:50:00',2.72),('10318','2013-08-14','11:55:00',2.78),('10318','2013-08-14','12:00:00',8.35),('10318','2013-08-14','12:05:00',7.02),('10318','2013-08-14','12:10:00',3.4),('10318','2013-08-14','12:15:00',3.88),('10318','2013-08-14','12:20:00',4.36),('10318','2013-08-14','12:25:00',4.1),('10318','2013-08-14','12:30:00',6.57),('10318','2013-08-14','12:35:00',9.14),('10318','2013-08-14','12:40:00',5.84),('10318','2013-08-14','12:45:00',2.75),('10318','2013-08-14','12:50:00',2.79),('10318','2013-08-14','12:55:00',3.25),('10318','2013-08-14','13:00:00',3.45),('10318','2013-08-14','13:05:00',3.31),('10318','2013-08-14','13:10:00',5.01),('10318','2013-08-14','13:15:00',7.86),('10318','2013-08-14','13:20:00',8.72),('10318','2013-08-14','13:25:00',9.35),('10318','2013-08-14','13:30:00',9.22),('10318','2013-08-14','13:35:00',8.42),('10318','2013-08-14','13:40:00',9.48),('10318','2013-08-14','13:45:00',9.53),('10318','2013-08-14','13:50:00',9.55),('10318','2013-08-14','13:55:00',8.21),('10318','2013-08-14','14:00:00',9.02),('10318','2013-08-14','14:05:00',8.96),('10318','2013-08-14','14:10:00',8.94),('10318','2013-08-14','14:15:00',8.92),('10318','2013-08-14','14:20:00',8.91),('10318','2013-08-14','14:25:00',8.5),('10318','2013-08-14','14:30:00',8.4),('10318','2013-08-14','14:35:00',7.72),('10318','2013-08-14','14:40:00',8.11),('10318','2013-08-14','14:45:00',8.01),('10318','2013-08-14','14:50:00',7.85),('10318','2013-08-14','14:55:00',7.83),('10318','2013-08-14','15:00:00',7.55),('10318','2013-08-14','15:05:00',7.42),('10318','2013-08-14','15:10:00',7.31),('10318','2013-08-14','15:15:00',7.26),('10318','2013-08-14','15:20:00',7.17),('10318','2013-08-14','15:25:00',7.07),('10318','2013-08-14','15:30:00',6.93),('10318','2013-08-14','15:35:00',6.77),('10318','2013-08-14','15:40:00',6.67),('10318','2013-08-14','15:45:00',6.33),('10318','2013-08-14','15:50:00',6.38),('10318','2013-08-14','15:55:00',6.3),('10318','2013-08-14','16:00:00',6.16),('10318','2013-08-14','16:05:00',6.02),('10318','2013-08-14','16:10:00',5.92),('10318','2013-08-14','16:15:00',5.71),('10318','2013-08-14','16:20:00',5.64),('10318','2013-08-14','16:25:00',5.46),('10318','2013-08-14','16:30:00',5.31),('10318','2013-08-14','16:35:00',5.11),('10318','2013-08-14','16:40:00',4.96),('10318','2013-08-14','16:45:00',4.82),('10318','2013-08-14','16:50:00',4.62),('10318','2013-08-14','16:55:00',4.42),('10318','2013-08-14','17:00:00',4.24),('10318','2013-08-14','17:05:00',4.08),('10318','2013-08-14','17:10:00',3.88),('10318','2013-08-14','17:15:00',3.7),('10318','2013-08-14','17:20:00',3.56),('10318','2013-08-14','17:25:00',3.38),('10318','2013-08-14','17:30:00',3.17),('10318','2013-08-14','17:35:00',3.04),('10318','2013-08-14','17:40:00',2.88),('10318','2013-08-14','17:45:00',2.71),('10318','2013-08-14','17:50:00',2.52),('10318','2013-08-14','17:55:00',2.37),('10318','2013-08-14','18:00:00',2.18),('10318','2013-08-14','18:05:00',2.08),('10318','2013-08-14','18:10:00',1.93),('10318','2013-08-14','18:15:00',1.81),('10318','2013-08-14','18:20:00',1.73),('10318','2013-08-14','18:25:00',1.73),('10318','2013-08-14','18:30:00',1.61),('10318','2013-08-14','18:35:00',1.37),('10318','2013-08-14','18:40:00',1.17),('10318','2013-08-14','18:45:00',1.11),('10318','2013-08-14','18:50:00',1.16),('10318','2013-08-14','18:55:00',1.14),('10318','2013-08-14','19:00:00',1.19),('10318','2013-08-14','19:05:00',1.06),('10318','2013-08-13','07:25:00',1.24),('10318','2013-08-13','07:30:00',1.53),('10318','2013-08-13','07:35:00',1.89),('10318','2013-08-13','07:40:00',2.12),('10318','2013-08-13','07:45:00',2.32),('10318','2013-08-13','07:50:00',2.54),('10318','2013-08-13','07:55:00',2.74),('10318','2013-08-13','08:00:00',3.01),('10318','2013-08-13','08:05:00',3.26),('10318','2013-08-13','08:10:00',3.37),('10318','2013-08-13','08:15:00',3.53),('10318','2013-08-13','08:20:00',3.79),('10318','2013-08-13','08:25:00',3.99),('10318','2013-08-13','08:30:00',4.16),('10318','2013-08-13','08:35:00',4.38),('10318','2013-08-13','08:40:00',4.53),('10318','2013-08-13','08:45:00',4.75),('10318','2013-08-13','08:50:00',4.94),('10318','2013-08-13','08:55:00',5.08),('10318','2013-08-13','09:00:00',5.32),('10318','2013-08-13','09:05:00',5.45),('10318','2013-08-13','09:10:00',5.65),('10318','2013-08-13','09:15:00',5.86),('10318','2013-08-13','09:20:00',5.95),('10318','2013-08-13','09:25:00',6.01),('10318','2013-08-13','09:30:00',6.14),('10318','2013-08-13','09:35:00',6.27),('10318','2013-08-13','09:40:00',6.55),('10318','2013-08-13','09:45:00',6.63),('10318','2013-08-13','09:50:00',6.79),('10318','2013-08-13','09:55:00',6.88),('10318','2013-08-13','10:00:00',3.79),('10318','2013-08-13','10:05:00',7.33),('10318','2013-08-13','10:10:00',7.34),('10318','2013-08-13','10:15:00',7.39),('10318','2013-08-13','10:20:00',7.37),('10318','2013-08-13','10:25:00',7.49),('10318','2013-08-13','10:30:00',7.58),('10318','2013-08-13','10:35:00',7.69),('10318','2013-08-13','10:40:00',7.18),('10318','2013-08-13','10:45:00',7.78),('10318','2013-08-13','10:50:00',7.86),('10318','2013-08-13','10:55:00',7.95),('10318','2013-08-13','11:00:00',8.17),('10318','2013-08-13','11:05:00',8.26),('10318','2013-08-13','11:10:00',8.06),('10318','2013-08-13','11:15:00',8.16),('10318','2013-08-13','11:20:00',8.08),('10318','2013-08-13','11:25:00',8.38),('10318','2013-08-13','11:30:00',8.41),('10318','2013-08-13','11:35:00',8.37),('10318','2013-08-13','11:40:00',8.17),('10318','2013-08-13','11:45:00',8.54),('10318','2013-08-13','11:50:00',7.64),('10318','2013-08-13','11:55:00',8.24),('10318','2013-08-13','12:00:00',8.88),('10318','2013-08-13','12:05:00',8.93),('10318','2013-08-13','12:10:00',9.1),('10318','2013-08-13','12:15:00',8.14),('10318','2013-08-13','12:20:00',8.16),('10318','2013-08-13','12:25:00',8.12),('10318','2013-08-13','12:30:00',9.55),('10318','2013-08-13','12:35:00',8.32),('10318','2013-08-13','12:40:00',3.49),('10318','2013-08-13','12:45:00',8.97),('10318','2013-08-13','12:50:00',4.17),('10318','2013-08-13','12:55:00',4.85),('10318','2013-08-13','13:00:00',7.73),('10318','2013-08-13','13:05:00',9.8),('10318','2013-08-13','13:10:00',9.08),('10318','2013-08-13','13:15:00',9.17),('10318','2013-08-13','13:20:00',8.85),('10318','2013-08-13','13:25:00',9.04),('10318','2013-08-13','13:30:00',9.32),('10318','2013-08-13','13:35:00',4.43),('10318','2013-08-13','13:40:00',3.41),('10318','2013-08-13','13:45:00',5.11),('10318','2013-08-13','13:50:00',9.96),('10318','2013-08-13','13:55:00',5.75),('10318','2013-08-13','14:00:00',9.24),('10318','2013-08-13','14:05:00',8.66),('10318','2013-08-13','14:10:00',8.59),('10318','2013-08-13','14:15:00',8.7),('10318','2013-08-13','14:20:00',8.48),('10318','2013-08-13','14:25:00',8.31),('10318','2013-08-13','14:30:00',8.69),('10318','2013-08-13','14:35:00',8.41),('10318','2013-08-13','14:40:00',8.06),('10318','2013-08-13','14:45:00',7.88),('10318','2013-08-13','14:50:00',7.89),('10318','2013-08-13','14:55:00',7.65),('10318','2013-08-13','15:00:00',7.7),('10318','2013-08-13','15:05:00',7.49),('10318','2013-08-13','15:10:00',7.4),('10318','2013-08-13','15:15:00',7.23),('10318','2013-08-13','15:20:00',7.16),('10318','2013-08-13','15:25:00',6.92),('10318','2013-08-13','15:30:00',5.82),('10318','2013-08-13','15:35:00',6.95),('10318','2013-08-13','15:40:00',6.67),('10318','2013-08-13','15:45:00',6.53),('10318','2013-08-13','15:50:00',6.41),('10318','2013-08-13','15:55:00',6.28),('10318','2013-08-13','16:00:00',6.05),('10318','2013-08-13','16:05:00',6.02),('10318','2013-08-13','16:10:00',5.86),('10318','2013-08-13','16:15:00',5.73),('10318','2013-08-13','16:20:00',5.57),('10318','2013-08-13','16:25:00',5.39),('10318','2013-08-13','16:30:00',5.26),('10318','2013-08-13','16:35:00',5.13),('10318','2013-08-13','16:40:00',4.98),('10318','2013-08-13','16:45:00',4.79),('10318','2013-08-13','16:50:00',4.63),('10318','2013-08-13','16:55:00',4.46),('10318','2013-08-13','17:00:00',4.26),('10318','2013-08-13','17:05:00',4.09),('10318','2013-08-13','17:10:00',3.92),('10318','2013-08-13','17:15:00',3.66),('10318','2013-08-12','07:25:00',1.29),('10318','2013-08-12','07:30:00',1.54),('10318','2013-08-12','07:35:00',1.86),('10318','2013-08-12','07:40:00',2.08),('10318','2013-08-12','07:45:00',2.36),('10318','2013-08-12','07:50:00',2.59),('10318','2013-08-12','07:55:00',2.74),('10318','2013-08-12','08:00:00',2.96),('10318','2013-08-12','08:05:00',3.16),('10318','2013-08-12','08:10:00',3.35),('10318','2013-08-12','08:15:00',3.55),('10318','2013-08-12','08:20:00',3.73),('10318','2013-08-12','08:25:00',3.9),('10318','2013-08-12','08:30:00',4.13),('10318','2013-08-12','08:35:00',4.33),('10318','2013-08-12','08:40:00',4.5),('10318','2013-08-12','08:45:00',4.69),('10318','2013-08-12','08:50:00',4.85),('10318','2013-08-12','08:55:00',5.02),('10318','2013-08-12','09:00:00',5.18),('10318','2013-08-12','09:05:00',5.32),('10318','2013-08-12','09:10:00',5.41),('10318','2013-08-12','09:15:00',5.65),('10318','2013-08-12','09:20:00',5.83),('10318','2013-08-12','09:25:00',5.98),('10318','2013-08-12','09:30:00',6.11),('10318','2013-08-12','09:35:00',6.26),('10318','2013-08-12','09:40:00',6.38),('10318','2013-08-12','09:45:00',6.52),('10318','2013-08-12','09:50:00',6.64),('10318','2013-08-12','09:55:00',6.76),('10318','2013-08-12','10:00:00',6.87),('10318','2013-08-12','10:05:00',6.97),('10318','2013-08-12','10:10:00',7.09),('10318','2013-08-12','10:15:00',7.2),('10318','2013-08-12','10:20:00',7.32),('10318','2013-08-12','10:25:00',7.4),('10318','2013-08-12','10:30:00',7.52),('10318','2013-08-12','10:35:00',7.59),('10318','2013-08-12','10:40:00',7.64),('10318','2013-08-12','10:45:00',7.76),('10318','2013-08-12','10:50:00',7.88),('10318','2013-08-12','10:55:00',7.72),('10318','2013-08-12','11:00:00',7.94),('10318','2013-08-12','11:05:00',8.01),('10318','2013-08-12','11:10:00',8.09),('10318','2013-08-12','11:15:00',8.12),('10318','2013-08-12','11:20:00',8.2),('10318','2013-08-12','11:25:00',8.19),('10318','2013-08-12','11:30:00',8.3),('10318','2013-08-12','11:35:00',8.13),('10318','2013-08-12','11:40:00',8.35),('10318','2013-08-12','11:45:00',8.48),('10318','2013-08-12','11:50:00',8.53),('10318','2013-08-12','11:55:00',8.54),('10318','2013-08-12','12:00:00',8.66),('10318','2013-08-12','12:05:00',5.53),('10318','2013-08-12','12:10:00',8.13),('10318','2013-08-12','12:15:00',9.18),('10318','2013-08-12','12:20:00',8.35),('10318','2013-08-12','12:25:00',7.51),('10318','2013-08-12','12:30:00',3.5),('10318','2013-08-12','12:35:00',8.36),('10318','2013-08-12','12:40:00',6.14),('10318','2013-08-12','12:45:00',2.09),('10318','2013-08-12','12:50:00',2.14),('10318','2013-08-12','12:55:00',4.45),('10318','2013-08-12','13:00:00',2.02),('10318','2013-08-12','13:05:00',3.39),('10318','2013-08-12','13:10:00',4.49),('10318','2013-08-12','13:15:00',6.54),('10318','2013-08-12','13:20:00',4.95),('10318','2013-08-12','13:25:00',3.27),('10318','2013-08-12','13:30:00',4.24),('10318','2013-08-12','13:35:00',9.88),('10318','2013-08-12','13:40:00',9.12),('10318','2013-08-12','13:45:00',6.18),('10318','2013-08-12','13:50:00',4.29),('10318','2013-08-12','13:55:00',3.29),('10318','2013-08-12','14:00:00',2.93),('10318','2013-08-12','14:05:00',3.84),('10318','2013-08-12','14:10:00',3),('10318','2013-08-12','14:15:00',2.35),('10318','2013-08-12','14:20:00',2.04),('10318','2013-08-12','14:25:00',2.68),('10318','2013-08-12','14:30:00',3.07),('10318','2013-08-12','14:35:00',3.84),('10318','2013-08-12','14:40:00',5.23),('10318','2013-08-12','14:45:00',9.09),('10318','2013-08-12','14:50:00',4.59),('10318','2013-08-12','14:55:00',5.62),('10318','2013-08-12','15:00:00',7.95),('10318','2013-08-12','15:05:00',8.24),('10318','2013-08-12','15:10:00',7.83),('10318','2013-08-12','15:15:00',7.56),('10318','2013-08-12','15:20:00',7.37),('10318','2013-08-12','15:25:00',7.24),('10318','2013-08-12','15:30:00',6.99),('10318','2013-08-12','15:35:00',2.94),('10318','2013-08-12','15:40:00',5.75),('10318','2013-08-12','15:45:00',6.23),('10318','2013-08-12','15:50:00',6.46),('10318','2013-08-12','15:55:00',6.37),('10318','2013-08-12','16:00:00',6.23),('10318','2013-08-12','16:05:00',5.7),('10318','2013-08-12','16:10:00',5.79),('10318','2013-08-12','16:15:00',5.64),('10318','2013-08-12','16:20:00',5.26),('10318','2013-08-12','16:25:00',5.18),('10318','2013-08-12','16:30:00',5.27),('10318','2013-08-12','16:35:00',5.16),('10318','2013-08-12','16:40:00',4.95),('10318','2013-08-12','16:45:00',4.74),('10318','2013-08-12','16:50:00',4.58),('10318','2013-08-12','16:55:00',4.45),('10318','2013-08-12','17:00:00',4.24),('10318','2013-08-12','17:05:00',4.1),('10318','2013-08-12','17:10:00',3.93),('10318','2013-08-12','17:15:00',3.7),('10318','2013-08-12','17:20:00',3.6),('10318','2013-08-12','17:25:00',3.42),('10318','2013-08-12','17:30:00',3.2),('10318','2013-08-12','17:35:00',3.1),('10318','2013-08-12','17:40:00',2.93),('10318','2013-08-12','17:45:00',2.74),('10318','2013-08-12','17:50:00',2.55),('10318','2013-08-12','17:55:00',2.36),('10318','2013-08-12','18:00:00',2.21),('10318','2013-08-12','18:05:00',2.07),('10318','2013-08-12','18:10:00',1.9),('10318','2013-08-12','18:15:00',1.76),('10318','2013-08-12','18:20:00',1.61),('10318','2013-08-12','18:25:00',1.49),('10318','2013-08-12','18:30:00',1.37),('10318','2013-08-12','18:35:00',1.26),('10318','2013-08-12','18:40:00',1.14),('10318','2013-08-12','18:45:00',1.03),('10318','2013-08-11','07:25:00',1.33),('10318','2013-08-11','07:30:00',1.55),('10318','2013-08-11','07:35:00',1.88),('10318','2013-08-11','07:40:00',2.13),('10318','2013-08-11','07:45:00',2.42),('10318','2013-08-11','07:50:00',2.69),('10318','2013-08-11','07:55:00',2.87),('10318','2013-08-11','08:00:00',3.11),('10318','2013-08-11','08:05:00',3.3),('10318','2013-08-11','08:10:00',3.47),('10318','2013-08-11','08:15:00',3.67),('10318','2013-08-11','08:20:00',3.86),('10318','2013-08-11','08:25:00',4.04),('10318','2013-08-11','08:30:00',4.27),('10318','2013-08-11','08:35:00',4.44),('10318','2013-08-11','08:40:00',4.64),('10318','2013-08-11','08:45:00',4.84),('10318','2013-08-11','08:50:00',5),('10318','2013-08-11','08:55:00',5.18),('10318','2013-08-11','09:00:00',5.37),('10318','2013-08-11','09:05:00',5.52),('10318','2013-08-11','09:10:00',5.67),('10318','2013-08-11','09:15:00',5.86),('10318','2013-08-11','09:20:00',5.97),('10318','2013-08-11','09:25:00',6.13),('10318','2013-08-11','09:30:00',6.28),('10318','2013-08-11','09:35:00',6.38),('10318','2013-08-11','09:40:00',6.51),('10318','2013-08-11','09:45:00',6.67),('10318','2013-08-11','09:50:00',6.79),('10318','2013-08-11','09:55:00',6.94),('10318','2013-08-11','10:00:00',7.05),('10318','2013-08-11','10:05:00',7.19),('10318','2013-08-11','10:10:00',7.27),('10318','2013-08-11','10:15:00',7.4),('10318','2013-08-11','10:20:00',7.47),('10318','2013-08-11','10:25:00',7.53),('10318','2013-08-11','10:30:00',7.63),('10318','2013-08-11','10:35:00',7.76),('10318','2013-08-11','10:40:00',7.83),('10318','2013-08-11','10:45:00',7.94),('10318','2013-08-11','10:50:00',8.03),('10318','2013-08-11','10:55:00',8.01),('10318','2013-08-11','11:00:00',8.18),('10318','2013-08-11','11:05:00',8.24),('10318','2013-08-11','11:10:00',8.34),('10318','2013-08-11','11:15:00',8.41),('10318','2013-08-11','11:20:00',8.45),('10318','2013-08-11','11:25:00',8.45),('10318','2013-08-11','11:30:00',8.51),('10318','2013-08-11','11:35:00',8.58),('10318','2013-08-11','11:40:00',8.6),('10318','2013-08-11','11:45:00',8.64),('10318','2013-08-11','11:50:00',8.67),('10318','2013-08-11','11:55:00',8.67),('10318','2013-08-11','12:00:00',8.7),('10318','2013-08-11','12:05:00',8.72),('10318','2013-08-11','12:10:00',8.73),('10318','2013-08-11','12:15:00',8.72),('10318','2013-08-11','12:20:00',8.77),('10318','2013-08-11','12:25:00',8.8),('10318','2013-08-11','12:30:00',8.78),('10318','2013-08-11','12:35:00',8.73),('10318','2013-08-11','12:40:00',8.53),('10318','2013-08-11','12:45:00',8.69),('10318','2013-08-11','12:50:00',8.73),('10318','2013-08-11','12:55:00',8.7),('10318','2013-08-11','13:00:00',8.67),('10318','2013-08-11','13:05:00',8.66),('10318','2013-08-11','13:10:00',8.64),('10318','2013-08-11','13:15:00',8.69),('10318','2013-08-11','13:20:00',8.65),('10318','2013-08-11','13:25:00',8.63),('10318','2013-08-11','13:30:00',8.54),('10318','2013-08-11','13:35:00',8.55),('10318','2013-08-11','13:40:00',8.51),('10318','2013-08-11','13:45:00',8.48),('10318','2013-08-11','13:50:00',8.46),('10318','2013-08-11','13:55:00',8.37),('10318','2013-08-11','14:00:00',8.35),('10318','2013-08-11','14:05:00',8.24),('10318','2013-08-11','14:10:00',8.11),('10318','2013-08-11','14:15:00',8.1),('10318','2013-08-11','14:20:00',8.08),('10318','2013-08-11','14:25:00',7.67),('10318','2013-08-11','14:30:00',7.88),('10318','2013-08-11','14:35:00',7.77),('10318','2013-08-11','14:40:00',7.66),('10318','2013-08-11','14:45:00',7.58),('10318','2013-08-11','14:50:00',7.5),('10318','2013-08-11','14:55:00',7.49),('10318','2013-08-11','15:00:00',7.42),('10318','2013-08-11','15:05:00',7.27),('10318','2013-08-11','15:10:00',7.15),('10318','2013-08-11','15:15:00',6.95),('10318','2013-08-11','15:20:00',5.11),('10318','2013-08-11','15:25:00',6.9),('10318','2013-08-11','15:30:00',6.84),('10318','2013-08-11','15:35:00',6.6),('10318','2013-08-11','15:40:00',6.57),('10318','2013-08-11','15:45:00',6.52),('10318','2013-08-11','15:50:00',6.39),('10318','2013-08-11','15:55:00',6.25),('10318','2013-08-11','16:00:00',6.11),('10318','2013-08-11','16:05:00',5.97),('10318','2013-08-11','16:10:00',5.62),('10318','2013-08-11','16:15:00',5.66),('10318','2013-08-11','16:20:00',5.49),('10318','2013-08-11','16:25:00',5.33),('10318','2013-08-11','16:30:00',5.16),('10318','2013-08-11','16:35:00',5.04),('10318','2013-08-11','16:40:00',4.89),('10318','2013-08-11','16:45:00',4.74),('10318','2013-08-11','16:50:00',4.57),('10318','2013-08-11','16:55:00',4.4),('10318','2013-08-11','17:00:00',4.24),('10318','2013-08-11','17:05:00',4.07),('10318','2013-08-11','17:10:00',3.9),('10318','2013-08-11','17:15:00',3.73),('10318','2013-08-11','17:20:00',3.55),('10318','2013-08-11','17:25:00',3.37),('10318','2013-08-11','17:30:00',3.2),('10318','2013-08-11','17:35:00',3.03),('10318','2013-08-11','17:40:00',2.86),('10318','2013-08-11','17:45:00',2.7),('10318','2013-08-11','17:50:00',2.53),('10318','2013-08-11','17:55:00',2.32),('10318','2013-08-11','18:00:00',2.2),('10318','2013-08-11','18:05:00',2.05),('10318','2013-08-11','18:10:00',1.9),('10318','2013-08-11','18:15:00',1.76),('10318','2013-08-11','18:20:00',1.61),('10318','2013-08-11','18:25:00',1.48),('10318','2013-08-11','18:30:00',1.34),('10318','2013-08-11','18:35:00',1.24),('10318','2013-08-11','18:40:00',1.1),('10318','2013-08-10','07:25:00',1.2),('10318','2013-08-10','07:30:00',1.6),('10318','2013-08-10','07:35:00',2),('10318','2013-08-10','07:40:00',2.23),('10318','2013-08-10','07:45:00',2.5),('10318','2013-08-10','07:50:00',2.78),('10318','2013-08-10','07:55:00',2.98),('10318','2013-08-10','08:00:00',3.18),('10318','2013-08-10','08:05:00',3.38),('10318','2013-08-10','08:10:00',3.52),('10318','2013-08-10','08:15:00',3.81),('10318','2013-08-10','08:20:00',4.02),('10318','2013-08-10','08:25:00',4.19),('10318','2013-08-10','08:30:00',4.38),('10318','2013-08-10','08:35:00',4.56),('10318','2013-08-10','08:40:00',4.73),('10318','2013-08-10','08:45:00',4.89),('10318','2013-08-10','08:50:00',5.08),('10318','2013-08-10','08:55:00',5.28),('10318','2013-08-10','09:00:00',5.42),('10318','2013-08-10','09:05:00',5.59),('10318','2013-08-10','09:10:00',5.74),('10318','2013-08-10','09:15:00',5.89),('10318','2013-08-10','09:20:00',6.08),('10318','2013-08-10','09:25:00',6.27),('10318','2013-08-10','09:30:00',6.41),('10318','2013-08-10','09:35:00',6.55),('10318','2013-08-10','09:40:00',6.65),('10318','2013-08-10','09:45:00',6.79),('10318','2013-08-10','09:50:00',6.92),('10318','2013-08-10','09:55:00',6.92),('10318','2013-08-10','10:00:00',7.14),('10318','2013-08-10','10:05:00',7.26),('10318','2013-08-10','10:10:00',7.4),('10318','2013-08-10','10:15:00',7.48),('10318','2013-08-10','10:20:00',7.55),('10318','2013-08-10','10:25:00',7.67),('10318','2013-08-10','10:30:00',7.75),('10318','2013-08-10','10:35:00',7.83),('10318','2013-08-10','10:40:00',7.94),('10318','2013-08-10','10:45:00',7.97),('10318','2013-08-10','10:50:00',8.08),('10318','2013-08-10','10:55:00',8.19),('10318','2013-08-10','11:00:00',8.38),('10318','2013-08-10','11:05:00',8.51),('10318','2013-08-10','11:10:00',8.38),('10318','2013-08-10','11:15:00',8.35),('10318','2013-08-10','11:20:00',8.85),('10318','2013-08-10','11:25:00',8.94),('10318','2013-08-10','11:30:00',8.8),('10318','2013-08-10','11:35:00',8.7),('10318','2013-08-10','11:40:00',8.49),('10318','2013-08-10','11:45:00',8.65),('10318','2013-08-10','11:50:00',8.82),('10318','2013-08-10','11:55:00',8.93),('10318','2013-08-10','12:00:00',8.98),('10318','2013-08-10','12:05:00',8.92),('10318','2013-08-10','12:10:00',8.93),('10318','2013-08-10','12:15:00',8.88),('10318','2013-08-10','12:20:00',8.88),('10318','2013-08-10','12:25:00',8.95),('10318','2013-08-10','12:30:00',9.03),('10318','2013-08-10','12:35:00',9.05),('10318','2013-08-10','12:40:00',9.11),('10318','2013-08-10','12:45:00',9.32),('10318','2013-08-10','12:50:00',9.62),('10318','2013-08-10','12:55:00',9.32),('10318','2013-08-10','13:00:00',9.02),('10318','2013-08-10','13:05:00',8.89),('10318','2013-08-10','13:10:00',9.23),('10318','2013-08-10','13:15:00',9.57),('10318','2013-08-10','13:20:00',3.65),('10318','2013-08-10','13:25:00',8.99),('10318','2013-08-10','13:30:00',2.39),('10318','2013-08-10','13:35:00',2.26),('10318','2013-08-10','13:40:00',2.32),('10318','2013-08-10','13:45:00',1.73),('10318','2013-08-10','13:50:00',2.88),('10318','2013-08-10','13:55:00',9.64),('10318','2013-08-10','14:00:00',9.4),('10318','2013-08-10','14:05:00',8.74),('10318','2013-08-10','14:10:00',9.23),('10318','2013-08-10','14:15:00',8.27),('10318','2013-08-10','14:20:00',2.87),('10318','2013-08-10','14:25:00',2.64),('10318','2013-08-10','14:30:00',2.42),('10318','2013-08-10','14:35:00',2.13),('10318','2013-08-10','14:40:00',1.96),('10318','2013-08-10','14:45:00',1.91),('10318','2013-08-10','14:50:00',1.82),('10318','2013-08-10','14:55:00',1.98),('10318','2013-08-10','15:00:00',2.23),('10318','2013-08-10','15:05:00',2.12),('10318','2013-08-10','15:10:00',2.21),('10318','2013-08-10','15:15:00',2.33),('10318','2013-08-10','15:20:00',2.39),('10318','2013-08-10','15:25:00',2.19),('10318','2013-08-10','15:30:00',2.32),('10318','2013-08-10','15:35:00',2.57),('10318','2013-08-10','15:40:00',2.55),('10318','2013-08-10','15:45:00',3.28),('10318','2013-08-10','15:50:00',3.72),('10318','2013-08-10','15:55:00',3.77),('10318','2013-08-10','16:00:00',5.18),('10318','2013-08-10','16:05:00',5.58),('10318','2013-08-10','16:10:00',3.8),('10318','2013-08-10','16:15:00',3.4),('10318','2013-08-10','16:20:00',3.03),('10318','2013-08-10','16:25:00',4.61),('10318','2013-08-10','16:30:00',4.24),('10318','2013-08-10','16:35:00',4.51),('10318','2013-08-10','16:40:00',3.72),('10318','2013-08-10','16:45:00',4),('10318','2013-08-10','16:50:00',5.09),('10318','2013-08-10','16:55:00',3.65),('10318','2013-08-10','17:00:00',1.51),('10318','2013-08-10','17:05:00',2.34),('10318','2013-08-10','17:10:00',3.55),('10318','2013-08-10','17:15:00',2.62),('10318','2013-08-10','17:20:00',2.48),('10318','2013-08-10','17:25:00',2.59),('10318','2013-08-10','17:30:00',2.05),('10318','2013-08-10','17:35:00',1.1),('10318','2013-08-10','18:20:00',1.06),('10318','2013-08-10','18:25:00',1.03),('10318','2014-04-09','07:35:00',1.08),('10318','2014-04-09','07:40:00',1.2),('10318','2014-04-09','07:45:00',1.29),('10318','2014-04-09','07:50:00',1.42),('10318','2014-04-09','07:55:00',1.99),('10318','2014-04-09','08:00:00',2.32),('10318','2014-04-09','08:05:00',2.79),('10318','2014-04-09','08:10:00',2.01),('10318','2014-04-09','08:15:00',3.12),('10318','2014-04-09','08:20:00',2.96),('10318','2014-04-09','08:25:00',2.04),('10318','2014-04-09','08:30:00',1.67),('10318','2014-04-09','08:50:00',1.71),('10318','2014-04-09','08:55:00',2.81),('10318','2014-04-09','09:00:00',2.19),('10318','2014-04-09','09:05:00',2.11),('10318','2014-04-09','09:10:00',1.96),('10318','2014-04-09','09:15:00',1.9),('10318','2014-04-09','09:20:00',2),('10318','2014-04-09','09:25:00',2.24),('10318','2014-04-09','09:30:00',2.08),('10318','2014-04-09','09:35:00',1.7),('10318','2014-04-09','09:40:00',1.76),('10318','2014-04-09','09:45:00',3.04),('10318','2014-04-09','09:50:00',7.6),('10318','2014-04-09','09:55:00',7.35),('10318','2014-04-09','10:00:00',7.29),('10318','2014-04-09','10:05:00',7.39),('10318','2014-04-09','10:10:00',6.43),('10318','2014-04-09','10:15:00',6.52),('10318','2014-04-09','10:20:00',8.76),('10318','2014-04-09','10:25:00',6.06),('10318','2014-04-09','10:30:00',5.02),('10318','2014-04-09','10:35:00',6.64),('10318','2014-04-09','10:40:00',9.69),('10318','2014-04-09','10:45:00',9.07),('10318','2014-04-09','10:50:00',9.42),('10318','2014-04-09','10:55:00',8.53),('10318','2014-04-09','11:00:00',10.13),('10318','2014-04-09','11:05:00',9.36),('10318','2014-04-09','11:10:00',3.44),('10318','2014-04-09','11:15:00',2.18),('10318','2014-04-09','11:20:00',1.95),('10318','2014-04-09','11:25:00',5.46),('10318','2014-04-09','11:30:00',9.99),('10318','2014-04-09','11:35:00',8.66),('10318','2014-04-09','11:40:00',8.56),('10318','2014-04-09','11:45:00',8.03),('10318','2014-04-09','11:50:00',3.54),('10318','2014-04-09','11:55:00',6.46),('10318','2014-04-09','12:00:00',6.39),('10318','2014-04-09','12:05:00',5),('10318','2014-04-09','12:10:00',4.28),('10318','2014-04-09','12:15:00',3.54),('10318','2014-04-09','12:20:00',2.45),('10318','2014-04-09','12:25:00',2.15),('10318','2014-04-09','12:30:00',2.14),('10318','2014-04-09','12:35:00',1.62),('10318','2014-04-09','12:40:00',1.35),('10318','2014-04-09','12:45:00',1.26),('10318','2014-04-09','12:50:00',1.25),('10318','2014-04-09','12:55:00',1.36),('10318','2014-04-09','13:00:00',1.76),('10318','2014-04-09','13:05:00',2.06),('10318','2014-04-09','13:10:00',2.49),('10318','2014-04-09','13:15:00',2.72),('10318','2014-04-09','13:20:00',2.81),('10318','2014-04-09','13:25:00',2.8),('10318','2014-04-09','13:30:00',2.72),('10318','2014-04-09','13:35:00',3.17),('10318','2014-04-09','13:40:00',3.21),('10318','2014-04-09','13:45:00',2.37),('10318','2014-04-09','13:50:00',2.37),('10318','2014-04-09','13:55:00',2.32),('10318','2014-04-09','14:00:00',2.43),('10318','2014-04-09','14:05:00',2.45),('10318','2014-04-09','14:10:00',3.63),('10318','2014-04-09','14:15:00',3.85),('10318','2014-04-09','14:20:00',4.35),('10318','2014-04-09','14:25:00',6.69),('10318','2014-04-09','14:30:00',3.41),('10318','2014-04-09','14:35:00',3.02),('10318','2014-04-09','14:40:00',3.58),('10318','2014-04-09','14:45:00',4.97),('10318','2014-04-09','14:50:00',6.74),('10318','2014-04-09','14:55:00',9.04),('10318','2014-04-09','15:00:00',4.22),('10318','2014-04-09','15:05:00',6.21),('10318','2014-04-09','15:10:00',5.45),('10318','2014-04-09','15:15:00',3.96),('10318','2014-04-09','15:20:00',4.45),('10318','2014-04-09','15:25:00',4.3),('10318','2014-04-09','15:30:00',3.61),('10318','2014-04-09','15:35:00',2.87),('10318','2014-04-09','15:40:00',2.67),('10318','2014-04-09','15:45:00',2.23),('10318','2014-04-09','15:50:00',1.99),('10318','2014-04-09','15:55:00',2.49),('10318','2014-04-09','16:00:00',5.15),('10318','2014-04-09','16:05:00',6.51),('10318','2014-04-09','16:10:00',6.2),('10318','2014-04-09','16:15:00',5.9),('10318','2014-04-09','16:20:00',6.12),('10318','2014-04-09','16:25:00',6.03),('10318','2014-04-09','16:30:00',5.93),('10318','2014-04-09','16:35:00',5.93),('10318','2014-04-09','16:40:00',5.74),('10318','2014-04-09','16:45:00',4.79),('10318','2014-04-09','16:50:00',3.04),('10318','2014-04-09','16:55:00',4.94),('10318','2014-04-09','17:00:00',4.65),('10318','2014-04-09','17:05:00',4.39),('10318','2014-04-09','17:10:00',3.78),('10318','2014-04-09','17:15:00',3.48),('10318','2014-04-09','17:20:00',3.24),('10318','2014-04-09','17:25:00',3.17),('10318','2014-04-09','17:30:00',2.62),('10318','2014-04-09','17:35:00',1.66),('10318','2014-04-09','17:40:00',1.87),('10318','2014-04-09','17:45:00',2.65),('10318','2014-04-09','17:50:00',2.16),('10318','2014-04-09','17:55:00',2.49),('10318','2014-04-09','18:00:00',2),('10318','2014-04-09','18:05:00',1.42),('10318','2014-04-09','18:10:00',1.48),('10318','2014-04-09','18:15:00',1.61),('10318','2014-04-09','18:20:00',1.35),('10318','2014-04-09','18:25:00',1.1),('10318','2013-08-09','07:20:00',1.2),('10318','2013-08-09','07:25:00',1.4),('10318','2013-08-09','07:30:00',1.18),('10318','2013-08-09','07:35:00',1.33),('10318','2013-08-09','07:40:00',1.13),('10318','2013-08-09','07:50:00',1.03),('10318','2013-08-09','07:55:00',1.44),('10318','2013-08-09','08:00:00',2.35),('10318','2013-08-09','08:05:00',2.61),('10318','2013-08-09','08:10:00',2.08),('10318','2013-08-09','08:15:00',1.76),('10318','2013-08-09','08:20:00',1.96),('10318','2013-08-09','08:25:00',1.88),('10318','2013-08-09','08:30:00',1.91),('10318','2013-08-09','08:35:00',3.26),('10318','2013-08-09','08:40:00',4.22),('10318','2013-08-09','08:45:00',4.22),('10318','2013-08-09','08:50:00',4.26),('10318','2013-08-09','08:55:00',4.83),('10318','2013-08-09','09:00:00',4.64),('10318','2013-08-09','09:05:00',5.1),('10318','2013-08-09','09:10:00',5.3),('10318','2013-08-09','09:15:00',3.97),('10318','2013-08-09','09:20:00',2.81),('10318','2013-08-09','09:25:00',4.19),('10318','2013-08-09','09:30:00',5.81),('10318','2013-08-09','09:35:00',5.87),('10318','2013-08-09','09:40:00',4.88),('10318','2013-08-09','09:45:00',4.61),('10318','2013-08-09','09:50:00',5.74),('10318','2013-08-09','09:55:00',2.7),('10318','2013-08-09','10:00:00',4.29),('10318','2013-08-09','10:05:00',5.42),('10318','2013-08-09','10:10:00',6.35),('10318','2013-08-09','10:15:00',6.73),('10318','2013-08-09','10:20:00',6.78),('10318','2013-08-09','10:25:00',6.93),('10318','2013-08-09','10:30:00',7),('10318','2013-08-09','10:35:00',6.96),('10318','2013-08-09','10:40:00',7.11),('10318','2013-08-09','10:45:00',7.05),('10318','2013-08-09','10:50:00',7.24),('10318','2013-08-09','10:55:00',7.54),('10318','2013-08-09','11:00:00',7.43),('10318','2013-08-09','11:05:00',7.52),('10318','2013-08-09','11:10:00',7.67),('10318','2013-08-09','11:15:00',7.64),('10318','2013-08-09','11:20:00',7.77),('10318','2013-08-09','11:25:00',7.84),('10318','2013-08-09','11:30:00',7.86),('10318','2013-08-09','11:35:00',7.79),('10318','2013-08-09','11:40:00',7.88),('10318','2013-08-09','11:45:00',7.99),('10318','2013-08-09','11:50:00',8.04),('10318','2013-08-09','11:55:00',8.03),('10318','2013-08-09','12:00:00',8.07),('10318','2013-08-09','12:05:00',8.2),('10318','2013-08-09','12:10:00',8.25),('10318','2013-08-09','12:15:00',8.32),('10318','2013-08-09','12:20:00',7.74),('10318','2013-08-09','12:25:00',8.5),('10318','2013-08-09','12:30:00',8.47),('10318','2013-08-09','12:35:00',5.03),('10318','2013-08-09','12:40:00',6.85),('10318','2013-08-09','12:45:00',9.39),('10318','2013-08-09','12:50:00',7.8),('10318','2013-08-09','12:55:00',5.95),('10318','2013-08-09','13:00:00',2.74),('10318','2013-08-09','13:05:00',1.82),('10318','2013-08-09','13:10:00',1.79),('10318','2013-08-09','13:15:00',2.4),('10318','2013-08-09','13:20:00',4.13),('10318','2013-08-09','13:25:00',4.34),('10318','2013-08-09','13:30:00',3.56),('10318','2013-08-09','13:35:00',3.18),('10318','2013-08-09','13:40:00',2.93),('10318','2013-08-09','13:45:00',2.79),('10318','2013-08-09','13:50:00',2.92),('10318','2013-08-09','13:55:00',2.9),('10318','2013-08-09','14:00:00',2.94),('10318','2013-08-09','14:05:00',2.56),('10318','2013-08-09','14:10:00',2.69),('10318','2013-08-09','14:15:00',2.09),('10318','2013-08-09','14:20:00',1.82),('10318','2013-08-09','14:25:00',1.87),('10318','2013-08-09','14:30:00',1.96),('10318','2013-08-09','14:35:00',1.78),('10318','2013-08-09','14:40:00',1.38),('10318','2013-08-09','14:45:00',1.09),('10318','2013-08-09','15:05:00',2.12),('10318','2013-08-09','15:10:00',5.01),('10318','2013-08-09','15:15:00',6.71),('10318','2013-08-09','15:20:00',3.71),('10318','2013-08-09','15:25:00',2.65),('10318','2013-08-09','15:30:00',2.42),('10318','2013-08-09','15:35:00',3.85),('10318','2013-08-09','15:40:00',5.16),('10318','2013-08-09','15:45:00',4.62),('10318','2013-08-09','15:50:00',3.46),('10318','2013-08-09','15:55:00',2.78),('10318','2013-08-09','16:00:00',2.36),('10318','2013-08-09','16:05:00',1.6),('10318','2013-08-09','16:10:00',1.31),('10318','2013-08-09','16:15:00',1.37),('10318','2013-08-09','16:20:00',1.48),('10318','2013-08-09','16:25:00',1.66),('10318','2013-08-09','16:30:00',1.39),('10318','2013-08-09','16:35:00',1.47),('10318','2013-08-09','16:40:00',1.63),('10318','2013-08-09','16:45:00',2.03),('10318','2013-08-09','16:50:00',3.12),('10318','2013-08-09','16:55:00',3.85),('10318','2013-08-09','17:00:00',2.31),('10318','2013-08-09','17:05:00',2.24),('10318','2013-08-09','17:10:00',1.96),('10318','2013-08-09','17:15:00',1.55),('10318','2013-08-09','17:20:00',1.37),('10318','2013-08-09','17:25:00',1.37),('10318','2013-08-09','17:30:00',1.65),('10318','2013-08-09','17:35:00',1.71),('10318','2013-08-09','17:40:00',1.72),('10318','2013-08-09','17:45:00',1.57),('10318','2013-08-09','17:50:00',1.25),('10318','2013-08-09','18:15:00',1.08),('10318','2013-08-09','18:20:00',1.02),('10318','2013-08-09','18:55:00',1.04),('10318','2013-08-09','19:00:00',1.36),('10318','2013-08-09','19:05:00',1.59),('10318','2013-08-09','19:10:00',1.66),('10318','2013-08-09','19:15:00',1.69),('10318','2013-08-09','19:20:00',1.96),('10318','2013-08-09','19:25:00',2.13),('10318','2013-08-09','19:30:00',1.25),('10318','2013-08-08','07:20:00',1.03),('10318','2013-08-08','07:25:00',1.29),('10318','2013-08-08','07:30:00',1.47),('10318','2013-08-08','07:35:00',1.69),('10318','2013-08-08','07:40:00',1.97),('10318','2013-08-08','07:45:00',2.2),('10318','2013-08-08','07:50:00',2.4),('10318','2013-08-08','07:55:00',2.58),('10318','2013-08-08','08:00:00',2.78),('10318','2013-08-08','08:05:00',2.92),('10318','2013-08-08','08:10:00',3.16),('10318','2013-08-08','08:15:00',3.34),('10318','2013-08-08','08:20:00',3.54),('10318','2013-08-08','08:25:00',3.72),('10318','2013-08-08','08:30:00',3.89),('10318','2013-08-08','08:35:00',4.04),('10318','2013-08-08','08:40:00',4.2),('10318','2013-08-08','08:45:00',4.36),('10318','2013-08-08','08:50:00',4.48),('10318','2013-08-08','08:55:00',4.72),('10318','2013-08-08','09:00:00',4.88),('10318','2013-08-08','09:05:00',5.05),('10318','2013-08-08','09:10:00',5.22),('10318','2013-08-08','09:15:00',5.34),('10318','2013-08-08','09:20:00',5.48),('10318','2013-08-08','09:25:00',5.66),('10318','2013-08-08','09:30:00',5.79),('10318','2013-08-08','09:35:00',5.95),('10318','2013-08-08','09:40:00',6.08),('10318','2013-08-08','09:45:00',6.23),('10318','2013-08-08','09:50:00',6.34),('10318','2013-08-08','09:55:00',6.46),('10318','2013-08-08','10:00:00',6.57),('10318','2013-08-08','10:05:00',6.67),('10318','2013-08-08','10:10:00',6.78),('10318','2013-08-08','10:15:00',6.9),('10318','2013-08-08','10:20:00',6.99),('10318','2013-08-08','10:25:00',7.08),('10318','2013-08-08','10:30:00',7.15),('10318','2013-08-08','10:35:00',7.1),('10318','2013-08-08','10:40:00',7.28),('10318','2013-08-08','10:45:00',7.39),('10318','2013-08-08','10:50:00',7.41),('10318','2013-08-08','10:55:00',7.45),('10318','2013-08-08','11:00:00',7.5),('10318','2013-08-08','11:05:00',7.59),('10318','2013-08-08','11:10:00',7.64),('10318','2013-08-08','11:15:00',7.75),('10318','2013-08-08','11:20:00',7.77),('10318','2013-08-08','11:25:00',7.78),('10318','2013-08-08','11:30:00',7.85),('10318','2013-08-08','11:35:00',7.85),('10318','2013-08-08','11:40:00',7.87),('10318','2013-08-08','11:45:00',7.94),('10318','2013-08-08','11:50:00',8.09),('10318','2013-08-08','11:55:00',8.05),('10318','2013-08-08','12:00:00',8.07),('10318','2013-08-08','12:05:00',8.12),('10318','2013-08-08','12:10:00',8.13),('10318','2013-08-08','12:15:00',8.04),('10318','2013-08-08','12:20:00',7.86),('10318','2013-08-08','12:25:00',8.21),('10318','2013-08-08','12:30:00',8.2),('10318','2013-08-08','12:35:00',8.21),('10318','2013-08-08','12:40:00',8.34),('10318','2013-08-08','12:45:00',8.37),('10318','2013-08-08','12:50:00',8.37),('10318','2013-08-08','12:55:00',8.29),('10318','2013-08-08','13:00:00',8.3),('10318','2013-08-08','13:05:00',8.27),('10318','2013-08-08','13:10:00',8.3),('10318','2013-08-08','13:15:00',8.29),('10318','2013-08-08','13:20:00',8.26),('10318','2013-08-08','13:25:00',8.22),('10318','2013-08-08','13:30:00',8.22),('10318','2013-08-08','13:35:00',8.16),('10318','2013-08-08','13:40:00',8.13),('10318','2013-08-08','13:45:00',8.11),('10318','2013-08-08','13:50:00',8.03),('10318','2013-08-08','13:55:00',8),('10318','2013-08-08','14:00:00',7.97),('10318','2013-08-08','14:05:00',7.9),('10318','2013-08-08','14:10:00',7.78),('10318','2013-08-08','14:15:00',7.8),('10318','2013-08-08','14:20:00',7.7),('10318','2013-08-08','14:25:00',7.62),('10318','2013-08-08','14:30:00',7.57),('10318','2013-08-08','14:35:00',7.51),('10318','2013-08-08','14:40:00',7.41),('10318','2013-08-08','14:45:00',7.32),('10318','2013-08-08','14:50:00',7.23),('10318','2013-08-08','14:55:00',7.14),('10318','2013-08-08','15:00:00',7.04),('10318','2013-08-08','15:05:00',6.95),('10318','2013-08-08','15:10:00',6.89),('10318','2013-08-08','15:15:00',6.77),('10318','2013-08-08','15:20:00',6.64),('10318','2013-08-08','15:25:00',6.47),('10318','2013-08-08','15:30:00',6.39),('10318','2013-08-08','15:35:00',6.3),('10318','2013-08-08','15:40:00',6.2),('10318','2013-08-08','15:45:00',6.07),('10318','2013-08-08','15:50:00',5.89),('10318','2013-08-08','15:55:00',5.74),('10318','2013-08-08','16:00:00',5.7),('10318','2013-08-08','16:05:00',5.6),('10318','2013-08-08','16:10:00',5.52),('10318','2013-08-08','16:15:00',5.38),('10318','2013-08-08','16:20:00',5.23),('10318','2013-08-08','16:25:00',5.11),('10318','2013-08-08','16:30:00',4.97),('10318','2013-08-08','16:35:00',4.79),('10318','2013-08-08','16:40:00',4.64),('10318','2013-08-08','16:45:00',4.47),('10318','2013-08-08','16:50:00',4.31),('10318','2013-08-08','16:55:00',4.13),('10318','2013-08-08','17:00:00',4),('10318','2013-08-08','17:05:00',3.86),('10318','2013-08-08','17:10:00',3.65),('10318','2013-08-08','17:15:00',3.53),('10318','2013-08-08','17:20:00',3.35),('10318','2013-08-08','17:25:00',3.19),('10318','2013-08-08','17:30:00',3.04),('10318','2013-08-08','17:35:00',2.87),('10318','2013-08-08','17:40:00',2.71),('10318','2013-08-08','17:45:00',2.57),('10318','2013-08-08','17:50:00',2.42),('10318','2013-08-08','17:55:00',2.27),('10318','2013-08-08','18:00:00',2.12),('10318','2013-08-08','18:05:00',1.96),('10318','2013-08-08','18:10:00',1.82),('10318','2013-08-08','18:15:00',1.69),('10318','2013-08-08','18:20:00',1.55),('10318','2013-08-08','18:25:00',1.43),('10318','2013-08-08','18:30:00',1.31),('10318','2013-08-08','18:35:00',1.2),('10318','2013-08-08','18:40:00',1.09),('10318','2013-08-07','07:20:00',1.16),('10318','2013-08-07','07:25:00',1.44),('10318','2013-08-07','07:30:00',1.67),('10318','2013-08-07','07:35:00',1.85),('10318','2013-08-07','07:40:00',2.08),('10318','2013-08-07','07:45:00',2.33),('10318','2013-08-07','07:50:00',2.56),('10318','2013-08-07','07:55:00',2.76),('10318','2013-08-07','08:00:00',2.91),('10318','2013-08-07','08:05:00',3.06),('10318','2013-08-07','08:10:00',3.27),('10318','2013-08-07','08:15:00',3.49),('10318','2013-08-07','08:20:00',3.67),('10318','2013-08-07','08:25:00',3.84),('10318','2013-08-07','08:30:00',3.99),('10318','2013-08-07','08:35:00',4.18),('10318','2013-08-07','08:40:00',4.38),('10318','2013-08-07','08:45:00',4.54),('10318','2013-08-07','08:50:00',4.71),('10318','2013-08-07','08:55:00',4.87),('10318','2013-08-07','09:00:00',5.05),('10318','2013-08-07','09:05:00',5.2),('10318','2013-08-07','09:10:00',5.32),('10318','2013-08-07','09:15:00',5.45),('10318','2013-08-07','09:20:00',5.52),('10318','2013-08-07','09:25:00',5.74),('10318','2013-08-07','09:30:00',5.91),('10318','2013-08-07','09:35:00',6.03),('10318','2013-08-07','09:40:00',6.12),('10318','2013-08-07','09:45:00',6.21),('10318','2013-08-07','09:50:00',6.27),('10318','2013-08-07','09:55:00',6.48),('10318','2013-08-07','10:00:00',6.64),('10318','2013-08-07','10:05:00',6.8),('10318','2013-08-07','10:10:00',6.91),('10318','2013-08-07','10:15:00',6.97),('10318','2013-08-07','10:20:00',7.05),('10318','2013-08-07','10:25:00',7.1),('10318','2013-08-07','10:30:00',7.17),('10318','2013-08-07','10:35:00',7.28),('10318','2013-08-07','10:40:00',7.33),('10318','2013-08-07','10:45:00',7.43),('10318','2013-08-07','10:50:00',7.48),('10318','2013-08-07','10:55:00',7.57),('10318','2013-08-07','11:00:00',7.62),('10318','2013-08-07','11:05:00',7.49),('10318','2013-08-07','11:10:00',7.75),('10318','2013-08-07','11:15:00',7.79),('10318','2013-08-07','11:20:00',7.82),('10318','2013-08-07','11:25:00',7.83),('10318','2013-08-07','11:30:00',7.9),('10318','2013-08-07','11:35:00',7.92),('10318','2013-08-07','11:40:00',7.92),('10318','2013-08-07','11:45:00',7.97),('10318','2013-08-07','11:50:00',8.03),('10318','2013-08-07','11:55:00',8.08),('10318','2013-08-07','12:00:00',8.1),('10318','2013-08-07','12:05:00',8.15),('10318','2013-08-07','12:10:00',8.12),('10318','2013-08-07','12:15:00',8.07),('10318','2013-08-07','12:20:00',7.97),('10318','2013-08-07','12:25:00',8.01),('10318','2013-08-07','12:30:00',8.04),('10318','2013-08-07','12:35:00',8.11),('10318','2013-08-07','12:40:00',8.27),('10318','2013-08-07','12:45:00',8.44),('10318','2013-08-07','12:50:00',7.98),('10318','2013-08-07','12:55:00',8.19),('10318','2013-08-07','13:00:00',8.2),('10318','2013-08-07','13:05:00',8.22),('10318','2013-08-07','13:10:00',8.19),('10318','2013-08-07','13:15:00',8.28),('10318','2013-08-07','13:20:00',8.21),('10318','2013-08-07','13:25:00',8.24),('10318','2013-08-07','13:30:00',8.21),('10318','2013-08-07','13:35:00',8.11),('10318','2013-08-07','13:40:00',8.21),('10318','2013-08-07','13:45:00',8.13),('10318','2013-08-07','13:50:00',8.16),('10318','2013-08-07','13:55:00',8.05),('10318','2013-08-07','14:00:00',8.03),('10318','2013-08-07','14:05:00',7.95),('10318','2013-08-07','14:10:00',7.83),('10318','2013-08-07','14:15:00',7.67),('10318','2013-08-07','14:20:00',7.64),('10318','2013-08-07','14:25:00',7.7),('10318','2013-08-07','14:30:00',7.65),('10318','2013-08-07','14:35:00',7.55),('10318','2013-08-07','14:40:00',7.59),('10318','2013-08-07','14:45:00',7.49),('10318','2013-08-07','14:50:00',7.35),('10318','2013-08-07','14:55:00',7.14),('10318','2013-08-07','15:00:00',7.08),('10318','2013-08-07','15:05:00',6.96),('10318','2013-08-07','15:10:00',6.97),('10318','2013-08-07','15:15:00',6.89),('10318','2013-08-07','15:20:00',6.73),('10318','2013-08-07','15:25:00',6.61),('10318','2013-08-07','15:30:00',6.55),('10318','2013-08-07','15:35:00',6.45),('10318','2013-08-07','15:40:00',6.35),('10318','2013-08-07','15:45:00',6.24),('10318','2013-08-07','15:50:00',6.08),('10318','2013-08-07','15:55:00',5.95),('10318','2013-08-07','16:00:00',5.84),('10318','2013-08-07','16:05:00',5.73),('10318','2013-08-07','16:10:00',5.57),('10318','2013-08-07','16:15:00',5.44),('10318','2013-08-07','16:20:00',5.26),('10318','2013-08-07','16:25:00',5.13),('10318','2013-08-07','16:30:00',4.99),('10318','2013-08-07','16:35:00',4.83),('10318','2013-08-07','16:40:00',4.68),('10318','2013-08-07','16:45:00',4.54),('10318','2013-08-07','16:50:00',4.35),('10318','2013-08-07','16:55:00',4.11),('10318','2013-08-07','17:00:00',3.94),('10318','2013-08-07','17:05:00',3.85),('10318','2013-08-07','17:10:00',3.75),('10318','2013-08-07','17:15:00',3.6),('10318','2013-08-07','17:20:00',3.44),('10318','2013-08-07','17:25:00',3.23),('10318','2013-08-07','17:30:00',3.09),('10318','2013-08-07','17:35:00',2.96),('10318','2013-08-07','17:40:00',2.82),('10318','2013-08-07','17:45:00',2.66),('10318','2013-08-07','17:50:00',2.49),('10318','2013-08-07','17:55:00',2.33),('10318','2013-08-07','18:00:00',2.12),('10318','2013-08-07','18:05:00',1.92),('10318','2013-08-07','18:10:00',1.86),('10318','2013-08-07','18:15:00',1.71),('10318','2013-08-07','18:20:00',1.6),('10318','2013-08-07','18:25:00',1.47),('10318','2013-08-07','18:30:00',1.36),('10318','2013-08-07','18:35:00',1.26),('10318','2013-08-07','18:40:00',1.13),('10318','2013-08-07','18:45:00',1.04),('10318','2013-08-06','07:20:00',1.09),('10318','2013-08-06','07:25:00',1.33),('10318','2013-08-06','07:30:00',1.59),('10318','2013-08-06','07:35:00',1.75),('10318','2013-08-06','07:40:00',1.99),('10318','2013-08-06','07:45:00',2.24),('10318','2013-08-06','07:50:00',2.43),('10318','2013-08-06','07:55:00',2.61),('10318','2013-08-06','08:00:00',2.79),('10318','2013-08-06','08:05:00',2.97),('10318','2013-08-06','08:10:00',3.17),('10318','2013-08-06','08:15:00',3.35),('10318','2013-08-06','08:20:00',3.53),('10318','2013-08-06','08:25:00',3.72),('10318','2013-08-06','08:30:00',3.91),('10318','2013-08-06','08:35:00',4.09),('10318','2013-08-06','08:40:00',4.27),('10318','2013-08-06','08:45:00',4.46),('10318','2013-08-06','08:50:00',4.54),('10318','2013-08-06','08:55:00',4.81),('10318','2013-08-06','09:00:00',4.96),('10318','2013-08-06','09:05:00',5.13),('10318','2013-08-06','09:10:00',5.28),('10318','2013-08-06','09:15:00',5.4),('10318','2013-08-06','09:20:00',5.53),('10318','2013-08-06','09:25:00',5.7),('10318','2013-08-06','09:30:00',5.81),('10318','2013-08-06','09:35:00',5.96),('10318','2013-08-06','09:40:00',6.07),('10318','2013-08-06','09:45:00',6.2),('10318','2013-08-06','09:50:00',6.32),('10318','2013-08-06','09:55:00',6.45),('10318','2013-08-06','10:00:00',6.53),('10318','2013-08-06','10:05:00',6.61),('10318','2013-08-06','10:10:00',6.74),('10318','2013-08-06','10:15:00',6.84),('10318','2013-08-06','10:20:00',6.91),('10318','2013-08-06','10:25:00',7.01),('10318','2013-08-06','10:30:00',7.08),('10318','2013-08-06','10:35:00',7.07),('10318','2013-08-06','10:40:00',7.29),('10318','2013-08-06','10:45:00',7.35),('10318','2013-08-06','10:50:00',7.39),('10318','2013-08-06','10:55:00',7.45),('10318','2013-08-06','11:00:00',7.56),('10318','2013-08-06','11:05:00',7.6),('10318','2013-08-06','11:10:00',7.67),('10318','2013-08-06','11:15:00',7.75),('10318','2013-08-06','11:20:00',7.82),('10318','2013-08-06','11:25:00',7.86),('10318','2013-08-06','11:30:00',7.93),('10318','2013-08-06','11:35:00',7.95),('10318','2013-08-06','11:40:00',8),('10318','2013-08-06','11:45:00',7.99),('10318','2013-08-06','11:50:00',8.01),('10318','2013-08-06','11:55:00',8.04),('10318','2013-08-06','12:00:00',8.04),('10318','2013-08-06','12:05:00',8.1),('10318','2013-08-06','12:10:00',8.12),('10318','2013-08-06','12:15:00',8.09),('10318','2013-08-06','12:20:00',7.85),('10318','2013-08-06','12:25:00',8.02),('10318','2013-08-06','12:30:00',8.1),('10318','2013-08-06','12:35:00',8.19),('10318','2013-08-06','12:40:00',8.21),('10318','2013-08-06','12:45:00',8.26),('10318','2013-08-06','12:50:00',8.38),('10318','2013-08-06','12:55:00',8.36),('10318','2013-08-06','13:00:00',8.39),('10318','2013-08-06','13:05:00',8.32),('10318','2013-08-06','13:10:00',8.38),('10318','2013-08-06','13:15:00',8.29),('10318','2013-08-06','13:20:00',8.26),('10318','2013-08-06','13:25:00',8.29),('10318','2013-08-06','13:30:00',8.27),('10318','2013-08-06','13:35:00',8.28),('10318','2013-08-06','13:40:00',8.3),('10318','2013-08-06','13:45:00',8.28),('10318','2013-08-06','13:50:00',8.23),('10318','2013-08-06','13:55:00',8.18),('10318','2013-08-06','14:00:00',8.16),('10318','2013-08-06','14:05:00',7.95),('10318','2013-08-06','14:10:00',8.08),('10318','2013-08-06','14:15:00',8.05),('10318','2013-08-06','14:20:00',8),('10318','2013-08-06','14:25:00',7.94),('10318','2013-08-06','14:30:00',7.85),('10318','2013-08-06','14:35:00',7.76),('10318','2013-08-06','14:40:00',7.7),('10318','2013-08-06','14:45:00',7.58),('10318','2013-08-06','14:50:00',7.56),('10318','2013-08-06','14:55:00',7.46),('10318','2013-08-06','15:00:00',7.35),('10318','2013-08-06','15:05:00',7.25),('10318','2013-08-06','15:10:00',7.18),('10318','2013-08-06','15:15:00',7.07),('10318','2013-08-06','15:20:00',6.98),('10318','2013-08-06','15:25:00',6.9),('10318','2013-08-06','15:30:00',6.8),('10318','2013-08-06','15:35:00',6.66),('10318','2013-08-06','15:40:00',6.51),('10318','2013-08-06','15:45:00',6.37),('10318','2013-08-06','15:50:00',6.24),('10318','2013-08-06','15:55:00',6.03),('10318','2013-08-06','16:00:00',5.98),('10318','2013-08-06','16:05:00',5.87),('10318','2013-08-06','16:10:00',5.73),('10318','2013-08-06','16:15:00',5.58),('10318','2013-08-06','16:20:00',5.43),('10318','2013-08-06','16:25:00',5.27),('10318','2013-08-06','16:30:00',5.14),('10318','2013-08-06','16:35:00',4.98),('10318','2013-08-06','16:40:00',4.84),('10318','2013-08-06','16:45:00',4.69),('10318','2013-08-06','16:50:00',4.52),('10318','2013-08-06','16:55:00',4.36),('10318','2013-08-06','17:00:00',4.21),('10318','2013-08-06','17:05:00',4.04),('10318','2013-08-06','17:10:00',3.8),('10318','2013-08-06','17:15:00',3.7),('10318','2013-08-06','17:20:00',3.55),('10318','2013-08-06','17:25:00',3.37),('10318','2013-08-06','17:30:00',3.19),('10318','2013-08-06','17:35:00',3.01),('10318','2013-08-06','17:40:00',2.84),('10318','2013-08-06','17:45:00',2.68),('10318','2013-08-06','17:50:00',2.53),('10318','2013-08-06','17:55:00',2.37),('10318','2013-08-06','18:00:00',2.23),('10318','2013-08-06','18:05:00',2.08),('10318','2013-08-06','18:10:00',1.93),('10318','2013-08-06','18:15:00',1.78),('10318','2013-08-06','18:20:00',1.64),('10318','2013-08-06','18:25:00',1.52),('10318','2013-08-06','18:30:00',1.38),('10318','2013-08-06','18:35:00',1.26),('10318','2013-08-06','18:40:00',1.12),('10318','2013-08-06','18:45:00',1),('10318','2013-08-05','07:20:00',1.18),('10318','2013-08-05','07:25:00',1.41),('10318','2013-08-05','07:30:00',1.67),('10318','2013-08-05','07:35:00',1.86),('10318','2013-08-05','07:40:00',2.11),('10318','2013-08-05','07:45:00',2.39),('10318','2013-08-05','07:50:00',2.59),('10318','2013-08-05','07:55:00',2.76),('10318','2013-08-05','08:00:00',2.93),('10318','2013-08-05','08:05:00',3.13),('10318','2013-08-05','08:10:00',3.33),('10318','2013-08-05','08:15:00',3.51),('10318','2013-08-05','08:20:00',3.69),('10318','2013-08-05','08:25:00',3.86),('10318','2013-08-05','08:30:00',4.02),('10318','2013-08-05','08:35:00',4.18),('10318','2013-08-05','08:40:00',4.31),('10318','2013-08-05','08:45:00',4.48),('10318','2013-08-05','08:50:00',4.68),('10318','2013-08-05','08:55:00',4.86),('10318','2013-08-05','09:00:00',5.02),('10318','2013-08-05','09:05:00',5.17),('10318','2013-08-05','09:10:00',5.35),('10318','2013-08-05','09:15:00',5.47),('10318','2013-08-05','09:20:00',5.58),('10318','2013-08-05','09:25:00',5.73),('10318','2013-08-05','09:30:00',5.87),('10318','2013-08-05','09:35:00',5.99),('10318','2013-08-05','09:40:00',6.14),('10318','2013-08-05','09:45:00',6.28),('10318','2013-08-05','09:50:00',6.28),('10318','2013-08-05','09:55:00',6.52),('10318','2013-08-05','10:00:00',6.64),('10318','2013-08-05','10:05:00',6.76),('10318','2013-08-05','10:10:00',6.88),('10318','2013-08-05','10:15:00',6.96),('10318','2013-08-05','10:20:00',7.08),('10318','2013-08-05','10:25:00',7.15),('10318','2013-08-05','10:30:00',7.3),('10318','2013-08-05','10:35:00',7.35),('10318','2013-08-05','10:40:00',7.44),('10318','2013-08-05','10:45:00',7.48),('10318','2013-08-05','10:50:00',7.59),('10318','2013-08-05','10:55:00',7.69),('10318','2013-08-05','11:00:00',7.79),('10318','2013-08-05','11:05:00',7.83),('10318','2013-08-05','11:10:00',7.91),('10318','2013-08-05','11:15:00',7.91),('10318','2013-08-05','11:20:00',7.94),('10318','2013-08-05','11:25:00',7.98),('10318','2013-08-05','11:30:00',8.05),('10318','2013-08-05','11:35:00',8.1),('10318','2013-08-05','11:40:00',8.17),('10318','2013-08-05','11:45:00',8.24),('10318','2013-08-05','11:50:00',8.27),('10318','2013-08-05','11:55:00',8.31),('10318','2013-08-05','12:00:00',8.3),('10318','2013-08-05','12:05:00',8.33),('10318','2013-08-05','12:10:00',8.36),('10318','2013-08-05','12:15:00',8.34),('10318','2013-08-05','12:20:00',8.4),('10318','2013-08-05','12:25:00',8.41),('10318','2013-08-05','12:30:00',8.34),('10318','2013-08-05','12:35:00',8.35),('10318','2013-08-05','12:40:00',8.46),('10318','2013-08-05','12:45:00',8.4),('10318','2013-08-05','12:50:00',8.34),('10318','2013-08-05','12:55:00',8.41),('10318','2013-08-05','13:00:00',8.3),('10318','2013-08-05','13:05:00',8.36),('10318','2013-08-05','13:10:00',8.24),('10318','2013-08-05','13:15:00',8.22),('10318','2013-08-05','13:20:00',7.98),('10318','2013-08-05','13:25:00',8.23),('10318','2013-08-05','13:30:00',8.29),('10318','2013-08-05','13:35:00',8.2),('10318','2013-08-05','13:40:00',8.16),('10318','2013-08-05','13:45:00',8.11),('10318','2013-08-05','13:50:00',8.07),('10318','2013-08-05','13:55:00',7.97),('10318','2013-08-05','14:00:00',8.01),('10318','2013-08-05','14:05:00',7.95),('10318','2013-08-05','14:10:00',7.91),('10318','2013-08-05','14:15:00',7.85),('10318','2013-08-05','14:20:00',7.8),('10318','2013-08-05','14:25:00',7.72),('10318','2013-08-05','14:30:00',7.61),('10318','2013-08-05','14:35:00',7.59),('10318','2013-08-05','14:40:00',7.53),('10318','2013-08-05','14:45:00',7.52),('10318','2013-08-05','14:50:00',7.41),('10318','2013-08-05','14:55:00',7.33),('10318','2013-08-05','15:00:00',7.2),('10318','2013-08-05','15:05:00',6.97),('10318','2013-08-05','15:10:00',7.03),('10318','2013-08-05','15:15:00',6.94),('10318','2013-08-05','15:20:00',6.85),('10318','2013-08-05','15:25:00',6.75),('10318','2013-08-05','15:30:00',6.73),('10318','2013-08-05','15:35:00',6.64),('10318','2013-08-05','15:40:00',6.47),('10318','2013-08-05','15:45:00',6.33),('10318','2013-08-05','15:50:00',6.18),('10318','2013-08-05','15:55:00',6.07),('10318','2013-08-05','16:00:00',5.96),('10318','2013-08-05','16:05:00',5.82),('10318','2013-08-05','16:10:00',5.71),('10318','2013-08-05','16:15:00',5.53),('10318','2013-08-05','16:20:00',5.32),('10318','2013-08-05','16:25:00',5.19),('10318','2013-08-05','16:30:00',5.06),('10318','2013-08-05','16:35:00',4.93),('10318','2013-08-05','16:40:00',4.78),('10318','2013-08-05','16:45:00',4.62),('10318','2013-08-05','16:50:00',4.4),('10318','2013-08-05','16:55:00',4.3),('10318','2013-08-05','17:00:00',4.12),('10318','2013-08-05','17:05:00',3.95),('10318','2013-08-05','17:10:00',3.8),('10318','2013-08-05','17:15:00',3.63),('10318','2013-08-05','17:20:00',3.48),('10318','2013-08-05','17:25:00',3.33),('10318','2013-08-05','17:30:00',3.17),('10318','2013-08-05','17:35:00',3.01),('10318','2013-08-05','17:40:00',2.83),('10318','2013-08-05','17:45:00',2.68),('10318','2013-08-05','17:50:00',2.5),('10318','2013-08-05','17:55:00',2.34),('10318','2013-08-05','18:00:00',2.19),('10318','2013-08-05','18:05:00',2.01),('10318','2013-08-05','18:10:00',1.9),('10318','2013-08-05','18:15:00',1.76),('10318','2013-08-05','18:20:00',1.63),('10318','2013-08-05','18:25:00',1.5),('10318','2013-08-05','18:30:00',1.38),('10318','2013-08-05','18:35:00',1.25),('10318','2013-08-05','18:40:00',1.15),('10318','2013-08-05','18:45:00',1.04),('10318','2013-08-04','07:20:00',1.27),('10318','2013-08-04','07:25:00',1.59),('10318','2013-08-04','07:30:00',1.91),('10318','2013-08-04','07:35:00',2.12),('10318','2013-08-04','07:40:00',2.39),('10318','2013-08-04','07:45:00',2.66),('10318','2013-08-04','07:50:00',2.87),('10318','2013-08-04','07:55:00',3.06),('10318','2013-08-04','08:00:00',3.26),('10318','2013-08-04','08:05:00',3.44),('10318','2013-08-04','08:10:00',3.63),('10318','2013-08-04','08:15:00',3.83),('10318','2013-08-04','08:20:00',4.02),('10318','2013-08-04','08:25:00',4.21),('10318','2013-08-04','08:30:00',4.35),('10318','2013-08-04','08:35:00',4.55),('10318','2013-08-04','08:40:00',4.72),('10318','2013-08-04','08:45:00',4.87),('10318','2013-08-04','08:50:00',5.02),('10318','2013-08-04','08:55:00',5.21),('10318','2013-08-04','09:00:00',5.37),('10318','2013-08-04','09:05:00',5.54),('10318','2013-08-04','09:10:00',5.68),('10318','2013-08-04','09:15:00',5.82),('10318','2013-08-04','09:20:00',5.96),('10318','2013-08-04','09:25:00',6.11),('10318','2013-08-04','09:30:00',6.24),('10318','2013-08-04','09:35:00',6.4),('10318','2013-08-04','09:40:00',6.51),('10318','2013-08-04','09:45:00',6.65),('10318','2013-08-04','09:50:00',6.74),('10318','2013-08-04','09:55:00',6.86),('10318','2013-08-04','10:00:00',6.96),('10318','2013-08-04','10:05:00',7.05),('10318','2013-08-04','10:10:00',7.16),('10318','2013-08-04','10:15:00',7.17),('10318','2013-08-04','10:20:00',7.36),('10318','2013-08-04','10:25:00',7.44),('10318','2013-08-04','10:30:00',7.48),('10318','2013-08-04','10:35:00',7.58),('10318','2013-08-04','10:40:00',7.64),('10318','2013-08-04','10:45:00',7.69),('10318','2013-08-04','10:50:00',7.78),('10318','2013-08-04','10:55:00',7.8),('10318','2013-08-04','11:00:00',7.88),('10318','2013-08-04','11:05:00',8),('10318','2013-08-04','11:10:00',8.14),('10318','2013-08-04','11:15:00',8.2),('10318','2013-08-04','11:20:00',8.22),('10318','2013-08-04','11:25:00',8.28),('10318','2013-08-04','11:30:00',8.37),('10318','2013-08-04','11:35:00',8.43),('10318','2013-08-04','11:40:00',8.48),('10318','2013-08-04','11:45:00',8.49),('10318','2013-08-04','11:50:00',8.53),('10318','2013-08-04','11:55:00',8.49),('10318','2013-08-04','12:00:00',8.55),('10318','2013-08-04','12:05:00',8.32),('10318','2013-08-04','12:10:00',8.53),('10318','2013-08-04','12:15:00',8.56),('10318','2013-08-04','12:20:00',8.53),('10318','2013-08-04','12:25:00',8.54),('10318','2013-08-04','12:30:00',8.58),('10318','2013-08-04','12:35:00',8.59),('10318','2013-08-04','12:40:00',8.62),('10318','2013-08-04','12:45:00',8.5),('10318','2013-08-04','12:50:00',8.51),('10318','2013-08-04','12:55:00',8.61),('10318','2013-08-04','13:00:00',8.62),('10318','2013-08-04','13:05:00',8.46),('10318','2013-08-04','13:10:00',8.51),('10318','2013-08-04','13:15:00',8.46),('10318','2013-08-04','13:20:00',8.49),('10318','2013-08-04','13:25:00',8.49),('10318','2013-08-04','13:30:00',8.47),('10318','2013-08-04','13:35:00',8.47),('10318','2013-08-04','13:40:00',8.45),('10318','2013-08-04','13:45:00',8.46),('10318','2013-08-04','13:50:00',8.2),('10318','2013-08-04','13:55:00',8.37),('10318','2013-08-04','14:00:00',8.3),('10318','2013-08-04','14:05:00',8.28),('10318','2013-08-04','14:10:00',8.23),('10318','2013-08-04','14:15:00',8.16),('10318','2013-08-04','14:20:00',8.14),('10318','2013-08-04','14:25:00',8.03),('10318','2013-08-04','14:30:00',7.98),('10318','2013-08-04','14:35:00',7.89),('10318','2013-08-04','14:40:00',7.82),('10318','2013-08-04','14:45:00',7.75),('10318','2013-08-04','14:50:00',7.62),('10318','2013-08-04','14:55:00',7.56),('10318','2013-08-04','15:00:00',7.5),('10318','2013-08-04','15:05:00',7.37),('10318','2013-08-04','15:10:00',7.26),('10318','2013-08-04','15:15:00',7.2),('10318','2013-08-04','15:20:00',7.08),('10318','2013-08-04','15:25:00',6.94),('10318','2013-08-04','15:30:00',6.84),('10318','2013-08-04','15:35:00',6.69),('10318','2013-08-04','15:40:00',6.61),('10318','2013-08-04','15:45:00',6.45),('10318','2013-08-04','15:50:00',6.09),('10318','2013-08-04','15:55:00',6.2),('10318','2013-08-04','16:00:00',6.23),('10318','2013-08-04','16:05:00',6.03),('10318','2013-08-04','16:10:00',5.88),('10318','2013-08-04','16:15:00',5.77),('10318','2013-08-04','16:20:00',5.62),('10318','2013-08-04','16:25:00',5.46),('10318','2013-08-04','16:30:00',5.28),('10318','2013-08-04','16:35:00',5.13),('10318','2013-08-04','16:40:00',4.98),('10318','2013-08-04','16:45:00',4.79),('10318','2013-08-04','16:50:00',4.61),('10318','2013-08-04','16:55:00',4.5),('10318','2013-08-04','17:00:00',4.31),('10318','2013-08-04','17:05:00',4.15),('10318','2013-08-04','17:10:00',3.96),('10318','2013-08-04','17:15:00',3.78),('10318','2013-08-04','17:20:00',3.57),('10318','2013-08-04','17:25:00',3.41),('10318','2013-08-04','17:30:00',3.24),('10318','2013-08-04','17:35:00',3.08),('10318','2013-08-04','17:40:00',2.91),('10318','2013-08-04','17:45:00',2.75),('10318','2013-08-04','17:50:00',2.56),('10318','2013-08-04','17:55:00',2.41),('10318','2013-08-04','18:00:00',2.23),('10318','2013-08-04','18:05:00',2.08),('10318','2013-08-04','18:10:00',1.93),('10318','2013-08-04','18:15:00',1.77),('10318','2013-08-04','18:20:00',1.62),('10318','2013-08-04','18:25:00',1.47),('10318','2013-08-04','18:30:00',1.34),('10318','2013-08-04','18:35:00',1.19),('10318','2013-08-04','18:40:00',1.1),('10318','2013-08-04','18:45:00',1.01),('10318','2013-08-03','07:15:00',1),('10318','2013-08-03','07:20:00',1.37),('10318','2013-08-03','07:25:00',1.59),('10318','2013-08-03','07:30:00',1.9),('10318','2013-08-03','07:35:00',2.05),('10318','2013-08-03','07:40:00',2.4),('10318','2013-08-03','07:45:00',2.66),('10318','2013-08-03','07:50:00',2.85),('10318','2013-08-03','07:55:00',3.04),('10318','2013-08-03','08:00:00',3.22),('10318','2013-08-03','08:05:00',3.42),('10318','2013-08-03','08:10:00',3.61),('10318','2013-08-03','08:15:00',3.72),('10318','2013-08-03','08:20:00',3.99),('10318','2013-08-03','08:25:00',4.17),('10318','2013-08-03','08:30:00',4.35),('10318','2013-08-03','08:35:00',4.53),('10318','2013-08-03','08:40:00',4.7),('10318','2013-08-03','08:45:00',4.87),('10318','2013-08-03','08:50:00',5.07),('10318','2013-08-03','08:55:00',5.2),('10318','2013-08-03','09:00:00',5.36),('10318','2013-08-03','09:05:00',5.52),('10318','2013-08-03','09:10:00',5.65),('10318','2013-08-03','09:15:00',5.79),('10318','2013-08-03','09:20:00',5.93),('10318','2013-08-03','09:25:00',6.06),('10318','2013-08-03','09:30:00',6.21),('10318','2013-08-03','09:35:00',6.29),('10318','2013-08-03','09:40:00',6.41),('10318','2013-08-03','09:45:00',6.53),('10318','2013-08-03','09:50:00',6.66),('10318','2013-08-03','09:55:00',6.76),('10318','2013-08-03','10:00:00',6.74),('10318','2013-08-03','10:05:00',6.95),('10318','2013-08-03','10:10:00',7.08),('10318','2013-08-03','10:15:00',7.14),('10318','2013-08-03','10:20:00',7.27),('10318','2013-08-03','10:25:00',7.4),('10318','2013-08-03','10:30:00',7.47),('10318','2013-08-03','10:35:00',7.53),('10318','2013-08-03','10:40:00',7.63),('10318','2013-08-03','10:45:00',7.84),('10318','2013-08-03','10:50:00',7.83),('10318','2013-08-03','10:55:00',7.91),('10318','2013-08-03','11:00:00',7.94),('10318','2013-08-03','11:05:00',8.01),('10318','2013-08-03','11:10:00',8.13),('10318','2013-08-03','11:15:00',8.13),('10318','2013-08-03','11:20:00',8.24),('10318','2013-08-03','11:25:00',8.23),('10318','2013-08-03','11:30:00',8.21),('10318','2013-08-03','11:35:00',8.29),('10318','2013-08-03','11:40:00',8.29),('10318','2013-08-03','11:45:00',8.24),('10318','2013-08-03','11:50:00',8.23),('10318','2013-08-03','11:55:00',8.3),('10318','2013-08-03','12:00:00',8.34),('10318','2013-08-03','12:05:00',8.33),('10318','2013-08-03','12:10:00',8.3),('10318','2013-08-03','12:15:00',8.37),('10318','2013-08-03','12:20:00',8.6),('10318','2013-08-03','12:25:00',8.52),('10318','2013-08-03','12:30:00',8.4),('10318','2013-08-03','12:35:00',8.51),('10318','2013-08-03','12:40:00',8.52),('10318','2013-08-03','12:45:00',8.39),('10318','2013-08-03','12:50:00',8.34),('10318','2013-08-03','12:55:00',8.35),('10318','2013-08-03','13:00:00',8.32),('10318','2013-08-03','13:05:00',8.31),('10318','2013-08-03','13:10:00',8.32),('10318','2013-08-03','13:15:00',8.23),('10318','2013-08-03','13:20:00',8.27),('10318','2013-08-03','13:25:00',8.28),('10318','2013-08-03','13:30:00',8.02),('10318','2013-08-03','13:35:00',8.32),('10318','2013-08-03','13:40:00',8.3),('10318','2013-08-03','13:45:00',8.2),('10318','2013-08-03','13:50:00',8.05),('10318','2013-08-03','13:55:00',7.95),('10318','2013-08-03','14:00:00',7.93),('10318','2013-08-03','14:05:00',7.79),('10318','2013-08-03','14:10:00',7.62),('10318','2013-08-03','14:15:00',7.66),('10318','2013-08-03','14:20:00',7.8),('10318','2013-08-03','14:25:00',7.87),('10318','2013-08-03','14:30:00',7.82),('10318','2013-08-03','14:35:00',7.74),('10318','2013-08-03','14:40:00',7.67),('10318','2013-08-03','14:45:00',7.64),('10318','2013-08-03','14:50:00',7.55),('10318','2013-08-03','14:55:00',7.47),('10318','2013-08-03','15:00:00',7.4),('10318','2013-08-03','15:05:00',7.32),('10318','2013-08-03','15:10:00',7.21),('10318','2013-08-03','15:15:00',7),('10318','2013-08-03','15:20:00',6.93),('10318','2013-08-03','15:25:00',6.83),('10318','2013-08-03','15:30:00',6.75),('10318','2013-08-03','15:35:00',6.63),('10318','2013-08-03','15:40:00',6.53),('10318','2013-08-03','15:45:00',6.45),('10318','2013-08-03','15:50:00',6.32),('10318','2013-08-03','15:55:00',6.2),('10318','2013-08-03','16:00:00',6.11),('10318','2013-08-03','16:05:00',5.96),('10318','2013-08-03','16:10:00',5.82),('10318','2013-08-03','16:15:00',5.65),('10318','2013-08-03','16:20:00',5.49),('10318','2013-08-03','16:25:00',5.36),('10318','2013-08-03','16:30:00',5.21),('10318','2013-08-03','16:35:00',4.96),('10318','2013-08-03','16:40:00',4.89),('10318','2013-08-03','16:45:00',4.73),('10318','2013-08-03','16:50:00',4.58),('10318','2013-08-03','16:55:00',4.44),('10318','2013-08-03','17:00:00',4.26),('10318','2013-08-03','17:05:00',4.07),('10318','2013-08-03','17:10:00',3.95),('10318','2013-08-03','17:15:00',3.77),('10318','2013-08-03','17:20:00',3.6),('10318','2013-08-03','17:25:00',3.43),('10318','2013-08-03','17:30:00',3.28),('10318','2013-08-03','17:35:00',3.1),('10318','2013-08-03','17:40:00',2.96),('10318','2013-08-03','17:45:00',2.78),('10318','2013-08-03','17:50:00',2.61),('10318','2013-08-03','17:55:00',2.43),('10318','2013-08-03','18:00:00',2.26),('10318','2013-08-03','18:05:00',2.11),('10318','2013-08-03','18:10:00',1.94),('10318','2013-08-03','18:15:00',1.8),('10318','2013-08-03','18:20:00',1.66),('10318','2013-08-03','18:25:00',1.53),('10318','2013-08-03','18:30:00',1.4),('10318','2013-08-03','18:35:00',1.28),('10318','2013-08-03','18:40:00',1.16),('10318','2013-08-03','18:45:00',1.04),('10318','2013-08-02','07:15:00',1.15),('10318','2013-08-02','07:20:00',1.5),('10318','2013-08-02','07:25:00',1.83),('10318','2013-08-02','07:30:00',1.86),('10318','2013-08-02','07:35:00',2.08),('10318','2013-08-02','07:40:00',2.57),('10318','2013-08-02','07:45:00',2.83),('10318','2013-08-02','07:50:00',3.03),('10318','2013-08-02','07:55:00',3.22),('10318','2013-08-02','08:00:00',3.4),('10318','2013-08-02','08:05:00',3.6),('10318','2013-08-02','08:10:00',3.79),('10318','2013-08-02','08:15:00',3.98),('10318','2013-08-02','08:20:00',4.17),('10318','2013-08-02','08:25:00',4.35),('10318','2013-08-02','08:30:00',4.47),('10318','2013-08-02','08:35:00',4.72),('10318','2013-08-02','08:40:00',4.9),('10318','2013-08-02','08:45:00',5.07),('10318','2013-08-02','08:50:00',5.24),('10318','2013-08-02','08:55:00',5.4),('10318','2013-08-02','09:00:00',5.56),('10318','2013-08-02','09:05:00',5.73),('10318','2013-08-02','09:10:00',5.87),('10318','2013-08-02','09:15:00',6.02),('10318','2013-08-02','09:20:00',6.17),('10318','2013-08-02','09:25:00',6.3),('10318','2013-08-02','09:30:00',6.41),('10318','2013-08-02','09:35:00',6.53),('10318','2013-08-02','09:40:00',6.63),('10318','2013-08-02','09:45:00',6.77),('10318','2013-08-02','09:50:00',6.87),('10318','2013-08-02','09:55:00',7),('10318','2013-08-02','10:00:00',7.1),('10318','2013-08-02','10:05:00',7.18),('10318','2013-08-02','10:10:00',7.27),('10318','2013-08-02','10:15:00',7.34),('10318','2013-08-02','10:20:00',7.45),('10318','2013-08-02','10:25:00',7.55),('10318','2013-08-02','10:30:00',7.65),('10318','2013-08-02','10:35:00',7.72),('10318','2013-08-02','10:40:00',7.79),('10318','2013-08-02','10:45:00',7.9),('10318','2013-08-02','10:50:00',7.99),('10318','2013-08-02','10:55:00',8.04),('10318','2013-08-02','11:00:00',8.08),('10318','2013-08-02','11:05:00',8.16),('10318','2013-08-02','11:10:00',8.23),('10318','2013-08-02','11:15:00',8.29),('10318','2013-08-02','11:20:00',8.39),('10318','2013-08-02','11:25:00',8.42),('10318','2013-08-02','11:30:00',8.4),('10318','2013-08-02','11:35:00',8.43),('10318','2013-08-02','11:40:00',8.42),('10318','2013-08-02','11:45:00',8.43),('10318','2013-08-02','11:50:00',8.47),('10318','2013-08-02','11:55:00',8.52),('10318','2013-08-02','12:00:00',8.54),('10318','2013-08-02','12:05:00',8.61),('10318','2013-08-02','12:10:00',8.6),('10318','2013-08-02','12:15:00',8.62),('10318','2013-08-02','12:20:00',8.67),('10318','2013-08-02','12:25:00',8.7),('10318','2013-08-02','12:30:00',8.68),('10318','2013-08-02','12:35:00',8.69),('10318','2013-08-02','12:40:00',8.66),('10318','2013-08-02','12:45:00',8.69),('10318','2013-08-02','12:50:00',8.68),('10318','2013-08-02','12:55:00',8.59),('10318','2013-08-02','13:00:00',8.58),('10318','2013-08-02','13:05:00',8.6),('10318','2013-08-02','13:10:00',8.7),('10318','2013-08-02','13:15:00',8.48),('10318','2013-08-02','13:20:00',8.62),('10318','2013-08-02','13:25:00',8.55),('10318','2013-08-02','13:30:00',8.42),('10318','2013-08-02','13:35:00',8.38),('10318','2013-08-02','13:40:00',8.37),('10318','2013-08-02','13:45:00',8.36),('10318','2013-08-02','13:50:00',8.34),('10318','2013-08-02','13:55:00',8.32),('10318','2013-08-02','14:00:00',8.32),('10318','2013-08-02','14:05:00',8.19),('10318','2013-08-02','14:10:00',8.13),('10318','2013-08-02','14:15:00',8.05),('10318','2013-08-02','14:20:00',7.97),('10318','2013-08-02','14:25:00',8.01),('10318','2013-08-02','14:30:00',7.91),('10318','2013-08-02','14:35:00',7.91),('10318','2013-08-02','14:40:00',7.88),('10318','2013-08-02','14:45:00',7.75),('10318','2013-08-02','14:50:00',7.63),('10318','2013-08-02','14:55:00',7.61),('10318','2013-08-02','15:00:00',7.31),('10318','2013-08-02','15:05:00',7.43),('10318','2013-08-02','15:10:00',7.3),('10318','2013-08-02','15:15:00',7.18),('10318','2013-08-02','15:20:00',7.09),('10318','2013-08-02','15:25:00',6.97),('10318','2013-08-02','15:30:00',6.93),('10318','2013-08-02','15:35:00',6.88),('10318','2013-08-02','15:40:00',6.74),('10318','2013-08-02','15:45:00',6.57),('10318','2013-08-02','15:50:00',6.46),('10318','2013-08-02','15:55:00',6.34),('10318','2013-08-02','16:00:00',6.15),('10318','2013-08-02','16:05:00',6.02),('10318','2013-08-02','16:10:00',5.88),('10318','2013-08-02','16:15:00',5.8),('10318','2013-08-02','16:20:00',5.67),('10318','2013-08-02','16:25:00',5.46),('10318','2013-08-02','16:30:00',5.3),('10318','2013-08-02','16:35:00',5.16),('10318','2013-08-02','16:40:00',5.03),('10318','2013-08-02','16:45:00',4.84),('10318','2013-08-02','16:50:00',4.73),('10318','2013-08-02','16:55:00',4.54),('10318','2013-08-02','17:00:00',4.38),('10318','2013-08-02','17:05:00',4.22),('10318','2013-08-02','17:10:00',4.02),('10318','2013-08-02','17:15:00',3.85),('10318','2013-08-02','17:20:00',3.7),('10318','2013-08-02','17:25:00',3.53),('10318','2013-08-02','17:30:00',3.36),('10318','2013-08-02','17:35:00',3.2),('10318','2013-08-02','17:40:00',3.02),('10318','2013-08-02','17:45:00',2.83),('10318','2013-08-02','17:50:00',2.66),('10318','2013-08-02','17:55:00',2.5),('10318','2013-08-02','18:00:00',2.3),('10318','2013-08-02','18:05:00',2.17),('10318','2013-08-02','18:10:00',2),('10318','2013-08-02','18:15:00',1.85),('10318','2013-08-02','18:20:00',1.7),('10318','2013-08-02','18:25:00',1.56),('10318','2013-08-02','18:30:00',1.43),('10318','2013-08-02','18:35:00',1.26),('10318','2013-08-02','18:40:00',1.17),('10318','2013-08-02','18:45:00',1.05),('10318','2013-08-01','07:15:00',1.24),('10318','2013-08-01','07:20:00',1.55),('10318','2013-08-01','07:25:00',1.82),('10318','2013-08-01','07:30:00',1.95),('10318','2013-08-01','07:35:00',2.09),('10318','2013-08-01','07:40:00',2.64),('10318','2013-08-01','07:45:00',2.85),('10318','2013-08-01','07:50:00',3.02),('10318','2013-08-01','07:55:00',3.18),('10318','2013-08-01','08:00:00',3.41),('10318','2013-08-01','08:05:00',3.61),('10318','2013-08-01','08:10:00',3.8),('10318','2013-08-01','08:15:00',3.98),('10318','2013-08-01','08:20:00',4.17),('10318','2013-08-01','08:25:00',4.34),('10318','2013-08-01','08:30:00',4.52),('10318','2013-08-01','08:35:00',4.7),('10318','2013-08-01','08:40:00',4.88),('10318','2013-08-01','08:45:00',5.09),('10318','2013-08-01','08:50:00',5.22),('10318','2013-08-01','08:55:00',5.38),('10318','2013-08-01','09:00:00',5.58),('10318','2013-08-01','09:05:00',5.76),('10318','2013-08-01','09:10:00',5.97),('10318','2013-08-01','09:15:00',6.1),('10318','2013-08-01','09:20:00',6.24),('10318','2013-08-01','09:25:00',6.4),('10318','2013-08-01','09:30:00',6.54),('10318','2013-08-01','09:35:00',6.65),('10318','2013-08-01','09:40:00',6.76),('10318','2013-08-01','09:45:00',6.91),('10318','2013-08-01','09:50:00',7.1),('10318','2013-08-01','09:55:00',7.23),('10318','2013-08-01','10:00:00',7.42),('10318','2013-08-01','10:05:00',7.57),('10318','2013-08-01','10:10:00',7.74),('10318','2013-08-01','10:15:00',7.84),('10318','2013-08-01','10:20:00',7.99),('10318','2013-08-01','10:25:00',8.12),('10318','2013-08-01','10:30:00',8.14),('10318','2013-08-01','10:35:00',8.28),('10318','2013-08-01','10:40:00',8.34),('10318','2013-08-01','10:45:00',8.4),('10318','2013-08-01','10:50:00',8.43),('10318','2013-08-01','10:55:00',8.55),('10318','2013-08-01','11:00:00',8.63),('10318','2013-08-01','11:05:00',8.72),('10318','2013-08-01','11:10:00',8.74),('10318','2013-08-01','11:15:00',8.84),('10318','2013-08-01','11:20:00',8.89),('10318','2013-08-01','11:25:00',8.96),('10318','2013-08-01','11:30:00',9.03),('10318','2013-08-01','11:35:00',9.06),('10318','2013-08-01','11:40:00',9.08),('10318','2013-08-01','11:45:00',9.16),('10318','2013-08-01','11:50:00',9.18),('10318','2013-08-01','11:55:00',9.16),('10318','2013-08-01','12:00:00',9.21),('10318','2013-08-01','12:05:00',9.22),('10318','2013-08-01','12:10:00',9.18),('10318','2013-08-01','12:15:00',8.91),('10318','2013-08-01','12:20:00',9.24),('10318','2013-08-01','12:25:00',9.02),('10318','2013-08-01','12:30:00',9.32),('10318','2013-08-01','12:35:00',9.26),('10318','2013-08-01','12:40:00',9.23),('10318','2013-08-01','12:45:00',8.62),('10318','2013-08-01','12:50:00',9.28),('10318','2013-08-01','12:55:00',9.27),('10318','2013-08-01','13:00:00',9.15),('10318','2013-08-01','13:05:00',9.32),('10318','2013-08-01','13:10:00',9.33),('10318','2013-08-01','13:15:00',9.37),('10318','2013-08-01','13:20:00',9.3),('10318','2013-08-01','13:25:00',9.22),('10318','2013-08-01','13:30:00',9.14),('10318','2013-08-01','13:35:00',9.13),('10318','2013-08-01','13:40:00',9.12),('10318','2013-08-01','13:45:00',9.1),('10318','2013-08-01','13:50:00',9.08),('10318','2013-08-01','13:55:00',9.03),('10318','2013-08-01','14:00:00',8.63),('10318','2013-08-01','14:05:00',8.71),('10318','2013-08-01','14:10:00',8.64),('10318','2013-08-01','14:15:00',8.66),('10318','2013-08-01','14:20:00',8.59),('10318','2013-08-01','14:25:00',8.47),('10318','2013-08-01','14:30:00',8.38),('10318','2013-08-01','14:35:00',8.38),('10318','2013-08-01','14:40:00',8.28),('10318','2013-08-01','14:45:00',8.2),('10318','2013-08-01','14:50:00',8.06),('10318','2013-08-01','14:55:00',7.81),('10318','2013-08-01','15:00:00',7.77),('10318','2013-08-01','15:05:00',7.73),('10318','2013-08-01','15:10:00',7.68),('10318','2013-08-01','15:15:00',7.59),('10318','2013-08-01','15:20:00',7.44),('10318','2013-08-01','15:25:00',7.3),('10318','2013-08-01','15:30:00',7.23),('10318','2013-08-01','15:35:00',7.1),('10318','2013-08-01','15:40:00',5.55),('10318','2013-08-01','15:45:00',6.51),('10318','2013-08-01','15:50:00',6.79),('10318','2013-08-01','15:55:00',6.62),('10318','2013-08-01','16:00:00',6.53),('10318','2013-08-01','16:05:00',6.37),('10318','2013-08-01','16:10:00',6.19),('10318','2013-08-01','16:15:00',6.02),('10318','2013-08-01','16:20:00',5.83),('10318','2013-08-01','16:25:00',5.69),('10318','2013-08-01','16:30:00',5.5),('10318','2013-08-01','16:35:00',5.33),('10318','2013-08-01','16:40:00',5.14),('10318','2013-08-01','16:45:00',4.96),('10318','2013-08-01','16:50:00',4.79),('10318','2013-08-01','16:55:00',4.61),('10318','2013-08-01','17:00:00',4.44),('10318','2013-08-01','17:05:00',4.24),('10318','2013-08-01','17:10:00',4.09),('10318','2013-08-01','17:15:00',3.94),('10318','2013-08-01','17:20:00',3.76),('10318','2013-08-01','17:25:00',3.56),('10318','2013-08-01','17:30:00',3.33),('10318','2013-08-01','17:35:00',3.22),('10318','2013-08-01','17:40:00',3.05),('10318','2013-08-01','17:45:00',2.87),('10318','2013-08-01','17:50:00',2.7),('10318','2013-08-01','17:55:00',2.52),('10318','2013-08-01','18:00:00',2.34),('10318','2013-08-01','18:05:00',2.19),('10318','2013-08-01','18:10:00',2.03),('10318','2013-08-01','18:15:00',1.87),('10318','2013-08-01','18:20:00',1.72),('10318','2013-08-01','18:25:00',1.57),('10318','2013-08-01','18:30:00',1.42),('10318','2013-08-01','18:35:00',1.29),('10318','2013-08-01','18:40:00',1.15),('10318','2013-08-01','18:45:00',1.03),('10318','2013-07-31','07:15:00',1.29),('10318','2013-07-31','07:20:00',1.56),('10318','2013-07-31','07:25:00',1.76),('10318','2013-07-31','07:30:00',2.05),('10318','2013-07-31','07:35:00',2.14),('10318','2013-07-31','07:40:00',2.69),('10318','2013-07-31','07:45:00',2.9),('10318','2013-07-31','07:50:00',3.1),('10318','2013-07-31','07:55:00',3.3),('10318','2013-07-31','08:00:00',3.53),('10318','2013-07-31','08:05:00',3.73),('10318','2013-07-31','08:10:00',3.9),('10318','2013-07-31','08:15:00',4.09),('10318','2013-07-31','08:20:00',4.29),('10318','2013-07-31','08:25:00',4.46),('10318','2013-07-31','08:30:00',4.63),('10318','2013-07-31','08:35:00',4.82),('10318','2013-07-31','08:40:00',4.98),('10318','2013-07-31','08:45:00',5.14),('10318','2013-07-31','08:50:00',5.29),('10318','2013-07-31','08:55:00',5.43),('10318','2013-07-31','09:00:00',5.64),('10318','2013-07-31','09:05:00',5.79),('10318','2013-07-31','09:10:00',5.86),('10318','2013-07-31','09:15:00',6.09),('10318','2013-07-31','09:20:00',6.22),('10318','2013-07-31','09:25:00',6.34),('10318','2013-07-31','09:30:00',6.45),('10318','2013-07-31','09:35:00',6.59),('10318','2013-07-31','09:40:00',6.71),('10318','2013-07-31','09:45:00',6.84),('10318','2013-07-31','09:50:00',6.96),('10318','2013-07-31','09:55:00',7.1),('10318','2013-07-31','10:00:00',7.2),('10318','2013-07-31','10:05:00',7.28),('10318','2013-07-31','10:10:00',7.41),('10318','2013-07-31','10:15:00',7.52),('10318','2013-07-31','10:20:00',7.69),('10318','2013-07-31','10:25:00',7.82),('10318','2013-07-31','10:30:00',7.77),('10318','2013-07-31','10:35:00',8.01),('10318','2013-07-31','10:40:00',8.05),('10318','2013-07-31','10:45:00',8.17),('10318','2013-07-31','10:50:00',8.18),('10318','2013-07-31','10:55:00',8.26),('10318','2013-07-31','11:00:00',8.49),('10318','2013-07-31','11:05:00',8.6),('10318','2013-07-31','11:10:00',8.64),('10318','2013-07-31','11:15:00',8.74),('10318','2013-07-31','11:20:00',8.81),('10318','2013-07-31','11:25:00',8.84),('10318','2013-07-31','11:30:00',8.89),('10318','2013-07-31','11:35:00',8.83),('10318','2013-07-31','11:40:00',8.86),('10318','2013-07-31','11:45:00',8.65),('10318','2013-07-31','11:50:00',8.87),('10318','2013-07-31','11:55:00',8.43),('10318','2013-07-31','12:00:00',8.97),('10318','2013-07-31','12:05:00',9),('10318','2013-07-31','12:10:00',9.17),('10318','2013-07-31','12:15:00',6.09),('10318','2013-07-31','12:20:00',8.81),('10318','2013-07-31','12:25:00',8.81),('10318','2013-07-31','12:30:00',8.2),('10318','2013-07-31','12:35:00',8.92),('10318','2013-07-31','12:40:00',6.21),('10318','2013-07-31','12:45:00',9.24),('10318','2013-07-31','12:50:00',9.67),('10318','2013-07-31','12:55:00',9.44),('10318','2013-07-31','13:00:00',9.37),('10318','2013-07-31','13:05:00',9.35),('10318','2013-07-31','13:10:00',9.28),('10318','2013-07-31','13:15:00',9.23),('10318','2013-07-31','13:20:00',7.39),('10318','2013-07-31','13:25:00',9.14),('10318','2013-07-31','13:30:00',9.17),('10318','2013-07-31','13:35:00',9.05),('10318','2013-07-31','13:40:00',8.94),('10318','2013-07-31','13:45:00',8.95),('10318','2013-07-31','13:50:00',9),('10318','2013-07-31','13:55:00',9.02),('10318','2013-07-31','14:00:00',8.85),('10318','2013-07-31','14:05:00',8.79),('10318','2013-07-31','14:10:00',8.79),('10318','2013-07-31','14:15:00',8.8),('10318','2013-07-31','14:20:00',8.65),('10318','2013-07-31','14:25:00',8.39),('10318','2013-07-31','14:30:00',7.78),('10318','2013-07-31','14:35:00',8.48),('10318','2013-07-31','14:40:00',8.45),('10318','2013-07-31','14:45:00',8.23),('10318','2013-07-31','14:50:00',8.19),('10318','2013-07-31','14:55:00',8.26),('10318','2013-07-31','15:00:00',8.07),('10318','2013-07-31','15:05:00',7.87),('10318','2013-07-31','15:10:00',7.7),('10318','2013-07-31','15:15:00',7.75),('10318','2013-07-31','15:20:00',7.55),('10318','2013-07-31','15:25:00',7.45),('10318','2013-07-31','15:30:00',7.25),('10318','2013-07-31','15:35:00',7.17),('10318','2013-07-31','15:40:00',7.08),('10318','2013-07-31','15:45:00',6.61),('10318','2013-07-31','15:50:00',6.61),('10318','2013-07-31','15:55:00',6.49),('10318','2013-07-31','16:00:00',6.35),('10318','2013-07-31','16:05:00',6.22),('10318','2013-07-31','16:10:00',6.15),('10318','2013-07-31','16:15:00',5.94),('10318','2013-07-31','16:20:00',5.9),('10318','2013-07-31','16:25:00',5.87),('10318','2013-07-31','16:30:00',5.64),('10318','2013-07-31','16:35:00',5.33),('10318','2013-07-31','16:40:00',5.19),('10318','2013-07-31','16:45:00',4.98),('10318','2013-07-31','16:50:00',4.86),('10318','2013-07-31','16:55:00',4.75),('10318','2013-07-31','17:00:00',4.24),('10318','2013-07-31','17:05:00',2.29),('10318','2013-07-31','17:10:00',1.77),('10318','2013-07-31','17:15:00',3.95),('10318','2013-07-31','17:20:00',3.86),('10318','2013-07-31','17:25:00',3.62),('10318','2013-07-31','17:30:00',3.37),('10318','2013-07-31','17:35:00',3.14),('10318','2013-07-31','17:40:00',3.06),('10318','2013-07-31','17:45:00',2.91),('10318','2013-07-31','17:50:00',2.71),('10318','2013-07-31','17:55:00',2.54),('10318','2013-07-31','18:00:00',2.35),('10318','2013-07-31','18:05:00',2.21),('10318','2013-07-31','18:10:00',2.07),('10318','2013-07-31','18:15:00',1.92),('10318','2013-07-31','18:20:00',1.76),('10318','2013-07-31','18:25:00',1.62),('10318','2013-07-31','18:30:00',1.47),('10318','2013-07-31','18:35:00',1.33),('10318','2013-07-31','18:40:00',1.2),('10318','2013-07-31','18:45:00',1.06),('10318','2014-04-08','07:45:00',1.52),('10318','2014-04-08','07:50:00',1.55),('10318','2014-04-08','07:55:00',1.47),('10318','2014-04-08','08:00:00',1.56),('10318','2014-04-08','08:05:00',1.62),('10318','2014-04-08','08:10:00',2.7),('10318','2014-04-08','08:15:00',3.35),('10318','2014-04-08','08:20:00',2.16),('10318','2014-04-08','08:25:00',3.89),('10318','2014-04-08','08:30:00',3.39),('10318','2014-04-08','08:35:00',2.94),('10318','2014-04-08','08:40:00',4.46),('10318','2014-04-08','08:45:00',4.4),('10318','2014-04-08','08:50:00',4.74),('10318','2014-04-08','08:55:00',5.07),('10318','2014-04-08','09:00:00',5.2),('10318','2014-04-08','09:05:00',5.4),('10318','2014-04-08','09:10:00',5.58),('10318','2014-04-08','09:15:00',5.74),('10318','2014-04-08','09:20:00',5.9),('10318','2014-04-08','09:25:00',6.07),('10318','2014-04-08','09:30:00',4.63),('10318','2014-04-08','09:35:00',6.23),('10318','2014-04-08','09:40:00',6.31),('10318','2014-04-08','09:45:00',6.53),('10318','2014-04-08','09:50:00',6.64),('10318','2014-04-08','09:55:00',6.76),('10318','2014-04-08','10:00:00',6.74),('10318','2014-04-08','10:05:00',6.94),('10318','2014-04-08','10:10:00',7.44),('10318','2014-04-08','10:15:00',7.52),('10318','2014-04-08','10:20:00',7.6),('10318','2014-04-08','10:25:00',7.71),('10318','2014-04-08','10:30:00',7.77),('10318','2014-04-08','10:35:00',7.87),('10318','2014-04-08','10:40:00',7.97),('10318','2014-04-08','10:45:00',8.09),('10318','2014-04-08','10:50:00',8.2),('10318','2014-04-08','10:55:00',8.26),('10318','2014-04-08','11:00:00',8.3),('10318','2014-04-08','11:05:00',8.26),('10318','2014-04-08','11:10:00',8.49),('10318','2014-04-08','11:15:00',8.48),('10318','2014-04-08','11:20:00',8.51),('10318','2014-04-08','11:25:00',8.36),('10318','2014-04-08','11:30:00',7.94),('10318','2014-04-08','11:35:00',8.54),('10318','2014-04-08','11:40:00',8.81),('10318','2014-04-08','11:45:00',8.78),('10318','2014-04-08','11:50:00',8.51),('10318','2014-04-08','11:55:00',9.03),('10318','2014-04-08','12:00:00',9),('10318','2014-04-08','12:05:00',8.51),('10318','2014-04-08','12:10:00',8.25),('10318','2014-04-08','12:15:00',7.82),('10318','2014-04-08','12:20:00',8.02),('10318','2014-04-08','12:25:00',8.29),('10318','2014-04-08','12:30:00',8.09),('10318','2014-04-08','12:35:00',8.64),('10318','2014-04-08','12:40:00',7.14),('10318','2014-04-08','12:45:00',7.67),('10318','2014-04-08','12:50:00',7.94),('10318','2014-04-08','12:55:00',9.08),('10318','2014-04-08','13:00:00',8.72),('10318','2014-04-08','13:05:00',9.09),('10318','2014-04-08','13:10:00',9.15),('10318','2014-04-08','13:15:00',9.28),('10318','2014-04-08','13:20:00',9.28),('10318','2014-04-08','13:25:00',9.23),('10318','2014-04-08','13:30:00',9.27),('10318','2014-04-08','13:35:00',9.24),('10318','2014-04-08','13:40:00',9.16),('10318','2014-04-08','13:45:00',8.99),('10318','2014-04-08','13:50:00',8.92),('10318','2014-04-08','13:55:00',8.88),('10318','2014-04-08','14:00:00',8.85),('10318','2014-04-08','14:05:00',8.66),('10318','2014-04-08','14:10:00',8.82),('10318','2014-04-08','14:15:00',8.73),('10318','2014-04-08','14:20:00',7.78),('10318','2014-04-08','14:25:00',8),('10318','2014-04-08','14:30:00',8.55),('10318','2014-04-08','14:35:00',8.04),('10318','2014-04-08','14:40:00',6.93),('10318','2014-04-08','14:45:00',7.94),('10318','2014-04-08','14:50:00',8.03),('10318','2014-04-08','14:55:00',8.03),('10318','2014-04-08','15:00:00',7.74),('10318','2014-04-08','15:05:00',7.61),('10318','2014-04-08','15:10:00',7.48),('10318','2014-04-08','15:15:00',7.31),('10318','2014-04-08','15:20:00',7.19),('10318','2014-04-08','15:25:00',7.31),('10318','2014-04-08','15:30:00',7.1),('10318','2014-04-08','15:35:00',6.93),('10318','2014-04-08','15:40:00',6.57),('10318','2014-04-08','15:45:00',6.44),('10318','2014-04-08','15:50:00',6.36),('10318','2014-04-08','15:55:00',6.21),('10318','2014-04-08','16:00:00',5.99),('10318','2014-04-08','16:05:00',5.96),('10318','2014-04-08','16:10:00',5.53),('10318','2014-04-08','16:15:00',5.36),('10318','2014-04-08','16:20:00',4.85),('10318','2014-04-08','16:25:00',5.13),('10318','2014-04-08','16:30:00',5.3),('10318','2014-04-08','16:35:00',4.86),('10318','2014-04-08','16:40:00',4.77),('10318','2014-04-08','16:45:00',4.52),('10318','2014-04-08','16:50:00',4.45),('10318','2014-04-08','16:55:00',4),('10318','2014-04-08','17:00:00',3.94),('10318','2014-04-08','17:05:00',3.8),('10318','2014-04-08','17:10:00',3.6),('10318','2014-04-08','17:15:00',3.4),('10318','2014-04-08','17:20:00',3.14),('10318','2014-04-08','17:25:00',2.89),('10318','2014-04-08','17:30:00',2.58),('10318','2014-04-08','17:35:00',2.51),('10318','2014-04-08','17:40:00',2.38),('10318','2014-04-08','17:45:00',2.32),('10318','2014-04-08','17:50:00',2.15),('10318','2014-04-08','17:55:00',1.89),('10318','2014-04-08','18:00:00',1.87),('10318','2014-04-08','18:05:00',1.73),('10318','2014-04-08','18:10:00',1.6),('10318','2014-04-08','18:15:00',1.49),('10318','2014-04-08','18:20:00',1.32),('10318','2014-04-08','18:25:00',1.05),('10318','2013-07-30','07:40:00',2.47),('10318','2013-07-30','07:45:00',2.98),('10318','2013-07-30','07:50:00',3.06),('10318','2013-07-30','07:55:00',3.11),('10318','2013-07-30','08:00:00',3.45),('10318','2013-07-30','08:05:00',3.77),('10318','2013-07-30','08:10:00',3.92),('10318','2013-07-30','08:15:00',4.13),('10318','2013-07-30','08:20:00',4.13),('10318','2013-07-30','08:25:00',4.25),('10318','2013-07-30','08:30:00',4.49),('10318','2013-07-30','08:35:00',4.56),('10318','2013-07-30','08:40:00',4.69),('10318','2013-07-30','08:45:00',5.14),('10318','2013-07-30','08:50:00',5.37),('10318','2013-07-30','08:55:00',5.7),('10318','2013-07-30','09:00:00',6.01),('10318','2013-07-30','09:05:00',6.11),('10318','2013-07-30','09:10:00',3.44),('10318','2013-07-30','09:15:00',5.33),('10318','2013-07-30','09:20:00',6.69),('10318','2013-07-30','09:25:00',6.8),('10318','2013-07-30','09:30:00',6.74),('10318','2013-07-30','09:35:00',6.97),('10318','2013-07-30','09:40:00',7.25),('10318','2013-07-30','09:45:00',7.48),('10318','2013-07-30','09:50:00',7.6),('10318','2013-07-30','09:55:00',7.62),('10318','2013-07-30','10:00:00',7.34),('10318','2013-07-30','10:05:00',7.91),('10318','2013-07-30','10:10:00',8.18),('10318','2013-07-30','10:15:00',8.29),('10318','2013-07-30','10:20:00',7.91),('10318','2013-07-30','10:25:00',8.12),('10318','2013-07-30','10:30:00',8.4),('10318','2013-07-30','10:35:00',8.24),('10318','2013-07-30','10:40:00',8.38),('10318','2013-07-30','10:45:00',6.26),('10318','2013-07-30','10:50:00',7.71),('10318','2013-07-30','10:55:00',8.54),('10318','2013-07-30','11:00:00',8.7),('10318','2013-07-30','11:05:00',8.49),('10318','2013-07-30','11:10:00',7.04),('10318','2013-07-30','11:15:00',8.57),('10318','2013-07-30','11:20:00',8.81),('10318','2013-07-30','11:25:00',8.72),('10318','2013-07-30','11:30:00',8.67),('10318','2013-07-30','11:35:00',8.75),('10318','2013-07-30','11:40:00',8.93),('10318','2013-07-30','11:45:00',8.99),('10318','2013-07-30','11:50:00',8.95),('10318','2013-07-30','11:55:00',8.34),('10318','2013-07-30','12:00:00',8.84),('10318','2013-07-30','12:05:00',6.82),('10318','2013-07-30','12:10:00',8.22),('10318','2013-07-30','12:15:00',8.81),('10318','2013-07-30','12:20:00',8.95),('10318','2013-07-30','12:25:00',6.63),('10318','2013-07-30','12:30:00',9.13),('10318','2013-07-30','12:35:00',9.23),('10318','2013-07-30','12:40:00',3.31),('10318','2013-07-30','12:45:00',4.04),('10318','2013-07-30','12:50:00',6.79),('10318','2013-07-30','12:55:00',2.59),('10318','2013-07-30','13:00:00',2.53),('10318','2013-07-30','13:05:00',2.88),('10318','2013-07-30','13:10:00',4.17),('10318','2013-07-30','13:15:00',5.35),('10318','2013-07-30','13:20:00',9.07),('10318','2013-07-30','13:25:00',9.53),('10318','2013-07-30','13:30:00',9.34),('10318','2013-07-30','13:35:00',9.31),('10318','2013-07-30','13:40:00',9.3),('10318','2013-07-30','13:45:00',9.49),('10318','2013-07-30','13:50:00',9.11),('10318','2013-07-30','13:55:00',8.89),('10318','2013-07-30','14:00:00',8.9),('10318','2013-07-30','14:05:00',8.67),('10318','2013-07-30','14:10:00',8.41),('10318','2013-07-30','14:15:00',8.41),('10318','2013-07-30','14:20:00',8.44),('10318','2013-07-30','14:25:00',8.46),('10318','2013-07-30','14:30:00',8.25),('10318','2013-07-30','14:35:00',8.15),('10318','2013-07-30','14:40:00',8.2),('10318','2013-07-30','14:45:00',7.83),('10318','2013-07-30','14:50:00',7.99),('10318','2013-07-30','14:55:00',7.84),('10318','2013-07-30','15:00:00',7.64),('10318','2013-07-30','15:05:00',7.49),('10318','2013-07-30','15:10:00',7.51),('10318','2013-07-30','15:15:00',7.36),('10318','2013-07-30','15:20:00',7.27),('10318','2013-07-30','15:25:00',7.17),('10318','2013-07-30','15:30:00',7.05),('10318','2013-07-30','15:35:00',6.92),('10318','2013-07-30','15:40:00',6.82),('10318','2013-07-30','15:45:00',6.7),('10318','2013-07-30','15:50:00',6.56),('10318','2013-07-30','15:55:00',6.36),('10318','2013-07-30','16:00:00',6.25),('10318','2013-07-30','16:05:00',6.12),('10318','2013-07-30','16:10:00',5.93),('10318','2013-07-30','16:15:00',5.77),('10318','2013-07-30','16:20:00',5.59),('10318','2013-07-30','16:25:00',5.43),('10318','2013-07-30','16:30:00',5.22),('10318','2013-07-30','16:35:00',5.18),('10318','2013-07-30','16:40:00',5.04),('10318','2013-07-30','16:45:00',4.89),('10318','2013-07-30','16:50:00',4.72),('10318','2013-07-30','16:55:00',4.57),('10318','2013-07-30','17:00:00',4.38),('10318','2013-07-30','17:05:00',4.24),('10318','2013-07-30','17:10:00',4.1),('10318','2013-07-30','17:15:00',3.89),('10318','2013-07-30','17:20:00',3.65),('10318','2013-07-30','17:25:00',3.53),('10318','2013-07-30','17:30:00',3.37),('10318','2013-07-30','17:35:00',3.18),('10318','2013-07-30','17:40:00',2.99),('10318','2013-07-30','17:45:00',2.81),('10318','2013-07-30','17:50:00',2.68),('10318','2013-07-30','17:55:00',2.51),('10318','2013-07-30','18:00:00',2.32),('10318','2013-07-30','18:05:00',2.16),('10318','2013-07-30','18:10:00',2.03),('10318','2013-07-30','18:15:00',1.88),('10318','2013-07-30','18:20:00',1.73),('10318','2013-07-30','18:25:00',1.6),('10318','2013-07-30','18:30:00',1.47),('10318','2013-07-30','18:35:00',1.32),('10318','2013-07-30','18:40:00',1.21),('10318','2013-07-30','18:45:00',1.11),('10318','2013-07-30','18:50:00',1.01),('10318','2013-07-29','07:15:00',1.18),('10318','2013-07-29','07:20:00',1.43),('10318','2013-07-29','07:25:00',1.62),('10318','2013-07-29','07:30:00',1.79),('10318','2013-07-29','07:35:00',2.05),('10318','2013-07-29','07:40:00',2.32),('10318','2013-07-29','07:45:00',2.49),('10318','2013-07-29','07:50:00',2.65),('10318','2013-07-29','07:55:00',2.84),('10318','2013-07-29','08:00:00',3.04),('10318','2013-07-29','08:05:00',3.25),('10318','2013-07-29','08:10:00',3.37),('10318','2013-07-29','08:15:00',3.6),('10318','2013-07-29','08:20:00',3.79),('10318','2013-07-29','08:25:00',3.96),('10318','2013-07-29','08:30:00',4.12),('10318','2013-07-29','08:35:00',4.31),('10318','2013-07-29','08:40:00',4.45),('10318','2013-07-29','08:45:00',4.6),('10318','2013-07-29','08:50:00',4.73),('10318','2013-07-29','08:55:00',4.87),('10318','2013-07-29','09:00:00',4.99),('10318','2013-07-29','09:05:00',5.16),('10318','2013-07-29','09:10:00',5.35),('10318','2013-07-29','09:15:00',5.46),('10318','2013-07-29','09:20:00',5.59),('10318','2013-07-29','09:25:00',5.66),('10318','2013-07-29','09:30:00',5.81),('10318','2013-07-29','09:35:00',6.06),('10318','2013-07-29','09:40:00',6.21),('10318','2013-07-29','09:45:00',6.35),('10318','2013-07-29','09:50:00',6.39),('10318','2013-07-29','09:55:00',6.53),('10318','2013-07-29','10:00:00',6.83),('10318','2013-07-29','10:05:00',6.9),('10318','2013-07-29','10:10:00',6.92),('10318','2013-07-29','10:15:00',7.08),('10318','2013-07-29','10:20:00',7.24),('10318','2013-07-29','10:25:00',7.34),('10318','2013-07-29','10:30:00',7.38),('10318','2013-07-29','10:35:00',7.46),('10318','2013-07-29','10:40:00',7.56),('10318','2013-07-29','10:45:00',7.57),('10318','2013-07-29','10:50:00',7.63),('10318','2013-07-29','10:55:00',7.7),('10318','2013-07-29','11:00:00',7.78),('10318','2013-07-29','11:05:00',7.81),('10318','2013-07-29','11:10:00',7.73),('10318','2013-07-29','11:15:00',8),('10318','2013-07-29','11:20:00',8.03),('10318','2013-07-29','11:25:00',8.07),('10318','2013-07-29','11:30:00',8.2),('10318','2013-07-29','11:35:00',8.22),('10318','2013-07-29','11:40:00',8.2),('10318','2013-07-29','11:45:00',8.16),('10318','2013-07-29','11:50:00',8.22),('10318','2013-07-29','11:55:00',8.34),('10318','2013-07-29','12:00:00',8.37),('10318','2013-07-29','12:05:00',8.45),('10318','2013-07-29','12:10:00',8.47),('10318','2013-07-29','12:15:00',8.52),('10318','2013-07-29','12:20:00',8.48),('10318','2013-07-29','12:25:00',8.47),('10318','2013-07-29','12:30:00',8.44),('10318','2013-07-29','12:35:00',8.35),('10318','2013-07-29','12:40:00',8.33),('10318','2013-07-29','12:45:00',8.32),('10318','2013-07-29','12:50:00',8.27),('10318','2013-07-29','12:55:00',8.33),('10318','2013-07-29','13:00:00',7.35),('10318','2013-07-29','13:05:00',8.58),('10318','2013-07-29','13:10:00',8.47),('10318','2013-07-29','13:15:00',8.43),('10318','2013-07-29','13:20:00',8.52),('10318','2013-07-29','13:25:00',8.46),('10318','2013-07-29','13:30:00',8.52),('10318','2013-07-29','13:35:00',8.52),('10318','2013-07-29','13:40:00',8.48),('10318','2013-07-29','13:45:00',8.48),('10318','2013-07-29','13:50:00',8.42),('10318','2013-07-29','13:55:00',8.39),('10318','2013-07-29','14:00:00',8.32),('10318','2013-07-29','14:05:00',8.27),('10318','2013-07-29','14:10:00',8.24),('10318','2013-07-29','14:15:00',8.19),('10318','2013-07-29','14:20:00',8.11),('10318','2013-07-29','14:25:00',8.02),('10318','2013-07-29','14:30:00',7.95),('10318','2013-07-29','14:35:00',7.84),('10318','2013-07-29','14:40:00',7.8),('10318','2013-07-29','14:45:00',7.56),('10318','2013-07-29','14:50:00',7.64),('10318','2013-07-29','14:55:00',7.54),('10318','2013-07-29','15:00:00',7.43),('10318','2013-07-29','15:05:00',7.34),('10318','2013-07-29','15:10:00',7.27),('10318','2013-07-29','15:15:00',7.06),('10318','2013-07-29','15:20:00',7.1),('10318','2013-07-29','15:25:00',6.99),('10318','2013-07-29','15:30:00',6.92),('10318','2013-07-29','15:35:00',6.85),('10318','2013-07-29','15:40:00',6.94),('10318','2013-07-29','15:45:00',5.64),('10318','2013-07-29','15:50:00',5.19),('10318','2013-07-29','15:55:00',3.5),('10318','2013-07-29','16:00:00',3.84),('10318','2013-07-29','16:05:00',6.68),('10318','2013-07-29','16:10:00',5.86),('10318','2013-07-29','16:15:00',5.38),('10318','2013-07-29','16:20:00',4.49),('10318','2013-07-29','16:25:00',5.21),('10318','2013-07-29','16:30:00',5.65),('10318','2013-07-29','16:35:00',4.64),('10318','2013-07-29','16:40:00',5.45),('10318','2013-07-29','16:45:00',5.33),('10318','2013-07-29','16:50:00',3.96),('10318','2013-07-29','16:55:00',2.94),('10318','2013-07-29','17:00:00',2.66),('10318','2013-07-29','17:05:00',3.9),('10318','2013-07-29','17:10:00',2.63),('10318','2013-07-29','17:15:00',3.24),('10318','2013-07-29','17:20:00',4),('10318','2013-07-29','17:25:00',2.98),('10318','2013-07-29','17:30:00',1.87),('10318','2013-07-29','17:35:00',1.44),('10318','2013-07-29','17:40:00',2.33),('10318','2013-07-29','17:45:00',3.24),('10318','2013-07-29','17:50:00',2.53),('10318','2013-07-29','17:55:00',2.12),('10318','2013-07-29','18:00:00',1.33),('10318','2013-07-29','18:05:00',1.72),('10318','2013-07-29','18:10:00',2.07),('10318','2013-07-29','18:15:00',1.77),('10318','2013-07-29','18:20:00',1.87),('10318','2013-07-29','18:25:00',1.89),('10318','2013-07-29','18:30:00',1.65),('10318','2013-07-29','18:35:00',1.43),('10318','2013-07-29','18:55:00',1.12),('10318','2013-07-29','19:00:00',1.24),('10318','2013-07-29','19:05:00',1.15),('10318','2013-07-28','07:15:00',1.21),('10318','2013-07-28','07:20:00',1.47),('10318','2013-07-28','07:25:00',1.68),('10318','2013-07-28','07:30:00',1.76),('10318','2013-07-28','07:35:00',2.06),('10318','2013-07-28','07:40:00',2.31),('10318','2013-07-28','07:45:00',2.47),('10318','2013-07-28','07:50:00',2.67),('10318','2013-07-28','07:55:00',2.86),('10318','2013-07-28','08:00:00',3.06),('10318','2013-07-28','08:05:00',3.23),('10318','2013-07-28','08:10:00',3.29),('10318','2013-07-28','08:15:00',3.58),('10318','2013-07-28','08:20:00',3.73),('10318','2013-07-28','08:25:00',3.92),('10318','2013-07-28','08:30:00',4.12),('10318','2013-07-28','08:35:00',4.32),('10318','2013-07-28','08:40:00',4.49),('10318','2013-07-28','08:45:00',4.67),('10318','2013-07-28','08:50:00',4.86),('10318','2013-07-28','08:55:00',5),('10318','2013-07-28','09:00:00',5.2),('10318','2013-07-28','09:05:00',5.35),('10318','2013-07-28','09:10:00',5.5),('10318','2013-07-28','09:15:00',5.65),('10318','2013-07-28','09:20:00',5.82),('10318','2013-07-28','09:25:00',5.97),('10318','2013-07-28','09:30:00',6.07),('10318','2013-07-28','09:35:00',6.17),('10318','2013-07-28','09:40:00',6.38),('10318','2013-07-28','09:45:00',6.44),('10318','2013-07-28','09:50:00',6.58),('10318','2013-07-28','09:55:00',6.56),('10318','2013-07-28','10:00:00',6.76),('10318','2013-07-28','10:05:00',6.87),('10318','2013-07-28','10:10:00',7.02),('10318','2013-07-28','10:15:00',7.11),('10318','2013-07-28','10:20:00',7.22),('10318','2013-07-28','10:25:00',7.28),('10318','2013-07-28','10:30:00',7.4),('10318','2013-07-28','10:35:00',7.51),('10318','2013-07-28','10:40:00',7.59),('10318','2013-07-28','10:45:00',7.63),('10318','2013-07-28','10:50:00',7.72),('10318','2013-07-28','10:55:00',7.83),('10318','2013-07-28','11:00:00',7.93),('10318','2013-07-28','11:05:00',8),('10318','2013-07-28','11:10:00',7.97),('10318','2013-07-28','11:15:00',8.05),('10318','2013-07-28','11:20:00',8.13),('10318','2013-07-28','11:25:00',8.13),('10318','2013-07-28','11:30:00',8.09),('10318','2013-07-28','11:35:00',8.05),('10318','2013-07-28','11:40:00',7.99),('10318','2013-07-28','11:45:00',8.08),('10318','2013-07-28','11:50:00',7.96),('10318','2013-07-28','11:55:00',8.24),('10318','2013-07-28','12:00:00',8.18),('10318','2013-07-28','12:05:00',8.22),('10318','2013-07-28','12:10:00',8.32),('10318','2013-07-28','12:15:00',8.5),('10318','2013-07-28','12:20:00',8.46),('10318','2013-07-28','12:25:00',8.38),('10318','2013-07-28','12:30:00',8.47),('10318','2013-07-28','12:35:00',8.56),('10318','2013-07-28','12:40:00',8.5),('10318','2013-07-28','12:45:00',8.56),('10318','2013-07-28','12:50:00',8.75),('10318','2013-07-28','12:55:00',8.66),('10318','2013-07-28','13:00:00',8.73),('10318','2013-07-28','13:05:00',8.54),('10318','2013-07-28','13:10:00',8.48),('10318','2013-07-28','13:15:00',8.48),('10318','2013-07-28','13:20:00',8.65),('10318','2013-07-28','13:25:00',8.58),('10318','2013-07-28','13:30:00',8.52),('10318','2013-07-28','13:35:00',8.47),('10318','2013-07-28','13:40:00',8.46),('10318','2013-07-28','13:45:00',8.35),('10318','2013-07-28','13:50:00',8.38),('10318','2013-07-28','13:55:00',8.33),('10318','2013-07-28','14:00:00',8.32),('10318','2013-07-28','14:05:00',8.25),('10318','2013-07-28','14:10:00',8.22),('10318','2013-07-28','14:15:00',8.14),('10318','2013-07-28','14:20:00',8.07),('10318','2013-07-28','14:25:00',7.99),('10318','2013-07-28','14:30:00',7.95),('10318','2013-07-28','14:35:00',7.82),('10318','2013-07-28','14:40:00',7.67),('10318','2013-07-28','14:45:00',7.7),('10318','2013-07-28','14:50:00',7.6),('10318','2013-07-28','14:55:00',7.52),('10318','2013-07-28','15:00:00',7.45),('10318','2013-07-28','15:05:00',7.29),('10318','2013-07-28','15:10:00',7.24),('10318','2013-07-28','15:15:00',7.16),('10318','2013-07-28','15:20:00',7.06),('10318','2013-07-28','15:25:00',6.95),('10318','2013-07-28','15:30:00',6.87),('10318','2013-07-28','15:35:00',6.72),('10318','2013-07-28','15:40:00',6.56),('10318','2013-07-28','15:45:00',6.48),('10318','2013-07-28','15:50:00',6.36),('10318','2013-07-28','15:55:00',6.26),('10318','2013-07-28','16:00:00',6.17),('10318','2013-07-28','16:05:00',6.07),('10318','2013-07-28','16:10:00',5.97),('10318','2013-07-28','16:15:00',5.83),('10318','2013-07-28','16:20:00',5.7),('10318','2013-07-28','16:25:00',5.54),('10318','2013-07-28','16:30:00',5.2),('10318','2013-07-28','16:35:00',5.21),('10318','2013-07-28','16:40:00',5.06),('10318','2013-07-28','16:45:00',4.89),('10318','2013-07-28','16:50:00',4.74),('10318','2013-07-28','16:55:00',4.58),('10318','2013-07-28','17:00:00',4.41),('10318','2013-07-28','17:05:00',4.27),('10318','2013-07-28','17:10:00',4.1),('10318','2013-07-28','17:15:00',3.92),('10318','2013-07-28','17:20:00',3.76),('10318','2013-07-28','17:25:00',3.59),('10318','2013-07-28','17:30:00',3.39),('10318','2013-07-28','17:35:00',3.25),('10318','2013-07-28','17:40:00',3.09),('10318','2013-07-28','17:45:00',2.91),('10318','2013-07-28','17:50:00',2.74),('10318','2013-07-28','17:55:00',2.56),('10318','2013-07-28','18:00:00',2.4),('10318','2013-07-28','18:05:00',2.24),('10318','2013-07-28','18:10:00',2.08),('10318','2013-07-28','18:15:00',1.91),('10318','2013-07-28','18:20:00',1.78),('10318','2013-07-28','18:25:00',1.64),('10318','2013-07-28','18:30:00',1.5),('10318','2013-07-28','18:35:00',1.37),('10318','2013-07-28','18:40:00',1.24),('10318','2013-07-28','18:45:00',1.12),('10318','2013-07-28','18:50:00',1.03),('10318','2013-07-27','07:10:00',1.04),('10318','2013-07-27','07:15:00',1.28),('10318','2013-07-27','07:20:00',1.48),('10318','2013-07-27','07:25:00',1.67),('10318','2013-07-27','07:30:00',1.79),('10318','2013-07-27','07:35:00',2.07),('10318','2013-07-27','07:40:00',2.31),('10318','2013-07-27','07:45:00',2.51),('10318','2013-07-27','07:50:00',2.7),('10318','2013-07-27','07:55:00',2.86),('10318','2013-07-27','08:00:00',3.08),('10318','2013-07-27','08:05:00',3.28),('10318','2013-07-27','08:10:00',3.47),('10318','2013-07-27','08:15:00',3.66),('10318','2013-07-27','08:20:00',3.83),('10318','2013-07-27','08:25:00',4.01),('10318','2013-07-27','08:30:00',4.2),('10318','2013-07-27','08:35:00',4.37),('10318','2013-07-27','08:40:00',4.48),('10318','2013-07-27','08:45:00',4.75),('10318','2013-07-27','08:50:00',4.94),('10318','2013-07-27','08:55:00',5.07),('10318','2013-07-27','09:00:00',5.26),('10318','2013-07-27','09:05:00',5.45),('10318','2013-07-27','09:10:00',5.66),('10318','2013-07-27','09:15:00',5.78),('10318','2013-07-27','09:20:00',5.9),('10318','2013-07-27','09:25:00',6.12),('10318','2013-07-27','09:30:00',6.25),('10318','2013-07-27','09:35:00',6.31),('10318','2013-07-27','09:40:00',6.39),('10318','2013-07-27','09:45:00',6.56),('10318','2013-07-27','09:50:00',6.7),('10318','2013-07-27','09:55:00',6.82),('10318','2013-07-27','10:00:00',6.96),('10318','2013-07-27','10:05:00',7.08),('10318','2013-07-27','10:10:00',7.25),('10318','2013-07-27','10:15:00',7.33),('10318','2013-07-27','10:20:00',7.37),('10318','2013-07-27','10:25:00',7.36),('10318','2013-07-27','10:30:00',7.55),('10318','2013-07-27','10:35:00',7.63),('10318','2013-07-27','10:40:00',7.77),('10318','2013-07-27','10:45:00',7.84),('10318','2013-07-27','10:50:00',7.9),('10318','2013-07-27','10:55:00',7.94),('10318','2013-07-27','11:00:00',7.98),('10318','2013-07-27','11:05:00',8),('10318','2013-07-27','11:10:00',8.08),('10318','2013-07-27','11:15:00',8.15),('10318','2013-07-27','11:20:00',8.22),('10318','2013-07-27','11:25:00',8.24),('10318','2013-07-27','11:30:00',8.31),('10318','2013-07-27','11:35:00',8.35),('10318','2013-07-27','11:40:00',8.37),('10318','2013-07-27','11:45:00',8.39),('10318','2013-07-27','11:50:00',8.39),('10318','2013-07-27','11:55:00',8.42),('10318','2013-07-27','12:00:00',8.45),('10318','2013-07-27','12:05:00',8.39),('10318','2013-07-27','12:10:00',8.39),('10318','2013-07-27','12:15:00',8.21),('10318','2013-07-27','12:20:00',8.69),('10318','2013-07-27','12:25:00',8.61),('10318','2013-07-27','12:30:00',8.44),('10318','2013-07-27','12:35:00',8.77),('10318','2013-07-27','12:40:00',8.75),('10318','2013-07-27','12:45:00',8.59),('10318','2013-07-27','12:50:00',8.67),('10318','2013-07-27','12:55:00',8.62),('10318','2013-07-27','13:00:00',8.71),('10318','2013-07-27','13:05:00',8.86),('10318','2013-07-27','13:10:00',8.74),('10318','2013-07-27','13:15:00',8.65),('10318','2013-07-27','13:20:00',8.59),('10318','2013-07-27','13:25:00',8.32),('10318','2013-07-27','13:30:00',8.51),('10318','2013-07-27','13:35:00',8.69),('10318','2013-07-27','13:40:00',8.59),('10318','2013-07-27','13:45:00',8.41),('10318','2013-07-27','13:50:00',8.35),('10318','2013-07-27','13:55:00',8.28),('10318','2013-07-27','14:00:00',8.21),('10318','2013-07-27','14:05:00',8.33),('10318','2013-07-27','14:10:00',8.18),('10318','2013-07-27','14:15:00',8.2),('10318','2013-07-27','14:20:00',8.08),('10318','2013-07-27','14:25:00',7.94),('10318','2013-07-27','14:30:00',7.92),('10318','2013-07-27','14:35:00',7.92),('10318','2013-07-27','14:40:00',7.81),('10318','2013-07-27','14:45:00',7.7),('10318','2013-07-27','14:50:00',7.64),('10318','2013-07-27','14:55:00',7.53),('10318','2013-07-27','15:00:00',7.47),('10318','2013-07-27','15:05:00',7.34),('10318','2013-07-27','15:10:00',7.14),('10318','2013-07-27','15:15:00',7.19),('10318','2013-07-27','15:20:00',7.09),('10318','2013-07-27','15:25:00',7.02),('10318','2013-07-27','15:30:00',6.92),('10318','2013-07-27','15:35:00',6.81),('10318','2013-07-27','15:40:00',6.66),('10318','2013-07-27','15:45:00',6.56),('10318','2013-07-27','15:50:00',6.46),('10318','2013-07-27','15:55:00',6.35),('10318','2013-07-27','16:00:00',6.21),('10318','2013-07-27','16:05:00',6.03),('10318','2013-07-27','16:10:00',5.88),('10318','2013-07-27','16:15:00',5.77),('10318','2013-07-27','16:20:00',5.64),('10318','2013-07-27','16:25:00',5.52),('10318','2013-07-27','16:30:00',5.39),('10318','2013-07-27','16:35:00',5.25),('10318','2013-07-27','16:40:00',5.09),('10318','2013-07-27','16:45:00',4.9),('10318','2013-07-27','16:50:00',4.76),('10318','2013-07-27','16:55:00',4.47),('10318','2013-07-27','17:00:00',4.45),('10318','2013-07-27','17:05:00',4.28),('10318','2013-07-27','17:10:00',4.12),('10318','2013-07-27','17:15:00',3.94),('10318','2013-07-27','17:20:00',3.76),('10318','2013-07-27','17:25:00',3.58),('10318','2013-07-27','17:30:00',3.42),('10318','2013-07-27','17:35:00',3.26),('10318','2013-07-27','17:40:00',3.09),('10318','2013-07-27','17:45:00',2.88),('10318','2013-07-27','17:50:00',2.71),('10318','2013-07-27','17:55:00',2.57),('10318','2013-07-27','18:00:00',2.42),('10318','2013-07-27','18:05:00',2.27),('10318','2013-07-27','18:10:00',2.13),('10318','2013-07-27','18:15:00',1.97),('10318','2013-07-27','18:20:00',1.81),('10318','2013-07-27','18:25:00',1.67),('10318','2013-07-27','18:30:00',1.55),('10318','2013-07-27','18:35:00',1.41),('10318','2013-07-27','18:40:00',1.26),('10318','2013-07-27','18:45:00',1.16),('10318','2013-07-27','18:50:00',1.04),('10318','2013-07-26','07:10:00',1.12),('10318','2013-07-26','07:15:00',1.4),('10318','2013-07-26','07:20:00',1.57),('10318','2013-07-26','07:25:00',1.77),('10318','2013-07-26','07:30:00',1.97),('10318','2013-07-26','07:35:00',2.1),('10318','2013-07-26','07:40:00',2.27),('10318','2013-07-26','07:45:00',2.47),('10318','2013-07-26','07:50:00',2.75),('10318','2013-07-26','07:55:00',3.01),('10318','2013-07-26','08:00:00',3.24),('10318','2013-07-26','08:05:00',3.39),('10318','2013-07-26','08:10:00',3.35),('10318','2013-07-26','08:15:00',3.12),('10318','2013-07-26','08:20:00',3.79),('10318','2013-07-26','08:25:00',3.93),('10318','2013-07-26','08:30:00',4.05),('10318','2013-07-26','08:35:00',4.27),('10318','2013-07-26','08:40:00',4.38),('10318','2013-07-26','08:45:00',4.67),('10318','2013-07-26','08:50:00',4.84),('10318','2013-07-26','08:55:00',4.94),('10318','2013-07-26','09:00:00',5.09),('10318','2013-07-26','09:05:00',5.31),('10318','2013-07-26','09:10:00',5.5),('10318','2013-07-26','09:15:00',5.64),('10318','2013-07-26','09:20:00',5.78),('10318','2013-07-26','09:25:00',5.96),('10318','2013-07-26','09:30:00',6.12),('10318','2013-07-26','09:35:00',6.31),('10318','2013-07-26','09:40:00',6.43),('10318','2013-07-26','09:45:00',6.5),('10318','2013-07-26','09:50:00',6.6),('10318','2013-07-26','09:55:00',6.75),('10318','2013-07-26','10:00:00',6.82),('10318','2013-07-26','10:05:00',6.94),('10318','2013-07-26','10:10:00',7.13),('10318','2013-07-26','10:15:00',7.17),('10318','2013-07-26','10:20:00',7.13),('10318','2013-07-26','10:25:00',7.25),('10318','2013-07-26','10:30:00',7.47),('10318','2013-07-26','10:35:00',7.62),('10318','2013-07-26','10:40:00',7.63),('10318','2013-07-26','10:45:00',7.74),('10318','2013-07-26','10:50:00',7.81),('10318','2013-07-26','10:55:00',7.81),('10318','2013-07-26','11:00:00',7.96),('10318','2013-07-26','11:05:00',8.01),('10318','2013-07-26','11:10:00',8.07),('10318','2013-07-26','11:15:00',8.15),('10318','2013-07-26','11:20:00',8.21),('10318','2013-07-26','11:25:00',8.21),('10318','2013-07-26','11:30:00',8.18),('10318','2013-07-26','11:35:00',8.18),('10318','2013-07-26','11:40:00',8.36),('10318','2013-07-26','11:45:00',8.47),('10318','2013-07-26','11:50:00',8.75),('10318','2013-07-26','11:55:00',8.49),('10318','2013-07-26','12:00:00',8.95),('10318','2013-07-26','12:05:00',8.7),('10318','2013-07-26','12:10:00',6.25),('10318','2013-07-26','12:15:00',5.32),('10318','2013-07-26','12:20:00',9.46),('10318','2013-07-26','12:25:00',9.06),('10318','2013-07-26','12:30:00',9.04),('10318','2013-07-26','12:35:00',7.59),('10318','2013-07-26','12:40:00',4.96),('10318','2013-07-26','12:45:00',3.29),('10318','2013-07-26','12:50:00',5.7),('10318','2013-07-26','12:55:00',6.7),('10318','2013-07-26','13:00:00',8.78),('10318','2013-07-26','13:05:00',9.35),('10318','2013-07-26','13:10:00',8.9),('10318','2013-07-26','13:15:00',8.31),('10318','2013-07-26','13:20:00',8.39),('10318','2013-07-26','13:25:00',8.29),('10318','2013-07-26','13:30:00',4.92),('10318','2013-07-26','13:35:00',5.07),('10318','2013-07-26','13:40:00',9.2),('10318','2013-07-26','13:45:00',9.09),('10318','2013-07-26','13:50:00',8.52),('10318','2013-07-26','13:55:00',8.58),('10318','2013-07-26','14:00:00',8.8),('10318','2013-07-26','14:05:00',8.36),('10318','2013-07-26','14:10:00',8.54),('10318','2013-07-26','14:15:00',8.52),('10318','2013-07-26','14:20:00',8.14),('10318','2013-07-26','14:25:00',8.18),('10318','2013-07-26','14:30:00',8.04),('10318','2013-07-26','14:35:00',7.98),('10318','2013-07-26','14:40:00',7.93),('10318','2013-07-26','14:45:00',7.72),('10318','2013-07-26','14:50:00',7.8),('10318','2013-07-26','14:55:00',7.68),('10318','2013-07-26','15:00:00',7.57),('10318','2013-07-26','15:05:00',7.49),('10318','2013-07-26','15:10:00',7.35),('10318','2013-07-26','15:15:00',7.27),('10318','2013-07-26','15:20:00',7.2),('10318','2013-07-26','15:25:00',7.07),('10318','2013-07-26','15:30:00',6.89),('10318','2013-07-26','15:35:00',6.84),('10318','2013-07-26','15:40:00',6.69),('10318','2013-07-26','15:45:00',6.65),('10318','2013-07-26','15:50:00',6.47),('10318','2013-07-26','15:55:00',6.36),('10318','2013-07-26','16:00:00',6.24),('10318','2013-07-26','16:05:00',6.1),('10318','2013-07-26','16:10:00',6),('10318','2013-07-26','16:15:00',5.86),('10318','2013-07-26','16:20:00',5.7),('10318','2013-07-26','16:25:00',5.56),('10318','2013-07-26','16:30:00',5.41),('10318','2013-07-26','16:35:00',5.25),('10318','2013-07-26','16:40:00',5.11),('10318','2013-07-26','16:45:00',4.95),('10318','2013-07-26','16:50:00',4.78),('10318','2013-07-26','16:55:00',4.61),('10318','2013-07-26','17:00:00',4.48),('10318','2013-07-26','17:05:00',4.33),('10318','2013-07-26','17:10:00',4.05),('10318','2013-07-26','17:15:00',3.97),('10318','2013-07-26','17:20:00',3.82),('10318','2013-07-26','17:25:00',3.63),('10318','2013-07-26','17:30:00',3.42),('10318','2013-07-26','17:35:00',3.27),('10318','2013-07-26','17:40:00',3.12),('10318','2013-07-26','17:45:00',2.92),('10318','2013-07-26','17:50:00',2.75),('10318','2013-07-26','17:55:00',2.5),('10318','2013-07-26','18:00:00',2.44),('10318','2013-07-26','18:05:00',2.24),('10318','2013-07-26','18:10:00',2.11),('10318','2013-07-26','18:15:00',1.97),('10318','2013-07-26','18:20:00',1.81),('10318','2013-07-26','18:25:00',1.69),('10318','2013-07-26','18:30:00',1.56),('10318','2013-07-26','18:35:00',1.43),('10318','2013-07-26','18:40:00',1.29),('10318','2013-07-26','18:45:00',1.19),('10318','2013-07-26','18:50:00',1.09),('10318','2013-07-25','07:10:00',1.08),('10318','2013-07-25','07:15:00',1.33),('10318','2013-07-25','07:20:00',1.51),('10318','2013-07-25','07:25:00',1.7),('10318','2013-07-25','07:30:00',1.86),('10318','2013-07-25','07:35:00',2.13),('10318','2013-07-25','07:40:00',2.34),('10318','2013-07-25','07:45:00',2.5),('10318','2013-07-25','07:50:00',2.67),('10318','2013-07-25','07:55:00',2.86),('10318','2013-07-25','08:00:00',3.04),('10318','2013-07-25','08:05:00',3.2),('10318','2013-07-25','08:10:00',3.45),('10318','2013-07-25','08:15:00',3.61),('10318','2013-07-25','08:20:00',3.75),('10318','2013-07-25','08:25:00',3.87),('10318','2013-07-25','08:30:00',4.07),('10318','2013-07-25','08:35:00',4.28),('10318','2013-07-25','08:40:00',4.33),('10318','2013-07-25','08:45:00',4.57),('10318','2013-07-25','08:50:00',4.83),('10318','2013-07-25','08:55:00',4.98),('10318','2013-07-25','09:00:00',5.18),('10318','2013-07-25','09:05:00',5.49),('10318','2013-07-25','09:10:00',5.59),('10318','2013-07-25','09:15:00',5.95),('10318','2013-07-25','09:20:00',6.41),('10318','2013-07-25','09:25:00',6.46),('10318','2013-07-25','09:30:00',5.13),('10318','2013-07-25','09:35:00',4.45),('10318','2013-07-25','09:40:00',3.64),('10318','2013-07-25','09:45:00',2.59),('10318','2013-07-25','09:50:00',5.37),('10318','2013-07-25','09:55:00',7.01),('10318','2013-07-25','10:00:00',6.92),('10318','2013-07-25','10:05:00',6.76),('10318','2013-07-25','10:10:00',7.35),('10318','2013-07-25','10:15:00',7.46),('10318','2013-07-25','10:20:00',7.58),('10318','2013-07-25','10:25:00',7.94),('10318','2013-07-25','10:30:00',7.06),('10318','2013-07-25','10:35:00',7.58),('10318','2013-07-25','10:40:00',7.14),('10318','2013-07-25','10:45:00',5.5),('10318','2013-07-25','10:50:00',5.33),('10318','2013-07-25','10:55:00',8.61),('10318','2013-07-25','11:00:00',8.37),('10318','2013-07-25','11:05:00',8.32),('10318','2013-07-25','11:10:00',8.23),('10318','2013-07-25','11:15:00',6.48),('10318','2013-07-25','11:20:00',6.75),('10318','2013-07-25','11:25:00',8.71),('10318','2013-07-25','11:30:00',8.57),('10318','2013-07-25','11:35:00',8.64),('10318','2013-07-25','11:40:00',5.16),('10318','2013-07-25','11:45:00',9.05),('10318','2013-07-25','11:50:00',8.45),('10318','2013-07-25','11:55:00',8.39),('10318','2013-07-25','12:00:00',8.74),('10318','2013-07-25','12:05:00',8.91),('10318','2013-07-25','12:10:00',8.64),('10318','2013-07-25','12:15:00',5.02),('10318','2013-07-25','12:20:00',3.14),('10318','2013-07-25','12:25:00',2.23),('10318','2013-07-25','12:30:00',1.9),('10318','2013-07-25','12:35:00',5.86),('10318','2013-07-25','12:40:00',9.5),('10318','2013-07-25','12:45:00',8.78),('10318','2013-07-25','12:50:00',8.42),('10318','2013-07-25','12:55:00',9.13),('10318','2013-07-25','13:00:00',9.04),('10318','2013-07-25','13:05:00',7.28),('10318','2013-07-25','13:10:00',8.84),('10318','2013-07-25','13:15:00',8.99),('10318','2013-07-25','13:20:00',9),('10318','2013-07-25','13:25:00',8.91),('10318','2013-07-25','13:30:00',8.88),('10318','2013-07-25','13:35:00',8.86),('10318','2013-07-25','13:40:00',8.84),('10318','2013-07-25','13:45:00',8.8),('10318','2013-07-25','13:50:00',8.76),('10318','2013-07-25','13:55:00',8.73),('10318','2013-07-25','14:00:00',8.73),('10318','2013-07-25','14:05:00',8.67),('10318','2013-07-25','14:10:00',8.58),('10318','2013-07-25','14:15:00',8.54),('10318','2013-07-25','14:20:00',8.51),('10318','2013-07-25','14:25:00',8.43),('10318','2013-07-25','14:30:00',8.29),('10318','2013-07-25','14:35:00',8.31),('10318','2013-07-25','14:40:00',8.2),('10318','2013-07-25','14:45:00',8.12),('10318','2013-07-25','14:50:00',7.97),('10318','2013-07-25','14:55:00',7.9),('10318','2013-07-25','15:00:00',7.8),('10318','2013-07-25','15:05:00',7.78),('10318','2013-07-25','15:10:00',7.7),('10318','2013-07-25','15:15:00',7.58),('10318','2013-07-25','15:20:00',7.46),('10318','2013-07-25','15:25:00',7.41),('10318','2013-07-25','15:30:00',7.28),('10318','2013-07-25','15:35:00',7.16),('10318','2013-07-25','15:40:00',7.09),('10318','2013-07-25','15:45:00',6.94),('10318','2013-07-25','15:50:00',6.75),('10318','2013-07-25','15:55:00',6.67),('10318','2013-07-25','16:00:00',6.58),('10318','2013-07-25','16:05:00',6.4),('10318','2013-07-25','16:10:00',6.27),('10318','2013-07-25','16:15:00',6.1),('10318','2013-07-25','16:20:00',5.95),('10318','2013-07-25','16:25:00',5.78),('10318','2013-07-25','16:30:00',5.65),('10318','2013-07-25','16:35:00',5.53),('10318','2013-07-25','16:40:00',5.34),('10318','2013-07-25','16:45:00',5.18),('10318','2013-07-25','16:50:00',5.03),('10318','2013-07-25','16:55:00',4.84),('10318','2013-07-25','17:00:00',4.66),('10318','2013-07-25','17:05:00',4.5),('10318','2013-07-25','17:10:00',4.3),('10318','2013-07-25','17:15:00',4.12),('10318','2013-07-25','17:20:00',3.94),('10318','2013-07-25','17:25:00',3.72),('10318','2013-07-25','17:30:00',3.55),('10318','2013-07-25','17:35:00',3.38),('10318','2013-07-25','17:40:00',3.24),('10318','2013-07-25','17:45:00',3.02),('10318','2013-07-25','17:50:00',2.87),('10318','2013-07-25','17:55:00',2.68),('10318','2013-07-25','18:00:00',2.54),('10318','2013-07-25','18:05:00',2.33),('10318','2013-07-25','18:10:00',2.14),('10318','2013-07-25','18:15:00',2.02),('10318','2013-07-25','18:20:00',1.88),('10318','2013-07-25','18:25:00',1.73),('10318','2013-07-25','18:30:00',1.55),('10318','2013-07-25','18:35:00',1.41),('10318','2013-07-25','18:40:00',1.29),('10318','2013-07-25','18:45:00',1.2),('10318','2013-07-25','18:50:00',1.08),('10318','2013-07-24','07:20:00',1.18),('10318','2013-07-24','07:25:00',1.71),('10318','2013-07-24','07:30:00',2.38),('10318','2013-07-24','07:35:00',1.89),('10318','2013-07-24','07:40:00',1.39),('10318','2013-07-24','07:45:00',1.34),('10318','2013-07-24','07:50:00',1.66),('10318','2013-07-24','07:55:00',1.83),('10318','2013-07-24','08:00:00',2.19),('10318','2013-07-24','08:05:00',2.71),('10318','2013-07-24','08:10:00',2.67),('10318','2013-07-24','08:15:00',3.77),('10318','2013-07-24','08:20:00',2.72),('10318','2013-07-24','08:25:00',2.38),('10318','2013-07-24','08:30:00',2.33),('10318','2013-07-24','08:35:00',2.85),('10318','2013-07-24','08:40:00',2.47),('10318','2013-07-24','08:45:00',4.11),('10318','2013-07-24','08:50:00',5.3),('10318','2013-07-24','08:55:00',4.38),('10318','2013-07-24','09:00:00',4.27),('10318','2013-07-24','09:05:00',5.16),('10318','2013-07-24','09:10:00',3.1),('10318','2013-07-24','09:15:00',3.65),('10318','2013-07-24','09:20:00',4.68),('10318','2013-07-24','09:25:00',4.23),('10318','2013-07-24','09:30:00',3.17),('10318','2013-07-24','09:35:00',6.95),('10318','2013-07-24','09:40:00',6.53),('10318','2013-07-24','09:45:00',3.12),('10318','2013-07-24','09:50:00',3.23),('10318','2013-07-24','09:55:00',3.63),('10318','2013-07-24','10:00:00',3.91),('10318','2013-07-24','10:05:00',8.25),('10318','2013-07-24','10:10:00',7.19),('10318','2013-07-24','10:15:00',6.12),('10318','2013-07-24','10:20:00',6.95),('10318','2013-07-24','10:25:00',6.28),('10318','2013-07-24','10:30:00',7.25),('10318','2013-07-24','10:35:00',4.5),('10318','2013-07-24','10:40:00',6.78),('10318','2013-07-24','10:45:00',3.66),('10318','2013-07-24','10:50:00',8.62),('10318','2013-07-24','10:55:00',8.53),('10318','2013-07-24','11:00:00',8.84),('10318','2013-07-24','11:05:00',9.07),('10318','2013-07-24','11:10:00',7.82),('10318','2013-07-24','11:15:00',8.74),('10318','2013-07-24','11:20:00',5.91),('10318','2013-07-24','11:25:00',3.48),('10318','2013-07-24','11:30:00',8.17),('10318','2013-07-24','11:35:00',9.02),('10318','2013-07-24','11:40:00',9.02),('10318','2013-07-24','11:45:00',9.21),('10318','2013-07-24','11:50:00',6.69),('10318','2013-07-24','11:55:00',3.04),('10318','2013-07-24','12:00:00',7.1),('10318','2013-07-24','12:05:00',3.93),('10318','2013-07-24','12:10:00',6.84),('10318','2013-07-24','12:15:00',9.99),('10318','2013-07-24','12:20:00',9.64),('10318','2013-07-24','12:25:00',9.43),('10318','2013-07-24','12:30:00',9.43),('10318','2013-07-24','12:35:00',9.56),('10318','2013-07-24','12:40:00',8.02),('10318','2013-07-24','12:45:00',6.7),('10318','2013-07-24','12:50:00',4.45),('10318','2013-07-24','12:55:00',9.08),('10318','2013-07-24','13:00:00',9.29),('10318','2013-07-24','13:05:00',9.07),('10318','2013-07-24','13:10:00',9.06),('10318','2013-07-24','13:15:00',9.24),('10318','2013-07-24','13:20:00',9.37),('10318','2013-07-24','13:25:00',9.13),('10318','2013-07-24','13:30:00',9.07),('10318','2013-07-24','13:35:00',8.99),('10318','2013-07-24','13:40:00',8.69),('10318','2013-07-24','13:45:00',8.88),('10318','2013-07-24','13:50:00',8.9),('10318','2013-07-24','13:55:00',8.81),('10318','2013-07-24','14:00:00',8.81),('10318','2013-07-24','14:05:00',8.93),('10318','2013-07-24','14:10:00',8.86),('10318','2013-07-24','14:15:00',8.81),('10318','2013-07-24','14:20:00',8.67),('10318','2013-07-24','14:25:00',8.73),('10318','2013-07-24','14:30:00',8.7),('10318','2013-07-24','14:35:00',8.63),('10318','2013-07-24','14:40:00',8.54),('10318','2013-07-24','14:45:00',8.46),('10318','2013-07-24','14:50:00',8.34),('10318','2013-07-24','14:55:00',8.23),('10318','2013-07-24','15:00:00',8.05),('10318','2013-07-24','15:05:00',7.89),('10318','2013-07-24','15:10:00',7.73),('10318','2013-07-24','15:15:00',7.7),('10318','2013-07-24','15:20:00',7.62),('10318','2013-07-24','15:25:00',7.35),('10318','2013-07-24','15:30:00',6.97),('10318','2013-07-24','15:35:00',7.25),('10318','2013-07-24','15:40:00',7.16),('10318','2013-07-24','15:45:00',6.8),('10318','2013-07-24','15:50:00',6.66),('10318','2013-07-24','15:55:00',6.67),('10318','2013-07-24','16:00:00',6.39),('10318','2013-07-24','16:05:00',6.25),('10318','2013-07-24','16:10:00',6.25),('10318','2013-07-24','16:15:00',6.42),('10318','2013-07-24','16:20:00',6.27),('10318','2013-07-24','16:25:00',6.01),('10318','2013-07-24','16:30:00',5.9),('10318','2013-07-24','16:35:00',5.8),('10318','2013-07-24','16:40:00',5.36),('10318','2013-07-24','16:45:00',5.39),('10318','2013-07-24','16:50:00',5.53),('10318','2013-07-24','16:55:00',5.37),('10318','2013-07-24','17:00:00',5.17),('10318','2013-07-24','17:05:00',4.82),('10318','2013-07-24','17:10:00',4.67),('10318','2013-07-24','17:15:00',4.4),('10318','2013-07-24','17:20:00',4.09),('10318','2013-07-24','17:25:00',3.89),('10318','2013-07-24','17:30:00',3.69),('10318','2013-07-24','17:35:00',3.47),('10318','2013-07-24','17:40:00',3.27),('10318','2013-07-24','17:45:00',3.09),('10318','2013-07-24','17:50:00',2.93),('10318','2013-07-24','17:55:00',2.72),('10318','2013-07-24','18:00:00',2.56),('10318','2013-07-24','18:05:00',2.38),('10318','2013-07-24','18:10:00',2.25),('10318','2013-07-24','18:15:00',2.09),('10318','2013-07-24','18:20:00',1.9),('10318','2013-07-24','18:25:00',1.7),('10318','2013-07-24','18:30:00',1.45),('10318','2013-07-24','18:35:00',1.11),('10318','2013-07-24','18:40:00',1.38),('10318','2013-07-24','18:45:00',1.25),('10318','2013-07-24','18:50:00',1.07),('10318','2013-07-23','07:10:00',1.25),('10318','2013-07-23','07:15:00',1.47),('10318','2013-07-23','07:20:00',1.77),('10318','2013-07-23','07:25:00',1.98),('10318','2013-07-23','07:30:00',2.2),('10318','2013-07-23','07:35:00',2.48),('10318','2013-07-23','07:40:00',2.69),('10318','2013-07-23','07:45:00',2.87),('10318','2013-07-23','07:50:00',3.05),('10318','2013-07-23','07:55:00',3.26),('10318','2013-07-23','08:00:00',3.44),('10318','2013-07-23','08:05:00',3.62),('10318','2013-07-23','08:10:00',3.81),('10318','2013-07-23','08:15:00',3.99),('10318','2013-07-23','08:20:00',4.18),('10318','2013-07-23','08:25:00',4.38),('10318','2013-07-23','08:30:00',4.55),('10318','2013-07-23','08:35:00',4.72),('10318','2013-07-23','08:40:00',4.91),('10318','2013-07-23','08:45:00',5.09),('10318','2013-07-23','08:50:00',5.25),('10318','2013-07-23','08:55:00',5.41),('10318','2013-07-23','09:00:00',5.57),('10318','2013-07-23','09:05:00',5.7),('10318','2013-07-23','09:10:00',5.83),('10318','2013-07-23','09:15:00',5.98),('10318','2013-07-23','09:20:00',6.06),('10318','2013-07-23','09:25:00',6.15),('10318','2013-07-23','09:30:00',6.3),('10318','2013-07-23','09:35:00',6.46),('10318','2013-07-23','09:40:00',6.56),('10318','2013-07-23','09:45:00',6.66),('10318','2013-07-23','09:50:00',6.77),('10318','2013-07-23','09:55:00',6.92),('10318','2013-07-23','10:00:00',7.03),('10318','2013-07-23','10:05:00',7.08),('10318','2013-07-23','10:10:00',7.16),('10318','2013-07-23','10:15:00',7.2),('10318','2013-07-23','10:20:00',7.32),('10318','2013-07-23','10:25:00',7.49),('10318','2013-07-23','10:30:00',7.68),('10318','2013-07-23','10:35:00',7.61),('10318','2013-07-23','10:40:00',7.85),('10318','2013-07-23','10:45:00',7.92),('10318','2013-07-23','10:50:00',8.04),('10318','2013-07-23','10:55:00',8.16),('10318','2013-07-23','11:00:00',8.17),('10318','2013-07-23','11:05:00',8.2),('10318','2013-07-23','11:10:00',8.38),('10318','2013-07-23','11:15:00',8.54),('10318','2013-07-23','11:20:00',8.52),('10318','2013-07-23','11:25:00',8.56),('10318','2013-07-23','11:30:00',8.7),('10318','2013-07-23','11:35:00',8.91),('10318','2013-07-23','11:40:00',9.18),('10318','2013-07-23','11:45:00',9.33),('10318','2013-07-23','11:50:00',9.14),('10318','2013-07-23','11:55:00',9.07),('10318','2013-07-23','12:00:00',9.17),('10318','2013-07-23','12:05:00',7.39),('10318','2013-07-23','12:10:00',2.82),('10318','2013-07-23','12:15:00',3.07),('10318','2013-07-23','12:20:00',3.09),('10318','2013-07-23','12:25:00',2.21),('10318','2013-07-23','12:30:00',2.03),('10318','2013-07-23','12:35:00',2.95),('10318','2013-07-23','12:40:00',9.68),('10318','2013-07-23','12:45:00',6.45),('10318','2013-07-23','12:50:00',1.83),('10318','2013-07-23','12:55:00',1.93),('10318','2013-07-23','13:00:00',1.86),('10318','2013-07-23','13:05:00',1.9),('10318','2013-07-23','13:10:00',1.31),('10318','2013-07-23','13:15:00',1.12),('10318','2013-07-23','13:20:00',5.44),('10318','2013-07-23','13:25:00',9.58),('10318','2013-07-23','13:30:00',3.81),('10318','2013-07-23','13:35:00',1.96),('10318','2013-07-23','13:40:00',8.93),('10318','2013-07-23','13:45:00',5.69),('10318','2013-07-23','13:50:00',1.49),('10318','2013-07-23','13:55:00',2.15),('10318','2013-07-23','14:00:00',3.87),('10318','2013-07-23','14:05:00',5.2),('10318','2013-07-23','14:10:00',8.55),('10318','2013-07-23','14:15:00',2.86),('10318','2013-07-23','14:20:00',2.58),('10318','2013-07-23','14:25:00',3.41),('10318','2013-07-23','14:30:00',6.92),('10318','2013-07-23','14:35:00',9.03),('10318','2013-07-23','14:40:00',3.65),('10318','2013-07-23','14:45:00',7.67),('10318','2013-07-23','14:50:00',8.98),('10318','2013-07-23','14:55:00',8.8),('10318','2013-07-23','15:00:00',8.5),('10318','2013-07-23','15:05:00',8.13),('10318','2013-07-23','15:10:00',8),('10318','2013-07-23','15:15:00',7.84),('10318','2013-07-23','15:20:00',7.53),('10318','2013-07-23','15:25:00',7.25),('10318','2013-07-23','15:30:00',7.2),('10318','2013-07-23','15:35:00',7.11),('10318','2013-07-23','15:40:00',6.85),('10318','2013-07-23','15:45:00',6.78),('10318','2013-07-23','15:50:00',6.62),('10318','2013-07-23','15:55:00',6.65),('10318','2013-07-23','16:00:00',6.37),('10318','2013-07-23','16:05:00',6.31),('10318','2013-07-23','16:10:00',6.21),('10318','2013-07-23','16:15:00',6.07),('10318','2013-07-23','16:20:00',5.9),('10318','2013-07-23','16:25:00',5.76),('10318','2013-07-23','16:30:00',5.54),('10318','2013-07-23','16:35:00',5.39),('10318','2013-07-23','16:40:00',5.25),('10318','2013-07-23','16:45:00',5.08),('10318','2013-07-23','16:50:00',4.93),('10318','2013-07-23','16:55:00',4.77),('10318','2013-07-23','17:00:00',4.6),('10318','2013-07-23','17:05:00',4.36),('10318','2013-07-23','17:10:00',4.26),('10318','2013-07-23','17:15:00',4.13),('10318','2013-07-23','17:20:00',3.97),('10318','2013-07-23','17:25:00',3.82),('10318','2013-07-23','17:30:00',3.64),('10318','2013-07-23','17:35:00',3.47),('10318','2013-07-23','17:40:00',3.35),('10318','2013-07-23','17:45:00',3.15),('10318','2013-07-23','17:50:00',2.95),('10318','2013-07-23','17:55:00',2.76),('10318','2013-07-23','18:00:00',2.62),('10318','2013-07-23','18:05:00',2.46),('10318','2013-07-23','18:10:00',2.3),('10318','2013-07-23','18:15:00',2.13),('10318','2013-07-23','18:20:00',1.95),('10318','2013-07-23','18:25:00',1.81),('10318','2013-07-23','18:30:00',1.67),('10318','2013-07-23','18:35:00',1.49),('10318','2013-07-23','18:40:00',1.05),('10318','2013-07-22','07:10:00',1.23),('10318','2013-07-22','07:15:00',1.44),('10318','2013-07-22','07:20:00',1.66),('10318','2013-07-22','07:25:00',1.86),('10318','2013-07-22','07:30:00',2.09),('10318','2013-07-22','07:35:00',2.36),('10318','2013-07-22','07:40:00',2.58),('10318','2013-07-22','07:45:00',2.76),('10318','2013-07-22','07:50:00',2.93),('10318','2013-07-22','07:55:00',3.13),('10318','2013-07-22','08:00:00',3.33),('10318','2013-07-22','08:05:00',3.52),('10318','2013-07-22','08:10:00',3.71),('10318','2013-07-22','08:15:00',3.91),('10318','2013-07-22','08:20:00',4.1),('10318','2013-07-22','08:25:00',4.29),('10318','2013-07-22','08:30:00',4.49),('10318','2013-07-22','08:35:00',4.66),('10318','2013-07-22','08:40:00',4.84),('10318','2013-07-22','08:45:00',5.01),('10318','2013-07-22','08:50:00',5.09),('10318','2013-07-22','08:55:00',5.37),('10318','2013-07-22','09:00:00',5.53),('10318','2013-07-22','09:05:00',5.68),('10318','2013-07-22','09:10:00',5.82),('10318','2013-07-22','09:15:00',5.97),('10318','2013-07-22','09:20:00',6.08),('10318','2013-07-22','09:25:00',6.24),('10318','2013-07-22','09:30:00',6.37),('10318','2013-07-22','09:35:00',6.5),('10318','2013-07-22','09:40:00',6.6),('10318','2013-07-22','09:45:00',6.75),('10318','2013-07-22','09:50:00',6.86),('10318','2013-07-22','09:55:00',7.01),('10318','2013-07-22','10:00:00',7.13),('10318','2013-07-22','10:05:00',7.21),('10318','2013-07-22','10:10:00',7.32),('10318','2013-07-22','10:15:00',7.46),('10318','2013-07-22','10:20:00',7.55),('10318','2013-07-22','10:25:00',7.61),('10318','2013-07-22','10:30:00',7.73),('10318','2013-07-22','10:35:00',7.67),('10318','2013-07-22','10:40:00',7.91),('10318','2013-07-22','10:45:00',7.95),('10318','2013-07-22','10:50:00',8.05),('10318','2013-07-22','10:55:00',8.17),('10318','2013-07-22','11:00:00',8.27),('10318','2013-07-22','11:05:00',8.31),('10318','2013-07-22','11:10:00',8.39),('10318','2013-07-22','11:15:00',8.43),('10318','2013-07-22','11:20:00',8.41),('10318','2013-07-22','11:25:00',8.46),('10318','2013-07-22','11:30:00',8.52),('10318','2013-07-22','11:35:00',8.59),('10318','2013-07-22','11:40:00',8.63),('10318','2013-07-22','11:45:00',8.7),('10318','2013-07-22','11:50:00',8.71),('10318','2013-07-22','11:55:00',8.72),('10318','2013-07-22','12:00:00',8.72),('10318','2013-07-22','12:05:00',8.71),('10318','2013-07-22','12:10:00',8.75),('10318','2013-07-22','12:15:00',8.83),('10318','2013-07-22','12:20:00',8.69),('10318','2013-07-22','12:25:00',8.83),('10318','2013-07-22','12:30:00',8.83),('10318','2013-07-22','12:35:00',8.84),('10318','2013-07-22','12:40:00',8.85),('10318','2013-07-22','12:45:00',8.85),('10318','2013-07-22','12:50:00',8.83),('10318','2013-07-22','12:55:00',8.89),('10318','2013-07-22','13:00:00',8.91),('10318','2013-07-22','13:05:00',8.85),('10318','2013-07-22','13:10:00',8.83),('10318','2013-07-22','13:15:00',8.82),('10318','2013-07-22','13:20:00',8.82),('10318','2013-07-22','13:25:00',8.77),('10318','2013-07-22','13:30:00',8.72),('10318','2013-07-22','13:35:00',8.63),('10318','2013-07-22','13:40:00',8.63),('10318','2013-07-22','13:45:00',8.56),('10318','2013-07-22','13:50:00',8.5),('10318','2013-07-22','13:55:00',8.45),('10318','2013-07-22','14:00:00',8.52),('10318','2013-07-22','14:05:00',8.12),('10318','2013-07-22','14:10:00',8.28),('10318','2013-07-22','14:15:00',8.24),('10318','2013-07-22','14:20:00',8.15),('10318','2013-07-22','14:25:00',8.06),('10318','2013-07-22','14:30:00',7.96),('10318','2013-07-22','14:35:00',7.8),('10318','2013-07-22','14:40:00',7.88),('10318','2013-07-22','14:45:00',7.91),('10318','2013-07-22','14:50:00',7.82),('10318','2013-07-22','14:55:00',7.73),('10318','2013-07-22','15:00:00',7.67),('10318','2013-07-22','15:05:00',7.54),('10318','2013-07-22','15:10:00',7.56),('10318','2013-07-22','15:15:00',7.46),('10318','2013-07-22','15:20:00',7.37),('10318','2013-07-22','15:25:00',7.33),('10318','2013-07-22','15:30:00',5.97),('10318','2013-07-22','15:35:00',6.84),('10318','2013-07-22','15:40:00',5.28),('10318','2013-07-22','15:45:00',4.02),('10318','2013-07-22','15:50:00',4.27),('10318','2013-07-22','15:55:00',5.56),('10318','2013-07-22','16:00:00',6.92),('10318','2013-07-22','16:05:00',6.99),('10318','2013-07-22','16:10:00',6.88),('10318','2013-07-22','16:15:00',6.65),('10318','2013-07-22','16:20:00',6.33),('10318','2013-07-22','16:25:00',6.1),('10318','2013-07-22','16:30:00',5.73),('10318','2013-07-22','16:35:00',5.47),('10318','2013-07-22','16:40:00',5.31),('10318','2013-07-22','16:45:00',5),('10318','2013-07-22','16:50:00',4.73),('10318','2013-07-22','16:55:00',4.62),('10318','2013-07-22','17:00:00',4.57),('10318','2013-07-22','17:05:00',4.28),('10318','2013-07-22','17:10:00',4.23),('10318','2013-07-22','17:15:00',4.06),('10318','2013-07-22','17:20:00',3.91),('10318','2013-07-22','17:25:00',3.75),('10318','2013-07-22','17:30:00',3.62),('10318','2013-07-22','17:35:00',3.45),('10318','2013-07-22','17:40:00',3.28),('10318','2013-07-22','17:45:00',3.22),('10318','2013-07-22','17:50:00',2.86),('10318','2013-07-22','17:55:00',2.41),('10318','2013-07-22','18:00:00',2.66),('10318','2013-07-22','18:05:00',2.47),('10318','2013-07-22','18:10:00',2.25),('10318','2013-07-22','18:15:00',2.1),('10318','2013-07-22','18:20:00',1.87),('10318','2013-07-22','18:25:00',1.64),('10318','2013-07-22','18:30:00',1.7),('10318','2013-07-22','18:35:00',1.58),('10318','2013-07-22','18:40:00',1.42),('10318','2013-07-22','18:45:00',1.25),('10318','2013-07-22','18:50:00',1.12),('10318','2013-07-22','18:55:00',1.02),('10318','2013-07-21','07:10:00',1.25),('10318','2013-07-21','07:15:00',1.46),('10318','2013-07-21','07:20:00',1.64),('10318','2013-07-21','07:25:00',1.83),('10318','2013-07-21','07:30:00',2.06),('10318','2013-07-21','07:35:00',2.35),('10318','2013-07-21','07:40:00',2.59),('10318','2013-07-21','07:45:00',2.82),('10318','2013-07-21','07:50:00',2.95),('10318','2013-07-21','07:55:00',3.08),('10318','2013-07-21','08:00:00',3.21),('10318','2013-07-21','08:05:00',3.32),('10318','2013-07-21','08:10:00',3.56),('10318','2013-07-21','08:15:00',3.74),('10318','2013-07-21','08:20:00',3.92),('10318','2013-07-21','08:25:00',4.12),('10318','2013-07-21','08:30:00',4.3),('10318','2013-07-21','08:35:00',4.47),('10318','2013-07-21','08:40:00',4.64),('10318','2013-07-21','08:45:00',4.79),('10318','2013-07-21','08:50:00',4.81),('10318','2013-07-21','08:55:00',5.16),('10318','2013-07-21','09:00:00',5.32),('10318','2013-07-21','09:05:00',5.48),('10318','2013-07-21','09:10:00',5.67),('10318','2013-07-21','09:15:00',5.83),('10318','2013-07-21','09:20:00',5.95),('10318','2013-07-21','09:25:00',6.06),('10318','2013-07-21','09:30:00',6.2),('10318','2013-07-21','09:35:00',6.34),('10318','2013-07-21','09:40:00',6.48),('10318','2013-07-21','09:45:00',6.6),('10318','2013-07-21','09:50:00',6.7),('10318','2013-07-21','09:55:00',6.85),('10318','2013-07-21','10:00:00',6.94),('10318','2013-07-21','10:05:00',7.08),('10318','2013-07-21','10:10:00',7.2),('10318','2013-07-21','10:15:00',7.27),('10318','2013-07-21','10:20:00',7.42),('10318','2013-07-21','10:25:00',7.54),('10318','2013-07-21','10:30:00',7.61),('10318','2013-07-21','10:35:00',7.7),('10318','2013-07-21','10:40:00',7.84),('10318','2013-07-21','10:45:00',7.94),('10318','2013-07-21','10:50:00',8.01),('10318','2013-07-21','10:55:00',8.01),('10318','2013-07-21','11:00:00',8.09),('10318','2013-07-21','11:05:00',8.17),('10318','2013-07-21','11:10:00',8.17),('10318','2013-07-21','11:15:00',8.19),('10318','2013-07-21','11:20:00',8.34),('10318','2013-07-21','11:25:00',8.45),('10318','2013-07-21','11:30:00',8.47),('10318','2013-07-21','11:35:00',8.48),('10318','2013-07-21','11:40:00',8.57),('10318','2013-07-21','11:45:00',8.59),('10318','2013-07-21','11:50:00',8.59),('10318','2013-07-21','11:55:00',8.71),('10318','2013-07-21','12:00:00',8.69),('10318','2013-07-21','12:05:00',8.63),('10318','2013-07-21','12:10:00',6.77),('10318','2013-07-21','12:15:00',8.03),('10318','2013-07-21','12:20:00',7.11),('10318','2013-07-21','12:25:00',7.18),('10318','2013-07-21','12:30:00',5.15),('10318','2013-07-21','12:35:00',5.28),('10318','2013-07-21','12:40:00',7.45),('10318','2013-07-21','12:45:00',4.41),('10318','2013-07-21','12:50:00',4.54),('10318','2013-07-21','12:55:00',4.28),('10318','2013-07-21','13:00:00',4.25),('10318','2013-07-21','13:05:00',3.97),('10318','2013-07-21','13:10:00',3.75),('10318','2013-07-21','13:15:00',4.55),('10318','2013-07-21','13:20:00',9.71),('10318','2013-07-21','13:25:00',7.05),('10318','2013-07-21','13:30:00',9.85),('10318','2013-07-21','13:35:00',9.11),('10318','2013-07-21','13:40:00',9.88),('10318','2013-07-21','13:45:00',9.43),('10318','2013-07-21','13:50:00',8.99),('10318','2013-07-21','13:55:00',5.91),('10318','2013-07-21','14:00:00',4.04),('10318','2013-07-21','14:05:00',3.34),('10318','2013-07-21','14:10:00',3.12),('10318','2013-07-21','14:15:00',2.99),('10318','2013-07-21','14:20:00',4.12),('10318','2013-07-21','14:25:00',6.27),('10318','2013-07-21','14:30:00',3.12),('10318','2013-07-21','14:35:00',2.54),('10318','2013-07-21','14:40:00',2.33),('10318','2013-07-21','14:45:00',2.54),('10318','2013-07-21','14:50:00',3.81),('10318','2013-07-21','14:55:00',5.07),('10318','2013-07-21','15:00:00',3.61),('10318','2013-07-21','15:05:00',3.76),('10318','2013-07-21','15:10:00',3.8),('10318','2013-07-21','15:15:00',3.46),('10318','2013-07-21','15:20:00',3.72),('10318','2013-07-21','15:25:00',3.44),('10318','2013-07-21','15:30:00',3.18),('10318','2013-07-21','15:35:00',3.37),('10318','2013-07-21','15:40:00',3.66),('10318','2013-07-21','15:45:00',4.1),('10318','2013-07-21','15:50:00',4.5),('10318','2013-07-21','15:55:00',3.33),('10318','2013-07-21','16:00:00',2.96),('10318','2013-07-21','16:05:00',2.26),('10318','2013-07-21','16:10:00',1.96),('10318','2013-07-21','16:15:00',1.72),('10318','2013-07-21','16:20:00',1.58),('10318','2013-07-21','16:25:00',1.56),('10318','2013-07-21','16:30:00',1.62),('10318','2013-07-21','16:35:00',1.87),('10318','2013-07-21','16:40:00',2.05),('10318','2013-07-21','16:45:00',2.13),('10318','2013-07-21','16:50:00',2.16),('10318','2013-07-21','16:55:00',2.32),('10318','2013-07-21','17:00:00',2.58),('10318','2013-07-21','17:05:00',3),('10318','2013-07-21','17:10:00',2.8),('10318','2013-07-21','17:15:00',2.34),('10318','2013-07-21','17:20:00',2.07),('10318','2013-07-21','17:25:00',1.85),('10318','2013-07-21','17:30:00',1.78),('10318','2013-07-21','17:35:00',1.71),('10318','2013-07-21','17:40:00',1.69),('10318','2013-07-21','17:45:00',1.67),('10318','2013-07-21','17:50:00',1.69),('10318','2013-07-21','17:55:00',1.71),('10318','2013-07-21','18:00:00',1.7),('10318','2013-07-21','18:05:00',1.61),('10318','2013-07-21','18:10:00',1.39),('10318','2013-07-21','18:15:00',1.23),('10318','2013-07-21','18:20:00',1.13),('10318','2013-07-21','18:25:00',1.03),('10318','2013-07-21','19:05:00',1.02),('10318','2014-04-07','07:35:00',1.05),('10318','2014-04-07','07:40:00',1.21),('10318','2014-04-07','07:45:00',1.22),('10318','2014-04-07','07:50:00',1.12),('10318','2014-04-07','07:55:00',1.2),('10318','2014-04-07','08:00:00',1.32),('10318','2014-04-07','08:05:00',1.59),('10318','2014-04-07','08:10:00',2.18),('10318','2014-04-07','08:15:00',2.3),('10318','2014-04-07','08:20:00',2.84),('10318','2014-04-07','08:25:00',2.72),('10318','2014-04-07','08:30:00',3.47),('10318','2014-04-07','08:35:00',3.44),('10318','2014-04-07','08:40:00',3.97),('10318','2014-04-07','08:45:00',3.36),('10318','2014-04-07','08:50:00',3.1),('10318','2014-04-07','08:55:00',2.71),('10318','2014-04-07','09:00:00',2.61),('10318','2014-04-07','09:05:00',2.7),('10318','2014-04-07','09:10:00',3.12),('10318','2014-04-07','09:15:00',2.73),('10318','2014-04-07','09:20:00',2.64),('10318','2014-04-07','09:25:00',2.57),('10318','2014-04-07','09:30:00',2.59),('10318','2014-04-07','09:35:00',2.63),('10318','2014-04-07','09:40:00',2.72),('10318','2014-04-07','09:45:00',2.91),('10318','2014-04-07','09:50:00',2.96),('10318','2014-04-07','09:55:00',2.96),('10318','2014-04-07','10:00:00',3.04),('10318','2014-04-07','10:05:00',3.01),('10318','2014-04-07','10:10:00',2.93),('10318','2014-04-07','10:15:00',2.91),('10318','2014-04-07','10:20:00',2.96),('10318','2014-04-07','10:25:00',2.99),('10318','2014-04-07','10:30:00',3.04),('10318','2014-04-07','10:35:00',3.14),('10318','2014-04-07','10:40:00',3.22),('10318','2014-04-07','10:45:00',3.4),('10318','2014-04-07','10:50:00',3.63),('10318','2014-04-07','10:55:00',3.94),('10318','2014-04-07','11:00:00',3.92),('10318','2014-04-07','11:05:00',4.06),('10318','2014-04-07','11:10:00',4.15),('10318','2014-04-07','11:15:00',4.45),('10318','2014-04-07','11:20:00',4.43),('10318','2014-04-07','11:25:00',4.21),('10318','2014-04-07','11:30:00',4.13),('10318','2014-04-07','11:35:00',4.3),('10318','2014-04-07','11:40:00',4.07),('10318','2014-04-07','11:45:00',3.94),('10318','2014-04-07','11:50:00',3.8),('10318','2014-04-07','11:55:00',3.8),('10318','2014-04-07','12:00:00',4.57),('10318','2014-04-07','12:05:00',5.05),('10318','2014-04-07','12:10:00',6.5),('10318','2014-04-07','12:15:00',8.41),('10318','2014-04-07','12:20:00',8.99),('10318','2014-04-07','12:25:00',6.87),('10318','2014-04-07','12:30:00',5.35),('10318','2014-04-07','12:35:00',5.07),('10318','2014-04-07','12:40:00',9.08),('10318','2014-04-07','12:45:00',9.5),('10318','2014-04-07','12:50:00',9.2),('10318','2014-04-07','12:55:00',9.03),('10318','2014-04-07','13:00:00',9.1),('10318','2014-04-07','13:05:00',9.02),('10318','2014-04-07','13:10:00',9.01),('10318','2014-04-07','13:15:00',8.96),('10318','2014-04-07','13:20:00',8.91),('10318','2014-04-07','13:25:00',8.89),('10318','2014-04-07','13:30:00',8.81),('10318','2014-04-07','13:35:00',8.76),('10318','2014-04-07','13:40:00',8.76),('10318','2014-04-07','13:45:00',8.67),('10318','2014-04-07','13:50:00',8.54),('10318','2014-04-07','13:55:00',8.57),('10318','2014-04-07','14:00:00',8.49),('10318','2014-04-07','14:05:00',8.41),('10318','2014-04-07','14:10:00',8.18),('10318','2014-04-07','14:15:00',8.34),('10318','2014-04-07','14:20:00',8.31),('10318','2014-04-07','14:25:00',8.19),('10318','2014-04-07','14:30:00',8.06),('10318','2014-04-07','14:35:00',7.93),('10318','2014-04-07','14:40:00',7.82),('10318','2014-04-07','14:45:00',7.97),('10318','2014-04-07','14:50:00',7.86),('10318','2014-04-07','14:55:00',7.79),('10318','2014-04-07','15:00:00',7.68),('10318','2014-04-07','15:05:00',7.29),('10318','2014-04-07','15:10:00',7.42),('10318','2014-04-07','15:15:00',7.43),('10318','2014-04-07','15:20:00',7.41),('10318','2014-04-07','15:25:00',7.27),('10318','2014-04-07','15:30:00',7.05),('10318','2014-04-07','15:35:00',6.89),('10318','2014-04-07','15:40:00',6.77),('10318','2014-04-07','15:45:00',6.8),('10318','2014-04-07','15:50:00',6.99),('10318','2014-04-07','15:55:00',7.02),('10318','2014-04-07','16:00:00',6.98),('10318','2014-04-07','16:05:00',6.46),('10318','2014-04-07','16:10:00',5.99),('10318','2014-04-07','16:15:00',5.7),('10318','2014-04-07','16:20:00',5.38),('10318','2014-04-07','16:25:00',5.05),('10318','2014-04-07','16:30:00',3.46),('10318','2014-04-07','16:35:00',2.53),('10318','2014-04-07','16:40:00',2.1),('10318','2014-04-07','16:45:00',1.99),('10318','2014-04-07','16:50:00',4.28),('10318','2014-04-07','16:55:00',4.78),('10318','2014-04-07','17:00:00',4.76),('10318','2014-04-07','17:05:00',4.62),('10318','2014-04-07','17:10:00',4.03),('10318','2014-04-07','17:15:00',3.89),('10318','2014-04-07','17:20:00',2.87),('10318','2014-04-07','17:25:00',2.4),('10318','2014-04-07','17:30:00',1.63),('10318','2014-04-07','17:35:00',1.35),('10318','2014-04-07','17:40:00',2.28),('10318','2014-04-07','17:45:00',2.45),('10318','2014-04-07','17:50:00',2.28),('10318','2014-04-07','17:55:00',2.06),('10318','2014-04-07','18:00:00',1.78),('10318','2014-04-07','18:05:00',1.72),('10318','2014-04-07','18:10:00',1.67),('10318','2014-04-07','18:15:00',1.62),('10318','2014-04-07','18:20:00',1.46),('10318','2014-04-07','18:25:00',1.28),('10318','2014-04-07','18:30:00',1.01),('10318','2013-07-20','07:10:00',1.02),('10318','2013-07-20','07:15:00',1.36),('10318','2013-07-20','07:20:00',1.61),('10318','2013-07-20','07:25:00',1.88),('10318','2013-07-20','07:30:00',2.22),('10318','2013-07-20','07:35:00',2.48),('10318','2013-07-20','07:40:00',2.66),('10318','2013-07-20','07:45:00',2.83),('10318','2013-07-20','07:50:00',3.05),('10318','2013-07-20','07:55:00',3.22),('10318','2013-07-20','08:00:00',3.38),('10318','2013-07-20','08:05:00',3.61),('10318','2013-07-20','08:10:00',3.82),('10318','2013-07-20','08:15:00',3.98),('10318','2013-07-20','08:20:00',4.18),('10318','2013-07-20','08:25:00',4.38),('10318','2013-07-20','08:30:00',4.58),('10318','2013-07-20','08:35:00',4.76),('10318','2013-07-20','08:40:00',4.95),('10318','2013-07-20','08:45:00',5.07),('10318','2013-07-20','08:50:00',5.28),('10318','2013-07-20','08:55:00',5.5),('10318','2013-07-20','09:00:00',5.63),('10318','2013-07-20','09:05:00',5.96),('10318','2013-07-20','09:10:00',6.15),('10318','2013-07-20','09:15:00',6.31),('10318','2013-07-20','09:20:00',6.35),('10318','2013-07-20','09:25:00',6.18),('10318','2013-07-20','09:30:00',6.29),('10318','2013-07-20','09:35:00',6.38),('10318','2013-07-20','09:40:00',6.63),('10318','2013-07-20','09:45:00',6.76),('10318','2013-07-20','09:50:00',6.48),('10318','2013-07-20','09:55:00',6.96),('10318','2013-07-20','10:00:00',7.07),('10318','2013-07-20','10:05:00',7.25),('10318','2013-07-20','10:10:00',7.35),('10318','2013-07-20','10:15:00',7.46),('10318','2013-07-20','10:20:00',7.58),('10318','2013-07-20','10:25:00',7.66),('10318','2013-07-20','10:30:00',7.72),('10318','2013-07-20','10:35:00',7.54),('10318','2013-07-20','10:40:00',7.89),('10318','2013-07-20','10:45:00',7.98),('10318','2013-07-20','10:50:00',7.97),('10318','2013-07-20','10:55:00',8.05),('10318','2013-07-20','11:00:00',8.19),('10318','2013-07-20','11:05:00',8.24),('10318','2013-07-20','11:10:00',8.33),('10318','2013-07-20','11:15:00',8.25),('10318','2013-07-20','11:20:00',8.33),('10318','2013-07-20','11:25:00',8.48),('10318','2013-07-20','11:30:00',8.58),('10318','2013-07-20','11:35:00',8.58),('10318','2013-07-20','11:40:00',8.66),('10318','2013-07-20','11:45:00',8.76),('10318','2013-07-20','11:50:00',8.5),('10318','2013-07-20','11:55:00',8.44),('10318','2013-07-20','12:00:00',9.09),('10318','2013-07-20','12:05:00',9.01),('10318','2013-07-20','12:10:00',8.88),('10318','2013-07-20','12:15:00',8.95),('10318','2013-07-20','12:20:00',8.91),('10318','2013-07-20','12:25:00',9.01),('10318','2013-07-20','12:30:00',8.61),('10318','2013-07-20','12:35:00',9.03),('10318','2013-07-20','12:40:00',9.25),('10318','2013-07-20','12:45:00',9.08),('10318','2013-07-20','12:50:00',9.04),('10318','2013-07-20','12:55:00',4.74),('10318','2013-07-20','13:00:00',7.91),('10318','2013-07-20','13:05:00',6.07),('10318','2013-07-20','13:10:00',3.89),('10318','2013-07-20','13:15:00',4.2),('10318','2013-07-20','13:20:00',9.09),('10318','2013-07-20','13:25:00',8.06),('10318','2013-07-20','13:30:00',7.33),('10318','2013-07-20','13:35:00',2.24),('10318','2013-07-20','13:40:00',2.67),('10318','2013-07-20','13:45:00',3.73),('10318','2013-07-20','13:50:00',9.93),('10318','2013-07-20','13:55:00',9.28),('10318','2013-07-20','14:00:00',8.93),('10318','2013-07-20','14:05:00',8.73),('10318','2013-07-20','14:10:00',8.68),('10318','2013-07-20','14:15:00',8.68),('10318','2013-07-20','14:20:00',8.38),('10318','2013-07-20','14:25:00',8.51),('10318','2013-07-20','14:30:00',7.97),('10318','2013-07-20','14:35:00',8.19),('10318','2013-07-20','14:40:00',8.14),('10318','2013-07-20','14:45:00',8.1),('10318','2013-07-20','14:50:00',8.05),('10318','2013-07-20','14:55:00',8.02),('10318','2013-07-20','15:00:00',7.91),('10318','2013-07-20','15:05:00',7.77),('10318','2013-07-20','15:10:00',7.57),('10318','2013-07-20','15:15:00',7.73),('10318','2013-07-20','15:20:00',7.32),('10318','2013-07-20','15:25:00',7.28),('10318','2013-07-20','15:30:00',7.28),('10318','2013-07-20','15:35:00',7.08),('10318','2013-07-20','15:40:00',6.99),('10318','2013-07-20','15:45:00',6.85),('10318','2013-07-20','15:50:00',6.74),('10318','2013-07-20','15:55:00',6.63),('10318','2013-07-20','16:00:00',6.48),('10318','2013-07-20','16:05:00',6.33),('10318','2013-07-20','16:10:00',6.22),('10318','2013-07-20','16:15:00',6.11),('10318','2013-07-20','16:20:00',5.91),('10318','2013-07-20','16:25:00',5.76),('10318','2013-07-20','16:30:00',5.65),('10318','2013-07-20','16:35:00',5.46),('10318','2013-07-20','16:40:00',5.32),('10318','2013-07-20','16:45:00',5.14),('10318','2013-07-20','16:50:00',4.97),('10318','2013-07-20','16:55:00',4.8),('10318','2013-07-20','17:00:00',4.64),('10318','2013-07-20','17:05:00',4.39),('10318','2013-07-20','17:10:00',4.3),('10318','2013-07-20','17:15:00',4.14),('10318','2013-07-20','17:20:00',3.95),('10318','2013-07-20','17:25:00',3.76),('10318','2013-07-20','17:30:00',3.61),('10318','2013-07-20','17:35:00',3.46),('10318','2013-07-20','17:40:00',3.29),('10318','2013-07-20','17:45:00',3.12),('10318','2013-07-20','17:50:00',2.95),('10318','2013-07-20','17:55:00',2.77),('10318','2013-07-20','18:00:00',2.62),('10318','2013-07-20','18:05:00',2.44),('10318','2013-07-20','18:10:00',2.28),('10318','2013-07-20','18:15:00',2.13),('10318','2013-07-20','18:20:00',1.96),('10318','2013-07-20','18:25:00',1.8),('10318','2013-07-20','18:30:00',1.64),('10318','2013-07-20','18:35:00',1.5),('10318','2013-07-20','18:40:00',1.38),('10318','2013-07-20','18:45:00',1.25),('10318','2013-07-20','18:50:00',1.11),('10318','2013-07-20','18:55:00',1.03),('10318','2013-07-19','07:05:00',1.08),('10318','2013-07-19','07:10:00',1.33),('10318','2013-07-19','07:15:00',1.49),('10318','2013-07-19','07:20:00',1.67),('10318','2013-07-19','07:25:00',1.86),('10318','2013-07-19','07:30:00',2.09),('10318','2013-07-19','07:35:00',2.34),('10318','2013-07-19','07:40:00',2.51),('10318','2013-07-19','07:45:00',2.68),('10318','2013-07-19','07:50:00',2.86),('10318','2013-07-19','07:55:00',3.02),('10318','2013-07-19','08:00:00',3.2),('10318','2013-07-19','08:05:00',3.41),('10318','2013-07-19','08:10:00',3.61),('10318','2013-07-19','08:15:00',3.79),('10318','2013-07-19','08:20:00',3.92),('10318','2013-07-19','08:25:00',4.1),('10318','2013-07-19','08:30:00',4.3),('10318','2013-07-19','08:35:00',4.5),('10318','2013-07-19','08:40:00',4.69),('10318','2013-07-19','08:45:00',4.8),('10318','2013-07-19','08:50:00',5.06),('10318','2013-07-19','08:55:00',5.17),('10318','2013-07-19','09:00:00',5.33),('10318','2013-07-19','09:05:00',5.49),('10318','2013-07-19','09:10:00',5.68),('10318','2013-07-19','09:15:00',5.72),('10318','2013-07-19','09:20:00',5.91),('10318','2013-07-19','09:25:00',5.99),('10318','2013-07-19','09:30:00',6.18),('10318','2013-07-19','09:35:00',6.18),('10318','2013-07-19','09:40:00',6.35),('10318','2013-07-19','09:45:00',6.47),('10318','2013-07-19','09:50:00',6.55),('10318','2013-07-19','09:55:00',6.66),('10318','2013-07-19','10:00:00',6.81),('10318','2013-07-19','10:05:00',6.87),('10318','2013-07-19','10:10:00',6.94),('10318','2013-07-19','10:15:00',7.11),('10318','2013-07-19','10:20:00',7.15),('10318','2013-07-19','10:25:00',7.24),('10318','2013-07-19','10:30:00',7.34),('10318','2013-07-19','10:35:00',7.27),('10318','2013-07-19','10:40:00',7.52),('10318','2013-07-19','10:45:00',7.62),('10318','2013-07-19','10:50:00',7.69),('10318','2013-07-19','10:55:00',7.75),('10318','2013-07-19','11:00:00',7.79),('10318','2013-07-19','11:05:00',7.87),('10318','2013-07-19','11:10:00',7.93),('10318','2013-07-19','11:15:00',7.97),('10318','2013-07-19','11:20:00',8.04),('10318','2013-07-19','11:25:00',8.12),('10318','2013-07-19','11:30:00',8.04),('10318','2013-07-19','11:35:00',7.72),('10318','2013-07-19','11:40:00',7.91),('10318','2013-07-19','11:45:00',7.79),('10318','2013-07-19','11:50:00',4.6),('10318','2013-07-19','11:55:00',7.3),('10318','2013-07-19','12:00:00',7.65),('10318','2013-07-19','12:05:00',6.22),('10318','2013-07-19','12:10:00',7.65),('10318','2013-07-19','12:15:00',8.75),('10318','2013-07-19','12:20:00',8.81),('10318','2013-07-19','12:25:00',9.08),('10318','2013-07-19','12:30:00',8.78),('10318','2013-07-19','12:35:00',8.61),('10318','2013-07-19','12:40:00',6.3),('10318','2013-07-19','12:45:00',8.77),('10318','2013-07-19','12:50:00',9.03),('10318','2013-07-19','12:55:00',9.02),('10318','2013-07-19','13:00:00',9.12),('10318','2013-07-19','13:05:00',8.93),('10318','2013-07-19','13:10:00',8.25),('10318','2013-07-19','13:15:00',6.53),('10318','2013-07-19','13:20:00',9.04),('10318','2013-07-19','13:25:00',8.92),('10318','2013-07-19','13:30:00',9.07),('10318','2013-07-19','13:35:00',8.87),('10318','2013-07-19','13:40:00',9),('10318','2013-07-19','13:45:00',9),('10318','2013-07-19','13:50:00',8.93),('10318','2013-07-19','13:55:00',8.89),('10318','2013-07-19','14:00:00',8.91),('10318','2013-07-19','14:05:00',8.74),('10318','2013-07-19','14:10:00',8.76),('10318','2013-07-19','14:15:00',8.66),('10318','2013-07-19','14:20:00',7.19),('10318','2013-07-19','14:25:00',8.69),('10318','2013-07-19','14:30:00',8.61),('10318','2013-07-19','14:35:00',8.49),('10318','2013-07-19','14:40:00',8.44),('10318','2013-07-19','14:45:00',8.01),('10318','2013-07-19','14:50:00',8.29),('10318','2013-07-19','14:55:00',7.27),('10318','2013-07-19','15:00:00',8.09),('10318','2013-07-19','15:05:00',6.62),('10318','2013-07-19','15:10:00',8.11),('10318','2013-07-19','15:15:00',3.26),('10318','2013-07-19','15:20:00',6.73),('10318','2013-07-19','15:25:00',7.65),('10318','2013-07-19','15:30:00',5.81),('10318','2013-07-19','15:35:00',7.33),('10318','2013-07-19','15:40:00',7.13),('10318','2013-07-19','15:45:00',7.22),('10318','2013-07-19','15:50:00',7.06),('10318','2013-07-19','15:55:00',6.86),('10318','2013-07-19','16:00:00',6.72),('10318','2013-07-19','16:05:00',6.56),('10318','2013-07-19','16:10:00',6.39),('10318','2013-07-19','16:15:00',6.34),('10318','2013-07-19','16:20:00',6.15),('10318','2013-07-19','16:25:00',6.04),('10318','2013-07-19','16:30:00',5.93),('10318','2013-07-19','16:35:00',5.84),('10318','2013-07-19','16:40:00',5.7),('10318','2013-07-19','16:45:00',5.63),('10318','2013-07-19','16:50:00',5.25),('10318','2013-07-19','16:55:00',5.7),('10318','2013-07-19','17:00:00',5.27),('10318','2013-07-19','17:05:00',5.09),('10318','2013-07-19','17:10:00',4.89),('10318','2013-07-19','17:15:00',3.36),('10318','2013-07-19','17:20:00',3.96),('10318','2013-07-19','17:25:00',3.43),('10318','2013-07-19','17:30:00',4.06),('10318','2013-07-19','17:35:00',4.02),('10318','2013-07-19','17:40:00',3.28),('10318','2013-07-19','17:45:00',2.9),('10318','2013-07-19','17:50:00',2.19),('10318','2013-07-19','17:55:00',1.78),('10318','2013-07-19','18:00:00',1.52),('10318','2013-07-19','18:05:00',1.4),('10318','2013-07-19','18:10:00',1.29),('10318','2013-07-19','18:15:00',1.04),('10318','2013-07-19','18:30:00',1.08),('10318','2013-07-19','18:35:00',1.14),('10318','2013-07-19','18:40:00',1.19),('10318','2013-07-19','18:45:00',1.19),('10318','2013-07-19','18:50:00',1.12),('10318','2013-07-19','18:55:00',1.12),('10318','2013-07-19','19:00:00',1.06),('10318','2013-07-18','07:05:00',1.13),('10318','2013-07-18','07:10:00',1.37),('10318','2013-07-18','07:15:00',1.55),('10318','2013-07-18','07:20:00',1.77),('10318','2013-07-18','07:25:00',1.99),('10318','2013-07-18','07:30:00',2.26),('10318','2013-07-18','07:35:00',2.52),('10318','2013-07-18','07:40:00',2.71),('10318','2013-07-18','07:45:00',2.93),('10318','2013-07-18','07:50:00',3.11),('10318','2013-07-18','07:55:00',3.29),('10318','2013-07-18','08:00:00',3.47),('10318','2013-07-18','08:05:00',3.65),('10318','2013-07-18','08:10:00',3.83),('10318','2013-07-18','08:15:00',3.91),('10318','2013-07-18','08:20:00',4.18),('10318','2013-07-18','08:25:00',4.37),('10318','2013-07-18','08:30:00',4.57),('10318','2013-07-18','08:35:00',4.74),('10318','2013-07-18','08:40:00',4.92),('10318','2013-07-18','08:45:00',5.08),('10318','2013-07-18','08:50:00',5.28),('10318','2013-07-18','08:55:00',5.44),('10318','2013-07-18','09:00:00',5.58),('10318','2013-07-18','09:05:00',5.75),('10318','2013-07-18','09:10:00',5.92),('10318','2013-07-18','09:15:00',6.07),('10318','2013-07-18','09:20:00',6.22),('10318','2013-07-18','09:25:00',6.34),('10318','2013-07-18','09:30:00',6.49),('10318','2013-07-18','09:35:00',6.58),('10318','2013-07-18','09:40:00',6.7),('10318','2013-07-18','09:45:00',6.83),('10318','2013-07-18','09:50:00',6.93),('10318','2013-07-18','09:55:00',7.06),('10318','2013-07-18','10:00:00',7.05),('10318','2013-07-18','10:05:00',7.29),('10318','2013-07-18','10:10:00',7.38),('10318','2013-07-18','10:15:00',7.5),('10318','2013-07-18','10:20:00',7.6),('10318','2013-07-18','10:25:00',7.72),('10318','2013-07-18','10:30:00',7.85),('10318','2013-07-18','10:35:00',7.96),('10318','2013-07-18','10:40:00',8.01),('10318','2013-07-18','10:45:00',8.07),('10318','2013-07-18','10:50:00',8.1),('10318','2013-07-18','10:55:00',8.12),('10318','2013-07-18','11:00:00',8.2),('10318','2013-07-18','11:05:00',8.25),('10318','2013-07-18','11:10:00',8.3),('10318','2013-07-18','11:15:00',8.28),('10318','2013-07-18','11:20:00',8.37),('10318','2013-07-18','11:25:00',8.44),('10318','2013-07-18','11:30:00',8.48),('10318','2013-07-18','11:35:00',8.53),('10318','2013-07-18','11:40:00',8.59),('10318','2013-07-18','11:45:00',8.65),('10318','2013-07-18','11:50:00',8.67),('10318','2013-07-18','11:55:00',8.74),('10318','2013-07-18','12:00:00',8.72),('10318','2013-07-18','12:05:00',8.74),('10318','2013-07-18','12:10:00',8.73),('10318','2013-07-18','12:15:00',8.66),('10318','2013-07-18','12:20:00',8.86),('10318','2013-07-18','12:25:00',8.89),('10318','2013-07-18','12:30:00',8.77),('10318','2013-07-18','12:35:00',8.92),('10318','2013-07-18','12:40:00',9.01),('10318','2013-07-18','12:45:00',8.99),('10318','2013-07-18','12:50:00',8.89),('10318','2013-07-18','12:55:00',8.81),('10318','2013-07-18','13:00:00',8.79),('10318','2013-07-18','13:05:00',8.9),('10318','2013-07-18','13:10:00',8.99),('10318','2013-07-18','13:15:00',9.04),('10318','2013-07-18','13:20:00',8.91),('10318','2013-07-18','13:25:00',8.83),('10318','2013-07-18','13:30:00',8.86),('10318','2013-07-18','13:35:00',8.92),('10318','2013-07-18','13:40:00',8.82),('10318','2013-07-18','13:45:00',8.81),('10318','2013-07-18','13:50:00',8.78),('10318','2013-07-18','13:55:00',8.65),('10318','2013-07-18','14:00:00',8.59),('10318','2013-07-18','14:05:00',8.62),('10318','2013-07-18','14:10:00',8.57),('10318','2013-07-18','14:15:00',8.58),('10318','2013-07-18','14:20:00',8.49),('10318','2013-07-18','14:25:00',8.4),('10318','2013-07-18','14:30:00',8.31),('10318','2013-07-18','14:35:00',8.17),('10318','2013-07-18','14:40:00',8.15),('10318','2013-07-18','14:45:00',8.1),('10318','2013-07-18','14:50:00',7.85),('10318','2013-07-18','14:55:00',7.85),('10318','2013-07-18','15:00:00',7.74),('10318','2013-07-18','15:05:00',7.65),('10318','2013-07-18','15:10:00',7.62),('10318','2013-07-18','15:15:00',7.47),('10318','2013-07-18','15:20:00',7.36),('10318','2013-07-18','15:25:00',7.28),('10318','2013-07-18','15:30:00',7.17),('10318','2013-07-18','15:35:00',7.01),('10318','2013-07-18','15:40:00',6.93),('10318','2013-07-18','15:45:00',6.74),('10318','2013-07-18','15:50:00',6.66),('10318','2013-07-18','15:55:00',6.49),('10318','2013-07-18','16:00:00',6.39),('10318','2013-07-18','16:05:00',6.28),('10318','2013-07-18','16:10:00',6.14),('10318','2013-07-18','16:15:00',5.96),('10318','2013-07-18','16:20:00',5.83),('10318','2013-07-18','16:25:00',5.69),('10318','2013-07-18','16:30:00',5.52),('10318','2013-07-18','16:35:00',5.2),('10318','2013-07-18','16:40:00',5.23),('10318','2013-07-18','16:45:00',5.03),('10318','2013-07-18','16:50:00',4.87),('10318','2013-07-18','16:55:00',4.74),('10318','2013-07-18','17:00:00',4.59),('10318','2013-07-18','17:05:00',4.34),('10318','2013-07-18','17:10:00',4.24),('10318','2013-07-18','17:15:00',4.1),('10318','2013-07-18','17:20:00',3.93),('10318','2013-07-18','17:25:00',3.75),('10318','2013-07-18','17:30:00',3.57),('10318','2013-07-18','17:35:00',3.36),('10318','2013-07-18','17:40:00',3.21),('10318','2013-07-18','17:45:00',2.96),('10318','2013-07-18','17:50:00',2.75),('10318','2013-07-18','17:55:00',2.31),('10318','2013-07-18','18:00:00',2.27),('10318','2013-07-18','18:05:00',2.07),('10318','2013-07-18','18:10:00',2.19),('10318','2013-07-18','18:15:00',1.96),('10318','2013-07-18','18:20:00',1.8),('10318','2013-07-18','18:25:00',1.56),('10318','2013-07-18','18:45:00',1.2),('10318','2013-07-18','18:50:00',1.36),('10318','2013-07-18','18:55:00',1.32),('10318','2013-07-18','19:00:00',1.25),('10318','2013-07-17','07:05:00',1.22),('10318','2013-07-17','07:10:00',1.47),('10318','2013-07-17','07:15:00',1.67),('10318','2013-07-17','07:20:00',1.88),('10318','2013-07-17','07:25:00',2.07),('10318','2013-07-17','07:30:00',2.38),('10318','2013-07-17','07:35:00',2.61),('10318','2013-07-17','07:40:00',2.8),('10318','2013-07-17','07:45:00',2.96),('10318','2013-07-17','07:50:00',3.17),('10318','2013-07-17','07:55:00',3.39),('10318','2013-07-17','08:00:00',3.59),('10318','2013-07-17','08:05:00',3.82),('10318','2013-07-17','08:10:00',3.96),('10318','2013-07-17','08:15:00',4.17),('10318','2013-07-17','08:20:00',4.36),('10318','2013-07-17','08:25:00',4.56),('10318','2013-07-17','08:30:00',4.8),('10318','2013-07-17','08:35:00',5),('10318','2013-07-17','08:40:00',5.15),('10318','2013-07-17','08:45:00',5.32),('10318','2013-07-17','08:50:00',5.51),('10318','2013-07-17','08:55:00',5.7),('10318','2013-07-17','09:00:00',5.74),('10318','2013-07-17','09:05:00',6),('10318','2013-07-17','09:10:00',6.15),('10318','2013-07-17','09:15:00',6.28),('10318','2013-07-17','09:20:00',6.43),('10318','2013-07-17','09:25:00',6.54),('10318','2013-07-17','09:30:00',6.68),('10318','2013-07-17','09:35:00',6.83),('10318','2013-07-17','09:40:00',6.99),('10318','2013-07-17','09:45:00',7.1),('10318','2013-07-17','09:50:00',7.18),('10318','2013-07-17','09:55:00',7.29),('10318','2013-07-17','10:00:00',7.38),('10318','2013-07-17','10:05:00',7.46),('10318','2013-07-17','10:10:00',7.59),('10318','2013-07-17','10:15:00',7.69),('10318','2013-07-17','10:20:00',7.82),('10318','2013-07-17','10:25:00',7.99),('10318','2013-07-17','10:30:00',8.09),('10318','2013-07-17','10:35:00',8.08),('10318','2013-07-17','10:40:00',8.15),('10318','2013-07-17','10:45:00',7.98),('10318','2013-07-17','10:50:00',8.28),('10318','2013-07-17','10:55:00',8.4),('10318','2013-07-17','11:00:00',8.47),('10318','2013-07-17','11:05:00',8.56),('10318','2013-07-17','11:10:00',8.69),('10318','2013-07-17','11:15:00',8.72),('10318','2013-07-17','11:20:00',8.79),('10318','2013-07-17','11:25:00',8.87),('10318','2013-07-17','11:30:00',8.89),('10318','2013-07-17','11:35:00',8.92),('10318','2013-07-17','11:40:00',9.01),('10318','2013-07-17','11:45:00',9.07),('10318','2013-07-17','11:50:00',9.11),('10318','2013-07-17','11:55:00',9.1),('10318','2013-07-17','12:00:00',9.1),('10318','2013-07-17','12:05:00',9.13),('10318','2013-07-17','12:10:00',9.1),('10318','2013-07-17','12:15:00',9.07),('10318','2013-07-17','12:20:00',9.22),('10318','2013-07-17','12:25:00',9.16),('10318','2013-07-17','12:30:00',9.12),('10318','2013-07-17','12:35:00',9.16),('10318','2013-07-17','12:40:00',9.19),('10318','2013-07-17','12:45:00',9.14),('10318','2013-07-17','12:50:00',9.23),('10318','2013-07-17','12:55:00',9.16),('10318','2013-07-17','13:00:00',9.1),('10318','2013-07-17','13:05:00',9.05),('10318','2013-07-17','13:10:00',9.14),('10318','2013-07-17','13:15:00',9.14),('10318','2013-07-17','13:20:00',9.08),('10318','2013-07-17','13:25:00',8.98),('10318','2013-07-17','13:30:00',8.84),('10318','2013-07-17','13:35:00',8.85),('10318','2013-07-17','13:40:00',8.86),('10318','2013-07-17','13:45:00',8.77),('10318','2013-07-17','13:50:00',8.72),('10318','2013-07-17','13:55:00',8.74),('10318','2013-07-17','14:00:00',8.64),('10318','2013-07-17','14:05:00',8.59),('10318','2013-07-17','14:10:00',8.56),('10318','2013-07-17','14:15:00',8.57),('10318','2013-07-17','14:20:00',8.54),('10318','2013-07-17','14:25:00',8.43),('10318','2013-07-17','14:30:00',8.41),('10318','2013-07-17','14:35:00',8.33),('10318','2013-07-17','14:40:00',8.34),('10318','2013-07-17','14:45:00',8.2),('10318','2013-07-17','14:50:00',8.08),('10318','2013-07-17','14:55:00',8.16),('10318','2013-07-17','15:00:00',7.75),('10318','2013-07-17','15:05:00',7.92),('10318','2013-07-17','15:10:00',7.66),('10318','2013-07-17','15:15:00',7.48),('10318','2013-07-17','15:20:00',7.65),('10318','2013-07-17','15:25:00',7.53),('10318','2013-07-17','15:30:00',7.21),('10318','2013-07-17','15:35:00',5.98),('10318','2013-07-17','15:40:00',4.32),('10318','2013-07-17','15:45:00',6.39),('10318','2013-07-17','15:50:00',3.56),('10318','2013-07-17','15:55:00',3.34),('10318','2013-07-17','16:00:00',3.89),('10318','2013-07-17','16:05:00',5.41),('10318','2013-07-17','16:10:00',4.9),('10318','2013-07-17','16:15:00',6.36),('10318','2013-07-17','16:20:00',6.05),('10318','2013-07-17','16:25:00',5.74),('10318','2013-07-17','16:30:00',5.64),('10318','2013-07-17','16:35:00',5.55),('10318','2013-07-17','16:40:00',5.44),('10318','2013-07-17','16:45:00',5.23),('10318','2013-07-17','16:50:00',5.09),('10318','2013-07-17','16:55:00',4.94),('10318','2013-07-17','17:00:00',4.77),('10318','2013-07-17','17:05:00',4.56),('10318','2013-07-17','17:10:00',4.39),('10318','2013-07-17','17:15:00',4.2),('10318','2013-07-17','17:20:00',3.96),('10318','2013-07-17','17:25:00',3.85),('10318','2013-07-17','17:30:00',3.71),('10318','2013-07-17','17:35:00',3.5),('10318','2013-07-17','17:40:00',3.28),('10318','2013-07-17','17:45:00',3.11),('10318','2013-07-17','17:50:00',2.97),('10318','2013-07-17','17:55:00',2.8),('10318','2013-07-17','18:00:00',2.61),('10318','2013-07-17','18:05:00',2.44),('10318','2013-07-17','18:10:00',2.26),('10318','2013-07-17','18:15:00',2.12),('10318','2013-07-17','18:20:00',1.97),('10318','2013-07-17','18:25:00',1.83),('10318','2013-07-17','18:30:00',1.68),('10318','2013-07-17','18:35:00',1.55),('10318','2013-07-17','18:40:00',1.41),('10318','2013-07-17','18:45:00',1.28),('10318','2013-07-17','18:50:00',1.16),('10318','2013-07-17','18:55:00',1.03),('10318','2013-07-16','07:05:00',1.25),('10318','2013-07-16','07:10:00',1.45),('10318','2013-07-16','07:15:00',1.67),('10318','2013-07-16','07:20:00',1.91),('10318','2013-07-16','07:25:00',2.15),('10318','2013-07-16','07:30:00',2.41),('10318','2013-07-16','07:35:00',2.63),('10318','2013-07-16','07:40:00',2.8),('10318','2013-07-16','07:45:00',2.9),('10318','2013-07-16','07:50:00',3.17),('10318','2013-07-16','07:55:00',3.36),('10318','2013-07-16','08:00:00',3.53),('10318','2013-07-16','08:05:00',3.72),('10318','2013-07-16','08:10:00',3.92),('10318','2013-07-16','08:15:00',4.08),('10318','2013-07-16','08:20:00',4.27),('10318','2013-07-16','08:25:00',4.43),('10318','2013-07-16','08:30:00',4.6),('10318','2013-07-16','08:35:00',4.78),('10318','2013-07-16','08:40:00',4.91),('10318','2013-07-16','08:45:00',5.08),('10318','2013-07-16','08:50:00',5.28),('10318','2013-07-16','08:55:00',5.47),('10318','2013-07-16','09:00:00',5.62),('10318','2013-07-16','09:05:00',5.73),('10318','2013-07-16','09:10:00',5.88),('10318','2013-07-16','09:15:00',5.96),('10318','2013-07-16','09:20:00',6.14),('10318','2013-07-16','09:25:00',6.33),('10318','2013-07-16','09:30:00',6.47),('10318','2013-07-16','09:35:00',6.62),('10318','2013-07-16','09:40:00',6.76),('10318','2013-07-16','09:45:00',6.9),('10318','2013-07-16','09:50:00',7.02),('10318','2013-07-16','09:55:00',7.13),('10318','2013-07-16','10:00:00',7.21),('10318','2013-07-16','10:05:00',7.31),('10318','2013-07-16','10:10:00',7.5),('10318','2013-07-16','10:15:00',7.62),('10318','2013-07-16','10:20:00',7.68),('10318','2013-07-16','10:25:00',7.78),('10318','2013-07-16','10:30:00',7.85),('10318','2013-07-16','10:35:00',7.95),('10318','2013-07-16','10:40:00',8.04),('10318','2013-07-16','10:45:00',8.02),('10318','2013-07-16','10:50:00',8.22),('10318','2013-07-16','10:55:00',8.31),('10318','2013-07-16','11:00:00',8.39),('10318','2013-07-16','11:05:00',8.48),('10318','2013-07-16','11:10:00',8.53),('10318','2013-07-16','11:15:00',8.64),('10318','2013-07-16','11:20:00',8.68),('10318','2013-07-16','11:25:00',8.69),('10318','2013-07-16','11:30:00',8.72),('10318','2013-07-16','11:35:00',8.7),('10318','2013-07-16','11:40:00',8.76),('10318','2013-07-16','11:45:00',8.76),('10318','2013-07-16','11:50:00',8.87),('10318','2013-07-16','11:55:00',8.98),('10318','2013-07-16','12:00:00',9.02),('10318','2013-07-16','12:05:00',9.06),('10318','2013-07-16','12:10:00',9.07),('10318','2013-07-16','12:15:00',9.11),('10318','2013-07-16','12:20:00',9.18),('10318','2013-07-16','12:25:00',9.19),('10318','2013-07-16','12:30:00',9.08),('10318','2013-07-16','12:35:00',9.22),('10318','2013-07-16','12:40:00',9.25),('10318','2013-07-16','12:45:00',9.27),('10318','2013-07-16','12:50:00',9.25),('10318','2013-07-16','12:55:00',9.28),('10318','2013-07-16','13:00:00',9.2),('10318','2013-07-16','13:05:00',9.16),('10318','2013-07-16','13:10:00',9.17),('10318','2013-07-16','13:15:00',9.07),('10318','2013-07-16','13:20:00',9.07),('10318','2013-07-16','13:25:00',9.02),('10318','2013-07-16','13:30:00',8.95),('10318','2013-07-16','13:35:00',8.96),('10318','2013-07-16','13:40:00',9),('10318','2013-07-16','13:45:00',9.06),('10318','2013-07-16','13:50:00',8.09),('10318','2013-07-16','13:55:00',7.63),('10318','2013-07-16','14:00:00',8.49),('10318','2013-07-16','14:05:00',6.27),('10318','2013-07-16','14:10:00',8.89),('10318','2013-07-16','14:15:00',8.65),('10318','2013-07-16','14:20:00',8.84),('10318','2013-07-16','14:25:00',8.65),('10318','2013-07-16','14:30:00',8.47),('10318','2013-07-16','14:35:00',8.4),('10318','2013-07-16','14:40:00',8.33),('10318','2013-07-16','14:45:00',8.22),('10318','2013-07-16','14:50:00',8.06),('10318','2013-07-16','14:55:00',7.98),('10318','2013-07-16','15:00:00',7.96),('10318','2013-07-16','15:05:00',7.86),('10318','2013-07-16','15:10:00',7.72),('10318','2013-07-16','15:15:00',7.61),('10318','2013-07-16','15:20:00',7.55),('10318','2013-07-16','15:25:00',7.5),('10318','2013-07-16','15:30:00',6.39),('10318','2013-07-16','15:35:00',5.8),('10318','2013-07-16','15:40:00',4.48),('10318','2013-07-16','15:45:00',5.53),('10318','2013-07-16','15:50:00',6.85),('10318','2013-07-16','15:55:00',6.66),('10318','2013-07-16','16:00:00',6.48),('10318','2013-07-16','16:05:00',6.6),('10318','2013-07-16','16:10:00',6.4),('10318','2013-07-16','16:15:00',6.04),('10318','2013-07-16','16:20:00',5.96),('10318','2013-07-16','16:25:00',5.31),('10318','2013-07-16','16:30:00',4.68),('10318','2013-07-16','16:35:00',3.16),('10318','2013-07-16','16:40:00',3.86),('10318','2013-07-16','16:45:00',4.88),('10318','2013-07-16','16:50:00',5.95),('10318','2013-07-16','16:55:00',4.34),('10318','2013-07-16','17:00:00',3.91),('10318','2013-07-16','17:05:00',3.89),('10318','2013-07-16','17:10:00',4.57),('10318','2013-07-16','17:15:00',3.88),('10318','2013-07-16','17:20:00',4.42),('10318','2013-07-16','17:25:00',4.48),('10318','2013-07-16','17:30:00',3.87),('10318','2013-07-16','17:35:00',3.88),('10318','2013-07-16','17:40:00',3.86),('10318','2013-07-16','17:45:00',3.24),('10318','2013-07-16','17:50:00',2.28),('10318','2013-07-16','17:55:00',2.83),('10318','2013-07-16','18:00:00',1.74),('10318','2013-07-16','18:05:00',2.46),('10318','2013-07-16','18:10:00',2.28),('10318','2013-07-16','18:15:00',2.15),('10318','2013-07-16','18:20:00',1.89),('10318','2013-07-16','18:25:00',1.86),('10318','2013-07-16','18:30:00',1.47),('10318','2013-07-16','18:35:00',1.62),('10318','2013-07-16','18:40:00',1.4),('10318','2013-07-16','18:45:00',1.33),('10318','2013-07-16','18:50:00',1.15),('10318','2013-07-16','18:55:00',1.01),('10318','2013-07-15','07:00:00',1.06),('10318','2013-07-15','07:05:00',1.34),('10318','2013-07-15','07:10:00',1.55),('10318','2013-07-15','07:15:00',1.76),('10318','2013-07-15','07:20:00',1.94),('10318','2013-07-15','07:25:00',2.23),('10318','2013-07-15','07:30:00',2.49),('10318','2013-07-15','07:35:00',2.72),('10318','2013-07-15','07:40:00',2.9),('10318','2013-07-15','07:45:00',3.08),('10318','2013-07-15','07:50:00',3.28),('10318','2013-07-15','07:55:00',3.47),('10318','2013-07-15','08:00:00',3.66),('10318','2013-07-15','08:05:00',3.87),('10318','2013-07-15','08:10:00',4.07),('10318','2013-07-15','08:15:00',4.26),('10318','2013-07-15','08:20:00',4.44),('10318','2013-07-15','08:25:00',4.63),('10318','2013-07-15','08:30:00',4.73),('10318','2013-07-15','08:35:00',5.02),('10318','2013-07-15','08:40:00',5.19),('10318','2013-07-15','08:45:00',5.36),('10318','2013-07-15','08:50:00',5.52),('10318','2013-07-15','08:55:00',5.69),('10318','2013-07-15','09:00:00',5.84),('10318','2013-07-15','09:05:00',6),('10318','2013-07-15','09:10:00',6.15),('10318','2013-07-15','09:15:00',6.3),('10318','2013-07-15','09:20:00',6.44),('10318','2013-07-15','09:25:00',6.63),('10318','2013-07-15','09:30:00',6.77),('10318','2013-07-15','09:35:00',6.89),('10318','2013-07-15','09:40:00',7.01),('10318','2013-07-15','09:45:00',7.09),('10318','2013-07-15','09:50:00',7.23),('10318','2013-07-15','09:55:00',7.36),('10318','2013-07-15','10:00:00',7.47),('10318','2013-07-15','10:05:00',7.56),('10318','2013-07-15','10:10:00',7.66),('10318','2013-07-15','10:15:00',7.51),('10318','2013-07-15','10:20:00',7.8),('10318','2013-07-15','10:25:00',7.9),('10318','2013-07-15','10:30:00',7.97),('10318','2013-07-15','10:35:00',8.04),('10318','2013-07-15','10:40:00',8.09),('10318','2013-07-15','10:45:00',8.19),('10318','2013-07-15','10:50:00',8.27),('10318','2013-07-15','10:55:00',8.32),('10318','2013-07-15','11:00:00',8.4),('10318','2013-07-15','11:05:00',8.46),('10318','2013-07-15','11:10:00',8.52),('10318','2013-07-15','11:15:00',8.61),('10318','2013-07-15','11:20:00',8.68),('10318','2013-07-15','11:25:00',8.74),('10318','2013-07-15','11:30:00',8.78),('10318','2013-07-15','11:35:00',8.83),('10318','2013-07-15','11:40:00',8.9),('10318','2013-07-15','11:45:00',8.93),('10318','2013-07-15','11:50:00',8.92),('10318','2013-07-15','11:55:00',8.95),('10318','2013-07-15','12:00:00',8.91),('10318','2013-07-15','12:05:00',8.91),('10318','2013-07-15','12:10:00',8.92),('10318','2013-07-15','12:15:00',9.02),('10318','2013-07-15','12:20:00',9.01),('10318','2013-07-15','12:25:00',8.97),('10318','2013-07-15','12:30:00',9),('10318','2013-07-15','12:35:00',9.01),('10318','2013-07-15','12:40:00',8.98),('10318','2013-07-15','12:45:00',8.92),('10318','2013-07-15','12:50:00',8.96),('10318','2013-07-15','12:55:00',9.05),('10318','2013-07-15','13:00:00',9.16),('10318','2013-07-15','13:05:00',8.67),('10318','2013-07-15','13:10:00',8.81),('10318','2013-07-15','13:15:00',8.87),('10318','2013-07-15','13:20:00',8.99),('10318','2013-07-15','13:25:00',9.28),('10318','2013-07-15','13:30:00',9.36),('10318','2013-07-15','13:35:00',8.45),('10318','2013-07-15','13:40:00',8.66),('10318','2013-07-15','13:45:00',6.63),('10318','2013-07-15','13:50:00',8.61),('10318','2013-07-15','13:55:00',8.11),('10318','2013-07-15','14:00:00',2.47),('10318','2013-07-15','14:05:00',5.8),('10318','2013-07-15','14:10:00',9.31),('10318','2013-07-15','14:15:00',6.15),('10318','2013-07-15','14:20:00',6.11),('10318','2013-07-15','14:25:00',3.79),('10318','2013-07-15','14:30:00',3.22),('10318','2013-07-15','14:35:00',2.41),('10318','2013-07-15','14:40:00',7.06),('10318','2013-07-15','14:45:00',7.18),('10318','2013-07-15','14:50:00',8.38),('10318','2013-07-15','14:55:00',8.24),('10318','2013-07-15','15:00:00',8.04),('10318','2013-07-15','15:05:00',8.01),('10318','2013-07-15','15:10:00',7.75),('10318','2013-07-15','15:15:00',7.61),('10318','2013-07-15','15:20:00',6.85),('10318','2013-07-15','15:25:00',3.3),('10318','2013-07-15','15:30:00',1.63),('10318','2013-07-15','15:35:00',2.31),('10318','2013-07-15','15:40:00',7.45),('10318','2013-07-15','15:45:00',6.29),('10318','2013-07-15','15:50:00',6.73),('10318','2013-07-15','15:55:00',6.84),('10318','2013-07-15','16:00:00',6.73),('10318','2013-07-15','16:05:00',6.43),('10318','2013-07-15','16:10:00',6.28),('10318','2013-07-15','16:15:00',6.1),('10318','2013-07-15','16:20:00',5.93),('10318','2013-07-15','16:25:00',5.83),('10318','2013-07-15','16:30:00',5.65),('10318','2013-07-15','16:35:00',5.48),('10318','2013-07-15','16:40:00',5.33),('10318','2013-07-15','16:45:00',5.06),('10318','2013-07-15','16:50:00',5.03),('10318','2013-07-15','16:55:00',4.89),('10318','2013-07-15','17:00:00',4.76),('10318','2013-07-15','17:05:00',4.56),('10318','2013-07-15','17:10:00',4.37),('10318','2013-07-15','17:15:00',4.19),('10318','2013-07-15','17:20:00',4.06),('10318','2013-07-15','17:25:00',3.89),('10318','2013-07-15','17:30:00',3.73),('10318','2013-07-15','17:35:00',3.53),('10318','2013-07-15','17:40:00',3.31),('10318','2013-07-15','17:45:00',3.14),('10318','2013-07-15','17:50:00',3),('10318','2013-07-15','17:55:00',2.81),('10318','2013-07-15','18:00:00',2.64),('10318','2013-07-15','18:05:00',2.51),('10318','2013-07-15','18:10:00',2.34),('10318','2013-07-15','18:15:00',2.18),('10318','2013-07-15','18:20:00',2),('10318','2013-07-15','18:25:00',1.88),('10318','2013-07-15','18:30:00',1.73),('10318','2013-07-15','18:35:00',1.54),('10318','2013-07-15','18:40:00',1.46),('10318','2013-07-15','18:45:00',1.33),('10318','2013-07-15','18:50:00',1.22),('10318','2013-07-15','18:55:00',1.12),('10318','2013-07-15','19:00:00',1.03),('10318','2013-07-14','07:35:00',1.46),('10318','2013-07-14','07:40:00',1.37),('10318','2013-07-14','07:45:00',1.93),('10318','2013-07-14','07:50:00',2.69),('10318','2013-07-14','07:55:00',3.08),('10318','2013-07-14','08:00:00',2.83),('10318','2013-07-14','08:05:00',2.94),('10318','2013-07-14','08:10:00',4.01),('10318','2013-07-14','08:15:00',3.71),('10318','2013-07-14','08:20:00',4.28),('10318','2013-07-14','08:25:00',2.15),('10318','2013-07-14','08:30:00',2.41),('10318','2013-07-14','08:35:00',2.84),('10318','2013-07-14','08:40:00',2.37),('10318','2013-07-14','08:45:00',2.2),('10318','2013-07-14','08:50:00',2.56),('10318','2013-07-14','08:55:00',2.72),('10318','2013-07-14','09:00:00',4.75),('10318','2013-07-14','09:05:00',3.27),('10318','2013-07-14','09:10:00',3.49),('10318','2013-07-14','09:15:00',4.15),('10318','2013-07-14','09:20:00',4.73),('10318','2013-07-14','09:25:00',6.6),('10318','2013-07-14','09:30:00',4.67),('10318','2013-07-14','09:35:00',5.19),('10318','2013-07-14','09:40:00',3.8),('10318','2013-07-14','09:45:00',3.71),('10318','2013-07-14','09:50:00',3.57),('10318','2013-07-14','09:55:00',3.84),('10318','2013-07-14','10:00:00',3.84),('10318','2013-07-14','10:05:00',4.12),('10318','2013-07-14','10:10:00',3.53),('10318','2013-07-14','10:15:00',4.24),('10318','2013-07-14','10:20:00',6.79),('10318','2013-07-14','10:25:00',8.41),('10318','2013-07-14','10:30:00',6.73),('10318','2013-07-14','10:35:00',6.93),('10318','2013-07-14','10:40:00',5.86),('10318','2013-07-14','10:45:00',9.65),('10318','2013-07-14','10:50:00',9.17),('10318','2013-07-14','10:55:00',8.9),('10318','2013-07-14','11:00:00',8.23),('10318','2013-07-14','11:05:00',7.52),('10318','2013-07-14','11:10:00',5.35),('10318','2013-07-14','11:15:00',8.4),('10318','2013-07-14','11:20:00',9.46),('10318','2013-07-14','11:25:00',9.55),('10318','2013-07-14','11:30:00',9.2),('10318','2013-07-14','11:35:00',8.97),('10318','2013-07-14','11:40:00',9.34),('10318','2013-07-14','11:45:00',9.67),('10318','2013-07-14','11:50:00',9.57),('10318','2013-07-14','11:55:00',9.37),('10318','2013-07-14','12:00:00',7.84),('10318','2013-07-14','12:05:00',2.53),('10318','2013-07-14','12:10:00',3.17),('10318','2013-07-14','12:15:00',4.88),('10318','2013-07-14','12:20:00',3.65),('10318','2013-07-14','12:25:00',9.63),('10318','2013-07-14','12:30:00',7.3),('10318','2013-07-14','12:35:00',3.95),('10318','2013-07-14','12:40:00',3.76),('10318','2013-07-14','12:45:00',7.37),('10318','2013-07-14','12:50:00',10.35),('10318','2013-07-14','12:55:00',8.45),('10318','2013-07-14','13:00:00',4.56),('10318','2013-07-14','13:05:00',4.98),('10318','2013-07-14','13:10:00',9.76),('10318','2013-07-14','13:15:00',8.11),('10318','2013-07-14','13:20:00',9.25),('10318','2013-07-14','13:25:00',9.28),('10318','2013-07-14','13:30:00',9.19),('10318','2013-07-14','13:35:00',9.16),('10318','2013-07-14','13:40:00',9.14),('10318','2013-07-14','13:45:00',9.19),('10318','2013-07-14','13:50:00',9.19),('10318','2013-07-14','13:55:00',9.2),('10318','2013-07-14','14:00:00',9.18),('10318','2013-07-14','14:05:00',9.12),('10318','2013-07-14','14:10:00',9.03),('10318','2013-07-14','14:15:00',8.96),('10318','2013-07-14','14:20:00',8.89),('10318','2013-07-14','14:25:00',8.85),('10318','2013-07-14','14:30:00',8.72),('10318','2013-07-14','14:35:00',8.59),('10318','2013-07-14','14:40:00',8.48),('10318','2013-07-14','14:45:00',8.43),('10318','2013-07-14','14:50:00',8.24),('10318','2013-07-14','14:55:00',7.93),('10318','2013-07-14','15:00:00',8.02),('10318','2013-07-14','15:05:00',7.91),('10318','2013-07-14','15:10:00',7.85),('10318','2013-07-14','15:15:00',7.69),('10318','2013-07-14','15:20:00',7.61),('10318','2013-07-14','15:25:00',7.44),('10318','2013-07-14','15:30:00',7.36),('10318','2013-07-14','15:35:00',7.21),('10318','2013-07-14','15:40:00',7.04),('10318','2013-07-14','15:45:00',6.94),('10318','2013-07-14','15:50:00',6.87),('10318','2013-07-14','15:55:00',6.76),('10318','2013-07-14','16:00:00',6.64),('10318','2013-07-14','16:05:00',6.33),('10318','2013-07-14','16:10:00',6.45),('10318','2013-07-14','16:15:00',5.24),('10318','2013-07-14','16:20:00',6.45),('10318','2013-07-14','16:25:00',6.45),('10318','2013-07-14','16:30:00',6.21),('10318','2013-07-14','16:35:00',4.4),('10318','2013-07-14','16:40:00',2.8),('10318','2013-07-14','16:45:00',4.1),('10318','2013-07-14','16:50:00',3.39),('10318','2013-07-14','16:55:00',4.74),('10318','2013-07-14','17:00:00',3.78),('10318','2013-07-14','17:05:00',5.01),('10318','2013-07-14','17:10:00',4.75),('10318','2013-07-14','17:15:00',2.77),('10318','2013-07-14','17:20:00',2.59),('10318','2013-07-14','17:25:00',3.62),('10318','2013-07-14','17:30:00',2.85),('10318','2013-07-14','17:35:00',4.06),('10318','2013-07-14','17:40:00',3.11),('10318','2013-07-14','17:45:00',3.14),('10318','2013-07-14','17:50:00',3.35),('10318','2013-07-14','17:55:00',1.62),('10318','2013-07-14','18:00:00',2.64),('10318','2013-07-14','18:05:00',2.17),('10318','2013-07-14','18:10:00',1.66),('10318','2013-07-14','18:35:00',1.2),('10318','2013-07-14','18:40:00',1.39),('10318','2013-07-14','18:45:00',1.57),('10318','2013-07-14','18:50:00',1.36),('10318','2013-07-14','18:55:00',1.18),('10318','2013-07-14','19:00:00',1.03),('10318','2013-07-14','19:05:00',1.22),('10318','2013-07-14','19:10:00',1.4),('10318','2013-07-14','19:15:00',1.6),('10318','2013-07-14','19:20:00',1.28),('10318','2013-07-13','07:15:00',1.15),('10318','2013-07-13','07:20:00',1.69),('10318','2013-07-13','07:25:00',2.12),('10318','2013-07-13','07:30:00',2.18),('10318','2013-07-13','07:35:00',2.35),('10318','2013-07-13','07:40:00',2.55),('10318','2013-07-13','07:45:00',2.73),('10318','2013-07-13','07:50:00',2.95),('10318','2013-07-13','07:55:00',3.15),('10318','2013-07-13','08:00:00',3.34),('10318','2013-07-13','08:05:00',3.54),('10318','2013-07-13','08:10:00',3.77),('10318','2013-07-13','08:15:00',3.99),('10318','2013-07-13','08:20:00',4.17),('10318','2013-07-13','08:25:00',4.33),('10318','2013-07-13','08:30:00',4.4),('10318','2013-07-13','08:35:00',4.69),('10318','2013-07-13','08:40:00',4.89),('10318','2013-07-13','08:45:00',5.03),('10318','2013-07-13','08:50:00',5.22),('10318','2013-07-13','08:55:00',5.4),('10318','2013-07-13','09:00:00',5.58),('10318','2013-07-13','09:05:00',5.77),('10318','2013-07-13','09:10:00',5.89),('10318','2013-07-13','09:15:00',6.05),('10318','2013-07-13','09:20:00',6.17),('10318','2013-07-13','09:25:00',6.23),('10318','2013-07-13','09:30:00',6.32),('10318','2013-07-13','09:35:00',6.43),('10318','2013-07-13','09:40:00',6.66),('10318','2013-07-13','09:45:00',6.83),('10318','2013-07-13','09:50:00',7.02),('10318','2013-07-13','09:55:00',7.06),('10318','2013-07-13','10:00:00',7.15),('10318','2013-07-13','10:05:00',7.31),('10318','2013-07-13','10:10:00',7.46),('10318','2013-07-13','10:15:00',7.41),('10318','2013-07-13','10:20:00',7.45),('10318','2013-07-13','10:25:00',7.85),('10318','2013-07-13','10:30:00',7.99),('10318','2013-07-13','10:35:00',8.13),('10318','2013-07-13','10:40:00',8.16),('10318','2013-07-13','10:45:00',8.24),('10318','2013-07-13','10:50:00',7.88),('10318','2013-07-13','10:55:00',8.91),('10318','2013-07-13','11:00:00',8.89),('10318','2013-07-13','11:05:00',5.66),('10318','2013-07-13','11:10:00',6.93),('10318','2013-07-13','11:15:00',8.9),('10318','2013-07-13','11:20:00',4.05),('10318','2013-07-13','11:25:00',9.5),('10318','2013-07-13','11:30:00',9.17),('10318','2013-07-13','11:35:00',9.47),('10318','2013-07-13','11:40:00',9.02),('10318','2013-07-13','11:45:00',8.87),('10318','2013-07-13','11:50:00',8.83),('10318','2013-07-13','11:55:00',4.75),('10318','2013-07-13','12:00:00',9.39),('10318','2013-07-13','12:05:00',9.52),('10318','2013-07-13','12:10:00',8.77),('10318','2013-07-13','12:15:00',9.49),('10318','2013-07-13','12:20:00',7.56),('10318','2013-07-13','12:25:00',7.1),('10318','2013-07-13','12:30:00',5.32),('10318','2013-07-13','12:35:00',5.75),('10318','2013-07-13','12:40:00',9.78),('10318','2013-07-13','12:45:00',9.7),('10318','2013-07-13','12:50:00',8.42),('10318','2013-07-13','12:55:00',5.35),('10318','2013-07-13','13:00:00',8.25),('10318','2013-07-13','13:05:00',9.75),('10318','2013-07-13','13:10:00',9.21),('10318','2013-07-13','13:15:00',8.95),('10318','2013-07-13','13:20:00',9.17),('10318','2013-07-13','13:25:00',9.21),('10318','2013-07-13','13:30:00',9.21),('10318','2013-07-13','13:35:00',9.14),('10318','2013-07-13','13:40:00',9.03),('10318','2013-07-13','13:45:00',9.08),('10318','2013-07-13','13:50:00',9.01),('10318','2013-07-13','13:55:00',8.91),('10318','2013-07-13','14:00:00',8.92),('10318','2013-07-13','14:05:00',8.81),('10318','2013-07-13','14:10:00',8.79),('10318','2013-07-13','14:15:00',8.71),('10318','2013-07-13','14:20:00',8.67),('10318','2013-07-13','14:25:00',8.58),('10318','2013-07-13','14:30:00',8.53),('10318','2013-07-13','14:35:00',8.47),('10318','2013-07-13','14:40:00',8.42),('10318','2013-07-13','14:45:00',8.31),('10318','2013-07-13','14:50:00',8.22),('10318','2013-07-13','14:55:00',8.2),('10318','2013-07-13','15:00:00',7.99),('10318','2013-07-13','15:05:00',7.83),('10318','2013-07-13','15:10:00',7.9),('10318','2013-07-13','15:15:00',7.86),('10318','2013-07-13','15:20:00',7.49),('10318','2013-07-13','15:25:00',7.82),('10318','2013-07-13','15:30:00',7.51),('10318','2013-07-13','15:35:00',7.54),('10318','2013-07-13','15:40:00',7.35),('10318','2013-07-13','15:45:00',7.21),('10318','2013-07-13','15:50:00',7.06),('10318','2013-07-13','15:55:00',6.89),('10318','2013-07-13','16:00:00',6.72),('10318','2013-07-13','16:05:00',6.56),('10318','2013-07-13','16:10:00',6.49),('10318','2013-07-13','16:15:00',6.13),('10318','2013-07-13','16:20:00',6.17),('10318','2013-07-13','16:25:00',6.03),('10318','2013-07-13','16:30:00',5.9),('10318','2013-07-13','16:35:00',5.71),('10318','2013-07-13','16:40:00',5.56),('10318','2013-07-13','16:45:00',5.41),('10318','2013-07-13','16:50:00',5.13),('10318','2013-07-13','16:55:00',5.02),('10318','2013-07-13','17:00:00',4.87),('10318','2013-07-13','17:05:00',4.62),('10318','2013-07-13','17:10:00',4.59),('10318','2013-07-13','17:15:00',4.4),('10318','2013-07-13','17:20:00',4.02),('10318','2013-07-13','17:25:00',4.09),('10318','2013-07-13','17:30:00',3.76),('10318','2013-07-13','17:35:00',3.64),('10318','2013-07-13','17:40:00',3.47),('10318','2013-07-13','17:45:00',3.36),('10318','2013-07-13','17:50:00',3.14),('10318','2013-07-13','17:55:00',3.05),('10318','2013-07-13','18:00:00',2.77),('10318','2013-07-13','18:05:00',2.55),('10318','2013-07-13','18:10:00',2.44),('10318','2013-07-13','18:15:00',2.31),('10318','2013-07-13','18:20:00',2.16),('10318','2013-07-13','18:25:00',2),('10318','2013-07-13','18:30:00',1.8),('10318','2013-07-13','18:35:00',1.46),('10318','2013-07-13','18:40:00',1.03),('10318','2013-07-13','18:50:00',1.29),('10318','2013-07-13','18:55:00',1.32),('10318','2013-07-13','19:00:00',1.14),('10318','2013-07-12','07:05:00',1.15),('10318','2013-07-12','07:10:00',1.26),('10318','2013-07-12','07:15:00',1.51),('10318','2013-07-12','07:20:00',1.46),('10318','2013-07-12','07:25:00',2.03),('10318','2013-07-12','07:30:00',1.6),('10318','2013-07-12','07:35:00',1.2),('10318','2013-07-12','07:40:00',1.48),('10318','2013-07-12','07:45:00',1.38),('10318','2013-07-12','07:50:00',1.19),('10318','2013-07-12','08:00:00',1.29),('10318','2013-07-12','08:05:00',1.6),('10318','2013-07-12','08:10:00',2.21),('10318','2013-07-12','08:15:00',2.47),('10318','2013-07-12','08:20:00',1.8),('10318','2013-07-12','08:25:00',1.8),('10318','2013-07-12','08:30:00',2.09),('10318','2013-07-12','08:35:00',2.56),('10318','2013-07-12','08:40:00',2.37),('10318','2013-07-12','08:45:00',1.97),('10318','2013-07-12','08:50:00',2.01),('10318','2013-07-12','08:55:00',1.79),('10318','2013-07-12','09:00:00',2.92),('10318','2013-07-12','09:05:00',5.68),('10318','2013-07-12','09:10:00',6.79),('10318','2013-07-12','09:15:00',4.7),('10318','2013-07-12','09:20:00',2.91),('10318','2013-07-12','09:25:00',3.8),('10318','2013-07-12','09:30:00',3.85),('10318','2013-07-12','09:35:00',4.38),('10318','2013-07-12','09:40:00',6.04),('10318','2013-07-12','09:45:00',6.86),('10318','2013-07-12','09:50:00',6.98),('10318','2013-07-12','09:55:00',6.86),('10318','2013-07-12','10:00:00',7.46),('10318','2013-07-12','10:05:00',7.87),('10318','2013-07-12','10:10:00',5.21),('10318','2013-07-12','10:15:00',3.61),('10318','2013-07-12','10:20:00',5.35),('10318','2013-07-12','10:25:00',7.77),('10318','2013-07-12','10:30:00',8.11),('10318','2013-07-12','10:35:00',8.27),('10318','2013-07-12','10:40:00',3.78),('10318','2013-07-12','10:45:00',3.2),('10318','2013-07-12','10:50:00',2.87),('10318','2013-07-12','10:55:00',2.9),('10318','2013-07-12','11:00:00',5.9),('10318','2013-07-12','11:05:00',4.3),('10318','2013-07-12','11:10:00',9.23),('10318','2013-07-12','11:15:00',6.12),('10318','2013-07-12','11:20:00',2.5),('10318','2013-07-12','11:25:00',3.66),('10318','2013-07-12','11:30:00',5.99),('10318','2013-07-12','11:35:00',10.11),('10318','2013-07-12','11:40:00',5.15),('10318','2013-07-12','11:45:00',5.72),('10318','2013-07-12','11:50:00',6.89),('10318','2013-07-12','11:55:00',5.02),('10318','2013-07-12','12:00:00',9.84),('10318','2013-07-12','12:05:00',9.61),('10318','2013-07-12','12:10:00',3.47),('10318','2013-07-12','12:15:00',6.18),('10318','2013-07-12','12:20:00',7.71),('10318','2013-07-12','12:25:00',4.96),('10318','2013-07-12','12:30:00',3.85),('10318','2013-07-12','12:35:00',6.12),('10318','2013-07-12','12:40:00',5.01),('10318','2013-07-12','12:45:00',10.35),('10318','2013-07-12','12:50:00',8.29),('10318','2013-07-12','12:55:00',8.36),('10318','2013-07-12','13:00:00',9.2),('10318','2013-07-12','13:05:00',8.51),('10318','2013-07-12','13:10:00',9.53),('10318','2013-07-12','13:15:00',8.36),('10318','2013-07-12','13:20:00',9.47),('10318','2013-07-12','13:25:00',8.16),('10318','2013-07-12','13:30:00',9.45),('10318','2013-07-12','13:35:00',9.12),('10318','2013-07-12','13:40:00',9.36),('10318','2013-07-12','13:45:00',9.36),('10318','2013-07-12','13:50:00',7.37),('10318','2013-07-12','13:55:00',7.9),('10318','2013-07-12','14:00:00',9.74),('10318','2013-07-12','14:05:00',7.77),('10318','2013-07-12','14:10:00',5.74),('10318','2013-07-12','14:15:00',9.48),('10318','2013-07-12','14:20:00',5.82),('10318','2013-07-12','14:25:00',8.33),('10318','2013-07-12','14:30:00',8.82),('10318','2013-07-12','14:35:00',8.59),('10318','2013-07-12','14:40:00',8.58),('10318','2013-07-12','14:45:00',8.08),('10318','2013-07-12','14:50:00',8.14),('10318','2013-07-12','14:55:00',8.02),('10318','2013-07-12','15:00:00',7.96),('10318','2013-07-12','15:05:00',7.93),('10318','2013-07-12','15:10:00',7.68),('10318','2013-07-12','15:15:00',6.32),('10318','2013-07-12','15:20:00',7.38),('10318','2013-07-12','15:25:00',7.52),('10318','2013-07-12','15:30:00',6.7),('10318','2013-07-12','15:35:00',6.98),('10318','2013-07-12','15:40:00',7.12),('10318','2013-07-12','15:45:00',7.07),('10318','2013-07-12','15:50:00',6.8),('10318','2013-07-12','15:55:00',6.72),('10318','2013-07-12','16:00:00',6.51),('10318','2013-07-12','16:05:00',6.46),('10318','2013-07-12','16:10:00',6.26),('10318','2013-07-12','16:15:00',6.13),('10318','2013-07-12','16:20:00',6.02),('10318','2013-07-12','16:25:00',5.79),('10318','2013-07-12','16:30:00',5.55),('10318','2013-07-12','16:35:00',5.48),('10318','2013-07-12','16:40:00',5.34),('10318','2013-07-12','16:45:00',5.22),('10318','2013-07-12','16:50:00',5.1),('10318','2013-07-12','16:55:00',4.9),('10318','2013-07-12','17:00:00',4.71),('10318','2013-07-12','17:05:00',4.58),('10318','2013-07-12','17:10:00',4.37),('10318','2013-07-12','17:15:00',4.2),('10318','2013-07-12','17:20:00',4.06),('10318','2013-07-12','17:25:00',3.86),('10318','2013-07-12','17:30:00',3.7),('10318','2013-07-12','17:35:00',3.51),('10318','2013-07-12','17:40:00',3.32),('10318','2013-07-12','17:45:00',3.15),('10318','2013-07-12','17:50:00',3.03),('10318','2013-07-12','17:55:00',2.85),('10318','2013-07-12','18:00:00',2.66),('10318','2013-07-12','18:05:00',2.53),('10318','2013-07-12','18:10:00',2.36),('10318','2013-07-12','18:15:00',2.16),('10318','2013-07-12','18:20:00',2.05),('10318','2013-07-12','18:25:00',1.94),('10318','2013-07-12','18:30:00',1.77),('10318','2013-07-12','18:35:00',1.6),('10318','2013-07-12','18:40:00',1.5),('10318','2013-07-12','18:45:00',1.36),('10318','2013-07-12','18:50:00',1.21),('10318','2013-07-12','18:55:00',1.12),('10318','2013-07-11','07:05:00',1.09),('10318','2013-07-11','07:10:00',1.31),('10318','2013-07-11','07:15:00',1.54),('10318','2013-07-11','07:20:00',1.74),('10318','2013-07-11','07:25:00',2.04),('10318','2013-07-11','07:30:00',2.24),('10318','2013-07-11','07:35:00',2.46),('10318','2013-07-11','07:40:00',2.63),('10318','2013-07-11','07:45:00',2.9),('10318','2013-07-11','07:50:00',3.08),('10318','2013-07-11','07:55:00',3.27),('10318','2013-07-11','08:00:00',3.42),('10318','2013-07-11','08:05:00',3.64),('10318','2013-07-11','08:10:00',3.8),('10318','2013-07-11','08:15:00',3.99),('10318','2013-07-11','08:20:00',4.2),('10318','2013-07-11','08:25:00',4.38),('10318','2013-07-11','08:30:00',4.51),('10318','2013-07-11','08:35:00',4.68),('10318','2013-07-11','08:40:00',4.89),('10318','2013-07-11','08:45:00',4.91),('10318','2013-07-11','08:50:00',5.14),('10318','2013-07-11','08:55:00',5.4),('10318','2013-07-11','09:00:00',5.54),('10318','2013-07-11','09:05:00',5.8),('10318','2013-07-11','09:10:00',5.99),('10318','2013-07-11','09:15:00',6.18),('10318','2013-07-11','09:20:00',6.2),('10318','2013-07-11','09:25:00',6.27),('10318','2013-07-11','09:30:00',6.68),('10318','2013-07-11','09:35:00',6.74),('10318','2013-07-11','09:40:00',7.08),('10318','2013-07-11','09:45:00',7.31),('10318','2013-07-11','09:50:00',6.83),('10318','2013-07-11','09:55:00',6.12),('10318','2013-07-11','10:00:00',7.9),('10318','2013-07-11','10:05:00',7.94),('10318','2013-07-11','10:10:00',8.05),('10318','2013-07-11','10:15:00',4.69),('10318','2013-07-11','10:20:00',3.13),('10318','2013-07-11','10:25:00',4.14),('10318','2013-07-11','10:30:00',5.95),('10318','2013-07-11','10:35:00',5.28),('10318','2013-07-11','10:40:00',8.8),('10318','2013-07-11','10:45:00',4.39),('10318','2013-07-11','10:50:00',2.46),('10318','2013-07-11','10:55:00',2.48),('10318','2013-07-11','11:00:00',2.93),('10318','2013-07-11','11:05:00',9.68),('10318','2013-07-11','11:10:00',6.32),('10318','2013-07-11','11:15:00',4.22),('10318','2013-07-11','11:20:00',3.28),('10318','2013-07-11','11:25:00',7.74),('10318','2013-07-11','11:30:00',10.11),('10318','2013-07-11','11:35:00',6.73),('10318','2013-07-11','11:40:00',6.22),('10318','2013-07-11','11:45:00',3.55),('10318','2013-07-11','11:50:00',5.16),('10318','2013-07-11','11:55:00',6.23),('10318','2013-07-11','12:00:00',9.04),('10318','2013-07-11','12:05:00',8.21),('10318','2013-07-11','12:10:00',3.12),('10318','2013-07-11','12:15:00',5.28),('10318','2013-07-11','12:20:00',8.73),('10318','2013-07-11','12:25:00',4.58),('10318','2013-07-11','12:30:00',7.98),('10318','2013-07-11','12:35:00',9.09),('10318','2013-07-11','12:40:00',10.11),('10318','2013-07-11','12:45:00',6.01),('10318','2013-07-11','12:50:00',9.97),('10318','2013-07-11','12:55:00',9.56),('10318','2013-07-11','13:00:00',9.48),('10318','2013-07-11','13:05:00',9.68),('10318','2013-07-11','13:10:00',7.16),('10318','2013-07-11','13:15:00',9.77),('10318','2013-07-11','13:20:00',9.53),('10318','2013-07-11','13:25:00',8.3),('10318','2013-07-11','13:30:00',8.89),('10318','2013-07-11','13:35:00',9.51),('10318','2013-07-11','13:40:00',9.44),('10318','2013-07-11','13:45:00',8.98),('10318','2013-07-11','13:50:00',9.09),('10318','2013-07-11','13:55:00',9.04),('10318','2013-07-11','14:00:00',8.88),('10318','2013-07-11','14:05:00',8.73),('10318','2013-07-11','14:10:00',8.78),('10318','2013-07-11','14:15:00',8.78),('10318','2013-07-11','14:20:00',8.67),('10318','2013-07-11','14:25:00',8.74),('10318','2013-07-11','14:30:00',8.65),('10318','2013-07-11','14:35:00',8.53),('10318','2013-07-11','14:40:00',8.44),('10318','2013-07-11','14:45:00',8.35),('10318','2013-07-11','14:50:00',8.33),('10318','2013-07-11','14:55:00',8.35),('10318','2013-07-11','15:00:00',7.31),('10318','2013-07-11','15:05:00',8.28),('10318','2013-07-11','15:10:00',8.11),('10318','2013-07-11','15:15:00',8.09),('10318','2013-07-11','15:20:00',7.87),('10318','2013-07-11','15:25:00',7.75),('10318','2013-07-11','15:30:00',7.43),('10318','2013-07-11','15:35:00',7.5),('10318','2013-07-11','15:40:00',7.34),('10318','2013-07-11','15:45:00',7.38),('10318','2013-07-11','15:50:00',7.35),('10318','2013-07-11','15:55:00',7.19),('10318','2013-07-11','16:00:00',7.17),('10318','2013-07-11','16:05:00',5.94),('10318','2013-07-11','16:10:00',6.67),('10318','2013-07-11','16:15:00',4.91),('10318','2013-07-11','16:20:00',5.34),('10318','2013-07-11','16:25:00',4.85),('10318','2013-07-11','16:30:00',5.99),('10318','2013-07-11','16:35:00',5.77),('10318','2013-07-11','16:40:00',5.24),('10318','2013-07-11','16:45:00',4.77),('10318','2013-07-11','16:50:00',5.37),('10318','2013-07-11','16:55:00',4.47),('10318','2013-07-11','17:00:00',4.75),('10318','2013-07-11','17:05:00',5.2),('10318','2013-07-11','17:10:00',4.19),('10318','2013-07-11','17:15:00',5.13),('10318','2013-07-11','17:20:00',4.6),('10318','2013-07-11','17:25:00',3.84),('10318','2013-07-11','17:30:00',4.1),('10318','2013-07-11','17:35:00',3.81),('10318','2013-07-11','17:40:00',3.07),('10318','2013-07-11','17:45:00',3.23),('10318','2013-07-11','17:50:00',3.16),('10318','2013-07-11','17:55:00',3.16),('10318','2013-07-11','18:00:00',3.29),('10318','2013-07-11','18:05:00',2.92),('10318','2013-07-11','18:10:00',2.55),('10318','2013-07-11','18:15:00',2.49),('10318','2013-07-11','18:20:00',2.41),('10318','2013-07-11','18:25:00',2.21),('10318','2013-07-11','18:30:00',1.29),('10318','2013-07-11','18:35:00',1.3),('10318','2013-07-11','18:40:00',1.13),('10318','2014-05-03','07:15:00',1.28),('10318','2014-05-03','07:20:00',2.03),('10318','2014-05-03','07:25:00',2.36),('10318','2014-05-03','07:30:00',2.63),('10318','2014-05-03','07:35:00',3.02),('10318','2014-05-03','07:40:00',3.31),('10318','2014-05-03','07:45:00',3.53),('10318','2014-05-03','07:50:00',3.76),('10318','2014-05-03','07:55:00',4.02),('10318','2014-05-03','08:00:00',4.56),('10318','2014-05-03','08:05:00',5.36),('10318','2014-05-03','08:10:00',4.95),('10318','2014-05-03','08:15:00',2.89),('10318','2014-05-03','08:20:00',4.15),('10318','2014-05-03','08:25:00',4.25),('10318','2014-05-03','08:30:00',4),('10318','2014-05-03','08:35:00',1.82),('10318','2014-05-03','08:40:00',6.17),('10318','2014-05-03','08:45:00',6.47),('10318','2014-05-03','08:50:00',6.1),('10318','2014-05-03','08:55:00',3.75),('10318','2014-05-03','09:00:00',2.21),('10318','2014-05-03','09:05:00',3.03),('10318','2014-05-03','09:10:00',6.21),('10318','2014-05-03','09:15:00',6.39),('10318','2014-05-03','09:20:00',2.71),('10318','2014-05-03','09:25:00',4.87),('10318','2014-05-03','09:30:00',7.15),('10318','2014-05-03','09:35:00',9.31),('10318','2014-05-03','09:40:00',9.22),('10318','2014-05-03','09:45:00',9.57),('10318','2014-05-03','09:50:00',7.81),('10318','2014-05-03','09:55:00',8.01),('10318','2014-05-03','10:00:00',8.61),('10318','2014-05-03','10:05:00',7.45),('10318','2014-05-03','10:10:00',7.01),('10318','2014-05-03','10:15:00',5.62),('10318','2014-05-03','10:20:00',1.93),('10318','2014-05-03','10:25:00',4.1),('10318','2014-05-03','10:30:00',9.86),('10318','2014-05-03','10:35:00',6.72),('10318','2014-05-03','10:40:00',3.72),('10318','2014-05-03','10:45:00',4.28),('10318','2014-05-03','10:50:00',11.26),('10318','2014-05-03','10:55:00',11.19),('10318','2014-05-03','11:00:00',10.78),('10318','2014-05-03','11:05:00',8.45),('10318','2014-05-03','11:10:00',5.82),('10318','2014-05-03','11:15:00',8.63),('10318','2014-05-03','11:20:00',6.53),('10318','2014-05-03','11:25:00',9.5),('10318','2014-05-03','11:30:00',5.81),('10318','2014-05-03','11:35:00',6.59),('10318','2014-05-03','11:40:00',6.02),('10318','2014-05-03','11:45:00',8.32),('10318','2014-05-03','11:50:00',7.84),('10318','2014-05-03','11:55:00',5.63),('10318','2014-05-03','12:00:00',4.77),('10318','2014-05-03','12:05:00',3.17),('10318','2014-05-03','12:10:00',2.68),('10318','2014-05-03','12:15:00',2.73),('10318','2014-05-03','12:20:00',2.66),('10318','2014-05-03','12:25:00',2.62),('10318','2014-05-03','12:30:00',2.97),('10318','2014-05-03','12:35:00',4.04),('10318','2014-05-03','12:40:00',4.75),('10318','2014-05-03','12:45:00',4.65),('10318','2014-05-03','12:50:00',3.86),('10318','2014-05-03','12:55:00',3.68),('10318','2014-05-03','13:00:00',4.66),('10318','2014-05-03','13:05:00',7.55),('10318','2014-05-03','13:10:00',8.95),('10318','2014-05-03','13:15:00',8.16),('10318','2014-05-03','13:20:00',6.7),('10318','2014-05-03','13:25:00',6.29),('10318','2014-05-03','13:30:00',5.64),('10318','2014-05-03','13:35:00',6.12),('10318','2014-05-03','13:40:00',5.99),('10318','2014-05-03','13:45:00',5.86),('10318','2014-05-03','13:50:00',5.5),('10318','2014-05-03','13:55:00',4.67),('10318','2014-05-03','14:00:00',4.57),('10318','2014-05-03','14:05:00',4.59),('10318','2014-05-03','14:10:00',5.19),('10318','2014-05-03','14:15:00',5.95),('10318','2014-05-03','14:20:00',6.66),('10318','2014-05-03','14:25:00',6.62),('10318','2014-05-03','14:30:00',7.77),('10318','2014-05-03','14:35:00',5.48),('10318','2014-05-03','14:40:00',2.31),('10318','2014-05-03','14:45:00',1.46),('10318','2014-05-03','14:55:00',1.07),('10318','2014-05-03','15:00:00',1.53),('10318','2014-05-03','15:05:00',1.28),('10318','2014-05-03','15:10:00',1.43),('10318','2014-05-03','15:15:00',1.26),('10318','2014-05-03','15:20:00',1.41),('10318','2014-05-03','15:25:00',1.6),('10318','2014-05-03','15:30:00',1.56),('10318','2014-05-03','15:35:00',1.36),('10318','2014-05-03','15:40:00',1.3),('10318','2014-05-03','15:45:00',1.21),('10318','2014-05-03','15:50:00',1.06),('10318','2014-05-03','16:25:00',1.17),('10318','2014-05-03','16:30:00',1.36),('10318','2014-05-03','16:35:00',1.53),('10318','2014-05-03','16:40:00',1.69),('10318','2014-05-03','16:45:00',1.82),('10318','2014-05-03','16:50:00',1.91),('10318','2014-05-03','16:55:00',2),('10318','2014-05-03','17:00:00',2.05),('10318','2014-05-03','17:05:00',2.08),('10318','2014-05-03','17:10:00',2.1),('10318','2014-05-03','17:15:00',2.09),('10318','2014-05-03','17:20:00',2.09),('10318','2014-05-03','17:25:00',2.13),('10318','2014-05-03','17:30:00',2.1),('10318','2014-05-03','17:35:00',2.11),('10318','2014-05-03','17:40:00',2.25),('10318','2014-05-03','17:45:00',2.5),('10318','2014-05-03','17:50:00',2.6),('10318','2014-05-03','17:55:00',2.38),('10318','2014-05-03','18:00:00',2.09),('10318','2014-05-03','18:05:00',1.77),('10318','2014-05-03','18:10:00',1.54),('10318','2014-05-03','18:15:00',1.3),('10318','2014-05-03','18:20:00',1.25),('10318','2014-05-03','18:25:00',1.06),('10318','2014-05-03','18:55:00',1.09),('10318','2014-04-06','07:55:00',1.6),('10318','2014-04-06','08:00:00',1.62),('10318','2014-04-06','08:05:00',2.46),('10318','2014-04-06','08:10:00',3.21),('10318','2014-04-06','08:15:00',3.5),('10318','2014-04-06','08:20:00',2.62),('10318','2014-04-06','08:25:00',1.1),('10318','2014-04-06','08:40:00',3.6),('10318','2014-04-06','08:45:00',5.12),('10318','2014-04-06','08:50:00',5.31),('10318','2014-04-06','08:55:00',5.07),('10318','2014-04-06','09:00:00',5.68),('10318','2014-04-06','09:05:00',6.02),('10318','2014-04-06','09:10:00',6.16),('10318','2014-04-06','09:15:00',5.14),('10318','2014-04-06','09:20:00',3.97),('10318','2014-04-06','09:25:00',3.84),('10318','2014-04-06','09:30:00',3.92),('10318','2014-04-06','09:35:00',4.19),('10318','2014-04-06','09:40:00',5),('10318','2014-04-06','09:45:00',4.41),('10318','2014-04-06','09:50:00',8.17),('10318','2014-04-06','09:55:00',8.87),('10318','2014-04-06','10:00:00',9.25),('10318','2014-04-06','10:05:00',8.52),('10318','2014-04-06','10:10:00',7.46),('10318','2014-04-06','10:15:00',4.84),('10318','2014-04-06','10:20:00',6.2),('10318','2014-04-06','10:25:00',4.29),('10318','2014-04-06','10:30:00',3.21),('10318','2014-04-06','10:35:00',3.35),('10318','2014-04-06','10:40:00',3.59),('10318','2014-04-06','10:45:00',3.91),('10318','2014-04-06','10:50:00',6.3),('10318','2014-04-06','10:55:00',9.66),('10318','2014-04-06','11:00:00',4.08),('10318','2014-04-06','11:05:00',4.12),('10318','2014-04-06','11:10:00',7.1),('10318','2014-04-06','11:15:00',10.26),('10318','2014-04-06','11:20:00',9.88),('10318','2014-04-06','11:25:00',9.76),('10318','2014-04-06','11:30:00',9.72),('10318','2014-04-06','11:35:00',4.96),('10318','2014-04-06','11:40:00',4.23),('10318','2014-04-06','11:45:00',3.76),('10318','2014-04-06','11:50:00',2.86),('10318','2014-04-06','11:55:00',5.32),('10318','2014-04-06','12:00:00',3.73),('10318','2014-04-06','12:05:00',7.19),('10318','2014-04-06','12:10:00',5.28),('10318','2014-04-06','12:15:00',7.57),('10318','2014-04-06','12:20:00',3.57),('10318','2014-04-06','12:25:00',2.46),('10318','2014-04-06','12:30:00',7.08),('10318','2014-04-06','12:35:00',4.41),('10318','2014-04-06','12:40:00',7.01),('10318','2014-04-06','12:45:00',3.68),('10318','2014-04-06','12:50:00',6.64),('10318','2014-04-06','12:55:00',8.64),('10318','2014-04-06','13:00:00',8.21),('10318','2014-04-06','13:05:00',9.53),('10318','2014-04-06','13:10:00',8.23),('10318','2014-04-06','13:15:00',9.7),('10318','2014-04-06','13:20:00',8.87),('10318','2014-04-06','13:25:00',8.77),('10318','2014-04-06','13:30:00',5.19),('10318','2014-04-06','13:35:00',4.69),('10318','2014-04-06','13:40:00',5.37),('10318','2014-04-06','13:45:00',10.12),('10318','2014-04-06','13:50:00',9.79),('10318','2014-04-06','13:55:00',2.35),('10318','2014-04-06','14:00:00',2.24),('10318','2014-04-06','14:05:00',6.25),('10318','2014-04-06','14:10:00',2.22),('10318','2014-04-06','14:15:00',3.43),('10318','2014-04-06','14:20:00',4.87),('10318','2014-04-06','14:25:00',4.3),('10318','2014-04-06','14:30:00',3.23),('10318','2014-04-06','14:35:00',2.89),('10318','2014-04-06','14:40:00',5.24),('10318','2014-04-06','14:45:00',8.54),('10318','2014-04-06','14:50:00',3.99),('10318','2014-04-06','14:55:00',4.32),('10318','2014-04-06','15:00:00',3.24),('10318','2014-04-06','15:05:00',6.13),('10318','2014-04-06','15:10:00',2.48),('10318','2014-04-06','15:15:00',2.51),('10318','2014-04-06','15:20:00',2.2),('10318','2014-04-06','15:25:00',2.21),('10318','2014-04-06','15:30:00',1.84),('10318','2014-04-06','15:35:00',1.52),('10318','2014-04-06','15:40:00',1.57),('10318','2014-04-06','15:45:00',1.99),('10318','2014-04-06','15:50:00',2.82),('10318','2014-04-06','15:55:00',6.92),('10318','2014-04-06','16:00:00',5.59),('10318','2014-04-06','16:05:00',7.65),('10318','2014-04-06','16:10:00',7.18),('10318','2014-04-06','16:15:00',3.84),('10318','2014-04-06','16:20:00',3.06),('10318','2014-04-06','16:25:00',2.56),('10318','2014-04-06','16:30:00',2.33),('10318','2014-04-06','16:35:00',2.42),('10318','2014-04-06','16:40:00',2.07),('10318','2014-04-06','16:45:00',5.45),('10318','2014-04-06','16:50:00',5.87),('10318','2014-04-06','16:55:00',4.94),('10318','2014-04-06','17:00:00',3.28),('10318','2014-04-06','17:05:00',1.74),('10318','2014-04-06','17:10:00',1.32),('10318','2014-04-06','17:15:00',1.24),('10318','2014-04-06','17:20:00',1.73),('10318','2014-04-06','17:25:00',2.97),('10318','2014-04-06','17:30:00',3.08),('10318','2014-04-06','17:35:00',1.36),('10318','2014-04-06','17:40:00',2.36),('10318','2014-04-06','17:45:00',2.83),('10318','2014-04-06','17:50:00',2.53),('10318','2014-04-06','17:55:00',2.37),('10318','2014-04-06','18:00:00',2.1),('10318','2014-04-06','18:05:00',1.88),('10318','2014-04-06','18:10:00',1.77),('10318','2014-04-06','18:15:00',1.77),('10318','2014-04-06','18:20:00',1.77),('10318','2014-04-06','18:25:00',1.61),('10318','2014-04-06','18:30:00',1.27),('10318','2013-07-10','07:00:00',1.25),('10318','2013-07-10','07:05:00',1.5),('10318','2013-07-10','07:10:00',1.71),('10318','2013-07-10','07:15:00',2.04),('10318','2013-07-10','07:20:00',2.62),('10318','2013-07-10','07:25:00',3.05),('10318','2013-07-10','07:30:00',3.41),('10318','2013-07-10','07:35:00',3.76),('10318','2013-07-10','07:40:00',4.03),('10318','2013-07-10','07:45:00',4.27),('10318','2013-07-10','07:50:00',4.53),('10318','2013-07-10','07:55:00',4.59),('10318','2013-07-10','08:00:00',3.43),('10318','2013-07-10','08:05:00',3.07),('10318','2013-07-10','08:10:00',3.27),('10318','2013-07-10','08:15:00',3.68),('10318','2013-07-10','08:20:00',4.72),('10318','2013-07-10','08:25:00',3.8),('10318','2013-07-10','08:30:00',3.97),('10318','2013-07-10','08:35:00',5.58),('10318','2013-07-10','08:40:00',5.99),('10318','2013-07-10','08:45:00',5.97),('10318','2013-07-10','08:50:00',5.91),('10318','2013-07-10','08:55:00',5.67),('10318','2013-07-10','09:00:00',5.88),('10318','2013-07-10','09:05:00',5.87),('10318','2013-07-10','09:10:00',4.89),('10318','2013-07-10','09:15:00',4.88),('10318','2013-07-10','09:20:00',5.81),('10318','2013-07-10','09:25:00',6.59),('10318','2013-07-10','09:30:00',6.76),('10318','2013-07-10','09:35:00',6.82),('10318','2013-07-10','09:40:00',6.89),('10318','2013-07-10','09:45:00',6.99),('10318','2013-07-10','09:50:00',7.08),('10318','2013-07-10','09:55:00',7.21),('10318','2013-07-10','10:00:00',7.29),('10318','2013-07-10','10:05:00',7.4),('10318','2013-07-10','10:10:00',7.59),('10318','2013-07-10','10:15:00',7.69),('10318','2013-07-10','10:20:00',7.78),('10318','2013-07-10','10:25:00',7.74),('10318','2013-07-10','10:30:00',7.94),('10318','2013-07-10','10:35:00',8.01),('10318','2013-07-10','10:40:00',8.08),('10318','2013-07-10','10:45:00',8.11),('10318','2013-07-10','10:50:00',8.19),('10318','2013-07-10','10:55:00',8.28),('10318','2013-07-10','11:00:00',8.33),('10318','2013-07-10','11:05:00',8.37),('10318','2013-07-10','11:10:00',8.48),('10318','2013-07-10','11:15:00',8.52),('10318','2013-07-10','11:20:00',8.54),('10318','2013-07-10','11:25:00',8.58),('10318','2013-07-10','11:30:00',8.64),('10318','2013-07-10','11:35:00',8.57),('10318','2013-07-10','11:40:00',8.67),('10318','2013-07-10','11:45:00',8.73),('10318','2013-07-10','11:50:00',8.71),('10318','2013-07-10','11:55:00',8.66),('10318','2013-07-10','12:00:00',8.79),('10318','2013-07-10','12:05:00',8.82),('10318','2013-07-10','12:10:00',8.76),('10318','2013-07-10','12:15:00',8.86),('10318','2013-07-10','12:20:00',9.05),('10318','2013-07-10','12:25:00',8.89),('10318','2013-07-10','12:30:00',9.04),('10318','2013-07-10','12:35:00',9.07),('10318','2013-07-10','12:40:00',9.03),('10318','2013-07-10','12:45:00',9.1),('10318','2013-07-10','12:50:00',9.12),('10318','2013-07-10','12:55:00',9.19),('10318','2013-07-10','13:00:00',9.17),('10318','2013-07-10','13:05:00',9.12),('10318','2013-07-10','13:10:00',9.14),('10318','2013-07-10','13:15:00',9.22),('10318','2013-07-10','13:20:00',9.1),('10318','2013-07-10','13:25:00',9.14),('10318','2013-07-10','13:30:00',9.04),('10318','2013-07-10','13:35:00',9.06),('10318','2013-07-10','13:40:00',9.06),('10318','2013-07-10','13:45:00',8.96),('10318','2013-07-10','13:50:00',8.97),('10318','2013-07-10','13:55:00',8.63),('10318','2013-07-10','14:00:00',8.94),('10318','2013-07-10','14:05:00',8.94),('10318','2013-07-10','14:10:00',8.84),('10318','2013-07-10','14:15:00',8.82),('10318','2013-07-10','14:20:00',8.74),('10318','2013-07-10','14:25:00',8.67),('10318','2013-07-10','14:30:00',8.59),('10318','2013-07-10','14:35:00',8.55),('10318','2013-07-10','14:40:00',8.46),('10318','2013-07-10','14:45:00',8.35),('10318','2013-07-10','14:50:00',8.23),('10318','2013-07-10','14:55:00',8.16),('10318','2013-07-10','15:00:00',8.1),('10318','2013-07-10','15:05:00',8.03),('10318','2013-07-10','15:10:00',7.94),('10318','2013-07-10','15:15:00',7.85),('10318','2013-07-10','15:20:00',7.76),('10318','2013-07-10','15:25:00',7.62),('10318','2013-07-10','15:30:00',7.46),('10318','2013-07-10','15:35:00',7.29),('10318','2013-07-10','15:40:00',7.17),('10318','2013-07-10','15:45:00',7.02),('10318','2013-07-10','15:50:00',6.96),('10318','2013-07-10','15:55:00',6.84),('10318','2013-07-10','16:00:00',6.7),('10318','2013-07-10','16:05:00',6.58),('10318','2013-07-10','16:10:00',6.41),('10318','2013-07-10','16:15:00',6.23),('10318','2013-07-10','16:20:00',6.12),('10318','2013-07-10','16:25:00',5.96),('10318','2013-07-10','16:30:00',5.79),('10318','2013-07-10','16:35:00',5.65),('10318','2013-07-10','16:40:00',5.5),('10318','2013-07-10','16:45:00',5.36),('10318','2013-07-10','16:50:00',5.26),('10318','2013-07-10','16:55:00',5.22),('10318','2013-07-10','17:00:00',5.16),('10318','2013-07-10','17:05:00',3.5),('10318','2013-07-10','17:10:00',2.76),('10318','2013-07-10','17:15:00',2.31),('10318','2013-07-10','17:20:00',1.9),('10318','2013-07-10','17:25:00',1.4),('10318','2013-07-10','17:30:00',1.16),('10318','2013-07-10','17:35:00',2.44),('10318','2013-07-10','17:40:00',3.76),('10318','2013-07-10','17:45:00',3.49),('10318','2013-07-10','17:50:00',3.29),('10318','2013-07-10','17:55:00',3.07),('10318','2013-07-10','18:00:00',2.96),('10318','2013-07-10','18:05:00',2.97),('10318','2013-07-10','18:10:00',2.26),('10318','2013-07-10','18:15:00',1.2),('10318','2013-07-10','18:20:00',1.13),('10318','2013-07-10','18:25:00',1.07),('10318','2013-07-10','18:30:00',1.12),('10318','2013-07-10','18:35:00',1.1),('10318','2013-07-10','18:40:00',1.07),('10318','2013-07-10','19:05:00',1.12),('10318','2013-07-10','19:10:00',1.02),('10318','2013-07-09','07:10:00',1.43),('10318','2013-07-09','07:15:00',1.86),('10318','2013-07-09','07:20:00',2.11),('10318','2013-07-09','07:25:00',2.34),('10318','2013-07-09','07:30:00',2.58),('10318','2013-07-09','07:35:00',2.8),('10318','2013-07-09','07:40:00',2.99),('10318','2013-07-09','07:45:00',3.16),('10318','2013-07-09','07:50:00',3.33),('10318','2013-07-09','07:55:00',3.5),('10318','2013-07-09','08:00:00',3.64),('10318','2013-07-09','08:05:00',3.8),('10318','2013-07-09','08:10:00',3.9),('10318','2013-07-09','08:15:00',4.16),('10318','2013-07-09','08:20:00',4.31),('10318','2013-07-09','08:25:00',4.46),('10318','2013-07-09','08:30:00',4.64),('10318','2013-07-09','08:35:00',4.83),('10318','2013-07-09','08:40:00',4.99),('10318','2013-07-09','08:45:00',5.17),('10318','2013-07-09','08:50:00',5.33),('10318','2013-07-09','08:55:00',5.52),('10318','2013-07-09','09:00:00',5.67),('10318','2013-07-09','09:05:00',5.82),('10318','2013-07-09','09:10:00',5.97),('10318','2013-07-09','09:15:00',6.12),('10318','2013-07-09','09:20:00',6.29),('10318','2013-07-09','09:25:00',6.41),('10318','2013-07-09','09:30:00',6.56),('10318','2013-07-09','09:35:00',6.71),('10318','2013-07-09','09:40:00',6.83),('10318','2013-07-09','09:45:00',6.92),('10318','2013-07-09','09:50:00',7.08),('10318','2013-07-09','09:55:00',7.06),('10318','2013-07-09','10:00:00',7.29),('10318','2013-07-09','10:05:00',7.37),('10318','2013-07-09','10:10:00',7.48),('10318','2013-07-09','10:15:00',7.56),('10318','2013-07-09','10:20:00',7.69),('10318','2013-07-09','10:25:00',7.74),('10318','2013-07-09','10:30:00',7.82),('10318','2013-07-09','10:35:00',7.91),('10318','2013-07-09','10:40:00',8.01),('10318','2013-07-09','10:45:00',8.1),('10318','2013-07-09','10:50:00',8.19),('10318','2013-07-09','10:55:00',8.31),('10318','2013-07-09','11:00:00',8.41),('10318','2013-07-09','11:05:00',8.21),('10318','2013-07-09','11:10:00',8.55),('10318','2013-07-09','11:15:00',8.68),('10318','2013-07-09','11:20:00',8.89),('10318','2013-07-09','11:25:00',7.93),('10318','2013-07-09','11:30:00',7.59),('10318','2013-07-09','11:35:00',9.37),('10318','2013-07-09','11:40:00',9.22),('10318','2013-07-09','11:45:00',9.61),('10318','2013-07-09','11:50:00',9.16),('10318','2013-07-09','11:55:00',9.55),('10318','2013-07-09','12:00:00',9.28),('10318','2013-07-09','12:05:00',8.71),('10318','2013-07-09','12:10:00',8.93),('10318','2013-07-09','12:15:00',8.25),('10318','2013-07-09','12:20:00',8.59),('10318','2013-07-09','12:25:00',8.88),('10318','2013-07-09','12:30:00',8.95),('10318','2013-07-09','12:35:00',8.97),('10318','2013-07-09','12:40:00',8.99),('10318','2013-07-09','12:45:00',9.09),('10318','2013-07-09','12:50:00',9.18),('10318','2013-07-09','12:55:00',9.06),('10318','2013-07-09','13:00:00',9.21),('10318','2013-07-09','13:05:00',9.25),('10318','2013-07-09','13:10:00',8.99),('10318','2013-07-09','13:15:00',9.14),('10318','2013-07-09','13:20:00',9.35),('10318','2013-07-09','13:25:00',9.33),('10318','2013-07-09','13:30:00',9.22),('10318','2013-07-09','13:35:00',9.23),('10318','2013-07-09','13:40:00',9.14),('10318','2013-07-09','13:45:00',7.65),('10318','2013-07-09','13:50:00',7.53),('10318','2013-07-09','13:55:00',8.83),('10318','2013-07-09','14:00:00',7.9),('10318','2013-07-09','14:05:00',7.44),('10318','2013-07-09','14:10:00',7.26),('10318','2013-07-09','14:15:00',7.92),('10318','2013-07-09','14:20:00',8.95),('10318','2013-07-09','14:25:00',6.41),('10318','2013-07-09','14:30:00',2.83),('10318','2013-07-09','14:35:00',2.19),('10318','2013-07-09','14:40:00',1.99),('10318','2013-07-09','14:45:00',1.63),('10318','2013-07-09','17:10:00',1.02),('10318','2013-07-09','17:15:00',1.03),('10318','2013-07-09','17:20:00',1.04),('10318','2013-07-09','17:25:00',1.12),('10318','2013-07-09','17:30:00',1.17),('10318','2013-07-09','17:35:00',1.17),('10318','2013-07-09','17:40:00',1.12),('10318','2013-07-09','17:45:00',1),('10318','2013-07-08','07:30:00',1.08),('10318','2013-07-08','07:35:00',1.94),('10318','2013-07-08','07:40:00',3.53),('10318','2013-07-08','07:45:00',3.41),('10318','2013-07-08','07:50:00',3.54),('10318','2013-07-08','07:55:00',3.09),('10318','2013-07-08','08:00:00',3.07),('10318','2013-07-08','08:05:00',3.58),('10318','2013-07-08','08:10:00',3.7),('10318','2013-07-08','08:15:00',4.12),('10318','2013-07-08','08:20:00',4.32),('10318','2013-07-08','08:25:00',4.52),('10318','2013-07-08','08:30:00',4.68),('10318','2013-07-08','08:35:00',4.86),('10318','2013-07-08','08:40:00',4.99),('10318','2013-07-08','08:45:00',5.2),('10318','2013-07-08','08:50:00',5.33),('10318','2013-07-08','08:55:00',5.47),('10318','2013-07-08','09:00:00',5.61),('10318','2013-07-08','09:05:00',5.82),('10318','2013-07-08','09:10:00',6.01),('10318','2013-07-08','09:15:00',6.14),('10318','2013-07-08','09:20:00',6.3),('10318','2013-07-08','09:25:00',6.36),('10318','2013-07-08','09:30:00',6.53),('10318','2013-07-08','09:35:00',6.65),('10318','2013-07-08','09:40:00',6.83),('10318','2013-07-08','09:45:00',6.9),('10318','2013-07-08','09:50:00',7.01),('10318','2013-07-08','09:55:00',7.01),('10318','2013-07-08','10:00:00',7.22),('10318','2013-07-08','10:05:00',7.33),('10318','2013-07-08','10:10:00',7.47),('10318','2013-07-08','10:15:00',7.53),('10318','2013-07-08','10:20:00',7.6),('10318','2013-07-08','10:25:00',4.63),('10318','2013-07-08','10:50:00',7.98),('10318','2013-07-08','10:55:00',8.11),('10318','2013-07-08','11:00:00',8.25),('10318','2013-07-08','11:05:00',8.3),('10318','2013-07-08','11:10:00',8.4),('10318','2013-07-08','11:15:00',8.52),('10318','2013-07-08','11:20:00',8.61),('10318','2013-07-08','11:25:00',8.58),('10318','2013-07-08','11:30:00',8.57),('10318','2013-07-08','11:45:00',3.1),('10318','2013-07-08','12:00:00',8.76),('10318','2013-07-08','12:05:00',9.03),('10318','2013-07-08','12:10:00',9.15),('10318','2013-07-08','12:15:00',9.25),('10318','2013-07-08','12:20:00',9.22),('10318','2013-07-08','12:25:00',8.07),('10318','2013-07-08','12:30:00',9.13),('10318','2013-07-08','12:35:00',9.19),('10318','2013-07-08','12:40:00',9.24),('10318','2013-07-08','12:45:00',9.28),('10318','2013-07-08','12:50:00',9.22),('10318','2013-07-08','12:55:00',9.43),('10318','2013-07-08','13:00:00',9.59),('10318','2013-07-08','13:05:00',9.7),('10318','2013-07-08','13:10:00',7.18),('10318','2013-07-08','13:15:00',3.23),('10318','2013-07-08','13:20:00',3.17),('10318','2013-07-08','13:25:00',2.48),('10318','2013-07-08','13:30:00',1.37),('10318','2013-07-08','13:55:00',1.06),('10318','2013-07-08','14:00:00',1.35),('10318','2013-07-08','14:05:00',1.76),('10318','2013-07-08','14:10:00',1.98),('10318','2013-07-08','14:15:00',1.99),('10318','2013-07-08','14:20:00',2),('10318','2013-07-08','14:25:00',2.11),('10318','2013-07-08','14:30:00',2.23),('10318','2013-07-08','14:35:00',2.74),('10318','2013-07-08','14:40:00',2.97),('10318','2013-07-08','14:45:00',2.84),('10318','2013-07-08','14:50:00',2.77),('10318','2013-07-08','14:55:00',2.69),('10318','2013-07-08','15:00:00',2.48),('10318','2013-07-08','15:05:00',2.27),('10318','2013-07-08','15:10:00',2.11),('10318','2013-07-08','15:15:00',1.86),('10318','2013-07-08','15:20:00',1.41),('10318','2013-07-08','15:25:00',1.2),('10318','2013-07-08','17:20:00',1.13),('10318','2013-07-08','17:25:00',1.52),('10318','2013-07-08','17:30:00',1.88),('10318','2013-07-08','17:35:00',2.09),('10318','2013-07-08','17:40:00',2.16),('10318','2013-07-08','17:45:00',2.1),('10318','2013-07-08','17:50:00',2.2),('10318','2013-07-08','17:55:00',2.11),('10318','2013-07-08','18:00:00',1.95),('10318','2013-07-08','18:05:00',1.78),('10318','2013-07-08','18:10:00',1.71),('10318','2013-07-08','18:15:00',1.71),('10318','2013-07-08','18:20:00',1.86),('10318','2013-07-08','18:25:00',1.88),('10318','2013-07-08','18:30:00',1.95),('10318','2013-07-08','18:35:00',2.14),('10318','2013-07-08','18:40:00',2.3),('10318','2013-07-08','18:45:00',1.97),('10318','2013-07-08','18:50:00',1.67),('10318','2013-07-08','18:55:00',1.42),('10318','2013-07-08','19:00:00',1.11),('10318','2013-07-07','07:00:00',1.27),('10318','2013-07-07','07:05:00',1.43),('10318','2013-07-07','07:10:00',1.73),('10318','2013-07-07','07:15:00',1.94),('10318','2013-07-07','07:20:00',2.21),('10318','2013-07-07','07:25:00',2.46),('10318','2013-07-07','07:30:00',2.71),('10318','2013-07-07','07:35:00',2.9),('10318','2013-07-07','07:40:00',3.09),('10318','2013-07-07','07:45:00',3.29),('10318','2013-07-07','07:50:00',3.47),('10318','2013-07-07','07:55:00',3.66),('10318','2013-07-07','08:00:00',3.87),('10318','2013-07-07','08:05:00',4.08),('10318','2013-07-07','08:10:00',4.27),('10318','2013-07-07','08:15:00',4.47),('10318','2013-07-07','08:20:00',3.76),('10318','2013-07-07','08:25:00',4.08),('10318','2013-07-07','08:30:00',4.74),('10318','2013-07-07','08:35:00',4.6),('10318','2013-07-07','08:40:00',2.89),('10318','2013-07-07','08:45:00',3.85),('10318','2013-07-07','08:50:00',4.1),('10318','2013-07-07','08:55:00',6.18),('10318','2013-07-07','09:00:00',6.41),('10318','2013-07-07','09:05:00',6.46),('10318','2013-07-07','09:10:00',5.85),('10318','2013-07-07','09:15:00',5.07),('10318','2013-07-07','09:20:00',5.77),('10318','2013-07-07','09:25:00',5.39),('10318','2013-07-07','09:30:00',5.89),('10318','2013-07-07','09:35:00',7.25),('10318','2013-07-07','09:40:00',6.8),('10318','2013-07-07','09:45:00',6.79),('10318','2013-07-07','09:50:00',7.61),('10318','2013-07-07','09:55:00',7.98),('10318','2013-07-07','10:00:00',7.84),('10318','2013-07-07','10:05:00',7.82),('10318','2013-07-07','10:10:00',6.78),('10318','2013-07-07','10:15:00',7.61),('10318','2013-07-07','10:20:00',7.53),('10318','2013-07-07','10:25:00',8.45),('10318','2013-07-07','10:30:00',6.99),('10318','2013-07-07','10:35:00',8),('10318','2013-07-07','10:40:00',8.59),('10318','2013-07-07','10:45:00',8.44),('10318','2013-07-07','10:50:00',8.56),('10318','2013-07-07','10:55:00',8.6),('10318','2013-07-07','11:00:00',8.68),('10318','2013-07-07','11:05:00',8.74),('10318','2013-07-07','11:10:00',8.8),('10318','2013-07-07','11:15:00',8.94),('10318','2013-07-07','11:20:00',7.97),('10318','2013-07-07','11:25:00',8.41),('10318','2013-07-07','11:30:00',8.15),('10318','2013-07-07','11:35:00',7.85),('10318','2013-07-07','11:40:00',8.02),('10318','2013-07-07','11:45:00',8.14),('10318','2013-07-07','11:50:00',8.3),('10318','2013-07-07','11:55:00',5.92),('10318','2013-07-07','12:00:00',6.53),('10318','2013-07-07','12:05:00',8.73),('10318','2013-07-07','12:10:00',8.49),('10318','2013-07-07','12:15:00',8.95),('10318','2013-07-07','12:20:00',6.69),('10318','2013-07-07','12:25:00',8.66),('10318','2013-07-07','12:30:00',8.59),('10318','2013-07-07','12:35:00',8.69),('10318','2013-07-07','12:40:00',9.03),('10318','2013-07-07','12:45:00',9.2),('10318','2013-07-07','12:50:00',9.33),('10318','2013-07-07','12:55:00',9.26),('10318','2013-07-07','13:00:00',9.26),('10318','2013-07-07','13:05:00',9.33),('10318','2013-07-07','13:10:00',9.28),('10318','2013-07-07','13:15:00',9.24),('10318','2013-07-07','13:20:00',9.16),('10318','2013-07-07','13:25:00',9.36),('10318','2013-07-07','13:30:00',9.17),('10318','2013-07-07','13:35:00',8.8),('10318','2013-07-07','13:40:00',9.19),('10318','2013-07-07','13:45:00',9.8),('10318','2013-07-07','13:50:00',9.96),('10318','2013-07-07','13:55:00',7.39),('10318','2013-07-07','14:00:00',7.42),('10318','2013-07-07','14:05:00',4.33),('10318','2013-07-07','14:10:00',4.29),('10318','2013-07-07','14:15:00',3.45),('10318','2013-07-07','14:20:00',3.56),('10318','2013-07-07','14:25:00',3.72),('10318','2013-07-07','14:30:00',2.98),('10318','2013-07-07','14:35:00',2.47),('10318','2013-07-07','14:40:00',2.17),('10318','2013-07-07','14:45:00',1.92),('10318','2013-07-07','14:50:00',1.82),('10318','2013-07-07','14:55:00',1.91),('10318','2013-07-07','15:00:00',2.22),('10318','2013-07-07','15:05:00',2.51),('10318','2013-07-07','15:10:00',1.77),('10318','2013-07-07','15:15:00',1.12),('10318','2013-07-07','15:20:00',1.25),('10318','2013-07-07','15:25:00',1.15),('10318','2013-07-07','16:40:00',1.01),('10318','2013-07-07','16:45:00',1.16),('10318','2013-07-07','16:50:00',1.42),('10318','2013-07-07','16:55:00',1.74),('10318','2013-07-07','17:00:00',2.01),('10318','2013-07-07','17:05:00',2.2),('10318','2013-07-07','17:10:00',2.31),('10318','2013-07-07','17:15:00',2.39),('10318','2013-07-07','17:20:00',2.43),('10318','2013-07-07','17:25:00',2.36),('10318','2013-07-07','17:30:00',2.39),('10318','2013-07-07','17:35:00',2.23),('10318','2013-07-07','17:40:00',2.06),('10318','2013-07-07','17:45:00',1.98),('10318','2013-07-07','17:50:00',1.94),('10318','2013-07-07','17:55:00',1.89),('10318','2013-07-07','18:00:00',1.82),('10318','2013-07-07','18:05:00',1.79),('10318','2013-07-07','18:10:00',1.68),('10318','2013-07-07','18:15:00',1.65),('10318','2013-07-07','18:20:00',1.67),('10318','2013-07-07','18:25:00',1.62),('10318','2013-07-07','18:30:00',1.53),('10318','2013-07-07','18:35:00',1.41),('10318','2013-07-07','18:40:00',1.31),('10318','2013-07-07','18:45:00',1.24),('10318','2013-07-07','18:50:00',1.25),('10318','2013-07-07','18:55:00',1.19),('10318','2013-07-07','19:00:00',1.08),('10318','2013-07-06','06:55:00',1.02),('10318','2013-07-06','07:00:00',1.3),('10318','2013-07-06','07:05:00',1.48),('10318','2013-07-06','07:10:00',1.66),('10318','2013-07-06','07:15:00',1.8),('10318','2013-07-06','07:20:00',2.14),('10318','2013-07-06','07:25:00',2.4),('10318','2013-07-06','07:30:00',2.6),('10318','2013-07-06','07:35:00',2.78),('10318','2013-07-06','07:40:00',2.94),('10318','2013-07-06','07:45:00',3.1),('10318','2013-07-06','07:50:00',3.32),('10318','2013-07-06','07:55:00',3.51),('10318','2013-07-06','08:00:00',3.7),('10318','2013-07-06','08:05:00',3.88),('10318','2013-07-06','08:10:00',4.07),('10318','2013-07-06','08:15:00',4.26),('10318','2013-07-06','08:20:00',4.42),('10318','2013-07-06','08:25:00',4.57),('10318','2013-07-06','08:30:00',4.78),('10318','2013-07-06','08:35:00',4.94),('10318','2013-07-06','08:40:00',5.08),('10318','2013-07-06','08:45:00',5.24),('10318','2013-07-06','08:50:00',5.39),('10318','2013-07-06','08:55:00',5.56),('10318','2013-07-06','09:00:00',5.73),('10318','2013-07-06','09:05:00',5.86),('10318','2013-07-06','09:10:00',6.04),('10318','2013-07-06','09:15:00',6.18),('10318','2013-07-06','09:20:00',6.25),('10318','2013-07-06','09:25:00',6.45),('10318','2013-07-06','09:30:00',6.58),('10318','2013-07-06','09:35:00',6.72),('10318','2013-07-06','09:40:00',6.86),('10318','2013-07-06','09:45:00',6.97),('10318','2013-07-06','09:50:00',7.06),('10318','2013-07-06','09:55:00',7.24),('10318','2013-07-06','10:00:00',7.38),('10318','2013-07-06','10:05:00',7.47),('10318','2013-07-06','10:10:00',7.57),('10318','2013-07-06','10:15:00',7.64),('10318','2013-07-06','10:20:00',7.75),('10318','2013-07-06','10:25:00',7.85),('10318','2013-07-06','10:30:00',7.94),('10318','2013-07-06','10:35:00',8.06),('10318','2013-07-06','10:40:00',8.23),('10318','2013-07-06','10:45:00',8.29),('10318','2013-07-06','10:50:00',8.4),('10318','2013-07-06','10:55:00',8.47),('10318','2013-07-06','11:00:00',8.54),('10318','2013-07-06','11:05:00',8.55),('10318','2013-07-06','11:10:00',8.48),('10318','2013-07-06','11:15:00',8.58),('10318','2013-07-06','11:20:00',8.59),('10318','2013-07-06','11:25:00',8.66),('10318','2013-07-06','11:30:00',8.67),('10318','2013-07-06','11:35:00',8.81),('10318','2013-07-06','11:40:00',8.88),('10318','2013-07-06','11:45:00',8.88),('10318','2013-07-06','11:50:00',8.91),('10318','2013-07-06','11:55:00',8.99),('10318','2013-07-06','12:00:00',9.12),('10318','2013-07-06','12:05:00',9.11),('10318','2013-07-06','12:10:00',9.19),('10318','2013-07-06','12:15:00',9.11),('10318','2013-07-06','12:20:00',9.16),('10318','2013-07-06','12:25:00',9.38),('10318','2013-07-06','12:30:00',9.29),('10318','2013-07-06','12:35:00',9.22),('10318','2013-07-06','12:40:00',9.31),('10318','2013-07-06','12:45:00',9.24),('10318','2013-07-06','12:50:00',9.19),('10318','2013-07-06','12:55:00',9.06),('10318','2013-07-06','13:00:00',9.16),('10318','2013-07-06','13:05:00',9.23),('10318','2013-07-06','13:10:00',9.15),('10318','2013-07-06','13:15:00',9.16),('10318','2013-07-06','13:20:00',9.22),('10318','2013-07-06','13:25:00',9.09),('10318','2013-07-06','13:30:00',9.19),('10318','2013-07-06','13:35:00',9.22),('10318','2013-07-06','13:40:00',9.3),('10318','2013-07-06','13:45:00',9.08),('10318','2013-07-06','13:50:00',8.98),('10318','2013-07-06','13:55:00',8.86),('10318','2013-07-06','14:00:00',8.8),('10318','2013-07-06','14:05:00',8.65),('10318','2013-07-06','14:10:00',8.74),('10318','2013-07-06','14:15:00',8.77),('10318','2013-07-06','14:20:00',8.74),('10318','2013-07-06','14:25:00',8.63),('10318','2013-07-06','14:30:00',8.4),('10318','2013-07-06','14:35:00',8.24),('10318','2013-07-06','14:40:00',8.04),('10318','2013-07-06','14:45:00',8.31),('10318','2013-07-06','14:50:00',8.34),('10318','2013-07-06','14:55:00',8.4),('10318','2013-07-06','15:00:00',8.21),('10318','2013-07-06','15:05:00',8.18),('10318','2013-07-06','15:10:00',7.93),('10318','2013-07-06','15:15:00',7.76),('10318','2013-07-06','15:20:00',7.88),('10318','2013-07-06','15:25:00',7.87),('10318','2013-07-06','15:30:00',4.01),('10318','2013-07-06','15:35:00',1.94),('10318','2013-07-06','15:40:00',1.45),('10318','2013-07-06','16:15:00',1.41),('10318','2013-07-06','16:20:00',1.4),('10318','2013-07-06','16:35:00',1.46),('10318','2013-07-06','16:40:00',2.02),('10318','2013-07-06','16:45:00',2),('10318','2013-07-06','16:50:00',5.05),('10318','2013-07-06','16:55:00',3.44),('10318','2013-07-06','17:00:00',2.64),('10318','2013-07-06','17:05:00',2.36),('10318','2013-07-06','17:10:00',3.2),('10318','2013-07-06','17:15:00',3.94),('10318','2013-07-06','17:20:00',2.88),('10318','2013-07-06','17:25:00',2.33),('10318','2013-07-06','17:30:00',2.31),('10318','2013-07-06','17:35:00',2.26),('10318','2013-07-06','17:40:00',2.06),('10318','2013-07-06','17:45:00',2.01),('10318','2013-07-06','17:50:00',1.85),('10318','2013-07-06','17:55:00',1.69),('10318','2013-07-06','18:00:00',1.53),('10318','2013-07-06','18:05:00',1.42),('10318','2013-07-06','18:10:00',1.36),('10318','2013-07-06','18:15:00',1.28),('10318','2013-07-06','18:20:00',1.23),('10318','2013-07-06','18:25:00',1.19),('10318','2013-07-06','18:30:00',1.12),('10318','2013-07-06','18:35:00',1.07),('10318','2013-07-06','18:40:00',1.02),('10318','2013-07-05','06:55:00',1.04),('10318','2013-07-05','07:00:00',1.31),('10318','2013-07-05','07:05:00',1.46),('10318','2013-07-05','07:10:00',1.64),('10318','2013-07-05','07:15:00',1.73),('10318','2013-07-05','07:20:00',2.11),('10318','2013-07-05','07:25:00',2.39),('10318','2013-07-05','07:30:00',2.4),('10318','2013-07-05','07:35:00',1.21),('10318','2013-07-05','07:40:00',2.43),('10318','2013-07-05','07:45:00',3.16),('10318','2013-07-05','07:50:00',3.34),('10318','2013-07-05','07:55:00',3.53),('10318','2013-07-05','08:00:00',3.7),('10318','2013-07-05','08:05:00',3.91),('10318','2013-07-05','08:10:00',4.12),('10318','2013-07-05','08:15:00',4.28),('10318','2013-07-05','08:20:00',4.42),('10318','2013-07-05','08:25:00',4.65),('10318','2013-07-05','08:30:00',4.81),('10318','2013-07-05','08:35:00',4.92),('10318','2013-07-05','08:40:00',5.13),('10318','2013-07-05','08:45:00',5.28),('10318','2013-07-05','08:50:00',5.46),('10318','2013-07-05','08:55:00',5.63),('10318','2013-07-05','09:00:00',5.8),('10318','2013-07-05','09:05:00',5.94),('10318','2013-07-05','09:10:00',6.05),('10318','2013-07-05','09:15:00',6.18),('10318','2013-07-05','09:20:00',6.34),('10318','2013-07-05','09:25:00',6.49),('10318','2013-07-05','09:30:00',6.65),('10318','2013-07-05','09:35:00',6.76),('10318','2013-07-05','09:40:00',6.88),('10318','2013-07-05','09:45:00',7),('10318','2013-07-05','09:50:00',7.11),('10318','2013-07-05','09:55:00',7.22),('10318','2013-07-05','10:00:00',7.33),('10318','2013-07-05','10:05:00',7.41),('10318','2013-07-05','10:10:00',7.54),('10318','2013-07-05','10:15:00',7.66),('10318','2013-07-05','10:20:00',7.64),('10318','2013-07-05','10:25:00',7.83),('10318','2013-07-05','10:30:00',7.91),('10318','2013-07-05','10:35:00',7.99),('10318','2013-07-05','10:40:00',8.09),('10318','2013-07-05','10:45:00',8.16),('10318','2013-07-05','10:50:00',8.24),('10318','2013-07-05','10:55:00',8.33),('10318','2013-07-05','11:00:00',8.37),('10318','2013-07-05','11:05:00',8.47),('10318','2013-07-05','11:10:00',8.54),('10318','2013-07-05','11:15:00',8.56),('10318','2013-07-05','11:20:00',8.6),('10318','2013-07-05','11:25:00',8.63),('10318','2013-07-05','11:30:00',8.75),('10318','2013-07-05','11:35:00',8.81),('10318','2013-07-05','11:40:00',8.84),('10318','2013-07-05','11:45:00',8.68),('10318','2013-07-05','11:50:00',8.82),('10318','2013-07-05','11:55:00',8.88),('10318','2013-07-05','12:00:00',8.76),('10318','2013-07-05','12:05:00',8.6),('10318','2013-07-05','12:10:00',8.6),('10318','2013-07-05','12:15:00',9.14),('10318','2013-07-05','12:20:00',9.13),('10318','2013-07-05','12:25:00',9.25),('10318','2013-07-05','12:30:00',9.5),('10318','2013-07-05','12:35:00',5.91),('10318','2013-07-05','12:40:00',8.71),('10318','2013-07-05','12:45:00',9.34),('10318','2013-07-05','12:50:00',9.24),('10318','2013-07-05','12:55:00',9.45),('10318','2013-07-05','13:00:00',9.71),('10318','2013-07-05','13:05:00',9.82),('10318','2013-07-05','13:10:00',8.41),('10318','2013-07-05','13:15:00',9.41),('10318','2013-07-05','13:20:00',9.43),('10318','2013-07-05','13:25:00',8.58),('10318','2013-07-05','13:30:00',8.35),('10318','2013-07-05','13:35:00',9.34),('10318','2013-07-05','13:40:00',9.2),('10318','2013-07-05','13:45:00',9.23),('10318','2013-07-05','13:50:00',8.3),('10318','2013-07-05','13:55:00',9.11),('10318','2013-07-05','14:00:00',8.31),('10318','2013-07-05','14:05:00',8.99),('10318','2013-07-05','14:10:00',6.8),('10318','2013-07-05','14:15:00',7.08),('10318','2013-07-05','14:20:00',8.86),('10318','2013-07-05','14:25:00',8.56),('10318','2013-07-05','14:30:00',8.56),('10318','2013-07-05','14:35:00',8.57),('10318','2013-07-05','14:40:00',8.45),('10318','2013-07-05','14:45:00',8.42),('10318','2013-07-05','14:50:00',8.34),('10318','2013-07-05','14:55:00',8.2),('10318','2013-07-05','15:00:00',8.17),('10318','2013-07-05','15:05:00',8.27),('10318','2013-07-05','15:10:00',7.97),('10318','2013-07-05','15:15:00',8),('10318','2013-07-05','15:20:00',7.88),('10318','2013-07-05','15:25:00',7.74),('10318','2013-07-05','15:30:00',7.6),('10318','2013-07-05','15:35:00',5.56),('10318','2013-07-05','15:40:00',6.15),('10318','2013-07-05','15:45:00',6.13),('10318','2013-07-05','15:50:00',7.22),('10318','2013-07-05','15:55:00',6.99),('10318','2013-07-05','16:00:00',6.7),('10318','2013-07-05','16:05:00',6.61),('10318','2013-07-05','16:10:00',6.39),('10318','2013-07-05','16:15:00',6.24),('10318','2013-07-05','16:20:00',6.17),('10318','2013-07-05','16:25:00',5.98),('10318','2013-07-05','16:30:00',5.82),('10318','2013-07-05','16:35:00',5.59),('10318','2013-07-05','16:40:00',5.43),('10318','2013-07-05','16:45:00',5.29),('10318','2013-07-05','16:50:00',5.14),('10318','2013-07-05','16:55:00',4.87),('10318','2013-07-05','17:00:00',4.75),('10318','2013-07-05','17:05:00',4.69),('10318','2013-07-05','17:10:00',4.54),('10318','2013-07-05','17:15:00',4.22),('10318','2013-07-05','17:20:00',4.1),('10318','2013-07-05','17:25:00',3.81),('10318','2013-07-05','17:30:00',3.75),('10318','2013-07-05','17:35:00',3.65),('10318','2013-07-05','17:40:00',3.43),('10318','2013-07-05','17:45:00',3.2),('10318','2013-07-05','17:50:00',2.99),('10318','2013-07-05','17:55:00',2.83),('10318','2013-07-05','18:00:00',2.71),('10318','2013-07-05','18:05:00',2.68),('10318','2013-07-05','18:10:00',2.57),('10318','2013-07-05','18:15:00',2.39),('10318','2013-07-05','18:20:00',2.16),('10318','2013-07-05','18:25:00',1.92),('10318','2013-07-05','18:30:00',1.81),('10318','2013-07-05','18:35:00',1.64),('10318','2013-07-05','18:40:00',1.46),('10318','2013-07-05','18:45:00',1.33),('10318','2013-07-05','18:50:00',1.2),('10318','2013-07-05','18:55:00',1.08),('10318','2013-07-04','07:50:00',1.02),('10318','2013-07-04','07:55:00',1.17),('10318','2013-07-04','08:00:00',1.18),('10318','2013-07-04','08:30:00',1.04),('10318','2013-07-04','08:35:00',1.05),('10318','2013-07-04','08:40:00',1.1),('10318','2013-07-04','08:45:00',1.37),('10318','2013-07-04','08:50:00',1.75),('10318','2013-07-04','08:55:00',1.96),('10318','2013-07-04','09:00:00',1.83),('10318','2013-07-04','09:05:00',1.52),('10318','2013-07-04','09:10:00',1.57),('10318','2013-07-04','09:15:00',1.58),('10318','2013-07-04','09:20:00',1.6),('10318','2013-07-04','09:25:00',1.7),('10318','2013-07-04','09:30:00',1.65),('10318','2013-07-04','09:35:00',1.41),('10318','2013-07-04','09:40:00',1.18),('10318','2013-07-04','09:45:00',1.04),('10318','2013-07-04','10:05:00',1.1),('10318','2013-07-04','10:10:00',1.34),('10318','2013-07-04','10:15:00',1.52),('10318','2013-07-04','10:20:00',1.59),('10318','2013-07-04','10:25:00',1.58),('10318','2013-07-04','10:30:00',1.64),('10318','2013-07-04','10:35:00',1.68),('10318','2013-07-04','10:40:00',1.54),('10318','2013-07-04','10:45:00',1.37),('10318','2013-07-04','10:50:00',1.33),('10318','2013-07-04','10:55:00',1.6),('10318','2013-07-04','11:00:00',1.89),('10318','2013-07-04','11:05:00',2.11),('10318','2013-07-04','11:10:00',2.4),('10318','2013-07-04','11:15:00',2.34),('10318','2013-07-04','11:20:00',2.38),('10318','2013-07-04','11:25:00',2.56),('10318','2013-07-04','11:30:00',2.82),('10318','2013-07-04','11:35:00',3.22),('10318','2013-07-04','11:40:00',3.43),('10318','2013-07-04','11:45:00',3.7),('10318','2013-07-04','11:50:00',3.69),('10318','2013-07-04','11:55:00',3.97),('10318','2013-07-04','12:00:00',4.3),('10318','2013-07-04','12:05:00',5.01),('10318','2013-07-04','12:10:00',6.24),('10318','2013-07-04','12:15:00',6.19),('10318','2013-07-04','12:20:00',4.39),('10318','2013-07-04','12:25:00',4.17),('10318','2013-07-04','12:30:00',3.44),('10318','2013-07-04','12:35:00',2.87),('10318','2013-07-04','12:40:00',2.3),('10318','2013-07-04','12:45:00',1.86),('10318','2013-07-04','12:50:00',1.54),('10318','2013-07-04','12:55:00',1.61),('10318','2013-07-04','13:00:00',1.9),('10318','2013-07-04','13:05:00',2.43),('10318','2013-07-04','13:10:00',3.64),('10318','2013-07-04','13:15:00',4.21),('10318','2013-07-04','13:20:00',4.15),('10318','2013-07-04','13:25:00',5.34),('10318','2013-07-04','13:30:00',5.85),('10318','2013-07-04','13:35:00',4.73),('10318','2013-07-04','13:40:00',7.66),('10318','2013-07-04','13:45:00',10.82),('10318','2013-07-04','13:50:00',10.46),('10318','2013-07-04','13:55:00',8.3),('10318','2013-07-04','14:00:00',5.74),('10318','2013-07-04','14:05:00',5.1),('10318','2013-07-04','14:10:00',4.43),('10318','2013-07-04','14:15:00',4.11),('10318','2013-07-04','14:20:00',3.92),('10318','2013-07-04','14:25:00',4.04),('10318','2013-07-04','14:30:00',3.93),('10318','2013-07-04','14:35:00',4.66),('10318','2013-07-04','14:40:00',4.83),('10318','2013-07-04','14:45:00',4.74),('10318','2013-07-04','14:50:00',5.81),('10318','2013-07-04','14:55:00',4.29),('10318','2013-07-04','15:00:00',4.74),('10318','2013-07-04','15:05:00',4.21),('10318','2013-07-04','15:10:00',7.57),('10318','2013-07-04','15:15:00',5.45),('10318','2013-07-04','15:20:00',5.33),('10318','2013-07-04','15:25:00',3.1),('10318','2013-07-04','15:30:00',4.26),('10318','2013-07-04','15:35:00',6.69),('10318','2013-07-04','15:40:00',5.51),('10318','2013-07-04','15:45:00',4.93),('10318','2013-07-04','15:50:00',5.43),('10318','2013-07-04','15:55:00',6.34),('10318','2013-07-04','16:00:00',6.43),('10318','2013-07-04','16:05:00',5.47),('10318','2013-07-04','16:10:00',3.69),('10318','2013-07-04','16:15:00',3.99),('10318','2013-07-04','16:20:00',4.56),('10318','2013-07-04','16:25:00',5.64),('10318','2013-07-04','16:30:00',4.29),('10318','2013-07-04','16:35:00',3.76),('10318','2013-07-04','16:40:00',3.29),('10318','2013-07-04','16:45:00',3.14),('10318','2013-07-04','16:50:00',3.17),('10318','2013-07-04','16:55:00',3.04),('10318','2013-07-04','17:00:00',2.79),('10318','2013-07-04','17:05:00',3.06),('10318','2013-07-04','17:10:00',4.24),('10318','2013-07-04','17:15:00',3.62),('10318','2013-07-04','17:20:00',5.39),('10318','2013-07-04','17:25:00',4.76),('10318','2013-07-04','17:30:00',4.15),('10318','2013-07-04','17:35:00',3.35),('10318','2013-07-04','17:40:00',4.03),('10318','2013-07-04','17:45:00',3.84),('10318','2013-07-04','17:50:00',3.42),('10318','2013-07-04','17:55:00',3.52),('10318','2013-07-04','18:00:00',3.38),('10318','2013-07-04','18:05:00',3.18),('10318','2013-07-04','18:10:00',3.03),('10318','2013-07-04','18:15:00',2.96),('10318','2013-07-04','18:20:00',2.67),('10318','2013-07-04','18:25:00',2.28),('10318','2013-07-04','18:30:00',1.7),('10318','2013-07-04','18:35:00',1.64),('10318','2013-07-04','18:40:00',1.44),('10318','2013-07-03','06:55:00',1.14),('10318','2013-07-03','07:00:00',1.43),('10318','2013-07-03','07:05:00',1.67),('10318','2013-07-03','07:10:00',1.8),('10318','2013-07-03','07:15:00',1.87),('10318','2013-07-03','07:20:00',2.33),('10318','2013-07-03','07:25:00',2.63),('10318','2013-07-03','07:30:00',2.81),('10318','2013-07-03','07:35:00',3),('10318','2013-07-03','07:40:00',3.2),('10318','2013-07-03','07:45:00',3.4),('10318','2013-07-03','07:50:00',3.58),('10318','2013-07-03','07:55:00',3.78),('10318','2013-07-03','08:00:00',3.98),('10318','2013-07-03','08:05:00',4.17),('10318','2013-07-03','08:10:00',4.35),('10318','2013-07-03','08:15:00',4.53),('10318','2013-07-03','08:20:00',4.69),('10318','2013-07-03','08:25:00',4.88),('10318','2013-07-03','08:30:00',5.07),('10318','2013-07-03','08:35:00',5.2),('10318','2013-07-03','08:40:00',5.41),('10318','2013-07-03','08:45:00',5.57),('10318','2013-07-03','08:50:00',5.72),('10318','2013-07-03','08:55:00',5.89),('10318','2013-07-03','09:00:00',6.02),('10318','2013-07-03','09:05:00',6.12),('10318','2013-07-03','09:10:00',6.31),('10318','2013-07-03','09:15:00',6.49),('10318','2013-07-03','09:20:00',6.63),('10318','2013-07-03','09:25:00',6.71),('10318','2013-07-03','09:30:00',6.85),('10318','2013-07-03','09:35:00',6.96),('10318','2013-07-03','09:40:00',7.11),('10318','2013-07-03','09:45:00',7.24),('10318','2013-07-03','09:50:00',7.35),('10318','2013-07-03','09:55:00',7.45),('10318','2013-07-03','10:00:00',7.46),('10318','2013-07-03','10:05:00',7.58),('10318','2013-07-03','10:10:00',7.82),('10318','2013-07-03','10:15:00',7.77),('10318','2013-07-03','10:20:00',7.75),('10318','2013-07-03','10:25:00',8.05),('10318','2013-07-03','10:30:00',8.13),('10318','2013-07-03','10:35:00',8.29),('10318','2013-07-03','10:40:00',8.45),('10318','2013-07-03','10:45:00',8.47),('10318','2013-07-03','10:50:00',8.5),('10318','2013-07-03','10:55:00',8.58),('10318','2013-07-03','11:00:00',8.58),('10318','2013-07-03','11:05:00',8.73),('10318','2013-07-03','11:10:00',8.67),('10318','2013-07-03','11:15:00',8.78),('10318','2013-07-03','11:20:00',8.85),('10318','2013-07-03','11:25:00',8.96),('10318','2013-07-03','11:30:00',9),('10318','2013-07-03','11:35:00',9.02),('10318','2013-07-03','11:40:00',8.87),('10318','2013-07-03','11:45:00',9.19),('10318','2013-07-03','11:50:00',9.17),('10318','2013-07-03','11:55:00',9.3),('10318','2013-07-03','12:00:00',9.29),('10318','2013-07-03','12:05:00',9.22),('10318','2013-07-03','12:10:00',9.33),('10318','2013-07-03','12:15:00',9.32),('10318','2013-07-03','12:20:00',9.37),('10318','2013-07-03','12:25:00',9.32),('10318','2013-07-03','12:30:00',9.34),('10318','2013-07-03','12:35:00',9.35),('10318','2013-07-03','12:40:00',9.32),('10318','2013-07-03','12:45:00',9.39),('10318','2013-07-03','12:50:00',9.38),('10318','2013-07-03','12:55:00',9.35),('10318','2013-07-03','13:00:00',9.34),('10318','2013-07-03','13:05:00',9.35),('10318','2013-07-03','13:10:00',9.29),('10318','2013-07-03','13:15:00',9.36),('10318','2013-07-03','13:20:00',9.35),('10318','2013-07-03','13:25:00',9.26),('10318','2013-07-03','13:30:00',9.21),('10318','2013-07-03','13:35:00',9.13),('10318','2013-07-03','13:40:00',9.13),('10318','2013-07-03','13:45:00',9.09),('10318','2013-07-03','13:50:00',9.03),('10318','2013-07-03','13:55:00',9.04),('10318','2013-07-03','14:00:00',8.99),('10318','2013-07-03','14:05:00',8.92),('10318','2013-07-03','14:10:00',8.91),('10318','2013-07-03','14:15:00',8.83),('10318','2013-07-03','14:20:00',8.84),('10318','2013-07-03','14:25:00',8.76),('10318','2013-07-03','14:30:00',8.65),('10318','2013-07-03','14:35:00',8.57),('10318','2013-07-03','14:40:00',8.53),('10318','2013-07-03','14:45:00',8.46),('10318','2013-07-03','14:50:00',8.39),('10318','2013-07-03','14:55:00',8.31),('10318','2013-07-03','15:00:00',8.25),('10318','2013-07-03','15:05:00',8.08),('10318','2013-07-03','15:10:00',8.08),('10318','2013-07-03','15:15:00',7.95),('10318','2013-07-03','15:20:00',7.85),('10318','2013-07-03','15:25:00',7.75),('10318','2013-07-03','15:30:00',7.62),('10318','2013-07-03','15:35:00',7.44),('10318','2013-07-03','15:40:00',7.39),('10318','2013-07-03','15:45:00',7.25),('10318','2013-07-03','15:50:00',7.09),('10318','2013-07-03','15:55:00',6.97),('10318','2013-07-03','16:00:00',6.84),('10318','2013-07-03','16:05:00',6.7),('10318','2013-07-03','16:10:00',6.57),('10318','2013-07-03','16:15:00',6.43),('10318','2013-07-03','16:20:00',6.24),('10318','2013-07-03','16:25:00',6.09),('10318','2013-07-03','16:30:00',5.95),('10318','2013-07-03','16:35:00',5.79),('10318','2013-07-03','16:40:00',5.67),('10318','2013-07-03','16:45:00',5.51),('10318','2013-07-03','16:50:00',5.35),('10318','2013-07-03','16:55:00',5.05),('10318','2013-07-03','17:00:00',5),('10318','2013-07-03','17:05:00',4.82),('10318','2013-07-03','17:10:00',4.65),('10318','2013-07-03','17:15:00',4.47),('10318','2013-07-03','17:20:00',4.27),('10318','2013-07-03','17:25:00',4.07),('10318','2013-07-03','17:30:00',3.92),('10318','2013-07-03','17:35:00',3.73),('10318','2013-07-03','17:40:00',3.56),('10318','2013-07-03','17:45:00',3.39),('10318','2013-07-03','17:50:00',3.19),('10318','2013-07-03','17:55:00',2.97),('10318','2013-07-03','18:00:00',2.8),('10318','2013-07-03','18:05:00',2.63),('10318','2013-07-03','18:10:00',2.45),('10318','2013-07-03','18:15:00',2.28),('10318','2013-07-03','18:20:00',2.11),('10318','2013-07-03','18:25:00',1.93),('10318','2013-07-03','18:30:00',1.77),('10318','2013-07-03','18:35:00',1.62),('10318','2013-07-03','18:40:00',1.41),('10318','2013-07-03','18:45:00',1.32),('10318','2013-07-03','18:50:00',1.18),('10318','2013-07-03','18:55:00',1.06),('10318','2013-07-02','06:55:00',1.11),('10318','2013-07-02','07:00:00',1.36),('10318','2013-07-02','07:05:00',1.61),('10318','2013-07-02','07:10:00',1.73),('10318','2013-07-02','07:15:00',1.99),('10318','2013-07-02','07:20:00',2.28),('10318','2013-07-02','07:25:00',2.54),('10318','2013-07-02','07:30:00',2.71),('10318','2013-07-02','07:35:00',2.86),('10318','2013-07-02','07:40:00',3.08),('10318','2013-07-02','07:45:00',3.28),('10318','2013-07-02','07:50:00',3.46),('10318','2013-07-02','07:55:00',3.65),('10318','2013-07-02','08:00:00',3.87),('10318','2013-07-02','08:05:00',4.03),('10318','2013-07-02','08:10:00',4.23),('10318','2013-07-02','08:15:00',4.44),('10318','2013-07-02','08:20:00',4.63),('10318','2013-07-02','08:25:00',4.82),('10318','2013-07-02','08:30:00',4.98),('10318','2013-07-02','08:35:00',5.17),('10318','2013-07-02','08:40:00',5.32),('10318','2013-07-02','08:45:00',5.5),('10318','2013-07-02','08:50:00',5.67),('10318','2013-07-02','08:55:00',5.82),('10318','2013-07-02','09:00:00',5.96),('10318','2013-07-02','09:05:00',6.13),('10318','2013-07-02','09:10:00',6.28),('10318','2013-07-02','09:15:00',6.39),('10318','2013-07-02','09:20:00',6.42),('10318','2013-07-02','09:25:00',6.67),('10318','2013-07-02','09:30:00',6.8),('10318','2013-07-02','09:35:00',6.88),('10318','2013-07-02','09:40:00',6.99),('10318','2013-07-02','09:45:00',7.09),('10318','2013-07-02','09:50:00',7.17),('10318','2013-07-02','09:55:00',7.25),('10318','2013-07-02','10:00:00',7.36),('10318','2013-07-02','10:05:00',7.45),('10318','2013-07-02','10:10:00',7.57),('10318','2013-07-02','10:15:00',7.68),('10318','2013-07-02','10:20:00',7.77),('10318','2013-07-02','10:25:00',7.84),('10318','2013-07-02','10:30:00',7.91),('10318','2013-07-02','10:35:00',7.98),('10318','2013-07-02','10:40:00',8.09),('10318','2013-07-02','10:45:00',8.22),('10318','2013-07-02','10:50:00',8.29),('10318','2013-07-02','10:55:00',8.31),('10318','2013-07-02','11:00:00',8.41),('10318','2013-07-02','11:05:00',8.36),('10318','2013-07-02','11:10:00',8.4),('10318','2013-07-02','11:15:00',8.44),('10318','2013-07-02','11:20:00',8.49),('10318','2013-07-02','11:25:00',8.4),('10318','2013-07-02','11:30:00',8.59),('10318','2013-07-02','11:35:00',8.49),('10318','2013-07-02','11:40:00',8.68),('10318','2013-07-02','11:45:00',8.71),('10318','2013-07-02','11:50:00',8.74),('10318','2013-07-02','11:55:00',8.86),('10318','2013-07-02','12:00:00',9.06),('10318','2013-07-02','12:05:00',9.12),('10318','2013-07-02','12:10:00',9.16),('10318','2013-07-02','12:15:00',9.13),('10318','2013-07-02','12:20:00',9.13),('10318','2013-07-02','12:25:00',9.32),('10318','2013-07-02','12:30:00',9.32),('10318','2013-07-02','12:35:00',9.04),('10318','2013-07-02','12:40:00',8.77),('10318','2013-07-02','12:45:00',8.79),('10318','2013-07-02','12:50:00',8.81),('10318','2013-07-02','12:55:00',9.38),('10318','2013-07-02','13:00:00',8.74),('10318','2013-07-02','13:05:00',9.27),('10318','2013-07-02','13:10:00',9.28),('10318','2013-07-02','13:15:00',9.26),('10318','2013-07-02','13:20:00',9.28),('10318','2013-07-02','13:25:00',9.15),('10318','2013-07-02','13:30:00',9.04),('10318','2013-07-02','13:35:00',9.03),('10318','2013-07-02','13:40:00',9.03),('10318','2013-07-02','13:45:00',8.93),('10318','2013-07-02','13:50:00',8.8),('10318','2013-07-02','13:55:00',8.72),('10318','2013-07-02','14:00:00',8.75),('10318','2013-07-02','14:05:00',8.74),('10318','2013-07-02','14:10:00',8.6),('10318','2013-07-02','14:15:00',8.58),('10318','2013-07-02','14:20:00',8.54),('10318','2013-07-02','14:25:00',8.48),('10318','2013-07-02','14:30:00',8.41),('10318','2013-07-02','14:35:00',8.32),('10318','2013-07-02','14:40:00',8.27),('10318','2013-07-02','14:45:00',8.21),('10318','2013-07-02','14:50:00',8.17),('10318','2013-07-02','14:55:00',8.09),('10318','2013-07-02','15:00:00',7.98),('10318','2013-07-02','15:05:00',7.85),('10318','2013-07-02','15:10:00',7.78),('10318','2013-07-02','15:15:00',7.67),('10318','2013-07-02','15:20:00',7.62),('10318','2013-07-02','15:25:00',7.57),('10318','2013-07-02','15:30:00',7.42),('10318','2013-07-02','15:35:00',7.25),('10318','2013-07-02','15:40:00',7.15),('10318','2013-07-02','15:45:00',7.06),('10318','2013-07-02','15:50:00',6.78),('10318','2013-07-02','15:55:00',6.8),('10318','2013-07-02','16:00:00',6.69),('10318','2013-07-02','16:05:00',6.54),('10318','2013-07-02','16:10:00',6.43),('10318','2013-07-02','16:15:00',6.27),('10318','2013-07-02','16:20:00',6.01),('10318','2013-07-02','16:25:00',5.97),('10318','2013-07-02','16:30:00',5.81),('10318','2013-07-02','16:35:00',5.65),('10318','2013-07-02','16:40:00',5.51),('10318','2013-07-02','16:45:00',5.36),('10318','2013-07-02','16:50:00',5.19),('10318','2013-07-02','16:55:00',5.01),('10318','2013-07-02','17:00:00',4.87),('10318','2013-07-02','17:05:00',4.7),('10318','2013-07-02','17:10:00',4.52),('10318','2013-07-02','17:15:00',4.33),('10318','2013-07-02','17:20:00',4.17),('10318','2013-07-02','17:25:00',3.99),('10318','2013-07-02','17:30:00',3.79),('10318','2013-07-02','17:35:00',3.62),('10318','2013-07-02','17:40:00',3.37),('10318','2013-07-02','17:45:00',3.25),('10318','2013-07-02','17:50:00',3.07),('10318','2013-07-02','17:55:00',2.9),('10318','2013-07-02','18:00:00',2.72),('10318','2013-07-02','18:05:00',2.55),('10318','2013-07-02','18:10:00',2.38),('10318','2013-07-02','18:15:00',2.23),('10318','2013-07-02','18:20:00',2.06),('10318','2013-07-02','18:25:00',1.89),('10318','2013-07-02','18:30:00',1.74),('10318','2013-07-02','18:35:00',1.59),('10318','2013-07-02','18:40:00',1.45),('10318','2013-07-02','18:45:00',1.32),('10318','2013-07-02','18:50:00',1.19),('10318','2013-07-02','18:55:00',1.08),('10318','2013-07-01','06:55:00',1.21),('10318','2013-07-01','07:00:00',1.41),('10318','2013-07-01','07:05:00',1.58),('10318','2013-07-01','07:10:00',1.78),('10318','2013-07-01','07:15:00',1.92),('10318','2013-07-01','07:20:00',2.32),('10318','2013-07-01','07:25:00',2.6),('10318','2013-07-01','07:30:00',2.78),('10318','2013-07-01','07:35:00',2.97),('10318','2013-07-01','07:40:00',3.14),('10318','2013-07-01','07:45:00',3.33),('10318','2013-07-01','07:50:00',3.52),('10318','2013-07-01','07:55:00',3.77),('10318','2013-07-01','08:00:00',3.97),('10318','2013-07-01','08:05:00',4.16),('10318','2013-07-01','08:10:00',4.35),('10318','2013-07-01','08:15:00',4.53),('10318','2013-07-01','08:20:00',4.73),('10318','2013-07-01','08:25:00',4.91),('10318','2013-07-01','08:30:00',5.08),('10318','2013-07-01','08:35:00',5.17),('10318','2013-07-01','08:40:00',5.42),('10318','2013-07-01','08:45:00',5.58),('10318','2013-07-01','08:50:00',5.75),('10318','2013-07-01','08:55:00',5.91),('10318','2013-07-01','09:00:00',6.09),('10318','2013-07-01','09:05:00',6.24),('10318','2013-07-01','09:10:00',6.42),('10318','2013-07-01','09:15:00',6.6),('10318','2013-07-01','09:20:00',6.71),('10318','2013-07-01','09:25:00',6.85),('10318','2013-07-01','09:30:00',7.01),('10318','2013-07-01','09:35:00',7.12),('10318','2013-07-01','09:40:00',7.22),('10318','2013-07-01','09:45:00',7.32),('10318','2013-07-01','09:50:00',7.34),('10318','2013-07-01','09:55:00',7.54),('10318','2013-07-01','10:00:00',7.61),('10318','2013-07-01','10:05:00',7.69),('10318','2013-07-01','10:10:00',7.8),('10318','2013-07-01','10:15:00',7.94),('10318','2013-07-01','10:20:00',8.05),('10318','2013-07-01','10:25:00',8.18),('10318','2013-07-01','10:30:00',8.31),('10318','2013-07-01','10:35:00',8.41),('10318','2013-07-01','10:40:00',8.53),('10318','2013-07-01','10:45:00',8.6),('10318','2013-07-01','10:50:00',8.66),('10318','2013-07-01','10:55:00',8.78),('10318','2013-07-01','11:00:00',8.84),('10318','2013-07-01','11:05:00',8.83),('10318','2013-07-01','11:10:00',8.87),('10318','2013-07-01','11:15:00',8.91),('10318','2013-07-01','11:20:00',8.95),('10318','2013-07-01','11:25:00',9.05),('10318','2013-07-01','11:30:00',9.14),('10318','2013-07-01','11:35:00',9.06),('10318','2013-07-01','11:40:00',9.16),('10318','2013-07-01','11:45:00',9.16),('10318','2013-07-01','11:50:00',9.19),('10318','2013-07-01','11:55:00',9.33),('10318','2013-07-01','12:00:00',9.32),('10318','2013-07-01','12:05:00',9.25),('10318','2013-07-01','12:10:00',9.19),('10318','2013-07-01','12:15:00',9.18),('10318','2013-07-01','12:20:00',9.24),('10318','2013-07-01','12:25:00',9.28),('10318','2013-07-01','12:30:00',9.29),('10318','2013-07-01','12:35:00',9.32),('10318','2013-07-01','12:40:00',9.36),('10318','2013-07-01','12:45:00',9.37),('10318','2013-07-01','12:50:00',9.38),('10318','2013-07-01','12:55:00',9.31),('10318','2013-07-01','13:00:00',9.29),('10318','2013-07-01','13:05:00',9.31),('10318','2013-07-01','13:10:00',9.3),('10318','2013-07-01','13:15:00',9.32),('10318','2013-07-01','13:20:00',9.19),('10318','2013-07-01','13:25:00',9.32),('10318','2013-07-01','13:30:00',9.31),('10318','2013-07-01','13:35:00',9.41),('10318','2013-07-01','13:40:00',9.25),('10318','2013-07-01','13:45:00',9.13),('10318','2013-07-01','13:50:00',9.01),('10318','2013-07-01','13:55:00',9.02),('10318','2013-07-01','14:00:00',8.91),('10318','2013-07-01','14:05:00',8.93),('10318','2013-07-01','14:10:00',8.88),('10318','2013-07-01','14:15:00',8.87),('10318','2013-07-01','14:20:00',8.84),('10318','2013-07-01','14:25:00',8.71),('10318','2013-07-01','14:30:00',8.56),('10318','2013-07-01','14:35:00',8.52),('10318','2013-07-01','14:40:00',8.44),('10318','2013-07-01','14:45:00',8.34),('10318','2013-07-01','14:50:00',8.22),('10318','2013-07-01','14:55:00',8.12),('10318','2013-07-01','15:00:00',7.98),('10318','2013-07-01','15:05:00',7.92),('10318','2013-07-01','15:10:00',7.73),('10318','2013-07-01','15:15:00',7.83),('10318','2013-07-01','15:20:00',7.68),('10318','2013-07-01','15:25:00',7.49),('10318','2013-07-01','15:30:00',7.37),('10318','2013-07-01','15:35:00',7.21),('10318','2013-07-01','15:40:00',7.15),('10318','2013-07-01','15:45:00',7.02),('10318','2013-07-01','15:50:00',6.87),('10318','2013-07-01','15:55:00',6.76),('10318','2013-07-01','16:00:00',6.61),('10318','2013-07-01','16:05:00',6.49),('10318','2013-07-01','16:10:00',6.3),('10318','2013-07-01','16:15:00',6.22),('10318','2013-07-01','16:20:00',6.04),('10318','2013-07-01','16:25:00',5.92),('10318','2013-07-01','16:30:00',5.74),('10318','2013-07-01','16:35:00',5.59),('10318','2013-07-01','16:40:00',5.43),('10318','2013-07-01','16:45:00',5.28),('10318','2013-07-01','16:50:00',5.13),('10318','2013-07-01','16:55:00',4.98),('10318','2013-07-01','17:00:00',4.79),('10318','2013-07-01','17:05:00',4.66),('10318','2013-07-01','17:10:00',4.51),('10318','2013-07-01','17:15:00',4.3),('10318','2013-07-01','17:20:00',4.1),('10318','2013-07-01','17:25:00',3.93),('10318','2013-07-01','17:30:00',3.75),('10318','2013-07-01','17:35:00',3.58),('10318','2013-07-01','17:40:00',3.41),('10318','2013-07-01','17:45:00',3.25),('10318','2013-07-01','17:50:00',3.08),('10318','2013-07-01','17:55:00',2.9),('10318','2013-07-01','18:00:00',2.63),('10318','2013-07-01','18:05:00',2.53),('10318','2013-07-01','18:10:00',2.29),('10318','2013-07-01','18:15:00',1.97),('10318','2013-07-01','18:20:00',2.1),('10318','2013-07-01','18:25:00',2.03),('10318','2013-07-01','18:30:00',1.88),('10318','2013-07-01','18:35:00',1.7),('10318','2013-07-01','18:40:00',1.47),('10318','2013-07-01','18:45:00',1.37),('10318','2013-07-01','18:50:00',1.2),('10318','2013-07-01','18:55:00',1.09),('10318','2013-07-01','19:00:00',1.03),('10318','2014-04-05','08:30:00',1.04),('10318','2014-04-05','08:35:00',1.52),('10318','2014-04-05','08:40:00',1.81),('10318','2014-04-05','08:45:00',1.71),('10318','2014-04-05','08:50:00',1.37),('10318','2014-04-05','08:55:00',1.14),('10318','2014-04-05','09:00:00',1.34),('10318','2014-04-05','09:05:00',1.55),('10318','2014-04-05','09:10:00',1.63),('10318','2014-04-05','09:15:00',1.99),('10318','2014-04-05','09:20:00',3.1),('10318','2014-04-05','09:25:00',3.79),('10318','2014-04-05','09:30:00',4.09),('10318','2014-04-05','09:35:00',4.93),('10318','2014-04-05','09:40:00',4.85),('10318','2014-04-05','09:45:00',5.81),('10318','2014-04-05','09:50:00',7.01),('10318','2014-04-05','09:55:00',5.7),('10318','2014-04-05','10:00:00',7.49),('10318','2014-04-05','10:05:00',4.54),('10318','2014-04-05','10:10:00',4.33),('10318','2014-04-05','10:15:00',4.51),('10318','2014-04-05','10:20:00',4.54),('10318','2014-04-05','10:25:00',6.72),('10318','2014-04-05','10:30:00',6.96),('10318','2014-04-05','10:35:00',7.97),('10318','2014-04-05','10:40:00',8.03),('10318','2014-04-05','10:45:00',7.4),('10318','2014-04-05','10:50:00',7.1),('10318','2014-04-05','10:55:00',7.91),('10318','2014-04-05','11:00:00',6.51),('10318','2014-04-05','11:05:00',6.79),('10318','2014-04-05','11:10:00',7.95),('10318','2014-04-05','11:15:00',8.45),('10318','2014-04-05','11:20:00',9),('10318','2014-04-05','11:25:00',9.98),('10318','2014-04-05','11:30:00',8.53),('10318','2014-04-05','11:35:00',7.6),('10318','2014-04-05','11:40:00',6.22),('10318','2014-04-05','11:45:00',5.23),('10318','2014-04-05','11:50:00',6.37),('10318','2014-04-05','11:55:00',7.61),('10318','2014-04-05','12:00:00',8.66),('10318','2014-04-05','12:05:00',9.05),('10318','2014-04-05','12:10:00',9.36),('10318','2014-04-05','12:15:00',6.8),('10318','2014-04-05','12:20:00',7.73),('10318','2014-04-05','12:25:00',8.2),('10318','2014-04-05','12:30:00',7.65),('10318','2014-04-05','12:35:00',7.38),('10318','2014-04-05','12:40:00',6.74),('10318','2014-04-05','12:45:00',7.5),('10318','2014-04-05','12:50:00',6.55),('10318','2014-04-05','12:55:00',7.52),('10318','2014-04-05','13:00:00',6.85),('10318','2014-04-05','13:05:00',6.38),('10318','2014-04-05','13:10:00',6.4),('10318','2014-04-05','13:15:00',7.65),('10318','2014-04-05','13:20:00',8.66),('10318','2014-04-05','13:25:00',6.99),('10318','2014-04-05','13:30:00',5.92),('10318','2014-04-05','13:35:00',8.42),('10318','2014-04-05','13:40:00',9.19),('10318','2014-04-05','13:45:00',9.86),('10318','2014-04-05','13:50:00',9.77),('10318','2014-04-05','13:55:00',9.69),('10318','2014-04-05','14:00:00',10.47),('10318','2014-04-05','14:05:00',9.31),('10318','2014-04-05','14:10:00',3.79),('10318','2014-04-05','14:15:00',1.44),('10318','2014-04-05','14:20:00',1.39),('10318','2014-04-05','14:25:00',1.86),('10318','2014-04-05','14:30:00',2.96),('10318','2014-04-05','14:35:00',2.11),('10318','2014-04-05','14:40:00',1.63),('10318','2014-04-05','14:45:00',1.8),('10318','2014-04-05','14:50:00',1.77),('10318','2014-04-05','14:55:00',5.77),('10318','2014-04-05','15:00:00',8.94),('10318','2014-04-05','15:05:00',8.66),('10318','2014-04-05','15:10:00',8.95),('10318','2014-04-05','15:15:00',7.58),('10318','2014-04-05','15:20:00',8.63),('10318','2014-04-05','15:25:00',6.65),('10318','2014-04-05','15:30:00',3.4),('10318','2014-04-05','15:35:00',4.91),('10318','2014-04-05','15:40:00',5.13),('10318','2014-04-05','15:45:00',4.72),('10318','2014-04-05','15:50:00',2.68),('10318','2014-04-05','15:55:00',2.54),('10318','2014-04-05','16:00:00',2.67),('10318','2014-04-05','16:05:00',2.85),('10318','2014-04-05','16:10:00',2.49),('10318','2014-04-05','16:15:00',2.7),('10318','2014-04-05','16:20:00',6.76),('10318','2014-04-05','16:25:00',6),('10318','2014-04-05','16:30:00',4.69),('10318','2014-04-05','16:35:00',3.34),('10318','2014-04-05','16:40:00',3.16),('10318','2014-04-05','16:45:00',5.08),('10318','2014-04-05','16:50:00',6.03),('10318','2014-04-05','16:55:00',5.36),('10318','2014-04-05','17:00:00',3.97),('10318','2014-04-05','17:05:00',4.11),('10318','2014-04-05','17:10:00',2.25),('10318','2014-04-05','17:15:00',3.35),('10318','2014-04-05','17:20:00',3.05),('10318','2014-04-05','17:25:00',2.91),('10318','2014-04-05','17:30:00',2.29),('10318','2014-04-05','17:35:00',1.54),('10318','2014-04-05','17:40:00',1.38),('10318','2014-04-05','17:45:00',1.41),('10318','2014-04-05','17:50:00',1.44),('10318','2014-04-05','17:55:00',1.67),('10318','2014-04-05','18:00:00',1.82),('10318','2014-04-05','18:05:00',1.82),('10318','2014-04-05','18:10:00',1.84),('10318','2014-04-05','18:15:00',1.73),('10318','2014-04-05','18:20:00',1.61),('10318','2014-04-05','18:25:00',1.32),('10318','2014-04-05','18:30:00',1.12),('10318','2013-06-30','06:55:00',1.26),('10318','2013-06-30','07:00:00',1.49),('10318','2013-06-30','07:05:00',1.8),('10318','2013-06-30','07:10:00',1.88),('10318','2013-06-30','07:15:00',2.09),('10318','2013-06-30','07:20:00',2.54),('10318','2013-06-30','07:25:00',2.83),('10318','2013-06-30','07:30:00',3.01),('10318','2013-06-30','07:35:00',3.18),('10318','2013-06-30','07:40:00',3.37),('10318','2013-06-30','07:45:00',3.56),('10318','2013-06-30','07:50:00',3.75),('10318','2013-06-30','07:55:00',3.95),('10318','2013-06-30','08:00:00',4.15),('10318','2013-06-30','08:05:00',4.34),('10318','2013-06-30','08:10:00',4.54),('10318','2013-06-30','08:15:00',4.75),('10318','2013-06-30','08:20:00',4.93),('10318','2013-06-30','08:25:00',5.11),('10318','2013-06-30','08:30:00',5.28),('10318','2013-06-30','08:35:00',5.45),('10318','2013-06-30','08:40:00',5.63),('10318','2013-06-30','08:45:00',5.8),('10318','2013-06-30','08:50:00',5.97),('10318','2013-06-30','08:55:00',6.12),('10318','2013-06-30','09:00:00',6.27),('10318','2013-06-30','09:05:00',6.4),('10318','2013-06-30','09:10:00',6.54),('10318','2013-06-30','09:15:00',6.68),('10318','2013-06-30','09:20:00',6.81),('10318','2013-06-30','09:25:00',6.96),('10318','2013-06-30','09:30:00',7.1),('10318','2013-06-30','09:35:00',7.22),('10318','2013-06-30','09:40:00',7.36),('10318','2013-06-30','09:45:00',7.49),('10318','2013-06-30','09:50:00',7.58),('10318','2013-06-30','09:55:00',7.68),('10318','2013-06-30','10:00:00',7.81),('10318','2013-06-30','10:05:00',7.93),('10318','2013-06-30','10:10:00',8.06),('10318','2013-06-30','10:15:00',8.16),('10318','2013-06-30','10:20:00',8.21),('10318','2013-06-30','10:25:00',8.31),('10318','2013-06-30','10:30:00',8.38),('10318','2013-06-30','10:35:00',8.49),('10318','2013-06-30','10:40:00',8.56),('10318','2013-06-30','10:45:00',8.62),('10318','2013-06-30','10:50:00',8.64),('10318','2013-06-30','10:55:00',8.73),('10318','2013-06-30','11:00:00',8.81),('10318','2013-06-30','11:05:00',8.9),('10318','2013-06-30','11:10:00',8.94),('10318','2013-06-30','11:15:00',9),('10318','2013-06-30','11:20:00',9.07),('10318','2013-06-30','11:25:00',9.13),('10318','2013-06-30','11:30:00',9.15),('10318','2013-06-30','11:35:00',8.91),('10318','2013-06-30','11:40:00',9.25),('10318','2013-06-30','11:45:00',9.31),('10318','2013-06-30','11:50:00',9.39),('10318','2013-06-30','11:55:00',9.34),('10318','2013-06-30','12:00:00',9.35),('10318','2013-06-30','12:05:00',9.32),('10318','2013-06-30','12:10:00',9.36),('10318','2013-06-30','12:15:00',9.4),('10318','2013-06-30','12:20:00',9.42),('10318','2013-06-30','12:25:00',9.37),('10318','2013-06-30','12:30:00',9.58),('10318','2013-06-30','12:35:00',9.38),('10318','2013-06-30','12:40:00',9.35),('10318','2013-06-30','12:45:00',9.34),('10318','2013-06-30','12:50:00',9.31),('10318','2013-06-30','12:55:00',9.44),('10318','2013-06-30','13:00:00',9.55),('10318','2013-06-30','13:05:00',9.53),('10318','2013-06-30','13:10:00',9.68),('10318','2013-06-30','13:15:00',9.69),('10318','2013-06-30','13:20:00',9.41),('10318','2013-06-30','13:25:00',9.67),('10318','2013-06-30','13:30:00',9.16),('10318','2013-06-30','13:35:00',8.99),('10318','2013-06-30','13:40:00',9.56),('10318','2013-06-30','13:45:00',8.69),('10318','2013-06-30','13:50:00',9.55),('10318','2013-06-30','13:55:00',9.5),('10318','2013-06-30','14:00:00',5.59),('10318','2013-06-30','14:05:00',9.59),('10318','2013-06-30','14:10:00',9.29),('10318','2013-06-30','14:15:00',9),('10318','2013-06-30','14:20:00',8.87),('10318','2013-06-30','14:25:00',8.86),('10318','2013-06-30','14:30:00',8.73),('10318','2013-06-30','14:35:00',8.57),('10318','2013-06-30','14:40:00',8.42),('10318','2013-06-30','14:45:00',8.41),('10318','2013-06-30','14:50:00',8.18),('10318','2013-06-30','14:55:00',8.19),('10318','2013-06-30','15:00:00',8.12),('10318','2013-06-30','15:05:00',7.8),('10318','2013-06-30','15:10:00',8.05),('10318','2013-06-30','15:15:00',7.91),('10318','2013-06-30','15:20:00',7.84),('10318','2013-06-30','15:25:00',7.74),('10318','2013-06-30','15:30:00',7.63),('10318','2013-06-30','15:35:00',7.53),('10318','2013-06-30','15:40:00',7.44),('10318','2013-06-30','15:45:00',7.2),('10318','2013-06-30','15:50:00',7.16),('10318','2013-06-30','15:55:00',7.05),('10318','2013-06-30','16:00:00',6.9),('10318','2013-06-30','16:05:00',6.81),('10318','2013-06-30','16:10:00',6.7),('10318','2013-06-30','16:15:00',6.6),('10318','2013-06-30','16:20:00',6.52),('10318','2013-06-30','16:25:00',6.41),('10318','2013-06-30','16:30:00',5.99),('10318','2013-06-30','16:35:00',5.93),('10318','2013-06-30','16:40:00',5.69),('10318','2013-06-30','16:45:00',5.44),('10318','2013-06-30','16:50:00',5.21),('10318','2013-06-30','16:55:00',5.13),('10318','2013-06-30','17:00:00',4.93),('10318','2013-06-30','17:05:00',4.74),('10318','2013-06-30','17:10:00',4.58),('10318','2013-06-30','17:15:00',4.43),('10318','2013-06-30','17:20:00',4.21),('10318','2013-06-30','17:25:00',4.05),('10318','2013-06-30','17:30:00',3.87),('10318','2013-06-30','17:35:00',3.68),('10318','2013-06-30','17:40:00',3.54),('10318','2013-06-30','17:45:00',3.37),('10318','2013-06-30','17:50:00',3.19),('10318','2013-06-30','17:55:00',2.93),('10318','2013-06-30','18:00:00',2.8),('10318','2013-06-30','18:05:00',2.6),('10318','2013-06-30','18:10:00',2.49),('10318','2013-06-30','18:15:00',2.32),('10318','2013-06-30','18:20:00',2.14),('10318','2013-06-30','18:25:00',2.01),('10318','2013-06-30','18:30:00',1.86),('10318','2013-06-30','18:35:00',1.71),('10318','2013-06-30','18:40:00',1.57),('10318','2013-06-30','18:45:00',1.44),('10318','2013-06-30','18:50:00',1.34),('10318','2013-06-30','18:55:00',1.21),('10318','2013-06-30','19:00:00',1.1),('10318','2013-06-29','07:15:00',1.16),('10318','2013-06-29','07:20:00',1.04),('10318','2013-06-29','07:25:00',2.18),('10318','2013-06-29','07:30:00',3.29),('10318','2013-06-29','07:35:00',4.02),('10318','2013-06-29','07:40:00',4.24),('10318','2013-06-29','07:45:00',4.31),('10318','2013-06-29','07:50:00',4.64),('10318','2013-06-29','07:55:00',5.07),('10318','2013-06-29','08:00:00',4.16),('10318','2013-06-29','08:05:00',3.61),('10318','2013-06-29','08:10:00',4.52),('10318','2013-06-29','08:15:00',3.24),('10318','2013-06-29','08:20:00',2.14),('10318','2013-06-29','08:25:00',4.83),('10318','2013-06-29','08:30:00',5.13),('10318','2013-06-29','08:35:00',5.56),('10318','2013-06-29','08:40:00',5.8),('10318','2013-06-29','08:45:00',5.83),('10318','2013-06-29','08:50:00',5.96),('10318','2013-06-29','08:55:00',6.11),('10318','2013-06-29','09:00:00',6.26),('10318','2013-06-29','09:05:00',6.37),('10318','2013-06-29','09:10:00',6.49),('10318','2013-06-29','09:15:00',6.54),('10318','2013-06-29','09:20:00',6.78),('10318','2013-06-29','09:25:00',6.9),('10318','2013-06-29','09:30:00',7.03),('10318','2013-06-29','09:35:00',7.16),('10318','2013-06-29','09:40:00',7.34),('10318','2013-06-29','09:45:00',7.4),('10318','2013-06-29','09:50:00',7.57),('10318','2013-06-29','09:55:00',7.68),('10318','2013-06-29','10:00:00',7.74),('10318','2013-06-29','10:05:00',7.86),('10318','2013-06-29','10:10:00',7.92),('10318','2013-06-29','10:15:00',8.05),('10318','2013-06-29','10:20:00',8.17),('10318','2013-06-29','10:25:00',8.25),('10318','2013-06-29','10:30:00',8.39),('10318','2013-06-29','10:35:00',8.48),('10318','2013-06-29','10:40:00',8.57),('10318','2013-06-29','10:45:00',8.68),('10318','2013-06-29','10:50:00',8.76),('10318','2013-06-29','10:55:00',8.93),('10318','2013-06-29','11:00:00',6.35),('10318','2013-06-29','11:05:00',5.43),('10318','2013-06-29','11:10:00',9.97),('10318','2013-06-29','11:15:00',8.89),('10318','2013-06-29','11:20:00',9.54),('10318','2013-06-29','11:25:00',9.15),('10318','2013-06-29','11:30:00',2.71),('10318','2013-06-29','11:35:00',2.43),('10318','2013-06-29','11:40:00',5.32),('10318','2013-06-29','11:45:00',6.41),('10318','2013-06-29','11:50:00',4.21),('10318','2013-06-29','11:55:00',4.85),('10318','2013-06-29','12:00:00',5.9),('10318','2013-06-29','12:05:00',10.27),('10318','2013-06-29','12:10:00',10.57),('10318','2013-06-29','12:15:00',3.61),('10318','2013-06-29','12:20:00',5.13),('10318','2013-06-29','12:25:00',3.5),('10318','2013-06-29','12:30:00',7.46),('10318','2013-06-29','12:35:00',9.36),('10318','2013-06-29','12:40:00',8.74),('10318','2013-06-29','12:45:00',4.7),('10318','2013-06-29','12:50:00',2.92),('10318','2013-06-29','12:55:00',5.59),('10318','2013-06-29','13:00:00',10.78),('10318','2013-06-29','13:05:00',7.37),('10318','2013-06-29','13:10:00',10.52),('10318','2013-06-29','13:15:00',10.3),('10318','2013-06-29','13:20:00',3.58),('10318','2013-06-29','13:25:00',3.01),('10318','2013-06-29','13:30:00',3.07),('10318','2013-06-29','13:35:00',2.98),('10318','2013-06-29','13:40:00',3.87),('10318','2013-06-29','13:45:00',5.84),('10318','2013-06-29','13:50:00',6.07),('10318','2013-06-29','13:55:00',10.48),('10318','2013-06-29','14:00:00',9.85),('10318','2013-06-29','14:05:00',9.85),('10318','2013-06-29','14:10:00',9.93),('10318','2013-06-29','14:15:00',4.23),('10318','2013-06-29','14:20:00',8.12),('10318','2013-06-29','14:25:00',9.92),('10318','2013-06-29','14:30:00',9.48),('10318','2013-06-29','14:35:00',9.39),('10318','2013-06-29','14:40:00',9.44),('10318','2013-06-29','14:45:00',9.51),('10318','2013-06-29','14:50:00',9.75),('10318','2013-06-29','14:55:00',8.29),('10318','2013-06-29','15:00:00',6.22),('10318','2013-06-29','15:05:00',5.73),('10318','2013-06-29','15:10:00',4.99),('10318','2013-06-29','15:15:00',7.37),('10318','2013-06-29','15:20:00',6.61),('10318','2013-06-29','15:25:00',3.54),('10318','2013-06-29','15:30:00',2.32),('10318','2013-06-29','15:35:00',1.34),('10318','2013-06-29','15:40:00',1.18),('10318','2013-06-29','15:45:00',1.15),('10318','2013-06-29','16:15:00',1.01),('10318','2013-06-29','16:20:00',1.44),('10318','2013-06-29','16:25:00',1.7),('10318','2013-06-29','16:30:00',1.99),('10318','2013-06-29','16:35:00',2.48),('10318','2013-06-29','16:40:00',3.32),('10318','2013-06-29','16:45:00',3.88),('10318','2013-06-29','16:50:00',3.2),('10318','2013-06-29','16:55:00',2.34),('10318','2013-06-29','17:00:00',2.94),('10318','2013-06-29','17:05:00',2.33),('10318','2013-06-29','17:10:00',2.25),('10318','2013-06-29','17:15:00',2.34),('10318','2013-06-29','17:20:00',3.5),('10318','2013-06-29','17:25:00',4.89),('10318','2013-06-29','17:30:00',4.63),('10318','2013-06-29','17:35:00',1.98),('10318','2013-06-29','17:40:00',2.27),('10318','2013-06-29','17:45:00',3.55),('10318','2013-06-29','17:50:00',2.03),('10318','2013-06-29','17:55:00',2.33),('10318','2013-06-29','18:00:00',1.83),('10318','2013-06-29','18:20:00',2.02),('10318','2013-06-29','18:25:00',1.78),('10318','2013-06-29','18:30:00',1.56),('10318','2013-06-29','18:35:00',1.29),('10318','2013-06-29','18:40:00',1.49),('10318','2013-06-29','19:05:00',1.2),('10318','2013-06-29','19:10:00',1.15),('10318','2013-06-28','06:55:00',1.18),('10318','2013-06-28','07:10:00',1.77),('10318','2013-06-28','07:15:00',2.19),('10318','2013-06-28','07:20:00',2.58),('10318','2013-06-28','07:25:00',2.83),('10318','2013-06-28','07:30:00',2.99),('10318','2013-06-28','07:35:00',2.99),('10318','2013-06-28','07:40:00',3.39),('10318','2013-06-28','07:45:00',3.7),('10318','2013-06-28','07:50:00',3.84),('10318','2013-06-28','07:55:00',3.94),('10318','2013-06-28','08:00:00',3.94),('10318','2013-06-28','08:05:00',4.22),('10318','2013-06-28','08:10:00',4.12),('10318','2013-06-28','08:15:00',4.59),('10318','2013-06-28','08:20:00',4.39),('10318','2013-06-28','08:25:00',4.88),('10318','2013-06-28','08:30:00',5.14),('10318','2013-06-28','08:35:00',5.37),('10318','2013-06-28','08:40:00',5.44),('10318','2013-06-28','08:45:00',5.54),('10318','2013-06-28','08:50:00',5.66),('10318','2013-06-28','08:55:00',5.25),('10318','2013-06-28','09:00:00',5.72),('10318','2013-06-28','09:05:00',5.23),('10318','2013-06-28','09:10:00',6.48),('10318','2013-06-28','09:15:00',6.77),('10318','2013-06-28','09:20:00',6.61),('10318','2013-06-28','09:25:00',6.09),('10318','2013-06-28','09:30:00',7.14),('10318','2013-06-28','09:35:00',5.95),('10318','2013-06-28','09:40:00',2.95),('10318','2013-06-28','09:45:00',8.05),('10318','2013-06-28','09:50:00',8.92),('10318','2013-06-28','09:55:00',8.01),('10318','2013-06-28','10:00:00',5.02),('10318','2013-06-28','10:05:00',8.73),('10318','2013-06-28','10:10:00',8.84),('10318','2013-06-28','10:15:00',9.03),('10318','2013-06-28','10:20:00',4.4),('10318','2013-06-28','10:25:00',2.64),('10318','2013-06-28','10:30:00',2.66),('10318','2013-06-28','10:35:00',2.36),('10318','2013-06-28','10:40:00',4.25),('10318','2013-06-28','10:45:00',4.08),('10318','2013-06-28','10:50:00',7.9),('10318','2013-06-28','10:55:00',3.79),('10318','2013-06-28','11:00:00',3.81),('10318','2013-06-28','11:05:00',6.04),('10318','2013-06-28','11:10:00',7.17),('10318','2013-06-28','11:15:00',6.95),('10318','2013-06-28','11:20:00',6.55),('10318','2013-06-28','11:25:00',4.56),('10318','2013-06-28','11:30:00',9.84),('10318','2013-06-28','11:35:00',6.84),('10318','2013-06-28','11:40:00',6.66),('10318','2013-06-28','11:45:00',10.68),('10318','2013-06-28','11:50:00',9.25),('10318','2013-06-28','11:55:00',8.66),('10318','2013-06-28','12:00:00',9.37),('10318','2013-06-28','12:05:00',8.28),('10318','2013-06-28','12:10:00',8.61),('10318','2013-06-28','12:15:00',7.16),('10318','2013-06-28','12:20:00',9.99),('10318','2013-06-28','12:25:00',9.46),('10318','2013-06-28','12:30:00',9.72),('10318','2013-06-28','12:35:00',9.88),('10318','2013-06-28','12:40:00',7.9),('10318','2013-06-28','12:45:00',10.08),('10318','2013-06-28','12:50:00',9.62),('10318','2013-06-28','12:55:00',9.9),('10318','2013-06-28','13:00:00',9.83),('10318','2013-06-28','13:05:00',7.26),('10318','2013-06-28','13:10:00',10.15),('10318','2013-06-28','13:15:00',9.29),('10318','2013-06-28','13:20:00',9.93),('10318','2013-06-28','13:25:00',8.33),('10318','2013-06-28','13:30:00',7.8),('10318','2013-06-28','13:35:00',9.72),('10318','2013-06-28','13:40:00',9.67),('10318','2013-06-28','13:45:00',6.42),('10318','2013-06-28','13:50:00',6.3),('10318','2013-06-28','13:55:00',8.18),('10318','2013-06-28','14:00:00',7.43),('10318','2013-06-28','14:05:00',8.09),('10318','2013-06-28','14:10:00',7.24),('10318','2013-06-28','14:15:00',7.53),('10318','2013-06-28','14:20:00',9.12),('10318','2013-06-28','14:25:00',8.45),('10318','2013-06-28','14:30:00',9.13),('10318','2013-06-28','14:35:00',9.44),('10318','2013-06-28','14:40:00',9.21),('10318','2013-06-28','14:45:00',6.9),('10318','2013-06-28','14:50:00',8.24),('10318','2013-06-28','14:55:00',4.99),('10318','2013-06-28','15:00:00',8),('10318','2013-06-28','15:05:00',8.68),('10318','2013-06-28','15:10:00',5.4),('10318','2013-06-28','15:15:00',5.25),('10318','2013-06-28','15:20:00',4.29),('10318','2013-06-28','15:25:00',8.94),('10318','2013-06-28','15:30:00',4.16),('10318','2013-06-28','15:35:00',6.25),('10318','2013-06-28','15:40:00',7.03),('10318','2013-06-28','15:45:00',8.81),('10318','2013-06-28','15:50:00',7.99),('10318','2013-06-28','15:55:00',7.8),('10318','2013-06-28','16:00:00',4.59),('10318','2013-06-28','16:05:00',4.06),('10318','2013-06-28','16:10:00',7.09),('10318','2013-06-28','16:15:00',2.34),('10318','2013-06-28','16:20:00',4.81),('10318','2013-06-28','16:25:00',4.98),('10318','2013-06-28','16:30:00',2.95),('10318','2013-06-28','16:35:00',3.88),('10318','2013-06-28','16:40:00',5.51),('10318','2013-06-28','16:45:00',2.9),('10318','2013-06-28','16:50:00',3.01),('10318','2013-06-28','16:55:00',3.5),('10318','2013-06-28','17:00:00',5.37),('10318','2013-06-28','17:05:00',4.51),('10318','2013-06-28','17:10:00',4.73),('10318','2013-06-28','17:15:00',4.67),('10318','2013-06-28','17:20:00',4.34),('10318','2013-06-28','17:25:00',3.95),('10318','2013-06-28','17:30:00',3.99),('10318','2013-06-28','17:35:00',3.8),('10318','2013-06-28','17:40:00',3.59),('10318','2013-06-28','17:45:00',3.44),('10318','2013-06-28','17:50:00',3.22),('10318','2013-06-28','17:55:00',3.07),('10318','2013-06-28','18:00:00',2.85),('10318','2013-06-28','18:05:00',2.66),('10318','2013-06-28','18:10:00',2.51),('10318','2013-06-28','18:15:00',2.34),('10318','2013-06-28','18:20:00',2.17),('10318','2013-06-28','18:25:00',2.07),('10318','2013-06-28','18:30:00',2.01),('10318','2013-06-28','18:35:00',1.89),('10318','2013-06-28','18:40:00',1.62),('10318','2013-06-28','18:45:00',1.51),('10318','2013-06-28','18:50:00',1.29),('10318','2013-06-28','18:55:00',1.15),('10318','2013-06-28','19:00:00',1.02),('10318','2013-06-27','07:15:00',1.55),('10318','2013-06-27','07:20:00',2.22),('10318','2013-06-27','07:25:00',2.51),('10318','2013-06-27','07:30:00',2.83),('10318','2013-06-27','07:35:00',3),('10318','2013-06-27','07:40:00',3.2),('10318','2013-06-27','07:45:00',3.45),('10318','2013-06-27','07:50:00',3.66),('10318','2013-06-27','07:55:00',3.9),('10318','2013-06-27','08:00:00',4.14),('10318','2013-06-27','08:05:00',4.35),('10318','2013-06-27','08:10:00',4.51),('10318','2013-06-27','08:15:00',4.7),('10318','2013-06-27','08:20:00',4.84),('10318','2013-06-27','08:25:00',5.04),('10318','2013-06-27','08:30:00',5.18),('10318','2013-06-27','08:35:00',5.28),('10318','2013-06-27','08:40:00',5.48),('10318','2013-06-27','08:45:00',5.66),('10318','2013-06-27','08:50:00',6.04),('10318','2013-06-27','08:55:00',6.53),('10318','2013-06-27','09:00:00',6.27),('10318','2013-06-27','09:05:00',5.86),('10318','2013-06-27','09:10:00',6.43),('10318','2013-06-27','09:15:00',6.68),('10318','2013-06-27','09:20:00',6.84),('10318','2013-06-27','09:25:00',7.05),('10318','2013-06-27','09:30:00',7.23),('10318','2013-06-27','09:35:00',7.35),('10318','2013-06-27','09:40:00',7.4),('10318','2013-06-27','09:45:00',7.45),('10318','2013-06-27','09:50:00',7.68),('10318','2013-06-27','09:55:00',7.2),('10318','2013-06-27','10:00:00',7.71),('10318','2013-06-27','10:05:00',8.06),('10318','2013-06-27','10:10:00',8.03),('10318','2013-06-27','10:15:00',8.15),('10318','2013-06-27','10:20:00',8.29),('10318','2013-06-27','10:25:00',8.33),('10318','2013-06-27','10:30:00',8.33),('10318','2013-06-27','10:35:00',7.3),('10318','2013-06-27','10:40:00',8.06),('10318','2013-06-27','10:45:00',9.37),('10318','2013-06-27','10:50:00',9.16),('10318','2013-06-27','10:55:00',9.19),('10318','2013-06-27','11:00:00',9.24),('10318','2013-06-27','11:05:00',5.16),('10318','2013-06-27','11:10:00',2.11),('10318','2013-06-27','11:15:00',7.48),('10318','2013-06-27','11:20:00',8.3),('10318','2013-06-27','11:25:00',4.83),('10318','2013-06-27','11:30:00',9.68),('10318','2013-06-27','11:35:00',10.14),('10318','2013-06-27','11:40:00',8.39),('10318','2013-06-27','11:45:00',4.82),('10318','2013-06-27','11:50:00',2.89),('10318','2013-06-27','11:55:00',4.82),('10318','2013-06-27','12:00:00',5.31),('10318','2013-06-27','12:05:00',3.88),('10318','2013-06-27','12:10:00',3.04),('10318','2013-06-27','12:15:00',2.73),('10318','2013-06-27','12:20:00',2.56),('10318','2013-06-27','12:25:00',2.51),('10318','2013-06-27','12:30:00',2.83),('10318','2013-06-27','12:35:00',2.39),('10318','2013-06-27','12:40:00',2.51),('10318','2013-06-27','12:45:00',2.67),('10318','2013-06-27','12:50:00',2.5),('10318','2013-06-27','12:55:00',2.78),('10318','2013-06-27','13:00:00',3.24),('10318','2013-06-27','13:05:00',7.09),('10318','2013-06-27','13:10:00',3.05),('10318','2013-06-27','13:15:00',3.1),('10318','2013-06-27','13:20:00',2.78),('10318','2013-06-27','13:25:00',2.72),('10318','2013-06-27','13:30:00',3.13),('10318','2013-06-27','13:35:00',3.58),('10318','2013-06-27','13:40:00',3.85),('10318','2013-06-27','13:45:00',7.96),('10318','2013-06-27','13:50:00',8.92),('10318','2013-06-27','13:55:00',5.84),('10318','2013-06-27','14:00:00',4.19),('10318','2013-06-27','14:05:00',5.6),('10318','2013-06-27','14:10:00',8.73),('10318','2013-06-27','14:15:00',8.28),('10318','2013-06-27','14:20:00',7.59),('10318','2013-06-27','14:25:00',8.49),('10318','2013-06-27','14:30:00',9.35),('10318','2013-06-27','14:35:00',8.95),('10318','2013-06-27','14:40:00',8.85),('10318','2013-06-27','14:45:00',8.62),('10318','2013-06-27','14:50:00',8.59),('10318','2013-06-27','14:55:00',8.26),('10318','2013-06-27','15:00:00',8.06),('10318','2013-06-27','15:05:00',7.98),('10318','2013-06-27','15:10:00',7.87),('10318','2013-06-27','15:15:00',7.78),('10318','2013-06-27','15:20:00',7.71),('10318','2013-06-27','15:25:00',7.62),('10318','2013-06-27','15:30:00',7.51),('10318','2013-06-27','15:35:00',7.37),('10318','2013-06-27','15:40:00',7.23),('10318','2013-06-27','15:45:00',7.11),('10318','2013-06-27','15:50:00',7.02),('10318','2013-06-27','15:55:00',6.77),('10318','2013-06-27','16:00:00',6.59),('10318','2013-06-27','16:05:00',6.48),('10318','2013-06-27','16:10:00',6.41),('10318','2013-06-27','16:15:00',6.33),('10318','2013-06-27','16:20:00',6.17),('10318','2013-06-27','16:25:00',6.04),('10318','2013-06-27','16:30:00',5.84),('10318','2013-06-27','16:35:00',5.3),('10318','2013-06-27','16:40:00',5.5),('10318','2013-06-27','16:45:00',5.4),('10318','2013-06-27','16:50:00',5.17),('10318','2013-06-27','16:55:00',5.04),('10318','2013-06-27','17:00:00',4.89),('10318','2013-06-27','17:05:00',4.63),('10318','2013-06-27','17:10:00',4.37),('10318','2013-06-27','17:15:00',4.28),('10318','2013-06-27','17:20:00',4.28),('10318','2013-06-27','17:25:00',4.01),('10318','2013-06-27','17:30:00',3.96),('10318','2013-06-27','17:35:00',3.8),('10318','2013-06-27','17:40:00',3.65),('10318','2013-06-27','17:45:00',3.44),('10318','2013-06-27','17:50:00',3.27),('10318','2013-06-27','17:55:00',3.03),('10318','2013-06-27','18:00:00',2.83),('10318','2013-06-27','18:05:00',2.66),('10318','2013-06-27','18:10:00',2.53),('10318','2013-06-27','18:15:00',2.35),('10318','2013-06-27','18:20:00',2.21),('10318','2013-06-27','18:25:00',2.16),('10318','2013-06-27','18:30:00',1.96),('10318','2013-06-27','18:35:00',1.75),('10318','2013-06-27','18:40:00',1.55),('10318','2013-06-27','18:45:00',1.43),('10318','2013-06-27','18:50:00',1.35),('10318','2013-06-27','18:55:00',1.23),('10318','2013-06-27','19:00:00',1.12),('10318','2013-06-26','06:50:00',1.06),('10318','2013-06-26','06:55:00',1.33),('10318','2013-06-26','07:00:00',1.5),('10318','2013-06-26','07:05:00',1.76),('10318','2013-06-26','07:10:00',1.95),('10318','2013-06-26','07:15:00',2.13),('10318','2013-06-26','07:20:00',2.53),('10318','2013-06-26','07:25:00',2.74),('10318','2013-06-26','07:30:00',2.93),('10318','2013-06-26','07:35:00',3.13),('10318','2013-06-26','07:40:00',3.33),('10318','2013-06-26','07:45:00',3.56),('10318','2013-06-26','07:50:00',3.77),('10318','2013-06-26','07:55:00',3.92),('10318','2013-06-26','08:00:00',4.09),('10318','2013-06-26','08:05:00',4.3),('10318','2013-06-26','08:10:00',4.52),('10318','2013-06-26','08:15:00',4.66),('10318','2013-06-26','08:20:00',4.81),('10318','2013-06-26','08:25:00',4.98),('10318','2013-06-26','08:30:00',5.18),('10318','2013-06-26','08:35:00',5.32),('10318','2013-06-26','08:40:00',5.47),('10318','2013-06-26','08:45:00',5.66),('10318','2013-06-26','08:50:00',5.81),('10318','2013-06-26','08:55:00',5.97),('10318','2013-06-26','09:00:00',6.1),('10318','2013-06-26','09:05:00',6.25),('10318','2013-06-26','09:10:00',6.39),('10318','2013-06-26','09:15:00',6.49),('10318','2013-06-26','09:20:00',6.66),('10318','2013-06-26','09:25:00',6.82),('10318','2013-06-26','09:30:00',6.95),('10318','2013-06-26','09:35:00',7.06),('10318','2013-06-26','09:40:00',7.16),('10318','2013-06-26','09:45:00',7.15),('10318','2013-06-26','09:50:00',7.36),('10318','2013-06-26','09:55:00',7.53),('10318','2013-06-26','10:00:00',7.61),('10318','2013-06-26','10:05:00',7.68),('10318','2013-06-26','10:10:00',7.82),('10318','2013-06-26','10:15:00',7.99),('10318','2013-06-26','10:20:00',8.03),('10318','2013-06-26','10:25:00',8.09),('10318','2013-06-26','10:30:00',8.16),('10318','2013-06-26','10:35:00',8.32),('10318','2013-06-26','10:40:00',8.4),('10318','2013-06-26','10:45:00',8.45),('10318','2013-06-26','10:50:00',8.49),('10318','2013-06-26','10:55:00',8.53),('10318','2013-06-26','11:00:00',8.63),('10318','2013-06-26','11:05:00',8.7),('10318','2013-06-26','11:10:00',8.76),('10318','2013-06-26','11:15:00',8.87),('10318','2013-06-26','11:20:00',8.99),('10318','2013-06-26','11:25:00',8.93),('10318','2013-06-26','11:30:00',8.97),('10318','2013-06-26','11:35:00',8.93),('10318','2013-06-26','11:40:00',9.14),('10318','2013-06-26','11:45:00',9.17),('10318','2013-06-26','11:50:00',9.31),('10318','2013-06-26','11:55:00',9.28),('10318','2013-06-26','12:00:00',9.26),('10318','2013-06-26','12:05:00',9.27),('10318','2013-06-26','12:10:00',9.29),('10318','2013-06-26','12:15:00',9.32),('10318','2013-06-26','12:20:00',9.32),('10318','2013-06-26','12:25:00',9.47),('10318','2013-06-26','12:30:00',9.43),('10318','2013-06-26','12:35:00',9.54),('10318','2013-06-26','12:40:00',9.53),('10318','2013-06-26','12:45:00',9.63),('10318','2013-06-26','12:50:00',9.68),('10318','2013-06-26','12:55:00',6.26),('10318','2013-06-26','13:00:00',8.58),('10318','2013-06-26','13:05:00',9.76),('10318','2013-06-26','13:10:00',8.75),('10318','2013-06-26','13:15:00',4.9),('10318','2013-06-26','13:20:00',5.19),('10318','2013-06-26','13:25:00',7.3),('10318','2013-06-26','13:30:00',8.41),('10318','2013-06-26','13:35:00',10.1),('10318','2013-06-26','13:40:00',9.9),('10318','2013-06-26','13:45:00',10.03),('10318','2013-06-26','13:50:00',9.96),('10318','2013-06-26','13:55:00',9.82),('10318','2013-06-26','14:00:00',9.36),('10318','2013-06-26','14:05:00',9.21),('10318','2013-06-26','14:10:00',9.19),('10318','2013-06-26','14:15:00',8.91),('10318','2013-06-26','14:20:00',8.6),('10318','2013-06-26','14:25:00',8.23),('10318','2013-06-26','14:30:00',8.93),('10318','2013-06-26','14:35:00',8.8),('10318','2013-06-26','14:40:00',8.72),('10318','2013-06-26','14:45:00',8.69),('10318','2013-06-26','14:50:00',8.6),('10318','2013-06-26','14:55:00',8.41),('10318','2013-06-26','15:00:00',8.2),('10318','2013-06-26','15:05:00',7.96),('10318','2013-06-26','15:10:00',7.88),('10318','2013-06-26','15:15:00',7.8),('10318','2013-06-26','15:20:00',7.61),('10318','2013-06-26','15:25:00',7.56),('10318','2013-06-26','15:30:00',7.51),('10318','2013-06-26','15:35:00',7.4),('10318','2013-06-26','15:40:00',7.33),('10318','2013-06-26','15:45:00',7.07),('10318','2013-06-26','15:50:00',6.96),('10318','2013-06-26','15:55:00',6.82),('10318','2013-06-26','16:00:00',6.68),('10318','2013-06-26','16:05:00',6.52),('10318','2013-06-26','16:10:00',6.46),('10318','2013-06-26','16:15:00',6.33),('10318','2013-06-26','16:20:00',6.21),('10318','2013-06-26','16:25:00',6.07),('10318','2013-06-26','16:30:00',5.93),('10318','2013-06-26','16:35:00',5.75),('10318','2013-06-26','16:40:00',5.59),('10318','2013-06-26','16:45:00',5.43),('10318','2013-06-26','16:50:00',5.26),('10318','2013-06-26','16:55:00',5.1),('10318','2013-06-26','17:00:00',4.93),('10318','2013-06-26','17:05:00',4.73),('10318','2013-06-26','17:10:00',4.57),('10318','2013-06-26','17:15:00',4.42),('10318','2013-06-26','17:20:00',4.23),('10318','2013-06-26','17:25:00',4.03),('10318','2013-06-26','17:30:00',3.89),('10318','2013-06-26','17:35:00',3.73),('10318','2013-06-26','17:40:00',3.51),('10318','2013-06-26','17:45:00',3.34),('10318','2013-06-26','17:50:00',3.14),('10318','2013-06-26','17:55:00',2.96),('10318','2013-06-26','18:00:00',2.8),('10318','2013-06-26','18:05:00',2.65),('10318','2013-06-26','18:10:00',3.02),('10318','2013-06-26','18:15:00',3.21),('10318','2013-06-26','18:20:00',2.38),('10318','2013-06-26','18:25:00',1.79),('10318','2013-06-26','18:30:00',1.37),('10318','2013-06-26','18:55:00',1.04),('10318','2013-06-26','19:00:00',1.05),('10318','2013-06-26','19:05:00',1.19),('10318','2013-06-26','19:10:00',1.08),('10318','2013-06-26','19:15:00',1.15),('10318','2013-06-26','19:20:00',1.04),('10318','2013-06-25','06:50:00',1.08),('10318','2013-06-25','06:55:00',1.33),('10318','2013-06-25','07:00:00',1.51),('10318','2013-06-25','07:05:00',1.73),('10318','2013-06-25','07:10:00',1.94),('10318','2013-06-25','07:15:00',2.08),('10318','2013-06-25','07:20:00',1.66),('10318','2013-06-25','07:25:00',2.41),('10318','2013-06-25','07:30:00',2.19),('10318','2013-06-25','07:35:00',1.7),('10318','2013-06-25','07:40:00',2.62),('10318','2013-06-25','07:45:00',3.58),('10318','2013-06-25','07:50:00',2.33),('10318','2013-06-25','07:55:00',4.06),('10318','2013-06-25','08:00:00',3.97),('10318','2013-06-25','08:05:00',2.93),('10318','2013-06-25','08:10:00',1.08),('10318','2013-06-25','08:15:00',1.03),('10318','2013-06-25','08:20:00',1.55),('10318','2013-06-25','08:25:00',5.35),('10318','2013-06-25','08:30:00',5.41),('10318','2013-06-25','08:35:00',5.45),('10318','2013-06-25','08:40:00',5.63),('10318','2013-06-25','08:45:00',5.78),('10318','2013-06-25','08:50:00',5.76),('10318','2013-06-25','08:55:00',6.02),('10318','2013-06-25','09:00:00',6.26),('10318','2013-06-25','09:05:00',6.36),('10318','2013-06-25','09:10:00',6.53),('10318','2013-06-25','09:15:00',6.58),('10318','2013-06-25','09:20:00',6.87),('10318','2013-06-25','09:25:00',7.2),('10318','2013-06-25','09:30:00',7.19),('10318','2013-06-25','09:35:00',7.38),('10318','2013-06-25','09:40:00',4.27),('10318','2013-06-25','09:45:00',1.8),('10318','2013-06-25','09:50:00',5.71),('10318','2013-06-25','09:55:00',8.39),('10318','2013-06-25','10:00:00',7.07),('10318','2013-06-25','10:05:00',2.43),('10318','2013-06-25','10:10:00',7.26),('10318','2013-06-25','10:15:00',6.43),('10318','2013-06-25','10:20:00',2.35),('10318','2013-06-25','10:25:00',4.28),('10318','2013-06-25','10:30:00',9.79),('10318','2013-06-25','10:35:00',9.54),('10318','2013-06-25','10:40:00',9.26),('10318','2013-06-25','10:45:00',9.26),('10318','2013-06-25','10:50:00',9.31),('10318','2013-06-25','10:55:00',9.31),('10318','2013-06-25','11:00:00',9.39),('10318','2013-06-25','11:05:00',9.79),('10318','2013-06-25','11:10:00',9.65),('10318','2013-06-25','11:15:00',9.62),('10318','2013-06-25','11:20:00',9.32),('10318','2013-06-25','11:25:00',6.5),('10318','2013-06-25','11:30:00',3.07),('10318','2013-06-25','11:35:00',4.34),('10318','2013-06-25','11:40:00',3.47),('10318','2013-06-25','11:45:00',8.9),('10318','2013-06-25','11:50:00',6.04),('10318','2013-06-25','11:55:00',4.75),('10318','2013-06-25','12:00:00',2.74),('10318','2013-06-25','12:05:00',6.53),('10318','2013-06-25','12:10:00',2.62),('10318','2013-06-25','12:15:00',2.64),('10318','2013-06-25','12:20:00',7.6),('10318','2013-06-25','12:25:00',8.96),('10318','2013-06-25','12:30:00',9.25),('10318','2013-06-25','12:35:00',9.39),('10318','2013-06-25','12:40:00',4.92),('10318','2013-06-25','12:45:00',4.17),('10318','2013-06-25','12:50:00',3.8),('10318','2013-06-25','12:55:00',8.89),('10318','2013-06-25','13:00:00',9.98),('10318','2013-06-25','13:05:00',9.94),('10318','2013-06-25','13:10:00',10.13),('10318','2013-06-25','13:15:00',10.03),('10318','2013-06-25','13:20:00',9.81),('10318','2013-06-25','13:25:00',9.69),('10318','2013-06-25','13:30:00',7.8),('10318','2013-06-25','13:35:00',9.17),('10318','2013-06-25','13:40:00',9.56),('10318','2013-06-25','13:45:00',9.37),('10318','2013-06-25','13:50:00',9.12),('10318','2013-06-25','13:55:00',9.19),('10318','2013-06-25','14:00:00',9.15),('10318','2013-06-25','14:05:00',9.14),('10318','2013-06-25','14:10:00',9.01),('10318','2013-06-25','14:15:00',9.01),('10318','2013-06-25','14:20:00',8.88),('10318','2013-06-25','14:25:00',8.83),('10318','2013-06-25','14:30:00',8.77),('10318','2013-06-25','14:35:00',8.65),('10318','2013-06-25','14:40:00',8.56),('10318','2013-06-25','14:45:00',8.51),('10318','2013-06-25','14:50:00',8.43),('10318','2013-06-25','14:55:00',8.3),('10318','2013-06-25','15:00:00',8.17),('10318','2013-06-25','15:05:00',7.96),('10318','2013-06-25','15:10:00',7.96),('10318','2013-06-25','15:15:00',7.89),('10318','2013-06-25','15:20:00',7.75),('10318','2013-06-25','15:25:00',7.61),('10318','2013-06-25','15:30:00',7.5),('10318','2013-06-25','15:35:00',7.38),('10318','2013-06-25','15:40:00',7.28),('10318','2013-06-25','15:45:00',7.12),('10318','2013-06-25','15:50:00',7),('10318','2013-06-25','15:55:00',6.86),('10318','2013-06-25','16:00:00',6.75),('10318','2013-06-25','16:05:00',6.58),('10318','2013-06-25','16:10:00',6.43),('10318','2013-06-25','16:15:00',6.26),('10318','2013-06-25','16:20:00',6.13),('10318','2013-06-25','16:25:00',5.96),('10318','2013-06-25','16:30:00',5.76),('10318','2013-06-25','16:35:00',5.62),('10318','2013-06-25','16:40:00',5.48),('10318','2013-06-25','16:45:00',5.31),('10318','2013-06-25','16:50:00',5.03),('10318','2013-06-25','16:55:00',5.03),('10318','2013-06-25','17:00:00',4.85),('10318','2013-06-25','17:05:00',4.69),('10318','2013-06-25','17:10:00',4.53),('10318','2013-06-25','17:15:00',4.35),('10318','2013-06-25','17:20:00',4.16),('10318','2013-06-25','17:25:00',3.98),('10318','2013-06-25','17:30:00',3.8),('10318','2013-06-25','17:35:00',3.62),('10318','2013-06-25','17:40:00',3.45),('10318','2013-06-25','17:45:00',3.28),('10318','2013-06-25','17:50:00',3.08),('10318','2013-06-25','17:55:00',2.92),('10318','2013-06-25','18:00:00',2.73),('10318','2013-06-25','18:05:00',2.55),('10318','2013-06-25','18:10:00',2.37),('10318','2013-06-25','18:15:00',2.21),('10318','2013-06-25','18:20:00',2.05),('10318','2013-06-25','18:25:00',1.9),('10318','2013-06-25','18:30:00',1.77),('10318','2013-06-25','18:35:00',1.59),('10318','2013-06-25','18:40:00',1.47),('10318','2013-06-25','18:45:00',1.34),('10318','2013-06-25','18:50:00',1.21),('10318','2013-06-25','18:55:00',1.1),('10318','2013-06-24','07:05:00',1.46),('10318','2013-06-24','07:10:00',2.3),('10318','2013-06-24','07:15:00',1.35),('10318','2013-06-24','07:20:00',1.47),('10318','2013-06-24','07:25:00',1.11),('10318','2013-06-24','07:30:00',1.2),('10318','2013-06-24','07:35:00',1.17),('10318','2013-06-24','07:45:00',1.21),('10318','2013-06-24','08:20:00',1.61),('10318','2013-06-24','08:25:00',5.42),('10318','2013-06-24','08:30:00',5.48),('10318','2013-06-24','08:35:00',5.05),('10318','2013-06-24','08:40:00',3.63),('10318','2013-06-24','08:45:00',5.97),('10318','2013-06-24','08:50:00',6.17),('10318','2013-06-24','08:55:00',6.67),('10318','2013-06-24','09:00:00',6.98),('10318','2013-06-24','09:05:00',6.06),('10318','2013-06-24','09:10:00',5.04),('10318','2013-06-24','09:15:00',7.65),('10318','2013-06-24','09:20:00',8.14),('10318','2013-06-24','09:25:00',2.92),('10318','2013-06-24','09:30:00',2.25),('10318','2013-06-24','09:35:00',7.21),('10318','2013-06-24','09:40:00',8.37),('10318','2013-06-24','09:45:00',3.91),('10318','2013-06-24','09:50:00',8.37),('10318','2013-06-24','09:55:00',7.62),('10318','2013-06-24','10:00:00',8.12),('10318','2013-06-24','10:05:00',6.5),('10318','2013-06-24','10:10:00',5.16),('10318','2013-06-24','10:15:00',9.13),('10318','2013-06-24','10:20:00',9.67),('10318','2013-06-24','10:25:00',4.75),('10318','2013-06-24','10:30:00',5.1),('10318','2013-06-24','10:35:00',9.04),('10318','2013-06-24','10:40:00',8.53),('10318','2013-06-24','10:45:00',6.74),('10318','2013-06-24','10:50:00',4.8),('10318','2013-06-24','10:55:00',7.72),('10318','2013-06-24','11:00:00',8.04),('10318','2013-06-24','11:05:00',4.86),('10318','2013-06-24','11:10:00',7.07),('10318','2013-06-24','11:15:00',5.23),('10318','2013-06-24','11:20:00',3.27),('10318','2013-06-24','11:25:00',2.92),('10318','2013-06-24','11:30:00',2.65),('10318','2013-06-24','11:35:00',3.18),('10318','2013-06-24','11:40:00',3.99),('10318','2013-06-24','11:45:00',4.61),('10318','2013-06-24','11:50:00',4.06),('10318','2013-06-24','11:55:00',3.56),('10318','2013-06-24','12:00:00',4.37),('10318','2013-06-24','12:05:00',9.26),('10318','2013-06-24','12:10:00',8.26),('10318','2013-06-24','12:15:00',5.9),('10318','2013-06-24','12:20:00',6.02),('10318','2013-06-24','12:25:00',4.94),('10318','2013-06-24','12:30:00',8.38),('10318','2013-06-24','12:35:00',9.55),('10318','2013-06-24','12:40:00',7.44),('10318','2013-06-24','12:45:00',10.92),('10318','2013-06-24','12:50:00',6.26),('10318','2013-06-24','12:55:00',9.85),('10318','2013-06-24','13:00:00',7.57),('10318','2013-06-24','13:05:00',6.29),('10318','2013-06-24','13:10:00',6.73),('10318','2013-06-24','13:15:00',9.72),('10318','2013-06-24','13:20:00',6.76),('10318','2013-06-24','13:25:00',10.33),('10318','2013-06-24','13:30:00',10.12),('10318','2013-06-24','13:35:00',10.35),('10318','2013-06-24','13:40:00',9.73),('10318','2013-06-24','13:45:00',5.99),('10318','2013-06-24','13:50:00',9),('10318','2013-06-24','13:55:00',9.74),('10318','2013-06-24','14:00:00',9.55),('10318','2013-06-24','14:05:00',9.46),('10318','2013-06-24','14:10:00',9.38),('10318','2013-06-24','14:15:00',9.41),('10318','2013-06-24','14:20:00',9.28),('10318','2013-06-24','14:25:00',9.24),('10318','2013-06-24','14:30:00',8.9),('10318','2013-06-24','14:35:00',8.29),('10318','2013-06-24','14:40:00',7.91),('10318','2013-06-24','14:45:00',9),('10318','2013-06-24','14:50:00',9.29),('10318','2013-06-24','14:55:00',9.35),('10318','2013-06-24','15:00:00',4.85),('10318','2013-06-24','15:05:00',5.38),('10318','2013-06-24','15:10:00',7.2),('10318','2013-06-24','15:15:00',5.79),('10318','2013-06-24','15:20:00',4.5),('10318','2013-06-24','15:25:00',7.62),('10318','2013-06-24','15:30:00',8.55),('10318','2013-06-24','15:35:00',3.98),('10318','2013-06-24','15:40:00',4.61),('10318','2013-06-24','15:45:00',8.92),('10318','2013-06-24','15:50:00',3.15),('10318','2013-06-24','15:55:00',2.6),('10318','2013-06-24','16:00:00',3.51),('10318','2013-06-24','16:05:00',6.9),('10318','2013-06-24','16:10:00',3.75),('10318','2013-06-24','16:15:00',5.15),('10318','2013-06-24','16:20:00',6.27),('10318','2013-06-24','16:25:00',7.71),('10318','2013-06-24','16:30:00',6.07),('10318','2013-06-24','16:35:00',6.39),('10318','2013-06-24','16:40:00',5.59),('10318','2013-06-24','16:45:00',2.64),('10318','2013-06-24','16:50:00',3.4),('10318','2013-06-24','16:55:00',3.53),('10318','2013-06-24','17:00:00',4.18),('10318','2013-06-24','17:05:00',2.32),('10318','2013-06-24','17:10:00',3.65),('10318','2013-06-24','17:15:00',1.93),('10318','2013-06-24','17:20:00',2.15),('10318','2013-06-24','17:25:00',2.17),('10318','2013-06-24','17:30:00',1.88),('10318','2013-06-24','17:35:00',2.05),('10318','2013-06-24','17:40:00',3.55),('10318','2013-06-24','17:45:00',3.12),('10318','2013-06-24','17:50:00',3.08),('10318','2013-06-24','17:55:00',2.13),('10318','2013-06-24','18:00:00',2.56),('10318','2013-06-24','18:05:00',2.66),('10318','2013-06-24','18:10:00',2.8),('10318','2013-06-24','18:15:00',2.51),('10318','2013-06-24','18:20:00',2.35),('10318','2013-06-24','18:25:00',2.08),('10318','2013-06-24','18:30:00',2.2),('10318','2013-06-24','18:35:00',1.89),('10318','2013-06-24','18:40:00',1.89),('10318','2013-06-24','18:45:00',1.56),('10318','2013-06-24','19:00:00',1.1),('10318','2013-06-24','19:05:00',1.02),('10318','2014-04-04','08:35:00',1.17),('10318','2014-04-04','08:40:00',1.64),('10318','2014-04-04','08:45:00',2),('10318','2014-04-04','08:50:00',2.37),('10318','2014-04-04','08:55:00',2.56),('10318','2014-04-04','09:00:00',3.21),('10318','2014-04-04','09:05:00',4.39),('10318','2014-04-04','09:10:00',4.92),('10318','2014-04-04','09:15:00',4.01),('10318','2014-04-04','09:20:00',2.23),('10318','2014-04-04','09:25:00',1.65),('10318','2014-04-04','09:30:00',1.71),('10318','2014-04-04','09:35:00',1.8),('10318','2014-04-04','09:40:00',1.7),('10318','2014-04-04','09:45:00',1.3),('10318','2014-04-04','09:50:00',1.06),('10318','2014-04-04','10:15:00',1.01),('10318','2014-04-04','10:40:00',1.08),('10318','2014-04-04','10:50:00',1.08),('10318','2014-04-04','10:55:00',1.23),('10318','2014-04-04','11:00:00',1.85),('10318','2014-04-04','11:05:00',1.96),('10318','2014-04-04','11:10:00',1.44),('10318','2014-04-04','11:15:00',1.73),('10318','2014-04-04','11:20:00',1.23),('10318','2014-04-04','12:15:00',1.03),('10318','2014-04-04','12:40:00',1.08),('10318','2014-04-04','12:45:00',1.35),('10318','2014-04-04','12:50:00',1.36),('10318','2014-04-04','12:55:00',1.29),('10318','2014-04-04','13:00:00',1.22),('10318','2014-04-04','13:05:00',2.32),('10318','2014-04-04','13:10:00',2.38),('10318','2014-04-04','13:15:00',2.97),('10318','2014-04-04','13:20:00',4.72),('10318','2014-04-04','13:25:00',4.41),('10318','2014-04-04','13:30:00',4.23),('10318','2014-04-04','13:35:00',7.65),('10318','2014-04-04','13:40:00',8.87),('10318','2014-04-04','13:45:00',8.75),('10318','2014-04-04','13:50:00',9.05),('10318','2014-04-04','13:55:00',8.3),('10318','2014-04-04','14:00:00',9.92),('10318','2014-04-04','14:05:00',9.9),('10318','2014-04-04','14:10:00',8.88),('10318','2014-04-04','14:15:00',9.08),('10318','2014-04-04','14:20:00',4.84),('10318','2014-04-04','14:25:00',6.89),('10318','2014-04-04','14:30:00',3.58),('10318','2014-04-04','14:35:00',7.88),('10318','2014-04-04','14:40:00',3.22),('10318','2014-04-04','14:45:00',6.6),('10318','2014-04-04','14:50:00',7.52),('10318','2014-04-04','14:55:00',6.1),('10318','2014-04-04','15:00:00',8.02),('10318','2014-04-04','15:05:00',4.94),('10318','2014-04-04','15:10:00',6.64),('10318','2014-04-04','15:15:00',6.49),('10318','2014-04-04','15:20:00',7.94),('10318','2014-04-04','15:25:00',3.59),('10318','2014-04-04','15:30:00',2.82),('10318','2014-04-04','15:35:00',3.01),('10318','2014-04-04','15:40:00',3.22),('10318','2014-04-04','15:45:00',3.97),('10318','2014-04-04','15:50:00',4.16),('10318','2014-04-04','15:55:00',6.52),('10318','2014-04-04','16:00:00',8.21),('10318','2014-04-04','16:05:00',5.1),('10318','2014-04-04','16:10:00',4.68),('10318','2014-04-04','16:15:00',3.69),('10318','2014-04-04','16:20:00',3.69),('10318','2014-04-04','16:25:00',3.22),('10318','2014-04-04','16:30:00',3.71),('10318','2014-04-04','16:35:00',5),('10318','2014-04-04','16:40:00',4.01),('10318','2014-04-04','16:45:00',5.2),('10318','2014-04-04','16:50:00',6.45),('10318','2014-04-04','16:55:00',5.64),('10318','2014-04-04','17:00:00',5.29),('10318','2014-04-04','17:05:00',3.35),('10318','2014-04-04','17:10:00',3.25),('10318','2014-04-04','17:15:00',2.38),('10318','2014-04-04','17:20:00',2.75),('10318','2014-04-04','17:25:00',4.16),('10318','2014-04-04','17:30:00',3.72),('10318','2014-04-04','17:35:00',2.46),('10318','2014-04-04','17:40:00',2.98),('10318','2014-04-04','17:45:00',1.6),('10318','2014-04-04','17:50:00',2.68),('10318','2014-04-04','17:55:00',2.37),('10318','2014-04-04','18:00:00',2),('10318','2014-04-04','18:05:00',1.21),('10318','2014-04-04','18:10:00',1.29),('10318','2014-04-04','18:15:00',1.41),('10318','2014-04-04','18:20:00',1.25),('10318','2014-04-04','18:25:00',1.18),('10318','2014-04-04','18:30:00',1.11),('10318','2013-06-20','06:50:00',1.03),('10318','2013-06-20','06:55:00',1.24),('10318','2013-06-20','07:00:00',1.42),('10318','2013-06-20','07:05:00',1.6),('10318','2013-06-20','07:10:00',1.8),('10318','2013-06-20','07:15:00',2),('10318','2013-06-20','07:20:00',2.28),('10318','2013-06-20','07:25:00',2.48),('10318','2013-06-20','07:30:00',2.67),('10318','2013-06-20','07:35:00',2.86),('10318','2013-06-20','07:40:00',3.04),('10318','2013-06-20','07:45:00',3.19),('10318','2013-06-20','07:50:00',3.38),('10318','2013-06-20','07:55:00',3.57),('10318','2013-06-20','08:00:00',3.72),('10318','2013-06-20','08:05:00',3.9),('10318','2013-06-20','08:10:00',4.11),('10318','2013-06-20','08:15:00',4.31),('10318','2013-06-20','08:20:00',4.48),('10318','2013-06-20','08:25:00',4.64),('10318','2013-06-20','08:30:00',4.76),('10318','2013-06-20','08:35:00',5.01),('10318','2013-06-20','08:40:00',5.2),('10318','2013-06-20','08:45:00',5.36),('10318','2013-06-20','08:50:00',5.48),('10318','2013-06-20','08:55:00',5.66),('10318','2013-06-20','09:00:00',5.8),('10318','2013-06-20','09:05:00',5.95),('10318','2013-06-20','09:10:00',6.09),('10318','2013-06-20','09:15:00',6.2),('10318','2013-06-20','09:20:00',6.32),('10318','2013-06-20','09:25:00',6.47),('10318','2013-06-20','09:30:00',6.56),('10318','2013-06-20','09:35:00',6.69),('10318','2013-06-20','09:40:00',6.87),('10318','2013-06-20','09:45:00',6.97),('10318','2013-06-20','09:50:00',7.08),('10318','2013-06-20','09:55:00',7.19),('10318','2013-06-20','10:00:00',7.27),('10318','2013-06-20','10:05:00',7.39),('10318','2013-06-20','10:10:00',7.47),('10318','2013-06-20','10:15:00',7.41),('10318','2013-06-20','10:20:00',7.63),('10318','2013-06-20','10:25:00',7.78),('10318','2013-06-20','10:30:00',7.82),('10318','2013-06-20','10:35:00',7.84),('10318','2013-06-20','10:40:00',7.99),('10318','2013-06-20','10:45:00',8.02),('10318','2013-06-20','10:50:00',8.08),('10318','2013-06-20','10:55:00',8.08),('10318','2013-06-20','11:00:00',8.16),('10318','2013-06-20','11:05:00',8.32),('10318','2013-06-20','11:10:00',8.33),('10318','2013-06-20','11:15:00',8.27),('10318','2013-06-20','11:20:00',8.3),('10318','2013-06-20','11:25:00',8.36),('10318','2013-06-20','11:30:00',8.31),('10318','2013-06-20','11:35:00',8.38),('10318','2013-06-20','11:40:00',8.38),('10318','2013-06-20','11:45:00',8.33),('10318','2013-06-20','11:50:00',8.28),('10318','2013-06-20','11:55:00',8.26),('10318','2013-06-20','12:00:00',8.32),('10318','2013-06-20','12:05:00',8.25),('10318','2013-06-20','12:10:00',8.33),('10318','2013-06-20','12:15:00',8.46),('10318','2013-06-20','12:20:00',8.4),('10318','2013-06-20','12:25:00',8.35),('10318','2013-06-20','12:30:00',8.36),('10318','2013-06-20','12:35:00',8.22),('10318','2013-06-20','12:40:00',8.47),('10318','2013-06-20','12:45:00',8.46),('10318','2013-06-20','12:50:00',8.5),('10318','2013-06-20','12:55:00',8.46),('10318','2013-06-20','13:00:00',8.49),('10318','2013-06-20','13:05:00',8.81),('10318','2013-06-20','13:10:00',8.62),('10318','2013-06-20','13:15:00',8.46),('10318','2013-06-20','13:20:00',8.75),('10318','2013-06-20','13:25:00',8.73),('10318','2013-06-20','13:30:00',8.67),('10318','2013-06-20','13:35:00',8.69),('10318','2013-06-20','13:40:00',8.75),('10318','2013-06-20','13:45:00',8.7),('10318','2013-06-20','13:50:00',8.74),('10318','2013-06-20','13:55:00',8.75),('10318','2013-06-20','14:00:00',8.76),('10318','2013-06-20','14:05:00',8.73),('10318','2013-06-20','14:10:00',8.69),('10318','2013-06-20','14:15:00',8.66),('10318','2013-06-19','06:50:00',1.02),('10318','2013-06-19','06:55:00',1.23),('10318','2013-06-19','07:00:00',1.4),('10318','2013-06-19','07:05:00',1.59),('10318','2013-06-19','07:10:00',1.81),('10318','2013-06-19','07:15:00',1.99),('10318','2013-06-19','07:20:00',2.29),('10318','2013-06-19','07:25:00',2.48),('10318','2013-06-19','07:30:00',2.63),('10318','2013-06-19','07:35:00',2.81),('10318','2013-06-19','07:40:00',2.99),('10318','2013-06-19','07:45:00',3.17),('10318','2013-06-19','07:50:00',3.34),('10318','2013-06-19','07:55:00',3.53),('10318','2013-06-19','08:00:00',3.71),('10318','2013-06-19','08:05:00',3.88),('10318','2013-06-19','08:10:00',4.02),('10318','2013-06-19','08:15:00',4.1),('10318','2013-06-19','08:20:00',4.31),('10318','2013-06-19','08:25:00',4.5),('10318','2013-06-19','08:30:00',4.68),('10318','2013-06-19','08:35:00',4.85),('10318','2013-06-19','08:40:00',5.01),('10318','2013-06-19','08:45:00',5.15),('10318','2013-06-19','08:50:00',5.33),('10318','2013-06-19','08:55:00',5.48),('10318','2013-06-19','09:00:00',5.65),('10318','2013-06-19','09:05:00',5.8),('10318','2013-06-19','09:10:00',5.94),('10318','2013-06-19','09:15:00',6.06),('10318','2013-06-19','09:20:00',6.21),('10318','2013-06-19','09:25:00',6.35),('10318','2013-06-19','09:30:00',6.46),('10318','2013-06-19','09:35:00',6.57),('10318','2013-06-19','09:40:00',6.68),('10318','2013-06-19','09:45:00',6.78),('10318','2013-06-19','09:50:00',6.88),('10318','2013-06-19','09:55:00',7),('10318','2013-06-19','10:00:00',7),('10318','2013-06-19','10:05:00',7.18),('10318','2013-06-19','10:10:00',7.28),('10318','2013-06-19','10:15:00',7.37),('10318','2013-06-19','10:20:00',7.45),('10318','2013-06-19','10:25:00',7.54),('10318','2013-06-19','10:30:00',7.59),('10318','2013-06-19','10:35:00',7.65),('10318','2013-06-19','10:40:00',7.68),('10318','2013-06-19','10:45:00',7.76),('10318','2013-06-19','10:50:00',7.83),('10318','2013-06-19','10:55:00',7.83),('10318','2013-06-19','11:00:00',7.89),('10318','2013-06-19','11:05:00',7.92),('10318','2013-06-19','11:10:00',7.97),('10318','2013-06-19','11:15:00',8.01),('10318','2013-06-19','11:20:00',8.09),('10318','2013-06-19','11:25:00',8.13),('10318','2013-06-19','11:30:00',8.22),('10318','2013-06-19','11:35:00',8.26),('10318','2013-06-19','11:40:00',8.26),('10318','2013-06-19','11:45:00',8.15),('10318','2013-06-19','11:50:00',8.39),('10318','2013-06-19','11:55:00',8.36),('10318','2013-06-19','12:00:00',8.41),('10318','2013-06-19','12:05:00',8.44),('10318','2013-06-19','12:10:00',8.51),('10318','2013-06-19','12:15:00',8.59),('10318','2013-06-19','12:20:00',8.6),('10318','2013-06-19','12:25:00',8.55),('10318','2013-06-19','12:30:00',8.55),('10318','2013-06-19','12:35:00',8.72),('10318','2013-06-19','12:40:00',8.71),('10318','2013-06-19','12:45:00',8.63),('10318','2013-06-19','12:50:00',8.7),('10318','2013-06-19','12:55:00',8.65),('10318','2013-06-19','13:00:00',8.61),('10318','2013-06-19','13:05:00',8.54),('10318','2013-06-19','13:10:00',8.59),('10318','2013-06-19','13:15:00',8.65),('10318','2013-06-19','13:20:00',8.6),('10318','2013-06-19','13:25:00',8.6),('10318','2013-06-19','13:30:00',8.57),('10318','2013-06-19','13:35:00',8.54),('10318','2013-06-19','13:40:00',8.5),('10318','2013-06-19','13:45:00',8.44),('10318','2013-06-19','13:50:00',8.47),('10318','2013-06-19','13:55:00',8.41),('10318','2013-06-19','14:00:00',8.35),('10318','2013-06-19','14:05:00',8.31),('10318','2013-06-19','14:10:00',8.28),('10318','2013-06-19','14:15:00',8.25),('10318','2013-06-19','14:20:00',8.19),('10318','2013-06-19','14:25:00',8.14),('10318','2013-06-19','14:30:00',8.06),('10318','2013-06-19','14:35:00',8),('10318','2013-06-19','14:40:00',7.98),('10318','2013-06-19','14:45:00',7.91),('10318','2013-06-19','14:50:00',7.8),('10318','2013-06-19','14:55:00',7.74),('10318','2013-06-19','15:00:00',7.63),('10318','2013-06-19','15:05:00',7.56),('10318','2013-06-19','15:10:00',7.46),('10318','2013-06-19','15:15:00',7.39),('10318','2013-06-19','15:20:00',7.27),('10318','2013-06-19','15:25:00',7.17),('10318','2013-06-19','15:30:00',7.04),('10318','2013-06-19','15:35:00',6.92),('10318','2013-06-19','15:40:00',6.78),('10318','2013-06-19','15:45:00',6.64),('10318','2013-06-19','15:50:00',6.49),('10318','2013-06-19','15:55:00',6.38),('10318','2013-06-19','16:00:00',6.26),('10318','2013-06-19','16:05:00',6.15),('10318','2013-06-19','16:10:00',6.01),('10318','2013-06-19','16:15:00',5.86),('10318','2013-06-19','16:20:00',5.69),('10318','2013-06-19','16:25:00',5.56),('10318','2013-06-19','16:30:00',5.42),('10318','2013-06-19','16:35:00',5.22),('10318','2013-06-19','16:40:00',5.15),('10318','2013-06-19','16:45:00',5.01),('10318','2013-06-19','16:50:00',4.83),('10318','2013-06-19','16:55:00',4.7),('10318','2013-06-19','17:00:00',4.56),('10318','2013-06-19','17:05:00',4.39),('10318','2013-06-19','17:10:00',4.24),('10318','2013-06-19','17:15:00',4.11),('10318','2013-06-19','17:20:00',3.93),('10318','2013-06-19','17:25:00',3.76),('10318','2013-06-19','17:30:00',3.6),('10318','2013-06-19','17:35:00',3.43),('10318','2013-06-19','17:40:00',3.27),('10318','2013-06-19','17:45:00',3.09),('10318','2013-06-19','17:50:00',2.91),('10318','2013-06-19','17:55:00',2.74),('10318','2013-06-19','18:00:00',2.57),('10318','2013-06-19','18:05:00',2.41),('10318','2013-06-19','18:10:00',2.26),('10318','2013-06-19','18:15:00',2.1),('10318','2013-06-19','18:20:00',1.9),('10318','2013-06-19','18:25:00',1.78),('10318','2013-06-19','18:30:00',1.6),('10318','2013-06-19','18:35:00',1.49),('10318','2013-06-19','18:40:00',1.36),('10318','2013-06-19','18:45:00',1.23),('10318','2013-06-19','18:50:00',1.08),('10318','2013-06-18','06:55:00',1.17),('10318','2013-06-18','07:00:00',1.34),('10318','2013-06-18','07:05:00',1.52),('10318','2013-06-18','07:10:00',1.76),('10318','2013-06-18','07:15:00',1.91),('10318','2013-06-18','07:20:00',2.22),('10318','2013-06-18','07:25:00',2.39),('10318','2013-06-18','07:30:00',2.5),('10318','2013-06-18','07:35:00',2.74),('10318','2013-06-18','07:40:00',2.92),('10318','2013-06-18','07:45:00',3.1),('10318','2013-06-18','07:50:00',3.28),('10318','2013-06-18','07:55:00',3.45),('10318','2013-06-18','08:00:00',3.6),('10318','2013-06-18','08:05:00',3.8),('10318','2013-06-18','08:10:00',3.97),('10318','2013-06-18','08:15:00',4.17),('10318','2013-06-18','08:20:00',4.34),('10318','2013-06-18','08:25:00',4.49),('10318','2013-06-18','08:30:00',4.66),('10318','2013-06-18','08:35:00',4.83),('10318','2013-06-18','08:40:00',5),('10318','2013-06-18','08:45:00',5.16),('10318','2013-06-18','08:50:00',5.32),('10318','2013-06-18','08:55:00',5.47),('10318','2013-06-18','09:00:00',5.6),('10318','2013-06-18','09:05:00',5.76),('10318','2013-06-18','09:10:00',5.91),('10318','2013-06-18','09:15:00',5.98),('10318','2013-06-18','09:20:00',6.17),('10318','2013-06-18','09:25:00',6.34),('10318','2013-06-18','09:30:00',6.45),('10318','2013-06-18','09:35:00',6.55),('10318','2013-06-18','09:40:00',6.66),('10318','2013-06-18','09:45:00',6.75),('10318','2013-06-18','09:50:00',6.87),('10318','2013-06-18','09:55:00',6.97),('10318','2013-06-18','10:00:00',7.07),('10318','2013-06-18','10:05:00',7.17),('10318','2013-06-18','10:10:00',7.25),('10318','2013-06-18','10:15:00',7.31),('10318','2013-06-18','10:20:00',7.42),('10318','2013-06-18','10:25:00',7.48),('10318','2013-06-18','10:30:00',7.55),('10318','2013-06-18','10:35:00',7.65),('10318','2013-06-18','10:40:00',7.74),('10318','2013-06-18','10:45:00',7.82),('10318','2013-06-18','10:50:00',7.87),('10318','2013-06-18','10:55:00',7.85),('10318','2013-06-18','11:00:00',7.82),('10318','2013-06-18','11:05:00',8.02),('10318','2013-06-18','11:10:00',8.08),('10318','2013-06-18','11:15:00',8.18),('10318','2013-06-18','11:20:00',8.22),('10318','2013-06-18','11:25:00',8.26),('10318','2013-06-18','11:30:00',8.31),('10318','2013-06-18','11:35:00',8.26),('10318','2013-06-18','11:40:00',8.3),('10318','2013-06-18','11:45:00',8.37),('10318','2013-06-18','11:50:00',8.36),('10318','2013-06-18','11:55:00',8.45),('10318','2013-06-18','12:00:00',8.46),('10318','2013-06-18','12:05:00',8.56),('10318','2013-06-18','12:10:00',8.48),('10318','2013-06-18','12:15:00',8.39),('10318','2013-06-18','12:20:00',8.36),('10318','2013-06-18','12:25:00',8.37),('10318','2013-06-18','12:30:00',8.35),('10318','2013-06-18','12:35:00',8.36),('10318','2013-06-18','12:40:00',8.33),('10318','2013-06-18','12:45:00',7.96),('10318','2013-06-18','12:50:00',8.19),('10318','2013-06-18','12:55:00',8.38),('10318','2013-06-18','13:00:00',8.61),('10318','2013-06-18','13:05:00',8.47),('10318','2013-06-18','13:10:00',3.65),('10318','2013-06-18','13:15:00',7.91),('10318','2013-06-18','13:20:00',8.84),('10318','2013-06-18','13:25:00',8.75),('10318','2013-06-18','13:30:00',8.64),('10318','2013-06-18','13:35:00',8.54),('10318','2013-06-18','13:40:00',8.36),('10318','2013-06-18','13:45:00',8.56),('10318','2013-06-18','13:50:00',8.52),('10318','2013-06-18','13:55:00',8.51),('10318','2013-06-18','14:00:00',8.79),('10318','2013-06-18','14:05:00',8.7),('10318','2013-06-18','14:10:00',8.56),('10318','2013-06-18','14:15:00',8.56),('10318','2013-06-18','14:20:00',8.49),('10318','2013-06-18','14:25:00',8.4),('10318','2013-06-18','14:30:00',8.47),('10318','2013-06-18','14:35:00',8.31),('10318','2013-06-18','14:40:00',8.44),('10318','2013-06-18','14:45:00',8.31),('10318','2013-06-18','14:50:00',8.04),('10318','2013-06-18','14:55:00',7.87),('10318','2013-06-18','15:00:00',7.73),('10318','2013-06-18','15:05:00',7.67),('10318','2013-06-18','15:10:00',7.57),('10318','2013-06-18','15:15:00',7.42),('10318','2013-06-18','15:20:00',7.36),('10318','2013-06-18','15:25:00',7.18),('10318','2013-06-18','15:30:00',7.07),('10318','2013-06-18','15:35:00',6.96),('10318','2013-06-18','15:40:00',6.89),('10318','2013-06-18','15:45:00',6.82),('10318','2013-06-18','15:50:00',6.73),('10318','2013-06-18','15:55:00',6.63),('10318','2013-06-18','16:00:00',6.49),('10318','2013-06-18','16:05:00',6.43),('10318','2013-06-18','16:10:00',6.35),('10318','2013-06-18','16:15:00',6.26),('10318','2013-06-18','16:20:00',6.04),('10318','2013-06-18','16:25:00',5.94),('10318','2013-06-18','16:30:00',5.61),('10318','2013-06-18','16:35:00',5.26),('10318','2013-06-18','16:40:00',5.29),('10318','2013-06-18','16:45:00',5.18),('10318','2013-06-18','16:50:00',4.96),('10318','2013-06-18','16:55:00',4.85),('10318','2013-06-18','17:00:00',4.69),('10318','2013-06-18','17:05:00',4.49),('10318','2013-06-18','17:10:00',4.32),('10318','2013-06-18','17:15:00',4.15),('10318','2013-06-18','17:20:00',3.99),('10318','2013-06-18','17:25:00',3.82),('10318','2013-06-18','17:30:00',3.61),('10318','2013-06-18','17:35:00',3.38),('10318','2013-06-18','17:40:00',3.28),('10318','2013-06-18','17:45:00',3.11),('10318','2013-06-18','17:50:00',2.94),('10318','2013-06-18','17:55:00',2.77),('10318','2013-06-18','18:00:00',2.63),('10318','2013-06-18','18:05:00',2.46),('10318','2013-06-18','18:10:00',2.32),('10318','2013-06-18','18:15:00',2.17),('10318','2013-06-18','18:20:00',2.03),('10318','2013-06-18','18:25:00',1.88),('10318','2013-06-18','18:30:00',1.73),('10318','2013-06-18','18:35:00',1.59),('10318','2013-06-18','18:40:00',1.46),('10318','2013-06-18','18:45:00',1.33),('10318','2013-06-18','18:50:00',1.21),('10318','2013-06-18','18:55:00',1.1),('10318','2013-06-17','06:50:00',1.08),('10318','2013-06-17','06:55:00',1.29),('10318','2013-06-17','07:00:00',1.49),('10318','2013-06-17','07:05:00',1.67),('10318','2013-06-17','07:10:00',1.93),('10318','2013-06-17','07:15:00',2.1),('10318','2013-06-17','07:20:00',2.41),('10318','2013-06-17','07:25:00',2.61),('10318','2013-06-17','07:30:00',2.79),('10318','2013-06-17','07:35:00',2.97),('10318','2013-06-17','07:40:00',3.14),('10318','2013-06-17','07:45:00',3.33),('10318','2013-06-17','07:50:00',3.53),('10318','2013-06-17','07:55:00',3.69),('10318','2013-06-17','08:00:00',3.88),('10318','2013-06-17','08:05:00',4.06),('10318','2013-06-17','08:10:00',4.25),('10318','2013-06-17','08:15:00',4.41),('10318','2013-06-17','08:20:00',4.6),('10318','2013-06-17','08:25:00',4.76),('10318','2013-06-17','08:30:00',4.94),('10318','2013-06-17','08:35:00',5.1),('10318','2013-06-17','08:40:00',5.28),('10318','2013-06-17','08:45:00',5.43),('10318','2013-06-17','08:50:00',5.57),('10318','2013-06-17','08:55:00',5.76),('10318','2013-06-17','09:00:00',5.83),('10318','2013-06-17','09:05:00',6.06),('10318','2013-06-17','09:10:00',6.22),('10318','2013-06-17','09:15:00',6.34),('10318','2013-06-17','09:20:00',6.45),('10318','2013-06-17','09:25:00',6.59),('10318','2013-06-17','09:30:00',6.71),('10318','2013-06-17','09:35:00',6.83),('10318','2013-06-17','09:40:00',6.98),('10318','2013-06-17','09:45:00',7.11),('10318','2013-06-17','09:50:00',7.2),('10318','2013-06-17','09:55:00',7.28),('10318','2013-06-17','10:00:00',7.39),('10318','2013-06-17','10:05:00',7.48),('10318','2013-06-17','10:10:00',7.58),('10318','2013-06-17','10:15:00',7.64),('10318','2013-06-17','10:20:00',7.76),('10318','2013-06-17','10:25:00',7.85),('10318','2013-06-17','10:30:00',7.92),('10318','2013-06-17','10:35:00',7.99),('10318','2013-06-17','10:40:00',8.05),('10318','2013-06-17','10:45:00',8.12),('10318','2013-06-17','10:50:00',8.21),('10318','2013-06-17','10:55:00',8.27),('10318','2013-06-17','11:00:00',8.29),('10318','2013-06-17','11:05:00',8.35),('10318','2013-06-17','11:10:00',8.36),('10318','2013-06-17','11:15:00',8.39),('10318','2013-06-17','11:20:00',8.45),('10318','2013-06-17','11:25:00',8.49),('10318','2013-06-17','11:30:00',8.58),('10318','2013-06-17','11:35:00',8.6),('10318','2013-06-17','11:40:00',8.68),('10318','2013-06-17','11:45:00',8.68),('10318','2013-06-17','11:50:00',8.65),('10318','2013-06-17','11:55:00',8.69),('10318','2013-06-17','12:00:00',8.61),('10318','2013-06-17','12:05:00',8.72),('10318','2013-06-17','12:10:00',8.69),('10318','2013-06-17','12:15:00',8.71),('10318','2013-06-17','12:20:00',8.68),('10318','2013-06-17','12:25:00',8.55),('10318','2013-06-17','12:30:00',8.69),('10318','2013-06-17','12:35:00',8.85),('10318','2013-06-17','12:40:00',8.91),('10318','2013-06-17','12:45:00',8.91),('10318','2013-06-17','12:50:00',8.86),('10318','2013-06-17','12:55:00',8.91),('10318','2013-06-17','13:00:00',8.82),('10318','2013-06-17','13:05:00',8.77),('10318','2013-06-17','13:10:00',8.8),('10318','2013-06-17','13:15:00',8.8),('10318','2013-06-17','13:20:00',8.77),('10318','2013-06-17','13:25:00',8.7),('10318','2013-06-17','13:30:00',8.66),('10318','2013-06-17','13:35:00',8.66),('10318','2013-06-17','13:40:00',8.61),('10318','2013-06-17','13:45:00',8.49),('10318','2013-06-17','13:50:00',8.52),('10318','2013-06-17','13:55:00',8.5),('10318','2013-06-17','14:00:00',8.45),('10318','2013-06-17','14:05:00',8.4),('10318','2013-06-17','14:10:00',8.37),('10318','2013-06-17','14:15:00',8.34),('10318','2013-06-17','14:20:00',8.28),('10318','2013-06-17','14:25:00',8.24),('10318','2013-06-17','14:30:00',8.15),('10318','2013-06-17','14:35:00',8.08),('10318','2013-06-17','14:40:00',7.99),('10318','2013-06-17','14:45:00',7.9),('10318','2013-06-17','14:50:00',7.83),('10318','2013-06-17','14:55:00',7.72),('10318','2013-06-17','15:00:00',7.63),('10318','2013-06-17','15:05:00',7.56),('10318','2013-06-17','15:10:00',7.46),('10318','2013-06-17','15:15:00',7.4),('10318','2013-06-17','15:20:00',7.32),('10318','2013-06-17','15:25:00',7.24),('10318','2013-06-17','15:30:00',6.98),('10318','2013-06-17','15:35:00',6.97),('10318','2013-06-17','15:40:00',6.86),('10318','2013-06-17','15:45:00',6.71),('10318','2013-06-17','15:50:00',6.64),('10318','2013-06-17','15:55:00',6.52),('10318','2013-06-17','16:00:00',6.4),('10318','2013-06-17','16:05:00',6.27),('10318','2013-06-17','16:10:00',6.13),('10318','2013-06-17','16:15:00',6.02),('10318','2013-06-17','16:20:00',5.86),('10318','2013-06-17','16:25:00',5.7),('10318','2013-06-17','16:30:00',5.55),('10318','2013-06-17','16:35:00',5.46),('10318','2013-06-17','16:40:00',5.31),('10318','2013-06-17','16:45:00',5.16),('10318','2013-06-17','16:50:00',5.01),('10318','2013-06-17','16:55:00',4.87),('10318','2013-06-17','17:00:00',4.73),('10318','2013-06-17','17:05:00',4.57),('10318','2013-06-17','17:10:00',4.41),('10318','2013-06-17','17:15:00',4.23),('10318','2013-06-17','17:20:00',4),('10318','2013-06-17','17:25:00',3.91),('10318','2013-06-17','17:30:00',3.77),('10318','2013-06-17','17:35:00',3.62),('10318','2013-06-17','17:40:00',3.46),('10318','2013-06-17','17:45:00',3.28),('10318','2013-06-17','17:50:00',3.1),('10318','2013-06-17','17:55:00',2.92),('10318','2013-06-17','18:00:00',2.75),('10318','2013-06-17','18:05:00',2.58),('10318','2013-06-17','18:10:00',2.45),('10318','2013-06-17','18:15:00',2.3),('10318','2013-06-17','18:20:00',2.13),('10318','2013-06-17','18:25:00',1.97),('10318','2013-06-17','18:30:00',1.76),('10318','2013-06-17','18:35:00',1.72),('10318','2013-06-17','18:40:00',1.51),('10318','2013-06-17','18:45:00',1.52),('10318','2013-06-17','18:50:00',1.4),('10318','2013-06-17','18:55:00',1.29),('10318','2013-06-17','19:00:00',1.18),('10318','2013-06-17','19:05:00',1.04),('10318','2013-06-16','06:50:00',1.13),('10318','2013-06-16','06:55:00',1.33),('10318','2013-06-16','07:00:00',1.54),('10318','2013-06-16','07:05:00',1.7),('10318','2013-06-16','07:10:00',1.96),('10318','2013-06-16','07:15:00',2.17),('10318','2013-06-16','07:20:00',2.42),('10318','2013-06-16','07:25:00',2.57),('10318','2013-06-16','07:30:00',2.8),('10318','2013-06-16','07:35:00',2.99),('10318','2013-06-16','07:40:00',3.18),('10318','2013-06-16','07:45:00',3.35),('10318','2013-06-16','07:50:00',3.56),('10318','2013-06-16','07:55:00',3.75),('10318','2013-06-16','08:00:00',3.95),('10318','2013-06-16','08:05:00',4.14),('10318','2013-06-16','08:10:00',4.35),('10318','2013-06-16','08:15:00',4.52),('10318','2013-06-16','08:20:00',4.69),('10318','2013-06-16','08:25:00',4.87),('10318','2013-06-16','08:30:00',5),('10318','2013-06-16','08:35:00',5.15),('10318','2013-06-16','08:40:00',5.33),('10318','2013-06-16','08:45:00',5.51),('10318','2013-06-16','08:50:00',5.69),('10318','2013-06-16','08:55:00',5.85),('10318','2013-06-16','09:00:00',6),('10318','2013-06-16','09:05:00',6.14),('10318','2013-06-16','09:10:00',6.32),('10318','2013-06-16','09:15:00',6.45),('10318','2013-06-16','09:20:00',6.56),('10318','2013-06-16','09:25:00',6.66),('10318','2013-06-16','09:30:00',6.8),('10318','2013-06-16','09:35:00',6.94),('10318','2013-06-16','09:40:00',7.12),('10318','2013-06-16','09:45:00',7.08),('10318','2013-06-16','09:50:00',7.31),('10318','2013-06-16','09:55:00',7.42),('10318','2013-06-16','10:00:00',7.52),('10318','2013-06-16','10:05:00',7.62),('10318','2013-06-16','10:10:00',7.68),('10318','2013-06-16','10:15:00',7.79),('10318','2013-06-16','10:20:00',7.86),('10318','2013-06-16','10:25:00',7.94),('10318','2013-06-16','10:30:00',8),('10318','2013-06-16','10:35:00',8.06),('10318','2013-06-16','10:40:00',8.17),('10318','2013-06-16','10:45:00',8.22),('10318','2013-06-16','10:50:00',8.28),('10318','2013-06-16','10:55:00',8.44),('10318','2013-06-16','11:00:00',8.51),('10318','2013-06-16','11:05:00',8.56),('10318','2013-06-16','11:10:00',8.59),('10318','2013-06-16','11:15:00',8.62),('10318','2013-06-16','11:20:00',8.69),('10318','2013-06-16','11:25:00',8.68),('10318','2013-06-16','11:30:00',8.6),('10318','2013-06-16','11:35:00',8.8),('10318','2013-06-16','11:40:00',8.88),('10318','2013-06-16','11:45:00',8.9),('10318','2013-06-16','11:50:00',8.98),('10318','2013-06-16','11:55:00',9.01),('10318','2013-06-16','12:00:00',9.05),('10318','2013-06-16','12:05:00',9.04),('10318','2013-06-16','12:10:00',9.03),('10318','2013-06-16','12:15:00',9.1),('10318','2013-06-16','12:20:00',9.01),('10318','2013-06-16','12:25:00',8.93),('10318','2013-06-16','12:30:00',9.04),('10318','2013-06-16','12:35:00',9.04),('10318','2013-06-16','12:40:00',9.08),('10318','2013-06-16','12:45:00',8.96),('10318','2013-06-16','12:50:00',9.08),('10318','2013-06-16','12:55:00',9.11),('10318','2013-06-16','13:00:00',9.08),('10318','2013-06-16','13:05:00',9.15),('10318','2013-06-16','13:10:00',9.15),('10318','2013-06-16','13:15:00',8.88),('10318','2013-06-16','13:20:00',9.1),('10318','2013-06-16','13:25:00',9.06),('10318','2013-06-16','13:30:00',8.99),('10318','2013-06-16','13:35:00',9.01),('10318','2013-06-16','13:40:00',8.96),('10318','2013-06-16','13:45:00',8.94),('10318','2013-06-16','13:50:00',8.91),('10318','2013-06-16','13:55:00',8.78),('10318','2013-06-16','14:00:00',8.79),('10318','2013-06-16','14:05:00',8.77),('10318','2013-06-16','14:10:00',8.74),('10318','2013-06-16','14:15:00',8.65),('10318','2013-06-16','14:20:00',8.59),('10318','2013-06-16','14:25:00',8.55),('10318','2013-06-16','14:30:00',8.43),('10318','2013-06-16','14:35:00',8.43),('10318','2013-06-16','14:40:00',8.29),('10318','2013-06-16','14:45:00',8.19),('10318','2013-06-16','14:50:00',8.12),('10318','2013-06-16','14:55:00',8.01),('10318','2013-06-16','15:00:00',7.85),('10318','2013-06-16','15:05:00',7.84),('10318','2013-06-16','15:10:00',7.75),('10318','2013-06-16','15:15:00',7.64),('10318','2013-06-16','15:20:00',7.55),('10318','2013-06-16','15:25:00',7.46),('10318','2013-06-16','15:30:00',7.29),('10318','2013-06-16','15:35:00',7.17),('10318','2013-06-16','15:40:00',7.06),('10318','2013-06-16','15:45:00',6.93),('10318','2013-06-16','15:50:00',6.81),('10318','2013-06-16','15:55:00',6.66),('10318','2013-06-16','16:00:00',6.5),('10318','2013-06-16','16:05:00',6.38),('10318','2013-06-16','16:10:00',6.24),('10318','2013-06-16','16:15:00',6.11),('10318','2013-06-16','16:20:00',5.94),('10318','2013-06-16','16:25:00',5.8),('10318','2013-06-16','16:30:00',5.65),('10318','2013-06-16','16:35:00',5.5),('10318','2013-06-16','16:40:00',5.34),('10318','2013-06-16','16:45:00',5.1),('10318','2013-06-16','16:50:00',5.03),('10318','2013-06-16','16:55:00',4.87),('10318','2013-06-16','17:00:00',4.7),('10318','2013-06-16','17:05:00',4.54),('10318','2013-06-16','17:10:00',4.37),('10318','2013-06-16','17:15:00',4.19),('10318','2013-06-16','17:20:00',4),('10318','2013-06-16','17:25:00',3.83),('10318','2013-06-16','17:30:00',3.65),('10318','2013-06-16','17:35:00',3.48),('10318','2013-06-16','17:40:00',3.3),('10318','2013-06-16','17:45:00',3.12),('10318','2013-06-16','17:50:00',2.94),('10318','2013-06-16','17:55:00',2.75),('10318','2013-06-16','18:00:00',2.59),('10318','2013-06-16','18:05:00',2.4),('10318','2013-06-16','18:10:00',2.27),('10318','2013-06-16','18:15:00',2.09),('10318','2013-06-16','18:20:00',1.92),('10318','2013-06-16','18:25:00',1.79),('10318','2013-06-16','18:30:00',1.62),('10318','2013-06-16','18:35:00',1.46),('10318','2013-06-16','18:40:00',1.35),('10318','2013-06-16','18:45:00',1.21),('10318','2013-06-16','18:50:00',1.09),('10318','2013-06-15','06:50:00',1.09),('10318','2013-06-15','06:55:00',1.28),('10318','2013-06-15','07:00:00',1.49),('10318','2013-06-15','07:05:00',1.66),('10318','2013-06-15','07:10:00',1.86),('10318','2013-06-15','07:15:00',2.05),('10318','2013-06-15','07:20:00',2.34),('10318','2013-06-15','07:25:00',2.51),('10318','2013-06-15','07:30:00',2.63),('10318','2013-06-15','07:35:00',2.86),('10318','2013-06-15','07:40:00',3.05),('10318','2013-06-15','07:45:00',3.22),('10318','2013-06-15','07:50:00',3.42),('10318','2013-06-15','07:55:00',3.59),('10318','2013-06-15','08:00:00',3.79),('10318','2013-06-15','08:05:00',3.98),('10318','2013-06-15','08:10:00',4.18),('10318','2013-06-15','08:15:00',4.37),('10318','2013-06-15','08:20:00',4.6),('10318','2013-06-15','08:25:00',4.85),('10318','2013-06-15','08:30:00',5.05),('10318','2013-06-15','08:35:00',5.16),('10318','2013-06-15','08:40:00',5.28),('10318','2013-06-15','08:45:00',5.76),('10318','2013-06-15','08:50:00',5.82),('10318','2013-06-15','08:55:00',6.07),('10318','2013-06-15','09:00:00',6.39),('10318','2013-06-15','09:05:00',4.41),('10318','2013-06-15','09:10:00',3.16),('10318','2013-06-15','09:15:00',6.16),('10318','2013-06-15','09:20:00',5.36),('10318','2013-06-15','09:25:00',6.68),('10318','2013-06-15','09:30:00',7.01),('10318','2013-06-15','09:35:00',7.05),('10318','2013-06-15','09:40:00',7.15),('10318','2013-06-15','09:45:00',7.18),('10318','2013-06-15','09:50:00',7.31),('10318','2013-06-15','09:55:00',7.54),('10318','2013-06-15','10:00:00',7.62),('10318','2013-06-15','10:05:00',7.73),('10318','2013-06-15','10:10:00',7.81),('10318','2013-06-15','10:15:00',7.69),('10318','2013-06-15','10:20:00',7.89),('10318','2013-06-15','10:25:00',7.79),('10318','2013-06-15','10:30:00',5.35),('10318','2013-06-15','10:35:00',5.81),('10318','2013-06-15','10:40:00',6.85),('10318','2013-06-15','10:45:00',8.11),('10318','2013-06-15','10:50:00',7.76),('10318','2013-06-15','10:55:00',8.63),('10318','2013-06-15','11:00:00',8.5),('10318','2013-06-15','11:05:00',8.71),('10318','2013-06-15','11:10:00',8.79),('10318','2013-06-15','11:15:00',8.77),('10318','2013-06-15','11:20:00',8.83),('10318','2013-06-15','11:25:00',8.87),('10318','2013-06-15','11:30:00',8.84),('10318','2013-06-15','11:35:00',8.93),('10318','2013-06-15','11:40:00',9),('10318','2013-06-15','11:45:00',9.06),('10318','2013-06-15','11:50:00',9.24),('10318','2013-06-15','11:55:00',9.05),('10318','2013-06-15','12:00:00',9.24),('10318','2013-06-15','12:05:00',9.18),('10318','2013-06-15','12:10:00',9.25),('10318','2013-06-15','12:15:00',9.23),('10318','2013-06-15','12:20:00',9.28),('10318','2013-06-15','12:25:00',9.18),('10318','2013-06-15','12:30:00',9.32),('10318','2013-06-15','12:35:00',9.28),('10318','2013-06-15','12:40:00',9.28),('10318','2013-06-15','12:45:00',9.31),('10318','2013-06-15','12:50:00',9.29),('10318','2013-06-15','12:55:00',9.31),('10318','2013-06-15','13:00:00',9.27),('10318','2013-06-15','13:05:00',9.3),('10318','2013-06-15','13:10:00',9.19),('10318','2013-06-15','13:15:00',9.14),('10318','2013-06-15','13:20:00',9.11),('10318','2013-06-15','13:25:00',9.12),('10318','2013-06-15','13:30:00',9.14),('10318','2013-06-15','13:35:00',9.08),('10318','2013-06-15','13:40:00',8.91),('10318','2013-06-15','13:45:00',8.93),('10318','2013-06-15','13:50:00',8.85),('10318','2013-06-15','13:55:00',8.79),('10318','2013-06-15','14:00:00',8.75),('10318','2013-06-15','14:05:00',8.64),('10318','2013-06-15','14:10:00',8.59),('10318','2013-06-15','14:15:00',8.55),('10318','2013-06-15','14:20:00',8.56),('10318','2013-06-15','14:25:00',8.39),('10318','2013-06-15','14:30:00',8.22),('10318','2013-06-15','14:35:00',8.36),('10318','2013-06-15','14:40:00',8.14),('10318','2013-06-15','14:45:00',8.17),('10318','2013-06-15','14:50:00',8.14),('10318','2013-06-15','14:55:00',8.05),('10318','2013-06-15','15:00:00',7.96),('10318','2013-06-15','15:05:00',7.82),('10318','2013-06-15','15:10:00',7.74),('10318','2013-06-15','15:15:00',7.67),('10318','2013-06-15','15:20:00',7.61),('10318','2013-06-15','15:25:00',7.46),('10318','2013-06-15','15:30:00',7.31),('10318','2013-06-15','15:35:00',7.2),('10318','2013-06-15','15:40:00',7.12),('10318','2013-06-15','15:45:00',6.84),('10318','2013-06-15','15:50:00',6.85),('10318','2013-06-15','15:55:00',6.69),('10318','2013-06-15','16:00:00',6.59),('10318','2013-06-15','16:05:00',6.44),('10318','2013-06-15','16:10:00',6.26),('10318','2013-06-15','16:15:00',6.1),('10318','2013-06-15','16:20:00',5.98),('10318','2013-06-15','16:25:00',5.83),('10318','2013-06-15','16:30:00',5.69),('10318','2013-06-15','16:35:00',5.53),('10318','2013-06-15','16:40:00',5.36),('10318','2013-06-15','16:45:00',5.2),('10318','2013-06-15','16:50:00',5.05),('10318','2013-06-15','16:55:00',4.9),('10318','2013-06-15','17:00:00',4.71),('10318','2013-06-15','17:05:00',4.53),('10318','2013-06-15','17:10:00',4.36),('10318','2013-06-15','17:15:00',4.2),('10318','2013-06-15','17:20:00',4.02),('10318','2013-06-15','17:25:00',3.83),('10318','2013-06-15','17:30:00',3.65),('10318','2013-06-15','17:35:00',3.38),('10318','2013-06-15','17:40:00',3.27),('10318','2013-06-15','17:45:00',3.13),('10318','2013-06-15','17:50:00',2.95),('10318','2013-06-15','17:55:00',2.75),('10318','2013-06-15','18:00:00',2.58),('10318','2013-06-15','18:05:00',2.41),('10318','2013-06-15','18:10:00',2.27),('10318','2013-06-15','18:15:00',2.14),('10318','2013-06-15','18:20:00',1.97),('10318','2013-06-15','18:25:00',1.81),('10318','2013-06-15','18:30:00',1.64),('10318','2013-06-15','18:35:00',1.49),('10318','2013-06-15','18:40:00',1.35),('10318','2013-06-15','18:45:00',1.25),('10318','2013-06-15','18:50:00',1.12),('10318','2013-06-15','18:55:00',1.02),('10318','2013-06-14','06:50:00',1.15),('10318','2013-06-14','06:55:00',1.34),('10318','2013-06-14','07:00:00',1.6),('10318','2013-06-14','07:05:00',1.81),('10318','2013-06-14','07:10:00',2.07),('10318','2013-06-14','07:15:00',2.39),('10318','2013-06-14','07:20:00',2.72),('10318','2013-06-14','07:25:00',2.92),('10318','2013-06-14','07:30:00',3.09),('10318','2013-06-14','07:35:00',3.3),('10318','2013-06-14','07:40:00',3.49),('10318','2013-06-14','07:45:00',3.69),('10318','2013-06-14','07:50:00',3.88),('10318','2013-06-14','07:55:00',4.07),('10318','2013-06-14','08:00:00',4.25),('10318','2013-06-14','08:05:00',4.47),('10318','2013-06-14','08:10:00',4.65),('10318','2013-06-14','08:15:00',4.84),('10318','2013-06-14','08:20:00',5.02),('10318','2013-06-14','08:25:00',5.19),('10318','2013-06-14','08:30:00',5.35),('10318','2013-06-14','08:35:00',5.51),('10318','2013-06-14','08:40:00',5.68),('10318','2013-06-14','08:45:00',5.71),('10318','2013-06-14','08:50:00',6.01),('10318','2013-06-14','08:55:00',6.15),('10318','2013-06-14','09:00:00',6.33),('10318','2013-06-14','09:05:00',6.47),('10318','2013-06-14','09:10:00',6.59),('10318','2013-06-14','09:15:00',6.69),('10318','2013-06-14','09:20:00',6.79),('10318','2013-06-14','09:25:00',6.9),('10318','2013-06-14','09:30:00',7),('10318','2013-06-14','09:35:00',7.21),('10318','2013-06-14','09:40:00',7.39),('10318','2013-06-14','09:45:00',7.46),('10318','2013-06-14','09:50:00',7.57),('10318','2013-06-14','09:55:00',7.66),('10318','2013-06-14','10:00:00',7.73),('10318','2013-06-14','10:05:00',7.8),('10318','2013-06-14','10:10:00',7.86),('10318','2013-06-14','10:15:00',8.08),('10318','2013-06-14','10:20:00',8.18),('10318','2013-06-14','10:25:00',8.32),('10318','2013-06-14','10:30:00',8.02),('10318','2013-06-14','10:35:00',8.58),('10318','2013-06-14','10:40:00',8.58),('10318','2013-06-14','10:45:00',8.57),('10318','2013-06-14','10:50:00',8.57),('10318','2013-06-14','10:55:00',8.55),('10318','2013-06-14','11:00:00',8.54),('10318','2013-06-14','11:05:00',8.75),('10318','2013-06-14','11:10:00',8.84),('10318','2013-06-14','11:15:00',8.89),('10318','2013-06-14','11:20:00',8.84),('10318','2013-06-14','11:25:00',9.09),('10318','2013-06-14','11:30:00',9.04),('10318','2013-06-14','11:35:00',9.02),('10318','2013-06-14','11:40:00',9.05),('10318','2013-06-14','11:45:00',8.94),('10318','2013-06-14','11:50:00',9.1),('10318','2013-06-14','11:55:00',9.14),('10318','2013-06-14','12:00:00',9.13),('10318','2013-06-14','12:05:00',9.13),('10318','2013-06-14','12:10:00',9.16),('10318','2013-06-14','12:15:00',9.22),('10318','2013-06-14','12:20:00',9.3),('10318','2013-06-14','12:25:00',9.31),('10318','2013-06-14','12:30:00',9.27),('10318','2013-06-14','12:35:00',9.21),('10318','2013-06-14','12:40:00',9.23),('10318','2013-06-14','12:45:00',9.19),('10318','2013-06-14','12:50:00',9.27),('10318','2013-06-14','12:55:00',9.33),('10318','2013-06-14','13:00:00',9.25),('10318','2013-06-14','13:05:00',9.14),('10318','2013-06-14','13:10:00',9.13),('10318','2013-06-14','13:15:00',9.08),('10318','2013-06-14','13:20:00',9.1),('10318','2013-06-14','13:25:00',9.16),('10318','2013-06-14','13:30:00',9.03),('10318','2013-06-14','13:35:00',9),('10318','2013-06-14','13:40:00',9.01),('10318','2013-06-14','13:45:00',9.03),('10318','2013-06-14','13:50:00',9.06),('10318','2013-06-14','13:55:00',8.98),('10318','2013-06-14','14:00:00',8.82),('10318','2013-06-14','14:05:00',8.71),('10318','2013-06-14','14:10:00',8.73),('10318','2013-06-14','14:15:00',8.68),('10318','2013-06-14','14:20:00',8.54),('10318','2013-06-14','14:25:00',8.53),('10318','2013-06-14','14:30:00',8.57),('10318','2013-06-14','14:35:00',8.5),('10318','2013-06-14','14:40:00',8.5),('10318','2013-06-14','14:45:00',8.43),('10318','2013-06-14','14:50:00',8.31),('10318','2013-06-14','14:55:00',8.16),('10318','2013-06-14','15:00:00',8.09),('10318','2013-06-14','15:05:00',7.99),('10318','2013-06-14','15:10:00',7.89),('10318','2013-06-14','15:15:00',7.56),('10318','2013-06-14','15:20:00',7.57),('10318','2013-06-14','15:25:00',7.52),('10318','2013-06-14','15:30:00',7.4),('10318','2013-06-14','15:35:00',7.32),('10318','2013-06-14','15:40:00',7.21),('10318','2013-06-14','15:45:00',7.1),('10318','2013-06-14','15:50:00',7),('10318','2013-06-14','15:55:00',6.85),('10318','2013-06-14','16:00:00',6.72),('10318','2013-06-14','16:05:00',6.58),('10318','2013-06-14','16:10:00',6.42),('10318','2013-06-14','16:15:00',6.24),('10318','2013-06-14','16:20:00',6.07),('10318','2013-06-14','16:25:00',5.89),('10318','2013-06-14','16:30:00',5.75),('10318','2013-06-14','16:35:00',5.61),('10318','2013-06-14','16:40:00',5.44),('10318','2013-06-14','16:45:00',5.28),('10318','2013-06-14','16:50:00',5.13),('10318','2013-06-14','16:55:00',4.95),('10318','2013-06-14','17:00:00',4.68),('10318','2013-06-14','17:05:00',4.51),('10318','2013-06-14','17:10:00',4.41),('10318','2013-06-14','17:15:00',4.23),('10318','2013-06-14','17:20:00',4.03),('10318','2013-06-14','17:25:00',3.83),('10318','2013-06-14','17:30:00',3.53),('10318','2013-06-14','17:35:00',3.53),('10318','2013-06-14','17:40:00',3.37),('10318','2013-06-14','17:45:00',3.2),('10318','2013-06-14','17:50:00',3),('10318','2013-06-14','17:55:00',2.82),('10318','2013-06-14','18:00:00',2.6),('10318','2013-06-14','18:05:00',2.47),('10318','2013-06-14','18:10:00',2.32),('10318','2013-06-14','18:15:00',2.15),('10318','2013-06-14','18:20:00',1.95),('10318','2013-06-14','18:25:00',1.81),('10318','2013-06-14','18:30:00',1.65),('10318','2013-06-14','18:35:00',1.49),('10318','2013-06-14','18:40:00',1.35),('10318','2013-06-14','18:45:00',1.24),('10318','2013-06-14','18:50:00',1.1),('10318','2013-06-13','06:50:00',1.16),('10318','2013-06-13','06:55:00',1.34),('10318','2013-06-13','07:00:00',1.64),('10318','2013-06-13','07:05:00',1.82),('10318','2013-06-13','07:10:00',2.04),('10318','2013-06-13','07:15:00',2.19),('10318','2013-06-13','07:20:00',2.7),('10318','2013-06-13','07:25:00',2.91),('10318','2013-06-13','07:30:00',3.12),('10318','2013-06-13','07:35:00',3.33),('10318','2013-06-13','07:40:00',3.53),('10318','2013-06-13','07:45:00',3.72),('10318','2013-06-13','07:50:00',3.95),('10318','2013-06-13','07:55:00',4.13),('10318','2013-06-13','08:00:00',4.32),('10318','2013-06-13','08:05:00',4.51),('10318','2013-06-13','08:10:00',4.7),('10318','2013-06-13','08:15:00',4.88),('10318','2013-06-13','08:20:00',5.07),('10318','2013-06-13','08:25:00',5.26),('10318','2013-06-13','08:30:00',5.32),('10318','2013-06-13','08:35:00',5.6),('10318','2013-06-13','08:40:00',5.75),('10318','2013-06-13','08:45:00',5.89),('10318','2013-06-13','08:50:00',6.06),('10318','2013-06-13','08:55:00',6.23),('10318','2013-06-13','09:00:00',6.38),('10318','2013-06-13','09:05:00',6.54),('10318','2013-06-13','09:10:00',6.72),('10318','2013-06-13','09:15:00',6.86),('10318','2013-06-13','09:20:00',7.01),('10318','2013-06-13','09:25:00',7.12),('10318','2013-06-13','09:30:00',7.3),('10318','2013-06-13','09:35:00',7.48),('10318','2013-06-13','09:40:00',7.63),('10318','2013-06-13','09:45:00',7.75),('10318','2013-06-13','09:50:00',7.89),('10318','2013-06-13','09:55:00',7.95),('10318','2013-06-13','10:00:00',8.09),('10318','2013-06-13','10:05:00',8.17),('10318','2013-06-13','10:10:00',8.26),('10318','2013-06-13','10:15:00',8.17),('10318','2013-06-13','10:20:00',8.45),('10318','2013-06-13','10:25:00',8.57),('10318','2013-06-13','10:30:00',8.58),('10318','2013-06-13','10:35:00',8.66),('10318','2013-06-13','10:40:00',8.75),('10318','2013-06-13','10:45:00',8.85),('10318','2013-06-13','10:50:00',8.86),('10318','2013-06-13','10:55:00',8.92),('10318','2013-06-13','11:00:00',8.97),('10318','2013-06-13','11:05:00',9.07),('10318','2013-06-13','11:10:00',9.1),('10318','2013-06-13','11:15:00',9.07),('10318','2013-06-13','11:20:00',9.13),('10318','2013-06-13','11:25:00',9.24),('10318','2013-06-13','11:30:00',9.23),('10318','2013-06-13','11:35:00',9.28),('10318','2013-06-13','11:40:00',9.36),('10318','2013-06-13','11:45:00',9.42),('10318','2013-06-13','11:50:00',9.36),('10318','2013-06-13','11:55:00',9.41),('10318','2013-06-13','12:00:00',9.34),('10318','2013-06-13','12:05:00',9.43),('10318','2013-06-13','12:10:00',9.32),('10318','2013-06-13','12:15:00',9.36),('10318','2013-06-13','12:20:00',9.38),('10318','2013-06-13','12:25:00',7.09),('10318','2013-06-13','12:30:00',9.51),('10318','2013-06-13','12:35:00',7.16),('10318','2013-06-13','12:40:00',9.49),('10318','2013-06-13','12:45:00',9.62),('10318','2013-06-13','12:50:00',9.6),('10318','2013-06-13','12:55:00',9.56),('10318','2013-06-13','13:00:00',9.55),('10318','2013-06-13','13:05:00',9.53),('10318','2013-06-13','13:10:00',9.51),('10318','2013-06-13','13:15:00',9.53),('10318','2013-06-13','13:20:00',9.48),('10318','2013-06-13','13:25:00',9.4),('10318','2013-06-13','13:30:00',9.36),('10318','2013-06-13','13:35:00',9.34),('10318','2013-06-13','13:40:00',9.2),('10318','2013-06-13','13:45:00',9.2),('10318','2013-06-13','13:50:00',8.9),('10318','2013-06-13','13:55:00',9.07),('10318','2013-06-13','14:00:00',9.13),('10318','2013-06-13','14:05:00',9.03),('10318','2013-06-13','14:10:00',9.03),('10318','2013-06-13','14:15:00',9),('10318','2013-06-13','14:20:00',8.85),('10318','2013-06-13','14:25:00',8.8),('10318','2013-06-13','14:30:00',8.79),('10318','2013-06-13','14:35:00',8.82),('10318','2013-06-13','14:40:00',8.67),('10318','2013-06-13','14:45:00',8.46),('10318','2013-06-13','14:50:00',8.35),('10318','2013-06-13','14:55:00',8.21),('10318','2013-06-13','15:00:00',8.1),('10318','2013-06-13','15:05:00',7.96),('10318','2013-06-13','15:10:00',7.87),('10318','2013-06-13','15:15:00',7.76),('10318','2013-06-13','15:20:00',7.67),('10318','2013-06-13','15:25:00',7.6),('10318','2013-06-13','15:30:00',7.5),('10318','2013-06-13','15:35:00',7.13),('10318','2013-06-13','15:40:00',7.25),('10318','2013-06-13','15:45:00',7.07),('10318','2013-06-13','15:50:00',6.89),('10318','2013-06-13','15:55:00',6.79),('10318','2013-06-13','16:00:00',6.66),('10318','2013-06-13','16:05:00',6.54),('10318','2013-06-13','16:10:00',6.4),('10318','2013-06-13','16:15:00',6.25),('10318','2013-06-13','16:20:00',6.06),('10318','2013-06-13','16:25:00',5.89),('10318','2013-06-13','16:30:00',5.71),('10318','2013-06-13','16:35:00',5.48),('10318','2013-06-13','16:40:00',5.28),('10318','2013-06-13','16:45:00',5.12),('10318','2013-06-13','16:50:00',5.04),('10318','2013-06-13','16:55:00',4.89),('10318','2013-06-13','17:00:00',4.71),('10318','2013-06-13','17:05:00',4.57),('10318','2013-06-13','17:10:00',4.4),('10318','2013-06-13','17:15:00',4.26),('10318','2013-06-13','17:20:00',4.11),('10318','2013-06-13','17:25:00',3.89),('10318','2013-06-13','17:30:00',3.72),('10318','2013-06-13','17:35:00',3.54),('10318','2013-06-13','17:40:00',3.35),('10318','2013-06-13','17:45:00',3.16),('10318','2013-06-13','17:50:00',2.93),('10318','2013-06-13','17:55:00',2.74),('10318','2013-06-13','18:00:00',2.6),('10318','2013-06-13','18:05:00',2.44),('10318','2013-06-13','18:10:00',2.25),('10318','2013-06-13','18:15:00',2.11),('10318','2013-06-13','18:20:00',1.92),('10318','2013-06-13','18:25:00',1.75),('10318','2013-06-13','18:30:00',1.59),('10318','2013-06-13','18:35:00',1.45),('10318','2013-06-13','18:40:00',1.28),('10318','2013-06-13','18:45:00',1.19),('10318','2013-06-13','18:50:00',1.08),('10318','2013-06-12','06:50:00',1.18),('10318','2013-06-12','06:55:00',1.37),('10318','2013-06-12','07:00:00',1.54),('10318','2013-06-12','07:05:00',1.82),('10318','2013-06-12','07:10:00',1.92),('10318','2013-06-12','07:15:00',2.48),('10318','2013-06-12','07:20:00',2.78),('10318','2013-06-12','07:25:00',2.98),('10318','2013-06-12','07:30:00',3.17),('10318','2013-06-12','07:35:00',3.36),('10318','2013-06-12','07:40:00',3.54),('10318','2013-06-12','07:45:00',3.66),('10318','2013-06-12','07:50:00',3.95),('10318','2013-06-12','07:55:00',4.15),('10318','2013-06-12','08:00:00',4.36),('10318','2013-06-12','08:05:00',4.55),('10318','2013-06-12','08:10:00',4.76),('10318','2013-06-12','08:15:00',4.93),('10318','2013-06-12','08:20:00',5.12),('10318','2013-06-12','08:25:00',5.3),('10318','2013-06-12','08:30:00',5.48),('10318','2013-06-12','08:35:00',5.66),('10318','2013-06-12','08:40:00',5.81),('10318','2013-06-12','08:45:00',5.95),('10318','2013-06-12','08:50:00',6.13),('10318','2013-06-12','08:55:00',6.31),('10318','2013-06-12','09:00:00',6.48),('10318','2013-06-12','09:05:00',6.66),('10318','2013-06-12','09:10:00',6.82),('10318','2013-06-12','09:15:00',6.97),('10318','2013-06-12','09:20:00',7.11),('10318','2013-06-12','09:25:00',7.24),('10318','2013-06-12','09:30:00',7.15),('10318','2013-06-12','09:35:00',7.53),('10318','2013-06-12','09:40:00',7.57),('10318','2013-06-12','09:45:00',7.69),('10318','2013-06-12','09:50:00',7.79),('10318','2013-06-12','09:55:00',7.87),('10318','2013-06-12','10:00:00',7.98),('10318','2013-06-12','10:05:00',8.09),('10318','2013-06-12','10:10:00',8.2),('10318','2013-06-12','10:15:00',8.35),('10318','2013-06-12','10:20:00',8.42),('10318','2013-06-12','10:25:00',8.57),('10318','2013-06-12','10:30:00',8.64),('10318','2013-06-12','10:35:00',8.75),('10318','2013-06-12','10:40:00',8.79),('10318','2013-06-12','10:45:00',8.88),('10318','2013-06-12','10:50:00',9.02),('10318','2013-06-12','10:55:00',9.14),('10318','2013-06-12','11:00:00',9.21),('10318','2013-06-12','11:05:00',9.18),('10318','2013-06-12','11:10:00',9.23),('10318','2013-06-12','11:15:00',9.27),('10318','2013-06-12','11:20:00',9.14),('10318','2013-06-12','11:25:00',9.43),('10318','2013-06-12','11:30:00',9.46),('10318','2013-06-12','11:35:00',9.5),('10318','2013-06-12','11:40:00',9.57),('10318','2013-06-12','11:45:00',9.55),('10318','2013-06-12','11:50:00',9.61),('10318','2013-06-12','11:55:00',9.64),('10318','2013-06-12','12:00:00',9.66),('10318','2013-06-12','12:05:00',9.66),('10318','2013-06-12','12:10:00',9.64),('10318','2013-06-12','12:15:00',9.65),('10318','2013-06-12','12:20:00',8.5),('10318','2013-06-12','12:25:00',9.94),('10318','2013-06-12','12:30:00',9.92),('10318','2013-06-12','12:35:00',9.76),('10318','2013-06-12','12:40:00',9.86),('10318','2013-06-12','12:45:00',10.02),('10318','2013-06-12','12:50:00',10.13),('10318','2013-06-12','12:55:00',9.24),('10318','2013-06-12','13:00:00',9.78),('10318','2013-06-12','13:05:00',9.51),('10318','2013-06-12','13:10:00',9.48),('10318','2013-06-12','13:15:00',9.34),('10318','2013-06-12','13:20:00',9.32),('10318','2013-06-12','13:25:00',9.36),('10318','2013-06-12','13:30:00',9.35),('10318','2013-06-12','13:35:00',9.32),('10318','2013-06-12','13:40:00',9.08),('10318','2013-06-12','13:45:00',9.24),('10318','2013-06-12','13:50:00',9.38),('10318','2013-06-12','13:55:00',9.36),('10318','2013-06-12','14:00:00',7.73),('10318','2013-06-12','14:05:00',3.29),('10318','2013-06-12','14:10:00',4.41),('10318','2013-06-12','14:15:00',7.42),('10318','2013-06-12','14:20:00',8.47),('10318','2013-06-12','14:25:00',9.15),('10318','2013-06-12','14:30:00',8.74),('10318','2013-06-12','14:35:00',8.94),('10318','2013-06-12','14:40:00',8.85),('10318','2013-06-12','14:45:00',8.74),('10318','2013-06-12','14:50:00',8.56),('10318','2013-06-12','14:55:00',8.52),('10318','2013-06-12','15:00:00',8.38),('10318','2013-06-12','15:05:00',6.24),('10318','2013-06-12','15:10:00',8.19),('10318','2013-06-12','15:15:00',8.33),('10318','2013-06-12','15:20:00',6.99),('10318','2013-06-12','15:25:00',7.86),('10318','2013-06-12','15:30:00',7.67),('10318','2013-06-12','15:35:00',7.2),('10318','2013-06-12','15:40:00',7.29),('10318','2013-06-12','15:45:00',7.27),('10318','2013-06-12','15:50:00',7.17),('10318','2013-06-12','15:55:00',6.72),('10318','2013-06-12','16:00:00',5.01),('10318','2013-06-12','16:05:00',6.8),('10318','2013-06-12','16:10:00',6.66),('10318','2013-06-12','16:15:00',5.6),('10318','2013-06-12','16:20:00',6.04),('10318','2013-06-12','16:25:00',6.35),('10318','2013-06-12','16:30:00',5.69),('10318','2013-06-12','16:35:00',4.73),('10318','2013-06-12','16:40:00',5.84),('10318','2013-06-12','16:45:00',4.62),('10318','2013-06-12','16:50:00',4.49),('10318','2013-06-12','16:55:00',5.12),('10318','2013-06-12','17:00:00',4.99),('10318','2013-06-12','17:05:00',4.79),('10318','2013-06-12','17:10:00',4.56),('10318','2013-06-12','17:15:00',4.36),('10318','2013-06-12','17:20:00',4.12),('10318','2013-06-12','17:25:00',3.99),('10318','2013-06-12','17:30:00',3.86),('10318','2013-06-12','17:35:00',3.71),('10318','2013-06-12','17:40:00',1.96),('10318','2013-06-12','17:45:00',1.89),('10318','2013-06-12','17:50:00',3.32),('10318','2013-06-12','17:55:00',2.12),('10318','2013-06-12','18:00:00',2.14),('10318','2013-06-12','18:05:00',2.59),('10318','2013-06-12','18:10:00',2.41),('10318','2013-06-12','18:15:00',2.38),('10318','2013-06-12','18:20:00',2.21),('10318','2013-06-12','18:25:00',1.84),('10318','2013-06-12','18:30:00',1.7),('10318','2013-06-12','18:35:00',1.52),('10318','2013-06-12','18:40:00',1.35),('10318','2013-06-12','18:45:00',1.21),('10318','2013-06-12','18:50:00',1.1),('10318','2013-06-11','06:55:00',1.01),('10318','2013-06-11','07:00:00',1.02),('10318','2013-06-11','07:05:00',1.05),('10318','2013-06-11','07:10:00',1.27),('10318','2013-06-11','07:15:00',1.59),('10318','2013-06-11','07:20:00',2.39),('10318','2013-06-11','07:25:00',2.56),('10318','2013-06-11','07:30:00',3.16),('10318','2013-06-11','07:35:00',3.27),('10318','2013-06-11','07:40:00',3.45),('10318','2013-06-11','07:45:00',3.56),('10318','2013-06-11','07:50:00',3.54),('10318','2013-06-11','07:55:00',2.78),('10318','2013-06-11','08:00:00',1.43),('10318','2013-06-11','08:05:00',4.56),('10318','2013-06-11','08:10:00',4.47),('10318','2013-06-11','08:15:00',3.8),('10318','2013-06-11','08:20:00',5.11),('10318','2013-06-11','08:25:00',5.22),('10318','2013-06-11','08:30:00',5.53),('10318','2013-06-11','08:35:00',5.54),('10318','2013-06-11','08:40:00',5.84),('10318','2013-06-11','08:45:00',6.02),('10318','2013-06-11','08:50:00',6.01),('10318','2013-06-11','08:55:00',6.37),('10318','2013-06-11','09:00:00',6.73),('10318','2013-06-11','09:05:00',6.77),('10318','2013-06-11','09:10:00',7.13),('10318','2013-06-11','09:15:00',7.32),('10318','2013-06-11','09:20:00',7.19),('10318','2013-06-11','09:25:00',7.32),('10318','2013-06-11','09:30:00',7.46),('10318','2013-06-11','09:35:00',6.77),('10318','2013-06-11','09:40:00',6.38),('10318','2013-06-11','09:45:00',4.73),('10318','2013-06-11','09:50:00',4.79),('10318','2013-06-11','09:55:00',7.88),('10318','2013-06-11','10:00:00',8.31),('10318','2013-06-11','10:05:00',8.16),('10318','2013-06-11','10:10:00',8.36),('10318','2013-06-11','10:15:00',6.72),('10318','2013-06-11','10:20:00',8.22),('10318','2013-06-11','10:25:00',9),('10318','2013-06-11','10:30:00',8.79),('10318','2013-06-11','10:35:00',9.09),('10318','2013-06-11','10:40:00',9.05),('10318','2013-06-11','10:45:00',9.02),('10318','2013-06-11','10:50:00',9.27),('10318','2013-06-11','10:55:00',9.78),('10318','2013-06-11','11:00:00',6.73),('10318','2013-06-11','11:05:00',9.03),('10318','2013-06-11','11:10:00',9.52),('10318','2013-06-11','11:15:00',9.45),('10318','2013-06-11','11:20:00',9.44),('10318','2013-06-11','11:25:00',9.41),('10318','2013-06-11','11:30:00',9.45),('10318','2013-06-11','11:35:00',9.52),('10318','2013-06-11','11:40:00',9.57),('10318','2013-06-11','11:45:00',9.63),('10318','2013-06-11','11:50:00',9.68),('10318','2013-06-11','11:55:00',9.69),('10318','2013-06-11','12:00:00',9.71),('10318','2013-06-11','12:05:00',9.82),('10318','2013-06-11','12:10:00',9.76),('10318','2013-06-11','12:15:00',9.83),('10318','2013-06-11','12:20:00',9.81),('10318','2013-06-11','12:25:00',9.79),('10318','2013-06-11','12:30:00',9.81),('10318','2013-06-11','12:35:00',9.89),('10318','2013-06-11','12:40:00',9.97),('10318','2013-06-11','12:45:00',9.84),('10318','2013-06-11','12:50:00',9.74),('10318','2013-06-11','12:55:00',9.56),('10318','2013-06-11','13:00:00',9.85),('10318','2013-06-11','13:05:00',9.69),('10318','2013-06-11','13:10:00',9.97),('10318','2013-06-11','13:15:00',9.79),('10318','2013-06-11','13:20:00',9.75),('10318','2013-06-11','13:25:00',9.79),('10318','2013-06-11','13:30:00',9.7),('10318','2013-06-11','13:35:00',9.66),('10318','2013-06-11','13:40:00',9.72),('10318','2013-06-11','13:45:00',9.6),('10318','2013-06-11','13:50:00',9.63),('10318','2013-06-11','13:55:00',9.54),('10318','2013-06-11','14:00:00',9.53),('10318','2013-06-11','14:05:00',9.26),('10318','2013-06-11','14:10:00',9.2),('10318','2013-06-11','14:15:00',9.08),('10318','2013-06-11','14:20:00',9.12),('10318','2013-06-11','14:25:00',9.06),('10318','2013-06-11','14:30:00',8.93),('10318','2013-06-11','14:35:00',8.58),('10318','2013-06-11','14:40:00',8.76),('10318','2013-06-11','14:45:00',8.63),('10318','2013-06-11','14:50:00',8.63),('10318','2013-06-11','14:55:00',8.56),('10318','2013-06-11','15:00:00',8.42),('10318','2013-06-11','15:05:00',8.29),('10318','2013-06-11','15:10:00',8.2),('10318','2013-06-11','15:15:00',8.07),('10318','2013-06-11','15:20:00',7.92),('10318','2013-06-11','15:25:00',7.8),('10318','2013-06-11','15:30:00',7.84),('10318','2013-06-11','15:35:00',7.9),('10318','2013-06-11','15:40:00',7.86),('10318','2013-06-11','15:45:00',7.4),('10318','2013-06-11','15:50:00',7.29),('10318','2013-06-11','15:55:00',7.39),('10318','2013-06-11','16:00:00',6.81),('10318','2013-06-11','16:05:00',6.54),('10318','2013-06-11','16:10:00',6.7),('10318','2013-06-11','16:15:00',6.54),('10318','2013-06-11','16:20:00',6.15),('10318','2013-06-11','16:25:00',6.23),('10318','2013-06-11','16:30:00',6.08),('10318','2013-06-11','16:35:00',5.95),('10318','2013-06-11','16:40:00',6.01),('10318','2013-06-11','16:45:00',6.19),('10318','2013-06-11','16:50:00',6.12),('10318','2013-06-11','16:55:00',5.68),('10318','2013-06-11','17:00:00',3.41),('10318','2013-06-11','17:05:00',2.79),('10318','2013-06-11','17:10:00',1.74),('10318','2013-06-11','17:15:00',1.56),('10318','2013-06-11','17:20:00',1.32),('10318','2013-06-11','19:15:00',1.21),('10318','2013-06-11','19:20:00',1.11),('10318','2013-06-11','19:25:00',1.09),('10318','2013-06-11','19:30:00',1.19),('10318','2014-04-03','08:00:00',1.04),('10318','2014-04-03','08:05:00',1.17),('10318','2014-04-03','08:10:00',1.28),('10318','2014-04-03','08:15:00',1.32),('10318','2014-04-03','08:20:00',1.39),('10318','2014-04-03','08:25:00',1.49),('10318','2014-04-03','08:30:00',1.62),('10318','2014-04-03','08:35:00',1.74),('10318','2014-04-03','08:40:00',1.95),('10318','2014-04-03','08:45:00',2.17),('10318','2014-04-03','08:50:00',2.43),('10318','2014-04-03','08:55:00',2.79),('10318','2014-04-03','09:00:00',3.01),('10318','2014-04-03','09:05:00',3.26),('10318','2014-04-03','09:10:00',3.11),('10318','2014-04-03','09:15:00',2.81),('10318','2014-04-03','09:20:00',2.84),('10318','2014-04-03','09:25:00',3.09),('10318','2014-04-03','09:30:00',3.68),('10318','2014-04-03','09:35:00',4.38),('10318','2014-04-03','09:40:00',4.48),('10318','2014-04-03','09:45:00',4.32),('10318','2014-04-03','09:50:00',4.29),('10318','2014-04-03','09:55:00',4.71),('10318','2014-04-03','10:00:00',5.79),('10318','2014-04-03','10:05:00',6.46),('10318','2014-04-03','10:10:00',6.95),('10318','2014-04-03','10:15:00',7.88),('10318','2014-04-03','10:20:00',6.97),('10318','2014-04-03','10:25:00',6.06),('10318','2014-04-03','10:30:00',6.68),('10318','2014-04-03','10:35:00',7.31),('10318','2014-04-03','10:40:00',5.93),('10318','2014-04-03','10:45:00',6.77),('10318','2014-04-03','10:50:00',5.49),('10318','2014-04-03','10:55:00',5.73),('10318','2014-04-03','11:00:00',4.62),('10318','2014-04-03','11:05:00',3.88),('10318','2014-04-03','11:10:00',3.59),('10318','2014-04-03','11:15:00',3.37),('10318','2014-04-03','11:20:00',3.16),('10318','2014-04-03','11:25:00',2.93),('10318','2014-04-03','11:30:00',2.94),('10318','2014-04-03','11:35:00',3.2),('10318','2014-04-03','11:40:00',3.52),('10318','2014-04-03','11:45:00',3.89),('10318','2014-04-03','11:50:00',4.79),('10318','2014-04-03','11:55:00',5.26),('10318','2014-04-03','12:00:00',5.16),('10318','2014-04-03','12:05:00',5.22),('10318','2014-04-03','12:10:00',4.94),('10318','2014-04-03','12:15:00',4.86),('10318','2014-04-03','12:20:00',5.85),('10318','2014-04-03','12:25:00',7.36),('10318','2014-04-03','12:30:00',9.5),('10318','2014-04-03','12:35:00',8.65),('10318','2014-04-03','12:40:00',8.06),('10318','2014-04-03','12:45:00',5.29),('10318','2014-04-03','12:50:00',6.33),('10318','2014-04-03','12:55:00',6.57),('10318','2014-04-03','13:00:00',5.22),('10318','2014-04-03','13:05:00',6.52),('10318','2014-04-03','13:10:00',5.74),('10318','2014-04-03','13:15:00',8.5),('10318','2014-04-03','13:20:00',5.29),('10318','2014-04-03','13:25:00',5.52),('10318','2014-04-03','13:30:00',7.07),('10318','2014-04-03','13:35:00',10.22),('10318','2014-04-03','13:40:00',8.05),('10318','2014-04-03','13:45:00',4.21),('10318','2014-04-03','13:50:00',4.8),('10318','2014-04-03','13:55:00',5.43),('10318','2014-04-03','14:00:00',6.99),('10318','2014-04-03','14:05:00',8.18),('10318','2014-04-03','14:10:00',6.61),('10318','2014-04-03','14:15:00',7.47),('10318','2014-04-03','14:20:00',8.05),('10318','2014-04-03','14:25:00',7.27),('10318','2014-04-03','14:30:00',7.71),('10318','2014-04-03','14:35:00',8.67),('10318','2014-04-03','14:40:00',7.87),('10318','2014-04-03','14:45:00',8.04),('10318','2014-04-03','14:50:00',7.95),('10318','2014-04-03','14:55:00',7.72),('10318','2014-04-03','15:00:00',7.55),('10318','2014-04-03','15:05:00',7.38),('10318','2014-04-03','15:10:00',7.31),('10318','2014-04-03','15:15:00',7.17),('10318','2014-04-03','15:20:00',7.08),('10318','2014-04-03','15:25:00',7),('10318','2014-04-03','15:30:00',6.9),('10318','2014-04-03','15:35:00',6.77),('10318','2014-04-03','15:40:00',6.7),('10318','2014-04-03','15:45:00',6.6),('10318','2014-04-03','15:50:00',6.5),('10318','2014-04-03','15:55:00',6.26),('10318','2014-04-03','16:00:00',6.33),('10318','2014-04-03','16:05:00',6.05),('10318','2014-04-03','16:10:00',6.01),('10318','2014-04-03','16:15:00',5.7),('10318','2014-04-03','16:20:00',5.32),('10318','2014-04-03','16:25:00',5.37),('10318','2014-04-03','16:30:00',5.12),('10318','2014-04-03','16:35:00',4.92),('10318','2014-04-03','16:40:00',4.8),('10318','2014-04-03','16:45:00',4.5),('10318','2014-04-03','16:50:00',4.05),('10318','2014-04-03','16:55:00',3.37),('10318','2014-04-03','17:00:00',2.61),('10318','2014-04-03','17:05:00',2.26),('10318','2014-04-03','17:10:00',2.07),('10318','2014-04-03','17:15:00',2.11),('10318','2014-04-03','17:20:00',2.42),('10318','2014-04-03','17:25:00',2.36),('10318','2014-04-03','17:30:00',2.44),('10318','2014-04-03','17:35:00',1.63),('10318','2014-04-03','17:40:00',1.35),('10318','2014-04-03','17:45:00',1.81),('10318','2014-04-03','17:50:00',2.35),('10318','2014-04-03','17:55:00',2.07),('10318','2014-04-03','18:00:00',1.86),('10318','2014-04-03','18:05:00',1.67),('10318','2014-04-03','18:10:00',1.5),('10318','2014-04-03','18:15:00',1.33),('10318','2014-04-03','18:20:00',1.15),('10318','2013-06-10','07:05:00',1.12),('10318','2013-06-10','07:10:00',1.4),('10318','2013-06-10','07:15:00',1.16),('10318','2013-06-10','07:20:00',1.37),('10318','2013-06-10','07:25:00',2.6),('10318','2013-06-10','07:30:00',3.78),('10318','2013-06-10','07:35:00',3.79),('10318','2013-06-10','07:40:00',1.91),('10318','2013-06-10','07:45:00',1.53),('10318','2013-06-10','07:50:00',1.61),('10318','2013-06-10','07:55:00',1.82),('10318','2013-06-10','08:00:00',3.95),('10318','2013-06-10','08:05:00',4.28),('10318','2013-06-10','08:10:00',3.41),('10318','2013-06-10','08:15:00',4.04),('10318','2013-06-10','08:20:00',2.65),('10318','2013-06-10','08:25:00',5.49),('10318','2013-06-10','08:30:00',3.72),('10318','2013-06-10','08:35:00',2.17),('10318','2013-06-10','08:40:00',2.69),('10318','2013-06-10','08:45:00',2.01),('10318','2013-06-10','08:50:00',3.62),('10318','2013-06-10','08:55:00',3.78),('10318','2013-06-10','09:00:00',3.48),('10318','2013-06-10','09:05:00',3.03),('10318','2013-06-10','09:10:00',3.21),('10318','2013-06-10','09:15:00',5.83),('10318','2013-06-10','09:20:00',4.85),('10318','2013-06-10','09:25:00',7.36),('10318','2013-06-10','09:30:00',7.02),('10318','2013-06-10','09:35:00',5.32),('10318','2013-06-10','09:40:00',4.12),('10318','2013-06-10','09:45:00',7.53),('10318','2013-06-10','09:50:00',8.48),('10318','2013-06-10','09:55:00',4.22),('10318','2013-06-10','10:00:00',4.89),('10318','2013-06-10','10:05:00',6.82),('10318','2013-06-10','10:10:00',8.91),('10318','2013-06-10','10:15:00',7.29),('10318','2013-06-10','10:20:00',5.67),('10318','2013-06-10','10:25:00',3.34),('10318','2013-06-10','10:30:00',3.02),('10318','2013-06-10','10:35:00',3.76),('10318','2013-06-10','10:40:00',5.85),('10318','2013-06-10','10:45:00',4.83),('10318','2013-06-10','10:50:00',6.65),('10318','2013-06-10','10:55:00',4.77),('10318','2013-06-10','11:00:00',4.99),('10318','2013-06-10','11:05:00',8.95),('10318','2013-06-10','11:10:00',7.19),('10318','2013-06-10','11:15:00',6.11),('10318','2013-06-10','11:20:00',8.59),('10318','2013-06-10','11:25:00',10.48),('10318','2013-06-10','11:30:00',2.96),('10318','2013-06-10','11:35:00',3.5),('10318','2013-06-10','11:40:00',4.57),('10318','2013-06-10','11:45:00',2.85),('10318','2013-06-10','11:50:00',2.5),('10318','2013-06-10','11:55:00',7.06),('10318','2013-06-10','12:00:00',4.68),('10318','2013-06-10','12:05:00',3.02),('10318','2013-06-10','12:10:00',8.71),('10318','2013-06-10','12:15:00',10.58),('10318','2013-06-10','12:20:00',8.63),('10318','2013-06-10','12:25:00',7.2),('10318','2013-06-10','12:30:00',7.8),('10318','2013-06-10','12:35:00',10.12),('10318','2013-06-10','12:40:00',8.15),('10318','2013-06-10','12:45:00',10.79),('10318','2013-06-10','12:50:00',6.84),('10318','2013-06-10','12:55:00',5.11),('10318','2013-06-10','13:00:00',7.6),('10318','2013-06-10','13:05:00',7.94),('10318','2013-06-10','13:10:00',5.53),('10318','2013-06-10','13:15:00',6),('10318','2013-06-10','13:20:00',3.13),('10318','2013-06-10','13:25:00',8.76),('10318','2013-06-10','13:30:00',10.42),('10318','2013-06-10','13:35:00',10.16),('10318','2013-06-10','13:40:00',8.76),('10318','2013-06-10','13:45:00',4.8),('10318','2013-06-10','13:50:00',4.09),('10318','2013-06-10','13:55:00',8.78),('10318','2013-06-10','14:00:00',4.87),('10318','2013-06-10','14:05:00',3.85),('10318','2013-06-10','14:10:00',9.42),('10318','2013-06-10','14:15:00',9.59),('10318','2013-06-10','14:20:00',9.14),('10318','2013-06-10','14:25:00',9.19),('10318','2013-06-10','14:30:00',8.88),('10318','2013-06-10','14:35:00',9.06),('10318','2013-06-10','14:40:00',8.83),('10318','2013-06-10','14:45:00',8.78),('10318','2013-06-10','14:50:00',8.42),('10318','2013-06-10','14:55:00',8.56),('10318','2013-06-10','15:00:00',8.44),('10318','2013-06-10','15:05:00',8.34),('10318','2013-06-10','15:10:00',8.22),('10318','2013-06-10','15:15:00',8.05),('10318','2013-06-10','15:20:00',8.07),('10318','2013-06-10','15:25:00',7.94),('10318','2013-06-10','15:30:00',7.85),('10318','2013-06-10','15:35:00',7.69),('10318','2013-06-10','15:40:00',7.61),('10318','2013-06-10','15:45:00',7.46),('10318','2013-06-10','15:50:00',7.32),('10318','2013-06-10','15:55:00',7.17),('10318','2013-06-10','16:00:00',7),('10318','2013-06-10','16:05:00',6.84),('10318','2013-06-10','16:10:00',6.74),('10318','2013-06-10','16:15:00',6.58),('10318','2013-06-10','16:20:00',6.38),('10318','2013-06-10','16:25:00',6.23),('10318','2013-06-10','16:30:00',6.06),('10318','2013-06-10','16:35:00',5.76),('10318','2013-06-10','16:40:00',5.73),('10318','2013-06-10','16:45:00',5.54),('10318','2013-06-10','16:50:00',5.37),('10318','2013-06-10','16:55:00',5.18),('10318','2013-06-10','17:00:00',5.05),('10318','2013-06-10','17:05:00',4.84),('10318','2013-06-10','17:10:00',4.65),('10318','2013-06-10','17:15:00',4.46),('10318','2013-06-10','17:20:00',4.26),('10318','2013-06-10','17:25:00',4.11),('10318','2013-06-10','17:30:00',3.91),('10318','2013-06-10','17:35:00',3.71),('10318','2013-06-10','17:40:00',3.51),('10318','2013-06-10','17:45:00',3.31),('10318','2013-06-10','17:50:00',3.07),('10318','2013-06-10','17:55:00',2.94),('10318','2013-06-10','18:00:00',2.73),('10318','2013-06-10','18:05:00',2.54),('10318','2013-06-10','18:10:00',2.38),('10318','2013-06-10','18:15:00',2.17),('10318','2013-06-10','18:20:00',1.97),('10318','2013-06-10','18:25:00',1.83),('10318','2013-06-10','18:30:00',1.66),('10318','2013-06-10','18:35:00',1.5),('10318','2013-06-10','18:40:00',1.34),('10318','2013-06-10','18:45:00',1.18),('10318','2013-06-10','18:50:00',1.04),('10318','2013-06-09','07:10:00',1.17),('10318','2013-06-09','07:15:00',1.08),('10318','2013-06-09','07:20:00',1.07),('10318','2013-06-09','07:25:00',1.71),('10318','2013-06-09','07:30:00',1.86),('10318','2013-06-09','07:35:00',3.02),('10318','2013-06-09','07:40:00',1.92),('10318','2013-06-09','07:45:00',1.33),('10318','2013-06-09','07:50:00',3.4),('10318','2013-06-09','07:55:00',3.36),('10318','2013-06-09','08:00:00',4.19),('10318','2013-06-09','08:05:00',4.25),('10318','2013-06-09','08:10:00',3.45),('10318','2013-06-09','08:15:00',4.09),('10318','2013-06-09','08:20:00',4.88),('10318','2013-06-09','08:25:00',4.84),('10318','2013-06-09','08:30:00',4.69),('10318','2013-06-09','08:35:00',4.54),('10318','2013-06-09','08:40:00',5.17),('10318','2013-06-09','08:45:00',5.51),('10318','2013-06-09','08:50:00',5.65),('10318','2013-06-09','08:55:00',5.87),('10318','2013-06-09','09:00:00',6.1),('10318','2013-06-09','09:05:00',6.32),('10318','2013-06-09','09:10:00',6.44),('10318','2013-06-09','09:15:00',6.5),('10318','2013-06-09','09:20:00',6.61),('10318','2013-06-09','09:25:00',6.79),('10318','2013-06-09','09:30:00',6.93),('10318','2013-06-09','09:35:00',6.98),('10318','2013-06-09','09:40:00',7.11),('10318','2013-06-09','09:45:00',7.29),('10318','2013-06-09','09:50:00',7.4),('10318','2013-06-09','09:55:00',7.54),('10318','2013-06-09','10:00:00',7.62),('10318','2013-06-09','10:05:00',7.71),('10318','2013-06-09','10:10:00',7.8),('10318','2013-06-09','10:15:00',7.89),('10318','2013-06-09','10:20:00',8.07),('10318','2013-06-09','10:25:00',8.14),('10318','2013-06-09','10:30:00',8.22),('10318','2013-06-09','10:35:00',8.22),('10318','2013-06-09','10:40:00',8.29),('10318','2013-06-09','10:45:00',8.4),('10318','2013-06-09','10:50:00',8.37),('10318','2013-06-09','10:55:00',8.5),('10318','2013-06-09','11:00:00',8.58),('10318','2013-06-09','11:05:00',8.63),('10318','2013-06-09','11:10:00',8.69),('10318','2013-06-09','11:15:00',8.69),('10318','2013-06-09','11:20:00',8.68),('10318','2013-06-09','11:25:00',8.67),('10318','2013-06-09','11:30:00',8.71),('10318','2013-06-09','11:35:00',8.79),('10318','2013-06-09','11:40:00',8.94),('10318','2013-06-09','11:45:00',8.86),('10318','2013-06-09','11:50:00',8.69),('10318','2013-06-09','11:55:00',8.8),('10318','2013-06-09','12:00:00',8.88),('10318','2013-06-09','12:05:00',9.13),('10318','2013-06-09','12:10:00',8.75),('10318','2013-06-09','12:15:00',9.13),('10318','2013-06-09','12:20:00',9.1),('10318','2013-06-09','12:25:00',8.76),('10318','2013-06-09','12:30:00',8.99),('10318','2013-06-09','12:35:00',9.05),('10318','2013-06-09','12:40:00',9.26),('10318','2013-06-09','12:45:00',7.47),('10318','2013-06-09','12:50:00',6.46),('10318','2013-06-09','12:55:00',9.63),('10318','2013-06-09','13:00:00',8.96),('10318','2013-06-09','13:05:00',9.2),('10318','2013-06-09','13:10:00',7.87),('10318','2013-06-09','13:15:00',8.91),('10318','2013-06-09','13:20:00',8.98),('10318','2013-06-09','13:25:00',5.26),('10318','2013-06-09','13:30:00',8.18),('10318','2013-06-09','13:35:00',9.05),('10318','2013-06-09','13:40:00',8.03),('10318','2013-06-09','13:45:00',9.33),('10318','2013-06-09','13:50:00',6.89),('10318','2013-06-09','13:55:00',7.27),('10318','2013-06-09','14:00:00',9.2),('10318','2013-06-09','14:05:00',8.78),('10318','2013-06-09','14:10:00',8.58),('10318','2013-06-09','14:15:00',8.95),('10318','2013-06-09','14:20:00',3.05),('10318','2013-06-09','14:25:00',2.39),('10318','2013-06-09','14:30:00',3.38),('10318','2013-06-09','14:35:00',8.14),('10318','2013-06-09','14:40:00',7.21),('10318','2013-06-09','14:45:00',8.71),('10318','2013-06-09','14:50:00',8.81),('10318','2013-06-09','14:55:00',8.54),('10318','2013-06-09','15:00:00',8.27),('10318','2013-06-09','15:05:00',8.12),('10318','2013-06-09','15:10:00',7.84),('10318','2013-06-09','15:15:00',7.7),('10318','2013-06-09','15:20:00',7.45),('10318','2013-06-09','15:25:00',7.65),('10318','2013-06-09','15:30:00',7.45),('10318','2013-06-09','15:35:00',7.68),('10318','2013-06-09','15:40:00',5.67),('10318','2013-06-09','15:45:00',5.92),('10318','2013-06-09','15:50:00',6.59),('10318','2013-06-09','15:55:00',7.35),('10318','2013-06-09','16:00:00',6.57),('10318','2013-06-09','16:05:00',6.08),('10318','2013-06-09','16:10:00',5.35),('10318','2013-06-09','16:15:00',5.61),('10318','2013-06-09','16:20:00',3.99),('10318','2013-06-09','16:25:00',4.95),('10318','2013-06-09','16:30:00',2.32),('10318','2013-06-09','16:35:00',2.09),('10318','2013-06-09','16:40:00',2.05),('10318','2013-06-09','16:45:00',2.07),('10318','2013-06-09','16:50:00',1.93),('10318','2013-06-09','16:55:00',1.84),('10318','2013-06-09','17:00:00',2),('10318','2013-06-09','17:05:00',2.06),('10318','2013-06-09','17:10:00',1.97),('10318','2013-06-09','17:15:00',1.66),('10318','2013-06-09','17:20:00',1.73),('10318','2013-06-09','17:25:00',1.36),('10318','2013-06-09','17:30:00',1.21),('10318','2013-06-09','17:35:00',1.38),('10318','2013-06-09','17:40:00',1.62),('10318','2013-06-09','17:45:00',1.54),('10318','2013-06-09','17:50:00',1.04),('10318','2013-06-09','17:55:00',1.23),('10318','2013-06-09','18:00:00',2.11),('10318','2013-06-09','18:05:00',1.85),('10318','2013-06-09','18:10:00',2.04),('10318','2013-06-09','18:15:00',1.21),('10318','2013-06-09','18:30:00',1.23),('10318','2013-06-09','18:35:00',1),('10318','2013-06-09','18:40:00',1.07),('10318','2013-06-09','18:45:00',1.17),('10318','2013-06-09','18:50:00',1.14),('10318','2013-06-08','06:50:00',1.07),('10318','2013-06-08','06:55:00',1.38),('10318','2013-06-08','07:00:00',1.65),('10318','2013-06-08','07:05:00',1.78),('10318','2013-06-08','07:10:00',1.84),('10318','2013-06-08','07:15:00',2.31),('10318','2013-06-08','07:20:00',2.59),('10318','2013-06-08','07:25:00',2.76),('10318','2013-06-08','07:30:00',2.89),('10318','2013-06-08','07:35:00',3.17),('10318','2013-06-08','07:40:00',3.32),('10318','2013-06-08','07:45:00',3.49),('10318','2013-06-08','07:50:00',3.69),('10318','2013-06-08','07:55:00',3.93),('10318','2013-06-08','08:00:00',4.14),('10318','2013-06-08','08:05:00',4.33),('10318','2013-06-08','08:10:00',4.5),('10318','2013-06-08','08:15:00',4.67),('10318','2013-06-08','08:20:00',4.86),('10318','2013-06-08','08:25:00',5.02),('10318','2013-06-08','08:30:00',5.17),('10318','2013-06-08','08:35:00',5.36),('10318','2013-06-08','08:40:00',5.55),('10318','2013-06-08','08:45:00',5.73),('10318','2013-06-08','08:50:00',5.89),('10318','2013-06-08','08:55:00',6.06),('10318','2013-06-08','09:00:00',6.16),('10318','2013-06-08','09:05:00',6.21),('10318','2013-06-08','09:10:00',6.47),('10318','2013-06-08','09:15:00',6.6),('10318','2013-06-08','09:20:00',6.8),('10318','2013-06-08','09:25:00',6.91),('10318','2013-06-08','09:30:00',7.04),('10318','2013-06-08','09:35:00',7.16),('10318','2013-06-08','09:40:00',7.24),('10318','2013-06-08','09:45:00',7.38),('10318','2013-06-08','09:50:00',7.5),('10318','2013-06-08','09:55:00',7.68),('10318','2013-06-08','10:00:00',7.81),('10318','2013-06-08','10:05:00',8.03),('10318','2013-06-08','10:10:00',8.2),('10318','2013-06-08','10:15:00',8.4),('10318','2013-06-08','10:20:00',8.82),('10318','2013-06-08','10:25:00',9.28),('10318','2013-06-08','10:30:00',8.83),('10318','2013-06-08','10:35:00',7.36),('10318','2013-06-08','10:40:00',4.61),('10318','2013-06-08','10:45:00',9.11),('10318','2013-06-08','10:50:00',9.58),('10318','2013-06-08','10:55:00',9.33),('10318','2013-06-08','11:00:00',6.84),('10318','2013-06-08','11:05:00',7.69),('10318','2013-06-08','11:10:00',6.25),('10318','2013-06-08','11:15:00',3.29),('10318','2013-06-08','11:20:00',7.73),('10318','2013-06-08','11:25:00',9.26),('10318','2013-06-08','11:30:00',5.65),('10318','2013-06-08','11:35:00',9.45),('10318','2013-06-08','11:40:00',8.34),('10318','2013-06-08','11:45:00',9.46),('10318','2013-06-08','11:50:00',10.05),('10318','2013-06-08','11:55:00',6.47),('10318','2013-06-08','12:00:00',10.09),('10318','2013-06-08','12:05:00',6.75),('10318','2013-06-08','12:10:00',5.39),('10318','2013-06-08','12:15:00',5.86),('10318','2013-06-08','12:20:00',6.16),('10318','2013-06-08','12:25:00',3.48),('10318','2013-06-08','12:30:00',9.6),('10318','2013-06-08','12:35:00',8.32),('10318','2013-06-08','12:40:00',8.56),('10318','2013-06-08','12:45:00',9.7),('10318','2013-06-08','12:50:00',9.81),('10318','2013-06-08','12:55:00',9.86),('10318','2013-06-08','13:00:00',9.55),('10318','2013-06-08','13:05:00',9.65),('10318','2013-06-08','13:10:00',9.58),('10318','2013-06-08','13:15:00',9.4),('10318','2013-06-08','13:20:00',9.6),('10318','2013-06-08','13:25:00',9.52),('10318','2013-06-08','13:30:00',4.93),('10318','2013-06-08','13:35:00',9.35),('10318','2013-06-08','13:40:00',9.57),('10318','2013-06-08','13:45:00',9.38),('10318','2013-06-08','13:50:00',9.26),('10318','2013-06-08','13:55:00',9.25),('10318','2013-06-08','14:00:00',8.99),('10318','2013-06-08','14:05:00',9.2),('10318','2013-06-08','14:10:00',9.1),('10318','2013-06-08','14:15:00',9.03),('10318','2013-06-08','14:20:00',8.96),('10318','2013-06-08','14:25:00',8.94),('10318','2013-06-08','14:30:00',8.81),('10318','2013-06-08','14:35:00',8.77),('10318','2013-06-08','14:40:00',8.61),('10318','2013-06-08','14:45:00',8.52),('10318','2013-06-08','14:50:00',8.51),('10318','2013-06-08','14:55:00',8.45),('10318','2013-06-08','15:00:00',8.27),('10318','2013-06-08','15:05:00',8.03),('10318','2013-06-08','15:10:00',7.34),('10318','2013-06-08','15:15:00',7.99),('10318','2013-06-08','15:20:00',8.08),('10318','2013-06-08','15:25:00',7.35),('10318','2013-06-08','15:30:00',7.81),('10318','2013-06-08','15:35:00',7.84),('10318','2013-06-08','15:40:00',7.49),('10318','2013-06-08','15:45:00',7.65),('10318','2013-06-08','15:50:00',7.57),('10318','2013-06-08','15:55:00',6.98),('10318','2013-06-08','16:00:00',7),('10318','2013-06-08','16:05:00',6.82),('10318','2013-06-08','16:10:00',6.88),('10318','2013-06-08','16:15:00',6.82),('10318','2013-06-08','16:20:00',6.63),('10318','2013-06-08','16:25:00',6.24),('10318','2013-06-08','16:30:00',5.95),('10318','2013-06-08','16:35:00',5.76),('10318','2013-06-08','16:40:00',5.56),('10318','2013-06-08','16:45:00',5.28),('10318','2013-06-08','16:50:00',4.33),('10318','2013-06-08','16:55:00',4.91),('10318','2013-06-08','17:00:00',4.58),('10318','2013-06-08','17:05:00',4.65),('10318','2013-06-08','17:10:00',5.13),('10318','2013-06-08','17:15:00',4.89),('10318','2013-06-08','17:20:00',4.48),('10318','2013-06-08','17:25:00',3.7),('10318','2013-06-08','17:30:00',2.39),('10318','2013-06-08','17:35:00',2.2),('10318','2013-06-08','17:40:00',3.84),('10318','2013-06-08','17:45:00',3.27),('10318','2013-06-08','17:50:00',3.48),('10318','2013-06-08','17:55:00',3.11),('10318','2013-06-08','18:00:00',2.51),('10318','2013-06-08','18:05:00',2.26),('10318','2013-06-08','18:10:00',1.96),('10318','2013-06-08','18:15:00',1.98),('10318','2013-06-08','18:20:00',1.8),('10318','2013-06-08','18:25:00',1.54),('10318','2013-06-08','18:30:00',1.19),('10318','2013-06-08','18:35:00',1.05),('10318','2013-06-07','06:50:00',1.09),('10318','2013-06-07','06:55:00',1.39),('10318','2013-06-07','07:00:00',1.63),('10318','2013-06-07','07:05:00',1.79),('10318','2013-06-07','07:10:00',1.84),('10318','2013-06-07','07:15:00',2.41),('10318','2013-06-07','07:20:00',2.71),('10318','2013-06-07','07:25:00',2.91),('10318','2013-06-07','07:30:00',3.1),('10318','2013-06-07','07:35:00',3.31),('10318','2013-06-07','07:40:00',3.53),('10318','2013-06-07','07:45:00',3.74),('10318','2013-06-07','07:50:00',3.94),('10318','2013-06-07','07:55:00',4.13),('10318','2013-06-07','08:00:00',4.24),('10318','2013-06-07','08:05:00',4.51),('10318','2013-06-07','08:10:00',4.7),('10318','2013-06-07','08:15:00',4.88),('10318','2013-06-07','08:20:00',5.07),('10318','2013-06-07','08:25:00',5.25),('10318','2013-06-07','08:30:00',5.44),('10318','2013-06-07','08:35:00',5.62),('10318','2013-06-07','08:40:00',5.8),('10318','2013-06-07','08:45:00',5.97),('10318','2013-06-07','08:50:00',6.15),('10318','2013-06-07','08:55:00',6.3),('10318','2013-06-07','09:00:00',6.44),('10318','2013-06-07','09:05:00',6.56),('10318','2013-06-07','09:10:00',6.69),('10318','2013-06-07','09:15:00',6.87),('10318','2013-06-07','09:20:00',7),('10318','2013-06-07','09:25:00',7.14),('10318','2013-06-07','09:30:00',7.28),('10318','2013-06-07','09:35:00',7.41),('10318','2013-06-07','09:40:00',7.55),('10318','2013-06-07','09:45:00',7.48),('10318','2013-06-07','09:50:00',7.8),('10318','2013-06-07','09:55:00',7.93),('10318','2013-06-07','10:00:00',8.06),('10318','2013-06-07','10:05:00',8.16),('10318','2013-06-07','10:10:00',8.26),('10318','2013-06-07','10:15:00',8.35),('10318','2013-06-07','10:20:00',8.45),('10318','2013-06-07','10:25:00',8.55),('10318','2013-06-07','10:30:00',8.6),('10318','2013-06-07','10:35:00',8.7),('10318','2013-06-07','10:40:00',8.74),('10318','2013-06-07','10:45:00',8.79),('10318','2013-06-07','10:50:00',8.89),('10318','2013-06-07','10:55:00',9.03),('10318','2013-06-07','11:00:00',9.11),('10318','2013-06-07','11:05:00',9.22),('10318','2013-06-07','11:10:00',9.31),('10318','2013-06-07','11:15:00',9.35),('10318','2013-06-07','11:20:00',9.33),('10318','2013-06-07','11:25:00',9.36),('10318','2013-06-07','11:30:00',9.29),('10318','2013-06-07','11:35:00',9.49),('10318','2013-06-07','11:40:00',9.5),('10318','2013-06-07','11:45:00',9.58),('10318','2013-06-07','11:50:00',9.62),('10318','2013-06-07','11:55:00',9.62),('10318','2013-06-07','12:00:00',9.62),('10318','2013-06-07','12:05:00',9.64),('10318','2013-06-07','12:10:00',9.67),('10318','2013-06-07','12:15:00',9.69),('10318','2013-06-07','12:20:00',9.68),('10318','2013-06-07','12:25:00',9.65),('10318','2013-06-07','12:30:00',9.68),('10318','2013-06-07','12:35:00',9.62),('10318','2013-06-07','12:40:00',9.58),('10318','2013-06-07','12:45:00',9.58),('10318','2013-06-07','12:50:00',9.59),('10318','2013-06-07','12:55:00',9.49),('10318','2013-06-07','13:00:00',9.47),('10318','2013-06-07','13:05:00',9.47),('10318','2013-06-07','13:10:00',9.43),('10318','2013-06-07','13:15:00',9.27),('10318','2013-06-07','13:20:00',9.44),('10318','2013-06-07','13:25:00',9.42),('10318','2013-06-07','13:30:00',9.25),('10318','2013-06-07','13:35:00',9.17),('10318','2013-06-07','13:40:00',9.2),('10318','2013-06-07','13:45:00',9.16),('10318','2013-06-07','13:50:00',9.05),('10318','2013-06-07','13:55:00',8.89),('10318','2013-06-07','14:00:00',8.9),('10318','2013-06-07','14:05:00',8.88),('10318','2013-06-07','14:10:00',7.53),('10318','2013-06-07','14:15:00',8.08),('10318','2013-06-07','14:20:00',8.65),('10318','2013-06-07','14:25:00',8.6),('10318','2013-06-07','14:30:00',8.6),('10318','2013-06-07','14:35:00',6.39),('10318','2013-06-07','14:40:00',8.37),('10318','2013-06-07','14:45:00',8.31),('10318','2013-06-07','14:50:00',8.11),('10318','2013-06-07','14:55:00',7.53),('10318','2013-06-07','15:00:00',2.11),('10318','2013-06-07','15:05:00',8.23),('10318','2013-06-07','15:10:00',8.11),('10318','2013-06-07','15:15:00',7.3),('10318','2013-06-07','15:20:00',7.76),('10318','2013-06-07','15:25:00',7.7),('10318','2013-06-07','15:30:00',7.6),('10318','2013-06-07','15:35:00',7.38),('10318','2013-06-07','15:40:00',7.21),('10318','2013-06-07','15:45:00',7.1),('10318','2013-06-07','15:50:00',6.96),('10318','2013-06-07','15:55:00',6.9),('10318','2013-06-07','16:00:00',6.76),('10318','2013-06-07','16:05:00',6.63),('10318','2013-06-07','16:10:00',6.62),('10318','2013-06-07','16:15:00',6.46),('10318','2013-06-07','16:20:00',6.16),('10318','2013-06-07','16:25:00',5.89),('10318','2013-06-07','16:30:00',5.67),('10318','2013-06-07','16:35:00',5.42),('10318','2013-06-07','16:40:00',5.53),('10318','2013-06-07','16:45:00',5.38),('10318','2013-06-07','16:50:00',5.2),('10318','2013-06-07','16:55:00',4.99),('10318','2013-06-07','17:00:00',4.79),('10318','2013-06-07','17:05:00',4.63),('10318','2013-06-07','17:10:00',4.44),('10318','2013-06-07','17:15:00',4.32),('10318','2013-06-07','17:20:00',4.12),('10318','2013-06-07','17:25:00',3.96),('10318','2013-06-07','17:30:00',3.81),('10318','2013-06-07','17:35:00',3.7),('10318','2013-06-07','17:40:00',3.57),('10318','2013-06-07','17:45:00',3.47),('10318','2013-06-07','17:50:00',3.14),('10318','2013-06-07','17:55:00',2.54),('10318','2013-06-07','18:00:00',2.74),('10318','2013-06-07','18:05:00',2.65),('10318','2013-06-07','18:10:00',2.41),('10318','2013-06-07','18:15:00',2.21),('10318','2013-06-07','18:20:00',2.02),('10318','2013-06-07','18:25:00',1.76),('10318','2013-06-07','18:30:00',1.62),('10318','2013-06-07','18:35:00',1.5),('10318','2013-06-07','18:40:00',1.33),('10318','2013-06-07','18:45:00',1.21),('10318','2013-06-07','18:50:00',1.1),('10318','2013-06-06','06:55:00',1.56),('10318','2013-06-06','07:00:00',2.28),('10318','2013-06-06','07:05:00',2.51),('10318','2013-06-06','07:10:00',2.54),('10318','2013-06-06','07:15:00',2.24),('10318','2013-06-06','07:20:00',2.03),('10318','2013-06-06','07:25:00',1.43),('10318','2013-06-06','07:30:00',1.47),('10318','2013-06-06','07:35:00',1.49),('10318','2013-06-06','07:40:00',1.93),('10318','2013-06-06','07:45:00',2.24),('10318','2013-06-06','07:50:00',4.05),('10318','2013-06-06','07:55:00',4.17),('10318','2013-06-06','08:00:00',4.08),('10318','2013-06-06','08:05:00',3.21),('10318','2013-06-06','08:10:00',3.92),('10318','2013-06-06','08:15:00',3.45),('10318','2013-06-06','08:20:00',4.85),('10318','2013-06-06','08:25:00',5.21),('10318','2013-06-06','08:30:00',5.31),('10318','2013-06-06','08:35:00',5.61),('10318','2013-06-06','08:40:00',5.69),('10318','2013-06-06','08:45:00',5.82),('10318','2013-06-06','08:50:00',6.06),('10318','2013-06-06','08:55:00',6.23),('10318','2013-06-06','09:00:00',6.35),('10318','2013-06-06','09:05:00',6.52),('10318','2013-06-06','09:10:00',6.72),('10318','2013-06-06','09:15:00',6.82),('10318','2013-06-06','09:20:00',6.99),('10318','2013-06-06','09:25:00',7.16),('10318','2013-06-06','09:30:00',7.3),('10318','2013-06-06','09:35:00',7.44),('10318','2013-06-06','09:40:00',7.58),('10318','2013-06-06','09:45:00',7.73),('10318','2013-06-06','09:50:00',7.81),('10318','2013-06-06','09:55:00',7.92),('10318','2013-06-06','10:00:00',7.93),('10318','2013-06-06','10:05:00',8.11),('10318','2013-06-06','10:10:00',8.22),('10318','2013-06-06','10:15:00',8.11),('10318','2013-06-06','10:20:00',8.42),('10318','2013-06-06','10:25:00',8.49),('10318','2013-06-06','10:30:00',8.56),('10318','2013-06-06','10:35:00',8.63),('10318','2013-06-06','10:40:00',8.68),('10318','2013-06-06','10:45:00',8.69),('10318','2013-06-06','10:50:00',8.76),('10318','2013-06-06','10:55:00',8.93),('10318','2013-06-06','11:00:00',8.89),('10318','2013-06-06','11:05:00',9.1),('10318','2013-06-06','11:10:00',9.15),('10318','2013-06-06','11:15:00',9.18),('10318','2013-06-06','11:20:00',9.16),('10318','2013-06-06','11:25:00',9.23),('10318','2013-06-06','11:30:00',9.27),('10318','2013-06-06','11:35:00',9.36),('10318','2013-06-06','11:40:00',9.37),('10318','2013-06-06','11:45:00',9.2),('10318','2013-06-06','11:50:00',9.18),('10318','2013-06-06','11:55:00',8.86),('10318','2013-06-06','12:00:00',9.36),('10318','2013-06-06','12:05:00',6.67),('10318','2013-06-06','12:10:00',2.59),('10318','2013-06-06','12:15:00',7.16),('10318','2013-06-06','12:20:00',9.58),('10318','2013-06-06','12:25:00',9.6),('10318','2013-06-06','12:30:00',9.42),('10318','2013-06-06','12:35:00',9.47),('10318','2013-06-06','12:40:00',9.51),('10318','2013-06-06','12:45:00',9.43),('10318','2013-06-06','12:50:00',9.66),('10318','2013-06-06','12:55:00',10),('10318','2013-06-06','13:00:00',5.19),('10318','2013-06-06','13:05:00',3.31),('10318','2013-06-06','13:10:00',4.31),('10318','2013-06-06','13:15:00',9.99),('10318','2013-06-06','13:20:00',9.8),('10318','2013-06-06','13:25:00',9.66),('10318','2013-06-06','13:30:00',9.53),('10318','2013-06-06','13:35:00',9.62),('10318','2013-06-06','13:40:00',9.95),('10318','2013-06-06','13:45:00',9.39),('10318','2013-06-06','13:50:00',7.15),('10318','2013-06-06','13:55:00',9.22),('10318','2013-06-06','14:00:00',9.09),('10318','2013-06-06','14:05:00',9.04),('10318','2013-06-06','14:10:00',9.01),('10318','2013-06-06','14:15:00',8.88),('10318','2013-06-06','14:20:00',8.66),('10318','2013-06-06','14:25:00',7.45),('10318','2013-06-06','14:30:00',7.53),('10318','2013-06-06','14:35:00',6.45),('10318','2013-06-06','14:40:00',8.41),('10318','2013-06-06','14:45:00',8.4),('10318','2013-06-06','14:50:00',8.55),('10318','2013-06-06','14:55:00',8.29),('10318','2013-06-06','15:00:00',8.09),('10318','2013-06-06','15:05:00',8.06),('10318','2013-06-06','15:10:00',8.01),('10318','2013-06-06','15:15:00',7.69),('10318','2013-06-06','15:20:00',7.67),('10318','2013-06-06','15:25:00',7.66),('10318','2013-06-06','15:30:00',7.34),('10318','2013-06-06','15:35:00',7.23),('10318','2013-06-06','15:40:00',6.99),('10318','2013-06-06','15:45:00',6.88),('10318','2013-06-06','15:50:00',6.89),('10318','2013-06-06','15:55:00',6.87),('10318','2013-06-06','16:00:00',6.66),('10318','2013-06-06','16:05:00',6.55),('10318','2013-06-06','16:10:00',6.24),('10318','2013-06-06','16:15:00',6.2),('10318','2013-06-06','16:20:00',6.02),('10318','2013-06-06','16:25:00',5.89),('10318','2013-06-06','16:30:00',5.77),('10318','2013-06-06','16:35:00',5.65),('10318','2013-06-06','16:40:00',5.51),('10318','2013-06-06','16:45:00',5.29),('10318','2013-06-06','16:50:00',5.07),('10318','2013-06-06','16:55:00',4.86),('10318','2013-06-06','17:00:00',4.67),('10318','2013-06-06','17:05:00',4.52),('10318','2013-06-06','17:10:00',4.34),('10318','2013-06-06','17:15:00',4.16),('10318','2013-06-06','17:20:00',3.98),('10318','2013-06-06','17:25:00',3.86),('10318','2013-06-06','17:30:00',3.68),('10318','2013-06-06','17:35:00',3.4),('10318','2013-06-06','17:40:00',3.3),('10318','2013-06-06','17:45:00',3.13),('10318','2013-06-06','17:50:00',2.94),('10318','2013-06-06','17:55:00',2.78),('10318','2013-06-06','18:00:00',2.57),('10318','2013-06-06','18:05:00',2.41),('10318','2013-06-06','18:10:00',2.26),('10318','2013-06-06','18:15:00',2.11),('10318','2013-06-06','18:20:00',1.96),('10318','2013-06-06','18:25:00',1.8),('10318','2013-06-06','18:30:00',1.65),('10318','2013-06-06','18:35:00',1.47),('10318','2013-06-06','18:40:00',1.36),('10318','2013-06-06','18:45:00',1.22),('10318','2013-06-06','18:50:00',1.1),('10318','2013-06-06','18:55:00',1.01),('10318','2013-06-05','06:55:00',1),('10318','2013-06-05','07:00:00',1.23),('10318','2013-06-05','07:05:00',1.49),('10318','2013-06-05','07:10:00',1.69),('10318','2013-06-05','07:15:00',1.79),('10318','2013-06-05','07:20:00',1.35),('10318','2013-06-05','07:25:00',1.03),('10318','2013-06-05','07:30:00',1.39),('10318','2013-06-05','07:35:00',3.12),('10318','2013-06-05','07:40:00',2.34),('10318','2013-06-05','07:45:00',3.58),('10318','2013-06-05','07:50:00',4.78),('10318','2013-06-05','07:55:00',4.61),('10318','2013-06-05','08:00:00',4.4),('10318','2013-06-05','08:05:00',4.36),('10318','2013-06-05','08:10:00',4.61),('10318','2013-06-05','08:15:00',4.78),('10318','2013-06-05','08:20:00',5.03),('10318','2013-06-05','08:25:00',5.21),('10318','2013-06-05','08:30:00',5.29),('10318','2013-06-05','08:35:00',5.52),('10318','2013-06-05','08:40:00',5.73),('10318','2013-06-05','08:45:00',5.89),('10318','2013-06-05','08:50:00',6.09),('10318','2013-06-05','08:55:00',6.33),('10318','2013-06-05','09:00:00',6.43),('10318','2013-06-05','09:05:00',6.73),('10318','2013-06-05','09:10:00',7.07),('10318','2013-06-05','09:15:00',7.23),('10318','2013-06-05','09:20:00',7.5),('10318','2013-06-05','09:25:00',7.72),('10318','2013-06-05','09:30:00',8.41),('10318','2013-06-05','09:35:00',7.81),('10318','2013-06-05','09:40:00',8.52),('10318','2013-06-05','09:45:00',8.03),('10318','2013-06-05','09:50:00',2.63),('10318','2013-06-05','09:55:00',3.15),('10318','2013-06-05','10:00:00',3.57),('10318','2013-06-05','10:05:00',2.82),('10318','2013-06-05','10:10:00',2.98),('10318','2013-06-05','10:15:00',6.65),('10318','2013-06-05','10:20:00',4.4),('10318','2013-06-05','10:25:00',5.07),('10318','2013-06-05','10:30:00',4.53),('10318','2013-06-05','10:35:00',8.99),('10318','2013-06-05','10:40:00',9.93),('10318','2013-06-05','10:45:00',9.86),('10318','2013-06-05','10:50:00',9.56),('10318','2013-06-05','10:55:00',9.73),('10318','2013-06-05','11:00:00',9.87),('10318','2013-06-05','11:05:00',9.06),('10318','2013-06-05','11:10:00',10.19),('10318','2013-06-05','11:15:00',10.18),('10318','2013-06-05','11:20:00',9.55),('10318','2013-06-05','11:25:00',10.62),('10318','2013-06-05','11:30:00',8.36),('10318','2013-06-05','11:35:00',8.59),('10318','2013-06-05','11:40:00',8.38),('10318','2013-06-05','11:45:00',4.29),('10318','2013-06-05','11:50:00',10.73),('10318','2013-06-05','11:55:00',10.32),('10318','2013-06-05','12:00:00',10.6),('10318','2013-06-05','12:05:00',10.6),('10318','2013-06-05','12:10:00',10.66),('10318','2013-06-05','12:15:00',3.98),('10318','2013-06-05','12:20:00',3.55),('10318','2013-06-05','12:25:00',5.16),('10318','2013-06-05','12:30:00',9.63),('10318','2013-06-05','12:35:00',4.16),('10318','2013-06-05','12:40:00',9.88),('10318','2013-06-05','12:45:00',8.43),('10318','2013-06-05','12:50:00',8.99),('10318','2013-06-05','12:55:00',7.08),('10318','2013-06-05','13:00:00',4.36),('10318','2013-06-05','13:05:00',7.25),('10318','2013-06-05','13:10:00',10.5),('10318','2013-06-05','13:15:00',10.8),('10318','2013-06-05','13:20:00',10.62),('10318','2013-06-05','13:25:00',8.04),('10318','2013-06-05','13:30:00',9.89),('10318','2013-06-05','13:35:00',8.84),('10318','2013-06-05','13:40:00',10.17),('10318','2013-06-05','13:45:00',10.01),('10318','2013-06-05','13:50:00',9.73),('10318','2013-06-05','13:55:00',9.42),('10318','2013-06-05','14:00:00',9.61),('10318','2013-06-05','14:05:00',9.57),('10318','2013-06-05','14:10:00',9.46),('10318','2013-06-05','14:15:00',9.31),('10318','2013-06-05','14:20:00',7.23),('10318','2013-06-05','14:25:00',6.86),('10318','2013-06-05','14:30:00',9.04),('10318','2013-06-05','14:35:00',8.96),('10318','2013-06-05','14:40:00',6.95),('10318','2013-06-05','14:45:00',8.91),('10318','2013-06-05','14:50:00',8.69),('10318','2013-06-05','14:55:00',8.56),('10318','2013-06-05','15:00:00',8.44),('10318','2013-06-05','15:05:00',8.31),('10318','2013-06-05','15:10:00',8.24),('10318','2013-06-05','15:15:00',8.22),('10318','2013-06-05','15:20:00',6.05),('10318','2013-06-05','15:25:00',8.76),('10318','2013-06-05','15:30:00',7.82),('10318','2013-06-05','15:35:00',4.55),('10318','2013-06-05','15:40:00',6.88),('10318','2013-06-05','15:45:00',7.38),('10318','2013-06-05','15:50:00',7.29),('10318','2013-06-05','15:55:00',5.36),('10318','2013-06-05','16:00:00',6.57),('10318','2013-06-05','16:05:00',6.77),('10318','2013-06-05','16:10:00',6.81),('10318','2013-06-05','16:15:00',6.64),('10318','2013-06-05','16:20:00',6.46),('10318','2013-06-05','16:25:00',6.34),('10318','2013-06-05','16:30:00',5.51),('10318','2013-06-05','16:35:00',5.93),('10318','2013-06-05','16:40:00',5.17),('10318','2013-06-05','16:45:00',4.03),('10318','2013-06-05','16:50:00',5.48),('10318','2013-06-05','16:55:00',3.06),('10318','2013-06-05','17:00:00',3),('10318','2013-06-05','17:05:00',4.66),('10318','2013-06-05','17:10:00',5.09),('10318','2013-06-05','17:15:00',4.55),('10318','2013-06-05','17:20:00',3.6),('10318','2013-06-05','17:25:00',3.61),('10318','2013-06-05','17:30:00',3.86),('10318','2013-06-05','17:35:00',3.72),('10318','2013-06-05','17:40:00',3.45),('10318','2013-06-05','17:45:00',3.2),('10318','2013-06-05','17:50:00',3),('10318','2013-06-05','17:55:00',2.83),('10318','2013-06-05','18:00:00',2.34),('10318','2013-06-05','18:05:00',1.93),('10318','2013-06-05','18:10:00',2.42),('10318','2013-06-05','18:15:00',2.47),('10318','2013-06-05','18:20:00',1.79),('10318','2013-06-05','18:25:00',1.86),('10318','2013-06-05','18:30:00',1.79),('10318','2013-06-05','18:35:00',1.61),('10318','2013-06-05','18:40:00',1.19),('10318','2013-06-05','18:45:00',1.54),('10318','2013-06-05','18:50:00',1.67),('10318','2013-06-05','18:55:00',1.45),('10318','2013-06-05','19:00:00',1.25),('10318','2013-06-04','07:00:00',1.52),('10318','2013-06-04','07:05:00',1.99),('10318','2013-06-04','07:10:00',2.13),('10318','2013-06-04','07:15:00',2.46),('10318','2013-06-04','07:20:00',2.52),('10318','2013-06-04','07:25:00',2.71),('10318','2013-06-04','07:30:00',3.05),('10318','2013-06-04','07:35:00',2.87),('10318','2013-06-04','07:40:00',2.1),('10318','2013-06-04','07:45:00',3.69),('10318','2013-06-04','07:50:00',4.28),('10318','2013-06-04','07:55:00',5.16),('10318','2013-06-04','08:00:00',5.52),('10318','2013-06-04','08:05:00',5.77),('10318','2013-06-04','08:10:00',5.77),('10318','2013-06-04','08:15:00',5.83),('10318','2013-06-04','08:20:00',5.88),('10318','2013-06-04','08:25:00',5.91),('10318','2013-06-04','08:30:00',4.12),('10318','2013-06-04','08:35:00',4.04),('10318','2013-06-04','08:40:00',4.25),('10318','2013-06-04','08:45:00',3.26),('10318','2013-06-04','08:50:00',3.05),('10318','2013-06-04','08:55:00',3.49),('10318','2013-06-04','09:00:00',3.75),('10318','2013-06-04','09:05:00',5.42),('10318','2013-06-04','09:10:00',7.56),('10318','2013-06-04','09:15:00',8.77),('10318','2013-06-04','09:20:00',5.49),('10318','2013-06-04','09:25:00',7.82),('10318','2013-06-04','09:30:00',5.51),('10318','2013-06-04','09:35:00',3.62),('10318','2013-06-04','09:40:00',4.2),('10318','2013-06-04','09:45:00',5),('10318','2013-06-04','09:50:00',4.03),('10318','2013-06-04','09:55:00',4.16),('10318','2013-06-04','10:00:00',6.21),('10318','2013-06-04','10:05:00',5.12),('10318','2013-06-04','10:10:00',3.8),('10318','2013-06-04','10:15:00',4.08),('10318','2013-06-04','10:20:00',4.48),('10318','2013-06-04','10:25:00',3.84),('10318','2013-06-04','10:30:00',3.71),('10318','2013-06-04','10:35:00',3.91),('10318','2013-06-04','10:40:00',5.09),('10318','2013-06-04','10:45:00',7.01),('10318','2013-06-04','10:50:00',6.96),('10318','2013-06-04','10:55:00',5.67),('10318','2013-06-04','11:00:00',6.17),('10318','2013-06-04','11:05:00',8.21),('10318','2013-06-04','11:10:00',8.24),('10318','2013-06-04','11:15:00',6.02),('10318','2013-06-04','11:20:00',5.4),('10318','2013-06-04','11:25:00',6.32),('10318','2013-06-04','11:30:00',6.75),('10318','2013-06-04','11:35:00',7.14),('10318','2013-06-04','11:40:00',7.83),('10318','2013-06-04','11:45:00',7.64),('10318','2013-06-04','11:50:00',10.3),('10318','2013-06-04','11:55:00',8.83),('10318','2013-06-04','12:00:00',5.36),('10318','2013-06-04','12:05:00',4.67),('10318','2013-06-04','12:10:00',7.22),('10318','2013-06-04','12:15:00',5.19),('10318','2013-06-04','12:20:00',6.12),('10318','2013-06-04','12:25:00',3.85),('10318','2013-06-04','12:30:00',4.68),('10318','2013-06-04','12:35:00',7.29),('10318','2013-06-04','12:40:00',5.16),('10318','2013-06-04','12:45:00',3.46),('10318','2013-06-04','12:50:00',4),('10318','2013-06-04','12:55:00',6.93),('10318','2013-06-04','13:00:00',5.04),('10318','2013-06-04','13:05:00',2.81),('10318','2013-06-04','13:10:00',2.55),('10318','2013-06-04','13:15:00',3.04),('10318','2013-06-04','13:20:00',3.95),('10318','2013-06-04','13:25:00',7.34),('10318','2013-06-04','13:30:00',11.06),('10318','2013-06-04','13:35:00',10.96),('10318','2013-06-04','13:40:00',9.14),('10318','2013-06-04','13:45:00',10.02),('10318','2013-06-04','13:50:00',6.88),('10318','2013-06-04','13:55:00',7.7),('10318','2013-06-04','14:00:00',10.48),('10318','2013-06-04','14:05:00',9.61),('10318','2013-06-04','14:10:00',5.41),('10318','2013-06-04','14:15:00',8.41),('10318','2013-06-04','14:20:00',6.53),('10318','2013-06-04','14:25:00',2.21),('10318','2013-06-04','14:30:00',2.45),('10318','2013-06-04','14:35:00',3.43),('10318','2013-06-04','14:40:00',4.49),('10318','2013-06-04','14:45:00',3.02),('10318','2013-06-04','14:50:00',5.9),('10318','2013-06-04','14:55:00',10.49),('10318','2013-06-04','15:00:00',7.13),('10318','2013-06-04','15:05:00',9.45),('10318','2013-06-04','15:10:00',6.84),('10318','2013-06-04','15:15:00',3.2),('10318','2013-06-04','15:20:00',4.45),('10318','2013-06-04','15:25:00',2.91),('10318','2013-06-04','15:30:00',1.77),('10318','2013-06-04','15:50:00',1.18),('10318','2013-06-04','15:55:00',1.03),('10318','2013-06-04','17:10:00',1.27),('10318','2013-06-04','17:15:00',1.69),('10318','2013-06-04','17:20:00',1.5),('10318','2013-06-04','17:25:00',1.21),('10318','2013-06-04','17:30:00',1.04),('10318','2013-06-04','17:35:00',1.3),('10318','2013-06-04','17:40:00',1.74),('10318','2013-06-04','17:45:00',1.5),('10318','2013-06-04','17:50:00',1.37),('10318','2013-06-04','17:55:00',1.46),('10318','2013-06-04','18:00:00',1.58),('10318','2013-06-04','18:05:00',1.77),('10318','2013-06-04','18:10:00',1.58),('10318','2013-06-04','18:15:00',1.46),('10318','2013-06-04','18:20:00',1.44),('10318','2013-06-04','18:25:00',1.24),('10318','2013-06-04','18:30:00',1.03),('10318','2013-06-04','18:35:00',1.13),('10318','2013-06-04','18:40:00',1.73),('10318','2013-06-04','18:45:00',1.64),('10318','2013-06-04','18:50:00',1.63),('10318','2013-06-04','18:55:00',1.34),('10318','2013-06-04','19:00:00',1.23),('10318','2013-06-04','19:05:00',1.07),('10318','2013-06-03','06:40:00',1.05),('10318','2013-06-03','06:45:00',1.65),('10318','2013-06-03','06:50:00',1.41),('10318','2013-06-03','06:55:00',1.22),('10318','2013-06-03','07:00:00',1.32),('10318','2013-06-03','07:05:00',1.68),('10318','2013-06-03','07:10:00',1.6),('10318','2013-06-03','07:15:00',2.27),('10318','2013-06-03','07:20:00',2.69),('10318','2013-06-03','07:25:00',2.94),('10318','2013-06-03','07:30:00',1.68),('10318','2013-06-03','07:35:00',2.12),('10318','2013-06-03','07:40:00',3.55),('10318','2013-06-03','07:45:00',3.61),('10318','2013-06-03','07:50:00',3.88),('10318','2013-06-03','07:55:00',4.03),('10318','2013-06-03','08:00:00',4.3),('10318','2013-06-03','08:05:00',4.42),('10318','2013-06-03','08:10:00',4.53),('10318','2013-06-03','08:15:00',4.81),('10318','2013-06-03','08:20:00',4.99),('10318','2013-06-03','08:25:00',5.2),('10318','2013-06-03','08:30:00',5.34),('10318','2013-06-03','08:35:00',5.45),('10318','2013-06-03','08:40:00',5.8),('10318','2013-06-03','08:45:00',6),('10318','2013-06-03','08:50:00',6.16),('10318','2013-06-03','08:55:00',6.18),('10318','2013-06-03','09:00:00',6.34),('10318','2013-06-03','09:05:00',6.61),('10318','2013-06-03','09:10:00',6.83),('10318','2013-06-03','09:15:00',7.04),('10318','2013-06-03','09:20:00',4.9),('10318','2013-06-03','09:25:00',3.32),('10318','2013-06-03','09:30:00',3.15),('10318','2013-06-03','09:35:00',3.3),('10318','2013-06-03','09:40:00',5.82),('10318','2013-06-03','09:45:00',8),('10318','2013-06-03','09:50:00',6.06),('10318','2013-06-03','09:55:00',4.24),('10318','2013-06-03','10:00:00',3.39),('10318','2013-06-03','10:05:00',2.7),('10318','2013-06-03','10:10:00',2.01),('10318','2013-06-03','10:15:00',1.65),('10318','2013-06-03','10:20:00',1.68),('10318','2013-06-03','10:25:00',2.06),('10318','2013-06-03','10:30:00',2.47),('10318','2013-06-03','10:35:00',2.9),('10318','2013-06-03','10:40:00',3.08),('10318','2013-06-03','10:45:00',3.22),('10318','2013-06-03','10:50:00',3.52),('10318','2013-06-03','10:55:00',4.17),('10318','2013-06-03','11:00:00',5.02),('10318','2013-06-03','11:05:00',8.75),('10318','2013-06-03','11:10:00',10.38),('10318','2013-06-03','11:15:00',7.18),('10318','2013-06-03','11:20:00',6.96),('10318','2013-06-03','11:25:00',6.82),('10318','2013-06-03','11:30:00',5.14),('10318','2013-06-03','11:35:00',8.6),('10318','2013-06-03','11:40:00',6.96),('10318','2013-06-03','11:45:00',3.4),('10318','2013-06-03','11:50:00',5.01),('10318','2013-06-03','11:55:00',3.6),('10318','2013-06-03','12:00:00',4.67),('10318','2013-06-03','12:05:00',5.32),('10318','2013-06-03','12:10:00',5.18),('10318','2013-06-03','12:15:00',2.78),('10318','2013-06-03','12:20:00',2.91),('10318','2013-06-03','12:25:00',2.99),('10318','2013-06-03','12:30:00',2.86),('10318','2013-06-03','12:35:00',2.5),('10318','2013-06-03','12:40:00',2.84),('10318','2013-06-03','12:45:00',3.8),('10318','2013-06-03','12:50:00',6.97),('10318','2013-06-03','12:55:00',10.77),('10318','2013-06-03','13:00:00',7.54),('10318','2013-06-03','13:05:00',6.23),('10318','2013-06-03','13:10:00',6.67),('10318','2013-06-03','13:15:00',4.87),('10318','2013-06-03','13:20:00',7.24),('10318','2013-06-03','13:25:00',10.19),('10318','2013-06-03','13:30:00',10.78),('10318','2013-06-03','13:35:00',6.36),('10318','2013-06-03','13:40:00',7.57),('10318','2013-06-03','13:45:00',10.38),('10318','2013-06-03','13:50:00',10.27),('10318','2013-06-03','13:55:00',9.3),('10318','2013-06-03','14:00:00',9.1),('10318','2013-06-03','14:05:00',5.85),('10318','2013-06-03','14:10:00',7.21),('10318','2013-06-03','14:15:00',4.33),('10318','2013-06-03','14:20:00',4.93),('10318','2013-06-03','14:25:00',8.75),('10318','2013-06-03','14:30:00',4.75),('10318','2013-06-03','14:35:00',8.54),('10318','2013-06-03','14:40:00',9.87),('10318','2013-06-03','14:45:00',6.34),('10318','2013-06-03','14:50:00',6.31),('10318','2013-06-03','14:55:00',7.64),('10318','2013-06-03','15:00:00',4.08),('10318','2013-06-03','15:05:00',5.31),('10318','2013-06-03','15:10:00',7.57),('10318','2013-06-03','15:15:00',8.14),('10318','2013-06-03','15:20:00',5.15),('10318','2013-06-03','15:25:00',5.01),('10318','2013-06-03','15:30:00',8.32),('10318','2013-06-03','15:35:00',7.88),('10318','2013-06-03','15:40:00',7.76),('10318','2013-06-03','15:45:00',7.59),('10318','2013-06-03','15:50:00',7.42),('10318','2013-06-03','15:55:00',7.27),('10318','2013-06-03','16:00:00',7.19),('10318','2013-06-03','16:05:00',7.06),('10318','2013-06-03','16:10:00',6.9),('10318','2013-06-03','16:15:00',6.19),('10318','2013-06-03','16:20:00',6.15),('10318','2013-06-03','16:25:00',6.2),('10318','2013-06-03','16:30:00',6.1),('10318','2013-06-03','16:35:00',5.77),('10318','2013-06-03','16:40:00',5.39),('10318','2013-06-03','16:45:00',4.87),('10318','2013-06-03','16:50:00',4.15),('10318','2013-06-03','16:55:00',4.3),('10318','2013-06-03','17:00:00',5.87),('10318','2013-06-03','17:05:00',5.92),('10318','2013-06-03','17:10:00',5.82),('10318','2013-06-03','17:15:00',4.75),('10318','2013-06-03','17:20:00',4.17),('10318','2013-06-03','17:25:00',3.65),('10318','2013-06-03','17:30:00',2.11),('10318','2013-06-03','17:35:00',1.72),('10318','2013-06-03','17:40:00',1.7),('10318','2013-06-03','17:45:00',1.4),('10318','2013-06-03','17:50:00',1.59),('10318','2013-06-03','17:55:00',1.54),('10318','2013-06-03','18:00:00',1.2),('10318','2013-06-03','18:05:00',1.06),('10318','2013-06-03','18:55:00',1),('10318','2013-06-03','19:00:00',1.16),('10318','2013-06-03','19:05:00',1.16),('10318','2013-06-02','06:45:00',1.19),('10318','2013-06-02','06:50:00',1.96),('10318','2013-06-02','06:55:00',2.49),('10318','2013-06-02','07:00:00',2.2),('10318','2013-06-02','07:05:00',1.99),('10318','2013-06-02','07:10:00',1.1),('10318','2013-06-02','07:15:00',1.15),('10318','2013-06-02','08:20:00',1.3),('10318','2013-06-02','08:25:00',1.63),('10318','2013-06-02','08:30:00',1.89),('10318','2013-06-02','08:35:00',2.15),('10318','2013-06-02','08:40:00',2.33),('10318','2013-06-02','08:45:00',2.74),('10318','2013-06-02','08:50:00',2.03),('10318','2013-06-02','08:55:00',2),('10318','2013-06-02','09:00:00',2.04),('10318','2013-06-02','09:05:00',2.26),('10318','2013-06-02','09:10:00',2.47),('10318','2013-06-02','09:15:00',2.69),('10318','2013-06-02','09:20:00',6.66),('10318','2013-06-02','09:25:00',7.17),('10318','2013-06-02','09:30:00',7.98),('10318','2013-06-02','09:35:00',7.86),('10318','2013-06-02','09:40:00',7.87),('10318','2013-06-02','09:45:00',7.95),('10318','2013-06-02','09:50:00',7.98),('10318','2013-06-02','09:55:00',8.17),('10318','2013-06-02','10:00:00',8.25),('10318','2013-06-02','10:05:00',8.44),('10318','2013-06-02','10:10:00',6.98),('10318','2013-06-02','10:15:00',8.69),('10318','2013-06-02','10:20:00',8.79),('10318','2013-06-02','10:25:00',8.3),('10318','2013-06-02','10:30:00',8.74),('10318','2013-06-02','10:35:00',5.52),('10318','2013-06-02','10:40:00',9.93),('10318','2013-06-02','10:45:00',8.01),('10318','2013-06-02','10:50:00',7.6),('10318','2013-06-02','10:55:00',9.96),('10318','2013-06-02','11:00:00',10.24),('10318','2013-06-02','11:05:00',10.57),('10318','2013-06-02','11:10:00',8.38),('10318','2013-06-02','11:15:00',3.42),('10318','2013-06-02','11:20:00',5.43),('10318','2013-06-02','11:25:00',5.94),('10318','2013-06-02','11:30:00',5.47),('10318','2013-06-02','11:35:00',6.23),('10318','2013-06-02','11:40:00',9.76),('10318','2013-06-02','11:45:00',8.68),('10318','2013-06-02','11:50:00',4.17),('10318','2013-06-02','11:55:00',8.69),('10318','2013-06-02','12:00:00',8.32),('10318','2013-06-02','12:05:00',11.14),('10318','2013-06-02','12:10:00',4.47),('10318','2013-06-02','12:15:00',6.16),('10318','2013-06-02','12:20:00',8.71),('10318','2013-06-02','12:25:00',10.65),('10318','2013-06-02','12:30:00',10.14),('10318','2013-06-02','12:35:00',10.57),('10318','2013-06-02','12:40:00',9.27),('10318','2013-06-02','12:45:00',8.22),('10318','2013-06-02','12:50:00',7.95),('10318','2013-06-02','12:55:00',4.37),('10318','2013-06-02','13:00:00',10.73),('10318','2013-06-02','13:05:00',9.71),('10318','2013-06-02','13:10:00',9.39),('10318','2013-06-02','13:15:00',10.07),('10318','2013-06-02','13:20:00',9.92),('10318','2013-06-02','13:25:00',9.79),('10318','2013-06-02','13:30:00',9.77),('10318','2013-06-02','13:35:00',9.64),('10318','2013-06-02','13:40:00',9.62),('10318','2013-06-02','13:45:00',9.57),('10318','2013-06-02','13:50:00',9.66),('10318','2013-06-02','13:55:00',9.51),('10318','2013-06-02','14:00:00',9.53),('10318','2013-06-02','14:05:00',9.26),('10318','2013-06-02','14:10:00',9.41),('10318','2013-06-02','14:15:00',9.28),('10318','2013-06-02','14:20:00',9.2),('10318','2013-06-02','14:25:00',9.1),('10318','2013-06-02','14:30:00',6.8),('10318','2013-06-02','14:35:00',9.09),('10318','2013-06-02','14:40:00',8.95),('10318','2013-06-02','14:45:00',8.79),('10318','2013-06-02','14:50:00',8.7),('10318','2013-06-02','14:55:00',8.58),('10318','2013-06-02','15:00:00',8.48),('10318','2013-06-02','15:05:00',6.35),('10318','2013-06-02','15:10:00',7.91),('10318','2013-06-02','15:15:00',5.43),('10318','2013-06-02','15:20:00',6.74),('10318','2013-06-02','15:25:00',6.34),('10318','2013-06-02','15:30:00',8.15),('10318','2013-06-02','15:35:00',7.83),('10318','2013-06-02','15:40:00',6.06),('10318','2013-06-02','15:45:00',7.38),('10318','2013-06-02','15:50:00',7.01),('10318','2013-06-02','15:55:00',6.62),('10318','2013-06-02','16:00:00',5.21),('10318','2013-06-02','16:05:00',6.24),('10318','2013-06-02','16:10:00',5.37),('10318','2013-06-02','16:15:00',6.07),('10318','2013-06-02','16:20:00',4.77),('10318','2013-06-02','16:25:00',3.83),('10318','2013-06-02','16:30:00',4.28),('10318','2013-06-02','16:35:00',6.27),('10318','2013-06-02','16:40:00',5.61),('10318','2013-06-02','16:45:00',5.61),('10318','2013-06-02','16:50:00',4.88),('10318','2013-06-02','16:55:00',3.69),('10318','2013-06-02','17:00:00',5.24),('10318','2013-06-02','17:05:00',4.66),('10318','2013-06-02','17:10:00',4.11),('10318','2013-06-02','17:15:00',3.8),('10318','2013-06-02','17:20:00',4.35),('10318','2013-06-02','17:25:00',3.89),('10318','2013-06-02','17:30:00',3.11),('10318','2013-06-02','17:35:00',3.62),('10318','2013-06-02','17:40:00',2.43),('10318','2013-06-02','17:45:00',2.36),('10318','2013-06-02','17:50:00',1.96),('10318','2013-06-02','17:55:00',1.67),('10318','2013-06-02','18:00:00',2.15),('10318','2013-06-02','18:05:00',1.78),('10318','2013-06-02','18:10:00',1.94),('10318','2013-06-02','18:15:00',2.25),('10318','2013-06-02','18:20:00',1.92),('10318','2013-06-02','18:25:00',1.62),('10318','2013-06-02','18:30:00',1.64),('10318','2013-06-02','18:35:00',1.57),('10318','2013-06-02','18:40:00',1.5),('10318','2013-06-02','18:45:00',1.68),('10318','2013-06-02','18:50:00',1.37),('10318','2013-06-02','19:05:00',1),('10318','2013-06-02','19:10:00',1.07),('10318','2013-06-01','06:50:00',1.13),('10318','2013-06-01','06:55:00',1.49),('10318','2013-06-01','07:00:00',1.63),('10318','2013-06-01','07:05:00',1.99),('10318','2013-06-01','07:10:00',2.19),('10318','2013-06-01','07:15:00',2.52),('10318','2013-06-01','07:20:00',2.82),('10318','2013-06-01','07:25:00',3.06),('10318','2013-06-01','07:30:00',3.3),('10318','2013-06-01','07:35:00',3.52),('10318','2013-06-01','07:40:00',3.75),('10318','2013-06-01','07:45:00',4.23),('10318','2013-06-01','07:50:00',4.28),('10318','2013-06-01','07:55:00',2.51),('10318','2013-06-01','08:00:00',1.67),('10318','2013-06-01','08:05:00',1.51),('10318','2013-06-01','08:10:00',2.72),('10318','2013-06-01','08:15:00',3.26),('10318','2013-06-01','08:20:00',1.51),('10318','2013-06-01','08:25:00',1.52),('10318','2013-06-01','08:30:00',3.05),('10318','2013-06-01','08:35:00',3.05),('10318','2013-06-01','08:40:00',1.65),('10318','2013-06-01','08:45:00',1.94),('10318','2013-06-01','08:50:00',2.15),('10318','2013-06-01','08:55:00',4.67),('10318','2013-06-01','09:00:00',4.84),('10318','2013-06-01','09:05:00',1.09),('10318','2013-06-01','09:35:00',1),('10318','2013-06-01','09:40:00',1.48),('10318','2013-06-01','09:45:00',2.19),('10318','2013-06-01','09:50:00',1.69),('10318','2013-06-01','09:55:00',1.38),('10318','2013-06-01','10:00:00',1.5),('10318','2013-06-01','10:05:00',1.65),('10318','2013-06-01','10:10:00',1.38),('10318','2013-06-01','10:15:00',1.08),('10318','2013-06-01','10:20:00',1.12),('10318','2013-06-01','10:25:00',1.98),('10318','2013-06-01','10:30:00',2.56),('10318','2013-06-01','10:35:00',3.37),('10318','2013-06-01','10:40:00',2.74),('10318','2013-06-01','10:45:00',3.91),('10318','2013-06-01','10:50:00',9.67),('10318','2013-06-01','10:55:00',3.14),('10318','2013-06-01','11:00:00',1.01),('10318','2013-06-01','11:05:00',1.49),('10318','2013-06-01','11:10:00',1.28),('10318','2013-06-01','11:45:00',1.59),('10318','2013-06-01','11:50:00',3.07),('10318','2013-06-01','11:55:00',5.36),('10318','2013-06-01','12:00:00',10.59),('10318','2013-06-01','12:05:00',8.73),('10318','2013-06-01','12:10:00',3.93),('10318','2013-06-01','12:15:00',2.56),('10318','2013-06-01','12:20:00',1.86),('10318','2013-06-01','12:25:00',2.98),('10318','2013-06-01','12:30:00',2.31),('10318','2013-06-01','12:35:00',1.97),('10318','2013-06-01','12:40:00',2.53),('10318','2013-06-01','12:45:00',4.04),('10318','2013-06-01','12:50:00',4.64),('10318','2013-06-01','12:55:00',4.93),('10318','2013-06-01','13:00:00',5.08),('10318','2013-06-01','13:05:00',4.87),('10318','2013-06-01','13:10:00',5.25),('10318','2013-06-01','13:15:00',5.46),('10318','2013-06-01','13:20:00',4.61),('10318','2013-06-01','13:25:00',3.98),('10318','2013-06-01','13:30:00',3.41),('10318','2013-06-01','13:35:00',2.6),('10318','2013-06-01','13:40:00',2.3),('10318','2013-06-01','13:45:00',2.34),('10318','2013-06-01','13:50:00',2.77),('10318','2013-06-01','13:55:00',3.51),('10318','2013-06-01','14:00:00',5.59),('10318','2013-06-01','14:05:00',5.44),('10318','2013-06-01','14:10:00',5.23),('10318','2013-06-01','14:15:00',4.92),('10318','2013-06-01','14:20:00',4.36),('10318','2013-06-01','14:25:00',3.68),('10318','2013-06-01','14:30:00',3.27),('10318','2013-06-01','14:35:00',3.03),('10318','2013-06-01','14:40:00',2.65),('10318','2013-06-01','14:45:00',2.35),('10318','2013-06-01','14:50:00',2.4),('10318','2013-06-01','14:55:00',2.01),('10318','2013-06-01','15:00:00',1.88),('10318','2013-06-01','15:05:00',1.6),('10318','2013-06-01','15:10:00',1.71),('10318','2013-06-01','15:15:00',1.77),('10318','2013-06-01','15:20:00',1.71),('10318','2013-06-01','15:25:00',1.6),('10318','2013-06-01','15:30:00',1.71),('10318','2013-06-01','15:35:00',1.87),('10318','2013-06-01','15:40:00',2.49),('10318','2013-06-01','15:45:00',2.68),('10318','2013-06-01','15:50:00',2.24),('10318','2013-06-01','15:55:00',2.93),('10318','2013-06-01','16:00:00',2.63),('10318','2013-06-01','16:05:00',2.35),('10318','2013-06-01','16:10:00',1.76),('10318','2013-06-01','16:15:00',2.03),('10318','2013-06-01','16:20:00',1.8),('10318','2013-06-01','16:25:00',1.62),('10318','2013-06-01','16:30:00',1.89),('10318','2013-06-01','16:35:00',1.92),('10318','2013-06-01','16:40:00',2.04),('10318','2013-06-01','16:45:00',1.85),('10318','2013-06-01','16:50:00',2.04),('10318','2013-06-01','16:55:00',1.89),('10318','2013-06-01','18:20:00',1.18),('10318','2013-06-01','18:25:00',2.04),('10318','2013-06-01','18:30:00',2.28),('10318','2013-06-01','18:35:00',1.72),('10318','2013-06-01','18:40:00',1.38),('10318','2013-06-01','18:45:00',1.55),('10318','2013-06-01','18:50:00',1.49),('10318','2013-06-01','18:55:00',2.06),('10318','2013-06-01','19:00:00',1.77),('10318','2013-06-01','19:05:00',1.16),('10318','2014-04-02','07:55:00',1.11),('10318','2014-04-02','08:00:00',1.15),('10318','2014-04-02','08:25:00',1.44),('10318','2014-04-02','08:30:00',2.06),('10318','2014-04-02','08:35:00',1.97),('10318','2014-04-02','08:40:00',1.66),('10318','2014-04-02','08:45:00',1.86),('10318','2014-04-02','08:50:00',1.66),('10318','2014-04-02','09:20:00',1.13),('10318','2014-04-02','09:25:00',1.22),('10318','2014-04-02','09:30:00',1.43),('10318','2014-04-02','09:35:00',1.45),('10318','2014-04-02','09:40:00',2.48),('10318','2014-04-02','09:45:00',6.16),('10318','2014-04-02','09:50:00',5.76),('10318','2014-04-02','09:55:00',4.04),('10318','2014-04-02','10:00:00',6.85),('10318','2014-04-02','10:05:00',3.6),('10318','2014-04-02','10:10:00',3.82),('10318','2014-04-02','10:15:00',4.49),('10318','2014-04-02','10:20:00',2.81),('10318','2014-04-02','10:25:00',2.21),('10318','2014-04-02','10:30:00',1.95),('10318','2014-04-02','10:35:00',2.19),('10318','2014-04-02','10:40:00',2.83),('10318','2014-04-02','10:45:00',2.97),('10318','2014-04-02','10:50:00',3.6),('10318','2014-04-02','10:55:00',3.24),('10318','2014-04-02','11:00:00',3.42),('10318','2014-04-02','11:05:00',8.4),('10318','2014-04-02','11:10:00',9.57),('10318','2014-04-02','11:15:00',10.41),('10318','2014-04-02','11:20:00',8.16),('10318','2014-04-02','11:25:00',8.99),('10318','2014-04-02','11:30:00',5.8),('10318','2014-04-02','11:35:00',6.83),('10318','2014-04-02','11:40:00',10.29),('10318','2014-04-02','11:45:00',10.58),('10318','2014-04-02','11:50:00',10.73),('10318','2014-04-02','11:55:00',5.36),('10318','2014-04-02','12:00:00',3.9),('10318','2014-04-02','12:05:00',10.07),('10318','2014-04-02','12:10:00',10.09),('10318','2014-04-02','12:15:00',7.13),('10318','2014-04-02','12:20:00',4.62),('10318','2014-04-02','12:25:00',3.07),('10318','2014-04-02','12:30:00',2.77),('10318','2014-04-02','12:35:00',2.54),('10318','2014-04-02','12:40:00',9.7),('10318','2014-04-02','12:45:00',10.1),('10318','2014-04-02','12:50:00',7.42),('10318','2014-04-02','12:55:00',8.54),('10318','2014-04-02','13:00:00',5.42),('10318','2014-04-02','13:05:00',8.96),('10318','2014-04-02','13:10:00',6.44),('10318','2014-04-02','13:15:00',4.52),('10318','2014-04-02','13:20:00',10.22),('10318','2014-04-02','13:25:00',9.82),('10318','2014-04-02','13:30:00',9.08),('10318','2014-04-02','13:35:00',7.78),('10318','2014-04-02','13:40:00',9.91),('10318','2014-04-02','13:45:00',7.67),('10318','2014-04-02','13:50:00',5.69),('10318','2014-04-02','13:55:00',7.08),('10318','2014-04-02','14:00:00',6.57),('10318','2014-04-02','14:05:00',9.59),('10318','2014-04-02','14:10:00',9.17),('10318','2014-04-02','14:15:00',7.03),('10318','2014-04-02','14:20:00',8.94),('10318','2014-04-02','14:25:00',8.69),('10318','2014-04-02','14:30:00',8.59),('10318','2014-04-02','14:35:00',7.96),('10318','2014-04-02','14:40:00',6.04),('10318','2014-04-02','14:45:00',8.57),('10318','2014-04-02','14:50:00',6.93),('10318','2014-04-02','14:55:00',7.74),('10318','2014-04-02','15:00:00',7.9),('10318','2014-04-02','15:05:00',7.78),('10318','2014-04-02','15:10:00',7.38),('10318','2014-04-02','15:15:00',7.35),('10318','2014-04-02','15:20:00',7.32),('10318','2014-04-02','15:25:00',7),('10318','2014-04-02','15:30:00',6.54),('10318','2014-04-02','15:35:00',6.36),('10318','2014-04-02','15:40:00',6.85),('10318','2014-04-02','15:45:00',6.78),('10318','2014-04-02','15:50:00',6.56),('10318','2014-04-02','15:55:00',5.72),('10318','2014-04-02','16:00:00',6.1),('10318','2014-04-02','16:05:00',5.91),('10318','2014-04-02','16:10:00',5.73),('10318','2014-04-02','16:15:00',5.49),('10318','2014-04-02','16:20:00',5.31),('10318','2014-04-02','16:25:00',5.3),('10318','2014-04-02','16:30:00',5.18),('10318','2014-04-02','16:35:00',4.89),('10318','2014-04-02','16:40:00',4.75),('10318','2014-04-02','16:45:00',4.51),('10318','2014-04-02','16:50:00',4.08),('10318','2014-04-02','16:55:00',4.19),('10318','2014-04-02','17:00:00',4.1),('10318','2014-04-02','17:05:00',3.62),('10318','2014-04-02','17:10:00',3.46),('10318','2014-04-02','17:15:00',3.13),('10318','2014-04-02','17:20:00',3.03),('10318','2014-04-02','17:25:00',2.87),('10318','2014-04-02','17:30:00',2.56),('10318','2014-04-02','17:35:00',2.52),('10318','2014-04-02','17:40:00',1.87),('10318','2014-04-02','17:45:00',1.98),('10318','2014-04-02','17:50:00',2.33),('10318','2014-04-02','17:55:00',1.93),('10318','2014-04-02','18:00:00',1.69),('10318','2014-04-02','18:05:00',1.15),('10318','2014-04-02','18:10:00',1.09),('10318','2014-04-02','18:15:00',1.08),('10318','2014-04-02','18:20:00',1.07),('10318','2013-05-31','06:50:00',1.15),('10318','2013-05-31','06:55:00',1.44),('10318','2013-05-31','07:00:00',1.67),('10318','2013-05-31','07:05:00',1.93),('10318','2013-05-31','07:10:00',2.14),('10318','2013-05-31','07:15:00',2.43),('10318','2013-05-31','07:20:00',2.75),('10318','2013-05-31','07:25:00',3.07),('10318','2013-05-31','07:30:00',3.28),('10318','2013-05-31','07:35:00',3.49),('10318','2013-05-31','07:40:00',3.67),('10318','2013-05-31','07:45:00',3.87),('10318','2013-05-31','07:50:00',4.08),('10318','2013-05-31','07:55:00',4.38),('10318','2013-05-31','08:00:00',4.57),('10318','2013-05-31','08:05:00',4.7),('10318','2013-05-31','08:10:00',4.93),('10318','2013-05-31','08:15:00',5.15),('10318','2013-05-31','08:20:00',5.4),('10318','2013-05-31','08:25:00',4.93),('10318','2013-05-31','08:30:00',5.9),('10318','2013-05-31','08:35:00',4.08),('10318','2013-05-31','08:40:00',4.92),('10318','2013-05-31','08:45:00',5.98),('10318','2013-05-31','08:50:00',5.24),('10318','2013-05-31','08:55:00',3.5),('10318','2013-05-31','09:00:00',2.78),('10318','2013-05-31','09:05:00',4.82),('10318','2013-05-31','09:10:00',5.23),('10318','2013-05-31','09:15:00',2.28),('10318','2013-05-31','09:20:00',2.13),('10318','2013-05-31','09:25:00',5.55),('10318','2013-05-31','09:30:00',3.41),('10318','2013-05-31','09:35:00',4.45),('10318','2013-05-31','09:40:00',8.9),('10318','2013-05-31','09:45:00',7.66),('10318','2013-05-31','09:50:00',8.31),('10318','2013-05-31','09:55:00',6.47),('10318','2013-05-31','10:00:00',7.9),('10318','2013-05-31','10:05:00',7.64),('10318','2013-05-31','10:10:00',7.34),('10318','2013-05-31','10:15:00',10.97),('10318','2013-05-31','10:20:00',2.35),('10318','2013-05-31','10:25:00',2.05),('10318','2013-05-31','10:30:00',6.67),('10318','2013-05-31','10:35:00',5.41),('10318','2013-05-31','10:40:00',8.01),('10318','2013-05-31','10:45:00',6.48),('10318','2013-05-31','10:50:00',3.02),('10318','2013-05-31','10:55:00',3.12),('10318','2013-05-31','11:00:00',3.6),('10318','2013-05-31','11:05:00',7.59),('10318','2013-05-31','11:10:00',6.74),('10318','2013-05-31','11:15:00',3.72),('10318','2013-05-31','11:20:00',6.6),('10318','2013-05-31','11:25:00',3.01),('10318','2013-05-31','11:30:00',2.71),('10318','2013-05-31','11:35:00',2.14),('10318','2013-05-31','11:40:00',5),('10318','2013-05-31','11:45:00',8.55),('10318','2013-05-31','11:50:00',7.56),('10318','2013-05-31','11:55:00',7.2),('10318','2013-05-31','12:00:00',7.15),('10318','2013-05-31','12:05:00',6.84),('10318','2013-05-31','12:10:00',5.08),('10318','2013-05-31','12:15:00',5.05),('10318','2013-05-31','12:20:00',8.04),('10318','2013-05-31','12:25:00',10.95),('10318','2013-05-31','12:30:00',3.84),('10318','2013-05-31','12:35:00',6.26),('10318','2013-05-31','12:40:00',8.49),('10318','2013-05-31','12:45:00',2.65),('10318','2013-05-31','12:50:00',3.27),('10318','2013-05-31','12:55:00',8.15),('10318','2013-05-31','13:00:00',9.21),('10318','2013-05-31','13:05:00',2.53),('10318','2013-05-31','13:10:00',1.5),('10318','2013-05-31','13:15:00',2.14),('10318','2013-05-31','13:20:00',5.11),('10318','2013-05-31','13:25:00',4.44),('10318','2013-05-31','13:30:00',6.77),('10318','2013-05-31','13:35:00',5.37),('10318','2013-05-31','13:40:00',4.11),('10318','2013-05-31','13:45:00',3.85),('10318','2013-05-31','13:50:00',3.41),('10318','2013-05-31','13:55:00',4.76),('10318','2013-05-31','14:00:00',3.18),('10318','2013-05-31','14:05:00',2.18),('10318','2013-05-31','14:10:00',1.38),('10318','2013-05-31','14:15:00',1.27),('10318','2013-05-31','14:20:00',1.88),('10318','2013-05-31','14:25:00',2.59),('10318','2013-05-31','14:30:00',2.32),('10318','2013-05-31','14:40:00',1.11),('10318','2013-05-31','14:45:00',2.05),('10318','2013-05-31','14:50:00',1.72),('10318','2013-05-31','14:55:00',1.24),('10318','2013-05-31','15:00:00',2.5),('10318','2013-05-31','15:05:00',3.52),('10318','2013-05-31','15:10:00',4.07),('10318','2013-05-31','15:15:00',7.34),('10318','2013-05-31','15:20:00',7.31),('10318','2013-05-31','15:25:00',6.51),('10318','2013-05-31','15:30:00',4.97),('10318','2013-05-31','15:35:00',4.46),('10318','2013-05-31','15:40:00',3.69),('10318','2013-05-31','15:45:00',4.37),('10318','2013-05-31','15:50:00',6.39),('10318','2013-05-31','15:55:00',5.22),('10318','2013-05-31','16:00:00',3.07),('10318','2013-05-31','16:05:00',2.49),('10318','2013-05-31','16:10:00',2.02),('10318','2013-05-31','16:15:00',1.83),('10318','2013-05-31','16:20:00',2.75),('10318','2013-05-31','16:25:00',3),('10318','2013-05-31','16:30:00',2.38),('10318','2013-05-31','16:35:00',2.26),('10318','2013-05-31','16:40:00',2.69),('10318','2013-05-31','16:45:00',2.47),('10318','2013-05-31','16:50:00',1.65),('10318','2013-05-31','16:55:00',1.3),('10318','2013-05-31','17:00:00',1.37),('10318','2013-05-31','17:05:00',1.37),('10318','2013-05-31','17:10:00',1.4),('10318','2013-05-31','17:15:00',1.45),('10318','2013-05-31','17:20:00',1.61),('10318','2013-05-31','17:25:00',1.76),('10318','2013-05-31','17:30:00',1.72),('10318','2013-05-31','17:35:00',1.56),('10318','2013-05-31','17:40:00',1.35),('10318','2013-05-31','17:45:00',1.19),('10318','2013-05-31','17:50:00',1.05),('10318','2013-05-31','18:05:00',1.08),('10318','2013-05-31','18:10:00',1.02),('10318','2013-05-31','18:30:00',1.27),('10318','2013-05-30','07:35:00',1.19),('10318','2013-05-30','07:40:00',2.83),('10318','2013-05-30','07:45:00',3.39),('10318','2013-05-30','07:50:00',2.06),('10318','2013-05-30','07:55:00',1.92),('10318','2013-05-30','08:00:00',1.57),('10318','2013-05-30','08:05:00',1.46),('10318','2013-05-30','08:10:00',1.89),('10318','2013-05-30','08:15:00',2.22),('10318','2013-05-30','08:20:00',2.05),('10318','2013-05-30','08:25:00',2.03),('10318','2013-05-30','08:30:00',1.68),('10318','2013-05-30','08:35:00',5.22),('10318','2013-05-30','08:40:00',6.41),('10318','2013-05-30','08:45:00',6.47),('10318','2013-05-30','08:50:00',6.58),('10318','2013-05-30','08:55:00',6.72),('10318','2013-05-30','09:00:00',6.86),('10318','2013-05-30','09:05:00',7.07),('10318','2013-05-30','09:10:00',7.19),('10318','2013-05-30','09:15:00',7.32),('10318','2013-05-30','09:20:00',7.68),('10318','2013-05-30','09:25:00',4.24),('10318','2013-05-30','09:30:00',8.28),('10318','2013-05-30','09:35:00',7.67),('10318','2013-05-30','09:40:00',7.49),('10318','2013-05-30','09:45:00',7.48),('10318','2013-05-30','09:50:00',6.65),('10318','2013-05-30','09:55:00',2.71),('10318','2013-05-30','10:00:00',2.23),('10318','2013-05-30','10:05:00',4.37),('10318','2013-05-30','10:10:00',5.49),('10318','2013-05-30','10:15:00',7.03),('10318','2013-05-30','10:20:00',4.85),('10318','2013-05-30','10:25:00',2.46),('10318','2013-05-30','10:30:00',2.26),('10318','2013-05-30','10:35:00',3.27),('10318','2013-05-30','10:40:00',8.58),('10318','2013-05-30','10:45:00',10.39),('10318','2013-05-30','10:50:00',7.54),('10318','2013-05-30','10:55:00',6.98),('10318','2013-05-30','11:00:00',4.78),('10318','2013-05-30','11:05:00',3.26),('10318','2013-05-30','11:10:00',4.59),('10318','2013-05-30','11:15:00',10.83),('10318','2013-05-30','11:20:00',5.04),('10318','2013-05-30','11:25:00',4.37),('10318','2013-05-30','11:30:00',9.64),('10318','2013-05-30','11:35:00',10.64),('10318','2013-05-30','11:40:00',4.12),('10318','2013-05-30','11:45:00',10.77),('10318','2013-05-30','11:50:00',8.02),('10318','2013-05-30','11:55:00',7.57),('10318','2013-05-30','12:00:00',11.01),('10318','2013-05-30','12:05:00',9.01),('10318','2013-05-30','12:10:00',4.98),('10318','2013-05-30','12:15:00',7.62),('10318','2013-05-30','12:20:00',5.93),('10318','2013-05-30','12:25:00',6.56),('10318','2013-05-30','12:30:00',9.64),('10318','2013-05-30','12:35:00',10.77),('10318','2013-05-30','12:40:00',8.71),('10318','2013-05-30','12:45:00',10.93),('10318','2013-05-30','12:50:00',10.23),('10318','2013-05-30','12:55:00',10.97),('10318','2013-05-30','13:00:00',7.89),('10318','2013-05-30','13:05:00',7.5),('10318','2013-05-30','13:10:00',7.64),('10318','2013-05-30','13:15:00',9.7),('10318','2013-05-30','13:20:00',5.32),('10318','2013-05-30','13:25:00',3.68),('10318','2013-05-30','13:30:00',4.21),('10318','2013-05-30','13:35:00',5.62),('10318','2013-05-30','13:40:00',8),('10318','2013-05-30','13:45:00',4.07),('10318','2013-05-30','13:50:00',3.47),('10318','2013-05-30','13:55:00',7.51),('10318','2013-05-30','14:00:00',6.36),('10318','2013-05-30','14:05:00',4.04),('10318','2013-05-30','14:10:00',7.36),('10318','2013-05-30','14:15:00',9.72),('10318','2013-05-30','14:20:00',8.17),('10318','2013-05-30','14:25:00',6.11),('10318','2013-05-30','14:30:00',9.97),('10318','2013-05-30','14:35:00',8.57),('10318','2013-05-30','14:40:00',5.24),('10318','2013-05-30','14:45:00',9.07),('10318','2013-05-30','14:50:00',8.99),('10318','2013-05-30','14:55:00',4.76),('10318','2013-05-30','15:01:00',9.72),('10318','2013-05-30','15:05:00',6.63),('10318','2013-05-30','15:10:00',6.88),('10318','2013-05-30','15:15:00',9.59),('10318','2013-05-30','15:20:00',9),('10318','2013-05-30','15:25:00',8.98),('10318','2013-05-30','15:30:00',9.19),('10318','2013-05-30','15:35:00',8.97),('10318','2013-05-30','15:40:00',8.33),('10318','2013-05-30','15:45:00',8.56),('10318','2013-05-30','15:50:00',7.95),('10318','2013-05-30','15:55:00',9.08),('10318','2013-05-30','16:00:00',8.45),('10318','2013-05-30','16:05:00',7.8),('10318','2013-05-30','16:10:00',7.42),('10318','2013-05-30','16:15:00',6.81),('10318','2013-05-30','16:20:00',3.97),('10318','2013-05-30','16:25:00',3.74),('10318','2013-05-30','16:30:00',2.06),('10318','2013-05-30','16:35:00',3.15),('10318','2013-05-30','16:40:00',2.14),('10318','2013-05-30','16:45:00',3.93),('10318','2013-05-30','16:50:00',4),('10318','2013-05-30','16:55:00',2.83),('10318','2013-05-30','17:00:00',4.04),('10318','2013-05-30','17:05:00',3.81),('10318','2013-05-30','17:10:00',2.03),('10318','2013-05-30','17:15:00',2.06),('10318','2013-05-30','17:20:00',1.84),('10318','2013-05-30','17:25:00',1.42),('10318','2013-05-30','17:30:00',1.8),('10318','2013-05-30','17:35:00',1.5),('10318','2013-05-30','17:40:00',1.02),('10318','2013-05-30','17:55:00',1.49),('10318','2013-05-30','18:00:00',2.35),('10318','2013-05-30','18:05:00',2.9),('10318','2013-05-30','18:10:00',1.99),('10318','2013-05-30','18:15:00',1.45),('10318','2013-05-30','18:20:00',1.63),('10318','2013-05-30','18:25:00',1.65),('10318','2013-05-30','18:30:00',2.31),('10318','2013-05-30','18:35:00',2.66),('10318','2013-05-30','18:40:00',2.75),('10318','2013-05-30','18:45:00',2.76),('10318','2013-05-30','18:50:00',2.04),('10318','2013-05-30','18:55:00',1.24),('10318','2013-05-30','19:00:00',1.21),('10318','2013-05-29','06:50:00',1.06),('10318','2013-05-29','06:55:00',1.31),('10318','2013-05-29','07:00:00',1.53),('10318','2013-05-29','07:05:00',1.86),('10318','2013-05-29','07:10:00',2.12),('10318','2013-05-29','07:15:00',2.41),('10318','2013-05-29','07:20:00',2.65),('10318','2013-05-29','07:25:00',3),('10318','2013-05-29','07:30:00',3.23),('10318','2013-05-29','07:35:00',3.41),('10318','2013-05-29','07:40:00',3.61),('10318','2013-05-29','07:45:00',3.81),('10318','2013-05-29','07:50:00',3.99),('10318','2013-05-29','07:55:00',4.19),('10318','2013-05-29','08:00:00',4.39),('10318','2013-05-29','08:05:00',4.62),('10318','2013-05-29','08:10:00',4.82),('10318','2013-05-29','08:15:00',5),('10318','2013-05-29','08:20:00',5.13),('10318','2013-05-29','08:25:00',5.37),('10318','2013-05-29','08:30:00',5.58),('10318','2013-05-29','08:35:00',5.74),('10318','2013-05-29','08:40:00',5.93),('10318','2013-05-29','08:45:00',6.09),('10318','2013-05-29','08:50:00',6.27),('10318','2013-05-29','08:55:00',6.47),('10318','2013-05-29','09:00:00',6.63),('10318','2013-05-29','09:05:00',6.64),('10318','2013-05-29','09:10:00',6.98),('10318','2013-05-29','09:15:00',7.11),('10318','2013-05-29','09:20:00',7.29),('10318','2013-05-29','09:25:00',7.46),('10318','2013-05-29','09:30:00',7.59),('10318','2013-05-29','09:35:00',7.72),('10318','2013-05-29','09:40:00',7.83),('10318','2013-05-29','09:45:00',7.94),('10318','2013-05-29','09:50:00',8.1),('10318','2013-05-29','09:55:00',8.23),('10318','2013-05-29','10:00:00',8.37),('10318','2013-05-29','10:05:00',8.39),('10318','2013-05-29','10:10:00',8.48),('10318','2013-05-29','10:15:00',8.66),('10318','2013-05-29','10:20:00',8.84),('10318','2013-05-29','10:25:00',8.92),('10318','2013-05-29','10:30:00',9),('10318','2013-05-29','10:35:00',9.19),('10318','2013-05-29','10:40:00',9.28),('10318','2013-05-29','10:45:00',9.4),('10318','2013-05-29','10:50:00',9.27),('10318','2013-05-29','10:55:00',9.56),('10318','2013-05-29','11:00:00',9.78),('10318','2013-05-29','11:05:00',9.73),('10318','2013-05-29','11:10:00',10.3),('10318','2013-05-29','11:15:00',10.6),('10318','2013-05-29','11:20:00',9.05),('10318','2013-05-29','11:25:00',8.62),('10318','2013-05-29','11:30:00',8.16),('10318','2013-05-29','11:35:00',8.13),('10318','2013-05-29','11:40:00',8.73),('10318','2013-05-29','11:45:00',6.81),('10318','2013-05-29','11:50:00',7.34),('10318','2013-05-29','11:55:00',7),('10318','2013-05-29','12:00:00',8.83),('10318','2013-05-29','12:05:00',9.24),('10318','2013-05-29','12:10:00',10.57),('10318','2013-05-29','12:15:00',10.54),('10318','2013-05-29','12:20:00',9.47),('10318','2013-05-29','12:25:00',10.48),('10318','2013-05-29','12:30:00',10.49),('10318','2013-05-29','12:35:00',9.22),('10318','2013-05-29','12:40:00',10.41),('10318','2013-05-29','12:45:00',9.76),('10318','2013-05-29','12:50:00',10),('10318','2013-05-29','12:55:00',10.27),('10318','2013-05-29','13:00:00',10.37),('10318','2013-05-29','13:05:00',10.47),('10318','2013-05-29','13:10:00',10.56),('10318','2013-05-29','13:15:00',10.36),('10318','2013-05-29','13:20:00',10.72),('10318','2013-05-29','13:25:00',8.45),('10318','2013-05-29','13:30:00',6),('10318','2013-05-29','13:35:00',7.57),('10318','2013-05-29','13:40:00',5.07),('10318','2013-05-29','13:45:00',8.46),('10318','2013-05-29','13:50:00',10.59),('10318','2013-05-29','13:55:00',10.32),('10318','2013-05-29','14:00:00',10.09),('10318','2013-05-29','14:05:00',9.36),('10318','2013-05-29','14:10:00',9.77),('10318','2013-05-29','14:15:00',9.7),('10318','2013-05-29','14:20:00',9.62),('10318','2013-05-29','14:25:00',9.61),('10318','2013-05-29','14:30:00',8.84),('10318','2013-05-29','14:35:00',8.32),('10318','2013-05-29','14:40:00',8.5),('10318','2013-05-29','14:45:00',9.55),('10318','2013-05-29','14:50:00',9.6),('10318','2013-05-29','14:55:00',8.76),('10318','2013-05-29','15:00:00',7.66),('10318','2013-05-29','15:05:00',7.26),('10318','2013-05-29','15:10:00',7.94),('10318','2013-05-29','15:15:00',7.17),('10318','2013-05-29','15:20:00',6.35),('10318','2013-05-29','15:25:00',5.82),('10318','2013-05-29','15:30:00',6.66),('10318','2013-05-29','15:35:00',7.13),('10318','2013-05-29','15:40:00',6.44),('10318','2013-05-29','15:45:00',4.86),('10318','2013-05-29','15:50:00',5.74),('10318','2013-05-29','15:55:00',5.99),('10318','2013-05-29','16:00:00',5.39),('10318','2013-05-29','16:05:00',5.21),('10318','2013-05-29','16:10:00',5.05),('10318','2013-05-29','16:15:00',4.87),('10318','2013-05-29','16:20:00',4.76),('10318','2013-05-29','16:25:00',5.42),('10318','2013-05-29','16:30:00',4.71),('10318','2013-05-29','16:35:00',4.62),('10318','2013-05-29','16:40:00',4.7),('10318','2013-05-29','16:45:00',4.23),('10318','2013-05-29','16:50:00',3.77),('10318','2013-05-29','16:55:00',3.16),('10318','2013-05-29','17:00:00',2.55),('10318','2013-05-29','17:05:00',1.53),('10318','2013-05-29','17:20:00',1.02),('10318','2013-05-29','17:25:00',1.26),('10318','2013-05-29','17:30:00',1.84),('10318','2013-05-29','17:35:00',2.63),('10318','2013-05-29','17:40:00',3.08),('10318','2013-05-29','17:45:00',2.26),('10318','2013-05-29','17:50:00',1.69),('10318','2013-05-29','17:55:00',1.63),('10318','2013-05-29','18:00:00',2.49),('10318','2013-05-29','18:05:00',2.68),('10318','2013-05-29','18:10:00',2.39),('10318','2013-05-29','18:15:00',2.76),('10318','2013-05-29','18:20:00',2.36),('10318','2013-05-29','18:25:00',1.29),('10318','2013-05-29','18:30:00',1.07),('10318','2013-05-29','18:35:00',1.06),('10318','2013-05-29','18:50:00',1.03),('10318','2013-05-29','19:00:00',1.25),('10318','2013-05-29','19:05:00',1.25),('10318','2013-05-29','19:10:00',1.16),('10318','2013-05-28','06:40:00',1.11),('10318','2013-05-28','06:45:00',1.31),('10318','2013-05-28','06:50:00',1.36),('10318','2013-05-28','06:55:00',1.31),('10318','2013-05-28','07:00:00',1.37),('10318','2013-05-28','07:05:00',1.38),('10318','2013-05-28','07:10:00',1.75),('10318','2013-05-28','07:15:00',2.59),('10318','2013-05-28','07:20:00',2.84),('10318','2013-05-28','07:25:00',2.93),('10318','2013-05-28','07:30:00',2.66),('10318','2013-05-28','07:35:00',2.14),('10318','2013-05-28','07:40:00',2.87),('10318','2013-05-28','07:45:00',3.13),('10318','2013-05-28','07:50:00',3.06),('10318','2013-05-28','07:55:00',3.08),('10318','2013-05-28','08:00:00',2.79),('10318','2013-05-28','08:05:00',3.23),('10318','2013-05-28','08:10:00',3.69),('10318','2013-05-28','08:15:00',4.41),('10318','2013-05-28','08:20:00',4.5),('10318','2013-05-28','08:25:00',3.94),('10318','2013-05-28','08:30:00',4.82),('10318','2013-05-28','08:35:00',4.42),('10318','2013-05-28','08:40:00',3.75),('10318','2013-05-28','08:45:00',3.58),('10318','2013-05-28','08:50:00',4.21),('10318','2013-05-28','08:55:00',3.2),('10318','2013-05-28','09:00:00',3.54),('10318','2013-05-28','09:05:00',4.53),('10318','2013-05-28','09:10:00',4.27),('10318','2013-05-28','09:15:00',4.16),('10318','2013-05-28','09:20:00',4.67),('10318','2013-05-28','09:25:00',5.02),('10318','2013-05-28','09:30:00',5.61),('10318','2013-05-28','09:35:00',6.01),('10318','2013-05-28','09:40:00',5.35),('10318','2013-05-28','09:45:00',5.19),('10318','2013-05-28','09:50:00',5.18),('10318','2013-05-28','09:55:00',5.43),('10318','2013-05-28','10:00:00',4.89),('10318','2013-05-28','10:05:00',5.12),('10318','2013-05-28','10:10:00',5.76),('10318','2013-05-28','10:15:00',6.13),('10318','2013-05-28','10:20:00',6.27),('10318','2013-05-28','10:25:00',6.17),('10318','2013-05-28','10:30:00',6.7),('10318','2013-05-28','10:35:00',6.73),('10318','2013-05-28','10:40:00',7.07),('10318','2013-05-28','10:45:00',6.41),('10318','2013-05-28','10:50:00',5.93),('10318','2013-05-28','10:55:00',6.38),('10318','2013-05-28','11:00:00',6.37),('10318','2013-05-28','11:05:00',6.78),('10318','2013-05-28','11:10:00',6.35),('10318','2013-05-28','11:15:00',5.71),('10318','2013-05-28','11:20:00',4.78),('10318','2013-05-28','11:25:00',7.08),('10318','2013-05-28','11:30:00',8.93),('10318','2013-05-28','11:35:00',8.99),('10318','2013-05-28','11:40:00',10.22),('10318','2013-05-28','11:45:00',8.19),('10318','2013-05-28','11:50:00',2.52),('10318','2013-05-28','11:55:00',3.23),('10318','2013-05-28','12:00:00',3.67),('10318','2013-05-28','12:05:00',4.66),('10318','2013-05-28','12:10:00',5.02),('10318','2013-05-28','12:15:00',5.24),('10318','2013-05-28','12:20:00',5.06),('10318','2013-05-28','12:25:00',5.56),('10318','2013-05-28','12:30:00',6.35),('10318','2013-05-28','12:35:00',5.76),('10318','2013-05-28','12:40:00',5.9),('10318','2013-05-28','12:45:00',5.76),('10318','2013-05-28','12:50:00',5.61),('10318','2013-05-28','12:55:00',5.97),('10318','2013-05-28','13:00:00',6.15),('10318','2013-05-28','13:05:00',6.89),('10318','2013-05-28','13:10:00',8),('10318','2013-05-28','13:15:00',5.61),('10318','2013-05-28','13:20:00',5.19),('10318','2013-05-28','13:25:00',4.13),('10318','2013-05-28','13:30:00',5.65),('10318','2013-05-28','13:35:00',5.65),('10318','2013-05-28','13:40:00',5.13),('10318','2013-05-28','13:45:00',4.58),('10318','2013-05-28','13:50:00',4.61),('10318','2013-05-28','13:55:00',4.33),('10318','2013-05-28','14:00:00',4.96),('10318','2013-05-28','14:05:00',5.81),('10318','2013-05-28','14:10:00',5.72),('10318','2013-05-28','14:15:00',7.18),('10318','2013-05-28','14:20:00',6.44),('10318','2013-05-28','14:25:00',5.29),('10318','2013-05-28','14:30:00',6.69),('10318','2013-05-28','14:35:00',6.02),('10318','2013-05-28','14:40:00',6.38),('10318','2013-05-28','14:45:00',7.15),('10318','2013-05-28','14:50:00',7.49),('10318','2013-05-28','14:55:00',8.3),('10318','2013-05-28','15:00:00',6.44),('10318','2013-05-28','15:05:00',5.13),('10318','2013-05-28','15:10:00',3.57),('10318','2013-05-28','15:15:00',5.06),('10318','2013-05-28','15:20:00',6.36),('10318','2013-05-28','15:25:00',4.74),('10318','2013-05-28','15:30:00',3.35),('10318','2013-05-28','15:35:00',3.45),('10318','2013-05-28','15:40:00',3.88),('10318','2013-05-28','15:45:00',7.44),('10318','2013-05-28','15:50:00',5.61),('10318','2013-05-28','15:55:00',4.16),('10318','2013-05-28','16:00:00',3.35),('10318','2013-05-28','16:05:00',2.89),('10318','2013-05-28','16:10:00',3.01),('10318','2013-05-28','16:15:00',3.78),('10318','2013-05-28','16:20:00',4.77),('10318','2013-05-28','16:25:00',4.78),('10318','2013-05-28','16:30:00',5.81),('10318','2013-05-28','16:35:00',5.98),('10318','2013-05-28','16:40:00',5.44),('10318','2013-05-28','16:45:00',5.18),('10318','2013-05-28','16:50:00',5.01),('10318','2013-05-28','16:55:00',4.81),('10318','2013-05-28','17:00:00',4.61),('10318','2013-05-28','17:05:00',4.41),('10318','2013-05-28','17:10:00',4.23),('10318','2013-05-28','17:15:00',3.98),('10318','2013-05-28','17:20:00',3.91),('10318','2013-05-28','17:25:00',3.68),('10318','2013-05-28','17:30:00',3.49),('10318','2013-05-28','17:35:00',3.32),('10318','2013-05-28','17:40:00',3.14),('10318','2013-05-28','17:45:00',2.96),('10318','2013-05-28','17:50:00',2.79),('10318','2013-05-28','17:55:00',2.63),('10318','2013-05-28','18:00:00',2.54),('10318','2013-05-28','18:05:00',2.39),('10318','2013-05-28','18:10:00',1.4),('10318','2013-05-28','18:15:00',1.41),('10318','2013-05-28','18:20:00',1.26),('10318','2013-05-28','18:25:00',1.28),('10318','2013-05-28','18:30:00',1.37),('10318','2013-05-28','18:35:00',1.38),('10318','2013-05-28','18:40:00',1.26),('10318','2013-05-28','18:45:00',1.14),('10318','2013-05-28','18:50:00',1.03),('10318','2013-05-27','06:45:00',1.01),('10318','2013-05-27','06:50:00',1.07),('10318','2013-05-27','06:55:00',1.01),('10318','2013-05-27','07:00:00',1.17),('10318','2013-05-27','07:05:00',1.11),('10318','2013-05-27','07:10:00',1.36),('10318','2013-05-27','07:15:00',2.25),('10318','2013-05-27','07:20:00',1.68),('10318','2013-05-27','07:25:00',2.51),('10318','2013-05-27','07:30:00',3.09),('10318','2013-05-27','07:35:00',3.1),('10318','2013-05-27','07:40:00',3.33),('10318','2013-05-27','07:45:00',3.56),('10318','2013-05-27','07:50:00',4.25),('10318','2013-05-27','07:55:00',2.62),('10318','2013-05-27','08:00:00',4.25),('10318','2013-05-27','08:05:00',5.34),('10318','2013-05-27','08:10:00',5.9),('10318','2013-05-27','08:15:00',5.31),('10318','2013-05-27','08:20:00',4.09),('10318','2013-05-27','08:25:00',5.72),('10318','2013-05-27','08:30:00',5.75),('10318','2013-05-27','08:35:00',5.95),('10318','2013-05-27','08:40:00',6.52),('10318','2013-05-27','08:45:00',5.34),('10318','2013-05-27','08:50:00',1.49),('10318','2013-05-27','08:55:00',7.09),('10318','2013-05-27','09:00:00',8.05),('10318','2013-05-27','09:05:00',7.82),('10318','2013-05-27','09:10:00',5.12),('10318','2013-05-27','09:15:00',8.63),('10318','2013-05-27','09:20:00',3.77),('10318','2013-05-27','09:25:00',6.96),('10318','2013-05-27','09:30:00',8),('10318','2013-05-27','09:35:00',8.04),('10318','2013-05-27','09:40:00',8.17),('10318','2013-05-27','09:45:00',8.33),('10318','2013-05-27','09:50:00',8.7),('10318','2013-05-27','09:55:00',7.4),('10318','2013-05-27','10:00:00',7.4),('10318','2013-05-27','10:05:00',8.75),('10318','2013-05-27','10:10:00',8.8),('10318','2013-05-27','10:15:00',9.21),('10318','2013-05-27','10:20:00',8.87),('10318','2013-05-27','10:25:00',9.83),('10318','2013-05-27','10:30:00',9.59),('10318','2013-05-27','10:35:00',7.07),('10318','2013-05-27','10:40:00',4.89),('10318','2013-05-27','10:45:00',7.09),('10318','2013-05-27','10:50:00',11.26),('10318','2013-05-27','10:55:00',8.01),('10318','2013-05-27','11:00:00',6.18),('10318','2013-05-27','11:05:00',9.28),('10318','2013-05-27','11:10:00',10.23),('10318','2013-05-27','11:15:00',9.28),('10318','2013-05-27','11:20:00',8.39),('10318','2013-05-27','11:25:00',3.47),('10318','2013-05-27','11:30:00',8.81),('10318','2013-05-27','11:35:00',10.62),('10318','2013-05-27','11:40:00',4.89),('10318','2013-05-27','11:45:00',4.44),('10318','2013-05-27','11:50:00',9.01),('10318','2013-05-27','11:55:00',4.8),('10318','2013-05-27','12:00:00',3.36),('10318','2013-05-27','12:05:00',10.34),('10318','2013-05-27','12:10:00',5.39),('10318','2013-05-27','12:15:00',8.09),('10318','2013-05-27','12:20:00',2.81),('10318','2013-05-27','12:25:00',8.86),('10318','2013-05-27','12:30:00',4.08),('10318','2013-05-27','12:35:00',10.1),('10318','2013-05-27','12:40:00',5.99),('10318','2013-05-27','12:45:00',10.75),('10318','2013-05-27','12:50:00',10.81),('10318','2013-05-27','12:55:00',10.61),('10318','2013-05-27','13:00:00',8.45),('10318','2013-05-27','13:05:00',3.54),('10318','2013-05-27','13:10:00',9.04),('10318','2013-05-27','13:15:00',9.69),('10318','2013-05-27','13:20:00',7.8),('10318','2013-05-27','13:25:00',8.25),('10318','2013-05-27','13:30:00',8.6),('10318','2013-05-27','13:35:00',9.68),('10318','2013-05-27','13:40:00',10.47),('10318','2013-05-27','13:45:00',10.27),('10318','2013-05-27','13:50:00',10.13),('10318','2013-05-27','13:55:00',9.82),('10318','2013-05-27','14:00:00',9.52),('10318','2013-05-27','14:05:00',9.88),('10318','2013-05-27','14:10:00',9.56),('10318','2013-05-27','14:15:00',9.55),('10318','2013-05-27','14:20:00',9.6),('10318','2013-05-27','14:25:00',9.48),('10318','2013-05-27','14:30:00',9.4),('10318','2013-05-27','14:35:00',9.38),('10318','2013-05-27','14:40:00',7.33),('10318','2013-05-27','14:45:00',6.87),('10318','2013-05-27','14:50:00',9.49),('10318','2013-05-27','14:55:00',7.39),('10318','2013-05-27','15:00:00',4.89),('10318','2013-05-27','15:05:00',6.59),('10318','2013-05-27','15:10:00',9.04),('10318','2013-05-27','15:15:00',6.41),('10318','2013-05-27','15:20:00',6.76),('10318','2013-05-27','15:25:00',7.27),('10318','2013-05-27','15:30:00',8.1),('10318','2013-05-27','15:35:00',8.19),('10318','2013-05-27','15:40:00',6.66),('10318','2013-05-27','15:45:00',6.69),('10318','2013-05-27','15:50:00',7.47),('10318','2013-05-27','15:55:00',5.06),('10318','2013-05-27','16:00:00',6.5),('10318','2013-05-27','16:05:00',5.16),('10318','2013-05-27','16:10:00',4.95),('10318','2013-05-27','16:15:00',5.23),('10318','2013-05-27','16:20:00',7.72),('10318','2013-05-27','16:25:00',6.89),('10318','2013-05-27','16:30:00',6.25),('10318','2013-05-27','16:35:00',4.62),('10318','2013-05-27','16:40:00',2.81),('10318','2013-05-27','16:45:00',2.67),('10318','2013-05-27','16:50:00',2.8),('10318','2013-05-27','16:55:00',3.01),('10318','2013-05-27','17:00:00',3.13),('10318','2013-05-27','17:05:00',3.29),('10318','2013-05-27','17:10:00',3.77),('10318','2013-05-27','17:15:00',3.07),('10318','2013-05-27','17:20:00',2.73),('10318','2013-05-27','17:25:00',2.58),('10318','2013-05-27','17:30:00',2.52),('10318','2013-05-27','17:35:00',2.29),('10318','2013-05-27','17:40:00',2.15),('10318','2013-05-27','17:45:00',2.05),('10318','2013-05-27','17:50:00',1.96),('10318','2013-05-27','17:55:00',2.03),('10318','2013-05-27','18:00:00',1.95),('10318','2013-05-27','18:05:00',1.79),('10318','2013-05-27','18:10:00',1.95),('10318','2013-05-27','18:15:00',2.02),('10318','2013-05-27','18:20:00',2.65),('10318','2013-05-27','18:25:00',3.05),('10318','2013-05-27','18:30:00',2.39),('10318','2013-05-27','18:35:00',1.55),('10318','2013-05-27','18:40:00',1.11),('10318','2013-05-27','18:45:00',1.3),('10318','2013-05-27','18:50:00',1.13),('10318','2013-05-27','18:55:00',1.58),('10318','2013-05-27','19:00:00',1.53),('10318','2013-05-27','19:05:00',1.4),('10318','2013-05-27','19:10:00',1.18),('10318','2013-05-26','07:15:00',1.17),('10318','2013-05-26','07:20:00',2.54),('10318','2013-05-26','07:25:00',1.46),('10318','2013-05-26','07:30:00',1.9),('10318','2013-05-26','07:35:00',1.94),('10318','2013-05-26','07:40:00',2.43),('10318','2013-05-26','07:45:00',4.51),('10318','2013-05-26','07:50:00',4.03),('10318','2013-05-26','08:00:00',4.28),('10318','2013-05-26','08:05:00',5.91),('10318','2013-05-26','08:10:00',2.09),('10318','2013-05-26','08:15:00',4.68),('10318','2013-05-26','08:20:00',5.03),('10318','2013-05-26','08:25:00',6.18),('10318','2013-05-26','08:30:00',5.1),('10318','2013-05-26','08:35:00',6.57),('10318','2013-05-26','08:40:00',4.02),('10318','2013-05-26','08:45:00',5.57),('10318','2013-05-26','08:50:00',2.03),('10318','2013-05-26','08:55:00',7.76),('10318','2013-05-26','09:00:00',3.41),('10318','2013-05-26','09:05:00',1.89),('10318','2013-05-26','09:10:00',6.88),('10318','2013-05-26','09:15:00',3.53),('10318','2013-05-26','09:20:00',2.05),('10318','2013-05-26','09:25:00',2.26),('10318','2013-05-26','09:30:00',2.83),('10318','2013-05-26','09:35:00',1.31),('10318','2013-05-26','09:40:00',4.92),('10318','2013-05-26','09:45:00',1.99),('10318','2013-05-26','09:50:00',1.61),('10318','2013-05-26','09:55:00',4.49),('10318','2013-05-26','10:00:00',4.18),('10318','2013-05-26','10:05:00',7.71),('10318','2013-05-26','10:10:00',8.26),('10318','2013-05-26','10:15:00',5.38),('10318','2013-05-26','10:20:00',8.16),('10318','2013-05-26','10:25:00',9.98),('10318','2013-05-26','10:30:00',9.59),('10318','2013-05-26','10:35:00',7.7),('10318','2013-05-26','10:40:00',9.43),('10318','2013-05-26','10:45:00',9.84),('10318','2013-05-26','10:50:00',10.03),('10318','2013-05-26','10:55:00',10.12),('10318','2013-05-26','11:00:00',10.15),('10318','2013-05-26','11:05:00',10.15),('10318','2013-05-26','11:10:00',10.19),('10318','2013-05-26','11:15:00',10.3),('10318','2013-05-26','11:20:00',10.36),('10318','2013-05-26','11:25:00',8.66),('10318','2013-05-26','11:30:00',10.48),('10318','2013-05-26','11:35:00',10.51),('10318','2013-05-26','11:40:00',10.62),('10318','2013-05-26','11:45:00',10.53),('10318','2013-05-26','11:50:00',10.6),('10318','2013-05-26','11:55:00',10.66),('10318','2013-05-26','12:00:00',10.68),('10318','2013-05-26','12:05:00',10.8),('10318','2013-05-26','12:10:00',10.81),('10318','2013-05-26','12:15:00',10.76),('10318','2013-05-26','12:20:00',9.88),('10318','2013-05-26','12:25:00',8.74),('10318','2013-05-26','12:30:00',9.7),('10318','2013-05-26','12:35:00',9.05),('10318','2013-05-26','12:40:00',6.6),('10318','2013-05-26','12:45:00',8.8),('10318','2013-05-26','12:50:00',9.5),('10318','2013-05-26','12:55:00',10.62),('10318','2013-05-26','13:00:00',9.96),('10318','2013-05-26','13:05:00',9.83),('10318','2013-05-26','13:10:00',10.1),('10318','2013-05-26','13:15:00',10.38),('10318','2013-05-26','13:20:00',10.52),('10318','2013-05-26','13:25:00',10.48),('10318','2013-05-26','13:30:00',10.43),('10318','2013-05-26','13:35:00',10.29),('10318','2013-05-26','13:40:00',10.29),('10318','2013-05-26','13:45:00',8.81),('10318','2013-05-26','13:50:00',9.76),('10318','2013-05-26','13:55:00',10.07),('10318','2013-05-26','14:00:00',10.01),('10318','2013-05-26','14:05:00',9.91),('10318','2013-05-26','14:10:00',9.77),('10318','2013-05-26','14:15:00',9.8),('10318','2013-05-26','14:20:00',9.72),('10318','2013-05-26','14:25:00',9.62),('10318','2013-05-26','14:30:00',9.54),('10318','2013-05-26','14:35:00',9.49),('10318','2013-05-26','14:40:00',9.35),('10318','2013-05-26','14:45:00',9.3),('10318','2013-05-26','14:50:00',9.23),('10318','2013-05-26','14:55:00',9.02),('10318','2013-05-26','15:00:00',8.94),('10318','2013-05-26','15:05:00',8.8),('10318','2013-05-26','15:10:00',8.67),('10318','2013-05-26','15:15:00',8.58),('10318','2013-05-26','15:20:00',8.47),('10318','2013-05-26','15:25:00',8.32),('10318','2013-05-26','15:30:00',8.18),('10318','2013-05-26','15:35:00',8.02),('10318','2013-05-26','15:40:00',7.9),('10318','2013-05-26','15:45:00',7.76),('10318','2013-05-26','15:50:00',7.65),('10318','2013-05-26','15:55:00',7.47),('10318','2013-05-26','16:00:00',7.29),('10318','2013-05-26','16:05:00',7.11),('10318','2013-05-26','16:10:00',6.94),('10318','2013-05-26','16:15:00',6.78),('10318','2013-05-26','16:20:00',6.63),('10318','2013-05-26','16:25:00',6.45),('10318','2013-05-26','16:30:00',6.29),('10318','2013-05-26','16:35:00',6.1),('10318','2013-05-26','16:40:00',5.89),('10318','2013-05-26','16:45:00',5.68),('10318','2013-05-26','16:50:00',5.52),('10318','2013-05-26','16:55:00',5.33),('10318','2013-05-26','17:00:00',5.11),('10318','2013-05-26','17:05:00',4.91),('10318','2013-05-26','17:10:00',4.71),('10318','2013-05-26','17:15:00',4.51),('10318','2013-05-26','17:20:00',4.3),('10318','2013-05-26','17:25:00',4.14),('10318','2013-05-26','17:30:00',3.93),('10318','2013-05-26','17:35:00',3.69),('10318','2013-05-26','17:40:00',3.48),('10318','2013-05-26','17:45:00',3.26),('10318','2013-05-26','17:50:00',3.07),('10318','2013-05-26','17:55:00',2.89),('10318','2013-05-26','18:00:00',2.61),('10318','2013-05-26','18:05:00',2.47),('10318','2013-05-26','18:10:00',2.26),('10318','2013-05-26','18:15:00',2.06),('10318','2013-05-26','18:20:00',1.9),('10318','2013-05-26','18:25:00',1.72),('10318','2013-05-26','18:30:00',1.53),('10318','2013-05-26','18:35:00',1.39),('10318','2013-05-26','18:40:00',1.27),('10318','2013-05-26','18:45:00',1.1),('10318','2013-05-25','07:10:00',1.13),('10318','2013-05-25','07:20:00',1.23),('10318','2013-05-25','07:25:00',3.27),('10318','2013-05-25','07:30:00',3.84),('10318','2013-05-25','07:35:00',4.27),('10318','2013-05-25','07:40:00',1.83),('10318','2013-05-25','07:45:00',3.68),('10318','2013-05-25','07:50:00',4.45),('10318','2013-05-25','07:55:00',5.36),('10318','2013-05-25','08:00:00',4.48),('10318','2013-05-25','08:05:00',3.29),('10318','2013-05-25','08:10:00',1.24),('10318','2013-05-25','08:15:00',2.8),('10318','2013-05-25','08:20:00',4.28),('10318','2013-05-25','08:25:00',7.28),('10318','2013-05-25','08:30:00',5.79),('10318','2013-05-25','08:35:00',2.4),('10318','2013-05-25','08:40:00',3.59),('10318','2013-05-25','08:45:00',2.54),('10318','2013-05-25','08:50:00',6.59),('10318','2013-05-25','08:55:00',7.66),('10318','2013-05-25','09:00:00',8.07),('10318','2013-05-25','09:05:00',8.23),('10318','2013-05-25','09:10:00',8.05),('10318','2013-05-25','09:15:00',4.24),('10318','2013-05-25','09:20:00',3.15),('10318','2013-05-25','09:25:00',5.71),('10318','2013-05-25','09:30:00',5.16),('10318','2013-05-25','09:35:00',7.26),('10318','2013-05-25','09:40:00',8.63),('10318','2013-05-25','09:45:00',7.72),('10318','2013-05-25','09:50:00',8.11),('10318','2013-05-25','09:55:00',3),('10318','2013-05-25','10:00:00',1.64),('10318','2013-05-25','10:05:00',2.29),('10318','2013-05-25','10:10:00',3.47),('10318','2013-05-25','10:15:00',1.58),('10318','2013-05-25','10:20:00',1.69),('10318','2013-05-25','10:25:00',1.63),('10318','2013-05-25','10:30:00',1.54),('10318','2013-05-25','10:35:00',2.31),('10318','2013-05-25','10:40:00',2.78),('10318','2013-05-25','10:45:00',2.46),('10318','2013-05-25','10:50:00',2.05),('10318','2013-05-25','10:55:00',1.59),('10318','2013-05-25','11:00:00',3.99),('10318','2013-05-25','11:05:00',9.54),('10318','2013-05-25','11:10:00',9.28),('10318','2013-05-25','11:15:00',7.04),('10318','2013-05-25','11:20:00',3.28),('10318','2013-05-25','11:25:00',1.14),('10318','2013-05-25','11:30:00',2.48),('10318','2013-05-25','11:35:00',5.95),('10318','2013-05-25','11:40:00',5.46),('10318','2013-05-25','11:45:00',4.5),('10318','2013-05-25','11:50:00',3.4),('10318','2013-05-25','11:55:00',3.3),('10318','2013-05-25','12:00:00',5.44),('10318','2013-05-25','12:05:00',7.85),('10318','2013-05-25','12:10:00',6.38),('10318','2013-05-25','12:15:00',3.27),('10318','2013-05-25','12:20:00',8.6),('10318','2013-05-25','12:25:00',6.5),('10318','2013-05-25','12:30:00',3.52),('10318','2013-05-25','12:35:00',7.27),('10318','2013-05-25','12:40:00',3.32),('10318','2013-05-25','12:45:00',2.6),('10318','2013-05-25','12:50:00',2.59),('10318','2013-05-25','12:55:00',2.54),('10318','2013-05-25','13:00:00',4.28),('10318','2013-05-25','13:05:00',3.46),('10318','2013-05-25','13:10:00',4.08),('10318','2013-05-25','13:15:00',4.33),('10318','2013-05-25','13:20:00',5.3),('10318','2013-05-25','13:25:00',6.93),('10318','2013-05-25','13:30:00',3.12),('10318','2013-05-25','13:35:00',4.34),('10318','2013-05-25','13:40:00',7.05),('10318','2013-05-25','13:45:00',9.24),('10318','2013-05-25','13:50:00',8.18),('10318','2013-05-25','13:55:00',8.75),('10318','2013-05-25','14:00:00',7.47),('10318','2013-05-25','14:05:00',9.61),('10318','2013-05-25','14:10:00',8.26),('10318','2013-05-25','14:15:00',6.39),('10318','2013-05-25','14:20:00',5.75),('10318','2013-05-25','14:25:00',8.51),('10318','2013-05-25','14:30:00',7.22),('10318','2013-05-25','14:35:00',9.79),('10318','2013-05-25','14:40:00',6.41),('10318','2013-05-25','14:45:00',10.18),('10318','2013-05-25','14:50:00',9.43),('10318','2013-05-25','14:55:00',5.74),('10318','2013-05-25','15:00:00',4.17),('10318','2013-05-25','15:05:00',4.23),('10318','2013-05-25','15:10:00',5.88),('10318','2013-05-25','15:15:00',4.11),('10318','2013-05-25','15:20:00',7.68),('10318','2013-05-25','15:25:00',8.99),('10318','2013-05-25','15:30:00',7),('10318','2013-05-25','15:35:00',5.84),('10318','2013-05-25','15:40:00',7.92),('10318','2013-05-25','15:45:00',5.8),('10318','2013-05-25','15:50:00',2.76),('10318','2013-05-25','15:55:00',8.51),('10318','2013-05-25','16:00:00',5.25),('10318','2013-05-25','16:05:00',7.35),('10318','2013-05-25','16:10:00',3.13),('10318','2013-05-25','16:15:00',6.68),('10318','2013-05-25','16:20:00',4.37),('10318','2013-05-25','16:25:00',5.51),('10318','2013-05-25','16:30:00',5.86),('10318','2013-05-25','16:35:00',2.81),('10318','2013-05-25','16:40:00',3.06),('10318','2013-05-25','16:45:00',4.35),('10318','2013-05-25','16:50:00',5.95),('10318','2013-05-25','16:55:00',6.19),('10318','2013-05-25','17:00:00',4.8),('10318','2013-05-25','17:05:00',3.8),('10318','2013-05-25','17:10:00',1.67),('10318','2013-05-25','17:15:00',3.62),('10318','2013-05-25','17:20:00',1.69),('10318','2013-05-25','17:25:00',1.41),('10318','2013-05-25','17:30:00',1.42),('10318','2013-05-25','17:35:00',2.17),('10318','2013-05-25','17:40:00',3.99),('10318','2013-05-25','17:45:00',2.53),('10318','2013-05-25','17:50:00',3.67),('10318','2013-05-25','17:55:00',2.09),('10318','2013-05-25','18:00:00',2.79),('10318','2013-05-25','18:05:00',2.11),('10318','2013-05-25','18:10:00',1.32),('10318','2013-05-25','18:15:00',1.28),('10318','2013-05-25','18:20:00',1.17),('10318','2013-05-25','18:35:00',1.24),('10318','2013-05-24','06:55:00',1.22),('10318','2013-05-24','07:00:00',1.99),('10318','2013-05-24','07:05:00',1.07),('10318','2013-05-24','07:30:00',1.1),('10318','2013-05-24','07:35:00',1.18),('10318','2013-05-24','07:40:00',1.51),('10318','2013-05-24','07:45:00',1.31),('10318','2013-05-24','07:50:00',1),('10318','2013-05-24','07:55:00',1.19),('10318','2013-05-24','08:00:00',2.61),('10318','2013-05-24','08:05:00',3.94),('10318','2013-05-24','08:10:00',2.77),('10318','2013-05-24','08:15:00',2.98),('10318','2013-05-24','08:20:00',1.92),('10318','2013-05-24','08:25:00',5.54),('10318','2013-05-24','08:30:00',5.35),('10318','2013-05-24','08:35:00',3.97),('10318','2013-05-24','08:40:00',6.16),('10318','2013-05-24','08:45:00',6.26),('10318','2013-05-24','08:50:00',6.45),('10318','2013-05-24','08:55:00',5.87),('10318','2013-05-24','09:00:00',7.34),('10318','2013-05-24','09:05:00',6.83),('10318','2013-05-24','09:10:00',1.1),('10318','2013-05-24','09:15:00',2.76),('10318','2013-05-24','09:20:00',2.24),('10318','2013-05-24','09:25:00',4.8),('10318','2013-05-24','09:30:00',4.4),('10318','2013-05-24','09:35:00',1.85),('10318','2013-05-24','09:40:00',3.07),('10318','2013-05-24','09:45:00',2.33),('10318','2013-05-24','09:50:00',3.71),('10318','2013-05-24','09:55:00',9.41),('10318','2013-05-24','10:00:00',6.44),('10318','2013-05-24','10:05:00',1.41),('10318','2013-05-24','10:10:00',1.02),('10318','2013-05-24','10:15:00',1.22),('10318','2013-05-24','10:20:00',3.72),('10318','2013-05-24','10:25:00',5.05),('10318','2013-05-24','10:30:00',9.95),('10318','2013-05-24','10:35:00',9.46),('10318','2013-05-24','10:40:00',9.55),('10318','2013-05-24','10:45:00',7.89),('10318','2013-05-24','10:50:00',9.46),('10318','2013-05-24','10:55:00',8.78),('10318','2013-05-24','11:00:00',6.72),('10318','2013-05-24','11:05:00',9.67),('10318','2013-05-24','11:10:00',9.48),('10318','2013-05-24','11:15:00',4.73),('10318','2013-05-24','11:20:00',9.66),('10318','2013-05-24','11:25:00',10.79),('10318','2013-05-24','11:30:00',10.36),('10318','2013-05-24','11:35:00',4.63),('10318','2013-05-24','11:40:00',2.17),('10318','2013-05-24','11:45:00',6.25),('10318','2013-05-24','11:50:00',6.78),('10318','2013-05-24','11:55:00',10.34),('10318','2013-05-24','12:00:00',8),('10318','2013-05-24','12:05:00',5.69),('10318','2013-05-24','12:10:00',5.65),('10318','2013-05-24','12:15:00',7.54),('10318','2013-05-24','12:20:00',7.27),('10318','2013-05-24','12:25:00',6.11),('10318','2013-05-24','12:30:00',5.94),('10318','2013-05-24','12:35:00',6.93),('10318','2013-05-24','12:40:00',5.1),('10318','2013-05-24','12:45:00',4.41),('10318','2013-05-24','12:50:00',6.24),('10318','2013-05-24','12:55:00',7.14),('10318','2013-05-24','13:00:00',8.56),('10318','2013-05-24','13:05:00',8.71),('10318','2013-05-24','13:10:00',6.82),('10318','2013-05-24','13:15:00',7.41),('10318','2013-05-24','13:20:00',7.54),('10318','2013-05-24','13:25:00',5.52),('10318','2013-05-24','13:30:00',6.81),('10318','2013-05-24','13:35:00',5.23),('10318','2013-05-24','13:40:00',3.31),('10318','2013-05-24','13:45:00',2.58),('10318','2013-05-24','13:50:00',3.16),('10318','2013-05-24','13:55:00',9.22),('10318','2013-05-24','14:00:00',5.64),('10318','2013-05-24','14:05:00',3.47),('10318','2013-05-24','14:10:00',6.97),('10318','2013-05-24','14:15:00',6.51),('10318','2013-05-24','14:20:00',4.19),('10318','2013-05-24','14:25:00',5.07),('10318','2013-05-24','14:30:00',8.16),('10318','2013-05-24','14:35:00',8.17),('10318','2013-05-24','14:40:00',7.86),('10318','2013-05-24','14:45:00',6.02),('10318','2013-05-24','14:50:00',5.96),('10318','2013-05-24','14:55:00',5.91),('10318','2013-05-24','15:00:00',4.76),('10318','2013-05-24','15:05:00',6.53),('10318','2013-05-24','15:10:00',7.84),('10318','2013-05-24','15:15:00',7.2),('10318','2013-05-24','15:20:00',8.32),('10318','2013-05-24','15:25:00',10.09),('10318','2013-05-24','15:30:00',8.94),('10318','2013-05-24','15:35:00',5.93),('10318','2013-05-24','15:40:00',5.58),('10318','2013-05-24','15:45:00',7.51),('10318','2013-05-24','15:50:00',6.74),('10318','2013-05-24','15:55:00',4.69),('10318','2013-05-24','16:00:00',4.44),('10318','2013-05-24','16:05:00',4.39),('10318','2013-05-24','16:10:00',4.83),('10318','2013-05-24','16:15:00',4.54),('10318','2013-05-24','16:20:00',4.94),('10318','2013-05-24','16:25:00',7.51),('10318','2013-05-24','16:30:00',3.83),('10318','2013-05-24','16:35:00',2.53),('10318','2013-05-24','16:40:00',1.55),('10318','2013-05-24','16:45:00',2.59),('10318','2013-05-24','16:50:00',3.81),('10318','2013-05-24','16:55:00',3.11),('10318','2013-05-24','17:00:00',2.88),('10318','2013-05-24','17:05:00',2.46),('10318','2013-05-24','17:10:00',2.05),('10318','2013-05-24','17:15:00',2.16),('10318','2013-05-24','17:20:00',2.49),('10318','2013-05-24','17:25:00',2.3),('10318','2013-05-24','17:30:00',2.13),('10318','2013-05-24','17:35:00',2.07),('10318','2013-05-24','17:40:00',2.07),('10318','2013-05-24','17:45:00',1.91),('10318','2013-05-24','17:50:00',1.49),('10318','2013-05-24','17:55:00',1.12),('10318','2013-05-24','18:00:00',1.11),('10318','2013-05-24','18:05:00',1.17),('10318','2013-05-24','18:10:00',1.05),('10318','2013-05-24','18:30:00',1.03),('10318','2013-05-23','07:00:00',1.35),('10318','2013-05-23','07:05:00',1.8),('10318','2013-05-23','07:10:00',1.66),('10318','2013-05-23','07:35:00',1.14),('10318','2013-05-23','07:40:00',1.38),('10318','2013-05-23','07:45:00',1.84),('10318','2013-05-23','07:50:00',2.24),('10318','2013-05-23','07:55:00',2.29),('10318','2013-05-23','08:00:00',2.6),('10318','2013-05-23','08:05:00',3.4),('10318','2013-05-23','08:10:00',2.12),('10318','2013-05-23','08:15:00',1.68),('10318','2013-05-23','08:20:00',1.26),('10318','2013-05-23','08:25:00',2.6),('10318','2013-05-23','08:30:00',4.56),('10318','2013-05-23','08:35:00',6.35),('10318','2013-05-23','08:40:00',6.86),('10318','2013-05-23','08:45:00',2.13),('10318','2013-05-23','08:55:00',1.63),('10318','2013-05-23','09:00:00',1.84),('10318','2013-05-23','09:15:00',3.78),('10318','2013-05-23','09:20:00',7.78),('10318','2013-05-23','09:25:00',4.86),('10318','2013-05-23','09:30:00',2.71),('10318','2013-05-23','09:35:00',5.89),('10318','2013-05-23','09:40:00',5.11),('10318','2013-05-23','09:45:00',7.46),('10318','2013-05-23','09:50:00',4.92),('10318','2013-05-23','09:55:00',5.85),('10318','2013-05-23','10:00:00',9.06),('10318','2013-05-23','10:05:00',5.84),('10318','2013-05-23','10:10:00',6.72),('10318','2013-05-23','10:15:00',7.58),('10318','2013-05-23','10:20:00',8.27),('10318','2013-05-23','10:25:00',9.13),('10318','2013-05-23','10:30:00',9),('10318','2013-05-23','10:35:00',5.61),('10318','2013-05-23','10:40:00',7.47),('10318','2013-05-23','10:45:00',9),('10318','2013-05-23','10:50:00',9.05),('10318','2013-05-23','10:55:00',4.79),('10318','2013-05-23','11:00:00',8.75),('10318','2013-05-23','11:05:00',5.57),('10318','2013-05-23','11:10:00',8.69),('10318','2013-05-23','11:15:00',8.8),('10318','2013-05-23','11:20:00',4.42),('10318','2013-05-23','11:25:00',8.48),('10318','2013-05-23','11:30:00',8.42),('10318','2013-05-23','11:35:00',10.87),('10318','2013-05-23','11:40:00',7.87),('10318','2013-05-23','11:45:00',3.55),('10318','2013-05-23','11:50:00',3),('10318','2013-05-23','11:55:00',7.36),('10318','2013-05-23','12:00:00',10.81),('10318','2013-05-23','12:05:00',10.05),('10318','2013-05-23','12:10:00',8.63),('10318','2013-05-23','12:15:00',8.25),('10318','2013-05-23','12:20:00',7.92),('10318','2013-05-23','12:25:00',3.41),('10318','2013-05-23','12:30:00',2.23),('10318','2013-05-23','12:35:00',4.59),('10318','2013-05-23','12:40:00',9.63),('10318','2013-05-23','12:45:00',8.41),('10318','2013-05-23','12:50:00',4.65),('10318','2013-05-23','12:55:00',7.21),('10318','2013-05-23','13:00:00',7.98),('10318','2013-05-23','13:05:00',9.35),('10318','2013-05-23','13:10:00',8.51),('10318','2013-05-23','13:15:00',10.59),('10318','2013-05-23','13:20:00',8.44),('10318','2013-05-23','13:25:00',6.54),('10318','2013-05-23','13:30:00',4.86),('10318','2013-05-23','13:35:00',7.86),('10318','2013-05-23','13:40:00',9.05),('10318','2013-05-23','13:45:00',6.3),('10318','2013-05-23','13:50:00',10.36),('10318','2013-05-23','13:55:00',7.14),('10318','2013-05-23','14:00:00',5.58),('10318','2013-05-23','14:05:00',4.71),('10318','2013-05-23','14:10:00',8.03),('10318','2013-05-23','14:15:00',6.64),('10318','2013-05-23','14:20:00',5.09),('10318','2013-05-23','14:25:00',4.55),('10318','2013-05-23','14:30:00',6.86),('10318','2013-05-23','14:35:00',5.65),('10318','2013-05-23','14:40:00',3.49),('10318','2013-05-23','14:45:00',5.02),('10318','2013-05-23','14:50:00',9.6),('10318','2013-05-23','14:55:00',7.07),('10318','2013-05-23','15:00:00',6.89),('10318','2013-05-23','15:05:00',5.73),('10318','2013-05-23','15:10:00',4.03),('10318','2013-05-23','15:15:00',8.41),('10318','2013-05-23','15:20:00',6.35),('10318','2013-05-23','15:25:00',9.5),('10318','2013-05-23','15:30:00',4.56),('10318','2013-05-23','15:35:00',5.69),('10318','2013-05-23','15:40:00',8.24),('10318','2013-05-23','15:45:00',4.66),('10318','2013-05-23','15:50:00',3.69),('10318','2013-05-23','15:55:00',7.47),('10318','2013-05-23','16:00:00',5.19),('10318','2013-05-23','16:05:00',4.72),('10318','2013-05-23','16:10:00',5.89),('10318','2013-05-23','16:15:00',7.43),('10318','2013-05-23','16:20:00',5.67),('10318','2013-05-23','16:25:00',4.18),('10318','2013-05-23','16:30:00',4.48),('10318','2013-05-23','16:35:00',4.9),('10318','2013-05-23','16:40:00',4.42),('10318','2013-05-23','16:45:00',4.06),('10318','2013-05-23','16:50:00',1.7),('10318','2013-05-23','16:55:00',1.33),('10318','2013-05-23','17:00:00',2.11),('10318','2013-05-23','17:05:00',4.67),('10318','2013-05-23','17:10:00',5.29),('10318','2013-05-23','17:15:00',1.87),('10318','2013-05-23','17:20:00',2.4),('10318','2013-05-23','17:25:00',1.66),('10318','2013-05-23','17:30:00',1.85),('10318','2013-05-23','17:35:00',1.93),('10318','2013-05-23','17:40:00',1.8),('10318','2013-05-23','17:45:00',2.02),('10318','2013-05-23','17:50:00',2.74),('10318','2013-05-23','17:55:00',2.85),('10318','2013-05-23','18:00:00',4.3),('10318','2013-05-23','18:05:00',2.19),('10318','2013-05-23','18:10:00',1.24),('10318','2013-05-23','18:35:00',1.07),('10318','2013-05-23','18:40:00',1.54),('10318','2013-05-23','18:45:00',1.91),('10318','2013-05-23','18:50:00',2.09),('10318','2013-05-23','18:55:00',1.83),('10318','2013-05-23','19:00:00',1.27),('10318','2013-05-22','07:10:00',1.06),('10318','2013-05-22','07:15:00',1.29),('10318','2013-05-22','07:20:00',1.39),('10318','2013-05-22','07:25:00',1.43),('10318','2013-05-22','07:30:00',1.29),('10318','2013-05-22','07:35:00',1.3),('10318','2013-05-22','07:40:00',1.5),('10318','2013-05-22','07:45:00',1.79),('10318','2013-05-22','07:50:00',2.28),('10318','2013-05-22','07:55:00',2.42),('10318','2013-05-22','08:00:00',2.67),('10318','2013-05-22','08:05:00',3.55),('10318','2013-05-22','08:10:00',3.94),('10318','2013-05-22','08:15:00',5.11),('10318','2013-05-22','08:20:00',3.38),('10318','2013-05-22','08:25:00',4.36),('10318','2013-05-22','08:30:00',5.71),('10318','2013-05-22','08:35:00',5.88),('10318','2013-05-22','08:40:00',2.89),('10318','2013-05-22','08:45:00',2.78),('10318','2013-05-22','08:50:00',1.24),('10318','2013-05-22','09:10:00',1.46),('10318','2013-05-22','09:15:00',2.02),('10318','2013-05-22','09:20:00',2.96),('10318','2013-05-22','09:25:00',5.07),('10318','2013-05-22','09:30:00',7.51),('10318','2013-05-22','09:35:00',7.36),('10318','2013-05-22','09:40:00',7.39),('10318','2013-05-22','09:45:00',7.4),('10318','2013-05-22','09:50:00',7.53),('10318','2013-05-22','09:55:00',7.49),('10318','2013-05-22','10:00:00',7.83),('10318','2013-05-22','10:05:00',7.94),('10318','2013-05-22','10:10:00',8),('10318','2013-05-22','10:15:00',8.1),('10318','2013-05-22','10:20:00',7.73),('10318','2013-05-22','10:25:00',6.55),('10318','2013-05-22','10:30:00',7.67),('10318','2013-05-22','10:35:00',8.63),('10318','2013-05-22','10:40:00',9.32),('10318','2013-05-22','10:45:00',8.95),('10318','2013-05-22','10:50:00',8.7),('10318','2013-05-22','10:55:00',8.7),('10318','2013-05-22','11:00:00',8.95),('10318','2013-05-22','11:05:00',7.97),('10318','2013-05-22','11:10:00',9.24),('10318','2013-05-22','11:15:00',9.25),('10318','2013-05-22','11:20:00',9.29),('10318','2013-05-22','11:25:00',9.05),('10318','2013-05-22','11:30:00',6.42),('10318','2013-05-22','11:35:00',9.53),('10318','2013-05-22','11:40:00',10.15),('10318','2013-05-22','11:45:00',8.23),('10318','2013-05-22','11:50:00',8.24),('10318','2013-05-22','11:55:00',5.1),('10318','2013-05-22','12:00:00',5.59),('10318','2013-05-22','12:05:00',5.54),('10318','2013-05-22','12:10:00',5.39),('10318','2013-05-22','12:15:00',6.2),('10318','2013-05-22','12:20:00',8.33),('10318','2013-05-22','12:25:00',8.36),('10318','2013-05-22','12:30:00',4.34),('10318','2013-05-22','12:35:00',3.95),('10318','2013-05-22','12:40:00',3.23),('10318','2013-05-22','12:45:00',1.78),('10318','2013-05-22','13:00:00',1.6),('10318','2013-05-22','13:05:00',6.93),('10318','2013-05-22','13:10:00',4.67),('10318','2013-05-22','13:15:00',5.56),('10318','2013-05-22','13:20:00',5.15),('10318','2013-05-22','13:25:00',2.46),('10318','2013-05-22','13:30:00',6.92),('10318','2013-05-22','13:35:00',8.66),('10318','2013-05-22','13:40:00',9.21),('10318','2013-05-22','13:45:00',7.78),('10318','2013-05-22','13:50:00',8),('10318','2013-05-22','13:55:00',9.66),('10318','2013-05-22','14:00:00',7.97),('10318','2013-05-22','14:05:00',7.47),('10318','2013-05-22','14:10:00',9.38),('10318','2013-05-22','14:15:00',9.15),('10318','2013-05-22','14:20:00',8.91),('10318','2013-05-22','14:25:00',8.76),('10318','2013-05-22','14:30:00',8.68),('10318','2013-05-22','14:35:00',8.61),('10318','2013-05-22','14:40:00',8.46),('10318','2013-05-22','14:45:00',8.4),('10318','2013-05-22','14:50:00',8.3),('10318','2013-05-22','14:55:00',8.18),('10318','2013-05-22','15:00:00',8.08),('10318','2013-05-22','15:05:00',7.95),('10318','2013-05-22','15:10:00',7.42),('10318','2013-05-22','15:15:00',7.56),('10318','2013-05-22','15:20:00',7.98),('10318','2013-05-22','15:25:00',5.48),('10318','2013-05-22','15:30:00',5.96),('10318','2013-05-22','15:35:00',4.1),('10318','2013-05-22','15:40:00',7.03),('10318','2013-05-22','15:45:00',7.24),('10318','2013-05-22','15:50:00',6.97),('10318','2013-05-22','15:55:00',6.7),('10318','2013-05-22','16:00:00',6.56),('10318','2013-05-22','16:05:00',6.33),('10318','2013-05-22','16:10:00',6.23),('10318','2013-05-22','16:15:00',6.06),('10318','2013-05-22','16:20:00',5.86),('10318','2013-05-22','16:25:00',5.73),('10318','2013-05-22','16:30:00',4.08),('10318','2013-05-22','16:35:00',4.67),('10318','2013-05-22','16:40:00',5.16),('10318','2013-05-22','16:45:00',4.03),('10318','2013-05-22','16:50:00',2.27),('10318','2013-05-22','16:55:00',1.64),('10318','2013-05-22','17:00:00',1.41),('10318','2013-05-22','17:05:00',1.45),('10318','2013-05-22','17:10:00',1.54),('10318','2013-05-22','17:15:00',2.58),('10318','2013-05-22','17:20:00',2.82),('10318','2013-05-22','17:25:00',2.78),('10318','2013-05-22','17:30:00',2.89),('10318','2013-05-22','17:35:00',3.44),('10318','2013-05-22','17:40:00',2.17),('10318','2013-05-22','17:45:00',1.06),('10318','2013-05-22','17:50:00',1.01),('10318','2013-05-22','17:55:00',2.55),('10318','2013-05-22','18:00:00',3.47),('10318','2013-05-22','18:05:00',2.87),('10318','2013-05-22','18:10:00',1.43),('10318','2013-05-22','18:15:00',1.28),('10318','2013-05-22','18:20:00',1.13),('10318','2013-05-22','18:25:00',1.43),('10318','2013-05-22','18:30:00',1.28),('10318','2013-05-22','18:40:00',1.05),('10318','2013-05-22','18:45:00',1.09),('10318','2013-05-22','19:05:00',1.04),('10318','2014-04-01','07:50:00',1.07),('10318','2014-04-01','07:55:00',1.35),('10318','2014-04-01','08:00:00',1.52),('10318','2014-04-01','08:05:00',2.22),('10318','2014-04-01','08:10:00',2.74),('10318','2014-04-01','08:15:00',2.93),('10318','2014-04-01','08:20:00',3.22),('10318','2014-04-01','08:25:00',3.59),('10318','2014-04-01','08:30:00',3.8),('10318','2014-04-01','08:35:00',4.03),('10318','2014-04-01','08:40:00',4.28),('10318','2014-04-01','08:45:00',4.54),('10318','2014-04-01','08:50:00',4.79),('10318','2014-04-01','08:55:00',4.99),('10318','2014-04-01','09:00:00',5.22),('10318','2014-04-01','09:05:00',5.41),('10318','2014-04-01','09:10:00',5.63),('10318','2014-04-01','09:15:00',5.79),('10318','2014-04-01','09:20:00',5.94),('10318','2014-04-01','09:25:00',6.1),('10318','2014-04-01','09:30:00',6.24),('10318','2014-04-01','09:35:00',6.51),('10318','2014-04-01','09:40:00',6.6),('10318','2014-04-01','09:45:00',6.67),('10318','2014-04-01','09:50:00',6.69),('10318','2014-04-01','09:55:00',7.08),('10318','2014-04-01','10:00:00',7.2),('10318','2014-04-01','10:05:00',7.63),('10318','2014-04-01','10:10:00',7.7),('10318','2014-04-01','10:15:00',4.62),('10318','2014-04-01','10:20:00',5.58),('10318','2014-04-01','10:25:00',8.31),('10318','2014-04-01','10:30:00',8.25),('10318','2014-04-01','10:35:00',8.22),('10318','2014-04-01','10:40:00',8.41),('10318','2014-04-01','10:45:00',8.44),('10318','2014-04-01','10:50:00',8.41),('10318','2014-04-01','10:55:00',8.47),('10318','2014-04-01','11:00:00',8.71),('10318','2014-04-01','11:05:00',8.85),('10318','2014-04-01','11:10:00',8.77),('10318','2014-04-01','11:15:00',8.83),('10318','2014-04-01','11:20:00',8.99),('10318','2014-04-01','11:25:00',9.12),('10318','2014-04-01','11:30:00',9.18),('10318','2014-04-01','11:35:00',8.96),('10318','2014-04-01','11:40:00',9.26),('10318','2014-04-01','11:45:00',9.47),('10318','2014-04-01','11:50:00',9.31),('10318','2014-04-01','11:55:00',9.51),('10318','2014-04-01','12:00:00',9.43),('10318','2014-04-01','12:05:00',9.5),('10318','2014-04-01','12:10:00',9.55),('10318','2014-04-01','12:15:00',9.62),('10318','2014-04-01','12:20:00',9.62),('10318','2014-04-01','12:25:00',9.7),('10318','2014-04-01','12:30:00',9.74),('10318','2014-04-01','12:35:00',9.76),('10318','2014-04-01','12:40:00',9.75),('10318','2014-04-01','12:45:00',9.71),('10318','2014-04-01','12:50:00',9.75),('10318','2014-04-01','12:55:00',9.85),('10318','2014-04-01','13:00:00',8.27),('10318','2014-04-01','13:05:00',9.88),('10318','2014-04-01','13:10:00',9.39),('10318','2014-04-01','13:15:00',9.41),('10318','2014-04-01','13:20:00',9.38),('10318','2014-04-01','13:25:00',8.79),('10318','2014-04-01','13:30:00',9.11),('10318','2014-04-01','13:35:00',9.72),('10318','2014-04-01','13:40:00',10.03),('10318','2014-04-01','13:45:00',9.75),('10318','2014-04-01','13:50:00',9.33),('10318','2014-04-01','13:55:00',9.27),('10318','2014-04-01','14:00:00',9.43),('10318','2014-04-01','14:05:00',9.25),('10318','2014-04-01','14:10:00',8.98),('10318','2014-04-01','14:15:00',9.02),('10318','2014-04-01','14:20:00',8.99),('10318','2014-04-01','14:25:00',9.01),('10318','2014-04-01','14:30:00',9),('10318','2014-04-01','14:35:00',8.88),('10318','2014-04-01','14:40:00',9.18),('10318','2014-04-01','14:45:00',7.93),('10318','2014-04-01','14:50:00',7.4),('10318','2014-04-01','14:55:00',8.41),('10318','2014-04-01','15:00:00',7.15),('10318','2014-04-01','15:05:00',7.1),('10318','2014-04-01','15:10:00',7.64),('10318','2014-04-01','15:15:00',8.07),('10318','2014-04-01','15:20:00',5.49),('10318','2014-04-01','15:25:00',5.49),('10318','2014-04-01','15:30:00',8.13),('10318','2014-04-01','15:35:00',6.58),('10318','2014-04-01','15:40:00',6.25),('10318','2014-04-01','15:45:00',6.95),('10318','2014-04-01','15:50:00',5.99),('10318','2014-04-01','15:55:00',6.4),('10318','2014-04-01','16:00:00',5.99),('10318','2014-04-01','16:05:00',5.76),('10318','2014-04-01','16:10:00',2.89),('10318','2014-04-01','16:15:00',5.65),('10318','2014-04-01','16:20:00',4.3),('10318','2014-04-01','16:25:00',2.5),('10318','2014-04-01','16:30:00',3.24),('10318','2014-04-01','16:35:00',4.84),('10318','2014-04-01','16:40:00',3.01),('10318','2014-04-01','16:45:00',4.54),('10318','2014-04-01','16:50:00',3.96),('10318','2014-04-01','16:55:00',3.71),('10318','2014-04-01','17:00:00',3.95),('10318','2014-04-01','17:05:00',3.95),('10318','2014-04-01','17:10:00',3.71),('10318','2014-04-01','17:15:00',3.53),('10318','2014-04-01','17:20:00',2.64),('10318','2014-04-01','17:25:00',3.08),('10318','2014-04-01','17:30:00',3),('10318','2014-04-01','17:35:00',2.77),('10318','2014-04-01','17:40:00',2.53),('10318','2014-04-01','17:45:00',2.4),('10318','2014-04-01','17:50:00',2.21),('10318','2014-04-01','17:55:00',1.97),('10318','2014-04-01','18:00:00',1.85),('10318','2014-04-01','18:05:00',1.33),('10318','2014-04-01','18:10:00',1.53),('10318','2014-04-01','18:15:00',1.32),('10318','2013-05-21','06:55:00',1.09),('10318','2013-05-21','07:00:00',1.39),('10318','2013-05-21','07:05:00',1.61),('10318','2013-05-21','07:10:00',1.82),('10318','2013-05-21','07:15:00',2.09),('10318','2013-05-21','07:20:00',2.33),('10318','2013-05-21','07:25:00',2.65),('10318','2013-05-21','07:30:00',3.09),('10318','2013-05-21','07:35:00',3.75),('10318','2013-05-21','07:40:00',4.13),('10318','2013-05-21','07:45:00',3.64),('10318','2013-05-21','07:50:00',2.47),('10318','2013-05-21','07:55:00',3.61),('10318','2013-05-21','08:00:00',2.37),('10318','2013-05-21','08:05:00',3.36),('10318','2013-05-21','08:10:00',5.32),('10318','2013-05-21','08:15:00',4.75),('10318','2013-05-21','08:20:00',3.68),('10318','2013-05-21','08:25:00',4.77),('10318','2013-05-21','08:30:00',3.03),('10318','2013-05-21','08:35:00',3.23),('10318','2013-05-21','08:40:00',3.62),('10318','2013-05-21','08:45:00',2.95),('10318','2013-05-21','08:50:00',3.32),('10318','2013-05-21','08:55:00',3.79),('10318','2013-05-21','09:00:00',3.31),('10318','2013-05-21','09:05:00',3.12),('10318','2013-05-21','09:10:00',3.79),('10318','2013-05-21','09:15:00',4.03),('10318','2013-05-21','09:20:00',4.8),('10318','2013-05-21','09:25:00',6.23),('10318','2013-05-21','09:30:00',4.78),('10318','2013-05-21','09:35:00',4.25),('10318','2013-05-21','09:40:00',4.3),('10318','2013-05-21','09:45:00',3.86),('10318','2013-05-21','09:50:00',3.99),('10318','2013-05-21','09:55:00',4.26),('10318','2013-05-21','10:00:00',4.58),('10318','2013-05-21','10:05:00',4.84),('10318','2013-05-21','10:10:00',4.87),('10318','2013-05-21','10:15:00',4.65),('10318','2013-05-21','10:20:00',4.37),('10318','2013-05-21','10:25:00',4.79),('10318','2013-05-21','10:30:00',4.1),('10318','2013-05-21','10:35:00',4.44),('10318','2013-05-21','10:40:00',5.72),('10318','2013-05-21','10:45:00',6.75),('10318','2013-05-21','10:50:00',5.41),('10318','2013-05-21','10:55:00',3.98),('10318','2013-05-21','11:00:00',4.21),('10318','2013-05-21','11:05:00',3.92),('10318','2013-05-21','11:10:00',5.7),('10318','2013-05-21','11:15:00',7.81),('10318','2013-05-21','11:20:00',9.45),('10318','2013-05-21','11:25:00',10.23),('10318','2013-05-21','11:30:00',8.56),('10318','2013-05-21','11:35:00',5.19),('10318','2013-05-21','11:40:00',5.49),('10318','2013-05-21','11:45:00',7.68),('10318','2013-05-21','11:50:00',5.83),('10318','2013-05-21','11:55:00',6.2),('10318','2013-05-21','12:00:00',7.3),('10318','2013-05-21','12:05:00',6.9),('10318','2013-05-21','12:10:00',6.52),('10318','2013-05-21','12:15:00',5.95),('10318','2013-05-21','12:20:00',6.35),('10318','2013-05-21','12:25:00',6.53),('10318','2013-05-21','12:30:00',8.61),('10318','2013-05-21','12:35:00',6.08),('10318','2013-05-21','12:40:00',8.04),('10318','2013-05-21','12:45:00',10.1),('10318','2013-05-21','12:50:00',6.05),('10318','2013-05-21','12:55:00',8.28),('10318','2013-05-21','13:00:00',6.47),('10318','2013-05-21','13:05:00',9.14),('10318','2013-05-21','13:10:00',6.28),('10318','2013-05-21','13:15:00',7.96),('10318','2013-05-21','13:20:00',8.18),('10318','2013-05-21','13:25:00',7.06),('10318','2013-05-21','13:30:00',4.39),('10318','2013-05-21','13:35:00',3.05),('10318','2013-05-21','13:40:00',1.84),('10318','2013-05-21','13:45:00',1.28),('10318','2013-05-21','14:00:00',1.3),('10318','2013-05-21','14:05:00',2.53),('10318','2013-05-21','14:10:00',3.54),('10318','2013-05-21','14:15:00',4.1),('10318','2013-05-21','14:20:00',3.71),('10318','2013-05-21','14:25:00',4.87),('10318','2013-05-21','14:30:00',5.71),('10318','2013-05-21','14:35:00',5.09),('10318','2013-05-21','14:40:00',4.3),('10318','2013-05-21','14:45:00',3.26),('10318','2013-05-21','14:50:00',1.86),('10318','2013-05-21','14:55:00',1.39),('10318','2013-05-21','15:00:00',1.08),('10318','2013-05-21','15:05:00',1.2),('10318','2013-05-21','15:10:00',1.53),('10318','2013-05-21','15:15:00',2.79),('10318','2013-05-21','15:20:00',3.48),('10318','2013-05-21','15:25:00',3.87),('10318','2013-05-21','15:30:00',4.79),('10318','2013-05-21','15:35:00',4.28),('10318','2013-05-21','15:40:00',3.93),('10318','2013-05-21','15:45:00',3.84),('10318','2013-05-21','15:50:00',2.7),('10318','2013-05-21','15:55:00',2.5),('10318','2013-05-21','16:00:00',2.36),('10318','2013-05-21','16:05:00',2.57),('10318','2013-05-21','16:10:00',2.85),('10318','2013-05-21','16:15:00',2.18),('10318','2013-05-21','16:20:00',2.03),('10318','2013-05-21','16:25:00',2.69),('10318','2013-05-21','16:30:00',3.41),('10318','2013-05-21','16:35:00',4.03),('10318','2013-05-21','16:40:00',3.93),('10318','2013-05-21','16:45:00',2.96),('10318','2013-05-21','16:50:00',2.28),('10318','2013-05-21','16:55:00',1.34),('10318','2013-05-21','17:00:00',1.3),('10318','2013-05-21','17:05:00',1.6),('10318','2013-05-21','17:10:00',1.35),('10318','2013-05-20','06:50:00',1.14),('10318','2013-05-20','06:55:00',1.3),('10318','2013-05-20','07:00:00',1.49),('10318','2013-05-20','07:05:00',1.69),('10318','2013-05-20','07:10:00',1.67),('10318','2013-05-20','07:15:00',2.4),('10318','2013-05-20','07:20:00',2.79),('10318','2013-05-20','07:25:00',2.72),('10318','2013-05-20','07:30:00',3),('10318','2013-05-20','07:35:00',3.62),('10318','2013-05-20','07:40:00',3.07),('10318','2013-05-20','07:45:00',2.15),('10318','2013-05-20','07:50:00',3.68),('10318','2013-05-20','07:55:00',4.09),('10318','2013-05-20','08:00:00',4.19),('10318','2013-05-20','08:05:00',2.75),('10318','2013-05-20','08:10:00',3.76),('10318','2013-05-20','08:15:00',5.09),('10318','2013-05-20','08:20:00',5.32),('10318','2013-05-20','08:25:00',3.19),('10318','2013-05-20','08:30:00',6.48),('10318','2013-05-20','08:35:00',3.05),('10318','2013-05-20','08:40:00',4.34),('10318','2013-05-20','08:45:00',2.87),('10318','2013-05-20','08:50:00',3.61),('10318','2013-05-20','08:55:00',3.24),('10318','2013-05-20','09:00:00',8.11),('10318','2013-05-20','09:05:00',7),('10318','2013-05-20','09:10:00',2.67),('10318','2013-05-20','09:15:00',1.57),('10318','2013-05-20','09:20:00',5.22),('10318','2013-05-20','09:25:00',7.38),('10318','2013-05-20','09:30:00',6.42),('10318','2013-05-20','09:35:00',4.49),('10318','2013-05-20','09:40:00',8.97),('10318','2013-05-20','09:45:00',8.78),('10318','2013-05-20','09:50:00',8.89),('10318','2013-05-20','09:55:00',9.57),('10318','2013-05-20','10:00:00',6.94),('10318','2013-05-20','10:05:00',5.9),('10318','2013-05-20','10:10:00',6.88),('10318','2013-05-20','10:15:00',3.29),('10318','2013-05-20','10:20:00',9.66),('10318','2013-05-20','10:25:00',4.32),('10318','2013-05-20','10:30:00',9.44),('10318','2013-05-20','10:35:00',10.53),('10318','2013-05-20','10:40:00',9.5),('10318','2013-05-20','10:45:00',8.46),('10318','2013-05-20','10:50:00',9.52),('10318','2013-05-20','10:55:00',6.55),('10318','2013-05-20','11:00:00',9.02),('10318','2013-05-20','11:05:00',4.67),('10318','2013-05-20','11:10:00',6.43),('10318','2013-05-20','11:15:00',10.23),('10318','2013-05-20','11:20:00',9.54),('10318','2013-05-20','11:25:00',3.53),('10318','2013-05-20','11:30:00',7.93),('10318','2013-05-20','11:35:00',5.1),('10318','2013-05-20','11:40:00',5.17),('10318','2013-05-20','11:45:00',6.87),('10318','2013-05-20','11:50:00',5.49),('10318','2013-05-20','11:55:00',4.04),('10318','2013-05-20','12:00:00',2.99),('10318','2013-05-20','12:05:00',3.57),('10318','2013-05-20','12:10:00',6.22),('10318','2013-05-20','12:15:00',3.25),('10318','2013-05-20','12:20:00',2.4),('10318','2013-05-20','12:25:00',2.9),('10318','2013-05-20','12:30:00',8.58),('10318','2013-05-20','12:35:00',10.01),('10318','2013-05-20','12:40:00',6.85),('10318','2013-05-20','12:45:00',10.69),('10318','2013-05-20','12:50:00',6.71),('10318','2013-05-20','12:55:00',9.66),('10318','2013-05-20','13:00:00',4.18),('10318','2013-05-20','13:05:00',6.12),('10318','2013-05-20','13:10:00',6.79),('10318','2013-05-20','13:15:00',4.57),('10318','2013-05-20','13:20:00',9.32),('10318','2013-05-20','13:25:00',4.95),('10318','2013-05-20','13:30:00',10.53),('10318','2013-05-20','13:35:00',6.76),('10318','2013-05-20','13:40:00',8.5),('10318','2013-05-20','13:45:00',7.45),('10318','2013-05-20','13:50:00',9.7),('10318','2013-05-20','13:55:00',10.19),('10318','2013-05-20','14:00:00',9.95),('10318','2013-05-20','14:05:00',9.97),('10318','2013-05-20','14:10:00',9.83),('10318','2013-05-20','14:15:00',9.64),('10318','2013-05-20','14:20:00',9.53),('10318','2013-05-20','14:25:00',9.4),('10318','2013-05-20','14:30:00',9.35),('10318','2013-05-20','14:35:00',9.23),('10318','2013-05-20','14:40:00',9.41),('10318','2013-05-20','14:45:00',8.85),('10318','2013-05-20','14:50:00',8.99),('10318','2013-05-20','14:55:00',9.12),('10318','2013-05-20','15:00:00',8.9),('10318','2013-05-20','15:05:00',8.88),('10318','2013-05-20','15:10:00',3.48),('10318','2013-05-20','15:15:00',3.9),('10318','2013-05-20','15:20:00',8.55),('10318','2013-05-20','15:25:00',4.36),('10318','2013-05-20','15:30:00',3.47),('10318','2013-05-20','15:35:00',7.66),('10318','2013-05-20','15:40:00',8.48),('10318','2013-05-20','15:45:00',8.21),('10318','2013-05-20','15:50:00',7.74),('10318','2013-05-20','15:55:00',4.78),('10318','2013-05-20','16:00:00',7.38),('10318','2013-05-20','16:05:00',7.05),('10318','2013-05-20','16:10:00',6.82),('10318','2013-05-20','16:15:00',6.69),('10318','2013-05-20','16:20:00',6.39),('10318','2013-05-20','16:25:00',6.22),('10318','2013-05-20','16:30:00',5.95),('10318','2013-05-20','16:35:00',5.82),('10318','2013-05-20','16:40:00',5.6),('10318','2013-05-20','16:45:00',5.12),('10318','2013-05-20','16:50:00',5.19),('10318','2013-05-20','16:55:00',4.96),('10318','2013-05-20','17:00:00',3.67),('10318','2013-05-20','17:05:00',4.25),('10318','2013-05-20','17:10:00',4.62),('10318','2013-05-20','17:15:00',3.08),('10318','2013-05-20','17:20:00',5.1),('10318','2013-05-20','17:25:00',4.89),('10318','2013-05-20','17:30:00',4.21),('10318','2013-05-20','17:35:00',3.54),('10318','2013-05-20','17:40:00',3.25),('10318','2013-05-20','17:45:00',3.06),('10318','2013-05-20','17:50:00',2.88),('10318','2013-05-20','17:55:00',2.68),('10318','2013-05-20','18:00:00',2.55),('10318','2013-05-20','18:05:00',2.44),('10318','2013-05-20','18:10:00',2.17),('10318','2013-05-20','18:15:00',2.23),('10318','2013-05-20','18:20:00',1.94),('10318','2013-05-20','18:25:00',1.68),('10318','2013-05-20','18:30:00',1.5),('10318','2013-05-20','18:35:00',1.3),('10318','2013-05-20','18:40:00',1.01),('10318','2013-05-20','18:45:00',1.07),('10318','2013-05-19','07:00:00',1.11),('10318','2013-05-19','07:05:00',1.14),('10318','2013-05-19','07:10:00',1.07),('10318','2013-05-19','07:15:00',1.08),('10318','2013-05-19','08:00:00',1.25),('10318','2013-05-19','08:10:00',1.19),('10318','2013-05-19','08:15:00',1.51),('10318','2013-05-19','08:20:00',1.36),('10318','2013-05-19','08:25:00',1.72),('10318','2013-05-19','08:30:00',2.15),('10318','2013-05-19','08:35:00',2.68),('10318','2013-05-19','08:40:00',3.01),('10318','2013-05-19','08:45:00',3.19),('10318','2013-05-19','08:50:00',2.49),('10318','2013-05-19','08:55:00',2.87),('10318','2013-05-19','09:00:00',2.86),('10318','2013-05-19','09:05:00',2.43),('10318','2013-05-19','09:10:00',2.68),('10318','2013-05-19','09:15:00',2.39),('10318','2013-05-19','09:20:00',1.27),('10318','2013-05-19','09:25:00',1.19),('10318','2013-05-19','09:30:00',1.77),('10318','2013-05-19','09:35:00',2.32),('10318','2013-05-19','09:40:00',2.14),('10318','2013-05-19','09:45:00',1.87),('10318','2013-05-19','09:50:00',2.43),('10318','2013-05-19','09:55:00',3.55),('10318','2013-05-19','10:00:00',3.83),('10318','2013-05-19','10:05:00',4.22),('10318','2013-05-19','10:10:00',6.24),('10318','2013-05-19','10:15:00',6.5),('10318','2013-05-19','10:20:00',7.03),('10318','2013-05-19','10:25:00',6.85),('10318','2013-05-19','10:30:00',7.32),('10318','2013-05-19','10:35:00',8.13),('10318','2013-05-19','10:40:00',8.43),('10318','2013-05-19','10:45:00',8.68),('10318','2013-05-19','10:50:00',8.73),('10318','2013-05-19','10:55:00',9.38),('10318','2013-05-19','11:00:00',9.25),('10318','2013-05-19','11:05:00',11.05),('10318','2013-05-19','11:10:00',10.01),('10318','2013-05-19','11:15:00',10.8),('10318','2013-05-19','11:20:00',10.4),('10318','2013-05-19','11:25:00',10.49),('10318','2013-05-19','11:30:00',10.19),('10318','2013-05-19','11:35:00',10.17),('10318','2013-05-19','11:40:00',9.88),('10318','2013-05-19','11:45:00',9.88),('10318','2013-05-19','11:50:00',10.05),('10318','2013-05-19','11:55:00',10.22),('10318','2013-05-19','12:00:00',10.26),('10318','2013-05-19','12:05:00',10.34),('10318','2013-05-19','12:10:00',10.41),('10318','2013-05-19','12:15:00',10.57),('10318','2013-05-19','12:20:00',8.05),('10318','2013-05-19','12:25:00',5.62),('10318','2013-05-19','12:30:00',5.03),('10318','2013-05-19','12:35:00',7.04),('10318','2013-05-19','12:40:00',6.18),('10318','2013-05-19','12:45:00',6.69),('10318','2013-05-19','12:50:00',6.53),('10318','2013-05-19','12:55:00',5.43),('10318','2013-05-19','13:00:00',8.75),('10318','2013-05-19','13:05:00',9.16),('10318','2013-05-19','13:10:00',10.21),('10318','2013-05-19','13:15:00',10.07),('10318','2013-05-19','13:20:00',10.5),('10318','2013-05-19','13:25:00',10.01),('10318','2013-05-19','13:30:00',10.01),('10318','2013-05-19','13:35:00',9.97),('10318','2013-05-19','13:40:00',9.96),('10318','2013-05-19','13:45:00',9.81),('10318','2013-05-19','13:50:00',9.72),('10318','2013-05-19','13:55:00',9.63),('10318','2013-05-19','14:00:00',9.31),('10318','2013-05-19','14:05:00',9.61),('10318','2013-05-19','14:10:00',9.58),('10318','2013-05-19','14:15:00',9.49),('10318','2013-05-19','14:20:00',9.39),('10318','2013-05-19','14:25:00',9.38),('10318','2013-05-19','14:30:00',9.34),('10318','2013-05-19','14:35:00',9.21),('10318','2013-05-19','14:40:00',9.03),('10318','2013-05-19','14:45:00',8.92),('10318','2013-05-19','14:50:00',8.88),('10318','2013-05-19','14:55:00',8.85),('10318','2013-05-19','15:00:00',8.68),('10318','2013-05-19','15:05:00',8.55),('10318','2013-05-19','15:10:00',8.48),('10318','2013-05-19','15:15:00',8.41),('10318','2013-05-19','15:20:00',8.2),('10318','2013-05-19','15:25:00',8.05),('10318','2013-05-19','15:30:00',7.89),('10318','2013-05-19','15:35:00',7.8),('10318','2013-05-19','15:40:00',7.7),('10318','2013-05-19','15:45:00',7.43),('10318','2013-05-19','15:50:00',7.38),('10318','2013-05-19','15:55:00',7.2),('10318','2013-05-19','16:00:00',7.04),('10318','2013-05-19','16:05:00',6.91),('10318','2013-05-19','16:10:00',6.77),('10318','2013-05-19','16:15:00',6.56),('10318','2013-05-19','16:20:00',6.38),('10318','2013-05-19','16:25:00',6.24),('10318','2013-05-19','16:30:00',6.08),('10318','2013-05-19','16:35:00',5.89),('10318','2013-05-19','16:40:00',5.7),('10318','2013-05-19','16:45:00',5.53),('10318','2013-05-19','16:50:00',5.35),('10318','2013-05-19','16:55:00',5.18),('10318','2013-05-19','17:00:00',5.02),('10318','2013-05-19','17:05:00',4.81),('10318','2013-05-19','17:10:00',4.57),('10318','2013-05-19','17:15:00',4.4),('10318','2013-05-19','17:20:00',4.18),('10318','2013-05-19','17:25:00',3.96),('10318','2013-05-19','17:30:00',3.71),('10318','2013-05-19','17:35:00',3.57),('10318','2013-05-19','17:40:00',3.37),('10318','2013-05-19','17:45:00',3.15),('10318','2013-05-19','17:50:00',2.98),('10318','2013-05-19','17:55:00',2.78),('10318','2013-05-19','18:00:00',2.57),('10318','2013-05-19','18:05:00',2.34),('10318','2013-05-19','18:10:00',2.16),('10318','2013-05-19','18:15:00',1.97),('10318','2013-05-19','18:20:00',1.81),('10318','2013-05-19','18:25:00',1.64),('10318','2013-05-19','18:30:00',1.48),('10318','2013-05-19','18:35:00',1.33),('10318','2013-05-19','18:40:00',1.19),('10318','2013-05-19','18:45:00',1.05),('10318','2013-05-18','06:55:00',1.05),('10318','2013-05-18','07:00:00',1.38),('10318','2013-05-18','07:05:00',1.61),('10318','2013-05-18','07:10:00',1.98),('10318','2013-05-18','07:15:00',2.23),('10318','2013-05-18','07:20:00',2.42),('10318','2013-05-18','07:25:00',2.74),('10318','2013-05-18','07:30:00',3),('10318','2013-05-18','07:35:00',3.22),('10318','2013-05-18','07:40:00',3.53),('10318','2013-05-18','07:45:00',3.85),('10318','2013-05-18','07:50:00',2.39),('10318','2013-05-18','07:55:00',3.21),('10318','2013-05-18','08:00:00',4.84),('10318','2013-05-18','08:05:00',3.45),('10318','2013-05-18','08:10:00',2.32),('10318','2013-05-18','08:15:00',2.38),('10318','2013-05-18','08:20:00',3.75),('10318','2013-05-18','08:25:00',6.32),('10318','2013-05-18','08:30:00',5.03),('10318','2013-05-18','08:35:00',5.77),('10318','2013-05-18','08:40:00',5.45),('10318','2013-05-18','08:45:00',5.96),('10318','2013-05-18','08:50:00',6.18),('10318','2013-05-18','08:55:00',6.35),('10318','2013-05-18','09:00:00',6.45),('10318','2013-05-18','09:05:00',6.66),('10318','2013-05-18','09:10:00',6.79),('10318','2013-05-18','09:15:00',6.93),('10318','2013-05-18','09:20:00',7.07),('10318','2013-05-18','09:25:00',7.21),('10318','2013-05-18','09:30:00',7.36),('10318','2013-05-18','09:35:00',7.49),('10318','2013-05-18','09:40:00',7.62),('10318','2013-05-18','09:45:00',7.7),('10318','2013-05-18','09:50:00',7.83),('10318','2013-05-18','09:55:00',7.96),('10318','2013-05-18','10:00:00',8),('10318','2013-05-18','10:05:00',8.13),('10318','2013-05-18','10:10:00',8.28),('10318','2013-05-18','10:15:00',8.35),('10318','2013-05-18','10:20:00',8.42),('10318','2013-05-18','10:25:00',8.46),('10318','2013-05-18','10:30:00',8.56),('10318','2013-05-18','10:35:00',8.64),('10318','2013-05-18','10:40:00',8.72),('10318','2013-05-18','10:45:00',8.83),('10318','2013-05-18','10:50:00',8.96),('10318','2013-05-18','10:55:00',9.12),('10318','2013-05-18','11:00:00',9.14),('10318','2013-05-18','11:05:00',9.11),('10318','2013-05-18','11:10:00',8.15),('10318','2013-05-18','11:15:00',10.19),('10318','2013-05-18','11:20:00',9.93),('10318','2013-05-18','11:25:00',10.13),('10318','2013-05-18','11:30:00',9.63),('10318','2013-05-18','11:35:00',9.68),('10318','2013-05-18','11:40:00',9.39),('10318','2013-05-18','11:45:00',9.31),('10318','2013-05-18','11:50:00',9.36),('10318','2013-05-18','11:55:00',6.19),('10318','2013-05-18','12:00:00',9.12),('10318','2013-05-18','12:05:00',9.5),('10318','2013-05-18','12:10:00',9.34),('10318','2013-05-18','12:15:00',9.32),('10318','2013-05-18','12:20:00',9.39),('10318','2013-05-18','12:25:00',9.42),('10318','2013-05-18','12:30:00',8.21),('10318','2013-05-18','12:35:00',9.42),('10318','2013-05-18','12:40:00',9.06),('10318','2013-05-18','12:45:00',9.4),('10318','2013-05-18','12:50:00',9.38),('10318','2013-05-18','12:55:00',9.29),('10318','2013-05-18','13:00:00',9.29),('10318','2013-05-18','13:05:00',9.23),('10318','2013-05-18','13:10:00',9.18),('10318','2013-05-18','13:15:00',9.22),('10318','2013-05-18','13:20:00',9.15),('10318','2013-05-18','13:25:00',9.09),('10318','2013-05-18','13:30:00',9.26),('10318','2013-05-18','13:35:00',9.27),('10318','2013-05-18','13:40:00',9.12),('10318','2013-05-18','13:45:00',9.05),('10318','2013-05-18','13:50:00',8.66),('10318','2013-05-18','13:55:00',6.37),('10318','2013-05-18','14:00:00',6.64),('10318','2013-05-18','14:05:00',7.44),('10318','2013-05-18','14:10:00',8.86),('10318','2013-05-18','14:15:00',6.54),('10318','2013-05-18','14:20:00',8.55),('10318','2013-05-18','14:25:00',9.21),('10318','2013-05-18','14:30:00',8.91),('10318','2013-05-18','14:35:00',6.63),('10318','2013-05-18','14:40:00',5.77),('10318','2013-05-18','14:45:00',4.42),('10318','2013-05-18','14:50:00',6.68),('10318','2013-05-18','14:55:00',7.96),('10318','2013-05-18','15:00:00',7.88),('10318','2013-05-18','15:05:00',7.64),('10318','2013-05-18','15:10:00',7.5),('10318','2013-05-18','15:15:00',7.35),('10318','2013-05-18','15:20:00',7.23),('10318','2013-05-18','15:25:00',7.09),('10318','2013-05-18','15:30:00',6.93),('10318','2013-05-18','15:35:00',6.82),('10318','2013-05-18','15:40:00',6.69),('10318','2013-05-18','15:45:00',6.51),('10318','2013-05-18','15:50:00',6.34),('10318','2013-05-18','15:55:00',6.2),('10318','2013-05-18','16:00:00',6.09),('10318','2013-05-18','16:05:00',5.91),('10318','2013-05-18','16:10:00',5.74),('10318','2013-05-18','16:15:00',5.61),('10318','2013-05-18','16:20:00',5.46),('10318','2013-05-18','16:25:00',5.32),('10318','2013-05-18','16:30:00',5.06),('10318','2013-05-18','16:35:00',5.02),('10318','2013-05-18','16:40:00',4.86),('10318','2013-05-18','16:45:00',4.71),('10318','2013-05-18','16:50:00',4.55),('10318','2013-05-18','16:55:00',4.35),('10318','2013-05-18','17:00:00',4.18),('10318','2013-05-18','17:05:00',4.02),('10318','2013-05-18','17:10:00',3.88),('10318','2013-05-18','17:15:00',3.72),('10318','2013-05-18','17:20:00',3.56),('10318','2013-05-18','17:25:00',3.39),('10318','2013-05-18','17:30:00',3.21),('10318','2013-05-18','17:35:00',3.07),('10318','2013-05-18','17:40:00',2.93),('10318','2013-05-18','17:45:00',2.77),('10318','2013-05-18','17:50:00',2.63),('10318','2013-05-18','17:55:00',2.5),('10318','2013-05-18','18:00:00',2.33),('10318','2013-05-18','18:05:00',2.17),('10318','2013-05-18','18:10:00',2.04),('10318','2013-05-18','18:15:00',1.88),('10318','2013-05-18','18:20:00',1.78),('10318','2013-05-18','18:25:00',1.64),('10318','2013-05-18','18:30:00',1.53),('10318','2013-05-18','18:35:00',1.4),('10318','2013-05-18','18:40:00',1.29),('10318','2013-05-18','18:45:00',1.15),('10318','2013-05-18','18:50:00',1.08),('10318','2013-05-17','06:55:00',1.06),('10318','2013-05-17','07:00:00',1.22),('10318','2013-05-17','07:05:00',2.11),('10318','2013-05-17','07:10:00',1.94),('10318','2013-05-17','07:15:00',1.88),('10318','2013-05-17','07:20:00',1.98),('10318','2013-05-17','07:25:00',1.14),('10318','2013-05-17','07:30:00',1.32),('10318','2013-05-17','07:35:00',3.02),('10318','2013-05-17','07:40:00',3.38),('10318','2013-05-17','07:45:00',3.7),('10318','2013-05-17','07:50:00',4.71),('10318','2013-05-17','07:55:00',4.61),('10318','2013-05-17','08:00:00',4.76),('10318','2013-05-17','08:05:00',4.04),('10318','2013-05-17','08:10:00',4.73),('10318','2013-05-17','08:15:00',5.59),('10318','2013-05-17','08:20:00',5.52),('10318','2013-05-17','08:25:00',3.45),('10318','2013-05-17','08:30:00',1.96),('10318','2013-05-17','08:35:00',1.25),('10318','2013-05-17','09:00:00',1.13),('10318','2013-05-17','09:05:00',1.46),('10318','2013-05-17','09:10:00',1.69),('10318','2013-05-17','09:15:00',1.15),('10318','2013-05-17','09:20:00',2.17),('10318','2013-05-17','09:25:00',1.78),('10318','2013-05-17','09:30:00',1.03),('10318','2013-05-17','10:05:00',1.03),('10318','2013-05-17','10:10:00',1.3),('10318','2013-05-17','10:15:00',1.73),('10318','2013-05-17','10:20:00',2.31),('10318','2013-05-17','10:25:00',3.11),('10318','2013-05-17','10:30:00',3.64),('10318','2013-05-17','10:35:00',2.86),('10318','2013-05-17','10:40:00',3.25),('10318','2013-05-17','10:45:00',3.77),('10318','2013-05-17','10:50:00',8.76),('10318','2013-05-17','10:55:00',5.99),('10318','2013-05-17','11:00:00',4.53),('10318','2013-05-17','11:05:00',3.88),('10318','2013-05-17','11:10:00',3.56),('10318','2013-05-17','11:15:00',8.91),('10318','2013-05-17','11:20:00',5.23),('10318','2013-05-17','11:25:00',3.94),('10318','2013-05-17','11:30:00',4.31),('10318','2013-05-17','11:35:00',4.82),('10318','2013-05-17','11:40:00',6.61),('10318','2013-05-17','11:45:00',9.33),('10318','2013-05-17','11:50:00',8.35),('10318','2013-05-17','11:55:00',9.35),('10318','2013-05-17','12:00:00',9.48),('10318','2013-05-17','12:05:00',8.07),('10318','2013-05-17','12:10:00',7.28),('10318','2013-05-17','12:15:00',6.72),('10318','2013-05-17','12:20:00',7.65),('10318','2013-05-17','12:25:00',7.87),('10318','2013-05-17','12:30:00',7.99),('10318','2013-05-17','12:35:00',8.99),('10318','2013-05-17','12:40:00',10.6),('10318','2013-05-17','12:45:00',10.75),('10318','2013-05-17','12:50:00',10.27),('10318','2013-05-17','12:55:00',10.52),('10318','2013-05-17','13:00:00',7.38),('10318','2013-05-17','13:05:00',10.45),('10318','2013-05-17','13:10:00',10.37),('10318','2013-05-17','13:15:00',7.9),('10318','2013-05-17','13:20:00',9.46),('10318','2013-05-17','13:25:00',9.46),('10318','2013-05-17','13:30:00',9.52),('10318','2013-05-17','13:35:00',9.21),('10318','2013-05-17','13:40:00',9.16),('10318','2013-05-17','13:45:00',9.54),('10318','2013-05-17','13:50:00',8.21),('10318','2013-05-17','13:55:00',8.99),('10318','2013-05-17','14:00:00',9.68),('10318','2013-05-17','14:05:00',9.53),('10318','2013-05-17','14:10:00',8.91),('10318','2013-05-17','14:15:00',9.66),('10318','2013-05-17','14:20:00',8.85),('10318','2013-05-17','14:25:00',6.5),('10318','2013-05-17','14:30:00',3.31),('10318','2013-05-17','14:35:00',7.38),('10318','2013-05-17','14:40:00',6.96),('10318','2013-05-17','14:45:00',4.33),('10318','2013-05-17','14:50:00',2.91),('10318','2013-05-17','14:55:00',5.21),('10318','2013-05-17','15:00:00',2.9),('10318','2013-05-17','15:05:00',3.11),('10318','2013-05-17','15:10:00',3.65),('10318','2013-05-17','15:15:00',8.2),('10318','2013-05-17','15:20:00',3.74),('10318','2013-05-17','15:25:00',7.75),('10318','2013-05-17','15:30:00',7.67),('10318','2013-05-17','15:35:00',8.95),('10318','2013-05-17','15:40:00',8.69),('10318','2013-05-17','15:45:00',7.51),('10318','2013-05-17','15:50:00',7.52),('10318','2013-05-17','15:55:00',6.61),('10318','2013-05-17','16:00:00',3.26),('10318','2013-05-17','16:05:00',2.77),('10318','2013-05-17','16:10:00',5.57),('10318','2013-05-17','16:15:00',5.77),('10318','2013-05-17','16:20:00',4.45),('10318','2013-05-17','16:25:00',5.1),('10318','2013-05-17','16:30:00',5.97),('10318','2013-05-17','16:35:00',5.36),('10318','2013-05-17','16:40:00',6.22),('10318','2013-05-17','16:45:00',5.11),('10318','2013-05-17','16:50:00',4.33),('10318','2013-05-17','16:55:00',5.12),('10318','2013-05-17','17:00:00',4.87),('10318','2013-05-17','17:05:00',4.65),('10318','2013-05-17','17:10:00',4.46),('10318','2013-05-17','17:15:00',4.25),('10318','2013-05-17','17:20:00',4.04),('10318','2013-05-17','17:25:00',3.83),('10318','2013-05-17','17:30:00',3.67),('10318','2013-05-17','17:35:00',3.38),('10318','2013-05-17','17:40:00',3.25),('10318','2013-05-17','17:45:00',3.06),('10318','2013-05-17','17:50:00',2.87),('10318','2013-05-17','17:55:00',2.65),('10318','2013-05-17','18:00:00',2.48),('10318','2013-05-17','18:05:00',2.2),('10318','2013-05-17','18:10:00',1.57),('10318','2013-05-17','18:15:00',1.93),('10318','2013-05-17','18:20:00',1.67),('10318','2013-05-17','18:25:00',1.09),('10318','2013-05-16','09:10:00',1.21),('10318','2013-05-16','09:15:00',2.07),('10318','2013-05-16','09:20:00',2.62),('10318','2013-05-16','09:25:00',3.71),('10318','2013-05-16','09:30:00',3.46),('10318','2013-05-16','09:35:00',4.47),('10318','2013-05-16','09:40:00',5.07),('10318','2013-05-16','09:45:00',6.8),('10318','2013-05-16','09:50:00',5.79),('10318','2013-05-16','09:55:00',2.77),('10318','2013-05-16','10:00:00',4.46),('10318','2013-05-16','10:05:00',3.29),('10318','2013-05-16','10:10:00',2.7),('10318','2013-05-16','10:15:00',3.56),('10318','2013-05-16','10:20:00',4.91),('10318','2013-05-16','10:25:00',3.44),('10318','2013-05-16','10:30:00',3.69),('10318','2013-05-16','10:35:00',3.02),('10318','2013-05-16','10:40:00',3.25),('10318','2013-05-16','10:45:00',3.19),('10318','2013-05-16','10:50:00',4.28),('10318','2013-05-16','10:55:00',4.11),('10318','2013-05-16','11:00:00',8.66),('10318','2013-05-16','11:05:00',9.23),('10318','2013-05-16','11:10:00',8.96),('10318','2013-05-16','11:15:00',8.93),('10318','2013-05-16','11:20:00',6.27),('10318','2013-05-16','11:25:00',3.14),('10318','2013-05-16','11:30:00',3.81),('10318','2013-05-16','11:35:00',8.92),('10318','2013-05-16','11:40:00',10.26),('10318','2013-05-16','11:45:00',10.24),('10318','2013-05-16','11:50:00',10.17),('10318','2013-05-16','11:55:00',9.33),('10318','2013-05-16','12:00:00',4.95),('10318','2013-05-16','12:05:00',3.61),('10318','2013-05-16','12:10:00',3.5),('10318','2013-05-16','12:15:00',5.29),('10318','2013-05-16','12:20:00',4.28),('10318','2013-05-16','12:25:00',4.41),('10318','2013-05-16','12:30:00',6.04),('10318','2013-05-16','12:35:00',8.01),('10318','2013-05-16','12:40:00',7.97),('10318','2013-05-16','12:45:00',8.06),('10318','2013-05-16','12:50:00',9.04),('10318','2013-05-16','12:55:00',7.6),('10318','2013-05-16','13:00:00',9.62),('10318','2013-05-16','13:05:00',9.28),('10318','2013-05-16','13:10:00',9.25),('10318','2013-05-16','13:15:00',9.2),('10318','2013-05-16','13:20:00',9.2),('10318','2013-05-16','13:25:00',9.09),('10318','2013-05-16','13:30:00',8.91),('10318','2013-05-16','13:35:00',8.78),('10318','2013-05-16','13:40:00',8.78),('10318','2013-05-16','13:45:00',8.77),('10318','2013-05-16','13:50:00',8.71),('10318','2013-05-16','13:55:00',8.64),('10318','2013-05-16','14:00:00',8.61),('10318','2013-05-16','14:05:00',8.47),('10318','2013-05-16','14:10:00',8.39),('10318','2013-05-16','14:15:00',8.28),('10318','2013-05-16','14:20:00',8.07),('10318','2013-05-16','14:25:00',7.67),('10318','2013-05-16','14:30:00',7.53),('10318','2013-05-16','14:35:00',7.9),('10318','2013-05-16','14:40:00',7.84),('10318','2013-05-16','14:45:00',7.84),('10318','2013-05-16','14:50:00',7.82),('10318','2013-05-16','14:55:00',7.68),('10318','2013-05-16','15:00:00',7.4),('10318','2013-05-16','15:05:00',7.3),('10318','2013-05-16','15:10:00',7.1),('10318','2013-05-16','15:15:00',6.48),('10318','2013-05-16','15:20:00',7.16),('10318','2013-05-16','15:25:00',6.68),('10318','2013-05-16','15:30:00',6.82),('10318','2013-05-16','15:35:00',6.58),('10318','2013-05-16','15:40:00',6.59),('10318','2013-05-16','15:45:00',6.4),('10318','2013-05-16','15:50:00',6.4),('10318','2013-05-16','15:55:00',6.21),('10318','2013-05-16','16:00:00',6.06),('10318','2013-05-16','16:05:00',5.61),('10318','2013-05-16','16:10:00',5.91),('10318','2013-05-16','16:15:00',5.26),('10318','2013-05-16','16:20:00',5.6),('10318','2013-05-16','16:25:00',5.51),('10318','2013-05-16','16:30:00',5.22),('10318','2013-05-16','16:35:00',5.16),('10318','2013-05-16','16:40:00',4.29),('10318','2013-05-16','16:45:00',3.16),('10318','2013-05-16','16:50:00',4.48),('10318','2013-05-16','16:55:00',2.82),('10318','2013-05-16','17:00:00',2.46),('10318','2013-05-16','17:05:00',1.75),('10318','2013-05-16','17:10:00',1.84),('10318','2013-05-16','17:15:00',2.69),('10318','2013-05-16','17:20:00',3.06),('10318','2013-05-16','17:25:00',3.24),('10318','2013-05-16','17:30:00',3.56),('10318','2013-05-16','17:35:00',2.81),('10318','2013-05-16','17:40:00',2.39),('10318','2013-05-16','17:45:00',2.04),('10318','2013-05-16','17:50:00',1.47),('10318','2013-05-16','17:55:00',1.08),('10318','2013-05-16','18:15:00',1.01),('10318','2013-05-16','18:20:00',1.17),('10318','2013-05-16','18:25:00',1.34),('10318','2013-05-16','18:30:00',1.53),('10318','2013-05-16','18:35:00',1.79),('10318','2013-05-16','18:40:00',1.88),('10318','2013-05-16','18:45:00',2.06),('10318','2013-05-16','18:50:00',2.09),('10318','2013-05-16','18:55:00',2.01),('10318','2013-05-16','19:00:00',1.98),('10318','2013-05-16','19:05:00',1.72),('10318','2013-05-16','19:10:00',1.45),('10318','2013-05-16','19:15:00',1.25),('10318','2013-05-16','19:20:00',1.06),('10318','2013-05-15','07:10:00',1.84),('10318','2013-05-15','07:15:00',2.15),('10318','2013-05-15','07:20:00',2.16),('10318','2013-05-15','07:25:00',2.69),('10318','2013-05-15','07:30:00',3.09),('10318','2013-05-15','07:35:00',3.25),('10318','2013-05-15','07:40:00',3.51),('10318','2013-05-15','07:45:00',3.87),('10318','2013-05-15','07:50:00',3.86),('10318','2013-05-15','07:55:00',3.88),('10318','2013-05-15','08:00:00',3.8),('10318','2013-05-15','08:05:00',3.88),('10318','2013-05-15','08:10:00',4.58),('10318','2013-05-15','08:15:00',4.81),('10318','2013-05-15','08:20:00',4.91),('10318','2013-05-15','08:25:00',5.02),('10318','2013-05-15','08:30:00',4.98),('10318','2013-05-15','08:35:00',5.38),('10318','2013-05-15','08:40:00',5.49),('10318','2013-05-15','08:45:00',5.91),('10318','2013-05-15','08:50:00',6.13),('10318','2013-05-15','08:55:00',6.26),('10318','2013-05-15','09:00:00',6.06),('10318','2013-05-15','09:05:00',6.35),('10318','2013-05-15','09:10:00',6.37),('10318','2013-05-15','09:15:00',6.53),('10318','2013-05-15','09:20:00',6.53),('10318','2013-05-15','09:25:00',6.87),('10318','2013-05-15','09:30:00',7.12),('10318','2013-05-15','09:35:00',7.16),('10318','2013-05-15','09:40:00',7.17),('10318','2013-05-15','09:45:00',7.43),('10318','2013-05-15','09:50:00',7.55),('10318','2013-05-15','09:55:00',7.62),('10318','2013-05-15','10:00:00',7.85),('10318','2013-05-15','10:05:00',7.95);
INSERT INTO `solarlogmod` VALUES ('10318','2013-05-15','10:10:00',7.95),('10318','2013-05-15','10:15:00',8.06),('10318','2013-05-15','10:20:00',8.28),('10318','2013-05-15','10:25:00',8.39),('10318','2013-05-15','10:30:00',8.35),('10318','2013-05-15','10:35:00',8.38),('10318','2013-05-15','10:40:00',8.51),('10318','2013-05-15','10:45:00',8.62),('10318','2013-05-15','10:50:00',8.68),('10318','2013-05-15','10:55:00',8.46),('10318','2013-05-15','11:00:00',8.55),('10318','2013-05-15','11:05:00',8.74),('10318','2013-05-15','11:10:00',8.99),('10318','2013-05-15','11:15:00',8.9),('10318','2013-05-15','11:20:00',8.64),('10318','2013-05-15','11:25:00',9.03),('10318','2013-05-15','11:30:00',9.28),('10318','2013-05-15','11:35:00',9.33),('10318','2013-05-15','11:40:00',7.04),('10318','2013-05-15','11:45:00',7.08),('10318','2013-05-15','11:50:00',5.77),('10318','2013-05-15','11:55:00',4.24),('10318','2013-05-15','12:00:00',5.82),('10318','2013-05-15','12:05:00',7.58),('10318','2013-05-15','12:10:00',9.23),('10318','2013-05-15','12:15:00',10.95),('10318','2013-05-15','12:20:00',9.95),('10318','2013-05-15','12:25:00',7.77),('10318','2013-05-15','12:30:00',7.77),('10318','2013-05-15','12:35:00',8.68),('10318','2013-05-15','12:40:00',8.22),('10318','2013-05-15','12:45:00',5.69),('10318','2013-05-15','12:50:00',5.42),('10318','2013-05-15','12:55:00',5.85),('10318','2013-05-15','13:00:00',5.73),('10318','2013-05-15','13:05:00',6.72),('10318','2013-05-15','13:10:00',5.45),('10318','2013-05-15','13:15:00',5.91),('10318','2013-05-15','13:20:00',5.81),('10318','2013-05-15','13:25:00',6.4),('10318','2013-05-15','13:30:00',5.83),('10318','2013-05-15','13:35:00',5.35),('10318','2013-05-15','13:40:00',6.51),('10318','2013-05-15','13:45:00',5.36),('10318','2013-05-15','13:50:00',4.64),('10318','2013-05-15','13:55:00',4.91),('10318','2013-05-15','14:00:00',4.13),('10318','2013-05-15','14:05:00',3.88),('10318','2013-05-15','14:10:00',4.19),('10318','2013-05-15','14:15:00',4),('10318','2013-05-15','14:20:00',4.54),('10318','2013-05-15','14:25:00',3.85),('10318','2013-05-15','14:30:00',3.34),('10318','2013-05-15','14:35:00',3.28),('10318','2013-05-15','14:40:00',3.48),('10318','2013-05-15','14:45:00',3.28),('10318','2013-05-15','14:50:00',3.22),('10318','2013-05-15','14:55:00',3.3),('10318','2013-05-15','15:00:00',3.19),('10318','2013-05-15','15:05:00',2.45),('10318','2013-05-15','15:10:00',1.94),('10318','2013-05-15','15:15:00',1.86),('10318','2013-05-15','15:20:00',1.79),('10318','2013-05-15','15:25:00',1.78),('10318','2013-05-15','15:30:00',1.88),('10318','2013-05-15','15:35:00',1.85),('10318','2013-05-15','15:40:00',2.02),('10318','2013-05-15','15:45:00',2.66),('10318','2013-05-15','15:50:00',3.53),('10318','2013-05-15','15:55:00',4.4),('10318','2013-05-15','16:00:00',4.17),('10318','2013-05-15','16:05:00',4.04),('10318','2013-05-15','16:10:00',3.69),('10318','2013-05-15','16:15:00',3.43),('10318','2013-05-15','16:20:00',3.53),('10318','2013-05-15','16:25:00',3.38),('10318','2013-05-15','16:30:00',2.88),('10318','2013-05-15','16:35:00',2.94),('10318','2013-05-15','16:40:00',2.79),('10318','2013-05-15','16:45:00',2.65),('10318','2013-05-15','16:50:00',2.89),('10318','2013-05-15','16:55:00',3.17),('10318','2013-05-15','17:00:00',3.79),('10318','2013-05-15','17:05:00',4.36),('10318','2013-05-15','17:10:00',4.54),('10318','2013-05-15','17:15:00',4.1),('10318','2013-05-15','17:20:00',2.52),('10318','2013-05-15','17:25:00',2.07),('10318','2013-05-15','17:30:00',2.39),('10318','2013-05-15','17:35:00',2.01),('10318','2013-05-15','17:40:00',1.89),('10318','2013-05-15','17:45:00',1.95),('10318','2013-05-15','17:50:00',1.92),('10318','2013-05-15','17:55:00',1.83),('10318','2013-05-15','18:00:00',1.59),('10318','2013-05-15','18:05:00',1.27),('10318','2013-05-15','18:20:00',1.02),('10318','2013-05-15','18:25:00',1.11),('10318','2013-05-14','07:00:00',1.12),('10318','2013-05-14','07:05:00',1.51),('10318','2013-05-14','07:10:00',1.96),('10318','2013-05-14','07:15:00',2.27),('10318','2013-05-14','07:20:00',2.42),('10318','2013-05-14','07:25:00',2.79),('10318','2013-05-14','07:30:00',3.16),('10318','2013-05-14','07:35:00',3.38),('10318','2013-05-14','07:40:00',3.6),('10318','2013-05-14','07:45:00',3.82),('10318','2013-05-14','07:50:00',4.04),('10318','2013-05-14','07:55:00',4.26),('10318','2013-05-14','08:00:00',4.47),('10318','2013-05-14','08:05:00',4.66),('10318','2013-05-14','08:10:00',4.87),('10318','2013-05-14','08:15:00',5.07),('10318','2013-05-14','08:20:00',5.29),('10318','2013-05-14','08:25:00',5.49),('10318','2013-05-14','08:30:00',5.56),('10318','2013-05-14','08:35:00',5.87),('10318','2013-05-14','08:40:00',6.04),('10318','2013-05-14','08:45:00',6.2),('10318','2013-05-14','08:50:00',6.37),('10318','2013-05-14','08:55:00',6.53),('10318','2013-05-14','09:00:00',6.68),('10318','2013-05-14','09:05:00',6.87),('10318','2013-05-14','09:10:00',7.01),('10318','2013-05-14','09:15:00',7.15),('10318','2013-05-14','09:20:00',7.29),('10318','2013-05-14','09:25:00',7.43),('10318','2013-05-14','09:30:00',7.56),('10318','2013-05-14','09:35:00',7.74),('10318','2013-05-14','09:40:00',7.81),('10318','2013-05-14','09:45:00',7.93),('10318','2013-05-14','09:50:00',8.09),('10318','2013-05-14','09:55:00',8.16),('10318','2013-05-14','10:00:00',8.34),('10318','2013-05-14','10:05:00',8.42),('10318','2013-05-14','10:10:00',8.56),('10318','2013-05-14','10:15:00',8.48),('10318','2013-05-14','10:20:00',8.71),('10318','2013-05-14','10:25:00',8.83),('10318','2013-05-14','10:30:00',8.93),('10318','2013-05-14','10:35:00',9.01),('10318','2013-05-14','10:40:00',9.07),('10318','2013-05-14','10:45:00',9.09),('10318','2013-05-14','10:50:00',9.17),('10318','2013-05-14','10:55:00',9.22),('10318','2013-05-14','11:00:00',9.26),('10318','2013-05-14','11:05:00',9.32),('10318','2013-05-14','11:10:00',9.35),('10318','2013-05-14','11:15:00',9.46),('10318','2013-05-14','11:20:00',9.48),('10318','2013-05-14','11:25:00',9.51),('10318','2013-05-14','11:30:00',9.54),('10318','2013-05-14','11:35:00',9.57),('10318','2013-05-14','11:40:00',9.66),('10318','2013-05-14','11:45:00',9.64),('10318','2013-05-14','11:50:00',9.66),('10318','2013-05-14','11:55:00',9.67),('10318','2013-05-14','12:00:00',9.54),('10318','2013-05-14','12:05:00',9.69),('10318','2013-05-14','12:10:00',9.77),('10318','2013-05-14','12:15:00',9.78),('10318','2013-05-14','12:20:00',9.71),('10318','2013-05-14','12:25:00',9.67),('10318','2013-05-14','12:30:00',9.65),('10318','2013-05-14','12:35:00',9.68),('10318','2013-05-14','12:40:00',9.64),('10318','2013-05-14','12:45:00',9.6),('10318','2013-05-14','12:50:00',9.67),('10318','2013-05-14','12:55:00',9.63),('10318','2013-05-14','13:00:00',9.64),('10318','2013-05-14','13:05:00',9.55),('10318','2013-05-14','13:10:00',9.45),('10318','2013-05-14','13:15:00',9.43),('10318','2013-05-14','13:20:00',9.44),('10318','2013-05-14','13:25:00',9.38),('10318','2013-05-14','13:30:00',9.33),('10318','2013-05-14','13:35:00',9.31),('10318','2013-05-14','13:40:00',9.24),('10318','2013-05-14','13:45:00',9.18),('10318','2013-05-14','13:50:00',9.18),('10318','2013-05-14','13:55:00',9.13),('10318','2013-05-14','14:00:00',9.12),('10318','2013-05-14','14:05:00',9.06),('10318','2013-05-14','14:10:00',8.98),('10318','2013-05-14','14:15:00',8.86),('10318','2013-05-14','14:20:00',8.77),('10318','2013-05-14','14:25:00',8.7),('10318','2013-05-14','14:30:00',8.61),('10318','2013-05-14','14:35:00',8.65),('10318','2013-05-14','14:40:00',8.66),('10318','2013-05-14','14:45:00',8.61),('10318','2013-05-14','14:50:00',8.53),('10318','2013-05-14','14:55:00',8.44),('10318','2013-05-14','15:00:00',8.31),('10318','2013-05-14','15:05:00',8.29),('10318','2013-05-14','15:10:00',8.16),('10318','2013-05-14','15:15:00',8.05),('10318','2013-05-14','15:20:00',7.89),('10318','2013-05-14','15:25:00',7.75),('10318','2013-05-14','15:30:00',7.62),('10318','2013-05-14','15:35:00',7.52),('10318','2013-05-14','15:40:00',7.43),('10318','2013-05-14','15:45:00',7.3),('10318','2013-05-14','15:50:00',7.1),('10318','2013-05-14','15:55:00',6.9),('10318','2013-05-14','16:00:00',6.75),('10318','2013-05-14','16:05:00',6.61),('10318','2013-05-14','16:10:00',6.42),('10318','2013-05-14','16:15:00',6.26),('10318','2013-05-14','16:20:00',6.1),('10318','2013-05-14','16:25:00',5.93),('10318','2013-05-14','16:30:00',5.77),('10318','2013-05-14','16:35:00',5.6),('10318','2013-05-14','16:40:00',5.42),('10318','2013-05-14','16:45:00',5.16),('10318','2013-05-14','16:50:00',5.04),('10318','2013-05-14','16:55:00',4.86),('10318','2013-05-14','17:00:00',4.67),('10318','2013-05-14','17:05:00',4.47),('10318','2013-05-14','17:10:00',4.28),('10318','2013-05-14','17:15:00',4.08),('10318','2013-05-14','17:20:00',3.88),('10318','2013-05-14','17:25:00',3.68),('10318','2013-05-14','17:30:00',3.48),('10318','2013-05-14','17:35:00',3.29),('10318','2013-05-14','17:40:00',3.1),('10318','2013-05-14','17:45:00',2.92),('10318','2013-05-14','17:50:00',2.73),('10318','2013-05-14','17:55:00',2.55),('10318','2013-05-14','18:00:00',2.36),('10318','2013-05-14','18:05:00',2.16),('10318','2013-05-14','18:10:00',1.99),('10318','2013-05-14','18:15:00',1.82),('10318','2013-05-14','18:20:00',1.66),('10318','2013-05-14','18:25:00',1.49),('10318','2013-05-14','18:30:00',1.36),('10318','2013-05-14','18:35:00',1.17),('10318','2013-05-14','18:40:00',1.09),('10318','2013-05-13','07:00:00',1.03),('10318','2013-05-13','07:05:00',1.16),('10318','2013-05-13','07:10:00',1.76),('10318','2013-05-13','07:15:00',1.62),('10318','2013-05-13','07:20:00',1.25),('10318','2013-05-13','07:25:00',1.47),('10318','2013-05-13','07:30:00',2.33),('10318','2013-05-13','07:35:00',2.95),('10318','2013-05-13','07:40:00',3.03),('10318','2013-05-13','07:45:00',3.41),('10318','2013-05-13','07:50:00',3.65),('10318','2013-05-13','07:55:00',3.99),('10318','2013-05-13','08:00:00',4.03),('10318','2013-05-13','08:05:00',4.16),('10318','2013-05-13','08:10:00',4.37),('10318','2013-05-13','08:15:00',4.6),('10318','2013-05-13','08:20:00',4.84),('10318','2013-05-13','08:25:00',5.05),('10318','2013-05-13','08:30:00',5.23),('10318','2013-05-13','08:35:00',5.38),('10318','2013-05-13','08:40:00',5.59),('10318','2013-05-13','08:45:00',5.78),('10318','2013-05-13','08:50:00',5.96),('10318','2013-05-13','08:55:00',6.09),('10318','2013-05-13','09:00:00',6.28),('10318','2013-05-13','09:05:00',6.43),('10318','2013-05-13','09:10:00',6.57),('10318','2013-05-13','09:15:00',6.74),('10318','2013-05-13','09:20:00',6.93),('10318','2013-05-13','09:25:00',7.07),('10318','2013-05-13','09:30:00',7.27),('10318','2013-05-13','09:35:00',7.35),('10318','2013-05-13','09:40:00',5.94),('10318','2013-05-13','09:45:00',7.62),('10318','2013-05-13','09:50:00',8.6),('10318','2013-05-13','09:55:00',7.83),('10318','2013-05-13','10:00:00',6.68),('10318','2013-05-13','10:05:00',4.6),('10318','2013-05-13','10:10:00',5.83),('10318','2013-05-13','10:15:00',8.69),('10318','2013-05-13','10:20:00',6.66),('10318','2013-05-13','10:25:00',6.98),('10318','2013-05-13','10:30:00',8.86),('10318','2013-05-13','10:35:00',8.38),('10318','2013-05-13','10:40:00',2.64),('10318','2013-05-13','10:45:00',4.84),('10318','2013-05-13','10:50:00',9.83),('10318','2013-05-13','10:55:00',6.96),('10318','2013-05-13','11:00:00',6.4),('10318','2013-05-13','11:05:00',3.49),('10318','2013-05-13','11:10:00',5.24),('10318','2013-05-13','11:15:00',4.13),('10318','2013-05-13','11:20:00',3.74),('10318','2013-05-13','11:25:00',4.51),('10318','2013-05-13','11:30:00',4.15),('10318','2013-05-13','11:35:00',6.25),('10318','2013-05-13','11:40:00',10.22),('10318','2013-05-13','11:45:00',10.67),('10318','2013-05-13','11:50:00',10.15),('10318','2013-05-13','11:55:00',6.24),('10318','2013-05-13','12:00:00',4.97),('10318','2013-05-13','12:05:00',3.86),('10318','2013-05-13','12:10:00',3.85),('10318','2013-05-13','12:15:00',2.73),('10318','2013-05-13','12:20:00',2.34),('10318','2013-05-13','12:25:00',2.63),('10318','2013-05-13','12:30:00',6.4),('10318','2013-05-13','12:35:00',10.81),('10318','2013-05-13','12:40:00',9.69),('10318','2013-05-13','12:45:00',10.78),('10318','2013-05-13','12:50:00',6.65),('10318','2013-05-13','12:55:00',3.75),('10318','2013-05-13','13:00:00',10.77),('10318','2013-05-13','13:05:00',7.78),('10318','2013-05-13','13:10:00',6.71),('10318','2013-05-13','13:15:00',10.58),('10318','2013-05-13','13:20:00',5.3),('10318','2013-05-13','13:25:00',2.55),('10318','2013-05-13','13:30:00',3.02),('10318','2013-05-13','13:35:00',8.67),('10318','2013-05-13','13:40:00',7.87),('10318','2013-05-13','13:45:00',5.99),('10318','2013-05-13','13:50:00',5.05),('10318','2013-05-13','13:55:00',8.24),('10318','2013-05-13','14:00:00',10.11),('10318','2013-05-13','14:05:00',9.96),('10318','2013-05-13','14:10:00',9.97),('10318','2013-05-13','14:15:00',8.57),('10318','2013-05-13','14:20:00',8.57),('10318','2013-05-13','14:25:00',7.03),('10318','2013-05-13','14:30:00',4.66),('10318','2013-05-13','14:35:00',1.62),('10318','2013-05-13','14:40:00',3.09),('10318','2013-05-13','14:45:00',9.62),('10318','2013-05-13','14:50:00',7.41),('10318','2013-05-13','14:55:00',7.15),('10318','2013-05-13','15:00:00',3.29),('10318','2013-05-13','15:05:00',2.89),('10318','2013-05-13','15:10:00',2.65),('10318','2013-05-13','15:15:00',2.21),('10318','2013-05-13','15:20:00',1.98),('10318','2013-05-13','15:25:00',1.78),('10318','2013-05-13','15:30:00',2.01),('10318','2013-05-13','15:35:00',2.21),('10318','2013-05-13','15:40:00',3.35),('10318','2013-05-13','15:45:00',3.39),('10318','2013-05-13','15:50:00',1.69),('10318','2013-05-13','15:55:00',1.51),('10318','2013-05-13','16:00:00',2.95),('10318','2013-05-13','16:05:00',4.37),('10318','2013-05-13','16:10:00',2.7),('10318','2013-05-13','16:15:00',2.99),('10318','2013-05-13','16:20:00',2.81),('10318','2013-05-13','16:25:00',3.13),('10318','2013-05-13','16:30:00',3.01),('10318','2013-05-13','16:35:00',2.49),('10318','2013-05-13','16:40:00',2.65),('10318','2013-05-13','16:45:00',2.2),('10318','2013-05-13','16:50:00',3.03),('10318','2013-05-13','16:55:00',5.55),('10318','2013-05-13','17:00:00',4.6),('10318','2013-05-13','17:05:00',2.31),('10318','2013-05-13','17:10:00',1.86),('10318','2013-05-13','17:15:00',1.9),('10318','2013-05-13','17:20:00',3.61),('10318','2013-05-13','17:25:00',4.97),('10318','2013-05-13','17:30:00',4.62),('10318','2013-05-13','17:35:00',4.51),('10318','2013-05-13','17:40:00',4.38),('10318','2013-05-13','17:45:00',4.06),('10318','2013-05-13','17:50:00',4.24),('10318','2013-05-13','17:55:00',4.28),('10318','2013-05-13','18:00:00',3.8),('10318','2013-05-13','18:05:00',3.23),('10318','2013-05-13','18:10:00',2.27),('10318','2013-05-13','18:15:00',2.52),('10318','2013-05-13','18:20:00',2.14),('10318','2013-05-13','18:25:00',1.39),('10318','2013-05-13','18:30:00',1.04),('10318','2013-05-13','18:40:00',1.16),('10318','2013-05-12','07:15:00',1.07),('10318','2013-05-12','07:20:00',1.14),('10318','2013-05-12','07:25:00',1.98),('10318','2013-05-12','07:30:00',2.44),('10318','2013-05-12','07:35:00',2.54),('10318','2013-05-12','07:40:00',3.66),('10318','2013-05-12','07:45:00',3.97),('10318','2013-05-12','07:50:00',4.19),('10318','2013-05-12','07:55:00',4.49),('10318','2013-05-12','08:00:00',4.47),('10318','2013-05-12','08:05:00',3.92),('10318','2013-05-12','08:10:00',2.43),('10318','2013-05-12','08:15:00',2.1),('10318','2013-05-12','08:20:00',2.23),('10318','2013-05-12','08:25:00',2.35),('10318','2013-05-12','08:30:00',2.09),('10318','2013-05-12','08:35:00',1.98),('10318','2013-05-12','08:40:00',2.42),('10318','2013-05-12','08:45:00',3.67),('10318','2013-05-12','08:50:00',2.51),('10318','2013-05-12','08:55:00',3.38),('10318','2013-05-12','09:00:00',5.24),('10318','2013-05-12','09:05:00',3.98),('10318','2013-05-12','09:10:00',5.9),('10318','2013-05-12','09:15:00',4.01),('10318','2013-05-12','09:20:00',3.57),('10318','2013-05-12','09:25:00',3.79),('10318','2013-05-12','09:30:00',5.63),('10318','2013-05-12','09:35:00',5.67),('10318','2013-05-12','09:40:00',4.71),('10318','2013-05-12','09:45:00',7.37),('10318','2013-05-12','09:50:00',8.53),('10318','2013-05-12','09:55:00',8.48),('10318','2013-05-12','10:00:00',8.45),('10318','2013-05-12','10:05:00',8.59),('10318','2013-05-12','10:10:00',8.64),('10318','2013-05-12','10:15:00',9.08),('10318','2013-05-12','10:20:00',9.36),('10318','2013-05-12','10:25:00',9.56),('10318','2013-05-12','10:30:00',8.78),('10318','2013-05-12','10:35:00',5.28),('10318','2013-05-12','10:40:00',7.05),('10318','2013-05-12','10:45:00',5.96),('10318','2013-05-12','10:50:00',8.68),('10318','2013-05-12','10:55:00',6.12),('10318','2013-05-12','11:00:00',10.32),('10318','2013-05-12','11:05:00',6.33),('10318','2013-05-12','11:10:00',2.9),('10318','2013-05-12','11:15:00',2.9),('10318','2013-05-12','11:20:00',3.11),('10318','2013-05-12','11:25:00',2.79),('10318','2013-05-12','11:30:00',2.61),('10318','2013-05-12','11:35:00',2.64),('10318','2013-05-12','11:40:00',2.74),('10318','2013-05-12','11:45:00',2.86),('10318','2013-05-12','11:50:00',3.58),('10318','2013-05-12','11:55:00',3.72),('10318','2013-05-12','12:00:00',3.3),('10318','2013-05-12','12:05:00',2.92),('10318','2013-05-12','12:10:00',2.48),('10318','2013-05-12','12:15:00',2.82),('10318','2013-05-12','12:20:00',3.55),('10318','2013-05-12','12:25:00',8.07),('10318','2013-05-12','12:30:00',10.76),('10318','2013-05-12','12:35:00',9.28),('10318','2013-05-12','12:40:00',8.41),('10318','2013-05-12','12:45:00',8.46),('10318','2013-05-12','12:50:00',10.2),('10318','2013-05-12','12:55:00',10.85),('10318','2013-05-12','13:00:00',10.14),('10318','2013-05-12','13:05:00',10.51),('10318','2013-05-12','13:10:00',10.22),('10318','2013-05-12','13:15:00',10.18),('10318','2013-05-12','13:20:00',7.87),('10318','2013-05-12','13:25:00',10.32),('10318','2013-05-12','13:30:00',10.26),('10318','2013-05-12','13:35:00',10.18),('10318','2013-05-12','13:40:00',9.97),('10318','2013-05-12','13:45:00',9.98),('10318','2013-05-12','13:50:00',9.94),('10318','2013-05-12','13:55:00',7.8),('10318','2013-05-12','14:00:00',10.29),('10318','2013-05-12','14:05:00',7.26),('10318','2013-05-12','14:10:00',6.03),('10318','2013-05-12','14:15:00',10.26),('10318','2013-05-12','14:20:00',7.87),('10318','2013-05-12','14:25:00',8.81),('10318','2013-05-12','14:30:00',9.62),('10318','2013-05-12','14:35:00',7.15),('10318','2013-05-12','14:40:00',6.74),('10318','2013-05-12','14:45:00',9.33),('10318','2013-05-12','14:50:00',6.96),('10318','2013-05-12','14:55:00',6.13),('10318','2013-05-12','15:00:00',9.45),('10318','2013-05-12','15:05:00',7.82),('10318','2013-05-12','15:10:00',7.33),('10318','2013-05-12','15:15:00',8.27),('10318','2013-05-12','15:20:00',8.35),('10318','2013-05-12','15:25:00',7.9),('10318','2013-05-12','15:30:00',7.7),('10318','2013-05-12','15:35:00',5.9),('10318','2013-05-12','15:40:00',7.33),('10318','2013-05-12','15:45:00',7.28),('10318','2013-05-12','15:50:00',7.1),('10318','2013-05-12','15:55:00',6.93),('10318','2013-05-12','16:00:00',6.77),('10318','2013-05-12','16:05:00',6.64),('10318','2013-05-12','16:10:00',6.41),('10318','2013-05-12','16:15:00',6.17),('10318','2013-05-12','16:20:00',6.05),('10318','2013-05-12','16:25:00',5.92),('10318','2013-05-12','16:30:00',5.53),('10318','2013-05-12','16:35:00',4.66),('10318','2013-05-12','16:40:00',4.98),('10318','2013-05-12','16:45:00',5.41),('10318','2013-05-12','16:50:00',6.6),('10318','2013-05-12','16:55:00',6.51),('10318','2013-05-12','17:00:00',6.22),('10318','2013-05-12','17:05:00',5.4),('10318','2013-05-12','17:10:00',6.14),('10318','2013-05-12','17:15:00',5.64),('10318','2013-05-12','17:20:00',4.75),('10318','2013-05-12','17:25:00',4.62),('10318','2013-05-12','17:30:00',4.33),('10318','2013-05-12','17:35:00',4.89),('10318','2013-05-12','17:40:00',4.13),('10318','2013-05-12','17:45:00',2.45),('10318','2013-05-12','17:50:00',2.02),('10318','2013-05-12','17:55:00',3.53),('10318','2013-05-12','18:00:00',3.77),('10318','2013-05-12','18:05:00',3.11),('10318','2013-05-12','18:10:00',3.98),('10318','2013-05-12','18:15:00',2.8),('10318','2013-05-12','18:20:00',2.8),('10318','2013-05-12','18:25:00',2.56),('10318','2013-05-12','18:30:00',2.82),('10318','2013-05-12','18:35:00',2.53),('10318','2013-05-12','18:40:00',2.28),('10318','2013-05-12','18:45:00',1.76),('10318','2013-05-12','18:50:00',1.49),('10318','2013-05-12','18:55:00',1.62),('10318','2013-05-12','19:00:00',1.74),('10318','2013-05-12','19:05:00',1.58),('10318','2013-05-12','19:10:00',1.64),('10318','2013-05-12','19:15:00',1.46),('10318','2013-05-12','19:25:00',1.02),('10318','2014-03-31','07:50:00',1.02),('10318','2014-03-31','07:55:00',1.35),('10318','2014-03-31','08:00:00',1.72),('10318','2014-03-31','08:05:00',2.25),('10318','2014-03-31','08:10:00',2.48),('10318','2014-03-31','08:15:00',2.91),('10318','2014-03-31','08:20:00',3.38),('10318','2014-03-31','08:25:00',3.7),('10318','2014-03-31','08:30:00',3.92),('10318','2014-03-31','08:35:00',4.11),('10318','2014-03-31','08:40:00',4.35),('10318','2014-03-31','08:45:00',4.57),('10318','2014-03-31','08:50:00',4.81),('10318','2014-03-31','08:55:00',5.02),('10318','2014-03-31','09:00:00',5.24),('10318','2014-03-31','09:05:00',5.43),('10318','2014-03-31','09:10:00',5.61),('10318','2014-03-31','09:15:00',5.73),('10318','2014-03-31','09:20:00',5.99),('10318','2014-03-31','09:25:00',6.16),('10318','2014-03-31','09:30:00',6.33),('10318','2014-03-31','09:35:00',6.53),('10318','2014-03-31','09:40:00',6.7),('10318','2014-03-31','09:45:00',6.82),('10318','2014-03-31','09:50:00',6.97),('10318','2014-03-31','09:55:00',7.12),('10318','2014-03-31','10:00:00',7.25),('10318','2014-03-31','10:05:00',7.36),('10318','2014-03-31','10:10:00',7.49),('10318','2014-03-31','10:15:00',7.62),('10318','2014-03-31','10:20:00',7.75),('10318','2014-03-31','10:25:00',7.83),('10318','2014-03-31','10:30:00',7.81),('10318','2014-03-31','10:35:00',8),('10318','2014-03-31','10:40:00',8.09),('10318','2014-03-31','10:45:00',8.18),('10318','2014-03-31','10:50:00',8.27),('10318','2014-03-31','10:55:00',8.4),('10318','2014-03-31','11:00:00',8.44),('10318','2014-03-31','11:05:00',8.53),('10318','2014-03-31','11:10:00',8.59),('10318','2014-03-31','11:15:00',8.66),('10318','2014-03-31','11:20:00',8.7),('10318','2014-03-31','11:25:00',8.77),('10318','2014-03-31','11:30:00',8.8),('10318','2014-03-31','11:35:00',8.85),('10318','2014-03-31','11:40:00',8.96),('10318','2014-03-31','11:45:00',8.99),('10318','2014-03-31','11:50:00',8.99),('10318','2014-03-31','11:55:00',9.11),('10318','2014-03-31','12:00:00',9.02),('10318','2014-03-31','12:05:00',9.07),('10318','2014-03-31','12:10:00',9.07),('10318','2014-03-31','12:15:00',9.13),('10318','2014-03-31','12:20:00',9.22),('10318','2014-03-31','12:25:00',9.17),('10318','2014-03-31','12:30:00',9.13),('10318','2014-03-31','12:35:00',9.13),('10318','2014-03-31','12:40:00',9.12),('10318','2014-03-31','12:45:00',9.12),('10318','2014-03-31','12:50:00',9.18),('10318','2014-03-31','12:55:00',9.26),('10318','2014-03-31','13:00:00',9.22),('10318','2014-03-31','13:05:00',9.17),('10318','2014-03-31','13:10:00',9.17),('10318','2014-03-31','13:15:00',9.17),('10318','2014-03-31','13:20:00',9.2),('10318','2014-03-31','13:25:00',9.14),('10318','2014-03-31','13:30:00',9.11),('10318','2014-03-31','13:35:00',9.14),('10318','2014-03-31','13:40:00',9.04),('10318','2014-03-31','13:45:00',8.94),('10318','2014-03-31','13:50:00',8.92),('10318','2014-03-31','13:55:00',8.82),('10318','2014-03-31','14:00:00',8.63),('10318','2014-03-31','14:05:00',8.73),('10318','2014-03-31','14:10:00',8.67),('10318','2014-03-31','14:15:00',8.6),('10318','2014-03-31','14:20:00',8.5),('10318','2014-03-31','14:25:00',8.48),('10318','2014-03-31','14:30:00',8.41),('10318','2014-03-31','14:35:00',8.32),('10318','2014-03-31','14:40:00',8.22),('10318','2014-03-31','14:45:00',8.11),('10318','2014-03-31','14:50:00',7.99),('10318','2014-03-31','14:55:00',7.92),('10318','2014-03-31','15:00:00',7.8),('10318','2014-03-31','15:05:00',7.67),('10318','2014-03-31','15:10:00',7.56),('10318','2014-03-31','15:15:00',7.43),('10318','2014-03-31','15:20:00',7.32),('10318','2014-03-31','15:25:00',7.21),('10318','2014-03-31','15:30:00',7.06),('10318','2014-03-31','15:35:00',6.88),('10318','2014-03-31','15:40:00',6.74),('10318','2014-03-31','15:45:00',6.58),('10318','2014-03-31','15:50:00',6.27),('10318','2014-03-31','15:55:00',6.19),('10318','2014-03-31','16:00:00',6.01),('10318','2014-03-31','16:05:00',5.81),('10318','2014-03-31','16:10:00',5.68),('10318','2014-03-31','16:15:00',5.5),('10318','2014-03-31','16:20:00',5.34),('10318','2014-03-31','16:25:00',5.15),('10318','2014-03-31','16:30:00',4.98),('10318','2014-03-31','16:35:00',4.8),('10318','2014-03-31','16:40:00',4.58),('10318','2014-03-31','16:45:00',4.41),('10318','2014-03-31','16:50:00',4.21),('10318','2014-03-31','16:55:00',4.06),('10318','2014-03-31','17:00:00',3.84),('10318','2014-03-31','17:05:00',3.64),('10318','2014-03-31','17:10:00',3.47),('10318','2014-03-31','17:15:00',3.31),('10318','2014-03-31','17:20:00',3.11),('10318','2014-03-31','17:25:00',2.96),('10318','2014-03-31','17:30:00',2.76),('10318','2014-03-31','17:35:00',2.54),('10318','2014-03-31','17:40:00',2.41),('10318','2014-03-31','17:45:00',2.25),('10318','2014-03-31','17:50:00',2.1),('10318','2014-03-31','17:55:00',1.95),('10318','2014-03-31','18:00:00',1.78),('10318','2014-03-31','18:05:00',1.63),('10318','2014-03-31','18:10:00',1.51),('10318','2014-03-31','18:15:00',1.42),('10318','2014-03-31','18:20:00',1.31),('10318','2014-03-31','18:25:00',1.19),('10318','2014-03-31','18:30:00',1.04),('10318','2013-05-11','07:10:00',1.04),('10318','2013-05-11','07:15:00',1.9),('10318','2013-05-11','07:20:00',2.05),('10318','2013-05-11','07:25:00',2.27),('10318','2013-05-11','07:30:00',2.67),('10318','2013-05-11','07:35:00',2.84),('10318','2013-05-11','07:40:00',3.12),('10318','2013-05-11','07:45:00',3.6),('10318','2013-05-11','07:50:00',4.05),('10318','2013-05-11','07:55:00',3.7),('10318','2013-05-11','08:00:00',3.7),('10318','2013-05-11','08:05:00',2.98),('10318','2013-05-11','08:10:00',2.21),('10318','2013-05-11','08:15:00',1.81),('10318','2013-05-11','08:20:00',1.15),('10318','2013-05-11','08:25:00',1.38),('10318','2013-05-11','08:30:00',1.34),('10318','2013-05-11','08:35:00',2.11),('10318','2013-05-11','08:40:00',2.71),('10318','2013-05-11','08:45:00',2.91),('10318','2013-05-11','08:50:00',2.53),('10318','2013-05-11','08:55:00',2.82),('10318','2013-05-11','09:00:00',6.5),('10318','2013-05-11','09:05:00',6.48),('10318','2013-05-11','09:10:00',3.7),('10318','2013-05-11','09:15:00',5.4),('10318','2013-05-11','09:20:00',4.23),('10318','2013-05-11','09:25:00',5.57),('10318','2013-05-11','09:30:00',4),('10318','2013-05-11','09:35:00',2.39),('10318','2013-05-11','09:40:00',3.17),('10318','2013-05-11','09:45:00',3.28),('10318','2013-05-11','09:50:00',3.76),('10318','2013-05-11','09:55:00',3.86),('10318','2013-05-11','10:00:00',2.21),('10318','2013-05-11','10:05:00',1.51),('10318','2013-05-11','10:10:00',1.53),('10318','2013-05-11','10:15:00',2.01),('10318','2013-05-11','10:20:00',2.75),('10318','2013-05-11','10:25:00',4.3),('10318','2013-05-11','10:30:00',4.56),('10318','2013-05-11','10:35:00',3.24),('10318','2013-05-11','10:40:00',6.34),('10318','2013-05-11','10:45:00',8.09),('10318','2013-05-11','10:50:00',9.69),('10318','2013-05-11','10:55:00',9.22),('10318','2013-05-11','11:00:00',10.24),('10318','2013-05-11','11:05:00',7.41),('10318','2013-05-11','11:10:00',3.18),('10318','2013-05-11','11:15:00',2.46),('10318','2013-05-11','11:20:00',2.48),('10318','2013-05-11','11:25:00',4.15),('10318','2013-05-11','11:30:00',3.34),('10318','2013-05-11','11:35:00',2.79),('10318','2013-05-11','11:40:00',3.98),('10318','2013-05-11','11:45:00',3.1),('10318','2013-05-11','11:50:00',4.1),('10318','2013-05-11','11:55:00',3.84),('10318','2013-05-11','12:00:00',6.21),('10318','2013-05-11','12:05:00',4.46),('10318','2013-05-11','12:10:00',3.27),('10318','2013-05-11','12:15:00',7.87),('10318','2013-05-11','12:20:00',10.83),('10318','2013-05-11','12:25:00',10.22),('10318','2013-05-11','12:30:00',10.13),('10318','2013-05-11','12:35:00',7.97),('10318','2013-05-11','12:40:00',8.74),('10318','2013-05-11','12:45:00',4.28),('10318','2013-05-11','12:50:00',3.73),('10318','2013-05-11','12:55:00',3.25),('10318','2013-05-11','13:00:00',3.14),('10318','2013-05-11','13:05:00',2.63),('10318','2013-05-11','13:10:00',2.16),('10318','2013-05-11','13:15:00',2.5),('10318','2013-05-11','13:20:00',4.04),('10318','2013-05-11','13:25:00',2.77),('10318','2013-05-11','13:30:00',3.03),('10318','2013-05-11','13:35:00',2.91),('10318','2013-05-11','13:40:00',1.86),('10318','2013-05-11','13:45:00',4.11),('10318','2013-05-11','13:50:00',7.72),('10318','2013-05-11','13:55:00',8.47),('10318','2013-05-11','14:00:00',7.64),('10318','2013-05-11','14:05:00',8.29),('10318','2013-05-11','14:10:00',7.64),('10318','2013-05-11','14:15:00',7.85),('10318','2013-05-11','14:20:00',6.77),('10318','2013-05-11','14:25:00',3.81),('10318','2013-05-11','14:30:00',3.8),('10318','2013-05-11','14:35:00',7.51),('10318','2013-05-11','14:40:00',5.1),('10318','2013-05-11','14:45:00',6.46),('10318','2013-05-11','14:50:00',4.2),('10318','2013-05-11','14:55:00',4.52),('10318','2013-05-11','15:00:00',7.58),('10318','2013-05-11','15:05:00',2.48),('10318','2013-05-11','15:10:00',3.67),('10318','2013-05-11','15:15:00',9),('10318','2013-05-11','15:20:00',5.24),('10318','2013-05-11','15:25:00',7.04),('10318','2013-05-11','15:30:00',5.44),('10318','2013-05-11','15:35:00',5.11),('10318','2013-05-11','15:40:00',6.25),('10318','2013-05-11','15:45:00',3.99),('10318','2013-05-11','15:50:00',4.94),('10318','2013-05-11','15:55:00',5.78),('10318','2013-05-11','16:00:00',7.18),('10318','2013-05-11','16:05:00',4.27),('10318','2013-05-11','16:10:00',5.06),('10318','2013-05-11','16:15:00',6.27),('10318','2013-05-11','16:20:00',5.97),('10318','2013-05-11','16:25:00',6.17),('10318','2013-05-11','16:30:00',5.26),('10318','2013-05-11','16:35:00',5.22),('10318','2013-05-11','16:40:00',4.18),('10318','2013-05-11','16:45:00',5.6),('10318','2013-05-11','16:50:00',5.47),('10318','2013-05-11','16:55:00',3.32),('10318','2013-05-11','17:00:00',2.6),('10318','2013-05-11','17:05:00',3.37),('10318','2013-05-11','17:10:00',4.79),('10318','2013-05-11','17:15:00',2.89),('10318','2013-05-11','17:20:00',3.85),('10318','2013-05-11','17:25:00',2.19),('10318','2013-05-11','17:30:00',2.29),('10318','2013-05-11','17:35:00',3.63),('10318','2013-05-11','17:40:00',3.17),('10318','2013-05-11','17:45:00',1.65),('10318','2013-05-11','17:50:00',1.27),('10318','2013-05-11','17:55:00',2.18),('10318','2013-05-11','18:00:00',3.11),('10318','2013-05-11','18:05:00',2.47),('10318','2013-05-11','18:10:00',1.67),('10318','2013-05-11','18:15:00',2.49),('10318','2013-05-11','18:20:00',2.26),('10318','2013-05-11','18:25:00',1.13),('10318','2013-05-11','18:30:00',1.94),('10318','2013-05-11','18:35:00',1.04),('10318','2013-05-11','18:40:00',1.27),('10318','2013-05-11','18:50:00',1.4),('10318','2013-05-11','18:55:00',1.05),('10318','2013-05-10','07:05:00',1.06),('10318','2013-05-10','07:10:00',1.41),('10318','2013-05-10','07:15:00',1.68),('10318','2013-05-10','07:20:00',2.33),('10318','2013-05-10','07:25:00',2.41),('10318','2013-05-10','07:30:00',2.76),('10318','2013-05-10','07:35:00',3.05),('10318','2013-05-10','07:40:00',3.11),('10318','2013-05-10','07:45:00',3.57),('10318','2013-05-10','07:50:00',3.92),('10318','2013-05-10','07:55:00',4.22),('10318','2013-05-10','08:00:00',2.74),('10318','2013-05-10','08:05:00',3.03),('10318','2013-05-10','08:10:00',4.11),('10318','2013-05-10','08:15:00',4.87),('10318','2013-05-10','08:20:00',5.07),('10318','2013-05-10','08:25:00',4.53),('10318','2013-05-10','08:30:00',5.27),('10318','2013-05-10','08:35:00',2.59),('10318','2013-05-10','08:40:00',1.51),('10318','2013-05-10','08:45:00',1.54),('10318','2013-05-10','08:50:00',1.55),('10318','2013-05-10','08:55:00',3.67),('10318','2013-05-10','09:00:00',5.94),('10318','2013-05-10','09:05:00',6.64),('10318','2013-05-10','09:10:00',6.78),('10318','2013-05-10','09:15:00',6.77),('10318','2013-05-10','09:20:00',5.6),('10318','2013-05-10','09:25:00',6.13),('10318','2013-05-10','09:30:00',7.61),('10318','2013-05-10','09:35:00',6.08),('10318','2013-05-10','09:40:00',6.41),('10318','2013-05-10','09:45:00',7.23),('10318','2013-05-10','09:50:00',8.01),('10318','2013-05-10','09:55:00',7.26),('10318','2013-05-10','10:00:00',7.05),('10318','2013-05-10','10:05:00',5.7),('10318','2013-05-10','10:10:00',6.27),('10318','2013-05-10','10:15:00',8.29),('10318','2013-05-10','10:20:00',8.75),('10318','2013-05-10','10:25:00',7.95),('10318','2013-05-10','10:30:00',5.82),('10318','2013-05-10','10:35:00',3.26),('10318','2013-05-10','10:40:00',9.14),('10318','2013-05-10','10:45:00',8.68),('10318','2013-05-10','10:50:00',7.87),('10318','2013-05-10','10:55:00',9.47),('10318','2013-05-10','11:00:00',9.01),('10318','2013-05-10','11:05:00',9.64),('10318','2013-05-10','11:10:00',9.86),('10318','2013-05-10','11:15:00',9.88),('10318','2013-05-10','11:20:00',6.72),('10318','2013-05-10','11:25:00',4.13),('10318','2013-05-10','11:30:00',3.31),('10318','2013-05-10','11:35:00',10.75),('10318','2013-05-10','11:40:00',5.15),('10318','2013-05-10','11:45:00',3),('10318','2013-05-10','11:50:00',3.46),('10318','2013-05-10','11:55:00',7.53),('10318','2013-05-10','12:00:00',7.11),('10318','2013-05-10','12:05:00',6.96),('10318','2013-05-10','12:10:00',7.17),('10318','2013-05-10','12:15:00',7.74),('10318','2013-05-10','12:20:00',5.99),('10318','2013-05-10','12:25:00',5.86),('10318','2013-05-10','12:30:00',6.42),('10318','2013-05-10','12:35:00',9.08),('10318','2013-05-10','12:40:00',10.64),('10318','2013-05-10','12:45:00',9.05),('10318','2013-05-10','12:50:00',9.63),('10318','2013-05-10','12:55:00',9.63),('10318','2013-05-10','13:00:00',9.66),('10318','2013-05-10','13:05:00',10.1),('10318','2013-05-10','13:10:00',10.53),('10318','2013-05-10','13:15:00',8.34),('10318','2013-05-10','13:20:00',7.14),('10318','2013-05-10','13:25:00',8.04),('10318','2013-05-10','13:30:00',8.81),('10318','2013-05-10','13:35:00',9.22),('10318','2013-05-10','13:40:00',9.69),('10318','2013-05-10','13:45:00',5.55),('10318','2013-05-10','13:50:00',4.68),('10318','2013-05-10','13:55:00',4.36),('10318','2013-05-10','14:00:00',4.39),('10318','2013-05-10','14:05:00',5.17),('10318','2013-05-10','14:10:00',5.9),('10318','2013-05-10','14:15:00',5.86),('10318','2013-05-10','14:20:00',5.74),('10318','2013-05-10','14:25:00',5.28),('10318','2013-05-10','14:30:00',6.57),('10318','2013-05-10','14:35:00',5.96),('10318','2013-05-10','14:40:00',4.57),('10318','2013-05-10','14:45:00',3.59),('10318','2013-05-10','14:50:00',3.04),('10318','2013-05-10','14:55:00',2.84),('10318','2013-05-10','15:00:00',3.1),('10318','2013-05-10','15:05:00',4.43),('10318','2013-05-10','15:10:00',7.57),('10318','2013-05-10','15:15:00',5.74),('10318','2013-05-10','15:20:00',4.44),('10318','2013-05-10','15:25:00',4.23),('10318','2013-05-10','15:30:00',4.39),('10318','2013-05-10','15:35:00',4.6),('10318','2013-05-10','15:40:00',4.44),('10318','2013-05-10','15:45:00',4.1),('10318','2013-05-10','15:50:00',3.8),('10318','2013-05-10','15:55:00',3.7),('10318','2013-05-10','16:00:00',3.72),('10318','2013-05-10','16:05:00',3.6),('10318','2013-05-10','16:10:00',3.37),('10318','2013-05-10','16:15:00',3.05),('10318','2013-05-10','16:20:00',3.03),('10318','2013-05-10','16:25:00',3.24),('10318','2013-05-10','16:30:00',3.55),('10318','2013-05-10','16:35:00',3.39),('10318','2013-05-10','16:40:00',3.1),('10318','2013-05-10','16:45:00',3.16),('10318','2013-05-10','16:50:00',2.71),('10318','2013-05-10','16:55:00',2.12),('10318','2013-05-10','17:00:00',2.07),('10318','2013-05-10','17:05:00',2.64),('10318','2013-05-10','17:10:00',3.59),('10318','2013-05-10','17:15:00',4.19),('10318','2013-05-10','17:20:00',4.64),('10318','2013-05-10','17:25:00',4.53),('10318','2013-05-10','17:30:00',5.58),('10318','2013-05-10','17:35:00',3.53),('10318','2013-05-10','17:40:00',2.87),('10318','2013-05-10','17:45:00',2.44),('10318','2013-05-10','17:50:00',2.2),('10318','2013-05-10','17:55:00',2.04),('10318','2013-05-10','18:00:00',1.96),('10318','2013-05-10','18:05:00',1.93),('10318','2013-05-10','18:10:00',1.72),('10318','2013-05-10','18:15:00',1.7),('10318','2013-05-10','18:20:00',1.59),('10318','2013-05-10','18:25:00',1.25),('10318','2013-05-09','07:05:00',1.09),('10318','2013-05-09','07:10:00',1.41),('10318','2013-05-09','07:15:00',1.86),('10318','2013-05-09','07:20:00',2.1),('10318','2013-05-09','07:25:00',2.45),('10318','2013-05-09','07:30:00',2.77),('10318','2013-05-09','07:35:00',2.98),('10318','2013-05-09','07:40:00',3.27),('10318','2013-05-09','07:45:00',3.47),('10318','2013-05-09','07:50:00',3.66),('10318','2013-05-09','07:55:00',3.87),('10318','2013-05-09','08:00:00',4.07),('10318','2013-05-09','08:05:00',4.28),('10318','2013-05-09','08:10:00',4.49),('10318','2013-05-09','08:15:00',4.7),('10318','2013-05-09','08:20:00',4.88),('10318','2013-05-09','08:25:00',5.07),('10318','2013-05-09','08:30:00',5.27),('10318','2013-05-09','08:35:00',5.45),('10318','2013-05-09','08:40:00',5.63),('10318','2013-05-09','08:45:00',5.82),('10318','2013-05-09','08:50:00',5.99),('10318','2013-05-09','08:55:00',6.17),('10318','2013-05-09','09:00:00',6.35),('10318','2013-05-09','09:05:00',6.5),('10318','2013-05-09','09:10:00',6.66),('10318','2013-05-09','09:15:00',6.81),('10318','2013-05-09','09:20:00',6.79),('10318','2013-05-09','09:25:00',7.12),('10318','2013-05-09','09:30:00',7.28),('10318','2013-05-09','09:35:00',7.42),('10318','2013-05-09','09:40:00',7.55),('10318','2013-05-09','09:45:00',7.65),('10318','2013-05-09','09:50:00',7.72),('10318','2013-05-09','09:55:00',7.9),('10318','2013-05-09','10:00:00',8.04),('10318','2013-05-09','10:05:00',8.14),('10318','2013-05-09','10:10:00',8.22),('10318','2013-05-09','10:15:00',8.31),('10318','2013-05-09','10:20:00',8.4),('10318','2013-05-09','10:25:00',8.57),('10318','2013-05-09','10:30:00',8.61),('10318','2013-05-09','10:35:00',8.69),('10318','2013-05-09','10:40:00',8.8),('10318','2013-05-09','10:45:00',8.81),('10318','2013-05-09','10:50:00',8.91),('10318','2013-05-09','10:55:00',8.96),('10318','2013-05-09','11:00:00',9.02),('10318','2013-05-09','11:05:00',9.12),('10318','2013-05-09','11:10:00',9.08),('10318','2013-05-09','11:15:00',9.25),('10318','2013-05-09','11:20:00',9.29),('10318','2013-05-09','11:25:00',9.32),('10318','2013-05-09','11:30:00',9.32),('10318','2013-05-09','11:35:00',9.38),('10318','2013-05-09','11:40:00',9.4),('10318','2013-05-09','11:45:00',9.4),('10318','2013-05-09','11:50:00',9.34),('10318','2013-05-09','11:55:00',9.41),('10318','2013-05-09','12:00:00',9.51),('10318','2013-05-09','12:05:00',9.57),('10318','2013-05-09','12:10:00',9.57),('10318','2013-05-09','12:15:00',9.6),('10318','2013-05-09','12:20:00',9.62),('10318','2013-05-09','12:25:00',9.63),('10318','2013-05-09','12:30:00',9.63),('10318','2013-05-09','12:35:00',9.55),('10318','2013-05-09','12:40:00',9.61),('10318','2013-05-09','12:45:00',9.57),('10318','2013-05-09','12:50:00',9.57),('10318','2013-05-09','12:55:00',9.47),('10318','2013-05-09','13:00:00',9.47),('10318','2013-05-09','13:05:00',9.29),('10318','2013-05-09','13:10:00',9.41),('10318','2013-05-09','13:15:00',9.55),('10318','2013-05-09','13:20:00',9.57),('10318','2013-05-09','13:25:00',9.5),('10318','2013-05-09','13:30:00',9.5),('10318','2013-05-09','13:35:00',9.61),('10318','2013-05-09','13:40:00',9.49),('10318','2013-05-09','13:45:00',6.62),('10318','2013-05-09','13:50:00',2.51),('10318','2013-05-09','13:55:00',2.16),('10318','2013-05-09','14:00:00',6.72),('10318','2013-05-09','14:05:00',8.87),('10318','2013-05-09','14:10:00',9.16),('10318','2013-05-09','14:15:00',8.58),('10318','2013-05-09','14:20:00',3.43),('10318','2013-05-09','14:25:00',9.52),('10318','2013-05-09','14:30:00',9.08),('10318','2013-05-09','14:35:00',8.83),('10318','2013-05-09','14:40:00',8.58),('10318','2013-05-09','14:45:00',8.46),('10318','2013-05-09','14:50:00',7.59),('10318','2013-05-09','14:55:00',8.25),('10318','2013-05-09','15:00:00',8.18),('10318','2013-05-09','15:05:00',8.15),('10318','2013-05-09','15:10:00',8.06),('10318','2013-05-09','15:15:00',7.96),('10318','2013-05-09','15:20:00',7.81),('10318','2013-05-09','15:25:00',7.57),('10318','2013-05-09','15:30:00',7.42),('10318','2013-05-09','15:35:00',7.36),('10318','2013-05-09','15:40:00',7.23),('10318','2013-05-09','15:45:00',7.13),('10318','2013-05-09','15:50:00',6.95),('10318','2013-05-09','15:55:00',6.7),('10318','2013-05-09','16:00:00',6.6),('10318','2013-05-09','16:05:00',6.42),('10318','2013-05-09','16:10:00',6.28),('10318','2013-05-09','16:15:00',6.1),('10318','2013-05-09','16:20:00',5.94),('10318','2013-05-09','16:25:00',5.74),('10318','2013-05-09','16:30:00',5.59),('10318','2013-05-09','16:35:00',5.39),('10318','2013-05-09','16:40:00',5.25),('10318','2013-05-09','16:45:00',5.06),('10318','2013-05-09','16:50:00',4.88),('10318','2013-05-09','16:55:00',4.69),('10318','2013-05-09','17:00:00',4.49),('10318','2013-05-09','17:05:00',4.28),('10318','2013-05-09','17:10:00',4.09),('10318','2013-05-09','17:15:00',3.91),('10318','2013-05-09','17:20:00',3.74),('10318','2013-05-09','17:25:00',3.55),('10318','2013-05-09','17:30:00',3.37),('10318','2013-05-09','17:35:00',3.19),('10318','2013-05-09','17:40:00',2.93),('10318','2013-05-09','17:45:00',2.79),('10318','2013-05-09','17:50:00',2.61),('10318','2013-05-09','17:55:00',2.44),('10318','2013-05-09','18:00:00',2.23),('10318','2013-05-09','18:05:00',2.09),('10318','2013-05-09','18:10:00',1.88),('10318','2013-05-09','18:15:00',1.76),('10318','2013-05-09','18:20:00',1.61),('10318','2013-05-09','18:25:00',1.46),('10318','2013-05-09','18:30:00',1.33),('10318','2013-05-09','18:35:00',1.17),('10318','2013-05-09','18:40:00',1.05),('10318','2013-05-08','07:55:00',3.08),('10318','2013-05-08','08:00:00',3.97),('10318','2013-05-08','08:05:00',4.12),('10318','2013-05-08','08:10:00',4.16),('10318','2013-05-08','08:15:00',4.79),('10318','2013-05-08','08:20:00',4.94),('10318','2013-05-08','08:25:00',5.03),('10318','2013-05-08','08:30:00',5.19),('10318','2013-05-08','08:35:00',5.36),('10318','2013-05-08','08:40:00',5.36),('10318','2013-05-08','08:45:00',5.63),('10318','2013-05-08','08:50:00',5.76),('10318','2013-05-08','08:55:00',4.86),('10318','2013-05-08','09:00:00',4.57),('10318','2013-05-08','09:05:00',6.71),('10318','2013-05-08','09:10:00',6.75),('10318','2013-05-08','09:15:00',6.9),('10318','2013-05-08','09:20:00',7.31),('10318','2013-05-08','09:25:00',7.8),('10318','2013-05-08','09:30:00',8.45),('10318','2013-05-08','09:35:00',8.36),('10318','2013-05-08','09:40:00',5.08),('10318','2013-05-08','09:45:00',6.27),('10318','2013-05-08','09:50:00',4.6),('10318','2013-05-08','09:55:00',9.26),('10318','2013-05-08','10:00:00',9.2),('10318','2013-05-08','10:05:00',8.74),('10318','2013-05-08','10:10:00',8.61),('10318','2013-05-08','10:15:00',9.62),('10318','2013-05-08','10:20:00',5.52),('10318','2013-05-08','10:25:00',1.76),('10318','2013-05-08','10:30:00',1.68),('10318','2013-05-08','10:35:00',1.66),('10318','2013-05-08','10:40:00',1.78),('10318','2013-05-08','10:45:00',2.13),('10318','2013-05-08','10:50:00',6.02),('10318','2013-05-08','10:55:00',10.21),('10318','2013-05-08','11:00:00',9.97),('10318','2013-05-08','11:05:00',9.89),('10318','2013-05-08','11:10:00',10.09),('10318','2013-05-08','11:15:00',10.48),('10318','2013-05-08','11:20:00',10.05),('10318','2013-05-08','11:25:00',9.98),('10318','2013-05-08','11:30:00',6.48),('10318','2013-05-08','11:35:00',6.4),('10318','2013-05-08','11:40:00',7.05),('10318','2013-05-08','11:45:00',8.19),('10318','2013-05-08','11:50:00',2.82),('10318','2013-05-08','11:55:00',2.62),('10318','2013-05-08','12:00:00',2.71),('10318','2013-05-08','12:05:00',2.74),('10318','2013-05-08','12:10:00',2.32),('10318','2013-05-08','12:15:00',4.45),('10318','2013-05-08','12:20:00',4.23),('10318','2013-05-08','12:25:00',2.2),('10318','2013-05-08','12:30:00',2.09),('10318','2013-05-08','12:35:00',1.86),('10318','2013-05-08','12:40:00',2.34),('10318','2013-05-08','12:45:00',2.95),('10318','2013-05-08','12:50:00',2.67),('10318','2013-05-08','12:55:00',2.93),('10318','2013-05-08','13:00:00',3.39),('10318','2013-05-08','13:05:00',5.1),('10318','2013-05-08','13:10:00',3.46),('10318','2013-05-08','13:15:00',2.29),('10318','2013-05-08','13:20:00',6.27),('10318','2013-05-08','13:25:00',6.42),('10318','2013-05-08','13:30:00',8.24),('10318','2013-05-08','13:35:00',10.49),('10318','2013-05-08','13:40:00',8.95),('10318','2013-05-08','13:45:00',4.59),('10318','2013-05-08','13:50:00',5.54),('10318','2013-05-08','13:55:00',9.68),('10318','2013-05-08','14:00:00',7.85),('10318','2013-05-08','14:05:00',5.25),('10318','2013-05-08','14:10:00',4.45),('10318','2013-05-08','14:15:00',3.82),('10318','2013-05-08','14:20:00',6.7),('10318','2013-05-08','14:25:00',10.03),('10318','2013-05-08','14:30:00',7.43),('10318','2013-05-08','14:35:00',8),('10318','2013-05-08','14:40:00',9.32),('10318','2013-05-08','14:45:00',8.84),('10318','2013-05-08','14:50:00',7.56),('10318','2013-05-08','14:55:00',4.81),('10318','2013-05-08','15:00:00',9.02),('10318','2013-05-08','15:05:00',8.69),('10318','2013-05-08','15:10:00',8.01),('10318','2013-05-08','15:15:00',7.99),('10318','2013-05-08','15:20:00',7.86),('10318','2013-05-08','15:25:00',7.77),('10318','2013-05-08','15:30:00',6.91),('10318','2013-05-08','15:35:00',7.55),('10318','2013-05-08','15:40:00',7.59),('10318','2013-05-08','15:45:00',7.41),('10318','2013-05-08','15:50:00',4.94),('10318','2013-05-08','15:55:00',6.17),('10318','2013-05-08','16:00:00',4.55),('10318','2013-05-08','16:05:00',5.44),('10318','2013-05-08','16:10:00',6.16),('10318','2013-05-08','16:15:00',6.58),('10318','2013-05-08','16:20:00',6.13),('10318','2013-05-08','16:25:00',6.2),('10318','2013-05-08','16:30:00',6.11),('10318','2013-05-08','16:35:00',5.92),('10318','2013-05-08','16:40:00',5.71),('10318','2013-05-08','16:45:00',5.45),('10318','2013-05-08','16:50:00',5.09),('10318','2013-05-08','16:55:00',4.82),('10318','2013-05-08','17:00:00',4.44),('10318','2013-05-08','17:05:00',4.5),('10318','2013-05-08','17:10:00',4.28),('10318','2013-05-08','17:15:00',3.73),('10318','2013-05-08','17:20:00',3.41),('10318','2013-05-08','17:25:00',3.6),('10318','2013-05-08','17:30:00',3.84),('10318','2013-05-08','17:35:00',3.84),('10318','2013-05-08','17:40:00',3.88),('10318','2013-05-08','17:45:00',3.81),('10318','2013-05-08','17:50:00',3.83),('10318','2013-05-08','17:55:00',3.56),('10318','2013-05-08','18:00:00',3.13),('10318','2013-05-08','18:05:00',2.84),('10318','2013-05-08','18:10:00',2.74),('10318','2013-05-08','18:15:00',2.52),('10318','2013-05-08','18:20:00',2.3),('10318','2013-05-08','18:25:00',1.94),('10318','2013-05-08','18:30:00',1.52),('10318','2013-05-08','18:35:00',1.31),('10318','2013-05-08','18:40:00',1.09),('10318','2013-05-07','07:10:00',1.43),('10318','2013-05-07','07:20:00',1.67),('10318','2013-05-07','07:25:00',2.39),('10318','2013-05-07','07:30:00',2.68),('10318','2013-05-07','07:35:00',3.02),('10318','2013-05-07','07:40:00',3.24),('10318','2013-05-07','07:45:00',3.34),('10318','2013-05-07','07:50:00',3.57),('10318','2013-05-07','07:55:00',3.8),('10318','2013-05-07','08:00:00',4.05),('10318','2013-05-07','08:05:00',4.25),('10318','2013-05-07','08:10:00',4.46),('10318','2013-05-07','08:15:00',4.64),('10318','2013-05-07','08:20:00',4.84),('10318','2013-05-07','08:25:00',5),('10318','2013-05-07','08:30:00',5.31),('10318','2013-05-07','08:35:00',5.54),('10318','2013-05-07','08:40:00',5.68),('10318','2013-05-07','08:45:00',5.64),('10318','2013-05-07','08:50:00',5.97),('10318','2013-05-07','08:55:00',6.57),('10318','2013-05-07','09:00:00',5.18),('10318','2013-05-07','09:05:00',4.69),('10318','2013-05-07','09:10:00',7.52),('10318','2013-05-07','09:15:00',7.57),('10318','2013-05-07','09:20:00',6.15),('10318','2013-05-07','09:25:00',2.06),('10318','2013-05-07','09:30:00',2.16),('10318','2013-05-07','09:35:00',2.73),('10318','2013-05-07','09:40:00',9.62),('10318','2013-05-07','09:45:00',6.71),('10318','2013-05-07','09:50:00',5.08),('10318','2013-05-07','09:55:00',2.3),('10318','2013-05-07','10:00:00',2.11),('10318','2013-05-07','10:05:00',1.52),('10318','2013-05-07','10:10:00',1.45),('10318','2013-05-07','10:15:00',1.57),('10318','2013-05-07','10:20:00',1.74),('10318','2013-05-07','10:25:00',1.93),('10318','2013-05-07','10:30:00',2.32),('10318','2013-05-07','10:35:00',2.68),('10318','2013-05-07','10:40:00',4),('10318','2013-05-07','10:45:00',10.99),('10318','2013-05-07','10:50:00',5.99),('10318','2013-05-07','10:55:00',3.24),('10318','2013-05-07','11:00:00',2.69),('10318','2013-05-07','11:05:00',2.25),('10318','2013-05-07','11:10:00',2.35),('10318','2013-05-07','11:15:00',2.76),('10318','2013-05-07','11:20:00',3.21),('10318','2013-05-07','11:25:00',1.49),('10318','2013-05-07','11:30:00',1.08),('10318','2013-05-07','11:35:00',1.36),('10318','2013-05-07','11:40:00',1.72),('10318','2013-05-07','11:45:00',6.69),('10318','2013-05-07','11:50:00',10.79),('10318','2013-05-07','11:55:00',10.81),('10318','2013-05-07','12:00:00',10.82),('10318','2013-05-07','12:05:00',10.86),('10318','2013-05-07','12:10:00',9.83),('10318','2013-05-07','12:15:00',3.73),('10318','2013-05-07','12:20:00',3.36),('10318','2013-05-07','12:25:00',3.13),('10318','2013-05-07','12:30:00',2.58),('10318','2013-05-07','12:35:00',2.9),('10318','2013-05-07','12:40:00',3.68),('10318','2013-05-07','12:45:00',3.22),('10318','2013-05-07','12:50:00',2.69),('10318','2013-05-07','12:55:00',2.58),('10318','2013-05-07','13:00:00',2.5),('10318','2013-05-07','13:05:00',3.39),('10318','2013-05-07','13:10:00',3.83),('10318','2013-05-07','13:15:00',3.22),('10318','2013-05-07','13:20:00',3.16),('10318','2013-05-07','13:25:00',6),('10318','2013-05-07','13:30:00',9.3),('10318','2013-05-07','13:35:00',8.92),('10318','2013-05-07','13:40:00',9.72),('10318','2013-05-07','13:45:00',8.9),('10318','2013-05-07','13:50:00',10.22),('10318','2013-05-07','13:55:00',9.09),('10318','2013-05-07','14:00:00',3.22),('10318','2013-05-07','14:05:00',5.6),('10318','2013-05-07','14:10:00',4.92),('10318','2013-05-07','14:15:00',5.04),('10318','2013-05-07','14:20:00',7.28),('10318','2013-05-07','14:25:00',10.35),('10318','2013-05-07','14:30:00',10.26),('10318','2013-05-07','14:35:00',9.95),('10318','2013-05-07','14:40:00',8.74),('10318','2013-05-07','14:45:00',9.31),('10318','2013-05-07','14:50:00',9.26),('10318','2013-05-07','14:55:00',8.13),('10318','2013-05-07','15:00:00',8.88),('10318','2013-05-07','15:05:00',8.57),('10318','2013-05-07','15:10:00',8.31),('10318','2013-05-07','15:15:00',8.41),('10318','2013-05-07','15:20:00',8.03),('10318','2013-05-07','15:25:00',5.58),('10318','2013-05-07','15:30:00',8.04),('10318','2013-05-07','15:35:00',5.62),('10318','2013-05-07','15:40:00',5.27),('10318','2013-05-07','15:45:00',4.21),('10318','2013-05-07','15:50:00',2.87),('10318','2013-05-07','15:55:00',4.66),('10318','2013-05-07','16:00:00',4.98),('10318','2013-05-07','16:05:00',6.39),('10318','2013-05-07','16:10:00',7.36),('10318','2013-05-07','16:15:00',7.66),('10318','2013-05-07','16:20:00',7.11),('10318','2013-05-07','16:25:00',7.41),('10318','2013-05-07','16:30:00',6.99),('10318','2013-05-07','16:35:00',5.23),('10318','2013-05-07','16:40:00',6.75),('10318','2013-05-07','16:45:00',5.96),('10318','2013-05-07','16:50:00',4.13),('10318','2013-05-07','16:55:00',4.35),('10318','2013-05-07','17:00:00',5.46),('10318','2013-05-07','17:05:00',4.06),('10318','2013-05-07','17:10:00',2.27),('10318','2013-05-07','17:15:00',2.31),('10318','2013-05-07','17:20:00',2.35),('10318','2013-05-07','17:25:00',2.55),('10318','2013-05-07','17:30:00',2.46),('10318','2013-05-07','17:35:00',2.24),('10318','2013-05-07','17:40:00',1.94),('10318','2013-05-07','17:45:00',1.7),('10318','2013-05-07','17:50:00',1.3),('10318','2013-05-07','17:55:00',1.11),('10318','2013-05-07','18:00:00',1.1),('10318','2013-05-07','18:05:00',1.01),('10318','2013-05-07','18:20:00',1.02),('10318','2013-05-07','18:25:00',1.07),('10318','2013-05-07','18:30:00',1.08),('10318','2013-05-07','18:35:00',1.21),('10318','2013-05-07','18:40:00',1.3),('10318','2013-05-07','18:45:00',1.44),('10318','2013-05-07','18:50:00',1.13),('10318','2013-05-06','08:10:00',1.25),('10318','2013-05-06','08:15:00',1.94),('10318','2013-05-06','08:20:00',2.5),('10318','2013-05-06','08:25:00',2.84),('10318','2013-05-06','08:30:00',2.52),('10318','2013-05-06','08:35:00',3.12),('10318','2013-05-06','08:40:00',3.93),('10318','2013-05-06','08:45:00',3.47),('10318','2013-05-06','08:50:00',3.53),('10318','2013-05-06','08:55:00',5.09),('10318','2013-05-06','09:00:00',4.6),('10318','2013-05-06','09:05:00',2.94),('10318','2013-05-06','09:10:00',2.73),('10318','2013-05-06','09:15:00',3.82),('10318','2013-05-06','09:20:00',5.86),('10318','2013-05-06','09:25:00',7.21),('10318','2013-05-06','09:30:00',2.57),('10318','2013-05-06','09:40:00',1.07),('10318','2013-05-06','09:45:00',2.14),('10318','2013-05-06','09:50:00',1.98),('10318','2013-05-06','09:55:00',2.37),('10318','2013-05-06','10:00:00',2.37),('10318','2013-05-06','10:05:00',2.15),('10318','2013-05-06','10:10:00',2.33),('10318','2013-05-06','10:15:00',2.98),('10318','2013-05-06','10:20:00',4.23),('10318','2013-05-06','10:25:00',4.91),('10318','2013-05-06','10:30:00',3.9),('10318','2013-05-06','10:35:00',3.93),('10318','2013-05-06','10:40:00',3.38),('10318','2013-05-06','10:45:00',3.32),('10318','2013-05-06','10:50:00',3.74),('10318','2013-05-06','10:55:00',3.98),('10318','2013-05-06','11:00:00',4.64),('10318','2013-05-06','11:05:00',3.58),('10318','2013-05-06','11:10:00',2.97),('10318','2013-05-06','11:15:00',3.1),('10318','2013-05-06','11:20:00',4.74),('10318','2013-05-06','11:25:00',3.16),('10318','2013-05-06','11:30:00',2.96),('10318','2013-05-06','11:35:00',4.57),('10318','2013-05-06','11:40:00',5.06),('10318','2013-05-06','11:45:00',4.95),('10318','2013-05-06','11:50:00',3.63),('10318','2013-05-06','11:55:00',3.39),('10318','2013-05-06','12:00:00',3.66),('10318','2013-05-06','12:05:00',4.64),('10318','2013-05-06','12:10:00',5.36),('10318','2013-05-06','12:15:00',7.23),('10318','2013-05-06','12:20:00',6.12),('10318','2013-05-06','12:25:00',10.82),('10318','2013-05-06','12:30:00',6.77),('10318','2013-05-06','12:35:00',4.25),('10318','2013-05-06','12:40:00',6.43),('10318','2013-05-06','12:45:00',9.32),('10318','2013-05-06','12:50:00',7.03),('10318','2013-05-06','12:55:00',5.9),('10318','2013-05-06','13:00:00',5.49),('10318','2013-05-06','13:05:00',9.08),('10318','2013-05-06','13:10:00',5.38),('10318','2013-05-06','13:15:00',10.21),('10318','2013-05-06','13:20:00',7.12),('10318','2013-05-06','13:25:00',6.85),('10318','2013-05-06','13:30:00',9.98),('10318','2013-05-06','13:35:00',8.56),('10318','2013-05-06','13:40:00',8.4),('10318','2013-05-06','13:45:00',9.43),('10318','2013-05-06','13:50:00',9.85),('10318','2013-05-06','13:55:00',5.74),('10318','2013-05-06','14:00:00',6.83),('10318','2013-05-06','14:05:00',4.9),('10318','2013-05-06','14:10:00',5.26),('10318','2013-05-06','14:15:00',5.11),('10318','2013-05-06','14:20:00',5.04),('10318','2013-05-06','14:25:00',5.54),('10318','2013-05-06','14:30:00',6.53),('10318','2013-05-06','14:35:00',7.74),('10318','2013-05-06','14:40:00',3.7),('10318','2013-05-06','14:45:00',6.42),('10318','2013-05-06','14:50:00',4.95),('10318','2013-05-06','14:55:00',4.69),('10318','2013-05-06','15:00:00',5.55),('10318','2013-05-06','15:05:00',5.98),('10318','2013-05-06','15:10:00',4.16),('10318','2013-05-06','15:15:00',4.19),('10318','2013-05-06','15:20:00',3.24),('10318','2013-05-06','15:25:00',6.66),('10318','2013-05-06','15:30:00',2.92),('10318','2013-05-06','15:35:00',7.23),('10318','2013-05-06','15:40:00',4.38),('10318','2013-05-06','15:45:00',5.77),('10318','2013-05-06','15:50:00',5.63),('10318','2013-05-06','15:55:00',6.84),('10318','2013-05-06','16:00:00',3.54),('10318','2013-05-06','16:05:00',3.01),('10318','2013-05-06','16:10:00',4.02),('10318','2013-05-06','16:15:00',4.89),('10318','2013-05-06','16:20:00',5.45),('10318','2013-05-06','16:25:00',3.61),('10318','2013-05-06','16:30:00',4.79),('10318','2013-05-06','16:35:00',6.14),('10318','2013-05-06','16:40:00',6.43),('10318','2013-05-06','16:45:00',3.65),('10318','2013-05-06','16:50:00',5.86),('10318','2013-05-06','16:55:00',1.47),('10318','2013-05-06','17:10:00',2.89),('10318','2013-05-06','17:15:00',5.31),('10318','2013-05-06','17:20:00',2.28),('10318','2013-05-06','17:25:00',3.58),('10318','2013-05-06','17:30:00',2.65),('10318','2013-05-06','17:35:00',2.99),('10318','2013-05-06','17:40:00',3.66),('10318','2013-05-06','17:45:00',3.56),('10318','2013-05-06','17:50:00',3.21),('10318','2013-05-06','17:55:00',3.15),('10318','2013-05-06','18:00:00',2.71),('10318','2013-05-06','18:05:00',2.4),('10318','2013-05-06','18:10:00',1.18),('10318','2013-05-06','18:15:00',1.44),('10318','2013-05-06','18:20:00',1.74),('10318','2013-05-05','07:10:00',1.17),('10318','2013-05-05','07:15:00',1.33),('10318','2013-05-05','07:20:00',1.58),('10318','2013-05-05','07:25:00',1.9),('10318','2013-05-05','07:30:00',1.93),('10318','2013-05-05','07:35:00',1.76),('10318','2013-05-05','07:40:00',1.37),('10318','2013-05-05','07:45:00',2.86),('10318','2013-05-05','07:50:00',3.12),('10318','2013-05-05','07:55:00',3.17),('10318','2013-05-05','08:00:00',3.46),('10318','2013-05-05','08:05:00',3.74),('10318','2013-05-05','08:10:00',3.99),('10318','2013-05-05','08:15:00',4.31),('10318','2013-05-05','08:20:00',4.8),('10318','2013-05-05','08:25:00',5.07),('10318','2013-05-05','08:30:00',5.58),('10318','2013-05-05','08:35:00',4.05),('10318','2013-05-05','08:40:00',4.38),('10318','2013-05-05','08:45:00',5.55),('10318','2013-05-05','08:50:00',3.11),('10318','2013-05-05','08:55:00',3.17),('10318','2013-05-05','09:00:00',3.37),('10318','2013-05-05','09:05:00',3.29),('10318','2013-05-05','09:10:00',3.73),('10318','2013-05-05','09:15:00',3.16),('10318','2013-05-05','09:20:00',3.02),('10318','2013-05-05','09:25:00',4.36),('10318','2013-05-05','09:30:00',7.36),('10318','2013-05-05','09:35:00',6.98),('10318','2013-05-05','09:40:00',8.27),('10318','2013-05-05','09:45:00',8.04),('10318','2013-05-05','09:50:00',7.8),('10318','2013-05-05','09:55:00',8.71),('10318','2013-05-05','10:00:00',9),('10318','2013-05-05','10:05:00',9.4),('10318','2013-05-05','10:10:00',9.3),('10318','2013-05-05','10:15:00',8.38),('10318','2013-05-05','10:20:00',7.19),('10318','2013-05-05','10:25:00',7.56),('10318','2013-05-05','10:30:00',6.62),('10318','2013-05-05','10:35:00',4.6),('10318','2013-05-05','10:40:00',4.21),('10318','2013-05-05','10:45:00',3.86),('10318','2013-05-05','10:50:00',3.1),('10318','2013-05-05','10:55:00',2.84),('10318','2013-05-05','11:00:00',3.31),('10318','2013-05-05','11:05:00',3.37),('10318','2013-05-05','11:10:00',3.23),('10318','2013-05-05','11:15:00',4.23),('10318','2013-05-05','11:20:00',6.35),('10318','2013-05-05','11:25:00',4.99),('10318','2013-05-05','11:30:00',7.29),('10318','2013-05-05','11:35:00',6.81),('10318','2013-05-05','11:40:00',6.66),('10318','2013-05-05','11:45:00',6.91),('10318','2013-05-05','11:50:00',9.62),('10318','2013-05-05','11:55:00',9.14),('10318','2013-05-05','12:00:00',7.3),('10318','2013-05-05','12:05:00',9.34),('10318','2013-05-05','12:10:00',8.72),('10318','2013-05-05','12:15:00',5.72),('10318','2013-05-05','12:20:00',7.92),('10318','2013-05-05','12:25:00',9.09),('10318','2013-05-05','12:30:00',5.23),('10318','2013-05-05','12:35:00',7.7),('10318','2013-05-05','12:40:00',5.82),('10318','2013-05-05','12:45:00',5.81),('10318','2013-05-05','12:50:00',10.67),('10318','2013-05-05','12:55:00',6.7),('10318','2013-05-05','13:00:00',6.02),('10318','2013-05-05','13:05:00',7.53),('10318','2013-05-05','13:10:00',6.6),('10318','2013-05-05','13:15:00',6.77),('10318','2013-05-05','13:20:00',5.55),('10318','2013-05-05','13:25:00',6.98),('10318','2013-05-05','13:30:00',8.7),('10318','2013-05-05','13:35:00',8.65),('10318','2013-05-05','13:40:00',10.09),('10318','2013-05-05','13:45:00',9.87),('10318','2013-05-05','13:50:00',6.36),('10318','2013-05-05','13:55:00',5.79),('10318','2013-05-05','14:00:00',6.73),('10318','2013-05-05','14:05:00',8.31),('10318','2013-05-05','14:10:00',9.63),('10318','2013-05-05','14:15:00',8.87),('10318','2013-05-05','14:20:00',7.61),('10318','2013-05-05','14:25:00',8.49),('10318','2013-05-05','14:30:00',8.3),('10318','2013-05-05','14:35:00',8.16),('10318','2013-05-05','14:40:00',7.83),('10318','2013-05-05','14:45:00',8.06),('10318','2013-05-05','14:50:00',7.95),('10318','2013-05-05','14:55:00',7.81),('10318','2013-05-05','15:00:00',7.7),('10318','2013-05-05','15:05:00',7.6),('10318','2013-05-05','15:10:00',7.45),('10318','2013-05-05','15:15:00',7.35),('10318','2013-05-05','15:20:00',7.21),('10318','2013-05-05','15:25:00',7.09),('10318','2013-05-05','15:30:00',6.98),('10318','2013-05-05','15:35:00',6.83),('10318','2013-05-05','15:40:00',6.75),('10318','2013-05-05','15:45:00',6.69),('10318','2013-05-05','15:50:00',6.6),('10318','2013-05-05','15:55:00',6.48),('10318','2013-05-05','16:00:00',6.32),('10318','2013-05-05','16:05:00',6.15),('10318','2013-05-05','16:10:00',6),('10318','2013-05-05','16:15:00',5.84),('10318','2013-05-05','16:20:00',5.67),('10318','2013-05-05','16:25:00',5.34),('10318','2013-05-05','16:30:00',5.36),('10318','2013-05-05','16:35:00',5.18),('10318','2013-05-05','16:40:00',5.03),('10318','2013-05-05','16:45:00',4.87),('10318','2013-05-05','16:50:00',4.69),('10318','2013-05-05','16:55:00',4.49),('10318','2013-05-05','17:00:00',4.3),('10318','2013-05-05','17:05:00',4.12),('10318','2013-05-05','17:10:00',3.94),('10318','2013-05-05','17:15:00',3.74),('10318','2013-05-05','17:20:00',3.57),('10318','2013-05-05','17:25:00',3.37),('10318','2013-05-05','17:30:00',3.16),('10318','2013-05-05','17:35:00',2.98),('10318','2013-05-05','17:40:00',2.82),('10318','2013-05-05','17:45:00',2.64),('10318','2013-05-05','17:50:00',2.49),('10318','2013-05-05','17:55:00',2.33),('10318','2013-05-05','18:00:00',2.13),('10318','2013-05-05','18:05:00',1.96),('10318','2013-05-05','18:10:00',1.8),('10318','2013-05-05','18:15:00',1.69),('10318','2013-05-05','18:20:00',1.54),('10318','2013-05-05','18:25:00',1.42),('10318','2013-05-05','18:30:00',1.3),('10318','2013-05-05','18:35:00',1.19),('10318','2013-05-05','18:40:00',1.09),('10318','2013-05-04','07:35:00',2.09),('10318','2013-05-04','07:40:00',2.86),('10318','2013-05-04','07:45:00',2.91),('10318','2013-05-04','07:50:00',2.49),('10318','2013-05-04','07:55:00',3.35),('10318','2013-05-04','08:00:00',3.64),('10318','2013-05-04','08:05:00',3.8),('10318','2013-05-04','08:10:00',4.02),('10318','2013-05-04','08:15:00',4.22),('10318','2013-05-04','08:20:00',4.4),('10318','2013-05-04','08:25:00',4.46),('10318','2013-05-04','08:30:00',4.77),('10318','2013-05-04','08:35:00',4.87),('10318','2013-05-04','08:40:00',5.08),('10318','2013-05-04','08:45:00',5.25),('10318','2013-05-04','08:50:00',5.43),('10318','2013-05-04','08:55:00',5.57),('10318','2013-05-04','09:00:00',5.73),('10318','2013-05-04','09:05:00',5.95),('10318','2013-05-04','09:10:00',6.04),('10318','2013-05-04','09:15:00',6.16),('10318','2013-05-04','09:20:00',6.4),('10318','2013-05-04','09:25:00',6.54),('10318','2013-05-04','09:30:00',6.69),('10318','2013-05-04','09:35:00',6.8),('10318','2013-05-04','09:40:00',7.04),('10318','2013-05-04','09:45:00',7.2),('10318','2013-05-04','09:50:00',7.36),('10318','2013-05-04','09:55:00',7.52),('10318','2013-05-04','10:00:00',7.74),('10318','2013-05-04','10:05:00',7.66),('10318','2013-05-04','10:10:00',7.69),('10318','2013-05-04','10:15:00',7.95),('10318','2013-05-04','10:20:00',8.06),('10318','2013-05-04','10:25:00',8.1),('10318','2013-05-04','10:30:00',8.22),('10318','2013-05-04','10:35:00',8.2),('10318','2013-05-04','10:40:00',8.18),('10318','2013-05-04','10:45:00',7.98),('10318','2013-05-04','10:50:00',7.96),('10318','2013-05-04','10:55:00',8.37),('10318','2013-05-04','11:00:00',8.29),('10318','2013-05-04','11:05:00',8.3),('10318','2013-05-04','11:10:00',7.93),('10318','2013-05-04','11:15:00',7.35),('10318','2013-05-04','11:20:00',7.74),('10318','2013-05-04','11:25:00',8.37),('10318','2013-05-04','11:30:00',7.87),('10318','2013-05-04','11:35:00',7.96),('10318','2013-05-04','11:40:00',7.92),('10318','2013-05-04','11:45:00',7.96),('10318','2013-05-04','11:50:00',8.02),('10318','2013-05-04','11:55:00',8.06),('10318','2013-05-04','12:00:00',8.19),('10318','2013-05-04','12:05:00',8.12),('10318','2013-05-04','12:10:00',8.31),('10318','2013-05-04','12:15:00',8.6),('10318','2013-05-04','12:20:00',8.66),('10318','2013-05-04','12:25:00',8.78),('10318','2013-05-04','12:30:00',8.75),('10318','2013-05-04','12:35:00',8.94),('10318','2013-05-04','12:40:00',8.79),('10318','2013-05-04','12:45:00',8.75),('10318','2013-05-04','12:50:00',8.57),('10318','2013-05-04','12:55:00',8.62),('10318','2013-05-04','13:00:00',8.39),('10318','2013-05-04','13:05:00',7.86),('10318','2013-05-04','13:10:00',8),('10318','2013-05-04','13:15:00',8.72),('10318','2013-05-04','13:20:00',8.97),('10318','2013-05-04','13:25:00',8.64),('10318','2013-05-04','13:30:00',8.46),('10318','2013-05-04','13:35:00',7.91),('10318','2013-05-04','13:40:00',8.27),('10318','2013-05-04','13:45:00',8.13),('10318','2013-05-04','13:50:00',7.32),('10318','2013-05-04','13:55:00',8.11),('10318','2013-05-04','14:00:00',8.05),('10318','2013-05-04','14:05:00',7.8),('10318','2013-05-04','14:10:00',7.59),('10318','2013-05-04','14:15:00',8),('10318','2013-05-04','14:20:00',7.48),('10318','2013-05-04','14:25:00',7.24),('10318','2013-05-04','14:30:00',7.55),('10318','2013-05-04','14:35:00',7.05),('10318','2013-05-04','14:40:00',7.18),('10318','2013-05-04','14:45:00',7.07),('10318','2013-05-04','14:50:00',6.76),('10318','2013-05-04','14:55:00',6.83),('10318','2013-05-04','15:00:00',7),('10318','2013-05-04','15:05:00',6.98),('10318','2013-05-04','15:10:00',6.61),('10318','2013-05-04','15:15:00',6.94),('10318','2013-05-04','15:20:00',6.84),('10318','2013-05-04','15:25:00',6.97),('10318','2013-05-04','15:30:00',6.88),('10318','2013-05-04','15:35:00',6.37),('10318','2013-05-04','15:40:00',6.69),('10318','2013-05-04','15:45:00',6.5),('10318','2013-05-04','15:50:00',6.32),('10318','2013-05-04','15:55:00',6.14),('10318','2013-05-04','16:00:00',5.99),('10318','2013-05-04','16:05:00',5.83),('10318','2013-05-04','16:10:00',5.67),('10318','2013-05-04','16:15:00',5.56),('10318','2013-05-04','16:20:00',5.4),('10318','2013-05-04','16:25:00',5.24),('10318','2013-05-04','16:30:00',5.05),('10318','2013-05-04','16:35:00',4.88),('10318','2013-05-04','16:40:00',4.63),('10318','2013-05-04','16:45:00',4.54),('10318','2013-05-04','16:50:00',4.36),('10318','2013-05-04','16:55:00',4.22),('10318','2013-05-04','17:00:00',4.08),('10318','2013-05-04','17:05:00',3.94),('10318','2013-05-04','17:10:00',3.29),('10318','2013-05-04','17:15:00',3.18),('10318','2013-05-04','17:20:00',3.48),('10318','2013-05-04','17:25:00',3.29),('10318','2013-05-04','17:30:00',3.06),('10318','2013-05-04','17:35:00',2.86),('10318','2013-05-04','17:40:00',2.37),('10318','2013-05-04','17:45:00',2.33),('10318','2013-05-04','17:50:00',2.46),('10318','2013-05-04','17:55:00',2.32),('10318','2013-05-04','18:00:00',2.14),('10318','2013-05-04','18:05:00',1.99),('10318','2013-05-04','18:10:00',1.52),('10318','2013-05-04','18:15:00',1.35),('10318','2013-05-04','18:20:00',1.07),('10318','2013-05-04','18:25:00',1.02),('10318','2013-05-03','07:25:00',1.07),('10318','2013-05-03','07:30:00',1.09),('10318','2013-05-03','07:35:00',1.09),('10318','2013-05-03','07:40:00',1.13),('10318','2013-05-03','07:45:00',1.28),('10318','2013-05-03','07:50:00',1.44),('10318','2013-05-03','07:55:00',1.63),('10318','2013-05-03','08:00:00',2.38),('10318','2013-05-03','08:05:00',3.44),('10318','2013-05-03','08:10:00',3.97),('10318','2013-05-03','08:15:00',4.45),('10318','2013-05-03','08:20:00',4.31),('10318','2013-05-03','08:25:00',4.81),('10318','2013-05-03','08:30:00',4.9),('10318','2013-05-03','08:35:00',4.78),('10318','2013-05-03','08:40:00',4.85),('10318','2013-05-03','08:45:00',4.79),('10318','2013-05-03','08:50:00',5.24),('10318','2013-05-03','08:55:00',5.51),('10318','2013-05-03','09:00:00',5.68),('10318','2013-05-03','09:05:00',6.11),('10318','2013-05-03','09:10:00',6.27),('10318','2013-05-03','09:15:00',6.49),('10318','2013-05-03','09:20:00',6.69),('10318','2013-05-03','09:25:00',6.79),('10318','2013-05-03','09:30:00',6.97),('10318','2013-05-03','09:35:00',7.09),('10318','2013-05-03','09:40:00',7.21),('10318','2013-05-03','09:45:00',7.38),('10318','2013-05-03','09:50:00',7.53),('10318','2013-05-03','09:55:00',7.67),('10318','2013-05-03','10:00:00',7.76),('10318','2013-05-03','10:05:00',7.89),('10318','2013-05-03','10:10:00',8.02),('10318','2013-05-03','10:15:00',8.07),('10318','2013-05-03','10:20:00',8.16),('10318','2013-05-03','10:25:00',8.25),('10318','2013-05-03','10:30:00',8.32),('10318','2013-05-03','10:35:00',8.36),('10318','2013-05-03','10:40:00',8.48),('10318','2013-05-03','10:45:00',8.61),('10318','2013-05-03','10:50:00',8.68),('10318','2013-05-03','10:55:00',8.71),('10318','2013-05-03','11:00:00',8.75),('10318','2013-05-03','11:05:00',8.81),('10318','2013-05-03','11:10:00',8.91),('10318','2013-05-03','11:15:00',8.94),('10318','2013-05-03','11:20:00',8.95),('10318','2013-05-03','11:25:00',9.01),('10318','2013-05-03','11:30:00',9.1),('10318','2013-05-03','11:35:00',9.13),('10318','2013-05-03','11:40:00',9.16),('10318','2013-05-03','11:45:00',9.2),('10318','2013-05-03','11:50:00',9.23),('10318','2013-05-03','11:55:00',9.32),('10318','2013-05-03','12:00:00',9.39),('10318','2013-05-03','12:05:00',9.35),('10318','2013-05-03','12:10:00',9.28),('10318','2013-05-03','12:15:00',9.26),('10318','2013-05-03','12:20:00',9.17),('10318','2013-05-03','12:25:00',9.19),('10318','2013-05-03','12:30:00',9.01),('10318','2013-05-03','12:35:00',9.17),('10318','2013-05-03','12:40:00',9.25),('10318','2013-05-03','12:45:00',8.95),('10318','2013-05-03','12:50:00',9.2),('10318','2013-05-03','12:55:00',9.24),('10318','2013-05-03','13:00:00',9.2),('10318','2013-05-03','13:05:00',9.15),('10318','2013-05-03','13:10:00',9.13),('10318','2013-05-03','13:15:00',9.09),('10318','2013-05-03','13:20:00',9.02),('10318','2013-05-03','13:25:00',9.03),('10318','2013-05-03','13:30:00',9.03),('10318','2013-05-03','13:35:00',8.8),('10318','2013-05-03','13:40:00',8.73),('10318','2013-05-03','13:45:00',8.82),('10318','2013-05-03','13:50:00',8.74),('10318','2013-05-03','13:55:00',8.65),('10318','2013-05-03','14:00:00',8.46),('10318','2013-05-03','14:05:00',8.08),('10318','2013-05-03','14:10:00',8.29),('10318','2013-05-03','14:15:00',8.07),('10318','2013-05-03','14:20:00',8.26),('10318','2013-05-03','14:25:00',8.18),('10318','2013-05-03','14:30:00',8.11),('10318','2013-05-03','14:35:00',8.12),('10318','2013-05-03','14:40:00',8.02),('10318','2013-05-03','14:45:00',7.89),('10318','2013-05-03','14:50:00',7.84),('10318','2013-05-03','14:55:00',7.63),('10318','2013-05-03','15:00:00',7.51),('10318','2013-05-03','15:05:00',7.46),('10318','2013-05-03','15:10:00',7.4),('10318','2013-05-03','15:15:00',7.33),('10318','2013-05-03','15:20:00',7.25),('10318','2013-05-03','15:25:00',7.14),('10318','2013-05-03','15:30:00',7.02),('10318','2013-05-03','15:35:00',6.91),('10318','2013-05-03','15:40:00',6.8),('10318','2013-05-03','15:45:00',6.67),('10318','2013-05-03','15:50:00',6.48),('10318','2013-05-03','15:55:00',6.3),('10318','2013-05-03','16:00:00',6.17),('10318','2013-05-03','16:05:00',5.86),('10318','2013-05-03','16:10:00',5.94),('10318','2013-05-03','16:15:00',5.71),('10318','2013-05-03','16:20:00',5.45),('10318','2013-05-03','16:25:00',5.32),('10318','2013-05-03','16:30:00',5.27),('10318','2013-05-03','16:35:00',5.1),('10318','2013-05-03','16:40:00',4.87),('10318','2013-05-03','16:45:00',4.7),('10318','2013-05-03','16:50:00',4.5),('10318','2013-05-03','16:55:00',4.32),('10318','2013-05-03','17:00:00',4.15),('10318','2013-05-03','17:05:00',3.98),('10318','2013-05-03','17:10:00',3.8),('10318','2013-05-03','17:15:00',3.62),('10318','2013-05-03','17:20:00',3.47),('10318','2013-05-03','17:25:00',3.27),('10318','2013-05-03','17:30:00',3.07),('10318','2013-05-03','17:35:00',2.86),('10318','2013-05-03','17:40:00',2.66),('10318','2013-05-03','17:45:00',2.48),('10318','2013-05-03','17:50:00',2.28),('10318','2013-05-03','17:55:00',2.17),('10318','2013-05-03','18:00:00',2),('10318','2013-05-03','18:05:00',1.88),('10318','2013-05-03','18:10:00',1.75),('10318','2013-05-03','18:15:00',1.61),('10318','2013-05-03','18:20:00',1.49),('10318','2013-05-03','18:25:00',1.37),('10318','2013-05-03','18:30:00',1.23),('10318','2013-05-03','18:35:00',1.14),('10318','2013-05-02','08:30:00',1.1),('10318','2013-05-02','08:35:00',1.69),('10318','2013-05-02','08:40:00',2.06),('10318','2013-05-02','08:45:00',1.84),('10318','2013-05-02','08:50:00',2.11),('10318','2013-05-02','08:55:00',3.3),('10318','2013-05-02','09:00:00',3.55),('10318','2013-05-02','09:05:00',2.11),('10318','2013-05-02','09:10:00',1.82),('10318','2013-05-02','09:15:00',1.99),('10318','2013-05-02','09:20:00',1.88),('10318','2013-05-02','09:25:00',4.87),('10318','2013-05-02','09:30:00',4.3),('10318','2013-05-02','09:35:00',4.01),('10318','2013-05-02','09:40:00',5.39),('10318','2013-05-02','09:45:00',5.92),('10318','2013-05-02','09:50:00',3.49),('10318','2013-05-02','09:55:00',2.69),('10318','2013-05-02','10:00:00',2.25),('10318','2013-05-02','10:05:00',3.38),('10318','2013-05-02','10:10:00',2.87),('10318','2013-05-02','10:15:00',4.68),('10318','2013-05-02','10:20:00',3.85),('10318','2013-05-02','10:25:00',4.2),('10318','2013-05-02','10:30:00',6.27),('10318','2013-05-02','10:35:00',8.65),('10318','2013-05-02','10:40:00',7.42),('10318','2013-05-02','10:45:00',8.14),('10318','2013-05-02','10:50:00',7.39),('10318','2013-05-02','10:55:00',8.71),('10318','2013-05-02','11:00:00',6.85),('10318','2013-05-02','11:05:00',7.98),('10318','2013-05-02','11:10:00',8.17),('10318','2013-05-02','11:15:00',5.34),('10318','2013-05-02','11:20:00',8.63),('10318','2013-05-02','11:25:00',7.94),('10318','2013-05-02','11:30:00',8.24),('10318','2013-05-02','11:35:00',9.24),('10318','2013-05-02','11:40:00',9.16),('10318','2013-05-02','11:45:00',9.18),('10318','2013-05-02','11:50:00',9.16),('10318','2013-05-02','11:55:00',9.12),('10318','2013-05-02','12:00:00',9.16),('10318','2013-05-02','12:05:00',9.14),('10318','2013-05-02','12:10:00',9.02),('10318','2013-05-02','12:15:00',9),('10318','2013-05-02','12:20:00',9),('10318','2013-05-02','12:25:00',9.1),('10318','2013-05-02','12:30:00',9.1),('10318','2013-05-02','12:35:00',9.06),('10318','2013-05-02','12:40:00',9.15),('10318','2013-05-02','12:45:00',9.36),('10318','2013-05-02','12:50:00',9.47),('10318','2013-05-02','12:55:00',9.45),('10318','2013-05-02','13:00:00',9.41),('10318','2013-05-02','13:05:00',9.36),('10318','2013-05-02','13:10:00',9.36),('10318','2013-05-02','13:15:00',9.33),('10318','2013-05-02','13:20:00',9.38),('10318','2013-05-02','13:25:00',9.25),('10318','2013-05-02','13:30:00',9.26),('10318','2013-05-02','13:35:00',9.21),('10318','2013-05-02','13:40:00',9.13),('10318','2013-05-02','13:45:00',9.12),('10318','2013-05-02','13:50:00',9.1),('10318','2013-05-02','13:55:00',9.09),('10318','2013-05-02','14:00:00',8.91),('10318','2013-05-02','14:05:00',8.71),('10318','2013-05-02','14:10:00',8.57),('10318','2013-05-02','14:15:00',8.54),('10318','2013-05-02','14:20:00',8.44),('10318','2013-05-02','14:25:00',8.35),('10318','2013-05-02','14:30:00',8.26),('10318','2013-05-02','14:35:00',8.11),('10318','2013-05-02','14:40:00',8.12),('10318','2013-05-02','14:45:00',7.98),('10318','2013-05-02','14:50:00',7.8),('10318','2013-05-02','14:55:00',7.69),('10318','2013-05-02','15:00:00',7.63),('10318','2013-05-02','15:05:00',7.53),('10318','2013-05-02','15:10:00',7.46),('10318','2013-05-02','15:15:00',7.36),('10318','2013-05-02','15:20:00',7.28),('10318','2013-05-02','15:25:00',7.17),('10318','2013-05-02','15:30:00',7.08),('10318','2013-05-02','15:35:00',6.93),('10318','2013-05-02','15:40:00',6.87),('10318','2013-05-02','15:45:00',6.71),('10318','2013-05-02','15:50:00',6.56),('10318','2013-05-02','15:55:00',6.47),('10318','2013-05-02','16:00:00',6.29),('10318','2013-05-02','16:05:00',6.12),('10318','2013-05-02','16:10:00',5.97),('10318','2013-05-02','16:15:00',5.84),('10318','2013-05-02','16:20:00',5.53),('10318','2013-05-02','16:25:00',5.48),('10318','2013-05-02','16:30:00',5.29),('10318','2013-05-02','16:35:00',5.15),('10318','2013-05-02','16:40:00',4.96),('10318','2013-05-02','16:45:00',4.8),('10318','2013-05-02','16:50:00',4.59),('10318','2013-05-02','16:55:00',4.4),('10318','2013-05-02','17:00:00',4.24),('10318','2013-05-02','17:05:00',4.07),('10318','2013-05-02','17:10:00',3.9),('10318','2013-05-02','17:15:00',3.72),('10318','2013-05-02','17:20:00',3.54),('10318','2013-05-02','17:25:00',3.35),('10318','2013-05-02','17:30:00',3.17),('10318','2013-05-02','17:35:00',2.98),('10318','2013-05-02','17:40:00',2.81),('10318','2013-05-02','17:45:00',2.63),('10318','2013-05-02','17:50:00',2.46),('10318','2013-05-02','17:55:00',2.31),('10318','2013-05-02','18:00:00',2.13),('10318','2013-05-02','18:05:00',1.93),('10318','2013-05-02','18:10:00',1.8),('10318','2013-05-02','18:15:00',1.66),('10318','2013-05-02','18:20:00',1.53),('10318','2013-05-02','18:25:00',1.4),('10318','2013-05-02','18:30:00',1.28),('10318','2013-05-02','18:35:00',1.13),('10318','2013-05-02','18:40:00',1.02),('10318','2014-03-30','07:45:00',1.17),('10318','2014-03-30','07:50:00',1.32),('10318','2014-03-30','07:55:00',1.63),('10318','2014-03-30','08:00:00',1.8),('10318','2014-03-30','08:05:00',1.9),('10318','2014-03-30','08:10:00',2.24),('10318','2014-03-30','08:15:00',2.68),('10318','2014-03-30','08:20:00',2.98),('10318','2014-03-30','08:25:00',3.39),('10318','2014-03-30','08:30:00',3.68),('10318','2014-03-30','08:35:00',3.61),('10318','2014-03-30','08:40:00',3.63),('10318','2014-03-30','08:45:00',3.64),('10318','2014-03-30','08:50:00',3.64),('10318','2014-03-30','08:55:00',3.68),('10318','2014-03-30','09:00:00',3.67),('10318','2014-03-30','09:05:00',3.76),('10318','2014-03-30','09:10:00',3.67),('10318','2014-03-30','09:15:00',4.16),('10318','2014-03-30','09:20:00',4.41),('10318','2014-03-30','09:25:00',4.61),('10318','2014-03-30','09:30:00',5.25),('10318','2014-03-30','09:35:00',5.49),('10318','2014-03-30','09:40:00',5.87),('10318','2014-03-30','09:45:00',6.27),('10318','2014-03-30','09:50:00',6.37),('10318','2014-03-30','09:55:00',6.25),('10318','2014-03-30','10:00:00',6.61),('10318','2014-03-30','10:05:00',6.83),('10318','2014-03-30','10:10:00',6.66),('10318','2014-03-30','10:15:00',6.38),('10318','2014-03-30','10:20:00',7.33),('10318','2014-03-30','10:25:00',7.74),('10318','2014-03-30','10:30:00',7.73),('10318','2014-03-30','10:35:00',7.64),('10318','2014-03-30','10:40:00',7.66),('10318','2014-03-30','10:45:00',7.7),('10318','2014-03-30','10:50:00',7.92),('10318','2014-03-30','10:55:00',7.81),('10318','2014-03-30','11:00:00',7.69),('10318','2014-03-30','11:05:00',7.84),('10318','2014-03-30','11:10:00',7.87),('10318','2014-03-30','11:15:00',7.64),('10318','2014-03-30','11:20:00',7.61),('10318','2014-03-30','11:25:00',7.86),('10318','2014-03-30','11:30:00',8.02),('10318','2014-03-30','11:35:00',8.46),('10318','2014-03-30','11:40:00',8.76),('10318','2014-03-30','11:45:00',8.85),('10318','2014-03-30','11:50:00',9.04),('10318','2014-03-30','11:55:00',8.89),('10318','2014-03-30','12:00:00',9.19),('10318','2014-03-30','12:05:00',9.29),('10318','2014-03-30','12:10:00',9.39),('10318','2014-03-30','12:15:00',9.69),('10318','2014-03-30','12:20:00',9.08),('10318','2014-03-30','12:25:00',9.17),('10318','2014-03-30','12:30:00',9.11),('10318','2014-03-30','12:35:00',9.15),('10318','2014-03-30','12:40:00',9.04),('10318','2014-03-30','12:45:00',9.25),('10318','2014-03-30','12:50:00',8.96),('10318','2014-03-30','12:55:00',9.3),('10318','2014-03-30','13:00:00',9.47),('10318','2014-03-30','13:05:00',9.37),('10318','2014-03-30','13:10:00',9.31),('10318','2014-03-30','13:15:00',9.23),('10318','2014-03-30','13:20:00',9.33),('10318','2014-03-30','13:25:00',9.32),('10318','2014-03-30','13:30:00',9.34),('10318','2014-03-30','13:35:00',9.25),('10318','2014-03-30','13:40:00',9.2),('10318','2014-03-30','13:45:00',9.15),('10318','2014-03-30','13:50:00',8.98),('10318','2014-03-30','13:55:00',8.98),('10318','2014-03-30','14:00:00',8.91),('10318','2014-03-30','14:05:00',8.81),('10318','2014-03-30','14:10:00',8.26),('10318','2014-03-30','14:15:00',7.75),('10318','2014-03-30','14:20:00',7.44),('10318','2014-03-30','14:25:00',6.49),('10318','2014-03-30','14:30:00',5.62),('10318','2014-03-30','14:35:00',4.72),('10318','2014-03-30','14:40:00',5.18),('10318','2014-03-30','14:45:00',5.55),('10318','2014-03-30','14:50:00',3.96),('10318','2014-03-30','14:55:00',3.99),('10318','2014-03-30','15:00:00',5.87),('10318','2014-03-30','15:05:00',6.45),('10318','2014-03-30','15:10:00',6.73),('10318','2014-03-30','15:15:00',6.72),('10318','2014-03-30','15:20:00',6.61),('10318','2014-03-30','15:25:00',6.58),('10318','2014-03-30','15:30:00',6.5),('10318','2014-03-30','15:35:00',6.69),('10318','2014-03-30','15:40:00',6.65),('10318','2014-03-30','15:45:00',6.44),('10318','2014-03-30','15:50:00',6.28),('10318','2014-03-30','15:55:00',5.74),('10318','2014-03-30','16:00:00',5.17),('10318','2014-03-30','16:05:00',5.2),('10318','2014-03-30','16:10:00',5.34),('10318','2014-03-30','16:15:00',5.16),('10318','2014-03-30','16:20:00',4.57),('10318','2014-03-30','16:25:00',4.49),('10318','2014-03-30','16:30:00',4.7),('10318','2014-03-30','16:35:00',4.3),('10318','2014-03-30','16:40:00',4.35),('10318','2014-03-30','16:45:00',4.39),('10318','2014-03-30','16:50:00',4.37),('10318','2014-03-30','16:55:00',4.24),('10318','2014-03-30','17:00:00',4.1),('10318','2014-03-30','17:05:00',3.81),('10318','2014-03-30','17:10:00',3.86),('10318','2014-03-30','17:15:00',3.58),('10318','2014-03-30','17:20:00',3.47),('10318','2014-03-30','17:25:00',3.11),('10318','2014-03-30','17:30:00',2.82),('10318','2014-03-30','17:35:00',2.54),('10318','2014-03-30','17:40:00',2.46),('10318','2014-03-30','17:45:00',2.38),('10318','2014-03-30','17:50:00',2.21),('10318','2014-03-30','17:55:00',1.67),('10318','2014-03-30','18:00:00',1.56),('10318','2014-03-30','18:05:00',1.17),('10318','2014-03-30','18:10:00',1.2),('10318','2014-03-30','18:15:00',1.33),('10318','2013-05-01','07:10:00',1.04),('10318','2013-05-01','07:15:00',1.17),('10318','2013-05-01','07:20:00',1.26),('10318','2013-05-01','07:25:00',1.41),('10318','2013-05-01','07:30:00',1.62),('10318','2013-05-01','07:35:00',1.89),('10318','2013-05-01','07:40:00',2.15),('10318','2013-05-01','07:45:00',2.38),('10318','2013-05-01','07:50:00',2.59),('10318','2013-05-01','07:55:00',2.82),('10318','2013-05-01','08:00:00',3.01),('10318','2013-05-01','08:05:00',3.15),('10318','2013-05-01','08:10:00',3.35),('10318','2013-05-01','08:15:00',3.63),('10318','2013-05-01','08:20:00',3.85),('10318','2013-05-01','08:25:00',4.09),('10318','2013-05-01','08:30:00',4.32),('10318','2013-05-01','08:35:00',4.43),('10318','2013-05-01','08:40:00',4.71),('10318','2013-05-01','08:45:00',4.9),('10318','2013-05-01','08:50:00',5.13),('10318','2013-05-01','08:55:00',5.33),('10318','2013-05-01','09:00:00',5.48),('10318','2013-05-01','09:05:00',5.63),('10318','2013-05-01','09:10:00',5.76),('10318','2013-05-01','09:15:00',5.86),('10318','2013-05-01','09:20:00',6.01),('10318','2013-05-01','09:25:00',6.08),('10318','2013-05-01','09:30:00',6.13),('10318','2013-05-01','09:35:00',6.35),('10318','2013-05-01','09:40:00',6.48),('10318','2013-05-01','09:45:00',6.7),('10318','2013-05-01','09:50:00',6.76),('10318','2013-05-01','09:55:00',6.91),('10318','2013-05-01','10:00:00',6.93),('10318','2013-05-01','10:05:00',7.01),('10318','2013-05-01','10:10:00',7.29),('10318','2013-05-01','10:15:00',7.38),('10318','2013-05-01','10:20:00',7.45),('10318','2013-05-01','10:25:00',7.64),('10318','2013-05-01','10:30:00',7.67),('10318','2013-05-01','10:35:00',8.03),('10318','2013-05-01','10:40:00',8.16),('10318','2013-05-01','10:45:00',8.29),('10318','2013-05-01','10:50:00',8.27),('10318','2013-05-01','10:55:00',8.36),('10318','2013-05-01','11:00:00',8.47),('10318','2013-05-01','11:05:00',8.5),('10318','2013-05-01','11:10:00',8.29),('10318','2013-05-01','11:15:00',8.31),('10318','2013-05-01','11:20:00',8.52),('10318','2013-05-01','11:25:00',7.83),('10318','2013-05-01','11:30:00',8.32),('10318','2013-05-01','11:35:00',6.47),('10318','2013-05-01','11:40:00',5.38),('10318','2013-05-01','11:45:00',5.6),('10318','2013-05-01','11:50:00',8.99),('10318','2013-05-01','11:55:00',8.98),('10318','2013-05-01','12:00:00',8.76),('10318','2013-05-01','12:05:00',8.65),('10318','2013-05-01','12:10:00',8.61),('10318','2013-05-01','12:15:00',8.55),('10318','2013-05-01','12:20:00',8.62),('10318','2013-05-01','12:25:00',8.69),('10318','2013-05-01','12:30:00',8.82),('10318','2013-05-01','12:35:00',8.93),('10318','2013-05-01','12:40:00',9.16),('10318','2013-05-01','12:45:00',6.85),('10318','2013-05-01','12:50:00',6.49),('10318','2013-05-01','12:55:00',3.24),('10318','2013-05-01','13:00:00',3.33),('10318','2013-05-01','13:05:00',5.46),('10318','2013-05-01','13:10:00',7.25),('10318','2013-05-01','13:15:00',9.26),('10318','2013-05-01','13:20:00',10.04),('10318','2013-05-01','13:25:00',7.89),('10318','2013-05-01','13:30:00',5.16),('10318','2013-05-01','13:35:00',7.48),('10318','2013-05-01','13:40:00',9.22),('10318','2013-05-01','13:45:00',9.24),('10318','2013-05-01','13:50:00',8.82),('10318','2013-05-01','13:55:00',8.45),('10318','2013-05-01','14:00:00',8.4),('10318','2013-05-01','14:05:00',8.34),('10318','2013-05-01','14:10:00',7.94),('10318','2013-05-01','14:15:00',7.69),('10318','2013-05-01','14:20:00',8.63),('10318','2013-05-01','14:25:00',8.41),('10318','2013-05-01','14:30:00',8.6),('10318','2013-05-01','14:35:00',7.94),('10318','2013-05-01','14:40:00',8.16),('10318','2013-05-01','14:45:00',7.24),('10318','2013-05-01','14:50:00',7.55),('10318','2013-05-01','14:55:00',5.56),('10318','2013-05-01','15:00:00',5.95),('10318','2013-05-01','15:05:00',7.11),('10318','2013-05-01','15:10:00',7.51),('10318','2013-05-01','15:15:00',7.08),('10318','2013-05-01','15:20:00',7.16),('10318','2013-05-01','15:25:00',5.83),('10318','2013-05-01','15:30:00',5.08),('10318','2013-05-01','15:35:00',4.59),('10318','2013-05-01','15:40:00',4.73),('10318','2013-05-01','15:45:00',4.59),('10318','2013-05-01','15:50:00',3.71),('10318','2013-05-01','15:55:00',3.67),('10318','2013-05-01','16:00:00',4.18),('10318','2013-05-01','16:05:00',3.86),('10318','2013-05-01','16:10:00',3.55),('10318','2013-05-01','16:15:00',3.37),('10318','2013-05-01','16:20:00',3.08),('10318','2013-05-01','16:25:00',2.48),('10318','2013-05-01','16:30:00',2.3),('10318','2013-05-01','16:35:00',2.36),('10318','2013-05-01','16:40:00',2.53),('10318','2013-05-01','16:45:00',2.34),('10318','2013-05-01','16:50:00',2.02),('10318','2013-05-01','16:55:00',1.94),('10318','2013-05-01','17:00:00',1.96),('10318','2013-05-01','17:05:00',1.99),('10318','2013-05-01','17:10:00',2.01),('10318','2013-05-01','17:15:00',1.95),('10318','2013-05-01','17:20:00',1.74),('10318','2013-05-01','17:25:00',1.49),('10318','2013-05-01','17:30:00',1.28),('10318','2013-05-01','17:35:00',1.15),('10318','2013-05-01','17:40:00',1.07),('10318','2013-04-30','08:20:00',1.19),('10318','2013-04-30','08:25:00',1.38),('10318','2013-04-30','08:30:00',1.74),('10318','2013-04-30','08:35:00',2.28),('10318','2013-04-30','08:40:00',1.98),('10318','2013-04-30','08:45:00',2.16),('10318','2013-04-30','08:50:00',2.86),('10318','2013-04-30','08:55:00',5.63),('10318','2013-04-30','09:00:00',5.08),('10318','2013-04-30','09:05:00',3.7),('10318','2013-04-30','09:10:00',4.74),('10318','2013-04-30','09:15:00',6.47),('10318','2013-04-30','09:20:00',6.35),('10318','2013-04-30','09:25:00',6.88),('10318','2013-04-30','09:30:00',6.79),('10318','2013-04-30','09:35:00',5.99),('10318','2013-04-30','09:40:00',4.31),('10318','2013-04-30','09:45:00',5.26),('10318','2013-04-30','09:50:00',6.51),('10318','2013-04-30','09:55:00',7.4),('10318','2013-04-30','10:00:00',8.05),('10318','2013-04-30','10:05:00',6.78),('10318','2013-04-30','10:10:00',5.89),('10318','2013-04-30','10:15:00',5.09),('10318','2013-04-30','10:20:00',4.24),('10318','2013-04-30','10:25:00',6.77),('10318','2013-04-30','10:30:00',5.58),('10318','2013-04-30','10:35:00',4.27),('10318','2013-04-30','10:40:00',4.19),('10318','2013-04-30','10:45:00',3.1),('10318','2013-04-30','10:50:00',3.17),('10318','2013-04-30','10:55:00',3.64),('10318','2013-04-30','11:00:00',4.07),('10318','2013-04-30','11:05:00',4.48),('10318','2013-04-30','11:10:00',4.48),('10318','2013-04-30','11:15:00',4.89),('10318','2013-04-30','11:20:00',5.44),('10318','2013-04-30','11:25:00',5.02),('10318','2013-04-30','11:30:00',5.17),('10318','2013-04-30','11:35:00',5.44),('10318','2013-04-30','11:40:00',4.47),('10318','2013-04-30','11:45:00',3.47),('10318','2013-04-30','11:50:00',3.56),('10318','2013-04-30','11:55:00',3.73),('10318','2013-04-30','12:00:00',3.98),('10318','2013-04-30','12:05:00',3.98),('10318','2013-04-30','12:10:00',3.75),('10318','2013-04-30','12:15:00',3.52),('10318','2013-04-30','12:20:00',3.4),('10318','2013-04-30','12:25:00',3.2),('10318','2013-04-30','12:30:00',3.32),('10318','2013-04-30','12:35:00',6.37),('10318','2013-04-30','12:40:00',10.2),('10318','2013-04-30','12:45:00',9.72),('10318','2013-04-30','12:50:00',9.61),('10318','2013-04-30','12:55:00',8.38),('10318','2013-04-30','13:00:00',9.23),('10318','2013-04-30','13:05:00',8.99),('10318','2013-04-30','13:10:00',9.11),('10318','2013-04-30','13:15:00',8.98),('10318','2013-04-30','13:20:00',8.89),('10318','2013-04-30','13:25:00',8.82),('10318','2013-04-30','13:30:00',8.6),('10318','2013-04-30','13:35:00',8.66),('10318','2013-04-30','13:40:00',8.57),('10318','2013-04-30','13:45:00',8.48),('10318','2013-04-30','13:50:00',8.35),('10318','2013-04-30','13:55:00',8.29),('10318','2013-04-30','14:00:00',8.19),('10318','2013-04-30','14:05:00',8.14),('10318','2013-04-30','14:10:00',8.04),('10318','2013-04-30','14:15:00',7.96),('10318','2013-04-30','14:20:00',7.86),('10318','2013-04-30','14:25:00',7.76),('10318','2013-04-30','14:30:00',7.66),('10318','2013-04-30','14:35:00',7.6),('10318','2013-04-30','14:40:00',7.56),('10318','2013-04-30','14:45:00',7.5),('10318','2013-04-30','14:50:00',7.35),('10318','2013-04-30','14:55:00',7.23),('10318','2013-04-30','15:00:00',7.11),('10318','2013-04-30','15:05:00',6.99),('10318','2013-04-30','15:10:00',6.87),('10318','2013-04-30','15:15:00',6.65),('10318','2013-04-30','15:20:00',6.64),('10318','2013-04-30','15:25:00',6.53),('10318','2013-04-30','15:30:00',6.43),('10318','2013-04-30','15:35:00',6.31),('10318','2013-04-30','15:40:00',6.19),('10318','2013-04-30','15:45:00',6.01),('10318','2013-04-30','15:50:00',5.84),('10318','2013-04-30','15:55:00',5.73),('10318','2013-04-30','16:00:00',5.64),('10318','2013-04-30','16:05:00',5.5),('10318','2013-04-30','16:10:00',5.35),('10318','2013-04-30','16:15:00',5.18),('10318','2013-04-30','16:20:00',5.04),('10318','2013-04-30','16:25:00',4.93),('10318','2013-04-30','16:30:00',4.41),('10318','2013-04-30','16:35:00',4.51),('10318','2013-04-30','16:40:00',4.39),('10318','2013-04-30','16:45:00',3.47),('10318','2013-04-30','16:50:00',2.62),('10318','2013-04-30','16:55:00',3.32),('10318','2013-04-30','17:00:00',3.45),('10318','2013-04-30','17:05:00',2.89),('10318','2013-04-30','17:10:00',2.35),('10318','2013-04-30','17:15:00',2),('10318','2013-04-30','17:20:00',2.89),('10318','2013-04-30','17:25:00',2.93),('10318','2013-04-30','17:30:00',2.73),('10318','2013-04-30','17:35:00',2.62),('10318','2013-04-30','17:40:00',2.49),('10318','2013-04-30','17:45:00',2.34),('10318','2013-04-30','17:50:00',2.19),('10318','2013-04-30','17:55:00',2.05),('10318','2013-04-30','18:00:00',1.91),('10318','2013-04-30','18:05:00',1.78),('10318','2013-04-30','18:10:00',1.65),('10318','2013-04-30','18:15:00',1.51),('10318','2013-04-30','18:20:00',1.43),('10318','2013-04-30','18:25:00',1.32),('10318','2013-04-30','18:30:00',1.21),('10318','2013-04-30','18:35:00',1.1),('10318','2013-04-29','07:10:00',1.09),('10318','2013-04-29','07:15:00',1.44),('10318','2013-04-29','07:20:00',1.73),('10318','2013-04-29','07:25:00',2.01),('10318','2013-04-29','07:30:00',2.04),('10318','2013-04-29','07:35:00',2.11),('10318','2013-04-29','07:40:00',1.94),('10318','2013-04-29','07:45:00',2.16),('10318','2013-04-29','07:50:00',2.48),('10318','2013-04-29','07:55:00',2.92),('10318','2013-04-29','08:00:00',3.31),('10318','2013-04-29','08:05:00',3.39),('10318','2013-04-29','08:10:00',3.13),('10318','2013-04-29','08:15:00',3.38),('10318','2013-04-29','08:20:00',3.74),('10318','2013-04-29','08:25:00',4.39),('10318','2013-04-29','08:30:00',4.94),('10318','2013-04-29','08:35:00',5.39),('10318','2013-04-29','08:40:00',5.21),('10318','2013-04-29','08:45:00',5.24),('10318','2013-04-29','08:50:00',5.05),('10318','2013-04-29','08:55:00',5.49),('10318','2013-04-29','09:00:00',4.68),('10318','2013-04-29','09:05:00',5.92),('10318','2013-04-29','09:10:00',6.4),('10318','2013-04-29','09:15:00',6.3),('10318','2013-04-29','09:20:00',6),('10318','2013-04-29','09:25:00',6.2),('10318','2013-04-29','09:30:00',6.2),('10318','2013-04-29','09:35:00',6.39),('10318','2013-04-29','09:40:00',6.4),('10318','2013-04-29','09:45:00',6.48),('10318','2013-04-29','09:50:00',6.69),('10318','2013-04-29','09:55:00',6.36),('10318','2013-04-29','10:00:00',6.84),('10318','2013-04-29','10:05:00',6.82),('10318','2013-04-29','10:10:00',6.51),('10318','2013-04-29','10:15:00',5.43),('10318','2013-04-29','10:20:00',6.68),('10318','2013-04-29','10:25:00',7.24),('10318','2013-04-29','10:30:00',7.76),('10318','2013-04-29','10:35:00',7.72),('10318','2013-04-29','10:40:00',7.67),('10318','2013-04-29','10:45:00',7.43),('10318','2013-04-29','10:50:00',7.44),('10318','2013-04-29','10:55:00',7.13),('10318','2013-04-29','11:00:00',7.61),('10318','2013-04-29','11:05:00',7.02),('10318','2013-04-29','11:10:00',6.61),('10318','2013-04-29','11:15:00',7.61),('10318','2013-04-29','11:20:00',8.48),('10318','2013-04-29','11:25:00',7.92),('10318','2013-04-29','11:30:00',8.26),('10318','2013-04-29','11:35:00',8.65),('10318','2013-04-29','11:40:00',8.98),('10318','2013-04-29','11:45:00',8.33),('10318','2013-04-29','11:50:00',8.88),('10318','2013-04-29','11:55:00',8.86),('10318','2013-04-29','12:00:00',9.17),('10318','2013-04-29','12:05:00',8.86),('10318','2013-04-29','12:10:00',8.76),('10318','2013-04-29','12:15:00',8.74),('10318','2013-04-29','12:20:00',8.78),('10318','2013-04-29','12:25:00',8.87),('10318','2013-04-29','12:30:00',8.97),('10318','2013-04-29','12:35:00',8.88),('10318','2013-04-29','12:40:00',8.85),('10318','2013-04-29','12:45:00',8.93),('10318','2013-04-29','12:50:00',8.74),('10318','2013-04-29','12:55:00',8.77),('10318','2013-04-29','13:00:00',8.81),('10318','2013-04-29','13:05:00',8.61),('10318','2013-04-29','13:10:00',8.46),('10318','2013-04-29','13:15:00',8.06),('10318','2013-04-29','13:20:00',8.81),('10318','2013-04-29','13:25:00',9.12),('10318','2013-04-29','13:30:00',8.77),('10318','2013-04-29','13:35:00',8.78),('10318','2013-04-29','13:40:00',8.49),('10318','2013-04-29','13:45:00',8.39),('10318','2013-04-29','13:50:00',8.09),('10318','2013-04-29','13:55:00',8.64),('10318','2013-04-29','14:00:00',8.08),('10318','2013-04-29','14:05:00',7.97),('10318','2013-04-29','14:10:00',8.5),('10318','2013-04-29','14:15:00',8.72),('10318','2013-04-29','14:20:00',8.51),('10318','2013-04-29','14:25:00',7.83),('10318','2013-04-29','14:30:00',7.78),('10318','2013-04-29','14:35:00',7.84),('10318','2013-04-29','14:40:00',7.28),('10318','2013-04-29','14:45:00',7.69),('10318','2013-04-29','14:50:00',7.93),('10318','2013-04-29','14:55:00',7.51),('10318','2013-04-29','15:00:00',7.13),('10318','2013-04-29','15:05:00',6.54),('10318','2013-04-29','15:10:00',6.71),('10318','2013-04-29','15:15:00',6.87),('10318','2013-04-29','15:20:00',7.03),('10318','2013-04-29','15:25:00',7.06),('10318','2013-04-29','15:30:00',6.49),('10318','2013-04-29','15:35:00',5.96),('10318','2013-04-29','15:40:00',5.57),('10318','2013-04-29','15:45:00',5.44),('10318','2013-04-29','15:50:00',5.6),('10318','2013-04-29','15:55:00',5.68),('10318','2013-04-29','16:00:00',5.84),('10318','2013-04-29','16:05:00',6.19),('10318','2013-04-29','16:10:00',5.96),('10318','2013-04-29','16:15:00',6.79),('10318','2013-04-29','16:20:00',5.67),('10318','2013-04-29','16:25:00',5.08),('10318','2013-04-29','16:30:00',5.03),('10318','2013-04-29','16:35:00',5.27),('10318','2013-04-29','16:40:00',5.15),('10318','2013-04-29','16:45:00',5.26),('10318','2013-04-29','16:50:00',5.32),('10318','2013-04-29','16:55:00',5.25),('10318','2013-04-29','17:00:00',4.87),('10318','2013-04-29','17:05:00',4.37),('10318','2013-04-29','17:10:00',4.18),('10318','2013-04-29','17:15:00',3.48),('10318','2013-04-29','17:20:00',3.09),('10318','2013-04-29','17:25:00',2.25),('10318','2013-04-29','17:30:00',2.74),('10318','2013-04-29','17:35:00',2.76),('10318','2013-04-29','17:40:00',2.45),('10318','2013-04-29','17:45:00',1.98),('10318','2013-04-29','17:50:00',2.55),('10318','2013-04-29','17:55:00',2.75),('10318','2013-04-29','18:00:00',2.56),('10318','2013-04-29','18:05:00',2.79),('10318','2013-04-29','18:10:00',2.41),('10318','2013-04-29','18:15:00',2.18),('10318','2013-04-29','18:20:00',1.84),('10318','2013-04-29','18:25:00',1.78),('10318','2013-04-29','18:30:00',1.5),('10318','2013-04-29','18:35:00',1.19),('10318','2013-04-28','07:20:00',1.48),('10318','2013-04-28','07:25:00',1.73),('10318','2013-04-28','07:30:00',2.08),('10318','2013-04-28','07:35:00',2.34),('10318','2013-04-28','07:40:00',2.68),('10318','2013-04-28','07:45:00',2.99),('10318','2013-04-28','07:50:00',3.14),('10318','2013-04-28','07:55:00',3.35),('10318','2013-04-28','08:00:00',3.53),('10318','2013-04-28','08:05:00',3.81),('10318','2013-04-28','08:10:00',4.04),('10318','2013-04-28','08:15:00',4.25),('10318','2013-04-28','08:20:00',4.48),('10318','2013-04-28','08:25:00',4.73),('10318','2013-04-28','08:30:00',4.88),('10318','2013-04-28','08:35:00',5.09),('10318','2013-04-28','08:40:00',5.28),('10318','2013-04-28','08:45:00',5.47),('10318','2013-04-28','08:50:00',5.62),('10318','2013-04-28','08:55:00',5.78),('10318','2013-04-28','09:00:00',5.97),('10318','2013-04-28','09:05:00',6.14),('10318','2013-04-28','09:10:00',6.32),('10318','2013-04-28','09:15:00',6.48),('10318','2013-04-28','09:20:00',6.66),('10318','2013-04-28','09:25:00',6.82),('10318','2013-04-28','09:30:00',6.94),('10318','2013-04-28','09:35:00',7.06),('10318','2013-04-28','09:40:00',7.25),('10318','2013-04-28','09:45:00',7.38),('10318','2013-04-28','09:50:00',7.51),('10318','2013-04-28','09:55:00',7.66),('10318','2013-04-28','10:00:00',7.73),('10318','2013-04-28','10:05:00',7.79),('10318','2013-04-28','10:10:00',7.97),('10318','2013-04-28','10:15:00',8),('10318','2013-04-28','10:20:00',8.2),('10318','2013-04-28','10:25:00',8.22),('10318','2013-04-28','10:30:00',7.68),('10318','2013-04-28','10:35:00',8.3),('10318','2013-04-28','10:40:00',7.69),('10318','2013-04-28','10:45:00',8.64),('10318','2013-04-28','10:50:00',8.59),('10318','2013-04-28','10:55:00',8.74),('10318','2013-04-28','11:00:00',8.75),('10318','2013-04-28','11:05:00',8.83),('10318','2013-04-28','11:10:00',8.81),('10318','2013-04-28','11:15:00',8.98),('10318','2013-04-28','11:20:00',8.94),('10318','2013-04-28','11:25:00',9.15),('10318','2013-04-28','11:30:00',9.18),('10318','2013-04-28','11:35:00',8.87),('10318','2013-04-28','11:40:00',8.94),('10318','2013-04-28','11:45:00',8.4),('10318','2013-04-28','11:50:00',8.68),('10318','2013-04-28','11:55:00',8.72),('10318','2013-04-28','12:00:00',7.86),('10318','2013-04-28','12:05:00',7.74),('10318','2013-04-28','12:10:00',8.57),('10318','2013-04-28','12:15:00',8.03),('10318','2013-04-28','12:20:00',8.26),('10318','2013-04-28','12:25:00',7.97),('10318','2013-04-28','12:30:00',8.18),('10318','2013-04-28','12:35:00',7.58),('10318','2013-04-28','12:40:00',7.03),('10318','2013-04-28','12:45:00',8.51),('10318','2013-04-28','12:50:00',9.08),('10318','2013-04-28','12:55:00',8.58),('10318','2013-04-28','13:00:00',8.99),('10318','2013-04-28','13:05:00',9.2),('10318','2013-04-28','13:10:00',8.87),('10318','2013-04-28','13:15:00',8.12),('10318','2013-04-28','13:20:00',7.57),('10318','2013-04-28','13:25:00',7.85),('10318','2013-04-28','13:30:00',8.83),('10318','2013-04-28','13:35:00',9.39),('10318','2013-04-28','13:40:00',9.33),('10318','2013-04-28','13:45:00',9.1),('10318','2013-04-28','13:50:00',9.11),('10318','2013-04-28','13:55:00',9.27),('10318','2013-04-28','14:00:00',8.99),('10318','2013-04-28','14:05:00',7.33),('10318','2013-04-28','14:10:00',7.03),('10318','2013-04-28','14:15:00',8.65),('10318','2013-04-28','14:20:00',8.4),('10318','2013-04-28','14:25:00',8.44),('10318','2013-04-28','14:30:00',8.36),('10318','2013-04-28','14:35:00',8.23),('10318','2013-04-28','14:40:00',7.99),('10318','2013-04-28','14:45:00',7.8),('10318','2013-04-28','14:50:00',7.73),('10318','2013-04-28','14:55:00',7.75),('10318','2013-04-28','15:00:00',7.67),('10318','2013-04-28','15:05:00',7.61),('10318','2013-04-28','15:10:00',7.49),('10318','2013-04-28','15:15:00',7.28),('10318','2013-04-28','15:20:00',7.13),('10318','2013-04-28','15:25:00',7.07),('10318','2013-04-28','15:30:00',6.95),('10318','2013-04-28','15:35:00',6.79),('10318','2013-04-28','15:40:00',6.64),('10318','2013-04-28','15:45:00',6.49),('10318','2013-04-28','15:50:00',6.34),('10318','2013-04-28','15:55:00',6.21),('10318','2013-04-28','16:00:00',6.13),('10318','2013-04-28','16:05:00',5.79),('10318','2013-04-28','16:10:00',5.8),('10318','2013-04-28','16:15:00',5.66),('10318','2013-04-28','16:20:00',5.51),('10318','2013-04-28','16:25:00',5.36),('10318','2013-04-28','16:30:00',5.19),('10318','2013-04-28','16:35:00',5.01),('10318','2013-04-28','16:40:00',4.83),('10318','2013-04-28','16:45:00',4.67),('10318','2013-04-28','16:50:00',4.5),('10318','2013-04-28','16:55:00',4.32),('10318','2013-04-28','17:00:00',4.15),('10318','2013-04-28','17:05:00',3.77),('10318','2013-04-28','17:10:00',3.68),('10318','2013-04-28','17:15:00',3.64),('10318','2013-04-28','17:20:00',3.45),('10318','2013-04-28','17:25:00',3.33),('10318','2013-04-28','17:30:00',2.78),('10318','2013-04-28','17:35:00',2.75),('10318','2013-04-28','17:40:00',2.62),('10318','2013-04-28','17:45:00',2.63),('10318','2013-04-28','17:50:00',2.35),('10318','2013-04-28','17:55:00',2.11),('10318','2013-04-28','18:00:00',2.08),('10318','2013-04-28','18:05:00',1.92),('10318','2013-04-28','18:10:00',1.17),('10318','2013-04-28','18:15:00',1.43),('10318','2013-04-28','18:20:00',1.74),('10318','2013-04-28','18:25:00',1.6),('10318','2013-04-28','18:30:00',1.28),('10318','2013-04-28','18:35:00',1.18),('10318','2013-04-28','18:40:00',1.08),('10318','2013-04-27','07:35:00',1.07),('10318','2013-04-27','07:40:00',1.07),('10318','2013-04-27','07:45:00',1),('10318','2013-04-27','11:40:00',1.05),('10318','2013-04-27','11:45:00',1.31),('10318','2013-04-27','11:50:00',1.54),('10318','2013-04-27','11:55:00',1.61),('10318','2013-04-27','12:00:00',1.69),('10318','2013-04-27','12:05:00',1.55),('10318','2013-04-27','12:10:00',1.31),('10318','2013-04-27','12:15:00',1.23),('10318','2013-04-27','12:20:00',1.22),('10318','2013-04-27','12:25:00',1.32),('10318','2013-04-27','12:30:00',1.41),('10318','2013-04-27','12:35:00',1.53),('10318','2013-04-27','12:40:00',1.87),('10318','2013-04-27','12:45:00',2.01),('10318','2013-04-27','12:50:00',2.39),('10318','2013-04-27','12:55:00',3.01),('10318','2013-04-27','13:00:00',3.01),('10318','2013-04-27','13:05:00',2.27),('10318','2013-04-27','13:10:00',2.7),('10318','2013-04-27','13:15:00',3.78),('10318','2013-04-27','13:20:00',3.94),('10318','2013-04-27','13:25:00',2.58),('10318','2013-04-27','13:30:00',2.67),('10318','2013-04-27','13:35:00',3),('10318','2013-04-27','13:40:00',2.94),('10318','2013-04-27','13:45:00',2.39),('10318','2013-04-27','13:50:00',2.32),('10318','2013-04-27','13:55:00',1.42),('10318','2013-04-27','14:00:00',1.07),('10318','2013-04-27','14:05:00',1.01),('10318','2013-04-27','14:20:00',1.06),('10318','2013-04-27','14:25:00',2.33),('10318','2013-04-27','14:30:00',4.76),('10318','2013-04-27','14:35:00',4.84),('10318','2013-04-27','14:40:00',2.64),('10318','2013-04-27','14:45:00',1.97),('10318','2013-04-27','14:50:00',1.39),('10318','2013-04-27','14:55:00',1.54),('10318','2013-04-27','15:00:00',1.61),('10318','2013-04-27','15:05:00',2.41),('10318','2013-04-27','15:10:00',2.81),('10318','2013-04-27','15:15:00',1.86),('10318','2013-04-27','15:20:00',1.13),('10318','2013-04-27','15:35:00',1.16),('10318','2013-04-27','15:40:00',1.29),('10318','2013-04-27','15:45:00',1.28),('10318','2013-04-27','15:50:00',1.45),('10318','2013-04-27','16:35:00',1.43),('10318','2013-04-27','16:40:00',3.69),('10318','2013-04-27','16:45:00',2.81),('10318','2013-04-27','16:50:00',3.94),('10318','2013-04-27','16:55:00',4.14),('10318','2013-04-27','17:00:00',3.55),('10318','2013-04-27','17:05:00',2.21),('10318','2013-04-27','17:10:00',1.58),('10318','2013-04-27','17:15:00',1.3),('10318','2013-04-27','17:20:00',1.91),('10318','2013-04-27','17:25:00',1.02),('10318','2013-04-27','17:30:00',1.08),('10318','2013-04-27','17:35:00',1.56),('10318','2013-04-27','17:40:00',2.15),('10318','2013-04-27','17:45:00',1.79),('10318','2013-04-27','17:50:00',1.05),('10318','2013-04-26','07:00:00',1.13),('10318','2013-04-26','07:05:00',1.25),('10318','2013-04-26','07:10:00',1.36),('10318','2013-04-26','07:15:00',1.42),('10318','2013-04-26','07:20:00',1.49),('10318','2013-04-26','07:25:00',1.51),('10318','2013-04-26','07:30:00',1.56),('10318','2013-04-26','07:35:00',1.38),('10318','2013-04-26','07:40:00',1.33),('10318','2013-04-26','07:45:00',1.47),('10318','2013-04-26','07:50:00',1.63),('10318','2013-04-26','07:55:00',1.73),('10318','2013-04-26','08:00:00',2.2),('10318','2013-04-26','08:05:00',2.91),('10318','2013-04-26','08:10:00',3.27),('10318','2013-04-26','08:15:00',3.51),('10318','2013-04-26','08:20:00',3.43),('10318','2013-04-26','08:25:00',3.66),('10318','2013-04-26','08:30:00',4.14),('10318','2013-04-26','08:35:00',4.27),('10318','2013-04-26','08:40:00',4.29),('10318','2013-04-26','08:45:00',4.63),('10318','2013-04-26','08:50:00',4.97),('10318','2013-04-26','08:55:00',4.68),('10318','2013-04-26','09:00:00',3.88),('10318','2013-04-26','09:05:00',3.51),('10318','2013-04-26','09:10:00',4.13),('10318','2013-04-26','09:15:00',3.7),('10318','2013-04-26','09:20:00',3.52),('10318','2013-04-26','09:25:00',4.56),('10318','2013-04-26','09:30:00',5.15),('10318','2013-04-26','09:35:00',4.32),('10318','2013-04-26','09:40:00',6.06),('10318','2013-04-26','09:45:00',5.4),('10318','2013-04-26','09:50:00',6.37),('10318','2013-04-26','09:55:00',4.97),('10318','2013-04-26','10:00:00',4.03),('10318','2013-04-26','10:05:00',6.31),('10318','2013-04-26','10:10:00',7.6),('10318','2013-04-26','10:15:00',7.81),('10318','2013-04-26','10:20:00',7.7),('10318','2013-04-26','10:25:00',7.87),('10318','2013-04-26','10:30:00',6.45),('10318','2013-04-26','10:35:00',8.33),('10318','2013-04-26','10:40:00',7.98),('10318','2013-04-26','10:45:00',5.34),('10318','2013-04-26','10:50:00',5.73),('10318','2013-04-26','10:55:00',8.4),('10318','2013-04-26','11:00:00',8.52),('10318','2013-04-26','11:05:00',8.34),('10318','2013-04-26','11:10:00',8.53),('10318','2013-04-26','11:15:00',7.49),('10318','2013-04-26','11:20:00',6.09),('10318','2013-04-26','11:25:00',6.33),('10318','2013-04-26','11:30:00',6.29),('10318','2013-04-26','11:35:00',9.19),('10318','2013-04-26','11:40:00',8.72),('10318','2013-04-26','11:45:00',8.97),('10318','2013-04-26','11:50:00',7.95),('10318','2013-04-26','11:55:00',6.03),('10318','2013-04-26','12:00:00',5.93),('10318','2013-04-26','12:05:00',6.14),('10318','2013-04-26','12:10:00',6.39),('10318','2013-04-26','12:15:00',5.92),('10318','2013-04-26','12:20:00',5.9),('10318','2013-04-26','12:25:00',3.94),('10318','2013-04-26','12:30:00',3.8),('10318','2013-04-26','12:35:00',4.58),('10318','2013-04-26','12:40:00',5.33),('10318','2013-04-26','12:45:00',5.79),('10318','2013-04-26','12:50:00',4.33),('10318','2013-04-26','12:55:00',3.43),('10318','2013-04-26','13:00:00',2.85),('10318','2013-04-26','13:05:00',2.79),('10318','2013-04-26','13:10:00',3.69),('10318','2013-04-26','13:15:00',5.28),('10318','2013-04-26','13:20:00',4.77),('10318','2013-04-26','13:25:00',7.19),('10318','2013-04-26','13:30:00',5.33),('10318','2013-04-26','13:35:00',8.2),('10318','2013-04-26','13:40:00',6.08),('10318','2013-04-26','13:45:00',5.79),('10318','2013-04-26','13:50:00',8.21),('10318','2013-04-26','13:55:00',6.49),('10318','2013-04-26','14:00:00',5.31),('10318','2013-04-26','14:05:00',8.15),('10318','2013-04-26','14:10:00',6.48),('10318','2013-04-26','14:15:00',5.37),('10318','2013-04-26','14:20:00',8.91),('10318','2013-04-26','14:25:00',8.28),('10318','2013-04-26','14:30:00',7.16),('10318','2013-04-26','14:35:00',4.77),('10318','2013-04-26','14:40:00',3.92),('10318','2013-04-26','14:45:00',3.01),('10318','2013-04-26','14:50:00',4.77),('10318','2013-04-26','14:55:00',8.75),('10318','2013-04-26','15:00:00',7.7),('10318','2013-04-26','15:05:00',5.82),('10318','2013-04-26','15:10:00',6.02),('10318','2013-04-26','15:15:00',6.38),('10318','2013-04-26','15:20:00',3.26),('10318','2013-04-26','15:25:00',3.64),('10318','2013-04-26','15:30:00',6.5),('10318','2013-04-26','15:35:00',4.31),('10318','2013-04-26','15:40:00',4.35),('10318','2013-04-26','15:45:00',5.3),('10318','2013-04-26','15:50:00',3.82),('10318','2013-04-26','15:55:00',2.05),('10318','2013-04-26','16:00:00',1.14),('10318','2013-04-26','16:35:00',1.24),('10318','2013-04-26','16:40:00',1.08),('10318','2013-04-25','07:30:00',1.13),('10318','2013-04-25','07:35:00',1.33),('10318','2013-04-25','07:40:00',1.47),('10318','2013-04-25','07:45:00',1.64),('10318','2013-04-25','07:50:00',1.73),('10318','2013-04-25','07:55:00',1.73),('10318','2013-04-25','08:00:00',1.99),('10318','2013-04-25','08:05:00',2.63),('10318','2013-04-25','08:10:00',2.68),('10318','2013-04-25','08:15:00',3.09),('10318','2013-04-25','08:20:00',2.59),('10318','2013-04-25','08:25:00',2.36),('10318','2013-04-25','08:30:00',2.44),('10318','2013-04-25','08:35:00',2.57),('10318','2013-04-25','08:40:00',2.78),('10318','2013-04-25','08:45:00',3.94),('10318','2013-04-25','08:50:00',5.54),('10318','2013-04-25','08:55:00',5.3),('10318','2013-04-25','09:00:00',3.7),('10318','2013-04-25','09:05:00',3.11),('10318','2013-04-25','09:10:00',3.16),('10318','2013-04-25','09:15:00',2.96),('10318','2013-04-25','09:20:00',3.33),('10318','2013-04-25','09:25:00',3.56),('10318','2013-04-25','09:30:00',3.72),('10318','2013-04-25','09:35:00',4.94),('10318','2013-04-25','09:40:00',5.93),('10318','2013-04-25','09:45:00',7.47),('10318','2013-04-25','09:50:00',7.66),('10318','2013-04-25','09:55:00',7.62),('10318','2013-04-25','10:00:00',7.4),('10318','2013-04-25','10:05:00',6.83),('10318','2013-04-25','10:10:00',6.32),('10318','2013-04-25','10:15:00',7.73),('10318','2013-04-25','10:20:00',8.05),('10318','2013-04-25','10:25:00',8.29),('10318','2013-04-25','10:30:00',8.26),('10318','2013-04-25','10:35:00',8.36),('10318','2013-04-25','10:40:00',8.31),('10318','2013-04-25','10:45:00',8.35),('10318','2013-04-25','10:50:00',7.47),('10318','2013-04-25','10:55:00',8.8),('10318','2013-04-25','11:00:00',8.83),('10318','2013-04-25','11:05:00',8.79),('10318','2013-04-25','11:10:00',8.79),('10318','2013-04-25','11:15:00',8.89),('10318','2013-04-25','11:20:00',8.95),('10318','2013-04-25','11:25:00',9.02),('10318','2013-04-25','11:30:00',8.52),('10318','2013-04-25','11:35:00',8.91),('10318','2013-04-25','11:40:00',9.27),('10318','2013-04-25','11:45:00',9.35),('10318','2013-04-25','11:50:00',9.36),('10318','2013-04-25','11:55:00',9.38),('10318','2013-04-25','12:00:00',9.19),('10318','2013-04-25','12:05:00',9.11),('10318','2013-04-25','12:10:00',9.3),('10318','2013-04-25','12:15:00',9.31),('10318','2013-04-25','12:20:00',9.21),('10318','2013-04-25','12:25:00',9.15),('10318','2013-04-25','12:30:00',9.11),('10318','2013-04-25','12:35:00',9.17),('10318','2013-04-25','12:40:00',9.14),('10318','2013-04-25','12:45:00',9.01),('10318','2013-04-25','12:50:00',9.04),('10318','2013-04-25','12:55:00',9.05),('10318','2013-04-25','13:00:00',9.15),('10318','2013-04-25','13:05:00',9.21),('10318','2013-04-25','13:10:00',9.18),('10318','2013-04-25','13:15:00',7.96),('10318','2013-04-25','13:20:00',8.59),('10318','2013-04-25','13:25:00',8.16),('10318','2013-04-25','13:30:00',6.42),('10318','2013-04-25','13:35:00',5.82),('10318','2013-04-25','13:40:00',5.1),('10318','2013-04-25','13:45:00',4.82),('10318','2013-04-25','13:50:00',4.64),('10318','2013-04-25','13:55:00',5.19),('10318','2013-04-25','14:00:00',5.38),('10318','2013-04-25','14:05:00',4.78),('10318','2013-04-25','14:10:00',5),('10318','2013-04-25','14:15:00',5.49),('10318','2013-04-25','14:20:00',6.27),('10318','2013-04-25','14:25:00',6.49),('10318','2013-04-25','14:30:00',7.5),('10318','2013-04-25','14:35:00',7.85),('10318','2013-04-25','14:40:00',7.44),('10318','2013-04-25','14:45:00',7.41),('10318','2013-04-25','14:50:00',6.81),('10318','2013-04-25','14:55:00',6.67),('10318','2013-04-25','15:00:00',6.61),('10318','2013-04-25','15:05:00',5.8),('10318','2013-04-25','15:10:00',6.22),('10318','2013-04-25','15:15:00',6.76),('10318','2013-04-25','15:20:00',6.97),('10318','2013-04-25','15:25:00',6.76),('10318','2013-04-25','15:30:00',6.59),('10318','2013-04-25','15:35:00',6.53),('10318','2013-04-25','15:40:00',5.79),('10318','2013-04-25','15:45:00',6.13),('10318','2013-04-25','15:50:00',4.99),('10318','2013-04-25','15:55:00',5.27),('10318','2013-04-25','16:00:00',5.09),('10318','2013-04-25','16:05:00',5.56),('10318','2013-04-25','16:10:00',4.81),('10318','2013-04-25','16:15:00',4.39),('10318','2013-04-25','16:20:00',5.38),('10318','2013-04-25','16:25:00',4.71),('10318','2013-04-25','16:30:00',5.16),('10318','2013-04-25','16:35:00',4.96),('10318','2013-04-25','16:40:00',5.14),('10318','2013-04-25','16:45:00',4.45),('10318','2013-04-25','16:50:00',3.76),('10318','2013-04-25','16:55:00',3.7),('10318','2013-04-25','17:00:00',4.3),('10318','2013-04-25','17:05:00',4.08),('10318','2013-04-25','17:10:00',3.37),('10318','2013-04-25','17:15:00',3.84),('10318','2013-04-25','17:20:00',3.75),('10318','2013-04-25','17:25:00',3.41),('10318','2013-04-25','17:30:00',3.22),('10318','2013-04-25','17:35:00',2.95),('10318','2013-04-25','17:40:00',2.59),('10318','2013-04-25','17:45:00',2.23),('10318','2013-04-25','17:50:00',1.92),('10318','2013-04-25','17:55:00',1.8),('10318','2013-04-25','18:00:00',1.64),('10318','2013-04-25','18:05:00',1.67),('10318','2013-04-25','18:10:00',1.48),('10318','2013-04-25','18:15:00',1.33),('10318','2013-04-25','18:20:00',1.23),('10318','2013-04-25','18:25:00',1.11),('10318','2013-04-25','18:30:00',1.04),('10318','2013-04-24','07:30:00',1.14),('10318','2013-04-24','07:35:00',1.65),('10318','2013-04-24','07:40:00',2.04),('10318','2013-04-24','07:45:00',2.28),('10318','2013-04-24','07:50:00',2.66),('10318','2013-04-24','07:55:00',3.04),('10318','2013-04-24','08:00:00',3.18),('10318','2013-04-24','08:05:00',3.33),('10318','2013-04-24','08:10:00',3.79),('10318','2013-04-24','08:15:00',4.17),('10318','2013-04-24','08:20:00',4.36),('10318','2013-04-24','08:25:00',4.7),('10318','2013-04-24','08:30:00',4.62),('10318','2013-04-24','08:35:00',4.47),('10318','2013-04-24','08:40:00',4.56),('10318','2013-04-24','08:45:00',4.81),('10318','2013-04-24','08:50:00',4.93),('10318','2013-04-24','08:55:00',5.03),('10318','2013-04-24','09:00:00',5.84),('10318','2013-04-24','09:05:00',6.31),('10318','2013-04-24','09:10:00',6.87),('10318','2013-04-24','09:15:00',5.34),('10318','2013-04-24','09:20:00',4.1),('10318','2013-04-24','09:25:00',5.21),('10318','2013-04-24','09:30:00',5.71),('10318','2013-04-24','09:35:00',6.37),('10318','2013-04-24','09:40:00',7.52),('10318','2013-04-24','09:45:00',6.89),('10318','2013-04-24','09:50:00',7.11),('10318','2013-04-24','09:55:00',8.06),('10318','2013-04-24','10:00:00',8.13),('10318','2013-04-24','10:05:00',8.15),('10318','2013-04-24','10:10:00',7.85),('10318','2013-04-24','10:15:00',7.99),('10318','2013-04-24','10:20:00',8.21),('10318','2013-04-24','10:25:00',8.02),('10318','2013-04-24','10:30:00',7.87),('10318','2013-04-24','10:35:00',7.84),('10318','2013-04-24','10:40:00',8.58),('10318','2013-04-24','10:45:00',8.72),('10318','2013-04-24','10:50:00',8.73),('10318','2013-04-24','10:55:00',8.96),('10318','2013-04-24','11:00:00',8.77),('10318','2013-04-24','11:05:00',8.91),('10318','2013-04-24','11:10:00',9.5),('10318','2013-04-24','11:15:00',9.48),('10318','2013-04-24','11:20:00',9.76),('10318','2013-04-24','11:25:00',10.09),('10318','2013-04-24','11:30:00',9.06),('10318','2013-04-24','11:35:00',7.54),('10318','2013-04-24','11:40:00',5.5),('10318','2013-04-24','11:45:00',5.79),('10318','2013-04-24','11:50:00',5.15),('10318','2013-04-24','11:55:00',5.81),('10318','2013-04-24','12:00:00',6.69),('10318','2013-04-24','12:05:00',6.48),('10318','2013-04-24','12:10:00',7.06),('10318','2013-04-24','12:15:00',8.17),('10318','2013-04-24','12:20:00',9.91),('10318','2013-04-24','12:25:00',8.01),('10318','2013-04-24','12:30:00',8.49),('10318','2013-04-24','12:35:00',8.33),('10318','2013-04-24','12:40:00',8.47),('10318','2013-04-24','12:45:00',9.14),('10318','2013-04-24','12:50:00',8.94),('10318','2013-04-24','12:55:00',8.97),('10318','2013-04-24','13:00:00',7.56),('10318','2013-04-24','13:05:00',8.31),('10318','2013-04-24','13:10:00',9.77),('10318','2013-04-24','13:15:00',8.15),('10318','2013-04-24','13:20:00',8.09),('10318','2013-04-24','13:25:00',8.83),('10318','2013-04-24','13:30:00',7.56),('10318','2013-04-24','13:35:00',7.52),('10318','2013-04-24','13:40:00',9.53),('10318','2013-04-24','13:45:00',5.89),('10318','2013-04-24','13:50:00',7.3),('10318','2013-04-24','13:55:00',8.81),('10318','2013-04-24','14:00:00',7.02),('10318','2013-04-24','14:05:00',6.01),('10318','2013-04-24','14:10:00',7.39),('10318','2013-04-24','14:15:00',8.28),('10318','2013-04-24','14:20:00',7.76),('10318','2013-04-24','14:25:00',8.21),('10318','2013-04-24','14:30:00',7.51),('10318','2013-04-24','14:35:00',6.55),('10318','2013-04-24','14:40:00',5.89),('10318','2013-04-24','14:45:00',6.15),('10318','2013-04-24','14:50:00',5.05),('10318','2013-04-24','14:55:00',5.18),('10318','2013-04-24','15:00:00',5.19),('10318','2013-04-24','15:05:00',5.16),('10318','2013-04-24','15:10:00',4.73),('10318','2013-04-24','15:15:00',4.96),('10318','2013-04-24','15:20:00',4.97),('10318','2013-04-24','15:25:00',4.04),('10318','2013-04-24','15:30:00',3.82),('10318','2013-04-24','15:35:00',3.7),('10318','2013-04-24','15:40:00',3.71),('10318','2013-04-24','15:45:00',3.81),('10318','2013-04-24','15:50:00',4.1),('10318','2013-04-24','15:55:00',4.79),('10318','2013-04-24','16:00:00',5.11),('10318','2013-04-24','16:05:00',5.41),('10318','2013-04-24','16:10:00',5.39),('10318','2013-04-24','16:15:00',6.23),('10318','2013-04-24','16:20:00',6.45),('10318','2013-04-24','16:25:00',5.02),('10318','2013-04-24','16:30:00',3.45),('10318','2013-04-24','16:35:00',4.38),('10318','2013-04-24','16:40:00',4.62),('10318','2013-04-24','16:45:00',4.77),('10318','2013-04-24','16:50:00',4.78),('10318','2013-04-24','16:55:00',5.29),('10318','2013-04-24','17:00:00',4.88),('10318','2013-04-24','17:05:00',4.71),('10318','2013-04-24','17:10:00',4.22),('10318','2013-04-24','17:15:00',3.03),('10318','2013-04-24','17:20:00',3.34),('10318','2013-04-24','17:25:00',2.48),('10318','2013-04-24','17:30:00',1.77),('10318','2013-04-24','17:35:00',1.35),('10318','2013-04-24','17:40:00',1.52),('10318','2013-04-24','17:45:00',1.75),('10318','2013-04-24','17:50:00',2.32),('10318','2013-04-24','17:55:00',2.43),('10318','2013-04-24','18:00:00',2.01),('10318','2013-04-24','18:05:00',2.05),('10318','2013-04-24','18:10:00',1.41),('10318','2013-04-24','18:15:00',1.21),('10318','2013-04-24','18:20:00',1.55),('10318','2013-04-24','18:25:00',1.43),('10318','2013-04-24','18:30:00',1.03),('10318','2013-04-23','07:25:00',1.18),('10318','2013-04-23','07:30:00',1.87),('10318','2013-04-23','07:35:00',2.3),('10318','2013-04-23','07:40:00',2.64),('10318','2013-04-23','07:45:00',3.05),('10318','2013-04-23','07:50:00',3.35),('10318','2013-04-23','07:55:00',3.6),('10318','2013-04-23','08:00:00',3.84),('10318','2013-04-23','08:05:00',4.05),('10318','2013-04-23','08:10:00',4.27),('10318','2013-04-23','08:15:00',4.48),('10318','2013-04-23','08:20:00',4.7),('10318','2013-04-23','08:25:00',4.93),('10318','2013-04-23','08:30:00',5.16),('10318','2013-04-23','08:35:00',5.37),('10318','2013-04-23','08:40:00',5.46),('10318','2013-04-23','08:45:00',5.79),('10318','2013-04-23','08:50:00',5.94),('10318','2013-04-23','08:55:00',6.13),('10318','2013-04-23','09:00:00',6.29),('10318','2013-04-23','09:05:00',6.48),('10318','2013-04-23','09:10:00',6.63),('10318','2013-04-23','09:15:00',6.78),('10318','2013-04-23','09:20:00',6.95),('10318','2013-04-23','09:25:00',7.11),('10318','2013-04-23','09:30:00',7.3),('10318','2013-04-23','09:35:00',7.5),('10318','2013-04-23','09:40:00',7.36),('10318','2013-04-23','09:45:00',5.92),('10318','2013-04-23','09:50:00',7.1),('10318','2013-04-23','09:55:00',8.02),('10318','2013-04-23','10:00:00',8.23),('10318','2013-04-23','10:05:00',8.27),('10318','2013-04-23','10:10:00',8.35),('10318','2013-04-23','10:15:00',8.46),('10318','2013-04-23','10:20:00',8.53),('10318','2013-04-23','10:25:00',8.6),('10318','2013-04-23','10:30:00',8.68),('10318','2013-04-23','10:35:00',8.81),('10318','2013-04-23','10:40:00',8.92),('10318','2013-04-23','10:45:00',8.77),('10318','2013-04-23','10:50:00',9.08),('10318','2013-04-23','10:55:00',9.14),('10318','2013-04-23','11:00:00',9.14),('10318','2013-04-23','11:05:00',9.17),('10318','2013-04-23','11:10:00',9.21),('10318','2013-04-23','11:15:00',9.26),('10318','2013-04-23','11:20:00',9.31),('10318','2013-04-23','11:25:00',9.33),('10318','2013-04-23','11:30:00',9.36),('10318','2013-04-23','11:35:00',9.45),('10318','2013-04-23','11:40:00',9.48),('10318','2013-04-23','11:45:00',9.47),('10318','2013-04-23','11:50:00',9.46),('10318','2013-04-23','11:55:00',9.44),('10318','2013-04-23','12:00:00',9.41),('10318','2013-04-23','12:05:00',9.45),('10318','2013-04-23','12:10:00',9.51),('10318','2013-04-23','12:15:00',9.59),('10318','2013-04-23','12:20:00',9.74),('10318','2013-04-23','12:25:00',9.76),('10318','2013-04-23','12:30:00',9.91),('10318','2013-04-23','12:35:00',7.03),('10318','2013-04-23','12:40:00',10.42),('10318','2013-04-23','12:45:00',10.57),('10318','2013-04-23','12:50:00',7.34),('10318','2013-04-23','12:55:00',10.45),('10318','2013-04-23','13:00:00',8.05),('10318','2013-04-23','13:05:00',8.41),('10318','2013-04-23','13:10:00',4.39),('10318','2013-04-23','13:15:00',3.43),('10318','2013-04-23','13:20:00',9.31),('10318','2013-04-23','13:25:00',7.62),('10318','2013-04-23','13:30:00',4.54),('10318','2013-04-23','13:35:00',8.51),('10318','2013-04-23','13:40:00',10.17),('10318','2013-04-23','13:45:00',8.19),('10318','2013-04-23','13:50:00',8.74),('10318','2013-04-23','13:55:00',10.18),('10318','2013-04-23','14:00:00',9.61),('10318','2013-04-23','14:05:00',9.62),('10318','2013-04-23','14:10:00',9.4),('10318','2013-04-23','14:15:00',8.87),('10318','2013-04-23','14:20:00',8.5),('10318','2013-04-23','14:25:00',3.53),('10318','2013-04-23','14:30:00',9.02),('10318','2013-04-23','14:35:00',8.3),('10318','2013-04-23','14:40:00',8.39),('10318','2013-04-23','14:45:00',6.72),('10318','2013-04-23','14:50:00',4.85),('10318','2013-04-23','14:55:00',4.53),('10318','2013-04-23','15:00:00',4.79),('10318','2013-04-23','15:05:00',5.58),('10318','2013-04-23','15:10:00',6.12),('10318','2013-04-23','15:15:00',6.22),('10318','2013-04-23','15:20:00',6.32),('10318','2013-04-23','15:25:00',5.34),('10318','2013-04-23','15:30:00',5.3),('10318','2013-04-23','15:35:00',5.83),('10318','2013-04-23','15:40:00',5.24),('10318','2013-04-23','15:45:00',4.61),('10318','2013-04-23','15:50:00',4.83),('10318','2013-04-23','15:55:00',4.24),('10318','2013-04-23','16:00:00',5.44),('10318','2013-04-23','16:05:00',5.27),('10318','2013-04-23','16:10:00',5.31),('10318','2013-04-23','16:15:00',4),('10318','2013-04-23','16:20:00',4.13),('10318','2013-04-23','16:25:00',3.91),('10318','2013-04-23','16:30:00',3.12),('10318','2013-04-23','16:35:00',2.51),('10318','2013-04-23','16:40:00',2.25),('10318','2013-04-23','16:45:00',2.25),('10318','2013-04-23','16:50:00',2.56),('10318','2013-04-23','16:55:00',2.83),('10318','2013-04-23','17:00:00',3.09),('10318','2013-04-23','17:05:00',2.96),('10318','2013-04-23','17:10:00',2.78),('10318','2013-04-23','17:15:00',2.26),('10318','2013-04-23','17:20:00',1.81),('10318','2013-04-23','17:25:00',1.72),('10318','2013-04-23','17:30:00',1.8),('10318','2013-04-23','17:35:00',2.02),('10318','2013-04-23','17:40:00',2.32),('10318','2013-04-23','17:45:00',2.76),('10318','2013-04-23','17:50:00',1.92),('10318','2013-04-23','17:55:00',1.4),('10318','2013-04-23','18:00:00',1.32),('10318','2013-04-23','18:05:00',1.16),('10318','2013-04-23','18:15:00',1.02),('10318','2013-04-23','18:20:00',1.08),('10318','2013-04-23','18:25:00',1.05),('10318','2013-04-22','08:40:00',1.07),('10318','2013-04-22','08:45:00',1.26),('10318','2013-04-22','08:55:00',1.3),('10318','2013-04-22','09:00:00',1.85),('10318','2013-04-22','09:05:00',1.58),('10318','2013-04-22','09:10:00',2.18),('10318','2013-04-22','09:15:00',1.68),('10318','2013-04-22','09:20:00',1.76),('10318','2013-04-22','09:25:00',2.36),('10318','2013-04-22','09:30:00',2.92),('10318','2013-04-22','09:35:00',2.28),('10318','2013-04-22','09:40:00',1.74),('10318','2013-04-22','09:45:00',1.39),('10318','2013-04-22','10:30:00',1.1),('10318','2013-04-22','10:35:00',8.07),('10318','2013-04-22','10:40:00',8.85),('10318','2013-04-22','10:45:00',7.21),('10318','2013-04-22','10:50:00',5.18),('10318','2013-04-22','10:55:00',4.17),('10318','2013-04-22','11:00:00',3.06),('10318','2013-04-22','11:05:00',4.62),('10318','2013-04-22','11:10:00',4.39),('10318','2013-04-22','11:15:00',3.8),('10318','2013-04-22','11:20:00',3.57),('10318','2013-04-22','11:25:00',3.76),('10318','2013-04-22','11:30:00',7.94),('10318','2013-04-22','11:35:00',10.35),('10318','2013-04-22','11:40:00',4.99),('10318','2013-04-22','11:45:00',8.06),('10318','2013-04-22','11:50:00',9.22),('10318','2013-04-22','11:55:00',10.72),('10318','2013-04-22','12:00:00',8.26),('10318','2013-04-22','12:05:00',8.52),('10318','2013-04-22','12:10:00',10.27),('10318','2013-04-22','12:15:00',10.77),('10318','2013-04-22','12:20:00',9.07),('10318','2013-04-22','12:25:00',7.83),('10318','2013-04-22','12:30:00',8.22),('10318','2013-04-22','12:35:00',8.77),('10318','2013-04-22','12:40:00',9.85),('10318','2013-04-22','12:45:00',6.31),('10318','2013-04-22','12:50:00',9.41),('10318','2013-04-22','12:55:00',10.39),('10318','2013-04-22','13:00:00',10.1),('10318','2013-04-22','13:05:00',8.4),('10318','2013-04-22','13:10:00',9.08),('10318','2013-04-22','13:15:00',6.34),('10318','2013-04-22','13:20:00',4.4),('10318','2013-04-22','13:25:00',9.09),('10318','2013-04-22','13:30:00',10.41),('10318','2013-04-22','13:35:00',6.22),('10318','2013-04-22','13:40:00',3.5),('10318','2013-04-22','13:45:00',4.38),('10318','2013-04-22','13:50:00',2.56),('10318','2013-04-22','13:55:00',2.01),('10318','2013-04-22','14:00:00',1.95),('10318','2013-04-22','14:05:00',2.65),('10318','2013-04-22','14:10:00',2.58),('10318','2013-04-22','14:15:00',6.89),('10318','2013-04-22','14:20:00',10.3),('10318','2013-04-22','14:25:00',9.92),('10318','2013-04-22','14:30:00',9.71),('10318','2013-04-22','14:35:00',7.28),('10318','2013-04-22','14:40:00',8.75),('10318','2013-04-22','14:45:00',8.08),('10318','2013-04-22','14:50:00',9.2),('10318','2013-04-22','14:55:00',9.5),('10318','2013-04-22','15:00:00',9.65),('10318','2013-04-22','15:05:00',4.82),('10318','2013-04-22','15:10:00',8.66),('10318','2013-04-22','15:15:00',9.8),('10318','2013-04-22','15:20:00',8.79),('10318','2013-04-22','15:25:00',7.29),('10318','2013-04-22','15:30:00',2.85),('10318','2013-04-22','15:35:00',3.15),('10318','2013-04-22','15:40:00',9.37),('10318','2013-04-22','15:45:00',8.51),('10318','2013-04-22','15:50:00',6.19),('10318','2013-04-22','15:55:00',5.54),('10318','2013-04-22','16:00:00',1.65),('10318','2013-04-22','16:05:00',1.69),('10318','2013-04-22','16:10:00',1.68),('10318','2013-04-22','16:15:00',1.47),('10318','2013-04-22','16:20:00',1.18),('10318','2013-04-22','16:40:00',1.33),('10318','2013-04-22','16:45:00',2.05),('10318','2013-04-22','16:50:00',2.76),('10318','2013-04-22','16:55:00',1.9),('10318','2013-04-22','17:00:00',1.64),('10318','2013-04-22','17:05:00',1.26),('10318','2013-04-22','17:10:00',1.51),('10318','2013-04-22','17:15:00',1.11),('10318','2013-04-22','17:20:00',1.37),('10318','2013-04-22','17:25:00',1.32),('10318','2013-04-22','17:30:00',1.44),('10318','2013-04-22','17:35:00',1.57),('10318','2013-04-22','17:40:00',1.19),('10318','2013-04-22','17:55:00',1.06),('10318','2013-04-22','18:00:00',1.77),('10318','2013-04-22','18:05:00',2.32),('10318','2013-04-22','18:10:00',1.34),('10318','2013-04-22','18:15:00',1.5),('10318','2013-04-22','18:20:00',1.67),('10318','2013-04-22','18:25:00',1.55),('10318','2013-04-22','18:30:00',1.3),('10318','2013-04-22','18:40:00',1.05),('10318','2014-03-29','06:55:00',1.2),('10318','2014-03-29','07:00:00',1.44),('10318','2014-03-29','07:05:00',1.85),('10318','2014-03-29','07:10:00',2.31),('10318','2014-03-29','07:15:00',2.65),('10318','2014-03-29','07:20:00',3),('10318','2014-03-29','07:25:00',3.32),('10318','2014-03-29','07:30:00',3.62),('10318','2014-03-29','07:35:00',3.85),('10318','2014-03-29','07:40:00',4.09),('10318','2014-03-29','07:45:00',4.33),('10318','2014-03-29','07:50:00',4.53),('10318','2014-03-29','07:55:00',4.76),('10318','2014-03-29','08:00:00',5.03),('10318','2014-03-29','08:05:00',5.27),('10318','2014-03-29','08:10:00',5.48),('10318','2014-03-29','08:15:00',5.68),('10318','2014-03-29','08:20:00',5.89),('10318','2014-03-29','08:25:00',6.12),('10318','2014-03-29','08:30:00',6.3),('10318','2014-03-29','08:35:00',6.46),('10318','2014-03-29','08:40:00',6.63),('10318','2014-03-29','08:45:00',6.75),('10318','2014-03-29','08:50:00',6.84),('10318','2014-03-29','08:55:00',6.99),('10318','2014-03-29','09:00:00',7.15),('10318','2014-03-29','09:05:00',7.03),('10318','2014-03-29','09:10:00',7.28),('10318','2014-03-29','09:15:00',7.38),('10318','2014-03-29','09:20:00',7.56),('10318','2014-03-29','09:25:00',7.68),('10318','2014-03-29','09:30:00',7.86),('10318','2014-03-29','09:35:00',7.99),('10318','2014-03-29','09:40:00',8.14),('10318','2014-03-29','09:45:00',8.18),('10318','2014-03-29','09:50:00',8.31),('10318','2014-03-29','09:55:00',8.41),('10318','2014-03-29','10:00:00',8.44),('10318','2014-03-29','10:05:00',8.6),('10318','2014-03-29','10:10:00',8.75),('10318','2014-03-29','10:15:00',8.86),('10318','2014-03-29','10:20:00',8.94),('10318','2014-03-29','10:25:00',8.97),('10318','2014-03-29','10:30:00',9.06),('10318','2014-03-29','10:35:00',9.11),('10318','2014-03-29','10:40:00',9.22),('10318','2014-03-29','10:45:00',9.24),('10318','2014-03-29','10:50:00',9.02),('10318','2014-03-29','10:55:00',9.26),('10318','2014-03-29','11:00:00',9.24),('10318','2014-03-29','11:05:00',9.17),('10318','2014-03-29','11:10:00',9.27),('10318','2014-03-29','11:15:00',9.31),('10318','2014-03-29','11:20:00',9.24),('10318','2014-03-29','11:25:00',9.29),('10318','2014-03-29','11:30:00',9.4),('10318','2014-03-29','11:35:00',9.16),('10318','2014-03-29','11:40:00',9.19),('10318','2014-03-29','11:45:00',9.32),('10318','2014-03-29','11:50:00',9.37),('10318','2014-03-29','11:55:00',9.28),('10318','2014-03-29','12:00:00',9.23),('10318','2014-03-29','12:05:00',9.26),('10318','2014-03-29','12:10:00',9.24),('10318','2014-03-29','12:15:00',9.27),('10318','2014-03-29','12:20:00',9.24),('10318','2014-03-29','12:25:00',9.2),('10318','2014-03-29','12:30:00',9.08),('10318','2014-03-29','12:35:00',8.72),('10318','2014-03-29','12:40:00',8.99),('10318','2014-03-29','12:45:00',8.93),('10318','2014-03-29','12:50:00',8.93),('10318','2014-03-29','12:55:00',8.8),('10318','2014-03-29','13:00:00',8.72),('10318','2014-03-29','13:05:00',8.63),('10318','2014-03-29','13:10:00',8.58),('10318','2014-03-29','13:15:00',8.58),('10318','2014-03-29','13:20:00',8.38),('10318','2014-03-29','13:25:00',8.2),('10318','2014-03-29','13:30:00',8.1),('10318','2014-03-29','13:35:00',7.98),('10318','2014-03-29','13:40:00',8.05),('10318','2014-03-29','13:45:00',7.94),('10318','2014-03-29','13:50:00',7.73),('10318','2014-03-29','13:55:00',7.68),('10318','2014-03-29','14:00:00',7.47),('10318','2014-03-29','14:05:00',7.42),('10318','2014-03-29','14:10:00',7.24),('10318','2014-03-29','14:15:00',7.09),('10318','2014-03-29','14:20:00',7.01),('10318','2014-03-29','14:25:00',6.91),('10318','2014-03-29','14:30:00',6.23),('10318','2014-03-29','14:35:00',6.58),('10318','2014-03-29','14:40:00',6.4),('10318','2014-03-29','14:45:00',6.49),('10318','2014-03-29','14:50:00',6.09),('10318','2014-03-29','14:55:00',6.13),('10318','2014-03-29','15:00:00',5.96),('10318','2014-03-29','15:05:00',5.87),('10318','2014-03-29','15:10:00',5.65),('10318','2014-03-29','15:15:00',5.41),('10318','2014-03-29','15:20:00',5.18),('10318','2014-03-29','15:25:00',4.95),('10318','2014-03-29','15:30:00',4.85),('10318','2014-03-29','15:35:00',4.68),('10318','2014-03-29','15:40:00',4.37),('10318','2014-03-29','15:45:00',4.3),('10318','2014-03-29','15:50:00',4.09),('10318','2014-03-29','15:55:00',3.91),('10318','2014-03-29','16:00:00',3.72),('10318','2014-03-29','16:05:00',3.54),('10318','2014-03-29','16:10:00',3.3),('10318','2014-03-29','16:15:00',3.15),('10318','2014-03-29','16:20:00',2.85),('10318','2014-03-29','16:25:00',2.84),('10318','2014-03-29','16:30:00',2.67),('10318','2014-03-29','16:35:00',2.4),('10318','2014-03-29','16:40:00',1.91),('10318','2014-03-29','16:45:00',1.76),('10318','2014-03-29','16:50:00',1.88),('10318','2014-03-29','16:55:00',1.81),('10318','2014-03-29','17:00:00',1.66),('10318','2014-03-29','17:05:00',1.5),('10318','2014-03-29','17:10:00',1.36),('10318','2014-03-29','17:15:00',1.22),('10318','2014-03-29','17:20:00',1.08),('10318','2013-04-21','07:45:00',1.06),('10318','2013-04-21','07:50:00',1.59),('10318','2013-04-21','07:55:00',2.01),('10318','2013-04-21','08:00:00',1.8),('10318','2013-04-21','08:05:00',1.99),('10318','2013-04-21','08:10:00',2.3),('10318','2013-04-21','08:15:00',2.21),('10318','2013-04-21','08:20:00',3.02),('10318','2013-04-21','08:25:00',2.85),('10318','2013-04-21','08:30:00',3.71),('10318','2013-04-21','08:35:00',3.44),('10318','2013-04-21','08:40:00',2.7),('10318','2013-04-21','08:45:00',2.56),('10318','2013-04-21','08:50:00',2.73),('10318','2013-04-21','08:55:00',3.48),('10318','2013-04-21','09:00:00',6.18),('10318','2013-04-21','09:05:00',5.04),('10318','2013-04-21','09:10:00',4.46),('10318','2013-04-21','09:15:00',4.29),('10318','2013-04-21','09:20:00',8.05),('10318','2013-04-21','09:25:00',7.13),('10318','2013-04-21','09:30:00',8.46),('10318','2013-04-21','09:35:00',7.78),('10318','2013-04-21','09:40:00',8.16),('10318','2013-04-21','09:45:00',6.04),('10318','2013-04-21','09:50:00',6.43),('10318','2013-04-21','09:55:00',5.39),('10318','2013-04-21','10:00:00',3.73),('10318','2013-04-21','10:05:00',2.8),('10318','2013-04-21','10:10:00',2.84),('10318','2013-04-21','10:15:00',2.94),('10318','2013-04-21','10:20:00',3.47),('10318','2013-04-21','10:25:00',3.35),('10318','2013-04-21','10:30:00',3.54),('10318','2013-04-21','10:35:00',3.9),('10318','2013-04-21','10:40:00',5.79),('10318','2013-04-21','10:45:00',4.56),('10318','2013-04-21','10:50:00',5.75),('10318','2013-04-21','10:55:00',9.36),('10318','2013-04-21','11:00:00',6.72),('10318','2013-04-21','11:05:00',6.4),('10318','2013-04-21','11:10:00',7.54),('10318','2013-04-21','11:15:00',7.47),('10318','2013-04-21','11:20:00',6.79),('10318','2013-04-21','11:25:00',6.36),('10318','2013-04-21','11:30:00',6.17),('10318','2013-04-21','11:35:00',7.02),('10318','2013-04-21','11:40:00',7.98),('10318','2013-04-21','11:45:00',8.11),('10318','2013-04-21','11:50:00',5.59),('10318','2013-04-21','11:55:00',6.26),('10318','2013-04-21','12:00:00',6.45),('10318','2013-04-21','12:05:00',5.27),('10318','2013-04-21','12:10:00',5.29),('10318','2013-04-21','12:15:00',4.7),('10318','2013-04-21','12:20:00',4.22),('10318','2013-04-21','12:25:00',4.35),('10318','2013-04-21','12:30:00',4.51),('10318','2013-04-21','12:35:00',4.82),('10318','2013-04-21','12:40:00',5.03),('10318','2013-04-21','12:45:00',4.75),('10318','2013-04-21','12:50:00',4.62),('10318','2013-04-21','12:55:00',4.69),('10318','2013-04-21','13:00:00',5.01),('10318','2013-04-21','13:05:00',6.81),('10318','2013-04-21','13:10:00',6.23),('10318','2013-04-21','13:15:00',5.31),('10318','2013-04-21','13:20:00',5.19),('10318','2013-04-21','13:25:00',5.22),('10318','2013-04-21','13:30:00',7.16),('10318','2013-04-21','13:35:00',9.32),('10318','2013-04-21','13:40:00',9.33),('10318','2013-04-21','13:45:00',10.31),('10318','2013-04-21','13:50:00',7.96),('10318','2013-04-21','13:55:00',8.65),('10318','2013-04-21','14:00:00',7.63),('10318','2013-04-21','14:05:00',9.52),('10318','2013-04-21','14:10:00',9.41),('10318','2013-04-21','14:15:00',9.57),('10318','2013-04-21','14:20:00',8.91),('10318','2013-04-21','14:25:00',7.39),('10318','2013-04-21','14:30:00',8.69),('10318','2013-04-21','14:35:00',8.86),('10318','2013-04-21','14:40:00',6.05),('10318','2013-04-21','14:45:00',7.13),('10318','2013-04-21','14:50:00',4.68),('10318','2013-04-21','14:55:00',8.85),('10318','2013-04-21','15:00:00',6.99),('10318','2013-04-21','15:05:00',7.81),('10318','2013-04-21','15:10:00',5.94),('10318','2013-04-21','15:15:00',4.98),('10318','2013-04-21','15:20:00',4.06),('10318','2013-04-21','15:25:00',4.41),('10318','2013-04-21','15:30:00',4.35),('10318','2013-04-21','15:35:00',3.62),('10318','2013-04-21','15:40:00',4.02),('10318','2013-04-21','15:45:00',2.79),('10318','2013-04-21','15:50:00',2.18),('10318','2013-04-21','15:55:00',1.74),('10318','2013-04-21','16:00:00',1.64),('10318','2013-04-21','16:05:00',1.45),('10318','2013-04-21','16:10:00',1.45),('10318','2013-04-21','16:15:00',1.36),('10318','2013-04-21','16:20:00',1.18),('10318','2013-04-21','16:30:00',1.05),('10318','2013-04-21','16:35:00',1.24),('10318','2013-04-21','16:40:00',1.21),('10318','2013-04-21','16:55:00',1.29),('10318','2013-04-21','17:00:00',1.58),('10318','2013-04-21','17:05:00',1.55),('10318','2013-04-21','17:10:00',1.58),('10318','2013-04-21','17:15:00',1.49),('10318','2013-04-21','17:20:00',1.26),('10318','2013-04-21','17:25:00',1.13),('10318','2013-04-21','17:30:00',1.05),('10318','2013-04-21','17:35:00',1.03),('10318','2013-04-21','17:40:00',1.01),('10318','2013-04-21','17:45:00',1.03),('10318','2013-04-20','07:20:00',1.18),('10318','2013-04-20','07:25:00',1.4),('10318','2013-04-20','07:30:00',1.74),('10318','2013-04-20','07:35:00',1.96),('10318','2013-04-20','07:40:00',1.96),('10318','2013-04-20','07:45:00',1.35),('10318','2013-04-20','07:50:00',1.66),('10318','2013-04-20','07:55:00',2.13),('10318','2013-04-20','08:00:00',2.68),('10318','2013-04-20','08:05:00',3.33),('10318','2013-04-20','08:10:00',3.49),('10318','2013-04-20','08:15:00',2.7),('10318','2013-04-20','08:20:00',3.18),('10318','2013-04-20','08:25:00',3.69),('10318','2013-04-20','08:30:00',4.38),('10318','2013-04-20','08:35:00',4.73),('10318','2013-04-20','08:40:00',5.03),('10318','2013-04-20','08:45:00',5.22),('10318','2013-04-20','08:50:00',5.3),('10318','2013-04-20','08:55:00',5.9),('10318','2013-04-20','09:00:00',6.04),('10318','2013-04-20','09:05:00',6.34),('10318','2013-04-20','09:10:00',4.17),('10318','2013-04-20','09:15:00',6.42),('10318','2013-04-20','09:20:00',5.62),('10318','2013-04-20','09:25:00',5.04),('10318','2013-04-20','09:30:00',2.62),('10318','2013-04-20','09:35:00',2.01),('10318','2013-04-20','09:40:00',1.67),('10318','2013-04-20','09:45:00',1.95),('10318','2013-04-20','09:50:00',1.79),('10318','2013-04-20','09:55:00',1.11),('10318','2013-04-20','10:20:00',1.1),('10318','2013-04-20','10:25:00',1.39),('10318','2013-04-20','10:30:00',1.76),('10318','2013-04-20','10:35:00',2.03),('10318','2013-04-20','10:40:00',2.91),('10318','2013-04-20','10:45:00',6.37),('10318','2013-04-20','10:50:00',7.27),('10318','2013-04-20','10:55:00',7.98),('10318','2013-04-20','11:00:00',7.7),('10318','2013-04-20','11:05:00',9.35),('10318','2013-04-20','11:10:00',5.69),('10318','2013-04-20','11:15:00',6.04),('10318','2013-04-20','11:20:00',7.16),('10318','2013-04-20','11:25:00',7.59),('10318','2013-04-20','11:30:00',7.17),('10318','2013-04-20','11:35:00',9.64),('10318','2013-04-20','11:40:00',8.24),('10318','2013-04-20','11:45:00',6.27),('10318','2013-04-20','11:50:00',7.55),('10318','2013-04-20','11:55:00',2.77),('10318','2013-04-20','12:00:00',7.25),('10318','2013-04-20','12:05:00',3.9),('10318','2013-04-20','12:10:00',4.67),('10318','2013-04-20','12:15:00',8.61),('10318','2013-04-20','12:20:00',9.42),('10318','2013-04-20','12:25:00',9.14),('10318','2013-04-20','12:30:00',10.51),('10318','2013-04-20','12:35:00',6.27),('10318','2013-04-20','12:40:00',8.07),('10318','2013-04-20','12:45:00',9.6),('10318','2013-04-20','12:50:00',7.83),('10318','2013-04-20','12:55:00',9.9),('10318','2013-04-20','13:00:00',9.68),('10318','2013-04-20','13:05:00',9.51),('10318','2013-04-20','13:10:00',9.65),('10318','2013-04-20','13:15:00',10.05),('10318','2013-04-20','13:20:00',6.18),('10318','2013-04-20','13:25:00',4.11),('10318','2013-04-20','13:30:00',10.25),('10318','2013-04-20','13:35:00',8.46),('10318','2013-04-20','13:40:00',5.63),('10318','2013-04-20','13:45:00',5.07),('10318','2013-04-20','13:50:00',6.67),('10318','2013-04-20','13:55:00',4.52),('10318','2013-04-20','14:00:00',8.55),('10318','2013-04-20','14:05:00',9.04),('10318','2013-04-20','14:10:00',9.55),('10318','2013-04-20','14:15:00',9.08),('10318','2013-04-20','14:20:00',8.43),('10318','2013-04-20','14:25:00',8.6),('10318','2013-04-20','14:30:00',8.4),('10318','2013-04-20','14:35:00',8.41),('10318','2013-04-20','14:40:00',8.29),('10318','2013-04-20','14:45:00',8.19),('10318','2013-04-20','14:50:00',8.18),('10318','2013-04-20','14:55:00',8.14),('10318','2013-04-20','15:00:00',8.11),('10318','2013-04-20','15:05:00',7.76),('10318','2013-04-20','15:10:00',6.41),('10318','2013-04-20','15:15:00',8.05),('10318','2013-04-20','15:20:00',6.49),('10318','2013-04-20','15:25:00',5.31),('10318','2013-04-20','15:30:00',2.56),('10318','2013-04-20','15:35:00',1.93),('10318','2013-04-20','15:40:00',1.89),('10318','2013-04-20','15:45:00',1.84),('10318','2013-04-20','15:50:00',1.71),('10318','2013-04-20','15:55:00',1.77),('10318','2013-04-20','16:00:00',2.18),('10318','2013-04-20','16:05:00',3.15),('10318','2013-04-20','16:10:00',5.12),('10318','2013-04-20','16:15:00',6.14),('10318','2013-04-20','16:20:00',5.88),('10318','2013-04-20','16:25:00',6.16),('10318','2013-04-20','16:30:00',6.24),('10318','2013-04-20','16:35:00',5.95),('10318','2013-04-20','16:40:00',5.95),('10318','2013-04-20','16:45:00',5.49),('10318','2013-04-20','16:50:00',4.97),('10318','2013-04-20','16:55:00',4.63),('10318','2013-04-20','17:00:00',4.31),('10318','2013-04-20','17:05:00',4.09),('10318','2013-04-20','17:10:00',3.9),('10318','2013-04-20','17:15:00',3.43),('10318','2013-04-20','17:20:00',3.4),('10318','2013-04-20','17:25:00',3.51),('10318','2013-04-20','17:30:00',3.51),('10318','2013-04-20','17:35:00',3.4),('10318','2013-04-20','17:40:00',2.29),('10318','2013-04-20','17:45:00',1.56),('10318','2013-04-20','17:50:00',2.36),('10318','2013-04-20','17:55:00',2.54),('10318','2013-04-20','18:00:00',1.89),('10318','2013-04-20','18:05:00',2.34),('10318','2013-04-20','18:10:00',2.31),('10318','2013-04-20','18:15:00',1.55),('10318','2013-04-19','07:40:00',1.35),('10318','2013-04-19','07:45:00',1.02),('10318','2013-04-19','07:50:00',1.19),('10318','2013-04-19','07:55:00',1.74),('10318','2013-04-19','08:00:00',1.99),('10318','2013-04-19','08:05:00',2.98),('10318','2013-04-19','08:10:00',3.44),('10318','2013-04-19','08:15:00',3.64),('10318','2013-04-19','08:20:00',3.87),('10318','2013-04-19','08:25:00',4.06),('10318','2013-04-19','08:30:00',4.36),('10318','2013-04-19','08:35:00',4.68),('10318','2013-04-19','08:40:00',4.76),('10318','2013-04-19','08:45:00',5.01),('10318','2013-04-19','08:50:00',5.29),('10318','2013-04-19','08:55:00',4.91),('10318','2013-04-19','09:00:00',5.55),('10318','2013-04-19','09:05:00',5.77),('10318','2013-04-19','09:10:00',5.93),('10318','2013-04-19','09:15:00',6.14),('10318','2013-04-19','09:20:00',6.14),('10318','2013-04-19','09:25:00',6.39),('10318','2013-04-19','09:30:00',6.49),('10318','2013-04-19','09:35:00',6.61),('10318','2013-04-19','09:40:00',6.64),('10318','2013-04-19','09:45:00',6.63),('10318','2013-04-19','09:50:00',6.87),('10318','2013-04-19','09:55:00',7.05),('10318','2013-04-19','10:00:00',7.13),('10318','2013-04-19','10:05:00',7.39),('10318','2013-04-19','10:10:00',7.5),('10318','2013-04-19','10:15:00',7.51),('10318','2013-04-19','10:20:00',7.81),('10318','2013-04-19','10:25:00',7.92),('10318','2013-04-19','10:30:00',7.69),('10318','2013-04-19','10:35:00',8.14),('10318','2013-04-19','10:40:00',7.06),('10318','2013-04-19','10:45:00',8.18),('10318','2013-04-19','10:50:00',8.22),('10318','2013-04-19','10:55:00',8.17),('10318','2013-04-19','11:00:00',8.31),('10318','2013-04-19','11:05:00',8.42),('10318','2013-04-19','11:10:00',8.49),('10318','2013-04-19','11:15:00',8.5),('10318','2013-04-19','11:20:00',8.49),('10318','2013-04-19','11:25:00',8.68),('10318','2013-04-19','11:30:00',8.58),('10318','2013-04-19','11:35:00',8.77),('10318','2013-04-19','11:40:00',8.8),('10318','2013-04-19','11:45:00',8.76),('10318','2013-04-19','11:50:00',8.76),('10318','2013-04-19','11:55:00',8.85),('10318','2013-04-19','12:00:00',8.93),('10318','2013-04-19','12:05:00',8.91),('10318','2013-04-19','12:10:00',8.85),('10318','2013-04-19','12:15:00',8.91),('10318','2013-04-19','12:20:00',8.98),('10318','2013-04-19','12:25:00',9.05),('10318','2013-04-19','12:30:00',8.88),('10318','2013-04-19','12:35:00',8.9),('10318','2013-04-19','12:40:00',8.86),('10318','2013-04-19','12:45:00',8.84),('10318','2013-04-19','12:50:00',9.19),('10318','2013-04-19','12:55:00',9.14),('10318','2013-04-19','13:00:00',9.08),('10318','2013-04-19','13:05:00',8.98),('10318','2013-04-19','13:10:00',8.94),('10318','2013-04-19','13:15:00',8.82),('10318','2013-04-19','13:20:00',9.02),('10318','2013-04-19','13:25:00',8.94),('10318','2013-04-19','13:30:00',8.78),('10318','2013-04-19','13:35:00',8.74),('10318','2013-04-19','13:40:00',8.77),('10318','2013-04-19','13:45:00',8.67),('10318','2013-04-19','13:50:00',8.51),('10318','2013-04-19','13:55:00',8.53),('10318','2013-04-19','14:00:00',8.46),('10318','2013-04-19','14:05:00',8.41),('10318','2013-04-19','14:10:00',8.32),('10318','2013-04-19','14:15:00',8.22),('10318','2013-04-19','14:20:00',8.15),('10318','2013-04-19','14:25:00',8.06),('10318','2013-04-19','14:30:00',7.89),('10318','2013-04-19','14:35:00',7.85),('10318','2013-04-19','14:40:00',7.76),('10318','2013-04-19','14:45:00',7.77),('10318','2013-04-19','14:50:00',7.66),('10318','2013-04-19','14:55:00',7.58),('10318','2013-04-19','15:00:00',7.21),('10318','2013-04-19','15:05:00',7.34),('10318','2013-04-19','15:10:00',7.26),('10318','2013-04-19','15:15:00',7.18),('10318','2013-04-19','15:20:00',7.06),('10318','2013-04-19','15:25:00',6.92),('10318','2013-04-19','15:30:00',6.86),('10318','2013-04-19','15:35:00',6.7),('10318','2013-04-19','15:40:00',6.54),('10318','2013-04-19','15:45:00',6.39),('10318','2013-04-19','15:50:00',6.21),('10318','2013-04-19','15:55:00',6.04),('10318','2013-04-19','16:00:00',5.86),('10318','2013-04-19','16:05:00',5.72),('10318','2013-04-19','16:10:00',5.58),('10318','2013-04-19','16:15:00',5.41),('10318','2013-04-19','16:20:00',5.21),('10318','2013-04-19','16:25:00',5.05),('10318','2013-04-19','16:30:00',4.92),('10318','2013-04-19','16:35:00',4.74),('10318','2013-04-19','16:40:00',4.53),('10318','2013-04-19','16:45:00',4.29),('10318','2013-04-19','16:50:00',4.06),('10318','2013-04-19','16:55:00',3.96),('10318','2013-04-19','17:00:00',3.8),('10318','2013-04-19','17:05:00',3.6),('10318','2013-04-19','17:10:00',3.4),('10318','2013-04-19','17:15:00',3.24),('10318','2013-04-19','17:20:00',3.06),('10318','2013-04-19','17:25:00',2.87),('10318','2013-04-19','17:30:00',2.74),('10318','2013-04-19','17:35:00',2.55),('10318','2013-04-19','17:40:00',2.37),('10318','2013-04-19','17:45:00',2.25),('10318','2013-04-19','17:50:00',2.09),('10318','2013-04-19','17:55:00',1.95),('10318','2013-04-19','18:00:00',1.81),('10318','2013-04-19','18:05:00',1.64),('10318','2013-04-19','18:10:00',1.56),('10318','2013-04-19','18:15:00',1.42),('10318','2013-04-19','18:20:00',1.33),('10318','2013-04-19','18:25:00',1.21),('10318','2013-04-19','18:30:00',1.11),('10318','2013-04-18','07:35:00',1.15),('10318','2013-04-18','07:40:00',1.25),('10318','2013-04-18','07:45:00',1.36),('10318','2013-04-18','07:50:00',1.57),('10318','2013-04-18','07:55:00',1.84),('10318','2013-04-18','08:00:00',2.1),('10318','2013-04-18','08:05:00',2.94),('10318','2013-04-18','08:10:00',3.32),('10318','2013-04-18','08:15:00',2.97),('10318','2013-04-18','08:20:00',3.16),('10318','2013-04-18','08:25:00',3.27),('10318','2013-04-18','08:30:00',3.53),('10318','2013-04-18','08:35:00',3.78),('10318','2013-04-18','08:40:00',3.52),('10318','2013-04-18','08:45:00',3.88),('10318','2013-04-18','08:50:00',4.19),('10318','2013-04-18','08:55:00',4.11),('10318','2013-04-18','09:00:00',4.59),('10318','2013-04-18','09:05:00',4.85),('10318','2013-04-18','09:10:00',5.47),('10318','2013-04-18','09:15:00',5.49),('10318','2013-04-18','09:20:00',5.11),('10318','2013-04-18','09:25:00',5.16),('10318','2013-04-18','09:30:00',5.24),('10318','2013-04-18','09:35:00',5.63),('10318','2013-04-18','09:40:00',6),('10318','2013-04-18','09:45:00',6.4),('10318','2013-04-18','09:50:00',6.68),('10318','2013-04-18','09:55:00',7.19),('10318','2013-04-18','10:00:00',6.52),('10318','2013-04-18','10:05:00',7.03),('10318','2013-04-18','10:10:00',7.35),('10318','2013-04-18','10:15:00',7.99),('10318','2013-04-18','10:20:00',8.13),('10318','2013-04-18','10:25:00',8.11),('10318','2013-04-18','10:30:00',8.05),('10318','2013-04-18','10:35:00',8.3),('10318','2013-04-18','10:40:00',8.37),('10318','2013-04-18','10:45:00',8.46),('10318','2013-04-18','10:50:00',8.53),('10318','2013-04-18','10:55:00',8.62),('10318','2013-04-18','11:00:00',8.7),('10318','2013-04-18','11:05:00',8.76),('10318','2013-04-18','11:10:00',8.78),('10318','2013-04-18','11:15:00',8.81),('10318','2013-04-18','11:20:00',8.82),('10318','2013-04-18','11:25:00',8.8),('10318','2013-04-18','11:30:00',8.7),('10318','2013-04-18','11:35:00',8.86),('10318','2013-04-18','11:40:00',8.95),('10318','2013-04-18','11:45:00',9.03),('10318','2013-04-18','11:50:00',9.2),('10318','2013-04-18','11:55:00',9.28),('10318','2013-04-18','12:00:00',9.09),('10318','2013-04-18','12:05:00',9.31),('10318','2013-04-18','12:10:00',9.29),('10318','2013-04-18','12:15:00',9.18),('10318','2013-04-18','12:20:00',9.32),('10318','2013-04-18','12:25:00',9.4),('10318','2013-04-18','12:30:00',9.34),('10318','2013-04-18','12:35:00',9.32),('10318','2013-04-18','12:40:00',9.34),('10318','2013-04-18','12:45:00',9.35),('10318','2013-04-18','12:50:00',9.38),('10318','2013-04-18','12:55:00',9.31),('10318','2013-04-18','13:00:00',9.27),('10318','2013-04-18','13:05:00',9.35),('10318','2013-04-18','13:10:00',9.31),('10318','2013-04-18','13:15:00',9.26),('10318','2013-04-18','13:20:00',9.19),('10318','2013-04-18','13:25:00',9.17),('10318','2013-04-18','13:30:00',8.94),('10318','2013-04-18','13:35:00',9.13),('10318','2013-04-18','13:40:00',9.09),('10318','2013-04-18','13:45:00',9.01),('10318','2013-04-18','13:50:00',8.94),('10318','2013-04-18','13:55:00',8.88),('10318','2013-04-18','14:00:00',8.85),('10318','2013-04-18','14:05:00',8.8),('10318','2013-04-18','14:10:00',8.74),('10318','2013-04-18','14:15:00',8.67),('10318','2013-04-18','14:20:00',8.61),('10318','2013-04-18','14:25:00',8.54),('10318','2013-04-18','14:30:00',8.43),('10318','2013-04-18','14:35:00',8.35),('10318','2013-04-18','14:40:00',8.25),('10318','2013-04-18','14:45:00',8.14),('10318','2013-04-18','14:50:00',8.04),('10318','2013-04-18','14:55:00',7.95),('10318','2013-04-18','15:00:00',7.8),('10318','2013-04-18','15:05:00',7.69),('10318','2013-04-18','15:10:00',7.56),('10318','2013-04-18','15:15:00',7.3),('10318','2013-04-18','15:20:00',7.28),('10318','2013-04-18','15:25:00',7.13),('10318','2013-04-18','15:30:00',6.98),('10318','2013-04-18','15:35:00',6.81),('10318','2013-04-18','15:40:00',6.66),('10318','2013-04-18','15:45:00',6.52),('10318','2013-04-18','15:50:00',6.41),('10318','2013-04-18','15:55:00',6.27),('10318','2013-04-18','16:00:00',6.07),('10318','2013-04-18','16:05:00',5.88),('10318','2013-04-18','16:10:00',5.77),('10318','2013-04-18','16:15:00',5.61),('10318','2013-04-18','16:20:00',5.42),('10318','2013-04-18','16:25:00',5.23),('10318','2013-04-18','16:30:00',5.06),('10318','2013-04-18','16:35:00',4.88),('10318','2013-04-18','16:40:00',4.72),('10318','2013-04-18','16:45:00',4.51),('10318','2013-04-18','16:50:00',4.32),('10318','2013-04-18','16:55:00',4.15),('10318','2013-04-18','17:00:00',3.91),('10318','2013-04-18','17:05:00',3.77),('10318','2013-04-18','17:10:00',3.59),('10318','2013-04-18','17:15:00',3.39),('10318','2013-04-18','17:20:00',3.21),('10318','2013-04-18','17:25:00',3.04),('10318','2013-04-18','17:30:00',2.85),('10318','2013-04-18','17:35:00',2.7),('10318','2013-04-18','17:40:00',2.52),('10318','2013-04-18','17:45:00',2.35),('10318','2013-04-18','17:50:00',2.17),('10318','2013-04-18','17:55:00',2.01),('10318','2013-04-18','18:00:00',1.82),('10318','2013-04-18','18:05:00',1.67),('10318','2013-04-18','18:10:00',1.52),('10318','2013-04-18','18:15:00',1.37),('10318','2013-04-18','18:20:00',1.24),('10318','2013-04-18','18:25:00',1.1),('10318','2013-04-17','07:35:00',1.58),('10318','2013-04-17','07:40:00',1.9),('10318','2013-04-17','07:45:00',2.51),('10318','2013-04-17','07:50:00',2.8),('10318','2013-04-17','07:55:00',3.07),('10318','2013-04-17','08:00:00',3.35),('10318','2013-04-17','08:05:00',3.58),('10318','2013-04-17','08:10:00',3.8),('10318','2013-04-17','08:15:00',4),('10318','2013-04-17','08:20:00',4.21),('10318','2013-04-17','08:25:00',4.42),('10318','2013-04-17','08:30:00',4.65),('10318','2013-04-17','08:35:00',4.84),('10318','2013-04-17','08:40:00',5.03),('10318','2013-04-17','08:45:00',5.23),('10318','2013-04-17','08:50:00',5.33),('10318','2013-04-17','08:55:00',5.59),('10318','2013-04-17','09:00:00',5.78),('10318','2013-04-17','09:05:00',5.98),('10318','2013-04-17','09:10:00',6.17),('10318','2013-04-17','09:15:00',6.32),('10318','2013-04-17','09:20:00',6.48),('10318','2013-04-17','09:25:00',6.66),('10318','2013-04-17','09:30:00',6.8),('10318','2013-04-17','09:35:00',6.94),('10318','2013-04-17','09:40:00',7.07),('10318','2013-04-17','09:45:00',7.19),('10318','2013-04-17','09:50:00',7.34),('10318','2013-04-17','09:55:00',7.48),('10318','2013-04-17','10:00:00',7.63),('10318','2013-04-17','10:05:00',7.71),('10318','2013-04-17','10:10:00',7.87),('10318','2013-04-17','10:15:00',7.93),('10318','2013-04-17','10:20:00',8.03),('10318','2013-04-17','10:25:00',8.17),('10318','2013-04-17','10:30:00',8.28),('10318','2013-04-17','10:35:00',8.11),('10318','2013-04-17','10:40:00',8.43),('10318','2013-04-17','10:45:00',8.53),('10318','2013-04-17','10:50:00',8.59),('10318','2013-04-17','10:55:00',8.65),('10318','2013-04-17','11:00:00',8.7),('10318','2013-04-17','11:05:00',8.79),('10318','2013-04-17','11:10:00',8.88),('10318','2013-04-17','11:15:00',8.94),('10318','2013-04-17','11:20:00',8.97),('10318','2013-04-17','11:25:00',9.03),('10318','2013-04-17','11:30:00',9.06),('10318','2013-04-17','11:35:00',9.11),('10318','2013-04-17','11:40:00',9.14),('10318','2013-04-17','11:45:00',9.15),('10318','2013-04-17','11:50:00',9.18),('10318','2013-04-17','11:55:00',9.2),('10318','2013-04-17','12:00:00',9.25),('10318','2013-04-17','12:05:00',9.31),('10318','2013-04-17','12:10:00',9.32),('10318','2013-04-17','12:15:00',9.33),('10318','2013-04-17','12:20:00',9.16),('10318','2013-04-17','12:25:00',9.35),('10318','2013-04-17','12:30:00',9.41),('10318','2013-04-17','12:35:00',9.34),('10318','2013-04-17','12:40:00',9.34),('10318','2013-04-17','12:45:00',9.32),('10318','2013-04-17','12:50:00',9.31),('10318','2013-04-17','12:55:00',9.35),('10318','2013-04-17','13:00:00',9.24),('10318','2013-04-17','13:05:00',9.3),('10318','2013-04-17','13:10:00',9.28),('10318','2013-04-17','13:15:00',9.21),('10318','2013-04-17','13:20:00',9.19),('10318','2013-04-17','13:25:00',9.23),('10318','2013-04-17','13:30:00',9.02),('10318','2013-04-17','13:35:00',9.1),('10318','2013-04-17','13:40:00',9.11),('10318','2013-04-17','13:45:00',8.54),('10318','2013-04-17','13:50:00',9.07),('10318','2013-04-17','13:55:00',8.32),('10318','2013-04-17','14:00:00',8.57),('10318','2013-04-17','14:05:00',9.28),('10318','2013-04-17','14:10:00',9.51),('10318','2013-04-17','14:15:00',9.33),('10318','2013-04-17','14:20:00',8.97),('10318','2013-04-17','14:25:00',8.97),('10318','2013-04-17','14:30:00',7.14),('10318','2013-04-17','14:35:00',8.34),('10318','2013-04-17','14:40:00',7.92),('10318','2013-04-17','14:45:00',8.34),('10318','2013-04-17','14:50:00',8),('10318','2013-04-17','14:55:00',8.7),('10318','2013-04-17','15:00:00',8.6),('10318','2013-04-17','15:05:00',8.63),('10318','2013-04-17','15:10:00',8.54),('10318','2013-04-17','15:15:00',7.65),('10318','2013-04-17','15:20:00',4.35),('10318','2013-04-17','15:25:00',3.56),('10318','2013-04-17','15:30:00',6.11),('10318','2013-04-17','15:35:00',6.91),('10318','2013-04-17','15:40:00',7.24),('10318','2013-04-17','15:45:00',7.2),('10318','2013-04-17','15:50:00',7.06),('10318','2013-04-17','15:55:00',6.97),('10318','2013-04-17','16:00:00',6.83),('10318','2013-04-17','16:05:00',5.4),('10318','2013-04-17','16:10:00',6.18),('10318','2013-04-17','16:15:00',6.06),('10318','2013-04-17','16:20:00',5.77),('10318','2013-04-17','16:25:00',5.56),('10318','2013-04-17','16:30:00',5.37),('10318','2013-04-17','16:35:00',5.19),('10318','2013-04-17','16:40:00',4.2),('10318','2013-04-17','16:45:00',4.88),('10318','2013-04-17','16:50:00',4.57),('10318','2013-04-17','16:55:00',4.31),('10318','2013-04-17','17:00:00',4.07),('10318','2013-04-17','17:05:00',3.81),('10318','2013-04-17','17:10:00',3.67),('10318','2013-04-17','17:15:00',3.47),('10318','2013-04-17','17:20:00',3.28),('10318','2013-04-17','17:25:00',3.09),('10318','2013-04-17','17:30:00',2.89),('10318','2013-04-17','17:35:00',2.7),('10318','2013-04-17','17:40:00',2.53),('10318','2013-04-17','17:45:00',2.33),('10318','2013-04-17','17:50:00',2.16),('10318','2013-04-17','17:55:00',1.99),('10318','2013-04-17','18:00:00',1.86),('10318','2013-04-17','18:05:00',1.68),('10318','2013-04-17','18:10:00',1.53),('10318','2013-04-17','18:15:00',1.41),('10318','2013-04-17','18:20:00',1.27),('10318','2013-04-17','18:25:00',1.13),('10318','2013-04-16','07:35:00',1.13),('10318','2013-04-16','07:40:00',1.63),('10318','2013-04-16','07:45:00',2.1),('10318','2013-04-16','07:50:00',2.34),('10318','2013-04-16','07:55:00',2.57),('10318','2013-04-16','08:00:00',2.88),('10318','2013-04-16','08:05:00',3.29),('10318','2013-04-16','08:10:00',3.8),('10318','2013-04-16','08:15:00',3.58),('10318','2013-04-16','08:20:00',1.82),('10318','2013-04-16','08:25:00',1.67),('10318','2013-04-16','08:30:00',1.97),('10318','2013-04-16','08:35:00',1.81),('10318','2013-04-16','08:40:00',1.83),('10318','2013-04-16','08:45:00',2.26),('10318','2013-04-16','08:50:00',2.62),('10318','2013-04-16','08:55:00',2.23),('10318','2013-04-16','09:00:00',1.93),('10318','2013-04-16','09:05:00',1.8),('10318','2013-04-16','09:10:00',4.62),('10318','2013-04-16','09:15:00',6.55),('10318','2013-04-16','09:20:00',5.13),('10318','2013-04-16','09:25:00',6.67),('10318','2013-04-16','09:30:00',4.25),('10318','2013-04-16','09:35:00',4.39),('10318','2013-04-16','09:40:00',4.5),('10318','2013-04-16','09:45:00',4.08),('10318','2013-04-16','09:50:00',3.54),('10318','2013-04-16','09:55:00',3.27),('10318','2013-04-16','10:00:00',3.01),('10318','2013-04-16','10:05:00',2.95),('10318','2013-04-16','10:10:00',3.18),('10318','2013-04-16','10:15:00',3.37),('10318','2013-04-16','10:20:00',3.5),('10318','2013-04-16','10:25:00',3.5),('10318','2013-04-16','10:30:00',3.48),('10318','2013-04-16','10:35:00',3.55),('10318','2013-04-16','10:40:00',3.56),('10318','2013-04-16','10:45:00',3.53),('10318','2013-04-16','10:50:00',3.51),('10318','2013-04-16','10:55:00',3.73),('10318','2013-04-16','11:00:00',3.95),('10318','2013-04-16','11:05:00',4.14),('10318','2013-04-16','11:10:00',4),('10318','2013-04-16','11:15:00',4.03),('10318','2013-04-16','11:20:00',4.12),('10318','2013-04-16','11:25:00',4.04),('10318','2013-04-16','11:30:00',3.93),('10318','2013-04-16','11:35:00',3.74),('10318','2013-04-16','11:40:00',4.16),('10318','2013-04-16','11:45:00',4.81),('10318','2013-04-16','11:50:00',5.36),('10318','2013-04-16','11:55:00',5.63),('10318','2013-04-16','12:00:00',6.09),('10318','2013-04-16','12:05:00',6.77),('10318','2013-04-16','12:10:00',6.47),('10318','2013-04-16','12:15:00',6.84),('10318','2013-04-16','12:20:00',6.49),('10318','2013-04-16','12:25:00',6.48),('10318','2013-04-16','12:30:00',6),('10318','2013-04-16','12:35:00',5.84),('10318','2013-04-16','12:40:00',6.28),('10318','2013-04-16','12:45:00',6.79),('10318','2013-04-16','12:50:00',6.54),('10318','2013-04-16','12:55:00',9.32),('10318','2013-04-16','13:00:00',9.2),('10318','2013-04-16','13:05:00',9.15),('10318','2013-04-16','13:10:00',8.65),('10318','2013-04-16','13:15:00',8.98),('10318','2013-04-16','13:20:00',8.99),('10318','2013-04-16','13:25:00',9.01),('10318','2013-04-16','13:30:00',8.76),('10318','2013-04-16','13:35:00',8.87),('10318','2013-04-16','13:40:00',8.7),('10318','2013-04-16','13:45:00',8.69),('10318','2013-04-16','13:50:00',8.73),('10318','2013-04-16','13:55:00',8.52),('10318','2013-04-16','14:00:00',8.69),('10318','2013-04-16','14:05:00',8.66),('10318','2013-04-16','14:10:00',8.55),('10318','2013-04-16','14:15:00',8.53),('10318','2013-04-16','14:20:00',8.67),('10318','2013-04-16','14:25:00',7.88),('10318','2013-04-16','14:30:00',8.08),('10318','2013-04-16','14:35:00',6.2),('10318','2013-04-16','14:40:00',7.92),('10318','2013-04-16','14:45:00',7.98),('10318','2013-04-16','14:50:00',7.67),('10318','2013-04-16','14:55:00',7.72),('10318','2013-04-16','15:00:00',7.43),('10318','2013-04-16','15:05:00',7.71),('10318','2013-04-16','15:10:00',7.64),('10318','2013-04-16','15:15:00',7.45),('10318','2013-04-16','15:20:00',6.11),('10318','2013-04-16','15:25:00',5.96),('10318','2013-04-16','15:30:00',6.6),('10318','2013-04-16','15:35:00',6.58),('10318','2013-04-16','15:40:00',6.65),('10318','2013-04-16','15:45:00',6.47),('10318','2013-04-16','15:50:00',6.23),('10318','2013-04-16','15:55:00',6.18),('10318','2013-04-16','16:00:00',6.03),('10318','2013-04-16','16:05:00',5.92),('10318','2013-04-16','16:10:00',5.43),('10318','2013-04-16','16:15:00',5.58),('10318','2013-04-16','16:20:00',5.4),('10318','2013-04-16','16:25:00',5.17),('10318','2013-04-16','16:30:00',5.06),('10318','2013-04-16','16:35:00',4.96),('10318','2013-04-16','16:40:00',4.78),('10318','2013-04-16','16:45:00',4.89),('10318','2013-04-16','16:50:00',4.54),('10318','2013-04-16','16:55:00',3.84),('10318','2013-04-16','17:00:00',4.04),('10318','2013-04-16','17:05:00',4),('10318','2013-04-16','17:10:00',3.87),('10318','2013-04-16','17:15:00',3.71),('10318','2013-04-16','17:20:00',2.98),('10318','2013-04-16','17:25:00',3.47),('10318','2013-04-16','17:30:00',3.16),('10318','2013-04-16','17:35:00',3.25),('10318','2013-04-16','17:40:00',2.92),('10318','2013-04-16','17:45:00',2.68),('10318','2013-04-16','17:50:00',2.41),('10318','2013-04-16','17:55:00',2.15),('10318','2013-04-16','18:00:00',1.97),('10318','2013-04-16','18:05:00',1.87),('10318','2013-04-16','18:10:00',1.66),('10318','2013-04-16','18:15:00',1.37),('10318','2013-04-16','18:20:00',1.12),('10318','2013-04-16','18:25:00',1.07),('10318','2013-04-15','07:35:00',1.2),('10318','2013-04-15','07:40:00',1.87),('10318','2013-04-15','07:45:00',2.44),('10318','2013-04-15','07:50:00',2.81),('10318','2013-04-15','07:55:00',3.03),('10318','2013-04-15','08:00:00',3.31),('10318','2013-04-15','08:05:00',3.54),('10318','2013-04-15','08:10:00',3.76),('10318','2013-04-15','08:15:00',3.97),('10318','2013-04-15','08:20:00',4.13),('10318','2013-04-15','08:25:00',4.38),('10318','2013-04-15','08:30:00',4.61),('10318','2013-04-15','08:35:00',4.78),('10318','2013-04-15','08:40:00',5.04),('10318','2013-04-15','08:45:00',5.24),('10318','2013-04-15','08:50:00',5.45),('10318','2013-04-15','08:55:00',5.67),('10318','2013-04-15','09:00:00',5.86),('10318','2013-04-15','09:05:00',6.03),('10318','2013-04-15','09:10:00',6.19),('10318','2013-04-15','09:15:00',6.35),('10318','2013-04-15','09:20:00',6.5),('10318','2013-04-15','09:25:00',6.66),('10318','2013-04-15','09:30:00',6.81),('10318','2013-04-15','09:35:00',6.9),('10318','2013-04-15','09:40:00',7.08),('10318','2013-04-15','09:45:00',7.22),('10318','2013-04-15','09:50:00',7.33),('10318','2013-04-15','09:55:00',7.44),('10318','2013-04-15','10:00:00',7.58),('10318','2013-04-15','10:05:00',7.7),('10318','2013-04-15','10:10:00',7.8),('10318','2013-04-15','10:15:00',7.95),('10318','2013-04-15','10:20:00',8.07),('10318','2013-04-15','10:25:00',8.16),('10318','2013-04-15','10:30:00',8.26),('10318','2013-04-15','10:35:00',8.35),('10318','2013-04-15','10:40:00',8.4),('10318','2013-04-15','10:45:00',8.47),('10318','2013-04-15','10:50:00',8.56),('10318','2013-04-15','10:55:00',8.65),('10318','2013-04-15','11:00:00',8.75),('10318','2013-04-15','11:05:00',8.81),('10318','2013-04-15','11:10:00',8.86),('10318','2013-04-15','11:15:00',8.91),('10318','2013-04-15','11:20:00',8.97),('10318','2013-04-15','11:25:00',8.87),('10318','2013-04-15','11:30:00',9.02),('10318','2013-04-15','11:35:00',9.06),('10318','2013-04-15','11:40:00',9.12),('10318','2013-04-15','11:45:00',9.15),('10318','2013-04-15','11:50:00',9.15),('10318','2013-04-15','11:55:00',9.17),('10318','2013-04-15','12:00:00',9.17),('10318','2013-04-15','12:05:00',9.2),('10318','2013-04-15','12:10:00',9.18),('10318','2013-04-15','12:15:00',9.16),('10318','2013-04-15','12:20:00',9.12),('10318','2013-04-15','12:25:00',9.16),('10318','2013-04-15','12:30:00',9.21),('10318','2013-04-15','12:35:00',9.27),('10318','2013-04-15','12:40:00',9.24),('10318','2013-04-15','12:45:00',9.22),('10318','2013-04-15','12:50:00',9.21),('10318','2013-04-15','12:55:00',9.23),('10318','2013-04-15','13:00:00',9.23),('10318','2013-04-15','13:05:00',9.17),('10318','2013-04-15','13:10:00',8.96),('10318','2013-04-15','13:15:00',9.16),('10318','2013-04-15','13:20:00',9.17),('10318','2013-04-15','13:25:00',9.1),('10318','2013-04-15','13:30:00',9.07),('10318','2013-04-15','13:35:00',9.02),('10318','2013-04-15','13:40:00',8.96),('10318','2013-04-15','13:45:00',8.93),('10318','2013-04-15','13:50:00',8.94),('10318','2013-04-15','13:55:00',9),('10318','2013-04-15','14:00:00',8.94),('10318','2013-04-15','14:05:00',8.86),('10318','2013-04-15','14:10:00',8.78),('10318','2013-04-15','14:15:00',8.73),('10318','2013-04-15','14:20:00',8.66),('10318','2013-04-15','14:25:00',8.52),('10318','2013-04-15','14:30:00',8.44),('10318','2013-04-15','14:35:00',8.4),('10318','2013-04-15','14:40:00',8.29),('10318','2013-04-15','14:45:00',8.16),('10318','2013-04-15','14:50:00',8.06),('10318','2013-04-15','14:55:00',7.73),('10318','2013-04-15','15:00:00',7.86),('10318','2013-04-15','15:05:00',7.72),('10318','2013-04-15','15:10:00',7.64),('10318','2013-04-15','15:15:00',7.53),('10318','2013-04-15','15:20:00',7.38),('10318','2013-04-15','15:25:00',7.23),('10318','2013-04-15','15:30:00',7.12),('10318','2013-04-15','15:35:00',6.96),('10318','2013-04-15','15:40:00',6.81),('10318','2013-04-15','15:45:00',6.65),('10318','2013-04-15','15:50:00',6.49),('10318','2013-04-15','15:55:00',6.34),('10318','2013-04-15','16:00:00',6.2),('10318','2013-04-15','16:05:00',6),('10318','2013-04-15','16:10:00',5.82),('10318','2013-04-15','16:15:00',5.64),('10318','2013-04-15','16:20:00',5.46),('10318','2013-04-15','16:25:00',5.3),('10318','2013-04-15','16:30:00',5.12),('10318','2013-04-15','16:35:00',4.93),('10318','2013-04-15','16:40:00',4.65),('10318','2013-04-15','16:45:00',4.54),('10318','2013-04-15','16:50:00',4.34),('10318','2013-04-15','16:55:00',4.19),('10318','2013-04-15','17:00:00',4.01),('10318','2013-04-15','17:05:00',3.82),('10318','2013-04-15','17:10:00',3.62),('10318','2013-04-15','17:15:00',3.45),('10318','2013-04-15','17:20:00',3.25),('10318','2013-04-15','17:25:00',3.05),('10318','2013-04-15','17:30:00',2.86),('10318','2013-04-15','17:35:00',2.67),('10318','2013-04-15','17:40:00',2.44),('10318','2013-04-15','17:45:00',2.29),('10318','2013-04-15','17:50:00',2.16),('10318','2013-04-15','17:55:00',2),('10318','2013-04-15','18:00:00',1.83),('10318','2013-04-15','18:05:00',1.7),('10318','2013-04-15','18:10:00',1.54),('10318','2013-04-15','18:15:00',1.38),('10318','2013-04-15','18:20:00',1.24),('10318','2013-04-15','18:25:00',1.11),('10318','2013-04-14','07:30:00',1.01),('10318','2013-04-14','07:35:00',1.19),('10318','2013-04-14','07:40:00',1.64),('10318','2013-04-14','07:45:00',2.13),('10318','2013-04-14','07:50:00',2.55),('10318','2013-04-14','07:55:00',2.8),('10318','2013-04-14','08:00:00',3),('10318','2013-04-14','08:05:00',3.19),('10318','2013-04-14','08:10:00',3.44),('10318','2013-04-14','08:15:00',3.71),('10318','2013-04-14','08:20:00',3.91),('10318','2013-04-14','08:25:00',4.12),('10318','2013-04-14','08:30:00',4.33),('10318','2013-04-14','08:35:00',4.52),('10318','2013-04-14','08:40:00',4.74),('10318','2013-04-14','08:45:00',4.94),('10318','2013-04-14','08:50:00',5.12),('10318','2013-04-14','08:55:00',5.3),('10318','2013-04-14','09:00:00',5.48),('10318','2013-04-14','09:05:00',5.69),('10318','2013-04-14','09:10:00',5.73),('10318','2013-04-14','09:15:00',6.03),('10318','2013-04-14','09:20:00',6.19),('10318','2013-04-14','09:25:00',6.34),('10318','2013-04-14','09:30:00',6.48),('10318','2013-04-14','09:35:00',6.65),('10318','2013-04-14','09:40:00',6.8),('10318','2013-04-14','09:45:00',6.93),('10318','2013-04-14','09:50:00',7.09),('10318','2013-04-14','09:55:00',7.27),('10318','2013-04-14','10:00:00',7.34),('10318','2013-04-14','10:05:00',7.47),('10318','2013-04-14','10:10:00',7.63),('10318','2013-04-14','10:15:00',7.77),('10318','2013-04-14','10:20:00',7.92),('10318','2013-04-14','10:25:00',8.02),('10318','2013-04-14','10:30:00',8.09),('10318','2013-04-14','10:35:00',8.2),('10318','2013-04-14','10:40:00',8.28),('10318','2013-04-14','10:45:00',8.36),('10318','2013-04-14','10:50:00',8.42),('10318','2013-04-14','10:55:00',8.32),('10318','2013-04-14','11:00:00',8.67),('10318','2013-04-14','11:05:00',8.7),('10318','2013-04-14','11:10:00',8.75),('10318','2013-04-14','11:15:00',8.84),('10318','2013-04-14','11:20:00',8.82),('10318','2013-04-14','11:25:00',8.92),('10318','2013-04-14','11:30:00',8.96),('10318','2013-04-14','11:35:00',9.04),('10318','2013-04-14','11:40:00',9.05),('10318','2013-04-14','11:45:00',9.05),('10318','2013-04-14','11:50:00',9.07),('10318','2013-04-14','11:55:00',9.09),('10318','2013-04-14','12:00:00',9.08),('10318','2013-04-14','12:05:00',9.09),('10318','2013-04-14','12:10:00',9.01),('10318','2013-04-14','12:15:00',8.99),('10318','2013-04-14','12:20:00',8.88),('10318','2013-04-14','12:25:00',9.19),('10318','2013-04-14','12:30:00',9.27),('10318','2013-04-14','12:35:00',9.27),('10318','2013-04-14','12:40:00',9.25),('10318','2013-04-14','12:45:00',9.35),('10318','2013-04-14','12:50:00',9.29),('10318','2013-04-14','12:55:00',9.2),('10318','2013-04-14','13:00:00',9.37),('10318','2013-04-14','13:05:00',9.23),('10318','2013-04-14','13:10:00',7.13),('10318','2013-04-14','13:15:00',9.37),('10318','2013-04-14','13:20:00',9.45),('10318','2013-04-14','13:25:00',9.22),('10318','2013-04-14','13:30:00',9.04),('10318','2013-04-14','13:35:00',9.1),('10318','2013-04-14','13:40:00',9.14),('10318','2013-04-14','13:45:00',7.34),('10318','2013-04-14','13:50:00',8.97),('10318','2013-04-14','13:55:00',8.73),('10318','2013-04-14','14:00:00',8.77),('10318','2013-04-14','14:05:00',8.75),('10318','2013-04-14','14:10:00',8.65),('10318','2013-04-14','14:15:00',8.55),('10318','2013-04-14','14:20:00',8.42),('10318','2013-04-14','14:25:00',8.34),('10318','2013-04-14','14:30:00',8.32),('10318','2013-04-14','14:35:00',8.33),('10318','2013-04-14','14:40:00',8.07),('10318','2013-04-14','14:45:00',7.32),('10318','2013-04-14','14:50:00',7.93),('10318','2013-04-14','14:55:00',6.4),('10318','2013-04-14','15:00:00',6.81),('10318','2013-04-14','15:05:00',6.68),('10318','2013-04-14','15:10:00',7.61),('10318','2013-04-14','15:15:00',7.46),('10318','2013-04-14','15:20:00',7.53),('10318','2013-04-14','15:25:00',7.06),('10318','2013-04-14','15:30:00',6.96),('10318','2013-04-14','15:35:00',7.05),('10318','2013-04-14','15:40:00',6.88),('10318','2013-04-14','15:45:00',6.95),('10318','2013-04-14','15:50:00',6.61),('10318','2013-04-14','15:55:00',6.29),('10318','2013-04-14','16:00:00',6),('10318','2013-04-14','16:05:00',5.85),('10318','2013-04-14','16:10:00',5.65),('10318','2013-04-14','16:15:00',5.6),('10318','2013-04-14','16:20:00',5.43),('10318','2013-04-14','16:25:00',5.16),('10318','2013-04-14','16:30:00',4.99),('10318','2013-04-14','16:35:00',4.77),('10318','2013-04-14','16:40:00',4.59),('10318','2013-04-14','16:45:00',4.45),('10318','2013-04-14','16:50:00',4.26),('10318','2013-04-14','16:55:00',4.07),('10318','2013-04-14','17:00:00',3.89),('10318','2013-04-14','17:05:00',3.67),('10318','2013-04-14','17:10:00',3.5),('10318','2013-04-14','17:15:00',3.33),('10318','2013-04-14','17:20:00',3.15),('10318','2013-04-14','17:25:00',2.93),('10318','2013-04-14','17:30:00',2.78),('10318','2013-04-14','17:35:00',2.61),('10318','2013-04-14','17:40:00',2.44),('10318','2013-04-14','17:45:00',2.29),('10318','2013-04-14','17:50:00',2.12),('10318','2013-04-14','17:55:00',1.94),('10318','2013-04-14','18:00:00',1.78),('10318','2013-04-14','18:05:00',1.62),('10318','2013-04-14','18:10:00',1.5),('10318','2013-04-14','18:15:00',1.37),('10318','2013-04-14','18:20:00',1.23),('10318','2013-04-14','18:25:00',1.11),('10318','2013-04-13','07:35:00',1.08),('10318','2013-04-13','07:40:00',1.31),('10318','2013-04-13','07:45:00',1.88),('10318','2013-04-13','07:50:00',2.32),('10318','2013-04-13','07:55:00',2.57),('10318','2013-04-13','08:00:00',2.77),('10318','2013-04-13','08:05:00',3.08),('10318','2013-04-13','08:10:00',3.3),('10318','2013-04-13','08:15:00',1.96),('10318','2013-04-13','08:20:00',1.36),('10318','2013-04-13','08:25:00',1.15),('10318','2013-04-13','08:30:00',1.65),('10318','2013-04-13','08:35:00',1.81),('10318','2013-04-13','08:40:00',1.6),('10318','2013-04-13','08:45:00',1.9),('10318','2013-04-13','08:50:00',2.35),('10318','2013-04-13','08:55:00',3.83),('10318','2013-04-13','09:00:00',1.92),('10318','2013-04-13','09:05:00',2.7),('10318','2013-04-13','09:10:00',6.26),('10318','2013-04-13','09:15:00',3.76),('10318','2013-04-13','09:20:00',6.16),('10318','2013-04-13','09:25:00',6.23),('10318','2013-04-13','09:30:00',6.41),('10318','2013-04-13','09:35:00',6.07),('10318','2013-04-13','09:40:00',6.54),('10318','2013-04-13','09:45:00',7.06),('10318','2013-04-13','09:50:00',7.17),('10318','2013-04-13','09:55:00',7.39),('10318','2013-04-13','10:00:00',6.88),('10318','2013-04-13','10:05:00',8.27),('10318','2013-04-13','10:10:00',5.47),('10318','2013-04-13','10:15:00',5.45),('10318','2013-04-13','10:20:00',3.56),('10318','2013-04-13','10:25:00',6.66),('10318','2013-04-13','10:30:00',9.21),('10318','2013-04-13','10:35:00',7.63),('10318','2013-04-13','10:40:00',8.93),('10318','2013-04-13','10:45:00',9.05),('10318','2013-04-13','10:50:00',7.3),('10318','2013-04-13','10:55:00',3.31),('10318','2013-04-13','11:00:00',5.23),('10318','2013-04-13','11:05:00',9.22),('10318','2013-04-13','11:10:00',9.2),('10318','2013-04-13','11:15:00',6.06),('10318','2013-04-13','11:20:00',6.24),('10318','2013-04-13','11:25:00',4.75),('10318','2013-04-13','11:30:00',5.16),('10318','2013-04-13','11:35:00',10.08),('10318','2013-04-13','11:40:00',9.65),('10318','2013-04-13','11:45:00',9.89),('10318','2013-04-13','11:50:00',9.09),('10318','2013-04-13','11:55:00',7.84),('10318','2013-04-13','12:00:00',5.65),('10318','2013-04-13','12:05:00',10.04),('10318','2013-04-13','12:10:00',9.04),('10318','2013-04-13','12:15:00',10.31),('10318','2013-04-13','12:20:00',9.75),('10318','2013-04-13','12:25:00',7.57),('10318','2013-04-13','12:30:00',10.17),('10318','2013-04-13','12:35:00',9.81),('10318','2013-04-13','12:40:00',9.56),('10318','2013-04-13','12:45:00',9.74),('10318','2013-04-13','12:50:00',9.43),('10318','2013-04-13','12:55:00',9.39),('10318','2013-04-13','13:00:00',9.3),('10318','2013-04-13','13:05:00',9.68),('10318','2013-04-13','13:10:00',9.59),('10318','2013-04-13','13:15:00',9.28),('10318','2013-04-13','13:20:00',9.09),('10318','2013-04-13','13:25:00',9.29),('10318','2013-04-13','13:30:00',8.95),('10318','2013-04-13','13:35:00',8.35),('10318','2013-04-13','13:40:00',8.11),('10318','2013-04-13','13:45:00',7.87),('10318','2013-04-13','13:50:00',7.8),('10318','2013-04-13','13:55:00',7.76),('10318','2013-04-13','14:00:00',7.57),('10318','2013-04-13','14:05:00',7.33),('10318','2013-04-13','14:10:00',5.3),('10318','2013-04-13','14:15:00',7.24),('10318','2013-04-13','14:20:00',6.2),('10318','2013-04-13','14:25:00',6.86),('10318','2013-04-13','14:30:00',8.01),('10318','2013-04-13','14:35:00',7.74),('10318','2013-04-13','14:40:00',7.59),('10318','2013-04-13','14:45:00',6.88),('10318','2013-04-13','14:50:00',7.34),('10318','2013-04-13','14:55:00',7.53),('10318','2013-04-13','15:00:00',6.9),('10318','2013-04-13','15:05:00',6.96),('10318','2013-04-13','15:10:00',6.55),('10318','2013-04-13','15:15:00',6.23),('10318','2013-04-13','15:20:00',6.01),('10318','2013-04-13','15:25:00',5.75),('10318','2013-04-13','15:30:00',5.76),('10318','2013-04-13','15:35:00',5.67),('10318','2013-04-13','15:40:00',5.83),('10318','2013-04-13','15:45:00',5.87),('10318','2013-04-13','15:50:00',5.78),('10318','2013-04-13','15:55:00',5.5),('10318','2013-04-13','16:00:00',5.53),('10318','2013-04-13','16:05:00',5.07),('10318','2013-04-13','16:10:00',4.96),('10318','2013-04-13','16:15:00',4.91),('10318','2013-04-13','16:20:00',4.74),('10318','2013-04-13','16:25:00',4.32),('10318','2013-04-13','16:30:00',4.11),('10318','2013-04-13','16:35:00',3.81),('10318','2013-04-13','16:40:00',3.62),('10318','2013-04-13','16:45:00',3.62),('10318','2013-04-13','16:50:00',3.53),('10318','2013-04-13','16:55:00',2.94),('10318','2013-04-13','17:00:00',2.56),('10318','2013-04-13','17:05:00',2.99),('10318','2013-04-13','17:10:00',3.82),('10318','2013-04-13','17:15:00',3.52),('10318','2013-04-13','17:20:00',3.18),('10318','2013-04-13','17:25:00',3.36),('10318','2013-04-13','17:30:00',2.97),('10318','2013-04-13','17:35:00',2.92),('10318','2013-04-13','17:40:00',2.59),('10318','2013-04-13','17:45:00',2.36),('10318','2013-04-13','17:50:00',2.09),('10318','2013-04-13','17:55:00',2.18),('10318','2013-04-13','18:00:00',1.72),('10318','2013-04-13','18:05:00',1.64),('10318','2013-04-13','18:10:00',1.55),('10318','2013-04-13','18:15:00',1.44),('10318','2013-04-13','18:20:00',1.43),('10318','2013-04-13','18:25:00',1.22),('10318','2013-04-13','18:30:00',1.1),('10318','2013-04-12','07:40:00',1.22),('10318','2013-04-12','07:45:00',1.15),('10318','2013-04-12','07:50:00',1.24),('10318','2013-04-12','07:55:00',1.82),('10318','2013-04-12','08:00:00',2.94),('10318','2013-04-12','08:05:00',2.94),('10318','2013-04-12','08:10:00',1.48),('10318','2013-04-12','08:15:00',1.31),('10318','2013-04-12','08:20:00',1.52),('10318','2013-04-12','08:25:00',1.36),('10318','2013-04-12','08:30:00',2.03),('10318','2013-04-12','08:35:00',2.38),('10318','2013-04-12','08:40:00',3.99),('10318','2013-04-12','08:45:00',3.09),('10318','2013-04-12','08:50:00',2.31),('10318','2013-04-12','08:55:00',2.71),('10318','2013-04-12','09:00:00',3.11),('10318','2013-04-12','09:05:00',2.69),('10318','2013-04-12','09:10:00',1.57),('10318','2013-04-12','09:15:00',2.32),('10318','2013-04-12','09:20:00',3.75),('10318','2013-04-12','09:25:00',3.05),('10318','2013-04-12','09:30:00',3.07),('10318','2013-04-12','09:35:00',3.18),('10318','2013-04-12','09:40:00',2.85),('10318','2013-04-12','09:45:00',3.21),('10318','2013-04-12','09:50:00',4.32),('10318','2013-04-12','09:55:00',5.96),('10318','2013-04-12','10:00:00',3.16),('10318','2013-04-12','10:05:00',7.02),('10318','2013-04-12','10:10:00',5.86),('10318','2013-04-12','10:15:00',7.71),('10318','2013-04-12','10:20:00',3.23),('10318','2013-04-12','10:25:00',1.92),('10318','2013-04-12','10:30:00',2.5),('10318','2013-04-12','10:35:00',3.28),('10318','2013-04-12','10:40:00',3.41),('10318','2013-04-12','10:45:00',4.18),('10318','2013-04-12','10:50:00',3.66),('10318','2013-04-12','10:55:00',5.62),('10318','2013-04-12','11:00:00',8.47),('10318','2013-04-12','11:05:00',7.96),('10318','2013-04-12','11:10:00',5.52),('10318','2013-04-12','11:15:00',5.7),('10318','2013-04-12','11:20:00',7.73),('10318','2013-04-12','11:25:00',7.03),('10318','2013-04-12','11:30:00',3.34),('10318','2013-04-12','11:35:00',5.75),('10318','2013-04-12','11:40:00',9.53),('10318','2013-04-12','11:45:00',9.42),('10318','2013-04-12','11:50:00',9.67),('10318','2013-04-12','11:55:00',9.62),('10318','2013-04-12','12:00:00',9.56),('10318','2013-04-12','12:05:00',9.32),('10318','2013-04-12','12:10:00',9.24),('10318','2013-04-12','12:15:00',9.95),('10318','2013-04-12','12:20:00',10.06),('10318','2013-04-12','12:25:00',10.08),('10318','2013-04-12','12:30:00',10.02),('10318','2013-04-12','12:35:00',9.92),('10318','2013-04-12','12:40:00',9.67),('10318','2013-04-12','12:45:00',9.65),('10318','2013-04-12','12:50:00',9.25),('10318','2013-04-12','12:55:00',9.57),('10318','2013-04-12','13:00:00',9.88),('10318','2013-04-12','13:05:00',7.12),('10318','2013-04-12','13:10:00',9.95),('10318','2013-04-12','13:15:00',9.68),('10318','2013-04-12','13:20:00',9.15),('10318','2013-04-12','13:25:00',9.37),('10318','2013-04-12','13:30:00',8.4),('10318','2013-04-12','13:35:00',9.48),('10318','2013-04-12','13:40:00',9.24),('10318','2013-04-12','13:45:00',8.32),('10318','2013-04-12','13:50:00',8.87),('10318','2013-04-12','13:55:00',8.38),('10318','2013-04-12','14:00:00',7.57),('10318','2013-04-12','14:05:00',9.12),('10318','2013-04-12','14:10:00',8.88),('10318','2013-04-12','14:15:00',8.76),('10318','2013-04-12','14:20:00',8.66),('10318','2013-04-12','14:25:00',8.55),('10318','2013-04-12','14:30:00',8.47),('10318','2013-04-12','14:35:00',8.42),('10318','2013-04-12','14:40:00',8.35),('10318','2013-04-12','14:45:00',8.22),('10318','2013-04-12','14:50:00',8.08),('10318','2013-04-12','14:55:00',8.01),('10318','2013-04-12','15:00:00',7.84),('10318','2013-04-12','15:05:00',7.73),('10318','2013-04-12','15:10:00',7.66),('10318','2013-04-12','15:15:00',7.46),('10318','2013-04-12','15:20:00',7.35),('10318','2013-04-12','15:25:00',7.21),('10318','2013-04-12','15:30:00',7.07),('10318','2013-04-12','15:35:00',6.9),('10318','2013-04-12','15:40:00',6.79),('10318','2013-04-12','15:45:00',6.61),('10318','2013-04-12','15:50:00',6.43),('10318','2013-04-12','15:55:00',6.28),('10318','2013-04-12','16:00:00',6.14),('10318','2013-04-12','16:05:00',5.95),('10318','2013-04-12','16:10:00',5.48),('10318','2013-04-12','16:15:00',4.7),('10318','2013-04-12','16:20:00',5.41),('10318','2013-04-12','16:25:00',4.65),('10318','2013-04-12','16:30:00',3.23),('10318','2013-04-12','16:35:00',3.79),('10318','2013-04-12','16:40:00',4.55),('10318','2013-04-12','16:45:00',4.42),('10318','2013-04-12','16:50:00',4.33),('10318','2013-04-12','16:55:00',4.09),('10318','2013-04-12','17:00:00',3.87),('10318','2013-04-12','17:05:00',3.76),('10318','2013-04-12','17:10:00',3.3),('10318','2013-04-12','17:15:00',3.23),('10318','2013-04-12','17:20:00',1.47),('10318','2013-04-12','17:25:00',1.8),('10318','2013-04-12','17:30:00',2.01),('10318','2013-04-12','17:35:00',1.48),('10318','2013-04-12','17:40:00',1.24),('10318','2013-04-12','17:50:00',1.78),('10318','2013-04-12','17:55:00',1.95),('10318','2013-04-12','18:00:00',1.81),('10318','2013-04-12','18:05:00',1.66),('10318','2013-04-12','18:10:00',1.49),('10318','2013-04-12','18:15:00',1.34),('10318','2013-04-12','18:20:00',1.07),('10318','2014-03-28','06:55:00',1.05),('10318','2014-03-28','07:00:00',1.33),('10318','2014-03-28','07:05:00',1.83),('10318','2014-03-28','07:10:00',2.49),('10318','2014-03-28','07:15:00',3.12),('10318','2014-03-28','07:20:00',3.31),('10318','2014-03-28','07:25:00',3.53),('10318','2014-03-28','07:30:00',3.89),('10318','2014-03-28','07:35:00',4.01),('10318','2014-03-28','07:40:00',4.45),('10318','2014-03-28','07:45:00',4.71),('10318','2014-03-28','07:50:00',4.84),('10318','2014-03-28','07:55:00',5.02),('10318','2014-03-28','08:00:00',5.23),('10318','2014-03-28','08:05:00',5.46),('10318','2014-03-28','08:10:00',5.65),('10318','2014-03-28','08:15:00',5.83),('10318','2014-03-28','08:20:00',6),('10318','2014-03-28','08:25:00',6.19),('10318','2014-03-28','08:30:00',6.39),('10318','2014-03-28','08:35:00',6.54),('10318','2014-03-28','08:40:00',6.67),('10318','2014-03-28','08:45:00',6.82),('10318','2014-03-28','08:50:00',7.07),('10318','2014-03-28','08:55:00',7.24),('10318','2014-03-28','09:00:00',7.48),('10318','2014-03-28','09:05:00',7.75),('10318','2014-03-28','09:10:00',7.9),('10318','2014-03-28','09:15:00',7.4),('10318','2014-03-28','09:20:00',7.97),('10318','2014-03-28','09:25:00',8.49),('10318','2014-03-28','09:30:00',8.68),('10318','2014-03-28','09:35:00',5.4),('10318','2014-03-28','09:40:00',4.54),('10318','2014-03-28','09:45:00',6.05),('10318','2014-03-28','09:50:00',8.56),('10318','2014-03-28','09:55:00',8.81),('10318','2014-03-28','10:00:00',8.83),('10318','2014-03-28','10:05:00',9.21),('10318','2014-03-28','10:10:00',7.73),('10318','2014-03-28','10:15:00',5.41),('10318','2014-03-28','10:20:00',7.91),('10318','2014-03-28','10:25:00',8.98),('10318','2014-03-28','10:30:00',8.65),('10318','2014-03-28','10:35:00',8.32),('10318','2014-03-28','10:40:00',7.72),('10318','2014-03-28','10:45:00',9.56),('10318','2014-03-28','10:50:00',9.28),('10318','2014-03-28','10:55:00',9),('10318','2014-03-28','11:00:00',5.77),('10318','2014-03-28','11:05:00',9.82),('10318','2014-03-28','11:10:00',8.45),('10318','2014-03-28','11:15:00',8.46),('10318','2014-03-28','11:20:00',3.56),('10318','2014-03-28','11:25:00',8.59),('10318','2014-03-28','11:30:00',4.95),('10318','2014-03-28','11:35:00',9.07),('10318','2014-03-28','11:40:00',5.89),('10318','2014-03-28','11:45:00',7.01),('10318','2014-03-28','11:50:00',4.76),('10318','2014-03-28','11:55:00',6.25),('10318','2014-03-28','12:00:00',4.24),('10318','2014-03-28','12:05:00',4.66),('10318','2014-03-28','12:10:00',7.78),('10318','2014-03-28','12:15:00',9.98),('10318','2014-03-28','12:20:00',8.18),('10318','2014-03-28','12:25:00',5),('10318','2014-03-28','12:30:00',4.33),('10318','2014-03-28','12:35:00',9.23),('10318','2014-03-28','12:40:00',9.75),('10318','2014-03-28','12:45:00',5.08),('10318','2014-03-28','12:50:00',7.62),('10318','2014-03-28','12:55:00',3.82),('10318','2014-03-28','13:00:00',4.44),('10318','2014-03-28','13:05:00',3.1),('10318','2014-03-28','13:10:00',4.58),('10318','2014-03-28','13:15:00',7.5),('10318','2014-03-28','13:20:00',5.38),('10318','2014-03-28','13:25:00',4.33),('10318','2014-03-28','13:30:00',4.7),('10318','2014-03-28','13:35:00',4.13),('10318','2014-03-28','13:40:00',5.11),('10318','2014-03-28','13:45:00',8.94),('10318','2014-03-28','13:50:00',8.48),('10318','2014-03-28','13:55:00',7.99),('10318','2014-03-28','14:00:00',8.21),('10318','2014-03-28','14:05:00',7.97),('10318','2014-03-28','14:10:00',7.88),('10318','2014-03-28','14:15:00',7.72),('10318','2014-03-28','14:20:00',7.57),('10318','2014-03-28','14:25:00',7.39),('10318','2014-03-28','14:30:00',7.25),('10318','2014-03-28','14:35:00',7.12),('10318','2014-03-28','14:40:00',6.98),('10318','2014-03-28','14:45:00',6.84),('10318','2014-03-28','14:50:00',6.67),('10318','2014-03-28','14:55:00',6.5),('10318','2014-03-28','15:00:00',6.43),('10318','2014-03-28','15:05:00',6.18),('10318','2014-03-28','15:10:00',6.01),('10318','2014-03-28','15:15:00',5.81),('10318','2014-03-28','15:20:00',5.63),('10318','2014-03-28','15:25:00',5.44),('10318','2014-03-28','15:30:00',5.25),('10318','2014-03-28','15:35:00',5.05),('10318','2014-03-28','15:40:00',4.78),('10318','2014-03-28','15:45:00',4.79),('10318','2014-03-28','15:50:00',4.57),('10318','2014-03-28','15:55:00',4.5),('10318','2014-03-28','16:00:00',4.68),('10318','2014-03-28','16:05:00',4.74),('10318','2014-03-28','16:10:00',4.4),('10318','2014-03-28','16:15:00',4.04),('10318','2014-03-28','16:20:00',3.4),('10318','2014-03-28','16:25:00',3.1),('10318','2014-03-28','16:30:00',1.93),('10318','2014-03-28','16:35:00',1.04),('10318','2014-03-28','16:40:00',2.14),('10318','2014-03-28','16:45:00',2.36),('10318','2014-03-28','16:50:00',1.15),('10318','2014-03-28','16:55:00',1.32),('10318','2014-03-28','17:00:00',1.88),('10318','2014-03-28','17:05:00',1.61),('10318','2014-03-28','17:10:00',1.51),('10318','2014-03-28','17:15:00',1.54),('10318','2014-03-28','17:20:00',1.54),('10318','2014-03-28','17:25:00',1.18),('10318','2014-03-28','17:30:00',1.29),('10318','2013-04-11','07:35:00',1.03),('10318','2013-04-11','07:40:00',1.19),('10318','2013-04-11','07:45:00',1.81),('10318','2013-04-11','07:50:00',2.33),('10318','2013-04-11','07:55:00',2.69),('10318','2013-04-11','08:00:00',2.93),('10318','2013-04-11','08:05:00',3.21),('10318','2013-04-11','08:10:00',3.49),('10318','2013-04-11','08:15:00',3.69),('10318','2013-04-11','08:20:00',3.91),('10318','2013-04-11','08:25:00',4.12),('10318','2013-04-11','08:30:00',4.34),('10318','2013-04-11','08:35:00',4.55),('10318','2013-04-11','08:40:00',4.75),('10318','2013-04-11','08:45:00',4.96),('10318','2013-04-11','08:50:00',5.16),('10318','2013-04-11','08:55:00',5.34),('10318','2013-04-11','09:00:00',5.44),('10318','2013-04-11','09:05:00',5.7),('10318','2013-04-11','09:10:00',5.88),('10318','2013-04-11','09:15:00',5.96),('10318','2013-04-11','09:20:00',6.12),('10318','2013-04-11','09:25:00',6.28),('10318','2013-04-11','09:30:00',6.57),('10318','2013-04-11','09:35:00',6.77),('10318','2013-04-11','09:40:00',6.96),('10318','2013-04-11','09:45:00',7.11),('10318','2013-04-11','09:50:00',7.01),('10318','2013-04-11','09:55:00',6.9),('10318','2013-04-11','10:00:00',7.83),('10318','2013-04-11','10:05:00',7.15),('10318','2013-04-11','10:10:00',5.91),('10318','2013-04-11','10:15:00',8.14),('10318','2013-04-11','10:20:00',8.4),('10318','2013-04-11','10:25:00',7.78),('10318','2013-04-11','10:30:00',9.11),('10318','2013-04-11','10:35:00',8.43),('10318','2013-04-11','10:40:00',6.04),('10318','2013-04-11','10:45:00',7.66),('10318','2013-04-11','10:50:00',9.1),('10318','2013-04-11','10:55:00',9.48),('10318','2013-04-11','11:00:00',8.5),('10318','2013-04-11','11:05:00',8.9),('10318','2013-04-11','11:10:00',9.77),('10318','2013-04-11','11:15:00',9.96),('10318','2013-04-11','11:20:00',7.97),('10318','2013-04-11','11:25:00',10.31),('10318','2013-04-11','11:30:00',6.12),('10318','2013-04-11','11:35:00',2.53),('10318','2013-04-11','11:40:00',5.45),('10318','2013-04-11','11:45:00',2.19),('10318','2013-04-11','11:50:00',2.17),('10318','2013-04-11','11:55:00',6.04),('10318','2013-04-11','12:00:00',8.9),('10318','2013-04-11','12:05:00',2.61),('10318','2013-04-11','12:10:00',10.54),('10318','2013-04-11','12:15:00',9.26),('10318','2013-04-11','12:20:00',8.9),('10318','2013-04-11','12:25:00',10.25),('10318','2013-04-11','12:30:00',10.27),('10318','2013-04-11','12:35:00',7.26),('10318','2013-04-11','12:40:00',10.48),('10318','2013-04-11','12:45:00',8.78),('10318','2013-04-11','12:50:00',3.74),('10318','2013-04-11','12:55:00',6.11),('10318','2013-04-11','13:00:00',10.07),('10318','2013-04-11','13:05:00',4.48),('10318','2013-04-11','13:10:00',10.15),('10318','2013-04-11','13:15:00',9.42),('10318','2013-04-11','13:20:00',9.81),('10318','2013-04-11','13:25:00',9.7),('10318','2013-04-11','13:30:00',5.18),('10318','2013-04-11','13:35:00',8.71),('10318','2013-04-11','13:40:00',6.64),('10318','2013-04-11','13:45:00',7.97),('10318','2013-04-11','13:50:00',9.38),('10318','2013-04-11','13:55:00',9.31),('10318','2013-04-11','14:00:00',9.17),('10318','2013-04-11','14:05:00',9.14),('10318','2013-04-11','14:10:00',8),('10318','2013-04-11','14:15:00',4.96),('10318','2013-04-11','14:20:00',9.52),('10318','2013-04-11','14:25:00',7.25),('10318','2013-04-11','14:30:00',5.22),('10318','2013-04-11','14:35:00',6.09),('10318','2013-04-11','14:40:00',8.81),('10318','2013-04-11','14:45:00',6.01),('10318','2013-04-11','14:50:00',8.28),('10318','2013-04-11','14:55:00',8.07),('10318','2013-04-11','15:00:00',7.75),('10318','2013-04-11','15:05:00',7.87),('10318','2013-04-11','15:10:00',7.84),('10318','2013-04-11','15:15:00',7.7),('10318','2013-04-11','15:20:00',7.56),('10318','2013-04-11','15:25:00',7.4),('10318','2013-04-11','15:30:00',7.22),('10318','2013-04-11','15:35:00',7.08),('10318','2013-04-11','15:40:00',6.88),('10318','2013-04-11','15:45:00',6.76),('10318','2013-04-11','15:50:00',6.6),('10318','2013-04-11','15:55:00',6.41),('10318','2013-04-11','16:00:00',6.2),('10318','2013-04-11','16:05:00',6.09),('10318','2013-04-11','16:10:00',5.84),('10318','2013-04-11','16:15:00',5.65),('10318','2013-04-11','16:20:00',5.42),('10318','2013-04-11','16:25:00',4.9),('10318','2013-04-11','16:30:00',5.06),('10318','2013-04-11','16:35:00',4.94),('10318','2013-04-11','16:40:00',4.78),('10318','2013-04-11','16:45:00',4.6),('10318','2013-04-11','16:50:00',4.16),('10318','2013-04-11','16:55:00',2.94),('10318','2013-04-11','17:00:00',3.96),('10318','2013-04-11','17:05:00',3.72),('10318','2013-04-11','17:10:00',3.31),('10318','2013-04-11','17:15:00',3.27),('10318','2013-04-11','17:20:00',3.13),('10318','2013-04-11','17:25:00',3.1),('10318','2013-04-11','17:30:00',2.84),('10318','2013-04-11','17:35:00',2.64),('10318','2013-04-11','17:40:00',2.5),('10318','2013-04-11','17:45:00',2.33),('10318','2013-04-11','17:50:00',2.14),('10318','2013-04-11','17:55:00',1.97),('10318','2013-04-11','18:00:00',1.77),('10318','2013-04-11','18:05:00',1.57),('10318','2013-04-11','18:10:00',1.37),('10318','2013-04-11','18:15:00',1.4),('10318','2013-04-11','18:20:00',1.31),('10318','2013-04-11','18:25:00',1.17),('10318','2013-04-10','08:10:00',1.27),('10318','2013-04-10','08:35:00',1.37),('10318','2013-04-10','08:40:00',1.83),('10318','2013-04-10','08:45:00',3.58),('10318','2013-04-10','08:50:00',5.3),('10318','2013-04-10','08:55:00',5.54),('10318','2013-04-10','09:00:00',5.91),('10318','2013-04-10','09:05:00',6.26),('10318','2013-04-10','09:10:00',6.51),('10318','2013-04-10','09:15:00',6.6),('10318','2013-04-10','09:20:00',6.5),('10318','2013-04-10','09:25:00',6.51),('10318','2013-04-10','09:30:00',6.75),('10318','2013-04-10','09:35:00',6.82),('10318','2013-04-10','09:40:00',7.09),('10318','2013-04-10','09:45:00',7.26),('10318','2013-04-10','09:50:00',7.49),('10318','2013-04-10','09:55:00',7.66),('10318','2013-04-10','10:00:00',7.9),('10318','2013-04-10','10:05:00',8.12),('10318','2013-04-10','10:10:00',8.42),('10318','2013-04-10','10:15:00',8.62),('10318','2013-04-10','10:20:00',8.76),('10318','2013-04-10','10:25:00',8.8),('10318','2013-04-10','10:30:00',8.88),('10318','2013-04-10','10:35:00',8.9),('10318','2013-04-10','10:40:00',8.97),('10318','2013-04-10','10:45:00',9.11),('10318','2013-04-10','10:50:00',8.34),('10318','2013-04-10','10:55:00',7.83),('10318','2013-04-10','11:00:00',8.78),('10318','2013-04-10','11:05:00',8.63),('10318','2013-04-10','11:10:00',8.79),('10318','2013-04-10','11:15:00',8.84),('10318','2013-04-10','11:20:00',8.7),('10318','2013-04-10','11:25:00',9.44),('10318','2013-04-10','11:30:00',9.59),('10318','2013-04-10','11:35:00',6.86),('10318','2013-04-10','11:40:00',9.67),('10318','2013-04-10','11:45:00',9.65),('10318','2013-04-10','11:50:00',5.55),('10318','2013-04-10','11:55:00',10.25),('10318','2013-04-10','12:00:00',5.95),('10318','2013-04-10','12:05:00',5.6),('10318','2013-04-10','12:10:00',10.49),('10318','2013-04-10','12:15:00',9.04),('10318','2013-04-10','12:20:00',10.49),('10318','2013-04-10','12:25:00',9.22),('10318','2013-04-10','12:30:00',7.65),('10318','2013-04-10','12:35:00',9.38),('10318','2013-04-10','12:40:00',10.39),('10318','2013-04-10','12:45:00',4.06),('10318','2013-04-10','12:50:00',6.53),('10318','2013-04-10','12:55:00',5.52),('10318','2013-04-10','13:00:00',10.01),('10318','2013-04-10','13:05:00',7.18),('10318','2013-04-10','13:10:00',8.96),('10318','2013-04-10','13:15:00',6.24),('10318','2013-04-10','13:20:00',8.31),('10318','2013-04-10','13:25:00',7.71),('10318','2013-04-10','13:30:00',5.94),('10318','2013-04-10','13:35:00',7.52),('10318','2013-04-10','13:40:00',7.44),('10318','2013-04-10','13:45:00',5.26),('10318','2013-04-10','13:50:00',8.75),('10318','2013-04-10','13:55:00',3.29),('10318','2013-04-10','14:00:00',10.09),('10318','2013-04-10','14:05:00',6.06),('10318','2013-04-10','14:10:00',8.85),('10318','2013-04-10','14:15:00',7.3),('10318','2013-04-10','14:20:00',5.86),('10318','2013-04-10','14:25:00',9.02),('10318','2013-04-10','14:30:00',9.4),('10318','2013-04-10','14:35:00',6.97),('10318','2013-04-10','14:40:00',6.14),('10318','2013-04-10','14:45:00',7.4),('10318','2013-04-10','14:50:00',6.7),('10318','2013-04-10','14:55:00',8.92),('10318','2013-04-10','15:00:00',8.45),('10318','2013-04-10','15:05:00',7.95),('10318','2013-04-10','15:10:00',7.79),('10318','2013-04-10','15:15:00',8.08),('10318','2013-04-10','15:20:00',7.63),('10318','2013-04-10','15:25:00',7.14),('10318','2013-04-10','15:30:00',7.34),('10318','2013-04-10','15:35:00',6.37),('10318','2013-04-10','15:40:00',7.06),('10318','2013-04-10','15:45:00',6.98),('10318','2013-04-10','15:50:00',5.13),('10318','2013-04-10','15:55:00',5.34),('10318','2013-04-10','16:00:00',5.94),('10318','2013-04-10','16:05:00',6.33),('10318','2013-04-10','16:10:00',5.58),('10318','2013-04-10','16:15:00',4.59),('10318','2013-04-10','16:20:00',5.78),('10318','2013-04-10','16:25:00',5.45),('10318','2013-04-10','16:30:00',5.17),('10318','2013-04-10','16:35:00',5.19),('10318','2013-04-10','16:40:00',5.15),('10318','2013-04-10','16:45:00',4.64),('10318','2013-04-10','16:50:00',3.34),('10318','2013-04-10','16:55:00',4.23),('10318','2013-04-10','17:00:00',4.07),('10318','2013-04-10','17:05:00',3.94),('10318','2013-04-10','17:10:00',2.36),('10318','2013-04-10','17:15:00',3.21),('10318','2013-04-10','17:20:00',3),('10318','2013-04-10','17:25:00',2.78),('10318','2013-04-10','17:30:00',3.08),('10318','2013-04-10','17:35:00',2.39),('10318','2013-04-10','17:40:00',1.69),('10318','2013-04-10','17:45:00',2),('10318','2013-04-10','17:50:00',2.53),('10318','2013-04-10','17:55:00',1.53),('10318','2013-04-10','18:00:00',1.86),('10318','2013-04-10','18:05:00',1.11),('10318','2013-04-09','07:30:00',1.06),('10318','2013-04-09','07:35:00',1.2),('10318','2013-04-09','07:40:00',1.03),('10318','2013-04-09','07:45:00',1.03),('10318','2013-04-09','07:50:00',1.8),('10318','2013-04-09','07:55:00',2.41),('10318','2013-04-09','08:00:00',1.18),('10318','2013-04-09','08:05:00',2.53),('10318','2013-04-09','08:10:00',3.36),('10318','2013-04-09','08:15:00',2.87),('10318','2013-04-09','08:20:00',3.09),('10318','2013-04-09','08:25:00',1.98),('10318','2013-04-09','08:30:00',1.96),('10318','2013-04-09','08:35:00',2.1),('10318','2013-04-09','08:40:00',2.46),('10318','2013-04-09','08:45:00',2.2),('10318','2013-04-09','08:50:00',2.04),('10318','2013-04-09','08:55:00',1.97),('10318','2013-04-09','09:00:00',1.88),('10318','2013-04-09','09:05:00',2.12),('10318','2013-04-09','09:10:00',2.28),('10318','2013-04-09','09:15:00',2.36),('10318','2013-04-09','09:20:00',2),('10318','2013-04-09','09:25:00',2.36),('10318','2013-04-09','09:30:00',1.54),('10318','2013-04-09','09:35:00',1.62),('10318','2013-04-09','09:40:00',4.72),('10318','2013-04-09','09:45:00',8),('10318','2013-04-09','09:50:00',8.43),('10318','2013-04-09','09:55:00',5.92),('10318','2013-04-09','10:00:00',1.98),('10318','2013-04-09','10:05:00',2.09),('10318','2013-04-09','10:10:00',3.57),('10318','2013-04-09','10:15:00',3.49),('10318','2013-04-09','10:20:00',2.94),('10318','2013-04-09','10:25:00',6.76),('10318','2013-04-09','10:30:00',9.18),('10318','2013-04-09','10:35:00',9.59),('10318','2013-04-09','10:40:00',5.51),('10318','2013-04-09','10:45:00',6.67),('10318','2013-04-09','10:50:00',7.11),('10318','2013-04-09','10:55:00',2.96),('10318','2013-04-09','11:00:00',8.31),('10318','2013-04-09','11:05:00',7.38),('10318','2013-04-09','11:10:00',3.2),('10318','2013-04-09','11:15:00',10.19),('10318','2013-04-09','11:20:00',7.17),('10318','2013-04-09','11:25:00',3.65),('10318','2013-04-09','11:30:00',6.66),('10318','2013-04-09','11:35:00',7.16),('10318','2013-04-09','11:40:00',8.28),('10318','2013-04-09','11:45:00',5.04),('10318','2013-04-09','11:50:00',2.17),('10318','2013-04-09','11:55:00',8.82),('10318','2013-04-09','12:00:00',9.42),('10318','2013-04-09','12:05:00',5.02),('10318','2013-04-09','12:10:00',4.38),('10318','2013-04-09','12:15:00',7.35),('10318','2013-04-09','12:20:00',10.35),('10318','2013-04-09','12:25:00',10.2),('10318','2013-04-09','12:30:00',8.02),('10318','2013-04-09','12:35:00',10.04),('10318','2013-04-09','12:40:00',9.57),('10318','2013-04-09','12:45:00',9.61),('10318','2013-04-09','12:50:00',7.27),('10318','2013-04-09','12:55:00',7.34),('10318','2013-04-09','13:00:00',4.71),('10318','2013-04-09','13:05:00',2.08),('10318','2013-04-09','13:10:00',3.54),('10318','2013-04-09','13:15:00',10.09),('10318','2013-04-09','13:20:00',7.02),('10318','2013-04-09','13:25:00',9.2),('10318','2013-04-09','13:30:00',8.78),('10318','2013-04-09','13:35:00',8.82),('10318','2013-04-09','13:40:00',6.19),('10318','2013-04-09','13:45:00',9.63),('10318','2013-04-09','13:50:00',9.1),('10318','2013-04-09','13:55:00',8.15),('10318','2013-04-09','14:00:00',8.62),('10318','2013-04-09','14:05:00',8.46),('10318','2013-04-09','14:10:00',7.85),('10318','2013-04-09','14:15:00',7.98),('10318','2013-04-09','14:20:00',7.31),('10318','2013-04-09','14:25:00',7.71),('10318','2013-04-09','14:30:00',6.58),('10318','2013-04-09','14:35:00',3.9),('10318','2013-04-09','14:40:00',8.37),('10318','2013-04-09','14:45:00',7.1),('10318','2013-04-09','14:50:00',8),('10318','2013-04-09','14:55:00',8.2),('10318','2013-04-09','15:00:00',8.56),('10318','2013-04-09','15:05:00',7.85),('10318','2013-04-09','15:10:00',6.89),('10318','2013-04-09','15:15:00',7.66),('10318','2013-04-09','15:20:00',7.34),('10318','2013-04-09','15:25:00',7.89),('10318','2013-04-09','15:30:00',7.68),('10318','2013-04-09','15:35:00',7.48),('10318','2013-04-09','15:40:00',7.26),('10318','2013-04-09','15:45:00',7.23),('10318','2013-04-09','15:50:00',6.86),('10318','2013-04-09','15:55:00',5.17),('10318','2013-04-09','16:00:00',5.61),('10318','2013-04-09','16:05:00',6.65),('10318','2013-04-09','16:10:00',6.26),('10318','2013-04-09','16:15:00',5.72),('10318','2013-04-09','16:20:00',5.2),('10318','2013-04-09','16:25:00',5.86),('10318','2013-04-09','16:30:00',5.32),('10318','2013-04-09','16:35:00',4.96),('10318','2013-04-09','16:40:00',3.51),('10318','2013-04-09','16:45:00',2.9),('10318','2013-04-09','16:50:00',3.25),('10318','2013-04-09','16:55:00',1.77),('10318','2013-04-09','17:00:00',3.21),('10318','2013-04-09','17:05:00',1.65),('10318','2013-04-09','17:10:00',1.63),('10318','2013-04-09','17:15:00',2.01),('10318','2013-04-09','17:20:00',2.33),('10318','2013-04-09','17:25:00',2.04),('10318','2013-04-09','17:30:00',1.87),('10318','2013-04-09','17:35:00',1.82),('10318','2013-04-09','17:40:00',1.31),('10318','2013-04-09','17:45:00',1.28),('10318','2013-04-09','17:50:00',1.07),('10318','2013-04-09','17:55:00',1.13),('10318','2013-04-09','18:00:00',1.34),('10318','2013-04-09','18:05:00',1.3),('10318','2013-04-09','18:10:00',1.16),('10318','2013-04-09','18:15:00',1.64),('10318','2013-04-09','18:20:00',1.32),('10318','2013-04-08','07:45:00',1.03),('10318','2013-04-08','07:50:00',1.02),('10318','2013-04-08','07:55:00',1.22),('10318','2013-04-08','08:00:00',1.37),('10318','2013-04-08','08:05:00',2.2),('10318','2013-04-08','08:10:00',2.24),('10318','2013-04-08','08:15:00',2.4),('10318','2013-04-08','08:20:00',2.03),('10318','2013-04-08','08:25:00',1.72),('10318','2013-04-08','08:30:00',1.78),('10318','2013-04-08','08:35:00',1.94),('10318','2013-04-08','08:40:00',4.02),('10318','2013-04-08','08:45:00',3.18),('10318','2013-04-08','08:50:00',4),('10318','2013-04-08','08:55:00',4.49),('10318','2013-04-08','09:00:00',3.88),('10318','2013-04-08','09:05:00',3.59),('10318','2013-04-08','09:10:00',6.41),('10318','2013-04-08','09:15:00',6.2),('10318','2013-04-08','09:20:00',5.08),('10318','2013-04-08','09:25:00',6.65),('10318','2013-04-08','09:30:00',7.07),('10318','2013-04-08','09:35:00',7.41),('10318','2013-04-08','09:40:00',7.43),('10318','2013-04-08','09:45:00',7.19),('10318','2013-04-08','09:50:00',4.01),('10318','2013-04-08','09:55:00',5.56),('10318','2013-04-08','10:00:00',8.12),('10318','2013-04-08','10:05:00',8.14),('10318','2013-04-08','10:10:00',8.14),('10318','2013-04-08','10:15:00',8.17),('10318','2013-04-08','10:20:00',8.24),('10318','2013-04-08','10:25:00',8.12),('10318','2013-04-08','10:30:00',7.81),('10318','2013-04-08','10:35:00',8.15),('10318','2013-04-08','10:40:00',8.46),('10318','2013-04-08','10:45:00',8.78),('10318','2013-04-08','10:50:00',8.95),('10318','2013-04-08','10:55:00',8.43),('10318','2013-04-08','11:00:00',8.53),('10318','2013-04-08','11:05:00',7.14),('10318','2013-04-08','11:10:00',6.98),('10318','2013-04-08','11:15:00',6.32),('10318','2013-04-08','11:20:00',5.02),('10318','2013-04-08','11:25:00',4.63),('10318','2013-04-08','11:30:00',5.84),('10318','2013-04-08','11:35:00',7.29),('10318','2013-04-08','11:40:00',6.87),('10318','2013-04-08','11:45:00',6.51),('10318','2013-04-08','11:50:00',5.7),('10318','2013-04-08','11:55:00',5.67),('10318','2013-04-08','12:00:00',5.08),('10318','2013-04-08','12:05:00',4.94),('10318','2013-04-08','12:10:00',5.62),('10318','2013-04-08','12:15:00',6.21),('10318','2013-04-08','12:20:00',6.53),('10318','2013-04-08','12:25:00',6.33),('10318','2013-04-08','12:30:00',7.07),('10318','2013-04-08','12:35:00',6.87),('10318','2013-04-08','12:40:00',6.94),('10318','2013-04-08','12:45:00',5.73),('10318','2013-04-08','12:50:00',5.07),('10318','2013-04-08','12:55:00',5.77),('10318','2013-04-08','13:00:00',4.94),('10318','2013-04-08','13:05:00',4.23),('10318','2013-04-08','13:10:00',4.14),('10318','2013-04-08','13:15:00',6.49),('10318','2013-04-08','13:20:00',8.22),('10318','2013-04-08','13:25:00',7.26),('10318','2013-04-08','13:30:00',6.69),('10318','2013-04-08','13:35:00',8.26),('10318','2013-04-08','13:40:00',7.82),('10318','2013-04-08','13:45:00',6.44),('10318','2013-04-08','13:50:00',8.71),('10318','2013-04-08','13:55:00',8.95),('10318','2013-04-08','14:00:00',6.18),('10318','2013-04-08','14:05:00',7.68),('10318','2013-04-08','14:10:00',7.64),('10318','2013-04-08','14:15:00',8.12),('10318','2013-04-08','14:20:00',7.07),('10318','2013-04-08','14:25:00',8.43),('10318','2013-04-08','14:30:00',8.18),('10318','2013-04-08','14:35:00',7.6),('10318','2013-04-08','14:40:00',8.2),('10318','2013-04-08','14:45:00',7.96),('10318','2013-04-08','14:50:00',8.18),('10318','2013-04-08','14:55:00',7.08),('10318','2013-04-08','15:00:00',5.95),('10318','2013-04-08','15:05:00',6.97),('10318','2013-04-08','15:10:00',7.63),('10318','2013-04-08','15:15:00',5.86),('10318','2013-04-08','15:20:00',6.97),('10318','2013-04-08','15:25:00',7.75),('10318','2013-04-08','15:30:00',7.5),('10318','2013-04-08','15:35:00',7.17),('10318','2013-04-08','15:40:00',7.03),('10318','2013-04-08','15:45:00',6.8),('10318','2013-04-08','15:50:00',6.68),('10318','2013-04-08','15:55:00',6.43),('10318','2013-04-08','16:00:00',6.08),('10318','2013-04-08','16:05:00',5.77),('10318','2013-04-08','16:10:00',5.59),('10318','2013-04-08','16:15:00',5.86),('10318','2013-04-08','16:20:00',5.66),('10318','2013-04-08','16:25:00',5.3),('10318','2013-04-08','16:30:00',5.22),('10318','2013-04-08','16:35:00',5.05),('10318','2013-04-08','16:40:00',4.88),('10318','2013-04-08','16:45:00',4.75),('10318','2013-04-08','16:50:00',4.56),('10318','2013-04-08','16:55:00',4.36),('10318','2013-04-08','17:00:00',4.19),('10318','2013-04-08','17:05:00',3.93),('10318','2013-04-08','17:10:00',3.69),('10318','2013-04-08','17:15:00',3.42),('10318','2013-04-08','17:20:00',3.3),('10318','2013-04-08','17:25:00',3.32),('10318','2013-04-08','17:30:00',2.98),('10318','2013-04-08','17:35:00',2.78),('10318','2013-04-08','17:40:00',2.4),('10318','2013-04-08','17:45:00',2.25),('10318','2013-04-08','17:50:00',1.79),('10318','2013-04-08','17:55:00',1.69),('10318','2013-04-08','18:00:00',1.66),('10318','2013-04-08','18:05:00',1.04),('10318','2013-04-08','18:10:00',1.02),('10318','2013-04-08','18:15:00',1.48),('10318','2013-04-08','18:20:00',2.02),('10318','2013-04-08','18:25:00',1.73),('10318','2013-04-07','08:00:00',1.25),('10318','2013-04-07','08:05:00',1.42),('10318','2013-04-07','08:10:00',1.69),('10318','2013-04-07','08:15:00',2),('10318','2013-04-07','08:20:00',2.32),('10318','2013-04-07','08:25:00',2.63),('10318','2013-04-07','08:30:00',2.96),('10318','2013-04-07','08:35:00',3.24),('10318','2013-04-07','08:40:00',3.42),('10318','2013-04-07','08:45:00',3.56),('10318','2013-04-07','08:50:00',3.75),('10318','2013-04-07','08:55:00',3.7),('10318','2013-04-07','09:00:00',3.69),('10318','2013-04-07','09:05:00',3.59),('10318','2013-04-07','09:10:00',3.53),('10318','2013-04-07','09:15:00',3.85),('10318','2013-04-07','09:20:00',4.42),('10318','2013-04-07','09:25:00',4.7),('10318','2013-04-07','09:30:00',4.68),('10318','2013-04-07','09:35:00',4.73),('10318','2013-04-07','09:40:00',4.66),('10318','2013-04-07','09:45:00',4.24),('10318','2013-04-07','09:50:00',4.17),('10318','2013-04-07','09:55:00',5.24),('10318','2013-04-07','10:00:00',5.58),('10318','2013-04-07','10:05:00',6.16),('10318','2013-04-07','10:10:00',6.87),('10318','2013-04-07','10:15:00',7.07),('10318','2013-04-07','10:20:00',7.15),('10318','2013-04-07','10:25:00',7.29),('10318','2013-04-07','10:30:00',7.53),('10318','2013-04-07','10:35:00',6.78),('10318','2013-04-07','10:40:00',6.58),('10318','2013-04-07','10:45:00',6.76),('10318','2013-04-07','10:50:00',6.64),('10318','2013-04-07','10:55:00',6.36),('10318','2013-04-07','11:00:00',5.91),('10318','2013-04-07','11:05:00',5.27),('10318','2013-04-07','11:10:00',4.83),('10318','2013-04-07','11:15:00',4.91),('10318','2013-04-07','11:20:00',6.25),('10318','2013-04-07','11:25:00',8.28),('10318','2013-04-07','11:30:00',8.98),('10318','2013-04-07','11:35:00',9.2),('10318','2013-04-07','11:40:00',8.64),('10318','2013-04-07','11:45:00',7.96),('10318','2013-04-07','11:50:00',6.17),('10318','2013-04-07','11:55:00',5.6),('10318','2013-04-07','12:00:00',6.03),('10318','2013-04-07','12:05:00',5.8),('10318','2013-04-07','12:10:00',5.77),('10318','2013-04-07','12:15:00',6.49),('10318','2013-04-07','12:20:00',6.14),('10318','2013-04-07','12:25:00',7.11),('10318','2013-04-07','12:30:00',7.48),('10318','2013-04-07','12:35:00',6.74),('10318','2013-04-07','12:40:00',7.14),('10318','2013-04-07','12:45:00',6.59),('10318','2013-04-07','12:50:00',6.02),('10318','2013-04-07','12:55:00',6.25),('10318','2013-04-07','13:00:00',6.25),('10318','2013-04-07','13:05:00',7.32),('10318','2013-04-07','13:10:00',7.17),('10318','2013-04-07','13:15:00',7.19),('10318','2013-04-07','13:20:00',6.51),('10318','2013-04-07','13:25:00',6.57),('10318','2013-04-07','13:30:00',6.86),('10318','2013-04-07','13:35:00',6.89),('10318','2013-04-07','13:40:00',7.17),('10318','2013-04-07','13:45:00',6.84),('10318','2013-04-07','13:50:00',5.45),('10318','2013-04-07','13:55:00',5.99),('10318','2013-04-07','14:00:00',6.48),('10318','2013-04-07','14:05:00',7.76),('10318','2013-04-07','14:10:00',8.01),('10318','2013-04-07','14:15:00',6.32),('10318','2013-04-07','14:20:00',3.35),('10318','2013-04-07','14:25:00',2.91),('10318','2013-04-07','14:30:00',3.1),('10318','2013-04-07','14:35:00',2.76),('10318','2013-04-07','14:40:00',2.99),('10318','2013-04-07','14:45:00',2.99),('10318','2013-04-07','14:50:00',3.21),('10318','2013-04-07','14:55:00',2.81),('10318','2013-04-07','15:00:00',2.96),('10318','2013-04-07','15:05:00',3.12),('10318','2013-04-07','15:10:00',4.3),('10318','2013-04-07','15:15:00',5.3),('10318','2013-04-07','15:20:00',5.43),('10318','2013-04-07','15:25:00',5.32),('10318','2013-04-07','15:30:00',5.44),('10318','2013-04-07','15:35:00',5.58),('10318','2013-04-07','15:40:00',5.56),('10318','2013-04-07','15:45:00',5.5),('10318','2013-04-07','15:50:00',5.28),('10318','2013-04-07','15:55:00',4.84),('10318','2013-04-07','16:00:00',4.2),('10318','2013-04-07','16:05:00',3.49),('10318','2013-04-07','16:10:00',3.28),('10318','2013-04-07','16:15:00',3.04),('10318','2013-04-07','16:20:00',2.82),('10318','2013-04-07','16:25:00',3.05),('10318','2013-04-07','16:30:00',3.59),('10318','2013-04-07','16:35:00',3.76),('10318','2013-04-07','16:40:00',4.43),('10318','2013-04-07','16:45:00',4.56),('10318','2013-04-07','16:50:00',3.54),('10318','2013-04-07','16:55:00',3.11),('10318','2013-04-07','17:00:00',3.26),('10318','2013-04-07','17:05:00',3.09),('10318','2013-04-07','17:10:00',3.23),('10318','2013-04-07','17:15:00',2.62),('10318','2013-04-07','17:20:00',3.33),('10318','2013-04-07','17:25:00',3.72),('10318','2013-04-07','17:30:00',3.44),('10318','2013-04-07','17:35:00',3.21),('10318','2013-04-07','17:40:00',3.01),('10318','2013-04-07','17:45:00',2.68),('10318','2013-04-07','17:50:00',2.56),('10318','2013-04-07','17:55:00',2.01),('10318','2013-04-07','18:00:00',1.43),('10318','2013-04-07','18:05:00',1.2),('10318','2013-04-07','18:10:00',1.15),('10318','2013-04-06','07:40:00',1.05),('10318','2013-04-06','07:45:00',1.24),('10318','2013-04-06','07:50:00',1.54),('10318','2013-04-06','07:55:00',2.2),('10318','2013-04-06','08:00:00',2.46),('10318','2013-04-06','08:05:00',2.73),('10318','2013-04-06','08:10:00',3.29),('10318','2013-04-06','08:15:00',3.57),('10318','2013-04-06','08:20:00',3.69),('10318','2013-04-06','08:25:00',4.03),('10318','2013-04-06','08:30:00',4.27),('10318','2013-04-06','08:35:00',4.46),('10318','2013-04-06','08:40:00',4.68),('10318','2013-04-06','08:45:00',4.87),('10318','2013-04-06','08:50:00',5.08),('10318','2013-04-06','08:55:00',5.29),('10318','2013-04-06','09:00:00',5.5),('10318','2013-04-06','09:05:00',5.7),('10318','2013-04-06','09:10:00',5.9),('10318','2013-04-06','09:15:00',6.08),('10318','2013-04-06','09:20:00',6.19),('10318','2013-04-06','09:25:00',6.4),('10318','2013-04-06','09:30:00',6.57),('10318','2013-04-06','09:35:00',6.54),('10318','2013-04-06','09:40:00',6.89),('10318','2013-04-06','09:45:00',7.04),('10318','2013-04-06','09:50:00',7.17),('10318','2013-04-06','09:55:00',7.3),('10318','2013-04-06','10:00:00',7.44),('10318','2013-04-06','10:05:00',7.42),('10318','2013-04-06','10:10:00',7.77),('10318','2013-04-06','10:15:00',7.93),('10318','2013-04-06','10:20:00',8.13),('10318','2013-04-06','10:25:00',8.26),('10318','2013-04-06','10:30:00',8.29),('10318','2013-04-06','10:35:00',8.29),('10318','2013-04-06','10:40:00',8.36),('10318','2013-04-06','10:45:00',8.47),('10318','2013-04-06','10:50:00',8.51),('10318','2013-04-06','10:55:00',8.51),('10318','2013-04-06','11:00:00',8.65),('10318','2013-04-06','11:05:00',8.8),('10318','2013-04-06','11:10:00',8.9),('10318','2013-04-06','11:15:00',8.93),('10318','2013-04-06','11:20:00',9.01),('10318','2013-04-06','11:25:00',9.1),('10318','2013-04-06','11:30:00',9.23),('10318','2013-04-06','11:35:00',6.88),('10318','2013-04-06','11:40:00',5.48),('10318','2013-04-06','11:45:00',9.55),('10318','2013-04-06','11:50:00',9.35),('10318','2013-04-06','11:55:00',9.18),('10318','2013-04-06','12:00:00',9.28),('10318','2013-04-06','12:05:00',9.41),('10318','2013-04-06','12:10:00',9.46),('10318','2013-04-06','12:15:00',9.57),('10318','2013-04-06','12:20:00',9.47),('10318','2013-04-06','12:25:00',8.57),('10318','2013-04-06','12:30:00',6.36),('10318','2013-04-06','12:35:00',9.44),('10318','2013-04-06','12:40:00',7.26),('10318','2013-04-06','12:45:00',7.87),('10318','2013-04-06','12:50:00',10.11),('10318','2013-04-06','12:55:00',10.15),('10318','2013-04-06','13:00:00',9.07),('10318','2013-04-06','13:05:00',4.82),('10318','2013-04-06','13:10:00',4.85),('10318','2013-04-06','13:15:00',9.31),('10318','2013-04-06','13:20:00',7.51),('10318','2013-04-06','13:25:00',7.6),('10318','2013-04-06','13:30:00',10.32),('10318','2013-04-06','13:35:00',9.77),('10318','2013-04-06','13:40:00',2.75),('10318','2013-04-06','13:45:00',3.84),('10318','2013-04-06','13:50:00',2.82),('10318','2013-04-06','13:55:00',3.18),('10318','2013-04-06','14:00:00',8.41),('10318','2013-04-06','14:05:00',3.13),('10318','2013-04-06','14:10:00',2.71),('10318','2013-04-06','14:15:00',4.2),('10318','2013-04-06','14:20:00',9.7),('10318','2013-04-06','14:25:00',8.96),('10318','2013-04-06','14:30:00',8.9),('10318','2013-04-06','14:35:00',8.7),('10318','2013-04-06','14:40:00',8.43),('10318','2013-04-06','14:45:00',8.4),('10318','2013-04-06','14:50:00',8.28),('10318','2013-04-06','14:55:00',8.2),('10318','2013-04-06','15:00:00',8.3),('10318','2013-04-06','15:05:00',7.77),('10318','2013-04-06','15:10:00',7.52),('10318','2013-04-06','15:15:00',7.4),('10318','2013-04-06','15:20:00',7.24),('10318','2013-04-06','15:25:00',7.05),('10318','2013-04-06','15:30:00',6.86),('10318','2013-04-06','15:35:00',6.79),('10318','2013-04-06','15:40:00',6.64),('10318','2013-04-06','15:45:00',6.47),('10318','2013-04-06','15:50:00',6.52),('10318','2013-04-06','15:55:00',6.43),('10318','2013-04-06','16:00:00',6.25),('10318','2013-04-06','16:05:00',5.96),('10318','2013-04-06','16:10:00',6.02),('10318','2013-04-06','16:15:00',5.74),('10318','2013-04-06','16:20:00',5.15),('10318','2013-04-06','16:25:00',4.42),('10318','2013-04-06','16:30:00',3.74),('10318','2013-04-06','16:35:00',3.68),('10318','2013-04-06','16:40:00',4.05),('10318','2013-04-06','16:45:00',4.88),('10318','2013-04-06','16:50:00',4.71),('10318','2013-04-06','16:55:00',4.38),('10318','2013-04-06','17:00:00',3.37),('10318','2013-04-06','17:05:00',2.67),('10318','2013-04-06','17:10:00',2.39),('10318','2013-04-06','17:15:00',2.18),('10318','2013-04-06','17:20:00',2.09),('10318','2013-04-06','17:25:00',2.05),('10318','2013-04-06','17:30:00',2.08),('10318','2013-04-06','17:35:00',2),('10318','2013-04-06','17:40:00',1.68),('10318','2013-04-06','17:45:00',1.57),('10318','2013-04-06','17:50:00',1.52),('10318','2013-04-06','17:55:00',1.39),('10318','2013-04-06','18:00:00',1.27),('10318','2013-04-06','18:05:00',1.2),('10318','2013-04-06','18:10:00',1.09),('10318','2013-04-05','07:45:00',1.28),('10318','2013-04-05','07:50:00',1.33),('10318','2013-04-05','07:55:00',1.74),('10318','2013-04-05','08:00:00',2.29),('10318','2013-04-05','08:05:00',2.93),('10318','2013-04-05','08:10:00',3.57),('10318','2013-04-05','08:15:00',4.39),('10318','2013-04-05','08:20:00',2.09),('10318','2013-04-05','08:25:00',1.34),('10318','2013-04-05','08:30:00',1.23),('10318','2013-04-05','08:35:00',1.06),('10318','2013-04-05','08:40:00',5.08),('10318','2013-04-05','08:45:00',4.66),('10318','2013-04-05','08:50:00',5),('10318','2013-04-05','08:55:00',3.94),('10318','2013-04-05','09:00:00',5.62),('10318','2013-04-05','09:05:00',2.64),('10318','2013-04-05','09:10:00',4.08),('10318','2013-04-05','09:15:00',5.02),('10318','2013-04-05','09:20:00',3.35),('10318','2013-04-05','09:25:00',2.02),('10318','2013-04-05','09:30:00',3.39),('10318','2013-04-05','09:35:00',4.9),('10318','2013-04-05','09:40:00',3.26),('10318','2013-04-05','09:45:00',4.35),('10318','2013-04-05','09:50:00',3.75),('10318','2013-04-05','09:55:00',5.13),('10318','2013-04-05','10:00:00',2.01),('10318','2013-04-05','10:05:00',3.06),('10318','2013-04-05','10:10:00',5.53),('10318','2013-04-05','10:15:00',5.94),('10318','2013-04-05','10:20:00',8.55),('10318','2013-04-05','10:25:00',8.23),('10318','2013-04-05','10:30:00',6.33),('10318','2013-04-05','10:35:00',4.91),('10318','2013-04-05','10:40:00',3.54),('10318','2013-04-05','10:45:00',5.38),('10318','2013-04-05','10:50:00',5.74),('10318','2013-04-05','10:55:00',8.97),('10318','2013-04-05','11:00:00',4.52),('10318','2013-04-05','11:05:00',8.78),('10318','2013-04-05','11:10:00',9.67),('10318','2013-04-05','11:15:00',9.96),('10318','2013-04-05','11:20:00',9.28),('10318','2013-04-05','11:25:00',9.65),('10318','2013-04-05','11:30:00',9.4),('10318','2013-04-05','11:35:00',8.31),('10318','2013-04-05','11:40:00',8.61),('10318','2013-04-05','11:45:00',9.94),('10318','2013-04-05','11:50:00',9.87),('10318','2013-04-05','11:55:00',10.35),('10318','2013-04-05','12:00:00',5.27),('10318','2013-04-05','12:05:00',6.57),('10318','2013-04-05','12:10:00',8.5),('10318','2013-04-05','12:15:00',6.39),('10318','2013-04-05','12:20:00',6.87),('10318','2013-04-05','12:25:00',6.95),('10318','2013-04-05','12:30:00',4.18),('10318','2013-04-05','12:35:00',3.88),('10318','2013-04-05','12:40:00',2.94),('10318','2013-04-05','12:45:00',5.32),('10318','2013-04-05','12:50:00',7.09),('10318','2013-04-05','12:55:00',10.43),('10318','2013-04-05','13:00:00',7.95),('10318','2013-04-05','13:05:00',5.61),('10318','2013-04-05','13:10:00',9.86),('10318','2013-04-05','13:15:00',9.25),('10318','2013-04-05','13:20:00',7.58),('10318','2013-04-05','13:25:00',10.13),('10318','2013-04-05','13:30:00',10.2),('10318','2013-04-05','13:35:00',6.53),('10318','2013-04-05','13:40:00',8.83),('10318','2013-04-05','13:45:00',8.76),('10318','2013-04-05','13:50:00',5.25),('10318','2013-04-05','13:55:00',6.88),('10318','2013-04-05','14:00:00',5.62),('10318','2013-04-05','14:05:00',8.31),('10318','2013-04-05','14:10:00',6.57),('10318','2013-04-05','14:15:00',4.99),('10318','2013-04-05','14:20:00',5.18),('10318','2013-04-05','14:25:00',6.88),('10318','2013-04-05','14:30:00',6.35),('10318','2013-04-05','14:35:00',9.02),('10318','2013-04-05','14:40:00',9.52),('10318','2013-04-05','14:45:00',8.15),('10318','2013-04-05','14:50:00',5.62),('10318','2013-04-05','14:55:00',4.09),('10318','2013-04-05','15:00:00',5.55),('10318','2013-04-05','15:05:00',4.16),('10318','2013-04-05','15:10:00',3.01),('10318','2013-04-05','15:15:00',3.65),('10318','2013-04-05','15:20:00',2.95),('10318','2013-04-05','15:25:00',2.77),('10318','2013-04-05','15:30:00',2.31),('10318','2013-04-05','15:35:00',2),('10318','2013-04-05','15:40:00',2.03),('10318','2013-04-05','15:45:00',2.52),('10318','2013-04-05','15:50:00',2.89),('10318','2013-04-05','15:55:00',2.97),('10318','2013-04-05','16:00:00',3.09),('10318','2013-04-05','16:05:00',3.22),('10318','2013-04-05','16:10:00',3.51),('10318','2013-04-05','16:15:00',2.88),('10318','2013-04-05','16:20:00',2.68),('10318','2013-04-05','16:25:00',2.65),('10318','2013-04-05','16:30:00',2.99),('10318','2013-04-05','16:35:00',2.68),('10318','2013-04-05','16:40:00',2.99),('10318','2013-04-05','16:45:00',5.45),('10318','2013-04-05','16:50:00',3.98),('10318','2013-04-05','16:55:00',4.23),('10318','2013-04-05','17:00:00',2.9),('10318','2013-04-05','17:05:00',3.69),('10318','2013-04-05','17:10:00',4.95),('10318','2013-04-05','17:15:00',2.79),('10318','2013-04-05','17:20:00',2.25),('10318','2013-04-05','17:25:00',4.01),('10318','2013-04-05','17:30:00',1.63),('10318','2013-04-05','17:35:00',2.6),('10318','2013-04-05','17:40:00',1.13),('10318','2013-04-05','17:45:00',2.17),('10318','2013-04-05','17:50:00',2.65),('10318','2013-04-05','17:55:00',2.44),('10318','2013-04-05','18:00:00',2.31),('10318','2013-04-05','18:05:00',1.57),('10318','2013-04-05','18:10:00',1.95),('10318','2013-04-05','18:15:00',1.07),('10318','2013-04-05','18:20:00',1.49),('10318','2013-04-05','18:25:00',1.16),('10318','2013-04-04','07:55:00',1.16),('10318','2013-04-04','08:00:00',1.46),('10318','2013-04-04','08:05:00',1.5),('10318','2013-04-04','08:10:00',1.31),('10318','2013-04-04','08:15:00',1.35),('10318','2013-04-04','08:20:00',1.44),('10318','2013-04-04','08:25:00',1.47),('10318','2013-04-04','08:30:00',1.71),('10318','2013-04-04','08:35:00',2.05),('10318','2013-04-04','08:40:00',1.89),('10318','2013-04-04','08:45:00',1.85),('10318','2013-04-04','08:50:00',2.47),('10318','2013-04-04','08:55:00',3.26),('10318','2013-04-04','09:00:00',5.35),('10318','2013-04-04','09:05:00',2.74),('10318','2013-04-04','09:10:00',2.91),('10318','2013-04-04','09:15:00',2.88),('10318','2013-04-04','09:20:00',3.04),('10318','2013-04-04','09:25:00',2.38),('10318','2013-04-04','09:30:00',4.48),('10318','2013-04-04','09:35:00',6.53),('10318','2013-04-04','09:40:00',4.83),('10318','2013-04-04','09:45:00',4.13),('10318','2013-04-04','09:50:00',2.5),('10318','2013-04-04','09:55:00',3.03),('10318','2013-04-04','10:00:00',4.76),('10318','2013-04-04','10:05:00',5.81),('10318','2013-04-04','10:10:00',4.86),('10318','2013-04-04','10:15:00',3.76),('10318','2013-04-04','10:20:00',4.31),('10318','2013-04-04','10:25:00',8.51),('10318','2013-04-04','10:30:00',6.52),('10318','2013-04-04','10:35:00',6.43),('10318','2013-04-04','10:40:00',8.29),('10318','2013-04-04','10:45:00',4.56),('10318','2013-04-04','10:50:00',6.95),('10318','2013-04-04','10:55:00',7.79),('10318','2013-04-04','11:00:00',3.87),('10318','2013-04-04','11:05:00',2.59),('10318','2013-04-04','11:10:00',2.59),('10318','2013-04-04','11:15:00',3.55),('10318','2013-04-04','11:20:00',2.78),('10318','2013-04-04','11:25:00',2.45),('10318','2013-04-04','11:30:00',2.72),('10318','2013-04-04','11:35:00',4.2),('10318','2013-04-04','11:40:00',7.04),('10318','2013-04-04','11:45:00',7.69),('10318','2013-04-04','11:50:00',8.92),('10318','2013-04-04','11:55:00',8.76),('10318','2013-04-04','12:00:00',7.53),('10318','2013-04-04','12:05:00',9.48),('10318','2013-04-04','12:10:00',9.01),('10318','2013-04-04','12:15:00',6.55),('10318','2013-04-04','12:20:00',4.79),('10318','2013-04-04','12:25:00',6.2),('10318','2013-04-04','12:30:00',7.77),('10318','2013-04-04','12:35:00',7.24),('10318','2013-04-04','12:40:00',9.84),('10318','2013-04-04','12:45:00',7.42),('10318','2013-04-04','12:50:00',7.64),('10318','2013-04-04','12:55:00',6.41),('10318','2013-04-04','13:00:00',4.04),('10318','2013-04-04','13:05:00',6.93),('10318','2013-04-04','13:10:00',9.53),('10318','2013-04-04','13:15:00',9.35),('10318','2013-04-04','13:20:00',9.13),('10318','2013-04-04','13:25:00',9.54),('10318','2013-04-04','13:30:00',8.94),('10318','2013-04-04','13:35:00',8.06),('10318','2013-04-04','13:40:00',7.38),('10318','2013-04-04','13:45:00',7.38),('10318','2013-04-04','13:50:00',6.98),('10318','2013-04-04','13:55:00',5.24),('10318','2013-04-04','14:00:00',6.12),('10318','2013-04-04','14:05:00',8.01),('10318','2013-04-04','14:10:00',8.79),('10318','2013-04-04','14:15:00',8.39),('10318','2013-04-04','14:20:00',8.22),('10318','2013-04-04','14:25:00',8.07),('10318','2013-04-04','14:30:00',8.17),('10318','2013-04-04','14:35:00',8.09),('10318','2013-04-04','14:40:00',8),('10318','2013-04-04','14:45:00',7.79),('10318','2013-04-04','14:50:00',7.7),('10318','2013-04-04','14:55:00',7.58),('10318','2013-04-04','15:00:00',7.5),('10318','2013-04-04','15:05:00',7.24),('10318','2013-04-04','15:10:00',6.48),('10318','2013-04-04','15:15:00',6.73),('10318','2013-04-04','15:20:00',6.72),('10318','2013-04-04','15:25:00',6.99),('10318','2013-04-04','15:30:00',6.76),('10318','2013-04-04','15:35:00',6.54),('10318','2013-04-04','15:40:00',6.35),('10318','2013-04-04','15:45:00',6.23),('10318','2013-04-04','15:50:00',6.06),('10318','2013-04-04','15:55:00',5.9),('10318','2013-04-04','16:00:00',5.73),('10318','2013-04-04','16:05:00',5.53),('10318','2013-04-04','16:10:00',5.22),('10318','2013-04-04','16:15:00',4.97),('10318','2013-04-04','16:20:00',4.61),('10318','2013-04-04','16:25:00',5.04),('10318','2013-04-04','16:30:00',4.32),('10318','2013-04-04','16:35:00',3.73),('10318','2013-04-04','16:40:00',4.12),('10318','2013-04-04','16:45:00',2.94),('10318','2013-04-04','16:50:00',3.44),('10318','2013-04-04','16:55:00',3.57),('10318','2013-04-04','17:00:00',3.32),('10318','2013-04-04','17:05:00',3.25),('10318','2013-04-04','17:10:00',2.61),('10318','2013-04-04','17:15:00',2.67),('10318','2013-04-04','17:20:00',2.05),('10318','2013-04-04','17:25:00',2.2),('10318','2013-04-04','17:30:00',1.53),('10318','2013-04-04','17:35:00',1.54),('10318','2013-04-04','17:40:00',1.74),('10318','2013-04-04','17:45:00',1.65),('10318','2013-04-04','17:50:00',1.84),('10318','2013-04-04','17:55:00',2.18),('10318','2013-04-04','18:00:00',2.01),('10318','2013-04-04','18:05:00',1.62),('10318','2013-04-03','07:45:00',1.03),('10318','2013-04-03','07:50:00',1.22),('10318','2013-04-03','07:55:00',1.44),('10318','2013-04-03','08:00:00',2.27),('10318','2013-04-03','08:05:00',2.73),('10318','2013-04-03','08:10:00',2.86),('10318','2013-04-03','08:15:00',3.61),('10318','2013-04-03','08:20:00',3.84),('10318','2013-04-03','08:25:00',3.99),('10318','2013-04-03','08:30:00',3.56),('10318','2013-04-03','08:35:00',3.53),('10318','2013-04-03','08:40:00',4.14),('10318','2013-04-03','08:45:00',4.98),('10318','2013-04-03','08:50:00',5.22),('10318','2013-04-03','08:55:00',5.41),('10318','2013-04-03','09:00:00',5.6),('10318','2013-04-03','09:05:00',5.94),('10318','2013-04-03','09:10:00',6.07),('10318','2013-04-03','09:15:00',5.04),('10318','2013-04-03','09:20:00',5.58),('10318','2013-04-03','09:25:00',7.61),('10318','2013-04-03','09:30:00',6.62),('10318','2013-04-03','09:35:00',6.05),('10318','2013-04-03','09:40:00',7.09),('10318','2013-04-03','09:45:00',6.43),('10318','2013-04-03','09:50:00',7.78),('10318','2013-04-03','09:55:00',6.54),('10318','2013-04-03','10:00:00',3.04),('10318','2013-04-03','10:05:00',2.95),('10318','2013-04-03','10:10:00',4.36),('10318','2013-04-03','10:15:00',3.54),('10318','2013-04-03','10:20:00',8.38),('10318','2013-04-03','10:25:00',5.79),('10318','2013-04-03','10:30:00',4.82),('10318','2013-04-03','10:35:00',4.18),('10318','2013-04-03','10:40:00',3.73),('10318','2013-04-03','10:45:00',5.29),('10318','2013-04-03','10:50:00',5.15),('10318','2013-04-03','10:55:00',9.11),('10318','2013-04-03','11:00:00',7.43),('10318','2013-04-03','11:05:00',10.09),('10318','2013-04-03','11:10:00',7.64),('10318','2013-04-03','11:15:00',6.13),('10318','2013-04-03','11:20:00',4.84),('10318','2013-04-03','11:25:00',3.43),('10318','2013-04-03','11:30:00',3.69),('10318','2013-04-03','11:35:00',2.66),('10318','2013-04-03','11:40:00',4.38),('10318','2013-04-03','11:45:00',6.19),('10318','2013-04-03','11:50:00',5.89),('10318','2013-04-03','11:55:00',4.4),('10318','2013-04-03','12:00:00',8.23),('10318','2013-04-03','12:05:00',5.28),('10318','2013-04-03','12:10:00',3.76),('10318','2013-04-03','12:15:00',7.09),('10318','2013-04-03','12:20:00',10.39),('10318','2013-04-03','12:25:00',8.19),('10318','2013-04-03','12:30:00',7.8),('10318','2013-04-03','12:35:00',7.47),('10318','2013-04-03','12:40:00',8.63),('10318','2013-04-03','12:45:00',9.15),('10318','2013-04-03','12:50:00',7.48),('10318','2013-04-03','12:55:00',9.43),('10318','2013-04-03','13:00:00',9.78),('10318','2013-04-03','13:05:00',5.07),('10318','2013-04-03','13:10:00',7.64),('10318','2013-04-03','13:15:00',7.2),('10318','2013-04-03','13:20:00',8.27),('10318','2013-04-03','13:25:00',8.56),('10318','2013-04-03','13:30:00',7.98),('10318','2013-04-03','13:35:00',8.27),('10318','2013-04-03','13:40:00',9.94),('10318','2013-04-03','13:45:00',10.09),('10318','2013-04-03','13:50:00',6.4),('10318','2013-04-03','13:55:00',8.06),('10318','2013-04-03','14:00:00',8.62),('10318','2013-04-03','14:05:00',9.82),('10318','2013-04-03','14:10:00',5.98),('10318','2013-04-03','14:15:00',4.75),('10318','2013-04-03','14:20:00',9.69),('10318','2013-04-03','14:25:00',8.14),('10318','2013-04-03','14:30:00',5.81),('10318','2013-04-03','14:35:00',9.33),('10318','2013-04-03','14:40:00',8.16),('10318','2013-04-03','14:45:00',8.3),('10318','2013-04-03','14:50:00',8.45),('10318','2013-04-03','14:55:00',8.84),('10318','2013-04-03','15:00:00',8.56),('10318','2013-04-03','15:05:00',8.79),('10318','2013-04-03','15:10:00',7.75),('10318','2013-04-03','15:15:00',6.84),('10318','2013-04-03','15:20:00',7.52),('10318','2013-04-03','15:25:00',6.7),('10318','2013-04-03','15:30:00',6.75),('10318','2013-04-03','15:35:00',6.44),('10318','2013-04-03','15:40:00',5.73),('10318','2013-04-03','15:45:00',3.43),('10318','2013-04-03','15:50:00',4.76),('10318','2013-04-03','15:55:00',7.35),('10318','2013-04-03','16:00:00',6.68),('10318','2013-04-03','16:05:00',6.42),('10318','2013-04-03','16:10:00',6.37),('10318','2013-04-03','16:15:00',6.2),('10318','2013-04-03','16:20:00',4.93),('10318','2013-04-03','16:25:00',4.86),('10318','2013-04-03','16:30:00',5.23),('10318','2013-04-03','16:35:00',4.64),('10318','2013-04-03','16:40:00',4.89),('10318','2013-04-03','16:45:00',4.83),('10318','2013-04-03','16:50:00',4.64),('10318','2013-04-03','16:55:00',4.45),('10318','2013-04-03','17:00:00',4.24),('10318','2013-04-03','17:05:00',4.08),('10318','2013-04-03','17:10:00',3.84),('10318','2013-04-03','17:15:00',3.54),('10318','2013-04-03','17:20:00',3.42),('10318','2013-04-03','17:25:00',3.19),('10318','2013-04-03','17:30:00',3),('10318','2013-04-03','17:35:00',2.79),('10318','2013-04-03','17:40:00',2.62),('10318','2013-04-03','17:45:00',2.44),('10318','2013-04-03','17:50:00',2.23),('10318','2013-04-03','17:55:00',2.04),('10318','2013-04-03','18:00:00',1.86),('10318','2013-04-03','18:05:00',1.54),('10318','2013-04-03','18:10:00',1.51),('10318','2013-04-03','18:15:00',1.37),('10318','2013-04-03','18:20:00',1.22),('10318','2013-04-03','18:25:00',1.07),('10318','2013-04-02','08:30:00',1.61),('10318','2013-04-02','08:35:00',1.85),('10318','2013-04-02','08:40:00',4.24),('10318','2013-04-02','08:45:00',4.98),('10318','2013-04-02','08:50:00',3.18),('10318','2013-04-02','08:55:00',2.56),('10318','2013-04-02','09:00:00',5.56),('10318','2013-04-02','09:05:00',5.81),('10318','2013-04-02','09:10:00',5.96),('10318','2013-04-02','09:15:00',6.22),('10318','2013-04-02','09:20:00',6.35),('10318','2013-04-02','09:25:00',6.6),('10318','2013-04-02','09:30:00',5.63),('10318','2013-04-02','09:35:00',5.81),('10318','2013-04-02','09:40:00',6.43),('10318','2013-04-02','09:45:00',5.38),('10318','2013-04-02','09:50:00',5.26),('10318','2013-04-02','09:55:00',7.31),('10318','2013-04-02','10:00:00',6.53),('10318','2013-04-02','10:05:00',3.87),('10318','2013-04-02','10:10:00',5.56),('10318','2013-04-02','10:15:00',3.26),('10318','2013-04-02','10:20:00',6.76),('10318','2013-04-02','10:25:00',7.24),('10318','2013-04-02','10:30:00',7.44),('10318','2013-04-02','10:35:00',9.05),('10318','2013-04-02','10:40:00',8.18),('10318','2013-04-02','10:45:00',2.68),('10318','2013-04-02','10:50:00',9.04),('10318','2013-04-02','10:55:00',2.64),('10318','2013-04-02','11:00:00',7.26),('10318','2013-04-02','11:05:00',6.44),('10318','2013-04-02','11:10:00',3.43),('10318','2013-04-02','11:15:00',3.03),('10318','2013-04-02','11:20:00',7.67),('10318','2013-04-02','11:25:00',7),('10318','2013-04-02','11:30:00',8.43),('10318','2013-04-02','11:35:00',6.02),('10318','2013-04-02','11:40:00',6.1),('10318','2013-04-02','11:45:00',4.43),('10318','2013-04-02','11:50:00',2.72),('10318','2013-04-02','11:55:00',1.71),('10318','2013-04-02','12:00:00',2.39),('10318','2013-04-02','12:05:00',6.68),('10318','2013-04-02','12:10:00',9.33),('10318','2013-04-02','12:15:00',4.38),('10318','2013-04-02','12:20:00',1.39),('10318','2013-04-02','12:25:00',1.29),('10318','2013-04-02','12:30:00',2.74),('10318','2013-04-02','12:35:00',7.07),('10318','2013-04-02','12:40:00',4.52),('10318','2013-04-02','12:45:00',5.89),('10318','2013-04-02','12:50:00',5.25),('10318','2013-04-02','12:55:00',7.46),('10318','2013-04-02','13:00:00',6.39),('10318','2013-04-02','13:05:00',7.36),('10318','2013-04-02','13:10:00',5.07),('10318','2013-04-02','13:15:00',5.81),('10318','2013-04-02','13:20:00',3.9),('10318','2013-04-02','13:25:00',4.56),('10318','2013-04-02','13:30:00',4.9),('10318','2013-04-02','13:35:00',4.87),('10318','2013-04-02','13:40:00',7.68),('10318','2013-04-02','13:45:00',5.6),('10318','2013-04-02','13:50:00',4.57),('10318','2013-04-02','13:55:00',3.59),('10318','2013-04-02','14:00:00',4.89),('10318','2013-04-02','14:05:00',5.97),('10318','2013-04-02','14:10:00',5.98),('10318','2013-04-02','14:15:00',5.85),('10318','2013-04-02','14:20:00',7.35),('10318','2013-04-02','14:25:00',8.76),('10318','2013-04-02','14:30:00',6.39),('10318','2013-04-02','14:35:00',4.6),('10318','2013-04-02','14:40:00',8.23),('10318','2013-04-02','14:45:00',7.07),('10318','2013-04-02','14:50:00',3.5),('10318','2013-04-02','14:55:00',3.44),('10318','2013-04-02','15:00:00',2.76),('10318','2013-04-02','15:05:00',1.84),('10318','2013-04-02','15:10:00',1.81),('10318','2013-04-02','15:15:00',2.32),('10318','2013-04-02','15:20:00',2.55),('10318','2013-04-02','15:25:00',1.05),('10318','2013-04-02','15:35:00',1.88),('10318','2013-04-02','15:40:00',2.12),('10318','2013-04-02','15:45:00',2.48),('10318','2013-04-02','15:50:00',1.95),('10318','2013-04-02','15:55:00',2.23),('10318','2013-04-02','16:00:00',2.65),('10318','2013-04-02','16:05:00',2.57),('10318','2013-04-02','16:10:00',1.93),('10318','2013-04-02','16:15:00',2.3),('10318','2013-04-02','16:20:00',2.09),('10318','2013-04-02','16:25:00',1.94),('10318','2013-04-02','16:30:00',2.18),('10318','2013-04-02','16:35:00',2.01),('10318','2013-04-02','16:40:00',1.95),('10318','2013-04-02','16:45:00',1.57),('10318','2013-04-02','16:55:00',1.32),('10318','2013-04-02','17:00:00',1.68),('10318','2013-04-02','17:05:00',1.39),('10318','2013-04-02','17:10:00',1.11),('10318','2013-04-02','17:15:00',1.03),('10318','2013-04-02','17:35:00',1.28),('10318','2013-04-02','17:40:00',1.78),('10318','2013-04-02','17:45:00',2.31),('10318','2014-05-02','07:05:00',1.08),('10318','2014-05-02','07:10:00',1.33),('10318','2014-05-02','07:30:00',1.18),('10318','2014-05-02','07:35:00',2.84),('10318','2014-05-02','07:40:00',3.14),('10318','2014-05-02','07:45:00',3.29),('10318','2014-05-02','07:50:00',3.8),('10318','2014-05-02','07:55:00',4.04),('10318','2014-05-02','08:00:00',3.9),('10318','2014-05-02','08:05:00',3.69),('10318','2014-05-02','08:10:00',3.07),('10318','2014-05-02','08:15:00',2.71),('10318','2014-05-02','08:20:00',1.79),('10318','2014-05-02','08:25:00',1.77),('10318','2014-05-02','08:30:00',1.64),('10318','2014-05-02','08:35:00',1.77),('10318','2014-05-02','08:40:00',2.69),('10318','2014-05-02','08:45:00',3.79),('10318','2014-05-02','08:50:00',1.93),('10318','2014-05-02','08:55:00',1.9),('10318','2014-05-02','09:00:00',2.33),('10318','2014-05-02','09:05:00',2.54),('10318','2014-05-02','09:10:00',2.73),('10318','2014-05-02','09:15:00',4.27),('10318','2014-05-02','09:20:00',4.94),('10318','2014-05-02','09:25:00',4.16),('10318','2014-05-02','09:30:00',4.16),('10318','2014-05-02','09:35:00',5.41),('10318','2014-05-02','09:40:00',5.27),('10318','2014-05-02','09:45:00',3.14),('10318','2014-05-02','09:50:00',3.39),('10318','2014-05-02','09:55:00',3.82),('10318','2014-05-02','10:00:00',5.72),('10318','2014-05-02','10:05:00',4.26),('10318','2014-05-02','10:10:00',2.81),('10318','2014-05-02','10:15:00',2.92),('10318','2014-05-02','10:20:00',2.47),('10318','2014-05-02','10:25:00',2.22),('10318','2014-05-02','10:30:00',2.13),('10318','2014-05-02','10:35:00',2.29),('10318','2014-05-02','10:40:00',2.54),('10318','2014-05-02','10:45:00',2.72),('10318','2014-05-02','10:50:00',2.37),('10318','2014-05-02','10:55:00',1.62),('10318','2014-05-02','11:00:00',1.46),('10318','2014-05-02','11:05:00',1.37),('10318','2014-05-02','11:10:00',1.3),('10318','2014-05-02','11:50:00',1.07),('10318','2014-05-02','12:15:00',1.24),('10318','2014-05-02','12:20:00',1.77),('10318','2014-05-02','12:25:00',2.15),('10318','2014-05-02','12:30:00',2.04),('10318','2014-05-02','12:35:00',2.49),('10318','2014-05-02','12:40:00',3.56),('10318','2014-05-02','12:45:00',4.23),('10318','2014-05-02','12:50:00',4.47),('10318','2014-05-02','12:55:00',4.22),('10318','2014-05-02','13:00:00',4.72),('10318','2014-05-02','13:05:00',4.91),('10318','2014-05-02','13:10:00',5.72),('10318','2014-05-02','13:15:00',9.3),('10318','2014-05-02','13:20:00',7.04),('10318','2014-05-02','13:25:00',9.35),('10318','2014-05-02','13:30:00',8.5),('10318','2014-05-02','13:35:00',7.25),('10318','2014-05-02','13:40:00',7.65),('10318','2014-05-02','13:45:00',6.63),('10318','2014-05-02','13:50:00',5.52),('10318','2014-05-02','13:55:00',6.52),('10318','2014-05-02','14:00:00',4.88),('10318','2014-05-02','14:05:00',5.75),('10318','2014-05-02','14:10:00',3.33),('10318','2014-05-02','14:15:00',2.19),('10318','2014-05-02','14:20:00',2.39),('10318','2014-05-02','14:25:00',2.89),('10318','2014-05-02','14:30:00',3.37),('10318','2014-05-02','14:35:00',5.03),('10318','2014-05-02','14:40:00',4.15),('10318','2014-05-02','14:45:00',2.5),('10318','2014-05-02','14:50:00',2.01),('10318','2014-05-02','14:55:00',4.45),('10318','2014-05-02','15:00:00',3.91),('10318','2014-05-02','15:05:00',5.7),('10318','2014-05-02','15:10:00',4.16),('10318','2014-05-02','15:15:00',4.66),('10318','2014-05-02','15:20:00',6.57),('10318','2014-05-02','15:25:00',5.73),('10318','2014-05-02','15:30:00',3.68),('10318','2014-05-02','15:35:00',4.06),('10318','2014-05-02','15:40:00',3.51),('10318','2014-05-02','15:45:00',1.89),('10318','2014-05-02','15:50:00',2.46),('10318','2014-05-02','15:55:00',3.48),('10318','2014-05-02','16:00:00',3.24),('10318','2014-05-02','16:05:00',2.94),('10318','2014-05-02','16:10:00',2.47),('10318','2014-05-02','16:15:00',2.72),('10318','2014-05-02','16:20:00',2.24),('10318','2014-05-02','16:25:00',1.74),('10318','2014-05-02','16:30:00',1.07),('10318','2014-05-02','16:50:00',1.35),('10318','2014-05-02','16:55:00',1.51),('10318','2014-05-02','17:10:00',1.09),('10318','2014-05-02','17:15:00',1.77),('10318','2014-05-02','17:20:00',1.9),('10318','2014-05-02','17:25:00',1.99),('10318','2014-05-02','17:30:00',1.63),('10318','2014-05-02','17:35:00',1.49),('10318','2014-05-02','17:40:00',1.38),('10318','2014-05-02','17:45:00',1.17),('10318','2014-05-02','18:00:00',1.01),('10318','2014-03-27','07:30:00',1.02),('10318','2014-03-27','07:35:00',1.04),('10318','2014-03-27','07:40:00',1.05),('10318','2014-03-27','07:45:00',1.36),('10318','2014-03-27','07:50:00',1.87),('10318','2014-03-27','07:55:00',2.32),('10318','2014-03-27','08:00:00',2.96),('10318','2014-03-27','08:05:00',3.24),('10318','2014-03-27','08:10:00',1.53),('10318','2014-03-27','09:05:00',1.12),('10318','2014-03-27','09:10:00',2.22),('10318','2014-03-27','09:15:00',2.54),('10318','2014-03-27','09:20:00',2.36),('10318','2014-03-27','09:25:00',2.16),('10318','2014-03-27','09:30:00',1.85),('10318','2014-03-27','09:35:00',1.44),('10318','2014-03-27','09:40:00',1.06),('10318','2014-03-27','09:50:00',1.05),('10318','2014-03-27','09:55:00',1.32),('10318','2014-03-27','10:00:00',2.08),('10318','2014-03-27','10:05:00',2.94),('10318','2014-03-27','10:10:00',3.16),('10318','2014-03-27','10:15:00',3.8),('10318','2014-03-27','10:20:00',5.2),('10318','2014-03-27','10:25:00',5.23),('10318','2014-03-27','10:30:00',5.49),('10318','2014-03-27','10:35:00',3.82),('10318','2014-03-27','10:40:00',2.81),('10318','2014-03-27','10:45:00',3.37),('10318','2014-03-27','10:50:00',2.49),('10318','2014-03-27','10:55:00',1.64),('10318','2014-03-27','11:00:00',1.4),('10318','2014-03-27','11:05:00',2.54),('10318','2014-03-27','11:10:00',5.59),('10318','2014-03-27','11:15:00',4.16),('10318','2014-03-27','11:20:00',2.37),('10318','2014-03-27','11:25:00',1.53),('10318','2014-03-27','11:45:00',1.7),('10318','2014-03-27','11:50:00',3.55),('10318','2014-03-27','11:55:00',4.4),('10318','2014-03-27','12:00:00',3.37),('10318','2014-03-27','12:05:00',2.72),('10318','2014-03-27','12:10:00',1.6),('10318','2014-03-27','12:15:00',1.23),('10318','2014-03-27','12:20:00',1.57),('10318','2014-03-27','12:25:00',1.13),('10318','2014-03-27','12:50:00',1.21),('10318','2014-03-27','12:55:00',1.82),('10318','2014-03-27','13:00:00',2.54),('10318','2014-03-27','13:05:00',3.08),('10318','2014-03-27','13:10:00',4.38),('10318','2014-03-27','13:15:00',5.99),('10318','2014-03-27','13:20:00',5.29),('10318','2014-03-27','13:25:00',5.78),('10318','2014-03-27','13:30:00',4.59),('10318','2014-03-27','13:35:00',4.4),('10318','2014-03-27','13:40:00',4.35),('10318','2014-03-27','13:45:00',3.67),('10318','2014-03-27','13:50:00',4.59),('10318','2014-03-27','13:55:00',5.7),('10318','2014-03-27','14:00:00',6.25),('10318','2014-03-27','14:05:00',4.04),('10318','2014-03-27','14:10:00',1.46),('10318','2014-03-27','14:15:00',3.24),('10318','2014-03-27','14:20:00',7.49),('10318','2014-03-27','14:25:00',5.22),('10318','2014-03-27','14:30:00',3.96),('10318','2014-03-27','14:35:00',5.87),('10318','2014-03-27','14:40:00',7.21),('10318','2014-03-27','14:45:00',4.36),('10318','2014-03-27','14:50:00',4),('10318','2014-03-27','14:55:00',5.95),('10318','2014-03-27','15:00:00',7.16),('10318','2014-03-27','15:05:00',1.72),('10318','2014-03-27','15:10:00',1.56),('10318','2014-03-27','15:15:00',1.16),('10318','2014-03-27','15:20:00',1.17),('10318','2014-03-27','15:25:00',3.02),('10318','2014-03-27','15:30:00',3.24),('10318','2014-03-27','15:35:00',2.61),('10318','2014-03-27','15:40:00',4.76),('10318','2014-03-27','15:45:00',1.46),('10318','2014-03-27','15:50:00',1.24),('10318','2014-03-27','15:55:00',1.4),('10318','2014-03-27','16:00:00',1.62),('10318','2014-03-27','16:05:00',1.66),('10318','2014-03-27','16:10:00',1.61),('10318','2014-03-27','16:15:00',1.6),('10318','2014-03-27','16:20:00',1.73),('10318','2014-03-27','16:25:00',2.48),('10318','2014-03-27','16:30:00',2.41),('10318','2014-03-27','16:35:00',1.98),('10318','2014-03-27','16:40:00',2.09),('10318','2014-03-27','16:45:00',2.27),('10318','2014-03-27','16:50:00',2.14),('10318','2014-03-27','16:55:00',2.64),('10318','2014-03-27','17:00:00',1.98),('10318','2014-03-27','17:05:00',1.69),('10318','2014-03-27','17:10:00',1.43),('10318','2014-03-27','17:15:00',1.28),('10318','2013-04-01','08:20:00',2.94),('10318','2013-04-01','08:25:00',4.31),('10318','2013-04-01','08:30:00',3.7),('10318','2013-04-01','08:35:00',1.79),('10318','2013-04-01','08:40:00',1.87),('10318','2013-04-01','08:45:00',1.46),('10318','2013-04-01','08:50:00',1.41),('10318','2013-04-01','08:55:00',3.88),('10318','2013-04-01','09:00:00',5.61),('10318','2013-04-01','09:05:00',5.84),('10318','2013-04-01','09:10:00',6.03),('10318','2013-04-01','09:15:00',5.9),('10318','2013-04-01','09:20:00',5.52),('10318','2013-04-01','09:25:00',5.9),('10318','2013-04-01','09:30:00',4.66),('10318','2013-04-01','09:35:00',7.07),('10318','2013-04-01','09:40:00',7.12),('10318','2013-04-01','09:45:00',6.35),('10318','2013-04-01','09:50:00',6.49),('10318','2013-04-01','09:55:00',6.61),('10318','2013-04-01','10:00:00',7.66),('10318','2013-04-01','10:05:00',7.79),('10318','2013-04-01','10:10:00',6.96),('10318','2013-04-01','10:15:00',7.36),('10318','2013-04-01','10:20:00',7.96),('10318','2013-04-01','10:25:00',8.03),('10318','2013-04-01','10:30:00',7.99),('10318','2013-04-01','10:35:00',7.58),('10318','2013-04-01','10:40:00',8.19),('10318','2013-04-01','10:45:00',8.12),('10318','2013-04-01','10:50:00',8.99),('10318','2013-04-01','10:55:00',7.52),('10318','2013-04-01','11:00:00',9.35),('10318','2013-04-01','11:05:00',7.2),('10318','2013-04-01','11:10:00',4.21),('10318','2013-04-01','11:15:00',9.94),('10318','2013-04-01','11:20:00',7.99),('10318','2013-04-01','11:25:00',7.38),('10318','2013-04-01','11:30:00',5.99),('10318','2013-04-01','11:35:00',5.46),('10318','2013-04-01','11:40:00',6.23),('10318','2013-04-01','11:45:00',4.1),('10318','2013-04-01','11:50:00',4.72),('10318','2013-04-01','11:55:00',5.11),('10318','2013-04-01','12:00:00',4.64),('10318','2013-04-01','12:05:00',3.62),('10318','2013-04-01','12:10:00',3.92),('10318','2013-04-01','12:15:00',3.51),('10318','2013-04-01','12:20:00',2.94),('10318','2013-04-01','12:25:00',3.25),('10318','2013-04-01','12:30:00',5.39),('10318','2013-04-01','12:35:00',5.02),('10318','2013-04-01','12:40:00',5.7),('10318','2013-04-01','12:45:00',5.98),('10318','2013-04-01','12:50:00',6.46),('10318','2013-04-01','12:55:00',6.92),('10318','2013-04-01','13:00:00',6.88),('10318','2013-04-01','13:05:00',7.66),('10318','2013-04-01','13:10:00',6.66),('10318','2013-04-01','13:15:00',6.47),('10318','2013-04-01','13:20:00',6.19),('10318','2013-04-01','13:25:00',6.03),('10318','2013-04-01','13:30:00',6.75),('10318','2013-04-01','13:35:00',5.3),('10318','2013-04-01','13:40:00',7.21),('10318','2013-04-01','13:45:00',7.57),('10318','2013-04-01','13:50:00',8.63),('10318','2013-04-01','13:55:00',8.12),('10318','2013-04-01','14:00:00',4.54),('10318','2013-04-01','14:05:00',4.05),('10318','2013-04-01','14:10:00',5.18),('10318','2013-04-01','14:15:00',5.29),('10318','2013-04-01','14:20:00',5.95),('10318','2013-04-01','14:25:00',9.21),('10318','2013-04-01','14:30:00',6.96),('10318','2013-04-01','14:35:00',5.3),('10318','2013-04-01','14:40:00',4.33),('10318','2013-04-01','14:45:00',4.65),('10318','2013-04-01','14:50:00',4.92),('10318','2013-04-01','14:55:00',4.74),('10318','2013-04-01','15:00:00',4.26),('10318','2013-04-01','15:05:00',4.17),('10318','2013-04-01','15:10:00',4.44),('10318','2013-04-01','15:15:00',4.77),('10318','2013-04-01','15:20:00',4.68),('10318','2013-04-01','15:25:00',4.93),('10318','2013-04-01','15:30:00',4.6),('10318','2013-04-01','15:35:00',5.09),('10318','2013-04-01','15:40:00',4.56),('10318','2013-04-01','15:45:00',4.19),('10318','2013-04-01','15:50:00',4.22),('10318','2013-04-01','15:55:00',4.1),('10318','2013-04-01','16:00:00',4),('10318','2013-04-01','16:05:00',3.44),('10318','2013-04-01','16:10:00',2.77),('10318','2013-04-01','16:15:00',2.2),('10318','2013-04-01','16:20:00',2.25),('10318','2013-04-01','16:25:00',2.09),('10318','2013-04-01','16:30:00',1.61),('10318','2013-04-01','16:35:00',1.64),('10318','2013-04-01','16:40:00',1.47),('10318','2013-04-01','16:45:00',1.12),('10318','2013-03-31','08:15:00',1.32),('10318','2013-03-31','08:20:00',1.53),('10318','2013-03-31','08:25:00',1.49),('10318','2013-03-31','08:30:00',3.18),('10318','2013-03-31','08:35:00',1.52),('10318','2013-03-31','08:40:00',2.17),('10318','2013-03-31','08:45:00',2.3),('10318','2013-03-31','08:50:00',3.46),('10318','2013-03-31','08:55:00',3.78),('10318','2013-03-31','09:00:00',2.32),('10318','2013-03-31','09:05:00',2.08),('10318','2013-03-31','09:10:00',2.57),('10318','2013-03-31','09:15:00',3.61),('10318','2013-03-31','09:20:00',4.03),('10318','2013-03-31','09:25:00',6.47),('10318','2013-03-31','09:30:00',5.46),('10318','2013-03-31','09:35:00',7.99),('10318','2013-03-31','09:40:00',7.05),('10318','2013-03-31','09:45:00',5.86),('10318','2013-03-31','09:50:00',2.73),('10318','2013-03-31','09:55:00',3.27),('10318','2013-03-31','10:00:00',1.98),('10318','2013-03-31','10:05:00',1.26),('10318','2013-03-31','10:10:00',1.89),('10318','2013-03-31','10:15:00',3.36),('10318','2013-03-31','10:20:00',4.21),('10318','2013-03-31','10:25:00',5.71),('10318','2013-03-31','10:30:00',4.26),('10318','2013-03-31','10:35:00',5.38),('10318','2013-03-31','10:40:00',1.81),('10318','2013-03-31','10:45:00',3.39),('10318','2013-03-31','10:50:00',4.93),('10318','2013-03-31','10:55:00',2.25),('10318','2013-03-31','11:00:00',1.78),('10318','2013-03-31','11:05:00',2.9),('10318','2013-03-31','11:10:00',2.61),('10318','2013-03-31','11:15:00',2),('10318','2013-03-31','11:20:00',2.42),('10318','2013-03-31','11:25:00',5.06),('10318','2013-03-31','11:30:00',4.35),('10318','2013-03-31','11:35:00',4.51),('10318','2013-03-31','11:40:00',5.79),('10318','2013-03-31','11:45:00',6.28),('10318','2013-03-31','11:50:00',5.73),('10318','2013-03-31','11:55:00',3.45),('10318','2013-03-31','12:00:00',3.12),('10318','2013-03-31','12:05:00',2.56),('10318','2013-03-31','12:10:00',2.83),('10318','2013-03-31','12:15:00',2.4),('10318','2013-03-31','12:20:00',1.89),('10318','2013-03-31','12:25:00',2.83),('10318','2013-03-31','12:30:00',4.98),('10318','2013-03-31','12:35:00',8.89),('10318','2013-03-31','12:40:00',8.73),('10318','2013-03-31','12:45:00',4.77),('10318','2013-03-31','12:50:00',5.25),('10318','2013-03-31','12:55:00',5.51),('10318','2013-03-31','13:00:00',5.8),('10318','2013-03-31','13:05:00',4.38),('10318','2013-03-31','13:10:00',6.73),('10318','2013-03-31','13:15:00',9.23),('10318','2013-03-31','13:20:00',8.83),('10318','2013-03-31','13:25:00',7.94),('10318','2013-03-31','13:30:00',2.08),('10318','2013-03-31','13:35:00',1.84),('10318','2013-03-31','13:40:00',7.19),('10318','2013-03-31','13:45:00',7.6),('10318','2013-03-31','13:50:00',5.59),('10318','2013-03-31','13:55:00',4.94),('10318','2013-03-31','14:00:00',5.39),('10318','2013-03-31','14:05:00',2.86),('10318','2013-03-31','14:10:00',4.5),('10318','2013-03-31','14:15:00',5.56),('10318','2013-03-31','14:20:00',5.8),('10318','2013-03-31','14:25:00',9.34),('10318','2013-03-31','14:30:00',4.83),('10318','2013-03-31','14:35:00',5.55),('10318','2013-03-31','14:40:00',6.85),('10318','2013-03-31','14:45:00',8.41),('10318','2013-03-31','14:50:00',6.68),('10318','2013-03-31','14:55:00',7.05),('10318','2013-03-31','15:00:00',7.82),('10318','2013-03-31','15:05:00',6.27),('10318','2013-03-31','15:10:00',6.72),('10318','2013-03-31','15:15:00',7.88),('10318','2013-03-31','15:20:00',9.15),('10318','2013-03-31','15:25:00',5.93),('10318','2013-03-31','15:30:00',5.42),('10318','2013-03-31','15:35:00',7.27),('10318','2013-03-31','15:40:00',5.89),('10318','2013-03-31','15:45:00',5.06),('10318','2013-03-31','15:50:00',2.17),('10318','2013-03-31','15:55:00',1.68),('10318','2013-03-31','16:00:00',5.28),('10318','2013-03-31','16:05:00',2.09),('10318','2013-03-31','16:10:00',2.59),('10318','2013-03-31','16:15:00',4.48),('10318','2013-03-31','16:20:00',3.88),('10318','2013-03-31','16:25:00',2.71),('10318','2013-03-31','16:30:00',2.53),('10318','2013-03-31','16:35:00',2.74),('10318','2013-03-31','16:40:00',2.77),('10318','2013-03-31','16:45:00',2.38),('10318','2013-03-31','16:50:00',1.91),('10318','2013-03-31','16:55:00',1.9),('10318','2013-03-31','17:00:00',2.46),('10318','2013-03-31','17:05:00',2.13),('10318','2013-03-31','17:10:00',1.58),('10318','2013-03-31','17:15:00',1.23),('10318','2013-03-31','17:20:00',1.8),('10318','2013-03-31','17:25:00',1.86),('10318','2013-03-31','17:30:00',2.28),('10318','2013-03-31','17:35:00',2.53),('10318','2013-03-31','17:40:00',2.13),('10318','2013-03-31','17:45:00',2.77),('10318','2013-03-31','17:50:00',3.44),('10318','2013-03-31','17:55:00',3.11),('10318','2013-03-31','18:10:00',1.34),('10318','2013-03-31','18:15:00',2.15),('10318','2013-03-31','18:20:00',1.01),('10318','2013-03-31','18:25:00',1.02),('10318','2013-03-30','07:05:00',1.07),('10318','2013-03-30','07:20:00',1.16),('10318','2013-03-30','07:25:00',1.37),('10318','2013-03-30','07:30:00',1.62),('10318','2013-03-30','07:35:00',1.06),('10318','2013-03-30','07:50:00',1.56),('10318','2013-03-30','07:55:00',1.95),('10318','2013-03-30','08:00:00',1.73),('10318','2013-03-30','08:05:00',1.42),('10318','2013-03-30','08:10:00',1.56),('10318','2013-03-30','08:15:00',1.77),('10318','2013-03-30','08:20:00',1.89),('10318','2013-03-30','08:25:00',2),('10318','2013-03-30','08:30:00',2.35),('10318','2013-03-30','08:35:00',2.69),('10318','2013-03-30','08:40:00',2.38),('10318','2013-03-30','08:45:00',1.68),('10318','2013-03-30','08:50:00',1.49),('10318','2013-03-30','08:55:00',1.21),('10318','2013-03-30','09:00:00',2.73),('10318','2013-03-30','09:05:00',6.51),('10318','2013-03-30','09:10:00',7.09),('10318','2013-03-30','09:15:00',9.22),('10318','2013-03-30','09:20:00',7.91),('10318','2013-03-30','09:25:00',4.85),('10318','2013-03-30','09:30:00',3.8),('10318','2013-03-30','09:35:00',3.37),('10318','2013-03-30','09:40:00',3.49),('10318','2013-03-30','09:45:00',2.64),('10318','2013-03-30','09:50:00',2.66),('10318','2013-03-30','09:55:00',3.7),('10318','2013-03-30','10:00:00',4.65),('10318','2013-03-30','10:05:00',4.24),('10318','2013-03-30','10:10:00',4.26),('10318','2013-03-30','10:15:00',3.42),('10318','2013-03-30','10:20:00',3.16),('10318','2013-03-30','10:25:00',3.38),('10318','2013-03-30','10:30:00',3.91),('10318','2013-03-30','10:35:00',4.62),('10318','2013-03-30','10:40:00',5.47),('10318','2013-03-30','10:45:00',5.64),('10318','2013-03-30','10:50:00',5.3),('10318','2013-03-30','10:55:00',6.56),('10318','2013-03-30','11:00:00',9.91),('10318','2013-03-30','11:05:00',7.43),('10318','2013-03-30','11:10:00',7.9),('10318','2013-03-30','11:15:00',9.8),('10318','2013-03-30','11:20:00',10.61),('10318','2013-03-30','11:25:00',5.43),('10318','2013-03-30','11:30:00',6.59),('10318','2013-03-30','11:35:00',7.79),('10318','2013-03-30','11:40:00',8.61),('10318','2013-03-30','11:45:00',8.55),('10318','2013-03-30','11:50:00',7.06),('10318','2013-03-30','11:55:00',8.15),('10318','2013-03-30','12:00:00',8.6),('10318','2013-03-30','12:05:00',6.22),('10318','2013-03-30','12:10:00',3.37),('10318','2013-03-30','12:15:00',2.83),('10318','2013-03-30','12:20:00',2.45),('10318','2013-03-30','12:25:00',1.55),('10318','2013-03-30','12:30:00',2.6),('10318','2013-03-30','12:35:00',2.19),('10318','2013-03-30','12:40:00',1.07),('10318','2013-03-30','12:45:00',1.43),('10318','2013-03-30','12:50:00',1.37),('10318','2013-03-30','12:55:00',1.11),('10318','2013-03-30','13:00:00',1.04),('10318','2013-03-30','13:05:00',3.68),('10318','2013-03-30','13:10:00',7.68),('10318','2013-03-30','13:15:00',5.22),('10318','2013-03-30','13:20:00',4.56),('10318','2013-03-30','13:25:00',3.79),('10318','2013-03-30','13:30:00',3.28),('10318','2013-03-30','13:35:00',3.35),('10318','2013-03-30','13:40:00',4.78),('10318','2013-03-30','13:45:00',6.23),('10318','2013-03-30','13:50:00',5.96),('10318','2013-03-30','13:55:00',3.9),('10318','2013-03-30','14:00:00',4.59),('10318','2013-03-30','14:05:00',4.11),('10318','2013-03-30','14:10:00',3.69),('10318','2013-03-30','14:15:00',2.61),('10318','2013-03-30','14:20:00',3.44),('10318','2013-03-30','14:25:00',3.66),('10318','2013-03-30','14:30:00',2.68),('10318','2013-03-30','14:35:00',1.94),('10318','2013-03-30','14:40:00',2.05),('10318','2013-03-30','14:45:00',2.32),('10318','2013-03-30','14:50:00',2.69),('10318','2013-03-30','14:55:00',2.01),('10318','2013-03-30','15:00:00',1.61),('10318','2013-03-30','15:05:00',1.86),('10318','2013-03-30','15:10:00',1.12),('10318','2013-03-30','15:15:00',1.28),('10318','2013-03-30','15:20:00',1.04),('10318','2013-03-30','15:30:00',1.07),('10318','2013-03-30','15:40:00',1.31),('10318','2013-03-30','15:45:00',1.03),('10318','2013-03-30','17:40:00',1.19),('10318','2013-03-30','17:45:00',1.2),('10318','2013-03-29','06:50:00',1.06),('10318','2013-03-29','06:55:00',1.16),('10318','2013-03-29','07:05:00',1.41),('10318','2013-03-29','07:10:00',2.17),('10318','2013-03-29','07:15:00',2.88),('10318','2013-03-29','07:20:00',3.2),('10318','2013-03-29','07:25:00',3.78),('10318','2013-03-29','07:30:00',2.69),('10318','2013-03-29','07:35:00',3.86),('10318','2013-03-29','07:40:00',4.4),('10318','2013-03-29','07:45:00',4.49),('10318','2013-03-29','07:50:00',3.47),('10318','2013-03-29','07:55:00',3.6),('10318','2013-03-29','08:00:00',3.33),('10318','2013-03-29','08:05:00',5),('10318','2013-03-29','08:10:00',4.9),('10318','2013-03-29','08:16:00',5.59),('10318','2013-03-29','08:20:00',5.88),('10318','2013-03-29','08:25:00',6.06),('10318','2013-03-29','08:30:00',6.26),('10318','2013-03-29','08:35:00',6.52),('10318','2013-03-29','08:40:00',6.52),('10318','2013-03-29','08:45:00',6.1),('10318','2013-03-29','08:50:00',6.31),('10318','2013-03-29','08:55:00',5.44),('10318','2013-03-29','09:00:00',6.99),('10318','2013-03-29','09:05:00',7.08),('10318','2013-03-29','09:10:00',7),('10318','2013-03-29','09:15:00',7.78),('10318','2013-03-29','09:20:00',7.85),('10318','2013-03-29','09:25:00',7.03),('10318','2013-03-29','09:30:00',7.61),('10318','2013-03-29','09:35:00',6.48),('10318','2013-03-29','09:40:00',4.96),('10318','2013-03-29','09:45:00',5.42),('10318','2013-03-29','09:50:00',7.4),('10318','2013-03-29','09:55:00',8.4),('10318','2013-03-29','10:00:00',7.7),('10318','2013-03-29','10:05:00',7.35),('10318','2013-03-29','10:10:00',7.39),('10318','2013-03-29','10:15:00',7.78),('10318','2013-03-29','10:20:00',6.96),('10318','2013-03-29','10:25:00',5.68),('10318','2013-03-29','10:30:00',3.82),('10318','2013-03-29','10:35:00',7.54),('10318','2013-03-29','10:40:00',7.85),('10318','2013-03-29','10:45:00',6.29),('10318','2013-03-29','10:50:00',8.04),('10318','2013-03-29','10:55:00',8.81),('10318','2013-03-29','11:00:00',8.88),('10318','2013-03-29','11:05:00',6.51),('10318','2013-03-29','11:10:00',8.48),('10318','2013-03-29','11:15:00',10.11),('10318','2013-03-29','11:20:00',9.93),('10318','2013-03-29','11:25:00',10.14),('10318','2013-03-29','11:30:00',9.81),('10318','2013-03-29','11:35:00',9.46),('10318','2013-03-29','11:40:00',9.49),('10318','2013-03-29','11:45:00',9.87),('10318','2013-03-29','11:50:00',9.88),('10318','2013-03-29','11:55:00',9.94),('10318','2013-03-29','12:00:00',9.88),('10318','2013-03-29','12:05:00',10.01),('10318','2013-03-29','12:10:00',9.56),('10318','2013-03-29','12:15:00',9.27),('10318','2013-03-29','12:20:00',9.42),('10318','2013-03-29','12:25:00',8.96),('10318','2013-03-29','12:30:00',9.5),('10318','2013-03-29','12:35:00',8.78),('10318','2013-03-29','12:40:00',8.76),('10318','2013-03-29','12:45:00',9.35),('10318','2013-03-29','12:50:00',9.34),('10318','2013-03-29','12:55:00',8.96),('10318','2013-03-29','13:00:00',8.05),('10318','2013-03-29','13:05:00',8.88),('10318','2013-03-29','13:10:00',8.48),('10318','2013-03-29','13:15:00',8.18),('10318','2013-03-29','13:20:00',7.87),('10318','2013-03-29','13:25:00',9.71),('10318','2013-03-29','13:30:00',7.25),('10318','2013-03-29','13:35:00',7.21),('10318','2013-03-29','13:40:00',7.1),('10318','2013-03-29','13:45:00',7.55),('10318','2013-03-29','13:50:00',7.31),('10318','2013-03-29','13:55:00',7.56),('10318','2013-03-29','14:00:00',7.82),('10318','2013-03-29','14:05:00',5.85),('10318','2013-03-29','14:10:00',5.19),('10318','2013-03-29','14:15:00',5.19),('10318','2013-03-29','14:20:00',5.15),('10318','2013-03-29','14:25:00',5.23),('10318','2013-03-29','14:30:00',4.56),('10318','2013-03-29','14:35:00',4.46),('10318','2013-03-29','14:40:00',4.35),('10318','2013-03-29','14:45:00',3.97),('10318','2013-03-29','14:50:00',3.87),('10318','2013-03-29','14:55:00',3.68),('10318','2013-03-29','15:00:00',3.45),('10318','2013-03-29','15:05:00',3.48),('10318','2013-03-29','15:10:00',3.2),('10318','2013-03-29','15:15:00',3.17),('10318','2013-03-29','15:20:00',2.93),('10318','2013-03-29','15:25:00',2.68),('10318','2013-03-29','15:30:00',2.52),('10318','2013-03-29','15:35:00',2.42),('10318','2013-03-29','15:40:00',2.29),('10318','2013-03-29','15:45:00',2.26),('10318','2013-03-29','15:50:00',2.56),('10318','2013-03-29','15:55:00',3.15),('10318','2013-03-29','16:00:00',3.02),('10318','2013-03-29','16:05:00',2.98),('10318','2013-03-29','16:10:00',2.33),('10318','2013-03-29','16:15:00',2.1),('10318','2013-03-29','16:20:00',1.93),('10318','2013-03-29','16:25:00',2.44),('10318','2013-03-29','16:30:00',2.15),('10318','2013-03-29','16:35:00',2.76),('10318','2013-03-29','16:40:00',3.59),('10318','2013-03-29','16:45:00',2.9),('10318','2013-03-29','16:50:00',2.15),('10318','2013-03-29','16:55:00',2.02),('10318','2013-03-29','17:00:00',2.24),('10318','2013-03-29','17:05:00',1.53),('10318','2013-03-29','17:10:00',1.12),('10318','2013-03-29','17:15:00',1.24),('10318','2013-03-29','17:20:00',1.68),('10318','2013-03-29','17:25:00',1.54),('10318','2013-03-29','17:30:00',1.33),('10318','2013-03-29','17:35:00',1.06),('10318','2013-03-28','07:30:00',1.13),('10318','2013-03-28','08:40:00',1.13),('10318','2013-03-28','08:45:00',1.11),('10318','2013-03-28','08:50:00',1.26),('10318','2013-03-28','08:55:00',1.4),('10318','2013-03-28','09:00:00',1.43),('10318','2013-03-28','09:05:00',1.96),('10318','2013-03-28','09:10:00',2.99),('10318','2013-03-28','09:15:00',4.15),('10318','2013-03-28','09:20:00',3.43),('10318','2013-03-28','09:25:00',3.86),('10318','2013-03-28','09:30:00',2.86),('10318','2013-03-28','09:35:00',2.06),('10318','2013-03-28','09:40:00',1.92),('10318','2013-03-28','09:45:00',2.27),('10318','2013-03-28','09:50:00',2.28),('10318','2013-03-28','09:55:00',2.58),('10318','2013-03-28','10:00:00',2.62),('10318','2013-03-28','10:05:00',2.06),('10318','2013-03-28','10:10:00',1.54),('10318','2013-03-28','10:15:00',1.58),('10318','2013-03-28','10:20:00',1.11),('10318','2013-03-28','10:25:00',1.1),('10318','2013-03-28','10:30:00',1.24),('10318','2013-03-28','10:35:00',1.29),('10318','2013-03-28','10:40:00',1.07),('10318','2013-03-28','10:50:00',1.09),('10318','2013-03-28','10:55:00',1.2),('10318','2013-03-28','11:00:00',1.94),('10318','2013-03-28','11:05:00',1.48),('10318','2013-03-28','11:10:00',1.77),('10318','2013-03-28','11:15:00',1.19),('10318','2013-03-28','11:30:00',1.15),('10318','2013-03-28','11:35:00',1.21),('10318','2013-03-28','11:40:00',1.42),('10318','2013-03-28','11:45:00',1.56),('10318','2013-03-28','11:50:00',2.08),('10318','2013-03-28','11:55:00',2.9),('10318','2013-03-28','12:00:00',1.91),('10318','2013-03-28','12:05:00',1.54),('10318','2013-03-28','12:10:00',1.47),('10318','2013-03-28','12:15:00',1.59),('10318','2013-03-28','12:20:00',1.8),('10318','2013-03-28','12:25:00',1.96),('10318','2013-03-28','12:30:00',2.82),('10318','2013-03-28','12:35:00',2.19),('10318','2013-03-28','12:40:00',2.95),('10318','2013-03-28','12:45:00',3.29),('10318','2013-03-28','12:50:00',4),('10318','2013-03-28','12:55:00',5.4),('10318','2013-03-28','13:00:00',5.68),('10318','2013-03-28','13:05:00',6.53),('10318','2013-03-28','13:10:00',5.52),('10318','2013-03-28','13:15:00',4.06),('10318','2013-03-28','13:20:00',6.64),('10318','2013-03-28','13:25:00',6.62),('10318','2013-03-28','13:30:00',7.58),('10318','2013-03-28','13:35:00',5.64),('10318','2013-03-28','13:40:00',2.48),('10318','2013-03-28','13:45:00',3),('10318','2013-03-28','13:50:00',4.36),('10318','2013-03-28','13:55:00',2.39),('10318','2013-03-28','14:00:00',3.34),('10318','2013-03-28','14:05:00',3.44),('10318','2013-03-28','14:10:00',2.48),('10318','2013-03-28','14:15:00',2.79),('10318','2013-03-28','14:20:00',3.4),('10318','2013-03-28','14:25:00',2.97),('10318','2013-03-28','14:30:00',3.54),('10318','2013-03-28','14:35:00',3.1),('10318','2013-03-28','14:40:00',2.45),('10318','2013-03-28','14:45:00',2.2),('10318','2013-03-28','14:50:00',1.64),('10318','2013-03-28','14:55:00',2.03),('10318','2013-03-28','15:00:00',2.74),('10318','2013-03-28','15:05:00',3.83),('10318','2013-03-28','15:10:00',7.06),('10318','2013-03-28','15:15:00',6.42),('10318','2013-03-28','15:20:00',5.24),('10318','2013-03-28','15:25:00',2.48),('10318','2013-03-28','15:30:00',3.01),('10318','2013-03-28','15:35:00',2.25),('10318','2013-03-28','15:40:00',2.05),('10318','2013-03-28','15:45:00',2.53),('10318','2013-03-28','15:50:00',2.55),('10318','2013-03-28','15:55:00',3.59),('10318','2013-03-28','16:00:00',2.37),('10318','2013-03-28','16:05:00',2.34),('10318','2013-03-28','16:10:00',2.35),('10318','2013-03-28','16:15:00',1.52),('10318','2013-03-28','16:25:00',1.19),('10318','2013-03-28','16:30:00',1.21),('10318','2013-03-28','16:35:00',1.67),('10318','2013-03-28','16:40:00',1.36),('10318','2013-03-28','16:45:00',1.62),('10318','2013-03-28','16:50:00',1.28),('10318','2013-03-28','16:55:00',1.32),('10318','2013-03-28','17:00:00',1.68),('10318','2013-03-28','17:05:00',2.1),('10318','2013-03-28','17:10:00',1.7),('10318','2013-03-28','17:15:00',1.46),('10318','2013-03-28','17:20:00',1.17),('10318','2013-03-27','06:50:00',1.11),('10318','2013-03-27','06:55:00',1.27),('10318','2013-03-27','07:00:00',1.81),('10318','2013-03-27','07:05:00',1.84),('10318','2013-03-27','07:10:00',2.08),('10318','2013-03-27','07:15:00',2.75),('10318','2013-03-27','07:20:00',3.07),('10318','2013-03-27','07:25:00',3.31),('10318','2013-03-27','07:30:00',3.57),('10318','2013-03-27','07:35:00',3.63),('10318','2013-03-27','07:40:00',3.91),('10318','2013-03-27','07:45:00',4.18),('10318','2013-03-27','07:50:00',4.4),('10318','2013-03-27','07:55:00',3.31),('10318','2013-03-27','08:00:00',3.93),('10318','2013-03-27','08:05:00',3.23),('10318','2013-03-27','08:10:00',3.1),('10318','2013-03-27','08:15:00',3.21),('10318','2013-03-27','08:20:00',2.98),('10318','2013-03-27','08:25:00',4.07),('10318','2013-03-27','08:30:00',4.41),('10318','2013-03-27','08:35:00',4.54),('10318','2013-03-27','08:40:00',3.19),('10318','2013-03-27','08:45:00',4.02),('10318','2013-03-27','08:50:00',4.81),('10318','2013-03-27','08:55:00',3.93),('10318','2013-03-27','09:00:00',1.69),('10318','2013-03-27','09:05:00',1.32),('10318','2013-03-27','09:10:00',1.48),('10318','2013-03-27','09:15:00',1.92),('10318','2013-03-27','09:20:00',2.83),('10318','2013-03-27','09:25:00',2.57),('10318','2013-03-27','09:30:00',3.36),('10318','2013-03-27','09:35:00',2.16),('10318','2013-03-27','09:40:00',4.87),('10318','2013-03-27','09:45:00',6.13),('10318','2013-03-27','09:50:00',3.68),('10318','2013-03-27','09:55:00',2.49),('10318','2013-03-27','10:00:00',2.21),('10318','2013-03-27','10:05:00',1.78),('10318','2013-03-27','10:10:00',1.87),('10318','2013-03-27','10:15:00',2.64),('10318','2013-03-27','10:20:00',2.81),('10318','2013-03-27','10:25:00',3.73),('10318','2013-03-27','10:30:00',6.38),('10318','2013-03-27','10:35:00',5.23),('10318','2013-03-27','10:40:00',6.74),('10318','2013-03-27','10:45:00',6.11),('10318','2013-03-27','10:50:00',5.47),('10318','2013-03-27','10:55:00',4.27),('10318','2013-03-27','11:00:00',3.71),('10318','2013-03-27','11:05:00',3.47),('10318','2013-03-27','11:10:00',3.48),('10318','2013-03-27','11:15:00',3.82),('10318','2013-03-27','11:20:00',3.96),('10318','2013-03-27','11:25:00',4.35),('10318','2013-03-27','11:30:00',5.17),('10318','2013-03-27','11:35:00',4.43),('10318','2013-03-27','11:40:00',3.96),('10318','2013-03-27','11:45:00',3.84),('10318','2013-03-27','11:50:00',4.43),('10318','2013-03-27','11:55:00',6.54),('10318','2013-03-27','12:00:00',5.17),('10318','2013-03-27','12:05:00',5.39),('10318','2013-03-27','12:10:00',5.78),('10318','2013-03-27','12:15:00',5.33),('10318','2013-03-27','12:20:00',5.59),('10318','2013-03-27','12:25:00',3.63),('10318','2013-03-27','12:30:00',4.32),('10318','2013-03-27','12:35:00',6.09),('10318','2013-03-27','12:40:00',6.25),('10318','2013-03-27','12:45:00',5.32),('10318','2013-03-27','12:50:00',3.33),('10318','2013-03-27','12:55:00',2.96),('10318','2013-03-27','13:00:00',4.45),('10318','2013-03-27','13:05:00',3.07),('10318','2013-03-27','13:10:00',2.37),('10318','2013-03-27','13:15:00',2.58),('10318','2013-03-27','13:20:00',2.69),('10318','2013-03-27','13:25:00',2.8),('10318','2013-03-27','13:30:00',2.98),('10318','2013-03-27','13:35:00',3.02),('10318','2013-03-27','13:40:00',2.17),('10318','2013-03-27','13:45:00',2.23),('10318','2013-03-27','13:50:00',2.08),('10318','2013-03-27','13:55:00',2.18),('10318','2013-03-27','14:00:00',2.84),('10318','2013-03-27','14:05:00',2.76),('10318','2013-03-27','14:10:00',2.91),('10318','2013-03-27','14:15:00',3.01),('10318','2013-03-27','14:20:00',3.05),('10318','2013-03-27','14:25:00',3.29),('10318','2013-03-27','14:30:00',3.23),('10318','2013-03-27','14:35:00',3.83),('10318','2013-03-27','14:40:00',4.34),('10318','2013-03-27','14:45:00',3.88),('10318','2013-03-27','14:50:00',2.81),('10318','2013-03-27','14:55:00',2.19),('10318','2013-03-27','15:00:00',2.15),('10318','2013-03-27','15:05:00',2.2),('10318','2013-03-27','15:10:00',2.36),('10318','2013-03-27','15:15:00',2.21),('10318','2013-03-27','15:20:00',1.96),('10318','2013-03-27','15:25:00',1.93),('10318','2013-03-27','15:30:00',2.01),('10318','2013-03-27','15:35:00',1.75),('10318','2013-03-27','15:40:00',2.23),('10318','2013-03-27','15:45:00',1.63),('10318','2013-03-27','15:50:00',1.15),('10318','2013-03-27','15:55:00',1.3),('10318','2013-03-27','16:00:00',1.38),('10318','2013-03-27','16:05:00',2.03),('10318','2013-03-27','16:10:00',3.04),('10318','2013-03-27','16:15:00',2.19),('10318','2013-03-27','16:20:00',1.9),('10318','2013-03-27','16:25:00',1.86),('10318','2013-03-27','16:30:00',1.91),('10318','2013-03-27','16:35:00',1.99),('10318','2013-03-27','16:40:00',2.32),('10318','2013-03-27','16:45:00',2.31),('10318','2013-03-27','16:50:00',2.05),('10318','2013-03-27','16:55:00',2.4),('10318','2013-03-27','17:00:00',2.49),('10318','2013-03-27','17:05:00',2.54),('10318','2013-03-27','17:10:00',2.08),('10318','2013-03-26','07:05:00',1.14),('10318','2013-03-26','07:10:00',1.16),('10318','2013-03-26','07:15:00',1.17),('10318','2013-03-26','07:20:00',1.07),('10318','2013-03-26','07:35:00',1.44),('10318','2013-03-26','07:40:00',1.86),('10318','2013-03-26','07:45:00',2.45),('10318','2013-03-26','07:50:00',4.88),('10318','2013-03-26','07:55:00',2.74),('10318','2013-03-26','08:00:00',1.64),('10318','2013-03-26','08:05:00',1.33),('10318','2013-03-26','08:10:00',1.31),('10318','2013-03-26','08:15:00',1.54),('10318','2013-03-26','08:20:00',1.65),('10318','2013-03-26','08:25:00',1.69),('10318','2013-03-26','08:30:00',2.68),('10318','2013-03-26','08:35:00',3.02),('10318','2013-03-26','08:40:00',2.58),('10318','2013-03-26','08:45:00',1.68),('10318','2013-03-26','08:50:00',1.81),('10318','2013-03-26','08:55:00',1.48),('10318','2013-03-26','09:00:00',1.88),('10318','2013-03-26','09:05:00',1.85),('10318','2013-03-26','09:10:00',2.94),('10318','2013-03-26','09:15:00',3.15),('10318','2013-03-26','09:20:00',1.65),('10318','2013-03-26','09:25:00',1.25),('10318','2013-03-26','09:40:00',1.19),('10318','2013-03-26','09:45:00',2.06),('10318','2013-03-26','09:50:00',4.46),('10318','2013-03-26','09:55:00',3.39),('10318','2013-03-26','10:00:00',2.13),('10318','2013-03-26','10:10:00',1.17),('10318','2013-03-26','10:15:00',1.33),('10318','2013-03-26','10:20:00',1.03),('10318','2013-03-26','10:35:00',1.58),('10318','2013-03-26','10:40:00',1.14),('10318','2013-03-26','10:45:00',1.27),('10318','2013-03-26','10:50:00',1.74),('10318','2013-03-26','10:55:00',2.79),('10318','2013-03-26','11:00:00',2.41),('10318','2013-03-26','11:05:00',3.38),('10318','2013-03-26','11:10:00',4.72),('10318','2013-03-26','11:15:00',2.54),('10318','2013-03-26','11:20:00',1.45),('10318','2013-03-26','11:25:00',1.06),('10318','2013-03-26','11:45:00',1.49),('10318','2013-03-26','11:50:00',1.57),('10318','2013-03-26','11:55:00',2.55),('10318','2013-03-26','12:00:00',4.92),('10318','2013-03-26','12:05:00',3.27),('10318','2013-03-26','12:10:00',3.16),('10318','2013-03-26','12:15:00',3.23),('10318','2013-03-26','12:20:00',4.14),('10318','2013-03-26','12:25:00',7.6),('10318','2013-03-26','12:30:00',7.32),('10318','2013-03-26','12:35:00',4.41),('10318','2013-03-26','12:40:00',3.08),('10318','2013-03-26','12:45:00',6.72),('10318','2013-03-26','12:50:00',3.66),('10318','2013-03-26','12:55:00',2.67),('10318','2013-03-26','13:00:00',4.99),('10318','2013-03-26','13:05:00',5.45),('10318','2013-03-26','13:10:00',6.69),('10318','2013-03-26','13:15:00',4.2),('10318','2013-03-26','13:20:00',4.61),('10318','2013-03-26','13:25:00',3.91),('10318','2013-03-26','13:30:00',5.73),('10318','2013-03-26','13:35:00',5.74),('10318','2013-03-26','13:40:00',6.23),('10318','2013-03-26','13:45:00',4.41),('10318','2013-03-26','13:50:00',3.49),('10318','2013-03-26','13:55:00',2.85),('10318','2013-03-26','14:00:00',3.33),('10318','2013-03-26','14:05:00',3.7),('10318','2013-03-26','14:10:00',3.91),('10318','2013-03-26','14:15:00',3.17),('10318','2013-03-26','14:20:00',2.84),('10318','2013-03-26','14:25:00',2.74),('10318','2013-03-26','14:30:00',2.28),('10318','2013-03-26','14:35:00',2.16),('10318','2013-03-26','14:40:00',2.24),('10318','2013-03-26','14:45:00',2.2),('10318','2013-03-26','14:50:00',1.97),('10318','2013-03-26','14:55:00',1.89),('10318','2013-03-26','15:00:00',1.93),('10318','2013-03-26','15:05:00',2.06),('10318','2013-03-26','15:10:00',1.87),('10318','2013-03-26','15:15:00',1.79),('10318','2013-03-26','15:20:00',1.91),('10318','2013-03-26','15:25:00',1.93),('10318','2013-03-26','15:30:00',2.14),('10318','2013-03-26','15:35:00',2.23),('10318','2013-03-26','15:40:00',1.69),('10318','2013-03-26','15:45:00',1.03),('10318','2013-03-25','08:10:00',1.55),('10318','2013-03-25','08:15:00',1.52),('10318','2013-03-25','08:20:00',2.06),('10318','2013-03-25','08:25:00',5.05),('10318','2013-03-25','08:30:00',3.67),('10318','2013-03-25','08:35:00',1.5),('10318','2013-03-25','08:40:00',1.74),('10318','2013-03-25','08:45:00',1.58),('10318','2013-03-25','08:50:00',2.53),('10318','2013-03-25','08:55:00',2.08),('10318','2013-03-25','09:00:00',1.34),('10318','2013-03-25','09:05:00',1.78),('10318','2013-03-25','09:10:00',2.33),('10318','2013-03-25','09:15:00',4.81),('10318','2013-03-25','09:20:00',5.52),('10318','2013-03-25','09:25:00',4.15),('10318','2013-03-25','09:30:00',4.58),('10318','2013-03-25','09:35:00',4.82),('10318','2013-03-25','09:40:00',2.63),('10318','2013-03-25','09:45:00',1.89),('10318','2013-03-25','09:50:00',2.53),('10318','2013-03-25','09:55:00',2.69),('10318','2013-03-25','10:00:00',1.72),('10318','2013-03-25','10:05:00',3.06),('10318','2013-03-25','10:10:00',3.17),('10318','2013-03-25','10:15:00',2.11),('10318','2013-03-25','10:20:00',5.2),('10318','2013-03-25','10:25:00',6.17),('10318','2013-03-25','10:30:00',3.98),('10318','2013-03-25','10:35:00',3.1),('10318','2013-03-25','10:40:00',3.06),('10318','2013-03-25','10:45:00',4.18),('10318','2013-03-25','10:50:00',5.28),('10318','2013-03-25','10:55:00',5.63),('10318','2013-03-25','11:00:00',6.32),('10318','2013-03-25','11:05:00',3.28),('10318','2013-03-25','11:10:00',2.17),('10318','2013-03-25','11:15:00',2.52),('10318','2013-03-25','11:20:00',3.26),('10318','2013-03-25','11:25:00',7.09),('10318','2013-03-25','11:30:00',5.38),('10318','2013-03-25','11:35:00',3.18),('10318','2013-03-25','11:40:00',3.1),('10318','2013-03-25','11:45:00',3.59),('10318','2013-03-25','11:50:00',4.2),('10318','2013-03-25','11:55:00',9.21),('10318','2013-03-25','12:00:00',10.33),('10318','2013-03-25','12:05:00',7.15),('10318','2013-03-25','12:10:00',7.29),('10318','2013-03-25','12:15:00',10.6),('10318','2013-03-25','12:20:00',10.87),('10318','2013-03-25','12:25:00',10.51),('10318','2013-03-25','12:30:00',5.77),('10318','2013-03-25','12:35:00',5.76),('10318','2013-03-25','12:40:00',5.8),('10318','2013-03-25','12:45:00',6.3),('10318','2013-03-25','12:50:00',6.22),('10318','2013-03-25','12:55:00',6.05),('10318','2013-03-25','13:00:00',5.94),('10318','2013-03-25','13:05:00',6.23),('10318','2013-03-25','13:10:00',5.73),('10318','2013-03-25','13:15:00',5.25),('10318','2013-03-25','13:20:00',3.33),('10318','2013-03-25','13:25:00',2.34),('10318','2013-03-25','13:30:00',1.98),('10318','2013-03-25','13:35:00',2.21),('10318','2013-03-25','13:40:00',2.89),('10318','2013-03-25','13:45:00',3.82),('10318','2013-03-25','13:50:00',3.27),('10318','2013-03-25','13:55:00',1.9),('10318','2013-03-25','14:00:00',1.85),('10318','2013-03-25','14:05:00',3.16),('10318','2013-03-25','14:10:00',3.21),('10318','2013-03-25','14:15:00',4.24),('10318','2013-03-25','14:20:00',5.27),('10318','2013-03-25','14:25:00',5.41),('10318','2013-03-25','14:30:00',6.82),('10318','2013-03-25','14:35:00',4.6),('10318','2013-03-25','14:40:00',5.58),('10318','2013-03-25','14:45:00',4.26),('10318','2013-03-25','14:50:00',4.08),('10318','2013-03-25','14:55:00',5.09),('10318','2013-03-25','15:00:00',4.14),('10318','2013-03-25','15:05:00',4.24),('10318','2013-03-25','15:10:00',5.93),('10318','2013-03-25','15:15:00',5.86),('10318','2013-03-25','15:20:00',5.18),('10318','2013-03-25','15:25:00',5.63),('10318','2013-03-25','15:30:00',6.2),('10318','2013-03-25','15:35:00',4.78),('10318','2013-03-25','15:40:00',3.76),('10318','2013-03-25','15:45:00',2.53),('10318','2013-03-25','15:50:00',4.73),('10318','2013-03-25','15:55:00',4.82),('10318','2013-03-25','16:00:00',4.1),('10318','2013-03-25','16:05:00',2.4),('10318','2013-03-25','16:10:00',2.5),('10318','2013-03-25','16:15:00',2.59),('10318','2013-03-25','16:20:00',1.36),('10318','2013-03-25','16:25:00',1.5),('10318','2013-03-25','16:30:00',3.07),('10318','2013-03-25','16:35:00',3.7),('10318','2013-03-25','16:40:00',2.9),('10318','2013-03-25','16:45:00',1.53),('10318','2013-03-25','16:50:00',1.16),('10318','2013-03-24','07:00:00',1.03),('10318','2013-03-24','07:05:00',1.31),('10318','2013-03-24','07:10:00',1.49),('10318','2013-03-24','07:15:00',1.75),('10318','2013-03-24','07:20:00',1.77),('10318','2013-03-24','07:25:00',2.19),('10318','2013-03-24','07:30:00',2.4),('10318','2013-03-24','07:35:00',2.63),('10318','2013-03-24','07:40:00',2.88),('10318','2013-03-24','07:45:00',3.3),('10318','2013-03-24','07:50:00',3.46),('10318','2013-03-24','07:55:00',3.88),('10318','2013-03-24','08:00:00',4.68),('10318','2013-03-24','08:05:00',5.07),('10318','2013-03-24','08:10:00',5.12),('10318','2013-03-24','08:15:00',5.45),('10318','2013-03-24','08:20:00',5.68),('10318','2013-03-24','08:25:00',5.87),('10318','2013-03-24','08:30:00',5.99),('10318','2013-03-24','08:35:00',6.16),('10318','2013-03-24','08:40:00',6.33),('10318','2013-03-24','08:45:00',6.36),('10318','2013-03-24','08:50:00',6.52),('10318','2013-03-24','08:55:00',6.59),('10318','2013-03-24','09:00:00',6.72),('10318','2013-03-24','09:05:00',6.9),('10318','2013-03-24','09:10:00',7.1),('10318','2013-03-24','09:15:00',7.22),('10318','2013-03-24','09:20:00',7.34),('10318','2013-03-24','09:25:00',7.49),('10318','2013-03-24','09:30:00',7.65),('10318','2013-03-24','09:35:00',7.74),('10318','2013-03-24','09:40:00',7.84),('10318','2013-03-24','09:45:00',7.96),('10318','2013-03-24','09:50:00',8.06),('10318','2013-03-24','09:55:00',8.11),('10318','2013-03-24','10:00:00',8.19),('10318','2013-03-24','10:05:00',8.32),('10318','2013-03-24','10:10:00',8.42),('10318','2013-03-24','10:15:00',8.5),('10318','2013-03-24','10:20:00',8.56),('10318','2013-03-24','10:25:00',8.59),('10318','2013-03-24','10:30:00',8.38),('10318','2013-03-24','10:35:00',8.74),('10318','2013-03-24','10:40:00',8.8),('10318','2013-03-24','10:45:00',8.8),('10318','2013-03-24','10:50:00',8.81),('10318','2013-03-24','10:55:00',8.85),('10318','2013-03-24','11:00:00',8.87),('10318','2013-03-24','11:05:00',8.9),('10318','2013-03-24','11:10:00',8.93),('10318','2013-03-24','11:15:00',8.91),('10318','2013-03-24','11:20:00',8.86),('10318','2013-03-24','11:25:00',8.89),('10318','2013-03-24','11:30:00',8.95),('10318','2013-03-24','11:35:00',8.95),('10318','2013-03-24','11:40:00',8.99),('10318','2013-03-24','11:45:00',8.9),('10318','2013-03-24','11:50:00',8.93),('10318','2013-03-24','11:55:00',8.89),('10318','2013-03-24','12:00:00',8.89),('10318','2013-03-24','12:05:00',8.94),('10318','2013-03-24','12:10:00',8.97),('10318','2013-03-24','12:15:00',9.07),('10318','2013-03-24','12:20:00',9.11),('10318','2013-03-24','12:25:00',9.31),('10318','2013-03-24','12:30:00',9.26),('10318','2013-03-24','12:35:00',9.3),('10318','2013-03-24','12:40:00',9.26),('10318','2013-03-24','12:45:00',9.11),('10318','2013-03-24','12:50:00',9.15),('10318','2013-03-24','12:55:00',9.06),('10318','2013-03-24','13:00:00',8.99),('10318','2013-03-24','13:05:00',8.94),('10318','2013-03-24','13:10:00',8.85),('10318','2013-03-24','13:15:00',8.81),('10318','2013-03-24','13:20:00',8.71),('10318','2013-03-24','13:25:00',8.58),('10318','2013-03-24','13:30:00',8.46),('10318','2013-03-24','13:35:00',8.39),('10318','2013-03-24','13:40:00',8.35),('10318','2013-03-24','13:45:00',8.23),('10318','2013-03-24','13:50:00',8.11),('10318','2013-03-24','13:55:00',7.94),('10318','2013-03-24','14:00:00',7.8),('10318','2013-03-24','14:05:00',7.53),('10318','2013-03-24','14:10:00',7.54),('10318','2013-03-24','14:15:00',7.36),('10318','2013-03-24','14:20:00',7.23),('10318','2013-03-24','14:25:00',7),('10318','2013-03-24','14:30:00',6.72),('10318','2013-03-24','14:35:00',6.52),('10318','2013-03-24','14:40:00',6.49),('10318','2013-03-24','14:45:00',6.41),('10318','2013-03-24','14:50:00',5.99),('10318','2013-03-24','14:55:00',6.06),('10318','2013-03-24','15:00:00',5.77),('10318','2013-03-24','15:05:00',5.74),('10318','2013-03-24','15:10:00',5.36),('10318','2013-03-24','15:15:00',5.65),('10318','2013-03-24','15:20:00',5.43),('10318','2013-03-24','15:25:00',5.17),('10318','2013-03-24','15:30:00',4.72),('10318','2013-03-24','15:35:00',4.44),('10318','2013-03-24','15:40:00',4.39),('10318','2013-03-24','15:45:00',3.63),('10318','2013-03-24','15:50:00',2.57),('10318','2013-03-24','15:55:00',2.5),('10318','2013-03-24','16:00:00',2.55),('10318','2013-03-24','16:05:00',2.67),('10318','2013-03-24','16:10:00',2.3),('10318','2013-03-24','16:15:00',2.9),('10318','2013-03-24','16:20:00',2.91),('10318','2013-03-24','16:25:00',2.04),('10318','2013-03-24','16:30:00',2.46),('10318','2013-03-24','16:35:00',2.02),('10318','2013-03-24','16:40:00',1.76),('10318','2013-03-24','16:45:00',1.75),('10318','2013-03-24','16:50:00',1.37),('10318','2013-03-24','16:55:00',1.22),('10318','2013-03-24','17:00:00',1.14),('10318','2013-03-23','07:00:00',1.29),('10318','2013-03-23','07:05:00',1.53),('10318','2013-03-23','07:10:00',1.76),('10318','2013-03-23','07:15:00',2.31),('10318','2013-03-23','07:20:00',2.7),('10318','2013-03-23','07:25:00',2.76),('10318','2013-03-23','07:30:00',3.08),('10318','2013-03-23','07:35:00',3.06),('10318','2013-03-23','07:40:00',3.69),('10318','2013-03-23','07:45:00',3.57),('10318','2013-03-23','07:50:00',4.08),('10318','2013-03-23','07:55:00',4.42),('10318','2013-03-23','08:00:00',4.87),('10318','2013-03-23','08:05:00',5.25),('10318','2013-03-23','08:10:00',5.37),('10318','2013-03-23','08:15:00',5.56),('10318','2013-03-23','08:20:00',5.69),('10318','2013-03-23','08:25:00',5.88),('10318','2013-03-23','08:30:00',5.92),('10318','2013-03-23','08:35:00',6.11),('10318','2013-03-23','08:40:00',6.36),('10318','2013-03-23','08:45:00',6.61),('10318','2013-03-23','08:50:00',6.74),('10318','2013-03-23','08:55:00',7),('10318','2013-03-23','09:00:00',7.16),('10318','2013-03-23','09:05:00',7.37),('10318','2013-03-23','09:10:00',7.44),('10318','2013-03-23','09:15:00',7.44),('10318','2013-03-23','09:20:00',7.53),('10318','2013-03-23','09:25:00',7.85),('10318','2013-03-23','09:30:00',8.1),('10318','2013-03-23','09:35:00',8.02),('10318','2013-03-23','09:40:00',7.9),('10318','2013-03-23','09:45:00',8.05),('10318','2013-03-23','09:50:00',8.06),('10318','2013-03-23','09:55:00',8.38),('10318','2013-03-23','10:00:00',8.43),('10318','2013-03-23','10:05:00',8.43),('10318','2013-03-23','10:10:00',7.37),('10318','2013-03-23','10:15:00',6.82),('10318','2013-03-23','10:20:00',8.5),('10318','2013-03-23','10:25:00',8.54),('10318','2013-03-23','10:30:00',8.68),('10318','2013-03-23','10:35:00',8.86),('10318','2013-03-23','10:40:00',8.81),('10318','2013-03-23','10:45:00',8.46),('10318','2013-03-23','10:50:00',8.54),('10318','2013-03-23','10:55:00',8.46),('10318','2013-03-23','11:00:00',8.4),('10318','2013-03-23','11:05:00',7.08),('10318','2013-03-23','11:10:00',6.88),('10318','2013-03-23','11:15:00',8.06),('10318','2013-03-23','11:20:00',8.84),('10318','2013-03-23','11:25:00',8.56),('10318','2013-03-23','11:30:00',8.75),('10318','2013-03-23','11:35:00',9.09),('10318','2013-03-23','11:40:00',8.98),('10318','2013-03-23','11:45:00',8.93),('10318','2013-03-23','11:50:00',8.6),('10318','2013-03-23','11:55:00',8.94),('10318','2013-03-23','12:00:00',9.07),('10318','2013-03-23','12:05:00',8.79),('10318','2013-03-23','12:10:00',9.09),('10318','2013-03-23','12:15:00',8.8),('10318','2013-03-23','12:20:00',8.84),('10318','2013-03-23','12:25:00',8.87),('10318','2013-03-23','12:30:00',8.96),('10318','2013-03-23','12:35:00',8.85),('10318','2013-03-23','12:40:00',8.53),('10318','2013-03-23','12:45:00',8.82),('10318','2013-03-23','12:50:00',8.82),('10318','2013-03-23','12:55:00',8.25),('10318','2013-03-23','13:00:00',6.71),('10318','2013-03-23','13:05:00',8.49),('10318','2013-03-23','13:10:00',8.63),('10318','2013-03-23','13:15:00',8.21),('10318','2013-03-23','13:20:00',8.51),('10318','2013-03-23','13:25:00',8.37),('10318','2013-03-23','13:30:00',8.25),('10318','2013-03-23','13:35:00',8.24),('10318','2013-03-23','13:40:00',8.11),('10318','2013-03-23','13:45:00',7.94),('10318','2013-03-23','13:50:00',7.82),('10318','2013-03-23','13:55:00',7.61),('10318','2013-03-23','14:00:00',7.36),('10318','2013-03-23','14:05:00',7.66),('10318','2013-03-23','14:10:00',7.28),('10318','2013-03-23','14:15:00',6.97),('10318','2013-03-23','14:20:00',7.15),('10318','2013-03-23','14:25:00',7.1),('10318','2013-03-23','14:30:00',6.93),('10318','2013-03-23','14:35:00',6.81),('10318','2013-03-23','14:40:00',6.52),('10318','2013-03-23','14:45:00',5.96),('10318','2013-03-23','14:50:00',6.06),('10318','2013-03-23','14:55:00',6.04),('10318','2013-03-23','15:00:00',5.81),('10318','2013-03-23','15:05:00',5.6),('10318','2013-03-23','15:10:00',5.5),('10318','2013-03-23','15:15:00',5.04),('10318','2013-03-23','15:20:00',5.2),('10318','2013-03-23','15:25:00',5),('10318','2013-03-23','15:30:00',4.47),('10318','2013-03-23','15:35:00',4.48),('10318','2013-03-23','15:40:00',4.23),('10318','2013-03-23','15:45:00',3.74),('10318','2013-03-23','15:50:00',3.67),('10318','2013-03-23','15:55:00',3.5),('10318','2013-03-23','16:00:00',3.15),('10318','2013-03-23','16:05:00',3.18),('10318','2013-03-23','16:10:00',3.73),('10318','2013-03-23','16:15:00',3.39),('10318','2013-03-23','16:20:00',2.91),('10318','2013-03-23','16:25:00',2.73),('10318','2013-03-23','16:30:00',2.36),('10318','2013-03-23','16:35:00',2.41),('10318','2013-03-23','16:40:00',2.02),('10318','2013-03-23','16:45:00',1.94),('10318','2013-03-23','16:50:00',1.69),('10318','2013-03-23','16:55:00',1.7),('10318','2013-03-23','17:00:00',1.94),('10318','2013-03-23','17:05:00',1.95),('10318','2013-03-23','17:10:00',1.65),('10318','2013-03-23','17:15:00',1.34),('10318','2013-03-23','17:20:00',1.15),('10318','2014-03-26','07:00:00',1.29),('10318','2014-03-26','07:05:00',1.5),('10318','2014-03-26','07:10:00',1.92),('10318','2014-03-26','07:15:00',2.82),('10318','2014-03-26','07:20:00',3.21),('10318','2014-03-26','07:25:00',3.46),('10318','2014-03-26','07:30:00',3.76),('10318','2014-03-26','07:35:00',4.06),('10318','2014-03-26','07:40:00',4.26),('10318','2014-03-26','07:45:00',4.53),('10318','2014-03-26','07:50:00',4.72),('10318','2014-03-26','07:55:00',5),('10318','2014-03-26','08:00:00',5.25),('10318','2014-03-26','08:05:00',5.46),('10318','2014-03-26','08:10:00',5.72),('10318','2014-03-26','08:15:00',6.22),('10318','2014-03-26','08:20:00',5.89),('10318','2014-03-26','08:25:00',3.21),('10318','2014-03-26','08:30:00',2.46),('10318','2014-03-26','08:35:00',2.04),('10318','2014-03-26','08:40:00',2.29),('10318','2014-03-26','08:45:00',2.63),('10318','2014-03-26','08:50:00',2.89),('10318','2014-03-26','08:55:00',3.71),('10318','2014-03-26','09:00:00',3.97),('10318','2014-03-26','09:05:00',3.45),('10318','2014-03-26','09:10:00',3.33),('10318','2014-03-26','09:15:00',4.47),('10318','2014-03-26','09:20:00',7.54),('10318','2014-03-26','09:25:00',7.6),('10318','2014-03-26','09:30:00',8.36),('10318','2014-03-26','09:35:00',8.35),('10318','2014-03-26','09:40:00',8.41),('10318','2014-03-26','09:45:00',8.49),('10318','2014-03-26','09:50:00',8.52),('10318','2014-03-26','09:55:00',7.61),('10318','2014-03-26','10:00:00',7.48),('10318','2014-03-26','10:05:00',5.13),('10318','2014-03-26','10:10:00',2.9),('10318','2014-03-26','10:15:00',9.02),('10318','2014-03-26','10:20:00',6.74),('10318','2014-03-26','10:25:00',6.28),('10318','2014-03-26','10:30:00',9.02),('10318','2014-03-26','10:35:00',4.23),('10318','2014-03-26','10:40:00',1.96),('10318','2014-03-26','10:45:00',5.36),('10318','2014-03-26','10:50:00',10.1),('10318','2014-03-26','10:55:00',4.86),('10318','2014-03-26','11:00:00',2.21),('10318','2014-03-26','11:05:00',6.27),('10318','2014-03-26','11:10:00',5.68),('10318','2014-03-26','11:15:00',4.25),('10318','2014-03-26','11:20:00',2.32),('10318','2014-03-26','11:25:00',2.02),('10318','2014-03-26','11:30:00',2.27),('10318','2014-03-26','11:35:00',6.33),('10318','2014-03-26','11:40:00',9.72),('10318','2014-03-26','11:45:00',9.87),('10318','2014-03-26','11:50:00',7.01),('10318','2014-03-26','11:55:00',5.7),('10318','2014-03-26','12:00:00',6.26),('10318','2014-03-26','12:05:00',7.32),('10318','2014-03-26','12:10:00',8.57),('10318','2014-03-26','12:15:00',3.58),('10318','2014-03-26','12:20:00',3.36),('10318','2014-03-26','12:25:00',3.27),('10318','2014-03-26','12:30:00',3.36),('10318','2014-03-26','12:35:00',3.45),('10318','2014-03-26','12:40:00',5),('10318','2014-03-26','12:45:00',5.74),('10318','2014-03-26','12:50:00',8.52),('10318','2014-03-26','12:55:00',9.89),('10318','2014-03-26','13:00:00',9.39),('10318','2014-03-26','13:05:00',9.83),('10318','2014-03-26','13:10:00',8.92),('10318','2014-03-26','13:15:00',8),('10318','2014-03-26','13:20:00',9.83),('10318','2014-03-26','13:25:00',7.55),('10318','2014-03-26','13:30:00',7.88),('10318','2014-03-26','13:35:00',5.23),('10318','2014-03-26','13:40:00',2.15),('10318','2014-03-26','13:45:00',2.65),('10318','2014-03-26','13:50:00',5.1),('10318','2014-03-26','13:55:00',8.44),('10318','2014-03-26','14:00:00',8.98),('10318','2014-03-26','14:05:00',9.7),('10318','2014-03-26','14:10:00',3.97),('10318','2014-03-26','14:15:00',3.27),('10318','2014-03-26','14:20:00',2.4),('10318','2014-03-26','14:25:00',1.95),('10318','2014-03-26','14:30:00',1.81),('10318','2014-03-26','14:35:00',1.65),('10318','2014-03-26','14:40:00',1.9),('10318','2014-03-26','14:45:00',4.16),('10318','2014-03-26','14:50:00',4.92),('10318','2014-03-26','14:55:00',6.91),('10318','2014-03-26','15:00:00',6.57),('10318','2014-03-26','15:05:00',5.94),('10318','2014-03-26','15:10:00',6.14),('10318','2014-03-26','15:15:00',6.28),('10318','2014-03-26','15:20:00',6.42),('10318','2014-03-26','15:25:00',5.58),('10318','2014-03-26','15:30:00',5.91),('10318','2014-03-26','15:35:00',5.72),('10318','2014-03-26','15:40:00',4.89),('10318','2014-03-26','15:45:00',4.12),('10318','2014-03-26','15:50:00',2.96),('10318','2014-03-26','15:55:00',2.21),('10318','2014-03-26','16:00:00',1.81),('10318','2014-03-26','16:05:00',2.73),('10318','2014-03-26','16:10:00',3.24),('10318','2014-03-26','16:15:00',4.08),('10318','2014-03-26','16:20:00',3.16),('10318','2014-03-26','16:25:00',2.3),('10318','2014-03-26','16:30:00',1.76),('10318','2014-03-26','16:35:00',1.51),('10318','2014-03-26','16:40:00',1.08),('10318','2014-03-26','16:45:00',1.05),('10318','2014-03-26','16:50:00',1.13),('10318','2014-03-26','16:55:00',1.09),('10318','2013-03-22','07:00:00',1.03),('10318','2013-03-22','07:05:00',1.27),('10318','2013-03-22','07:10:00',1.45),('10318','2013-03-22','07:15:00',1.93),('10318','2013-03-22','07:20:00',2.7),('10318','2013-03-22','07:25:00',3.15),('10318','2013-03-22','07:30:00',3.4),('10318','2013-03-22','07:35:00',3.69),('10318','2013-03-22','07:40:00',3.94),('10318','2013-03-22','07:45:00',4.16),('10318','2013-03-22','07:50:00',4.39),('10318','2013-03-22','07:55:00',4.58),('10318','2013-03-22','08:00:00',4.7),('10318','2013-03-22','08:05:00',5.04),('10318','2013-03-22','08:10:00',5.28),('10318','2013-03-22','08:15:00',5.49),('10318','2013-03-22','08:20:00',5.69),('10318','2013-03-22','08:25:00',5.91),('10318','2013-03-22','08:30:00',6.13),('10318','2013-03-22','08:35:00',6.31),('10318','2013-03-22','08:40:00',6.49),('10318','2013-03-22','08:45:00',6.67),('10318','2013-03-22','08:50:00',6.84),('10318','2013-03-22','08:55:00',7),('10318','2013-03-22','09:00:00',7.1),('10318','2013-03-22','09:05:00',7.22),('10318','2013-03-22','09:10:00',7.35),('10318','2013-03-22','09:15:00',7.47),('10318','2013-03-22','09:20:00',7.62),('10318','2013-03-22','09:25:00',7.68),('10318','2013-03-22','09:30:00',7.84),('10318','2013-03-22','09:35:00',7.97),('10318','2013-03-22','09:40:00',7.98),('10318','2013-03-22','09:45:00',7.94),('10318','2013-03-22','09:50:00',8.2),('10318','2013-03-22','09:55:00',8.24),('10318','2013-03-22','10:00:00',8.43),('10318','2013-03-22','10:05:00',8.49),('10318','2013-03-22','10:10:00',8.56),('10318','2013-03-22','10:15:00',8.66),('10318','2013-03-22','10:20:00',8.76),('10318','2013-03-22','10:25:00',8.82),('10318','2013-03-22','10:30:00',8.92),('10318','2013-03-22','10:35:00',9.1),('10318','2013-03-22','10:40:00',9.12),('10318','2013-03-22','10:45:00',9.21),('10318','2013-03-22','10:50:00',9.25),('10318','2013-03-22','10:55:00',9.3),('10318','2013-03-22','11:00:00',9.32),('10318','2013-03-22','11:05:00',9.45),('10318','2013-03-22','11:10:00',9.41),('10318','2013-03-22','11:15:00',9.42),('10318','2013-03-22','11:20:00',9.47),('10318','2013-03-22','11:25:00',9.41),('10318','2013-03-22','11:30:00',9.39),('10318','2013-03-22','11:35:00',9.6),('10318','2013-03-22','11:40:00',9.63),('10318','2013-03-22','11:45:00',9.66),('10318','2013-03-22','11:50:00',9.66),('10318','2013-03-22','11:55:00',9.66),('10318','2013-03-22','12:00:00',9.68),('10318','2013-03-22','12:05:00',9.65),('10318','2013-03-22','12:10:00',9.59),('10318','2013-03-22','12:15:00',9.58),('10318','2013-03-22','12:20:00',9.56),('10318','2013-03-22','12:25:00',9.53),('10318','2013-03-22','12:30:00',9.51),('10318','2013-03-22','12:35:00',9.43),('10318','2013-03-22','12:40:00',9.39),('10318','2013-03-22','12:45:00',9.36),('10318','2013-03-22','12:50:00',9.08),('10318','2013-03-22','12:55:00',9.05),('10318','2013-03-22','13:00:00',9.19),('10318','2013-03-22','13:05:00',9.22),('10318','2013-03-22','13:10:00',9.16),('10318','2013-03-22','13:15:00',9.01),('10318','2013-03-22','13:20:00',8.84),('10318','2013-03-22','13:25:00',7.98),('10318','2013-03-22','13:30:00',8.49),('10318','2013-03-22','13:35:00',8.28),('10318','2013-03-22','13:40:00',7.17),('10318','2013-03-22','13:45:00',8.26),('10318','2013-03-22','13:50:00',8.45),('10318','2013-03-22','13:55:00',8.22),('10318','2013-03-22','14:00:00',8.07),('10318','2013-03-22','14:05:00',7.93),('10318','2013-03-22','14:10:00',7.83),('10318','2013-03-22','14:15:00',7.68),('10318','2013-03-22','14:20:00',7.5),('10318','2013-03-22','14:25:00',7.36),('10318','2013-03-22','14:30:00',7.16),('10318','2013-03-22','14:35:00',6.89),('10318','2013-03-22','14:40:00',6.87),('10318','2013-03-22','14:45:00',6.65),('10318','2013-03-22','14:50:00',6.54),('10318','2013-03-22','14:55:00',6.38),('10318','2013-03-22','15:00:00',6.22),('10318','2013-03-22','15:05:00',5.97),('10318','2013-03-22','15:10:00',5.18),('10318','2013-03-22','15:15:00',4.27),('10318','2013-03-22','15:20:00',4.38),('10318','2013-03-22','15:25:00',4.45),('10318','2013-03-22','15:30:00',4.44),('10318','2013-03-22','15:35:00',4.64),('10318','2013-03-22','15:40:00',4.22),('10318','2013-03-22','15:45:00',3.85),('10318','2013-03-22','15:50:00',4.07),('10318','2013-03-22','15:55:00',3.41),('10318','2013-03-22','16:00:00',2.55),('10318','2013-03-22','16:05:00',2.94),('10318','2013-03-22','16:10:00',3.3),('10318','2013-03-22','16:15:00',3.5),('10318','2013-03-22','16:20:00',2.73),('10318','2013-03-22','16:25:00',2.97),('10318','2013-03-22','16:30:00',3.11),('10318','2013-03-22','16:35:00',3.06),('10318','2013-03-22','16:40:00',2.93),('10318','2013-03-22','16:45:00',2.45),('10318','2013-03-22','16:50:00',2.54),('10318','2013-03-22','16:55:00',2.4),('10318','2013-03-22','17:00:00',1.63),('10318','2013-03-22','17:05:00',1.38),('10318','2013-03-22','17:15:00',1.3),('10318','2013-03-22','17:25:00',1.05),('10318','2013-03-21','07:20:00',2.31),('10318','2013-03-21','07:25:00',3.38),('10318','2013-03-21','07:30:00',3.62),('10318','2013-03-21','07:35:00',3.99),('10318','2013-03-21','07:40:00',4.32),('10318','2013-03-21','07:45:00',5.11),('10318','2013-03-21','07:50:00',5.37),('10318','2013-03-21','07:55:00',2.09),('10318','2013-03-21','08:00:00',1.69),('10318','2013-03-21','08:05:00',3.23),('10318','2013-03-21','08:10:00',5.41),('10318','2013-03-21','08:15:00',5.5),('10318','2013-03-21','08:20:00',4.41),('10318','2013-03-21','08:25:00',6.12),('10318','2013-03-21','08:30:00',6.16),('10318','2013-03-21','08:35:00',6.46),('10318','2013-03-21','08:40:00',6.79),('10318','2013-03-21','08:45:00',6.81),('10318','2013-03-21','08:50:00',7.18),('10318','2013-03-21','08:55:00',7.79),('10318','2013-03-21','09:00:00',8.34),('10318','2013-03-21','09:05:00',4.59),('10318','2013-03-21','09:10:00',4.69),('10318','2013-03-21','09:15:00',3.68),('10318','2013-03-21','09:20:00',4.33),('10318','2013-03-21','09:25:00',6.42),('10318','2013-03-21','09:30:00',8.25),('10318','2013-03-21','09:35:00',8.51),('10318','2013-03-21','09:40:00',8.68),('10318','2013-03-21','09:45:00',8.82),('10318','2013-03-21','09:50:00',8.82),('10318','2013-03-21','09:55:00',9.04),('10318','2013-03-21','10:00:00',9.12),('10318','2013-03-21','10:05:00',9.08),('10318','2013-03-21','10:10:00',9.19),('10318','2013-03-21','10:15:00',9.24),('10318','2013-03-21','10:20:00',9.21),('10318','2013-03-21','10:25:00',9.34),('10318','2013-03-21','10:30:00',9.46),('10318','2013-03-21','10:35:00',9.42),('10318','2013-03-21','10:40:00',9.34),('10318','2013-03-21','10:45:00',9.33),('10318','2013-03-21','10:50:00',9.49),('10318','2013-03-21','10:55:00',9.67),('10318','2013-03-21','11:00:00',9.63),('10318','2013-03-21','11:05:00',9.56),('10318','2013-03-21','11:10:00',9.75),('10318','2013-03-21','11:15:00',9.77),('10318','2013-03-21','11:20:00',9.85),('10318','2013-03-21','11:25:00',9.99),('10318','2013-03-21','11:30:00',9.94),('10318','2013-03-21','11:35:00',10.03),('10318','2013-03-21','11:40:00',9.98),('10318','2013-03-21','11:45:00',10.03),('10318','2013-03-21','11:50:00',10.04),('10318','2013-03-21','11:55:00',10.06),('10318','2013-03-21','12:00:00',9.97),('10318','2013-03-21','12:05:00',9.93),('10318','2013-03-21','12:10:00',9.97),('10318','2013-03-21','12:15:00',9.93),('10318','2013-03-21','12:20:00',9.85),('10318','2013-03-21','12:25:00',9.91),('10318','2013-03-21','12:30:00',9.91),('10318','2013-03-21','12:35:00',9.88),('10318','2013-03-21','12:40:00',9.81),('10318','2013-03-21','12:45:00',9.69),('10318','2013-03-21','12:50:00',9.54),('10318','2013-03-21','12:55:00',9.51),('10318','2013-03-21','13:00:00',9.42),('10318','2013-03-21','13:05:00',9.36),('10318','2013-03-21','13:10:00',9.24),('10318','2013-03-21','13:15:00',9.14),('10318','2013-03-21','13:20:00',9.05),('10318','2013-03-21','13:25:00',8.95),('10318','2013-03-21','13:30:00',8.88),('10318','2013-03-21','13:35:00',8.77),('10318','2013-03-21','13:40:00',8.67),('10318','2013-03-21','13:45:00',8.62),('10318','2013-03-21','13:50:00',8.47),('10318','2013-03-21','13:55:00',8.35),('10318','2013-03-21','14:00:00',8.21),('10318','2013-03-21','14:05:00',8.01),('10318','2013-03-21','14:10:00',7.9),('10318','2013-03-21','14:15:00',7.73),('10318','2013-03-21','14:20:00',7.61),('10318','2013-03-21','14:25:00',7.44),('10318','2013-03-21','14:30:00',7.27),('10318','2013-03-21','14:35:00',6.93),('10318','2013-03-21','14:40:00',6.91),('10318','2013-03-21','14:45:00',6.78),('10318','2013-03-21','14:50:00',6.63),('10318','2013-03-21','14:55:00',6.47),('10318','2013-03-21','15:00:00',6.3),('10318','2013-03-21','15:05:00',6.12),('10318','2013-03-21','15:10:00',5.95),('10318','2013-03-21','15:15:00',5.75),('10318','2013-03-21','15:20:00',5.54),('10318','2013-03-21','15:25:00',5.36),('10318','2013-03-21','15:30:00',5.16),('10318','2013-03-21','15:35:00',4.95),('10318','2013-03-21','15:40:00',4.72),('10318','2013-03-21','15:45:00',4.51),('10318','2013-03-21','15:50:00',4.31),('10318','2013-03-21','15:55:00',4.11),('10318','2013-03-21','16:00:00',3.91),('10318','2013-03-21','16:05:00',3.71),('10318','2013-03-21','16:10:00',3.53),('10318','2013-03-21','16:15:00',3.33),('10318','2013-03-21','16:20:00',3.11),('10318','2013-03-21','16:25:00',2.95),('10318','2013-03-21','16:30:00',2.76),('10318','2013-03-21','16:35:00',2.6),('10318','2013-03-21','16:40:00',2.42),('10318','2013-03-21','16:45:00',2.25),('10318','2013-03-21','16:50:00',2.06),('10318','2013-03-21','16:55:00',1.89),('10318','2013-03-21','17:00:00',1.73),('10318','2013-03-21','17:05:00',1.56),('10318','2013-03-21','17:10:00',1.4),('10318','2013-03-21','17:15:00',1.19),('10318','2013-03-21','17:20:00',1.01),('10318','2013-03-20','07:05:00',1.21),('10318','2013-03-20','07:10:00',1.42),('10318','2013-03-20','07:15:00',1.62),('10318','2013-03-20','07:20:00',2.19),('10318','2013-03-20','07:25:00',3.03),('10318','2013-03-20','07:30:00',3.42),('10318','2013-03-20','07:35:00',3.74),('10318','2013-03-20','07:40:00',3.93),('10318','2013-03-20','07:45:00',3.95),('10318','2013-03-20','07:50:00',4.22),('10318','2013-03-20','07:55:00',4.87),('10318','2013-03-20','08:00:00',3.26),('10318','2013-03-20','08:05:00',5.26),('10318','2013-03-20','08:10:00',5.23),('10318','2013-03-20','08:15:00',5.46),('10318','2013-03-20','08:20:00',5.47),('10318','2013-03-20','08:25:00',5.86),('10318','2013-03-20','08:30:00',6.19),('10318','2013-03-20','08:35:00',5.82),('10318','2013-03-20','08:40:00',6.07),('10318','2013-03-20','08:45:00',6.34),('10318','2013-03-20','08:50:00',6.53),('10318','2013-03-20','08:55:00',6.36),('10318','2013-03-20','09:00:00',6.64),('10318','2013-03-20','09:05:00',5.89),('10318','2013-03-20','09:10:00',5.87),('10318','2013-03-20','09:15:00',7.39),('10318','2013-03-20','09:20:00',5.76),('10318','2013-03-20','09:25:00',7.65),('10318','2013-03-20','09:30:00',8.19),('10318','2013-03-20','09:35:00',7.8),('10318','2013-03-20','09:40:00',8.12),('10318','2013-03-20','09:45:00',8.27),('10318','2013-03-20','09:50:00',7.86),('10318','2013-03-20','09:55:00',8.16),('10318','2013-03-20','10:00:00',8.41),('10318','2013-03-20','10:05:00',7.26),('10318','2013-03-20','10:10:00',7.99),('10318','2013-03-20','10:15:00',8.12),('10318','2013-03-20','10:20:00',5.04),('10318','2013-03-20','10:25:00',5.34),('10318','2013-03-20','10:30:00',9.1),('10318','2013-03-20','10:35:00',9.34),('10318','2013-03-20','10:40:00',6.99),('10318','2013-03-20','10:45:00',6.74),('10318','2013-03-20','10:50:00',7.96),('10318','2013-03-20','10:55:00',7.21),('10318','2013-03-20','11:00:00',6.05),('10318','2013-03-20','11:05:00',7.66),('10318','2013-03-20','11:10:00',5.56),('10318','2013-03-20','11:15:00',5.59),('10318','2013-03-20','11:20:00',6.41),('10318','2013-03-20','11:25:00',6.05),('10318','2013-03-20','11:30:00',5.55),('10318','2013-03-20','11:35:00',6.21),('10318','2013-03-20','11:40:00',4.96),('10318','2013-03-20','11:45:00',4.72),('10318','2013-03-20','11:50:00',4.63),('10318','2013-03-20','11:55:00',4.83),('10318','2013-03-20','12:00:00',4.97),('10318','2013-03-20','12:05:00',5.18),('10318','2013-03-20','12:10:00',4.38),('10318','2013-03-20','12:15:00',3.67),('10318','2013-03-20','12:20:00',3.28),('10318','2013-03-20','12:25:00',2.77),('10318','2013-03-20','12:30:00',2.48),('10318','2013-03-20','12:35:00',3.17),('10318','2013-03-20','12:40:00',2.29),('10318','2013-03-20','12:45:00',2.61),('10318','2013-03-20','12:50:00',3.37),('10318','2013-03-20','12:55:00',4.31),('10318','2013-03-20','13:00:00',3.88),('10318','2013-03-20','13:05:00',3.02),('10318','2013-03-20','13:10:00',2.93),('10318','2013-03-20','13:15:00',2.61),('10318','2013-03-20','13:20:00',2.75),('10318','2013-03-20','13:25:00',3.04),('10318','2013-03-20','13:30:00',3.27),('10318','2013-03-20','13:35:00',3.17),('10318','2013-03-20','13:40:00',4.14),('10318','2013-03-20','13:45:00',4.41),('10318','2013-03-20','13:50:00',3.7),('10318','2013-03-20','13:55:00',3.55),('10318','2013-03-20','14:00:00',3.54),('10318','2013-03-20','14:05:00',2.96),('10318','2013-03-20','14:10:00',2.89),('10318','2013-03-20','14:15:00',4.07),('10318','2013-03-20','14:20:00',4.59),('10318','2013-03-20','14:25:00',4.39),('10318','2013-03-20','14:30:00',3.83),('10318','2013-03-20','14:35:00',3.01),('10318','2013-03-20','14:40:00',2.44),('10318','2013-03-20','14:45:00',2.44),('10318','2013-03-20','14:50:00',1.9),('10318','2013-03-20','14:55:00',1.43),('10318','2013-03-20','15:00:00',1.69),('10318','2013-03-20','15:05:00',1.6),('10318','2013-03-20','15:10:00',1.41),('10318','2013-03-20','15:15:00',1.18),('10318','2013-03-20','15:20:00',1.14),('10318','2013-03-20','15:25:00',1.18),('10318','2013-03-20','15:30:00',1.42),('10318','2013-03-20','15:35:00',1.14),('10318','2013-03-19','07:00:00',1.08),('10318','2013-03-19','07:05:00',1.33),('10318','2013-03-19','07:20:00',2.01),('10318','2013-03-19','07:25:00',2.8),('10318','2013-03-19','07:30:00',3.18),('10318','2013-03-19','07:35:00',3.51),('10318','2013-03-19','07:40:00',3.76),('10318','2013-03-19','07:45:00',4),('10318','2013-03-19','07:50:00',4.36),('10318','2013-03-19','07:55:00',4.15),('10318','2013-03-19','08:00:00',3.44),('10318','2013-03-19','08:05:00',4.49),('10318','2013-03-19','08:10:00',4.89),('10318','2013-03-19','08:15:00',5.33),('10318','2013-03-19','08:20:00',5.58),('10318','2013-03-19','08:25:00',5.82),('10318','2013-03-19','08:30:00',6.11),('10318','2013-03-19','08:35:00',6.32),('10318','2013-03-19','08:40:00',6.42),('10318','2013-03-19','08:45:00',6.71),('10318','2013-03-19','08:50:00',6.72),('10318','2013-03-19','08:55:00',6.98),('10318','2013-03-19','09:00:00',7.18),('10318','2013-03-19','09:05:00',7.08),('10318','2013-03-19','09:10:00',7.49),('10318','2013-03-19','09:15:00',7.65),('10318','2013-03-19','09:20:00',7.8),('10318','2013-03-19','09:25:00',7.9),('10318','2013-03-19','09:30:00',8.06),('10318','2013-03-19','09:35:00',8.18),('10318','2013-03-19','09:40:00',7.48),('10318','2013-03-19','09:45:00',8.66),('10318','2013-03-19','09:50:00',6.9),('10318','2013-03-19','09:55:00',8.19),('10318','2013-03-19','10:00:00',6.67),('10318','2013-03-19','10:05:00',8.51),('10318','2013-03-19','10:10:00',9.1),('10318','2013-03-19','10:15:00',9.12),('10318','2013-03-19','10:20:00',9.22),('10318','2013-03-19','10:25:00',9.29),('10318','2013-03-19','10:30:00',9.29),('10318','2013-03-19','10:35:00',9.41),('10318','2013-03-19','10:40:00',9.49),('10318','2013-03-19','10:45:00',9.57),('10318','2013-03-19','10:50:00',9.42),('10318','2013-03-19','10:55:00',9.82),('10318','2013-03-19','11:00:00',9.82),('10318','2013-03-19','11:05:00',9.52),('10318','2013-03-19','11:10:00',9.83),('10318','2013-03-19','11:15:00',9.57),('10318','2013-03-19','11:20:00',9.85),('10318','2013-03-19','11:25:00',9.9),('10318','2013-03-19','11:30:00',9.78),('10318','2013-03-19','11:35:00',5.93),('10318','2013-03-19','11:40:00',8.62),('10318','2013-03-19','11:45:00',8.96),('10318','2013-03-19','11:50:00',10.04),('10318','2013-03-19','11:55:00',10.1),('10318','2013-03-19','12:00:00',9.96),('10318','2013-03-19','12:05:00',9.73),('10318','2013-03-19','12:10:00',9.84),('10318','2013-03-19','12:15:00',9.44),('10318','2013-03-19','12:20:00',9.81),('10318','2013-03-19','12:25:00',9.65),('10318','2013-03-19','12:30:00',9.66),('10318','2013-03-19','12:35:00',9.46),('10318','2013-03-19','12:40:00',9.57),('10318','2013-03-19','12:45:00',9.54),('10318','2013-03-19','12:50:00',8.69),('10318','2013-03-19','12:55:00',9.2),('10318','2013-03-19','13:00:00',9.17),('10318','2013-03-19','13:05:00',9.15),('10318','2013-03-19','13:10:00',9.12),('10318','2013-03-19','13:15:00',9.06),('10318','2013-03-19','13:20:00',8.94),('10318','2013-03-19','13:25:00',8.85),('10318','2013-03-19','13:30:00',8.71),('10318','2013-03-19','13:35:00',8.55),('10318','2013-03-19','13:40:00',8.4),('10318','2013-03-19','13:45:00',8.46),('10318','2013-03-19','13:50:00',8.18),('10318','2013-03-19','13:55:00',8.22),('10318','2013-03-19','14:00:00',8.1),('10318','2013-03-19','14:05:00',7.93),('10318','2013-03-19','14:10:00',7.76),('10318','2013-03-19','14:15:00',7.62),('10318','2013-03-19','14:20:00',7.48),('10318','2013-03-19','14:25:00',7.31),('10318','2013-03-19','14:30:00',7.2),('10318','2013-03-19','14:35:00',7.04),('10318','2013-03-19','14:40:00',6.86),('10318','2013-03-19','14:45:00',6.72),('10318','2013-03-19','14:50:00',6.49),('10318','2013-03-19','14:55:00',6.43),('10318','2013-03-19','15:00:00',6.23),('10318','2013-03-19','15:05:00',6.02),('10318','2013-03-19','15:10:00',5.87),('10318','2013-03-19','15:15:00',5.65),('10318','2013-03-19','15:20:00',5.49),('10318','2013-03-19','15:25:00',5.31),('10318','2013-03-19','15:30:00',5.1),('10318','2013-03-19','15:35:00',4.77),('10318','2013-03-19','15:40:00',4.71),('10318','2013-03-19','15:45:00',4.54),('10318','2013-03-19','15:50:00',4.31),('10318','2013-03-19','15:55:00',4.14),('10318','2013-03-19','16:00:00',3.95),('10318','2013-03-19','16:05:00',3.73),('10318','2013-03-19','16:10:00',3.51),('10318','2013-03-19','16:15:00',3.36),('10318','2013-03-19','16:20:00',3.16),('10318','2013-03-19','16:25:00',2.98),('10318','2013-03-19','16:30:00',2.8),('10318','2013-03-19','16:35:00',2.58),('10318','2013-03-19','16:40:00',2.46),('10318','2013-03-19','16:45:00',1.95),('10318','2013-03-19','16:50:00',1.6),('10318','2013-03-19','16:55:00',1.75),('10318','2013-03-19','17:00:00',1.23),('10318','2013-03-19','17:05:00',1.19),('10318','2013-03-19','17:10:00',1.23),('10318','2013-03-19','17:15:00',1.37),('10318','2013-03-19','17:20:00',1.23),('10318','2013-03-18','08:00:00',1.03),('10318','2013-03-18','08:10:00',1.01),('10318','2013-03-18','08:15:00',1.18),('10318','2013-03-18','08:20:00',1.44),('10318','2013-03-18','08:25:00',1.58),('10318','2013-03-18','08:30:00',1.59),('10318','2013-03-18','08:35:00',1.74),('10318','2013-03-18','08:40:00',1.93),('10318','2013-03-18','08:45:00',2.44),('10318','2013-03-18','08:50:00',1.94),('10318','2013-03-18','08:55:00',1.51),('10318','2013-03-18','09:20:00',1.13),('10318','2013-03-18','09:25:00',1.17),('10318','2013-03-18','09:30:00',1.22),('10318','2013-03-18','09:35:00',1.41),('10318','2013-03-18','09:40:00',1.67),('10318','2013-03-18','09:45:00',1.68),('10318','2013-03-18','09:50:00',1.91),('10318','2013-03-18','09:55:00',2.66),('10318','2013-03-18','10:00:00',3.22),('10318','2013-03-18','10:05:00',3.78),('10318','2013-03-18','10:10:00',4.2),('10318','2013-03-18','10:15:00',3.56),('10318','2013-03-18','10:20:00',4.04),('10318','2013-03-18','10:25:00',4.65),('10318','2013-03-18','10:30:00',4.3),('10318','2013-03-18','10:35:00',3.75),('10318','2013-03-18','10:40:00',3.51),('10318','2013-03-18','10:45:00',3.94),('10318','2013-03-18','10:50:00',3.11),('10318','2013-03-18','10:55:00',2.64),('10318','2013-03-18','11:00:00',2.94),('10318','2013-03-18','11:05:00',3.29),('10318','2013-03-18','11:10:00',3.79),('10318','2013-03-18','11:15:00',4.33),('10318','2013-03-18','11:20:00',4.39),('10318','2013-03-18','11:25:00',4.53),('10318','2013-03-18','11:30:00',6),('10318','2013-03-18','11:35:00',4.65),('10318','2013-03-18','11:40:00',3.98),('10318','2013-03-18','11:45:00',3.31),('10318','2013-03-18','11:50:00',2.88),('10318','2013-03-18','11:55:00',3.53),('10318','2013-03-18','12:00:00',3.64),('10318','2013-03-18','12:05:00',5.53),('10318','2013-03-18','12:10:00',6.03),('10318','2013-03-18','12:15:00',7.83),('10318','2013-03-18','12:20:00',7.04),('10318','2013-03-18','12:25:00',6.5),('10318','2013-03-18','12:30:00',8.7),('10318','2013-03-18','12:35:00',8.38),('10318','2013-03-18','12:40:00',5.34),('10318','2013-03-18','12:45:00',6.68),('10318','2013-03-18','12:50:00',7.77),('10318','2013-03-18','12:55:00',8.23),('10318','2013-03-18','13:00:00',6.81),('10318','2013-03-18','13:05:00',3.47),('10318','2013-03-18','13:10:00',2.85),('10318','2013-03-18','13:15:00',2.12),('10318','2013-03-18','13:20:00',3.08),('10318','2013-03-18','13:25:00',5.58),('10318','2013-03-18','13:30:00',2.75),('10318','2013-03-18','13:35:00',2.8),('10318','2013-03-18','13:40:00',4.36),('10318','2013-03-18','13:45:00',4.1),('10318','2013-03-18','13:50:00',3.48),('10318','2013-03-18','13:55:00',2.83),('10318','2013-03-18','14:00:00',3.97),('10318','2013-03-18','14:05:00',4.35),('10318','2013-03-18','14:10:00',5.04),('10318','2013-03-18','14:15:00',2.53),('10318','2013-03-18','14:20:00',2.79),('10318','2013-03-18','14:25:00',2.83),('10318','2013-03-18','14:30:00',1.77),('10318','2013-03-18','14:35:00',2.44),('10318','2013-03-18','14:40:00',2.33),('10318','2013-03-18','14:45:00',1.88),('10318','2013-03-18','14:50:00',1.22),('10318','2013-03-18','14:55:00',2.2),('10318','2013-03-18','15:00:00',2.18),('10318','2013-03-18','15:05:00',2),('10318','2013-03-18','15:10:00',1.52),('10318','2013-03-18','15:15:00',1.97),('10318','2013-03-18','15:20:00',1.35),('10318','2013-03-18','15:25:00',1.33),('10318','2013-03-18','15:30:00',1.32),('10318','2013-03-18','15:35:00',1.17),('10318','2013-03-17','07:40:00',1.08),('10318','2013-03-17','07:45:00',1.22),('10318','2013-03-17','07:50:00',1.39),('10318','2013-03-17','07:55:00',1.49),('10318','2013-03-17','08:00:00',1.66),('10318','2013-03-17','08:05:00',1.99),('10318','2013-03-17','08:10:00',2.17),('10318','2013-03-17','08:15:00',3.13),('10318','2013-03-17','08:20:00',2.92),('10318','2013-03-17','08:25:00',4.33),('10318','2013-03-17','08:30:00',3.11),('10318','2013-03-17','08:35:00',2.78),('10318','2013-03-17','08:40:00',3.07),('10318','2013-03-17','08:45:00',3.57),('10318','2013-03-17','08:50:00',3.36),('10318','2013-03-17','08:55:00',2.97),('10318','2013-03-17','09:00:00',3.04),('10318','2013-03-17','09:05:00',3.69),('10318','2013-03-17','09:10:00',4.41),('10318','2013-03-17','09:15:00',4.56),('10318','2013-03-17','09:20:00',3.57),('10318','2013-03-17','09:25:00',2.86),('10318','2013-03-17','09:30:00',3.44),('10318','2013-03-17','09:35:00',3.63),('10318','2013-03-17','09:40:00',3.39),('10318','2013-03-17','09:45:00',3.64),('10318','2013-03-17','09:50:00',4.15),('10318','2013-03-17','09:55:00',4.36),('10318','2013-03-17','10:00:00',4.87),('10318','2013-03-17','10:05:00',3.84),('10318','2013-03-17','10:10:00',3.94),('10318','2013-03-17','10:15:00',4.18),('10318','2013-03-17','10:20:00',4.3),('10318','2013-03-17','10:25:00',4.48),('10318','2013-03-17','10:30:00',4.29),('10318','2013-03-17','10:35:00',4.14),('10318','2013-03-17','10:40:00',3.93),('10318','2013-03-17','10:45:00',4.09),('10318','2013-03-17','10:50:00',3.46),('10318','2013-03-17','10:55:00',2.89),('10318','2013-03-17','11:00:00',2.94),('10318','2013-03-17','11:05:00',2.89),('10318','2013-03-17','11:10:00',2.9),('10318','2013-03-17','11:15:00',3.36),('10318','2013-03-17','11:20:00',4.03),('10318','2013-03-17','11:25:00',3.75),('10318','2013-03-17','11:30:00',3.43),('10318','2013-03-17','11:35:00',3.43),('10318','2013-03-17','11:40:00',3.27),('10318','2013-03-17','11:45:00',2.98),('10318','2013-03-17','11:50:00',2.79),('10318','2013-03-17','11:55:00',2.53),('10318','2013-03-17','12:00:00',2.41),('10318','2013-03-17','12:05:00',2.46),('10318','2013-03-17','12:10:00',3.31),('10318','2013-03-17','12:15:00',4.59),('10318','2013-03-17','12:20:00',5.41),('10318','2013-03-17','12:25:00',6.98),('10318','2013-03-17','12:30:00',6.64),('10318','2013-03-17','12:35:00',5.46),('10318','2013-03-17','12:40:00',5.55),('10318','2013-03-17','12:45:00',5.28),('10318','2013-03-17','12:50:00',4.45),('10318','2013-03-17','12:55:00',3.88),('10318','2013-03-17','13:00:00',4.62),('10318','2013-03-17','13:05:00',4.77),('10318','2013-03-17','13:10:00',5.23),('10318','2013-03-17','13:15:00',4.72),('10318','2013-03-17','13:20:00',4.11),('10318','2013-03-17','13:25:00',4.07),('10318','2013-03-17','13:30:00',6.16),('10318','2013-03-17','13:35:00',5.34),('10318','2013-03-17','13:40:00',4.35),('10318','2013-03-17','13:45:00',3.71),('10318','2013-03-17','13:50:00',3.41),('10318','2013-03-17','13:55:00',5.24),('10318','2013-03-17','14:00:00',4.46),('10318','2013-03-17','14:05:00',5.1),('10318','2013-03-17','14:10:00',6.17),('10318','2013-03-17','14:15:00',5.54),('10318','2013-03-17','14:20:00',5.84),('10318','2013-03-17','14:25:00',5.41),('10318','2013-03-17','14:30:00',4.64),('10318','2013-03-17','14:35:00',4.33),('10318','2013-03-17','14:40:00',3.32),('10318','2013-03-17','14:45:00',3.04),('10318','2013-03-17','14:50:00',2.52),('10318','2013-03-17','14:55:00',2.85),('10318','2013-03-17','15:00:00',3.58),('10318','2013-03-17','15:05:00',4.62),('10318','2013-03-17','15:10:00',6.5),('10318','2013-03-17','15:15:00',5.28),('10318','2013-03-17','15:20:00',6.37),('10318','2013-03-17','15:25:00',5.2),('10318','2013-03-17','15:30:00',3.64),('10318','2013-03-17','15:35:00',2.94),('10318','2013-03-17','15:40:00',2.58),('10318','2013-03-17','15:45:00',2.67),('10318','2013-03-17','15:50:00',1.58),('10318','2013-03-17','15:55:00',1.47),('10318','2013-03-17','16:00:00',1.31),('10318','2013-03-17','16:15:00',1.61),('10318','2013-03-17','16:20:00',1.32),('10318','2013-03-17','16:30:00',1.16),('10318','2013-03-17','16:35:00',1.31),('10318','2013-03-17','16:40:00',1.9),('10318','2013-03-17','16:45:00',1.74),('10318','2013-03-16','07:30:00',1.04),('10318','2013-03-16','07:35:00',1.12),('10318','2013-03-16','07:40:00',1.32),('10318','2013-03-16','07:45:00',2.34),('10318','2013-03-16','07:50:00',2.07),('10318','2013-03-16','07:55:00',2.31),('10318','2013-03-16','08:00:00',2.31),('10318','2013-03-16','08:05:00',3.72),('10318','2013-03-16','08:10:00',3.82),('10318','2013-03-16','08:15:00',3.34),('10318','2013-03-16','08:20:00',5.04),('10318','2013-03-16','08:25:00',6.04),('10318','2013-03-16','08:30:00',6.36),('10318','2013-03-16','08:35:00',6.54),('10318','2013-03-16','08:40:00',6.35),('10318','2013-03-16','08:45:00',6.41),('10318','2013-03-16','08:50:00',7.36),('10318','2013-03-16','08:55:00',7.32),('10318','2013-03-16','09:00:00',7.38),('10318','2013-03-16','09:05:00',6.67),('10318','2013-03-16','09:10:00',7.88),('10318','2013-03-16','09:15:00',7.89),('10318','2013-03-16','09:20:00',8.19),('10318','2013-03-16','09:25:00',7.22),('10318','2013-03-16','09:30:00',8.62),('10318','2013-03-16','09:35:00',8.49),('10318','2013-03-16','09:40:00',6.76),('10318','2013-03-16','09:45:00',9.15),('10318','2013-03-16','09:50:00',9.11),('10318','2013-03-16','09:55:00',9.49),('10318','2013-03-16','10:00:00',7.71),('10318','2013-03-16','10:05:00',7.04),('10318','2013-03-16','10:10:00',7.26),('10318','2013-03-16','10:15:00',6.39),('10318','2013-03-16','10:20:00',7.21),('10318','2013-03-16','10:25:00',6.41),('10318','2013-03-16','10:30:00',5.31),('10318','2013-03-16','10:35:00',7.86),('10318','2013-03-16','10:40:00',9.88),('10318','2013-03-16','10:45:00',9.78),('10318','2013-03-16','10:50:00',9.53),('10318','2013-03-16','10:55:00',9.77),('10318','2013-03-16','11:00:00',9.76),('10318','2013-03-16','11:05:00',9.55),('10318','2013-03-16','11:10:00',9.71),('10318','2013-03-16','11:15:00',9.75),('10318','2013-03-16','11:20:00',9.77),('10318','2013-03-16','11:25:00',9.75),('10318','2013-03-16','11:30:00',9.74),('10318','2013-03-16','11:35:00',9.75),('10318','2013-03-16','11:40:00',9.79),('10318','2013-03-16','11:45:00',9.79),('10318','2013-03-16','11:50:00',9.79),('10318','2013-03-16','11:55:00',9.8),('10318','2013-03-16','12:00:00',9.73),('10318','2013-03-16','12:05:00',9.69),('10318','2013-03-16','12:10:00',9.67),('10318','2013-03-16','12:15:00',9.67),('10318','2013-03-16','12:20:00',9.49),('10318','2013-03-16','12:25:00',9.54),('10318','2013-03-16','12:30:00',9.39),('10318','2013-03-16','12:35:00',9.42),('10318','2013-03-16','12:40:00',9.44),('10318','2013-03-16','12:45:00',9.38),('10318','2013-03-16','12:50:00',9.32),('10318','2013-03-16','12:55:00',9.18),('10318','2013-03-16','13:00:00',9.07),('10318','2013-03-16','13:05:00',9.05),('10318','2013-03-16','13:10:00',9.06),('10318','2013-03-16','13:15:00',9.08),('10318','2013-03-16','13:20:00',9.19),('10318','2013-03-16','13:25:00',8.94),('10318','2013-03-16','13:30:00',8.76),('10318','2013-03-16','13:35:00',8.65),('10318','2013-03-16','13:40:00',8.6),('10318','2013-03-16','13:45:00',8.69),('10318','2013-03-16','13:50:00',8.63),('10318','2013-03-16','13:55:00',8.53),('10318','2013-03-16','14:00:00',2.29),('10318','2013-03-16','14:05:00',6.09),('10318','2013-03-16','14:10:00',5.02),('10318','2013-03-16','14:15:00',5.24),('10318','2013-03-16','14:20:00',8.27),('10318','2013-03-16','14:25:00',7.23),('10318','2013-03-16','14:30:00',5.02),('10318','2013-03-16','14:35:00',2.03),('10318','2013-03-16','14:40:00',2.43),('10318','2013-03-16','14:45:00',1.72),('10318','2013-03-16','14:50:00',1.46),('10318','2013-03-16','14:55:00',1.29),('10318','2013-03-16','15:00:00',1.25),('10318','2013-03-16','15:05:00',1.17),('10318','2013-03-16','15:10:00',1.09),('10318','2013-03-16','15:15:00',1.12),('10318','2013-03-16','15:20:00',1.31),('10318','2013-03-16','15:25:00',1.29),('10318','2013-03-16','15:30:00',1.34),('10318','2013-03-16','15:35:00',3.18),('10318','2013-03-16','15:40:00',3.86),('10318','2013-03-16','15:45:00',1.68),('10318','2013-03-16','15:50:00',3.11),('10318','2013-03-16','15:55:00',4.25),('10318','2013-03-16','16:00:00',4.08),('10318','2013-03-16','16:05:00',4),('10318','2013-03-16','16:10:00',3.62),('10318','2013-03-16','16:15:00',1.9),('10318','2013-03-16','16:20:00',2.74),('10318','2013-03-16','16:25:00',1.75),('10318','2013-03-16','16:30:00',1.85),('10318','2013-03-16','16:35:00',2.58),('10318','2013-03-16','16:40:00',2.88),('10318','2013-03-16','16:45:00',2.9),('10318','2013-03-16','16:50:00',2.73),('10318','2013-03-16','16:55:00',2.53),('10318','2013-03-16','17:00:00',2.24),('10318','2013-03-16','17:05:00',2.12),('10318','2013-03-16','17:10:00',1.86),('10318','2013-03-16','17:15:00',1.5),('10318','2013-03-16','17:20:00',1.09),('10318','2013-03-16','17:25:00',1.09),('10318','2013-03-15','09:50:00',1.05),('10318','2013-03-15','09:55:00',1.25),('10318','2013-03-15','10:00:00',1.56),('10318','2013-03-15','10:05:00',1.64),('10318','2013-03-15','10:10:00',1.42),('10318','2013-03-15','10:15:00',1.52),('10318','2013-03-15','10:20:00',1.54),('10318','2013-03-15','10:25:00',1.77),('10318','2013-03-15','10:30:00',2.26),('10318','2013-03-15','10:35:00',2.55),('10318','2013-03-15','10:40:00',2.85),('10318','2013-03-15','10:45:00',3.16),('10318','2013-03-15','10:50:00',3.49),('10318','2013-03-15','10:55:00',3.65),('10318','2013-03-15','11:00:00',3.37),('10318','2013-03-15','11:05:00',3.03),('10318','2013-03-15','11:10:00',2.95),('10318','2013-03-15','11:15:00',2.45),('10318','2013-03-15','11:20:00',2.66),('10318','2013-03-15','11:25:00',3.17),('10318','2013-03-15','11:30:00',3.8),('10318','2013-03-15','11:35:00',4.86),('10318','2013-03-15','11:40:00',4.6),('10318','2013-03-15','11:45:00',4.81),('10318','2013-03-15','11:50:00',4.83),('10318','2013-03-15','11:55:00',5.11),('10318','2013-03-15','12:00:00',4.64),('10318','2013-03-15','12:05:00',4.43),('10318','2013-03-15','12:10:00',5.63),('10318','2013-03-15','12:15:00',4.27),('10318','2013-03-15','12:20:00',4.33),('10318','2013-03-15','12:25:00',4.52),('10318','2013-03-15','12:30:00',4.77),('10318','2013-03-15','12:35:00',4.71),('10318','2013-03-15','12:40:00',3.68),('10318','2013-03-15','12:45:00',2.84),('10318','2013-03-15','12:50:00',2.89),('10318','2013-03-15','12:55:00',2.98),('10318','2013-03-15','13:00:00',2.72),('10318','2013-03-15','13:05:00',2.62),('10318','2013-03-15','13:10:00',2.88),('10318','2013-03-15','13:15:00',3.29),('10318','2013-03-15','13:20:00',3.7),('10318','2013-03-15','13:25:00',4.16),('10318','2013-03-15','13:30:00',3.47),('10318','2013-03-15','13:35:00',3.38),('10318','2013-03-15','13:40:00',3.39),('10318','2013-03-15','13:45:00',3.27),('10318','2013-03-15','13:50:00',2.75),('10318','2013-03-15','13:55:00',2.45),('10318','2013-03-15','14:00:00',2.14),('10318','2013-03-15','14:05:00',1.87),('10318','2013-03-15','14:10:00',1.67),('10318','2013-03-15','14:15:00',1.62),('10318','2013-03-15','14:20:00',1.46),('10318','2013-03-15','14:25:00',1.24),('10318','2013-03-15','14:30:00',1.13),('10318','2013-03-15','14:35:00',1.23),('10318','2013-03-15','14:40:00',1.6),('10318','2013-03-15','14:45:00',2.12),('10318','2013-03-15','14:50:00',2.66),('10318','2013-03-15','14:55:00',2.77),('10318','2013-03-15','15:00:00',2.78),('10318','2013-03-15','15:05:00',2.63),('10318','2013-03-15','15:10:00',2.82),('10318','2013-03-15','15:15:00',2.95),('10318','2013-03-15','15:20:00',3.66),('10318','2013-03-15','15:25:00',3.12),('10318','2013-03-15','15:30:00',2.53),('10318','2013-03-15','15:35:00',2.2),('10318','2013-03-15','15:40:00',2.01),('10318','2013-03-15','15:45:00',2.05),('10318','2013-03-15','15:50:00',1.84),('10318','2013-03-15','15:55:00',1.78),('10318','2013-03-15','16:00:00',1.84),('10318','2013-03-15','16:05:00',1.63),('10318','2013-03-15','16:10:00',1.5),('10318','2013-03-15','16:15:00',1.46),('10318','2013-03-15','16:20:00',1.16),('10318','2013-03-15','17:10:00',1.5),('10318','2013-03-15','17:15:00',1.47),('10318','2013-03-15','17:20:00',1.14),('10318','2013-03-14','08:20:00',1.18),('10318','2013-03-14','08:25:00',1.42),('10318','2013-03-14','08:30:00',1.16),('10318','2013-03-14','09:30:00',1.27),('10318','2013-03-14','09:35:00',1.46),('10318','2013-03-14','09:40:00',1.57),('10318','2013-03-14','09:45:00',1.62),('10318','2013-03-14','09:50:00',1.45),('10318','2013-03-14','09:55:00',1.48),('10318','2013-03-14','10:00:00',1.47),('10318','2013-03-14','10:05:00',1.32),('10318','2013-03-14','10:10:00',1.28),('10318','2013-03-14','10:15:00',1.44),('10318','2013-03-14','10:20:00',1.5),('10318','2013-03-14','10:25:00',1.32),('10318','2013-03-14','10:30:00',1.25),('10318','2013-03-14','10:35:00',1.22),('10318','2013-03-14','10:40:00',1.08),('10318','2013-03-14','11:10:00',1.03),('10318','2013-03-14','11:15:00',1.24),('10318','2013-03-14','11:20:00',1.42),('10318','2013-03-14','11:25:00',1.53),('10318','2013-03-14','11:30:00',1.65),('10318','2013-03-14','11:35:00',1.72),('10318','2013-03-14','11:40:00',1.74),('10318','2013-03-14','11:45:00',1.71),('10318','2013-03-14','11:50:00',1.64),('10318','2013-03-14','11:55:00',1.45),('10318','2013-03-14','12:00:00',1.35),('10318','2013-03-14','12:05:00',1.36),('10318','2013-03-14','12:10:00',1.33),('10318','2013-03-14','12:15:00',1.41),('10318','2013-03-14','12:20:00',1.53),('10318','2013-03-14','12:25:00',1.7),('10318','2013-03-14','12:30:00',1.79),('10318','2013-03-14','12:35:00',1.93),('10318','2013-03-14','12:40:00',2.16),('10318','2013-03-14','12:45:00',2.39),('10318','2013-03-14','12:50:00',2.58),('10318','2013-03-14','12:55:00',2.64),('10318','2013-03-14','13:00:00',2.78),('10318','2013-03-14','13:05:00',2.83),('10318','2013-03-14','13:10:00',2.86),('10318','2013-03-14','13:15:00',3.06),('10318','2013-03-14','13:20:00',2.39),('10318','2013-03-14','13:25:00',2.33),('10318','2013-03-14','13:30:00',3.38),('10318','2013-03-14','13:35:00',3.8),('10318','2013-03-14','13:40:00',3.61),('10318','2013-03-14','13:45:00',2.93),('10318','2013-03-14','13:50:00',2.67),('10318','2013-03-14','13:55:00',3.25),('10318','2013-03-14','14:00:00',3.42),('10318','2013-03-14','14:05:00',3.25),('10318','2013-03-14','14:10:00',2.98),('10318','2013-03-14','14:15:00',2.84),('10318','2013-03-14','14:20:00',3.05),('10318','2013-03-14','14:25:00',2.45),('10318','2013-03-14','14:30:00',1.69),('10318','2013-03-14','14:35:00',1.05),('10318','2013-03-14','14:40:00',1.04),('10318','2013-03-14','14:45:00',1.06),('10318','2013-03-14','14:50:00',1.12),('10318','2013-03-14','14:55:00',1.19),('10318','2013-03-14','15:00:00',1.22),('10318','2013-03-14','15:05:00',1.93),('10318','2013-03-14','15:10:00',2.58),('10318','2013-03-14','15:15:00',2.5),('10318','2013-03-14','15:20:00',2.6),('10318','2013-03-14','15:25:00',2.81),('10318','2013-03-14','15:30:00',2.66),('10318','2013-03-14','15:35:00',1.92),('10318','2013-03-14','15:40:00',1.38),('10318','2013-03-14','16:25:00',1.38),('10318','2013-03-14','16:30:00',1.23),('10318','2013-03-13','08:05:00',1.57),('10318','2013-03-13','08:10:00',1.69),('10318','2013-03-13','08:15:00',1.31),('10318','2013-03-13','08:20:00',1.32),('10318','2013-03-13','08:25:00',1.31),('10318','2013-03-13','08:30:00',1.16),('10318','2013-03-13','08:35:00',1.11),('10318','2013-03-13','08:40:00',1.56),('10318','2013-03-13','08:45:00',1.66),('10318','2013-03-13','08:50:00',2.2),('10318','2013-03-13','08:55:00',1.96),('10318','2013-03-13','09:00:00',1.52),('10318','2013-03-13','09:05:00',1.77),('10318','2013-03-13','09:10:00',2.49),('10318','2013-03-13','09:15:00',2.04),('10318','2013-03-13','09:20:00',1.59),('10318','2013-03-13','09:25:00',1.81),('10318','2013-03-13','09:30:00',1.84),('10318','2013-03-13','09:35:00',1.84),('10318','2013-03-13','09:40:00',1.8),('10318','2013-03-13','09:45:00',2.01),('10318','2013-03-13','09:50:00',2.23),('10318','2013-03-13','09:55:00',1.37),('10318','2013-03-13','10:00:00',1.53),('10318','2013-03-13','10:05:00',2.47),('10318','2013-03-13','10:10:00',4.41),('10318','2013-03-13','10:15:00',4.14),('10318','2013-03-13','10:20:00',2.27),('10318','2013-03-13','10:25:00',4.77),('10318','2013-03-13','10:30:00',7.95),('10318','2013-03-13','10:35:00',6.9),('10318','2013-03-13','10:40:00',6.68),('10318','2013-03-13','10:45:00',6.51),('10318','2013-03-13','10:50:00',3.71),('10318','2013-03-13','10:55:00',2.19),('10318','2013-03-13','11:00:00',1.9),('10318','2013-03-13','11:05:00',2.01),('10318','2013-03-13','11:10:00',2.52),('10318','2013-03-13','11:15:00',2.54),('10318','2013-03-13','11:20:00',2.8),('10318','2013-03-13','11:25:00',2.38),('10318','2013-03-13','11:30:00',2.67),('10318','2013-03-13','11:35:00',2.74),('10318','2013-03-13','11:40:00',3.01),('10318','2013-03-13','11:45:00',3.45),('10318','2013-03-13','11:50:00',2.94),('10318','2013-03-13','11:55:00',2.05),('10318','2013-03-13','12:00:00',1.06),('10318','2013-03-13','12:20:00',1.12),('10318','2013-03-13','12:25:00',1.35),('10318','2013-03-13','12:30:00',1.7),('10318','2013-03-13','12:35:00',2.04),('10318','2013-03-13','12:40:00',2.26),('10318','2013-03-13','12:45:00',2.6),('10318','2013-03-13','12:50:00',2.84),('10318','2013-03-13','12:55:00',2.76),('10318','2013-03-13','13:00:00',2.61),('10318','2013-03-13','13:05:00',2.58),('10318','2013-03-13','13:10:00',2.43),('10318','2013-03-13','13:15:00',1.88),('10318','2013-03-13','13:20:00',1.59),('10318','2013-03-13','13:25:00',1.6),('10318','2013-03-13','13:30:00',1.98),('10318','2013-03-13','13:35:00',2.71),('10318','2013-03-13','13:40:00',2.33),('10318','2013-03-13','13:45:00',2.04),('10318','2013-03-13','13:50:00',1.78),('10318','2013-03-13','13:55:00',1.23),('10318','2013-03-13','14:00:00',1.08),('10318','2013-03-13','14:05:00',1.19),('10318','2013-03-13','14:10:00',1.2),('10318','2013-03-13','14:35:00',1.11),('10318','2013-03-13','14:40:00',1.11),('10318','2013-03-13','14:45:00',1.31),('10318','2013-03-13','14:50:00',1.58),('10318','2013-03-13','14:55:00',1.47),('10318','2013-03-13','15:00:00',1.53),('10318','2013-03-13','15:05:00',1.64),('10318','2013-03-13','15:10:00',1.75),('10318','2013-03-13','15:15:00',1.36),('10318','2014-03-25','06:50:00',1.11),('10318','2014-03-25','06:55:00',1.26),('10318','2014-03-25','07:00:00',1.3),('10318','2014-03-25','07:05:00',1.51),('10318','2014-03-25','07:10:00',2.36),('10318','2014-03-25','07:15:00',3.23),('10318','2014-03-25','07:20:00',3.99),('10318','2014-03-25','07:25:00',3.96),('10318','2014-03-25','07:30:00',4.12),('10318','2014-03-25','07:35:00',3.04),('10318','2014-03-25','07:40:00',2.91),('10318','2014-03-25','07:45:00',3.24),('10318','2014-03-25','07:50:00',3.31),('10318','2014-03-25','07:55:00',3.26),('10318','2014-03-25','08:00:00',3.02),('10318','2014-03-25','08:05:00',3.1),('10318','2014-03-25','08:10:00',3.3),('10318','2014-03-25','08:15:00',3.43),('10318','2014-03-25','08:20:00',2.98),('10318','2014-03-25','08:25:00',2.67),('10318','2014-03-25','08:30:00',2.45),('10318','2014-03-25','08:35:00',2.63),('10318','2014-03-25','08:40:00',3.32),('10318','2014-03-25','08:45:00',4.79),('10318','2014-03-25','08:50:00',4.57),('10318','2014-03-25','08:55:00',4.77),('10318','2014-03-25','09:00:00',4.25),('10318','2014-03-25','09:05:00',4.45),('10318','2014-03-25','09:10:00',4.6),('10318','2014-03-25','09:15:00',5.91),('10318','2014-03-25','09:20:00',6.03),('10318','2014-03-25','09:25:00',5.07),('10318','2014-03-25','09:30:00',4.54),('10318','2014-03-25','09:35:00',4.34),('10318','2014-03-25','09:40:00',4.32),('10318','2014-03-25','09:45:00',4.21),('10318','2014-03-25','09:50:00',4.63),('10318','2014-03-25','09:55:00',5.16),('10318','2014-03-25','10:00:00',5.76),('10318','2014-03-25','10:05:00',6.49),('10318','2014-03-25','10:10:00',7.01),('10318','2014-03-25','10:15:00',7.48),('10318','2014-03-25','10:20:00',7.09),('10318','2014-03-25','10:25:00',7.53),('10318','2014-03-25','10:30:00',6.61),('10318','2014-03-25','10:35:00',5.39),('10318','2014-03-25','10:40:00',4.74),('10318','2014-03-25','10:45:00',4.39),('10318','2014-03-25','10:50:00',4.17),('10318','2014-03-25','10:55:00',4.41),('10318','2014-03-25','11:00:00',4.98),('10318','2014-03-25','11:05:00',5.7),('10318','2014-03-25','11:10:00',6.44),('10318','2014-03-25','11:15:00',6.72),('10318','2014-03-25','11:20:00',6.96),('10318','2014-03-25','11:25:00',7.29),('10318','2014-03-25','11:30:00',7.45),('10318','2014-03-25','11:35:00',6.57),('10318','2014-03-25','11:40:00',5.05),('10318','2014-03-25','11:45:00',4.63),('10318','2014-03-25','11:50:00',5.01),('10318','2014-03-25','11:55:00',3.77),('10318','2014-03-25','12:00:00',2.43),('10318','2014-03-25','12:05:00',1.67),('10318','2014-03-25','12:10:00',1.73),('10318','2014-03-25','12:15:00',1.94),('10318','2014-03-25','12:20:00',2.31),('10318','2014-03-25','12:25:00',2.92),('10318','2014-03-25','12:30:00',2.79),('10318','2014-03-25','12:35:00',2.4),('10318','2014-03-25','12:40:00',2.08),('10318','2014-03-25','12:45:00',2.34),('10318','2014-03-25','12:50:00',2.01),('10318','2014-03-25','12:55:00',1.31),('10318','2014-03-25','13:05:00',1.13),('10318','2014-03-25','13:10:00',1.15),('10318','2014-03-25','13:15:00',1.13),('10318','2014-03-25','13:20:00',1.23),('10318','2014-03-25','13:25:00',1.36),('10318','2014-03-25','13:30:00',1.57),('10318','2014-03-25','13:35:00',1.83),('10318','2014-03-25','13:40:00',1.78),('10318','2014-03-25','13:45:00',1.48),('10318','2014-03-25','13:50:00',1.6),('10318','2014-03-25','13:55:00',1.88),('10318','2014-03-25','14:00:00',2.01),('10318','2014-03-25','14:05:00',1.83),('10318','2014-03-25','14:10:00',1.54),('10318','2014-03-25','14:15:00',1.51),('10318','2014-03-25','14:20:00',1.34),('10318','2014-03-25','14:25:00',1.21),('10318','2014-03-25','14:30:00',1.5),('10318','2014-03-25','14:35:00',1.55),('10318','2014-03-25','14:40:00',1.52),('10318','2014-03-25','14:45:00',1.65),('10318','2014-03-25','14:50:00',1.55),('10318','2014-03-25','14:55:00',1.3),('10318','2014-03-25','15:00:00',1.18),('10318','2014-03-25','15:10:00',1.07),('10318','2014-03-25','15:15:00',1.63),('10318','2014-03-25','15:20:00',1.66),('10318','2014-03-25','15:25:00',1.18),('10318','2014-03-25','15:45:00',1.1),('10318','2014-03-25','15:50:00',1.05),('10318','2014-03-25','15:55:00',1.15),('10318','2013-03-11','07:10:00',1.01),('10318','2013-03-11','07:15:00',1.37),('10318','2013-03-11','07:20:00',1.64),('10318','2013-03-11','07:25:00',1.63),('10318','2013-03-11','07:30:00',1.87),('10318','2013-03-11','07:35:00',3.31),('10318','2013-03-11','07:40:00',2.9),('10318','2013-03-11','07:55:00',1.45),('10318','2013-03-11','08:00:00',3.02),('10318','2013-03-11','08:05:00',3.82),('10318','2013-03-11','08:10:00',4.63),('10318','2013-03-11','08:15:00',4.87),('10318','2013-03-11','08:20:00',5.09),('10318','2013-03-11','08:25:00',5.33),('10318','2013-03-11','08:30:00',5.53),('10318','2013-03-11','08:35:00',5.66),('10318','2013-03-11','08:40:00',6),('10318','2013-03-11','08:45:00',6.23),('10318','2013-03-11','08:50:00',5.56),('10318','2013-03-11','08:55:00',6.34),('10318','2013-03-11','09:00:00',6.66),('10318','2013-03-11','09:05:00',6.8),('10318','2013-03-11','09:10:00',6.95),('10318','2013-03-11','09:15:00',7.13),('10318','2013-03-11','09:20:00',7.48),('10318','2013-03-11','09:25:00',8.49),('10318','2013-03-11','09:30:00',6.8),('10318','2013-03-11','09:35:00',5.19),('10318','2013-03-11','09:40:00',4.37),('10318','2013-03-11','09:45:00',2.35),('10318','2013-03-11','09:50:00',1.67),('10318','2013-03-11','09:55:00',2.07),('10318','2013-03-11','10:00:00',2.32),('10318','2013-03-11','10:05:00',2.68),('10318','2013-03-11','10:10:00',3.22),('10318','2013-03-11','10:15:00',3.11),('10318','2013-03-11','10:20:00',3.23),('10318','2013-03-11','10:25:00',3.21),('10318','2013-03-11','10:30:00',3.16),('10318','2013-03-11','10:35:00',3.84),('10318','2013-03-11','10:40:00',5.68),('10318','2013-03-11','10:45:00',6.27),('10318','2013-03-11','10:50:00',6.13),('10318','2013-03-11','10:55:00',4.77),('10318','2013-03-11','11:00:00',3.92),('10318','2013-03-11','11:05:00',3.25),('10318','2013-03-11','11:10:00',3.13),('10318','2013-03-11','11:15:00',3.2),('10318','2013-03-11','11:20:00',3.18),('10318','2013-03-11','11:25:00',3.93),('10318','2013-03-11','11:30:00',4.74),('10318','2013-03-11','11:35:00',3.58),('10318','2013-03-11','11:40:00',4.36),('10318','2013-03-11','11:45:00',8.09),('10318','2013-03-11','11:50:00',5.54),('10318','2013-03-11','11:55:00',4.35),('10318','2013-03-11','12:00:00',3.86),('10318','2013-03-11','12:05:00',3.83),('10318','2013-03-11','12:10:00',6.97),('10318','2013-03-11','12:15:00',7.39),('10318','2013-03-11','12:20:00',7.22),('10318','2013-03-11','12:25:00',3.97),('10318','2013-03-11','12:30:00',3.73),('10318','2013-03-11','12:35:00',4.37),('10318','2013-03-11','12:40:00',3.33),('10318','2013-03-11','12:45:00',3.64),('10318','2013-03-11','12:50:00',3.47),('10318','2013-03-11','12:55:00',6.01),('10318','2013-03-11','13:00:00',5.48),('10318','2013-03-11','13:05:00',6.37),('10318','2013-03-11','13:10:00',4.45),('10318','2013-03-11','13:15:00',3.7),('10318','2013-03-11','13:20:00',6.93),('10318','2013-03-11','13:25:00',8.61),('10318','2013-03-11','13:30:00',3.3),('10318','2013-03-11','13:35:00',8.11),('10318','2013-03-11','13:40:00',2.45),('10318','2013-03-11','13:45:00',1.87),('10318','2013-03-11','13:50:00',1.69),('10318','2013-03-11','13:55:00',1.53),('10318','2013-03-11','14:00:00',1.53),('10318','2013-03-11','14:05:00',3.91),('10318','2013-03-11','14:10:00',8.48),('10318','2013-03-11','14:15:00',7.46),('10318','2013-03-11','14:20:00',5.47),('10318','2013-03-11','14:25:00',6.17),('10318','2013-03-11','14:30:00',7.92),('10318','2013-03-11','14:35:00',7.4),('10318','2013-03-11','14:40:00',2.62),('10318','2013-03-11','14:45:00',5.77),('10318','2013-03-11','14:50:00',6.88),('10318','2013-03-11','14:55:00',6.6),('10318','2013-03-11','15:00:00',5.22),('10318','2013-03-11','15:05:00',5.04),('10318','2013-03-11','15:10:00',5.26),('10318','2013-03-11','15:15:00',6.01),('10318','2013-03-11','15:20:00',5.81),('10318','2013-03-11','15:25:00',4.65),('10318','2013-03-11','15:30:00',4.86),('10318','2013-03-11','15:35:00',4.27),('10318','2013-03-11','15:40:00',5.18),('10318','2013-03-11','15:45:00',4.74),('10318','2013-03-11','15:50:00',3.8),('10318','2013-03-11','15:55:00',2.88),('10318','2013-03-11','16:00:00',2.06),('10318','2013-03-11','16:05:00',4.31),('10318','2013-03-11','16:10:00',3.45),('10318','2013-03-11','16:15:00',3.38),('10318','2013-03-11','16:20:00',3.2),('10318','2013-03-11','16:25:00',2.78),('10318','2013-03-11','16:30:00',2.58),('10318','2013-03-11','16:35:00',2.27),('10318','2013-03-11','16:40:00',1.81),('10318','2013-03-11','16:45:00',1.54),('10318','2013-03-11','16:50:00',1.14),('10318','2013-03-11','17:05:00',1.13),('10318','2013-03-10','07:15:00',1.05),('10318','2013-03-10','07:20:00',1.24),('10318','2013-03-10','07:25:00',1.38),('10318','2013-03-10','07:30:00',1.79),('10318','2013-03-10','07:35:00',2.42),('10318','2013-03-10','07:40:00',3.25),('10318','2013-03-10','07:45:00',3.12),('10318','2013-03-10','07:50:00',3.71),('10318','2013-03-10','07:55:00',3.97),('10318','2013-03-10','08:00:00',4.22),('10318','2013-03-10','08:05:00',4.43),('10318','2013-03-10','08:10:00',4.52),('10318','2013-03-10','08:15:00',4.96),('10318','2013-03-10','08:20:00',5.13),('10318','2013-03-10','08:25:00',5.33),('10318','2013-03-10','08:30:00',5.53),('10318','2013-03-10','08:35:00',5.66),('10318','2013-03-10','08:40:00',5.88),('10318','2013-03-10','08:45:00',6.08),('10318','2013-03-10','08:50:00',6.26),('10318','2013-03-10','08:55:00',6.47),('10318','2013-03-10','09:00:00',6.63),('10318','2013-03-10','09:05:00',6.7),('10318','2013-03-10','09:10:00',6.95),('10318','2013-03-10','09:15:00',7.1),('10318','2013-03-10','09:20:00',7.15),('10318','2013-03-10','09:25:00',7.36),('10318','2013-03-10','09:30:00',7.62),('10318','2013-03-10','09:35:00',7.56),('10318','2013-03-10','09:40:00',8.32),('10318','2013-03-10','09:45:00',4.67),('10318','2013-03-10','09:50:00',8),('10318','2013-03-10','09:55:00',8.95),('10318','2013-03-10','10:00:00',9.39),('10318','2013-03-10','10:05:00',8.4),('10318','2013-03-10','10:10:00',8.71),('10318','2013-03-10','10:15:00',8.7),('10318','2013-03-10','10:20:00',7.19),('10318','2013-03-10','10:25:00',6.84),('10318','2013-03-10','10:30:00',8.39),('10318','2013-03-10','10:35:00',8.93),('10318','2013-03-10','10:40:00',8.52),('10318','2013-03-10','10:45:00',8.85),('10318','2013-03-10','10:50:00',8.84),('10318','2013-03-10','10:55:00',9.09),('10318','2013-03-10','11:00:00',9.33),('10318','2013-03-10','11:05:00',8.41),('10318','2013-03-10','11:10:00',7.81),('10318','2013-03-10','11:15:00',9.51),('10318','2013-03-10','11:20:00',8.96),('10318','2013-03-10','11:25:00',7.32),('10318','2013-03-10','11:30:00',8.59),('10318','2013-03-10','11:35:00',10.16),('10318','2013-03-10','11:40:00',3.87),('10318','2013-03-10','11:45:00',7.99),('10318','2013-03-10','11:50:00',9.8),('10318','2013-03-10','11:55:00',9.54),('10318','2013-03-10','12:00:00',9.35),('10318','2013-03-10','12:05:00',9.22),('10318','2013-03-10','12:10:00',9.22),('10318','2013-03-10','12:15:00',9.25),('10318','2013-03-10','12:20:00',8.89),('10318','2013-03-10','12:25:00',8.88),('10318','2013-03-10','12:30:00',9.25),('10318','2013-03-10','12:35:00',8.9),('10318','2013-03-10','12:40:00',9.26),('10318','2013-03-10','12:45:00',9.5),('10318','2013-03-10','12:50:00',9.35),('10318','2013-03-10','12:55:00',9.27),('10318','2013-03-10','13:00:00',9.11),('10318','2013-03-10','13:05:00',8.56),('10318','2013-03-10','13:10:00',8.4),('10318','2013-03-10','13:15:00',8.84),('10318','2013-03-10','13:20:00',8.7),('10318','2013-03-10','13:25:00',7.71),('10318','2013-03-10','13:30:00',8.02),('10318','2013-03-10','13:35:00',6.63),('10318','2013-03-10','13:40:00',4.61),('10318','2013-03-10','13:45:00',4.54),('10318','2013-03-10','13:50:00',3.96),('10318','2013-03-10','13:55:00',4.02),('10318','2013-03-10','14:00:00',3.63),('10318','2013-03-10','14:05:00',4.93),('10318','2013-03-10','14:10:00',4.46),('10318','2013-03-10','14:15:00',5.1),('10318','2013-03-10','14:20:00',5.65),('10318','2013-03-10','14:25:00',5.29),('10318','2013-03-10','14:30:00',6.41),('10318','2013-03-10','14:35:00',4.19),('10318','2013-03-10','14:40:00',5.9),('10318','2013-03-10','14:45:00',4.12),('10318','2013-03-10','14:50:00',3.57),('10318','2013-03-10','14:55:00',2.88),('10318','2013-03-10','15:00:00',2.29),('10318','2013-03-10','15:05:00',3.15),('10318','2013-03-10','15:10:00',2.55),('10318','2013-03-10','15:15:00',1.9),('10318','2013-03-10','15:20:00',1.84),('10318','2013-03-10','15:25:00',1.21),('10318','2013-03-10','15:30:00',1.27),('10318','2013-03-10','15:35:00',1.3),('10318','2013-03-10','15:40:00',1.25),('10318','2013-03-10','15:45:00',1.5),('10318','2013-03-10','15:50:00',1.89),('10318','2013-03-10','15:55:00',1.62),('10318','2013-03-10','16:00:00',1.05),('10318','2013-03-09','07:40:00',1.22),('10318','2013-03-09','07:45:00',2.7),('10318','2013-03-09','07:50:00',1.08),('10318','2013-03-09','07:55:00',1.42),('10318','2013-03-09','08:00:00',3.56),('10318','2013-03-09','08:05:00',3.73),('10318','2013-03-09','08:10:00',4.67),('10318','2013-03-09','08:15:00',4.61),('10318','2013-03-09','08:20:00',4.99),('10318','2013-03-09','08:25:00',5.15),('10318','2013-03-09','08:30:00',5.46),('10318','2013-03-09','08:35:00',5.64),('10318','2013-03-09','08:40:00',5.78),('10318','2013-03-09','08:45:00',6),('10318','2013-03-09','08:50:00',5.98),('10318','2013-03-09','08:55:00',4.63),('10318','2013-03-09','09:00:00',4.64),('10318','2013-03-09','09:05:00',5.22),('10318','2013-03-09','09:10:00',6.05),('10318','2013-03-09','09:15:00',3.22),('10318','2013-03-09','09:20:00',2.17),('10318','2013-03-09','09:25:00',2.32),('10318','2013-03-09','09:30:00',5.24),('10318','2013-03-09','09:35:00',1.84),('10318','2013-03-09','09:40:00',3.43),('10318','2013-03-09','09:45:00',2.44),('10318','2013-03-09','09:50:00',4.45),('10318','2013-03-09','09:55:00',4.49),('10318','2013-03-09','10:00:00',6.25),('10318','2013-03-09','10:05:00',2.12),('10318','2013-03-09','10:10:00',3.72),('10318','2013-03-09','10:15:00',1.9),('10318','2013-03-09','10:20:00',1.83),('10318','2013-03-09','10:25:00',3.31),('10318','2013-03-09','10:30:00',2.53),('10318','2013-03-09','10:35:00',6.17),('10318','2013-03-09','10:40:00',3.44),('10318','2013-03-09','10:45:00',4.26),('10318','2013-03-09','10:50:00',6.9),('10318','2013-03-09','10:55:00',7.55),('10318','2013-03-09','11:00:00',8.57),('10318','2013-03-09','11:05:00',8.4),('10318','2013-03-09','11:10:00',8.21),('10318','2013-03-09','11:15:00',8.94),('10318','2013-03-09','11:20:00',8.27),('10318','2013-03-09','11:25:00',9.15),('10318','2013-03-09','11:30:00',9.32),('10318','2013-03-09','11:35:00',8.96),('10318','2013-03-09','11:40:00',8.86),('10318','2013-03-09','11:45:00',9.28),('10318','2013-03-09','11:50:00',9.22),('10318','2013-03-09','11:55:00',9.24),('10318','2013-03-09','12:00:00',9.2),('10318','2013-03-09','12:05:00',9.28),('10318','2013-03-09','12:10:00',8.81),('10318','2013-03-09','12:15:00',8.05),('10318','2013-03-09','12:20:00',5.2),('10318','2013-03-09','12:25:00',7.8),('10318','2013-03-09','12:30:00',7.77),('10318','2013-03-09','12:35:00',5.52),('10318','2013-03-09','12:40:00',7.11),('10318','2013-03-09','12:45:00',9.15),('10318','2013-03-09','12:50:00',9.33),('10318','2013-03-09','12:55:00',8.86),('10318','2013-03-09','13:00:00',6.49),('10318','2013-03-09','13:05:00',8.74),('10318','2013-03-09','13:10:00',8.46),('10318','2013-03-09','13:15:00',8.82),('10318','2013-03-09','13:20:00',8.98),('10318','2013-03-09','13:25:00',9.4),('10318','2013-03-09','13:30:00',8.55),('10318','2013-03-09','13:35:00',8.33),('10318','2013-03-09','13:40:00',7.1),('10318','2013-03-09','13:45:00',6.31),('10318','2013-03-09','13:50:00',3.68),('10318','2013-03-09','13:55:00',6.23),('10318','2013-03-09','14:00:00',3.14),('10318','2013-03-09','14:05:00',8.14),('10318','2013-03-09','14:10:00',7.78),('10318','2013-03-09','14:15:00',2.89),('10318','2013-03-09','14:20:00',5.52),('10318','2013-03-09','14:25:00',5.88),('10318','2013-03-09','14:30:00',6.81),('10318','2013-03-09','14:35:00',6.58),('10318','2013-03-09','14:40:00',6.41),('10318','2013-03-09','14:45:00',6.24),('10318','2013-03-09','14:50:00',6.08),('10318','2013-03-09','14:55:00',5.79),('10318','2013-03-09','15:00:00',5.74),('10318','2013-03-09','15:05:00',5.57),('10318','2013-03-09','15:10:00',5.39),('10318','2013-03-09','15:15:00',5.21),('10318','2013-03-09','15:20:00',5.03),('10318','2013-03-09','15:25:00',4.86),('10318','2013-03-09','15:30:00',4.71),('10318','2013-03-09','15:35:00',4.52),('10318','2013-03-09','15:40:00',4.3),('10318','2013-03-09','15:45:00',4.13),('10318','2013-03-09','15:50:00',3.91),('10318','2013-03-09','15:55:00',3.76),('10318','2013-03-09','16:00:00',3.18),('10318','2013-03-09','16:05:00',3.11),('10318','2013-03-09','16:10:00',2.39),('10318','2013-03-09','16:15:00',2.73),('10318','2013-03-09','16:20:00',1.97),('10318','2013-03-09','16:25:00',2.83),('10318','2013-03-09','16:30:00',1.69),('10318','2013-03-09','16:35:00',2.13),('10318','2013-03-09','16:40:00',1.96),('10318','2013-03-09','16:45:00',1.32),('10318','2013-03-09','16:50:00',1.31),('10318','2013-03-08','08:10:00',1.12),('10318','2013-03-08','08:15:00',1.14),('10318','2013-03-08','08:25:00',1.13),('10318','2013-03-08','08:30:00',3.06),('10318','2013-03-08','08:35:00',2.97),('10318','2013-03-08','08:40:00',1.81),('10318','2013-03-08','08:45:00',1.32),('10318','2013-03-08','08:50:00',1.23),('10318','2013-03-08','09:05:00',2.37),('10318','2013-03-08','09:10:00',2.77),('10318','2013-03-08','09:15:00',5.36),('10318','2013-03-08','09:20:00',2.66),('10318','2013-03-08','09:25:00',3.03),('10318','2013-03-08','09:30:00',5.64),('10318','2013-03-08','09:35:00',5.72),('10318','2013-03-08','09:40:00',6.49),('10318','2013-03-08','09:45:00',7.11),('10318','2013-03-08','09:50:00',8.67),('10318','2013-03-08','09:55:00',8.38),('10318','2013-03-08','10:00:00',8.91),('10318','2013-03-08','10:05:00',5.19),('10318','2013-03-08','10:10:00',3.6),('10318','2013-03-08','10:15:00',4.35),('10318','2013-03-08','10:20:00',4.57),('10318','2013-03-08','10:25:00',3.55),('10318','2013-03-08','10:30:00',5.48),('10318','2013-03-08','10:35:00',5.03),('10318','2013-03-08','10:40:00',3.09),('10318','2013-03-08','10:45:00',2.26),('10318','2013-03-08','10:50:00',2.13),('10318','2013-03-08','10:55:00',2.51),('10318','2013-03-08','11:00:00',1.73),('10318','2013-03-08','11:05:00',1.38),('10318','2013-03-08','11:10:00',1.34),('10318','2013-03-08','11:20:00',1.03),('10318','2013-03-08','11:35:00',1.76),('10318','2013-03-08','11:40:00',1.99),('10318','2013-03-08','11:45:00',2.17),('10318','2013-03-08','11:50:00',2.21),('10318','2013-03-08','11:55:00',3.54),('10318','2013-03-08','12:00:00',4.16),('10318','2013-03-08','12:05:00',5.1),('10318','2013-03-08','12:10:00',4.76),('10318','2013-03-08','12:15:00',3.45),('10318','2013-03-08','12:20:00',3.68),('10318','2013-03-08','12:25:00',3.17),('10318','2013-03-08','12:30:00',2.63),('10318','2013-03-08','12:35:00',2.57),('10318','2013-03-08','12:40:00',4.94),('10318','2013-03-08','12:45:00',4.32),('10318','2013-03-08','12:50:00',5.27),('10318','2013-03-08','12:55:00',4.77),('10318','2013-03-08','13:00:00',4.7),('10318','2013-03-08','13:05:00',4.11),('10318','2013-03-08','13:10:00',3.08),('10318','2013-03-08','13:15:00',2.63),('10318','2013-03-08','13:20:00',2.52),('10318','2013-03-08','13:25:00',2.88),('10318','2013-03-08','13:30:00',2.99),('10318','2013-03-08','13:35:00',2.73),('10318','2013-03-08','13:40:00',1.95),('10318','2013-03-08','13:45:00',1.7),('10318','2013-03-08','13:50:00',2.18),('10318','2013-03-08','13:55:00',1.71),('10318','2013-03-08','14:00:00',1.72),('10318','2013-03-08','14:05:00',1.43),('10318','2013-03-08','14:10:00',1),('10318','2013-03-08','16:55:00',1.32),('10318','2013-03-08','17:00:00',1.22),('10318','2013-03-08','17:05:00',1.64),('10318','2013-03-08','17:10:00',2.21),('10318','2013-03-08','17:15:00',1.52),('10318','2013-03-08','17:20:00',1.23),('10318','2013-03-07','08:30:00',1.01),('10318','2013-03-07','08:35:00',1.51),('10318','2013-03-07','08:40:00',2.04),('10318','2013-03-07','08:45:00',2.55),('10318','2013-03-07','08:50:00',2.81),('10318','2013-03-07','08:55:00',2.91),('10318','2013-03-07','09:00:00',2.28),('10318','2013-03-07','09:05:00',1.81),('10318','2013-03-07','09:15:00',1.04),('10318','2013-03-07','09:20:00',1.39),('10318','2013-03-07','09:25:00',1.77),('10318','2013-03-07','09:30:00',1.74),('10318','2013-03-07','09:40:00',1.27),('10318','2013-03-07','09:45:00',1.56),('10318','2013-03-07','09:50:00',1.32),('10318','2013-03-07','09:55:00',1.26),('10318','2013-03-07','10:20:00',1.65),('10318','2013-03-07','10:25:00',1.82),('10318','2013-03-07','10:30:00',1.55),('10318','2013-03-07','10:35:00',1.73),('10318','2013-03-07','10:40:00',2.23),('10318','2013-03-07','10:45:00',1.9),('10318','2013-03-07','10:50:00',2.21),('10318','2013-03-07','10:55:00',2.78),('10318','2013-03-07','11:00:00',3.42),('10318','2013-03-07','11:05:00',3.52),('10318','2013-03-07','11:10:00',2.56),('10318','2013-03-07','11:15:00',2.47),('10318','2013-03-07','11:25:00',1),('10318','2013-03-07','11:30:00',2.83),('10318','2013-03-07','11:35:00',3.64),('10318','2013-03-07','11:40:00',6.41),('10318','2013-03-07','11:45:00',9.81),('10318','2013-03-07','11:50:00',5.09),('10318','2013-03-07','11:55:00',5.7),('10318','2013-03-07','12:00:00',4.45),('10318','2013-03-07','12:05:00',2.22),('10318','2013-03-07','12:15:00',1.24),('10318','2013-03-07','12:20:00',2.34),('10318','2013-03-07','12:25:00',4.01),('10318','2013-03-07','12:30:00',5.94),('10318','2013-03-07','12:35:00',2.03),('10318','2013-03-07','12:40:00',1.54),('10318','2013-03-07','12:45:00',2.01),('10318','2013-03-07','12:50:00',2.13),('10318','2013-03-07','12:55:00',2.49),('10318','2013-03-07','13:00:00',3.8),('10318','2013-03-07','13:05:00',4.94),('10318','2013-03-07','13:10:00',4.62),('10318','2013-03-07','13:15:00',4.25),('10318','2013-03-07','13:20:00',3.9),('10318','2013-03-07','13:25:00',4.99),('10318','2013-03-07','13:30:00',4.67),('10318','2013-03-07','13:35:00',3.58),('10318','2013-03-07','13:40:00',2.28),('10318','2013-03-07','13:45:00',1.34),('10318','2013-03-07','13:50:00',1.2),('10318','2013-03-07','13:55:00',1.62),('10318','2013-03-07','14:00:00',1.9),('10318','2013-03-07','14:05:00',2.17),('10318','2013-03-07','14:10:00',2.19),('10318','2013-03-07','14:15:00',2.35),('10318','2013-03-07','14:20:00',1.78),('10318','2013-03-07','14:25:00',1.85),('10318','2013-03-07','14:30:00',1.06),('10318','2013-03-07','14:45:00',1.8),('10318','2013-03-07','14:50:00',1.75),('10318','2013-03-07','15:20:00',1.19),('10318','2013-03-07','15:25:00',1.24),('10318','2013-03-07','15:30:00',1.24),('10318','2013-03-07','15:35:00',2.96),('10318','2013-03-07','15:40:00',2.87),('10318','2013-03-07','15:45:00',2.8),('10318','2013-03-07','15:50:00',2.02),('10318','2013-03-07','15:55:00',1.34),('10318','2013-03-07','16:00:00',1.15),('10318','2013-03-07','16:05:00',1.14),('10318','2013-03-07','16:10:00',1.14),('10318','2013-03-07','16:15:00',1.38),('10318','2013-03-07','16:20:00',1.38),('10318','2013-03-07','16:25:00',1.16),('10318','2013-03-07','16:30:00',1.19),('10318','2013-03-07','16:35:00',1.52),('10318','2013-03-07','16:40:00',2.06),('10318','2013-03-07','16:45:00',1.27),('10318','2013-03-06','08:20:00',1.05),('10318','2013-03-06','08:25:00',1.11),('10318','2013-03-06','08:30:00',1.02),('10318','2013-03-06','09:05:00',1.09),('10318','2013-03-06','09:10:00',1.18),('10318','2013-03-06','09:20:00',1.01),('10318','2013-03-06','09:25:00',1.03),('10318','2013-03-06','09:50:00',1.12),('10318','2013-03-06','12:00:00',1.02),('10318','2013-03-06','15:40:00',1.31),('10318','2013-03-06','15:45:00',1.19),('10318','2013-03-06','15:50:00',1.04),('10318','2013-03-06','15:55:00',1.01),('10318','2013-03-06','16:00:00',1.18),('10318','2013-03-06','16:05:00',1.2),('10318','2013-03-06','16:10:00',1.11),('10318','2013-03-06','16:15:00',1.06),('10318','2013-03-05','07:35:00',1.31),('10318','2013-03-05','07:40:00',1.24),('10318','2013-03-05','07:45:00',1.29),('10318','2013-03-05','07:50:00',1.29),('10318','2013-03-05','07:55:00',1.29),('10318','2013-03-05','08:00:00',1.63),('10318','2013-03-05','08:05:00',2.13),('10318','2013-03-05','08:10:00',2.62),('10318','2013-03-05','08:15:00',3.42),('10318','2013-03-05','08:20:00',2.94),('10318','2013-03-05','08:25:00',4.67),('10318','2013-03-05','08:30:00',5.3),('10318','2013-03-05','08:35:00',5.31),('10318','2013-03-05','08:40:00',4.94),('10318','2013-03-05','08:45:00',4.2),('10318','2013-03-05','08:50:00',4.28),('10318','2013-03-05','08:55:00',4.09),('10318','2013-03-05','09:00:00',3.79),('10318','2013-03-05','09:05:00',3.88),('10318','2013-03-05','09:10:00',3.54),('10318','2013-03-05','09:15:00',3.44),('10318','2013-03-05','09:20:00',3.49),('10318','2013-03-05','09:25:00',3.47),('10318','2013-03-05','09:30:00',3.7),('10318','2013-03-05','09:35:00',3.99),('10318','2013-03-05','09:40:00',4.08),('10318','2013-03-05','09:45:00',4.17),('10318','2013-03-05','09:50:00',3.99),('10318','2013-03-05','09:55:00',4.01),('10318','2013-03-05','10:00:00',4.13),('10318','2013-03-05','10:05:00',4.29),('10318','2013-03-05','10:10:00',4.12),('10318','2013-03-05','10:15:00',4.37),('10318','2013-03-05','10:20:00',4.97),('10318','2013-03-05','10:25:00',4.5),('10318','2013-03-05','10:30:00',4.51),('10318','2013-03-05','10:35:00',5.42),('10318','2013-03-05','10:40:00',5.52),('10318','2013-03-05','10:45:00',5.92),('10318','2013-03-05','10:50:00',6.4),('10318','2013-03-05','10:55:00',6.35),('10318','2013-03-05','11:00:00',6.16),('10318','2013-03-05','11:05:00',6.46),('10318','2013-03-05','11:10:00',6.5),('10318','2013-03-05','11:15:00',6.21),('10318','2013-03-05','11:20:00',6.06),('10318','2013-03-05','11:25:00',5.87),('10318','2013-03-05','11:30:00',6.05),('10318','2013-03-05','11:35:00',6.73),('10318','2013-03-05','11:40:00',7.13),('10318','2013-03-05','11:45:00',6.97),('10318','2013-03-05','11:50:00',7.28),('10318','2013-03-05','11:55:00',7.19),('10318','2013-03-05','12:00:00',7.56),('10318','2013-03-05','12:05:00',7.78),('10318','2013-03-05','12:10:00',7.81),('10318','2013-03-05','12:15:00',5.97),('10318','2013-03-05','12:20:00',7.45),('10318','2013-03-05','12:25:00',7.05),('10318','2013-03-05','12:30:00',5.95),('10318','2013-03-05','12:35:00',6.17),('10318','2013-03-05','12:40:00',5.84),('10318','2013-03-05','12:45:00',5.92),('10318','2013-03-05','12:50:00',5.11),('10318','2013-03-05','12:55:00',4.41),('10318','2013-03-05','13:00:00',3.82),('10318','2013-03-05','13:05:00',3.7),('10318','2013-03-05','13:10:00',3.92),('10318','2013-03-05','13:15:00',4.14),('10318','2013-03-05','13:20:00',3.9),('10318','2013-03-05','13:25:00',3.52),('10318','2013-03-05','13:30:00',3.21),('10318','2013-03-05','13:35:00',3.04),('10318','2013-03-05','13:40:00',2.8),('10318','2013-03-05','13:45:00',2.58),('10318','2013-03-05','13:50:00',2.37),('10318','2013-03-05','13:55:00',2.32),('10318','2013-03-05','14:00:00',2.34),('10318','2013-03-05','14:05:00',2.39),('10318','2013-03-05','14:10:00',2.41),('10318','2013-03-05','14:15:00',2.22),('10318','2013-03-05','14:20:00',2.14),('10318','2013-03-05','14:25:00',2.16),('10318','2013-03-05','14:30:00',2.12),('10318','2013-03-05','14:35:00',2.15),('10318','2013-03-05','14:40:00',2.2),('10318','2013-03-05','14:45:00',2.26),('10318','2013-03-05','14:50:00',2.17),('10318','2013-03-05','14:55:00',1.91),('10318','2013-03-05','15:00:00',1.78),('10318','2013-03-05','15:05:00',1.64),('10318','2013-03-05','15:10:00',1.3),('10318','2013-03-05','15:15:00',1.23),('10318','2013-03-05','15:20:00',1.44),('10318','2013-03-05','15:25:00',1.62),('10318','2013-03-05','15:30:00',1.97),('10318','2013-03-05','15:35:00',2.01),('10318','2013-03-05','15:40:00',2.23),('10318','2013-03-05','15:45:00',2.55),('10318','2013-03-05','15:50:00',2.3),('10318','2013-03-05','15:55:00',2.01),('10318','2013-03-05','16:00:00',1.77),('10318','2013-03-05','16:05:00',1.57),('10318','2013-03-05','16:10:00',1.27),('10318','2013-03-05','16:15:00',1.13),('10318','2013-03-04','07:20:00',1.03),('10318','2013-03-04','07:25:00',1.21),('10318','2013-03-04','07:30:00',1.39),('10318','2013-03-04','07:35:00',1.59),('10318','2013-03-04','07:40:00',1.85),('10318','2013-03-04','07:45:00',2.58),('10318','2013-03-04','07:50:00',3.09),('10318','2013-03-04','07:55:00',3.4),('10318','2013-03-04','08:00:00',3.62),('10318','2013-03-04','08:05:00',3.86),('10318','2013-03-04','08:10:00',4.12),('10318','2013-03-04','08:15:00',4.37),('10318','2013-03-04','08:20:00',4.6),('10318','2013-03-04','08:25:00',4.83),('10318','2013-03-04','08:30:00',4.94),('10318','2013-03-04','08:35:00',5.25),('10318','2013-03-04','08:40:00',5.44),('10318','2013-03-04','08:45:00',5.63),('10318','2013-03-04','08:50:00',5.81),('10318','2013-03-04','08:55:00',6.03),('10318','2013-03-04','09:00:00',6.13),('10318','2013-03-04','09:05:00',6.33),('10318','2013-03-04','09:10:00',6.46),('10318','2013-03-04','09:15:00',6.64),('10318','2013-03-04','09:20:00',6.81),('10318','2013-03-04','09:25:00',6.93),('10318','2013-03-04','09:30:00',7.09),('10318','2013-03-04','09:35:00',7.22),('10318','2013-03-04','09:40:00',7.38),('10318','2013-03-04','09:45:00',7.49),('10318','2013-03-04','09:50:00',7.6),('10318','2013-03-04','09:55:00',7.72),('10318','2013-03-04','10:00:00',7.8),('10318','2013-03-04','10:05:00',7.94),('10318','2013-03-04','10:10:00',8.02),('10318','2013-03-04','10:15:00',8),('10318','2013-03-04','10:20:00',8.17),('10318','2013-03-04','10:25:00',8.22),('10318','2013-03-04','10:30:00',8.24),('10318','2013-03-04','10:35:00',8.34),('10318','2013-03-04','10:40:00',8.39),('10318','2013-03-04','10:45:00',8.43),('10318','2013-03-04','10:50:00',8.46),('10318','2013-03-04','10:55:00',8.49),('10318','2013-03-04','11:00:00',8.59),('10318','2013-03-04','11:05:00',8.7),('10318','2013-03-04','11:10:00',8.67),('10318','2013-03-04','11:15:00',8.6),('10318','2013-03-04','11:20:00',8.69),('10318','2013-03-04','11:25:00',8.68),('10318','2013-03-04','11:30:00',8.57),('10318','2013-03-04','11:35:00',8.51),('10318','2013-03-04','11:40:00',8.58),('10318','2013-03-04','11:45:00',8.6),('10318','2013-03-04','11:50:00',8.71),('10318','2013-03-04','11:55:00',8.66),('10318','2013-03-04','12:00:00',8.4),('10318','2013-03-04','12:05:00',8.43),('10318','2013-03-04','12:10:00',8.45),('10318','2013-03-04','12:15:00',8.52),('10318','2013-03-04','12:20:00',8.52),('10318','2013-03-04','12:25:00',8.57),('10318','2013-03-04','12:30:00',8.54),('10318','2013-03-04','12:35:00',8.5),('10318','2013-03-04','12:40:00',8.36),('10318','2013-03-04','12:45:00',8.32),('10318','2013-03-04','12:50:00',8.2),('10318','2013-03-04','12:55:00',8.23),('10318','2013-03-04','13:00:00',8.22),('10318','2013-03-04','13:05:00',8.15),('10318','2013-03-04','13:10:00',7.89),('10318','2013-03-04','13:15:00',7.67),('10318','2013-03-04','13:20:00',7.73),('10318','2013-03-04','13:25:00',7.77),('10318','2013-03-04','13:30:00',8.19),('10318','2013-03-04','13:35:00',8.06),('10318','2013-03-04','13:40:00',7.59),('10318','2013-03-04','13:45:00',7.13),('10318','2013-03-04','13:50:00',7.25),('10318','2013-03-04','13:55:00',7.11),('10318','2013-03-04','14:00:00',6.89),('10318','2013-03-04','14:05:00',6.8),('10318','2013-03-04','14:10:00',6.68),('10318','2013-03-04','14:15:00',6.5),('10318','2013-03-04','14:20:00',6.3),('10318','2013-03-04','14:25:00',6),('10318','2013-03-04','14:30:00',5.96),('10318','2013-03-04','14:35:00',6.03),('10318','2013-03-04','14:40:00',5.92),('10318','2013-03-04','14:45:00',5.63),('10318','2013-03-04','14:50:00',5.48),('10318','2013-03-04','14:55:00',5.33),('10318','2013-03-04','15:00:00',5.19),('10318','2013-03-04','15:05:00',5.06),('10318','2013-03-04','15:10:00',4.93),('10318','2013-03-04','15:15:00',4.73),('10318','2013-03-04','15:20:00',4.6),('10318','2013-03-04','15:25:00',4.4),('10318','2013-03-04','15:30:00',4.17),('10318','2013-03-04','15:35:00',4.03),('10318','2013-03-04','15:40:00',3.86),('10318','2013-03-04','15:45:00',3.76),('10318','2013-03-04','15:50:00',3.58),('10318','2013-03-04','15:55:00',3.4),('10318','2013-03-04','16:00:00',3.22),('10318','2013-03-04','16:05:00',3.07),('10318','2013-03-04','16:10:00',2.88),('10318','2013-03-04','16:15:00',2.63),('10318','2013-03-04','16:20:00',2.55),('10318','2013-03-04','16:25:00',2.45),('10318','2013-03-04','16:30:00',2.27),('10318','2013-03-04','16:35:00',2.1),('10318','2013-03-04','16:40:00',1.92),('10318','2013-03-04','16:45:00',1.75),('10318','2013-03-04','16:50:00',1.56),('10318','2013-03-04','16:55:00',1.41),('10318','2013-03-04','17:00:00',1.24),('10318','2013-03-04','17:05:00',1.05),('10318','2013-03-03','07:20:00',1.01),('10318','2013-03-03','07:25:00',1.23),('10318','2013-03-03','07:30:00',1.4),('10318','2013-03-03','07:35:00',1.64),('10318','2013-03-03','07:40:00',1.83),('10318','2013-03-03','07:45:00',2.15),('10318','2013-03-03','07:50:00',3.29),('10318','2013-03-03','07:55:00',3.73),('10318','2013-03-03','08:00:00',3.98),('10318','2013-03-03','08:05:00',4.23),('10318','2013-03-03','08:10:00',4.43),('10318','2013-03-03','08:15:00',4.69),('10318','2013-03-03','08:20:00',4.89),('10318','2013-03-03','08:25:00',5.14),('10318','2013-03-03','08:30:00',5.36),('10318','2013-03-03','08:35:00',5.56),('10318','2013-03-03','08:40:00',5.76),('10318','2013-03-03','08:45:00',5.97),('10318','2013-03-03','08:50:00',6.16),('10318','2013-03-03','08:55:00',6.33),('10318','2013-03-03','09:00:00',6.51),('10318','2013-03-03','09:05:00',6.69),('10318','2013-03-03','09:10:00',6.86),('10318','2013-03-03','09:15:00',6.86),('10318','2013-03-03','09:20:00',7.14),('10318','2013-03-03','09:25:00',7.26),('10318','2013-03-03','09:30:00',7.37),('10318','2013-03-03','09:35:00',7.51),('10318','2013-03-03','09:40:00',7.64),('10318','2013-03-03','09:45:00',7.74),('10318','2013-03-03','09:50:00',7.81),('10318','2013-03-03','09:55:00',7.95),('10318','2013-03-03','10:00:00',8.06),('10318','2013-03-03','10:05:00',8.19),('10318','2013-03-03','10:10:00',8.26),('10318','2013-03-03','10:15:00',8.35),('10318','2013-03-03','10:20:00',8.47),('10318','2013-03-03','10:25:00',8.55),('10318','2013-03-03','10:30:00',8.62),('10318','2013-03-03','10:35:00',8.7),('10318','2013-03-03','10:40:00',8.75),('10318','2013-03-03','10:45:00',8.76),('10318','2013-03-03','10:50:00',8.78),('10318','2013-03-03','10:55:00',8.83),('10318','2013-03-03','11:00:00',8.91),('10318','2013-03-03','11:05:00',8.85),('10318','2013-03-03','11:10:00',8.96),('10318','2013-03-03','11:15:00',8.98),('10318','2013-03-03','11:20:00',9),('10318','2013-03-03','11:25:00',9.03),('10318','2013-03-03','11:30:00',9.04),('10318','2013-03-03','11:35:00',8.97),('10318','2013-03-03','11:40:00',8.98),('10318','2013-03-03','11:45:00',9.02),('10318','2013-03-03','11:50:00',8.99),('10318','2013-03-03','11:55:00',8.98),('10318','2013-03-03','12:00:00',8.94),('10318','2013-03-03','12:05:00',8.91),('10318','2013-03-03','12:10:00',8.92),('10318','2013-03-03','12:15:00',8.86),('10318','2013-03-03','12:20:00',8.94),('10318','2013-03-03','12:25:00',8.89),('10318','2013-03-03','12:30:00',8.82),('10318','2013-03-03','12:35:00',8.69),('10318','2013-03-03','12:40:00',8.68),('10318','2013-03-03','12:45:00',8.68),('10318','2013-03-03','12:50:00',8.44),('10318','2013-03-03','12:55:00',8.59),('10318','2013-03-03','13:00:00',8.48),('10318','2013-03-03','13:05:00',8.43),('10318','2013-03-03','13:10:00',8.37),('10318','2013-03-03','13:15:00',8.3),('10318','2013-03-03','13:20:00',8.16),('10318','2013-03-03','13:25:00',8.04),('10318','2013-03-03','13:30:00',7.95),('10318','2013-03-03','13:35:00',7.88),('10318','2013-03-03','13:40:00',7.83),('10318','2013-03-03','13:45:00',7.7),('10318','2013-03-03','13:50:00',7.55),('10318','2013-03-03','13:55:00',7.48),('10318','2013-03-03','14:00:00',7.38),('10318','2013-03-03','14:05:00',7.24),('10318','2013-03-03','14:10:00',7.07),('10318','2013-03-03','14:15:00',6.96),('10318','2013-03-03','14:20:00',6.84),('10318','2013-03-03','14:25:00',6.75),('10318','2013-03-03','14:30:00',6.61),('10318','2013-03-03','14:35:00',6.33),('10318','2013-03-03','14:40:00',6.26),('10318','2013-03-03','14:45:00',5.98),('10318','2013-03-03','14:50:00',5.89),('10318','2013-03-03','14:55:00',5.69),('10318','2013-03-03','15:00:00',5.52),('10318','2013-03-03','15:05:00',5.34),('10318','2013-03-03','15:10:00',5.22),('10318','2013-03-03','15:15:00',5.08),('10318','2013-03-03','15:20:00',4.91),('10318','2013-03-03','15:25:00',4.71),('10318','2013-03-03','15:30:00',4.55),('10318','2013-03-03','15:35:00',4.33),('10318','2013-03-03','15:40:00',4.16),('10318','2013-03-03','15:45:00',3.99),('10318','2013-03-03','15:50:00',3.78),('10318','2013-03-03','15:55:00',3.63),('10318','2013-03-03','16:00:00',3.45),('10318','2013-03-03','16:05:00',3.29),('10318','2013-03-03','16:10:00',3.12),('10318','2013-03-03','16:15:00',2.94),('10318','2013-03-03','16:20:00',2.76),('10318','2013-03-03','16:25:00',2.61),('10318','2013-03-03','16:30:00',2.4),('10318','2013-03-03','16:35:00',2.22),('10318','2013-03-03','16:40:00',2.05),('10318','2013-03-03','16:45:00',1.84),('10318','2013-03-03','16:50:00',1.67),('10318','2013-03-03','16:55:00',1.5),('10318','2013-03-03','17:00:00',1.33),('10318','2013-03-03','17:05:00',1.17),('10318','2013-03-03','17:10:00',1.01),('10318','2014-03-24','07:05:00',1.1),('10318','2014-03-24','07:30:00',1.85),('10318','2014-03-24','07:35:00',1.77),('10318','2014-03-24','07:40:00',1.93),('10318','2014-03-24','07:45:00',3.46),('10318','2014-03-24','07:50:00',1.97),('10318','2014-03-24','07:55:00',1.64),('10318','2014-03-24','08:30:00',1.69),('10318','2014-03-24','08:35:00',2.29),('10318','2014-03-24','08:40:00',1.92),('10318','2014-03-24','08:45:00',1.23),('10318','2014-03-24','08:50:00',2.38),('10318','2014-03-24','08:55:00',5.38),('10318','2014-03-24','09:00:00',3.14),('10318','2014-03-24','09:05:00',1.58),('10318','2014-03-24','09:10:00',1.3),('10318','2014-03-24','09:15:00',1.76),('10318','2014-03-24','09:20:00',2.66),('10318','2014-03-24','09:25:00',4.02),('10318','2014-03-24','09:30:00',3.09),('10318','2014-03-24','09:35:00',2.44),('10318','2014-03-24','09:40:00',4.41),('10318','2014-03-24','09:45:00',2.74),('10318','2014-03-24','09:50:00',2.44),('10318','2014-03-24','09:55:00',1.81),('10318','2014-03-24','10:00:00',7.33),('10318','2014-03-24','10:05:00',7.86),('10318','2014-03-24','10:10:00',5.7),('10318','2014-03-24','10:15:00',2.38),('10318','2014-03-24','10:20:00',2.06),('10318','2014-03-24','10:25:00',1.87),('10318','2014-03-24','10:30:00',2.09),('10318','2014-03-24','10:35:00',3.32),('10318','2014-03-24','10:40:00',2.37),('10318','2014-03-24','10:45:00',4.6),('10318','2014-03-24','10:50:00',10.6),('10318','2014-03-24','10:55:00',7.97),('10318','2014-03-24','11:00:00',8.51),('10318','2014-03-24','11:05:00',4.9),('10318','2014-03-24','11:10:00',5.45),('10318','2014-03-24','11:15:00',8.19),('10318','2014-03-24','11:20:00',7.99),('10318','2014-03-24','11:25:00',6.53),('10318','2014-03-24','11:30:00',6.87),('10318','2014-03-24','11:35:00',3.26),('10318','2014-03-24','11:40:00',1.64),('10318','2014-03-24','11:45:00',1.39),('10318','2014-03-24','11:50:00',1.4),('10318','2014-03-24','11:55:00',1.38),('10318','2014-03-24','12:00:00',1.15),('10318','2014-03-24','12:15:00',1.07),('10318','2014-03-24','12:20:00',1.31),('10318','2014-03-24','12:25:00',1.78),('10318','2014-03-24','12:30:00',3.8),('10318','2014-03-24','12:35:00',4.75),('10318','2014-03-24','12:40:00',4.75),('10318','2014-03-24','12:45:00',3.64),('10318','2014-03-24','12:50:00',3.34),('10318','2014-03-24','12:55:00',3.24),('10318','2014-03-24','13:00:00',3.2),('10318','2014-03-24','13:05:00',3.06),('10318','2014-03-24','13:10:00',2.47),('10318','2014-03-24','13:15:00',2.85),('10318','2014-03-24','13:20:00',2.96),('10318','2014-03-24','13:25:00',3.26),('10318','2014-03-24','13:30:00',3.08),('10318','2014-03-24','13:35:00',3.06),('10318','2014-03-24','13:40:00',3.21),('10318','2014-03-24','13:45:00',3.17),('10318','2014-03-24','13:50:00',2.98),('10318','2014-03-24','13:55:00',2.78),('10318','2014-03-24','14:00:00',2.41),('10318','2014-03-24','14:05:00',2.59),('10318','2014-03-24','14:10:00',3.01),('10318','2014-03-24','14:15:00',3.99),('10318','2014-03-24','14:20:00',4.91),('10318','2014-03-24','14:25:00',4.52),('10318','2014-03-24','14:30:00',4.25),('10318','2014-03-24','14:35:00',5.64),('10318','2014-03-24','14:40:00',6.7),('10318','2014-03-24','14:45:00',7.9),('10318','2014-03-24','14:50:00',7.5),('10318','2014-03-24','14:55:00',6.08),('10318','2014-03-24','15:00:00',5.1),('10318','2014-03-24','15:05:00',5.05),('10318','2014-03-24','15:10:00',4.24),('10318','2014-03-24','15:15:00',3.95),('10318','2014-03-24','15:20:00',3.81),('10318','2014-03-24','15:25:00',3.44),('10318','2014-03-24','15:30:00',3.84),('10318','2014-03-24','15:35:00',3.45),('10318','2014-03-24','15:40:00',2.68),('10318','2014-03-24','15:45:00',2.93),('10318','2014-03-24','15:50:00',2.83),('10318','2014-03-24','15:55:00',4.84),('10318','2014-03-24','16:00:00',3.18),('10318','2014-03-24','16:10:00',2.1),('10318','2013-03-02','08:05:00',1.03),('10318','2013-03-02','08:35:00',1.18),('10318','2013-03-02','08:40:00',1.23),('10318','2013-03-02','08:45:00',1.29),('10318','2013-03-02','08:50:00',1.52),('10318','2013-03-02','08:55:00',1.59),('10318','2013-03-02','09:00:00',1.71),('10318','2013-03-02','09:05:00',1.61),('10318','2013-03-02','09:10:00',1.19),('10318','2013-03-02','09:20:00',1.01),('10318','2013-03-02','09:25:00',1.11),('10318','2013-03-02','09:30:00',1.03),('10318','2013-03-02','09:35:00',1.04),('10318','2013-03-02','09:40:00',1.34),('10318','2013-03-02','09:45:00',1.75),('10318','2013-03-02','09:50:00',1.93),('10318','2013-03-02','09:55:00',1.77),('10318','2013-03-02','10:00:00',1.43),('10318','2013-03-02','10:05:00',1.46),('10318','2013-03-02','10:10:00',1.4),('10318','2013-03-02','10:15:00',1.45),('10318','2013-03-02','10:20:00',1.62),('10318','2013-03-02','10:25:00',1.82),('10318','2013-03-02','10:30:00',2.02),('10318','2013-03-02','10:35:00',2.14),('10318','2013-03-02','10:40:00',2.22),('10318','2013-03-02','10:45:00',2.27),('10318','2013-03-02','10:50:00',2.5),('10318','2013-03-02','10:55:00',2.7),('10318','2013-03-02','11:00:00',2.93),('10318','2013-03-02','11:05:00',3.33),('10318','2013-03-02','11:10:00',3.07),('10318','2013-03-02','11:15:00',3.65),('10318','2013-03-02','11:20:00',3.08),('10318','2013-03-02','11:25:00',2.81),('10318','2013-03-02','11:30:00',2.85),('10318','2013-03-02','11:35:00',2.89),('10318','2013-03-02','11:40:00',3.51),('10318','2013-03-02','11:45:00',3.27),('10318','2013-03-02','11:50:00',3.35),('10318','2013-03-02','11:55:00',3.27),('10318','2013-03-02','12:00:00',3.14),('10318','2013-03-02','12:05:00',3.59),('10318','2013-03-02','12:10:00',3.61),('10318','2013-03-02','12:15:00',4.05),('10318','2013-03-02','12:20:00',4.38),('10318','2013-03-02','12:25:00',4.35),('10318','2013-03-02','12:30:00',4.82),('10318','2013-03-02','12:35:00',4.76),('10318','2013-03-02','12:40:00',5.23),('10318','2013-03-02','12:45:00',4.51),('10318','2013-03-02','12:50:00',4.09),('10318','2013-03-02','12:55:00',3.41),('10318','2013-03-02','13:00:00',3.03),('10318','2013-03-02','13:05:00',2.54),('10318','2013-03-02','13:10:00',2.11),('10318','2013-03-02','13:15:00',2.02),('10318','2013-03-02','13:20:00',2.07),('10318','2013-03-02','13:25:00',2.06),('10318','2013-03-02','13:30:00',2.53),('10318','2013-03-02','13:35:00',2.65),('10318','2013-03-02','13:40:00',2.59),('10318','2013-03-02','13:45:00',2.71),('10318','2013-03-02','13:50:00',2.6),('10318','2013-03-02','13:55:00',2.88),('10318','2013-03-02','14:00:00',3.01),('10318','2013-03-02','14:05:00',2.87),('10318','2013-03-02','14:10:00',2.49),('10318','2013-03-02','14:15:00',2.17),('10318','2013-03-02','14:20:00',1.93),('10318','2013-03-02','14:25:00',1.63),('10318','2013-03-02','14:30:00',1.35),('10318','2013-03-02','14:35:00',1.08),('10318','2013-03-02','14:40:00',1.03),('10318','2013-03-02','14:45:00',1.13),('10318','2013-03-02','14:50:00',1.52),('10318','2013-03-02','14:55:00',1.97),('10318','2013-03-02','15:00:00',1.8),('10318','2013-03-02','15:05:00',1.91),('10318','2013-03-02','15:10:00',2.02),('10318','2013-03-02','15:15:00',2.02),('10318','2013-03-02','15:20:00',1.92),('10318','2013-03-02','15:25:00',1.79),('10318','2013-03-02','15:30:00',1.9),('10318','2013-03-02','15:35:00',1.78),('10318','2013-03-02','15:40:00',1.51),('10318','2013-03-02','15:45:00',1.59),('10318','2013-03-02','15:50:00',1.51),('10318','2013-03-02','15:55:00',1.52),('10318','2013-03-02','16:00:00',1.43),('10318','2013-03-02','16:05:00',1.12),('10318','2013-03-02','16:10:00',1.12),('10318','2013-03-02','16:15:00',1.18),('10318','2013-03-02','16:20:00',1.14),('10318','2013-03-02','16:25:00',1.16),('10318','2013-03-02','16:30:00',1.24),('10318','2013-03-02','16:35:00',1.13),('10318','2013-03-01','07:40:00',1.19),('10318','2013-03-01','07:45:00',1.46),('10318','2013-03-01','07:50:00',1.91),('10318','2013-03-01','07:55:00',2.64),('10318','2013-03-01','08:00:00',2.85),('10318','2013-03-01','08:05:00',2.73),('10318','2013-03-01','08:10:00',2.81),('10318','2013-03-01','08:15:00',2.97),('10318','2013-03-01','08:20:00',3.03),('10318','2013-03-01','08:25:00',3.17),('10318','2013-03-01','08:30:00',3.34),('10318','2013-03-01','08:35:00',3.54),('10318','2013-03-01','08:40:00',3.83),('10318','2013-03-01','08:45:00',4.22),('10318','2013-03-01','08:50:00',4.42),('10318','2013-03-01','08:55:00',4.74),('10318','2013-03-01','09:00:00',5.15),('10318','2013-03-01','09:05:00',5.55),('10318','2013-03-01','09:10:00',5.3),('10318','2013-03-01','09:15:00',5.31),('10318','2013-03-01','09:20:00',5.52),('10318','2013-03-01','09:25:00',6.03),('10318','2013-03-01','09:30:00',6.2),('10318','2013-03-01','09:35:00',6.15),('10318','2013-03-01','09:40:00',6.23),('10318','2013-03-01','09:45:00',6.56),('10318','2013-03-01','09:50:00',6.66),('10318','2013-03-01','09:55:00',6.44),('10318','2013-03-01','10:00:00',6.19),('10318','2013-03-01','10:05:00',5.61),('10318','2013-03-01','10:10:00',5.28),('10318','2013-03-01','10:15:00',5.14),('10318','2013-03-01','10:20:00',4.91),('10318','2013-03-01','10:25:00',5.12),('10318','2013-03-01','10:30:00',6.06),('10318','2013-03-01','10:35:00',6.45),('10318','2013-03-01','10:40:00',5.65),('10318','2013-03-01','10:45:00',5.32),('10318','2013-03-01','10:50:00',5.1),('10318','2013-03-01','10:55:00',4.71),('10318','2013-03-01','11:00:00',4.14),('10318','2013-03-01','11:05:00',3.73),('10318','2013-03-01','11:10:00',3.57),('10318','2013-03-01','11:15:00',3.95),('10318','2013-03-01','11:20:00',4.11),('10318','2013-03-01','11:25:00',4.07),('10318','2013-03-01','11:30:00',4.09),('10318','2013-03-01','11:35:00',4.07),('10318','2013-03-01','11:40:00',3.84),('10318','2013-03-01','11:45:00',3.71),('10318','2013-03-01','11:50:00',3.65),('10318','2013-03-01','11:55:00',3.38),('10318','2013-03-01','12:00:00',3.22),('10318','2013-03-01','12:05:00',3),('10318','2013-03-01','12:10:00',2.79),('10318','2013-03-01','12:15:00',2.61),('10318','2013-03-01','12:20:00',2.51),('10318','2013-03-01','12:25:00',2.55),('10318','2013-03-01','12:30:00',2.63),('10318','2013-03-01','12:35:00',2.59),('10318','2013-03-01','12:40:00',2.52),('10318','2013-03-01','12:45:00',2.56),('10318','2013-03-01','12:50:00',2.67),('10318','2013-03-01','12:55:00',2.78),('10318','2013-03-01','13:00:00',2.92),('10318','2013-03-01','13:05:00',2.96),('10318','2013-03-01','13:10:00',3.09),('10318','2013-03-01','13:15:00',3.3),('10318','2013-03-01','13:20:00',3.66),('10318','2013-03-01','13:25:00',3.84),('10318','2013-03-01','13:30:00',3.61),('10318','2013-03-01','13:35:00',3.38),('10318','2013-03-01','13:40:00',3.25),('10318','2013-03-01','13:45:00',3.23),('10318','2013-03-01','13:50:00',3.19),('10318','2013-03-01','13:55:00',3.08),('10318','2013-03-01','14:00:00',2.97),('10318','2013-03-01','14:05:00',2.82),('10318','2013-03-01','14:10:00',2.61),('10318','2013-03-01','14:15:00',2.51),('10318','2013-03-01','14:20:00',2.43),('10318','2013-03-01','14:25:00',2.46),('10318','2013-03-01','14:30:00',2.5),('10318','2013-03-01','14:35:00',2.46),('10318','2013-03-01','14:40:00',2.3),('10318','2013-03-01','14:45:00',2.19),('10318','2013-03-01','14:50:00',2.11),('10318','2013-03-01','14:55:00',2.13),('10318','2013-03-01','15:00:00',2.12),('10318','2013-03-01','15:05:00',2.05),('10318','2013-03-01','15:10:00',1.88),('10318','2013-03-01','15:15:00',1.7),('10318','2013-03-01','15:20:00',1.64),('10318','2013-03-01','15:25:00',1.49),('10318','2013-03-01','15:30:00',1.35),('10318','2013-03-01','15:35:00',1.38),('10318','2013-03-01','15:40:00',1.44),('10318','2013-03-01','15:45:00',1.4),('10318','2013-03-01','15:50:00',1.27),('10318','2013-03-01','15:55:00',1.24),('10318','2013-03-01','16:00:00',1.26),('10318','2013-03-01','16:05:00',1.25),('10318','2013-03-01','16:10:00',1.2),('10318','2013-03-01','16:15:00',1.09),('10318','2013-02-28','07:30:00',1.1),('10318','2013-02-28','07:35:00',1.3),('10318','2013-02-28','07:40:00',1.53),('10318','2013-02-28','07:45:00',1.71),('10318','2013-02-28','07:50:00',2.05),('10318','2013-02-28','07:55:00',2.78),('10318','2013-02-28','08:00:00',3.12),('10318','2013-02-28','08:05:00',3.33),('10318','2013-02-28','08:10:00',3.59),('10318','2013-02-28','08:15:00',3.83),('10318','2013-02-28','08:20:00',4.05),('10318','2013-02-28','08:25:00',4.28),('10318','2013-02-28','08:30:00',4.51),('10318','2013-02-28','08:35:00',4.73),('10318','2013-02-28','08:40:00',4.95),('10318','2013-02-28','08:45:00',5.19),('10318','2013-02-28','08:50:00',5.38),('10318','2013-02-28','08:55:00',5.56),('10318','2013-02-28','09:00:00',5.72),('10318','2013-02-28','09:05:00',5.88),('10318','2013-02-28','09:10:00',6),('10318','2013-02-28','09:15:00',6.24),('10318','2013-02-28','09:20:00',6.31),('10318','2013-02-28','09:25:00',6.42),('10318','2013-02-28','09:30:00',6.59),('10318','2013-02-28','09:35:00',6.62),('10318','2013-02-28','09:40:00',6.94),('10318','2013-02-28','09:45:00',7.12),('10318','2013-02-28','09:50:00',6.7),('10318','2013-02-28','09:55:00',7.24),('10318','2013-02-28','10:00:00',7.38),('10318','2013-02-28','10:05:00',7.42),('10318','2013-02-28','10:10:00',7.54),('10318','2013-02-28','10:15:00',7.66),('10318','2013-02-28','10:20:00',7.81),('10318','2013-02-28','10:25:00',7.84),('10318','2013-02-28','10:30:00',7.78),('10318','2013-02-28','10:35:00',7.96),('10318','2013-02-28','10:40:00',8.05),('10318','2013-02-28','10:45:00',8.09),('10318','2013-02-28','10:50:00',8.04),('10318','2013-02-28','10:55:00',7.96),('10318','2013-02-28','11:00:00',8.14),('10318','2013-02-28','11:05:00',8.26),('10318','2013-02-28','11:10:00',8.19),('10318','2013-02-28','11:15:00',8.14),('10318','2013-02-28','11:20:00',8.13),('10318','2013-02-28','11:25:00',8.58),('10318','2013-02-28','11:30:00',8.51),('10318','2013-02-28','11:35:00',8.31),('10318','2013-02-28','11:40:00',8.35),('10318','2013-02-28','11:45:00',8.45),('10318','2013-02-28','11:50:00',8.46),('10318','2013-02-28','11:55:00',8.51),('10318','2013-02-28','12:00:00',8.37),('10318','2013-02-28','12:05:00',8.41),('10318','2013-02-28','12:10:00',8.35),('10318','2013-02-28','12:15:00',8.49),('10318','2013-02-28','12:20:00',8.58),('10318','2013-02-28','12:25:00',8.3),('10318','2013-02-28','12:30:00',8.29),('10318','2013-02-28','12:35:00',8.23),('10318','2013-02-28','12:40:00',8.07),('10318','2013-02-28','12:45:00',8.23),('10318','2013-02-28','12:50:00',8.19),('10318','2013-02-28','12:55:00',8.17),('10318','2013-02-28','13:00:00',7.88),('10318','2013-02-28','13:05:00',8.04),('10318','2013-02-28','13:10:00',7.75),('10318','2013-02-28','13:15:00',7.63),('10318','2013-02-28','13:20:00',7.88),('10318','2013-02-28','13:25:00',7.8),('10318','2013-02-28','13:30:00',7.72),('10318','2013-02-28','13:35:00',7.63),('10318','2013-02-28','13:40:00',7.57),('10318','2013-02-28','13:45:00',7.29),('10318','2013-02-28','13:50:00',7),('10318','2013-02-28','13:55:00',7),('10318','2013-02-28','14:00:00',7.04),('10318','2013-02-28','14:05:00',6.94),('10318','2013-02-28','14:10:00',6.83),('10318','2013-02-28','14:15:00',6.72),('10318','2013-02-28','14:20:00',6.42),('10318','2013-02-28','14:25:00',6.19),('10318','2013-02-28','14:30:00',6.12),('10318','2013-02-28','14:35:00',5.63),('10318','2013-02-28','14:40:00',5.81),('10318','2013-02-28','14:45:00',5.76),('10318','2013-02-28','14:50:00',5.63),('10318','2013-02-28','14:55:00',5.4),('10318','2013-02-28','15:00:00',5.43),('10318','2013-02-28','15:05:00',5.2),('10318','2013-02-28','15:10:00',4.86),('10318','2013-02-28','15:15:00',4.59),('10318','2013-02-28','15:20:00',4.26),('10318','2013-02-28','15:25:00',4.11),('10318','2013-02-28','15:30:00',3.88),('10318','2013-02-28','15:35:00',3.81),('10318','2013-02-28','15:40:00',3.65),('10318','2013-02-28','15:45:00',3.46),('10318','2013-02-28','15:50:00',3.26),('10318','2013-02-28','15:55:00',3.16),('10318','2013-02-28','16:00:00',2.98),('10318','2013-02-28','16:05:00',2.82),('10318','2013-02-28','16:10:00',2.65),('10318','2013-02-28','16:15:00',2.5),('10318','2013-02-28','16:20:00',2.36),('10318','2013-02-28','16:25:00',2.19),('10318','2013-02-28','16:30:00',2.03),('10318','2013-02-28','16:35:00',1.88),('10318','2013-02-28','16:40:00',1.72),('10318','2013-02-28','16:45:00',1.55),('10318','2013-02-28','16:50:00',1.4),('10318','2013-02-28','16:55:00',1.23),('10318','2013-02-28','17:00:00',1.08),('10318','2013-02-27','07:30:00',1.03),('10318','2013-02-27','07:35:00',1.21),('10318','2013-02-27','07:40:00',1.42),('10318','2013-02-27','07:45:00',1.64),('10318','2013-02-27','07:50:00',1.83),('10318','2013-02-27','07:55:00',2.49),('10318','2013-02-27','08:00:00',3.06),('10318','2013-02-27','08:05:00',3.28),('10318','2013-02-27','08:10:00',3.47),('10318','2013-02-27','08:15:00',3.71),('10318','2013-02-27','08:20:00',3.9),('10318','2013-02-27','08:25:00',4.11),('10318','2013-02-27','08:30:00',4.37),('10318','2013-02-27','08:35:00',4.58),('10318','2013-02-27','08:40:00',4.8),('10318','2013-02-27','08:45:00',4.98),('10318','2013-02-27','08:50:00',5.15),('10318','2013-02-27','08:55:00',5.41),('10318','2013-02-27','09:00:00',5.6),('10318','2013-02-27','09:05:00',5.79),('10318','2013-02-27','09:10:00',5.93),('10318','2013-02-27','09:15:00',6.11),('10318','2013-02-27','09:20:00',6.26),('10318','2013-02-27','09:25:00',6.38),('10318','2013-02-27','09:30:00',6.52),('10318','2013-02-27','09:35:00',6.65),('10318','2013-02-27','09:40:00',6.66),('10318','2013-02-27','09:45:00',6.94),('10318','2013-02-27','09:50:00',7.05),('10318','2013-02-27','09:55:00',7.17),('10318','2013-02-27','10:00:00',7.3),('10318','2013-02-27','10:05:00',7.45),('10318','2013-02-27','10:10:00',7.5),('10318','2013-02-27','10:15:00',7.63),('10318','2013-02-27','10:20:00',7.72),('10318','2013-02-27','10:25:00',7.88),('10318','2013-02-27','10:30:00',7.95),('10318','2013-02-27','10:35:00',8.06),('10318','2013-02-27','10:40:00',8.04),('10318','2013-02-27','10:45:00',8.19),('10318','2013-02-27','10:50:00',8.28),('10318','2013-02-27','10:55:00',8.15),('10318','2013-02-27','11:00:00',8.35),('10318','2013-02-27','11:05:00',8.4),('10318','2013-02-27','11:10:00',8.41),('10318','2013-02-27','11:15:00',8.59),('10318','2013-02-27','11:20:00',8.51),('10318','2013-02-27','11:25:00',8.45),('10318','2013-02-27','11:30:00',8.69),('10318','2013-02-27','11:35:00',8.7),('10318','2013-02-27','11:40:00',8.75),('10318','2013-02-27','11:45:00',8.65),('10318','2013-02-27','11:50:00',8.07),('10318','2013-02-27','11:55:00',8.52),('10318','2013-02-27','12:00:00',8.85),('10318','2013-02-27','12:05:00',8.87),('10318','2013-02-27','12:10:00',8.35),('10318','2013-02-27','12:15:00',4.7),('10318','2013-02-27','12:20:00',8.88),('10318','2013-02-27','12:25:00',8.82),('10318','2013-02-27','12:30:00',8.85),('10318','2013-02-27','12:35:00',8.69),('10318','2013-02-27','12:40:00',8.43),('10318','2013-02-27','12:45:00',8.29),('10318','2013-02-27','12:50:00',8.45),('10318','2013-02-27','12:55:00',8.36),('10318','2013-02-27','13:00:00',7.9),('10318','2013-02-27','13:05:00',8.01),('10318','2013-02-27','13:10:00',7.72),('10318','2013-02-27','13:15:00',7.9),('10318','2013-02-27','13:20:00',8.11),('10318','2013-02-27','13:25:00',8.02),('10318','2013-02-27','13:30:00',8.03),('10318','2013-02-27','13:35:00',7.74),('10318','2013-02-27','13:40:00',7.49),('10318','2013-02-27','13:45:00',7.12),('10318','2013-02-27','13:50:00',7.52),('10318','2013-02-27','13:55:00',7.41),('10318','2013-02-27','14:00:00',7.13),('10318','2013-02-27','14:05:00',6.44),('10318','2013-02-27','14:10:00',6.08),('10318','2013-02-27','14:15:00',5.13),('10318','2013-02-27','14:20:00',6.52),('10318','2013-02-27','14:25:00',6.17),('10318','2013-02-27','14:30:00',3.12),('10318','2013-02-27','14:35:00',2.86),('10318','2013-02-27','14:40:00',6.16),('10318','2013-02-27','14:45:00',6.2),('10318','2013-02-27','14:50:00',6.13),('10318','2013-02-27','14:55:00',5.64),('10318','2013-02-27','15:00:00',5.59),('10318','2013-02-27','15:05:00',5.39),('10318','2013-02-27','15:10:00',5.23),('10318','2013-02-27','15:15:00',4.92),('10318','2013-02-27','15:20:00',4.65),('10318','2013-02-27','15:25:00',4.43),('10318','2013-02-27','15:30:00',4.22),('10318','2013-02-27','15:35:00',4.02),('10318','2013-02-27','15:40:00',3.79),('10318','2013-02-27','15:45:00',3.62),('10318','2013-02-27','15:50:00',3.48),('10318','2013-02-27','15:55:00',3.32),('10318','2013-02-27','16:00:00',3.14),('10318','2013-02-27','16:05:00',2.97),('10318','2013-02-27','16:10:00',2.82),('10318','2013-02-27','16:15:00',2.66),('10318','2013-02-27','16:20:00',2.52),('10318','2013-02-27','16:25:00',2.31),('10318','2013-02-27','16:30:00',2.14),('10318','2013-02-27','16:35:00',1.97),('10318','2013-02-27','16:40:00',1.79),('10318','2013-02-27','16:45:00',1.62),('10318','2013-02-27','16:50:00',1.45),('10318','2013-02-27','16:55:00',1.3),('10318','2013-02-27','17:00:00',1.12),('10318','2013-02-26','08:40:00',1.02),('10318','2013-02-26','08:45:00',1.15),('10318','2013-02-26','08:50:00',1.3),('10318','2013-02-26','08:55:00',1.55),('10318','2013-02-26','09:00:00',1.7),('10318','2013-02-26','09:05:00',1.81),('10318','2013-02-26','09:10:00',2.01),('10318','2013-02-26','09:15:00',2.24),('10318','2013-02-26','09:20:00',2.38),('10318','2013-02-26','09:25:00',2.58),('10318','2013-02-26','09:30:00',2.93),('10318','2013-02-26','09:35:00',3.54),('10318','2013-02-26','09:40:00',4.48),('10318','2013-02-26','09:45:00',5.21),('10318','2013-02-26','09:50:00',5.71),('10318','2013-02-26','09:55:00',6.08),('10318','2013-02-26','10:00:00',5.99),('10318','2013-02-26','10:05:00',5.8),('10318','2013-02-26','10:10:00',5.77),('10318','2013-02-26','10:15:00',6.83),('10318','2013-02-26','10:20:00',7.71),('10318','2013-02-26','10:25:00',8.5),('10318','2013-02-26','10:30:00',6.14),('10318','2013-02-26','10:35:00',5.96),('10318','2013-02-26','10:40:00',4.94),('10318','2013-02-26','10:45:00',4.75),('10318','2013-02-26','10:50:00',4.95),('10318','2013-02-26','10:55:00',5.95),('10318','2013-02-26','11:00:00',6.4),('10318','2013-02-26','11:05:00',6.74),('10318','2013-02-26','11:10:00',7.42),('10318','2013-02-26','11:15:00',5.13),('10318','2013-02-26','11:20:00',5.59),('10318','2013-02-26','11:25:00',5.22),('10318','2013-02-26','11:30:00',4.27),('10318','2013-02-26','11:35:00',4.12),('10318','2013-02-26','11:40:00',4),('10318','2013-02-26','11:45:00',3.98),('10318','2013-02-26','11:50:00',4.19),('10318','2013-02-26','11:55:00',3.82),('10318','2013-02-26','12:00:00',5.04),('10318','2013-02-26','12:05:00',3.95),('10318','2013-02-26','12:10:00',3.82),('10318','2013-02-26','12:15:00',3.57),('10318','2013-02-26','12:20:00',3.5),('10318','2013-02-26','12:25:00',3.27),('10318','2013-02-26','12:30:00',3.17),('10318','2013-02-26','12:35:00',2.78),('10318','2013-02-26','12:40:00',2.63),('10318','2013-02-26','12:45:00',2.42),('10318','2013-02-26','12:50:00',2.23),('10318','2013-02-26','12:55:00',2.33),('10318','2013-02-26','13:00:00',2.53),('10318','2013-02-26','13:05:00',2.36),('10318','2013-02-26','13:10:00',2.25),('10318','2013-02-26','13:15:00',2.33),('10318','2013-02-26','13:20:00',2.13),('10318','2013-02-26','13:25:00',2.09),('10318','2013-02-26','13:30:00',2.11),('10318','2013-02-26','13:35:00',2.1),('10318','2013-02-26','13:40:00',2.11),('10318','2013-02-26','13:45:00',2.14),('10318','2013-02-26','13:50:00',1.91),('10318','2013-02-26','13:55:00',1.72),('10318','2013-02-26','14:00:00',1.57),('10318','2013-02-26','14:05:00',1.54),('10318','2013-02-26','14:10:00',1.42),('10318','2013-02-26','14:15:00',1.21),('10318','2013-02-25','08:35:00',1.66),('10318','2013-02-25','08:40:00',2.57),('10318','2013-02-25','08:45:00',2.71),('10318','2013-02-25','08:50:00',2.42),('10318','2013-02-25','08:55:00',2.17),('10318','2013-02-25','09:00:00',1.56),('10318','2013-02-25','09:05:00',1.61),('10318','2013-02-25','09:10:00',2.75),('10318','2013-02-25','09:15:00',2.1),('10318','2013-02-25','09:20:00',2.24),('10318','2013-02-25','09:25:00',3.8),('10318','2013-02-25','09:30:00',4.43),('10318','2013-02-25','09:35:00',2.91),('10318','2013-02-25','09:40:00',2.07),('10318','2013-02-25','09:45:00',1.93),('10318','2013-02-25','09:50:00',1.38),('10318','2013-02-25','10:20:00',1.42),('10318','2013-02-25','10:25:00',1.54),('10318','2013-02-25','10:30:00',1.29),('10318','2013-02-25','10:35:00',1.48),('10318','2013-02-25','10:40:00',2.32),('10318','2013-02-25','10:45:00',4.1),('10318','2013-02-25','10:50:00',8.6),('10318','2013-02-25','10:55:00',10.53),('10318','2013-02-25','11:00:00',9.04),('10318','2013-02-25','11:05:00',7.32),('10318','2013-02-25','11:10:00',8.35),('10318','2013-02-25','11:15:00',5.73),('10318','2013-02-25','11:20:00',8.65),('10318','2013-02-25','11:25:00',8.67),('10318','2013-02-25','11:30:00',5.87),('10318','2013-02-25','11:35:00',6.99),('10318','2013-02-25','11:40:00',3.76),('10318','2013-02-25','11:45:00',5.21),('10318','2013-02-25','11:50:00',4.89),('10318','2013-02-25','11:55:00',3.84),('10318','2013-02-25','12:00:00',3.7),('10318','2013-02-25','12:05:00',6.68),('10318','2013-02-25','12:10:00',6.17),('10318','2013-02-25','12:15:00',6.44),('10318','2013-02-25','12:20:00',6.6),('10318','2013-02-25','12:25:00',6.15),('10318','2013-02-25','12:30:00',7.26),('10318','2013-02-25','12:35:00',9.23),('10318','2013-02-25','12:40:00',9.8),('10318','2013-02-25','12:45:00',8.07),('10318','2013-02-25','12:50:00',6.69),('10318','2013-02-25','12:55:00',9.15),('10318','2013-02-25','13:00:00',7.89),('10318','2013-02-25','13:05:00',6.51),('10318','2013-02-25','13:10:00',4.59),('10318','2013-02-25','13:15:00',3.29),('10318','2013-02-25','13:20:00',2.99),('10318','2013-02-25','13:25:00',2.65),('10318','2013-02-25','13:30:00',2.62),('10318','2013-02-25','13:35:00',2.34),('10318','2013-02-25','13:40:00',2.73),('10318','2013-02-25','13:45:00',3.56),('10318','2013-02-25','13:50:00',2.59),('10318','2013-02-25','13:55:00',2.23),('10318','2013-02-25','14:00:00',1.85),('10318','2013-02-25','14:05:00',1.33),('10318','2013-02-25','14:10:00',1.01),('10318','2013-02-25','14:20:00',1.04),('10318','2013-02-25','14:30:00',1.09),('10318','2013-02-25','14:35:00',1.22),('10318','2013-02-25','14:40:00',1.18),('10318','2013-02-25','14:45:00',1.43),('10318','2013-02-25','14:50:00',1.65),('10318','2013-02-25','14:55:00',1.65),('10318','2013-02-25','15:00:00',1.46),('10318','2013-02-25','15:05:00',1.56),('10318','2013-02-25','15:10:00',1.63),('10318','2013-02-25','15:15:00',1.57),('10318','2013-02-25','15:20:00',1.5),('10318','2013-02-25','15:25:00',1.37),('10318','2013-02-25','15:30:00',1.07),('10318','2013-02-25','15:55:00',1.16),('10318','2013-02-25','16:00:00',1.32),('10318','2013-02-25','16:05:00',1.35),('10318','2013-02-25','16:10:00',1.25),('10318','2013-02-25','16:15:00',1),('10318','2013-02-25','16:30:00',2.06),('10318','2013-02-25','16:35:00',1.89),('10318','2013-02-25','16:40:00',1.4),('10318','2013-02-25','16:45:00',1.24),('10318','2013-02-25','16:50:00',1.38),('10318','2013-02-25','16:55:00',1.7),('10318','2013-02-25','17:00:00',1.52),('10318','2013-02-25','17:05:00',1.26),('10318','2013-02-25','17:10:00',1.01),('10318','2013-02-24','08:00:00',1.49),('10318','2013-02-24','08:05:00',1.21),('10318','2013-02-24','08:15:00',1.41),('10318','2013-02-24','08:20:00',1.65),('10318','2013-02-24','08:25:00',1.55),('10318','2013-02-24','08:30:00',1.09),('10318','2013-02-24','08:40:00',1.12),('10318','2013-02-24','08:45:00',2.07),('10318','2013-02-24','08:50:00',2.24),('10318','2013-02-24','08:55:00',1.52),('10318','2013-02-24','09:00:00',1.74),('10318','2013-02-24','09:05:00',1.31),('10318','2013-02-24','09:10:00',1.01),('10318','2013-02-24','09:25:00',1.1),('10318','2013-02-24','09:30:00',1.04),('10318','2013-02-24','09:45:00',1.27),('10318','2013-02-24','09:50:00',1),('10318','2013-02-24','09:55:00',1.05),('10318','2013-02-24','10:00:00',1.4),('10318','2013-02-24','10:05:00',1.29),('10318','2013-02-24','10:10:00',1.19),('10318','2013-02-24','10:15:00',1.18),('10318','2013-02-24','10:25:00',1.29),('10318','2013-02-24','10:30:00',1.46),('10318','2013-02-24','10:35:00',1.74),('10318','2013-02-24','10:40:00',2.22),('10318','2013-02-24','10:45:00',2.77),('10318','2013-02-24','10:50:00',4.3),('10318','2013-02-24','10:55:00',3.7),('10318','2013-02-24','11:00:00',2.92),('10318','2013-02-24','11:05:00',2.42),('10318','2013-02-24','11:10:00',2.07),('10318','2013-02-24','11:15:00',2.01),('10318','2013-02-24','11:20:00',1.85),('10318','2013-02-24','11:25:00',2.2),('10318','2013-02-24','11:30:00',2.1),('10318','2013-02-24','11:35:00',1.91),('10318','2013-02-24','11:40:00',2.12),('10318','2013-02-24','11:45:00',2.25),('10318','2013-02-24','11:50:00',2.05),('10318','2013-02-24','11:55:00',2.18),('10318','2013-02-24','12:00:00',1.92),('10318','2013-02-24','12:05:00',1.65),('10318','2013-02-24','12:10:00',1.19),('10318','2013-02-24','12:15:00',1.18),('10318','2013-02-24','12:25:00',1.12),('10318','2013-02-24','12:30:00',2.25),('10318','2013-02-24','12:35:00',2.31),('10318','2013-02-24','12:40:00',3),('10318','2013-02-24','12:45:00',2.22),('10318','2013-02-24','12:50:00',2.19),('10318','2013-02-24','12:55:00',2.28),('10318','2013-02-24','13:00:00',2.71),('10318','2013-02-24','13:05:00',3.14),('10318','2013-02-24','13:10:00',3.09),('10318','2013-02-24','13:15:00',2.91),('10318','2013-02-24','13:20:00',2.48),('10318','2013-02-24','13:25:00',2.42),('10318','2013-02-24','13:30:00',3.83),('10318','2013-02-24','13:35:00',2.1),('10318','2013-02-24','13:40:00',1.78),('10318','2013-02-24','13:45:00',2.64),('10318','2013-02-24','13:50:00',2.53),('10318','2013-02-24','13:55:00',2.39),('10318','2013-02-24','14:00:00',4.14),('10318','2013-02-24','14:05:00',4.82),('10318','2013-02-24','14:10:00',3.62),('10318','2013-02-24','14:15:00',3.03),('10318','2013-02-24','14:20:00',2.29),('10318','2013-02-24','14:25:00',2.58),('10318','2013-02-24','14:30:00',2.6),('10318','2013-02-24','14:35:00',2.26),('10318','2013-02-24','14:40:00',1.87),('10318','2013-02-24','14:45:00',1.78),('10318','2013-02-24','14:50:00',1.67),('10318','2013-02-24','14:55:00',1.59),('10318','2013-02-24','15:00:00',2.89),('10318','2013-02-24','15:05:00',4.08),('10318','2013-02-24','15:10:00',3.98),('10318','2013-02-24','15:15:00',3.8),('10318','2013-02-24','15:20:00',5.26),('10318','2013-02-24','15:25:00',3.37),('10318','2013-02-24','15:30:00',5.78),('10318','2013-02-24','15:35:00',3.55),('10318','2013-02-24','15:40:00',2.26),('10318','2013-02-24','15:45:00',2.93),('10318','2013-02-24','15:50:00',3.27),('10318','2013-02-24','15:55:00',3.3),('10318','2013-02-24','16:00:00',1.98),('10318','2013-02-24','16:05:00',1.53),('10318','2013-02-24','16:10:00',1.16),('10318','2013-02-24','16:15:00',1.2),('10318','2013-02-24','16:20:00',1.4),('10318','2013-02-24','16:25:00',1.71),('10318','2013-02-24','16:30:00',1.81),('10318','2013-02-24','16:35:00',2.48),('10318','2013-02-24','16:40:00',2.05),('10318','2013-02-23','07:30:00',1.05),('10318','2013-02-23','07:35:00',1.26),('10318','2013-02-23','07:40:00',1.46),('10318','2013-02-23','07:45:00',1.72),('10318','2013-02-23','07:50:00',1.97),('10318','2013-02-23','07:55:00',2.46),('10318','2013-02-23','08:00:00',3.32),('10318','2013-02-23','08:05:00',3.9),('10318','2013-02-23','08:10:00',4.62),('10318','2013-02-23','08:15:00',4.88),('10318','2013-02-23','08:20:00',2.14),('10318','2013-02-23','08:25:00',1.53),('10318','2013-02-23','08:30:00',1.38),('10318','2013-02-23','08:35:00',1.24),('10318','2013-02-23','08:40:00',1.13),('10318','2013-02-23','08:45:00',1.46),('10318','2013-02-23','08:50:00',2.05),('10318','2013-02-23','08:55:00',2.52),('10318','2013-02-23','09:00:00',3.41),('10318','2013-02-23','09:05:00',3.8),('10318','2013-02-23','09:10:00',2.27),('10318','2013-02-23','09:15:00',1.72),('10318','2013-02-23','09:20:00',1.45),('10318','2013-02-23','09:30:00',1.18),('10318','2013-02-23','09:35:00',1.71),('10318','2013-02-23','09:40:00',1.98),('10318','2013-02-23','09:45:00',2.82),('10318','2013-02-23','09:50:00',3.03),('10318','2013-02-23','09:55:00',2.95),('10318','2013-02-23','10:00:00',2.25),('10318','2013-02-23','10:05:00',2.08),('10318','2013-02-23','10:10:00',1.72),('10318','2013-02-23','10:15:00',1.42),('10318','2013-02-23','10:20:00',1.73),('10318','2013-02-23','10:25:00',2.4),('10318','2013-02-23','10:30:00',2.79),('10318','2013-02-23','10:35:00',2.42),('10318','2013-02-23','10:40:00',2.33),('10318','2013-02-23','10:45:00',2.3),('10318','2013-02-23','10:50:00',2.63),('10318','2013-02-23','10:55:00',2.18),('10318','2013-02-23','11:00:00',1.56),('10318','2013-02-23','11:05:00',1.4),('10318','2013-02-23','11:10:00',1.46),('10318','2013-02-23','11:15:00',1.52),('10318','2013-02-23','11:20:00',1.88),('10318','2013-02-23','11:25:00',1.84),('10318','2013-02-23','11:30:00',1.79),('10318','2013-02-23','11:35:00',2.34),('10318','2013-02-23','11:40:00',2.03),('10318','2013-02-23','11:45:00',1.85),('10318','2013-02-23','11:50:00',1.6),('10318','2013-02-23','11:55:00',1.34),('10318','2013-02-23','12:00:00',1.22),('10318','2013-02-23','12:05:00',1.7),('10318','2013-02-23','12:10:00',1.57),('10318','2013-02-23','12:15:00',1.18),('10318','2013-02-23','12:20:00',1.37),('10318','2013-02-23','12:25:00',1.28),('10318','2013-02-23','12:30:00',1.19),('10318','2013-02-23','13:10:00',1.03),('10318','2013-02-23','13:50:00',1.31),('10318','2013-02-23','13:55:00',2.02),('10318','2013-02-23','14:00:00',2.19),('10318','2013-02-23','14:05:00',3.72),('10318','2013-02-23','14:10:00',2.23),('10318','2013-02-23','14:45:00',1.59),('10318','2013-02-23','14:50:00',1.28),('10318','2013-02-23','14:55:00',1.05),('10318','2013-02-22','09:35:00',1.14),('10318','2013-02-22','09:40:00',1.18),('10318','2013-02-22','09:50:00',1.14),('10318','2013-02-22','10:00:00',1.05),('10318','2013-02-22','10:05:00',1.02),('10318','2013-02-22','10:15:00',1.14),('10318','2013-02-22','11:10:00',1.03),('10318','2013-02-22','11:15:00',1.02),('10318','2013-02-22','11:30:00',1.13),('10318','2013-02-22','11:35:00',1.66),('10318','2013-02-22','11:40:00',1.48),('10318','2013-02-22','11:45:00',1),('10318','2013-02-22','11:50:00',1.02),('10318','2013-02-22','11:55:00',1.38),('10318','2013-02-22','12:00:00',2.07),('10318','2013-02-22','12:05:00',1.78),('10318','2013-02-22','12:40:00',1.14),('10318','2013-02-22','12:45:00',1.82),('10318','2013-02-22','12:50:00',2.15),('10318','2013-02-22','12:55:00',2.47),('10318','2013-02-22','13:00:00',1.68),('10318','2013-02-22','13:05:00',1.04),('10318','2013-02-22','14:00:00',2.23),('10318','2013-02-22','14:05:00',1.68),('10318','2013-02-22','14:10:00',2.24),('10318','2013-02-22','14:15:00',2.72),('10318','2013-02-22','14:20:00',2.12),('10318','2013-02-22','14:25:00',1.25),('10318','2013-02-22','14:30:00',1.77),('10318','2013-02-22','14:35:00',2.56),('10318','2013-02-22','14:40:00',3.52),('10318','2013-02-22','14:45:00',3.06),('10318','2013-02-22','14:50:00',2.1),('10318','2013-02-22','14:55:00',2.1),('10318','2013-02-22','15:00:00',1.73),('10318','2013-02-22','15:45:00',1.31),('10318','2013-02-22','15:50:00',1.67),('10318','2013-02-22','15:55:00',2.12),('10318','2013-02-22','16:00:00',1.89),('10318','2013-02-22','16:05:00',1.73),('10318','2013-02-22','16:15:00',3.29),('10318','2013-02-22','16:20:00',3.57),('10318','2013-02-22','16:25:00',1.6),('10318','2013-02-22','16:30:00',1.48),('10318','2013-02-22','16:35:00',1.11),('10318','2013-02-21','09:35:00',1.1),('10318','2013-02-21','09:40:00',1.4),('10318','2013-02-21','09:45:00',1.77),('10318','2013-02-21','09:50:00',1.75),('10318','2013-02-21','09:55:00',1.68),('10318','2013-02-21','10:00:00',1.57),('10318','2013-02-21','10:05:00',1.68),('10318','2013-02-21','10:10:00',1.68),('10318','2013-02-21','10:15:00',1.64),('10318','2013-02-21','10:20:00',1.64),('10318','2013-02-21','10:25:00',1.62),('10318','2013-02-21','10:30:00',1.71),('10318','2013-02-21','10:35:00',1.71),('10318','2013-02-21','10:40:00',1.62),('10318','2013-02-21','10:45:00',1.49),('10318','2013-02-21','10:50:00',1.54),('10318','2013-02-21','10:55:00',1.48),('10318','2013-02-21','11:00:00',1.4),('10318','2013-02-21','11:05:00',1.44),('10318','2013-02-21','11:10:00',1.51),('10318','2013-02-21','11:15:00',1.64),('10318','2013-02-21','11:20:00',1.97),('10318','2013-02-21','11:25:00',2.18),('10318','2013-02-21','11:30:00',2.27),('10318','2013-02-21','11:35:00',2.35),('10318','2013-02-21','11:40:00',2.32),('10318','2013-02-21','11:45:00',2.48),('10318','2013-02-21','11:50:00',2.71),('10318','2013-02-21','11:55:00',2.55),('10318','2013-02-21','12:00:00',2.5),('10318','2013-02-21','12:05:00',2.7),('10318','2013-02-21','12:10:00',2.69),('10318','2013-02-21','12:15:00',2.86),('10318','2013-02-21','12:20:00',2.88),('10318','2013-02-21','12:25:00',2.7),('10318','2013-02-21','12:30:00',2.64),('10318','2013-02-21','12:35:00',2.62),('10318','2013-02-21','12:40:00',2.66),('10318','2013-02-21','12:45:00',2.67),('10318','2013-02-21','12:50:00',2.7),('10318','2013-02-21','12:55:00',2.83),('10318','2013-02-21','13:00:00',2.68),('10318','2013-02-21','13:05:00',2.55),('10318','2013-02-21','13:10:00',2.59),('10318','2013-02-21','13:15:00',2.66),('10318','2013-02-21','13:20:00',2.89),('10318','2013-02-21','13:25:00',2.95),('10318','2013-02-21','13:30:00',2.9),('10318','2013-02-21','13:35:00',2.75),('10318','2013-02-21','13:40:00',2.51),('10318','2013-02-21','13:45:00',2.48),('10318','2013-02-21','13:50:00',2.5),('10318','2013-02-21','13:55:00',2.44),('10318','2013-02-21','14:00:00',2.58),('10318','2013-02-21','14:05:00',2.34),('10318','2013-02-21','14:10:00',2.1),('10318','2013-02-21','14:15:00',1.77),('10318','2013-02-21','14:20:00',1.72),('10318','2013-02-21','14:25:00',1.76),('10318','2013-02-21','14:30:00',1.88),('10318','2013-02-21','14:35:00',1.94),('10318','2013-02-21','14:40:00',1.89),('10318','2013-02-21','14:45:00',1.86),('10318','2013-02-21','14:50:00',1.76),('10318','2013-02-21','14:55:00',1.59),('10318','2013-02-21','15:00:00',1.45),('10318','2013-02-21','15:05:00',1.42),('10318','2013-02-21','15:10:00',1.49),('10318','2013-02-21','15:15:00',1.43),('10318','2013-02-21','15:20:00',1.3),('10318','2013-02-21','15:25:00',1.27),('10318','2013-02-21','15:30:00',1.37),('10318','2013-02-21','15:35:00',1.46),('10318','2013-02-21','15:40:00',1.61),('10318','2013-02-21','15:45:00',1.82),('10318','2013-02-21','15:50:00',2.07),('10318','2013-02-21','15:55:00',2.3),('10318','2013-02-21','16:00:00',2.23),('10318','2013-02-21','16:05:00',2.46),('10318','2013-02-21','16:10:00',2.47),('10318','2013-02-21','16:15:00',2.91),('10318','2013-02-21','16:20:00',3.42),('10318','2013-02-21','16:25:00',3.21),('10318','2013-02-21','16:30:00',2.84),('10318','2013-02-21','16:35:00',2.36),('10318','2013-02-21','16:40:00',1.96),('10318','2013-02-21','16:45:00',1.57),('10318','2013-02-21','16:50:00',1.25),('10318','2013-02-21','16:55:00',1.04),('10318','2014-03-23','08:00:00',1.33),('10318','2014-03-23','08:05:00',1.47),('10318','2014-03-23','08:10:00',1.65),('10318','2014-03-23','08:15:00',1.65),('10318','2014-03-23','08:20:00',1.96),('10318','2014-03-23','08:25:00',2.26),('10318','2014-03-23','08:30:00',2.69),('10318','2014-03-23','08:35:00',2.44),('10318','2014-03-23','08:40:00',1.87),('10318','2014-03-23','08:45:00',2.2),('10318','2014-03-23','08:50:00',3.52),('10318','2014-03-23','08:55:00',4.01),('10318','2014-03-23','09:00:00',3),('10318','2014-03-23','09:05:00',5.67),('10318','2014-03-23','09:10:00',7.33),('10318','2014-03-23','09:15:00',6.27),('10318','2014-03-23','09:20:00',3.66),('10318','2014-03-23','09:25:00',2.4),('10318','2014-03-23','09:30:00',3.46),('10318','2014-03-23','09:35:00',3.49),('10318','2014-03-23','09:40:00',2.27),('10318','2014-03-23','09:45:00',1.89),('10318','2014-03-23','09:50:00',1.8),('10318','2014-03-23','09:55:00',1.72),('10318','2014-03-23','10:00:00',1.66),('10318','2014-03-23','10:05:00',1.66),('10318','2014-03-23','10:10:00',1.57),('10318','2014-03-23','10:15:00',1.32),('10318','2014-03-23','10:20:00',1.79),('10318','2014-03-23','10:25:00',3.08),('10318','2014-03-23','10:30:00',1.89),('10318','2014-03-23','10:35:00',1.91),('10318','2014-03-23','10:40:00',2.7),('10318','2014-03-23','10:45:00',1.64),('10318','2014-03-23','10:50:00',2.7),('10318','2014-03-23','10:55:00',3.81),('10318','2014-03-23','11:00:00',2.56),('10318','2014-03-23','11:05:00',2.68),('10318','2014-03-23','11:10:00',2.6),('10318','2014-03-23','11:15:00',1.52),('10318','2014-03-23','11:20:00',2.32),('10318','2014-03-23','11:25:00',2.67),('10318','2014-03-23','11:30:00',1.88),('10318','2014-03-23','11:35:00',5.34),('10318','2014-03-23','11:40:00',7.3),('10318','2014-03-23','11:45:00',1.71),('10318','2014-03-23','11:55:00',1.38),('10318','2014-03-23','12:00:00',2.13),('10318','2014-03-23','12:05:00',1.14),('10318','2014-03-23','12:20:00',1.24),('10318','2014-03-23','12:25:00',1.67),('10318','2014-03-23','12:30:00',1.51),('10318','2014-03-23','12:35:00',1.52),('10318','2014-03-23','13:05:00',1.28),('10318','2014-03-23','13:10:00',1.36),('10318','2014-03-23','13:15:00',1.38),('10318','2014-03-23','13:35:00',1.83),('10318','2014-03-23','13:40:00',4.43),('10318','2014-03-23','13:45:00',5.91),('10318','2014-03-23','13:50:00',2.34),('10318','2014-03-23','13:55:00',2.36),('10318','2014-03-23','14:00:00',1.88),('10318','2014-03-23','14:05:00',1.47),('10318','2014-03-23','14:20:00',1.09),('10318','2014-03-23','14:45:00',1.81),('10318','2014-03-23','14:55:00',1.51),('10318','2014-03-23','15:00:00',2.08),('10318','2014-03-23','15:05:00',3.79),('10318','2014-03-23','15:10:00',3.69),('10318','2014-03-23','15:15:00',3.2),('10318','2014-03-23','15:20:00',3.39),('10318','2014-03-23','15:25:00',5.22),('10318','2014-03-23','15:30:00',2.71),('10318','2014-03-23','15:35:00',2.05),('10318','2014-03-23','15:40:00',1.42),('10318','2013-02-20','07:55:00',1.92),('10318','2013-02-20','08:00:00',1.78),('10318','2013-02-20','08:05:00',1.36),('10318','2013-02-20','08:10:00',1.46),('10318','2013-02-20','08:15:00',2.05),('10318','2013-02-20','08:20:00',4.06),('10318','2013-02-20','08:25:00',4.31),('10318','2013-02-20','08:30:00',4.55),('10318','2013-02-20','08:35:00',4.76),('10318','2013-02-20','08:40:00',4.94),('10318','2013-02-20','08:45:00',5.14),('10318','2013-02-20','08:50:00',5.35),('10318','2013-02-20','08:55:00',5.58),('10318','2013-02-20','09:00:00',5.34),('10318','2013-02-20','09:05:00',4.77),('10318','2013-02-20','09:10:00',2.82),('10318','2013-02-20','09:15:00',2.72),('10318','2013-02-20','09:20:00',6.38),('10318','2013-02-20','09:25:00',4.89),('10318','2013-02-20','09:30:00',6.44),('10318','2013-02-20','09:35:00',7.38),('10318','2013-02-20','09:40:00',4.33),('10318','2013-02-20','09:45:00',3.69),('10318','2013-02-20','09:50:00',5.62),('10318','2013-02-20','09:55:00',5.18),('10318','2013-02-20','10:00:00',6.33),('10318','2013-02-20','10:05:00',2.44),('10318','2013-02-20','10:10:00',2.11),('10318','2013-02-20','10:15:00',1.84),('10318','2013-02-20','10:20:00',1.95),('10318','2013-02-20','10:25:00',1.94),('10318','2013-02-20','10:30:00',1.9),('10318','2013-02-20','10:35:00',2.35),('10318','2013-02-20','10:40:00',2.68),('10318','2013-02-20','10:45:00',6.14),('10318','2013-02-20','10:50:00',4.57),('10318','2013-02-20','10:55:00',5.7),('10318','2013-02-20','11:00:00',7.12),('10318','2013-02-20','11:05:00',4.6),('10318','2013-02-20','11:10:00',9.97),('10318','2013-02-20','11:15:00',10.08),('10318','2013-02-20','11:20:00',9.96),('10318','2013-02-20','11:25:00',8.63),('10318','2013-02-20','11:30:00',5.94),('10318','2013-02-20','11:35:00',6.21),('10318','2013-02-20','11:40:00',5.99),('10318','2013-02-20','11:45:00',10.2),('10318','2013-02-20','11:50:00',9.89),('10318','2013-02-20','11:55:00',8.59),('10318','2013-02-20','12:00:00',2.9),('10318','2013-02-20','12:05:00',2.55),('10318','2013-02-20','12:10:00',2.69),('10318','2013-02-20','12:15:00',3.84),('10318','2013-02-20','12:20:00',3.96),('10318','2013-02-20','12:25:00',3.39),('10318','2013-02-20','12:30:00',6.49),('10318','2013-02-20','12:35:00',8.72),('10318','2013-02-20','12:40:00',8.62),('10318','2013-02-20','12:45:00',7.26),('10318','2013-02-20','12:50:00',9.36),('10318','2013-02-20','12:55:00',7.19),('10318','2013-02-20','13:00:00',4.68),('10318','2013-02-20','13:05:00',8.78),('10318','2013-02-20','13:10:00',8.88),('10318','2013-02-20','13:15:00',8),('10318','2013-02-20','13:20:00',4.06),('10318','2013-02-20','13:25:00',3.03),('10318','2013-02-20','13:30:00',2.97),('10318','2013-02-20','13:35:00',2.55),('10318','2013-02-20','13:40:00',5.02),('10318','2013-02-20','13:45:00',7.68),('10318','2013-02-20','13:50:00',7.35),('10318','2013-02-20','13:55:00',7.1),('10318','2013-02-20','14:00:00',6.75),('10318','2013-02-20','14:05:00',4.63),('10318','2013-02-20','14:10:00',2.11),('10318','2013-02-20','14:15:00',1.67),('10318','2013-02-20','14:20:00',1.69),('10318','2013-02-20','14:25:00',2.03),('10318','2013-02-20','14:30:00',2.61),('10318','2013-02-20','14:35:00',2.57),('10318','2013-02-20','14:40:00',2.57),('10318','2013-02-20','14:45:00',2.96),('10318','2013-02-20','14:50:00',2.71),('10318','2013-02-20','14:55:00',5.13),('10318','2013-02-20','15:00:00',5.27),('10318','2013-02-20','15:05:00',4.2),('10318','2013-02-20','15:10:00',3.25),('10318','2013-02-20','15:15:00',5.42),('10318','2013-02-20','15:20:00',2.66),('10318','2013-02-20','15:25:00',1.95),('10318','2013-02-20','15:30:00',1.76),('10318','2013-02-20','15:35:00',1.57),('10318','2013-02-20','15:40:00',1.23),('10318','2013-02-20','15:45:00',1.36),('10318','2013-02-20','15:50:00',1.32),('10318','2013-02-20','15:55:00',1.49),('10318','2013-02-20','16:00:00',1.57),('10318','2013-02-20','16:05:00',2.1),('10318','2013-02-20','16:10:00',3.15),('10318','2013-02-20','16:15:00',2.28),('10318','2013-02-20','16:20:00',2.2),('10318','2013-02-20','16:25:00',2.54),('10318','2013-02-20','16:30:00',2.43),('10318','2013-02-20','16:35:00',1.94),('10318','2013-02-20','16:40:00',1.82),('10318','2013-02-20','16:45:00',1.16),('10318','2013-02-20','16:55:00',1.11),('10318','2013-02-20','17:00:00',1.09),('10318','2013-02-19','07:35:00',1.03),('10318','2013-02-19','07:40:00',1.21),('10318','2013-02-19','07:45:00',1.42),('10318','2013-02-19','07:50:00',1.63),('10318','2013-02-19','07:55:00',1.82),('10318','2013-02-19','08:00:00',2.04),('10318','2013-02-19','08:05:00',2.91),('10318','2013-02-19','08:10:00',3.48),('10318','2013-02-19','08:15:00',3.73),('10318','2013-02-19','08:20:00',3.98),('10318','2013-02-19','08:25:00',4.21),('10318','2013-02-19','08:30:00',4.43),('10318','2013-02-19','08:35:00',4.59),('10318','2013-02-19','08:40:00',4.88),('10318','2013-02-19','08:45:00',5.04),('10318','2013-02-19','08:50:00',5.21),('10318','2013-02-19','08:55:00',5.41),('10318','2013-02-19','09:00:00',5.59),('10318','2013-02-19','09:05:00',5.74),('10318','2013-02-19','09:10:00',5.91),('10318','2013-02-19','09:15:00',6.08),('10318','2013-02-19','09:20:00',6.24),('10318','2013-02-19','09:25:00',6.38),('10318','2013-02-19','09:30:00',6.52),('10318','2013-02-19','09:35:00',6.66),('10318','2013-02-19','09:40:00',6.78),('10318','2013-02-19','09:45:00',6.89),('10318','2013-02-19','09:50:00',6.94),('10318','2013-02-19','09:55:00',7.2),('10318','2013-02-19','10:00:00',7.29),('10318','2013-02-19','10:05:00',7.39),('10318','2013-02-19','10:10:00',7.5),('10318','2013-02-19','10:15:00',7.56),('10318','2013-02-19','10:20:00',7.71),('10318','2013-02-19','10:25:00',7.83),('10318','2013-02-19','10:30:00',7.87),('10318','2013-02-19','10:35:00',7.93),('10318','2013-02-19','10:40:00',8.03),('10318','2013-02-19','10:45:00',8.04),('10318','2013-02-19','10:50:00',8.06),('10318','2013-02-19','10:55:00',8.15),('10318','2013-02-19','11:00:00',8.2),('10318','2013-02-19','11:05:00',8.3),('10318','2013-02-19','11:10:00',8.4),('10318','2013-02-19','11:15:00',8.39),('10318','2013-02-19','11:20:00',8.37),('10318','2013-02-19','11:25:00',8.42),('10318','2013-02-19','11:30:00',8.46),('10318','2013-02-19','11:35:00',8.34),('10318','2013-02-19','11:40:00',8.43),('10318','2013-02-19','11:45:00',8.45),('10318','2013-02-19','11:50:00',8.47),('10318','2013-02-19','11:55:00',8.43),('10318','2013-02-19','12:00:00',8.47),('10318','2013-02-19','12:05:00',8.5),('10318','2013-02-19','12:10:00',8.43),('10318','2013-02-19','12:15:00',8.35),('10318','2013-02-19','12:20:00',8.35),('10318','2013-02-19','12:25:00',8.3),('10318','2013-02-19','12:30:00',8.27),('10318','2013-02-19','12:35:00',8.2),('10318','2013-02-19','12:40:00',8.09),('10318','2013-02-19','12:45:00',8.07),('10318','2013-02-19','12:50:00',8.02),('10318','2013-02-19','12:55:00',7.99),('10318','2013-02-19','13:00:00',7.91),('10318','2013-02-19','13:05:00',7.9),('10318','2013-02-19','13:10:00',7.78),('10318','2013-02-19','13:15:00',7.72),('10318','2013-02-19','13:20:00',7.49),('10318','2013-02-19','13:25:00',7.5),('10318','2013-02-19','13:30:00',7.24),('10318','2013-02-19','13:35:00',7.14),('10318','2013-02-19','13:40:00',6.42),('10318','2013-02-19','13:45:00',2.54),('10318','2013-02-19','13:50:00',6.18),('10318','2013-02-19','13:55:00',6.86),('10318','2013-02-19','14:00:00',6.82),('10318','2013-02-19','14:05:00',6.72),('10318','2013-02-19','14:10:00',6.53),('10318','2013-02-19','14:15:00',6.28),('10318','2013-02-19','14:20:00',6.15),('10318','2013-02-19','14:25:00',6.03),('10318','2013-02-19','14:30:00',5.92),('10318','2013-02-19','14:35:00',5.76),('10318','2013-02-19','14:40:00',5.62),('10318','2013-02-19','14:45:00',5.41),('10318','2013-02-19','14:50:00',5.28),('10318','2013-02-19','14:55:00',5.1),('10318','2013-02-19','15:00:00',4.95),('10318','2013-02-19','15:05:00',4.86),('10318','2013-02-19','15:10:00',4.77),('10318','2013-02-19','15:15:00',4.73),('10318','2013-02-19','15:20:00',4.46),('10318','2013-02-19','15:25:00',4.11),('10318','2013-02-19','15:30:00',3.87),('10318','2013-02-19','15:35:00',3.67),('10318','2013-02-19','15:40:00',3.57),('10318','2013-02-19','15:45:00',3.43),('10318','2013-02-19','15:50:00',3.3),('10318','2013-02-19','15:55:00',3.18),('10318','2013-02-19','16:00:00',2.95),('10318','2013-02-19','16:05:00',2.76),('10318','2013-02-19','16:10:00',2.63),('10318','2013-02-19','16:15:00',2.47),('10318','2013-02-19','16:20:00',2.22),('10318','2013-02-19','16:25:00',2.03),('10318','2013-02-19','16:30:00',1.92),('10318','2013-02-19','16:35:00',1.79),('10318','2013-02-19','16:40:00',1.57),('10318','2013-02-19','16:45:00',1.46),('10318','2013-02-19','16:50:00',1.26),('10318','2013-02-19','16:55:00',1.11),('10318','2013-02-18','07:50:00',1.12),('10318','2013-02-18','07:55:00',1.79),('10318','2013-02-18','08:00:00',2.33),('10318','2013-02-18','08:05:00',2.72),('10318','2013-02-18','08:10:00',3.25),('10318','2013-02-18','08:15:00',3.46),('10318','2013-02-18','08:20:00',3.59),('10318','2013-02-18','08:25:00',3.85),('10318','2013-02-18','08:30:00',4.06),('10318','2013-02-18','08:35:00',4.29),('10318','2013-02-18','08:40:00',4.43),('10318','2013-02-18','08:45:00',4.63),('10318','2013-02-18','08:50:00',4.85),('10318','2013-02-18','08:55:00',5.05),('10318','2013-02-18','09:00:00',5.18),('10318','2013-02-18','09:05:00',5.46),('10318','2013-02-18','09:10:00',5.67),('10318','2013-02-18','09:15:00',6),('10318','2013-02-18','09:20:00',5.62),('10318','2013-02-18','09:25:00',6.19),('10318','2013-02-18','09:30:00',5.7),('10318','2013-02-18','09:35:00',2.58),('10318','2013-02-18','09:40:00',2.95),('10318','2013-02-18','09:45:00',6.32),('10318','2013-02-18','09:50:00',1.99),('10318','2013-02-18','09:55:00',1.42),('10318','2013-02-18','10:00:00',3.8),('10318','2013-02-18','10:05:00',8.01),('10318','2013-02-18','10:10:00',6.74),('10318','2013-02-18','10:15:00',3.95),('10318','2013-02-18','10:20:00',3.09),('10318','2013-02-18','10:25:00',1.68),('10318','2013-02-18','10:30:00',1.83),('10318','2013-02-18','10:35:00',1.48),('10318','2013-02-18','10:40:00',1.79),('10318','2013-02-18','10:45:00',1.79),('10318','2013-02-18','10:50:00',1.75),('10318','2013-02-18','10:55:00',2.28),('10318','2013-02-18','11:00:00',2.14),('10318','2013-02-18','11:05:00',2.83),('10318','2013-02-18','11:10:00',3.54),('10318','2013-02-18','11:15:00',3.34),('10318','2013-02-18','11:20:00',4),('10318','2013-02-18','11:25:00',3.3),('10318','2013-02-18','11:30:00',3.4),('10318','2013-02-18','11:35:00',3.91),('10318','2013-02-18','11:40:00',3.8),('10318','2013-02-18','11:45:00',3.67),('10318','2013-02-18','11:50:00',4.03),('10318','2013-02-18','11:55:00',5.04),('10318','2013-02-18','12:00:00',4.3),('10318','2013-02-18','12:05:00',3.53),('10318','2013-02-18','12:10:00',3.31),('10318','2013-02-18','12:15:00',3.35),('10318','2013-02-18','12:20:00',3.11),('10318','2013-02-18','12:25:00',3.16),('10318','2013-02-18','12:30:00',2.92),('10318','2013-02-18','12:35:00',2.73),('10318','2013-02-18','12:40:00',2.97),('10318','2013-02-18','12:45:00',3.77),('10318','2013-02-18','12:50:00',3.51),('10318','2013-02-18','12:55:00',3.33),('10318','2013-02-18','13:00:00',3.65),('10318','2013-02-18','13:05:00',4.06),('10318','2013-02-18','13:10:00',4.39),('10318','2013-02-18','13:15:00',4.81),('10318','2013-02-18','13:20:00',4.08),('10318','2013-02-18','13:25:00',4.36),('10318','2013-02-18','13:30:00',3.26),('10318','2013-02-18','13:35:00',2.81),('10318','2013-02-18','13:40:00',3.01),('10318','2013-02-18','13:45:00',2.97),('10318','2013-02-18','13:50:00',3.08),('10318','2013-02-18','13:55:00',4.05),('10318','2013-02-18','14:00:00',3.8),('10318','2013-02-18','14:05:00',3.96),('10318','2013-02-18','14:10:00',3.05),('10318','2013-02-18','14:15:00',2.93),('10318','2013-02-18','14:20:00',3.78),('10318','2013-02-18','14:25:00',2.53),('10318','2013-02-18','14:30:00',2.29),('10318','2013-02-18','14:35:00',2.36),('10318','2013-02-18','14:40:00',2.72),('10318','2013-02-18','14:45:00',2.77),('10318','2013-02-18','14:50:00',2.19),('10318','2013-02-18','14:55:00',3.56),('10318','2013-02-18','15:00:00',3.64),('10318','2013-02-18','15:05:00',4.18),('10318','2013-02-18','15:10:00',1.79),('10318','2013-02-18','15:15:00',1.09),('10318','2013-02-18','15:35:00',1.29),('10318','2013-02-18','15:40:00',1.03),('10318','2013-02-17','07:45:00',1.17),('10318','2013-02-17','07:50:00',1.34),('10318','2013-02-17','07:55:00',1.57),('10318','2013-02-17','08:00:00',1.79),('10318','2013-02-17','08:05:00',2.14),('10318','2013-02-17','08:10:00',2.93),('10318','2013-02-17','08:15:00',3.21),('10318','2013-02-17','08:20:00',3.44),('10318','2013-02-17','08:25:00',3.69),('10318','2013-02-17','08:30:00',3.99),('10318','2013-02-17','08:35:00',4.37),('10318','2013-02-17','08:40:00',4.52),('10318','2013-02-17','08:45:00',4.4),('10318','2013-02-17','08:50:00',3.83),('10318','2013-02-17','08:55:00',4.95),('10318','2013-02-17','09:00:00',4.99),('10318','2013-02-17','09:05:00',5.06),('10318','2013-02-17','09:10:00',5.22),('10318','2013-02-17','09:15:00',5.69),('10318','2013-02-17','09:20:00',5.89),('10318','2013-02-17','09:25:00',6.05),('10318','2013-02-17','09:30:00',6.15),('10318','2013-02-17','09:35:00',6.23),('10318','2013-02-17','09:40:00',6.39),('10318','2013-02-17','09:45:00',6.49),('10318','2013-02-17','09:50:00',6.62),('10318','2013-02-17','09:55:00',6.78),('10318','2013-02-17','10:00:00',6.91),('10318','2013-02-17','10:05:00',7.06),('10318','2013-02-17','10:10:00',7.14),('10318','2013-02-17','10:15:00',7.15),('10318','2013-02-17','10:20:00',7.3),('10318','2013-02-17','10:25:00',7.21),('10318','2013-02-17','10:30:00',7.43),('10318','2013-02-17','10:35:00',7.53),('10318','2013-02-17','10:40:00',7.61),('10318','2013-02-17','10:45:00',7.67),('10318','2013-02-17','10:50:00',7.7),('10318','2013-02-17','10:55:00',7.78),('10318','2013-02-17','11:00:00',7.83),('10318','2013-02-17','11:05:00',7.83),('10318','2013-02-17','11:10:00',7.86),('10318','2013-02-17','11:15:00',7.87),('10318','2013-02-17','11:20:00',8.04),('10318','2013-02-17','11:25:00',8.06),('10318','2013-02-17','11:30:00',8.01),('10318','2013-02-17','11:35:00',8.03),('10318','2013-02-17','11:40:00',8.15),('10318','2013-02-17','11:45:00',8.13),('10318','2013-02-17','11:50:00',8.09),('10318','2013-02-17','11:55:00',8.03),('10318','2013-02-17','12:00:00',8.02),('10318','2013-02-17','12:05:00',8.05),('10318','2013-02-17','12:10:00',7.77),('10318','2013-02-17','12:15:00',7.89),('10318','2013-02-17','12:20:00',7.9),('10318','2013-02-17','12:25:00',7.93),('10318','2013-02-17','12:30:00',7.91),('10318','2013-02-17','12:35:00',7.89),('10318','2013-02-17','12:40:00',7.82),('10318','2013-02-17','12:45:00',7.79),('10318','2013-02-17','12:50:00',7.67),('10318','2013-02-17','12:55:00',7.62),('10318','2013-02-17','13:00:00',7.55),('10318','2013-02-17','13:05:00',7.43),('10318','2013-02-17','13:10:00',7.34),('10318','2013-02-17','13:15:00',7.42),('10318','2013-02-17','13:20:00',7.4),('10318','2013-02-17','13:25:00',7.25),('10318','2013-02-17','13:30:00',7.07),('10318','2013-02-17','13:35:00',6.77),('10318','2013-02-17','13:40:00',6.68),('10318','2013-02-17','13:45:00',6.23),('10318','2013-02-17','13:50:00',6.26),('10318','2013-02-17','13:55:00',6.2),('10318','2013-02-17','14:01:00',4.33),('10318','2013-02-17','14:05:00',3.69),('10318','2013-02-17','14:10:00',6.4),('10318','2013-02-17','14:15:00',6.36),('10318','2013-02-17','14:20:00',6.5),('10318','2013-02-17','14:25:00',3.79),('10318','2013-02-17','14:30:00',2.68),('10318','2013-02-17','14:35:00',5.83),('10318','2013-02-17','14:40:00',5.49),('10318','2013-02-17','14:45:00',2.92),('10318','2013-02-17','14:50:00',4.72),('10318','2013-02-17','14:55:00',5.54),('10318','2013-02-17','15:00:00',5.34),('10318','2013-02-17','15:05:00',5.3),('10318','2013-02-17','15:10:00',5.13),('10318','2013-02-17','15:15:00',4.74),('10318','2013-02-17','15:20:00',4.52),('10318','2013-02-17','15:25:00',4.31),('10318','2013-02-17','15:30:00',4.06),('10318','2013-02-17','15:35:00',3.92),('10318','2013-02-17','15:40:00',3.69),('10318','2013-02-17','15:45:00',3.6),('10318','2013-02-17','15:50:00',3.4),('10318','2013-02-17','15:55:00',2.96),('10318','2013-02-17','16:00:00',2.89),('10318','2013-02-17','16:05:00',2.28),('10318','2013-02-17','16:15:00',1.94),('10318','2013-02-17','16:20:00',2.21),('10318','2013-02-17','16:25:00',1.94),('10318','2013-02-17','16:30:00',2.37),('10318','2013-02-17','16:35:00',1.43),('10318','2013-02-16','07:50:00',1.25),('10318','2013-02-16','07:55:00',1.6),('10318','2013-02-16','08:00:00',2.03),('10318','2013-02-16','08:05:00',2.31),('10318','2013-02-16','08:10:00',2.81),('10318','2013-02-16','08:15:00',3.14),('10318','2013-02-16','08:20:00',3.41),('10318','2013-02-16','08:25:00',3.63),('10318','2013-02-16','08:30:00',3.87),('10318','2013-02-16','08:35:00',4.11),('10318','2013-02-16','08:40:00',4.17),('10318','2013-02-16','08:45:00',2.8),('10318','2013-02-16','08:50:00',1.11),('10318','2013-02-16','08:55:00',1.61),('10318','2013-02-16','09:00:00',1.96),('10318','2013-02-16','09:05:00',4.91),('10318','2013-02-16','09:10:00',5.84),('10318','2013-02-16','09:15:00',5.97),('10318','2013-02-16','09:20:00',6.21),('10318','2013-02-16','09:25:00',6.19),('10318','2013-02-16','09:30:00',6.51),('10318','2013-02-16','09:35:00',6.54),('10318','2013-02-16','09:40:00',6.65),('10318','2013-02-16','09:45:00',6.68),('10318','2013-02-16','09:50:00',6.8),('10318','2013-02-16','09:55:00',6.87),('10318','2013-02-16','10:00:00',7),('10318','2013-02-16','10:05:00',7.12),('10318','2013-02-16','10:10:00',7.26),('10318','2013-02-16','10:15:00',7.32),('10318','2013-02-16','10:20:00',7.43),('10318','2013-02-16','10:25:00',7.6),('10318','2013-02-16','10:30:00',7.66),('10318','2013-02-16','10:35:00',7.8),('10318','2013-02-16','10:40:00',7.83),('10318','2013-02-16','10:45:00',7.91),('10318','2013-02-16','10:50:00',7.98),('10318','2013-02-16','10:55:00',8.01),('10318','2013-02-16','11:00:00',8.16),('10318','2013-02-16','11:05:00',8.22),('10318','2013-02-16','11:10:00',8.23),('10318','2013-02-16','11:15:00',8.34),('10318','2013-02-16','11:20:00',8.34),('10318','2013-02-16','11:25:00',8.29),('10318','2013-02-16','11:30:00',8.35),('10318','2013-02-16','11:35:00',8.37),('10318','2013-02-16','11:40:00',8.38),('10318','2013-02-16','11:45:00',8.42),('10318','2013-02-16','11:50:00',8.42),('10318','2013-02-16','11:55:00',8.38),('10318','2013-02-16','12:00:00',8.34),('10318','2013-02-16','12:05:00',8.36),('10318','2013-02-16','12:10:00',8.33),('10318','2013-02-16','12:15:00',8.29),('10318','2013-02-16','12:20:00',8.22),('10318','2013-02-16','12:25:00',8.21),('10318','2013-02-16','12:30:00',8.04),('10318','2013-02-16','12:35:00',8.1),('10318','2013-02-16','12:40:00',8.14),('10318','2013-02-16','12:45:00',8.07),('10318','2013-02-16','12:50:00',7.98),('10318','2013-02-16','12:55:00',7.91),('10318','2013-02-16','13:00:00',7.79),('10318','2013-02-16','13:05:00',7.73),('10318','2013-02-16','13:10:00',7.67),('10318','2013-02-16','13:15:00',7.59),('10318','2013-02-16','13:20:00',7.48),('10318','2013-02-16','13:25:00',7.41),('10318','2013-02-16','13:30:00',7.28),('10318','2013-02-16','13:35:00',7.21),('10318','2013-02-16','13:40:00',7.15),('10318','2013-02-16','13:45:00',7.1),('10318','2013-02-16','13:50:00',6.92),('10318','2013-02-16','13:55:00',6.75),('10318','2013-02-16','14:00:00',6.83),('10318','2013-02-16','14:05:00',6.6),('10318','2013-02-16','14:10:00',6.47),('10318','2013-02-16','14:15:00',6.25),('10318','2013-02-16','14:20:00',5.6),('10318','2013-02-16','14:25:00',2.14),('10318','2013-02-16','14:30:00',5.53),('10318','2013-02-16','14:35:00',3.05),('10318','2013-02-16','14:40:00',2.09),('10318','2013-02-16','14:45:00',2.37),('10318','2013-02-16','14:50:00',1.99),('10318','2013-02-16','14:55:00',1.9),('10318','2013-02-16','15:00:00',1.99),('10318','2013-02-16','15:05:00',1.99),('10318','2013-02-16','15:10:00',2.11),('10318','2013-02-16','15:15:00',3.07),('10318','2013-02-16','15:20:00',5.12),('10318','2013-02-16','15:25:00',4.96),('10318','2013-02-16','15:30:00',4.64),('10318','2013-02-16','15:35:00',4.34),('10318','2013-02-16','15:40:00',4.31),('10318','2013-02-16','15:45:00',2.54),('10318','2013-02-16','15:50:00',2.05),('10318','2013-02-16','15:55:00',1.96),('10318','2013-02-16','16:00:00',1.93),('10318','2013-02-16','16:05:00',1.68),('10318','2013-02-16','16:10:00',2.6),('10318','2013-02-16','16:15:00',1.67),('10318','2013-02-16','16:20:00',2.2),('10318','2013-02-16','16:25:00',1.74),('10318','2013-02-16','16:30:00',1.26),('10318','2013-02-15','07:40:00',1.16),('10318','2013-02-15','07:45:00',1.42),('10318','2013-02-15','07:50:00',1.68),('10318','2013-02-15','07:55:00',1.96),('10318','2013-02-15','08:00:00',1.95),('10318','2013-02-15','08:05:00',1.91),('10318','2013-02-15','08:10:00',2.46),('10318','2013-02-15','08:15:00',1.72),('10318','2013-02-15','08:20:00',1.46),('10318','2013-02-15','08:50:00',1.32),('10318','2013-02-15','08:55:00',1.42),('10318','2013-02-15','09:00:00',1.23),('10318','2013-02-15','09:10:00',1.24),('10318','2013-02-15','09:15:00',2),('10318','2013-02-15','09:20:00',3.17),('10318','2013-02-15','09:25:00',2.3),('10318','2013-02-15','09:30:00',3.52),('10318','2013-02-15','09:35:00',2.28),('10318','2013-02-15','09:40:00',3.06),('10318','2013-02-15','09:45:00',4),('10318','2013-02-15','09:50:00',3.22),('10318','2013-02-15','09:55:00',5.24),('10318','2013-02-15','10:00:00',5.74),('10318','2013-02-15','10:05:00',5.89),('10318','2013-02-15','10:10:00',5.06),('10318','2013-02-15','10:15:00',4.93),('10318','2013-02-15','10:20:00',5.57),('10318','2013-02-15','10:25:00',4.88),('10318','2013-02-15','10:30:00',6.49),('10318','2013-02-15','10:35:00',6.93),('10318','2013-02-15','10:40:00',7.06),('10318','2013-02-15','10:45:00',7.86),('10318','2013-02-15','10:50:00',4.16),('10318','2013-02-15','10:55:00',4.35),('10318','2013-02-15','11:00:00',4.63),('10318','2013-02-15','11:05:00',4.86),('10318','2013-02-15','11:10:00',5.94),('10318','2013-02-15','11:15:00',8.6),('10318','2013-02-15','11:20:00',8.57),('10318','2013-02-15','11:25:00',8.4),('10318','2013-02-15','11:30:00',8.46),('10318','2013-02-15','11:35:00',7.44),('10318','2013-02-15','11:40:00',8.03),('10318','2013-02-15','11:45:00',8.87),('10318','2013-02-15','11:50:00',7.6),('10318','2013-02-15','11:55:00',5.78),('10318','2013-02-15','12:00:00',6.19),('10318','2013-02-15','12:05:00',6.5),('10318','2013-02-15','12:10:00',6.71),('10318','2013-02-15','12:15:00',8.53),('10318','2013-02-15','12:20:00',8.53),('10318','2013-02-15','12:25:00',8.34),('10318','2013-02-15','12:30:00',8.26),('10318','2013-02-15','12:35:00',8.08),('10318','2013-02-15','12:40:00',8.11),('10318','2013-02-15','12:45:00',8.01),('10318','2013-02-15','12:50:00',7.92),('10318','2013-02-15','12:55:00',7.9),('10318','2013-02-15','13:00:00',7.88),('10318','2013-02-15','13:05:00',7.76),('10318','2013-02-15','13:10:00',7.19),('10318','2013-02-15','13:15:00',5.59),('10318','2013-02-15','13:20:00',3.7),('10318','2013-02-15','13:25:00',3.73),('10318','2013-02-15','13:30:00',5.41),('10318','2013-02-15','13:35:00',7.1),('10318','2013-02-15','13:40:00',5.79),('10318','2013-02-15','13:45:00',5.28),('10318','2013-02-15','13:50:00',5.95),('10318','2013-02-15','13:55:00',4.44),('10318','2013-02-15','14:00:00',5.01),('10318','2013-02-15','14:05:00',7.91),('10318','2013-02-15','14:10:00',5.69),('10318','2013-02-15','14:15:00',5.94),('10318','2013-02-15','14:20:00',5.06),('10318','2013-02-15','14:25:00',5.85),('10318','2013-02-15','14:30:00',4.37),('10318','2013-02-15','14:35:00',6.04),('10318','2013-02-15','14:40:00',4.87),('10318','2013-02-15','14:45:00',3.24),('10318','2013-02-15','14:50:00',3.06),('10318','2013-02-15','14:55:00',3.01),('10318','2013-02-15','15:00:00',3.03),('10318','2013-02-15','15:05:00',2.76),('10318','2013-02-15','15:10:00',4.05),('10318','2013-02-15','15:15:00',3.38),('10318','2013-02-15','15:20:00',3.31),('10318','2013-02-15','15:25:00',4.11),('10318','2013-02-15','15:30:00',3.94),('10318','2013-02-15','15:35:00',2.82),('10318','2013-02-15','15:40:00',2.7),('10318','2013-02-15','15:45:00',2.25),('10318','2013-02-15','15:50:00',1.87),('10318','2013-02-15','15:55:00',1.69),('10318','2013-02-15','16:00:00',1.63),('10318','2013-02-15','16:05:00',1.5),('10318','2013-02-15','16:10:00',1.37),('10318','2013-02-15','16:15:00',1.17),('10318','2013-02-15','16:20:00',1.01),('10318','2013-02-14','07:40:00',1.06),('10318','2013-02-14','07:45:00',1.25),('10318','2013-02-14','07:50:00',1.49),('10318','2013-02-14','07:55:00',1.67),('10318','2013-02-14','08:00:00',2.36),('10318','2013-02-14','08:05:00',2.69),('10318','2013-02-14','08:10:00',2.95),('10318','2013-02-14','08:15:00',3.48),('10318','2013-02-14','08:20:00',3.64),('10318','2013-02-14','08:25:00',4.08),('10318','2013-02-14','08:30:00',4.38),('10318','2013-02-14','08:35:00',4.58),('10318','2013-02-14','08:40:00',4.81),('10318','2013-02-14','08:45:00',5.01),('10318','2013-02-14','08:50:00',5.21),('10318','2013-02-14','08:55:00',5.4),('10318','2013-02-14','09:00:00',5.48),('10318','2013-02-14','09:05:00',5.7),('10318','2013-02-14','09:10:00',5.86),('10318','2013-02-14','09:15:00',6.1),('10318','2013-02-14','09:20:00',6.29),('10318','2013-02-14','09:25:00',6.44),('10318','2013-02-14','09:30:00',6.55),('10318','2013-02-14','09:35:00',6.7),('10318','2013-02-14','09:40:00',6.86),('10318','2013-02-14','09:45:00',7),('10318','2013-02-14','09:50:00',7.15),('10318','2013-02-14','09:55:00',7.29),('10318','2013-02-14','10:00:00',7.39),('10318','2013-02-14','10:05:00',7.53),('10318','2013-02-14','10:10:00',7.64),('10318','2013-02-14','10:15:00',7.71),('10318','2013-02-14','10:20:00',7.83),('10318','2013-02-14','10:25:00',7.91),('10318','2013-02-14','10:30:00',8),('10318','2013-02-14','10:35:00',8.07),('10318','2013-02-14','10:40:00',8.14),('10318','2013-02-14','10:45:00',8.04),('10318','2013-02-14','10:50:00',8.26),('10318','2013-02-14','10:55:00',8.31),('10318','2013-02-14','11:00:00',8.35),('10318','2013-02-14','11:05:00',8.38),('10318','2013-02-14','11:10:00',8.4),('10318','2013-02-14','11:15:00',8.45),('10318','2013-02-14','11:20:00',8.51),('10318','2013-02-14','11:25:00',8.55),('10318','2013-02-14','11:30:00',8.53),('10318','2013-02-14','11:35:00',8.51),('10318','2013-02-14','11:40:00',8.52),('10318','2013-02-14','11:45:00',8.55),('10318','2013-02-14','11:50:00',8.51),('10318','2013-02-14','11:55:00',8.5),('10318','2013-02-14','12:00:00',8.57),('10318','2013-02-14','12:05:00',8.53),('10318','2013-02-14','12:10:00',8.5),('10318','2013-02-14','12:15:00',8.47),('10318','2013-02-14','12:20:00',8.46),('10318','2013-02-14','12:25:00',8.37),('10318','2013-02-14','12:30:00',8.24),('10318','2013-02-14','12:35:00',8.29),('10318','2013-02-14','12:40:00',8.27),('10318','2013-02-14','12:45:00',8.25),('10318','2013-02-14','12:50:00',8.16),('10318','2013-02-14','12:55:00',8.05),('10318','2013-02-14','13:00:00',8),('10318','2013-02-14','13:05:00',7.94),('10318','2013-02-14','13:10:00',7.85),('10318','2013-02-14','13:15:00',7.77),('10318','2013-02-14','13:20:00',7.65),('10318','2013-02-14','13:25:00',7.57),('10318','2013-02-14','13:30:00',7.48),('10318','2013-02-14','13:35:00',7.38),('10318','2013-02-14','13:40:00',7.25),('10318','2013-02-14','13:45:00',7.13),('10318','2013-02-14','13:50:00',7),('10318','2013-02-14','13:55:00',6.89),('10318','2013-02-14','14:00:00',6.81),('10318','2013-02-14','14:05:00',6.63),('10318','2013-02-14','14:10:00',6.51),('10318','2013-02-14','14:15:00',6.29),('10318','2013-02-14','14:20:00',6.2),('10318','2013-02-14','14:25:00',6.06),('10318','2013-02-14','14:30:00',5.95),('10318','2013-02-14','14:35:00',5.76),('10318','2013-02-14','14:40:00',5.61),('10318','2013-02-14','14:45:00',5.45),('10318','2013-02-14','14:50:00',5.31),('10318','2013-02-14','14:55:00',5.1),('10318','2013-02-14','15:00:00',4.9),('10318','2013-02-14','15:05:00',4.75),('10318','2013-02-14','15:10:00',4.57),('10318','2013-02-14','15:15:00',4.36),('10318','2013-02-14','15:20:00',4.21),('10318','2013-02-14','15:25:00',4.06),('10318','2013-02-14','15:30:00',3.83),('10318','2013-02-14','15:35:00',3.7),('10318','2013-02-14','15:40:00',3.54),('10318','2013-02-14','15:45:00',3.37),('10318','2013-02-14','15:50:00',3.19),('10318','2013-02-14','15:55:00',3.02),('10318','2013-02-14','16:00:00',2.83),('10318','2013-02-14','16:05:00',2.71),('10318','2013-02-14','16:10:00',2.49),('10318','2013-02-14','16:15:00',2.37),('10318','2013-02-14','16:20:00',2.2),('10318','2013-02-14','16:25:00',2.03),('10318','2013-02-14','16:30:00',1.83),('10318','2013-02-14','16:35:00',1.64),('10318','2013-02-14','16:40:00',1.46),('10318','2013-02-14','16:45:00',1.3),('10318','2013-02-14','16:50:00',1.14),('10318','2013-02-13','08:25:00',1.07),('10318','2013-02-13','08:30:00',1.18),('10318','2013-02-13','08:35:00',1.34),('10318','2013-02-13','08:40:00',1.5),('10318','2013-02-13','08:45:00',1.72),('10318','2013-02-13','08:50:00',2.03),('10318','2013-02-13','08:55:00',2.48),('10318','2013-02-13','09:00:00',2.71),('10318','2013-02-13','09:05:00',2.99),('10318','2013-02-13','09:10:00',3.02),('10318','2013-02-13','09:15:00',3.08),('10318','2013-02-13','09:20:00',3.05),('10318','2013-02-13','09:25:00',3.2),('10318','2013-02-13','09:30:00',4.19),('10318','2013-02-13','09:35:00',5.33),('10318','2013-02-13','09:40:00',5.16),('10318','2013-02-13','09:45:00',6.15),('10318','2013-02-13','09:50:00',5.88),('10318','2013-02-13','09:55:00',5.13),('10318','2013-02-13','10:00:00',6.18),('10318','2013-02-13','10:05:00',6.64),('10318','2013-02-13','10:10:00',7.06),('10318','2013-02-13','10:15:00',7.27),('10318','2013-02-13','10:20:00',7.51),('10318','2013-02-13','10:25:00',7.51),('10318','2013-02-13','10:30:00',7.8),('10318','2013-02-13','10:35:00',8.05),('10318','2013-02-13','10:40:00',8.05),('10318','2013-02-13','10:45:00',7.59),('10318','2013-02-13','10:50:00',7.21),('10318','2013-02-13','10:55:00',7.84),('10318','2013-02-13','11:00:00',8.42),('10318','2013-02-13','11:05:00',8.09),('10318','2013-02-13','11:10:00',7.5),('10318','2013-02-13','11:15:00',6.21),('10318','2013-02-13','11:20:00',5.88),('10318','2013-02-13','11:25:00',3.21),('10318','2013-02-13','11:30:00',2.7),('10318','2013-02-13','11:35:00',4.9),('10318','2013-02-13','11:40:00',2.99),('10318','2013-02-13','11:45:00',3.1),('10318','2013-02-13','11:50:00',6.55),('10318','2013-02-13','11:55:00',8.12),('10318','2013-02-13','12:00:00',5.75),('10318','2013-02-13','12:05:00',5.16),('10318','2013-02-13','12:10:00',3.58),('10318','2013-02-13','12:15:00',4.33),('10318','2013-02-13','12:20:00',3.02),('10318','2013-02-13','12:25:00',4.13),('10318','2013-02-13','12:30:00',2.14),('10318','2013-02-13','12:35:00',2.36),('10318','2013-02-13','12:40:00',3.67),('10318','2013-02-13','12:45:00',7.19),('10318','2013-02-13','12:50:00',6.45),('10318','2013-02-13','12:55:00',5.13),('10318','2013-02-13','13:00:00',5.31),('10318','2013-02-13','13:05:00',5.47),('10318','2013-02-13','13:10:00',6.13),('10318','2013-02-13','13:15:00',6.68),('10318','2013-02-13','13:20:00',7),('10318','2013-02-13','13:25:00',7.11),('10318','2013-02-13','13:30:00',7.54),('10318','2013-02-13','13:35:00',7.93),('10318','2013-02-13','13:40:00',8.01),('10318','2013-02-13','13:45:00',7.88),('10318','2013-02-13','13:50:00',5.69),('10318','2013-02-13','13:55:00',6.85),('10318','2013-02-13','14:00:00',5.68),('10318','2013-02-13','14:05:00',5.71),('10318','2013-02-13','14:10:00',6.52),('10318','2013-02-13','14:15:00',6.02),('10318','2013-02-13','14:20:00',5.18),('10318','2013-02-13','14:25:00',5.44),('10318','2013-02-13','14:30:00',5.12),('10318','2013-02-13','14:35:00',5.55),('10318','2013-02-13','14:40:00',5.59),('10318','2013-02-13','14:45:00',5.51),('10318','2013-02-13','14:50:00',5.11),('10318','2013-02-13','14:55:00',5.12),('10318','2013-02-13','15:00:00',4.93),('10318','2013-02-13','15:05:00',4.8),('10318','2013-02-13','15:10:00',4.56),('10318','2013-02-13','15:15:00',4.39),('10318','2013-02-13','15:20:00',4.18),('10318','2013-02-13','15:25:00',4.07),('10318','2013-02-13','15:30:00',3.93),('10318','2013-02-13','15:35:00',3.77),('10318','2013-02-13','15:40:00',3.59),('10318','2013-02-13','15:45:00',3.44),('10318','2013-02-13','15:50:00',3.32),('10318','2013-02-13','15:55:00',3.13),('10318','2013-02-13','16:00:00',2.93),('10318','2013-02-13','16:05:00',2.8),('10318','2013-02-13','16:10:00',2.62),('10318','2013-02-13','16:15:00',2.45),('10318','2013-02-13','16:20:00',2.27),('10318','2013-02-13','16:25:00',2.06),('10318','2013-02-13','16:30:00',1.75),('10318','2013-02-13','16:35:00',1.68),('10318','2013-02-13','16:40:00',1.48),('10318','2013-02-13','16:45:00',1.32),('10318','2013-02-12','11:40:00',1.12),('10318','2013-02-12','11:45:00',1.16),('10318','2013-02-12','11:50:00',1.1),('10318','2013-02-12','11:55:00',1.01),('10318','2013-02-12','12:05:00',1.03),('10318','2013-02-12','12:10:00',1.22),('10318','2013-02-12','12:15:00',1.23),('10318','2013-02-12','12:20:00',1.17),('10318','2013-02-12','12:25:00',1.1),('10318','2013-02-12','12:30:00',1.14),('10318','2013-02-12','12:35:00',1.05),('10318','2013-02-12','12:40:00',1.07),('10318','2013-02-12','13:25:00',1.03),('10318','2013-02-12','13:30:00',1.16),('10318','2013-02-12','13:35:00',1.13),('10318','2013-02-12','13:40:00',1.06),('10318','2013-02-12','13:45:00',1.02),('10318','2013-02-11','09:10:00',1.06),('10318','2013-02-11','09:15:00',1.25),('10318','2013-02-11','09:20:00',1.34),('10318','2013-02-11','09:25:00',1.53),('10318','2013-02-11','09:30:00',1.51),('10318','2013-02-11','09:35:00',1.49),('10318','2013-02-11','09:40:00',1.11),('10318','2013-02-11','09:55:00',1.06),('10318','2013-02-11','10:00:00',1.27),('10318','2013-02-11','10:05:00',1.45),('10318','2013-02-11','10:10:00',1.55),('10318','2013-02-11','10:15:00',2.21),('10318','2013-02-11','10:20:00',2.47),('10318','2013-02-11','10:25:00',2.43),('10318','2013-02-11','10:30:00',2.11),('10318','2013-02-11','10:35:00',2.44),('10318','2013-02-11','10:40:00',1.77),('10318','2013-02-11','10:45:00',1.65),('10318','2013-02-11','10:50:00',1.4),('10318','2013-02-11','10:55:00',1.32),('10318','2013-02-11','11:00:00',1.67),('10318','2013-02-11','11:05:00',1.7),('10318','2013-02-11','11:10:00',2.59),('10318','2013-02-11','11:15:00',2.94),('10318','2013-02-11','11:20:00',2.69),('10318','2013-02-11','11:25:00',1.77),('10318','2013-02-11','11:30:00',1.2),('10318','2013-02-11','11:35:00',1.41),('10318','2013-02-11','11:40:00',1.92),('10318','2013-02-11','11:45:00',2.78),('10318','2013-02-11','11:50:00',1.96),('10318','2013-02-11','11:55:00',1.22),('10318','2013-02-11','12:00:00',1.1),('10318','2013-02-11','12:05:00',1.28),('10318','2013-02-11','12:10:00',1.24),('10318','2013-02-11','12:15:00',1.3),('10318','2013-02-11','12:35:00',1.09),('10318','2013-02-11','12:40:00',1.94),('10318','2013-02-11','12:45:00',2.72),('10318','2013-02-11','12:50:00',1.44),('10318','2013-02-11','12:55:00',1.69),('10318','2013-02-11','13:00:00',1.39),('10318','2013-02-11','13:05:00',1.03),('10318','2013-02-11','13:50:00',1.7),('10318','2013-02-11','13:55:00',1.97),('10318','2013-02-11','14:00:00',2.07),('10318','2013-02-11','14:05:00',1.84),('10318','2013-02-11','14:10:00',2.64),('10318','2013-02-11','14:15:00',1.98),('10318','2013-02-11','14:20:00',2.13),('10318','2013-02-11','14:25:00',3.13),('10318','2013-02-11','14:30:00',4.16),('10318','2013-02-11','14:35:00',3.54),('10318','2013-02-11','14:40:00',3.6),('10318','2013-02-11','14:45:00',2.8),('10318','2013-02-11','14:50:00',2.13),('10318','2013-02-11','14:55:00',1.8),('10318','2013-02-11','15:00:00',1.5),('10318','2013-02-11','15:05:00',2),('10318','2013-02-11','15:10:00',1.73),('10318','2013-02-11','15:15:00',1.59),('10318','2013-02-11','15:20:00',1.93),('10318','2013-02-11','15:25:00',1.65),('10318','2013-02-11','15:30:00',1.35),('10318','2013-02-11','15:35:00',1.45),('10318','2013-02-11','15:40:00',1.05),('10318','2013-02-11','15:45:00',1.36),('10318','2013-02-11','15:50:00',1.45),('10318','2014-03-22','07:25:00',1.06),('10318','2014-03-22','07:30:00',1.53),('10318','2014-03-22','07:35:00',2.2),('10318','2014-03-22','07:40:00',2.39),('10318','2014-03-22','07:45:00',2.82),('10318','2014-03-22','07:50:00',2.39),('10318','2014-03-22','07:55:00',1.36),('10318','2014-03-22','08:00:00',1.23),('10318','2014-03-22','08:05:00',2.62),('10318','2014-03-22','08:10:00',4.27),('10318','2014-03-22','08:15:00',4.39),('10318','2014-03-22','08:20:00',4.67),('10318','2014-03-22','08:25:00',5.08),('10318','2014-03-22','08:30:00',4.18),('10318','2014-03-22','08:35:00',4.73),('10318','2014-03-22','08:40:00',5.88),('10318','2014-03-22','08:45:00',6.17),('10318','2014-03-22','08:50:00',4.38),('10318','2014-03-22','08:55:00',4.32),('10318','2014-03-22','09:00:00',4.02),('10318','2014-03-22','09:05:00',5.12),('10318','2014-03-22','09:10:00',5.18),('10318','2014-03-22','09:15:00',3.1),('10318','2014-03-22','09:20:00',3.36),('10318','2014-03-22','09:25:00',6.2),('10318','2014-03-22','09:30:00',4.56),('10318','2014-03-22','09:35:00',5.98),('10318','2014-03-22','09:40:00',7.46),('10318','2014-03-22','09:45:00',7.48),('10318','2014-03-22','09:50:00',7.73),('10318','2014-03-22','09:55:00',4.52),('10318','2014-03-22','10:00:00',5.5),('10318','2014-03-22','10:05:00',9.65),('10318','2014-03-22','10:10:00',5.4),('10318','2014-03-22','10:15:00',3.16),('10318','2014-03-22','10:20:00',3.14),('10318','2014-03-22','10:25:00',3.15),('10318','2014-03-22','10:30:00',3.68),('10318','2014-03-22','10:35:00',4.7),('10318','2014-03-22','10:40:00',4.64),('10318','2014-03-22','10:45:00',5.73),('10318','2014-03-22','10:50:00',3.82),('10318','2014-03-22','10:55:00',2.95),('10318','2014-03-22','11:00:00',2.78),('10318','2014-03-22','11:05:00',4.92),('10318','2014-03-22','11:10:00',3.79),('10318','2014-03-22','11:15:00',4.19),('10318','2014-03-22','11:20:00',6.48),('10318','2014-03-22','11:25:00',4.95),('10318','2014-03-22','11:30:00',7.2),('10318','2014-03-22','11:35:00',5.39),('10318','2014-03-22','11:40:00',5.08),('10318','2014-03-22','11:45:00',6.06),('10318','2014-03-22','11:50:00',8.31),('10318','2014-03-22','11:55:00',4.3),('10318','2014-03-22','12:00:00',5.37),('10318','2014-03-22','12:05:00',6.34),('10318','2014-03-22','12:10:00',4.32),('10318','2014-03-22','12:15:00',3.76),('10318','2014-03-22','12:20:00',3.8),('10318','2014-03-22','12:25:00',9.29),('10318','2014-03-22','12:30:00',9.31),('10318','2014-03-22','12:35:00',7.19),('10318','2014-03-22','12:40:00',3.85),('10318','2014-03-22','12:45:00',7.34),('10318','2014-03-22','12:50:00',9.28),('10318','2014-03-22','12:55:00',3.47),('10318','2014-03-22','13:00:00',5.59),('10318','2014-03-22','13:05:00',4.9),('10318','2014-03-22','13:10:00',4.71),('10318','2014-03-22','13:15:00',4.2),('10318','2014-03-22','13:20:00',3.04),('10318','2014-03-22','13:25:00',3.67),('10318','2014-03-22','13:30:00',6.39),('10318','2014-03-22','13:35:00',7.9),('10318','2014-03-22','13:40:00',6.62),('10318','2014-03-22','13:45:00',8.24),('10318','2014-03-22','13:50:00',7.69),('10318','2014-03-22','13:55:00',5.22),('10318','2014-03-22','14:00:00',7.46),('10318','2014-03-22','14:05:00',7.66),('10318','2014-03-22','14:10:00',7.41),('10318','2014-03-22','14:15:00',7.18),('10318','2014-03-22','14:20:00',7.15),('10318','2014-03-22','14:25:00',6.78),('10318','2014-03-22','14:30:00',6.68),('10318','2014-03-22','14:35:00',6.69),('10318','2014-03-22','14:40:00',6.2),('10318','2014-03-22','14:45:00',6.17),('10318','2014-03-22','14:50:00',6.05),('10318','2014-03-22','14:55:00',5.93),('10318','2014-03-22','15:00:00',5.8),('10318','2014-03-22','15:05:00',5.74),('10318','2014-03-22','15:10:00',5.4),('10318','2014-03-22','15:15:00',5.12),('10318','2014-03-22','15:20:00',4.77),('10318','2014-03-22','15:25:00',4.01),('10318','2014-03-22','15:30:00',5.54),('10318','2014-03-22','15:35:00',5.99),('10318','2014-03-22','15:40:00',5.45),('10318','2014-03-22','15:45:00',5),('10318','2014-03-22','15:50:00',4.9),('10318','2014-03-22','15:55:00',4.31),('10318','2014-03-22','16:00:00',4.04),('10318','2014-03-22','16:05:00',3.63),('10318','2014-03-22','16:10:00',2.69),('10318','2014-03-22','16:15:00',1.47),('10318','2014-03-22','16:20:00',2.5),('10318','2014-03-22','16:25:00',1.32),('10318','2014-03-22','16:35:00',1.76),('10318','2014-03-22','16:40:00',1.5),('10318','2014-03-22','16:45:00',1.55),('10318','2014-03-22','16:50:00',1.59),('10318','2014-03-22','16:55:00',1.64),('10318','2014-03-22','17:00:00',1.43),('10318','2014-03-22','17:05:00',1.15),('10318','2014-03-22','17:10:00',1.25),('10318','2013-02-10','08:55:00',1),('10318','2013-02-10','09:00:00',1.36),('10318','2013-02-10','09:05:00',1.51),('10318','2013-02-10','09:10:00',1.64),('10318','2013-02-10','09:15:00',1.8),('10318','2013-02-10','09:20:00',1.32),('10318','2013-02-10','09:25:00',1.06),('10318','2013-02-10','09:30:00',1.4),('10318','2013-02-10','09:35:00',2.21),('10318','2013-02-10','09:40:00',4.15),('10318','2013-02-10','09:45:00',6.04),('10318','2013-02-10','09:50:00',7.01),('10318','2013-02-10','09:55:00',7.47),('10318','2013-02-10','10:00:00',7.42),('10318','2013-02-10','10:05:00',7.41),('10318','2013-02-10','10:10:00',7.43),('10318','2013-02-10','10:15:00',7.51),('10318','2013-02-10','10:20:00',7.59),('10318','2013-02-10','10:25:00',7.7),('10318','2013-02-10','10:30:00',7.75),('10318','2013-02-10','10:35:00',7.8),('10318','2013-02-10','10:40:00',7.87),('10318','2013-02-10','10:45:00',7.99),('10318','2013-02-10','10:50:00',8.02),('10318','2013-02-10','10:55:00',8.06),('10318','2013-02-10','11:00:00',7.87),('10318','2013-02-10','11:05:00',8.14),('10318','2013-02-10','11:10:00',8.13),('10318','2013-02-10','11:15:00',8.16),('10318','2013-02-10','11:20:00',8.17),('10318','2013-02-10','11:25:00',8.2),('10318','2013-02-10','11:30:00',8.21),('10318','2013-02-10','11:35:00',8.26),('10318','2013-02-10','11:40:00',8.27),('10318','2013-02-10','11:45:00',8.3),('10318','2013-02-10','11:50:00',8.37),('10318','2013-02-10','11:55:00',8.36),('10318','2013-02-10','12:00:00',8.38),('10318','2013-02-10','12:05:00',8.33),('10318','2013-02-10','12:10:00',8.35),('10318','2013-02-10','12:15:00',8.15),('10318','2013-02-10','12:20:00',8.32),('10318','2013-02-10','12:25:00',8.29),('10318','2013-02-10','12:30:00',8.21),('10318','2013-02-10','12:35:00',8.18),('10318','2013-02-10','12:40:00',8.12),('10318','2013-02-10','12:45:00',7.93),('10318','2013-02-10','12:50:00',8.03),('10318','2013-02-10','12:55:00',7.92),('10318','2013-02-10','13:00:00',7.8),('10318','2013-02-10','13:05:00',7.73),('10318','2013-02-10','13:10:00',7.68),('10318','2013-02-10','13:15:00',7.69),('10318','2013-02-10','13:20:00',7.52),('10318','2013-02-10','13:25:00',7.39),('10318','2013-02-10','13:30:00',7.27),('10318','2013-02-10','13:35:00',7.19),('10318','2013-02-10','13:40:00',6.96),('10318','2013-02-10','13:45:00',6.64),('10318','2013-02-10','13:50:00',6.74),('10318','2013-02-10','13:55:00',6.67),('10318','2013-02-10','14:00:00',6.35),('10318','2013-02-10','14:05:00',6.31),('10318','2013-02-10','14:10:00',6.31),('10318','2013-02-10','14:15:00',6.12),('10318','2013-02-10','14:20:00',6.08),('10318','2013-02-10','14:25:00',5.94),('10318','2013-02-10','14:30:00',5.78),('10318','2013-02-10','14:35:00',5.63),('10318','2013-02-10','14:40:00',5.37),('10318','2013-02-10','14:45:00',4.77),('10318','2013-02-10','14:50:00',1.61),('10318','2013-02-10','14:55:00',4.43),('10318','2013-02-10','15:00:00',4.73),('10318','2013-02-10','15:05:00',4.54),('10318','2013-02-10','15:10:00',4.5),('10318','2013-02-10','15:15:00',4.51),('10318','2013-02-10','15:20:00',4.72),('10318','2013-02-10','15:25:00',2.38),('10318','2013-02-10','15:30:00',3.51),('10318','2013-02-10','15:35:00',3.42),('10318','2013-02-10','15:40:00',1.67),('10318','2013-02-10','15:45:00',1.22),('10318','2013-02-10','15:50:00',2.31),('10318','2013-02-10','15:55:00',2.14),('10318','2013-02-10','16:00:00',1.14),('10318','2013-02-10','16:05:00',1.01),('10318','2013-02-10','16:10:00',1.01),('10318','2013-02-10','16:15:00',1.42),('10318','2013-02-10','16:20:00',1.86),('10318','2013-02-10','16:25:00',2.43),('10318','2013-02-10','16:30:00',2.44),('10318','2013-02-10','16:35:00',2.02),('10318','2013-02-09','09:05:00',1.08),('10318','2013-02-09','09:10:00',1.24),('10318','2013-02-09','09:15:00',1.22),('10318','2013-02-09','09:20:00',1.22),('10318','2013-02-09','09:25:00',1.44),('10318','2013-02-09','09:30:00',1.68),('10318','2013-02-09','09:35:00',1.55),('10318','2013-02-09','09:40:00',1.35),('10318','2013-02-09','09:45:00',1.23),('10318','2013-02-09','09:50:00',1.15),('10318','2013-02-09','09:55:00',1.08),('10318','2013-02-09','10:00:00',1.08),('10318','2013-02-09','10:05:00',1.1),('10318','2013-02-09','10:10:00',1.12),('10318','2013-02-09','10:15:00',1.12),('10318','2013-02-09','10:20:00',1.16),('10318','2013-02-09','10:25:00',1.25),('10318','2013-02-09','10:30:00',1.38),('10318','2013-02-09','10:35:00',1.48),('10318','2013-02-09','10:40:00',1.64),('10318','2013-02-09','10:45:00',1.9),('10318','2013-02-09','10:50:00',2.16),('10318','2013-02-09','10:55:00',2.36),('10318','2013-02-09','11:00:00',2.51),('10318','2013-02-09','11:05:00',2.62),('10318','2013-02-09','11:10:00',2.72),('10318','2013-02-09','11:15:00',2.75),('10318','2013-02-09','11:20:00',2.89),('10318','2013-02-09','11:25:00',2.9),('10318','2013-02-09','11:30:00',2.9),('10318','2013-02-09','11:35:00',2.8),('10318','2013-02-09','11:40:00',2.74),('10318','2013-02-09','11:45:00',2.74),('10318','2013-02-09','11:50:00',2.67),('10318','2013-02-09','11:55:00',2.61),('10318','2013-02-09','12:00:00',2.64),('10318','2013-02-09','12:05:00',2.66),('10318','2013-02-09','12:10:00',2.56),('10318','2013-02-09','12:15:00',2.5),('10318','2013-02-09','12:20:00',2.54),('10318','2013-02-09','12:25:00',2.59),('10318','2013-02-09','12:30:00',2.67),('10318','2013-02-09','12:35:00',2.8),('10318','2013-02-09','12:40:00',2.85),('10318','2013-02-09','12:45:00',2.85),('10318','2013-02-09','12:50:00',2.82),('10318','2013-02-09','12:55:00',2.91),('10318','2013-02-09','13:00:00',3.23),('10318','2013-02-09','13:05:00',3.81),('10318','2013-02-09','13:10:00',4.45),('10318','2013-02-09','13:15:00',4.89),('10318','2013-02-09','13:20:00',5.46),('10318','2013-02-09','13:25:00',6.18),('10318','2013-02-09','13:30:00',6.45),('10318','2013-02-09','13:35:00',7),('10318','2013-02-09','13:40:00',6.96),('10318','2013-02-09','13:45:00',7.45),('10318','2013-02-09','13:50:00',7.72),('10318','2013-02-09','13:55:00',7.66),('10318','2013-02-09','14:00:00',6.93),('10318','2013-02-09','14:05:00',6.73),('10318','2013-02-09','14:10:00',4.95),('10318','2013-02-09','14:15:00',6.72),('10318','2013-02-09','14:20:00',7.74),('10318','2013-02-09','14:25:00',7.09),('10318','2013-02-09','14:30:00',6.43),('10318','2013-02-09','14:35:00',5.77),('10318','2013-02-09','14:40:00',5.18),('10318','2013-02-09','14:45:00',4.76),('10318','2013-02-09','14:50:00',5.21),('10318','2013-02-09','14:55:00',4.94),('10318','2013-02-09','15:00:00',4.73),('10318','2013-02-09','15:05:00',4.53),('10318','2013-02-09','15:10:00',4.29),('10318','2013-02-09','15:15:00',4.07),('10318','2013-02-09','15:20:00',4.03),('10318','2013-02-09','15:25:00',3.55),('10318','2013-02-09','15:30:00',3.63),('10318','2013-02-09','15:35:00',3.47),('10318','2013-02-09','15:40:00',2.93),('10318','2013-02-09','15:45:00',2.45),('10318','2013-02-09','15:50:00',1.35),('10318','2013-02-09','16:00:00',1.7),('10318','2013-02-09','16:05:00',1.36),('10318','2013-02-09','16:10:00',1.95),('10318','2013-02-09','16:15:00',2.7),('10318','2013-02-09','16:20:00',2.43),('10318','2013-02-09','16:25:00',2.13),('10318','2013-02-09','16:30:00',1.82),('10318','2013-02-09','16:35:00',1.83),('10318','2013-02-09','16:40:00',1.12),('10318','2013-02-09','16:50:00',1.42),('10318','2013-02-09','16:55:00',1.2),('10318','2013-02-08','08:40:00',1.01),('10318','2013-02-08','08:45:00',1.16),('10318','2013-02-08','08:50:00',1.34),('10318','2013-02-08','08:55:00',1.48),('10318','2013-02-08','09:00:00',1.38),('10318','2013-02-08','09:05:00',1.46),('10318','2013-02-08','09:10:00',1.55),('10318','2013-02-08','09:15:00',1.7),('10318','2013-02-08','09:20:00',2.44),('10318','2013-02-08','09:25:00',2.59),('10318','2013-02-08','09:30:00',3.77),('10318','2013-02-08','09:35:00',5.95),('10318','2013-02-08','09:40:00',6.58),('10318','2013-02-08','09:45:00',7.6),('10318','2013-02-08','09:50:00',8.07),('10318','2013-02-08','09:55:00',7.99),('10318','2013-02-08','10:00:00',8.29),('10318','2013-02-08','10:05:00',8.72),('10318','2013-02-08','10:10:00',3.95),('10318','2013-02-08','10:15:00',3.93),('10318','2013-02-08','10:20:00',6.45),('10318','2013-02-08','10:25:00',8.77),('10318','2013-02-08','10:30:00',5.34),('10318','2013-02-08','10:35:00',5.35),('10318','2013-02-08','10:40:00',8.56),('10318','2013-02-08','10:45:00',8.96),('10318','2013-02-08','10:50:00',9.2),('10318','2013-02-08','10:55:00',8.61),('10318','2013-02-08','11:00:00',7.58),('10318','2013-02-08','11:05:00',8.35),('10318','2013-02-08','11:10:00',8.32),('10318','2013-02-08','11:15:00',8.31),('10318','2013-02-08','11:20:00',8.34),('10318','2013-02-08','11:25:00',8.36),('10318','2013-02-08','11:30:00',8.33),('10318','2013-02-08','11:35:00',8.32),('10318','2013-02-08','11:40:00',8.34),('10318','2013-02-08','11:45:00',8.33),('10318','2013-02-08','11:50:00',8.31),('10318','2013-02-08','11:55:00',8.32),('10318','2013-02-08','12:00:00',8.12),('10318','2013-02-08','12:05:00',8.31),('10318','2013-02-08','12:10:00',8.28),('10318','2013-02-08','12:15:00',8.27),('10318','2013-02-08','12:20:00',8.31),('10318','2013-02-08','12:25:00',8.45),('10318','2013-02-08','12:30:00',8.29),('10318','2013-02-08','12:35:00',8.19),('10318','2013-02-08','12:40:00',6.88),('10318','2013-02-08','12:45:00',4.56),('10318','2013-02-08','12:50:00',6.03),('10318','2013-02-08','12:55:00',7),('10318','2013-02-08','13:00:00',5.32),('10318','2013-02-08','13:05:00',3.66),('10318','2013-02-08','13:10:00',4.03),('10318','2013-02-08','13:15:00',4.08),('10318','2013-02-08','13:20:00',4.27),('10318','2013-02-08','13:25:00',3.86),('10318','2013-02-08','13:30:00',3.64),('10318','2013-02-08','13:35:00',3.91),('10318','2013-02-08','13:40:00',3.84),('10318','2013-02-08','13:45:00',3.03),('10318','2013-02-08','13:50:00',2.96),('10318','2013-02-08','13:55:00',3.12),('10318','2013-02-08','14:00:00',3.07),('10318','2013-02-08','14:05:00',3.07),('10318','2013-02-08','14:10:00',3.02),('10318','2013-02-08','14:15:00',3.32),('10318','2013-02-08','14:20:00',3.81),('10318','2013-02-08','14:25:00',3.96),('10318','2013-02-08','14:30:00',4.47),('10318','2013-02-08','14:35:00',6.51),('10318','2013-02-08','14:40:00',6.86),('10318','2013-02-08','14:45:00',4.26),('10318','2013-02-08','14:50:00',5),('10318','2013-02-08','14:55:00',6.51),('10318','2013-02-08','15:00:00',6.46),('10318','2013-02-08','15:05:00',6.05),('10318','2013-02-08','15:10:00',5.63),('10318','2013-02-08','15:15:00',5.08),('10318','2013-02-08','15:20:00',4.58),('10318','2013-02-08','15:25:00',4.17),('10318','2013-02-08','15:30:00',3.89),('10318','2013-02-08','15:35:00',3.73),('10318','2013-02-08','15:40:00',3.55),('10318','2013-02-08','15:45:00',3.36),('10318','2013-02-08','15:50:00',3.19),('10318','2013-02-08','15:55:00',3.03),('10318','2013-02-08','16:00:00',2.87),('10318','2013-02-08','16:05:00',2.66),('10318','2013-02-08','16:10:00',2.38),('10318','2013-02-08','16:15:00',1.45),('10318','2013-02-07','09:15:00',1.54),('10318','2013-02-07','09:20:00',1.91),('10318','2013-02-07','09:25:00',1.27),('10318','2013-02-07','09:30:00',1.3),('10318','2013-02-07','09:35:00',1.35),('10318','2013-02-07','09:40:00',1.39),('10318','2013-02-07','09:45:00',1.54),('10318','2013-02-07','09:50:00',1.37),('10318','2013-02-07','09:55:00',1.04),('10318','2013-02-07','10:00:00',1.02),('10318','2013-02-07','10:20:00',1.21),('10318','2013-02-07','10:25:00',1.69),('10318','2013-02-07','10:30:00',2.13),('10318','2013-02-07','10:35:00',4.18),('10318','2013-02-07','10:40:00',5.04),('10318','2013-02-07','10:45:00',6.16),('10318','2013-02-07','10:50:00',3.34),('10318','2013-02-07','10:55:00',2.77),('10318','2013-02-07','11:00:00',2.78),('10318','2013-02-07','11:05:00',2.34),('10318','2013-02-07','11:10:00',2.86),('10318','2013-02-07','11:15:00',1.53),('10318','2013-02-07','12:15:00',1.05),('10318','2013-02-07','12:20:00',2.07),('10318','2013-02-07','12:25:00',3.75),('10318','2013-02-07','12:30:00',3.15),('10318','2013-02-07','12:35:00',1.86),('10318','2013-02-07','12:40:00',1.82),('10318','2013-02-07','12:45:00',2.1),('10318','2013-02-07','12:50:00',1.91),('10318','2013-02-07','12:55:00',1.43),('10318','2013-02-07','13:00:00',1.33),('10318','2013-02-07','13:05:00',1.6),('10318','2013-02-07','13:10:00',2.25),('10318','2013-02-07','13:15:00',8.13),('10318','2013-02-07','13:20:00',6.44),('10318','2013-02-07','13:25:00',3.09),('10318','2013-02-07','13:30:00',2.1),('10318','2013-02-07','13:35:00',1.89),('10318','2013-02-07','13:40:00',1.98),('10318','2013-02-07','13:45:00',2.05),('10318','2013-02-07','13:50:00',2.17),('10318','2013-02-07','13:55:00',2.48),('10318','2013-02-07','14:00:00',3.74),('10318','2013-02-07','14:05:00',5.32),('10318','2013-02-07','14:10:00',7.65),('10318','2013-02-07','14:15:00',5.3),('10318','2013-02-07','14:20:00',3.24),('10318','2013-02-07','14:25:00',3.82),('10318','2013-02-07','14:30:00',1.94),('10318','2013-02-07','14:35:00',1.82),('10318','2013-02-07','14:40:00',2.14),('10318','2013-02-07','14:45:00',1.73),('10318','2013-02-07','14:50:00',1.36),('10318','2013-02-07','14:55:00',1.97),('10318','2013-02-07','15:00:00',3.59),('10318','2013-02-07','15:05:00',3.14),('10318','2013-02-07','15:10:00',2.7),('10318','2013-02-07','15:15:00',2.22),('10318','2013-02-07','15:20:00',1.8),('10318','2013-02-07','15:25:00',1.45),('10318','2013-02-07','15:30:00',1.37),('10318','2013-02-07','15:35:00',1.62),('10318','2013-02-07','15:40:00',2.32),('10318','2013-02-07','15:45:00',2.24),('10318','2013-02-07','15:50:00',3.02),('10318','2013-02-07','15:55:00',1.8),('10318','2013-02-06','07:50:00',1.03),('10318','2013-02-06','07:55:00',1.14),('10318','2013-02-06','08:10:00',1.11),('10318','2013-02-06','08:15:00',1.1),('10318','2013-02-06','08:20:00',1.18),('10318','2013-02-06','08:25:00',1.23),('10318','2013-02-06','08:30:00',1.46),('10318','2013-02-06','08:35:00',1.87),('10318','2013-02-06','08:40:00',2.5),('10318','2013-02-06','08:45:00',2.75),('10318','2013-02-06','08:50:00',3.66),('10318','2013-02-06','08:55:00',2.25),('10318','2013-02-06','09:00:00',3.79),('10318','2013-02-06','09:05:00',3.17),('10318','2013-02-06','09:10:00',3.45),('10318','2013-02-06','09:15:00',2.39),('10318','2013-02-06','09:20:00',2.51),('10318','2013-02-06','09:25:00',3.16),('10318','2013-02-06','09:30:00',4.22),('10318','2013-02-06','09:35:00',3.17),('10318','2013-02-06','09:40:00',3.17),('10318','2013-02-06','09:45:00',3.34),('10318','2013-02-06','09:50:00',3.15),('10318','2013-02-06','09:55:00',3.91),('10318','2013-02-06','10:00:00',3.01),('10318','2013-02-06','10:05:00',4.35),('10318','2013-02-06','10:10:00',3),('10318','2013-02-06','10:15:00',3.42),('10318','2013-02-06','10:20:00',4.13),('10318','2013-02-06','10:25:00',3.63),('10318','2013-02-06','10:30:00',3.55),('10318','2013-02-06','10:35:00',4.18),('10318','2013-02-06','10:40:00',2.52),('10318','2013-02-06','10:45:00',2.47),('10318','2013-02-06','10:50:00',3.59),('10318','2013-02-06','10:55:00',4.48),('10318','2013-02-06','11:00:00',3.52),('10318','2013-02-06','11:05:00',3.46),('10318','2013-02-06','11:10:00',3.56),('10318','2013-02-06','11:15:00',3.53),('10318','2013-02-06','11:20:00',6.26),('10318','2013-02-06','11:25:00',5.22),('10318','2013-02-06','11:30:00',3.07),('10318','2013-02-06','11:35:00',3.26),('10318','2013-02-06','11:40:00',3.75),('10318','2013-02-06','11:45:00',3.88),('10318','2013-02-06','11:50:00',3.82),('10318','2013-02-06','11:55:00',3.33),('10318','2013-02-06','12:00:00',2.56),('10318','2013-02-06','12:05:00',1.59),('10318','2013-02-06','12:10:00',2.63),('10318','2013-02-06','12:15:00',2.79),('10318','2013-02-06','12:20:00',2.45),('10318','2013-02-06','12:25:00',2.18),('10318','2013-02-06','12:30:00',1.86),('10318','2013-02-06','12:35:00',1.71),('10318','2013-02-06','12:40:00',1.62),('10318','2013-02-06','12:45:00',1.64),('10318','2013-02-06','12:50:00',1.53),('10318','2013-02-06','12:55:00',1.52),('10318','2013-02-06','13:00:00',1.35),('10318','2013-02-06','13:05:00',1.53),('10318','2013-02-06','13:10:00',1.64),('10318','2013-02-06','13:15:00',2.04),('10318','2013-02-06','13:20:00',2.34),('10318','2013-02-06','13:25:00',2.85),('10318','2013-02-06','13:30:00',3.26),('10318','2013-02-06','13:35:00',4.16),('10318','2013-02-06','13:40:00',2.71),('10318','2013-02-06','13:45:00',3.22),('10318','2013-02-06','13:50:00',4.14),('10318','2013-02-06','13:55:00',2.9),('10318','2013-02-06','14:00:00',2.84),('10318','2013-02-06','14:05:00',3.74),('10318','2013-02-06','14:10:00',1.35),('10318','2013-02-06','14:25:00',1.53),('10318','2013-02-06','14:30:00',4.5),('10318','2013-02-06','14:35:00',4.26),('10318','2013-02-06','14:40:00',2.55),('10318','2013-02-06','14:45:00',1.08),('10318','2013-02-06','15:15:00',1.15),('10318','2013-02-06','15:20:00',1.31),('10318','2013-02-06','15:25:00',1.95),('10318','2013-02-06','15:45:00',1.65),('10318','2013-02-06','15:50:00',1.59),('10318','2013-02-06','15:55:00',1.01),('10318','2013-02-06','16:00:00',1.04),('10318','2013-02-06','16:05:00',1.01),('10318','2013-02-05','07:50:00',1.06),('10318','2013-02-05','07:55:00',1.33),('10318','2013-02-05','08:00:00',1.53),('10318','2013-02-05','08:05:00',2.02),('10318','2013-02-05','08:10:00',2.4),('10318','2013-02-05','08:15:00',2.68),('10318','2013-02-05','08:20:00',3.06),('10318','2013-02-05','08:25:00',3.48),('10318','2013-02-05','08:30:00',3.72),('10318','2013-02-05','08:35:00',3.91),('10318','2013-02-05','08:40:00',4.12),('10318','2013-02-05','08:45:00',4.31),('10318','2013-02-05','08:50:00',4.47),('10318','2013-02-05','08:55:00',4.68),('10318','2013-02-05','09:00:00',4.83),('10318','2013-02-05','09:05:00',5.06),('10318','2013-02-05','09:10:00',5.26),('10318','2013-02-05','09:15:00',5.45),('10318','2013-02-05','09:20:00',5.52),('10318','2013-02-05','09:25:00',5.74),('10318','2013-02-05','09:30:00',5.86),('10318','2013-02-05','09:35:00',6),('10318','2013-02-05','09:40:00',6.11),('10318','2013-02-05','09:45:00',6.22),('10318','2013-02-05','09:50:00',6.35),('10318','2013-02-05','09:55:00',6.48),('10318','2013-02-05','10:00:00',6.51),('10318','2013-02-05','10:05:00',6.25),('10318','2013-02-05','10:10:00',6.33),('10318','2013-02-05','10:15:00',6.42),('10318','2013-02-05','10:20:00',6.96),('10318','2013-02-05','10:25:00',6.98),('10318','2013-02-05','10:30:00',7.06),('10318','2013-02-05','10:35:00',7.07),('10318','2013-02-05','10:40:00',7.19),('10318','2013-02-05','10:45:00',7.28),('10318','2013-02-05','10:50:00',7.29),('10318','2013-02-05','10:55:00',7.33),('10318','2013-02-05','11:00:00',7.33),('10318','2013-02-05','11:05:00',7.09),('10318','2013-02-05','11:10:00',7.43),('10318','2013-02-05','11:15:00',7.41),('10318','2013-02-05','11:20:00',7.42),('10318','2013-02-05','11:25:00',7.43),('10318','2013-02-05','11:30:00',7.24),('10318','2013-02-05','11:35:00',5.34),('10318','2013-02-05','11:40:00',4.11),('10318','2013-02-05','11:45:00',4.14),('10318','2013-02-05','11:50:00',3.7),('10318','2013-02-05','11:55:00',4.77),('10318','2013-02-05','12:00:00',3.59),('10318','2013-02-05','12:05:00',2.81),('10318','2013-02-05','12:10:00',3.2),('10318','2013-02-05','12:15:00',3.03),('10318','2013-02-05','12:20:00',2.77),('10318','2013-02-05','12:25:00',2.75),('10318','2013-02-05','12:30:00',4.7),('10318','2013-02-05','12:35:00',4.46),('10318','2013-02-05','12:40:00',3.61),('10318','2013-02-05','12:45:00',4.37),('10318','2013-02-05','12:50:00',3.14),('10318','2013-02-05','12:55:00',1.89),('10318','2013-02-05','13:00:00',1.38),('10318','2013-02-05','13:05:00',2.2),('10318','2013-02-05','13:10:00',2.99),('10318','2013-02-05','13:15:00',4.27),('10318','2013-02-05','13:20:00',3.67),('10318','2013-02-05','13:25:00',3.48),('10318','2013-02-05','13:30:00',2.62),('10318','2013-02-05','13:35:00',2.38),('10318','2013-02-05','13:40:00',2.79),('10318','2013-02-05','13:45:00',3.37),('10318','2013-02-05','13:50:00',3.33),('10318','2013-02-05','13:55:00',2.97),('10318','2013-02-05','14:00:00',3.02),('10318','2013-02-05','14:05:00',2.78),('10318','2013-02-05','14:10:00',2.47),('10318','2013-02-05','14:15:00',2.88),('10318','2013-02-05','14:20:00',3.59),('10318','2013-02-05','14:25:00',4.15),('10318','2013-02-05','14:30:00',4.26),('10318','2013-02-05','14:35:00',3.85),('10318','2013-02-05','14:40:00',2.72),('10318','2013-02-05','14:45:00',2.3),('10318','2013-02-05','14:50:00',2.1),('10318','2013-02-05','14:55:00',1.9),('10318','2013-02-05','15:00:00',2.09),('10318','2013-02-05','15:05:00',2.25),('10318','2013-02-05','15:10:00',1.76),('10318','2013-02-05','15:15:00',1.81),('10318','2013-02-04','07:50:00',1.13),('10318','2013-02-04','07:55:00',1.32),('10318','2013-02-04','08:00:00',1.53),('10318','2013-02-04','08:05:00',1.86),('10318','2013-02-04','08:10:00',2.48),('10318','2013-02-04','08:15:00',2.8),('10318','2013-02-04','08:20:00',3.17),('10318','2013-02-04','08:25:00',3.62),('10318','2013-02-04','08:30:00',3.87),('10318','2013-02-04','08:35:00',4.14),('10318','2013-02-04','08:40:00',4.32),('10318','2013-02-04','08:45:00',4.52),('10318','2013-02-04','08:50:00',4.73),('10318','2013-02-04','08:55:00',4.59),('10318','2013-02-04','09:00:00',5.2),('10318','2013-02-04','09:05:00',5.37),('10318','2013-02-04','09:10:00',5.71),('10318','2013-02-04','09:15:00',5.77),('10318','2013-02-04','09:20:00',5.07),('10318','2013-02-04','09:25:00',5.71),('10318','2013-02-04','09:30:00',5.98),('10318','2013-02-04','09:35:00',6.14),('10318','2013-02-04','09:40:00',6.34),('10318','2013-02-04','09:45:00',6.31),('10318','2013-02-04','09:50:00',6.9),('10318','2013-02-04','09:55:00',7.05),('10318','2013-02-04','10:00:00',7.14),('10318','2013-02-04','10:05:00',7.26),('10318','2013-02-04','10:10:00',7.35),('10318','2013-02-04','10:15:00',7.39),('10318','2013-02-04','10:20:00',6.78),('10318','2013-02-04','10:25:00',7.49),('10318','2013-02-04','10:30:00',6.64),('10318','2013-02-04','10:35:00',6.89),('10318','2013-02-04','10:40:00',7.22),('10318','2013-02-04','10:45:00',7.7),('10318','2013-02-04','10:50:00',7.65),('10318','2013-02-04','10:55:00',7.89),('10318','2013-02-04','11:00:00',7.76),('10318','2013-02-04','11:05:00',7.99),('10318','2013-02-04','11:10:00',7.99),('10318','2013-02-04','11:15:00',7.98),('10318','2013-02-04','11:20:00',8.02),('10318','2013-02-04','11:25:00',7.95),('10318','2013-02-04','11:30:00',8),('10318','2013-02-04','11:35:00',8.02),('10318','2013-02-04','11:40:00',8.06),('10318','2013-02-04','11:45:00',8.02),('10318','2013-02-04','11:50:00',8),('10318','2013-02-04','11:55:00',7.98),('10318','2013-02-04','12:00:00',7.98),('10318','2013-02-04','12:05:00',7.98),('10318','2013-02-04','12:10:00',7.95),('10318','2013-02-04','12:15:00',8.02),('10318','2013-02-04','12:20:00',7.95),('10318','2013-02-04','12:25:00',7.91),('10318','2013-02-04','12:30:00',7.85),('10318','2013-02-04','12:35:00',7.8),('10318','2013-02-04','12:40:00',7.6),('10318','2013-02-04','12:45:00',7.64),('10318','2013-02-04','12:50:00',7.57),('10318','2013-02-04','12:55:00',7.53),('10318','2013-02-04','13:00:00',7.47),('10318','2013-02-04','13:05:00',7.46),('10318','2013-02-04','13:10:00',7.37),('10318','2013-02-04','13:15:00',7.28),('10318','2013-02-04','13:20:00',7.17),('10318','2013-02-04','13:25:00',7.1),('10318','2013-02-04','13:30:00',6.99),('10318','2013-02-04','13:35:00',6.93),('10318','2013-02-04','13:40:00',6.79),('10318','2013-02-04','13:45:00',6.68),('10318','2013-02-04','13:50:00',6.51),('10318','2013-02-04','13:55:00',6.45),('10318','2013-02-04','14:00:00',6.35),('10318','2013-02-04','14:05:00',6.24),('10318','2013-02-04','14:10:00',6.12),('10318','2013-02-04','14:15:00',5.97),('10318','2013-02-04','14:20:00',5.8),('10318','2013-02-04','14:25:00',5.56),('10318','2013-02-04','14:30:00',5.51),('10318','2013-02-04','14:35:00',5.36),('10318','2013-02-04','14:40:00',5.2),('10318','2013-02-04','14:45:00',5.01),('10318','2013-02-04','14:50:00',4.88),('10318','2013-02-04','14:55:00',4.72),('10318','2013-02-04','15:00:00',4.55),('10318','2013-02-04','15:05:00',4.37),('10318','2013-02-04','15:10:00',4.21),('10318','2013-02-04','15:15:00',4.08),('10318','2013-02-04','15:20:00',3.91),('10318','2013-02-04','15:25:00',3.74),('10318','2013-02-04','15:30:00',3.57),('10318','2013-02-04','15:35:00',3.42),('10318','2013-02-04','15:40:00',3.2),('10318','2013-02-04','15:45:00',3.12),('10318','2013-02-04','15:50:00',2.97),('10318','2013-02-04','15:55:00',2.82),('10318','2013-02-04','16:00:00',2.64),('10318','2013-02-04','16:05:00',2.47),('10318','2013-02-04','16:10:00',2.27),('10318','2013-02-04','16:15:00',2.09),('10318','2013-02-04','16:20:00',1.88),('10318','2013-02-04','16:25:00',1.71),('10318','2013-02-04','16:30:00',1.54),('10318','2013-02-04','16:35:00',1.42),('10318','2013-02-04','16:40:00',1.21),('10318','2013-02-04','16:45:00',1.04),('10318','2013-02-03','08:40:00',1.43),('10318','2013-02-03','08:45:00',2.16),('10318','2013-02-03','08:50:00',1.44),('10318','2013-02-03','08:55:00',1.06),('10318','2013-02-03','09:05:00',1.04),('10318','2013-02-03','09:10:00',1.28),('10318','2013-02-03','09:15:00',2.36),('10318','2013-02-03','09:20:00',2.89),('10318','2013-02-03','09:25:00',5.36),('10318','2013-02-03','09:30:00',2.01),('10318','2013-02-03','09:35:00',1.74),('10318','2013-02-03','09:40:00',2.33),('10318','2013-02-03','09:45:00',4.28),('10318','2013-02-03','09:50:00',3.41),('10318','2013-02-03','09:55:00',2.42),('10318','2013-02-03','10:00:00',2.69),('10318','2013-02-03','10:20:00',1.01),('10318','2013-02-03','11:15:00',1.81),('10318','2013-02-03','11:20:00',3.55),('10318','2013-02-03','11:25:00',2.38),('10318','2013-02-03','11:30:00',2.16),('10318','2013-02-03','11:35:00',1.31),('10318','2013-02-03','11:40:00',2.02),('10318','2013-02-03','11:45:00',3.68),('10318','2013-02-03','11:50:00',5.43),('10318','2013-02-03','11:55:00',3.41),('10318','2013-02-03','12:00:00',3.47),('10318','2013-02-03','12:05:00',3.42),('10318','2013-02-03','12:10:00',3.39),('10318','2013-02-03','12:15:00',1.3),('10318','2013-02-03','14:00:00',1.11),('10318','2013-02-03','14:50:00',1.17),('10318','2013-02-03','14:55:00',1.3),('10318','2013-02-03','15:00:00',1.05),('10318','2013-02-02','08:15:00',1.27),('10318','2013-02-02','09:50:00',1.3),('10318','2013-02-02','09:55:00',1.08),('10318','2013-02-02','10:00:00',1.1),('10318','2013-02-02','10:05:00',1.52),('10318','2013-02-02','10:10:00',1.87),('10318','2013-02-02','10:15:00',2.81),('10318','2013-02-02','10:20:00',3.25),('10318','2013-02-02','10:25:00',2.88),('10318','2013-02-02','10:30:00',2.87),('10318','2013-02-02','10:35:00',3.41),('10318','2013-02-02','10:40:00',3.75),('10318','2013-02-02','10:45:00',4.54),('10318','2013-02-02','10:50:00',4.23),('10318','2013-02-02','10:55:00',5.12),('10318','2013-02-02','11:00:00',5.12),('10318','2013-02-02','11:05:00',4.42),('10318','2013-02-02','11:10:00',5.11),('10318','2013-02-02','11:15:00',4.27),('10318','2013-02-02','11:20:00',4.36),('10318','2013-02-02','11:25:00',5.13),('10318','2013-02-02','11:30:00',4.76),('10318','2013-02-02','11:35:00',4.4),('10318','2013-02-02','11:40:00',4.07),('10318','2013-02-02','11:45:00',3.01),('10318','2013-02-02','11:50:00',2.78),('10318','2013-02-02','11:55:00',1.96),('10318','2013-02-02','12:00:00',1.38),('10318','2013-02-02','12:05:00',1.46),('10318','2013-02-02','12:10:00',1.24),('10318','2013-02-02','12:15:00',1.03),('10318','2013-02-02','12:20:00',1),('10318','2013-02-02','12:25:00',1.01),('10318','2013-02-02','12:35:00',1.27),('10318','2013-02-02','12:40:00',1.33),('10318','2013-02-02','12:45:00',1.35),('10318','2013-02-02','12:50:00',4.47),('10318','2013-02-02','12:55:00',5.56),('10318','2013-02-02','13:00:00',5.64),('10318','2013-02-02','13:05:00',5.46),('10318','2013-02-02','13:10:00',5.82),('10318','2013-02-02','13:15:00',4.5),('10318','2013-02-02','13:20:00',5.19),('10318','2013-02-02','13:25:00',4.3),('10318','2013-02-02','13:30:00',4.06),('10318','2013-02-02','13:35:00',4.7),('10318','2013-02-02','13:40:00',4.65),('10318','2013-02-02','13:45:00',3.37),('10318','2013-02-02','13:50:00',2.6),('10318','2013-02-02','13:55:00',1.75),('10318','2013-02-02','14:00:00',1.54),('10318','2013-02-02','14:05:00',1.24),('10318','2013-02-01','08:10:00',1.72),('10318','2013-02-01','08:15:00',2.19),('10318','2013-02-01','08:20:00',2.26),('10318','2013-02-01','08:25:00',2.44),('10318','2013-02-01','08:30:00',2.94),('10318','2013-02-01','08:35:00',3.15),('10318','2013-02-01','08:40:00',3.23),('10318','2013-02-01','08:45:00',3.49),('10318','2013-02-01','08:50:00',3.2),('10318','2013-02-01','08:55:00',3.64),('10318','2013-02-01','09:00:00',4.28),('10318','2013-02-01','09:05:00',3.05),('10318','2013-02-01','09:10:00',2.06),('10318','2013-02-01','09:15:00',3.36),('10318','2013-02-01','09:20:00',4.8),('10318','2013-02-01','09:25:00',4.42),('10318','2013-02-01','09:30:00',2.45),('10318','2013-02-01','09:35:00',2.59),('10318','2013-02-01','09:40:00',4.56),('10318','2013-02-01','09:45:00',2.23),('10318','2013-02-01','09:50:00',3.85),('10318','2013-02-01','09:55:00',2.44),('10318','2013-02-01','10:00:00',4.21),('10318','2013-02-01','10:05:00',4.24),('10318','2013-02-01','10:10:00',4.73),('10318','2013-02-01','10:15:00',4.82),('10318','2013-02-01','10:20:00',1.46),('10318','2013-02-01','10:25:00',2.03),('10318','2013-02-01','10:30:00',2.44),('10318','2013-02-01','10:35:00',1.41),('10318','2013-02-01','10:40:00',1.52),('10318','2013-02-01','10:45:00',2.07),('10318','2013-02-01','10:50:00',3.06),('10318','2013-02-01','10:55:00',5.07),('10318','2013-02-01','11:00:00',8.3),('10318','2013-02-01','11:05:00',3.86),('10318','2013-02-01','11:10:00',4.85),('10318','2013-02-01','11:15:00',1.27),('10318','2013-02-01','11:20:00',1.11),('10318','2013-02-01','11:25:00',1.87),('10318','2013-02-01','11:30:00',2.67),('10318','2013-02-01','11:35:00',2.61),('10318','2013-02-01','11:40:00',3.66),('10318','2013-02-01','11:45:00',3.58),('10318','2013-02-01','11:50:00',4.11),('10318','2013-02-01','11:55:00',2.7),('10318','2013-02-01','12:00:00',3.17),('10318','2013-02-01','12:05:00',6.93),('10318','2013-02-01','12:10:00',9.16),('10318','2013-02-01','12:15:00',8.63),('10318','2013-02-01','12:20:00',8.11),('10318','2013-02-01','12:25:00',8.05),('10318','2013-02-01','12:30:00',6.06),('10318','2013-02-01','12:35:00',2.92),('10318','2013-02-01','12:40:00',5.91),('10318','2013-02-01','12:45:00',8.11),('10318','2013-02-01','12:50:00',6.88),('10318','2013-02-01','12:55:00',1.88),('10318','2013-02-01','13:00:00',7.81),('10318','2013-02-01','13:05:00',7.5),('10318','2013-02-01','13:10:00',7.08),('10318','2013-02-01','13:15:00',6.96),('10318','2013-02-01','13:20:00',4.87),('10318','2013-02-01','13:25:00',3.95),('10318','2013-02-01','13:30:00',3.27),('10318','2013-02-01','13:35:00',2.58),('10318','2013-02-01','13:40:00',2.8),('10318','2013-02-01','13:45:00',2.83),('10318','2013-02-01','13:50:00',3.6),('10318','2013-02-01','13:55:00',6.78),('10318','2013-02-01','14:00:00',7.11),('10318','2013-02-01','14:05:00',4.73),('10318','2013-02-01','14:10:00',5.88),('10318','2013-02-01','14:15:00',6.04),('10318','2013-02-01','14:20:00',5.33),('10318','2013-02-01','14:25:00',5.33),('10318','2013-02-01','14:30:00',5.32),('10318','2013-02-01','14:35:00',3.28),('10318','2013-02-01','14:40:00',3.59),('10318','2013-02-01','14:45:00',4.27),('10318','2013-02-01','14:50:00',5.12),('10318','2013-02-01','14:55:00',3.45),('10318','2013-02-01','15:00:00',2.63),('10318','2013-02-01','15:05:00',2.6),('10318','2013-02-01','15:10:00',2.09),('10318','2013-02-01','15:15:00',3.29),('10318','2013-02-01','15:20:00',2.91),('10318','2013-02-01','15:25:00',2.55),('10318','2013-02-01','15:30:00',1.59),('10318','2013-02-01','15:35:00',2.66),('10318','2013-02-01','15:40:00',2.13),('10318','2013-02-01','15:45:00',1.13),('10318','2013-02-01','15:50:00',2.44),('10318','2013-02-01','15:55:00',1.17),('10318','2014-03-21','07:00:00',1.02),('10318','2014-03-21','07:05:00',1.09),('10318','2014-03-21','07:10:00',1.14),('10318','2014-03-21','07:15:00',1.31),('10318','2014-03-21','07:20:00',1.9),('10318','2014-03-21','07:25:00',2.27),('10318','2014-03-21','07:30:00',2.19),('10318','2014-03-21','07:35:00',2.85),('10318','2014-03-21','07:40:00',3.18),('10318','2014-03-21','07:45:00',3.47),('10318','2014-03-21','07:50:00',3.84),('10318','2014-03-21','07:55:00',4.12),('10318','2014-03-21','08:00:00',4.21),('10318','2014-03-21','08:05:00',4.45),('10318','2014-03-21','08:10:00',4.64),('10318','2014-03-21','08:15:00',4.8),('10318','2014-03-21','08:20:00',4.89),('10318','2014-03-21','08:25:00',5.15),('10318','2014-03-21','08:30:00',5.44),('10318','2014-03-21','08:35:00',5.7),('10318','2014-03-21','08:40:00',5.86),('10318','2014-03-21','08:45:00',5.97),('10318','2014-03-21','08:50:00',6.13),('10318','2014-03-21','08:55:00',6.31),('10318','2014-03-21','09:00:00',6.46),('10318','2014-03-21','09:05:00',6.61),('10318','2014-03-21','09:10:00',6.82),('10318','2014-03-21','09:15:00',6.96),('10318','2014-03-21','09:20:00',7.15),('10318','2014-03-21','09:25:00',6.95),('10318','2014-03-21','09:30:00',7.19),('10318','2014-03-21','09:35:00',7.27),('10318','2014-03-21','09:40:00',7.56),('10318','2014-03-21','09:45:00',7.46),('10318','2014-03-21','09:50:00',7.71),('10318','2014-03-21','09:55:00',7.69),('10318','2014-03-21','10:00:00',7.8),('10318','2014-03-21','10:05:00',8),('10318','2014-03-21','10:10:00',7.91),('10318','2014-03-21','10:15:00',8.03),('10318','2014-03-21','10:20:00',8.06),('10318','2014-03-21','10:25:00',8.15),('10318','2014-03-21','10:30:00',8.25),('10318','2014-03-21','10:35:00',8.35),('10318','2014-03-21','10:40:00',8.2),('10318','2014-03-21','10:45:00',8.23),('10318','2014-03-21','10:50:00',8.26),('10318','2014-03-21','10:55:00',8.12),('10318','2014-03-21','11:00:00',8.26),('10318','2014-03-21','11:05:00',8.17),('10318','2014-03-21','11:10:00',7.75),('10318','2014-03-21','11:15:00',6.55),('10318','2014-03-21','11:20:00',8.46),('10318','2014-03-21','11:25:00',8.3),('10318','2014-03-21','11:30:00',8.38),('10318','2014-03-21','11:35:00',8.61),('10318','2014-03-21','11:40:00',8.48),('10318','2014-03-21','11:45:00',8.44),('10318','2014-03-21','11:50:00',8.63),('10318','2014-03-21','11:55:00',8.46),('10318','2014-03-21','12:00:00',8.4),('10318','2014-03-21','12:05:00',7.93),('10318','2014-03-21','12:10:00',8.73),('10318','2014-03-21','12:15:00',8.58),('10318','2014-03-21','12:20:00',8.62),('10318','2014-03-21','12:25:00',8.6),('10318','2014-03-21','12:30:00',8.63),('10318','2014-03-21','12:35:00',8.68),('10318','2014-03-21','12:40:00',8.57),('10318','2014-03-21','12:45:00',8.31),('10318','2014-03-21','12:50:00',8.43),('10318','2014-03-21','12:55:00',8.36),('10318','2014-03-21','13:00:00',8.33),('10318','2014-03-21','13:05:00',8.32),('10318','2014-03-21','13:10:00',8.3),('10318','2014-03-21','13:15:00',8.22),('10318','2014-03-21','13:20:00',8.13),('10318','2014-03-21','13:25:00',8.16),('10318','2014-03-21','13:30:00',8.05),('10318','2014-03-21','13:35:00',7.95),('10318','2014-03-21','13:40:00',7.87),('10318','2014-03-21','13:45:00',7.84),('10318','2014-03-21','13:50:00',7.78),('10318','2014-03-21','13:55:00',7.66),('10318','2014-03-21','14:00:00',7.58),('10318','2014-03-21','14:05:00',7.48),('10318','2014-03-21','14:10:00',7.39),('10318','2014-03-21','14:15:00',7.26),('10318','2014-03-21','14:20:00',7.14),('10318','2014-03-21','14:25:00',7),('10318','2014-03-21','14:30:00',6.63),('10318','2014-03-21','14:35:00',6.44),('10318','2014-03-21','14:40:00',6.28),('10318','2014-03-21','14:45:00',5.59),('10318','2014-03-21','14:50:00',2.73),('10318','2014-03-21','14:55:00',1.78),('10318','2014-03-21','15:00:00',2.98),('10318','2014-03-21','15:05:00',4.3),('10318','2014-03-21','15:10:00',5.83),('10318','2014-03-21','15:15:00',6.24),('10318','2014-03-21','15:20:00',3.73),('10318','2014-03-21','15:25:00',5.8),('10318','2014-03-21','15:30:00',5.73),('10318','2014-03-21','15:35:00',5.02),('10318','2014-03-21','15:40:00',5.1),('10318','2014-03-21','15:45:00',5.07),('10318','2014-03-21','15:50:00',5.07),('10318','2014-03-21','15:55:00',4.87),('10318','2014-03-21','16:00:00',4.53),('10318','2014-03-21','16:05:00',4.08),('10318','2014-03-21','16:10:00',3.78),('10318','2014-03-21','16:15:00',3.42),('10318','2014-03-21','16:20:00',3.1),('10318','2014-03-21','16:25:00',2.86),('10318','2014-03-21','16:30:00',2.61),('10318','2014-03-21','16:35:00',2.42),('10318','2014-03-21','16:40:00',2.26),('10318','2014-03-21','16:45:00',2.08),('10318','2014-03-21','16:50:00',1.91),('10318','2014-03-21','16:55:00',1.74),('10318','2014-03-21','17:00:00',1.44),('10318','2014-03-21','17:05:00',1.33),('10318','2014-03-21','17:10:00',1.18),('10318','2013-01-31','08:55:00',1.19),('10318','2013-01-31','09:00:00',1.71),('10318','2013-01-31','09:05:00',1.47),('10318','2013-01-31','09:10:00',1.4),('10318','2013-01-31','09:15:00',1.8),('10318','2013-01-31','09:20:00',1.91),('10318','2013-01-31','09:25:00',2.93),('10318','2013-01-31','09:30:00',2.21),('10318','2013-01-31','09:35:00',5.05),('10318','2013-01-31','09:40:00',5.82),('10318','2013-01-31','09:45:00',5.64),('10318','2013-01-31','09:50:00',6.11),('10318','2013-01-31','09:55:00',6.02),('10318','2013-01-31','10:00:00',6.95),('10318','2013-01-31','10:05:00',6.35),('10318','2013-01-31','10:10:00',4.53),('10318','2013-01-31','10:15:00',5.72),('10318','2013-01-31','10:20:00',6.38),('10318','2013-01-31','10:25:00',7.21),('10318','2013-01-31','10:30:00',7.46),('10318','2013-01-31','10:35:00',7.7),('10318','2013-01-31','10:40:00',5.61),('10318','2013-01-31','10:45:00',7.03),('10318','2013-01-31','10:50:00',2.47),('10318','2013-01-31','10:55:00',1.64),('10318','2013-01-31','11:00:00',1.29),('10318','2013-01-31','11:05:00',1.17),('10318','2013-01-31','11:10:00',7.14),('10318','2013-01-31','11:15:00',7.98),('10318','2013-01-31','11:20:00',8.25),('10318','2013-01-31','11:25:00',8.4),('10318','2013-01-31','11:30:00',8.02),('10318','2013-01-31','11:35:00',7.64),('10318','2013-01-31','11:40:00',7.49),('10318','2013-01-31','11:45:00',7.52),('10318','2013-01-31','11:50:00',7.5),('10318','2013-01-31','11:55:00',7.46),('10318','2013-01-31','12:00:00',7.4),('10318','2013-01-31','12:05:00',7.36),('10318','2013-01-31','12:10:00',7.31),('10318','2013-01-31','12:15:00',7.12),('10318','2013-01-31','12:20:00',7.23),('10318','2013-01-31','12:25:00',7.26),('10318','2013-01-31','12:30:00',7.13),('10318','2013-01-31','12:35:00',7.19),('10318','2013-01-31','12:40:00',7.05),('10318','2013-01-31','12:45:00',7),('10318','2013-01-31','12:50:00',6.9),('10318','2013-01-31','12:55:00',6.93),('10318','2013-01-31','13:00:00',6.78),('10318','2013-01-31','13:05:00',6.58),('10318','2013-01-31','13:10:00',6.64),('10318','2013-01-31','13:15:00',6.52),('10318','2013-01-31','13:20:00',6.52),('10318','2013-01-31','13:25:00',6.38),('10318','2013-01-31','13:30:00',6.28),('10318','2013-01-31','13:35:00',6.13),('10318','2013-01-31','13:40:00',6.07),('10318','2013-01-31','13:45:00',5.95),('10318','2013-01-31','13:50:00',5.76),('10318','2013-01-31','13:55:00',5.69),('10318','2013-01-31','14:00:00',5.52),('10318','2013-01-31','14:05:00',5.52),('10318','2013-01-31','14:10:00',5.41),('10318','2013-01-31','14:15:00',5.2),('10318','2013-01-31','14:20:00',5.06),('10318','2013-01-31','14:25:00',4.89),('10318','2013-01-31','14:30:00',4.83),('10318','2013-01-31','14:35:00',4.59),('10318','2013-01-31','14:40:00',4.48),('10318','2013-01-31','14:45:00',4.42),('10318','2013-01-31','14:50:00',4.22),('10318','2013-01-31','14:55:00',4.09),('10318','2013-01-31','15:00:00',4),('10318','2013-01-31','15:05:00',3.89),('10318','2013-01-31','15:10:00',3.73),('10318','2013-01-31','15:15:00',3.58),('10318','2013-01-31','15:20:00',3.45),('10318','2013-01-31','15:25:00',3.07),('10318','2013-01-31','15:30:00',2.96),('10318','2013-01-31','15:35:00',3.13),('10318','2013-01-31','15:40:00',2.95),('10318','2013-01-31','15:45:00',2.58),('10318','2013-01-31','15:50:00',2.57),('10318','2013-01-31','15:55:00',2.41),('10318','2013-01-31','16:00:00',1.88),('10318','2013-01-31','16:05:00',1.7),('10318','2013-01-31','16:10:00',1.88),('10318','2013-01-31','16:15:00',1.56),('10318','2013-01-31','16:20:00',1.51),('10318','2013-01-31','16:25:00',1.32),('10318','2013-01-31','16:30:00',1.3),('10318','2013-01-31','16:35:00',1.13),('10318','2013-01-30','08:55:00',1.1),('10318','2013-01-30','09:00:00',1.42),('10318','2013-01-30','09:05:00',1.6),('10318','2013-01-30','09:10:00',1.25),('10318','2013-01-30','09:15:00',2.07),('10318','2013-01-30','09:20:00',1.77),('10318','2013-01-30','09:25:00',1.65),('10318','2013-01-30','09:30:00',2.48),('10318','2013-01-30','09:35:00',1.47),('10318','2013-01-30','09:40:00',1.61),('10318','2013-01-30','09:45:00',1.66),('10318','2013-01-30','09:55:00',1.78),('10318','2013-01-30','10:00:00',3.14),('10318','2013-01-30','10:05:00',2.42),('10318','2013-01-30','10:10:00',2.63),('10318','2013-01-30','10:15:00',3.87),('10318','2013-01-30','10:20:00',4.83),('10318','2013-01-30','10:25:00',3.03),('10318','2013-01-30','10:30:00',3.33),('10318','2013-01-30','10:35:00',4.21),('10318','2013-01-30','10:40:00',5.83),('10318','2013-01-30','10:45:00',6.74),('10318','2013-01-30','10:50:00',7.56),('10318','2013-01-30','10:55:00',7.22),('10318','2013-01-30','11:00:00',6.82),('10318','2013-01-30','11:05:00',6.69),('10318','2013-01-30','11:10:00',6.94),('10318','2013-01-30','11:15:00',7.15),('10318','2013-01-30','11:20:00',7.35),('10318','2013-01-30','11:25:00',7.29),('10318','2013-01-30','11:30:00',5.36),('10318','2013-01-30','11:35:00',7.25),('10318','2013-01-30','11:40:00',5.75),('10318','2013-01-30','11:45:00',5.3),('10318','2013-01-30','11:50:00',3.2),('10318','2013-01-30','11:55:00',2.74),('10318','2013-01-30','12:00:00',5.96),('10318','2013-01-30','12:05:00',6.54),('10318','2013-01-30','12:10:00',5.41),('10318','2013-01-30','12:15:00',6.22),('10318','2013-01-30','12:20:00',7.16),('10318','2013-01-30','12:25:00',8.81),('10318','2013-01-30','12:30:00',8.5),('10318','2013-01-30','12:35:00',7.3),('10318','2013-01-30','12:40:00',3.75),('10318','2013-01-30','12:45:00',3.85),('10318','2013-01-30','12:50:00',4.08),('10318','2013-01-30','12:55:00',2.31),('10318','2013-01-30','13:00:00',4.41),('10318','2013-01-30','13:05:00',2.9),('10318','2013-01-30','13:10:00',5.7),('10318','2013-01-30','13:15:00',7.57),('10318','2013-01-30','13:20:00',6.22),('10318','2013-01-30','13:25:00',2.7),('10318','2013-01-30','13:30:00',1.68),('10318','2013-01-30','13:35:00',2.22),('10318','2013-01-30','13:40:00',2.5),('10318','2013-01-30','13:45:00',4.21),('10318','2013-01-30','13:50:00',4.17),('10318','2013-01-30','13:55:00',3.84),('10318','2013-01-30','14:00:00',2.11),('10318','2013-01-30','14:05:00',1.95),('10318','2013-01-30','14:10:00',2.17),('10318','2013-01-30','14:15:00',3.02),('10318','2013-01-30','14:20:00',4.45),('10318','2013-01-30','14:25:00',5.56),('10318','2013-01-30','14:30:00',4.89),('10318','2013-01-30','14:35:00',3.47),('10318','2013-01-30','14:40:00',4.73),('10318','2013-01-30','14:45:00',3.85),('10318','2013-01-30','14:50:00',2.71),('10318','2013-01-30','14:55:00',2.74),('10318','2013-01-30','15:00:00',3.34),('10318','2013-01-30','15:05:00',2.37),('10318','2013-01-30','15:10:00',2.05),('10318','2013-01-30','15:15:00',1.74),('10318','2013-01-30','15:20:00',1.61),('10318','2013-01-30','15:25:00',1.58),('10318','2013-01-30','15:30:00',1.6),('10318','2013-01-30','15:35:00',1.4),('10318','2013-01-30','15:40:00',1.31),('10318','2013-01-30','15:45:00',1.24),('10318','2013-01-30','15:50:00',1.22),('10318','2013-01-30','15:55:00',1.18),('10318','2013-01-30','16:00:00',1.08),('10318','2013-01-30','16:05:00',1.02),('10318','2013-01-30','16:10:00',1.07),('10318','2013-01-30','16:15:00',1.25),('10318','2013-01-30','16:20:00',1.19),('10318','2013-01-30','16:25:00',1.06),('10318','2013-01-29','08:00:00',1.16),('10318','2013-01-29','08:05:00',1.36),('10318','2013-01-29','08:10:00',1.54),('10318','2013-01-29','08:15:00',2.07),('10318','2013-01-29','08:20:00',2.41),('10318','2013-01-29','08:25:00',2.75),('10318','2013-01-29','08:30:00',3.14),('10318','2013-01-29','08:35:00',3.34),('10318','2013-01-29','08:40:00',3.63),('10318','2013-01-29','08:45:00',3.85),('10318','2013-01-29','08:50:00',4.05),('10318','2013-01-29','08:55:00',4.23),('10318','2013-01-29','09:00:00',4.43),('10318','2013-01-29','09:05:00',4.63),('10318','2013-01-29','09:10:00',4.82),('10318','2013-01-29','09:15:00',5),('10318','2013-01-29','09:20:00',5.15),('10318','2013-01-29','09:25:00',5.28),('10318','2013-01-29','09:30:00',5.45),('10318','2013-01-29','09:35:00',5.62),('10318','2013-01-29','09:40:00',5.78),('10318','2013-01-29','09:45:00',5.91),('10318','2013-01-29','09:50:00',6.06),('10318','2013-01-29','09:55:00',6.23),('10318','2013-01-29','10:00:00',6.35),('10318','2013-01-29','10:05:00',6.42),('10318','2013-01-29','10:10:00',6.48),('10318','2013-01-29','10:15:00',6.55),('10318','2013-01-29','10:20:00',6.76),('10318','2013-01-29','10:25:00',6.84),('10318','2013-01-29','10:30:00',6.96),('10318','2013-01-29','10:35:00',7.07),('10318','2013-01-29','10:40:00',7.12),('10318','2013-01-29','10:45:00',7.18),('10318','2013-01-29','10:50:00',7.28),('10318','2013-01-29','10:55:00',7.22),('10318','2013-01-29','11:00:00',7.18),('10318','2013-01-29','11:05:00',7.16),('10318','2013-01-29','11:10:00',7.22),('10318','2013-01-29','11:15:00',7.24),('10318','2013-01-29','11:20:00',7.41),('10318','2013-01-29','11:25:00',7.29),('10318','2013-01-29','11:30:00',7.02),('10318','2013-01-29','11:35:00',7.41),('10318','2013-01-29','11:40:00',7.41),('10318','2013-01-29','11:45:00',7.41),('10318','2013-01-29','11:50:00',7.4),('10318','2013-01-29','11:55:00',7.47),('10318','2013-01-29','12:00:00',7.47),('10318','2013-01-29','12:05:00',7.44),('10318','2013-01-29','12:10:00',7.51),('10318','2013-01-29','12:15:00',7.46),('10318','2013-01-29','12:20:00',7.32),('10318','2013-01-29','12:25:00',7.35),('10318','2013-01-29','12:30:00',7.36),('10318','2013-01-29','12:35:00',7.21),('10318','2013-01-29','12:40:00',7.23),('10318','2013-01-29','12:45:00',7.06),('10318','2013-01-29','12:50:00',7.07),('10318','2013-01-29','12:55:00',7.13),('10318','2013-01-29','13:00:00',7.06),('10318','2013-01-29','13:05:00',7.03),('10318','2013-01-29','13:10:00',6.96),('10318','2013-01-29','13:15:00',6.78),('10318','2013-01-29','13:20:00',6.72),('10318','2013-01-29','13:25:00',6.58),('10318','2013-01-29','13:30:00',6.5),('10318','2013-01-29','13:35:00',6.43),('10318','2013-01-29','13:40:00',6.23),('10318','2013-01-29','13:45:00',6.13),('10318','2013-01-29','13:50:00',5.94),('10318','2013-01-29','13:55:00',5.88),('10318','2013-01-29','14:00:00',5.78),('10318','2013-01-29','14:05:00',5.08),('10318','2013-01-29','14:10:00',5.55),('10318','2013-01-29','14:15:00',5.44),('10318','2013-01-29','14:20:00',5.34),('10318','2013-01-29','14:25:00',5.19),('10318','2013-01-29','14:30:00',5.01),('10318','2013-01-29','14:35:00',4.85),('10318','2013-01-29','14:40:00',4.71),('10318','2013-01-29','14:45:00',4.59),('10318','2013-01-29','14:50:00',4.35),('10318','2013-01-29','14:55:00',4.17),('10318','2013-01-29','15:00:00',3.95),('10318','2013-01-29','15:05:00',3.97),('10318','2013-01-29','15:10:00',3.79),('10318','2013-01-29','15:15:00',3.63),('10318','2013-01-29','15:20:00',3.47),('10318','2013-01-29','15:25:00',3.33),('10318','2013-01-29','15:30:00',3.18),('10318','2013-01-29','15:35:00',3.07),('10318','2013-01-29','15:40:00',2.89),('10318','2013-01-29','15:45:00',2.71),('10318','2013-01-29','15:50:00',2.66),('10318','2013-01-29','15:55:00',2.58),('10318','2013-01-29','16:00:00',2.41),('10318','2013-01-29','16:05:00',2.24),('10318','2013-01-29','16:10:00',2.03),('10318','2013-01-29','16:15:00',1.83),('10318','2013-01-29','16:20:00',1.67),('10318','2013-01-29','16:25:00',1.55),('10318','2013-01-29','16:30:00',1.36),('10318','2013-01-29','16:35:00',1.17),('10318','2013-01-29','16:40:00',1.02),('10318','2013-01-28','08:25:00',1.07),('10318','2013-01-28','08:30:00',1.11),('10318','2013-01-28','08:35:00',1.11),('10318','2013-01-28','08:40:00',1.04),('10318','2013-01-28','10:05:00',1.06),('10318','2013-01-28','10:10:00',1.18),('10318','2013-01-28','10:15:00',1.13),('10318','2013-01-28','10:20:00',1.11),('10318','2013-01-28','10:25:00',1.06),('10318','2013-01-28','10:45:00',1.04),('10318','2013-01-28','10:50:00',1.27),('10318','2013-01-28','10:55:00',1.51),('10318','2013-01-28','11:00:00',1.75),('10318','2013-01-28','11:05:00',1.97),('10318','2013-01-28','11:10:00',1.92),('10318','2013-01-28','11:15:00',1.66),('10318','2013-01-28','11:20:00',1.63),('10318','2013-01-28','11:25:00',1.52),('10318','2013-01-28','11:30:00',1.31),('10318','2013-01-28','11:35:00',1.21),('10318','2013-01-28','11:40:00',1.17),('10318','2013-01-28','11:45:00',1.22),('10318','2013-01-28','11:50:00',1.13),('10318','2013-01-28','12:15:00',1.05),('10318','2013-01-28','12:20:00',1.11),('10318','2013-01-28','12:25:00',1.15),('10318','2013-01-28','12:30:00',1.35),('10318','2013-01-28','12:35:00',1.76),('10318','2013-01-28','12:40:00',2.28),('10318','2013-01-28','12:45:00',2.73),('10318','2013-01-28','12:50:00',2.83),('10318','2013-01-28','12:55:00',2.66),('10318','2013-01-28','13:00:00',2.48),('10318','2013-01-28','13:05:00',2.47),('10318','2013-01-28','13:10:00',2.31),('10318','2013-01-28','13:15:00',2.19),('10318','2013-01-28','13:20:00',2.05),('10318','2013-01-28','13:25:00',1.97),('10318','2013-01-28','13:30:00',1.94),('10318','2013-01-28','13:35:00',1.9),('10318','2013-01-28','13:40:00',1.78),('10318','2013-01-28','13:45:00',1.63),('10318','2013-01-28','13:50:00',1.5),('10318','2013-01-28','13:55:00',1.57),('10318','2013-01-28','14:00:00',1.59),('10318','2013-01-28','14:05:00',1.59),('10318','2013-01-28','14:10:00',1.58),('10318','2013-01-28','14:15:00',1.44),('10318','2013-01-28','14:20:00',1.3),('10318','2013-01-28','14:25:00',1.17),('10318','2013-01-28','14:30:00',1.13),('10318','2013-01-28','14:35:00',1.03),('10318','2013-01-28','14:40:00',1.04),('10318','2013-01-28','14:45:00',1.04),('10318','2013-01-27','08:00:00',1.11),('10318','2013-01-27','08:05:00',1.3),('10318','2013-01-27','08:10:00',1.53),('10318','2013-01-27','08:15:00',2),('10318','2013-01-27','08:20:00',2.32),('10318','2013-01-27','08:25:00',2.76),('10318','2013-01-27','08:30:00',3.31),('10318','2013-01-27','08:35:00',3.47),('10318','2013-01-27','08:40:00',3.49),('10318','2013-01-27','08:45:00',3.26),('10318','2013-01-27','08:50:00',3.7),('10318','2013-01-27','08:55:00',4.39),('10318','2013-01-27','09:00:00',4.44),('10318','2013-01-27','09:05:00',4.53),('10318','2013-01-27','09:10:00',4.61),('10318','2013-01-27','09:15:00',4.79),('10318','2013-01-27','09:20:00',5.02),('10318','2013-01-27','09:25:00',5.15),('10318','2013-01-27','09:30:00',5.29),('10318','2013-01-27','09:35:00',5.51),('10318','2013-01-27','09:40:00',5.64),('10318','2013-01-27','09:45:00',5.66),('10318','2013-01-27','09:50:00',5.88),('10318','2013-01-27','09:55:00',5.99),('10318','2013-01-27','10:00:00',6.08),('10318','2013-01-27','10:05:00',6.24),('10318','2013-01-27','10:10:00',6.35),('10318','2013-01-27','10:15:00',6.44),('10318','2013-01-27','10:20:00',6.6),('10318','2013-01-27','10:25:00',6.67),('10318','2013-01-27','10:30:00',6.69),('10318','2013-01-27','10:35:00',6.81),('10318','2013-01-27','10:40:00',6.86),('10318','2013-01-27','10:45:00',6.97),('10318','2013-01-27','10:50:00',7.03),('10318','2013-01-27','10:55:00',7.12),('10318','2013-01-27','11:00:00',7.15),('10318','2013-01-27','11:05:00',7.15),('10318','2013-01-27','11:10:00',7.22),('10318','2013-01-27','11:15:00',7.29),('10318','2013-01-27','11:20:00',7.34),('10318','2013-01-27','11:25:00',7.32),('10318','2013-01-27','11:30:00',7.2),('10318','2013-01-27','11:35:00',7.34),('10318','2013-01-27','11:40:00',7.41),('10318','2013-01-27','11:45:00',7.37),('10318','2013-01-27','11:50:00',7.37),('10318','2013-01-27','11:55:00',7.38),('10318','2013-01-27','12:00:00',7.34),('10318','2013-01-27','12:05:00',7.35),('10318','2013-01-27','12:10:00',7.37),('10318','2013-01-27','12:15:00',7.35),('10318','2013-01-27','12:20:00',7.27),('10318','2013-01-27','12:25:00',7.23),('10318','2013-01-27','12:30:00',7.22),('10318','2013-01-27','12:35:00',7.12),('10318','2013-01-27','12:40:00',7.08),('10318','2013-01-27','12:45:00',7.14),('10318','2013-01-27','12:50:00',7.08),('10318','2013-01-27','12:55:00',6.99),('10318','2013-01-27','13:00:00',6.76),('10318','2013-01-27','13:05:00',6.13),('10318','2013-01-27','13:10:00',5.94),('10318','2013-01-27','13:15:00',6.41),('10318','2013-01-27','13:20:00',6.4),('10318','2013-01-27','13:25:00',6.35),('10318','2013-01-27','13:30:00',6.17),('10318','2013-01-27','13:35:00',6.07),('10318','2013-01-27','13:40:00',6.04),('10318','2013-01-27','13:45:00',5.9),('10318','2013-01-27','13:50:00',5.8),('10318','2013-01-27','13:55:00',5.65),('10318','2013-01-27','14:00:00',5.49),('10318','2013-01-27','14:05:00',5.33),('10318','2013-01-27','14:10:00',5.24),('10318','2013-01-27','14:15:00',5.05),('10318','2013-01-27','14:20:00',5.02),('10318','2013-01-27','14:25:00',4.92),('10318','2013-01-27','14:30:00',4.8),('10318','2013-01-27','14:35:00',4.63),('10318','2013-01-27','14:40:00',4.43),('10318','2013-01-27','14:45:00',4.29),('10318','2013-01-27','14:50:00',4.2),('10318','2013-01-27','14:55:00',4.02),('10318','2013-01-27','15:00:00',3.76),('10318','2013-01-27','15:05:00',3.71),('10318','2013-01-27','15:10:00',3.53),('10318','2013-01-27','15:15:00',3.43),('10318','2013-01-27','15:20:00',3.26),('10318','2013-01-27','15:25:00',3.11),('10318','2013-01-27','15:30:00',2.92),('10318','2013-01-27','15:35:00',2.85),('10318','2013-01-27','15:40:00',2.8),('10318','2013-01-27','15:45:00',2.68),('10318','2013-01-27','15:50:00',2.52),('10318','2013-01-27','15:55:00',2.34),('10318','2013-01-27','16:00:00',2.1),('10318','2013-01-27','16:05:00',1.9),('10318','2013-01-27','16:10:00',1.77),('10318','2013-01-27','16:15:00',1.58),('10318','2013-01-27','16:20:00',1.39),('10318','2013-01-27','16:25:00',1.25),('10318','2013-01-27','16:30:00',1.1),('10318','2013-01-26','08:45:00',1.12),('10318','2013-01-26','08:50:00',1.27),('10318','2013-01-26','08:55:00',1.99),('10318','2013-01-26','09:00:00',3.08),('10318','2013-01-26','09:05:00',4.04),('10318','2013-01-26','09:10:00',3.66),('10318','2013-01-26','09:15:00',2.78),('10318','2013-01-26','09:20:00',2.97),('10318','2013-01-26','09:25:00',1.91),('10318','2013-01-26','09:30:00',2.25),('10318','2013-01-26','09:35:00',1.84),('10318','2013-01-26','09:40:00',1.45),('10318','2013-01-26','09:45:00',2.26),('10318','2013-01-26','09:50:00',2.45),('10318','2013-01-26','09:55:00',1.82),('10318','2013-01-26','10:00:00',1.6),('10318','2013-01-26','10:05:00',1.65),('10318','2013-01-26','10:10:00',1.78),('10318','2013-01-26','10:15:00',2.3),('10318','2013-01-26','10:20:00',2.67),('10318','2013-01-26','10:25:00',1.9),('10318','2013-01-26','10:30:00',1.72),('10318','2013-01-26','10:35:00',1.83),('10318','2013-01-26','10:40:00',2.09),('10318','2013-01-26','10:45:00',2.35),('10318','2013-01-26','10:50:00',2.14),('10318','2013-01-26','10:55:00',1.81),('10318','2013-01-26','11:00:00',1.99),('10318','2013-01-26','11:05:00',2.18),('10318','2013-01-26','11:10:00',2.16),('10318','2013-01-26','11:15:00',2.27),('10318','2013-01-26','11:20:00',2.14),('10318','2013-01-26','11:25:00',2.9),('10318','2013-01-26','11:30:00',2.85),('10318','2013-01-26','11:35:00',1.98),('10318','2013-01-26','11:40:00',2.07),('10318','2013-01-26','11:45:00',2.03),('10318','2013-01-26','11:50:00',2),('10318','2013-01-26','11:55:00',1.58),('10318','2013-01-26','12:00:00',1.59),('10318','2013-01-26','12:05:00',1.51),('10318','2013-01-26','12:10:00',1.57),('10318','2013-01-26','12:15:00',1.7),('10318','2013-01-26','12:20:00',1.79),('10318','2013-01-26','12:25:00',1.82),('10318','2013-01-26','12:30:00',1.78),('10318','2013-01-26','12:35:00',1.75),('10318','2013-01-26','12:40:00',1.7),('10318','2013-01-26','12:45:00',1.71),('10318','2013-01-26','12:50:00',1.42),('10318','2013-01-26','12:55:00',1.24),('10318','2013-01-26','13:00:00',1.61),('10318','2013-01-26','13:05:00',1.52),('10318','2013-01-26','13:10:00',1.18),('10318','2013-01-26','13:15:00',1.15),('10318','2013-01-26','13:20:00',1.18),('10318','2013-01-26','13:25:00',1.24),('10318','2013-01-26','13:30:00',1.46),('10318','2013-01-26','13:35:00',1.61),('10318','2013-01-26','13:40:00',1.64),('10318','2013-01-26','13:45:00',1.64),('10318','2013-01-26','13:50:00',1.41),('10318','2013-01-26','13:55:00',1.23),('10318','2013-01-26','14:00:00',1.06),('10318','2013-01-26','14:05:00',1.06),('10318','2013-01-26','14:10:00',1.06),('10318','2013-01-26','14:15:00',1.13),('10318','2013-01-26','14:20:00',1.29),('10318','2013-01-26','14:25:00',1.32),('10318','2013-01-26','14:30:00',1.2),('10318','2013-01-26','14:35:00',1),('10318','2013-01-25','08:15:00',1.07),('10318','2013-01-25','08:20:00',2.13),('10318','2013-01-25','08:25:00',2.87),('10318','2013-01-25','08:30:00',3.45),('10318','2013-01-25','08:35:00',3.66),('10318','2013-01-25','08:40:00',3.86),('10318','2013-01-25','08:45:00',4.14),('10318','2013-01-25','08:50:00',4.36),('10318','2013-01-25','08:55:00',4.47),('10318','2013-01-25','09:00:00',4.47),('10318','2013-01-25','09:05:00',3.69),('10318','2013-01-25','09:10:00',4.6),('10318','2013-01-25','09:15:00',4.79),('10318','2013-01-25','09:20:00',5.05),('10318','2013-01-25','09:25:00',5.01),('10318','2013-01-25','09:30:00',5.35),('10318','2013-01-25','09:35:00',4.91),('10318','2013-01-25','09:40:00',4.7),('10318','2013-01-25','09:45:00',5.18),('10318','2013-01-25','09:50:00',5.79),('10318','2013-01-25','09:55:00',6.2),('10318','2013-01-25','10:00:00',6.64),('10318','2013-01-25','10:05:00',6.86),('10318','2013-01-25','10:10:00',7),('10318','2013-01-25','10:15:00',6.95),('10318','2013-01-25','10:20:00',7.16),('10318','2013-01-25','10:25:00',6.9),('10318','2013-01-25','10:30:00',7.45),('10318','2013-01-25','10:35:00',7.38),('10318','2013-01-25','10:40:00',7.28),('10318','2013-01-25','10:45:00',7.32),('10318','2013-01-25','10:50:00',5.8),('10318','2013-01-25','10:55:00',7.97),('10318','2013-01-25','11:00:00',6.92),('10318','2013-01-25','11:05:00',6.76),('10318','2013-01-25','11:10:00',7.63),('10318','2013-01-25','11:15:00',7.51),('10318','2013-01-25','11:20:00',7.4),('10318','2013-01-25','11:25:00',7.77),('10318','2013-01-25','11:30:00',7.84),('10318','2013-01-25','11:35:00',7.83),('10318','2013-01-25','11:40:00',7.81),('10318','2013-01-25','11:45:00',7.79),('10318','2013-01-25','11:50:00',7.7),('10318','2013-01-25','11:55:00',7.82),('10318','2013-01-25','12:00:00',7.75),('10318','2013-01-25','12:05:00',7.4),('10318','2013-01-25','12:10:00',7.41),('10318','2013-01-25','12:15:00',7.47),('10318','2013-01-25','12:20:00',7.51),('10318','2013-01-25','12:25:00',7.52),('10318','2013-01-25','12:30:00',6.51),('10318','2013-01-25','12:35:00',6.59),('10318','2013-01-25','12:40:00',6.91),('10318','2013-01-25','12:45:00',6.83),('10318','2013-01-25','12:50:00',7.1),('10318','2013-01-25','12:55:00',7.11),('10318','2013-01-25','13:00:00',6.98),('10318','2013-01-25','13:05:00',6.9),('10318','2013-01-25','13:10:00',6.77),('10318','2013-01-25','13:15:00',6.77),('10318','2013-01-25','13:20:00',6.59),('10318','2013-01-25','13:25:00',6.39),('10318','2013-01-25','13:30:00',6.55),('10318','2013-01-25','13:35:00',6.5),('10318','2013-01-25','13:40:00',6.54),('10318','2013-01-25','13:45:00',6.35),('10318','2013-01-25','13:50:00',6.21),('10318','2013-01-25','13:55:00',6.05),('10318','2013-01-25','14:00:00',5.62),('10318','2013-01-25','14:05:00',5.34),('10318','2013-01-25','14:10:00',5.05),('10318','2013-01-25','14:15:00',5.04),('10318','2013-01-25','14:20:00',4.81),('10318','2013-01-25','14:25:00',4.71),('10318','2013-01-25','14:30:00',4.47),('10318','2013-01-25','14:35:00',4.34),('10318','2013-01-25','14:40:00',4.23),('10318','2013-01-25','14:45:00',4.09),('10318','2013-01-25','14:50:00',3.84),('10318','2013-01-25','14:55:00',3.67),('10318','2013-01-25','15:00:00',3.36),('10318','2013-01-25','15:05:00',3.34),('10318','2013-01-25','15:10:00',3.22),('10318','2013-01-25','15:15:00',3.22),('10318','2013-01-25','15:20:00',3.05),('10318','2013-01-25','15:25:00',2.97),('10318','2013-01-25','15:30:00',3.12),('10318','2013-01-25','15:35:00',3.17),('10318','2013-01-25','15:40:00',2.87),('10318','2013-01-25','15:45:00',3.01),('10318','2013-01-25','15:50:00',2.81),('10318','2013-01-25','15:55:00',2.35),('10318','2013-01-25','16:00:00',1.55),('10318','2013-01-25','16:05:00',1.26),('10318','2013-01-25','16:10:00',1.3),('10318','2013-01-25','16:15:00',1.42),('10318','2013-01-25','16:20:00',1.39),('10318','2013-01-25','16:25:00',1.12),('10318','2013-01-24','08:45:00',1.17),('10318','2013-01-24','08:50:00',1.51),('10318','2013-01-24','08:55:00',1.71),('10318','2013-01-24','09:00:00',1.64),('10318','2013-01-24','09:05:00',1.41),('10318','2013-01-24','09:10:00',1.51),('10318','2013-01-24','09:15:00',1.73),('10318','2013-01-24','09:20:00',1.97),('10318','2013-01-24','09:25:00',2.03),('10318','2013-01-24','09:30:00',4.01),('10318','2013-01-24','09:35:00',3.15),('10318','2013-01-24','09:40:00',5.5),('10318','2013-01-24','09:45:00',6.08),('10318','2013-01-24','09:50:00',6.31),('10318','2013-01-24','09:55:00',5.93),('10318','2013-01-24','10:00:00',4.2),('10318','2013-01-24','10:05:00',5.5),('10318','2013-01-24','10:10:00',6.83),('10318','2013-01-24','10:15:00',7.07),('10318','2013-01-24','10:20:00',7.18),('10318','2013-01-24','10:25:00',7.17),('10318','2013-01-24','10:30:00',7.16),('10318','2013-01-24','10:35:00',7.22),('10318','2013-01-24','10:40:00',7.3),('10318','2013-01-24','10:45:00',7.39),('10318','2013-01-24','10:50:00',6.8),('10318','2013-01-24','10:55:00',4.03),('10318','2013-01-24','11:00:00',2.33),('10318','2013-01-24','11:05:00',1.2),('10318','2013-01-24','11:10:00',1),('10318','2013-01-24','11:25:00',1),('10318','2013-01-24','11:30:00',1.01),('10318','2013-01-24','11:35:00',1.08),('10318','2013-01-24','11:40:00',1.12),('10318','2013-01-24','11:45:00',1.08),('10318','2013-01-24','11:50:00',1.08),('10318','2013-01-24','11:55:00',1),('10318','2013-01-24','12:25:00',1.16),('10318','2013-01-24','12:30:00',1.47),('10318','2013-01-24','12:35:00',1.89),('10318','2013-01-24','12:40:00',2.26),('10318','2013-01-24','12:45:00',2.4),('10318','2013-01-24','12:50:00',2.28),('10318','2013-01-24','12:55:00',2.14),('10318','2013-01-24','13:00:00',2.09),('10318','2013-01-24','13:05:00',2.09),('10318','2013-01-24','13:10:00',2.09),('10318','2013-01-24','13:15:00',1.97),('10318','2013-01-24','13:20:00',1.88),('10318','2013-01-24','13:25:00',1.88),('10318','2013-01-24','13:30:00',1.83),('10318','2013-01-24','13:35:00',1.85),('10318','2013-01-24','13:40:00',1.84),('10318','2013-01-24','13:45:00',1.89),('10318','2013-01-24','13:50:00',2.01),('10318','2013-01-24','13:55:00',2.3),('10318','2013-01-24','14:00:00',2.61),('10318','2013-01-24','14:05:00',2.48),('10318','2013-01-24','14:10:00',2.62),('10318','2013-01-24','14:15:00',3.06),('10318','2013-01-24','14:20:00',6.51),('10318','2013-01-24','14:25:00',6.74),('10318','2013-01-24','14:30:00',4.58),('10318','2013-01-24','14:35:00',3.26),('10318','2013-01-24','14:40:00',4.6),('10318','2013-01-24','14:45:00',4.62),('10318','2013-01-24','14:50:00',4.9),('10318','2013-01-24','14:55:00',3.77),('10318','2013-01-24','15:00:00',2.56),('10318','2013-01-24','15:05:00',2.42),('10318','2013-01-24','15:10:00',2.78),('10318','2013-01-24','15:15:00',3.01),('10318','2013-01-24','15:20:00',2.7),('10318','2013-01-24','15:25:00',2.74),('10318','2013-01-24','15:30:00',2.88),('10318','2013-01-24','15:35:00',1.59),('10318','2013-01-24','15:40:00',2.59),('10318','2013-01-24','15:45:00',2.72),('10318','2013-01-24','15:50:00',2.63),('10318','2013-01-24','15:55:00',2.38),('10318','2013-01-24','16:00:00',2.04),('10318','2013-01-24','16:05:00',1.21),('10318','2013-01-24','16:10:00',1.53),('10318','2013-01-24','16:15:00',1.63),('10318','2013-01-24','16:20:00',1.42),('10318','2013-01-23','09:10:00',1.43),('10318','2013-01-23','09:30:00',1.03),('10318','2013-01-23','09:35:00',1.33),('10318','2013-01-23','09:40:00',1.46),('10318','2013-01-23','09:45:00',1.98),('10318','2013-01-23','09:50:00',2.13),('10318','2013-01-23','09:55:00',4.73),('10318','2013-01-23','10:00:00',5.38),('10318','2013-01-23','10:05:00',2.11),('10318','2013-01-23','10:10:00',1.58),('10318','2013-01-23','10:15:00',2.34),('10318','2013-01-23','10:20:00',1.86),('10318','2013-01-23','10:25:00',3.4),('10318','2013-01-23','10:30:00',5.7),('10318','2013-01-23','10:35:00',6.73),('10318','2013-01-23','10:40:00',5.09),('10318','2013-01-23','10:45:00',3.06),('10318','2013-01-23','10:50:00',2.78),('10318','2013-01-23','10:55:00',2.64),('10318','2013-01-23','11:00:00',1.64),('10318','2013-01-23','13:40:00',1.06),('10318','2013-01-22','08:00:00',1.19),('10318','2013-01-22','08:05:00',1.43),('10318','2013-01-22','08:10:00',1.45),('10318','2013-01-22','08:15:00',1.43),('10318','2013-01-22','08:20:00',1.78),('10318','2013-01-22','08:25:00',1.62),('10318','2013-01-22','08:30:00',1.35),('10318','2013-01-22','08:35:00',1.72),('10318','2013-01-22','08:40:00',2.73),('10318','2013-01-22','08:45:00',3.46),('10318','2013-01-22','08:50:00',3.35),('10318','2013-01-22','08:55:00',2.59),('10318','2013-01-22','09:00:00',3.55),('10318','2013-01-22','09:05:00',1.76),('10318','2013-01-22','09:25:00',4.12),('10318','2013-01-22','09:30:00',5.72),('10318','2013-01-22','09:35:00',5.97),('10318','2013-01-22','09:40:00',5.41),('10318','2013-01-22','09:45:00',5.89),('10318','2013-01-22','09:50:00',5.23),('10318','2013-01-22','09:55:00',4.75),('10318','2013-01-22','10:00:00',3.32),('10318','2013-01-22','10:05:00',6.35),('10318','2013-01-22','10:10:00',6.39),('10318','2013-01-22','10:15:00',6.15),('10318','2013-01-22','10:20:00',6.9),('10318','2013-01-22','10:25:00',7.36),('10318','2013-01-22','10:30:00',6.64),('10318','2013-01-22','10:35:00',7.63),('10318','2013-01-22','10:40:00',7),('10318','2013-01-22','10:45:00',4.75),('10318','2013-01-22','10:50:00',5.11),('10318','2013-01-22','10:55:00',2.12),('10318','2013-01-22','11:00:00',1.42),('10318','2013-01-22','11:05:00',2.91),('10318','2013-01-22','11:10:00',2.08),('10318','2013-01-22','11:15:00',3.1),('10318','2013-01-22','11:20:00',4.9),('10318','2013-01-22','11:25:00',3.27),('10318','2013-01-22','11:30:00',1.65),('10318','2013-01-22','11:35:00',1.6),('10318','2013-01-22','11:40:00',1.08),('10318','2013-01-22','11:45:00',6.16),('10318','2013-01-22','11:50:00',2.29),('10318','2013-01-22','11:55:00',1.71),('10318','2013-01-22','12:00:00',2.24),('10318','2013-01-22','12:05:00',2.05),('10318','2013-01-22','12:10:00',5.45),('10318','2013-01-22','12:15:00',1.91),('10318','2013-01-22','12:20:00',5.04),('10318','2013-01-22','12:25:00',2.83),('10318','2013-01-22','12:30:00',2.47),('10318','2013-01-22','12:35:00',6.68),('10318','2013-01-22','12:40:00',2.89),('10318','2013-01-22','12:45:00',1.87),('10318','2013-01-22','12:50:00',4.65),('10318','2013-01-22','12:55:00',5.09),('10318','2013-01-22','13:00:00',6.86),('10318','2013-01-22','13:05:00',2.17),('10318','2013-01-22','13:10:00',3.36),('10318','2013-01-22','13:15:00',6.99),('10318','2013-01-22','13:20:00',3.92),('10318','2013-01-22','13:25:00',2.72),('10318','2013-01-22','13:30:00',1.32),('10318','2013-01-22','13:35:00',1.8),('10318','2013-01-22','13:40:00',4.79),('10318','2013-01-22','13:45:00',3.23),('10318','2013-01-22','13:50:00',1.69),('10318','2013-01-22','13:55:00',1.45),('10318','2013-01-22','14:00:00',3.71),('10318','2013-01-22','14:05:00',1.53),('10318','2013-01-22','14:10:00',4.83),('10318','2013-01-22','14:15:00',4.65),('10318','2013-01-22','14:20:00',3.97),('10318','2013-01-22','14:25:00',2.67),('10318','2013-01-22','14:30:00',1.89),('10318','2013-01-22','14:35:00',2.97),('10318','2013-01-22','14:40:00',3.43),('10318','2013-01-22','14:45:00',3.23),('10318','2013-01-22','14:50:00',1.85),('10318','2013-01-22','14:55:00',1.1),('10318','2013-01-22','15:00:00',2.85),('10318','2013-01-22','15:10:00',1.09),('10318','2013-01-22','15:20:00',1.02),('10318','2013-01-22','15:25:00',1.12),('10318','2013-01-22','15:30:00',1.11),('10318','2014-03-20','07:00:00',1.04),('10318','2014-03-20','07:05:00',1.33),('10318','2014-03-20','07:10:00',1.5),('10318','2014-03-20','07:15:00',1.8),('10318','2014-03-20','07:20:00',2.17),('10318','2014-03-20','07:25:00',2.63),('10318','2014-03-20','07:30:00',2.81),('10318','2014-03-20','07:35:00',3.24),('10318','2014-03-20','07:40:00',3.57),('10318','2014-03-20','07:45:00',3.77),('10318','2014-03-20','07:50:00',4.04),('10318','2014-03-20','07:55:00',4.18),('10318','2014-03-20','08:00:00',4.32),('10318','2014-03-20','08:05:00',4.43),('10318','2014-03-20','08:10:00',4.42),('10318','2014-03-20','08:15:00',4.55),('10318','2014-03-20','08:20:00',4.81),('10318','2014-03-20','08:25:00',5.03),('10318','2014-03-20','08:30:00',5.28),('10318','2014-03-20','08:35:00',5.48),('10318','2014-03-20','08:40:00',5.92),('10318','2014-03-20','08:45:00',6.12),('10318','2014-03-20','08:50:00',6.19),('10318','2014-03-20','08:55:00',6.3),('10318','2014-03-20','09:00:00',6.22),('10318','2014-03-20','09:05:00',6.71),('10318','2014-03-20','09:10:00',6.83),('10318','2014-03-20','09:15:00',6.91),('10318','2014-03-20','09:20:00',7.02),('10318','2014-03-20','09:25:00',7.15),('10318','2014-03-20','09:30:00',7.23),('10318','2014-03-20','09:35:00',7.38),('10318','2014-03-20','09:40:00',7.5),('10318','2014-03-20','09:45:00',7.44),('10318','2014-03-20','09:50:00',7.55),('10318','2014-03-20','09:55:00',7.85),('10318','2014-03-20','10:00:00',7.98),('10318','2014-03-20','10:05:00',8.09),('10318','2014-03-20','10:10:00',8.23),('10318','2014-03-20','10:15:00',8.02),('10318','2014-03-20','10:20:00',7.96),('10318','2014-03-20','10:25:00',8.26),('10318','2014-03-20','10:30:00',8.34),('10318','2014-03-20','10:35:00',8.11),('10318','2014-03-20','10:40:00',8.01),('10318','2014-03-20','10:45:00',7.97),('10318','2014-03-20','10:50:00',8.5),('10318','2014-03-20','10:55:00',8.65),('10318','2014-03-20','11:00:00',8.72),('10318','2014-03-20','11:05:00',8.77),('10318','2014-03-20','11:10:00',8.61),('10318','2014-03-20','11:15:00',8.09),('10318','2014-03-20','11:20:00',8.32),('10318','2014-03-20','11:25:00',8.41),('10318','2014-03-20','11:30:00',8.56),('10318','2014-03-20','11:35:00',8.43),('10318','2014-03-20','11:40:00',8.73),('10318','2014-03-20','11:45:00',8.6),('10318','2014-03-20','11:50:00',8.2),('10318','2014-03-20','11:55:00',7.7),('10318','2014-03-20','12:00:00',7.3),('10318','2014-03-20','12:05:00',7.93),('10318','2014-03-20','12:10:00',8.57),('10318','2014-03-20','12:15:00',8.83),('10318','2014-03-20','12:20:00',8.58),('10318','2014-03-20','12:25:00',8.08),('10318','2014-03-20','12:30:00',8.34),('10318','2014-03-20','12:35:00',8.69),('10318','2014-03-20','12:40:00',8.68),('10318','2014-03-20','12:45:00',8.68),('10318','2014-03-20','12:50:00',8.64),('10318','2014-03-20','12:55:00',8.48),('10318','2014-03-20','13:00:00',8.49),('10318','2014-03-20','13:05:00',8.3),('10318','2014-03-20','13:10:00',8.11),('10318','2014-03-20','13:15:00',8.09),('10318','2014-03-20','13:20:00',8),('10318','2014-03-20','13:25:00',7.75),('10318','2014-03-20','13:30:00',7.72),('10318','2014-03-20','13:35:00',7.63),('10318','2014-03-20','13:40:00',7.28),('10318','2014-03-20','13:45:00',6.82),('10318','2014-03-20','13:50:00',6.48),('10318','2014-03-20','13:55:00',6.2),('10318','2014-03-20','14:00:00',6.55),('10318','2014-03-20','14:05:00',6.58),('10318','2014-03-20','14:10:00',6.33),('10318','2014-03-20','14:15:00',6.36),('10318','2014-03-20','14:20:00',6.24),('10318','2014-03-20','14:25:00',5.84),('10318','2014-03-20','14:30:00',5.16),('10318','2014-03-20','14:35:00',4.87),('10318','2014-03-20','14:40:00',5.22),('10318','2014-03-20','14:45:00',5.12),('10318','2014-03-20','14:50:00',4.83),('10318','2014-03-20','14:55:00',4.6),('10318','2014-03-20','15:00:00',4.64),('10318','2014-03-20','15:05:00',4.51),('10318','2014-03-20','15:10:00',4.66),('10318','2014-03-20','15:15:00',4.42),('10318','2014-03-20','15:20:00',4.28),('10318','2014-03-20','15:25:00',4),('10318','2014-03-20','15:30:00',3.63),('10318','2014-03-20','15:35:00',3.4),('10318','2014-03-20','15:40:00',3.29),('10318','2014-03-20','15:45:00',3.15),('10318','2014-03-20','15:50:00',2.85),('10318','2014-03-20','15:55:00',2.42),('10318','2014-03-20','16:00:00',2.45),('10318','2014-03-20','16:05:00',2.13),('10318','2014-03-20','16:10:00',1.97),('10318','2014-03-20','16:15:00',1.94),('10318','2014-03-20','16:20:00',1.87),('10318','2014-03-20','16:25:00',1.91),('10318','2014-03-20','16:30:00',1.94),('10318','2014-03-20','16:35:00',1.89),('10318','2014-03-20','16:40:00',1.72),('10318','2014-03-20','16:45:00',1.31),('10318','2014-03-20','16:50:00',1.08),('10318','2013-01-21','10:00:00',1.02),('10318','2013-01-21','10:05:00',1.37),('10318','2013-01-21','10:10:00',1.84),('10318','2013-01-21','10:15:00',1.6),('10318','2013-01-21','10:20:00',1.4),('10318','2013-01-21','10:25:00',1.64),('10318','2013-01-21','10:30:00',1.39),('10318','2013-01-21','10:35:00',1.28),('10318','2013-01-21','10:40:00',1.32),('10318','2013-01-21','10:45:00',1.5),('10318','2013-01-21','10:50:00',1.66),('10318','2013-01-21','10:55:00',1.8),('10318','2013-01-21','11:00:00',1.87),('10318','2013-01-21','11:05:00',2.22),('10318','2013-01-21','11:10:00',2.62),('10318','2013-01-21','11:15:00',3.33),('10318','2013-01-21','11:20:00',2.8),('10318','2013-01-21','11:25:00',1.99),('10318','2013-01-21','11:30:00',1.74),('10318','2013-01-21','11:35:00',1.21),('10318','2013-01-21','11:40:00',2.02),('10318','2013-01-21','11:45:00',2.25),('10318','2013-01-21','11:50:00',6.53),('10318','2013-01-21','11:55:00',7.71),('10318','2013-01-21','12:00:00',7.24),('10318','2013-01-21','12:05:00',7.22),('10318','2013-01-21','12:10:00',5.09),('10318','2013-01-21','12:15:00',5.34),('10318','2013-01-21','12:20:00',3.39),('10318','2013-01-21','12:25:00',2.49),('10318','2013-01-21','12:30:00',1.72),('10318','2013-01-21','12:35:00',2.9),('10318','2013-01-21','12:40:00',1.74),('10318','2013-01-21','12:45:00',2.06),('10318','2013-01-21','12:50:00',1.78),('10318','2013-01-21','12:55:00',1.48),('10318','2013-01-21','13:00:00',2.7),('10318','2013-01-21','13:05:00',3.16),('10318','2013-01-21','13:10:00',2.59),('10318','2013-01-21','13:15:00',1.55),('10318','2013-01-21','13:20:00',1.78),('10318','2013-01-21','13:25:00',4.37),('10318','2013-01-21','13:30:00',5.78),('10318','2013-01-21','13:35:00',5.47),('10318','2013-01-21','13:40:00',4.51),('10318','2013-01-21','13:45:00',1.85),('10318','2013-01-21','13:50:00',2.62),('10318','2013-01-21','13:55:00',6.38),('10318','2013-01-21','14:00:00',4.16),('10318','2013-01-21','14:05:00',4.15),('10318','2013-01-21','14:10:00',4.28),('10318','2013-01-21','14:15:00',5.64),('10318','2013-01-21','14:20:00',5.01),('10318','2013-01-21','14:25:00',4.52),('10318','2013-01-21','14:30:00',1.79),('10318','2013-01-21','14:35:00',1.22),('10318','2013-01-21','14:40:00',1.35),('10318','2013-01-21','14:45:00',1.08),('10318','2013-01-21','14:50:00',1.14),('10318','2013-01-21','14:55:00',1.02),('10318','2013-01-21','15:00:00',1.03),('10318','2013-01-21','15:35:00',1),('10318','2013-01-21','15:40:00',1.34),('10318','2013-01-20','08:30:00',1.38),('10318','2013-01-20','08:35:00',1.56),('10318','2013-01-20','08:40:00',1.39),('10318','2013-01-20','08:45:00',1.09),('10318','2013-01-20','09:00:00',1.04),('10318','2013-01-20','09:05:00',1.15),('10318','2013-01-20','10:00:00',1.18),('10318','2013-01-20','10:05:00',1.11),('10318','2013-01-20','10:20:00',1.02),('10318','2013-01-20','10:25:00',1.28),('10318','2013-01-20','10:30:00',1.39),('10318','2013-01-20','10:35:00',1.29),('10318','2013-01-20','10:40:00',1.53),('10318','2013-01-20','10:45:00',1.77),('10318','2013-01-20','10:50:00',1.97),('10318','2013-01-20','10:55:00',2.14),('10318','2013-01-20','11:00:00',2.65),('10318','2013-01-20','11:05:00',2.6),('10318','2013-01-20','11:10:00',3.21),('10318','2013-01-20','11:15:00',4.2),('10318','2013-01-20','11:20:00',3.14),('10318','2013-01-20','11:25:00',4.44),('10318','2013-01-20','11:30:00',5.23),('10318','2013-01-20','11:35:00',3.95),('10318','2013-01-20','11:40:00',2.15),('10318','2013-01-20','11:45:00',2.01),('10318','2013-01-20','11:50:00',1.6),('10318','2013-01-20','11:55:00',1.2),('10318','2013-01-20','12:00:00',1.17),('10318','2013-01-20','12:05:00',1.19),('10318','2013-01-20','12:10:00',1.51),('10318','2013-01-20','12:15:00',1.85),('10318','2013-01-20','12:20:00',2.03),('10318','2013-01-20','12:25:00',2.06),('10318','2013-01-20','12:30:00',1.87),('10318','2013-01-20','12:35:00',1.72),('10318','2013-01-20','12:40:00',1.54),('10318','2013-01-20','12:45:00',1.51),('10318','2013-01-20','12:50:00',1.53),('10318','2013-01-20','12:55:00',1.51),('10318','2013-01-20','13:00:00',1.37),('10318','2013-01-20','13:05:00',1.36),('10318','2013-01-20','13:10:00',1.45),('10318','2013-01-20','13:15:00',1.62),('10318','2013-01-20','13:20:00',1.58),('10318','2013-01-20','13:25:00',1.5),('10318','2013-01-20','13:30:00',1.49),('10318','2013-01-20','13:35:00',1.76),('10318','2013-01-20','13:40:00',1.92),('10318','2013-01-20','13:45:00',1.88),('10318','2013-01-20','13:50:00',1.8),('10318','2013-01-20','13:55:00',1.57),('10318','2013-01-20','14:00:00',1.41),('10318','2013-01-20','14:05:00',1.26),('10318','2013-01-20','14:10:00',1.18),('10318','2013-01-20','14:15:00',1.35),('10318','2013-01-20','14:20:00',1.52),('10318','2013-01-20','14:25:00',1.32),('10318','2013-01-20','14:30:00',1.07),('10318','2013-01-19','08:45:00',1.13),('10318','2013-01-19','08:50:00',1.26),('10318','2013-01-19','08:55:00',1.35),('10318','2013-01-19','09:00:00',1.56),('10318','2013-01-19','09:05:00',1.74),('10318','2013-01-19','09:10:00',2.06),('10318','2013-01-19','09:15:00',3.64),('10318','2013-01-19','09:20:00',3.56),('10318','2013-01-19','09:25:00',2.19),('10318','2013-01-19','09:30:00',1.61),('10318','2013-01-19','09:35:00',1.43),('10318','2013-01-19','09:40:00',1.33),('10318','2013-01-19','09:45:00',2),('10318','2013-01-19','09:50:00',2.74),('10318','2013-01-19','09:55:00',3.63),('10318','2013-01-19','10:00:00',2.94),('10318','2013-01-19','10:05:00',2.19),('10318','2013-01-19','10:10:00',1.43),('10318','2013-01-19','10:15:00',1.05),('10318','2013-01-19','10:20:00',1.02),('10318','2013-01-19','10:25:00',1.3),('10318','2013-01-19','10:30:00',1.37),('10318','2013-01-19','10:35:00',2.3),('10318','2013-01-19','10:40:00',2.45),('10318','2013-01-19','10:45:00',3.26),('10318','2013-01-19','10:50:00',2.37),('10318','2013-01-19','10:55:00',1.47),('10318','2013-01-19','11:00:00',1.75),('10318','2013-01-19','11:05:00',1.71),('10318','2013-01-19','11:10:00',1.86),('10318','2013-01-19','11:15:00',2.19),('10318','2013-01-19','11:20:00',2.77),('10318','2013-01-19','11:25:00',2.43),('10318','2013-01-19','11:30:00',1.92),('10318','2013-01-19','11:35:00',1.43),('10318','2013-01-19','11:40:00',1.04),('10318','2013-01-19','11:45:00',1.26),('10318','2013-01-19','11:50:00',1.54),('10318','2013-01-19','11:55:00',1.28),('10318','2013-01-19','12:05:00',1.31),('10318','2013-01-19','12:10:00',1.55),('10318','2013-01-19','12:15:00',1.48),('10318','2013-01-19','12:20:00',1.36),('10318','2013-01-19','12:25:00',1.15),('10318','2013-01-19','14:25:00',1.04),('10318','2013-01-19','14:30:00',1.58),('10318','2013-01-19','14:35:00',1.04),('10318','2013-01-18','08:40:00',1.15),('10318','2013-01-18','08:45:00',1.48),('10318','2013-01-18','08:50:00',1.58),('10318','2013-01-18','08:55:00',1.92),('10318','2013-01-18','09:00:00',1.14),('10318','2013-01-18','09:30:00',1.05),('10318','2013-01-18','09:35:00',1.11),('10318','2013-01-18','09:50:00',1.14),('10318','2013-01-18','09:55:00',1.29),('10318','2013-01-18','10:00:00',1.34),('10318','2013-01-18','10:05:00',1.54),('10318','2013-01-18','10:10:00',2.36),('10318','2013-01-18','10:15:00',7.74),('10318','2013-01-18','10:20:00',5.87),('10318','2013-01-18','10:25:00',3.97),('10318','2013-01-18','10:30:00',2.78),('10318','2013-01-18','10:35:00',2.36),('10318','2013-01-18','10:40:00',1.8),('10318','2013-01-18','10:45:00',1.68),('10318','2013-01-18','10:50:00',1.72),('10318','2013-01-18','10:55:00',1.78),('10318','2013-01-18','11:00:00',1.84),('10318','2013-01-18','11:05:00',2.02),('10318','2013-01-18','11:10:00',1.87),('10318','2013-01-18','11:15:00',1.82),('10318','2013-01-18','11:20:00',1.71),('10318','2013-01-18','11:25:00',2.12),('10318','2013-01-18','11:30:00',2.61),('10318','2013-01-18','11:35:00',2.89),('10318','2013-01-18','11:40:00',2.38),('10318','2013-01-18','11:45:00',1.98),('10318','2013-01-18','11:50:00',1.81),('10318','2013-01-18','11:55:00',1.96),('10318','2013-01-18','12:00:00',2.05),('10318','2013-01-18','12:05:00',2.11),('10318','2013-01-18','12:10:00',2.33),('10318','2013-01-18','12:15:00',2.43),('10318','2013-01-18','12:20:00',2.53),('10318','2013-01-18','12:25:00',2.5),('10318','2013-01-18','12:30:00',2.65),('10318','2013-01-18','12:35:00',3.26),('10318','2013-01-18','12:40:00',2.99),('10318','2013-01-18','12:45:00',3.37),('10318','2013-01-18','12:50:00',4.38),('10318','2013-01-18','12:55:00',5.24),('10318','2013-01-18','13:00:00',6.28),('10318','2013-01-18','13:05:00',5.96),('10318','2013-01-18','13:10:00',6.15),('10318','2013-01-18','13:15:00',5.76),('10318','2013-01-18','13:20:00',4.75),('10318','2013-01-18','13:25:00',3.87),('10318','2013-01-18','13:30:00',2.96),('10318','2013-01-18','13:35:00',2.79),('10318','2013-01-18','13:40:00',5.96),('10318','2013-01-18','13:45:00',6.74),('10318','2013-01-18','13:50:00',3.9),('10318','2013-01-18','13:55:00',6.3),('10318','2013-01-18','14:00:00',6.42),('10318','2013-01-18','14:05:00',5.89),('10318','2013-01-18','14:10:00',5.85),('10318','2013-01-18','14:15:00',6.48),('10318','2013-01-18','14:20:00',6.12),('10318','2013-01-18','14:25:00',3.65),('10318','2013-01-18','14:30:00',2.53),('10318','2013-01-18','14:35:00',2.15),('10318','2013-01-18','14:40:00',2.05),('10318','2013-01-18','14:45:00',2.01),('10318','2013-01-18','14:50:00',2.56),('10318','2013-01-18','14:55:00',2.55),('10318','2013-01-18','15:00:00',2.03),('10318','2013-01-18','15:05:00',1.99),('10318','2013-01-18','15:10:00',2.07),('10318','2013-01-18','15:15:00',1.99),('10318','2013-01-18','15:20:00',1.66),('10318','2013-01-18','15:25:00',1.7),('10318','2013-01-18','15:30:00',1.35),('10318','2013-01-18','15:35:00',1.93),('10318','2013-01-18','15:40:00',1.69),('10318','2013-01-18','15:45:00',2.14),('10318','2013-01-18','15:50:00',2.11),('10318','2013-01-18','15:55:00',2.12),('10318','2013-01-18','16:00:00',1.95),('10318','2013-01-18','16:05:00',1.8),('10318','2013-01-18','16:10:00',1.81),('10318','2013-01-18','16:15:00',1.65),('10318','2013-01-18','16:20:00',1.36),('10318','2013-01-18','16:25:00',1.19),('10318','2013-01-17','09:00:00',1.04),('10318','2013-01-17','09:05:00',1.45),('10318','2013-01-17','09:10:00',1.74),('10318','2013-01-17','09:15:00',1.73),('10318','2013-01-17','09:20:00',1.65),('10318','2013-01-17','09:25:00',1.54),('10318','2013-01-17','09:30:00',1.84),('10318','2013-01-17','09:35:00',1.86),('10318','2013-01-17','09:40:00',2.19),('10318','2013-01-17','09:45:00',3.15),('10318','2013-01-17','09:50:00',4.01),('10318','2013-01-17','09:55:00',3.46),('10318','2013-01-17','10:00:00',2.43),('10318','2013-01-17','10:05:00',2.45),('10318','2013-01-17','10:10:00',2.87),('10318','2013-01-17','10:15:00',3.48),('10318','2013-01-17','10:20:00',3.82),('10318','2013-01-17','10:25:00',3.97),('10318','2013-01-17','10:30:00',4.2),('10318','2013-01-17','10:35:00',4.03),('10318','2013-01-17','10:40:00',3.89),('10318','2013-01-17','10:45:00',3.83),('10318','2013-01-17','10:50:00',3.6),('10318','2013-01-17','10:55:00',3.98),('10318','2013-01-17','11:00:00',3.52),('10318','2013-01-17','11:05:00',4.16),('10318','2013-01-17','11:10:00',4.55),('10318','2013-01-17','11:15:00',4.61),('10318','2013-01-17','11:20:00',4.19),('10318','2013-01-17','11:25:00',3.6),('10318','2013-01-17','11:30:00',3.13),('10318','2013-01-17','11:35:00',3.7),('10318','2013-01-17','11:40:00',4),('10318','2013-01-17','11:45:00',3.76),('10318','2013-01-17','11:50:00',3.82),('10318','2013-01-17','11:55:00',3.94),('10318','2013-01-17','12:00:00',4.2),('10318','2013-01-17','12:05:00',4.34),('10318','2013-01-17','12:10:00',3.84),('10318','2013-01-17','12:15:00',4.38),('10318','2013-01-17','12:20:00',4.91),('10318','2013-01-17','12:25:00',3.68),('10318','2013-01-17','12:30:00',3),('10318','2013-01-17','12:35:00',3.4),('10318','2013-01-17','12:40:00',2.68),('10318','2013-01-17','12:45:00',2.32),('10318','2013-01-17','12:50:00',2.23),('10318','2013-01-17','12:55:00',2.8),('10318','2013-01-17','13:00:00',2.99),('10318','2013-01-17','13:05:00',3.18),('10318','2013-01-17','13:10:00',3.13),('10318','2013-01-17','13:15:00',3),('10318','2013-01-17','13:20:00',3.12),('10318','2013-01-17','13:25:00',3.29),('10318','2013-01-17','13:30:00',2.53),('10318','2013-01-17','13:35:00',2.43),('10318','2013-01-17','13:40:00',4.02),('10318','2013-01-17','13:45:00',5.66),('10318','2013-01-17','13:50:00',4.54),('10318','2013-01-17','13:55:00',3.63),('10318','2013-01-17','14:00:00',2.86),('10318','2013-01-17','14:05:00',2.24),('10318','2013-01-17','14:10:00',1.83),('10318','2013-01-17','14:15:00',2.14),('10318','2013-01-17','14:20:00',2.27),('10318','2013-01-17','14:25:00',2.54),('10318','2013-01-17','14:30:00',2.64),('10318','2013-01-17','14:35:00',2.09),('10318','2013-01-17','14:40:00',1.09),('10318','2013-01-17','14:50:00',1.43),('10318','2013-01-17','14:55:00',1.95),('10318','2013-01-17','15:00:00',1.68),('10318','2013-01-17','15:05:00',1.4),('10318','2013-01-17','15:20:00',1.05),('10318','2013-01-17','15:25:00',1.04),('10318','2013-01-16','08:40:00',1.15),('10318','2013-01-16','09:10:00',2.8),('10318','2013-01-16','09:15:00',3.45),('10318','2013-01-16','09:20:00',3.6),('10318','2013-01-16','09:25:00',5.26),('10318','2013-01-16','09:30:00',5.37),('10318','2013-01-16','09:35:00',5.5),('10318','2013-01-16','09:40:00',4.28),('10318','2013-01-16','09:45:00',2.78),('10318','2013-01-16','09:50:00',1.31),('10318','2013-01-16','09:55:00',2.08),('10318','2013-01-16','10:00:00',1.33),('10318','2013-01-16','10:20:00',1.19),('10318','2013-01-16','10:25:00',1.44),('10318','2013-01-16','10:30:00',2.69),('10318','2013-01-16','10:35:00',5.76),('10318','2013-01-16','10:40:00',7.01),('10318','2013-01-16','10:45:00',4.13),('10318','2013-01-16','10:50:00',5.79),('10318','2013-01-16','10:55:00',3.85),('10318','2013-01-16','11:00:00',1.67),('10318','2013-01-16','11:05:00',1.5),('10318','2013-01-16','12:00:00',3.7),('10318','2013-01-16','12:05:00',3.58),('10318','2013-01-16','12:10:00',7.29),('10318','2013-01-16','12:15:00',8.58),('10318','2013-01-16','12:20:00',6.24),('10318','2013-01-16','12:25:00',1.24),('10318','2013-01-16','13:00:00',1.01),('10318','2013-01-16','13:05:00',5.58),('10318','2013-01-16','13:10:00',5),('10318','2013-01-16','13:15:00',8.07),('10318','2013-01-16','13:20:00',5.68),('10318','2013-01-16','13:25:00',2.02),('10318','2013-01-16','13:30:00',1.22),('10318','2013-01-16','13:50:00',3.46),('10318','2013-01-16','13:55:00',6.94),('10318','2013-01-16','14:00:00',2.36),('10318','2013-01-16','15:00:00',1.89),('10318','2013-01-16','15:05:00',1.76),('10318','2013-01-16','15:10:00',1.79),('10318','2013-01-16','16:00:00',1.73),('10318','2013-01-16','16:05:00',1.86),('10318','2013-01-16','16:10:00',1.44),('10318','2013-01-16','16:15:00',1.29),('10318','2013-01-15','08:10:00',1.2),('10318','2013-01-15','08:15:00',1.4),('10318','2013-01-15','08:20:00',1.21),('10318','2013-01-15','08:25:00',1.26),('10318','2013-01-15','08:30:00',1.67),('10318','2013-01-15','08:35:00',1.34),('10318','2013-01-15','08:40:00',1.63),('10318','2013-01-15','08:45:00',1.06),('10318','2013-01-15','08:55:00',1.48),('10318','2013-01-15','09:00:00',1.2),('10318','2013-01-15','09:05:00',1.25),('10318','2013-01-15','09:10:00',1.43),('10318','2013-01-15','09:15:00',1.63),('10318','2013-01-15','09:20:00',1.15),('10318','2013-01-15','09:50:00',1.19),('10318','2013-01-15','09:55:00',2.15),('10318','2013-01-15','10:00:00',2.61),('10318','2013-01-15','10:05:00',1.53),('10318','2013-01-15','10:10:00',1.78),('10318','2013-01-15','10:15:00',1.71),('10318','2013-01-15','10:20:00',1.91),('10318','2013-01-15','10:25:00',2.76),('10318','2013-01-15','10:30:00',2.05),('10318','2013-01-15','10:35:00',2.02),('10318','2013-01-15','10:40:00',2.22),('10318','2013-01-15','10:45:00',2.54),('10318','2013-01-15','10:50:00',3.25),('10318','2013-01-15','10:55:00',3.86),('10318','2013-01-15','11:00:00',3.51),('10318','2013-01-15','11:05:00',3.64),('10318','2013-01-15','11:10:00',4.08),('10318','2013-01-15','11:15:00',3.86),('10318','2013-01-15','11:20:00',3.74),('10318','2013-01-15','11:25:00',3.52),('10318','2013-01-15','11:30:00',3.23),('10318','2013-01-15','11:35:00',2.82),('10318','2013-01-15','11:40:00',2.66),('10318','2013-01-15','11:45:00',2.54),('10318','2013-01-15','11:50:00',2.53),('10318','2013-01-15','11:55:00',2.67),('10318','2013-01-15','12:00:00',2.39),('10318','2013-01-15','12:05:00',2.24),('10318','2013-01-15','12:10:00',2.36),('10318','2013-01-15','12:15:00',2.56),('10318','2013-01-15','12:20:00',2.82),('10318','2013-01-15','12:25:00',2.99),('10318','2013-01-15','12:30:00',2.93),('10318','2013-01-15','12:35:00',3.04),('10318','2013-01-15','12:40:00',3.31),('10318','2013-01-15','12:45:00',3.46),('10318','2013-01-15','12:50:00',3.4),('10318','2013-01-15','12:55:00',2.77),('10318','2013-01-15','13:00:00',2.43),('10318','2013-01-15','13:05:00',2.49),('10318','2013-01-15','13:10:00',2.55),('10318','2013-01-15','13:15:00',2.53),('10318','2013-01-15','13:20:00',2.46),('10318','2013-01-15','13:25:00',2.4),('10318','2013-01-15','13:30:00',2.62),('10318','2013-01-15','13:35:00',2.86),('10318','2013-01-15','13:40:00',3.14),('10318','2013-01-15','13:45:00',2.76),('10318','2013-01-15','13:50:00',2.52),('10318','2013-01-15','13:55:00',3),('10318','2013-01-15','14:00:00',2.83),('10318','2013-01-15','14:05:00',2.46),('10318','2013-01-15','14:10:00',3.71),('10318','2013-01-15','14:15:00',4.7),('10318','2013-01-15','14:20:00',5.85),('10318','2013-01-15','14:25:00',5.08),('10318','2013-01-15','14:30:00',5.11),('10318','2013-01-15','14:35:00',4.94),('10318','2013-01-15','14:40:00',4.73),('10318','2013-01-15','14:45:00',4.05),('10318','2013-01-15','14:50:00',2.5),('10318','2013-01-15','14:55:00',3.25),('10318','2013-01-15','15:00:00',3.85),('10318','2013-01-15','15:05:00',3.82),('10318','2013-01-15','15:10:00',3.61),('10318','2013-01-15','15:15:00',3.18),('10318','2013-01-15','15:20:00',2.91),('10318','2013-01-15','15:25:00',2.83),('10318','2013-01-15','15:30:00',2.71),('10318','2013-01-15','15:35:00',2.56),('10318','2013-01-15','15:40:00',2.04),('10318','2013-01-15','15:45:00',1.67),('10318','2013-01-15','15:50:00',1.66),('10318','2013-01-15','15:55:00',1.98),('10318','2013-01-15','16:00:00',2.06),('10318','2013-01-15','16:05:00',2.3),('10318','2013-01-15','16:10:00',2.04),('10318','2013-01-15','16:15:00',1.85),('10318','2013-01-15','16:20:00',1.62),('10318','2013-01-15','16:25:00',1.37),('10318','2013-01-15','16:30:00',1.15),('10318','2013-01-14','09:50:00',1.18),('10318','2013-01-14','10:25:00',1.33),('10318','2013-01-14','10:35:00',1.2),('10318','2013-01-14','10:45:00',1.02),('10318','2013-01-14','10:55:00',1.06),('10318','2013-01-14','11:05:00',1.22),('10318','2013-01-14','11:10:00',1.06),('10318','2013-01-14','11:20:00',1.45),('10318','2013-01-14','11:25:00',1.36),('10318','2013-01-14','11:30:00',1.18),('10318','2013-01-14','11:35:00',1.14),('10318','2013-01-14','11:40:00',1.19),('10318','2013-01-14','11:45:00',1.03),('10318','2013-01-14','11:50:00',1.25),('10318','2013-01-14','11:55:00',1.11),('10318','2013-01-14','12:15:00',1.34),('10318','2013-01-14','12:20:00',1.59),('10318','2013-01-14','12:25:00',1.94),('10318','2013-01-14','12:30:00',1.99),('10318','2013-01-14','12:35:00',1.63),('10318','2013-01-14','12:40:00',2.02),('10318','2013-01-14','12:45:00',2.29),('10318','2013-01-14','12:50:00',2.39),('10318','2013-01-14','12:55:00',2.57),('10318','2013-01-14','13:00:00',2.59),('10318','2013-01-14','13:05:00',2.4),('10318','2013-01-14','13:10:00',1.62),('10318','2013-01-14','13:15:00',1.46),('10318','2013-01-14','13:20:00',1.13),('10318','2013-01-14','13:30:00',1.11),('10318','2013-01-14','13:35:00',1.4),('10318','2013-01-14','15:10:00',1.64),('10318','2013-01-14','15:15:00',1.78),('10318','2013-01-14','15:20:00',1.83),('10318','2013-01-14','15:25:00',1.57),('10318','2013-01-13','09:10:00',1.46),('10318','2013-01-13','09:15:00',4.53),('10318','2013-01-13','09:20:00',4.55),('10318','2013-01-13','09:25:00',4.51),('10318','2013-01-13','09:30:00',3.91),('10318','2013-01-13','09:35:00',4.15),('10318','2013-01-13','09:40:00',3.84),('10318','2013-01-13','09:45:00',3.21),('10318','2013-01-13','09:50:00',3.88),('10318','2013-01-13','09:55:00',5.02),('10318','2013-01-13','10:00:00',5.26),('10318','2013-01-13','10:05:00',5.85),('10318','2013-01-13','10:10:00',5.79),('10318','2013-01-13','10:15:00',6.14),('10318','2013-01-13','10:20:00',4.48),('10318','2013-01-13','10:25:00',7.84),('10318','2013-01-13','10:30:00',3.29),('10318','2013-01-13','10:35:00',1.95),('10318','2013-01-13','10:40:00',1.84),('10318','2013-01-13','10:45:00',1.21),('10318','2013-01-13','12:05:00',1.01),('10318','2013-01-13','12:10:00',1.15),('10318','2013-01-13','12:15:00',1.36),('10318','2013-01-13','12:20:00',1.41),('10318','2013-01-13','12:35:00',1.08),('10318','2013-01-13','12:40:00',1.25),('10318','2013-01-12','08:05:00',1.01),('10318','2013-01-12','08:10:00',1.37),('10318','2013-01-12','08:15:00',1.67),('10318','2013-01-12','08:20:00',1.93),('10318','2013-01-12','08:25:00',2.28),('10318','2013-01-12','08:30:00',2.52),('10318','2013-01-12','08:35:00',2.78),('10318','2013-01-12','08:40:00',3.15),('10318','2013-01-12','08:45:00',3.32),('10318','2013-01-12','08:50:00',3.55),('10318','2013-01-12','08:55:00',3.74),('10318','2013-01-12','09:00:00',3.97),('10318','2013-01-12','09:05:00',4.18),('10318','2013-01-12','09:10:00',4.38),('10318','2013-01-12','09:15:00',4.54),('10318','2013-01-12','09:20:00',4.66),('10318','2013-01-12','09:25:00',4.8),('10318','2013-01-12','09:30:00',4.94),('10318','2013-01-12','09:35:00',5.09),('10318','2013-01-12','09:40:00',5.24),('10318','2013-01-12','09:45:00',5.4),('10318','2013-01-12','09:50:00',5.54),('10318','2013-01-12','09:55:00',5.63),('10318','2013-01-12','10:00:00',5.75),('10318','2013-01-12','10:05:00',5.84),('10318','2013-01-12','10:10:00',5.94),('10318','2013-01-12','10:15:00',6.03),('10318','2013-01-12','10:20:00',6.03),('10318','2013-01-12','10:25:00',6.19),('10318','2013-01-12','10:30:00',6.3),('10318','2013-01-12','10:35:00',6.4),('10318','2013-01-12','10:40:00',6.38),('10318','2013-01-12','10:45:00',6.47),('10318','2013-01-12','10:50:00',6.51),('10318','2013-01-12','10:55:00',6.58),('10318','2013-01-12','11:00:00',6.6),('10318','2013-01-12','11:05:00',6.7),('10318','2013-01-12','11:10:00',6.65),('10318','2013-01-12','11:15:00',6.66),('10318','2013-01-12','11:20:00',6.58),('10318','2013-01-12','11:25:00',6.7),('10318','2013-01-12','11:30:00',6.74),('10318','2013-01-12','11:35:00',6.72),('10318','2013-01-12','11:40:00',6.73),('10318','2013-01-12','11:45:00',6.67),('10318','2013-01-12','11:50:00',6.61),('10318','2013-01-12','11:55:00',6.55),('10318','2013-01-12','12:00:00',6.44),('10318','2013-01-12','12:05:00',6.41),('10318','2013-01-12','12:10:00',6.27),('10318','2013-01-12','12:15:00',6.33),('10318','2013-01-12','12:20:00',6.27),('10318','2013-01-12','12:25:00',6.39),('10318','2013-01-12','12:30:00',6.27),('10318','2013-01-12','12:35:00',6.22),('10318','2013-01-12','12:40:00',3.22),('10318','2013-01-12','12:45:00',2.26),('10318','2013-01-12','12:50:00',4.23),('10318','2013-01-12','12:55:00',5.77),('10318','2013-01-12','13:00:00',6.13),('10318','2013-01-12','13:05:00',6.02),('10318','2013-01-12','13:10:00',5.62),('10318','2013-01-12','13:15:00',5.25),('10318','2013-01-12','13:20:00',5.31),('10318','2013-01-12','13:25:00',4.67),('10318','2013-01-12','13:30:00',5.93),('10318','2013-01-12','13:35:00',5.76),('10318','2013-01-12','13:40:00',4.6),('10318','2013-01-12','13:45:00',2.69),('10318','2013-01-12','13:50:00',2.48),('10318','2013-01-12','13:55:00',5.75),('10318','2013-01-12','14:00:00',5.03),('10318','2013-01-12','14:05:00',5.01),('10318','2013-01-12','14:10:00',5.21),('10318','2013-01-12','14:15:00',4.24),('10318','2013-01-12','14:20:00',4.43),('10318','2013-01-12','14:25:00',4.25),('10318','2013-01-12','14:30:00',4.14),('10318','2013-01-12','14:35:00',4.02),('10318','2013-01-12','14:40:00',3.9),('10318','2013-01-12','14:45:00',3.71),('10318','2013-01-12','14:50:00',3.5),('10318','2013-01-12','14:55:00',3.36),('10318','2013-01-12','15:00:00',3.17),('10318','2013-01-12','15:05:00',3.05),('10318','2013-01-12','15:10:00',2.87),('10318','2013-01-12','15:15:00',2.86),('10318','2013-01-12','15:20:00',2.1),('10318','2013-01-12','15:25:00',2.35),('10318','2013-01-12','15:30:00',1.36),('10318','2013-01-12','15:35:00',2.18),('10318','2013-01-12','15:40:00',1.99),('10318','2013-01-12','15:45:00',1.95),('10318','2013-01-12','15:50:00',1.82),('10318','2013-01-12','15:55:00',1.68),('10318','2013-01-12','16:00:00',1.53),('10318','2013-01-12','16:05:00',1.36),('10318','2013-01-12','16:10:00',1.18),('10318','2014-03-19','07:55:00',1.25),('10318','2014-03-19','08:00:00',1.36),('10318','2014-03-19','08:05:00',1.08),('10318','2014-03-19','08:10:00',1.16),('10318','2014-03-19','08:15:00',1.22),('10318','2014-03-19','08:20:00',1.42),('10318','2014-03-19','08:25:00',1.56),('10318','2014-03-19','08:30:00',1.78),('10318','2014-03-19','08:35:00',1.86),('10318','2014-03-19','08:40:00',2.14),('10318','2014-03-19','08:45:00',2.32),('10318','2014-03-19','08:50:00',2.43),('10318','2014-03-19','08:55:00',2.57),('10318','2014-03-19','09:00:00',2.55),('10318','2014-03-19','09:05:00',2.55),('10318','2014-03-19','09:10:00',2.75),('10318','2014-03-19','09:15:00',3.06),('10318','2014-03-19','09:20:00',3.31),('10318','2014-03-19','09:25:00',4),('10318','2014-03-19','09:30:00',4.41),('10318','2014-03-19','09:35:00',5.63),('10318','2014-03-19','09:40:00',5.84),('10318','2014-03-19','09:45:00',4.56),('10318','2014-03-19','09:50:00',3.64),('10318','2014-03-19','09:55:00',3.32),('10318','2014-03-19','10:00:00',7.08),('10318','2014-03-19','10:05:00',6.14),('10318','2014-03-19','10:10:00',3.52),('10318','2014-03-19','10:15:00',3.01),('10318','2014-03-19','10:20:00',3.16),('10318','2014-03-19','10:25:00',4.3),('10318','2014-03-19','10:30:00',6.55),('10318','2014-03-19','10:35:00',7.58),('10318','2014-03-19','10:40:00',4.58),('10318','2014-03-19','10:45:00',4.18),('10318','2014-03-19','10:50:00',3.82),('10318','2014-03-19','10:55:00',3.37),('10318','2014-03-19','11:00:00',2.84),('10318','2014-03-19','11:05:00',2.7),('10318','2014-03-19','11:10:00',3.24),('10318','2014-03-19','11:15:00',3.71),('10318','2014-03-19','11:20:00',6.43),('10318','2014-03-19','11:25:00',7.49),('10318','2014-03-19','11:30:00',8.57),('10318','2014-03-19','11:35:00',10.25),('10318','2014-03-19','11:40:00',10.07),('10318','2014-03-19','11:45:00',5.08),('10318','2014-03-19','11:50:00',4.29),('10318','2014-03-19','11:55:00',5.24),('10318','2014-03-19','12:00:00',8),('10318','2014-03-19','12:05:00',9.47),('10318','2014-03-19','12:10:00',7.82),('10318','2014-03-19','12:15:00',8.02),('10318','2014-03-19','12:20:00',6.6),('10318','2014-03-19','12:25:00',9.01),('10318','2014-03-19','12:30:00',8.29),('10318','2014-03-19','12:35:00',8.33),('10318','2014-03-19','12:40:00',8.75),('10318','2014-03-19','12:45:00',8.44),('10318','2014-03-19','12:50:00',8.82),('10318','2014-03-19','12:55:00',6.56),('10318','2014-03-19','13:00:00',8.34),('10318','2014-03-19','13:05:00',8),('10318','2014-03-19','13:10:00',8.62),('10318','2014-03-19','13:15:00',8.02),('10318','2014-03-19','13:20:00',6.91),('10318','2014-03-19','13:25:00',7.56),('10318','2014-03-19','13:30:00',7.97),('10318','2014-03-19','13:35:00',7.88),('10318','2014-03-19','13:40:00',7.74),('10318','2014-03-19','13:45:00',7.52),('10318','2014-03-19','13:50:00',7.05),('10318','2014-03-19','13:55:00',7.49),('10318','2014-03-19','14:00:00',7.22),('10318','2014-03-19','14:05:00',7.09),('10318','2014-03-19','14:10:00',6.96),('10318','2014-03-19','14:15:00',6.66),('10318','2014-03-19','14:20:00',6.7),('10318','2014-03-19','14:25:00',6.62),('10318','2014-03-19','14:30:00',6.45),('10318','2014-03-19','14:35:00',6.52),('10318','2014-03-19','14:40:00',6.35),('10318','2014-03-19','14:45:00',6.18),('10318','2014-03-19','14:50:00',6.03),('10318','2014-03-19','14:55:00',5.77),('10318','2014-03-19','15:00:00',5.59),('10318','2014-03-19','15:05:00',5.44),('10318','2014-03-19','15:10:00',5.35),('10318','2014-03-19','15:15:00',5.23),('10318','2014-03-19','15:20:00',4.99),('10318','2014-03-19','15:25:00',4.85),('10318','2014-03-19','15:30:00',4.58),('10318','2014-03-19','15:35:00',4.4),('10318','2014-03-19','15:40:00',4.32),('10318','2014-03-19','15:45:00',4.14),('10318','2014-03-19','15:50:00',3.92),('10318','2014-03-19','15:55:00',3.8),('10318','2014-03-19','16:00:00',3.58),('10318','2014-03-19','16:05:00',3.45),('10318','2014-03-19','16:10:00',3.3),('10318','2014-03-19','16:15:00',3.13),('10318','2014-03-19','16:20:00',2.91),('10318','2014-03-19','16:25:00',2.69),('10318','2014-03-19','16:30:00',2.44),('10318','2014-03-19','16:35:00',2.21),('10318','2014-03-19','16:40:00',2.01),('10318','2014-03-19','16:45:00',1.9),('10318','2014-03-19','16:50:00',1.6),('10318','2014-03-19','16:55:00',1.52),('10318','2014-03-19','17:00:00',1.2),('10318','2014-03-19','17:05:00',1.01),('10318','2013-01-11','09:15:00',1.24),('10318','2013-01-11','09:20:00',1.23),('10318','2013-01-11','09:25:00',1.15),('10318','2013-01-11','09:30:00',1.3),('10318','2013-01-11','09:35:00',1.3),('10318','2013-01-11','09:40:00',1.43),('10318','2013-01-11','09:45:00',3.49),('10318','2013-01-11','09:50:00',3.59),('10318','2013-01-11','09:55:00',2.67),('10318','2013-01-11','10:00:00',1.81),('10318','2013-01-11','10:05:00',3.57),('10318','2013-01-11','10:10:00',7.21),('10318','2013-01-11','10:15:00',6.03),('10318','2013-01-11','10:20:00',2.43),('10318','2013-01-11','10:25:00',5.11),('10318','2013-01-11','10:30:00',5.9),('10318','2013-01-11','10:35:00',5.95),('10318','2013-01-11','10:40:00',6.1),('10318','2013-01-11','10:45:00',6.18),('10318','2013-01-11','10:50:00',6.21),('10318','2013-01-11','10:55:00',6.29),('10318','2013-01-11','11:00:00',6.23),('10318','2013-01-11','11:05:00',6.38),('10318','2013-01-11','11:10:00',6.51),('10318','2013-01-11','11:15:00',6.45),('10318','2013-01-11','11:20:00',6.28),('10318','2013-01-11','11:25:00',1.9),('10318','2013-01-11','11:30:00',2.88),('10318','2013-01-11','11:35:00',3.92),('10318','2013-01-11','11:40:00',4.29),('10318','2013-01-11','11:45:00',4.71),('10318','2013-01-11','11:50:00',3.39),('10318','2013-01-11','11:55:00',2.86),('10318','2013-01-11','12:00:00',2.05),('10318','2013-01-11','12:05:00',1.27),('10318','2013-01-11','12:20:00',1.11),('10318','2013-01-11','12:50:00',2.19),('10318','2013-01-11','12:55:00',2.87),('10318','2013-01-11','13:00:00',3.07),('10318','2013-01-11','13:05:00',2.36),('10318','2013-01-11','13:10:00',2.28),('10318','2013-01-11','13:15:00',1.92),('10318','2013-01-11','13:20:00',1.84),('10318','2013-01-11','13:25:00',1.94),('10318','2013-01-11','13:30:00',2.21),('10318','2013-01-11','13:35:00',6.55),('10318','2013-01-11','13:40:00',3.74),('10318','2013-01-11','13:45:00',4.41),('10318','2013-01-11','14:15:00',1.45),('10318','2013-01-11','14:20:00',2.37),('10318','2013-01-11','14:25:00',1.76),('10318','2013-01-11','14:30:00',1.77),('10318','2013-01-11','14:35:00',1.74),('10318','2013-01-11','14:40:00',1.74),('10318','2013-01-11','14:45:00',3.29),('10318','2013-01-11','14:50:00',4.26),('10318','2013-01-11','14:55:00',3.75),('10318','2013-01-11','15:00:00',3.7),('10318','2013-01-11','15:05:00',1.8),('10318','2013-01-11','15:10:00',1.09),('10318','2013-01-11','15:40:00',1.87),('10318','2013-01-11','15:45:00',1.35),('10318','2013-01-10','09:55:00',1.18),('10318','2013-01-10','10:00:00',1.33),('10318','2013-01-10','10:05:00',1.3),('10318','2013-01-10','10:10:00',1.21),('10318','2013-01-10','10:15:00',1.03),('10318','2013-01-10','10:20:00',1.03),('10318','2013-01-10','10:25:00',1.22),('10318','2013-01-10','11:15:00',1.19),('10318','2013-01-10','11:20:00',1.24),('10318','2013-01-10','11:25:00',2.09),('10318','2013-01-10','11:30:00',2.61),('10318','2013-01-10','11:35:00',1.92),('10318','2013-01-10','11:40:00',1.34),('10318','2013-01-10','11:45:00',1.44),('10318','2013-01-10','11:50:00',2.21),('10318','2013-01-10','11:55:00',2.66),('10318','2013-01-10','12:00:00',2.66),('10318','2013-01-10','12:05:00',2.36),('10318','2013-01-10','12:10:00',1.77),('10318','2013-01-10','12:15:00',1.76),('10318','2013-01-10','12:20:00',1.46),('10318','2013-01-10','12:25:00',1.39),('10318','2013-01-10','12:30:00',1.44),('10318','2013-01-10','12:35:00',1.44),('10318','2013-01-10','12:40:00',1.36),('10318','2013-01-10','12:45:00',1.28),('10318','2013-01-10','12:50:00',1.11),('10318','2013-01-10','13:10:00',1.27),('10318','2013-01-10','13:15:00',1.62),('10318','2013-01-10','13:20:00',1.33),('10318','2013-01-10','13:25:00',1.17),('10318','2013-01-10','13:30:00',1.37),('10318','2013-01-10','13:35:00',1.32),('10318','2013-01-10','13:40:00',1.37),('10318','2013-01-10','13:45:00',1.64),('10318','2013-01-10','13:50:00',1.45),('10318','2013-01-10','13:55:00',1.72),('10318','2013-01-10','14:00:00',1.81),('10318','2013-01-10','14:05:00',1.51),('10318','2013-01-10','14:10:00',1.1),('10318','2013-01-09','09:35:00',1.02),('10318','2013-01-09','09:45:00',1.08),('10318','2013-01-09','09:50:00',1.51),('10318','2013-01-09','09:55:00',1.69),('10318','2013-01-09','10:00:00',1.22),('10318','2013-01-09','10:05:00',1.21),('10318','2013-01-09','10:10:00',1.34),('10318','2013-01-09','10:15:00',1.5),('10318','2013-01-09','10:20:00',1.22),('10318','2013-01-09','10:25:00',1.47),('10318','2013-01-09','10:30:00',1.8),('10318','2013-01-09','10:35:00',1.96),('10318','2013-01-09','10:40:00',2.21),('10318','2013-01-09','10:45:00',2.99),('10318','2013-01-09','10:50:00',2.81),('10318','2013-01-09','10:55:00',2.42),('10318','2013-01-09','11:00:00',2.63),('10318','2013-01-09','11:05:00',3.21),('10318','2013-01-09','11:10:00',3.76),('10318','2013-01-09','11:15:00',3.63),('10318','2013-01-09','11:20:00',3.96),('10318','2013-01-09','11:25:00',3.47),('10318','2013-01-09','11:30:00',3.09),('10318','2013-01-09','11:35:00',2.83),('10318','2013-01-09','11:40:00',3.24),('10318','2013-01-09','11:45:00',3.33),('10318','2013-01-09','11:50:00',2.9),('10318','2013-01-09','11:55:00',2.64),('10318','2013-01-09','12:00:00',2.67),('10318','2013-01-09','12:05:00',2.85),('10318','2013-01-09','12:10:00',2.94),('10318','2013-01-09','12:15:00',2.85),('10318','2013-01-09','12:20:00',2.54),('10318','2013-01-09','12:25:00',2.51),('10318','2013-01-09','12:30:00',2.62),('10318','2013-01-09','12:35:00',2.65),('10318','2013-01-09','12:40:00',2.57),('10318','2013-01-09','12:45:00',2.83),('10318','2013-01-09','12:50:00',2.83),('10318','2013-01-09','12:55:00',2.91),('10318','2013-01-09','13:00:00',2.61),('10318','2013-01-09','13:05:00',2.68),('10318','2013-01-09','13:10:00',2.38),('10318','2013-01-09','13:15:00',2.23),('10318','2013-01-09','13:20:00',2.08),('10318','2013-01-09','13:25:00',2.06),('10318','2013-01-09','13:30:00',2.12),('10318','2013-01-09','13:35:00',2.46),('10318','2013-01-09','13:40:00',2.53),('10318','2013-01-09','13:45:00',2.1),('10318','2013-01-09','13:50:00',1.91),('10318','2013-01-09','13:55:00',1.88),('10318','2013-01-09','14:00:00',2),('10318','2013-01-09','14:05:00',1.78),('10318','2013-01-09','14:10:00',1.68),('10318','2013-01-09','14:15:00',1.52),('10318','2013-01-09','14:20:00',1.38),('10318','2013-01-09','14:25:00',1.22),('10318','2013-01-09','14:30:00',1.22),('10318','2013-01-09','14:35:00',1.12),('10318','2013-01-09','15:40:00',1.38),('10318','2013-01-09','15:45:00',1.21),('10318','2013-01-09','15:50:00',1.11),('10318','2013-01-09','15:55:00',1.02),('10318','2013-01-09','16:10:00',1.13),('10318','2013-01-08','08:25:00',1.24),('10318','2013-01-08','08:30:00',2.48),('10318','2013-01-08','08:35:00',3.6),('10318','2013-01-08','08:40:00',3.9),('10318','2013-01-08','08:45:00',4.13),('10318','2013-01-08','08:50:00',3.65),('10318','2013-01-08','08:55:00',4.54),('10318','2013-01-08','09:00:00',4.87),('10318','2013-01-08','09:05:00',4.53),('10318','2013-01-08','09:10:00',2.55),('10318','2013-01-08','09:15:00',4.19),('10318','2013-01-08','09:20:00',4.37),('10318','2013-01-08','09:25:00',5.11),('10318','2013-01-08','09:30:00',4.19),('10318','2013-01-08','09:35:00',4.84),('10318','2013-01-08','09:40:00',4.86),('10318','2013-01-08','09:45:00',5.96),('10318','2013-01-08','09:50:00',6.05),('10318','2013-01-08','09:55:00',5.87),('10318','2013-01-08','10:00:00',5.56),('10318','2013-01-08','10:05:00',4.96),('10318','2013-01-08','10:10:00',5.41),('10318','2013-01-08','10:15:00',4.76),('10318','2013-01-08','10:20:00',4.53),('10318','2013-01-08','10:25:00',4.86),('10318','2013-01-08','10:30:00',5.24),('10318','2013-01-08','10:35:00',5.51),('10318','2013-01-08','10:40:00',4.78),('10318','2013-01-08','10:45:00',4.19),('10318','2013-01-08','10:50:00',5.88),('10318','2013-01-08','10:55:00',6.26),('10318','2013-01-08','11:00:00',6.41),('10318','2013-01-08','11:05:00',6.5),('10318','2013-01-08','11:10:00',6.49),('10318','2013-01-08','11:15:00',6.49),('10318','2013-01-08','11:20:00',6.49),('10318','2013-01-08','11:25:00',6.5),('10318','2013-01-08','11:30:00',6.55),('10318','2013-01-08','11:35:00',6.49),('10318','2013-01-08','11:40:00',6.61),('10318','2013-01-08','11:45:00',7.3),('10318','2013-01-08','11:50:00',4.48),('10318','2013-01-08','11:55:00',5.03),('10318','2013-01-08','12:00:00',4.07),('10318','2013-01-08','12:05:00',3.68),('10318','2013-01-08','12:10:00',3.79),('10318','2013-01-08','12:15:00',3.74),('10318','2013-01-08','12:20:00',2.98),('10318','2013-01-08','12:25:00',2.82),('10318','2013-01-08','12:30:00',2.74),('10318','2013-01-08','12:35:00',2.74),('10318','2013-01-08','12:40:00',3.34),('10318','2013-01-08','12:45:00',3.4),('10318','2013-01-08','12:50:00',3.79),('10318','2013-01-08','12:55:00',4.85),('10318','2013-01-08','13:00:00',2.38),('10318','2013-01-08','13:05:00',2.52),('10318','2013-01-08','13:10:00',1.87),('10318','2013-01-08','13:15:00',1.92),('10318','2013-01-08','13:20:00',2.16),('10318','2013-01-08','13:25:00',1.58),('10318','2013-01-08','13:30:00',1.75),('10318','2013-01-08','13:35:00',1.8),('10318','2013-01-08','13:40:00',3.88),('10318','2013-01-08','13:45:00',2.53),('10318','2013-01-08','13:50:00',3.19),('10318','2013-01-08','13:55:00',2.28),('10318','2013-01-08','14:00:00',2.44),('10318','2013-01-08','14:05:00',1.94),('10318','2013-01-08','14:10:00',1.81),('10318','2013-01-08','14:15:00',1.66),('10318','2013-01-08','14:20:00',1.83),('10318','2013-01-08','14:25:00',1.97),('10318','2013-01-08','14:30:00',1.91),('10318','2013-01-08','14:35:00',1.96),('10318','2013-01-08','14:40:00',1.78),('10318','2013-01-08','14:45:00',1.22),('10318','2013-01-08','14:50:00',1.28),('10318','2013-01-08','14:55:00',1.37),('10318','2013-01-08','15:00:00',1.39),('10318','2013-01-08','15:05:00',1.49),('10318','2013-01-08','15:10:00',1.21),('10318','2013-01-08','15:15:00',1.11),('10318','2013-01-08','15:20:00',1),('10318','2013-01-08','15:35:00',1.18),('10318','2013-01-08','15:40:00',1.11),('10318','2013-01-07','08:10:00',1.17),('10318','2013-01-07','08:15:00',1.44),('10318','2013-01-07','08:20:00',1.73),('10318','2013-01-07','08:25:00',1.98),('10318','2013-01-07','08:30:00',2.37),('10318','2013-01-07','08:35:00',2.63),('10318','2013-01-07','08:40:00',2.88),('10318','2013-01-07','08:45:00',3.09),('10318','2013-01-07','08:50:00',3.3),('10318','2013-01-07','08:55:00',3.53),('10318','2013-01-07','09:00:00',3.49),('10318','2013-01-07','09:05:00',3.18),('10318','2013-01-07','09:10:00',3.04),('10318','2013-01-07','09:15:00',3.34),('10318','2013-01-07','09:20:00',4.31),('10318','2013-01-07','09:25:00',4.52),('10318','2013-01-07','09:30:00',4.67),('10318','2013-01-07','09:35:00',4.84),('10318','2013-01-07','09:40:00',4.96),('10318','2013-01-07','09:45:00',5.14),('10318','2013-01-07','09:50:00',5.31),('10318','2013-01-07','09:55:00',5.41),('10318','2013-01-07','10:00:00',5.49),('10318','2013-01-07','10:05:00',5.61),('10318','2013-01-07','10:10:00',5.67),('10318','2013-01-07','10:15:00',6),('10318','2013-01-07','10:20:00',6.07),('10318','2013-01-07','10:25:00',6.1),('10318','2013-01-07','10:30:00',6.09),('10318','2013-01-07','10:35:00',6.23),('10318','2013-01-07','10:40:00',6.33),('10318','2013-01-07','10:45:00',6.38),('10318','2013-01-07','10:50:00',6.35),('10318','2013-01-07','10:55:00',6.36),('10318','2013-01-07','11:00:00',6.35),('10318','2013-01-07','11:05:00',6.38),('10318','2013-01-07','11:10:00',6.44),('10318','2013-01-07','11:15:00',6.5),('10318','2013-01-07','11:20:00',6.51),('10318','2013-01-07','11:25:00',6.53),('10318','2013-01-07','11:30:00',6.56),('10318','2013-01-07','11:35:00',6.49),('10318','2013-01-07','11:40:00',6.51),('10318','2013-01-07','11:45:00',6.46),('10318','2013-01-07','11:50:00',6.49),('10318','2013-01-07','11:55:00',6.32),('10318','2013-01-07','12:00:00',6.48),('10318','2013-01-07','12:05:00',6.4),('10318','2013-01-07','12:10:00',6.36),('10318','2013-01-07','12:15:00',6.36),('10318','2013-01-07','12:20:00',6.36),('10318','2013-01-07','12:25:00',6.32),('10318','2013-01-07','12:30:00',6.24),('10318','2013-01-07','12:35:00',6.16),('10318','2013-01-07','12:40:00',6.11),('10318','2013-01-07','12:45:00',6.14),('10318','2013-01-07','12:50:00',6),('10318','2013-01-07','12:55:00',5.88),('10318','2013-01-07','13:00:00',5.83),('10318','2013-01-07','13:05:00',5.79),('10318','2013-01-07','13:10:00',5.6),('10318','2013-01-07','13:15:00',5.6),('10318','2013-01-07','13:20:00',5.52),('10318','2013-01-07','13:25:00',5.41),('10318','2013-01-07','13:30:00',5.34),('10318','2013-01-07','13:35:00',5.18),('10318','2013-01-07','13:40:00',5.08),('10318','2013-01-07','13:45:00',5.02),('10318','2013-01-07','13:50:00',4.86),('10318','2013-01-07','13:55:00',4.73),('10318','2013-01-07','14:00:00',4.63),('10318','2013-01-07','14:05:00',4.52),('10318','2013-01-07','14:10:00',4.49),('10318','2013-01-07','14:15:00',4.4),('10318','2013-01-07','14:20:00',4.31),('10318','2013-01-07','14:25:00',4.15),('10318','2013-01-07','14:30:00',4.01),('10318','2013-01-07','14:35:00',3.87),('10318','2013-01-07','14:40:00',3.73),('10318','2013-01-07','14:45:00',3.59),('10318','2013-01-07','14:50:00',3.45),('10318','2013-01-07','14:55:00',3.26),('10318','2013-01-07','15:00:00',3.18),('10318','2013-01-07','15:05:00',3.03),('10318','2013-01-07','15:10:00',2.85),('10318','2013-01-07','15:15:00',2.71),('10318','2013-01-07','15:20:00',2.57),('10318','2013-01-07','15:25:00',2.46),('10318','2013-01-07','15:30:00',2.44),('10318','2013-01-07','15:35:00',2.3),('10318','2013-01-07','15:40:00',2.15),('10318','2013-01-07','15:45:00',1.99),('10318','2013-01-07','15:50:00',1.84),('10318','2013-01-07','15:55:00',1.68),('10318','2013-01-07','16:00:00',1.52),('10318','2013-01-07','16:05:00',1.35),('10318','2013-01-07','16:10:00',1.18),('10318','2013-01-07','16:15:00',1.01),('10318','2013-01-06','08:00:00',1.06),('10318','2013-01-06','08:05:00',1.34),('10318','2013-01-06','08:10:00',1.64),('10318','2013-01-06','08:15:00',1.89),('10318','2013-01-06','08:20:00',2.12),('10318','2013-01-06','08:25:00',2.36),('10318','2013-01-06','08:30:00',2.64),('10318','2013-01-06','08:35:00',2.94),('10318','2013-01-06','08:40:00',3.18),('10318','2013-01-06','08:45:00',3.38),('10318','2013-01-06','08:50:00',3.57),('10318','2013-01-06','08:55:00',3.78),('10318','2013-01-06','09:00:00',3.96),('10318','2013-01-06','09:05:00',4.14),('10318','2013-01-06','09:10:00',4.23),('10318','2013-01-06','09:15:00',4.47),('10318','2013-01-06','09:20:00',4.63),('10318','2013-01-06','09:25:00',4.78),('10318','2013-01-06','09:30:00',4.94),('10318','2013-01-06','09:35:00',5.08),('10318','2013-01-06','09:40:00',5.2),('10318','2013-01-06','09:45:00',5.34),('10318','2013-01-06','09:50:00',5.48),('10318','2013-01-06','09:55:00',5.53),('10318','2013-01-06','10:00:00',5.68),('10318','2013-01-06','10:05:00',5.74),('10318','2013-01-06','10:10:00',5.82),('10318','2013-01-06','10:15:00',5.92),('10318','2013-01-06','10:20:00',5.95),('10318','2013-01-06','10:25:00',6.07),('10318','2013-01-06','10:30:00',6.17),('10318','2013-01-06','10:35:00',6.25),('10318','2013-01-06','10:40:00',6.29),('10318','2013-01-06','10:45:00',6.27),('10318','2013-01-06','10:50:00',6.31),('10318','2013-01-06','10:55:00',6.29),('10318','2013-01-06','11:00:00',6.4),('10318','2013-01-06','11:05:00',6.44),('10318','2013-01-06','11:10:00',6.46),('10318','2013-01-06','11:15:00',6.51),('10318','2013-01-06','11:20:00',6.55),('10318','2013-01-06','11:25:00',6.55),('10318','2013-01-06','11:30:00',6.56),('10318','2013-01-06','11:35:00',6.55),('10318','2013-01-06','11:40:00',6.55),('10318','2013-01-06','11:45:00',6.57),('10318','2013-01-06','11:50:00',6.56),('10318','2013-01-06','11:55:00',6.54),('10318','2013-01-06','12:00:00',6.53),('10318','2013-01-06','12:05:00',6.5),('10318','2013-01-06','12:10:00',6.42),('10318','2013-01-06','12:15:00',6.37),('10318','2013-01-06','12:20:00',6.26),('10318','2013-01-06','12:25:00',6.27),('10318','2013-01-06','12:30:00',6.28),('10318','2013-01-06','12:35:00',6.2),('10318','2013-01-06','12:40:00',6.16),('10318','2013-01-06','12:45:00',6.24),('10318','2013-01-06','12:50:00',6.2),('10318','2013-01-06','12:55:00',6.15),('10318','2013-01-06','13:00:00',6.1),('10318','2013-01-06','13:05:00',6.02),('10318','2013-01-06','13:10:00',5.92),('10318','2013-01-06','13:15:00',5.81),('10318','2013-01-06','13:20:00',5.75),('10318','2013-01-06','13:25:00',5.65),('10318','2013-01-06','13:30:00',5.54),('10318','2013-01-06','13:35:00',5.39),('10318','2013-01-06','13:40:00',5.28),('10318','2013-01-06','13:45:00',5.15),('10318','2013-01-06','13:50:00',5),('10318','2013-01-06','13:55:00',4.76),('10318','2013-01-06','14:00:00',4.77),('10318','2013-01-06','14:05:00',4.69),('10318','2013-01-06','14:10:00',4.52),('10318','2013-01-06','14:15:00',4.33),('10318','2013-01-06','14:20:00',4.13),('10318','2013-01-06','14:25:00',4.05),('10318','2013-01-06','14:30:00',3.81),('10318','2013-01-06','14:35:00',3.66),('10318','2013-01-06','14:40:00',3.58),('10318','2013-01-06','14:45:00',3.42),('10318','2013-01-06','14:50:00',3.23),('10318','2013-01-06','14:55:00',3.1),('10318','2013-01-06','15:00:00',2.98),('10318','2013-01-06','15:05:00',2.82),('10318','2013-01-06','15:10:00',2.76),('10318','2013-01-06','15:15:00',2.63),('10318','2013-01-06','15:20:00',2.47),('10318','2013-01-06','15:25:00',2.35),('10318','2013-01-06','15:30:00',2.19),('10318','2013-01-06','15:35:00',2.04),('10318','2013-01-06','15:40:00',1.85),('10318','2013-01-06','15:45:00',1.74),('10318','2013-01-06','15:50:00',1.6),('10318','2013-01-06','15:55:00',1.48),('10318','2013-01-06','16:00:00',1.35),('10318','2013-01-06','16:05:00',1.19),('10318','2013-01-06','16:10:00',1.04),('10318','2013-01-05','08:35:00',1.24),('10318','2013-01-05','08:40:00',1.38),('10318','2013-01-05','08:45:00',2.08),('10318','2013-01-05','08:50:00',1.93),('10318','2013-01-05','08:55:00',1.63),('10318','2013-01-05','09:00:00',1.48),('10318','2013-01-05','09:05:00',1.62),('10318','2013-01-05','09:10:00',1.64),('10318','2013-01-05','09:15:00',1.58),('10318','2013-01-05','09:20:00',1.48),('10318','2013-01-05','09:25:00',1.58),('10318','2013-01-05','09:30:00',1.56),('10318','2013-01-05','09:35:00',1.75),('10318','2013-01-05','09:40:00',1.85),('10318','2013-01-05','09:45:00',1.71),('10318','2013-01-05','09:50:00',1.63),('10318','2013-01-05','09:55:00',1.73),('10318','2013-01-05','10:00:00',1.94),('10318','2013-01-05','10:05:00',2.12),('10318','2013-01-05','10:10:00',2.51),('10318','2013-01-05','10:15:00',2.58),('10318','2013-01-05','10:20:00',2.91),('10318','2013-01-05','10:25:00',2.36),('10318','2013-01-05','10:30:00',2.39),('10318','2013-01-05','10:35:00',2.81),('10318','2013-01-05','10:40:00',2.81),('10318','2013-01-05','10:45:00',3.1),('10318','2013-01-05','10:50:00',3.53),('10318','2013-01-05','10:55:00',5.64),('10318','2013-01-05','11:00:00',5.57),('10318','2013-01-05','11:05:00',5.03),('10318','2013-01-05','11:10:00',5.28),('10318','2013-01-05','11:15:00',4.79),('10318','2013-01-05','11:20:00',6.22),('10318','2013-01-05','11:25:00',6.37),('10318','2013-01-05','11:30:00',6.06),('10318','2013-01-05','11:35:00',5.58),('10318','2013-01-05','11:40:00',5.34),('10318','2013-01-05','11:45:00',5.4),('10318','2013-01-05','11:50:00',4.73),('10318','2013-01-05','11:55:00',4.06),('10318','2013-01-05','12:00:00',3.63),('10318','2013-01-05','12:05:00',3.7),('10318','2013-01-05','12:10:00',3.85),('10318','2013-01-05','12:15:00',3.84),('10318','2013-01-05','12:20:00',3.41),('10318','2013-01-05','12:25:00',2.82),('10318','2013-01-05','12:30:00',2.77),('10318','2013-01-05','12:35:00',3.81),('10318','2013-01-05','12:40:00',5.29),('10318','2013-01-05','12:45:00',5),('10318','2013-01-05','12:50:00',3.11),('10318','2013-01-05','12:55:00',2.77),('10318','2013-01-05','13:00:00',2.75),('10318','2013-01-05','13:05:00',2.9),('10318','2013-01-05','13:10:00',2.85),('10318','2013-01-05','13:15:00',2.48),('10318','2013-01-05','13:20:00',2.05),('10318','2013-01-05','13:25:00',2.88),('10318','2013-01-05','13:30:00',3.74),('10318','2013-01-05','13:35:00',2.91),('10318','2013-01-05','13:40:00',2.33),('10318','2013-01-05','13:45:00',1.94),('10318','2013-01-05','13:50:00',2.06),('10318','2013-01-05','13:55:00',2.99),('10318','2013-01-05','14:00:00',2.3),('10318','2013-01-05','14:05:00',3.94),('10318','2013-01-05','14:10:00',3.49),('10318','2013-01-05','14:15:00',3.56),('10318','2013-01-05','14:20:00',2.9),('10318','2013-01-05','14:25:00',1.75),('10318','2013-01-05','14:30:00',2.41),('10318','2013-01-05','14:35:00',2.56),('10318','2013-01-05','14:40:00',2.82),('10318','2013-01-05','14:45:00',2.58),('10318','2013-01-05','14:50:00',2.34),('10318','2013-01-05','14:55:00',2.31),('10318','2013-01-05','15:00:00',2.35),('10318','2013-01-05','15:05:00',1.78),('10318','2013-01-05','15:40:00',1.1),('10318','2013-01-04','08:10:00',1.14),('10318','2013-01-04','08:15:00',1.24),('10318','2013-01-04','08:20:00',1.38),('10318','2013-01-04','08:25:00',1.41),('10318','2013-01-04','08:30:00',1.4),('10318','2013-01-04','08:35:00',2.12),('10318','2013-01-04','08:40:00',2.31),('10318','2013-01-04','08:45:00',3.3),('10318','2013-01-04','08:50:00',3.26),('10318','2013-01-04','08:55:00',3.61),('10318','2013-01-04','09:00:00',3.42),('10318','2013-01-04','09:05:00',3.38),('10318','2013-01-04','09:10:00',3.78),('10318','2013-01-04','09:15:00',3.59),('10318','2013-01-04','09:20:00',3.8),('10318','2013-01-04','09:25:00',3.52),('10318','2013-01-04','09:30:00',3.8),('10318','2013-01-04','09:35:00',3.28),('10318','2013-01-04','09:40:00',3.68),('10318','2013-01-04','09:45:00',4),('10318','2013-01-04','09:50:00',4.67),('10318','2013-01-04','09:55:00',4.91),('10318','2013-01-04','10:00:00',5.73),('10318','2013-01-04','10:05:00',6.04),('10318','2013-01-04','10:10:00',5.31),('10318','2013-01-04','10:15:00',5.57),('10318','2013-01-04','10:20:00',4.97),('10318','2013-01-04','10:25:00',5.29),('10318','2013-01-04','10:30:00',6.06),('10318','2013-01-04','10:35:00',6.29),('10318','2013-01-04','10:40:00',6.31),('10318','2013-01-04','10:45:00',6.55),('10318','2013-01-04','10:50:00',6.73),('10318','2013-01-04','10:55:00',6.99),('10318','2013-01-04','11:00:00',6.55),('10318','2013-01-04','11:05:00',3.46),('10318','2013-01-04','11:10:00',2.45),('10318','2013-01-04','11:15:00',4.18),('10318','2013-01-04','11:20:00',1.98),('10318','2013-01-04','11:25:00',1.69),('10318','2013-01-04','11:30:00',1.88),('10318','2013-01-04','11:35:00',1.71),('10318','2013-01-04','11:40:00',2.34),('10318','2013-01-04','11:45:00',2.6),('10318','2013-01-04','11:50:00',5.46),('10318','2013-01-04','11:55:00',7.05),('10318','2013-01-04','12:00:00',7.75),('10318','2013-01-04','12:05:00',6.09),('10318','2013-01-04','12:10:00',4.13),('10318','2013-01-04','12:15:00',2.83),('10318','2013-01-04','12:20:00',2.26),('10318','2013-01-04','12:25:00',3),('10318','2013-01-04','12:30:00',5.15),('10318','2013-01-04','12:35:00',4.51),('10318','2013-01-04','12:40:00',5.81),('10318','2013-01-04','12:45:00',5.73),('10318','2013-01-04','12:50:00',6.38),('10318','2013-01-04','12:55:00',6.24),('10318','2013-01-04','13:00:00',5.98),('10318','2013-01-04','13:05:00',5.1),('10318','2013-01-04','13:10:00',4.34),('10318','2013-01-04','13:15:00',4.62),('10318','2013-01-04','13:20:00',5.5),('10318','2013-01-04','13:25:00',5.35),('10318','2013-01-04','13:30:00',5.28),('10318','2013-01-04','13:35:00',5.14),('10318','2013-01-04','13:40:00',4.99),('10318','2013-01-04','13:45:00',4.93),('10318','2013-01-04','13:50:00',4.74),('10318','2013-01-04','13:55:00',4.64),('10318','2013-01-04','14:00:00',4.57),('10318','2013-01-04','14:05:00',4.42),('10318','2013-01-04','14:10:00',4.26),('10318','2013-01-04','14:15:00',4.11),('10318','2013-01-04','14:20:00',3.89),('10318','2013-01-04','14:25:00',3.71),('10318','2013-01-04','14:30:00',3.65),('10318','2013-01-04','14:35:00',3.55),('10318','2013-01-04','14:40:00',3.41),('10318','2013-01-04','14:45:00',3.36),('10318','2013-01-04','14:50:00',3.1),('10318','2013-01-04','14:55:00',2.96),('10318','2013-01-04','15:00:00',2.9),('10318','2013-01-04','15:05:00',2.69),('10318','2013-01-04','15:10:00',2.45),('10318','2013-01-04','15:15:00',2.51),('10318','2013-01-04','15:20:00',2.43),('10318','2013-01-04','15:25:00',2.24),('10318','2013-01-04','15:30:00',2.08),('10318','2013-01-04','15:35:00',1.97),('10318','2013-01-04','15:40:00',1.83),('10318','2013-01-04','15:45:00',1.39),('10318','2013-01-03','08:05:00',1.02),('10318','2013-01-03','08:10:00',1.3),('10318','2013-01-03','08:15:00',1.68),('10318','2013-01-03','08:20:00',1.87),('10318','2013-01-03','08:25:00',2.03),('10318','2013-01-03','08:30:00',2.4),('10318','2013-01-03','08:35:00',2.62),('10318','2013-01-03','08:40:00',2.98),('10318','2013-01-03','08:45:00',3.16),('10318','2013-01-03','08:50:00',3.29),('10318','2013-01-03','08:55:00',3.56),('10318','2013-01-03','09:00:00',3.78),('10318','2013-01-03','09:05:00',3.99),('10318','2013-01-03','09:10:00',4.19),('10318','2013-01-03','09:15:00',4.42),('10318','2013-01-03','09:20:00',4.58),('10318','2013-01-03','09:25:00',4.67),('10318','2013-01-03','09:30:00',4.92),('10318','2013-01-03','09:35:00',5.07),('10318','2013-01-03','09:40:00',5.41),('10318','2013-01-03','09:45:00',5.76),('10318','2013-01-03','09:50:00',6.13),('10318','2013-01-03','09:55:00',6.44),('10318','2013-01-03','10:00:00',6.63),('10318','2013-01-03','10:05:00',6.68),('10318','2013-01-03','10:10:00',4.25),('10318','2013-01-03','10:15:00',5.46),('10318','2013-01-03','10:20:00',5.24),('10318','2013-01-03','10:25:00',4.75),('10318','2013-01-03','10:30:00',4.83),('10318','2013-01-03','10:35:00',4.89),('10318','2013-01-03','10:40:00',4.81),('10318','2013-01-03','10:45:00',4.4),('10318','2013-01-03','10:50:00',3.86),('10318','2013-01-03','10:55:00',3.9),('10318','2013-01-03','11:00:00',4.12),('10318','2013-01-03','11:05:00',4.24),('10318','2013-01-03','11:10:00',3.91),('10318','2013-01-03','11:15:00',3.79),('10318','2013-01-03','11:20:00',3.43),('10318','2013-01-03','11:25:00',2.92),('10318','2013-01-03','11:30:00',2.64),('10318','2013-01-03','11:35:00',4.07),('10318','2013-01-03','11:40:00',6.97),('10318','2013-01-03','11:45:00',6.93),('10318','2013-01-03','11:50:00',6.79),('10318','2013-01-03','11:55:00',6.65),('10318','2013-01-03','12:00:00',6.58),('10318','2013-01-03','12:05:00',6.54),('10318','2013-01-03','12:10:00',6.47),('10318','2013-01-03','12:15:00',6.45),('10318','2013-01-03','12:20:00',6.41),('10318','2013-01-03','12:25:00',6.34),('10318','2013-01-03','12:30:00',6.33),('10318','2013-01-03','12:35:00',6.32),('10318','2013-01-03','12:40:00',6.25),('10318','2013-01-03','12:45:00',6.22),('10318','2013-01-03','12:50:00',6.15),('10318','2013-01-03','12:55:00',6.07),('10318','2013-01-03','13:00:00',5.89),('10318','2013-01-03','13:05:00',5.94),('10318','2013-01-03','13:10:00',5.84),('10318','2013-01-03','13:15:00',5.73),('10318','2013-01-03','13:20:00',5.68),('10318','2013-01-03','13:25:00',5.6),('10318','2013-01-03','13:30:00',5.49),('10318','2013-01-03','13:35:00',5.37),('10318','2013-01-03','13:40:00',5.25),('10318','2013-01-03','13:45:00',5.14),('10318','2013-01-03','13:50:00',5.01),('10318','2013-01-03','13:55:00',4.89),('10318','2013-01-03','14:00:00',4.75),('10318','2013-01-03','14:05:00',4.63),('10318','2013-01-03','14:10:00',4.48),('10318','2013-01-03','14:15:00',4.33),('10318','2013-01-03','14:20:00',4.22),('10318','2013-01-03','14:25:00',4.07),('10318','2013-01-03','14:30:00',3.94),('10318','2013-01-03','14:35:00',3.76),('10318','2013-01-03','14:40:00',3.63),('10318','2013-01-03','14:45:00',3.4),('10318','2013-01-03','14:50:00',3.37),('10318','2013-01-03','14:55:00',3.24),('10318','2013-01-03','15:00:00',3.1),('10318','2013-01-03','15:05:00',2.95),('10318','2013-01-03','15:10:00',2.81),('10318','2013-01-03','15:15:00',2.64),('10318','2013-01-03','15:20:00',2.29),('10318','2013-01-03','15:25:00',2.21),('10318','2013-01-03','15:30:00',2.22),('10318','2013-01-03','15:35:00',2.09),('10318','2013-01-03','15:40:00',1.86),('10318','2013-01-03','15:45:00',1.78),('10318','2013-01-03','15:50:00',1.64),('10318','2013-01-03','15:55:00',1.49),('10318','2013-01-03','16:00:00',1.3),('10318','2013-01-03','16:05:00',1.15),('10318','2013-01-02','09:40:00',1.48),('10318','2013-01-02','09:45:00',1.45),('10318','2013-01-02','09:50:00',1.42),('10318','2013-01-02','09:55:00',1.43),('10318','2013-01-02','10:00:00',1.46),('10318','2013-01-02','10:05:00',1.37),('10318','2013-01-02','10:10:00',1.33),('10318','2013-01-02','10:15:00',1.26),('10318','2013-01-02','10:40:00',1.1),('10318','2013-01-02','10:50:00',1.11),('10318','2013-01-02','10:55:00',1.01),('10318','2013-01-02','11:00:00',1.06),('10318','2013-01-02','11:05:00',1.53),('10318','2013-01-02','11:10:00',1.38),('10318','2013-01-02','11:15:00',1.2),('10318','2013-01-02','11:40:00',1.01),('10318','2013-01-02','11:45:00',1.02),('10318','2013-01-02','12:30:00',1.14),('10318','2013-01-02','12:50:00',1.13),('10318','2013-01-02','12:55:00',1.38),('10318','2013-01-02','13:30:00',2.12),('10318','2013-01-02','13:35:00',2.7),('10318','2013-01-02','13:40:00',2.59),('10318','2013-01-02','13:45:00',2.12),('10318','2013-01-02','13:50:00',1.92),('10318','2013-01-02','13:55:00',1.71),('10318','2013-01-02','14:00:00',1.33),('10318','2014-03-18','07:30:00',1),('10318','2014-03-18','07:35:00',1.03),('10318','2014-03-18','07:40:00',1.13),('10318','2014-03-18','07:45:00',1.43),('10318','2014-03-18','07:50:00',1.67),('10318','2014-03-18','07:55:00',2.02),('10318','2014-03-18','08:00:00',3.56),('10318','2014-03-18','08:05:00',4.3),('10318','2014-03-18','08:10:00',2.63),('10318','2014-03-18','08:15:00',2.94),('10318','2014-03-18','08:20:00',2.16),('10318','2014-03-18','08:25:00',3.51),('10318','2014-03-18','08:30:00',4.3),('10318','2014-03-18','08:35:00',4.63),('10318','2014-03-18','08:40:00',6.76),('10318','2014-03-18','08:45:00',6.01),('10318','2014-03-18','08:50:00',3.25),('10318','2014-03-18','08:55:00',1.55),('10318','2014-03-18','09:00:00',1.52),('10318','2014-03-18','09:05:00',1.84),('10318','2014-03-18','09:10:00',1.99),('10318','2014-03-18','09:15:00',2.07),('10318','2014-03-18','09:20:00',2.18),('10318','2014-03-18','09:25:00',2.2),('10318','2014-03-18','09:30:00',2.13),('10318','2014-03-18','09:35:00',2.1),('10318','2014-03-18','09:40:00',2.6),('10318','2014-03-18','09:45:00',2.75),('10318','2014-03-18','09:50:00',7.19),('10318','2014-03-18','09:55:00',8.31),('10318','2014-03-18','10:00:00',8.2),('10318','2014-03-18','10:05:00',9.13),('10318','2014-03-18','10:10:00',4.37),('10318','2014-03-18','10:15:00',3.2),('10318','2014-03-18','10:20:00',3.33),('10318','2014-03-18','10:25:00',7.11),('10318','2014-03-18','10:30:00',5.88),('10318','2014-03-18','10:35:00',6.05),('10318','2014-03-18','10:40:00',9.98),('10318','2014-03-18','10:45:00',9.23),('10318','2014-03-18','10:50:00',4.48),('10318','2014-03-18','10:55:00',4.78),('10318','2014-03-18','11:00:00',9.51),('10318','2014-03-18','11:05:00',7.21),('10318','2014-03-18','11:10:00',4.63),('10318','2014-03-18','11:15:00',5.01),('10318','2014-03-18','11:20:00',5.31),('10318','2014-03-18','11:25:00',4.83),('10318','2014-03-18','11:30:00',4.46),('10318','2014-03-18','11:35:00',4.29),('10318','2014-03-18','11:40:00',4.58),('10318','2014-03-18','11:45:00',3.99),('10318','2014-03-18','11:50:00',3.65),('10318','2014-03-18','11:55:00',3.58),('10318','2014-03-18','12:00:00',4.34),('10318','2014-03-18','12:05:00',3.95),('10318','2014-03-18','12:10:00',8.42),('10318','2014-03-18','12:15:00',8.74),('10318','2014-03-18','12:20:00',8.38),('10318','2014-03-18','12:25:00',6.57),('10318','2014-03-18','12:30:00',8.78),('10318','2014-03-18','12:35:00',8.68),('10318','2014-03-18','12:40:00',7.55),('10318','2014-03-18','12:45:00',7.42),('10318','2014-03-18','12:50:00',8.68),('10318','2014-03-18','12:55:00',6.2),('10318','2014-03-18','13:00:00',9.1),('10318','2014-03-18','13:05:00',8.67),('10318','2014-03-18','13:10:00',7.73),('10318','2014-03-18','13:15:00',8.46),('10318','2014-03-18','13:20:00',8.24),('10318','2014-03-18','13:25:00',8.07),('10318','2014-03-18','13:30:00',7.96),('10318','2014-03-18','13:35:00',7.98),('10318','2014-03-18','13:40:00',7.83),('10318','2014-03-18','13:45:00',7.65),('10318','2014-03-18','13:50:00',7.73),('10318','2014-03-18','13:55:00',7.55),('10318','2014-03-18','14:00:00',7.43),('10318','2014-03-18','14:05:00',7.25),('10318','2014-03-18','14:10:00',7.12),('10318','2014-03-18','14:15:00',7.04),('10318','2014-03-18','14:20:00',6.83),('10318','2014-03-18','14:25:00',6.78),('10318','2014-03-18','14:30:00',6.7),('10318','2014-03-18','14:35:00',6.54),('10318','2014-03-18','14:40:00',6.36),('10318','2014-03-18','14:45:00',6.18),('10318','2014-03-18','14:50:00',6.02),('10318','2014-03-18','14:55:00',5.88),('10318','2014-03-18','15:00:00',5.72),('10318','2014-03-18','15:05:00',5.54),('10318','2014-03-18','15:10:00',5.37),('10318','2014-03-18','15:15:00',5.22),('10318','2014-03-18','15:20:00',5.04),('10318','2014-03-18','15:25:00',4.83),('10318','2014-03-18','15:30:00',4.59),('10318','2014-03-18','15:35:00',4.48),('10318','2014-03-18','15:40:00',4.31),('10318','2014-03-18','15:45:00',4.09),('10318','2014-03-18','15:50:00',3.89),('10318','2014-03-18','15:55:00',3.69),('10318','2014-03-18','16:00:00',3.47),('10318','2014-03-18','16:05:00',3.32),('10318','2014-03-18','16:10:00',3.17),('10318','2014-03-18','16:15:00',3.01),('10318','2014-03-18','16:20:00',2.84),('10318','2014-03-18','16:25:00',2.63),('10318','2014-03-18','16:30:00',2.46),('10318','2014-03-18','16:35:00',2.3),('10318','2014-03-18','16:40:00',2.09),('10318','2014-03-18','16:45:00',1.97),('10318','2014-03-18','16:50:00',1.8),('10318','2014-03-18','16:55:00',1.66),('10318','2014-03-18','17:00:00',1.49),('10318','2014-03-18','17:05:00',1.29),('10318','2014-03-18','17:10:00',1.18),('10318','2014-03-18','17:15:00',1.05),('10318','2013-01-01','08:05:00',1.11),('10318','2013-01-01','08:10:00',1.37),('10318','2013-01-01','08:15:00',1.58),('10318','2013-01-01','08:20:00',1.79),('10318','2013-01-01','08:25:00',2.02),('10318','2013-01-01','08:30:00',2.29),('10318','2013-01-01','08:35:00',2.6),('10318','2013-01-01','08:40:00',2.84),('10318','2013-01-01','08:45:00',3.03),('10318','2013-01-01','08:50:00',3.22),('10318','2013-01-01','08:55:00',3.44),('10318','2013-01-01','09:00:00',3.64),('10318','2013-01-01','09:05:00',3.81),('10318','2013-01-01','09:10:00',3.98),('10318','2013-01-01','09:15:00',4.17),('10318','2013-01-01','09:20:00',4.37),('10318','2013-01-01','09:25:00',4.5),('10318','2013-01-01','09:30:00',4.65),('10318','2013-01-01','09:35:00',4.77),('10318','2013-01-01','09:40:00',4.91),('10318','2013-01-01','09:45:00',5.03),('10318','2013-01-01','09:50:00',5.14),('10318','2013-01-01','09:55:00',5.26),('10318','2013-01-01','10:00:00',5.36),('10318','2013-01-01','10:05:00',5.42),('10318','2013-01-01','10:10:00',5.53),('10318','2013-01-01','10:15:00',5.63),('10318','2013-01-01','10:20:00',5.64),('10318','2013-01-01','10:25:00',5.75),('10318','2013-01-01','10:30:00',5.79),('10318','2013-01-01','10:35:00',5.98),('10318','2013-01-01','10:40:00',5.75),('10318','2013-01-01','10:45:00',4.2),('10318','2013-01-01','10:50:00',3.38),('10318','2013-01-01','10:55:00',2.51),('10318','2013-01-01','11:00:00',6.55),('10318','2013-01-01','11:05:00',6.43),('10318','2013-01-01','11:10:00',5.01),('10318','2013-01-01','11:15:00',4.49),('10318','2013-01-01','11:20:00',4.62),('10318','2013-01-01','11:25:00',6.28),('10318','2013-01-01','11:30:00',3.05),('10318','2013-01-01','11:35:00',3.24),('10318','2013-01-01','11:40:00',6.4),('10318','2013-01-01','11:45:00',6.76),('10318','2013-01-01','11:50:00',4.7),('10318','2013-01-01','11:55:00',2.62),('10318','2013-01-01','12:00:00',2.5),('10318','2013-01-01','12:05:00',2.79),('10318','2013-01-01','12:10:00',3.24),('10318','2013-01-01','12:15:00',3.13),('10318','2013-01-01','12:20:00',2.78),('10318','2013-01-01','12:25:00',2.19),('10318','2013-01-01','12:30:00',1.84),('10318','2013-01-01','12:35:00',1.97),('10318','2013-01-01','12:40:00',2.62),('10318','2013-01-01','12:45:00',3.47),('10318','2013-01-01','12:50:00',3.07),('10318','2013-01-01','12:55:00',2.98),('10318','2013-01-01','13:00:00',3.02),('10318','2013-01-01','13:05:00',1.95),('10318','2013-01-01','13:10:00',1.97),('10318','2013-01-01','13:15:00',1.82),('10318','2013-01-01','13:20:00',1.59),('10318','2013-01-01','13:25:00',1.3),('10318','2013-01-01','13:30:00',1.07),('10318','2012-12-31','08:00:00',1.15),('10318','2012-12-31','08:05:00',1.46),('10318','2012-12-31','08:10:00',1.89),('10318','2012-12-31','08:15:00',2.07),('10318','2012-12-31','08:20:00',2.19),('10318','2012-12-31','08:25:00',2.65),('10318','2012-12-31','08:30:00',2.91),('10318','2012-12-31','08:35:00',2.56),('10318','2012-12-31','08:40:00',1.31),('10318','2012-12-31','08:45:00',1.93),('10318','2012-12-31','08:50:00',2.4),('10318','2012-12-31','08:55:00',3.21),('10318','2012-12-31','09:00:00',3.34),('10318','2012-12-31','09:05:00',3.33),('10318','2012-12-31','09:10:00',3.9),('10318','2012-12-31','09:15:00',4.06),('10318','2012-12-31','09:20:00',4.85),('10318','2012-12-31','09:25:00',5.1),('10318','2012-12-31','09:30:00',2.34),('10318','2012-12-31','09:35:00',1.47),('10318','2012-12-31','09:40:00',1.11),('10318','2012-12-31','09:45:00',2.53),('10318','2012-12-31','09:50:00',3.55),('10318','2012-12-31','09:55:00',5.58),('10318','2012-12-31','10:00:00',3.95),('10318','2012-12-31','10:05:00',5.44),('10318','2012-12-31','10:10:00',6.21),('10318','2012-12-31','10:15:00',6.25),('10318','2012-12-31','10:20:00',6.25),('10318','2012-12-31','10:25:00',6.28),('10318','2012-12-31','10:30:00',6.29),('10318','2012-12-31','10:35:00',6.27),('10318','2012-12-31','10:40:00',6.19),('10318','2012-12-31','10:45:00',6.3),('10318','2012-12-31','10:50:00',6.4),('10318','2012-12-31','10:55:00',6.5),('10318','2012-12-31','11:00:00',6.4),('10318','2012-12-31','11:05:00',6.22),('10318','2012-12-31','11:10:00',6.53),('10318','2012-12-31','11:15:00',6.65),('10318','2012-12-31','11:20:00',6.69),('10318','2012-12-31','11:25:00',6.69),('10318','2012-12-31','11:30:00',6.71),('10318','2012-12-31','11:35:00',6.71),('10318','2012-12-31','11:40:00',6.75),('10318','2012-12-31','11:45:00',6.76),('10318','2012-12-31','11:50:00',6.57),('10318','2012-12-31','11:55:00',6.74),('10318','2012-12-31','12:00:00',6.79),('10318','2012-12-31','12:05:00',6.78),('10318','2012-12-31','12:10:00',6.73),('10318','2012-12-31','12:15:00',6.71),('10318','2012-12-31','12:20:00',6.63),('10318','2012-12-31','12:25:00',6.61),('10318','2012-12-31','12:30:00',6.54),('10318','2012-12-31','12:35:00',6.49),('10318','2012-12-31','12:40:00',6.46),('10318','2012-12-31','12:45:00',6.38),('10318','2012-12-31','12:50:00',6.27),('10318','2012-12-31','12:55:00',6.21),('10318','2012-12-31','13:00:00',6.1),('10318','2012-12-31','13:05:00',6.01),('10318','2012-12-31','13:10:00',5.94),('10318','2012-12-31','13:15:00',5.84),('10318','2012-12-31','13:20:00',5.76),('10318','2012-12-31','13:25:00',5.64),('10318','2012-12-31','13:30:00',5.5),('10318','2012-12-31','13:35:00',5.25),('10318','2012-12-31','13:40:00',5.26),('10318','2012-12-31','13:45:00',5.11),('10318','2012-12-31','13:50:00',4.99),('10318','2012-12-31','13:55:00',4.88),('10318','2012-12-31','14:00:00',4.78),('10318','2012-12-31','14:05:00',4.63),('10318','2012-12-31','14:10:00',4.52),('10318','2012-12-31','14:15:00',4.37),('10318','2012-12-31','14:20:00',4.24),('10318','2012-12-31','14:25:00',4.1),('10318','2012-12-31','14:30:00',3.96),('10318','2012-12-31','14:35:00',3.84),('10318','2012-12-31','14:40:00',3.7),('10318','2012-12-31','14:45:00',3.62),('10318','2012-12-31','14:50:00',3.45),('10318','2012-12-31','14:55:00',3.29),('10318','2012-12-31','15:00:00',3.14),('10318','2012-12-31','15:05:00',2.96),('10318','2012-12-31','15:10:00',2.81),('10318','2012-12-31','15:15:00',2.7),('10318','2012-12-31','15:20:00',2.54),('10318','2012-12-31','15:25:00',2.4),('10318','2012-12-31','15:30:00',2.26),('10318','2012-12-31','15:35:00',2.11),('10318','2012-12-31','15:40:00',1.94),('10318','2012-12-31','15:45:00',1.75),('10318','2012-12-31','15:50:00',1.58),('10318','2012-12-31','15:55:00',1.42),('10318','2012-12-31','16:00:00',1.26),('10318','2012-12-31','16:05:00',1.06),('10318','2012-12-30','08:00:00',1.11),('10318','2012-12-30','08:05:00',1.35),('10318','2012-12-30','08:10:00',1.67),('10318','2012-12-30','08:15:00',1.93),('10318','2012-12-30','08:20:00',2.17),('10318','2012-12-30','08:25:00',2.44),('10318','2012-12-30','08:30:00',2.75),('10318','2012-12-30','08:35:00',3.02),('10318','2012-12-30','08:40:00',3.28),('10318','2012-12-30','08:45:00',3.5),('10318','2012-12-30','08:50:00',3.7),('10318','2012-12-30','08:55:00',3.87),('10318','2012-12-30','09:00:00',4.04),('10318','2012-12-30','09:05:00',4.2),('10318','2012-12-30','09:10:00',4.27),('10318','2012-12-30','09:15:00',4.52),('10318','2012-12-30','09:20:00',4.64),('10318','2012-12-30','09:25:00',4.79),('10318','2012-12-30','09:30:00',4.93),('10318','2012-12-30','09:35:00',5.09),('10318','2012-12-30','09:40:00',5.21),('10318','2012-12-30','09:45:00',5.38),('10318','2012-12-30','09:50:00',5.48),('10318','2012-12-30','09:55:00',5.58),('10318','2012-12-30','10:00:00',5.72),('10318','2012-12-30','10:05:00',5.83),('10318','2012-12-30','10:10:00',5.91),('10318','2012-12-30','10:15:00',6),('10318','2012-12-30','10:20:00',6.07),('10318','2012-12-30','10:25:00',6.18),('10318','2012-12-30','10:30:00',6.28),('10318','2012-12-30','10:35:00',6.34),('10318','2012-12-30','10:40:00',6.32),('10318','2012-12-30','10:45:00',6.4),('10318','2012-12-30','10:50:00',6.46),('10318','2012-12-30','10:55:00',6.36),('10318','2012-12-30','11:00:00',6.54),('10318','2012-12-30','11:05:00',6.58),('10318','2012-12-30','11:10:00',6.62),('10318','2012-12-30','11:15:00',6.62),('10318','2012-12-30','11:20:00',6.6),('10318','2012-12-30','11:25:00',6.59),('10318','2012-12-30','11:30:00',6.6),('10318','2012-12-30','11:35:00',6.57),('10318','2012-12-30','11:40:00',6.58),('10318','2012-12-30','11:45:00',6.61),('10318','2012-12-30','11:50:00',6.62),('10318','2012-12-30','11:55:00',6.61),('10318','2012-12-30','12:00:00',6.54),('10318','2012-12-30','12:05:00',6.52),('10318','2012-12-30','12:10:00',6.53),('10318','2012-12-30','12:15:00',6.48),('10318','2012-12-30','12:20:00',6.4),('10318','2012-12-30','12:25:00',6.28),('10318','2012-12-30','12:30:00',6.22),('10318','2012-12-30','12:35:00',6.23),('10318','2012-12-30','12:40:00',6.15),('10318','2012-12-30','12:45:00',6.18),('10318','2012-12-30','12:50:00',6.17),('10318','2012-12-30','12:55:00',6.06),('10318','2012-12-30','13:00:00',6.03),('10318','2012-12-30','13:05:00',5.92),('10318','2012-12-30','13:10:00',5.87),('10318','2012-12-30','13:15:00',5.77),('10318','2012-12-30','13:20:00',5.67),('10318','2012-12-30','13:25:00',5.6),('10318','2012-12-30','13:30:00',5.5),('10318','2012-12-30','13:35:00',5.41),('10318','2012-12-30','13:40:00',5.29),('10318','2012-12-30','13:45:00',5.18),('10318','2012-12-30','13:50:00',5.06),('10318','2012-12-30','13:55:00',4.94),('10318','2012-12-30','14:00:00',4.81),('10318','2012-12-30','14:05:00',4.67),('10318','2012-12-30','14:10:00',4.55),('10318','2012-12-30','14:15:00',4.36),('10318','2012-12-30','14:20:00',4.26),('10318','2012-12-30','14:25:00',4.09),('10318','2012-12-30','14:30:00',3.99),('10318','2012-12-30','14:35:00',3.84),('10318','2012-12-30','14:40:00',3.69),('10318','2012-12-30','14:45:00',3.54),('10318','2012-12-30','14:50:00',3.37),('10318','2012-12-30','14:55:00',3.25),('10318','2012-12-30','15:00:00',3.09),('10318','2012-12-30','15:05:00',2.96),('10318','2012-12-30','15:10:00',2.83),('10318','2012-12-30','15:15:00',2.69),('10318','2012-12-30','15:20:00',2.53),('10318','2012-12-30','15:25:00',2.37),('10318','2012-12-30','15:30:00',2.24),('10318','2012-12-30','15:35:00',2.06),('10318','2012-12-30','15:40:00',1.91),('10318','2012-12-30','15:45:00',1.79),('10318','2012-12-30','15:50:00',1.63),('10318','2012-12-30','15:55:00',1.45),('10318','2012-12-30','16:00:00',1.27),('10318','2012-12-30','16:05:00',1.12),('10318','2012-12-29','08:00:00',1),('10318','2012-12-29','08:05:00',1.28),('10318','2012-12-29','08:10:00',1.62),('10318','2012-12-29','08:15:00',1.87),('10318','2012-12-29','08:20:00',2.08),('10318','2012-12-29','08:25:00',2.37),('10318','2012-12-29','08:30:00',2.66),('10318','2012-12-29','08:35:00',2.94),('10318','2012-12-29','08:40:00',3.18),('10318','2012-12-29','08:45:00',3.38),('10318','2012-12-29','08:50:00',3.59),('10318','2012-12-29','08:55:00',3.81),('10318','2012-12-29','09:00:00',4),('10318','2012-12-29','09:05:00',4.17),('10318','2012-12-29','09:10:00',4.34),('10318','2012-12-29','09:15:00',4.49),('10318','2012-12-29','09:20:00',4.6),('10318','2012-12-29','09:25:00',4.66),('10318','2012-12-29','09:30:00',4.87),('10318','2012-12-29','09:35:00',5.06),('10318','2012-12-29','09:40:00',5.19),('10318','2012-12-29','09:45:00',5.31),('10318','2012-12-29','09:50:00',5.43),('10318','2012-12-29','09:55:00',5.58),('10318','2012-12-29','10:00:00',5.75),('10318','2012-12-29','10:05:00',5.88),('10318','2012-12-29','10:10:00',6),('10318','2012-12-29','10:15:00',6.1),('10318','2012-12-29','10:20:00',6.2),('10318','2012-12-29','10:25:00',6.26),('10318','2012-12-29','10:30:00',6.37),('10318','2012-12-29','10:35:00',6.43),('10318','2012-12-29','10:40:00',6.49),('10318','2012-12-29','10:45:00',6.49),('10318','2012-12-29','10:50:00',6.55),('10318','2012-12-29','10:55:00',6.65),('10318','2012-12-29','11:00:00',6.68),('10318','2012-12-29','11:05:00',6.68),('10318','2012-12-29','11:10:00',6.5),('10318','2012-12-29','11:15:00',6.63),('10318','2012-12-29','11:20:00',6.69),('10318','2012-12-29','11:25:00',6.68),('10318','2012-12-29','11:30:00',6.71),('10318','2012-12-29','11:35:00',6.72),('10318','2012-12-29','11:40:00',6.74),('10318','2012-12-29','11:45:00',6.78),('10318','2012-12-29','11:50:00',6.84),('10318','2012-12-29','11:55:00',6.86),('10318','2012-12-29','12:00:00',6.87),('10318','2012-12-29','12:05:00',6.82),('10318','2012-12-29','12:10:00',6.75),('10318','2012-12-29','12:15:00',6.74),('10318','2012-12-29','12:20:00',6.69),('10318','2012-12-29','12:25:00',6.64),('10318','2012-12-29','12:30:00',6.52),('10318','2012-12-29','12:35:00',6.42),('10318','2012-12-29','12:40:00',6.34),('10318','2012-12-29','12:45:00',6.3),('10318','2012-12-29','12:50:00',6.26),('10318','2012-12-29','12:55:00',6.06),('10318','2012-12-29','13:00:00',6.05),('10318','2012-12-29','13:05:00',6.06),('10318','2012-12-29','13:10:00',5.96),('10318','2012-12-29','13:15:00',5.75),('10318','2012-12-29','13:20:00',5.69),('10318','2012-12-29','13:25:00',5.63),('10318','2012-12-29','13:30:00',5.56),('10318','2012-12-29','13:35:00',5.45),('10318','2012-12-29','13:40:00',5.29),('10318','2012-12-29','13:45:00',5.2),('10318','2012-12-29','13:50:00',5.11),('10318','2012-12-29','13:55:00',5),('10318','2012-12-29','14:00:00',4.86),('10318','2012-12-29','14:05:00',4.71),('10318','2012-12-29','14:10:00',4.59),('10318','2012-12-29','14:15:00',4.49),('10318','2012-12-29','14:20:00',4.32),('10318','2012-12-29','14:25:00',4.18),('10318','2012-12-29','14:30:00',4.05),('10318','2012-12-29','14:35:00',3.93),('10318','2012-12-29','14:40:00',3.73),('10318','2012-12-29','14:45:00',3.66),('10318','2012-12-29','14:50:00',3.52),('10318','2012-12-29','14:55:00',3.38),('10318','2012-12-29','15:00:00',3.24),('10318','2012-12-29','15:05:00',3.07),('10318','2012-12-29','15:10:00',2.92),('10318','2012-12-29','15:15:00',2.79),('10318','2012-12-29','15:20:00',2.65),('10318','2012-12-29','15:25:00',2.5),('10318','2012-12-29','15:30:00',2.33),('10318','2012-12-29','15:35:00',2.17),('10318','2012-12-29','15:40:00',1.99),('10318','2012-12-29','15:45:00',1.86),('10318','2012-12-29','15:50:00',1.68),('10318','2012-12-29','15:55:00',1.52),('10318','2012-12-29','16:00:00',1.34),('10318','2012-12-29','16:05:00',1.17),('10318','2012-12-28','08:35:00',1.2),('10318','2012-12-28','08:40:00',2.66),('10318','2012-12-28','08:45:00',2.93),('10318','2012-12-28','08:50:00',3.18),('10318','2012-12-28','08:55:00',3.4),('10318','2012-12-28','09:00:00',3.61),('10318','2012-12-28','09:05:00',3.76),('10318','2012-12-28','09:10:00',3.98),('10318','2012-12-28','09:15:00',4.13),('10318','2012-12-28','09:20:00',4.25),('10318','2012-12-28','09:25:00',4.37),('10318','2012-12-28','09:30:00',4.48),('10318','2012-12-28','09:35:00',4.61),('10318','2012-12-28','09:40:00',4.8),('10318','2012-12-28','09:45:00',4.89),('10318','2012-12-28','09:50:00',4.94),('10318','2012-12-28','09:55:00',5.04),('10318','2012-12-28','10:00:00',5.14),('10318','2012-12-28','10:05:00',5.41),('10318','2012-12-28','10:10:00',5.54),('10318','2012-12-28','10:15:00',5.67),('10318','2012-12-28','10:20:00',5.78),('10318','2012-12-28','10:25:00',5.83),('10318','2012-12-28','10:30:00',5.86),('10318','2012-12-28','10:35:00',6.06),('10318','2012-12-28','10:40:00',6.07),('10318','2012-12-28','10:45:00',6.12),('10318','2012-12-28','10:50:00',6.14),('10318','2012-12-28','10:55:00',6.16),('10318','2012-12-28','11:00:00',6.19),('10318','2012-12-28','11:05:00',6.33),('10318','2012-12-28','11:10:00',6.44),('10318','2012-12-28','11:15:00',6.46),('10318','2012-12-28','11:20:00',6.35),('10318','2012-12-28','11:25:00',6.56),('10318','2012-12-28','11:30:00',6.5),('10318','2012-12-28','11:35:00',6.56),('10318','2012-12-28','11:40:00',6.49),('10318','2012-12-28','11:45:00',5.88),('10318','2012-12-28','11:50:00',6.61),('10318','2012-12-28','11:55:00',6.55),('10318','2012-12-28','12:00:00',6.49),('10318','2012-12-28','12:05:00',6.49),('10318','2012-12-28','12:10:00',6.46),('10318','2012-12-28','12:15:00',6.24),('10318','2012-12-28','12:20:00',6.34),('10318','2012-12-28','12:25:00',6.34),('10318','2012-12-28','12:30:00',6.26),('10318','2012-12-28','12:35:00',6.18),('10318','2012-12-28','12:40:00',6.07),('10318','2012-12-28','12:45:00',5.97),('10318','2012-12-28','12:50:00',5.93),('10318','2012-12-28','12:55:00',5.81),('10318','2012-12-28','13:00:00',5.75),('10318','2012-12-28','13:05:00',5.74),('10318','2012-12-28','13:10:00',5.55),('10318','2012-12-28','13:15:00',5.29),('10318','2012-12-28','13:20:00',5.24),('10318','2012-12-28','13:25:00',2.45),('10318','2012-12-28','13:30:00',4.5),('10318','2012-12-28','13:35:00',4.91),('10318','2012-12-28','13:40:00',4.72),('10318','2012-12-28','13:45:00',4.77),('10318','2012-12-28','13:50:00',4.61),('10318','2012-12-28','13:55:00',4.53),('10318','2012-12-28','14:00:00',4.45),('10318','2012-12-28','14:05:00',4.3),('10318','2012-12-28','14:10:00',4.19),('10318','2012-12-28','14:15:00',3.82),('10318','2012-12-28','14:20:00',2.3),('10318','2012-12-28','14:25:00',3.84),('10318','2012-12-28','14:30:00',3.81),('10318','2012-12-28','14:35:00',3.65),('10318','2012-12-28','14:40:00',3.44),('10318','2012-12-28','14:45:00',3.26),('10318','2012-12-28','14:50:00',3.14),('10318','2012-12-28','14:55:00',2.99),('10318','2012-12-28','15:00:00',2.89),('10318','2012-12-28','15:05:00',2.78),('10318','2012-12-28','15:10:00',2.63),('10318','2012-12-28','15:15:00',2.46),('10318','2012-12-28','15:20:00',2.35),('10318','2012-12-28','15:25:00',2.18),('10318','2012-12-28','15:30:00',2.03),('10318','2012-12-28','15:35:00',1.85),('10318','2012-12-28','15:40:00',1.67),('10318','2012-12-28','15:45:00',1.51),('10318','2012-12-28','15:50:00',1.36),('10318','2012-12-28','15:55:00',1.2),('10318','2012-12-28','16:00:00',1.05),('10318','2012-12-27','08:50:00',1.04),('10318','2012-12-27','08:55:00',1.05),('10318','2012-12-27','09:05:00',1.29),('10318','2012-12-27','09:10:00',1.93),('10318','2012-12-27','09:15:00',1.66),('10318','2012-12-27','09:20:00',2.07),('10318','2012-12-27','09:25:00',4.59),('10318','2012-12-27','09:30:00',4.2),('10318','2012-12-27','09:35:00',4.42),('10318','2012-12-27','09:40:00',5.03),('10318','2012-12-27','09:45:00',5.22),('10318','2012-12-27','09:50:00',4.38),('10318','2012-12-27','09:55:00',3.9),('10318','2012-12-27','10:00:00',2.67),('10318','2012-12-27','10:05:00',5.38),('10318','2012-12-27','10:10:00',5.21),('10318','2012-12-27','10:15:00',5.4),('10318','2012-12-27','10:20:00',3.54),('10318','2012-12-27','10:25:00',5.31),('10318','2012-12-27','10:30:00',5.75),('10318','2012-12-27','10:35:00',5.51),('10318','2012-12-27','10:40:00',1.75),('10318','2012-12-27','10:45:00',5.34),('10318','2012-12-27','10:50:00',5.54),('10318','2012-12-27','10:55:00',5.16),('10318','2012-12-27','11:00:00',5.62),('10318','2012-12-27','11:05:00',5.38),('10318','2012-12-27','11:10:00',2.56),('10318','2012-12-27','11:15:00',3.07),('10318','2012-12-27','11:20:00',1.73),('10318','2012-12-27','11:25:00',1.46),('10318','2012-12-27','11:30:00',2.58),('10318','2012-12-27','11:35:00',3.93),('10318','2012-12-27','11:40:00',6.06),('10318','2012-12-27','11:45:00',6.49),('10318','2012-12-27','11:50:00',6.94),('10318','2012-12-27','11:55:00',5.31),('10318','2012-12-27','12:00:00',2.1),('10318','2012-12-27','12:05:00',3.44),('10318','2012-12-27','12:10:00',5.69),('10318','2012-12-27','12:15:00',5.51),('10318','2012-12-27','12:20:00',5.65),('10318','2012-12-27','12:25:00',6.03),('10318','2012-12-27','12:30:00',4.84),('10318','2012-12-27','12:35:00',2.54),('10318','2012-12-27','12:40:00',6.14),('10318','2012-12-27','12:45:00',5.68),('10318','2012-12-27','12:50:00',6.32),('10318','2012-12-27','12:55:00',6.42),('10318','2012-12-27','13:00:00',5.63),('10318','2012-12-27','13:05:00',3.34),('10318','2012-12-27','13:10:00',2.29),('10318','2012-12-27','13:15:00',3.12),('10318','2012-12-27','13:20:00',2.76),('10318','2012-12-27','13:25:00',1.68),('10318','2012-12-27','13:45:00',1),('10318','2012-12-27','13:50:00',2.25),('10318','2012-12-27','13:55:00',2.45),('10318','2012-12-27','14:00:00',4.4),('10318','2012-12-27','14:05:00',3.92),('10318','2012-12-27','14:10:00',4.36),('10318','2012-12-27','14:15:00',4.18),('10318','2012-12-27','14:20:00',4.08),('10318','2012-12-27','14:25:00',3.91),('10318','2012-12-27','14:30:00',3.68),('10318','2012-12-27','14:35:00',2.75),('10318','2012-12-27','14:40:00',1.04),('10318','2012-12-27','14:50:00',1.52),('10318','2012-12-27','14:55:00',3.54),('10318','2012-12-27','15:00:00',2.78),('10318','2012-12-27','15:05:00',1.56),('10318','2012-12-27','15:10:00',1.27),('10318','2012-12-27','15:20:00',1.28),('10318','2012-12-27','15:25:00',2.31),('10318','2012-12-27','15:30:00',1.75),('10318','2012-12-27','15:35:00',1.98),('10318','2012-12-27','15:40:00',1.76),('10318','2012-12-27','15:45:00',1.64),('10318','2012-12-27','15:50:00',1.32),('10318','2012-12-27','15:55:00',1.02),('10318','2012-12-26','08:55:00',1.08),('10318','2012-12-26','09:00:00',1.54),('10318','2012-12-26','09:05:00',1.51),('10318','2012-12-26','09:10:00',2.43),('10318','2012-12-26','09:15:00',4.07),('10318','2012-12-26','09:20:00',4.39),('10318','2012-12-26','09:25:00',4.51),('10318','2012-12-26','09:30:00',4.62),('10318','2012-12-26','09:35:00',4.7),('10318','2012-12-26','09:40:00',4.78),('10318','2012-12-26','09:45:00',4.95),('10318','2012-12-26','09:50:00',5.05),('10318','2012-12-26','09:55:00',5.13),('10318','2012-12-26','10:00:00',5.26),('10318','2012-12-26','10:05:00',5.36),('10318','2012-12-26','10:10:00',5.41),('10318','2012-12-26','10:15:00',5.62),('10318','2012-12-26','10:20:00',5.62),('10318','2012-12-26','10:25:00',5.7),('10318','2012-12-26','10:30:00',5.72),('10318','2012-12-26','10:35:00',5.78),('10318','2012-12-26','10:40:00',5.81),('10318','2012-12-26','10:45:00',5.84),('10318','2012-12-26','10:50:00',5.85),('10318','2012-12-26','10:55:00',5.89),('10318','2012-12-26','11:00:00',5.84),('10318','2012-12-26','11:05:00',5.96),('10318','2012-12-26','11:10:00',5.93),('10318','2012-12-26','11:15:00',5.91),('10318','2012-12-26','11:20:00',6.01),('10318','2012-12-26','11:25:00',5.96),('10318','2012-12-26','11:30:00',6.17),('10318','2012-12-26','11:35:00',6.14),('10318','2012-12-26','11:40:00',6.14),('10318','2012-12-26','11:45:00',5.93),('10318','2012-12-26','11:50:00',6.12),('10318','2012-12-26','11:55:00',6.06),('10318','2012-12-26','12:00:00',6.58),('10318','2012-12-26','12:05:00',6.36),('10318','2012-12-26','12:10:00',6.77),('10318','2012-12-26','12:15:00',6.57),('10318','2012-12-26','12:20:00',6.5),('10318','2012-12-26','12:25:00',6.48),('10318','2012-12-26','12:30:00',6.53),('10318','2012-12-26','12:35:00',6.25),('10318','2012-12-26','12:40:00',5.23),('10318','2012-12-26','12:45:00',5.99),('10318','2012-12-26','12:50:00',4.77),('10318','2012-12-26','12:55:00',5.97),('10318','2012-12-26','13:00:00',4.61),('10318','2012-12-26','13:05:00',5.94),('10318','2012-12-26','13:10:00',3.95),('10318','2012-12-26','13:15:00',5.18),('10318','2012-12-26','13:20:00',6.54),('10318','2012-12-26','13:25:00',5.62),('10318','2012-12-26','13:30:00',6.06),('10318','2012-12-26','13:35:00',6.42),('10318','2012-12-26','13:40:00',5.24),('10318','2012-12-26','13:45:00',5.54),('10318','2012-12-26','13:50:00',3.6),('10318','2012-12-26','13:55:00',3.47),('10318','2012-12-26','14:00:00',3.47),('10318','2012-12-26','14:05:00',2.88),('10318','2012-12-26','14:10:00',2.05),('10318','2012-12-26','14:15:00',1.88),('10318','2012-12-26','14:20:00',1.14),('10318','2012-12-26','14:25:00',1.39),('10318','2012-12-25','09:55:00',1.03),('10318','2012-12-25','10:00:00',1.23),('10318','2012-12-25','10:05:00',1.41),('10318','2012-12-25','10:10:00',1.48),('10318','2012-12-25','10:15:00',1.56),('10318','2012-12-25','10:20:00',1.74),('10318','2012-12-25','10:25:00',1.66),('10318','2012-12-25','10:30:00',1.68),('10318','2012-12-25','10:35:00',1.66),('10318','2012-12-25','10:40:00',1.5),('10318','2012-12-25','10:45:00',1.49),('10318','2012-12-25','10:50:00',1.51),('10318','2012-12-25','10:55:00',1.68),('10318','2012-12-25','11:00:00',1.81),('10318','2012-12-25','11:05:00',1.63),('10318','2012-12-25','11:10:00',1.87),('10318','2012-12-25','11:15:00',1.83),('10318','2012-12-25','11:20:00',1.9),('10318','2012-12-25','11:25:00',2.01),('10318','2012-12-25','11:30:00',1.81),('10318','2012-12-25','11:35:00',1.82),('10318','2012-12-25','11:40:00',1.94),('10318','2012-12-25','11:45:00',2.04),('10318','2012-12-25','11:50:00',1.93),('10318','2012-12-25','11:55:00',1.87),('10318','2012-12-25','12:00:00',1.89),('10318','2012-12-25','12:05:00',1.79),('10318','2012-12-25','12:10:00',1.53),('10318','2012-12-25','12:15:00',1.61),('10318','2012-12-25','12:20:00',1.73),('10318','2012-12-25','12:25:00',1.73),('10318','2012-12-25','12:30:00',1.67),('10318','2012-12-25','12:35:00',1.56),('10318','2012-12-25','12:40:00',1.64),('10318','2012-12-25','12:45:00',1.45),('10318','2012-12-25','12:50:00',1.55),('10318','2012-12-25','12:55:00',1.43),('10318','2012-12-25','13:00:00',1.54),('10318','2012-12-25','13:05:00',1.74),('10318','2012-12-25','13:10:00',2.02),('10318','2012-12-25','13:15:00',2.05),('10318','2012-12-25','13:20:00',2.23),('10318','2012-12-25','13:25:00',2.53),('10318','2012-12-25','13:30:00',2.03),('10318','2012-12-25','13:35:00',1.8),('10318','2012-12-25','13:40:00',1.75),('10318','2012-12-25','13:45:00',1.66),('10318','2012-12-25','13:50:00',1.47),('10318','2012-12-25','13:55:00',1.17),('10318','2012-12-25','14:00:00',1.3),('10318','2012-12-25','14:05:00',1.04),('10318','2012-12-25','14:35:00',1.07),('10318','2012-12-25','14:40:00',1.13),('10318','2012-12-25','14:45:00',1.1),('10318','2012-12-25','14:50:00',1.04),('10318','2012-12-25','15:05:00',1.07),('10318','2012-12-25','15:10:00',1.57),('10318','2012-12-25','15:15:00',1.75),('10318','2012-12-25','15:20:00',1.45),('10318','2012-12-25','15:25:00',1.37),('10318','2012-12-25','15:30:00',1.16),('10318','2012-12-25','15:35:00',1.23),('10318','2012-12-25','15:40:00',1.18),('10318','2012-12-25','15:45:00',1.02),('10318','2012-12-24','10:40:00',1.01),('10318','2012-12-24','10:45:00',1.06),('10318','2012-12-24','10:50:00',1.12),('10318','2012-12-24','10:55:00',1.18),('10318','2012-12-24','11:00:00',1.1),('10318','2012-12-24','11:05:00',1.02),('10318','2012-12-24','11:10:00',1.11),('10318','2012-12-24','11:15:00',1.19),('10318','2012-12-24','11:20:00',1.42),('10318','2012-12-24','11:25:00',1.53),('10318','2012-12-24','11:30:00',1.54),('10318','2012-12-24','11:35:00',1.5),('10318','2012-12-24','11:40:00',1.42),('10318','2012-12-24','11:45:00',1.36),('10318','2012-12-24','11:50:00',1.32),('10318','2012-12-24','11:55:00',1.36),('10318','2012-12-24','12:00:00',1.49),('10318','2012-12-24','12:05:00',1.66),('10318','2012-12-24','12:10:00',1.76),('10318','2012-12-24','12:15:00',1.76),('10318','2012-12-24','12:20:00',1.71),('10318','2012-12-24','12:25:00',1.75),('10318','2012-12-24','12:30:00',1.58),('10318','2012-12-24','12:35:00',1.59),('10318','2012-12-24','12:40:00',1.6),('10318','2012-12-24','12:45:00',1.41),('10318','2012-12-24','12:50:00',1.24),('10318','2012-12-24','12:55:00',1.34),('10318','2012-12-24','13:00:00',1.34),('10318','2012-12-24','13:05:00',1.32),('10318','2012-12-24','13:10:00',1.19),('10318','2012-12-24','13:15:00',1.21),('10318','2012-12-24','13:20:00',1.17),('10318','2012-12-24','13:25:00',1.17),('10318','2012-12-24','13:30:00',1.14),('10318','2012-12-24','13:35:00',1.13),('10318','2012-12-24','13:40:00',1.04),('10318','2012-12-24','13:45:00',1.07),('10318','2012-12-24','13:50:00',1.1),('10318','2012-12-24','13:55:00',1.07),('10318','2012-12-23','08:00:00',1.11),('10318','2012-12-23','08:05:00',1.38),('10318','2012-12-23','08:10:00',1.56),('10318','2012-12-23','08:15:00',1.9),('10318','2012-12-23','08:20:00',2.11),('10318','2012-12-23','08:25:00',2.3),('10318','2012-12-23','08:30:00',2.58),('10318','2012-12-23','08:35:00',2.92),('10318','2012-12-23','08:40:00',3.08),('10318','2012-12-23','08:45:00',3.33),('10318','2012-12-23','08:50:00',3.44),('10318','2012-12-23','08:55:00',3.74),('10318','2012-12-23','09:00:00',3.93),('10318','2012-12-23','09:05:00',4.1),('10318','2012-12-23','09:10:00',4.25),('10318','2012-12-23','09:15:00',4.33),('10318','2012-12-23','09:20:00',4.38),('10318','2012-12-23','09:25:00',4.63),('10318','2012-12-23','09:30:00',4.71),('10318','2012-12-23','09:35:00',4.84),('10318','2012-12-23','09:40:00',5),('10318','2012-12-23','09:45:00',5.09),('10318','2012-12-23','09:50:00',5.23),('10318','2012-12-23','09:55:00',5.39),('10318','2012-12-23','10:00:00',5.48),('10318','2012-12-23','10:05:00',5.59),('10318','2012-12-23','10:10:00',5.66),('10318','2012-12-23','10:15:00',5.68),('10318','2012-12-23','10:20:00',5.72),('10318','2012-12-23','10:25:00',5.43),('10318','2012-12-23','10:30:00',5.57),('10318','2012-12-23','10:35:00',5.76),('10318','2012-12-23','10:40:00',5.96),('10318','2012-12-23','10:45:00',6.07),('10318','2012-12-23','10:50:00',6.01),('10318','2012-12-23','10:55:00',5.8),('10318','2012-12-23','11:00:00',6.12),('10318','2012-12-23','11:05:00',6.22),('10318','2012-12-23','11:10:00',6.23),('10318','2012-12-23','11:15:00',6.3),('10318','2012-12-23','11:20:00',6.34),('10318','2012-12-23','11:25:00',5.98),('10318','2012-12-23','11:30:00',5.49),('10318','2012-12-23','11:35:00',6.34),('10318','2012-12-23','11:40:00',6.37),('10318','2012-12-23','11:45:00',6.23),('10318','2012-12-23','11:50:00',6.46),('10318','2012-12-23','11:55:00',5.78),('10318','2012-12-23','12:00:00',5.62),('10318','2012-12-23','12:05:00',5.67),('10318','2012-12-23','12:10:00',5.31),('10318','2012-12-23','12:15:00',3.84),('10318','2012-12-23','12:20:00',5.04),('10318','2012-12-23','12:25:00',4.3),('10318','2012-12-23','12:30:00',4.35),('10318','2012-12-23','12:35:00',4.51),('10318','2012-12-23','12:40:00',4.05),('10318','2012-12-23','12:45:00',3.1),('10318','2012-12-23','12:50:00',3.66),('10318','2012-12-23','12:55:00',4.74),('10318','2012-12-23','13:00:00',4.47),('10318','2012-12-23','13:05:00',5.16),('10318','2012-12-23','13:10:00',4.64),('10318','2012-12-23','13:15:00',3.48),('10318','2012-12-23','13:20:00',2.76),('10318','2012-12-23','13:25:00',2.72),('10318','2012-12-23','13:30:00',2.81),('10318','2012-12-23','13:35:00',3.71),('10318','2012-12-23','13:40:00',4.09),('10318','2012-12-23','13:45:00',3.5),('10318','2012-12-23','13:50:00',3.12),('10318','2012-12-23','13:55:00',3.56),('10318','2012-12-23','14:00:00',4.65),('10318','2012-12-23','14:05:00',4.15),('10318','2012-12-23','14:10:00',3.94),('10318','2012-12-23','14:15:00',3.78),('10318','2012-12-23','14:20:00',2.68),('10318','2012-12-23','14:25:00',1.98),('10318','2012-12-23','14:30:00',2.34),('10318','2012-12-23','14:35:00',2.64),('10318','2012-12-23','14:40:00',2.96),('10318','2012-12-23','14:45:00',3.1),('10318','2012-12-23','14:50:00',1.94),('10318','2012-12-23','14:55:00',1.53),('10318','2012-12-23','15:00:00',1.75),('10318','2012-12-23','15:05:00',1.58),('10318','2012-12-23','15:10:00',1.8),('10318','2012-12-23','15:15:00',1.08),('10318','2012-12-23','15:45:00',1.45),('10318','2014-05-01','07:35:00',2.14),('10318','2014-05-01','07:40:00',2.18),('10318','2014-05-01','07:45:00',2.07),('10318','2014-05-01','07:50:00',3.74),('10318','2014-05-01','07:55:00',3.96),('10318','2014-05-01','08:00:00',4.27),('10318','2014-05-01','08:05:00',4.09),('10318','2014-05-01','08:10:00',4.45),('10318','2014-05-01','08:15:00',4.6),('10318','2014-05-01','08:20:00',4.79),('10318','2014-05-01','08:25:00',4.99),('10318','2014-05-01','08:30:00',5.22),('10318','2014-05-01','08:35:00',5.43),('10318','2014-05-01','08:40:00',5.61),('10318','2014-05-01','08:45:00',5.81),('10318','2014-05-01','08:50:00',4.88),('10318','2014-05-01','08:55:00',3.39),('10318','2014-05-01','09:00:00',2.83),('10318','2014-05-01','09:05:00',4.61),('10318','2014-05-01','09:10:00',4.21),('10318','2014-05-01','09:15:00',5.74),('10318','2014-05-01','09:20:00',7.59),('10318','2014-05-01','09:25:00',7.02),('10318','2014-05-01','09:30:00',7.41),('10318','2014-05-01','09:35:00',6.48),('10318','2014-05-01','09:40:00',9.54),('10318','2014-05-01','09:45:00',3.68),('10318','2014-05-01','09:50:00',4.32),('10318','2014-05-01','09:55:00',2.9),('10318','2014-05-01','10:00:00',4.05),('10318','2014-05-01','10:05:00',3.11),('10318','2014-05-01','10:10:00',3.3),('10318','2014-05-01','10:15:00',6.61),('10318','2014-05-01','10:20:00',5.65),('10318','2014-05-01','10:25:00',7.33),('10318','2014-05-01','10:30:00',4.56),('10318','2014-05-01','10:35:00',8.86),('10318','2014-05-01','10:40:00',10.04),('10318','2014-05-01','10:45:00',9.99),('10318','2014-05-01','10:50:00',8.12),('10318','2014-05-01','10:55:00',10.71),('10318','2014-05-01','11:00:00',9.96),('10318','2014-05-01','11:05:00',10.84),('10318','2014-05-01','11:10:00',3.92),('10318','2014-05-01','11:15:00',5.73),('10318','2014-05-01','11:20:00',10.88),('10318','2014-05-01','11:25:00',10.67),('10318','2014-05-01','11:30:00',9.11),('10318','2014-05-01','11:35:00',6.72),('10318','2014-05-01','11:40:00',7.66),('10318','2014-05-01','11:45:00',9.81),('10318','2014-05-01','11:50:00',9.33),('10318','2014-05-01','11:55:00',2.4),('10318','2014-05-01','12:00:00',4.07),('10318','2014-05-01','12:05:00',10.34),('10318','2014-05-01','12:10:00',10.37),('10318','2014-05-01','12:15:00',10.39),('10318','2014-05-01','12:20:00',10.44),('10318','2014-05-01','12:25:00',10.67),('10318','2014-05-01','12:30:00',10.22),('10318','2014-05-01','12:35:00',7.23),('10318','2014-05-01','12:40:00',5.96),('10318','2014-05-01','12:45:00',2.53),('10318','2014-05-01','12:50:00',2.79),('10318','2014-05-01','12:55:00',3.65),('10318','2014-05-01','13:00:00',8.92),('10318','2014-05-01','13:05:00',2.2),('10318','2014-05-01','13:10:00',10.42),('10318','2014-05-01','13:15:00',10.5),('10318','2014-05-01','13:20:00',10.54),('10318','2014-05-01','13:25:00',9.69),('10318','2014-05-01','13:30:00',5.26),('10318','2014-05-01','13:35:00',6.19),('10318','2014-05-01','13:40:00',2.94),('10318','2014-05-01','13:45:00',6.99),('10318','2014-05-01','13:50:00',4.36),('10318','2014-05-01','13:55:00',9.07),('10318','2014-05-01','14:00:00',10),('10318','2014-05-01','14:05:00',9.98),('10318','2014-05-01','14:10:00',9.75),('10318','2014-05-01','14:15:00',9.43),('10318','2014-05-01','14:20:00',9.05),('10318','2014-05-01','14:25:00',9),('10318','2014-05-01','14:30:00',8.68),('10318','2014-05-01','14:35:00',8.58),('10318','2014-05-01','14:40:00',9.06),('10318','2014-05-01','14:45:00',8.99),('10318','2014-05-01','14:50:00',8.72),('10318','2014-05-01','14:55:00',7.53),('10318','2014-05-01','15:00:00',3.87),('10318','2014-05-01','15:05:00',2.72),('10318','2014-05-01','15:10:00',6.21),('10318','2014-05-01','15:15:00',8.56),('10318','2014-05-01','15:20:00',8.22),('10318','2014-05-01','15:25:00',8.06),('10318','2014-05-01','15:30:00',7.78),('10318','2014-05-01','15:35:00',7.59),('10318','2014-05-01','15:40:00',7.43),('10318','2014-05-01','15:45:00',7.14),('10318','2014-05-01','15:50:00',6.9),('10318','2014-05-01','15:55:00',6.87),('10318','2014-05-01','16:00:00',6.83),('10318','2014-05-01','16:05:00',6.65),('10318','2014-05-01','16:10:00',6.43),('10318','2014-05-01','16:15:00',6.21),('10318','2014-05-01','16:20:00',5.85),('10318','2014-05-01','16:25:00',5.55),('10318','2014-05-01','16:30:00',5.58),('10318','2014-05-01','16:35:00',5.51),('10318','2014-05-01','16:40:00',5.08),('10318','2014-05-01','16:45:00',4.28),('10318','2014-05-01','16:50:00',4.5),('10318','2014-05-01','16:55:00',4.47),('10318','2014-05-01','17:00:00',3.8),('10318','2014-05-01','17:05:00',4.41),('10318','2014-05-01','17:10:00',4.3),('10318','2014-05-01','17:15:00',4.04),('10318','2014-05-01','17:20:00',3.83),('10318','2014-05-01','17:25:00',3.54),('10318','2014-05-01','17:30:00',3.19),('10318','2014-05-01','17:35:00',3.32),('10318','2014-05-01','17:40:00',2.38),('10318','2014-05-01','17:45:00',2.57),('10318','2014-05-01','17:50:00',2.6),('10318','2014-05-01','17:55:00',2.44),('10318','2014-05-01','18:00:00',1.89),('10318','2014-05-01','18:05:00',2.12),('10318','2014-05-01','18:10:00',1.97),('10318','2014-05-01','18:15:00',1.75),('10318','2014-05-01','18:20:00',1.58),('10318','2014-05-01','18:25:00',1.39),('10318','2014-05-01','18:30:00',1.32),('10318','2014-05-01','18:35:00',1.18),('10318','2014-03-17','08:25:00',1.03),('10318','2014-03-17','08:30:00',1.14),('10318','2014-03-17','08:35:00',1.27),('10318','2014-03-17','08:40:00',1.49),('10318','2014-03-17','08:45:00',1.82),('10318','2014-03-17','08:50:00',1.61),('10318','2014-03-17','08:55:00',1.81),('10318','2014-03-17','09:00:00',1.8),('10318','2014-03-17','09:05:00',1.79),('10318','2014-03-17','09:10:00',1.95),('10318','2014-03-17','09:15:00',2.53),('10318','2014-03-17','09:20:00',3.79),('10318','2014-03-17','09:25:00',3.3),('10318','2014-03-17','09:30:00',3.34),('10318','2014-03-17','09:35:00',3.68),('10318','2014-03-17','09:40:00',3.72),('10318','2014-03-17','09:45:00',4.09),('10318','2014-03-17','09:50:00',4.57),('10318','2014-03-17','09:55:00',3.72),('10318','2014-03-17','10:00:00',3.84),('10318','2014-03-17','10:05:00',3.33),('10318','2014-03-17','10:10:00',3.45),('10318','2014-03-17','10:15:00',3.66),('10318','2014-03-17','10:20:00',4.14),('10318','2014-03-17','10:25:00',2.48),('10318','2014-03-17','10:30:00',2.78),('10318','2014-03-17','10:35:00',2.79),('10318','2014-03-17','10:40:00',3.15),('10318','2014-03-17','10:45:00',2.59),('10318','2014-03-17','10:50:00',2.65),('10318','2014-03-17','10:55:00',3.38),('10318','2014-03-17','11:00:00',2.98),('10318','2014-03-17','11:05:00',3.31),('10318','2014-03-17','11:10:00',3.63),('10318','2014-03-17','11:15:00',3.54),('10318','2014-03-17','11:20:00',2.83),('10318','2014-03-17','11:25:00',2.95),('10318','2014-03-17','11:30:00',3.68),('10318','2014-03-17','11:35:00',3.07),('10318','2014-03-17','11:40:00',2.9),('10318','2014-03-17','11:45:00',2.9),('10318','2014-03-17','11:50:00',2.87),('10318','2014-03-17','11:55:00',4.05),('10318','2014-03-17','12:00:00',3.12),('10318','2014-03-17','12:05:00',3.1),('10318','2014-03-17','12:10:00',5.56),('10318','2014-03-17','12:15:00',5.48),('10318','2014-03-17','12:20:00',3.79),('10318','2014-03-17','12:25:00',4.6),('10318','2014-03-17','12:30:00',4.17),('10318','2014-03-17','12:35:00',5.35),('10318','2014-03-17','12:40:00',6.07),('10318','2014-03-17','12:45:00',9.44),('10318','2014-03-17','12:50:00',9.07),('10318','2014-03-17','12:55:00',8.69),('10318','2014-03-17','13:00:00',5.59),('10318','2014-03-17','13:05:00',8.18),('10318','2014-03-17','13:10:00',6.23),('10318','2014-03-17','13:15:00',5.44),('10318','2014-03-17','13:20:00',8.42),('10318','2014-03-17','13:25:00',7.28),('10318','2014-03-17','13:30:00',7.65),('10318','2014-03-17','13:35:00',6.29),('10318','2014-03-17','13:40:00',6.64),('10318','2014-03-17','13:45:00',4.65),('10318','2014-03-17','13:50:00',6.76),('10318','2014-03-17','13:55:00',4.43),('10318','2014-03-17','14:00:00',6.26),('10318','2014-03-17','14:05:00',6.12),('10318','2014-03-17','14:10:00',4.66),('10318','2014-03-17','14:15:00',7.85),('10318','2014-03-17','14:20:00',5.61),('10318','2014-03-17','14:25:00',4.19),('10318','2014-03-17','14:30:00',3.45),('10318','2014-03-17','14:35:00',4.5),('10318','2014-03-17','14:40:00',5.29),('10318','2014-03-17','14:45:00',6.15),('10318','2014-03-17','14:50:00',6.41),('10318','2014-03-17','14:55:00',6.08),('10318','2014-03-17','15:00:00',5.22),('10318','2014-03-17','15:05:00',4.63),('10318','2014-03-17','15:10:00',3.46),('10318','2014-03-17','15:15:00',4.03),('10318','2014-03-17','15:20:00',5.33),('10318','2014-03-17','15:25:00',5.19),('10318','2014-03-17','15:30:00',4.95),('10318','2014-03-17','15:35:00',4.43),('10318','2014-03-17','15:40:00',3.91),('10318','2014-03-17','15:45:00',2.33),('10318','2014-03-17','15:50:00',3.18),('10318','2014-03-17','15:55:00',3.41),('10318','2014-03-17','16:00:00',3.55),('10318','2014-03-17','16:05:00',3.24),('10318','2014-03-17','16:10:00',3.05),('10318','2014-03-17','16:15:00',3.06),('10318','2014-03-17','16:20:00',2.89),('10318','2014-03-17','16:25:00',2.62),('10318','2014-03-17','16:30:00',2.45),('10318','2014-03-17','16:35:00',2.25),('10318','2014-03-17','16:40:00',1.98),('10318','2014-03-17','16:45:00',1.99),('10318','2014-03-17','16:50:00',1.69),('10318','2014-03-17','16:55:00',1.49),('10318','2014-03-17','17:00:00',1.43),('10318','2014-03-17','17:05:00',1.12),('10318','2012-12-22','09:25:00',1.25),('10318','2012-12-22','09:30:00',1.6),('10318','2012-12-22','09:35:00',1.77),('10318','2012-12-22','09:40:00',2.31),('10318','2012-12-22','09:45:00',1.76),('10318','2012-12-22','09:50:00',1.49),('10318','2012-12-22','09:55:00',1.67),('10318','2012-12-22','10:00:00',1.84),('10318','2012-12-22','10:05:00',1.87),('10318','2012-12-22','10:10:00',1.95),('10318','2012-12-22','10:15:00',2.11),('10318','2012-12-22','10:20:00',2.61),('10318','2012-12-22','10:25:00',4.06),('10318','2012-12-22','10:30:00',6.19),('10318','2012-12-22','10:35:00',7.26),('10318','2012-12-22','10:40:00',7.82),('10318','2012-12-22','10:45:00',6.75),('10318','2012-12-22','10:50:00',4.62),('10318','2012-12-22','10:55:00',3.42),('10318','2012-12-22','11:00:00',2.2),('10318','2012-12-22','11:05:00',1.9),('10318','2012-12-22','11:10:00',1.25),('10318','2012-12-22','11:15:00',1.27),('10318','2012-12-22','11:20:00',2.32),('10318','2012-12-22','11:25:00',1.56),('10318','2012-12-22','11:30:00',2.28),('10318','2012-12-22','11:35:00',5.03),('10318','2012-12-22','11:40:00',5.71),('10318','2012-12-22','11:45:00',2.1),('10318','2012-12-22','11:50:00',2.44),('10318','2012-12-22','11:55:00',3.03),('10318','2012-12-22','12:00:00',1.5),('10318','2012-12-22','12:05:00',1.88),('10318','2012-12-22','12:10:00',2.48),('10318','2012-12-22','12:15:00',3.36),('10318','2012-12-22','12:20:00',2.2),('10318','2012-12-22','12:25:00',2.26),('10318','2012-12-22','12:30:00',2.11),('10318','2012-12-22','12:35:00',5.37),('10318','2012-12-22','12:40:00',7.65),('10318','2012-12-22','12:45:00',7.75),('10318','2012-12-22','12:50:00',3.54),('10318','2012-12-22','12:55:00',2.58),('10318','2012-12-22','13:00:00',2.77),('10318','2012-12-22','13:05:00',3.9),('10318','2012-12-22','13:10:00',7.75),('10318','2012-12-22','13:15:00',7.25),('10318','2012-12-22','13:20:00',6.92),('10318','2012-12-22','13:25:00',6.84),('10318','2012-12-22','13:30:00',6.63),('10318','2012-12-22','13:35:00',4.33),('10318','2012-12-22','13:40:00',4.5),('10318','2012-12-22','13:45:00',5.44),('10318','2012-12-22','13:50:00',2.92),('10318','2012-12-22','13:55:00',2.35),('10318','2012-12-22','14:00:00',1.81),('10318','2012-12-22','14:05:00',4.82),('10318','2012-12-22','14:10:00',4.49),('10318','2012-12-22','14:15:00',2.07),('10318','2012-12-22','14:20:00',1.76),('10318','2012-12-22','14:25:00',1.22),('10318','2012-12-22','14:45:00',1.03),('10318','2012-12-22','14:50:00',2.09),('10318','2012-12-22','14:55:00',3.55),('10318','2012-12-22','15:00:00',2.45),('10318','2012-12-22','15:05:00',1.25),('10318','2012-12-22','15:10:00',1.17),('10318','2012-12-22','15:15:00',1.22),('10318','2012-12-22','15:50:00',1.24),('10318','2012-12-22','15:55:00',1.24),('10318','2012-12-22','16:00:00',1.02),('10318','2014-03-16','07:10:00',1.09),('10318','2014-03-16','07:15:00',1.32),('10318','2014-03-16','07:20:00',1.46),('10318','2014-03-16','07:25:00',1.62),('10318','2014-03-16','07:30:00',1.92),('10318','2014-03-16','07:35:00',2.26),('10318','2014-03-16','07:40:00',2.39),('10318','2014-03-16','07:45:00',2.5),('10318','2014-03-16','07:50:00',2.58),('10318','2014-03-16','07:55:00',2.98),('10318','2014-03-16','08:00:00',3.36),('10318','2014-03-16','08:05:00',3.62),('10318','2014-03-16','08:10:00',3.74),('10318','2014-03-16','08:15:00',3.86),('10318','2014-03-16','08:20:00',4.12),('10318','2014-03-16','08:25:00',4.46),('10318','2014-03-16','08:30:00',4.69),('10318','2014-03-16','08:35:00',4.87),('10318','2014-03-16','08:40:00',4.95),('10318','2014-03-16','08:45:00',5.2),('10318','2014-03-16','08:50:00',5.35),('10318','2014-03-16','08:55:00',5.46),('10318','2014-03-16','09:00:00',5.39),('10318','2014-03-16','09:05:00',5.6),('10318','2014-03-16','09:10:00',5.84),('10318','2014-03-16','09:15:00',6.3),('10318','2014-03-16','09:20:00',6.33),('10318','2014-03-16','09:25:00',6.22),('10318','2014-03-16','09:30:00',6.39),('10318','2014-03-16','09:35:00',6.44),('10318','2014-03-16','09:40:00',6.6),('10318','2014-03-16','09:45:00',6.84),('10318','2014-03-16','09:50:00',7.26),('10318','2014-03-16','09:55:00',7),('10318','2014-03-16','10:00:00',7.16),('10318','2014-03-16','10:05:00',7.45),('10318','2014-03-16','10:10:00',7.42),('10318','2014-03-16','10:15:00',7.72),('10318','2014-03-16','10:20:00',7.71),('10318','2014-03-16','10:25:00',7.64),('10318','2014-03-16','10:30:00',7.75),('10318','2014-03-16','10:35:00',7.77),('10318','2014-03-16','10:40:00',7.89),('10318','2014-03-16','10:45:00',8.07),('10318','2014-03-16','10:50:00',8.14),('10318','2014-03-16','10:55:00',8.16),('10318','2014-03-16','11:00:00',7.5),('10318','2014-03-16','11:05:00',5.56),('10318','2014-03-16','11:10:00',8.22),('10318','2014-03-16','11:15:00',8.11),('10318','2014-03-16','11:20:00',8.49),('10318','2014-03-16','11:25:00',8.51),('10318','2014-03-16','11:30:00',8.48),('10318','2014-03-16','11:35:00',8.4),('10318','2014-03-16','11:40:00',8.45),('10318','2014-03-16','11:45:00',8.46),('10318','2014-03-16','11:50:00',8.32),('10318','2014-03-16','11:55:00',8.22),('10318','2014-03-16','12:00:00',8.16),('10318','2014-03-16','12:05:00',8.22),('10318','2014-03-16','12:10:00',8.3),('10318','2014-03-16','12:15:00',8.23),('10318','2014-03-16','12:20:00',8.09),('10318','2014-03-16','12:25:00',7.91),('10318','2014-03-16','12:30:00',8.06),('10318','2014-03-16','12:35:00',8.06),('10318','2014-03-16','12:40:00',8.07),('10318','2014-03-16','12:45:00',8.06),('10318','2014-03-16','12:50:00',8.13),('10318','2014-03-16','12:55:00',7.9),('10318','2014-03-16','13:00:00',6.3),('10318','2014-03-16','13:05:00',8.05),('10318','2014-03-16','13:10:00',7.88),('10318','2014-03-16','13:15:00',7.79),('10318','2014-03-16','13:20:00',7.51),('10318','2014-03-16','13:25:00',7.59),('10318','2014-03-16','13:30:00',7.4),('10318','2014-03-16','13:35:00',7.5),('10318','2014-03-16','13:40:00',7.49),('10318','2014-03-16','13:45:00',7.45),('10318','2014-03-16','13:50:00',7.19),('10318','2014-03-16','13:55:00',7.14),('10318','2014-03-16','14:00:00',7.01),('10318','2014-03-16','14:05:00',6.81),('10318','2014-03-16','14:10:00',6.55),('10318','2014-03-16','14:15:00',6.62),('10318','2014-03-16','14:20:00',6.41),('10318','2014-03-16','14:25:00',6.34),('10318','2014-03-16','14:30:00',6.21),('10318','2014-03-16','14:35:00',6.02),('10318','2014-03-16','14:40:00',5.93),('10318','2014-03-16','14:45:00',5.86),('10318','2014-03-16','14:50:00',5.23),('10318','2014-03-16','14:55:00',5.38),('10318','2014-03-16','15:00:00',5.25),('10318','2014-03-16','15:05:00',5.13),('10318','2014-03-16','15:10:00',4.81),('10318','2014-03-16','15:15:00',4.08),('10318','2014-03-16','15:20:00',3.72),('10318','2014-03-16','15:25:00',4.11),('10318','2014-03-16','15:30:00',3.75),('10318','2014-03-16','15:35:00',3.35),('10318','2014-03-16','15:40:00',2.89),('10318','2014-03-16','15:45:00',2.99),('10318','2014-03-16','15:50:00',3.03),('10318','2014-03-16','15:55:00',2.85),('10318','2014-03-16','16:00:00',2.35),('10318','2014-03-16','16:05:00',2.95),('10318','2014-03-16','16:10:00',3.08),('10318','2014-03-16','16:15:00',2.92),('10318','2014-03-16','16:20:00',2.79),('10318','2014-03-16','16:25:00',2.55),('10318','2014-03-16','16:30:00',2.65),('10318','2014-03-16','16:35:00',2.53),('10318','2014-03-16','16:40:00',2.12),('10318','2014-03-16','16:45:00',1.89),('10318','2014-03-16','16:50:00',1.76),('10318','2014-03-16','16:55:00',1.42),('10318','2014-03-16','17:00:00',1.2),('10318','2014-03-16','17:05:00',1.09),('10318','2014-03-15','07:15:00',1.12),('10318','2014-03-15','07:20:00',1.29),('10318','2014-03-15','07:25:00',1.44),('10318','2014-03-15','07:30:00',1.68),('10318','2014-03-15','07:35:00',2.08),('10318','2014-03-15','07:40:00',2.28),('10318','2014-03-15','07:45:00',2.48),('10318','2014-03-15','07:50:00',2.74),('10318','2014-03-15','07:55:00',2.98),('10318','2014-03-15','08:00:00',3.19),('10318','2014-03-15','08:05:00',3.42),('10318','2014-03-15','08:10:00',3.6),('10318','2014-03-15','08:15:00',3.8),('10318','2014-03-15','08:20:00',4.05),('10318','2014-03-15','08:25:00',4.25),('10318','2014-03-15','08:30:00',4.44),('10318','2014-03-15','08:35:00',4.61),('10318','2014-03-15','08:40:00',4.75),('10318','2014-03-15','08:45:00',4.91),('10318','2014-03-15','08:50:00',5.16),('10318','2014-03-15','08:55:00',5.36),('10318','2014-03-15','09:00:00',5.43),('10318','2014-03-15','09:05:00',5.68),('10318','2014-03-15','09:10:00',5.82),('10318','2014-03-15','09:15:00',5.99),('10318','2014-03-15','09:20:00',6.09),('10318','2014-03-15','09:25:00',6.22),('10318','2014-03-15','09:30:00',6.31),('10318','2014-03-15','09:35:00',6.52),('10318','2014-03-15','09:40:00',6.66),('10318','2014-03-15','09:45:00',6.78),('10318','2014-03-15','09:50:00',6.9),('10318','2014-03-15','09:55:00',7.02),('10318','2014-03-15','10:00:00',7.07),('10318','2014-03-15','10:05:00',7.23),('10318','2014-03-15','10:10:00',7.25),('10318','2014-03-15','10:15:00',7.31),('10318','2014-03-15','10:20:00',7.39),('10318','2014-03-15','10:25:00',7.42),('10318','2014-03-15','10:30:00',7.48),('10318','2014-03-15','10:35:00',7.56),('10318','2014-03-15','10:40:00',7.58),('10318','2014-03-15','10:45:00',7.23),('10318','2014-03-15','10:50:00',7.61),('10318','2014-03-15','10:55:00',7.79),('10318','2014-03-15','11:00:00',7.69),('10318','2014-03-15','11:05:00',8.02),('10318','2014-03-15','11:10:00',8.14),('10318','2014-03-15','11:15:00',8.04),('10318','2014-03-15','11:20:00',8.21),('10318','2014-03-15','11:25:00',8.1),('10318','2014-03-15','11:30:00',8.1),('10318','2014-03-15','11:35:00',8.15),('10318','2014-03-15','11:40:00',8.29),('10318','2014-03-15','11:45:00',8.21),('10318','2014-03-15','11:50:00',8.2),('10318','2014-03-15','11:55:00',8.15),('10318','2014-03-15','12:00:00',8.17),('10318','2014-03-15','12:05:00',8.29),('10318','2014-03-15','12:10:00',8.03),('10318','2014-03-15','12:15:00',8.25),('10318','2014-03-15','12:20:00',8.21),('10318','2014-03-15','12:25:00',8.3),('10318','2014-03-15','12:30:00',8.24),('10318','2014-03-15','12:35:00',7.96),('10318','2014-03-15','12:40:00',8.09),('10318','2014-03-15','12:45:00',8.13),('10318','2014-03-15','12:50:00',8.22),('10318','2014-03-15','12:55:00',8),('10318','2014-03-15','13:00:00',7.99),('10318','2014-03-15','13:05:00',7.89),('10318','2014-03-15','13:10:00',7.91),('10318','2014-03-15','13:15:00',7.87),('10318','2014-03-15','13:20:00',7.77),('10318','2014-03-15','13:25:00',7.77),('10318','2014-03-15','13:30:00',7.71),('10318','2014-03-15','13:35:00',7.62),('10318','2014-03-15','13:40:00',7.5),('10318','2014-03-15','13:45:00',7.33),('10318','2014-03-15','13:50:00',7.33),('10318','2014-03-15','13:55:00',7.26),('10318','2014-03-15','14:00:00',7.18),('10318','2014-03-15','14:05:00',7.04),('10318','2014-03-15','14:10:00',6.91),('10318','2014-03-15','14:15:00',6.77),('10318','2014-03-15','14:20:00',6.5),('10318','2014-03-15','14:25:00',6.53),('10318','2014-03-15','14:30:00',6.39),('10318','2014-03-15','14:35:00',6.21),('10318','2014-03-15','14:40:00',6.06),('10318','2014-03-15','14:45:00',5.84),('10318','2014-03-15','14:50:00',5.72),('10318','2014-03-15','14:55:00',5.62),('10318','2014-03-15','15:00:00',5.45),('10318','2014-03-15','15:05:00',5.27),('10318','2014-03-15','15:10:00',5.09),('10318','2014-03-15','15:15:00',4.92),('10318','2014-03-15','15:20:00',4.77),('10318','2014-03-15','15:25:00',4.57),('10318','2014-03-15','15:30:00',4.39),('10318','2014-03-15','15:35:00',4.13),('10318','2014-03-15','15:40:00',4.01),('10318','2014-03-15','15:45:00',3.87),('10318','2014-03-15','15:50:00',3.66),('10318','2014-03-15','15:55:00',3.43),('10318','2014-03-15','16:00:00',3.2),('10318','2014-03-15','16:05:00',2.99),('10318','2014-03-15','16:10:00',2.85),('10318','2014-03-15','16:15:00',2.59),('10318','2014-03-15','16:20:00',2.48),('10318','2014-03-15','16:25:00',2.35),('10318','2014-03-15','16:30:00',2.2),('10318','2014-03-15','16:35:00',1.98),('10318','2014-03-15','16:40:00',1.91),('10318','2014-03-15','16:45:00',1.75),('10318','2014-03-15','16:50:00',1.58),('10318','2014-03-15','16:55:00',1.43),('10318','2014-03-15','17:00:00',1.29),('10318','2014-03-15','17:05:00',1.14),('10318','2014-03-15','17:10:00',1.02),('10318','2014-03-14','07:30:00',1.1),('10318','2014-03-14','07:35:00',1.21),('10318','2014-03-14','07:40:00',1.35),('10318','2014-03-14','07:45:00',1.51),('10318','2014-03-14','07:50:00',1.65),('10318','2014-03-14','07:55:00',1.79),('10318','2014-03-14','08:00:00',1.92),('10318','2014-03-14','08:05:00',2.04),('10318','2014-03-14','08:10:00',2.19),('10318','2014-03-14','08:15:00',2.36),('10318','2014-03-14','08:20:00',2.68),('10318','2014-03-14','08:25:00',3.02),('10318','2014-03-14','08:30:00',3.06),('10318','2014-03-14','08:35:00',3.01),('10318','2014-03-14','08:40:00',2.72),('10318','2014-03-14','08:45:00',2.57),('10318','2014-03-14','08:50:00',2.45),('10318','2014-03-14','08:55:00',2.46),('10318','2014-03-14','09:00:00',2.7),('10318','2014-03-14','09:05:00',3.06),('10318','2014-03-14','09:10:00',3.66),('10318','2014-03-14','09:15:00',3.96),('10318','2014-03-14','09:20:00',3.81),('10318','2014-03-14','09:25:00',3.67),('10318','2014-03-14','09:30:00',3.89),('10318','2014-03-14','09:35:00',4.2),('10318','2014-03-14','09:40:00',5.09),('10318','2014-03-14','09:45:00',6.05),('10318','2014-03-14','09:50:00',6.84),('10318','2014-03-14','09:55:00',7.71),('10318','2014-03-14','10:00:00',8.2),('10318','2014-03-14','10:05:00',8.25),('10318','2014-03-14','10:10:00',8.23),('10318','2014-03-14','10:15:00',8.47),('10318','2014-03-14','10:20:00',8.39),('10318','2014-03-14','10:25:00',8.03),('10318','2014-03-14','10:30:00',7.85),('10318','2014-03-14','10:35:00',7.88),('10318','2014-03-14','10:40:00',8.2),('10318','2014-03-14','10:45:00',8.04),('10318','2014-03-14','10:50:00',5.6),('10318','2014-03-14','10:55:00',5.17),('10318','2014-03-14','11:00:00',7.62),('10318','2014-03-14','11:05:00',7.72),('10318','2014-03-14','11:10:00',8.32),('10318','2014-03-14','11:15:00',8.8),('10318','2014-03-14','11:20:00',8.71),('10318','2014-03-14','11:25:00',8.26),('10318','2014-03-14','11:30:00',8.29),('10318','2014-03-14','11:35:00',8.25),('10318','2014-03-14','11:40:00',8.03),('10318','2014-03-14','11:45:00',7.94),('10318','2014-03-14','11:50:00',8.35),('10318','2014-03-14','11:55:00',8.42),('10318','2014-03-14','12:00:00',8.34),('10318','2014-03-14','12:05:00',8.38),('10318','2014-03-14','12:10:00',8.22),('10318','2014-03-14','12:15:00',7.96),('10318','2014-03-14','12:20:00',7.5),('10318','2014-03-14','12:25:00',6.16),('10318','2014-03-14','12:30:00',5.52),('10318','2014-03-14','12:35:00',4.93),('10318','2014-03-14','12:40:00',4.33),('10318','2014-03-14','12:45:00',5.33),('10318','2014-03-14','12:50:00',5.35),('10318','2014-03-14','12:55:00',6.12),('10318','2014-03-14','13:00:00',5.47),('10318','2014-03-14','13:05:00',3.94),('10318','2014-03-14','13:10:00',4.86),('10318','2014-03-14','13:15:00',5.23),('10318','2014-03-14','13:20:00',5.83),('10318','2014-03-14','13:25:00',5.9),('10318','2014-03-14','13:30:00',5.5),('10318','2014-03-14','13:35:00',4.99),('10318','2014-03-14','13:40:00',4.11),('10318','2014-03-14','13:45:00',4.56),('10318','2014-03-14','13:50:00',4.92),('10318','2014-03-14','13:55:00',4.85),('10318','2014-03-14','14:00:00',4.59),('10318','2014-03-14','14:05:00',5.34),('10318','2014-03-14','14:10:00',5.76),('10318','2014-03-14','14:15:00',6.36),('10318','2014-03-14','14:20:00',5.46),('10318','2014-03-14','14:25:00',5.47),('10318','2014-03-14','14:30:00',5.39),('10318','2014-03-14','14:35:00',5.45),('10318','2014-03-14','14:40:00',4.76),('10318','2014-03-14','14:45:00',3.8),('10318','2014-03-14','14:50:00',3.45),('10318','2014-03-14','14:55:00',3.11),('10318','2014-03-14','15:00:00',2.77),('10318','2014-03-14','15:05:00',2.69),('10318','2014-03-14','15:10:00',2.61),('10318','2014-03-14','15:15:00',2.43),('10318','2014-03-14','15:20:00',2.51),('10318','2014-03-14','15:25:00',2.93),('10318','2014-03-14','15:30:00',2.97),('10318','2014-03-14','15:35:00',3.54),('10318','2014-03-14','15:40:00',3.47),('10318','2014-03-14','15:45:00',2.88),('10318','2014-03-14','15:50:00',2.49),('10318','2014-03-14','15:55:00',2.39),('10318','2014-03-14','16:00:00',2.24),('10318','2014-03-14','16:05:00',2.18),('10318','2014-03-14','16:10:00',2.11),('10318','2014-03-14','16:15:00',1.75),('10318','2014-03-14','16:20:00',1.51),('10318','2014-03-14','16:25:00',1.35),('10318','2014-03-14','16:30:00',1.3),('10318','2014-03-14','16:35:00',1.26),('10318','2014-03-14','16:40:00',1.17),('10318','2014-03-14','16:45:00',1.09),('10318','2014-03-14','16:50:00',1.05),('10318','2014-03-13','07:10:00',1.07),('10318','2014-03-13','07:15:00',1.24),('10318','2014-03-13','07:20:00',1.46),('10318','2014-03-13','07:25:00',1.66),('10318','2014-03-13','07:30:00',2.1),('10318','2014-03-13','07:35:00',2.93),('10318','2014-03-13','07:40:00',3.34),('10318','2014-03-13','07:45:00',3.57),('10318','2014-03-13','07:50:00',3.82),('10318','2014-03-13','07:55:00',4.06),('10318','2014-03-13','08:00:00',4.28),('10318','2014-03-13','08:05:00',4.5),('10318','2014-03-13','08:10:00',4.71),('10318','2014-03-13','08:15:00',4.9),('10318','2014-03-13','08:20:00',5.11),('10318','2014-03-13','08:25:00',5.31),('10318','2014-03-13','08:30:00',5.48),('10318','2014-03-13','08:35:00',5.69),('10318','2014-03-13','08:40:00',5.87),('10318','2014-03-13','08:45:00',6.03),('10318','2014-03-13','08:50:00',6.23),('10318','2014-03-13','08:55:00',6.4),('10318','2014-03-13','09:00:00',6.38),('10318','2014-03-13','09:05:00',6.7),('10318','2014-03-13','09:10:00',6.83),('10318','2014-03-13','09:15:00',6.98),('10318','2014-03-13','09:20:00',7.09),('10318','2014-03-13','09:25:00',7.24),('10318','2014-03-13','09:30:00',7.35),('10318','2014-03-13','09:35:00',7.46),('10318','2014-03-13','09:40:00',7.54),('10318','2014-03-13','09:45:00',7.68),('10318','2014-03-13','09:50:00',7.77),('10318','2014-03-13','09:55:00',7.95),('10318','2014-03-13','10:00:00',8.05),('10318','2014-03-13','10:05:00',8.19),('10318','2014-03-13','10:10:00',8.32),('10318','2014-03-13','10:15:00',8.34),('10318','2014-03-13','10:20:00',8.44),('10318','2014-03-13','10:25:00',8.51),('10318','2014-03-13','10:30:00',8.57),('10318','2014-03-13','10:35:00',8.64),('10318','2014-03-13','10:40:00',8.64),('10318','2014-03-13','10:45:00',8.72),('10318','2014-03-13','10:50:00',8.76),('10318','2014-03-13','10:55:00',8.76),('10318','2014-03-13','11:00:00',8.76),('10318','2014-03-13','11:05:00',8.83),('10318','2014-03-13','11:10:00',8.89),('10318','2014-03-13','11:15:00',8.85),('10318','2014-03-13','11:20:00',8.85),('10318','2014-03-13','11:25:00',8.86),('10318','2014-03-13','11:30:00',8.85),('10318','2014-03-13','11:35:00',8.84),('10318','2014-03-13','11:40:00',8.76),('10318','2014-03-13','11:45:00',8.84),('10318','2014-03-13','11:50:00',8.83),('10318','2014-03-13','11:55:00',8.78),('10318','2014-03-13','12:00:00',8.62),('10318','2014-03-13','12:05:00',8.78),('10318','2014-03-13','12:10:00',8.74),('10318','2014-03-13','12:15:00',8.71),('10318','2014-03-13','12:20:00',8.64),('10318','2014-03-13','12:25:00',8.58),('10318','2014-03-13','12:30:00',8.58),('10318','2014-03-13','12:35:00',8.54),('10318','2014-03-13','12:40:00',8.5),('10318','2014-03-13','12:45:00',8.41),('10318','2014-03-13','12:50:00',8.31),('10318','2014-03-13','12:55:00',8.21),('10318','2014-03-13','13:00:00',8.12),('10318','2014-03-13','13:05:00',8.03),('10318','2014-03-13','13:10:00',7.92),('10318','2014-03-13','13:15:00',7.95),('10318','2014-03-13','13:20:00',7.91),('10318','2014-03-13','13:25:00',7.85),('10318','2014-03-13','13:30:00',7.77),('10318','2014-03-13','13:35:00',7.71),('10318','2014-03-13','13:40:00',7.59),('10318','2014-03-13','13:45:00',7.54),('10318','2014-03-13','13:50:00',7.29),('10318','2014-03-13','13:55:00',7.3),('10318','2014-03-13','14:00:00',7.14),('10318','2014-03-13','14:05:00',6.99),('10318','2014-03-13','14:10:00',6.91),('10318','2014-03-13','14:15:00',6.75),('10318','2014-03-13','14:20:00',6.57),('10318','2014-03-13','14:25:00',6.46),('10318','2014-03-13','14:30:00',6.36),('10318','2014-03-13','14:35:00',6.26),('10318','2014-03-13','14:40:00',6.09),('10318','2014-03-13','14:45:00',5.92),('10318','2014-03-13','14:50:00',5.73),('10318','2014-03-13','14:55:00',5.57),('10318','2014-03-13','15:00:00',5.38),('10318','2014-03-13','15:05:00',5.18),('10318','2014-03-13','15:10:00',5.02),('10318','2014-03-13','15:15:00',4.84),('10318','2014-03-13','15:20:00',4.67),('10318','2014-03-13','15:25:00',4.48),('10318','2014-03-13','15:30:00',4.31),('10318','2014-03-13','15:35:00',4.06),('10318','2014-03-13','15:40:00',3.96),('10318','2014-03-13','15:45:00',3.77),('10318','2014-03-13','15:50:00',3.61),('10318','2014-03-13','15:55:00',3.46),('10318','2014-03-13','16:00:00',3.27),('10318','2014-03-13','16:05:00',3.08),('10318','2014-03-13','16:10:00',2.92),('10318','2014-03-13','16:15:00',2.74),('10318','2014-03-13','16:20:00',2.59),('10318','2014-03-13','16:25:00',2.43),('10318','2014-03-13','16:30:00',2.27),('10318','2014-03-13','16:35:00',2.11),('10318','2014-03-13','16:40:00',1.96),('10318','2014-03-13','16:45:00',1.83),('10318','2014-03-13','16:50:00',1.66),('10318','2014-03-13','16:55:00',1.5),('10318','2014-03-13','17:00:00',1.34),('10318','2014-03-13','17:05:00',1.19),('10318','2014-03-13','17:10:00',1.04),('10318','2014-03-12','07:15:00',1.15),('10318','2014-03-12','07:20:00',1.31),('10318','2014-03-12','07:25:00',1.52),('10318','2014-03-12','07:30:00',1.7),('10318','2014-03-12','07:35:00',2.62),('10318','2014-03-12','07:40:00',3.17),('10318','2014-03-12','07:45:00',3.41),('10318','2014-03-12','07:50:00',3.65),('10318','2014-03-12','07:55:00',3.9),('10318','2014-03-12','08:00:00',4.13),('10318','2014-03-12','08:05:00',4.25),('10318','2014-03-12','08:10:00',4.59),('10318','2014-03-12','08:15:00',4.8),('10318','2014-03-12','08:20:00',5.04),('10318','2014-03-12','08:25:00',5.24),('10318','2014-03-12','08:30:00',5.42),('10318','2014-03-12','08:35:00',5.58),('10318','2014-03-12','08:40:00',5.81),('10318','2014-03-12','08:45:00',6.01),('10318','2014-03-12','08:50:00',6.19),('10318','2014-03-12','08:55:00',6.36),('10318','2014-03-12','09:00:00',6.51),('10318','2014-03-12','09:05:00',6.66),('10318','2014-03-12','09:10:00',6.79),('10318','2014-03-12','09:15:00',6.92),('10318','2014-03-12','09:20:00',7.06),('10318','2014-03-12','09:25:00',7.16),('10318','2014-03-12','09:30:00',7.24),('10318','2014-03-12','09:35:00',7.39),('10318','2014-03-12','09:40:00',7.52),('10318','2014-03-12','09:45:00',7.61),('10318','2014-03-12','09:50:00',7.66),('10318','2014-03-12','09:55:00',7.88),('10318','2014-03-12','10:00:00',7.93),('10318','2014-03-12','10:05:00',8.03),('10318','2014-03-12','10:10:00',8.11),('10318','2014-03-12','10:15:00',8.19),('10318','2014-03-12','10:20:00',8.27),('10318','2014-03-12','10:25:00',8.35),('10318','2014-03-12','10:30:00',8.4),('10318','2014-03-12','10:35:00',8.5),('10318','2014-03-12','10:40:00',8.62),('10318','2014-03-12','10:45:00',8.72),('10318','2014-03-12','10:50:00',8.77),('10318','2014-03-12','10:55:00',8.82),('10318','2014-03-12','11:00:00',8.86),('10318','2014-03-12','11:05:00',8.95),('10318','2014-03-12','11:10:00',8.92),('10318','2014-03-12','11:15:00',8.94),('10318','2014-03-12','11:20:00',9.05),('10318','2014-03-12','11:25:00',9.04),('10318','2014-03-12','11:30:00',9),('10318','2014-03-12','11:35:00',8.79),('10318','2014-03-12','11:40:00',8.98),('10318','2014-03-12','11:45:00',9.04),('10318','2014-03-12','11:50:00',9.06),('10318','2014-03-12','11:55:00',9.02),('10318','2014-03-12','12:00:00',8.98),('10318','2014-03-12','12:05:00',8.97),('10318','2014-03-12','12:10:00',9.02),('10318','2014-03-12','12:15:00',8.98),('10318','2014-03-12','12:20:00',8.91),('10318','2014-03-12','12:25:00',8.91),('10318','2014-03-12','12:30:00',8.82),('10318','2014-03-12','12:35:00',8.78),('10318','2014-03-12','12:40:00',8.75),('10318','2014-03-12','12:45:00',8.75),('10318','2014-03-12','12:50:00',8.62),('10318','2014-03-12','12:55:00',8.59),('10318','2014-03-12','13:00:00',8.53),('10318','2014-03-12','13:05:00',8.41),('10318','2014-03-12','13:10:00',8.29),('10318','2014-03-12','13:15:00',8.21),('10318','2014-03-12','13:20:00',8.04),('10318','2014-03-12','13:25:00',8.11),('10318','2014-03-12','13:30:00',8),('10318','2014-03-12','13:35:00',7.92),('10318','2014-03-12','13:40:00',7.84),('10318','2014-03-12','13:45:00',7.76),('10318','2014-03-12','13:50:00',7.58),('10318','2014-03-12','13:55:00',7.54),('10318','2014-03-12','14:00:00',7.35),('10318','2014-03-12','14:05:00',7.23),('10318','2014-03-12','14:10:00',7.08),('10318','2014-03-12','14:15:00',6.95),('10318','2014-03-12','14:20:00',6.82),('10318','2014-03-12','14:25:00',6.73),('10318','2014-03-12','14:30:00',6.51),('10318','2014-03-12','14:35:00',6.28),('10318','2014-03-12','14:40:00',6.12),('10318','2014-03-12','14:45:00',5.87),('10318','2014-03-12','14:50:00',5.3),('10318','2014-03-12','14:55:00',4.13),('10318','2014-03-12','15:00:00',5.59),('10318','2014-03-12','15:05:00',5.21),('10318','2014-03-12','15:10:00',4.99),('10318','2014-03-12','15:15:00',4.79),('10318','2014-03-12','15:20:00',4.61),('10318','2014-03-12','15:25:00',4.5),('10318','2014-03-12','15:30:00',4.36),('10318','2014-03-12','15:35:00',4.22),('10318','2014-03-12','15:40:00',4.1),('10318','2014-03-12','15:45:00',3.89),('10318','2014-03-12','15:50:00',3.67),('10318','2014-03-12','15:55:00',3.52),('10318','2014-03-12','16:00:00',3.35),('10318','2014-03-12','16:05:00',3.18),('10318','2014-03-12','16:10:00',3.01),('10318','2014-03-12','16:15:00',2.82),('10318','2014-03-12','16:20:00',2.63),('10318','2014-03-12','16:25:00',2.51),('10318','2014-03-12','16:30:00',2.33),('10318','2014-03-12','16:35:00',2.17),('10318','2014-03-12','16:40:00',2),('10318','2014-03-12','16:45:00',1.83),('10318','2014-03-12','16:50:00',1.63),('10318','2014-03-12','16:55:00',1.46),('10318','2014-03-12','17:00:00',1.32),('10318','2014-03-12','17:05:00',1.18),('10318','2014-03-12','17:10:00',1.03),('10318','2014-03-11','07:35:00',1.07),('10318','2014-03-11','07:40:00',1.21),('10318','2014-03-11','07:45:00',1.36),('10318','2014-03-11','07:50:00',1.36),('10318','2014-03-11','07:55:00',1.45),('10318','2014-03-11','08:00:00',1.36),('10318','2014-03-11','08:05:00',1.16),('10318','2014-03-11','08:10:00',1),('10318','2014-03-11','08:20:00',1.05),('10318','2014-03-11','08:25:00',1.13),('10318','2014-03-11','08:55:00',1.03),('10318','2014-03-11','09:00:00',1.07),('10318','2014-03-11','09:05:00',1.09),('10318','2014-03-11','09:10:00',1.18),('10318','2014-03-11','09:15:00',1.19),('10318','2014-03-11','09:20:00',1.09),('10318','2014-03-11','09:25:00',1.12),('10318','2014-03-11','09:30:00',1.17),('10318','2014-03-11','09:35:00',1.15),('10318','2014-03-11','09:40:00',1.09),('10318','2014-03-11','09:50:00',1.02),('10318','2014-03-11','09:55:00',1.01),('10318','2014-03-11','10:00:00',1.05),('10318','2014-03-11','10:05:00',1.22),('10318','2014-03-11','10:10:00',1.45),('10318','2014-03-11','10:15:00',1.71),('10318','2014-03-11','10:20:00',2.08),('10318','2014-03-11','10:25:00',2.22),('10318','2014-03-11','10:30:00',2.32),('10318','2014-03-11','10:35:00',2.19),('10318','2014-03-11','10:40:00',2.05),('10318','2014-03-11','10:45:00',1.93),('10318','2014-03-11','10:50:00',1.84),('10318','2014-03-11','10:55:00',2),('10318','2014-03-11','11:00:00',2.29),('10318','2014-03-11','11:05:00',2.46),('10318','2014-03-11','11:10:00',2.58),('10318','2014-03-11','11:15:00',2.68),('10318','2014-03-11','11:20:00',2.47),('10318','2014-03-11','11:25:00',2.31),('10318','2014-03-11','11:30:00',1.96),('10318','2014-03-11','11:35:00',1.93),('10318','2014-03-11','11:40:00',1.99),('10318','2014-03-11','11:45:00',2.17),('10318','2014-03-11','11:50:00',2.08),('10318','2014-03-11','11:55:00',2.27),('10318','2014-03-11','12:00:00',2.39),('10318','2014-03-11','12:05:00',2.35),('10318','2014-03-11','12:10:00',2.4),('10318','2014-03-11','12:15:00',2.77),('10318','2014-03-11','12:20:00',3.01),('10318','2014-03-11','12:25:00',2.8),('10318','2014-03-11','12:30:00',2.77),('10318','2014-03-11','12:35:00',3.02),('10318','2014-03-11','12:40:00',3.17),('10318','2014-03-11','12:45:00',3.42),('10318','2014-03-11','12:50:00',3.45),('10318','2014-03-11','12:55:00',3.29),('10318','2014-03-11','13:00:00',3.1),('10318','2014-03-11','13:05:00',3.11),('10318','2014-03-11','13:10:00',3.24),('10318','2014-03-11','13:15:00',2.99),('10318','2014-03-11','13:20:00',3.48),('10318','2014-03-11','13:25:00',2.95),('10318','2014-03-11','13:30:00',2.54),('10318','2014-03-11','13:35:00',2.46),('10318','2014-03-11','13:40:00',2.62),('10318','2014-03-11','13:45:00',3.04),('10318','2014-03-11','13:50:00',3.31),('10318','2014-03-11','13:55:00',3.55),('10318','2014-03-11','14:00:00',3.94),('10318','2014-03-11','14:05:00',4.52),('10318','2014-03-11','14:10:00',5),('10318','2014-03-11','14:15:00',5.54),('10318','2014-03-11','14:20:00',7.76),('10318','2014-03-11','14:25:00',4.42),('10318','2014-03-11','14:30:00',3.52),('10318','2014-03-11','14:35:00',3.79),('10318','2014-03-11','14:40:00',3.47),('10318','2014-03-11','14:45:00',3.77),('10318','2014-03-11','14:50:00',3.36),('10318','2014-03-11','14:55:00',3.21),('10318','2014-03-11','15:00:00',3.36),('10318','2014-03-11','15:05:00',3.39),('10318','2014-03-11','15:10:00',3.64),('10318','2014-03-11','15:15:00',4.34),('10318','2014-03-11','15:20:00',3.7),('10318','2014-03-11','15:25:00',3.16),('10318','2014-03-11','15:30:00',3.04),('10318','2014-03-11','15:35:00',2.81),('10318','2014-03-11','15:40:00',2.41),('10318','2014-03-11','15:45:00',2.26),('10318','2014-03-11','15:50:00',2.26),('10318','2014-03-11','15:55:00',1.82),('10318','2014-03-11','16:00:00',1.65),('10318','2014-03-11','16:05:00',1.54),('10318','2014-03-11','16:10:00',1.62),('10318','2014-03-11','16:15:00',1.58),('10318','2014-03-11','16:20:00',1.57),('10318','2014-03-11','16:25:00',1.39),('10318','2014-03-11','16:30:00',1.32),('10318','2014-03-11','16:35:00',1.21),('10318','2014-03-11','16:40:00',1.12),('10318','2014-03-10','08:05:00',1.03),('10318','2014-03-10','08:10:00',1.21),('10318','2014-03-10','08:15:00',1.3),('10318','2014-03-10','08:20:00',1.42),('10318','2014-03-10','08:25:00',1.57),('10318','2014-03-10','08:30:00',1.68),('10318','2014-03-10','08:35:00',1.9),('10318','2014-03-10','08:40:00',2.07),('10318','2014-03-10','08:45:00',2.11),('10318','2014-03-10','08:50:00',2.22),('10318','2014-03-10','08:55:00',2.24),('10318','2014-03-10','09:00:00',2.26),('10318','2014-03-10','09:05:00',2.42),('10318','2014-03-10','09:10:00',2.46),('10318','2014-03-10','09:15:00',2.59),('10318','2014-03-10','09:20:00',2.32),('10318','2014-03-10','09:25:00',1.92),('10318','2014-03-10','09:30:00',2.1),('10318','2014-03-10','09:35:00',2.42),('10318','2014-03-10','09:40:00',2.61),('10318','2014-03-10','09:45:00',2.48),('10318','2014-03-10','09:50:00',2.33),('10318','2014-03-10','09:55:00',2.18),('10318','2014-03-10','10:00:00',1.88),('10318','2014-03-10','10:05:00',2.04),('10318','2014-03-10','10:10:00',2.38),('10318','2014-03-10','10:15:00',2.66),('10318','2014-03-10','10:20:00',2.38),('10318','2014-03-10','10:25:00',2.06),('10318','2014-03-10','10:30:00',2.38),('10318','2014-03-10','10:35:00',2.45),('10318','2014-03-10','10:40:00',1.81),('10318','2014-03-10','10:45:00',1.36),('10318','2014-03-10','11:00:00',1.12),('10318','2014-03-10','11:05:00',1.24),('10318','2014-03-10','11:10:00',1.35),('10318','2014-03-10','11:15:00',1.88),('10318','2014-03-10','11:20:00',2.17),('10318','2014-03-10','11:25:00',2.01),('10318','2014-03-10','11:30:00',1.83),('10318','2014-03-10','11:35:00',1.21),('10318','2014-03-10','12:05:00',1.14),('10318','2014-03-10','12:10:00',1.3),('10318','2014-03-10','12:15:00',1.33),('10318','2014-03-10','12:20:00',1.36),('10318','2014-03-10','12:25:00',1.4),('10318','2014-03-10','12:30:00',1.5),('10318','2014-03-10','12:35:00',1.72),('10318','2014-03-10','12:40:00',1.95),('10318','2014-03-10','12:45:00',2.21),('10318','2014-03-10','12:50:00',2.43),('10318','2014-03-10','12:55:00',2.59),('10318','2014-03-10','13:00:00',2.72),('10318','2014-03-10','13:05:00',2.72),('10318','2014-03-10','13:10:00',2.72),('10318','2014-03-10','13:15:00',2.79),('10318','2014-03-10','13:20:00',2.79),('10318','2014-03-10','13:25:00',2.46),('10318','2014-03-10','13:30:00',2.29),('10318','2014-03-10','13:35:00',2),('10318','2014-03-10','13:40:00',1.74),('10318','2014-03-10','13:45:00',1.58),('10318','2014-03-10','13:50:00',2.12),('10318','2014-03-10','13:55:00',2.49),('10318','2014-03-10','14:00:00',2.57),('10318','2014-03-10','14:05:00',3.33),('10318','2014-03-10','14:10:00',3.44),('10318','2014-03-10','14:15:00',3.75),('10318','2014-03-10','14:20:00',3.3),('10318','2014-03-10','14:25:00',2.65),('10318','2014-03-10','14:30:00',2.43),('10318','2014-03-10','14:35:00',2.92),('10318','2014-03-10','14:40:00',3.8),('10318','2014-03-10','14:45:00',4.68),('10318','2014-03-10','14:50:00',4.16),('10318','2014-03-10','14:55:00',4.26),('10318','2014-03-10','15:00:00',6.5),('10318','2014-03-10','15:05:00',6.37),('10318','2014-03-10','15:10:00',6.06),('10318','2014-03-10','15:15:00',5.7),('10318','2014-03-10','15:20:00',5.36),('10318','2014-03-10','15:25:00',5.26),('10318','2014-03-10','15:30:00',5.2),('10318','2014-03-10','15:35:00',3.9),('10318','2014-03-10','15:40:00',2.75),('10318','2014-03-10','15:45:00',2.18),('10318','2014-03-10','15:50:00',1.27),('10318','2014-03-10','15:55:00',1.63),('10318','2014-03-10','16:00:00',1.51),('10318','2014-03-10','16:05:00',1.42),('10318','2014-03-10','16:10:00',1.22),('10318','2014-03-10','16:15:00',1.36),('10318','2014-03-10','16:20:00',1.43),('10318','2014-03-10','16:25:00',1.62),('10318','2014-03-10','16:30:00',2.29),('10318','2014-03-10','16:35:00',2.29),('10318','2014-03-10','16:40:00',1.66),('10318','2014-03-10','16:45:00',1.47),('10318','2014-03-10','16:50:00',1.43),('10318','2014-03-10','16:55:00',1.7),('10318','2014-03-10','17:00:00',1.77),('10318','2014-03-10','17:05:00',1.41),('10318','2014-03-09','07:30:00',1.21),('10318','2014-03-09','07:35:00',1.29),('10318','2014-03-09','07:40:00',2.38),('10318','2014-03-09','07:45:00',3.03),('10318','2014-03-09','07:50:00',3.07),('10318','2014-03-09','07:55:00',3.65),('10318','2014-03-09','08:00:00',3.89),('10318','2014-03-09','08:05:00',4.12),('10318','2014-03-09','08:10:00',4.37),('10318','2014-03-09','08:15:00',4.61),('10318','2014-03-09','08:20:00',4.84),('10318','2014-03-09','08:25:00',4.98),('10318','2014-03-09','08:30:00',4.9),('10318','2014-03-09','08:35:00',4.53),('10318','2014-03-09','08:40:00',4.81),('10318','2014-03-09','08:45:00',5.57),('10318','2014-03-09','08:50:00',4.97),('10318','2014-03-09','08:55:00',6.01),('10318','2014-03-09','09:00:00',6.48),('10318','2014-03-09','09:05:00',6.66),('10318','2014-03-09','09:10:00',6.8),('10318','2014-03-09','09:15:00',6.91),('10318','2014-03-09','09:20:00',6),('10318','2014-03-09','09:25:00',7.41),('10318','2014-03-09','09:30:00',7.58),('10318','2014-03-09','09:35:00',7.93),('10318','2014-03-09','09:40:00',7.94),('10318','2014-03-09','09:45:00',8.06),('10318','2014-03-09','09:50:00',8.09),('10318','2014-03-09','09:55:00',8.1),('10318','2014-03-09','10:00:00',8.18),('10318','2014-03-09','10:05:00',8.24),('10318','2014-03-09','10:10:00',8.36),('10318','2014-03-09','10:15:00',8.42),('10318','2014-03-09','10:20:00',8.38),('10318','2014-03-09','10:25:00',8.32),('10318','2014-03-09','10:30:00',8.5),('10318','2014-03-09','10:35:00',7.73),('10318','2014-03-09','10:40:00',8.74),('10318','2014-03-09','10:45:00',8.33),('10318','2014-03-09','10:50:00',9.2),('10318','2014-03-09','10:55:00',9.42),('10318','2014-03-09','11:00:00',9.79),('10318','2014-03-09','11:05:00',9.28),('10318','2014-03-09','11:10:00',9.29),('10318','2014-03-09','11:15:00',10.27),('10318','2014-03-09','11:20:00',10.47),('10318','2014-03-09','11:25:00',8.13),('10318','2014-03-09','11:30:00',2.96),('10318','2014-03-09','11:35:00',4.89),('10318','2014-03-09','11:40:00',3.79),('10318','2014-03-09','11:45:00',3.69),('10318','2014-03-09','11:50:00',6.74),('10318','2014-03-09','11:55:00',4.93),('10318','2014-03-09','12:00:00',7.13),('10318','2014-03-09','12:05:00',4.08),('10318','2014-03-09','12:10:00',9.83),('10318','2014-03-09','12:15:00',9.78),('10318','2014-03-09','12:20:00',9.91),('10318','2014-03-09','12:25:00',9.86),('10318','2014-03-09','12:30:00',8.28),('10318','2014-03-09','12:35:00',7.54),('10318','2014-03-09','12:40:00',8.63),('10318','2014-03-09','12:45:00',9.61),('10318','2014-03-09','12:50:00',9.44),('10318','2014-03-09','12:55:00',8.2),('10318','2014-03-09','13:00:00',9.54),('10318','2014-03-09','13:05:00',9.04),('10318','2014-03-09','13:10:00',4.9),('10318','2014-03-09','13:15:00',4.03),('10318','2014-03-09','13:20:00',5.06),('10318','2014-03-09','13:25:00',7.32),('10318','2014-03-09','13:30:00',7.71),('10318','2014-03-09','13:35:00',8.92),('10318','2014-03-09','13:40:00',8.67),('10318','2014-03-09','13:45:00',7.77),('10318','2014-03-09','13:50:00',8.53),('10318','2014-03-09','13:55:00',8.29),('10318','2014-03-09','14:00:00',4.02),('10318','2014-03-09','14:05:00',3.11),('10318','2014-03-09','14:10:00',7.76),('10318','2014-03-09','14:15:00',7.42),('10318','2014-03-09','14:20:00',7.39),('10318','2014-03-09','14:25:00',7.44),('10318','2014-03-09','14:30:00',7.11),('10318','2014-03-09','14:35:00',2.28),('10318','2014-03-09','14:40:00',1.58),('10318','2014-03-09','14:45:00',1.81),('10318','2014-03-09','14:50:00',2.85),('10318','2014-03-09','14:55:00',6.29),('10318','2014-03-09','15:00:00',5.98),('10318','2014-03-09','15:05:00',5.87),('10318','2014-03-09','15:10:00',5.66),('10318','2014-03-09','15:15:00',5.47),('10318','2014-03-09','15:20:00',5.17),('10318','2014-03-09','15:25:00',5.05),('10318','2014-03-09','15:30:00',4.86),('10318','2014-03-09','15:35:00',4.63),('10318','2014-03-09','15:40:00',4.35),('10318','2014-03-09','15:45:00',4.25),('10318','2014-03-09','15:50:00',3.13),('10318','2014-03-09','15:55:00',1.18),('10318','2014-03-09','16:00:00',1.26),('10318','2014-03-09','16:05:00',2.8),('10318','2014-03-09','16:10:00',1.89),('10318','2014-03-09','16:15:00',2.95),('10318','2014-03-09','16:20:00',2.81),('10318','2014-03-09','16:25:00',2.62),('10318','2014-03-09','16:30:00',2.43),('10318','2014-03-09','16:35:00',2.29),('10318','2014-03-09','16:40:00',2.19),('10318','2014-03-09','16:45:00',1.92),('10318','2014-03-09','16:50:00',1.69),('10318','2014-03-09','16:55:00',1.5),('10318','2014-03-09','17:00:00',1.34),('10318','2014-03-09','17:05:00',1.17),('10318','2014-03-08','07:15:00',1.01),('10318','2014-03-08','07:20:00',1.23),('10318','2014-03-08','07:25:00',1.4),('10318','2014-03-08','07:30:00',1.61),('10318','2014-03-08','07:35:00',1.82),('10318','2014-03-08','07:40:00',2.6),('10318','2014-03-08','07:45:00',3.27),('10318','2014-03-08','07:50:00',3.55),('10318','2014-03-08','07:55:00',3.78),('10318','2014-03-08','08:00:00',4.01),('10318','2014-03-08','08:05:00',4.23),('10318','2014-03-08','08:10:00',4.42),('10318','2014-03-08','08:15:00',4.63),('10318','2014-03-08','08:20:00',4.83),('10318','2014-03-08','08:25:00',5.02),('10318','2014-03-08','08:30:00',5.25),('10318','2014-03-08','08:35:00',5.44),('10318','2014-03-08','08:40:00',5.64),('10318','2014-03-08','08:45:00',5.83),('10318','2014-03-08','08:50:00',5.98),('10318','2014-03-08','08:55:00',6.15),('10318','2014-03-08','09:00:00',6.34),('10318','2014-03-08','09:05:00',6.51),('10318','2014-03-08','09:10:00',6.68),('10318','2014-03-08','09:15:00',6.84),('10318','2014-03-08','09:20:00',6.98),('10318','2014-03-08','09:25:00',7.1),('10318','2014-03-08','09:30:00',7.24),('10318','2014-03-08','09:35:00',7.37),('10318','2014-03-08','09:40:00',7.49),('10318','2014-03-08','09:45:00',7.57),('10318','2014-03-08','09:50:00',7.67),('10318','2014-03-08','09:55:00',7.79),('10318','2014-03-08','10:00:00',7.87),('10318','2014-03-08','10:05:00',7.95),('10318','2014-03-08','10:10:00',7.86),('10318','2014-03-08','10:15:00',8.15),('10318','2014-03-08','10:20:00',8.25),('10318','2014-03-08','10:25:00',8.36),('10318','2014-03-08','10:30:00',8.43),('10318','2014-03-08','10:35:00',8.49),('10318','2014-03-08','10:40:00',8.56),('10318','2014-03-08','10:45:00',8.63),('10318','2014-03-08','10:50:00',8.75),('10318','2014-03-08','10:55:00',8.78),('10318','2014-03-08','11:00:00',8.82),('10318','2014-03-08','11:05:00',8.9),('10318','2014-03-08','11:10:00',8.87),('10318','2014-03-08','11:15:00',9.04),('10318','2014-03-08','11:20:00',9.15),('10318','2014-03-08','11:25:00',8.85),('10318','2014-03-08','11:30:00',9.58),('10318','2014-03-08','11:35:00',10.04),('10318','2014-03-08','11:40:00',9.93),('10318','2014-03-08','11:45:00',8.09),('10318','2014-03-08','11:50:00',2.84),('10318','2014-03-08','11:55:00',2.71),('10318','2014-03-08','12:00:00',3.76),('10318','2014-03-08','12:05:00',4.76),('10318','2014-03-08','12:10:00',3.26),('10318','2014-03-08','12:15:00',3.08),('10318','2014-03-08','12:20:00',2.81),('10318','2014-03-08','12:25:00',3.15),('10318','2014-03-08','12:30:00',3.28),('10318','2014-03-08','12:35:00',3.61),('10318','2014-03-08','12:40:00',4.52),('10318','2014-03-08','12:45:00',3.82),('10318','2014-03-08','12:50:00',3.68),('10318','2014-03-08','12:55:00',4.15),('10318','2014-03-08','13:00:00',5.29),('10318','2014-03-08','13:05:00',4.2),('10318','2014-03-08','13:10:00',3.6),('10318','2014-03-08','13:15:00',2.99),('10318','2014-03-08','13:20:00',2.41),('10318','2014-03-08','13:25:00',2.26),('10318','2014-03-08','13:30:00',2.8),('10318','2014-03-08','13:35:00',6.41),('10318','2014-03-08','13:40:00',3.75),('10318','2014-03-08','13:45:00',5.95),('10318','2014-03-08','13:50:00',7.72),('10318','2014-03-08','13:55:00',3.6),('10318','2014-03-08','14:00:00',2.66),('10318','2014-03-08','14:05:00',2.48),('10318','2014-03-08','14:10:00',2.37),('10318','2014-03-08','14:15:00',1.95),('10318','2014-03-08','14:20:00',1.71),('10318','2014-03-08','14:25:00',1.66),('10318','2014-03-08','14:30:00',1.6),('10318','2014-03-08','14:35:00',1.84),('10318','2014-03-08','14:40:00',2.04),('10318','2014-03-08','14:45:00',2.1),('10318','2014-03-08','14:50:00',2.2),('10318','2014-03-08','14:55:00',2.38),('10318','2014-03-08','15:00:00',2.25),('10318','2014-03-08','15:05:00',1.9),('10318','2014-03-08','15:10:00',1.99),('10318','2014-03-08','15:15:00',2.25),('10318','2014-03-08','15:20:00',3.96),('10318','2014-03-08','15:25:00',2.87),('10318','2014-03-08','15:30:00',2.45),('10318','2014-03-08','15:35:00',2.4),('10318','2014-03-08','15:40:00',1.47),('10318','2014-03-08','15:45:00',1.37),('10318','2014-03-08','15:50:00',1.67),('10318','2014-03-08','15:55:00',1.75),('10318','2014-03-08','16:00:00',1.94),('10318','2014-03-08','16:05:00',1.69),('10318','2014-03-08','16:10:00',1.35),('10318','2014-03-08','16:15:00',1.24),('10318','2014-03-08','16:20:00',1.33),('10318','2014-03-08','16:25:00',1.18),('10318','2014-03-08','16:30:00',1.21),('10318','2014-03-08','16:35:00',2.51),('10318','2014-03-08','16:40:00',2.08),('10318','2014-03-08','16:45:00',1.96),('10318','2014-03-08','16:50:00',1.82),('10318','2014-03-08','16:55:00',1.52),('10318','2014-03-08','17:00:00',1.34),('10318','2014-03-08','17:05:00',1.19),('10318','2014-04-30','07:15:00',1.24),('10318','2014-04-30','07:20:00',1.71),('10318','2014-04-30','07:25:00',2.07),('10318','2014-04-30','07:30:00',2.34),('10318','2014-04-30','07:35:00',2.69),('10318','2014-04-30','07:40:00',2.95),('10318','2014-04-30','07:45:00',3.15),('10318','2014-04-30','07:50:00',3.42),('10318','2014-04-30','07:55:00',3.64),('10318','2014-04-30','08:00:00',3.86),('10318','2014-04-30','08:05:00',3.95),('10318','2014-04-30','08:10:00',4.26),('10318','2014-04-30','08:15:00',4.43),('10318','2014-04-30','08:20:00',4.7),('10318','2014-04-30','08:25:00',4.83),('10318','2014-04-30','08:30:00',5.06),('10318','2014-04-30','08:35:00',5.25),('10318','2014-04-30','08:40:00',5.38),('10318','2014-04-30','08:45:00',5.59),('10318','2014-04-30','08:50:00',5.91),('10318','2014-04-30','08:55:00',5.88),('10318','2014-04-30','09:00:00',6.37),('10318','2014-04-30','09:05:00',5.45),('10318','2014-04-30','09:10:00',6.48),('10318','2014-04-30','09:15:00',5.71),('10318','2014-04-30','09:20:00',4.34),('10318','2014-04-30','09:25:00',7.05),('10318','2014-04-30','09:30:00',7.52),('10318','2014-04-30','09:35:00',7.72),('10318','2014-04-30','09:40:00',8.07),('10318','2014-04-30','09:45:00',5.83),('10318','2014-04-30','09:50:00',5.5),('10318','2014-04-30','09:55:00',8.79),('10318','2014-04-30','10:00:00',8.87),('10318','2014-04-30','10:05:00',6.5),('10318','2014-04-30','10:10:00',3.32),('10318','2014-04-30','10:15:00',4.08),('10318','2014-04-30','10:20:00',4.31),('10318','2014-04-30','10:25:00',4.36),('10318','2014-04-30','10:30:00',5.07),('10318','2014-04-30','10:35:00',4.57),('10318','2014-04-30','10:40:00',3.62),('10318','2014-04-30','10:45:00',4.3),('10318','2014-04-30','10:50:00',6.93),('10318','2014-04-30','10:55:00',4.28),('10318','2014-04-30','11:00:00',4.93),('10318','2014-04-30','11:05:00',5.24),('10318','2014-04-30','11:10:00',8.15),('10318','2014-04-30','11:15:00',9.34),('10318','2014-04-30','11:20:00',6.12),('10318','2014-04-30','11:25:00',4.31),('10318','2014-04-30','11:30:00',5.89),('10318','2014-04-30','11:35:00',7.1),('10318','2014-04-30','11:40:00',5.68),('10318','2014-04-30','11:45:00',6.35),('10318','2014-04-30','11:50:00',5.12),('10318','2014-04-30','11:55:00',5.9),('10318','2014-04-30','12:00:00',5.1),('10318','2014-04-30','12:05:00',7.36),('10318','2014-04-30','12:10:00',5.24),('10318','2014-04-30','12:15:00',2.96),('10318','2014-04-30','12:20:00',2.75),('10318','2014-04-30','12:25:00',3.31),('10318','2014-04-30','12:30:00',2.54),('10318','2014-04-30','12:35:00',2.16),('10318','2014-04-30','12:40:00',7.32),('10318','2014-04-30','12:45:00',10.86),('10318','2014-04-30','12:50:00',7.25),('10318','2014-04-30','12:55:00',8.31),('10318','2014-04-30','13:00:00',9.81),('10318','2014-04-30','13:05:00',7.83),('10318','2014-04-30','13:10:00',3.16),('10318','2014-04-30','13:15:00',4.26),('10318','2014-04-30','13:20:00',7.18),('10318','2014-04-30','13:25:00',3.62),('10318','2014-04-30','13:30:00',4),('10318','2014-04-30','13:35:00',9.82),('10318','2014-04-30','13:40:00',9.02),('10318','2014-04-30','13:45:00',7.54),('10318','2014-04-30','13:50:00',7.99),('10318','2014-04-30','13:55:00',4.89),('10318','2014-04-30','14:00:00',4.04),('10318','2014-04-30','14:05:00',3.8),('10318','2014-04-30','14:10:00',3.97),('10318','2014-04-30','14:15:00',7.86),('10318','2014-04-30','14:20:00',7.78),('10318','2014-04-30','14:25:00',8.78),('10318','2014-04-30','14:30:00',7.44),('10318','2014-04-30','14:35:00',5.3),('10318','2014-04-30','14:40:00',3.15),('10318','2014-04-30','14:45:00',3.26),('10318','2014-04-30','14:50:00',3.85),('10318','2014-04-30','14:55:00',3.82),('10318','2014-04-30','15:00:00',3.4),('10318','2014-04-30','15:05:00',3.99),('10318','2014-04-30','15:10:00',3.66),('10318','2014-04-30','15:15:00',2.96),('10318','2014-04-30','15:20:00',4.04),('10318','2014-04-30','15:25:00',3.56),('10318','2014-04-30','15:30:00',5.55),('10318','2014-04-30','15:35:00',4.29),('10318','2014-04-30','15:40:00',3.16),('10318','2014-04-30','15:45:00',3.27),('10318','2014-04-30','15:50:00',3.64),('10318','2014-04-30','15:55:00',6.37),('10318','2014-04-30','16:00:00',3.58),('10318','2014-04-30','16:05:00',3.67),('10318','2014-04-30','16:10:00',4.49),('10318','2014-04-30','16:15:00',5.21),('10318','2014-04-30','16:20:00',7.53),('10318','2014-04-30','16:25:00',3.33),('10318','2014-04-30','16:30:00',3.27),('10318','2014-04-30','16:35:00',5.47),('10318','2014-04-30','16:40:00',6.89),('10318','2014-04-30','16:45:00',2.5),('10318','2014-04-30','16:50:00',4.11),('10318','2014-04-30','16:55:00',2.79),('10318','2014-04-30','17:00:00',5.35),('10318','2014-04-30','17:05:00',4.99),('10318','2014-04-30','17:10:00',2.91),('10318','2014-04-30','17:15:00',2.04),('10318','2014-04-30','17:20:00',3.56),('10318','2014-04-30','17:25:00',1.4),('10318','2014-04-30','17:30:00',1.5),('10318','2014-04-30','17:35:00',2.21),('10318','2014-04-30','17:40:00',2.51),('10318','2014-04-30','17:45:00',1.91),('10318','2014-04-30','17:50:00',1.36),('10318','2014-04-30','17:55:00',1.31),('10318','2014-04-30','18:00:00',1.26),('10318','2014-04-30','18:05:00',1.01),('10318','2014-04-30','18:25:00',1.01),('10318','2014-04-30','18:30:00',1.11),('10318','2014-04-30','18:35:00',1.17),('10318','2014-04-30','18:40:00',1.16),('10318','2014-04-30','18:45:00',1.26),('10318','2014-04-30','18:50:00',1.09),('10318','2014-03-07','09:30:00',1.04),('10318','2014-03-07','09:35:00',1.37),('10318','2014-03-07','09:40:00',1.5),('10318','2014-03-07','09:45:00',1.4),('10318','2014-03-07','09:50:00',1.12),('10318','2014-03-07','09:55:00',1.27),('10318','2014-03-07','10:00:00',2.13),('10318','2014-03-07','10:05:00',1.49),('10318','2014-03-07','10:10:00',1.58),('10318','2014-03-07','10:15:00',1.56),('10318','2014-03-07','10:20:00',2.13),('10318','2014-03-07','10:25:00',2.86),('10318','2014-03-07','10:30:00',3.46),('10318','2014-03-07','10:35:00',2.48),('10318','2014-03-07','10:40:00',2.06),('10318','2014-03-07','10:45:00',2.05),('10318','2014-03-07','10:50:00',2.15),('10318','2014-03-07','10:55:00',2.62),('10318','2014-03-07','11:00:00',3.75),('10318','2014-03-07','11:05:00',2.5),('10318','2014-03-07','11:10:00',2.01),('10318','2014-03-07','11:15:00',2.37),('10318','2014-03-07','11:20:00',3.91),('10318','2014-03-07','11:25:00',5.9),('10318','2014-03-07','11:30:00',3.52),('10318','2014-03-07','11:35:00',4.86),('10318','2014-03-07','11:40:00',2.63),('10318','2014-03-07','11:45:00',3.19),('10318','2014-03-07','11:50:00',7.57),('10318','2014-03-07','11:55:00',10.3),('10318','2014-03-07','12:00:00',5.46),('10318','2014-03-07','12:05:00',9.78),('10318','2014-03-07','12:10:00',9.81),('10318','2014-03-07','12:15:00',9.61),('10318','2014-03-07','12:20:00',9.55),('10318','2014-03-07','12:25:00',9.43),('10318','2014-03-07','12:30:00',4.84),('10318','2014-03-07','12:35:00',3.62),('10318','2014-03-07','12:40:00',3.39),('10318','2014-03-07','12:45:00',4.54),('10318','2014-03-07','12:50:00',4.67),('10318','2014-03-07','12:55:00',2.5),('10318','2014-03-07','13:00:00',1.86),('10318','2014-03-07','13:05:00',2.89),('10318','2014-03-07','13:10:00',4.44),('10318','2014-03-07','13:15:00',2.91),('10318','2014-03-07','13:20:00',5.58),('10318','2014-03-07','13:25:00',5.65),('10318','2014-03-07','13:30:00',3.79),('10318','2014-03-07','13:35:00',3.55),('10318','2014-03-07','13:40:00',3.43),('10318','2014-03-07','13:45:00',3.59),('10318','2014-03-07','13:50:00',3.39),('10318','2014-03-07','13:55:00',3.1),('10318','2014-03-07','14:00:00',2.89),('10318','2014-03-07','14:05:00',2.7),('10318','2014-03-07','14:10:00',2.59),('10318','2014-03-07','14:15:00',2.56),('10318','2014-03-07','14:20:00',2.6),('10318','2014-03-07','14:25:00',2.6),('10318','2014-03-07','14:30:00',2.7),('10318','2014-03-07','14:35:00',2.92),('10318','2014-03-07','14:40:00',3.12),('10318','2014-03-07','14:45:00',3.54),('10318','2014-03-07','14:50:00',4.6),('10318','2014-03-07','15:00:00',6.46),('10318','2014-03-07','15:05:00',6.5),('10318','2014-03-07','15:10:00',6.63),('10318','2014-03-07','15:15:00',6.22),('10318','2014-03-07','15:20:00',6.16),('10318','2014-03-07','15:25:00',5.86),('10318','2014-03-07','15:30:00',5.6),('10318','2014-03-07','15:35:00',5.46),('10318','2014-03-07','15:40:00',5.09),('10318','2014-03-07','15:45:00',4.75),('10318','2014-03-07','15:50:00',4.03),('10318','2014-03-07','15:55:00',4.11),('10318','2014-03-07','16:00:00',3.89),('10318','2014-03-07','16:05:00',3.49),('10318','2014-03-07','16:10:00',3.16),('10318','2014-03-07','16:15:00',3.29),('10318','2014-03-07','16:20:00',3.04),('10318','2014-03-07','16:25:00',2.85),('10318','2014-03-07','16:30:00',2.63),('10318','2014-03-07','16:35:00',2.56),('10318','2014-03-07','16:40:00',2.6),('10318','2014-03-07','16:45:00',2.47),('10318','2014-03-07','16:50:00',2.28),('10318','2014-03-07','16:55:00',2.14),('10318','2014-03-07','17:00:00',1.97),('10318','2014-03-07','17:05:00',1.79),('10318','2014-03-07','17:10:00',1.57),('10318','2014-03-07','17:15:00',1.35),('10318','2014-03-07','17:20:00',1.07),('10318','2014-03-06','07:55:00',1.4),('10318','2014-03-06','08:00:00',2.38),('10318','2014-03-06','08:05:00',3.17),('10318','2014-03-06','08:10:00',3.11),('10318','2014-03-06','08:15:00',5.43),('10318','2014-03-06','08:20:00',4.24),('10318','2014-03-06','08:25:00',3.68),('10318','2014-03-06','08:30:00',3.88),('10318','2014-03-06','08:35:00',2.28),('10318','2014-03-06','08:40:00',1.77),('10318','2014-03-06','08:45:00',1.74),('10318','2014-03-06','08:50:00',1.81),('10318','2014-03-06','08:55:00',2.49),('10318','2014-03-06','09:00:00',2.36),('10318','2014-03-06','09:05:00',2.36),('10318','2014-03-06','09:10:00',2.38),('10318','2014-03-06','09:15:00',2.66),('10318','2014-03-06','09:20:00',4.91),('10318','2014-03-06','09:25:00',4.2),('10318','2014-03-06','09:30:00',3.99),('10318','2014-03-06','09:35:00',4.44),('10318','2014-03-06','09:40:00',4.72),('10318','2014-03-06','09:45:00',5.35),('10318','2014-03-06','09:50:00',6.19),('10318','2014-03-06','09:55:00',5.67),('10318','2014-03-06','10:00:00',5.48),('10318','2014-03-06','10:05:00',6.36),('10318','2014-03-06','10:10:00',7.36),('10318','2014-03-06','10:15:00',8.3),('10318','2014-03-06','10:20:00',7.93),('10318','2014-03-06','10:25:00',7.76),('10318','2014-03-06','10:30:00',8.19),('10318','2014-03-06','10:35:00',8.05),('10318','2014-03-06','10:40:00',8.88),('10318','2014-03-06','10:45:00',8.35),('10318','2014-03-06','10:50:00',8.93),('10318','2014-03-06','10:55:00',7.83),('10318','2014-03-06','11:00:00',8.32),('10318','2014-03-06','11:05:00',6.71),('10318','2014-03-06','11:10:00',7.61),('10318','2014-03-06','11:15:00',8.82),('10318','2014-03-06','11:20:00',6.12),('10318','2014-03-06','11:25:00',3.38),('10318','2014-03-06','11:30:00',3.12),('10318','2014-03-06','11:35:00',3.44),('10318','2014-03-06','11:40:00',3.05),('10318','2014-03-06','11:45:00',2.97),('10318','2014-03-06','11:50:00',2.85),('10318','2014-03-06','11:55:00',3.47),('10318','2014-03-06','12:00:00',3.46),('10318','2014-03-06','12:05:00',6.09),('10318','2014-03-06','12:10:00',6.44),('10318','2014-03-06','12:15:00',5.68),('10318','2014-03-06','12:20:00',2.95),('10318','2014-03-06','12:25:00',2.65),('10318','2014-03-06','12:30:00',3.31),('10318','2014-03-06','12:35:00',3.32),('10318','2014-03-06','12:40:00',2.57),('10318','2014-03-06','12:45:00',2.37),('10318','2014-03-06','12:50:00',2.66),('10318','2014-03-06','12:55:00',3.79),('10318','2014-03-06','13:00:00',3.52),('10318','2014-03-06','13:05:00',3.82),('10318','2014-03-06','13:10:00',2.98),('10318','2014-03-06','13:15:00',2.78),('10318','2014-03-06','13:20:00',2.68),('10318','2014-03-06','13:25:00',2.39),('10318','2014-03-06','13:30:00',2.32),('10318','2014-03-06','13:35:00',2.2),('10318','2014-03-06','13:40:00',2.28),('10318','2014-03-06','13:45:00',2.36),('10318','2014-03-06','13:50:00',2.24),('10318','2014-03-06','13:55:00',2.09),('10318','2014-03-06','14:00:00',2.11),('10318','2014-03-06','14:05:00',2.42),('10318','2014-03-06','14:10:00',2.71),('10318','2014-03-06','14:15:00',2.73),('10318','2014-03-06','14:20:00',2.8),('10318','2014-03-06','14:25:00',2.57),('10318','2014-03-06','14:30:00',2.42),('10318','2014-03-06','14:35:00',2.67),('10318','2014-03-06','14:40:00',2.37),('10318','2014-03-06','14:45:00',1.86),('10318','2014-03-06','14:50:00',1.84),('10318','2014-03-06','14:55:00',2.08),('10318','2014-03-06','15:00:00',2.37),('10318','2014-03-06','15:05:00',2.61),('10318','2014-03-06','15:10:00',3.18),('10318','2014-03-06','15:15:00',2.37),('10318','2014-03-06','15:20:00',1.84),('10318','2014-03-06','15:25:00',2.02),('10318','2014-03-06','15:30:00',1.65),('10318','2014-03-06','15:35:00',1.87),('10318','2014-03-06','15:40:00',1.81),('10318','2014-03-06','15:45:00',1.2),('10318','2014-03-06','15:55:00',1.04),('10318','2014-03-06','16:00:00',1.37),('10318','2014-03-06','16:05:00',1.68),('10318','2014-03-06','16:10:00',1.41),('10318','2014-03-06','16:15:00',1.41),('10318','2014-03-06','16:20:00',1.52),('10318','2014-03-06','16:25:00',1.44),('10318','2014-03-06','16:30:00',1.33),('10318','2014-03-06','16:35:00',1.15),('10318','2014-03-06','16:45:00',1.02),('10318','2014-03-06','16:50:00',1.04),('10318','2014-03-06','16:55:00',1.06),('10318','2014-03-06','17:05:00',1.24),('10318','2014-03-06','17:10:00',1.32),('10318','2014-03-06','17:15:00',1.12),('10318','2014-03-05','07:15:00',1.26),('10318','2014-03-05','07:20:00',1.36),('10318','2014-03-05','07:25:00',1.58),('10318','2014-03-05','07:30:00',1.89),('10318','2014-03-05','07:35:00',2.33),('10318','2014-03-05','07:40:00',2.63),('10318','2014-03-05','07:45:00',3.37),('10318','2014-03-05','07:50:00',4.19),('10318','2014-03-05','07:55:00',4.37),('10318','2014-03-05','08:00:00',4.55),('10318','2014-03-05','08:05:00',4.72),('10318','2014-03-05','08:10:00',4.96),('10318','2014-03-05','08:15:00',5.3),('10318','2014-03-05','08:20:00',5.66),('10318','2014-03-05','08:25:00',3.81),('10318','2014-03-05','08:30:00',2.29),('10318','2014-03-05','08:35:00',5.58),('10318','2014-03-05','08:40:00',6.82),('10318','2014-03-05','08:45:00',6.56),('10318','2014-03-05','08:50:00',6.05),('10318','2014-03-05','08:55:00',4.27),('10318','2014-03-05','09:00:00',2.42),('10318','2014-03-05','09:05:00',3.86),('10318','2014-03-05','09:10:00',6.61),('10318','2014-03-05','09:15:00',7.14),('10318','2014-03-05','09:20:00',7.04),('10318','2014-03-05','09:25:00',7.32),('10318','2014-03-05','09:30:00',7.29),('10318','2014-03-05','09:35:00',7.55),('10318','2014-03-05','09:40:00',7.71),('10318','2014-03-05','09:45:00',7.82),('10318','2014-03-05','09:50:00',7.88),('10318','2014-03-05','09:55:00',7.99),('10318','2014-03-05','10:00:00',8.07),('10318','2014-03-05','10:05:00',8.17),('10318','2014-03-05','10:10:00',8.28),('10318','2014-03-05','10:15:00',8.37),('10318','2014-03-05','10:20:00',8.44),('10318','2014-03-05','10:25:00',8.5),('10318','2014-03-05','10:30:00',8.6),('10318','2014-03-05','10:35:00',8.64),('10318','2014-03-05','10:40:00',8.68),('10318','2014-03-05','10:45:00',8.54),('10318','2014-03-05','10:50:00',8.71),('10318','2014-03-05','10:55:00',8.73),('10318','2014-03-05','11:00:00',8.82),('10318','2014-03-05','11:05:00',8.96),('10318','2014-03-05','11:10:00',9.09),('10318','2014-03-05','11:15:00',9.14),('10318','2014-03-05','11:20:00',9.66),('10318','2014-03-05','11:25:00',9.91),('10318','2014-03-05','11:30:00',9.81),('10318','2014-03-05','11:35:00',9.8),('10318','2014-03-05','11:40:00',9.7),('10318','2014-03-05','11:45:00',9.52),('10318','2014-03-05','11:50:00',9.54),('10318','2014-03-05','11:55:00',8.72),('10318','2014-03-05','12:00:00',6.78),('10318','2014-03-05','12:05:00',5.97),('10318','2014-03-05','12:10:00',9.12),('10318','2014-03-05','12:15:00',6.69),('10318','2014-03-05','12:20:00',7.64),('10318','2014-03-05','12:25:00',5.21),('10318','2014-03-05','12:30:00',3.49),('10318','2014-03-05','12:35:00',4.8),('10318','2014-03-05','12:40:00',6.24),('10318','2014-03-05','12:45:00',2.82),('10318','2014-03-05','12:50:00',3.16),('10318','2014-03-05','12:55:00',2.09),('10318','2014-03-05','13:00:00',5.89),('10318','2014-03-05','13:05:00',4.53),('10318','2014-03-05','13:10:00',7.63),('10318','2014-03-05','13:15:00',8.17),('10318','2014-03-05','13:20:00',5),('10318','2014-03-05','13:25:00',6.15),('10318','2014-03-05','13:30:00',4.7),('10318','2014-03-05','13:35:00',2.98),('10318','2014-03-05','13:40:00',4.12),('10318','2014-03-05','13:45:00',4.8),('10318','2014-03-05','13:50:00',3.25),('10318','2014-03-05','13:55:00',2.87),('10318','2014-03-05','14:00:00',2.67),('10318','2014-03-05','14:05:00',3.12),('10318','2014-03-05','14:10:00',2.95),('10318','2014-03-05','14:15:00',2.76),('10318','2014-03-05','14:20:00',3.13),('10318','2014-03-05','14:25:00',4.09),('10318','2014-03-05','14:30:00',4.9),('10318','2014-03-05','14:35:00',3.36),('10318','2014-03-05','14:40:00',7.1),('10318','2014-03-05','14:45:00',7.56),('10318','2014-03-05','14:50:00',6.98),('10318','2014-03-05','14:55:00',4.34),('10318','2014-03-05','15:00:00',2.67),('10318','2014-03-05','15:05:00',1.84),('10318','2014-03-05','15:10:00',1.68),('10318','2014-03-05','15:15:00',1.62),('10318','2014-03-05','15:20:00',1.6),('10318','2014-03-05','15:25:00',1.79),('10318','2014-03-05','15:30:00',2.09),('10318','2014-03-05','15:35:00',2.42),('10318','2014-03-05','15:40:00',3.25),('10318','2014-03-05','15:45:00',4.07),('10318','2014-03-05','15:50:00',4.1),('10318','2014-03-05','15:55:00',3.95),('10318','2014-03-05','16:00:00',5.09),('10318','2014-03-05','16:05:00',5.12),('10318','2014-03-05','16:10:00',4.42),('10318','2014-03-05','16:15:00',3.06),('10318','2014-03-05','16:20:00',1.19),('10318','2014-03-04','08:40:00',1.33),('10318','2014-03-04','08:45:00',1.39),('10318','2014-03-04','09:00:00',1.93),('10318','2014-03-04','09:05:00',1.94),('10318','2014-03-04','09:10:00',5.84),('10318','2014-03-04','09:15:00',4.47),('10318','2014-03-04','09:20:00',2.41),('10318','2014-03-04','09:25:00',1.89),('10318','2014-03-04','09:30:00',1.86),('10318','2014-03-04','09:35:00',1.69),('10318','2014-03-04','09:40:00',1.75),('10318','2014-03-04','09:45:00',1.26),('10318','2014-03-04','09:50:00',2.03),('10318','2014-03-04','09:55:00',4.35),('10318','2014-03-04','10:00:00',3.13),('10318','2014-03-04','10:05:00',2.39),('10318','2014-03-04','10:10:00',1.59),('10318','2014-03-04','10:15:00',1.27),('10318','2014-03-04','10:20:00',3.25),('10318','2014-03-04','10:25:00',3.21),('10318','2014-03-04','10:30:00',5.95),('10318','2014-03-04','10:35:00',10.2),('10318','2014-03-04','10:40:00',9.33),('10318','2014-03-04','10:45:00',10.74),('10318','2014-03-04','10:50:00',10.01),('10318','2014-03-04','10:55:00',10.15),('10318','2014-03-04','11:00:00',9.93),('10318','2014-03-04','11:05:00',10.44),('10318','2014-03-04','11:10:00',9.52),('10318','2014-03-04','11:15:00',7.92),('10318','2014-03-04','11:25:00',2.34),('10318','2014-03-04','11:30:00',2.64),('10318','2014-03-04','11:35:00',1.97),('10318','2014-03-04','11:40:00',2),('10318','2014-03-04','11:45:00',3.57),('10318','2014-03-04','11:50:00',9.28),('10318','2014-03-04','11:55:00',9.89),('10318','2014-03-04','12:00:00',9.52),('10318','2014-03-04','12:05:00',9.38),('10318','2014-03-04','12:10:00',9.24),('10318','2014-03-04','12:15:00',9.3),('10318','2014-03-04','12:20:00',8.39),('10318','2014-03-04','12:25:00',8.19),('10318','2014-03-04','12:30:00',8.95),('10318','2014-03-04','12:35:00',8.68),('10318','2014-03-04','12:40:00',9.05),('10318','2014-03-04','12:45:00',8.99),('10318','2014-03-04','12:50:00',8.69),('10318','2014-03-04','12:55:00',8.89),('10318','2014-03-04','13:00:00',8.27),('10318','2014-03-04','13:05:00',7.81),('10318','2014-03-04','13:10:00',6.8),('10318','2014-03-04','13:15:00',3.87),('10318','2014-03-04','13:20:00',7.5),('10318','2014-03-04','13:25:00',7.42),('10318','2014-03-04','13:30:00',4.35),('10318','2014-03-04','13:35:00',1.77),('10318','2014-03-04','13:40:00',2.92),('10318','2014-03-04','13:45:00',5.1),('10318','2014-03-04','13:50:00',2.35),('10318','2014-03-04','13:55:00',2.31),('10318','2014-03-04','14:00:00',3.59),('10318','2014-03-04','14:05:00',8),('10318','2014-03-04','14:10:00',8.07),('10318','2014-03-04','14:15:00',2.64),('10318','2014-03-04','14:20:00',8.02),('10318','2014-03-04','14:25:00',7.61),('10318','2014-03-04','14:30:00',6.97),('10318','2014-03-04','14:35:00',6.7),('10318','2014-03-04','14:40:00',6),('10318','2014-03-04','14:45:00',4.92),('10318','2014-03-04','14:50:00',6.07),('10318','2014-03-04','14:55:00',5.23),('10318','2014-03-04','15:00:00',4.49),('10318','2014-03-04','15:05:00',5.87),('10318','2014-03-04','15:10:00',5.05),('10318','2014-03-04','15:15:00',4.8),('10318','2014-03-04','15:20:00',5.15),('10318','2014-03-04','15:25:00',4.34),('10318','2014-03-04','15:30:00',5.35),('10318','2014-03-04','15:35:00',4.87),('10318','2014-03-04','15:40:00',4.58),('10318','2014-03-04','15:45:00',3.52),('10318','2014-03-04','15:50:00',4.27),('10318','2014-03-04','15:55:00',1.32),('10318','2014-03-04','16:00:00',1.61),('10318','2014-03-04','16:05:00',2.19),('10318','2014-03-04','16:10:00',1.65),('10318','2014-03-04','16:15:00',1.65),('10318','2014-03-04','16:20:00',2.06),('10318','2014-03-04','16:25:00',2.52),('10318','2014-03-04','16:30:00',2.04),('10318','2014-03-04','16:35:00',1.89),('10318','2014-03-04','16:40:00',2.07),('10318','2014-03-04','16:45:00',2.04),('10318','2014-03-04','16:50:00',1.73),('10318','2014-03-04','16:55:00',1.45),('10318','2014-03-04','17:00:00',1.05),('10318','2014-03-03','07:20:00',1.03),('10318','2014-03-03','07:25:00',1.29),('10318','2014-03-03','07:30:00',1.51),('10318','2014-03-03','07:35:00',1.71),('10318','2014-03-03','07:40:00',1.89),('10318','2014-03-03','07:45:00',2.04),('10318','2014-03-03','07:50:00',3.23),('10318','2014-03-03','07:55:00',3.19),('10318','2014-03-03','08:00:00',3.28),('10318','2014-03-03','08:05:00',3.79),('10318','2014-03-03','08:10:00',4.48),('10318','2014-03-03','08:15:00',4.69),('10318','2014-03-03','08:20:00',4.89),('10318','2014-03-03','08:25:00',5.07),('10318','2014-03-03','08:30:00',5.27),('10318','2014-03-03','08:35:00',5.4),('10318','2014-03-03','08:40:00',5.69),('10318','2014-03-03','08:45:00',5.86),('10318','2014-03-03','08:50:00',5.89),('10318','2014-03-03','08:55:00',6.04),('10318','2014-03-03','09:00:00',5.57),('10318','2014-03-03','09:05:00',4.86),('10318','2014-03-03','09:10:00',5.26),('10318','2014-03-03','09:15:00',6.72),('10318','2014-03-03','09:20:00',6.87),('10318','2014-03-03','09:25:00',7.18),('10318','2014-03-03','09:30:00',6.82),('10318','2014-03-03','09:35:00',6.84),('10318','2014-03-03','09:40:00',6.43),('10318','2014-03-03','09:45:00',7.06),('10318','2014-03-03','09:50:00',7.33),('10318','2014-03-03','09:55:00',6.98),('10318','2014-03-03','10:00:00',7.9),('10318','2014-03-03','10:05:00',7.92),('10318','2014-03-03','10:10:00',8.05),('10318','2014-03-03','10:15:00',8.12),('10318','2014-03-03','10:20:00',7.95),('10318','2014-03-03','10:25:00',8.24),('10318','2014-03-03','10:30:00',8.29),('10318','2014-03-03','10:35:00',8.33),('10318','2014-03-03','10:40:00',8.36),('10318','2014-03-03','10:45:00',8.46),('10318','2014-03-03','10:50:00',8.62),('10318','2014-03-03','10:55:00',8.63),('10318','2014-03-03','11:00:00',8.64),('10318','2014-03-03','11:05:00',8.67),('10318','2014-03-03','11:10:00',8.69),('10318','2014-03-03','11:15:00',8.74),('10318','2014-03-03','11:20:00',8.77),('10318','2014-03-03','11:25:00',8.9),('10318','2014-03-03','11:30:00',8.95),('10318','2014-03-03','11:35:00',8.94),('10318','2014-03-03','11:40:00',8.88),('10318','2014-03-03','11:45:00',8.91),('10318','2014-03-03','11:50:00',8.96),('10318','2014-03-03','11:55:00',8.97),('10318','2014-03-03','12:00:00',8.96),('10318','2014-03-03','12:05:00',8.92),('10318','2014-03-03','12:10:00',8.92),('10318','2014-03-03','12:15:00',8.92),('10318','2014-03-03','12:20:00',8.89),('10318','2014-03-03','12:25:00',8.84),('10318','2014-03-03','12:30:00',8.81),('10318','2014-03-03','12:35:00',8.81),('10318','2014-03-03','12:40:00',8.78),('10318','2014-03-03','12:45:00',8.73),('10318','2014-03-03','12:50:00',8.68),('10318','2014-03-03','12:55:00',8.66),('10318','2014-03-03','13:00:00',8.59),('10318','2014-03-03','13:05:00',8.48),('10318','2014-03-03','13:10:00',8.43),('10318','2014-03-03','13:15:00',8.34),('10318','2014-03-03','13:20:00',8.21),('10318','2014-03-03','13:25:00',8.2),('10318','2014-03-03','13:30:00',8.09),('10318','2014-03-03','13:35:00',7.65),('10318','2014-03-03','13:40:00',7.89),('10318','2014-03-03','13:45:00',7.85),('10318','2014-03-03','13:50:00',6.47),('10318','2014-03-03','13:55:00',6.45),('10318','2014-03-03','14:00:00',7.64),('10318','2014-03-03','14:05:00',7.64),('10318','2014-03-03','14:10:00',6.96),('10318','2014-03-03','14:15:00',7.21),('10318','2014-03-03','14:20:00',5.36),('10318','2014-03-03','14:25:00',7.04),('10318','2014-03-03','14:30:00',6.58),('10318','2014-03-03','14:35:00',6.64),('10318','2014-03-03','14:40:00',6.36),('10318','2014-03-03','14:45:00',6.2),('10318','2014-03-03','14:50:00',6.03),('10318','2014-03-03','14:55:00',5.76),('10318','2014-03-03','15:00:00',5.72),('10318','2014-03-03','15:05:00',5.39),('10318','2014-03-03','15:10:00',5.3),('10318','2014-03-03','15:15:00',5.25),('10318','2014-03-03','15:20:00',5.13),('10318','2014-03-03','15:25:00',3.93),('10318','2014-03-03','15:30:00',4.72),('10318','2014-03-03','15:35:00',4.48),('10318','2014-03-03','15:40:00',4.23),('10318','2014-03-03','15:45:00',3.87),('10318','2014-03-03','15:50:00',3.83),('10318','2014-03-03','15:55:00',3.63),('10318','2014-03-03','16:00:00',3.43),('10318','2014-03-03','16:05:00',3.26),('10318','2014-03-03','16:10:00',3.12),('10318','2014-03-03','16:15:00',2.95),('10318','2014-03-03','16:20:00',2.78),('10318','2014-03-03','16:25:00',2.61),('10318','2014-03-03','16:30:00',2.43),('10318','2014-03-03','16:35:00',2.23),('10318','2014-03-03','16:40:00',2.01),('10318','2014-03-03','16:45:00',1.81),('10318','2014-03-03','16:50:00',1.57),('10318','2014-03-03','16:55:00',1.24),('10318','2014-03-03','17:00:00',1.28),('10318','2014-03-03','17:05:00',1.11),('10318','2014-03-02','07:45:00',1.02),('10318','2014-03-02','07:50:00',1.94),('10318','2014-03-02','07:55:00',3.36),('10318','2014-03-02','08:00:00',3.06),('10318','2014-03-02','08:05:00',1.35),('10318','2014-03-02','08:10:00',2.69),('10318','2014-03-02','08:15:00',3.16),('10318','2014-03-02','08:20:00',3.24),('10318','2014-03-02','08:25:00',5.73),('10318','2014-03-02','08:30:00',5.4),('10318','2014-03-02','08:35:00',5.44),('10318','2014-03-02','08:40:00',5.72),('10318','2014-03-02','08:45:00',5.91),('10318','2014-03-02','08:50:00',6.13),('10318','2014-03-02','08:55:00',6.3),('10318','2014-03-02','09:00:00',6.47),('10318','2014-03-02','09:05:00',6.7),('10318','2014-03-02','09:10:00',7.01),('10318','2014-03-02','09:15:00',5.79),('10318','2014-03-02','09:20:00',6.13),('10318','2014-03-02','09:25:00',7.69),('10318','2014-03-02','09:30:00',5.95),('10318','2014-03-02','09:35:00',7.34),('10318','2014-03-02','09:40:00',5.01),('10318','2014-03-02','09:45:00',1.04),('10318','2014-03-02','09:50:00',1.39),('10318','2014-03-02','09:55:00',3.36),('10318','2014-03-02','10:00:00',4.65),('10318','2014-03-02','10:05:00',2.58),('10318','2014-03-02','10:10:00',2.71),('10318','2014-03-02','10:15:00',3.43),('10318','2014-03-02','10:20:00',4.96),('10318','2014-03-02','10:25:00',6.02),('10318','2014-03-02','10:30:00',5.12),('10318','2014-03-02','10:35:00',9.17),('10318','2014-03-02','10:40:00',9.13),('10318','2014-03-02','10:45:00',9.22),('10318','2014-03-02','10:50:00',9.48),('10318','2014-03-02','10:55:00',8.78),('10318','2014-03-02','11:00:00',10.21),('10318','2014-03-02','11:05:00',5.24),('10318','2014-03-02','11:10:00',3.6),('10318','2014-03-02','11:15:00',4.03),('10318','2014-03-02','11:20:00',5.07),('10318','2014-03-02','11:25:00',6.51),('10318','2014-03-02','11:30:00',10.55),('10318','2014-03-02','11:35:00',7.93),('10318','2014-03-02','11:40:00',10.22),('10318','2014-03-02','11:45:00',9.99),('10318','2014-03-02','11:50:00',10.21),('10318','2014-03-02','11:55:00',9.98),('10318','2014-03-02','12:00:00',8.72),('10318','2014-03-02','12:05:00',5.22),('10318','2014-03-02','12:10:00',4),('10318','2014-03-02','12:15:00',5.24),('10318','2014-03-02','12:20:00',4.08),('10318','2014-03-02','12:25:00',3.44),('10318','2014-03-02','12:30:00',2.87),('10318','2014-03-02','12:35:00',2.2),('10318','2014-03-02','12:40:00',1.54),('10318','2014-03-02','12:45:00',1.29),('10318','2014-03-02','12:50:00',1.16),('10318','2014-03-02','12:55:00',1.21),('10318','2014-03-02','13:00:00',1.69),('10318','2014-03-02','13:05:00',2.57),('10318','2014-03-02','13:10:00',2.87),('10318','2014-03-02','13:15:00',2.58),('10318','2014-03-02','13:20:00',2.37),('10318','2014-03-02','13:25:00',2.08),('10318','2014-03-02','13:30:00',2.31),('10318','2014-03-02','13:35:00',2.38),('10318','2014-03-02','13:40:00',2.19),('10318','2014-03-02','13:45:00',1.99),('10318','2014-03-02','13:50:00',2.15),('10318','2014-03-02','13:55:00',2.36),('10318','2014-03-02','14:00:00',2.56),('10318','2014-03-02','14:05:00',2.76),('10318','2014-03-02','14:10:00',2.7),('10318','2014-03-02','14:15:00',2.62),('10318','2014-03-02','14:20:00',2.58),('10318','2014-03-02','14:25:00',2.47),('10318','2014-03-02','14:30:00',2.46),('10318','2014-03-02','14:35:00',2.49),('10318','2014-03-02','14:40:00',2.49),('10318','2014-03-02','14:45:00',2.5),('10318','2014-03-02','14:50:00',2.57),('10318','2014-03-02','14:55:00',2.63),('10318','2014-03-02','15:00:00',2.76),('10318','2014-03-02','15:05:00',2.87),('10318','2014-03-02','15:10:00',2.82),('10318','2014-03-02','15:15:00',2.89),('10318','2014-03-02','15:20:00',3.01),('10318','2014-03-02','15:25:00',2.92),('10318','2014-03-02','15:30:00',3.02),('10318','2014-03-02','15:35:00',3.02),('10318','2014-03-02','15:40:00',2.81),('10318','2014-03-02','15:45:00',2.77),('10318','2014-03-02','15:50:00',2.4),('10318','2014-03-02','15:55:00',1.97),('10318','2014-03-02','16:00:00',1.84),('10318','2014-03-02','16:05:00',1.63),('10318','2014-03-02','16:10:00',1.4),('10318','2014-03-02','16:15:00',1.29),('10318','2014-03-02','16:20:00',1.22),('10318','2014-03-02','16:25:00',1.04),('10318','2014-03-01','08:35:00',1.03),('10318','2014-03-01','09:50:00',1.13),('10318','2014-03-01','09:55:00',1.18),('10318','2014-03-01','10:20:00',1.02),('10318','2014-03-01','10:25:00',1.06),('10318','2014-03-01','10:30:00',1.03),('10318','2014-03-01','12:00:00',1.15),('10318','2014-03-01','12:05:00',1.04),('10318','2014-03-01','12:30:00',1.09),('10318','2014-03-01','12:35:00',1.1),('10318','2014-03-01','12:40:00',1.33),('10318','2014-03-01','12:45:00',1.2),('10318','2014-03-01','13:00:00',1.09),('10318','2014-03-01','13:05:00',1.24),('10318','2014-03-01','13:10:00',1.27),('10318','2014-03-01','13:15:00',1.13),('10318','2014-03-01','13:20:00',1.08),('10318','2014-03-01','14:35:00',1.59),('10318','2014-03-01','14:40:00',1.74),('10318','2014-03-01','14:45:00',1.32),('10318','2014-03-01','15:00:00',1.01),('10318','2014-03-01','16:10:00',1.16),('10318','2014-03-01','16:15:00',1.32),('10318','2014-03-01','16:20:00',1.24),('10318','2014-02-28','11:15:00',3.07),('10318','2014-02-28','11:20:00',3.72),('10318','2014-02-28','11:25:00',3.78),('10318','2014-02-28','11:30:00',2.95),('10318','2014-02-28','11:35:00',1.98),('10318','2014-02-28','11:40:00',2.02),('10318','2014-02-28','11:45:00',1.86),('10318','2014-02-28','11:50:00',2.29),('10318','2014-02-28','11:55:00',2.79),('10318','2014-02-28','12:00:00',4.58),('10318','2014-02-28','12:05:00',6.67),('10318','2014-02-28','12:10:00',2.5),('10318','2014-02-28','12:15:00',1.38),('10318','2014-02-28','12:20:00',2.84),('10318','2014-02-28','12:25:00',5.84),('10318','2014-02-28','12:30:00',7.17),('10318','2014-02-28','12:35:00',9.74),('10318','2014-02-28','12:40:00',7.12),('10318','2014-02-28','12:45:00',3.1),('10318','2014-02-28','12:50:00',3.51),('10318','2014-02-28','12:55:00',5.53),('10318','2014-02-28','13:00:00',5.44),('10318','2014-02-28','13:05:00',3.88),('10318','2014-02-28','13:11:00',3.14),('10318','2014-02-28','13:15:00',1.94),('10318','2014-02-28','13:20:00',1.18),('10318','2014-02-28','13:40:00',1.18),('10318','2014-02-28','13:45:00',2.54),('10318','2014-02-28','13:50:00',3.26),('10318','2014-02-28','13:55:00',2.37),('10318','2014-02-28','14:00:00',2.17),('10318','2014-02-28','14:05:00',1.39),('10318','2014-02-28','14:10:00',1.52),('10318','2014-02-28','14:15:00',2.35),('10318','2014-02-28','14:20:00',3.46),('10318','2014-02-28','14:25:00',4.48),('10318','2014-02-28','14:30:00',4.2),('10318','2014-02-28','14:35:00',3.24),('10318','2014-02-28','14:40:00',2.96),('10318','2014-02-28','15:00:00',2.4),('10318','2014-02-28','15:05:00',2.65),('10318','2014-02-28','15:10:00',1.5),('10318','2014-02-28','15:15:00',1.23),('10318','2014-02-28','15:20:00',3.27),('10318','2014-02-28','15:25:00',4.05),('10318','2014-02-28','15:30:00',3.57),('10318','2014-02-28','15:35:00',2.23),('10318','2014-02-28','15:40:00',1.77),('10318','2014-02-28','15:45:00',1.64),('10318','2014-02-28','15:50:00',1.25),('10318','2014-02-28','16:10:00',1.35),('10318','2014-02-28','16:15:00',3.77),('10318','2014-02-28','16:20:00',2.71),('10318','2014-02-28','16:25:00',1.15),('10318','2014-02-28','16:30:00',1.5),('10318','2014-02-28','16:35:00',2.16),('10318','2014-02-28','16:40:00',2.73),('10318','2014-02-28','16:45:00',2.36),('10318','2014-02-28','16:50:00',1.54),('10318','2014-02-27','09:50:00',1.06),('10318','2014-02-27','10:05:00',1.14),('10318','2014-02-27','10:10:00',1.17),('10318','2014-02-27','10:15:00',1.17),('10318','2014-02-27','10:20:00',1.29),('10318','2014-02-27','10:25:00',1.63),('10318','2014-02-27','10:30:00',2.13),('10318','2014-02-27','10:35:00',2.49),('10318','2014-02-27','10:40:00',2.91),('10318','2014-02-27','10:45:00',2.98),('10318','2014-02-27','10:50:00',2.93),('10318','2014-02-27','10:55:00',3.31),('10318','2014-02-27','11:00:00',4.08),('10318','2014-02-27','11:05:00',3.97),('10318','2014-02-27','11:10:00',3.79),('10318','2014-02-27','11:15:00',3.47),('10318','2014-02-27','11:20:00',3.08),('10318','2014-02-27','11:25:00',4.02),('10318','2014-02-27','11:30:00',4.57),('10318','2014-02-27','11:35:00',3.64),('10318','2014-02-27','11:40:00',3.11),('10318','2014-02-27','11:45:00',2.6),('10318','2014-02-27','11:50:00',2.75),('10318','2014-02-27','11:55:00',3),('10318','2014-02-27','12:00:00',2.75),('10318','2014-02-27','12:05:00',2.66),('10318','2014-02-27','12:10:00',2.96),('10318','2014-02-27','12:15:00',2.94),('10318','2014-02-27','12:20:00',2.99),('10318','2014-02-27','12:25:00',2.97),('10318','2014-02-27','12:30:00',2.87),('10318','2014-02-27','12:35:00',2.75),('10318','2014-02-27','12:40:00',2.68),('10318','2014-02-27','12:45:00',2.69),('10318','2014-02-27','12:50:00',2.68),('10318','2014-02-27','12:55:00',2.73),('10318','2014-02-27','13:00:00',2.72),('10318','2014-02-27','13:05:00',2.31),('10318','2014-02-27','13:10:00',2.5),('10318','2014-02-27','13:15:00',2.74),('10318','2014-02-27','13:20:00',2.77),('10318','2014-02-27','13:25:00',2.97),('10318','2014-02-27','13:30:00',3.59),('10318','2014-02-27','13:35:00',3.89),('10318','2014-02-27','13:40:00',3.91),('10318','2014-02-27','13:45:00',3.76),('10318','2014-02-27','13:50:00',3.61),('10318','2014-02-27','13:55:00',4.68),('10318','2014-02-27','14:00:00',5.04),('10318','2014-02-27','14:05:00',3.67),('10318','2014-02-27','14:10:00',3.64),('10318','2014-02-27','14:15:00',3.47),('10318','2014-02-27','14:20:00',3.11),('10318','2014-02-27','14:25:00',2.68),('10318','2014-02-27','14:30:00',2.43),('10318','2014-02-27','14:35:00',2.13),('10318','2014-02-27','14:40:00',1.9),('10318','2014-02-27','14:45:00',2.09),('10318','2014-02-27','14:50:00',2.15),('10318','2014-02-27','14:55:00',2.21),('10318','2014-02-27','15:00:00',2.56),('10318','2014-02-27','15:05:00',2.83),('10318','2014-02-27','15:10:00',3.26),('10318','2014-02-27','15:15:00',4.04),('10318','2014-02-27','15:20:00',3.47),('10318','2014-02-27','15:25:00',3.02),('10318','2014-02-27','15:30:00',2.66),('10318','2014-02-27','15:35:00',2.39),('10318','2014-02-27','15:40:00',2.11),('10318','2014-02-27','15:45:00',1.84),('10318','2014-02-27','15:50:00',1.53),('10318','2014-02-27','15:55:00',1.46),('10318','2014-02-27','16:00:00',1.36),('10318','2014-02-27','16:05:00',1.16),('10318','2014-02-27','16:25:00',1.57),('10318','2014-02-27','16:30:00',1.75),('10318','2014-02-27','16:35:00',1.72),('10318','2014-02-27','16:40:00',1.39),('10318','2014-02-27','16:45:00',1.89),('10318','2014-02-27','16:50:00',2.33),('10318','2014-02-27','16:55:00',2.03),('10318','2014-02-27','17:00:00',1.71),('10318','2014-02-27','17:05:00',1.34),('10318','2014-02-26','07:30:00',1.11),('10318','2014-02-26','07:35:00',1.21),('10318','2014-02-26','07:40:00',1.36),('10318','2014-02-26','07:45:00',1.48),('10318','2014-02-26','07:50:00',1.76),('10318','2014-02-26','07:55:00',2.56),('10318','2014-02-26','08:00:00',3.27),('10318','2014-02-26','08:05:00',3.67),('10318','2014-02-26','08:10:00',3.96),('10318','2014-02-26','08:15:00',4.21),('10318','2014-02-26','08:20:00',4.39),('10318','2014-02-26','08:25:00',4.45),('10318','2014-02-26','08:30:00',4.83),('10318','2014-02-26','08:35:00',5.06),('10318','2014-02-26','08:40:00',5.45),('10318','2014-02-26','08:45:00',4.66),('10318','2014-02-26','08:50:00',3.41),('10318','2014-02-26','08:55:00',5.76),('10318','2014-02-26','09:00:00',5.75),('10318','2014-02-26','09:05:00',5.97),('10318','2014-02-26','09:10:00',6.26),('10318','2014-02-26','09:15:00',5.74),('10318','2014-02-26','09:20:00',5.63),('10318','2014-02-26','09:25:00',6.01),('10318','2014-02-26','09:30:00',4.19),('10318','2014-02-26','09:35:00',3.01),('10318','2014-02-26','09:40:00',4.28),('10318','2014-02-26','09:45:00',4.03),('10318','2014-02-26','09:50:00',3.43),('10318','2014-02-26','09:55:00',3.45),('10318','2014-02-26','10:00:00',2.53),('10318','2014-02-26','10:05:00',2.45),('10318','2014-02-26','10:10:00',2.14),('10318','2014-02-26','10:15:00',2.13),('10318','2014-02-26','10:20:00',1.67),('10318','2014-02-26','10:25:00',1.51),('10318','2014-02-26','10:30:00',1.75),('10318','2014-02-26','10:35:00',1.88),('10318','2014-02-26','10:40:00',1.51),('10318','2014-02-26','10:45:00',1.34),('10318','2014-02-26','10:50:00',1.51),('10318','2014-02-26','10:55:00',2.22),('10318','2014-02-26','11:00:00',2.8),('10318','2014-02-26','11:05:00',2.69),('10318','2014-02-26','11:10:00',2.69),('10318','2014-02-26','11:15:00',2.55),('10318','2014-02-26','11:20:00',2.27),('10318','2014-02-26','11:25:00',1.97),('10318','2014-02-26','11:30:00',1.75),('10318','2014-02-26','11:35:00',1.82),('10318','2014-02-26','11:40:00',2.05),('10318','2014-02-26','11:45:00',2.76),('10318','2014-02-26','11:50:00',2.69),('10318','2014-02-26','11:55:00',2.65),('10318','2014-02-26','12:00:00',2.61),('10318','2014-02-26','12:05:00',2.47),('10318','2014-02-26','12:10:00',2.54),('10318','2014-02-26','12:15:00',3.46),('10318','2014-02-26','12:20:00',6.41),('10318','2014-02-26','12:25:00',5.13),('10318','2014-02-26','12:30:00',3.96),('10318','2014-02-26','12:35:00',6.67),('10318','2014-02-26','12:40:00',9.02),('10318','2014-02-26','12:45:00',6.49),('10318','2014-02-26','12:50:00',8.69),('10318','2014-02-26','12:55:00',7.88),('10318','2014-02-26','13:00:00',7.64),('10318','2014-02-26','13:05:00',4.84),('10318','2014-02-26','13:10:00',6.27),('10318','2014-02-26','13:15:00',3.05),('10318','2014-02-26','13:20:00',4.57),('10318','2014-02-26','13:25:00',5.92),('10318','2014-02-26','13:30:00',7.86),('10318','2014-02-26','13:35:00',6.94),('10318','2014-02-26','13:40:00',4.96),('10318','2014-02-26','13:45:00',3.43),('10318','2014-02-26','13:50:00',6.89),('10318','2014-02-26','13:55:00',2.49),('10318','2014-02-26','14:00:00',4.45),('10318','2014-02-26','14:05:00',6.12),('10318','2014-02-26','14:10:00',1.84),('10318','2014-02-26','14:15:00',4.85),('10318','2014-02-26','14:20:00',5.39),('10318','2014-02-26','14:25:00',6.27),('10318','2014-02-26','14:30:00',6.16),('10318','2014-02-26','14:35:00',4.42),('10318','2014-02-26','14:40:00',4.97),('10318','2014-02-26','14:45:00',2.76),('10318','2014-02-26','14:50:00',5.86),('10318','2014-02-26','14:55:00',3.18),('10318','2014-02-26','15:00:00',5.67),('10318','2014-02-26','15:05:00',5.71),('10318','2014-02-26','15:10:00',5.46),('10318','2014-02-26','15:15:00',4.73),('10318','2014-02-26','15:20:00',3.47),('10318','2014-02-26','15:25:00',2.24),('10318','2014-02-26','15:30:00',2.62),('10318','2014-02-26','15:35:00',3.4),('10318','2014-02-26','15:40:00',3.46),('10318','2014-02-26','15:45:00',2.84),('10318','2014-02-26','15:50:00',2.81),('10318','2014-02-26','15:55:00',3.56),('10318','2014-02-26','16:00:00',3.64),('10318','2014-02-26','16:05:00',3.15),('10318','2014-02-26','16:10:00',2.43),('10318','2014-02-26','16:15:00',2.24),('10318','2014-02-26','16:20:00',1.87),('10318','2014-02-26','16:25:00',1.26),('10318','2014-02-26','16:30:00',1.09),('10318','2014-04-29','09:10:00',1.09),('10318','2014-04-29','09:15:00',1.18),('10318','2014-04-29','09:20:00',1.01),('10318','2014-04-29','09:35:00',1.08),('10318','2014-04-29','09:40:00',1.49),('10318','2014-04-29','09:45:00',2.03),('10318','2014-04-29','09:50:00',2.64),('10318','2014-04-29','09:55:00',3.25),('10318','2014-04-29','10:00:00',4.75),('10318','2014-04-29','10:05:00',8.13),('10318','2014-04-29','10:10:00',9.75),('10318','2014-04-29','10:15:00',9.16),('10318','2014-04-29','10:20:00',9.55),('10318','2014-04-29','10:25:00',9.25),('10318','2014-04-29','10:30:00',9.52),('10318','2014-04-29','10:35:00',9.49),('10318','2014-04-29','10:40:00',9.62),('10318','2014-04-29','10:45:00',9.74),('10318','2014-04-29','10:50:00',8.94),('10318','2014-04-29','10:55:00',8.97),('10318','2014-04-29','11:00:00',9.57),('10318','2014-04-29','11:05:00',9.48),('10318','2014-04-29','11:10:00',5.7),('10318','2014-04-29','11:15:00',7.46),('10318','2014-04-29','11:20:00',9.56),('10318','2014-04-29','11:25:00',9.22),('10318','2014-04-29','11:30:00',6.49),('10318','2014-04-29','11:35:00',9.65),('10318','2014-04-29','11:40:00',5.12),('10318','2014-04-29','11:45:00',8.69),('10318','2014-04-29','11:50:00',3.44),('10318','2014-04-29','11:55:00',3.25),('10318','2014-04-29','12:00:00',2.96),('10318','2014-04-29','12:05:00',3.6),('10318','2014-04-29','12:10:00',5.32),('10318','2014-04-29','12:15:00',4.25),('10318','2014-04-29','12:20:00',8.55),('10318','2014-04-29','12:25:00',3.05),('10318','2014-04-29','12:30:00',6.76),('10318','2014-04-29','12:35:00',10.04),('10318','2014-04-29','12:40:00',10.44),('10318','2014-04-29','12:45:00',3.66),('10318','2014-04-29','12:50:00',3.53),('10318','2014-04-29','12:55:00',3.48),('10318','2014-04-29','13:00:00',5.58),('10318','2014-04-29','13:05:00',5.72),('10318','2014-04-29','13:10:00',3.56),('10318','2014-04-29','13:15:00',2.99),('10318','2014-04-29','13:20:00',3.46),('10318','2014-04-29','13:25:00',6.09),('10318','2014-04-29','13:30:00',4.21),('10318','2014-04-29','13:35:00',3.62),('10318','2014-04-29','13:40:00',6.47),('10318','2014-04-29','13:45:00',4.12),('10318','2014-04-29','13:50:00',1.91),('10318','2014-04-29','13:55:00',1.16),('10318','2014-04-29','14:20:00',1),('10318','2014-04-29','14:25:00',1.11),('10318','2014-04-29','14:30:00',1.01),('10318','2014-04-29','14:35:00',1.1),('10318','2014-04-29','14:40:00',1.23),('10318','2014-04-29','14:45:00',1.22),('10318','2014-04-29','14:50:00',1.09),('10318','2014-04-29','14:55:00',1.12),('10318','2014-04-29','15:00:00',1.54),('10318','2014-04-29','15:05:00',2.1),('10318','2014-04-29','15:10:00',2.25),('10318','2014-04-29','15:15:00',2.03),('10318','2014-04-29','15:20:00',1.89),('10318','2014-04-29','15:25:00',2.1),('10318','2014-04-29','15:30:00',1.99),('10318','2014-04-29','15:35:00',1.67),('10318','2014-04-29','15:40:00',1.15),('10318','2014-04-29','15:45:00',1.05),('10318','2014-04-29','15:50:00',1.31),('10318','2014-04-29','15:55:00',1.46),('10318','2014-04-29','16:00:00',1.44),('10318','2014-04-29','16:05:00',1.73),('10318','2014-04-29','16:10:00',1.83),('10318','2014-04-29','16:15:00',1.68),('10318','2014-04-29','16:20:00',1.45),('10318','2014-04-29','16:25:00',1.33),('10318','2014-04-29','16:30:00',1.21),('10318','2014-04-29','16:35:00',1.2),('10318','2014-04-29','16:40:00',1.33),('10318','2014-04-29','16:45:00',1.34),('10318','2014-04-29','16:50:00',1.41),('10318','2014-04-29','16:55:00',1.75),('10318','2014-04-29','17:00:00',2.32),('10318','2014-04-29','17:05:00',2.34),('10318','2014-04-29','17:10:00',2.07),('10318','2014-04-29','17:15:00',1.84),('10318','2014-04-29','17:20:00',2.75),('10318','2014-04-29','17:25:00',2.61),('10318','2014-04-29','17:30:00',3.5),('10318','2014-04-29','17:35:00',4.12),('10318','2014-04-29','17:40:00',3.36),('10318','2014-04-29','17:45:00',1.96),('10318','2014-04-29','17:50:00',1.11),('10318','2014-04-29','17:55:00',1.4),('10318','2014-04-29','18:00:00',1.48),('10318','2014-04-29','18:05:00',1.4),('10318','2014-02-25','07:30:00',1.06),('10318','2014-02-25','07:35:00',1.22),('10318','2014-02-25','07:40:00',1.41),('10318','2014-02-25','07:45:00',1.66),('10318','2014-02-25','07:50:00',1.86),('10318','2014-02-25','07:55:00',2.44),('10318','2014-02-25','08:00:00',3.24),('10318','2014-02-25','08:05:00',3.54),('10318','2014-02-25','08:10:00',3.75),('10318','2014-02-25','08:15:00',3.97),('10318','2014-02-25','08:20:00',4.21),('10318','2014-02-25','08:25:00',4.45),('10318','2014-02-25','08:30:00',4.66),('10318','2014-02-25','08:35:00',4.87),('10318','2014-02-25','08:40:00',5.08),('10318','2014-02-25','08:45:00',5.29),('10318','2014-02-25','08:50:00',5.47),('10318','2014-02-25','08:55:00',5.64),('10318','2014-02-25','09:00:00',5.8),('10318','2014-02-25','09:05:00',5.95),('10318','2014-02-25','09:10:00',6.1),('10318','2014-02-25','09:15:00',6.26),('10318','2014-02-25','09:20:00',6.45),('10318','2014-02-25','09:25:00',6.44),('10318','2014-02-25','09:30:00',6.69),('10318','2014-02-25','09:35:00',6.84),('10318','2014-02-25','09:40:00',6.96),('10318','2014-02-25','09:45:00',7.12),('10318','2014-02-25','09:50:00',7.18),('10318','2014-02-25','09:55:00',7.17),('10318','2014-02-25','10:00:00',7.25),('10318','2014-02-25','10:05:00',7.37),('10318','2014-02-25','10:10:00',7.55),('10318','2014-02-25','10:15:00',7.65),('10318','2014-02-25','10:20:00',7.75),('10318','2014-02-25','10:25:00',7.8),('10318','2014-02-25','10:30:00',7.91),('10318','2014-02-25','10:35:00',8.01),('10318','2014-02-25','10:40:00',8.04),('10318','2014-02-25','10:45:00',8.14),('10318','2014-02-25','10:50:00',8.18),('10318','2014-02-25','10:55:00',8.23),('10318','2014-02-25','11:00:00',8.27),('10318','2014-02-25','11:05:00',8.3),('10318','2014-02-25','11:10:00',8.24),('10318','2014-02-25','11:15:00',8.31),('10318','2014-02-25','11:20:00',8.37),('10318','2014-02-25','11:25:00',8.39),('10318','2014-02-25','11:30:00',8.34),('10318','2014-02-25','11:35:00',8.36),('10318','2014-02-25','11:40:00',8.36),('10318','2014-02-25','11:45:00',8.41),('10318','2014-02-25','11:50:00',8.35),('10318','2014-02-25','11:55:00',8.38),('10318','2014-02-25','12:00:00',8.35),('10318','2014-02-25','12:05:00',8.26),('10318','2014-02-25','12:10:00',8.37),('10318','2014-02-25','12:15:00',8.36),('10318','2014-02-25','12:20:00',8.28),('10318','2014-02-25','12:25:00',8.2),('10318','2014-02-25','12:30:00',8.16),('10318','2014-02-25','12:35:00',8.09),('10318','2014-02-25','12:40:00',8.13),('10318','2014-02-25','12:45:00',8.06),('10318','2014-02-25','12:50:00',7.89),('10318','2014-02-25','12:55:00',7.78),('10318','2014-02-25','13:00:00',7.78),('10318','2014-02-25','13:05:00',7.68),('10318','2014-02-25','13:10:00',7.51),('10318','2014-02-25','13:15:00',6.92),('10318','2014-02-25','13:20:00',6.05),('10318','2014-02-25','13:25:00',3.87),('10318','2014-02-25','13:30:00',2.18),('10318','2014-02-25','13:35:00',2.77),('10318','2014-02-25','13:40:00',2.82),('10318','2014-02-25','13:45:00',3.14),('10318','2014-02-25','13:50:00',2.9),('10318','2014-02-25','13:55:00',4.83),('10318','2014-02-25','14:00:00',5.06),('10318','2014-02-25','14:05:00',7.56),('10318','2014-02-25','14:10:00',7.41),('10318','2014-02-25','14:15:00',6.39),('10318','2014-02-25','14:20:00',6.49),('10318','2014-02-25','14:25:00',6.45),('10318','2014-02-25','14:30:00',6.3),('10318','2014-02-25','14:35:00',6.2),('10318','2014-02-25','14:40:00',6.16),('10318','2014-02-25','14:45:00',5.87),('10318','2014-02-25','14:50:00',5.51),('10318','2014-02-25','14:55:00',5.54),('10318','2014-02-25','15:00:00',5.22),('10318','2014-02-25','15:05:00',5.08),('10318','2014-02-25','15:10:00',4.84),('10318','2014-02-25','15:15:00',4.74),('10318','2014-02-25','15:20:00',4.33),('10318','2014-02-25','15:25:00',3.99),('10318','2014-02-25','15:30:00',3.58),('10318','2014-02-25','15:35:00',3.4),('10318','2014-02-25','15:40:00',2.86),('10318','2014-02-25','15:45:00',1.58),('10318','2014-02-25','15:50:00',2.05),('10318','2014-02-25','15:55:00',2.37),('10318','2014-02-25','16:00:00',1.95),('10318','2014-02-25','16:05:00',2.18),('10318','2014-02-25','16:10:00',2.16),('10318','2014-02-25','16:15:00',2.34),('10318','2014-02-25','16:20:00',2.12),('10318','2014-02-25','16:25:00',1.61),('10318','2014-02-25','16:30:00',1.07),('10318','2014-02-24','07:30:00',1.16),('10318','2014-02-24','07:35:00',1.33),('10318','2014-02-24','07:40:00',1.42),('10318','2014-02-24','07:45:00',1.61),('10318','2014-02-24','07:50:00',1.8),('10318','2014-02-24','07:55:00',2.13),('10318','2014-02-24','08:00:00',3.56),('10318','2014-02-24','08:05:00',4.24),('10318','2014-02-24','08:10:00',4.64),('10318','2014-02-24','08:15:00',4.88),('10318','2014-02-24','08:20:00',5.03),('10318','2014-02-24','08:25:00',4.14),('10318','2014-02-24','08:30:00',3.6),('10318','2014-02-24','08:35:00',3.57),('10318','2014-02-24','08:40:00',3.02),('10318','2014-02-24','08:45:00',3.26),('10318','2014-02-24','08:50:00',5.57),('10318','2014-02-24','08:55:00',6.02),('10318','2014-02-24','09:00:00',6),('10318','2014-02-24','09:05:00',6.05),('10318','2014-02-24','09:10:00',6.21),('10318','2014-02-24','09:15:00',4.69),('10318','2014-02-24','09:20:00',4.99),('10318','2014-02-24','09:25:00',6.6),('10318','2014-02-24','09:30:00',6.75),('10318','2014-02-24','09:35:00',6.87),('10318','2014-02-24','09:40:00',7),('10318','2014-02-24','09:45:00',7.15),('10318','2014-02-24','09:50:00',7.26),('10318','2014-02-24','09:55:00',7.37),('10318','2014-02-24','10:00:00',5.5),('10318','2014-02-24','10:05:00',7.59),('10318','2014-02-24','10:10:00',7.72),('10318','2014-02-24','10:15:00',7.84),('10318','2014-02-24','10:20:00',7.95),('10318','2014-02-24','10:25:00',6),('10318','2014-02-24','10:30:00',8.07),('10318','2014-02-24','10:35:00',8.17),('10318','2014-02-24','10:40:00',8.22),('10318','2014-02-24','10:45:00',8.24),('10318','2014-02-24','10:50:00',8.32),('10318','2014-02-24','10:55:00',8.31),('10318','2014-02-24','11:00:00',8.31),('10318','2014-02-24','11:05:00',8.42),('10318','2014-02-24','11:10:00',8.47),('10318','2014-02-24','11:15:00',8.55),('10318','2014-02-24','11:20:00',8.64),('10318','2014-02-24','11:25:00',8.85),('10318','2014-02-24','11:30:00',9.39),('10318','2014-02-24','11:35:00',9.04),('10318','2014-02-24','11:40:00',7.88),('10318','2014-02-24','11:45:00',4.94),('10318','2014-02-24','11:50:00',5.85),('10318','2014-02-24','11:55:00',8.69),('10318','2014-02-24','12:00:00',8.79),('10318','2014-02-24','12:05:00',8.7),('10318','2014-02-24','12:10:00',8.61),('10318','2014-02-24','12:15:00',8.56),('10318','2014-02-24','12:20:00',8.49),('10318','2014-02-24','12:25:00',8.67),('10318','2014-02-24','12:30:00',8.7),('10318','2014-02-24','12:35:00',8.66),('10318','2014-02-24','12:40:00',8.64),('10318','2014-02-24','12:45:00',8.69),('10318','2014-02-24','12:50:00',8.08),('10318','2014-02-24','12:55:00',8.74),('10318','2014-02-24','13:00:00',9.2),('10318','2014-02-24','13:05:00',8.79),('10318','2014-02-24','13:10:00',6.73),('10318','2014-02-24','13:15:00',1.92),('10318','2014-02-24','13:20:00',1.75),('10318','2014-02-24','13:25:00',1.74),('10318','2014-02-24','13:30:00',1.69),('10318','2014-02-24','13:35:00',1.58),('10318','2014-02-24','13:40:00',1.58),('10318','2014-02-24','13:45:00',1.61),('10318','2014-02-24','13:50:00',1.73),('10318','2014-02-24','13:55:00',1.97),('10318','2014-02-24','14:00:00',2.23),('10318','2014-02-24','14:05:00',2.48),('10318','2014-02-24','14:10:00',2.78),('10318','2014-02-24','14:15:00',2.55),('10318','2014-02-24','14:20:00',2.4),('10318','2014-02-24','14:25:00',2.22),('10318','2014-02-24','14:30:00',2.3),('10318','2014-02-24','14:35:00',2.18),('10318','2014-02-24','14:40:00',2.12),('10318','2014-02-24','14:45:00',2.23),('10318','2014-02-24','14:50:00',2.26),('10318','2014-02-24','14:55:00',2.12),('10318','2014-02-24','15:00:00',2.04),('10318','2014-02-24','15:05:00',1.97),('10318','2014-02-24','15:10:00',2.15),('10318','2014-02-24','15:15:00',2.73),('10318','2014-02-24','15:20:00',3.96),('10318','2014-02-24','15:25:00',5.9),('10318','2014-02-24','15:30:00',5.11),('10318','2014-02-24','15:35:00',4.79),('10318','2014-02-24','15:40:00',4.6),('10318','2014-02-24','15:45:00',4.19),('10318','2014-02-24','15:50:00',4.25),('10318','2014-02-24','15:55:00',4.33),('10318','2014-02-24','16:00:00',4.39),('10318','2014-02-24','16:05:00',4.18),('10318','2014-02-24','16:10:00',3.84),('10318','2014-02-24','16:15:00',3.41),('10318','2014-02-24','16:20:00',2.75),('10318','2014-02-24','16:40:00',1.7),('10318','2014-02-24','16:45:00',1.57),('10318','2014-02-24','16:50:00',1.33),('10318','2014-02-24','16:55:00',1.12),('10318','2014-02-23','07:35:00',1.11),('10318','2014-02-23','07:40:00',1.42),('10318','2014-02-23','07:45:00',1.72),('10318','2014-02-23','07:50:00',2.2),('10318','2014-02-23','07:55:00',2.5),('10318','2014-02-23','08:00:00',2.97),('10318','2014-02-23','08:05:00',3.44),('10318','2014-02-23','08:10:00',3.67),('10318','2014-02-23','08:15:00',3.89),('10318','2014-02-23','08:20:00',4.11),('10318','2014-02-23','08:25:00',4.32),('10318','2014-02-23','08:30:00',4.51),('10318','2014-02-23','08:35:00',4.76),('10318','2014-02-23','08:40:00',4.97),('10318','2014-02-23','08:45:00',5.19),('10318','2014-02-23','08:50:00',5.39),('10318','2014-02-23','08:55:00',5.59),('10318','2014-02-23','09:00:00',5.75),('10318','2014-02-23','09:05:00',5.96),('10318','2014-02-23','09:10:00',6.15),('10318','2014-02-23','09:15:00',6.35),('10318','2014-02-23','09:20:00',6.48),('10318','2014-02-23','09:25:00',6.26),('10318','2014-02-23','09:30:00',5.97),('10318','2014-02-23','09:35:00',6.82),('10318','2014-02-23','09:40:00',6.93),('10318','2014-02-23','09:45:00',6.99),('10318','2014-02-23','09:50:00',7.1),('10318','2014-02-23','09:55:00',7.21),('10318','2014-02-23','10:00:00',7.29),('10318','2014-02-23','10:05:00',7.35),('10318','2014-02-23','10:10:00',7.47),('10318','2014-02-23','10:15:00',7.47),('10318','2014-02-23','10:20:00',7.66),('10318','2014-02-23','10:25:00',7.79),('10318','2014-02-23','10:30:00',7.9),('10318','2014-02-23','10:35:00',7.91),('10318','2014-02-23','10:40:00',8.03),('10318','2014-02-23','10:45:00',8.13),('10318','2014-02-23','10:50:00',8.11),('10318','2014-02-23','10:55:00',8.01),('10318','2014-02-23','11:00:00',8.3),('10318','2014-02-23','11:05:00',8.42),('10318','2014-02-23','11:10:00',8.58),('10318','2014-02-23','11:15:00',8.56),('10318','2014-02-23','11:20:00',8.58),('10318','2014-02-23','11:25:00',8.5),('10318','2014-02-23','11:30:00',8.63),('10318','2014-02-23','11:35:00',8.69),('10318','2014-02-23','11:40:00',8.83),('10318','2014-02-23','11:45:00',8.93),('10318','2014-02-23','11:50:00',7.81),('10318','2014-02-23','11:55:00',5.94),('10318','2014-02-23','12:00:00',7.91),('10318','2014-02-23','12:05:00',8.95),('10318','2014-02-23','12:10:00',9.19),('10318','2014-02-23','12:15:00',9.14),('10318','2014-02-23','12:20:00',6.8),('10318','2014-02-23','12:25:00',4.43),('10318','2014-02-23','12:30:00',8.78),('10318','2014-02-23','12:35:00',5.96),('10318','2014-02-23','12:40:00',5.8),('10318','2014-02-23','12:45:00',4.45),('10318','2014-02-23','12:50:00',4.92),('10318','2014-02-23','12:55:00',5.44),('10318','2014-02-23','13:00:00',8.18),('10318','2014-02-23','13:05:00',8.37),('10318','2014-02-23','13:10:00',8.22),('10318','2014-02-23','13:15:00',8.27),('10318','2014-02-23','13:20:00',8.32),('10318','2014-02-23','13:25:00',8.07),('10318','2014-02-23','13:30:00',7.77),('10318','2014-02-23','13:35:00',7.2),('10318','2014-02-23','13:40:00',6.42),('10318','2014-02-23','13:45:00',4.05),('10318','2014-02-23','13:50:00',4.47),('10318','2014-02-23','13:55:00',3.22),('10318','2014-02-23','14:00:00',3.47),('10318','2014-02-23','14:05:00',5.26),('10318','2014-02-23','14:10:00',2.8),('10318','2014-02-23','14:15:00',3.31),('10318','2014-02-23','14:20:00',7.17),('10318','2014-02-23','14:25:00',7.61),('10318','2014-02-23','14:30:00',7.63),('10318','2014-02-23','14:35:00',6.7),('10318','2014-02-23','14:40:00',6.93),('10318','2014-02-23','14:45:00',6.79),('10318','2014-02-23','14:50:00',6.25),('10318','2014-02-23','14:55:00',3.62),('10318','2014-02-23','15:00:00',1.65),('10318','2014-02-23','15:05:00',2.09),('10318','2014-02-23','15:10:00',1.56),('10318','2014-02-23','15:15:00',1.62),('10318','2014-02-23','15:20:00',4.62),('10318','2014-02-23','15:25:00',3.68),('10318','2014-02-23','15:30:00',1.69),('10318','2014-02-23','15:35:00',1.35),('10318','2014-02-23','15:40:00',1.02),('10318','2014-02-22','08:50:00',1.1),('10318','2014-02-22','09:00:00',1.48),('10318','2014-02-22','09:05:00',2.19),('10318','2014-02-22','09:10:00',1.95),('10318','2014-02-22','09:15:00',1.51),('10318','2014-02-22','09:20:00',2.74),('10318','2014-02-22','09:25:00',1.81),('10318','2014-02-22','09:30:00',1.84),('10318','2014-02-22','09:35:00',1.94),('10318','2014-02-22','09:40:00',2.69),('10318','2014-02-22','09:45:00',5.29),('10318','2014-02-22','09:50:00',2.38),('10318','2014-02-22','09:55:00',2.5),('10318','2014-02-22','10:00:00',3.23),('10318','2014-02-22','10:05:00',3.98),('10318','2014-02-22','10:10:00',6.06),('10318','2014-02-22','10:15:00',3),('10318','2014-02-22','10:20:00',3.55),('10318','2014-02-22','10:25:00',3.67),('10318','2014-02-22','10:30:00',4.28),('10318','2014-02-22','10:35:00',3.55),('10318','2014-02-22','10:40:00',7.14),('10318','2014-02-22','10:45:00',8.39),('10318','2014-02-22','10:50:00',3.94),('10318','2014-02-22','10:55:00',2.57),('10318','2014-02-22','11:00:00',1.16),('10318','2014-02-22','11:05:00',2.01),('10318','2014-02-22','11:10:00',2.36),('10318','2014-02-22','11:15:00',1.14),('10318','2014-02-22','11:35:00',1.01),('10318','2014-02-22','11:40:00',1.41),('10318','2014-02-22','11:45:00',1.28),('10318','2014-02-22','11:50:00',1.53),('10318','2014-02-22','11:55:00',1.75),('10318','2014-02-22','12:00:00',2.37),('10318','2014-02-22','12:05:00',3.21),('10318','2014-02-22','12:10:00',4.18),('10318','2014-02-22','12:15:00',3.48),('10318','2014-02-22','12:20:00',5.15),('10318','2014-02-22','12:25:00',2.81),('10318','2014-02-22','12:30:00',2.56),('10318','2014-02-22','12:35:00',3.33),('10318','2014-02-22','12:40:00',6.64),('10318','2014-02-22','12:45:00',9.58),('10318','2014-02-22','12:50:00',7.97),('10318','2014-02-22','12:55:00',4.68),('10318','2014-02-22','13:00:00',3.52),('10318','2014-02-22','13:05:00',8.13),('10318','2014-02-22','13:10:00',8.19),('10318','2014-02-22','13:15:00',3.39),('10318','2014-02-22','13:20:00',2.99),('10318','2014-02-22','13:25:00',7.55),('10318','2014-02-22','13:30:00',4.5),('10318','2014-02-22','13:35:00',6.91),('10318','2014-02-22','13:40:00',7.01),('10318','2014-02-22','13:45:00',7.61),('10318','2014-02-22','13:50:00',7.84),('10318','2014-02-22','13:55:00',6.1),('10318','2014-02-22','14:00:00',7.6),('10318','2014-02-22','14:05:00',7.73),('10318','2014-02-22','14:10:00',7.65),('10318','2014-02-22','14:15:00',6.73),('10318','2014-02-22','14:20:00',6.6),('10318','2014-02-22','14:25:00',7.05),('10318','2014-02-22','14:30:00',7.15),('10318','2014-02-22','14:35:00',6.47),('10318','2014-02-22','14:40:00',4.05),('10318','2014-02-22','14:45:00',3.24),('10318','2014-02-22','14:50:00',2.76),('10318','2014-02-22','14:55:00',2.88),('10318','2014-02-22','15:00:00',3.32),('10318','2014-02-22','15:05:00',5.22),('10318','2014-02-22','15:10:00',3.04),('10318','2014-02-22','15:15:00',2.04),('10318','2014-02-22','15:20:00',3.34),('10318','2014-02-22','15:25:00',2.54),('10318','2014-02-22','15:30:00',3.61),('10318','2014-02-22','15:35:00',1.76),('10318','2014-02-22','15:40:00',1.94),('10318','2014-02-22','15:45:00',2.36),('10318','2014-02-22','15:50:00',1.5),('10318','2014-02-22','15:55:00',3.57),('10318','2014-02-22','16:00:00',3.26),('10318','2014-02-22','16:05:00',2.57),('10318','2014-02-22','16:10:00',2.87),('10318','2014-02-22','16:15:00',2.67),('10318','2014-02-22','16:20:00',2.54),('10318','2014-02-22','16:25:00',2.3),('10318','2014-02-22','16:30:00',2.06),('10318','2014-02-22','16:35:00',1.73),('10318','2014-02-22','16:40:00',1.76),('10318','2014-02-22','16:45:00',1.54),('10318','2014-02-22','16:50:00',1.35),('10318','2014-02-22','16:55:00',1.02),('10318','2014-02-22','17:00:00',1),('10318','2014-02-21','08:15:00',1),('10318','2014-02-21','08:20:00',1.12),('10318','2014-02-21','08:25:00',1.22),('10318','2014-02-21','08:30:00',1.33),('10318','2014-02-21','08:35:00',1.45),('10318','2014-02-21','08:40:00',1.59),('10318','2014-02-21','08:45:00',1.68),('10318','2014-02-21','08:50:00',1.8),('10318','2014-02-21','08:55:00',1.88),('10318','2014-02-21','09:00:00',1.91),('10318','2014-02-21','09:05:00',1.81),('10318','2014-02-21','09:10:00',1.88),('10318','2014-02-21','09:15:00',2.29),('10318','2014-02-21','09:20:00',2.68),('10318','2014-02-21','09:25:00',2.28),('10318','2014-02-21','09:30:00',2.1),('10318','2014-02-21','09:35:00',2.2),('10318','2014-02-21','09:40:00',2.34),('10318','2014-02-21','09:45:00',2.65),('10318','2014-02-21','09:50:00',2.74),('10318','2014-02-21','09:55:00',2.74),('10318','2014-02-21','10:00:00',3.01),('10318','2014-02-21','10:05:00',3.18),('10318','2014-02-21','10:10:00',3.21),('10318','2014-02-21','10:15:00',4.27),('10318','2014-02-21','10:20:00',5.07),('10318','2014-02-21','10:25:00',5.86),('10318','2014-02-21','10:30:00',5.29),('10318','2014-02-21','10:35:00',3.96),('10318','2014-02-21','10:40:00',3.85),('10318','2014-02-21','10:45:00',3.78),('10318','2014-02-21','10:50:00',5.59),('10318','2014-02-21','10:55:00',6.84),('10318','2014-02-21','11:00:00',5.91),('10318','2014-02-21','11:05:00',4.45),('10318','2014-02-21','11:10:00',4.56),('10318','2014-02-21','11:15:00',4.21),('10318','2014-02-21','11:20:00',3.75),('10318','2014-02-21','11:25:00',3.62),('10318','2014-02-21','11:30:00',3.23),('10318','2014-02-21','11:35:00',3.4),('10318','2014-02-21','11:40:00',4.1),('10318','2014-02-21','11:45:00',3.68),('10318','2014-02-21','11:50:00',3.64),('10318','2014-02-21','11:55:00',3.82),('10318','2014-02-21','12:00:00',4.09),('10318','2014-02-21','12:05:00',7.97),('10318','2014-02-21','12:10:00',9.12),('10318','2014-02-21','12:15:00',6.54),('10318','2014-02-21','12:20:00',3.85),('10318','2014-02-21','12:25:00',2.34),('10318','2014-02-21','12:30:00',2.33),('10318','2014-02-21','12:35:00',2.63),('10318','2014-02-21','12:40:00',2.09),('10318','2014-02-21','12:45:00',1.29),('10318','2014-02-21','12:50:00',1.17),('10318','2014-02-21','12:55:00',1.06),('10318','2014-02-21','13:30:00',1.29),('10318','2014-02-21','13:35:00',1.6),('10318','2014-02-21','13:40:00',1.75),('10318','2014-02-21','13:45:00',2.08),('10318','2014-02-21','13:50:00',2.1),('10318','2014-02-21','13:55:00',1.86),('10318','2014-02-21','14:00:00',1.57),('10318','2014-02-21','14:05:00',1.61),('10318','2014-02-21','14:10:00',1.59),('10318','2014-02-21','14:15:00',1.61),('10318','2014-02-21','14:20:00',1.72),('10318','2014-02-21','14:25:00',1.74),('10318','2014-02-21','14:30:00',1.88),('10318','2014-02-21','14:35:00',2.13),('10318','2014-02-21','14:40:00',2.34),('10318','2014-02-21','14:45:00',2.36),('10318','2014-02-21','14:50:00',2.31),('10318','2014-02-21','14:55:00',2.34),('10318','2014-02-21','15:00:00',2.25),('10318','2014-02-21','15:05:00',2.01),('10318','2014-02-21','15:10:00',1.66),('10318','2014-02-21','15:15:00',1.51),('10318','2014-02-21','15:20:00',1.7),('10318','2014-02-21','15:25:00',1.63),('10318','2014-02-21','15:30:00',1.52),('10318','2014-02-21','15:35:00',2.66),('10318','2014-02-21','15:40:00',3.69),('10318','2014-02-21','15:45:00',3.48),('10318','2014-02-21','15:50:00',3.29),('10318','2014-02-21','15:55:00',3.09),('10318','2014-02-21','16:00:00',2.97),('10318','2014-02-21','16:05:00',2.75),('10318','2014-02-21','16:10:00',2.59),('10318','2014-02-21','16:15:00',2.44),('10318','2014-02-21','16:20:00',2.28),('10318','2014-02-21','16:25:00',2.11),('10318','2014-02-21','16:30:00',1.93),('10318','2014-02-21','16:35:00',1.72),('10318','2014-02-21','16:40:00',1.52),('10318','2014-02-21','16:45:00',1.33),('10318','2014-02-21','16:50:00',1.17),('10318','2014-02-20','08:15:00',1.09),('10318','2014-02-20','08:20:00',1.19),('10318','2014-02-20','09:30:00',1.1),('10318','2014-02-20','09:35:00',1.39),('10318','2014-02-20','09:40:00',1.56),('10318','2014-02-20','09:45:00',1.38),('10318','2014-02-20','09:50:00',1.15),('10318','2014-02-20','10:00:00',1.01),('10318','2014-02-20','10:05:00',1.09),('10318','2014-02-20','10:10:00',1.34),('10318','2014-02-20','10:15:00',1.12),('10318','2014-02-20','10:20:00',1.46),('10318','2014-02-20','10:25:00',1.71),('10318','2014-02-20','10:30:00',1.78),('10318','2014-02-20','10:35:00',1.79),('10318','2014-02-20','10:40:00',1.82),('10318','2014-02-20','10:45:00',1.77),('10318','2014-02-20','10:50:00',1.71),('10318','2014-02-20','10:55:00',1.98),('10318','2014-02-20','11:00:00',1.19),('10318','2014-02-20','11:15:00',1.56),('10318','2014-02-20','11:20:00',2.73),('10318','2014-02-20','11:25:00',2.76),('10318','2014-02-20','11:30:00',2.81),('10318','2014-02-20','11:35:00',2.24),('10318','2014-02-20','11:40:00',1.44),('10318','2014-02-20','11:45:00',1.53),('10318','2014-02-20','11:50:00',1.43),('10318','2014-02-20','11:55:00',1.65),('10318','2014-02-20','12:00:00',1.78),('10318','2014-02-20','12:05:00',1.61),('10318','2014-02-20','12:10:00',1.76),('10318','2014-02-20','12:15:00',2.17),('10318','2014-02-20','12:20:00',2.76),('10318','2014-02-20','12:25:00',2.68),('10318','2014-02-20','12:30:00',2.28),('10318','2014-02-20','12:35:00',2.46),('10318','2014-02-20','12:40:00',3),('10318','2014-02-20','12:45:00',3.17),('10318','2014-02-20','12:50:00',3),('10318','2014-02-20','12:55:00',2.85),('10318','2014-02-20','13:00:00',2.87),('10318','2014-02-20','13:05:00',1.99),('10318','2014-02-20','13:10:00',1.78),('10318','2014-02-20','13:15:00',2.42),('10318','2014-02-20','13:20:00',1.91),('10318','2014-02-20','13:25:00',2.23),('10318','2014-02-20','13:30:00',2.86),('10318','2014-02-20','13:35:00',2.42),('10318','2014-02-20','13:40:00',2.04),('10318','2014-02-20','13:45:00',2.09),('10318','2014-02-20','13:50:00',2.24),('10318','2014-02-20','13:55:00',2.11),('10318','2014-02-20','14:00:00',2.66),('10318','2014-02-20','14:05:00',1.93),('10318','2014-02-20','14:10:00',1.42),('10318','2014-02-20','14:15:00',1.59),('10318','2014-02-20','14:20:00',1.01),('10318','2014-02-19','08:30:00',1.11),('10318','2014-02-19','08:35:00',1.43),('10318','2014-02-19','08:40:00',1.57),('10318','2014-02-19','08:45:00',1.74),('10318','2014-02-19','08:50:00',1.6),('10318','2014-02-19','08:55:00',1.57),('10318','2014-02-19','09:00:00',1.65),('10318','2014-02-19','09:05:00',1.69),('10318','2014-02-19','09:10:00',1.67),('10318','2014-02-19','09:15:00',1.86),('10318','2014-02-19','09:20:00',2.04),('10318','2014-02-19','09:25:00',2.36),('10318','2014-02-19','09:30:00',2.4),('10318','2014-02-19','09:35:00',2.82),('10318','2014-02-19','09:40:00',3.09),('10318','2014-02-19','09:45:00',3.72),('10318','2014-02-19','09:50:00',3.37),('10318','2014-02-19','09:55:00',3.07),('10318','2014-02-19','10:00:00',3.03),('10318','2014-02-19','10:05:00',3.02),('10318','2014-02-19','10:10:00',3.42),('10318','2014-02-19','10:15:00',3.55),('10318','2014-02-19','10:20:00',3.16),('10318','2014-02-19','10:25:00',3.3),('10318','2014-02-19','10:30:00',3.25),('10318','2014-02-19','10:35:00',3.49),('10318','2014-02-19','10:40:00',4.08),('10318','2014-02-19','10:45:00',4.26),('10318','2014-02-19','10:50:00',4.41),('10318','2014-02-19','10:55:00',3.92),('10318','2014-02-19','11:00:00',3.3),('10318','2014-02-19','11:05:00',3.05),('10318','2014-02-19','11:10:00',3),('10318','2014-02-19','11:15:00',3.23),('10318','2014-02-19','11:20:00',3.61),('10318','2014-02-19','11:25:00',3.17),('10318','2014-02-19','11:30:00',3.07),('10318','2014-02-19','11:35:00',3.19),('10318','2014-02-19','11:40:00',2.97),('10318','2014-02-19','11:45:00',3.04),('10318','2014-02-19','11:50:00',3.66),('10318','2014-02-19','11:55:00',3.72),('10318','2014-02-19','12:00:00',3.63),('10318','2014-02-19','12:05:00',3.85),('10318','2014-02-19','12:10:00',3.56),('10318','2014-02-19','12:15:00',2.64),('10318','2014-02-19','12:20:00',2.19),('10318','2014-02-19','12:25:00',2.37),('10318','2014-02-19','12:30:00',2.99),('10318','2014-02-19','12:35:00',2.67),('10318','2014-02-19','12:40:00',2.86),('10318','2014-02-19','12:45:00',2.68),('10318','2014-02-19','12:50:00',2.38),('10318','2014-02-19','12:55:00',2.09),('10318','2014-02-19','13:00:00',2.28),('10318','2014-02-19','13:05:00',2.58),('10318','2014-02-19','13:10:00',2.34),('10318','2014-02-19','13:15:00',2.66),('10318','2014-02-19','13:20:00',2.82),('10318','2014-02-19','13:25:00',3.79),('10318','2014-02-19','13:30:00',3.78),('10318','2014-02-19','13:35:00',4.19),('10318','2014-02-19','13:40:00',4.14),('10318','2014-02-19','13:45:00',5.14),('10318','2014-02-19','13:50:00',4.61),('10318','2014-02-19','13:55:00',4.61),('10318','2014-02-19','14:00:00',4.29),('10318','2014-02-19','14:05:00',3.72),('10318','2014-02-19','14:10:00',2.81),('10318','2014-02-19','14:15:00',2.89),('10318','2014-02-19','14:20:00',4.33),('10318','2014-02-19','14:25:00',2.98),('10318','2014-02-19','14:30:00',3.42),('10318','2014-02-19','14:35:00',3.54),('10318','2014-02-19','14:40:00',2.74),('10318','2014-02-19','14:45:00',2.54),('10318','2014-02-19','14:50:00',3.84),('10318','2014-02-19','14:55:00',2.74),('10318','2014-02-19','15:00:00',2.47),('10318','2014-02-19','15:05:00',2.46),('10318','2014-02-19','15:10:00',2.43),('10318','2014-02-19','15:15:00',2.85),('10318','2014-02-19','15:20:00',2.21),('10318','2014-02-19','15:25:00',2.72),('10318','2014-02-19','15:30:00',2.13),('10318','2014-02-19','15:35:00',1.9),('10318','2014-02-19','15:40:00',2.04),('10318','2014-02-19','15:45:00',2.26),('10318','2014-02-19','15:50:00',2.53),('10318','2014-02-19','15:55:00',2.06),('10318','2014-02-19','16:00:00',1.88),('10318','2014-02-19','16:05:00',1.73),('10318','2014-02-19','16:10:00',1.59),('10318','2014-02-19','16:15:00',1.51),('10318','2014-02-19','16:20:00',1.17),('10318','2014-02-18','07:40:00',1.18),('10318','2014-02-18','07:45:00',1.39),('10318','2014-02-18','07:50:00',1.6),('10318','2014-02-18','07:55:00',1.82),('10318','2014-02-18','08:00:00',1.98),('10318','2014-02-18','08:05:00',2.87),('10318','2014-02-18','08:10:00',3.44),('10318','2014-02-18','08:15:00',3.66),('10318','2014-02-18','08:20:00',3.87),('10318','2014-02-18','08:25:00',4.09),('10318','2014-02-18','08:30:00',4.29),('10318','2014-02-18','08:35:00',4.46),('10318','2014-02-18','08:40:00',4.66),('10318','2014-02-18','08:45:00',4.84),('10318','2014-02-18','08:50:00',5.01),('10318','2014-02-18','08:55:00',5.18),('10318','2014-02-18','09:00:00',5.34),('10318','2014-02-18','09:05:00',5.48),('10318','2014-02-18','09:10:00',5.66),('10318','2014-02-18','09:15:00',5.83),('10318','2014-02-18','09:20:00',5.83),('10318','2014-02-18','09:25:00',6.11),('10318','2014-02-18','09:30:00',6.27),('10318','2014-02-18','09:35:00',6.4),('10318','2014-02-18','09:40:00',6.52),('10318','2014-02-18','09:45:00',6.66),('10318','2014-02-18','09:50:00',6.78),('10318','2014-02-18','09:55:00',6.89),('10318','2014-02-18','10:00:00',6.98),('10318','2014-02-18','10:05:00',7.04),('10318','2014-02-18','10:10:00',7.09),('10318','2014-02-18','10:15:00',7.19),('10318','2014-02-18','10:20:00',7.33),('10318','2014-02-18','10:25:00',7.37),('10318','2014-02-18','10:30:00',7.39),('10318','2014-02-18','10:35:00',7.4),('10318','2014-02-18','10:40:00',7.56),('10318','2014-02-18','10:45:00',7.64),('10318','2014-02-18','10:50:00',7.73),('10318','2014-02-18','10:55:00',7.81),('10318','2014-02-18','11:00:00',7.92),('10318','2014-02-18','11:05:00',6.9),('10318','2014-02-18','11:10:00',6.83),('10318','2014-02-18','11:15:00',6.76),('10318','2014-02-18','11:20:00',7.27),('10318','2014-02-18','11:25:00',8.09),('10318','2014-02-18','11:30:00',8.06),('10318','2014-02-18','11:35:00',7.38),('10318','2014-02-18','11:40:00',4.53),('10318','2014-02-18','11:45:00',4.11),('10318','2014-02-18','11:50:00',3.93),('10318','2014-02-18','11:55:00',3.55),('10318','2014-02-18','12:00:00',3.46),('10318','2014-02-18','12:05:00',3.39),('10318','2014-02-18','12:10:00',3.84),('10318','2014-02-18','12:15:00',4.13),('10318','2014-02-18','12:20:00',4.17),('10318','2014-02-18','12:25:00',4.88),('10318','2014-02-18','12:30:00',4.78),('10318','2014-02-18','12:35:00',4.22),('10318','2014-02-18','12:40:00',3.51),('10318','2014-02-18','12:45:00',3.34),('10318','2014-02-18','12:50:00',3.55),('10318','2014-02-18','12:55:00',3.86),('10318','2014-02-18','13:00:00',3.13),('10318','2014-02-18','13:05:00',2.98),('10318','2014-02-18','13:10:00',3.1),('10318','2014-02-18','13:15:00',4.32),('10318','2014-02-18','13:20:00',4.74),('10318','2014-02-18','13:25:00',6.3),('10318','2014-02-18','13:30:00',4.38),('10318','2014-02-18','13:35:00',3.91),('10318','2014-02-18','13:40:00',4.65),('10318','2014-02-18','13:45:00',4.81),('10318','2014-02-18','13:50:00',3.99),('10318','2014-02-18','13:55:00',3.82),('10318','2014-02-18','14:00:00',4.11),('10318','2014-02-18','14:05:00',5.31),('10318','2014-02-18','14:10:00',3.7),('10318','2014-02-18','14:15:00',2.99),('10318','2014-02-18','14:20:00',2.58),('10318','2014-02-18','14:25:00',2.58),('10318','2014-02-18','14:30:00',3.11),('10318','2014-02-18','14:35:00',3.01),('10318','2014-02-18','14:40:00',2.6),('10318','2014-02-18','14:45:00',2.31),('10318','2014-02-18','14:50:00',2.21),('10318','2014-02-18','14:55:00',2.13),('10318','2014-02-18','15:00:00',1.98),('10318','2014-02-18','15:05:00',1.88),('10318','2014-02-18','15:10:00',1.86),('10318','2014-02-18','15:15:00',1.49),('10318','2014-02-18','15:20:00',1.59),('10318','2014-02-18','15:25:00',1.7),('10318','2014-02-18','15:30:00',1.43),('10318','2014-02-18','15:35:00',2.21),('10318','2014-02-18','15:40:00',2.79),('10318','2014-02-18','15:45:00',2.65),('10318','2014-02-18','15:50:00',2.26),('10318','2014-02-18','15:55:00',2.03),('10318','2014-02-18','16:00:00',2.15),('10318','2014-02-18','16:05:00',2.32),('10318','2014-02-18','16:10:00',1.91),('10318','2014-02-18','16:15:00',1.59),('10318','2014-02-18','16:20:00',1.2),('10318','2014-02-18','16:30:00',1.2),('10318','2014-02-18','16:35:00',1.36),('10318','2014-02-18','16:40:00',1.12),('10318','2014-02-18','16:45:00',1),('10318','2014-02-18','16:50:00',1.09),('10318','2014-02-17','07:40:00',1.12),('10318','2014-02-17','07:45:00',1.3),('10318','2014-02-17','07:50:00',1.49),('10318','2014-02-17','07:55:00',1.68),('10318','2014-02-17','08:00:00',1.87),('10318','2014-02-17','08:05:00',2.14),('10318','2014-02-17','08:10:00',2.78),('10318','2014-02-17','08:15:00',3.02),('10318','2014-02-17','08:20:00',3.24),('10318','2014-02-17','08:25:00',3.48),('10318','2014-02-17','08:30:00',3.65),('10318','2014-02-17','08:35:00',3.84),('10318','2014-02-17','08:40:00',4.04),('10318','2014-02-17','08:45:00',4.22),('10318','2014-02-17','08:50:00',4.33),('10318','2014-02-17','08:55:00',4.5),('10318','2014-02-17','09:00:00',4.64),('10318','2014-02-17','09:05:00',4.92),('10318','2014-02-17','09:10:00',5.12),('10318','2014-02-17','09:15:00',5.28),('10318','2014-02-17','09:20:00',5.44),('10318','2014-02-17','09:25:00',5.63),('10318','2014-02-17','09:30:00',5.8),('10318','2014-02-17','09:35:00',5.93),('10318','2014-02-17','09:40:00',6.04),('10318','2014-02-17','09:45:00',6.12),('10318','2014-02-17','09:50:00',6.22),('10318','2014-02-17','09:55:00',6.34),('10318','2014-02-17','10:00:00',6.45),('10318','2014-02-17','10:05:00',6.54),('10318','2014-02-17','10:10:00',6.61),('10318','2014-02-17','10:15:00',6.67),('10318','2014-02-17','10:20:00',6.73),('10318','2014-02-17','10:25:00',6.83),('10318','2014-02-17','10:30:00',6.9),('10318','2014-02-17','10:35:00',6.88),('10318','2014-02-17','10:40:00',6.86),('10318','2014-02-17','10:45:00',6.86),('10318','2014-02-17','10:50:00',6.96),('10318','2014-02-17','10:55:00',6.99),('10318','2014-02-17','11:00:00',7.02),('10318','2014-02-17','11:05:00',7.07),('10318','2014-02-17','11:10:00',6.99),('10318','2014-02-17','11:15:00',7.15),('10318','2014-02-17','11:20:00',7.13),('10318','2014-02-17','11:25:00',7.27),('10318','2014-02-17','11:30:00',7.43),('10318','2014-02-17','11:35:00',7.6),('10318','2014-02-17','11:40:00',7.62),('10318','2014-02-17','11:45:00',7.66),('10318','2014-02-17','11:50:00',7.61),('10318','2014-02-17','11:55:00',7.59),('10318','2014-02-17','12:00:00',7.56),('10318','2014-02-17','12:05:00',7.59),('10318','2014-02-17','12:10:00',7.52),('10318','2014-02-17','12:15:00',7.51),('10318','2014-02-17','12:20:00',7.5),('10318','2014-02-17','12:25:00',7.47),('10318','2014-02-17','12:30:00',7.44),('10318','2014-02-17','12:35:00',7.36),('10318','2014-02-17','12:40:00',7.35),('10318','2014-02-17','12:45:00',7.34),('10318','2014-02-17','12:50:00',7.26),('10318','2014-02-17','12:55:00',6.94),('10318','2014-02-17','13:00:00',7.1),('10318','2014-02-17','13:05:00',7.02),('10318','2014-02-17','13:10:00',7.02),('10318','2014-02-17','13:15:00',6.97),('10318','2014-02-17','13:20:00',6.89),('10318','2014-02-17','13:25:00',6.82),('10318','2014-02-17','13:30:00',6.79),('10318','2014-02-17','13:35:00',6.65),('10318','2014-02-17','13:40:00',6.57),('10318','2014-02-17','13:45:00',6.35),('10318','2014-02-17','13:50:00',6.3),('10318','2014-02-17','13:55:00',6.19),('10318','2014-02-17','14:00:00',6.07),('10318','2014-02-17','14:05:00',5.98),('10318','2014-02-17','14:10:00',5.78),('10318','2014-02-17','14:15:00',5.61),('10318','2014-02-17','14:20:00',5.71),('10318','2014-02-17','14:25:00',5.52),('10318','2014-02-17','14:30:00',5.24),('10318','2014-02-17','14:35:00',5.1),('10318','2014-02-17','14:40:00',4.84),('10318','2014-02-17','14:45:00',5.03),('10318','2014-02-17','14:50:00',4.94),('10318','2014-02-17','14:55:00',4.66),('10318','2014-02-17','15:00:00',4.49),('10318','2014-02-17','15:05:00',4.26),('10318','2014-02-17','15:10:00',4.11),('10318','2014-02-17','15:15:00',4.14),('10318','2014-02-17','15:20:00',4),('10318','2014-02-17','15:25:00',3.78),('10318','2014-02-17','15:30:00',3.65),('10318','2014-02-17','15:35:00',3.46),('10318','2014-02-17','15:40:00',3.18),('10318','2014-02-17','15:45:00',3.17),('10318','2014-02-17','15:50:00',2.98),('10318','2014-02-17','15:55:00',2.77),('10318','2014-02-17','16:00:00',2.57),('10318','2014-02-17','16:05:00',2.47),('10318','2014-02-17','16:10:00',2.31),('10318','2014-02-17','16:15:00',2.1),('10318','2014-02-17','16:20:00',1.94),('10318','2014-02-17','16:25:00',1.78),('10318','2014-02-17','16:30:00',1.58),('10318','2014-02-17','16:35:00',1.41),('10318','2014-02-17','16:40:00',1.24),('10318','2014-02-17','16:45:00',1.05),('10318','2014-02-16','07:40:00',1.1),('10318','2014-02-16','07:45:00',1.3),('10318','2014-02-16','07:50:00',1.48),('10318','2014-02-16','07:55:00',1.69),('10318','2014-02-16','08:00:00',1.88),('10318','2014-02-16','08:05:00',2.18),('10318','2014-02-16','08:10:00',3.2),('10318','2014-02-16','08:15:00',3.56),('10318','2014-02-16','08:20:00',3.68),('10318','2014-02-16','08:25:00',4),('10318','2014-02-16','08:30:00',4.23),('10318','2014-02-16','08:35:00',4.45),('10318','2014-02-16','08:40:00',4.19),('10318','2014-02-16','08:45:00',4.68),('10318','2014-02-16','08:50:00',4.97),('10318','2014-02-16','08:55:00',5.24),('10318','2014-02-16','09:00:00',5.56),('10318','2014-02-16','09:05:00',5.65),('10318','2014-02-16','09:10:00',5.36),('10318','2014-02-16','09:15:00',5.03),('10318','2014-02-16','09:20:00',5.63),('10318','2014-02-16','09:25:00',5.86),('10318','2014-02-16','09:30:00',5.6),('10318','2014-02-16','09:35:00',5.24),('10318','2014-02-16','09:40:00',6.36),('10318','2014-02-16','09:45:00',6.46),('10318','2014-02-16','09:50:00',6.65),('10318','2014-02-16','09:55:00',6.34),('10318','2014-02-16','10:00:00',6.51),('10318','2014-02-16','10:05:00',7.09),('10318','2014-02-16','10:10:00',6.98),('10318','2014-02-16','10:15:00',7.05),('10318','2014-02-16','10:20:00',7.2),('10318','2014-02-16','10:25:00',7.11),('10318','2014-02-16','10:30:00',7.49),('10318','2014-02-16','10:35:00',7.49),('10318','2014-02-16','10:40:00',7.76),('10318','2014-02-16','10:45:00',7.62),('10318','2014-02-16','10:50:00',6.4),('10318','2014-02-16','10:55:00',7.35),('10318','2014-02-16','11:00:00',7.84),('10318','2014-02-16','11:05:00',7.71),('10318','2014-02-16','11:10:00',7.68),('10318','2014-02-16','11:15:00',7.3),('10318','2014-02-16','11:20:00',6.8),('10318','2014-02-16','11:25:00',7.23),('10318','2014-02-16','11:30:00',7.51),('10318','2014-02-16','11:35:00',7.71),('10318','2014-02-16','11:40:00',7.48),('10318','2014-02-16','11:45:00',7.2),('10318','2014-02-16','11:50:00',7.54),('10318','2014-02-16','11:55:00',7.08),('10318','2014-02-16','12:00:00',7.89),('10318','2014-02-16','12:05:00',7.79),('10318','2014-02-16','12:10:00',7.76),('10318','2014-02-16','12:15:00',7.71),('10318','2014-02-16','12:20:00',7.65),('10318','2014-02-16','12:25:00',7.58),('10318','2014-02-16','12:30:00',7.59),('10318','2014-02-16','12:35:00',7.51),('10318','2014-02-16','12:40:00',7.5),('10318','2014-02-16','12:45:00',7.45),('10318','2014-02-16','12:50:00',7.39),('10318','2014-02-16','12:55:00',7.36),('10318','2014-02-16','13:00:00',7.2),('10318','2014-02-16','13:05:00',7.2),('10318','2014-02-16','13:10:00',6.91),('10318','2014-02-16','13:15:00',7.1),('10318','2014-02-16','13:20:00',6.93),('10318','2014-02-16','13:25:00',6.81),('10318','2014-02-16','13:30:00',6.78),('10318','2014-02-16','13:35:00',6.75),('10318','2014-02-16','13:40:00',6.56),('10318','2014-02-16','13:45:00',6.42),('10318','2014-02-16','13:50:00',6.41),('10318','2014-02-16','13:55:00',6.43),('10318','2014-02-16','14:00:00',6.39),('10318','2014-02-16','14:05:00',6.26),('10318','2014-02-16','14:10:00',6.16),('10318','2014-02-16','14:15:00',6.09),('10318','2014-02-16','14:20:00',5.99),('10318','2014-02-16','14:25:00',5.87),('10318','2014-02-16','14:30:00',5.73),('10318','2014-02-16','14:35:00',5.53),('10318','2014-02-16','14:40:00',5.33),('10318','2014-02-16','14:45:00',5.26),('10318','2014-02-16','14:50:00',5.1),('10318','2014-02-16','14:55:00',4.99),('10318','2014-02-16','15:00:00',4.36),('10318','2014-02-16','15:05:00',4.54),('10318','2014-02-16','15:10:00',4.48),('10318','2014-02-16','15:15:00',4.3),('10318','2014-02-16','15:20:00',4.12),('10318','2014-02-16','15:25:00',3.97),('10318','2014-02-16','15:30:00',3.79),('10318','2014-02-16','15:35:00',3.63),('10318','2014-02-16','15:40:00',2.55),('10318','2014-02-16','15:45:00',2.97),('10318','2014-02-16','15:50:00',2.35),('10318','2014-02-16','16:05:00',1.07),('10318','2014-02-16','16:10:00',1.92),('10318','2014-02-16','16:15:00',1.99),('10318','2014-02-16','16:20:00',2.54),('10318','2014-02-16','16:25:00',2.78),('10318','2014-02-16','16:30:00',2.51),('10318','2014-02-16','16:35:00',2.04),('10318','2014-02-16','16:40:00',1.27),('10318','2014-04-28','07:15:00',1.21),('10318','2014-04-28','07:20:00',1.08),('10318','2014-04-28','07:25:00',1.06),('10318','2014-04-28','07:30:00',1.09),('10318','2014-04-28','07:35:00',1.09),('10318','2014-04-28','07:40:00',1.21),('10318','2014-04-28','07:45:00',1.38),('10318','2014-04-28','07:50:00',1.39),('10318','2014-04-28','07:55:00',1.71),('10318','2014-04-28','08:00:00',1.65),('10318','2014-04-28','08:05:00',1.05),('10318','2014-04-28','08:10:00',4.28),('10318','2014-04-28','08:15:00',5.06),('10318','2014-04-28','08:20:00',5.56),('10318','2014-04-28','08:25:00',3.87),('10318','2014-04-28','08:30:00',2.74),('10318','2014-04-28','08:35:00',2.7),('10318','2014-04-28','08:40:00',4.29),('10318','2014-04-28','08:45:00',2.99),('10318','2014-04-28','08:50:00',2.93),('10318','2014-04-28','08:55:00',2.8),('10318','2014-04-28','09:00:00',2.92),('10318','2014-04-28','09:05:00',5.56),('10318','2014-04-28','09:10:00',6.21),('10318','2014-04-28','09:15:00',6.96),('10318','2014-04-28','09:20:00',4.42),('10318','2014-04-28','09:25:00',7.81),('10318','2014-04-28','09:30:00',4.11),('10318','2014-04-28','09:35:00',6.19),('10318','2014-04-28','09:40:00',6.65),('10318','2014-04-28','09:45:00',7.06),('10318','2014-04-28','09:50:00',6),('10318','2014-04-28','09:55:00',3.72),('10318','2014-04-28','10:00:00',4.66),('10318','2014-04-28','10:05:00',5.29),('10318','2014-04-28','10:10:00',4.58),('10318','2014-04-28','10:15:00',4.33),('10318','2014-04-28','10:20:00',2.41),('10318','2014-04-28','10:25:00',1.48),('10318','2014-04-28','10:30:00',2.17),('10318','2014-04-28','10:35:00',2.45),('10318','2014-04-28','10:40:00',3.12),('10318','2014-04-28','10:45:00',3.42),('10318','2014-04-28','10:50:00',3.35),('10318','2014-04-28','10:55:00',4.5),('10318','2014-04-28','11:00:00',6.32),('10318','2014-04-28','11:05:00',5.97),('10318','2014-04-28','11:10:00',5.63),('10318','2014-04-28','11:15:00',5.87),('10318','2014-04-28','11:20:00',3.87),('10318','2014-04-28','11:25:00',3.35),('10318','2014-04-28','11:30:00',2.88),('10318','2014-04-28','11:35:00',3.28),('10318','2014-04-28','11:40:00',3.62),('10318','2014-04-28','11:45:00',4.11),('10318','2014-04-28','11:50:00',3.99),('10318','2014-04-28','11:55:00',3.84),('10318','2014-04-28','12:00:00',4.05),('10318','2014-04-28','12:05:00',4.14),('10318','2014-04-28','12:10:00',5.17),('10318','2014-04-28','12:15:00',6.12),('10318','2014-04-28','12:20:00',5.38),('10318','2014-04-28','12:25:00',5.47),('10318','2014-04-28','12:30:00',4.78),('10318','2014-04-28','12:35:00',4.62),('10318','2014-04-28','12:40:00',4.51),('10318','2014-04-28','12:45:00',4.67),('10318','2014-04-28','12:50:00',5.02),('10318','2014-04-28','12:55:00',5.7),('10318','2014-04-28','13:00:00',8.41),('10318','2014-04-28','13:05:00',6),('10318','2014-04-28','13:10:00',4.93),('10318','2014-04-28','13:15:00',6.75),('10318','2014-04-28','13:20:00',9.09),('10318','2014-04-28','13:25:00',8.9),('10318','2014-04-28','13:30:00',10.24),('10318','2014-04-28','13:35:00',10.6),('10318','2014-04-28','13:40:00',7.14),('10318','2014-04-28','13:45:00',9.4),('10318','2014-04-28','13:50:00',4.67),('10318','2014-04-28','13:55:00',4.81),('10318','2014-04-28','14:00:00',6.11),('10318','2014-04-28','14:05:00',9.93),('10318','2014-04-28','14:10:00',8.74),('10318','2014-04-28','14:15:00',4.85),('10318','2014-04-28','14:20:00',7.65),('10318','2014-04-28','14:25:00',9.05),('10318','2014-04-28','14:30:00',6.3),('10318','2014-04-28','14:35:00',3.7),('10318','2014-04-28','14:40:00',3.28),('10318','2014-04-28','14:45:00',3),('10318','2014-04-28','14:50:00',4.88),('10318','2014-04-28','14:55:00',6.81),('10318','2014-04-28','15:00:00',3.79),('10318','2014-04-28','15:05:00',7.36),('10318','2014-04-28','15:10:00',5.28),('10318','2014-04-28','15:15:00',5.07),('10318','2014-04-28','15:20:00',5.94),('10318','2014-04-28','15:25:00',5.21),('10318','2014-04-28','15:30:00',4.77),('10318','2014-04-28','15:35:00',3.56),('10318','2014-04-28','15:40:00',3.01),('10318','2014-04-28','15:45:00',6.97),('10318','2014-04-28','15:50:00',3.95),('10318','2014-04-28','15:55:00',6.83),('10318','2014-04-28','16:00:00',6.17),('10318','2014-04-28','16:05:00',5.52),('10318','2014-04-28','16:10:00',2.28),('10318','2014-04-28','16:15:00',3.41),('10318','2014-04-28','16:20:00',3.99),('10318','2014-04-28','16:25:00',3.67),('10318','2014-04-28','16:30:00',3.73),('10318','2014-04-28','16:35:00',2.47),('10318','2014-04-28','16:40:00',1.45),('10318','2014-04-28','16:45:00',1.49),('10318','2014-04-28','16:50:00',2.95),('10318','2014-04-28','16:55:00',2.98),('10318','2014-04-28','17:00:00',1.72),('10318','2014-04-28','17:05:00',1.56),('10318','2014-04-28','17:10:00',2.02),('10318','2014-04-28','17:15:00',2.7),('10318','2014-04-28','17:20:00',2.66),('10318','2014-04-28','17:25:00',2),('10318','2014-04-28','17:30:00',2.01),('10318','2014-04-28','17:35:00',2.85),('10318','2014-04-28','17:40:00',2.4),('10318','2014-04-28','17:45:00',1.47),('10318','2014-04-28','17:50:00',1.8),('10318','2014-04-28','17:55:00',1.44),('10318','2014-04-28','18:05:00',1.56),('10318','2014-04-28','18:10:00',1.56),('10318','2014-04-28','18:15:00',1.37),('10318','2014-04-28','18:20:00',1.19),('10318','2014-04-28','18:25:00',1.21),('10318','2014-04-28','18:30:00',1.18),('10318','2014-04-28','18:35:00',1.5),('10318','2014-04-28','18:40:00',1.12),('10318','2014-02-15','07:45:00',1.23),('10318','2014-02-15','07:50:00',1.42),('10318','2014-02-15','07:55:00',1.77),('10318','2014-02-15','08:00:00',2.22),('10318','2014-02-15','08:05:00',2.5),('10318','2014-02-15','08:10:00',2.91),('10318','2014-02-15','08:15:00',3.29),('10318','2014-02-15','08:20:00',3.52),('10318','2014-02-15','08:25:00',3.71),('10318','2014-02-15','08:30:00',3.92),('10318','2014-02-15','08:35:00',4.1),('10318','2014-02-15','08:40:00',4.29),('10318','2014-02-15','08:45:00',4.51),('10318','2014-02-15','08:50:00',4.61),('10318','2014-02-15','08:55:00',4.85),('10318','2014-02-15','09:00:00',5.06),('10318','2014-02-15','09:05:00',5.24),('10318','2014-02-15','09:10:00',5.42),('10318','2014-02-15','09:15:00',5.54),('10318','2014-02-15','09:20:00',5.71),('10318','2014-02-15','09:25:00',5.81),('10318','2014-02-15','09:30:00',6),('10318','2014-02-15','09:35:00',6.13),('10318','2014-02-15','09:40:00',6.09),('10318','2014-02-15','09:45:00',6.39),('10318','2014-02-15','09:50:00',6.5),('10318','2014-02-15','09:55:00',6.61),('10318','2014-02-15','10:00:00',6.71),('10318','2014-02-15','10:05:00',6.77),('10318','2014-02-15','10:10:00',6.77),('10318','2014-02-15','10:15:00',6.85),('10318','2014-02-15','10:20:00',6.89),('10318','2014-02-15','10:25:00',6.91),('10318','2014-02-15','10:30:00',7.04),('10318','2014-02-15','10:35:00',7.06),('10318','2014-02-15','10:40:00',7.12),('10318','2014-02-15','10:45:00',7.29),('10318','2014-02-15','10:50:00',7.26),('10318','2014-02-15','10:55:00',7.45),('10318','2014-02-15','11:00:00',7.49),('10318','2014-02-15','11:05:00',7.53),('10318','2014-02-15','11:10:00',7.41),('10318','2014-02-15','11:15:00',7.69),('10318','2014-02-15','11:20:00',7.6),('10318','2014-02-15','11:25:00',7.52),('10318','2014-02-15','11:30:00',2.92),('10318','2014-02-15','11:35:00',4.99),('10318','2014-02-15','11:40:00',8.17),('10318','2014-02-15','11:45:00',3.28),('10318','2014-02-15','11:50:00',7.94),('10318','2014-02-15','11:55:00',7.63),('10318','2014-02-15','12:00:00',5.06),('10318','2014-02-15','12:05:00',2.37),('10318','2014-02-15','12:10:00',7.79),('10318','2014-02-15','12:15:00',8.34),('10318','2014-02-15','12:20:00',8.25),('10318','2014-02-15','12:25:00',8),('10318','2014-02-15','12:30:00',8.02),('10318','2014-02-15','12:35:00',7.97),('10318','2014-02-15','12:40:00',3.91),('10318','2014-02-15','12:45:00',7.7),('10318','2014-02-15','12:50:00',7.77),('10318','2014-02-15','12:55:00',7.61),('10318','2014-02-15','13:00:00',7.54),('10318','2014-02-15','13:05:00',7.01),('10318','2014-02-15','13:10:00',7.65),('10318','2014-02-15','13:15:00',5.48),('10318','2014-02-15','13:20:00',6.79),('10318','2014-02-15','13:25:00',6.91),('10318','2014-02-15','13:30:00',7.23),('10318','2014-02-15','13:35:00',7.2),('10318','2014-02-15','13:40:00',6.11),('10318','2014-02-15','13:45:00',6.96),('10318','2014-02-15','13:50:00',6.85),('10318','2014-02-15','13:55:00',6.7),('10318','2014-02-15','14:00:00',5.19),('10318','2014-02-15','14:05:00',5.96),('10318','2014-02-15','14:10:00',6.14),('10318','2014-02-15','14:15:00',6.11),('10318','2014-02-15','14:20:00',6),('10318','2014-02-15','14:25:00',5.9),('10318','2014-02-15','14:30:00',5.73),('10318','2014-02-15','14:35:00',5.48),('10318','2014-02-15','14:40:00',5.43),('10318','2014-02-15','14:45:00',5.18),('10318','2014-02-15','14:50:00',5),('10318','2014-02-15','14:55:00',4.74),('10318','2014-02-15','15:00:00',4.66),('10318','2014-02-15','15:05:00',4.52),('10318','2014-02-15','15:10:00',4.38),('10318','2014-02-15','15:15:00',4.24),('10318','2014-02-15','15:20:00',4.09),('10318','2014-02-15','15:25:00',3.9),('10318','2014-02-15','15:30:00',3.77),('10318','2014-02-15','15:35:00',3.62),('10318','2014-02-15','15:40:00',3.47),('10318','2014-02-15','15:45:00',3.29),('10318','2014-02-15','15:50:00',3.14),('10318','2014-02-15','15:55:00',2.98),('10318','2014-02-15','16:00:00',2.8),('10318','2014-02-15','16:05:00',2.64),('10318','2014-02-15','16:10:00',2.45),('10318','2014-02-15','16:15:00',2.29),('10318','2014-02-15','16:20:00',2.13),('10318','2014-02-15','16:25:00',1.97),('10318','2014-02-15','16:30:00',1.76),('10318','2014-02-15','16:35:00',1.56),('10318','2014-02-15','16:40:00',1.41),('10318','2014-02-15','16:45:00',1.23),('10318','2014-02-15','16:50:00',1.03),('10318','2014-02-14','08:35:00',1.53),('10318','2014-02-14','08:40:00',4.27),('10318','2014-02-14','08:45:00',4.7),('10318','2014-02-14','08:50:00',4.74),('10318','2014-02-14','08:55:00',4.76),('10318','2014-02-14','09:00:00',5.09),('10318','2014-02-14','09:05:00',5.22),('10318','2014-02-14','09:10:00',5.32),('10318','2014-02-14','09:15:00',4.16),('10318','2014-02-14','09:20:00',4.73),('10318','2014-02-14','09:25:00',4.17),('10318','2014-02-14','09:30:00',4.83),('10318','2014-02-14','09:35:00',3.88),('10318','2014-02-14','09:40:00',6.17),('10318','2014-02-14','09:45:00',5.9),('10318','2014-02-14','09:50:00',5.21),('10318','2014-02-14','09:55:00',7.09),('10318','2014-02-14','10:00:00',6.05),('10318','2014-02-14','10:05:00',5.86),('10318','2014-02-14','10:10:00',5.21),('10318','2014-02-14','10:15:00',7.23),('10318','2014-02-14','10:20:00',5.76),('10318','2014-02-14','10:25:00',7.75),('10318','2014-02-14','10:30:00',7.51),('10318','2014-02-14','10:35:00',7.48),('10318','2014-02-14','10:40:00',7.49),('10318','2014-02-14','10:45:00',6.78),('10318','2014-02-14','10:50:00',7.67),('10318','2014-02-14','10:55:00',8.04),('10318','2014-02-14','11:00:00',8.08),('10318','2014-02-14','11:05:00',8.08),('10318','2014-02-14','11:10:00',8.06),('10318','2014-02-14','11:15:00',8.1),('10318','2014-02-14','11:20:00',8.21),('10318','2014-02-14','11:25:00',8.22),('10318','2014-02-14','11:30:00',8.13),('10318','2014-02-14','11:35:00',8.24),('10318','2014-02-14','11:40:00',8.18),('10318','2014-02-14','11:45:00',8.26),('10318','2014-02-14','11:50:00',8.31),('10318','2014-02-14','11:55:00',7.98),('10318','2014-02-14','12:00:00',8.18),('10318','2014-02-14','12:05:00',8.15),('10318','2014-02-14','12:10:00',8.03),('10318','2014-02-14','12:15:00',8.08),('10318','2014-02-14','12:20:00',8.16),('10318','2014-02-14','12:25:00',8.05),('10318','2014-02-14','12:30:00',8.07),('10318','2014-02-14','12:35:00',7.97),('10318','2014-02-14','12:40:00',7.98),('10318','2014-02-14','12:45:00',7.87),('10318','2014-02-14','12:50:00',7.79),('10318','2014-02-14','12:55:00',7.76),('10318','2014-02-14','13:00:00',7.65),('10318','2014-02-14','13:05:00',7.66),('10318','2014-02-14','13:10:00',7.6),('10318','2014-02-14','13:15:00',7.48),('10318','2014-02-14','13:20:00',7.44),('10318','2014-02-14','13:25:00',7.38),('10318','2014-02-14','13:30:00',7.28),('10318','2014-02-14','13:35:00',7.11),('10318','2014-02-14','13:40:00',7.05),('10318','2014-02-14','13:45:00',6.84),('10318','2014-02-14','13:50:00',6.8),('10318','2014-02-14','13:55:00',6.74),('10318','2014-02-14','14:00:00',6.64),('10318','2014-02-14','14:05:00',6.45),('10318','2014-02-14','14:10:00',6.33),('10318','2014-02-14','14:15:00',6.16),('10318','2014-02-14','14:20:00',6.01),('10318','2014-02-14','14:25:00',5.87),('10318','2014-02-14','14:30:00',5.72),('10318','2014-02-14','14:35:00',5.59),('10318','2014-02-14','14:40:00',5.46),('10318','2014-02-14','14:45:00',5.26),('10318','2014-02-14','14:50:00',5.1),('10318','2014-02-14','14:55:00',4.95),('10318','2014-02-14','15:00:00',4.75),('10318','2014-02-14','15:05:00',4.56),('10318','2014-02-14','15:10:00',4.42),('10318','2014-02-14','15:15:00',4.24),('10318','2014-02-14','15:20:00',4.06),('10318','2014-02-14','15:25:00',3.92),('10318','2014-02-14','15:30:00',3.74),('10318','2014-02-14','15:35:00',3.57),('10318','2014-02-14','15:40:00',3.41),('10318','2014-02-14','15:45:00',3.18),('10318','2014-02-14','15:50:00',3.03),('10318','2014-02-14','15:55:00',2.89),('10318','2014-02-14','16:00:00',2.77),('10318','2014-02-14','16:05:00',2.62),('10318','2014-02-14','16:10:00',2.39),('10318','2014-02-14','16:15:00',2.25),('10318','2014-02-14','16:20:00',2.07),('10318','2014-02-14','16:25:00',1.88),('10318','2014-02-14','16:30:00',1.65),('10318','2014-02-14','16:35:00',1.45),('10318','2014-02-14','16:40:00',1.31),('10318','2014-02-14','16:45:00',1.14),('10318','2014-02-13','07:45:00',1.15),('10318','2014-02-13','07:50:00',1.35),('10318','2014-02-13','07:55:00',1.56),('10318','2014-02-13','08:00:00',2.18),('10318','2014-02-13','08:05:00',2.48),('10318','2014-02-13','08:10:00',2.91),('10318','2014-02-13','08:15:00',2.9),('10318','2014-02-13','08:20:00',2.41),('10318','2014-02-13','08:25:00',3.68),('10318','2014-02-13','08:30:00',3.95),('10318','2014-02-13','08:35:00',4.19),('10318','2014-02-13','08:40:00',4.38),('10318','2014-02-13','08:45:00',4.64),('10318','2014-02-13','08:50:00',4.85),('10318','2014-02-13','08:55:00',5.05),('10318','2014-02-13','09:00:00',5.22),('10318','2014-02-13','09:05:00',5.45),('10318','2014-02-13','09:10:00',5.59),('10318','2014-02-13','09:15:00',5.69),('10318','2014-02-13','09:20:00',5.91),('10318','2014-02-13','09:25:00',6.02),('10318','2014-02-13','09:30:00',6.18),('10318','2014-02-13','09:35:00',6.31),('10318','2014-02-13','09:40:00',6.4),('10318','2014-02-13','09:45:00',6.5),('10318','2014-02-13','09:50:00',6.65),('10318','2014-02-13','09:55:00',6.77),('10318','2014-02-13','10:00:00',6.85),('10318','2014-02-13','10:05:00',6.99),('10318','2014-02-13','10:10:00',7.07),('10318','2014-02-13','10:15:00',7.08),('10318','2014-02-13','10:20:00',7.13),('10318','2014-02-13','10:25:00',7.23),('10318','2014-02-13','10:30:00',7.38),('10318','2014-02-13','10:35:00',7.47),('10318','2014-02-13','10:40:00',7.51),('10318','2014-02-13','10:45:00',7.51),('10318','2014-02-13','10:50:00',7.5),('10318','2014-02-13','10:55:00',7.66),('10318','2014-02-13','11:00:00',7.5),('10318','2014-02-13','11:05:00',7.7),('10318','2014-02-13','11:10:00',5.43),('10318','2014-02-13','11:15:00',2.39),('10318','2014-02-13','11:20:00',7.76),('10318','2014-02-13','11:25:00',7.29),('10318','2014-02-13','11:30:00',3.61),('10318','2014-02-13','11:35:00',8.09),('10318','2014-02-13','11:40:00',7.22),('10318','2014-02-13','11:45:00',3.59),('10318','2014-02-13','11:50:00',3.82),('10318','2014-02-13','11:55:00',2.49),('10318','2014-02-13','12:00:00',3.18),('10318','2014-02-13','12:05:00',5.5),('10318','2014-02-13','12:10:00',3.07),('10318','2014-02-13','12:15:00',3.14),('10318','2014-02-13','12:20:00',4.98),('10318','2014-02-13','12:25:00',4.52),('10318','2014-02-13','12:30:00',6.93),('10318','2014-02-13','12:35:00',8.34),('10318','2014-02-13','12:40:00',6.25),('10318','2014-02-13','12:45:00',8.8),('10318','2014-02-13','12:50:00',8.34),('10318','2014-02-13','12:55:00',7.83),('10318','2014-02-13','13:00:00',7.89),('10318','2014-02-13','13:05:00',7.76),('10318','2014-02-13','13:10:00',7.74),('10318','2014-02-13','13:15:00',7.66),('10318','2014-02-13','13:20:00',7.5),('10318','2014-02-13','13:25:00',7.41),('10318','2014-02-13','13:30:00',7.33),('10318','2014-02-13','13:35:00',7.22),('10318','2014-02-13','13:40:00',7.11),('10318','2014-02-13','13:45:00',7.03),('10318','2014-02-13','13:50:00',6.91),('10318','2014-02-13','13:55:00',6.83),('10318','2014-02-13','14:00:00',6.61),('10318','2014-02-13','14:05:00',5.96),('10318','2014-02-13','14:10:00',5.94),('10318','2014-02-13','14:15:00',6.27),('10318','2014-02-13','14:20:00',6.23),('10318','2014-02-13','14:25:00',6),('10318','2014-02-13','14:30:00',5.84),('10318','2014-02-13','14:35:00',4.46),('10318','2014-02-13','14:40:00',5.77),('10318','2014-02-13','14:45:00',5.28),('10318','2014-02-13','14:50:00',3.49),('10318','2014-02-13','14:55:00',3.66),('10318','2014-02-13','15:00:00',1.58),('10318','2014-02-13','15:05:00',5.02),('10318','2014-02-13','15:10:00',3.35),('10318','2014-02-13','15:15:00',4.69),('10318','2014-02-13','15:20:00',4.6),('10318','2014-02-13','15:25:00',3.23),('10318','2014-02-13','15:30:00',4.24),('10318','2014-02-13','15:35:00',3.92),('10318','2014-02-13','15:40:00',3.83),('10318','2014-02-13','15:45:00',3.36),('10318','2014-02-13','15:50:00',3.5),('10318','2014-02-13','15:55:00',3.12),('10318','2014-02-13','16:00:00',2.73),('10318','2014-02-13','16:05:00',2.64),('10318','2014-02-13','16:10:00',1.48),('10318','2014-02-13','16:15:00',2.18),('10318','2014-02-13','16:20:00',1.58),('10318','2014-02-13','16:30:00',1.08),('10318','2014-02-12','08:10:00',1.04),('10318','2014-02-12','08:15:00',2.97),('10318','2014-02-12','08:20:00',3.02),('10318','2014-02-12','08:25:00',3.17),('10318','2014-02-12','08:30:00',2.92),('10318','2014-02-12','08:35:00',1),('10318','2014-02-12','08:40:00',3.48),('10318','2014-02-12','08:45:00',4.57),('10318','2014-02-12','08:50:00',4.73),('10318','2014-02-12','08:55:00',4.02),('10318','2014-02-12','09:00:00',4.39),('10318','2014-02-12','09:05:00',4.07),('10318','2014-02-12','09:10:00',5.68),('10318','2014-02-12','09:15:00',5.84),('10318','2014-02-12','09:20:00',6.07),('10318','2014-02-12','09:25:00',6.17),('10318','2014-02-12','09:30:00',4.31),('10318','2014-02-12','09:35:00',6.84),('10318','2014-02-12','09:40:00',8.02),('10318','2014-02-12','09:45:00',6.59),('10318','2014-02-12','09:50:00',8.54),('10318','2014-02-12','09:55:00',2.43),('10318','2014-02-12','10:00:00',4.04),('10318','2014-02-12','10:05:00',3.55),('10318','2014-02-12','10:10:00',2.87),('10318','2014-02-12','10:15:00',2.38),('10318','2014-02-12','10:20:00',2.63),('10318','2014-02-12','10:25:00',2.76),('10318','2014-02-12','10:30:00',3.35),('10318','2014-02-12','10:35:00',2.73),('10318','2014-02-12','10:40:00',3.24),('10318','2014-02-12','10:45:00',3.19),('10318','2014-02-12','10:50:00',3.28),('10318','2014-02-12','10:55:00',3.42),('10318','2014-02-12','11:00:00',3.17),('10318','2014-02-12','11:05:00',3.34),('10318','2014-02-12','11:10:00',3.3),('10318','2014-02-12','11:15:00',2.96),('10318','2014-02-12','11:20:00',3.11),('10318','2014-02-12','11:25:00',3.21),('10318','2014-02-12','11:30:00',3.39),('10318','2014-02-12','11:35:00',3.99),('10318','2014-02-12','11:40:00',3.5),('10318','2014-02-12','11:45:00',2.43),('10318','2014-02-12','11:50:00',2.04),('10318','2014-02-12','11:55:00',1.72),('10318','2014-02-12','12:00:00',1.81),('10318','2014-02-12','12:05:00',2.29),('10318','2014-02-12','12:10:00',2.88),('10318','2014-02-12','12:15:00',2.95),('10318','2014-02-12','12:20:00',3.05),('10318','2014-02-12','12:25:00',2.99),('10318','2014-02-12','12:30:00',3.09),('10318','2014-02-12','12:35:00',3.07),('10318','2014-02-12','12:40:00',3.12),('10318','2014-02-12','12:45:00',3.46),('10318','2014-02-12','12:50:00',3.72),('10318','2014-02-12','12:55:00',4.63),('10318','2014-02-12','13:00:00',5.72),('10318','2014-02-12','13:05:00',4.92),('10318','2014-02-12','13:10:00',3.62),('10318','2014-02-12','13:15:00',3.76),('10318','2014-02-12','13:20:00',3.39),('10318','2014-02-12','13:25:00',3.41),('10318','2014-02-12','13:30:00',3.77),('10318','2014-02-12','13:35:00',4.68),('10318','2014-02-12','13:40:00',4.07),('10318','2014-02-12','13:45:00',5.72),('10318','2014-02-12','13:50:00',5.29),('10318','2014-02-12','13:55:00',5.41),('10318','2014-02-12','14:00:00',7.42),('10318','2014-02-12','14:05:00',7.91),('10318','2014-02-12','14:10:00',5.11),('10318','2014-02-12','14:15:00',5.99),('10318','2014-02-12','14:20:00',6.98),('10318','2014-02-12','14:25:00',3.83),('10318','2014-02-12','14:30:00',4.79),('10318','2014-02-12','14:35:00',4.38),('10318','2014-02-12','14:40:00',3.6),('10318','2014-02-12','14:45:00',5.77),('10318','2014-02-12','14:50:00',5.41),('10318','2014-02-12','14:55:00',5.07),('10318','2014-02-12','15:00:00',3.21),('10318','2014-02-12','15:05:00',2.1),('10318','2014-02-12','15:10:00',2.92),('10318','2014-02-12','15:15:00',4.25),('10318','2014-02-12','15:20:00',4.54),('10318','2014-02-12','15:25:00',2.17),('10318','2014-02-12','15:30:00',2.44),('10318','2014-02-12','15:35:00',3.58),('10318','2014-02-12','15:40:00',4.5),('10318','2014-02-12','15:45:00',3.12),('10318','2014-02-12','15:50:00',2.5),('10318','2014-02-12','15:55:00',2.49),('10318','2014-02-12','16:00:00',2.15),('10318','2014-02-12','16:05:00',2.96),('10318','2014-02-12','16:10:00',1.79),('10318','2014-02-11','08:45:00',1.04),('10318','2014-02-11','08:50:00',1.17),('10318','2014-02-11','08:55:00',1.33),('10318','2014-02-11','09:00:00',1.54),('10318','2014-02-11','09:05:00',1.56),('10318','2014-02-11','09:10:00',1.59),('10318','2014-02-11','09:15:00',1.96),('10318','2014-02-11','09:20:00',2.83),('10318','2014-02-11','09:25:00',3.26),('10318','2014-02-11','09:30:00',3.02),('10318','2014-02-11','09:35:00',3.11),('10318','2014-02-11','09:40:00',2.82),('10318','2014-02-11','09:45:00',2.95),('10318','2014-02-11','09:50:00',2.97),('10318','2014-02-11','09:55:00',2.8),('10318','2014-02-11','10:00:00',2.53),('10318','2014-02-11','10:05:00',2.79),('10318','2014-02-11','10:10:00',3.08),('10318','2014-02-11','10:15:00',3.61),('10318','2014-02-11','10:20:00',4.73),('10318','2014-02-11','10:25:00',5.26),('10318','2014-02-11','10:30:00',5.67),('10318','2014-02-11','10:35:00',5.6),('10318','2014-02-11','10:40:00',4.91),('10318','2014-02-11','10:45:00',5.3),('10318','2014-02-11','10:50:00',5.65),('10318','2014-02-11','10:55:00',5.21),('10318','2014-02-11','11:00:00',5.38),('10318','2014-02-11','11:05:00',5.88),('10318','2014-02-11','11:10:00',5.83),('10318','2014-02-11','11:15:00',6.25),('10318','2014-02-11','11:20:00',5.78),('10318','2014-02-11','11:25:00',5.24),('10318','2014-02-11','11:30:00',4.95),('10318','2014-02-11','11:35:00',5.74),('10318','2014-02-11','11:40:00',5.67),('10318','2014-02-11','11:45:00',4.1),('10318','2014-02-11','11:50:00',5.03),('10318','2014-02-11','11:55:00',4.34),('10318','2014-02-11','12:00:00',3.4),('10318','2014-02-11','12:05:00',3.97),('10318','2014-02-11','12:10:00',4.78),('10318','2014-02-11','12:15:00',4.52),('10318','2014-02-11','12:20:00',3.96),('10318','2014-02-11','12:25:00',4.99),('10318','2014-02-11','12:30:00',5.06),('10318','2014-02-11','12:35:00',4.91),('10318','2014-02-11','12:40:00',3.39),('10318','2014-02-11','12:45:00',4.14),('10318','2014-02-11','12:50:00',3.14),('10318','2014-02-11','12:55:00',3.62),('10318','2014-02-11','13:00:00',4.11),('10318','2014-02-11','13:05:00',5.3),('10318','2014-02-11','13:10:00',7.38),('10318','2014-02-11','13:15:00',7.14),('10318','2014-02-11','13:20:00',7.33),('10318','2014-02-11','13:25:00',6.06),('10318','2014-02-11','13:30:00',5.68),('10318','2014-02-11','13:35:00',5.82),('10318','2014-02-11','13:40:00',5.91),('10318','2014-02-11','13:45:00',5.57),('10318','2014-02-11','13:50:00',3.46),('10318','2014-02-11','13:55:00',3.24),('10318','2014-02-11','14:00:00',3.54),('10318','2014-02-11','14:05:00',4.9),('10318','2014-02-11','14:10:00',3.18),('10318','2014-02-11','14:15:00',4.46),('10318','2014-02-11','14:20:00',3.83),('10318','2014-02-11','14:25:00',4.06),('10318','2014-02-11','14:30:00',3.41),('10318','2014-02-11','14:35:00',2.8),('10318','2014-02-11','14:40:00',2.47),('10318','2014-02-11','14:45:00',2.35),('10318','2014-02-11','14:50:00',2.03),('10318','2014-02-11','14:55:00',1.97),('10318','2014-02-11','15:00:00',2.01),('10318','2014-02-11','15:05:00',2.13),('10318','2014-02-11','15:10:00',2.28),('10318','2014-02-11','15:15:00',2.77),('10318','2014-02-11','15:20:00',2.92),('10318','2014-02-11','15:25:00',2.56),('10318','2014-02-11','15:30:00',1.83),('10318','2014-02-11','15:35:00',1.87),('10318','2014-02-11','15:40:00',1.7),('10318','2014-02-11','15:45:00',1.44),('10318','2014-02-11','15:50:00',1.32),('10318','2014-02-11','15:55:00',1.33),('10318','2014-02-11','16:00:00',1.41),('10318','2014-02-11','16:05:00',1.84),('10318','2014-02-11','16:10:00',2.28),('10318','2014-02-11','16:15:00',2.08),('10318','2014-02-11','16:20:00',1.88),('10318','2014-02-11','16:25:00',1.96),('10318','2014-02-11','16:30:00',1.82),('10318','2014-02-11','16:35:00',1.65),('10318','2014-02-11','16:40:00',1.45),('10318','2014-02-11','16:45:00',1.17),('10318','2014-02-10','15:25:00',1.78),('10318','2014-02-10','15:30:00',1.66),('10318','2014-02-10','15:35:00',1.36),('10318','2014-02-10','15:40:00',1.05),('10318','2014-02-10','15:45:00',1.02),('10318','2014-02-10','15:50:00',1.05),('10318','2014-04-27','07:35:00',1.15),('10318','2014-04-27','08:10:00',1.2),('10318','2014-04-27','08:15:00',1.07),('10318','2014-04-27','08:20:00',1.13),('10318','2014-04-27','08:25:00',1.24),('10318','2014-04-27','08:30:00',1.01),('10318','2014-04-27','08:40:00',1.29),('10318','2014-04-27','08:45:00',2.01),('10318','2014-04-27','08:50:00',2.74),('10318','2014-04-27','08:55:00',1.68),('10318','2014-04-27','09:00:00',1.34),('10318','2014-04-27','09:05:00',2.05),('10318','2014-04-27','09:10:00',2.31),('10318','2014-04-27','09:15:00',2.41),('10318','2014-04-27','09:20:00',1.92),('10318','2014-04-27','09:25:00',1.36),('10318','2014-04-27','09:30:00',1.42),('10318','2014-04-27','09:35:00',1.06),('10318','2014-04-27','09:45:00',1.01),('10318','2014-04-27','09:50:00',1.18),('10318','2014-04-27','09:55:00',1.44),('10318','2014-04-27','10:00:00',1.85),('10318','2014-04-27','10:05:00',2.3),('10318','2014-04-27','10:10:00',2.69),('10318','2014-04-27','10:15:00',3.25),('10318','2014-04-27','10:20:00',3.97),('10318','2014-04-27','10:25:00',2.6),('10318','2014-04-27','10:30:00',2.56),('10318','2014-04-27','10:35:00',1.06),('10318','2014-04-27','10:45:00',1.02),('10318','2014-04-27','10:50:00',1.22),('10318','2014-04-27','10:55:00',1.76),('10318','2014-04-27','11:00:00',2),('10318','2014-04-27','11:05:00',1.29),('10318','2014-04-27','11:10:00',1.21),('10318','2014-04-27','11:15:00',1.19),('10318','2014-04-27','11:30:00',1.77),('10318','2014-04-27','11:35:00',2.56),('10318','2014-04-27','11:40:00',4.73),('10318','2014-04-27','11:45:00',7.17),('10318','2014-04-27','11:50:00',9.48),('10318','2014-04-27','11:55:00',5.94),('10318','2014-04-27','12:00:00',5.27),('10318','2014-04-27','12:05:00',5.87),('10318','2014-04-27','12:10:00',6.3),('10318','2014-04-27','12:15:00',6.64),('10318','2014-04-27','12:20:00',5.66),('10318','2014-04-27','12:25:00',5.96),('10318','2014-04-27','12:30:00',6.24),('10318','2014-04-27','12:35:00',6.5),('10318','2014-04-27','12:40:00',6.11),('10318','2014-04-27','12:45:00',4.99),('10318','2014-04-27','12:50:00',4.11),('10318','2014-04-27','12:55:00',4.64),('10318','2014-04-27','13:00:00',5.06),('10318','2014-04-27','13:05:00',4.4),('10318','2014-04-27','13:10:00',4.29),('10318','2014-04-27','13:15:00',4.76),('10318','2014-04-27','13:20:00',5.29),('10318','2014-04-27','13:25:00',4.87),('10318','2014-04-27','13:30:00',4.42),('10318','2014-04-27','13:35:00',3.62),('10318','2014-04-27','13:40:00',3.55),('10318','2014-04-27','13:45:00',3.9),('10318','2014-04-27','13:50:00',3.94),('10318','2014-04-27','13:55:00',3.94),('10318','2014-04-27','14:00:00',5.9),('10318','2014-04-27','14:05:00',4.94),('10318','2014-04-27','14:10:00',3.43),('10318','2014-04-27','14:15:00',3.73),('10318','2014-04-27','14:20:00',4.02),('10318','2014-04-27','14:25:00',4.59),('10318','2014-04-27','14:30:00',4.97),('10318','2014-04-27','14:35:00',5.38),('10318','2014-04-27','14:40:00',5.77),('10318','2014-04-27','14:45:00',4.81),('10318','2014-04-27','14:50:00',4.3),('10318','2014-04-27','14:55:00',4.44),('10318','2014-04-27','15:00:00',5.09),('10318','2014-04-27','15:05:00',7.14),('10318','2014-04-27','15:10:00',7.24),('10318','2014-04-27','15:15:00',5.39),('10318','2014-04-27','15:20:00',3.55),('10318','2014-04-27','15:25:00',2.33),('10318','2014-04-27','15:30:00',2.07),('10318','2014-04-27','15:35:00',2.4),('10318','2014-04-27','15:40:00',2.45),('10318','2014-04-27','15:45:00',1.76),('10318','2014-04-27','15:50:00',1.67),('10318','2014-04-27','15:55:00',1.46),('11288','2014-05-05','07:45:00',1.05),('11288','2014-05-05','07:50:00',1.14),('11288','2014-05-05','07:55:00',1.3),('11288','2014-05-05','08:00:00',1.63),('11288','2014-05-05','08:05:00',1.77),('11288','2014-05-05','08:10:00',1.95),('11288','2014-05-05','08:15:00',2.14),('11288','2014-05-05','08:20:00',2.24),('11288','2014-05-05','08:25:00',2.45),('11288','2014-05-05','08:30:00',2.72),('11288','2014-05-05','08:35:00',2.8),('11288','2014-05-05','08:40:00',3.03),('11288','2014-05-05','08:45:00',3.12),('11288','2014-05-05','08:50:00',3.28),('11288','2014-05-05','08:55:00',3.38),('11288','2014-05-05','09:00:00',3.66),('11288','2014-05-05','09:05:00',3.81),('11288','2014-05-05','09:10:00',3.95),('11288','2014-05-05','09:15:00',4.19),('11288','2014-05-05','09:20:00',4.21),('11288','2014-05-05','09:25:00',4.25),('11288','2014-05-05','09:30:00',4.61),('11288','2014-05-05','09:35:00',4.69),('11288','2014-05-05','09:40:00',4.92),('11288','2014-05-05','09:45:00',5.01),('11288','2014-05-05','09:50:00',5.2),('11288','2014-05-05','09:55:00',5.33),('11288','2014-05-05','10:00:00',5.46),('11288','2014-05-05','10:05:00',5.59),('11288','2014-05-05','10:10:00',5.7),('11288','2014-05-05','10:15:00',5.75),('11288','2014-05-05','10:20:00',5.8),('11288','2014-05-05','10:25:00',5.9),('11288','2014-05-05','10:30:00',5.99),('11288','2014-05-05','10:35:00',6.12),('11288','2014-05-05','10:40:00',6.17),('11288','2014-05-05','10:45:00',6.25),('11288','2014-05-05','10:50:00',6.28),('11288','2014-05-05','10:55:00',6.32),('11288','2014-05-05','11:00:00',6.45),('11288','2014-05-05','11:05:00',6.53),('11288','2014-05-05','11:10:00',6.57),('11288','2014-05-05','11:15:00',6.71),('11288','2014-05-05','11:20:00',6.67),('11288','2014-05-05','11:25:00',6.74),('11288','2014-05-05','11:30:00',6.76),('11288','2014-05-05','11:35:00',6.78),('11288','2014-05-05','11:40:00',6.82),('11288','2014-05-05','11:45:00',6.92),('11288','2014-05-05','11:50:00',7.01),('11288','2014-05-05','11:55:00',6.62),('11288','2014-05-05','12:00:00',7.24),('11288','2014-05-05','12:05:00',5.2),('11288','2014-05-05','12:10:00',2.9),('11288','2014-05-05','12:15:00',3.61),('11288','2014-05-05','12:20:00',3.65),('11288','2014-05-05','12:25:00',2.95),('11288','2014-05-05','12:30:00',6.62),('11288','2014-05-05','12:35:00',5.39),('11288','2014-05-05','12:40:00',2.62),('11288','2014-05-05','12:45:00',5.15),('11288','2014-05-05','12:50:00',7.24),('11288','2014-05-05','12:55:00',3.6),('11288','2014-05-05','13:00:00',2.18),('11288','2014-05-05','13:05:00',3.81),('11288','2014-05-05','13:10:00',8.11),('11288','2014-05-05','13:15:00',7.71),('11288','2014-05-05','13:20:00',7.43),('11288','2014-05-05','13:25:00',7.29),('11288','2014-05-05','13:30:00',7.3),('11288','2014-05-05','13:35:00',7.36),('11288','2014-05-05','13:40:00',7.3),('11288','2014-05-05','13:45:00',6.56),('11288','2014-05-05','13:50:00',7.36),('11288','2014-05-05','13:55:00',7.32),('11288','2014-05-05','14:00:00',6.84),('11288','2014-05-05','14:05:00',5.69),('11288','2014-05-05','14:10:00',3.55),('11288','2014-05-05','14:15:00',7.9),('11288','2014-05-05','14:20:00',7.49),('11288','2014-05-05','14:25:00',6.2),('11288','2014-05-05','14:30:00',6.82),('11288','2014-05-05','14:35:00',4.53),('11288','2014-05-05','14:40:00',4.89),('11288','2014-05-05','14:45:00',3.15),('11288','2014-05-05','14:50:00',2.5),('11288','2014-05-05','14:55:00',2.89),('11288','2014-05-05','15:00:00',4.99),('11288','2014-05-05','15:05:00',7.47),('11288','2014-05-05','15:10:00',5.45),('11288','2014-05-05','15:15:00',2.34),('11288','2014-05-05','15:20:00',2.35),('11288','2014-05-05','15:25:00',3.57),('11288','2014-05-05','15:30:00',4.97),('11288','2014-05-05','15:35:00',2.22),('11288','2014-05-05','15:40:00',7.01),('11288','2014-05-05','15:45:00',5.76),('11288','2014-05-05','15:50:00',2.21),('11288','2014-05-05','15:55:00',2.05),('11288','2014-05-05','16:00:00',3.39),('11288','2014-05-05','16:05:00',4.08),('11288','2014-05-05','16:10:00',4.28),('11288','2014-05-05','16:15:00',2.28),('11288','2014-05-05','16:20:00',3.16),('11288','2014-05-05','16:25:00',2.56),('11288','2014-05-05','16:30:00',2.6),('11288','2014-05-05','16:35:00',5.56),('11288','2014-05-05','16:40:00',5.31),('11288','2014-05-05','16:45:00',4.71),('11288','2014-05-05','16:50:00',4.82),('11288','2014-05-05','16:55:00',4.53),('11288','2014-05-05','17:00:00',4.22),('11288','2014-05-05','17:05:00',4.03),('11288','2014-05-05','17:10:00',4.05),('11288','2014-05-05','17:15:00',3.83),('11288','2014-05-05','17:20:00',3.66),('11288','2014-05-05','17:25:00',3.48),('11288','2014-05-05','17:30:00',3.26),('11288','2014-05-05','17:35:00',3.08),('11288','2014-05-05','17:40:00',2.95),('11288','2014-05-05','17:45:00',2.72),('11288','2014-05-05','17:50:00',2.61),('11288','2014-05-05','17:55:00',2.47),('11288','2014-05-05','18:00:00',2.3),('11288','2014-05-05','18:05:00',2.23),('11288','2014-05-05','18:10:00',2.19),('11288','2014-05-05','18:15:00',2.05),('11288','2014-05-05','18:20:00',1.89),('11288','2014-05-05','18:25:00',1.7),('11288','2014-05-05','18:30:00',1.59),('11288','2014-05-05','18:35:00',1.47),('11288','2014-05-05','18:40:00',1.32),('11288','2014-05-05','18:45:00',1.15),('11288','2014-05-05','18:50:00',1.02),('11288','2014-04-26','08:00:00',1.04),('11288','2014-04-26','08:05:00',1.12),('11288','2014-04-26','08:10:00',1.21),('11288','2014-04-26','08:15:00',1.21),('11288','2014-04-26','08:20:00',1.24),('11288','2014-04-26','08:25:00',1.29),('11288','2014-04-26','08:30:00',1.19),('11288','2014-04-26','08:35:00',1.27),('11288','2014-04-26','08:40:00',1.45),('11288','2014-04-26','08:45:00',1.56),('11288','2014-04-26','08:50:00',1.62),('11288','2014-04-26','08:55:00',1.61),('11288','2014-04-26','09:00:00',1.62),('11288','2014-04-26','09:05:00',1.8),('11288','2014-04-26','09:10:00',1.6),('11288','2014-04-26','09:15:00',1.42),('11288','2014-04-26','09:20:00',1.43),('11288','2014-04-26','09:25:00',1.47),('11288','2014-04-26','09:30:00',1.46),('11288','2014-04-26','09:35:00',1.55),('11288','2014-04-26','09:40:00',1.69),('11288','2014-04-26','09:45:00',1.51),('11288','2014-04-26','09:50:00',1.66),('11288','2014-04-26','09:55:00',2.45),('11288','2014-04-26','10:00:00',2.57),('11288','2014-04-26','10:05:00',2.31),('11288','2014-04-26','10:10:00',2.21),('11288','2014-04-26','10:15:00',2.34),('11288','2014-04-26','10:20:00',2.61),('11288','2014-04-26','10:25:00',2.89),('11288','2014-04-26','10:30:00',3.38),('11288','2014-04-26','10:35:00',3.59),('11288','2014-04-26','10:40:00',3.46),('11288','2014-04-26','10:45:00',3.56),('11288','2014-04-26','10:50:00',4.44),('11288','2014-04-26','10:55:00',6.05),('11288','2014-04-26','11:00:00',6.05),('11288','2014-04-26','11:05:00',5.78),('11288','2014-04-26','11:10:00',5.47),('11288','2014-04-26','11:15:00',5.21),('11288','2014-04-26','11:20:00',5.15),('11288','2014-04-26','11:25:00',4.94),('11288','2014-04-26','11:30:00',5.17),('11288','2014-04-26','11:35:00',5.16),('11288','2014-04-26','11:40:00',4.97),('11288','2014-04-26','11:45:00',5.2),('11288','2014-04-26','11:50:00',5.13),('11288','2014-04-26','11:55:00',4.96),('11288','2014-04-26','12:00:00',5.13),('11288','2014-04-26','12:05:00',5.53),('11288','2014-04-26','12:10:00',5.76),('11288','2014-04-26','12:15:00',3.91),('11288','2014-04-26','12:20:00',5.01),('11288','2014-04-26','12:25:00',5.14),('11288','2014-04-26','12:30:00',3.69),('11288','2014-04-26','12:35:00',6.37),('11288','2014-04-26','12:40:00',5.92),('11288','2014-04-26','12:45:00',6.69),('11288','2014-04-26','12:50:00',6.75),('11288','2014-04-26','12:55:00',7.07),('11288','2014-04-26','13:00:00',6.22),('11288','2014-04-26','13:05:00',5.09),('11288','2014-04-26','13:10:00',5.29),('11288','2014-04-26','13:15:00',6.98),('11288','2014-04-26','13:20:00',7.53),('11288','2014-04-26','13:25:00',6.99),('11288','2014-04-26','13:30:00',2.54),('11288','2014-04-26','13:35:00',3.02),('11288','2014-04-26','13:40:00',7.52),('11288','2014-04-26','13:45:00',7.2),('11288','2014-04-26','13:50:00',6.97),('11288','2014-04-26','13:55:00',6.97),('11288','2014-04-26','14:00:00',5.79),('11288','2014-04-26','14:05:00',1.32),('11288','2014-04-26','14:10:00',2.68),('11288','2014-04-26','14:15:00',3.32),('11288','2014-04-26','14:25:00',1.44),('11288','2014-04-26','14:30:00',1.58),('11288','2014-04-26','14:35:00',2.69),('11288','2014-04-26','14:40:00',4.24),('11288','2014-04-26','14:45:00',1.57),('11288','2014-04-26','17:40:00',1.16),('11288','2014-04-26','17:45:00',1.53),('11288','2014-04-26','17:50:00',1.64),('11288','2014-04-26','17:55:00',1.52),('11288','2014-04-26','18:30:00',1.06),('11288','2014-04-26','18:35:00',1.29),('11288','2014-04-26','18:40:00',1.54),('11288','2014-04-26','18:45:00',1.69),('11288','2014-04-26','18:50:00',1.3),('11288','2014-01-26','08:55:00',1.04),('11288','2014-01-26','09:00:00',1.48),('11288','2014-01-26','09:05:00',1.85),('11288','2014-01-26','09:10:00',1.28),('11288','2014-01-26','09:15:00',1.01),('11288','2014-01-26','09:25:00',1.37),('11288','2014-01-26','09:30:00',2.21),('11288','2014-01-26','09:35:00',2.32),('11288','2014-01-26','09:40:00',1.41),('11288','2014-01-26','09:45:00',1.94),('11288','2014-01-26','09:50:00',2.28),('11288','2014-01-26','09:55:00',1.78),('11288','2014-01-26','10:00:00',1.37),('11288','2014-01-26','10:05:00',1.44),('11288','2014-01-26','10:10:00',2.75),('11288','2014-01-26','10:15:00',3.13),('11288','2014-01-26','10:20:00',1.95),('11288','2014-01-26','10:25:00',1.79),('11288','2014-01-26','10:30:00',1.68),('11288','2014-01-26','10:35:00',1.41),('11288','2014-01-26','10:40:00',1.24),('11288','2014-01-26','10:45:00',1.31),('11288','2014-01-26','10:50:00',1.47),('11288','2014-01-26','10:55:00',1.64),('11288','2014-01-26','11:00:00',1.51),('11288','2014-01-26','11:05:00',1.58),('11288','2014-01-26','11:10:00',1.35),('11288','2014-01-26','11:15:00',1.32),('11288','2014-01-26','11:20:00',1.37),('11288','2014-01-26','11:25:00',1.95),('11288','2014-01-26','11:30:00',1.58),('11288','2014-01-26','11:35:00',1.38),('11288','2014-01-26','11:40:00',1.36),('11288','2014-01-26','11:45:00',1.19),('11288','2014-01-26','11:50:00',1.02),('11288','2014-01-26','11:55:00',1.06),('11288','2014-01-26','12:00:00',1.06),('11288','2014-01-26','12:05:00',1.19),('11288','2014-01-26','12:10:00',1.56),('11288','2014-01-26','12:15:00',2.08),('11288','2014-01-26','12:20:00',2.19),('11288','2014-01-26','12:25:00',2.36),('11288','2014-01-26','12:30:00',3.89),('11288','2014-01-26','12:35:00',2.96),('11288','2014-01-26','12:40:00',2.21),('11288','2014-01-26','12:45:00',1.96),('11288','2014-01-26','12:50:00',1.74),('11288','2014-01-26','12:55:00',1.67),('11288','2014-01-26','13:00:00',1.81),('11288','2014-01-26','13:05:00',2.04),('11288','2014-01-26','13:10:00',2.25),('11288','2014-01-26','13:15:00',2.42),('11288','2014-01-26','13:20:00',2.52),('11288','2014-01-26','13:25:00',2.09),('11288','2014-01-26','13:30:00',1.61),('11288','2014-01-26','13:35:00',1.34),('11288','2014-01-26','13:40:00',1.18),('11288','2014-01-26','13:45:00',1.26),('11288','2014-01-26','13:50:00',1.65),('11288','2014-01-26','13:55:00',1.16),('11288','2014-01-26','14:05:00',1.04),('11288','2014-01-26','14:10:00',1.23),('11288','2014-01-26','14:15:00',1.2),('11288','2014-01-26','15:20:00',1),('11288','2014-01-26','15:25:00',1.41),('11288','2014-01-26','15:45:00',1.5),('11288','2014-01-25','09:00:00',1.1),('11288','2014-01-25','09:05:00',1.7),('11288','2014-01-25','09:10:00',2.03),('11288','2014-01-25','09:15:00',1.44),('11288','2014-01-25','09:20:00',1.72),('11288','2014-01-25','09:25:00',1.12),('11288','2014-01-25','09:40:00',1.1),('11288','2014-01-25','09:45:00',1.43),('11288','2014-01-25','09:50:00',2.22),('11288','2014-01-25','09:55:00',2.83),('11288','2014-01-25','10:00:00',2.06),('11288','2014-01-25','10:05:00',3),('11288','2014-01-25','10:10:00',3.58),('11288','2014-01-25','10:15:00',3.93),('11288','2014-01-25','10:20:00',3.93),('11288','2014-01-25','10:25:00',2.72),('11288','2014-01-25','10:30:00',2.57),('11288','2014-01-25','10:35:00',2.25),('11288','2014-01-25','10:40:00',2.94),('11288','2014-01-25','10:45:00',2.33),('11288','2014-01-25','10:50:00',2.78),('11288','2014-01-25','10:55:00',2.9),('11288','2014-01-25','11:00:00',2.1),('11288','2014-01-25','11:05:00',2),('11288','2014-01-25','11:10:00',1.84),('11288','2014-01-25','11:15:00',2.11),('11288','2014-01-25','11:20:00',1.96),('11288','2014-01-25','11:25:00',2.26),('11288','2014-01-25','11:30:00',4.7),('11288','2014-01-25','11:35:00',5.11),('11288','2014-01-25','11:40:00',3.03),('11288','2014-01-25','11:45:00',2.38),('11288','2014-01-25','11:50:00',2.7),('11288','2014-01-25','11:55:00',2.8),('11288','2014-01-25','12:00:00',2.73),('11288','2014-01-25','12:05:00',2.9),('11288','2014-01-25','12:10:00',3.07),('11288','2014-01-25','12:15:00',2.94),('11288','2014-01-25','12:20:00',3.06),('11288','2014-01-25','12:25:00',3.26),('11288','2014-01-25','12:30:00',3.16),('11288','2014-01-25','12:35:00',2.82),('11288','2014-01-25','12:40:00',2.97),('11288','2014-01-25','12:45:00',3.41),('11288','2014-01-25','12:50:00',3.39),('11288','2014-01-25','12:55:00',3.9),('11288','2014-01-25','13:00:00',4.03),('11288','2014-01-25','13:05:00',3.86),('11288','2014-01-25','13:10:00',4.32),('11288','2014-01-25','13:15:00',3.44),('11288','2014-01-25','13:20:00',1.88),('11288','2014-01-25','13:25:00',2.4),('11288','2014-01-25','13:30:00',2.17),('11288','2014-01-25','13:35:00',2.45),('11288','2014-01-25','13:40:00',1.69),('11288','2014-01-25','13:45:00',2.03),('11288','2014-01-25','13:50:00',2.24),('11288','2014-01-25','13:55:00',1.32),('11288','2014-01-25','14:00:00',1.67),('11288','2014-01-25','14:05:00',1.93),('11288','2014-01-25','14:10:00',3.23),('11288','2014-01-25','14:15:00',1.75),('11288','2014-01-25','14:20:00',3.12),('11288','2014-01-25','14:25:00',3.41),('11288','2014-01-25','14:30:00',3.77),('11288','2014-01-25','14:35:00',4),('11288','2014-01-25','14:40:00',3.71),('11288','2014-01-25','14:45:00',3.64),('11288','2014-01-25','14:50:00',3.35),('11288','2014-01-25','14:55:00',3.03),('11288','2014-01-25','15:00:00',2.63),('11288','2014-01-25','15:05:00',2.37),('11288','2014-01-25','15:10:00',2.23),('11288','2014-01-25','15:15:00',2.1),('11288','2014-01-25','15:20:00',1.93),('11288','2014-01-25','15:25:00',1.8),('11288','2014-01-25','15:30:00',1.67),('11288','2014-01-25','15:35:00',1.52),('11288','2014-01-25','15:40:00',1.38),('11288','2014-01-25','15:45:00',1.26),('11288','2014-01-25','15:50:00',1.06),('11288','2014-01-24','10:05:00',1.63),('11288','2014-01-24','10:10:00',1.73),('11288','2014-01-24','10:15:00',2.32),('11288','2014-01-24','10:20:00',1.28),('11288','2014-01-24','10:25:00',1.49),('11288','2014-01-24','10:30:00',2.26),('11288','2014-01-24','10:35:00',2.28),('11288','2014-01-24','10:40:00',3.09),('11288','2014-01-24','10:45:00',2.76),('11288','2014-01-24','10:50:00',1.91),('11288','2014-01-24','10:55:00',1.82),('11288','2014-01-24','11:00:00',1.87),('11288','2014-01-24','11:05:00',1.29),('11288','2014-01-24','11:20:00',1.39),('11288','2014-01-24','11:25:00',2.1),('11288','2014-01-24','11:30:00',2.52),('11288','2014-01-24','11:35:00',2.18),('11288','2014-01-24','11:40:00',1.06),('11288','2014-01-24','11:45:00',3.09),('11288','2014-01-24','11:50:00',4.8),('11288','2014-01-24','11:55:00',4.85),('11288','2014-01-24','12:00:00',2.95),('11288','2014-01-24','12:05:00',2.19),('11288','2014-01-24','12:10:00',1.58),('11288','2014-01-24','12:15:00',1.13),('11288','2014-01-24','12:20:00',1.65),('11288','2014-01-24','12:25:00',2.86),('11288','2014-01-24','12:30:00',2.13),('11288','2014-01-24','12:35:00',4.32),('11288','2014-01-24','12:40:00',3.74),('11288','2014-01-24','12:45:00',2.6),('11288','2014-01-24','12:50:00',1.98),('11288','2014-01-24','12:55:00',2.53),('11288','2014-01-24','13:00:00',2.95),('11288','2014-01-24','13:05:00',3.27),('11288','2014-01-24','13:10:00',2.22),('11288','2014-01-24','13:15:00',1.81),('11288','2014-01-24','13:20:00',1.34),('11288','2014-01-24','13:25:00',1.35),('11288','2014-01-24','13:30:00',2.28),('11288','2014-01-24','13:35:00',2.75),('11288','2014-01-24','13:40:00',2.42),('11288','2014-01-24','13:45:00',2.44),('11288','2014-01-24','13:50:00',2.57),('11288','2014-01-24','13:55:00',2.73),('11288','2014-01-24','14:00:00',2.35),('11288','2014-01-24','14:05:00',1.43),('11288','2014-01-24','14:10:00',4.16),('11288','2014-01-24','14:15:00',3.09),('11288','2014-01-24','14:20:00',2.9),('11288','2014-01-24','14:25:00',2.54),('11288','2014-01-24','14:35:00',1.19),('11288','2014-01-24','14:40:00',1.26),('11288','2014-01-24','14:45:00',1.7),('11288','2014-01-23','10:10:00',1.02),('11288','2014-01-23','10:15:00',1.21),('11288','2014-01-23','10:20:00',1.24),('11288','2014-01-23','10:25:00',1.24),('11288','2014-01-23','10:30:00',1),('11288','2014-01-23','10:40:00',1.01),('11288','2014-01-23','10:45:00',1.08),('11288','2014-01-23','10:50:00',1.35),('11288','2014-01-23','10:55:00',1.6),('11288','2014-01-23','11:00:00',1.88),('11288','2014-01-23','11:05:00',1.86),('11288','2014-01-23','11:10:00',1.83),('11288','2014-01-23','11:15:00',1.84),('11288','2014-01-23','11:20:00',1.77),('11288','2014-01-23','11:25:00',1.56),('11288','2014-01-23','11:30:00',1.14),('11288','2014-01-23','12:05:00',1.23),('11288','2014-01-23','12:10:00',1.54),('11288','2014-01-23','12:15:00',1.01),('11288','2014-01-23','12:25:00',1.33),('11288','2014-01-23','12:30:00',1.86),('11288','2014-01-23','12:35:00',1.54),('11288','2014-01-23','12:40:00',1.01),('11288','2014-01-23','14:00:00',1),('11288','2014-01-23','14:05:00',1.26),('11288','2014-01-23','14:10:00',1.39),('11288','2014-01-23','14:15:00',1.45),('11288','2014-01-23','14:20:00',1.24),('11288','2014-01-23','14:25:00',1.06),('11288','2014-01-22','10:10:00',1.04),('11288','2014-01-22','10:15:00',1.68),('11288','2014-01-22','10:20:00',1.13),('11288','2014-01-22','10:40:00',1.05),('11288','2014-01-22','10:45:00',1.37),('11288','2014-01-22','10:50:00',1.33),('11288','2014-01-22','10:55:00',1.34),('11288','2014-01-22','11:00:00',1.57),('11288','2014-01-22','11:05:00',1.75),('11288','2014-01-22','11:10:00',1.82),('11288','2014-01-22','11:15:00',1.69),('11288','2014-01-22','11:20:00',1.76),('11288','2014-01-22','11:25:00',1.63),('11288','2014-01-22','11:30:00',1.23),('11288','2014-01-22','11:35:00',1.24),('11288','2014-01-22','11:40:00',1.75),('11288','2014-01-22','11:45:00',1.53),('11288','2014-01-22','11:50:00',1.37),('11288','2014-01-22','11:55:00',1.52),('11288','2014-01-22','12:00:00',1.52),('11288','2014-01-22','12:05:00',1.58),('11288','2014-01-22','12:10:00',1.23),('11288','2014-01-22','12:35:00',1.03),('11288','2014-01-22','12:40:00',1.3),('11288','2014-01-22','12:45:00',1.36),('11288','2014-01-22','12:50:00',1.59),('11288','2014-01-22','12:55:00',1.67),('11288','2014-01-22','13:00:00',1.43),('11288','2014-01-22','13:05:00',1.56),('11288','2014-01-22','13:10:00',1.98),('11288','2014-01-22','13:15:00',2.88),('11288','2014-01-22','13:20:00',1.79),('11288','2014-01-22','13:25:00',1.27),('11288','2014-01-22','13:30:00',1.01),('11288','2014-01-22','13:40:00',1.15),('11288','2014-01-22','13:45:00',1.04),('11288','2014-01-22','13:50:00',1.14),('11288','2014-01-22','13:55:00',1.34),('11288','2014-01-22','14:00:00',1.21),('11288','2014-01-22','14:05:00',1.14),('11288','2014-01-22','14:10:00',1.38),('11288','2014-01-22','14:15:00',1.17),('11288','2014-01-22','14:20:00',1.13),('11288','2014-01-22','14:25:00',1.13),('11288','2014-01-22','14:30:00',1.04),('11288','2014-01-22','15:00:00',1),('11288','2014-01-22','15:05:00',1.07),('11288','2014-01-22','16:05:00',1.18),('11288','2014-01-22','16:10:00',1.3),('11288','2014-01-21','09:35:00',1.29),('11288','2014-01-21','09:40:00',1.41),('11288','2014-01-21','09:50:00',1.16),('11288','2014-01-21','09:55:00',1.7),('11288','2014-01-21','10:00:00',2.05),('11288','2014-01-21','10:05:00',2.1),('11288','2014-01-21','10:35:00',1.42),('11288','2014-01-21','10:40:00',1.3),('11288','2014-01-21','10:55:00',2.52),('11288','2014-01-21','11:00:00',3.5),('11288','2014-01-21','11:05:00',1.44),('11288','2014-01-21','11:15:00',1.14),('11288','2014-01-21','11:20:00',1.29),('11288','2014-01-21','11:45:00',1.03),('11288','2014-01-21','11:50:00',1.7),('11288','2014-01-21','11:55:00',1.62),('11288','2014-01-21','12:00:00',1.86),('11288','2014-01-21','12:05:00',2.48),('11288','2014-01-21','12:10:00',2.95),('11288','2014-01-21','12:15:00',2.2),('11288','2014-01-21','12:20:00',1.85),('11288','2014-01-21','12:25:00',2.41),('11288','2014-01-21','12:30:00',2.78),('11288','2014-01-21','12:35:00',2.55),('11288','2014-01-21','12:40:00',2.22),('11288','2014-01-21','12:45:00',2.13),('11288','2014-01-21','12:50:00',2.57),('11288','2014-01-21','12:55:00',1.2),('11288','2014-01-21','13:10:00',1.05),('11288','2014-01-21','13:15:00',1.48),('11288','2014-01-21','13:20:00',1.65),('11288','2014-01-21','13:55:00',1.13),('11288','2014-01-21','14:00:00',1.92),('11288','2014-01-21','14:05:00',2.33),('11288','2014-01-21','14:10:00',2.15),('11288','2014-01-21','14:15:00',1.78),('11288','2014-01-21','14:20:00',1.24),('11288','2014-01-21','15:25:00',1.06),('11288','2014-01-21','15:30:00',1.13),('11288','2014-01-21','15:35:00',1.43),('11288','2014-01-21','15:40:00',1.26),('11288','2014-01-20','10:50:00',1.05),('11288','2014-01-20','11:15:00',1.77),('11288','2014-01-20','11:20:00',2.73),('11288','2014-01-20','11:25:00',3.13),('11288','2014-01-20','11:30:00',3.18),('11288','2014-01-20','11:35:00',3.19),('11288','2014-01-20','11:40:00',4.35),('11288','2014-01-20','11:45:00',4.7),('11288','2014-01-20','11:50:00',2.9),('11288','2014-01-20','11:55:00',1.86),('11288','2014-01-20','12:00:00',1.85),('11288','2014-01-20','12:05:00',1.91),('11288','2014-01-20','12:10:00',1.36),('11288','2014-01-20','12:15:00',1.22),('11288','2014-01-20','12:25:00',1.96),('11288','2014-01-20','12:30:00',2.02),('11288','2014-01-20','12:35:00',1.35),('11288','2014-01-20','12:45:00',1.05),('11288','2014-01-20','13:10:00',1.04),('11288','2014-01-20','13:15:00',2.14),('11288','2014-01-20','13:20:00',6),('11288','2014-01-20','13:25:00',5.31),('11288','2014-01-20','13:30:00',4.76),('11288','2014-01-20','13:35:00',4.39),('11288','2014-01-20','13:40:00',3.33),('11288','2014-01-20','13:45:00',3.17),('11288','2014-01-20','13:50:00',1.91),('11288','2014-01-20','13:55:00',2.36),('11288','2014-01-20','14:00:00',4.09),('11288','2014-01-20','14:05:00',2.5),('11288','2014-01-20','14:10:00',1.81),('11288','2014-01-20','14:15:00',1.66),('11288','2014-01-20','14:20:00',1.43),('11288','2014-01-20','14:25:00',1.23),('11288','2014-01-19','10:20:00',1.06),('11288','2014-01-19','11:05:00',1.06),('11288','2014-01-19','11:40:00',1),('11288','2014-01-19','11:45:00',1.34),('11288','2014-01-19','11:50:00',1.67),('11288','2014-01-19','11:55:00',1.74),('11288','2014-01-19','12:00:00',1.86),('11288','2014-01-19','12:05:00',1.91),('11288','2014-01-19','12:10:00',1.83),('11288','2014-01-19','12:15:00',1.57),('11288','2014-01-19','12:20:00',1.67),('11288','2014-01-19','12:25:00',1.7),('11288','2014-01-19','12:30:00',1.12),('11288','2014-01-19','12:55:00',1.07),('11288','2014-01-19','13:00:00',1.37),('11288','2014-01-19','13:05:00',1.82),('11288','2014-01-19','13:10:00',2.02),('11288','2014-01-19','13:15:00',1.77),('11288','2014-01-19','13:20:00',1.43),('11288','2014-01-19','13:25:00',1.27),('11288','2014-01-19','13:30:00',1.25),('11288','2014-01-19','13:35:00',1.2),('11288','2014-01-19','13:40:00',1.09),('11288','2014-01-19','13:45:00',1.06),('11288','2014-01-19','13:50:00',1.1),('11288','2014-01-19','13:55:00',1.39),('11288','2014-01-19','14:00:00',1.26),('11288','2014-01-19','14:05:00',1.08),('11288','2014-01-19','14:15:00',1.33),('11288','2014-01-19','14:20:00',2.32),('11288','2014-01-19','14:25:00',2.59),('11288','2014-01-19','14:30:00',2.88),('11288','2014-01-19','14:35:00',2.03),('11288','2014-01-19','14:40:00',1.73),('11288','2014-01-19','14:45:00',1.42),('11288','2014-01-19','15:40:00',1.2),('11288','2014-01-18','09:25:00',1.01),('11288','2014-01-18','09:30:00',1.21),('11288','2014-01-18','09:35:00',1.48),('11288','2014-01-18','09:40:00',1.51),('11288','2014-01-18','09:45:00',1.45),('11288','2014-01-18','09:50:00',1.41),('11288','2014-01-18','09:55:00',1.61),('11288','2014-01-18','10:00:00',1.96),('11288','2014-01-18','10:05:00',2.41),('11288','2014-01-18','10:10:00',3.15),('11288','2014-01-18','10:15:00',3.35),('11288','2014-01-18','10:20:00',2.83),('11288','2014-01-18','10:25:00',2.34),('11288','2014-01-18','10:30:00',2.46),('11288','2014-01-18','10:35:00',1.88),('11288','2014-01-18','10:40:00',1.72),('11288','2014-01-18','10:45:00',1.91),('11288','2014-01-18','10:50:00',2.09),('11288','2014-01-18','10:55:00',1.91),('11288','2014-01-18','11:00:00',1.4),('11288','2014-01-18','11:05:00',2),('11288','2014-01-18','11:10:00',2.85),('11288','2014-01-18','11:15:00',4),('11288','2014-01-18','11:20:00',3.8),('11288','2014-01-18','11:25:00',3.65),('11288','2014-01-18','11:30:00',3.74),('11288','2014-01-18','11:35:00',3.77),('11288','2014-01-18','11:40:00',3.9),('11288','2014-01-18','11:45:00',4.32),('11288','2014-01-18','11:50:00',4.21),('11288','2014-01-18','11:55:00',4.59),('11288','2014-01-18','12:00:00',4.35),('11288','2014-01-18','12:05:00',3.21),('11288','2014-01-18','12:10:00',4.13),('11288','2014-01-18','12:15:00',3.82),('11288','2014-01-18','12:20:00',3.58),('11288','2014-01-18','12:25:00',3.85),('11288','2014-01-18','12:30:00',3.94),('11288','2014-01-18','12:35:00',3.92),('11288','2014-01-18','12:40:00',3.97),('11288','2014-01-18','12:45:00',3.79),('11288','2014-01-18','12:50:00',3.54),('11288','2014-01-18','12:55:00',4.11),('11288','2014-01-18','13:00:00',2.77),('11288','2014-01-18','13:05:00',2.62),('11288','2014-01-18','13:10:00',3.38),('11288','2014-01-18','13:15:00',4.01),('11288','2014-01-18','13:20:00',2.68),('11288','2014-01-18','13:25:00',2.16),('11288','2014-01-18','13:30:00',3.51),('11288','2014-01-18','13:35:00',2.32),('11288','2014-01-18','13:40:00',3.21),('11288','2014-01-18','13:45:00',3.58),('11288','2014-01-18','13:50:00',2.71),('11288','2014-01-18','13:55:00',3.44),('11288','2014-01-18','14:00:00',3.33),('11288','2014-01-18','14:05:00',3.14),('11288','2014-01-18','14:10:00',2.94),('11288','2014-01-18','14:15:00',2.8),('11288','2014-01-18','14:20:00',2.86),('11288','2014-01-18','14:25:00',2.71),('11288','2014-01-18','14:30:00',2.59),('11288','2014-01-18','14:35:00',2.47),('11288','2014-01-18','14:40:00',2.35),('11288','2014-01-18','14:45:00',2.24),('11288','2014-01-18','14:50:00',2.13),('11288','2014-01-18','14:55:00',1.39),('11288','2014-01-18','15:15:00',1.01),('11288','2014-01-18','15:20:00',1.06),('11288','2014-01-17','09:00:00',1.47),('11288','2014-01-17','09:05:00',1.47),('11288','2014-01-17','09:10:00',1.31),('11288','2014-01-17','09:20:00',1.49),('11288','2014-01-17','09:25:00',1.61),('11288','2014-01-17','09:30:00',1.71),('11288','2014-01-17','09:35:00',2.06),('11288','2014-01-17','09:40:00',2.34),('11288','2014-01-17','09:45:00',2.62),('11288','2014-01-17','09:50:00',1.51),('11288','2014-01-17','10:05:00',1.23),('11288','2014-01-17','10:15:00',1),('11288','2014-01-17','11:20:00',1.24),('11288','2014-01-17','11:25:00',2.11),('11288','2014-01-17','11:30:00',2.79),('11288','2014-01-17','11:35:00',3.18),('11288','2014-01-17','11:40:00',2.79),('11288','2014-01-17','11:45:00',1.3),('11288','2014-01-17','11:50:00',1.35),('11288','2014-01-17','11:55:00',1.81),('11288','2014-01-17','12:00:00',2.22),('11288','2014-01-17','12:05:00',2.39),('11288','2014-01-17','12:10:00',2.02),('11288','2014-01-17','12:15:00',1.36),('11288','2014-01-17','12:20:00',1.65),('11288','2014-01-17','12:25:00',1.5),('11288','2014-01-17','12:30:00',1.09),('11288','2014-01-17','12:35:00',1.18),('11288','2014-01-17','12:40:00',1.73),('11288','2014-01-17','12:45:00',1.96),('11288','2014-01-17','12:50:00',1.56),('11288','2014-01-17','13:10:00',1.14),('11288','2014-04-25','07:45:00',1.16),('11288','2014-04-25','07:50:00',1.23),('11288','2014-04-25','07:55:00',1.33),('11288','2014-04-25','08:00:00',1.27),('11288','2014-04-25','08:05:00',1.39),('11288','2014-04-25','08:10:00',1.47),('11288','2014-04-25','08:15:00',1.89),('11288','2014-04-25','08:20:00',1.92),('11288','2014-04-25','08:25:00',1.97),('11288','2014-04-25','08:30:00',2.18),('11288','2014-04-25','08:35:00',2.06),('11288','2014-04-25','08:40:00',2.15),('11288','2014-04-25','08:45:00',2.62),('11288','2014-04-25','08:50:00',2.9),('11288','2014-04-25','08:55:00',2.32),('11288','2014-04-25','09:00:00',2.15),('11288','2014-04-25','09:05:00',1.98),('11288','2014-04-25','09:10:00',1.53),('11288','2014-04-25','09:15:00',1.22),('11288','2014-04-25','09:20:00',1.61),('11288','2014-04-25','09:25:00',2.85),('11288','2014-04-25','09:30:00',1.83),('11288','2014-04-25','09:35:00',1.86),('11288','2014-04-25','09:40:00',1.76),('11288','2014-04-25','09:45:00',1.75),('11288','2014-04-25','09:50:00',1.75),('11288','2014-04-25','09:55:00',2),('11288','2014-04-25','10:00:00',2.33),('11288','2014-04-25','10:05:00',2.21),('11288','2014-04-25','10:10:00',2.37),('11288','2014-04-25','10:15:00',2.17),('11288','2014-04-25','10:20:00',2.38),('11288','2014-04-25','10:25:00',2.41),('11288','2014-04-25','10:30:00',3.47),('11288','2014-04-25','10:35:00',5.12),('11288','2014-04-25','10:40:00',3.92),('11288','2014-04-25','10:45:00',4.59),('11288','2014-04-25','10:50:00',3.8),('11288','2014-04-25','10:55:00',5.76),('11288','2014-04-25','11:00:00',4.84),('11288','2014-04-25','11:05:00',3.2),('11288','2014-04-25','11:10:00',4.61),('11288','2014-04-25','11:15:00',6.74),('11288','2014-04-25','11:20:00',3.57),('11288','2014-04-25','11:25:00',5.89),('11288','2014-04-25','11:30:00',4.42),('11288','2014-04-25','11:35:00',4.4),('11288','2014-04-25','11:40:00',4.38),('11288','2014-04-25','11:45:00',2.99),('11288','2014-04-25','11:50:00',5.16),('11288','2014-04-25','11:55:00',7.87),('11288','2014-04-25','12:00:00',5.55),('11288','2014-04-25','12:05:00',6.58),('11288','2014-04-25','12:10:00',5.94),('11288','2014-04-25','12:15:00',2.32),('11288','2014-04-25','12:20:00',5.08),('11288','2014-04-25','12:25:00',6.64),('11288','2014-04-25','12:30:00',7.1),('11288','2014-04-25','12:35:00',7.33),('11288','2014-04-25','12:40:00',7.42),('11288','2014-04-25','12:45:00',7.52),('11288','2014-04-25','12:50:00',5.97),('11288','2014-04-25','12:55:00',6.38),('11288','2014-04-25','13:00:00',6.44),('11288','2014-04-25','13:05:00',5.73),('11288','2014-04-25','13:10:00',6.93),('11288','2014-04-25','13:15:00',5.12),('11288','2014-04-25','13:20:00',3.36),('11288','2014-04-25','13:25:00',4.66),('11288','2014-04-25','13:30:00',2.44),('11288','2014-04-25','13:35:00',1.88),('11288','2014-04-25','13:40:00',3.17),('11288','2014-04-25','13:45:00',2.38),('11288','2014-04-25','13:50:00',2.2),('11288','2014-04-25','13:55:00',2.69),('11288','2014-04-25','14:00:00',2.45),('11288','2014-04-25','14:05:00',2.68),('11288','2014-04-25','14:10:00',2.13),('11288','2014-04-25','14:15:00',2.47),('11288','2014-04-25','14:20:00',4.85),('11288','2014-04-25','14:25:00',2.71),('11288','2014-04-25','14:30:00',6.95),('11288','2014-04-25','14:35:00',6.95),('11288','2014-04-25','14:40:00',6.55),('11288','2014-04-25','14:45:00',6.35),('11288','2014-04-25','14:50:00',6.32),('11288','2014-04-25','14:55:00',6.27),('11288','2014-04-25','15:00:00',6.15),('11288','2014-04-25','15:05:00',6.06),('11288','2014-04-25','15:10:00',6.03),('11288','2014-04-25','15:15:00',5.91),('11288','2014-04-25','15:20:00',5.66),('11288','2014-04-25','15:25:00',5.65),('11288','2014-04-25','15:30:00',5.5),('11288','2014-04-25','15:35:00',5.65),('11288','2014-04-25','15:40:00',5.54),('11288','2014-04-25','15:45:00',5.38),('11288','2014-04-25','15:50:00',5.4),('11288','2014-04-25','15:55:00',5.28),('11288','2014-04-25','16:00:00',5.18),('11288','2014-04-25','16:05:00',5),('11288','2014-04-25','16:10:00',4.72),('11288','2014-04-25','16:15:00',4.62),('11288','2014-04-25','16:20:00',4.28),('11288','2014-04-25','16:25:00',4.38),('11288','2014-04-25','16:30:00',4.46),('11288','2014-04-25','16:35:00',4.5),('11288','2014-04-25','16:40:00',4.38),('11288','2014-04-25','16:45:00',4.28),('11288','2014-04-25','16:50:00',3.81),('11288','2014-04-25','16:55:00',3.24),('11288','2014-04-25','17:00:00',3.31),('11288','2014-04-25','17:05:00',3.53),('11288','2014-04-25','17:10:00',2.96),('11288','2014-04-25','17:15:00',3.13),('11288','2014-04-25','17:20:00',2.05),('11288','2014-04-25','17:25:00',1.6),('11288','2014-04-25','17:30:00',1.72),('11288','2014-04-25','17:35:00',1.73),('11288','2014-04-25','17:40:00',1.61),('11288','2014-04-25','17:45:00',1.48),('11288','2014-04-25','17:50:00',1.36),('11288','2014-04-25','17:55:00',1.3),('11288','2014-04-25','18:00:00',1.27),('11288','2014-04-25','18:05:00',1.29),('11288','2014-04-25','18:10:00',1.24),('11288','2014-04-25','18:15:00',1.06),('11288','2014-04-25','18:20:00',1.08),('11288','2014-04-25','18:25:00',1.06),('11288','2014-04-25','18:30:00',1.01),('11288','2014-01-16','08:40:00',1.02),('11288','2014-01-16','08:55:00',1.03),('11288','2014-01-16','09:00:00',1.18),('11288','2014-01-16','09:05:00',1.21),('11288','2014-01-16','09:10:00',1.36),('11288','2014-01-16','09:15:00',1.4),('11288','2014-01-16','09:20:00',1.97),('11288','2014-01-16','09:25:00',2.16),('11288','2014-01-16','09:30:00',2.3),('11288','2014-01-16','09:35:00',2.41),('11288','2014-01-16','09:40:00',2.65),('11288','2014-01-16','09:45:00',2.42),('11288','2014-01-16','09:50:00',1.97),('11288','2014-01-16','09:55:00',1.67),('11288','2014-01-16','10:00:00',1.54),('11288','2014-01-16','10:05:00',1.63),('11288','2014-01-16','10:10:00',1.79),('11288','2014-01-16','10:15:00',2.03),('11288','2014-01-16','10:20:00',1.96),('11288','2014-01-16','10:25:00',2.22),('11288','2014-01-16','10:30:00',2.89),('11288','2014-01-16','10:35:00',3.62),('11288','2014-01-16','10:40:00',3.43),('11288','2014-01-16','10:45:00',2.6),('11288','2014-01-16','10:50:00',2.75),('11288','2014-01-16','10:55:00',2.99),('11288','2014-01-16','11:00:00',3.04),('11288','2014-01-16','11:05:00',3),('11288','2014-01-16','11:10:00',3.16),('11288','2014-01-16','11:15:00',3.06),('11288','2014-01-16','11:20:00',2.85),('11288','2014-01-16','11:25:00',2.98),('11288','2014-01-16','11:30:00',2.77),('11288','2014-01-16','11:35:00',2.53),('11288','2014-01-16','11:40:00',2.46),('11288','2014-01-16','11:45:00',2.5),('11288','2014-01-16','11:50:00',2.2),('11288','2014-01-16','11:55:00',2.52),('11288','2014-01-16','12:00:00',2.22),('11288','2014-01-16','12:05:00',2.52),('11288','2014-01-16','12:10:00',2.71),('11288','2014-01-16','12:15:00',2.49),('11288','2014-01-16','12:20:00',2.36),('11288','2014-01-16','12:25:00',2.28),('11288','2014-01-16','12:30:00',2.45),('11288','2014-01-16','12:35:00',2.95),('11288','2014-01-16','12:40:00',2.98),('11288','2014-01-16','12:45:00',3.02),('11288','2014-01-16','12:50:00',3.14),('11288','2014-01-16','12:55:00',3.26),('11288','2014-01-16','13:00:00',3.44),('11288','2014-01-16','13:05:00',3.22),('11288','2014-01-16','13:10:00',3),('11288','2014-01-16','13:15:00',2.45),('11288','2014-01-16','13:20:00',2.36),('11288','2014-01-16','13:25:00',2.64),('11288','2014-01-16','13:30:00',2.04),('11288','2014-01-16','13:35:00',1.82),('11288','2014-01-16','13:40:00',2.17),('11288','2014-01-16','13:45:00',3.03),('11288','2014-01-16','13:50:00',2.73),('11288','2014-01-16','13:55:00',3.31),('11288','2014-01-16','14:00:00',1.85),('11288','2014-01-16','14:05:00',1.87),('11288','2014-01-16','14:10:00',1.77),('11288','2014-01-16','14:15:00',1.47),('11288','2014-01-16','14:20:00',1.37),('11288','2014-01-16','14:25:00',1.64),('11288','2014-01-16','14:30:00',1.66),('11288','2014-01-16','14:35:00',1.54),('11288','2014-01-16','14:40:00',1.33),('11288','2014-01-16','14:45:00',1.25),('11288','2014-01-16','14:50:00',1.38),('11288','2014-01-16','14:55:00',1.47),('11288','2014-01-16','15:00:00',1.43),('11288','2014-01-16','15:05:00',1.46),('11288','2014-01-16','15:10:00',1.36),('11288','2014-01-16','15:15:00',1.1),('11288','2014-01-15','09:40:00',1.08),('11288','2014-01-15','09:45:00',1.03),('11288','2014-01-15','10:00:00',1.01),('11288','2014-01-15','10:10:00',1.41),('11288','2014-01-15','10:15:00',2.05),('11288','2014-01-15','10:20:00',2.63),('11288','2014-01-15','10:25:00',2.85),('11288','2014-01-15','10:30:00',2.61),('11288','2014-01-15','10:35:00',2.15),('11288','2014-01-15','10:40:00',2.71),('11288','2014-01-15','10:45:00',2.27),('11288','2014-01-15','10:50:00',1.49),('11288','2014-01-15','10:55:00',1.74),('11288','2014-01-15','11:00:00',2.15),('11288','2014-01-15','11:05:00',2.62),('11288','2014-01-15','11:10:00',3.83),('11288','2014-01-15','11:15:00',3.74),('11288','2014-01-15','11:20:00',3.56),('11288','2014-01-15','11:25:00',3.4),('11288','2014-01-15','11:30:00',2.77),('11288','2014-01-15','11:35:00',1.8),('11288','2014-01-15','11:40:00',2.67),('11288','2014-01-15','11:45:00',3.44),('11288','2014-01-15','11:50:00',3.5),('11288','2014-01-15','11:55:00',3),('11288','2014-01-15','12:00:00',2.92),('11288','2014-01-15','12:05:00',2.63),('11288','2014-01-15','12:10:00',2.56),('11288','2014-01-15','12:15:00',2.93),('11288','2014-01-15','12:20:00',3.59),('11288','2014-01-15','12:25:00',2.95),('11288','2014-01-15','12:30:00',2.24),('11288','2014-01-15','12:35:00',2.53),('11288','2014-01-15','12:40:00',2.2),('11288','2014-01-15','12:45:00',2.34),('11288','2014-01-15','12:50:00',2.37),('11288','2014-01-15','12:55:00',2.13),('11288','2014-01-15','13:00:00',2.06),('11288','2014-01-15','13:05:00',2.19),('11288','2014-01-15','13:10:00',2.91),('11288','2014-01-15','13:15:00',4.18),('11288','2014-01-15','13:20:00',4.2),('11288','2014-01-15','13:25:00',3.95),('11288','2014-01-15','13:30:00',3.79),('11288','2014-01-15','13:35:00',3.49),('11288','2014-01-15','13:40:00',3.33),('11288','2014-01-15','13:45:00',3.32),('11288','2014-01-15','13:50:00',1.81),('11288','2014-01-15','13:55:00',2.21),('11288','2014-01-15','14:00:00',2.99),('11288','2014-01-15','14:05:00',2.94),('11288','2014-01-15','14:10:00',2.87),('11288','2014-01-15','14:15:00',2.73),('11288','2014-01-15','14:20:00',2.72),('11288','2014-01-15','14:25:00',2.64),('11288','2014-01-15','14:30:00',2.54),('11288','2014-01-15','14:35:00',2.46),('11288','2014-01-15','14:40:00',2.5),('11288','2014-01-15','14:45:00',2.45),('11288','2014-01-15','14:50:00',2.24),('11288','2014-01-15','14:55:00',2.14),('11288','2014-01-15','15:00:00',2.09),('11288','2014-01-15','15:05:00',1.97),('11288','2014-01-15','15:10:00',1.88),('11288','2014-01-15','15:15:00',1.71),('11288','2014-01-15','15:25:00',1.4),('11288','2014-01-15','15:30:00',1.34),('11288','2014-01-15','15:35:00',1.24),('11288','2014-01-15','15:40:00',1.1),('11288','2014-01-14','10:15:00',1.06),('11288','2014-01-14','10:20:00',1.56),('11288','2014-01-14','10:25:00',2.58),('11288','2014-01-14','10:30:00',3.78),('11288','2014-01-14','10:35:00',3.78),('11288','2014-01-14','10:40:00',3.54),('11288','2014-01-14','10:45:00',3.4),('11288','2014-01-14','10:50:00',2.3),('11288','2014-01-14','10:55:00',2.1),('11288','2014-01-14','11:00:00',2.5),('11288','2014-01-14','11:05:00',1.99),('11288','2014-01-14','11:10:00',1.32),('11288','2014-01-14','11:15:00',1.48),('11288','2014-01-14','11:20:00',1.72),('11288','2014-01-14','11:25:00',1.26),('11288','2014-01-14','11:30:00',1.91),('11288','2014-01-14','11:35:00',2.05),('11288','2014-01-14','11:40:00',2.27),('11288','2014-01-14','11:45:00',1.67),('11288','2014-01-14','11:50:00',1.63),('11288','2014-01-14','11:55:00',1.57),('11288','2014-01-14','12:00:00',1.27),('11288','2014-01-13','09:05:00',1.58),('11288','2014-01-13','09:10:00',1.8),('11288','2014-01-13','09:15:00',1.78),('11288','2014-01-13','09:20:00',1.79),('11288','2014-01-13','09:25:00',1.81),('11288','2014-01-13','09:30:00',1.86),('11288','2014-01-13','09:35:00',1.94),('11288','2014-01-13','09:40:00',2),('11288','2014-01-13','09:45:00',1.99),('11288','2014-01-13','09:50:00',2.13),('11288','2014-01-13','09:55:00',2.2),('11288','2014-01-13','10:00:00',2.28),('11288','2014-01-13','10:05:00',2.36),('11288','2014-01-13','10:10:00',2.42),('11288','2014-01-13','10:15:00',2.41),('11288','2014-01-13','10:20:00',2.54),('11288','2014-01-13','10:25:00',2.66),('11288','2014-01-13','10:30:00',2.75),('11288','2014-01-13','10:35:00',2.81),('11288','2014-01-13','10:40:00',2.91),('11288','2014-01-13','10:45:00',2.97),('11288','2014-01-13','10:50:00',2.99),('11288','2014-01-13','10:55:00',3.06),('11288','2014-01-13','11:00:00',3.16),('11288','2014-01-13','11:05:00',3.18),('11288','2014-01-13','11:10:00',3.26),('11288','2014-01-13','11:15:00',3.34),('11288','2014-01-13','11:20:00',3.37),('11288','2014-01-13','11:25:00',3.4),('11288','2014-01-13','11:30:00',3.41),('11288','2014-01-13','11:35:00',3.44),('11288','2014-01-13','11:40:00',3.47),('11288','2014-01-13','11:45:00',3.42),('11288','2014-01-13','11:50:00',3.46),('11288','2014-01-13','11:55:00',3.48),('11288','2014-01-13','12:00:00',3.45),('11288','2014-01-13','12:05:00',3.44),('11288','2014-01-13','12:10:00',3.45),('11288','2014-01-13','12:15:00',3.37),('11288','2014-01-13','12:20:00',3.37),('11288','2014-01-13','12:25:00',3.51),('11288','2014-01-13','12:30:00',3.45),('11288','2014-01-13','12:35:00',3.35),('11288','2014-01-13','12:40:00',3.37),('11288','2014-01-13','12:45:00',3.34),('11288','2014-01-13','12:50:00',3.27),('11288','2014-01-13','12:55:00',3.12),('11288','2014-01-13','13:00:00',3.19),('11288','2014-01-13','13:05:00',3.22),('11288','2014-01-13','13:10:00',3.17),('11288','2014-01-13','13:15:00',3.16),('11288','2014-01-13','13:20:00',3.15),('11288','2014-01-13','13:25:00',3.06),('11288','2014-01-13','13:30:00',3.03),('11288','2014-01-13','13:35:00',3),('11288','2014-01-13','13:40:00',2.89),('11288','2014-01-13','13:45:00',2.75),('11288','2014-01-13','13:50:00',2.85),('11288','2014-01-13','13:55:00',2.71),('11288','2014-01-13','14:00:00',2.71),('11288','2014-01-13','14:05:00',2.55),('11288','2014-01-13','14:10:00',2.55),('11288','2014-01-13','14:15:00',2.47),('11288','2014-01-13','14:20:00',2.45),('11288','2014-01-13','14:25:00',2.33),('11288','2014-01-13','14:30:00',2.21),('11288','2014-01-13','14:35:00',2.12),('11288','2014-01-13','14:40:00',2.06),('11288','2014-01-13','14:45:00',1.96),('11288','2014-01-13','14:50:00',1.84),('11288','2014-01-13','14:55:00',1.76),('11288','2014-01-13','15:00:00',1.7),('11288','2014-01-13','15:05:00',1.6),('11288','2014-01-13','15:10:00',1.5),('11288','2014-01-13','15:15:00',1.4),('11288','2014-01-13','15:20:00',1.31),('11288','2014-01-13','15:25:00',1.2),('11288','2014-01-13','15:30:00',1.08),('11288','2014-01-12','09:35:00',1.06),('11288','2014-01-12','09:40:00',1.26),('11288','2014-01-12','09:45:00',1.45),('11288','2014-01-12','09:50:00',1.61),('11288','2014-01-12','09:55:00',1.63),('11288','2014-01-12','10:00:00',1.58),('11288','2014-01-12','10:05:00',1.54),('11288','2014-01-12','10:10:00',1.56),('11288','2014-01-12','10:15:00',1.66),('11288','2014-01-12','10:20:00',1.88),('11288','2014-01-12','10:25:00',1.81),('11288','2014-01-12','10:30:00',1.85),('11288','2014-01-12','10:35:00',2.09),('11288','2014-01-12','10:40:00',2.34),('11288','2014-01-12','10:45:00',2.3),('11288','2014-01-12','10:50:00',2.52),('11288','2014-01-12','10:55:00',2.66),('11288','2014-01-12','11:00:00',2.58),('11288','2014-01-12','11:05:00',2.69),('11288','2014-01-12','11:10:00',3.03),('11288','2014-01-12','11:15:00',2.68),('11288','2014-01-12','11:20:00',2.46),('11288','2014-01-12','11:25:00',2.55),('11288','2014-01-12','11:30:00',2.51),('11288','2014-01-12','11:35:00',2.36),('11288','2014-01-12','11:40:00',2.73),('11288','2014-01-12','11:45:00',3.06),('11288','2014-01-12','11:50:00',3.24),('11288','2014-01-12','11:55:00',2.88),('11288','2014-01-12','12:00:00',2.43),('11288','2014-01-12','12:05:00',2.45),('11288','2014-01-12','12:10:00',2.2),('11288','2014-01-12','12:15:00',2.12),('11288','2014-01-12','12:20:00',2.09),('11288','2014-01-12','12:25:00',2.04),('11288','2014-01-12','12:30:00',2.1),('11288','2014-01-12','12:35:00',2.15),('11288','2014-01-12','12:40:00',2.23),('11288','2014-01-12','12:45:00',2.15),('11288','2014-01-12','12:50:00',2.22),('11288','2014-01-12','12:55:00',2.15),('11288','2014-01-12','13:00:00',2.15),('11288','2014-01-12','13:05:00',2.02),('11288','2014-01-12','13:10:00',1.93),('11288','2014-01-12','13:15:00',1.88),('11288','2014-01-12','13:20:00',1.94),('11288','2014-01-12','13:25:00',2.01),('11288','2014-01-12','13:30:00',2.22),('11288','2014-01-12','13:35:00',2.08),('11288','2014-01-12','13:40:00',1.88),('11288','2014-01-12','13:45:00',1.7),('11288','2014-01-12','13:50:00',1.55),('11288','2014-01-12','13:55:00',1.47),('11288','2014-01-12','14:00:00',1.43),('11288','2014-01-12','14:05:00',1.39),('11288','2014-01-12','14:10:00',1.31),('11288','2014-01-12','14:15:00',1.2),('11288','2014-01-12','14:20:00',1.12),('11288','2014-01-12','14:25:00',1.06),('11288','2014-01-11','09:20:00',1.06),('11288','2014-01-11','09:25:00',1.17),('11288','2014-01-11','09:50:00',1.39),('11288','2014-01-11','09:55:00',1.88),('11288','2014-01-11','10:00:00',1.99),('11288','2014-01-11','10:05:00',1.77),('11288','2014-01-11','10:10:00',1.75),('11288','2014-01-11','10:15:00',1.83),('11288','2014-01-11','10:20:00',1.95),('11288','2014-01-11','10:25:00',2.24),('11288','2014-01-11','10:30:00',2.26),('11288','2014-01-11','10:35:00',2.43),('11288','2014-01-11','10:40:00',3.05),('11288','2014-01-11','10:45:00',3.19),('11288','2014-01-11','10:50:00',3.21),('11288','2014-01-11','10:55:00',3.22),('11288','2014-01-11','11:00:00',3.17),('11288','2014-01-11','11:05:00',3.04),('11288','2014-01-11','11:10:00',3.34),('11288','2014-01-11','11:15:00',2.94),('11288','2014-01-11','11:20:00',2.84),('11288','2014-01-11','11:25:00',2.91),('11288','2014-01-11','11:30:00',2.88),('11288','2014-01-11','11:35:00',2.54),('11288','2014-01-11','11:40:00',2.36),('11288','2014-01-11','11:45:00',2.48),('11288','2014-01-11','11:50:00',2.73),('11288','2014-01-11','11:55:00',2.78),('11288','2014-01-11','12:00:00',2.9),('11288','2014-01-11','12:05:00',3.22),('11288','2014-01-11','12:10:00',2.92),('11288','2014-01-11','12:15:00',2.82),('11288','2014-01-11','12:20:00',2.89),('11288','2014-01-11','12:25:00',2.66),('11288','2014-01-11','12:30:00',2.45),('11288','2014-01-11','12:35:00',2.14),('11288','2014-01-11','12:40:00',2.1),('11288','2014-01-11','12:45:00',2.35),('11288','2014-01-11','12:50:00',2.87),('11288','2014-01-11','12:55:00',2.93),('11288','2014-01-11','13:00:00',2.98),('11288','2014-01-11','13:05:00',2.57),('11288','2014-01-11','13:10:00',2.48),('11288','2014-01-11','13:15:00',3.05),('11288','2014-01-11','13:20:00',2.57),('11288','2014-01-11','13:25:00',2.23),('11288','2014-01-11','13:30:00',1.79),('11288','2014-01-11','13:35:00',1.87),('11288','2014-01-11','13:40:00',1.75),('11288','2014-01-11','13:45:00',1.9),('11288','2014-01-11','13:50:00',1.55),('11288','2014-01-11','13:55:00',1.76),('11288','2014-01-11','14:00:00',2.26),('11288','2014-01-11','14:05:00',2.36),('11288','2014-01-11','14:10:00',1.96),('11288','2014-01-11','14:15:00',1.32),('11288','2014-01-11','14:20:00',1.06),('11288','2014-01-11','14:30:00',1.06),('11288','2014-01-11','14:35:00',1.21),('11288','2014-01-11','14:40:00',1.39),('11288','2014-01-11','14:45:00',1.42),('11288','2014-01-11','14:50:00',1.29),('11288','2014-01-11','14:55:00',1.15),('11288','2014-01-11','15:00:00',1.13),('11288','2014-01-11','15:05:00',1.06),('11288','2014-01-11','15:10:00',1.03),('11288','2014-01-11','15:15:00',1.04),('11288','2014-01-10','09:50:00',1.05),('11288','2014-01-10','09:55:00',1.1),('11288','2014-01-10','10:00:00',1.07),('11288','2014-01-10','10:05:00',1.02),('11288','2014-01-10','10:10:00',1.02),('11288','2014-01-10','10:15:00',1.04),('11288','2014-01-10','10:20:00',1.09),('11288','2014-01-10','10:25:00',1.14),('11288','2014-01-10','10:30:00',1.07),('11288','2014-01-10','10:35:00',1.04),('11288','2014-01-10','10:45:00',1.1),('11288','2014-01-10','10:50:00',1.21),('11288','2014-01-10','10:55:00',1.18),('11288','2014-01-10','11:00:00',1.17),('11288','2014-01-10','11:05:00',1.26),('11288','2014-01-10','11:10:00',1.23),('11288','2014-01-10','11:15:00',1.11),('11288','2014-01-10','11:20:00',1.04),('11288','2014-01-10','11:25:00',1.1),('11288','2014-01-10','11:30:00',1.27),('11288','2014-01-10','11:35:00',1.38),('11288','2014-01-10','11:40:00',1.34),('11288','2014-01-10','11:45:00',1.25),('11288','2014-01-10','11:50:00',1.33),('11288','2014-01-10','11:55:00',1.38),('11288','2014-01-10','12:00:00',1.09),('11288','2014-01-10','12:10:00',1.02),('11288','2014-01-10','12:15:00',1.15),('11288','2014-01-10','12:20:00',1.42),('11288','2014-01-10','12:25:00',1.39),('11288','2014-01-10','12:30:00',1.53),('11288','2014-01-10','12:35:00',1.47),('11288','2014-01-10','12:40:00',1.34),('11288','2014-01-10','12:45:00',1.39),('11288','2014-01-10','12:50:00',1.59),('11288','2014-01-10','12:55:00',1.56),('11288','2014-01-10','13:00:00',1.66),('11288','2014-01-10','13:05:00',1.76),('11288','2014-01-10','13:10:00',1.64),('11288','2014-01-10','13:15:00',1.41),('11288','2014-01-10','13:20:00',1.28),('11288','2014-01-10','13:25:00',1.25),('11288','2014-01-10','13:30:00',1.33),('11288','2014-01-10','13:35:00',1.35),('11288','2014-01-10','13:40:00',1.34),('11288','2014-01-10','13:45:00',1.25),('11288','2014-01-10','13:50:00',1.26),('11288','2014-01-10','13:55:00',1.18),('11288','2014-01-09','09:05:00',1.14),('11288','2014-01-09','09:10:00',1.21),('11288','2014-01-09','09:15:00',1.2),('11288','2014-01-09','09:20:00',1.47),('11288','2014-01-09','09:25:00',1.54),('11288','2014-01-09','09:30:00',1.79),('11288','2014-01-09','09:35:00',1.69),('11288','2014-01-09','09:40:00',2.21),('11288','2014-01-09','09:45:00',2.51),('11288','2014-01-09','09:50:00',2.64),('11288','2014-01-09','09:55:00',2.58),('11288','2014-01-09','10:00:00',2.66),('11288','2014-01-09','10:05:00',2.61),('11288','2014-01-09','10:10:00',2.35),('11288','2014-01-09','10:15:00',2.35),('11288','2014-01-09','10:20:00',2.43),('11288','2014-01-09','10:25:00',2.64),('11288','2014-01-09','10:30:00',2.67),('11288','2014-01-09','10:35:00',2.88),('11288','2014-01-09','10:40:00',3.23),('11288','2014-01-09','10:45:00',2.64),('11288','2014-01-09','10:50:00',2.05),('11288','2014-01-09','10:55:00',2.14),('11288','2014-01-09','11:00:00',2.23),('11288','2014-01-09','11:05:00',2.19),('11288','2014-01-09','11:10:00',1.94),('11288','2014-01-09','11:15:00',2.12),('11288','2014-01-09','11:20:00',2.48),('11288','2014-01-09','11:25:00',2.36),('11288','2014-01-09','11:30:00',2.13),('11288','2014-01-09','11:35:00',2.55),('11288','2014-01-09','11:40:00',2.75),('11288','2014-01-09','11:45:00',1.95),('11288','2014-01-09','12:00:00',1.46),('11288','2014-01-09','12:05:00',1.31),('11288','2014-01-09','12:10:00',1.4),('11288','2014-01-09','12:15:00',1.51),('11288','2014-01-09','12:20:00',1.29),('11288','2014-01-09','12:25:00',1.43),('11288','2014-01-09','12:30:00',1.25),('11288','2014-01-09','12:35:00',1.21),('11288','2014-01-09','12:40:00',1.36),('11288','2014-01-09','12:45:00',1.45),('11288','2014-01-09','12:50:00',1.37),('11288','2014-01-09','12:55:00',1.33),('11288','2014-01-09','13:00:00',1.24),('11288','2014-01-09','13:05:00',1.74),('11288','2014-01-09','13:10:00',1.72),('11288','2014-01-09','13:15:00',1.84),('11288','2014-01-09','13:20:00',1.57),('11288','2014-01-09','13:25:00',1.68),('11288','2014-01-09','13:30:00',1.7),('11288','2014-01-09','13:35:00',1.55),('11288','2014-01-09','13:40:00',1.45),('11288','2014-01-09','13:45:00',1.3),('11288','2014-01-09','13:50:00',1.33),('11288','2014-01-09','13:55:00',1.2),('11288','2014-01-09','14:00:00',1.14),('11288','2014-01-09','14:05:00',1.16),('11288','2014-01-09','14:10:00',1.19),('11288','2014-01-09','14:15:00',1.15),('11288','2014-01-09','14:20:00',1.06),('11288','2014-01-09','14:25:00',1.02),('11288','2014-01-09','14:30:00',1.04),('11288','2014-01-09','14:35:00',1.19),('11288','2014-01-09','14:40:00',1.08),('11288','2014-01-08','08:55:00',1.03),('11288','2014-01-08','09:00:00',1.25),('11288','2014-01-08','09:05:00',1.34),('11288','2014-01-08','09:10:00',1.48),('11288','2014-01-08','09:15:00',1.59),('11288','2014-01-08','09:20:00',1.63),('11288','2014-01-08','09:25:00',1.73),('11288','2014-01-08','09:30:00',1.74),('11288','2014-01-08','09:35:00',1.73),('11288','2014-01-08','09:40:00',1.9),('11288','2014-01-08','09:45:00',2),('11288','2014-01-08','09:50:00',2.03),('11288','2014-01-08','09:55:00',2.13),('11288','2014-01-08','10:00:00',2.25),('11288','2014-01-08','10:05:00',2.17),('11288','2014-01-08','10:10:00',2.17),('11288','2014-01-08','10:15:00',2.29),('11288','2014-01-08','10:20:00',2.57),('11288','2014-01-08','10:25:00',2.75),('11288','2014-01-08','10:30:00',2.83),('11288','2014-01-08','10:35:00',2.75),('11288','2014-01-08','10:40:00',2.72),('11288','2014-01-08','10:45:00',2.94),('11288','2014-01-08','10:50:00',2.91),('11288','2014-01-08','10:55:00',3.13),('11288','2014-01-08','11:00:00',3.2),('11288','2014-01-08','11:05:00',3.26),('11288','2014-01-08','11:10:00',3.35),('11288','2014-01-08','11:15:00',3.39),('11288','2014-01-08','11:20:00',3.39),('11288','2014-01-08','11:25:00',3.42),('11288','2014-01-08','11:30:00',3.36),('11288','2014-01-08','11:35:00',3.32),('11288','2014-01-08','11:40:00',3.12),('11288','2014-01-08','11:45:00',3.58),('11288','2014-01-08','11:50:00',3.55),('11288','2014-01-08','11:55:00',3.52),('11288','2014-01-08','12:00:00',3.52),('11288','2014-01-08','12:05:00',3.49),('11288','2014-01-08','12:10:00',3.41),('11288','2014-01-08','12:15:00',3.45),('11288','2014-01-08','12:20:00',3.47),('11288','2014-01-08','12:25:00',3.5),('11288','2014-01-08','12:30:00',3.42),('11288','2014-01-08','12:35:00',3.46),('11288','2014-01-08','12:40:00',3.35),('11288','2014-01-08','12:45:00',3.2),('11288','2014-01-08','12:50:00',3.25),('11288','2014-01-08','12:55:00',3.3),('11288','2014-01-08','13:00:00',3.3),('11288','2014-01-08','13:05:00',3.28),('11288','2014-01-08','13:10:00',3.2),('11288','2014-01-08','13:15:00',3.1),('11288','2014-01-08','13:20:00',3.05),('11288','2014-01-08','13:25:00',3.06),('11288','2014-01-08','13:30:00',3.03),('11288','2014-01-08','13:35:00',2.98),('11288','2014-01-08','13:40:00',2.88),('11288','2014-01-08','13:45:00',2.81),('11288','2014-01-08','13:50:00',2.8),('11288','2014-01-08','13:55:00',2.73),('11288','2014-01-08','14:00:00',2.64),('11288','2014-01-08','14:05:00',2.62),('11288','2014-01-08','14:10:00',2.51),('11288','2014-01-08','14:15:00',2.42),('11288','2014-01-08','14:20:00',2.46),('11288','2014-01-08','14:25:00',2.38),('11288','2014-01-08','14:30:00',2.32),('11288','2014-01-08','14:35:00',2.24),('11288','2014-01-08','14:40:00',2.01),('11288','2014-01-08','14:45:00',1.88),('11288','2014-01-08','14:50:00',1.77),('11288','2014-01-08','14:55:00',1.49),('11288','2014-01-08','15:00:00',1.45),('11288','2014-01-08','15:05:00',1.31),('11288','2014-01-08','15:10:00',1.09),('11288','2014-01-08','15:15:00',1.21),('11288','2014-01-08','15:20:00',1.35),('11288','2014-01-08','15:25:00',1.14),('11288','2014-01-08','15:30:00',1.01),('11288','2014-01-07','08:50:00',1),('11288','2014-01-07','08:55:00',1.16),('11288','2014-01-07','09:00:00',1.29),('11288','2014-01-07','09:05:00',1.37),('11288','2014-01-07','09:10:00',1.48),('11288','2014-01-07','09:15:00',1.59),('11288','2014-01-07','09:20:00',1.67),('11288','2014-01-07','09:25:00',1.76),('11288','2014-01-07','09:30:00',1.82),('11288','2014-01-07','09:35:00',1.88),('11288','2014-01-07','09:40:00',1.97),('11288','2014-01-07','09:45:00',2.07),('11288','2014-01-07','09:50:00',2.15),('11288','2014-01-07','09:55:00',2.22),('11288','2014-01-07','10:00:00',2.31),('11288','2014-01-07','10:05:00',2.39),('11288','2014-01-07','10:10:00',2.34),('11288','2014-01-07','10:15:00',2.53),('11288','2014-01-07','10:20:00',2.64),('11288','2014-01-07','10:25:00',2.76),('11288','2014-01-07','10:30:00',2.86),('11288','2014-01-07','10:35:00',2.93),('11288','2014-01-07','10:40:00',3.02),('11288','2014-01-07','10:45:00',3.01),('11288','2014-01-07','10:50:00',3.01),('11288','2014-01-07','10:55:00',3.19),('11288','2014-01-07','11:00:00',3.27),('11288','2014-01-07','11:05:00',3.32),('11288','2014-01-07','11:10:00',3.39),('11288','2014-01-07','11:15:00',3.43),('11288','2014-01-07','11:20:00',3.47),('11288','2014-01-07','11:25:00',3.55),('11288','2014-01-07','11:30:00',3.48),('11288','2014-01-07','11:35:00',3.23),('11288','2014-01-07','11:40:00',3.26),('11288','2014-01-07','11:45:00',3.6),('11288','2014-01-07','11:50:00',3.63),('11288','2014-01-07','11:55:00',3.63),('11288','2014-01-07','12:00:00',3.66),('11288','2014-01-07','12:05:00',3.6),('11288','2014-01-07','12:10:00',3.55),('11288','2014-01-07','12:15:00',3.59),('11288','2014-01-07','12:20:00',3.56),('11288','2014-01-07','12:25:00',3.59),('11288','2014-01-07','12:30:00',3.58),('11288','2014-01-07','12:35:00',3.51),('11288','2014-01-07','12:40:00',3.38),('11288','2014-01-07','12:45:00',3.47),('11288','2014-01-07','12:50:00',3.42),('11288','2014-01-07','12:55:00',3.38),('11288','2014-01-07','13:00:00',3.24),('11288','2014-01-07','13:05:00',3.16),('11288','2014-01-07','13:10:00',3.19),('11288','2014-01-07','13:15:00',3.19),('11288','2014-01-07','13:20:00',3.13),('11288','2014-01-07','13:25:00',2.98),('11288','2014-01-07','13:30:00',2.96),('11288','2014-01-07','13:35:00',3.01),('11288','2014-01-07','13:40:00',2.99),('11288','2014-01-07','13:45:00',3.02),('11288','2014-01-07','13:50:00',2.95),('11288','2014-01-07','13:55:00',2.85),('11288','2014-01-07','14:00:00',2.77),('11288','2014-01-07','14:05:00',2.61),('11288','2014-01-07','14:10:00',2.5),('11288','2014-01-07','14:15:00',2.44),('11288','2014-01-07','14:20:00',2.43),('11288','2014-01-07','14:25:00',2.28),('11288','2014-01-07','14:30:00',2.17),('11288','2014-01-07','14:35:00',2.13),('11288','2014-01-07','14:40:00',2.05),('11288','2014-01-07','14:45:00',1.92),('11288','2014-01-07','14:50:00',1.87),('11288','2014-01-07','14:55:00',1.75),('11288','2014-01-07','15:00:00',1.67),('11288','2014-01-07','15:05:00',1.56),('11288','2014-01-07','15:10:00',1.29),('11288','2014-01-07','15:15:00',1.35),('11288','2014-01-07','15:20:00',1.32),('11288','2014-01-07','15:25:00',1.06),('11288','2014-01-07','15:30:00',1.02),('11288','2014-04-24','07:45:00',1.12),('11288','2014-04-24','07:50:00',1.21),('11288','2014-04-24','07:55:00',1.28),('11288','2014-04-24','08:10:00',1.18),('11288','2014-04-24','08:15:00',1.58),('11288','2014-04-24','08:20:00',1.84),('11288','2014-04-24','08:25:00',1.9),('11288','2014-04-24','08:30:00',1.95),('11288','2014-04-24','08:35:00',2.25),('11288','2014-04-24','08:40:00',2.12),('11288','2014-04-24','08:45:00',2.55),('11288','2014-04-24','08:50:00',2.36),('11288','2014-04-24','08:55:00',2.94),('11288','2014-04-24','09:00:00',3.09),('11288','2014-04-24','09:05:00',3.34),('11288','2014-04-24','09:10:00',2.78),('11288','2014-04-24','09:15:00',3.62),('11288','2014-04-24','09:20:00',3.76),('11288','2014-04-24','09:25:00',3.78),('11288','2014-04-24','09:30:00',3.16),('11288','2014-04-24','09:35:00',3.92),('11288','2014-04-24','09:40:00',4.13),('11288','2014-04-24','09:45:00',4.2),('11288','2014-04-24','09:50:00',4.24),('11288','2014-04-24','09:55:00',4.28),('11288','2014-04-24','10:00:00',4.42),('11288','2014-04-24','10:05:00',4.77),('11288','2014-04-24','10:10:00',4.91),('11288','2014-04-24','10:15:00',5.09),('11288','2014-04-24','10:20:00',5.22),('11288','2014-04-24','10:25:00',5.3),('11288','2014-04-24','10:30:00',5.45),('11288','2014-04-24','10:35:00',5.53),('11288','2014-04-24','10:40:00',5.63),('11288','2014-04-24','10:45:00',5.68),('11288','2014-04-24','10:50:00',5.74),('11288','2014-04-24','10:55:00',5.77),('11288','2014-04-24','11:00:00',5.78),('11288','2014-04-24','11:05:00',5.9),('11288','2014-04-24','11:10:00',5.92),('11288','2014-04-24','11:15:00',5.96),('11288','2014-04-24','11:20:00',6.02),('11288','2014-04-24','11:25:00',6.03),('11288','2014-04-24','11:30:00',6.03),('11288','2014-04-24','11:35:00',6.09),('11288','2014-04-24','11:40:00',6.19),('11288','2014-04-24','11:45:00',6.27),('11288','2014-04-24','11:50:00',6.32),('11288','2014-04-24','11:55:00',6.3),('11288','2014-04-24','12:00:00',6.35),('11288','2014-04-24','12:05:00',6.48),('11288','2014-04-24','12:10:00',3.17),('11288','2014-04-24','12:15:00',6.49),('11288','2014-04-24','12:20:00',6.81),('11288','2014-04-24','12:25:00',6.75),('11288','2014-04-24','12:30:00',6.11),('11288','2014-04-24','12:35:00',6.79),('11288','2014-04-24','12:40:00',6.78),('11288','2014-04-24','12:45:00',6.63),('11288','2014-04-24','12:50:00',6.76),('11288','2014-04-24','12:55:00',6.82),('11288','2014-04-24','13:00:00',6.77),('11288','2014-04-24','13:05:00',6.74),('11288','2014-04-24','13:10:00',6.84),('11288','2014-04-24','13:15:00',6.99),('11288','2014-04-24','13:20:00',6.93),('11288','2014-04-24','13:25:00',6.91),('11288','2014-04-24','13:30:00',6.08),('11288','2014-04-24','13:35:00',3.27),('11288','2014-04-24','13:40:00',3.54),('11288','2014-04-24','13:45:00',3.81),('11288','2014-04-24','13:50:00',7.73),('11288','2014-04-24','13:55:00',7.59),('11288','2014-04-24','14:00:00',7.59),('11288','2014-04-24','14:05:00',7.43),('11288','2014-04-24','14:10:00',7.4),('11288','2014-04-24','14:15:00',7.4),('11288','2014-04-24','14:20:00',7.06),('11288','2014-04-24','14:25:00',7.12),('11288','2014-04-24','14:30:00',5.96),('11288','2014-04-24','14:35:00',5.88),('11288','2014-04-24','14:40:00',5.18),('11288','2014-04-24','14:45:00',3.37),('11288','2014-04-24','14:50:00',4.26),('11288','2014-04-24','14:55:00',7.58),('11288','2014-04-24','15:00:00',7.17),('11288','2014-04-24','15:05:00',7.07),('11288','2014-04-24','15:10:00',7.39),('11288','2014-04-24','15:15:00',6.76),('11288','2014-04-24','15:20:00',5.12),('11288','2014-04-24','15:25:00',3.73),('11288','2014-04-24','15:30:00',4.65),('11288','2014-04-24','15:35:00',4.49),('11288','2014-04-24','15:40:00',4.14),('11288','2014-04-24','15:45:00',3.7),('11288','2014-04-24','15:50:00',4.24),('11288','2014-04-24','15:55:00',4.85),('11288','2014-04-24','16:00:00',6.37),('11288','2014-04-24','16:05:00',5.68),('11288','2014-04-24','16:10:00',4.97),('11288','2014-04-24','16:15:00',6.18),('11288','2014-04-24','16:20:00',5.6),('11288','2014-04-24','16:25:00',4.27),('11288','2014-04-24','16:30:00',4.2),('11288','2014-04-24','16:35:00',3.28),('11288','2014-04-24','16:40:00',3.28),('11288','2014-04-24','16:45:00',2.64),('11288','2014-04-24','16:50:00',2.2),('11288','2014-04-24','16:55:00',2.29),('11288','2014-04-24','17:00:00',2.4),('11288','2014-04-24','17:05:00',2.22),('11288','2014-04-24','17:10:00',2.09),('11288','2014-04-24','17:15:00',1.88),('11288','2014-04-24','17:20:00',1.86),('11288','2014-04-24','17:25:00',1.85),('11288','2014-04-24','17:30:00',1.88),('11288','2014-04-24','17:35:00',1.69),('11288','2014-04-24','17:40:00',1.41),('11288','2014-01-06','11:05:00',1.19),('11288','2014-01-06','11:10:00',1.48),('11288','2014-01-06','11:15:00',1.8),('11288','2014-01-06','11:20:00',1.7),('11288','2014-01-06','11:25:00',1.61),('11288','2014-01-06','11:30:00',1.44),('11288','2014-01-06','11:35:00',1.85),('11288','2014-01-06','11:40:00',3.65),('11288','2014-01-06','11:45:00',3.86),('11288','2014-01-06','11:50:00',3.3),('11288','2014-01-06','11:55:00',2.91),('11288','2014-01-06','12:00:00',3.88),('11288','2014-01-06','12:05:00',3.66),('11288','2014-01-06','12:10:00',3.61),('11288','2014-01-06','12:15:00',3.38),('11288','2014-01-06','12:20:00',3.43),('11288','2014-01-06','12:25:00',3.62),('11288','2014-01-06','12:30:00',3.6),('11288','2014-01-06','12:35:00',3.58),('11288','2014-01-06','12:40:00',3.51),('11288','2014-01-06','12:45:00',3.48),('11288','2014-01-06','12:50:00',3.49),('11288','2014-01-06','12:55:00',3.46),('11288','2014-01-06','13:00:00',3.36),('11288','2014-01-06','13:05:00',3.31),('11288','2014-01-06','13:10:00',3.31),('11288','2014-01-06','13:15:00',3.47),('11288','2014-01-06','13:20:00',3.3),('11288','2014-01-06','13:25:00',3.29),('11288','2014-01-06','13:30:00',3.12),('11288','2014-01-06','13:35:00',3.04),('11288','2014-01-06','13:40:00',2.96),('11288','2014-01-06','13:45:00',2.86),('11288','2014-01-06','13:50:00',2.81),('11288','2014-01-06','13:55:00',2.74),('11288','2014-01-06','14:00:00',2.49),('11288','2014-01-06','14:05:00',1.14),('11288','2014-01-06','14:10:00',1.26),('11288','2014-01-06','14:15:00',2.22),('11288','2014-01-06','14:20:00',2.04),('11288','2014-01-06','14:25:00',1.18),('11288','2014-01-06','14:30:00',1.25),('11288','2014-01-06','14:35:00',1.95),('11288','2014-01-06','14:40:00',2.33),('11288','2014-01-06','14:45:00',2.55),('11288','2014-01-06','14:50:00',2.02),('11288','2014-01-06','14:55:00',1.78),('11288','2014-01-06','15:00:00',1.48),('11288','2014-01-06','15:05:00',1.5),('11288','2014-01-06','15:10:00',1.45),('11288','2014-01-06','15:15:00',1.35),('11288','2014-01-06','15:20:00',1.25),('11288','2014-01-06','15:25:00',1.08),('11288','2014-01-06','15:30:00',1.04),('11288','2014-01-05','13:20:00',1.11),('11288','2014-01-05','13:30:00',1.02),('11288','2014-01-05','15:10:00',1.14),('11288','2014-01-05','15:15:00',1.09),('11288','2014-01-04','14:40:00',1.03),('11288','2014-01-04','14:50:00',1),('11288','2014-01-04','14:55:00',1.12),('11288','2014-01-04','15:00:00',1.38),('11288','2014-01-03','09:15:00',1.25),('11288','2014-01-03','09:30:00',1.37),('11288','2014-01-03','09:35:00',2.1),('11288','2014-01-03','09:40:00',2.42),('11288','2014-01-03','09:45:00',2.51),('11288','2014-01-03','09:50:00',1.7),('11288','2014-01-03','09:55:00',1.63),('11288','2014-01-03','10:00:00',2.52),('11288','2014-01-03','10:05:00',1.8),('11288','2014-01-03','10:10:00',2.19),('11288','2014-01-03','10:15:00',2),('11288','2014-01-03','10:20:00',2.25),('11288','2014-01-03','10:25:00',1.5),('11288','2014-01-03','10:30:00',1.49),('11288','2014-01-03','10:35:00',1.59),('11288','2014-01-03','10:40:00',1.71),('11288','2014-01-03','10:45:00',1.99),('11288','2014-01-03','10:50:00',1.91),('11288','2014-01-03','10:55:00',1.55),('11288','2014-01-03','11:00:00',1.35),('11288','2014-01-03','11:05:00',1.5),('11288','2014-01-03','11:10:00',1.39),('11288','2014-01-03','11:15:00',1.38),('11288','2014-01-03','11:20:00',1.53),('11288','2014-01-03','11:25:00',1.59),('11288','2014-01-03','11:30:00',1.79),('11288','2014-01-03','11:35:00',2.03),('11288','2014-01-03','11:40:00',2.24),('11288','2014-01-03','11:45:00',2.34),('11288','2014-01-03','11:50:00',2.2),('11288','2014-01-03','11:55:00',2.22),('11288','2014-01-03','12:00:00',2.76),('11288','2014-01-03','12:05:00',3.17),('11288','2014-01-03','12:10:00',3.77),('11288','2014-01-03','12:15:00',3.55),('11288','2014-01-03','12:20:00',3.91),('11288','2014-01-03','12:25:00',3.59),('11288','2014-01-03','12:30:00',3.37),('11288','2014-01-03','12:35:00',2.62),('11288','2014-01-03','12:40:00',2.7),('11288','2014-01-03','12:45:00',2.7),('11288','2014-01-03','12:50:00',2.43),('11288','2014-01-03','12:55:00',1.97),('11288','2014-01-03','13:00:00',1.92),('11288','2014-01-03','13:05:00',2.68),('11288','2014-01-03','13:10:00',2.33),('11288','2014-01-03','13:15:00',2.02),('11288','2014-01-03','13:20:00',1.67),('11288','2014-01-03','13:25:00',1.69),('11288','2014-01-03','13:30:00',2.15),('11288','2014-01-03','13:35:00',2.44),('11288','2014-01-03','13:40:00',2.05),('11288','2014-01-03','13:45:00',1.85),('11288','2014-01-03','13:50:00',1.49),('11288','2014-01-03','13:55:00',1.26),('11288','2014-01-03','14:00:00',1.08),('11288','2014-01-02','08:50:00',1.03),('11288','2014-01-02','08:55:00',1.01),('11288','2014-01-02','09:00:00',1.23),('11288','2014-01-02','09:05:00',1.34),('11288','2014-01-02','09:10:00',1.45),('11288','2014-01-02','09:15:00',1.56),('11288','2014-01-02','09:20:00',1.64),('11288','2014-01-02','09:25:00',1.72),('11288','2014-01-02','09:30:00',1.77),('11288','2014-01-02','09:35:00',1.81),('11288','2014-01-02','09:40:00',1.92),('11288','2014-01-02','09:45:00',2.04),('11288','2014-01-02','09:50:00',2.11),('11288','2014-01-02','09:55:00',2.2),('11288','2014-01-02','10:00:00',2.26),('11288','2014-01-02','10:05:00',2.32),('11288','2014-01-02','10:10:00',2.29),('11288','2014-01-02','10:15:00',2.46),('11288','2014-01-02','10:20:00',2.62),('11288','2014-01-02','10:25:00',2.74),('11288','2014-01-02','10:30:00',2.76),('11288','2014-01-02','10:35:00',2.83),('11288','2014-01-02','10:40:00',2.88),('11288','2014-01-02','10:45:00',2.93),('11288','2014-01-02','10:50:00',3.08),('11288','2014-01-02','10:55:00',3.27),('11288','2014-01-02','11:00:00',3.32),('11288','2014-01-02','11:05:00',3.3),('11288','2014-01-02','11:10:00',2.12),('11288','2014-01-02','11:15:00',2.05),('11288','2014-01-02','11:20:00',2.29),('11288','2014-01-02','11:25:00',2.56),('11288','2014-01-02','11:30:00',2.76),('11288','2014-01-02','11:35:00',3.43),('11288','2014-01-02','11:40:00',3.08),('11288','2014-01-02','11:45:00',2.68),('11288','2014-01-02','11:50:00',2.21),('11288','2014-01-02','11:55:00',2.11),('11288','2014-01-02','12:00:00',1.92),('11288','2014-01-02','12:05:00',1.98),('11288','2014-01-02','12:10:00',1.86),('11288','2014-01-02','12:15:00',1.69),('11288','2014-01-02','12:20:00',1.57),('11288','2014-01-02','12:25:00',1.63),('11288','2014-01-02','12:30:00',1.48),('11288','2014-01-02','12:35:00',1.32),('11288','2014-01-02','12:40:00',1.43),('11288','2014-01-02','12:45:00',1.69),('11288','2014-01-02','12:50:00',2.46),('11288','2014-01-02','12:55:00',2.45),('11288','2014-01-02','13:00:00',1.59),('11288','2014-01-02','13:05:00',1.74),('11288','2014-01-02','13:10:00',1.83),('11288','2014-01-02','13:15:00',1.34),('11288','2014-01-02','13:20:00',1.12),('11288','2014-01-02','13:25:00',1.42),('11288','2014-01-02','13:30:00',2.38),('11288','2014-01-02','13:35:00',2.84),('11288','2014-01-02','13:40:00',2.68),('11288','2014-01-02','13:45:00',1.59),('11288','2014-01-02','13:50:00',1.37),('11288','2014-01-02','14:15:00',1.06),('11288','2014-01-02','14:20:00',1.18),('11288','2014-01-02','14:25:00',1.13),('11288','2014-01-02','14:30:00',1.01),('11288','2014-01-01','08:50:00',1.09),('11288','2014-01-01','08:55:00',1.26),('11288','2014-01-01','09:00:00',1.43),('11288','2014-01-01','09:05:00',1.9),('11288','2014-01-01','09:10:00',1.63),('11288','2014-01-01','09:15:00',1.31),('11288','2014-01-01','09:20:00',1.2),('11288','2014-01-01','09:25:00',1.28),('11288','2014-01-01','09:30:00',1.63),('11288','2014-01-01','09:35:00',2.34),('11288','2014-01-01','09:40:00',2.01),('11288','2014-01-01','09:45:00',2.46),('11288','2014-01-01','09:50:00',3.02),('11288','2014-01-01','09:55:00',2.64),('11288','2014-01-01','10:00:00',2.05),('11288','2014-01-01','10:05:00',1.82),('11288','2014-01-01','10:10:00',1.59),('11288','2014-01-01','10:15:00',1.41),('11288','2014-01-01','10:20:00',1.38),('11288','2014-01-01','10:25:00',1.35),('11288','2014-01-01','10:30:00',1.33),('11288','2014-01-01','10:35:00',1.28),('11288','2014-01-01','10:40:00',1.3),('11288','2014-01-01','10:45:00',1.36),('11288','2014-01-01','10:50:00',1.49),('11288','2014-01-01','10:55:00',1.63),('11288','2014-01-01','11:00:00',1.62),('11288','2014-01-01','11:05:00',1.55),('11288','2014-01-01','11:10:00',1.54),('11288','2014-01-01','11:15:00',1.61),('11288','2014-01-01','11:20:00',1.69),('11288','2014-01-01','11:25:00',1.74),('11288','2014-01-01','11:30:00',1.75),('11288','2014-01-01','11:35:00',1.71),('11288','2014-01-01','11:40:00',1.68),('11288','2014-01-01','11:45:00',1.69),('11288','2014-01-01','11:50:00',1.67),('11288','2014-01-01','11:55:00',1.73),('11288','2014-01-01','12:00:00',1.86),('11288','2014-01-01','12:05:00',1.97),('11288','2014-01-01','12:10:00',2.06),('11288','2014-01-01','12:15:00',2.11),('11288','2014-01-01','12:20:00',2.17),('11288','2014-01-01','12:25:00',2.16),('11288','2014-01-01','12:30:00',2.14),('11288','2014-01-01','12:35:00',2.17),('11288','2014-01-01','12:40:00',2.03),('11288','2014-01-01','12:45:00',2.08),('11288','2014-01-01','12:50:00',2.09),('11288','2014-01-01','12:55:00',2.07),('11288','2014-01-01','13:00:00',2.02),('11288','2014-01-01','13:05:00',1.9),('11288','2014-01-01','13:10:00',1.83),('11288','2014-01-01','13:15:00',1.82),('11288','2014-01-01','13:20:00',1.97),('11288','2014-01-01','13:25:00',2),('11288','2014-01-01','13:30:00',2.03),('11288','2014-01-01','13:35:00',2.13),('11288','2014-01-01','13:40:00',2.18),('11288','2014-01-01','13:45:00',1.97),('11288','2014-01-01','13:50:00',3.04),('11288','2014-01-01','13:55:00',2.62),('11288','2014-01-01','14:00:00',2.06),('11288','2014-01-01','14:05:00',1.83),('11288','2014-01-01','14:10:00',1.76),('11288','2014-01-01','14:15:00',1.87),('11288','2014-01-01','14:20:00',1.6),('11288','2014-01-01','14:25:00',1.43),('11288','2014-01-01','14:30:00',1.42),('11288','2014-01-01','14:35:00',1.31),('11288','2014-01-01','14:40:00',1.37),('11288','2014-01-01','14:45:00',1.31),('11288','2014-01-01','14:50:00',1.25),('11288','2014-01-01','14:55:00',1.23),('11288','2014-01-01','15:00:00',1.46),('11288','2014-01-01','15:05:00',1.93),('11288','2014-01-01','15:10:00',1.72),('11288','2014-01-01','15:15:00',1.35),('11288','2014-01-01','15:20:00',1.25),('11288','2013-12-31','09:00:00',1.02),('11288','2013-12-31','09:15:00',1.21),('11288','2013-12-31','09:20:00',1.74),('11288','2013-12-31','09:25:00',1.84),('11288','2013-12-31','09:30:00',2.03),('11288','2013-12-31','09:35:00',2.12),('11288','2013-12-31','09:40:00',1.76),('11288','2013-12-31','09:45:00',1.13),('11288','2013-12-31','09:50:00',2.37),('11288','2013-12-31','09:55:00',1.82),('11288','2013-12-31','10:00:00',1.98),('11288','2013-12-31','10:05:00',1.9),('11288','2013-12-31','10:10:00',1.37),('11288','2013-12-31','10:15:00',1.43),('11288','2013-12-31','10:20:00',1.28),('11288','2013-12-31','10:25:00',1.35),('11288','2013-12-31','10:30:00',1.65),('11288','2013-12-31','10:35:00',1.65),('11288','2013-12-31','10:40:00',1.63),('11288','2013-12-31','10:45:00',1.67),('11288','2013-12-31','10:50:00',2.05),('11288','2013-12-31','10:55:00',2.12),('11288','2013-12-31','11:00:00',2.07),('11288','2013-12-31','11:05:00',2.08),('11288','2013-12-31','11:10:00',1.94),('11288','2013-12-31','11:15:00',1.87),('11288','2013-12-31','11:20:00',1.78),('11288','2013-12-31','11:25:00',2.78),('11288','2013-12-31','11:30:00',3.91),('11288','2013-12-31','11:35:00',2.67),('11288','2013-12-31','11:40:00',3.48),('11288','2013-12-31','11:45:00',1.24),('11288','2013-12-31','11:50:00',1.74),('11288','2013-12-31','11:55:00',1.86),('11288','2013-12-31','12:00:00',3.88),('11288','2013-12-31','12:05:00',3.75),('11288','2013-12-31','12:10:00',3.55),('11288','2013-12-31','12:15:00',3.27),('11288','2013-12-31','12:20:00',3.56),('11288','2013-12-31','12:25:00',3.65),('11288','2013-12-31','12:30:00',3.62),('11288','2013-12-31','12:35:00',3.54),('11288','2013-12-31','12:40:00',3.51),('11288','2013-12-31','12:45:00',3.51),('11288','2013-12-31','12:50:00',3.48),('11288','2013-12-31','12:55:00',3.44),('11288','2013-12-31','13:00:00',3.41),('11288','2013-12-31','13:05:00',3.36),('11288','2013-12-31','13:10:00',3.31),('11288','2013-12-31','13:15:00',3.27),('11288','2013-12-31','13:20:00',3.22),('11288','2013-12-31','13:25:00',3.17),('11288','2013-12-31','13:30:00',3.13),('11288','2013-12-31','13:35:00',3.05),('11288','2013-12-31','13:40:00',2.98),('11288','2013-12-31','13:45:00',2.87),('11288','2013-12-31','13:50:00',2.74),('11288','2013-12-31','13:55:00',2.69),('11288','2013-12-31','14:00:00',2.64),('11288','2013-12-31','14:05:00',2.54),('11288','2013-12-31','14:10:00',2.46),('11288','2013-12-31','14:15:00',2.39),('11288','2013-12-31','14:20:00',2.3),('11288','2013-12-31','14:25:00',2.21),('11288','2013-12-31','14:30:00',2.11),('11288','2013-12-31','14:35:00',1.99),('11288','2013-12-31','14:40:00',1.9),('11288','2013-12-31','14:45:00',1.79),('11288','2013-12-31','14:50:00',1.69),('11288','2013-12-31','14:55:00',1.59),('11288','2013-12-31','15:00:00',1.51),('11288','2013-12-31','15:05:00',1.39),('11288','2013-12-31','15:10:00',1.29),('11288','2013-12-31','15:15:00',1.18),('11288','2013-12-31','15:20:00',1.07),('11288','2013-12-30','09:15:00',1.02),('11288','2013-12-30','09:20:00',1.12),('11288','2013-12-30','09:25:00',1.24),('11288','2013-12-30','09:30:00',1.18),('11288','2013-12-30','11:10:00',1.15),('11288','2013-12-30','11:15:00',1.41),('11288','2013-12-30','11:20:00',1.71),('11288','2013-12-30','11:25:00',1.86),('11288','2013-12-30','11:30:00',1.85),('11288','2013-12-30','11:35:00',1.76),('11288','2013-12-30','11:40:00',1.65),('11288','2013-12-30','11:45:00',1.58),('11288','2013-12-30','11:50:00',1.53),('11288','2013-12-30','11:55:00',1.37),('11288','2013-12-30','12:00:00',1.24),('11288','2013-12-30','12:05:00',1.24),('11288','2013-12-30','12:10:00',1.29),('11288','2013-12-30','12:15:00',1.29),('11288','2013-12-30','12:20:00',1.25),('11288','2013-12-30','12:25:00',1.29),('11288','2013-12-30','12:30:00',1.29),('11288','2013-12-30','12:35:00',1.28),('11288','2013-12-30','12:40:00',1.35),('11288','2013-12-30','12:45:00',1.46),('11288','2013-12-30','12:50:00',1.43),('11288','2013-12-30','12:55:00',1.3),('11288','2013-12-30','13:00:00',1.19),('11288','2013-12-30','13:05:00',1.22),('11288','2013-12-30','13:10:00',1.3),('11288','2013-12-30','13:15:00',1.23),('11288','2013-12-30','13:20:00',1.19),('11288','2013-12-30','13:25:00',1.24),('11288','2013-12-30','13:30:00',1.24),('11288','2013-12-30','13:35:00',1.22),('11288','2013-12-30','13:40:00',1.16),('11288','2013-12-30','13:45:00',1.13),('11288','2013-12-30','13:50:00',1.03),('11288','2013-12-29','08:25:00',1.03),('11288','2013-12-29','08:35:00',1.24),('11288','2013-12-29','08:40:00',1.01),('11288','2013-12-29','09:05:00',1.2),('11288','2013-12-29','09:10:00',1.43),('11288','2013-12-29','09:15:00',1.8),('11288','2013-12-29','09:20:00',1.88),('11288','2013-12-29','09:25:00',1.86),('11288','2013-12-29','09:30:00',1.9),('11288','2013-12-29','09:35:00',1.94),('11288','2013-12-29','09:40:00',2.07),('11288','2013-12-29','09:45:00',2.18),('11288','2013-12-29','09:50:00',2.06),('11288','2013-12-29','09:55:00',1.93),('11288','2013-12-29','10:00:00',1.95),('11288','2013-12-29','10:05:00',2.17),('11288','2013-12-29','10:10:00',2.5),('11288','2013-12-29','10:15:00',2.69),('11288','2013-12-29','10:20:00',2.95),('11288','2013-12-29','10:25:00',2.94),('11288','2013-12-29','10:30:00',3.62),('11288','2013-12-29','10:35:00',4.11),('11288','2013-12-29','10:40:00',2.66),('11288','2013-12-29','10:45:00',2.21),('11288','2013-12-29','10:50:00',1.65),('11288','2013-12-29','10:55:00',2.19),('11288','2013-12-29','11:00:00',1.3),('11288','2013-12-29','11:05:00',1.5),('11288','2013-12-29','11:10:00',1.26),('11288','2013-12-29','11:15:00',1.28),('11288','2013-12-29','11:30:00',1.14),('11288','2013-12-29','11:35:00',1.09),('11288','2013-12-29','11:50:00',1.08),('11288','2013-12-29','11:55:00',1.38),('11288','2013-12-29','12:00:00',1.36),('11288','2013-12-29','12:05:00',1.26),('11288','2013-12-29','12:10:00',1.14),('11288','2013-12-29','13:35:00',1.15),('11288','2013-12-29','13:40:00',1.18),('11288','2013-12-28','08:50:00',1.05),('11288','2013-12-28','08:55:00',1.12),('11288','2013-12-28','09:00:00',1.27),('11288','2013-12-28','09:05:00',1.37),('11288','2013-12-28','09:10:00',1.47),('11288','2013-12-28','09:15:00',1.56),('11288','2013-12-28','09:20:00',1.69),('11288','2013-12-28','09:25:00',1.79),('11288','2013-12-28','09:30:00',1.83),('11288','2013-12-28','09:35:00',1.92),('11288','2013-12-28','09:40:00',1.98),('11288','2013-12-28','09:45:00',2.08),('11288','2013-12-28','09:50:00',2.16),('11288','2013-12-28','09:55:00',2.23),('11288','2013-12-28','10:00:00',2.31),('11288','2013-12-28','10:05:00',2.32),('11288','2013-12-28','10:10:00',2.23),('11288','2013-12-28','10:15:00',2.57),('11288','2013-12-28','10:20:00',2.68),('11288','2013-12-28','10:25:00',2.78),('11288','2013-12-28','10:30:00',2.84),('11288','2013-12-28','10:35:00',2.91),('11288','2013-12-28','10:40:00',2.89),('11288','2013-12-28','10:45:00',3.04),('11288','2013-12-28','10:50:00',3.1),('11288','2013-12-28','10:55:00',3.18),('11288','2013-12-28','11:00:00',3.24),('11288','2013-12-28','11:05:00',3.33),('11288','2013-12-28','11:10:00',3.36),('11288','2013-12-28','11:15:00',3.4),('11288','2013-12-28','11:20:00',3.46),('11288','2013-12-28','11:25:00',3.37),('11288','2013-12-28','11:30:00',3.46),('11288','2013-12-28','11:35:00',3.48),('11288','2013-12-28','11:40:00',3.52),('11288','2013-12-28','11:45:00',3.54),('11288','2013-12-28','11:50:00',3.54),('11288','2013-12-28','11:55:00',3.53),('11288','2013-12-28','12:00:00',3.55),('11288','2013-12-28','12:05:00',3.51),('11288','2013-12-28','12:10:00',3.29),('11288','2013-12-28','12:15:00',3.49),('11288','2013-12-28','12:20:00',3.47),('11288','2013-12-28','12:25:00',3.44),('11288','2013-12-28','12:30:00',3.43),('11288','2013-12-28','12:35:00',3.4),('11288','2013-12-28','12:40:00',3.37),('11288','2013-12-28','12:45:00',3.38),('11288','2013-12-28','12:50:00',3.32),('11288','2013-12-28','12:55:00',3.29),('11288','2013-12-28','13:00:00',3.2),('11288','2013-12-28','13:05:00',3.16),('11288','2013-12-28','13:10:00',3.11),('11288','2013-12-28','13:15:00',3.07),('11288','2013-12-28','13:20:00',3.02),('11288','2013-12-28','13:25:00',2.88),('11288','2013-12-28','13:30:00',2.81),('11288','2013-12-28','13:35:00',2.79),('11288','2013-12-28','13:40:00',2.71),('11288','2013-12-28','13:45:00',2.59),('11288','2013-12-28','13:50:00',2.54),('11288','2013-12-28','13:55:00',2.48),('11288','2013-12-28','14:00:00',2.38),('11288','2013-12-28','14:05:00',2.32),('11288','2013-12-28','14:10:00',2.22),('11288','2013-12-28','14:15:00',2.09),('11288','2013-12-28','14:20:00',2),('11288','2013-12-28','14:25:00',2.02),('11288','2013-12-28','14:30:00',1.93),('11288','2013-12-28','14:35:00',1.85),('11288','2013-12-28','14:40:00',1.82),('11288','2013-12-28','14:45:00',1.47),('11288','2013-12-28','14:50:00',1.16),('11288','2013-12-28','15:00:00',1.2),('11288','2013-12-28','15:05:00',1.34),('11288','2013-12-28','15:10:00',1.08),('11288','2013-12-28','15:15:00',1.08),('11288','2014-04-23','10:40:00',1.12),('11288','2014-04-23','10:45:00',1.08),('11288','2014-04-23','10:50:00',1.02),('11288','2014-04-23','11:15:00',1.08),('11288','2014-04-23','11:20:00',1.01),('11288','2014-04-23','11:35:00',1.09),('11288','2014-04-23','11:40:00',1.19),('11288','2014-04-23','11:45:00',1.25),('11288','2014-04-23','11:50:00',1.01),('11288','2014-04-23','12:50:00',1.02),('11288','2014-04-23','12:55:00',1.09),('11288','2014-04-23','13:00:00',1.2),('11288','2014-04-23','13:05:00',1.44),('11288','2014-04-23','13:10:00',1.82),('11288','2014-04-23','13:15:00',2.12),('11288','2014-04-23','13:20:00',2.37),('11288','2014-04-23','13:25:00',2.44),('11288','2014-04-23','13:30:00',2.59),('11288','2014-04-23','13:35:00',2.68),('11288','2014-04-23','13:40:00',2.82),('11288','2014-04-23','13:45:00',2.84),('11288','2014-04-23','13:50:00',2.82),('11288','2014-04-23','13:55:00',2.83),('11288','2014-04-23','14:00:00',2.69),('11288','2014-04-23','14:05:00',2.7),('11288','2014-04-23','14:10:00',2.58),('11288','2014-04-23','14:15:00',2.15),('11288','2014-04-23','14:20:00',1.87),('11288','2014-04-23','14:25:00',1.69),('11288','2014-04-23','14:30:00',1.6),('11288','2014-04-23','14:35:00',1.53),('11288','2014-04-23','14:40:00',1.59),('11288','2014-04-23','14:45:00',1.86),('11288','2014-04-23','14:50:00',2.22),('11288','2014-04-23','14:55:00',2.57),('11288','2014-04-23','15:00:00',2.87),('11288','2014-04-23','15:05:00',3),('11288','2014-04-23','15:10:00',2.94),('11288','2014-04-23','15:15:00',3.17),('11288','2014-04-23','15:20:00',2.67),('11288','2014-04-23','15:25:00',2.4),('11288','2014-04-23','15:30:00',2.26),('11288','2014-04-23','15:35:00',2.18),('11288','2014-04-23','15:40:00',2.14),('11288','2014-04-23','15:45:00',2.23),('11288','2014-04-23','15:50:00',2.02),('11288','2014-04-23','15:55:00',1.79),('11288','2014-04-23','16:00:00',1.51),('11288','2014-04-23','16:05:00',1.44),('11288','2014-04-23','16:10:00',1.26),('11288','2014-04-23','16:15:00',1.09),('11288','2013-12-27','10:20:00',1.09),('11288','2013-12-27','10:25:00',1.28),('11288','2013-12-27','10:30:00',1.38),('11288','2013-12-27','10:35:00',1.39),('11288','2013-12-27','10:40:00',1.38),('11288','2013-12-27','10:45:00',1.32),('11288','2013-12-27','10:50:00',1.19),('11288','2013-12-27','10:55:00',1.04),('11288','2013-12-27','11:25:00',1.2),('11288','2013-12-27','11:30:00',1.44),('11288','2013-12-27','11:35:00',1.53),('11288','2013-12-27','11:40:00',1.47),('11288','2013-12-27','11:45:00',1.52),('11288','2013-12-27','11:50:00',1.42),('11288','2013-12-27','11:55:00',1.26),('11288','2013-12-27','12:00:00',1.34),('11288','2013-12-27','12:05:00',1.83),('11288','2013-12-27','12:10:00',2.88),('11288','2013-12-27','12:15:00',2.54),('11288','2013-12-27','12:20:00',2.92),('11288','2013-12-27','12:25:00',2.13),('11288','2013-12-27','12:30:00',1.77),('11288','2013-12-27','12:35:00',1.91),('11288','2013-12-27','12:40:00',2.07),('11288','2013-12-27','12:45:00',2.47),('11288','2013-12-27','12:50:00',3.19),('11288','2013-12-27','12:55:00',3.24),('11288','2013-12-27','13:00:00',3.24),('11288','2013-12-27','13:05:00',2.86),('11288','2013-12-27','13:10:00',1.95),('11288','2013-12-27','13:15:00',1.92),('11288','2013-12-27','13:20:00',2.72),('11288','2013-12-27','13:25:00',2.52),('11288','2013-12-27','13:30:00',3.56),('11288','2013-12-27','13:35:00',3.14),('11288','2013-12-27','13:40:00',2.22),('11288','2013-12-27','13:45:00',1.95),('11288','2013-12-27','13:50:00',1.7),('11288','2013-12-27','13:55:00',1.42),('11288','2013-12-27','14:00:00',1.44),('11288','2013-12-27','14:05:00',1.55),('11288','2013-12-27','14:10:00',1.74),('11288','2013-12-27','14:15:00',1.79),('11288','2013-12-27','14:20:00',1.72),('11288','2013-12-27','14:25:00',1.69),('11288','2013-12-27','14:30:00',1.8),('11288','2013-12-27','14:35:00',1.88),('11288','2013-12-27','14:40:00',1.88),('11288','2013-12-27','14:45:00',1.41),('11288','2013-12-26','09:55:00',1.14),('11288','2013-12-26','11:05:00',1.14),('11288','2013-12-25','09:10:00',1.02),('11288','2013-12-25','09:15:00',1.26),('11288','2013-12-25','09:20:00',1.1),('11288','2013-12-25','09:25:00',1.72),('11288','2013-12-25','09:30:00',1.2),('11288','2013-12-25','09:35:00',1.17),('11288','2013-12-25','09:40:00',1),('11288','2013-12-25','10:25:00',1.66),('11288','2013-12-25','10:30:00',2.34),('11288','2013-12-25','10:35:00',2.37),('11288','2013-12-25','10:40:00',2.1),('11288','2013-12-25','10:45:00',2.36),('11288','2013-12-25','10:50:00',2.13),('11288','2013-12-25','10:55:00',1.63),('11288','2013-12-25','11:00:00',1.45),('11288','2013-12-25','11:05:00',1.63),('11288','2013-12-25','11:10:00',1.63),('11288','2013-12-25','11:15:00',2.12),('11288','2013-12-25','11:20:00',2.94),('11288','2013-12-25','11:25:00',2),('11288','2013-12-25','11:30:00',2.77),('11288','2013-12-25','11:35:00',1.67),('11288','2013-12-25','11:40:00',2.47),('11288','2013-12-25','11:45:00',2.61),('11288','2013-12-25','11:50:00',2.15),('11288','2013-12-25','11:55:00',3.2),('11288','2013-12-25','12:00:00',2.26),('11288','2013-12-25','12:05:00',2.25),('11288','2013-12-25','12:10:00',2.14),('11288','2013-12-25','12:15:00',1.9),('11288','2013-12-25','12:20:00',2.22),('11288','2013-12-25','12:25:00',2.57),('11288','2013-12-25','12:30:00',2.21),('11288','2013-12-25','12:35:00',1.66),('11288','2013-12-25','12:40:00',1.54),('11288','2013-12-25','12:45:00',1.75),('11288','2013-12-25','12:50:00',2.06),('11288','2013-12-25','12:55:00',1.25),('11288','2013-12-25','13:00:00',1.09),('11288','2013-12-25','13:05:00',1.71),('11288','2013-12-25','13:10:00',1.57),('11288','2013-12-25','13:25:00',1.83),('11288','2013-12-25','13:30:00',1.71),('11288','2013-12-25','13:35:00',1.68),('11288','2013-12-25','13:40:00',1.72),('11288','2013-12-25','13:45:00',1.92),('11288','2013-12-25','13:50:00',2.07),('11288','2013-12-25','13:55:00',1.84),('11288','2013-12-25','14:00:00',1.49),('11288','2013-12-25','14:05:00',1.41),('11288','2013-12-25','14:10:00',1.31),('11288','2013-12-25','14:15:00',1.26),('11288','2013-12-25','14:20:00',1.16),('11288','2013-12-25','14:25:00',1.1),('11288','2013-12-25','14:30:00',1.1),('11288','2013-12-25','14:35:00',1.12),('11288','2013-12-25','14:40:00',1.08),('11288','2013-12-25','14:45:00',1.08),('11288','2013-12-25','14:50:00',1.09),('11288','2013-12-25','14:55:00',1),('11288','2013-12-25','15:15:00',1.12),('11288','2013-12-25','15:20:00',1.03),('11288','2013-12-24','08:55:00',1.03),('11288','2013-12-24','09:00:00',1.22),('11288','2013-12-24','09:05:00',1.33),('11288','2013-12-24','09:10:00',1.43),('11288','2013-12-24','09:15:00',1.53),('11288','2013-12-24','09:20:00',1.62),('11288','2013-12-24','09:25:00',1.67),('11288','2013-12-24','09:30:00',1.74),('11288','2013-12-24','09:35:00',1.81),('11288','2013-12-24','09:40:00',1.94),('11288','2013-12-24','09:45:00',1.99),('11288','2013-12-24','09:50:00',1.98),('11288','2013-12-24','09:55:00',2.03),('11288','2013-12-24','10:00:00',2.09),('11288','2013-12-24','10:05:00',2.16),('11288','2013-12-24','10:10:00',2.12),('11288','2013-12-24','10:15:00',2.43),('11288','2013-12-24','10:20:00',2.59),('11288','2013-12-24','10:25:00',2.64),('11288','2013-12-24','10:30:00',2.68),('11288','2013-12-24','10:35:00',2.73),('11288','2013-12-24','10:40:00',2.66),('11288','2013-12-24','10:45:00',2.84),('11288','2013-12-24','10:50:00',2.9),('11288','2013-12-24','10:55:00',2.94),('11288','2013-12-24','11:00:00',3),('11288','2013-12-24','11:05:00',3.05),('11288','2013-12-24','11:10:00',3.06),('11288','2013-12-24','11:15:00',3.05),('11288','2013-12-24','11:20:00',3.12),('11288','2013-12-24','11:25:00',3.01),('11288','2013-12-24','11:30:00',3.14),('11288','2013-12-24','11:35:00',3.23),('11288','2013-12-24','11:40:00',3.21),('11288','2013-12-24','11:45:00',3.23),('11288','2013-12-24','11:50:00',3.29),('11288','2013-12-24','11:55:00',3.27),('11288','2013-12-24','12:00:00',3.24),('11288','2013-12-24','12:05:00',3.16),('11288','2013-12-24','12:10:00',2.99),('11288','2013-12-24','12:15:00',2.97),('11288','2013-12-24','12:20:00',3.21),('11288','2013-12-24','12:25:00',3.2),('11288','2013-12-24','12:30:00',3.13),('11288','2013-12-24','12:35:00',3.04),('11288','2013-12-24','12:40:00',2.99),('11288','2013-12-24','12:45:00',2.99),('11288','2013-12-24','12:50:00',2.99),('11288','2013-12-24','12:55:00',2.95),('11288','2013-12-24','13:00:00',2.86),('11288','2013-12-24','13:05:00',2.88),('11288','2013-12-24','13:10:00',2.86),('11288','2013-12-24','13:15:00',2.8),('11288','2013-12-24','13:20:00',2.7),('11288','2013-12-24','13:25:00',2.63),('11288','2013-12-24','13:30:00',2.6),('11288','2013-12-24','13:35:00',2.53),('11288','2013-12-24','13:40:00',2.43),('11288','2013-12-24','13:45:00',2.34),('11288','2013-12-24','13:50:00',2.26),('11288','2013-12-24','13:55:00',2.18),('11288','2013-12-24','14:00:00',2.1),('11288','2013-12-24','14:05:00',2.06),('11288','2013-12-24','14:10:00',1.99),('11288','2013-12-24','14:15:00',1.93),('11288','2013-12-24','14:20:00',1.86),('11288','2013-12-24','14:25:00',1.74),('11288','2013-12-24','14:30:00',1.62),('11288','2013-12-24','14:35:00',1.51),('11288','2013-12-24','14:40:00',1.37),('11288','2013-12-24','14:45:00',1.23),('11288','2013-12-24','14:50:00',1.18),('11288','2013-12-24','14:55:00',1.1),('11288','2013-12-23','09:15:00',1.08),('11288','2013-12-23','09:20:00',1.2),('11288','2013-12-23','09:25:00',1.35),('11288','2013-12-23','09:30:00',1.44),('11288','2013-12-23','09:35:00',1.53),('11288','2013-12-23','09:40:00',1.53),('11288','2013-12-23','09:45:00',1.56),('11288','2013-12-23','09:50:00',1.82),('11288','2013-12-23','09:55:00',2.12),('11288','2013-12-23','10:00:00',2.51),('11288','2013-12-23','10:05:00',2.63),('11288','2013-12-23','10:10:00',2.53),('11288','2013-12-23','10:15:00',2.69),('11288','2013-12-23','10:20:00',2.74),('11288','2013-12-23','10:25:00',2.68),('11288','2013-12-23','10:30:00',2.62),('11288','2013-12-23','10:35:00',2.68),('11288','2013-12-23','10:40:00',2.76),('11288','2013-12-23','10:45:00',2.85),('11288','2013-12-23','10:50:00',2.94),('11288','2013-12-23','10:55:00',3.25),('11288','2013-12-23','11:00:00',3.52),('11288','2013-12-23','11:05:00',3.54),('11288','2013-12-23','11:10:00',3.61),('11288','2013-12-23','11:15:00',3.5),('11288','2013-12-23','11:20:00',3.51),('11288','2013-12-23','11:25:00',3.27),('11288','2013-12-23','11:30:00',3.51),('11288','2013-12-23','11:35:00',3.62),('11288','2013-12-23','11:40:00',3.27),('11288','2013-12-23','11:45:00',3.07),('11288','2013-12-23','11:50:00',3.25),('11288','2013-12-23','11:55:00',3.32),('11288','2013-12-23','12:00:00',3.47),('11288','2013-12-23','12:05:00',3.33),('11288','2013-12-23','12:10:00',3.2),('11288','2013-12-23','12:15:00',3.37),('11288','2013-12-23','12:20:00',3.32),('11288','2013-12-23','12:25:00',3.27),('11288','2013-12-23','12:30:00',3.21),('11288','2013-12-23','12:35:00',3.19),('11288','2013-12-23','12:40:00',3.34),('11288','2013-12-23','12:45:00',3.33),('11288','2013-12-23','12:50:00',3.3),('11288','2013-12-23','12:55:00',3.26),('11288','2013-12-23','13:00:00',3.2),('11288','2013-12-23','13:05:00',3.19),('11288','2013-12-23','13:10:00',3.1),('11288','2013-12-23','13:15:00',3.01),('11288','2013-12-23','13:20:00',2.42),('11288','2013-12-23','13:25:00',2.8),('11288','2013-12-23','13:30:00',2.35),('11288','2013-12-23','13:35:00',1.29),('11288','2013-12-23','13:40:00',2.32),('11288','2013-12-23','13:45:00',1.6),('11288','2013-12-23','13:50:00',2.19),('11288','2013-12-23','13:55:00',2.32),('11288','2013-12-23','14:00:00',2.46),('11288','2013-12-23','14:05:00',2.4),('11288','2013-12-23','14:10:00',2.28),('11288','2013-12-23','14:15:00',2.14),('11288','2013-12-23','14:20:00',2.1),('11288','2013-12-23','14:25:00',2),('11288','2013-12-23','14:30:00',1.78),('11288','2013-12-23','14:35:00',1.85),('11288','2013-12-23','14:40:00',1.7),('11288','2013-12-23','14:45:00',1.59),('11288','2013-12-23','14:50:00',1.51),('11288','2013-12-23','14:55:00',1.42),('11288','2013-12-23','15:00:00',1.31),('11288','2013-12-23','15:05:00',1.19),('11288','2013-12-23','15:10:00',1.09),('11288','2013-12-22','09:00:00',1.19),('11288','2013-12-22','09:05:00',1.44),('11288','2013-12-22','09:10:00',1.4),('11288','2013-12-22','09:15:00',1.54),('11288','2013-12-22','09:20:00',1.74),('11288','2013-12-22','09:25:00',1.72),('11288','2013-12-22','09:30:00',1.82),('11288','2013-12-22','09:35:00',2.45),('11288','2013-12-22','09:40:00',2.76),('11288','2013-12-22','09:45:00',2.87),('11288','2013-12-22','09:50:00',3),('11288','2013-12-22','09:55:00',2.95),('11288','2013-12-22','10:00:00',2.92),('11288','2013-12-22','10:05:00',2.86),('11288','2013-12-22','10:10:00',2.97),('11288','2013-12-22','10:15:00',2.98),('11288','2013-12-22','10:20:00',2.97),('11288','2013-12-22','10:25:00',3.01),('11288','2013-12-22','10:30:00',3.15),('11288','2013-12-22','10:35:00',2.91),('11288','2013-12-22','10:40:00',2.77),('11288','2013-12-22','10:45:00',3.06),('11288','2013-12-22','10:50:00',3.01),('11288','2013-12-22','10:55:00',2.85),('11288','2013-12-22','11:00:00',2.63),('11288','2013-12-22','11:05:00',2.93),('11288','2013-12-22','11:10:00',3.58),('11288','2013-12-22','11:15:00',3.43),('11288','2013-12-22','11:20:00',3.14),('11288','2013-12-22','11:25:00',3.16),('11288','2013-12-22','11:30:00',2.97),('11288','2013-12-22','11:35:00',3.06),('11288','2013-12-22','11:40:00',3.21),('11288','2013-12-22','11:45:00',2.92),('11288','2013-12-22','11:50:00',2.23),('11288','2013-12-22','11:55:00',1.7),('11288','2013-12-22','12:00:00',1.36),('11288','2013-12-22','12:05:00',1.29),('11288','2013-12-22','12:10:00',1.35),('11288','2013-12-22','12:15:00',1.5),('11288','2013-12-22','12:20:00',1.88),('11288','2013-12-22','12:25:00',2.05),('11288','2013-12-22','12:30:00',2.45),('11288','2013-12-22','12:35:00',2.67),('11288','2013-12-22','12:40:00',2.59),('11288','2013-12-22','12:45:00',2.65),('11288','2013-12-22','12:50:00',3.12),('11288','2013-12-22','12:55:00',3.67),('11288','2013-12-22','13:00:00',3.5),('11288','2013-12-22','13:05:00',4.11),('11288','2013-12-22','13:10:00',3.98),('11288','2013-12-22','13:15:00',3.09),('11288','2013-12-22','13:20:00',2.93),('11288','2013-12-22','13:25:00',2.91),('11288','2013-12-22','13:30:00',2.69),('11288','2013-12-22','13:35:00',2.51),('11288','2013-12-22','13:40:00',2.04),('11288','2013-12-22','13:45:00',2.3),('11288','2013-12-22','13:50:00',1.98),('11288','2013-12-22','13:55:00',1.89),('11288','2013-12-22','14:00:00',1.63),('11288','2013-12-22','14:05:00',1.97),('11288','2013-12-22','14:10:00',2.02),('11288','2013-12-22','14:15:00',1.6),('11288','2013-12-22','14:20:00',1.67),('11288','2013-12-22','14:25:00',1.37),('11288','2013-12-22','14:30:00',1.38),('11288','2013-12-22','14:35:00',1.65),('11288','2013-12-22','14:40:00',1.65),('11288','2013-12-22','14:45:00',1.56),('11288','2013-12-22','14:50:00',1.1),('11288','2013-12-22','14:55:00',1.03),('11288','2013-12-22','15:00:00',1.05),('11288','2013-12-22','15:05:00',1),('11288','2013-12-22','15:10:00',1),('11288','2013-12-21','08:50:00',1),('11288','2013-12-21','08:55:00',1.17),('11288','2013-12-21','09:00:00',1.27),('11288','2013-12-21','09:05:00',1.36),('11288','2013-12-21','09:10:00',1.44),('11288','2013-12-21','09:15:00',1.55),('11288','2013-12-21','09:20:00',1.67),('11288','2013-12-21','09:25:00',1.75),('11288','2013-12-21','09:30:00',1.83),('11288','2013-12-21','09:35:00',1.9),('11288','2013-12-21','09:40:00',1.95),('11288','2013-12-21','09:45:00',2.03),('11288','2013-12-21','09:50:00',2.09),('11288','2013-12-21','09:55:00',2.17),('11288','2013-12-21','10:00:00',2.2),('11288','2013-12-21','10:05:00',2.13),('11288','2013-12-21','10:10:00',2.39),('11288','2013-12-21','10:15:00',2.54),('11288','2013-12-21','10:20:00',2.64),('11288','2013-12-21','10:25:00',2.68),('11288','2013-12-21','10:30:00',2.76),('11288','2013-12-21','10:35:00',2.81),('11288','2013-12-21','10:40:00',2.9),('11288','2013-12-21','10:45:00',2.98),('11288','2013-12-21','10:50:00',3.03),('11288','2013-12-21','10:55:00',3.09),('11288','2013-12-21','11:00:00',3.17),('11288','2013-12-21','11:05:00',3.24),('11288','2013-12-21','11:10:00',3.27),('11288','2013-12-21','11:15:00',3.32),('11288','2013-12-21','11:20:00',3.31),('11288','2013-12-21','11:25:00',3.33),('11288','2013-12-21','11:30:00',3.4),('11288','2013-12-21','11:35:00',3.41),('11288','2013-12-21','11:40:00',3.45),('11288','2013-12-21','11:45:00',3.49),('11288','2013-12-21','11:50:00',3.5),('11288','2013-12-21','11:55:00',3.52),('11288','2013-12-21','12:00:00',3.48),('11288','2013-12-21','12:05:00',3.33),('11288','2013-12-21','12:10:00',3.4),('11288','2013-12-21','12:15:00',3.5),('11288','2013-12-21','12:20:00',3.48),('11288','2013-12-21','12:25:00',3.47),('11288','2013-12-21','12:30:00',3.44),('11288','2013-12-21','12:35:00',3.4),('11288','2013-12-21','12:40:00',3.39),('11288','2013-12-21','12:45:00',3.36),('11288','2013-12-21','12:50:00',3.35),('11288','2013-12-21','12:55:00',3.32),('11288','2013-12-21','13:00:00',3.24),('11288','2013-12-21','13:05:00',3.18),('11288','2013-12-21','13:10:00',3.15),('11288','2013-12-21','13:15:00',3.09),('11288','2013-12-21','13:20:00',3.01),('11288','2013-12-21','13:25:00',2.95),('11288','2013-12-21','13:30:00',2.89),('11288','2013-12-21','13:35:00',2.81),('11288','2013-12-21','13:40:00',2.72),('11288','2013-12-21','13:45:00',2.63),('11288','2013-12-21','13:50:00',2.55),('11288','2013-12-21','13:55:00',2.49),('11288','2013-12-21','14:00:00',2.42),('11288','2013-12-21','14:05:00',2.34),('11288','2013-12-21','14:10:00',2.26),('11288','2013-12-21','14:15:00',2.17),('11288','2013-12-21','14:20:00',2.13),('11288','2013-12-21','14:25:00',2.01),('11288','2013-12-21','14:30:00',1.91),('11288','2013-12-21','14:35:00',1.82),('11288','2013-12-21','14:40:00',1.71),('11288','2013-12-21','14:45:00',1.62),('11288','2013-12-21','14:50:00',1.52),('11288','2013-12-21','14:55:00',1.42),('11288','2013-12-21','15:00:00',1.3),('11288','2013-12-21','15:05:00',1.05),('11288','2013-12-21','15:10:00',1.11),('11288','2013-12-20','08:45:00',1),('11288','2013-12-20','08:50:00',1.08),('11288','2013-12-20','08:55:00',1.09),('11288','2013-12-20','09:00:00',1.25),('11288','2013-12-20','09:05:00',1.34),('11288','2013-12-20','09:10:00',1.42),('11288','2013-12-20','09:15:00',1.54),('11288','2013-12-20','09:20:00',1.64),('11288','2013-12-20','09:25:00',1.7),('11288','2013-12-20','09:30:00',1.79),('11288','2013-12-20','09:35:00',1.85),('11288','2013-12-20','09:40:00',1.92),('11288','2013-12-20','09:45:00',1.99),('11288','2013-12-20','09:50:00',2.09),('11288','2013-12-20','09:55:00',2.14),('11288','2013-12-20','10:00:00',2.17),('11288','2013-12-20','10:05:00',2.23),('11288','2013-12-20','10:10:00',2.29),('11288','2013-12-20','10:15:00',2.45),('11288','2013-12-20','10:20:00',2.53),('11288','2013-12-20','10:25:00',2.6),('11288','2013-12-20','10:30:00',2.68),('11288','2013-12-20','10:35:00',2.7),('11288','2013-12-20','10:40:00',2.68),('11288','2013-12-20','10:45:00',2.86),('11288','2013-12-20','10:50:00',2.91),('11288','2013-12-20','10:55:00',2.99),('11288','2013-12-20','11:00:00',3.05),('11288','2013-12-20','11:05:00',3.12),('11288','2013-12-20','11:10:00',3.14),('11288','2013-12-20','11:15:00',3.12),('11288','2013-12-20','11:20:00',3.13),('11288','2013-12-20','11:25:00',3.14),('11288','2013-12-20','11:30:00',3.18),('11288','2013-12-20','11:35:00',3.24),('11288','2013-12-20','11:40:00',3.19),('11288','2013-12-20','11:45:00',3.26),('11288','2013-12-20','11:50:00',3.33),('11288','2013-12-20','11:55:00',3.3),('11288','2013-12-20','12:00:00',3.3),('11288','2013-12-20','12:05:00',3.15),('11288','2013-12-20','12:10:00',2.94),('11288','2013-12-20','12:15:00',3.18),('11288','2013-12-20','12:20:00',3.31),('11288','2013-12-20','12:25:00',3.26),('11288','2013-12-20','12:30:00',3.23),('11288','2013-12-20','12:35:00',3.22),('11288','2013-12-20','12:40:00',3.2),('11288','2013-12-20','12:45:00',3.16),('11288','2013-12-20','12:50:00',3.11),('11288','2013-12-20','12:55:00',3.07),('11288','2013-12-20','13:00:00',3.03),('11288','2013-12-20','13:05:00',2.98),('11288','2013-12-20','13:10:00',2.92),('11288','2013-12-20','13:15:00',2.86),('11288','2013-12-20','13:20:00',2.76),('11288','2013-12-20','13:25:00',2.65),('11288','2013-12-20','13:30:00',2.57),('11288','2013-12-20','13:35:00',2.53),('11288','2013-12-20','13:40:00',2.37),('11288','2013-12-20','13:45:00',2.31),('11288','2013-12-20','13:50:00',2.28),('11288','2013-12-20','13:55:00',2.27),('11288','2013-12-20','14:00:00',1.59),('11288','2013-12-20','14:05:00',1.3),('11288','2013-12-20','14:10:00',1.2),('11288','2013-12-19','08:55:00',1.44),('11288','2013-12-19','09:00:00',1.74),('11288','2013-12-19','09:05:00',1.83),('11288','2013-12-19','09:10:00',1.76),('11288','2013-12-19','09:15:00',1.83),('11288','2013-12-19','09:20:00',2.27),('11288','2013-12-19','09:25:00',1.53),('11288','2013-12-19','09:30:00',2.01),('11288','2013-12-19','09:35:00',1.69),('11288','2013-12-19','09:40:00',1.44),('11288','2013-12-19','09:45:00',1.29),('11288','2013-12-19','09:50:00',2.15),('11288','2013-12-19','09:55:00',2.43),('11288','2013-12-19','10:00:00',2.38),('11288','2013-12-19','10:05:00',2.74),('11288','2013-12-19','10:10:00',2.96),('11288','2013-12-19','10:15:00',2.72),('11288','2013-12-19','10:20:00',2.14),('11288','2013-12-19','10:25:00',1.84),('11288','2013-12-19','10:30:00',1.58),('11288','2013-12-19','10:35:00',1.55),('11288','2013-12-19','10:40:00',2.52),('11288','2013-12-19','10:45:00',3.14),('11288','2013-12-19','10:50:00',2.07),('11288','2013-12-19','10:55:00',1.26),('11288','2013-12-19','11:00:00',1.13),('11288','2013-12-19','11:05:00',1.05),('11288','2013-12-19','11:10:00',1.61),('11288','2013-12-19','11:15:00',1.87),('11288','2013-12-19','11:20:00',1.81),('11288','2013-12-19','11:25:00',1.37),('11288','2013-12-19','11:30:00',1.07),('11288','2013-12-19','12:35:00',1.26),('11288','2013-12-19','12:40:00',1.47),('11288','2013-12-19','12:45:00',1.34),('11288','2013-12-19','12:50:00',1.23),('11288','2013-12-19','12:55:00',1.15),('11288','2013-12-19','13:00:00',1.15),('11288','2013-12-19','13:05:00',1.03),('11288','2013-12-19','13:20:00',1.05),('11288','2013-12-19','13:25:00',1),('11288','2013-12-19','13:45:00',1.06),('11288','2013-12-19','13:50:00',1.14),('11288','2013-12-19','13:55:00',1.27),('11288','2013-12-19','14:00:00',1.42),('11288','2013-12-19','14:05:00',1.4),('11288','2013-12-19','14:10:00',1.24),('11288','2013-12-19','14:15:00',1.17),('11288','2013-12-19','14:20:00',1.31),('11288','2013-12-19','14:25:00',1.46),('11288','2013-12-19','14:30:00',1.87),('11288','2013-12-19','14:35:00',1.46),('11288','2013-12-19','14:40:00',1.37),('11288','2013-12-18','08:45:00',1),('11288','2013-12-18','08:50:00',1.1),('11288','2013-12-18','08:55:00',1.23),('11288','2013-12-18','09:00:00',1.34),('11288','2013-12-18','09:05:00',1.44),('11288','2013-12-18','09:10:00',1.51),('11288','2013-12-18','09:15:00',1.63),('11288','2013-12-18','09:20:00',1.73),('11288','2013-12-18','09:25:00',1.79),('11288','2013-12-18','09:30:00',1.86),('11288','2013-12-18','09:35:00',1.94),('11288','2013-12-18','09:40:00',2.03),('11288','2013-12-18','09:45:00',2.09),('11288','2013-12-18','09:50:00',2.18),('11288','2013-12-18','09:55:00',2.25),('11288','2013-12-18','10:00:00',2.26),('11288','2013-12-18','10:05:00',2.21),('11288','2013-12-18','10:10:00',2.52),('11288','2013-12-18','10:15:00',2.65),('11288','2013-12-18','10:20:00',2.75),('11288','2013-12-18','10:25:00',2.8),('11288','2013-12-18','10:30:00',2.86),('11288','2013-12-18','10:35:00',2.87),('11288','2013-12-18','10:40:00',2.99),('11288','2013-12-18','10:45:00',3.04),('11288','2013-12-18','10:50:00',3.11),('11288','2013-12-18','10:55:00',3.15),('11288','2013-12-18','11:00:00',3.22),('11288','2013-12-18','11:05:00',3.28),('11288','2013-12-18','11:10:00',3.31),('11288','2013-12-18','11:15:00',3.35),('11288','2013-12-18','11:20:00',3.31),('11288','2013-12-18','11:25:00',3.37),('11288','2013-12-18','11:30:00',3.37),('11288','2013-12-18','11:35:00',3.4),('11288','2013-12-18','11:40:00',3.44),('11288','2013-12-18','11:45:00',3.46),('11288','2013-12-18','11:50:00',3.44),('11288','2013-12-18','11:55:00',3.43),('11288','2013-12-18','12:00:00',3.38),('11288','2013-12-18','12:05:00',3.19),('11288','2013-12-18','12:10:00',3.4),('11288','2013-12-18','12:15:00',3.42),('11288','2013-12-18','12:20:00',3.41),('11288','2013-12-18','12:25:00',3.4),('11288','2013-12-18','12:30:00',3.35),('11288','2013-12-18','12:35:00',3.3),('11288','2013-12-18','12:40:00',3.36),('11288','2013-12-18','12:45:00',3.32),('11288','2013-12-18','12:50:00',3.26),('11288','2013-12-18','12:55:00',3.24),('11288','2013-12-18','13:00:00',3.17),('11288','2013-12-18','13:05:00',3.07),('11288','2013-12-18','13:10:00',3.08),('11288','2013-12-18','13:15:00',3),('11288','2013-12-18','13:20:00',2.91),('11288','2013-12-18','13:25:00',2.88),('11288','2013-12-18','13:30:00',2.78),('11288','2013-12-18','13:35:00',2.72),('11288','2013-12-18','13:40:00',2.57),('11288','2013-12-18','13:45:00',2.51),('11288','2013-12-18','13:50:00',2.41),('11288','2013-12-18','13:55:00',2.36),('11288','2013-12-18','14:00:00',2.31),('11288','2013-12-18','14:05:00',2.18),('11288','2013-12-18','14:10:00',2.13),('11288','2013-12-18','14:15:00',2.12),('11288','2013-12-18','14:20:00',2.05),('11288','2013-12-18','14:25:00',1.97),('11288','2013-12-18','14:30:00',1.88),('11288','2013-12-18','14:35:00',1.78),('11288','2013-12-18','14:40:00',1.67),('11288','2013-12-18','14:45:00',1.58),('11288','2013-12-18','14:50:00',1.5),('11288','2013-12-18','14:55:00',1.44),('11288','2013-12-18','15:00:00',1.28),('11288','2013-12-18','15:05:00',1.02),('11288','2013-12-18','15:10:00',1.06),('11288','2014-04-22','07:45:00',1.13),('11288','2014-04-22','07:50:00',1.28),('11288','2014-04-22','07:55:00',1.35),('11288','2014-04-22','08:00:00',1.51),('11288','2014-04-22','08:05:00',1.59),('11288','2014-04-22','08:10:00',1.71),('11288','2014-04-22','08:15:00',1.75),('11288','2014-04-22','08:20:00',1.85),('11288','2014-04-22','08:25:00',1.98),('11288','2014-04-22','08:30:00',2.21),('11288','2014-04-22','08:35:00',2.25),('11288','2014-04-22','08:40:00',2.47),('11288','2014-04-22','08:45:00',2.71),('11288','2014-04-22','08:50:00',2.92),('11288','2014-04-22','08:55:00',2.95),('11288','2014-04-22','09:00:00',2.77),('11288','2014-04-22','09:05:00',3.5),('11288','2014-04-22','09:10:00',3.31),('11288','2014-04-22','09:15:00',3.29),('11288','2014-04-22','09:20:00',3.77),('11288','2014-04-22','09:25:00',3.8),('11288','2014-04-22','09:30:00',2.93),('11288','2014-04-22','09:35:00',3.68),('11288','2014-04-22','09:40:00',3.8),('11288','2014-04-22','09:45:00',4.56),('11288','2014-04-22','09:50:00',3.56),('11288','2014-04-22','09:55:00',2.44),('11288','2014-04-22','10:00:00',2.33),('11288','2014-04-22','10:05:00',2.51),('11288','2014-04-22','10:10:00',3.32),('11288','2014-04-22','10:15:00',3.64),('11288','2014-04-22','10:20:00',5.09),('11288','2014-04-22','10:25:00',3.61),('11288','2014-04-22','10:30:00',5.88),('11288','2014-04-22','10:35:00',5.95),('11288','2014-04-22','10:40:00',5.84),('11288','2014-04-22','10:45:00',6.26),('11288','2014-04-22','10:50:00',6.22),('11288','2014-04-22','10:55:00',4.62),('11288','2014-04-22','11:00:00',3.4),('11288','2014-04-22','11:05:00',3.91),('11288','2014-04-22','11:10:00',2.88),('11288','2014-04-22','11:15:00',2.5),('11288','2014-04-22','11:20:00',2.18),('11288','2014-04-22','11:25:00',2.16),('11288','2014-04-22','11:30:00',1.99),('11288','2014-04-22','11:35:00',2.08),('11288','2014-04-22','11:40:00',1.85),('11288','2014-04-22','11:45:00',1.58),('11288','2014-04-22','11:50:00',1.65),('11288','2014-04-22','11:55:00',1.57),('11288','2014-04-22','12:00:00',1.75),('11288','2014-04-22','12:05:00',2.12),('11288','2014-04-22','12:10:00',2.11),('11288','2014-04-22','12:15:00',2.15),('11288','2014-04-22','12:20:00',2.23),('11288','2014-04-22','12:25:00',2.42),('11288','2014-04-22','12:30:00',2.77),('11288','2014-04-22','12:35:00',2.36),('11288','2014-04-22','12:40:00',1.79),('11288','2014-04-22','12:45:00',1.49),('11288','2014-04-22','12:50:00',1.3),('11288','2014-04-22','12:55:00',1.25),('11288','2014-04-22','13:00:00',1.27),('11288','2014-04-22','13:05:00',1.39),('11288','2014-04-22','13:10:00',1.67),('11288','2014-04-22','13:15:00',2.68),('11288','2014-04-22','13:20:00',3.92),('11288','2014-04-22','13:25:00',4.57),('11288','2014-04-22','13:30:00',4.71),('11288','2014-04-22','13:35:00',4.54),('11288','2014-04-22','13:40:00',5.34),('11288','2014-04-22','13:45:00',5.35),('11288','2014-04-22','13:50:00',4.41),('11288','2014-04-22','13:55:00',2.65),('11288','2014-04-22','14:00:00',2.37),('11288','2014-04-22','14:05:00',3.4),('11288','2014-04-22','14:10:00',5.71),('11288','2014-04-22','14:15:00',5.69),('11288','2014-04-22','14:20:00',6.59),('11288','2014-04-22','14:25:00',3.86),('11288','2014-04-22','14:30:00',3.64),('11288','2014-04-22','14:35:00',4.37),('11288','2014-04-22','14:40:00',5.72),('11288','2014-04-22','14:45:00',6.84),('11288','2014-04-22','14:50:00',6.37),('11288','2014-04-22','14:55:00',4.74),('11288','2014-04-22','15:00:00',2.24),('11288','2014-04-22','15:05:00',2.21),('11288','2014-04-22','15:10:00',2.08),('11288','2014-04-22','15:15:00',2.08),('11288','2014-04-22','15:20:00',2.3),('11288','2014-04-22','15:25:00',2.57),('11288','2014-04-22','15:30:00',3.24),('11288','2014-04-22','15:35:00',4.35),('11288','2014-04-22','15:40:00',3.55),('11288','2014-04-22','15:45:00',3.24),('11288','2014-04-22','15:50:00',3.79),('11288','2014-04-22','15:55:00',3.14),('11288','2014-04-22','16:00:00',3.63),('11288','2014-04-22','16:05:00',2.6),('11288','2014-04-22','16:10:00',2.53),('11288','2014-04-22','16:15:00',2.43),('11288','2014-04-22','16:20:00',2.8),('11288','2014-04-22','16:25:00',2.63),('11288','2014-04-22','16:30:00',2.25),('11288','2014-04-22','16:35:00',2.49),('11288','2014-04-22','16:40:00',2.98),('11288','2014-04-22','16:45:00',2.77),('11288','2014-04-22','16:50:00',2.25),('11288','2014-04-22','16:55:00',1.97),('11288','2014-04-22','17:00:00',2.27),('11288','2014-04-22','17:05:00',2.47),('11288','2014-04-22','17:10:00',1.94),('11288','2014-04-22','17:15:00',1.71),('11288','2014-04-22','17:20:00',1.32),('11288','2014-04-22','17:25:00',1.14),('11288','2014-04-22','17:30:00',1.08),('11288','2014-04-22','17:35:00',1.25),('11288','2014-04-22','17:40:00',1.25),('11288','2014-04-22','17:45:00',1.11),('11288','2014-04-22','17:50:00',1.02),('11288','2013-12-17','08:40:00',1.06),('11288','2013-12-17','08:45:00',1.09),('11288','2013-12-17','08:50:00',1.22),('11288','2013-12-17','08:55:00',1.34),('11288','2013-12-17','09:00:00',1.44),('11288','2013-12-17','09:05:00',1.53),('11288','2013-12-17','09:10:00',1.62),('11288','2013-12-17','09:15:00',1.71),('11288','2013-12-17','09:20:00',1.79),('11288','2013-12-17','09:25:00',1.83),('11288','2013-12-17','09:30:00',1.93),('11288','2013-12-17','09:35:00',2.01),('11288','2013-12-17','09:40:00',2.08),('11288','2013-12-17','09:45:00',2.17),('11288','2013-12-17','09:50:00',2.25),('11288','2013-12-17','09:55:00',2.31),('11288','2013-12-17','10:00:00',2.37),('11288','2013-12-17','10:05:00',2.44),('11288','2013-12-17','10:10:00',2.58),('11288','2013-12-17','10:15:00',2.71),('11288','2013-12-17','10:20:00',2.79),('11288','2013-12-17','10:25:00',2.84),('11288','2013-12-17','10:30:00',2.91),('11288','2013-12-17','10:35:00',2.93),('11288','2013-12-17','10:40:00',3.06),('11288','2013-12-17','10:45:00',3.1),('11288','2013-12-17','10:50:00',3.16),('11288','2013-12-17','10:55:00',3.23),('11288','2013-12-17','11:00:00',3.29),('11288','2013-12-17','11:05:00',3.29),('11288','2013-12-17','11:10:00',3.36),('11288','2013-12-17','11:15:00',3.44),('11288','2013-12-17','11:20:00',3.38),('11288','2013-12-17','11:25:00',3.43),('11288','2013-12-17','11:30:00',3.44),('11288','2013-12-17','11:35:00',3.49),('11288','2013-12-17','11:40:00',3.51),('11288','2013-12-17','11:45:00',3.53),('11288','2013-12-17','11:50:00',3.58),('11288','2013-12-17','11:55:00',3.59),('11288','2013-12-17','12:00:00',3.53),('11288','2013-12-17','12:05:00',3.4),('11288','2013-12-17','12:10:00',3.58),('11288','2013-12-17','12:15:00',3.57),('11288','2013-12-17','12:20:00',3.58),('11288','2013-12-17','12:25:00',3.57),('11288','2013-12-17','12:30:00',3.53),('11288','2013-12-17','12:35:00',3.51),('11288','2013-12-17','12:40:00',3.49),('11288','2013-12-17','12:45:00',3.46),('11288','2013-12-17','12:50:00',3.41),('11288','2013-12-17','12:55:00',3.38),('11288','2013-12-17','13:00:00',3.29),('11288','2013-12-17','13:05:00',3.25),('11288','2013-12-17','13:10:00',3.2),('11288','2013-12-17','13:15:00',3.16),('11288','2013-12-17','13:20:00',3.07),('11288','2013-12-17','13:25:00',3.02),('11288','2013-12-17','13:30:00',2.96),('11288','2013-12-17','13:35:00',2.87),('11288','2013-12-17','13:40:00',2.76),('11288','2013-12-17','13:45:00',2.69),('11288','2013-12-17','13:50:00',2.65),('11288','2013-12-17','13:55:00',2.58),('11288','2013-12-17','14:00:00',2.47),('11288','2013-12-17','14:05:00',2.39),('11288','2013-12-17','14:10:00',2.3),('11288','2013-12-17','14:15:00',2.21),('11288','2013-12-17','14:20:00',2.11),('11288','2013-12-17','14:25:00',1.99),('11288','2013-12-17','14:30:00',1.89),('11288','2013-12-17','14:35:00',1.78),('11288','2013-12-17','14:40:00',1.71),('11288','2013-12-17','14:45:00',1.61),('11288','2013-12-17','14:50:00',1.51),('11288','2013-12-17','14:55:00',1.43),('11288','2013-12-17','15:00:00',1.24),('11288','2013-12-17','15:05:00',1.1),('11288','2013-12-17','15:10:00',1.07),('11288','2013-12-16','08:40:00',1.01),('11288','2013-12-16','08:45:00',1.04),('11288','2013-12-16','08:50:00',1.2),('11288','2013-12-16','08:55:00',1.29),('11288','2013-12-16','09:00:00',1.41),('11288','2013-12-16','09:05:00',1.5),('11288','2013-12-16','09:10:00',1.56),('11288','2013-12-16','09:15:00',1.69),('11288','2013-12-16','09:20:00',1.77),('11288','2013-12-16','09:25:00',1.82),('11288','2013-12-16','09:30:00',1.89),('11288','2013-12-16','09:35:00',1.98),('11288','2013-12-16','09:40:00',2.06),('11288','2013-12-16','09:45:00',2.15),('11288','2013-12-16','09:50:00',2.22),('11288','2013-12-16','09:55:00',2.28),('11288','2013-12-16','10:00:00',2.28),('11288','2013-12-16','10:05:00',2.32),('11288','2013-12-16','10:10:00',2.56),('11288','2013-12-16','10:15:00',2.68),('11288','2013-12-16','10:20:00',2.72),('11288','2013-12-16','10:25:00',2.76),('11288','2013-12-16','10:30:00',2.82),('11288','2013-12-16','10:35:00',2.86),('11288','2013-12-16','10:40:00',2.99),('11288','2013-12-16','10:45:00',3.03),('11288','2013-12-16','10:50:00',3.09),('11288','2013-12-16','10:55:00',3.16),('11288','2013-12-16','11:00:00',3.22),('11288','2013-12-16','11:05:00',3.27),('11288','2013-12-16','11:10:00',3.27),('11288','2013-12-16','11:15:00',3.3),('11288','2013-12-16','11:20:00',3.28),('11288','2013-12-16','11:25:00',3.37),('11288','2013-12-16','11:30:00',3.39),('11288','2013-12-16','11:35:00',3.41),('11288','2013-12-16','11:40:00',3.45),('11288','2013-12-16','11:45:00',3.47),('11288','2013-12-16','11:50:00',3.52),('11288','2013-12-16','11:55:00',3.52),('11288','2013-12-16','12:00:00',3.46),('11288','2013-12-16','12:05:00',3.33),('11288','2013-12-16','12:10:00',3.54),('11288','2013-12-16','12:15:00',3.54),('11288','2013-12-16','12:20:00',3.55),('11288','2013-12-16','12:25:00',3.55),('11288','2013-12-16','12:30:00',3.49),('11288','2013-12-16','12:35:00',3.43),('11288','2013-12-16','12:40:00',3.45),('11288','2013-12-16','12:45:00',3.4),('11288','2013-12-16','12:50:00',3.37),('11288','2013-12-16','12:55:00',3.33),('11288','2013-12-16','13:00:00',3.28),('11288','2013-12-16','13:05:00',3.25),('11288','2013-12-16','13:10:00',3.21),('11288','2013-12-16','13:15:00',3.14),('11288','2013-12-16','13:20:00',3.07),('11288','2013-12-16','13:25:00',3),('11288','2013-12-16','13:30:00',2.92),('11288','2013-12-16','13:35:00',2.81),('11288','2013-12-16','13:40:00',2.7),('11288','2013-12-16','13:45:00',2.64),('11288','2013-12-16','13:50:00',2.58),('11288','2013-12-16','13:55:00',2.53),('11288','2013-12-16','14:00:00',2.42),('11288','2013-12-16','14:05:00',2.33),('11288','2013-12-16','14:10:00',2.29),('11288','2013-12-16','14:15:00',2.21),('11288','2013-12-16','14:20:00',2.11),('11288','2013-12-16','14:25:00',2),('11288','2013-12-16','14:30:00',1.89),('11288','2013-12-16','14:35:00',1.79),('11288','2013-12-16','14:40:00',1.69),('11288','2013-12-16','14:45:00',1.6),('11288','2013-12-16','14:50:00',1.48),('11288','2013-12-16','14:55:00',1.38),('11288','2013-12-16','15:00:00',1.19),('11288','2013-12-16','15:05:00',1.11),('11288','2013-12-16','15:10:00',1.1),('11288','2013-12-15','09:45:00',1.14),('11288','2013-12-15','09:50:00',1.28),('11288','2013-12-15','09:55:00',1.3),('11288','2013-12-15','10:00:00',1.28),('11288','2013-12-15','10:05:00',1.28),('11288','2013-12-15','10:10:00',1.37),('11288','2013-12-15','10:15:00',1.47),('11288','2013-12-15','10:20:00',1.9),('11288','2013-12-15','10:25:00',2.03),('11288','2013-12-15','10:30:00',1.92),('11288','2013-12-15','10:35:00',2.02),('11288','2013-12-15','10:40:00',2.05),('11288','2013-12-15','10:45:00',2.05),('11288','2013-12-15','10:50:00',1.69),('11288','2013-12-15','10:55:00',1.44),('11288','2013-12-15','11:00:00',1.43),('11288','2013-12-15','11:05:00',1.39),('11288','2013-12-15','11:10:00',1.36),('11288','2013-12-15','11:15:00',1.41),('11288','2013-12-15','11:20:00',1.55),('11288','2013-12-15','11:25:00',1.53),('11288','2013-12-15','11:30:00',1.49),('11288','2013-12-15','11:35:00',1.56),('11288','2013-12-15','11:40:00',1.64),('11288','2013-12-15','11:45:00',1.7),('11288','2013-12-15','11:50:00',1.66),('11288','2013-12-15','11:55:00',1.63),('11288','2013-12-15','12:00:00',1.69),('11288','2013-12-15','12:05:00',1.69),('11288','2013-12-15','12:10:00',1.54),('11288','2013-12-15','12:15:00',1.44),('11288','2013-12-15','12:20:00',1.51),('11288','2013-12-15','12:25:00',1.16),('11288','2013-12-15','12:35:00',1.01),('11288','2013-12-15','12:40:00',1.13),('11288','2013-12-15','12:45:00',1.26),('11288','2013-12-15','12:50:00',1.26),('11288','2013-12-14','08:45:00',1.02),('11288','2013-12-14','08:50:00',1.16),('11288','2013-12-14','08:55:00',1.26),('11288','2013-12-14','09:00:00',1.37),('11288','2013-12-14','09:05:00',1.48),('11288','2013-12-14','09:10:00',1.59),('11288','2013-12-14','09:15:00',1.69),('11288','2013-12-14','09:20:00',1.75),('11288','2013-12-14','09:25:00',1.82),('11288','2013-12-14','09:30:00',1.93),('11288','2013-12-14','09:35:00',2.01),('11288','2013-12-14','09:40:00',2.09),('11288','2013-12-14','09:45:00',2.17),('11288','2013-12-14','09:50:00',2.23),('11288','2013-12-14','09:55:00',2.28),('11288','2013-12-14','10:00:00',2.26),('11288','2013-12-14','10:05:00',2.36),('11288','2013-12-14','10:10:00',2.56),('11288','2013-12-14','10:15:00',2.67),('11288','2013-12-14','10:20:00',2.75),('11288','2013-12-14','10:25:00',2.79),('11288','2013-12-14','10:30:00',2.84),('11288','2013-12-14','10:35:00',2.89),('11288','2013-12-14','10:40:00',2.98),('11288','2013-12-14','10:45:00',3.06),('11288','2013-12-14','10:50:00',3.12),('11288','2013-12-14','10:55:00',3.16),('11288','2013-12-14','11:00:00',3.21),('11288','2013-12-14','11:05:00',3.25),('11288','2013-12-14','11:10:00',3.3),('11288','2013-12-14','11:15:00',3.33),('11288','2013-12-14','11:20:00',3.28),('11288','2013-12-14','11:25:00',3.33),('11288','2013-12-14','11:30:00',3.35),('11288','2013-12-14','11:35:00',3.37),('11288','2013-12-14','11:40:00',3.4),('11288','2013-12-14','11:45:00',3.37),('11288','2013-12-14','11:50:00',3.35),('11288','2013-12-14','11:55:00',3.32),('11288','2013-12-14','12:00:00',3.21),('11288','2013-12-14','12:05:00',3.2),('11288','2013-12-14','12:10:00',3.36),('11288','2013-12-14','12:15:00',3.29),('11288','2013-12-14','12:20:00',3.34),('11288','2013-12-14','12:25:00',3.27),('11288','2013-12-14','12:30:00',3.33),('11288','2013-12-14','12:35:00',3.29),('11288','2013-12-14','12:40:00',3.31),('11288','2013-12-14','12:45:00',3.3),('11288','2013-12-14','12:50:00',3.23),('11288','2013-12-14','12:55:00',3.1),('11288','2013-12-14','13:00:00',3.07),('11288','2013-12-14','13:05:00',3.07),('11288','2013-12-14','13:10:00',3),('11288','2013-12-14','13:15:00',2.96),('11288','2013-12-14','13:20:00',2.95),('11288','2013-12-14','13:25:00',2.94),('11288','2013-12-14','13:30:00',2.91),('11288','2013-12-14','13:35:00',2.78),('11288','2013-12-14','13:40:00',2.67),('11288','2013-12-14','13:45:00',2.56),('11288','2013-12-14','13:50:00',2.49),('11288','2013-12-14','13:55:00',2.48),('11288','2013-12-14','14:00:00',2.4),('11288','2013-12-14','14:05:00',2.33),('11288','2013-12-14','14:10:00',2.23),('11288','2013-12-14','14:15:00',2.14),('11288','2013-12-14','14:20:00',2.04),('11288','2013-12-14','14:25:00',1.9),('11288','2013-12-14','14:30:00',1.85),('11288','2013-12-14','14:35:00',1.7),('11288','2013-12-14','14:40:00',1.62),('11288','2013-12-14','14:45:00',1.53),('11288','2013-12-14','14:50:00',1.43),('11288','2013-12-14','14:55:00',1.36),('11288','2013-12-14','15:00:00',1.16),('11288','2013-12-14','15:05:00',1.13),('11288','2013-12-14','15:10:00',1.1),('11288','2013-12-13','08:45:00',1.02),('11288','2013-12-13','08:50:00',1.14),('11288','2013-12-13','08:55:00',1.24),('11288','2013-12-13','09:00:00',1.34),('11288','2013-12-13','09:05:00',1.45),('11288','2013-12-13','09:10:00',1.52),('11288','2013-12-13','09:15:00',1.61),('11288','2013-12-13','09:20:00',1.69),('11288','2013-12-13','09:25:00',1.72),('11288','2013-12-13','09:30:00',1.8),('11288','2013-12-13','09:35:00',1.86),('11288','2013-12-13','09:40:00',1.92),('11288','2013-12-13','09:45:00',1.99),('11288','2013-12-13','09:50:00',2.06),('11288','2013-12-13','09:55:00',2.14),('11288','2013-12-13','10:00:00',2.14),('11288','2013-12-13','10:05:00',2.29),('11288','2013-12-13','10:10:00',2.41),('11288','2013-12-13','10:15:00',2.5),('11288','2013-12-13','10:20:00',2.54),('11288','2013-12-13','10:25:00',2.62),('11288','2013-12-13','10:30:00',2.69),('11288','2013-12-13','10:35:00',2.76),('11288','2013-12-13','10:40:00',2.86),('11288','2013-12-13','10:45:00',2.92),('11288','2013-12-13','10:50:00',2.94),('11288','2013-12-13','10:55:00',3.01),('11288','2013-12-13','11:00:00',3.09),('11288','2013-12-13','11:05:00',3.16),('11288','2013-12-13','11:10:00',3.21),('11288','2013-12-13','11:15:00',3.2),('11288','2013-12-13','11:20:00',3.12),('11288','2013-12-13','11:25:00',3.16),('11288','2013-12-13','11:30:00',3.17),('11288','2013-12-13','11:35:00',3.28),('11288','2013-12-13','11:40:00',3.33),('11288','2013-12-13','11:45:00',3.41),('11288','2013-12-13','11:50:00',3.4),('11288','2013-12-13','11:55:00',3.39),('11288','2013-12-13','12:00:00',3.27),('11288','2013-12-13','12:05:00',3.24),('11288','2013-12-13','12:10:00',3.42),('11288','2013-12-13','12:15:00',3.32),('11288','2013-12-13','12:20:00',3.32),('11288','2013-12-13','12:25:00',3.24),('11288','2013-12-13','12:30:00',3.23),('11288','2013-12-13','12:35:00',3.17),('11288','2013-12-13','12:40:00',3.26),('11288','2013-12-13','12:45:00',3.16),('11288','2013-12-13','12:50:00',3.14),('11288','2013-12-13','12:55:00',3.06),('11288','2013-12-13','13:00:00',3.11),('11288','2013-12-13','13:05:00',3.09),('11288','2013-12-13','13:10:00',3.08),('11288','2013-12-13','13:15:00',2.99),('11288','2013-12-13','13:20:00',3),('11288','2013-12-13','13:25:00',2.97),('11288','2013-12-13','13:30:00',2.93),('11288','2013-12-13','13:35:00',2.81),('11288','2013-12-13','13:40:00',2.71),('11288','2013-12-13','13:45:00',2.59),('11288','2013-12-13','13:50:00',2.53),('11288','2013-12-13','13:55:00',2.46),('11288','2013-12-13','14:00:00',2.42),('11288','2013-12-13','14:05:00',2.37),('11288','2013-12-13','14:10:00',2.25),('11288','2013-12-13','14:15:00',2.16),('11288','2013-12-13','14:20:00',2.07),('11288','2013-12-13','14:25:00',1.92),('11288','2013-12-13','14:30:00',1.86),('11288','2013-12-13','14:35:00',1.78),('11288','2013-12-13','14:40:00',1.7),('11288','2013-12-13','14:45:00',1.63),('11288','2013-12-13','14:50:00',1.53),('11288','2013-12-13','14:55:00',1.34),('11288','2013-12-13','15:00:00',1.12),('11288','2013-12-13','15:05:00',1.07),('11288','2013-12-13','15:10:00',1.01),('11288','2013-12-12','08:40:00',1.02),('11288','2013-12-12','08:45:00',1.05),('11288','2013-12-12','08:50:00',1.2),('11288','2013-12-12','08:55:00',1.29),('11288','2013-12-12','09:00:00',1.4),('11288','2013-12-12','09:05:00',1.49),('11288','2013-12-12','09:10:00',1.58),('11288','2013-12-12','09:15:00',1.69),('11288','2013-12-12','09:20:00',1.75),('11288','2013-12-12','09:25:00',1.8),('11288','2013-12-12','09:30:00',1.89),('11288','2013-12-12','09:35:00',1.99),('11288','2013-12-12','09:40:00',2.08),('11288','2013-12-12','09:45:00',2.16),('11288','2013-12-12','09:50:00',2.22),('11288','2013-12-12','09:55:00',2.27),('11288','2013-12-12','10:00:00',2.22),('11288','2013-12-12','10:05:00',2.31),('11288','2013-12-12','10:10:00',2.56),('11288','2013-12-12','10:15:00',2.68),('11288','2013-12-12','10:20:00',2.73),('11288','2013-12-12','10:25:00',2.78),('11288','2013-12-12','10:30:00',2.86),('11288','2013-12-12','10:35:00',2.87),('11288','2013-12-12','10:40:00',3),('11288','2013-12-12','10:45:00',3.05),('11288','2013-12-12','10:50:00',3.12),('11288','2013-12-12','10:55:00',3.17),('11288','2013-12-12','11:00:00',3.21),('11288','2013-12-12','11:05:00',3.24),('11288','2013-12-12','11:10:00',3.29),('11288','2013-12-12','11:15:00',3.29),('11288','2013-12-12','11:20:00',3.19),('11288','2013-12-12','11:25:00',3.27),('11288','2013-12-12','11:30:00',3.33),('11288','2013-12-12','11:35:00',3.34),('11288','2013-12-12','11:40:00',3.37),('11288','2013-12-12','11:45:00',3.39),('11288','2013-12-12','11:50:00',3.37),('11288','2013-12-12','11:55:00',3.4),('11288','2013-12-12','12:00:00',3.27),('11288','2013-12-12','12:05:00',3.24),('11288','2013-12-12','12:10:00',3.41),('11288','2013-12-12','12:15:00',3.38),('11288','2013-12-12','12:20:00',3.39),('11288','2013-12-12','12:25:00',3.39),('11288','2013-12-12','12:30:00',3.34),('11288','2013-12-12','12:35:00',3.35),('11288','2013-12-12','12:40:00',3.3),('11288','2013-12-12','12:45:00',3.2),('11288','2013-12-12','12:50:00',3.21),('11288','2013-12-12','12:55:00',3.13),('11288','2013-12-12','13:00:00',3.08),('11288','2013-12-12','13:05:00',3.04),('11288','2013-12-12','13:10:00',3.01),('11288','2013-12-12','13:15:00',2.88),('11288','2013-12-12','13:20:00',2.88),('11288','2013-12-12','13:25:00',2.9),('11288','2013-12-12','13:30:00',2.83),('11288','2013-12-12','13:35:00',2.72),('11288','2013-12-12','13:40:00',2.59),('11288','2013-12-12','13:45:00',2.58),('11288','2013-12-12','13:50:00',2.52),('11288','2013-12-12','13:55:00',2.45),('11288','2013-12-12','14:00:00',2.37),('11288','2013-12-12','14:05:00',2.3),('11288','2013-12-12','14:10:00',2.22),('11288','2013-12-12','14:15:00',2.09),('11288','2013-12-12','14:20:00',2),('11288','2013-12-12','14:25:00',1.88),('11288','2013-12-12','14:30:00',1.79),('11288','2013-12-12','14:35:00',1.68),('11288','2013-12-12','14:40:00',1.58),('11288','2013-12-12','14:45:00',1.49),('11288','2013-12-12','14:50:00',1.42),('11288','2013-12-12','14:55:00',1.31),('11288','2013-12-12','15:00:00',1.08),('11288','2013-12-11','08:40:00',1.03),('11288','2013-12-11','08:45:00',1.03),('11288','2013-12-11','08:50:00',1.2),('11288','2013-12-11','08:55:00',1.3),('11288','2013-12-11','09:00:00',1.38),('11288','2013-12-11','09:05:00',1.48),('11288','2013-12-11','09:10:00',1.55),('11288','2013-12-11','09:15:00',1.63),('11288','2013-12-11','09:20:00',1.73),('11288','2013-12-11','09:25:00',1.79),('11288','2013-12-11','09:30:00',1.88),('11288','2013-12-11','09:35:00',1.98),('11288','2013-12-11','09:40:00',2.06),('11288','2013-12-11','09:45:00',2.18),('11288','2013-12-11','09:50:00',2.23),('11288','2013-12-11','09:55:00',2.29),('11288','2013-12-11','10:00:00',2.22),('11288','2013-12-11','10:05:00',2.48),('11288','2013-12-11','10:10:00',2.6),('11288','2013-12-11','10:15:00',2.7),('11288','2013-12-11','10:20:00',2.78),('11288','2013-12-11','10:25:00',2.86),('11288','2013-12-11','10:30:00',2.9),('11288','2013-12-11','10:35:00',2.99),('11288','2013-12-11','10:40:00',3.07),('11288','2013-12-11','10:45:00',3.11),('11288','2013-12-11','10:50:00',3.15),('11288','2013-12-11','10:55:00',3.24),('11288','2013-12-11','11:00:00',3.3),('11288','2013-12-11','11:05:00',3.35),('11288','2013-12-11','11:10:00',3.43),('11288','2013-12-11','11:15:00',3.41),('11288','2013-12-11','11:20:00',3.44),('11288','2013-12-11','11:25:00',3.47),('11288','2013-12-11','11:30:00',3.4),('11288','2013-12-11','11:35:00',3.47),('11288','2013-12-11','11:40:00',3.5),('11288','2013-12-11','11:45:00',3.53),('11288','2013-12-11','11:50:00',3.56),('11288','2013-12-11','11:55:00',3.55),('11288','2013-12-11','12:00:00',3.39),('11288','2013-12-11','12:05:00',3.48),('11288','2013-12-11','12:10:00',3.57),('11288','2013-12-11','12:15:00',3.48),('11288','2013-12-11','12:20:00',3.47),('11288','2013-12-11','12:25:00',3.42),('11288','2013-12-11','12:30:00',3.36),('11288','2013-12-11','12:35:00',3.4),('11288','2013-12-11','12:40:00',3.4),('11288','2013-12-11','12:45:00',3.4),('11288','2013-12-11','12:50:00',3.37),('11288','2013-12-11','12:55:00',3.3),('11288','2013-12-11','13:00:00',3.28),('11288','2013-12-11','13:05:00',3.21),('11288','2013-12-11','13:10:00',3.13),('11288','2013-12-11','13:15:00',3.09),('11288','2013-12-11','13:20:00',3.05),('11288','2013-12-11','13:25:00',3),('11288','2013-12-11','13:30:00',2.94),('11288','2013-12-11','13:35:00',2.84),('11288','2013-12-11','13:40:00',2.7),('11288','2013-12-11','13:45:00',2.63),('11288','2013-12-11','13:50:00',2.58),('11288','2013-12-11','13:55:00',2.47),('11288','2013-12-11','14:00:00',2.4),('11288','2013-12-11','14:05:00',2.33),('11288','2013-12-11','14:10:00',2.27),('11288','2013-12-11','14:15:00',2.18),('11288','2013-12-11','14:20:00',2.07),('11288','2013-12-11','14:25:00',1.98),('11288','2013-12-11','14:30:00',1.9),('11288','2013-12-11','14:35:00',1.79),('11288','2013-12-11','14:40:00',1.68),('11288','2013-12-11','14:45:00',1.57),('11288','2013-12-11','14:50:00',1.49),('11288','2013-12-11','14:55:00',1.35),('11288','2013-12-11','15:00:00',1.11),('11288','2013-12-11','15:05:00',1.18),('11288','2013-12-11','15:10:00',1.04),('11288','2013-12-10','08:45:00',1.16),('11288','2013-12-10','08:50:00',1.27),('11288','2013-12-10','08:55:00',1.37),('11288','2013-12-10','09:00:00',1.49),('11288','2013-12-10','09:05:00',1.6),('11288','2013-12-10','09:10:00',1.67),('11288','2013-12-10','09:15:00',1.77),('11288','2013-12-10','09:20:00',1.85),('11288','2013-12-10','09:25:00',1.9),('11288','2013-12-10','09:30:00',1.95),('11288','2013-12-10','09:35:00',2.04),('11288','2013-12-10','09:40:00',2.14),('11288','2013-12-10','09:45:00',2.21),('11288','2013-12-10','09:50:00',2.31),('11288','2013-12-10','09:55:00',2.36),('11288','2013-12-10','10:00:00',2.31),('11288','2013-12-10','10:05:00',2.56),('11288','2013-12-10','10:10:00',2.66),('11288','2013-12-10','10:15:00',2.79),('11288','2013-12-10','10:20:00',2.84),('11288','2013-12-10','10:25:00',2.94),('11288','2013-12-10','10:30:00',2.98),('11288','2013-12-10','10:35:00',3.06),('11288','2013-12-10','10:40:00',3.15),('11288','2013-12-10','10:45:00',3.17),('11288','2013-12-10','10:50:00',3.21),('11288','2013-12-10','10:55:00',3.28),('11288','2013-12-10','11:00:00',3.33),('11288','2013-12-10','11:05:00',3.38),('11288','2013-12-10','11:10:00',3.45),('11288','2013-12-10','11:15:00',3.44),('11288','2013-12-10','11:20:00',3.47),('11288','2013-12-10','11:25:00',3.51),('11288','2013-12-10','11:30:00',3.55),('11288','2013-12-10','11:35:00',3.6),('11288','2013-12-10','11:40:00',3.6),('11288','2013-12-10','11:45:00',3.61),('11288','2013-12-10','11:50:00',3.61),('11288','2013-12-10','11:55:00',3.58),('11288','2013-12-10','12:00:00',3.39),('11288','2013-12-10','12:05:00',3.6),('11288','2013-12-10','12:10:00',3.56),('11288','2013-12-10','12:15:00',3.55),('11288','2013-12-10','12:20:00',3.53),('11288','2013-12-10','12:25:00',3.49),('11288','2013-12-10','12:30:00',3.39),('11288','2013-12-10','12:35:00',3.39),('11288','2013-12-10','12:40:00',3.34),('11288','2013-12-10','12:45:00',3.33),('11288','2013-12-10','12:50:00',3.3),('11288','2013-12-10','12:55:00',3.21),('11288','2013-12-10','13:00:00',3.17),('11288','2013-12-10','13:05:00',3.08),('11288','2013-12-10','13:10:00',3.09),('11288','2013-12-10','13:15:00',2.99),('11288','2013-12-10','13:20:00',2.92),('11288','2013-12-10','13:25:00',2.9),('11288','2013-12-10','13:30:00',2.86),('11288','2013-12-10','13:35:00',2.77),('11288','2013-12-10','13:40:00',2.71),('11288','2013-12-10','13:45:00',2.68),('11288','2013-12-10','13:50:00',2.63),('11288','2013-12-10','13:55:00',2.54),('11288','2013-12-10','14:00:00',2.45),('11288','2013-12-10','14:05:00',2.38),('11288','2013-12-10','14:10:00',2.3),('11288','2013-12-10','14:15:00',2.2),('11288','2013-12-10','14:20:00',2.1),('11288','2013-12-10','14:25:00',2.01),('11288','2013-12-10','14:30:00',1.94),('11288','2013-12-10','14:35:00',1.83),('11288','2013-12-10','14:40:00',1.74),('11288','2013-12-10','14:45:00',1.61),('11288','2013-12-10','14:50:00',1.56),('11288','2013-12-10','14:55:00',1.36),('11288','2013-12-10','15:00:00',1.18),('11288','2013-12-10','15:05:00',1.2),('11288','2013-12-10','15:10:00',1.03),('11288','2013-12-09','09:30:00',1.43),('11288','2013-12-09','09:35:00',1.66),('11288','2013-12-09','09:40:00',1.82),('11288','2013-12-09','09:45:00',2.19),('11288','2013-12-09','09:50:00',2.27),('11288','2013-12-09','09:55:00',2.35),('11288','2013-12-09','10:00:00',2.51),('11288','2013-12-09','10:05:00',2.83),('11288','2013-12-09','10:10:00',3.27),('11288','2013-12-09','10:15:00',3.81),('11288','2013-12-09','10:20:00',3.96),('11288','2013-12-09','10:25:00',2.54),('11288','2013-12-09','10:30:00',1.32),('11288','2013-12-09','10:35:00',1.15),('11288','2013-12-09','10:40:00',1.02),('11288','2013-12-09','11:50:00',1.03),('11288','2013-12-09','11:55:00',1.14),('11288','2013-12-09','12:00:00',1.25),('11288','2013-12-09','12:05:00',1.3),('11288','2013-12-09','12:10:00',1.24),('11288','2013-12-09','12:15:00',1.21),('11288','2013-12-09','12:20:00',1.35),('11288','2013-12-09','12:25:00',1.85),('11288','2013-12-09','12:30:00',3.23),('11288','2013-12-09','12:35:00',1.92),('11288','2013-12-09','12:40:00',1.94),('11288','2013-12-09','12:45:00',2.84),('11288','2013-12-09','12:50:00',2.43),('11288','2013-12-09','12:55:00',3.07),('11288','2013-12-09','13:00:00',3.21),('11288','2013-12-09','13:05:00',1.9),('11288','2013-12-09','13:10:00',2.48),('11288','2013-12-09','13:15:00',2.62),('11288','2013-12-09','13:20:00',2.64),('11288','2013-12-09','13:25:00',1.95),('11288','2013-12-09','13:30:00',1.2),('11288','2013-12-09','13:35:00',1.05),('11288','2013-12-09','13:40:00',1.38),('11288','2013-12-09','13:45:00',1.66),('11288','2013-12-09','13:50:00',1.9),('11288','2013-12-09','13:55:00',1.96),('11288','2013-12-09','14:00:00',1.68),('11288','2013-12-09','14:05:00',1.34),('11288','2013-12-09','14:10:00',1.14),('11288','2013-12-09','14:15:00',1.01),('11288','2013-12-09','14:45:00',1.04),('11288','2013-12-09','14:50:00',1.01),('11288','2013-12-08','08:55:00',1.04),('11288','2013-12-08','09:00:00',1.07),('11288','2013-12-08','09:05:00',1.14),('11288','2013-12-08','09:10:00',1.05),('11288','2013-12-08','09:15:00',1),('11288','2013-12-08','09:20:00',1.01),('11288','2013-12-08','09:25:00',1.11),('11288','2013-12-08','09:30:00',1.08),('11288','2013-12-08','09:35:00',1.19),('11288','2013-12-08','09:40:00',1.21),('11288','2013-12-08','09:45:00',1.29),('11288','2013-12-08','09:50:00',1.47),('11288','2013-12-08','09:55:00',1.58),('11288','2013-12-08','10:00:00',1.48),('11288','2013-12-08','10:05:00',1.55),('11288','2013-12-08','10:10:00',1.56),('11288','2013-12-08','10:15:00',1.65),('11288','2013-12-08','10:20:00',1.67),('11288','2013-12-08','10:25:00',1.63),('11288','2013-12-08','10:30:00',1.63),('11288','2013-12-08','10:35:00',1.72),('11288','2013-12-08','10:40:00',1.85),('11288','2013-12-08','10:45:00',1.89),('11288','2013-12-08','10:50:00',1.99),('11288','2013-12-08','10:55:00',2.11),('11288','2013-12-08','11:00:00',2.17),('11288','2013-12-08','11:05:00',2.07),('11288','2013-12-08','11:10:00',2.26),('11288','2013-12-08','11:15:00',3.04),('11288','2013-12-08','11:20:00',1.98),('11288','2013-12-08','11:25:00',1.6),('11288','2013-12-08','11:30:00',1.41),('11288','2013-12-08','11:35:00',1.4),('11288','2013-12-08','11:40:00',1.41),('11288','2013-12-08','11:45:00',1.36),('11288','2013-12-08','11:50:00',1.47),('11288','2013-12-08','11:55:00',1.47),('11288','2013-12-08','12:00:00',1.42),('11288','2013-12-08','12:05:00',1.42),('11288','2013-12-08','12:10:00',1.31),('11288','2013-12-08','12:15:00',1.23),('11288','2013-12-08','12:20:00',1.33),('11288','2013-12-08','12:25:00',1.31),('11288','2013-12-08','12:30:00',1.2),('11288','2013-12-08','12:35:00',1.12),('11288','2013-12-08','12:40:00',1.04),('11288','2013-12-08','12:45:00',1.02),('11288','2013-12-08','12:50:00',1.17),('11288','2013-12-08','12:55:00',2.36),('11288','2013-12-08','13:00:00',1.79),('11288','2013-12-08','13:05:00',2.1),('11288','2013-12-08','13:10:00',3.31),('11288','2013-12-08','13:15:00',2.57),('11288','2013-12-08','13:20:00',1.82),('11288','2013-12-08','13:25:00',2.3),('11288','2013-12-08','13:30:00',2.28),('11288','2013-12-08','13:35:00',1.23),('11288','2014-04-21','08:20:00',1.01),('11288','2014-04-21','08:25:00',1.14),('11288','2014-04-21','08:30:00',1.53),('11288','2014-04-21','08:35:00',1.49),('11288','2014-04-21','08:40:00',1.68),('11288','2014-04-21','08:45:00',1.61),('11288','2014-04-21','08:50:00',1.55),('11288','2014-04-21','08:55:00',1.53),('11288','2014-04-21','09:00:00',1.75),('11288','2014-04-21','09:05:00',1.72),('11288','2014-04-21','09:10:00',1.75),('11288','2014-04-21','09:15:00',1.92),('11288','2014-04-21','09:20:00',2.54),('11288','2014-04-21','09:25:00',1.85),('11288','2014-04-21','09:35:00',1.05),('11288','2014-04-21','09:40:00',1.51),('11288','2014-04-21','09:45:00',1.66),('11288','2014-04-21','09:50:00',1.75),('11288','2014-04-21','09:55:00',1.88),('11288','2014-04-21','10:00:00',2.52),('11288','2014-04-21','10:05:00',4.73),('11288','2014-04-21','10:10:00',4.59),('11288','2014-04-21','10:15:00',5.38),('11288','2014-04-21','10:20:00',5.35),('11288','2014-04-21','10:25:00',5.4),('11288','2014-04-21','10:30:00',5.41),('11288','2014-04-21','10:35:00',5.44),('11288','2014-04-21','10:40:00',5.5),('11288','2014-04-21','10:45:00',5.59),('11288','2014-04-21','10:50:00',5.65),('11288','2014-04-21','10:55:00',5.69),('11288','2014-04-21','11:00:00',5.74),('11288','2014-04-21','11:05:00',5.8),('11288','2014-04-21','11:10:00',5.82),('11288','2014-04-21','11:15:00',5.83),('11288','2014-04-21','11:20:00',5.89),('11288','2014-04-21','11:25:00',5.96),('11288','2014-04-21','11:30:00',6.01),('11288','2014-04-21','11:35:00',6.07),('11288','2014-04-21','11:40:00',6.14),('11288','2014-04-21','11:45:00',6.13),('11288','2014-04-21','11:50:00',6.23),('11288','2014-04-21','11:55:00',6.29),('11288','2014-04-21','12:00:00',6.37),('11288','2014-04-21','12:05:00',6.44),('11288','2014-04-21','12:10:00',6.47),('11288','2014-04-21','12:15:00',6.54),('11288','2014-04-21','12:20:00',6.61),('11288','2014-04-21','12:25:00',6.58),('11288','2014-04-21','12:30:00',6.6),('11288','2014-04-21','12:35:00',6.63),('11288','2014-04-21','12:40:00',6.64),('11288','2014-04-21','12:45:00',6.67),('11288','2014-04-21','12:50:00',6.71),('11288','2014-04-21','12:55:00',6.7),('11288','2014-04-21','13:00:00',6.71),('11288','2014-04-21','13:05:00',6.72),('11288','2014-04-21','13:10:00',6.7),('11288','2014-04-21','13:15:00',6.7),('11288','2014-04-21','13:20:00',6.65),('11288','2014-04-21','13:25:00',6.63),('11288','2014-04-21','13:30:00',6.64),('11288','2014-04-21','13:35:00',6.62),('11288','2014-04-21','13:40:00',6.64),('11288','2014-04-21','13:45:00',6.72),('11288','2014-04-21','13:50:00',6.73),('11288','2014-04-21','13:55:00',6.71),('11288','2014-04-21','14:00:00',6.67),('11288','2014-04-21','14:05:00',6.68),('11288','2014-04-21','14:10:00',6.66),('11288','2014-04-21','14:15:00',6.6),('11288','2014-04-21','14:20:00',6.61),('11288','2014-04-21','14:25:00',6.54),('11288','2014-04-21','14:30:00',6.48),('11288','2014-04-21','14:35:00',6.44),('11288','2014-04-21','14:40:00',6.41),('11288','2014-04-21','14:45:00',6.33),('11288','2014-04-21','14:50:00',6.28),('11288','2014-04-21','14:55:00',6.24),('11288','2014-04-21','15:00:00',6.19),('11288','2014-04-21','15:05:00',6.1),('11288','2014-04-21','15:10:00',6.01),('11288','2014-04-21','15:15:00',5.91),('11288','2014-04-21','15:20:00',5.82),('11288','2014-04-21','15:25:00',5.75),('11288','2014-04-21','15:30:00',5.68),('11288','2014-04-21','15:35:00',5.62),('11288','2014-04-21','15:40:00',5.55),('11288','2014-04-21','15:45:00',5.47),('11288','2014-04-21','15:50:00',5.39),('11288','2014-04-21','15:55:00',5.27),('11288','2014-04-21','16:00:00',5.18),('11288','2014-04-21','16:05:00',5.12),('11288','2014-04-21','16:10:00',5.06),('11288','2014-04-21','16:15:00',5.24),('11288','2014-04-21','16:20:00',4.8),('11288','2014-04-21','16:25:00',4.37),('11288','2014-04-21','16:30:00',4.57),('11288','2014-04-21','16:35:00',4.43),('11288','2014-04-21','16:40:00',4.31),('11288','2014-04-21','16:45:00',4.22),('11288','2014-04-21','16:50:00',4.09),('11288','2014-04-21','16:55:00',3.93),('11288','2014-04-21','17:00:00',3.77),('11288','2014-04-21','17:05:00',3.66),('11288','2014-04-21','17:10:00',3.5),('11288','2014-04-21','17:15:00',3.38),('11288','2014-04-21','17:20:00',3.24),('11288','2014-04-21','17:25:00',3.11),('11288','2014-04-21','17:30:00',3),('11288','2014-04-21','17:35:00',2.83),('11288','2014-04-21','17:40:00',2.56),('11288','2014-04-21','17:45:00',2.53),('11288','2014-04-21','17:50:00',2.37),('11288','2014-04-21','17:55:00',2.22),('11288','2014-04-21','18:00:00',2.07),('11288','2014-04-21','18:05:00',1.91),('11288','2014-04-21','18:10:00',1.72),('11288','2014-04-21','18:15:00',1.62),('11288','2014-04-21','18:20:00',1.51),('11288','2014-04-21','18:25:00',1.37),('11288','2014-04-21','18:30:00',1.26),('11288','2014-04-21','18:35:00',1.16),('11288','2014-04-21','18:40:00',1.01),('11288','2013-12-07','08:35:00',1.07),('11288','2013-12-07','08:40:00',1.08),('11288','2013-12-07','08:45:00',1.23),('11288','2013-12-07','08:50:00',1.33),('11288','2013-12-07','08:55:00',1.44),('11288','2013-12-07','09:00:00',1.53),('11288','2013-12-07','09:05:00',1.64),('11288','2013-12-07','09:10:00',1.72),('11288','2013-12-07','09:15:00',1.79),('11288','2013-12-07','09:20:00',1.86),('11288','2013-12-07','09:25:00',1.95),('11288','2013-12-07','09:30:00',2.09),('11288','2013-12-07','09:35:00',2.16),('11288','2013-12-07','09:40:00',2.24),('11288','2013-12-07','09:45:00',2.28),('11288','2013-12-07','09:50:00',2.39),('11288','2013-12-07','09:55:00',2.36),('11288','2013-12-07','10:00:00',2.51),('11288','2013-12-07','10:05:00',2.65),('11288','2013-12-07','10:10:00',2.75),('11288','2013-12-07','10:15:00',2.79),('11288','2013-12-07','10:20:00',2.84),('11288','2013-12-07','10:25:00',2.96),('11288','2013-12-07','10:30:00',2.98),('11288','2013-12-07','10:35:00',3.07),('11288','2013-12-07','10:40:00',3.16),('11288','2013-12-07','10:45:00',3.22),('11288','2013-12-07','10:50:00',3.24),('11288','2013-12-07','10:55:00',3.27),('11288','2013-12-07','11:00:00',3.31),('11288','2013-12-07','11:05:00',3.35),('11288','2013-12-07','11:10:00',3.39),('11288','2013-12-07','11:15:00',3.39),('11288','2013-12-07','11:20:00',3.39),('11288','2013-12-07','11:25:00',3.4),('11288','2013-12-07','11:30:00',3.4),('11288','2013-12-07','11:35:00',3.43),('11288','2013-12-07','11:40:00',3.43),('11288','2013-12-07','11:45:00',3.45),('11288','2013-12-07','11:50:00',3.43),('11288','2013-12-07','11:55:00',3.4),('11288','2013-12-07','12:00:00',3.35),('11288','2013-12-07','12:05:00',3.43),('11288','2013-12-07','12:10:00',3.42),('11288','2013-12-07','12:15:00',3.43),('11288','2013-12-07','12:20:00',3.41),('11288','2013-12-07','12:25:00',3.36),('11288','2013-12-07','12:30:00',3.32),('11288','2013-12-07','12:35:00',3.33),('11288','2013-12-07','12:40:00',3.32),('11288','2013-12-07','12:45:00',3.3),('11288','2013-12-07','12:50:00',3.24),('11288','2013-12-07','12:55:00',3.19),('11288','2013-12-07','13:00:00',3.13),('11288','2013-12-07','13:05:00',3.13),('11288','2013-12-07','13:10:00',3.11),('11288','2013-12-07','13:15:00',3.08),('11288','2013-12-07','13:20:00',3.04),('11288','2013-12-07','13:25:00',2.97),('11288','2013-12-07','13:30:00',2.92),('11288','2013-12-07','13:35:00',2.87),('11288','2013-12-07','13:40:00',2.81),('11288','2013-12-07','13:45:00',2.7),('11288','2013-12-07','13:50:00',2.61),('11288','2013-12-07','13:55:00',2.51),('11288','2013-12-07','14:00:00',2.42),('11288','2013-12-07','14:05:00',2.37),('11288','2013-12-07','14:10:00',2.28),('11288','2013-12-07','14:15:00',2.14),('11288','2013-12-07','14:20:00',1.99),('11288','2013-12-07','14:25:00',1.91),('11288','2013-12-07','14:30:00',1.84),('11288','2013-12-07','14:35:00',1.7),('11288','2013-12-07','14:40:00',1.61),('11288','2013-12-07','14:45:00',1.5),('11288','2013-12-07','14:50:00',1.43),('11288','2013-12-07','14:55:00',1.22),('11288','2013-12-07','15:00:00',1.13),('11288','2013-12-07','15:05:00',1.15),('11288','2013-12-06','09:15:00',1.08),('11288','2013-12-06','09:20:00',1.12),('11288','2013-12-06','09:25:00',1.14),('11288','2013-12-06','09:30:00',1.05),('11288','2013-12-06','09:35:00',1.01),('11288','2013-12-06','09:40:00',1.17),('11288','2013-12-06','09:45:00',1.22),('11288','2013-12-06','09:50:00',1.17),('11288','2013-12-06','09:55:00',1.27),('11288','2013-12-06','10:00:00',1.28),('11288','2013-12-06','10:05:00',1.53),('11288','2013-12-06','10:10:00',1.77),('11288','2013-12-06','10:15:00',1.75),('11288','2013-12-06','10:20:00',1.51),('11288','2013-12-06','10:25:00',1.35),('11288','2013-12-06','10:30:00',1.25),('11288','2013-12-06','10:35:00',1.11),('11288','2013-12-06','10:40:00',1.03),('11288','2013-12-06','10:45:00',1.14),('11288','2013-12-06','10:50:00',1.27),('11288','2013-12-06','10:55:00',1.42),('11288','2013-12-06','11:00:00',1.62),('11288','2013-12-06','11:05:00',1.72),('11288','2013-12-06','11:10:00',1.59),('11288','2013-12-06','11:15:00',1.52),('11288','2013-12-06','11:20:00',1.68),('11288','2013-12-06','11:25:00',1.76),('11288','2013-12-06','11:30:00',1.84),('11288','2013-12-06','11:35:00',2.05),('11288','2013-12-06','11:40:00',3.06),('11288','2013-12-06','11:45:00',2.46),('11288','2013-12-06','11:50:00',3.19),('11288','2013-12-06','11:55:00',3.46),('11288','2013-12-06','12:00:00',3.67),('11288','2013-12-06','12:05:00',2.36),('11288','2013-12-06','12:10:00',2.77),('11288','2013-12-06','12:15:00',2.38),('11288','2013-12-06','12:20:00',2.77),('11288','2013-12-06','12:25:00',1.79),('11288','2013-12-06','12:30:00',1.9),('11288','2013-12-06','12:35:00',1.96),('11288','2013-12-06','12:40:00',3.2),('11288','2013-12-06','12:45:00',1.98),('11288','2013-12-06','12:50:00',1.81),('11288','2013-12-06','12:55:00',1.6),('11288','2013-12-06','13:00:00',1.54),('11288','2013-12-06','13:05:00',1.32),('11288','2013-12-06','13:10:00',1.19),('11288','2013-12-06','13:15:00',1.17),('11288','2013-12-06','13:20:00',1.17),('11288','2013-12-06','13:25:00',1.33),('11288','2013-12-06','13:30:00',1.46),('11288','2013-12-06','13:35:00',1.53),('11288','2013-12-06','13:40:00',1.67),('11288','2013-12-06','13:45:00',1.72),('11288','2013-12-06','13:50:00',1.56),('11288','2013-12-06','13:55:00',1.44),('11288','2013-12-06','14:00:00',1.32),('11288','2013-12-06','14:05:00',1.27),('11288','2013-12-06','14:10:00',1.34),('11288','2013-12-06','14:15:00',1.25),('11288','2013-12-06','14:20:00',1.25),('11288','2013-12-06','14:25:00',1.32),('11288','2013-12-06','14:30:00',1.3),('11288','2013-12-06','14:35:00',1.36),('11288','2013-12-06','14:40:00',1.5),('11288','2013-12-06','14:45:00',1.64),('11288','2013-12-06','14:50:00',1.33),('11288','2013-12-06','14:55:00',1.04),('11288','2013-12-05','08:35:00',1.03),('11288','2013-12-05','08:40:00',1.18),('11288','2013-12-05','08:45:00',1.31),('11288','2013-12-05','08:50:00',1.4),('11288','2013-12-05','08:55:00',1.5),('11288','2013-12-05','09:00:00',1.6),('11288','2013-12-05','09:05:00',1.69),('11288','2013-12-05','09:10:00',1.79),('11288','2013-12-05','09:15:00',1.85),('11288','2013-12-05','09:20:00',1.92),('11288','2013-12-05','09:25:00',1.99),('11288','2013-12-05','09:30:00',2.11),('11288','2013-12-05','09:35:00',2.19),('11288','2013-12-05','09:40:00',2.28),('11288','2013-12-05','09:45:00',2.33),('11288','2013-12-05','09:50:00',2.4),('11288','2013-12-05','09:55:00',2.38),('11288','2013-12-05','10:00:00',2.59),('11288','2013-12-05','10:05:00',2.68),('11288','2013-12-05','10:10:00',2.79),('11288','2013-12-05','10:15:00',2.87),('11288','2013-12-05','10:20:00',2.92),('11288','2013-12-05','10:25:00',3.03),('11288','2013-12-05','10:30:00',3),('11288','2013-12-05','10:35:00',3.02),('11288','2013-12-05','10:40:00',3.18),('11288','2013-12-05','10:45:00',3.27),('11288','2013-12-05','10:50:00',3.29),('11288','2013-12-05','10:55:00',3.36),('11288','2013-12-05','11:00:00',3.41),('11288','2013-12-05','11:05:00',3.44),('11288','2013-12-05','11:10:00',3.56),('11288','2013-12-05','11:15:00',3.44),('11288','2013-12-05','11:20:00',3.22),('11288','2013-12-05','11:25:00',3.07),('11288','2013-12-05','11:30:00',3.53),('11288','2013-12-05','11:35:00',3.54),('11288','2013-12-05','11:40:00',3.55),('11288','2013-12-05','11:45:00',3.57),('11288','2013-12-05','11:50:00',3.66),('11288','2013-12-05','11:55:00',3.53),('11288','2013-12-05','12:00:00',3.58),('11288','2013-12-05','12:05:00',3.58),('11288','2013-12-05','12:10:00',3.52),('11288','2013-12-05','12:15:00',3.52),('11288','2013-12-05','12:20:00',3.54),('11288','2013-12-05','12:25:00',3.39),('11288','2013-12-05','12:30:00',3.34),('11288','2013-12-05','12:35:00',3.44),('11288','2013-12-05','12:40:00',3.44),('11288','2013-12-05','12:45:00',3.32),('11288','2013-12-05','12:50:00',3.47),('11288','2013-12-05','12:55:00',3.31),('11288','2013-12-05','13:00:00',3.43),('11288','2013-12-05','13:05:00',3.41),('11288','2013-12-05','13:10:00',3.3),('11288','2013-12-05','13:15:00',3.24),('11288','2013-12-05','13:20:00',3.2),('11288','2013-12-05','13:25:00',3.15),('11288','2013-12-05','13:30:00',3.02),('11288','2013-12-05','13:35:00',2.94),('11288','2013-12-05','13:40:00',2.74),('11288','2013-12-05','13:45:00',2.42),('11288','2013-12-05','13:50:00',2.61),('11288','2013-12-05','13:55:00',2.48),('11288','2013-12-05','14:00:00',2.42),('11288','2013-12-05','14:05:00',2.39),('11288','2013-12-05','14:10:00',2.25),('11288','2013-12-05','14:15:00',2.18),('11288','2013-12-05','14:20:00',2.09),('11288','2013-12-05','14:25:00',1.96),('11288','2013-12-05','14:30:00',1.86),('11288','2013-12-05','14:35:00',1.78),('11288','2013-12-05','14:40:00',1.71),('11288','2013-12-05','14:45:00',1.62),('11288','2013-12-05','14:50:00',1.48),('11288','2013-12-05','14:55:00',1.25),('11288','2013-12-05','15:00:00',1.26),('11288','2013-12-05','15:05:00',1.21),('11288','2013-12-04','08:25:00',1.01),('11288','2013-12-04','08:30:00',1.11),('11288','2013-12-04','08:35:00',1.13),('11288','2013-12-04','08:40:00',1.32),('11288','2013-12-04','08:45:00',1.42),('11288','2013-12-04','08:50:00',1.49),('11288','2013-12-04','08:55:00',1.61),('11288','2013-12-04','09:00:00',1.69),('11288','2013-12-04','09:05:00',1.79),('11288','2013-12-04','09:10:00',1.86),('11288','2013-12-04','09:15:00',1.93),('11288','2013-12-04','09:20:00',2.04),('11288','2013-12-04','09:25:00',2.1),('11288','2013-12-04','09:30:00',2.2),('11288','2013-12-04','09:35:00',2.27),('11288','2013-12-04','09:40:00',2.37),('11288','2013-12-04','09:45:00',2.44),('11288','2013-12-04','09:50:00',2.55),('11288','2013-12-04','09:55:00',2.6),('11288','2013-12-04','10:00:00',2.73),('11288','2013-12-04','10:05:00',2.83),('11288','2013-12-04','10:10:00',2.94),('11288','2013-12-04','10:15:00',3.03),('11288','2013-12-04','10:20:00',3.1),('11288','2013-12-04','10:25:00',3.21),('11288','2013-12-04','10:30:00',3.17),('11288','2013-12-04','10:35:00',3.17),('11288','2013-12-04','10:40:00',3.38),('11288','2013-12-04','10:45:00',3.45),('11288','2013-12-04','10:50:00',3.49),('11288','2013-12-04','10:55:00',3.54),('11288','2013-12-04','11:00:00',3.6),('11288','2013-12-04','11:05:00',3.66),('11288','2013-12-04','11:10:00',3.7),('11288','2013-12-04','11:15:00',3.58),('11288','2013-12-04','11:20:00',3.34),('11288','2013-12-04','11:25:00',3.35),('11288','2013-12-04','11:30:00',3.77),('11288','2013-12-04','11:35:00',3.79),('11288','2013-12-04','11:40:00',3.78),('11288','2013-12-04','11:45:00',3.81),('11288','2013-12-04','11:50:00',3.8),('11288','2013-12-04','11:55:00',3.77),('11288','2013-12-04','12:00:00',3.81),('11288','2013-12-04','12:05:00',3.8),('11288','2013-12-04','12:10:00',3.77),('11288','2013-12-04','12:15:00',3.76),('11288','2013-12-04','12:20:00',3.75),('11288','2013-12-04','12:25:00',3.68),('11288','2013-12-04','12:30:00',3.68),('11288','2013-12-04','12:35:00',3.68),('11288','2013-12-04','12:40:00',3.65),('11288','2013-12-04','12:45:00',3.62),('11288','2013-12-04','12:50:00',3.56),('11288','2013-12-04','12:55:00',3.5),('11288','2013-12-04','13:00:00',3.44),('11288','2013-12-04','13:05:00',3.41),('11288','2013-12-04','13:10:00',3.37),('11288','2013-12-04','13:15:00',3.31),('11288','2013-12-04','13:20:00',3.26),('11288','2013-12-04','13:25:00',3.18),('11288','2013-12-04','13:30:00',3.11),('11288','2013-12-04','13:35:00',3.01),('11288','2013-12-04','13:40:00',2.94),('11288','2013-12-04','13:45:00',2.89),('11288','2013-12-04','13:50:00',2.79),('11288','2013-12-04','13:55:00',2.68),('11288','2013-12-04','14:00:00',2.61),('11288','2013-12-04','14:05:00',2.54),('11288','2013-12-04','14:10:00',2.43),('11288','2013-12-04','14:15:00',2.32),('11288','2013-12-04','14:20:00',2.22),('11288','2013-12-04','14:25:00',2.1),('11288','2013-12-04','14:30:00',2.03),('11288','2013-12-04','14:35:00',1.92),('11288','2013-12-04','14:40:00',1.83),('11288','2013-12-04','14:45:00',1.71),('11288','2013-12-04','14:50:00',1.48),('11288','2013-12-04','14:55:00',1.31),('11288','2013-12-04','15:00:00',1.4),('11288','2013-12-04','15:05:00',1.27),('11288','2013-12-04','15:10:00',1.07),('11288','2013-12-04','15:15:00',1.05),('11288','2013-12-03','09:20:00',1.07),('11288','2013-12-03','09:25:00',1.2),('11288','2013-12-03','09:30:00',1.44),('11288','2013-12-03','09:35:00',1.57),('11288','2013-12-03','09:40:00',1.9),('11288','2013-12-03','09:45:00',2.09),('11288','2013-12-03','09:50:00',2.26),('11288','2013-12-03','09:55:00',2.01),('11288','2013-12-03','10:00:00',2.44),('11288','2013-12-03','10:05:00',2.75),('11288','2013-12-03','10:10:00',2.91),('11288','2013-12-03','10:15:00',2.99),('11288','2013-12-03','10:20:00',3.04),('11288','2013-12-03','10:25:00',3.15),('11288','2013-12-03','10:30:00',3.12),('11288','2013-12-03','10:35:00',3.22),('11288','2013-12-03','10:40:00',3.34),('11288','2013-12-03','10:45:00',3.42),('11288','2013-12-03','10:50:00',3.49),('11288','2013-12-03','10:55:00',3.6),('11288','2013-12-03','11:00:00',3.66),('11288','2013-12-03','11:05:00',3.73),('11288','2013-12-03','11:10:00',3.79),('11288','2013-12-03','11:15:00',3.68),('11288','2013-12-03','11:20:00',3.7),('11288','2013-12-03','11:25:00',3.78),('11288','2013-12-03','11:30:00',3.83),('11288','2013-12-03','11:35:00',3.85),('11288','2013-12-03','11:40:00',3.86),('11288','2013-12-03','11:45:00',3.88),('11288','2013-12-03','11:50:00',3.9),('11288','2013-12-03','11:55:00',3.82),('11288','2013-12-03','12:00:00',3.59),('11288','2013-12-03','12:05:00',3.84),('11288','2013-12-03','12:10:00',3.99),('11288','2013-12-03','12:15:00',4.01),('11288','2013-12-03','12:20:00',4.01),('11288','2013-12-03','12:25:00',4.02),('11288','2013-12-03','12:30:00',4.09),('11288','2013-12-03','12:35:00',4.14),('11288','2013-12-03','12:40:00',4.19),('11288','2013-12-03','12:45:00',4.27),('11288','2013-12-03','12:50:00',4.36),('11288','2013-12-03','12:55:00',4.5),('11288','2013-12-03','13:00:00',4.57),('11288','2013-12-03','13:05:00',4.6),('11288','2013-12-03','13:10:00',4.61),('11288','2013-12-03','13:15:00',4.44),('11288','2013-12-03','13:20:00',4.36),('11288','2013-12-03','13:25:00',4.18),('11288','2013-12-03','13:30:00',3.93),('11288','2013-12-03','13:35:00',3.8),('11288','2013-12-03','13:40:00',3.6),('11288','2013-12-03','13:45:00',3.38),('11288','2013-12-03','13:50:00',3.2),('11288','2013-12-03','13:55:00',2.97),('11288','2013-12-03','14:00:00',2.83),('11288','2013-12-03','14:05:00',2.63),('11288','2013-12-03','14:10:00',2.42),('11288','2013-12-03','14:15:00',2.28),('11288','2013-12-03','14:20:00',1.94),('11288','2013-12-03','14:25:00',1.82),('11288','2013-12-03','14:30:00',1.91),('11288','2013-12-03','14:35:00',1.89),('11288','2013-12-03','14:40:00',1.83),('11288','2013-12-03','14:45:00',1.71),('11288','2013-12-03','14:50:00',1.52),('11288','2013-12-03','14:55:00',1.48),('11288','2013-12-03','15:00:00',1.39),('11288','2013-12-03','15:05:00',1.25),('11288','2013-12-03','15:10:00',1.15),('11288','2013-12-03','15:15:00',1.04),('11288','2013-12-02','13:40:00',1.07),('11288','2013-12-02','13:45:00',1.16),('11288','2013-12-02','13:50:00',1.13),('11288','2013-12-02','13:55:00',1.24),('11288','2013-12-02','14:00:00',1.23),('11288','2013-12-02','14:05:00',1.13),('11288','2013-12-01','11:00:00',1.01),('11288','2013-12-01','11:05:00',1.14),('11288','2013-12-01','11:10:00',1.05),('11288','2013-12-01','11:25:00',1.22),('11288','2013-12-01','11:30:00',1.45),('11288','2013-12-01','11:35:00',2.05),('11288','2013-12-01','11:40:00',2.06),('11288','2013-12-01','11:45:00',1.6),('11288','2013-12-01','11:50:00',1.6),('11288','2013-12-01','11:55:00',2.28),('11288','2013-12-01','12:00:00',1.99),('11288','2013-12-01','12:05:00',2.27),('11288','2013-12-01','12:10:00',2.75),('11288','2013-12-01','12:15:00',2.03),('11288','2013-12-01','12:20:00',1.16),('11288','2013-12-01','12:45:00',1.44),('11288','2013-12-01','12:50:00',1.45),('11288','2013-12-01','12:55:00',1.4),('11288','2013-12-01','13:00:00',1.38),('11288','2013-12-01','13:05:00',1.19),('11288','2013-11-30','08:55:00',1.3),('11288','2013-11-30','09:00:00',1.33),('11288','2013-11-30','09:05:00',1.32),('11288','2013-11-30','09:10:00',2.01),('11288','2013-11-30','09:15:00',2.22),('11288','2013-11-30','09:20:00',2.43),('11288','2013-11-30','09:25:00',2.39),('11288','2013-11-30','09:30:00',2.71),('11288','2013-11-30','09:35:00',3),('11288','2013-11-30','09:40:00',2.91),('11288','2013-11-30','09:45:00',2.28),('11288','2013-11-30','09:50:00',1.98),('11288','2013-11-30','09:55:00',1.92),('11288','2013-11-30','10:00:00',1.92),('11288','2013-11-30','10:05:00',1.79),('11288','2013-11-30','10:10:00',1.72),('11288','2013-11-30','10:15:00',1.91),('11288','2013-11-30','10:20:00',2.08),('11288','2013-11-30','10:25:00',2.02),('11288','2013-11-30','10:30:00',2.12),('11288','2013-11-30','10:35:00',2.33),('11288','2013-11-30','10:40:00',2.5),('11288','2013-11-30','10:45:00',2.37),('11288','2013-11-30','10:50:00',2.13),('11288','2013-11-30','10:55:00',1.99),('11288','2013-11-30','11:00:00',1.92),('11288','2013-11-30','11:05:00',2.36),('11288','2013-11-30','11:10:00',2.38),('11288','2013-11-30','11:15:00',2.3),('11288','2013-11-30','11:20:00',2.17),('11288','2013-11-30','11:25:00',2.25),('11288','2013-11-30','11:30:00',2.01),('11288','2013-11-30','11:35:00',1.91),('11288','2013-11-30','11:40:00',1.79),('11288','2013-11-30','11:45:00',1.61),('11288','2013-11-30','11:50:00',1.57),('11288','2013-11-30','11:55:00',1.41),('11288','2013-11-30','12:00:00',1.32),('11288','2013-11-30','12:05:00',1.28),('11288','2013-11-30','12:10:00',1.2),('11288','2013-11-30','12:15:00',1.13),('11288','2013-11-30','12:20:00',1.13),('11288','2013-11-30','12:25:00',1.21),('11288','2013-11-30','12:30:00',1.15),('11288','2013-11-30','12:35:00',1.07),('11288','2013-11-30','13:45:00',1.11),('11288','2013-11-30','13:50:00',1.35),('11288','2013-11-30','13:55:00',1.28),('11288','2013-11-30','14:00:00',1.11),('11288','2013-11-29','08:30:00',1.02),('11288','2013-11-29','08:35:00',1.2),('11288','2013-11-29','08:40:00',1.32),('11288','2013-11-29','08:45:00',1.42),('11288','2013-11-29','08:50:00',1.52),('11288','2013-11-29','08:55:00',1.63),('11288','2013-11-29','09:00:00',1.71),('11288','2013-11-29','09:05:00',1.8),('11288','2013-11-29','09:10:00',1.88),('11288','2013-11-29','09:15:00',1.99),('11288','2013-11-29','09:20:00',2.08),('11288','2013-11-29','09:25:00',2.16),('11288','2013-11-29','09:30:00',2.26),('11288','2013-11-29','09:35:00',2.35),('11288','2013-11-29','09:40:00',2.46),('11288','2013-11-29','09:45:00',2.54),('11288','2013-11-29','09:50:00',2.64),('11288','2013-11-29','09:55:00',2.64),('11288','2013-11-29','10:00:00',2.55),('11288','2013-11-29','10:05:00',2.62),('11288','2013-11-29','10:10:00',3.03),('11288','2013-11-29','10:15:00',3.11),('11288','2013-11-29','10:20:00',3.2),('11288','2013-11-29','10:25:00',3.28),('11288','2013-11-29','10:30:00',3.21),('11288','2013-11-29','10:35:00',3.24),('11288','2013-11-29','10:40:00',3.48),('11288','2013-11-29','10:45:00',3.55),('11288','2013-11-29','10:50:00',3.61),('11288','2013-11-29','10:55:00',3.66),('11288','2013-11-29','11:00:00',3.69),('11288','2013-11-29','11:05:00',3.77),('11288','2013-11-29','11:10:00',3.79),('11288','2013-11-29','11:15:00',3.62),('11288','2013-11-29','11:20:00',3.38),('11288','2013-11-29','11:25:00',3.86),('11288','2013-11-29','11:30:00',3.91),('11288','2013-11-29','11:35:00',3.93),('11288','2013-11-29','11:40:00',3.95),('11288','2013-11-29','11:45:00',3.95),('11288','2013-11-29','11:50:00',3.92),('11288','2013-11-29','11:55:00',3.94),('11288','2013-11-29','12:00:00',3.94),('11288','2013-11-29','12:05:00',3.92),('11288','2013-11-29','12:10:00',3.89),('11288','2013-11-29','12:15:00',3.9),('11288','2013-11-29','12:20:00',3.86),('11288','2013-11-29','12:25:00',3.82),('11288','2013-11-29','12:30:00',3.82),('11288','2013-11-29','12:35:00',3.78),('11288','2013-11-29','12:40:00',3.73),('11288','2013-11-29','12:45:00',3.73),('11288','2013-11-29','12:50:00',3.67),('11288','2013-11-29','12:55:00',3.62),('11288','2013-11-29','13:00:00',3.57),('11288','2013-11-29','13:05:00',3.51),('11288','2013-11-29','13:10:00',3.48),('11288','2013-11-29','13:15:00',3.41),('11288','2013-11-29','13:20:00',3.34),('11288','2013-11-29','13:25:00',3.26),('11288','2013-11-29','13:30:00',3.18),('11288','2013-11-29','13:35:00',3.09),('11288','2013-11-29','13:40:00',3.03),('11288','2013-11-29','13:45:00',2.96),('11288','2013-11-29','13:50:00',2.9),('11288','2013-11-29','13:55:00',2.78),('11288','2013-11-29','14:00:00',2.69),('11288','2013-11-29','14:05:00',2.59),('11288','2013-11-29','14:10:00',2.45),('11288','2013-11-29','14:15:00',2.37),('11288','2013-11-29','14:20:00',2.27),('11288','2013-11-29','14:25:00',2.16),('11288','2013-11-29','14:30:00',2.07),('11288','2013-11-29','14:35:00',1.97),('11288','2013-11-29','14:40:00',1.86),('11288','2013-11-29','14:45:00',1.67),('11288','2013-11-29','14:50:00',1.45),('11288','2013-11-29','14:55:00',1.5),('11288','2013-11-29','15:00:00',1.39),('11288','2013-11-29','15:05:00',1.16),('11288','2013-11-29','15:10:00',1.18),('11288','2013-11-29','15:15:00',1.05),('11288','2013-11-28','09:25:00',1.07),('11288','2013-11-28','09:30:00',1.27),('11288','2013-11-28','09:35:00',1.36),('11288','2013-11-28','09:40:00',1.53),('11288','2013-11-28','09:45:00',1.6),('11288','2013-11-28','09:50:00',1.68),('11288','2013-11-28','09:55:00',1.51),('11288','2013-11-28','10:00:00',1.34),('11288','2013-11-28','10:05:00',1.23),('11288','2013-11-28','11:20:00',1.11),('11288','2013-11-28','11:25:00',1.22),('11288','2013-11-28','12:30:00',1.07),('11288','2013-11-28','12:35:00',1.12),('11288','2013-11-28','12:40:00',1.19),('11288','2013-11-28','12:45:00',1.34),('11288','2013-11-28','12:50:00',1.6),('11288','2013-11-28','12:55:00',1.96),('11288','2013-11-28','13:00:00',1.59),('11288','2013-11-28','13:25:00',1.6),('11288','2013-11-28','13:30:00',1.33),('11288','2013-11-28','13:35:00',1.55),('11288','2013-11-28','13:40:00',1.43),('11288','2013-11-28','13:45:00',1.32),('11288','2013-11-28','13:50:00',1.25),('11288','2013-11-28','14:10:00',1.39),('11288','2013-11-28','14:15:00',1.08),('11288','2014-04-20','07:50:00',1.28),('11288','2014-04-20','07:55:00',1.45),('11288','2014-04-20','08:00:00',1.4),('11288','2014-04-20','08:05:00',1.52),('11288','2014-04-20','08:10:00',1.6),('11288','2014-04-20','08:15:00',1.78),('11288','2014-04-20','08:20:00',2.48),('11288','2014-04-20','08:25:00',2.92),('11288','2014-04-20','08:30:00',3.04),('11288','2014-04-20','08:35:00',2.46),('11288','2014-04-20','08:40:00',1.68),('11288','2014-04-20','08:45:00',2.83),('11288','2014-04-20','08:50:00',1.83),('11288','2014-04-20','08:55:00',2.05),('11288','2014-04-20','09:00:00',2.92),('11288','2014-04-20','09:05:00',2.15),('11288','2014-04-20','09:10:00',3.39),('11288','2014-04-20','09:15:00',3.92),('11288','2014-04-20','09:20:00',4.16),('11288','2014-04-20','09:25:00',4.81),('11288','2014-04-20','09:30:00',5.31),('11288','2014-04-20','09:35:00',4.75),('11288','2014-04-20','09:40:00',3.15),('11288','2014-04-20','09:45:00',2.47),('11288','2014-04-20','09:50:00',2.83),('11288','2014-04-20','09:55:00',3.28),('11288','2014-04-20','10:00:00',3.75),('11288','2014-04-20','10:05:00',4.55),('11288','2014-04-20','10:10:00',4.48),('11288','2014-04-20','10:15:00',5.1),('11288','2014-04-20','10:20:00',5.09),('11288','2014-04-20','10:25:00',4.88),('11288','2014-04-20','10:30:00',4.47),('11288','2014-04-20','10:35:00',4.73),('11288','2014-04-20','10:40:00',4.44),('11288','2014-04-20','10:45:00',4.5),('11288','2014-04-20','10:50:00',4.83),('11288','2014-04-20','10:55:00',4.91),('11288','2014-04-20','11:00:00',5.7),('11288','2014-04-20','11:05:00',5.43),('11288','2014-04-20','11:10:00',5.75),('11288','2014-04-20','11:15:00',3.79),('11288','2014-04-20','11:20:00',5.71),('11288','2014-04-20','11:25:00',6.43),('11288','2014-04-20','11:30:00',6.38),('11288','2014-04-20','11:35:00',6.66),('11288','2014-04-20','11:40:00',3.9),('11288','2014-04-20','11:45:00',5.69),('11288','2014-04-20','11:50:00',4.16),('11288','2014-04-20','11:55:00',7.3),('11288','2014-04-20','12:00:00',7.1),('11288','2014-04-20','12:05:00',7.08),('11288','2014-04-20','12:10:00',5.34),('11288','2014-04-20','12:15:00',2.5),('11288','2014-04-20','12:20:00',4.63),('11288','2014-04-20','12:25:00',4.88),('11288','2014-04-20','12:30:00',7.62),('11288','2014-04-20','12:35:00',7.19),('11288','2014-04-20','12:40:00',7.21),('11288','2014-04-20','12:45:00',7.14),('11288','2014-04-20','12:50:00',7.15),('11288','2014-04-20','12:55:00',7.15),('11288','2014-04-20','13:00:00',7.17),('11288','2014-04-20','13:05:00',7.23),('11288','2014-04-20','13:10:00',7.13),('11288','2014-04-20','13:15:00',6.85),('11288','2014-04-20','13:20:00',7.08),('11288','2014-04-20','13:25:00',7.08),('11288','2014-04-20','13:30:00',7.08),('11288','2014-04-20','13:35:00',7.08),('11288','2014-04-20','13:40:00',7.09),('11288','2014-04-20','13:45:00',7.03),('11288','2014-04-20','13:50:00',7.05),('11288','2014-04-20','13:55:00',7.04),('11288','2014-04-20','14:00:00',6.96),('11288','2014-04-20','14:05:00',6.9),('11288','2014-04-20','14:10:00',6.92),('11288','2014-04-20','14:15:00',7.25),('11288','2014-04-20','14:20:00',5.36),('11288','2014-04-20','14:25:00',5.18),('11288','2014-04-20','14:30:00',4.9),('11288','2014-04-20','14:35:00',4.26),('11288','2014-04-20','14:40:00',4.29),('11288','2014-04-20','14:45:00',4.65),('11288','2014-04-20','14:50:00',4.52),('11288','2014-04-20','14:55:00',5.03),('11288','2014-04-20','15:00:00',6.63),('11288','2014-04-20','15:05:00',5.72),('11288','2014-04-20','15:10:00',6.48),('11288','2014-04-20','15:15:00',6.28),('11288','2014-04-20','15:20:00',6.09),('11288','2014-04-20','15:25:00',6.03),('11288','2014-04-20','15:30:00',5.96),('11288','2014-04-20','15:35:00',5.78),('11288','2014-04-20','15:40:00',5.98),('11288','2014-04-20','15:45:00',3.99),('11288','2014-04-20','15:50:00',4.71),('11288','2014-04-20','15:55:00',5.61),('11288','2014-04-20','16:00:00',5.42),('11288','2014-04-20','16:05:00',5.28),('11288','2014-04-20','16:10:00',5.21),('11288','2014-04-20','16:15:00',5.14),('11288','2014-04-20','16:20:00',5.07),('11288','2014-04-20','16:25:00',4.72),('11288','2014-04-20','16:30:00',4.81),('11288','2014-04-20','16:35:00',4.57),('11288','2014-04-20','16:40:00',4.07),('11288','2014-04-20','16:45:00',3.22),('11288','2014-04-20','16:50:00',3.99),('11288','2014-04-20','16:55:00',4.22),('11288','2014-04-20','17:00:00',3.99),('11288','2014-04-20','17:05:00',3.79),('11288','2014-04-20','17:10:00',3.57),('11288','2014-04-20','17:15:00',3.42),('11288','2014-04-20','17:20:00',3.27),('11288','2014-04-20','17:25:00',3.13),('11288','2014-04-20','17:30:00',2.98),('11288','2014-04-20','17:35:00',2.83),('11288','2014-04-20','17:40:00',2.64),('11288','2014-04-20','17:45:00',2.44),('11288','2014-04-20','17:50:00',2.24),('11288','2014-04-20','17:55:00',2.17),('11288','2014-04-20','18:00:00',2.06),('11288','2014-04-20','18:05:00',1.92),('11288','2014-04-20','18:10:00',1.74),('11288','2014-04-20','18:15:00',1.55),('11288','2014-04-20','18:30:00',1.18),('11288','2014-04-20','18:35:00',1.15),('11288','2013-11-27','08:45:00',1.1),('11288','2013-11-27','08:50:00',1.3),('11288','2013-11-27','08:55:00',1.38),('11288','2013-11-27','09:00:00',1.25),('11288','2013-11-27','09:05:00',1.14),('11288','2013-11-27','09:15:00',1.13),('11288','2013-11-27','09:20:00',1.4),('11288','2013-11-27','09:25:00',1.45),('11288','2013-11-27','09:30:00',1.53),('11288','2013-11-27','09:35:00',1.63),('11288','2013-11-27','09:40:00',1.68),('11288','2013-11-27','09:45:00',1.56),('11288','2013-11-27','09:50:00',1.96),('11288','2013-11-27','09:55:00',2.22),('11288','2013-11-27','10:00:00',2.11),('11288','2013-11-27','10:05:00',2.14),('11288','2013-11-27','10:10:00',2.12),('11288','2013-11-27','10:15:00',2.12),('11288','2013-11-27','10:20:00',1.96),('11288','2013-11-27','10:25:00',1.83),('11288','2013-11-27','10:30:00',1.86),('11288','2013-11-27','10:35:00',1.96),('11288','2013-11-27','10:40:00',2.23),('11288','2013-11-27','10:45:00',2.41),('11288','2013-11-27','10:50:00',2.27),('11288','2013-11-27','10:55:00',2.24),('11288','2013-11-27','11:00:00',2.37),('11288','2013-11-27','11:05:00',2.57),('11288','2013-11-27','11:10:00',2.87),('11288','2013-11-27','11:15:00',2.36),('11288','2013-11-27','11:20:00',2.34),('11288','2013-11-27','11:25:00',2.51),('11288','2013-11-27','11:30:00',3.77),('11288','2013-11-27','11:35:00',3.28),('11288','2013-11-27','11:40:00',2.68),('11288','2013-11-27','11:45:00',2.69),('11288','2013-11-27','11:50:00',3.72),('11288','2013-11-27','11:55:00',3.72),('11288','2013-11-27','12:00:00',4.39),('11288','2013-11-27','12:05:00',3.48),('11288','2013-11-27','12:10:00',2.29),('11288','2013-11-27','12:15:00',2.7),('11288','2013-11-27','12:20:00',3.94),('11288','2013-11-27','12:25:00',2.61),('11288','2013-11-27','12:30:00',2.13),('11288','2013-11-27','12:35:00',4.31),('11288','2013-11-27','12:40:00',2.06),('11288','2013-11-27','12:45:00',1.67),('11288','2013-11-27','12:50:00',1.7),('11288','2013-11-27','12:55:00',1.73),('11288','2013-11-27','13:00:00',1.82),('11288','2013-11-27','13:05:00',1.81),('11288','2013-11-27','13:10:00',1.81),('11288','2013-11-27','13:15:00',1.8),('11288','2013-11-27','13:20:00',1.77),('11288','2013-11-27','13:25:00',1.73),('11288','2013-11-27','13:30:00',1.75),('11288','2013-11-27','13:35:00',1.67),('11288','2013-11-27','13:40:00',1.73),('11288','2013-11-27','13:45:00',1.57),('11288','2013-11-27','13:50:00',1.3),('11288','2013-11-27','13:55:00',1.17),('11288','2013-11-27','14:00:00',1.2),('11288','2013-11-27','14:05:00',1.05),('11288','2013-11-26','08:10:00',1.02),('11288','2013-11-26','08:45:00',1.11),('11288','2013-11-26','08:55:00',1.1),('11288','2013-11-26','09:00:00',1.4),('11288','2013-11-26','09:05:00',1.62),('11288','2013-11-26','09:10:00',1.94),('11288','2013-11-26','09:15:00',1.85),('11288','2013-11-26','09:20:00',1.82),('11288','2013-11-26','09:25:00',1.73),('11288','2013-11-26','09:30:00',1.87),('11288','2013-11-26','09:35:00',1.89),('11288','2013-11-26','09:40:00',2.34),('11288','2013-11-26','09:45:00',1.73),('11288','2013-11-26','09:50:00',1.8),('11288','2013-11-26','09:55:00',2.64),('11288','2013-11-26','10:00:00',2.17),('11288','2013-11-26','10:05:00',2.28),('11288','2013-11-26','10:10:00',2.03),('11288','2013-11-26','10:15:00',1.51),('11288','2013-11-26','10:20:00',2.17),('11288','2013-11-26','10:25:00',2.28),('11288','2013-11-26','10:30:00',2.58),('11288','2013-11-26','10:35:00',3.78),('11288','2013-11-26','10:40:00',3.81),('11288','2013-11-26','10:45:00',3.9),('11288','2013-11-26','10:50:00',3.89),('11288','2013-11-26','10:55:00',4.01),('11288','2013-11-26','11:00:00',4.21),('11288','2013-11-26','11:05:00',4.12),('11288','2013-11-26','11:10:00',4.78),('11288','2013-11-26','11:15:00',4.85),('11288','2013-11-26','11:20:00',3.45),('11288','2013-11-26','11:25:00',4.74),('11288','2013-11-26','11:30:00',4.83),('11288','2013-11-26','11:35:00',3.61),('11288','2013-11-26','11:40:00',3.91),('11288','2013-11-26','11:45:00',5.1),('11288','2013-11-26','11:50:00',4.25),('11288','2013-11-26','11:55:00',3.46),('11288','2013-11-26','12:00:00',1.96),('11288','2013-11-26','12:05:00',2.45),('11288','2013-11-26','12:10:00',1.05),('11288','2013-11-26','12:15:00',1.79),('11288','2013-11-26','12:20:00',4.14),('11288','2013-11-26','12:25:00',4.2),('11288','2013-11-26','12:30:00',4.14),('11288','2013-11-26','12:35:00',4.12),('11288','2013-11-26','12:40:00',4.13),('11288','2013-11-26','12:45:00',4.06),('11288','2013-11-26','12:50:00',3.99),('11288','2013-11-26','12:55:00',3.95),('11288','2013-11-26','13:00:00',3.91),('11288','2013-11-26','13:05:00',3.86),('11288','2013-11-26','13:10:00',3.82),('11288','2013-11-26','13:15:00',3.72),('11288','2013-11-26','13:20:00',3.66),('11288','2013-11-26','13:25:00',3.6),('11288','2013-11-26','13:30:00',3.52),('11288','2013-11-26','13:35:00',3.44),('11288','2013-11-26','13:40:00',3.37),('11288','2013-11-26','13:45:00',3.32),('11288','2013-11-26','13:50:00',3.35),('11288','2013-11-26','13:55:00',3.23),('11288','2013-11-26','14:00:00',3.51),('11288','2013-11-26','14:05:00',3.64),('11288','2013-11-26','14:10:00',3.57),('11288','2013-11-26','14:15:00',4.1),('11288','2013-11-26','14:20:00',3.71),('11288','2013-11-26','14:25:00',2.41),('11288','2013-11-26','14:30:00',1.65),('11288','2013-11-26','14:35:00',2.1),('11288','2013-11-26','14:40:00',2.16),('11288','2013-11-26','14:45:00',2.31),('11288','2013-11-26','14:50:00',2.14),('11288','2013-11-26','14:55:00',2.56),('11288','2013-11-26','15:00:00',2.18),('11288','2013-11-26','15:05:00',1.74),('11288','2013-11-26','15:10:00',1.6),('11288','2013-11-26','15:15:00',1.34),('11288','2013-11-26','15:20:00',1.19),('11288','2013-11-26','15:25:00',1.1),('11288','2013-11-25','08:15:00',1.08),('11288','2013-11-25','08:20:00',1.26),('11288','2013-11-25','08:25:00',1.48),('11288','2013-11-25','08:30:00',1.45),('11288','2013-11-25','08:35:00',1.75),('11288','2013-11-25','08:40:00',1.89),('11288','2013-11-25','08:45:00',2.1),('11288','2013-11-25','08:50:00',2.29),('11288','2013-11-25','08:55:00',2.51),('11288','2013-11-25','09:00:00',2.84),('11288','2013-11-25','09:05:00',2.94),('11288','2013-11-25','09:10:00',2.92),('11288','2013-11-25','09:15:00',3.07),('11288','2013-11-25','09:20:00',3.47),('11288','2013-11-25','09:25:00',2.65),('11288','2013-11-25','09:30:00',2.34),('11288','2013-11-25','09:35:00',2.61),('11288','2013-11-25','09:40:00',2.94),('11288','2013-11-25','09:45:00',2.1),('11288','2013-11-25','09:50:00',3.08),('11288','2013-11-25','09:55:00',2.67),('11288','2013-11-25','10:00:00',2.39),('11288','2013-11-25','10:05:00',3.08),('11288','2013-11-25','10:10:00',2.1),('11288','2013-11-25','10:15:00',3.25),('11288','2013-11-25','10:20:00',1.73),('11288','2013-11-25','10:25:00',2.41),('11288','2013-11-25','10:30:00',2.9),('11288','2013-11-25','10:35:00',3.24),('11288','2013-11-25','10:40:00',4.66),('11288','2013-11-25','10:45:00',4.23),('11288','2013-11-25','10:50:00',3.47),('11288','2013-11-25','10:55:00',3.92),('11288','2013-11-25','11:00:00',4.04),('11288','2013-11-25','11:05:00',4.34),('11288','2013-11-25','11:10:00',4.99),('11288','2013-11-25','11:15:00',4.25),('11288','2013-11-25','11:20:00',1.92),('11288','2013-11-25','11:25:00',2.11),('11288','2013-11-25','11:30:00',2.62),('11288','2013-11-25','11:35:00',2.07),('11288','2013-11-25','11:40:00',1.88),('11288','2013-11-25','11:45:00',2.03),('11288','2013-11-25','11:50:00',2.42),('11288','2013-11-25','11:55:00',1.96),('11288','2013-11-25','12:00:00',2.58),('11288','2013-11-25','12:05:00',2.63),('11288','2013-11-25','12:10:00',3.4),('11288','2013-11-25','12:15:00',2.8),('11288','2013-11-25','12:20:00',2.31),('11288','2013-11-25','12:25:00',2.45),('11288','2013-11-25','12:30:00',2.17),('11288','2013-11-25','12:35:00',1.99),('11288','2013-11-25','12:40:00',3.74),('11288','2013-11-25','12:45:00',3.67),('11288','2013-11-25','12:50:00',3.23),('11288','2013-11-25','12:55:00',3.71),('11288','2013-11-25','13:00:00',4.6),('11288','2013-11-25','13:05:00',4.3),('11288','2013-11-25','13:10:00',3.89),('11288','2013-11-25','13:15:00',3.06),('11288','2013-11-25','13:20:00',5.03),('11288','2013-11-25','13:25:00',4.8),('11288','2013-11-25','13:30:00',2.95),('11288','2013-11-25','13:35:00',1.85),('11288','2013-11-25','13:40:00',1.6),('11288','2013-11-25','13:45:00',1.55),('11288','2013-11-25','13:50:00',1.56),('11288','2013-11-25','13:55:00',1.24),('11288','2013-11-25','14:00:00',1.03),('11288','2013-11-24','09:50:00',1.49),('11288','2013-11-24','09:55:00',2.19),('11288','2013-11-24','10:00:00',2.57),('11288','2013-11-24','10:05:00',2.67),('11288','2013-11-24','10:10:00',2.72),('11288','2013-11-24','10:15:00',2.52),('11288','2013-11-24','10:20:00',2.27),('11288','2013-11-24','10:25:00',2.92),('11288','2013-11-24','10:30:00',2.62),('11288','2013-11-24','10:35:00',2.03),('11288','2013-11-24','10:40:00',1.72),('11288','2013-11-24','10:45:00',1.68),('11288','2013-11-24','10:50:00',1.8),('11288','2013-11-24','10:55:00',1.98),('11288','2013-11-24','11:00:00',2.07),('11288','2013-11-24','11:05:00',2.17),('11288','2013-11-24','11:10:00',2.27),('11288','2013-11-24','11:15:00',2.34),('11288','2013-11-24','11:20:00',2.49),('11288','2013-11-24','11:25:00',2.52),('11288','2013-11-24','11:30:00',2.52),('11288','2013-11-24','11:35:00',2.16),('11288','2013-11-24','11:40:00',2.03),('11288','2013-11-24','11:45:00',2.04),('11288','2013-11-24','11:50:00',2.22),('11288','2013-11-24','11:55:00',1.99),('11288','2013-11-24','12:00:00',1.54),('11288','2013-11-24','12:05:00',1.24),('11288','2013-11-24','12:10:00',1.16),('11288','2013-11-24','12:15:00',1.46),('11288','2013-11-24','12:20:00',1.68),('11288','2013-11-24','12:25:00',1.8),('11288','2013-11-24','12:30:00',1.76),('11288','2013-11-24','12:35:00',1.74),('11288','2013-11-24','12:40:00',1.79),('11288','2013-11-24','12:45:00',1.77),('11288','2013-11-24','12:50:00',1.75),('11288','2013-11-24','12:55:00',1.68),('11288','2013-11-24','13:00:00',1.97),('11288','2013-11-24','13:05:00',2.48),('11288','2013-11-24','13:10:00',2.48),('11288','2013-11-24','13:15:00',2.4),('11288','2013-11-24','13:20:00',2.08),('11288','2013-11-24','13:25:00',1.76),('11288','2013-11-24','13:30:00',1.54),('11288','2013-11-24','13:35:00',1.49),('11288','2013-11-24','13:40:00',1.44),('11288','2013-11-24','13:45:00',1.33),('11288','2013-11-24','13:50:00',1.22),('11288','2013-11-24','13:55:00',1.1),('11288','2013-11-24','14:00:00',1.14),('11288','2013-11-24','14:05:00',1.13),('11288','2013-11-24','14:10:00',1.07),('11288','2013-11-24','14:15:00',1.05),('11288','2013-11-24','14:20:00',1.03),('11288','2013-11-24','14:25:00',1.01),('11288','2013-11-23','08:20:00',1.19),('11288','2013-11-23','08:25:00',1.26),('11288','2013-11-23','08:35:00',1.11),('11288','2013-11-23','08:40:00',1.19),('11288','2013-11-23','10:00:00',1.11),('11288','2013-11-23','10:05:00',1.21),('11288','2013-11-23','10:10:00',1.24),('11288','2013-11-23','10:15:00',1.96),('11288','2013-11-23','10:20:00',2.02),('11288','2013-11-23','10:25:00',2.53),('11288','2013-11-23','10:30:00',2.6),('11288','2013-11-23','10:35:00',1.93),('11288','2013-11-23','10:40:00',3.25),('11288','2013-11-23','11:20:00',1.06),('11288','2013-11-23','11:25:00',1.34),('11288','2013-11-23','11:30:00',1.22),('11288','2013-11-23','11:35:00',1.12),('11288','2013-11-23','11:40:00',1.37),('11288','2013-11-23','11:45:00',1.25),('11288','2013-11-23','13:20:00',1.73),('11288','2013-11-23','13:25:00',2.21),('11288','2013-11-23','13:30:00',2.04),('11288','2013-11-23','13:35:00',2.58),('11288','2013-11-23','13:40:00',2.16),('11288','2013-11-23','13:45:00',1.52),('11288','2013-11-23','13:50:00',1.67),('11288','2013-11-23','13:55:00',1.85),('11288','2013-11-23','14:00:00',1.95),('11288','2013-11-23','14:05:00',1.83),('11288','2013-11-23','14:50:00',1),('11288','2013-11-23','14:55:00',1.17),('11288','2013-11-23','15:00:00',1.12),('11288','2013-11-23','15:05:00',1.01),('11288','2013-11-23','16:15:00',1.13),('11288','2013-11-22','09:20:00',1),('11288','2013-11-22','10:00:00',1.11),('11288','2013-11-21','08:10:00',1.41),('11288','2013-11-21','08:15:00',1.57),('11288','2013-11-21','09:05:00',1.09),('11288','2013-11-21','09:10:00',1.62),('11288','2013-11-21','09:15:00',1.63),('11288','2013-11-21','09:20:00',1.64),('11288','2013-11-21','09:25:00',1.73),('11288','2013-11-21','09:30:00',1.41),('11288','2013-11-21','09:35:00',1.24),('11288','2013-11-21','09:40:00',2.08),('11288','2013-11-21','09:45:00',2.64),('11288','2013-11-21','09:50:00',1.74),('11288','2013-11-21','09:55:00',2.32),('11288','2013-11-21','10:00:00',2.71),('11288','2013-11-21','10:05:00',3.16),('11288','2013-11-21','10:10:00',2.7),('11288','2013-11-21','10:15:00',3.42),('11288','2013-11-21','10:20:00',2.94),('11288','2013-11-21','10:25:00',2.23),('11288','2013-11-21','10:30:00',2.94),('11288','2013-11-21','10:35:00',3.56),('11288','2013-11-21','10:40:00',3.96),('11288','2013-11-21','10:45:00',2.68),('11288','2013-11-21','10:50:00',1.03),('11288','2013-11-21','11:00:00',1.17),('11288','2013-11-21','11:05:00',1.17),('11288','2013-11-21','11:10:00',1.19),('11288','2013-11-21','11:15:00',1.65),('11288','2013-11-21','11:20:00',2.4),('11288','2013-11-21','11:25:00',2.39),('11288','2013-11-21','11:30:00',2.7),('11288','2013-11-21','11:35:00',3.29),('11288','2013-11-21','11:40:00',3.07),('11288','2013-11-21','11:45:00',2.77),('11288','2013-11-21','11:50:00',3.23),('11288','2013-11-21','11:55:00',4.03),('11288','2013-11-21','12:00:00',1.74),('11288','2013-11-21','12:05:00',4.07),('11288','2013-11-21','12:10:00',4),('11288','2013-11-21','12:15:00',3.98),('11288','2013-11-21','12:20:00',4),('11288','2013-11-21','12:25:00',4.16),('11288','2013-11-21','12:30:00',4.46),('11288','2013-11-21','12:35:00',4.41),('11288','2013-11-21','12:40:00',4.65),('11288','2013-11-21','12:45:00',4.48),('11288','2013-11-21','12:50:00',4.19),('11288','2013-11-21','12:55:00',4.62),('11288','2013-11-21','13:00:00',4.44),('11288','2013-11-21','13:05:00',4.34),('11288','2013-11-21','13:10:00',4.13),('11288','2013-11-21','13:15:00',4.22),('11288','2013-11-21','13:20:00',3.91),('11288','2013-11-21','13:25:00',3.02),('11288','2013-11-21','13:30:00',1.56),('11288','2013-11-21','13:35:00',1.34),('11288','2013-11-21','13:40:00',2.74),('11288','2013-11-21','13:45:00',2.82),('11288','2013-11-21','13:50:00',1.68),('11288','2013-11-21','13:55:00',2.54),('11288','2013-11-21','14:00:00',2.74),('11288','2013-11-21','14:05:00',1.84),('11288','2013-11-21','14:10:00',1.32),('11288','2013-11-21','14:15:00',1.11),('11288','2013-11-21','14:25:00',1.31),('11288','2013-11-21','14:40:00',1.62),('11288','2013-11-21','14:45:00',1.51),('11288','2013-11-21','14:50:00',1.74),('11288','2013-11-21','14:55:00',1.58),('11288','2013-11-21','15:00:00',1.43),('11288','2013-11-21','15:05:00',1.35),('11288','2013-11-21','15:10:00',1.15),('11288','2013-11-20','08:20:00',1.23),('11288','2013-11-20','09:00:00',1.12),('11288','2013-11-20','09:10:00',1.15),('11288','2013-11-20','09:15:00',1.8),('11288','2013-11-20','09:20:00',1.87),('11288','2013-11-20','09:25:00',2.09),('11288','2013-11-20','09:30:00',2.3),('11288','2013-11-20','09:35:00',1.26),('11288','2013-11-20','09:55:00',1.23),('11288','2013-11-20','10:00:00',2.27),('11288','2013-11-20','10:05:00',1.23),('11288','2013-11-20','10:10:00',1.82),('11288','2013-11-20','10:15:00',2.65),('11288','2013-11-20','10:25:00',1.57),('11288','2013-11-20','10:30:00',1.6),('11288','2013-11-20','10:35:00',1.31),('11288','2013-11-20','10:40:00',1.16),('11288','2013-11-20','10:45:00',1.01),('11288','2013-11-20','10:50:00',1.48),('11288','2013-11-20','10:55:00',1.39),('11288','2013-11-20','11:00:00',1.22),('11288','2013-11-20','11:05:00',1.23),('11288','2013-11-20','11:10:00',1.1),('11288','2013-11-20','11:15:00',1.07),('11288','2013-11-20','11:20:00',1.77),('11288','2013-11-20','11:25:00',2),('11288','2013-11-20','11:30:00',1.82),('11288','2013-11-20','11:35:00',1.78),('11288','2013-11-20','11:40:00',2.04),('11288','2013-11-20','11:45:00',5.34),('11288','2013-11-20','11:50:00',5.47),('11288','2013-11-20','11:55:00',2.79),('11288','2013-11-20','12:00:00',1.24),('11288','2013-11-20','12:10:00',1.15),('11288','2013-11-20','12:15:00',1.83),('11288','2013-11-20','12:20:00',2.66),('11288','2013-11-20','12:25:00',1.77),('11288','2013-11-20','12:30:00',1.26),('11288','2013-11-20','12:35:00',1.45),('11288','2013-11-20','12:40:00',1.66),('11288','2013-11-20','12:45:00',2.04),('11288','2013-11-20','12:50:00',3.88),('11288','2013-11-20','12:55:00',4.41),('11288','2013-11-20','13:00:00',2.75),('11288','2013-11-20','13:05:00',2.68),('11288','2013-11-20','13:10:00',1.37),('11288','2013-11-20','13:15:00',1.59),('11288','2013-11-20','13:20:00',2.5),('11288','2013-11-20','13:25:00',2.2),('11288','2013-11-20','13:30:00',1.25),('11288','2013-11-20','13:35:00',1.53),('11288','2013-11-20','13:40:00',1.51),('11288','2013-11-20','13:45:00',1.9),('11288','2013-11-20','13:50:00',2.4),('11288','2013-11-20','13:55:00',1.34),('11288','2013-11-20','14:00:00',1.45),('11288','2013-11-20','14:05:00',1.46),('11288','2013-11-20','14:10:00',1.38),('11288','2013-11-20','14:15:00',1.37),('11288','2013-11-20','14:20:00',1.51),('11288','2013-11-20','14:25:00',2.05),('11288','2013-11-20','14:30:00',1.29),('11288','2013-11-20','14:35:00',1.26),('11288','2013-11-20','14:40:00',1.65),('11288','2013-11-20','14:45:00',1.75),('11288','2013-11-20','15:05:00',1.72),('11288','2013-11-20','15:10:00',1.57),('11288','2013-11-20','15:15:00',1.11),('11288','2013-11-20','15:20:00',1.07),('11288','2013-11-19','09:35:00',1.73),('11288','2013-11-19','09:40:00',2.8),('11288','2013-11-19','09:45:00',2.63),('11288','2013-11-19','09:50:00',1.23),('11288','2013-11-19','09:55:00',1.5),('11288','2013-11-19','10:00:00',1.99),('11288','2013-11-19','10:05:00',1.77),('11288','2013-11-19','10:10:00',1.09),('11288','2013-11-19','10:20:00',1.07),('11288','2013-11-19','10:45:00',1.26),('11288','2013-11-19','10:50:00',2.36),('11288','2013-11-19','10:55:00',1.56),('11288','2013-11-19','11:05:00',1.29),('11288','2013-11-19','11:10:00',1.49),('11288','2013-11-19','11:15:00',1.42),('11288','2013-11-19','11:20:00',2.94),('11288','2013-11-19','11:25:00',3.32),('11288','2013-11-19','11:30:00',3.8),('11288','2013-11-19','11:35:00',4.17),('11288','2013-11-19','11:40:00',3.52),('11288','2013-11-19','11:45:00',3.81),('11288','2013-11-19','11:50:00',3.53),('11288','2013-11-19','11:55:00',3.18),('11288','2013-11-19','12:00:00',3.11),('11288','2013-11-19','12:05:00',3.67),('11288','2013-11-19','12:10:00',3.04),('11288','2013-11-19','12:15:00',3.71),('11288','2013-11-19','12:20:00',1.7),('11288','2013-11-19','12:25:00',1.52),('11288','2013-11-19','12:30:00',2.46),('11288','2013-11-19','12:40:00',2.22),('11288','2013-11-19','12:45:00',2.87),('11288','2013-11-19','12:50:00',3.06),('11288','2013-11-19','12:55:00',4.4),('11288','2013-11-19','13:00:00',1.54),('11288','2013-11-19','13:05:00',1.48),('11288','2013-11-19','13:10:00',1.87),('11288','2013-11-19','13:15:00',3.08),('11288','2013-11-19','13:20:00',2.52),('11288','2013-11-19','13:30:00',1.05),('11288','2013-11-19','14:30:00',1.18),('11288','2013-11-19','14:35:00',1.08),('11288','2013-11-19','14:40:00',1.27),('11288','2013-11-19','14:45:00',1.15),('11288','2013-11-19','14:50:00',1.14),('11288','2013-11-19','14:55:00',1.17),('11288','2013-11-19','15:25:00',1.76),('11288','2013-11-19','15:30:00',1.88),('11288','2013-11-19','15:35:00',1.16),('11288','2013-11-19','15:40:00',1.01),('11288','2013-11-18','08:05:00',1.11),('11288','2013-11-18','08:10:00',1.05),('11288','2013-11-18','08:15:00',1.03),('11288','2013-11-18','08:20:00',1.21),('11288','2013-11-18','08:25:00',1.31),('11288','2013-11-18','08:30:00',1.43),('11288','2013-11-18','08:35:00',1.41),('11288','2013-11-18','08:40:00',1.43),('11288','2013-11-18','08:45:00',1.42),('11288','2013-11-18','08:50:00',1.37),('11288','2013-11-18','08:55:00',1.45),('11288','2013-11-18','09:00:00',1.51),('11288','2013-11-18','09:05:00',1.4),('11288','2013-11-18','09:10:00',1.38),('11288','2013-11-18','09:15:00',1.82),('11288','2013-11-18','09:20:00',2.19),('11288','2013-11-18','09:25:00',2.32),('11288','2013-11-18','09:30:00',2.1),('11288','2013-11-18','09:35:00',2.73),('11288','2013-11-18','09:40:00',2.1),('11288','2013-11-18','09:45:00',1.88),('11288','2013-11-18','09:50:00',1.66),('11288','2013-11-18','09:55:00',1.82),('11288','2013-11-18','10:00:00',2.07),('11288','2013-11-18','10:05:00',2.25),('11288','2013-11-18','10:10:00',2.6),('11288','2013-11-18','10:15:00',2.64),('11288','2013-11-18','10:20:00',2.22),('11288','2013-11-18','10:25:00',2.17),('11288','2013-11-18','10:30:00',2.02),('11288','2013-11-18','10:35:00',2.06),('11288','2013-11-18','10:40:00',2.15),('11288','2013-11-18','10:45:00',2.22),('11288','2013-11-18','10:50:00',2.09),('11288','2013-11-18','10:55:00',1.86),('11288','2013-11-18','11:00:00',1.7),('11288','2013-11-18','11:05:00',1.56),('11288','2013-11-18','11:10:00',1.42),('11288','2013-11-18','11:15:00',1.32),('11288','2013-11-18','11:20:00',1.45),('11288','2013-11-18','11:25:00',1.69),('11288','2013-11-18','11:30:00',1.89),('11288','2013-11-18','11:35:00',1.97),('11288','2013-11-18','11:40:00',2.04),('11288','2013-11-18','11:45:00',2.09),('11288','2013-11-18','11:50:00',2.18),('11288','2013-11-18','11:55:00',2.32),('11288','2013-11-18','12:00:00',2.42),('11288','2013-11-18','12:05:00',2.5),('11288','2013-11-18','12:10:00',2.48),('11288','2013-11-18','12:15:00',2.56),('11288','2013-11-18','12:20:00',2.68),('11288','2013-11-18','12:25:00',2.73),('11288','2013-11-18','12:30:00',2.47),('11288','2013-11-18','12:35:00',2.2),('11288','2013-11-18','12:40:00',1.91),('11288','2013-11-18','12:45:00',1.73),('11288','2013-11-18','12:50:00',1.62),('11288','2013-11-18','12:55:00',1.57),('11288','2013-11-18','13:00:00',1.55),('11288','2013-11-18','13:05:00',1.66),('11288','2013-11-18','13:10:00',1.79),('11288','2013-11-18','13:15:00',1.72),('11288','2013-11-18','13:20:00',1.59),('11288','2013-11-18','13:25:00',1.46),('11288','2013-11-18','13:30:00',1.64),('11288','2013-11-18','13:35:00',1.94),('11288','2013-11-18','13:40:00',2),('11288','2013-11-18','13:45:00',1.85),('11288','2013-11-18','13:50:00',1.74),('11288','2013-11-18','13:55:00',1.56),('11288','2013-11-18','14:00:00',1.34),('11288','2013-11-18','14:05:00',1.1),('11288','2014-04-19','07:30:00',1.07),('11288','2014-04-19','07:35:00',1.27),('11288','2014-04-19','07:40:00',1.45),('11288','2014-04-19','07:45:00',1.1),('11288','2014-04-19','07:50:00',1.55),('11288','2014-04-19','07:55:00',2.61),('11288','2014-04-19','08:00:00',2.21),('11288','2014-04-19','08:05:00',1.91),('11288','2014-04-19','08:10:00',2.1),('11288','2014-04-19','08:15:00',1.89),('11288','2014-04-19','08:20:00',2.14),('11288','2014-04-19','08:25:00',2.68),('11288','2014-04-19','08:30:00',3.03),('11288','2014-04-19','08:35:00',3.03),('11288','2014-04-19','08:40:00',3.21),('11288','2014-04-19','08:45:00',3.04),('11288','2014-04-19','08:50:00',2.44),('11288','2014-04-19','08:55:00',1.61),('11288','2014-04-19','09:00:00',1.06),('11288','2014-04-19','09:10:00',1.21),('11288','2014-04-19','09:15:00',1.52),('11288','2014-04-19','09:20:00',1.96),('11288','2014-04-19','09:25:00',2.75),('11288','2014-04-19','09:30:00',3.72),('11288','2014-04-19','09:35:00',3.24),('11288','2014-04-19','09:40:00',2.01),('11288','2014-04-19','09:45:00',1.52),('11288','2014-04-19','09:50:00',1.37),('11288','2014-04-19','09:55:00',1.32),('11288','2014-04-19','10:00:00',1.34),('11288','2014-04-19','10:05:00',1.04),('11288','2014-04-19','10:10:00',1.01),('11288','2014-04-19','10:15:00',1.21),('11288','2014-04-19','10:20:00',1.43),('11288','2014-04-19','10:25:00',1.33),('11288','2014-04-19','10:30:00',1.39),('11288','2014-04-19','10:35:00',1.76),('11288','2014-04-19','10:40:00',2.22),('11288','2014-04-19','10:45:00',2.09),('11288','2014-04-19','10:50:00',2.25),('11288','2014-04-19','10:55:00',2.88),('11288','2014-04-19','11:00:00',2.85),('11288','2014-04-19','11:05:00',2.27),('11288','2014-04-19','11:10:00',2.31),('11288','2014-04-19','11:15:00',3.59),('11288','2014-04-19','11:20:00',5.01),('11288','2014-04-19','11:25:00',3.96),('11288','2014-04-19','11:30:00',4.47),('11288','2014-04-19','11:35:00',4.45),('11288','2014-04-19','11:40:00',3.85),('11288','2014-04-19','11:45:00',3.63),('11288','2014-04-19','11:50:00',2.83),('11288','2014-04-19','11:55:00',1.82),('11288','2014-04-19','12:00:00',1.49),('11288','2014-04-19','12:05:00',1.2),('11288','2014-04-19','13:05:00',1.42),('11288','2014-04-19','13:10:00',1.32),('11288','2014-04-19','13:15:00',2.87),('11288','2014-04-19','13:20:00',2.21),('11288','2014-04-19','13:25:00',1.3),('11288','2014-04-19','13:35:00',1.61),('11288','2014-04-19','13:40:00',1.29),('11288','2014-04-19','13:45:00',1.06),('11288','2014-04-19','13:50:00',1.52),('11288','2014-04-19','13:55:00',1.62),('11288','2014-04-19','14:15:00',1.02),('11288','2014-04-19','14:25:00',1.26),('11288','2014-04-19','14:30:00',2.57),('11288','2014-04-19','14:35:00',2.79),('11288','2014-04-19','14:40:00',3.39),('11288','2014-04-19','14:45:00',3.49),('11288','2014-04-19','14:50:00',2.18),('11288','2014-04-19','14:55:00',2.1),('11288','2014-04-19','15:00:00',2.67),('11288','2014-04-19','15:05:00',2.01),('11288','2014-04-19','15:10:00',1.02),('11288','2014-04-19','15:20:00',1.38),('11288','2014-04-19','15:25:00',2.1),('11288','2014-04-19','15:30:00',1.87),('11288','2014-04-19','15:35:00',1.19),('11288','2014-04-19','15:45:00',2.15),('11288','2014-04-19','15:50:00',6.3),('11288','2014-04-19','15:55:00',4.3),('11288','2014-04-19','16:00:00',4.31),('11288','2014-04-19','16:05:00',3.69),('11288','2014-04-19','16:10:00',3.21),('11288','2014-04-19','16:15:00',3.19),('11288','2014-04-19','16:20:00',3.65),('11288','2014-04-19','16:25:00',3.47),('11288','2014-04-19','16:30:00',4.27),('11288','2014-04-19','16:35:00',2.7),('11288','2014-04-19','16:40:00',1.96),('11288','2014-04-19','16:45:00',1.79),('11288','2014-04-19','16:50:00',1.36),('11288','2014-04-19','17:00:00',1.16),('11288','2014-04-19','17:05:00',1.77),('11288','2014-04-19','17:10:00',1.74),('11288','2014-04-19','17:15:00',2.04),('11288','2014-04-19','17:20:00',2.98),('11288','2014-04-19','17:25:00',2.24),('11288','2014-04-19','17:30:00',2.09),('11288','2014-04-19','17:35:00',1.71),('11288','2014-04-19','17:40:00',1.02),('11288','2013-11-17','08:40:00',1.03),('11288','2013-11-17','08:45:00',1.65),('11288','2013-11-17','08:50:00',2.18),('11288','2013-11-17','08:55:00',2.36),('11288','2013-11-17','09:00:00',2.14),('11288','2013-11-17','09:05:00',2.06),('11288','2013-11-17','09:10:00',2.16),('11288','2013-11-17','09:15:00',1.2),('11288','2013-11-17','09:20:00',2.22),('11288','2013-11-17','09:25:00',2.55),('11288','2013-11-17','09:30:00',2.57),('11288','2013-11-17','09:35:00',2.45),('11288','2013-11-17','09:40:00',2.55),('11288','2013-11-17','09:45:00',2.69),('11288','2013-11-17','09:50:00',2.75),('11288','2013-11-17','09:55:00',2.83),('11288','2013-11-17','10:00:00',2.93),('11288','2013-11-17','10:05:00',3),('11288','2013-11-17','10:10:00',3.11),('11288','2013-11-17','10:15:00',3.2),('11288','2013-11-17','10:20:00',3.27),('11288','2013-11-17','10:25:00',3.3),('11288','2013-11-17','10:30:00',3.26),('11288','2013-11-17','10:35:00',3.25),('11288','2013-11-17','10:40:00',3.45),('11288','2013-11-17','10:45:00',3.48),('11288','2013-11-17','10:50:00',3.53),('11288','2013-11-17','10:55:00',3.6),('11288','2013-11-17','11:00:00',3.67),('11288','2013-11-17','11:05:00',3.7),('11288','2013-11-17','11:10:00',3.69),('11288','2013-11-17','11:15:00',3.7),('11288','2013-11-17','11:20:00',3.76),('11288','2013-11-17','11:25:00',3.79),('11288','2013-11-17','11:30:00',3.77),('11288','2013-11-17','11:35:00',3.77),('11288','2013-11-17','11:40:00',3.79),('11288','2013-11-17','11:45:00',3.82),('11288','2013-11-17','11:50:00',3.71),('11288','2013-11-17','11:55:00',3.52),('11288','2013-11-17','12:00:00',3.75),('11288','2013-11-17','12:05:00',3.75),('11288','2013-11-17','12:10:00',3.72),('11288','2013-11-17','12:15:00',3.72),('11288','2013-11-17','12:20:00',3.62),('11288','2013-11-17','12:25:00',3.66),('11288','2013-11-17','12:30:00',3.67),('11288','2013-11-17','12:35:00',3.63),('11288','2013-11-17','12:40:00',3.56),('11288','2013-11-17','12:45:00',3.54),('11288','2013-11-17','12:50:00',3.46),('11288','2013-11-17','12:55:00',3.42),('11288','2013-11-17','13:00:00',3.42),('11288','2013-11-17','13:05:00',3.37),('11288','2013-11-17','13:10:00',3.28),('11288','2013-11-17','13:15:00',3.26),('11288','2013-11-17','13:20:00',3.21),('11288','2013-11-17','13:25:00',3.19),('11288','2013-11-17','13:30:00',3.19),('11288','2013-11-17','13:35:00',3.19),('11288','2013-11-17','13:40:00',2.47),('11288','2013-11-17','13:45:00',2.01),('11288','2013-11-17','13:50:00',2.13),('11288','2013-11-17','14:10:00',1.73),('11288','2013-11-17','14:15:00',2.39),('11288','2013-11-17','14:20:00',2.27),('11288','2013-11-17','14:25:00',2.15),('11288','2013-11-17','14:30:00',2),('11288','2013-11-17','14:35:00',1.93),('11288','2013-11-17','14:40:00',1.75),('11288','2013-11-16','12:45:00',1.03),('11288','2013-11-16','12:50:00',1.35),('11288','2013-11-16','12:55:00',1.43),('11288','2013-11-16','13:00:00',1.6),('11288','2013-11-16','13:05:00',1.86),('11288','2013-11-16','13:10:00',1.6),('11288','2013-11-16','13:15:00',1.27),('11288','2013-11-16','13:20:00',1.09),('11288','2013-11-16','13:25:00',1.06),('11288','2013-11-15','08:50:00',1.06),('11288','2013-11-15','08:55:00',1.2),('11288','2013-11-15','09:00:00',1.35),('11288','2013-11-15','09:05:00',1.57),('11288','2013-11-15','09:10:00',1.93),('11288','2013-11-15','09:15:00',2.2),('11288','2013-11-15','09:20:00',1.83),('11288','2013-11-15','09:25:00',1.79),('11288','2013-11-15','09:30:00',2.2),('11288','2013-11-15','09:35:00',2.31),('11288','2013-11-15','09:40:00',1.9),('11288','2013-11-15','09:45:00',1.27),('11288','2013-11-15','09:50:00',1.02),('11288','2013-11-15','10:00:00',1.08),('11288','2013-11-15','10:05:00',1.27),('11288','2013-11-15','10:10:00',1.89),('11288','2013-11-15','10:15:00',2.33),('11288','2013-11-15','10:20:00',2.14),('11288','2013-11-15','10:25:00',1.71),('11288','2013-11-15','10:30:00',1.51),('11288','2013-11-15','10:35:00',1.36),('11288','2013-11-15','10:40:00',1.24),('11288','2013-11-15','10:45:00',1.33),('11288','2013-11-15','10:50:00',1.83),('11288','2013-11-15','10:55:00',2.23),('11288','2013-11-15','11:00:00',2.2),('11288','2013-11-15','11:05:00',2.12),('11288','2013-11-15','11:10:00',2.06),('11288','2013-11-15','11:15:00',2.16),('11288','2013-11-15','11:20:00',2.68),('11288','2013-11-15','11:25:00',2.79),('11288','2013-11-15','11:30:00',2.92),('11288','2013-11-15','11:35:00',2.84),('11288','2013-11-15','11:40:00',2.96),('11288','2013-11-15','11:45:00',2.53),('11288','2013-11-15','11:50:00',2.2),('11288','2013-11-15','11:55:00',2.02),('11288','2013-11-15','12:00:00',2.09),('11288','2013-11-15','12:05:00',2.14),('11288','2013-11-15','12:10:00',1.86),('11288','2013-11-15','12:15:00',1.94),('11288','2013-11-15','12:20:00',2.39),('11288','2013-11-15','12:25:00',2.46),('11288','2013-11-15','12:30:00',2.14),('11288','2013-11-15','12:35:00',1.95),('11288','2013-11-15','12:40:00',1.87),('11288','2013-11-15','12:45:00',1.83),('11288','2013-11-15','12:50:00',1.9),('11288','2013-11-15','12:55:00',2.16),('11288','2013-11-15','13:00:00',2.2),('11288','2013-11-15','13:05:00',1.92),('11288','2013-11-15','13:10:00',1.74),('11288','2013-11-15','13:15:00',1.48),('11288','2013-11-15','13:20:00',1.44),('11288','2013-11-15','13:25:00',1.62),('11288','2013-11-15','13:30:00',1.78),('11288','2013-11-15','13:35:00',1.99),('11288','2013-11-15','13:40:00',2.27),('11288','2013-11-15','13:45:00',2.77),('11288','2013-11-15','13:50:00',2.79),('11288','2013-11-15','13:55:00',1.91),('11288','2013-11-15','14:00:00',1.77),('11288','2013-11-15','14:05:00',1.53),('11288','2013-11-15','14:10:00',1.28),('11288','2013-11-15','14:15:00',1.03),('11288','2013-11-14','08:15:00',1.1),('11288','2013-11-14','08:55:00',1.36),('11288','2013-11-14','09:00:00',2.34),('11288','2013-11-14','09:05:00',2.44),('11288','2013-11-14','09:10:00',2.19),('11288','2013-11-14','09:15:00',2),('11288','2013-11-14','09:20:00',2.37),('11288','2013-11-14','09:25:00',2.37),('11288','2013-11-14','09:30:00',2.44),('11288','2013-11-14','09:35:00',2.6),('11288','2013-11-14','09:40:00',2.67),('11288','2013-11-14','09:45:00',2.75),('11288','2013-11-14','09:50:00',1.95),('11288','2013-11-14','09:55:00',1.48),('11288','2013-11-14','10:00:00',1.36),('11288','2013-11-14','10:05:00',1.96),('11288','2013-11-14','10:10:00',1.68),('11288','2013-11-14','10:15:00',3.32),('11288','2013-11-14','10:20:00',3.39),('11288','2013-11-14','10:25:00',3.37),('11288','2013-11-14','10:30:00',3.35),('11288','2013-11-14','10:35:00',3.18),('11288','2013-11-14','10:40:00',3.46),('11288','2013-11-14','10:45:00',3.44),('11288','2013-11-14','10:50:00',3.58),('11288','2013-11-14','10:55:00',3.67),('11288','2013-11-14','11:00:00',3.69),('11288','2013-11-14','11:05:00',3.83),('11288','2013-11-14','11:10:00',3.9),('11288','2013-11-14','11:15:00',3.96),('11288','2013-11-14','11:20:00',4.09),('11288','2013-11-14','11:25:00',4.12),('11288','2013-11-14','11:30:00',4.14),('11288','2013-11-14','11:35:00',3.7),('11288','2013-11-14','11:40:00',3.4),('11288','2013-11-14','11:45:00',2.68),('11288','2013-11-14','11:50:00',2.54),('11288','2013-11-14','11:55:00',3.69),('11288','2013-11-14','12:00:00',4.56),('11288','2013-11-14','12:05:00',3.77),('11288','2013-11-14','12:10:00',2.27),('11288','2013-11-14','12:15:00',2.3),('11288','2013-11-14','12:20:00',2.13),('11288','2013-11-14','12:25:00',1.87),('11288','2013-11-14','12:30:00',1.87),('11288','2013-11-14','12:35:00',1.95),('11288','2013-11-14','12:40:00',1.91),('11288','2013-11-14','12:45:00',1.95),('11288','2013-11-14','12:50:00',1.99),('11288','2013-11-14','12:55:00',1.94),('11288','2013-11-14','13:00:00',1.9),('11288','2013-11-14','13:05:00',1.68),('11288','2013-11-14','13:10:00',1.5),('11288','2013-11-14','13:15:00',1.53),('11288','2013-11-14','13:20:00',1.52),('11288','2013-11-14','13:25:00',1.51),('11288','2013-11-14','13:30:00',1.66),('11288','2013-11-14','13:35:00',1.57),('11288','2013-11-14','13:40:00',1.46),('11288','2013-11-14','13:45:00',1.4),('11288','2013-11-14','13:50:00',1.43),('11288','2013-11-14','13:55:00',1.7),('11288','2013-11-14','14:00:00',1.53),('11288','2013-11-14','14:05:00',1.5),('11288','2013-11-14','14:10:00',1.42),('11288','2013-11-14','14:15:00',1.32),('11288','2013-11-14','14:20:00',1.3),('11288','2013-11-14','14:25:00',1.21),('11288','2013-11-14','14:30:00',1.11),('11288','2013-11-14','14:35:00',1.06),('11288','2013-11-13','10:00:00',1.52),('11288','2013-11-13','10:05:00',1.89),('11288','2013-11-13','10:10:00',1.9),('11288','2013-11-13','10:15:00',2.21),('11288','2013-11-13','10:20:00',3.84),('11288','2013-11-13','10:25:00',4.37),('11288','2013-11-13','10:30:00',4.14),('11288','2013-11-13','10:35:00',5.03),('11288','2013-11-13','10:40:00',4.58),('11288','2013-11-13','10:45:00',4.6),('11288','2013-11-13','10:50:00',5.11),('11288','2013-11-13','10:55:00',3.78),('11288','2013-11-13','11:00:00',1.79),('11288','2013-11-13','11:05:00',1.47),('11288','2013-11-13','11:10:00',1.49),('11288','2013-11-13','11:15:00',1.54),('11288','2013-11-13','11:20:00',1.59),('11288','2013-11-13','11:25:00',1.65),('11288','2013-11-13','11:30:00',1.72),('11288','2013-11-13','11:35:00',1.59),('11288','2013-11-13','11:40:00',1.53),('11288','2013-11-13','11:45:00',1.78),('11288','2013-11-13','11:50:00',2.01),('11288','2013-11-13','11:55:00',1.86),('11288','2013-11-13','12:00:00',1.42),('11288','2013-11-13','12:05:00',1.32),('11288','2013-11-13','12:10:00',1.46),('11288','2013-11-13','12:15:00',1.53),('11288','2013-11-13','12:20:00',1.46),('11288','2013-11-13','12:25:00',1.36),('11288','2013-11-13','12:30:00',1.09),('11288','2013-11-13','12:35:00',1.08),('11288','2013-11-13','12:40:00',1.3),('11288','2013-11-13','12:45:00',1.25),('11288','2013-11-13','12:50:00',1.25),('11288','2013-11-13','12:55:00',1.73),('11288','2013-11-13','13:00:00',1.96),('11288','2013-11-13','13:05:00',2.18),('11288','2013-11-13','13:10:00',2.07),('11288','2013-11-13','13:15:00',2.03),('11288','2013-11-13','13:20:00',1.63),('11288','2013-11-13','13:25:00',1.36),('11288','2013-11-13','13:30:00',1.41),('11288','2013-11-13','13:35:00',1.53),('11288','2013-11-13','13:40:00',1.67),('11288','2013-11-13','13:45:00',1.52),('11288','2013-11-13','13:50:00',1.36),('11288','2013-11-13','13:55:00',2.2),('11288','2013-11-13','14:00:00',2.43),('11288','2013-11-13','14:05:00',2.55),('11288','2013-11-13','14:10:00',2.43),('11288','2013-11-13','14:15:00',2.45),('11288','2013-11-13','14:20:00',2.24),('11288','2013-11-13','14:25:00',2.39),('11288','2013-11-13','14:30:00',2.25),('11288','2013-11-13','14:35:00',1.72),('11288','2013-11-13','14:40:00',1.4),('11288','2013-11-13','14:45:00',1.17),('11288','2013-11-13','14:50:00',1.06),('11288','2013-11-12','10:00:00',1.38),('11288','2013-11-12','10:05:00',1.18),('11288','2013-11-12','10:50:00',1.01),('11288','2013-11-12','10:55:00',1.16),('11288','2013-11-12','11:00:00',1.28),('11288','2013-11-12','11:05:00',1.16),('11288','2013-11-12','11:10:00',1.36),('11288','2013-11-12','11:15:00',1.4),('11288','2013-11-12','11:20:00',1.4),('11288','2013-11-12','11:25:00',2.17),('11288','2013-11-12','11:30:00',1.54),('11288','2013-11-12','11:35:00',1.89),('11288','2013-11-12','11:40:00',2.52),('11288','2013-11-12','11:45:00',1.74),('11288','2013-11-12','11:50:00',2.65),('11288','2013-11-12','11:55:00',1.74),('11288','2013-11-12','12:00:00',3.65),('11288','2013-11-12','12:05:00',2.27),('11288','2013-11-12','12:10:00',1.38),('11288','2013-11-12','12:15:00',1.36),('11288','2013-11-12','12:20:00',1.47),('11288','2013-11-12','12:25:00',1.71),('11288','2013-11-12','12:30:00',5.02),('11288','2013-11-12','12:35:00',4.82),('11288','2013-11-12','12:40:00',3.4),('11288','2013-11-12','12:45:00',3.25),('11288','2013-11-12','12:50:00',3.1),('11288','2013-11-12','12:55:00',3.56),('11288','2013-11-12','13:00:00',3.18),('11288','2013-11-12','13:05:00',3.13),('11288','2013-11-12','13:10:00',3.42),('11288','2013-11-12','13:15:00',3.47),('11288','2013-11-12','13:20:00',2.85),('11288','2013-11-12','13:25:00',3.01),('11288','2013-11-12','13:30:00',3.07),('11288','2013-11-12','13:35:00',3.19),('11288','2013-11-12','13:40:00',3.18),('11288','2013-11-12','13:45:00',2.7),('11288','2013-11-12','13:50:00',2.32),('11288','2013-11-12','13:55:00',2.33),('11288','2013-11-12','14:00:00',2.28),('11288','2013-11-12','14:05:00',2.12),('11288','2013-11-12','14:10:00',3.51),('11288','2013-11-12','14:15:00',3.88),('11288','2013-11-12','14:20:00',3.21),('11288','2013-11-12','14:25:00',1.89),('11288','2013-11-12','14:30:00',2.27),('11288','2013-11-12','14:35:00',1.97),('11288','2013-11-12','14:40:00',2),('11288','2013-11-12','14:45:00',1.79),('11288','2013-11-12','14:50:00',1.49),('11288','2013-11-12','14:55:00',1.29),('11288','2013-11-12','15:00:00',1.21),('11288','2013-11-12','15:05:00',1.03),('11288','2013-11-12','15:20:00',1.04),('11288','2013-11-11','09:45:00',1.15),('11288','2013-11-11','09:50:00',2.04),('11288','2013-11-11','09:55:00',2.09),('11288','2013-11-11','10:00:00',1.66),('11288','2013-11-11','10:05:00',1.65),('11288','2013-11-11','10:10:00',2.24),('11288','2013-11-11','10:15:00',3.44),('11288','2013-11-11','10:20:00',3.56),('11288','2013-11-11','10:25:00',1.87),('11288','2013-11-11','10:30:00',1.35),('11288','2013-11-11','10:35:00',1.51),('11288','2013-11-11','10:40:00',1.13),('11288','2013-11-11','10:50:00',1.01),('11288','2013-11-11','11:00:00',1.44),('11288','2013-11-11','11:05:00',2.8),('11288','2013-11-11','11:10:00',5.23),('11288','2013-11-11','11:15:00',4.97),('11288','2013-11-11','11:20:00',3.02),('11288','2013-11-11','11:25:00',3.37),('11288','2013-11-11','11:30:00',5.53),('11288','2013-11-11','11:35:00',4.5),('11288','2013-11-11','11:40:00',4.99),('11288','2013-11-11','11:45:00',4),('11288','2013-11-11','11:50:00',5.04),('11288','2013-11-11','11:55:00',4.86),('11288','2013-11-11','12:00:00',4.63),('11288','2013-11-11','12:05:00',4.45),('11288','2013-11-11','12:10:00',3.78),('11288','2013-11-11','12:15:00',3.79),('11288','2013-11-11','12:20:00',4.37),('11288','2013-11-11','12:25:00',4.54),('11288','2013-11-11','12:30:00',1.76),('11288','2013-11-11','12:35:00',1.07),('11288','2013-11-11','12:40:00',2.48),('11288','2013-11-11','12:45:00',3.02),('11288','2013-11-11','12:50:00',1.5),('11288','2013-11-11','12:55:00',1.31),('11288','2013-11-11','13:00:00',1.84),('11288','2013-11-11','13:05:00',1.65),('11288','2013-11-11','13:10:00',2.37),('11288','2013-11-11','13:15:00',2.47),('11288','2013-11-11','13:30:00',1.12),('11288','2013-11-11','13:35:00',1.77),('11288','2013-11-11','13:40:00',2.48),('11288','2013-11-11','13:45:00',1.02),('11288','2013-11-11','13:50:00',1.06),('11288','2013-11-11','13:55:00',1.35),('11288','2013-11-11','14:00:00',3.29),('11288','2013-11-11','14:05:00',1.99),('11288','2013-11-11','14:10:00',1.4),('11288','2013-11-11','14:15:00',1.34),('11288','2013-11-11','14:20:00',2.06),('11288','2013-11-11','14:25:00',2.54),('11288','2013-11-11','14:30:00',2.34),('11288','2013-11-11','14:35:00',2.55),('11288','2013-11-11','14:40:00',2.17),('11288','2013-11-11','14:45:00',1.26),('11288','2013-11-10','07:40:00',1.06),('11288','2013-11-10','07:45:00',1.28),('11288','2013-11-10','07:50:00',1.47),('11288','2013-11-10','07:55:00',1.43),('11288','2013-11-10','08:00:00',1.52),('11288','2013-11-10','08:05:00',1.23),('11288','2013-11-10','08:10:00',1.2),('11288','2013-11-10','08:15:00',1.24),('11288','2013-11-10','08:20:00',1.46),('11288','2013-11-10','08:25:00',1.36),('11288','2013-11-10','08:30:00',1.51),('11288','2013-11-10','08:35:00',1.81),('11288','2013-11-10','08:40:00',1.92),('11288','2013-11-10','08:45:00',1.68),('11288','2013-11-10','08:50:00',2.24),('11288','2013-11-10','08:55:00',2.14),('11288','2013-11-10','09:00:00',2.17),('11288','2013-11-10','09:05:00',1.78),('11288','2013-11-10','09:10:00',1.61),('11288','2013-11-10','09:15:00',1.9),('11288','2013-11-10','09:20:00',2.32),('11288','2013-11-10','09:25:00',2.73),('11288','2013-11-10','09:30:00',2.27),('11288','2013-11-10','09:35:00',2.34),('11288','2013-11-10','09:40:00',2.61),('11288','2013-11-10','09:45:00',2.91),('11288','2013-11-10','09:50:00',3.05),('11288','2013-11-10','09:55:00',2.98),('11288','2013-11-10','10:00:00',2.89),('11288','2013-11-10','10:05:00',3.44),('11288','2013-11-10','10:10:00',3.71),('11288','2013-11-10','10:15:00',3.7),('11288','2013-11-10','10:20:00',3.43),('11288','2013-11-10','10:25:00',4.17),('11288','2013-11-10','10:30:00',3.95),('11288','2013-11-10','10:35:00',2.61),('11288','2013-11-10','10:40:00',3.98),('11288','2013-11-10','10:45:00',3.69),('11288','2013-11-10','10:50:00',4.37),('11288','2013-11-10','10:55:00',4.77),('11288','2013-11-10','11:00:00',2.37),('11288','2013-11-10','11:05:00',2.18),('11288','2013-11-10','11:10:00',1.69),('11288','2013-11-10','11:20:00',1.78),('11288','2013-11-10','11:25:00',2.23),('11288','2013-11-10','11:30:00',1.49),('11288','2013-11-10','11:35:00',2.16),('11288','2013-11-10','11:40:00',3.58),('11288','2013-11-10','11:45:00',3.87),('11288','2013-11-10','11:50:00',1.5),('11288','2013-11-10','11:55:00',2.31),('11288','2013-11-10','12:00:00',1.38),('11288','2013-11-10','12:05:00',1.8),('11288','2013-11-10','12:10:00',2.73),('11288','2013-11-10','12:15:00',4.23),('11288','2013-11-10','12:20:00',3.75),('11288','2013-11-10','12:25:00',3.93),('11288','2013-11-10','12:30:00',2.28),('11288','2013-11-10','12:35:00',3.82),('11288','2013-11-10','12:40:00',4.45),('11288','2013-11-10','12:45:00',4.71),('11288','2013-11-10','12:50:00',4.91),('11288','2013-11-10','12:55:00',2.89),('11288','2013-11-10','13:00:00',2.13),('11288','2013-11-10','13:05:00',1.3),('11288','2013-11-10','13:10:00',1.45),('11288','2013-11-10','13:35:00',1.53),('11288','2013-11-10','13:40:00',1.32),('11288','2013-11-10','13:45:00',1.89),('11288','2013-11-10','13:50:00',3.29),('11288','2013-11-10','13:55:00',2.25),('11288','2013-11-10','14:20:00',1.32),('11288','2013-11-10','14:25:00',1.04),('11288','2013-11-10','14:30:00',1.76),('11288','2013-11-09','09:10:00',1.03),('11288','2013-11-09','09:15:00',1.32),('11288','2013-11-09','09:30:00',1.47),('11288','2013-11-09','09:35:00',1.35),('11288','2013-11-09','09:40:00',2.3),('11288','2013-11-09','09:45:00',2.47),('11288','2013-11-09','09:50:00',3.64),('11288','2013-11-09','09:55:00',3.32),('11288','2013-11-09','10:00:00',3.37),('11288','2013-11-09','10:05:00',3.27),('11288','2013-11-09','10:10:00',2.89),('11288','2013-11-09','10:15:00',3.22),('11288','2013-11-09','10:20:00',2.96),('11288','2013-11-09','10:25:00',2.01),('11288','2013-11-09','10:30:00',1.97),('11288','2013-11-09','10:35:00',2.27),('11288','2013-11-09','10:40:00',2.32),('11288','2013-11-09','10:45:00',2.31),('11288','2013-11-09','10:50:00',2.86),('11288','2013-11-09','10:55:00',3.02),('11288','2013-11-09','11:00:00',3.01),('11288','2013-11-09','11:05:00',3.43),('11288','2013-11-09','11:10:00',4.02),('11288','2013-11-09','11:15:00',3.58),('11288','2013-11-09','11:20:00',2.81),('11288','2013-11-09','11:25:00',3.14),('11288','2013-11-09','11:30:00',3.34),('11288','2013-11-09','11:35:00',2.49),('11288','2013-11-09','11:40:00',4.08),('11288','2013-11-09','11:45:00',4.86),('11288','2013-11-09','11:50:00',3.75),('11288','2013-11-09','11:55:00',4.84),('11288','2013-11-09','12:00:00',5.42),('11288','2013-11-09','12:05:00',4.84),('11288','2013-11-09','12:10:00',2.55),('11288','2013-11-09','12:15:00',3.27),('11288','2013-11-09','12:20:00',1.91),('11288','2013-11-09','12:25:00',2.85),('11288','2013-11-09','12:30:00',3.47),('11288','2013-11-09','12:35:00',4.67),('11288','2013-11-09','12:40:00',4.71),('11288','2013-11-09','12:45:00',2.52),('11288','2013-11-09','12:50:00',2.33),('11288','2013-11-09','12:55:00',3.07),('11288','2013-11-09','13:00:00',3.38),('11288','2013-11-09','13:05:00',3.8),('11288','2013-11-09','13:10:00',4.32),('11288','2013-11-09','13:15:00',3.66),('11288','2013-11-09','13:20:00',1.39),('11288','2013-11-09','13:25:00',4.03),('11288','2013-11-09','13:30:00',3.65),('11288','2013-11-09','13:35:00',3.56),('11288','2013-11-09','13:40:00',3.39),('11288','2013-11-09','13:45:00',3.33),('11288','2013-11-09','13:50:00',3.33),('11288','2013-11-09','13:55:00',3.27),('11288','2013-11-09','14:00:00',2.62),('11288','2013-11-09','14:05:00',2.79),('11288','2013-11-09','14:10:00',1.43),('11288','2013-11-09','14:15:00',2.03),('11288','2013-11-09','14:20:00',2.86),('11288','2013-11-09','14:25:00',1.85),('11288','2013-11-09','14:35:00',1.71),('11288','2013-11-09','14:40:00',1.77),('11288','2013-11-09','14:45:00',1.31),('11288','2013-11-09','14:50:00',1.68),('11288','2013-11-09','15:30:00',1.18),('11288','2013-11-09','15:35:00',1),('11288','2013-11-08','09:00:00',1.24),('11288','2013-11-08','09:05:00',1.43),('11288','2013-11-08','09:10:00',2),('11288','2013-11-08','09:15:00',1.85),('11288','2013-11-08','09:20:00',1.41),('11288','2013-11-08','09:25:00',1.73),('11288','2013-11-08','09:30:00',2.66),('11288','2013-11-08','09:35:00',2.21),('11288','2013-11-08','09:40:00',1.97),('11288','2013-11-08','09:45:00',1.39),('11288','2013-11-08','09:50:00',3.27),('11288','2013-11-08','09:55:00',3.08),('11288','2013-11-08','10:00:00',3.1),('11288','2013-11-08','10:05:00',2.54),('11288','2013-11-08','10:10:00',2.23),('11288','2013-11-08','10:15:00',1.49),('11288','2013-11-08','10:20:00',1.01),('11288','2013-11-08','10:25:00',1.15),('11288','2013-11-08','10:45:00',2.43),('11288','2013-11-08','10:50:00',3.88),('11288','2013-11-08','10:55:00',1.55),('11288','2013-11-08','11:00:00',1.31),('11288','2013-11-08','11:05:00',1.13),('11288','2013-11-08','11:10:00',1.15),('11288','2013-11-08','11:15:00',1.41),('11288','2013-11-08','11:20:00',2.07),('11288','2013-11-08','11:25:00',1.2),('11288','2013-11-08','11:30:00',1.29),('11288','2013-11-08','11:35:00',2.28),('11288','2013-11-08','11:40:00',2.81),('11288','2013-11-08','11:45:00',2.62),('11288','2013-11-08','11:50:00',4.13),('11288','2013-11-08','11:55:00',4.66),('11288','2013-11-08','12:00:00',4.3),('11288','2013-11-08','12:05:00',4.06),('11288','2013-11-08','12:10:00',3.5),('11288','2013-11-08','12:20:00',2.53),('11288','2013-11-08','12:30:00',3.7),('11288','2013-11-08','12:35:00',4.44),('11288','2013-11-08','12:40:00',4.45),('11288','2013-11-08','12:45:00',4.45),('11288','2013-11-08','12:50:00',4.35),('11288','2013-11-08','12:55:00',4.19),('11288','2013-11-08','13:00:00',4.03),('11288','2013-11-08','13:05:00',4.08),('11288','2013-11-08','13:10:00',3.37),('11288','2013-11-08','13:15:00',1.58),('11288','2013-11-08','13:20:00',2.76),('11288','2013-11-08','13:30:00',2.36),('11288','2013-11-08','13:35:00',3.59),('11288','2013-11-08','13:40:00',3.42),('11288','2013-11-08','13:45:00',3.27),('11288','2013-11-08','13:50:00',3.22),('11288','2013-11-08','13:55:00',3.14),('11288','2013-11-08','14:00:00',3.02),('11288','2013-11-08','14:05:00',2.91),('11288','2013-11-08','14:10:00',2.81),('11288','2013-11-08','14:15:00',2.63),('11288','2013-11-08','14:20:00',1.88),('11288','2013-11-08','14:25:00',2.56),('11288','2013-11-08','14:30:00',2.56),('11288','2013-11-08','14:35:00',2.58),('11288','2013-11-08','14:40:00',2.28),('11288','2013-11-08','14:45:00',2.1),('11288','2013-11-08','14:50:00',1.98),('11288','2013-11-08','14:55:00',1.57),('11288','2013-11-08','15:00:00',1.69),('11288','2013-11-08','15:05:00',1.72),('11288','2013-11-08','15:10:00',1.55),('11288','2013-11-08','15:15:00',1.28),('11288','2014-04-18','08:00:00',1.18),('11288','2014-04-18','08:05:00',1.99),('11288','2014-04-18','08:10:00',2.1),('11288','2014-04-18','08:15:00',1.06),('11288','2014-04-18','08:30:00',1),('11288','2014-04-18','08:35:00',1.47),('11288','2014-04-18','08:40:00',2.09),('11288','2014-04-18','08:45:00',2.32),('11288','2014-04-18','08:50:00',1.92),('11288','2014-04-18','08:55:00',1.8),('11288','2014-04-18','09:00:00',2.03),('11288','2014-04-18','09:05:00',3.48),('11288','2014-04-18','09:10:00',4.57),('11288','2014-04-18','09:15:00',4.4),('11288','2014-04-18','09:20:00',4.18),('11288','2014-04-18','09:25:00',2.51),('11288','2014-04-18','09:30:00',4.11),('11288','2014-04-18','09:35:00',2.78),('11288','2014-04-18','09:40:00',1.77),('11288','2014-04-18','09:45:00',2.67),('11288','2014-04-18','09:50:00',4.34),('11288','2014-04-18','09:55:00',5.18),('11288','2014-04-18','10:00:00',4.32),('11288','2014-04-18','10:05:00',2.93),('11288','2014-04-18','10:10:00',2.59),('11288','2014-04-18','10:15:00',2.8),('11288','2014-04-18','10:20:00',2.64),('11288','2014-04-18','10:25:00',2.7),('11288','2014-04-18','10:30:00',2.29),('11288','2014-04-18','10:35:00',2.1),('11288','2014-04-18','10:40:00',2.42),('11288','2014-04-18','10:45:00',3.84),('11288','2014-04-18','10:50:00',4.33),('11288','2014-04-18','10:55:00',4.72),('11288','2014-04-18','11:00:00',3.29),('11288','2014-04-18','11:05:00',2.95),('11288','2014-04-18','11:10:00',3.19),('11288','2014-04-18','11:15:00',5.24),('11288','2014-04-18','11:20:00',3.4),('11288','2014-04-18','11:25:00',2.52),('11288','2014-04-18','11:30:00',2.93),('11288','2014-04-18','11:35:00',2.93),('11288','2014-04-18','11:40:00',3.05),('11288','2014-04-18','11:45:00',2.9),('11288','2014-04-18','11:50:00',3.51),('11288','2014-04-18','11:55:00',3.11),('11288','2014-04-18','12:00:00',3.24),('11288','2014-04-18','12:05:00',6.03),('11288','2014-04-18','12:10:00',6.03),('11288','2014-04-18','12:15:00',6.32),('11288','2014-04-18','12:20:00',6.38),('11288','2014-04-18','12:25:00',4.86),('11288','2014-04-18','12:30:00',7.34),('11288','2014-04-18','12:35:00',7.05),('11288','2014-04-18','12:40:00',7.39),('11288','2014-04-18','12:45:00',5.88),('11288','2014-04-18','12:50:00',6.12),('11288','2014-04-18','12:55:00',4.55),('11288','2014-04-18','13:00:00',7.38),('11288','2014-04-18','13:05:00',4.07),('11288','2014-04-18','13:10:00',4.18),('11288','2014-04-18','13:15:00',4.06),('11288','2014-04-18','13:20:00',3.86),('11288','2014-04-18','13:25:00',2.95),('11288','2014-04-18','13:30:00',2.39),('11288','2014-04-18','13:35:00',2.45),('11288','2014-04-18','13:40:00',2.39),('11288','2014-04-18','13:45:00',2.05),('11288','2014-04-18','13:50:00',2.43),('11288','2014-04-18','13:55:00',4.06),('11288','2014-04-18','14:00:00',3.58),('11288','2014-04-18','14:05:00',3.16),('11288','2014-04-18','14:10:00',2.7),('11288','2014-04-18','14:15:00',2.42),('11288','2014-04-18','14:20:00',2.81),('11288','2014-04-18','14:25:00',3.57),('11288','2014-04-18','14:30:00',4.06),('11288','2014-04-18','14:35:00',4.51),('11288','2014-04-18','14:40:00',3.93),('11288','2014-04-18','14:45:00',4.58),('11288','2014-04-18','14:50:00',4.93),('11288','2014-04-18','14:55:00',4.03),('11288','2014-04-18','15:00:00',7.39),('11288','2014-04-18','15:05:00',4.5),('11288','2014-04-18','15:10:00',3.21),('11288','2014-04-18','15:15:00',3.64),('11288','2014-04-18','15:20:00',3.22),('11288','2014-04-18','15:25:00',3.93),('11288','2014-04-18','15:30:00',5.38),('11288','2014-04-18','15:35:00',6.05),('11288','2014-04-18','15:40:00',6.01),('11288','2014-04-18','15:45:00',4.05),('11288','2014-04-18','15:50:00',4.56),('11288','2014-04-18','15:55:00',4.82),('11288','2014-04-18','16:00:00',4.1),('11288','2014-04-18','16:05:00',3.19),('11288','2014-04-18','16:10:00',2.6),('11288','2014-04-18','16:15:00',2.29),('11288','2014-04-18','16:20:00',2.38),('11288','2014-04-18','16:25:00',3.93),('11288','2014-04-18','16:30:00',4.21),('11288','2014-04-18','16:35:00',4.99),('11288','2014-04-18','16:40:00',4.89),('11288','2014-04-18','16:45:00',4.46),('11288','2014-04-18','16:50:00',4.47),('11288','2014-04-18','16:55:00',4.35),('11288','2014-04-18','17:00:00',4.5),('11288','2014-04-18','17:05:00',4.42),('11288','2014-04-18','17:10:00',3.59),('11288','2014-04-18','17:15:00',3.32),('11288','2014-04-18','17:20:00',3.31),('11288','2014-04-18','17:25:00',3.25),('11288','2014-04-18','17:30:00',2.91),('11288','2014-04-18','17:35:00',2.78),('11288','2014-04-18','17:40:00',2.65),('11288','2014-04-18','17:45:00',2.47),('11288','2014-04-18','17:50:00',2.34),('11288','2014-04-18','17:55:00',2.22),('11288','2014-04-18','18:00:00',2.11),('11288','2014-04-18','18:05:00',1.89),('11288','2014-04-18','18:10:00',1.74),('11288','2014-04-18','18:15:00',1.54),('11288','2014-04-18','18:20:00',1.42),('11288','2014-04-18','18:25:00',1.25),('11288','2014-04-18','18:35:00',1.01),('11288','2013-11-07','08:00:00',1.01),('11288','2013-11-07','08:05:00',1.01),('11288','2013-11-07','08:10:00',1.21),('11288','2013-11-07','08:15:00',1.31),('11288','2013-11-07','08:20:00',1.37),('11288','2013-11-07','08:25:00',1.49),('11288','2013-11-07','08:30:00',1.58),('11288','2013-11-07','08:35:00',1.66),('11288','2013-11-07','08:40:00',1.72),('11288','2013-11-07','08:45:00',1.82),('11288','2013-11-07','08:50:00',1.92),('11288','2013-11-07','08:55:00',2.07),('11288','2013-11-07','09:00:00',2.13),('11288','2013-11-07','09:05:00',2.2),('11288','2013-11-07','09:10:00',2.37),('11288','2013-11-07','09:15:00',2.43),('11288','2013-11-07','09:20:00',2.41),('11288','2013-11-07','09:25:00',2.55),('11288','2013-11-07','09:30:00',2.54),('11288','2013-11-07','09:35:00',2.73),('11288','2013-11-07','09:40:00',2.85),('11288','2013-11-07','09:45:00',2.97),('11288','2013-11-07','09:50:00',3.07),('11288','2013-11-07','09:55:00',3.13),('11288','2013-11-07','10:00:00',3.11),('11288','2013-11-07','10:05:00',2.94),('11288','2013-11-07','10:10:00',3.16),('11288','2013-11-07','10:15:00',3.35),('11288','2013-11-07','10:20:00',3.38),('11288','2013-11-07','10:25:00',3.47),('11288','2013-11-07','10:30:00',3.46),('11288','2013-11-07','10:35:00',3.35),('11288','2013-11-07','10:40:00',3.6),('11288','2013-11-07','10:45:00',3.63),('11288','2013-11-07','10:50:00',3.68),('11288','2013-11-07','10:55:00',3.71),('11288','2013-11-07','11:00:00',3.75),('11288','2013-11-07','11:05:00',3.78),('11288','2013-11-07','11:10:00',3.73),('11288','2013-11-07','11:15:00',3.76),('11288','2013-11-07','11:20:00',3.82),('11288','2013-11-07','11:25:00',3.78),('11288','2013-11-07','11:30:00',3.87),('11288','2013-11-07','11:35:00',3.91),('11288','2013-11-07','11:40:00',3.88),('11288','2013-11-07','11:45:00',3.86),('11288','2013-11-07','11:50:00',3.75),('11288','2013-11-07','11:55:00',3.68),('11288','2013-11-07','12:00:00',3.83),('11288','2013-11-07','12:05:00',3.82),('11288','2013-11-07','12:10:00',3.81),('11288','2013-11-07','12:15:00',3.7),('11288','2013-11-07','12:20:00',3.68),('11288','2013-11-07','12:25:00',3.69),('11288','2013-11-07','12:30:00',3.61),('11288','2013-11-07','12:35:00',3.71),('11288','2013-11-07','12:40:00',3.74),('11288','2013-11-07','12:45:00',3.72),('11288','2013-11-07','12:50:00',3.65),('11288','2013-11-07','12:55:00',3.87),('11288','2013-11-07','13:00:00',4.07),('11288','2013-11-07','13:05:00',1.74),('11288','2013-11-07','13:10:00',1.55),('11288','2013-11-07','13:15:00',1.79),('11288','2013-11-07','13:20:00',1.97),('11288','2013-11-07','13:25:00',3.61),('11288','2013-11-07','13:30:00',2.73),('11288','2013-11-07','13:35:00',3.07),('11288','2013-11-07','13:40:00',1.91),('11288','2013-11-07','13:45:00',2.65),('11288','2013-11-07','13:50:00',2.36),('11288','2013-11-07','13:55:00',2.32),('11288','2013-11-07','14:00:00',1.63),('11288','2013-11-07','14:05:00',2.28),('11288','2013-11-07','14:10:00',2.29),('11288','2013-11-07','14:15:00',1.39),('11288','2013-11-07','14:20:00',2.01),('11288','2013-11-07','14:25:00',2.15),('11288','2013-11-07','14:30:00',2.54),('11288','2013-11-07','14:35:00',2.03),('11288','2013-11-07','14:40:00',1.88),('11288','2013-11-07','14:45:00',2.1),('11288','2013-11-07','14:50:00',2.01),('11288','2013-11-07','14:55:00',1.87),('11288','2013-11-07','15:00:00',1.74),('11288','2013-11-07','15:05:00',1.62),('11288','2013-11-07','15:10:00',1.47),('11288','2013-11-07','15:15:00',1.35),('11288','2013-11-07','15:20:00',1.26),('11288','2013-11-07','15:25:00',1.15),('11288','2013-11-07','15:30:00',1.05),('11288','2013-11-06','08:10:00',1.27),('11288','2013-11-06','08:15:00',1.55),('11288','2013-11-06','08:20:00',1.43),('11288','2013-11-06','08:35:00',1.17),('11288','2013-11-06','08:40:00',1.87),('11288','2013-11-06','08:45:00',1.96),('11288','2013-11-06','08:50:00',2.2),('11288','2013-11-06','08:55:00',2.14),('11288','2013-11-06','09:00:00',1.47),('11288','2013-11-06','09:05:00',1.54),('11288','2013-11-06','09:10:00',1.67),('11288','2013-11-06','09:15:00',2.16),('11288','2013-11-06','09:20:00',2.22),('11288','2013-11-06','09:25:00',2.72),('11288','2013-11-06','09:30:00',2.71),('11288','2013-11-06','09:35:00',2.85),('11288','2013-11-06','09:40:00',2.94),('11288','2013-11-06','09:45:00',3.08),('11288','2013-11-06','09:50:00',3.22),('11288','2013-11-06','09:55:00',3.3),('11288','2013-11-06','10:00:00',3.29),('11288','2013-11-06','10:05:00',3.11),('11288','2013-11-06','10:10:00',3.48),('11288','2013-11-06','10:15:00',3.6),('11288','2013-11-06','10:20:00',3.66),('11288','2013-11-06','10:25:00',3.72),('11288','2013-11-06','10:30:00',3.69),('11288','2013-11-06','10:35:00',3.53),('11288','2013-11-06','10:40:00',3.8),('11288','2013-11-06','10:45:00',3.87),('11288','2013-11-06','10:50:00',3.95),('11288','2013-11-06','10:55:00',4.02),('11288','2013-11-06','11:00:00',4.05),('11288','2013-11-06','11:05:00',4.07),('11288','2013-11-06','11:10:00',4.05),('11288','2013-11-06','11:15:00',3.85),('11288','2013-11-06','11:20:00',3.64),('11288','2013-11-06','11:25:00',4.14),('11288','2013-11-06','11:30:00',4.14),('11288','2013-11-06','11:35:00',4.15),('11288','2013-11-06','11:40:00',4.16),('11288','2013-11-06','11:45:00',4.22),('11288','2013-11-06','11:50:00',3.99),('11288','2013-11-06','11:55:00',4.11),('11288','2013-11-06','12:00:00',4.18),('11288','2013-11-06','12:05:00',4.15),('11288','2013-11-06','12:10:00',4.13),('11288','2013-11-06','12:15:00',4.09),('11288','2013-11-06','12:20:00',4.08),('11288','2013-11-06','12:25:00',4.06),('11288','2013-11-06','12:30:00',4.07),('11288','2013-11-06','12:35:00',4.04),('11288','2013-11-06','12:40:00',3.97),('11288','2013-11-06','12:45:00',3.96),('11288','2013-11-06','12:50:00',3.91),('11288','2013-11-06','12:55:00',3.83),('11288','2013-11-06','13:00:00',3.81),('11288','2013-11-06','13:05:00',3.79),('11288','2013-11-06','13:10:00',3.7),('11288','2013-11-06','13:15:00',3.63),('11288','2013-11-06','13:20:00',3.59),('11288','2013-11-06','13:25:00',3.55),('11288','2013-11-06','13:30:00',3.48),('11288','2013-11-06','13:35:00',3.4),('11288','2013-11-06','13:40:00',3.34),('11288','2013-11-06','13:45:00',3.27),('11288','2013-11-06','13:50:00',3.18),('11288','2013-11-06','13:55:00',3.11),('11288','2013-11-06','14:00:00',3),('11288','2013-11-06','14:05:00',2.93),('11288','2013-11-06','14:10:00',2.86),('11288','2013-11-06','14:15:00',2.77),('11288','2013-11-06','14:20:00',2.71),('11288','2013-11-06','14:25:00',2.6),('11288','2013-11-06','14:30:00',2.49),('11288','2013-11-06','14:35:00',2.41),('11288','2013-11-06','14:40:00',2.29),('11288','2013-11-06','14:45:00',2.17),('11288','2013-11-06','14:50:00',2.06),('11288','2013-11-06','14:55:00',1.92),('11288','2013-11-06','15:00:00',1.82),('11288','2013-11-06','15:05:00',1.69),('11288','2013-11-06','15:10:00',1.57),('11288','2013-11-06','15:15:00',1.45),('11288','2013-11-06','15:20:00',1.33),('11288','2013-11-06','15:25:00',1.19),('11288','2013-11-06','15:30:00',1.09),('11288','2013-11-05','08:20:00',1.08),('11288','2013-11-05','08:25:00',1.64),('11288','2013-11-05','08:30:00',1.88),('11288','2013-11-05','08:35:00',2.28),('11288','2013-11-05','08:40:00',2.25),('11288','2013-11-05','08:45:00',1.46),('11288','2013-11-05','08:50:00',1.21),('11288','2013-11-05','09:55:00',1.12),('11288','2013-11-05','10:00:00',1.36),('11288','2013-11-05','10:05:00',1.21),('11288','2013-11-05','10:10:00',1.14),('11288','2013-11-05','10:15:00',1.75),('11288','2013-11-05','10:20:00',2.78),('11288','2013-11-05','10:25:00',3.47),('11288','2013-11-05','10:30:00',2.62),('11288','2013-11-05','10:35:00',3.57),('11288','2013-11-05','10:40:00',2.61),('11288','2013-11-05','10:45:00',2.75),('11288','2013-11-05','10:50:00',2.38),('11288','2013-11-05','10:55:00',2.12),('11288','2013-11-05','11:00:00',1.78),('11288','2013-11-05','11:05:00',1.37),('11288','2013-11-05','11:10:00',1.07),('11288','2013-11-05','11:20:00',1.12),('11288','2013-11-05','11:25:00',1.33),('11288','2013-11-05','11:30:00',1.54),('11288','2013-11-05','11:35:00',2.04),('11288','2013-11-05','11:40:00',2.61),('11288','2013-11-05','11:45:00',2.47),('11288','2013-11-05','11:50:00',2.28),('11288','2013-11-05','11:55:00',1.92),('11288','2013-11-05','12:00:00',1.75),('11288','2013-11-05','12:05:00',2.31),('11288','2013-11-05','12:10:00',2.65),('11288','2013-11-05','12:15:00',2.6),('11288','2013-11-05','12:20:00',2.56),('11288','2013-11-05','12:25:00',2.36),('11288','2013-11-05','12:30:00',2.35),('11288','2013-11-05','12:35:00',1.87),('11288','2013-11-05','12:40:00',1.54),('11288','2013-11-05','12:45:00',1.2),('11288','2013-11-05','12:50:00',1.22),('11288','2013-11-05','12:55:00',1.51),('11288','2013-11-05','13:00:00',1.57),('11288','2013-11-05','13:05:00',1.31),('11288','2013-11-05','13:10:00',1.41),('11288','2013-11-05','13:15:00',1.03),('11288','2013-11-05','13:20:00',1.1),('11288','2013-11-05','13:25:00',1.48),('11288','2013-11-05','13:30:00',2.06),('11288','2013-11-05','13:35:00',3.36),('11288','2013-11-05','13:40:00',3.72),('11288','2013-11-05','13:45:00',3.31),('11288','2013-11-05','13:50:00',1.87),('11288','2013-11-05','13:55:00',3.17),('11288','2013-11-05','14:00:00',2.52),('11288','2013-11-05','14:05:00',3.22),('11288','2013-11-05','14:10:00',3.02),('11288','2013-11-05','14:15:00',1.07),('11288','2013-11-05','14:20:00',1.76),('11288','2013-11-05','14:25:00',2.63),('11288','2013-11-05','14:30:00',2.77),('11288','2013-11-05','14:35:00',2.66),('11288','2013-11-05','14:40:00',2.5),('11288','2013-11-05','14:45:00',2.43),('11288','2013-11-05','15:30:00',1.23),('11288','2013-11-05','15:35:00',1.18),('11288','2013-11-04','08:00:00',1.02),('11288','2013-11-04','08:05:00',1.12),('11288','2013-11-04','08:10:00',1.18),('11288','2013-11-04','08:15:00',1.34),('11288','2013-11-04','08:20:00',1.42),('11288','2013-11-04','08:25:00',1.43),('11288','2013-11-04','08:30:00',1.36),('11288','2013-11-04','08:35:00',1.59),('11288','2013-11-04','08:40:00',1.24),('11288','2013-11-04','09:05:00',1.02),('11288','2013-11-04','09:10:00',2.18),('11288','2013-11-04','09:15:00',2.77),('11288','2013-11-04','09:20:00',2.79),('11288','2013-11-04','09:25:00',3.4),('11288','2013-11-04','09:30:00',1.57),('11288','2013-11-04','10:00:00',2.44),('11288','2013-11-04','10:05:00',2.97),('11288','2013-11-04','10:10:00',3.02),('11288','2013-11-04','10:15:00',3.75),('11288','2013-11-04','10:20:00',3.81),('11288','2013-11-04','10:25:00',4.35),('11288','2013-11-04','10:30:00',4.24),('11288','2013-11-04','10:35:00',4.1),('11288','2013-11-04','10:40:00',4.46),('11288','2013-11-04','10:45:00',2.97),('11288','2013-11-04','10:50:00',3.17),('11288','2013-11-04','10:55:00',4.08),('11288','2013-11-04','11:00:00',4.08),('11288','2013-11-04','11:05:00',4.19),('11288','2013-11-04','11:10:00',2.56),('11288','2013-11-04','11:15:00',3.15),('11288','2013-11-04','11:20:00',2.73),('11288','2013-11-04','11:25:00',2.48),('11288','2013-11-04','11:30:00',3.96),('11288','2013-11-04','11:35:00',4.06),('11288','2013-11-04','11:40:00',3.55),('11288','2013-11-04','11:45:00',4.22),('11288','2013-11-04','11:50:00',5.49),('11288','2013-11-04','11:55:00',4.89),('11288','2013-11-04','12:00:00',4.86),('11288','2013-11-04','12:05:00',4.5),('11288','2013-11-04','12:10:00',4.45),('11288','2013-11-04','12:15:00',4.39),('11288','2013-11-04','12:20:00',4.37),('11288','2013-11-04','12:25:00',4.32),('11288','2013-11-04','12:30:00',4.32),('11288','2013-11-04','12:35:00',4.35),('11288','2013-11-04','12:40:00',4.28),('11288','2013-11-04','12:45:00',4.22),('11288','2013-11-04','12:50:00',4.08),('11288','2013-11-04','12:55:00',4),('11288','2013-11-04','13:00:00',4.05),('11288','2013-11-04','13:05:00',3.99),('11288','2013-11-04','13:10:00',3.93),('11288','2013-11-04','13:15:00',3.52),('11288','2013-11-04','13:20:00',3.21),('11288','2013-11-04','13:25:00',3.8),('11288','2013-11-04','13:30:00',3.74),('11288','2013-11-04','13:35:00',3.71),('11288','2013-11-04','13:40:00',2.96),('11288','2013-11-04','13:45:00',3.82),('11288','2013-11-04','13:50:00',3.57),('11288','2013-11-04','13:55:00',2.18),('11288','2013-11-04','14:00:00',1.88),('11288','2013-11-04','14:05:00',2.92),('11288','2013-11-04','14:10:00',3.38),('11288','2013-11-04','14:15:00',3.24),('11288','2013-11-04','14:20:00',3.26),('11288','2013-11-04','14:25:00',1.68),('11288','2013-11-04','14:30:00',2.17),('11288','2013-11-04','14:35:00',3.01),('11288','2013-11-04','14:40:00',2.6),('11288','2013-11-04','14:45:00',2.48),('11288','2013-11-04','14:50:00',2.35),('11288','2013-11-04','14:55:00',1.8),('11288','2013-11-04','15:00:00',1.9),('11288','2013-11-04','15:05:00',1.06),('11288','2013-11-04','15:10:00',1.28),('11288','2013-11-04','15:15:00',1.35),('11288','2013-11-04','15:20:00',1.45),('11288','2013-11-04','15:25:00',1.47),('11288','2013-11-04','15:30:00',1.34);
INSERT INTO `solarlogmod` VALUES ('11288','2013-11-04','15:35:00',1.33),('11288','2013-11-04','15:40:00',1.25),('11288','2013-11-04','15:45:00',1.33),('11288','2013-11-04','15:50:00',1.04),('11288','2013-11-03','07:55:00',1.02),('11288','2013-11-03','08:20:00',1.08),('11288','2013-11-03','08:35:00',1.61),('11288','2013-11-03','08:45:00',1.13),('11288','2013-11-03','08:50:00',1.88),('11288','2013-11-03','08:55:00',1.23),('11288','2013-11-03','09:00:00',1.06),('11288','2013-11-03','09:05:00',1.04),('11288','2013-11-03','09:35:00',1.1),('11288','2013-11-03','09:40:00',3.32),('11288','2013-11-03','09:45:00',2.19),('11288','2013-11-03','09:50:00',1.49),('11288','2013-11-03','10:05:00',1.69),('11288','2013-11-03','10:10:00',1.67),('11288','2013-11-03','10:15:00',1.26),('11288','2013-11-03','10:20:00',2.95),('11288','2013-11-03','10:25:00',1.62),('11288','2013-11-03','10:30:00',3.34),('11288','2013-11-03','10:35:00',1.81),('11288','2013-11-03','10:55:00',1.04),('11288','2013-11-03','11:10:00',1.24),('11288','2013-11-03','11:15:00',1.69),('11288','2013-11-03','11:20:00',2.68),('11288','2013-11-03','11:25:00',1.58),('11288','2013-11-03','11:30:00',3.97),('11288','2013-11-03','11:35:00',3.57),('11288','2013-11-03','11:40:00',4.71),('11288','2013-11-03','11:45:00',4.82),('11288','2013-11-03','11:50:00',4.97),('11288','2013-11-03','11:55:00',3.81),('11288','2013-11-03','12:00:00',4.52),('11288','2013-11-03','12:05:00',4.67),('11288','2013-11-03','12:10:00',4.12),('11288','2013-11-03','12:15:00',2.75),('11288','2013-11-03','12:20:00',1.29),('11288','2013-11-03','12:25:00',2.25),('11288','2013-11-03','12:30:00',1.42),('11288','2013-11-03','12:35:00',1.98),('11288','2013-11-03','12:40:00',2.15),('11288','2013-11-03','12:45:00',1.78),('11288','2013-11-03','12:50:00',1.78),('11288','2013-11-03','12:55:00',1.43),('11288','2013-11-03','13:00:00',1.32),('11288','2013-11-03','13:05:00',1.48),('11288','2013-11-03','13:10:00',1.61),('11288','2013-11-03','13:15:00',1.42),('11288','2013-11-03','13:20:00',1.61),('11288','2013-11-03','13:25:00',1.74),('11288','2013-11-03','13:30:00',1.68),('11288','2013-11-03','13:35:00',2.14),('11288','2013-11-03','13:40:00',2.31),('11288','2013-11-03','13:45:00',3.47),('11288','2013-11-03','13:50:00',1.54),('11288','2013-11-03','13:55:00',2.1),('11288','2013-11-03','14:00:00',2.45),('11288','2013-11-03','14:05:00',3.15),('11288','2013-11-03','14:10:00',3.61),('11288','2013-11-03','14:15:00',3.18),('11288','2013-11-03','14:20:00',2.63),('11288','2013-11-03','14:25:00',2.69),('11288','2013-11-03','14:30:00',1.55),('11288','2013-11-03','14:35:00',1.9),('11288','2013-11-03','14:40:00',2.65),('11288','2013-11-03','14:45:00',2.29),('11288','2013-11-03','14:50:00',1.71),('11288','2013-11-03','14:55:00',1.21),('11288','2013-11-03','15:05:00',1.12),('11288','2013-11-02','08:00:00',1.02),('11288','2013-11-02','08:05:00',1.06),('11288','2013-11-02','08:10:00',1.25),('11288','2013-11-02','08:15:00',1.34),('11288','2013-11-02','08:20:00',1.42),('11288','2013-11-02','08:25:00',1.46),('11288','2013-11-02','08:30:00',1.58),('11288','2013-11-02','08:35:00',1.66),('11288','2013-11-02','08:40:00',1.77),('11288','2013-11-02','08:45:00',1.84),('11288','2013-11-02','08:50:00',1.94),('11288','2013-11-02','08:55:00',2.1),('11288','2013-11-02','09:00:00',2.21),('11288','2013-11-02','09:05:00',2.5),('11288','2013-11-02','09:10:00',2.47),('11288','2013-11-02','09:15:00',2.44),('11288','2013-11-02','09:20:00',1.92),('11288','2013-11-02','09:25:00',2.71),('11288','2013-11-02','09:30:00',2.83),('11288','2013-11-02','09:35:00',2.54),('11288','2013-11-02','09:40:00',2.96),('11288','2013-11-02','09:45:00',3.19),('11288','2013-11-02','09:50:00',3.37),('11288','2013-11-02','09:55:00',2.94),('11288','2013-11-02','10:00:00',3.07),('11288','2013-11-02','10:05:00',3.38),('11288','2013-11-02','10:10:00',2.24),('11288','2013-11-02','10:15:00',2.1),('11288','2013-11-02','10:20:00',1.4),('11288','2013-11-02','10:25:00',1.12),('11288','2013-11-02','10:35:00',1.12),('11288','2013-11-02','10:40:00',1.26),('11288','2013-11-02','10:45:00',1.29),('11288','2013-11-02','10:50:00',1.21),('11288','2013-11-02','10:55:00',1.77),('11288','2013-11-02','11:00:00',2.19),('11288','2013-11-02','11:05:00',2.37),('11288','2013-11-02','11:10:00',1.93),('11288','2013-11-02','11:15:00',1.34),('11288','2013-11-02','11:20:00',1),('11288','2013-11-02','11:25:00',1.19),('11288','2013-11-02','11:30:00',1.26),('11288','2013-11-02','11:35:00',1.33),('11288','2013-11-02','11:40:00',1.58),('11288','2013-11-02','11:45:00',1.66),('11288','2013-11-02','11:50:00',2.35),('11288','2013-11-02','11:55:00',3.47),('11288','2013-11-02','12:00:00',4.9),('11288','2013-11-02','12:05:00',4.96),('11288','2013-11-02','12:10:00',4.52),('11288','2013-11-02','12:15:00',3.81),('11288','2013-11-02','12:20:00',3.99),('11288','2013-11-02','12:25:00',4.65),('11288','2013-11-02','12:30:00',5.27),('11288','2013-11-02','12:35:00',4.24),('11288','2013-11-02','12:40:00',4.32),('11288','2013-11-02','12:45:00',3.1),('11288','2013-11-02','12:50:00',4.29),('11288','2013-11-02','12:55:00',4.69),('11288','2013-11-02','13:00:00',3.46),('11288','2013-11-02','13:05:00',4.95),('11288','2013-11-02','13:10:00',4.65),('11288','2013-11-02','13:15:00',2.44),('11288','2013-11-02','13:20:00',1.68),('11288','2013-11-02','13:25:00',1.58),('11288','2013-11-02','13:30:00',2.85),('11288','2013-11-02','13:35:00',4.01),('11288','2013-11-02','13:40:00',3.59),('11288','2013-11-02','13:45:00',4.17),('11288','2013-11-02','13:50:00',3.99),('11288','2013-11-02','13:55:00',4.04),('11288','2013-11-02','14:00:00',3.76),('11288','2013-11-02','14:05:00',3.29),('11288','2013-11-02','14:10:00',3.01),('11288','2013-11-02','14:15:00',2.93),('11288','2013-11-02','14:20:00',2.8),('11288','2013-11-02','14:25:00',2.7),('11288','2013-11-02','14:30:00',2.6),('11288','2013-11-02','14:35:00',2.48),('11288','2013-11-02','14:40:00',2.37),('11288','2013-11-02','14:45:00',2.25),('11288','2013-11-02','14:50:00',2.12),('11288','2013-11-02','14:55:00',1.96),('11288','2013-11-02','15:00:00',1.93),('11288','2013-11-02','15:05:00',1.36),('11288','2013-11-02','15:10:00',1.56),('11288','2013-11-02','15:15:00',1.11),('11288','2013-11-02','15:45:00',1),('11288','2013-11-02','15:50:00',1.06),('11288','2013-11-01','08:15:00',1.13),('11288','2013-11-01','08:20:00',1.25),('11288','2013-11-01','08:25:00',1.32),('11288','2013-11-01','08:30:00',1.51),('11288','2013-11-01','08:35:00',1.66),('11288','2013-11-01','08:40:00',1.82),('11288','2013-11-01','08:45:00',1.76),('11288','2013-11-01','08:50:00',1.81),('11288','2013-11-01','08:55:00',1.92),('11288','2013-11-01','09:00:00',2),('11288','2013-11-01','09:05:00',2.25),('11288','2013-11-01','09:10:00',2.34),('11288','2013-11-01','09:15:00',2.47),('11288','2013-11-01','09:20:00',2.58),('11288','2013-11-01','09:25:00',2.7),('11288','2013-11-01','09:30:00',2.82),('11288','2013-11-01','09:35:00',2.81),('11288','2013-11-01','09:40:00',2.9),('11288','2013-11-01','09:45:00',3.07),('11288','2013-11-01','09:50:00',3.16),('11288','2013-11-01','09:55:00',3.24),('11288','2013-11-01','10:00:00',3.32),('11288','2013-11-01','10:05:00',3.36),('11288','2013-11-01','10:10:00',3.43),('11288','2013-11-01','10:15:00',3.51),('11288','2013-11-01','10:20:00',3.6),('11288','2013-11-01','10:25:00',3.67),('11288','2013-11-01','10:30:00',3.59),('11288','2013-11-01','10:35:00',3.63),('11288','2013-11-01','10:40:00',3.72),('11288','2013-11-01','10:45:00',3.67),('11288','2013-11-01','10:50:00',3.68),('11288','2013-11-01','10:55:00',3.81),('11288','2013-11-01','11:00:00',3.88),('11288','2013-11-01','11:05:00',3.5),('11288','2013-11-01','11:10:00',3.11),('11288','2013-11-01','11:15:00',3.5),('11288','2013-11-01','11:20:00',4.05),('11288','2013-11-01','11:25:00',4.3),('11288','2013-11-01','11:30:00',4.33),('11288','2013-11-01','11:35:00',4.16),('11288','2013-11-01','11:40:00',3.61),('11288','2013-11-01','11:45:00',4.01),('11288','2013-11-01','11:50:00',4.32),('11288','2013-11-01','11:55:00',4.33),('11288','2013-11-01','12:00:00',4.22),('11288','2013-11-01','12:05:00',4.15),('11288','2013-11-01','12:10:00',3.78),('11288','2013-11-01','12:15:00',3.44),('11288','2013-11-01','12:20:00',3.5),('11288','2013-11-01','12:25:00',3.85),('11288','2013-11-01','12:30:00',2.09),('11288','2013-11-01','12:35:00',1.24),('11288','2013-11-01','12:40:00',1.05),('11288','2013-11-01','13:00:00',1.05),('11288','2013-11-01','13:05:00',1.19),('11288','2013-11-01','13:10:00',1.8),('11288','2013-11-01','13:15:00',1.98),('11288','2013-11-01','13:20:00',1.87),('11288','2013-11-01','13:25:00',1.69),('11288','2013-11-01','13:30:00',2.09),('11288','2013-11-01','13:35:00',2),('11288','2013-11-01','13:40:00',1.68),('11288','2013-11-01','13:45:00',1.36),('11288','2013-11-01','13:50:00',1.15),('11288','2013-11-01','13:55:00',1.35),('11288','2013-11-01','14:00:00',1.17),('11288','2013-11-01','14:05:00',1.2),('11288','2013-11-01','14:10:00',1.23),('11288','2013-11-01','14:15:00',1.28),('11288','2013-11-01','14:20:00',1.15),('11288','2013-10-31','08:10:00',1.22),('11288','2013-10-31','08:15:00',1.23),('11288','2013-10-31','08:20:00',1.26),('11288','2013-10-31','08:25:00',1.43),('11288','2013-10-31','08:30:00',1.5),('11288','2013-10-31','08:35:00',1.8),('11288','2013-10-31','08:40:00',2.09),('11288','2013-10-31','08:45:00',2.04),('11288','2013-10-31','08:50:00',2.17),('11288','2013-10-31','08:55:00',2.04),('11288','2013-10-31','09:00:00',2),('11288','2013-10-31','09:05:00',1.7),('11288','2013-10-31','09:10:00',1.06),('11288','2013-10-31','09:15:00',1.6),('11288','2013-10-31','09:20:00',1.91),('11288','2013-10-31','09:25:00',2.11),('11288','2013-10-31','09:30:00',2.33),('11288','2013-10-31','09:35:00',2.48),('11288','2013-10-31','09:40:00',2.32),('11288','2013-10-31','09:45:00',2.44),('11288','2013-10-31','09:50:00',2.43),('11288','2013-10-31','09:55:00',2.59),('11288','2013-10-31','10:00:00',2.68),('11288','2013-10-31','10:05:00',2.47),('11288','2013-10-31','10:10:00',2.39),('11288','2013-10-31','10:15:00',1.99),('11288','2013-10-31','10:20:00',2.24),('11288','2013-10-31','10:25:00',2.37),('11288','2013-10-31','10:30:00',2.48),('11288','2013-10-31','10:35:00',2.78),('11288','2013-10-31','10:40:00',2.67),('11288','2013-10-31','10:45:00',2.49),('11288','2013-10-31','10:50:00',2.69),('11288','2013-10-31','10:55:00',2.96),('11288','2013-10-31','11:00:00',3.53),('11288','2013-10-31','11:05:00',4.04),('11288','2013-10-31','11:10:00',3.86),('11288','2013-10-31','11:15:00',3.95),('11288','2013-10-31','11:20:00',3.78),('11288','2013-10-31','11:25:00',3.46),('11288','2013-10-31','11:30:00',3.84),('11288','2013-10-31','11:35:00',3.68),('11288','2013-10-31','11:40:00',4.11),('11288','2013-10-31','11:45:00',4.28),('11288','2013-10-31','11:50:00',4.17),('11288','2013-10-31','11:55:00',4.13),('11288','2013-10-31','12:00:00',4.04),('11288','2013-10-31','12:05:00',3.93),('11288','2013-10-31','12:10:00',4.07),('11288','2013-10-31','12:15:00',3.97),('11288','2013-10-31','12:20:00',3.94),('11288','2013-10-31','12:25:00',4),('11288','2013-10-31','12:30:00',3.88),('11288','2013-10-31','12:35:00',3.75),('11288','2013-10-31','12:40:00',3.87),('11288','2013-10-31','12:45:00',4),('11288','2013-10-31','12:50:00',4.01),('11288','2013-10-31','12:55:00',4.05),('11288','2013-10-31','13:00:00',3.97),('11288','2013-10-31','13:05:00',3.89),('11288','2013-10-31','13:10:00',3.77),('11288','2013-10-31','13:15:00',3.67),('11288','2013-10-31','13:20:00',3.65),('11288','2013-10-31','13:25:00',3.55),('11288','2013-10-31','13:30:00',3.47),('11288','2013-10-31','13:35:00',3.33),('11288','2013-10-31','13:40:00',3.1),('11288','2013-10-31','13:45:00',3.02),('11288','2013-10-31','13:50:00',2.19),('11288','2013-10-31','13:55:00',2.34),('11288','2013-10-31','14:00:00',2.98),('11288','2013-10-31','14:05:00',2.9),('11288','2013-10-31','14:10:00',2.64),('11288','2013-10-31','14:15:00',1.68),('11288','2013-10-31','14:25:00',1.68),('11288','2013-10-31','14:45:00',1.06),('11288','2013-10-31','14:50:00',1.02),('11288','2013-10-31','14:55:00',1.39),('11288','2013-10-31','15:00:00',1.4),('11288','2013-10-31','15:05:00',1.35),('11288','2013-10-31','15:10:00',1.28),('11288','2013-10-31','15:15:00',1.2),('11288','2013-10-31','15:20:00',1.13),('11288','2013-10-31','15:25:00',1.04),('11288','2013-10-30','08:00:00',1),('11288','2013-10-30','08:05:00',1.16),('11288','2013-10-30','08:10:00',1.25),('11288','2013-10-30','08:15:00',1.33),('11288','2013-10-30','08:20:00',1.47),('11288','2013-10-30','08:25:00',1.57),('11288','2013-10-30','08:30:00',1.62),('11288','2013-10-30','08:35:00',1.7),('11288','2013-10-30','08:40:00',1.83),('11288','2013-10-30','08:45:00',1.93),('11288','2013-10-30','08:50:00',1.99),('11288','2013-10-30','08:55:00',1.98),('11288','2013-10-30','09:00:00',2.11),('11288','2013-10-30','09:05:00',2.28),('11288','2013-10-30','09:10:00',2.37),('11288','2013-10-30','09:15:00',2.49),('11288','2013-10-30','09:20:00',2.63),('11288','2013-10-30','09:25:00',2.78),('11288','2013-10-30','09:30:00',2.84),('11288','2013-10-30','09:35:00',2.93),('11288','2013-10-30','09:40:00',2.92),('11288','2013-10-30','09:45:00',3.02),('11288','2013-10-30','09:50:00',3.18),('11288','2013-10-30','09:55:00',2.94),('11288','2013-10-30','10:00:00',2.64),('11288','2013-10-30','10:05:00',2.83),('11288','2013-10-30','10:10:00',3.44),('11288','2013-10-30','10:15:00',3.44),('11288','2013-10-30','10:20:00',3.39),('11288','2013-10-30','10:25:00',3.49),('11288','2013-10-30','10:30:00',3.54),('11288','2013-10-30','10:35:00',3.43),('11288','2013-10-30','10:40:00',3.51),('11288','2013-10-30','10:45:00',3.53),('11288','2013-10-30','10:50:00',2.55),('11288','2013-10-30','10:55:00',3.03),('11288','2013-10-30','11:00:00',3.08),('11288','2013-10-30','11:05:00',4.12),('11288','2013-10-30','11:10:00',4.07),('11288','2013-10-30','11:15:00',3.64),('11288','2013-10-30','11:20:00',3.43),('11288','2013-10-30','11:25:00',1.9),('11288','2013-10-30','11:30:00',1.73),('11288','2013-10-30','11:35:00',1.55),('11288','2013-10-30','11:40:00',1.96),('11288','2013-10-30','11:45:00',2.1),('11288','2013-10-30','11:50:00',1.94),('11288','2013-10-30','11:55:00',1.48),('11288','2013-10-30','12:00:00',1.83),('11288','2013-10-30','12:05:00',1.89),('11288','2013-10-30','12:10:00',1.98),('11288','2013-10-30','12:15:00',3.59),('11288','2013-10-30','12:20:00',4.74),('11288','2013-10-30','12:25:00',2.96),('11288','2013-10-30','12:30:00',3),('11288','2013-10-30','12:35:00',1.77),('11288','2013-10-30','12:40:00',1.85),('11288','2013-10-30','12:45:00',1.72),('11288','2013-10-30','12:50:00',2.16),('11288','2013-10-30','12:55:00',3.99),('11288','2013-10-30','13:00:00',3.8),('11288','2013-10-30','13:05:00',4.44),('11288','2013-10-30','13:10:00',4.32),('11288','2013-10-30','13:15:00',4.55),('11288','2013-10-30','13:20:00',4.39),('11288','2013-10-30','13:25:00',4.28),('11288','2013-10-30','13:30:00',2.22),('11288','2013-10-30','13:35:00',3.58),('11288','2013-10-30','13:40:00',3.87),('11288','2013-10-30','13:45:00',2.97),('11288','2013-10-30','13:50:00',3.07),('11288','2013-10-30','13:55:00',3.76),('11288','2013-10-30','14:00:00',3.7),('11288','2013-10-30','14:05:00',2.08),('11288','2013-10-30','14:10:00',1.41),('11288','2013-10-30','14:20:00',1.99),('11288','2013-10-30','14:35:00',1.24),('11288','2013-10-30','14:40:00',2.1),('11288','2013-10-30','14:45:00',1.55),('11288','2013-10-30','15:05:00',1.1),('11288','2013-10-30','15:10:00',1.4),('11288','2013-10-30','15:15:00',1.6),('11288','2013-10-30','15:20:00',1.55),('11288','2013-10-30','15:25:00',1.26),('11288','2013-10-29','08:15:00',1.09),('11288','2013-10-29','08:20:00',1.26),('11288','2013-10-29','08:25:00',1.37),('11288','2013-10-29','08:30:00',1.49),('11288','2013-10-29','08:35:00',1.77),('11288','2013-10-29','08:40:00',2.09),('11288','2013-10-29','08:45:00',1.81),('11288','2013-10-29','08:50:00',2.01),('11288','2013-10-29','08:55:00',2.15),('11288','2013-10-29','09:00:00',2.28),('11288','2013-10-29','09:05:00',2.41),('11288','2013-10-29','09:10:00',2.38),('11288','2013-10-29','09:15:00',2.58),('11288','2013-10-29','09:20:00',2.69),('11288','2013-10-29','09:25:00',2.81),('11288','2013-10-29','09:30:00',2.9),('11288','2013-10-29','09:35:00',2.78),('11288','2013-10-29','09:40:00',1.82),('11288','2013-10-29','09:45:00',2.67),('11288','2013-10-29','09:50:00',2.98),('11288','2013-10-29','09:55:00',3.22),('11288','2013-10-29','10:00:00',3.53),('11288','2013-10-29','10:05:00',3.66),('11288','2013-10-29','10:10:00',3.64),('11288','2013-10-29','10:15:00',3.7),('11288','2013-10-29','10:20:00',2.23),('11288','2013-10-29','10:25:00',2.08),('11288','2013-10-29','10:30:00',1.59),('11288','2013-10-29','10:35:00',2.25),('11288','2013-10-29','10:40:00',2.35),('11288','2013-10-29','10:45:00',2.26),('11288','2013-10-29','10:50:00',2.99),('11288','2013-10-29','10:55:00',4.7),('11288','2013-10-29','11:00:00',4.58),('11288','2013-10-29','11:05:00',4.74),('11288','2013-10-29','11:10:00',4.56),('11288','2013-10-29','11:15:00',4.25),('11288','2013-10-29','11:20:00',4.03),('11288','2013-10-29','11:25:00',4.28),('11288','2013-10-29','11:30:00',4.3),('11288','2013-10-29','11:35:00',4.34),('11288','2013-10-29','11:40:00',4.28),('11288','2013-10-29','11:45:00',4.32),('11288','2013-10-29','11:50:00',4.23),('11288','2013-10-29','11:55:00',4.16),('11288','2013-10-29','12:00:00',4.1),('11288','2013-10-29','12:05:00',4.15),('11288','2013-10-29','12:10:00',4.12),('11288','2013-10-29','12:15:00',4.1),('11288','2013-10-29','12:20:00',4.07),('11288','2013-10-29','12:25:00',3.95),('11288','2013-10-29','12:30:00',3.97),('11288','2013-10-29','12:35:00',4),('11288','2013-10-29','12:40:00',3.87),('11288','2013-10-29','12:45:00',3.73),('11288','2013-10-29','12:50:00',3.81),('11288','2013-10-29','12:55:00',3.79),('11288','2013-10-29','13:00:00',3.79),('11288','2013-10-29','13:05:00',3.78),('11288','2013-10-29','13:10:00',3.75),('11288','2013-10-29','13:15:00',3.53),('11288','2013-10-29','13:20:00',3.58),('11288','2013-10-29','13:25:00',3.58),('11288','2013-10-29','13:30:00',3.52),('11288','2013-10-29','13:35:00',3.31),('11288','2013-10-29','13:40:00',3.09),('11288','2013-10-29','13:45:00',3.16),('11288','2013-10-29','13:50:00',3.14),('11288','2013-10-29','13:55:00',3.08),('11288','2013-10-29','14:00:00',2.99),('11288','2013-10-29','14:05:00',2.88),('11288','2013-10-29','14:10:00',2.81),('11288','2013-10-29','14:15:00',2.76),('11288','2013-10-29','14:20:00',2.66),('11288','2013-10-29','14:25:00',2.55),('11288','2013-10-29','14:30:00',2.46),('11288','2013-10-29','14:35:00',2.34),('11288','2013-10-29','14:40:00',2.26),('11288','2013-10-29','14:45:00',2.17),('11288','2013-10-29','14:50:00',2.05),('11288','2013-10-29','14:55:00',1.94),('11288','2013-10-29','15:00:00',1.85),('11288','2013-10-29','15:05:00',1.74),('11288','2013-10-29','15:10:00',1.67),('11288','2013-10-29','15:15:00',1.58),('11288','2013-10-29','15:20:00',1.44),('11288','2013-10-29','15:25:00',1.29),('11288','2013-10-29','15:30:00',1.16),('11288','2013-10-29','15:35:00',1.06),('11288','2014-04-17','07:55:00',1.05),('11288','2014-04-17','08:00:00',1.36),('11288','2014-04-17','08:05:00',1.46),('11288','2014-04-17','08:10:00',1.58),('11288','2014-04-17','08:15:00',1.67),('11288','2014-04-17','08:20:00',1.81),('11288','2014-04-17','08:25:00',2.01),('11288','2014-04-17','08:30:00',2.06),('11288','2014-04-17','08:35:00',2.23),('11288','2014-04-17','08:40:00',2.49),('11288','2014-04-17','08:45:00',2.65),('11288','2014-04-17','08:50:00',2.77),('11288','2014-04-17','08:55:00',2.83),('11288','2014-04-17','09:00:00',2.71),('11288','2014-04-17','09:05:00',3.14),('11288','2014-04-17','09:10:00',3.52),('11288','2014-04-17','09:15:00',3.7),('11288','2014-04-17','09:20:00',3.89),('11288','2014-04-17','09:25:00',3.96),('11288','2014-04-17','09:30:00',4.07),('11288','2014-04-17','09:35:00',4.32),('11288','2014-04-17','09:40:00',4.52),('11288','2014-04-17','09:45:00',4.66),('11288','2014-04-17','09:50:00',4.77),('11288','2014-04-17','09:55:00',4.89),('11288','2014-04-17','10:00:00',5.26),('11288','2014-04-17','10:05:00',5.75),('11288','2014-04-17','10:10:00',5.49),('11288','2014-04-17','10:15:00',4.21),('11288','2014-04-17','10:20:00',5.98),('11288','2014-04-17','10:25:00',6.2),('11288','2014-04-17','10:30:00',6.66),('11288','2014-04-17','10:35:00',7.03),('11288','2014-04-17','10:40:00',6.54),('11288','2014-04-17','10:45:00',6.15),('11288','2014-04-17','10:50:00',4.62),('11288','2014-04-17','10:55:00',4.08),('11288','2014-04-17','11:00:00',4.65),('11288','2014-04-17','11:05:00',5.09),('11288','2014-04-17','11:10:00',5.11),('11288','2014-04-17','11:15:00',3.82),('11288','2014-04-17','11:20:00',4.82),('11288','2014-04-17','11:25:00',6.65),('11288','2014-04-17','11:30:00',4.34),('11288','2014-04-17','11:35:00',3.81),('11288','2014-04-17','11:40:00',3.96),('11288','2014-04-17','11:45:00',6.74),('11288','2014-04-17','11:50:00',5.46),('11288','2014-04-17','11:55:00',4.01),('11288','2014-04-17','12:00:00',5.11),('11288','2014-04-17','12:05:00',5.16),('11288','2014-04-17','12:10:00',4.41),('11288','2014-04-17','12:15:00',3.94),('11288','2014-04-17','12:20:00',4.24),('11288','2014-04-17','12:25:00',4.84),('11288','2014-04-17','12:30:00',5.59),('11288','2014-04-17','12:35:00',6.06),('11288','2014-04-17','12:40:00',7.18),('11288','2014-04-17','12:45:00',6.9),('11288','2014-04-17','12:50:00',4.47),('11288','2014-04-17','12:55:00',1.74),('11288','2014-04-17','13:00:00',7.83),('11288','2014-04-17','13:05:00',7.76),('11288','2014-04-17','13:10:00',7.66),('11288','2014-04-17','13:15:00',7.75),('11288','2014-04-17','13:20:00',2.14),('11288','2014-04-17','13:25:00',7.42),('11288','2014-04-17','13:30:00',8.04),('11288','2014-04-17','13:35:00',3.83),('11288','2014-04-17','13:40:00',1.72),('11288','2014-04-17','13:45:00',1.65),('11288','2014-04-17','13:50:00',3.36),('11288','2014-04-17','13:55:00',3.7),('11288','2014-04-17','14:00:00',1.84),('11288','2014-04-17','14:05:00',2.03),('11288','2014-04-17','14:10:00',2.98),('11288','2014-04-17','14:15:00',7.85),('11288','2014-04-17','14:20:00',2.53),('11288','2014-04-17','14:25:00',3.15),('11288','2014-04-17','14:30:00',3.67),('11288','2014-04-17','14:35:00',3.78),('11288','2014-04-17','14:40:00',5.07),('11288','2014-04-17','14:45:00',2.85),('11288','2014-04-17','14:50:00',1.45),('11288','2014-04-17','14:55:00',1.23),('11288','2014-04-17','15:00:00',1.29),('11288','2014-04-17','15:05:00',1.42),('11288','2014-04-17','15:10:00',1.38),('11288','2014-04-17','15:15:00',1.36),('11288','2014-04-17','15:20:00',1.58),('11288','2014-04-17','15:25:00',2.11),('11288','2014-04-17','15:30:00',3.16),('11288','2014-04-17','15:35:00',4.6),('11288','2014-04-17','15:40:00',3.49),('11288','2014-04-17','15:45:00',2.5),('11288','2014-04-17','15:50:00',2.18),('11288','2014-04-17','15:55:00',2.42),('11288','2014-04-17','16:00:00',2.02),('11288','2014-04-17','16:05:00',1.84),('11288','2014-04-17','16:10:00',1.86),('11288','2014-04-17','16:15:00',1.9),('11288','2014-04-17','16:20:00',1.84),('11288','2014-04-17','16:25:00',2.05),('11288','2014-04-17','16:30:00',2.09),('11288','2014-04-17','16:35:00',1.9),('11288','2014-04-17','16:40:00',2.21),('11288','2014-04-17','16:45:00',3.14),('11288','2014-04-17','16:50:00',2.89),('11288','2014-04-17','16:55:00',2.16),('11288','2014-04-17','17:00:00',1.81),('11288','2014-04-17','17:05:00',1.54),('11288','2014-04-17','17:10:00',1.49),('11288','2014-04-17','17:15:00',1.73),('11288','2014-04-17','17:20:00',1.95),('11288','2014-04-17','17:25:00',1.7),('11288','2014-04-17','17:30:00',1.74),('11288','2014-04-17','17:35:00',1.82),('11288','2014-04-17','17:40:00',1.72),('11288','2014-04-17','17:45:00',1.6),('11288','2014-04-17','17:50:00',1.26),('11288','2014-04-17','17:55:00',1.22),('11288','2013-10-28','07:30:00',1.07),('11288','2013-10-28','07:35:00',1.09),('11288','2013-10-28','08:10:00',1.1),('11288','2013-10-28','08:15:00',1.03),('11288','2013-10-28','08:20:00',1.14),('11288','2013-10-28','08:35:00',1.07),('11288','2013-10-28','08:45:00',1.02),('11288','2013-10-28','08:50:00',1.49),('11288','2013-10-28','08:55:00',2.06),('11288','2013-10-28','09:00:00',2.43),('11288','2013-10-28','09:05:00',2.75),('11288','2013-10-28','09:10:00',2.84),('11288','2013-10-28','09:15:00',2.82),('11288','2013-10-28','09:20:00',2.91),('11288','2013-10-28','09:25:00',3),('11288','2013-10-28','09:30:00',3.02),('11288','2013-10-28','09:35:00',3.09),('11288','2013-10-28','09:40:00',3.66),('11288','2013-10-28','09:45:00',3.45),('11288','2013-10-28','09:50:00',3.64),('11288','2013-10-28','09:55:00',2.13),('11288','2013-10-28','10:00:00',1.34),('11288','2013-10-28','10:05:00',1.49),('11288','2013-10-28','10:10:00',1.44),('11288','2013-10-28','10:15:00',1.44),('11288','2013-10-28','10:20:00',1.5),('11288','2013-10-28','10:25:00',1.55),('11288','2013-10-28','10:30:00',1.59),('11288','2013-10-28','10:35:00',1.51),('11288','2013-10-28','10:40:00',1.12),('11288','2013-10-28','10:45:00',1.76),('11288','2013-10-28','10:50:00',4.21),('11288','2013-10-28','10:55:00',4.19),('11288','2013-10-28','11:00:00',4.18),('11288','2013-10-28','11:05:00',4.21),('11288','2013-10-28','11:10:00',4.25),('11288','2013-10-28','11:15:00',4.18),('11288','2013-10-28','11:20:00',4.21),('11288','2013-10-28','11:25:00',4.24),('11288','2013-10-28','11:30:00',4.26),('11288','2013-10-28','11:35:00',4.25),('11288','2013-10-28','11:40:00',4.27),('11288','2013-10-28','11:45:00',4.29),('11288','2013-10-28','11:50:00',4.24),('11288','2013-10-28','11:55:00',3.61),('11288','2013-10-28','12:00:00',2.81),('11288','2013-10-28','12:05:00',4.01),('11288','2013-10-28','12:10:00',4.5),('11288','2013-10-28','12:15:00',4.41),('11288','2013-10-28','12:20:00',3.62),('11288','2013-10-28','12:25:00',2.73),('11288','2013-10-28','12:30:00',4.78),('11288','2013-10-28','12:35:00',4.94),('11288','2013-10-28','12:40:00',4.4),('11288','2013-10-28','12:45:00',4.54),('11288','2013-10-28','12:50:00',4.39),('11288','2013-10-28','12:55:00',4.15),('11288','2013-10-28','13:00:00',4.05),('11288','2013-10-28','13:05:00',4),('11288','2013-10-28','13:10:00',3.92),('11288','2013-10-28','13:15:00',3.88),('11288','2013-10-28','13:20:00',3.38),('11288','2013-10-28','13:25:00',3.66),('11288','2013-10-28','13:30:00',3.68),('11288','2013-10-28','13:35:00',3.66),('11288','2013-10-28','13:40:00',3.63),('11288','2013-10-28','13:45:00',3.5),('11288','2013-10-28','13:50:00',3.44),('11288','2013-10-28','13:55:00',3.46),('11288','2013-10-28','14:00:00',3.06),('11288','2013-10-28','14:05:00',3.54),('11288','2013-10-28','14:10:00',3.37),('11288','2013-10-28','14:15:00',3.15),('11288','2013-10-28','14:20:00',3.12),('11288','2013-10-28','14:25:00',2.54),('11288','2013-10-28','14:30:00',1.56),('11288','2013-10-28','14:35:00',2.01),('11288','2013-10-28','14:40:00',1.35),('11288','2013-10-28','14:45:00',2.14),('11288','2013-10-28','14:50:00',2.25),('11288','2013-10-28','14:55:00',1.65),('11288','2013-10-28','15:00:00',1.83),('11288','2013-10-28','15:05:00',1.9),('11288','2013-10-28','15:10:00',1.76),('11288','2013-10-28','15:20:00',1.14),('11288','2013-10-28','15:25:00',1.26),('11288','2013-10-28','15:35:00',1.02),('11288','2013-10-28','15:40:00',1.31),('11288','2013-10-28','15:45:00',1.44),('11288','2013-10-28','15:50:00',1.09),('11288','2013-10-27','08:50:00',1.12),('11288','2013-10-27','08:55:00',1.21),('11288','2013-10-27','09:00:00',1.31),('11288','2013-10-27','09:25:00',1.02),('11288','2013-10-27','09:30:00',1.17),('11288','2013-10-27','09:35:00',1.34),('11288','2013-10-27','09:40:00',1.44),('11288','2013-10-27','09:45:00',1.5),('11288','2013-10-27','09:50:00',1.62),('11288','2013-10-27','09:55:00',1.78),('11288','2013-10-27','10:00:00',1.84),('11288','2013-10-27','10:05:00',1.88),('11288','2013-10-27','10:10:00',2.04),('11288','2013-10-27','10:15:00',2.16),('11288','2013-10-27','10:20:00',2.3),('11288','2013-10-27','10:25:00',2.24),('11288','2013-10-27','10:30:00',2.2),('11288','2013-10-27','10:35:00',2.23),('11288','2013-10-27','10:40:00',2.26),('11288','2013-10-27','10:45:00',2.49),('11288','2013-10-27','10:50:00',2.42),('11288','2013-10-27','10:55:00',2.19),('11288','2013-10-27','11:00:00',1.89),('11288','2013-10-27','11:05:00',1.66),('11288','2013-10-27','11:10:00',1.28),('11288','2013-10-27','11:15:00',1.06),('11288','2013-10-27','11:20:00',1.09),('11288','2013-10-27','11:25:00',1.41),('11288','2013-10-27','11:30:00',1.96),('11288','2013-10-27','11:35:00',2.59),('11288','2013-10-27','11:40:00',2.99),('11288','2013-10-27','11:45:00',3.17),('11288','2013-10-27','11:50:00',2.16),('11288','2013-10-27','11:55:00',1.89),('11288','2013-10-27','12:00:00',2.16),('11288','2013-10-27','12:05:00',2.09),('11288','2013-10-27','12:10:00',2.09),('11288','2013-10-27','12:15:00',2.88),('11288','2013-10-27','12:20:00',4.22),('11288','2013-10-27','12:25:00',3.71),('11288','2013-10-27','12:30:00',4.02),('11288','2013-10-27','12:35:00',5.25),('11288','2013-10-27','12:40:00',2.75),('11288','2013-10-27','12:45:00',3.77),('11288','2013-10-27','12:50:00',4.64),('11288','2013-10-27','12:55:00',3.31),('11288','2013-10-27','13:00:00',2.13),('11288','2013-10-27','13:05:00',2.15),('11288','2013-10-27','13:10:00',2.19),('11288','2013-10-27','13:15:00',1.68),('11288','2013-10-27','13:20:00',1.56),('11288','2013-10-27','13:25:00',2.93),('11288','2013-10-27','13:30:00',2.96),('11288','2013-10-27','13:35:00',2.72),('11288','2013-10-27','13:40:00',1.67),('11288','2013-10-27','13:45:00',1.27),('11288','2013-10-27','13:50:00',1.18),('11288','2013-10-27','13:55:00',1.56),('11288','2013-10-27','14:00:00',2.06),('11288','2013-10-27','14:05:00',1.55),('11288','2013-10-27','14:10:00',1.97),('11288','2013-10-27','14:15:00',1.91),('11288','2013-10-27','14:20:00',2.49),('11288','2013-10-27','14:25:00',2.12),('11288','2013-10-27','14:30:00',2.68),('11288','2013-10-27','14:35:00',2.17),('11288','2013-10-27','14:40:00',2.19),('11288','2013-10-27','14:45:00',1.63),('11288','2013-10-27','14:50:00',1.48),('11288','2013-10-27','14:55:00',1.9),('11288','2013-10-27','15:00:00',1.87),('11288','2013-10-27','15:05:00',1.86),('11288','2013-10-27','15:10:00',1.89),('11288','2013-10-27','15:15:00',1.78),('11288','2013-10-27','15:20:00',1.64),('11288','2013-10-27','15:25:00',1.3),('11288','2013-10-26','08:55:00',1.03),('11288','2013-10-26','09:00:00',1.17),('11288','2013-10-26','09:05:00',1.25),('11288','2013-10-26','09:10:00',1.35),('11288','2013-10-26','09:15:00',1.47),('11288','2013-10-26','09:20:00',1.53),('11288','2013-10-26','09:25:00',1.67),('11288','2013-10-26','09:30:00',1.78),('11288','2013-10-26','09:35:00',1.78),('11288','2013-10-26','09:40:00',1.96),('11288','2013-10-26','09:45:00',2.08),('11288','2013-10-26','09:50:00',2.14),('11288','2013-10-26','09:55:00',2.27),('11288','2013-10-26','10:00:00',2.39),('11288','2013-10-26','10:05:00',2.49),('11288','2013-10-26','10:10:00',2.57),('11288','2013-10-26','10:15:00',2.68),('11288','2013-10-26','10:20:00',2.77),('11288','2013-10-26','10:25:00',2.88),('11288','2013-10-26','10:30:00',2.98),('11288','2013-10-26','10:35:00',3.07),('11288','2013-10-26','10:40:00',3.17),('11288','2013-10-26','10:45:00',3.27),('11288','2013-10-26','10:50:00',3.37),('11288','2013-10-26','10:55:00',3.46),('11288','2013-10-26','11:00:00',3.53),('11288','2013-10-26','11:05:00',3.52),('11288','2013-10-26','11:10:00',3.42),('11288','2013-10-26','11:15:00',3.65),('11288','2013-10-26','11:20:00',3.75),('11288','2013-10-26','11:25:00',3.8),('11288','2013-10-26','11:30:00',3.82),('11288','2013-10-26','11:35:00',3.84),('11288','2013-10-26','11:40:00',3.83),('11288','2013-10-26','11:45:00',3.92),('11288','2013-10-26','11:50:00',4),('11288','2013-10-26','11:55:00',4.05),('11288','2013-10-26','12:00:00',3.99),('11288','2013-10-26','12:05:00',4.03),('11288','2013-10-26','12:10:00',4.12),('11288','2013-10-26','12:15:00',4),('11288','2013-10-26','12:20:00',3.8),('11288','2013-10-26','12:25:00',3.78),('11288','2013-10-26','12:30:00',4.09),('11288','2013-10-26','12:35:00',4.25),('11288','2013-10-26','12:40:00',4.11),('11288','2013-10-26','12:45:00',3.36),('11288','2013-10-26','12:50:00',4.08),('11288','2013-10-26','12:55:00',3.67),('11288','2013-10-26','13:00:00',4.07),('11288','2013-10-26','13:05:00',3.98),('11288','2013-10-26','13:10:00',4.13),('11288','2013-10-26','13:15:00',4.16),('11288','2013-10-26','13:20:00',4.05),('11288','2013-10-26','13:25:00',3.97),('11288','2013-10-26','13:30:00',4.12),('11288','2013-10-26','13:35:00',3.38),('11288','2013-10-26','13:40:00',4.12),('11288','2013-10-26','13:45:00',3.72),('11288','2013-10-26','13:50:00',3.86),('11288','2013-10-26','13:55:00',3.72),('11288','2013-10-26','14:00:00',3.55),('11288','2013-10-26','14:05:00',3.06),('11288','2013-10-26','14:10:00',2.74),('11288','2013-10-26','14:15:00',1.72),('11288','2013-10-26','14:20:00',3.3),('11288','2013-10-26','14:25:00',3.18),('11288','2013-10-26','14:30:00',3.07),('11288','2013-10-26','14:35:00',3.06),('11288','2013-10-26','14:40:00',2.89),('11288','2013-10-26','14:45:00',1.86),('11288','2013-10-26','14:50:00',1.92),('11288','2013-10-26','14:55:00',3.15),('11288','2013-10-26','15:00:00',3.03),('11288','2013-10-26','15:05:00',2.93),('11288','2013-10-26','15:10:00',2.97),('11288','2013-10-26','15:15:00',2.74),('11288','2013-10-26','15:20:00',2.7),('11288','2013-10-26','15:25:00',2.79),('11288','2013-10-26','15:30:00',2.7),('11288','2013-10-26','15:35:00',2.67),('11288','2013-10-26','15:40:00',2.4),('11288','2013-10-26','15:45:00',2.31),('11288','2013-10-26','15:50:00',2.11),('11288','2013-10-26','15:55:00',1.99),('11288','2013-10-26','16:00:00',1.89),('11288','2013-10-26','16:05:00',1.8),('11288','2013-10-26','16:10:00',1.66),('11288','2013-10-26','16:15:00',1.58),('11288','2013-10-26','16:20:00',1.49),('11288','2013-10-26','16:25:00',1.33),('11288','2013-10-26','16:30:00',1.27),('11288','2013-10-26','16:35:00',1.14),('11288','2013-10-26','16:40:00',1.07),('11288','2013-10-25','08:55:00',1.01),('11288','2013-10-25','09:00:00',1.18),('11288','2013-10-25','09:05:00',1.27),('11288','2013-10-25','09:10:00',1.4),('11288','2013-10-25','09:15:00',1.53),('11288','2013-10-25','09:20:00',1.6),('11288','2013-10-25','09:25:00',1.74),('11288','2013-10-25','09:30:00',1.85),('11288','2013-10-25','09:35:00',1.88),('11288','2013-10-25','09:40:00',1.93),('11288','2013-10-25','09:45:00',2.14),('11288','2013-10-25','09:50:00',2.22),('11288','2013-10-25','09:55:00',2.29),('11288','2013-10-25','10:00:00',2.43),('11288','2013-10-25','10:05:00',2.59),('11288','2013-10-25','10:10:00',2.67),('11288','2013-10-25','10:15:00',2.72),('11288','2013-10-25','10:20:00',2.76),('11288','2013-10-25','10:25:00',2.98),('11288','2013-10-25','10:30:00',3.08),('11288','2013-10-25','10:35:00',3.18),('11288','2013-10-25','10:40:00',3.26),('11288','2013-10-25','10:45:00',3.34),('11288','2013-10-25','10:50:00',3.37),('11288','2013-10-25','10:55:00',3.48),('11288','2013-10-25','11:00:00',3.5),('11288','2013-10-25','11:05:00',3.54),('11288','2013-10-25','11:10:00',3.47),('11288','2013-10-25','11:15:00',3.64),('11288','2013-10-25','11:20:00',3.72),('11288','2013-10-25','11:25:00',3.82),('11288','2013-10-25','11:30:00',3.89),('11288','2013-10-25','11:35:00',3.95),('11288','2013-10-25','11:40:00',3.79),('11288','2013-10-25','11:45:00',4),('11288','2013-10-25','11:50:00',4.15),('11288','2013-10-25','11:55:00',4.18),('11288','2013-10-25','12:00:00',4.26),('11288','2013-10-25','12:05:00',4.3),('11288','2013-10-25','12:10:00',4.29),('11288','2013-10-25','12:15:00',4.29),('11288','2013-10-25','12:20:00',4.33),('11288','2013-10-25','12:25:00',4.34),('11288','2013-10-25','12:30:00',4.3),('11288','2013-10-25','12:35:00',4.3),('11288','2013-10-25','12:40:00',4.38),('11288','2013-10-25','12:45:00',4.4),('11288','2013-10-25','12:50:00',4.34),('11288','2013-10-25','12:55:00',4.34),('11288','2013-10-25','13:00:00',4.32),('11288','2013-10-25','13:05:00',4.32),('11288','2013-10-25','13:10:00',4.31),('11288','2013-10-25','13:15:00',4.29),('11288','2013-10-25','13:20:00',4.27),('11288','2013-10-25','13:25:00',4.25),('11288','2013-10-25','13:30:00',4.19),('11288','2013-10-25','13:35:00',4.13),('11288','2013-10-25','13:40:00',4.07),('11288','2013-10-25','13:45:00',4.08),('11288','2013-10-25','13:50:00',4.06),('11288','2013-10-25','13:55:00',4.01),('11288','2013-10-25','14:00:00',3.95),('11288','2013-10-25','14:05:00',3.92),('11288','2013-10-25','14:10:00',3.85),('11288','2013-10-25','14:15:00',3.82),('11288','2013-10-25','14:20:00',3.8),('11288','2013-10-25','14:25:00',3.72),('11288','2013-10-25','14:30:00',3.69),('11288','2013-10-25','14:35:00',3.61),('11288','2013-10-25','14:40:00',3.5),('11288','2013-10-25','14:45:00',3.47),('11288','2013-10-25','14:50:00',3.39),('11288','2013-10-25','14:55:00',3.33),('11288','2013-10-25','15:00:00',3.18),('11288','2013-10-25','15:05:00',3.13),('11288','2013-10-25','15:10:00',3.06),('11288','2013-10-25','15:15:00',2.96),('11288','2013-10-25','15:20:00',2.86),('11288','2013-10-25','15:25:00',2.77),('11288','2013-10-25','15:30:00',2.66),('11288','2013-10-25','15:35:00',2.52),('11288','2013-10-25','15:40:00',2.51),('11288','2013-10-25','15:45:00',2.36),('11288','2013-10-25','15:50:00',2.27),('11288','2013-10-25','15:55:00',2.17),('11288','2013-10-25','16:00:00',2.02),('11288','2013-10-25','16:05:00',1.95),('11288','2013-10-25','16:10:00',1.86),('11288','2013-10-25','16:15:00',1.77),('11288','2013-10-25','16:20:00',1.64),('11288','2013-10-25','16:25:00',1.53),('11288','2013-10-25','16:30:00',1.43),('11288','2013-10-25','16:35:00',1.32),('11288','2013-10-25','16:40:00',1.21),('11288','2013-10-25','16:45:00',1.08),('11288','2013-10-25','16:50:00',1.02),('11288','2013-10-24','08:55:00',1.11),('11288','2013-10-24','09:00:00',1.32),('11288','2013-10-24','09:05:00',1.57),('11288','2013-10-24','09:10:00',1.68),('11288','2013-10-24','09:15:00',1.97),('11288','2013-10-24','09:20:00',1.62),('11288','2013-10-24','09:25:00',1.43),('11288','2013-10-24','09:30:00',1.56),('11288','2013-10-24','09:35:00',1.74),('11288','2013-10-24','09:40:00',1.84),('11288','2013-10-24','09:45:00',1.9),('11288','2013-10-24','09:50:00',1.89),('11288','2013-10-24','09:55:00',1.87),('11288','2013-10-24','10:00:00',1.82),('11288','2013-10-24','10:05:00',1.71),('11288','2013-10-24','10:10:00',1.55),('11288','2013-10-24','10:15:00',1.42),('11288','2013-10-24','10:20:00',1.99),('11288','2013-10-24','10:25:00',1.15),('11288','2013-10-24','10:30:00',1.36),('11288','2013-10-24','10:35:00',2.28),('11288','2013-10-24','10:40:00',1.73),('11288','2013-10-24','10:45:00',2.91),('11288','2013-10-24','10:50:00',2.53),('11288','2013-10-24','10:55:00',3.03),('11288','2013-10-24','11:00:00',4.22),('11288','2013-10-24','11:05:00',4.33),('11288','2013-10-24','11:10:00',3.33),('11288','2013-10-24','11:15:00',2.7),('11288','2013-10-24','11:20:00',2.81),('11288','2013-10-24','11:25:00',2.19),('11288','2013-10-24','11:30:00',1.91),('11288','2013-10-24','11:35:00',1.93),('11288','2013-10-24','11:40:00',1.83),('11288','2013-10-24','11:45:00',2.02),('11288','2013-10-24','11:50:00',2.71),('11288','2013-10-24','11:55:00',3.39),('11288','2013-10-24','12:00:00',2.88),('11288','2013-10-24','12:05:00',2.36),('11288','2013-10-24','12:10:00',2.25),('11288','2013-10-24','12:15:00',2.24),('11288','2013-10-24','12:20:00',2.34),('11288','2013-10-24','12:25:00',2.52),('11288','2013-10-24','12:30:00',2.66),('11288','2013-10-24','12:35:00',2.9),('11288','2013-10-24','12:40:00',3.5),('11288','2013-10-24','12:45:00',3.72),('11288','2013-10-24','12:50:00',3.18),('11288','2013-10-24','12:55:00',4.75),('11288','2013-10-24','13:00:00',5.08),('11288','2013-10-24','13:05:00',4.73),('11288','2013-10-24','13:10:00',3.76),('11288','2013-10-24','13:15:00',3.65),('11288','2013-10-24','13:20:00',3.36),('11288','2013-10-24','13:25:00',2.63),('11288','2013-10-24','13:30:00',2.25),('11288','2013-10-24','13:35:00',2.19),('11288','2013-10-24','13:40:00',2.22),('11288','2013-10-24','13:45:00',2.53),('11288','2013-10-24','13:50:00',2.91),('11288','2013-10-24','13:55:00',3.69),('11288','2013-10-24','14:00:00',3.4),('11288','2013-10-24','14:05:00',2.38),('11288','2013-10-24','14:10:00',2.25),('11288','2013-10-24','14:15:00',2.24),('11288','2013-10-24','14:20:00',2.43),('11288','2013-10-24','14:25:00',2.45),('11288','2013-10-24','14:30:00',2.54),('11288','2013-10-24','14:35:00',2.76),('11288','2013-10-24','14:40:00',3.06),('11288','2013-10-24','14:45:00',3.52),('11288','2013-10-24','14:50:00',2.21),('11288','2013-10-24','14:55:00',1.42),('11288','2013-10-24','15:00:00',1.48),('11288','2013-10-24','15:05:00',2.04),('11288','2013-10-24','15:10:00',2.74),('11288','2013-10-24','15:15:00',1.8),('11288','2013-10-24','15:20:00',1.95),('11288','2013-10-24','15:25:00',1.61),('11288','2013-10-24','15:30:00',2.1),('11288','2013-10-24','15:35:00',3.01),('11288','2013-10-24','15:40:00',2.64),('11288','2013-10-24','15:45:00',2.86),('11288','2013-10-24','15:50:00',1.67),('11288','2013-10-24','15:55:00',1.29),('11288','2013-10-24','16:00:00',1.24),('11288','2013-10-24','16:05:00',1.24),('11288','2013-10-24','16:10:00',1.21),('11288','2013-10-24','16:15:00',1.2),('11288','2013-10-24','16:20:00',1.12),('11288','2013-10-23','09:50:00',1.15),('11288','2013-10-23','09:55:00',1.57),('11288','2013-10-23','10:00:00',1.34),('11288','2013-10-23','10:05:00',1),('11288','2013-10-23','10:10:00',1.24),('11288','2013-10-23','10:15:00',1.49),('11288','2013-10-23','10:20:00',2.14),('11288','2013-10-23','10:25:00',2.19),('11288','2013-10-23','10:30:00',2.48),('11288','2013-10-23','10:35:00',2.33),('11288','2013-10-23','10:40:00',1.84),('11288','2013-10-23','10:45:00',2.17),('11288','2013-10-23','10:50:00',2.39),('11288','2013-10-23','10:55:00',2.29),('11288','2013-10-23','11:00:00',2.53),('11288','2013-10-23','11:05:00',3.55),('11288','2013-10-23','11:10:00',3.3),('11288','2013-10-23','11:15:00',2.62),('11288','2013-10-23','11:20:00',2.84),('11288','2013-10-23','11:25:00',3.51),('11288','2013-10-23','11:30:00',3.97),('11288','2013-10-23','11:35:00',3.92),('11288','2013-10-23','11:40:00',3.74),('11288','2013-10-23','11:45:00',3.64),('11288','2013-10-23','11:50:00',3.51),('11288','2013-10-23','11:55:00',4.02),('11288','2013-10-23','12:00:00',4.21),('11288','2013-10-23','12:05:00',3.65),('11288','2013-10-23','12:10:00',3.83),('11288','2013-10-23','12:15:00',3.9),('11288','2013-10-23','12:20:00',4.01),('11288','2013-10-23','12:25:00',4.08),('11288','2013-10-23','12:30:00',4.03),('11288','2013-10-23','12:35:00',4.28),('11288','2013-10-23','12:40:00',4.22),('11288','2013-10-23','12:45:00',4.08),('11288','2013-10-23','12:50:00',3.33),('11288','2013-10-23','12:55:00',3.45),('11288','2013-10-23','13:00:00',3.68),('11288','2013-10-23','13:05:00',3.74),('11288','2013-10-23','13:10:00',3.97),('11288','2013-10-23','13:15:00',3.84),('11288','2013-10-23','13:20:00',3.95),('11288','2013-10-23','13:25:00',4.07),('11288','2013-10-23','13:30:00',3.88),('11288','2013-10-23','13:35:00',3.92),('11288','2013-10-23','13:40:00',3.94),('11288','2013-10-23','13:45:00',3.9),('11288','2013-10-23','13:50:00',3.61),('11288','2013-10-23','13:55:00',3.17),('11288','2013-10-23','14:00:00',3.73),('11288','2013-10-23','14:05:00',3.97),('11288','2013-10-23','14:10:00',3.68),('11288','2013-10-23','14:15:00',3.34),('11288','2013-10-23','14:20:00',3.44),('11288','2013-10-23','14:25:00',3.38),('11288','2013-10-23','14:30:00',3.39),('11288','2013-10-23','14:35:00',3.32),('11288','2013-10-23','14:40:00',3.38),('11288','2013-10-23','14:45:00',3.37),('11288','2013-10-23','14:50:00',3.29),('11288','2013-10-23','14:55:00',3.42),('11288','2013-10-23','15:00:00',3.39),('11288','2013-10-23','15:05:00',3.25),('11288','2013-10-23','15:10:00',3.08),('11288','2013-10-23','15:15:00',2.99),('11288','2013-10-23','15:20:00',2.97),('11288','2013-10-23','15:25:00',2.89),('11288','2013-10-23','15:30:00',2.57),('11288','2013-10-23','15:35:00',2.4),('11288','2013-10-23','15:40:00',2.68),('11288','2013-10-23','15:45:00',2.66),('11288','2013-10-23','15:50:00',2.42),('11288','2013-10-23','15:55:00',1.93),('11288','2013-10-23','16:00:00',1.46),('11288','2013-10-23','16:05:00',1.26),('11288','2013-10-23','16:10:00',1.24),('11288','2013-10-23','16:15:00',1.32),('11288','2013-10-23','16:20:00',1.18),('11288','2013-10-23','16:25:00',1.22),('11288','2013-10-23','16:30:00',1.2),('11288','2013-10-23','16:35:00',1.39),('11288','2013-10-23','16:40:00',1.39),('11288','2013-10-23','16:45:00',1.2),('11288','2013-10-23','16:50:00',1),('11288','2013-10-22','08:55:00',1.15),('11288','2013-10-22','09:00:00',1.26),('11288','2013-10-22','09:05:00',1.35),('11288','2013-10-22','09:10:00',1.45),('11288','2013-10-22','09:15:00',1.54),('11288','2013-10-22','09:20:00',1.67),('11288','2013-10-22','09:25:00',1.79),('11288','2013-10-22','09:30:00',1.89),('11288','2013-10-22','09:35:00',1.98),('11288','2013-10-22','09:40:00',2.03),('11288','2013-10-22','09:45:00',2.07),('11288','2013-10-22','09:50:00',2.26),('11288','2013-10-22','09:55:00',2.38),('11288','2013-10-22','10:00:00',2.5),('11288','2013-10-22','10:05:00',2.58),('11288','2013-10-22','10:10:00',2.69),('11288','2013-10-22','10:15:00',2.79),('11288','2013-10-22','10:20:00',2.81),('11288','2013-10-22','10:25:00',2.96),('11288','2013-10-22','10:30:00',3.1),('11288','2013-10-22','10:35:00',3.21),('11288','2013-10-22','10:40:00',3.26),('11288','2013-10-22','10:45:00',3.23),('11288','2013-10-22','10:50:00',3.43),('11288','2013-10-22','10:55:00',3.52),('11288','2013-10-22','11:00:00',3.6),('11288','2013-10-22','11:05:00',3.62),('11288','2013-10-22','11:10:00',3.6),('11288','2013-10-22','11:15:00',3.62),('11288','2013-10-22','11:20:00',3.74),('11288','2013-10-22','11:25:00',3.78),('11288','2013-10-22','11:30:00',3.74),('11288','2013-10-22','11:35:00',3.8),('11288','2013-10-22','11:40:00',3.79),('11288','2013-10-22','11:45:00',3.92),('11288','2013-10-22','11:50:00',3.94),('11288','2013-10-22','11:55:00',4.02),('11288','2013-10-22','12:00:00',4.09),('11288','2013-10-22','12:05:00',4.09),('11288','2013-10-22','12:10:00',4.09),('11288','2013-10-22','12:15:00',4.09),('11288','2013-10-22','12:20:00',3.9),('11288','2013-10-22','12:25:00',4.07),('11288','2013-10-22','12:30:00',4.21),('11288','2013-10-22','12:35:00',4.26),('11288','2013-10-22','12:40:00',4.28),('11288','2013-10-22','12:45:00',4.24),('11288','2013-10-22','12:50:00',4.14),('11288','2013-10-22','12:55:00',4.15),('11288','2013-10-22','13:00:00',4.07),('11288','2013-10-22','13:05:00',4.07),('11288','2013-10-22','13:10:00',4.13),('11288','2013-10-22','13:15:00',4.18),('11288','2013-10-22','13:20:00',4.11),('11288','2013-10-22','13:25:00',4.17),('11288','2013-10-22','13:30:00',3.98),('11288','2013-10-22','13:35:00',4.01),('11288','2013-10-22','13:40:00',3.83),('11288','2013-10-22','13:45:00',3.68),('11288','2013-10-22','13:50:00',3.98),('11288','2013-10-22','13:55:00',3.99),('11288','2013-10-22','14:00:00',3.65),('11288','2013-10-22','14:05:00',2.98),('11288','2013-10-22','14:10:00',4.07),('11288','2013-10-22','14:15:00',4.23),('11288','2013-10-22','14:20:00',4.26),('11288','2013-10-22','14:25:00',4.45),('11288','2013-10-22','14:30:00',4.06),('11288','2013-10-22','14:35:00',4.04),('11288','2013-10-22','14:40:00',3.66),('11288','2013-10-22','14:45:00',3.64),('11288','2013-10-22','14:50:00',3.4),('11288','2013-10-22','14:55:00',3.32),('11288','2013-10-22','15:00:00',3.23),('11288','2013-10-22','15:05:00',3.07),('11288','2013-10-22','15:10:00',3.01),('11288','2013-10-22','15:15:00',2.97),('11288','2013-10-22','15:20:00',2.87),('11288','2013-10-22','15:25:00',2.68),('11288','2013-10-22','15:30:00',2.68),('11288','2013-10-22','15:35:00',2.75),('11288','2013-10-22','15:40:00',2.67),('11288','2013-10-22','15:45:00',2.31),('11288','2013-10-22','15:50:00',2.33),('11288','2013-10-22','15:55:00',2.13),('11288','2013-10-22','16:00:00',1.95),('11288','2013-10-22','16:05:00',1.79),('11288','2013-10-22','16:10:00',1.75),('11288','2013-10-22','16:15:00',1.69),('11288','2013-10-22','16:20:00',1.57),('11288','2013-10-22','16:25:00',1.47),('11288','2013-10-22','16:30:00',1.44),('11288','2013-10-22','16:35:00',1.35),('11288','2013-10-22','16:40:00',1.22),('11288','2013-10-22','16:45:00',1.13),('11288','2013-10-22','16:50:00',1.06),('11288','2013-10-21','08:55:00',1.01),('11288','2013-10-21','09:05:00',1.07),('11288','2013-10-21','09:10:00',1.38),('11288','2013-10-21','09:15:00',1.52),('11288','2013-10-21','09:20:00',1.9),('11288','2013-10-21','09:25:00',1.97),('11288','2013-10-21','09:30:00',1.84),('11288','2013-10-21','09:35:00',1.8),('11288','2013-10-21','09:40:00',2.02),('11288','2013-10-21','09:45:00',1.85),('11288','2013-10-21','09:50:00',2.09),('11288','2013-10-21','09:55:00',2.41),('11288','2013-10-21','10:00:00',2.35),('11288','2013-10-21','10:05:00',2.84),('11288','2013-10-21','10:10:00',2.81),('11288','2013-10-21','10:15:00',2.95),('11288','2013-10-21','10:20:00',2.83),('11288','2013-10-21','10:25:00',3.13),('11288','2013-10-21','10:30:00',3.14),('11288','2013-10-21','10:35:00',3.22),('11288','2013-10-21','10:40:00',3.18),('11288','2013-10-21','10:45:00',3.28),('11288','2013-10-21','10:50:00',3.51),('11288','2013-10-21','10:55:00',3.45),('11288','2013-10-21','11:00:00',3.74),('11288','2013-10-21','11:05:00',3.2),('11288','2013-10-21','11:10:00',3.44),('11288','2013-10-21','11:15:00',3.81),('11288','2013-10-21','11:20:00',3.89),('11288','2013-10-21','11:25:00',3.86),('11288','2013-10-21','11:30:00',4.01),('11288','2013-10-21','11:35:00',3.88),('11288','2013-10-21','11:40:00',3.86),('11288','2013-10-21','11:45:00',4.07),('11288','2013-10-21','11:50:00',4.24),('11288','2013-10-21','11:55:00',4.24),('11288','2013-10-21','12:00:00',4.33),('11288','2013-10-21','12:05:00',4.43),('11288','2013-10-21','12:10:00',4.45),('11288','2013-10-21','12:15:00',4.4),('11288','2013-10-21','12:20:00',4.4),('11288','2013-10-21','12:25:00',4.33),('11288','2013-10-21','12:30:00',4.27),('11288','2013-10-21','12:35:00',4.45),('11288','2013-10-21','12:40:00',4.49),('11288','2013-10-21','12:45:00',4.46),('11288','2013-10-21','12:50:00',4.39),('11288','2013-10-21','12:55:00',4.44),('11288','2013-10-21','13:00:00',4.38),('11288','2013-10-21','13:05:00',4.27),('11288','2013-10-21','13:10:00',4.25),('11288','2013-10-21','13:15:00',4.26),('11288','2013-10-21','13:20:00',4.21),('11288','2013-10-21','13:25:00',4.35),('11288','2013-10-21','13:30:00',4.36),('11288','2013-10-21','13:35:00',4.31),('11288','2013-10-21','13:40:00',4.26),('11288','2013-10-21','13:45:00',4.22),('11288','2013-10-21','13:50:00',4.06),('11288','2013-10-21','13:55:00',4),('11288','2013-10-21','14:00:00',4),('11288','2013-10-21','14:05:00',4.03),('11288','2013-10-21','14:10:00',3.97),('11288','2013-10-21','14:15:00',3.94),('11288','2013-10-21','14:20:00',3.9),('11288','2013-10-21','14:25:00',3.75),('11288','2013-10-21','14:30:00',3.75),('11288','2013-10-21','14:35:00',3.61),('11288','2013-10-21','14:40:00',3.44),('11288','2013-10-21','14:45:00',3.38),('11288','2013-10-21','14:50:00',3.28),('11288','2013-10-21','14:55:00',3.29),('11288','2013-10-21','15:00:00',3.27),('11288','2013-10-21','15:05:00',3.25),('11288','2013-10-21','15:10:00',3.16),('11288','2013-10-21','15:15:00',3.09),('11288','2013-10-21','15:20:00',3),('11288','2013-10-21','15:25:00',2.91),('11288','2013-10-21','15:30:00',2.76),('11288','2013-10-21','15:35:00',2.67),('11288','2013-10-21','15:40:00',2.59),('11288','2013-10-21','15:45:00',2.5),('11288','2013-10-21','15:50:00',2.41),('11288','2013-10-21','15:55:00',2.28),('11288','2013-10-21','16:00:00',2.09),('11288','2013-10-21','16:05:00',2.11),('11288','2013-10-21','16:10:00',2.03),('11288','2013-10-21','16:15:00',1.87),('11288','2013-10-21','16:20:00',1.74),('11288','2013-10-21','16:25:00',1.64),('11288','2013-10-21','16:30:00',1.54),('11288','2013-10-21','16:35:00',1.41),('11288','2013-10-21','16:40:00',1.27),('11288','2013-10-21','16:45:00',1.14),('11288','2013-10-21','16:50:00',1.11),('11288','2013-10-20','08:35:00',1.02),('11288','2013-10-20','08:40:00',1.02),('11288','2013-10-20','08:45:00',1.09),('11288','2013-10-20','08:50:00',1.11),('11288','2013-10-20','08:55:00',1.23),('11288','2013-10-20','09:00:00',1.24),('11288','2013-10-20','09:05:00',1.46),('11288','2013-10-20','09:10:00',1.59),('11288','2013-10-20','09:15:00',1.69),('11288','2013-10-20','09:20:00',1.86),('11288','2013-10-20','09:25:00',1.95),('11288','2013-10-20','09:30:00',2.04),('11288','2013-10-20','09:35:00',2.14),('11288','2013-10-20','09:40:00',2.28),('11288','2013-10-20','09:45:00',2.29),('11288','2013-10-20','09:50:00',2.46),('11288','2013-10-20','09:55:00',2.57),('11288','2013-10-20','10:00:00',2.65),('11288','2013-10-20','10:05:00',2.84),('11288','2013-10-20','10:10:00',2.93),('11288','2013-10-20','10:15:00',3),('11288','2013-10-20','10:20:00',3),('11288','2013-10-20','10:25:00',3.21),('11288','2013-10-20','10:30:00',3.33),('11288','2013-10-20','10:35:00',3.42),('11288','2013-10-20','10:40:00',3.49),('11288','2013-10-20','10:45:00',3.5),('11288','2013-10-20','10:50:00',3.53),('11288','2013-10-20','10:55:00',3.76),('11288','2013-10-20','11:00:00',3.78),('11288','2013-10-20','11:05:00',3.84),('11288','2013-10-20','11:10:00',3.81),('11288','2013-10-20','11:15:00',3.79),('11288','2013-10-20','11:20:00',4.02),('11288','2013-10-20','11:25:00',4.11),('11288','2013-10-20','11:30:00',4.15),('11288','2013-10-20','11:35:00',4.22),('11288','2013-10-20','11:40:00',4.18),('11288','2013-10-20','11:45:00',4.28),('11288','2013-10-20','11:50:00',4.34),('11288','2013-10-20','11:55:00',4.21),('11288','2013-10-20','12:00:00',4.34),('11288','2013-10-20','12:05:00',4.49),('11288','2013-10-20','12:10:00',4.03),('11288','2013-10-20','12:15:00',3.95),('11288','2013-10-20','12:20:00',2.82),('11288','2013-10-20','12:25:00',4.8),('11288','2013-10-20','12:30:00',4.41),('11288','2013-10-20','12:35:00',3.79),('11288','2013-10-20','12:40:00',2.87),('11288','2013-10-20','12:45:00',3.74),('11288','2013-10-20','12:50:00',2.96),('11288','2013-10-20','12:55:00',3.37),('11288','2013-10-20','13:00:00',3.56),('11288','2013-10-20','13:05:00',2.34),('11288','2013-10-20','13:10:00',2.14),('11288','2013-10-20','13:15:00',2.03),('11288','2013-10-20','13:20:00',4.2),('11288','2013-10-20','13:25:00',2.56),('11288','2013-10-20','13:30:00',1.6),('11288','2013-10-20','13:35:00',2.01),('11288','2013-10-20','13:40:00',2.21),('11288','2013-10-20','13:45:00',2.31),('11288','2013-10-20','13:50:00',1.92),('11288','2013-10-20','13:55:00',2.33),('11288','2013-10-20','14:00:00',1.75),('11288','2013-10-20','14:05:00',1.53),('11288','2013-10-20','14:10:00',1.68),('11288','2013-10-20','14:15:00',2.05),('11288','2013-10-20','14:40:00',1.11),('11288','2013-10-20','14:45:00',1.13),('11288','2013-10-20','14:50:00',1.08),('11288','2013-10-20','14:55:00',1.01),('11288','2013-10-20','16:30:00',1.15),('11288','2013-10-20','16:35:00',1.42),('11288','2013-10-20','16:40:00',1.85),('11288','2013-10-20','16:45:00',1.68),('11288','2013-10-20','16:50:00',1.89),('11288','2013-10-20','16:55:00',1.79),('11288','2013-10-20','17:00:00',1.54),('11288','2013-10-20','17:05:00',1.32),('11288','2013-10-19','08:40:00',1.02),('11288','2013-10-19','08:45:00',1.01),('11288','2013-10-19','08:50:00',1.25),('11288','2013-10-19','09:00:00',1.22),('11288','2013-10-19','09:05:00',1.42),('11288','2013-10-19','09:10:00',1.75),('11288','2013-10-19','09:15:00',2.2),('11288','2013-10-19','09:20:00',2.29),('11288','2013-10-19','09:25:00',2.37),('11288','2013-10-19','09:30:00',2.42),('11288','2013-10-19','09:35:00',2.5),('11288','2013-10-19','09:40:00',2.68),('11288','2013-10-19','09:45:00',2.6),('11288','2013-10-19','09:50:00',2.87),('11288','2013-10-19','09:55:00',3.05),('11288','2013-10-19','10:00:00',2.92),('11288','2013-10-19','10:05:00',2.93),('11288','2013-10-19','10:10:00',3.21),('11288','2013-10-19','10:15:00',3.07),('11288','2013-10-19','10:20:00',3.17),('11288','2013-10-19','10:25:00',3.67),('11288','2013-10-19','10:30:00',3.8),('11288','2013-10-19','10:35:00',3.85),('11288','2013-10-19','10:40:00',3.92),('11288','2013-10-19','10:45:00',3.85),('11288','2013-10-19','10:50:00',3.98),('11288','2013-10-19','10:55:00',3.89),('11288','2013-10-19','11:00:00',3.79),('11288','2013-10-19','11:05:00',3.95),('11288','2013-10-19','11:10:00',1.62),('11288','2013-10-19','11:15:00',1.96),('11288','2013-10-19','11:20:00',4.2),('11288','2013-10-19','11:25:00',4.48),('11288','2013-10-19','11:30:00',4.76),('11288','2013-10-19','11:35:00',4.64),('11288','2013-10-19','11:40:00',4.48),('11288','2013-10-19','11:45:00',4.76),('11288','2013-10-19','11:50:00',4.24),('11288','2013-10-19','11:55:00',4.81),('11288','2013-10-19','12:00:00',4.93),('11288','2013-10-19','12:05:00',4.93),('11288','2013-10-19','12:10:00',4.84),('11288','2013-10-19','12:15:00',4.9),('11288','2013-10-19','12:20:00',4.75),('11288','2013-10-19','12:25:00',4.61),('11288','2013-10-19','12:30:00',4.91),('11288','2013-10-19','12:35:00',5.01),('11288','2013-10-19','12:40:00',5.16),('11288','2013-10-19','12:45:00',5.26),('11288','2013-10-19','12:50:00',5.21),('11288','2013-10-19','12:55:00',5.5),('11288','2013-10-19','13:00:00',5.86),('11288','2013-10-19','13:05:00',4.85),('11288','2013-10-19','13:10:00',5.08),('11288','2013-10-19','13:15:00',4.73),('11288','2013-10-19','13:20:00',4.63),('11288','2013-10-19','13:25:00',4.92),('11288','2013-10-19','13:30:00',5.36),('11288','2013-10-19','13:35:00',3.61),('11288','2013-10-19','13:40:00',3.61),('11288','2013-10-19','13:45:00',3.06),('11288','2013-10-19','13:50:00',4.34),('11288','2013-10-19','13:55:00',5.11),('11288','2013-10-19','14:00:00',4.17),('11288','2013-10-19','14:05:00',3.58),('11288','2013-10-19','14:10:00',2.84),('11288','2013-10-19','14:15:00',3.82),('11288','2013-10-19','14:20:00',3.24),('11288','2013-10-19','14:25:00',2.51),('11288','2013-10-19','14:30:00',3.4),('11288','2013-10-19','14:35:00',4.32),('11288','2013-10-19','14:40:00',3.51),('11288','2013-10-19','14:45:00',3.26),('11288','2013-10-19','14:50:00',4.36),('11288','2013-10-19','14:55:00',4.15),('11288','2013-10-19','15:00:00',4.05),('11288','2013-10-19','15:05:00',3.9),('11288','2013-10-19','15:10:00',3.8),('11288','2013-10-19','15:15:00',3.68),('11288','2013-10-19','15:20:00',3.4),('11288','2013-10-19','15:25:00',3.23),('11288','2013-10-19','15:30:00',3.09),('11288','2013-10-19','15:35:00',3.07),('11288','2013-10-19','15:40:00',2.82),('11288','2013-10-19','15:45:00',2.42),('11288','2013-10-19','15:50:00',2.68),('11288','2013-10-19','15:55:00',2.79),('11288','2013-10-19','16:00:00',2.18),('11288','2013-10-19','16:05:00',2.43),('11288','2013-10-19','16:10:00',2.27),('11288','2013-10-19','16:15:00',2.33),('11288','2013-10-19','16:20:00',1.96),('11288','2013-10-19','16:25:00',1.64),('11288','2013-10-19','16:30:00',2.04),('11288','2013-10-19','16:35:00',1.91),('11288','2013-10-19','16:40:00',1.81),('11288','2013-10-19','16:45:00',1.76),('11288','2013-10-19','16:50:00',1.52),('11288','2014-05-04','07:45:00',1.05),('11288','2014-05-04','07:50:00',1.55),('11288','2014-05-04','07:55:00',1.65),('11288','2014-05-04','08:00:00',1.61),('11288','2014-05-04','08:05:00',1.88),('11288','2014-05-04','08:10:00',1.97),('11288','2014-05-04','08:15:00',2.13),('11288','2014-05-04','08:20:00',2.46),('11288','2014-05-04','08:25:00',2.36),('11288','2014-05-04','08:30:00',2.61),('11288','2014-05-04','08:35:00',3.38),('11288','2014-05-04','08:40:00',2.19),('11288','2014-05-04','08:45:00',2.32),('11288','2014-05-04','08:50:00',2.54),('11288','2014-05-04','08:55:00',2.06),('11288','2014-05-04','09:00:00',2.31),('11288','2014-05-04','09:05:00',3.41),('11288','2014-05-04','09:10:00',3.73),('11288','2014-05-04','09:15:00',3.3),('11288','2014-05-04','09:20:00',5.45),('11288','2014-05-04','09:25:00',5.8),('11288','2014-05-04','09:30:00',3.6),('11288','2014-05-04','09:35:00',2.21),('11288','2014-05-04','09:40:00',2.43),('11288','2014-05-04','09:45:00',3.32),('11288','2014-05-04','09:50:00',3.66),('11288','2014-05-04','09:55:00',3.45),('11288','2014-05-04','10:00:00',5.29),('11288','2014-05-04','10:05:00',6.25),('11288','2014-05-04','10:10:00',5.69),('11288','2014-05-04','10:15:00',4.6),('11288','2014-05-04','10:20:00',3.42),('11288','2014-05-04','10:25:00',3.43),('11288','2014-05-04','10:30:00',3.75),('11288','2014-05-04','10:35:00',3.81),('11288','2014-05-04','10:40:00',3.86),('11288','2014-05-04','10:45:00',4.37),('11288','2014-05-04','10:50:00',4.35),('11288','2014-05-04','10:55:00',4.23),('11288','2014-05-04','11:00:00',4.1),('11288','2014-05-04','11:05:00',4.06),('11288','2014-05-04','11:10:00',5.95),('11288','2014-05-04','11:15:00',6.29),('11288','2014-05-04','11:20:00',7.5),('11288','2014-05-04','11:25:00',7.28),('11288','2014-05-04','11:30:00',6.77),('11288','2014-05-04','11:35:00',6.44),('11288','2014-05-04','11:40:00',4.91),('11288','2014-05-04','11:45:00',6.63),('11288','2014-05-04','11:50:00',4.96),('11288','2014-05-04','11:55:00',7.52),('11288','2014-05-04','12:00:00',4.76),('11288','2014-05-04','12:05:00',4.18),('11288','2014-05-04','12:10:00',3.16),('11288','2014-05-04','12:15:00',2.91),('11288','2014-05-04','12:20:00',2.73),('11288','2014-05-04','12:25:00',2.96),('11288','2014-05-04','12:30:00',4.41),('11288','2014-05-04','12:35:00',9.21),('11288','2014-05-04','12:40:00',4.53),('11288','2014-05-04','12:45:00',3.62),('11288','2014-05-04','12:50:00',2.77),('11288','2014-05-04','12:55:00',3.47),('11288','2014-05-04','13:00:00',3.45),('11288','2014-05-04','13:05:00',2.84),('11288','2014-05-04','13:10:00',2.9),('11288','2014-05-04','13:15:00',2.93),('11288','2014-05-04','13:20:00',2.8),('11288','2014-05-04','13:25:00',2.72),('11288','2014-05-04','13:30:00',2.61),('11288','2014-05-04','13:35:00',2.89),('11288','2014-05-04','13:40:00',2.84),('11288','2014-05-04','13:45:00',2.51),('11288','2014-05-04','13:50:00',2.35),('11288','2014-05-04','13:55:00',2.46),('11288','2014-05-04','14:00:00',2.47),('11288','2014-05-04','14:05:00',2.5),('11288','2014-05-04','14:10:00',2.47),('11288','2014-05-04','14:15:00',2.29),('11288','2014-05-04','14:20:00',1.77),('11288','2014-05-04','14:25:00',1.24),('11288','2014-05-04','14:30:00',1.08),('11288','2014-05-04','14:35:00',1.14),('11288','2014-05-04','14:40:00',1.32),('11288','2014-05-04','14:45:00',1.54),('11288','2014-05-04','14:50:00',2.12),('11288','2014-05-04','14:55:00',3.01),('11288','2014-05-04','15:00:00',3.42),('11288','2014-05-04','15:05:00',3.84),('11288','2014-05-04','15:10:00',5.67),('11288','2014-05-04','15:15:00',4.56),('11288','2014-05-04','15:20:00',3.8),('11288','2014-05-04','15:25:00',2.83),('11288','2014-05-04','15:30:00',2.4),('11288','2014-05-04','15:35:00',1.6),('11288','2014-05-04','15:40:00',1.41),('11288','2014-05-04','15:45:00',1.65),('11288','2014-05-04','15:50:00',2.01),('11288','2014-05-04','15:55:00',2.08),('11288','2014-05-04','16:00:00',1.9),('11288','2014-05-04','16:05:00',1.98),('11288','2014-05-04','16:10:00',2.33),('11288','2014-05-04','16:15:00',2.2),('11288','2014-05-04','16:20:00',1.87),('11288','2014-05-04','16:25:00',1.45),('11288','2014-05-04','16:30:00',1.11),('11288','2014-05-04','16:55:00',1.01),('11288','2014-05-04','17:20:00',1.13),('11288','2014-05-04','17:25:00',1.62),('11288','2014-05-04','17:30:00',1.66),('11288','2014-05-04','17:35:00',1.75),('11288','2014-05-04','17:40:00',1.91),('11288','2014-05-04','17:45:00',1.35),('11288','2014-05-04','17:50:00',1.1),('11288','2014-05-04','18:05:00',1.15),('11288','2014-04-16','07:55:00',1.1),('11288','2014-04-16','08:00:00',1.33),('11288','2014-04-16','08:05:00',1.41),('11288','2014-04-16','08:10:00',1.47),('11288','2014-04-16','08:15:00',1.58),('11288','2014-04-16','08:20:00',1.74),('11288','2014-04-16','08:25:00',1.88),('11288','2014-04-16','08:30:00',1.57),('11288','2014-04-16','08:35:00',1.25),('11288','2014-04-16','08:40:00',1.44),('11288','2014-04-16','08:45:00',2.4),('11288','2014-04-16','08:50:00',2.61),('11288','2014-04-16','08:55:00',3.07),('11288','2014-04-16','09:00:00',3.27),('11288','2014-04-16','09:05:00',3.26),('11288','2014-04-16','09:10:00',3.44),('11288','2014-04-16','09:15:00',3.54),('11288','2014-04-16','09:20:00',3.74),('11288','2014-04-16','09:25:00',3.92),('11288','2014-04-16','09:30:00',2.62),('11288','2014-04-16','09:35:00',1.94),('11288','2014-04-16','09:40:00',1.52),('11288','2014-04-16','09:45:00',1.57),('11288','2014-04-16','09:50:00',1.76),('11288','2014-04-16','09:55:00',4.83),('11288','2014-04-16','10:00:00',5.25),('11288','2014-04-16','10:05:00',5.33),('11288','2014-04-16','10:10:00',5.43),('11288','2014-04-16','10:15:00',5.61),('11288','2014-04-16','10:20:00',5.76),('11288','2014-04-16','10:25:00',5.89),('11288','2014-04-16','10:30:00',5.99),('11288','2014-04-16','10:35:00',6.04),('11288','2014-04-16','10:40:00',6.14),('11288','2014-04-16','10:45:00',6.29),('11288','2014-04-16','10:50:00',6.54),('11288','2014-04-16','10:55:00',5.98),('11288','2014-04-16','11:00:00',6.18),('11288','2014-04-16','11:05:00',3.36),('11288','2014-04-16','11:10:00',2.76),('11288','2014-04-16','11:15:00',3.19),('11288','2014-04-16','11:20:00',5.92),('11288','2014-04-16','11:25:00',6.18),('11288','2014-04-16','11:30:00',6.79),('11288','2014-04-16','11:35:00',4.75),('11288','2014-04-16','11:40:00',5.51),('11288','2014-04-16','11:45:00',7.14),('11288','2014-04-16','11:50:00',8.02),('11288','2014-04-16','11:55:00',8),('11288','2014-04-16','12:00:00',8.03),('11288','2014-04-16','12:05:00',6.76),('11288','2014-04-16','12:10:00',6.43),('11288','2014-04-16','12:15:00',8.09),('11288','2014-04-16','12:20:00',4.31),('11288','2014-04-16','12:25:00',2.16),('11288','2014-04-16','12:30:00',2.34),('11288','2014-04-16','12:35:00',7.78),('11288','2014-04-16','12:40:00',7.8),('11288','2014-04-16','12:45:00',7.81),('11288','2014-04-16','12:50:00',7.07),('11288','2014-04-16','12:55:00',1.95),('11288','2014-04-16','13:00:00',4.58),('11288','2014-04-16','13:05:00',2.57),('11288','2014-04-16','13:10:00',1.53),('11288','2014-04-16','13:15:00',1.6),('11288','2014-04-16','13:20:00',2.57),('11288','2014-04-16','13:25:00',2.05),('11288','2014-04-16','13:30:00',1.69),('11288','2014-04-16','13:35:00',2.8),('11288','2014-04-16','13:40:00',4.84),('11288','2014-04-16','13:45:00',8.62),('11288','2014-04-16','13:50:00',7.68),('11288','2014-04-16','13:55:00',7.84),('11288','2014-04-16','14:00:00',3.02),('11288','2014-04-16','14:05:00',6.14),('11288','2014-04-16','14:10:00',7.46),('11288','2014-04-16','14:15:00',8.38),('11288','2014-04-16','14:20:00',6.34),('11288','2014-04-16','14:25:00',6.78),('11288','2014-04-16','14:30:00',7.58),('11288','2014-04-16','14:35:00',7.22),('11288','2014-04-16','14:40:00',7.09),('11288','2014-04-16','14:45:00',7.41),('11288','2014-04-16','14:50:00',7.59),('11288','2014-04-16','14:55:00',3.35),('11288','2014-04-16','15:00:00',2.13),('11288','2014-04-16','15:05:00',5.13),('11288','2014-04-16','15:10:00',7.82),('11288','2014-04-16','15:15:00',5.41),('11288','2014-04-16','15:20:00',1.12),('11288','2014-04-16','15:25:00',2.09),('11288','2014-04-16','15:30:00',4.08),('11288','2014-04-16','15:35:00',6.98),('11288','2014-04-16','15:40:00',6.72),('11288','2014-04-16','15:45:00',6.43),('11288','2014-04-16','15:50:00',6.2),('11288','2014-04-16','15:55:00',5.94),('11288','2014-04-16','16:00:00',5.77),('11288','2014-04-16','16:05:00',5.6),('11288','2014-04-16','16:10:00',5.46),('11288','2014-04-16','16:15:00',5.35),('11288','2014-04-16','16:20:00',5.32),('11288','2014-04-16','16:25:00',5.12),('11288','2014-04-16','16:30:00',5),('11288','2014-04-16','16:35:00',4.82),('11288','2014-04-16','16:40:00',4.71),('11288','2014-04-16','16:45:00',4.58),('11288','2014-04-16','16:50:00',4.42),('11288','2014-04-16','16:55:00',4.24),('11288','2014-04-16','17:00:00',4.07),('11288','2014-04-16','17:05:00',3.93),('11288','2014-04-16','17:10:00',3.77),('11288','2014-04-16','17:15:00',3.64),('11288','2014-04-16','17:20:00',3.45),('11288','2014-04-16','17:25:00',3.28),('11288','2014-04-16','17:30:00',3.12),('11288','2014-04-16','17:35:00',3.01),('11288','2014-04-16','17:40:00',2.81),('11288','2014-04-16','17:45:00',2.68),('11288','2014-04-16','17:50:00',2.61),('11288','2014-04-16','17:55:00',2.57),('11288','2014-04-16','18:00:00',2.35),('11288','2014-04-16','18:05:00',2.22),('11288','2014-04-16','18:10:00',1.97),('11288','2014-04-16','18:15:00',1.49),('11288','2014-04-16','18:20:00',1.74),('11288','2014-04-16','18:25:00',1.47),('11288','2014-04-16','18:30:00',1.27),('11288','2014-04-16','18:35:00',1.1),('11288','2014-04-16','18:40:00',1.23),('11288','2014-04-16','18:45:00',1.32),('11288','2014-04-16','18:50:00',1.35),('11288','2014-04-16','18:55:00',1.08),('11288','2013-10-18','08:45:00',1.07),('11288','2013-10-18','08:50:00',1.24),('11288','2013-10-18','08:55:00',1.3),('11288','2013-10-18','09:00:00',1.38),('11288','2013-10-18','09:05:00',1.62),('11288','2013-10-18','09:10:00',1.78),('11288','2013-10-18','09:15:00',1.89),('11288','2013-10-18','09:20:00',2.09),('11288','2013-10-18','09:25:00',2.2),('11288','2013-10-18','09:30:00',2.3),('11288','2013-10-18','09:35:00',2.45),('11288','2013-10-18','09:40:00',2.53),('11288','2013-10-18','09:45:00',2.57),('11288','2013-10-18','09:50:00',2.82),('11288','2013-10-18','09:55:00',2.95),('11288','2013-10-18','10:00:00',2.97),('11288','2013-10-18','10:05:00',3.18),('11288','2013-10-18','10:10:00',3.27),('11288','2013-10-18','10:15:00',3.36),('11288','2013-10-18','10:20:00',3.31),('11288','2013-10-18','10:25:00',3.39),('11288','2013-10-18','10:30:00',3.68),('11288','2013-10-18','10:35:00',3.78),('11288','2013-10-18','10:40:00',3.87),('11288','2013-10-18','10:45:00',3.9),('11288','2013-10-18','10:50:00',3.97),('11288','2013-10-18','10:55:00',4.03),('11288','2013-10-18','11:00:00',4.06),('11288','2013-10-18','11:05:00',3.89),('11288','2013-10-18','11:10:00',4.07),('11288','2013-10-18','11:15:00',3.99),('11288','2013-10-18','11:20:00',4.41),('11288','2013-10-18','11:25:00',4.42),('11288','2013-10-18','11:30:00',4.4),('11288','2013-10-18','11:35:00',4.51),('11288','2013-10-18','11:40:00',4.62),('11288','2013-10-18','11:45:00',4.47),('11288','2013-10-18','11:50:00',4.51),('11288','2013-10-18','11:55:00',4.77),('11288','2013-10-18','12:00:00',4.73),('11288','2013-10-18','12:05:00',4.72),('11288','2013-10-18','12:10:00',4.8),('11288','2013-10-18','12:15:00',4.75),('11288','2013-10-18','12:20:00',4.66),('11288','2013-10-18','12:25:00',4.74),('11288','2013-10-18','12:30:00',4.78),('11288','2013-10-18','12:35:00',4.71),('11288','2013-10-18','12:40:00',4.75),('11288','2013-10-18','12:45:00',4.7),('11288','2013-10-18','12:50:00',4.62),('11288','2013-10-18','12:55:00',4.73),('11288','2013-10-18','13:00:00',4.69),('11288','2013-10-18','13:05:00',4.63),('11288','2013-10-18','13:10:00',4.41),('11288','2013-10-18','13:15:00',4.46),('11288','2013-10-18','13:20:00',4.69),('11288','2013-10-18','13:25:00',4.7),('11288','2013-10-18','13:30:00',4.75),('11288','2013-10-18','13:35:00',4.64),('11288','2013-10-18','13:40:00',4.62),('11288','2013-10-18','13:45:00',4.52),('11288','2013-10-18','13:50:00',4.53),('11288','2013-10-18','13:55:00',4.5),('11288','2013-10-18','14:00:00',4.2),('11288','2013-10-18','14:05:00',4.16),('11288','2013-10-18','14:10:00',4.15),('11288','2013-10-18','14:15:00',4.22),('11288','2013-10-18','14:20:00',4.13),('11288','2013-10-18','14:25:00',4.15),('11288','2013-10-18','14:30:00',4.11),('11288','2013-10-18','14:35:00',3.94),('11288','2013-10-18','14:40:00',3.93),('11288','2013-10-18','14:45:00',3.71),('11288','2013-10-18','14:50:00',3.66),('11288','2013-10-18','14:55:00',3.71),('11288','2013-10-18','15:00:00',3.15),('11288','2013-10-18','15:05:00',2.99),('11288','2013-10-18','15:10:00',3.28),('11288','2013-10-18','15:15:00',3.22),('11288','2013-10-18','15:20:00',3.35),('11288','2013-10-18','15:25:00',3.12),('11288','2013-10-18','15:30:00',2.95),('11288','2013-10-18','15:35:00',2.93),('11288','2013-10-18','15:40:00',2.74),('11288','2013-10-18','15:45:00',2.52),('11288','2013-10-18','15:50:00',2.37),('11288','2013-10-18','15:55:00',2.18),('11288','2013-10-18','16:00:00',2.25),('11288','2013-10-18','16:05:00',2.17),('11288','2013-10-18','16:10:00',2.08),('11288','2013-10-18','16:15:00',1.81),('11288','2013-10-18','16:20:00',1.74),('11288','2013-10-18','16:25:00',1.53),('11288','2013-10-18','16:30:00',1.39),('11288','2013-10-18','16:35:00',1.32),('11288','2013-10-18','16:40:00',1.03),('11288','2013-10-17','08:45:00',1.18),('11288','2013-10-17','08:50:00',1.35),('11288','2013-10-17','08:55:00',1.5),('11288','2013-10-17','09:00:00',1.59),('11288','2013-10-17','09:05:00',1.73),('11288','2013-10-17','09:10:00',1.85),('11288','2013-10-17','09:15:00',1.99),('11288','2013-10-17','09:20:00',2.09),('11288','2013-10-17','09:25:00',2.21),('11288','2013-10-17','09:30:00',2.32),('11288','2013-10-17','09:35:00',2.44),('11288','2013-10-17','09:40:00',2.51),('11288','2013-10-17','09:45:00',2.62),('11288','2013-10-17','09:50:00',2.82),('11288','2013-10-17','09:55:00',2.91),('11288','2013-10-17','10:00:00',2.97),('11288','2013-10-17','10:05:00',3.14),('11288','2013-10-17','10:10:00',3.24),('11288','2013-10-17','10:15:00',3.38),('11288','2013-10-17','10:20:00',3.43),('11288','2013-10-17','10:25:00',3.45),('11288','2013-10-17','10:30:00',3.66),('11288','2013-10-17','10:35:00',3.79),('11288','2013-10-17','10:40:00',3.89),('11288','2013-10-17','10:45:00',4),('11288','2013-10-17','10:50:00',4.06),('11288','2013-10-17','10:55:00',4.17),('11288','2013-10-17','11:00:00',4.23),('11288','2013-10-17','11:05:00',4.29),('11288','2013-10-17','11:10:00',4.34),('11288','2013-10-17','11:15:00',4.38),('11288','2013-10-17','11:20:00',4.46),('11288','2013-10-17','11:25:00',4.55),('11288','2013-10-17','11:30:00',4.59),('11288','2013-10-17','11:35:00',4.65),('11288','2013-10-17','11:40:00',4.69),('11288','2013-10-17','11:45:00',4.77),('11288','2013-10-17','11:50:00',4.78),('11288','2013-10-17','11:55:00',4.78),('11288','2013-10-17','12:00:00',4.81),('11288','2013-10-17','12:05:00',4.93),('11288','2013-10-17','12:10:00',4.95),('11288','2013-10-17','12:15:00',4.97),('11288','2013-10-17','12:20:00',4.95),('11288','2013-10-17','12:25:00',4.98),('11288','2013-10-17','12:30:00',4.99),('11288','2013-10-17','12:35:00',4.99),('11288','2013-10-17','12:40:00',5.05),('11288','2013-10-17','12:45:00',5.09),('11288','2013-10-17','12:50:00',5.05),('11288','2013-10-17','12:55:00',5.04),('11288','2013-10-17','13:00:00',5.02),('11288','2013-10-17','13:05:00',4.99),('11288','2013-10-17','13:10:00',4.99),('11288','2013-10-17','13:15:00',4.99),('11288','2013-10-17','13:20:00',4.95),('11288','2013-10-17','13:25:00',4.91),('11288','2013-10-17','13:30:00',4.88),('11288','2013-10-17','13:35:00',4.88),('11288','2013-10-17','13:40:00',4.83),('11288','2013-10-17','13:45:00',4.8),('11288','2013-10-17','13:50:00',4.78),('11288','2013-10-17','13:55:00',4.74),('11288','2013-10-17','14:00:00',4.7),('11288','2013-10-17','14:05:00',4.66),('11288','2013-10-17','14:10:00',4.61),('11288','2013-10-17','14:15:00',4.58),('11288','2013-10-17','14:20:00',4.47),('11288','2013-10-17','14:25:00',4.47),('11288','2013-10-17','14:30:00',4.38),('11288','2013-10-17','14:35:00',4.32),('11288','2013-10-17','14:40:00',4.26),('11288','2013-10-17','14:45:00',4.15),('11288','2013-10-17','14:50:00',4.1),('11288','2013-10-17','14:55:00',3.99),('11288','2013-10-17','15:00:00',3.92),('11288','2013-10-17','15:05:00',3.87),('11288','2013-10-17','15:10:00',3.76),('11288','2013-10-17','15:15:00',3.69),('11288','2013-10-17','15:20:00',3.59),('11288','2013-10-17','15:25:00',3.5),('11288','2013-10-17','15:30:00',3.35),('11288','2013-10-17','15:35:00',3.24),('11288','2013-10-17','15:40:00',3.14),('11288','2013-10-17','15:45:00',3.02),('11288','2013-10-17','15:50:00',2.91),('11288','2013-10-17','15:55:00',2.7),('11288','2013-10-17','16:00:00',2.56),('11288','2013-10-17','16:05:00',2.53),('11288','2013-10-17','16:10:00',2.41),('11288','2013-10-17','16:15:00',2.13),('11288','2013-10-17','16:20:00',2.18),('11288','2013-10-17','16:25:00',2.08),('11288','2013-10-17','16:30:00',1.93),('11288','2013-10-17','16:35:00',1.76),('11288','2013-10-17','16:40:00',1.67),('11288','2013-10-17','16:45:00',1.53),('11288','2013-10-17','16:50:00',1.38),('11288','2013-10-17','16:55:00',1.29),('11288','2013-10-17','17:00:00',1.18),('11288','2013-10-17','17:05:00',1.05),('11288','2013-10-16','09:40:00',1.09),('11288','2013-10-16','09:45:00',2.63),('11288','2013-10-16','09:50:00',2.07),('11288','2013-10-16','09:55:00',1.45),('11288','2013-10-16','10:00:00',1.51),('11288','2013-10-16','11:05:00',1.64),('11288','2013-10-16','11:10:00',1.75),('11288','2013-10-16','11:15:00',2.14),('11288','2013-10-16','11:20:00',1.71),('11288','2013-10-16','11:25:00',1.06),('11288','2013-10-16','11:55:00',2.03),('11288','2013-10-16','12:00:00',1.77),('11288','2013-10-16','12:10:00',1.91),('11288','2013-10-16','12:15:00',4.58),('11288','2013-10-16','12:20:00',2.57),('11288','2013-10-16','12:25:00',1.52),('11288','2013-10-16','12:30:00',2.59),('11288','2013-10-16','12:35:00',2.71),('11288','2013-10-16','12:40:00',6.04),('11288','2013-10-16','12:45:00',3.37),('11288','2013-10-16','12:50:00',5),('11288','2013-10-16','12:55:00',3.67),('11288','2013-10-16','13:00:00',3.36),('11288','2013-10-16','13:05:00',4.47),('11288','2013-10-16','13:10:00',5.43),('11288','2013-10-16','13:15:00',5.7),('11288','2013-10-16','13:20:00',5.39),('11288','2013-10-16','13:25:00',5.19),('11288','2013-10-16','13:30:00',4.95),('11288','2013-10-16','13:35:00',4.87),('11288','2013-10-16','13:40:00',4.9),('11288','2013-10-16','13:45:00',4.9),('11288','2013-10-16','13:50:00',4.39),('11288','2013-10-16','13:55:00',5.08),('11288','2013-10-16','14:00:00',4.17),('11288','2013-10-16','14:05:00',2.92),('11288','2013-10-16','14:10:00',5.07),('11288','2013-10-16','14:15:00',4.3),('11288','2013-10-16','14:20:00',4.35),('11288','2013-10-16','14:25:00',5.05),('11288','2013-10-16','14:30:00',4.62),('11288','2013-10-16','14:35:00',4.83),('11288','2013-10-16','14:40:00',4.48),('11288','2013-10-16','14:45:00',3.83),('11288','2013-10-16','14:50:00',3.92),('11288','2013-10-16','14:55:00',4.17),('11288','2013-10-16','15:00:00',3.84),('11288','2013-10-16','15:05:00',2.64),('11288','2013-10-16','15:10:00',3.84),('11288','2013-10-16','15:15:00',3.77),('11288','2013-10-16','15:20:00',3.38),('11288','2013-10-16','15:25:00',2.64),('11288','2013-10-16','15:30:00',1.15),('11288','2013-10-16','15:35:00',1.84),('11288','2013-10-16','15:40:00',3.32),('11288','2013-10-16','15:45:00',3.08),('11288','2013-10-16','15:50:00',2.93),('11288','2013-10-16','15:55:00',2.72),('11288','2013-10-16','16:00:00',2.62),('11288','2013-10-16','16:05:00',2.6),('11288','2013-10-16','16:10:00',2.44),('11288','2013-10-16','16:15:00',2.23),('11288','2013-10-16','16:20:00',2.17),('11288','2013-10-16','16:25:00',2.06),('11288','2013-10-16','16:30:00',1.9),('11288','2013-10-16','16:35:00',1.53),('11288','2013-10-16','16:40:00',1.5),('11288','2013-10-16','16:45:00',1.37),('11288','2013-10-16','16:50:00',1.42),('11288','2013-10-16','16:55:00',1.34),('11288','2013-10-16','17:00:00',1.21),('11288','2013-10-16','17:05:00',1.1),('11288','2013-10-16','17:10:00',1.01),('11288','2013-10-15','09:00:00',1.19),('11288','2013-10-15','09:05:00',1.38),('11288','2013-10-15','09:10:00',1.51),('11288','2013-10-15','09:15:00',1.47),('11288','2013-10-15','09:20:00',1.57),('11288','2013-10-15','09:25:00',1.55),('11288','2013-10-15','09:30:00',2.06),('11288','2013-10-15','09:35:00',1.48),('11288','2013-10-15','09:40:00',1.99),('11288','2013-10-15','09:45:00',2.58),('11288','2013-10-15','09:50:00',2.75),('11288','2013-10-15','09:55:00',2.98),('11288','2013-10-15','10:00:00',3.03),('11288','2013-10-15','10:05:00',3.39),('11288','2013-10-15','10:10:00',2.65),('11288','2013-10-15','10:15:00',1.79),('11288','2013-10-15','10:20:00',1.81),('11288','2013-10-15','10:25:00',2.29),('11288','2013-10-15','10:30:00',2.9),('11288','2013-10-15','10:35:00',2.45),('11288','2013-10-15','10:40:00',2.95),('11288','2013-10-15','10:45:00',3.49),('11288','2013-10-15','10:50:00',3.33),('11288','2013-10-15','10:55:00',2.93),('11288','2013-10-15','11:00:00',2.89),('11288','2013-10-15','11:05:00',3.13),('11288','2013-10-15','11:10:00',3.96),('11288','2013-10-15','11:15:00',4.33),('11288','2013-10-15','11:20:00',4.37),('11288','2013-10-15','11:25:00',4.04),('11288','2013-10-15','11:30:00',4.24),('11288','2013-10-15','11:35:00',3.57),('11288','2013-10-15','11:40:00',2.97),('11288','2013-10-15','11:45:00',2.52),('11288','2013-10-15','11:50:00',2.45),('11288','2013-10-15','11:55:00',2.44),('11288','2013-10-15','12:00:00',2.56),('11288','2013-10-15','12:05:00',2.58),('11288','2013-10-15','12:10:00',2.61),('11288','2013-10-15','12:15:00',2.57),('11288','2013-10-15','12:20:00',2.69),('11288','2013-10-15','12:25:00',2.43),('11288','2013-10-15','12:30:00',2.29),('11288','2013-10-15','12:35:00',2.21),('11288','2013-10-15','12:40:00',2.26),('11288','2013-10-15','12:45:00',2.46),('11288','2013-10-15','12:50:00',2.34),('11288','2013-10-15','12:55:00',2.11),('11288','2013-10-15','13:00:00',2.1),('11288','2013-10-15','13:05:00',2.7),('11288','2013-10-15','13:10:00',2.94),('11288','2013-10-15','13:15:00',2.98),('11288','2013-10-15','13:20:00',4.2),('11288','2013-10-15','13:25:00',4.59),('11288','2013-10-15','13:30:00',2.98),('11288','2013-10-15','13:35:00',2.6),('11288','2013-10-15','13:40:00',2.57),('11288','2013-10-15','13:45:00',2.63),('11288','2013-10-15','13:50:00',2.46),('11288','2013-10-15','13:55:00',2.22),('11288','2013-10-15','14:00:00',2.03),('11288','2013-10-15','14:05:00',2.04),('11288','2013-10-15','14:10:00',2.27),('11288','2013-10-15','14:15:00',3.03),('11288','2013-10-15','14:20:00',3.19),('11288','2013-10-15','14:25:00',3.45),('11288','2013-10-15','14:30:00',3.17),('11288','2013-10-15','14:35:00',2.22),('11288','2013-10-15','14:40:00',3.03),('11288','2013-10-15','14:45:00',3.08),('11288','2013-10-15','14:50:00',4),('11288','2013-10-15','14:55:00',2.96),('11288','2013-10-15','15:00:00',2.08),('11288','2013-10-15','15:05:00',2.17),('11288','2013-10-15','15:10:00',2.18),('11288','2013-10-15','15:15:00',2.05),('11288','2013-10-15','15:20:00',1.88),('11288','2013-10-15','15:25:00',1.73),('11288','2013-10-15','15:30:00',1.7),('11288','2013-10-15','15:35:00',1.78),('11288','2013-10-15','15:40:00',1.85),('11288','2013-10-15','15:45:00',1.78),('11288','2013-10-15','15:50:00',1.56),('11288','2013-10-15','15:55:00',1.38),('11288','2013-10-15','16:00:00',1.27),('11288','2013-10-15','16:05:00',1.3),('11288','2013-10-15','16:10:00',1.33),('11288','2013-10-15','16:15:00',1.24),('11288','2013-10-15','16:20:00',1.17),('11288','2013-10-15','16:25:00',1.56),('11288','2013-10-15','16:30:00',1.92),('11288','2013-10-15','16:35:00',1.93),('11288','2013-10-15','16:40:00',1.58),('11288','2013-10-15','16:45:00',1.28),('11288','2013-10-15','16:50:00',1.04),('11288','2013-10-15','16:55:00',1.07),('11288','2013-10-15','17:00:00',1.07),('11288','2013-10-14','08:25:00',1.05),('11288','2013-10-14','08:30:00',1.1),('11288','2013-10-14','08:35:00',1.22),('11288','2013-10-14','08:40:00',1.17),('11288','2013-10-14','08:45:00',1.3),('11288','2013-10-14','08:50:00',1.37),('11288','2013-10-14','08:55:00',1.56),('11288','2013-10-14','09:00:00',1.38),('11288','2013-10-14','09:05:00',1.41),('11288','2013-10-14','09:10:00',1.15),('11288','2013-10-14','09:15:00',1.01),('11288','2013-10-14','09:20:00',1.42),('11288','2013-10-14','09:25:00',2.1),('11288','2013-10-14','09:30:00',2.36),('11288','2013-10-14','09:35:00',2.09),('11288','2013-10-14','09:40:00',1.92),('11288','2013-10-14','09:45:00',1.62),('11288','2013-10-14','09:50:00',2.23),('11288','2013-10-14','09:55:00',2.61),('11288','2013-10-14','10:00:00',2.62),('11288','2013-10-14','10:05:00',2.87),('11288','2013-10-14','10:10:00',3.1),('11288','2013-10-14','10:15:00',3.29),('11288','2013-10-14','10:20:00',3.41),('11288','2013-10-14','10:25:00',3.48),('11288','2013-10-14','10:30:00',3.54),('11288','2013-10-14','10:35:00',3.64),('11288','2013-10-14','10:40:00',3.62),('11288','2013-10-14','10:45:00',3.74),('11288','2013-10-14','10:50:00',3.87),('11288','2013-10-14','10:55:00',3.94),('11288','2013-10-14','11:00:00',4),('11288','2013-10-14','11:05:00',4.01),('11288','2013-10-14','11:10:00',4.23),('11288','2013-10-14','11:15:00',4.18),('11288','2013-10-14','11:20:00',4.22),('11288','2013-10-14','11:25:00',4.32),('11288','2013-10-14','11:30:00',4.44),('11288','2013-10-14','11:35:00',4.35),('11288','2013-10-14','11:40:00',4.42),('11288','2013-10-14','11:45:00',4.36),('11288','2013-10-14','11:50:00',4.46),('11288','2013-10-14','11:55:00',4.49),('11288','2013-10-14','12:00:00',4.55),('11288','2013-10-14','12:05:00',4.6),('11288','2013-10-14','12:10:00',4.74),('11288','2013-10-14','12:15:00',4.65),('11288','2013-10-14','12:20:00',4.31),('11288','2013-10-14','12:25:00',4.62),('11288','2013-10-14','12:30:00',4.79),('11288','2013-10-14','12:35:00',4.67),('11288','2013-10-14','12:40:00',4.76),('11288','2013-10-14','12:45:00',4.79),('11288','2013-10-14','12:50:00',4.71),('11288','2013-10-14','12:55:00',4.74),('11288','2013-10-14','13:00:00',4.73),('11288','2013-10-14','13:05:00',4.68),('11288','2013-10-14','13:10:00',4.66),('11288','2013-10-14','13:15:00',4.63),('11288','2013-10-14','13:20:00',4.64),('11288','2013-10-14','13:25:00',4.63),('11288','2013-10-14','13:30:00',4.59),('11288','2013-10-14','13:35:00',4.58),('11288','2013-10-14','13:40:00',4.58),('11288','2013-10-14','13:45:00',4.55),('11288','2013-10-14','13:50:00',4.53),('11288','2013-10-14','13:55:00',4.47),('11288','2013-10-14','14:00:00',4.43),('11288','2013-10-14','14:05:00',4.41),('11288','2013-10-14','14:10:00',4.36),('11288','2013-10-14','14:15:00',4.31),('11288','2013-10-14','14:20:00',4.22),('11288','2013-10-14','14:25:00',4.21),('11288','2013-10-14','14:30:00',4.16),('11288','2013-10-14','14:35:00',4.09),('11288','2013-10-14','14:40:00',4.04),('11288','2013-10-14','14:45:00',3.96),('11288','2013-10-14','14:50:00',3.85),('11288','2013-10-14','14:55:00',3.77),('11288','2013-10-14','15:00:00',3.73),('11288','2013-10-14','15:05:00',3.65),('11288','2013-10-14','15:10:00',3.51),('11288','2013-10-14','15:15:00',3.41),('11288','2013-10-14','15:20:00',3.33),('11288','2013-10-14','15:25:00',3.25),('11288','2013-10-14','15:30:00',3.08),('11288','2013-10-14','15:35:00',2.97),('11288','2013-10-14','15:40:00',2.71),('11288','2013-10-14','15:45:00',2.13),('11288','2013-10-14','15:50:00',2.23),('11288','2013-10-14','15:55:00',1.49),('11288','2013-10-14','16:00:00',1.68),('11288','2013-10-14','16:05:00',1.52),('11288','2013-10-14','16:10:00',1.52),('11288','2013-10-14','16:15:00',1.47),('11288','2013-10-14','16:20:00',1.39),('11288','2013-10-14','16:25:00',1.54),('11288','2013-10-14','16:30:00',1.26),('11288','2013-10-14','16:45:00',1.26),('11288','2013-10-13','08:50:00',1.07),('11288','2013-10-13','08:55:00',1.23),('11288','2013-10-13','09:00:00',1.38),('11288','2013-10-13','09:05:00',1.38),('11288','2013-10-13','09:10:00',1.54),('11288','2013-10-13','09:15:00',2.28),('11288','2013-10-13','09:20:00',2.41),('11288','2013-10-13','09:25:00',2.16),('11288','2013-10-13','09:30:00',1.69),('11288','2013-10-13','09:35:00',2.21),('11288','2013-10-13','09:40:00',3.09),('11288','2013-10-13','09:45:00',3.75),('11288','2013-10-13','09:50:00',3.71),('11288','2013-10-13','09:55:00',3.74),('11288','2013-10-13','10:00:00',2.68),('11288','2013-10-13','10:05:00',2.22),('11288','2013-10-13','10:10:00',3.07),('11288','2013-10-13','10:15:00',3.27),('11288','2013-10-13','10:20:00',2.77),('11288','2013-10-13','10:25:00',3.15),('11288','2013-10-13','10:30:00',4.1),('11288','2013-10-13','10:35:00',4.59),('11288','2013-10-13','10:40:00',4.73),('11288','2013-10-13','10:45:00',4.89),('11288','2013-10-13','10:50:00',3.86),('11288','2013-10-13','10:55:00',3.61),('11288','2013-10-13','11:00:00',4.3),('11288','2013-10-13','11:05:00',4.28),('11288','2013-10-13','11:10:00',4.51),('11288','2013-10-13','11:15:00',4.62),('11288','2013-10-13','11:20:00',4.44),('11288','2013-10-13','11:25:00',4.37),('11288','2013-10-13','11:30:00',4.52),('11288','2013-10-13','11:35:00',4.49),('11288','2013-10-13','11:40:00',4.55),('11288','2013-10-13','11:45:00',4.54),('11288','2013-10-13','11:50:00',4.61),('11288','2013-10-13','11:55:00',4.66),('11288','2013-10-13','12:00:00',4.7),('11288','2013-10-13','12:05:00',4.74),('11288','2013-10-13','12:10:00',4.77),('11288','2013-10-13','12:15:00',4.84),('11288','2013-10-13','12:20:00',4.64),('11288','2013-10-13','12:25:00',4.61),('11288','2013-10-13','12:30:00',4.81),('11288','2013-10-13','12:35:00',4.87),('11288','2013-10-13','12:40:00',4.93),('11288','2013-10-13','12:45:00',4.85),('11288','2013-10-13','12:50:00',4.73),('11288','2013-10-13','12:55:00',4.72),('11288','2013-10-13','13:00:00',4.76),('11288','2013-10-13','13:05:00',4.74),('11288','2013-10-13','13:10:00',4.79),('11288','2013-10-13','13:15:00',4.82),('11288','2013-10-13','13:20:00',4.86),('11288','2013-10-13','13:25:00',4.14),('11288','2013-10-13','13:30:00',3.63),('11288','2013-10-13','13:35:00',3.71),('11288','2013-10-13','13:40:00',2.82),('11288','2013-10-13','13:45:00',3.19),('11288','2013-10-13','13:50:00',3.54),('11288','2013-10-13','13:55:00',3.91),('11288','2013-10-13','14:00:00',4.73),('11288','2013-10-13','14:05:00',4.63),('11288','2013-10-13','14:10:00',4.54),('11288','2013-10-13','14:15:00',4.22),('11288','2013-10-13','14:20:00',4.66),('11288','2013-10-13','14:25:00',4.6),('11288','2013-10-13','14:30:00',3.72),('11288','2013-10-13','14:35:00',3.78),('11288','2013-10-13','14:40:00',4.04),('11288','2013-10-13','14:45:00',3.01),('11288','2013-10-13','14:50:00',2.71),('11288','2013-10-13','14:55:00',3.25),('11288','2013-10-13','15:00:00',4.05),('11288','2013-10-13','15:05:00',3.21),('11288','2013-10-13','15:10:00',2.41),('11288','2013-10-13','15:15:00',2.96),('11288','2013-10-13','15:20:00',3.33),('11288','2013-10-13','15:25:00',3.48),('11288','2013-10-13','15:30:00',2.64),('11288','2013-10-13','15:35:00',2.34),('11288','2013-10-13','15:40:00',2.31),('11288','2013-10-13','15:45:00',2.27),('11288','2013-10-13','15:50:00',2.12),('11288','2013-10-13','15:55:00',2.08),('11288','2013-10-13','16:00:00',2.24),('11288','2013-10-13','16:05:00',2.5),('11288','2013-10-13','16:10:00',2.18),('11288','2013-10-13','16:15:00',1.97),('11288','2013-10-13','16:20:00',2.1),('11288','2013-10-13','16:25:00',2.44),('11288','2013-10-13','16:30:00',2.32),('11288','2013-10-13','16:35:00',1.88),('11288','2013-10-13','16:40:00',1.58),('11288','2013-10-13','16:45:00',1.26),('11288','2013-10-13','16:50:00',1.29),('11288','2013-10-13','16:55:00',1.14),('11288','2013-10-13','17:20:00',1.01),('11288','2013-10-13','17:25:00',1.14),('11288','2013-10-12','10:50:00',1.06),('11288','2013-10-12','10:55:00',1.17),('11288','2013-10-12','11:00:00',1.32),('11288','2013-10-12','11:05:00',1.3),('11288','2013-10-12','11:10:00',1.49),('11288','2013-10-12','11:15:00',1.68),('11288','2013-10-12','11:20:00',1.96),('11288','2013-10-12','11:25:00',1.9),('11288','2013-10-12','11:30:00',2.47),('11288','2013-10-12','11:35:00',3.23),('11288','2013-10-12','11:40:00',4.66),('11288','2013-10-12','11:45:00',2.4),('11288','2013-10-12','11:50:00',2.37),('11288','2013-10-12','11:55:00',2.1),('11288','2013-10-12','12:00:00',1.41),('11288','2013-10-12','12:05:00',1.1),('11288','2013-10-12','12:10:00',1.36),('11288','2013-10-12','12:15:00',1.98),('11288','2013-10-12','12:20:00',3.46),('11288','2013-10-12','12:25:00',5.4),('11288','2013-10-12','12:30:00',4.19),('11288','2013-10-12','12:35:00',5.02),('11288','2013-10-12','12:40:00',4.71),('11288','2013-10-12','12:45:00',4.64),('11288','2013-10-12','12:50:00',4.45),('11288','2013-10-12','12:55:00',3.47),('11288','2013-10-12','13:00:00',2.85),('11288','2013-10-12','13:05:00',1.76),('11288','2013-10-12','13:10:00',1.42),('11288','2013-10-12','13:15:00',2.27),('11288','2013-10-12','13:20:00',2.32),('11288','2013-10-12','13:25:00',2.76),('11288','2013-10-12','13:30:00',5.91),('11288','2013-10-12','13:35:00',2.47),('11288','2013-10-12','13:55:00',1.09),('11288','2013-10-12','14:00:00',1.14),('11288','2013-10-12','15:10:00',1.09),('11288','2013-10-12','15:15:00',1.19),('11288','2013-10-12','15:20:00',1.27),('11288','2013-10-12','15:25:00',1.47),('11288','2013-10-12','15:30:00',1.53),('11288','2013-10-12','15:35:00',1.42),('11288','2013-10-12','15:40:00',1.27),('11288','2013-10-12','15:45:00',1.21),('11288','2013-10-12','15:50:00',1.36),('11288','2013-10-12','15:55:00',1.71),('11288','2013-10-12','16:00:00',1.96),('11288','2013-10-12','16:05:00',1.86),('11288','2013-10-12','16:10:00',1.94),('11288','2013-10-12','16:15:00',2.7),('11288','2013-10-12','16:20:00',2.93),('11288','2013-10-12','16:25:00',1.86),('11288','2013-10-12','16:30:00',1.22),('11288','2013-10-12','17:00:00',1.2),('11288','2013-10-11','09:05:00',1.01),('11288','2013-10-11','09:15:00',1.63),('11288','2013-10-11','09:20:00',1.36),('11288','2013-10-11','09:25:00',1.01),('11288','2013-10-11','09:30:00',1.01),('11288','2013-10-11','09:40:00',1.77),('11288','2013-10-11','09:45:00',2.87),('11288','2013-10-11','09:50:00',3.02),('11288','2013-10-11','09:55:00',3.13),('11288','2013-10-11','10:00:00',3.3),('11288','2013-10-11','10:05:00',3.45),('11288','2013-10-11','10:10:00',3.54),('11288','2013-10-11','10:15:00',2.87),('11288','2013-10-11','10:20:00',2.27),('11288','2013-10-11','10:25:00',3.03),('11288','2013-10-11','10:30:00',3.42),('11288','2013-10-11','10:35:00',3.57),('11288','2013-10-11','10:40:00',2.1),('11288','2013-10-11','10:45:00',1.41),('11288','2013-10-11','11:00:00',1.03),('11288','2013-10-11','11:05:00',4.12),('11288','2013-10-11','11:10:00',3.21),('11288','2013-10-11','11:15:00',1.73),('11288','2013-10-11','11:20:00',1.86),('11288','2013-10-11','11:25:00',1.8),('11288','2013-10-11','11:30:00',1.56),('11288','2013-10-11','11:35:00',2.07),('11288','2013-10-11','11:40:00',2.83),('11288','2013-10-11','11:45:00',3.04),('11288','2013-10-11','11:50:00',3.42),('11288','2013-10-11','11:55:00',3.09),('11288','2013-10-11','12:00:00',4.6),('11288','2013-10-11','12:05:00',4.59),('11288','2013-10-11','12:10:00',2.41),('11288','2013-10-11','12:15:00',1.9),('11288','2013-10-11','12:20:00',1.62),('11288','2013-10-11','12:25:00',2.53),('11288','2013-10-11','12:30:00',1.71),('11288','2013-10-11','13:00:00',1.38),('11288','2013-10-11','13:05:00',3.79),('11288','2013-10-11','13:10:00',3.47),('11288','2013-10-11','13:15:00',2.84),('11288','2013-10-11','13:20:00',3.31),('11288','2013-10-11','13:25:00',5.74),('11288','2013-10-11','13:30:00',2.54),('11288','2013-10-11','13:35:00',1.26),('11288','2013-10-11','13:40:00',3.83),('11288','2013-10-11','13:45:00',4.68),('11288','2013-10-11','13:50:00',1.18),('11288','2013-10-11','15:10:00',1.44),('11288','2013-10-11','15:30:00',1.76),('11288','2013-10-11','15:35:00',2.17),('11288','2013-10-11','15:40:00',2.62),('11288','2013-10-11','15:45:00',1.76),('11288','2013-10-11','15:50:00',1.19),('11288','2013-10-11','15:55:00',1.67),('11288','2013-10-11','16:00:00',3.28),('11288','2013-10-11','16:05:00',1.47),('11288','2013-10-11','16:10:00',1.21),('11288','2013-10-11','16:25:00',1.04),('11288','2013-10-11','16:30:00',1.44),('11288','2013-10-11','16:35:00',1.46),('11288','2013-10-11','17:00:00',1.47),('11288','2013-10-10','08:45:00',1.15),('11288','2013-10-10','08:50:00',1.2),('11288','2013-10-10','08:55:00',1.33),('11288','2013-10-10','09:00:00',1.3),('11288','2013-10-10','09:05:00',1.24),('11288','2013-10-10','09:10:00',2.04),('11288','2013-10-10','09:15:00',2.22),('11288','2013-10-10','09:20:00',2.27),('11288','2013-10-10','09:25:00',2.33),('11288','2013-10-10','09:30:00',2.35),('11288','2013-10-10','09:35:00',2),('11288','2013-10-10','09:40:00',2.37),('11288','2013-10-10','09:45:00',2.52),('11288','2013-10-10','09:50:00',2.41),('11288','2013-10-10','09:55:00',1.6),('11288','2013-10-10','10:10:00',2.79),('11288','2013-10-10','10:15:00',3.63),('11288','2013-10-10','10:20:00',3.69),('11288','2013-10-10','10:25:00',1.63),('11288','2013-10-10','10:30:00',2.03),('11288','2013-10-10','10:35:00',1.04),('11288','2013-10-10','10:40:00',3.85),('11288','2013-10-10','10:45:00',4.31),('11288','2013-10-10','10:50:00',3.42),('11288','2013-10-10','10:55:00',2.01),('11288','2013-10-10','11:05:00',1.27),('11288','2013-10-10','11:20:00',4.16),('11288','2013-10-10','11:25:00',3.85),('11288','2013-10-10','11:30:00',1.34),('11288','2013-10-10','11:35:00',3.73),('11288','2013-10-10','11:40:00',3.39),('11288','2013-10-10','11:45:00',1.08),('11288','2013-10-10','11:50:00',5.04),('11288','2013-10-10','11:55:00',5.73),('11288','2013-10-10','12:00:00',5.48),('11288','2013-10-10','12:05:00',5.7),('11288','2013-10-10','12:10:00',1.41),('11288','2013-10-10','12:15:00',1.01),('11288','2013-10-10','12:20:00',4.87),('11288','2013-10-10','12:25:00',4.92),('11288','2013-10-10','12:30:00',1.68),('11288','2013-10-10','12:35:00',6.33),('11288','2013-10-10','12:40:00',5.92),('11288','2013-10-10','12:45:00',4.11),('11288','2013-10-10','12:50:00',3.53),('11288','2013-10-10','12:55:00',6.24),('11288','2013-10-10','13:00:00',5.52),('11288','2013-10-10','13:05:00',6.1),('11288','2013-10-10','13:10:00',5.91),('11288','2013-10-10','13:15:00',3.79),('11288','2013-10-10','13:20:00',2.15),('11288','2013-10-10','13:25:00',6.52),('11288','2013-10-10','13:30:00',5.35),('11288','2013-10-10','13:35:00',4.77),('11288','2013-10-10','13:40:00',3.88),('11288','2013-10-10','13:45:00',4.52),('11288','2013-10-10','13:50:00',5.34),('11288','2013-10-10','13:55:00',5.45),('11288','2013-10-10','14:00:00',5.29),('11288','2013-10-10','14:05:00',5.35),('11288','2013-10-10','14:10:00',5.34),('11288','2013-10-10','14:15:00',2.72),('11288','2013-10-10','14:20:00',4.85),('11288','2013-10-10','14:25:00',5.63),('11288','2013-10-10','14:30:00',5.5),('11288','2013-10-10','14:35:00',5.52),('11288','2013-10-10','14:40:00',5.07),('11288','2013-10-10','14:45:00',4.87),('11288','2013-10-10','14:50:00',4.64),('11288','2013-10-10','14:55:00',4.45),('11288','2013-10-10','15:00:00',4.61),('11288','2013-10-10','15:05:00',3.68),('11288','2013-10-10','15:10:00',4.31),('11288','2013-10-10','15:15:00',3.2),('11288','2013-10-10','15:20:00',4.14),('11288','2013-10-10','15:25:00',2.2),('11288','2013-10-10','15:30:00',3.02),('11288','2013-10-10','15:35:00',1.53),('11288','2013-10-10','15:40:00',3.52),('11288','2013-10-10','15:45:00',2.17),('11288','2013-10-10','15:50:00',2.44),('11288','2013-10-10','15:55:00',3.41),('11288','2013-10-10','16:00:00',2.24),('11288','2013-10-10','16:05:00',1.44),('11288','2013-10-10','16:10:00',1.56),('11288','2013-10-10','16:15:00',2.18),('11288','2013-10-10','16:20:00',1.15),('11288','2013-10-10','16:25:00',2.44),('11288','2013-10-10','16:40:00',1.21),('11288','2013-10-10','16:45:00',1.53),('11288','2013-10-10','16:50:00',1.74),('11288','2013-10-10','16:55:00',1.59),('11288','2013-10-10','17:00:00',1.19),('11288','2013-10-10','17:15:00',1.32),('11288','2013-10-10','17:20:00',1.39),('11288','2013-10-09','08:30:00',1.03),('11288','2013-10-09','08:35:00',1.1),('11288','2013-10-09','08:40:00',1.2),('11288','2013-10-09','08:45:00',1.39),('11288','2013-10-09','08:50:00',1.48),('11288','2013-10-09','08:55:00',1.57),('11288','2013-10-09','09:00:00',1.69),('11288','2013-10-09','09:05:00',1.92),('11288','2013-10-09','09:10:00',2.07),('11288','2013-10-09','09:15:00',1.93),('11288','2013-10-09','09:20:00',2.14),('11288','2013-10-09','09:25:00',2.47),('11288','2013-10-09','09:30:00',2.65),('11288','2013-10-09','09:35:00',2.79),('11288','2013-10-09','09:40:00',3.01),('11288','2013-10-09','09:45:00',3.15),('11288','2013-10-09','09:50:00',3.25),('11288','2013-10-09','09:55:00',3.38),('11288','2013-10-09','10:00:00',3.7),('11288','2013-10-09','10:05:00',3.89),('11288','2013-10-09','10:10:00',3.1),('11288','2013-10-09','10:15:00',2.01),('11288','2013-10-09','10:20:00',1.48),('11288','2013-10-09','10:25:00',1.69),('11288','2013-10-09','10:30:00',1.87),('11288','2013-10-09','10:35:00',2.12),('11288','2013-10-09','10:40:00',2.41),('11288','2013-10-09','10:45:00',3.73),('11288','2013-10-09','10:50:00',5.08),('11288','2013-10-09','10:55:00',3.81),('11288','2013-10-09','11:00:00',4.47),('11288','2013-10-09','11:05:00',5.99),('11288','2013-10-09','11:10:00',5.99),('11288','2013-10-09','11:15:00',5.24),('11288','2013-10-09','11:20:00',3.48),('11288','2013-10-09','11:25:00',5.06),('11288','2013-10-09','11:30:00',6.07),('11288','2013-10-09','11:35:00',6.38),('11288','2013-10-09','11:40:00',5.51),('11288','2013-10-09','11:45:00',5.39),('11288','2013-10-09','11:50:00',4.77),('11288','2013-10-09','11:55:00',5.07),('11288','2013-10-09','12:00:00',2.36),('11288','2013-10-09','12:05:00',3.94),('11288','2013-10-09','12:10:00',5.05),('11288','2013-10-09','12:15:00',7.39),('11288','2013-10-09','12:20:00',5.84),('11288','2013-10-09','12:25:00',3.34),('11288','2013-10-09','12:30:00',4.14),('11288','2013-10-09','12:35:00',4.31),('11288','2013-10-09','12:40:00',2.11),('11288','2013-10-09','12:45:00',1.39),('11288','2013-10-09','12:50:00',1.39),('11288','2013-10-09','12:55:00',2.07),('11288','2013-10-09','13:00:00',1.62),('11288','2013-10-09','13:05:00',1.31),('11288','2013-10-09','13:10:00',2.11),('11288','2013-10-09','13:15:00',2.5),('11288','2013-10-09','13:20:00',3.79),('11288','2013-10-09','13:25:00',4.34),('11288','2013-10-09','13:30:00',4.25),('11288','2013-10-09','13:35:00',5.61),('11288','2013-10-09','13:40:00',4.14),('11288','2013-10-09','13:45:00',2.6),('11288','2013-10-09','13:50:00',4.85),('11288','2013-10-09','13:55:00',6.36),('11288','2013-10-09','14:00:00',2.84),('11288','2013-10-09','14:05:00',3.71),('11288','2013-10-09','14:10:00',1.33),('11288','2013-10-09','14:15:00',1.31),('11288','2013-10-09','14:25:00',1.06),('11288','2013-10-09','14:30:00',1.07),('11288','2013-10-09','14:45:00',1.14),('11288','2013-10-09','14:50:00',1.66),('11288','2013-10-09','14:55:00',2.07),('11288','2013-10-09','15:00:00',2.85),('11288','2013-10-09','15:05:00',5.23),('11288','2013-10-09','15:10:00',4.75),('11288','2013-10-09','15:15:00',4.36),('11288','2013-10-09','15:20:00',4.03),('11288','2013-10-09','15:25:00',3.72),('11288','2013-10-09','15:30:00',3.46),('11288','2013-10-09','15:35:00',4.69),('11288','2013-10-09','15:40:00',2.88),('11288','2013-10-09','15:45:00',2.1),('11288','2013-10-09','15:50:00',1.15),('11288','2013-10-09','16:05:00',1.07),('11288','2013-10-09','16:10:00',1.63),('11288','2013-10-09','16:15:00',1.82),('11288','2013-10-09','16:20:00',2.38),('11288','2013-10-09','16:25:00',2.2),('11288','2013-10-09','16:30:00',2.12),('11288','2013-10-09','16:35:00',2.14),('11288','2013-10-09','16:40:00',1.72),('11288','2013-10-09','17:25:00',1.37),('11288','2013-10-09','17:30:00',1.53),('11288','2013-10-09','17:35:00',1.59),('11288','2013-10-09','17:40:00',1.03),('11288','2014-04-15','08:00:00',1.3),('11288','2014-04-15','08:05:00',1.03),('11288','2014-04-15','08:50:00',1.05),('11288','2014-04-15','08:55:00',1.51),('11288','2014-04-15','09:00:00',2.85),('11288','2014-04-15','09:05:00',2.21),('11288','2014-04-15','09:10:00',3.1),('11288','2014-04-15','09:15:00',3.54),('11288','2014-04-15','09:20:00',4.07),('11288','2014-04-15','09:25:00',4.15),('11288','2014-04-15','09:30:00',2.4),('11288','2014-04-15','09:35:00',1.44),('11288','2014-04-15','09:40:00',1.27),('11288','2014-04-15','09:45:00',2.1),('11288','2014-04-15','09:50:00',2.75),('11288','2014-04-15','10:00:00',1.12),('11288','2014-04-15','10:05:00',3.75),('11288','2014-04-15','10:10:00',4.21),('11288','2014-04-15','10:15:00',2.95),('11288','2014-04-15','10:20:00',3.22),('11288','2014-04-15','10:25:00',4.28),('11288','2014-04-15','10:30:00',6),('11288','2014-04-15','10:35:00',3.46),('11288','2014-04-15','10:40:00',4.26),('11288','2014-04-15','10:45:00',4.01),('11288','2014-04-15','10:50:00',4),('11288','2014-04-15','10:55:00',2.51),('11288','2014-04-15','11:00:00',4.07),('11288','2014-04-15','11:05:00',3.38),('11288','2014-04-15','11:10:00',2.96),('11288','2014-04-15','11:15:00',2.64),('11288','2014-04-15','11:20:00',2.06),('11288','2014-04-15','11:25:00',2.27),('11288','2014-04-15','11:30:00',2.14),('11288','2014-04-15','11:35:00',1.64),('11288','2014-04-15','11:40:00',1.2),('11288','2014-04-15','11:45:00',2.15),('11288','2014-04-15','11:50:00',2.44),('11288','2014-04-15','11:55:00',1.77),('11288','2014-04-15','12:00:00',1.15),('11288','2014-04-15','12:05:00',1.5),('11288','2014-04-15','12:10:00',1.72),('11288','2014-04-15','12:15:00',2.87),('11288','2014-04-15','12:20:00',2.58),('11288','2014-04-15','12:25:00',1.54),('11288','2014-04-15','12:30:00',1.01),('11288','2014-04-15','12:35:00',1.33),('11288','2014-04-15','13:00:00',1.07),('11288','2014-04-15','13:05:00',2.03),('11288','2014-04-15','13:10:00',2.44),('11288','2014-04-15','13:15:00',4.48),('11288','2014-04-15','13:20:00',4.74),('11288','2014-04-15','13:25:00',4.02),('11288','2014-04-15','13:30:00',4.07),('11288','2014-04-15','13:35:00',5.21),('11288','2014-04-15','13:40:00',2.97),('11288','2014-04-15','13:45:00',1.19),('11288','2014-04-15','13:50:00',1.45),('11288','2014-04-15','13:55:00',1.56),('11288','2014-04-15','14:00:00',5.71),('11288','2014-04-15','14:05:00',2.64),('11288','2014-04-15','14:10:00',5.67),('11288','2014-04-15','14:15:00',4.4),('11288','2014-04-15','14:20:00',6.06),('11288','2014-04-15','14:25:00',5.84),('11288','2014-04-15','14:30:00',3.25),('11288','2014-04-15','14:35:00',2.53),('11288','2014-04-15','14:40:00',4.73),('11288','2014-04-15','14:45:00',4.23),('11288','2014-04-15','14:50:00',3.04),('11288','2014-04-15','14:55:00',2.05),('11288','2014-04-15','15:00:00',1.47),('11288','2014-04-15','15:05:00',1.64),('11288','2014-04-15','15:10:00',1.99),('11288','2014-04-15','15:15:00',2.95),('11288','2014-04-15','15:20:00',3.16),('11288','2014-04-15','15:25:00',3.38),('11288','2014-04-15','15:30:00',2.78),('11288','2014-04-15','15:35:00',2.59),('11288','2014-04-15','15:40:00',2.62),('11288','2014-04-15','15:45:00',2.43),('11288','2014-04-15','15:50:00',2.43),('11288','2014-04-15','15:55:00',2.71),('11288','2014-04-15','16:00:00',2.98),('11288','2014-04-15','16:05:00',2.55),('11288','2014-04-15','16:10:00',1.59),('11288','2014-04-15','16:15:00',1.21),('11288','2013-10-08','08:10:00',1.21),('11288','2013-10-08','08:15:00',1.58),('11288','2013-10-08','08:20:00',1.51),('11288','2013-10-08','08:25:00',1.27),('11288','2013-10-08','08:30:00',1.12),('11288','2013-10-08','09:55:00',1.13),('11288','2013-10-08','10:00:00',1.6),('11288','2013-10-08','10:05:00',1.73),('11288','2013-10-08','10:10:00',1.66),('11288','2013-10-08','10:15:00',1.53),('11288','2013-10-08','10:20:00',1.01),('11288','2013-10-08','10:55:00',1.96),('11288','2013-10-08','11:00:00',2.62),('11288','2013-10-08','11:05:00',2.02),('11288','2013-10-08','11:10:00',2.67),('11288','2013-10-08','11:15:00',4.61),('11288','2013-10-08','11:20:00',5.29),('11288','2013-10-08','11:25:00',3.25),('11288','2013-10-08','11:30:00',3.81),('11288','2013-10-08','11:35:00',3.53),('11288','2013-10-08','11:40:00',2.56),('11288','2013-10-08','11:45:00',2.25),('11288','2013-10-08','11:50:00',1.47),('11288','2013-10-08','11:55:00',1.13),('11288','2013-10-08','12:05:00',1.15),('11288','2013-10-08','12:10:00',1.43),('11288','2013-10-08','12:15:00',1.66),('11288','2013-10-08','12:20:00',1.92),('11288','2013-10-08','12:25:00',2.7),('11288','2013-10-08','12:30:00',3.47),('11288','2013-10-08','12:35:00',3.94),('11288','2013-10-08','12:40:00',6.63),('11288','2013-10-08','12:45:00',5.71),('11288','2013-10-08','12:50:00',5.52),('11288','2013-10-08','12:55:00',5.97),('11288','2013-10-08','13:00:00',5.31),('11288','2013-10-08','13:05:00',3.91),('11288','2013-10-08','13:10:00',2.73),('11288','2013-10-08','13:15:00',4.48),('11288','2013-10-08','13:20:00',2.46),('11288','2013-10-08','13:25:00',5.21),('11288','2013-10-08','13:30:00',3.34),('11288','2013-10-08','13:35:00',2.27),('11288','2013-10-08','13:40:00',1.92),('11288','2013-10-08','13:45:00',1.62),('11288','2013-10-08','13:50:00',1.35),('11288','2013-10-08','13:55:00',1.45),('11288','2013-10-08','14:00:00',1.33),('11288','2013-10-08','14:05:00',2.45),('11288','2013-10-08','14:10:00',3.06),('11288','2013-10-08','14:15:00',3.89),('11288','2013-10-08','14:20:00',4.14),('11288','2013-10-08','14:25:00',4.64),('11288','2013-10-08','14:30:00',3.79),('11288','2013-10-08','14:35:00',2.18),('11288','2013-10-08','14:40:00',2.48),('11288','2013-10-08','14:45:00',4.84),('11288','2013-10-08','14:50:00',5),('11288','2013-10-08','14:55:00',4.66),('11288','2013-10-08','15:00:00',4.52),('11288','2013-10-08','15:05:00',4.56),('11288','2013-10-08','15:10:00',4.47),('11288','2013-10-08','15:15:00',3.67),('11288','2013-10-08','15:20:00',4.53),('11288','2013-10-08','15:25:00',4.99),('11288','2013-10-08','15:30:00',4.93),('11288','2013-10-08','15:35:00',4.25),('11288','2013-10-08','15:40:00',2.14),('11288','2013-10-08','15:45:00',1.72),('11288','2013-10-08','15:50:00',2.79),('11288','2013-10-08','15:55:00',1.91),('11288','2013-10-08','16:00:00',1.59),('11288','2013-10-08','16:05:00',1.37),('11288','2013-10-08','16:30:00',1.39),('11288','2013-10-08','16:35:00',1.11),('11288','2013-10-08','16:40:00',1.1),('11288','2013-10-08','16:45:00',1.19),('11288','2013-10-08','16:50:00',1.03),('11288','2013-10-07','08:30:00',1.1),('11288','2013-10-07','08:35:00',1.11),('11288','2013-10-07','08:40:00',1.5),('11288','2013-10-07','08:45:00',1.05),('11288','2013-10-07','08:50:00',1.02),('11288','2013-10-07','08:55:00',1.24),('11288','2013-10-07','09:00:00',1.76),('11288','2013-10-07','09:05:00',1.51),('11288','2013-10-07','09:10:00',1.78),('11288','2013-10-07','09:15:00',2.25),('11288','2013-10-07','09:20:00',2.1),('11288','2013-10-07','09:25:00',2.49),('11288','2013-10-07','09:30:00',2.68),('11288','2013-10-07','09:35:00',2.73),('11288','2013-10-07','09:40:00',2.91),('11288','2013-10-07','09:45:00',3.04),('11288','2013-10-07','09:50:00',3.19),('11288','2013-10-07','09:55:00',3.25),('11288','2013-10-07','10:00:00',3.39),('11288','2013-10-07','10:05:00',3.42),('11288','2013-10-07','10:10:00',3.45),('11288','2013-10-07','10:15:00',3.67),('11288','2013-10-07','10:20:00',3.8),('11288','2013-10-07','10:25:00',3.8),('11288','2013-10-07','10:30:00',4.09),('11288','2013-10-07','10:35:00',4.46),('11288','2013-10-07','10:40:00',4.28),('11288','2013-10-07','10:45:00',4.32),('11288','2013-10-07','10:50:00',4.43),('11288','2013-10-07','10:55:00',3.9),('11288','2013-10-07','11:00:00',3.95),('11288','2013-10-07','11:05:00',4.72),('11288','2013-10-07','11:10:00',4.28),('11288','2013-10-07','11:15:00',4.51),('11288','2013-10-07','11:20:00',4.55),('11288','2013-10-07','11:25:00',4.79),('11288','2013-10-07','11:30:00',4.82),('11288','2013-10-07','11:35:00',4.9),('11288','2013-10-07','11:40:00',4.96),('11288','2013-10-07','11:45:00',5.03),('11288','2013-10-07','11:50:00',5.08),('11288','2013-10-07','11:55:00',5.13),('11288','2013-10-07','12:00:00',5.18),('11288','2013-10-07','12:05:00',5.41),('11288','2013-10-07','12:10:00',5.31),('11288','2013-10-07','12:15:00',1.54),('11288','2013-10-07','12:20:00',4.06),('11288','2013-10-07','12:25:00',5.99),('11288','2013-10-07','12:30:00',6.11),('11288','2013-10-07','12:35:00',5.74),('11288','2013-10-07','12:40:00',3.66),('11288','2013-10-07','12:45:00',5.79),('11288','2013-10-07','12:50:00',3.97),('11288','2013-10-07','12:55:00',5.94),('11288','2013-10-07','13:00:00',5.81),('11288','2013-10-07','13:05:00',5.64),('11288','2013-10-07','13:10:00',5.81),('11288','2013-10-07','13:15:00',5.1),('11288','2013-10-07','13:20:00',4.94),('11288','2013-10-07','13:25:00',2.67),('11288','2013-10-07','13:30:00',2.23),('11288','2013-10-07','13:35:00',3.82),('11288','2013-10-07','13:40:00',5.14),('11288','2013-10-07','13:45:00',2.18),('11288','2013-10-07','13:50:00',5.44),('11288','2013-10-07','13:55:00',5.73),('11288','2013-10-07','14:00:00',3.27),('11288','2013-10-07','14:05:00',2.52),('11288','2013-10-07','14:10:00',2.83),('11288','2013-10-07','14:15:00',1.56),('11288','2013-10-07','14:20:00',1.82),('11288','2013-10-07','14:25:00',1.44),('11288','2013-10-07','14:30:00',5.29),('11288','2013-10-07','14:35:00',5.89),('11288','2013-10-07','14:40:00',3.46),('11288','2013-10-07','14:45:00',5),('11288','2013-10-07','14:50:00',5.46),('11288','2013-10-07','14:55:00',5.32),('11288','2013-10-07','15:00:00',3.9),('11288','2013-10-07','15:05:00',4.81),('11288','2013-10-07','15:10:00',2.46),('11288','2013-10-07','15:15:00',4.72),('11288','2013-10-07','15:20:00',1.57),('11288','2013-10-07','15:25:00',4.04),('11288','2013-10-07','15:30:00',2.44),('11288','2013-10-07','15:35:00',2.19),('11288','2013-10-07','15:40:00',2.57),('11288','2013-10-07','15:45:00',4.56),('11288','2013-10-07','15:50:00',2.96),('11288','2013-10-07','15:55:00',1.21),('11288','2013-10-07','16:00:00',1.79),('11288','2013-10-07','16:05:00',3.22),('11288','2013-10-07','16:10:00',2.99),('11288','2013-10-07','16:15:00',3.04),('11288','2013-10-07','16:20:00',2.94),('11288','2013-10-07','16:25:00',2.77),('11288','2013-10-07','16:30:00',1.87),('11288','2013-10-07','16:35:00',2.32),('11288','2013-10-07','16:40:00',2.12),('11288','2013-10-07','16:45:00',2.25),('11288','2013-10-07','16:50:00',2.07),('11288','2013-10-07','16:55:00',1.76),('11288','2013-10-07','17:00:00',1.52),('11288','2013-10-07','17:05:00',1.47),('11288','2013-10-07','17:10:00',1.34),('11288','2013-10-07','17:15:00',1.13),('11288','2013-10-07','17:20:00',1.08),('11288','2013-10-06','09:00:00',1.14),('11288','2013-10-06','09:05:00',1.6),('11288','2013-10-06','09:10:00',1.32),('11288','2013-10-06','09:25:00',1.14),('11288','2013-10-06','09:30:00',1.63),('11288','2013-10-06','09:35:00',1.92),('11288','2013-10-06','09:40:00',2.03),('11288','2013-10-06','09:45:00',1.86),('11288','2013-10-06','09:50:00',3.11),('11288','2013-10-06','09:55:00',3.68),('11288','2013-10-06','10:00:00',4.17),('11288','2013-10-06','10:05:00',4.25),('11288','2013-10-06','10:10:00',4.23),('11288','2013-10-06','10:15:00',3.97),('11288','2013-10-06','10:20:00',4.04),('11288','2013-10-06','10:25:00',4.52),('11288','2013-10-06','10:30:00',4.47),('11288','2013-10-06','10:35:00',4.39),('11288','2013-10-06','10:40:00',3.63),('11288','2013-10-06','10:45:00',3.04),('11288','2013-10-06','10:50:00',3.59),('11288','2013-10-06','10:55:00',3.59),('11288','2013-10-06','11:00:00',3.89),('11288','2013-10-06','11:05:00',4.25),('11288','2013-10-06','11:10:00',4.35),('11288','2013-10-06','11:15:00',4.18),('11288','2013-10-06','11:20:00',4.44),('11288','2013-10-06','11:25:00',4.43),('11288','2013-10-06','11:30:00',4.36),('11288','2013-10-06','11:35:00',4.09),('11288','2013-10-06','11:40:00',2.97),('11288','2013-10-06','11:45:00',2.9),('11288','2013-10-06','11:50:00',2.51),('11288','2013-10-06','11:55:00',4),('11288','2013-10-06','12:00:00',4.05),('11288','2013-10-06','12:05:00',4.32),('11288','2013-10-06','12:10:00',5.24),('11288','2013-10-06','12:15:00',4.8),('11288','2013-10-06','12:20:00',4.09),('11288','2013-10-06','12:25:00',3.97),('11288','2013-10-06','12:30:00',3.33),('11288','2013-10-06','12:35:00',4.17),('11288','2013-10-06','12:40:00',4),('11288','2013-10-06','12:45:00',4.05),('11288','2013-10-06','12:50:00',4.42),('11288','2013-10-06','12:55:00',4.88),('11288','2013-10-06','13:00:00',4.6),('11288','2013-10-06','13:05:00',4.95),('11288','2013-10-06','13:10:00',4.79),('11288','2013-10-06','13:15:00',5.62),('11288','2013-10-06','13:20:00',2.39),('11288','2013-10-06','13:25:00',1.78),('11288','2013-10-06','13:30:00',1.32),('11288','2013-10-06','13:40:00',1.54),('11288','2013-10-06','13:45:00',3.16),('11288','2013-10-06','13:50:00',5.97),('11288','2013-10-06','13:55:00',5.5),('11288','2013-10-06','14:00:00',4.63),('11288','2013-10-06','14:05:00',3.26),('11288','2013-10-06','14:10:00',2.54),('11288','2013-10-06','14:15:00',2.23),('11288','2013-10-06','14:20:00',2.44),('11288','2013-10-06','14:25:00',2.6),('11288','2013-10-06','14:30:00',3.82),('11288','2013-10-06','14:35:00',3.67),('11288','2013-10-06','14:40:00',3.33),('11288','2013-10-06','14:45:00',2.79),('11288','2013-10-06','14:50:00',3.09),('11288','2013-10-06','14:55:00',3.98),('11288','2013-10-06','15:00:00',3.07),('11288','2013-10-06','15:05:00',2.36),('11288','2013-10-06','15:10:00',1.97),('11288','2013-10-06','15:15:00',1.96),('11288','2013-10-06','15:20:00',1.69),('11288','2013-10-06','15:25:00',1.35),('11288','2013-10-06','15:30:00',1.28),('11288','2013-10-06','15:35:00',1.33),('11288','2013-10-06','15:40:00',1.46),('11288','2013-10-06','15:45:00',1.55),('11288','2013-10-06','15:50:00',1.64),('11288','2013-10-06','15:55:00',1.99),('11288','2013-10-06','16:00:00',1.93),('11288','2013-10-06','16:05:00',1.3),('11288','2013-10-06','16:10:00',1.01),('11288','2013-10-06','17:05:00',1.02),('11288','2013-10-06','17:10:00',1.29),('11288','2013-10-06','17:15:00',1.37),('11288','2013-10-06','17:20:00',1.27),('11288','2013-10-06','17:25:00',1.04),('11288','2013-10-05','14:40:00',1.02),('11288','2013-10-05','14:45:00',1.06),('11288','2013-10-05','14:50:00',1.12),('11288','2013-10-05','14:55:00',1.06),('11288','2013-10-05','15:00:00',1.05),('11288','2013-10-05','15:05:00',1.09),('11288','2013-10-05','15:10:00',1.04),('11288','2013-10-05','15:15:00',1.02),('11288','2013-10-05','15:20:00',1.04),('11288','2013-10-05','15:25:00',1.07),('11288','2013-10-05','15:30:00',1.07),('11288','2013-10-05','15:35:00',1.18),('11288','2013-10-05','15:40:00',1.36),('11288','2013-10-05','15:45:00',1.4),('11288','2013-10-05','15:50:00',1.46),('11288','2013-10-05','15:55:00',1.59),('11288','2013-10-05','16:00:00',1.79),('11288','2013-10-05','16:05:00',2.13),('11288','2013-10-05','16:10:00',2.05),('11288','2013-10-05','16:15:00',1.89),('11288','2013-10-05','16:20:00',1.88),('11288','2013-10-05','16:25:00',1.81),('11288','2013-10-05','16:30:00',1.6),('11288','2013-10-05','16:35:00',1.5),('11288','2013-10-05','16:40:00',1.61),('11288','2013-10-05','16:45:00',1.49),('11288','2013-10-05','16:50:00',1.46),('11288','2013-10-05','16:55:00',1.31),('11288','2013-10-05','17:00:00',1.35),('11288','2013-10-05','17:05:00',1.27),('11288','2013-10-05','17:10:00',1.19),('11288','2013-10-05','17:15:00',1.18),('11288','2013-10-04','08:45:00',1.2),('11288','2013-10-04','08:50:00',1.08),('11288','2013-10-04','08:55:00',1.2),('11288','2013-10-04','09:00:00',1.04),('11288','2013-10-04','09:05:00',1.04),('11288','2013-10-04','09:10:00',1.17),('11288','2013-10-04','09:15:00',1.1),('11288','2013-10-04','09:20:00',1.27),('11288','2013-10-04','09:25:00',1.75),('11288','2013-10-04','09:30:00',1.85),('11288','2013-10-04','09:35:00',1.98),('11288','2013-10-04','09:40:00',1.93),('11288','2013-10-04','09:45:00',2),('11288','2013-10-04','09:50:00',2.42),('11288','2013-10-04','09:55:00',3.51),('11288','2013-10-04','10:00:00',3.22),('11288','2013-10-04','10:05:00',2.43),('11288','2013-10-04','10:10:00',2.52),('11288','2013-10-04','10:15:00',2.75),('11288','2013-10-04','10:20:00',2.57),('11288','2013-10-04','10:25:00',2.95),('11288','2013-10-04','10:30:00',3.51),('11288','2013-10-04','10:35:00',3.66),('11288','2013-10-04','10:40:00',3.83),('11288','2013-10-04','10:45:00',4.08),('11288','2013-10-04','10:50:00',3.18),('11288','2013-10-04','10:55:00',3.71),('11288','2013-10-04','11:00:00',3.31),('11288','2013-10-04','11:05:00',2.8),('11288','2013-10-04','11:10:00',2.69),('11288','2013-10-04','11:15:00',4.24),('11288','2013-10-04','11:20:00',4.28),('11288','2013-10-04','11:25:00',4.56),('11288','2013-10-04','11:30:00',5.56),('11288','2013-10-04','11:35:00',5.12),('11288','2013-10-04','11:40:00',5.33),('11288','2013-10-04','11:45:00',5.3),('11288','2013-10-04','11:50:00',5.33),('11288','2013-10-04','11:55:00',5.38),('11288','2013-10-04','12:00:00',5.42),('11288','2013-10-04','12:05:00',5.52),('11288','2013-10-04','12:10:00',5.54),('11288','2013-10-04','12:15:00',5.27),('11288','2013-10-04','12:20:00',5.18),('11288','2013-10-04','12:25:00',5.65),('11288','2013-10-04','12:30:00',5.82),('11288','2013-10-04','12:35:00',5.51),('11288','2013-10-04','12:40:00',5.44),('11288','2013-10-04','12:45:00',5.51),('11288','2013-10-04','12:50:00',5.39),('11288','2013-10-04','12:55:00',5.36),('11288','2013-10-04','13:00:00',5.39),('11288','2013-10-04','13:05:00',5.49),('11288','2013-10-04','13:10:00',5.55),('11288','2013-10-04','13:15:00',5.78),('11288','2013-10-04','13:20:00',5.6),('11288','2013-10-04','13:25:00',5.23),('11288','2013-10-04','13:30:00',5.64),('11288','2013-10-04','13:35:00',5.65),('11288','2013-10-04','13:40:00',5.3),('11288','2013-10-04','13:45:00',5.26),('11288','2013-10-04','13:50:00',5.21),('11288','2013-10-04','13:55:00',5.1),('11288','2013-10-04','14:00:00',5.09),('11288','2013-10-04','14:05:00',5.09),('11288','2013-10-04','14:10:00',4.6),('11288','2013-10-04','14:15:00',3.8),('11288','2013-10-04','14:20:00',4.77),('11288','2013-10-04','14:25:00',4.83),('11288','2013-10-04','14:30:00',4.23),('11288','2013-10-04','14:35:00',2.98),('11288','2013-10-04','14:40:00',2.56),('11288','2013-10-04','14:45:00',3.14),('11288','2013-10-04','14:50:00',3.98),('11288','2013-10-04','14:55:00',3.84),('11288','2013-10-04','15:00:00',3.29),('11288','2013-10-04','15:05:00',3.68),('11288','2013-10-04','15:10:00',3.05),('11288','2013-10-04','15:15:00',2.53),('11288','2013-10-04','15:20:00',2.21),('11288','2013-10-04','15:25:00',4.04),('11288','2013-10-04','15:30:00',3.23),('11288','2013-10-04','15:35:00',1.93),('11288','2013-10-04','15:40:00',1.48),('11288','2013-10-04','15:45:00',1.29),('11288','2013-10-04','15:50:00',1.26),('11288','2013-10-04','15:55:00',1.48),('11288','2013-10-04','16:00:00',1.83),('11288','2013-10-04','16:05:00',1.96),('11288','2013-10-04','16:10:00',1.77),('11288','2013-10-04','16:15:00',1.57),('11288','2013-10-04','16:20:00',1.35),('11288','2013-10-04','16:25:00',1.15),('11288','2013-10-04','16:30:00',1.08),('11288','2013-10-04','16:35:00',1.1),('11288','2013-10-04','16:40:00',1.05),('11288','2013-10-03','08:30:00',1.04),('11288','2013-10-03','08:35:00',1.19),('11288','2013-10-03','08:40:00',1.33),('11288','2013-10-03','08:45:00',1.5),('11288','2013-10-03','08:50:00',1.6),('11288','2013-10-03','08:55:00',1.76),('11288','2013-10-03','09:00:00',1.99),('11288','2013-10-03','09:05:00',2.13),('11288','2013-10-03','09:10:00',2.31),('11288','2013-10-03','09:15:00',2.47),('11288','2013-10-03','09:20:00',2.65),('11288','2013-10-03','09:25:00',2.65),('11288','2013-10-03','09:30:00',2.65),('11288','2013-10-03','09:35:00',3.09),('11288','2013-10-03','09:40:00',3.25),('11288','2013-10-03','09:45:00',3.4),('11288','2013-10-03','09:50:00',3.53),('11288','2013-10-03','09:55:00',3.65),('11288','2013-10-03','10:00:00',3.77),('11288','2013-10-03','10:05:00',3.93),('11288','2013-10-03','10:10:00',4),('11288','2013-10-03','10:15:00',4.1),('11288','2013-10-03','10:20:00',4.28),('11288','2013-10-03','10:25:00',4.43),('11288','2013-10-03','10:30:00',4.53),('11288','2013-10-03','10:35:00',4.65),('11288','2013-10-03','10:40:00',4.74),('11288','2013-10-03','10:45:00',4.83),('11288','2013-10-03','10:50:00',4.89),('11288','2013-10-03','10:55:00',4.97),('11288','2013-10-03','11:00:00',5.02),('11288','2013-10-03','11:05:00',5.1),('11288','2013-10-03','11:10:00',5.17),('11288','2013-10-03','11:15:00',5.22),('11288','2013-10-03','11:20:00',5.28),('11288','2013-10-03','11:25:00',5.34),('11288','2013-10-03','11:30:00',5.36),('11288','2013-10-03','11:35:00',5.44),('11288','2013-10-03','11:40:00',5.54),('11288','2013-10-03','11:45:00',5.57),('11288','2013-10-03','11:50:00',5.62),('11288','2013-10-03','11:55:00',5.71),('11288','2013-10-03','12:00:00',5.74),('11288','2013-10-03','12:05:00',5.78),('11288','2013-10-03','12:10:00',5.83),('11288','2013-10-03','12:15:00',5.82),('11288','2013-10-03','12:20:00',5.83),('11288','2013-10-03','12:25:00',5.86),('11288','2013-10-03','12:30:00',5.87),('11288','2013-10-03','12:35:00',5.89),('11288','2013-10-03','12:40:00',5.88),('11288','2013-10-03','12:45:00',5.89),('11288','2013-10-03','12:50:00',5.9),('11288','2013-10-03','12:55:00',5.89),('11288','2013-10-03','13:00:00',5.86),('11288','2013-10-03','13:05:00',5.75),('11288','2013-10-03','13:10:00',5.81),('11288','2013-10-03','13:15:00',5.83),('11288','2013-10-03','13:20:00',5.83),('11288','2013-10-03','13:25:00',5.79),('11288','2013-10-03','13:30:00',5.78),('11288','2013-10-03','13:35:00',5.77),('11288','2013-10-03','13:40:00',5.74),('11288','2013-10-03','13:45:00',5.66),('11288','2013-10-03','13:50:00',5.61),('11288','2013-10-03','13:55:00',5.61),('11288','2013-10-03','14:00:00',5.64),('11288','2013-10-03','14:05:00',5.59),('11288','2013-10-03','14:10:00',5.54),('11288','2013-10-03','14:15:00',5.44),('11288','2013-10-03','14:20:00',5.31),('11288','2013-10-03','14:25:00',5.29),('11288','2013-10-03','14:30:00',5.27),('11288','2013-10-03','14:35:00',5.16),('11288','2013-10-03','14:40:00',5.09),('11288','2013-10-03','14:45:00',5.05),('11288','2013-10-03','14:50:00',4.99),('11288','2013-10-03','14:55:00',4.88),('11288','2013-10-03','15:00:00',4.76),('11288','2013-10-03','15:05:00',4.67),('11288','2013-10-03','15:10:00',4.59),('11288','2013-10-03','15:15:00',4.54),('11288','2013-10-03','15:20:00',4.44),('11288','2013-10-03','15:25:00',4.27),('11288','2013-10-03','15:30:00',4.18),('11288','2013-10-03','15:35:00',4.11),('11288','2013-10-03','15:40:00',3.98),('11288','2013-10-03','15:45:00',3.83),('11288','2013-10-03','15:50:00',3.72),('11288','2013-10-03','15:55:00',3.59),('11288','2013-10-03','16:00:00',3.46),('11288','2013-10-03','16:05:00',3.32),('11288','2013-10-03','16:10:00',3.22),('11288','2013-10-03','16:15:00',3.06),('11288','2013-10-03','16:20:00',2.92),('11288','2013-10-03','16:25:00',2.79),('11288','2013-10-03','16:30:00',2.68),('11288','2013-10-03','16:35:00',2.53),('11288','2013-10-03','16:40:00',2.4),('11288','2013-10-03','16:45:00',2.25),('11288','2013-10-03','16:50:00',2.04),('11288','2013-10-03','16:55:00',1.97),('11288','2013-10-03','17:00:00',1.81),('11288','2013-10-03','17:05:00',1.67),('11288','2013-10-03','17:10:00',1.53),('11288','2013-10-03','17:15:00',1.38),('11288','2013-10-03','17:20:00',1.28),('11288','2013-10-03','17:25:00',1.14),('11288','2013-10-03','17:30:00',1.03),('11288','2013-10-02','08:20:00',1.18),('11288','2013-10-02','08:25:00',1.15),('11288','2013-10-02','08:30:00',1.16),('11288','2013-10-02','08:35:00',1.13),('11288','2013-10-02','08:40:00',1.24),('11288','2013-10-02','08:45:00',1.38),('11288','2013-10-02','08:50:00',1.57),('11288','2013-10-02','08:55:00',1.61),('11288','2013-10-02','09:00:00',1.89),('11288','2013-10-02','09:05:00',2.03),('11288','2013-10-02','09:10:00',2.18),('11288','2013-10-02','09:15:00',2.34),('11288','2013-10-02','09:20:00',2.5),('11288','2013-10-02','09:25:00',2.54),('11288','2013-10-02','09:30:00',2.64),('11288','2013-10-02','09:35:00',2.94),('11288','2013-10-02','09:40:00',3.1),('11288','2013-10-02','09:45:00',3.21),('11288','2013-10-02','09:50:00',3.34),('11288','2013-10-02','09:55:00',3.45),('11288','2013-10-02','10:00:00',3.54),('11288','2013-10-02','10:05:00',3.65),('11288','2013-10-02','10:10:00',3.72),('11288','2013-10-02','10:15:00',3.81),('11288','2013-10-02','10:20:00',3.98),('11288','2013-10-02','10:25:00',4.13),('11288','2013-10-02','10:30:00',4.25),('11288','2013-10-02','10:35:00',4.36),('11288','2013-10-02','10:40:00',4.45),('11288','2013-10-02','10:45:00',4.58),('11288','2013-10-02','10:50:00',4.67),('11288','2013-10-02','10:55:00',4.75),('11288','2013-10-02','11:00:00',4.81),('11288','2013-10-02','11:05:00',4.9),('11288','2013-10-02','11:10:00',4.96),('11288','2013-10-02','11:15:00',5.01),('11288','2013-10-02','11:20:00',5.06),('11288','2013-10-02','11:25:00',5.1),('11288','2013-10-02','11:30:00',5.13),('11288','2013-10-02','11:35:00',5.22),('11288','2013-10-02','11:40:00',5.27),('11288','2013-10-02','11:45:00',5.3),('11288','2013-10-02','11:50:00',5.35),('11288','2013-10-02','11:55:00',5.41),('11288','2013-10-02','12:00:00',5.47),('11288','2013-10-02','12:05:00',5.55),('11288','2013-10-02','12:10:00',5.6),('11288','2013-10-02','12:15:00',5.62),('11288','2013-10-02','12:20:00',5.65),('11288','2013-10-02','12:25:00',5.63),('11288','2013-10-02','12:30:00',5.62),('11288','2013-10-02','12:35:00',5.58),('11288','2013-10-02','12:40:00',5.66),('11288','2013-10-02','12:45:00',5.67),('11288','2013-10-02','12:50:00',5.66),('11288','2013-10-02','12:55:00',5.64),('11288','2013-10-02','13:00:00',5.65),('11288','2013-10-02','13:05:00',5.69),('11288','2013-10-02','13:10:00',5.67),('11288','2013-10-02','13:15:00',5.67),('11288','2013-10-02','13:20:00',5.66),('11288','2013-10-02','13:25:00',5.66),('11288','2013-10-02','13:30:00',5.63),('11288','2013-10-02','13:35:00',5.62),('11288','2013-10-02','13:40:00',5.59),('11288','2013-10-02','13:45:00',5.53),('11288','2013-10-02','13:50:00',5.43),('11288','2013-10-02','13:55:00',5.47),('11288','2013-10-02','14:00:00',5.44),('11288','2013-10-02','14:05:00',5.44),('11288','2013-10-02','14:10:00',5.39),('11288','2013-10-02','14:15:00',5.33),('11288','2013-10-02','14:20:00',5.26),('11288','2013-10-02','14:25:00',5.21),('11288','2013-10-02','14:30:00',5.15),('11288','2013-10-02','14:35:00',5.08),('11288','2013-10-02','14:40:00',4.99),('11288','2013-10-02','14:45:00',4.94),('11288','2013-10-02','14:50:00',4.85),('11288','2013-10-02','14:55:00',4.81),('11288','2013-10-02','15:00:00',4.69),('11288','2013-10-02','15:05:00',4.6),('11288','2013-10-02','15:10:00',4.52),('11288','2013-10-02','15:15:00',4.46),('11288','2013-10-02','15:20:00',4.34),('11288','2013-10-02','15:25:00',4.17),('11288','2013-10-02','15:30:00',4.08),('11288','2013-10-02','15:35:00',4),('11288','2013-10-02','15:40:00',3.88),('11288','2013-10-02','15:45:00',3.75),('11288','2013-10-02','15:50:00',3.66),('11288','2013-10-02','15:55:00',3.54),('11288','2013-10-02','16:00:00',3.42),('11288','2013-10-02','16:05:00',3.29),('11288','2013-10-02','16:10:00',3.17),('11288','2013-10-02','16:15:00',3.02),('11288','2013-10-02','16:20:00',2.88),('11288','2013-10-02','16:25:00',2.74),('11288','2013-10-02','16:30:00',2.63),('11288','2013-10-02','16:35:00',2.48),('11288','2013-10-02','16:40:00',2.37),('11288','2013-10-02','16:45:00',2.22),('11288','2013-10-02','16:50:00',2.03),('11288','2013-10-02','16:55:00',1.94),('11288','2013-10-02','17:00:00',1.79),('11288','2013-10-02','17:05:00',1.67),('11288','2013-10-02','17:10:00',1.5),('11288','2013-10-02','17:15:00',1.4),('11288','2013-10-02','17:20:00',1.27),('11288','2013-10-02','17:25:00',1.16),('11288','2013-10-02','17:30:00',1.03),('11288','2013-10-01','08:25:00',1.04),('11288','2013-10-01','08:30:00',1.07),('11288','2013-10-01','08:35:00',1.19),('11288','2013-10-01','08:40:00',1.32),('11288','2013-10-01','08:45:00',1.47),('11288','2013-10-01','08:50:00',1.67),('11288','2013-10-01','08:55:00',1.7),('11288','2013-10-01','09:00:00',1.89),('11288','2013-10-01','09:05:00',2.07),('11288','2013-10-01','09:10:00',2.22),('11288','2013-10-01','09:15:00',2.34),('11288','2013-10-01','09:20:00',2.52),('11288','2013-10-01','09:25:00',2.6),('11288','2013-10-01','09:30:00',2.61),('11288','2013-10-01','09:35:00',2.84),('11288','2013-10-01','09:40:00',3.09),('11288','2013-10-01','09:45:00',3.23),('11288','2013-10-01','09:50:00',3.3),('11288','2013-10-01','09:55:00',3.41),('11288','2013-10-01','10:00:00',3.47),('11288','2013-10-01','10:05:00',3.64),('11288','2013-10-01','10:10:00',3.75),('11288','2013-10-01','10:15:00',3.84),('11288','2013-10-01','10:20:00',4),('11288','2013-10-01','10:25:00',3.97),('11288','2013-10-01','10:30:00',4.27),('11288','2013-10-01','10:35:00',4.32),('11288','2013-10-01','10:40:00',4.36),('11288','2013-10-01','10:45:00',4.46),('11288','2013-10-01','10:50:00',4.55),('11288','2013-10-01','10:55:00',4.67),('11288','2013-10-01','11:00:00',4.86),('11288','2013-10-01','11:05:00',3.57),('11288','2013-10-01','11:10:00',4.49),('11288','2013-10-01','11:15:00',5.35),('11288','2013-10-01','11:20:00',2.52),('11288','2013-10-01','11:25:00',1.28),('11288','2013-10-01','11:30:00',3.18),('11288','2013-10-01','11:35:00',5.45),('11288','2013-10-01','11:40:00',5.48),('11288','2013-10-01','11:45:00',5.53),('11288','2013-10-01','11:50:00',3.16),('11288','2013-10-01','11:55:00',1.24),('11288','2013-10-01','12:00:00',2.68),('11288','2013-10-01','12:05:00',1.52),('11288','2013-10-01','12:10:00',5.23),('11288','2013-10-01','12:15:00',5.49),('11288','2013-10-01','12:20:00',5.98),('11288','2013-10-01','12:25:00',5.99),('11288','2013-10-01','12:30:00',5.84),('11288','2013-10-01','12:35:00',1.74),('11288','2013-10-01','12:40:00',2.24),('11288','2013-10-01','12:45:00',2.8),('11288','2013-10-01','12:50:00',1.97),('11288','2013-10-01','12:55:00',2.39),('11288','2013-10-01','13:00:00',6.19),('11288','2013-10-01','13:05:00',3.65),('11288','2013-10-01','13:10:00',1.73),('11288','2013-10-01','13:15:00',3.79),('11288','2013-10-01','13:20:00',6.27),('11288','2013-10-01','13:25:00',4.55),('11288','2013-10-01','13:30:00',5.7),('11288','2013-10-01','13:35:00',6.2),('11288','2013-10-01','13:40:00',5.95),('11288','2013-10-01','13:45:00',5.3),('11288','2013-10-01','13:50:00',5.21),('11288','2013-10-01','13:55:00',5.36),('11288','2013-10-01','14:00:00',5.26),('11288','2013-10-01','14:05:00',5.24),('11288','2013-10-01','14:10:00',5.11),('11288','2013-10-01','14:15:00',5.1),('11288','2013-10-01','14:20:00',5.12),('11288','2013-10-01','14:25:00',5),('11288','2013-10-01','14:30:00',5.01),('11288','2013-10-01','14:35:00',5),('11288','2013-10-01','14:40:00',4.92),('11288','2013-10-01','14:45:00',5.03),('11288','2013-10-01','14:50:00',5),('11288','2013-10-01','14:55:00',4.91),('11288','2013-10-01','15:00:00',4.69),('11288','2013-10-01','15:05:00',4.54),('11288','2013-10-01','15:10:00',4.46),('11288','2013-10-01','15:15:00',4.4),('11288','2013-10-01','15:20:00',4.3),('11288','2013-10-01','15:25:00',4.17),('11288','2013-10-01','15:30:00',4.07),('11288','2013-10-01','15:35:00',4.01),('11288','2013-10-01','15:40:00',3.9),('11288','2013-10-01','15:45:00',3.74),('11288','2013-10-01','15:50:00',3.63),('11288','2013-10-01','15:55:00',3.5),('11288','2013-10-01','16:00:00',3.38),('11288','2013-10-01','16:05:00',3.24),('11288','2013-10-01','16:10:00',3.16),('11288','2013-10-01','16:15:00',3.03),('11288','2013-10-01','16:20:00',2.9),('11288','2013-10-01','16:25:00',2.77),('11288','2013-10-01','16:30:00',2.65),('11288','2013-10-01','16:35:00',2.5),('11288','2013-10-01','16:40:00',2.35),('11288','2013-10-01','16:45:00',2.23),('11288','2013-10-01','16:50:00',2.09),('11288','2013-10-01','16:55:00',1.99),('11288','2013-10-01','17:00:00',1.83),('11288','2013-10-01','17:05:00',1.7),('11288','2013-10-01','17:10:00',1.52),('11288','2013-10-01','17:15:00',1.43),('11288','2013-10-01','17:20:00',1.29),('11288','2013-10-01','17:25:00',1.22),('11288','2013-10-01','17:30:00',1.07),('11288','2013-09-30','09:35:00',1.11),('11288','2013-09-30','09:40:00',1.23),('11288','2013-09-30','09:45:00',1.62),('11288','2013-09-30','09:50:00',2.01),('11288','2013-09-30','09:55:00',1.78),('11288','2013-09-30','10:00:00',1.71),('11288','2013-09-30','10:05:00',1.72),('11288','2013-09-30','10:10:00',1.88),('11288','2013-09-30','10:15:00',1.9),('11288','2013-09-30','10:20:00',1.93),('11288','2013-09-30','10:25:00',2.11),('11288','2013-09-30','10:30:00',2.34),('11288','2013-09-30','10:35:00',2.6),('11288','2013-09-30','10:40:00',3.43),('11288','2013-09-30','10:45:00',4.95),('11288','2013-09-30','10:50:00',4.94),('11288','2013-09-30','10:55:00',4.42),('11288','2013-09-30','11:00:00',3.98),('11288','2013-09-30','11:05:00',2.06),('11288','2013-09-30','11:10:00',3.58),('11288','2013-09-30','11:15:00',3.8),('11288','2013-09-30','11:20:00',4.28),('11288','2013-09-30','11:25:00',3.81),('11288','2013-09-30','11:30:00',3.38),('11288','2013-09-30','11:35:00',2.76),('11288','2013-09-30','11:40:00',5.05),('11288','2013-09-30','11:45:00',2.38),('11288','2013-09-30','11:50:00',2.42),('11288','2013-09-30','11:55:00',2.22),('11288','2013-09-30','12:00:00',3.1),('11288','2013-09-30','12:05:00',1.49),('11288','2013-09-30','12:10:00',2.93),('11288','2013-09-30','12:15:00',6.06),('11288','2013-09-30','12:20:00',6.06),('11288','2013-09-30','12:25:00',5.96),('11288','2013-09-30','12:30:00',5.82),('11288','2013-09-30','12:35:00',5.72),('11288','2013-09-30','12:40:00',5.66),('11288','2013-09-30','12:45:00',4.62),('11288','2013-09-30','12:50:00',6.02),('11288','2013-09-30','12:55:00',5.91),('11288','2013-09-30','13:00:00',5.97),('11288','2013-09-30','13:05:00',6.08),('11288','2013-09-30','13:10:00',5.97),('11288','2013-09-30','13:15:00',6.35),('11288','2013-09-30','13:20:00',6.36),('11288','2013-09-30','13:25:00',6.77),('11288','2013-09-30','13:30:00',6.35),('11288','2013-09-30','13:35:00',5.79),('11288','2013-09-30','13:40:00',5.49),('11288','2013-09-30','13:45:00',2.45),('11288','2013-09-30','13:50:00',4.69),('11288','2013-09-30','13:55:00',4.37),('11288','2013-09-30','14:00:00',3.32),('11288','2013-09-30','14:05:00',2.21),('11288','2013-09-30','14:10:00',2.21),('11288','2013-09-30','14:15:00',2.1),('11288','2013-09-30','14:20:00',1.82),('11288','2013-09-30','14:25:00',2.08),('11288','2013-09-30','14:30:00',4.78),('11288','2013-09-30','14:35:00',4.06),('11288','2013-09-30','14:40:00',5.41),('11288','2013-09-30','14:45:00',5.9),('11288','2013-09-30','14:50:00',3.82),('11288','2013-09-30','14:55:00',3.9),('11288','2013-09-30','15:00:00',3.21),('11288','2013-09-30','15:05:00',4.5),('11288','2013-09-30','15:10:00',5.81),('11288','2013-09-30','15:15:00',4.01),('11288','2013-09-30','15:20:00',3.27),('11288','2013-09-30','15:25:00',3.94),('11288','2013-09-30','15:30:00',3.89),('11288','2013-09-30','15:35:00',5.22),('11288','2013-09-30','15:40:00',4.81),('11288','2013-09-30','15:45:00',2.65),('11288','2013-09-30','16:10:00',1.8),('11288','2013-09-30','16:15:00',2.36),('11288','2013-09-30','16:20:00',2.8),('11288','2013-09-30','16:25:00',1.63),('11288','2013-09-30','16:30:00',1.13),('11288','2013-09-30','16:40:00',1.35),('11288','2013-09-30','16:45:00',2),('11288','2013-09-30','16:50:00',1.15),('11288','2013-09-30','16:55:00',1.69),('11288','2013-09-30','17:00:00',1.45),('11288','2013-09-30','17:05:00',1.26),('11288','2013-09-30','17:10:00',1.1),('11288','2013-09-30','17:15:00',1.37),('11288','2013-09-30','17:20:00',1.39),('11288','2013-09-30','17:25:00',1.19),('11288','2013-09-29','08:40:00',1.23),('11288','2013-09-29','08:45:00',1.59),('11288','2013-09-29','08:50:00',1.99),('11288','2013-09-29','08:55:00',1.69),('11288','2013-09-29','09:00:00',1.66),('11288','2013-09-29','09:05:00',1.4),('11288','2013-09-29','09:10:00',1.7),('11288','2013-09-29','09:15:00',1.83),('11288','2013-09-29','09:20:00',1.5),('11288','2013-09-29','09:25:00',1.56),('11288','2013-09-29','09:30:00',1.51),('11288','2013-09-29','09:35:00',1.45),('11288','2013-09-29','09:40:00',1.42),('11288','2013-09-29','09:45:00',1.6),('11288','2013-09-29','09:50:00',1.68),('11288','2013-09-29','09:55:00',1.76),('11288','2013-09-29','10:00:00',1.99),('11288','2013-09-29','10:05:00',2.6),('11288','2013-09-29','10:10:00',3.1),('11288','2013-09-29','10:15:00',3.87),('11288','2013-09-29','10:20:00',3.23),('11288','2013-09-29','10:25:00',3.1),('11288','2013-09-29','10:30:00',3.51),('11288','2013-09-29','10:35:00',3.63),('11288','2013-09-29','10:40:00',3.41),('11288','2013-09-29','10:45:00',3.98),('11288','2013-09-29','10:50:00',4.2),('11288','2013-09-29','10:55:00',4.21),('11288','2013-09-29','11:00:00',4.26),('11288','2013-09-29','11:05:00',4.12),('11288','2013-09-29','11:10:00',4.11),('11288','2013-09-29','11:15:00',4.45),('11288','2013-09-29','11:20:00',4.37),('11288','2013-09-29','11:25:00',4.13),('11288','2013-09-29','11:30:00',4.49),('11288','2013-09-29','11:35:00',4.4),('11288','2013-09-29','11:40:00',4.6),('11288','2013-09-29','11:45:00',4.75),('11288','2013-09-29','11:50:00',4.91),('11288','2013-09-29','11:55:00',4.97),('11288','2013-09-29','12:00:00',4.39),('11288','2013-09-29','12:05:00',3.14),('11288','2013-09-29','12:10:00',5.45),('11288','2013-09-29','12:15:00',5.75),('11288','2013-09-29','12:20:00',2.93),('11288','2013-09-29','12:25:00',2.81),('11288','2013-09-29','12:30:00',3.07),('11288','2013-09-29','12:35:00',2.93),('11288','2013-09-29','12:40:00',2.64),('11288','2013-09-29','12:45:00',2.33),('11288','2013-09-29','12:50:00',2.31),('11288','2013-09-29','12:55:00',2.08),('11288','2013-09-29','13:00:00',2),('11288','2013-09-29','13:05:00',1.79),('11288','2013-09-29','13:10:00',1.79),('11288','2013-09-29','13:15:00',1.35),('11288','2013-09-29','13:20:00',1.68),('11288','2013-09-29','13:25:00',2.47),('11288','2013-09-29','13:30:00',2.8),('11288','2013-09-29','13:35:00',3.25),('11288','2013-09-29','13:40:00',2.86),('11288','2013-09-29','13:45:00',2.59),('11288','2013-09-29','13:50:00',2.89),('11288','2013-09-29','13:55:00',3.2),('11288','2013-09-29','14:00:00',3.14),('11288','2013-09-29','14:05:00',3.35),('11288','2013-09-29','14:10:00',2.15),('11288','2013-09-29','14:15:00',2.93),('11288','2013-09-29','14:20:00',4.6),('11288','2013-09-29','14:25:00',2.45),('11288','2013-09-29','14:30:00',2.87),('11288','2013-09-29','14:35:00',2.1),('11288','2013-09-29','14:40:00',1.68),('11288','2013-09-29','14:45:00',1.27),('11288','2013-09-29','14:50:00',1.63),('11288','2013-09-29','14:55:00',1.75),('11288','2013-09-29','15:00:00',1.91),('11288','2013-09-29','15:15:00',1.16),('11288','2013-09-29','15:20:00',1.68),('11288','2013-09-29','15:25:00',1.53),('11288','2013-09-29','15:30:00',1.37),('11288','2013-09-29','15:35:00',1.28),('11288','2013-09-29','15:40:00',1.42),('11288','2013-09-29','15:45:00',1.22),('11288','2013-09-29','15:50:00',1.03),('11288','2013-09-29','15:55:00',1.7),('11288','2013-09-29','16:00:00',1.99),('11288','2013-09-29','16:05:00',1.67),('11288','2013-09-29','16:10:00',1.22),('11288','2013-09-29','16:15:00',1.11),('11288','2013-09-29','16:20:00',1.31),('11288','2013-09-29','16:25:00',1.55),('11288','2013-09-29','16:30:00',2.02),('11288','2013-09-29','16:35:00',1.79),('11288','2013-09-29','16:40:00',1.49),('11288','2013-09-29','16:45:00',1.41),('11288','2013-09-29','17:05:00',1.1),('11288','2014-04-14','07:55:00',1.1),('11288','2014-04-14','08:00:00',1.2),('11288','2014-04-14','08:05:00',1.24),('11288','2014-04-14','08:10:00',1.44),('11288','2014-04-14','08:15:00',1.57),('11288','2014-04-14','08:20:00',1.57),('11288','2014-04-14','08:25:00',1.81),('11288','2014-04-14','08:30:00',2.01),('11288','2014-04-14','08:35:00',2.1),('11288','2014-04-14','08:40:00',2.33),('11288','2014-04-14','08:45:00',2.52),('11288','2014-04-14','08:50:00',2.66),('11288','2014-04-14','08:55:00',2.85),('11288','2014-04-14','09:00:00',3.03),('11288','2014-04-14','09:05:00',3.06),('11288','2014-04-14','09:10:00',3.22),('11288','2014-04-14','09:15:00',3.34),('11288','2014-04-14','09:20:00',3.39),('11288','2014-04-14','09:25:00',3.44),('11288','2014-04-14','09:30:00',3.83),('11288','2014-04-14','09:35:00',3.94),('11288','2014-04-14','09:40:00',4.03),('11288','2014-04-14','09:45:00',4.05),('11288','2014-04-14','09:50:00',4.04),('11288','2014-04-14','09:55:00',4.2),('11288','2014-04-14','10:00:00',4.68),('11288','2014-04-14','10:05:00',4.83),('11288','2014-04-14','10:10:00',4.95),('11288','2014-04-14','10:15:00',5.07),('11288','2014-04-14','10:20:00',5.08),('11288','2014-04-14','10:25:00',5.24),('11288','2014-04-14','10:30:00',5.4),('11288','2014-04-14','10:35:00',5.51),('11288','2014-04-14','10:40:00',5.62),('11288','2014-04-14','10:45:00',5.65),('11288','2014-04-14','10:50:00',5.73),('11288','2014-04-14','10:55:00',5.83),('11288','2014-04-14','11:00:00',5.89),('11288','2014-04-14','11:05:00',5.95),('11288','2014-04-14','11:10:00',6),('11288','2014-04-14','11:15:00',6.04),('11288','2014-04-14','11:20:00',6.12),('11288','2014-04-14','11:25:00',6.19),('11288','2014-04-14','11:30:00',6.26),('11288','2014-04-14','11:35:00',6.32),('11288','2014-04-14','11:40:00',6.33),('11288','2014-04-14','11:45:00',6.4),('11288','2014-04-14','11:50:00',6.42),('11288','2014-04-14','11:55:00',6.43),('11288','2014-04-14','12:00:00',6.59),('11288','2014-04-14','12:05:00',6.63),('11288','2014-04-14','12:10:00',6.63),('11288','2014-04-14','12:15:00',6.68),('11288','2014-04-14','12:20:00',6.72),('11288','2014-04-14','12:25:00',6.75),('11288','2014-04-14','12:30:00',6.75),('11288','2014-04-14','12:35:00',6.78),('11288','2014-04-14','12:40:00',6.77),('11288','2014-04-14','12:45:00',6.77),('11288','2014-04-14','12:50:00',6.8),('11288','2014-04-14','12:55:00',6.79),('11288','2014-04-14','13:00:00',6.82),('11288','2014-04-14','13:05:00',6.8),('11288','2014-04-14','13:10:00',6.8),('11288','2014-04-14','13:15:00',6.86),('11288','2014-04-14','13:20:00',6.83),('11288','2014-04-14','13:25:00',6.83),('11288','2014-04-14','13:30:00',6.83),('11288','2014-04-14','13:35:00',6.81),('11288','2014-04-14','13:40:00',6.82),('11288','2014-04-14','13:45:00',6.79),('11288','2014-04-14','13:50:00',6.85),('11288','2014-04-14','13:55:00',6.81),('11288','2014-04-14','14:00:00',6.71),('11288','2014-04-14','14:05:00',6.77),('11288','2014-04-14','14:10:00',6.74),('11288','2014-04-14','14:15:00',6.72),('11288','2014-04-14','14:20:00',6.72),('11288','2014-04-14','14:25:00',6.65),('11288','2014-04-14','14:30:00',6.57),('11288','2014-04-14','14:35:00',6.55),('11288','2014-04-14','14:40:00',6.5),('11288','2014-04-14','14:45:00',6.44),('11288','2014-04-14','14:50:00',6.4),('11288','2014-04-14','14:55:00',6.37),('11288','2014-04-14','15:00:00',6.31),('11288','2014-04-14','15:05:00',6.23),('11288','2014-04-14','15:10:00',6.17),('11288','2014-04-14','15:15:00',6.08),('11288','2014-04-14','15:20:00',6.02),('11288','2014-04-14','15:25:00',5.94),('11288','2014-04-14','15:30:00',5.85),('11288','2014-04-14','15:35:00',5.79),('11288','2014-04-14','15:40:00',5.71),('11288','2014-04-14','15:45:00',5.62),('11288','2014-04-14','15:50:00',5.51),('11288','2014-04-14','15:55:00',5.38),('11288','2014-04-14','16:00:00',5.28),('11288','2014-04-14','16:05:00',5.17),('11288','2014-04-14','16:10:00',5.07),('11288','2014-04-14','16:15:00',4.89),('11288','2014-04-14','16:20:00',4.82),('11288','2014-04-14','16:25:00',4.7),('11288','2014-04-14','16:30:00',4.58),('11288','2014-04-14','16:35:00',4.43),('11288','2014-04-14','16:40:00',4.31),('11288','2014-04-14','16:45:00',4.18),('11288','2014-04-14','16:50:00',4.03),('11288','2014-04-14','16:55:00',3.88),('11288','2014-04-14','17:00:00',3.74),('11288','2014-04-14','17:05:00',3.58),('11288','2014-04-14','17:10:00',3.42),('11288','2014-04-14','17:15:00',3.29),('11288','2014-04-14','17:20:00',3.15),('11288','2014-04-14','17:25:00',3.01),('11288','2014-04-14','17:30:00',2.83),('11288','2014-04-14','17:35:00',2.66),('11288','2014-04-14','17:40:00',2.51),('11288','2014-04-14','17:45:00',2.34),('11288','2014-04-14','17:50:00',2.19),('11288','2014-04-14','17:55:00',2.01),('11288','2014-04-14','18:00:00',1.85),('11288','2014-04-14','18:05:00',1.73),('11288','2014-04-14','18:10:00',1.61),('11288','2014-04-14','18:15:00',1.48),('11288','2014-04-14','18:20:00',1.34),('11288','2014-04-14','18:25:00',1.21),('11288','2014-04-14','18:30:00',1.08),('11288','2013-09-28','08:30:00',1.13),('11288','2013-09-28','08:35:00',1.16),('11288','2013-09-28','08:40:00',1.34),('11288','2013-09-28','08:45:00',1.5),('11288','2013-09-28','08:50:00',1.6),('11288','2013-09-28','08:55:00',1.68),('11288','2013-09-28','09:00:00',1.83),('11288','2013-09-28','09:05:00',1.84),('11288','2013-09-28','09:10:00',2.14),('11288','2013-09-28','09:15:00',2.28),('11288','2013-09-28','09:20:00',2.44),('11288','2013-09-28','09:25:00',2.58),('11288','2013-09-28','09:30:00',2.69),('11288','2013-09-28','09:35:00',2.65),('11288','2013-09-28','09:40:00',2.61),('11288','2013-09-28','09:45:00',3.1),('11288','2013-09-28','09:50:00',3.51),('11288','2013-09-28','09:55:00',3.77),('11288','2013-09-28','10:00:00',3.06),('11288','2013-09-28','10:05:00',1.86),('11288','2013-09-28','10:10:00',2.69),('11288','2013-09-28','10:15:00',3.13),('11288','2013-09-28','10:20:00',2.79),('11288','2013-09-28','10:25:00',2.06),('11288','2013-09-28','10:30:00',2.18),('11288','2013-09-28','10:35:00',2.42),('11288','2013-09-28','10:40:00',3.6),('11288','2013-09-28','10:45:00',5.26),('11288','2013-09-28','10:50:00',5.43),('11288','2013-09-28','10:55:00',5.05),('11288','2013-09-28','11:00:00',3.06),('11288','2013-09-28','11:05:00',3.71),('11288','2013-09-28','11:10:00',3.73),('11288','2013-09-28','11:15:00',5.36),('11288','2013-09-28','11:20:00',5.54),('11288','2013-09-28','11:25:00',5.65),('11288','2013-09-28','11:30:00',5.47),('11288','2013-09-28','11:35:00',4.2),('11288','2013-09-28','11:40:00',1.34),('11288','2013-09-28','11:45:00',1.67),('11288','2013-09-28','11:50:00',3.81),('11288','2013-09-28','11:55:00',4.75),('11288','2013-09-28','12:00:00',5.98),('11288','2013-09-28','12:05:00',3.68),('11288','2013-09-28','12:10:00',5.42),('11288','2013-09-28','12:15:00',4.61),('11288','2013-09-28','12:20:00',4.9),('11288','2013-09-28','12:25:00',4.71),('11288','2013-09-28','12:30:00',3.34),('11288','2013-09-28','12:35:00',5.55),('11288','2013-09-28','12:40:00',5.68),('11288','2013-09-28','12:45:00',6.07),('11288','2013-09-28','12:50:00',6.24),('11288','2013-09-28','12:55:00',6.09),('11288','2013-09-28','13:00:00',5.18),('11288','2013-09-28','13:05:00',3.69),('11288','2013-09-28','13:10:00',6.26),('11288','2013-09-28','13:15:00',5.79),('11288','2013-09-28','13:20:00',5.87),('11288','2013-09-28','13:25:00',4.86),('11288','2013-09-28','13:30:00',2.91),('11288','2013-09-28','13:35:00',2.74),('11288','2013-09-28','13:40:00',3.78),('11288','2013-09-28','13:45:00',4.7),('11288','2013-09-28','13:50:00',4.85),('11288','2013-09-28','13:55:00',5.31),('11288','2013-09-28','14:00:00',5.63),('11288','2013-09-28','14:05:00',4.26),('11288','2013-09-28','14:10:00',5.72),('11288','2013-09-28','14:15:00',6.03),('11288','2013-09-28','14:20:00',5.74),('11288','2013-09-28','14:25:00',5.55),('11288','2013-09-28','14:30:00',5.45),('11288','2013-09-28','14:35:00',5.47),('11288','2013-09-28','14:40:00',5.3),('11288','2013-09-28','14:45:00',5.19),('11288','2013-09-28','14:50:00',5.08),('11288','2013-09-28','14:55:00',4.97),('11288','2013-09-28','15:00:00',5.02),('11288','2013-09-28','15:05:00',4.29),('11288','2013-09-28','15:10:00',4.56),('11288','2013-09-28','15:15:00',4.67),('11288','2013-09-28','15:20:00',4.5),('11288','2013-09-28','15:25:00',4.34),('11288','2013-09-28','15:30:00',4.18),('11288','2013-09-28','15:35:00',4.1),('11288','2013-09-28','15:40:00',3.95),('11288','2013-09-28','15:45:00',3.92),('11288','2013-09-28','15:50:00',3.7),('11288','2013-09-28','15:55:00',3.75),('11288','2013-09-28','16:00:00',3.7),('11288','2013-09-28','16:05:00',3.53),('11288','2013-09-28','16:10:00',3.4),('11288','2013-09-28','16:15:00',2.29),('11288','2013-09-28','16:20:00',2.21),('11288','2013-09-28','16:25:00',2.35),('11288','2013-09-28','16:30:00',2.36),('11288','2013-09-28','16:35:00',2.56),('11288','2013-09-28','16:40:00',2.39),('11288','2013-09-28','16:45:00',2.23),('11288','2013-09-28','16:50:00',2.13),('11288','2013-09-28','16:55:00',1.99),('11288','2013-09-28','17:00:00',1.85),('11288','2013-09-28','17:05:00',1.71),('11288','2013-09-28','17:10:00',1.58),('11288','2013-09-28','17:15:00',1.47),('11288','2013-09-28','17:20:00',1.36),('11288','2013-09-28','17:25:00',1.27),('11288','2013-09-28','17:30:00',1.17),('11288','2013-09-28','17:35:00',1.06),('11288','2013-09-27','08:20:00',1.13),('11288','2013-09-27','08:25:00',1.13),('11288','2013-09-27','08:30:00',1.18),('11288','2013-09-27','08:35:00',1.36),('11288','2013-09-27','08:40:00',1.39),('11288','2013-09-27','08:45:00',1.55),('11288','2013-09-27','08:50:00',1.67),('11288','2013-09-27','08:55:00',2.09),('11288','2013-09-27','09:00:00',2.2),('11288','2013-09-27','09:05:00',1.72),('11288','2013-09-27','09:10:00',1.48),('11288','2013-09-27','09:15:00',1.67),('11288','2013-09-27','09:20:00',1.44),('11288','2013-09-27','09:25:00',1.46),('11288','2013-09-27','09:30:00',1.31),('11288','2013-09-27','09:35:00',1.56),('11288','2013-09-27','09:40:00',1.5),('11288','2013-09-27','09:45:00',1.65),('11288','2013-09-27','09:50:00',2.81),('11288','2013-09-27','09:55:00',3.32),('11288','2013-09-27','10:00:00',2.79),('11288','2013-09-27','10:05:00',2.99),('11288','2013-09-27','10:10:00',2.78),('11288','2013-09-27','10:15:00',2.61),('11288','2013-09-27','10:20:00',3.35),('11288','2013-09-27','10:25:00',2.44),('11288','2013-09-27','10:30:00',2.27),('11288','2013-09-27','10:35:00',2.11),('11288','2013-09-27','10:40:00',1.87),('11288','2013-09-27','10:45:00',1.83),('11288','2013-09-27','10:50:00',1.66),('11288','2013-09-27','10:55:00',3.53),('11288','2013-09-27','11:00:00',3.45),('11288','2013-09-27','11:05:00',2.71),('11288','2013-09-27','11:10:00',3.33),('11288','2013-09-27','11:15:00',3.51),('11288','2013-09-27','11:20:00',5.04),('11288','2013-09-27','11:25:00',4.27),('11288','2013-09-27','11:30:00',2.43),('11288','2013-09-27','11:35:00',1.73),('11288','2013-09-27','11:40:00',1.73),('11288','2013-09-27','11:45:00',2),('11288','2013-09-27','11:50:00',1.98),('11288','2013-09-27','11:55:00',3.37),('11288','2013-09-27','12:00:00',5.5),('11288','2013-09-27','12:05:00',3.65),('11288','2013-09-27','12:10:00',5.55),('11288','2013-09-27','12:15:00',1.79),('11288','2013-09-27','12:20:00',1.45),('11288','2013-09-27','12:25:00',1.49),('11288','2013-09-27','12:30:00',1.59),('11288','2013-09-27','12:35:00',1.5),('11288','2013-09-27','12:40:00',1.7),('11288','2013-09-27','12:45:00',2.38),('11288','2013-09-27','12:50:00',3.94),('11288','2013-09-27','12:55:00',5.27),('11288','2013-09-27','13:00:00',5.59),('11288','2013-09-27','13:05:00',5.98),('11288','2013-09-27','13:10:00',4.97),('11288','2013-09-27','13:15:00',3.37),('11288','2013-09-27','13:20:00',2.91),('11288','2013-09-27','13:25:00',1.69),('11288','2013-09-27','13:30:00',1.35),('11288','2013-09-27','13:35:00',1.41),('11288','2013-09-27','13:40:00',1.73),('11288','2013-09-27','13:45:00',1.59),('11288','2013-09-27','13:50:00',3.27),('11288','2013-09-27','13:55:00',3.97),('11288','2013-09-27','14:00:00',6.01),('11288','2013-09-27','14:05:00',4.79),('11288','2013-09-27','14:10:00',5.39),('11288','2013-09-27','14:15:00',5.49),('11288','2013-09-27','14:20:00',5.36),('11288','2013-09-27','14:25:00',3.99),('11288','2013-09-27','14:30:00',5.09),('11288','2013-09-27','14:35:00',5),('11288','2013-09-27','14:40:00',4.64),('11288','2013-09-27','14:45:00',4.93),('11288','2013-09-27','14:50:00',4),('11288','2013-09-27','14:55:00',4.96),('11288','2013-09-27','15:00:00',4.75),('11288','2013-09-27','15:05:00',3.18),('11288','2013-09-27','15:10:00',4.54),('11288','2013-09-27','15:15:00',4.5),('11288','2013-09-27','15:20:00',4.51),('11288','2013-09-27','15:25:00',4.41),('11288','2013-09-27','15:30:00',3.14),('11288','2013-09-27','15:35:00',4.23),('11288','2013-09-27','15:40:00',3.19),('11288','2013-09-27','15:45:00',4.14),('11288','2013-09-27','15:50:00',4.07),('11288','2013-09-27','15:55:00',3.68),('11288','2013-09-27','16:00:00',3.5),('11288','2013-09-27','16:05:00',1.98),('11288','2013-09-27','16:10:00',2.31),('11288','2013-09-27','16:15:00',2.25),('11288','2013-09-27','16:20:00',2.6),('11288','2013-09-27','16:25:00',2.45),('11288','2013-09-27','16:30:00',2.07),('11288','2013-09-27','16:35:00',2.28),('11288','2013-09-27','16:40:00',2.19),('11288','2013-09-27','16:45:00',2.28),('11288','2013-09-27','16:50:00',2),('11288','2013-09-27','16:55:00',1.03),('11288','2013-09-27','17:05:00',1.04),('11288','2013-09-27','17:10:00',1.77),('11288','2013-09-27','17:15:00',1.66),('11288','2013-09-27','17:20:00',1.5),('11288','2013-09-27','17:25:00',1.38),('11288','2013-09-27','17:30:00',1.26),('11288','2013-09-27','17:35:00',1.07),('11288','2013-09-26','08:25:00',1.02),('11288','2013-09-26','08:35:00',1.09),('11288','2013-09-26','08:40:00',1.39),('11288','2013-09-26','08:45:00',1.59),('11288','2013-09-26','08:50:00',1.64),('11288','2013-09-26','08:55:00',1.83),('11288','2013-09-26','09:00:00',2.03),('11288','2013-09-26','09:05:00',2.05),('11288','2013-09-26','09:10:00',2.2),('11288','2013-09-26','09:15:00',2.46),('11288','2013-09-26','09:20:00',2.48),('11288','2013-09-26','09:25:00',2.67),('11288','2013-09-26','09:30:00',2.87),('11288','2013-09-26','09:35:00',2.95),('11288','2013-09-26','09:40:00',3.05),('11288','2013-09-26','09:45:00',3.3),('11288','2013-09-26','09:50:00',3.38),('11288','2013-09-26','09:55:00',3.49),('11288','2013-09-26','10:00:00',3.6),('11288','2013-09-26','10:05:00',3.7),('11288','2013-09-26','10:10:00',3.78),('11288','2013-09-26','10:15:00',3.91),('11288','2013-09-26','10:20:00',4.04),('11288','2013-09-26','10:25:00',4.04),('11288','2013-09-26','10:30:00',4.25),('11288','2013-09-26','10:35:00',4.3),('11288','2013-09-26','10:40:00',3.89),('11288','2013-09-26','10:45:00',4.36),('11288','2013-09-26','10:50:00',4.48),('11288','2013-09-26','10:55:00',4.42),('11288','2013-09-26','11:00:00',4.49),('11288','2013-09-26','11:05:00',4.43),('11288','2013-09-26','11:10:00',4.74),('11288','2013-09-26','11:15:00',4.76),('11288','2013-09-26','11:20:00',4.72),('11288','2013-09-26','11:25:00',4.66),('11288','2013-09-26','11:30:00',4.82),('11288','2013-09-26','11:35:00',4.35),('11288','2013-09-26','11:40:00',4.77),('11288','2013-09-26','11:45:00',5.08),('11288','2013-09-26','11:50:00',4.97),('11288','2013-09-26','11:55:00',5.35),('11288','2013-09-26','12:00:00',5.49),('11288','2013-09-26','12:05:00',6.03),('11288','2013-09-26','12:10:00',2.48),('11288','2013-09-26','12:15:00',2.76),('11288','2013-09-26','12:20:00',3.19),('11288','2013-09-26','12:25:00',2),('11288','2013-09-26','12:30:00',2.32),('11288','2013-09-26','12:35:00',2.68),('11288','2013-09-26','12:40:00',2.59),('11288','2013-09-26','12:45:00',2.61),('11288','2013-09-26','12:50:00',2.59),('11288','2013-09-26','12:55:00',6.07),('11288','2013-09-26','13:00:00',3.31),('11288','2013-09-26','13:05:00',3.23),('11288','2013-09-26','13:10:00',4.13),('11288','2013-09-26','13:15:00',5.76),('11288','2013-09-26','13:20:00',4.56),('11288','2013-09-26','13:25:00',3.32),('11288','2013-09-26','13:30:00',3.78),('11288','2013-09-26','13:35:00',3.17),('11288','2013-09-26','13:40:00',2.5),('11288','2013-09-26','13:45:00',2.8),('11288','2013-09-26','13:50:00',4.57),('11288','2013-09-26','13:55:00',3.13),('11288','2013-09-26','14:00:00',4.44),('11288','2013-09-26','14:05:00',6.1),('11288','2013-09-26','14:10:00',5),('11288','2013-09-26','14:15:00',4.25),('11288','2013-09-26','14:20:00',1.69),('11288','2013-09-26','14:25:00',1.26),('11288','2013-09-26','14:30:00',3.29),('11288','2013-09-26','14:35:00',1.6),('11288','2013-09-26','14:40:00',3.2),('11288','2013-09-26','14:45:00',6.03),('11288','2013-09-26','14:50:00',5.61),('11288','2013-09-26','14:55:00',4.25),('11288','2013-09-26','15:00:00',2.56),('11288','2013-09-26','15:05:00',3.95),('11288','2013-09-26','15:10:00',1.78),('11288','2013-09-26','15:15:00',1.76),('11288','2013-09-26','15:20:00',4.16),('11288','2013-09-26','15:25:00',1.62),('11288','2013-09-26','15:30:00',2.01),('11288','2013-09-26','15:35:00',4.29),('11288','2013-09-26','15:40:00',1.48),('11288','2013-09-26','15:45:00',1.3),('11288','2013-09-26','15:50:00',2.79),('11288','2013-09-26','15:55:00',3.82),('11288','2013-09-26','16:00:00',3.25),('11288','2013-09-26','16:05:00',1.57),('11288','2013-09-26','16:10:00',2.87),('11288','2013-09-26','16:15:00',3.14),('11288','2013-09-26','16:20:00',3.13),('11288','2013-09-26','16:25:00',3.05),('11288','2013-09-26','16:30:00',2.85),('11288','2013-09-26','16:35:00',2.69),('11288','2013-09-26','16:40:00',2.54),('11288','2013-09-26','16:45:00',2.39),('11288','2013-09-26','16:50:00',2.26),('11288','2013-09-26','16:55:00',2.14),('11288','2013-09-26','17:00:00',1.97),('11288','2013-09-26','17:05:00',1.88),('11288','2013-09-26','17:10:00',1.79),('11288','2013-09-26','17:15:00',1.64),('11288','2013-09-26','17:20:00',1.54),('11288','2013-09-26','17:25:00',1.43),('11288','2013-09-26','17:30:00',1.36),('11288','2013-09-26','17:35:00',1.37),('11288','2013-09-26','17:40:00',1.19),('11288','2013-09-26','17:45:00',1.05),('11288','2013-09-25','08:25:00',1.08),('11288','2013-09-25','08:30:00',1.24),('11288','2013-09-25','08:40:00',1.24),('11288','2013-09-25','08:45:00',1.93),('11288','2013-09-25','08:50:00',1.19),('11288','2013-09-25','08:55:00',1.14),('11288','2013-09-25','09:00:00',1.46),('11288','2013-09-25','09:05:00',2.04),('11288','2013-09-25','09:10:00',2.37),('11288','2013-09-25','09:15:00',2.08),('11288','2013-09-25','09:20:00',1.95),('11288','2013-09-25','09:25:00',2.12),('11288','2013-09-25','09:30:00',1.77),('11288','2013-09-25','09:35:00',3.13),('11288','2013-09-25','09:40:00',2.22),('11288','2013-09-25','09:55:00',1.13),('11288','2013-09-25','10:00:00',1.63),('11288','2013-09-25','10:10:00',1.09),('11288','2013-09-25','10:25:00',1.58),('11288','2013-09-25','10:30:00',2.07),('11288','2013-09-25','10:35:00',1.89),('11288','2013-09-25','10:40:00',2.49),('11288','2013-09-25','10:45:00',3.98),('11288','2013-09-25','10:50:00',4.78),('11288','2013-09-25','10:55:00',4.97),('11288','2013-09-25','11:00:00',4.14),('11288','2013-09-25','11:05:00',1.75),('11288','2013-09-25','11:10:00',3.34),('11288','2013-09-25','11:15:00',2.52),('11288','2013-09-25','11:20:00',4.29),('11288','2013-09-25','11:25:00',3.33),('11288','2013-09-25','11:30:00',5.18),('11288','2013-09-25','11:35:00',5.33),('11288','2013-09-25','11:40:00',5.35),('11288','2013-09-25','11:45:00',3.65),('11288','2013-09-25','11:50:00',1.63),('11288','2013-09-25','11:55:00',1.43),('11288','2013-09-25','12:00:00',1.21),('11288','2013-09-25','12:05:00',1.38),('11288','2013-09-25','12:10:00',5.12),('11288','2013-09-25','12:15:00',4.78),('11288','2013-09-25','12:20:00',1.38),('11288','2013-09-25','12:25:00',2.35),('11288','2013-09-25','12:30:00',6.55),('11288','2013-09-25','12:35:00',4.91),('11288','2013-09-25','12:40:00',1.81),('11288','2013-09-25','12:45:00',2.17),('11288','2013-09-25','12:50:00',1.99),('11288','2013-09-25','12:55:00',1.85),('11288','2013-09-25','13:00:00',2.87),('11288','2013-09-25','13:05:00',1.46),('11288','2013-09-25','13:10:00',1.92),('11288','2013-09-25','13:15:00',4.43),('11288','2013-09-25','13:20:00',4.59),('11288','2013-09-25','13:25:00',6.97),('11288','2013-09-25','13:30:00',6.57),('11288','2013-09-25','13:35:00',6.67),('11288','2013-09-25','13:40:00',6.6),('11288','2013-09-25','13:45:00',6.43),('11288','2013-09-25','13:50:00',4.94),('11288','2013-09-25','13:55:00',1.64),('11288','2013-09-25','14:00:00',1.48),('11288','2013-09-25','14:05:00',1.72),('11288','2013-09-25','14:10:00',1.81),('11288','2013-09-25','14:15:00',1.65),('11288','2013-09-25','14:20:00',2.26),('11288','2013-09-25','14:25:00',3.87),('11288','2013-09-25','14:30:00',6.24),('11288','2013-09-25','14:35:00',6.26),('11288','2013-09-25','14:40:00',5.77),('11288','2013-09-25','14:45:00',4.96),('11288','2013-09-25','14:50:00',4.54),('11288','2013-09-25','14:55:00',4.05),('11288','2013-09-25','15:00:00',4.73),('11288','2013-09-25','15:05:00',5.32),('11288','2013-09-25','15:10:00',5.02),('11288','2013-09-25','15:15:00',4.93),('11288','2013-09-25','15:20:00',3.44),('11288','2013-09-25','15:25:00',4.6),('11288','2013-09-25','15:30:00',4.04),('11288','2013-09-25','15:35:00',4.88),('11288','2013-09-25','15:40:00',4.55),('11288','2013-09-25','15:45:00',4.17),('11288','2013-09-25','15:50:00',4.18),('11288','2013-09-25','15:55:00',4.06),('11288','2013-09-25','16:00:00',3.95),('11288','2013-09-25','16:05:00',3.71),('11288','2013-09-25','16:10:00',3.62),('11288','2013-09-25','16:15:00',3.5),('11288','2013-09-25','16:20:00',3.04),('11288','2013-09-25','16:25:00',3.19),('11288','2013-09-25','16:30:00',3.1),('11288','2013-09-25','16:35:00',2.3),('11288','2013-09-25','16:40:00',2.34),('11288','2013-09-25','16:45:00',2.58),('11288','2013-09-25','16:50:00',2.44),('11288','2013-09-25','16:55:00',2.31),('11288','2013-09-25','17:00:00',2.17),('11288','2013-09-25','17:05:00',2.03),('11288','2013-09-25','17:10:00',1.89),('11288','2013-09-25','17:15:00',1.73),('11288','2013-09-25','17:20:00',1.6),('11288','2013-09-25','17:25:00',1.51),('11288','2013-09-25','17:30:00',1.4),('11288','2013-09-25','17:35:00',1.26),('11288','2013-09-25','17:40:00',1.11),('11288','2013-09-24','08:25:00',1.12),('11288','2013-09-24','08:30:00',1.25),('11288','2013-09-24','08:35:00',1.43),('11288','2013-09-24','08:40:00',1.44),('11288','2013-09-24','08:45:00',1.58),('11288','2013-09-24','08:50:00',1.71),('11288','2013-09-24','08:55:00',1.95),('11288','2013-09-24','09:00:00',2.13),('11288','2013-09-24','09:05:00',2.25),('11288','2013-09-24','09:10:00',2.41),('11288','2013-09-24','09:15:00',2.47),('11288','2013-09-24','09:20:00',2.59),('11288','2013-09-24','09:25:00',2.87),('11288','2013-09-24','09:30:00',3.01),('11288','2013-09-24','09:35:00',3.17),('11288','2013-09-24','09:40:00',3.31),('11288','2013-09-24','09:45:00',3.43),('11288','2013-09-24','09:50:00',3.53),('11288','2013-09-24','09:55:00',3.66),('11288','2013-09-24','10:00:00',3.78),('11288','2013-09-24','10:05:00',3.91),('11288','2013-09-24','10:10:00',4.03),('11288','2013-09-24','10:15:00',4.2),('11288','2013-09-24','10:20:00',4.31),('11288','2013-09-24','10:25:00',4.44),('11288','2013-09-24','10:30:00',4.52),('11288','2013-09-24','10:35:00',4.59),('11288','2013-09-24','10:40:00',4.66),('11288','2013-09-24','10:45:00',4.73),('11288','2013-09-24','10:50:00',4.79),('11288','2013-09-24','10:55:00',4.84),('11288','2013-09-24','11:00:00',4.9),('11288','2013-09-24','11:05:00',4.94),('11288','2013-09-24','11:10:00',4.94),('11288','2013-09-24','11:15:00',5),('11288','2013-09-24','11:20:00',5.07),('11288','2013-09-24','11:25:00',5.1),('11288','2013-09-24','11:30:00',5.18),('11288','2013-09-24','11:35:00',5.17),('11288','2013-09-24','11:40:00',5.23),('11288','2013-09-24','11:45:00',5.29),('11288','2013-09-24','11:50:00',5.35),('11288','2013-09-24','11:55:00',5.37),('11288','2013-09-24','12:00:00',5.49),('11288','2013-09-24','12:05:00',5.55),('11288','2013-09-24','12:10:00',5.53),('11288','2013-09-24','12:15:00',5.48),('11288','2013-09-24','12:20:00',5.56),('11288','2013-09-24','12:25:00',5.62),('11288','2013-09-24','12:30:00',5.62),('11288','2013-09-24','12:35:00',5.64),('11288','2013-09-24','12:40:00',5.68),('11288','2013-09-24','12:45:00',5.68),('11288','2013-09-24','12:50:00',5.61),('11288','2013-09-24','12:55:00',5.66),('11288','2013-09-24','13:00:00',5.72),('11288','2013-09-24','13:05:00',5.71),('11288','2013-09-24','13:10:00',5.7),('11288','2013-09-24','13:15:00',5.68),('11288','2013-09-24','13:20:00',5.67),('11288','2013-09-24','13:25:00',5.56),('11288','2013-09-24','13:30:00',5.64),('11288','2013-09-24','13:35:00',5.65),('11288','2013-09-24','13:40:00',5.65),('11288','2013-09-24','13:45:00',5.55),('11288','2013-09-24','13:50:00',5.5),('11288','2013-09-24','13:55:00',5.47),('11288','2013-09-24','14:00:00',5.46),('11288','2013-09-24','14:05:00',5.44),('11288','2013-09-24','14:10:00',5.43),('11288','2013-09-24','14:15:00',5.39),('11288','2013-09-24','14:20:00',5.32),('11288','2013-09-24','14:25:00',5.31),('11288','2013-09-24','14:30:00',5.22),('11288','2013-09-24','14:35:00',5.18),('11288','2013-09-24','14:40:00',5.14),('11288','2013-09-24','14:45:00',5.06),('11288','2013-09-24','14:50:00',5.02),('11288','2013-09-24','14:55:00',4.91),('11288','2013-09-24','15:00:00',4.91),('11288','2013-09-24','15:05:00',4.81),('11288','2013-09-24','15:10:00',4.7),('11288','2013-09-24','15:15:00',4.68),('11288','2013-09-24','15:20:00',4.64),('11288','2013-09-24','15:25:00',4.57),('11288','2013-09-24','15:30:00',4.44),('11288','2013-09-24','15:35:00',4.34),('11288','2013-09-24','15:40:00',4.26),('11288','2013-09-24','15:45:00',4.2),('11288','2013-09-24','15:50:00',4.05),('11288','2013-09-24','15:55:00',3.95),('11288','2013-09-24','16:00:00',3.86),('11288','2013-09-24','16:05:00',3.72),('11288','2013-09-24','16:10:00',3.6),('11288','2013-09-24','16:15:00',3.48),('11288','2013-09-24','16:20:00',3.39),('11288','2013-09-24','16:25:00',3.21),('11288','2013-09-24','16:30:00',3.09),('11288','2013-09-24','16:35:00',2.95),('11288','2013-09-24','16:40:00',2.8),('11288','2013-09-24','16:45:00',2.69),('11288','2013-09-24','16:50:00',2.54),('11288','2013-09-24','16:55:00',2.42),('11288','2013-09-24','17:00:00',2.24),('11288','2013-09-24','17:05:00',2.09),('11288','2013-09-24','17:10:00',1.94),('11288','2013-09-24','17:15:00',1.81),('11288','2013-09-24','17:20:00',1.68),('11288','2013-09-24','17:25:00',1.55),('11288','2013-09-24','17:30:00',1.4),('11288','2013-09-24','17:35:00',1.28),('11288','2013-09-24','17:40:00',1.13),('11288','2013-09-23','08:25:00',1.08),('11288','2013-09-23','08:30:00',1.2),('11288','2013-09-23','08:35:00',1.34),('11288','2013-09-23','08:40:00',1.49),('11288','2013-09-23','08:45:00',1.69),('11288','2013-09-23','08:50:00',1.85),('11288','2013-09-23','08:55:00',1.96),('11288','2013-09-23','09:00:00',2.12),('11288','2013-09-23','09:05:00',2.29),('11288','2013-09-23','09:10:00',2.3),('11288','2013-09-23','09:15:00',2.34),('11288','2013-09-23','09:20:00',2.54),('11288','2013-09-23','09:25:00',2.84),('11288','2013-09-23','09:30:00',3),('11288','2013-09-23','09:35:00',3.17),('11288','2013-09-23','09:40:00',3.38),('11288','2013-09-23','09:45:00',3.5),('11288','2013-09-23','09:50:00',3.61),('11288','2013-09-23','09:55:00',3.76),('11288','2013-09-23','10:00:00',3.86),('11288','2013-09-23','10:05:00',3.99),('11288','2013-09-23','10:10:00',4.15),('11288','2013-09-23','10:15:00',4.31),('11288','2013-09-23','10:20:00',4.38),('11288','2013-09-23','10:25:00',4.51),('11288','2013-09-23','10:30:00',4.59),('11288','2013-09-23','10:35:00',4.67),('11288','2013-09-23','10:40:00',4.76),('11288','2013-09-23','10:45:00',4.83),('11288','2013-09-23','10:50:00',4.9),('11288','2013-09-23','10:55:00',5),('11288','2013-09-23','11:00:00',5.02),('11288','2013-09-23','11:05:00',5.06),('11288','2013-09-23','11:10:00',5.16),('11288','2013-09-23','11:15:00',5.25),('11288','2013-09-23','11:20:00',5.33),('11288','2013-09-23','11:25:00',5.36),('11288','2013-09-23','11:30:00',5.42),('11288','2013-09-23','11:35:00',5.43),('11288','2013-09-23','11:40:00',5.48),('11288','2013-09-23','11:45:00',5.56),('11288','2013-09-23','11:50:00',5.64),('11288','2013-09-23','11:55:00',5.69),('11288','2013-09-23','12:00:00',5.76),('11288','2013-09-23','12:05:00',5.83),('11288','2013-09-23','12:10:00',5.85),('11288','2013-09-23','12:15:00',5.93),('11288','2013-09-23','12:20:00',5.93),('11288','2013-09-23','12:25:00',5.97),('11288','2013-09-23','12:30:00',6.01),('11288','2013-09-23','12:35:00',5.97),('11288','2013-09-23','12:40:00',5.94),('11288','2013-09-23','12:45:00',5.94),('11288','2013-09-23','12:50:00',5.95),('11288','2013-09-23','12:55:00',5.9),('11288','2013-09-23','13:00:00',5.92),('11288','2013-09-23','13:05:00',5.9),('11288','2013-09-23','13:10:00',5.85),('11288','2013-09-23','13:15:00',5.8),('11288','2013-09-23','13:20:00',5.77),('11288','2013-09-23','13:25:00',5.66),('11288','2013-09-23','13:30:00',5.72),('11288','2013-09-23','13:35:00',5.75),('11288','2013-09-23','13:40:00',5.75),('11288','2013-09-23','13:45:00',5.76),('11288','2013-09-23','13:50:00',5.7),('11288','2013-09-23','13:55:00',5.64),('11288','2013-09-23','14:00:00',5.6),('11288','2013-09-23','14:05:00',5.52),('11288','2013-09-23','14:10:00',5.44),('11288','2013-09-23','14:15:00',5.55),('11288','2013-09-23','14:20:00',5.47),('11288','2013-09-23','14:25:00',5.41),('11288','2013-09-23','14:30:00',5.44),('11288','2013-09-23','14:35:00',5.29),('11288','2013-09-23','14:40:00',5.15),('11288','2013-09-23','14:45:00',5.09),('11288','2013-09-23','14:50:00',5.02),('11288','2013-09-23','14:55:00',4.31),('11288','2013-09-23','15:00:00',5.1),('11288','2013-09-23','15:05:00',5.06),('11288','2013-09-23','15:10:00',3.28),('11288','2013-09-23','15:15:00',3.11),('11288','2013-09-23','15:20:00',4.11),('11288','2013-09-23','15:25:00',3.29),('11288','2013-09-23','15:30:00',4.36),('11288','2013-09-23','15:35:00',4.31),('11288','2013-09-23','15:40:00',4.38),('11288','2013-09-23','15:45:00',4.26),('11288','2013-09-23','15:50:00',4.11),('11288','2013-09-23','15:55:00',3.95),('11288','2013-09-23','16:00:00',3.83),('11288','2013-09-23','16:05:00',3.72),('11288','2013-09-23','16:10:00',3.55),('11288','2013-09-23','16:15:00',3.24),('11288','2013-09-23','16:20:00',3.37),('11288','2013-09-23','16:25:00',3.22),('11288','2013-09-23','16:30:00',3.07),('11288','2013-09-23','16:35:00',2.89),('11288','2013-09-23','16:40:00',2.74),('11288','2013-09-23','16:45:00',2.63),('11288','2013-09-23','16:50:00',2.49),('11288','2013-09-23','16:55:00',2.36),('11288','2013-09-23','17:00:00',2.23),('11288','2013-09-23','17:05:00',2.09),('11288','2013-09-23','17:10:00',1.94),('11288','2013-09-23','17:15:00',1.81),('11288','2013-09-23','17:20:00',1.69),('11288','2013-09-23','17:25:00',1.58),('11288','2013-09-23','17:30:00',1.48),('11288','2013-09-23','17:35:00',1.35),('11288','2013-09-23','17:40:00',1.22),('11288','2013-09-23','17:45:00',1.05),('11288','2013-09-22','08:15:00',1.07),('11288','2013-09-22','08:20:00',1.03),('11288','2013-09-22','08:25:00',1.17),('11288','2013-09-22','08:30:00',1.24),('11288','2013-09-22','08:35:00',1.35),('11288','2013-09-22','08:40:00',1.49),('11288','2013-09-22','08:45:00',1.65),('11288','2013-09-22','08:50:00',1.83),('11288','2013-09-22','08:55:00',1.97),('11288','2013-09-22','09:00:00',2.14),('11288','2013-09-22','09:05:00',2.27),('11288','2013-09-22','09:10:00',2.38),('11288','2013-09-22','09:15:00',2.32),('11288','2013-09-22','09:20:00',2.48),('11288','2013-09-22','09:25:00',2.86),('11288','2013-09-22','09:30:00',3.09),('11288','2013-09-22','09:35:00',3.26),('11288','2013-09-22','09:40:00',3.39),('11288','2013-09-22','09:45:00',3.49),('11288','2013-09-22','09:50:00',3.61),('11288','2013-09-22','09:55:00',3.74),('11288','2013-09-22','10:00:00',3.89),('11288','2013-09-22','10:05:00',4),('11288','2013-09-22','10:10:00',4.2),('11288','2013-09-22','10:15:00',4.34),('11288','2013-09-22','10:20:00',4.45),('11288','2013-09-22','10:25:00',4.57),('11288','2013-09-22','10:30:00',4.68),('11288','2013-09-22','10:35:00',4.78),('11288','2013-09-22','10:40:00',4.84),('11288','2013-09-22','10:45:00',4.9),('11288','2013-09-22','10:50:00',4.98),('11288','2013-09-22','10:55:00',5.03),('11288','2013-09-22','11:00:00',5.08),('11288','2013-09-22','11:05:00',5.13),('11288','2013-09-22','11:10:00',5.17),('11288','2013-09-22','11:15:00',5.25),('11288','2013-09-22','11:20:00',5.31),('11288','2013-09-22','11:25:00',5.38),('11288','2013-09-22','11:30:00',5.44),('11288','2013-09-22','11:35:00',5.52),('11288','2013-09-22','11:40:00',5.56),('11288','2013-09-22','11:45:00',5.68),('11288','2013-09-22','11:50:00',5.74),('11288','2013-09-22','11:55:00',5.77),('11288','2013-09-22','12:00:00',5.84),('11288','2013-09-22','12:05:00',5.95),('11288','2013-09-22','12:10:00',5.98),('11288','2013-09-22','12:15:00',6.01),('11288','2013-09-22','12:20:00',6.03),('11288','2013-09-22','12:25:00',6.07),('11288','2013-09-22','12:30:00',6.04),('11288','2013-09-22','12:35:00',6),('11288','2013-09-22','12:40:00',6.06),('11288','2013-09-22','12:45:00',6.09),('11288','2013-09-22','12:50:00',6.13),('11288','2013-09-22','12:55:00',6.16),('11288','2013-09-22','13:00:00',6.11),('11288','2013-09-22','13:05:00',6.11),('11288','2013-09-22','13:10:00',6.14),('11288','2013-09-22','13:15:00',6.06),('11288','2013-09-22','13:20:00',6.01),('11288','2013-09-22','13:25:00',5.94),('11288','2013-09-22','13:30:00',5.16),('11288','2013-09-22','13:35:00',5.97),('11288','2013-09-22','13:40:00',5.91),('11288','2013-09-22','13:45:00',5.94),('11288','2013-09-22','13:50:00',5.94),('11288','2013-09-22','13:55:00',5.91),('11288','2013-09-22','14:00:00',5.82),('11288','2013-09-22','14:05:00',5.87),('11288','2013-09-22','14:10:00',5.62),('11288','2013-09-22','14:15:00',5.58),('11288','2013-09-22','14:20:00',5.82),('11288','2013-09-22','14:25:00',6.23),('11288','2013-09-22','14:30:00',1.32),('11288','2013-09-22','14:35:00',4.71),('11288','2013-09-22','14:40:00',5.78),('11288','2013-09-22','14:45:00',5.08),('11288','2013-09-22','14:50:00',5.41),('11288','2013-09-22','14:55:00',5.35),('11288','2013-09-22','15:00:00',5.41),('11288','2013-09-22','15:05:00',5.49),('11288','2013-09-22','15:10:00',5.33),('11288','2013-09-22','15:15:00',5.56),('11288','2013-09-22','15:20:00',5.94),('11288','2013-09-22','15:25:00',3.77),('11288','2013-09-22','15:30:00',2.42),('11288','2013-09-22','15:35:00',2.1),('11288','2013-09-22','15:40:00',4.59),('11288','2013-09-22','15:45:00',4.62),('11288','2013-09-22','15:50:00',4.33),('11288','2013-09-22','15:55:00',4.3),('11288','2013-09-22','16:00:00',4.57),('11288','2013-09-22','16:05:00',4.84),('11288','2013-09-22','16:10:00',4.83),('11288','2013-09-22','16:15:00',4.56),('11288','2013-09-22','16:20:00',3.2),('11288','2013-09-22','16:25:00',2.53),('11288','2013-09-22','16:30:00',2.26),('11288','2013-09-22','16:35:00',2.11),('11288','2013-09-22','16:40:00',1.69),('11288','2013-09-22','16:45:00',2.36),('11288','2013-09-22','16:50:00',3.41),('11288','2013-09-22','16:55:00',2.15),('11288','2013-09-22','17:00:00',2.68),('11288','2013-09-22','17:05:00',2.64),('11288','2013-09-22','17:10:00',2.46),('11288','2013-09-22','17:15:00',1.56),('11288','2013-09-22','17:30:00',1.01),('11288','2013-09-22','17:35:00',1.25),('11288','2013-09-21','08:20:00',1.05),('11288','2013-09-21','08:25:00',1.1),('11288','2013-09-21','08:30:00',1.24),('11288','2013-09-21','08:35:00',1.41),('11288','2013-09-21','08:40:00',1.5),('11288','2013-09-21','08:45:00',1.68),('11288','2013-09-21','08:50:00',1.83),('11288','2013-09-21','08:55:00',1.98),('11288','2013-09-21','09:00:00',2.17),('11288','2013-09-21','09:05:00',2.3),('11288','2013-09-21','09:10:00',2.4),('11288','2013-09-21','09:15:00',2.44),('11288','2013-09-21','09:20:00',2.57),('11288','2013-09-21','09:25:00',2.88),('11288','2013-09-21','09:30:00',3.04),('11288','2013-09-21','09:35:00',3.21),('11288','2013-09-21','09:40:00',3.29),('11288','2013-09-21','09:45:00',3.46),('11288','2013-09-21','09:50:00',3.59),('11288','2013-09-21','09:55:00',3.7),('11288','2013-09-21','10:00:00',3.78),('11288','2013-09-21','10:05:00',3.93),('11288','2013-09-21','10:10:00',4.1),('11288','2013-09-21','10:15:00',4.23),('11288','2013-09-21','10:20:00',4.34),('11288','2013-09-21','10:25:00',4.44),('11288','2013-09-21','10:30:00',4.54),('11288','2013-09-21','10:35:00',4.63),('11288','2013-09-21','10:40:00',4.69),('11288','2013-09-21','10:45:00',4.77),('11288','2013-09-21','10:50:00',4.85),('11288','2013-09-21','10:55:00',4.92),('11288','2013-09-21','11:00:00',4.98),('11288','2013-09-21','11:05:00',5.01),('11288','2013-09-21','11:10:00',5.06),('11288','2013-09-21','11:15:00',5.12),('11288','2013-09-21','11:20:00',5.19),('11288','2013-09-21','11:25:00',5.23),('11288','2013-09-21','11:30:00',5.29),('11288','2013-09-21','11:35:00',5.34),('11288','2013-09-21','11:40:00',5.44),('11288','2013-09-21','11:45:00',5.49),('11288','2013-09-21','11:50:00',5.55),('11288','2013-09-21','11:55:00',5.52),('11288','2013-09-21','12:00:00',5.63),('11288','2013-09-21','12:05:00',5.78),('11288','2013-09-21','12:10:00',5.8),('11288','2013-09-21','12:15:00',5.87),('11288','2013-09-21','12:20:00',5.6),('11288','2013-09-21','12:25:00',5.53),('11288','2013-09-21','12:30:00',5.99),('11288','2013-09-21','12:35:00',5.83),('11288','2013-09-21','12:40:00',5.66),('11288','2013-09-21','12:45:00',5.78),('11288','2013-09-21','12:50:00',5.85),('11288','2013-09-21','12:55:00',5.97),('11288','2013-09-21','13:00:00',5.96),('11288','2013-09-21','13:05:00',5.79),('11288','2013-09-21','13:10:00',5.9),('11288','2013-09-21','13:15:00',6.05),('11288','2013-09-21','13:20:00',5.05),('11288','2013-09-21','13:25:00',5.74),('11288','2013-09-21','13:30:00',5.74),('11288','2013-09-21','13:35:00',5.61),('11288','2013-09-21','13:40:00',5.18),('11288','2013-09-21','13:45:00',5.18),('11288','2013-09-21','13:50:00',5.03),('11288','2013-09-21','13:55:00',4.94),('11288','2013-09-21','14:00:00',5.41),('11288','2013-09-21','14:05:00',5.54),('11288','2013-09-21','14:10:00',5.44),('11288','2013-09-21','14:15:00',5.6),('11288','2013-09-21','14:20:00',5.54),('11288','2013-09-21','14:25:00',5.49),('11288','2013-09-21','14:30:00',5.42),('11288','2013-09-21','14:35:00',5.35),('11288','2013-09-21','14:40:00',5.3),('11288','2013-09-21','14:45:00',5.2),('11288','2013-09-21','14:50:00',5.15),('11288','2013-09-21','14:55:00',5.06),('11288','2013-09-21','15:00:00',5.02),('11288','2013-09-21','15:05:00',4.93),('11288','2013-09-21','15:10:00',4.82),('11288','2013-09-21','15:15:00',4.72),('11288','2013-09-21','15:20:00',4.73),('11288','2013-09-21','15:25:00',4.62),('11288','2013-09-21','15:30:00',4.5),('11288','2013-09-21','15:35:00',4.38),('11288','2013-09-21','15:40:00',3.99),('11288','2013-09-21','15:45:00',3.11),('11288','2013-09-21','15:50:00',4.18),('11288','2013-09-21','15:55:00',3.81),('11288','2013-09-21','16:00:00',2.87),('11288','2013-09-21','16:05:00',2.08),('11288','2013-09-21','16:10:00',2.37),('11288','2013-09-21','16:15:00',2.2),('11288','2013-09-21','16:20:00',2.44),('11288','2013-09-21','16:25:00',1.33),('11288','2013-09-21','16:30:00',1.82),('11288','2013-09-21','16:35:00',2.22),('11288','2013-09-21','16:40:00',1.57),('11288','2013-09-21','16:45:00',1.3),('11288','2013-09-21','16:50:00',1.35),('11288','2013-09-21','16:55:00',1.84),('11288','2013-09-21','17:00:00',1.33),('11288','2013-09-21','17:05:00',1.37),('11288','2013-09-21','17:10:00',1.37),('11288','2013-09-21','17:15:00',1.45),('11288','2013-09-21','17:30:00',1.12),('11288','2013-09-21','17:35:00',1.26),('11288','2013-09-21','17:40:00',1.37),('11288','2013-09-21','17:45:00',1.27),('11288','2013-09-20','08:25:00',1.03),('11288','2013-09-20','08:30:00',1.55),('11288','2013-09-20','08:35:00',1.51),('11288','2013-09-20','08:40:00',1.71),('11288','2013-09-20','08:45:00',1.66),('11288','2013-09-20','08:50:00',1.61),('11288','2013-09-20','08:55:00',1.62),('11288','2013-09-20','09:00:00',1.8),('11288','2013-09-20','09:05:00',1.88),('11288','2013-09-20','09:10:00',1.92),('11288','2013-09-20','09:15:00',2.05),('11288','2013-09-20','09:20:00',2.06),('11288','2013-09-20','09:25:00',2.16),('11288','2013-09-20','09:30:00',2.1),('11288','2013-09-20','09:35:00',2.04),('11288','2013-09-20','09:40:00',2.11),('11288','2013-09-20','09:45:00',2.15),('11288','2013-09-20','09:50:00',2.27),('11288','2013-09-20','09:55:00',2.61),('11288','2013-09-20','10:00:00',3.06),('11288','2013-09-20','10:05:00',3.01),('11288','2013-09-20','10:10:00',3.52),('11288','2013-09-20','10:15:00',4.29),('11288','2013-09-20','10:20:00',5.35),('11288','2013-09-20','10:25:00',5.21),('11288','2013-09-20','10:30:00',5.42),('11288','2013-09-20','10:35:00',4.88),('11288','2013-09-20','10:40:00',5.82),('11288','2013-09-20','10:45:00',4.58),('11288','2013-09-20','10:50:00',4.27),('11288','2013-09-20','10:55:00',3.16),('11288','2013-09-20','11:00:00',3.1),('11288','2013-09-20','11:05:00',3.44),('11288','2013-09-20','11:10:00',3.87),('11288','2013-09-20','11:15:00',3.68),('11288','2013-09-20','11:20:00',3.52),('11288','2013-09-20','11:25:00',3.34),('11288','2013-09-20','11:30:00',4.57),('11288','2013-09-20','11:35:00',3.47),('11288','2013-09-20','11:40:00',6.49),('11288','2013-09-20','11:45:00',6.09),('11288','2013-09-20','11:50:00',5.91),('11288','2013-09-20','11:55:00',5.74),('11288','2013-09-20','12:00:00',5.74),('11288','2013-09-20','12:05:00',5.84),('11288','2013-09-20','12:10:00',5.9),('11288','2013-09-20','12:15:00',6.03),('11288','2013-09-20','12:20:00',6.21),('11288','2013-09-20','12:25:00',5.02),('11288','2013-09-20','12:30:00',5.12),('11288','2013-09-20','12:35:00',4.43),('11288','2013-09-20','12:40:00',4.2),('11288','2013-09-20','12:45:00',3.53),('11288','2013-09-20','12:50:00',6.38),('11288','2013-09-20','12:55:00',6.11),('11288','2013-09-20','13:00:00',5.46),('11288','2013-09-20','13:05:00',5.83),('11288','2013-09-20','13:10:00',5.66),('11288','2013-09-20','13:15:00',4.94),('11288','2013-09-20','13:20:00',4.06),('11288','2013-09-20','13:25:00',3.4),('11288','2013-09-20','13:30:00',6.05),('11288','2013-09-20','13:35:00',6.03),('11288','2013-09-20','13:40:00',5.44),('11288','2013-09-20','13:45:00',5.95),('11288','2013-09-20','13:50:00',5.53),('11288','2013-09-20','13:55:00',4.66),('11288','2013-09-20','14:00:00',1),('11288','2013-09-20','14:10:00',3.13),('11288','2013-09-20','14:15:00',6.13),('11288','2013-09-20','14:20:00',4.42),('11288','2013-09-20','14:25:00',5.49),('11288','2013-09-20','14:30:00',5.61),('11288','2013-09-20','14:35:00',5.01),('11288','2013-09-20','14:40:00',5.48),('11288','2013-09-20','14:45:00',5.6),('11288','2013-09-20','14:50:00',5.49),('11288','2013-09-20','14:55:00',5.53),('11288','2013-09-20','15:00:00',3.59),('11288','2013-09-20','15:05:00',5.81),('11288','2013-09-20','15:10:00',3.68),('11288','2013-09-20','15:15:00',3.27),('11288','2013-09-20','15:20:00',4.08),('11288','2013-09-20','15:25:00',3.63),('11288','2013-09-20','15:30:00',1.98),('11288','2013-09-20','15:35:00',4.72),('11288','2013-09-20','15:40:00',4.86),('11288','2013-09-20','15:45:00',4.57),('11288','2013-09-20','15:50:00',4.49),('11288','2013-09-20','15:55:00',4.54),('11288','2013-09-20','16:00:00',4.83),('11288','2013-09-20','16:05:00',3.09),('11288','2013-09-20','16:10:00',2.45),('11288','2013-09-20','16:15:00',3.62),('11288','2013-09-20','16:20:00',2.39),('11288','2013-09-20','16:25:00',2.9),('11288','2013-09-20','16:30:00',2.12),('11288','2013-09-20','16:35:00',1.39),('11288','2013-09-20','16:40:00',1.68),('11288','2013-09-20','16:45:00',2.98),('11288','2013-09-20','16:50:00',2.98),('11288','2013-09-20','16:55:00',3.12),('11288','2013-09-20','17:00:00',3.07),('11288','2013-09-20','17:05:00',3.17),('11288','2013-09-20','17:10:00',3.24),('11288','2013-09-20','17:15:00',3.07),('11288','2013-09-20','17:20:00',2.87),('11288','2013-09-20','17:25:00',2.58),('11288','2013-09-20','17:30:00',2.06),('11288','2013-09-20','17:35:00',1.5),('11288','2013-09-20','17:40:00',1.45),('11288','2013-09-20','17:45:00',1.63),('11288','2013-09-20','17:50:00',1.44),('11288','2013-09-20','17:55:00',1.39),('11288','2013-09-20','18:00:00',1.41),('11288','2013-09-20','18:05:00',1.53),('11288','2013-09-20','18:10:00',1.46),('11288','2013-09-20','18:15:00',1.3),('11288','2013-09-19','08:10:00',1.13),('11288','2013-09-19','08:20:00',1.07),('11288','2013-09-19','08:25:00',1.13),('11288','2013-09-19','08:30:00',1.39),('11288','2013-09-19','08:35:00',1.55),('11288','2013-09-19','08:40:00',1.53),('11288','2013-09-19','08:45:00',1.56),('11288','2013-09-19','08:50:00',1.48),('11288','2013-09-19','08:55:00',1.69),('11288','2013-09-19','09:00:00',1.66),('11288','2013-09-19','09:05:00',1.16),('11288','2013-09-19','09:10:00',2.3),('11288','2013-09-19','09:15:00',2.38),('11288','2013-09-19','09:20:00',1.91),('11288','2013-09-19','09:25:00',1.61),('11288','2013-09-19','09:30:00',1.56),('11288','2013-09-19','09:45:00',1.1),('11288','2013-09-19','09:55:00',1.11),('11288','2013-09-19','10:00:00',1.26),('11288','2013-09-19','10:05:00',3.7),('11288','2013-09-19','10:10:00',2.05),('11288','2013-09-19','10:15:00',1.82),('11288','2013-09-19','10:20:00',1.41),('11288','2013-09-19','10:25:00',1.84),('11288','2013-09-19','10:30:00',2.11),('11288','2013-09-19','10:35:00',5.3),('11288','2013-09-19','10:40:00',3.83),('11288','2013-09-19','10:45:00',2.94),('11288','2013-09-19','10:50:00',2.4),('11288','2013-09-19','10:55:00',5.64),('11288','2013-09-19','11:00:00',6.05),('11288','2013-09-19','11:05:00',3.39),('11288','2013-09-19','11:10:00',4.28),('11288','2013-09-19','11:15:00',2.81),('11288','2013-09-19','11:20:00',3.32),('11288','2013-09-19','11:25:00',3.98),('11288','2013-09-19','11:30:00',4.45),('11288','2013-09-19','11:35:00',4.44),('11288','2013-09-19','11:40:00',3.86),('11288','2013-09-19','11:45:00',5.03),('11288','2013-09-19','11:50:00',5.96),('11288','2013-09-19','11:55:00',4.34),('11288','2013-09-19','12:00:00',2.81),('11288','2013-09-19','12:05:00',3.17),('11288','2013-09-19','12:10:00',5.44),('11288','2013-09-19','12:15:00',3.46),('11288','2013-09-19','12:20:00',6.05),('11288','2013-09-19','12:25:00',5.44),('11288','2013-09-19','12:30:00',6.52),('11288','2013-09-19','12:35:00',6.27),('11288','2013-09-19','12:40:00',6.51),('11288','2013-09-19','12:45:00',5.22),('11288','2013-09-19','12:50:00',6.48),('11288','2013-09-19','12:55:00',6.43),('11288','2013-09-19','13:00:00',6.42),('11288','2013-09-19','13:05:00',6.53),('11288','2013-09-19','13:10:00',6.76),('11288','2013-09-19','13:15:00',6.74),('11288','2013-09-19','13:20:00',6.77),('11288','2013-09-19','13:25:00',6.27),('11288','2013-09-19','13:30:00',6.25),('11288','2013-09-19','13:35:00',6.39),('11288','2013-09-19','13:40:00',6.77),('11288','2013-09-19','13:45:00',6.92),('11288','2013-09-19','13:50:00',5.43),('11288','2013-09-19','13:55:00',2.09),('11288','2013-09-19','14:00:00',2.87),('11288','2013-09-19','14:05:00',6.54),('11288','2013-09-19','14:10:00',5.62),('11288','2013-09-19','14:15:00',5.46),('11288','2013-09-19','14:20:00',5.8),('11288','2013-09-19','14:25:00',5.69),('11288','2013-09-19','14:30:00',5.66),('11288','2013-09-19','14:35:00',5.63),('11288','2013-09-19','14:40:00',5.01),('11288','2013-09-19','14:45:00',5.45),('11288','2013-09-19','14:50:00',5.43),('11288','2013-09-19','14:55:00',5.48),('11288','2013-09-19','15:00:00',5.36),('11288','2013-09-19','15:05:00',5.26),('11288','2013-09-19','15:10:00',4.59),('11288','2013-09-19','15:15:00',4.97),('11288','2013-09-19','15:20:00',5.15),('11288','2013-09-19','15:25:00',4.72),('11288','2013-09-19','15:30:00',4.29),('11288','2013-09-19','15:35:00',4.02),('11288','2013-09-19','15:40:00',5.03),('11288','2013-09-19','15:45:00',4.73),('11288','2013-09-19','15:50:00',4.18),('11288','2013-09-19','15:55:00',3.99),('11288','2013-09-19','16:00:00',4.1),('11288','2013-09-19','16:05:00',3.94),('11288','2013-09-19','16:10:00',3.9),('11288','2013-09-19','16:15:00',3.8),('11288','2013-09-19','16:20:00',3.88),('11288','2013-09-19','16:25:00',3.45),('11288','2013-09-19','16:30:00',3.15),('11288','2013-09-19','16:35:00',3.1),('11288','2013-09-19','16:40:00',2.26),('11288','2013-09-19','16:45:00',2.84),('11288','2013-09-19','16:50:00',3.1),('11288','2013-09-19','16:55:00',2.91),('11288','2013-09-19','17:00:00',2.35),('11288','2013-09-19','17:05:00',2.34),('11288','2013-09-19','17:10:00',2.18),('11288','2013-09-19','17:15:00',2.09),('11288','2013-09-19','17:20:00',1.86),('11288','2013-09-19','17:25:00',1.79),('11288','2013-09-19','17:30:00',1.54),('11288','2013-09-19','17:35:00',1.46),('11288','2013-09-19','17:40:00',1.28),('11288','2013-09-19','17:45:00',1.01),('11288','2013-09-19','17:50:00',1.04),('11288','2014-04-13','08:30:00',1.19),('11288','2014-04-13','08:35:00',1.2),('11288','2014-04-13','08:40:00',1.22),('11288','2014-04-13','08:45:00',1.25),('11288','2014-04-13','08:50:00',1.2),('11288','2014-04-13','08:55:00',1.31),('11288','2014-04-13','09:00:00',1.66),('11288','2014-04-13','09:05:00',2.23),('11288','2014-04-13','09:10:00',2.65),('11288','2014-04-13','09:15:00',2.24),('11288','2014-04-13','09:20:00',2.36),('11288','2014-04-13','09:25:00',2.63),('11288','2014-04-13','09:30:00',3.31),('11288','2014-04-13','09:35:00',2.91),('11288','2014-04-13','09:40:00',3.46),('11288','2014-04-13','09:45:00',3.16),('11288','2014-04-13','09:50:00',2.42),('11288','2014-04-13','09:55:00',2.5),('11288','2014-04-13','10:00:00',3.89),('11288','2014-04-13','10:05:00',5.14),('11288','2014-04-13','10:10:00',4.4),('11288','2014-04-13','10:15:00',4.04),('11288','2014-04-13','10:20:00',4.35),('11288','2014-04-13','10:25:00',3.14),('11288','2014-04-13','10:30:00',4.86),('11288','2014-04-13','10:35:00',5.36),('11288','2014-04-13','10:40:00',5.41),('11288','2014-04-13','10:45:00',5.7),('11288','2014-04-13','10:50:00',5.74),('11288','2014-04-13','10:55:00',5.82),('11288','2014-04-13','11:00:00',5.9),('11288','2014-04-13','11:05:00',6.12),('11288','2014-04-13','11:10:00',5.94),('11288','2014-04-13','11:15:00',6.17),('11288','2014-04-13','11:20:00',7.28),('11288','2014-04-13','11:25:00',4.26),('11288','2014-04-13','11:30:00',3.61),('11288','2014-04-13','11:35:00',5.27),('11288','2014-04-13','11:40:00',6.42),('11288','2014-04-13','11:45:00',5.68),('11288','2014-04-13','11:50:00',6.34),('11288','2014-04-13','11:55:00',4.88),('11288','2014-04-13','12:00:00',3.54),('11288','2014-04-13','12:05:00',2.92),('11288','2014-04-13','12:10:00',2.59),('11288','2014-04-13','12:15:00',2.49),('11288','2014-04-13','12:20:00',2.29),('11288','2014-04-13','12:25:00',1.67),('11288','2014-04-13','12:30:00',1.15),('11288','2014-04-13','12:45:00',1.03),('11288','2014-04-13','12:50:00',1.17),('11288','2014-04-13','12:55:00',1.34),('11288','2014-04-13','13:00:00',1.47),('11288','2014-04-13','13:05:00',2.38),('11288','2014-04-13','13:10:00',3.53),('11288','2014-04-13','13:15:00',3.59),('11288','2014-04-13','13:20:00',4.64),('11288','2014-04-13','13:25:00',5.47),('11288','2014-04-13','13:30:00',7.51),('11288','2014-04-13','13:35:00',6.83),('11288','2014-04-13','13:40:00',6.24),('11288','2014-04-13','13:45:00',3.55),('11288','2014-04-13','13:50:00',5.12),('11288','2014-04-13','13:55:00',4.37),('11288','2014-04-13','14:00:00',6.86),('11288','2014-04-13','14:05:00',6.43),('11288','2014-04-13','14:10:00',6.49),('11288','2014-04-13','14:15:00',7.07),('11288','2014-04-13','14:20:00',3.35),('11288','2014-04-13','14:25:00',2.94),('11288','2014-04-13','14:30:00',3.07),('11288','2014-04-13','14:35:00',2.81),('11288','2014-04-13','14:40:00',2.44),('11288','2014-04-13','14:45:00',4.04),('11288','2014-04-13','14:50:00',6.43),('11288','2014-04-13','14:55:00',5.57),('11288','2014-04-13','15:00:00',5.51),('11288','2014-04-13','15:05:00',6.17),('11288','2014-04-13','15:10:00',6.3),('11288','2014-04-13','15:15:00',5.36),('11288','2014-04-13','15:20:00',5.29),('11288','2014-04-13','15:25:00',5.78),('11288','2014-04-13','15:30:00',5.43),('11288','2014-04-13','15:35:00',3.69),('11288','2014-04-13','15:40:00',2.43),('11288','2014-04-13','15:45:00',2.5),('11288','2014-04-13','15:50:00',3.07),('11288','2014-04-13','15:55:00',3.09),('11288','2014-04-13','16:00:00',5.53),('11288','2014-04-13','16:05:00',4.8),('11288','2014-04-13','16:10:00',2.14),('11288','2014-04-13','16:15:00',2.21),('11288','2014-04-13','16:20:00',2.27),('11288','2014-04-13','16:25:00',3.06),('11288','2014-04-13','16:30:00',2.5),('11288','2014-04-13','16:35:00',2.49),('11288','2014-04-13','16:40:00',4.02),('11288','2014-04-13','16:45:00',4.42),('11288','2014-04-13','16:50:00',3.84),('11288','2014-04-13','16:55:00',3.79),('11288','2014-04-13','17:00:00',2.87),('11288','2014-04-13','17:05:00',2.54),('11288','2014-04-13','17:10:00',1.75),('11288','2014-04-13','17:15:00',1.74),('11288','2014-04-13','17:20:00',2.47),('11288','2014-04-13','17:25:00',2.19),('11288','2014-04-13','17:30:00',1.53),('11288','2014-04-13','17:35:00',1.13),('11288','2014-04-13','17:40:00',1.27),('11288','2014-04-13','17:45:00',1.47),('11288','2014-04-13','17:50:00',1.58),('11288','2014-04-13','17:55:00',1.81),('11288','2014-04-13','18:00:00',1.78),('11288','2014-04-13','18:05:00',1.73),('11288','2013-09-18','08:15:00',1),('11288','2013-09-18','08:20:00',1.08),('11288','2013-09-18','08:25:00',1.06),('11288','2013-09-18','08:30:00',1.33),('11288','2013-09-18','08:35:00',1.05),('11288','2013-09-18','08:40:00',1.32),('11288','2013-09-18','08:45:00',1.71),('11288','2013-09-18','08:50:00',1.7),('11288','2013-09-18','08:55:00',1.79),('11288','2013-09-18','09:00:00',2.46),('11288','2013-09-18','09:05:00',1.9),('11288','2013-09-18','09:10:00',1.54),('11288','2013-09-18','09:15:00',2.02),('11288','2013-09-18','09:20:00',3.35),('11288','2013-09-18','09:25:00',2.27),('11288','2013-09-18','09:30:00',1.86),('11288','2013-09-18','09:35:00',3.43),('11288','2013-09-18','09:40:00',2),('11288','2013-09-18','09:45:00',1.13),('11288','2013-09-18','09:50:00',1.73),('11288','2013-09-18','09:55:00',3.01),('11288','2013-09-18','10:00:00',3.47),('11288','2013-09-18','10:05:00',4.61),('11288','2013-09-18','10:10:00',4.39),('11288','2013-09-18','10:15:00',4.25),('11288','2013-09-18','10:20:00',4.39),('11288','2013-09-18','10:25:00',4.45),('11288','2013-09-18','10:30:00',4.53),('11288','2013-09-18','10:35:00',4.6),('11288','2013-09-18','10:40:00',4.7),('11288','2013-09-18','10:45:00',4.76),('11288','2013-09-18','10:50:00',4.81),('11288','2013-09-18','10:55:00',5.17),('11288','2013-09-18','11:00:00',5.22),('11288','2013-09-18','11:05:00',5.32),('11288','2013-09-18','11:10:00',4.61),('11288','2013-09-18','11:15:00',3.33),('11288','2013-09-18','11:20:00',4.97),('11288','2013-09-18','11:25:00',5.88),('11288','2013-09-18','11:30:00',5.56),('11288','2013-09-18','11:35:00',4.8),('11288','2013-09-18','11:40:00',4.1),('11288','2013-09-18','11:45:00',5.75),('11288','2013-09-18','11:50:00',5.75),('11288','2013-09-18','11:55:00',5.57),('11288','2013-09-18','12:00:00',5.95),('11288','2013-09-18','12:05:00',6.17),('11288','2013-09-18','12:10:00',6.12),('11288','2013-09-18','12:15:00',6.3),('11288','2013-09-18','12:20:00',6.28),('11288','2013-09-18','12:25:00',2.58),('11288','2013-09-18','12:30:00',4.74),('11288','2013-09-18','12:35:00',6.92),('11288','2013-09-18','12:40:00',4.62),('11288','2013-09-18','12:45:00',6.24),('11288','2013-09-18','12:50:00',4.15),('11288','2013-09-18','12:55:00',4.1),('11288','2013-09-18','13:00:00',2.26),('11288','2013-09-18','13:05:00',6.71),('11288','2013-09-18','13:10:00',6.53),('11288','2013-09-18','13:15:00',6.36),('11288','2013-09-18','13:20:00',6.22),('11288','2013-09-18','13:25:00',6.28),('11288','2013-09-18','13:30:00',6.19),('11288','2013-09-18','13:35:00',6.2),('11288','2013-09-18','13:40:00',6.23),('11288','2013-09-18','13:45:00',6.32),('11288','2013-09-18','13:50:00',6.5),('11288','2013-09-18','13:55:00',6.26),('11288','2013-09-18','14:00:00',5.42),('11288','2013-09-18','14:05:00',4.4),('11288','2013-09-18','14:10:00',6.02),('11288','2013-09-18','14:15:00',5.33),('11288','2013-09-18','14:20:00',5.45),('11288','2013-09-18','14:25:00',5.79),('11288','2013-09-18','14:30:00',5.69),('11288','2013-09-18','14:35:00',5.66),('11288','2013-09-18','14:40:00',5.66),('11288','2013-09-18','14:45:00',5.45),('11288','2013-09-18','14:50:00',5.53),('11288','2013-09-18','14:55:00',4.3),('11288','2013-09-18','15:00:00',4.2),('11288','2013-09-18','15:05:00',3.71),('11288','2013-09-18','15:10:00',2.27),('11288','2013-09-18','15:15:00',4.98),('11288','2013-09-18','15:20:00',3.27),('11288','2013-09-18','15:25:00',4.56),('11288','2013-09-18','15:30:00',5.09),('11288','2013-09-18','15:35:00',4.53),('11288','2013-09-18','15:40:00',4.8),('11288','2013-09-18','15:45:00',4.57),('11288','2013-09-18','15:50:00',3.15),('11288','2013-09-18','15:55:00',4.19),('11288','2013-09-18','16:00:00',4.54),('11288','2013-09-18','16:05:00',4.54),('11288','2013-09-18','16:10:00',4.16),('11288','2013-09-18','16:15:00',3.93),('11288','2013-09-18','16:20:00',3.72),('11288','2013-09-18','16:25:00',3.24),('11288','2013-09-18','16:30:00',3.12),('11288','2013-09-18','16:35:00',2.9),('11288','2013-09-18','16:40:00',3.01),('11288','2013-09-18','16:45:00',2.93),('11288','2013-09-18','16:50:00',2.59),('11288','2013-09-18','16:55:00',2.54),('11288','2013-09-18','17:00:00',2.64),('11288','2013-09-18','17:05:00',2.36),('11288','2013-09-18','17:10:00',2.35),('11288','2013-09-18','17:15:00',2.02),('11288','2013-09-18','17:20:00',1.88),('11288','2013-09-18','17:25:00',1.84),('11288','2013-09-18','17:30:00',1.83),('11288','2013-09-18','17:35:00',1.65),('11288','2013-09-18','17:40:00',1.51),('11288','2013-09-18','17:45:00',1.37),('11288','2013-09-18','17:50:00',1.22),('11288','2013-09-18','17:55:00',1.01),('11288','2013-09-17','08:40:00',1.2),('11288','2013-09-17','08:45:00',1.24),('11288','2013-09-17','08:50:00',1.12),('11288','2013-09-17','08:55:00',1.18),('11288','2013-09-17','09:00:00',1.28),('11288','2013-09-17','09:05:00',1.24),('11288','2013-09-17','09:10:00',1.24),('11288','2013-09-17','09:15:00',1.51),('11288','2013-09-17','09:20:00',2.15),('11288','2013-09-17','09:25:00',1.56),('11288','2013-09-17','09:30:00',1.92),('11288','2013-09-17','09:35:00',1.25),('11288','2013-09-17','09:40:00',1.94),('11288','2013-09-17','09:45:00',2.65),('11288','2013-09-17','09:50:00',1.84),('11288','2013-09-17','09:55:00',3.03),('11288','2013-09-17','10:00:00',3.33),('11288','2013-09-17','10:05:00',2.38),('11288','2013-09-17','10:10:00',2.48),('11288','2013-09-17','10:15:00',1.01),('11288','2013-09-17','10:20:00',2.39),('11288','2013-09-17','10:25:00',3.83),('11288','2013-09-17','10:30:00',4.88),('11288','2013-09-17','10:35:00',2.62),('11288','2013-09-17','10:40:00',2.75),('11288','2013-09-17','10:45:00',3.95),('11288','2013-09-17','10:50:00',5.8),('11288','2013-09-17','10:55:00',4.71),('11288','2013-09-17','11:00:00',3.76),('11288','2013-09-17','11:05:00',3.67),('11288','2013-09-17','11:10:00',5.12),('11288','2013-09-17','11:15:00',4.39),('11288','2013-09-17','11:20:00',3.89),('11288','2013-09-17','11:25:00',2.79),('11288','2013-09-17','11:30:00',3.12),('11288','2013-09-17','11:35:00',4.52),('11288','2013-09-17','11:40:00',4.42),('11288','2013-09-17','11:45:00',4.74),('11288','2013-09-17','11:50:00',5.55),('11288','2013-09-17','11:55:00',5.45),('11288','2013-09-17','12:00:00',5.24),('11288','2013-09-17','12:05:00',4.85),('11288','2013-09-17','12:10:00',2.97),('11288','2013-09-17','12:15:00',3.22),('11288','2013-09-17','12:20:00',3.44),('11288','2013-09-17','12:25:00',6.58),('11288','2013-09-17','12:30:00',3.62),('11288','2013-09-17','12:35:00',3.98),('11288','2013-09-17','12:40:00',5.09),('11288','2013-09-17','12:45:00',7),('11288','2013-09-17','12:50:00',4.6),('11288','2013-09-17','12:55:00',5.23),('11288','2013-09-17','13:00:00',3.29),('11288','2013-09-17','13:05:00',2.43),('11288','2013-09-17','13:10:00',5.07),('11288','2013-09-17','13:15:00',4.26),('11288','2013-09-17','13:20:00',4.18),('11288','2013-09-17','13:25:00',3.57),('11288','2013-09-17','13:30:00',2.63),('11288','2013-09-17','13:35:00',3.73),('11288','2013-09-17','13:40:00',3.75),('11288','2013-09-17','13:45:00',2.27),('11288','2013-09-17','13:50:00',1.63),('11288','2013-09-17','13:55:00',2.65),('11288','2013-09-17','14:00:00',3.02),('11288','2013-09-17','14:05:00',2.25),('11288','2013-09-17','14:10:00',1.64),('11288','2013-09-17','14:15:00',2.29),('11288','2013-09-17','14:20:00',1.64),('11288','2013-09-17','14:25:00',3.04),('11288','2013-09-17','14:30:00',1.65),('11288','2013-09-17','14:35:00',2.05),('11288','2013-09-17','14:40:00',1.45),('11288','2013-09-17','14:45:00',1.49),('11288','2013-09-17','14:50:00',2.93),('11288','2013-09-17','14:55:00',5.84),('11288','2013-09-17','15:00:00',5.39),('11288','2013-09-17','15:05:00',4.57),('11288','2013-09-17','15:10:00',4.03),('11288','2013-09-17','15:15:00',4.89),('11288','2013-09-17','15:20:00',4.89),('11288','2013-09-17','15:25:00',4.37),('11288','2013-09-17','15:30:00',4.23),('11288','2013-09-17','15:35:00',2.19),('11288','2013-09-17','15:40:00',1.27),('11288','2013-09-17','15:45:00',2.44),('11288','2013-09-17','15:50:00',2.97),('11288','2013-09-17','15:55:00',3.25),('11288','2013-09-17','16:00:00',2.32),('11288','2013-09-17','16:05:00',3.27),('11288','2013-09-17','16:10:00',2.79),('11288','2013-09-17','16:15:00',2.53),('11288','2013-09-17','16:20:00',1.7),('11288','2013-09-17','16:25:00',1.16),('11288','2013-09-17','16:35:00',1.41),('11288','2013-09-17','16:40:00',2.11),('11288','2013-09-17','16:45:00',2.5),('11288','2013-09-17','16:50:00',2.05),('11288','2013-09-17','16:55:00',1.75),('11288','2013-09-17','17:00:00',2.42),('11288','2013-09-17','17:05:00',2.62),('11288','2013-09-17','17:10:00',2.43),('11288','2013-09-17','17:15:00',2.41),('11288','2013-09-17','17:20:00',1.93),('11288','2013-09-17','17:25:00',2.02),('11288','2013-09-17','17:30:00',1.68),('11288','2013-09-17','17:35:00',1.67),('11288','2013-09-17','17:40:00',1.56),('11288','2013-09-17','17:45:00',1.12),('11288','2013-09-17','17:50:00',1.2),('11288','2013-09-17','17:55:00',1.16),('11288','2013-09-16','08:10:00',1.18),('11288','2013-09-16','08:15:00',1.04),('11288','2013-09-16','08:20:00',1.23),('11288','2013-09-16','08:25:00',1.31),('11288','2013-09-16','08:30:00',1.44),('11288','2013-09-16','08:35:00',1.6),('11288','2013-09-16','08:40:00',1.71),('11288','2013-09-16','08:45:00',1.78),('11288','2013-09-16','08:50:00',1.36),('11288','2013-09-16','08:55:00',1.45),('11288','2013-09-16','09:00:00',1.4),('11288','2013-09-16','09:05:00',2.8),('11288','2013-09-16','09:10:00',2.06),('11288','2013-09-16','09:15:00',2.2),('11288','2013-09-16','09:20:00',2.78),('11288','2013-09-16','09:25:00',2.75),('11288','2013-09-16','09:30:00',2.2),('11288','2013-09-16','09:35:00',3.32),('11288','2013-09-16','09:40:00',3.44),('11288','2013-09-16','09:45:00',3.61),('11288','2013-09-16','09:50:00',3.75),('11288','2013-09-16','09:55:00',3.79),('11288','2013-09-16','10:00:00',4.1),('11288','2013-09-16','10:05:00',4.45),('11288','2013-09-16','10:10:00',2.59),('11288','2013-09-16','10:15:00',2.61),('11288','2013-09-16','10:20:00',3.6),('11288','2013-09-16','10:25:00',4.12),('11288','2013-09-16','10:30:00',5.08),('11288','2013-09-16','10:35:00',5.39),('11288','2013-09-16','10:40:00',5.68),('11288','2013-09-16','10:45:00',6.11),('11288','2013-09-16','10:50:00',3.97),('11288','2013-09-16','10:55:00',2.57),('11288','2013-09-16','11:00:00',3.29),('11288','2013-09-16','11:05:00',2.47),('11288','2013-09-16','11:10:00',1.08),('11288','2013-09-16','11:15:00',1.41),('11288','2013-09-16','11:20:00',1.54),('11288','2013-09-16','11:25:00',4.6),('11288','2013-09-16','11:30:00',3.93),('11288','2013-09-16','11:35:00',5.99),('11288','2013-09-16','11:40:00',6.05),('11288','2013-09-16','11:45:00',5.52),('11288','2013-09-16','11:50:00',6.11),('11288','2013-09-16','11:55:00',6.07),('11288','2013-09-16','12:00:00',6.28),('11288','2013-09-16','12:05:00',6.23),('11288','2013-09-16','12:10:00',6.08),('11288','2013-09-16','12:15:00',5.93),('11288','2013-09-16','12:20:00',6.24),('11288','2013-09-16','12:25:00',6.23),('11288','2013-09-16','12:30:00',6.18),('11288','2013-09-16','12:35:00',6.26),('11288','2013-09-16','12:40:00',6.52),('11288','2013-09-16','12:45:00',6.44),('11288','2013-09-16','12:50:00',7.45),('11288','2013-09-16','12:55:00',7.26),('11288','2013-09-16','13:00:00',7.01),('11288','2013-09-16','13:05:00',4.51),('11288','2013-09-16','13:10:00',6.85),('11288','2013-09-16','13:15:00',6.26),('11288','2013-09-16','13:20:00',6.17),('11288','2013-09-16','13:25:00',6.17),('11288','2013-09-16','13:30:00',6.13),('11288','2013-09-16','13:35:00',6.13),('11288','2013-09-16','13:40:00',6.11),('11288','2013-09-16','13:45:00',6.11),('11288','2013-09-16','13:50:00',6.14),('11288','2013-09-16','13:55:00',6.28),('11288','2013-09-16','14:00:00',6.18),('11288','2013-09-16','14:05:00',5.92),('11288','2013-09-16','14:10:00',5.83),('11288','2013-09-16','14:15:00',5.8),('11288','2013-09-16','14:20:00',5.74),('11288','2013-09-16','14:25:00',5.73),('11288','2013-09-16','14:30:00',5.67),('11288','2013-09-16','14:35:00',5.61),('11288','2013-09-16','14:40:00',5.53),('11288','2013-09-16','14:45:00',5.49),('11288','2013-09-16','14:50:00',5.48),('11288','2013-09-16','14:55:00',5.15),('11288','2013-09-16','15:00:00',5.36),('11288','2013-09-16','15:05:00',5.29),('11288','2013-09-16','15:10:00',5.24),('11288','2013-09-16','15:15:00',5.18),('11288','2013-09-16','15:20:00',5.07),('11288','2013-09-16','15:25:00',5),('11288','2013-09-16','15:30:00',4.89),('11288','2013-09-16','15:35:00',4.82),('11288','2013-09-16','15:40:00',4.73),('11288','2013-09-16','15:45:00',4.62),('11288','2013-09-16','15:50:00',4.53),('11288','2013-09-16','15:55:00',4.43),('11288','2013-09-16','16:00:00',4.35),('11288','2013-09-16','16:05:00',3.47),('11288','2013-09-16','16:10:00',4.2),('11288','2013-09-16','16:15:00',3.96),('11288','2013-09-16','16:20:00',3.84),('11288','2013-09-16','16:25:00',3.72),('11288','2013-09-16','16:30:00',3.58),('11288','2013-09-16','16:35:00',3.44),('11288','2013-09-16','16:40:00',3.35),('11288','2013-09-16','16:45:00',3.19),('11288','2013-09-16','16:50:00',3.05),('11288','2013-09-16','16:55:00',2.91),('11288','2013-09-16','17:00:00',2.77),('11288','2013-09-16','17:05:00',2.64),('11288','2013-09-16','17:10:00',2.47),('11288','2013-09-16','17:15:00',2.32),('11288','2013-09-16','17:20:00',2.19),('11288','2013-09-16','17:25:00',2.05),('11288','2013-09-16','17:30:00',1.87),('11288','2013-09-16','17:45:00',1.4),('11288','2013-09-16','17:50:00',1.18),('11288','2013-09-16','17:55:00',1.17),('11288','2013-09-16','18:00:00',1.02),('11288','2013-09-15','08:10:00',1),('11288','2013-09-15','08:15:00',1.07),('11288','2013-09-15','08:20:00',1.17),('11288','2013-09-15','08:25:00',1.31),('11288','2013-09-15','08:30:00',1.46),('11288','2013-09-15','08:35:00',1.63),('11288','2013-09-15','08:40:00',1.82),('11288','2013-09-15','08:45:00',1.93),('11288','2013-09-15','08:50:00',1.91),('11288','2013-09-15','08:55:00',1.93),('11288','2013-09-15','09:00:00',2.16),('11288','2013-09-15','09:05:00',2.23),('11288','2013-09-15','09:10:00',2.53),('11288','2013-09-15','09:15:00',2.83),('11288','2013-09-15','09:20:00',2.75),('11288','2013-09-15','09:25:00',2.92),('11288','2013-09-15','09:30:00',3.01),('11288','2013-09-15','09:35:00',3.34),('11288','2013-09-15','09:40:00',3.51),('11288','2013-09-15','09:45:00',3.63),('11288','2013-09-15','09:50:00',3.72),('11288','2013-09-15','09:55:00',3.89),('11288','2013-09-15','10:00:00',4.05),('11288','2013-09-15','10:05:00',4.24),('11288','2013-09-15','10:10:00',4.33),('11288','2013-09-15','10:15:00',4.26),('11288','2013-09-15','10:20:00',4.39),('11288','2013-09-15','10:25:00',4.44),('11288','2013-09-15','10:30:00',4.25),('11288','2013-09-15','10:35:00',2.09),('11288','2013-09-15','10:40:00',1.95),('11288','2013-09-15','10:45:00',1.11),('11288','2013-09-15','10:50:00',3.85),('11288','2013-09-15','10:55:00',5.71),('11288','2013-09-15','11:00:00',5.81),('11288','2013-09-15','11:05:00',5.57),('11288','2013-09-15','11:10:00',2.56),('11288','2013-09-15','11:15:00',1.77),('11288','2013-09-15','11:20:00',2.1),('11288','2013-09-15','11:25:00',1.49),('11288','2013-09-15','11:30:00',3.79),('11288','2013-09-15','11:35:00',3.1),('11288','2013-09-15','11:40:00',2.49),('11288','2013-09-15','11:45:00',4.34),('11288','2013-09-15','11:50:00',3.04),('11288','2013-09-15','11:55:00',2.71),('11288','2013-09-15','12:00:00',2.22),('11288','2013-09-15','12:05:00',2.05),('11288','2013-09-15','12:10:00',2.02),('11288','2013-09-15','12:15:00',2.22),('11288','2013-09-15','12:20:00',2.78),('11288','2013-09-15','12:25:00',3.01),('11288','2013-09-15','12:30:00',2.78),('11288','2013-09-15','12:35:00',2.54),('11288','2013-09-15','12:40:00',2.52),('11288','2013-09-15','12:45:00',2.09),('11288','2013-09-15','12:50:00',2.66),('11288','2013-09-15','12:55:00',2.34),('11288','2013-09-15','13:00:00',2.13),('11288','2013-09-15','13:05:00',1.72),('11288','2013-09-15','13:10:00',1.14),('11288','2013-09-15','13:20:00',1.32),('11288','2013-09-15','13:25:00',2.02),('11288','2013-09-15','13:30:00',1.97),('11288','2013-09-15','13:35:00',2.03),('11288','2013-09-15','13:40:00',2.38),('11288','2013-09-15','13:45:00',3.22),('11288','2013-09-15','13:50:00',2.78),('11288','2013-09-15','13:55:00',2.11),('11288','2013-09-15','14:00:00',3.32),('11288','2013-09-15','14:05:00',3.01),('11288','2013-09-15','14:10:00',2.64),('11288','2013-09-15','14:15:00',2.61),('11288','2013-09-15','14:20:00',2.52),('11288','2013-09-15','14:25:00',2.45),('11288','2013-09-15','14:30:00',2.26),('11288','2013-09-15','14:35:00',1.91),('11288','2013-09-15','14:40:00',1.94),('11288','2013-09-15','14:45:00',1.82),('11288','2013-09-15','14:50:00',1.92),('11288','2013-09-15','14:55:00',1.92),('11288','2013-09-15','15:00:00',1.96),('11288','2013-09-15','15:05:00',2.08),('11288','2013-09-15','15:10:00',2.44),('11288','2013-09-15','15:15:00',4.98),('11288','2013-09-15','15:20:00',3.41),('11288','2013-09-15','15:25:00',2.57),('11288','2013-09-15','15:30:00',1.93),('11288','2013-09-15','15:35:00',1.94),('11288','2013-09-15','15:40:00',1.8),('11288','2013-09-15','15:45:00',1.73),('11288','2013-09-15','15:50:00',1.71),('11288','2013-09-15','15:55:00',1.68),('11288','2013-09-15','16:00:00',1.41),('11288','2013-09-15','16:05:00',1.65),('11288','2013-09-15','16:10:00',1.27),('11288','2013-09-15','16:30:00',1.09),('11288','2013-09-15','16:35:00',1.12),('11288','2013-09-15','16:40:00',1.38),('11288','2013-09-15','16:45:00',1.13),('11288','2013-09-15','17:00:00',1),('11288','2013-09-15','17:15:00',1.04),('11288','2013-09-15','17:20:00',1.33),('11288','2013-09-15','17:25:00',1.02),('11288','2013-09-15','17:30:00',1.02),('11288','2013-09-15','18:00:00',1.03),('11288','2013-09-14','08:10:00',1.01),('11288','2013-09-14','08:15:00',1.08),('11288','2013-09-14','08:20:00',1.23),('11288','2013-09-14','08:25:00',1.36),('11288','2013-09-14','08:30:00',1.53),('11288','2013-09-14','08:35:00',1.61),('11288','2013-09-14','08:40:00',1.69),('11288','2013-09-14','08:45:00',1.89),('11288','2013-09-14','08:50:00',1.98),('11288','2013-09-14','08:55:00',2.02),('11288','2013-09-14','09:00:00',2.27),('11288','2013-09-14','09:05:00',2.38),('11288','2013-09-14','09:10:00',2.53),('11288','2013-09-14','09:15:00',2.64),('11288','2013-09-14','09:20:00',2.75),('11288','2013-09-14','09:25:00',2.88),('11288','2013-09-14','09:30:00',3.08),('11288','2013-09-14','09:35:00',3.21),('11288','2013-09-14','09:40:00',3.44),('11288','2013-09-14','09:45:00',3.59),('11288','2013-09-14','09:50:00',3.7),('11288','2013-09-14','09:55:00',2.92),('11288','2013-09-14','10:00:00',3.91),('11288','2013-09-14','10:05:00',4.09),('11288','2013-09-14','10:10:00',3.87),('11288','2013-09-14','10:15:00',3.99),('11288','2013-09-14','10:20:00',4.33),('11288','2013-09-14','10:25:00',4.52),('11288','2013-09-14','10:30:00',4.61),('11288','2013-09-14','10:35:00',4.97),('11288','2013-09-14','10:40:00',4.87),('11288','2013-09-14','10:45:00',4.17),('11288','2013-09-14','10:50:00',5.82),('11288','2013-09-14','10:55:00',4.3),('11288','2013-09-14','11:00:00',3.84),('11288','2013-09-14','11:05:00',1.98),('11288','2013-09-14','11:10:00',3.92),('11288','2013-09-14','11:15:00',1.21),('11288','2013-09-14','11:20:00',2.54),('11288','2013-09-14','11:25:00',4.72),('11288','2013-09-14','11:30:00',5.39),('11288','2013-09-14','11:35:00',5.82),('11288','2013-09-14','11:40:00',5.76),('11288','2013-09-14','11:45:00',5.97),('11288','2013-09-14','11:50:00',2.16),('11288','2013-09-14','11:55:00',1.55),('11288','2013-09-14','12:00:00',1.28),('11288','2013-09-14','12:05:00',1.88),('11288','2013-09-14','12:10:00',3.11),('11288','2013-09-14','12:15:00',1.46),('11288','2013-09-14','12:20:00',1.32),('11288','2013-09-14','12:25:00',1.05),('11288','2013-09-14','12:30:00',2.43),('11288','2013-09-14','12:35:00',4.56),('11288','2013-09-14','12:40:00',1.78),('11288','2013-09-14','12:45:00',1.55),('11288','2013-09-14','12:50:00',1.29),('11288','2013-09-14','12:55:00',1.7),('11288','2013-09-14','13:00:00',1.6),('11288','2013-09-14','13:05:00',1.47),('11288','2013-09-14','13:10:00',3.97),('11288','2013-09-14','13:15:00',7.02),('11288','2013-09-14','13:20:00',5.06),('11288','2013-09-14','13:25:00',6.79),('11288','2013-09-14','13:30:00',4.78),('11288','2013-09-14','13:35:00',2.92),('11288','2013-09-14','13:40:00',6.47),('11288','2013-09-14','13:45:00',3.85),('11288','2013-09-14','13:50:00',5.94),('11288','2013-09-14','13:55:00',7.05),('11288','2013-09-14','14:00:00',6.44),('11288','2013-09-14','14:05:00',6.06),('11288','2013-09-14','14:10:00',5.97),('11288','2013-09-14','14:15:00',5.96),('11288','2013-09-14','14:20:00',5.76),('11288','2013-09-14','14:25:00',5.84),('11288','2013-09-14','14:30:00',5.76),('11288','2013-09-14','14:35:00',5.69),('11288','2013-09-14','14:40:00',5.7),('11288','2013-09-14','14:45:00',5.57),('11288','2013-09-14','14:50:00',5.52),('11288','2013-09-14','14:55:00',5.49),('11288','2013-09-14','15:00:00',5.36),('11288','2013-09-14','15:05:00',5.27),('11288','2013-09-14','15:10:00',5.22),('11288','2013-09-14','15:15:00',5.16),('11288','2013-09-14','15:20:00',5.08),('11288','2013-09-14','15:25:00',3.38),('11288','2013-09-14','15:30:00',5.06),('11288','2013-09-14','15:35:00',4.87),('11288','2013-09-14','15:40:00',4.74),('11288','2013-09-14','15:45:00',4.62),('11288','2013-09-14','15:50:00',4.53),('11288','2013-09-14','15:55:00',4.42),('11288','2013-09-14','16:00:00',4.28),('11288','2013-09-14','16:05:00',4.16),('11288','2013-09-14','16:10:00',4.03),('11288','2013-09-14','16:15:00',3.94),('11288','2013-09-14','16:20:00',3.78),('11288','2013-09-14','16:25:00',3.74),('11288','2013-09-14','16:30:00',3.62),('11288','2013-09-14','16:35:00',3.45),('11288','2013-09-14','16:40:00',3.31),('11288','2013-09-14','16:45:00',3.17),('11288','2013-09-14','16:50:00',3.06),('11288','2013-09-14','16:55:00',2.93),('11288','2013-09-14','17:00:00',2.77),('11288','2013-09-14','17:05:00',2.66),('11288','2013-09-14','17:10:00',2.5),('11288','2013-09-14','17:15:00',2.38),('11288','2013-09-14','17:20:00',2.24),('11288','2013-09-14','17:25:00',2.09),('11288','2013-09-14','17:30:00',1.94),('11288','2013-09-14','17:40:00',1.46),('11288','2013-09-14','17:45:00',1.5),('11288','2013-09-14','17:50:00',1.44),('11288','2013-09-14','17:55:00',1.26),('11288','2013-09-13','08:15:00',1.03),('11288','2013-09-13','08:20:00',1.24),('11288','2013-09-13','08:25:00',1.48),('11288','2013-09-13','08:30:00',1.33),('11288','2013-09-13','08:35:00',1.19),('11288','2013-09-13','08:40:00',1.29),('11288','2013-09-13','08:45:00',1.49),('11288','2013-09-13','08:50:00',1.66),('11288','2013-09-13','08:55:00',1.74),('11288','2013-09-13','09:00:00',1.77),('11288','2013-09-13','09:05:00',1.7),('11288','2013-09-13','09:10:00',1.64),('11288','2013-09-13','09:15:00',1.71),('11288','2013-09-13','09:20:00',1.77),('11288','2013-09-13','09:25:00',1.97),('11288','2013-09-13','09:30:00',2.09),('11288','2013-09-13','09:35:00',2.25),('11288','2013-09-13','09:40:00',2.41),('11288','2013-09-13','09:45:00',2.29),('11288','2013-09-13','09:50:00',2.71),('11288','2013-09-13','09:55:00',3.8),('11288','2013-09-13','10:00:00',2.77),('11288','2013-09-13','10:05:00',2.4),('11288','2013-09-13','10:10:00',3.91),('11288','2013-09-13','10:15:00',5.82),('11288','2013-09-13','10:20:00',5.48),('11288','2013-09-13','10:25:00',2.81),('11288','2013-09-13','10:30:00',4.41),('11288','2013-09-13','10:35:00',4.69),('11288','2013-09-13','10:40:00',4.99),('11288','2013-09-13','10:45:00',4.98),('11288','2013-09-13','10:50:00',5.06),('11288','2013-09-13','10:55:00',5.14),('11288','2013-09-13','11:00:00',5.21),('11288','2013-09-13','11:05:00',5.28),('11288','2013-09-13','11:10:00',5.34),('11288','2013-09-13','11:15:00',5.44),('11288','2013-09-13','11:20:00',5.46),('11288','2013-09-13','11:25:00',5.49),('11288','2013-09-13','11:30:00',5.53),('11288','2013-09-13','11:35:00',5.62),('11288','2013-09-13','11:40:00',5.64),('11288','2013-09-13','11:45:00',5.67),('11288','2013-09-13','11:50:00',5.73),('11288','2013-09-13','11:55:00',5.76),('11288','2013-09-13','12:00:00',5.85),('11288','2013-09-13','12:05:00',6.01),('11288','2013-09-13','12:10:00',6.04),('11288','2013-09-13','12:15:00',6.08),('11288','2013-09-13','12:20:00',6.15),('11288','2013-09-13','12:25:00',6.18),('11288','2013-09-13','12:30:00',6.26),('11288','2013-09-13','12:35:00',6.25),('11288','2013-09-13','12:40:00',6.35),('11288','2013-09-13','12:45:00',6.37),('11288','2013-09-13','12:50:00',6.41),('11288','2013-09-13','12:55:00',6.35),('11288','2013-09-13','13:00:00',6.24),('11288','2013-09-13','13:05:00',6.22),('11288','2013-09-13','13:10:00',6.15),('11288','2013-09-13','13:15:00',6.13),('11288','2013-09-13','13:20:00',6.12),('11288','2013-09-13','13:25:00',6.1),('11288','2013-09-13','13:30:00',6.07),('11288','2013-09-13','13:35:00',6.02),('11288','2013-09-13','13:40:00',5.98),('11288','2013-09-13','13:45:00',6),('11288','2013-09-13','13:50:00',5.93),('11288','2013-09-13','13:55:00',5.89),('11288','2013-09-13','14:00:00',5.86),('11288','2013-09-13','14:05:00',5.83),('11288','2013-09-13','14:10:00',5.83),('11288','2013-09-13','14:15:00',5.82),('11288','2013-09-13','14:20:00',5.83),('11288','2013-09-13','14:25:00',2.74),('11288','2013-09-13','14:35:00',4.71),('11288','2013-09-13','14:40:00',5.8),('11288','2013-09-13','14:45:00',5.1),('11288','2013-09-13','14:50:00',5.63),('11288','2013-09-13','14:55:00',5.52),('11288','2013-09-13','15:00:00',5.47),('11288','2013-09-13','15:05:00',5.43),('11288','2013-09-13','15:10:00',5.34),('11288','2013-09-13','15:15:00',5.22),('11288','2013-09-13','15:20:00',5.2),('11288','2013-09-13','15:25:00',5.04),('11288','2013-09-13','15:30:00',4.99),('11288','2013-09-13','15:35:00',4.91),('11288','2013-09-13','15:40:00',4.79),('11288','2013-09-13','15:45:00',4.7),('11288','2013-09-13','15:50:00',4.61),('11288','2013-09-13','15:55:00',4.49),('11288','2013-09-13','16:00:00',4.37),('11288','2013-09-13','16:05:00',4.28),('11288','2013-09-13','16:10:00',4.16),('11288','2013-09-13','16:15:00',4.04),('11288','2013-09-13','16:20:00',3.92),('11288','2013-09-13','16:25:00',3.83),('11288','2013-09-13','16:30:00',3.68),('11288','2013-09-13','16:35:00',3.52),('11288','2013-09-13','16:40:00',3.39),('11288','2013-09-13','16:45:00',3.27),('11288','2013-09-13','16:50:00',3.11),('11288','2013-09-13','16:55:00',2.98),('11288','2013-09-13','17:00:00',2.82),('11288','2013-09-13','17:05:00',2.69),('11288','2013-09-13','17:10:00',2.55),('11288','2013-09-13','17:15:00',2.42),('11288','2013-09-13','17:20:00',2.27),('11288','2013-09-13','17:25:00',2.12),('11288','2013-09-13','17:30:00',1.96),('11288','2013-09-13','17:35:00',1.82),('11288','2013-09-13','17:40:00',1.71),('11288','2013-09-13','17:45:00',1.58),('11288','2013-09-13','17:50:00',1.45),('11288','2013-09-13','17:55:00',1.33),('11288','2013-09-13','18:00:00',1.17),('11288','2013-09-13','18:05:00',1.02),('11288','2013-09-12','07:55:00',1.13),('11288','2013-09-12','08:00:00',1.32),('11288','2013-09-12','08:15:00',1.42),('11288','2013-09-12','08:20:00',1.45),('11288','2013-09-12','08:25:00',1.89),('11288','2013-09-12','08:30:00',2.13),('11288','2013-09-12','08:35:00',2.04),('11288','2013-09-12','08:40:00',1.59),('11288','2013-09-12','08:45:00',1.26),('11288','2013-09-12','08:50:00',1.03),('11288','2013-09-12','08:55:00',1.68),('11288','2013-09-12','09:00:00',2.4),('11288','2013-09-12','09:05:00',2.32),('11288','2013-09-12','09:10:00',1.73),('11288','2013-09-12','09:15:00',2.79),('11288','2013-09-12','09:20:00',2.9),('11288','2013-09-12','09:25:00',3.01),('11288','2013-09-12','09:30:00',3.32),('11288','2013-09-12','09:35:00',3.22),('11288','2013-09-12','09:40:00',2.71),('11288','2013-09-12','09:45:00',3.36),('11288','2013-09-12','09:50:00',2.98),('11288','2013-09-12','09:55:00',2.01),('11288','2013-09-12','10:00:00',1.84),('11288','2013-09-12','10:05:00',2.53),('11288','2013-09-12','10:10:00',2.94),('11288','2013-09-12','10:15:00',2.93),('11288','2013-09-12','10:20:00',1.92),('11288','2013-09-12','10:25:00',1.92),('11288','2013-09-12','10:30:00',3.63),('11288','2013-09-12','10:35:00',2.96),('11288','2013-09-12','10:40:00',1.1),('11288','2013-09-12','10:50:00',1.04),('11288','2013-09-12','10:55:00',3.08),('11288','2013-09-12','11:00:00',4.15),('11288','2013-09-12','11:05:00',5.77),('11288','2013-09-12','11:10:00',4.24),('11288','2013-09-12','11:15:00',3.96),('11288','2013-09-12','11:20:00',2.64),('11288','2013-09-12','11:40:00',2.48),('11288','2013-09-12','11:45:00',3.77),('11288','2013-09-12','11:50:00',2.81),('11288','2013-09-12','11:55:00',3.04),('11288','2013-09-12','12:00:00',4.81),('11288','2013-09-12','12:05:00',5.7),('11288','2013-09-12','12:10:00',3.67),('11288','2013-09-12','12:15:00',3.33),('11288','2013-09-12','12:20:00',2.35),('11288','2013-09-12','12:25:00',2.87),('11288','2013-09-12','12:30:00',2.41),('11288','2013-09-12','12:35:00',4.92),('11288','2013-09-12','12:40:00',4.11),('11288','2013-09-12','12:45:00',1.71),('11288','2013-09-12','12:50:00',2.42),('11288','2013-09-12','12:55:00',4.27),('11288','2013-09-12','13:00:00',5.88),('11288','2013-09-12','13:05:00',3.48),('11288','2013-09-12','13:10:00',4.66),('11288','2013-09-12','13:15:00',6.62),('11288','2013-09-12','13:20:00',6.96),('11288','2013-09-12','13:25:00',6.54),('11288','2013-09-12','13:30:00',5.64),('11288','2013-09-12','13:35:00',3.17),('11288','2013-09-12','13:40:00',4.65),('11288','2013-09-12','13:45:00',3.79),('11288','2013-09-12','13:50:00',5.97),('11288','2013-09-12','13:55:00',6.39),('11288','2013-09-12','14:00:00',5.3),('11288','2013-09-12','14:05:00',6.25),('11288','2013-09-12','14:10:00',5.89),('11288','2013-09-12','14:15:00',5.63),('11288','2013-09-12','14:20:00',6.11),('11288','2013-09-12','14:25:00',5.96),('11288','2013-09-12','14:30:00',6.25),('11288','2013-09-12','14:35:00',3),('11288','2013-09-12','14:40:00',5.33),('11288','2013-09-12','14:45:00',5.8),('11288','2013-09-12','14:50:00',5.83),('11288','2013-09-12','14:55:00',5.7),('11288','2013-09-12','15:00:00',4.59),('11288','2013-09-12','15:05:00',3.61),('11288','2013-09-12','15:10:00',5.14),('11288','2013-09-12','15:15:00',5.37),('11288','2013-09-12','15:20:00',5.28),('11288','2013-09-12','15:25:00',5),('11288','2013-09-12','15:30:00',5.14),('11288','2013-09-12','15:35:00',5.01),('11288','2013-09-12','15:40:00',4.97),('11288','2013-09-12','15:45:00',4.86),('11288','2013-09-12','15:50:00',4.77),('11288','2013-09-12','15:55:00',4.69),('11288','2013-09-12','16:00:00',4.3),('11288','2013-09-12','16:05:00',3.53),('11288','2013-09-12','16:10:00',4.67),('11288','2013-09-12','16:15:00',2.79),('11288','2013-09-12','16:20:00',3.61),('11288','2013-09-12','16:25:00',2.49),('11288','2013-09-12','16:30:00',3.7),('11288','2013-09-12','16:35:00',1.95),('11288','2013-09-12','16:40:00',3.9),('11288','2013-09-12','16:45:00',2.8),('11288','2013-09-12','16:50:00',1.23),('11288','2013-09-12','16:55:00',1.72),('11288','2013-09-12','17:00:00',2.96),('11288','2013-09-12','17:05:00',2.84),('11288','2013-09-12','17:10:00',2.23),('11288','2013-09-12','17:15:00',1.7),('11288','2013-09-12','17:20:00',1.27),('11288','2013-09-12','17:30:00',2.21),('11288','2013-09-12','17:35:00',2.1),('11288','2013-09-12','17:40:00',1.93),('11288','2013-09-12','17:45:00',1.62),('11288','2013-09-12','17:50:00',1.23),('11288','2013-09-12','17:55:00',1.29),('11288','2013-09-12','18:00:00',1.12),('11288','2013-09-11','08:05:00',1.19),('11288','2013-09-11','08:10:00',1.62),('11288','2013-09-11','08:15:00',1.32),('11288','2013-09-11','08:25:00',1.11),('11288','2013-09-11','08:30:00',1.55),('11288','2013-09-11','08:35:00',1.24),('11288','2013-09-11','08:40:00',1.31),('11288','2013-09-11','08:45:00',1.18),('11288','2013-09-11','08:50:00',1.5),('11288','2013-09-11','08:55:00',2.05),('11288','2013-09-11','09:00:00',2.21),('11288','2013-09-11','09:05:00',2.34),('11288','2013-09-11','09:10:00',2.48),('11288','2013-09-11','09:15:00',3.1),('11288','2013-09-11','09:20:00',3.38),('11288','2013-09-11','09:25:00',2.41),('11288','2013-09-11','09:30:00',2.11),('11288','2013-09-11','09:35:00',3.04),('11288','2013-09-11','09:40:00',2.09),('11288','2013-09-11','09:45:00',1.3),('11288','2013-09-11','09:50:00',1.6),('11288','2013-09-11','09:55:00',1.46),('11288','2013-09-11','10:00:00',1.95),('11288','2013-09-11','10:05:00',3.03),('11288','2013-09-11','10:15:00',3.67),('11288','2013-09-11','10:20:00',2.85),('11288','2013-09-11','10:25:00',3.75),('11288','2013-09-11','10:30:00',5.04),('11288','2013-09-11','10:35:00',3.95),('11288','2013-09-11','10:40:00',4.91),('11288','2013-09-11','10:45:00',5.39),('11288','2013-09-11','10:50:00',3.24),('11288','2013-09-11','10:55:00',3.44),('11288','2013-09-11','11:00:00',2.27),('11288','2013-09-11','11:05:00',5.03),('11288','2013-09-11','11:10:00',3.86),('11288','2013-09-11','11:15:00',6.13),('11288','2013-09-11','11:20:00',5.07),('11288','2013-09-11','11:25:00',2.57),('11288','2013-09-11','11:30:00',3.96),('11288','2013-09-11','11:35:00',2.34),('11288','2013-09-11','11:40:00',6.11),('11288','2013-09-11','11:45:00',5.98),('11288','2013-09-11','11:50:00',6.05),('11288','2013-09-11','11:55:00',5.22),('11288','2013-09-11','12:00:00',6.48),('11288','2013-09-11','12:05:00',4.26),('11288','2013-09-11','12:10:00',5.14),('11288','2013-09-11','12:15:00',3.39),('11288','2013-09-11','12:20:00',4.15),('11288','2013-09-11','12:25:00',4.61),('11288','2013-09-11','12:30:00',3.05),('11288','2013-09-11','12:35:00',5.33),('11288','2013-09-11','12:40:00',5.27),('11288','2013-09-11','12:45:00',5.5),('11288','2013-09-11','12:50:00',7.2),('11288','2013-09-11','12:55:00',3.71),('11288','2013-09-11','13:00:00',6.62),('11288','2013-09-11','13:05:00',6.62),('11288','2013-09-11','13:10:00',6.64),('11288','2013-09-11','13:15:00',6.76),('11288','2013-09-11','13:20:00',6.08),('11288','2013-09-11','13:25:00',5.97),('11288','2013-09-11','13:30:00',4.54),('11288','2013-09-11','13:35:00',7.25),('11288','2013-09-11','13:40:00',3.99),('11288','2013-09-11','13:45:00',6.42),('11288','2013-09-11','13:50:00',5.47),('11288','2013-09-11','13:55:00',4.35),('11288','2013-09-11','14:00:00',6.17),('11288','2013-09-11','14:05:00',5.29),('11288','2013-09-11','14:10:00',5.13),('11288','2013-09-11','14:15:00',5.47),('11288','2013-09-11','14:20:00',5.36),('11288','2013-09-11','14:25:00',4.8),('11288','2013-09-11','14:30:00',3.93),('11288','2013-09-11','14:35:00',4.04),('11288','2013-09-11','14:40:00',3.91),('11288','2013-09-11','14:45:00',5.44),('11288','2013-09-11','14:50:00',4.66),('11288','2013-09-11','14:55:00',2.88),('11288','2013-09-11','15:00:00',6.12),('11288','2013-09-11','15:05:00',5.69),('11288','2013-09-11','15:10:00',4.75),('11288','2013-09-11','15:15:00',5.9),('11288','2013-09-11','15:20:00',4.57),('11288','2013-09-11','15:25:00',2.45),('11288','2013-09-11','15:30:00',2.45),('11288','2013-09-11','15:35:00',1.64),('11288','2013-09-11','15:40:00',2.01),('11288','2013-09-11','15:45:00',4.32),('11288','2013-09-11','15:50:00',4.13),('11288','2013-09-11','15:55:00',4.89),('11288','2013-09-11','16:00:00',3.81),('11288','2013-09-11','16:05:00',4.9),('11288','2013-09-11','16:10:00',4.53),('11288','2013-09-11','16:15:00',4.24),('11288','2013-09-11','16:20:00',3.07),('11288','2013-09-11','16:25:00',2.88),('11288','2013-09-11','16:30:00',2.54),('11288','2013-09-11','16:35:00',2.99),('11288','2013-09-11','16:40:00',3.12),('11288','2013-09-11','16:45:00',3.11),('11288','2013-09-11','16:50:00',3.26),('11288','2013-09-11','16:55:00',1.64),('11288','2013-09-11','17:00:00',2.94),('11288','2013-09-11','17:05:00',2.74),('11288','2013-09-11','17:10:00',2.7),('11288','2013-09-11','17:15:00',2.49),('11288','2013-09-11','17:20:00',2.31),('11288','2013-09-11','17:25:00',2.16),('11288','2013-09-11','17:30:00',2.07),('11288','2013-09-11','17:35:00',1.96),('11288','2013-09-11','17:40:00',1.36),('11288','2013-09-11','17:45:00',1.14),('11288','2013-09-11','17:50:00',1.14),('11288','2013-09-11','17:55:00',1),('11288','2013-09-11','18:00:00',1.27),('11288','2013-09-11','18:05:00',1.14),('11288','2013-09-10','07:55:00',1.06),('11288','2013-09-10','08:00:00',1.11),('11288','2013-09-10','08:05:00',1.03),('11288','2013-09-10','08:10:00',1.13),('11288','2013-09-10','08:15:00',1.35),('11288','2013-09-10','08:20:00',1.21),('11288','2013-09-10','08:25:00',1.05),('11288','2013-09-10','08:35:00',1.01),('11288','2013-09-10','08:40:00',1.22),('11288','2013-09-10','08:45:00',1.39),('11288','2013-09-10','08:50:00',1.18),('11288','2013-09-10','08:55:00',1.89),('11288','2013-09-10','09:00:00',2.29),('11288','2013-09-10','09:05:00',2.65),('11288','2013-09-10','09:10:00',3.27),('11288','2013-09-10','09:15:00',2.77),('11288','2013-09-10','09:20:00',2.25),('11288','2013-09-10','09:25:00',2.33),('11288','2013-09-10','09:30:00',3.84),('11288','2013-09-10','09:35:00',4.09),('11288','2013-09-10','09:40:00',2.69),('11288','2013-09-10','09:45:00',2.25),('11288','2013-09-10','09:50:00',2.07),('11288','2013-09-10','09:55:00',1.84),('11288','2013-09-10','10:00:00',1.45),('11288','2013-09-10','10:05:00',1.29),('11288','2013-09-10','10:10:00',1.06),('11288','2013-09-10','10:15:00',1.1),('11288','2013-09-10','10:20:00',1.52),('11288','2013-09-10','10:25:00',1.74),('11288','2013-09-10','10:30:00',1.73),('11288','2013-09-10','10:35:00',2.01),('11288','2013-09-10','10:40:00',2.65),('11288','2013-09-10','10:45:00',3.48),('11288','2013-09-10','10:50:00',2.12),('11288','2013-09-10','10:55:00',2.32),('11288','2013-09-10','11:00:00',2.73),('11288','2013-09-10','11:05:00',2.4),('11288','2013-09-10','11:10:00',2.35),('11288','2013-09-10','11:15:00',2.07),('11288','2013-09-10','11:20:00',2.25),('11288','2013-09-10','11:25:00',2.37),('11288','2013-09-10','11:30:00',1.82),('11288','2013-09-10','11:35:00',1.27),('11288','2013-09-10','11:40:00',1.42),('11288','2013-09-10','11:45:00',2.23),('11288','2013-09-10','11:50:00',2.22),('11288','2013-09-10','11:55:00',2.61),('11288','2013-09-10','12:00:00',2.29),('11288','2013-09-10','12:05:00',1.76),('11288','2013-09-10','12:10:00',1.8),('11288','2013-09-10','12:15:00',1.9),('11288','2013-09-10','12:20:00',1.76),('11288','2013-09-10','12:25:00',1.62),('11288','2013-09-10','12:30:00',1.45),('11288','2013-09-10','12:35:00',1.44),('11288','2013-09-10','12:40:00',1.14),('11288','2013-09-10','12:45:00',1.13),('11288','2013-09-10','12:50:00',1.13),('11288','2013-09-10','12:55:00',1.17),('11288','2013-09-10','13:00:00',1.43),('11288','2013-09-10','13:05:00',1.14),('11288','2013-09-10','13:10:00',1.12),('11288','2013-09-10','13:15:00',1.54),('11288','2013-09-10','13:20:00',1.63),('11288','2013-09-10','13:25:00',1.91),('11288','2013-09-10','13:30:00',1.75),('11288','2013-09-10','13:35:00',1.94),('11288','2013-09-10','13:40:00',3.22),('11288','2013-09-10','13:45:00',4.58),('11288','2013-09-10','13:50:00',3.02),('11288','2013-09-10','13:55:00',2.56),('11288','2013-09-10','14:00:00',1.96),('11288','2013-09-10','14:05:00',2.26),('11288','2013-09-10','14:10:00',2.34),('11288','2013-09-10','14:15:00',2.75),('11288','2013-09-10','14:20:00',2.71),('11288','2013-09-10','14:25:00',3.72),('11288','2013-09-10','14:30:00',3.15),('11288','2013-09-10','14:35:00',2.5),('11288','2013-09-10','14:40:00',3.01),('11288','2013-09-10','14:45:00',3.15),('11288','2013-09-10','14:50:00',3.58),('11288','2013-09-10','14:55:00',3.06),('11288','2013-09-10','15:00:00',4.16),('11288','2013-09-10','15:05:00',3.58),('11288','2013-09-10','15:10:00',2.77),('11288','2013-09-10','15:15:00',2.72),('11288','2013-09-10','15:20:00',3.21),('11288','2013-09-10','15:25:00',2.9),('11288','2013-09-10','15:30:00',3.4),('11288','2013-09-10','15:35:00',2.63),('11288','2013-09-10','15:40:00',1.99),('11288','2013-09-10','15:45:00',1.77),('11288','2013-09-10','15:50:00',1.87),('11288','2013-09-10','15:55:00',1.76),('11288','2013-09-10','16:00:00',1.77),('11288','2013-09-10','16:05:00',1.88),('11288','2013-09-10','16:10:00',2.21),('11288','2013-09-10','16:15:00',2.37),('11288','2013-09-10','16:20:00',1.72),('11288','2013-09-10','16:25:00',1.63),('11288','2013-09-10','16:30:00',1.3),('11288','2013-09-10','16:45:00',1.13),('11288','2013-09-10','16:50:00',1.41),('11288','2013-09-10','16:55:00',1.39),('11288','2013-09-10','17:00:00',1.22),('11288','2013-09-10','17:05:00',1.13),('11288','2013-09-10','17:10:00',1.19),('11288','2013-09-10','17:15:00',1.41),('11288','2013-09-10','17:20:00',1.4),('11288','2013-09-10','17:25:00',1.34),('11288','2013-09-10','17:30:00',1.2),('11288','2013-09-10','17:45:00',1.16),('11288','2013-09-10','17:50:00',1.28),('11288','2013-09-10','17:55:00',1.06),('11288','2013-09-09','07:35:00',1.11),('11288','2013-09-09','07:40:00',1.41),('11288','2013-09-09','07:45:00',1.55),('11288','2013-09-09','07:50:00',1.47),('11288','2013-09-09','07:55:00',1.4),('11288','2013-09-09','08:00:00',1.27),('11288','2013-09-09','08:25:00',1.03),('11288','2013-09-09','08:40:00',1.2),('11288','2013-09-09','08:45:00',1.54),('11288','2013-09-09','08:50:00',1.74),('11288','2013-09-09','08:55:00',2.02),('11288','2013-09-09','09:00:00',2),('11288','2013-09-09','09:05:00',1.87),('11288','2013-09-09','09:10:00',1.61),('11288','2013-09-09','09:15:00',1.05),('11288','2013-09-09','09:20:00',1.44),('11288','2013-09-09','09:25:00',1.14),('11288','2013-09-09','09:30:00',1.38),('11288','2013-09-09','09:35:00',2.03),('11288','2013-09-09','09:40:00',1.63),('11288','2013-09-09','09:45:00',1),('11288','2013-09-09','09:50:00',1.35),('11288','2013-09-09','09:55:00',1.39),('11288','2013-09-09','10:00:00',2.59),('11288','2013-09-09','10:05:00',3.02),('11288','2013-09-09','10:10:00',2.93),('11288','2013-09-09','10:15:00',2.86),('11288','2013-09-09','10:20:00',2.76),('11288','2013-09-09','10:25:00',2.74),('11288','2013-09-09','10:30:00',2.63),('11288','2013-09-09','10:35:00',2.73),('11288','2013-09-09','10:40:00',2.87),('11288','2013-09-09','10:45:00',3.27),('11288','2013-09-09','10:50:00',4.1),('11288','2013-09-09','10:55:00',3.98),('11288','2013-09-09','11:00:00',4.36),('11288','2013-09-09','11:05:00',3.62),('11288','2013-09-09','11:10:00',3.44),('11288','2013-09-09','11:15:00',3.36),('11288','2013-09-09','11:20:00',3.57),('11288','2013-09-09','11:25:00',3.78),('11288','2013-09-09','11:30:00',3.46),('11288','2013-09-09','11:35:00',3.71),('11288','2013-09-09','11:40:00',5.05),('11288','2013-09-09','11:45:00',5.16),('11288','2013-09-09','11:50:00',5.6),('11288','2013-09-09','11:55:00',4.98),('11288','2013-09-09','12:00:00',4.43),('11288','2013-09-09','12:05:00',4.11),('11288','2013-09-09','12:10:00',4.61),('11288','2013-09-09','12:15:00',3.3),('11288','2013-09-09','12:20:00',2.34),('11288','2013-09-09','12:25:00',1.91),('11288','2013-09-09','12:30:00',1.89),('11288','2013-09-09','12:35:00',1.85),('11288','2013-09-09','12:40:00',2.84),('11288','2013-09-09','12:45:00',2.48),('11288','2013-09-09','12:50:00',2.17),('11288','2013-09-09','12:55:00',3.11),('11288','2013-09-09','13:00:00',3.12),('11288','2013-09-09','13:05:00',4.02),('11288','2013-09-09','13:10:00',4.14),('11288','2013-09-09','13:15:00',5.06),('11288','2013-09-09','13:20:00',4.42),('11288','2013-09-09','13:25:00',4.76),('11288','2013-09-09','13:30:00',5.45),('11288','2013-09-09','13:35:00',5.94),('11288','2013-09-09','13:40:00',4.73),('11288','2013-09-09','13:45:00',6.25),('11288','2013-09-09','13:50:00',5.35),('11288','2013-09-09','13:55:00',6.16),('11288','2013-09-09','14:00:00',5.69),('11288','2013-09-09','14:05:00',5.2),('11288','2013-09-09','14:10:00',5.24),('11288','2013-09-09','14:15:00',3.16),('11288','2013-09-09','14:20:00',3.27),('11288','2013-09-09','14:25:00',2.53),('11288','2013-09-09','14:30:00',4.21),('11288','2013-09-09','14:35:00',5.44),('11288','2013-09-09','14:40:00',5.39),('11288','2013-09-09','14:45:00',4.68),('11288','2013-09-09','14:50:00',5.22),('11288','2013-09-09','14:55:00',4.06),('11288','2013-09-09','15:00:00',3.99),('11288','2013-09-09','15:05:00',4.49),('11288','2013-09-09','15:10:00',3.48),('11288','2013-09-09','15:15:00',2.31),('11288','2013-09-09','15:20:00',4.04),('11288','2013-09-09','15:25:00',2.38),('11288','2013-09-09','15:30:00',4.84),('11288','2013-09-09','15:35:00',4.04),('11288','2013-09-09','15:40:00',3.39),('11288','2013-09-09','15:45:00',2.47),('11288','2013-09-09','15:50:00',2.44),('11288','2013-09-09','15:55:00',2.74),('11288','2013-09-09','16:00:00',3.11),('11288','2013-09-09','16:05:00',2.3),('11288','2013-09-09','16:10:00',3.02),('11288','2013-09-09','16:15:00',3.65),('11288','2013-09-09','16:20:00',2.88),('11288','2013-09-09','16:25:00',1.91),('11288','2013-09-09','16:30:00',1.84),('11288','2013-09-09','16:35:00',2.15),('11288','2013-09-09','16:40:00',2.36),('11288','2013-09-09','16:45:00',3.37),('11288','2013-09-09','16:50:00',1.31),('11288','2013-09-09','16:55:00',1.3),('11288','2013-09-09','17:00:00',1.67),('11288','2013-09-09','17:05:00',1.35),('11288','2013-09-09','17:10:00',1.33),('11288','2013-09-09','17:15:00',1.02),('11288','2013-09-09','17:35:00',1.04),('11288','2013-09-09','17:40:00',1.04),('11288','2013-09-09','18:10:00',1.3),('11288','2013-09-09','18:15:00',1.52),('11288','2013-09-09','18:20:00',1.29),('11288','2014-04-12','08:05:00',1),('11288','2014-04-12','08:10:00',1.1),('11288','2014-04-12','08:20:00',1.12),('11288','2014-04-12','08:25:00',1.05),('11288','2014-04-12','08:35:00',1.01),('11288','2014-04-12','08:45:00',1.01),('11288','2014-04-12','08:50:00',1.07),('11288','2014-04-12','08:55:00',1.03),('11288','2014-04-12','09:00:00',1.23),('11288','2014-04-12','09:05:00',1.51),('11288','2014-04-12','09:10:00',1.81),('11288','2014-04-12','09:15:00',2.86),('11288','2014-04-12','09:20:00',3.9),('11288','2014-04-12','09:25:00',4.03),('11288','2014-04-12','09:30:00',3.04),('11288','2014-04-12','09:35:00',2.48),('11288','2014-04-12','09:40:00',2.19),('11288','2014-04-12','09:45:00',2.23),('11288','2014-04-12','09:50:00',2.46),('11288','2014-04-12','09:55:00',2.37),('11288','2014-04-12','10:00:00',2.4),('11288','2014-04-12','10:05:00',2.49),('11288','2014-04-12','10:10:00',2.7),('11288','2014-04-12','10:15:00',2.98),('11288','2014-04-12','10:20:00',3.13),('11288','2014-04-12','10:25:00',3.28),('11288','2014-04-12','10:30:00',3.58),('11288','2014-04-12','10:35:00',3.84),('11288','2014-04-12','10:40:00',3.86),('11288','2014-04-12','10:45:00',4.17),('11288','2014-04-12','10:50:00',4.39),('11288','2014-04-12','10:55:00',4.51),('11288','2014-04-12','11:00:00',4.63),('11288','2014-04-12','11:05:00',3.63),('11288','2014-04-12','11:10:00',4.95),('11288','2014-04-12','11:15:00',5.43),('11288','2014-04-12','11:20:00',5.96),('11288','2014-04-12','11:25:00',5.09),('11288','2014-04-12','11:30:00',5.77),('11288','2014-04-12','11:35:00',6.3),('11288','2014-04-12','11:40:00',5.86),('11288','2014-04-12','11:45:00',6.02),('11288','2014-04-12','11:50:00',3.97),('11288','2014-04-12','11:55:00',4.1),('11288','2014-04-12','12:00:00',3.74),('11288','2014-04-12','12:05:00',2.7),('11288','2014-04-12','12:10:00',2.76),('11288','2014-04-12','12:15:00',3.72),('11288','2014-04-12','12:20:00',5.3),('11288','2014-04-12','12:25:00',3.5),('11288','2014-04-12','12:30:00',3.94),('11288','2014-04-12','12:35:00',4.44),('11288','2014-04-12','12:40:00',4.95),('11288','2014-04-12','12:45:00',3.48),('11288','2014-04-12','12:50:00',3.45),('11288','2014-04-12','12:55:00',3.41),('11288','2014-04-12','13:00:00',3.37),('11288','2014-04-12','13:05:00',3.87),('11288','2014-04-12','13:10:00',4.05),('11288','2014-04-12','13:15:00',4.53),('11288','2014-04-12','13:20:00',5.75),('11288','2014-04-12','13:25:00',6.75),('11288','2014-04-12','13:30:00',2.88),('11288','2014-04-12','13:35:00',2.86),('11288','2014-04-12','13:40:00',3.96),('11288','2014-04-12','13:45:00',5.39),('11288','2014-04-12','13:50:00',2.96),('11288','2014-04-12','13:55:00',6.1),('11288','2014-04-12','14:00:00',6.5),('11288','2014-04-12','14:05:00',6.18),('11288','2014-04-12','14:10:00',2.57),('11288','2014-04-12','14:15:00',3.81),('11288','2014-04-12','14:20:00',5.71),('11288','2014-04-12','14:25:00',3.18),('11288','2014-04-12','14:30:00',4.53),('11288','2014-04-12','14:35:00',3.55),('11288','2014-04-12','14:40:00',4.16),('11288','2014-04-12','14:45:00',3.99),('11288','2014-04-12','14:50:00',5.57),('11288','2014-04-12','14:55:00',3.94),('11288','2014-04-12','15:00:00',4.45),('11288','2014-04-12','15:05:00',5.84),('11288','2014-04-12','15:10:00',6.02),('11288','2014-04-12','15:15:00',5.81),('11288','2014-04-12','15:20:00',4.59),('11288','2014-04-12','15:25:00',4.32),('11288','2014-04-12','15:30:00',3.93),('11288','2014-04-12','15:35:00',3.36),('11288','2014-04-12','15:40:00',4.05),('11288','2014-04-12','15:45:00',4.97),('11288','2014-04-12','15:50:00',5.57),('11288','2014-04-12','15:55:00',5.46),('11288','2014-04-12','16:00:00',5.37),('11288','2014-04-12','16:05:00',5.26),('11288','2014-04-12','16:10:00',4.98),('11288','2014-04-12','16:15:00',5.14),('11288','2014-04-12','16:20:00',5.18),('11288','2014-04-12','16:25:00',4.61),('11288','2014-04-12','16:30:00',4.32),('11288','2014-04-12','16:35:00',3.53),('11288','2014-04-12','16:40:00',3.75),('11288','2014-04-12','16:45:00',3.41),('11288','2014-04-12','16:50:00',2.54),('11288','2014-04-12','16:55:00',3.64),('11288','2014-04-12','17:00:00',3.61),('11288','2014-04-12','17:05:00',3.33),('11288','2014-04-12','17:10:00',3.28),('11288','2014-04-12','17:15:00',3.15),('11288','2014-04-12','17:20:00',2.52),('11288','2014-04-12','17:25:00',2.91),('11288','2014-04-12','17:30:00',2.52),('11288','2014-04-12','17:35:00',2.27),('11288','2014-04-12','17:40:00',2.9),('11288','2014-04-12','17:45:00',2.82),('11288','2014-04-12','17:50:00',2.58),('11288','2014-04-12','17:55:00',2.06),('11288','2014-04-12','18:00:00',1.66),('11288','2014-04-12','18:05:00',1.03),('11288','2014-04-12','18:30:00',1.04),('11288','2013-09-08','07:55:00',1.2),('11288','2013-09-08','08:20:00',1.13),('11288','2013-09-08','08:25:00',1.05),('11288','2013-09-08','08:30:00',1.22),('11288','2013-09-08','08:35:00',1.55),('11288','2013-09-08','08:40:00',1.24),('11288','2013-09-08','08:45:00',1.33),('11288','2013-09-08','08:50:00',1.44),('11288','2013-09-08','08:55:00',1.47),('11288','2013-09-08','09:00:00',1.77),('11288','2013-09-08','09:05:00',1.84),('11288','2013-09-08','09:10:00',1.85),('11288','2013-09-08','09:15:00',1.95),('11288','2013-09-08','09:20:00',2.24),('11288','2013-09-08','09:25:00',3.09),('11288','2013-09-08','09:30:00',2.48),('11288','2013-09-08','09:35:00',2.47),('11288','2013-09-08','09:40:00',2.82),('11288','2013-09-08','09:45:00',3.36),('11288','2013-09-08','09:50:00',3.45),('11288','2013-09-08','09:55:00',3.6),('11288','2013-09-08','10:00:00',3.75),('11288','2013-09-08','10:05:00',3.89),('11288','2013-09-08','10:10:00',3.95),('11288','2013-09-08','10:15:00',4.05),('11288','2013-09-08','10:20:00',4.22),('11288','2013-09-08','10:25:00',4.34),('11288','2013-09-08','10:30:00',4.38),('11288','2013-09-08','10:35:00',4.51),('11288','2013-09-08','10:40:00',4.39),('11288','2013-09-08','10:45:00',4.55),('11288','2013-09-08','10:50:00',4.65),('11288','2013-09-08','10:55:00',4.54),('11288','2013-09-08','11:00:00',4.83),('11288','2013-09-08','11:05:00',4.92),('11288','2013-09-08','11:10:00',4.94),('11288','2013-09-08','11:15:00',5.04),('11288','2013-09-08','11:20:00',5.06),('11288','2013-09-08','11:25:00',4.96),('11288','2013-09-08','11:30:00',4.95),('11288','2013-09-08','11:35:00',5.03),('11288','2013-09-08','11:40:00',5.06),('11288','2013-09-08','11:45:00',5.19),('11288','2013-09-08','11:50:00',5.04),('11288','2013-09-08','11:55:00',5.11),('11288','2013-09-08','12:00:00',5.03),('11288','2013-09-08','12:05:00',4.85),('11288','2013-09-08','12:10:00',5.27),('11288','2013-09-08','12:15:00',5.57),('11288','2013-09-08','12:20:00',5.49),('11288','2013-09-08','12:25:00',5.47),('11288','2013-09-08','12:30:00',5.24),('11288','2013-09-08','12:35:00',5.42),('11288','2013-09-08','12:40:00',5.29),('11288','2013-09-08','12:45:00',5.37),('11288','2013-09-08','12:50:00',5.43),('11288','2013-09-08','12:55:00',5.56),('11288','2013-09-08','13:00:00',5.5),('11288','2013-09-08','13:05:00',5.63),('11288','2013-09-08','13:10:00',5.55),('11288','2013-09-08','13:15:00',5.44),('11288','2013-09-08','13:20:00',5.46),('11288','2013-09-08','13:25:00',4.99),('11288','2013-09-08','13:30:00',5.03),('11288','2013-09-08','13:35:00',4.82),('11288','2013-09-08','13:40:00',3.47),('11288','2013-09-08','13:45:00',3.39),('11288','2013-09-08','13:50:00',4.72),('11288','2013-09-08','13:55:00',4.73),('11288','2013-09-08','14:00:00',5.33),('11288','2013-09-08','14:05:00',5.07),('11288','2013-09-08','14:10:00',5.74),('11288','2013-09-08','14:15:00',5.23),('11288','2013-09-08','14:20:00',5.98),('11288','2013-09-08','14:25:00',6.06),('11288','2013-09-08','14:30:00',5.31),('11288','2013-09-08','14:35:00',5.58),('11288','2013-09-08','14:40:00',5.42),('11288','2013-09-08','14:45:00',5.25),('11288','2013-09-08','14:50:00',5.29),('11288','2013-09-08','14:55:00',5.26),('11288','2013-09-08','15:00:00',5.25),('11288','2013-09-08','15:05:00',4.11),('11288','2013-09-08','15:10:00',2.89),('11288','2013-09-08','15:15:00',3.99),('11288','2013-09-08','15:20:00',5.04),('11288','2013-09-08','15:25:00',5.07),('11288','2013-09-08','15:30:00',5.05),('11288','2013-09-08','15:35:00',4.86),('11288','2013-09-08','15:40:00',4.52),('11288','2013-09-08','15:45:00',4.56),('11288','2013-09-08','15:50:00',4.35),('11288','2013-09-08','15:55:00',3.58),('11288','2013-09-08','16:00:00',3.77),('11288','2013-09-08','16:05:00',3.76),('11288','2013-09-08','16:10:00',3.2),('11288','2013-09-08','16:15:00',3.92),('11288','2013-09-08','16:20:00',3.41),('11288','2013-09-08','16:25:00',3.28),('11288','2013-09-08','16:30:00',3.49),('11288','2013-09-08','16:35:00',3.16),('11288','2013-09-08','16:40:00',2.63),('11288','2013-09-08','16:45:00',2.03),('11288','2013-09-08','16:50:00',1.94),('11288','2013-09-08','16:55:00',1.85),('11288','2013-09-08','17:00:00',2.64),('11288','2013-09-08','17:05:00',2.96),('11288','2013-09-08','17:10:00',2.75),('11288','2013-09-08','17:15:00',2.52),('11288','2013-09-08','17:20:00',2.09),('11288','2013-09-08','17:25:00',2.12),('11288','2013-09-08','17:30:00',1.89),('11288','2013-09-08','17:40:00',1.07),('11288','2013-09-08','17:45:00',1.5),('11288','2013-09-08','17:50:00',1.5),('11288','2013-09-08','17:55:00',1.4),('11288','2013-09-08','18:00:00',1.22),('11288','2013-09-08','18:05:00',1.04),('11288','2013-09-07','08:10:00',1.02),('11288','2013-09-07','08:15:00',1.13),('11288','2013-09-07','08:20:00',1.23),('11288','2013-09-07','08:25:00',1.4),('11288','2013-09-07','08:30:00',1.42),('11288','2013-09-07','08:35:00',1.58),('11288','2013-09-07','08:40:00',1.8),('11288','2013-09-07','08:45:00',1.87),('11288','2013-09-07','08:50:00',2.09),('11288','2013-09-07','08:55:00',2.16),('11288','2013-09-07','09:00:00',2.25),('11288','2013-09-07','09:05:00',2.35),('11288','2013-09-07','09:10:00',2.49),('11288','2013-09-07','09:15:00',2.5),('11288','2013-09-07','09:20:00',2.64),('11288','2013-09-07','09:25:00',2.97),('11288','2013-09-07','09:30:00',2.99),('11288','2013-09-07','09:35:00',3.08),('11288','2013-09-07','09:40:00',3.18),('11288','2013-09-07','09:45:00',3.29),('11288','2013-09-07','09:50:00',3.53),('11288','2013-09-07','09:55:00',3.72),('11288','2013-09-07','10:00:00',3.84),('11288','2013-09-07','10:05:00',4),('11288','2013-09-07','10:10:00',4.11),('11288','2013-09-07','10:15:00',4.19),('11288','2013-09-07','10:20:00',4.26),('11288','2013-09-07','10:25:00',4.37),('11288','2013-09-07','10:30:00',4.42),('11288','2013-09-07','10:35:00',4.53),('11288','2013-09-07','10:40:00',4.59),('11288','2013-09-07','10:45:00',4.65),('11288','2013-09-07','10:50:00',4.73),('11288','2013-09-07','10:55:00',4.88),('11288','2013-09-07','11:00:00',4.96),('11288','2013-09-07','11:05:00',4.99),('11288','2013-09-07','11:10:00',5.06),('11288','2013-09-07','11:15:00',5.09),('11288','2013-09-07','11:20:00',5.12),('11288','2013-09-07','11:25:00',5.17),('11288','2013-09-07','11:30:00',5.25),('11288','2013-09-07','11:35:00',5.32),('11288','2013-09-07','11:40:00',5.4),('11288','2013-09-07','11:45:00',5.4),('11288','2013-09-07','11:50:00',5.46),('11288','2013-09-07','11:55:00',5.5),('11288','2013-09-07','12:00:00',5.58),('11288','2013-09-07','12:05:00',5.64),('11288','2013-09-07','12:10:00',5.68),('11288','2013-09-07','12:15:00',5.67),('11288','2013-09-07','12:20:00',5.71),('11288','2013-09-07','12:25:00',5.71),('11288','2013-09-07','12:30:00',5.7),('11288','2013-09-07','12:35:00',5.69),('11288','2013-09-07','12:40:00',5.69),('11288','2013-09-07','12:45:00',5.69),('11288','2013-09-07','12:50:00',5.78),('11288','2013-09-07','12:55:00',5.72),('11288','2013-09-07','13:00:00',5.75),('11288','2013-09-07','13:05:00',5.77),('11288','2013-09-07','13:10:00',5.75),('11288','2013-09-07','13:15:00',5.73),('11288','2013-09-07','13:20:00',5.77),('11288','2013-09-07','13:25:00',5.83),('11288','2013-09-07','13:30:00',5.83),('11288','2013-09-07','13:35:00',4.75),('11288','2013-09-07','13:40:00',3.9),('11288','2013-09-07','13:45:00',3.38),('11288','2013-09-07','13:50:00',5.58),('11288','2013-09-07','13:55:00',5.8),('11288','2013-09-07','14:00:00',5.86),('11288','2013-09-07','14:05:00',5.84),('11288','2013-09-07','14:10:00',5.77),('11288','2013-09-07','14:15:00',5.65),('11288','2013-09-07','14:20:00',5.54),('11288','2013-09-07','14:25:00',5.52),('11288','2013-09-07','14:30:00',5.55),('11288','2013-09-07','14:35:00',5.57),('11288','2013-09-07','14:40:00',5.54),('11288','2013-09-07','14:45:00',5.47),('11288','2013-09-07','14:50:00',5.37),('11288','2013-09-07','14:55:00',5.31),('11288','2013-09-07','15:00:00',5.25),('11288','2013-09-07','15:05:00',5.19),('11288','2013-09-07','15:10:00',5.12),('11288','2013-09-07','15:15:00',5.09),('11288','2013-09-07','15:20:00',5.05),('11288','2013-09-07','15:25:00',4.96),('11288','2013-09-07','15:30:00',4.9),('11288','2013-09-07','15:35:00',4.8),('11288','2013-09-07','15:40:00',4.66),('11288','2013-09-07','15:45:00',4.56),('11288','2013-09-07','15:50:00',4.45),('11288','2013-09-07','15:55:00',4.34),('11288','2013-09-07','16:00:00',4.26),('11288','2013-09-07','16:05:00',4.13),('11288','2013-09-07','16:10:00',4.01),('11288','2013-09-07','16:15:00',3.9),('11288','2013-09-07','16:20:00',3.78),('11288','2013-09-07','16:25:00',3.62),('11288','2013-09-07','16:30:00',3.52),('11288','2013-09-07','16:35:00',3.4),('11288','2013-09-07','16:40:00',3.29),('11288','2013-09-07','16:45:00',3.19),('11288','2013-09-07','16:50:00',3.07),('11288','2013-09-07','16:55:00',2.94),('11288','2013-09-07','17:00:00',2.8),('11288','2013-09-07','17:05:00',2.68),('11288','2013-09-07','17:10:00',2.52),('11288','2013-09-07','17:15:00',2.42),('11288','2013-09-07','17:20:00',2.29),('11288','2013-09-07','17:25:00',2.15),('11288','2013-09-07','17:30:00',1.99),('11288','2013-09-07','17:35:00',1.88),('11288','2013-09-07','17:40:00',1.75),('11288','2013-09-07','17:45:00',1.64),('11288','2013-09-07','17:50:00',1.53),('11288','2013-09-07','17:55:00',1.4),('11288','2013-09-07','18:00:00',1.28),('11288','2013-09-07','18:05:00',1.14),('11288','2013-09-07','18:10:00',1.02),('11288','2013-09-06','08:10:00',1.08),('11288','2013-09-06','08:15:00',1.17),('11288','2013-09-06','08:20:00',1.31),('11288','2013-09-06','08:25:00',1.49),('11288','2013-09-06','08:30:00',1.53),('11288','2013-09-06','08:35:00',1.66),('11288','2013-09-06','08:40:00',1.81),('11288','2013-09-06','08:45:00',2),('11288','2013-09-06','08:50:00',2.19),('11288','2013-09-06','08:55:00',2.28),('11288','2013-09-06','09:00:00',2.4),('11288','2013-09-06','09:05:00',2.5),('11288','2013-09-06','09:10:00',2.57),('11288','2013-09-06','09:15:00',2.66),('11288','2013-09-06','09:20:00',2.78),('11288','2013-09-06','09:25:00',2.99),('11288','2013-09-06','09:30:00',3.09),('11288','2013-09-06','09:35:00',3.27),('11288','2013-09-06','09:40:00',3.32),('11288','2013-09-06','09:45:00',3.33),('11288','2013-09-06','09:50:00',3.65),('11288','2013-09-06','09:55:00',3.82),('11288','2013-09-06','10:00:00',3.92),('11288','2013-09-06','10:05:00',4.06),('11288','2013-09-06','10:10:00',4.17),('11288','2013-09-06','10:15:00',4.26),('11288','2013-09-06','10:20:00',4.32),('11288','2013-09-06','10:25:00',4.46),('11288','2013-09-06','10:30:00',4.59),('11288','2013-09-06','10:35:00',4.69),('11288','2013-09-06','10:40:00',4.77),('11288','2013-09-06','10:45:00',4.88),('11288','2013-09-06','10:50:00',4.93),('11288','2013-09-06','10:55:00',4.99),('11288','2013-09-06','11:00:00',5.08),('11288','2013-09-06','11:05:00',5.11),('11288','2013-09-06','11:10:00',5.19),('11288','2013-09-06','11:15:00',5.28),('11288','2013-09-06','11:20:00',5.28),('11288','2013-09-06','11:25:00',5.38),('11288','2013-09-06','11:30:00',5.4),('11288','2013-09-06','11:35:00',5.44),('11288','2013-09-06','11:40:00',5.47),('11288','2013-09-06','11:45:00',5.51),('11288','2013-09-06','11:50:00',5.52),('11288','2013-09-06','11:55:00',5.53),('11288','2013-09-06','12:00:00',5.59),('11288','2013-09-06','12:05:00',5.63),('11288','2013-09-06','12:10:00',5.69),('11288','2013-09-06','12:15:00',5.77),('11288','2013-09-06','12:20:00',5.8),('11288','2013-09-06','12:25:00',5.81),('11288','2013-09-06','12:30:00',5.83),('11288','2013-09-06','12:35:00',5.85),('11288','2013-09-06','12:40:00',5.88),('11288','2013-09-06','12:45:00',5.87),('11288','2013-09-06','12:50:00',5.87),('11288','2013-09-06','12:55:00',5.88),('11288','2013-09-06','13:00:00',5.89),('11288','2013-09-06','13:05:00',5.88),('11288','2013-09-06','13:10:00',5.87),('11288','2013-09-06','13:15:00',5.86),('11288','2013-09-06','13:20:00',5.85),('11288','2013-09-06','13:25:00',5.8),('11288','2013-09-06','13:30:00',5.83),('11288','2013-09-06','13:35:00',5.84),('11288','2013-09-06','13:40:00',5.79),('11288','2013-09-06','13:45:00',5.71),('11288','2013-09-06','13:50:00',5.69),('11288','2013-09-06','13:55:00',5.65),('11288','2013-09-06','14:00:00',5.6),('11288','2013-09-06','14:05:00',5.61),('11288','2013-09-06','14:10:00',5.59),('11288','2013-09-06','14:15:00',5.56),('11288','2013-09-06','14:20:00',5.5),('11288','2013-09-06','14:25:00',5.49),('11288','2013-09-06','14:30:00',5.32),('11288','2013-09-06','14:35:00',5.19),('11288','2013-09-06','14:40:00',5.21),('11288','2013-09-06','14:45:00',5.22),('11288','2013-09-06','14:50:00',5.3),('11288','2013-09-06','14:55:00',5.3),('11288','2013-09-06','15:00:00',5.24),('11288','2013-09-06','15:05:00',5.15),('11288','2013-09-06','15:10:00',5.06),('11288','2013-09-06','15:15:00',5.02),('11288','2013-09-06','15:20:00',4.96),('11288','2013-09-06','15:25:00',4.85),('11288','2013-09-06','15:30:00',4.72),('11288','2013-09-06','15:35:00',4.63),('11288','2013-09-06','15:40:00',4.6),('11288','2013-09-06','15:45:00',4.52),('11288','2013-09-06','15:50:00',4.43),('11288','2013-09-06','15:55:00',4.32),('11288','2013-09-06','16:00:00',4.24),('11288','2013-09-06','16:05:00',4.16),('11288','2013-09-06','16:10:00',4.03),('11288','2013-09-06','16:15:00',3.94),('11288','2013-09-06','16:20:00',3.84),('11288','2013-09-06','16:25:00',3.74),('11288','2013-09-06','16:30:00',3.69),('11288','2013-09-06','16:35:00',3.53),('11288','2013-09-06','16:40:00',3.42),('11288','2013-09-06','16:45:00',3.23),('11288','2013-09-06','16:50:00',3.14),('11288','2013-09-06','16:55:00',2.99),('11288','2013-09-06','17:00:00',2.91),('11288','2013-09-06','17:05:00',2.74),('11288','2013-09-06','17:10:00',2.58),('11288','2013-09-06','17:15:00',2.5),('11288','2013-09-06','17:20:00',2.35),('11288','2013-09-06','17:25:00',2.2),('11288','2013-09-06','17:30:00',2.06),('11288','2013-09-06','17:35:00',1.93),('11288','2013-09-06','17:40:00',1.82),('11288','2013-09-06','17:45:00',1.69),('11288','2013-09-06','17:50:00',1.52),('11288','2013-09-06','17:55:00',1.4),('11288','2013-09-06','18:00:00',1.32),('11288','2013-09-06','18:05:00',1.2),('11288','2013-09-06','18:10:00',1.1),('11288','2013-09-05','08:10:00',1.1),('11288','2013-09-05','08:15:00',1.24),('11288','2013-09-05','08:20:00',1.42),('11288','2013-09-05','08:25:00',1.6),('11288','2013-09-05','08:30:00',1.71),('11288','2013-09-05','08:35:00',1.85),('11288','2013-09-05','08:40:00',1.98),('11288','2013-09-05','08:45:00',2.1),('11288','2013-09-05','08:50:00',2.33),('11288','2013-09-05','08:55:00',2.4),('11288','2013-09-05','09:00:00',2.48),('11288','2013-09-05','09:05:00',2.61),('11288','2013-09-05','09:10:00',2.58),('11288','2013-09-05','09:15:00',2.71),('11288','2013-09-05','09:20:00',3.03),('11288','2013-09-05','09:25:00',3.17),('11288','2013-09-05','09:30:00',3.3),('11288','2013-09-05','09:35:00',3.4),('11288','2013-09-05','09:40:00',3.43),('11288','2013-09-05','09:45:00',3.33),('11288','2013-09-05','09:50:00',3.77),('11288','2013-09-05','09:55:00',4),('11288','2013-09-05','10:00:00',4.11),('11288','2013-09-05','10:05:00',4.26),('11288','2013-09-05','10:10:00',4.38),('11288','2013-09-05','10:15:00',4.51),('11288','2013-09-05','10:20:00',4.61),('11288','2013-09-05','10:25:00',4.66),('11288','2013-09-05','10:30:00',4.79),('11288','2013-09-05','10:35:00',4.86),('11288','2013-09-05','10:40:00',4.92),('11288','2013-09-05','10:45:00',5),('11288','2013-09-05','10:50:00',5.07),('11288','2013-09-05','10:55:00',5.14),('11288','2013-09-05','11:00:00',5.28),('11288','2013-09-05','11:05:00',5.34),('11288','2013-09-05','11:10:00',5.36),('11288','2013-09-05','11:15:00',5.4),('11288','2013-09-05','11:20:00',5.46),('11288','2013-09-05','11:25:00',5.54),('11288','2013-09-05','11:30:00',5.55),('11288','2013-09-05','11:35:00',5.54),('11288','2013-09-05','11:40:00',5.56),('11288','2013-09-05','11:45:00',5.55),('11288','2013-09-05','11:50:00',5.66),('11288','2013-09-05','11:55:00',5.77),('11288','2013-09-05','12:00:00',5.83),('11288','2013-09-05','12:05:00',5.91),('11288','2013-09-05','12:10:00',5.94),('11288','2013-09-05','12:15:00',5.98),('11288','2013-09-05','12:20:00',5.98),('11288','2013-09-05','12:25:00',6.03),('11288','2013-09-05','12:30:00',6),('11288','2013-09-05','12:35:00',6),('11288','2013-09-05','12:40:00',6.03),('11288','2013-09-05','12:45:00',6.03),('11288','2013-09-05','12:50:00',6.06),('11288','2013-09-05','12:55:00',6.08),('11288','2013-09-05','13:00:00',6.05),('11288','2013-09-05','13:05:00',6.04),('11288','2013-09-05','13:10:00',6.06),('11288','2013-09-05','13:15:00',6.06),('11288','2013-09-05','13:20:00',6.03),('11288','2013-09-05','13:25:00',6.01),('11288','2013-09-05','13:30:00',6.07),('11288','2013-09-05','13:35:00',6.04),('11288','2013-09-05','13:40:00',5.99),('11288','2013-09-05','13:45:00',5.93),('11288','2013-09-05','13:50:00',5.88),('11288','2013-09-05','13:55:00',5.85),('11288','2013-09-05','14:00:00',5.82),('11288','2013-09-05','14:05:00',5.8),('11288','2013-09-05','14:10:00',5.81),('11288','2013-09-05','14:15:00',5.76),('11288','2013-09-05','14:20:00',5.71),('11288','2013-09-05','14:25:00',5.63),('11288','2013-09-05','14:30:00',5.61),('11288','2013-09-05','14:35:00',5.52),('11288','2013-09-05','14:40:00',5.51),('11288','2013-09-05','14:45:00',5.46),('11288','2013-09-05','14:50:00',5.42),('11288','2013-09-05','14:55:00',5.42),('11288','2013-09-05','15:00:00',5.4),('11288','2013-09-05','15:05:00',5.33),('11288','2013-09-05','15:10:00',5.24),('11288','2013-09-05','15:15:00',5.19),('11288','2013-09-05','15:20:00',5.13),('11288','2013-09-05','15:25:00',5.03),('11288','2013-09-05','15:30:00',4.96),('11288','2013-09-05','15:35:00',4.88),('11288','2013-09-05','15:40:00',4.82),('11288','2013-09-05','15:45:00',4.72),('11288','2013-09-05','15:50:00',4.62),('11288','2013-09-05','15:55:00',4.53),('11288','2013-09-05','16:00:00',4.42),('11288','2013-09-05','16:05:00',4.36),('11288','2013-09-05','16:10:00',4.25),('11288','2013-09-05','16:15:00',4.16),('11288','2013-09-05','16:20:00',4.04),('11288','2013-09-05','16:25:00',3.94),('11288','2013-09-05','16:30:00',3.87),('11288','2013-09-05','16:35:00',3.84),('11288','2013-09-05','16:40:00',3.73),('11288','2013-09-05','16:45:00',3.64),('11288','2013-09-05','16:50:00',2.9),('11288','2013-09-05','16:55:00',2.36),('11288','2013-09-05','17:00:00',1.93),('11288','2013-09-05','17:05:00',2.17),('11288','2013-09-05','17:10:00',2.09),('11288','2013-09-05','17:15:00',1.9),('11288','2013-09-05','17:20:00',2.11),('11288','2013-09-05','17:25:00',2.1),('11288','2013-09-05','17:30:00',2.08),('11288','2013-09-05','17:35:00',2.22),('11288','2013-09-05','17:40:00',2.27),('11288','2013-09-05','17:45:00',1.99),('11288','2013-09-05','17:50:00',1.84),('11288','2013-09-05','17:55:00',1.6),('11288','2013-09-05','18:00:00',1.2),('11288','2013-09-05','18:05:00',1.08),('11288','2013-09-05','18:10:00',1.04),('11288','2013-09-05','18:15:00',1),('11288','2013-09-05','18:20:00',1.11),('11288','2013-09-04','08:05:00',1.01),('11288','2013-09-04','08:10:00',1.08),('11288','2013-09-04','08:15:00',1.25),('11288','2013-09-04','08:20:00',1.45),('11288','2013-09-04','08:25:00',1.56),('11288','2013-09-04','08:30:00',1.72),('11288','2013-09-04','08:35:00',1.87),('11288','2013-09-04','08:40:00',2.01),('11288','2013-09-04','08:45:00',2.11),('11288','2013-09-04','08:50:00',2.34),('11288','2013-09-04','08:55:00',2.38),('11288','2013-09-04','09:00:00',2.58),('11288','2013-09-04','09:05:00',2.68),('11288','2013-09-04','09:10:00',2.75),('11288','2013-09-04','09:15:00',2.75),('11288','2013-09-04','09:20:00',3.13),('11288','2013-09-04','09:25:00',3.25),('11288','2013-09-04','09:30:00',3.39),('11288','2013-09-04','09:35:00',3.6),('11288','2013-09-04','09:40:00',3.61),('11288','2013-09-04','09:45:00',3.64),('11288','2013-09-04','09:50:00',4),('11288','2013-09-04','09:55:00',4.13),('11288','2013-09-04','10:00:00',4.29),('11288','2013-09-04','10:05:00',4.47),('11288','2013-09-04','10:10:00',4.59),('11288','2013-09-04','10:15:00',4.66),('11288','2013-09-04','10:20:00',4.77),('11288','2013-09-04','10:25:00',4.85),('11288','2013-09-04','10:30:00',4.97),('11288','2013-09-04','10:35:00',5.03),('11288','2013-09-04','10:40:00',5.13),('11288','2013-09-04','10:45:00',5.21),('11288','2013-09-04','10:50:00',5.32),('11288','2013-09-04','10:55:00',5.41),('11288','2013-09-04','11:00:00',5.49),('11288','2013-09-04','11:05:00',5.53),('11288','2013-09-04','11:10:00',5.61),('11288','2013-09-04','11:15:00',5.66),('11288','2013-09-04','11:20:00',5.72),('11288','2013-09-04','11:25:00',5.74),('11288','2013-09-04','11:30:00',5.78),('11288','2013-09-04','11:35:00',5.84),('11288','2013-09-04','11:40:00',5.92),('11288','2013-09-04','11:45:00',5.96),('11288','2013-09-04','11:50:00',6.02),('11288','2013-09-04','11:55:00',6.08),('11288','2013-09-04','12:00:00',6.13),('11288','2013-09-04','12:05:00',6.2),('11288','2013-09-04','12:10:00',6.24),('11288','2013-09-04','12:15:00',6.23),('11288','2013-09-04','12:20:00',6.23),('11288','2013-09-04','12:25:00',6.31),('11288','2013-09-04','12:30:00',6.33),('11288','2013-09-04','12:35:00',6.36),('11288','2013-09-04','12:40:00',6.39),('11288','2013-09-04','12:45:00',6.38),('11288','2013-09-04','12:50:00',6.29),('11288','2013-09-04','12:55:00',6.3),('11288','2013-09-04','13:00:00',6.3),('11288','2013-09-04','13:05:00',6.31),('11288','2013-09-04','13:10:00',6.35),('11288','2013-09-04','13:15:00',6.32),('11288','2013-09-04','13:20:00',6.28),('11288','2013-09-04','13:25:00',6.27),('11288','2013-09-04','13:30:00',6.28),('11288','2013-09-04','13:35:00',6.27),('11288','2013-09-04','13:40:00',6.27),('11288','2013-09-04','13:45:00',6.22),('11288','2013-09-04','13:50:00',6.22),('11288','2013-09-04','13:55:00',6.2),('11288','2013-09-04','14:00:00',6.16),('11288','2013-09-04','14:05:00',6.12),('11288','2013-09-04','14:10:00',6.08),('11288','2013-09-04','14:15:00',6.05),('11288','2013-09-04','14:20:00',5.97),('11288','2013-09-04','14:25:00',5.95),('11288','2013-09-04','14:30:00',5.95),('11288','2013-09-04','14:35:00',5.9),('11288','2013-09-04','14:40:00',5.87),('11288','2013-09-04','14:45:00',5.8),('11288','2013-09-04','14:50:00',5.73),('11288','2013-09-04','14:55:00',5.66),('11288','2013-09-04','15:00:00',5.57),('11288','2013-09-04','15:05:00',5.52),('11288','2013-09-04','15:10:00',5.5),('11288','2013-09-04','15:15:00',5.41),('11288','2013-09-04','15:20:00',5.38),('11288','2013-09-04','15:25:00',5.27),('11288','2013-09-04','15:30:00',5.2),('11288','2013-09-04','15:35:00',5.11),('11288','2013-09-04','15:40:00',5.03),('11288','2013-09-04','15:45:00',4.94),('11288','2013-09-04','15:50:00',4.81),('11288','2013-09-04','15:55:00',4.7),('11288','2013-09-04','16:00:00',4.61),('11288','2013-09-04','16:05:00',4.47),('11288','2013-09-04','16:10:00',4.32),('11288','2013-09-04','16:15:00',4.23),('11288','2013-09-04','16:20:00',4.14),('11288','2013-09-04','16:25:00',4.02),('11288','2013-09-04','16:30:00',3.91),('11288','2013-09-04','16:35:00',3.8),('11288','2013-09-04','16:40:00',3.67),('11288','2013-09-04','16:45:00',3.55),('11288','2013-09-04','16:50:00',3.38),('11288','2013-09-04','16:55:00',3.27),('11288','2013-09-04','17:00:00',3.13),('11288','2013-09-04','17:05:00',3),('11288','2013-09-04','17:10:00',2.86),('11288','2013-09-04','17:15:00',2.74),('11288','2013-09-04','17:20:00',2.58),('11288','2013-09-04','17:25:00',2.46),('11288','2013-09-04','17:30:00',2.32),('11288','2013-09-04','17:35:00',2.18),('11288','2013-09-04','17:40:00',2.01),('11288','2013-09-04','17:45:00',1.85),('11288','2013-09-04','17:50:00',1.69),('11288','2013-09-04','17:55:00',1.57),('11288','2013-09-04','18:00:00',1.45),('11288','2013-09-04','18:05:00',1.31),('11288','2013-09-04','18:10:00',1.2),('11288','2013-09-04','18:15:00',1.05),('11288','2013-09-03','08:05:00',1.01),('11288','2013-09-03','08:10:00',1.07),('11288','2013-09-03','08:15:00',1.21),('11288','2013-09-03','08:20:00',1.36),('11288','2013-09-03','08:25:00',1.49),('11288','2013-09-03','08:30:00',1.64),('11288','2013-09-03','08:35:00',1.81),('11288','2013-09-03','08:40:00',1.9),('11288','2013-09-03','08:45:00',2.04),('11288','2013-09-03','08:50:00',2.19),('11288','2013-09-03','08:55:00',2.3),('11288','2013-09-03','09:00:00',2.39),('11288','2013-09-03','09:05:00',2.53),('11288','2013-09-03','09:10:00',2.66),('11288','2013-09-03','09:15:00',2.63),('11288','2013-09-03','09:20:00',2.91),('11288','2013-09-03','09:25:00',3.13),('11288','2013-09-03','09:30:00',3.23),('11288','2013-09-03','09:35:00',3.43),('11288','2013-09-03','09:40:00',3.35),('11288','2013-09-03','09:45:00',3.39),('11288','2013-09-03','09:50:00',3.72),('11288','2013-09-03','09:55:00',3.82),('11288','2013-09-03','10:00:00',3.94),('11288','2013-09-03','10:05:00',4.12),('11288','2013-09-03','10:10:00',4.23),('11288','2013-09-03','10:15:00',4.34),('11288','2013-09-03','10:20:00',4.49),('11288','2013-09-03','10:25:00',4.59),('11288','2013-09-03','10:30:00',4.71),('11288','2013-09-03','10:35:00',4.81),('11288','2013-09-03','10:40:00',4.94),('11288','2013-09-03','10:45:00',5.04),('11288','2013-09-03','10:50:00',5.13),('11288','2013-09-03','10:55:00',5.24),('11288','2013-09-03','11:00:00',5.28),('11288','2013-09-03','11:05:00',5.33),('11288','2013-09-03','11:10:00',5.36),('11288','2013-09-03','11:15:00',5.42),('11288','2013-09-03','11:20:00',5.47),('11288','2013-09-03','11:25:00',5.5),('11288','2013-09-03','11:30:00',5.56),('11288','2013-09-03','11:35:00',5.61),('11288','2013-09-03','11:40:00',5.66),('11288','2013-09-03','11:45:00',5.69),('11288','2013-09-03','11:50:00',5.75),('11288','2013-09-03','11:55:00',5.81),('11288','2013-09-03','12:00:00',5.92),('11288','2013-09-03','12:05:00',5.97),('11288','2013-09-03','12:10:00',5.98),('11288','2013-09-03','12:15:00',6.01),('11288','2013-09-03','12:20:00',6.05),('11288','2013-09-03','12:25:00',6.11),('11288','2013-09-03','12:30:00',6.15),('11288','2013-09-03','12:35:00',6.15),('11288','2013-09-03','12:40:00',6.19),('11288','2013-09-03','12:45:00',6.21),('11288','2013-09-03','12:50:00',6.16),('11288','2013-09-03','12:55:00',6.17),('11288','2013-09-03','13:00:00',6.19),('11288','2013-09-03','13:05:00',6.17),('11288','2013-09-03','13:10:00',6.2),('11288','2013-09-03','13:15:00',6.17),('11288','2013-09-03','13:20:00',6.18),('11288','2013-09-03','13:25:00',6.12),('11288','2013-09-03','13:30:00',6.11),('11288','2013-09-03','13:35:00',6.11),('11288','2013-09-03','13:40:00',6.1),('11288','2013-09-03','13:45:00',6.06),('11288','2013-09-03','13:50:00',6.08),('11288','2013-09-03','13:55:00',6.08),('11288','2013-09-03','14:00:00',6.01),('11288','2013-09-03','14:05:00',5.88),('11288','2013-09-03','14:10:00',5.83),('11288','2013-09-03','14:15:00',5.86),('11288','2013-09-03','14:20:00',5.81),('11288','2013-09-03','14:25:00',5.8),('11288','2013-09-03','14:30:00',5.78),('11288','2013-09-03','14:35:00',5.77),('11288','2013-09-03','14:40:00',5.75),('11288','2013-09-03','14:45:00',5.67),('11288','2013-09-03','14:50:00',5.65),('11288','2013-09-03','14:55:00',5.63),('11288','2013-09-03','15:00:00',5.55),('11288','2013-09-03','15:05:00',5.4),('11288','2013-09-03','15:10:00',5.26),('11288','2013-09-03','15:15:00',5.28),('11288','2013-09-03','15:20:00',5.24),('11288','2013-09-03','15:25:00',5.17),('11288','2013-09-03','15:30:00',5.1),('11288','2013-09-03','15:35:00',4.95),('11288','2013-09-03','15:40:00',4.89),('11288','2013-09-03','15:45:00',4.77),('11288','2013-09-03','15:50:00',4.68),('11288','2013-09-03','15:55:00',4.6),('11288','2013-09-03','16:00:00',4.51),('11288','2013-09-03','16:05:00',4.47),('11288','2013-09-03','16:10:00',4.36),('11288','2013-09-03','16:15:00',4.23),('11288','2013-09-03','16:20:00',4.12),('11288','2013-09-03','16:25:00',4.01),('11288','2013-09-03','16:30:00',3.88),('11288','2013-09-03','16:35:00',3.76),('11288','2013-09-03','16:40:00',3.66),('11288','2013-09-03','16:45:00',3.53),('11288','2013-09-03','16:50:00',3.37),('11288','2013-09-03','16:55:00',3.28),('11288','2013-09-03','17:00:00',3.15),('11288','2013-09-03','17:05:00',3),('11288','2013-09-03','17:10:00',2.88),('11288','2013-09-03','17:15:00',2.74),('11288','2013-09-03','17:20:00',2.62),('11288','2013-09-03','17:25:00',2.48),('11288','2013-09-03','17:30:00',2.35),('11288','2013-09-03','17:35:00',2.2),('11288','2013-09-03','17:40:00',2.05),('11288','2013-09-03','17:45:00',1.92),('11288','2013-09-03','17:50:00',1.79),('11288','2013-09-03','17:55:00',1.61),('11288','2013-09-03','18:00:00',1.33),('11288','2013-09-03','18:05:00',1.22),('11288','2013-09-03','18:10:00',1.16),('11288','2013-09-03','18:15:00',1.07),('11288','2013-09-02','08:05:00',1.1),('11288','2013-09-02','08:10:00',1.17),('11288','2013-09-02','08:15:00',1.29),('11288','2013-09-02','08:20:00',1.44),('11288','2013-09-02','08:25:00',1.54),('11288','2013-09-02','08:30:00',1.71),('11288','2013-09-02','08:35:00',1.86),('11288','2013-09-02','08:40:00',2),('11288','2013-09-02','08:45:00',2.14),('11288','2013-09-02','08:50:00',2.29),('11288','2013-09-02','08:55:00',2.32),('11288','2013-09-02','09:00:00',2.5),('11288','2013-09-02','09:05:00',2.6),('11288','2013-09-02','09:10:00',2.73),('11288','2013-09-02','09:15:00',2.86),('11288','2013-09-02','09:20:00',3.03),('11288','2013-09-02','09:25:00',3.1),('11288','2013-09-02','09:30:00',3.16),('11288','2013-09-02','09:35:00',3.46),('11288','2013-09-02','09:40:00',3.46),('11288','2013-09-02','09:45:00',3.56),('11288','2013-09-02','09:50:00',3.85),('11288','2013-09-02','09:55:00',3.73),('11288','2013-09-02','10:00:00',3.97),('11288','2013-09-02','10:05:00',4.26),('11288','2013-09-02','10:10:00',4.37),('11288','2013-09-02','10:15:00',4.5),('11288','2013-09-02','10:20:00',4.59),('11288','2013-09-02','10:25:00',4.7),('11288','2013-09-02','10:30:00',4.79),('11288','2013-09-02','10:35:00',4.91),('11288','2013-09-02','10:40:00',4.99),('11288','2013-09-02','10:45:00',5.05),('11288','2013-09-02','10:50:00',5.13),('11288','2013-09-02','10:55:00',5.23),('11288','2013-09-02','11:00:00',5.28),('11288','2013-09-02','11:05:00',5.34),('11288','2013-09-02','11:10:00',5.4),('11288','2013-09-02','11:15:00',5.47),('11288','2013-09-02','11:20:00',5.49),('11288','2013-09-02','11:25:00',5.54),('11288','2013-09-02','11:30:00',5.59),('11288','2013-09-02','11:35:00',5.66),('11288','2013-09-02','11:40:00',5.7),('11288','2013-09-02','11:45:00',5.71),('11288','2013-09-02','11:50:00',5.73),('11288','2013-09-02','11:55:00',5.78),('11288','2013-09-02','12:00:00',5.9),('11288','2013-09-02','12:05:00',5.95),('11288','2013-09-02','12:10:00',5.98),('11288','2013-09-02','12:15:00',6.05),('11288','2013-09-02','12:20:00',6.04),('11288','2013-09-02','12:25:00',6.04),('11288','2013-09-02','12:30:00',6.05),('11288','2013-09-02','12:35:00',5.99),('11288','2013-09-02','12:40:00',6.03),('11288','2013-09-02','12:45:00',6.05),('11288','2013-09-02','12:50:00',6.08),('11288','2013-09-02','12:55:00',6.14),('11288','2013-09-02','13:00:00',6.16),('11288','2013-09-02','13:05:00',6.13),('11288','2013-09-02','13:10:00',6.12),('11288','2013-09-02','13:15:00',6.1),('11288','2013-09-02','13:20:00',6.06),('11288','2013-09-02','13:25:00',6.07),('11288','2013-09-02','13:30:00',5.98),('11288','2013-09-02','13:35:00',5.89),('11288','2013-09-02','13:40:00',5.81),('11288','2013-09-02','13:45:00',6.11),('11288','2013-09-02','13:50:00',5.64),('11288','2013-09-02','13:55:00',1.73),('11288','2013-09-02','14:00:00',6.26),('11288','2013-09-02','14:05:00',6.2),('11288','2013-09-02','14:10:00',6.04),('11288','2013-09-02','14:15:00',5.97),('11288','2013-09-02','14:20:00',5.76),('11288','2013-09-02','14:25:00',5.78),('11288','2013-09-02','14:30:00',5.88),('11288','2013-09-02','14:35:00',5.78),('11288','2013-09-02','14:40:00',5.8),('11288','2013-09-02','14:45:00',5.85),('11288','2013-09-02','14:50:00',5.82),('11288','2013-09-02','14:55:00',3.52),('11288','2013-09-02','15:00:00',3.94),('11288','2013-09-02','15:05:00',5.01),('11288','2013-09-02','15:10:00',2.87),('11288','2013-09-02','15:15:00',2.98),('11288','2013-09-02','15:20:00',1.47),('11288','2013-09-02','15:25:00',3.75),('11288','2013-09-02','15:30:00',5.17),('11288','2013-09-02','15:35:00',4.83),('11288','2013-09-02','15:40:00',4.42),('11288','2013-09-02','15:45:00',4.74),('11288','2013-09-02','15:50:00',4.79),('11288','2013-09-02','15:55:00',4.71),('11288','2013-09-02','16:00:00',4.66),('11288','2013-09-02','16:05:00',4.53),('11288','2013-09-02','16:10:00',4.39),('11288','2013-09-02','16:15:00',4.33),('11288','2013-09-02','16:20:00',4.25),('11288','2013-09-02','16:25:00',4.06),('11288','2013-09-02','16:30:00',3.9),('11288','2013-09-02','16:35:00',3.8),('11288','2013-09-02','16:40:00',3.66),('11288','2013-09-02','16:45:00',3.5),('11288','2013-09-02','16:50:00',3.32),('11288','2013-09-02','16:55:00',3.14),('11288','2013-09-02','17:00:00',3.02),('11288','2013-09-02','17:05:00',2.88),('11288','2013-09-02','17:10:00',2.78),('11288','2013-09-02','17:15:00',2.65),('11288','2013-09-02','17:20:00',2.55),('11288','2013-09-02','17:25:00',2.43),('11288','2013-09-02','17:30:00',2.3),('11288','2013-09-02','17:35:00',2.14),('11288','2013-09-02','17:40:00',2.01),('11288','2013-09-02','17:45:00',1.89),('11288','2013-09-02','17:50:00',1.75),('11288','2013-09-02','17:55:00',1.65),('11288','2013-09-02','18:00:00',1.52),('11288','2013-09-02','18:05:00',1.38),('11288','2013-09-02','18:10:00',1.26),('11288','2013-09-02','18:15:00',1.14),('11288','2013-09-02','18:20:00',1.01),('11288','2013-09-01','08:05:00',1.07),('11288','2013-09-01','08:10:00',1.19),('11288','2013-09-01','08:15:00',1.34),('11288','2013-09-01','08:20:00',1.43),('11288','2013-09-01','08:25:00',1.53),('11288','2013-09-01','08:30:00',1.68),('11288','2013-09-01','08:35:00',1.9),('11288','2013-09-01','08:40:00',2.08),('11288','2013-09-01','08:45:00',2.26),('11288','2013-09-01','08:50:00',2.33),('11288','2013-09-01','08:55:00',2.44),('11288','2013-09-01','09:00:00',2.57),('11288','2013-09-01','09:05:00',2.73),('11288','2013-09-01','09:10:00',2.73),('11288','2013-09-01','09:15:00',2.98),('11288','2013-09-01','09:20:00',3.17),('11288','2013-09-01','09:25:00',3.26),('11288','2013-09-01','09:30:00',3.27),('11288','2013-09-01','09:35:00',3.52),('11288','2013-09-01','09:40:00',3.6),('11288','2013-09-01','09:45:00',3.72),('11288','2013-09-01','09:50:00',3.89),('11288','2013-09-01','09:55:00',3.89),('11288','2013-09-01','10:00:00',4.02),('11288','2013-09-01','10:05:00',4.29),('11288','2013-09-01','10:10:00',4.44),('11288','2013-09-01','10:15:00',4.53),('11288','2013-09-01','10:20:00',4.61),('11288','2013-09-01','10:25:00',4.73),('11288','2013-09-01','10:30:00',4.85),('11288','2013-09-01','10:35:00',4.92),('11288','2013-09-01','10:40:00',5.01),('11288','2013-09-01','10:45:00',5.08),('11288','2013-09-01','10:50:00',5.15),('11288','2013-09-01','10:55:00',5.29),('11288','2013-09-01','11:00:00',5.32),('11288','2013-09-01','11:05:00',5.42),('11288','2013-09-01','11:10:00',5.46),('11288','2013-09-01','11:15:00',5.51),('11288','2013-09-01','11:20:00',5.49),('11288','2013-09-01','11:25:00',5.6),('11288','2013-09-01','11:30:00',5.57),('11288','2013-09-01','11:35:00',5.66),('11288','2013-09-01','11:40:00',5.74),('11288','2013-09-01','11:45:00',5.81),('11288','2013-09-01','11:50:00',5.84),('11288','2013-09-01','11:55:00',5.84),('11288','2013-09-01','12:00:00',5.88),('11288','2013-09-01','12:05:00',5.8),('11288','2013-09-01','12:10:00',5.96),('11288','2013-09-01','12:15:00',6.03),('11288','2013-09-01','12:20:00',6.09),('11288','2013-09-01','12:25:00',5.92),('11288','2013-09-01','12:30:00',6.12),('11288','2013-09-01','12:35:00',6.14),('11288','2013-09-01','12:40:00',6.19),('11288','2013-09-01','12:45:00',6.08),('11288','2013-09-01','12:50:00',6.15),('11288','2013-09-01','12:55:00',6.14),('11288','2013-09-01','13:00:00',6.28),('11288','2013-09-01','13:05:00',6.28),('11288','2013-09-01','13:10:00',6.25),('11288','2013-09-01','13:15:00',5.54),('11288','2013-09-01','13:20:00',6.3),('11288','2013-09-01','13:25:00',6.29),('11288','2013-09-01','13:30:00',6.33),('11288','2013-09-01','13:35:00',6.14),('11288','2013-09-01','13:40:00',6.21),('11288','2013-09-01','13:45:00',5.84),('11288','2013-09-01','13:50:00',5.25),('11288','2013-09-01','13:55:00',5.32),('11288','2013-09-01','14:00:00',4.76),('11288','2013-09-01','14:05:00',4.83),('11288','2013-09-01','14:10:00',5.57),('11288','2013-09-01','14:15:00',5.59),('11288','2013-09-01','14:20:00',5.08),('11288','2013-09-01','14:25:00',5.11),('11288','2013-09-01','14:30:00',5.27),('11288','2013-09-01','14:35:00',5.2),('11288','2013-09-01','14:40:00',5.27),('11288','2013-09-01','14:45:00',5.33),('11288','2013-09-01','14:50:00',5.26),('11288','2013-09-01','14:55:00',5.14),('11288','2013-09-01','15:00:00',5.11),('11288','2013-09-01','15:05:00',5.04),('11288','2013-09-01','15:10:00',5.02),('11288','2013-09-01','15:15:00',5),('11288','2013-09-01','15:20:00',4.64),('11288','2013-09-01','15:25:00',4.01),('11288','2013-09-01','15:30:00',3.43),('11288','2013-09-01','15:35:00',3.81),('11288','2013-09-01','15:40:00',4.49),('11288','2013-09-01','15:45:00',4.13),('11288','2013-09-01','15:50:00',3.04),('11288','2013-09-01','15:55:00',3.59),('11288','2013-09-01','16:00:00',4.3),('11288','2013-09-01','16:05:00',4.54),('11288','2013-09-01','16:10:00',4.31),('11288','2013-09-01','16:15:00',4.28),('11288','2013-09-01','16:20:00',3.83),('11288','2013-09-01','16:25:00',4.02),('11288','2013-09-01','16:30:00',4.18),('11288','2013-09-01','16:35:00',4.01),('11288','2013-09-01','16:40:00',3.89),('11288','2013-09-01','16:45:00',3.52),('11288','2013-09-01','16:50:00',3.45),('11288','2013-09-01','16:55:00',3.03),('11288','2013-09-01','17:00:00',2.56),('11288','2013-09-01','17:05:00',2.65),('11288','2013-09-01','17:10:00',2.24),('11288','2013-09-01','17:15:00',2.26),('11288','2013-09-01','17:20:00',2.42),('11288','2013-09-01','17:25:00',2.29),('11288','2013-09-01','17:30:00',2.01),('11288','2013-09-01','17:35:00',2.02),('11288','2013-09-01','17:40:00',2.07),('11288','2013-09-01','17:45:00',1.67),('11288','2013-09-01','17:50:00',1.56),('11288','2013-09-01','17:55:00',1.54),('11288','2013-09-01','18:00:00',1.54),('11288','2013-09-01','18:05:00',1.51),('11288','2013-09-01','18:10:00',1.57),('11288','2013-09-01','18:15:00',1.45),('11288','2013-09-01','18:20:00',1.29),('11288','2013-09-01','18:25:00',1.25),('11288','2013-09-01','18:30:00',1.17),('11288','2013-09-01','18:35:00',1.05),('11288','2013-09-01','18:40:00',1.09),('11288','2013-09-01','18:45:00',1.01),('11288','2013-08-31','08:20:00',1.18),('11288','2013-08-31','08:25:00',1.51),('11288','2013-08-31','08:30:00',1.76),('11288','2013-08-31','08:35:00',1.87),('11288','2013-08-31','08:40:00',2.15),('11288','2013-08-31','08:45:00',2.38),('11288','2013-08-31','08:50:00',2.58),('11288','2013-08-31','08:55:00',2.84),('11288','2013-08-31','09:00:00',2.92),('11288','2013-08-31','09:05:00',2.62),('11288','2013-08-31','09:10:00',2.29),('11288','2013-08-31','09:15:00',2.9),('11288','2013-08-31','09:20:00',2.94),('11288','2013-08-31','09:25:00',3.49),('11288','2013-08-31','09:30:00',3.52),('11288','2013-08-31','09:35:00',3.71),('11288','2013-08-31','09:40:00',3.9),('11288','2013-08-31','09:45:00',3.78),('11288','2013-08-31','09:50:00',3.83),('11288','2013-08-31','09:55:00',4.13),('11288','2013-08-31','10:00:00',4.37),('11288','2013-08-31','10:05:00',4.35),('11288','2013-08-31','10:10:00',4.59),('11288','2013-08-31','10:15:00',4.67),('11288','2013-08-31','10:20:00',4.75),('11288','2013-08-31','10:25:00',4.9),('11288','2013-08-31','10:30:00',5.03),('11288','2013-08-31','10:35:00',5.19),('11288','2013-08-31','10:40:00',5.21),('11288','2013-08-31','10:45:00',5.3),('11288','2013-08-31','10:50:00',5.46),('11288','2013-08-31','10:55:00',5.55),('11288','2013-08-31','11:00:00',5.67),('11288','2013-08-31','11:05:00',5.73),('11288','2013-08-31','11:10:00',5.76),('11288','2013-08-31','11:15:00',5.82),('11288','2013-08-31','11:20:00',5.89),('11288','2013-08-31','11:25:00',5.94),('11288','2013-08-31','11:30:00',6.01),('11288','2013-08-31','11:35:00',6.05),('11288','2013-08-31','11:40:00',6.1),('11288','2013-08-31','11:45:00',6.15),('11288','2013-08-31','11:50:00',6.19),('11288','2013-08-31','11:55:00',6.22),('11288','2013-08-31','12:00:00',6.05),('11288','2013-08-31','12:05:00',5.02),('11288','2013-08-31','12:10:00',4.99),('11288','2013-08-31','12:15:00',5.82),('11288','2013-08-31','12:20:00',6.36),('11288','2013-08-31','12:25:00',6.31),('11288','2013-08-31','12:30:00',6.3),('11288','2013-08-31','12:35:00',6.36),('11288','2013-08-31','12:40:00',6.28),('11288','2013-08-31','12:45:00',6.33),('11288','2013-08-31','12:50:00',6.28),('11288','2013-08-31','12:55:00',6.31),('11288','2013-08-31','13:00:00',6.3),('11288','2013-08-31','13:05:00',6.33),('11288','2013-08-31','13:10:00',6.23),('11288','2013-08-31','13:15:00',6.31),('11288','2013-08-31','13:20:00',6.31),('11288','2013-08-31','13:25:00',6.28),('11288','2013-08-31','13:30:00',6.32),('11288','2013-08-31','13:35:00',6.2),('11288','2013-08-31','13:40:00',6.16),('11288','2013-08-31','13:45:00',6.09),('11288','2013-08-31','13:50:00',6.18),('11288','2013-08-31','13:55:00',6.13),('11288','2013-08-31','14:00:00',6.15),('11288','2013-08-31','14:05:00',6.1),('11288','2013-08-31','14:10:00',6.06),('11288','2013-08-31','14:15:00',6.01),('11288','2013-08-31','14:20:00',5.95),('11288','2013-08-31','14:25:00',5.88),('11288','2013-08-31','14:30:00',5.81),('11288','2013-08-31','14:35:00',5.58),('11288','2013-08-31','14:40:00',5.68),('11288','2013-08-31','14:45:00',5.63),('11288','2013-08-31','14:50:00',5.67),('11288','2013-08-31','14:55:00',5.51),('11288','2013-08-31','15:00:00',5.47),('11288','2013-08-31','15:05:00',5.45),('11288','2013-08-31','15:10:00',5.39),('11288','2013-08-31','15:15:00',5.33),('11288','2013-08-31','15:20:00',5.24),('11288','2013-08-31','15:25:00',5.17),('11288','2013-08-31','15:30:00',5.16),('11288','2013-08-31','15:35:00',5),('11288','2013-08-31','15:40:00',4.97),('11288','2013-08-31','15:45:00',4.86),('11288','2013-08-31','15:50:00',4.76),('11288','2013-08-31','15:55:00',4.59),('11288','2013-08-31','16:00:00',4.53),('11288','2013-08-31','16:05:00',4.43),('11288','2013-08-31','16:10:00',4.36),('11288','2013-08-31','16:15:00',4.25),('11288','2013-08-31','16:20:00',4.19),('11288','2013-08-31','16:25:00',4.01),('11288','2013-08-31','16:30:00',3.9),('11288','2013-08-31','16:35:00',3.87),('11288','2013-08-31','16:40:00',3.75),('11288','2013-08-31','16:45:00',3.55),('11288','2013-08-31','16:50:00',3.4),('11288','2013-08-31','16:55:00',3.27),('11288','2013-08-31','17:00:00',3.14),('11288','2013-08-31','17:05:00',3.06),('11288','2013-08-31','17:10:00',2.93),('11288','2013-08-31','17:15:00',2.77),('11288','2013-08-31','17:20:00',2.68),('11288','2013-08-31','17:25:00',2.53),('11288','2013-08-31','17:30:00',2.39),('11288','2013-08-31','17:35:00',2.19),('11288','2013-08-31','17:40:00',2.1),('11288','2013-08-31','17:45:00',1.92),('11288','2013-08-31','17:50:00',1.77),('11288','2013-08-31','17:55:00',1.51),('11288','2013-08-31','18:05:00',1.08),('11288','2013-08-31','18:10:00',1.1),('11288','2013-08-31','18:20:00',1),('11288','2013-08-30','07:55:00',1.02),('11288','2013-08-30','08:00:00',1.18),('11288','2013-08-30','08:05:00',1.43),('11288','2013-08-30','08:10:00',1.62),('11288','2013-08-30','08:15:00',1.69),('11288','2013-08-30','08:20:00',1.86),('11288','2013-08-30','08:25:00',1.95),('11288','2013-08-30','08:30:00',2.09),('11288','2013-08-30','08:35:00',2.24),('11288','2013-08-30','08:40:00',2.32),('11288','2013-08-30','08:45:00',2.15),('11288','2013-08-30','08:50:00',2.01),('11288','2013-08-30','08:55:00',2.06),('11288','2013-08-30','09:00:00',2.37),('11288','2013-08-30','09:05:00',2.59),('11288','2013-08-30','09:10:00',2.37),('11288','2013-08-30','09:15:00',2.22),('11288','2013-08-30','09:20:00',1.99),('11288','2013-08-30','09:25:00',2.14),('11288','2013-08-30','09:30:00',2.6),('11288','2013-08-30','09:35:00',2.9),('11288','2013-08-30','09:40:00',2.79),('11288','2013-08-30','09:45:00',2.89),('11288','2013-08-30','09:50:00',2.94),('11288','2013-08-30','09:55:00',3.13),('11288','2013-08-30','10:00:00',3.19),('11288','2013-08-30','10:05:00',3.21),('11288','2013-08-30','10:10:00',3.19),('11288','2013-08-30','10:15:00',3.39),('11288','2013-08-30','10:20:00',3.55),('11288','2013-08-30','10:25:00',3.32),('11288','2013-08-30','10:30:00',3.63),('11288','2013-08-30','10:35:00',3.5),('11288','2013-08-30','10:40:00',3.3),('11288','2013-08-30','10:45:00',3.26),('11288','2013-08-30','10:50:00',3.44),('11288','2013-08-30','10:55:00',3.27),('11288','2013-08-30','11:00:00',3.46),('11288','2013-08-30','11:05:00',3.61),('11288','2013-08-30','11:10:00',3.82),('11288','2013-08-30','11:15:00',3.82),('11288','2013-08-30','11:20:00',3.86),('11288','2013-08-30','11:25:00',3.98),('11288','2013-08-30','11:30:00',4.17),('11288','2013-08-30','11:35:00',3.98),('11288','2013-08-30','11:40:00',4.29),('11288','2013-08-30','11:45:00',4.28),('11288','2013-08-30','11:50:00',4.81),('11288','2013-08-30','11:55:00',4.26),('11288','2013-08-30','12:00:00',3.87),('11288','2013-08-30','12:05:00',3.39),('11288','2013-08-30','12:10:00',3.7),('11288','2013-08-30','12:15:00',4.06),('11288','2013-08-30','12:20:00',4.34),('11288','2013-08-30','12:25:00',4.78),('11288','2013-08-30','12:30:00',5.35),('11288','2013-08-30','12:35:00',4.98),('11288','2013-08-30','12:40:00',4.92),('11288','2013-08-30','12:45:00',5.12),('11288','2013-08-30','12:50:00',5),('11288','2013-08-30','12:55:00',4.65),('11288','2013-08-30','13:00:00',4.62),('11288','2013-08-30','13:05:00',4.62),('11288','2013-08-30','13:10:00',4.63),('11288','2013-08-30','13:15:00',4.36),('11288','2013-08-30','13:20:00',5.37),('11288','2013-08-30','13:25:00',5.99),('11288','2013-08-30','13:30:00',6.35),('11288','2013-08-30','13:35:00',5.94),('11288','2013-08-30','13:40:00',6.21),('11288','2013-08-30','13:45:00',5.57),('11288','2013-08-30','13:50:00',5.59),('11288','2013-08-30','13:55:00',6.12),('11288','2013-08-30','14:00:00',6.31),('11288','2013-08-30','14:05:00',6.01),('11288','2013-08-30','14:10:00',6.11),('11288','2013-08-30','14:15:00',5.92),('11288','2013-08-30','14:20:00',6.17),('11288','2013-08-30','14:25:00',6.07),('11288','2013-08-30','14:30:00',5.98),('11288','2013-08-30','14:35:00',6.11),('11288','2013-08-30','14:40:00',5.78),('11288','2013-08-30','14:45:00',4.47),('11288','2013-08-30','14:50:00',4.05),('11288','2013-08-30','14:55:00',4.61),('11288','2013-08-30','15:00:00',4),('11288','2013-08-30','15:05:00',3.72),('11288','2013-08-30','15:10:00',3.82),('11288','2013-08-30','15:15:00',4.67),('11288','2013-08-30','15:20:00',3.89),('11288','2013-08-30','15:25:00',3.63),('11288','2013-08-30','15:30:00',3.47),('11288','2013-08-30','15:35:00',2.85),('11288','2013-08-30','15:40:00',3.14),('11288','2013-08-30','15:45:00',3.66),('11288','2013-08-30','15:50:00',3.93),('11288','2013-08-30','15:55:00',3.76),('11288','2013-08-30','16:00:00',3.57),('11288','2013-08-30','16:05:00',3.13),('11288','2013-08-30','16:10:00',2.62),('11288','2013-08-30','16:15:00',2.43),('11288','2013-08-30','16:20:00',2.72),('11288','2013-08-30','16:25:00',2.62),('11288','2013-08-30','16:30:00',3),('11288','2013-08-30','16:35:00',2.62),('11288','2013-08-30','16:40:00',3.39),('11288','2013-08-30','16:45:00',3.59),('11288','2013-08-30','16:50:00',3.3),('11288','2013-08-30','16:55:00',2.91),('11288','2013-08-30','17:00:00',3.24),('11288','2013-08-30','17:05:00',2.14),('11288','2013-08-30','17:10:00',2.47),('11288','2013-08-30','17:15:00',2.19),('11288','2013-08-30','17:20:00',1.89),('11288','2013-08-30','17:25:00',1.97),('11288','2013-08-30','17:30:00',2.06),('11288','2013-08-30','17:35:00',2.38),('11288','2013-08-30','17:40:00',1.74),('11288','2013-08-30','17:45:00',2.08),('11288','2013-08-30','17:50:00',2.02),('11288','2013-08-30','17:55:00',1.82),('11288','2013-08-30','18:00:00',1.4),('11288','2014-04-11','07:50:00',1.12),('11288','2014-04-11','07:55:00',1.17),('11288','2014-04-11','08:30:00',1.23),('11288','2014-04-11','08:35:00',2.44),('11288','2014-04-11','08:40:00',2.61),('11288','2014-04-11','08:45:00',2.76),('11288','2014-04-11','08:50:00',2.77),('11288','2014-04-11','08:55:00',2.73),('11288','2014-04-11','09:00:00',2.55),('11288','2014-04-11','09:05:00',2.91),('11288','2014-04-11','09:10:00',3.04),('11288','2014-04-11','09:15:00',3.19),('11288','2014-04-11','09:20:00',3.4),('11288','2014-04-11','09:25:00',3.51),('11288','2014-04-11','09:30:00',3.42),('11288','2014-04-11','09:35:00',3.73),('11288','2014-04-11','09:40:00',3.83),('11288','2014-04-11','09:45:00',3.84),('11288','2014-04-11','09:50:00',4.11),('11288','2014-04-11','09:55:00',4.19),('11288','2014-04-11','10:00:00',4.28),('11288','2014-04-11','10:05:00',4.62),('11288','2014-04-11','10:10:00',4.77),('11288','2014-04-11','10:15:00',4.86),('11288','2014-04-11','10:20:00',5.01),('11288','2014-04-11','10:25:00',5.15),('11288','2014-04-11','10:30:00',5.25),('11288','2014-04-11','10:35:00',5.29),('11288','2014-04-11','10:40:00',5.46),('11288','2014-04-11','10:45:00',5.57),('11288','2014-04-11','10:50:00',5.68),('11288','2014-04-11','10:55:00',5.78),('11288','2014-04-11','11:00:00',5.88),('11288','2014-04-11','11:05:00',5.94),('11288','2014-04-11','11:10:00',5.95),('11288','2014-04-11','11:15:00',6),('11288','2014-04-11','11:20:00',6.11),('11288','2014-04-11','11:25:00',6.2),('11288','2014-04-11','11:30:00',6.27),('11288','2014-04-11','11:35:00',6.32),('11288','2014-04-11','11:40:00',6.34),('11288','2014-04-11','11:45:00',6.43),('11288','2014-04-11','11:50:00',6.59),('11288','2014-04-11','11:55:00',6.44),('11288','2014-04-11','12:00:00',6.16),('11288','2014-04-11','12:05:00',6.77),('11288','2014-04-11','12:10:00',6.48),('11288','2014-04-11','12:15:00',5.92),('11288','2014-04-11','12:20:00',6.85),('11288','2014-04-11','12:25:00',6.9),('11288','2014-04-11','12:30:00',6.97),('11288','2014-04-11','12:35:00',7.12),('11288','2014-04-11','12:40:00',7.18),('11288','2014-04-11','12:45:00',6.64),('11288','2014-04-11','12:50:00',7.12),('11288','2014-04-11','12:55:00',7.04),('11288','2014-04-11','13:00:00',6.48),('11288','2014-04-11','13:05:00',7.52),('11288','2014-04-11','13:10:00',6.86),('11288','2014-04-11','13:15:00',4.84),('11288','2014-04-11','13:20:00',5.51),('11288','2014-04-11','13:25:00',7.39),('11288','2014-04-11','13:30:00',4.04),('11288','2014-04-11','13:35:00',4.43),('11288','2014-04-11','13:40:00',4.73),('11288','2014-04-11','13:45:00',7.22),('11288','2014-04-11','13:50:00',5.99),('11288','2014-04-11','13:55:00',5.98),('11288','2014-04-11','14:00:00',6.21),('11288','2014-04-11','14:05:00',6.55),('11288','2014-04-11','14:10:00',3.06),('11288','2014-04-11','14:15:00',3.66),('11288','2014-04-11','14:20:00',4.36),('11288','2014-04-11','14:25:00',5.6),('11288','2014-04-11','14:30:00',7.18),('11288','2014-04-11','14:35:00',6.89),('11288','2014-04-11','14:40:00',3.93),('11288','2014-04-11','14:45:00',5.24),('11288','2014-04-11','14:50:00',5.97),('11288','2014-04-11','14:55:00',4.41),('11288','2014-04-11','15:00:00',6.55),('11288','2014-04-11','15:05:00',5.21),('11288','2014-04-11','15:10:00',6.3),('11288','2014-04-11','15:15:00',6.21),('11288','2014-04-11','15:20:00',4.77),('11288','2014-04-11','15:25:00',6),('11288','2014-04-11','15:30:00',5.42),('11288','2014-04-11','15:35:00',4.13),('11288','2014-04-11','15:40:00',5.65),('11288','2014-04-11','15:45:00',5.47),('11288','2014-04-11','15:50:00',5.43),('11288','2014-04-11','15:55:00',5.33),('11288','2014-04-11','16:00:00',5.16),('11288','2014-04-11','16:05:00',4.96),('11288','2014-04-11','16:10:00',3.76),('11288','2014-04-11','16:15:00',4.77),('11288','2014-04-11','16:20:00',4.61),('11288','2014-04-11','16:25:00',4.55),('11288','2014-04-11','16:30:00',4.43),('11288','2014-04-11','16:35:00',3.21),('11288','2014-04-11','16:40:00',4.16),('11288','2014-04-11','16:45:00',3.83),('11288','2014-04-11','16:50:00',2.65),('11288','2014-04-11','16:55:00',3.47),('11288','2014-04-11','17:00:00',3.02),('11288','2014-04-11','17:05:00',3.28),('11288','2014-04-11','17:10:00',3.08),('11288','2014-04-11','17:15:00',2.8),('11288','2014-04-11','17:20:00',2.81),('11288','2014-04-11','17:25:00',2.94),('11288','2014-04-11','17:30:00',2.93),('11288','2014-04-11','17:35:00',2.84),('11288','2014-04-11','17:40:00',2.65),('11288','2014-04-11','17:45:00',2.36),('11288','2014-04-11','17:50:00',2.14),('11288','2014-04-11','17:55:00',1.98),('11288','2014-04-11','18:00:00',1.78),('11288','2014-04-11','18:05:00',1.64),('11288','2014-04-11','18:10:00',1.53),('11288','2014-04-11','18:15:00',1.46),('11288','2014-04-11','18:20:00',1.34),('11288','2014-04-11','18:25:00',1.28),('11288','2014-04-11','18:30:00',1.4),('11288','2014-04-11','18:35:00',1.21),('11288','2014-04-11','18:40:00',1.03),('11288','2013-08-29','07:55:00',1.07),('11288','2013-08-29','08:00:00',1.17),('11288','2013-08-29','08:05:00',1.2),('11288','2013-08-29','08:10:00',1.4),('11288','2013-08-29','08:15:00',1.53),('11288','2013-08-29','08:20:00',1.66),('11288','2013-08-29','08:25:00',2.06),('11288','2013-08-29','08:30:00',2.4),('11288','2013-08-29','08:35:00',2.47),('11288','2013-08-29','08:40:00',2.08),('11288','2013-08-29','08:45:00',1.8),('11288','2013-08-29','08:50:00',2.14),('11288','2013-08-29','08:55:00',2.7),('11288','2013-08-29','09:00:00',2.63),('11288','2013-08-29','09:05:00',2.61),('11288','2013-08-29','09:10:00',2.59),('11288','2013-08-29','09:15:00',2.72),('11288','2013-08-29','09:20:00',2.69),('11288','2013-08-29','09:25:00',2.54),('11288','2013-08-29','09:30:00',2.63),('11288','2013-08-29','09:35:00',2.85),('11288','2013-08-29','09:40:00',2.84),('11288','2013-08-29','09:45:00',2.62),('11288','2013-08-29','09:50:00',2.54),('11288','2013-08-29','09:55:00',2.64),('11288','2013-08-29','10:00:00',2.77),('11288','2013-08-29','10:05:00',2.65),('11288','2013-08-29','10:10:00',2.6),('11288','2013-08-29','10:15:00',2.61),('11288','2013-08-29','10:20:00',2.65),('11288','2013-08-29','10:25:00',2.67),('11288','2013-08-29','10:30:00',2.74),('11288','2013-08-29','10:35:00',2.58),('11288','2013-08-29','10:40:00',2.37),('11288','2013-08-29','10:45:00',2.22),('11288','2013-08-29','10:50:00',2.22),('11288','2013-08-29','10:55:00',2.48),('11288','2013-08-29','11:00:00',2.63),('11288','2013-08-29','11:05:00',2.68),('11288','2013-08-29','11:10:00',3.86),('11288','2013-08-29','11:15:00',4.18),('11288','2013-08-29','11:20:00',3.95),('11288','2013-08-29','11:25:00',3.08),('11288','2013-08-29','11:30:00',2.66),('11288','2013-08-29','11:35:00',2.44),('11288','2013-08-29','11:40:00',2.76),('11288','2013-08-29','11:45:00',3.21),('11288','2013-08-29','11:50:00',3.29),('11288','2013-08-29','11:55:00',3.16),('11288','2013-08-29','12:00:00',3.13),('11288','2013-08-29','12:05:00',3.67),('11288','2013-08-29','12:10:00',4.26),('11288','2013-08-29','12:15:00',4.85),('11288','2013-08-29','12:20:00',4.34),('11288','2013-08-29','12:25:00',4.39),('11288','2013-08-29','12:30:00',4.49),('11288','2013-08-29','12:35:00',5.62),('11288','2013-08-29','12:40:00',7.46),('11288','2013-08-29','12:45:00',6.6),('11288','2013-08-29','12:50:00',4.23),('11288','2013-08-29','12:55:00',6.6),('11288','2013-08-29','13:00:00',4.48),('11288','2013-08-29','13:05:00',4.25),('11288','2013-08-29','13:10:00',4.13),('11288','2013-08-29','13:15:00',4.03),('11288','2013-08-29','13:20:00',3.86),('11288','2013-08-29','13:25:00',3.39),('11288','2013-08-29','13:30:00',3.17),('11288','2013-08-29','13:35:00',2.97),('11288','2013-08-29','13:40:00',2.86),('11288','2013-08-29','13:45:00',2.71),('11288','2013-08-29','13:50:00',2.67),('11288','2013-08-29','13:55:00',3.12),('11288','2013-08-29','14:00:00',3.86),('11288','2013-08-29','14:05:00',2.91),('11288','2013-08-29','14:10:00',2.63),('11288','2013-08-29','14:15:00',2.2),('11288','2013-08-29','14:20:00',1.78),('11288','2013-08-29','14:25:00',1.61),('11288','2013-08-29','14:30:00',1.54),('11288','2013-08-29','14:35:00',1.58),('11288','2013-08-29','14:40:00',1.63),('11288','2013-08-29','14:45:00',1.84),('11288','2013-08-29','14:50:00',2.14),('11288','2013-08-29','14:55:00',2.46),('11288','2013-08-29','15:00:00',2.7),('11288','2013-08-29','15:05:00',2.98),('11288','2013-08-29','15:10:00',2.34),('11288','2013-08-29','15:15:00',2.08),('11288','2013-08-29','15:20:00',2.3),('11288','2013-08-29','15:25:00',2.63),('11288','2013-08-29','15:30:00',4.23),('11288','2013-08-29','15:35:00',3.71),('11288','2013-08-29','15:40:00',3.65),('11288','2013-08-29','15:45:00',4.07),('11288','2013-08-29','15:50:00',4.87),('11288','2013-08-29','15:55:00',5.1),('11288','2013-08-29','16:00:00',4.82),('11288','2013-08-29','16:05:00',5.5),('11288','2013-08-29','16:10:00',5.07),('11288','2013-08-29','16:15:00',4.68),('11288','2013-08-29','16:20:00',4.49),('11288','2013-08-29','16:25:00',4.31),('11288','2013-08-29','16:30:00',4.18),('11288','2013-08-29','16:35:00',4.04),('11288','2013-08-29','16:40:00',3.92),('11288','2013-08-29','16:45:00',3.81),('11288','2013-08-29','16:50:00',3.68),('11288','2013-08-29','16:55:00',3.54),('11288','2013-08-29','17:00:00',3.43),('11288','2013-08-29','17:05:00',3.29),('11288','2013-08-29','17:10:00',3.14),('11288','2013-08-29','17:15:00',3.02),('11288','2013-08-29','17:20:00',2.86),('11288','2013-08-29','17:25:00',2.71),('11288','2013-08-29','17:30:00',2.58),('11288','2013-08-29','17:35:00',2.44),('11288','2013-08-29','17:40:00',2.29),('11288','2013-08-29','17:45:00',2.11),('11288','2013-08-29','17:50:00',1.98),('11288','2013-08-29','17:55:00',1.82),('11288','2013-08-29','18:00:00',1.71),('11288','2013-08-29','18:05:00',1.58),('11288','2013-08-29','18:10:00',1.47),('11288','2013-08-29','18:15:00',1.36),('11288','2013-08-29','18:20:00',1.24),('11288','2013-08-29','18:25:00',1.1),('11288','2013-08-28','08:00:00',1.2),('11288','2013-08-28','08:05:00',1.21),('11288','2013-08-28','08:10:00',1.3),('11288','2013-08-28','08:15:00',1.45),('11288','2013-08-28','08:20:00',1.54),('11288','2013-08-28','08:25:00',1.59),('11288','2013-08-28','08:30:00',1.8),('11288','2013-08-28','08:35:00',2.03),('11288','2013-08-28','08:40:00',1.98),('11288','2013-08-28','08:45:00',2.01),('11288','2013-08-28','08:50:00',2.05),('11288','2013-08-28','08:55:00',1.5),('11288','2013-08-28','09:00:00',2.4),('11288','2013-08-28','09:05:00',1.39),('11288','2013-08-28','09:10:00',2.1),('11288','2013-08-28','09:15:00',2.78),('11288','2013-08-28','09:20:00',1.97),('11288','2013-08-28','09:25:00',1.3),('11288','2013-08-28','09:30:00',1.9),('11288','2013-08-28','09:35:00',3.17),('11288','2013-08-28','09:40:00',3.89),('11288','2013-08-28','09:45:00',3.94),('11288','2013-08-28','09:50:00',4.13),('11288','2013-08-28','09:55:00',4.19),('11288','2013-08-28','10:00:00',4.14),('11288','2013-08-28','10:05:00',4.39),('11288','2013-08-28','10:10:00',4.59),('11288','2013-08-28','10:15:00',4.83),('11288','2013-08-28','10:20:00',4.69),('11288','2013-08-28','10:25:00',1.91),('11288','2013-08-28','10:30:00',2.98),('11288','2013-08-28','10:35:00',3.41),('11288','2013-08-28','10:40:00',4.93),('11288','2013-08-28','10:45:00',5.47),('11288','2013-08-28','10:50:00',5.32),('11288','2013-08-28','10:55:00',5.46),('11288','2013-08-28','11:00:00',2.51),('11288','2013-08-28','11:05:00',6.27),('11288','2013-08-28','11:10:00',3.2),('11288','2013-08-28','11:15:00',6.63),('11288','2013-08-28','11:20:00',6.15),('11288','2013-08-28','11:25:00',6.24),('11288','2013-08-28','11:30:00',6.37),('11288','2013-08-28','11:35:00',6.46),('11288','2013-08-28','11:40:00',6.56),('11288','2013-08-28','11:45:00',5.66),('11288','2013-08-28','11:50:00',5.33),('11288','2013-08-28','11:55:00',1.98),('11288','2013-08-28','12:00:00',5.97),('11288','2013-08-28','12:05:00',6.11),('11288','2013-08-28','12:10:00',5.05),('11288','2013-08-28','12:15:00',6.72),('11288','2013-08-28','12:20:00',6.11),('11288','2013-08-28','12:25:00',6.59),('11288','2013-08-28','12:30:00',6.5),('11288','2013-08-28','12:35:00',6.49),('11288','2013-08-28','12:40:00',6.61),('11288','2013-08-28','12:45:00',6.74),('11288','2013-08-28','12:50:00',6.63),('11288','2013-08-28','12:55:00',6.62),('11288','2013-08-28','13:00:00',6.74),('11288','2013-08-28','13:05:00',6.88),('11288','2013-08-28','13:10:00',6.82),('11288','2013-08-28','13:15:00',6.7),('11288','2013-08-28','13:20:00',6.61),('11288','2013-08-28','13:25:00',5.66),('11288','2013-08-28','13:30:00',6.23),('11288','2013-08-28','13:35:00',6.74),('11288','2013-08-28','13:40:00',5.28),('11288','2013-08-28','13:45:00',6.23),('11288','2013-08-28','13:50:00',6.84),('11288','2013-08-28','13:55:00',4.52),('11288','2013-08-28','14:00:00',6.67),('11288','2013-08-28','14:05:00',6.56),('11288','2013-08-28','14:10:00',6.36),('11288','2013-08-28','14:15:00',6.39),('11288','2013-08-28','14:20:00',6.36),('11288','2013-08-28','14:25:00',6.36),('11288','2013-08-28','14:30:00',6.31),('11288','2013-08-28','14:35:00',6.47),('11288','2013-08-28','14:40:00',6.27),('11288','2013-08-28','14:45:00',6.17),('11288','2013-08-28','14:50:00',6.09),('11288','2013-08-28','14:55:00',6.03),('11288','2013-08-28','15:00:00',5.93),('11288','2013-08-28','15:05:00',4.83),('11288','2013-08-28','15:10:00',5.74),('11288','2013-08-28','15:15:00',5.93),('11288','2013-08-28','15:20:00',4.96),('11288','2013-08-28','15:25:00',4.54),('11288','2013-08-28','15:30:00',4.89),('11288','2013-08-28','15:35:00',5.6),('11288','2013-08-28','15:40:00',2.15),('11288','2013-08-28','15:45:00',2.16),('11288','2013-08-28','15:50:00',2.71),('11288','2013-08-28','15:55:00',5.72),('11288','2013-08-28','16:00:00',5.42),('11288','2013-08-28','16:05:00',3.53),('11288','2013-08-28','16:10:00',3.2),('11288','2013-08-28','16:15:00',3.49),('11288','2013-08-28','16:20:00',4.44),('11288','2013-08-28','16:25:00',4.78),('11288','2013-08-28','16:30:00',4.5),('11288','2013-08-28','16:35:00',4.37),('11288','2013-08-28','16:40:00',4.22),('11288','2013-08-28','16:45:00',4),('11288','2013-08-28','16:50:00',3.82),('11288','2013-08-28','16:55:00',3.72),('11288','2013-08-28','17:00:00',3.62),('11288','2013-08-28','17:05:00',3.4),('11288','2013-08-28','17:10:00',3.32),('11288','2013-08-28','17:15:00',2.55),('11288','2013-08-28','17:20:00',1.57),('11288','2013-08-28','17:25:00',2.91),('11288','2013-08-28','17:30:00',1.95),('11288','2013-08-28','17:35:00',2.7),('11288','2013-08-28','17:40:00',2.55),('11288','2013-08-28','17:45:00',1.16),('11288','2013-08-28','17:50:00',1),('11288','2013-08-28','17:55:00',1.45),('11288','2013-08-28','18:00:00',1.16),('11288','2013-08-28','18:05:00',1.01),('11288','2013-08-28','18:10:00',1.52),('11288','2013-08-28','18:15:00',1.39),('11288','2013-08-28','18:25:00',1.09),('11288','2013-08-27','08:05:00',1.03),('11288','2013-08-27','08:10:00',1.22),('11288','2013-08-27','08:15:00',1.46),('11288','2013-08-27','08:20:00',1.82),('11288','2013-08-27','08:25:00',2.08),('11288','2013-08-27','08:30:00',2.01),('11288','2013-08-27','08:35:00',1.64),('11288','2013-08-27','08:40:00',1.58),('11288','2013-08-27','08:45:00',1.72),('11288','2013-08-27','08:50:00',1.37),('11288','2013-08-27','08:55:00',1.26),('11288','2013-08-27','09:00:00',1.49),('11288','2013-08-27','09:05:00',1.62),('11288','2013-08-27','09:10:00',2.01),('11288','2013-08-27','09:15:00',2.02),('11288','2013-08-27','09:20:00',2.42),('11288','2013-08-27','09:25:00',3),('11288','2013-08-27','09:30:00',3.17),('11288','2013-08-27','09:35:00',1.99),('11288','2013-08-27','09:40:00',1.67),('11288','2013-08-27','09:45:00',1.75),('11288','2013-08-27','09:50:00',1.83),('11288','2013-08-27','09:55:00',2.36),('11288','2013-08-27','10:00:00',3.01),('11288','2013-08-27','10:05:00',3.59),('11288','2013-08-27','10:10:00',4.47),('11288','2013-08-27','10:15:00',4.49),('11288','2013-08-27','10:20:00',4.77),('11288','2013-08-27','10:25:00',4.85),('11288','2013-08-27','10:30:00',4.91),('11288','2013-08-27','10:35:00',4.95),('11288','2013-08-27','10:40:00',4.9),('11288','2013-08-27','10:45:00',5.05),('11288','2013-08-27','10:50:00',5.09),('11288','2013-08-27','10:55:00',5.19),('11288','2013-08-27','11:00:00',5.19),('11288','2013-08-27','11:05:00',5.33),('11288','2013-08-27','11:10:00',5.35),('11288','2013-08-27','11:15:00',5.31),('11288','2013-08-27','11:20:00',5.39),('11288','2013-08-27','11:25:00',5.43),('11288','2013-08-27','11:30:00',5.53),('11288','2013-08-27','11:35:00',5.33),('11288','2013-08-27','11:40:00',5.23),('11288','2013-08-27','11:45:00',6.48),('11288','2013-08-27','11:50:00',4.4),('11288','2013-08-27','11:55:00',6.19),('11288','2013-08-27','12:00:00',6.64),('11288','2013-08-27','12:05:00',5.76),('11288','2013-08-27','12:10:00',4.79),('11288','2013-08-27','12:15:00',5.69),('11288','2013-08-27','12:20:00',6.24),('11288','2013-08-27','12:25:00',6.12),('11288','2013-08-27','12:30:00',6.26),('11288','2013-08-27','12:35:00',6.76),('11288','2013-08-27','12:40:00',6.53),('11288','2013-08-27','12:45:00',4.59),('11288','2013-08-27','12:50:00',3.27),('11288','2013-08-27','12:55:00',2.79),('11288','2013-08-27','13:00:00',2.14),('11288','2013-08-27','13:05:00',2.78),('11288','2013-08-27','13:10:00',2.85),('11288','2013-08-27','13:15:00',3.13),('11288','2013-08-27','13:20:00',3.51),('11288','2013-08-27','13:25:00',3.82),('11288','2013-08-27','13:30:00',4.02),('11288','2013-08-27','13:35:00',3.42),('11288','2013-08-27','13:40:00',3.26),('11288','2013-08-27','13:45:00',5.09),('11288','2013-08-27','13:50:00',5.66),('11288','2013-08-27','13:55:00',5.41),('11288','2013-08-27','14:00:00',6.38),('11288','2013-08-27','14:05:00',3.22),('11288','2013-08-27','14:10:00',3.84),('11288','2013-08-27','14:15:00',5.08),('11288','2013-08-27','14:20:00',3.06),('11288','2013-08-27','14:25:00',2.12),('11288','2013-08-27','14:30:00',2.11),('11288','2013-08-27','14:35:00',1.87),('11288','2013-08-27','14:40:00',2.12),('11288','2013-08-27','14:45:00',2.14),('11288','2013-08-27','14:50:00',1.67),('11288','2013-08-27','14:55:00',1.36),('11288','2013-08-27','15:00:00',1.33),('11288','2013-08-27','15:05:00',1.22),('11288','2013-08-27','15:10:00',1.27),('11288','2013-08-27','15:15:00',1.38),('11288','2013-08-27','15:20:00',1.23),('11288','2013-08-27','15:35:00',1.01),('11288','2013-08-27','15:50:00',1.01),('11288','2013-08-27','15:55:00',2.45),('11288','2013-08-27','16:00:00',2.51),('11288','2013-08-27','16:05:00',3.57),('11288','2013-08-27','16:10:00',5.91),('11288','2013-08-27','16:15:00',5.18),('11288','2013-08-27','16:20:00',3.73),('11288','2013-08-27','16:25:00',3.49),('11288','2013-08-27','16:30:00',1.51),('11288','2013-08-27','16:35:00',1.97),('11288','2013-08-27','16:40:00',2.82),('11288','2013-08-27','16:45:00',2.68),('11288','2013-08-27','16:50:00',3.96),('11288','2013-08-27','16:55:00',3.3),('11288','2013-08-27','17:00:00',1.14),('11288','2013-08-27','17:05:00',2.22),('11288','2013-08-27','17:10:00',4.11),('11288','2013-08-27','17:15:00',2.14),('11288','2013-08-27','17:20:00',1.48),('11288','2013-08-27','17:25:00',1.48),('11288','2013-08-27','17:30:00',1.26),('11288','2013-08-27','17:35:00',1.56),('11288','2013-08-27','17:40:00',1.27),('11288','2013-08-27','17:45:00',2.01),('11288','2013-08-27','17:50:00',2.17),('11288','2013-08-27','17:55:00',2.26),('11288','2013-08-27','18:00:00',1.85),('11288','2013-08-27','18:05:00',1.35),('11288','2013-08-26','07:40:00',1.06),('11288','2013-08-26','07:55:00',1.01),('11288','2013-08-26','08:00:00',1.06),('11288','2013-08-26','08:05:00',1.76),('11288','2013-08-26','08:10:00',1.78),('11288','2013-08-26','08:15:00',1.39),('11288','2013-08-26','08:20:00',1.69),('11288','2013-08-26','08:25:00',1.54),('11288','2013-08-26','08:30:00',1.88),('11288','2013-08-26','08:35:00',1.65),('11288','2013-08-26','08:40:00',2.18),('11288','2013-08-26','08:45:00',2.24),('11288','2013-08-26','08:50:00',2.35),('11288','2013-08-26','08:55:00',2.57),('11288','2013-08-26','09:00:00',2.77),('11288','2013-08-26','09:05:00',2.83),('11288','2013-08-26','09:10:00',2.98),('11288','2013-08-26','09:15:00',3.13),('11288','2013-08-26','09:20:00',3.22),('11288','2013-08-26','09:25:00',3.32),('11288','2013-08-26','09:30:00',3.36),('11288','2013-08-26','09:35:00',3.4),('11288','2013-08-26','09:40:00',3.76),('11288','2013-08-26','09:45:00',3.86),('11288','2013-08-26','09:50:00',3.91),('11288','2013-08-26','09:55:00',4.04),('11288','2013-08-26','10:00:00',4.2),('11288','2013-08-26','10:05:00',4.39),('11288','2013-08-26','10:10:00',4.43),('11288','2013-08-26','10:15:00',4.53),('11288','2013-08-26','10:20:00',4.76),('11288','2013-08-26','10:25:00',4.84),('11288','2013-08-26','10:30:00',4.89),('11288','2013-08-26','10:35:00',4.99),('11288','2013-08-26','10:40:00',5.08),('11288','2013-08-26','10:45:00',5.17),('11288','2013-08-26','10:50:00',5.25),('11288','2013-08-26','10:55:00',5.32),('11288','2013-08-26','11:00:00',5.39),('11288','2013-08-26','11:05:00',5.43),('11288','2013-08-26','11:10:00',5.49),('11288','2013-08-26','11:15:00',5.54),('11288','2013-08-26','11:20:00',5.58),('11288','2013-08-26','11:25:00',5.63),('11288','2013-08-26','11:30:00',5.69),('11288','2013-08-26','11:35:00',5.77),('11288','2013-08-26','11:40:00',5.8),('11288','2013-08-26','11:45:00',5.87),('11288','2013-08-26','11:50:00',5.91),('11288','2013-08-26','11:55:00',5.91),('11288','2013-08-26','12:00:00',6),('11288','2013-08-26','12:05:00',6.03),('11288','2013-08-26','12:10:00',4.44),('11288','2013-08-26','12:15:00',5.65),('11288','2013-08-26','12:20:00',6),('11288','2013-08-26','12:25:00',6.02),('11288','2013-08-26','12:30:00',5.26),('11288','2013-08-26','12:35:00',4.89),('11288','2013-08-26','12:40:00',6.18),('11288','2013-08-26','12:45:00',6.14),('11288','2013-08-26','12:50:00',6.2),('11288','2013-08-26','12:55:00',4.29),('11288','2013-08-26','13:00:00',6.45),('11288','2013-08-26','13:05:00',6.95),('11288','2013-08-26','13:10:00',6.52),('11288','2013-08-26','13:15:00',3.66),('11288','2013-08-26','13:20:00',4.38),('11288','2013-08-26','13:25:00',4.91),('11288','2013-08-26','13:30:00',4.78),('11288','2013-08-26','13:35:00',5.71),('11288','2013-08-26','13:40:00',6.22),('11288','2013-08-26','13:45:00',6.24),('11288','2013-08-26','13:50:00',5.61),('11288','2013-08-26','13:55:00',4.43),('11288','2013-08-26','14:00:00',4.08),('11288','2013-08-26','14:05:00',5.08),('11288','2013-08-26','14:10:00',4.39),('11288','2013-08-26','14:15:00',5.96),('11288','2013-08-26','14:20:00',6.07),('11288','2013-08-26','14:25:00',5.98),('11288','2013-08-26','14:30:00',5.95),('11288','2013-08-26','14:35:00',5.61),('11288','2013-08-26','14:40:00',5.04),('11288','2013-08-26','14:45:00',3.73),('11288','2013-08-26','14:50:00',3.45),('11288','2013-08-26','14:55:00',3.3),('11288','2013-08-26','15:00:00',3.12),('11288','2013-08-26','15:05:00',2.22),('11288','2013-08-26','15:10:00',1.79),('11288','2013-08-26','15:15:00',1.59),('11288','2013-08-26','15:20:00',1.32),('11288','2013-08-26','15:25:00',1.23),('11288','2013-08-26','15:30:00',1.35),('11288','2013-08-26','15:35:00',1.79),('11288','2013-08-26','15:40:00',2.76),('11288','2013-08-26','15:45:00',2.92),('11288','2013-08-26','15:50:00',2.86),('11288','2013-08-26','15:55:00',2.82),('11288','2013-08-26','16:00:00',4.43),('11288','2013-08-26','16:05:00',5.35),('11288','2013-08-26','16:10:00',4.63),('11288','2013-08-26','16:15:00',4.43),('11288','2013-08-26','16:20:00',4.26),('11288','2013-08-26','16:25:00',4.13),('11288','2013-08-26','16:30:00',4.03),('11288','2013-08-26','16:35:00',3.91),('11288','2013-08-26','16:40:00',3.8),('11288','2013-08-26','16:45:00',3.76),('11288','2013-08-26','16:50:00',3.45),('11288','2013-08-26','16:55:00',3.38),('11288','2013-08-26','17:00:00',3.29),('11288','2013-08-26','17:05:00',3.02),('11288','2013-08-26','17:10:00',3.01),('11288','2013-08-26','17:15:00',2.88),('11288','2013-08-26','17:20:00',1.97),('11288','2013-08-26','17:30:00',2.13),('11288','2013-08-26','17:35:00',1.62),('11288','2013-08-26','17:40:00',1.69),('11288','2013-08-26','17:45:00',1.96),('11288','2013-08-26','17:50:00',2.18),('11288','2013-08-26','17:55:00',2.14),('11288','2013-08-26','18:00:00',1.88),('11288','2013-08-26','18:05:00',1.64),('11288','2013-08-26','18:10:00',1.46),('11288','2013-08-26','18:15:00',1.32),('11288','2013-08-26','18:20:00',1.2),('11288','2013-08-26','18:25:00',1.08),('11288','2013-08-25','07:55:00',1.14),('11288','2013-08-25','08:00:00',1.17),('11288','2013-08-25','08:05:00',1.4),('11288','2013-08-25','08:10:00',1.73),('11288','2013-08-25','08:15:00',1.57),('11288','2013-08-25','08:20:00',1.47),('11288','2013-08-25','08:25:00',1.68),('11288','2013-08-25','08:30:00',1.3),('11288','2013-08-25','08:35:00',1.39),('11288','2013-08-25','08:40:00',1.94),('11288','2013-08-25','08:45:00',1.86),('11288','2013-08-25','08:50:00',1.42),('11288','2013-08-25','09:05:00',1.37),('11288','2013-08-25','09:10:00',1.32),('11288','2013-08-25','09:15:00',1.84),('11288','2013-08-25','09:20:00',3.13),('11288','2013-08-25','09:25:00',3.46),('11288','2013-08-25','09:30:00',2.24),('11288','2013-08-25','09:35:00',1.62),('11288','2013-08-25','09:40:00',3.59),('11288','2013-08-25','09:45:00',4.83),('11288','2013-08-25','09:50:00',4.33),('11288','2013-08-25','09:55:00',4.2),('11288','2013-08-25','10:00:00',3.49),('11288','2013-08-25','10:05:00',2.36),('11288','2013-08-25','10:10:00',1.52),('11288','2013-08-25','10:15:00',1.24),('11288','2013-08-25','10:20:00',1.18),('11288','2013-08-25','15:00:00',1.37),('11288','2013-08-25','15:05:00',1.71),('11288','2013-08-25','15:10:00',1.88),('11288','2013-08-25','15:15:00',2.17),('11288','2013-08-25','15:20:00',2.55),('11288','2013-08-25','15:25:00',2.74),('11288','2013-08-25','15:30:00',3.76),('11288','2013-08-25','15:35:00',5.56),('11288','2013-08-25','15:40:00',6.03),('11288','2013-08-25','15:45:00',6.05),('11288','2013-08-25','15:50:00',3.11),('11288','2013-08-25','15:55:00',5.02),('11288','2013-08-25','16:00:00',5.52),('11288','2013-08-25','16:05:00',5.15),('11288','2013-08-25','16:10:00',4.89),('11288','2013-08-25','16:15:00',4.71),('11288','2013-08-25','16:20:00',4.55),('11288','2013-08-25','16:25:00',4.44),('11288','2013-08-25','16:30:00',4.38),('11288','2013-08-25','16:35:00',4.18),('11288','2013-08-25','16:40:00',2.72),('11288','2013-08-25','16:45:00',1.95),('11288','2013-08-25','16:50:00',3.18),('11288','2013-08-25','16:55:00',4.2),('11288','2013-08-25','17:00:00',3.84),('11288','2013-08-25','17:05:00',3.65),('11288','2013-08-25','17:10:00',3.38),('11288','2013-08-25','17:15:00',3.12),('11288','2013-08-25','17:20:00',2.97),('11288','2013-08-25','17:25:00',2.8),('11288','2013-08-25','17:30:00',2.66),('11288','2013-08-25','17:35:00',2.32),('11288','2013-08-25','17:40:00',2.13),('11288','2013-08-25','17:45:00',2.28),('11288','2013-08-25','17:50:00',2.01),('11288','2013-08-25','17:55:00',1.72),('11288','2013-08-25','18:00:00',1.35),('11288','2013-08-25','18:05:00',1.19),('11288','2013-08-25','18:10:00',1.37),('11288','2013-08-25','18:15:00',1.49),('11288','2013-08-25','18:20:00',1.42),('11288','2013-08-25','18:25:00',1.24),('11288','2013-08-25','18:30:00',1.08),('11288','2013-08-24','07:55:00',1.03),('11288','2013-08-24','08:00:00',1.08),('11288','2013-08-24','08:05:00',1.02),('11288','2013-08-24','08:10:00',1.29),('11288','2013-08-24','08:15:00',1.22),('11288','2013-08-24','08:20:00',1.38),('11288','2013-08-24','08:25:00',1.64),('11288','2013-08-24','08:30:00',1.76),('11288','2013-08-24','08:35:00',1.95),('11288','2013-08-24','08:40:00',2.19),('11288','2013-08-24','08:45:00',2.09),('11288','2013-08-24','08:50:00',2.27),('11288','2013-08-24','08:55:00',2.77),('11288','2013-08-24','09:00:00',2.79),('11288','2013-08-24','09:05:00',2.95),('11288','2013-08-24','09:10:00',3),('11288','2013-08-24','09:15:00',2.83),('11288','2013-08-24','09:20:00',2.93),('11288','2013-08-24','09:25:00',3.4),('11288','2013-08-24','09:30:00',3.7),('11288','2013-08-24','09:35:00',3.25),('11288','2013-08-24','09:40:00',3.35),('11288','2013-08-24','09:45:00',3.63),('11288','2013-08-24','09:50:00',2.63),('11288','2013-08-24','09:55:00',3.15),('11288','2013-08-24','10:00:00',3.92),('11288','2013-08-24','10:05:00',4.37),('11288','2013-08-24','10:10:00',4.45),('11288','2013-08-24','10:15:00',4.58),('11288','2013-08-24','10:20:00',4.73),('11288','2013-08-24','10:25:00',4.8),('11288','2013-08-24','10:30:00',4.83),('11288','2013-08-24','10:35:00',4.99),('11288','2013-08-24','10:40:00',5.05),('11288','2013-08-24','10:45:00',5.01),('11288','2013-08-24','10:50:00',5.36),('11288','2013-08-24','10:55:00',5.29),('11288','2013-08-24','11:00:00',5.31),('11288','2013-08-24','11:05:00',5.5),('11288','2013-08-24','11:10:00',5.49),('11288','2013-08-24','11:15:00',5.42),('11288','2013-08-24','11:20:00',5.5),('11288','2013-08-24','11:25:00',5.64),('11288','2013-08-24','11:30:00',5.64),('11288','2013-08-24','11:35:00',5.71),('11288','2013-08-24','11:40:00',5.75),('11288','2013-08-24','11:45:00',5.78),('11288','2013-08-24','11:50:00',5.79),('11288','2013-08-24','11:55:00',5.88),('11288','2013-08-24','12:00:00',5.95),('11288','2013-08-24','12:05:00',6.09),('11288','2013-08-24','12:10:00',6.04),('11288','2013-08-24','12:15:00',6.03),('11288','2013-08-24','12:20:00',6.12),('11288','2013-08-24','12:25:00',6.11),('11288','2013-08-24','12:30:00',6.12),('11288','2013-08-24','12:35:00',6.15),('11288','2013-08-24','12:40:00',6.1),('11288','2013-08-24','12:45:00',6.12),('11288','2013-08-24','12:50:00',6.18),('11288','2013-08-24','12:55:00',6.08),('11288','2013-08-24','13:00:00',6.16),('11288','2013-08-24','13:05:00',6.17),('11288','2013-08-24','13:10:00',6.15),('11288','2013-08-24','13:15:00',6.22),('11288','2013-08-24','13:20:00',6.28),('11288','2013-08-24','13:25:00',6.26),('11288','2013-08-24','13:30:00',6.27),('11288','2013-08-24','13:35:00',6.27),('11288','2013-08-24','13:40:00',6.22),('11288','2013-08-24','13:45:00',6.19),('11288','2013-08-24','13:50:00',6.14),('11288','2013-08-24','13:55:00',6.16),('11288','2013-08-24','14:00:00',6.1),('11288','2013-08-24','14:05:00',6.07),('11288','2013-08-24','14:10:00',6.05),('11288','2013-08-24','14:15:00',6.03),('11288','2013-08-24','14:20:00',5.98),('11288','2013-08-24','14:25:00',5.95),('11288','2013-08-24','14:30:00',5.94),('11288','2013-08-24','14:35:00',5.89),('11288','2013-08-24','14:40:00',5.85),('11288','2013-08-24','14:45:00',5.78),('11288','2013-08-24','14:50:00',5.73),('11288','2013-08-24','14:55:00',5.67),('11288','2013-08-24','15:00:00',5.65),('11288','2013-08-24','15:05:00',5.59),('11288','2013-08-24','15:10:00',5.48),('11288','2013-08-24','15:15:00',5.41),('11288','2013-08-24','15:20:00',5.36),('11288','2013-08-24','15:25:00',5.29),('11288','2013-08-24','15:30:00',5.24),('11288','2013-08-24','15:35:00',5.21),('11288','2013-08-24','15:40:00',5.07),('11288','2013-08-24','15:45:00',4.98),('11288','2013-08-24','15:50:00',4.9),('11288','2013-08-24','15:55:00',4.8),('11288','2013-08-24','16:00:00',4.69),('11288','2013-08-24','16:05:00',4.59),('11288','2013-08-24','16:10:00',4.5),('11288','2013-08-24','16:15:00',4.42),('11288','2013-08-24','16:20:00',4.32),('11288','2013-08-24','16:25:00',4.23),('11288','2013-08-24','16:30:00',4.12),('11288','2013-08-24','16:35:00',3.97),('11288','2013-08-24','16:40:00',3.82),('11288','2013-08-24','16:45:00',3.72),('11288','2013-08-24','16:50:00',3.62),('11288','2013-08-24','16:55:00',3.49),('11288','2013-08-24','17:00:00',3.37),('11288','2013-08-24','17:05:00',3.25),('11288','2013-08-24','17:10:00',3.11),('11288','2013-08-24','17:15:00',3),('11288','2013-08-24','17:20:00',2.87),('11288','2013-08-24','17:25:00',2.74),('11288','2013-08-24','17:30:00',2.62),('11288','2013-08-24','17:35:00',2.46),('11288','2013-08-24','17:40:00',2.32),('11288','2013-08-24','17:45:00',2.18),('11288','2013-08-24','17:50:00',2.02),('11288','2013-08-24','17:55:00',1.85),('11288','2013-08-24','18:00:00',1.78),('11288','2013-08-24','18:05:00',1.66),('11288','2013-08-24','18:10:00',1.53),('11288','2013-08-24','18:15:00',1.41),('11288','2013-08-24','18:20:00',1.26),('11288','2013-08-24','18:25:00',1.16),('11288','2013-08-24','18:30:00',1.06),('11288','2013-08-23','07:55:00',1.03),('11288','2013-08-23','08:00:00',1.13),('11288','2013-08-23','08:05:00',1.22),('11288','2013-08-23','08:10:00',1.31),('11288','2013-08-23','08:15:00',1.41),('11288','2013-08-23','08:20:00',1.51),('11288','2013-08-23','08:25:00',1.65),('11288','2013-08-23','08:30:00',1.77),('11288','2013-08-23','08:35:00',1.74),('11288','2013-08-23','08:40:00',1.96),('11288','2013-08-23','08:45:00',1.98),('11288','2013-08-23','08:50:00',2.22),('11288','2013-08-23','08:55:00',2.44),('11288','2013-08-23','09:00:00',2.54),('11288','2013-08-23','09:05:00',2.63),('11288','2013-08-23','09:10:00',2.83),('11288','2013-08-23','09:15:00',2.9),('11288','2013-08-23','09:20:00',3.02),('11288','2013-08-23','09:25:00',3.15),('11288','2013-08-23','09:30:00',3.2),('11288','2013-08-23','09:35:00',3.24),('11288','2013-08-23','09:40:00',3.38),('11288','2013-08-23','09:45:00',3.56),('11288','2013-08-23','09:50:00',3.6),('11288','2013-08-23','09:55:00',3.72),('11288','2013-08-23','10:00:00',3.83),('11288','2013-08-23','10:05:00',3.94),('11288','2013-08-23','10:10:00',4.01),('11288','2013-08-23','10:15:00',4.15),('11288','2013-08-23','10:20:00',4.28),('11288','2013-08-23','10:25:00',4.44),('11288','2013-08-23','10:30:00',4.54),('11288','2013-08-23','10:35:00',4.57),('11288','2013-08-23','10:40:00',4.58),('11288','2013-08-23','10:45:00',4.74),('11288','2013-08-23','10:50:00',4.81),('11288','2013-08-23','10:55:00',4.74),('11288','2013-08-23','11:00:00',4.46),('11288','2013-08-23','11:05:00',4.05),('11288','2013-08-23','11:10:00',1.99),('11288','2013-08-23','11:15:00',2.71),('11288','2013-08-23','11:20:00',4.8),('11288','2013-08-23','11:25:00',5.25),('11288','2013-08-23','11:30:00',5.59),('11288','2013-08-23','11:35:00',5.71),('11288','2013-08-23','11:40:00',4.4),('11288','2013-08-23','11:45:00',5.93),('11288','2013-08-23','11:50:00',5.7),('11288','2013-08-23','11:55:00',2.41),('11288','2013-08-23','12:00:00',2.78),('11288','2013-08-23','12:05:00',6.23),('11288','2013-08-23','12:10:00',4.15),('11288','2013-08-23','12:15:00',1.61),('11288','2013-08-23','12:20:00',1.64),('11288','2013-08-23','12:25:00',1.74),('11288','2013-08-23','12:30:00',3.49),('11288','2013-08-23','12:35:00',4.26),('11288','2013-08-23','12:40:00',1.97),('11288','2013-08-23','12:45:00',2.7),('11288','2013-08-23','12:50:00',2.24),('11288','2013-08-23','12:55:00',1.74),('11288','2013-08-23','13:00:00',3.75),('11288','2013-08-23','13:05:00',5.2),('11288','2013-08-23','13:10:00',3.46),('11288','2013-08-23','13:15:00',4.26),('11288','2013-08-23','13:20:00',6.6),('11288','2013-08-23','13:25:00',5.78),('11288','2013-08-23','13:30:00',6.72),('11288','2013-08-23','13:35:00',5),('11288','2013-08-23','13:40:00',6.22),('11288','2013-08-23','13:45:00',5.79),('11288','2013-08-23','13:50:00',3.85),('11288','2013-08-23','13:55:00',6.63),('11288','2013-08-23','14:00:00',6.64),('11288','2013-08-23','14:05:00',6.36),('11288','2013-08-23','14:10:00',6.22),('11288','2013-08-23','14:15:00',6.18),('11288','2013-08-23','14:20:00',5.28),('11288','2013-08-23','14:25:00',5.76),('11288','2013-08-23','14:30:00',4.46),('11288','2013-08-23','14:35:00',5.92),('11288','2013-08-23','14:40:00',5.84),('11288','2013-08-23','14:45:00',5.69),('11288','2013-08-23','14:50:00',5.43),('11288','2013-08-23','14:55:00',5.62),('11288','2013-08-23','15:00:00',5.48),('11288','2013-08-23','15:05:00',5.08),('11288','2013-08-23','15:10:00',5.37),('11288','2013-08-23','15:15:00',5.22),('11288','2013-08-23','15:20:00',5.24),('11288','2013-08-23','15:25:00',5.28),('11288','2013-08-23','15:30:00',5.44),('11288','2013-08-23','15:35:00',5.03),('11288','2013-08-23','15:40:00',5.01),('11288','2013-08-23','15:45:00',4.98),('11288','2013-08-23','15:50:00',4.51),('11288','2013-08-23','15:55:00',4.85),('11288','2013-08-23','16:00:00',4.6),('11288','2013-08-23','16:05:00',4.35),('11288','2013-08-23','16:10:00',3.9),('11288','2013-08-23','16:15:00',4.35),('11288','2013-08-23','16:20:00',4.55),('11288','2013-08-23','16:25:00',4.41),('11288','2013-08-23','16:30:00',4.28),('11288','2013-08-23','16:35:00',4.21),('11288','2013-08-23','16:40:00',4.04),('11288','2013-08-23','16:45:00',3.95),('11288','2013-08-23','16:50:00',3.78),('11288','2013-08-23','16:55:00',3.6),('11288','2013-08-23','17:00:00',3.41),('11288','2013-08-23','17:05:00',3.28),('11288','2013-08-23','17:10:00',3.13),('11288','2013-08-23','17:15:00',2.97),('11288','2013-08-23','17:20:00',2.87),('11288','2013-08-23','17:25:00',2.67),('11288','2013-08-23','17:30:00',2.54),('11288','2013-08-23','17:35:00',2.42),('11288','2013-08-23','17:40:00',2.28),('11288','2013-08-23','17:45:00',2.12),('11288','2013-08-23','17:50:00',1.99),('11288','2013-08-23','17:55:00',1.84),('11288','2013-08-23','18:00:00',1.76),('11288','2013-08-23','18:05:00',1.63),('11288','2013-08-23','18:10:00',1.31),('11288','2013-08-23','18:15:00',1.24),('11288','2013-08-23','18:20:00',1.31),('11288','2013-08-23','18:25:00',1.24),('11288','2013-08-23','18:30:00',1.12),('11288','2013-08-23','18:35:00',1.01),('11288','2013-08-22','07:55:00',1.07),('11288','2013-08-22','08:00:00',1.17),('11288','2013-08-22','08:05:00',1.25),('11288','2013-08-22','08:10:00',1.37),('11288','2013-08-22','08:15:00',1.45),('11288','2013-08-22','08:20:00',1.53),('11288','2013-08-22','08:25:00',1.67),('11288','2013-08-22','08:30:00',1.78),('11288','2013-08-22','08:35:00',1.83),('11288','2013-08-22','08:40:00',2.03),('11288','2013-08-22','08:45:00',2.18),('11288','2013-08-22','08:50:00',2.3),('11288','2013-08-22','08:55:00',2.61),('11288','2013-08-22','09:00:00',2.72),('11288','2013-08-22','09:05:00',2.89),('11288','2013-08-22','09:10:00',3.27),('11288','2013-08-22','09:15:00',3.37),('11288','2013-08-22','09:20:00',3.62),('11288','2013-08-22','09:25:00',3.71),('11288','2013-08-22','09:30:00',3.97),('11288','2013-08-22','09:35:00',2.69),('11288','2013-08-22','09:40:00',3.24),('11288','2013-08-22','09:45:00',3.88),('11288','2013-08-22','09:50:00',3.96),('11288','2013-08-22','09:55:00',3.83),('11288','2013-08-22','10:00:00',4.38),('11288','2013-08-22','10:05:00',4.46),('11288','2013-08-22','10:10:00',4.54),('11288','2013-08-22','10:15:00',4.56),('11288','2013-08-22','10:20:00',4.58),('11288','2013-08-22','10:25:00',4.78),('11288','2013-08-22','10:30:00',4.87),('11288','2013-08-22','10:35:00',4.97),('11288','2013-08-22','10:40:00',5.04),('11288','2013-08-22','10:45:00',5.09),('11288','2013-08-22','10:50:00',5.17),('11288','2013-08-22','10:55:00',5.24),('11288','2013-08-22','11:00:00',5.33),('11288','2013-08-22','11:05:00',5.36),('11288','2013-08-22','11:10:00',5.41),('11288','2013-08-22','11:15:00',5.39),('11288','2013-08-22','11:20:00',5.46),('11288','2013-08-22','11:25:00',5.44),('11288','2013-08-22','11:30:00',5.55),('11288','2013-08-22','11:35:00',5.59),('11288','2013-08-22','11:40:00',5.66),('11288','2013-08-22','11:45:00',5.68),('11288','2013-08-22','11:50:00',5.69),('11288','2013-08-22','11:55:00',5.79),('11288','2013-08-22','12:00:00',5.81),('11288','2013-08-22','12:05:00',5.88),('11288','2013-08-22','12:10:00',5.89),('11288','2013-08-22','12:15:00',5.94),('11288','2013-08-22','12:20:00',5.98),('11288','2013-08-22','12:25:00',5.99),('11288','2013-08-22','12:30:00',5.97),('11288','2013-08-22','12:35:00',5.96),('11288','2013-08-22','12:40:00',5.99),('11288','2013-08-22','12:45:00',6.03),('11288','2013-08-22','12:50:00',6.04),('11288','2013-08-22','12:55:00',6.02),('11288','2013-08-22','13:00:00',5.99),('11288','2013-08-22','13:05:00',5.98),('11288','2013-08-22','13:10:00',5.88),('11288','2013-08-22','13:15:00',5.91),('11288','2013-08-22','13:20:00',5.89),('11288','2013-08-22','13:25:00',5.89),('11288','2013-08-22','13:30:00',5.94),('11288','2013-08-22','13:35:00',5.92),('11288','2013-08-22','13:40:00',5.83),('11288','2013-08-22','13:45:00',5.92),('11288','2013-08-22','13:50:00',5.96),('11288','2013-08-22','13:55:00',5.87),('11288','2013-08-22','14:00:00',5.86),('11288','2013-08-22','14:05:00',5.87),('11288','2013-08-22','14:10:00',5.83),('11288','2013-08-22','14:15:00',5.82),('11288','2013-08-22','14:20:00',5.87),('11288','2013-08-22','14:25:00',5.9),('11288','2013-08-22','14:30:00',5.85),('11288','2013-08-22','14:35:00',5.8),('11288','2013-08-22','14:40:00',5.85),('11288','2013-08-22','14:45:00',5.67),('11288','2013-08-22','14:50:00',5.63),('11288','2013-08-22','14:55:00',5.6),('11288','2013-08-22','15:00:00',5.5),('11288','2013-08-22','15:05:00',5.44),('11288','2013-08-22','15:10:00',5.42),('11288','2013-08-22','15:15:00',5.3),('11288','2013-08-22','15:20:00',5.28),('11288','2013-08-22','15:25:00',5.23),('11288','2013-08-22','15:30:00',5.08),('11288','2013-08-22','15:35:00',5),('11288','2013-08-22','15:40:00',5),('11288','2013-08-22','15:45:00',4.94),('11288','2013-08-22','15:50:00',4.87),('11288','2013-08-22','15:55:00',4.75),('11288','2013-08-22','16:00:00',4.61),('11288','2013-08-22','16:05:00',4.45),('11288','2013-08-22','16:10:00',4.39),('11288','2013-08-22','16:15:00',4.34),('11288','2013-08-22','16:20:00',4.21),('11288','2013-08-22','16:25:00',4.11),('11288','2013-08-22','16:30:00',4.03),('11288','2013-08-22','16:35:00',3.88),('11288','2013-08-22','16:40:00',3.73),('11288','2013-08-22','16:45:00',3.64),('11288','2013-08-22','16:50:00',3.49),('11288','2013-08-22','16:55:00',3.42),('11288','2013-08-22','17:00:00',3.29),('11288','2013-08-22','17:05:00',3.11),('11288','2013-08-22','17:10:00',3),('11288','2013-08-22','17:15:00',2.86),('11288','2013-08-22','17:20:00',2.74),('11288','2013-08-22','17:25:00',2.62),('11288','2013-08-22','17:30:00',2.5),('11288','2013-08-22','17:35:00',2.38),('11288','2013-08-22','17:40:00',2.23),('11288','2013-08-22','17:45:00',2.08),('11288','2013-08-22','17:50:00',1.91),('11288','2013-08-22','17:55:00',1.8),('11288','2013-08-22','18:00:00',1.74),('11288','2013-08-22','18:05:00',1.65),('11288','2013-08-22','18:10:00',1.6),('11288','2013-08-22','18:15:00',1.6),('11288','2013-08-22','18:20:00',1.41),('11288','2013-08-22','18:25:00',1.17),('11288','2013-08-22','18:30:00',1.12),('11288','2013-08-21','08:20:00',1.16),('11288','2013-08-21','08:25:00',1.31),('11288','2013-08-21','08:30:00',1.38),('11288','2013-08-21','08:35:00',1.5),('11288','2013-08-21','08:40:00',1.44),('11288','2013-08-21','08:45:00',1.35),('11288','2013-08-21','08:50:00',1.24),('11288','2013-08-21','08:55:00',1.31),('11288','2013-08-21','09:00:00',1.54),('11288','2013-08-21','09:05:00',2.51),('11288','2013-08-21','09:10:00',2.44),('11288','2013-08-21','09:15:00',3.66),('11288','2013-08-21','09:20:00',3.65),('11288','2013-08-21','09:25:00',1.98),('11288','2013-08-21','09:30:00',1.35),('11288','2013-08-21','09:35:00',1.53),('11288','2013-08-21','09:40:00',1.78),('11288','2013-08-21','09:45:00',2.33),('11288','2013-08-21','09:50:00',4.14),('11288','2013-08-21','09:55:00',5.56),('11288','2013-08-21','10:00:00',4.94),('11288','2013-08-21','10:05:00',4.1),('11288','2013-08-21','10:10:00',3.41),('11288','2013-08-21','10:15:00',3.2),('11288','2013-08-21','10:20:00',3.25),('11288','2013-08-21','10:25:00',2.7),('11288','2013-08-21','10:30:00',4.16),('11288','2013-08-21','10:35:00',4.73),('11288','2013-08-21','10:40:00',2.7),('11288','2013-08-21','10:45:00',4.07),('11288','2013-08-21','10:50:00',3.76),('11288','2013-08-21','10:55:00',3.04),('11288','2013-08-21','11:00:00',4.35),('11288','2013-08-21','11:05:00',3.25),('11288','2013-08-21','11:10:00',2.95),('11288','2013-08-21','11:15:00',3.52),('11288','2013-08-21','11:20:00',4.3),('11288','2013-08-21','11:25:00',4.51),('11288','2013-08-21','11:30:00',5.52),('11288','2013-08-21','11:35:00',6.84),('11288','2013-08-21','11:40:00',6.43),('11288','2013-08-21','11:45:00',6.33),('11288','2013-08-21','11:50:00',6.32),('11288','2013-08-21','11:55:00',6.23),('11288','2013-08-21','12:00:00',6.36),('11288','2013-08-21','12:05:00',6.39),('11288','2013-08-21','12:10:00',6.41),('11288','2013-08-21','12:15:00',6.46),('11288','2013-08-21','12:20:00',6.4),('11288','2013-08-21','12:25:00',4.58),('11288','2013-08-21','12:30:00',4.07),('11288','2013-08-21','12:35:00',3.43),('11288','2013-08-21','12:40:00',5.96),('11288','2013-08-21','12:45:00',6.35),('11288','2013-08-21','12:50:00',5.99),('11288','2013-08-21','12:55:00',6.02),('11288','2013-08-21','13:00:00',6.2),('11288','2013-08-21','13:05:00',6.19),('11288','2013-08-21','13:10:00',6.33),('11288','2013-08-21','13:15:00',6.41),('11288','2013-08-21','13:20:00',6.45),('11288','2013-08-21','13:25:00',6.41),('11288','2013-08-21','13:30:00',6.2),('11288','2013-08-21','13:35:00',6.16),('11288','2013-08-21','13:40:00',6.3),('11288','2013-08-21','13:45:00',6.28),('11288','2013-08-21','13:50:00',6.03),('11288','2013-08-21','13:55:00',5.99),('11288','2013-08-21','14:00:00',6.01),('11288','2013-08-21','14:05:00',5.58),('11288','2013-08-21','14:10:00',5.75),('11288','2013-08-21','14:15:00',3.41),('11288','2013-08-21','14:20:00',2.5),('11288','2013-08-21','14:25:00',2.96),('11288','2013-08-21','14:30:00',5.43),('11288','2013-08-21','14:35:00',5.72),('11288','2013-08-21','14:40:00',5.67),('11288','2013-08-21','14:45:00',5.5),('11288','2013-08-21','14:50:00',5.32),('11288','2013-08-21','14:55:00',5.39),('11288','2013-08-21','15:00:00',5.52),('11288','2013-08-21','15:05:00',5.44),('11288','2013-08-21','15:10:00',5.27),('11288','2013-08-21','15:15:00',5.22),('11288','2013-08-21','15:20:00',5.04),('11288','2013-08-21','15:25:00',4.76),('11288','2013-08-21','15:30:00',4.65),('11288','2013-08-21','15:35:00',4.52),('11288','2013-08-21','15:40:00',4.31),('11288','2013-08-21','15:45:00',4.46),('11288','2013-08-21','15:50:00',4.39),('11288','2013-08-21','15:55:00',4.46),('11288','2013-08-21','16:00:00',4.07),('11288','2013-08-21','16:05:00',3.81),('11288','2013-08-21','16:10:00',3.74),('11288','2013-08-21','16:15:00',3.82),('11288','2013-08-21','16:20:00',3.97),('11288','2013-08-21','16:25:00',4.03),('11288','2013-08-21','16:30:00',4.24),('11288','2013-08-21','16:35:00',4.22),('11288','2013-08-21','16:40:00',4),('11288','2013-08-21','16:45:00',3.85),('11288','2013-08-21','16:50:00',3.75),('11288','2013-08-21','16:55:00',3.61),('11288','2013-08-21','17:00:00',3.55),('11288','2013-08-21','17:05:00',3.48),('11288','2013-08-21','17:10:00',3.35),('11288','2013-08-21','17:15:00',3.22),('11288','2013-08-21','17:20:00',3.19),('11288','2013-08-21','17:25:00',3.05),('11288','2013-08-21','17:30:00',2.9),('11288','2013-08-21','17:35:00',2.83),('11288','2013-08-21','17:40:00',2.7),('11288','2013-08-21','17:45:00',2.58),('11288','2013-08-21','17:50:00',2.47),('11288','2013-08-21','17:55:00',2.33),('11288','2013-08-21','18:00:00',2.24),('11288','2013-08-21','18:05:00',2.11),('11288','2013-08-21','18:10:00',1.93),('11288','2013-08-21','18:15:00',1.77),('11288','2013-08-21','18:20:00',1.6),('11288','2013-08-21','18:25:00',1.49),('11288','2013-08-21','18:30:00',1.29),('11288','2013-08-21','18:35:00',1.09),('11288','2013-08-20','07:35:00',1.02),('11288','2013-08-20','07:40:00',1.14),('11288','2013-08-20','07:45:00',1.11),('11288','2013-08-20','07:50:00',1.39),('11288','2013-08-20','07:55:00',1.55),('11288','2013-08-20','08:00:00',1.39),('11288','2013-08-20','08:05:00',1.21),('11288','2013-08-20','08:10:00',1.14),('11288','2013-08-20','08:15:00',1.16),('11288','2013-08-20','08:20:00',1.25),('11288','2013-08-20','08:25:00',1.24),('11288','2013-08-20','08:30:00',1.21),('11288','2013-08-20','08:35:00',1.2),('11288','2013-08-20','08:40:00',1.29),('11288','2013-08-20','08:45:00',1.44),('11288','2013-08-20','08:50:00',1.61),('11288','2013-08-20','08:55:00',1.76),('11288','2013-08-20','09:00:00',1.74),('11288','2013-08-20','09:05:00',1.53),('11288','2013-08-20','09:10:00',1.26),('11288','2013-08-20','09:15:00',1.49),('11288','2013-08-20','09:20:00',1.99),('11288','2013-08-20','09:25:00',2.93),('11288','2013-08-20','09:30:00',3.8),('11288','2013-08-20','09:35:00',4.3),('11288','2013-08-20','09:40:00',5.32),('11288','2013-08-20','09:45:00',3.57),('11288','2013-08-20','09:50:00',3.4),('11288','2013-08-20','09:55:00',4.67),('11288','2013-08-20','10:00:00',3.03),('11288','2013-08-20','10:05:00',1.89),('11288','2013-08-20','10:10:00',2.09),('11288','2013-08-20','10:15:00',3.52),('11288','2013-08-20','10:20:00',2.22),('11288','2013-08-20','10:25:00',1.76),('11288','2013-08-20','10:30:00',1.78),('11288','2013-08-20','10:35:00',1.91),('11288','2013-08-20','10:40:00',2.8),('11288','2013-08-20','10:45:00',4.4),('11288','2013-08-20','10:50:00',4.87),('11288','2013-08-20','10:55:00',2.53),('11288','2013-08-20','11:00:00',1.81),('11288','2013-08-20','11:05:00',2.92),('11288','2013-08-20','11:10:00',5.89),('11288','2013-08-20','11:15:00',6.29),('11288','2013-08-20','11:20:00',6.24),('11288','2013-08-20','11:25:00',3.78),('11288','2013-08-20','11:30:00',5.44),('11288','2013-08-20','11:35:00',6.36),('11288','2013-08-20','11:40:00',6.54),('11288','2013-08-20','11:45:00',6.71),('11288','2013-08-20','11:50:00',7.24),('11288','2013-08-20','11:55:00',6.58),('11288','2013-08-20','12:00:00',4.66),('11288','2013-08-20','12:05:00',3.06),('11288','2013-08-20','12:10:00',2.52),('11288','2013-08-20','12:15:00',1.35),('11288','2013-08-20','12:20:00',1.52),('11288','2013-08-20','12:25:00',2.15),('11288','2013-08-20','12:30:00',2.7),('11288','2013-08-20','12:35:00',2.91),('11288','2013-08-20','12:40:00',3.04),('11288','2013-08-20','12:45:00',2.96),('11288','2013-08-20','12:50:00',2.96),('11288','2013-08-20','12:55:00',3.12),('11288','2013-08-20','13:00:00',3.06),('11288','2013-08-20','13:05:00',2.84),('11288','2013-08-20','13:10:00',2.82),('11288','2013-08-20','13:15:00',2.87),('11288','2013-08-20','13:20:00',2.97),('11288','2013-08-20','13:25:00',3.09),('11288','2013-08-20','13:30:00',3.38),('11288','2013-08-20','13:35:00',4.48),('11288','2013-08-20','13:40:00',7.13),('11288','2013-08-20','13:45:00',5.82),('11288','2013-08-20','13:50:00',6.84),('11288','2013-08-20','13:55:00',6.56),('11288','2013-08-20','14:00:00',6.46),('11288','2013-08-20','14:05:00',6.21),('11288','2013-08-20','14:10:00',5.36),('11288','2013-08-20','14:15:00',6.1),('11288','2013-08-20','14:20:00',6.31),('11288','2013-08-20','14:25:00',5.72),('11288','2013-08-20','14:30:00',5.52),('11288','2013-08-20','14:35:00',6.68),('11288','2013-08-20','14:40:00',6.51),('11288','2013-08-20','14:45:00',5.86),('11288','2013-08-20','14:50:00',6.27),('11288','2013-08-20','14:55:00',5.96),('11288','2013-08-20','15:00:00',6.06),('11288','2013-08-20','15:05:00',6.21),('11288','2013-08-20','15:10:00',6.08),('11288','2013-08-20','15:15:00',6.06),('11288','2013-08-20','15:20:00',5.88),('11288','2013-08-20','15:25:00',5.84),('11288','2013-08-20','15:30:00',5.86),('11288','2013-08-20','15:35:00',5.8),('11288','2013-08-20','15:40:00',5.92),('11288','2013-08-20','15:45:00',6.06),('11288','2013-08-20','15:50:00',6.32),('11288','2013-08-20','15:55:00',6.42),('11288','2013-08-20','16:00:00',6.03),('11288','2013-08-20','16:05:00',5.9),('11288','2013-08-20','16:10:00',5.82),('11288','2013-08-20','16:15:00',5.78),('11288','2013-08-20','16:20:00',5.66),('11288','2013-08-20','16:25:00',5.48),('11288','2013-08-20','16:30:00',5.17),('11288','2013-08-20','16:35:00',5.07),('11288','2013-08-20','16:40:00',5.04),('11288','2013-08-20','16:45:00',4.84),('11288','2013-08-20','16:50:00',4.57),('11288','2013-08-20','16:55:00',4.26),('11288','2013-08-20','17:00:00',3.92),('11288','2013-08-20','17:05:00',3.68),('11288','2013-08-20','17:10:00',3.54),('11288','2013-08-20','17:15:00',3.32),('11288','2013-08-20','17:20:00',3.12),('11288','2013-08-20','17:25:00',3.03),('11288','2013-08-20','17:30:00',2.96),('11288','2013-08-20','17:35:00',2.86),('11288','2013-08-20','17:40:00',2.75),('11288','2013-08-20','17:45:00',2.57),('11288','2013-08-20','17:50:00',2.27),('11288','2013-08-20','17:55:00',2.1),('11288','2013-08-20','18:00:00',1.87),('11288','2013-08-20','18:05:00',1.83),('11288','2013-08-20','18:10:00',1.88),('11288','2013-08-20','18:15:00',1.83),('11288','2013-08-20','18:20:00',1.74),('11288','2013-08-20','18:25:00',1.74),('11288','2013-08-20','18:30:00',1.73),('11288','2013-08-20','18:35:00',1.63),('11288','2013-08-20','18:40:00',1.61),('11288','2013-08-20','18:45:00',1.55),('11288','2013-08-20','18:50:00',1.21),('11288','2013-08-20','18:55:00',1.29),('11288','2013-08-20','19:00:00',1.22),('11288','2013-08-20','19:05:00',1.01),('11288','2014-04-10','08:05:00',1.11),('11288','2014-04-10','08:10:00',1.24),('11288','2014-04-10','08:15:00',1.35),('11288','2014-04-10','08:20:00',1.55),('11288','2014-04-10','08:25:00',1.66),('11288','2014-04-10','08:30:00',1.92),('11288','2014-04-10','08:35:00',2.1),('11288','2014-04-10','08:40:00',2.29),('11288','2014-04-10','08:45:00',2.42),('11288','2014-04-10','08:50:00',2.61),('11288','2014-04-10','08:55:00',2.66),('11288','2014-04-10','09:00:00',2.87),('11288','2014-04-10','09:05:00',3.03),('11288','2014-04-10','09:10:00',3.01),('11288','2014-04-10','09:15:00',3.22),('11288','2014-04-10','09:20:00',3.38),('11288','2014-04-10','09:25:00',3.54),('11288','2014-04-10','09:30:00',3.58),('11288','2014-04-10','09:35:00',3.88),('11288','2014-04-10','09:40:00',3.96),('11288','2014-04-10','09:45:00',3.95),('11288','2014-04-10','09:50:00',4.23),('11288','2014-04-10','09:55:00',4.26),('11288','2014-04-10','10:00:00',4.29),('11288','2014-04-10','10:05:00',4.74),('11288','2014-04-10','10:10:00',4.97),('11288','2014-04-10','10:15:00',4.97),('11288','2014-04-10','10:20:00',5.12),('11288','2014-04-10','10:25:00',5.22),('11288','2014-04-10','10:30:00',5.3),('11288','2014-04-10','10:35:00',5.51),('11288','2014-04-10','10:40:00',5.62),('11288','2014-04-10','10:45:00',5.63),('11288','2014-04-10','10:50:00',5.62),('11288','2014-04-10','10:55:00',5.82),('11288','2014-04-10','11:00:00',5.84),('11288','2014-04-10','11:05:00',6.01),('11288','2014-04-10','11:10:00',5.9),('11288','2014-04-10','11:15:00',6.12),('11288','2014-04-10','11:20:00',6.29),('11288','2014-04-10','11:25:00',6.38),('11288','2014-04-10','11:30:00',6.4),('11288','2014-04-10','11:35:00',6.49),('11288','2014-04-10','11:40:00',6.26),('11288','2014-04-10','11:45:00',6.47),('11288','2014-04-10','11:50:00',6.26),('11288','2014-04-10','11:55:00',6.59),('11288','2014-04-10','12:00:00',6.5),('11288','2014-04-10','12:05:00',6.22),('11288','2014-04-10','12:10:00',6.48),('11288','2014-04-10','12:15:00',6.56),('11288','2014-04-10','12:20:00',6.65),('11288','2014-04-10','12:25:00',6.29),('11288','2014-04-10','12:30:00',6.45),('11288','2014-04-10','12:35:00',6.87),('11288','2014-04-10','12:40:00',6.48),('11288','2014-04-10','12:45:00',6.65),('11288','2014-04-10','12:50:00',6.68),('11288','2014-04-10','12:55:00',6.62),('11288','2014-04-10','13:00:00',6.48),('11288','2014-04-10','13:05:00',6.29),('11288','2014-04-10','13:10:00',6.53),('11288','2014-04-10','13:15:00',6.45),('11288','2014-04-10','13:20:00',6.25),('11288','2014-04-10','13:25:00',6.79),('11288','2014-04-10','13:30:00',6.68),('11288','2014-04-10','13:35:00',6.8),('11288','2014-04-10','13:40:00',6.44),('11288','2014-04-10','13:45:00',6.77),('11288','2014-04-10','13:50:00',6.75),('11288','2014-04-10','13:55:00',6.74),('11288','2014-04-10','14:00:00',6.69),('11288','2014-04-10','14:05:00',6.56),('11288','2014-04-10','14:10:00',6.52),('11288','2014-04-10','14:15:00',6.55),('11288','2014-04-10','14:20:00',6.61),('11288','2014-04-10','14:25:00',6.53),('11288','2014-04-10','14:30:00',6.42),('11288','2014-04-10','14:35:00',6.4),('11288','2014-04-10','14:40:00',6.33),('11288','2014-04-10','14:45:00',5.69),('11288','2014-04-10','14:50:00',6.33),('11288','2014-04-10','14:55:00',6.22),('11288','2014-04-10','15:00:00',6.18),('11288','2014-04-10','15:05:00',6.04),('11288','2014-04-10','15:10:00',5.92),('11288','2014-04-10','15:15:00',5.89),('11288','2014-04-10','15:20:00',5.86),('11288','2014-04-10','15:25:00',5.73),('11288','2014-04-10','15:30:00',5.28),('11288','2014-04-10','15:35:00',5.08),('11288','2014-04-10','15:40:00',5.1),('11288','2014-04-10','15:45:00',5.2),('11288','2014-04-10','15:50:00',5.19),('11288','2014-04-10','15:55:00',5.09),('11288','2014-04-10','16:00:00',5.01),('11288','2014-04-10','16:05:00',5.07),('11288','2014-04-10','16:10:00',5.06),('11288','2014-04-10','16:15:00',5.11),('11288','2014-04-10','16:20:00',4.86),('11288','2014-04-10','16:25:00',4.82),('11288','2014-04-10','16:30:00',4.75),('11288','2014-04-10','16:35:00',4.48),('11288','2014-04-10','16:40:00',4.42),('11288','2014-04-10','16:45:00',4.42),('11288','2014-04-10','16:50:00',4.05),('11288','2014-04-10','16:55:00',3.97),('11288','2014-04-10','17:00:00',3.79),('11288','2014-04-10','17:05:00',3.63),('11288','2014-04-10','17:10:00',3.47),('11288','2014-04-10','17:15:00',3.25),('11288','2014-04-10','17:20:00',3.14),('11288','2014-04-10','17:25:00',2.97),('11288','2014-04-10','17:30:00',2.79),('11288','2014-04-10','17:35:00',2.61),('11288','2014-04-10','17:40:00',2.46),('11288','2014-04-10','17:45:00',2.3),('11288','2014-04-10','17:50:00',2.14),('11288','2014-04-10','17:55:00',1.99),('11288','2014-04-10','18:00:00',1.83),('11288','2014-04-10','18:05:00',1.65),('11288','2014-04-10','18:10:00',1.54),('11288','2014-04-10','18:15:00',1.41),('11288','2014-04-10','18:20:00',1.27),('11288','2014-04-10','18:25:00',1.12),('11288','2013-08-19','07:50:00',1.05),('11288','2013-08-19','07:55:00',1.12),('11288','2013-08-19','08:00:00',1.22),('11288','2013-08-19','08:05:00',1.32),('11288','2013-08-19','08:10:00',1.43),('11288','2013-08-19','08:15:00',1.56),('11288','2013-08-19','08:20:00',1.68),('11288','2013-08-19','08:25:00',1.8),('11288','2013-08-19','08:30:00',1.85),('11288','2013-08-19','08:35:00',2.05),('11288','2013-08-19','08:40:00',2.03),('11288','2013-08-19','08:45:00',1.95),('11288','2013-08-19','08:50:00',2.43),('11288','2013-08-19','08:55:00',2.61),('11288','2013-08-19','09:00:00',2.65),('11288','2013-08-19','09:05:00',2.85),('11288','2013-08-19','09:10:00',2.95),('11288','2013-08-19','09:15:00',2.98),('11288','2013-08-19','09:20:00',3.33),('11288','2013-08-19','09:25:00',3.5),('11288','2013-08-19','09:30:00',3.58),('11288','2013-08-19','09:35:00',3.73),('11288','2013-08-19','09:40:00',3.75),('11288','2013-08-19','09:45:00',3.82),('11288','2013-08-19','09:50:00',4),('11288','2013-08-19','09:55:00',4.05),('11288','2013-08-19','10:00:00',4.08),('11288','2013-08-19','10:05:00',4.31),('11288','2013-08-19','10:10:00',4.47),('11288','2013-08-19','10:15:00',4.58),('11288','2013-08-19','10:20:00',4.66),('11288','2013-08-19','10:25:00',4.78),('11288','2013-08-19','10:30:00',4.9),('11288','2013-08-19','10:35:00',5.02),('11288','2013-08-19','10:40:00',5.04),('11288','2013-08-19','10:45:00',5.18),('11288','2013-08-19','10:50:00',5.27),('11288','2013-08-19','10:55:00',5.3),('11288','2013-08-19','11:00:00',5.38),('11288','2013-08-19','11:05:00',5.4),('11288','2013-08-19','11:10:00',5.54),('11288','2013-08-19','11:15:00',5.6),('11288','2013-08-19','11:20:00',5.63),('11288','2013-08-19','11:25:00',5.66),('11288','2013-08-19','11:30:00',5.69),('11288','2013-08-19','11:35:00',5.73),('11288','2013-08-19','11:40:00',5.71),('11288','2013-08-19','11:45:00',5.7),('11288','2013-08-19','11:50:00',5.73),('11288','2013-08-19','11:55:00',5.83),('11288','2013-08-19','12:00:00',5.93),('11288','2013-08-19','12:05:00',5.94),('11288','2013-08-19','12:10:00',6.01),('11288','2013-08-19','12:15:00',6.05),('11288','2013-08-19','12:20:00',6.07),('11288','2013-08-19','12:25:00',6.14),('11288','2013-08-19','12:30:00',6.13),('11288','2013-08-19','12:35:00',6.16),('11288','2013-08-19','12:40:00',6.2),('11288','2013-08-19','12:45:00',6.24),('11288','2013-08-19','12:50:00',6.21),('11288','2013-08-19','12:55:00',6.26),('11288','2013-08-19','13:00:00',6.28),('11288','2013-08-19','13:05:00',6.32),('11288','2013-08-19','13:10:00',6.31),('11288','2013-08-19','13:15:00',6.3),('11288','2013-08-19','13:20:00',6.31),('11288','2013-08-19','13:25:00',6.3),('11288','2013-08-19','13:30:00',6.28),('11288','2013-08-19','13:35:00',6.25),('11288','2013-08-19','13:40:00',6.27),('11288','2013-08-19','13:45:00',6.25),('11288','2013-08-19','13:50:00',6.27),('11288','2013-08-19','13:55:00',6.25),('11288','2013-08-19','14:00:00',6.18),('11288','2013-08-19','14:05:00',6.17),('11288','2013-08-19','14:10:00',6.15),('11288','2013-08-19','14:15:00',6.15),('11288','2013-08-19','14:20:00',6.07),('11288','2013-08-19','14:25:00',6.06),('11288','2013-08-19','14:30:00',6.06),('11288','2013-08-19','14:35:00',6.01),('11288','2013-08-19','14:40:00',6.02),('11288','2013-08-19','14:45:00',5.98),('11288','2013-08-19','14:50:00',5.94),('11288','2013-08-19','14:55:00',5.9),('11288','2013-08-19','15:00:00',5.85),('11288','2013-08-19','15:05:00',5.76),('11288','2013-08-19','15:10:00',5.75),('11288','2013-08-19','15:15:00',5.69),('11288','2013-08-19','15:20:00',5.66),('11288','2013-08-19','15:25:00',5.53),('11288','2013-08-19','15:30:00',5.49),('11288','2013-08-19','15:35:00',5.43),('11288','2013-08-19','15:40:00',5.35),('11288','2013-08-19','15:45:00',5.26),('11288','2013-08-19','15:50:00',5.17),('11288','2013-08-19','15:55:00',5.11),('11288','2013-08-19','16:00:00',4.97),('11288','2013-08-19','16:05:00',4.86),('11288','2013-08-19','16:10:00',4.8),('11288','2013-08-19','16:15:00',4.72),('11288','2013-08-19','16:20:00',4.58),('11288','2013-08-19','16:25:00',4.45),('11288','2013-08-19','16:30:00',4.36),('11288','2013-08-19','16:35:00',4.27),('11288','2013-08-19','16:40:00',4.15),('11288','2013-08-19','16:45:00',4.01),('11288','2013-08-19','16:50:00',3.89),('11288','2013-08-19','16:55:00',3.78),('11288','2013-08-19','17:00:00',3.64),('11288','2013-08-19','17:05:00',3.5),('11288','2013-08-19','17:10:00',3.37),('11288','2013-08-19','17:15:00',3.24),('11288','2013-08-19','17:20:00',3.12),('11288','2013-08-19','17:25:00',2.99),('11288','2013-08-19','17:30:00',2.85),('11288','2013-08-19','17:35:00',2.73),('11288','2013-08-19','17:40:00',2.56),('11288','2013-08-19','17:45:00',2.38),('11288','2013-08-19','17:50:00',2.22),('11288','2013-08-19','17:55:00',2.18),('11288','2013-08-19','18:00:00',2.04),('11288','2013-08-19','18:05:00',1.91),('11288','2013-08-19','18:10:00',1.73),('11288','2013-08-19','18:15:00',1.61),('11288','2013-08-19','18:20:00',1.51),('11288','2013-08-19','18:25:00',1.4),('11288','2013-08-19','18:30:00',1.28),('11288','2013-08-19','18:35:00',1.22),('11288','2013-08-19','18:40:00',1.13),('11288','2013-08-18','07:50:00',1.07),('11288','2013-08-18','07:55:00',1.15),('11288','2013-08-18','08:00:00',1.24),('11288','2013-08-18','08:05:00',1.36),('11288','2013-08-18','08:10:00',1.48),('11288','2013-08-18','08:15:00',1.61),('11288','2013-08-18','08:20:00',1.78),('11288','2013-08-18','08:25:00',1.82),('11288','2013-08-18','08:30:00',1.89),('11288','2013-08-18','08:35:00',2.08),('11288','2013-08-18','08:40:00',1.97),('11288','2013-08-18','08:45:00',2.15),('11288','2013-08-18','08:50:00',2.5),('11288','2013-08-18','08:55:00',2.62),('11288','2013-08-18','09:00:00',2.79),('11288','2013-08-18','09:05:00',2.93),('11288','2013-08-18','09:10:00',3.2),('11288','2013-08-18','09:15:00',3.27),('11288','2013-08-18','09:20:00',3.46),('11288','2013-08-18','09:25:00',3.62),('11288','2013-08-18','09:30:00',3.73),('11288','2013-08-18','09:35:00',3.82),('11288','2013-08-18','09:40:00',3.74),('11288','2013-08-18','09:45:00',3.85),('11288','2013-08-18','09:50:00',3.66),('11288','2013-08-18','09:55:00',3.38),('11288','2013-08-18','10:00:00',3.98),('11288','2013-08-18','10:05:00',3.67),('11288','2013-08-18','10:10:00',4.48),('11288','2013-08-18','10:15:00',4.63),('11288','2013-08-18','10:20:00',4.78),('11288','2013-08-18','10:25:00',4.88),('11288','2013-08-18','10:30:00',4.95),('11288','2013-08-18','10:35:00',5.05),('11288','2013-08-18','10:40:00',5.09),('11288','2013-08-18','10:45:00',5.15),('11288','2013-08-18','10:50:00',5.22),('11288','2013-08-18','10:55:00',5.17),('11288','2013-08-18','11:00:00',5.35),('11288','2013-08-18','11:05:00',5.41),('11288','2013-08-18','11:10:00',5.45),('11288','2013-08-18','11:15:00',5.52),('11288','2013-08-18','11:20:00',5.57),('11288','2013-08-18','11:25:00',5.62),('11288','2013-08-18','11:30:00',5.67),('11288','2013-08-18','11:35:00',5.73),('11288','2013-08-18','11:40:00',5.77),('11288','2013-08-18','11:45:00',5.81),('11288','2013-08-18','11:50:00',5.91),('11288','2013-08-18','11:55:00',5.87),('11288','2013-08-18','12:00:00',6.02),('11288','2013-08-18','12:05:00',6.16),('11288','2013-08-18','12:10:00',6.25),('11288','2013-08-18','12:15:00',6.28),('11288','2013-08-18','12:20:00',6.29),('11288','2013-08-18','12:25:00',6),('11288','2013-08-18','12:30:00',3.51),('11288','2013-08-18','12:35:00',2.46),('11288','2013-08-18','12:40:00',1.42),('11288','2013-08-18','12:45:00',1.77),('11288','2013-08-18','12:50:00',1.81),('11288','2013-08-18','12:55:00',4.03),('11288','2013-08-18','13:00:00',6.15),('11288','2013-08-18','13:05:00',6.21),('11288','2013-08-18','13:10:00',6.61),('11288','2013-08-18','13:15:00',6.58),('11288','2013-08-18','13:20:00',6.38),('11288','2013-08-18','13:25:00',6.27),('11288','2013-08-18','13:30:00',6.3),('11288','2013-08-18','13:35:00',6.26),('11288','2013-08-18','13:40:00',6.25),('11288','2013-08-18','13:45:00',6.24),('11288','2013-08-18','13:50:00',6.15),('11288','2013-08-18','13:55:00',6.17),('11288','2013-08-18','14:00:00',6.26),('11288','2013-08-18','14:05:00',6.2),('11288','2013-08-18','14:10:00',6.17),('11288','2013-08-18','14:15:00',6.17),('11288','2013-08-18','14:20:00',6.13),('11288','2013-08-18','14:25:00',6.1),('11288','2013-08-18','14:30:00',6.11),('11288','2013-08-18','14:35:00',6.07),('11288','2013-08-18','14:40:00',6.02),('11288','2013-08-18','14:45:00',5.97),('11288','2013-08-18','14:50:00',5.87),('11288','2013-08-18','14:55:00',5.83),('11288','2013-08-18','15:00:00',5.83),('11288','2013-08-18','15:05:00',5.82),('11288','2013-08-18','15:10:00',5.76),('11288','2013-08-18','15:15:00',5.67),('11288','2013-08-18','15:20:00',5.61),('11288','2013-08-18','15:25:00',5.56),('11288','2013-08-18','15:30:00',5.48),('11288','2013-08-18','15:35:00',5.39),('11288','2013-08-18','15:40:00',5.33),('11288','2013-08-18','15:45:00',5.26),('11288','2013-08-18','15:50:00',5.17),('11288','2013-08-18','15:55:00',5.07),('11288','2013-08-18','16:00:00',4.94),('11288','2013-08-18','16:05:00',4.85),('11288','2013-08-18','16:10:00',4.77),('11288','2013-08-18','16:15:00',4.67),('11288','2013-08-18','16:20:00',4.56),('11288','2013-08-18','16:25:00',4.46),('11288','2013-08-18','16:30:00',4.36),('11288','2013-08-18','16:35:00',4.24),('11288','2013-08-18','16:40:00',4.15),('11288','2013-08-18','16:45:00',4.01),('11288','2013-08-18','16:50:00',3.91),('11288','2013-08-18','16:55:00',3.79),('11288','2013-08-18','17:00:00',3.67),('11288','2013-08-18','17:05:00',3.52),('11288','2013-08-18','17:10:00',3.43),('11288','2013-08-18','17:15:00',3.3),('11288','2013-08-18','17:20:00',3.16),('11288','2013-08-18','17:25:00',3.06),('11288','2013-08-18','17:30:00',2.9),('11288','2013-08-18','17:35:00',2.75),('11288','2013-08-18','17:40:00',2.56),('11288','2013-08-18','17:45:00',2.38),('11288','2013-08-18','17:50:00',2.27),('11288','2013-08-18','17:55:00',2.19),('11288','2013-08-18','18:00:00',2.05),('11288','2013-08-18','18:05:00',1.92),('11288','2013-08-18','18:10:00',1.75),('11288','2013-08-18','18:15:00',1.65),('11288','2013-08-18','18:20:00',1.55),('11288','2013-08-18','18:25:00',1.43),('11288','2013-08-18','18:30:00',1.33),('11288','2013-08-18','18:35:00',1.29),('11288','2013-08-18','18:40:00',1.16),('11288','2013-08-18','18:45:00',1),('11288','2013-08-17','07:50:00',1.01),('11288','2013-08-17','07:55:00',1.11),('11288','2013-08-17','08:00:00',1.22),('11288','2013-08-17','08:05:00',1.29),('11288','2013-08-17','08:10:00',1.39),('11288','2013-08-17','08:15:00',1.51),('11288','2013-08-17','08:20:00',1.58),('11288','2013-08-17','08:25:00',1.74),('11288','2013-08-17','08:30:00',1.9),('11288','2013-08-17','08:35:00',2.05),('11288','2013-08-17','08:40:00',2.01),('11288','2013-08-17','08:45:00',2.28),('11288','2013-08-17','08:50:00',2.48),('11288','2013-08-17','08:55:00',2.61),('11288','2013-08-17','09:00:00',2.81),('11288','2013-08-17','09:05:00',2.93),('11288','2013-08-17','09:10:00',3.03),('11288','2013-08-17','09:15:00',3.29),('11288','2013-08-17','09:20:00',3.38),('11288','2013-08-17','09:25:00',3.5),('11288','2013-08-17','09:30:00',3.74),('11288','2013-08-17','09:35:00',3.73),('11288','2013-08-17','09:40:00',3.84),('11288','2013-08-17','09:45:00',3.98),('11288','2013-08-17','09:50:00',4.06),('11288','2013-08-17','09:55:00',4.05),('11288','2013-08-17','10:00:00',4.25),('11288','2013-08-17','10:05:00',4.43),('11288','2013-08-17','10:10:00',4.51),('11288','2013-08-17','10:15:00',4.61),('11288','2013-08-17','10:20:00',4.78),('11288','2013-08-17','10:25:00',4.89),('11288','2013-08-17','10:30:00',4.96),('11288','2013-08-17','10:35:00',5.09),('11288','2013-08-17','10:40:00',5.18),('11288','2013-08-17','10:45:00',5.28),('11288','2013-08-17','10:50:00',5.35),('11288','2013-08-17','10:55:00',5.41),('11288','2013-08-17','11:00:00',5.48),('11288','2013-08-17','11:05:00',5.55),('11288','2013-08-17','11:10:00',5.58),('11288','2013-08-17','11:15:00',5.61),('11288','2013-08-17','11:20:00',5.68),('11288','2013-08-17','11:25:00',5.76),('11288','2013-08-17','11:30:00',5.72),('11288','2013-08-17','11:35:00',5.75),('11288','2013-08-17','11:40:00',5.84),('11288','2013-08-17','11:45:00',5.9),('11288','2013-08-17','11:50:00',5.53),('11288','2013-08-17','11:55:00',5.54),('11288','2013-08-17','12:00:00',5.99),('11288','2013-08-17','12:05:00',6.04),('11288','2013-08-17','12:10:00',6.06),('11288','2013-08-17','12:15:00',6.02),('11288','2013-08-17','12:20:00',6.09),('11288','2013-08-17','12:25:00',6.32),('11288','2013-08-17','12:30:00',6.32),('11288','2013-08-17','12:35:00',6.25),('11288','2013-08-17','12:40:00',6.23),('11288','2013-08-17','12:45:00',6.18),('11288','2013-08-17','12:50:00',6.32),('11288','2013-08-17','12:55:00',6.41),('11288','2013-08-17','13:00:00',6.42),('11288','2013-08-17','13:05:00',6.15),('11288','2013-08-17','13:10:00',4),('11288','2013-08-17','13:15:00',6.19),('11288','2013-08-17','13:20:00',6.61),('11288','2013-08-17','13:25:00',6.46),('11288','2013-08-17','13:30:00',6.58),('11288','2013-08-17','13:35:00',6.61),('11288','2013-08-17','13:40:00',5.43),('11288','2013-08-17','13:45:00',6.68),('11288','2013-08-17','13:50:00',5.63),('11288','2013-08-17','13:55:00',6.3),('11288','2013-08-17','14:00:00',4.04),('11288','2013-08-17','14:05:00',6.39),('11288','2013-08-17','14:10:00',6.25),('11288','2013-08-17','14:15:00',6.18),('11288','2013-08-17','14:20:00',5.04),('11288','2013-08-17','14:25:00',6.01),('11288','2013-08-17','14:30:00',5.56),('11288','2013-08-17','14:35:00',5.99),('11288','2013-08-17','14:40:00',5.9),('11288','2013-08-17','14:45:00',5.97),('11288','2013-08-17','14:50:00',5.87),('11288','2013-08-17','14:55:00',5.84),('11288','2013-08-17','15:00:00',5.77),('11288','2013-08-17','15:05:00',5.75),('11288','2013-08-17','15:10:00',5.68),('11288','2013-08-17','15:15:00',5.61),('11288','2013-08-17','15:20:00',5.54),('11288','2013-08-17','15:25:00',5.53),('11288','2013-08-17','15:30:00',5.44),('11288','2013-08-17','15:35:00',5.4),('11288','2013-08-17','15:40:00',5.34),('11288','2013-08-17','15:45:00',5.26),('11288','2013-08-17','15:50:00',5.19),('11288','2013-08-17','15:55:00',5.11),('11288','2013-08-17','16:00:00',5.01),('11288','2013-08-17','16:05:00',4.87),('11288','2013-08-17','16:10:00',4.78),('11288','2013-08-17','16:15:00',4.69),('11288','2013-08-17','16:20:00',4.66),('11288','2013-08-17','16:25:00',4.48),('11288','2013-08-17','16:30:00',4.42),('11288','2013-08-17','16:35:00',4.34),('11288','2013-08-17','16:40:00',4.26),('11288','2013-08-17','16:45:00',4.03),('11288','2013-08-17','16:50:00',3.94),('11288','2013-08-17','16:55:00',3.89),('11288','2013-08-17','17:00:00',3.78),('11288','2013-08-17','17:05:00',3.58),('11288','2013-08-17','17:10:00',3.32),('11288','2013-08-17','17:15:00',3.09),('11288','2013-08-17','17:20:00',3.08),('11288','2013-08-17','17:25:00',3.19),('11288','2013-08-17','17:30:00',3.07),('11288','2013-08-17','17:35:00',2.93),('11288','2013-08-17','17:40:00',2.74),('11288','2013-08-17','17:45:00',2.55),('11288','2013-08-17','17:50:00',2.48),('11288','2013-08-17','17:55:00',2.34),('11288','2013-08-17','18:00:00',2.2),('11288','2013-08-17','18:05:00',2.04),('11288','2013-08-17','18:10:00',1.86),('11288','2013-08-17','18:15:00',1.77),('11288','2013-08-17','18:20:00',1.65),('11288','2013-08-17','18:25:00',1.52),('11288','2013-08-17','18:30:00',1.42),('11288','2013-08-17','18:35:00',1.35),('11288','2013-08-17','18:40:00',1.22),('11288','2013-08-17','18:45:00',1.07),('11288','2013-08-16','07:50:00',1.02),('11288','2013-08-16','07:55:00',1.16),('11288','2013-08-16','08:00:00',1.27),('11288','2013-08-16','08:05:00',1.33),('11288','2013-08-16','08:10:00',1.43),('11288','2013-08-16','08:15:00',1.61),('11288','2013-08-16','08:20:00',1.76),('11288','2013-08-16','08:25:00',1.78),('11288','2013-08-16','08:30:00',2),('11288','2013-08-16','08:35:00',2.06),('11288','2013-08-16','08:40:00',2.1),('11288','2013-08-16','08:45:00',2.35),('11288','2013-08-16','08:50:00',2.52),('11288','2013-08-16','08:55:00',2.71),('11288','2013-08-16','09:00:00',2.87),('11288','2013-08-16','09:05:00',3.09),('11288','2013-08-16','09:10:00',3.21),('11288','2013-08-16','09:15:00',3.41),('11288','2013-08-16','09:20:00',3.57),('11288','2013-08-16','09:25:00',3.74),('11288','2013-08-16','09:30:00',3.88),('11288','2013-08-16','09:35:00',3.94),('11288','2013-08-16','09:40:00',4.12),('11288','2013-08-16','09:45:00',4.19),('11288','2013-08-16','09:50:00',4.29),('11288','2013-08-16','09:55:00',4.35),('11288','2013-08-16','10:00:00',4.54),('11288','2013-08-16','10:05:00',4.59),('11288','2013-08-16','10:10:00',4.52),('11288','2013-08-16','10:15:00',4.73),('11288','2013-08-16','10:20:00',4.94),('11288','2013-08-16','10:25:00',5.08),('11288','2013-08-16','10:30:00',5.16),('11288','2013-08-16','10:35:00',5.28),('11288','2013-08-16','10:40:00',5.37),('11288','2013-08-16','10:45:00',5.48),('11288','2013-08-16','10:50:00',5.55),('11288','2013-08-16','10:55:00',5.65),('11288','2013-08-16','11:00:00',5.68),('11288','2013-08-16','11:05:00',5.75),('11288','2013-08-16','11:10:00',5.81),('11288','2013-08-16','11:15:00',5.83),('11288','2013-08-16','11:20:00',5.89),('11288','2013-08-16','11:25:00',5.93),('11288','2013-08-16','11:30:00',5.94),('11288','2013-08-16','11:35:00',5.97),('11288','2013-08-16','11:40:00',6.01),('11288','2013-08-16','11:45:00',6.02),('11288','2013-08-16','11:50:00',6.09),('11288','2013-08-16','11:55:00',6.11),('11288','2013-08-16','12:00:00',6.14),('11288','2013-08-16','12:05:00',6.22),('11288','2013-08-16','12:10:00',6.26),('11288','2013-08-16','12:15:00',6.31),('11288','2013-08-16','12:20:00',6.33),('11288','2013-08-16','12:25:00',6.36),('11288','2013-08-16','12:30:00',6.38),('11288','2013-08-16','12:35:00',6.4),('11288','2013-08-16','12:40:00',6.4),('11288','2013-08-16','12:45:00',6.34),('11288','2013-08-16','12:50:00',6.35),('11288','2013-08-16','12:55:00',6.32),('11288','2013-08-16','13:00:00',6.33),('11288','2013-08-16','13:05:00',6.33),('11288','2013-08-16','13:10:00',6.32),('11288','2013-08-16','13:15:00',6.31),('11288','2013-08-16','13:20:00',6.35),('11288','2013-08-16','13:25:00',6.33),('11288','2013-08-16','13:30:00',6.31),('11288','2013-08-16','13:35:00',6.33),('11288','2013-08-16','13:40:00',6.26),('11288','2013-08-16','13:45:00',6.23),('11288','2013-08-16','13:50:00',6.2),('11288','2013-08-16','13:55:00',6.19),('11288','2013-08-16','14:00:00',6.19),('11288','2013-08-16','14:05:00',6.16),('11288','2013-08-16','14:10:00',6.13),('11288','2013-08-16','14:15:00',6.11),('11288','2013-08-16','14:20:00',6.07),('11288','2013-08-16','14:25:00',6),('11288','2013-08-16','14:30:00',5.91),('11288','2013-08-16','14:35:00',5.92),('11288','2013-08-16','14:40:00',5.95),('11288','2013-08-16','14:45:00',5.88),('11288','2013-08-16','14:50:00',5.82),('11288','2013-08-16','14:55:00',5.73),('11288','2013-08-16','15:00:00',5.6),('11288','2013-08-16','15:05:00',5.52),('11288','2013-08-16','15:10:00',5.62),('11288','2013-08-16','15:15:00',5.52),('11288','2013-08-16','15:20:00',5.56),('11288','2013-08-16','15:25:00',5.52),('11288','2013-08-16','15:30:00',5.49),('11288','2013-08-16','15:35:00',5.41),('11288','2013-08-16','15:40:00',5.33),('11288','2013-08-16','15:45:00',5.26),('11288','2013-08-16','15:50:00',5.24),('11288','2013-08-16','15:55:00',5.18),('11288','2013-08-16','16:00:00',5.08),('11288','2013-08-16','16:05:00',4.93),('11288','2013-08-16','16:10:00',4.86),('11288','2013-08-16','16:15:00',4.78),('11288','2013-08-16','16:20:00',4.67),('11288','2013-08-16','16:25:00',4.56),('11288','2013-08-16','16:30:00',4.45),('11288','2013-08-16','16:35:00',4.36),('11288','2013-08-16','16:40:00',4.24),('11288','2013-08-16','16:45:00',4.1),('11288','2013-08-16','16:50:00',3.99),('11288','2013-08-16','16:55:00',3.87),('11288','2013-08-16','17:00:00',3.75),('11288','2013-08-16','17:05:00',3.62),('11288','2013-08-16','17:10:00',3.5),('11288','2013-08-16','17:15:00',3.36),('11288','2013-08-16','17:20:00',3.2),('11288','2013-08-16','17:25:00',3.08),('11288','2013-08-16','17:30:00',2.93),('11288','2013-08-16','17:35:00',2.77),('11288','2013-08-16','17:40:00',2.58),('11288','2013-08-16','17:45:00',2.49),('11288','2013-08-16','17:50:00',2.37),('11288','2013-08-16','17:55:00',2.24),('11288','2013-08-16','18:00:00',2.1),('11288','2013-08-16','18:05:00',1.94),('11288','2013-08-16','18:10:00',1.77),('11288','2013-08-16','18:15:00',1.72),('11288','2013-08-16','18:20:00',1.6),('11288','2013-08-16','18:25:00',1.49),('11288','2013-08-16','18:30:00',1.32),('11288','2013-08-15','07:55:00',1.15),('11288','2013-08-15','08:00:00',1.45),('11288','2013-08-15','08:05:00',1.54),('11288','2013-08-15','08:10:00',1.67),('11288','2013-08-15','08:15:00',1.66),('11288','2013-08-15','08:20:00',1.72),('11288','2013-08-15','08:25:00',1.82),('11288','2013-08-15','08:30:00',1.96),('11288','2013-08-15','08:35:00',2.11),('11288','2013-08-15','08:40:00',2.26),('11288','2013-08-15','08:45:00',2.45),('11288','2013-08-15','08:50:00',2.62),('11288','2013-08-15','08:55:00',2.67),('11288','2013-08-15','09:00:00',2.9),('11288','2013-08-15','09:05:00',2.89),('11288','2013-08-15','09:10:00',2.2),('11288','2013-08-15','09:15:00',3.14),('11288','2013-08-15','09:20:00',3.84),('11288','2013-08-15','09:25:00',3.7),('11288','2013-08-15','09:30:00',3.85),('11288','2013-08-15','09:35:00',3.99),('11288','2013-08-15','09:40:00',4.08),('11288','2013-08-15','09:45:00',4.13),('11288','2013-08-15','09:50:00',4.31),('11288','2013-08-15','09:55:00',4.37),('11288','2013-08-15','10:00:00',4.37),('11288','2013-08-15','10:05:00',4.64),('11288','2013-08-15','10:10:00',4.65),('11288','2013-08-15','10:15:00',4.69),('11288','2013-08-15','10:20:00',4.99),('11288','2013-08-15','10:25:00',5.13),('11288','2013-08-15','10:30:00',5.23),('11288','2013-08-15','10:35:00',5.3),('11288','2013-08-15','10:40:00',5.42),('11288','2013-08-15','10:45:00',5.55),('11288','2013-08-15','10:50:00',5.6),('11288','2013-08-15','10:55:00',4.88),('11288','2013-08-15','11:00:00',5.33),('11288','2013-08-15','11:05:00',5.25),('11288','2013-08-15','11:10:00',3.79),('11288','2013-08-15','11:15:00',3.72),('11288','2013-08-15','11:20:00',4.38),('11288','2013-08-15','11:25:00',4.93),('11288','2013-08-15','11:30:00',5.34),('11288','2013-08-15','11:35:00',5.87),('11288','2013-08-15','11:40:00',6.3),('11288','2013-08-15','11:45:00',6.55),('11288','2013-08-15','11:50:00',6.7),('11288','2013-08-15','11:55:00',6.66),('11288','2013-08-15','12:00:00',6.73),('11288','2013-08-15','12:05:00',6.72),('11288','2013-08-15','12:10:00',6.65),('11288','2013-08-15','12:15:00',6.58),('11288','2013-08-15','12:20:00',6.64),('11288','2013-08-15','12:25:00',6.6),('11288','2013-08-15','12:30:00',6.63),('11288','2013-08-15','12:35:00',6.58),('11288','2013-08-15','12:40:00',6.63),('11288','2013-08-15','12:45:00',6.59),('11288','2013-08-15','12:50:00',6.59),('11288','2013-08-15','12:55:00',6.46),('11288','2013-08-15','13:00:00',6.27),('11288','2013-08-15','13:05:00',6.34),('11288','2013-08-15','13:10:00',6.38),('11288','2013-08-15','13:15:00',6.26),('11288','2013-08-15','13:20:00',6.04),('11288','2013-08-15','13:25:00',6.25),('11288','2013-08-15','13:30:00',6.4),('11288','2013-08-15','13:35:00',6.48),('11288','2013-08-15','13:40:00',6.47),('11288','2013-08-15','13:45:00',6.45),('11288','2013-08-15','13:50:00',6.37),('11288','2013-08-15','13:55:00',6.29),('11288','2013-08-15','14:00:00',6.26),('11288','2013-08-15','14:05:00',6.34),('11288','2013-08-15','14:10:00',6.28),('11288','2013-08-15','14:15:00',6.24),('11288','2013-08-15','14:20:00',6.23),('11288','2013-08-15','14:25:00',6.17),('11288','2013-08-15','14:30:00',6.05),('11288','2013-08-15','14:35:00',6.03),('11288','2013-08-15','14:40:00',6.06),('11288','2013-08-15','14:45:00',6),('11288','2013-08-15','14:50:00',5.85),('11288','2013-08-15','14:55:00',5.79),('11288','2013-08-15','15:00:00',5.72),('11288','2013-08-15','15:05:00',5.65),('11288','2013-08-15','15:10:00',5.66),('11288','2013-08-15','15:15:00',5.63),('11288','2013-08-15','15:20:00',5.53),('11288','2013-08-15','15:25:00',5.47),('11288','2013-08-15','15:30:00',5.34),('11288','2013-08-15','15:35:00',5.29),('11288','2013-08-15','15:40:00',5.22),('11288','2013-08-15','15:45:00',5.15),('11288','2013-08-15','15:50:00',5.07),('11288','2013-08-15','15:55:00',4.96),('11288','2013-08-15','16:00:00',4.86),('11288','2013-08-15','16:05:00',4.83),('11288','2013-08-15','16:10:00',4.74),('11288','2013-08-15','16:15:00',4.56),('11288','2013-08-15','16:20:00',4.49),('11288','2013-08-15','16:25:00',4.37),('11288','2013-08-15','16:30:00',4.28),('11288','2013-08-15','16:35:00',4.15),('11288','2013-08-15','16:40:00',3.79),('11288','2013-08-15','16:45:00',3.55),('11288','2013-08-15','16:50:00',3.74),('11288','2013-08-15','16:55:00',3.73),('11288','2013-08-15','17:00:00',3.62),('11288','2013-08-15','17:05:00',3.43),('11288','2013-08-15','17:10:00',3.32),('11288','2013-08-15','17:15:00',3.22),('11288','2013-08-15','17:20:00',2.86),('11288','2013-08-15','17:25:00',2.25),('11288','2013-08-15','17:30:00',2.27),('11288','2013-08-15','17:35:00',2.53),('11288','2013-08-15','17:40:00',2.6),('11288','2013-08-15','17:45:00',2.47),('11288','2013-08-15','17:50:00',2.35),('11288','2013-08-15','17:55:00',2.21),('11288','2013-08-15','18:00:00',2.08),('11288','2013-08-15','18:05:00',1.9),('11288','2013-08-15','18:10:00',1.75),('11288','2013-08-15','18:15:00',1.69),('11288','2013-08-15','18:20:00',1.61),('11288','2013-08-15','18:25:00',1.52),('11288','2013-08-15','18:30:00',1.45),('11288','2013-08-15','18:35:00',1.37),('11288','2013-08-15','18:40:00',1.26),('11288','2013-08-14','07:45:00',1.06),('11288','2013-08-14','07:50:00',1.12),('11288','2013-08-14','07:55:00',1.22),('11288','2013-08-14','08:00:00',1.35),('11288','2013-08-14','08:05:00',1.41),('11288','2013-08-14','08:10:00',1.46),('11288','2013-08-14','08:15:00',1.7),('11288','2013-08-14','08:20:00',1.8),('11288','2013-08-14','08:25:00',1.85),('11288','2013-08-14','08:30:00',2),('11288','2013-08-14','08:35:00',1.98),('11288','2013-08-14','08:40:00',2.06),('11288','2013-08-14','08:45:00',2.38),('11288','2013-08-14','08:50:00',2.36),('11288','2013-08-14','08:55:00',2.58),('11288','2013-08-14','09:00:00',1.94),('11288','2013-08-14','09:05:00',2.72),('11288','2013-08-14','09:10:00',3.34),('11288','2013-08-14','09:15:00',3.63),('11288','2013-08-14','09:20:00',3.87),('11288','2013-08-14','09:25:00',3.61),('11288','2013-08-14','09:30:00',4.11),('11288','2013-08-14','09:35:00',2.29),('11288','2013-08-14','09:40:00',2.08),('11288','2013-08-14','09:45:00',2.88),('11288','2013-08-14','09:50:00',3.25),('11288','2013-08-14','09:55:00',4.02),('11288','2013-08-14','10:00:00',4.47),('11288','2013-08-14','10:05:00',2.67),('11288','2013-08-14','10:10:00',1.92),('11288','2013-08-14','10:15:00',1.82),('11288','2013-08-14','10:20:00',2.57),('11288','2013-08-14','10:25:00',4.77),('11288','2013-08-14','10:30:00',5.94),('11288','2013-08-14','10:35:00',5.62),('11288','2013-08-14','10:40:00',3.58),('11288','2013-08-14','10:45:00',1.8),('11288','2013-08-14','10:50:00',1.78),('11288','2013-08-14','10:55:00',2.11),('11288','2013-08-14','11:00:00',2.41),('11288','2013-08-14','11:05:00',3.5),('11288','2013-08-14','11:10:00',5.88),('11288','2013-08-14','11:15:00',5.86),('11288','2013-08-14','11:20:00',5.52),('11288','2013-08-14','11:25:00',5.71),('11288','2013-08-14','11:30:00',6.11),('11288','2013-08-14','11:35:00',5),('11288','2013-08-14','11:40:00',2.79),('11288','2013-08-14','11:45:00',2.37),('11288','2013-08-14','11:50:00',2.98),('11288','2013-08-14','11:55:00',6.5),('11288','2013-08-14','12:00:00',6.86),('11288','2013-08-14','12:05:00',5.87),('11288','2013-08-14','12:10:00',3.27),('11288','2013-08-14','12:15:00',2.25),('11288','2013-08-14','12:20:00',2.08),('11288','2013-08-14','12:25:00',2.26),('11288','2013-08-14','12:30:00',1.91),('11288','2013-08-14','12:35:00',2.16),('11288','2013-08-14','12:40:00',2.72),('11288','2013-08-14','12:45:00',2.77),('11288','2013-08-14','12:50:00',3.82),('11288','2013-08-14','12:55:00',5.39),('11288','2013-08-14','13:00:00',4.85),('11288','2013-08-14','13:05:00',1.94),('11288','2013-08-14','13:10:00',2.23),('11288','2013-08-14','13:15:00',2.94),('11288','2013-08-14','13:20:00',3.13),('11288','2013-08-14','13:25:00',6.5),('11288','2013-08-14','13:30:00',5.05),('11288','2013-08-14','13:35:00',6.88),('11288','2013-08-14','13:40:00',5.83),('11288','2013-08-14','13:45:00',6.91),('11288','2013-08-14','13:50:00',5.7),('11288','2013-08-14','13:55:00',6.82),('11288','2013-08-14','14:00:00',6.05),('11288','2013-08-14','14:05:00',6.67),('11288','2013-08-14','14:10:00',6.59),('11288','2013-08-14','14:15:00',6.71),('11288','2013-08-14','14:20:00',4.54),('11288','2013-08-14','14:25:00',6.46),('11288','2013-08-14','14:30:00',5.67),('11288','2013-08-14','14:35:00',6.1),('11288','2013-08-14','14:40:00',6.28),('11288','2013-08-14','14:45:00',6.24),('11288','2013-08-14','14:50:00',6.15),('11288','2013-08-14','14:55:00',6.1),('11288','2013-08-14','15:00:00',5.96),('11288','2013-08-14','15:05:00',5.71),('11288','2013-08-14','15:10:00',5.88),('11288','2013-08-14','15:15:00',5.93),('11288','2013-08-14','15:20:00',5.86),('11288','2013-08-14','15:25:00',5.67),('11288','2013-08-14','15:30:00',5.51),('11288','2013-08-14','15:35:00',5.48),('11288','2013-08-14','15:40:00',5.41),('11288','2013-08-14','15:45:00',5.35),('11288','2013-08-14','15:50:00',5.28),('11288','2013-08-14','15:55:00',5.19),('11288','2013-08-14','16:00:00',5.07),('11288','2013-08-14','16:05:00',4.96),('11288','2013-08-14','16:10:00',4.97),('11288','2013-08-14','16:15:00',4.94),('11288','2013-08-14','16:20:00',4.82),('11288','2013-08-14','16:25:00',4.68),('11288','2013-08-14','16:30:00',4.57),('11288','2013-08-14','16:35:00',4.44),('11288','2013-08-14','16:40:00',4.37),('11288','2013-08-14','16:45:00',4.23),('11288','2013-08-14','16:50:00',4.09),('11288','2013-08-14','16:55:00',3.97),('11288','2013-08-14','17:00:00',3.83),('11288','2013-08-14','17:05:00',3.74),('11288','2013-08-14','17:10:00',3.57),('11288','2013-08-14','17:15:00',3.48),('11288','2013-08-14','17:20:00',3.3),('11288','2013-08-14','17:25:00',3.15),('11288','2013-08-14','17:30:00',3.02),('11288','2013-08-14','17:35:00',2.89),('11288','2013-08-14','17:40:00',2.78),('11288','2013-08-14','17:45:00',2.61),('11288','2013-08-14','17:50:00',2.49),('11288','2013-08-14','17:55:00',2.35),('11288','2013-08-14','18:00:00',2.2),('11288','2013-08-14','18:05:00',2.09),('11288','2013-08-14','18:10:00',1.97),('11288','2013-08-14','18:15:00',1.84),('11288','2013-08-14','18:20:00',1.8),('11288','2013-08-14','18:25:00',1.82),('11288','2013-08-14','18:30:00',1.76),('11288','2013-08-14','18:35:00',1.56),('11288','2013-08-14','18:40:00',1.39),('11288','2013-08-14','18:45:00',1.35),('11288','2013-08-14','18:50:00',1.34),('11288','2013-08-14','18:55:00',1.27),('11288','2013-08-14','19:00:00',1.24),('11288','2013-08-14','19:05:00',1.01),('11288','2013-08-13','07:45:00',1.07),('11288','2013-08-13','07:50:00',1.16),('11288','2013-08-13','07:55:00',1.27),('11288','2013-08-13','08:00:00',1.41),('11288','2013-08-13','08:05:00',1.41),('11288','2013-08-13','08:10:00',1.51),('11288','2013-08-13','08:15:00',1.58),('11288','2013-08-13','08:20:00',1.8),('11288','2013-08-13','08:25:00',1.96),('11288','2013-08-13','08:30:00',2.08),('11288','2013-08-13','08:35:00',2.07),('11288','2013-08-13','08:40:00',2.17),('11288','2013-08-13','08:45:00',2.46),('11288','2013-08-13','08:50:00',2.45),('11288','2013-08-13','08:55:00',2.6),('11288','2013-08-13','09:00:00',2.91),('11288','2013-08-13','09:05:00',3.06),('11288','2013-08-13','09:10:00',3.23),('11288','2013-08-13','09:15:00',3.39),('11288','2013-08-13','09:20:00',3.48),('11288','2013-08-13','09:25:00',3.69),('11288','2013-08-13','09:30:00',3.66),('11288','2013-08-13','09:35:00',3.91),('11288','2013-08-13','09:40:00',3.98),('11288','2013-08-13','09:45:00',4.09),('11288','2013-08-13','09:50:00',4.23),('11288','2013-08-13','09:55:00',4.29),('11288','2013-08-13','10:00:00',4.33),('11288','2013-08-13','10:05:00',4.47),('11288','2013-08-13','10:10:00',2.57),('11288','2013-08-13','10:15:00',4.74),('11288','2013-08-13','10:20:00',4.98),('11288','2013-08-13','10:25:00',5),('11288','2013-08-13','10:30:00',5.12),('11288','2013-08-13','10:35:00',5.09),('11288','2013-08-13','10:40:00',5.14),('11288','2013-08-13','10:45:00',5.29),('11288','2013-08-13','10:50:00',5.45),('11288','2013-08-13','10:55:00',5.52),('11288','2013-08-13','11:00:00',5.6),('11288','2013-08-13','11:05:00',5.58),('11288','2013-08-13','11:10:00',5.53),('11288','2013-08-13','11:15:00',5.68),('11288','2013-08-13','11:20:00',5.75),('11288','2013-08-13','11:25:00',5.75),('11288','2013-08-13','11:30:00',5.63),('11288','2013-08-13','11:35:00',5.7),('11288','2013-08-13','11:40:00',5.9),('11288','2013-08-13','11:45:00',5.94),('11288','2013-08-13','11:50:00',6.03),('11288','2013-08-13','11:55:00',6.05),('11288','2013-08-13','12:00:00',4.77),('11288','2013-08-13','12:05:00',3.92),('11288','2013-08-13','12:10:00',6.25),('11288','2013-08-13','12:15:00',6.6),('11288','2013-08-13','12:20:00',6.6),('11288','2013-08-13','12:25:00',6.73),('11288','2013-08-13','12:30:00',5.72),('11288','2013-08-13','12:35:00',2.36),('11288','2013-08-13','12:40:00',1.94),('11288','2013-08-13','12:45:00',2.12),('11288','2013-08-13','12:50:00',2.56),('11288','2013-08-13','12:55:00',5.72),('11288','2013-08-13','13:00:00',5.49),('11288','2013-08-13','13:05:00',3.3),('11288','2013-08-13','13:10:00',4.67),('11288','2013-08-13','13:15:00',4.44),('11288','2013-08-13','13:20:00',2.63),('11288','2013-08-13','13:25:00',2.06),('11288','2013-08-13','13:30:00',3.04),('11288','2013-08-13','13:35:00',6.12),('11288','2013-08-13','13:40:00',4.66),('11288','2013-08-13','13:45:00',2.36),('11288','2013-08-13','13:50:00',4.42),('11288','2013-08-13','13:55:00',7.34),('11288','2013-08-13','14:00:00',6.24),('11288','2013-08-13','14:05:00',7.13),('11288','2013-08-13','14:10:00',6.78),('11288','2013-08-13','14:15:00',6.56),('11288','2013-08-13','14:20:00',6.64),('11288','2013-08-13','14:25:00',6.06),('11288','2013-08-13','14:30:00',5.9),('11288','2013-08-13','14:35:00',5.08),('11288','2013-08-13','14:40:00',4.07),('11288','2013-08-13','14:45:00',3.37),('11288','2013-08-13','14:50:00',2.3),('11288','2013-08-13','14:55:00',6.12),('11288','2013-08-13','15:00:00',6.35),('11288','2013-08-13','15:05:00',5.23),('11288','2013-08-13','15:10:00',6.16),('11288','2013-08-13','15:15:00',6.05),('11288','2013-08-13','15:20:00',4.17),('11288','2013-08-13','15:25:00',5.75),('11288','2013-08-13','15:30:00',5.77),('11288','2013-08-13','15:35:00',4.75),('11288','2013-08-13','15:40:00',5.41),('11288','2013-08-13','15:45:00',5.48),('11288','2013-08-13','15:50:00',5.31),('11288','2013-08-13','15:55:00',5.18),('11288','2013-08-13','16:00:00',5.13),('11288','2013-08-13','16:05:00',5.02),('11288','2013-08-13','16:10:00',4.89),('11288','2013-08-13','16:15:00',4.8),('11288','2013-08-13','16:20:00',4.74),('11288','2013-08-13','16:25:00',4.66),('11288','2013-08-13','16:30:00',4.53),('11288','2013-08-13','16:35:00',4.42),('11288','2013-08-13','16:40:00',4.31),('11288','2013-08-13','16:45:00',4.17),('11288','2013-08-13','16:50:00',4.06),('11288','2013-08-13','16:55:00',3.95),('11288','2013-08-13','17:00:00',3.84),('11288','2013-08-13','17:05:00',3.73),('11288','2013-08-13','17:10:00',3.59),('11288','2013-08-13','17:15:00',3.46),('11288','2013-08-13','17:20:00',3.34),('11288','2013-08-13','17:25:00',3.19),('11288','2013-08-13','17:30:00',3.03),('11288','2013-08-13','17:35:00',2.88),('11288','2013-08-13','17:40:00',2.76),('11288','2013-08-13','17:45:00',2.62),('11288','2013-08-13','17:50:00',2.51),('11288','2013-08-13','17:55:00',2.35),('11288','2013-08-13','18:00:00',2.19),('11288','2013-08-13','18:05:00',2.04),('11288','2013-08-13','18:10:00',1.91),('11288','2013-08-13','18:15:00',1.77),('11288','2013-08-13','18:20:00',1.69),('11288','2013-08-13','18:25:00',1.6),('11288','2013-08-13','18:30:00',1.54),('11288','2013-08-13','18:35:00',1.41),('11288','2013-08-13','18:40:00',1.28),('11288','2013-08-13','18:45:00',1.14),('11288','2013-08-13','18:50:00',1),('11288','2013-08-12','07:45:00',1.05),('11288','2013-08-12','07:50:00',1.14),('11288','2013-08-12','07:55:00',1.27),('11288','2013-08-12','08:00:00',1.34),('11288','2013-08-12','08:05:00',1.45),('11288','2013-08-12','08:10:00',1.53),('11288','2013-08-12','08:15:00',1.6),('11288','2013-08-12','08:20:00',1.81),('11288','2013-08-12','08:25:00',1.91),('11288','2013-08-12','08:30:00',2.01),('11288','2013-08-12','08:35:00',2.15),('11288','2013-08-12','08:40:00',2.23),('11288','2013-08-12','08:45:00',2.39),('11288','2013-08-12','08:50:00',2.45),('11288','2013-08-12','08:55:00',2.5),('11288','2013-08-12','09:00:00',2.82),('11288','2013-08-12','09:05:00',2.99),('11288','2013-08-12','09:10:00',3.17),('11288','2013-08-12','09:15:00',3.37),('11288','2013-08-12','09:20:00',3.41),('11288','2013-08-12','09:25:00',3.63),('11288','2013-08-12','09:30:00',3.69),('11288','2013-08-12','09:35:00',3.88),('11288','2013-08-12','09:40:00',3.98),('11288','2013-08-12','09:45:00',4.1),('11288','2013-08-12','09:50:00',4.14),('11288','2013-08-12','09:55:00',4.25),('11288','2013-08-12','10:00:00',4.25),('11288','2013-08-12','10:05:00',4.38),('11288','2013-08-12','10:10:00',4.44),('11288','2013-08-12','10:15:00',4.66),('11288','2013-08-12','10:20:00',4.77),('11288','2013-08-12','10:25:00',4.85),('11288','2013-08-12','10:30:00',4.95),('11288','2013-08-12','10:35:00',5.07),('11288','2013-08-12','10:40:00',5.13),('11288','2013-08-12','10:45:00',5.22),('11288','2013-08-12','10:50:00',5.32),('11288','2013-08-12','10:55:00',5.4),('11288','2013-08-12','11:00:00',5.44),('11288','2013-08-12','11:05:00',5.55),('11288','2013-08-12','11:10:00',5.67),('11288','2013-08-12','11:15:00',5.7),('11288','2013-08-12','11:20:00',5.76),('11288','2013-08-12','11:25:00',5.77),('11288','2013-08-12','11:30:00',5.85),('11288','2013-08-12','11:35:00',5.92),('11288','2013-08-12','11:40:00',5.92),('11288','2013-08-12','11:45:00',6.03),('11288','2013-08-12','11:50:00',6.2),('11288','2013-08-12','11:55:00',6.24),('11288','2013-08-12','12:00:00',6.31),('11288','2013-08-12','12:05:00',6.25),('11288','2013-08-12','12:10:00',5.79),('11288','2013-08-12','12:15:00',3.12),('11288','2013-08-12','12:20:00',4.59),('11288','2013-08-12','12:25:00',6.25),('11288','2013-08-12','12:30:00',4.61),('11288','2013-08-12','12:35:00',6.75),('11288','2013-08-12','12:40:00',4.35),('11288','2013-08-12','12:45:00',2.28),('11288','2013-08-12','12:50:00',2.63),('11288','2013-08-12','12:55:00',2.24),('11288','2013-08-12','13:00:00',1.38),('11288','2013-08-12','13:05:00',1.28),('11288','2013-08-12','13:10:00',1.48),('11288','2013-08-12','13:15:00',1.87),('11288','2013-08-12','13:20:00',2.19),('11288','2013-08-12','13:25:00',2.52),('11288','2013-08-12','13:30:00',2.22),('11288','2013-08-12','13:35:00',2.3),('11288','2013-08-12','13:40:00',2.03),('11288','2013-08-12','13:45:00',3.04),('11288','2013-08-12','13:50:00',7.45),('11288','2013-08-12','13:55:00',5.55),('11288','2013-08-12','14:00:00',4.68),('11288','2013-08-12','14:05:00',4.26),('11288','2013-08-12','14:10:00',1.93),('11288','2013-08-12','14:15:00',1.77),('11288','2013-08-12','14:20:00',1.55),('11288','2013-08-12','14:25:00',1.38),('11288','2013-08-12','14:30:00',1.67),('11288','2013-08-12','14:35:00',2.07),('11288','2013-08-12','14:40:00',2.16),('11288','2013-08-12','14:45:00',3.11),('11288','2013-08-12','14:50:00',5.52),('11288','2013-08-12','14:55:00',6.98),('11288','2013-08-12','15:00:00',6.78),('11288','2013-08-12','15:05:00',5.26),('11288','2013-08-12','15:10:00',5.28),('11288','2013-08-12','15:15:00',5.57),('11288','2013-08-12','15:20:00',4.84),('11288','2013-08-12','15:25:00',5.9),('11288','2013-08-12','15:30:00',5.67),('11288','2013-08-12','15:35:00',5.53),('11288','2013-08-12','15:40:00',5.48),('11288','2013-08-12','15:45:00',5.45),('11288','2013-08-12','15:50:00',5.38),('11288','2013-08-12','15:55:00',5.24),('11288','2013-08-12','16:00:00',5.15),('11288','2013-08-12','16:05:00',4.99),('11288','2013-08-12','16:10:00',4.9),('11288','2013-08-12','16:15:00',4.75),('11288','2013-08-12','16:20:00',4.72),('11288','2013-08-12','16:25:00',4.68),('11288','2013-08-12','16:30:00',4.43),('11288','2013-08-12','16:35:00',4.38),('11288','2013-08-12','16:40:00',4.18),('11288','2013-08-12','16:45:00',4.1),('11288','2013-08-12','16:50:00',3.92),('11288','2013-08-12','16:55:00',3.99),('11288','2013-08-12','17:00:00',3.83),('11288','2013-08-12','17:05:00',3.69),('11288','2013-08-12','17:10:00',3.5),('11288','2013-08-12','17:15:00',3.39),('11288','2013-08-12','17:20:00',3.26),('11288','2013-08-12','17:25:00',3.15),('11288','2013-08-12','17:30:00',3),('11288','2013-08-12','17:35:00',2.81),('11288','2013-08-12','17:40:00',2.6),('11288','2013-08-12','17:45:00',2.52),('11288','2013-08-12','17:50:00',2.47),('11288','2013-08-12','17:55:00',2.37),('11288','2013-08-12','18:00:00',2.21),('11288','2013-08-12','18:05:00',2.07),('11288','2013-08-12','18:10:00',1.95),('11288','2013-08-12','18:15:00',1.83),('11288','2013-08-12','18:20:00',1.74),('11288','2013-08-12','18:25:00',1.72),('11288','2013-08-12','18:30:00',1.64),('11288','2013-08-12','18:35:00',1.48),('11288','2013-08-12','18:40:00',1.36),('11288','2013-08-12','18:45:00',1.22),('11288','2013-08-12','18:50:00',1.11),('11288','2013-08-11','07:45:00',1.06),('11288','2013-08-11','07:50:00',1.15),('11288','2013-08-11','07:55:00',1.25),('11288','2013-08-11','08:00:00',1.37),('11288','2013-08-11','08:05:00',1.43),('11288','2013-08-11','08:10:00',1.53),('11288','2013-08-11','08:15:00',1.77),('11288','2013-08-11','08:20:00',1.87),('11288','2013-08-11','08:25:00',1.99),('11288','2013-08-11','08:30:00',2.07),('11288','2013-08-11','08:35:00',2.17),('11288','2013-08-11','08:40:00',2.3),('11288','2013-08-11','08:45:00',2.48),('11288','2013-08-11','08:50:00',2.57),('11288','2013-08-11','08:55:00',2.63),('11288','2013-08-11','09:00:00',2.8),('11288','2013-08-11','09:05:00',2.98),('11288','2013-08-11','09:10:00',3.17),('11288','2013-08-11','09:15:00',3.45),('11288','2013-08-11','09:20:00',3.52),('11288','2013-08-11','09:25:00',3.68),('11288','2013-08-11','09:30:00',3.86),('11288','2013-08-11','09:35:00',3.91),('11288','2013-08-11','09:40:00',4.09),('11288','2013-08-11','09:45:00',4.18),('11288','2013-08-11','09:50:00',4.28),('11288','2013-08-11','09:55:00',4.42),('11288','2013-08-11','10:00:00',4.58),('11288','2013-08-11','10:05:00',4.65),('11288','2013-08-11','10:10:00',4.77),('11288','2013-08-11','10:15:00',4.86),('11288','2013-08-11','10:20:00',4.97),('11288','2013-08-11','10:25:00',5.11),('11288','2013-08-11','10:30:00',5.22),('11288','2013-08-11','10:35:00',5.29),('11288','2013-08-11','10:40:00',5.34),('11288','2013-08-11','10:45:00',5.43),('11288','2013-08-11','10:50:00',5.49),('11288','2013-08-11','10:55:00',5.64),('11288','2013-08-11','11:00:00',5.7),('11288','2013-08-11','11:05:00',5.8),('11288','2013-08-11','11:10:00',5.84),('11288','2013-08-11','11:15:00',5.89),('11288','2013-08-11','11:20:00',5.91),('11288','2013-08-11','11:25:00',5.95),('11288','2013-08-11','11:30:00',6.05),('11288','2013-08-11','11:35:00',6.1),('11288','2013-08-11','11:40:00',6.14),('11288','2013-08-11','11:45:00',6.17),('11288','2013-08-11','11:50:00',6.14),('11288','2013-08-11','11:55:00',6.23),('11288','2013-08-11','12:00:00',6.33),('11288','2013-08-11','12:05:00',6.33),('11288','2013-08-11','12:10:00',6.35),('11288','2013-08-11','12:15:00',6.38),('11288','2013-08-11','12:20:00',6.39),('11288','2013-08-11','12:25:00',6.39),('11288','2013-08-11','12:30:00',6.42),('11288','2013-08-11','12:35:00',6.48),('11288','2013-08-11','12:40:00',6.47),('11288','2013-08-11','12:45:00',6.48),('11288','2013-08-11','12:50:00',6.45),('11288','2013-08-11','12:55:00',6.41),('11288','2013-08-11','13:00:00',6.43),('11288','2013-08-11','13:05:00',6.4),('11288','2013-08-11','13:10:00',6.42),('11288','2013-08-11','13:15:00',6.41),('11288','2013-08-11','13:20:00',6.34),('11288','2013-08-11','13:25:00',6.36),('11288','2013-08-11','13:30:00',6.39),('11288','2013-08-11','13:35:00',6.41),('11288','2013-08-11','13:40:00',6.39),('11288','2013-08-11','13:45:00',6.41),('11288','2013-08-11','13:50:00',6.31),('11288','2013-08-11','13:55:00',6.23),('11288','2013-08-11','14:00:00',6.25),('11288','2013-08-11','14:05:00',6.23),('11288','2013-08-11','14:10:00',6.2),('11288','2013-08-11','14:15:00',6.17),('11288','2013-08-11','14:20:00',6.1),('11288','2013-08-11','14:25:00',6.13),('11288','2013-08-11','14:30:00',6.04),('11288','2013-08-11','14:35:00',5.98),('11288','2013-08-11','14:40:00',6),('11288','2013-08-11','14:45:00',5.98),('11288','2013-08-11','14:50:00',5.99),('11288','2013-08-11','14:55:00',5.83),('11288','2013-08-11','15:00:00',5.42),('11288','2013-08-11','15:05:00',5.08),('11288','2013-08-11','15:10:00',5.64),('11288','2013-08-11','15:15:00',5.61),('11288','2013-08-11','15:20:00',5.59),('11288','2013-08-11','15:25:00',4.34),('11288','2013-08-11','15:30:00',4.03),('11288','2013-08-11','15:35:00',5.4),('11288','2013-08-11','15:40:00',5.4),('11288','2013-08-11','15:45:00',5.34),('11288','2013-08-11','15:50:00',5.22),('11288','2013-08-11','15:55:00',5.19),('11288','2013-08-11','16:00:00',5.13),('11288','2013-08-11','16:05:00',5.05),('11288','2013-08-11','16:10:00',4.92),('11288','2013-08-11','16:15:00',4.83),('11288','2013-08-11','16:20:00',4.73),('11288','2013-08-11','16:25:00',4.64),('11288','2013-08-11','16:30:00',4.49),('11288','2013-08-11','16:35:00',4.41),('11288','2013-08-11','16:40:00',4.28),('11288','2013-08-11','16:45:00',4.17),('11288','2013-08-11','16:50:00',4.04),('11288','2013-08-11','16:55:00',3.92),('11288','2013-08-11','17:00:00',3.78),('11288','2013-08-11','17:05:00',3.69),('11288','2013-08-11','17:10:00',3.54),('11288','2013-08-11','17:15:00',3.45),('11288','2013-08-11','17:20:00',3.32),('11288','2013-08-11','17:25:00',3.17),('11288','2013-08-11','17:30:00',3.03),('11288','2013-08-11','17:35:00',2.9),('11288','2013-08-11','17:40:00',2.78),('11288','2013-08-11','17:45:00',2.65),('11288','2013-08-11','17:50:00',2.51),('11288','2013-08-11','17:55:00',2.36),('11288','2013-08-11','18:00:00',2.2),('11288','2013-08-11','18:05:00',2.07),('11288','2013-08-11','18:10:00',1.87),('11288','2013-08-11','18:15:00',1.79),('11288','2013-08-11','18:20:00',1.71),('11288','2013-08-11','18:25:00',1.69),('11288','2013-08-11','18:30:00',1.59),('11288','2013-08-11','18:35:00',1.45),('11288','2013-08-11','18:40:00',1.3),('11288','2013-08-11','18:45:00',1.19),('11288','2013-08-11','18:50:00',1.05),('11288','2013-08-10','07:45:00',1.06),('11288','2013-08-10','07:50:00',1.17),('11288','2013-08-10','07:55:00',1.31),('11288','2013-08-10','08:00:00',1.38),('11288','2013-08-10','08:05:00',1.44),('11288','2013-08-10','08:10:00',1.44),('11288','2013-08-10','08:15:00',1.78),('11288','2013-08-10','08:20:00',1.84),('11288','2013-08-10','08:25:00',1.95),('11288','2013-08-10','08:30:00',2.14),('11288','2013-08-10','08:35:00',2.19),('11288','2013-08-10','08:40:00',2.28),('11288','2013-08-10','08:45:00',2.59),('11288','2013-08-10','08:50:00',2.68),('11288','2013-08-10','08:55:00',2.73),('11288','2013-08-10','09:00:00',2.95),('11288','2013-08-10','09:05:00',3.09),('11288','2013-08-10','09:10:00',3.31),('11288','2013-08-10','09:15:00',3.53),('11288','2013-08-10','09:20:00',3.65),('11288','2013-08-10','09:25:00',3.65),('11288','2013-08-10','09:30:00',3.9),('11288','2013-08-10','09:35:00',3.92),('11288','2013-08-10','09:40:00',4.07),('11288','2013-08-10','09:45:00',4.25),('11288','2013-08-10','09:50:00',4.32),('11288','2013-08-10','09:55:00',4.39),('11288','2013-08-10','10:00:00',4.58),('11288','2013-08-10','10:05:00',4.71),('11288','2013-08-10','10:10:00',4.08),('11288','2013-08-10','10:20:00',3.5),('11288','2013-08-10','10:25:00',4.71),('11288','2013-08-10','10:30:00',4.85),('11288','2013-08-10','10:35:00',5.26),('11288','2013-08-10','10:40:00',3.91),('11288','2013-08-10','10:45:00',5.4),('11288','2013-08-10','10:50:00',5.41),('11288','2013-08-10','10:55:00',5.64),('11288','2013-08-10','11:00:00',3.98),('11288','2013-08-10','11:05:00',5.85),('11288','2013-08-10','11:10:00',6.1),('11288','2013-08-10','11:15:00',5.96),('11288','2013-08-10','11:20:00',4.7),('11288','2013-08-10','11:25:00',4.72),('11288','2013-08-10','11:30:00',6.28),('11288','2013-08-10','11:35:00',5.83),('11288','2013-08-10','11:40:00',5.55),('11288','2013-08-10','11:45:00',4.63),('11288','2013-08-10','11:50:00',6.19),('11288','2013-08-10','11:55:00',6.24),('11288','2013-08-10','12:00:00',6.31),('11288','2013-08-10','12:05:00',6.36),('11288','2013-08-10','12:10:00',6.41),('11288','2013-08-10','12:15:00',6.4),('11288','2013-08-10','12:20:00',6.42),('11288','2013-08-10','12:25:00',6.44),('11288','2013-08-10','12:30:00',6.48),('11288','2013-08-10','12:35:00',6.49),('11288','2013-08-10','12:40:00',6.53),('11288','2013-08-10','12:45:00',6.64),('11288','2013-08-10','12:50:00',6.8),('11288','2013-08-10','12:55:00',6.71),('11288','2013-08-10','13:00:00',6.7),('11288','2013-08-10','13:05:00',6.56),('11288','2013-08-10','13:10:00',6.68),('11288','2013-08-10','13:15:00',6.83),('11288','2013-08-10','13:20:00',6.65),('11288','2013-08-10','13:25:00',7.03),('11288','2013-08-10','13:30:00',7.2),('11288','2013-08-10','13:35:00',6.14),('11288','2013-08-10','13:40:00',2.45),('11288','2013-08-10','13:45:00',1.1),('11288','2013-08-10','13:50:00',2.22),('11288','2013-08-10','13:55:00',6.27),('11288','2013-08-10','14:00:00',7.18),('11288','2013-08-10','14:05:00',7.48),('11288','2013-08-10','14:10:00',5.34),('11288','2013-08-10','14:15:00',5.15),('11288','2013-08-10','14:20:00',3.75),('11288','2013-08-10','14:25:00',2.26),('11288','2013-08-10','14:30:00',2.11),('11288','2013-08-10','14:35:00',1.87),('11288','2013-08-10','14:40:00',1.73),('11288','2013-08-10','14:45:00',1.69),('11288','2013-08-10','14:50:00',1.57),('11288','2013-08-10','14:55:00',1.58),('11288','2013-08-10','15:00:00',1.78),('11288','2013-08-10','15:05:00',1.86),('11288','2013-08-10','15:10:00',1.97),('11288','2013-08-10','15:15:00',2.14),('11288','2013-08-10','15:20:00',2.14),('11288','2013-08-10','15:25:00',1.92),('11288','2013-08-10','15:30:00',1.88),('11288','2013-08-10','15:35:00',2.33),('11288','2013-08-10','15:40:00',2.25),('11288','2013-08-10','15:45:00',2.57),('11288','2013-08-10','15:50:00',3.47),('11288','2013-08-10','15:55:00',4.11),('11288','2013-08-10','16:00:00',3.9),('11288','2013-08-10','16:05:00',7.25),('11288','2013-08-10','16:10:00',3.97),('11288','2013-08-10','16:15:00',3.68),('11288','2013-08-10','16:20:00',4.17),('11288','2013-08-10','16:25:00',1.93),('11288','2013-08-10','16:30:00',3.54),('11288','2013-08-10','16:35:00',3.79),('11288','2013-08-10','16:40:00',4.23),('11288','2013-08-10','16:45:00',4.76),('11288','2013-08-10','16:50:00',4.44),('11288','2013-08-10','16:55:00',4.14),('11288','2013-08-10','17:00:00',2.86),('11288','2013-08-10','17:05:00',2.68),('11288','2013-08-10','17:10:00',1.65),('11288','2013-08-10','17:15:00',1.95),('11288','2013-08-10','17:20:00',2.15),('11288','2013-08-10','17:25:00',2.68),('11288','2013-08-10','17:30:00',1.97),('11288','2013-08-10','17:55:00',1.33),('11288','2013-08-10','18:00:00',1.1),('11288','2014-04-09','08:00:00',1.35),('11288','2014-04-09','08:05:00',1.57),('11288','2014-04-09','08:10:00',1.42),('11288','2014-04-09','08:15:00',1.34),('11288','2014-04-09','08:20:00',1.55),('11288','2014-04-09','08:25:00',1.29),('11288','2014-04-09','08:30:00',1.51),('11288','2014-04-09','08:50:00',1.03),('11288','2014-04-09','08:55:00',1.61),('11288','2014-04-09','09:00:00',1.69),('11288','2014-04-09','09:05:00',1.54),('11288','2014-04-09','09:10:00',1.54),('11288','2014-04-09','09:15:00',1.52),('11288','2014-04-09','09:20:00',1.53),('11288','2014-04-09','09:25:00',1.7),('11288','2014-04-09','09:30:00',1.73),('11288','2014-04-09','09:35:00',1.48),('11288','2014-04-09','09:40:00',1.34),('11288','2014-04-09','09:45:00',1.39),('11288','2014-04-09','09:50:00',3.5),('11288','2014-04-09','09:55:00',4.27),('11288','2014-04-09','10:00:00',4.44),('11288','2014-04-09','10:05:00',4.48),('11288','2014-04-09','10:10:00',4.64),('11288','2014-04-09','10:15:00',4.12),('11288','2014-04-09','10:20:00',5.14),('11288','2014-04-09','10:25:00',5.55),('11288','2014-04-09','10:30:00',5.8),('11288','2014-04-09','10:35:00',3.46),('11288','2014-04-09','10:40:00',2.15),('11288','2014-04-09','10:45:00',3.17),('11288','2014-04-09','10:50:00',2.12),('11288','2014-04-09','10:55:00',6.1),('11288','2014-04-09','11:00:00',6.5),('11288','2014-04-09','11:05:00',6.58),('11288','2014-04-09','11:10:00',6.68),('11288','2014-04-09','11:15:00',6.9),('11288','2014-04-09','11:20:00',6.23),('11288','2014-04-09','11:25:00',5.19),('11288','2014-04-09','11:30:00',4.53),('11288','2014-04-09','11:35:00',6.87),('11288','2014-04-09','11:40:00',6.99),('11288','2014-04-09','11:45:00',5.72),('11288','2014-04-09','11:50:00',7.06),('11288','2014-04-09','11:55:00',6.99),('11288','2014-04-09','12:00:00',7.31),('11288','2014-04-09','12:05:00',5.49),('11288','2014-04-09','12:10:00',5.86),('11288','2014-04-09','12:15:00',2.95),('11288','2014-04-09','12:20:00',3.96),('11288','2014-04-09','12:25:00',1.98),('11288','2014-04-09','12:30:00',1.67),('11288','2014-04-09','12:35:00',1.61),('11288','2014-04-09','12:40:00',1.54),('11288','2014-04-09','12:45:00',1.16),('11288','2014-04-09','12:50:00',1.04),('11288','2014-04-09','13:10:00',1.13),('11288','2014-04-09','13:15:00',1.83),('11288','2014-04-09','13:20:00',2.3),('11288','2014-04-09','13:25:00',2.23),('11288','2014-04-09','13:30:00',1.86),('11288','2014-04-09','13:35:00',1.87),('11288','2014-04-09','13:40:00',1.59),('11288','2014-04-09','13:45:00',1.48),('11288','2014-04-09','13:50:00',1.49),('11288','2014-04-09','13:55:00',1.5),('11288','2014-04-09','14:00:00',1.91),('11288','2014-04-09','14:05:00',2.45),('11288','2014-04-09','14:10:00',2.54),('11288','2014-04-09','14:15:00',2.43),('11288','2014-04-09','14:20:00',2.16),('11288','2014-04-09','14:25:00',2.26),('11288','2014-04-09','14:30:00',2.47),('11288','2014-04-09','14:35:00',2.46),('11288','2014-04-09','14:40:00',3.39),('11288','2014-04-09','14:45:00',3.51),('11288','2014-04-09','14:50:00',3.64),('11288','2014-04-09','14:55:00',3.4),('11288','2014-04-09','15:00:00',2.95),('11288','2014-04-09','15:05:00',3.16),('11288','2014-04-09','15:10:00',6.66),('11288','2014-04-09','15:15:00',6.53),('11288','2014-04-09','15:20:00',5.13),('11288','2014-04-09','15:25:00',4.8),('11288','2014-04-09','15:30:00',4.19),('11288','2014-04-09','15:35:00',3.44),('11288','2014-04-09','15:40:00',3.02),('11288','2014-04-09','15:45:00',2.63),('11288','2014-04-09','15:50:00',2.24),('11288','2014-04-09','15:55:00',2.09),('11288','2014-04-09','16:00:00',2.82),('11288','2014-04-09','16:05:00',3.9),('11288','2014-04-09','16:10:00',3.96),('11288','2014-04-09','16:15:00',4.91),('11288','2014-04-09','16:20:00',4.67),('11288','2014-04-09','16:25:00',4.54),('11288','2014-04-09','16:30:00',5.08),('11288','2014-04-09','16:35:00',5.27),('11288','2014-04-09','16:40:00',4.29),('11288','2014-04-09','16:45:00',4.78),('11288','2014-04-09','16:50:00',3.48),('11288','2014-04-09','16:55:00',3.51),('11288','2014-04-09','17:00:00',3.72),('11288','2014-04-09','17:05:00',4.22),('11288','2014-04-09','17:10:00',3.39),('11288','2014-04-09','17:15:00',3),('11288','2014-04-09','17:20:00',2.92),('11288','2014-04-09','17:25:00',2.81),('11288','2014-04-09','17:30:00',2.43),('11288','2014-04-09','17:35:00',1.24),('11288','2014-04-09','17:40:00',1.26),('11288','2014-04-09','17:45:00',2.01),('11288','2014-04-09','17:50:00',2.07),('11288','2014-04-09','17:55:00',1.97),('11288','2014-04-09','18:00:00',1.72),('11288','2014-04-09','18:05:00',1.1),('11288','2014-04-09','18:10:00',1.39),('11288','2014-04-09','18:15:00',1.05),('11288','2013-08-09','08:00:00',1.46),('11288','2013-08-09','08:05:00',1.64),('11288','2013-08-09','08:10:00',1.44),('11288','2013-08-09','08:15:00',1.42),('11288','2013-08-09','08:20:00',1.45),('11288','2013-08-09','08:25:00',1.28),('11288','2013-08-09','08:30:00',1.32),('11288','2013-08-09','08:35:00',1.83),('11288','2013-08-09','08:40:00',2.49),('11288','2013-08-09','08:45:00',2.58),('11288','2013-08-09','08:50:00',2.64),('11288','2013-08-09','08:55:00',2.77),('11288','2013-08-09','09:00:00',2.73),('11288','2013-08-09','09:05:00',2.9),('11288','2013-08-09','09:10:00',3.4),('11288','2013-08-09','09:15:00',3.57),('11288','2013-08-09','09:20:00',2.49),('11288','2013-08-09','09:25:00',2.57),('11288','2013-08-09','09:30:00',3.03),('11288','2013-08-09','09:35:00',4.45),('11288','2013-08-09','09:40:00',4.13),('11288','2013-08-09','09:45:00',4),('11288','2013-08-09','09:50:00',3.05),('11288','2013-08-09','09:55:00',2.62),('11288','2013-08-09','10:00:00',3),('11288','2013-08-09','10:05:00',3.26),('11288','2013-08-09','10:10:00',4.08),('11288','2013-08-09','10:15:00',4.4),('11288','2013-08-09','10:20:00',4.37),('11288','2013-08-09','10:25:00',4.4),('11288','2013-08-09','10:30:00',4.52),('11288','2013-08-09','10:35:00',4.29),('11288','2013-08-09','10:40:00',4.14),('11288','2013-08-09','10:45:00',5),('11288','2013-08-09','10:50:00',4.97),('11288','2013-08-09','10:55:00',5.13),('11288','2013-08-09','11:00:00',5.32),('11288','2013-08-09','11:05:00',5.33),('11288','2013-08-09','11:10:00',5.29),('11288','2013-08-09','11:15:00',5.45),('11288','2013-08-09','11:20:00',5.52),('11288','2013-08-09','11:25:00',5.55),('11288','2013-08-09','11:30:00',5.57),('11288','2013-08-09','11:35:00',5.54),('11288','2013-08-09','11:40:00',5.64),('11288','2013-08-09','11:45:00',5.7),('11288','2013-08-09','11:50:00',5.72),('11288','2013-08-09','11:55:00',5.73),('11288','2013-08-09','12:00:00',5.76),('11288','2013-08-09','12:05:00',5.89),('11288','2013-08-09','12:10:00',5.84),('11288','2013-08-09','12:15:00',5.95),('11288','2013-08-09','12:20:00',6.16),('11288','2013-08-09','12:25:00',4.45),('11288','2013-08-09','12:30:00',4.29),('11288','2013-08-09','12:35:00',4.67),('11288','2013-08-09','12:40:00',6.11),('11288','2013-08-09','12:45:00',5.21),('11288','2013-08-09','12:50:00',3.96),('11288','2013-08-09','12:55:00',4.53),('11288','2013-08-09','13:00:00',1.93),('11288','2013-08-09','13:05:00',1.51),('11288','2013-08-09','13:10:00',1.47),('11288','2013-08-09','13:15:00',2.09),('11288','2013-08-09','13:20:00',2.73),('11288','2013-08-09','13:25:00',3.7),('11288','2013-08-09','13:30:00',3.03),('11288','2013-08-09','13:35:00',2.59),('11288','2013-08-09','13:40:00',2.51),('11288','2013-08-09','13:45:00',2.44),('11288','2013-08-09','13:50:00',2.56),('11288','2013-08-09','13:55:00',2.27),('11288','2013-08-09','14:00:00',2.27),('11288','2013-08-09','14:05:00',2.18),('11288','2013-08-09','14:10:00',2.63),('11288','2013-08-09','14:15:00',1.72),('11288','2013-08-09','14:20:00',1.58),('11288','2013-08-09','14:25:00',1.76),('11288','2013-08-09','14:30:00',1.75),('11288','2013-08-09','14:35:00',1.44),('11288','2013-08-09','14:40:00',1.06),('11288','2013-08-09','15:05:00',2.37),('11288','2013-08-09','15:10:00',4.79),('11288','2013-08-09','15:15:00',4.31),('11288','2013-08-09','15:20:00',2.69),('11288','2013-08-09','15:25:00',2.14),('11288','2013-08-09','15:30:00',2.18),('11288','2013-08-09','15:35:00',3.8),('11288','2013-08-09','15:40:00',2.79),('11288','2013-08-09','15:45:00',4.65),('11288','2013-08-09','15:50:00',3.59),('11288','2013-08-09','15:55:00',3.12),('11288','2013-08-09','16:00:00',2.02),('11288','2013-08-09','16:05:00',1.29),('11288','2013-08-09','16:10:00',1.14),('11288','2013-08-09','16:15:00',1.22),('11288','2013-08-09','16:20:00',1.29),('11288','2013-08-09','16:25:00',1.42),('11288','2013-08-09','16:30:00',1.07),('11288','2013-08-09','16:35:00',1.12),('11288','2013-08-09','16:40:00',1.25),('11288','2013-08-09','16:45:00',1.55),('11288','2013-08-09','16:50:00',2.8),('11288','2013-08-09','16:55:00',3.62),('11288','2013-08-09','17:00:00',2.7),('11288','2013-08-09','17:05:00',2.62),('11288','2013-08-09','17:10:00',1.61),('11288','2013-08-09','17:15:00',1.25),('11288','2013-08-09','17:20:00',1.14),('11288','2013-08-09','17:25:00',1.25),('11288','2013-08-09','17:30:00',1.48),('11288','2013-08-09','17:35:00',1.52),('11288','2013-08-09','17:40:00',1.46),('11288','2013-08-09','17:45:00',1.37),('11288','2013-08-09','17:50:00',1.07),('11288','2013-08-09','19:00:00',1.2),('11288','2013-08-09','19:05:00',1.51),('11288','2013-08-09','19:10:00',1.57),('11288','2013-08-09','19:15:00',1.59),('11288','2013-08-09','19:20:00',1.82),('11288','2013-08-09','19:25:00',1.76),('11288','2013-08-08','07:45:00',1.07),('11288','2013-08-08','07:50:00',1.18),('11288','2013-08-08','07:55:00',1.25),('11288','2013-08-08','08:00:00',1.31),('11288','2013-08-08','08:05:00',1.45),('11288','2013-08-08','08:10:00',1.52),('11288','2013-08-08','08:15:00',1.64),('11288','2013-08-08','08:20:00',1.82),('11288','2013-08-08','08:25:00',1.93),('11288','2013-08-08','08:30:00',1.93),('11288','2013-08-08','08:35:00',2.02),('11288','2013-08-08','08:40:00',2.33),('11288','2013-08-08','08:45:00',2.33),('11288','2013-08-08','08:50:00',2.46),('11288','2013-08-08','08:55:00',2.6),('11288','2013-08-08','09:00:00',2.61),('11288','2013-08-08','09:05:00',2.75),('11288','2013-08-08','09:10:00',3.06),('11288','2013-08-08','09:15:00',3.19),('11288','2013-08-08','09:20:00',3.34),('11288','2013-08-08','09:25:00',3.54),('11288','2013-08-08','09:30:00',3.54),('11288','2013-08-08','09:35:00',3.7),('11288','2013-08-08','09:40:00',3.85),('11288','2013-08-08','09:45:00',3.89),('11288','2013-08-08','09:50:00',4.03),('11288','2013-08-08','09:55:00',4.13),('11288','2013-08-08','10:00:00',4.15),('11288','2013-08-08','10:05:00',4.32),('11288','2013-08-08','10:10:00',4.5),('11288','2013-08-08','10:15:00',4.57),('11288','2013-08-08','10:20:00',4.66),('11288','2013-08-08','10:25:00',4.72),('11288','2013-08-08','10:30:00',4.81),('11288','2013-08-08','10:35:00',4.87),('11288','2013-08-08','10:40:00',4.98),('11288','2013-08-08','10:45:00',5.05),('11288','2013-08-08','10:50:00',5.11),('11288','2013-08-08','10:55:00',5.2),('11288','2013-08-08','11:00:00',5.26),('11288','2013-08-08','11:05:00',5.3),('11288','2013-08-08','11:10:00',5.39),('11288','2013-08-08','11:15:00',5.4),('11288','2013-08-08','11:20:00',5.45),('11288','2013-08-08','11:25:00',5.52),('11288','2013-08-08','11:30:00',5.56),('11288','2013-08-08','11:35:00',5.55),('11288','2013-08-08','11:40:00',5.57),('11288','2013-08-08','11:45:00',5.61),('11288','2013-08-08','11:50:00',5.73),('11288','2013-08-08','11:55:00',5.75),('11288','2013-08-08','12:00:00',5.73),('11288','2013-08-08','12:05:00',5.8),('11288','2013-08-08','12:10:00',5.85),('11288','2013-08-08','12:15:00',5.82),('11288','2013-08-08','12:20:00',5.89),('11288','2013-08-08','12:25:00',5.89),('11288','2013-08-08','12:30:00',5.81),('11288','2013-08-08','12:35:00',6.02),('11288','2013-08-08','12:40:00',6.06),('11288','2013-08-08','12:45:00',6.07),('11288','2013-08-08','12:50:00',6.08),('11288','2013-08-08','12:55:00',6.06),('11288','2013-08-08','13:00:00',6.06),('11288','2013-08-08','13:05:00',6.13),('11288','2013-08-08','13:10:00',6.08),('11288','2013-08-08','13:15:00',6.15),('11288','2013-08-08','13:20:00',6.14),('11288','2013-08-08','13:25:00',6.08),('11288','2013-08-08','13:30:00',6.1),('11288','2013-08-08','13:35:00',6.06),('11288','2013-08-08','13:40:00',6.05),('11288','2013-08-08','13:45:00',6.07),('11288','2013-08-08','13:50:00',6.02),('11288','2013-08-08','13:55:00',6.03),('11288','2013-08-08','14:00:00',6.01),('11288','2013-08-08','14:05:00',5.98),('11288','2013-08-08','14:10:00',5.93),('11288','2013-08-08','14:15:00',5.89),('11288','2013-08-08','14:20:00',5.89),('11288','2013-08-08','14:25:00',5.87),('11288','2013-08-08','14:30:00',5.81),('11288','2013-08-08','14:35:00',5.75),('11288','2013-08-08','14:40:00',5.7),('11288','2013-08-08','14:45:00',5.7),('11288','2013-08-08','14:50:00',5.67),('11288','2013-08-08','14:55:00',5.64),('11288','2013-08-08','15:00:00',5.6),('11288','2013-08-08','15:05:00',5.54),('11288','2013-08-08','15:10:00',5.45),('11288','2013-08-08','15:15:00',5.35),('11288','2013-08-08','15:20:00',5.29),('11288','2013-08-08','15:25:00',5.21),('11288','2013-08-08','15:30:00',5.19),('11288','2013-08-08','15:35:00',5.14),('11288','2013-08-08','15:40:00',5.1),('11288','2013-08-08','15:45:00',5),('11288','2013-08-08','15:50:00',4.93),('11288','2013-08-08','15:55:00',4.84),('11288','2013-08-08','16:00:00',4.84),('11288','2013-08-08','16:05:00',4.76),('11288','2013-08-08','16:10:00',4.64),('11288','2013-08-08','16:15:00',4.59),('11288','2013-08-08','16:20:00',4.53),('11288','2013-08-08','16:25:00',4.42),('11288','2013-08-08','16:30:00',4.37),('11288','2013-08-08','16:35:00',4.24),('11288','2013-08-08','16:40:00',4.12),('11288','2013-08-08','16:45:00',4),('11288','2013-08-08','16:50:00',3.84),('11288','2013-08-08','16:55:00',3.74),('11288','2013-08-08','17:00:00',3.64),('11288','2013-08-08','17:05:00',3.5),('11288','2013-08-08','17:10:00',3.39),('11288','2013-08-08','17:15:00',3.25),('11288','2013-08-08','17:20:00',3.13),('11288','2013-08-08','17:25:00',3),('11288','2013-08-08','17:30:00',2.87),('11288','2013-08-08','17:35:00',2.72),('11288','2013-08-08','17:40:00',2.61),('11288','2013-08-08','17:45:00',2.51),('11288','2013-08-08','17:50:00',2.39),('11288','2013-08-08','17:55:00',2.25),('11288','2013-08-08','18:00:00',2.13),('11288','2013-08-08','18:05:00',2.01),('11288','2013-08-08','18:10:00',1.88),('11288','2013-08-08','18:15:00',1.81),('11288','2013-08-08','18:20:00',1.74),('11288','2013-08-08','18:25:00',1.64),('11288','2013-08-08','18:30:00',1.49),('11288','2013-08-08','18:35:00',1.37),('11288','2013-08-08','18:40:00',1.27),('11288','2013-08-08','18:45:00',1.17),('11288','2013-08-08','18:50:00',1.05),('11288','2013-08-07','07:40:00',1.05),('11288','2013-08-07','07:45:00',1.12),('11288','2013-08-07','07:50:00',1.22),('11288','2013-08-07','07:55:00',1.29),('11288','2013-08-07','08:00:00',1.36),('11288','2013-08-07','08:05:00',1.49),('11288','2013-08-07','08:10:00',1.53),('11288','2013-08-07','08:15:00',1.69),('11288','2013-08-07','08:20:00',1.85),('11288','2013-08-07','08:25:00',1.95),('11288','2013-08-07','08:30:00',1.98),('11288','2013-08-07','08:35:00',2.18),('11288','2013-08-07','08:40:00',2.39),('11288','2013-08-07','08:45:00',2.37),('11288','2013-08-07','08:50:00',2.52),('11288','2013-08-07','08:55:00',2.59),('11288','2013-08-07','09:00:00',2.62),('11288','2013-08-07','09:05:00',2.85),('11288','2013-08-07','09:10:00',3.1),('11288','2013-08-07','09:15:00',3.21),('11288','2013-08-07','09:20:00',3.4),('11288','2013-08-07','09:25:00',3.57),('11288','2013-08-07','09:30:00',3.64),('11288','2013-08-07','09:35:00',3.74),('11288','2013-08-07','09:40:00',3.9),('11288','2013-08-07','09:45:00',3.92),('11288','2013-08-07','09:50:00',4.13),('11288','2013-08-07','09:55:00',4.25),('11288','2013-08-07','10:00:00',4.21),('11288','2013-08-07','10:05:00',4.4),('11288','2013-08-07','10:10:00',4.6),('11288','2013-08-07','10:15:00',4.64),('11288','2013-08-07','10:20:00',4.7),('11288','2013-08-07','10:25:00',4.75),('11288','2013-08-07','10:30:00',4.9),('11288','2013-08-07','10:35:00',4.93),('11288','2013-08-07','10:40:00',5.03),('11288','2013-08-07','10:45:00',5.12),('11288','2013-08-07','10:50:00',5.19),('11288','2013-08-07','10:55:00',5.27),('11288','2013-08-07','11:00:00',5.32),('11288','2013-08-07','11:05:00',5.37),('11288','2013-08-07','11:10:00',5.47),('11288','2013-08-07','11:15:00',5.53),('11288','2013-08-07','11:20:00',5.59),('11288','2013-08-07','11:25:00',5.59),('11288','2013-08-07','11:30:00',5.63),('11288','2013-08-07','11:35:00',5.66),('11288','2013-08-07','11:40:00',5.67),('11288','2013-08-07','11:45:00',5.72),('11288','2013-08-07','11:50:00',5.78),('11288','2013-08-07','11:55:00',5.79),('11288','2013-08-07','12:00:00',5.85),('11288','2013-08-07','12:05:00',5.88),('11288','2013-08-07','12:10:00',5.87),('11288','2013-08-07','12:15:00',5.84),('11288','2013-08-07','12:20:00',5.82),('11288','2013-08-07','12:25:00',5.83),('11288','2013-08-07','12:30:00',5.88),('11288','2013-08-07','12:35:00',5.97),('11288','2013-08-07','12:40:00',5.95),('11288','2013-08-07','12:45:00',6.03),('11288','2013-08-07','12:50:00',6.03),('11288','2013-08-07','12:55:00',6.02),('11288','2013-08-07','13:00:00',6.1),('11288','2013-08-07','13:05:00',6.09),('11288','2013-08-07','13:10:00',5.93),('11288','2013-08-07','13:15:00',6.2),('11288','2013-08-07','13:20:00',5.96),('11288','2013-08-07','13:25:00',6.02),('11288','2013-08-07','13:30:00',6.06),('11288','2013-08-07','13:35:00',6.11),('11288','2013-08-07','13:40:00',6.13),('11288','2013-08-07','13:45:00',6.13),('11288','2013-08-07','13:50:00',6.09),('11288','2013-08-07','13:55:00',6.09),('11288','2013-08-07','14:00:00',6.13),('11288','2013-08-07','14:05:00',6),('11288','2013-08-07','14:10:00',5.95),('11288','2013-08-07','14:15:00',5.89),('11288','2013-08-07','14:20:00',5.86),('11288','2013-08-07','14:25:00',5.76),('11288','2013-08-07','14:30:00',5.72),('11288','2013-08-07','14:35:00',5.71),('11288','2013-08-07','14:40:00',5.69),('11288','2013-08-07','14:45:00',5.66),('11288','2013-08-07','14:50:00',5.7),('11288','2013-08-07','14:55:00',5.62),('11288','2013-08-07','15:00:00',5.63),('11288','2013-08-07','15:05:00',5.58),('11288','2013-08-07','15:10:00',5.52),('11288','2013-08-07','15:15:00',5.4),('11288','2013-08-07','15:20:00',5.41),('11288','2013-08-07','15:25:00',5.34),('11288','2013-08-07','15:30:00',5.26),('11288','2013-08-07','15:35:00',5.26),('11288','2013-08-07','15:40:00',5.21),('11288','2013-08-07','15:45:00',5.16),('11288','2013-08-07','15:50:00',5.07),('11288','2013-08-07','15:55:00',4.97),('11288','2013-08-07','16:00:00',4.86),('11288','2013-08-07','16:05:00',4.76),('11288','2013-08-07','16:10:00',4.58),('11288','2013-08-07','16:15:00',4.53),('11288','2013-08-07','16:20:00',4.45),('11288','2013-08-07','16:25:00',4.44),('11288','2013-08-07','16:30:00',4.34),('11288','2013-08-07','16:35:00',4.26),('11288','2013-08-07','16:40:00',4.14),('11288','2013-08-07','16:45:00',4.09),('11288','2013-08-07','16:50:00',3.95),('11288','2013-08-07','16:55:00',3.87),('11288','2013-08-07','17:00:00',3.77),('11288','2013-08-07','17:05:00',3.65),('11288','2013-08-07','17:10:00',3.54),('11288','2013-08-07','17:15:00',3.4),('11288','2013-08-07','17:20:00',3.28),('11288','2013-08-07','17:25:00',3.08),('11288','2013-08-07','17:30:00',2.97),('11288','2013-08-07','17:35:00',2.84),('11288','2013-08-07','17:40:00',2.71),('11288','2013-08-07','17:45:00',2.59),('11288','2013-08-07','17:50:00',2.45),('11288','2013-08-07','17:55:00',2.29),('11288','2013-08-07','18:00:00',2.18),('11288','2013-08-07','18:05:00',1.99),('11288','2013-08-07','18:10:00',1.86),('11288','2013-08-07','18:15:00',1.84),('11288','2013-08-07','18:20:00',1.76),('11288','2013-08-07','18:25:00',1.66),('11288','2013-08-07','18:30:00',1.56),('11288','2013-08-07','18:35:00',1.43),('11288','2013-08-07','18:40:00',1.34),('11288','2013-08-07','18:45:00',1.24),('11288','2013-08-07','18:50:00',1.14),('11288','2013-08-06','07:40:00',1.02),('11288','2013-08-06','07:45:00',1.1),('11288','2013-08-06','07:50:00',1.21),('11288','2013-08-06','07:55:00',1.27),('11288','2013-08-06','08:00:00',1.37),('11288','2013-08-06','08:05:00',1.49),('11288','2013-08-06','08:10:00',1.58),('11288','2013-08-06','08:15:00',1.67),('11288','2013-08-06','08:20:00',1.82),('11288','2013-08-06','08:25:00',1.93),('11288','2013-08-06','08:30:00',1.95),('11288','2013-08-06','08:35:00',2.11),('11288','2013-08-06','08:40:00',2.38),('11288','2013-08-06','08:45:00',2.38),('11288','2013-08-06','08:50:00',2.51),('11288','2013-08-06','08:55:00',2.65),('11288','2013-08-06','09:00:00',2.76),('11288','2013-08-06','09:05:00',2.86),('11288','2013-08-06','09:10:00',3.11),('11288','2013-08-06','09:15:00',3.21),('11288','2013-08-06','09:20:00',3.41),('11288','2013-08-06','09:25:00',3.54),('11288','2013-08-06','09:30:00',3.65),('11288','2013-08-06','09:35:00',3.73),('11288','2013-08-06','09:40:00',3.89),('11288','2013-08-06','09:45:00',4.03),('11288','2013-08-06','09:50:00',4.06),('11288','2013-08-06','09:55:00',4.19),('11288','2013-08-06','10:00:00',4.21),('11288','2013-08-06','10:05:00',4.33),('11288','2013-08-06','10:10:00',4.53),('11288','2013-08-06','10:15:00',4.62),('11288','2013-08-06','10:20:00',4.58),('11288','2013-08-06','10:25:00',4.75),('11288','2013-08-06','10:30:00',4.87),('11288','2013-08-06','10:35:00',4.89),('11288','2013-08-06','10:40:00',5.02),('11288','2013-08-06','10:45:00',5.09),('11288','2013-08-06','10:50:00',5.1),('11288','2013-08-06','10:55:00',5.22),('11288','2013-08-06','11:00:00',5.3),('11288','2013-08-06','11:05:00',5.35),('11288','2013-08-06','11:10:00',5.44),('11288','2013-08-06','11:15:00',5.51),('11288','2013-08-06','11:20:00',5.54),('11288','2013-08-06','11:25:00',5.61),('11288','2013-08-06','11:30:00',5.63),('11288','2013-08-06','11:35:00',5.67),('11288','2013-08-06','11:40:00',5.69),('11288','2013-08-06','11:45:00',5.7),('11288','2013-08-06','11:50:00',5.73),('11288','2013-08-06','11:55:00',5.79),('11288','2013-08-06','12:00:00',5.86),('11288','2013-08-06','12:05:00',5.89),('11288','2013-08-06','12:10:00',5.91),('11288','2013-08-06','12:15:00',5.91),('11288','2013-08-06','12:20:00',5.89),('11288','2013-08-06','12:25:00',5.87),('11288','2013-08-06','12:30:00',5.9),('11288','2013-08-06','12:35:00',5.88),('11288','2013-08-06','12:40:00',5.96),('11288','2013-08-06','12:45:00',6.01),('11288','2013-08-06','12:50:00',6),('11288','2013-08-06','12:55:00',5.92),('11288','2013-08-06','13:00:00',6),('11288','2013-08-06','13:05:00',6.05),('11288','2013-08-06','13:10:00',6.1),('11288','2013-08-06','13:15:00',6.1),('11288','2013-08-06','13:20:00',6.15),('11288','2013-08-06','13:25:00',6.07),('11288','2013-08-06','13:30:00',6.13),('11288','2013-08-06','13:35:00',6.19),('11288','2013-08-06','13:40:00',6.21),('11288','2013-08-06','13:45:00',6.17),('11288','2013-08-06','13:50:00',6.19),('11288','2013-08-06','13:55:00',6.21),('11288','2013-08-06','14:00:00',6.19),('11288','2013-08-06','14:05:00',6.17),('11288','2013-08-06','14:10:00',6.15),('11288','2013-08-06','14:15:00',6.15),('11288','2013-08-06','14:20:00',6.13),('11288','2013-08-06','14:25:00',6.12),('11288','2013-08-06','14:30:00',6.08),('11288','2013-08-06','14:35:00',6.06),('11288','2013-08-06','14:40:00',5.99),('11288','2013-08-06','14:45:00',5.94),('11288','2013-08-06','14:50:00',5.93),('11288','2013-08-06','14:55:00',5.88),('11288','2013-08-06','15:00:00',5.86),('11288','2013-08-06','15:05:00',5.83),('11288','2013-08-06','15:10:00',5.79),('11288','2013-08-06','15:15:00',5.76),('11288','2013-08-06','15:20:00',5.68),('11288','2013-08-06','15:25:00',5.63),('11288','2013-08-06','15:30:00',5.57),('11288','2013-08-06','15:35:00',5.49),('11288','2013-08-06','15:40:00',5.42),('11288','2013-08-06','15:45:00',5.34),('11288','2013-08-06','15:50:00',5.25),('11288','2013-08-06','15:55:00',5.19),('11288','2013-08-06','16:00:00',5.11),('11288','2013-08-06','16:05:00',5.01),('11288','2013-08-06','16:10:00',4.9),('11288','2013-08-06','16:15:00',4.8),('11288','2013-08-06','16:20:00',4.7),('11288','2013-08-06','16:25:00',4.62),('11288','2013-08-06','16:30:00',4.5),('11288','2013-08-06','16:35:00',4.36),('11288','2013-08-06','16:40:00',4.26),('11288','2013-08-06','16:45:00',4.16),('11288','2013-08-06','16:50:00',4.07),('11288','2013-08-06','16:55:00',3.93),('11288','2013-08-06','17:00:00',3.84),('11288','2013-08-06','17:05:00',3.75),('11288','2013-08-06','17:10:00',3.62),('11288','2013-08-06','17:15:00',3.48),('11288','2013-08-06','17:20:00',3.33),('11288','2013-08-06','17:25:00',3.18),('11288','2013-08-06','17:30:00',3.07),('11288','2013-08-06','17:35:00',2.94),('11288','2013-08-06','17:40:00',2.8),('11288','2013-08-06','17:45:00',2.67),('11288','2013-08-06','17:50:00',2.52),('11288','2013-08-06','17:55:00',2.36),('11288','2013-08-06','18:00:00',2.26),('11288','2013-08-06','18:05:00',2.14),('11288','2013-08-06','18:10:00',2.02),('11288','2013-08-06','18:15:00',1.98),('11288','2013-08-06','18:20:00',1.89),('11288','2013-08-06','18:25:00',1.76),('11288','2013-08-06','18:30:00',1.64),('11288','2013-08-06','18:35:00',1.54),('11288','2013-08-06','18:40:00',1.39),('11288','2013-08-06','18:45:00',1.26),('11288','2013-08-06','18:50:00',1.12),('11288','2013-08-05','07:40:00',1.09),('11288','2013-08-05','07:45:00',1.2),('11288','2013-08-05','07:50:00',1.3),('11288','2013-08-05','07:55:00',1.35),('11288','2013-08-05','08:00:00',1.46),('11288','2013-08-05','08:05:00',1.6),('11288','2013-08-05','08:10:00',1.67),('11288','2013-08-05','08:15:00',1.72),('11288','2013-08-05','08:20:00',1.93),('11288','2013-08-05','08:25:00',1.99),('11288','2013-08-05','08:30:00',1.99),('11288','2013-08-05','08:35:00',2.27),('11288','2013-08-05','08:40:00',2.44),('11288','2013-08-05','08:45:00',2.53),('11288','2013-08-05','08:50:00',2.65),('11288','2013-08-05','08:55:00',2.69),('11288','2013-08-05','09:00:00',2.8),('11288','2013-08-05','09:05:00',2.97),('11288','2013-08-05','09:10:00',2.98),('11288','2013-08-05','09:15:00',3.28),('11288','2013-08-05','09:20:00',3.47),('11288','2013-08-05','09:25:00',3.48),('11288','2013-08-05','09:30:00',3.63),('11288','2013-08-05','09:35:00',3.79),('11288','2013-08-05','09:40:00',3.93),('11288','2013-08-05','09:45:00',4.04),('11288','2013-08-05','09:50:00',4.08),('11288','2013-08-05','09:55:00',4.18),('11288','2013-08-05','10:00:00',4.29),('11288','2013-08-05','10:05:00',4.43),('11288','2013-08-05','10:10:00',4.6),('11288','2013-08-05','10:15:00',4.72),('11288','2013-08-05','10:20:00',4.78),('11288','2013-08-05','10:25:00',4.84),('11288','2013-08-05','10:30:00',4.93),('11288','2013-08-05','10:35:00',4.95),('11288','2013-08-05','10:40:00',5.1),('11288','2013-08-05','10:45:00',5.2),('11288','2013-08-05','10:50:00',5.28),('11288','2013-08-05','10:55:00',5.37),('11288','2013-08-05','11:00:00',5.42),('11288','2013-08-05','11:05:00',5.49),('11288','2013-08-05','11:10:00',5.55),('11288','2013-08-05','11:15:00',5.63),('11288','2013-08-05','11:20:00',5.63),('11288','2013-08-05','11:25:00',5.71),('11288','2013-08-05','11:30:00',5.76),('11288','2013-08-05','11:35:00',5.82),('11288','2013-08-05','11:40:00',5.83),('11288','2013-08-05','11:45:00',5.84),('11288','2013-08-05','11:50:00',5.9),('11288','2013-08-05','11:55:00',5.97),('11288','2013-08-05','12:00:00',6.02),('11288','2013-08-05','12:05:00',6.06),('11288','2013-08-05','12:10:00',6.07),('11288','2013-08-05','12:15:00',6.11),('11288','2013-08-05','12:20:00',6.05),('11288','2013-08-05','12:25:00',6.12),('11288','2013-08-05','12:30:00',6.14),('11288','2013-08-05','12:35:00',6.14),('11288','2013-08-05','12:40:00',6.16),('11288','2013-08-05','12:45:00',6.2),('11288','2013-08-05','12:50:00',6.16),('11288','2013-08-05','12:55:00',6.15),('11288','2013-08-05','13:00:00',6.17),('11288','2013-08-05','13:05:00',6.16),('11288','2013-08-05','13:10:00',6.15),('11288','2013-08-05','13:15:00',6.14),('11288','2013-08-05','13:20:00',6.15),('11288','2013-08-05','13:25:00',6.17),('11288','2013-08-05','13:30:00',6.13),('11288','2013-08-05','13:35:00',6.14),('11288','2013-08-05','13:40:00',6.1),('11288','2013-08-05','13:45:00',6),('11288','2013-08-05','13:50:00',6.08),('11288','2013-08-05','13:55:00',6.07),('11288','2013-08-05','14:00:00',6.12),('11288','2013-08-05','14:05:00',6.02),('11288','2013-08-05','14:10:00',5.98),('11288','2013-08-05','14:15:00',5.98),('11288','2013-08-05','14:20:00',5.93),('11288','2013-08-05','14:25:00',5.91),('11288','2013-08-05','14:30:00',5.93),('11288','2013-08-05','14:35:00',5.86),('11288','2013-08-05','14:40:00',5.86),('11288','2013-08-05','14:45:00',5.83),('11288','2013-08-05','14:50:00',5.76),('11288','2013-08-05','14:55:00',5.73),('11288','2013-08-05','15:00:00',5.71),('11288','2013-08-05','15:05:00',5.66),('11288','2013-08-05','15:10:00',5.63),('11288','2013-08-05','15:15:00',5.59),('11288','2013-08-05','15:20:00',5.56),('11288','2013-08-05','15:25:00',5.53),('11288','2013-08-05','15:30:00',5.47),('11288','2013-08-05','15:35:00',5.41),('11288','2013-08-05','15:40:00',5.36),('11288','2013-08-05','15:45:00',5.3),('11288','2013-08-05','15:50:00',5.23),('11288','2013-08-05','15:55:00',5.16),('11288','2013-08-05','16:00:00',5.08),('11288','2013-08-05','16:05:00',5.03),('11288','2013-08-05','16:10:00',4.93),('11288','2013-08-05','16:15:00',4.78),('11288','2013-08-05','16:20:00',4.66),('11288','2013-08-05','16:25:00',4.57),('11288','2013-08-05','16:30:00',4.48),('11288','2013-08-05','16:35:00',4.38),('11288','2013-08-05','16:40:00',4.28),('11288','2013-08-05','16:45:00',4.17),('11288','2013-08-05','16:50:00',4.02),('11288','2013-08-05','16:55:00',3.92),('11288','2013-08-05','17:00:00',3.8),('11288','2013-08-05','17:05:00',3.71),('11288','2013-08-05','17:10:00',3.6),('11288','2013-08-05','17:15:00',3.43),('11288','2013-08-05','17:20:00',3.28),('11288','2013-08-05','17:25:00',3.17),('11288','2013-08-05','17:30:00',3.03),('11288','2013-08-05','17:35:00',2.93),('11288','2013-08-05','17:40:00',2.8),('11288','2013-08-05','17:45:00',2.67),('11288','2013-08-05','17:50:00',2.5),('11288','2013-08-05','17:55:00',2.37),('11288','2013-08-05','18:00:00',2.24),('11288','2013-08-05','18:05:00',2.09),('11288','2013-08-05','18:10:00',1.99),('11288','2013-08-05','18:15:00',1.94),('11288','2013-08-05','18:20:00',1.85),('11288','2013-08-05','18:25:00',1.73),('11288','2013-08-05','18:30:00',1.59),('11288','2013-08-05','18:35:00',1.48),('11288','2013-08-05','18:40:00',1.36),('11288','2013-08-05','18:45:00',1.26),('11288','2013-08-05','18:50:00',1.15),('11288','2013-08-05','18:55:00',1.02),('11288','2013-08-04','07:40:00',1.01),('11288','2013-08-04','07:45:00',1.11),('11288','2013-08-04','07:50:00',1.21),('11288','2013-08-04','07:55:00',1.33),('11288','2013-08-04','08:00:00',1.41),('11288','2013-08-04','08:05:00',1.56),('11288','2013-08-04','08:10:00',1.6),('11288','2013-08-04','08:15:00',1.65),('11288','2013-08-04','08:20:00',1.94),('11288','2013-08-04','08:25:00',1.85),('11288','2013-08-04','08:30:00',1.87),('11288','2013-08-04','08:35:00',2.41),('11288','2013-08-04','08:40:00',2.46),('11288','2013-08-04','08:45:00',2.59),('11288','2013-08-04','08:50:00',2.68),('11288','2013-08-04','08:55:00',2.76),('11288','2013-08-04','09:00:00',2.86),('11288','2013-08-04','09:05:00',3.19),('11288','2013-08-04','09:10:00',3.22),('11288','2013-08-04','09:15:00',3.4),('11288','2013-08-04','09:20:00',3.65),('11288','2013-08-04','09:25:00',3.58),('11288','2013-08-04','09:30:00',3.72),('11288','2013-08-04','09:35:00',3.99),('11288','2013-08-04','09:40:00',4.15),('11288','2013-08-04','09:45:00',4.2),('11288','2013-08-04','09:50:00',4.31),('11288','2013-08-04','09:55:00',4.3),('11288','2013-08-04','10:00:00',4.43),('11288','2013-08-04','10:05:00',4.73),('11288','2013-08-04','10:10:00',4.82),('11288','2013-08-04','10:15:00',4.94),('11288','2013-08-04','10:20:00',5.01),('11288','2013-08-04','10:25:00',5.09),('11288','2013-08-04','10:30:00',5.16),('11288','2013-08-04','10:35:00',5.22),('11288','2013-08-04','10:40:00',5.31),('11288','2013-08-04','10:45:00',5.37),('11288','2013-08-04','10:50:00',5.43),('11288','2013-08-04','10:55:00',5.5),('11288','2013-08-04','11:00:00',5.56),('11288','2013-08-04','11:05:00',5.59),('11288','2013-08-04','11:10:00',5.65),('11288','2013-08-04','11:15:00',5.74),('11288','2013-08-04','11:20:00',5.8),('11288','2013-08-04','11:25:00',5.86),('11288','2013-08-04','11:30:00',5.98),('11288','2013-08-04','11:35:00',5.99),('11288','2013-08-04','11:40:00',6.03),('11288','2013-08-04','11:45:00',6.08),('11288','2013-08-04','11:50:00',6.16),('11288','2013-08-04','11:55:00',6.21),('11288','2013-08-04','12:00:00',6.25),('11288','2013-08-04','12:05:00',6.23),('11288','2013-08-04','12:10:00',6.29),('11288','2013-08-04','12:15:00',6.29),('11288','2013-08-04','12:20:00',6.26),('11288','2013-08-04','12:25:00',6.28),('11288','2013-08-04','12:30:00',6.32),('11288','2013-08-04','12:35:00',6.31),('11288','2013-08-04','12:40:00',6.36),('11288','2013-08-04','12:45:00',6.35),('11288','2013-08-04','12:50:00',6.36),('11288','2013-08-04','12:55:00',6.34),('11288','2013-08-04','13:00:00',6.34),('11288','2013-08-04','13:05:00',6.35),('11288','2013-08-04','13:10:00',6.35),('11288','2013-08-04','13:15:00',6.32),('11288','2013-08-04','13:20:00',6.34),('11288','2013-08-04','13:25:00',6.3),('11288','2013-08-04','13:30:00',6.35),('11288','2013-08-04','13:35:00',6.34),('11288','2013-08-04','13:40:00',6.35),('11288','2013-08-04','13:45:00',6.4),('11288','2013-08-04','13:50:00',6.32),('11288','2013-08-04','13:55:00',6.39),('11288','2013-08-04','14:00:00',6.4),('11288','2013-08-04','14:05:00',6.35),('11288','2013-08-04','14:10:00',6.34),('11288','2013-08-04','14:15:00',6.28),('11288','2013-08-04','14:20:00',6.24),('11288','2013-08-04','14:25:00',6.27),('11288','2013-08-04','14:30:00',6.17),('11288','2013-08-04','14:35:00',6.15),('11288','2013-08-04','14:40:00',6.16),('11288','2013-08-04','14:45:00',6.08),('11288','2013-08-04','14:50:00',6.03),('11288','2013-08-04','14:55:00',5.99),('11288','2013-08-04','15:00:00',5.94),('11288','2013-08-04','15:05:00',5.91),('11288','2013-08-04','15:10:00',5.86),('11288','2013-08-04','15:15:00',5.79),('11288','2013-08-04','15:20:00',5.72),('11288','2013-08-04','15:25:00',5.67),('11288','2013-08-04','15:30:00',5.56),('11288','2013-08-04','15:35:00',5.59),('11288','2013-08-04','15:40:00',5.52),('11288','2013-08-04','15:45:00',5.4),('11288','2013-08-04','15:50:00',5.28),('11288','2013-08-04','15:55:00',5.26),('11288','2013-08-04','16:00:00',5.14),('11288','2013-08-04','16:05:00',5.14),('11288','2013-08-04','16:10:00',5.02),('11288','2013-08-04','16:15:00',4.91),('11288','2013-08-04','16:20:00',4.79),('11288','2013-08-04','16:25:00',4.76),('11288','2013-08-04','16:30:00',4.66),('11288','2013-08-04','16:35:00',4.54),('11288','2013-08-04','16:40:00',4.43),('11288','2013-08-04','16:45:00',4.33),('11288','2013-08-04','16:50:00',4.18),('11288','2013-08-04','16:55:00',4.06),('11288','2013-08-04','17:00:00',3.99),('11288','2013-08-04','17:05:00',3.87),('11288','2013-08-04','17:10:00',3.75),('11288','2013-08-04','17:15:00',3.58),('11288','2013-08-04','17:20:00',3.41),('11288','2013-08-04','17:25:00',3.31),('11288','2013-08-04','17:30:00',3.16),('11288','2013-08-04','17:35:00',3.04),('11288','2013-08-04','17:40:00',2.9),('11288','2013-08-04','17:45:00',2.75),('11288','2013-08-04','17:50:00',2.62),('11288','2013-08-04','17:55:00',2.47),('11288','2013-08-04','18:00:00',2.35),('11288','2013-08-04','18:05:00',2.18),('11288','2013-08-04','18:10:00',2.07),('11288','2013-08-04','18:15:00',2.03),('11288','2013-08-04','18:20:00',1.96),('11288','2013-08-04','18:25:00',1.81),('11288','2013-08-04','18:30:00',1.66),('11288','2013-08-04','18:35:00',1.54),('11288','2013-08-04','18:40:00',1.4),('11288','2013-08-04','18:45:00',1.24),('11288','2013-08-04','18:50:00',1.15),('11288','2013-08-04','18:55:00',1.04),('11288','2013-08-03','07:40:00',1.02),('11288','2013-08-03','07:45:00',1.16),('11288','2013-08-03','07:50:00',1.22),('11288','2013-08-03','07:55:00',1.33),('11288','2013-08-03','08:00:00',1.43),('11288','2013-08-03','08:05:00',1.51),('11288','2013-08-03','08:10:00',1.57),('11288','2013-08-03','08:15:00',1.66),('11288','2013-08-03','08:20:00',1.85),('11288','2013-08-03','08:25:00',1.87),('11288','2013-08-03','08:30:00',2),('11288','2013-08-03','08:35:00',2.45),('11288','2013-08-03','08:40:00',2.48),('11288','2013-08-03','08:45:00',2.62),('11288','2013-08-03','08:50:00',2.6),('11288','2013-08-03','08:55:00',2.77),('11288','2013-08-03','09:00:00',2.97),('11288','2013-08-03','09:05:00',3.1),('11288','2013-08-03','09:10:00',2.93),('11288','2013-08-03','09:15:00',3.37),('11288','2013-08-03','09:20:00',3.61),('11288','2013-08-03','09:25:00',3.61),('11288','2013-08-03','09:30:00',3.67),('11288','2013-08-03','09:35:00',3.93),('11288','2013-08-03','09:40:00',4.07),('11288','2013-08-03','09:45:00',4.08),('11288','2013-08-03','09:50:00',4.36),('11288','2013-08-03','09:55:00',4.47),('11288','2013-08-03','10:00:00',4.59),('11288','2013-08-03','10:05:00',4.68),('11288','2013-08-03','10:10:00',4.77),('11288','2013-08-03','10:15:00',4.91),('11288','2013-08-03','10:20:00',5.02),('11288','2013-08-03','10:25:00',5.12),('11288','2013-08-03','10:30:00',5.15),('11288','2013-08-03','10:35:00',5.18),('11288','2013-08-03','10:40:00',5.31),('11288','2013-08-03','10:45:00',5.39),('11288','2013-08-03','10:50:00',5.45),('11288','2013-08-03','10:55:00',5.57),('11288','2013-08-03','11:00:00',5.59),('11288','2013-08-03','11:05:00',5.66),('11288','2013-08-03','11:10:00',5.77),('11288','2013-08-03','11:15:00',5.8),('11288','2013-08-03','11:20:00',5.82),('11288','2013-08-03','11:25:00',5.9),('11288','2013-08-03','11:30:00',5.91),('11288','2013-08-03','11:35:00',5.97),('11288','2013-08-03','11:40:00',6.02),('11288','2013-08-03','11:45:00',6.04),('11288','2013-08-03','11:50:00',6.05),('11288','2013-08-03','11:55:00',6.06),('11288','2013-08-03','12:00:00',6.09),('11288','2013-08-03','12:05:00',6.13),('11288','2013-08-03','12:10:00',6.06),('11288','2013-08-03','12:15:00',6.11),('11288','2013-08-03','12:20:00',6.19),('11288','2013-08-03','12:25:00',6.17),('11288','2013-08-03','12:30:00',6.23),('11288','2013-08-03','12:35:00',6.19),('11288','2013-08-03','12:40:00',6.16),('11288','2013-08-03','12:45:00',6.18),('11288','2013-08-03','12:50:00',6.12),('11288','2013-08-03','12:55:00',6.13),('11288','2013-08-03','13:00:00',6.17),('11288','2013-08-03','13:05:00',6.2),('11288','2013-08-03','13:10:00',6.21),('11288','2013-08-03','13:15:00',6.15),('11288','2013-08-03','13:20:00',6.12),('11288','2013-08-03','13:25:00',6.11),('11288','2013-08-03','13:30:00',6.11),('11288','2013-08-03','13:35:00',6.22),('11288','2013-08-03','13:40:00',6.23),('11288','2013-08-03','13:45:00',6.18),('11288','2013-08-03','13:50:00',6.18),('11288','2013-08-03','13:55:00',6.12),('11288','2013-08-03','14:00:00',6.11),('11288','2013-08-03','14:05:00',6.06),('11288','2013-08-03','14:10:00',5.98),('11288','2013-08-03','14:15:00',5.93),('11288','2013-08-03','14:20:00',6.01),('11288','2013-08-03','14:25:00',6.06),('11288','2013-08-03','14:30:00',6.07),('11288','2013-08-03','14:35:00',6.12),('11288','2013-08-03','14:40:00',6.12),('11288','2013-08-03','14:45:00',6.08),('11288','2013-08-03','14:50:00',6.01),('11288','2013-08-03','14:55:00',5.96),('11288','2013-08-03','15:00:00',5.95),('11288','2013-08-03','15:05:00',5.89),('11288','2013-08-03','15:10:00',5.87),('11288','2013-08-03','15:15:00',5.81),('11288','2013-08-03','15:20:00',5.69),('11288','2013-08-03','15:25:00',5.68),('11288','2013-08-03','15:30:00',5.62),('11288','2013-08-03','15:35:00',5.56),('11288','2013-08-03','15:40:00',5.47),('11288','2013-08-03','15:45:00',5.43),('11288','2013-08-03','15:50:00',5.39),('11288','2013-08-03','15:55:00',5.29),('11288','2013-08-03','16:00:00',5.2),('11288','2013-08-03','16:05:00',5.07),('11288','2013-08-03','16:10:00',4.96),('11288','2013-08-03','16:15:00',4.81),('11288','2013-08-03','16:20:00',4.71),('11288','2013-08-03','16:25:00',4.64),('11288','2013-08-03','16:30:00',4.58),('11288','2013-08-03','16:35:00',4.44),('11288','2013-08-03','16:40:00',4.35),('11288','2013-08-03','16:45:00',4.23),('11288','2013-08-03','16:50:00',4.16),('11288','2013-08-03','16:55:00',3.69),('11288','2013-08-03','17:00:00',3.77),('11288','2013-08-03','17:05:00',3.8),('11288','2013-08-03','17:10:00',3.73),('11288','2013-08-03','17:15:00',3.54),('11288','2013-08-03','17:20:00',3.38),('11288','2013-08-03','17:25:00',3.3),('11288','2013-08-03','17:30:00',3.17),('11288','2013-08-03','17:35:00',3.05),('11288','2013-08-03','17:40:00',2.91),('11288','2013-08-03','17:45:00',2.75),('11288','2013-08-03','17:50:00',2.62),('11288','2013-08-03','17:55:00',2.49),('11288','2013-08-03','18:00:00',2.38),('11288','2013-08-03','18:05:00',2.24),('11288','2013-08-03','18:10:00',2.13),('11288','2013-08-03','18:15:00',2.12),('11288','2013-08-03','18:20:00',2.01),('11288','2013-08-03','18:25:00',1.87),('11288','2013-08-03','18:30:00',1.75),('11288','2013-08-03','18:35:00',1.63),('11288','2013-08-03','18:40:00',1.5),('11288','2013-08-03','18:45:00',1.37),('11288','2013-08-03','18:50:00',1.24),('11288','2013-08-03','18:55:00',1.13),('11288','2013-08-02','07:40:00',1.07),('11288','2013-08-02','07:45:00',1.15),('11288','2013-08-02','07:50:00',1.27),('11288','2013-08-02','07:55:00',1.42),('11288','2013-08-02','08:00:00',1.55),('11288','2013-08-02','08:05:00',1.62),('11288','2013-08-02','08:10:00',1.6),('11288','2013-08-02','08:15:00',1.72),('11288','2013-08-02','08:20:00',1.95),('11288','2013-08-02','08:25:00',1.91),('11288','2013-08-02','08:30:00',2.25),('11288','2013-08-02','08:35:00',2.51),('11288','2013-08-02','08:40:00',2.58),('11288','2013-08-02','08:45:00',2.72),('11288','2013-08-02','08:50:00',2.74),('11288','2013-08-02','08:55:00',2.89),('11288','2013-08-02','09:00:00',3.1),('11288','2013-08-02','09:05:00',3.15),('11288','2013-08-02','09:10:00',3.14),('11288','2013-08-02','09:15:00',3.52),('11288','2013-08-02','09:20:00',3.76),('11288','2013-08-02','09:25:00',3.8),('11288','2013-08-02','09:30:00',3.86),('11288','2013-08-02','09:35:00',4.06),('11288','2013-08-02','09:40:00',4.11),('11288','2013-08-02','09:45:00',4.2),('11288','2013-08-02','09:50:00',4.41),('11288','2013-08-02','09:55:00',4.36),('11288','2013-08-02','10:00:00',4.49),('11288','2013-08-02','10:05:00',4.82),('11288','2013-08-02','10:10:00',4.91),('11288','2013-08-02','10:15:00',5.03),('11288','2013-08-02','10:20:00',5.08),('11288','2013-08-02','10:25:00',5.2),('11288','2013-08-02','10:30:00',5.3),('11288','2013-08-02','10:35:00',5.32),('11288','2013-08-02','10:40:00',5.42),('11288','2013-08-02','10:45:00',5.52),('11288','2013-08-02','10:50:00',5.59),('11288','2013-08-02','10:55:00',5.63),('11288','2013-08-02','11:00:00',5.64),('11288','2013-08-02','11:05:00',5.76),('11288','2013-08-02','11:10:00',5.83),('11288','2013-08-02','11:15:00',5.87),('11288','2013-08-02','11:20:00',5.92),('11288','2013-08-02','11:25:00',5.99),('11288','2013-08-02','11:30:00',6.02),('11288','2013-08-02','11:35:00',6.09),('11288','2013-08-02','11:40:00',6.12),('11288','2013-08-02','11:45:00',6.15),('11288','2013-08-02','11:50:00',6.16),('11288','2013-08-02','11:55:00',6.2),('11288','2013-08-02','12:00:00',6.24),('11288','2013-08-02','12:05:00',6.32),('11288','2013-08-02','12:10:00',6.35),('11288','2013-08-02','12:15:00',6.42),('11288','2013-08-02','12:20:00',6.42),('11288','2013-08-02','12:25:00',6.42),('11288','2013-08-02','12:30:00',6.4),('11288','2013-08-02','12:35:00',6.4),('11288','2013-08-02','12:40:00',6.44),('11288','2013-08-02','12:45:00',6.46),('11288','2013-08-02','12:50:00',6.43),('11288','2013-08-02','12:55:00',6.42),('11288','2013-08-02','13:00:00',6.44),('11288','2013-08-02','13:05:00',6.46),('11288','2013-08-02','13:10:00',6.47),('11288','2013-08-02','13:15:00',6.47),('11288','2013-08-02','13:20:00',6.44),('11288','2013-08-02','13:25:00',6.43),('11288','2013-08-02','13:30:00',6.37),('11288','2013-08-02','13:35:00',6.39),('11288','2013-08-02','13:40:00',6.44),('11288','2013-08-02','13:45:00',6.39),('11288','2013-08-02','13:50:00',6.38),('11288','2013-08-02','13:55:00',6.39),('11288','2013-08-02','14:00:00',6.38),('11288','2013-08-02','14:05:00',6.34),('11288','2013-08-02','14:10:00',6.31),('11288','2013-08-02','14:15:00',6.24),('11288','2013-08-02','14:20:00',6.14),('11288','2013-08-02','14:25:00',6.12),('11288','2013-08-02','14:30:00',6.17),('11288','2013-08-02','14:35:00',6.24),('11288','2013-08-02','14:40:00',6.21),('11288','2013-08-02','14:45:00',6.2),('11288','2013-08-02','14:50:00',6.13),('11288','2013-08-02','14:55:00',6.1),('11288','2013-08-02','15:00:00',6),('11288','2013-08-02','15:05:00',5.95),('11288','2013-08-02','15:10:00',5.88),('11288','2013-08-02','15:15:00',5.82),('11288','2013-08-02','15:20:00',5.85),('11288','2013-08-02','15:25:00',5.82),('11288','2013-08-02','15:30:00',5.75),('11288','2013-08-02','15:35:00',5.67),('11288','2013-08-02','15:40:00',5.59),('11288','2013-08-02','15:45:00',5.54),('11288','2013-08-02','15:50:00',5.45),('11288','2013-08-02','15:55:00',5.39),('11288','2013-08-02','16:00:00',5.32),('11288','2013-08-02','16:05:00',5.2),('11288','2013-08-02','16:10:00',5.09),('11288','2013-08-02','16:15:00',5.02),('11288','2013-08-02','16:20:00',4.93),('11288','2013-08-02','16:25:00',4.85),('11288','2013-08-02','16:30:00',4.75),('11288','2013-08-02','16:35:00',4.62),('11288','2013-08-02','16:40:00',4.54),('11288','2013-08-02','16:45:00',4.42),('11288','2013-08-02','16:50:00',4.3),('11288','2013-08-02','16:55:00',4.18),('11288','2013-08-02','17:00:00',4.03),('11288','2013-08-02','17:05:00',3.92),('11288','2013-08-02','17:10:00',3.84),('11288','2013-08-02','17:15:00',3.69),('11288','2013-08-02','17:20:00',3.51),('11288','2013-08-02','17:25:00',3.44),('11288','2013-08-02','17:30:00',3.27),('11288','2013-08-02','17:35:00',3.16),('11288','2013-08-02','17:40:00',3.01),('11288','2013-08-02','17:45:00',2.84),('11288','2013-08-02','17:50:00',2.7),('11288','2013-08-02','17:55:00',2.58),('11288','2013-08-02','18:00:00',2.47),('11288','2013-08-02','18:05:00',2.34),('11288','2013-08-02','18:10:00',2.25),('11288','2013-08-02','18:15:00',2.21),('11288','2013-08-02','18:20:00',2.07),('11288','2013-08-02','18:25:00',1.93),('11288','2013-08-02','18:30:00',1.8),('11288','2013-08-02','18:35:00',1.67),('11288','2013-08-02','18:40:00',1.54),('11288','2013-08-02','18:45:00',1.39),('11288','2013-08-02','18:50:00',1.27),('11288','2013-08-02','18:55:00',1.17),('11288','2013-08-02','19:00:00',1.04),('11288','2013-08-01','07:40:00',1.08),('11288','2013-08-01','07:45:00',1.19),('11288','2013-08-01','07:50:00',1.32),('11288','2013-08-01','07:55:00',1.39),('11288','2013-08-01','08:00:00',1.53),('11288','2013-08-01','08:05:00',1.6),('11288','2013-08-01','08:10:00',1.64),('11288','2013-08-01','08:15:00',1.77),('11288','2013-08-01','08:20:00',1.82),('11288','2013-08-01','08:25:00',1.94),('11288','2013-08-01','08:30:00',2.34),('11288','2013-08-01','08:35:00',2.47),('11288','2013-08-01','08:40:00',2.62),('11288','2013-08-01','08:45:00',2.8),('11288','2013-08-01','08:50:00',2.88),('11288','2013-08-01','08:55:00',3.01),('11288','2013-08-01','09:00:00',3.17),('11288','2013-08-01','09:05:00',3.25),('11288','2013-08-01','09:10:00',3.35),('11288','2013-08-01','09:15:00',3.68),('11288','2013-08-01','09:20:00',3.84),('11288','2013-08-01','09:25:00',3.9),('11288','2013-08-01','09:30:00',4.03),('11288','2013-08-01','09:35:00',4.19),('11288','2013-08-01','09:40:00',4.32),('11288','2013-08-01','09:45:00',4.5),('11288','2013-08-01','09:50:00',4.69),('11288','2013-08-01','09:55:00',4.81),('11288','2013-08-01','10:00:00',4.9),('11288','2013-08-01','10:05:00',5.01),('11288','2013-08-01','10:10:00',5.14),('11288','2013-08-01','10:15:00',5.22),('11288','2013-08-01','10:20:00',5.32),('11288','2013-08-01','10:25:00',5.47),('11288','2013-08-01','10:30:00',5.57),('11288','2013-08-01','10:35:00',5.58),('11288','2013-08-01','10:40:00',5.65),('11288','2013-08-01','10:45:00',5.72),('11288','2013-08-01','10:50:00',5.88),('11288','2013-08-01','10:55:00',5.93),('11288','2013-08-01','11:00:00',5.99),('11288','2013-08-01','11:05:00',6.14),('11288','2013-08-01','11:10:00',6.22),('11288','2013-08-01','11:15:00',6.29),('11288','2013-08-01','11:20:00',6.36),('11288','2013-08-01','11:25:00',6.4),('11288','2013-08-01','11:30:00',6.42),('11288','2013-08-01','11:35:00',6.45),('11288','2013-08-01','11:40:00',6.55),('11288','2013-08-01','11:45:00',6.61),('11288','2013-08-01','11:50:00',6.65),('11288','2013-08-01','11:55:00',6.66),('11288','2013-08-01','12:00:00',6.69),('11288','2013-08-01','12:05:00',6.67),('11288','2013-08-01','12:10:00',6.7),('11288','2013-08-01','12:15:00',6.7),('11288','2013-08-01','12:20:00',6.82),('11288','2013-08-01','12:25:00',6.83),('11288','2013-08-01','12:30:00',6.86),('11288','2013-08-01','12:35:00',6.85),('11288','2013-08-01','12:40:00',6.88),('11288','2013-08-01','12:45:00',6.89),('11288','2013-08-01','12:50:00',6.91),('11288','2013-08-01','12:55:00',6.84),('11288','2013-08-01','13:00:00',6.86),('11288','2013-08-01','13:05:00',6.86),('11288','2013-08-01','13:10:00',6.9),('11288','2013-08-01','13:15:00',6.35),('11288','2013-08-01','13:20:00',6.87),('11288','2013-08-01','13:25:00',6.94),('11288','2013-08-01','13:30:00',6.59),('11288','2013-08-01','13:35:00',6.84),('11288','2013-08-01','13:40:00',6.99),('11288','2013-08-01','13:45:00',6.3),('11288','2013-08-01','13:50:00',7.07),('11288','2013-08-01','13:55:00',6.03),('11288','2013-08-01','14:00:00',6.56),('11288','2013-08-01','14:05:00',6.83),('11288','2013-08-01','14:10:00',6.32),('11288','2013-08-01','14:15:00',6.49),('11288','2013-08-01','14:20:00',6.46),('11288','2013-08-01','14:25:00',6.54),('11288','2013-08-01','14:30:00',6.44),('11288','2013-08-01','14:35:00',6.01),('11288','2013-08-01','14:40:00',6.4),('11288','2013-08-01','14:45:00',6.35),('11288','2013-08-01','14:50:00',4.78),('11288','2013-08-01','14:55:00',6.34),('11288','2013-08-01','15:00:00',6.18),('11288','2013-08-01','15:05:00',6.22),('11288','2013-08-01','15:10:00',6.25),('11288','2013-08-01','15:15:00',6.24),('11288','2013-08-01','15:20:00',6.14),('11288','2013-08-01','15:25:00',6.09),('11288','2013-08-01','15:30:00',5.91),('11288','2013-08-01','15:35:00',5.93),('11288','2013-08-01','15:40:00',5.17),('11288','2013-08-01','15:45:00',5.71),('11288','2013-08-01','15:50:00',5.62),('11288','2013-08-01','15:55:00',5.62),('11288','2013-08-01','16:00:00',5.6),('11288','2013-08-01','16:05:00',5.52),('11288','2013-08-01','16:10:00',5.31),('11288','2013-08-01','16:15:00',5.11),('11288','2013-08-01','16:20:00',5.1),('11288','2013-08-01','16:25:00',5.04),('11288','2013-08-01','16:30:00',4.91),('11288','2013-08-01','16:35:00',4.79),('11288','2013-08-01','16:40:00',4.68),('11288','2013-08-01','16:45:00',4.57),('11288','2013-08-01','16:50:00',4.45),('11288','2013-08-01','16:55:00',4.32),('11288','2013-08-01','17:00:00',4.18),('11288','2013-08-01','17:05:00',4.04),('11288','2013-08-01','17:10:00',3.93),('11288','2013-08-01','17:15:00',3.74),('11288','2013-08-01','17:20:00',3.64),('11288','2013-08-01','17:25:00',3.52),('11288','2013-08-01','17:30:00',3.4),('11288','2013-08-01','17:35:00',3.27),('11288','2013-08-01','17:40:00',3.12),('11288','2013-08-01','17:45:00',2.95),('11288','2013-08-01','17:50:00',2.83),('11288','2013-08-01','17:55:00',2.71),('11288','2013-08-01','18:00:00',2.58),('11288','2013-08-01','18:05:00',2.45),('11288','2013-08-01','18:10:00',2.38),('11288','2013-08-01','18:15:00',2.3),('11288','2013-08-01','18:20:00',2.18),('11288','2013-08-01','18:25:00',2.03),('11288','2013-08-01','18:30:00',1.9),('11288','2013-08-01','18:35:00',1.76),('11288','2013-08-01','18:40:00',1.64),('11288','2013-08-01','18:45:00',1.49),('11288','2013-08-01','18:50:00',1.36),('11288','2013-08-01','18:55:00',1.24),('11288','2013-08-01','19:00:00',1.08),('11288','2013-07-31','07:40:00',1.11),('11288','2013-07-31','07:45:00',1.25),('11288','2013-07-31','07:50:00',1.33),('11288','2013-07-31','07:55:00',1.47),('11288','2013-07-31','08:00:00',1.59),('11288','2013-07-31','08:05:00',1.74),('11288','2013-07-31','08:10:00',1.87),('11288','2013-07-31','08:15:00',1.96),('11288','2013-07-31','08:20:00',2.05),('11288','2013-07-31','08:25:00',2.2),('11288','2013-07-31','08:30:00',2.4),('11288','2013-07-31','08:35:00',2.57),('11288','2013-07-31','08:40:00',2.73),('11288','2013-07-31','08:45:00',2.87),('11288','2013-07-31','08:50:00',2.93),('11288','2013-07-31','08:55:00',3.08),('11288','2013-07-31','09:00:00',3.26),('11288','2013-07-31','09:05:00',3.36),('11288','2013-07-31','09:10:00',3.51),('11288','2013-07-31','09:15:00',3.77),('11288','2013-07-31','09:20:00',3.82),('11288','2013-07-31','09:25:00',3.93),('11288','2013-07-31','09:30:00',4.14),('11288','2013-07-31','09:35:00',4.2),('11288','2013-07-31','09:40:00',4.35),('11288','2013-07-31','09:45:00',4.5),('11288','2013-07-31','09:50:00',4.47),('11288','2013-07-31','09:55:00',4.73),('11288','2013-07-31','10:00:00',4.89),('11288','2013-07-31','10:05:00',5.04),('11288','2013-07-31','10:10:00',5.1),('11288','2013-07-31','10:15:00',5.2),('11288','2013-07-31','10:20:00',5.36),('11288','2013-07-31','10:25:00',5.47),('11288','2013-07-31','10:30:00',5.6),('11288','2013-07-31','10:35:00',5.7),('11288','2013-07-31','10:40:00',5.77),('11288','2013-07-31','10:45:00',5.84),('11288','2013-07-31','10:50:00',5.95),('11288','2013-07-31','10:55:00',6.04),('11288','2013-07-31','11:00:00',6.12),('11288','2013-07-31','11:05:00',6.21),('11288','2013-07-31','11:10:00',6.26),('11288','2013-07-31','11:15:00',6.33),('11288','2013-07-31','11:20:00',6.36),('11288','2013-07-31','11:25:00',6.42),('11288','2013-07-31','11:30:00',6.44),('11288','2013-07-31','11:35:00',6.49),('11288','2013-07-31','11:40:00',6.52),('11288','2013-07-31','11:45:00',6.57),('11288','2013-07-31','11:50:00',6.65),('11288','2013-07-31','11:55:00',6.73),('11288','2013-07-31','12:00:00',6.74),('11288','2013-07-31','12:05:00',6.74),('11288','2013-07-31','12:10:00',6.81),('11288','2013-07-31','12:15:00',6.89),('11288','2013-07-31','12:20:00',6.84),('11288','2013-07-31','12:25:00',6.93),('11288','2013-07-31','12:30:00',6.76),('11288','2013-07-31','12:35:00',6.85),('11288','2013-07-31','12:40:00',6.92),('11288','2013-07-31','12:45:00',6.38),('11288','2013-07-31','12:50:00',3.02),('11288','2013-07-31','12:55:00',7.35),('11288','2013-07-31','13:00:00',3.24),('11288','2013-07-31','13:05:00',5.6),('11288','2013-07-31','13:10:00',6.95),('11288','2013-07-31','13:15:00',7.15),('11288','2013-07-31','13:20:00',6.61),('11288','2013-07-31','13:25:00',6.98),('11288','2013-07-31','13:30:00',6.42),('11288','2013-07-31','13:35:00',6.73),('11288','2013-07-31','13:40:00',6.94),('11288','2013-07-31','13:45:00',6.66),('11288','2013-07-31','13:50:00',7.18),('11288','2013-07-31','13:55:00',5.16),('11288','2013-07-31','14:00:00',5.01),('11288','2013-07-31','14:05:00',7.1),('11288','2013-07-31','14:10:00',7.05),('11288','2013-07-31','14:15:00',5.9),('11288','2013-07-31','14:20:00',6.74),('11288','2013-07-31','14:25:00',6.36),('11288','2013-07-31','14:30:00',6.75),('11288','2013-07-31','14:35:00',6.61),('11288','2013-07-31','14:40:00',6.66),('11288','2013-07-31','14:45:00',6.47),('11288','2013-07-31','14:50:00',6.88),('11288','2013-07-31','14:55:00',5.27),('11288','2013-07-31','15:00:00',2.5),('11288','2013-07-31','15:05:00',4.83),('11288','2013-07-31','15:10:00',6.53),('11288','2013-07-31','15:15:00',5.63),('11288','2013-07-31','15:20:00',5.77),('11288','2013-07-31','15:25:00',6.31),('11288','2013-07-31','15:30:00',5.14),('11288','2013-07-31','15:35:00',5.99),('11288','2013-07-31','15:40:00',6.11),('11288','2013-07-31','15:45:00',5.48),('11288','2013-07-31','15:50:00',5.69),('11288','2013-07-31','15:55:00',5.61),('11288','2013-07-31','16:00:00',5.48),('11288','2013-07-31','16:05:00',5.52),('11288','2013-07-31','16:10:00',5.48),('11288','2013-07-31','16:15:00',5.27),('11288','2013-07-31','16:20:00',5.3),('11288','2013-07-31','16:25:00',5.32),('11288','2013-07-31','16:30:00',5.17),('11288','2013-07-31','16:35:00',4.88),('11288','2013-07-31','16:40:00',4.65),('11288','2013-07-31','16:45:00',4.48),('11288','2013-07-31','16:50:00',4.47),('11288','2013-07-31','16:55:00',4.34),('11288','2013-07-31','17:00:00',4.2),('11288','2013-07-31','17:05:00',4.1),('11288','2013-07-31','17:10:00',3.53),('11288','2013-07-31','17:15:00',3.9),('11288','2013-07-31','17:20:00',2.63),('11288','2013-07-31','17:25:00',3.5),('11288','2013-07-31','17:30:00',3.39),('11288','2013-07-31','17:35:00',3.21),('11288','2013-07-31','17:40:00',3.09),('11288','2013-07-31','17:45:00',2.95),('11288','2013-07-31','17:50:00',2.81),('11288','2013-07-31','17:55:00',2.69),('11288','2013-07-31','18:00:00',2.57),('11288','2013-07-31','18:05:00',2.44),('11288','2013-07-31','18:10:00',2.4),('11288','2013-07-31','18:15:00',2.31),('11288','2013-07-31','18:20:00',2.18),('11288','2013-07-31','18:25:00',2.08),('11288','2013-07-31','18:30:00',1.96),('11288','2013-07-31','18:35:00',1.83),('11288','2013-07-31','18:40:00',1.69),('11288','2013-07-31','18:45:00',1.55),('11288','2013-07-31','18:50:00',1.41),('11288','2013-07-31','18:55:00',1.3),('11288','2013-07-31','19:00:00',1.14),('11288','2014-04-08','07:50:00',1.11),('11288','2014-04-08','07:55:00',1.12),('11288','2014-04-08','08:00:00',1.15),('11288','2014-04-08','08:05:00',1.21),('11288','2014-04-08','08:10:00',1.25),('11288','2014-04-08','08:15:00',1.53),('11288','2014-04-08','08:20:00',1.93),('11288','2014-04-08','08:25:00',1.77),('11288','2014-04-08','08:30:00',1.77),('11288','2014-04-08','08:35:00',1.71),('11288','2014-04-08','08:40:00',1.99),('11288','2014-04-08','08:45:00',2.17),('11288','2014-04-08','08:50:00',2.26),('11288','2014-04-08','08:55:00',2.47),('11288','2014-04-08','09:00:00',2.56),('11288','2014-04-08','09:05:00',2.73),('11288','2014-04-08','09:10:00',2.84),('11288','2014-04-08','09:15:00',2.88),('11288','2014-04-08','09:20:00',2.86),('11288','2014-04-08','09:25:00',3.29),('11288','2014-04-08','09:30:00',3.41),('11288','2014-04-08','09:35:00',3.46),('11288','2014-04-08','09:40:00',3.57),('11288','2014-04-08','09:45:00',3.59),('11288','2014-04-08','09:50:00',3.75),('11288','2014-04-08','09:55:00',3.92),('11288','2014-04-08','10:00:00',4.05),('11288','2014-04-08','10:05:00',4.08),('11288','2014-04-08','10:10:00',4.35),('11288','2014-04-08','10:15:00',4.61),('11288','2014-04-08','10:20:00',4.74),('11288','2014-04-08','10:25:00',4.79),('11288','2014-04-08','10:30:00',4.91),('11288','2014-04-08','10:35:00',5.03),('11288','2014-04-08','10:40:00',5.11),('11288','2014-04-08','10:45:00',5.11),('11288','2014-04-08','10:50:00',5.26),('11288','2014-04-08','10:55:00',5.41),('11288','2014-04-08','11:00:00',5.42),('11288','2014-04-08','11:05:00',5.41),('11288','2014-04-08','11:10:00',5.45),('11288','2014-04-08','11:15:00',5.48),('11288','2014-04-08','11:20:00',5.61),('11288','2014-04-08','11:25:00',5.65),('11288','2014-04-08','11:30:00',5.72),('11288','2014-04-08','11:35:00',5.58),('11288','2014-04-08','11:40:00',5.77),('11288','2014-04-08','11:45:00',5.84),('11288','2014-04-08','11:50:00',5.83),('11288','2014-04-08','11:55:00',5.94),('11288','2014-04-08','12:00:00',6.06),('11288','2014-04-08','12:05:00',6.09),('11288','2014-04-08','12:10:00',5.85),('11288','2014-04-08','12:15:00',5.53),('11288','2014-04-08','12:20:00',5.55),('11288','2014-04-08','12:25:00',5.53),('11288','2014-04-08','12:30:00',6.53),('11288','2014-04-08','12:35:00',6.46),('11288','2014-04-08','12:40:00',5.41),('11288','2014-04-08','12:45:00',4.19),('11288','2014-04-08','12:50:00',5.68),('11288','2014-04-08','12:55:00',6.32),('11288','2014-04-08','13:00:00',6.1),('11288','2014-04-08','13:05:00',6.32),('11288','2014-04-08','13:10:00',6.46),('11288','2014-04-08','13:15:00',6.56),('11288','2014-04-08','13:20:00',6.51),('11288','2014-04-08','13:25:00',6.57),('11288','2014-04-08','13:30:00',6.53),('11288','2014-04-08','13:35:00',6.58),('11288','2014-04-08','13:40:00',6.53),('11288','2014-04-08','13:45:00',6.44),('11288','2014-04-08','13:50:00',6.44),('11288','2014-04-08','13:55:00',6.49),('11288','2014-04-08','14:00:00',6.44),('11288','2014-04-08','14:05:00',6.44),('11288','2014-04-08','14:10:00',6.39),('11288','2014-04-08','14:15:00',6.33),('11288','2014-04-08','14:20:00',5.9),('11288','2014-04-08','14:25:00',6.03),('11288','2014-04-08','14:30:00',6.41),('11288','2014-04-08','14:35:00',6.14),('11288','2014-04-08','14:40:00',5.34),('11288','2014-04-08','14:45:00',5.54),('11288','2014-04-08','14:50:00',5.96),('11288','2014-04-08','14:55:00',6.11),('11288','2014-04-08','15:00:00',5.93),('11288','2014-04-08','15:05:00',5.8),('11288','2014-04-08','15:10:00',5.82),('11288','2014-04-08','15:15:00',5.67),('11288','2014-04-08','15:20:00',5.55),('11288','2014-04-08','15:25:00',5.31),('11288','2014-04-08','15:30:00',5.09),('11288','2014-04-08','15:35:00',5.4),('11288','2014-04-08','15:40:00',5.28),('11288','2014-04-08','15:45:00',4.99),('11288','2014-04-08','15:50:00',5.04),('11288','2014-04-08','15:55:00',4.98),('11288','2014-04-08','16:00:00',4.75),('11288','2014-04-08','16:05:00',4.73),('11288','2014-04-08','16:10:00',4.54),('11288','2014-04-08','16:15:00',4.23),('11288','2014-04-08','16:20:00',3.9),('11288','2014-04-08','16:25:00',4.1),('11288','2014-04-08','16:30:00',4.33),('11288','2014-04-08','16:35:00',4.12),('11288','2014-04-08','16:40:00',3.91),('11288','2014-04-08','16:45:00',3.73),('11288','2014-04-08','16:50:00',3.72),('11288','2014-04-08','16:55:00',3.44),('11288','2014-04-08','17:00:00',3.2),('11288','2014-04-08','17:05:00',3.29),('11288','2014-04-08','17:10:00',3.06),('11288','2014-04-08','17:15:00',2.92),('11288','2014-04-08','17:20:00',2.79),('11288','2014-04-08','17:25:00',2.46),('11288','2014-04-08','17:30:00',2.33),('11288','2014-04-08','17:35:00',2.13),('11288','2014-04-08','17:40:00',2.07),('11288','2014-04-08','17:45:00',1.98),('11288','2014-04-08','17:50:00',1.89),('11288','2014-04-08','17:55:00',1.66),('11288','2014-04-08','18:00:00',1.64),('11288','2014-04-08','18:05:00',1.57),('11288','2014-04-08','18:10:00',1.4),('11288','2014-04-08','18:15:00',1.33),('11288','2014-04-08','18:20:00',1.17),('11288','2013-07-30','07:20:00',1.11),('11288','2013-07-30','07:25:00',1.37),('11288','2013-07-30','07:45:00',1.16),('11288','2013-07-30','07:50:00',1.35),('11288','2013-07-30','07:55:00',1.43),('11288','2013-07-30','08:00:00',1.57),('11288','2013-07-30','08:05:00',1.89),('11288','2013-07-30','08:10:00',2.03),('11288','2013-07-30','08:15:00',2.16),('11288','2013-07-30','08:20:00',2.43),('11288','2013-07-30','08:25:00',2.41),('11288','2013-07-30','08:30:00',2.42),('11288','2013-07-30','08:35:00',2.63),('11288','2013-07-30','08:40:00',2.7),('11288','2013-07-30','08:45:00',2.77),('11288','2013-07-30','08:50:00',3),('11288','2013-07-30','08:55:00',3.12),('11288','2013-07-30','09:00:00',3.17),('11288','2013-07-30','09:05:00',3.36),('11288','2013-07-30','09:10:00',3.48),('11288','2013-07-30','09:15:00',3.74),('11288','2013-07-30','09:20:00',3.52),('11288','2013-07-30','09:25:00',3.44),('11288','2013-07-30','09:30:00',4.22),('11288','2013-07-30','09:35:00',4.06),('11288','2013-07-30','09:40:00',3.81),('11288','2013-07-30','09:45:00',2.92),('11288','2013-07-30','09:50:00',1.75),('11288','2013-07-30','09:55:00',1.18),('11288','2013-07-30','10:00:00',1.05),('11288','2013-07-30','10:05:00',3.82),('11288','2013-07-30','10:10:00',5.56),('11288','2013-07-30','10:15:00',5.57),('11288','2013-07-30','10:20:00',5.7),('11288','2013-07-30','10:25:00',5.84),('11288','2013-07-30','10:30:00',5.81),('11288','2013-07-30','10:35:00',5.73),('11288','2013-07-30','10:40:00',5.7),('11288','2013-07-30','10:45:00',5.69),('11288','2013-07-30','10:50:00',5.65),('11288','2013-07-30','10:55:00',5.82),('11288','2013-07-30','11:00:00',6.08),('11288','2013-07-30','11:05:00',6.1),('11288','2013-07-30','11:10:00',6.16),('11288','2013-07-30','11:15:00',6.19),('11288','2013-07-30','11:20:00',6.29),('11288','2013-07-30','11:25:00',6.28),('11288','2013-07-30','11:30:00',6.26),('11288','2013-07-30','11:35:00',6.49),('11288','2013-07-30','11:40:00',6.4),('11288','2013-07-30','11:45:00',5.89),('11288','2013-07-30','11:50:00',3.98),('11288','2013-07-30','11:55:00',5.67),('11288','2013-07-30','12:00:00',6.53),('11288','2013-07-30','12:05:00',6.62),('11288','2013-07-30','12:10:00',6.28),('11288','2013-07-30','12:15:00',6.29),('11288','2013-07-30','12:20:00',6.6),('11288','2013-07-30','12:25:00',6.63),('11288','2013-07-30','12:30:00',6.58),('11288','2013-07-30','12:35:00',5.54),('11288','2013-07-30','12:40:00',4.28),('11288','2013-07-30','12:45:00',6.78),('11288','2013-07-30','12:50:00',7.03),('11288','2013-07-30','12:55:00',6.13),('11288','2013-07-30','13:00:00',5.96),('11288','2013-07-30','13:05:00',3.15),('11288','2013-07-30','13:10:00',3.94),('11288','2013-07-30','13:15:00',5.78),('11288','2013-07-30','13:20:00',7.14),('11288','2013-07-30','13:25:00',7.08),('11288','2013-07-30','13:30:00',6.97),('11288','2013-07-30','13:35:00',6.82),('11288','2013-07-30','13:40:00',6.97),('11288','2013-07-30','13:45:00',6.74),('11288','2013-07-30','13:50:00',6.73),('11288','2013-07-30','13:55:00',6.83),('11288','2013-07-30','14:00:00',5.4),('11288','2013-07-30','14:05:00',5.21),('11288','2013-07-30','14:10:00',6.18),('11288','2013-07-30','14:15:00',6.77),('11288','2013-07-30','14:20:00',6.23),('11288','2013-07-30','14:25:00',6),('11288','2013-07-30','14:30:00',6.59),('11288','2013-07-30','14:35:00',6.6),('11288','2013-07-30','14:40:00',6.34),('11288','2013-07-30','14:45:00',6.24),('11288','2013-07-30','14:50:00',6.11),('11288','2013-07-30','14:55:00',6.16),('11288','2013-07-30','15:00:00',6.16),('11288','2013-07-30','15:05:00',6.03),('11288','2013-07-30','15:10:00',5.92),('11288','2013-07-30','15:15:00',5.85),('11288','2013-07-30','15:20:00',5.82),('11288','2013-07-30','15:25:00',5.82),('11288','2013-07-30','15:30:00',5.73),('11288','2013-07-30','15:35:00',5.65),('11288','2013-07-30','15:40:00',5.61),('11288','2013-07-30','15:45:00',5.54),('11288','2013-07-30','15:50:00',5.45),('11288','2013-07-30','15:55:00',5.38),('11288','2013-07-30','16:00:00',5.34),('11288','2013-07-30','16:05:00',5.24),('11288','2013-07-30','16:10:00',5.15),('11288','2013-07-30','16:15:00',5.01),('11288','2013-07-30','16:20:00',4.95),('11288','2013-07-30','16:25:00',4.87),('11288','2013-07-30','16:30:00',4.73),('11288','2013-07-30','16:35:00',4.59),('11288','2013-07-30','16:40:00',4.57),('11288','2013-07-30','16:45:00',4.45),('11288','2013-07-30','16:50:00',4.32),('11288','2013-07-30','16:55:00',4.22),('11288','2013-07-30','17:00:00',4.1),('11288','2013-07-30','17:05:00',3.96),('11288','2013-07-30','17:10:00',3.82),('11288','2013-07-30','17:15:00',3.62),('11288','2013-07-30','17:20:00',3.49),('11288','2013-07-30','17:25:00',3.47),('11288','2013-07-30','17:30:00',3.33),('11288','2013-07-30','17:35:00',3.18),('11288','2013-07-30','17:40:00',3.08),('11288','2013-07-30','17:45:00',2.93),('11288','2013-07-30','17:50:00',2.78),('11288','2013-07-30','17:55:00',2.63),('11288','2013-07-30','18:00:00',2.49),('11288','2013-07-30','18:05:00',2.4),('11288','2013-07-30','18:10:00',2.37),('11288','2013-07-30','18:15:00',2.24),('11288','2013-07-30','18:20:00',2.12),('11288','2013-07-30','18:25:00',2.01),('11288','2013-07-30','18:30:00',1.85),('11288','2013-07-30','18:35:00',1.72),('11288','2013-07-30','18:40:00',1.58),('11288','2013-07-30','18:45:00',1.46),('11288','2013-07-30','18:50:00',1.31),('11288','2013-07-30','18:55:00',1.2),('11288','2013-07-30','19:00:00',1.09),('11288','2013-07-29','07:30:00',1.01),('11288','2013-07-29','07:35:00',1.1),('11288','2013-07-29','07:40:00',1.19),('11288','2013-07-29','07:45:00',1.28),('11288','2013-07-29','07:50:00',1.36),('11288','2013-07-29','07:55:00',1.51),('11288','2013-07-29','08:00:00',1.65),('11288','2013-07-29','08:05:00',1.77),('11288','2013-07-29','08:10:00',1.84),('11288','2013-07-29','08:15:00',1.91),('11288','2013-07-29','08:20:00',1.99),('11288','2013-07-29','08:25:00',2.11),('11288','2013-07-29','08:30:00',2.32),('11288','2013-07-29','08:35:00',2.5),('11288','2013-07-29','08:40:00',2.57),('11288','2013-07-29','08:45:00',2.65),('11288','2013-07-29','08:50:00',2.79),('11288','2013-07-29','08:55:00',2.9),('11288','2013-07-29','09:00:00',3.02),('11288','2013-07-29','09:05:00',3.14),('11288','2013-07-29','09:10:00',3.22),('11288','2013-07-29','09:15:00',3.44),('11288','2013-07-29','09:20:00',3.49),('11288','2013-07-29','09:25:00',3.61),('11288','2013-07-29','09:30:00',3.77),('11288','2013-07-29','09:35:00',3.82),('11288','2013-07-29','09:40:00',4.01),('11288','2013-07-29','09:45:00',4.23),('11288','2013-07-29','09:50:00',4.28),('11288','2013-07-29','09:55:00',4.31),('11288','2013-07-29','10:00:00',4.55),('11288','2013-07-29','10:05:00',4.67),('11288','2013-07-29','10:10:00',4.78),('11288','2013-07-29','10:15:00',4.84),('11288','2013-07-29','10:20:00',5.01),('11288','2013-07-29','10:25:00',5.1),('11288','2013-07-29','10:30:00',5.16),('11288','2013-07-29','10:35:00',5.26),('11288','2013-07-29','10:40:00',5.36),('11288','2013-07-29','10:45:00',5.37),('11288','2013-07-29','10:50:00',5.46),('11288','2013-07-29','10:55:00',5.51),('11288','2013-07-29','11:00:00',5.55),('11288','2013-07-29','11:05:00',5.65),('11288','2013-07-29','11:10:00',5.66),('11288','2013-07-29','11:15:00',5.71),('11288','2013-07-29','11:20:00',5.81),('11288','2013-07-29','11:25:00',5.84),('11288','2013-07-29','11:30:00',5.83),('11288','2013-07-29','11:35:00',5.9),('11288','2013-07-29','11:40:00',5.98),('11288','2013-07-29','11:45:00',5.93),('11288','2013-07-29','11:50:00',5.92),('11288','2013-07-29','11:55:00',5.96),('11288','2013-07-29','12:00:00',6.07),('11288','2013-07-29','12:05:00',6.15),('11288','2013-07-29','12:10:00',6.16),('11288','2013-07-29','12:15:00',6.13),('11288','2013-07-29','12:20:00',6.17),('11288','2013-07-29','12:25:00',6.19),('11288','2013-07-29','12:30:00',6.17),('11288','2013-07-29','12:35:00',6.19),('11288','2013-07-29','12:40:00',6.23),('11288','2013-07-29','12:45:00',6.25),('11288','2013-07-29','12:50:00',6.16),('11288','2013-07-29','12:55:00',6.11),('11288','2013-07-29','13:00:00',6.28),('11288','2013-07-29','13:05:00',6.18),('11288','2013-07-29','13:10:00',6.3),('11288','2013-07-29','13:15:00',6.36),('11288','2013-07-29','13:20:00',6.45),('11288','2013-07-29','13:25:00',6.5),('11288','2013-07-29','13:30:00',6.55),('11288','2013-07-29','13:35:00',6.51),('11288','2013-07-29','13:40:00',6.51),('11288','2013-07-29','13:45:00',6.55),('11288','2013-07-29','13:50:00',6.54),('11288','2013-07-29','13:55:00',6.52),('11288','2013-07-29','14:00:00',6.49),('11288','2013-07-29','14:05:00',6.45),('11288','2013-07-29','14:10:00',6.43),('11288','2013-07-29','14:15:00',6.45),('11288','2013-07-29','14:20:00',6.39),('11288','2013-07-29','14:25:00',6.31),('11288','2013-07-29','14:30:00',6.3),('11288','2013-07-29','14:35:00',6.25),('11288','2013-07-29','14:40:00',6.19),('11288','2013-07-29','14:45:00',6.16),('11288','2013-07-29','14:50:00',6.13),('11288','2013-07-29','14:55:00',6.1),('11288','2013-07-29','15:00:00',6.02),('11288','2013-07-29','15:05:00',5.98),('11288','2013-07-29','15:10:00',5.93),('11288','2013-07-29','15:15:00',5.86),('11288','2013-07-29','15:20:00',5.83),('11288','2013-07-29','15:25:00',5.79),('11288','2013-07-29','15:30:00',5.71),('11288','2013-07-29','15:35:00',5.69),('11288','2013-07-29','15:40:00',5.75),('11288','2013-07-29','15:45:00',5.82),('11288','2013-07-29','15:50:00',4.61),('11288','2013-07-29','15:55:00',3.22),('11288','2013-07-29','16:00:00',3.2),('11288','2013-07-29','16:05:00',4.94),('11288','2013-07-29','16:10:00',4.9),('11288','2013-07-29','16:15:00',3.95),('11288','2013-07-29','16:20:00',4.02),('11288','2013-07-29','16:25:00',4.56),('11288','2013-07-29','16:30:00',4.94),('11288','2013-07-29','16:35:00',3.89),('11288','2013-07-29','16:40:00',4.24),('11288','2013-07-29','16:45:00',4.87),('11288','2013-07-29','16:50:00',4.17),('11288','2013-07-29','16:55:00',2.93),('11288','2013-07-29','17:00:00',2.39),('11288','2013-07-29','17:05:00',3.38),('11288','2013-07-29','17:10:00',2.2),('11288','2013-07-29','17:15:00',1.97),('11288','2013-07-29','17:20:00',3.78),('11288','2013-07-29','17:25:00',3.35),('11288','2013-07-29','17:30:00',2.03),('11288','2013-07-29','17:35:00',1.48),('11288','2013-07-29','17:40:00',1.89),('11288','2013-07-29','17:45:00',2.98),('11288','2013-07-29','17:50:00',2.8),('11288','2013-07-29','17:55:00',2.52),('11288','2013-07-29','18:00:00',1.76),('11288','2013-07-29','18:05:00',1.34),('11288','2013-07-29','18:10:00',2.19),('11288','2013-07-29','18:15:00',1.9),('11288','2013-07-29','18:20:00',2.08),('11288','2013-07-29','18:25:00',2.02),('11288','2013-07-29','18:30:00',1.91),('11288','2013-07-29','18:35:00',1.66),('11288','2013-07-29','18:40:00',1.18),('11288','2013-07-29','18:50:00',1.01),('11288','2013-07-29','18:55:00',1.07),('11288','2013-07-29','19:00:00',1.37),('11288','2013-07-29','19:05:00',1.33),('11288','2013-07-29','19:10:00',1.02),('11288','2013-07-28','07:35:00',1.05),('11288','2013-07-28','07:40:00',1.18),('11288','2013-07-28','07:45:00',1.23),('11288','2013-07-28','07:50:00',1.32),('11288','2013-07-28','07:55:00',1.48),('11288','2013-07-28','08:00:00',1.57),('11288','2013-07-28','08:05:00',1.68),('11288','2013-07-28','08:10:00',1.79),('11288','2013-07-28','08:15:00',1.78),('11288','2013-07-28','08:20:00',1.86),('11288','2013-07-28','08:25:00',2.16),('11288','2013-07-28','08:30:00',2.3),('11288','2013-07-28','08:35:00',2.4),('11288','2013-07-28','08:40:00',2.55),('11288','2013-07-28','08:45:00',2.65),('11288','2013-07-28','08:50:00',2.71),('11288','2013-07-28','08:55:00',2.86),('11288','2013-07-28','09:00:00',2.91),('11288','2013-07-28','09:05:00',3.15),('11288','2013-07-28','09:10:00',3.26),('11288','2013-07-28','09:15:00',3.5),('11288','2013-07-28','09:20:00',3.56),('11288','2013-07-28','09:25:00',3.61),('11288','2013-07-28','09:30:00',3.77),('11288','2013-07-28','09:35:00',3.87),('11288','2013-07-28','09:40:00',4.04),('11288','2013-07-28','09:45:00',4.26),('11288','2013-07-28','09:50:00',4.32),('11288','2013-07-28','09:55:00',4.29),('11288','2013-07-28','10:00:00',4.59),('11288','2013-07-28','10:05:00',4.7),('11288','2013-07-28','10:10:00',4.84),('11288','2013-07-28','10:15:00',4.91),('11288','2013-07-28','10:20:00',5.02),('11288','2013-07-28','10:25:00',5.13),('11288','2013-07-28','10:30:00',5.2),('11288','2013-07-28','10:35:00',5.27),('11288','2013-07-28','10:40:00',5.3),('11288','2013-07-28','10:45:00',5.37),('11288','2013-07-28','10:50:00',5.41),('11288','2013-07-28','10:55:00',5.45),('11288','2013-07-28','11:00:00',5.53),('11288','2013-07-28','11:05:00',5.62),('11288','2013-07-28','11:10:00',5.64),('11288','2013-07-28','11:15:00',5.67),('11288','2013-07-28','11:20:00',5.71),('11288','2013-07-28','11:25:00',5.75),('11288','2013-07-28','11:30:00',5.82),('11288','2013-07-28','11:35:00',5.94),('11288','2013-07-28','11:40:00',5.95),('11288','2013-07-28','11:45:00',5.98),('11288','2013-07-28','11:50:00',5.93),('11288','2013-07-28','11:55:00',6),('11288','2013-07-28','12:00:00',6.09),('11288','2013-07-28','12:05:00',6.08),('11288','2013-07-28','12:10:00',6.07),('11288','2013-07-28','12:15:00',6.1),('11288','2013-07-28','12:20:00',6.07),('11288','2013-07-28','12:25:00',6.17),('11288','2013-07-28','12:30:00',6.2),('11288','2013-07-28','12:35:00',6.28),('11288','2013-07-28','12:40:00',6.35),('11288','2013-07-28','12:45:00',6.41),('11288','2013-07-28','12:50:00',6.07),('11288','2013-07-28','12:55:00',6.39),('11288','2013-07-28','13:00:00',6.34),('11288','2013-07-28','13:05:00',6.34),('11288','2013-07-28','13:10:00',6.34),('11288','2013-07-28','13:15:00',5.64),('11288','2013-07-28','13:20:00',6.49),('11288','2013-07-28','13:25:00',6.5),('11288','2013-07-28','13:30:00',6.41),('11288','2013-07-28','13:35:00',6.35),('11288','2013-07-28','13:40:00',6.41),('11288','2013-07-28','13:45:00',6.38),('11288','2013-07-28','13:50:00',6.32),('11288','2013-07-28','13:55:00',6.36),('11288','2013-07-28','14:00:00',6.38),('11288','2013-07-28','14:05:00',6.37),('11288','2013-07-28','14:10:00',6.42),('11288','2013-07-28','14:15:00',6.34),('11288','2013-07-28','14:20:00',6.3),('11288','2013-07-28','14:25:00',6.2),('11288','2013-07-28','14:30:00',6.15),('11288','2013-07-28','14:35:00',6.08),('11288','2013-07-28','14:40:00',6.09),('11288','2013-07-28','14:45:00',6),('11288','2013-07-28','14:50:00',6.02),('11288','2013-07-28','14:55:00',5.98),('11288','2013-07-28','15:00:00',5.95),('11288','2013-07-28','15:05:00',5.92),('11288','2013-07-28','15:10:00',5.84),('11288','2013-07-28','15:15:00',5.75),('11288','2013-07-28','15:20:00',5.72),('11288','2013-07-28','15:25:00',5.66),('11288','2013-07-28','15:30:00',5.56),('11288','2013-07-28','15:35:00',5.54),('11288','2013-07-28','15:40:00',5.51),('11288','2013-07-28','15:45:00',5.4),('11288','2013-07-28','15:50:00',5.38),('11288','2013-07-28','15:55:00',5.32),('11288','2013-07-28','16:00:00',5.31),('11288','2013-07-28','16:05:00',5.26),('11288','2013-07-28','16:10:00',5.13),('11288','2013-07-28','16:15:00',5.05),('11288','2013-07-28','16:20:00',4.98),('11288','2013-07-28','16:25:00',4.92),('11288','2013-07-28','16:30:00',4.83),('11288','2013-07-28','16:35:00',4.73),('11288','2013-07-28','16:40:00',4.6),('11288','2013-07-28','16:45:00',4.48),('11288','2013-07-28','16:50:00',4.39),('11288','2013-07-28','16:55:00',4.28),('11288','2013-07-28','17:00:00',4.13),('11288','2013-07-28','17:05:00',4.01),('11288','2013-07-28','17:10:00',3.84),('11288','2013-07-28','17:15:00',3.74),('11288','2013-07-28','17:20:00',3.64),('11288','2013-07-28','17:25:00',3.53),('11288','2013-07-28','17:30:00',3.4),('11288','2013-07-28','17:35:00',3.28),('11288','2013-07-28','17:40:00',3.15),('11288','2013-07-28','17:45:00',2.99),('11288','2013-07-28','17:50:00',2.86),('11288','2013-07-28','17:55:00',2.73),('11288','2013-07-28','18:00:00',2.59),('11288','2013-07-28','18:05:00',2.54),('11288','2013-07-28','18:10:00',2.43),('11288','2013-07-28','18:15:00',2.3),('11288','2013-07-28','18:20:00',2.16),('11288','2013-07-28','18:25:00',2.05),('11288','2013-07-28','18:30:00',1.9),('11288','2013-07-28','18:35:00',1.76),('11288','2013-07-28','18:40:00',1.63),('11288','2013-07-28','18:45:00',1.51),('11288','2013-07-28','18:50:00',1.39),('11288','2013-07-28','18:55:00',1.27),('11288','2013-07-28','19:00:00',1.12),('11288','2013-07-27','07:35:00',1.07),('11288','2013-07-27','07:40:00',1.18),('11288','2013-07-27','07:45:00',1.23),('11288','2013-07-27','07:50:00',1.35),('11288','2013-07-27','07:55:00',1.51),('11288','2013-07-27','08:00:00',1.64),('11288','2013-07-27','08:05:00',1.73),('11288','2013-07-27','08:10:00',1.84),('11288','2013-07-27','08:15:00',1.83),('11288','2013-07-27','08:20:00',1.96),('11288','2013-07-27','08:25:00',2.27),('11288','2013-07-27','08:30:00',2.35),('11288','2013-07-27','08:35:00',2.37),('11288','2013-07-27','08:40:00',2.69),('11288','2013-07-27','08:45:00',2.76),('11288','2013-07-27','08:50:00',2.83),('11288','2013-07-27','08:55:00',3.01),('11288','2013-07-27','09:00:00',2.93),('11288','2013-07-27','09:05:00',3.1),('11288','2013-07-27','09:10:00',3.38),('11288','2013-07-27','09:15:00',3.58),('11288','2013-07-27','09:20:00',3.62),('11288','2013-07-27','09:25:00',3.75),('11288','2013-07-27','09:30:00',3.85),('11288','2013-07-27','09:35:00',4.01),('11288','2013-07-27','09:40:00',4.07),('11288','2013-07-27','09:45:00',4.22),('11288','2013-07-27','09:50:00',4.3),('11288','2013-07-27','09:55:00',4.44),('11288','2013-07-27','10:00:00',4.65),('11288','2013-07-27','10:05:00',4.75),('11288','2013-07-27','10:10:00',4.87),('11288','2013-07-27','10:15:00',4.98),('11288','2013-07-27','10:20:00',5.13),('11288','2013-07-27','10:25:00',5.2),('11288','2013-07-27','10:30:00',5.24),('11288','2013-07-27','10:35:00',5.39),('11288','2013-07-27','10:40:00',5.43),('11288','2013-07-27','10:45:00',5.43),('11288','2013-07-27','10:50:00',5.51),('11288','2013-07-27','10:55:00',5.56),('11288','2013-07-27','11:00:00',5.66),('11288','2013-07-27','11:05:00',5.76),('11288','2013-07-27','11:10:00',5.84),('11288','2013-07-27','11:15:00',5.82),('11288','2013-07-27','11:20:00',5.95),('11288','2013-07-27','11:25:00',5.97),('11288','2013-07-27','11:30:00',5.98),('11288','2013-07-27','11:35:00',6.02),('11288','2013-07-27','11:40:00',6.07),('11288','2013-07-27','11:45:00',6.07),('11288','2013-07-27','11:50:00',6.1),('11288','2013-07-27','11:55:00',6.15),('11288','2013-07-27','12:00:00',6.2),('11288','2013-07-27','12:05:00',6.22),('11288','2013-07-27','12:10:00',6.26),('11288','2013-07-27','12:15:00',6.12),('11288','2013-07-27','12:20:00',6.08),('11288','2013-07-27','12:25:00',6.25),('11288','2013-07-27','12:30:00',6.33),('11288','2013-07-27','12:35:00',6.24),('11288','2013-07-27','12:40:00',6.2),('11288','2013-07-27','12:45:00',6.4),('11288','2013-07-27','12:50:00',6.43),('11288','2013-07-27','12:55:00',6.4),('11288','2013-07-27','13:00:00',6.39),('11288','2013-07-27','13:05:00',2.77),('11288','2013-07-27','13:10:00',3.95),('11288','2013-07-27','13:15:00',6.54),('11288','2013-07-27','13:20:00',6.66),('11288','2013-07-27','13:25:00',6.55),('11288','2013-07-27','13:30:00',6.53),('11288','2013-07-27','13:35:00',6.45),('11288','2013-07-27','13:40:00',6.29),('11288','2013-07-27','13:45:00',6.46),('11288','2013-07-27','13:50:00',6.35),('11288','2013-07-27','13:55:00',6.4),('11288','2013-07-27','14:00:00',6.31),('11288','2013-07-27','14:05:00',6.49),('11288','2013-07-27','14:10:00',6.55),('11288','2013-07-27','14:15:00',6.22),('11288','2013-07-27','14:20:00',6.3),('11288','2013-07-27','14:25:00',6.25),('11288','2013-07-27','14:30:00',6.18),('11288','2013-07-27','14:35:00',6.19),('11288','2013-07-27','14:40:00',6.1),('11288','2013-07-27','14:45:00',6.12),('11288','2013-07-27','14:50:00',6.11),('11288','2013-07-27','14:55:00',6.05),('11288','2013-07-27','15:00:00',5.98),('11288','2013-07-27','15:05:00',6.02),('11288','2013-07-27','15:10:00',5.9),('11288','2013-07-27','15:15:00',5.92),('11288','2013-07-27','15:20:00',5.86),('11288','2013-07-27','15:25:00',5.78),('11288','2013-07-27','15:30:00',5.75),('11288','2013-07-27','15:35:00',5.67),('11288','2013-07-27','15:40:00',5.57),('11288','2013-07-27','15:45:00',5.53),('11288','2013-07-27','15:50:00',5.45),('11288','2013-07-27','15:55:00',5.38),('11288','2013-07-27','16:00:00',5.33),('11288','2013-07-27','16:05:00',5.24),('11288','2013-07-27','16:10:00',5.15),('11288','2013-07-27','16:15:00',4.99),('11288','2013-07-27','16:20:00',4.95),('11288','2013-07-27','16:25:00',4.89),('11288','2013-07-27','16:30:00',4.82),('11288','2013-07-27','16:35:00',4.73),('11288','2013-07-27','16:40:00',4.6),('11288','2013-07-27','16:45:00',4.49),('11288','2013-07-27','16:50:00',4.41),('11288','2013-07-27','16:55:00',4.28),('11288','2013-07-27','17:00:00',4.1),('11288','2013-07-27','17:05:00',4.03),('11288','2013-07-27','17:10:00',3.84),('11288','2013-07-27','17:15:00',3.76),('11288','2013-07-27','17:20:00',3.62),('11288','2013-07-27','17:25:00',3.49),('11288','2013-07-27','17:30:00',3.38),('11288','2013-07-27','17:35:00',3.25),('11288','2013-07-27','17:40:00',3.12),('11288','2013-07-27','17:45:00',2.98),('11288','2013-07-27','17:50:00',2.85),('11288','2013-07-27','17:55:00',2.74),('11288','2013-07-27','18:00:00',2.63),('11288','2013-07-27','18:05:00',2.59),('11288','2013-07-27','18:10:00',2.51),('11288','2013-07-27','18:15:00',2.36),('11288','2013-07-27','18:20:00',2.22),('11288','2013-07-27','18:25:00',2.1),('11288','2013-07-27','18:30:00',1.97),('11288','2013-07-27','18:35:00',1.84),('11288','2013-07-27','18:40:00',1.7),('11288','2013-07-27','18:45:00',1.59),('11288','2013-07-27','18:50:00',1.47),('11288','2013-07-27','18:55:00',1.34),('11288','2013-07-27','19:00:00',1.21),('11288','2013-07-27','19:05:00',1.06),('11288','2013-07-26','07:30:00',1.02),('11288','2013-07-26','07:35:00',1.14),('11288','2013-07-26','07:40:00',1.25),('11288','2013-07-26','07:45:00',1.32),('11288','2013-07-26','07:50:00',1.4),('11288','2013-07-26','07:55:00',1.51),('11288','2013-07-26','08:00:00',1.63),('11288','2013-07-26','08:05:00',1.81),('11288','2013-07-26','08:10:00',1.92),('11288','2013-07-26','08:15:00',1.91),('11288','2013-07-26','08:20:00',1.99),('11288','2013-07-26','08:25:00',2.24),('11288','2013-07-26','08:30:00',2.39),('11288','2013-07-26','08:35:00',2.41),('11288','2013-07-26','08:40:00',2.69),('11288','2013-07-26','08:45:00',2.77),('11288','2013-07-26','08:50:00',2.87),('11288','2013-07-26','08:55:00',3.03),('11288','2013-07-26','09:00:00',2.99),('11288','2013-07-26','09:05:00',3.02),('11288','2013-07-26','09:10:00',3.28),('11288','2013-07-26','09:15:00',3.46),('11288','2013-07-26','09:20:00',3.57),('11288','2013-07-26','09:25:00',3.71),('11288','2013-07-26','09:30:00',3.91),('11288','2013-07-26','09:35:00',3.83),('11288','2013-07-26','09:40:00',4.11),('11288','2013-07-26','09:45:00',4.2),('11288','2013-07-26','09:50:00',4.19),('11288','2013-07-26','09:55:00',3.5),('11288','2013-07-26','10:00:00',4.37),('11288','2013-07-26','10:05:00',4.61),('11288','2013-07-26','10:10:00',4.71),('11288','2013-07-26','10:15:00',4.87),('11288','2013-07-26','10:20:00',4.95),('11288','2013-07-26','10:25:00',5),('11288','2013-07-26','10:30:00',5.12),('11288','2013-07-26','10:35:00',5.28),('11288','2013-07-26','10:40:00',5.34),('11288','2013-07-26','10:45:00',5.41),('11288','2013-07-26','10:50:00',5.29),('11288','2013-07-26','10:55:00',5.63),('11288','2013-07-26','11:00:00',5.19),('11288','2013-07-26','11:05:00',5.43),('11288','2013-07-26','11:10:00',5.82),('11288','2013-07-26','11:15:00',5.37),('11288','2013-07-26','11:20:00',5.57),('11288','2013-07-26','11:25:00',5.98),('11288','2013-07-26','11:30:00',6.08),('11288','2013-07-26','11:35:00',6.02),('11288','2013-07-26','11:40:00',6.02),('11288','2013-07-26','11:45:00',6.21),('11288','2013-07-26','11:50:00',6.38),('11288','2013-07-26','11:55:00',6.19),('11288','2013-07-26','12:00:00',5.97),('11288','2013-07-26','12:05:00',6.3),('11288','2013-07-26','12:10:00',6.21),('11288','2013-07-26','12:15:00',5.48),('11288','2013-07-26','12:20:00',6.63),('11288','2013-07-26','12:25:00',6.41),('11288','2013-07-26','12:30:00',6.12),('11288','2013-07-26','12:35:00',6.42),('11288','2013-07-26','12:40:00',6.79),('11288','2013-07-26','12:45:00',6.79),('11288','2013-07-26','12:50:00',6.85),('11288','2013-07-26','12:55:00',5.8),('11288','2013-07-26','13:00:00',4.97),('11288','2013-07-26','13:05:00',2.12),('11288','2013-07-26','13:10:00',2.9),('11288','2013-07-26','13:15:00',2.92),('11288','2013-07-26','13:20:00',2.44),('11288','2013-07-26','13:25:00',3.08),('11288','2013-07-26','13:30:00',6.76),('11288','2013-07-26','13:35:00',7.14),('11288','2013-07-26','13:40:00',6.87),('11288','2013-07-26','13:45:00',6.04),('11288','2013-07-26','13:50:00',3.63),('11288','2013-07-26','13:55:00',7.11),('11288','2013-07-26','14:00:00',6.91),('11288','2013-07-26','14:05:00',6.59),('11288','2013-07-26','14:10:00',6.78),('11288','2013-07-26','14:15:00',6.47),('11288','2013-07-26','14:20:00',6.48),('11288','2013-07-26','14:25:00',6.42),('11288','2013-07-26','14:30:00',6.39),('11288','2013-07-26','14:35:00',6.39),('11288','2013-07-26','14:40:00',6.26),('11288','2013-07-26','14:45:00',6.26),('11288','2013-07-26','14:50:00',6.16),('11288','2013-07-26','14:55:00',6.14),('11288','2013-07-26','15:00:00',6.12),('11288','2013-07-26','15:05:00',6.04),('11288','2013-07-26','15:10:00',5.99),('11288','2013-07-26','15:15:00',5.99),('11288','2013-07-26','15:20:00',5.88),('11288','2013-07-26','15:25:00',5.79),('11288','2013-07-26','15:30:00',5.73),('11288','2013-07-26','15:35:00',5.71),('11288','2013-07-26','15:40:00',5.74),('11288','2013-07-26','15:45:00',5.62),('11288','2013-07-26','15:50:00',5.56),('11288','2013-07-26','15:55:00',5.49),('11288','2013-07-26','16:00:00',5.41),('11288','2013-07-26','16:05:00',5.33),('11288','2013-07-26','16:10:00',5.24),('11288','2013-07-26','16:15:00',5.11),('11288','2013-07-26','16:20:00',5.02),('11288','2013-07-26','16:25:00',4.93),('11288','2013-07-26','16:30:00',4.87),('11288','2013-07-26','16:35:00',4.76),('11288','2013-07-26','16:40:00',4.6),('11288','2013-07-26','16:45:00',4.51),('11288','2013-07-26','16:50:00',4.41),('11288','2013-07-26','16:55:00',4.26),('11288','2013-07-26','17:00:00',4.12),('11288','2013-07-26','17:05:00',4),('11288','2013-07-26','17:10:00',3.85),('11288','2013-07-26','17:15:00',3.77),('11288','2013-07-26','17:20:00',3.62),('11288','2013-07-26','17:25:00',3.54),('11288','2013-07-26','17:30:00',3.39),('11288','2013-07-26','17:35:00',3.22),('11288','2013-07-26','17:40:00',3.1),('11288','2013-07-26','17:45:00',2.96),('11288','2013-07-26','17:50:00',2.76),('11288','2013-07-26','17:55:00',2.61),('11288','2013-07-26','18:00:00',2.53),('11288','2013-07-26','18:05:00',2.52),('11288','2013-07-26','18:10:00',2.37),('11288','2013-07-26','18:15:00',2.2),('11288','2013-07-26','18:20:00',2.12),('11288','2013-07-26','18:25:00',2.04),('11288','2013-07-26','18:30:00',1.91),('11288','2013-07-26','18:35:00',1.76),('11288','2013-07-26','18:40:00',1.62),('11288','2013-07-26','18:45:00',1.49),('11288','2013-07-26','18:50:00',1.4),('11288','2013-07-26','18:55:00',1.27),('11288','2013-07-26','19:00:00',1.15),('11288','2013-07-26','19:05:00',1.02),('11288','2013-07-25','07:30:00',1.05),('11288','2013-07-25','07:35:00',1.14),('11288','2013-07-25','07:40:00',1.24),('11288','2013-07-25','07:45:00',1.34),('11288','2013-07-25','07:50:00',1.41),('11288','2013-07-25','07:55:00',1.56),('11288','2013-07-25','08:00:00',1.64),('11288','2013-07-25','08:05:00',1.79),('11288','2013-07-25','08:10:00',1.89),('11288','2013-07-25','08:15:00',1.92),('11288','2013-07-25','08:20:00',2.01),('11288','2013-07-25','08:25:00',2.24),('11288','2013-07-25','08:30:00',2.3),('11288','2013-07-25','08:35:00',2.51),('11288','2013-07-25','08:40:00',2.6),('11288','2013-07-25','08:45:00',2.8),('11288','2013-07-25','08:50:00',2.86),('11288','2013-07-25','08:55:00',3.09),('11288','2013-07-25','09:00:00',3.06),('11288','2013-07-25','09:05:00',3.22),('11288','2013-07-25','09:10:00',3.53),('11288','2013-07-25','09:15:00',3.63),('11288','2013-07-25','09:20:00',1.88),('11288','2013-07-25','09:25:00',3.98),('11288','2013-07-25','09:30:00',4.58),('11288','2013-07-25','09:35:00',3.77),('11288','2013-07-25','09:40:00',3.72),('11288','2013-07-25','09:45:00',2.19),('11288','2013-07-25','09:50:00',4.09),('11288','2013-07-25','09:55:00',1.76),('11288','2013-07-25','10:00:00',3.98),('11288','2013-07-25','10:05:00',4.74),('11288','2013-07-25','10:10:00',4.95),('11288','2013-07-25','10:15:00',4.88),('11288','2013-07-25','10:20:00',3.28),('11288','2013-07-25','10:25:00',5.31),('11288','2013-07-25','10:30:00',4.41),('11288','2013-07-25','10:35:00',5.2),('11288','2013-07-25','10:40:00',5.85),('11288','2013-07-25','10:45:00',5.86),('11288','2013-07-25','10:50:00',5.86),('11288','2013-07-25','10:55:00',5.9),('11288','2013-07-25','11:00:00',6.13),('11288','2013-07-25','11:05:00',5.88),('11288','2013-07-25','11:10:00',6.12),('11288','2013-07-25','11:15:00',6.31),('11288','2013-07-25','11:20:00',6.3),('11288','2013-07-25','11:25:00',6.32),('11288','2013-07-25','11:30:00',6.46),('11288','2013-07-25','11:35:00',5.5),('11288','2013-07-25','11:40:00',3.99),('11288','2013-07-25','11:45:00',2.98),('11288','2013-07-25','11:50:00',7),('11288','2013-07-25','11:55:00',6.91),('11288','2013-07-25','12:00:00',5.19),('11288','2013-07-25','12:05:00',1.65),('11288','2013-07-25','12:10:00',4.01),('11288','2013-07-25','12:15:00',4.28),('11288','2013-07-25','12:20:00',6.09),('11288','2013-07-25','12:25:00',7.35),('11288','2013-07-25','12:30:00',7.24),('11288','2013-07-25','12:35:00',6.37),('11288','2013-07-25','12:40:00',6.77),('11288','2013-07-25','12:45:00',4.85),('11288','2013-07-25','12:50:00',6.92),('11288','2013-07-25','12:55:00',7.05),('11288','2013-07-25','13:00:00',6.9),('11288','2013-07-25','13:05:00',6.93),('11288','2013-07-25','13:10:00',7),('11288','2013-07-25','13:15:00',6.86),('11288','2013-07-25','13:20:00',6.8),('11288','2013-07-25','13:25:00',6.7),('11288','2013-07-25','13:30:00',6.84),('11288','2013-07-25','13:35:00',6.87),('11288','2013-07-25','13:40:00',6.81),('11288','2013-07-25','13:45:00',6.84),('11288','2013-07-25','13:50:00',6.89),('11288','2013-07-25','13:55:00',6.81),('11288','2013-07-25','14:00:00',6.82),('11288','2013-07-25','14:05:00',6.79),('11288','2013-07-25','14:10:00',6.75),('11288','2013-07-25','14:15:00',6.71),('11288','2013-07-25','14:20:00',6.69),('11288','2013-07-25','14:25:00',6.64),('11288','2013-07-25','14:30:00',6.63),('11288','2013-07-25','14:35:00',6.59),('11288','2013-07-25','14:40:00',6.57),('11288','2013-07-25','14:45:00',6.51),('11288','2013-07-25','14:50:00',6.47),('11288','2013-07-25','14:55:00',6.38),('11288','2013-07-25','15:00:00',6.37),('11288','2013-07-25','15:05:00',6.3),('11288','2013-07-25','15:10:00',6.24),('11288','2013-07-25','15:15:00',6.18),('11288','2013-07-25','15:20:00',6.14),('11288','2013-07-25','15:25:00',6.07),('11288','2013-07-25','15:30:00',6.04),('11288','2013-07-25','15:35:00',5.98),('11288','2013-07-25','15:40:00',5.92),('11288','2013-07-25','15:45:00',5.85),('11288','2013-07-25','15:50:00',5.77),('11288','2013-07-25','15:55:00',5.68),('11288','2013-07-25','16:00:00',5.62),('11288','2013-07-25','16:05:00',5.54),('11288','2013-07-25','16:10:00',5.46),('11288','2013-07-25','16:15:00',5.33),('11288','2013-07-25','16:20:00',5.22),('11288','2013-07-25','16:25:00',5.11),('11288','2013-07-25','16:30:00',4.98),('11288','2013-07-25','16:35:00',4.93),('11288','2013-07-25','16:40:00',4.75),('11288','2013-07-25','16:45:00',4.75),('11288','2013-07-25','16:50:00',4.6),('11288','2013-07-25','16:55:00',4.47),('11288','2013-07-25','17:00:00',4.35),('11288','2013-07-25','17:05:00',4.19),('11288','2013-07-25','17:10:00',3.96),('11288','2013-07-25','17:15:00',4.01),('11288','2013-07-25','17:20:00',3.84),('11288','2013-07-25','17:25:00',3.77),('11288','2013-07-25','17:30:00',3.62),('11288','2013-07-25','17:35:00',3.47),('11288','2013-07-25','17:40:00',3.3),('11288','2013-07-25','17:45:00',3.19),('11288','2013-07-25','17:50:00',3),('11288','2013-07-25','17:55:00',2.91),('11288','2013-07-25','18:00:00',2.85),('11288','2013-07-25','18:05:00',2.75),('11288','2013-07-25','18:10:00',2.6),('11288','2013-07-25','18:15:00',2.43),('11288','2013-07-25','18:20:00',2.3),('11288','2013-07-25','18:25:00',2.14),('11288','2013-07-25','18:30:00',2.03),('11288','2013-07-25','18:35:00',1.86),('11288','2013-07-25','18:40:00',1.66),('11288','2013-07-25','18:45:00',1.64),('11288','2013-07-25','18:50:00',1.48),('11288','2013-07-25','18:55:00',1.35),('11288','2013-07-25','19:00:00',1.23),('11288','2013-07-25','19:05:00',1.08),('11288','2013-07-24','07:40:00',1.26),('11288','2013-07-24','07:45:00',1.19),('11288','2013-07-24','07:50:00',1.44),('11288','2013-07-24','07:55:00',1.51),('11288','2013-07-24','08:00:00',1.61),('11288','2013-07-24','08:05:00',1.76),('11288','2013-07-24','08:10:00',1.65),('11288','2013-07-24','08:15:00',2.07),('11288','2013-07-24','08:20:00',1.78),('11288','2013-07-24','08:25:00',2.1),('11288','2013-07-24','08:30:00',2.01),('11288','2013-07-24','08:35:00',2.07),('11288','2013-07-24','08:40:00',2.05),('11288','2013-07-24','08:45:00',3.01),('11288','2013-07-24','08:50:00',3.05),('11288','2013-07-24','08:55:00',3.21),('11288','2013-07-24','09:00:00',2.56),('11288','2013-07-24','09:05:00',3.57),('11288','2013-07-24','09:10:00',2.85),('11288','2013-07-24','09:15:00',2.37),('11288','2013-07-24','09:20:00',3.39),('11288','2013-07-24','09:25:00',3.58),('11288','2013-07-24','09:30:00',4.02),('11288','2013-07-24','09:35:00',3.15),('11288','2013-07-24','09:40:00',2.46),('11288','2013-07-24','09:45:00',3.08),('11288','2013-07-24','09:50:00',2.37),('11288','2013-07-24','09:55:00',2.1),('11288','2013-07-24','10:00:00',1.37),('11288','2013-07-24','10:05:00',1.34),('11288','2013-07-24','10:10:00',2.77),('11288','2013-07-24','10:15:00',2.35),('11288','2013-07-24','10:20:00',4.11),('11288','2013-07-24','10:25:00',5.85),('11288','2013-07-24','10:30:00',5.85),('11288','2013-07-24','10:35:00',5.99),('11288','2013-07-24','10:40:00',3.1),('11288','2013-07-24','10:45:00',3.35),('11288','2013-07-24','10:50:00',4.16),('11288','2013-07-24','10:55:00',4.38),('11288','2013-07-24','11:00:00',2.33),('11288','2013-07-24','11:05:00',4.85),('11288','2013-07-24','11:10:00',6.52),('11288','2013-07-24','11:15:00',6.46),('11288','2013-07-24','11:20:00',6.2),('11288','2013-07-24','11:25:00',5.52),('11288','2013-07-24','11:30:00',2.95),('11288','2013-07-24','11:35:00',4.29),('11288','2013-07-24','11:40:00',6.61),('11288','2013-07-24','11:45:00',6.59),('11288','2013-07-24','11:50:00',6.53),('11288','2013-07-24','11:55:00',6.73),('11288','2013-07-24','12:00:00',6.5),('11288','2013-07-24','12:05:00',5.4),('11288','2013-07-24','12:10:00',7.27),('11288','2013-07-24','12:15:00',5.95),('11288','2013-07-24','12:20:00',5.27),('11288','2013-07-24','12:25:00',3.66),('11288','2013-07-24','12:30:00',2.51),('11288','2013-07-24','12:35:00',5),('11288','2013-07-24','12:40:00',7.62),('11288','2013-07-24','12:45:00',4.88),('11288','2013-07-24','12:50:00',5.94),('11288','2013-07-24','12:55:00',7.25),('11288','2013-07-24','13:00:00',7.11),('11288','2013-07-24','13:05:00',6.63),('11288','2013-07-24','13:10:00',6.89),('11288','2013-07-24','13:15:00',6.05),('11288','2013-07-24','13:20:00',4.67),('11288','2013-07-24','13:25:00',5.65),('11288','2013-07-24','13:30:00',6.27),('11288','2013-07-24','13:35:00',3.04),('11288','2013-07-24','13:40:00',1.78),('11288','2013-07-24','13:45:00',5.86),('11288','2013-07-24','13:50:00',7.58),('11288','2013-07-24','13:55:00',4.71),('11288','2013-07-24','14:00:00',7.04),('11288','2013-07-24','14:05:00',6.56),('11288','2013-07-24','14:10:00',7.25),('11288','2013-07-24','14:15:00',6.48),('11288','2013-07-24','14:20:00',6.93),('11288','2013-07-24','14:25:00',6.96),('11288','2013-07-24','14:30:00',7),('11288','2013-07-24','14:35:00',7.05),('11288','2013-07-24','14:40:00',6.47),('11288','2013-07-24','14:45:00',6.74),('11288','2013-07-24','14:50:00',6.65),('11288','2013-07-24','14:55:00',6.6),('11288','2013-07-24','15:00:00',6.54),('11288','2013-07-24','15:05:00',6.41),('11288','2013-07-24','15:10:00',6.32),('11288','2013-07-24','15:15:00',6.38),('11288','2013-07-24','15:20:00',6.29),('11288','2013-07-24','15:25:00',6.25),('11288','2013-07-24','15:30:00',5.93),('11288','2013-07-24','15:35:00',5.8),('11288','2013-07-24','15:40:00',5.98),('11288','2013-07-24','15:45:00',5.84),('11288','2013-07-24','15:50:00',5.73),('11288','2013-07-24','15:55:00',5.74),('11288','2013-07-24','16:00:00',5.66),('11288','2013-07-24','16:05:00',5.51),('11288','2013-07-24','16:10:00',5.55),('11288','2013-07-24','16:15:00',5.4),('11288','2013-07-24','16:20:00',5.44),('11288','2013-07-24','16:25:00',5.33),('11288','2013-07-24','16:30:00',5.27),('11288','2013-07-24','16:35:00',5.14),('11288','2013-07-24','16:40:00',5.04),('11288','2013-07-24','16:45:00',4.82),('11288','2013-07-24','16:50:00',4.82),('11288','2013-07-24','16:55:00',4.87),('11288','2013-07-24','17:00:00',4.73),('11288','2013-07-24','17:05:00',4.54),('11288','2013-07-24','17:10:00',4.2),('11288','2013-07-24','17:15:00',4.16),('11288','2013-07-24','17:20:00',3.97),('11288','2013-07-24','17:25:00',3.81),('11288','2013-07-24','17:30:00',3.68),('11288','2013-07-24','17:35:00',3.5),('11288','2013-07-24','17:40:00',3.31),('11288','2013-07-24','17:45:00',3.14),('11288','2013-07-24','17:50:00',2.98),('11288','2013-07-24','17:55:00',2.87),('11288','2013-07-24','18:00:00',2.8),('11288','2013-07-24','18:05:00',2.69),('11288','2013-07-24','18:10:00',2.54),('11288','2013-07-24','18:15:00',2.37),('11288','2013-07-24','18:20:00',2.21),('11288','2013-07-24','18:25:00',2),('11288','2013-07-24','18:30:00',2),('11288','2013-07-24','18:35:00',1.93),('11288','2013-07-24','18:40:00',1.76),('11288','2013-07-24','18:45:00',1.65),('11288','2013-07-24','18:50:00',1.44),('11288','2013-07-24','18:55:00',1.33),('11288','2013-07-24','19:00:00',1.24),('11288','2013-07-24','19:05:00',1.06),('11288','2013-07-23','07:30:00',1.06),('11288','2013-07-23','07:35:00',1.18),('11288','2013-07-23','07:40:00',1.27),('11288','2013-07-23','07:45:00',1.36),('11288','2013-07-23','07:50:00',1.44),('11288','2013-07-23','07:55:00',1.48),('11288','2013-07-23','08:00:00',1.67),('11288','2013-07-23','08:05:00',1.86),('11288','2013-07-23','08:10:00',1.94),('11288','2013-07-23','08:15:00',2.04),('11288','2013-07-23','08:20:00',2.14),('11288','2013-07-23','08:25:00',2.25),('11288','2013-07-23','08:30:00',2.43),('11288','2013-07-23','08:35:00',2.57),('11288','2013-07-23','08:40:00',2.8),('11288','2013-07-23','08:45:00',2.87),('11288','2013-07-23','08:50:00',3.03),('11288','2013-07-23','08:55:00',3.19),('11288','2013-07-23','09:00:00',3.35),('11288','2013-07-23','09:05:00',3.38),('11288','2013-07-23','09:10:00',3.6),('11288','2013-07-23','09:15:00',3.64),('11288','2013-07-23','09:20:00',3.78),('11288','2013-07-23','09:25:00',3.92),('11288','2013-07-23','09:30:00',3.94),('11288','2013-07-23','09:35:00',4.21),('11288','2013-07-23','09:40:00',4.24),('11288','2013-07-23','09:45:00',4.28),('11288','2013-07-23','09:50:00',4.38),('11288','2013-07-23','09:55:00',4.55),('11288','2013-07-23','10:00:00',4.49),('11288','2013-07-23','10:05:00',4.67),('11288','2013-07-23','10:10:00',4.91),('11288','2013-07-23','10:15:00',4.94),('11288','2013-07-23','10:20:00',5.2),('11288','2013-07-23','10:25:00',5.37),('11288','2013-07-23','10:30:00',5.51),('11288','2013-07-23','10:35:00',5.61),('11288','2013-07-23','10:40:00',5.68),('11288','2013-07-23','10:45:00',5.74),('11288','2013-07-23','10:50:00',5.82),('11288','2013-07-23','10:55:00',5.94),('11288','2013-07-23','11:00:00',6.01),('11288','2013-07-23','11:05:00',6.03),('11288','2013-07-23','11:10:00',6.1),('11288','2013-07-23','11:15:00',6.21),('11288','2013-07-23','11:20:00',6.19),('11288','2013-07-23','11:25:00',6.21),('11288','2013-07-23','11:30:00',6.26),('11288','2013-07-23','11:35:00',6.35),('11288','2013-07-23','11:40:00',6.42),('11288','2013-07-23','11:45:00',6.46),('11288','2013-07-23','11:50:00',6.53),('11288','2013-07-23','11:55:00',6.6),('11288','2013-07-23','12:00:00',6.7),('11288','2013-07-23','12:05:00',6.68),('11288','2013-07-23','12:10:00',6.78),('11288','2013-07-23','12:15:00',6.88),('11288','2013-07-23','12:20:00',6.87),('11288','2013-07-23','12:25:00',6.21),('11288','2013-07-23','12:30:00',5.76),('11288','2013-07-23','12:35:00',1.76),('11288','2013-07-23','12:40:00',1.43),('11288','2013-07-23','12:45:00',2.83),('11288','2013-07-23','12:50:00',2.66),('11288','2013-07-23','12:55:00',6.26),('11288','2013-07-23','13:00:00',3.03),('11288','2013-07-23','13:05:00',1.57),('11288','2013-07-23','13:10:00',1.3),('11288','2013-07-23','13:15:00',1.04),('11288','2013-07-23','13:20:00',1.1),('11288','2013-07-23','13:25:00',1.34),('11288','2013-07-23','13:30:00',1.7),('11288','2013-07-23','13:35:00',6.98),('11288','2013-07-23','13:40:00',2.97),('11288','2013-07-23','13:45:00',1.05),('11288','2013-07-23','13:50:00',1.25),('11288','2013-07-23','13:55:00',2.63),('11288','2013-07-23','14:00:00',6.42),('11288','2013-07-23','14:05:00',7.13),('11288','2013-07-23','14:10:00',1.33),('11288','2013-07-23','14:20:00',1),('11288','2013-07-23','14:25:00',3.12),('11288','2013-07-23','14:30:00',4.62),('11288','2013-07-23','14:35:00',2.78),('11288','2013-07-23','14:40:00',2.45),('11288','2013-07-23','14:45:00',5.38),('11288','2013-07-23','14:50:00',4.85),('11288','2013-07-23','14:55:00',6.04),('11288','2013-07-23','15:00:00',7.42),('11288','2013-07-23','15:05:00',5.99),('11288','2013-07-23','15:10:00',6.52),('11288','2013-07-23','15:15:00',6.43),('11288','2013-07-23','15:20:00',6.27),('11288','2013-07-23','15:25:00',6.19),('11288','2013-07-23','15:30:00',6.14),('11288','2013-07-23','15:35:00',6.05),('11288','2013-07-23','15:40:00',5.72),('11288','2013-07-23','15:45:00',5.67),('11288','2013-07-23','15:50:00',5.69),('11288','2013-07-23','15:55:00',5.65),('11288','2013-07-23','16:00:00',5.52),('11288','2013-07-23','16:05:00',5.45),('11288','2013-07-23','16:10:00',5.34),('11288','2013-07-23','16:15:00',5.22),('11288','2013-07-23','16:20:00',5.17),('11288','2013-07-23','16:25:00',5.1),('11288','2013-07-23','16:30:00',4.99),('11288','2013-07-23','16:35:00',4.88),('11288','2013-07-23','16:40:00',4.74),('11288','2013-07-23','16:45:00',4.67),('11288','2013-07-23','16:50:00',4.59),('11288','2013-07-23','16:55:00',4.47),('11288','2013-07-23','17:00:00',4.31),('11288','2013-07-23','17:05:00',4.09),('11288','2013-07-23','17:10:00',4.05),('11288','2013-07-23','17:15:00',3.98),('11288','2013-07-23','17:20:00',3.86),('11288','2013-07-23','17:25:00',3.76),('11288','2013-07-23','17:30:00',3.64),('11288','2013-07-23','17:35:00',3.53),('11288','2013-07-23','17:40:00',3.36),('11288','2013-07-23','17:45:00',3.23),('11288','2013-07-23','17:50:00',3.09),('11288','2013-07-23','17:55:00',2.99),('11288','2013-07-23','18:00:00',2.97),('11288','2013-07-23','18:05:00',2.83),('11288','2013-07-23','18:10:00',2.64),('11288','2013-07-23','18:15:00',2.51),('11288','2013-07-23','18:20:00',2.43),('11288','2013-07-23','18:25:00',2.29),('11288','2013-07-23','18:30:00',2.16),('11288','2013-07-23','18:35:00',2),('11288','2013-07-23','18:40:00',1.55),('11288','2013-07-23','18:45:00',1.17),('11288','2013-07-23','18:50:00',1.14),('11288','2013-07-23','18:55:00',1.32),('11288','2013-07-23','19:00:00',1.25),('11288','2013-07-23','19:05:00',1.12),('11288','2013-07-22','07:30:00',1.08),('11288','2013-07-22','07:35:00',1.18),('11288','2013-07-22','07:40:00',1.27),('11288','2013-07-22','07:45:00',1.37),('11288','2013-07-22','07:50:00',1.43),('11288','2013-07-22','07:55:00',1.49),('11288','2013-07-22','08:00:00',1.7),('11288','2013-07-22','08:05:00',1.87),('11288','2013-07-22','08:10:00',1.99),('11288','2013-07-22','08:15:00',2.02),('11288','2013-07-22','08:20:00',2.14),('11288','2013-07-22','08:25:00',2.23),('11288','2013-07-22','08:30:00',2.45),('11288','2013-07-22','08:35:00',2.65),('11288','2013-07-22','08:40:00',2.83),('11288','2013-07-22','08:45:00',2.93),('11288','2013-07-22','08:50:00',3.06),('11288','2013-07-22','08:55:00',3.2),('11288','2013-07-22','09:00:00',3.31),('11288','2013-07-22','09:05:00',3.42),('11288','2013-07-22','09:10:00',3.7),('11288','2013-07-22','09:15:00',3.71),('11288','2013-07-22','09:20:00',3.81),('11288','2013-07-22','09:25:00',3.97),('11288','2013-07-22','09:30:00',4.06),('11288','2013-07-22','09:35:00',4.28),('11288','2013-07-22','09:40:00',4.34),('11288','2013-07-22','09:45:00',4.41),('11288','2013-07-22','09:50:00',4.49),('11288','2013-07-22','09:55:00',4.59),('11288','2013-07-22','10:00:00',4.7),('11288','2013-07-22','10:05:00',4.76),('11288','2013-07-22','10:10:00',5.11),('11288','2013-07-22','10:15:00',5.2),('11288','2013-07-22','10:20:00',5.33),('11288','2013-07-22','10:25:00',5.41),('11288','2013-07-22','10:30:00',5.51),('11288','2013-07-22','10:35:00',5.63),('11288','2013-07-22','10:40:00',5.7),('11288','2013-07-22','10:45:00',5.76),('11288','2013-07-22','10:50:00',5.84),('11288','2013-07-22','10:55:00',5.88),('11288','2013-07-22','11:00:00',5.98),('11288','2013-07-22','11:05:00',6.04),('11288','2013-07-22','11:10:00',6.05),('11288','2013-07-22','11:15:00',6.07),('11288','2013-07-22','11:20:00',6.15),('11288','2013-07-22','11:25:00',6.21),('11288','2013-07-22','11:30:00',6.18),('11288','2013-07-22','11:35:00',6.19),('11288','2013-07-22','11:40:00',6.26),('11288','2013-07-22','11:45:00',6.31),('11288','2013-07-22','11:50:00',6.37),('11288','2013-07-22','11:55:00',6.42),('11288','2013-07-22','12:00:00',6.43),('11288','2013-07-22','12:05:00',6.53),('11288','2013-07-22','12:10:00',6.57),('11288','2013-07-22','12:15:00',6.6),('11288','2013-07-22','12:20:00',6.6),('11288','2013-07-22','12:25:00',6.6),('11288','2013-07-22','12:30:00',6.6),('11288','2013-07-22','12:35:00',6.69),('11288','2013-07-22','12:40:00',6.72),('11288','2013-07-22','12:45:00',6.71),('11288','2013-07-22','12:50:00',6.72),('11288','2013-07-22','12:55:00',6.68),('11288','2013-07-22','13:00:00',6.66),('11288','2013-07-22','13:05:00',6.71),('11288','2013-07-22','13:10:00',6.73),('11288','2013-07-22','13:15:00',6.72),('11288','2013-07-22','13:20:00',6.77),('11288','2013-07-22','13:25:00',6.83),('11288','2013-07-22','13:30:00',6.77),('11288','2013-07-22','13:35:00',6.76),('11288','2013-07-22','13:40:00',6.72),('11288','2013-07-22','13:45:00',6.8),('11288','2013-07-22','13:50:00',6.71),('11288','2013-07-22','13:55:00',6.68),('11288','2013-07-22','14:00:00',6.66),('11288','2013-07-22','14:05:00',6.61),('11288','2013-07-22','14:10:00',6.52),('11288','2013-07-22','14:15:00',6.5),('11288','2013-07-22','14:20:00',6.47),('11288','2013-07-22','14:25:00',6.43),('11288','2013-07-22','14:30:00',6.44),('11288','2013-07-22','14:35:00',6.4),('11288','2013-07-22','14:40:00',6.31),('11288','2013-07-22','14:45:00',6.3),('11288','2013-07-22','14:50:00',6.31),('11288','2013-07-22','14:55:00',6.23),('11288','2013-07-22','15:00:00',6.16),('11288','2013-07-22','15:05:00',6.11),('11288','2013-07-22','15:10:00',6.22),('11288','2013-07-22','15:15:00',6.06),('11288','2013-07-22','15:20:00',5.98),('11288','2013-07-22','15:25:00',6.03),('11288','2013-07-22','15:30:00',4.25),('11288','2013-07-22','15:35:00',1.27),('11288','2013-07-22','15:40:00',1.99),('11288','2013-07-22','15:45:00',2.84),('11288','2013-07-22','15:50:00',6.3),('11288','2013-07-22','15:55:00',6.35),('11288','2013-07-22','16:00:00',6.36),('11288','2013-07-22','16:05:00',6.11),('11288','2013-07-22','16:10:00',5.81),('11288','2013-07-22','16:15:00',5.29),('11288','2013-07-22','16:20:00',5.64),('11288','2013-07-22','16:25:00',5.41),('11288','2013-07-22','16:30:00',5.15),('11288','2013-07-22','16:35:00',5.04),('11288','2013-07-22','16:40:00',4.69),('11288','2013-07-22','16:45:00',4.52),('11288','2013-07-22','16:50:00',4.48),('11288','2013-07-22','16:55:00',4.41),('11288','2013-07-22','17:00:00',4.25),('11288','2013-07-22','17:05:00',4.09),('11288','2013-07-22','17:10:00',4),('11288','2013-07-22','17:15:00',3.92),('11288','2013-07-22','17:20:00',3.8),('11288','2013-07-22','17:25:00',3.56),('11288','2013-07-22','17:30:00',3.41),('11288','2013-07-22','17:35:00',3.44),('11288','2013-07-22','17:40:00',3.31),('11288','2013-07-22','17:45:00',2.94),('11288','2013-07-22','17:50:00',2.82),('11288','2013-07-22','17:55:00',2.87),('11288','2013-07-22','18:00:00',2.94),('11288','2013-07-22','18:05:00',2.76),('11288','2013-07-22','18:10:00',2.5),('11288','2013-07-22','18:15:00',2.32),('11288','2013-07-22','18:20:00',2.24),('11288','2013-07-22','18:25:00',2.18),('11288','2013-07-22','18:30:00',1.97),('11288','2013-07-22','18:35:00',1.87),('11288','2013-07-22','18:40:00',1.7),('11288','2013-07-22','18:45:00',1.59),('11288','2013-07-22','18:50:00',1.46),('11288','2013-07-22','18:55:00',1.32),('11288','2013-07-22','19:00:00',1.1),('11288','2013-07-22','19:05:00',1.13),('11288','2013-07-22','19:10:00',1.06),('11288','2013-07-21','07:25:00',1.05),('11288','2013-07-21','07:30:00',1.13),('11288','2013-07-21','07:35:00',1.23),('11288','2013-07-21','07:40:00',1.36),('11288','2013-07-21','07:45:00',1.48),('11288','2013-07-21','07:50:00',1.52),('11288','2013-07-21','07:55:00',1.58),('11288','2013-07-21','08:00:00',1.75),('11288','2013-07-21','08:05:00',1.84),('11288','2013-07-21','08:10:00',1.98),('11288','2013-07-21','08:15:00',2.06),('11288','2013-07-21','08:20:00',2.06),('11288','2013-07-21','08:25:00',2.19),('11288','2013-07-21','08:30:00',2.41),('11288','2013-07-21','08:35:00',2.62),('11288','2013-07-21','08:40:00',2.76),('11288','2013-07-21','08:45:00',2.85),('11288','2013-07-21','08:50:00',2.94),('11288','2013-07-21','08:55:00',3.14),('11288','2013-07-21','09:00:00',3.21),('11288','2013-07-21','09:05:00',3.33),('11288','2013-07-21','09:10:00',3.6),('11288','2013-07-21','09:15:00',3.64),('11288','2013-07-21','09:20:00',3.7),('11288','2013-07-21','09:25:00',3.89),('11288','2013-07-21','09:30:00',4),('11288','2013-07-21','09:35:00',4.13),('11288','2013-07-21','09:40:00',4.24),('11288','2013-07-21','09:45:00',4.32),('11288','2013-07-21','09:50:00',4.37),('11288','2013-07-21','09:55:00',4.61),('11288','2013-07-21','10:00:00',4.75),('11288','2013-07-21','10:05:00',4.88),('11288','2013-07-21','10:10:00',4.97),('11288','2013-07-21','10:15:00',5.07),('11288','2013-07-21','10:20:00',5.23),('11288','2013-07-21','10:25:00',5.29),('11288','2013-07-21','10:30:00',5.37),('11288','2013-07-21','10:35:00',5.47),('11288','2013-07-21','10:40:00',5.54),('11288','2013-07-21','10:45:00',5.57),('11288','2013-07-21','10:50:00',5.68),('11288','2013-07-21','10:55:00',5.76),('11288','2013-07-21','11:00:00',5.85),('11288','2013-07-21','11:05:00',5.96),('11288','2013-07-21','11:10:00',5.97),('11288','2013-07-21','11:15:00',5.98),('11288','2013-07-21','11:20:00',5.99),('11288','2013-07-21','11:25:00',6.07),('11288','2013-07-21','11:30:00',6.19),('11288','2013-07-21','11:35:00',6.19),('11288','2013-07-21','11:40:00',6.35),('11288','2013-07-21','11:45:00',6.4),('11288','2013-07-21','11:50:00',6.35),('11288','2013-07-21','11:55:00',6.39),('11288','2013-07-21','12:00:00',6.44),('11288','2013-07-21','12:05:00',6.44),('11288','2013-07-21','12:10:00',6.22),('11288','2013-07-21','12:15:00',6.65),('11288','2013-07-21','12:20:00',7.11),('11288','2013-07-21','12:25:00',7.48),('11288','2013-07-21','12:30:00',5.9),('11288','2013-07-21','12:35:00',7.09),('11288','2013-07-21','12:40:00',7.93),('11288','2013-07-21','12:45:00',7.86),('11288','2013-07-21','12:50:00',7.72),('11288','2013-07-21','12:55:00',7.71),('11288','2013-07-21','13:00:00',8.04),('11288','2013-07-21','13:05:00',7.76),('11288','2013-07-21','13:10:00',6.17),('11288','2013-07-21','13:15:00',4.1),('11288','2013-07-21','13:20:00',6.91),('11288','2013-07-21','13:25:00',6.58),('11288','2013-07-21','13:30:00',7.47),('11288','2013-07-21','13:35:00',7.25),('11288','2013-07-21','13:40:00',7.2),('11288','2013-07-21','13:45:00',6.93),('11288','2013-07-21','13:50:00',4.67),('11288','2013-07-21','13:55:00',1.75),('11288','2013-07-21','14:00:00',1.83),('11288','2013-07-21','14:05:00',2.04),('11288','2013-07-21','14:10:00',1.93),('11288','2013-07-21','14:15:00',1.94),('11288','2013-07-21','14:20:00',2.4),('11288','2013-07-21','14:25:00',2.61),('11288','2013-07-21','14:30:00',2.17),('11288','2013-07-21','14:35:00',2.19),('11288','2013-07-21','14:40:00',2.23),('11288','2013-07-21','14:45:00',2.47),('11288','2013-07-21','14:50:00',2.85),('11288','2013-07-21','14:55:00',2.93),('11288','2013-07-21','15:00:00',3.43),('11288','2013-07-21','15:05:00',3.2),('11288','2013-07-21','15:10:00',3.18),('11288','2013-07-21','15:15:00',6.27),('11288','2013-07-21','15:20:00',7.42),('11288','2013-07-21','15:25:00',2.92),('11288','2013-07-21','15:30:00',2.61),('11288','2013-07-21','15:35:00',2.97),('11288','2013-07-21','15:40:00',4.68),('11288','2013-07-21','15:45:00',6.4),('11288','2013-07-21','15:50:00',5.08),('11288','2013-07-21','15:55:00',4.2),('11288','2013-07-21','16:00:00',2.37),('11288','2013-07-21','16:05:00',1.81),('11288','2013-07-21','16:10:00',1.56),('11288','2013-07-21','16:15:00',1.39),('11288','2013-07-21','16:20:00',1.3),('11288','2013-07-21','16:25:00',1.34),('11288','2013-07-21','16:30:00',1.39),('11288','2013-07-21','16:35:00',1.52),('11288','2013-07-21','16:40:00',1.6),('11288','2013-07-21','16:45:00',1.63),('11288','2013-07-21','16:50:00',1.67),('11288','2013-07-21','16:55:00',1.88),('11288','2013-07-21','17:00:00',2.13),('11288','2013-07-21','17:05:00',2.3),('11288','2013-07-21','17:10:00',2.37),('11288','2013-07-21','17:15:00',1.99),('11288','2013-07-21','17:20:00',1.77),('11288','2013-07-21','17:25:00',1.6),('11288','2013-07-21','17:30:00',1.51),('11288','2013-07-21','17:35:00',1.45),('11288','2013-07-21','17:40:00',1.44),('11288','2013-07-21','17:45:00',1.42),('11288','2013-07-21','17:50:00',1.44),('11288','2013-07-21','17:55:00',1.47),('11288','2013-07-21','18:00:00',1.46),('11288','2013-07-21','18:05:00',1.37),('11288','2013-07-21','18:10:00',1.19),('11288','2013-07-21','18:15:00',1.03),('11288','2014-04-07','08:10:00',1.29),('11288','2014-04-07','08:15:00',1.4),('11288','2014-04-07','08:20:00',1.59),('11288','2014-04-07','08:25:00',1.72),('11288','2014-04-07','08:30:00',1.98),('11288','2014-04-07','08:35:00',2.33),('11288','2014-04-07','08:40:00',2.46),('11288','2014-04-07','08:45:00',2.28),('11288','2014-04-07','08:50:00',2.2),('11288','2014-04-07','08:55:00',2.12),('11288','2014-04-07','09:00:00',2.04),('11288','2014-04-07','09:05:00',2.08),('11288','2014-04-07','09:10:00',2.38),('11288','2014-04-07','09:15:00',2.62),('11288','2014-04-07','09:20:00',2.21),('11288','2014-04-07','09:25:00',2.1),('11288','2014-04-07','09:30:00',2.07),('11288','2014-04-07','09:35:00',2.01),('11288','2014-04-07','09:40:00',2.08),('11288','2014-04-07','09:45:00',2.19),('11288','2014-04-07','09:50:00',2.3),('11288','2014-04-07','09:55:00',2.39),('11288','2014-04-07','10:00:00',2.41),('11288','2014-04-07','10:05:00',2.41),('11288','2014-04-07','10:10:00',2.45),('11288','2014-04-07','10:15:00',2.29),('11288','2014-04-07','10:20:00',2.29),('11288','2014-04-07','10:25:00',2.34),('11288','2014-04-07','10:30:00',2.4),('11288','2014-04-07','10:35:00',2.54),('11288','2014-04-07','10:40:00',2.6),('11288','2014-04-07','10:45:00',2.68),('11288','2014-04-07','10:50:00',2.81),('11288','2014-04-07','10:55:00',3.01),('11288','2014-04-07','11:00:00',3.26),('11288','2014-04-07','11:05:00',3.29),('11288','2014-04-07','11:10:00',3.64),('11288','2014-04-07','11:15:00',3.82),('11288','2014-04-07','11:20:00',3.8),('11288','2014-04-07','11:25:00',3.42),('11288','2014-04-07','11:30:00',3.39),('11288','2014-04-07','11:35:00',3.38),('11288','2014-04-07','11:40:00',3.35),('11288','2014-04-07','11:45:00',3.17),('11288','2014-04-07','11:50:00',2.99),('11288','2014-04-07','11:55:00',2.89),('11288','2014-04-07','12:00:00',3.14),('11288','2014-04-07','12:05:00',3.88),('11288','2014-04-07','12:10:00',4.08),('11288','2014-04-07','12:15:00',5.41),('11288','2014-04-07','12:20:00',6.47),('11288','2014-04-07','12:25:00',6.01),('11288','2014-04-07','12:30:00',3.89),('11288','2014-04-07','12:35:00',3.53),('11288','2014-04-07','12:40:00',4.13),('11288','2014-04-07','12:45:00',6.45),('11288','2014-04-07','12:50:00',6.52),('11288','2014-04-07','12:55:00',6.37),('11288','2014-04-07','13:00:00',6.38),('11288','2014-04-07','13:05:00',6.4),('11288','2014-04-07','13:10:00',6.31),('11288','2014-04-07','13:15:00',6.3),('11288','2014-04-07','13:20:00',6.26),('11288','2014-04-07','13:25:00',6.26),('11288','2014-04-07','13:30:00',6.3),('11288','2014-04-07','13:35:00',6.29),('11288','2014-04-07','13:40:00',6.23),('11288','2014-04-07','13:45:00',6.24),('11288','2014-04-07','13:50:00',6.32),('11288','2014-04-07','13:55:00',6.33),('11288','2014-04-07','14:00:00',6.27),('11288','2014-04-07','14:05:00',6.23),('11288','2014-04-07','14:10:00',6.16),('11288','2014-04-07','14:15:00',6.05),('11288','2014-04-07','14:20:00',6.03),('11288','2014-04-07','14:25:00',6.15),('11288','2014-04-07','14:30:00',6.13),('11288','2014-04-07','14:35:00',5.97),('11288','2014-04-07','14:40:00',5.9),('11288','2014-04-07','14:45:00',5.91),('11288','2014-04-07','14:50:00',5.86),('11288','2014-04-07','14:55:00',5.83),('11288','2014-04-07','15:00:00',5.11),('11288','2014-04-07','15:05:00',5.84),('11288','2014-04-07','15:10:00',5.71),('11288','2014-04-07','15:15:00',5.88),('11288','2014-04-07','15:20:00',6.07),('11288','2014-04-07','15:25:00',6),('11288','2014-04-07','15:30:00',5.62),('11288','2014-04-07','15:35:00',5.54),('11288','2014-04-07','15:40:00',5.49),('11288','2014-04-07','15:45:00',5.58),('11288','2014-04-07','15:50:00',5.81),('11288','2014-04-07','15:55:00',5.72),('11288','2014-04-07','16:00:00',4.46),('11288','2014-04-07','16:05:00',3.39),('11288','2014-04-07','16:10:00',4.95),('11288','2014-04-07','16:15:00',4.59),('11288','2014-04-07','16:20:00',4.26),('11288','2014-04-07','16:25:00',4.15),('11288','2014-04-07','16:30:00',3.9),('11288','2014-04-07','16:35:00',2.11),('11288','2014-04-07','16:40:00',2.43),('11288','2014-04-07','16:45:00',2.62),('11288','2014-04-07','16:50:00',3.37),('11288','2014-04-07','16:55:00',3.57),('11288','2014-04-07','17:00:00',3.94),('11288','2014-04-07','17:05:00',3.74),('11288','2014-04-07','17:10:00',2.9),('11288','2014-04-07','17:15:00',3.02),('11288','2014-04-07','17:20:00',2.54),('11288','2014-04-07','17:25:00',1.6),('11288','2014-04-07','17:30:00',1.27),('11288','2014-04-07','17:35:00',1.05),('11288','2014-04-07','17:45:00',1.34),('11288','2014-04-07','17:50:00',1.25),('11288','2014-04-07','17:55:00',1.65),('11288','2014-04-07','18:00:00',1.55),('11288','2014-04-07','18:05:00',1.44),('11288','2014-04-07','18:10:00',1.41),('11288','2014-04-07','18:15:00',1.4),('11288','2014-04-07','18:20:00',1.24),('11288','2014-04-07','18:25:00',1.1),('11288','2013-07-20','07:30:00',1.08),('11288','2013-07-20','07:35:00',1.18),('11288','2013-07-20','07:40:00',1.28),('11288','2013-07-20','07:45:00',1.36),('11288','2013-07-20','07:50:00',1.45),('11288','2013-07-20','07:55:00',1.58),('11288','2013-07-20','08:00:00',1.73),('11288','2013-07-20','08:05:00',1.89),('11288','2013-07-20','08:10:00',1.96),('11288','2013-07-20','08:15:00',2.08),('11288','2013-07-20','08:20:00',2.15),('11288','2013-07-20','08:25:00',2.11),('11288','2013-07-20','08:30:00',2.44),('11288','2013-07-20','08:35:00',2.67),('11288','2013-07-20','08:40:00',2.83),('11288','2013-07-20','08:45:00',2.93),('11288','2013-07-20','08:50:00',3.15),('11288','2013-07-20','08:55:00',3.29),('11288','2013-07-20','09:00:00',3.39),('11288','2013-07-20','09:05:00',3.6),('11288','2013-07-20','09:10:00',3.82),('11288','2013-07-20','09:15:00',3.91),('11288','2013-07-20','09:20:00',4.02),('11288','2013-07-20','09:25:00',4),('11288','2013-07-20','09:30:00',3.98),('11288','2013-07-20','09:35:00',4.05),('11288','2013-07-20','09:40:00',4.04),('11288','2013-07-20','09:45:00',4.45),('11288','2013-07-20','09:50:00',4.4),('11288','2013-07-20','09:55:00',4.2),('11288','2013-07-20','10:00:00',4.51),('11288','2013-07-20','10:05:00',4.92),('11288','2013-07-20','10:10:00',5.12),('11288','2013-07-20','10:15:00',5.21),('11288','2013-07-20','10:20:00',5.34),('11288','2013-07-20','10:25:00',5.37),('11288','2013-07-20','10:30:00',5.49),('11288','2013-07-20','10:35:00',5.56),('11288','2013-07-20','10:40:00',5.61),('11288','2013-07-20','10:45:00',5.64),('11288','2013-07-20','10:50:00',5.77),('11288','2013-07-20','10:55:00',5.9),('11288','2013-07-20','11:00:00',6),('11288','2013-07-20','11:05:00',6.03),('11288','2013-07-20','11:10:00',6.05),('11288','2013-07-20','11:15:00',6.07),('11288','2013-07-20','11:20:00',6),('11288','2013-07-20','11:25:00',6.11),('11288','2013-07-20','11:30:00',6.12),('11288','2013-07-20','11:35:00',6.24),('11288','2013-07-20','11:40:00',6.27),('11288','2013-07-20','11:45:00',6.28),('11288','2013-07-20','11:50:00',6.32),('11288','2013-07-20','11:55:00',6.56),('11288','2013-07-20','12:00:00',6.56),('11288','2013-07-20','12:05:00',6.68),('11288','2013-07-20','12:10:00',6.58),('11288','2013-07-20','12:15:00',6.56),('11288','2013-07-20','12:20:00',6.63),('11288','2013-07-20','12:25:00',6.56),('11288','2013-07-20','12:30:00',6.59),('11288','2013-07-20','12:35:00',6.7),('11288','2013-07-20','12:40:00',6.79),('11288','2013-07-20','12:45:00',6.81),('11288','2013-07-20','12:50:00',6.74),('11288','2013-07-20','12:55:00',6.73),('11288','2013-07-20','13:00:00',7),('11288','2013-07-20','13:05:00',4.68),('11288','2013-07-20','13:10:00',1.66),('11288','2013-07-20','13:15:00',1.99),('11288','2013-07-20','13:20:00',3.33),('11288','2013-07-20','13:25:00',3.31),('11288','2013-07-20','13:30:00',4.91),('11288','2013-07-20','13:35:00',7.52),('11288','2013-07-20','13:40:00',6.49),('11288','2013-07-20','13:45:00',6.83),('11288','2013-07-20','13:50:00',3.01),('11288','2013-07-20','13:55:00',1.79),('11288','2013-07-20','14:00:00',6.6),('11288','2013-07-20','14:05:00',7.08),('11288','2013-07-20','14:10:00',7.14),('11288','2013-07-20','14:15:00',7.09),('11288','2013-07-20','14:20:00',6.96),('11288','2013-07-20','14:25:00',6.55),('11288','2013-07-20','14:30:00',6.6),('11288','2013-07-20','14:35:00',6.6),('11288','2013-07-20','14:40:00',5.94),('11288','2013-07-20','14:45:00',6.68),('11288','2013-07-20','14:50:00',6.75),('11288','2013-07-20','14:55:00',6.7),('11288','2013-07-20','15:00:00',6.56),('11288','2013-07-20','15:05:00',6.4),('11288','2013-07-20','15:10:00',6.3),('11288','2013-07-20','15:15:00',6.23),('11288','2013-07-20','15:20:00',6.08),('11288','2013-07-20','15:25:00',6.04),('11288','2013-07-20','15:30:00',6),('11288','2013-07-20','15:35:00',5.95),('11288','2013-07-20','15:40:00',5.9),('11288','2013-07-20','15:45:00',5.87),('11288','2013-07-20','15:50:00',5.76),('11288','2013-07-20','15:55:00',5.64),('11288','2013-07-20','16:00:00',5.63),('11288','2013-07-20','16:05:00',5.56),('11288','2013-07-20','16:10:00',5.44),('11288','2013-07-20','16:15:00',5.39),('11288','2013-07-20','16:20:00',5.25),('11288','2013-07-20','16:25:00',5.18),('11288','2013-07-20','16:30:00',5.05),('11288','2013-07-20','16:35:00',4.9),('11288','2013-07-20','16:40:00',4.79),('11288','2013-07-20','16:45:00',4.7),('11288','2013-07-20','16:50:00',4.63),('11288','2013-07-20','16:55:00',4.43),('11288','2013-07-20','17:00:00',4.25),('11288','2013-07-20','17:05:00',4.05),('11288','2013-07-20','17:10:00',4.07),('11288','2013-07-20','17:15:00',3.96),('11288','2013-07-20','17:20:00',3.83),('11288','2013-07-20','17:25:00',3.7),('11288','2013-07-20','17:30:00',3.59),('11288','2013-07-20','17:35:00',3.48),('11288','2013-07-20','17:40:00',3.31),('11288','2013-07-20','17:45:00',3.2),('11288','2013-07-20','17:50:00',3.09),('11288','2013-07-20','17:55:00',3.04),('11288','2013-07-20','18:00:00',2.94),('11288','2013-07-20','18:05:00',2.78),('11288','2013-07-20','18:10:00',2.64),('11288','2013-07-20','18:15:00',2.52),('11288','2013-07-20','18:20:00',2.39),('11288','2013-07-20','18:25:00',2.26),('11288','2013-07-20','18:30:00',2.1),('11288','2013-07-20','18:35:00',1.96),('11288','2013-07-20','18:40:00',1.85),('11288','2013-07-20','18:45:00',1.68),('11288','2013-07-20','18:50:00',1.55),('11288','2013-07-20','18:55:00',1.44),('11288','2013-07-20','19:00:00',1.32),('11288','2013-07-20','19:05:00',1.18),('11288','2013-07-20','19:10:00',1.04),('11288','2013-07-19','07:25:00',1.04),('11288','2013-07-19','07:30:00',1.12),('11288','2013-07-19','07:35:00',1.21),('11288','2013-07-19','07:40:00',1.32),('11288','2013-07-19','07:45:00',1.4),('11288','2013-07-19','07:50:00',1.49),('11288','2013-07-19','07:55:00',1.65),('11288','2013-07-19','08:00:00',1.8),('11288','2013-07-19','08:05:00',1.89),('11288','2013-07-19','08:10:00',1.99),('11288','2013-07-19','08:15:00',2.1),('11288','2013-07-19','08:20:00',2.24),('11288','2013-07-19','08:35:00',2.65),('11288','2013-07-19','08:40:00',2.76),('11288','2013-07-19','08:45:00',2.88),('11288','2013-07-19','08:50:00',2.94),('11288','2013-07-19','08:55:00',2.85),('11288','2013-07-19','09:00:00',3.3),('11288','2013-07-19','09:05:00',3.44),('11288','2013-07-19','09:10:00',3.55),('11288','2013-07-19','09:15:00',2.89),('11288','2013-07-19','09:20:00',3.75),('11288','2013-07-19','09:25:00',3.92),('11288','2013-07-19','09:30:00',4.05),('11288','2013-07-19','09:45:00',3.36),('11288','2013-07-19','09:50:00',4.34),('11288','2013-07-19','09:55:00',4.39),('11288','2013-07-19','10:00:00',4.53),('11288','2013-07-19','10:05:00',3.52),('11288','2013-07-19','10:10:00',4.88),('11288','2013-07-19','10:15:00',4.98),('11288','2013-07-19','10:20:00',5.09),('11288','2013-07-19','10:25:00',3.88),('11288','2013-07-19','10:30:00',5.25),('11288','2013-07-19','10:35:00',5.39),('11288','2013-07-19','10:40:00',5.49),('11288','2013-07-19','10:45:00',4.15),('11288','2013-07-19','10:50:00',5.25),('11288','2013-07-19','10:55:00',5.61),('11288','2013-07-19','11:00:00',5.71),('11288','2013-07-19','11:05:00',5.25),('11288','2013-07-19','11:10:00',4.65),('11288','2013-07-19','11:15:00',5.96),('11288','2013-07-19','11:20:00',5.96),('11288','2013-07-19','11:25:00',5.95),('11288','2013-07-19','11:30:00',6.05),('11288','2013-07-19','11:35:00',6.05),('11288','2013-07-19','11:40:00',6.18),('11288','2013-07-19','11:45:00',6.28),('11288','2013-07-19','11:50:00',6.17),('11288','2013-07-19','11:55:00',5.99),('11288','2013-07-19','12:00:00',6.4),('11288','2013-07-19','12:05:00',6.82),('11288','2013-07-19','12:10:00',6.69),('11288','2013-07-19','12:15:00',6.83),('11288','2013-07-19','12:20:00',6.64),('11288','2013-07-19','12:25:00',6.64),('11288','2013-07-19','12:30:00',6.66),('11288','2013-07-19','12:35:00',6.57),('11288','2013-07-19','12:40:00',6.46),('11288','2013-07-19','12:45:00',6.52),('11288','2013-07-19','12:50:00',6.79),('11288','2013-07-19','12:55:00',6.15),('11288','2013-07-19','13:00:00',5.33),('11288','2013-07-19','13:05:00',6.87),('11288','2013-07-19','13:10:00',4.59),('11288','2013-07-19','13:15:00',2.74),('11288','2013-07-19','13:20:00',5.7),('11288','2013-07-19','13:25:00',7.3),('11288','2013-07-19','13:30:00',7.16),('11288','2013-07-19','13:35:00',7.02),('11288','2013-07-19','13:40:00',7.03),('11288','2013-07-19','13:45:00',6.98),('11288','2013-07-19','13:50:00',6.99),('11288','2013-07-19','13:55:00',6.99),('11288','2013-07-19','14:00:00',6.91),('11288','2013-07-19','14:05:00',6.66),('11288','2013-07-19','14:10:00',6.12),('11288','2013-07-19','14:15:00',6.4),('11288','2013-07-19','14:20:00',6.5),('11288','2013-07-19','14:25:00',6.64),('11288','2013-07-19','14:30:00',6.9),('11288','2013-07-19','14:35:00',5.99),('11288','2013-07-19','14:40:00',6.63),('11288','2013-07-19','14:45:00',6.54),('11288','2013-07-19','14:50:00',6.65),('11288','2013-07-19','14:55:00',6.69),('11288','2013-07-19','15:00:00',6.43),('11288','2013-07-19','15:05:00',6.58),('11288','2013-07-19','15:10:00',6.16),('11288','2013-07-19','15:15:00',3.69),('11288','2013-07-19','15:20:00',5.31),('11288','2013-07-19','15:25:00',5.8),('11288','2013-07-19','15:30:00',6.53),('11288','2013-07-19','15:35:00',6.41),('11288','2013-07-19','15:40:00',6.32),('11288','2013-07-19','15:45:00',6.12),('11288','2013-07-19','15:50:00',5.83),('11288','2013-07-19','15:55:00',5.91),('11288','2013-07-19','16:00:00',5.78),('11288','2013-07-19','16:05:00',5.71),('11288','2013-07-19','16:10:00',5.66),('11288','2013-07-19','16:15:00',5.54),('11288','2013-07-19','16:20:00',5.43),('11288','2013-07-19','16:25:00',5.34),('11288','2013-07-19','16:30:00',5.32),('11288','2013-07-19','16:35:00',5.23),('11288','2013-07-19','16:40:00',5.11),('11288','2013-07-19','16:45:00',5.06),('11288','2013-07-19','16:50:00',5),('11288','2013-07-19','16:55:00',4.95),('11288','2013-07-19','17:00:00',4.82),('11288','2013-07-19','17:05:00',4.24),('11288','2013-07-19','17:10:00',4.36),('11288','2013-07-19','17:15:00',3.96),('11288','2013-07-19','17:20:00',3.61),('11288','2013-07-19','17:25:00',3.08),('11288','2013-07-19','17:30:00',3.75),('11288','2013-07-19','17:35:00',4.11),('11288','2013-07-19','17:40:00',3.22),('11288','2013-07-19','17:45:00',2.53),('11288','2013-07-19','17:50:00',1.73),('11288','2013-07-19','17:55:00',1.54),('11288','2013-07-19','18:00:00',1.36),('11288','2013-07-19','18:05:00',1.15),('11288','2013-07-19','18:10:00',1.04),('11288','2013-07-18','07:30:00',1.11),('11288','2013-07-18','07:35:00',1.21),('11288','2013-07-18','07:40:00',1.33),('11288','2013-07-18','07:45:00',1.43),('11288','2013-07-18','07:50:00',1.48),('11288','2013-07-18','07:55:00',1.68),('11288','2013-07-18','08:00:00',1.85),('11288','2013-07-18','08:05:00',1.91),('11288','2013-07-18','08:10:00',2),('11288','2013-07-18','08:15:00',2.22),('11288','2013-07-18','08:20:00',2.21),('11288','2013-07-18','08:25:00',2.17),('11288','2013-07-18','08:30:00',2.52),('11288','2013-07-18','08:35:00',2.76),('11288','2013-07-18','08:40:00',2.8),('11288','2013-07-18','08:45:00',3.04),('11288','2013-07-18','08:50:00',3.22),('11288','2013-07-18','08:55:00',3.31),('11288','2013-07-18','09:00:00',3.4),('11288','2013-07-18','09:05:00',3.47),('11288','2013-07-18','09:10:00',3.61),('11288','2013-07-18','09:15:00',3.72),('11288','2013-07-18','09:20:00',3.91),('11288','2013-07-18','09:25:00',4.03),('11288','2013-07-18','09:30:00',4.15),('11288','2013-07-18','09:35:00',4.33),('11288','2013-07-18','09:40:00',4.34),('11288','2013-07-18','09:45:00',4.37),('11288','2013-07-18','09:50:00',4.61),('11288','2013-07-18','09:55:00',4.56),('11288','2013-07-18','10:00:00',4.64),('11288','2013-07-18','10:05:00',5.01),('11288','2013-07-18','10:10:00',5.07),('11288','2013-07-18','10:15:00',5.19),('11288','2013-07-18','10:20:00',5.33),('11288','2013-07-18','10:25:00',5.41),('11288','2013-07-18','10:30:00',5.5),('11288','2013-07-18','10:35:00',5.6),('11288','2013-07-18','10:40:00',5.68),('11288','2013-07-18','10:45:00',5.78),('11288','2013-07-18','10:50:00',5.83),('11288','2013-07-18','10:55:00',5.88),('11288','2013-07-18','11:00:00',5.98),('11288','2013-07-18','11:05:00',6.04),('11288','2013-07-18','11:10:00',6.08),('11288','2013-07-18','11:15:00',6.16),('11288','2013-07-18','11:20:00',6.15),('11288','2013-07-18','11:25:00',6.21),('11288','2013-07-18','11:30:00',6.25),('11288','2013-07-18','11:35:00',6.29),('11288','2013-07-18','11:40:00',6.3),('11288','2013-07-18','11:45:00',6.31),('11288','2013-07-18','11:50:00',6.38),('11288','2013-07-18','11:55:00',6.48),('11288','2013-07-18','12:00:00',6.49),('11288','2013-07-18','12:05:00',6.39),('11288','2013-07-18','12:10:00',6.4),('11288','2013-07-18','12:15:00',6.5),('11288','2013-07-18','12:20:00',6.5),('11288','2013-07-18','12:25:00',6.55),('11288','2013-07-18','12:30:00',6.82),('11288','2013-07-18','12:35:00',6.77),('11288','2013-07-18','12:40:00',6.9),('11288','2013-07-18','12:45:00',7.17),('11288','2013-07-18','12:50:00',6.8),('11288','2013-07-18','12:55:00',6.87),('11288','2013-07-18','13:00:00',6.9),('11288','2013-07-18','13:05:00',6.71),('11288','2013-07-18','13:10:00',6.86),('11288','2013-07-18','13:15:00',6.79),('11288','2013-07-18','13:20:00',6.68),('11288','2013-07-18','13:25:00',6.55),('11288','2013-07-18','13:30:00',5.9),('11288','2013-07-18','13:35:00',6.92),('11288','2013-07-18','13:40:00',6.88),('11288','2013-07-18','13:45:00',6.91),('11288','2013-07-18','13:50:00',6.95),('11288','2013-07-18','13:55:00',6.84),('11288','2013-07-18','14:00:00',6.72),('11288','2013-07-18','14:05:00',6.73),('11288','2013-07-18','14:10:00',6.77),('11288','2013-07-18','14:15:00',6.74),('11288','2013-07-18','14:20:00',6.61),('11288','2013-07-18','14:25:00',6.51),('11288','2013-07-18','14:30:00',6.62),('11288','2013-07-18','14:35:00',6.6),('11288','2013-07-18','14:40:00',6.51),('11288','2013-07-18','14:45:00',6.43),('11288','2013-07-18','14:50:00',6.31),('11288','2013-07-18','14:55:00',6.33),('11288','2013-07-18','15:00:00',6.35),('11288','2013-07-18','15:05:00',6.29),('11288','2013-07-18','15:10:00',6.18),('11288','2013-07-18','15:15:00',6.16),('11288','2013-07-18','15:20:00',6.16),('11288','2013-07-18','15:25:00',6.11),('11288','2013-07-18','15:30:00',6.04),('11288','2013-07-18','15:35:00',5.98),('11288','2013-07-18','15:40:00',5.9),('11288','2013-07-18','15:45:00',5.86),('11288','2013-07-18','15:50:00',5.73),('11288','2013-07-18','15:55:00',5.65),('11288','2013-07-18','16:00:00',5.59),('11288','2013-07-18','16:05:00',5.51),('11288','2013-07-18','16:10:00',5.44),('11288','2013-07-18','16:15:00',5.32),('11288','2013-07-18','16:20:00',5.15),('11288','2013-07-18','16:25:00',5.11),('11288','2013-07-18','16:30:00',5.02),('11288','2013-07-18','16:35:00',4.91),('11288','2013-07-18','16:40:00',4.77),('11288','2013-07-18','16:45:00',4.69),('11288','2013-07-18','16:50:00',4.57),('11288','2013-07-18','16:55:00',4.38),('11288','2013-07-18','17:00:00',4.18),('11288','2013-07-18','17:05:00',4.04),('11288','2013-07-18','17:10:00',4.03),('11288','2013-07-18','17:15:00',3.91),('11288','2013-07-18','17:20:00',3.85),('11288','2013-07-18','17:25:00',3.67),('11288','2013-07-18','17:30:00',3.54),('11288','2013-07-18','17:35:00',3.33),('11288','2013-07-18','17:40:00',3.02),('11288','2013-07-18','17:45:00',3.07),('11288','2013-07-18','17:50:00',2.93),('11288','2013-07-18','17:55:00',2.77),('11288','2013-07-18','18:00:00',2.63),('11288','2013-07-18','18:05:00',2.25),('11288','2013-07-18','18:10:00',2.39),('11288','2013-07-18','18:15:00',2.2),('11288','2013-07-18','18:20:00',2.07),('11288','2013-07-18','18:25:00',1.95),('11288','2013-07-18','18:30:00',1.1),('11288','2013-07-18','18:50:00',1.04),('11288','2013-07-18','18:55:00',1.29),('11288','2013-07-18','19:00:00',1.34),('11288','2013-07-18','19:05:00',1.11),('11288','2013-07-17','07:25:00',1.04),('11288','2013-07-17','07:30:00',1.13),('11288','2013-07-17','07:35:00',1.22),('11288','2013-07-17','07:40:00',1.37),('11288','2013-07-17','07:45:00',1.43),('11288','2013-07-17','07:50:00',1.49),('11288','2013-07-17','07:55:00',1.67),('11288','2013-07-17','08:00:00',1.88),('11288','2013-07-17','08:05:00',2),('11288','2013-07-17','08:10:00',2.04),('11288','2013-07-17','08:15:00',2.34),('11288','2013-07-17','08:20:00',2.45),('11288','2013-07-17','08:25:00',2.4),('11288','2013-07-17','08:30:00',2.7),('11288','2013-07-17','08:35:00',2.91),('11288','2013-07-17','08:40:00',2.94),('11288','2013-07-17','08:45:00',3.21),('11288','2013-07-17','08:50:00',3.36),('11288','2013-07-17','08:55:00',3.44),('11288','2013-07-17','09:00:00',3.59),('11288','2013-07-17','09:05:00',3.69),('11288','2013-07-17','09:10:00',3.84),('11288','2013-07-17','09:15:00',4.02),('11288','2013-07-17','09:20:00',4.11),('11288','2013-07-17','09:25:00',4.23),('11288','2013-07-17','09:30:00',4.44),('11288','2013-07-17','09:35:00',4.53),('11288','2013-07-17','09:40:00',4.51),('11288','2013-07-17','09:45:00',4.7),('11288','2013-07-17','09:50:00',4.8),('11288','2013-07-17','09:55:00',4.75),('11288','2013-07-17','10:00:00',4.9),('11288','2013-07-17','10:05:00',5.26),('11288','2013-07-17','10:10:00',5.34),('11288','2013-07-17','10:15:00',5.43),('11288','2013-07-17','10:20:00',5.52),('11288','2013-07-17','10:25:00',5.58),('11288','2013-07-17','10:30:00',5.73),('11288','2013-07-17','10:35:00',5.85),('11288','2013-07-17','10:40:00',5.87),('11288','2013-07-17','10:45:00',5.96),('11288','2013-07-17','10:50:00',6.07),('11288','2013-07-17','10:55:00',6.15),('11288','2013-07-17','11:00:00',6.25),('11288','2013-07-17','11:05:00',6.35),('11288','2013-07-17','11:10:00',6.41),('11288','2013-07-17','11:15:00',6.44),('11288','2013-07-17','11:20:00',6.47),('11288','2013-07-17','11:25:00',6.48),('11288','2013-07-17','11:30:00',6.56),('11288','2013-07-17','11:35:00',6.54),('11288','2013-07-17','11:40:00',6.61),('11288','2013-07-17','11:45:00',6.65),('11288','2013-07-17','11:50:00',6.73),('11288','2013-07-17','11:55:00',6.75),('11288','2013-07-17','12:00:00',6.83),('11288','2013-07-17','12:05:00',6.84),('11288','2013-07-17','12:10:00',6.82),('11288','2013-07-17','12:15:00',6.83),('11288','2013-07-17','12:20:00',6.84),('11288','2013-07-17','12:25:00',6.82),('11288','2013-07-17','12:30:00',6.87),('11288','2013-07-17','12:35:00',6.87),('11288','2013-07-17','12:40:00',6.82),('11288','2013-07-17','12:45:00',6.84),('11288','2013-07-17','12:50:00',6.82),('11288','2013-07-17','12:55:00',6.85),('11288','2013-07-17','13:00:00',6.89),('11288','2013-07-17','13:05:00',6.94),('11288','2013-07-17','13:10:00',6.86),('11288','2013-07-17','13:15:00',6.9),('11288','2013-07-17','13:20:00',6.91),('11288','2013-07-17','13:25:00',6.79),('11288','2013-07-17','13:30:00',6.78),('11288','2013-07-17','13:35:00',6.82),('11288','2013-07-17','13:40:00',6.75),('11288','2013-07-17','13:45:00',6.75),('11288','2013-07-17','13:50:00',6.69),('11288','2013-07-17','13:55:00',6.56),('11288','2013-07-17','14:00:00',6.79),('11288','2013-07-17','14:05:00',6.76),('11288','2013-07-17','14:10:00',6.8),('11288','2013-07-17','14:15:00',6.77),('11288','2013-07-17','14:20:00',6.67),('11288','2013-07-17','14:25:00',6.63),('11288','2013-07-17','14:30:00',6.59),('11288','2013-07-17','14:35:00',6.58),('11288','2013-07-17','14:40:00',6.66),('11288','2013-07-17','14:45:00',6.58),('11288','2013-07-17','14:50:00',6.39),('11288','2013-07-17','14:55:00',5.02),('11288','2013-07-17','15:00:00',5.75),('11288','2013-07-17','15:05:00',6.42),('11288','2013-07-17','15:10:00',6.21),('11288','2013-07-17','15:15:00',6.28),('11288','2013-07-17','15:20:00',6.23),('11288','2013-07-17','15:25:00',6.21),('11288','2013-07-17','15:30:00',6.16),('11288','2013-07-17','15:35:00',6.12),('11288','2013-07-17','15:40:00',6.09),('11288','2013-07-17','15:45:00',5.81),('11288','2013-07-17','15:50:00',5.38),('11288','2013-07-17','15:55:00',5.12),('11288','2013-07-17','16:00:00',5.75),('11288','2013-07-17','16:05:00',5.61),('11288','2013-07-17','16:10:00',5.62),('11288','2013-07-17','16:15:00',5.51),('11288','2013-07-17','16:20:00',5.3),('11288','2013-07-17','16:25:00',5),('11288','2013-07-17','16:30:00',4.94),('11288','2013-07-17','16:35:00',4.96),('11288','2013-07-17','16:40:00',4.47),('11288','2013-07-17','16:45:00',4.71),('11288','2013-07-17','16:50:00',4.61),('11288','2013-07-17','16:55:00',4.44),('11288','2013-07-17','17:00:00',4.36),('11288','2013-07-17','17:05:00',4.23),('11288','2013-07-17','17:10:00',4.26),('11288','2013-07-17','17:15:00',4.12),('11288','2013-07-17','17:20:00',3.96),('11288','2013-07-17','17:25:00',3.77),('11288','2013-07-17','17:30:00',3.62),('11288','2013-07-17','17:35:00',3.55),('11288','2013-07-17','17:40:00',3.35),('11288','2013-07-17','17:45:00',3.22),('11288','2013-07-17','17:50:00',3.17),('11288','2013-07-17','17:55:00',3.1),('11288','2013-07-17','18:00:00',2.91),('11288','2013-07-17','18:05:00',2.81),('11288','2013-07-17','18:10:00',2.69),('11288','2013-07-17','18:15:00',2.57),('11288','2013-07-17','18:20:00',2.42),('11288','2013-07-17','18:25:00',2.29),('11288','2013-07-17','18:30:00',2.16),('11288','2013-07-17','18:35:00',2.03),('11288','2013-07-17','18:40:00',1.91),('11288','2013-07-17','18:45:00',1.74),('11288','2013-07-17','18:50:00',1.61),('11288','2013-07-17','18:55:00',1.47),('11288','2013-07-17','19:00:00',1.35),('11288','2013-07-17','19:05:00',1.23),('11288','2013-07-17','19:10:00',1.1),('11288','2013-07-16','07:20:00',1.03),('11288','2013-07-16','07:25:00',1.12),('11288','2013-07-16','07:30:00',1.2),('11288','2013-07-16','07:35:00',1.3),('11288','2013-07-16','07:40:00',1.46),('11288','2013-07-16','07:45:00',1.52),('11288','2013-07-16','07:50:00',1.6),('11288','2013-07-16','07:55:00',1.68),('11288','2013-07-16','08:00:00',1.91),('11288','2013-07-16','08:05:00',2.06),('11288','2013-07-16','08:10:00',2.05),('11288','2013-07-16','08:15:00',2.2),('11288','2013-07-16','08:20:00',2.3),('11288','2013-07-16','08:25:00',2.34),('11288','2013-07-16','08:30:00',2.63),('11288','2013-07-16','08:35:00',2.8),('11288','2013-07-16','08:40:00',2.93),('11288','2013-07-16','08:45:00',3.1),('11288','2013-07-16','08:50:00',3.21),('11288','2013-07-16','08:55:00',3.36),('11288','2013-07-16','09:00:00',3.52),('11288','2013-07-16','09:05:00',3.53),('11288','2013-07-16','09:10:00',3.53),('11288','2013-07-16','09:15:00',3.73),('11288','2013-07-16','09:20:00',3.93),('11288','2013-07-16','09:25:00',4),('11288','2013-07-16','09:30:00',4.24),('11288','2013-07-16','09:35:00',4.31),('11288','2013-07-16','09:40:00',4.39),('11288','2013-07-16','09:45:00',4.5),('11288','2013-07-16','09:50:00',4.62),('11288','2013-07-16','09:55:00',4.68),('11288','2013-07-16','10:00:00',4.81),('11288','2013-07-16','10:05:00',5.11),('11288','2013-07-16','10:10:00',5.2),('11288','2013-07-16','10:15:00',5.35),('11288','2013-07-16','10:20:00',5.43),('11288','2013-07-16','10:25:00',5.52),('11288','2013-07-16','10:30:00',5.66),('11288','2013-07-16','10:35:00',5.74),('11288','2013-07-16','10:40:00',5.81),('11288','2013-07-16','10:45:00',5.94),('11288','2013-07-16','10:50:00',5.98),('11288','2013-07-16','10:55:00',6.05),('11288','2013-07-16','11:00:00',6.15),('11288','2013-07-16','11:05:00',6.22),('11288','2013-07-16','11:10:00',6.28),('11288','2013-07-16','11:15:00',6.32),('11288','2013-07-16','11:20:00',6.38),('11288','2013-07-16','11:25:00',6.39),('11288','2013-07-16','11:30:00',6.41),('11288','2013-07-16','11:35:00',6.46),('11288','2013-07-16','11:40:00',6.49),('11288','2013-07-16','11:45:00',6.55),('11288','2013-07-16','11:50:00',6.65),('11288','2013-07-16','11:55:00',6.74),('11288','2013-07-16','12:00:00',6.75),('11288','2013-07-16','12:05:00',6.83),('11288','2013-07-16','12:10:00',6.88),('11288','2013-07-16','12:15:00',6.9),('11288','2013-07-16','12:20:00',6.9),('11288','2013-07-16','12:25:00',6.88),('11288','2013-07-16','12:30:00',6.85),('11288','2013-07-16','12:35:00',6.84),('11288','2013-07-16','12:40:00',6.83),('11288','2013-07-16','12:45:00',6.9),('11288','2013-07-16','12:50:00',6.74),('11288','2013-07-16','12:55:00',6.75),('11288','2013-07-16','13:00:00',6.76),('11288','2013-07-16','13:05:00',6.81),('11288','2013-07-16','13:10:00',6.86),('11288','2013-07-16','13:15:00',6.87),('11288','2013-07-16','13:20:00',6.93),('11288','2013-07-16','13:25:00',6.9),('11288','2013-07-16','13:30:00',6.95),('11288','2013-07-16','13:35:00',6.88),('11288','2013-07-16','13:40:00',6.98),('11288','2013-07-16','13:45:00',7.04),('11288','2013-07-16','13:50:00',7.21),('11288','2013-07-16','13:55:00',6.93),('11288','2013-07-16','14:00:00',6.73),('11288','2013-07-16','14:05:00',6.82),('11288','2013-07-16','14:10:00',2.85),('11288','2013-07-16','14:15:00',6.76),('11288','2013-07-16','14:20:00',2.57),('11288','2013-07-16','14:25:00',5.28),('11288','2013-07-16','14:30:00',6.9),('11288','2013-07-16','14:35:00',6.75),('11288','2013-07-16','14:40:00',6.7),('11288','2013-07-16','14:45:00',6.57),('11288','2013-07-16','14:50:00',6.57),('11288','2013-07-16','14:55:00',6.62),('11288','2013-07-16','15:00:00',6.53),('11288','2013-07-16','15:05:00',6.43),('11288','2013-07-16','15:10:00',6.37),('11288','2013-07-16','15:15:00',6.28),('11288','2013-07-16','15:20:00',6.23),('11288','2013-07-16','15:25:00',6.24),('11288','2013-07-16','15:30:00',6.26),('11288','2013-07-16','15:35:00',5.03),('11288','2013-07-16','15:40:00',6.15),('11288','2013-07-16','15:45:00',4.58),('11288','2013-07-16','15:50:00',5.79),('11288','2013-07-16','15:55:00',5.83),('11288','2013-07-16','16:00:00',5.63),('11288','2013-07-16','16:05:00',4.04),('11288','2013-07-16','16:10:00',4.47),('11288','2013-07-16','16:15:00',3.74),('11288','2013-07-16','16:20:00',2.74),('11288','2013-07-16','16:25:00',3.18),('11288','2013-07-16','16:30:00',2.17),('11288','2013-07-16','16:35:00',1.37),('11288','2013-07-16','16:40:00',1.39),('11288','2013-07-16','16:45:00',1.79),('11288','2013-07-16','16:50:00',2.55),('11288','2013-07-16','16:55:00',2.92),('11288','2013-07-16','17:00:00',4.21),('11288','2013-07-16','17:05:00',4.89),('11288','2013-07-16','17:10:00',4.73),('11288','2013-07-16','17:15:00',4.2),('11288','2013-07-16','17:20:00',2.35),('11288','2013-07-16','17:25:00',3.43),('11288','2013-07-16','17:30:00',2.88),('11288','2013-07-16','17:35:00',2.96),('11288','2013-07-16','17:40:00',3.43),('11288','2013-07-16','17:45:00',3.46),('11288','2013-07-16','17:50:00',3.12),('11288','2013-07-16','17:55:00',2.01),('11288','2013-07-16','18:00:00',1.6),('11288','2013-07-16','18:05:00',2.4),('11288','2013-07-16','18:10:00',1.97),('11288','2013-07-16','18:15:00',2.3),('11288','2013-07-16','18:20:00',2.2),('11288','2013-07-16','18:25:00',2.26),('11288','2013-07-16','18:30:00',2.13),('11288','2013-07-16','18:35:00',1.99),('11288','2013-07-16','18:40:00',1.81),('11288','2013-07-16','18:45:00',1.65),('11288','2013-07-16','18:50:00',1.51),('11288','2013-07-16','18:55:00',1.31),('11288','2013-07-16','19:00:00',1.22),('11288','2013-07-16','19:05:00',1.11),('11288','2013-07-15','07:20:00',1.05),('11288','2013-07-15','07:25:00',1.13),('11288','2013-07-15','07:30:00',1.21),('11288','2013-07-15','07:35:00',1.26),('11288','2013-07-15','07:40:00',1.4),('11288','2013-07-15','07:45:00',1.52),('11288','2013-07-15','07:50:00',1.57),('11288','2013-07-15','07:55:00',1.75),('11288','2013-07-15','08:00:00',1.98),('11288','2013-07-15','08:05:00',2.14),('11288','2013-07-15','08:10:00',2.08),('11288','2013-07-15','08:15:00',2.33),('11288','2013-07-15','08:20:00',2.44),('11288','2013-07-15','08:25:00',2.44),('11288','2013-07-15','08:30:00',2.7),('11288','2013-07-15','08:35:00',2.91),('11288','2013-07-15','08:40:00',3.04),('11288','2013-07-15','08:45:00',3.24),('11288','2013-07-15','08:50:00',3.35),('11288','2013-07-15','08:55:00',3.47),('11288','2013-07-15','09:00:00',3.67),('11288','2013-07-15','09:05:00',3.8),('11288','2013-07-15','09:10:00',3.8),('11288','2013-07-15','09:15:00',3.97),('11288','2013-07-15','09:20:00',3.95),('11288','2013-07-15','09:25:00',3.85),('11288','2013-07-15','09:30:00',4.26),('11288','2013-07-15','09:35:00',4.46),('11288','2013-07-15','09:40:00',4.52),('11288','2013-07-15','09:45:00',4.68),('11288','2013-07-15','09:50:00',4.89),('11288','2013-07-15','09:55:00',5.02),('11288','2013-07-15','10:00:00',5.14),('11288','2013-07-15','10:05:00',5.24),('11288','2013-07-15','10:10:00',5.3),('11288','2013-07-15','10:15:00',5.43),('11288','2013-07-15','10:20:00',5.51),('11288','2013-07-15','10:25:00',5.6),('11288','2013-07-15','10:30:00',5.71),('11288','2013-07-15','10:35:00',5.79),('11288','2013-07-15','10:40:00',5.83),('11288','2013-07-15','10:45:00',5.93),('11288','2013-07-15','10:50:00',5.96),('11288','2013-07-15','10:55:00',6.04),('11288','2013-07-15','11:00:00',6.16),('11288','2013-07-15','11:05:00',6.22),('11288','2013-07-15','11:10:00',6.26),('11288','2013-07-15','11:15:00',6.3),('11288','2013-07-15','11:20:00',6.32),('11288','2013-07-15','11:25:00',6.35),('11288','2013-07-15','11:30:00',6.36),('11288','2013-07-15','11:35:00',6.46),('11288','2013-07-15','11:40:00',6.5),('11288','2013-07-15','11:45:00',6.54),('11288','2013-07-15','11:50:00',6.55),('11288','2013-07-15','11:55:00',6.59),('11288','2013-07-15','12:00:00',6.73),('11288','2013-07-15','12:05:00',6.76),('11288','2013-07-15','12:10:00',6.75),('11288','2013-07-15','12:15:00',6.72),('11288','2013-07-15','12:20:00',6.85),('11288','2013-07-15','12:25:00',6.87),('11288','2013-07-15','12:30:00',6.82),('11288','2013-07-15','12:35:00',6.92),('11288','2013-07-15','12:40:00',6.88),('11288','2013-07-15','12:45:00',6.81),('11288','2013-07-15','12:50:00',6.74),('11288','2013-07-15','12:55:00',6.64),('11288','2013-07-15','13:00:00',6.99),('11288','2013-07-15','13:05:00',6.72),('11288','2013-07-15','13:10:00',4.65),('11288','2013-07-15','13:15:00',7.01),('11288','2013-07-15','13:20:00',7.02),('11288','2013-07-15','13:25:00',7.23),('11288','2013-07-15','13:30:00',7.34),('11288','2013-07-15','13:35:00',7.45),('11288','2013-07-15','13:40:00',3.91),('11288','2013-07-15','13:45:00',4.01),('11288','2013-07-15','13:50:00',2.25),('11288','2013-07-15','13:55:00',4.52),('11288','2013-07-15','14:00:00',6.42),('11288','2013-07-15','14:05:00',7.62),('11288','2013-07-15','14:10:00',5.85),('11288','2013-07-15','14:15:00',1.62),('11288','2013-07-15','14:20:00',1.82),('11288','2013-07-15','14:25:00',6.9),('11288','2013-07-15','14:30:00',7.24),('11288','2013-07-15','14:35:00',7.08),('11288','2013-07-15','14:40:00',6.61),('11288','2013-07-15','14:45:00',6.24),('11288','2013-07-15','14:50:00',6.81),('11288','2013-07-15','14:55:00',6.77),('11288','2013-07-15','15:00:00',6.71),('11288','2013-07-15','15:05:00',6.56),('11288','2013-07-15','15:10:00',6.46),('11288','2013-07-15','15:15:00',6.36),('11288','2013-07-15','15:20:00',5.23),('11288','2013-07-15','15:25:00',1.55),('11288','2013-07-15','15:30:00',5.63),('11288','2013-07-15','15:35:00',6.5),('11288','2013-07-15','15:40:00',6.35),('11288','2013-07-15','15:45:00',6.09),('11288','2013-07-15','15:50:00',6.02),('11288','2013-07-15','15:55:00',5.9),('11288','2013-07-15','16:00:00',5.74),('11288','2013-07-15','16:05:00',5.64),('11288','2013-07-15','16:10:00',5.55),('11288','2013-07-15','16:15:00',5.43),('11288','2013-07-15','16:20:00',5.25),('11288','2013-07-15','16:25:00',5.16),('11288','2013-07-15','16:30:00',5.1),('11288','2013-07-15','16:35:00',4.93),('11288','2013-07-15','16:40:00',4.88),('11288','2013-07-15','16:45:00',4.76),('11288','2013-07-15','16:50:00',4.64),('11288','2013-07-15','16:55:00',4.46),('11288','2013-07-15','17:00:00',4.24),('11288','2013-07-15','17:05:00',4.24),('11288','2013-07-15','17:10:00',4.14),('11288','2013-07-15','17:15:00',4.03),('11288','2013-07-15','17:20:00',3.91),('11288','2013-07-15','17:25:00',3.79),('11288','2013-07-15','17:30:00',3.67),('11288','2013-07-15','17:35:00',3.51),('11288','2013-07-15','17:40:00',3.38),('11288','2013-07-15','17:45:00',3.21),('11288','2013-07-15','17:50:00',3.15),('11288','2013-07-15','17:55:00',3.06),('11288','2013-07-15','18:00:00',2.89),('11288','2013-07-15','18:05:00',2.72),('11288','2013-07-15','18:10:00',2.65),('11288','2013-07-15','18:15:00',2.5),('11288','2013-07-15','18:20:00',2.34),('11288','2013-07-15','18:25:00',2.23),('11288','2013-07-15','18:30:00',2.1),('11288','2013-07-15','18:35:00',1.96),('11288','2013-07-15','18:40:00',1.85),('11288','2013-07-15','18:45:00',1.72),('11288','2013-07-15','18:50:00',1.59),('11288','2013-07-15','18:55:00',1.48),('11288','2013-07-15','19:00:00',1.39),('11288','2013-07-15','19:05:00',1.27),('11288','2013-07-15','19:10:00',1.13),('11288','2013-07-15','19:15:00',1.01),('11288','2013-07-14','07:35:00',1.13),('11288','2013-07-14','07:40:00',1.49),('11288','2013-07-14','07:45:00',1.65),('11288','2013-07-14','07:50:00',2.22),('11288','2013-07-14','07:55:00',2.58),('11288','2013-07-14','08:00:00',2.35),('11288','2013-07-14','08:05:00',2.89),('11288','2013-07-14','08:10:00',2.86),('11288','2013-07-14','08:15:00',2.39),('11288','2013-07-14','08:20:00',2.93),('11288','2013-07-14','08:25:00',2.17),('11288','2013-07-14','08:30:00',1.81),('11288','2013-07-14','08:35:00',2.13),('11288','2013-07-14','08:40:00',1.89),('11288','2013-07-14','08:45:00',1.66),('11288','2013-07-14','08:50:00',1.82),('11288','2013-07-14','08:55:00',1.96),('11288','2013-07-14','09:00:00',1.94),('11288','2013-07-14','09:05:00',2.17),('11288','2013-07-14','09:10:00',2.57),('11288','2013-07-14','09:15:00',2.26),('11288','2013-07-14','09:20:00',3.39),('11288','2013-07-14','09:25:00',3.98),('11288','2013-07-14','09:30:00',3.93),('11288','2013-07-14','09:35:00',3.68),('11288','2013-07-14','09:40:00',3.01),('11288','2013-07-14','09:45:00',2.94),('11288','2013-07-14','09:50:00',2.86),('11288','2013-07-14','09:55:00',2.81),('11288','2013-07-14','10:00:00',2.74),('11288','2013-07-14','10:05:00',3.13),('11288','2013-07-14','10:10:00',2.97),('11288','2013-07-14','10:15:00',2.74),('11288','2013-07-14','10:20:00',3.45),('11288','2013-07-14','10:25:00',5.32),('11288','2013-07-14','10:30:00',4.89),('11288','2013-07-14','10:35:00',5.89),('11288','2013-07-14','10:40:00',5.46),('11288','2013-07-14','10:45:00',4.57),('11288','2013-07-14','10:50:00',6.3),('11288','2013-07-14','10:55:00',5.84),('11288','2013-07-14','11:00:00',5.45),('11288','2013-07-14','11:05:00',2.04),('11288','2013-07-14','11:10:00',2.61),('11288','2013-07-14','11:15:00',4.39),('11288','2013-07-14','11:20:00',7.12),('11288','2013-07-14','11:25:00',3.02),('11288','2013-07-14','11:30:00',3.08),('11288','2013-07-14','11:35:00',3.9),('11288','2013-07-14','11:40:00',3.11),('11288','2013-07-14','11:45:00',2.41),('11288','2013-07-14','11:50:00',3.4),('11288','2013-07-14','11:55:00',7.51),('11288','2013-07-14','12:00:00',7.4),('11288','2013-07-14','12:05:00',7.06),('11288','2013-07-14','12:10:00',7.27),('11288','2013-07-14','12:15:00',6.96),('11288','2013-07-14','12:20:00',6.85),('11288','2013-07-14','12:25:00',7.24),('11288','2013-07-14','12:30:00',7.36),('11288','2013-07-14','12:35:00',6.99),('11288','2013-07-14','12:40:00',6.76),('11288','2013-07-14','12:45:00',7.19),('11288','2013-07-14','12:50:00',7.37),('11288','2013-07-14','12:55:00',5.95),('11288','2013-07-14','13:00:00',3.06),('11288','2013-07-14','13:05:00',7.28),('11288','2013-07-14','13:10:00',7.63),('11288','2013-07-14','13:15:00',7.34),('11288','2013-07-14','13:20:00',7.2),('11288','2013-07-14','13:25:00',7.05),('11288','2013-07-14','13:30:00',6.93),('11288','2013-07-14','13:35:00',6.94),('11288','2013-07-14','13:40:00',7.06),('11288','2013-07-14','13:45:00',7.03),('11288','2013-07-14','13:50:00',7.13),('11288','2013-07-14','13:55:00',7.13),('11288','2013-07-14','14:00:00',7.09),('11288','2013-07-14','14:05:00',7.11),('11288','2013-07-14','14:10:00',7.15),('11288','2013-07-14','14:15:00',7.08),('11288','2013-07-14','14:20:00',7.01),('11288','2013-07-14','14:25:00',6.93),('11288','2013-07-14','14:30:00',6.87),('11288','2013-07-14','14:35:00',6.8),('11288','2013-07-14','14:40:00',6.72),('11288','2013-07-14','14:45:00',6.66),('11288','2013-07-14','14:50:00',6.56),('11288','2013-07-14','14:55:00',6.44),('11288','2013-07-14','15:00:00',6.41),('11288','2013-07-14','15:05:00',6.42),('11288','2013-07-14','15:10:00',6.36),('11288','2013-07-14','15:15:00',6.3),('11288','2013-07-14','15:20:00',6.24),('11288','2013-07-14','15:25:00',6.18),('11288','2013-07-14','15:30:00',6.11),('11288','2013-07-14','15:35:00',6.06),('11288','2013-07-14','15:40:00',5.98),('11288','2013-07-14','15:45:00',5.87),('11288','2013-07-14','15:50:00',5.79),('11288','2013-07-14','15:55:00',5.77),('11288','2013-07-14','16:00:00',5.69),('11288','2013-07-14','16:05:00',5.65),('11288','2013-07-14','16:10:00',5.58),('11288','2013-07-14','16:15:00',5.52),('11288','2013-07-14','16:20:00',5.34),('11288','2013-07-14','16:25:00',3.76),('11288','2013-07-14','16:30:00',4.28),('11288','2013-07-14','16:35:00',5.19),('11288','2013-07-14','16:40:00',5.2),('11288','2013-07-14','16:45:00',3.86),('11288','2013-07-14','16:50:00',2.56),('11288','2013-07-14','16:55:00',3.77),('11288','2013-07-14','17:00:00',3.94),('11288','2013-07-14','17:05:00',2.46),('11288','2013-07-14','17:10:00',3.33),('11288','2013-07-14','17:15:00',4.02),('11288','2013-07-14','17:20:00',2.07),('11288','2013-07-14','17:25:00',3.69),('11288','2013-07-14','17:30:00',3.95),('11288','2013-07-14','17:35:00',3.79),('11288','2013-07-14','17:40:00',2.79),('11288','2013-07-14','17:45:00',3.04),('11288','2013-07-14','17:50:00',2.5),('11288','2013-07-14','17:55:00',2.39),('11288','2013-07-14','18:00:00',2.64),('11288','2013-07-14','18:05:00',2.46),('11288','2013-07-14','18:10:00',1.38),('11288','2013-07-14','18:40:00',1.17),('11288','2013-07-14','18:45:00',1.39),('11288','2013-07-14','18:50:00',1.26),('11288','2013-07-14','18:55:00',1.07),('11288','2013-07-14','19:10:00',1.34),('11288','2013-07-14','19:15:00',1.5),('11288','2013-07-14','19:20:00',1.54),('11288','2013-07-14','19:25:00',1.13),('11288','2013-07-13','07:30:00',1.13),('11288','2013-07-13','07:35:00',1.24),('11288','2013-07-13','07:40:00',1.41),('11288','2013-07-13','07:45:00',1.58),('11288','2013-07-13','07:50:00',1.65),('11288','2013-07-13','07:55:00',1.78),('11288','2013-07-13','08:00:00',1.93),('11288','2013-07-13','08:05:00',2.05),('11288','2013-07-13','08:10:00',2.06),('11288','2013-07-13','08:15:00',2.24),('11288','2013-07-13','08:20:00',2.39),('11288','2013-07-13','08:25:00',2.39),('11288','2013-07-13','08:30:00',2.58),('11288','2013-07-13','08:35:00',2.78),('11288','2013-07-13','08:40:00',2.91),('11288','2013-07-13','08:45:00',2.96),('11288','2013-07-13','08:50:00',3.32),('11288','2013-07-13','08:55:00',3.33),('11288','2013-07-13','09:00:00',3.43),('11288','2013-07-13','09:05:00',3.62),('11288','2013-07-13','09:10:00',3.54),('11288','2013-07-13','09:15:00',3.63),('11288','2013-07-13','09:20:00',3.93),('11288','2013-07-13','09:25:00',4.06),('11288','2013-07-13','09:30:00',4.21),('11288','2013-07-13','09:35:00',4.28),('11288','2013-07-13','09:40:00',4.34),('11288','2013-07-13','09:45:00',4.45),('11288','2013-07-13','09:50:00',4.69),('11288','2013-07-13','09:55:00',4.82),('11288','2013-07-13','10:00:00',4.93),('11288','2013-07-13','10:05:00',5.09),('11288','2013-07-13','10:10:00',5.18),('11288','2013-07-13','10:15:00',5.09),('11288','2013-07-13','10:20:00',4.46),('11288','2013-07-13','10:25:00',3.66),('11288','2013-07-13','10:30:00',5.42),('11288','2013-07-13','10:35:00',5.74),('11288','2013-07-13','10:40:00',5.88),('11288','2013-07-13','10:45:00',6.02),('11288','2013-07-13','10:50:00',6.18),('11288','2013-07-13','10:55:00',6.14),('11288','2013-07-13','11:00:00',6.66),('11288','2013-07-13','11:05:00',5.93),('11288','2013-07-13','11:10:00',5.52),('11288','2013-07-13','11:15:00',5.45),('11288','2013-07-13','11:20:00',1.76),('11288','2013-07-13','11:25:00',2.04),('11288','2013-07-13','11:30:00',7.28),('11288','2013-07-13','11:35:00',6.9),('11288','2013-07-13','11:40:00',2.23),('11288','2013-07-13','11:45:00',1.68),('11288','2013-07-13','11:50:00',7.23),('11288','2013-07-13','11:55:00',5.92),('11288','2013-07-13','12:00:00',3.31),('11288','2013-07-13','12:05:00',6.58),('11288','2013-07-13','12:10:00',7.1),('11288','2013-07-13','12:15:00',7.26),('11288','2013-07-13','12:20:00',2.5),('11288','2013-07-13','12:25:00',6.17),('11288','2013-07-13','12:30:00',7.3),('11288','2013-07-13','12:35:00',6.97),('11288','2013-07-13','12:40:00',7.27),('11288','2013-07-13','12:45:00',5.95),('11288','2013-07-13','12:50:00',1.75),('11288','2013-07-13','12:55:00',4.09),('11288','2013-07-13','13:00:00',7.61),('11288','2013-07-13','13:05:00',7.48),('11288','2013-07-13','13:10:00',7.21),('11288','2013-07-13','13:15:00',7.13),('11288','2013-07-13','13:20:00',7.09),('11288','2013-07-13','13:25:00',6.99),('11288','2013-07-13','13:30:00',7.03),('11288','2013-07-13','13:35:00',7.09),('11288','2013-07-13','13:40:00',6.99),('11288','2013-07-13','13:45:00',6.98),('11288','2013-07-13','13:50:00',6.95),('11288','2013-07-13','13:55:00',6.92),('11288','2013-07-13','14:00:00',6.96),('11288','2013-07-13','14:05:00',6.94),('11288','2013-07-13','14:10:00',6.91),('11288','2013-07-13','14:15:00',6.86),('11288','2013-07-13','14:20:00',6.8),('11288','2013-07-13','14:25:00',6.78),('11288','2013-07-13','14:30:00',6.77),('11288','2013-07-13','14:35:00',6.72),('11288','2013-07-13','14:40:00',6.68),('11288','2013-07-13','14:45:00',6.73),('11288','2013-07-13','14:50:00',6.66),('11288','2013-07-13','14:55:00',6.66),('11288','2013-07-13','15:00:00',6.62),('11288','2013-07-13','15:05:00',6.62),('11288','2013-07-13','15:10:00',6.55),('11288','2013-07-13','15:15:00',6.55),('11288','2013-07-13','15:20:00',6.18),('11288','2013-07-13','15:25:00',6.5),('11288','2013-07-13','15:30:00',6.26),('11288','2013-07-13','15:35:00',6.32),('11288','2013-07-13','15:40:00',6.26),('11288','2013-07-13','15:45:00',6.16),('11288','2013-07-13','15:50:00',6.07),('11288','2013-07-13','15:55:00',6.03),('11288','2013-07-13','16:00:00',5.96),('11288','2013-07-13','16:05:00',5.81),('11288','2013-07-13','16:10:00',5.7),('11288','2013-07-13','16:15:00',5.59),('11288','2013-07-13','16:20:00',5.5),('11288','2013-07-13','16:25:00',5.47),('11288','2013-07-13','16:30:00',5.35),('11288','2013-07-13','16:35:00',5.25),('11288','2013-07-13','16:40:00',5.13),('11288','2013-07-13','16:45:00',5.01),('11288','2013-07-13','16:50:00',4.77),('11288','2013-07-13','16:55:00',4.69),('11288','2013-07-13','17:00:00',4.54),('11288','2013-07-13','17:05:00',4.35),('11288','2013-07-13','17:10:00',4.31),('11288','2013-07-13','17:15:00',4.21),('11288','2013-07-13','17:20:00',3.94),('11288','2013-07-13','17:25:00',4.01),('11288','2013-07-13','17:30:00',3.74),('11288','2013-07-13','17:35:00',3.63),('11288','2013-07-13','17:40:00',3.56),('11288','2013-07-13','17:45:00',3.43),('11288','2013-07-13','17:50:00',3.3),('11288','2013-07-13','17:55:00',3.34),('11288','2013-07-13','18:00:00',3),('11288','2013-07-13','18:05:00',2.75),('11288','2013-07-13','18:10:00',2.8),('11288','2013-07-13','18:15:00',2.69),('11288','2013-07-13','18:20:00',2.54),('11288','2013-07-13','18:25:00',2.45),('11288','2013-07-13','18:30:00',2.28),('11288','2013-07-13','18:35:00',2.14),('11288','2013-07-13','18:40:00',1.49),('11288','2013-07-13','18:45:00',1.07),('11288','2013-07-13','18:50:00',1.52),('11288','2013-07-13','18:55:00',1.74),('11288','2013-07-13','19:00:00',1.65),('11288','2013-07-13','19:05:00',1.45),('11288','2013-07-13','19:10:00',1.27),('11288','2013-07-12','07:15:00',1.03),('11288','2013-07-12','07:20:00',1.27),('11288','2013-07-12','07:25:00',1.35),('11288','2013-07-12','07:30:00',1.18),('11288','2013-07-12','07:35:00',1.02),('11288','2013-07-12','07:40:00',1.02),('11288','2013-07-12','07:45:00',1.27),('11288','2013-07-12','07:50:00',1.37),('11288','2013-07-12','08:05:00',1.51),('11288','2013-07-12','08:10:00',2.04),('11288','2013-07-12','08:15:00',2.02),('11288','2013-07-12','08:20:00',2.03),('11288','2013-07-12','08:25:00',1.43),('11288','2013-07-12','08:30:00',1.31),('11288','2013-07-12','08:35:00',1.59),('11288','2013-07-12','08:40:00',1.83),('11288','2013-07-12','08:45:00',1.95),('11288','2013-07-12','08:50:00',1.67),('11288','2013-07-12','08:55:00',1.28),('11288','2013-07-12','09:00:00',1.33),('11288','2013-07-12','09:05:00',1.73),('11288','2013-07-12','09:10:00',2.33),('11288','2013-07-12','09:15:00',2.78),('11288','2013-07-12','09:20:00',4.19),('11288','2013-07-12','09:25:00',4.35),('11288','2013-07-12','09:30:00',2.89),('11288','2013-07-12','09:35:00',4.08),('11288','2013-07-12','09:40:00',4.26),('11288','2013-07-12','09:45:00',4.56),('11288','2013-07-12','09:50:00',4.8),('11288','2013-07-12','09:55:00',4.85),('11288','2013-07-12','10:00:00',4.82),('11288','2013-07-12','10:05:00',4.7),('11288','2013-07-12','10:10:00',5.42),('11288','2013-07-12','10:15:00',5.47),('11288','2013-07-12','10:20:00',5.73),('11288','2013-07-12','10:25:00',2.94),('11288','2013-07-12','10:30:00',1.72),('11288','2013-07-12','10:35:00',1.45),('11288','2013-07-12','10:40:00',1.97),('11288','2013-07-12','10:45:00',4.74),('11288','2013-07-12','10:50:00',6.38),('11288','2013-07-12','10:55:00',6.71),('11288','2013-07-12','11:00:00',3.36),('11288','2013-07-12','11:05:00',2.52),('11288','2013-07-12','11:10:00',4.31),('11288','2013-07-12','11:15:00',5.78),('11288','2013-07-12','11:20:00',7.09),('11288','2013-07-12','11:25:00',5.99),('11288','2013-07-12','11:30:00',5.13),('11288','2013-07-12','11:35:00',6.26),('11288','2013-07-12','11:40:00',6.97),('11288','2013-07-12','11:45:00',2.6),('11288','2013-07-12','11:50:00',6.36),('11288','2013-07-12','11:55:00',6.66),('11288','2013-07-12','12:00:00',7.38),('11288','2013-07-12','12:05:00',3.02),('11288','2013-07-12','12:10:00',4.6),('11288','2013-07-12','12:15:00',7.8),('11288','2013-07-12','12:20:00',5.31),('11288','2013-07-12','12:25:00',6.97),('11288','2013-07-12','12:30:00',7.66),('11288','2013-07-12','12:35:00',6.57),('11288','2013-07-12','12:40:00',7.68),('11288','2013-07-12','12:45:00',7.57),('11288','2013-07-12','12:50:00',6.61),('11288','2013-07-12','12:55:00',7.23),('11288','2013-07-12','13:00:00',7.12),('11288','2013-07-12','13:05:00',5.66),('11288','2013-07-12','13:10:00',7.28),('11288','2013-07-12','13:15:00',7.23),('11288','2013-07-12','13:20:00',7.08),('11288','2013-07-12','13:25:00',6.98),('11288','2013-07-12','13:30:00',7.02),('11288','2013-07-12','13:35:00',7.01),('11288','2013-07-12','13:40:00',7.06),('11288','2013-07-12','13:45:00',6.58),('11288','2013-07-12','13:50:00',7.21),('11288','2013-07-12','13:55:00',5.24),('11288','2013-07-12','14:00:00',7.42),('11288','2013-07-12','14:05:00',4.39),('11288','2013-07-12','14:10:00',3.97),('11288','2013-07-12','14:15:00',7.68),('11288','2013-07-12','14:20:00',6.7),('11288','2013-07-12','14:25:00',7.18),('11288','2013-07-12','14:30:00',5.67),('11288','2013-07-12','14:35:00',6.85),('11288','2013-07-12','14:40:00',6.68),('11288','2013-07-12','14:45:00',6.61),('11288','2013-07-12','14:50:00',6.6),('11288','2013-07-12','14:55:00',6.54),('11288','2013-07-12','15:00:00',6.37),('11288','2013-07-12','15:05:00',6.47),('11288','2013-07-12','15:10:00',6.42),('11288','2013-07-12','15:15:00',6.33),('11288','2013-07-12','15:20:00',6.32),('11288','2013-07-12','15:25:00',6.18),('11288','2013-07-12','15:30:00',5.4),('11288','2013-07-12','15:35:00',6.04),('11288','2013-07-12','15:40:00',6.06),('11288','2013-07-12','15:45:00',5.93),('11288','2013-07-12','15:50:00',5.83),('11288','2013-07-12','15:55:00',5.77),('11288','2013-07-12','16:00:00',5.74),('11288','2013-07-12','16:05:00',5.61),('11288','2013-07-12','16:10:00',5.52),('11288','2013-07-12','16:15:00',5.37),('11288','2013-07-12','16:20:00',5.29),('11288','2013-07-12','16:25:00',5.2),('11288','2013-07-12','16:30:00',5.12),('11288','2013-07-12','16:35:00',5.07),('11288','2013-07-12','16:40:00',4.94),('11288','2013-07-12','16:45:00',4.87),('11288','2013-07-12','16:50:00',4.64),('11288','2013-07-12','16:55:00',4.47),('11288','2013-07-12','17:00:00',4.28),('11288','2013-07-12','17:05:00',4.35),('11288','2013-07-12','17:10:00',4.23),('11288','2013-07-12','17:15:00',4.1),('11288','2013-07-12','17:20:00',3.94),('11288','2013-07-12','17:25:00',3.8),('11288','2013-07-12','17:30:00',3.68),('11288','2013-07-12','17:35:00',3.58),('11288','2013-07-12','17:40:00',3.43),('11288','2013-07-12','17:45:00',3.29),('11288','2013-07-12','17:50:00',3.29),('11288','2013-07-12','17:55:00',3.1),('11288','2013-07-12','18:00:00',2.93),('11288','2013-07-12','18:05:00',2.84),('11288','2013-07-12','18:10:00',2.72),('11288','2013-07-12','18:15:00',2.59),('11288','2013-07-12','18:20:00',2.38),('11288','2013-07-12','18:25:00',2.3),('11288','2013-07-12','18:30:00',2.19),('11288','2013-07-12','18:35:00',2.06),('11288','2013-07-12','18:40:00',1.91),('11288','2013-07-12','18:45:00',1.78),('11288','2013-07-12','18:50:00',1.64),('11288','2013-07-12','18:55:00',1.52),('11288','2013-07-12','19:00:00',1.39),('11288','2013-07-12','19:05:00',1.27),('11288','2013-07-12','19:10:00',1.16),('11288','2013-07-12','19:15:00',1.03),('11288','2013-07-11','07:20:00',1.11),('11288','2013-07-11','07:25:00',1.19),('11288','2013-07-11','07:30:00',1.26),('11288','2013-07-11','07:35:00',1.35),('11288','2013-07-11','07:40:00',1.46),('11288','2013-07-11','07:45:00',1.53),('11288','2013-07-11','07:50:00',1.64),('11288','2013-07-11','07:55:00',1.8),('11288','2013-07-11','08:00:00',1.99),('11288','2013-07-11','08:05:00',2.05),('11288','2013-07-11','08:10:00',2.17),('11288','2013-07-11','08:15:00',2.29),('11288','2013-07-11','08:20:00',2.4),('11288','2013-07-11','08:25:00',2.4),('11288','2013-07-11','08:30:00',2.72),('11288','2013-07-11','08:35:00',2.78),('11288','2013-07-11','08:40:00',2.8),('11288','2013-07-11','08:45:00',3.09),('11288','2013-07-11','08:50:00',3.26),('11288','2013-07-11','08:55:00',3.44),('11288','2013-07-11','09:00:00',3.67),('11288','2013-07-11','09:05:00',3.67),('11288','2013-07-11','09:10:00',3.79),('11288','2013-07-11','09:15:00',3.79),('11288','2013-07-11','09:20:00',3.86),('11288','2013-07-11','09:25:00',2.31),('11288','2013-07-11','09:30:00',4.45),('11288','2013-07-11','09:35:00',4.54),('11288','2013-07-11','09:40:00',4.73),('11288','2013-07-11','09:45:00',4.99),('11288','2013-07-11','09:50:00',5.09),('11288','2013-07-11','09:55:00',4.04),('11288','2013-07-11','10:00:00',3.2),('11288','2013-07-11','10:05:00',4.83),('11288','2013-07-11','10:10:00',5.68),('11288','2013-07-11','10:15:00',4.91),('11288','2013-07-11','10:20:00',5.47),('11288','2013-07-11','10:25:00',5.46),('11288','2013-07-11','10:30:00',4.09),('11288','2013-07-11','10:35:00',4.7),('11288','2013-07-11','10:40:00',4.65),('11288','2013-07-11','10:45:00',6.25),('11288','2013-07-11','10:50:00',4.86),('11288','2013-07-11','10:55:00',4.86),('11288','2013-07-11','11:00:00',6.76),('11288','2013-07-11','11:05:00',6.65),('11288','2013-07-11','11:10:00',6.66),('11288','2013-07-11','11:15:00',6.85),('11288','2013-07-11','11:20:00',5.49),('11288','2013-07-11','11:25:00',6.65),('11288','2013-07-11','11:30:00',4.47),('11288','2013-07-11','11:35:00',2.74),('11288','2013-07-11','11:40:00',6.87),('11288','2013-07-11','11:45:00',2.83),('11288','2013-07-11','11:50:00',7.23),('11288','2013-07-11','11:55:00',7.61),('11288','2013-07-11','12:00:00',5.79),('11288','2013-07-11','12:05:00',1.72),('11288','2013-07-11','12:10:00',4.38),('11288','2013-07-11','12:15:00',7.35),('11288','2013-07-11','12:20:00',7.47),('11288','2013-07-11','12:25:00',7.45),('11288','2013-07-11','12:30:00',7.43),('11288','2013-07-11','12:35:00',7.28),('11288','2013-07-11','12:40:00',7.46),('11288','2013-07-11','12:45:00',7.28),('11288','2013-07-11','12:50:00',5.74),('11288','2013-07-11','12:55:00',5.98),('11288','2013-07-11','13:00:00',7.32),('11288','2013-07-11','13:05:00',7.21),('11288','2013-07-11','13:10:00',6.03),('11288','2013-07-11','13:15:00',7.29),('11288','2013-07-11','13:20:00',6.96),('11288','2013-07-11','13:25:00',5.5),('11288','2013-07-11','13:30:00',7.24),('11288','2013-07-11','13:35:00',7.48),('11288','2013-07-11','13:40:00',6.65),('11288','2013-07-11','13:45:00',5.4),('11288','2013-07-11','13:50:00',3.9),('11288','2013-07-11','13:55:00',5.35),('11288','2013-07-11','14:00:00',7.32),('11288','2013-07-11','14:05:00',6.95),('11288','2013-07-11','14:10:00',6.52),('11288','2013-07-11','14:15:00',6.87),('11288','2013-07-11','14:20:00',7.08),('11288','2013-07-11','14:25:00',7.1),('11288','2013-07-11','14:30:00',6.99),('11288','2013-07-11','14:35:00',6.94),('11288','2013-07-11','14:40:00',6.02),('11288','2013-07-11','14:45:00',6.88),('11288','2013-07-11','14:50:00',6.77),('11288','2013-07-11','14:55:00',6.68),('11288','2013-07-11','15:00:00',4.76),('11288','2013-07-11','15:05:00',3.06),('11288','2013-07-11','15:10:00',5.48),('11288','2013-07-11','15:15:00',2.88),('11288','2013-07-11','15:20:00',4.21),('11288','2013-07-11','15:25:00',5.47),('11288','2013-07-11','15:30:00',6.19),('11288','2013-07-11','15:35:00',4.05),('11288','2013-07-11','15:40:00',5.67),('11288','2013-07-11','15:45:00',5.09),('11288','2013-07-11','15:50:00',4.04),('11288','2013-07-11','15:55:00',2.89),('11288','2013-07-11','16:00:00',5.36),('11288','2013-07-11','16:05:00',5.05),('11288','2013-07-11','16:10:00',5.17),('11288','2013-07-11','16:15:00',3.97),('11288','2013-07-11','16:20:00',4.23),('11288','2013-07-11','16:25:00',2.67),('11288','2013-07-11','16:30:00',4.71),('11288','2013-07-11','16:35:00',3.19),('11288','2013-07-11','16:40:00',5.59),('11288','2013-07-11','16:45:00',5.68),('11288','2013-07-11','16:50:00',4.91),('11288','2013-07-11','16:55:00',4.43),('11288','2013-07-11','17:00:00',3.17),('11288','2013-07-11','17:05:00',4.61),('11288','2013-07-11','17:10:00',4.5),('11288','2013-07-11','17:15:00',4.05),('11288','2013-07-11','17:20:00',4.55),('11288','2013-07-11','17:25:00',3.66),('11288','2013-07-11','17:30:00',3.87),('11288','2013-07-11','17:35:00',3.55),('11288','2013-07-11','17:40:00',2.67),('11288','2013-07-11','17:45:00',3.37),('11288','2013-07-11','17:50:00',2.59),('11288','2013-07-11','17:55:00',3.32),('11288','2013-07-11','18:00:00',2.69),('11288','2013-07-11','18:05:00',2.46),('11288','2013-07-11','18:10:00',2.98),('11288','2013-07-11','18:15:00',2.81),('11288','2013-07-11','18:20:00',2.13),('11288','2013-07-11','18:25:00',2.12),('11288','2013-07-11','18:30:00',1.58),('11288','2013-07-11','18:35:00',1.7),('11288','2013-07-11','18:40:00',1.46),('11288','2013-07-11','18:45:00',1.34),('11288','2013-07-11','18:50:00',1.17),('11288','2013-07-11','18:55:00',1.42),('11288','2013-07-11','19:00:00',1.2),('11288','2013-07-11','19:05:00',1.01),('11288','2013-07-11','19:10:00',1.16),('11288','2013-07-11','19:15:00',1.03),('11288','2014-05-03','07:35:00',1.07),('11288','2014-05-03','07:40:00',1.21),('11288','2014-05-03','07:45:00',1.36),('11288','2014-05-03','07:50:00',1.38),('11288','2014-05-03','07:55:00',1.55),('11288','2014-05-03','08:00:00',1.67),('11288','2014-05-03','08:05:00',1.93),('11288','2014-05-03','08:10:00',2.64),('11288','2014-05-03','08:15:00',2.21),('11288','2014-05-03','08:20:00',1.76),('11288','2014-05-03','08:25:00',1.87),('11288','2014-05-03','08:30:00',2.07),('11288','2014-05-03','08:35:00',1.38),('11288','2014-05-03','08:40:00',1.42),('11288','2014-05-03','08:45:00',2.66),('11288','2014-05-03','08:50:00',3.82),('11288','2014-05-03','08:55:00',4.07),('11288','2014-05-03','09:00:00',3.23),('11288','2014-05-03','09:05:00',3.32),('11288','2014-05-03','09:10:00',2.6),('11288','2014-05-03','09:15:00',3.56),('11288','2014-05-03','09:20:00',5.23),('11288','2014-05-03','09:25:00',2.77),('11288','2014-05-03','09:30:00',4.84),('11288','2014-05-03','09:35:00',4.87),('11288','2014-05-03','09:40:00',3.86),('11288','2014-05-03','09:45:00',4.92),('11288','2014-05-03','09:50:00',2.99),('11288','2014-05-03','09:55:00',5.69),('11288','2014-05-03','10:00:00',5.79),('11288','2014-05-03','10:05:00',5.77),('11288','2014-05-03','10:10:00',5.5),('11288','2014-05-03','10:15:00',6.02),('11288','2014-05-03','10:20:00',2.23),('11288','2014-05-03','10:25:00',2.35),('11288','2014-05-03','10:30:00',4.41),('11288','2014-05-03','10:35:00',2.02),('11288','2014-05-03','10:40:00',2.89),('11288','2014-05-03','10:45:00',2.01),('11288','2014-05-03','10:50:00',2.12),('11288','2014-05-03','10:55:00',4.13),('11288','2014-05-03','11:00:00',3.36),('11288','2014-05-03','11:05:00',7.13),('11288','2014-05-03','11:10:00',6.97),('11288','2014-05-03','11:15:00',8.05),('11288','2014-05-03','11:20:00',7.79),('11288','2014-05-03','11:25:00',6.78),('11288','2014-05-03','11:30:00',7.44),('11288','2014-05-03','11:35:00',4.55),('11288','2014-05-03','11:40:00',5.31),('11288','2014-05-03','11:45:00',4.43),('11288','2014-05-03','11:50:00',4.1),('11288','2014-05-03','11:55:00',4),('11288','2014-05-03','12:00:00',2.97),('11288','2014-05-03','12:05:00',2.45),('11288','2014-05-03','12:10:00',2.29),('11288','2014-05-03','12:15:00',2.17),('11288','2014-05-03','12:20:00',2.08),('11288','2014-05-03','12:25:00',2.25),('11288','2014-05-03','12:30:00',3.03),('11288','2014-05-03','12:35:00',3.93),('11288','2014-05-03','12:40:00',3.85),('11288','2014-05-03','12:45:00',3.65),('11288','2014-05-03','12:50:00',3.09),('11288','2014-05-03','12:55:00',3.04),('11288','2014-05-03','13:00:00',3.46),('11288','2014-05-03','13:05:00',4.2),('11288','2014-05-03','13:10:00',5.19),('11288','2014-05-03','13:15:00',4.69),('11288','2014-05-03','13:20:00',4.46),('11288','2014-05-03','13:25:00',5.24),('11288','2014-05-03','13:30:00',5.68),('11288','2014-05-03','13:35:00',5.31),('11288','2014-05-03','13:40:00',3.47),('11288','2014-05-03','13:45:00',3.26),('11288','2014-05-03','13:50:00',3.22),('11288','2014-05-03','13:55:00',3.25),('11288','2014-05-03','14:00:00',3.23),('11288','2014-05-03','14:05:00',3.35),('11288','2014-05-03','14:10:00',3.72),('11288','2014-05-03','14:15:00',4.42),('11288','2014-05-03','14:20:00',4.99),('11288','2014-05-03','14:25:00',5.54),('11288','2014-05-03','14:30:00',3.35),('11288','2014-05-03','14:35:00',2.59),('11288','2014-05-03','14:40:00',1.88),('11288','2014-05-03','14:45:00',1.22),('11288','2014-05-03','14:50:00',1.97),('11288','2014-05-03','14:55:00',7.44),('11288','2014-05-03','15:00:00',4.95),('11288','2014-05-03','15:05:00',2.46),('11288','2014-05-03','15:10:00',1.85),('11288','2014-05-03','15:15:00',1.26),('11288','2014-05-03','15:20:00',1.08),('11288','2014-05-03','15:25:00',1.1),('11288','2014-05-03','15:30:00',1.08),('11288','2014-05-03','15:35:00',1.09),('11288','2014-05-03','15:40:00',1.04),('11288','2014-05-03','16:25:00',1),('11288','2014-05-03','16:30:00',1.17),('11288','2014-05-03','16:35:00',1.31),('11288','2014-05-03','16:40:00',1.46),('11288','2014-05-03','16:45:00',1.59),('11288','2014-05-03','16:50:00',1.67),('11288','2014-05-03','16:55:00',1.72),('11288','2014-05-03','17:00:00',1.74),('11288','2014-05-03','17:05:00',1.75),('11288','2014-05-03','17:10:00',1.76),('11288','2014-05-03','17:15:00',1.76),('11288','2014-05-03','17:20:00',1.75),('11288','2014-05-03','17:25:00',1.75),('11288','2014-05-03','17:30:00',1.7),('11288','2014-05-03','17:35:00',1.64),('11288','2014-05-03','17:40:00',1.67),('11288','2014-05-03','17:45:00',1.71),('11288','2014-05-03','17:50:00',1.92),('11288','2014-05-03','17:55:00',2),('11288','2014-05-03','18:00:00',1.66),('11288','2014-05-03','18:05:00',1.39),('11288','2014-05-03','18:10:00',1.28),('11288','2014-05-03','18:15:00',1.18),('11288','2014-05-03','18:50:00',1.02),('11288','2014-04-06','08:15:00',1.27),('11288','2014-04-06','08:20:00',1.39),('11288','2014-04-06','08:25:00',1.59),('11288','2014-04-06','08:30:00',1.76),('11288','2014-04-06','08:35:00',1.83),('11288','2014-04-06','08:40:00',1.97),('11288','2014-04-06','08:45:00',2.14),('11288','2014-04-06','08:50:00',2.38),('11288','2014-04-06','09:10:00',1.66),('11288','2014-04-06','09:15:00',3.28),('11288','2014-04-06','09:20:00',2.95),('11288','2014-04-06','09:25:00',2.52),('11288','2014-04-06','09:30:00',2.74),('11288','2014-04-06','09:35:00',3.38),('11288','2014-04-06','09:40:00',3.83),('11288','2014-04-06','09:45:00',4.47),('11288','2014-04-06','09:50:00',5.12),('11288','2014-04-06','09:55:00',4.99),('11288','2014-04-06','10:00:00',5.5),('11288','2014-04-06','10:05:00',3.16),('11288','2014-04-06','10:10:00',2.51),('11288','2014-04-06','10:15:00',2.99),('11288','2014-04-06','10:20:00',2.44),('11288','2014-04-06','10:25:00',2.19),('11288','2014-04-06','10:30:00',2.35),('11288','2014-04-06','10:35:00',2.6),('11288','2014-04-06','10:40:00',2.84),('11288','2014-04-06','10:45:00',4.36),('11288','2014-04-06','10:50:00',6.03),('11288','2014-04-06','10:55:00',2.49),('11288','2014-04-06','11:00:00',5.58),('11288','2014-04-06','11:05:00',5.98),('11288','2014-04-06','11:10:00',6.64),('11288','2014-04-06','11:15:00',3.71),('11288','2014-04-06','11:20:00',5.1),('11288','2014-04-06','11:25:00',6.49),('11288','2014-04-06','11:30:00',6.72),('11288','2014-04-06','11:35:00',7.22),('11288','2014-04-06','11:40:00',6.91),('11288','2014-04-06','11:45:00',6.93),('11288','2014-04-06','11:50:00',6.24),('11288','2014-04-06','11:55:00',6.31),('11288','2014-04-06','12:00:00',6.95),('11288','2014-04-06','12:05:00',6.91),('11288','2014-04-06','12:10:00',6.86),('11288','2014-04-06','12:15:00',7.06),('11288','2014-04-06','12:20:00',6.19),('11288','2014-04-06','12:25:00',3.43),('11288','2014-04-06','12:30:00',2.98),('11288','2014-04-06','12:35:00',3.74),('11288','2014-04-06','12:40:00',2.25),('11288','2014-04-06','12:45:00',1.88),('11288','2014-04-06','12:50:00',1.78),('11288','2014-04-06','12:55:00',1.84),('11288','2014-04-06','13:00:00',5.36),('11288','2014-04-06','13:05:00',5.73),('11288','2014-04-06','13:10:00',6.83),('11288','2014-04-06','13:15:00',5.42),('11288','2014-04-06','13:20:00',5.52),('11288','2014-04-06','13:25:00',2.4),('11288','2014-04-06','13:30:00',4.83),('11288','2014-04-06','13:35:00',5.95),('11288','2014-04-06','13:40:00',2.38),('11288','2014-04-06','13:45:00',5.22),('11288','2014-04-06','13:50:00',6.87),('11288','2014-04-06','13:55:00',7.23),('11288','2014-04-06','14:00:00',6.92),('11288','2014-04-06','14:05:00',6.72),('11288','2014-04-06','14:10:00',6.58),('11288','2014-04-06','14:15:00',7.01),('11288','2014-04-06','14:20:00',3.63),('11288','2014-04-06','14:25:00',2.48),('11288','2014-04-06','14:30:00',1.86),('11288','2014-04-06','14:35:00',2.19),('11288','2014-04-06','14:40:00',2.36),('11288','2014-04-06','14:45:00',6.45),('11288','2014-04-06','14:50:00',5.93),('11288','2014-04-06','14:55:00',4.32),('11288','2014-04-06','15:00:00',4.81),('11288','2014-04-06','15:05:00',2.11),('11288','2014-04-06','15:10:00',4.23),('11288','2014-04-06','15:15:00',5.36),('11288','2014-04-06','15:20:00',5.11),('11288','2014-04-06','15:25:00',2.54),('11288','2014-04-06','15:30:00',2.23),('11288','2014-04-06','15:35:00',1.15),('11288','2014-04-06','15:40:00',1.23),('11288','2014-04-06','15:45:00',1.66),('11288','2014-04-06','15:50:00',2.31),('11288','2014-04-06','15:55:00',6.21),('11288','2014-04-06','16:00:00',5.68),('11288','2014-04-06','16:05:00',3.37),('11288','2014-04-06','16:10:00',3.61),('11288','2014-04-06','16:15:00',2.4),('11288','2014-04-06','16:20:00',1.09),('11288','2014-04-06','16:25:00',1.32),('11288','2014-04-06','16:30:00',1.61),('11288','2014-04-06','16:35:00',2.35),('11288','2014-04-06','16:40:00',3.12),('11288','2014-04-06','16:45:00',4.5),('11288','2014-04-06','16:50:00',4.87),('11288','2014-04-06','16:55:00',4.02),('11288','2014-04-06','17:00:00',1.53),('11288','2014-04-06','17:05:00',1.31),('11288','2014-04-06','17:10:00',1.12),('11288','2014-04-06','17:15:00',1.01),('11288','2014-04-06','17:20:00',1.27),('11288','2014-04-06','17:25:00',2.44),('11288','2014-04-06','17:30:00',2.6),('11288','2014-04-06','17:35:00',2.02),('11288','2014-04-06','17:40:00',1),('11288','2014-04-06','17:45:00',1.6),('11288','2014-04-06','17:50:00',2.26),('11288','2014-04-06','17:55:00',1.99),('11288','2014-04-06','18:00:00',1.85),('11288','2014-04-06','18:05:00',1.68),('11288','2014-04-06','18:10:00',1.57),('11288','2014-04-06','18:15:00',1.51),('11288','2014-04-06','18:20:00',1.49),('11288','2014-04-06','18:25:00',1.32),('11288','2013-07-10','07:15:00',1.15),('11288','2013-07-10','07:20:00',1.47),('11288','2013-07-10','07:25:00',1.78),('11288','2013-07-10','07:30:00',1.93),('11288','2013-07-10','07:35:00',2.14),('11288','2013-07-10','07:40:00',2.39),('11288','2013-07-10','07:45:00',2.5),('11288','2013-07-10','07:50:00',2.68),('11288','2013-07-10','07:55:00',2.89),('11288','2013-07-10','08:00:00',2.48),('11288','2013-07-10','08:05:00',2.72),('11288','2013-07-10','08:10:00',2.94),('11288','2013-07-10','08:15:00',2.86),('11288','2013-07-10','08:20:00',3.05),('11288','2013-07-10','08:25:00',2.99),('11288','2013-07-10','08:30:00',2.82),('11288','2013-07-10','08:35:00',3.22),('11288','2013-07-10','08:40:00',3.7),('11288','2013-07-10','08:45:00',3.78),('11288','2013-07-10','08:50:00',3.84),('11288','2013-07-10','08:55:00',3.7),('11288','2013-07-10','09:00:00',3.78),('11288','2013-07-10','09:05:00',3.96),('11288','2013-07-10','09:10:00',3.99),('11288','2013-07-10','09:15:00',4.22),('11288','2013-07-10','09:20:00',3.31),('11288','2013-07-10','09:25:00',2.98),('11288','2013-07-10','09:30:00',3.95),('11288','2013-07-10','09:35:00',4.34),('11288','2013-07-10','09:40:00',4.44),('11288','2013-07-10','09:45:00',4.64),('11288','2013-07-10','09:50:00',4.53),('11288','2013-07-10','09:55:00',3.7),('11288','2013-07-10','10:00:00',5.02),('11288','2013-07-10','10:05:00',5.02),('11288','2013-07-10','10:10:00',5.17),('11288','2013-07-10','10:15:00',5.34),('11288','2013-07-10','10:20:00',5.46),('11288','2013-07-10','10:25:00',5.6),('11288','2013-07-10','10:30:00',5.67),('11288','2013-07-10','10:35:00',5.76),('11288','2013-07-10','10:40:00',5.84),('11288','2013-07-10','10:45:00',5.93),('11288','2013-07-10','10:50:00',6.01),('11288','2013-07-10','10:55:00',6.03),('11288','2013-07-10','11:00:00',6.11),('11288','2013-07-10','11:05:00',6.1),('11288','2013-07-10','11:10:00',6.17),('11288','2013-07-10','11:15:00',6.24),('11288','2013-07-10','11:20:00',6.33),('11288','2013-07-10','11:25:00',6.33),('11288','2013-07-10','11:30:00',6.36),('11288','2013-07-10','11:35:00',6.44),('11288','2013-07-10','11:40:00',6.47),('11288','2013-07-10','11:45:00',6.52),('11288','2013-07-10','11:50:00',6.57),('11288','2013-07-10','11:55:00',6.6),('11288','2013-07-10','12:00:00',6.62),('11288','2013-07-10','12:05:00',6.66),('11288','2013-07-10','12:10:00',6.72),('11288','2013-07-10','12:15:00',6.77),('11288','2013-07-10','12:20:00',6.83),('11288','2013-07-10','12:25:00',6.76),('11288','2013-07-10','12:30:00',6.72),('11288','2013-07-10','12:35:00',6.91),('11288','2013-07-10','12:40:00',6.96),('11288','2013-07-10','12:45:00',6.83),('11288','2013-07-10','12:50:00',6.92),('11288','2013-07-10','12:55:00',6.9),('11288','2013-07-10','13:00:00',6.96),('11288','2013-07-10','13:05:00',6.97),('11288','2013-07-10','13:10:00',6.95),('11288','2013-07-10','13:15:00',6.86),('11288','2013-07-10','13:20:00',6.89),('11288','2013-07-10','13:25:00',6.92),('11288','2013-07-10','13:30:00',6.89),('11288','2013-07-10','13:35:00',6.97),('11288','2013-07-10','13:40:00',6.97),('11288','2013-07-10','13:45:00',6.99),('11288','2013-07-10','13:50:00',6.99),('11288','2013-07-10','13:55:00',6.97),('11288','2013-07-10','14:00:00',6.93),('11288','2013-07-10','14:05:00',6.94),('11288','2013-07-10','14:10:00',6.95),('11288','2013-07-10','14:15:00',6.93),('11288','2013-07-10','14:20:00',6.95),('11288','2013-07-10','14:25:00',6.9),('11288','2013-07-10','14:30:00',6.83),('11288','2013-07-10','14:35:00',6.81),('11288','2013-07-10','14:40:00',6.8),('11288','2013-07-10','14:45:00',6.7),('11288','2013-07-10','14:50:00',6.69),('11288','2013-07-10','14:55:00',6.65),('11288','2013-07-10','15:00:00',6.59),('11288','2013-07-10','15:05:00',6.61),('11288','2013-07-10','15:10:00',6.56),('11288','2013-07-10','15:15:00',6.48),('11288','2013-07-10','15:20:00',6.41),('11288','2013-07-10','15:25:00',6.34),('11288','2013-07-10','15:30:00',6.29),('11288','2013-07-10','15:35:00',6.21),('11288','2013-07-10','15:45:00',2.82),('11288','2013-07-10','15:50:00',5.95),('11288','2013-07-10','15:55:00',5.91),('11288','2013-07-10','16:00:00',5.84),('11288','2013-07-10','16:05:00',4.06),('11288','2013-07-10','16:10:00',5.69),('11288','2013-07-10','16:15:00',5.58),('11288','2013-07-10','16:20:00',5.43),('11288','2013-07-10','16:25:00',3.98),('11288','2013-07-10','16:30:00',4.97),('11288','2013-07-10','16:35:00',5.12),('11288','2013-07-10','16:40:00',5),('11288','2013-07-10','16:45:00',4.43),('11288','2013-07-10','16:50:00',3.94),('11288','2013-07-10','16:55:00',4.56),('11288','2013-07-10','17:00:00',4.65),('11288','2013-07-10','17:05:00',4.02),('11288','2013-07-10','17:10:00',3.22),('11288','2013-07-10','17:15:00',2.65),('11288','2013-07-10','17:20:00',3.04),('11288','2013-07-10','17:25:00',1.38),('11288','2013-07-10','17:30:00',1.1),('11288','2013-07-10','17:35:00',2.43),('11288','2013-07-10','17:40:00',2.59),('11288','2013-07-10','17:45:00',2.98),('11288','2013-07-10','17:50:00',3.41),('11288','2013-07-10','17:55:00',3.03),('11288','2013-07-10','18:00:00',3.02),('11288','2013-07-10','18:05:00',2.77),('11288','2013-07-10','18:10:00',2.39),('11288','2013-07-10','18:15:00',1.25),('11288','2013-07-10','18:20:00',2.08),('11288','2013-07-10','18:25:00',1.13),('11288','2013-07-10','18:30:00',1.01),('11288','2013-07-10','19:05:00',1.14),('11288','2013-07-10','19:10:00',1.31),('11288','2013-07-10','19:15:00',1.23),('11288','2013-07-10','19:20:00',1.09),('11288','2013-07-09','07:15:00',1.04),('11288','2013-07-09','07:20:00',1.13),('11288','2013-07-09','07:25:00',1.17),('11288','2013-07-09','07:35:00',1.04),('11288','2013-07-09','07:40:00',1.43),('11288','2013-07-09','07:45:00',1.59),('11288','2013-07-09','07:50:00',1.65),('11288','2013-07-09','07:55:00',1.88),('11288','2013-07-09','08:00:00',2.05),('11288','2013-07-09','08:05:00',2.11),('11288','2013-07-09','08:10:00',2.24),('11288','2013-07-09','08:15:00',2.34),('11288','2013-07-09','08:20:00',2.37),('11288','2013-07-09','08:25:00',2.43),('11288','2013-07-09','08:30:00',2.78),('11288','2013-07-09','08:35:00',2.81),('11288','2013-07-09','08:40:00',2.91),('11288','2013-07-09','08:45:00',3.21),('11288','2013-07-09','08:50:00',3.34),('11288','2013-07-09','08:55:00',3.48),('11288','2013-07-09','09:00:00',3.67),('11288','2013-07-09','09:05:00',3.7),('11288','2013-07-09','09:10:00',3.57),('11288','2013-07-09','09:15:00',3.87),('11288','2013-07-09','09:20:00',3.96),('11288','2013-07-09','09:25:00',3.94),('11288','2013-07-09','09:30:00',4.31),('11288','2013-07-09','09:35:00',4.38),('11288','2013-07-09','09:40:00',4.37),('11288','2013-07-09','09:45:00',4.6),('11288','2013-07-09','09:50:00',4.64),('11288','2013-07-09','09:55:00',4.66),('11288','2013-07-09','10:00:00',4.87),('11288','2013-07-09','10:05:00',4.82),('11288','2013-07-09','10:10:00',5.09),('11288','2013-07-09','10:15:00',5.26),('11288','2013-07-09','10:20:00',5.41),('11288','2013-07-09','10:25:00',5.53),('11288','2013-07-09','10:30:00',5.62),('11288','2013-07-09','10:35:00',5.7),('11288','2013-07-09','10:40:00',5.8),('11288','2013-07-09','10:45:00',5.9),('11288','2013-07-09','10:50:00',5.99),('11288','2013-07-09','10:55:00',6.07),('11288','2013-07-09','11:00:00',6.18),('11288','2013-07-09','11:05:00',6.24),('11288','2013-07-09','11:10:00',6.24),('11288','2013-07-09','11:15:00',6.36),('11288','2013-07-09','11:20:00',6.16),('11288','2013-07-09','11:25:00',4.74),('11288','2013-07-09','11:30:00',5.23),('11288','2013-07-09','11:35:00',4.78),('11288','2013-07-09','11:40:00',5.15),('11288','2013-07-09','11:45:00',4.72),('11288','2013-07-09','11:50:00',7.52),('11288','2013-07-09','11:55:00',7.3),('11288','2013-07-09','12:00:00',7.19),('11288','2013-07-09','12:05:00',7.13),('11288','2013-07-09','12:10:00',6.96),('11288','2013-07-09','12:15:00',6.9),('11288','2013-07-09','12:20:00',6.73),('11288','2013-07-09','12:25:00',6.72),('11288','2013-07-09','12:30:00',6.69),('11288','2013-07-09','12:35:00',6.77),('11288','2013-07-09','12:40:00',6.78),('11288','2013-07-09','12:45:00',6.81),('11288','2013-07-09','12:50:00',6.73),('11288','2013-07-09','12:55:00',6.62),('11288','2013-07-09','13:00:00',6.76),('11288','2013-07-09','13:05:00',6.99),('11288','2013-07-09','13:10:00',7.05),('11288','2013-07-09','13:15:00',6.94),('11288','2013-07-09','13:20:00',6.93),('11288','2013-07-09','13:25:00',7.06),('11288','2013-07-09','13:30:00',7.27),('11288','2013-07-09','13:35:00',6.9),('11288','2013-07-09','13:40:00',6.8),('11288','2013-07-09','13:45:00',6.28),('11288','2013-07-09','13:50:00',5.29),('11288','2013-07-09','13:55:00',5.56),('11288','2013-07-09','14:00:00',5.71),('11288','2013-07-09','14:05:00',5.3),('11288','2013-07-09','14:10:00',5.91),('11288','2013-07-09','14:15:00',6.15),('11288','2013-07-09','14:20:00',4.78),('11288','2013-07-09','14:25:00',5.56),('11288','2013-07-09','14:30:00',3.21),('11288','2013-07-09','14:35:00',1.86),('11288','2013-07-09','14:40:00',1.65),('11288','2013-07-09','14:45:00',1.35),('11288','2013-07-09','17:30:00',1.03),('11288','2013-07-09','17:35:00',1.06),('11288','2013-07-09','17:40:00',1.02),('11288','2013-07-08','07:35:00',1.05),('11288','2013-07-08','07:40:00',1.74),('11288','2013-07-08','07:45:00',2.01),('11288','2013-07-08','07:50:00',1.6),('11288','2013-07-08','07:55:00',1.52),('11288','2013-07-08','08:00:00',1.89),('11288','2013-07-08','08:05:00',1.89),('11288','2013-07-08','08:10:00',2.12),('11288','2013-07-08','08:15:00',2.34),('11288','2013-07-08','08:20:00',2.49),('11288','2013-07-08','08:25:00',2.58),('11288','2013-07-08','08:30:00',2.82),('11288','2013-07-08','08:35:00',2.94),('11288','2013-07-08','08:40:00',2.98),('11288','2013-07-08','08:45:00',3.26),('11288','2013-07-08','08:50:00',3.38),('11288','2013-07-08','08:55:00',3.53),('11288','2013-07-08','09:00:00',3.67),('11288','2013-07-08','09:05:00',3.69),('11288','2013-07-08','09:10:00',3.58),('11288','2013-07-08','09:15:00',3.82),('11288','2013-07-08','09:20:00',3.93),('11288','2013-07-08','09:25:00',3.77),('11288','2013-07-08','09:30:00',4.25),('11288','2013-07-08','09:35:00',4.46),('11288','2013-07-08','09:40:00',4.46),('11288','2013-07-08','09:45:00',4.7),('11288','2013-07-08','09:50:00',4.71),('11288','2013-07-08','09:55:00',4.83),('11288','2013-07-08','10:00:00',5.15),('11288','2013-07-08','10:05:00',5.22),('11288','2013-07-08','10:10:00',5.31),('11288','2013-07-08','10:15:00',5.41),('11288','2013-07-08','10:20:00',5.48),('11288','2013-07-08','10:25:00',5.61),('11288','2013-07-08','10:30:00',5.75),('11288','2013-07-08','10:35:00',5.76),('11288','2013-07-08','10:40:00',5.78),('11288','2013-07-08','10:45:00',5.89),('11288','2013-07-08','10:50:00',5.99),('11288','2013-07-08','10:55:00',6.07),('11288','2013-07-08','11:00:00',6.1),('11288','2013-07-08','11:05:00',6.18),('11288','2013-07-08','11:10:00',6.26),('11288','2013-07-08','11:15:00',6.33),('11288','2013-07-08','11:20:00',6.4),('11288','2013-07-08','11:25:00',6.49),('11288','2013-07-08','11:30:00',6.54),('11288','2013-07-08','11:35:00',6.58),('11288','2013-07-08','11:40:00',6.37),('11288','2013-07-08','11:45:00',6.49),('11288','2013-07-08','11:50:00',6.69),('11288','2013-07-08','11:55:00',6.62),('11288','2013-07-08','12:00:00',6.66),('11288','2013-07-08','12:05:00',6.86),('11288','2013-07-08','12:10:00',7.03),('11288','2013-07-08','12:15:00',7.19),('11288','2013-07-08','12:20:00',6.79),('11288','2013-07-08','12:25:00',7.06),('11288','2013-07-08','12:30:00',5.81),('11288','2013-07-08','12:35:00',6.95),('11288','2013-07-08','12:40:00',6.99),('11288','2013-07-08','12:45:00',6.95),('11288','2013-07-08','12:50:00',6.93),('11288','2013-07-08','12:55:00',7.03),('11288','2013-07-08','13:00:00',7.25),('11288','2013-07-08','13:05:00',6.97),('11288','2013-07-08','13:10:00',6.68),('11288','2013-07-08','13:15:00',7.81),('11288','2013-07-08','13:20:00',5.9),('11288','2013-07-08','13:25:00',2.06),('11288','2013-07-08','13:30:00',1.18),('11288','2013-07-08','14:00:00',1.15),('11288','2013-07-08','14:05:00',1.43),('11288','2013-07-08','14:10:00',1.55),('11288','2013-07-08','14:15:00',1.6),('11288','2013-07-08','14:20:00',1.6),('11288','2013-07-08','14:25:00',1.67),('11288','2013-07-08','14:30:00',1.83),('11288','2013-07-08','14:35:00',2.14),('11288','2013-07-08','14:40:00',2.25),('11288','2013-07-08','14:45:00',2.13),('11288','2013-07-08','14:50:00',2.09),('11288','2013-07-08','14:55:00',2.06),('11288','2013-07-08','15:00:00',1.91),('11288','2013-07-08','15:05:00',1.72),('11288','2013-07-08','15:10:00',1.57),('11288','2013-07-08','15:15:00',1.37),('11288','2013-07-08','15:20:00',1.04),('11288','2013-07-08','17:20:00',1.14),('11288','2013-07-08','17:25:00',1.45),('11288','2013-07-08','17:30:00',1.7),('11288','2013-07-08','17:35:00',1.89),('11288','2013-07-08','17:40:00',1.94),('11288','2013-07-08','17:45:00',1.92),('11288','2013-07-08','17:50:00',1.92),('11288','2013-07-08','17:55:00',1.85),('11288','2013-07-08','18:00:00',1.7),('11288','2013-07-08','18:05:00',1.53),('11288','2013-07-08','18:10:00',1.45),('11288','2013-07-08','18:15:00',1.51),('11288','2013-07-08','18:20:00',1.66),('11288','2013-07-08','18:25:00',1.69),('11288','2013-07-08','18:30:00',1.63),('11288','2013-07-08','18:35:00',1.59),('11288','2013-07-08','18:40:00',1.95),('11288','2013-07-08','18:45:00',2.16),('11288','2013-07-08','18:50:00',2.02),('11288','2013-07-08','18:55:00',1.67),('11288','2013-07-08','19:00:00',1.46),('11288','2013-07-08','19:05:00',1.16),('11288','2013-07-07','07:20:00',1.04),('11288','2013-07-07','07:25:00',1.15),('11288','2013-07-07','07:30:00',1.24),('11288','2013-07-07','07:35:00',1.31),('11288','2013-07-07','07:40:00',1.45),('11288','2013-07-07','07:45:00',1.51),('11288','2013-07-07','07:50:00',1.58),('11288','2013-07-07','07:55:00',1.88),('11288','2013-07-07','08:00:00',1.99),('11288','2013-07-07','08:05:00',2.1),('11288','2013-07-07','08:10:00',2.33),('11288','2013-07-07','08:15:00',2.39),('11288','2013-07-07','08:20:00',1.87),('11288','2013-07-07','08:25:00',2.13),('11288','2013-07-07','08:30:00',2.53),('11288','2013-07-07','08:35:00',3.12),('11288','2013-07-07','08:40:00',2.93),('11288','2013-07-07','08:45:00',1.29),('11288','2013-07-07','08:50:00',2.7),('11288','2013-07-07','08:55:00',3.66),('11288','2013-07-07','09:00:00',3.74),('11288','2013-07-07','09:05:00',3.46),('11288','2013-07-07','09:10:00',3.72),('11288','2013-07-07','09:15:00',3.93),('11288','2013-07-07','09:20:00',2.59),('11288','2013-07-07','09:25:00',3.12),('11288','2013-07-07','09:30:00',4.45),('11288','2013-07-07','09:35:00',4.66),('11288','2013-07-07','09:40:00',4.61),('11288','2013-07-07','09:45:00',4.59),('11288','2013-07-07','09:50:00',4.93),('11288','2013-07-07','09:55:00',5.15),('11288','2013-07-07','10:00:00',5.39),('11288','2013-07-07','10:05:00',5.04),('11288','2013-07-07','10:10:00',5.25),('11288','2013-07-07','10:15:00',5.3),('11288','2013-07-07','10:20:00',5.08),('11288','2013-07-07','10:25:00',5.65),('11288','2013-07-07','10:30:00',4.94),('11288','2013-07-07','10:35:00',6.06),('11288','2013-07-07','10:40:00',5.85),('11288','2013-07-07','10:45:00',5.95),('11288','2013-07-07','10:50:00',6.25),('11288','2013-07-07','10:55:00',6.23),('11288','2013-07-07','11:00:00',6.3),('11288','2013-07-07','11:05:00',6.34),('11288','2013-07-07','11:10:00',6.49),('11288','2013-07-07','11:15:00',6.52),('11288','2013-07-07','11:20:00',6.13),('11288','2013-07-07','11:25:00',5.62),('11288','2013-07-07','11:30:00',5.67),('11288','2013-07-07','11:35:00',5.69),('11288','2013-07-07','11:40:00',5.71),('11288','2013-07-07','11:45:00',5.05),('11288','2013-07-07','11:50:00',5.14),('11288','2013-07-07','11:55:00',3.84),('11288','2013-07-07','12:00:00',3.45),('11288','2013-07-07','12:05:00',6.51),('11288','2013-07-07','12:10:00',6.77),('11288','2013-07-07','12:15:00',6.75),('11288','2013-07-07','12:20:00',7.01),('11288','2013-07-07','12:25:00',6.61),('11288','2013-07-07','12:30:00',6.41),('11288','2013-07-07','12:35:00',6.75),('11288','2013-07-07','12:40:00',7.01),('11288','2013-07-07','12:45:00',7.12),('11288','2013-07-07','12:50:00',6.86),('11288','2013-07-07','12:55:00',7.21),('11288','2013-07-07','13:00:00',7.06),('11288','2013-07-07','13:05:00',6.42),('11288','2013-07-07','13:10:00',7.02),('11288','2013-07-07','13:15:00',7.11),('11288','2013-07-07','13:20:00',7),('11288','2013-07-07','13:25:00',6.04),('11288','2013-07-07','13:30:00',5.67),('11288','2013-07-07','13:35:00',7.2),('11288','2013-07-07','13:40:00',7.39),('11288','2013-07-07','13:45:00',6.79),('11288','2013-07-07','13:50:00',7.79),('11288','2013-07-07','13:55:00',6.41),('11288','2013-07-07','14:00:00',3.97),('11288','2013-07-07','14:05:00',5.86),('11288','2013-07-07','14:10:00',3.63),('11288','2013-07-07','14:15:00',2.57),('11288','2013-07-07','14:20:00',2.18),('11288','2013-07-07','14:25:00',1.92),('11288','2013-07-07','14:30:00',1.83),('11288','2013-07-07','14:35:00',1.7),('11288','2013-07-07','14:40:00',1.57),('11288','2013-07-07','14:45:00',1.44),('11288','2013-07-07','14:50:00',1.41),('11288','2013-07-07','14:55:00',1.54),('11288','2013-07-07','15:00:00',1.82),('11288','2013-07-07','15:05:00',2.07),('11288','2013-07-07','15:10:00',1.61),('11288','2013-07-07','15:15:00',1.08),('11288','2013-07-07','15:20:00',1.21),('11288','2013-07-07','15:25:00',1.1),('11288','2013-07-07','16:45:00',1.11),('11288','2013-07-07','16:50:00',1.34),('11288','2013-07-07','16:55:00',1.58),('11288','2013-07-07','17:00:00',1.77),('11288','2013-07-07','17:05:00',1.89),('11288','2013-07-07','17:10:00',1.95),('11288','2013-07-07','17:15:00',2),('11288','2013-07-07','17:20:00',2.02),('11288','2013-07-07','17:25:00',1.99),('11288','2013-07-07','17:30:00',1.92),('11288','2013-07-07','17:35:00',1.81),('11288','2013-07-07','17:40:00',1.71),('11288','2013-07-07','17:45:00',1.66),('11288','2013-07-07','17:50:00',1.63),('11288','2013-07-07','17:55:00',1.58),('11288','2013-07-07','18:00:00',1.51),('11288','2013-07-07','18:05:00',1.48),('11288','2013-07-07','18:10:00',1.43),('11288','2013-07-07','18:15:00',1.43),('11288','2013-07-07','18:20:00',1.45),('11288','2013-07-07','18:25:00',1.41),('11288','2013-07-07','18:30:00',1.33),('11288','2013-07-07','18:35:00',1.22),('11288','2013-07-07','18:40:00',1.13),('11288','2013-07-07','18:45:00',1.06),('11288','2013-07-07','18:50:00',1.04),('11288','2013-07-07','18:55:00',1.03),('11288','2013-07-06','07:20:00',1.06),('11288','2013-07-06','07:25:00',1.14),('11288','2013-07-06','07:30:00',1.22),('11288','2013-07-06','07:35:00',1.32),('11288','2013-07-06','07:40:00',1.41),('11288','2013-07-06','07:45:00',1.37),('11288','2013-07-06','07:50:00',1.55),('11288','2013-07-06','07:55:00',1.87),('11288','2013-07-06','08:00:00',1.93),('11288','2013-07-06','08:05:00',2.11),('11288','2013-07-06','08:10:00',2.22),('11288','2013-07-06','08:15:00',2.25),('11288','2013-07-06','08:20:00',2.38),('11288','2013-07-06','08:25:00',2.66),('11288','2013-07-06','08:30:00',2.71),('11288','2013-07-06','08:35:00',3),('11288','2013-07-06','08:40:00',3.07),('11288','2013-07-06','08:45:00',3.21),('11288','2013-07-06','08:50:00',3.43),('11288','2013-07-06','08:55:00',3.51),('11288','2013-07-06','09:00:00',3.6),('11288','2013-07-06','09:05:00',3.72),('11288','2013-07-06','09:10:00',3.86),('11288','2013-07-06','09:15:00',3.9),('11288','2013-07-06','09:20:00',3.97),('11288','2013-07-06','09:25:00',4.22),('11288','2013-07-06','09:30:00',4.25),('11288','2013-07-06','09:35:00',4.36),('11288','2013-07-06','09:40:00',4.53),('11288','2013-07-06','09:45:00',4.71),('11288','2013-07-06','09:50:00',4.85),('11288','2013-07-06','09:55:00',5.03),('11288','2013-07-06','10:00:00',5.04),('11288','2013-07-06','10:05:00',5.22),('11288','2013-07-06','10:10:00',5.42),('11288','2013-07-06','10:15:00',5.5),('11288','2013-07-06','10:20:00',5.59),('11288','2013-07-06','10:25:00',5.72),('11288','2013-07-06','10:30:00',5.8),('11288','2013-07-06','10:35:00',5.86),('11288','2013-07-06','10:40:00',5.91),('11288','2013-07-06','10:45:00',6.03),('11288','2013-07-06','10:50:00',6.12),('11288','2013-07-06','10:55:00',6.25),('11288','2013-07-06','11:00:00',6.34),('11288','2013-07-06','11:05:00',6.38),('11288','2013-07-06','11:10:00',6.41),('11288','2013-07-06','11:15:00',6.47),('11288','2013-07-06','11:20:00',6.44),('11288','2013-07-06','11:25:00',6.51),('11288','2013-07-06','11:30:00',6.57),('11288','2013-07-06','11:35:00',6.59),('11288','2013-07-06','11:40:00',6.57),('11288','2013-07-06','11:45:00',6.66),('11288','2013-07-06','11:50:00',6.71),('11288','2013-07-06','11:55:00',6.67),('11288','2013-07-06','12:00:00',6.76),('11288','2013-07-06','12:05:00',6.86),('11288','2013-07-06','12:10:00',7),('11288','2013-07-06','12:15:00',7.07),('11288','2013-07-06','12:20:00',7.11),('11288','2013-07-06','12:25:00',7.14),('11288','2013-07-06','12:30:00',7.11),('11288','2013-07-06','12:35:00',7.11),('11288','2013-07-06','12:40:00',7.01),('11288','2013-07-06','12:45:00',7.06),('11288','2013-07-06','12:50:00',7.08),('11288','2013-07-06','12:55:00',7.05),('11288','2013-07-06','13:00:00',7.14),('11288','2013-07-06','13:05:00',7.15),('11288','2013-07-06','13:10:00',7.06),('11288','2013-07-06','13:15:00',7.09),('11288','2013-07-06','13:20:00',7.15),('11288','2013-07-06','13:25:00',7.09),('11288','2013-07-06','13:30:00',7.17),('11288','2013-07-06','13:35:00',7.04),('11288','2013-07-06','13:40:00',7.07),('11288','2013-07-06','13:45:00',7.14),('11288','2013-07-06','13:50:00',7.05),('11288','2013-07-06','13:55:00',6.98),('11288','2013-07-06','14:00:00',7.01),('11288','2013-07-06','14:05:00',7.07),('11288','2013-07-06','14:10:00',6.97),('11288','2013-07-06','14:15:00',6.99),('11288','2013-07-06','14:20:00',5.72),('11288','2013-07-06','14:25:00',7.1),('11288','2013-07-06','14:30:00',6.9),('11288','2013-07-06','14:35:00',6.85),('11288','2013-07-06','14:40:00',6.8),('11288','2013-07-06','14:45:00',6.75),('11288','2013-07-06','14:50:00',6.37),('11288','2013-07-06','14:55:00',5.03),('11288','2013-07-06','15:00:00',5.47),('11288','2013-07-06','15:05:00',6.84),('11288','2013-07-06','15:10:00',6.68),('11288','2013-07-06','15:15:00',6.52),('11288','2013-07-06','15:20:00',6.39),('11288','2013-07-06','15:25:00',6.41),('11288','2013-07-06','15:30:00',5.47),('11288','2013-07-06','15:35:00',3.43),('11288','2013-07-06','15:40:00',1.96),('11288','2013-07-06','16:40:00',1.25),('11288','2013-07-06','16:45:00',1.72),('11288','2013-07-06','16:50:00',2.98),('11288','2013-07-06','16:55:00',2.85),('11288','2013-07-06','17:00:00',2.11),('11288','2013-07-06','17:05:00',1.98),('11288','2013-07-06','17:10:00',1.92),('11288','2013-07-06','17:15:00',2.9),('11288','2013-07-06','17:20:00',2.11),('11288','2013-07-06','17:25:00',1.85),('11288','2013-07-06','17:30:00',2.12),('11288','2013-07-06','17:35:00',2.09),('11288','2013-07-06','17:40:00',1.77),('11288','2013-07-06','17:45:00',1.68),('11288','2013-07-06','17:50:00',1.47),('11288','2013-07-06','17:55:00',1.38),('11288','2013-07-06','18:00:00',1.28),('11288','2013-07-06','18:05:00',1.18),('11288','2013-07-06','18:10:00',1.13),('11288','2013-07-06','18:15:00',1.04),('11288','2013-07-06','19:15:00',1.16),('11288','2013-07-06','19:20:00',1.08),('11288','2013-07-05','07:15:00',1.06),('11288','2013-07-05','07:20:00',1.15),('11288','2013-07-05','07:25:00',1.27),('11288','2013-07-05','07:30:00',1.31),('11288','2013-07-05','07:35:00',1.44),('11288','2013-07-05','07:40:00',1.56),('11288','2013-07-05','07:45:00',1.55),('11288','2013-07-05','07:50:00',1.7),('11288','2013-07-05','07:55:00',1.95),('11288','2013-07-05','08:00:00',2.02),('11288','2013-07-05','08:05:00',2.18),('11288','2013-07-05','08:10:00',2.35),('11288','2013-07-05','08:15:00',2.33),('11288','2013-07-05','08:20:00',2.49),('11288','2013-07-05','08:25:00',2.68),('11288','2013-07-05','08:30:00',2.76),('11288','2013-07-05','08:35:00',2.99),('11288','2013-07-05','08:40:00',3.08),('11288','2013-07-05','08:45:00',3.15),('11288','2013-07-05','08:50:00',3.43),('11288','2013-07-05','08:55:00',3.52),('11288','2013-07-05','09:00:00',3.63),('11288','2013-07-05','09:05:00',3.77),('11288','2013-07-05','09:10:00',3.85),('11288','2013-07-05','09:15:00',3.94),('11288','2013-07-05','09:20:00',4.02),('11288','2013-07-05','09:25:00',4.28),('11288','2013-07-05','09:30:00',4.28),('11288','2013-07-05','09:35:00',4.41),('11288','2013-07-05','09:40:00',4.6),('11288','2013-07-05','09:45:00',4.79),('11288','2013-07-05','09:50:00',4.91),('11288','2013-07-05','09:55:00',5.01),('11288','2013-07-05','10:00:00',5),('11288','2013-07-05','10:05:00',5.12),('11288','2013-07-05','10:10:00',5.35),('11288','2013-07-05','10:15:00',5.42),('11288','2013-07-05','10:20:00',5.55),('11288','2013-07-05','10:25:00',5.66),('11288','2013-07-05','10:30:00',5.76),('11288','2013-07-05','10:35:00',5.83),('11288','2013-07-05','10:40:00',5.91),('11288','2013-07-05','10:45:00',5.95),('11288','2013-07-05','10:50:00',6.01),('11288','2013-07-05','10:55:00',6.1),('11288','2013-07-05','11:00:00',6.15),('11288','2013-07-05','11:05:00',6.19),('11288','2013-07-05','11:10:00',6.23),('11288','2013-07-05','11:15:00',6.3),('11288','2013-07-05','11:20:00',6.38),('11288','2013-07-05','11:25:00',6.42),('11288','2013-07-05','11:30:00',6.51),('11288','2013-07-05','11:35:00',6.53),('11288','2013-07-05','11:40:00',6.54),('11288','2013-07-05','11:45:00',6.56),('11288','2013-07-05','11:50:00',6.58),('11288','2013-07-05','11:55:00',6.68),('11288','2013-07-05','12:00:00',6.68),('11288','2013-07-05','12:05:00',6.73),('11288','2013-07-05','12:10:00',6.73),('11288','2013-07-05','12:15:00',6.72),('11288','2013-07-05','12:20:00',6.89),('11288','2013-07-05','12:25:00',5.32),('11288','2013-07-05','12:30:00',6.27),('11288','2013-07-05','12:35:00',6.58),('11288','2013-07-05','12:40:00',6.13),('11288','2013-07-05','12:45:00',6.91),('11288','2013-07-05','12:50:00',6.95),('11288','2013-07-05','12:55:00',7.01),('11288','2013-07-05','13:00:00',5.47),('11288','2013-07-05','13:05:00',4.67),('11288','2013-07-05','13:10:00',6.93),('11288','2013-07-05','13:15:00',7.32),('11288','2013-07-05','13:20:00',5.31),('11288','2013-07-05','13:25:00',6.99),('11288','2013-07-05','13:30:00',6.73),('11288','2013-07-05','13:35:00',7.28),('11288','2013-07-05','13:40:00',7.24),('11288','2013-07-05','13:45:00',7.22),('11288','2013-07-05','13:50:00',7.08),('11288','2013-07-05','13:55:00',7.12),('11288','2013-07-05','14:00:00',7.16),('11288','2013-07-05','14:05:00',7.1),('11288','2013-07-05','14:10:00',6.23),('11288','2013-07-05','14:15:00',6.96),('11288','2013-07-05','14:20:00',6.87),('11288','2013-07-05','14:25:00',6.85),('11288','2013-07-05','14:30:00',6.78),('11288','2013-07-05','14:35:00',5.69),('11288','2013-07-05','14:40:00',6.54),('11288','2013-07-05','14:45:00',5.13),('11288','2013-07-05','14:50:00',5.24),('11288','2013-07-05','14:55:00',6.15),('11288','2013-07-05','15:00:00',6.74),('11288','2013-07-05','15:05:00',4.61),('11288','2013-07-05','15:10:00',6.88),('11288','2013-07-05','15:15:00',6.62),('11288','2013-07-05','15:20:00',5.47),('11288','2013-07-05','15:25:00',5),('11288','2013-07-05','15:30:00',5.59),('11288','2013-07-05','15:35:00',6.47),('11288','2013-07-05','15:40:00',6.21),('11288','2013-07-05','15:45:00',6.26),('11288','2013-07-05','15:50:00',6.1),('11288','2013-07-05','15:55:00',5.95),('11288','2013-07-05','16:00:00',5.87),('11288','2013-07-05','16:05:00',5.82),('11288','2013-07-05','16:10:00',5.67),('11288','2013-07-05','16:15:00',5.57),('11288','2013-07-05','16:20:00',5.54),('11288','2013-07-05','16:25:00',5.47),('11288','2013-07-05','16:30:00',5.35),('11288','2013-07-05','16:35:00',5.25),('11288','2013-07-05','16:40:00',5.08),('11288','2013-07-05','16:45:00',4.9),('11288','2013-07-05','16:50:00',4.61),('11288','2013-07-05','16:55:00',4.31),('11288','2013-07-05','17:00:00',4.52),('11288','2013-07-05','17:05:00',4.37),('11288','2013-07-05','17:10:00',4.29),('11288','2013-07-05','17:15:00',4.32),('11288','2013-07-05','17:20:00',4.22),('11288','2013-07-05','17:25:00',3.99),('11288','2013-07-05','17:30:00',3.86),('11288','2013-07-05','17:35:00',3.73),('11288','2013-07-05','17:40:00',3.55),('11288','2013-07-05','17:45:00',3.45),('11288','2013-07-05','17:50:00',3.24),('11288','2013-07-05','17:55:00',3.13),('11288','2013-07-05','18:00:00',3.1),('11288','2013-07-05','18:05:00',3.02),('11288','2013-07-05','18:10:00',2.69),('11288','2013-07-05','18:15:00',2.36),('11288','2013-07-05','18:20:00',2.18),('11288','2013-07-05','18:25:00',1.55),('11288','2013-07-05','18:30:00',1.95),('11288','2013-07-05','18:35:00',2),('11288','2013-07-05','18:40:00',1.94),('11288','2013-07-05','18:45:00',1.84),('11288','2013-07-05','18:50:00',1.7),('11288','2013-07-05','18:55:00',1.56),('11288','2013-07-05','19:00:00',1.43),('11288','2013-07-05','19:05:00',1.32),('11288','2013-07-05','19:10:00',1.19),('11288','2013-07-05','19:15:00',1.05),('11288','2013-07-04','08:45:00',1.08),('11288','2013-07-04','08:50:00',1.44),('11288','2013-07-04','08:55:00',1.73),('11288','2013-07-04','09:00:00',1.63),('11288','2013-07-04','09:05:00',1.33),('11288','2013-07-04','09:10:00',1.24),('11288','2013-07-04','09:15:00',1.27),('11288','2013-07-04','09:20:00',1.25),('11288','2013-07-04','09:25:00',1.39),('11288','2013-07-04','09:30:00',1.41),('11288','2013-07-04','09:35:00',1.31),('11288','2013-07-04','09:40:00',1.08),('11288','2013-07-04','10:10:00',1.06),('11288','2013-07-04','10:15:00',1.23),('11288','2013-07-04','10:20:00',1.33),('11288','2013-07-04','10:25:00',1.36),('11288','2013-07-04','10:30:00',1.39),('11288','2013-07-04','10:35:00',1.43),('11288','2013-07-04','10:40:00',1.34),('11288','2013-07-04','10:45:00',1.17),('11288','2013-07-04','10:50:00',1.07),('11288','2013-07-04','10:55:00',1.22),('11288','2013-07-04','11:00:00',1.47),('11288','2013-07-04','11:05:00',1.66),('11288','2013-07-04','11:10:00',1.94),('11288','2013-07-04','11:15:00',2.01),('11288','2013-07-04','11:20:00',1.95),('11288','2013-07-04','11:25:00',2.09),('11288','2013-07-04','11:30:00',2.29),('11288','2013-07-04','11:35:00',2.62),('11288','2013-07-04','11:40:00',2.93),('11288','2013-07-04','11:45:00',3.1),('11288','2013-07-04','11:50:00',3.06),('11288','2013-07-04','11:55:00',2.7),('11288','2013-07-04','12:00:00',2.61),('11288','2013-07-04','12:05:00',3.54),('11288','2013-07-04','12:10:00',4.37),('11288','2013-07-04','12:15:00',4.23),('11288','2013-07-04','12:20:00',4.7),('11288','2013-07-04','12:25:00',5.73),('11288','2013-07-04','12:30:00',4.72),('11288','2013-07-04','12:35:00',3.77),('11288','2013-07-04','12:40:00',2.95),('11288','2013-07-04','12:45:00',2.35),('11288','2013-07-04','12:50:00',1.9),('11288','2013-07-04','12:55:00',1.76),('11288','2013-07-04','13:00:00',2),('11288','2013-07-04','13:05:00',2.49),('11288','2013-07-04','13:10:00',3.29),('11288','2013-07-04','13:15:00',4.57),('11288','2013-07-04','13:20:00',3.84),('11288','2013-07-04','13:25:00',4.85),('11288','2013-07-04','13:30:00',4.22),('11288','2013-07-04','13:35:00',4.98),('11288','2013-07-04','13:40:00',7.76),('11288','2013-07-04','13:45:00',8.06),('11288','2013-07-04','13:50:00',9.22),('11288','2013-07-04','13:55:00',6.76),('11288','2013-07-04','14:00:00',5.46),('11288','2013-07-04','14:05:00',4.05),('11288','2013-07-04','14:10:00',3.92),('11288','2013-07-04','14:15:00',4.05),('11288','2013-07-04','14:20:00',4),('11288','2013-07-04','14:25:00',3.72),('11288','2013-07-04','14:30:00',3.71),('11288','2013-07-04','14:35:00',4.08),('11288','2013-07-04','14:40:00',4.07),('11288','2013-07-04','14:45:00',5.79),('11288','2013-07-04','14:50:00',4.86),('11288','2013-07-04','14:55:00',3.64),('11288','2013-07-04','15:00:00',3.27),('11288','2013-07-04','15:05:00',3.41),('11288','2013-07-04','15:10:00',4.96),('11288','2013-07-04','15:15:00',4.38),('11288','2013-07-04','15:20:00',4.94),('11288','2013-07-04','15:25:00',6.44),('11288','2013-07-04','15:30:00',4.61),('11288','2013-07-04','15:35:00',3.76),('11288','2013-07-04','15:40:00',4.63),('11288','2013-07-04','15:45:00',6.21),('11288','2013-07-04','15:50:00',3.53),('11288','2013-07-04','15:55:00',3.62),('11288','2013-07-04','16:00:00',3.75),('11288','2013-07-04','16:05:00',4.02),('11288','2013-07-04','16:10:00',3.21),('11288','2013-07-04','16:15:00',3.22),('11288','2013-07-04','16:20:00',3.34),('11288','2013-07-04','16:25:00',4.13),('11288','2013-07-04','16:30:00',3.72),('11288','2013-07-04','16:35:00',4.64),('11288','2013-07-04','16:40:00',2.97),('11288','2013-07-04','16:45:00',2.86),('11288','2013-07-04','16:50:00',2.73),('11288','2013-07-04','16:55:00',2.6),('11288','2013-07-04','17:00:00',2.31),('11288','2013-07-04','17:05:00',2.35),('11288','2013-07-04','17:10:00',3.01),('11288','2013-07-04','17:15:00',4.17),('11288','2013-07-04','17:20:00',3.32),('11288','2013-07-04','17:25:00',4.58),('11288','2013-07-04','17:30:00',3.67),('11288','2013-07-04','17:35:00',4.01),('11288','2013-07-04','17:40:00',3.98),('11288','2013-07-04','17:45:00',3.93),('11288','2013-07-04','17:50:00',3.8),('11288','2013-07-04','17:55:00',3.1),('11288','2013-07-04','18:00:00',3.26),('11288','2013-07-04','18:05:00',3.1),('11288','2013-07-04','18:10:00',3.19),('11288','2013-07-04','18:15:00',3.18),('11288','2013-07-04','18:20:00',2.94),('11288','2013-07-04','18:25:00',2.34),('11288','2013-07-04','18:30:00',1.68),('11288','2013-07-04','18:35:00',1.59),('11288','2013-07-04','18:40:00',1.07),('11288','2013-07-03','07:15:00',1.01),('11288','2013-07-03','07:20:00',1.15),('11288','2013-07-03','07:25:00',1.23),('11288','2013-07-03','07:30:00',1.29),('11288','2013-07-03','07:35:00',1.38),('11288','2013-07-03','07:40:00',1.5),('11288','2013-07-03','07:45:00',1.55),('11288','2013-07-03','07:50:00',1.71),('11288','2013-07-03','07:55:00',1.9),('11288','2013-07-03','08:00:00',2),('11288','2013-07-03','08:05:00',2.3),('11288','2013-07-03','08:10:00',2.39),('11288','2013-07-03','08:15:00',2.38),('11288','2013-07-03','08:20:00',2.54),('11288','2013-07-03','08:25:00',2.85),('11288','2013-07-03','08:30:00',2.83),('11288','2013-07-03','08:35:00',3.08),('11288','2013-07-03','08:40:00',3.2),('11288','2013-07-03','08:45:00',3.28),('11288','2013-07-03','08:50:00',3.5),('11288','2013-07-03','08:55:00',3.69),('11288','2013-07-03','09:00:00',3.72),('11288','2013-07-03','09:05:00',3.89),('11288','2013-07-03','09:10:00',4.02),('11288','2013-07-03','09:15:00',3.96),('11288','2013-07-03','09:20:00',4.13),('11288','2013-07-03','09:25:00',4.45),('11288','2013-07-03','09:30:00',4.39),('11288','2013-07-03','09:35:00',4.49),('11288','2013-07-03','09:40:00',4.67),('11288','2013-07-03','09:45:00',4.84),('11288','2013-07-03','09:50:00',4.99),('11288','2013-07-03','09:55:00',5.13),('11288','2013-07-03','10:00:00',5.21),('11288','2013-07-03','10:05:00',5.29),('11288','2013-07-03','10:10:00',5.42),('11288','2013-07-03','10:15:00',5.49),('11288','2013-07-03','10:20:00',5.52),('11288','2013-07-03','10:25:00',5.61),('11288','2013-07-03','10:30:00',5.8),('11288','2013-07-03','10:35:00',5.86),('11288','2013-07-03','10:40:00',5.98),('11288','2013-07-03','10:45:00',6),('11288','2013-07-03','10:50:00',6.07),('11288','2013-07-03','10:55:00',6.18),('11288','2013-07-03','11:00:00',6.28),('11288','2013-07-03','11:05:00',6.34),('11288','2013-07-03','11:10:00',6.43),('11288','2013-07-03','11:15:00',6.51),('11288','2013-07-03','11:20:00',6.5),('11288','2013-07-03','11:25:00',6.45),('11288','2013-07-03','11:30:00',6.51),('11288','2013-07-03','11:35:00',6.6),('11288','2013-07-03','11:40:00',6.77),('11288','2013-07-03','11:45:00',6.79),('11288','2013-07-03','11:50:00',6.73),('11288','2013-07-03','11:55:00',6.81),('11288','2013-07-03','12:00:00',6.84),('11288','2013-07-03','12:05:00',6.89),('11288','2013-07-03','12:10:00',6.89),('11288','2013-07-03','12:15:00',6.89),('11288','2013-07-03','12:20:00',6.91),('11288','2013-07-03','12:25:00',7),('11288','2013-07-03','12:30:00',7.09),('11288','2013-07-03','12:35:00',7.1),('11288','2013-07-03','12:40:00',7.06),('11288','2013-07-03','12:45:00',7.07),('11288','2013-07-03','12:50:00',7.13),('11288','2013-07-03','12:55:00',7.15),('11288','2013-07-03','13:00:00',7.15),('11288','2013-07-03','13:05:00',7.18),('11288','2013-07-03','13:10:00',7.18),('11288','2013-07-03','13:15:00',7.19),('11288','2013-07-03','13:20:00',7.13),('11288','2013-07-03','13:25:00',7.14),('11288','2013-07-03','13:30:00',7.12),('11288','2013-07-03','13:35:00',7.1),('11288','2013-07-03','13:40:00',7.09),('11288','2013-07-03','13:45:00',7.1),('11288','2013-07-03','13:50:00',7.13),('11288','2013-07-03','13:55:00',7.08),('11288','2013-07-03','14:00:00',7.08),('11288','2013-07-03','14:05:00',7.08),('11288','2013-07-03','14:10:00',7.01),('11288','2013-07-03','14:15:00',7.02),('11288','2013-07-03','14:20:00',7),('11288','2013-07-03','14:25:00',7),('11288','2013-07-03','14:30:00',6.98),('11288','2013-07-03','14:35:00',6.93),('11288','2013-07-03','14:40:00',6.87),('11288','2013-07-03','14:45:00',6.82),('11288','2013-07-03','14:50:00',6.8),('11288','2013-07-03','14:55:00',6.78),('11288','2013-07-03','15:00:00',6.73),('11288','2013-07-03','15:05:00',6.68),('11288','2013-07-03','15:10:00',6.66),('11288','2013-07-03','15:15:00',6.63),('11288','2013-07-03','15:20:00',6.54),('11288','2013-07-03','15:25:00',6.48),('11288','2013-07-03','15:30:00',6.44),('11288','2013-07-03','15:35:00',6.36),('11288','2013-07-03','15:40:00',6.27),('11288','2013-07-03','15:45:00',6.19),('11288','2013-07-03','15:50:00',6.12),('11288','2013-07-03','15:55:00',6.05),('11288','2013-07-03','16:00:00',5.99),('11288','2013-07-03','16:05:00',5.93),('11288','2013-07-03','16:10:00',5.82),('11288','2013-07-03','16:15:00',5.75),('11288','2013-07-03','16:20:00',5.61),('11288','2013-07-03','16:25:00',5.49),('11288','2013-07-03','16:30:00',5.43),('11288','2013-07-03','16:35:00',5.34),('11288','2013-07-03','16:40:00',5.17),('11288','2013-07-03','16:45:00',4.93),('11288','2013-07-03','16:50:00',4.7),('11288','2013-07-03','16:55:00',4.69),('11288','2013-07-03','17:00:00',4.75),('11288','2013-07-03','17:05:00',4.63),('11288','2013-07-03','17:10:00',4.5),('11288','2013-07-03','17:15:00',4.4),('11288','2013-07-03','17:20:00',4.3),('11288','2013-07-03','17:25:00',4.18),('11288','2013-07-03','17:30:00',4.02),('11288','2013-07-03','17:35:00',3.9),('11288','2013-07-03','17:40:00',3.86),('11288','2013-07-03','17:45:00',3.75),('11288','2013-07-03','17:50:00',3.56),('11288','2013-07-03','17:55:00',3.43),('11288','2013-07-03','18:00:00',3.29),('11288','2013-07-03','18:05:00',3.1),('11288','2013-07-03','18:10:00',3.01),('11288','2013-07-03','18:15:00',2.89),('11288','2013-07-03','18:20:00',2.76),('11288','2013-07-03','18:25:00',2.63),('11288','2013-07-03','18:30:00',2.46),('11288','2013-07-03','18:35:00',2.34),('11288','2013-07-03','18:40:00',2.2),('11288','2013-07-03','18:45:00',2.08),('11288','2013-07-03','18:50:00',1.93),('11288','2013-07-03','18:55:00',1.79),('11288','2013-07-03','19:00:00',1.65),('11288','2013-07-03','19:05:00',1.52),('11288','2013-07-03','19:10:00',1.37),('11288','2013-07-03','19:15:00',1.22),('11288','2013-07-03','19:20:00',1.1),('11288','2013-07-03','19:25:00',1.01),('11288','2013-07-02','07:20:00',1.14),('11288','2013-07-02','07:25:00',1.2),('11288','2013-07-02','07:30:00',1.26),('11288','2013-07-02','07:35:00',1.38),('11288','2013-07-02','07:40:00',1.49),('11288','2013-07-02','07:45:00',1.5),('11288','2013-07-02','07:50:00',1.72),('11288','2013-07-02','07:55:00',1.82),('11288','2013-07-02','08:00:00',2),('11288','2013-07-02','08:05:00',2.25),('11288','2013-07-02','08:10:00',2.28),('11288','2013-07-02','08:15:00',2.37),('11288','2013-07-02','08:20:00',2.55),('11288','2013-07-02','08:25:00',2.81),('11288','2013-07-02','08:30:00',2.8),('11288','2013-07-02','08:35:00',3.09),('11288','2013-07-02','08:40:00',3.18),('11288','2013-07-02','08:45:00',3.22),('11288','2013-07-02','08:50:00',3.47),('11288','2013-07-02','08:55:00',3.64),('11288','2013-07-02','09:00:00',3.67),('11288','2013-07-02','09:05:00',3.86),('11288','2013-07-02','09:10:00',3.94),('11288','2013-07-02','09:15:00',3.86),('11288','2013-07-02','09:20:00',4.1),('11288','2013-07-02','09:25:00',4.32),('11288','2013-07-02','09:30:00',4.24),('11288','2013-07-02','09:35:00',4.45),('11288','2013-07-02','09:40:00',4.67),('11288','2013-07-02','09:45:00',4.83),('11288','2013-07-02','09:50:00',4.94),('11288','2013-07-02','09:55:00',5.1),('11288','2013-07-02','10:00:00',5.19),('11288','2013-07-02','10:05:00',5.28),('11288','2013-07-02','10:10:00',5.38),('11288','2013-07-02','10:15:00',5.48),('11288','2013-07-02','10:20:00',5.58),('11288','2013-07-02','10:25:00',5.65),('11288','2013-07-02','10:30:00',5.71),('11288','2013-07-02','10:35:00',5.75),('11288','2013-07-02','10:40:00',5.89),('11288','2013-07-02','10:45:00',5.99),('11288','2013-07-02','10:50:00',5.99),('11288','2013-07-02','10:55:00',6.11),('11288','2013-07-02','11:00:00',6.15),('11288','2013-07-02','11:05:00',6.13),('11288','2013-07-02','11:10:00',6.15),('11288','2013-07-02','11:15:00',6.27),('11288','2013-07-02','11:20:00',6.33),('11288','2013-07-02','11:25:00',6.38),('11288','2013-07-02','11:30:00',6.34),('11288','2013-07-02','11:35:00',6.42),('11288','2013-07-02','11:40:00',6.5),('11288','2013-07-02','11:45:00',6.5),('11288','2013-07-02','11:50:00',6.5),('11288','2013-07-02','11:55:00',6.56),('11288','2013-07-02','12:00:00',6.62),('11288','2013-07-02','12:05:00',6.63),('11288','2013-07-02','12:10:00',6.65),('11288','2013-07-02','12:15:00',6.61),('11288','2013-07-02','12:20:00',6.7),('11288','2013-07-02','12:25:00',6.74),('11288','2013-07-02','12:30:00',6.85),('11288','2013-07-02','12:35:00',4.58),('11288','2013-07-02','12:40:00',7.17),('11288','2013-07-02','12:45:00',7.31),('11288','2013-07-02','12:50:00',6.3),('11288','2013-07-02','12:55:00',6.07),('11288','2013-07-02','13:00:00',4.57),('11288','2013-07-02','13:05:00',5.72),('11288','2013-07-02','13:10:00',7.55),('11288','2013-07-02','13:15:00',6.46),('11288','2013-07-02','13:20:00',7.18),('11288','2013-07-02','13:25:00',7.18),('11288','2013-07-02','13:30:00',6.92),('11288','2013-07-02','13:35:00',6.99),('11288','2013-07-02','13:40:00',6.8),('11288','2013-07-02','13:45:00',6.89),('11288','2013-07-02','13:50:00',6.84),('11288','2013-07-02','13:55:00',6.84),('11288','2013-07-02','14:00:00',6.76),('11288','2013-07-02','14:05:00',6.74),('11288','2013-07-02','14:10:00',6.81),('11288','2013-07-02','14:15:00',6.86),('11288','2013-07-02','14:20:00',6.83),('11288','2013-07-02','14:25:00',6.8),('11288','2013-07-02','14:30:00',6.74),('11288','2013-07-02','14:35:00',6.73),('11288','2013-07-02','14:40:00',6.7),('11288','2013-07-02','14:45:00',6.63),('11288','2013-07-02','14:50:00',6.59),('11288','2013-07-02','14:55:00',6.54),('11288','2013-07-02','15:00:00',6.54),('11288','2013-07-02','15:05:00',6.5),('11288','2013-07-02','15:10:00',6.46),('11288','2013-07-02','15:15:00',6.39),('11288','2013-07-02','15:20:00',6.35),('11288','2013-07-02','15:25:00',6.3),('11288','2013-07-02','15:30:00',6.29),('11288','2013-07-02','15:35:00',6.24),('11288','2013-07-02','15:40:00',6.18),('11288','2013-07-02','15:45:00',6.08),('11288','2013-07-02','15:50:00',5.99),('11288','2013-07-02','15:55:00',5.95),('11288','2013-07-02','16:00:00',5.89),('11288','2013-07-02','16:05:00',5.79),('11288','2013-07-02','16:10:00',5.73),('11288','2013-07-02','16:15:00',5.61),('11288','2013-07-02','16:20:00',5.48),('11288','2013-07-02','16:25:00',5.37),('11288','2013-07-02','16:30:00',5.27),('11288','2013-07-02','16:35:00',5.19),('11288','2013-07-02','16:40:00',5.06),('11288','2013-07-02','16:45:00',4.79),('11288','2013-07-02','16:50:00',4.54),('11288','2013-07-02','16:55:00',4.61),('11288','2013-07-02','17:00:00',4.64),('11288','2013-07-02','17:05:00',4.47),('11288','2013-07-02','17:10:00',4.31),('11288','2013-07-02','17:15:00',4.23),('11288','2013-07-02','17:20:00',4.13),('11288','2013-07-02','17:25:00',4.02),('11288','2013-07-02','17:30:00',3.88),('11288','2013-07-02','17:35:00',3.73),('11288','2013-07-02','17:40:00',3.68),('11288','2013-07-02','17:45:00',3.54),('11288','2013-07-02','17:50:00',3.38),('11288','2013-07-02','17:55:00',3.26),('11288','2013-07-02','18:00:00',3.13),('11288','2013-07-02','18:05:00',3),('11288','2013-07-02','18:10:00',2.88),('11288','2013-07-02','18:15:00',2.76),('11288','2013-07-02','18:20:00',2.62),('11288','2013-07-02','18:25:00',2.49),('11288','2013-07-02','18:30:00',2.31),('11288','2013-07-02','18:35:00',2.19),('11288','2013-07-02','18:40:00',2.06),('11288','2013-07-02','18:45:00',1.95),('11288','2013-07-02','18:50:00',1.81),('11288','2013-07-02','18:55:00',1.68),('11288','2013-07-02','19:00:00',1.57),('11288','2013-07-02','19:05:00',1.46),('11288','2013-07-02','19:10:00',1.32),('11288','2013-07-02','19:15:00',1.17),('11288','2013-07-02','19:20:00',1.06),('11288','2013-07-01','07:15:00',1.05),('11288','2013-07-01','07:20:00',1.19),('11288','2013-07-01','07:25:00',1.26),('11288','2013-07-01','07:30:00',1.33),('11288','2013-07-01','07:35:00',1.46),('11288','2013-07-01','07:40:00',1.57),('11288','2013-07-01','07:45:00',1.59),('11288','2013-07-01','07:50:00',1.75),('11288','2013-07-01','07:55:00',1.98),('11288','2013-07-01','08:00:00',2.03),('11288','2013-07-01','08:05:00',2.29),('11288','2013-07-01','08:10:00',2.37),('11288','2013-07-01','08:15:00',2.45),('11288','2013-07-01','08:20:00',2.63),('11288','2013-07-01','08:25:00',2.86),('11288','2013-07-01','08:30:00',2.83),('11288','2013-07-01','08:35:00',3.13),('11288','2013-07-01','08:40:00',3.29),('11288','2013-07-01','08:45:00',3.35),('11288','2013-07-01','08:50:00',3.45),('11288','2013-07-01','08:55:00',3.77),('11288','2013-07-01','09:00:00',3.77),('11288','2013-07-01','09:05:00',3.93),('11288','2013-07-01','09:10:00',4.04),('11288','2013-07-01','09:15:00',3.94),('11288','2013-07-01','09:20:00',4.19),('11288','2013-07-01','09:25:00',4.48),('11288','2013-07-01','09:30:00',4.4),('11288','2013-07-01','09:35:00',4.6),('11288','2013-07-01','09:40:00',4.84),('11288','2013-07-01','09:45:00',4.99),('11288','2013-07-01','09:50:00',5.1),('11288','2013-07-01','09:55:00',5.15),('11288','2013-07-01','10:00:00',5.01),('11288','2013-07-01','10:05:00',5.19),('11288','2013-07-01','10:10:00',5.48),('11288','2013-07-01','10:15:00',5.58),('11288','2013-07-01','10:20:00',5.75),('11288','2013-07-01','10:25:00',5.84),('11288','2013-07-01','10:30:00',5.91),('11288','2013-07-01','10:35:00',6.02),('11288','2013-07-01','10:40:00',6.13),('11288','2013-07-01','10:45:00',6.22),('11288','2013-07-01','10:50:00',6.31),('11288','2013-07-01','10:55:00',6.41),('11288','2013-07-01','11:00:00',6.47),('11288','2013-07-01','11:05:00',6.5),('11288','2013-07-01','11:10:00',6.46),('11288','2013-07-01','11:15:00',6.61),('11288','2013-07-01','11:20:00',6.68),('11288','2013-07-01','11:25:00',6.78),('11288','2013-07-01','11:30:00',6.8),('11288','2013-07-01','11:35:00',6.77),('11288','2013-07-01','11:40:00',6.76),('11288','2013-07-01','11:45:00',6.85),('11288','2013-07-01','11:50:00',6.92),('11288','2013-07-01','11:55:00',6.96),('11288','2013-07-01','12:00:00',6.93),('11288','2013-07-01','12:05:00',6.91),('11288','2013-07-01','12:10:00',6.9),('11288','2013-07-01','12:15:00',6.93),('11288','2013-07-01','12:20:00',6.96),('11288','2013-07-01','12:25:00',6.99),('11288','2013-07-01','12:30:00',6.98),('11288','2013-07-01','12:35:00',7.06),('11288','2013-07-01','12:40:00',7.03),('11288','2013-07-01','12:45:00',7.08),('11288','2013-07-01','12:50:00',7.09),('11288','2013-07-01','12:55:00',7.1),('11288','2013-07-01','13:00:00',7.06),('11288','2013-07-01','13:05:00',7.09),('11288','2013-07-01','13:10:00',7.15),('11288','2013-07-01','13:15:00',7.1),('11288','2013-07-01','13:20:00',7.06),('11288','2013-07-01','13:25:00',7.08),('11288','2013-07-01','13:30:00',7.13),('11288','2013-07-01','13:35:00',7.16),('11288','2013-07-01','13:40:00',7.14),('11288','2013-07-01','13:45:00',7.03),('11288','2013-07-01','13:50:00',7),('11288','2013-07-01','13:55:00',7.02),('11288','2013-07-01','14:00:00',7.03),('11288','2013-07-01','14:05:00',7.02),('11288','2013-07-01','14:10:00',7.04),('11288','2013-07-01','14:15:00',7),('11288','2013-07-01','14:20:00',6.98),('11288','2013-07-01','14:25:00',6.9),('11288','2013-07-01','14:30:00',6.88),('11288','2013-07-01','14:35:00',6.87),('11288','2013-07-01','14:40:00',6.78),('11288','2013-07-01','14:45:00',6.76),('11288','2013-07-01','14:50:00',6.68),('11288','2013-07-01','14:55:00',6.58),('11288','2013-07-01','15:00:00',6.55),('11288','2013-07-01','15:05:00',6.52),('11288','2013-07-01','15:10:00',6.5),('11288','2013-07-01','15:15:00',6.45),('11288','2013-07-01','15:20:00',6.37),('11288','2013-07-01','15:25:00',6.3),('11288','2013-07-01','15:30:00',6.22),('11288','2013-07-01','15:35:00',6.14),('11288','2013-07-01','15:40:00',6.05),('11288','2013-07-01','15:45:00',6.07),('11288','2013-07-01','15:50:00',6.01),('11288','2013-07-01','15:55:00',5.9),('11288','2013-07-01','16:00:00',5.82),('11288','2013-07-01','16:05:00',5.76),('11288','2013-07-01','16:10:00',5.63),('11288','2013-07-01','16:15:00',5.52),('11288','2013-07-01','16:20:00',5.34),('11288','2013-07-01','16:25:00',5.29),('11288','2013-07-01','16:30:00',5.2),('11288','2013-07-01','16:35:00',5.09),('11288','2013-07-01','16:40:00',4.94),('11288','2013-07-01','16:45:00',4.85),('11288','2013-07-01','16:50:00',4.77),('11288','2013-07-01','16:55:00',4.69),('11288','2013-07-01','17:00:00',4.59),('11288','2013-07-01','17:05:00',4.46),('11288','2013-07-01','17:10:00',4.32),('11288','2013-07-01','17:15:00',4.24),('11288','2013-07-01','17:20:00',4.1),('11288','2013-07-01','17:25:00',3.97),('11288','2013-07-01','17:30:00',3.83),('11288','2013-07-01','17:35:00',3.69),('11288','2013-07-01','17:40:00',3.66),('11288','2013-07-01','17:45:00',3.52),('11288','2013-07-01','17:50:00',3.39),('11288','2013-07-01','17:55:00',3.26),('11288','2013-07-01','18:00:00',2.88),('11288','2013-07-01','18:05:00',2.98),('11288','2013-07-01','18:10:00',2.82),('11288','2013-07-01','18:15:00',2.22),('11288','2013-07-01','18:20:00',2.42),('11288','2013-07-01','18:25:00',2.56),('11288','2013-07-01','18:30:00',2.39),('11288','2013-07-01','18:35:00',2.24),('11288','2013-07-01','18:40:00',2),('11288','2013-07-01','18:45:00',1.9),('11288','2013-07-01','18:50:00',1.75),('11288','2013-07-01','18:55:00',1.53),('11288','2013-07-01','19:00:00',1.47),('11288','2013-07-01','19:05:00',1.38),('11288','2013-07-01','19:10:00',1.26),('11288','2013-07-01','19:20:00',1.02),('11288','2014-04-05','08:35:00',1.17),('11288','2014-04-05','08:40:00',1.2),('11288','2014-04-05','08:45:00',1.1),('11288','2014-04-05','09:00:00',1.07),('11288','2014-04-05','09:05:00',1.26),('11288','2014-04-05','09:10:00',1.47),('11288','2014-04-05','09:15:00',1.96),('11288','2014-04-05','09:20:00',2.75),('11288','2014-04-05','09:25:00',3.02),('11288','2014-04-05','09:30:00',4.66),('11288','2014-04-05','09:35:00',4.86),('11288','2014-04-05','09:40:00',5.28),('11288','2014-04-05','09:45:00',4.7),('11288','2014-04-05','09:50:00',3.16),('11288','2014-04-05','09:55:00',2.51),('11288','2014-04-05','10:00:00',3.1),('11288','2014-04-05','10:05:00',3.21),('11288','2014-04-05','10:10:00',3.36),('11288','2014-04-05','10:15:00',3.2),('11288','2014-04-05','10:20:00',3.48),('11288','2014-04-05','10:25:00',4.32),('11288','2014-04-05','10:30:00',4.12),('11288','2014-04-05','10:35:00',4.37),('11288','2014-04-05','10:40:00',5.05),('11288','2014-04-05','10:45:00',5.35),('11288','2014-04-05','10:50:00',4.48),('11288','2014-04-05','10:55:00',4.53),('11288','2014-04-05','11:00:00',5.19),('11288','2014-04-05','11:05:00',5.64),('11288','2014-04-05','11:10:00',6.13),('11288','2014-04-05','11:15:00',6.37),('11288','2014-04-05','11:20:00',6.81),('11288','2014-04-05','11:25:00',6.29),('11288','2014-04-05','11:30:00',4.44),('11288','2014-04-05','11:35:00',3.51),('11288','2014-04-05','11:40:00',4.44),('11288','2014-04-05','11:45:00',6.09),('11288','2014-04-05','11:50:00',6.53),('11288','2014-04-05','11:55:00',6.27),('11288','2014-04-05','12:00:00',6.49),('11288','2014-04-05','12:05:00',5.22),('11288','2014-04-05','12:10:00',4.94),('11288','2014-04-05','12:15:00',5.63),('11288','2014-04-05','12:20:00',5.46),('11288','2014-04-05','12:25:00',6.09),('11288','2014-04-05','12:30:00',4.83),('11288','2014-04-05','12:35:00',4.36),('11288','2014-04-05','12:40:00',4.77),('11288','2014-04-05','12:45:00',7.45),('11288','2014-04-05','12:50:00',7.07),('11288','2014-04-05','12:55:00',7.06),('11288','2014-04-05','13:00:00',6.14),('11288','2014-04-05','13:05:00',5.02),('11288','2014-04-05','13:10:00',3.5),('11288','2014-04-05','13:15:00',3.6),('11288','2014-04-05','13:20:00',4.22),('11288','2014-04-05','13:25:00',8.02),('11288','2014-04-05','13:30:00',6.37),('11288','2014-04-05','13:35:00',5.41),('11288','2014-04-05','13:40:00',3.39),('11288','2014-04-05','13:45:00',6.71),('11288','2014-04-05','13:50:00',7.24),('11288','2014-04-05','13:55:00',6.23),('11288','2014-04-05','14:00:00',5.22),('11288','2014-04-05','14:05:00',8.08),('11288','2014-04-05','14:10:00',5.54),('11288','2014-04-05','14:15:00',1.32),('11288','2014-04-05','14:20:00',1.43),('11288','2014-04-05','14:25:00',2.27),('11288','2014-04-05','14:30:00',5.4),('11288','2014-04-05','14:35:00',1.92),('11288','2014-04-05','14:40:00',1.29),('11288','2014-04-05','14:45:00',1.26),('11288','2014-04-05','14:50:00',1.11),('11288','2014-04-05','14:55:00',5.21),('11288','2014-04-05','15:00:00',6.76),('11288','2014-04-05','15:05:00',5.82),('11288','2014-04-05','15:10:00',5.8),('11288','2014-04-05','15:15:00',3.4),('11288','2014-04-05','15:20:00',6.58),('11288','2014-04-05','15:25:00',3.53),('11288','2014-04-05','15:30:00',2.81),('11288','2014-04-05','15:35:00',2.54),('11288','2014-04-05','15:40:00',3.39),('11288','2014-04-05','15:45:00',3.55),('11288','2014-04-05','15:50:00',3.99),('11288','2014-04-05','15:55:00',2.31),('11288','2014-04-05','16:00:00',2.22),('11288','2014-04-05','16:05:00',2.22),('11288','2014-04-05','16:10:00',2.11),('11288','2014-04-05','16:15:00',3.32),('11288','2014-04-05','16:20:00',5.72),('11288','2014-04-05','16:25:00',4.94),('11288','2014-04-05','16:30:00',3.19),('11288','2014-04-05','16:35:00',4.86),('11288','2014-04-05','16:40:00',2.63),('11288','2014-04-05','16:45:00',3.67),('11288','2014-04-05','16:50:00',2.94),('11288','2014-04-05','16:55:00',3.93),('11288','2014-04-05','17:00:00',2.38),('11288','2014-04-05','17:05:00',3.26),('11288','2014-04-05','17:10:00',2.72),('11288','2014-04-05','17:15:00',1.4),('11288','2014-04-05','17:20:00',1.79),('11288','2014-04-05','17:25:00',1.96),('11288','2014-04-05','17:30:00',2),('11288','2014-04-05','17:35:00',1.8),('11288','2014-04-05','17:40:00',1.47),('11288','2014-04-05','17:45:00',1.26),('11288','2014-04-05','17:50:00',1.66),('11288','2014-04-05','17:55:00',1.7),('11288','2014-04-05','18:00:00',1.69),('11288','2014-04-05','18:05:00',1.55),('11288','2014-04-05','18:10:00',1.51),('11288','2014-04-05','18:15:00',1.57),('11288','2014-04-05','18:20:00',1.5),('11288','2014-04-05','18:25:00',1.2),('11288','2013-06-30','07:15:00',1.07),('11288','2013-06-30','07:20:00',1.23),('11288','2013-06-30','07:25:00',1.31),('11288','2013-06-30','07:30:00',1.38),('11288','2013-06-30','07:35:00',1.56),('11288','2013-06-30','07:40:00',1.63),('11288','2013-06-30','07:45:00',1.61),('11288','2013-06-30','07:50:00',1.88),('11288','2013-06-30','07:55:00',2.02),('11288','2013-06-30','08:00:00',2.06),('11288','2013-06-30','08:05:00',2.42),('11288','2013-06-30','08:10:00',2.41),('11288','2013-06-30','08:15:00',2.52),('11288','2013-06-30','08:20:00',2.71),('11288','2013-06-30','08:25:00',2.9),('11288','2013-06-30','08:30:00',3),('11288','2013-06-30','08:35:00',3.25),('11288','2013-06-30','08:40:00',3.34),('11288','2013-06-30','08:45:00',3.39),('11288','2013-06-30','08:50:00',3.64),('11288','2013-06-30','08:55:00',3.89),('11288','2013-06-30','09:00:00',3.87),('11288','2013-06-30','09:05:00',4.08),('11288','2013-06-30','09:10:00',4.23),('11288','2013-06-30','09:15:00',4.15),('11288','2013-06-30','09:20:00',4.38),('11288','2013-06-30','09:25:00',4.43),('11288','2013-06-30','09:30:00',4.14),('11288','2013-06-30','09:35:00',4.42),('11288','2013-06-30','09:40:00',4.97),('11288','2013-06-30','09:45:00',5.14),('11288','2013-06-30','09:50:00',5.29),('11288','2013-06-30','09:55:00',5.3),('11288','2013-06-30','10:00:00',5.14),('11288','2013-06-30','10:05:00',5.45),('11288','2013-06-30','10:10:00',5.73),('11288','2013-06-30','10:15:00',5.83),('11288','2013-06-30','10:20:00',5.97),('11288','2013-06-30','10:25:00',6.08),('11288','2013-06-30','10:30:00',6.12),('11288','2013-06-30','10:35:00',6.2),('11288','2013-06-30','10:40:00',6.28),('11288','2013-06-30','10:45:00',6.38),('11288','2013-06-30','10:50:00',6.44),('11288','2013-06-30','10:55:00',6.5),('11288','2013-06-30','11:00:00',6.51),('11288','2013-06-30','11:05:00',6.58),('11288','2013-06-30','11:10:00',6.64),('11288','2013-06-30','11:15:00',6.66),('11288','2013-06-30','11:20:00',6.69),('11288','2013-06-30','11:25:00',6.74),('11288','2013-06-30','11:30:00',6.76),('11288','2013-06-30','11:35:00',6.81),('11288','2013-06-30','11:40:00',6.83),('11288','2013-06-30','11:45:00',6.86),('11288','2013-06-30','11:50:00',6.92),('11288','2013-06-30','11:55:00',6.98),('11288','2013-06-30','12:00:00',7),('11288','2013-06-30','12:05:00',7.04),('11288','2013-06-30','12:10:00',7.1),('11288','2013-06-30','12:15:00',7.15),('11288','2013-06-30','12:20:00',7.15),('11288','2013-06-30','12:25:00',7.1),('11288','2013-06-30','12:30:00',7.1),('11288','2013-06-30','12:35:00',7.14),('11288','2013-06-30','12:40:00',7.18),('11288','2013-06-30','12:45:00',7.11),('11288','2013-06-30','12:50:00',7.21),('11288','2013-06-30','12:55:00',7.3),('11288','2013-06-30','13:00:00',7.32),('11288','2013-06-30','13:05:00',7.26),('11288','2013-06-30','13:10:00',7.2),('11288','2013-06-30','13:15:00',7.26),('11288','2013-06-30','13:20:00',7.3),('11288','2013-06-30','13:25:00',7.41),('11288','2013-06-30','13:30:00',7.38),('11288','2013-06-30','13:35:00',7.26),('11288','2013-06-30','13:40:00',6.77),('11288','2013-06-30','13:45:00',5.78),('11288','2013-06-30','13:50:00',7.44),('11288','2013-06-30','13:55:00',7.35),('11288','2013-06-30','14:00:00',6.91),('11288','2013-06-30','14:05:00',7.26),('11288','2013-06-30','14:10:00',7.23),('11288','2013-06-30','14:15:00',7.08),('11288','2013-06-30','14:20:00',7),('11288','2013-06-30','14:25:00',7.01),('11288','2013-06-30','14:30:00',6.85),('11288','2013-06-30','14:35:00',6.84),('11288','2013-06-30','14:40:00',6.88),('11288','2013-06-30','14:45:00',6.93),('11288','2013-06-30','14:50:00',6.84),('11288','2013-06-30','14:55:00',6.79),('11288','2013-06-30','15:00:00',6.74),('11288','2013-06-30','15:05:00',6.65),('11288','2013-06-30','15:10:00',6.66),('11288','2013-06-30','15:15:00',6.6),('11288','2013-06-30','15:20:00',6.59),('11288','2013-06-30','15:25:00',6.51),('11288','2013-06-30','15:30:00',6.47),('11288','2013-06-30','15:35:00',6.45),('11288','2013-06-30','15:40:00',6.39),('11288','2013-06-30','15:45:00',6.32),('11288','2013-06-30','15:50:00',6.31),('11288','2013-06-30','15:55:00',6.17),('11288','2013-06-30','16:00:00',6.08),('11288','2013-06-30','16:05:00',6.01),('11288','2013-06-30','16:10:00',5.96),('11288','2013-06-30','16:15:00',5.82),('11288','2013-06-30','16:20:00',5.52),('11288','2013-06-30','16:25:00',5.83),('11288','2013-06-30','16:30:00',5.82),('11288','2013-06-30','16:35:00',5.52),('11288','2013-06-30','16:40:00',5.12),('11288','2013-06-30','16:45:00',4.92),('11288','2013-06-30','16:50:00',4.68),('11288','2013-06-30','16:55:00',4.74),('11288','2013-06-30','17:00:00',4.66),('11288','2013-06-30','17:05:00',4.47),('11288','2013-06-30','17:10:00',4.42),('11288','2013-06-30','17:15:00',4.3),('11288','2013-06-30','17:20:00',4.17),('11288','2013-06-30','17:25:00',4.04),('11288','2013-06-30','17:30:00',3.86),('11288','2013-06-30','17:35:00',3.72),('11288','2013-06-30','17:40:00',3.76),('11288','2013-06-30','17:45:00',3.57),('11288','2013-06-30','17:50:00',3.43),('11288','2013-06-30','17:55:00',3.29),('11288','2013-06-30','18:00:00',3.09),('11288','2013-06-30','18:05:00',2.79),('11288','2013-06-30','18:10:00',2.86),('11288','2013-06-30','18:15:00',2.73),('11288','2013-06-30','18:20:00',2.61),('11288','2013-06-30','18:25:00',2.51),('11288','2013-06-30','18:30:00',2.31),('11288','2013-06-30','18:35:00',2.2),('11288','2013-06-30','18:40:00',2.09),('11288','2013-06-30','18:45:00',1.93),('11288','2013-06-30','18:50:00',1.83),('11288','2013-06-30','18:55:00',1.72),('11288','2013-06-30','19:00:00',1.6),('11288','2013-06-30','19:05:00',1.48),('11288','2013-06-30','19:10:00',1.36),('11288','2013-06-30','19:15:00',1.2),('11288','2013-06-30','19:20:00',1.07),('11288','2013-06-29','07:25:00',1.24),('11288','2013-06-29','07:30:00',1.84),('11288','2013-06-29','07:35:00',2.23),('11288','2013-06-29','07:40:00',2.27),('11288','2013-06-29','07:45:00',2.21),('11288','2013-06-29','07:50:00',2.36),('11288','2013-06-29','07:55:00',2.76),('11288','2013-06-29','08:00:00',3.15),('11288','2013-06-29','08:05:00',3.47),('11288','2013-06-29','08:10:00',3.41),('11288','2013-06-29','08:15:00',3.07),('11288','2013-06-29','08:20:00',2.47),('11288','2013-06-29','08:25:00',3.1),('11288','2013-06-29','08:30:00',3.24),('11288','2013-06-29','08:35:00',3.27),('11288','2013-06-29','08:40:00',2.16),('11288','2013-06-29','08:45:00',3.44),('11288','2013-06-29','08:50:00',3.7),('11288','2013-06-29','08:55:00',3.88),('11288','2013-06-29','09:00:00',3.96),('11288','2013-06-29','09:05:00',4.05),('11288','2013-06-29','09:10:00',4.07),('11288','2013-06-29','09:15:00',4.13),('11288','2013-06-29','09:20:00',4.31),('11288','2013-06-29','09:25:00',4.35),('11288','2013-06-29','09:30:00',4.52),('11288','2013-06-29','09:35:00',4.74),('11288','2013-06-29','09:40:00',4.87),('11288','2013-06-29','09:45:00',5.09),('11288','2013-06-29','09:50:00',5.2),('11288','2013-06-29','09:55:00',5.31),('11288','2013-06-29','10:00:00',5.37),('11288','2013-06-29','10:05:00',5.55),('11288','2013-06-29','10:10:00',5.65),('11288','2013-06-29','10:15:00',5.75),('11288','2013-06-29','10:20:00',5.86),('11288','2013-06-29','10:25:00',5.97),('11288','2013-06-29','10:30:00',6.05),('11288','2013-06-29','10:35:00',6.11),('11288','2013-06-29','10:40:00',6.26),('11288','2013-06-29','10:45:00',6.26),('11288','2013-06-29','10:50:00',4.06),('11288','2013-06-29','10:55:00',3.95),('11288','2013-06-29','11:00:00',6.86),('11288','2013-06-29','11:05:00',6.78),('11288','2013-06-29','11:10:00',6.84),('11288','2013-06-29','11:15:00',7.02),('11288','2013-06-29','11:20:00',7.07),('11288','2013-06-29','11:25:00',7.49),('11288','2013-06-29','11:30:00',6.91),('11288','2013-06-29','11:35:00',5.33),('11288','2013-06-29','11:40:00',3.03),('11288','2013-06-29','11:45:00',8.06),('11288','2013-06-29','11:50:00',8.16),('11288','2013-06-29','11:55:00',7.24),('11288','2013-06-29','12:00:00',6.76),('11288','2013-06-29','12:05:00',6.86),('11288','2013-06-29','12:10:00',7.56),('11288','2013-06-29','12:15:00',7.74),('11288','2013-06-29','12:20:00',4.79),('11288','2013-06-29','12:25:00',7.55),('11288','2013-06-29','12:30:00',7.86),('11288','2013-06-29','12:35:00',3.34),('11288','2013-06-29','12:40:00',3.85),('11288','2013-06-29','12:45:00',8.53),('11288','2013-06-29','12:50:00',7.21),('11288','2013-06-29','12:55:00',7.93),('11288','2013-06-29','13:00:00',4.34),('11288','2013-06-29','13:05:00',5.6),('11288','2013-06-29','13:10:00',8.06),('11288','2013-06-29','13:15:00',7.33),('11288','2013-06-29','13:20:00',2.76),('11288','2013-06-29','13:25:00',6.17),('11288','2013-06-29','13:30:00',1.91),('11288','2013-06-29','13:35:00',1.62),('11288','2013-06-29','13:40:00',1.77),('11288','2013-06-29','13:45:00',3.01),('11288','2013-06-29','13:50:00',3),('11288','2013-06-29','13:55:00',5.82),('11288','2013-06-29','14:00:00',8.41),('11288','2013-06-29','14:05:00',8.24),('11288','2013-06-29','14:10:00',7.98),('11288','2013-06-29','14:15:00',7.92),('11288','2013-06-29','14:20:00',8.3),('11288','2013-06-29','14:25:00',8.16),('11288','2013-06-29','14:30:00',7.75),('11288','2013-06-29','14:35:00',7.69),('11288','2013-06-29','14:40:00',7.7),('11288','2013-06-29','14:45:00',7.77),('11288','2013-06-29','14:50:00',8.14),('11288','2013-06-29','14:55:00',6),('11288','2013-06-29','15:00:00',6.68),('11288','2013-06-29','15:05:00',8.48),('11288','2013-06-29','15:10:00',4.63),('11288','2013-06-29','15:15:00',4.71),('11288','2013-06-29','15:20:00',2.64),('11288','2013-06-29','15:25:00',2.33),('11288','2013-06-29','15:30:00',1.22),('11288','2013-06-29','15:35:00',1.07),('11288','2013-06-29','16:25:00',1.07),('11288','2013-06-29','16:30:00',1.3),('11288','2013-06-29','16:35:00',1.71),('11288','2013-06-29','16:40:00',2.31),('11288','2013-06-29','16:45:00',2.91),('11288','2013-06-29','16:50:00',4.27),('11288','2013-06-29','16:55:00',2.29),('11288','2013-06-29','17:00:00',2.3),('11288','2013-06-29','17:05:00',3.13),('11288','2013-06-29','17:10:00',2.11),('11288','2013-06-29','17:15:00',2.01),('11288','2013-06-29','17:20:00',2.57),('11288','2013-06-29','17:25:00',3.12),('11288','2013-06-29','17:30:00',4.32),('11288','2013-06-29','17:35:00',3.21),('11288','2013-06-29','17:40:00',2.2),('11288','2013-06-29','17:45:00',3.2),('11288','2013-06-29','17:50:00',3.34),('11288','2013-06-29','17:55:00',3.43),('11288','2013-06-29','18:00:00',3.21),('11288','2013-06-29','18:05:00',3.05),('11288','2013-06-29','18:15:00',1.51),('11288','2013-06-29','18:20:00',2.51),('11288','2013-06-29','18:25:00',2.01),('11288','2013-06-29','18:35:00',2.13),('11288','2013-06-29','18:40:00',2.26),('11288','2013-06-29','18:45:00',1.17),('11288','2013-06-29','19:05:00',1.6),('11288','2013-06-29','19:10:00',1.58),('11288','2013-06-29','19:15:00',1),('11288','2013-06-28','07:10:00',1.09),('11288','2013-06-28','07:25:00',1.32),('11288','2013-06-28','07:30:00',1.44),('11288','2013-06-28','07:35:00',1.55),('11288','2013-06-28','07:40:00',1.53),('11288','2013-06-28','07:45:00',1.69),('11288','2013-06-28','07:50:00',1.84),('11288','2013-06-28','07:55:00',2.06),('11288','2013-06-28','08:00:00',2.11),('11288','2013-06-28','08:05:00',2.12),('11288','2013-06-28','08:10:00',2.18),('11288','2013-06-28','08:15:00',2.47),('11288','2013-06-28','08:20:00',2.48),('11288','2013-06-28','08:25:00',2.66),('11288','2013-06-28','08:30:00',2.89),('11288','2013-06-28','08:35:00',3.1),('11288','2013-06-28','08:40:00',3.22),('11288','2013-06-28','08:45:00',3.26),('11288','2013-06-28','08:50:00',3.44),('11288','2013-06-28','08:55:00',3.84),('11288','2013-06-28','09:00:00',3.91),('11288','2013-06-28','09:05:00',4.06),('11288','2013-06-28','09:10:00',4.5),('11288','2013-06-28','09:15:00',3.67),('11288','2013-06-28','09:20:00',1.33),('11288','2013-06-28','09:25:00',3.3),('11288','2013-06-28','09:30:00',4.91),('11288','2013-06-28','09:35:00',5.01),('11288','2013-06-28','09:40:00',5.31),('11288','2013-06-28','09:45:00',5.33),('11288','2013-06-28','09:50:00',4.92),('11288','2013-06-28','09:55:00',3.73),('11288','2013-06-28','10:00:00',2.28),('11288','2013-06-28','10:05:00',6.06),('11288','2013-06-28','10:10:00',6.11),('11288','2013-06-28','10:15:00',5.1),('11288','2013-06-28','10:20:00',2.33),('11288','2013-06-28','10:25:00',2.4),('11288','2013-06-28','10:30:00',7.3),('11288','2013-06-28','10:35:00',7.05),('11288','2013-06-28','10:40:00',5.4),('11288','2013-06-28','10:45:00',5.13),('11288','2013-06-28','10:50:00',3.99),('11288','2013-06-28','10:55:00',3.35),('11288','2013-06-28','11:00:00',4.15),('11288','2013-06-28','11:05:00',4.02),('11288','2013-06-28','11:10:00',3.37),('11288','2013-06-28','11:15:00',3.01),('11288','2013-06-28','11:20:00',3.13),('11288','2013-06-28','11:25:00',5.86),('11288','2013-06-28','11:30:00',6.94),('11288','2013-06-28','11:35:00',6.51),('11288','2013-06-28','11:40:00',7.79),('11288','2013-06-28','11:45:00',5.82),('11288','2013-06-28','11:50:00',5.83),('11288','2013-06-28','11:55:00',6.59),('11288','2013-06-28','12:00:00',4.73),('11288','2013-06-28','12:05:00',6.64),('11288','2013-06-28','12:10:00',8.34),('11288','2013-06-28','12:15:00',7.74),('11288','2013-06-28','12:20:00',7.4),('11288','2013-06-28','12:25:00',7.51),('11288','2013-06-28','12:30:00',7.68),('11288','2013-06-28','12:35:00',5.33),('11288','2013-06-28','12:40:00',5.62),('11288','2013-06-28','12:45:00',7.76),('11288','2013-06-28','12:50:00',7.69),('11288','2013-06-28','12:55:00',7.44),('11288','2013-06-28','13:00:00',7.59),('11288','2013-06-28','13:05:00',7.76),('11288','2013-06-28','13:10:00',7.13),('11288','2013-06-28','13:15:00',6.4),('11288','2013-06-28','13:20:00',7.23),('11288','2013-06-28','13:25:00',7.51),('11288','2013-06-28','13:30:00',7.5),('11288','2013-06-28','13:35:00',7.48),('11288','2013-06-28','13:40:00',5.76),('11288','2013-06-28','13:45:00',6.95),('11288','2013-06-28','13:50:00',5.98),('11288','2013-06-28','13:55:00',7.51),('11288','2013-06-28','14:00:00',6.61),('11288','2013-06-28','14:05:00',7.22),('11288','2013-06-28','14:10:00',5.58),('11288','2013-06-28','14:15:00',7.14),('11288','2013-06-28','14:20:00',7.47),('11288','2013-06-28','14:25:00',3.27),('11288','2013-06-28','14:30:00',7.67),('11288','2013-06-28','14:35:00',6.64),('11288','2013-06-28','14:40:00',6.26),('11288','2013-06-28','14:45:00',7.77),('11288','2013-06-28','14:50:00',7.3),('11288','2013-06-28','14:55:00',6.91),('11288','2013-06-28','15:00:00',6.63),('11288','2013-06-28','15:05:00',6.96),('11288','2013-06-28','15:10:00',6.96),('11288','2013-06-28','15:15:00',7.09),('11288','2013-06-28','15:20:00',7.19),('11288','2013-06-28','15:25:00',6.78),('11288','2013-06-28','15:30:00',6.32),('11288','2013-06-28','15:35:00',6.04),('11288','2013-06-28','15:40:00',2.97),('11288','2013-06-28','15:45:00',6.74),('11288','2013-06-28','15:50:00',4.89),('11288','2013-06-28','15:55:00',6.74),('11288','2013-06-28','16:00:00',5.95),('11288','2013-06-28','16:05:00',4.76),('11288','2013-06-28','16:10:00',3.19),('11288','2013-06-28','16:15:00',5.41),('11288','2013-06-28','16:20:00',5.18),('11288','2013-06-28','16:25:00',4.33),('11288','2013-06-28','16:30:00',5.16),('11288','2013-06-28','16:35:00',1.68),('11288','2013-06-28','16:40:00',3.22),('11288','2013-06-28','16:45:00',3.85),('11288','2013-06-28','16:50:00',5.11),('11288','2013-06-28','16:55:00',4.82),('11288','2013-06-28','17:00:00',4.74),('11288','2013-06-28','17:05:00',4.15),('11288','2013-06-28','17:10:00',4.47),('11288','2013-06-28','17:15:00',4.34),('11288','2013-06-28','17:20:00',4.18),('11288','2013-06-28','17:25:00',4.19),('11288','2013-06-28','17:30:00',4.02),('11288','2013-06-28','17:35:00',3.89),('11288','2013-06-28','17:40:00',3.76),('11288','2013-06-28','17:45:00',3.67),('11288','2013-06-28','17:50:00',3.5),('11288','2013-06-28','17:55:00',3.42),('11288','2013-06-28','18:00:00',3.28),('11288','2013-06-28','18:05:00',3.1),('11288','2013-06-28','18:10:00',2.96),('11288','2013-06-28','18:15:00',2.87),('11288','2013-06-28','18:20:00',2.77),('11288','2013-06-28','18:25:00',2.63),('11288','2013-06-28','18:30:00',1.8),('11288','2013-06-28','18:35:00',1.54),('11288','2013-06-28','18:40:00',1.75),('11288','2013-06-28','18:45:00',1.49),('11288','2013-06-28','18:50:00',1.86),('11288','2013-06-28','18:55:00',1.42),('11288','2013-06-28','19:00:00',1.34),('11288','2013-06-28','19:05:00',1.29),('11288','2013-06-28','19:10:00',1.22),('11288','2013-06-28','19:15:00',1.18),('11288','2013-06-28','19:20:00',1.09),('11288','2013-06-28','19:25:00',1.05),('11288','2013-06-27','07:25:00',1.17),('11288','2013-06-27','07:30:00',1.35),('11288','2013-06-27','07:35:00',1.42),('11288','2013-06-27','07:40:00',1.52),('11288','2013-06-27','07:45:00',1.58),('11288','2013-06-27','07:50:00',1.72),('11288','2013-06-27','07:55:00',2.03),('11288','2013-06-27','08:00:00',2.11),('11288','2013-06-27','08:05:00',2.34),('11288','2013-06-27','08:10:00',2.4),('11288','2013-06-27','08:15:00',2.44),('11288','2013-06-27','08:20:00',2.58),('11288','2013-06-27','08:25:00',2.85),('11288','2013-06-27','08:30:00',2.92),('11288','2013-06-27','08:35:00',3.04),('11288','2013-06-27','08:40:00',3.25),('11288','2013-06-27','08:45:00',3.42),('11288','2013-06-27','08:50:00',3.6),('11288','2013-06-27','08:55:00',3.86),('11288','2013-06-27','09:00:00',3.87),('11288','2013-06-27','09:05:00',3.98),('11288','2013-06-27','09:10:00',4.14),('11288','2013-06-27','09:15:00',4.22),('11288','2013-06-27','09:20:00',4.34),('11288','2013-06-27','09:25:00',4.5),('11288','2013-06-27','09:30:00',4.55),('11288','2013-06-27','09:35:00',4.62),('11288','2013-06-27','09:40:00',4.9),('11288','2013-06-27','09:45:00',4.99),('11288','2013-06-27','09:50:00',5.27),('11288','2013-06-27','09:55:00',5.49),('11288','2013-06-27','10:00:00',4.83),('11288','2013-06-27','10:05:00',4.68),('11288','2013-06-27','10:10:00',4.46),('11288','2013-06-27','10:15:00',2.87),('11288','2013-06-27','10:20:00',6.02),('11288','2013-06-27','10:25:00',6.09),('11288','2013-06-27','10:30:00',6.22),('11288','2013-06-27','10:35:00',5.54),('11288','2013-06-27','10:40:00',6.93),('11288','2013-06-27','10:45:00',6.94),('11288','2013-06-27','10:50:00',6.66),('11288','2013-06-27','10:55:00',6.46),('11288','2013-06-27','11:00:00',6.84),('11288','2013-06-27','11:05:00',6.94),('11288','2013-06-27','11:10:00',6.97),('11288','2013-06-27','11:15:00',6.95),('11288','2013-06-27','11:20:00',6.93),('11288','2013-06-27','11:25:00',7.18),('11288','2013-06-27','11:30:00',6.61),('11288','2013-06-27','11:35:00',6.11),('11288','2013-06-27','11:40:00',7.55),('11288','2013-06-27','11:45:00',7.51),('11288','2013-06-27','11:50:00',4.44),('11288','2013-06-27','11:55:00',2.22),('11288','2013-06-27','12:00:00',2.36),('11288','2013-06-27','12:05:00',2.17),('11288','2013-06-27','12:10:00',2.14),('11288','2013-06-27','12:15:00',1.88),('11288','2013-06-27','12:20:00',2.05),('11288','2013-06-27','12:25:00',3.16),('11288','2013-06-27','12:30:00',3.67),('11288','2013-06-27','12:35:00',6.09),('11288','2013-06-27','12:40:00',2.97),('11288','2013-06-27','12:45:00',3.65),('11288','2013-06-27','12:50:00',2.79),('11288','2013-06-27','12:55:00',2.09),('11288','2013-06-27','13:00:00',1.76),('11288','2013-06-27','13:05:00',2.01),('11288','2013-06-27','13:10:00',2.35),('11288','2013-06-27','13:15:00',2.53),('11288','2013-06-27','13:20:00',2.55),('11288','2013-06-27','13:25:00',2.7),('11288','2013-06-27','13:30:00',2.46),('11288','2013-06-27','13:35:00',2.34),('11288','2013-06-27','13:40:00',2.27),('11288','2013-06-27','13:45:00',2.42),('11288','2013-06-27','13:50:00',2.7),('11288','2013-06-27','13:55:00',2.37),('11288','2013-06-27','14:00:00',2.44),('11288','2013-06-27','14:05:00',2.46),('11288','2013-06-27','14:10:00',3.38),('11288','2013-06-27','14:15:00',4.1),('11288','2013-06-27','14:20:00',7.19),('11288','2013-06-27','14:25:00',5.04),('11288','2013-06-27','14:30:00',3.44),('11288','2013-06-27','14:35:00',3.57),('11288','2013-06-27','14:40:00',7.05),('11288','2013-06-27','14:45:00',5.73),('11288','2013-06-27','14:50:00',6.88),('11288','2013-06-27','14:55:00',6.82),('11288','2013-06-27','15:00:00',6.62),('11288','2013-06-27','15:05:00',6.54),('11288','2013-06-27','15:10:00',6.51),('11288','2013-06-27','15:15:00',6.44),('11288','2013-06-27','15:20:00',6.41),('11288','2013-06-27','15:25:00',6.4),('11288','2013-06-27','15:30:00',6.33),('11288','2013-06-27','15:35:00',6.26),('11288','2013-06-27','15:40:00',6.16),('11288','2013-06-27','15:45:00',6.08),('11288','2013-06-27','15:50:00',6.08),('11288','2013-06-27','15:55:00',5.99),('11288','2013-06-27','16:00:00',5.77),('11288','2013-06-27','16:05:00',5.63),('11288','2013-06-27','16:10:00',5.61),('11288','2013-06-27','16:15:00',5.58),('11288','2013-06-27','16:20:00',5.49),('11288','2013-06-27','16:25:00',5.4),('11288','2013-06-27','16:30:00',5.3),('11288','2013-06-27','16:35:00',4.92),('11288','2013-06-27','16:40:00',4.96),('11288','2013-06-27','16:45:00',4.95),('11288','2013-06-27','16:50:00',4.75),('11288','2013-06-27','16:55:00',4.69),('11288','2013-06-27','17:00:00',4.57),('11288','2013-06-27','17:05:00',4.39),('11288','2013-06-27','17:10:00',4.17),('11288','2013-06-27','17:15:00',4.07),('11288','2013-06-27','17:20:00',4.2),('11288','2013-06-27','17:25:00',4.05),('11288','2013-06-27','17:30:00',3.95),('11288','2013-06-27','17:35:00',3.83),('11288','2013-06-27','17:40:00',3.02),('11288','2013-06-27','17:45:00',1.71),('11288','2013-06-27','17:50:00',3),('11288','2013-06-27','17:55:00',2.86),('11288','2013-06-27','18:00:00',3.04),('11288','2013-06-27','18:05:00',2.93),('11288','2013-06-27','18:10:00',2.78),('11288','2013-06-27','18:15:00',2.59),('11288','2013-06-27','18:20:00',2.49),('11288','2013-06-27','18:25:00',2.5),('11288','2013-06-27','18:30:00',2.35),('11288','2013-06-27','18:35:00',2.17),('11288','2013-06-27','18:40:00',1.91),('11288','2013-06-27','18:45:00',1.79),('11288','2013-06-27','18:50:00',1.72),('11288','2013-06-27','18:55:00',1.63),('11288','2013-06-27','19:00:00',1.5),('11288','2013-06-27','19:05:00',1.37),('11288','2013-06-27','19:10:00',1.25),('11288','2013-06-27','19:15:00',1.12),('11288','2013-06-27','19:20:00',1.01),('11288','2013-06-26','07:15:00',1.06),('11288','2013-06-26','07:20:00',1.16),('11288','2013-06-26','07:25:00',1.22),('11288','2013-06-26','07:30:00',1.34),('11288','2013-06-26','07:35:00',1.48),('11288','2013-06-26','07:40:00',1.54),('11288','2013-06-26','07:45:00',1.6),('11288','2013-06-26','07:50:00',1.88),('11288','2013-06-26','07:55:00',1.84),('11288','2013-06-26','08:00:00',2.07),('11288','2013-06-26','08:05:00',2.32),('11288','2013-06-26','08:10:00',2.3),('11288','2013-06-26','08:15:00',2.47),('11288','2013-06-26','08:20:00',2.7),('11288','2013-06-26','08:25:00',2.83),('11288','2013-06-26','08:30:00',2.93),('11288','2013-06-26','08:35:00',3.16),('11288','2013-06-26','08:40:00',3.24),('11288','2013-06-26','08:45:00',3.26),('11288','2013-06-26','08:50:00',3.59),('11288','2013-06-26','08:55:00',3.7),('11288','2013-06-26','09:00:00',3.82),('11288','2013-06-26','09:05:00',3.97),('11288','2013-06-26','09:10:00',3.94),('11288','2013-06-26','09:15:00',3.94),('11288','2013-06-26','09:20:00',4.33),('11288','2013-06-26','09:25:00',4.32),('11288','2013-06-26','09:30:00',4.08),('11288','2013-06-26','09:35:00',4.51),('11288','2013-06-26','09:40:00',4.69),('11288','2013-06-26','09:45:00',4.64),('11288','2013-06-26','09:50:00',5),('11288','2013-06-26','09:55:00',5.03),('11288','2013-06-26','10:00:00',4.96),('11288','2013-06-26','10:05:00',5.34),('11288','2013-06-26','10:10:00',5.53),('11288','2013-06-26','10:15:00',5.69),('11288','2013-06-26','10:20:00',5.82),('11288','2013-06-26','10:25:00',5.85),('11288','2013-06-26','10:30:00',5.87),('11288','2013-06-26','10:35:00',5.98),('11288','2013-06-26','10:40:00',6.1),('11288','2013-06-26','10:45:00',6.16),('11288','2013-06-26','10:50:00',6.24),('11288','2013-06-26','10:55:00',6.31),('11288','2013-06-26','11:00:00',6.36),('11288','2013-06-26','11:05:00',6.44),('11288','2013-06-26','11:10:00',6.51),('11288','2013-06-26','11:15:00',6.55),('11288','2013-06-26','11:20:00',6.62),('11288','2013-06-26','11:25:00',6.62),('11288','2013-06-26','11:30:00',6.62),('11288','2013-06-26','11:35:00',6.7),('11288','2013-06-26','11:40:00',6.71),('11288','2013-06-26','11:45:00',6.74),('11288','2013-06-26','11:50:00',6.75),('11288','2013-06-26','11:55:00',6.89),('11288','2013-06-26','12:00:00',6.99),('11288','2013-06-26','12:05:00',7.04),('11288','2013-06-26','12:10:00',7),('11288','2013-06-26','12:15:00',6.96),('11288','2013-06-26','12:20:00',6.93),('11288','2013-06-26','12:25:00',6.91),('11288','2013-06-26','12:30:00',7.02),('11288','2013-06-26','12:35:00',7),('11288','2013-06-26','12:40:00',5.42),('11288','2013-06-26','12:45:00',3.39),('11288','2013-06-26','12:50:00',3.27),('11288','2013-06-26','12:55:00',2.28),('11288','2013-06-26','13:00:00',5.31),('11288','2013-06-26','13:05:00',4.12),('11288','2013-06-26','13:10:00',8.06),('11288','2013-06-26','13:15:00',7.69),('11288','2013-06-26','13:20:00',2.91),('11288','2013-06-26','13:25:00',4.68),('11288','2013-06-26','13:30:00',2.6),('11288','2013-06-26','13:35:00',2.56),('11288','2013-06-26','13:40:00',2.92),('11288','2013-06-26','13:45:00',4.17),('11288','2013-06-26','13:50:00',5.26),('11288','2013-06-26','13:55:00',4.05),('11288','2013-06-26','14:00:00',6.74),('11288','2013-06-26','14:05:00',7.78),('11288','2013-06-26','14:10:00',6.82),('11288','2013-06-26','14:15:00',3.01),('11288','2013-06-26','14:20:00',7.52),('11288','2013-06-26','14:25:00',6.64),('11288','2013-06-26','14:30:00',4.69),('11288','2013-06-26','14:35:00',5.48),('11288','2013-06-26','14:40:00',7.69),('11288','2013-06-26','14:45:00',5.38),('11288','2013-06-26','14:50:00',7.3),('11288','2013-06-26','14:55:00',7.12),('11288','2013-06-26','15:00:00',6.74),('11288','2013-06-26','15:05:00',6.67),('11288','2013-06-26','15:10:00',6.53),('11288','2013-06-26','15:15:00',6.47),('11288','2013-06-26','15:20:00',6.48),('11288','2013-06-26','15:25:00',6.38),('11288','2013-06-26','15:30:00',6.31),('11288','2013-06-26','15:35:00',6.33),('11288','2013-06-26','15:40:00',6.24),('11288','2013-06-26','15:45:00',6.13),('11288','2013-06-26','15:50:00',6.18),('11288','2013-06-26','15:55:00',6.01),('11288','2013-06-26','16:00:00',5.93),('11288','2013-06-26','16:05:00',5.82),('11288','2013-06-26','16:10:00',5.75),('11288','2013-06-26','16:15:00',5.63),('11288','2013-06-26','16:20:00',5.52),('11288','2013-06-26','16:25:00',5.43),('11288','2013-06-26','16:30:00',5.29),('11288','2013-06-26','16:35:00',5.12),('11288','2013-06-26','16:40:00',4.96),('11288','2013-06-26','16:45:00',4.74),('11288','2013-06-26','16:50:00',4.54),('11288','2013-06-26','16:55:00',4.72),('11288','2013-06-26','17:00:00',4.64),('11288','2013-06-26','17:05:00',4.49),('11288','2013-06-26','17:10:00',4.38),('11288','2013-06-26','17:15:00',4.24),('11288','2013-06-26','17:20:00',4.12),('11288','2013-06-26','17:25:00',4),('11288','2013-06-26','17:30:00',3.88),('11288','2013-06-26','17:35:00',3.8),('11288','2013-06-26','17:40:00',3.71),('11288','2013-06-26','17:45:00',3.5),('11288','2013-06-26','17:50:00',3.35),('11288','2013-06-26','17:55:00',3.22),('11288','2013-06-26','18:00:00',3.09),('11288','2013-06-26','18:05:00',3.1),('11288','2013-06-26','18:10:00',3.43),('11288','2013-06-26','18:15:00',2.51),('11288','2013-06-26','18:20:00',1.44),('11288','2013-06-26','18:25:00',1.38),('11288','2013-06-26','18:30:00',1.11),('11288','2013-06-26','19:00:00',1.13),('11288','2013-06-26','19:15:00',1.12),('11288','2013-06-26','19:20:00',1.14),('11288','2013-06-26','19:25:00',1.05),('11288','2013-06-25','07:10:00',1.05),('11288','2013-06-25','07:15:00',1.16),('11288','2013-06-25','07:20:00',1.26),('11288','2013-06-25','07:25:00',1.36),('11288','2013-06-25','07:30:00',1.5),('11288','2013-06-25','07:35:00',1.68),('11288','2013-06-25','07:40:00',1.8),('11288','2013-06-25','07:45:00',1.9),('11288','2013-06-25','07:50:00',1.71),('11288','2013-06-25','07:55:00',1.82),('11288','2013-06-25','08:00:00',2.48),('11288','2013-06-25','08:05:00',2.23),('11288','2013-06-25','08:10:00',1.55),('11288','2013-06-25','08:15:00',1.24),('11288','2013-06-25','08:20:00',2.01),('11288','2013-06-25','08:25:00',2.87),('11288','2013-06-25','08:30:00',2.94),('11288','2013-06-25','08:35:00',3.22),('11288','2013-06-25','08:40:00',3.36),('11288','2013-06-25','08:45:00',3.39),('11288','2013-06-25','08:50:00',3.67),('11288','2013-06-25','08:55:00',3.84),('11288','2013-06-25','09:00:00',3.92),('11288','2013-06-25','09:05:00',4.02),('11288','2013-06-25','09:10:00',3.99),('11288','2013-06-25','09:15:00',3.95),('11288','2013-06-25','09:20:00',4.28),('11288','2013-06-25','09:25:00',4.43),('11288','2013-06-25','09:30:00',4.25),('11288','2013-06-25','09:35:00',4.91),('11288','2013-06-25','09:40:00',5.15),('11288','2013-06-25','09:45:00',5.31),('11288','2013-06-25','09:50:00',5.55),('11288','2013-06-25','09:55:00',5.85),('11288','2013-06-25','10:00:00',5.99),('11288','2013-06-25','10:05:00',6.19),('11288','2013-06-25','10:10:00',6.4),('11288','2013-06-25','10:15:00',5.97),('11288','2013-06-25','10:20:00',1.62),('11288','2013-06-25','10:25:00',1.82),('11288','2013-06-25','10:30:00',7.1),('11288','2013-06-25','10:35:00',6.86),('11288','2013-06-25','10:40:00',6.45),('11288','2013-06-25','10:45:00',2.43),('11288','2013-06-25','10:50:00',2.19),('11288','2013-06-25','10:55:00',4.52),('11288','2013-06-25','11:00:00',6.97),('11288','2013-06-25','11:05:00',1.98),('11288','2013-06-25','11:10:00',3.61),('11288','2013-06-25','11:15:00',7),('11288','2013-06-25','11:20:00',1.83),('11288','2013-06-25','11:25:00',1.94),('11288','2013-06-25','11:30:00',1.98),('11288','2013-06-25','11:35:00',5.92),('11288','2013-06-25','11:40:00',8.3),('11288','2013-06-25','11:45:00',7.72),('11288','2013-06-25','11:50:00',7.93),('11288','2013-06-25','11:55:00',2.84),('11288','2013-06-25','12:00:00',1.91),('11288','2013-06-25','12:05:00',1.81),('11288','2013-06-25','12:10:00',1.96),('11288','2013-06-25','12:15:00',1.92),('11288','2013-06-25','12:20:00',2.65),('11288','2013-06-25','12:25:00',2.28),('11288','2013-06-25','12:30:00',2.52),('11288','2013-06-25','12:35:00',7.13),('11288','2013-06-25','12:40:00',6.33),('11288','2013-06-25','12:45:00',5.76),('11288','2013-06-25','12:50:00',4.22),('11288','2013-06-25','12:55:00',4.58),('11288','2013-06-25','13:00:00',7.27),('11288','2013-06-25','13:05:00',7.8),('11288','2013-06-25','13:10:00',3.77),('11288','2013-06-25','13:15:00',6.93),('11288','2013-06-25','13:20:00',5.98),('11288','2013-06-25','13:25:00',6.94),('11288','2013-06-25','13:30:00',5.34),('11288','2013-06-25','13:35:00',6.11),('11288','2013-06-25','13:40:00',7.89),('11288','2013-06-25','13:45:00',7.5),('11288','2013-06-25','13:50:00',6.03),('11288','2013-06-25','13:55:00',4.49),('11288','2013-06-25','14:00:00',5.95),('11288','2013-06-25','14:05:00',7.53),('11288','2013-06-25','14:10:00',6.44),('11288','2013-06-25','14:15:00',7.37),('11288','2013-06-25','14:20:00',7.17),('11288','2013-06-25','14:25:00',7.07),('11288','2013-06-25','14:30:00',6.93),('11288','2013-06-25','14:35:00',6.94),('11288','2013-06-25','14:40:00',6.75),('11288','2013-06-25','14:45:00',6.93),('11288','2013-06-25','14:50:00',6.83),('11288','2013-06-25','14:55:00',6.77),('11288','2013-06-25','15:00:00',6.66),('11288','2013-06-25','15:05:00',6.68),('11288','2013-06-25','15:10:00',6.64),('11288','2013-06-25','15:15:00',6.55),('11288','2013-06-25','15:20:00',6.47),('11288','2013-06-25','15:25:00',6.38),('11288','2013-06-25','15:30:00',6.36),('11288','2013-06-25','15:35:00',6.27),('11288','2013-06-25','15:40:00',6.21),('11288','2013-06-25','15:45:00',6.12),('11288','2013-06-25','15:50:00',6.02),('11288','2013-06-25','15:55:00',5.91),('11288','2013-06-25','16:00:00',5.87),('11288','2013-06-25','16:05:00',5.8),('11288','2013-06-25','16:10:00',5.72),('11288','2013-06-25','16:15:00',5.62),('11288','2013-06-25','16:20:00',5.46),('11288','2013-06-25','16:25:00',5.36),('11288','2013-06-25','16:30:00',5.31),('11288','2013-06-25','16:35:00',5.15),('11288','2013-06-25','16:40:00',5.01),('11288','2013-06-25','16:45:00',4.91),('11288','2013-06-25','16:50:00',4.81),('11288','2013-06-25','16:55:00',4.7),('11288','2013-06-25','17:00:00',4.58),('11288','2013-06-25','17:05:00',4.42),('11288','2013-06-25','17:10:00',4.31),('11288','2013-06-25','17:15:00',4.21),('11288','2013-06-25','17:20:00',4.11),('11288','2013-06-25','17:25:00',3.98),('11288','2013-06-25','17:30:00',3.85),('11288','2013-06-25','17:35:00',3.77),('11288','2013-06-25','17:40:00',3.68),('11288','2013-06-25','17:45:00',3.49),('11288','2013-06-25','17:50:00',3.33),('11288','2013-06-25','17:55:00',3.23),('11288','2013-06-25','18:00:00',3.11),('11288','2013-06-25','18:05:00',2.96),('11288','2013-06-25','18:10:00',2.81),('11288','2013-06-25','18:15:00',2.65),('11288','2013-06-25','18:20:00',2.57),('11288','2013-06-25','18:25:00',2.4),('11288','2013-06-25','18:30:00',2.28),('11288','2013-06-25','18:35:00',2.18),('11288','2013-06-25','18:40:00',2.04),('11288','2013-06-25','18:45:00',1.91),('11288','2013-06-25','18:50:00',1.76),('11288','2013-06-25','18:55:00',1.64),('11288','2013-06-25','19:00:00',1.54),('11288','2013-06-25','19:05:00',1.42),('11288','2013-06-25','19:10:00',1.31),('11288','2013-06-25','19:15:00',1.16),('11288','2013-06-25','19:20:00',1.05),('11288','2013-06-24','07:10:00',1.03),('11288','2013-06-24','07:20:00',1.01),('11288','2013-06-24','07:25:00',1.36),('11288','2013-06-24','07:30:00',1.02),('11288','2013-06-24','07:50:00',1.58),('11288','2013-06-24','08:20:00',1.04),('11288','2013-06-24','08:25:00',1.53),('11288','2013-06-24','08:35:00',1.23),('11288','2013-06-24','08:40:00',3.54),('11288','2013-06-24','08:45:00',3.73),('11288','2013-06-24','08:50:00',3.94),('11288','2013-06-24','08:55:00',4.22),('11288','2013-06-24','09:00:00',4.59),('11288','2013-06-24','09:05:00',2.95),('11288','2013-06-24','09:10:00',3.16),('11288','2013-06-24','09:15:00',4.21),('11288','2013-06-24','09:20:00',4.44),('11288','2013-06-24','09:25:00',5.77),('11288','2013-06-24','09:30:00',4.89),('11288','2013-06-24','09:35:00',4.65),('11288','2013-06-24','09:40:00',5.47),('11288','2013-06-24','09:45:00',5.87),('11288','2013-06-24','09:50:00',5.73),('11288','2013-06-24','09:55:00',5.39),('11288','2013-06-24','10:00:00',5.65),('11288','2013-06-24','10:05:00',5.84),('11288','2013-06-24','10:10:00',5.89),('11288','2013-06-24','10:15:00',5.23),('11288','2013-06-24','10:20:00',5.6),('11288','2013-06-24','10:25:00',7.11),('11288','2013-06-24','10:30:00',6.3),('11288','2013-06-24','10:35:00',7.02),('11288','2013-06-24','10:40:00',2.99),('11288','2013-06-24','10:45:00',5),('11288','2013-06-24','10:50:00',6.29),('11288','2013-06-24','10:55:00',5.46),('11288','2013-06-24','11:00:00',6.5),('11288','2013-06-24','11:05:00',5.41),('11288','2013-06-24','11:10:00',2.09),('11288','2013-06-24','11:15:00',8.04),('11288','2013-06-24','11:20:00',5.46),('11288','2013-06-24','11:25:00',3.35),('11288','2013-06-24','11:30:00',4.94),('11288','2013-06-24','11:35:00',2.49),('11288','2013-06-24','11:40:00',2.24),('11288','2013-06-24','11:45:00',3.82),('11288','2013-06-24','11:50:00',3.77),('11288','2013-06-24','11:55:00',6.62),('11288','2013-06-24','12:00:00',6.07),('11288','2013-06-24','12:05:00',5.72),('11288','2013-06-24','12:10:00',7.87),('11288','2013-06-24','12:15:00',3.61),('11288','2013-06-24','12:20:00',8.3),('11288','2013-06-24','12:25:00',7.58),('11288','2013-06-24','12:30:00',5.44),('11288','2013-06-24','12:35:00',8.35),('11288','2013-06-24','12:40:00',4.99),('11288','2013-06-24','12:45:00',7.28),('11288','2013-06-24','12:50:00',7.58),('11288','2013-06-24','12:55:00',6.67),('11288','2013-06-24','13:00:00',6.54),('11288','2013-06-24','13:05:00',8.32),('11288','2013-06-24','13:10:00',6.92),('11288','2013-06-24','13:15:00',5.12),('11288','2013-06-24','13:20:00',3.67),('11288','2013-06-24','13:25:00',7.67),('11288','2013-06-24','13:30:00',7.77),('11288','2013-06-24','13:35:00',7.14),('11288','2013-06-24','13:40:00',7.5),('11288','2013-06-24','13:45:00',7.12),('11288','2013-06-24','13:50:00',7.64),('11288','2013-06-24','13:55:00',7.29),('11288','2013-06-24','14:00:00',6.92),('11288','2013-06-24','14:05:00',7.44),('11288','2013-06-24','14:10:00',7.41),('11288','2013-06-24','14:15:00',7.39),('11288','2013-06-24','14:20:00',7.32),('11288','2013-06-24','14:25:00',7.44),('11288','2013-06-24','14:30:00',7.26),('11288','2013-06-24','14:35:00',7.38),('11288','2013-06-24','14:40:00',7.29),('11288','2013-06-24','14:45:00',6.7),('11288','2013-06-24','14:50:00',6.54),('11288','2013-06-24','14:55:00',4.19),('11288','2013-06-24','15:00:00',6.38),('11288','2013-06-24','15:05:00',2.8),('11288','2013-06-24','15:10:00',6.52),('11288','2013-06-24','15:15:00',6.34),('11288','2013-06-24','15:20:00',6.14),('11288','2013-06-24','15:25:00',5.63),('11288','2013-06-24','15:30:00',5.25),('11288','2013-06-24','15:35:00',2.97),('11288','2013-06-24','15:40:00',4.77),('11288','2013-06-24','15:45:00',4.55),('11288','2013-06-24','15:50:00',6.97),('11288','2013-06-24','15:55:00',6.52),('11288','2013-06-24','16:00:00',6.49),('11288','2013-06-24','16:05:00',6.92),('11288','2013-06-24','16:10:00',5.93),('11288','2013-06-24','16:15:00',5.79),('11288','2013-06-24','16:20:00',3.57),('11288','2013-06-24','16:25:00',4.62),('11288','2013-06-24','16:30:00',5.52),('11288','2013-06-24','16:35:00',5.32),('11288','2013-06-24','16:40:00',3.64),('11288','2013-06-24','16:45:00',2.7),('11288','2013-06-24','16:50:00',3.34),('11288','2013-06-24','16:55:00',2.35),('11288','2013-06-24','17:00:00',2.48),('11288','2013-06-24','17:05:00',3.91),('11288','2013-06-24','17:10:00',3.23),('11288','2013-06-24','17:15:00',4.19),('11288','2013-06-24','17:20:00',3.78),('11288','2013-06-24','17:25:00',3.43),('11288','2013-06-24','17:30:00',2.13),('11288','2013-06-24','17:35:00',1.7),('11288','2013-06-24','17:40:00',1.53),('11288','2013-06-24','17:45:00',1.51),('11288','2013-06-24','17:50:00',2.27),('11288','2013-06-24','17:55:00',2.49),('11288','2013-06-24','18:00:00',3.42),('11288','2013-06-24','18:05:00',3.25),('11288','2013-06-24','18:10:00',2.72),('11288','2013-06-24','18:15:00',2.87),('11288','2013-06-24','18:20:00',2.45),('11288','2013-06-24','18:25:00',2.27),('11288','2013-06-24','18:30:00',1.98),('11288','2013-06-24','18:35:00',2.17),('11288','2013-06-24','18:40:00',1.69),('11288','2013-06-24','18:45:00',2.06),('11288','2013-06-24','18:50:00',1.81),('11288','2013-06-24','18:55:00',1.73),('11288','2013-06-24','19:00:00',1.68),('11288','2013-06-24','19:05:00',1.52),('11288','2013-06-24','19:10:00',1.5),('11288','2013-06-24','19:15:00',1.25),('11288','2013-06-24','19:20:00',1.1),('11288','2013-06-24','19:25:00',1.04),('11288','2013-06-23','08:35:00',1.2),('11288','2013-06-23','08:40:00',1.41),('11288','2013-06-23','08:45:00',1.96),('11288','2013-06-23','08:50:00',2.48),('11288','2013-06-23','08:55:00',2.05),('11288','2013-06-23','09:00:00',3.34),('11288','2013-06-23','09:05:00',2.61),('11288','2013-06-23','09:15:00',1.35),('11288','2013-06-23','09:20:00',2.97),('11288','2013-06-23','09:25:00',4.46),('11288','2013-06-23','09:30:00',4.68),('11288','2013-06-23','09:35:00',4.91),('11288','2013-06-23','09:40:00',5.91),('11288','2013-06-23','09:45:00',3.55),('11288','2013-06-23','09:50:00',1.75),('11288','2013-06-23','09:55:00',3.56),('11288','2013-06-23','10:00:00',3.96),('11288','2013-06-23','10:05:00',3.69),('11288','2013-06-23','10:10:00',3.94),('11288','2013-06-23','10:15:00',4.15),('11288','2013-06-23','10:20:00',3.29),('11288','2013-06-23','10:25:00',3.27),('11288','2013-06-23','10:30:00',3.61),('11288','2013-06-23','10:35:00',4.37),('11288','2013-06-23','10:40:00',5.45),('11288','2013-06-23','10:45:00',6.24),('11288','2013-06-23','10:50:00',6.22),('11288','2013-06-23','10:55:00',6.26),('11288','2013-06-23','11:00:00',6.29),('11288','2013-06-23','11:05:00',6.42),('11288','2013-06-23','11:10:00',6.4),('11288','2013-06-23','11:15:00',6.34),('11288','2013-06-23','11:20:00',6.6),('11288','2013-06-23','11:25:00',6.42),('11288','2013-06-23','11:30:00',5.74),('11288','2013-06-23','11:35:00',6.53),('11288','2013-06-23','11:40:00',6.54),('11288','2013-06-23','11:45:00',6.58),('11288','2013-06-23','11:50:00',6.56),('11288','2013-06-23','11:55:00',6.73),('11288','2013-06-23','12:00:00',6.9),('11288','2013-06-23','12:05:00',6.85),('11288','2013-06-23','12:10:00',6.94),('11288','2013-06-23','12:15:00',6.84),('11288','2013-06-23','12:20:00',6.91),('11288','2013-06-23','12:25:00',7.07),('11288','2013-06-23','12:30:00',7.02),('11288','2013-06-23','12:35:00',6.95),('11288','2013-06-23','12:40:00',7.03),('11288','2013-06-23','12:45:00',7.02),('11288','2013-06-23','12:50:00',7.04),('11288','2013-06-23','12:55:00',7.06),('11288','2013-06-23','13:00:00',7.09),('11288','2013-06-23','13:05:00',7.07),('11288','2013-06-23','13:10:00',7.1),('11288','2013-06-23','13:15:00',7.04),('11288','2013-06-23','13:20:00',7.06),('11288','2013-06-23','13:25:00',7.06),('11288','2013-06-23','13:30:00',7.06),('11288','2013-06-23','13:35:00',7.1),('11288','2013-06-23','13:40:00',7.1),('11288','2013-06-23','13:45:00',7.08),('11288','2013-06-23','13:50:00',7.09),('11288','2013-06-23','13:55:00',7.13),('11288','2013-06-23','14:00:00',7.04),('11288','2013-06-23','14:05:00',7.03),('11288','2013-06-23','14:10:00',7.01),('11288','2013-06-23','14:15:00',6.98),('11288','2013-06-23','14:20:00',6.95),('11288','2013-06-23','14:25:00',6.96),('11288','2013-06-23','14:30:00',6.89),('11288','2013-06-23','14:35:00',6.91),('11288','2013-06-23','14:40:00',6.84),('11288','2013-06-23','14:45:00',6.84),('11288','2013-06-23','14:50:00',6.79),('11288','2013-06-23','14:55:00',6.75),('11288','2013-06-23','15:00:00',6.72),('11288','2013-06-23','15:05:00',6.65),('11288','2013-06-23','15:10:00',6.62),('11288','2013-06-23','15:15:00',6.56),('11288','2013-06-23','15:20:00',6.5),('11288','2013-06-23','15:25:00',6.42),('11288','2013-06-23','15:30:00',6.35),('11288','2013-06-23','15:35:00',6.28),('11288','2013-06-23','15:40:00',6.2),('11288','2013-06-23','15:45:00',6.14),('11288','2013-06-23','15:50:00',6.09),('11288','2013-06-23','15:55:00',6),('11288','2013-06-23','16:00:00',5.9),('11288','2013-06-23','16:05:00',5.79),('11288','2013-06-23','16:10:00',5.68),('11288','2013-06-23','16:15:00',5.52),('11288','2013-06-23','16:20:00',5.43),('11288','2013-06-23','16:25:00',5.36),('11288','2013-06-23','16:30:00',5.25),('11288','2013-06-23','16:35:00',5.18),('11288','2013-06-23','16:40:00',4.92),('11288','2013-06-23','16:45:00',4.89),('11288','2013-06-23','16:50:00',4.76),('11288','2013-06-23','16:55:00',4.67),('11288','2013-06-23','17:00:00',4.57),('11288','2013-06-23','17:05:00',4.44),('11288','2013-06-23','17:10:00',4.34),('11288','2013-06-23','17:15:00',4.23),('11288','2013-06-23','17:20:00',4.09),('11288','2013-06-23','17:25:00',4.01),('11288','2013-06-23','17:30:00',3.88),('11288','2013-06-23','17:35:00',3.76),('11288','2013-06-23','17:40:00',3.73),('11288','2013-06-23','17:45:00',3.56),('11288','2013-06-23','17:50:00',3.42),('11288','2013-06-23','17:55:00',3.28),('11288','2013-06-23','18:00:00',3.14),('11288','2013-06-23','18:05:00',3.04),('11288','2013-06-23','18:10:00',2.86),('11288','2013-06-23','18:15:00',2.71),('11288','2013-06-23','18:20:00',2.63),('11288','2013-06-23','18:25:00',2.44),('11288','2013-06-23','18:30:00',2.32),('11288','2013-06-23','18:35:00',2.12),('11288','2013-06-23','18:40:00',2.11),('11288','2013-06-23','18:45:00',1.98),('11288','2013-06-23','18:50:00',1.86),('11288','2013-06-23','18:55:00',1.68),('11288','2013-06-23','19:00:00',1.35),('11288','2013-06-23','19:05:00',1.47),('11288','2013-06-23','19:10:00',1.31),('11288','2013-06-23','19:15:00',1.03),('11288','2013-06-22','07:10:00',1),('11288','2013-06-22','07:15:00',1.1),('11288','2013-06-22','07:20:00',1.18),('11288','2013-06-22','07:25:00',1.27),('11288','2013-06-22','07:30:00',1.37),('11288','2013-06-22','07:35:00',1.46),('11288','2013-06-22','07:40:00',1.52),('11288','2013-06-22','07:45:00',1.59),('11288','2013-06-22','07:50:00',1.78),('11288','2013-06-22','07:55:00',1.84),('11288','2013-06-22','08:00:00',2.12),('11288','2013-06-22','08:05:00',2.2),('11288','2013-06-22','08:10:00',2.3),('11288','2013-06-22','08:15:00',2.44),('11288','2013-06-22','08:20:00',2.64),('11288','2013-06-22','08:25:00',2.72),('11288','2013-06-22','08:30:00',2.86),('11288','2013-06-22','08:35:00',3.11),('11288','2013-06-22','08:40:00',3.11),('11288','2013-06-22','08:45:00',3.19),('11288','2013-06-22','08:50:00',3.52),('11288','2013-06-22','08:55:00',3.57),('11288','2013-06-22','09:00:00',3.73),('11288','2013-06-22','09:05:00',3.83),('11288','2013-06-22','09:10:00',3.79),('11288','2013-06-22','09:15:00',3.74),('11288','2013-06-22','09:20:00',4.2),('11288','2013-06-22','09:25:00',4.13),('11288','2013-06-22','09:30:00',4.03),('11288','2013-06-22','09:35:00',4.51),('11288','2013-06-22','09:40:00',4.51),('11288','2013-06-22','09:45:00',4.52),('11288','2013-06-22','09:50:00',4.92),('11288','2013-06-22','09:55:00',4.87),('11288','2013-06-22','10:00:00',4.86),('11288','2013-06-22','10:05:00',5.24),('11288','2013-06-22','10:10:00',5.32),('11288','2013-06-22','10:15:00',5.45),('11288','2013-06-22','10:20:00',5.64),('11288','2013-06-22','10:25:00',5.67),('11288','2013-06-22','10:30:00',5.68),('11288','2013-06-22','10:35:00',5.79),('11288','2013-06-22','10:40:00',5.91),('11288','2013-06-22','10:45:00',6.05),('11288','2013-06-22','10:50:00',6.17),('11288','2013-06-22','10:55:00',6.18),('11288','2013-06-22','11:00:00',6.22),('11288','2013-06-22','11:05:00',6.27),('11288','2013-06-22','11:10:00',6.34),('11288','2013-06-22','11:15:00',6.38),('11288','2013-06-22','11:20:00',6.43),('11288','2013-06-22','11:25:00',6.47),('11288','2013-06-22','11:30:00',6.56),('11288','2013-06-22','11:35:00',6.62),('11288','2013-06-22','11:40:00',6.64),('11288','2013-06-22','11:45:00',6.66),('11288','2013-06-22','11:50:00',6.65),('11288','2013-06-22','11:55:00',6.7),('11288','2013-06-22','12:00:00',6.76),('11288','2013-06-22','12:05:00',6.62),('11288','2013-06-22','12:10:00',6.6),('11288','2013-06-22','12:15:00',6.83),('11288','2013-06-22','12:20:00',6.73),('11288','2013-06-22','12:25:00',6.79),('11288','2013-06-22','12:30:00',6.82),('11288','2013-06-22','12:35:00',6.91),('11288','2013-06-22','12:40:00',6.92),('11288','2013-06-22','12:45:00',6.82),('11288','2013-06-22','12:50:00',6.74),('11288','2013-06-22','12:55:00',6.73),('11288','2013-06-22','13:00:00',6.63),('11288','2013-06-22','13:05:00',6.67),('11288','2013-06-22','13:10:00',6.62),('11288','2013-06-22','13:15:00',6.48),('11288','2013-06-22','13:20:00',6.33),('11288','2013-06-22','13:25:00',6.92),('11288','2013-06-22','13:30:00',7.16),('11288','2013-06-22','13:35:00',7.21),('11288','2013-06-22','13:40:00',6.43),('11288','2013-06-22','13:45:00',6.99),('11288','2013-06-22','13:50:00',6.98),('11288','2013-06-22','13:55:00',4.96),('11288','2013-06-22','14:00:00',5.01),('11288','2013-06-22','14:05:00',7.65),('11288','2013-06-22','14:10:00',7.29),('11288','2013-06-22','14:15:00',7.12),('11288','2013-06-22','14:20:00',6.09),('11288','2013-06-22','14:25:00',7.01),('11288','2013-06-22','14:30:00',4.98),('11288','2013-06-22','14:35:00',3.89),('11288','2013-06-22','14:40:00',3),('11288','2013-06-22','14:45:00',4.05),('11288','2013-06-22','14:50:00',6.67),('11288','2013-06-22','14:55:00',6.88),('11288','2013-06-22','15:00:00',6.75),('11288','2013-06-22','15:05:00',5.07),('11288','2013-06-22','15:10:00',6.84),('11288','2013-06-22','15:15:00',6.87),('11288','2013-06-22','15:20:00',6.13),('11288','2013-06-22','15:25:00',5.39),('11288','2013-06-22','15:30:00',4.08),('11288','2013-06-22','15:35:00',3.07),('11288','2013-06-22','15:40:00',3.76),('11288','2013-06-22','15:45:00',4.9),('11288','2013-06-22','15:50:00',4.34),('11288','2013-06-22','15:55:00',4.37),('11288','2013-06-22','16:00:00',3.17),('11288','2013-06-22','16:05:00',2.23),('11288','2013-06-22','16:10:00',2.36),('11288','2013-06-22','16:15:00',2.99),('11288','2013-06-22','16:20:00',3.26),('11288','2013-06-22','16:25:00',2.32),('11288','2013-06-22','16:30:00',1.89),('11288','2013-06-22','16:35:00',1.64),('11288','2013-06-22','16:40:00',1.51),('11288','2013-06-22','16:45:00',1.45),('11288','2013-06-22','16:50:00',1.61),('11288','2013-06-22','16:55:00',2.33),('11288','2013-06-22','17:00:00',2.78),('11288','2013-06-22','17:05:00',2.71),('11288','2013-06-22','17:10:00',3.82),('11288','2013-06-22','17:15:00',4.86),('11288','2013-06-22','17:20:00',4.61),('11288','2013-06-22','17:25:00',4.7),('11288','2013-06-22','17:30:00',3.57),('11288','2013-06-22','17:35:00',3.48),('11288','2013-06-22','17:40:00',3.85),('11288','2013-06-22','17:45:00',3.74),('11288','2013-06-22','17:50:00',3.37),('11288','2013-06-22','17:55:00',3.36),('11288','2013-06-22','18:00:00',3.05),('11288','2013-06-22','18:05:00',2.52),('11288','2013-06-22','18:10:00',1.73),('11288','2013-06-22','18:15:00',1.83),('11288','2013-06-22','18:20:00',1.84),('11288','2013-06-22','18:25:00',1.05),('11288','2013-06-22','18:35:00',1.1),('11288','2013-06-22','18:40:00',1.05),('11288','2013-06-22','19:00:00',1.03),('11288','2013-06-22','19:15:00',1.18),('11288','2013-06-22','19:20:00',1.16),('11288','2013-06-22','19:25:00',1.15),('11288','2013-06-21','07:10:00',1.03),('11288','2013-06-21','07:15:00',1.13),('11288','2013-06-21','07:20:00',1.19),('11288','2013-06-21','07:25:00',1.29),('11288','2013-06-21','07:30:00',1.4),('11288','2013-06-21','07:35:00',1.49),('11288','2013-06-21','07:40:00',1.57),('11288','2013-06-21','07:45:00',1.62),('11288','2013-06-21','07:50:00',1.79),('11288','2013-06-21','07:55:00',1.89),('11288','2013-06-21','08:00:00',2.08),('11288','2013-06-21','08:05:00',2.26),('11288','2013-06-21','08:10:00',2.29),('11288','2013-06-21','08:15:00',2.43),('11288','2013-06-21','08:20:00',2.61),('11288','2013-06-21','08:25:00',2.69),('11288','2013-06-21','08:30:00',2.79),('11288','2013-06-21','08:35:00',2.96),('11288','2013-06-21','08:40:00',2.89),('11288','2013-06-21','08:45:00',2.91),('11288','2013-06-21','08:50:00',3.4),('11288','2013-06-21','08:55:00',3.48),('11288','2013-06-21','09:00:00',3.64),('11288','2013-06-21','09:05:00',3.74),('11288','2013-06-21','09:10:00',3.7),('11288','2013-06-21','09:15:00',3.72),('11288','2013-06-21','09:20:00',4.05),('11288','2013-06-21','09:25:00',4),('11288','2013-06-21','09:30:00',3.91),('11288','2013-06-21','09:35:00',4.31),('11288','2013-06-21','09:40:00',4.38),('11288','2013-06-21','09:45:00',4.38),('11288','2013-06-21','09:50:00',4.75),('11288','2013-06-21','09:55:00',4.68),('11288','2013-06-21','10:00:00',4.67),('11288','2013-06-21','10:05:00',4.98),('11288','2013-06-21','10:10:00',5.08),('11288','2013-06-21','10:15:00',5.17),('11288','2013-06-21','10:20:00',5.25),('11288','2013-06-21','10:25:00',5.31),('11288','2013-06-21','10:30:00',5.38),('11288','2013-06-21','10:35:00',5.49),('11288','2013-06-21','10:40:00',5.57),('11288','2013-06-21','10:45:00',5.63),('11288','2013-06-21','10:50:00',5.7),('11288','2013-06-21','10:55:00',5.66),('11288','2013-06-21','11:00:00',5.74),('11288','2013-06-21','11:05:00',5.81),('11288','2013-06-21','11:10:00',5.89),('11288','2013-06-21','11:15:00',6.02),('11288','2013-06-21','11:20:00',6.12),('11288','2013-06-21','11:25:00',6.15),('11288','2013-06-21','11:30:00',6.17),('11288','2013-06-21','11:35:00',6.2),('11288','2013-06-21','11:40:00',6.23),('11288','2013-06-21','11:45:00',6.27),('11288','2013-06-21','11:50:00',6.39),('11288','2013-06-21','11:55:00',6.37),('11288','2013-06-21','12:00:00',6.41),('11288','2013-06-21','12:05:00',6.41),('11288','2013-06-21','12:10:00',6.4),('11288','2013-06-21','12:15:00',6.38),('11288','2013-06-21','12:20:00',6.37),('11288','2013-06-21','12:25:00',6.35),('11288','2013-06-21','12:30:00',6.33),('11288','2013-06-21','12:35:00',6.36),('11288','2013-06-21','12:40:00',6.42),('11288','2013-06-21','12:45:00',6.51),('11288','2013-06-21','12:50:00',6.35),('11288','2013-06-21','12:55:00',6.38),('11288','2013-06-21','13:00:00',6.44),('11288','2013-06-21','13:05:00',6.35),('11288','2013-06-21','13:10:00',6.46),('11288','2013-06-21','13:15:00',6.55),('11288','2013-06-21','13:20:00',6.58),('11288','2013-06-21','13:25:00',6.62),('11288','2013-06-21','13:30:00',6.66),('11288','2013-06-21','13:35:00',6.62),('11288','2013-06-21','13:40:00',6.64),('11288','2013-06-21','13:45:00',6.62),('11288','2013-06-21','13:50:00',6.59),('11288','2013-06-21','13:55:00',6.65),('11288','2013-06-21','14:00:00',6.69),('11288','2013-06-21','14:05:00',6.65),('11288','2013-06-21','14:10:00',6.6),('11288','2013-06-21','14:15:00',6.56),('11288','2013-06-21','14:20:00',6.55),('11288','2013-06-21','14:25:00',6.6),('11288','2013-06-21','14:30:00',6.58),('11288','2013-06-21','14:35:00',6.52),('11288','2013-06-21','14:40:00',6.5),('11288','2013-06-21','14:45:00',6.48),('11288','2013-06-21','14:50:00',6.47),('11288','2013-06-21','14:55:00',6.44),('11288','2013-06-21','15:00:00',6.4),('11288','2013-06-21','15:05:00',6.36),('11288','2013-06-21','15:10:00',6.28),('11288','2013-06-21','15:15:00',6.25),('11288','2013-06-21','15:20:00',6.16),('11288','2013-06-21','15:25:00',6.11),('11288','2013-06-21','15:30:00',6.09),('11288','2013-06-21','15:35:00',6.04),('11288','2013-06-21','15:40:00',5.95),('11288','2013-06-21','15:45:00',5.88),('11288','2013-06-21','15:50:00',5.82),('11288','2013-06-21','15:55:00',5.74),('11288','2013-06-21','16:00:00',5.66),('11288','2013-06-21','16:05:00',5.59),('11288','2013-06-21','16:10:00',5.49),('11288','2013-06-21','16:15:00',5.41),('11288','2013-06-21','16:20:00',5.31),('11288','2013-06-21','16:25:00',5.22),('11288','2013-06-21','16:30:00',5.13),('11288','2013-06-21','16:35:00',5),('11288','2013-06-21','16:40:00',4.88),('11288','2013-06-21','16:45:00',4.77),('11288','2013-06-21','16:50:00',4.66),('11288','2013-06-21','16:55:00',4.58),('11288','2013-06-21','17:00:00',4.46),('11288','2013-06-21','17:05:00',4.32),('11288','2013-06-21','17:10:00',4.24),('11288','2013-06-21','17:15:00',4.12),('11288','2013-06-21','17:20:00',4),('11288','2013-06-21','17:25:00',3.88),('11288','2013-06-21','17:30:00',3.77),('11288','2013-06-21','17:35:00',3.72),('11288','2013-06-21','17:40:00',3.62),('11288','2013-06-21','17:45:00',3.44),('11288','2013-06-21','17:50:00',3.29),('11288','2013-06-21','17:55:00',3.17),('11288','2013-06-21','18:00:00',3.05),('11288','2013-06-21','18:05:00',2.92),('11288','2013-06-21','18:10:00',2.78),('11288','2013-06-21','18:15:00',2.64),('11288','2013-06-21','18:20:00',2.51),('11288','2013-06-21','18:25:00',2.34),('11288','2013-06-21','18:30:00',2.23),('11288','2013-06-21','18:35:00',2.1),('11288','2013-06-21','18:40:00',1.96),('11288','2013-06-21','18:45:00',1.83),('11288','2013-06-21','18:50:00',1.69),('11288','2013-06-21','18:55:00',1.57),('11288','2013-06-21','19:00:00',1.48),('11288','2013-06-21','19:05:00',1.35),('11288','2013-06-21','19:10:00',1.21),('11288','2013-06-21','19:15:00',1.05),('11288','2014-04-04','08:35:00',1.03),('11288','2014-04-04','08:40:00',1.43),('11288','2014-04-04','08:45:00',1.55),('11288','2014-04-04','08:50:00',1.77),('11288','2014-04-04','08:55:00',1.72),('11288','2014-04-04','09:00:00',1.79),('11288','2014-04-04','09:05:00',2.65),('11288','2014-04-04','09:10:00',3.19),('11288','2014-04-04','09:15:00',3.12),('11288','2014-04-04','09:20:00',2.29),('11288','2014-04-04','09:25:00',1.59),('11288','2014-04-04','09:30:00',1.57),('11288','2014-04-04','09:35:00',1.6),('11288','2014-04-04','09:40:00',1.52),('11288','2014-04-04','09:45:00',1.47),('11288','2014-04-04','09:50:00',1.36),('11288','2014-04-04','11:15:00',1.07),('11288','2014-04-04','11:20:00',1.14),('11288','2014-04-04','12:50:00',1.18),('11288','2014-04-04','13:05:00',1.14),('11288','2014-04-04','13:10:00',2.12),('11288','2014-04-04','13:15:00',1.68),('11288','2014-04-04','13:20:00',3.45),('11288','2014-04-04','13:25:00',3.69),('11288','2014-04-04','13:30:00',3.8),('11288','2014-04-04','13:35:00',4.89),('11288','2014-04-04','13:40:00',7.5),('11288','2014-04-04','13:45:00',5.58),('11288','2014-04-04','13:50:00',7.29),('11288','2014-04-04','13:55:00',3.34),('11288','2014-04-04','14:00:00',5.63),('11288','2014-04-04','14:05:00',7.17),('11288','2014-04-04','14:10:00',7.72),('11288','2014-04-04','14:15:00',5.24),('11288','2014-04-04','14:20:00',5.32),('11288','2014-04-04','14:25:00',5.4),('11288','2014-04-04','14:30:00',2.17),('11288','2014-04-04','14:35:00',3.55),('11288','2014-04-04','14:40:00',2.33),('11288','2014-04-04','14:45:00',2.63),('11288','2014-04-04','14:50:00',5.24),('11288','2014-04-04','14:55:00',6.84),('11288','2014-04-04','15:00:00',5.86),('11288','2014-04-04','15:05:00',5.21),('11288','2014-04-04','15:10:00',6.17),('11288','2014-04-04','15:15:00',5.33),('11288','2014-04-04','15:20:00',3.39),('11288','2014-04-04','15:25:00',3.19),('11288','2014-04-04','15:30:00',2.56),('11288','2014-04-04','15:35:00',2.72),('11288','2014-04-04','15:40:00',3.6),('11288','2014-04-04','15:45:00',2.81),('11288','2014-04-04','15:50:00',3.36),('11288','2014-04-04','15:55:00',5.41),('11288','2014-04-04','16:00:00',3.64),('11288','2014-04-04','16:05:00',3.8),('11288','2014-04-04','16:10:00',5.29),('11288','2014-04-04','16:15:00',2.93),('11288','2014-04-04','16:20:00',1.97),('11288','2014-04-04','16:25:00',2.07),('11288','2014-04-04','16:30:00',3.58),('11288','2014-04-04','16:35:00',2.98),('11288','2014-04-04','16:40:00',2.41),('11288','2014-04-04','16:45:00',3.97),('11288','2014-04-04','16:50:00',4.37),('11288','2014-04-04','16:55:00',3.97),('11288','2014-04-04','17:00:00',3.4),('11288','2014-04-04','17:05:00',3.02),('11288','2014-04-04','17:10:00',3.46),('11288','2014-04-04','17:15:00',3.31),('11288','2014-04-04','17:20:00',2.58),('11288','2014-04-04','17:25:00',2.31),('11288','2014-04-04','17:30:00',3),('11288','2014-04-04','17:35:00',2.12),('11288','2014-04-04','17:40:00',2.4),('11288','2014-04-04','17:45:00',2.4),('11288','2014-04-04','17:50:00',2.28),('11288','2014-04-04','17:55:00',1.97),('11288','2014-04-04','18:00:00',1.78),('11288','2014-04-04','18:10:00',1.32),('11288','2014-04-04','18:15:00',1.22),('11288','2014-04-04','18:20:00',1.06),('11288','2013-06-20','07:15:00',1.03),('11288','2013-06-20','07:20:00',1.1),('11288','2013-06-20','07:25:00',1.18),('11288','2013-06-20','07:30:00',1.31),('11288','2013-06-20','07:35:00',1.36),('11288','2013-06-20','07:40:00',1.43),('11288','2013-06-20','07:45:00',1.51),('11288','2013-06-20','07:50:00',1.63),('11288','2013-06-20','07:55:00',1.7),('11288','2013-06-20','08:00:00',2.06),('11288','2013-06-20','08:05:00',2.13),('11288','2013-06-20','08:10:00',2.2),('11288','2013-06-20','08:15:00',2.42),('11288','2013-06-20','08:20:00',2.54),('11288','2013-06-20','08:25:00',2.63),('11288','2013-06-20','08:30:00',2.77),('11288','2013-06-20','08:35:00',2.97),('11288','2013-06-20','08:40:00',3.1),('11288','2013-06-20','08:45:00',3.31),('11288','2013-06-20','08:50:00',3.42),('11288','2013-06-20','08:55:00',3.55),('11288','2013-06-20','09:00:00',3.67),('11288','2013-06-20','09:05:00',3.76),('11288','2013-06-20','09:10:00',3.69),('11288','2013-06-20','09:15:00',3.86),('11288','2013-06-20','09:20:00',4.15),('11288','2013-06-20','09:25:00',4.1),('11288','2013-06-20','09:30:00',4.19),('11288','2013-06-20','09:35:00',4.49),('11288','2013-06-20','09:40:00',4.5),('11288','2013-06-20','09:45:00',4.46),('11288','2013-06-20','09:50:00',4.9),('11288','2013-06-20','09:55:00',4.78),('11288','2013-06-20','10:00:00',4.83),('11288','2013-06-20','10:05:00',5.2),('11288','2013-06-20','10:10:00',5.27),('11288','2013-06-20','10:15:00',5.32),('11288','2013-06-20','10:20:00',5.5),('11288','2013-06-20','10:25:00',5.59),('11288','2013-06-20','10:30:00',5.61),('11288','2013-06-20','10:35:00',5.71),('11288','2013-06-20','10:40:00',5.78),('11288','2013-06-20','10:45:00',5.82),('11288','2013-06-20','10:50:00',5.93),('11288','2013-06-20','10:55:00',6.02),('11288','2013-06-20','11:00:00',5.96),('11288','2013-06-20','11:05:00',6.04),('11288','2013-06-20','11:10:00',6.06),('11288','2013-06-20','11:15:00',6.05),('11288','2013-06-20','11:20:00',6.06),('11288','2013-06-20','11:25:00',6.11),('11288','2013-06-20','11:30:00',6.2),('11288','2013-06-20','11:35:00',6.27),('11288','2013-06-20','11:40:00',6.28),('11288','2013-06-20','11:45:00',6.19),('11288','2013-06-20','11:50:00',6.1),('11288','2013-06-20','11:55:00',6.16),('11288','2013-06-20','12:00:00',6.09),('11288','2013-06-20','12:05:00',6.19),('11288','2013-06-20','12:10:00',4.88),('11288','2013-06-20','12:15:00',6.26),('11288','2013-06-20','12:20:00',4.31),('11288','2013-06-20','12:25:00',4.55),('11288','2013-06-20','12:30:00',6.64),('11288','2013-06-20','12:35:00',6.43),('11288','2013-06-20','12:40:00',6.39),('11288','2013-06-20','12:45:00',4.28),('11288','2013-06-20','12:50:00',6.63),('11288','2013-06-20','12:55:00',6.55),('11288','2013-06-20','13:00:00',6.82),('11288','2013-06-20','13:05:00',6.67),('11288','2013-06-20','13:10:00',5.18),('11288','2013-06-20','13:15:00',4.57),('11288','2013-06-20','13:20:00',6.62),('11288','2013-06-20','13:25:00',6.64),('11288','2013-06-20','13:30:00',6.05),('11288','2013-06-20','13:35:00',6.74),('11288','2013-06-20','13:40:00',6.72),('11288','2013-06-20','13:45:00',6.78),('11288','2013-06-20','13:50:00',6.77),('11288','2013-06-20','13:55:00',6.68),('11288','2013-06-20','14:00:00',6.79),('11288','2013-06-20','14:05:00',6.68),('11288','2013-06-20','14:10:00',6.73),('11288','2013-06-20','14:15:00',6.74),('11288','2013-06-20','14:20:00',6.78),('11288','2013-06-20','14:25:00',6.73),('11288','2013-06-20','14:30:00',6.77),('11288','2013-06-20','14:35:00',6.76),('11288','2013-06-20','14:40:00',6.76),('11288','2013-06-20','14:45:00',6.72),('11288','2013-06-20','14:50:00',6.68),('11288','2013-06-20','14:55:00',6.63),('11288','2013-06-20','15:00:00',6.55),('11288','2013-06-20','15:05:00',6.52),('11288','2013-06-20','15:10:00',6.48),('11288','2013-06-20','15:15:00',6.39),('11288','2013-06-20','15:20:00',6.34),('11288','2013-06-20','15:25:00',6.26),('11288','2013-06-20','15:30:00',6.16),('11288','2013-06-20','15:35:00',6.09),('11288','2013-06-20','15:40:00',6.03),('11288','2013-06-20','15:45:00',5.91),('11288','2013-06-20','15:50:00',5.87),('11288','2013-06-20','15:55:00',5.8),('11288','2013-06-20','16:00:00',5.74),('11288','2013-06-20','16:05:00',5.63),('11288','2013-06-20','16:10:00',5.6),('11288','2013-06-20','16:15:00',5.52),('11288','2013-06-20','16:20:00',5.36),('11288','2013-06-20','16:25:00',5.3),('11288','2013-06-20','16:30:00',5.22),('11288','2013-06-20','16:35:00',5.06),('11288','2013-06-20','16:40:00',4.81),('11288','2013-06-20','16:45:00',4.53),('11288','2013-06-20','16:50:00',4.53),('11288','2013-06-20','16:55:00',4.59),('11288','2013-06-20','17:00:00',4.48),('11288','2013-06-20','17:05:00',4.37),('11288','2013-06-20','17:10:00',4.26),('11288','2013-06-20','17:15:00',4.16),('11288','2013-06-20','17:20:00',4.02),('11288','2013-06-20','17:25:00',3.94),('11288','2013-06-20','17:30:00',3.79),('11288','2013-06-20','17:35:00',3.73),('11288','2013-06-20','17:40:00',3.66),('11288','2013-06-20','17:45:00',3.49),('11288','2013-06-20','17:50:00',3.33),('11288','2013-06-20','17:55:00',3.23),('11288','2013-06-20','18:00:00',3.11),('11288','2013-06-20','18:05:00',2.97),('11288','2013-06-20','18:10:00',2.84),('11288','2013-06-20','18:15:00',2.7),('11288','2013-06-20','18:20:00',2.58),('11288','2013-06-20','18:25:00',2.43),('11288','2013-06-20','18:30:00',2.29),('11288','2013-06-20','18:35:00',2.14),('11288','2013-06-20','18:40:00',2.01),('11288','2013-06-20','18:45:00',1.87),('11288','2013-06-20','18:50:00',1.74),('11288','2013-06-20','18:55:00',1.6),('11288','2013-06-20','19:00:00',1.47),('11288','2013-06-20','19:05:00',1.34),('11288','2013-06-20','19:10:00',1.22),('11288','2013-06-20','19:15:00',1.08),('11288','2013-06-19','07:15:00',1.07),('11288','2013-06-19','07:20:00',1.14),('11288','2013-06-19','07:25:00',1.21),('11288','2013-06-19','07:30:00',1.3),('11288','2013-06-19','07:35:00',1.38),('11288','2013-06-19','07:40:00',1.46),('11288','2013-06-19','07:45:00',1.54),('11288','2013-06-19','07:50:00',1.65),('11288','2013-06-19','07:55:00',1.73),('11288','2013-06-19','08:00:00',2),('11288','2013-06-19','08:05:00',2.1),('11288','2013-06-19','08:10:00',2.14),('11288','2013-06-19','08:15:00',2.38),('11288','2013-06-19','08:20:00',2.49),('11288','2013-06-19','08:25:00',2.59),('11288','2013-06-19','08:30:00',2.71),('11288','2013-06-19','08:35:00',2.93),('11288','2013-06-19','08:40:00',2.95),('11288','2013-06-19','08:45:00',3.01),('11288','2013-06-19','08:50:00',3.32),('11288','2013-06-19','08:55:00',3.39),('11288','2013-06-19','09:00:00',3.59),('11288','2013-06-19','09:05:00',3.68),('11288','2013-06-19','09:10:00',3.58),('11288','2013-06-19','09:15:00',3.6),('11288','2013-06-19','09:20:00',4.07),('11288','2013-06-19','09:25:00',3.93),('11288','2013-06-19','09:30:00',3.87),('11288','2013-06-19','09:35:00',4.39),('11288','2013-06-19','09:40:00',4.38),('11288','2013-06-19','09:45:00',4.36),('11288','2013-06-19','09:50:00',4.78),('11288','2013-06-19','09:55:00',4.66),('11288','2013-06-19','10:00:00',4.66),('11288','2013-06-19','10:05:00',5),('11288','2013-06-19','10:10:00',5.08),('11288','2013-06-19','10:15:00',5.19),('11288','2013-06-19','10:20:00',5.32),('11288','2013-06-19','10:25:00',5.4),('11288','2013-06-19','10:30:00',5.51),('11288','2013-06-19','10:35:00',5.59),('11288','2013-06-19','10:40:00',5.59),('11288','2013-06-19','10:45:00',5.63),('11288','2013-06-19','10:50:00',5.73),('11288','2013-06-19','10:55:00',5.76),('11288','2013-06-19','11:00:00',5.8),('11288','2013-06-19','11:05:00',5.83),('11288','2013-06-19','11:10:00',5.91),('11288','2013-06-19','11:15:00',5.91),('11288','2013-06-19','11:20:00',6.05),('11288','2013-06-19','11:25:00',6.05),('11288','2013-06-19','11:30:00',6.12),('11288','2013-06-19','11:35:00',6.09),('11288','2013-06-19','11:40:00',6.15),('11288','2013-06-19','11:45:00',6.22),('11288','2013-06-19','11:50:00',6.22),('11288','2013-06-19','11:55:00',6.28),('11288','2013-06-19','12:00:00',6.31),('11288','2013-06-19','12:05:00',6.26),('11288','2013-06-19','12:10:00',6.33),('11288','2013-06-19','12:15:00',6.32),('11288','2013-06-19','12:20:00',6.32),('11288','2013-06-19','12:25:00',6.3),('11288','2013-06-19','12:30:00',6.45),('11288','2013-06-19','12:35:00',6.56),('11288','2013-06-19','12:40:00',6.59),('11288','2013-06-19','12:45:00',6.5),('11288','2013-06-19','12:50:00',6.57),('11288','2013-06-19','12:55:00',6.54),('11288','2013-06-19','13:00:00',6.52),('11288','2013-06-19','13:05:00',6.61),('11288','2013-06-19','13:10:00',6.58),('11288','2013-06-19','13:15:00',6.53),('11288','2013-06-19','13:20:00',6.6),('11288','2013-06-19','13:25:00',6.67),('11288','2013-06-19','13:30:00',6.63),('11288','2013-06-19','13:35:00',6.61),('11288','2013-06-19','13:40:00',6.61),('11288','2013-06-19','13:45:00',6.61),('11288','2013-06-19','13:50:00',6.65),('11288','2013-06-19','13:55:00',6.65),('11288','2013-06-19','14:00:00',6.63),('11288','2013-06-19','14:05:00',6.61),('11288','2013-06-19','14:10:00',6.58),('11288','2013-06-19','14:15:00',6.53),('11288','2013-06-19','14:20:00',6.49),('11288','2013-06-19','14:25:00',6.54),('11288','2013-06-19','14:30:00',6.45),('11288','2013-06-19','14:35:00',6.38),('11288','2013-06-19','14:40:00',6.32),('11288','2013-06-19','14:45:00',6.32),('11288','2013-06-19','14:50:00',6.3),('11288','2013-06-19','14:55:00',6.26),('11288','2013-06-19','15:00:00',6.22),('11288','2013-06-19','15:05:00',6.16),('11288','2013-06-19','15:10:00',6.13),('11288','2013-06-19','15:15:00',6.08),('11288','2013-06-19','15:20:00',6.05),('11288','2013-06-19','15:25:00',5.99),('11288','2013-06-19','15:30:00',5.88),('11288','2013-06-19','15:35:00',5.82),('11288','2013-06-19','15:40:00',5.73),('11288','2013-06-19','15:45:00',5.67),('11288','2013-06-19','15:50:00',5.58),('11288','2013-06-19','15:55:00',5.53),('11288','2013-06-19','16:00:00',5.48),('11288','2013-06-19','16:05:00',5.34),('11288','2013-06-19','16:10:00',5.26),('11288','2013-06-19','16:15:00',5.17),('11288','2013-06-19','16:20:00',5.07),('11288','2013-06-19','16:25:00',5),('11288','2013-06-19','16:30:00',4.91),('11288','2013-06-19','16:35:00',4.75),('11288','2013-06-19','16:40:00',4.58),('11288','2013-06-19','16:45:00',4.36),('11288','2013-06-19','16:50:00',4.32),('11288','2013-06-19','16:55:00',4.42),('11288','2013-06-19','17:00:00',4.32),('11288','2013-06-19','17:05:00',4.18),('11288','2013-06-19','17:10:00',4.1),('11288','2013-06-19','17:15:00',4.01),('11288','2013-06-19','17:20:00',3.92),('11288','2013-06-19','17:25:00',3.84),('11288','2013-06-19','17:30:00',3.73),('11288','2013-06-19','17:35:00',3.69),('11288','2013-06-19','17:40:00',3.57),('11288','2013-06-19','17:45:00',3.4),('11288','2013-06-19','17:50:00',3.25),('11288','2013-06-19','17:55:00',3.13),('11288','2013-06-19','18:00:00',3.01),('11288','2013-06-19','18:05:00',2.87),('11288','2013-06-19','18:10:00',2.7),('11288','2013-06-19','18:15:00',2.57),('11288','2013-06-19','18:20:00',2.44),('11288','2013-06-19','18:25:00',2.26),('11288','2013-06-19','18:30:00',2.14),('11288','2013-06-19','18:35:00',1.92),('11288','2013-06-19','18:40:00',1.72),('11288','2013-06-19','18:45:00',1.67),('11288','2013-06-19','18:50:00',1.55),('11288','2013-06-19','18:55:00',1.46),('11288','2013-06-19','19:00:00',1.41),('11288','2013-06-19','19:05:00',1.28),('11288','2013-06-19','19:10:00',1.14),('11288','2013-06-19','19:15:00',1.04),('11288','2013-06-18','07:20:00',1.09),('11288','2013-06-18','07:25:00',1.16),('11288','2013-06-18','07:30:00',1.27),('11288','2013-06-18','07:35:00',1.36),('11288','2013-06-18','07:40:00',1.42),('11288','2013-06-18','07:45:00',1.52),('11288','2013-06-18','07:50:00',1.67),('11288','2013-06-18','07:55:00',1.74),('11288','2013-06-18','08:00:00',2),('11288','2013-06-18','08:05:00',2.1),('11288','2013-06-18','08:10:00',2.15),('11288','2013-06-18','08:15:00',2.32),('11288','2013-06-18','08:20:00',2.47),('11288','2013-06-18','08:25:00',2.6),('11288','2013-06-18','08:30:00',2.71),('11288','2013-06-18','08:35:00',2.91),('11288','2013-06-18','08:40:00',2.91),('11288','2013-06-18','08:45:00',3.01),('11288','2013-06-18','08:50:00',3.3),('11288','2013-06-18','08:55:00',3.41),('11288','2013-06-18','09:00:00',3.56),('11288','2013-06-18','09:05:00',3.66),('11288','2013-06-18','09:10:00',3.59),('11288','2013-06-18','09:15:00',3.61),('11288','2013-06-18','09:20:00',4.01),('11288','2013-06-18','09:25:00',3.89),('11288','2013-06-18','09:30:00',3.82),('11288','2013-06-18','09:35:00',4.3),('11288','2013-06-18','09:40:00',4.28),('11288','2013-06-18','09:45:00',4.34),('11288','2013-06-18','09:50:00',4.66),('11288','2013-06-18','09:55:00',4.58),('11288','2013-06-18','10:00:00',4.63),('11288','2013-06-18','10:05:00',4.97),('11288','2013-06-18','10:10:00',5.02),('11288','2013-06-18','10:15:00',5.18),('11288','2013-06-18','10:20:00',5.32),('11288','2013-06-18','10:25:00',5.39),('11288','2013-06-18','10:30:00',5.45),('11288','2013-06-18','10:35:00',5.59),('11288','2013-06-18','10:40:00',5.64),('11288','2013-06-18','10:45:00',5.72),('11288','2013-06-18','10:50:00',5.75),('11288','2013-06-18','10:55:00',5.76),('11288','2013-06-18','11:00:00',5.81),('11288','2013-06-18','11:05:00',5.9),('11288','2013-06-18','11:10:00',5.87),('11288','2013-06-18','11:15:00',5.92),('11288','2013-06-18','11:20:00',6.06),('11288','2013-06-18','11:25:00',6.08),('11288','2013-06-18','11:30:00',6.05),('11288','2013-06-18','11:35:00',6.08),('11288','2013-06-18','11:40:00',6.12),('11288','2013-06-18','11:45:00',6.11),('11288','2013-06-18','11:50:00',6.13),('11288','2013-06-18','11:55:00',6.16),('11288','2013-06-18','12:00:00',6.19),('11288','2013-06-18','12:05:00',6.2),('11288','2013-06-18','12:10:00',6.05),('11288','2013-06-18','12:15:00',5.72),('11288','2013-06-18','12:20:00',6.21),('11288','2013-06-18','12:25:00',6.33),('11288','2013-06-18','12:30:00',6.23),('11288','2013-06-18','12:35:00',6.19),('11288','2013-06-18','12:40:00',4.87),('11288','2013-06-18','12:45:00',4.44),('11288','2013-06-18','12:50:00',2.76),('11288','2013-06-18','12:55:00',5.41),('11288','2013-06-18','13:00:00',3.29),('11288','2013-06-18','13:05:00',5.13),('11288','2013-06-18','13:10:00',5.65),('11288','2013-06-18','13:15:00',5.76),('11288','2013-06-18','13:20:00',6.67),('11288','2013-06-18','13:25:00',4.86),('11288','2013-06-18','13:30:00',4.45),('11288','2013-06-18','13:35:00',6.87),('11288','2013-06-18','13:40:00',5.84),('11288','2013-06-18','13:45:00',4.85),('11288','2013-06-18','13:50:00',6.62),('11288','2013-06-18','13:55:00',5.18),('11288','2013-06-18','14:00:00',6.72),('11288','2013-06-18','14:05:00',6.81),('11288','2013-06-18','14:10:00',6.59),('11288','2013-06-18','14:15:00',6.64),('11288','2013-06-18','14:20:00',6.63),('11288','2013-06-18','14:25:00',6.54),('11288','2013-06-18','14:30:00',6.5),('11288','2013-06-18','14:35:00',6.61),('11288','2013-06-18','14:40:00',6.63),('11288','2013-06-18','14:45:00',6.56),('11288','2013-06-18','14:50:00',6.47),('11288','2013-06-18','14:55:00',6.44),('11288','2013-06-18','15:00:00',6.38),('11288','2013-06-18','15:05:00',6.27),('11288','2013-06-18','15:10:00',6.23),('11288','2013-06-18','15:15:00',6.13),('11288','2013-06-18','15:20:00',6.07),('11288','2013-06-18','15:25:00',6.02),('11288','2013-06-18','15:30:00',5.95),('11288','2013-06-18','15:35:00',5.94),('11288','2013-06-18','15:40:00',5.93),('11288','2013-06-18','15:45:00',5.83),('11288','2013-06-18','15:50:00',5.78),('11288','2013-06-18','15:55:00',5.78),('11288','2013-06-18','16:00:00',5.72),('11288','2013-06-18','16:05:00',5.66),('11288','2013-06-18','16:10:00',5.6),('11288','2013-06-18','16:15:00',5.56),('11288','2013-06-18','16:20:00',5.49),('11288','2013-06-18','16:25:00',5.35),('11288','2013-06-18','16:30:00',5.21),('11288','2013-06-18','16:35:00',4.94),('11288','2013-06-18','16:40:00',4.85),('11288','2013-06-18','16:45:00',4.67),('11288','2013-06-18','16:50:00',4.59),('11288','2013-06-18','16:55:00',4.49),('11288','2013-06-18','17:00:00',4.38),('11288','2013-06-18','17:05:00',4.25),('11288','2013-06-18','17:10:00',4.13),('11288','2013-06-18','17:15:00',4.05),('11288','2013-06-18','17:20:00',3.95),('11288','2013-06-18','17:25:00',3.87),('11288','2013-06-18','17:30:00',3.73),('11288','2013-06-18','17:35:00',3.64),('11288','2013-06-18','17:40:00',3.55),('11288','2013-06-18','17:45:00',3.37),('11288','2013-06-18','17:50:00',3.23),('11288','2013-06-18','17:55:00',3.13),('11288','2013-06-18','18:00:00',3.01),('11288','2013-06-18','18:05:00',2.87),('11288','2013-06-18','18:10:00',2.73),('11288','2013-06-18','18:15:00',2.6),('11288','2013-06-18','18:20:00',2.55),('11288','2013-06-18','18:25:00',2.37),('11288','2013-06-18','18:30:00',2.24),('11288','2013-06-18','18:35:00',2.13),('11288','2013-06-18','18:40:00',1.98),('11288','2013-06-18','18:45:00',1.87),('11288','2013-06-18','18:50:00',1.73),('11288','2013-06-18','18:55:00',1.6),('11288','2013-06-18','19:00:00',1.5),('11288','2013-06-18','19:05:00',1.37),('11288','2013-06-18','19:10:00',1.26),('11288','2013-06-18','19:15:00',1.13),('11288','2013-06-18','19:20:00',1.02),('11288','2013-06-17','07:15:00',1.1),('11288','2013-06-17','07:20:00',1.18),('11288','2013-06-17','07:25:00',1.25),('11288','2013-06-17','07:30:00',1.37),('11288','2013-06-17','07:35:00',1.43),('11288','2013-06-17','07:40:00',1.49),('11288','2013-06-17','07:45:00',1.62),('11288','2013-06-17','07:50:00',1.72),('11288','2013-06-17','07:55:00',1.8),('11288','2013-06-17','08:00:00',2.16),('11288','2013-06-17','08:05:00',2.18),('11288','2013-06-17','08:10:00',2.23),('11288','2013-06-17','08:15:00',2.43),('11288','2013-06-17','08:20:00',2.57),('11288','2013-06-17','08:25:00',2.7),('11288','2013-06-17','08:30:00',2.84),('11288','2013-06-17','08:35:00',3.04),('11288','2013-06-17','08:40:00',3.11),('11288','2013-06-17','08:45:00',3.36),('11288','2013-06-17','08:50:00',3.47),('11288','2013-06-17','08:55:00',3.59),('11288','2013-06-17','09:00:00',3.76),('11288','2013-06-17','09:05:00',3.8),('11288','2013-06-17','09:10:00',3.69),('11288','2013-06-17','09:15:00',3.97),('11288','2013-06-17','09:20:00',4.21),('11288','2013-06-17','09:25:00',4.04),('11288','2013-06-17','09:30:00',4.03),('11288','2013-06-17','09:35:00',4.51),('11288','2013-06-17','09:40:00',4.65),('11288','2013-06-17','09:45:00',4.82),('11288','2013-06-17','09:50:00',4.92),('11288','2013-06-17','09:55:00',4.82),('11288','2013-06-17','10:00:00',4.87),('11288','2013-06-17','10:05:00',5.2),('11288','2013-06-17','10:10:00',5.26),('11288','2013-06-17','10:15:00',5.33),('11288','2013-06-17','10:20:00',5.43),('11288','2013-06-17','10:25:00',5.52),('11288','2013-06-17','10:30:00',5.58),('11288','2013-06-17','10:35:00',5.74),('11288','2013-06-17','10:40:00',5.82),('11288','2013-06-17','10:45:00',5.89),('11288','2013-06-17','10:50:00',5.97),('11288','2013-06-17','10:55:00',6.04),('11288','2013-06-17','11:00:00',6.04),('11288','2013-06-17','11:05:00',6.11),('11288','2013-06-17','11:10:00',6.15),('11288','2013-06-17','11:15:00',6.19),('11288','2013-06-17','11:20:00',6.21),('11288','2013-06-17','11:25:00',6.27),('11288','2013-06-17','11:30:00',6.29),('11288','2013-06-17','11:35:00',6.35),('11288','2013-06-17','11:40:00',6.35),('11288','2013-06-17','11:45:00',6.39),('11288','2013-06-17','11:50:00',6.39),('11288','2013-06-17','11:55:00',6.4),('11288','2013-06-17','12:00:00',6.41),('11288','2013-06-17','12:05:00',6.41),('11288','2013-06-17','12:10:00',6.36),('11288','2013-06-17','12:15:00',6.42),('11288','2013-06-17','12:20:00',6.36),('11288','2013-06-17','12:25:00',6.47),('11288','2013-06-17','12:30:00',6.44),('11288','2013-06-17','12:35:00',6.54),('11288','2013-06-17','12:40:00',6.51),('11288','2013-06-17','12:45:00',6.64),('11288','2013-06-17','12:50:00',6.68),('11288','2013-06-17','12:55:00',6.81),('11288','2013-06-17','13:00:00',6.73),('11288','2013-06-17','13:05:00',6.72),('11288','2013-06-17','13:10:00',6.69),('11288','2013-06-17','13:15:00',6.71),('11288','2013-06-17','13:20:00',6.65),('11288','2013-06-17','13:25:00',6.68),('11288','2013-06-17','13:30:00',6.68),('11288','2013-06-17','13:35:00',6.67),('11288','2013-06-17','13:40:00',6.66),('11288','2013-06-17','13:45:00',6.65),('11288','2013-06-17','13:50:00',6.64),('11288','2013-06-17','13:55:00',6.63),('11288','2013-06-17','14:00:00',6.65),('11288','2013-06-17','14:05:00',6.58),('11288','2013-06-17','14:10:00',6.6),('11288','2013-06-17','14:15:00',6.56),('11288','2013-06-17','14:20:00',6.52),('11288','2013-06-17','14:25:00',6.47),('11288','2013-06-17','14:30:00',6.47),('11288','2013-06-17','14:35:00',6.37),('11288','2013-06-17','14:40:00',6.38),('11288','2013-06-17','14:45:00',6.36),('11288','2013-06-17','14:50:00',6.33),('11288','2013-06-17','14:55:00',6.28),('11288','2013-06-17','15:00:00',6.22),('11288','2013-06-17','15:05:00',6.18),('11288','2013-06-17','15:10:00',6.14),('11288','2013-06-17','15:15:00',6.11),('11288','2013-06-17','15:20:00',6.09),('11288','2013-06-17','15:25:00',6.02),('11288','2013-06-17','15:30:00',5.95),('11288','2013-06-17','15:35:00',5.87),('11288','2013-06-17','15:40:00',5.82),('11288','2013-06-17','15:45:00',5.77),('11288','2013-06-17','15:50:00',5.69),('11288','2013-06-17','15:55:00',5.62),('11288','2013-06-17','16:00:00',5.57),('11288','2013-06-17','16:05:00',5.49),('11288','2013-06-17','16:10:00',5.45),('11288','2013-06-17','16:15:00',5.34),('11288','2013-06-17','16:20:00',5.23),('11288','2013-06-17','16:25:00',5.17),('11288','2013-06-17','16:30:00',5.1),('11288','2013-06-17','16:35:00',4.94),('11288','2013-06-17','16:40:00',4.7),('11288','2013-06-17','16:45:00',4.43),('11288','2013-06-17','16:50:00',4.42),('11288','2013-06-17','16:55:00',4.51),('11288','2013-06-17','17:00:00',4.39),('11288','2013-06-17','17:05:00',4.27),('11288','2013-06-17','17:10:00',4.17),('11288','2013-06-17','17:15:00',4.07),('11288','2013-06-17','17:20:00',3.98),('11288','2013-06-17','17:25:00',3.89),('11288','2013-06-17','17:30:00',3.81),('11288','2013-06-17','17:35:00',3.78),('11288','2013-06-17','17:40:00',3.64),('11288','2013-06-17','17:45:00',3.47),('11288','2013-06-17','17:50:00',3.32),('11288','2013-06-17','17:55:00',3.23),('11288','2013-06-17','18:00:00',3.11),('11288','2013-06-17','18:05:00',2.99),('11288','2013-06-17','18:10:00',2.86),('11288','2013-06-17','18:15:00',2.72),('11288','2013-06-17','18:20:00',2.62),('11288','2013-06-17','18:25:00',2.29),('11288','2013-06-17','18:30:00',2.28),('11288','2013-06-17','18:35:00',1.98),('11288','2013-06-17','18:40:00',2.16),('11288','2013-06-17','18:45:00',2.05),('11288','2013-06-17','18:50:00',1.95),('11288','2013-06-17','18:55:00',1.84),('11288','2013-06-17','19:00:00',1.73),('11288','2013-06-17','19:05:00',1.58),('11288','2013-06-17','19:10:00',1.42),('11288','2013-06-17','19:15:00',1.27),('11288','2013-06-17','19:20:00',1.15),('11288','2013-06-17','19:25:00',1.07),('11288','2013-06-16','07:10:00',1.01),('11288','2013-06-16','07:15:00',1.12),('11288','2013-06-16','07:20:00',1.19),('11288','2013-06-16','07:25:00',1.28),('11288','2013-06-16','07:30:00',1.39),('11288','2013-06-16','07:35:00',1.45),('11288','2013-06-16','07:40:00',1.53),('11288','2013-06-16','07:45:00',1.66),('11288','2013-06-16','07:50:00',1.73),('11288','2013-06-16','07:55:00',1.81),('11288','2013-06-16','08:00:00',2.2),('11288','2013-06-16','08:05:00',2.22),('11288','2013-06-16','08:10:00',2.24),('11288','2013-06-16','08:15:00',2.54),('11288','2013-06-16','08:20:00',2.63),('11288','2013-06-16','08:25:00',2.75),('11288','2013-06-16','08:30:00',2.89),('11288','2013-06-16','08:35:00',3.04),('11288','2013-06-16','08:40:00',3.19),('11288','2013-06-16','08:45:00',3.43),('11288','2013-06-16','08:50:00',3.55),('11288','2013-06-16','08:55:00',3.65),('11288','2013-06-16','09:00:00',3.78),('11288','2013-06-16','09:05:00',3.85),('11288','2013-06-16','09:10:00',3.82),('11288','2013-06-16','09:15:00',4.09),('11288','2013-06-16','09:20:00',4.27),('11288','2013-06-16','09:25:00',4.07),('11288','2013-06-16','09:30:00',4.16),('11288','2013-06-16','09:35:00',4.6),('11288','2013-06-16','09:40:00',4.54),('11288','2013-06-16','09:45:00',4.63),('11288','2013-06-16','09:50:00',4.95),('11288','2013-06-16','09:55:00',4.81),('11288','2013-06-16','10:00:00',5),('11288','2013-06-16','10:05:00',5.34),('11288','2013-06-16','10:10:00',5.42),('11288','2013-06-16','10:15:00',5.44),('11288','2013-06-16','10:20:00',5.59),('11288','2013-06-16','10:25:00',5.72),('11288','2013-06-16','10:30:00',5.81),('11288','2013-06-16','10:35:00',5.84),('11288','2013-06-16','10:40:00',5.9),('11288','2013-06-16','10:45:00',6.02),('11288','2013-06-16','10:50:00',6.15),('11288','2013-06-16','10:55:00',6.17),('11288','2013-06-16','11:00:00',6.17),('11288','2013-06-16','11:05:00',6.22),('11288','2013-06-16','11:10:00',6.32),('11288','2013-06-16','11:15:00',6.36),('11288','2013-06-16','11:20:00',6.42),('11288','2013-06-16','11:25:00',6.48),('11288','2013-06-16','11:30:00',6.52),('11288','2013-06-16','11:35:00',6.56),('11288','2013-06-16','11:40:00',6.55),('11288','2013-06-16','11:45:00',6.55),('11288','2013-06-16','11:50:00',6.63),('11288','2013-06-16','11:55:00',6.67),('11288','2013-06-16','12:00:00',6.72),('11288','2013-06-16','12:05:00',6.77),('11288','2013-06-16','12:10:00',6.74),('11288','2013-06-16','12:15:00',6.77),('11288','2013-06-16','12:20:00',6.77),('11288','2013-06-16','12:25:00',6.77),('11288','2013-06-16','12:30:00',6.7),('11288','2013-06-16','12:35:00',6.81),('11288','2013-06-16','12:40:00',6.8),('11288','2013-06-16','12:45:00',6.78),('11288','2013-06-16','12:50:00',6.77),('11288','2013-06-16','12:55:00',6.87),('11288','2013-06-16','13:00:00',6.91),('11288','2013-06-16','13:05:00',6.94),('11288','2013-06-16','13:10:00',6.98),('11288','2013-06-16','13:15:00',6.96),('11288','2013-06-16','13:20:00',7.02),('11288','2013-06-16','13:25:00',6.98),('11288','2013-06-16','13:30:00',6.95),('11288','2013-06-16','13:35:00',7.01),('11288','2013-06-16','13:40:00',6.94),('11288','2013-06-16','13:45:00',6.93),('11288','2013-06-16','13:50:00',6.93),('11288','2013-06-16','13:55:00',6.89),('11288','2013-06-16','14:00:00',6.85),('11288','2013-06-16','14:05:00',6.82),('11288','2013-06-16','14:10:00',6.83),('11288','2013-06-16','14:15:00',6.83),('11288','2013-06-16','14:20:00',6.76),('11288','2013-06-16','14:25:00',6.76),('11288','2013-06-16','14:30:00',6.72),('11288','2013-06-16','14:35:00',6.66),('11288','2013-06-16','14:40:00',6.64),('11288','2013-06-16','14:45:00',6.6),('11288','2013-06-16','14:50:00',6.54),('11288','2013-06-16','14:55:00',6.51),('11288','2013-06-16','15:00:00',6.47),('11288','2013-06-16','15:05:00',6.43),('11288','2013-06-16','15:10:00',6.38),('11288','2013-06-16','15:15:00',6.34),('11288','2013-06-16','15:20:00',6.3),('11288','2013-06-16','15:25:00',6.23),('11288','2013-06-16','15:30:00',6.15),('11288','2013-06-16','15:35:00',6.1),('11288','2013-06-16','15:40:00',6.03),('11288','2013-06-16','15:45:00',5.96),('11288','2013-06-16','15:50:00',5.89),('11288','2013-06-16','15:55:00',5.8),('11288','2013-06-16','16:00:00',5.72),('11288','2013-06-16','16:05:00',5.58),('11288','2013-06-16','16:10:00',5.57),('11288','2013-06-16','16:15:00',5.46),('11288','2013-06-16','16:20:00',5.36),('11288','2013-06-16','16:25:00',5.26),('11288','2013-06-16','16:30:00',5.17),('11288','2013-06-16','16:35:00',5),('11288','2013-06-16','16:40:00',4.76),('11288','2013-06-16','16:45:00',4.5),('11288','2013-06-16','16:50:00',4.55),('11288','2013-06-16','16:55:00',4.56),('11288','2013-06-16','17:00:00',4.44),('11288','2013-06-16','17:05:00',4.32),('11288','2013-06-16','17:10:00',4.2),('11288','2013-06-16','17:15:00',4.1),('11288','2013-06-16','17:20:00',3.98),('11288','2013-06-16','17:25:00',3.88),('11288','2013-06-16','17:30:00',3.76),('11288','2013-06-16','17:35:00',3.72),('11288','2013-06-16','17:40:00',3.54),('11288','2013-06-16','17:45:00',3.34),('11288','2013-06-16','17:50:00',3.21),('11288','2013-06-16','17:55:00',3.11),('11288','2013-06-16','18:00:00',3.01),('11288','2013-06-16','18:05:00',2.86),('11288','2013-06-16','18:10:00',2.74),('11288','2013-06-16','18:15:00',2.61),('11288','2013-06-16','18:20:00',2.48),('11288','2013-06-16','18:25:00',2.31),('11288','2013-06-16','18:30:00',2.22),('11288','2013-06-16','18:35:00',2.1),('11288','2013-06-16','18:40:00',1.97),('11288','2013-06-16','18:45:00',1.85),('11288','2013-06-16','18:50:00',1.7),('11288','2013-06-16','18:55:00',1.59),('11288','2013-06-16','19:00:00',1.48),('11288','2013-06-16','19:05:00',1.35),('11288','2013-06-16','19:10:00',1.2),('11288','2013-06-16','19:15:00',1.08),('11288','2013-06-15','07:15:00',1.11),('11288','2013-06-15','07:20:00',1.21),('11288','2013-06-15','07:25:00',1.3),('11288','2013-06-15','07:30:00',1.41),('11288','2013-06-15','07:35:00',1.5),('11288','2013-06-15','07:40:00',1.54),('11288','2013-06-15','07:45:00',1.67),('11288','2013-06-15','07:50:00',1.82),('11288','2013-06-15','07:55:00',1.97),('11288','2013-06-15','08:00:00',2.22),('11288','2013-06-15','08:05:00',2.25),('11288','2013-06-15','08:10:00',2.33),('11288','2013-06-15','08:15:00',2.53),('11288','2013-06-15','08:20:00',2.6),('11288','2013-06-15','08:25:00',2.69),('11288','2013-06-15','08:30:00',2.91),('11288','2013-06-15','08:35:00',2.94),('11288','2013-06-15','08:40:00',3.01),('11288','2013-06-15','08:45:00',3.26),('11288','2013-06-15','08:50:00',3.47),('11288','2013-06-15','08:55:00',3.33),('11288','2013-06-15','09:00:00',3.38),('11288','2013-06-15','09:05:00',3.5),('11288','2013-06-15','09:10:00',3.82),('11288','2013-06-15','09:15:00',4.15),('11288','2013-06-15','09:20:00',4.38),('11288','2013-06-15','09:25:00',4.27),('11288','2013-06-15','09:30:00',4.29),('11288','2013-06-15','09:35:00',4.69),('11288','2013-06-15','09:40:00',4.52),('11288','2013-06-15','09:45:00',4.64),('11288','2013-06-15','09:50:00',4.89),('11288','2013-06-15','09:55:00',4.23),('11288','2013-06-15','10:00:00',4.36),('11288','2013-06-15','10:05:00',5.34),('11288','2013-06-15','10:10:00',5.59),('11288','2013-06-15','10:15:00',5.72),('11288','2013-06-15','10:20:00',4.27),('11288','2013-06-15','10:25:00',5.89),('11288','2013-06-15','10:30:00',5.96),('11288','2013-06-15','10:35:00',5.65),('11288','2013-06-15','10:40:00',5.6),('11288','2013-06-15','10:45:00',5.3),('11288','2013-06-15','10:50:00',4.76),('11288','2013-06-15','10:55:00',3.52),('11288','2013-06-15','11:00:00',6.67),('11288','2013-06-15','11:05:00',5.13),('11288','2013-06-15','11:10:00',4.92),('11288','2013-06-15','11:15:00',2.92),('11288','2013-06-15','11:20:00',3.79),('11288','2013-06-15','11:25:00',6.95),('11288','2013-06-15','11:30:00',6.74),('11288','2013-06-15','11:35:00',6.87),('11288','2013-06-15','11:40:00',6.91),('11288','2013-06-15','11:45:00',6.49),('11288','2013-06-15','11:50:00',6.93),('11288','2013-06-15','11:55:00',6.39),('11288','2013-06-15','12:00:00',3.98),('11288','2013-06-15','12:05:00',6.89),('11288','2013-06-15','12:10:00',7.05),('11288','2013-06-15','12:15:00',7.02),('11288','2013-06-15','12:20:00',7),('11288','2013-06-15','12:25:00',6.93),('11288','2013-06-15','12:30:00',6.96),('11288','2013-06-15','12:35:00',6.98),('11288','2013-06-15','12:40:00',7.03),('11288','2013-06-15','12:45:00',6.96),('11288','2013-06-15','12:50:00',7),('11288','2013-06-15','12:55:00',7.03),('11288','2013-06-15','13:00:00',6.99),('11288','2013-06-15','13:05:00',7.01),('11288','2013-06-15','13:10:00',7),('11288','2013-06-15','13:15:00',6.98),('11288','2013-06-15','13:20:00',6.9),('11288','2013-06-15','13:25:00',6.95),('11288','2013-06-15','13:30:00',6.89),('11288','2013-06-15','13:35:00',6.9),('11288','2013-06-15','13:40:00',6.94),('11288','2013-06-15','13:45:00',6.92),('11288','2013-06-15','13:50:00',6.86),('11288','2013-06-15','13:55:00',6.89),('11288','2013-06-15','14:00:00',6.86),('11288','2013-06-15','14:05:00',6.82),('11288','2013-06-15','14:10:00',6.82),('11288','2013-06-15','14:15:00',6.79),('11288','2013-06-15','14:20:00',6.77),('11288','2013-06-15','14:25:00',6.65),('11288','2013-06-15','14:30:00',6.66),('11288','2013-06-15','14:35:00',6.6),('11288','2013-06-15','14:40:00',6.67),('11288','2013-06-15','14:45:00',6.52),('11288','2013-06-15','14:50:00',6.57),('11288','2013-06-15','14:55:00',6.48),('11288','2013-06-15','15:00:00',6.37),('11288','2013-06-15','15:05:00',6.36),('11288','2013-06-15','15:10:00',6.37),('11288','2013-06-15','15:15:00',6.39),('11288','2013-06-15','15:20:00',6.33),('11288','2013-06-15','15:25:00',6.3),('11288','2013-06-15','15:30:00',6.23),('11288','2013-06-15','15:35:00',6.17),('11288','2013-06-15','15:40:00',6.06),('11288','2013-06-15','15:45:00',5.97),('11288','2013-06-15','15:50:00',5.88),('11288','2013-06-15','15:55:00',5.81),('11288','2013-06-15','16:00:00',5.72),('11288','2013-06-15','16:05:00',5.63),('11288','2013-06-15','16:10:00',5.55),('11288','2013-06-15','16:15:00',5.44),('11288','2013-06-15','16:20:00',5.32),('11288','2013-06-15','16:25:00',5.24),('11288','2013-06-15','16:30:00',5.16),('11288','2013-06-15','16:35:00',5.01),('11288','2013-06-15','16:40:00',4.87),('11288','2013-06-15','16:45:00',4.79),('11288','2013-06-15','16:50:00',4.66),('11288','2013-06-15','16:55:00',4.59),('11288','2013-06-15','17:00:00',4.47),('11288','2013-06-15','17:05:00',4.32),('11288','2013-06-15','17:10:00',4.22),('11288','2013-06-15','17:15:00',4.09),('11288','2013-06-15','17:20:00',3.97),('11288','2013-06-15','17:25:00',3.85),('11288','2013-06-15','17:30:00',3.72),('11288','2013-06-15','17:35:00',3.66),('11288','2013-06-15','17:40:00',3.53),('11288','2013-06-15','17:45:00',3.32),('11288','2013-06-15','17:50:00',3.18),('11288','2013-06-15','17:55:00',3.08),('11288','2013-06-15','18:00:00',2.99),('11288','2013-06-15','18:05:00',2.81),('11288','2013-06-15','18:10:00',2.69),('11288','2013-06-15','18:15:00',2.55),('11288','2013-06-15','18:20:00',2.44),('11288','2013-06-15','18:25:00',2.24),('11288','2013-06-15','18:30:00',2.14),('11288','2013-06-15','18:35:00',2.01),('11288','2013-06-15','18:40:00',1.92),('11288','2013-06-15','18:45:00',1.79),('11288','2013-06-15','18:50:00',1.66),('11288','2013-06-15','18:55:00',1.55),('11288','2013-06-15','19:00:00',1.44),('11288','2013-06-15','19:05:00',1.31),('11288','2013-06-15','19:10:00',1.17),('11288','2013-06-15','19:15:00',1.06),('11288','2013-06-14','07:15:00',1.08),('11288','2013-06-14','07:20:00',1.18),('11288','2013-06-14','07:25:00',1.27),('11288','2013-06-14','07:30:00',1.42),('11288','2013-06-14','07:35:00',1.46),('11288','2013-06-14','07:40:00',1.55),('11288','2013-06-14','07:45:00',1.67),('11288','2013-06-14','07:50:00',1.81),('11288','2013-06-14','07:55:00',1.84),('11288','2013-06-14','08:00:00',2.27),('11288','2013-06-14','08:05:00',2.32),('11288','2013-06-14','08:10:00',2.48),('11288','2013-06-14','08:15:00',2.72),('11288','2013-06-14','08:20:00',2.8),('11288','2013-06-14','08:25:00',2.96),('11288','2013-06-14','08:30:00',3.1),('11288','2013-06-14','08:35:00',3.21),('11288','2013-06-14','08:40:00',3.37),('11288','2013-06-14','08:45:00',3.6),('11288','2013-06-14','08:50:00',3.69),('11288','2013-06-14','08:55:00',3.78),('11288','2013-06-14','09:00:00',3.98),('11288','2013-06-14','09:05:00',4.12),('11288','2013-06-14','09:10:00',4.05),('11288','2013-06-14','09:15:00',4.22),('11288','2013-06-14','09:20:00',4.38),('11288','2013-06-14','09:25:00',4.1),('11288','2013-06-14','09:30:00',4.34),('11288','2013-06-14','09:35:00',4.81),('11288','2013-06-14','09:40:00',4.99),('11288','2013-06-14','09:45:00',5.14),('11288','2013-06-14','09:50:00',5.21),('11288','2013-06-14','09:55:00',5.03),('11288','2013-06-14','10:00:00',5.26),('11288','2013-06-14','10:05:00',5.53),('11288','2013-06-14','10:10:00',5.63),('11288','2013-06-14','10:15:00',5.74),('11288','2013-06-14','10:20:00',5.82),('11288','2013-06-14','10:25:00',5.9),('11288','2013-06-14','10:30:00',5.79),('11288','2013-06-14','10:35:00',6.18),('11288','2013-06-14','10:40:00',6.21),('11288','2013-06-14','10:45:00',6.25),('11288','2013-06-14','10:50:00',6.33),('11288','2013-06-14','10:55:00',6.35),('11288','2013-06-14','11:00:00',6.31),('11288','2013-06-14','11:05:00',6.36),('11288','2013-06-14','11:10:00',6.45),('11288','2013-06-14','11:15:00',6.57),('11288','2013-06-14','11:20:00',6.57),('11288','2013-06-14','11:25:00',6.41),('11288','2013-06-14','11:30:00',6.74),('11288','2013-06-14','11:35:00',6.77),('11288','2013-06-14','11:40:00',6.8),('11288','2013-06-14','11:45:00',6.79),('11288','2013-06-14','11:50:00',6.86),('11288','2013-06-14','11:55:00',6.91),('11288','2013-06-14','12:00:00',6.87),('11288','2013-06-14','12:05:00',6.86),('11288','2013-06-14','12:10:00',6.82),('11288','2013-06-14','12:15:00',6.84),('11288','2013-06-14','12:20:00',6.86),('11288','2013-06-14','12:25:00',6.76),('11288','2013-06-14','12:30:00',6.88),('11288','2013-06-14','12:35:00',7.02),('11288','2013-06-14','12:40:00',6.93),('11288','2013-06-14','12:45:00',7.03),('11288','2013-06-14','12:50:00',6.96),('11288','2013-06-14','12:55:00',6.98),('11288','2013-06-14','13:00:00',7.02),('11288','2013-06-14','13:05:00',7.11),('11288','2013-06-14','13:10:00',7.12),('11288','2013-06-14','13:15:00',7.08),('11288','2013-06-14','13:20:00',7.09),('11288','2013-06-14','13:25:00',7.16),('11288','2013-06-14','13:30:00',7.02),('11288','2013-06-14','13:35:00',7.05),('11288','2013-06-14','13:40:00',6.95),('11288','2013-06-14','13:45:00',6.93),('11288','2013-06-14','13:50:00',7.03),('11288','2013-06-14','13:55:00',6.97),('11288','2013-06-14','14:00:00',6.85),('11288','2013-06-14','14:05:00',6.86),('11288','2013-06-14','14:10:00',6.93),('11288','2013-06-14','14:15:00',6.78),('11288','2013-06-14','14:20:00',6.72),('11288','2013-06-14','14:25:00',6.73),('11288','2013-06-14','14:30:00',6.77),('11288','2013-06-14','14:35:00',6.77),('11288','2013-06-14','14:40:00',6.73),('11288','2013-06-14','14:45:00',6.63),('11288','2013-06-14','14:50:00',6.6),('11288','2013-06-14','14:55:00',6.62),('11288','2013-06-14','15:00:00',6.59),('11288','2013-06-14','15:05:00',6.53),('11288','2013-06-14','15:10:00',6.46),('11288','2013-06-14','15:15:00',6.41),('11288','2013-06-14','15:20:00',6.38),('11288','2013-06-14','15:25:00',6.35),('11288','2013-06-14','15:30:00',6.29),('11288','2013-06-14','15:35:00',6.23),('11288','2013-06-14','15:40:00',6.17),('11288','2013-06-14','15:45:00',6.1),('11288','2013-06-14','15:50:00',6.05),('11288','2013-06-14','15:55:00',5.95),('11288','2013-06-14','16:00:00',5.86),('11288','2013-06-14','16:05:00',5.8),('11288','2013-06-14','16:10:00',5.69),('11288','2013-06-14','16:15:00',5.56),('11288','2013-06-14','16:20:00',5.46),('11288','2013-06-14','16:25:00',5.36),('11288','2013-06-14','16:30:00',5.23),('11288','2013-06-14','16:35:00',5.02),('11288','2013-06-14','16:40:00',4.92),('11288','2013-06-14','16:45:00',4.85),('11288','2013-06-14','16:50:00',4.72),('11288','2013-06-14','16:55:00',4.64),('11288','2013-06-14','17:00:00',4.53),('11288','2013-06-14','17:05:00',4.27),('11288','2013-06-14','17:10:00',4.23),('11288','2013-06-14','17:15:00',4.21),('11288','2013-06-14','17:20:00',4.07),('11288','2013-06-14','17:25:00',3.93),('11288','2013-06-14','17:30:00',3.71),('11288','2013-06-14','17:35:00',3.77),('11288','2013-06-14','17:40:00',3.7),('11288','2013-06-14','17:45:00',3.52),('11288','2013-06-14','17:50:00',3.39),('11288','2013-06-14','17:55:00',3.25),('11288','2013-06-14','18:00:00',3.09),('11288','2013-06-14','18:05:00',3),('11288','2013-06-14','18:10:00',2.86),('11288','2013-06-14','18:15:00',2.73),('11288','2013-06-14','18:20:00',2.59),('11288','2013-06-14','18:25:00',2.4),('11288','2013-06-14','18:30:00',2.32),('11288','2013-06-14','18:35:00',2.18),('11288','2013-06-14','18:40:00',2.07),('11288','2013-06-14','18:45:00',1.94),('11288','2013-06-14','18:50:00',1.79),('11288','2013-06-14','18:55:00',1.66),('11288','2013-06-14','19:00:00',1.56),('11288','2013-06-14','19:05:00',1.41),('11288','2013-06-14','19:10:00',1.24),('11288','2013-06-14','19:15:00',1.13),('11288','2013-06-14','19:20:00',1.03),('11288','2013-06-13','07:15:00',1.1),('11288','2013-06-13','07:20:00',1.2),('11288','2013-06-13','07:25:00',1.25),('11288','2013-06-13','07:30:00',1.43),('11288','2013-06-13','07:35:00',1.55),('11288','2013-06-13','07:40:00',1.54),('11288','2013-06-13','07:45:00',1.69),('11288','2013-06-13','07:50:00',1.91),('11288','2013-06-13','07:55:00',1.86),('11288','2013-06-13','08:00:00',2.32),('11288','2013-06-13','08:05:00',2.36),('11288','2013-06-13','08:10:00',2.42),('11288','2013-06-13','08:15:00',2.61),('11288','2013-06-13','08:20:00',2.81),('11288','2013-06-13','08:25:00',2.85),('11288','2013-06-13','08:30:00',3.06),('11288','2013-06-13','08:35:00',3.25),('11288','2013-06-13','08:40:00',3.25),('11288','2013-06-13','08:45:00',3.54),('11288','2013-06-13','08:50:00',3.82),('11288','2013-06-13','08:55:00',3.77),('11288','2013-06-13','09:00:00',3.92),('11288','2013-06-13','09:05:00',4.17),('11288','2013-06-13','09:10:00',4.09),('11288','2013-06-13','09:15:00',4.23),('11288','2013-06-13','09:20:00',4.52),('11288','2013-06-13','09:25:00',4.52),('11288','2013-06-13','09:30:00',4.57),('11288','2013-06-13','09:35:00',4.95),('11288','2013-06-13','09:40:00',5.14),('11288','2013-06-13','09:45:00',5.27),('11288','2013-06-13','09:50:00',5.38),('11288','2013-06-13','09:55:00',5.29),('11288','2013-06-13','10:00:00',5.41),('11288','2013-06-13','10:05:00',5.74),('11288','2013-06-13','10:10:00',5.84),('11288','2013-06-13','10:15:00',5.94),('11288','2013-06-13','10:20:00',6.1),('11288','2013-06-13','10:25:00',6.14),('11288','2013-06-13','10:30:00',6.19),('11288','2013-06-13','10:35:00',6.31),('11288','2013-06-13','10:40:00',6.32),('11288','2013-06-13','10:45:00',6.42),('11288','2013-06-13','10:50:00',6.58),('11288','2013-06-13','10:55:00',6.63),('11288','2013-06-13','11:00:00',6.67),('11288','2013-06-13','11:05:00',6.67),('11288','2013-06-13','11:10:00',6.76),('11288','2013-06-13','11:15:00',6.83),('11288','2013-06-13','11:20:00',6.84),('11288','2013-06-13','11:25:00',6.92),('11288','2013-06-13','11:30:00',6.98),('11288','2013-06-13','11:35:00',7.04),('11288','2013-06-13','11:40:00',7.1),('11288','2013-06-13','11:45:00',7.14),('11288','2013-06-13','11:50:00',7.22),('11288','2013-06-13','11:55:00',7.17),('11288','2013-06-13','12:00:00',7.13),('11288','2013-06-13','12:05:00',7.21),('11288','2013-06-13','12:10:00',7.32),('11288','2013-06-13','12:15:00',7.27),('11288','2013-06-13','12:20:00',7.24),('11288','2013-06-13','12:25:00',7.27),('11288','2013-06-13','12:30:00',7.31),('11288','2013-06-13','12:35:00',7.32),('11288','2013-06-13','12:40:00',7.33),('11288','2013-06-13','12:45:00',7.36),('11288','2013-06-13','12:50:00',7.36),('11288','2013-06-13','12:55:00',7.32),('11288','2013-06-13','13:00:00',7.34),('11288','2013-06-13','13:05:00',7.38),('11288','2013-06-13','13:10:00',7.33),('11288','2013-06-13','13:15:00',7.34),('11288','2013-06-13','13:20:00',7.29),('11288','2013-06-13','13:25:00',7.3),('11288','2013-06-13','13:30:00',7.24),('11288','2013-06-13','13:35:00',7.28),('11288','2013-06-13','13:40:00',7.27),('11288','2013-06-13','13:45:00',7.22),('11288','2013-06-13','13:50:00',7.23),('11288','2013-06-13','13:55:00',7.14),('11288','2013-06-13','14:00:00',7.16),('11288','2013-06-13','14:05:00',7.16),('11288','2013-06-13','14:10:00',7.17),('11288','2013-06-13','14:15:00',7.16),('11288','2013-06-13','14:20:00',7.15),('11288','2013-06-13','14:25:00',7.07),('11288','2013-06-13','14:30:00',5.74),('11288','2013-06-13','14:35:00',5.27),('11288','2013-06-13','14:40:00',7.15),('11288','2013-06-13','14:45:00',7.05),('11288','2013-06-13','14:50:00',6.86),('11288','2013-06-13','14:55:00',6.73),('11288','2013-06-13','15:00:00',6.75),('11288','2013-06-13','15:05:00',6.69),('11288','2013-06-13','15:10:00',6.56),('11288','2013-06-13','15:15:00',6.57),('11288','2013-06-13','15:20:00',6.44),('11288','2013-06-13','15:25:00',6.4),('11288','2013-06-13','15:30:00',6.34),('11288','2013-06-13','15:35:00',6.25),('11288','2013-06-13','15:40:00',6.17),('11288','2013-06-13','15:45:00',6.11),('11288','2013-06-13','15:50:00',6),('11288','2013-06-13','15:55:00',5.93),('11288','2013-06-13','16:00:00',5.86),('11288','2013-06-13','16:05:00',5.77),('11288','2013-06-13','16:10:00',5.68),('11288','2013-06-13','16:15:00',5.57),('11288','2013-06-13','16:20:00',5.45),('11288','2013-06-13','16:25:00',5.34),('11288','2013-06-13','16:30:00',5.24),('11288','2013-06-13','16:35:00',5.09),('11288','2013-06-13','16:40:00',4.92),('11288','2013-06-13','16:45:00',4.82),('11288','2013-06-13','16:50:00',4.67),('11288','2013-06-13','16:55:00',4.59),('11288','2013-06-13','17:00:00',4.49),('11288','2013-06-13','17:05:00',4.4),('11288','2013-06-13','17:10:00',4.3),('11288','2013-06-13','17:15:00',4.16),('11288','2013-06-13','17:20:00',4.09),('11288','2013-06-13','17:25:00',3.98),('11288','2013-06-13','17:30:00',3.84),('11288','2013-06-13','17:35:00',3.81),('11288','2013-06-13','17:40:00',3.63),('11288','2013-06-13','17:45:00',3.48),('11288','2013-06-13','17:50:00',3.35),('11288','2013-06-13','17:55:00',3.22),('11288','2013-06-13','18:00:00',3.07),('11288','2013-06-13','18:05:00',2.93),('11288','2013-06-13','18:10:00',2.78),('11288','2013-06-13','18:15:00',2.67),('11288','2013-06-13','18:20:00',2.58),('11288','2013-06-13','18:25:00',2.39),('11288','2013-06-13','18:30:00',2.29),('11288','2013-06-13','18:35:00',2.15),('11288','2013-06-13','18:40:00',2),('11288','2013-06-13','18:45:00',1.89),('11288','2013-06-13','18:50:00',1.75),('11288','2013-06-13','18:55:00',1.62),('11288','2013-06-13','19:00:00',1.51),('11288','2013-06-13','19:05:00',1.37),('11288','2013-06-13','19:10:00',1.22),('11288','2013-06-13','19:15:00',1.11),('11288','2013-06-12','07:10:00',1.01),('11288','2013-06-12','07:15:00',1.13),('11288','2013-06-12','07:20:00',1.27),('11288','2013-06-12','07:25:00',1.29),('11288','2013-06-12','07:30:00',1.45),('11288','2013-06-12','07:35:00',1.56),('11288','2013-06-12','07:40:00',1.57),('11288','2013-06-12','07:45:00',1.67),('11288','2013-06-12','07:50:00',1.95),('11288','2013-06-12','07:55:00',1.93),('11288','2013-06-12','08:00:00',2.28),('11288','2013-06-12','08:05:00',2.37),('11288','2013-06-12','08:10:00',2.48),('11288','2013-06-12','08:15:00',2.61),('11288','2013-06-12','08:20:00',2.96),('11288','2013-06-12','08:25:00',2.99),('11288','2013-06-12','08:30:00',3.23),('11288','2013-06-12','08:35:00',3.37),('11288','2013-06-12','08:40:00',3.36),('11288','2013-06-12','08:45:00',3.63),('11288','2013-06-12','08:50:00',3.95),('11288','2013-06-12','08:55:00',3.9),('11288','2013-06-12','09:00:00',4.05),('11288','2013-06-12','09:05:00',4.24),('11288','2013-06-12','09:10:00',4.22),('11288','2013-06-12','09:15:00',4.33),('11288','2013-06-12','09:20:00',4.63),('11288','2013-06-12','09:25:00',4.63),('11288','2013-06-12','09:30:00',4.7),('11288','2013-06-12','09:35:00',4.97),('11288','2013-06-12','09:40:00',5.16),('11288','2013-06-12','09:45:00',5.31),('11288','2013-06-12','09:50:00',5.47),('11288','2013-06-12','09:55:00',5.54),('11288','2013-06-12','10:00:00',5.67),('11288','2013-06-12','10:05:00',5.75),('11288','2013-06-12','10:10:00',5.83),('11288','2013-06-12','10:15:00',5.95),('11288','2013-06-12','10:20:00',6.11),('11288','2013-06-12','10:25:00',6.21),('11288','2013-06-12','10:30:00',6.25),('11288','2013-06-12','10:35:00',6.34),('11288','2013-06-12','10:40:00',6.37),('11288','2013-06-12','10:45:00',6.44),('11288','2013-06-12','10:50:00',6.63),('11288','2013-06-12','10:55:00',6.71),('11288','2013-06-12','11:00:00',6.81),('11288','2013-06-12','11:05:00',6.88),('11288','2013-06-12','11:10:00',6.94),('11288','2013-06-12','11:15:00',7),('11288','2013-06-12','11:20:00',7.02),('11288','2013-06-12','11:25:00',7.01),('11288','2013-06-12','11:30:00',7.04),('11288','2013-06-12','11:35:00',7.02),('11288','2013-06-12','11:40:00',7.09),('11288','2013-06-12','11:45:00',7.14),('11288','2013-06-12','11:50:00',7.11),('11288','2013-06-12','11:55:00',7.2),('11288','2013-06-12','12:00:00',7.18),('11288','2013-06-12','12:05:00',7.19),('11288','2013-06-12','12:10:00',7.23),('11288','2013-06-12','12:15:00',7.27),('11288','2013-06-12','12:20:00',7.55),('11288','2013-06-12','12:25:00',5.94),('11288','2013-06-12','12:30:00',2.94),('11288','2013-06-12','12:35:00',7.9),('11288','2013-06-12','12:40:00',7.64),('11288','2013-06-12','12:45:00',2.63),('11288','2013-06-12','12:50:00',2.64),('11288','2013-06-12','12:55:00',3.79),('11288','2013-06-12','13:00:00',6.87),('11288','2013-06-12','13:05:00',2.58),('11288','2013-06-12','13:10:00',7.57),('11288','2013-06-12','13:15:00',7.61),('11288','2013-06-12','13:20:00',7.48),('11288','2013-06-12','13:25:00',7.34),('11288','2013-06-12','13:30:00',7.27),('11288','2013-06-12','13:35:00',7.3),('11288','2013-06-12','13:40:00',7.44),('11288','2013-06-12','13:45:00',6.86),('11288','2013-06-12','13:50:00',7.38),('11288','2013-06-12','13:55:00',7.56),('11288','2013-06-12','14:00:00',5.52),('11288','2013-06-12','14:05:00',5.09),('11288','2013-06-12','14:10:00',1.97),('11288','2013-06-12','14:15:00',7.05),('11288','2013-06-12','14:20:00',4.7),('11288','2013-06-12','14:25:00',5.19),('11288','2013-06-12','14:30:00',6.57),('11288','2013-06-12','14:35:00',6.14),('11288','2013-06-12','14:40:00',6.72),('11288','2013-06-12','14:45:00',7.29),('11288','2013-06-12','14:50:00',7.27),('11288','2013-06-12','14:55:00',7.18),('11288','2013-06-12','15:00:00',7.05),('11288','2013-06-12','15:05:00',6.98),('11288','2013-06-12','15:10:00',6.88),('11288','2013-06-12','15:15:00',6.03),('11288','2013-06-12','15:20:00',6.84),('11288','2013-06-12','15:25:00',6.52),('11288','2013-06-12','15:30:00',6.52),('11288','2013-06-12','15:35:00',6.5),('11288','2013-06-12','15:40:00',6.47),('11288','2013-06-12','15:45:00',6.38),('11288','2013-06-12','15:50:00',6.23),('11288','2013-06-12','15:55:00',6.26),('11288','2013-06-12','16:00:00',6.28),('11288','2013-06-12','16:05:00',5.98),('11288','2013-06-12','16:10:00',5.91),('11288','2013-06-12','16:15:00',5.78),('11288','2013-06-12','16:20:00',5.58),('11288','2013-06-12','16:25:00',5.6),('11288','2013-06-12','16:30:00',5.08),('11288','2013-06-12','16:35:00',5.04),('11288','2013-06-12','16:40:00',5.26),('11288','2013-06-12','16:45:00',4.13),('11288','2013-06-12','16:50:00',5.03),('11288','2013-06-12','16:55:00',4.19),('11288','2013-06-12','17:00:00',4.64),('11288','2013-06-12','17:05:00',4.55),('11288','2013-06-12','17:10:00',4.48),('11288','2013-06-12','17:15:00',4.34),('11288','2013-06-12','17:20:00',4.22),('11288','2013-06-12','17:25:00',4.06),('11288','2013-06-12','17:30:00',3.91),('11288','2013-06-12','17:35:00',3.96),('11288','2013-06-12','17:40:00',3.86),('11288','2013-06-12','17:45:00',1.71),('11288','2013-06-12','18:05:00',2.19),('11288','2013-06-12','18:10:00',2.97),('11288','2013-06-12','18:15:00',2.89),('11288','2013-06-12','18:20:00',2.77),('11288','2013-06-12','18:25:00',2.42),('11288','2013-06-12','18:30:00',2.36),('11288','2013-06-12','18:35:00',2.18),('11288','2013-06-12','18:40:00',2.03),('11288','2013-06-12','18:45:00',1.91),('11288','2013-06-12','18:50:00',1.78),('11288','2013-06-12','18:55:00',1.66),('11288','2013-06-12','19:00:00',1.55),('11288','2013-06-12','19:05:00',1.4),('11288','2013-06-11','07:10:00',1.01),('11288','2013-06-11','07:15:00',1.05),('11288','2013-06-11','07:20:00',1.2),('11288','2013-06-11','07:25:00',1.36),('11288','2013-06-11','07:30:00',1.46),('11288','2013-06-11','07:35:00',1.54),('11288','2013-06-11','07:40:00',1.51),('11288','2013-06-11','07:45:00',1.27),('11288','2013-06-11','07:50:00',2.02),('11288','2013-06-11','07:55:00',2.19),('11288','2013-06-11','08:00:00',2.47),('11288','2013-06-11','08:05:00',2.82),('11288','2013-06-11','08:10:00',2.81),('11288','2013-06-11','08:15:00',1.9),('11288','2013-06-11','08:20:00',2.61),('11288','2013-06-11','08:25:00',3.45),('11288','2013-06-11','08:30:00',3.53),('11288','2013-06-11','08:35:00',3.56),('11288','2013-06-11','08:40:00',3.61),('11288','2013-06-11','08:45:00',2.51),('11288','2013-06-11','08:50:00',1.26),('11288','2013-06-11','08:55:00',3.62),('11288','2013-06-11','09:00:00',2.58),('11288','2013-06-11','09:05:00',4.07),('11288','2013-06-11','09:10:00',4.7),('11288','2013-06-11','09:15:00',4.78),('11288','2013-06-11','09:20:00',4.93),('11288','2013-06-11','09:25:00',3.08),('11288','2013-06-11','09:30:00',4.36),('11288','2013-06-11','09:35:00',2.27),('11288','2013-06-11','09:40:00',4.32),('11288','2013-06-11','09:45:00',5.62),('11288','2013-06-11','09:50:00',5.64),('11288','2013-06-11','09:55:00',5.8),('11288','2013-06-11','10:00:00',4.53),('11288','2013-06-11','10:05:00',4.63),('11288','2013-06-11','10:10:00',6.11),('11288','2013-06-11','10:15:00',6.32),('11288','2013-06-11','10:20:00',6.5),('11288','2013-06-11','10:25:00',4.65),('11288','2013-06-11','10:30:00',6.54),('11288','2013-06-11','10:35:00',6.57),('11288','2013-06-11','10:40:00',6.58),('11288','2013-06-11','10:45:00',6.69),('11288','2013-06-11','10:50:00',4.03),('11288','2013-06-11','10:55:00',2.59),('11288','2013-06-11','11:00:00',7.37),('11288','2013-06-11','11:05:00',5.35),('11288','2013-06-11','11:10:00',5.21),('11288','2013-06-11','11:15:00',7.32),('11288','2013-06-11','11:20:00',7.12),('11288','2013-06-11','11:25:00',7.16),('11288','2013-06-11','11:30:00',7.18),('11288','2013-06-11','11:35:00',7.17),('11288','2013-06-11','11:40:00',7.22),('11288','2013-06-11','11:45:00',7.25),('11288','2013-06-11','11:50:00',7.33),('11288','2013-06-11','11:55:00',7.36),('11288','2013-06-11','12:00:00',7.38),('11288','2013-06-11','12:05:00',7.45),('11288','2013-06-11','12:10:00',7.39),('11288','2013-06-11','12:15:00',7.4),('11288','2013-06-11','12:20:00',7.49),('11288','2013-06-11','12:25:00',7.44),('11288','2013-06-11','12:30:00',7.45),('11288','2013-06-11','12:35:00',7.48),('11288','2013-06-11','12:40:00',7.53),('11288','2013-06-11','12:45:00',7.57),('11288','2013-06-11','12:50:00',7.7),('11288','2013-06-11','12:55:00',7.55),('11288','2013-06-11','13:00:00',7.58),('11288','2013-06-11','13:05:00',7.66),('11288','2013-06-11','13:10:00',7.59),('11288','2013-06-11','13:15:00',7.64),('11288','2013-06-11','13:20:00',7.6),('11288','2013-06-11','13:25:00',7.58),('11288','2013-06-11','13:30:00',7.61),('11288','2013-06-11','13:35:00',7.4),('11288','2013-06-11','13:40:00',7.69),('11288','2013-06-11','13:45:00',6.58),('11288','2013-06-11','13:50:00',7.84),('11288','2013-06-11','13:55:00',7.53),('11288','2013-06-11','14:00:00',7.5),('11288','2013-06-11','14:05:00',7.44),('11288','2013-06-11','14:10:00',7.43),('11288','2013-06-11','14:15:00',7.36),('11288','2013-06-11','14:20:00',7.31),('11288','2013-06-11','14:25:00',7.3),('11288','2013-06-11','14:30:00',7.27),('11288','2013-06-11','14:35:00',7.17),('11288','2013-06-11','14:40:00',7.12),('11288','2013-06-11','14:45:00',7.08),('11288','2013-06-11','14:50:00',7.04),('11288','2013-06-11','14:55:00',7.02),('11288','2013-06-11','15:00:00',6.99),('11288','2013-06-11','15:05:00',6.94),('11288','2013-06-11','15:10:00',6.89),('11288','2013-06-11','15:15:00',6.8),('11288','2013-06-11','15:20:00',6.76),('11288','2013-06-11','15:25:00',6.66),('11288','2013-06-11','15:30:00',6.65),('11288','2013-06-11','15:35:00',6.59),('11288','2013-06-11','15:40:00',6.65),('11288','2013-06-11','15:45:00',6.58),('11288','2013-06-11','15:50:00',6.31),('11288','2013-06-11','15:55:00',6.32),('11288','2013-06-11','16:00:00',6.24),('11288','2013-06-11','16:05:00',6.17),('11288','2013-06-11','16:10:00',6),('11288','2013-06-11','16:15:00',5.87),('11288','2013-06-11','16:20:00',5.81),('11288','2013-06-11','16:25:00',5.73),('11288','2013-06-11','16:30:00',5.65),('11288','2013-06-11','16:35:00',5.48),('11288','2013-06-11','16:40:00',5.47),('11288','2013-06-11','16:45:00',5.73),('11288','2013-06-11','16:50:00',5.73),('11288','2013-06-11','16:55:00',5.52),('11288','2013-06-11','17:00:00',4.19),('11288','2013-06-11','17:05:00',3.01),('11288','2013-06-11','17:10:00',1.55),('11288','2013-06-11','17:15:00',1.28),('11288','2013-06-11','17:20:00',1.09),('11288','2013-06-11','19:15:00',1.04),('11288','2013-06-11','19:30:00',1.31),('11288','2013-06-11','19:35:00',1.05),('11288','2014-04-03','08:15:00',1.01),('11288','2014-04-03','08:20:00',1.1),('11288','2014-04-03','08:25:00',1.15),('11288','2014-04-03','08:30:00',1.24),('11288','2014-04-03','08:35:00',1.32),('11288','2014-04-03','08:40:00',1.46),('11288','2014-04-03','08:45:00',1.67),('11288','2014-04-03','08:50:00',1.7),('11288','2014-04-03','08:55:00',1.91),('11288','2014-04-03','09:00:00',2.09),('11288','2014-04-03','09:05:00',2.27),('11288','2014-04-03','09:10:00',2.2),('11288','2014-04-03','09:15:00',2.06),('11288','2014-04-03','09:20:00',2.08),('11288','2014-04-03','09:25:00',2.23),('11288','2014-04-03','09:30:00',2.61),('11288','2014-04-03','09:35:00',2.99),('11288','2014-04-03','09:40:00',3.09),('11288','2014-04-03','09:45:00',3.04),('11288','2014-04-03','09:50:00',2.91),('11288','2014-04-03','09:55:00',3.03),('11288','2014-04-03','10:00:00',3.6),('11288','2014-04-03','10:05:00',4.22),('11288','2014-04-03','10:10:00',4.48),('11288','2014-04-03','10:15:00',5.09),('11288','2014-04-03','10:20:00',5.14),('11288','2014-04-03','10:25:00',4.46),('11288','2014-04-03','10:30:00',4.41),('11288','2014-04-03','10:35:00',4.67),('11288','2014-04-03','10:40:00',3.74),('11288','2014-04-03','10:45:00',3.98),('11288','2014-04-03','10:50:00',3.5),('11288','2014-04-03','10:55:00',3.66),('11288','2014-04-03','11:00:00',3.41),('11288','2014-04-03','11:05:00',2.96),('11288','2014-04-03','11:10:00',2.82),('11288','2014-04-03','11:15:00',2.66),('11288','2014-04-03','11:20:00',2.54),('11288','2014-04-03','11:25:00',2.37),('11288','2014-04-03','11:30:00',2.36),('11288','2014-04-03','11:35:00',2.52),('11288','2014-04-03','11:40:00',2.75),('11288','2014-04-03','11:45:00',3.15),('11288','2014-04-03','11:50:00',3.83),('11288','2014-04-03','11:55:00',4.13),('11288','2014-04-03','12:00:00',3.95),('11288','2014-04-03','12:05:00',3.95),('11288','2014-04-03','12:10:00',3.83),('11288','2014-04-03','12:15:00',3.74),('11288','2014-04-03','12:20:00',4.23),('11288','2014-04-03','12:25:00',5.12),('11288','2014-04-03','12:30:00',6.36),('11288','2014-04-03','12:35:00',6.23),('11288','2014-04-03','12:40:00',6.8),('11288','2014-04-03','12:45:00',3.78),('11288','2014-04-03','12:50:00',4.74),('11288','2014-04-03','12:55:00',4.47),('11288','2014-04-03','13:00:00',4.43),('11288','2014-04-03','13:05:00',5.46),('11288','2014-04-03','13:10:00',4.62),('11288','2014-04-03','13:15:00',7.46),('11288','2014-04-03','13:20:00',4.27),('11288','2014-04-03','13:25:00',4.73),('11288','2014-04-03','13:30:00',4.89),('11288','2014-04-03','13:35:00',7.47),('11288','2014-04-03','13:40:00',6.23),('11288','2014-04-03','13:45:00',3.54),('11288','2014-04-03','13:50:00',3.6),('11288','2014-04-03','13:55:00',4.64),('11288','2014-04-03','14:00:00',6.14),('11288','2014-04-03','14:05:00',5.57),('11288','2014-04-03','14:10:00',4.44),('11288','2014-04-03','14:15:00',6.09),('11288','2014-04-03','14:20:00',6.03),('11288','2014-04-03','14:25:00',6.25),('11288','2014-04-03','14:30:00',6.34),('11288','2014-04-03','14:35:00',6.35),('11288','2014-04-03','14:40:00',6.13),('11288','2014-04-03','14:45:00',5.96),('11288','2014-04-03','14:50:00',5.87),('11288','2014-04-03','14:55:00',5.76),('11288','2014-04-03','15:00:00',5.66),('11288','2014-04-03','15:05:00',5.6),('11288','2014-04-03','15:10:00',5.58),('11288','2014-04-03','15:15:00',5.56),('11288','2014-04-03','15:20:00',5.52),('11288','2014-04-03','15:25:00',5.49),('11288','2014-04-03','15:30:00',5.39),('11288','2014-04-03','15:35:00',5.31),('11288','2014-04-03','15:40:00',5.28),('11288','2014-04-03','15:45:00',5.24),('11288','2014-04-03','15:50:00',5.1),('11288','2014-04-03','15:55:00',5.06),('11288','2014-04-03','16:00:00',5.02),('11288','2014-04-03','16:05:00',4.89),('11288','2014-04-03','16:10:00',4.8),('11288','2014-04-03','16:15:00',4.63),('11288','2014-04-03','16:20:00',4.54),('11288','2014-04-03','16:25:00',4.4),('11288','2014-04-03','16:30:00',4.21),('11288','2014-04-03','16:35:00',4.1),('11288','2014-04-03','16:40:00',4.02),('11288','2014-04-03','16:45:00',3.75),('11288','2014-04-03','16:50:00',2.79),('11288','2014-04-03','16:55:00',2.27),('11288','2014-04-03','17:00:00',1.81),('11288','2014-04-03','17:05:00',1.64),('11288','2014-04-03','17:10:00',1.5),('11288','2014-04-03','17:15:00',1.44),('11288','2014-04-03','17:20:00',1.59),('11288','2014-04-03','17:25:00',1.63),('11288','2014-04-03','17:30:00',1.51),('11288','2014-04-03','17:45:00',1.91),('11288','2014-04-03','17:50:00',2.05),('11288','2014-04-03','17:55:00',1.82),('11288','2014-04-03','18:00:00',1.64),('11288','2014-04-03','18:05:00',1.47),('11288','2014-04-03','18:10:00',1.33),('11288','2014-04-03','18:15:00',1.17),('11288','2013-06-10','07:20:00',1.03),('11288','2013-06-10','07:25:00',1.4),('11288','2013-06-10','07:30:00',1.72),('11288','2013-06-10','07:35:00',2.55),('11288','2013-06-10','07:40:00',1.65),('11288','2013-06-10','07:45:00',1.33),('11288','2013-06-10','07:50:00',1.35),('11288','2013-06-10','07:55:00',1.58),('11288','2013-06-10','08:00:00',2.03),('11288','2013-06-10','08:05:00',2.67),('11288','2013-06-10','08:10:00',3.44),('11288','2013-06-10','08:15:00',2.83),('11288','2013-06-10','08:20:00',2.51),('11288','2013-06-10','08:25:00',2.63),('11288','2013-06-10','08:30:00',2),('11288','2013-06-10','08:35:00',1.99),('11288','2013-06-10','08:40:00',2.59),('11288','2013-06-10','08:45:00',1.28),('11288','2013-06-10','08:50:00',1.42),('11288','2013-06-10','08:55:00',1.97),('11288','2013-06-10','09:00:00',2.06),('11288','2013-06-10','09:05:00',2.11),('11288','2013-06-10','09:10:00',2.31),('11288','2013-06-10','09:15:00',2.45),('11288','2013-06-10','09:20:00',4.44),('11288','2013-06-10','09:25:00',5.12),('11288','2013-06-10','09:30:00',4.1),('11288','2013-06-10','09:35:00',5.46),('11288','2013-06-10','09:40:00',4.42),('11288','2013-06-10','09:45:00',5.95),('11288','2013-06-10','09:50:00',3.1),('11288','2013-06-10','09:55:00',2.96),('11288','2013-06-10','10:00:00',3.85),('11288','2013-06-10','10:05:00',4.06),('11288','2013-06-10','10:10:00',3.39),('11288','2013-06-10','10:15:00',4.44),('11288','2013-06-10','10:20:00',3.91),('11288','2013-06-10','10:25:00',2.99),('11288','2013-06-10','10:30:00',2.55),('11288','2013-06-10','10:35:00',3.88),('11288','2013-06-10','10:40:00',2.61),('11288','2013-06-10','10:45:00',2.23),('11288','2013-06-10','10:50:00',3.49),('11288','2013-06-10','10:55:00',6.77),('11288','2013-06-10','11:00:00',3.7),('11288','2013-06-10','11:05:00',3.55),('11288','2013-06-10','11:10:00',5.42),('11288','2013-06-10','11:15:00',6.76),('11288','2013-06-10','11:20:00',6.8),('11288','2013-06-10','11:25:00',5.9),('11288','2013-06-10','11:30:00',7.53),('11288','2013-06-10','11:35:00',6.49),('11288','2013-06-10','11:40:00',5.28),('11288','2013-06-10','11:45:00',5.79),('11288','2013-06-10','11:50:00',3.53),('11288','2013-06-10','11:55:00',7.87),('11288','2013-06-10','12:00:00',5.94),('11288','2013-06-10','12:05:00',3),('11288','2013-06-10','12:10:00',8.52),('11288','2013-06-10','12:15:00',7.44),('11288','2013-06-10','12:20:00',7.78),('11288','2013-06-10','12:25:00',7.98),('11288','2013-06-10','12:30:00',6.68),('11288','2013-06-10','12:35:00',6.81),('11288','2013-06-10','12:40:00',5.57),('11288','2013-06-10','12:45:00',5.19),('11288','2013-06-10','12:50:00',5.82),('11288','2013-06-10','12:55:00',6.09),('11288','2013-06-10','13:00:00',8.46),('11288','2013-06-10','13:05:00',5.93),('11288','2013-06-10','13:10:00',4.8),('11288','2013-06-10','13:15:00',7.77),('11288','2013-06-10','13:20:00',7.91),('11288','2013-06-10','13:25:00',6.43),('11288','2013-06-10','13:30:00',6.64),('11288','2013-06-10','13:35:00',5.5),('11288','2013-06-10','13:40:00',6.27),('11288','2013-06-10','13:45:00',6.03),('11288','2013-06-10','13:50:00',5.89),('11288','2013-06-10','13:55:00',6.2),('11288','2013-06-10','14:00:00',6.52),('11288','2013-06-10','14:05:00',7.91),('11288','2013-06-10','14:10:00',7.91),('11288','2013-06-10','14:15:00',7.51),('11288','2013-06-10','14:20:00',7.45),('11288','2013-06-10','14:25:00',7.38),('11288','2013-06-10','14:30:00',7.07),('11288','2013-06-10','14:35:00',7.33),('11288','2013-06-10','14:40:00',6.32),('11288','2013-06-10','14:45:00',7.23),('11288','2013-06-10','14:50:00',7.14),('11288','2013-06-10','14:55:00',7.03),('11288','2013-06-10','15:00:00',6.99),('11288','2013-06-10','15:05:00',6.93),('11288','2013-06-10','15:10:00',6.85),('11288','2013-06-10','15:15:00',6.84),('11288','2013-06-10','15:20:00',6.8),('11288','2013-06-10','15:25:00',6.77),('11288','2013-06-10','15:30:00',6.7),('11288','2013-06-10','15:35:00',6.65),('11288','2013-06-10','15:40:00',6.56),('11288','2013-06-10','15:45:00',6.48),('11288','2013-06-10','15:50:00',6.38),('11288','2013-06-10','15:55:00',6.29),('11288','2013-06-10','16:00:00',6.16),('11288','2013-06-10','16:05:00',6.1),('11288','2013-06-10','16:10:00',6.05),('11288','2013-06-10','16:15:00',5.9),('11288','2013-06-10','16:20:00',5.75),('11288','2013-06-10','16:25:00',5.71),('11288','2013-06-10','16:30:00',5.62),('11288','2013-06-10','16:35:00',5.46),('11288','2013-06-10','16:40:00',5.31),('11288','2013-06-10','16:45:00',5.23),('11288','2013-06-10','16:50:00',5.1),('11288','2013-06-10','16:55:00',5.01),('11288','2013-06-10','17:00:00',4.88),('11288','2013-06-10','17:05:00',4.76),('11288','2013-06-10','17:10:00',4.65),('11288','2013-06-10','17:15:00',4.52),('11288','2013-06-10','17:20:00',4.4),('11288','2013-06-10','17:25:00',4.23),('11288','2013-06-10','17:30:00',4.1),('11288','2013-06-10','17:35:00',4.04),('11288','2013-06-10','17:40:00',3.89),('11288','2013-06-10','17:45:00',3.73),('11288','2013-06-10','17:50:00',3.61),('11288','2013-06-10','17:55:00',3.48),('11288','2013-06-10','18:00:00',3.34),('11288','2013-06-10','18:05:00',3.19),('11288','2013-06-10','18:10:00',3.02),('11288','2013-06-10','18:15:00',2.89),('11288','2013-06-10','18:20:00',2.76),('11288','2013-06-10','18:25:00',2.56),('11288','2013-06-10','18:30:00',2.45),('11288','2013-06-10','18:35:00',2.3),('11288','2013-06-10','18:40:00',2.17),('11288','2013-06-10','18:45:00',2.03),('11288','2013-06-10','18:50:00',1.88),('11288','2013-06-10','18:55:00',1.72),('11288','2013-06-10','19:00:00',1.6),('11288','2013-06-10','19:05:00',1.44),('11288','2013-06-10','19:10:00',1.28),('11288','2013-06-10','19:15:00',1.16),('11288','2013-06-10','19:20:00',1.05),('11288','2013-06-09','07:10:00',1.14),('11288','2013-06-09','07:25:00',1.29),('11288','2013-06-09','07:30:00',1.34),('11288','2013-06-09','07:35:00',2.22),('11288','2013-06-09','07:40:00',1.8),('11288','2013-06-09','07:45:00',1.09),('11288','2013-06-09','07:50:00',1.86),('11288','2013-06-09','07:55:00',2.14),('11288','2013-06-09','08:00:00',2.15),('11288','2013-06-09','08:05:00',2.47),('11288','2013-06-09','08:10:00',2.14),('11288','2013-06-09','08:15:00',1.97),('11288','2013-06-09','08:20:00',3),('11288','2013-06-09','08:25:00',2.89),('11288','2013-06-09','08:30:00',3.09),('11288','2013-06-09','08:35:00',3.37),('11288','2013-06-09','08:40:00',3.47),('11288','2013-06-09','08:45:00',3.55),('11288','2013-06-09','08:50:00',3.81),('11288','2013-06-09','08:55:00',3.81),('11288','2013-06-09','09:00:00',3.89),('11288','2013-06-09','09:05:00',4.08),('11288','2013-06-09','09:10:00',4.07),('11288','2013-06-09','09:15:00',4.23),('11288','2013-06-09','09:20:00',4.48),('11288','2013-06-09','09:25:00',4.42),('11288','2013-06-09','09:30:00',4.61),('11288','2013-06-09','09:35:00',4.7),('11288','2013-06-09','09:40:00',4.76),('11288','2013-06-09','09:45:00',4.99),('11288','2013-06-09','09:50:00',5.18),('11288','2013-06-09','09:55:00',5.16),('11288','2013-06-09','10:00:00',5.21),('11288','2013-06-09','10:05:00',5.49),('11288','2013-06-09','10:10:00',5.6),('11288','2013-06-09','10:15:00',5.66),('11288','2013-06-09','10:20:00',5.75),('11288','2013-06-09','10:25:00',5.92),('11288','2013-06-09','10:30:00',5.96),('11288','2013-06-09','10:35:00',6.08),('11288','2013-06-09','10:40:00',6.14),('11288','2013-06-09','10:45:00',6.22),('11288','2013-06-09','10:50:00',6.27),('11288','2013-06-09','10:55:00',6.21),('11288','2013-06-09','11:00:00',6.28),('11288','2013-06-09','11:05:00',6.35),('11288','2013-06-09','11:10:00',6.53),('11288','2013-06-09','11:15:00',6.51),('11288','2013-06-09','11:20:00',6.45),('11288','2013-06-09','11:25:00',6.48),('11288','2013-06-09','11:30:00',6.57),('11288','2013-06-09','11:35:00',6.64),('11288','2013-06-09','11:40:00',6.69),('11288','2013-06-09','11:45:00',6.71),('11288','2013-06-09','11:50:00',6.69),('11288','2013-06-09','11:55:00',6.69),('11288','2013-06-09','12:00:00',6.75),('11288','2013-06-09','12:05:00',6.9),('11288','2013-06-09','12:10:00',5.63),('11288','2013-06-09','12:15:00',6.9),('11288','2013-06-09','12:20:00',6.92),('11288','2013-06-09','12:25:00',6.97),('11288','2013-06-09','12:30:00',6.81),('11288','2013-06-09','12:35:00',6.76),('11288','2013-06-09','12:40:00',6.97),('11288','2013-06-09','12:45:00',6.87),('11288','2013-06-09','12:50:00',7.1),('11288','2013-06-09','12:55:00',6.75),('11288','2013-06-09','13:00:00',6.95),('11288','2013-06-09','13:05:00',2.8),('11288','2013-06-09','13:10:00',4.74),('11288','2013-06-09','13:15:00',3.49),('11288','2013-06-09','13:20:00',5.8),('11288','2013-06-09','13:25:00',7.74),('11288','2013-06-09','13:30:00',7.29),('11288','2013-06-09','13:35:00',7.42),('11288','2013-06-09','13:40:00',7.69),('11288','2013-06-09','13:45:00',7.69),('11288','2013-06-09','13:50:00',7.99),('11288','2013-06-09','13:55:00',6.64),('11288','2013-06-09','14:00:00',6.29),('11288','2013-06-09','14:05:00',7.56),('11288','2013-06-09','14:10:00',7.22),('11288','2013-06-09','14:15:00',5.18),('11288','2013-06-09','14:20:00',3.08),('11288','2013-06-09','14:25:00',2.08),('11288','2013-06-09','14:30:00',3.02),('11288','2013-06-09','14:35:00',6.72),('11288','2013-06-09','14:40:00',7.45),('11288','2013-06-09','14:45:00',6.62),('11288','2013-06-09','14:50:00',7.09),('11288','2013-06-09','14:55:00',6.99),('11288','2013-06-09','15:00:00',6.84),('11288','2013-06-09','15:05:00',6.55),('11288','2013-06-09','15:10:00',6.6),('11288','2013-06-09','15:15:00',6.44),('11288','2013-06-09','15:20:00',6.35),('11288','2013-06-09','15:25:00',6.4),('11288','2013-06-09','15:30:00',6.15),('11288','2013-06-09','15:35:00',6.24),('11288','2013-06-09','15:40:00',4.91),('11288','2013-06-09','15:45:00',5.26),('11288','2013-06-09','15:50:00',5.97),('11288','2013-06-09','15:55:00',6.04),('11288','2013-06-09','16:00:00',4.08),('11288','2013-06-09','16:05:00',5.86),('11288','2013-06-09','16:10:00',5.41),('11288','2013-06-09','16:15:00',2.65),('11288','2013-06-09','16:20:00',2.9),('11288','2013-06-09','16:25:00',4.03),('11288','2013-06-09','16:30:00',2.3),('11288','2013-06-09','16:35:00',1.77),('11288','2013-06-09','16:40:00',1.74),('11288','2013-06-09','16:45:00',1.74),('11288','2013-06-09','16:50:00',1.66),('11288','2013-06-09','16:55:00',1.57),('11288','2013-06-09','17:00:00',1.67),('11288','2013-06-09','17:05:00',1.85),('11288','2013-06-09','17:10:00',1.75),('11288','2013-06-09','17:15:00',1.46),('11288','2013-06-09','17:20:00',1.56),('11288','2013-06-09','17:25:00',1.18),('11288','2013-06-09','17:30:00',1.02),('11288','2013-06-09','17:35:00',1.18),('11288','2013-06-09','17:40:00',1.4),('11288','2013-06-09','17:45:00',1.29),('11288','2013-06-09','17:55:00',1.05),('11288','2013-06-09','18:00:00',1.86),('11288','2013-06-09','18:05:00',1.62),('11288','2013-06-09','18:10:00',2.33),('11288','2013-06-09','18:15:00',1.79),('11288','2013-06-09','18:20:00',1.56),('11288','2013-06-09','18:30:00',1.57),('11288','2013-06-09','18:35:00',1.08),('11288','2013-06-09','18:45:00',1.24),('11288','2013-06-09','18:50:00',1.24),('11288','2013-06-08','07:10:00',1.01),('11288','2013-06-08','07:15:00',1.14),('11288','2013-06-08','07:20:00',1.22),('11288','2013-06-08','07:25:00',1.31),('11288','2013-06-08','07:30:00',1.41),('11288','2013-06-08','07:35:00',1.53),('11288','2013-06-08','07:40:00',1.55),('11288','2013-06-08','07:45:00',1.77),('11288','2013-06-08','07:50:00',1.89),('11288','2013-06-08','07:55:00',2.02),('11288','2013-06-08','08:00:00',2.29),('11288','2013-06-08','08:05:00',2.36),('11288','2013-06-08','08:10:00',2.37),('11288','2013-06-08','08:15:00',2.65),('11288','2013-06-08','08:20:00',2.85),('11288','2013-06-08','08:25:00',2.87),('11288','2013-06-08','08:30:00',3.14),('11288','2013-06-08','08:35:00',3.19),('11288','2013-06-08','08:40:00',3.32),('11288','2013-06-08','08:45:00',3.61),('11288','2013-06-08','08:50:00',3.73),('11288','2013-06-08','08:55:00',3.77),('11288','2013-06-08','09:00:00',3.9),('11288','2013-06-08','09:05:00',3.94),('11288','2013-06-08','09:10:00',3.99),('11288','2013-06-08','09:15:00',4.23),('11288','2013-06-08','09:20:00',4.41),('11288','2013-06-08','09:25:00',4.37),('11288','2013-06-08','09:30:00',4.53),('11288','2013-06-08','09:35:00',4.71),('11288','2013-06-08','09:40:00',4.94),('11288','2013-06-08','09:45:00',5.03),('11288','2013-06-08','09:50:00',5.26),('11288','2013-06-08','09:55:00',5.41),('11288','2013-06-08','10:00:00',5.37),('11288','2013-06-08','10:05:00',5.34),('11288','2013-06-08','10:10:00',5.73),('11288','2013-06-08','10:15:00',5.1),('11288','2013-06-08','10:20:00',5.87),('11288','2013-06-08','10:25:00',4.85),('11288','2013-06-08','10:30:00',5.75),('11288','2013-06-08','10:35:00',6.19),('11288','2013-06-08','10:40:00',6.34),('11288','2013-06-08','10:45:00',6.44),('11288','2013-06-08','10:50:00',5.11),('11288','2013-06-08','10:55:00',2.25),('11288','2013-06-08','11:00:00',4.93),('11288','2013-06-08','11:05:00',2.44),('11288','2013-06-08','11:10:00',7.36),('11288','2013-06-08','11:15:00',7.7),('11288','2013-06-08','11:20:00',7.34),('11288','2013-06-08','11:25:00',2.27),('11288','2013-06-08','11:30:00',2.06),('11288','2013-06-08','11:35:00',5.52),('11288','2013-06-08','11:40:00',7.64),('11288','2013-06-08','11:45:00',7.33),('11288','2013-06-08','11:50:00',7.66),('11288','2013-06-08','11:55:00',7.76),('11288','2013-06-08','12:00:00',7.66),('11288','2013-06-08','12:05:00',4.2),('11288','2013-06-08','12:10:00',7.59),('11288','2013-06-08','12:15:00',7.7),('11288','2013-06-08','12:20:00',7.51),('11288','2013-06-08','12:25:00',6.52),('11288','2013-06-08','12:30:00',6.51),('11288','2013-06-08','12:35:00',7.35),('11288','2013-06-08','12:40:00',6.44),('11288','2013-06-08','12:45:00',7.35),('11288','2013-06-08','12:50:00',7.44),('11288','2013-06-08','12:55:00',7.36),('11288','2013-06-08','13:00:00',7.47),('11288','2013-06-08','13:05:00',7.38),('11288','2013-06-08','13:10:00',7.42),('11288','2013-06-08','13:15:00',7.59),('11288','2013-06-08','13:20:00',7.51),('11288','2013-06-08','13:25:00',7.39),('11288','2013-06-08','13:30:00',7.48),('11288','2013-06-08','13:35:00',7.33),('11288','2013-06-08','13:40:00',7.31),('11288','2013-06-08','13:45:00',7.29),('11288','2013-06-08','13:50:00',7.22),('11288','2013-06-08','13:55:00',7.27),('11288','2013-06-08','14:00:00',7.3),('11288','2013-06-08','14:05:00',7.26),('11288','2013-06-08','14:10:00',7.2),('11288','2013-06-08','14:15:00',7.17),('11288','2013-06-08','14:20:00',7.08),('11288','2013-06-08','14:25:00',7.12),('11288','2013-06-08','14:30:00',7.05),('11288','2013-06-08','14:35:00',7.05),('11288','2013-06-08','14:40:00',7.07),('11288','2013-06-08','14:45:00',7.02),('11288','2013-06-08','14:50:00',7),('11288','2013-06-08','14:55:00',6.99),('11288','2013-06-08','15:00:00',6.87),('11288','2013-06-08','15:05:00',6.59),('11288','2013-06-08','15:10:00',6.18),('11288','2013-06-08','15:15:00',6.49),('11288','2013-06-08','15:20:00',6.71),('11288','2013-06-08','15:25:00',6.32),('11288','2013-06-08','15:30:00',6.23),('11288','2013-06-08','15:35:00',6.17),('11288','2013-06-08','15:40:00',6.21),('11288','2013-06-08','15:45:00',6.62),('11288','2013-06-08','15:50:00',6.58),('11288','2013-06-08','15:55:00',6.02),('11288','2013-06-08','16:00:00',6.17),('11288','2013-06-08','16:05:00',6.14),('11288','2013-06-08','16:10:00',6.18),('11288','2013-06-08','16:15:00',6.03),('11288','2013-06-08','16:20:00',5.9),('11288','2013-06-08','16:25:00',5.65),('11288','2013-06-08','16:30:00',5.41),('11288','2013-06-08','16:35:00',5.26),('11288','2013-06-08','16:40:00',5.03),('11288','2013-06-08','16:45:00',4.75),('11288','2013-06-08','16:50:00',4.05),('11288','2013-06-08','16:55:00',4.46),('11288','2013-06-08','17:00:00',4.77),('11288','2013-06-08','17:05:00',4.66),('11288','2013-06-08','17:10:00',4.97),('11288','2013-06-08','17:15:00',4.88),('11288','2013-06-08','17:20:00',4.62),('11288','2013-06-08','17:25:00',4.3),('11288','2013-06-08','17:30:00',3.22),('11288','2013-06-08','17:35:00',2.55),('11288','2013-06-08','17:40:00',3.91),('11288','2013-06-08','17:45:00',3.93),('11288','2013-06-08','17:50:00',3.62),('11288','2013-06-08','17:55:00',3.56),('11288','2013-06-08','18:00:00',2.98),('11288','2013-06-08','18:05:00',2.62),('11288','2013-06-08','18:10:00',2.15),('11288','2013-06-08','18:15:00',2.19),('11288','2013-06-08','18:20:00',2.18),('11288','2013-06-08','18:25:00',2.06),('11288','2013-06-08','18:30:00',1.31),('11288','2013-06-08','18:35:00',1.13),('11288','2013-06-07','07:15:00',1.11),('11288','2013-06-07','07:20:00',1.21),('11288','2013-06-07','07:25:00',1.29),('11288','2013-06-07','07:30:00',1.41),('11288','2013-06-07','07:35:00',1.51),('11288','2013-06-07','07:40:00',1.58),('11288','2013-06-07','07:45:00',1.77),('11288','2013-06-07','07:50:00',2),('11288','2013-06-07','07:55:00',2.06),('11288','2013-06-07','08:00:00',2.34),('11288','2013-06-07','08:05:00',2.48),('11288','2013-06-07','08:10:00',2.47),('11288','2013-06-07','08:15:00',2.7),('11288','2013-06-07','08:20:00',2.92),('11288','2013-06-07','08:25:00',2.97),('11288','2013-06-07','08:30:00',3.25),('11288','2013-06-07','08:35:00',3.37),('11288','2013-06-07','08:40:00',3.55),('11288','2013-06-07','08:45:00',3.78),('11288','2013-06-07','08:50:00',3.86),('11288','2013-06-07','08:55:00',3.96),('11288','2013-06-07','09:00:00',4.1),('11288','2013-06-07','09:05:00',4.19),('11288','2013-06-07','09:10:00',4.18),('11288','2013-06-07','09:15:00',4.49),('11288','2013-06-07','09:20:00',4.72),('11288','2013-06-07','09:25:00',4.88),('11288','2013-06-07','09:30:00',4.99),('11288','2013-06-07','09:35:00',5.08),('11288','2013-06-07','09:40:00',5.27),('11288','2013-06-07','09:45:00',5.44),('11288','2013-06-07','09:50:00',5.61),('11288','2013-06-07','09:55:00',5.67),('11288','2013-06-07','10:00:00',5.8),('11288','2013-06-07','10:05:00',5.96),('11288','2013-06-07','10:10:00',6.02),('11288','2013-06-07','10:15:00',6.1),('11288','2013-06-07','10:20:00',6.28),('11288','2013-06-07','10:25:00',6.35),('11288','2013-06-07','10:30:00',6.43),('11288','2013-06-07','10:35:00',6.55),('11288','2013-06-07','10:40:00',6.59),('11288','2013-06-07','10:45:00',6.64),('11288','2013-06-07','10:50:00',6.74),('11288','2013-06-07','10:55:00',6.79),('11288','2013-06-07','11:00:00',6.87),('11288','2013-06-07','11:05:00',6.96),('11288','2013-06-07','11:10:00',7.04),('11288','2013-06-07','11:15:00',7.07),('11288','2013-06-07','11:20:00',7.04),('11288','2013-06-07','11:25:00',7.08),('11288','2013-06-07','11:30:00',7.17),('11288','2013-06-07','11:35:00',7.22),('11288','2013-06-07','11:40:00',7.26),('11288','2013-06-07','11:45:00',7.31),('11288','2013-06-07','11:50:00',7.28),('11288','2013-06-07','11:55:00',7.35),('11288','2013-06-07','12:00:00',7.38),('11288','2013-06-07','12:05:00',7.41),('11288','2013-06-07','12:10:00',7.4),('11288','2013-06-07','12:15:00',7.4),('11288','2013-06-07','12:20:00',7.4),('11288','2013-06-07','12:25:00',7.41),('11288','2013-06-07','12:30:00',7.43),('11288','2013-06-07','12:35:00',7.45),('11288','2013-06-07','12:40:00',7.42),('11288','2013-06-07','12:45:00',7.48),('11288','2013-06-07','12:50:00',7.44),('11288','2013-06-07','12:55:00',7.47),('11288','2013-06-07','13:00:00',7.49),('11288','2013-06-07','13:05:00',7.48),('11288','2013-06-07','13:10:00',7.42),('11288','2013-06-07','13:15:00',7.41),('11288','2013-06-07','13:20:00',7.37),('11288','2013-06-07','13:25:00',7.36),('11288','2013-06-07','13:30:00',7.38),('11288','2013-06-07','13:35:00',7.35),('11288','2013-06-07','13:40:00',7.25),('11288','2013-06-07','13:45:00',7.17),('11288','2013-06-07','13:50:00',7.17),('11288','2013-06-07','13:55:00',7.18),('11288','2013-06-07','14:00:00',7.14),('11288','2013-06-07','14:05:00',7.12),('11288','2013-06-07','14:10:00',7.05),('11288','2013-06-07','14:15:00',7.05),('11288','2013-06-07','14:20:00',6.98),('11288','2013-06-07','14:25:00',6.91),('11288','2013-06-07','14:30:00',6.86),('11288','2013-06-07','14:35:00',6.82),('11288','2013-06-07','14:40:00',6.83),('11288','2013-06-07','14:45:00',6.88),('11288','2013-06-07','14:50:00',6.81),('11288','2013-06-07','14:55:00',6.74),('11288','2013-06-07','15:00:00',6.67),('11288','2013-06-07','15:05:00',6.67),('11288','2013-06-07','15:10:00',6.58),('11288','2013-06-07','15:15:00',6.57),('11288','2013-06-07','15:20:00',6.52),('11288','2013-06-07','15:25:00',6.54),('11288','2013-06-07','15:30:00',6.5),('11288','2013-06-07','15:35:00',6.42),('11288','2013-06-07','15:40:00',6.31),('11288','2013-06-07','15:45:00',6.24),('11288','2013-06-07','15:50:00',6.17),('11288','2013-06-07','15:55:00',6.07),('11288','2013-06-07','16:00:00',5.99),('11288','2013-06-07','16:05:00',5.9),('11288','2013-06-07','16:10:00',5.74),('11288','2013-06-07','16:15:00',5.41),('11288','2013-06-07','16:20:00',5.41),('11288','2013-06-07','16:25:00',5.54),('11288','2013-06-07','16:30:00',5.49),('11288','2013-06-07','16:35:00',5.27),('11288','2013-06-07','16:40:00',5.18),('11288','2013-06-07','16:45:00',5.07),('11288','2013-06-07','16:50:00',4.99),('11288','2013-06-07','16:55:00',4.87),('11288','2013-06-07','17:00:00',4.74),('11288','2013-06-07','17:05:00',4.62),('11288','2013-06-07','17:10:00',4.54),('11288','2013-06-07','17:15:00',4.38),('11288','2013-06-07','17:20:00',4.26),('11288','2013-06-07','17:25:00',4.13),('11288','2013-06-07','17:30:00',3.99),('11288','2013-06-07','17:35:00',3.93),('11288','2013-06-07','17:40:00',3.79),('11288','2013-06-07','17:45:00',3.65),('11288','2013-06-07','17:50:00',3.57),('11288','2013-06-07','17:55:00',3.46),('11288','2013-06-07','18:00:00',3.26),('11288','2013-06-07','18:05:00',3.13),('11288','2013-06-07','18:10:00',2.94),('11288','2013-06-07','18:15:00',2.72),('11288','2013-06-07','18:20:00',2.57),('11288','2013-06-07','18:25:00',2.32),('11288','2013-06-07','18:30:00',2.2),('11288','2013-06-07','18:35:00',2.1),('11288','2013-06-07','18:40:00',1.95),('11288','2013-06-07','18:45:00',1.77),('11288','2013-06-07','18:50:00',1.66),('11288','2013-06-07','18:55:00',1.55),('11288','2013-06-07','19:00:00',1.47),('11288','2013-06-07','19:05:00',1.32),('11288','2013-06-06','06:55:00',1.03),('11288','2013-06-06','07:00:00',1.43),('11288','2013-06-06','07:05:00',1.65),('11288','2013-06-06','07:10:00',1.57),('11288','2013-06-06','07:15:00',1.75),('11288','2013-06-06','07:20:00',1.18),('11288','2013-06-06','07:25:00',1.24),('11288','2013-06-06','07:30:00',1.14),('11288','2013-06-06','07:35:00',1.1),('11288','2013-06-06','07:40:00',1.25),('11288','2013-06-06','07:45:00',1.26),('11288','2013-06-06','07:50:00',1.91),('11288','2013-06-06','07:55:00',2.45),('11288','2013-06-06','08:00:00',2.53),('11288','2013-06-06','08:05:00',2.03),('11288','2013-06-06','08:10:00',2.64),('11288','2013-06-06','08:15:00',2.24),('11288','2013-06-06','08:20:00',2.64),('11288','2013-06-06','08:25:00',3),('11288','2013-06-06','08:30:00',3.27),('11288','2013-06-06','08:35:00',3.26),('11288','2013-06-06','08:40:00',3.51),('11288','2013-06-06','08:45:00',3.73),('11288','2013-06-06','08:50:00',3.74),('11288','2013-06-06','08:55:00',3.96),('11288','2013-06-06','09:00:00',4.12),('11288','2013-06-06','09:05:00',4.13),('11288','2013-06-06','09:10:00',4.15),('11288','2013-06-06','09:15:00',4.41),('11288','2013-06-06','09:20:00',4.44),('11288','2013-06-06','09:25:00',4.51),('11288','2013-06-06','09:30:00',4.79),('11288','2013-06-06','09:35:00',4.97),('11288','2013-06-06','09:40:00',5.1),('11288','2013-06-06','09:45:00',5.28),('11288','2013-06-06','09:50:00',5.46),('11288','2013-06-06','09:55:00',5.54),('11288','2013-06-06','10:00:00',5.67),('11288','2013-06-06','10:05:00',5.67),('11288','2013-06-06','10:10:00',5.62),('11288','2013-06-06','10:15:00',5.74),('11288','2013-06-06','10:20:00',6.01),('11288','2013-06-06','10:25:00',6.2),('11288','2013-06-06','10:30:00',6.31),('11288','2013-06-06','10:35:00',6.26),('11288','2013-06-06','10:40:00',6.29),('11288','2013-06-06','10:45:00',6.45),('11288','2013-06-06','10:50:00',6.65),('11288','2013-06-06','10:55:00',6.67),('11288','2013-06-06','11:00:00',6.72),('11288','2013-06-06','11:05:00',6.84),('11288','2013-06-06','11:10:00',6.72),('11288','2013-06-06','11:15:00',6.85),('11288','2013-06-06','11:20:00',6.73),('11288','2013-06-06','11:25:00',6.86),('11288','2013-06-06','11:30:00',6.89),('11288','2013-06-06','11:35:00',7),('11288','2013-06-06','11:40:00',6.82),('11288','2013-06-06','11:45:00',6.86),('11288','2013-06-06','11:50:00',6.93),('11288','2013-06-06','11:55:00',7.08),('11288','2013-06-06','12:00:00',7.1),('11288','2013-06-06','12:05:00',7.15),('11288','2013-06-06','12:10:00',7.1),('11288','2013-06-06','12:15:00',7.08),('11288','2013-06-06','12:20:00',7.08),('11288','2013-06-06','12:25:00',7.1),('11288','2013-06-06','12:30:00',6.96),('11288','2013-06-06','12:35:00',7),('11288','2013-06-06','12:40:00',7.14),('11288','2013-06-06','12:45:00',7.33),('11288','2013-06-06','12:50:00',7.34),('11288','2013-06-06','12:55:00',7.42),('11288','2013-06-06','13:00:00',7.34),('11288','2013-06-06','13:05:00',7.38),('11288','2013-06-06','13:10:00',7.32),('11288','2013-06-06','13:15:00',7.42),('11288','2013-06-06','13:20:00',7.39),('11288','2013-06-06','13:25:00',6.16),('11288','2013-06-06','13:30:00',7.3),('11288','2013-06-06','13:35:00',7.37),('11288','2013-06-06','13:40:00',3.54),('11288','2013-06-06','13:45:00',1.53),('11288','2013-06-06','13:50:00',1.84),('11288','2013-06-06','13:55:00',6.06),('11288','2013-06-06','14:00:00',7.25),('11288','2013-06-06','14:05:00',3.87),('11288','2013-06-06','14:10:00',3.05),('11288','2013-06-06','14:15:00',3.09),('11288','2013-06-06','14:20:00',4.98),('11288','2013-06-06','14:25:00',7.42),('11288','2013-06-06','14:30:00',5.99),('11288','2013-06-06','14:35:00',7.06),('11288','2013-06-06','14:40:00',7.08),('11288','2013-06-06','14:45:00',6.11),('11288','2013-06-06','14:50:00',7.36),('11288','2013-06-06','14:55:00',6.89),('11288','2013-06-06','15:00:00',6.78),('11288','2013-06-06','15:05:00',6.83),('11288','2013-06-06','15:10:00',6.85),('11288','2013-06-06','15:15:00',6.64),('11288','2013-06-06','15:20:00',5.86),('11288','2013-06-06','15:25:00',6.08),('11288','2013-06-06','15:30:00',6.17),('11288','2013-06-06','15:35:00',6.23),('11288','2013-06-06','15:40:00',6.27),('11288','2013-06-06','15:45:00',6.12),('11288','2013-06-06','15:50:00',5.58),('11288','2013-06-06','15:55:00',6.21),('11288','2013-06-06','16:00:00',6.25),('11288','2013-06-06','16:05:00',6.12),('11288','2013-06-06','16:10:00',5.75),('11288','2013-06-06','16:15:00',5.39),('11288','2013-06-06','16:20:00',5.38),('11288','2013-06-06','16:25:00',5.34),('11288','2013-06-06','16:30:00',5.22),('11288','2013-06-06','16:35:00',5.13),('11288','2013-06-06','16:40:00',4.9),('11288','2013-06-06','16:45:00',4.63),('11288','2013-06-06','16:50:00',4.76),('11288','2013-06-06','16:55:00',4.63),('11288','2013-06-06','17:00:00',4.42),('11288','2013-06-06','17:05:00',4.36),('11288','2013-06-06','17:10:00',4.25),('11288','2013-06-06','17:15:00',4.08),('11288','2013-06-06','17:20:00',3.99),('11288','2013-06-06','17:25:00',3.9),('11288','2013-06-06','17:30:00',3.79),('11288','2013-06-06','17:35:00',3.71),('11288','2013-06-06','17:40:00',3.6),('11288','2013-06-06','17:45:00',3.4),('11288','2013-06-06','17:50:00',3.24),('11288','2013-06-06','17:55:00',3.12),('11288','2013-06-06','18:00:00',3.01),('11288','2013-06-06','18:05:00',2.9),('11288','2013-06-06','18:10:00',2.74),('11288','2013-06-06','18:15:00',2.56),('11288','2013-06-06','18:20:00',2.42),('11288','2013-06-06','18:25:00',2.28),('11288','2013-06-06','18:30:00',2.13),('11288','2013-06-06','18:35:00',2.01),('11288','2013-06-06','18:40:00',1.92),('11288','2013-06-06','18:45:00',1.77),('11288','2013-06-06','18:50:00',1.62),('11288','2013-06-06','18:55:00',1.53),('11288','2013-06-06','19:00:00',1.4),('11288','2013-06-06','19:05:00',1.25),('11288','2013-06-06','19:10:00',1.11),('11288','2013-06-06','19:15:00',1.03),('11288','2013-06-05','07:25:00',1.42),('11288','2013-06-05','07:30:00',1.22),('11288','2013-06-05','07:35:00',1.16),('11288','2013-06-05','07:40:00',1.19),('11288','2013-06-05','07:45:00',1.72),('11288','2013-06-05','07:50:00',2.65),('11288','2013-06-05','07:55:00',2.81),('11288','2013-06-05','08:00:00',2.95),('11288','2013-06-05','08:05:00',2.8),('11288','2013-06-05','08:10:00',2.56),('11288','2013-06-05','08:15:00',2.67),('11288','2013-06-05','08:20:00',2.84),('11288','2013-06-05','08:25:00',3.02),('11288','2013-06-05','08:30:00',3.26),('11288','2013-06-05','08:35:00',3.36),('11288','2013-06-05','08:40:00',3.51),('11288','2013-06-05','08:45:00',3.72),('11288','2013-06-05','08:50:00',3.81),('11288','2013-06-05','08:55:00',3.94),('11288','2013-06-05','09:00:00',4),('11288','2013-06-05','09:05:00',4.39),('11288','2013-06-05','09:10:00',3.16),('11288','2013-06-05','09:15:00',3.12),('11288','2013-06-05','09:20:00',4.78),('11288','2013-06-05','09:25:00',3.1),('11288','2013-06-05','09:30:00',2.49),('11288','2013-06-05','09:35:00',5.34),('11288','2013-06-05','09:40:00',5.99),('11288','2013-06-05','09:45:00',3.08),('11288','2013-06-05','09:50:00',3.97),('11288','2013-06-05','09:55:00',4.38),('11288','2013-06-05','10:00:00',6.07),('11288','2013-06-05','10:05:00',6.68),('11288','2013-06-05','10:10:00',5.97),('11288','2013-06-05','10:15:00',3.86),('11288','2013-06-05','10:20:00',2.67),('11288','2013-06-05','10:25:00',2.7),('11288','2013-06-05','10:30:00',2.25),('11288','2013-06-05','10:35:00',4.01),('11288','2013-06-05','10:40:00',7.64),('11288','2013-06-05','10:45:00',7.51),('11288','2013-06-05','10:50:00',6.78),('11288','2013-06-05','10:55:00',4.84),('11288','2013-06-05','11:00:00',2.79),('11288','2013-06-05','11:05:00',2.92),('11288','2013-06-05','11:10:00',2.08),('11288','2013-06-05','11:15:00',2.01),('11288','2013-06-05','11:20:00',1.92),('11288','2013-06-05','11:25:00',2.12),('11288','2013-06-05','11:30:00',3.24),('11288','2013-06-05','11:35:00',5.71),('11288','2013-06-05','11:40:00',8.04),('11288','2013-06-05','11:45:00',3.13),('11288','2013-06-05','11:50:00',5.3),('11288','2013-06-05','11:55:00',8.11),('11288','2013-06-05','12:00:00',8.18),('11288','2013-06-05','12:05:00',7.95),('11288','2013-06-05','12:10:00',7.78),('11288','2013-06-05','12:15:00',7.82),('11288','2013-06-05','12:20:00',8.29),('11288','2013-06-05','12:25:00',7.88),('11288','2013-06-05','12:30:00',4.64),('11288','2013-06-05','12:35:00',3.04),('11288','2013-06-05','12:40:00',6.24),('11288','2013-06-05','12:45:00',8.14),('11288','2013-06-05','12:50:00',3.76),('11288','2013-06-05','12:55:00',3.87),('11288','2013-06-05','13:00:00',4.53),('11288','2013-06-05','13:05:00',5.89),('11288','2013-06-05','13:10:00',7.12),('11288','2013-06-05','13:15:00',5.82),('11288','2013-06-05','13:20:00',4.46),('11288','2013-06-05','13:25:00',7.25),('11288','2013-06-05','13:30:00',8.66),('11288','2013-06-05','13:35:00',8.2),('11288','2013-06-05','13:40:00',7.93),('11288','2013-06-05','13:45:00',7.89),('11288','2013-06-05','13:50:00',7.61),('11288','2013-06-05','13:55:00',7.65),('11288','2013-06-05','14:00:00',7.52),('11288','2013-06-05','14:05:00',7.51),('11288','2013-06-05','14:10:00',7.42),('11288','2013-06-05','14:15:00',7.38),('11288','2013-06-05','14:20:00',7.35),('11288','2013-06-05','14:25:00',7.28),('11288','2013-06-05','14:30:00',6.54),('11288','2013-06-05','14:35:00',7.09),('11288','2013-06-05','14:40:00',7.22),('11288','2013-06-05','14:45:00',7.18),('11288','2013-06-05','14:50:00',7.13),('11288','2013-06-05','14:55:00',7.04),('11288','2013-06-05','15:00:00',6.93),('11288','2013-06-05','15:05:00',6.83),('11288','2013-06-05','15:10:00',6.84),('11288','2013-06-05','15:15:00',6.81),('11288','2013-06-05','15:20:00',6.73),('11288','2013-06-05','15:25:00',6.75),('11288','2013-06-05','15:30:00',6.83),('11288','2013-06-05','15:35:00',6.84),('11288','2013-06-05','15:40:00',6.6),('11288','2013-06-05','15:45:00',6.5),('11288','2013-06-05','15:50:00',6.42),('11288','2013-06-05','15:55:00',6.35),('11288','2013-06-05','16:00:00',6.29),('11288','2013-06-05','16:05:00',6.21),('11288','2013-06-05','16:10:00',6),('11288','2013-06-05','16:15:00',5.92),('11288','2013-06-05','16:20:00',5.75),('11288','2013-06-05','16:25:00',5.73),('11288','2013-06-05','16:30:00',5.61),('11288','2013-06-05','16:35:00',5.45),('11288','2013-06-05','16:40:00',5.21),('11288','2013-06-05','16:45:00',5.02),('11288','2013-06-05','16:50:00',4.77),('11288','2013-06-05','16:55:00',4.83),('11288','2013-06-05','17:00:00',1.71),('11288','2013-06-05','17:05:00',3.87),('11288','2013-06-05','17:10:00',2.14),('11288','2013-06-05','17:15:00',2.84),('11288','2013-06-05','17:20:00',3.01),('11288','2013-06-05','17:25:00',2.31),('11288','2013-06-05','17:30:00',3.64),('11288','2013-06-05','17:35:00',3.81),('11288','2013-06-05','17:40:00',3.56),('11288','2013-06-05','17:45:00',3.58),('11288','2013-06-05','17:50:00',3.29),('11288','2013-06-05','17:55:00',3.18),('11288','2013-06-05','18:00:00',3.05),('11288','2013-06-05','18:05:00',1.71),('11288','2013-06-05','18:10:00',2.41),('11288','2013-06-05','18:15:00',1.91),('11288','2013-06-05','18:20:00',1.5),('11288','2013-06-05','18:25:00',1.72),('11288','2013-06-05','18:30:00',2.17),('11288','2013-06-05','18:35:00',2.19),('11288','2013-06-05','18:40:00',2.25),('11288','2013-06-05','18:45:00',1.25),('11288','2013-06-05','18:50:00',1.37),('11288','2013-06-05','18:55:00',1.4),('11288','2013-06-05','19:00:00',1.26),('11288','2013-06-05','19:05:00',1.01),('11288','2013-06-04','07:10:00',1.2),('11288','2013-06-04','07:15:00',1.28),('11288','2013-06-04','07:20:00',1.33),('11288','2013-06-04','07:25:00',1.45),('11288','2013-06-04','07:30:00',1.52),('11288','2013-06-04','07:35:00',1.7),('11288','2013-06-04','07:40:00',1.95),('11288','2013-06-04','07:45:00',2.27),('11288','2013-06-04','07:50:00',2.68),('11288','2013-06-04','07:55:00',2.93),('11288','2013-06-04','08:00:00',3.29),('11288','2013-06-04','08:05:00',3.64),('11288','2013-06-04','08:10:00',3.55),('11288','2013-06-04','08:15:00',3.53),('11288','2013-06-04','08:20:00',3.72),('11288','2013-06-04','08:25:00',3.79),('11288','2013-06-04','08:30:00',4.1),('11288','2013-06-04','08:35:00',4),('11288','2013-06-04','08:40:00',3.63),('11288','2013-06-04','08:45:00',3.38),('11288','2013-06-04','08:50:00',2.56),('11288','2013-06-04','08:55:00',2.59),('11288','2013-06-04','09:00:00',2.93),('11288','2013-06-04','09:05:00',3.13),('11288','2013-06-04','09:10:00',3.93),('11288','2013-06-04','09:15:00',5.99),('11288','2013-06-04','09:20:00',5.45),('11288','2013-06-04','09:25:00',4.24),('11288','2013-06-04','09:30:00',5.1),('11288','2013-06-04','09:35:00',4.23),('11288','2013-06-04','09:40:00',3.44),('11288','2013-06-04','09:45:00',4.12),('11288','2013-06-04','09:50:00',3.6),('11288','2013-06-04','09:55:00',3.37),('11288','2013-06-04','10:00:00',3.82),('11288','2013-06-04','10:05:00',4.58),('11288','2013-06-04','10:10:00',4.02),('11288','2013-06-04','10:15:00',3.24),('11288','2013-06-04','10:20:00',3.51),('11288','2013-06-04','10:25:00',3.55),('11288','2013-06-04','10:30:00',3.14),('11288','2013-06-04','10:35:00',3.19),('11288','2013-06-04','10:40:00',3.57),('11288','2013-06-04','10:45:00',4.62),('11288','2013-06-04','10:50:00',5.25),('11288','2013-06-04','10:55:00',4.94),('11288','2013-06-04','11:00:00',4.26),('11288','2013-06-04','11:05:00',5.3),('11288','2013-06-04','11:10:00',6.77),('11288','2013-06-04','11:15:00',5.64),('11288','2013-06-04','11:20:00',4.06),('11288','2013-06-04','11:25:00',4.9),('11288','2013-06-04','11:30:00',5.48),('11288','2013-06-04','11:35:00',5.09),('11288','2013-06-04','11:40:00',5.8),('11288','2013-06-04','11:45:00',6.75),('11288','2013-06-04','11:50:00',7.8),('11288','2013-06-04','11:55:00',7.65),('11288','2013-06-04','12:00:00',7.23),('11288','2013-06-04','12:05:00',7.55),('11288','2013-06-04','12:10:00',4.75),('11288','2013-06-04','12:15:00',4.87),('11288','2013-06-04','12:20:00',4.51),('11288','2013-06-04','12:25:00',4.11),('11288','2013-06-04','12:30:00',5.44),('11288','2013-06-04','12:35:00',6.44),('11288','2013-06-04','12:40:00',4.16),('11288','2013-06-04','12:45:00',5.71),('11288','2013-06-04','12:50:00',3.98),('11288','2013-06-04','12:55:00',3),('11288','2013-06-04','13:00:00',3.01),('11288','2013-06-04','13:05:00',3.07),('11288','2013-06-04','13:10:00',3.09),('11288','2013-06-04','13:15:00',2.04),('11288','2013-06-04','13:20:00',2.08),('11288','2013-06-04','13:25:00',2.5),('11288','2013-06-04','13:30:00',3.73),('11288','2013-06-04','13:35:00',8.26),('11288','2013-06-04','13:40:00',6.85),('11288','2013-06-04','13:45:00',6.12),('11288','2013-06-04','13:50:00',7.54),('11288','2013-06-04','13:55:00',6.06),('11288','2013-06-04','14:00:00',3.77),('11288','2013-06-04','14:05:00',6.61),('11288','2013-06-04','14:10:00',5.82),('11288','2013-06-04','14:15:00',3.26),('11288','2013-06-04','14:20:00',7.55),('11288','2013-06-04','14:25:00',2.09),('11288','2013-06-04','14:30:00',2.13),('11288','2013-06-04','14:35:00',2.62),('11288','2013-06-04','14:40:00',4.03),('11288','2013-06-04','14:45:00',2.5),('11288','2013-06-04','14:50:00',2.54),('11288','2013-06-04','14:55:00',5.67),('11288','2013-06-04','15:00:00',7.56),('11288','2013-06-04','15:05:00',3.48),('11288','2013-06-04','15:10:00',2.85),('11288','2013-06-04','15:15:00',4.06),('11288','2013-06-04','15:20:00',2.14),('11288','2013-06-04','15:25:00',1.65),('11288','2013-06-04','15:30:00',1.1),('11288','2013-06-04','17:15:00',1.6),('11288','2013-06-04','17:20:00',1.44),('11288','2013-06-04','17:25:00',1.16),('11288','2013-06-04','17:35:00',1.05),('11288','2013-06-04','17:40:00',1.41),('11288','2013-06-04','17:45:00',1.36),('11288','2013-06-04','17:50:00',1.23),('11288','2013-06-04','17:55:00',1.29),('11288','2013-06-04','18:00:00',1.38),('11288','2013-06-04','18:05:00',1.84),('11288','2013-06-04','18:10:00',1.63),('11288','2013-06-04','18:15:00',1.44),('11288','2013-06-04','18:20:00',1.32),('11288','2013-06-04','18:25:00',1.21),('11288','2013-06-04','18:30:00',1.05),('11288','2013-06-04','18:40:00',1.37),('11288','2013-06-04','18:45:00',1.7),('11288','2013-06-04','18:50:00',1.28),('11288','2013-06-04','18:55:00',1.25),('11288','2013-06-04','19:00:00',1.06),('11288','2013-06-03','06:50:00',1.01),('11288','2013-06-03','07:20:00',1.16),('11288','2013-06-03','07:25:00',1.35),('11288','2013-06-03','07:40:00',1.76),('11288','2013-06-03','07:45:00',1.7),('11288','2013-06-03','07:50:00',2.19),('11288','2013-06-03','07:55:00',2.28),('11288','2013-06-03','08:00:00',2.29),('11288','2013-06-03','08:05:00',2.49),('11288','2013-06-03','08:10:00',2.59),('11288','2013-06-03','08:15:00',2.68),('11288','2013-06-03','08:20:00',2.84),('11288','2013-06-03','08:25:00',3.13),('11288','2013-06-03','08:30:00',3.23),('11288','2013-06-03','08:35:00',3.37),('11288','2013-06-03','08:40:00',3.56),('11288','2013-06-03','08:45:00',3.79),('11288','2013-06-03','08:50:00',3.94),('11288','2013-06-03','08:55:00',4.1),('11288','2013-06-03','09:00:00',4.13),('11288','2013-06-03','09:05:00',4.19),('11288','2013-06-03','09:10:00',4.38),('11288','2013-06-03','09:15:00',5.05),('11288','2013-06-03','09:20:00',5.32),('11288','2013-06-03','09:25:00',3.73),('11288','2013-06-03','09:30:00',3.04),('11288','2013-06-03','09:35:00',3.53),('11288','2013-06-03','09:40:00',4.39),('11288','2013-06-03','09:45:00',5.81),('11288','2013-06-03','09:50:00',5.84),('11288','2013-06-03','09:55:00',6.16),('11288','2013-06-03','10:00:00',6.36),('11288','2013-06-03','10:05:00',5.99),('11288','2013-06-03','10:10:00',3.91),('11288','2013-06-03','10:15:00',2.04),('11288','2013-06-03','10:20:00',1.59),('11288','2013-06-03','10:25:00',1.62),('11288','2013-06-03','10:30:00',1.98),('11288','2013-06-03','10:35:00',2.38),('11288','2013-06-03','10:40:00',2.66),('11288','2013-06-03','10:45:00',3.42),('11288','2013-06-03','10:50:00',5.03),('11288','2013-06-03','10:55:00',3.76),('11288','2013-06-03','11:00:00',4.71),('11288','2013-06-03','11:05:00',3.47),('11288','2013-06-03','11:10:00',3.1),('11288','2013-06-03','11:15:00',2.57),('11288','2013-06-03','11:20:00',3.36),('11288','2013-06-03','11:25:00',3.26),('11288','2013-06-03','11:30:00',4.46),('11288','2013-06-03','11:35:00',2.73),('11288','2013-06-03','11:40:00',2.82),('11288','2013-06-03','11:45:00',2.82),('11288','2013-06-03','11:50:00',3.27),('11288','2013-06-03','11:55:00',3.24),('11288','2013-06-03','12:00:00',4.59),('11288','2013-06-03','12:05:00',2.31),('11288','2013-06-03','12:10:00',2.32),('11288','2013-06-03','12:15:00',2.35),('11288','2013-06-03','12:20:00',2.55),('11288','2013-06-03','12:25:00',2.22),('11288','2013-06-03','12:30:00',2.53),('11288','2013-06-03','12:35:00',4.56),('11288','2013-06-03','12:40:00',9.58),('11288','2013-06-03','12:45:00',5.03),('11288','2013-06-03','12:50:00',4.02),('11288','2013-06-03','12:55:00',6.48),('11288','2013-06-03','13:00:00',5.46),('11288','2013-06-03','13:05:00',4.65),('11288','2013-06-03','13:10:00',4.52),('11288','2013-06-03','13:15:00',7.81),('11288','2013-06-03','13:20:00',8.85),('11288','2013-06-03','13:25:00',7.99),('11288','2013-06-03','13:30:00',7.35),('11288','2013-06-03','13:35:00',8.18),('11288','2013-06-03','13:40:00',7.89),('11288','2013-06-03','13:45:00',8.29),('11288','2013-06-03','13:50:00',7.99),('11288','2013-06-03','13:55:00',3.07),('11288','2013-06-03','14:00:00',5.21),('11288','2013-06-03','14:05:00',6.02),('11288','2013-06-03','14:10:00',4.44),('11288','2013-06-03','14:15:00',4.93),('11288','2013-06-03','14:20:00',5.92),('11288','2013-06-03','14:25:00',4.98),('11288','2013-06-03','14:30:00',8.32),('11288','2013-06-03','14:35:00',8.36),('11288','2013-06-03','14:40:00',5.44),('11288','2013-06-03','14:45:00',5.51),('11288','2013-06-03','14:50:00',4.12),('11288','2013-06-03','14:55:00',6.49),('11288','2013-06-03','15:00:00',7.64),('11288','2013-06-03','15:05:00',7.2),('11288','2013-06-03','15:10:00',6.17),('11288','2013-06-03','15:15:00',7.83),('11288','2013-06-03','15:20:00',5.11),('11288','2013-06-03','15:25:00',7.07),('11288','2013-06-03','15:30:00',6.92),('11288','2013-06-03','15:35:00',6.82),('11288','2013-06-03','15:40:00',6.67),('11288','2013-06-03','15:45:00',6.54),('11288','2013-06-03','15:50:00',6.51),('11288','2013-06-03','15:55:00',6.47),('11288','2013-06-03','16:00:00',6.36),('11288','2013-06-03','16:05:00',6.27),('11288','2013-06-03','16:10:00',6.28),('11288','2013-06-03','16:15:00',6.07),('11288','2013-06-03','16:20:00',5.55),('11288','2013-06-03','16:25:00',5.89),('11288','2013-06-03','16:30:00',6.07),('11288','2013-06-03','16:35:00',5.83),('11288','2013-06-03','16:40:00',5.8),('11288','2013-06-03','16:45:00',5.04),('11288','2013-06-03','16:50:00',4.2),('11288','2013-06-03','16:55:00',3.49),('11288','2013-06-03','17:00:00',4.56),('11288','2013-06-03','17:05:00',5.42),('11288','2013-06-03','17:10:00',4.91),('11288','2013-06-03','17:15:00',3.93),('11288','2013-06-03','17:20:00',3.85),('11288','2013-06-03','17:25:00',2.74),('11288','2013-06-03','17:30:00',1.58),('11288','2013-06-03','17:35:00',1.26),('11288','2013-06-03','17:40:00',1.3),('11288','2013-06-03','17:45:00',1.12),('11288','2013-06-03','17:50:00',1.21),('11288','2013-06-03','17:55:00',1.21),('11288','2013-06-03','18:00:00',1.04),('11288','2013-06-02','06:50:00',1.16),('11288','2013-06-02','06:55:00',1.52),('11288','2013-06-02','07:00:00',1.3),('11288','2013-06-02','07:05:00',1.07),('11288','2013-06-02','08:25:00',1.45),('11288','2013-06-02','08:30:00',1.58),('11288','2013-06-02','08:35:00',1.79),('11288','2013-06-02','08:40:00',1.75),('11288','2013-06-02','08:45:00',1.89),('11288','2013-06-02','08:50:00',1.91),('11288','2013-06-02','08:55:00',1.72),('11288','2013-06-02','09:00:00',1.74),('11288','2013-06-02','09:05:00',1.86),('11288','2013-06-02','09:10:00',2.04),('11288','2013-06-02','09:15:00',2.3),('11288','2013-06-02','09:20:00',4.19),('11288','2013-06-02','09:25:00',5.57),('11288','2013-06-02','09:30:00',5.2),('11288','2013-06-02','09:35:00',5.38),('11288','2013-06-02','09:40:00',5.23),('11288','2013-06-02','09:45:00',5.15),('11288','2013-06-02','09:50:00',5.47),('11288','2013-06-02','09:55:00',5.7),('11288','2013-06-02','10:00:00',5.79),('11288','2013-06-02','10:05:00',5.97),('11288','2013-06-02','10:10:00',6.04),('11288','2013-06-02','10:15:00',6.18),('11288','2013-06-02','10:20:00',5.86),('11288','2013-06-02','10:25:00',6.31),('11288','2013-06-02','10:30:00',6.75),('11288','2013-06-02','10:35:00',4.97),('11288','2013-06-02','10:40:00',7.16),('11288','2013-06-02','10:45:00',4.24),('11288','2013-06-02','10:50:00',6.6),('11288','2013-06-02','10:55:00',7.59),('11288','2013-06-02','11:00:00',7.93),('11288','2013-06-02','11:05:00',6.59),('11288','2013-06-02','11:10:00',2.86),('11288','2013-06-02','11:15:00',6.42),('11288','2013-06-02','11:20:00',7.9),('11288','2013-06-02','11:25:00',5.73),('11288','2013-06-02','11:30:00',3.1),('11288','2013-06-02','11:35:00',4.83),('11288','2013-06-02','11:40:00',4.48),('11288','2013-06-02','11:45:00',3.12),('11288','2013-06-02','11:50:00',2.3),('11288','2013-06-02','11:55:00',4.76),('11288','2013-06-02','12:00:00',4.5),('11288','2013-06-02','12:05:00',3.43),('11288','2013-06-02','12:10:00',8.22),('11288','2013-06-02','12:15:00',4.98),('11288','2013-06-02','12:20:00',7.45),('11288','2013-06-02','12:25:00',4.87),('11288','2013-06-02','12:30:00',6.58),('11288','2013-06-02','12:35:00',6.72),('11288','2013-06-02','12:40:00',7.95),('11288','2013-06-02','12:45:00',4.92),('11288','2013-06-02','12:50:00',6.35),('11288','2013-06-02','12:55:00',5.99),('11288','2013-06-02','13:00:00',4.18),('11288','2013-06-02','13:05:00',8.63),('11288','2013-06-02','13:10:00',8.18),('11288','2013-06-02','13:15:00',7.83),('11288','2013-06-02','13:20:00',7.68),('11288','2013-06-02','13:25:00',7.6),('11288','2013-06-02','13:30:00',7.57),('11288','2013-06-02','13:35:00',7.55),('11288','2013-06-02','13:40:00',7.52),('11288','2013-06-02','13:45:00',7.52),('11288','2013-06-02','13:50:00',7.48),('11288','2013-06-02','13:55:00',7.43),('11288','2013-06-02','14:00:00',7.35),('11288','2013-06-02','14:05:00',7.41),('11288','2013-06-02','14:10:00',7.48),('11288','2013-06-02','14:15:00',7.37),('11288','2013-06-02','14:20:00',7.31),('11288','2013-06-02','14:25:00',7.3),('11288','2013-06-02','14:30:00',7.28),('11288','2013-06-02','14:35:00',7.14),('11288','2013-06-02','14:40:00',7.14),('11288','2013-06-02','14:45:00',7.1),('11288','2013-06-02','14:50:00',7.08),('11288','2013-06-02','14:55:00',7.03),('11288','2013-06-02','15:00:00',6.98),('11288','2013-06-02','15:05:00',6.81),('11288','2013-06-02','15:10:00',6.77),('11288','2013-06-02','15:15:00',6.79),('11288','2013-06-02','15:20:00',5.09),('11288','2013-06-02','15:25:00',7.04),('11288','2013-06-02','15:30:00',5.51),('11288','2013-06-02','15:35:00',6.15),('11288','2013-06-02','15:40:00',5.36),('11288','2013-06-02','15:45:00',6.01),('11288','2013-06-02','15:50:00',4.8),('11288','2013-06-02','15:55:00',6.71),('11288','2013-06-02','16:00:00',6.47),('11288','2013-06-02','16:05:00',5.31),('11288','2013-06-02','16:10:00',5.32),('11288','2013-06-02','16:15:00',6.08),('11288','2013-06-02','16:20:00',5.95),('11288','2013-06-02','16:25:00',5.82),('11288','2013-06-02','16:30:00',5.4),('11288','2013-06-02','16:35:00',5.42),('11288','2013-06-02','16:40:00',5.44),('11288','2013-06-02','16:45:00',5.18),('11288','2013-06-02','16:50:00',5.13),('11288','2013-06-02','16:55:00',4.95),('11288','2013-06-02','17:00:00',4.37),('11288','2013-06-02','17:05:00',4.73),('11288','2013-06-02','17:10:00',4.54),('11288','2013-06-02','17:15:00',4.46),('11288','2013-06-02','17:20:00',4.26),('11288','2013-06-02','17:25:00',4.09),('11288','2013-06-02','17:30:00',2.94),('11288','2013-06-02','17:35:00',2.64),('11288','2013-06-02','17:40:00',1.5),('11288','2013-06-02','17:45:00',3.06),('11288','2013-06-02','17:50:00',1.84),('11288','2013-06-02','17:55:00',2.54),('11288','2013-06-02','18:00:00',1.48),('11288','2013-06-02','18:05:00',1.14),('11288','2013-06-02','18:10:00',2.41),('11288','2013-06-02','18:15:00',1.33),('11288','2013-06-02','18:20:00',1.13),('11288','2013-06-02','18:25:00',1.51),('11288','2013-06-02','18:30:00',1.81),('11288','2013-06-02','18:35:00',1.15),('11288','2013-06-02','18:40:00',1.03),('11288','2013-06-02','18:45:00',1.05),('11288','2013-06-01','07:10:00',1.07),('11288','2013-06-01','07:15:00',1.16),('11288','2013-06-01','07:20:00',1.25),('11288','2013-06-01','07:25:00',1.33),('11288','2013-06-01','07:30:00',1.51),('11288','2013-06-01','07:35:00',1.58),('11288','2013-06-01','07:40:00',1.76),('11288','2013-06-01','07:45:00',2.06),('11288','2013-06-01','07:50:00',1.84),('11288','2013-06-01','07:55:00',2.31),('11288','2013-06-01','08:00:00',1.27),('11288','2013-06-01','08:05:00',1.17),('11288','2013-06-01','08:10:00',1.95),('11288','2013-06-01','08:15:00',2.88),('11288','2013-06-01','08:20:00',1.98),('11288','2013-06-01','08:25:00',1.65),('11288','2013-06-01','08:30:00',2.66),('11288','2013-06-01','08:35:00',1.96),('11288','2013-06-01','08:40:00',1.46),('11288','2013-06-01','08:45:00',1.05),('11288','2013-06-01','08:50:00',1.38),('11288','2013-06-01','08:55:00',1.34),('11288','2013-06-01','09:00:00',1.76),('11288','2013-06-01','09:05:00',1.05),('11288','2013-06-01','09:40:00',1.29),('11288','2013-06-01','09:45:00',1.62),('11288','2013-06-01','09:50:00',1.66),('11288','2013-06-01','09:55:00',1.29),('11288','2013-06-01','10:00:00',1.22),('11288','2013-06-01','10:05:00',1.34),('11288','2013-06-01','10:10:00',1.26),('11288','2013-06-01','10:15:00',1.03),('11288','2013-06-01','10:30:00',1.87),('11288','2013-06-01','10:35:00',2.44),('11288','2013-06-01','10:40:00',1.94),('11288','2013-06-01','10:45:00',1.78),('11288','2013-06-01','10:50:00',5.04),('11288','2013-06-01','10:55:00',3.76),('11288','2013-06-01','11:00:00',1.08),('11288','2013-06-01','11:45:00',1.28),('11288','2013-06-01','11:50:00',2.77),('11288','2013-06-01','11:55:00',3.22),('11288','2013-06-01','12:00:00',6.98),('11288','2013-06-01','12:05:00',4.85),('11288','2013-06-01','12:10:00',5.13),('11288','2013-06-01','12:15:00',2.29),('11288','2013-06-01','12:20:00',1.88),('11288','2013-06-01','12:25:00',2.31),('11288','2013-06-01','12:30:00',2.07),('11288','2013-06-01','12:35:00',1.65),('11288','2013-06-01','12:40:00',2.28),('11288','2013-06-01','12:45:00',3.42),('11288','2013-06-01','12:50:00',3.62),('11288','2013-06-01','12:55:00',3.84),('11288','2013-06-01','13:00:00',4.12),('11288','2013-06-01','13:05:00',4.28),('11288','2013-06-01','13:10:00',4.55),('11288','2013-06-01','13:15:00',4.77),('11288','2013-06-01','13:20:00',3.88),('11288','2013-06-01','13:25:00',3.31),('11288','2013-06-01','13:30:00',2.78),('11288','2013-06-01','13:35:00',2.22),('11288','2013-06-01','13:40:00',1.99),('11288','2013-06-01','13:45:00',2.21),('11288','2013-06-01','13:50:00',2.47),('11288','2013-06-01','13:55:00',2.81),('11288','2013-06-01','14:00:00',3.97),('11288','2013-06-01','14:05:00',4.28),('11288','2013-06-01','14:10:00',4.23),('11288','2013-06-01','14:15:00',4.71),('11288','2013-06-01','14:20:00',4.16),('11288','2013-06-01','14:25:00',2.83),('11288','2013-06-01','14:30:00',2.46),('11288','2013-06-01','14:35:00',2.49),('11288','2013-06-01','14:40:00',2.29),('11288','2013-06-01','14:45:00',2.21),('11288','2013-06-01','14:50:00',2.09),('11288','2013-06-01','14:55:00',1.65),('11288','2013-06-01','15:00:00',1.7),('11288','2013-06-01','15:05:00',1.58),('11288','2013-06-01','15:10:00',1.3),('11288','2013-06-01','15:15:00',1.42),('11288','2013-06-01','15:20:00',1.3),('11288','2013-06-01','15:45:00',1.08),('11288','2013-06-01','15:50:00',1.07),('11288','2013-06-01','15:55:00',1.09),('11288','2013-06-01','16:00:00',1.21),('11288','2013-06-01','16:05:00',1.29),('11288','2013-06-01','16:10:00',1.22),('11288','2013-06-01','16:15:00',1.4),('11288','2013-06-01','16:20:00',1.47),('11288','2013-06-01','16:25:00',1.13),('11288','2013-06-01','16:30:00',1.38),('11288','2013-06-01','16:35:00',1.52),('11288','2013-06-01','16:40:00',1.71),('11288','2013-06-01','16:45:00',1.43),('11288','2013-06-01','16:50:00',1.3),('11288','2013-06-01','16:55:00',1.14),('11288','2013-06-01','18:25:00',1.22),('11288','2013-06-01','18:30:00',1.84),('11288','2013-06-01','18:35:00',1.87),('11288','2013-06-01','18:40:00',1.33),('11288','2013-06-01','18:45:00',1.41),('11288','2013-06-01','18:50:00',1.26),('11288','2013-06-01','18:55:00',1.38),('11288','2013-06-01','19:00:00',2.33),('11288','2013-06-01','19:05:00',1.55),('11288','2014-04-02','07:55:00',1.11),('11288','2014-04-02','08:00:00',1.28),('11288','2014-04-02','08:30:00',1.17),('11288','2014-04-02','08:35:00',1.52),('11288','2014-04-02','08:40:00',1.39),('11288','2014-04-02','08:45:00',1.37),('11288','2014-04-02','08:50:00',2.01),('11288','2014-04-02','08:55:00',1.96),('11288','2014-04-02','09:00:00',1.31),('11288','2014-04-02','09:05:00',1.09),('11288','2014-04-02','09:10:00',1.3),('11288','2014-04-02','09:15:00',1.76),('11288','2014-04-02','09:20:00',1.41),('11288','2014-04-02','09:25:00',1.23),('11288','2014-04-02','09:30:00',1.27),('11288','2014-04-02','09:35:00',1.43),('11288','2014-04-02','09:40:00',1.31),('11288','2014-04-02','09:45:00',1.15),('11288','2014-04-02','09:50:00',2.06),('11288','2014-04-02','09:55:00',3.79),('11288','2014-04-02','10:00:00',3.24),('11288','2014-04-02','10:05:00',4.2),('11288','2014-04-02','10:10:00',5.12),('11288','2014-04-02','10:15:00',4.32),('11288','2014-04-02','10:20:00',3.63),('11288','2014-04-02','10:25:00',2.85),('11288','2014-04-02','10:30:00',1.98),('11288','2014-04-02','10:35:00',2.18),('11288','2014-04-02','10:40:00',2.22),('11288','2014-04-02','10:45:00',3.74),('11288','2014-04-02','10:50:00',5.51),('11288','2014-04-02','10:55:00',6.17),('11288','2014-04-02','11:00:00',3.06),('11288','2014-04-02','11:05:00',1.94),('11288','2014-04-02','11:10:00',2.24),('11288','2014-04-02','11:15:00',5.17),('11288','2014-04-02','11:20:00',5.64),('11288','2014-04-02','11:25:00',6.99),('11288','2014-04-02','11:30:00',5.84),('11288','2014-04-02','11:35:00',2.05),('11288','2014-04-02','11:40:00',1.93),('11288','2014-04-02','11:45:00',4.09),('11288','2014-04-02','11:50:00',5.62),('11288','2014-04-02','11:55:00',6.73),('11288','2014-04-02','12:00:00',4.51),('11288','2014-04-02','12:05:00',3.66),('11288','2014-04-02','12:10:00',2.46),('11288','2014-04-02','12:15:00',2.71),('11288','2014-04-02','12:20:00',5.01),('11288','2014-04-02','12:25:00',3.08),('11288','2014-04-02','12:30:00',7.71),('11288','2014-04-02','12:35:00',3.55),('11288','2014-04-02','12:40:00',7),('11288','2014-04-02','12:45:00',6.96),('11288','2014-04-02','12:50:00',5.68),('11288','2014-04-02','12:55:00',2.19),('11288','2014-04-02','13:00:00',7.01),('11288','2014-04-02','13:05:00',7.73),('11288','2014-04-02','13:10:00',7.53),('11288','2014-04-02','13:15:00',7.33),('11288','2014-04-02','13:20:00',6.89),('11288','2014-04-02','13:25:00',6.86),('11288','2014-04-02','13:30:00',6.92),('11288','2014-04-02','13:35:00',6.93),('11288','2014-04-02','13:40:00',6.9),('11288','2014-04-02','13:45:00',6.65),('11288','2014-04-02','13:50:00',6.63),('11288','2014-04-02','13:55:00',6.66),('11288','2014-04-02','14:00:00',6.54),('11288','2014-04-02','14:05:00',6.52),('11288','2014-04-02','14:10:00',5.85),('11288','2014-04-02','14:15:00',6.45),('11288','2014-04-02','14:20:00',6.45),('11288','2014-04-02','14:25:00',6.46),('11288','2014-04-02','14:30:00',6.36),('11288','2014-04-02','14:35:00',6.34),('11288','2014-04-02','14:40:00',6.23),('11288','2014-04-02','14:45:00',5.26),('11288','2014-04-02','14:50:00',5.36),('11288','2014-04-02','14:55:00',5.55),('11288','2014-04-02','15:00:00',5.67),('11288','2014-04-02','15:05:00',5.87),('11288','2014-04-02','15:10:00',5.48),('11288','2014-04-02','15:15:00',5.59),('11288','2014-04-02','15:20:00',5.57),('11288','2014-04-02','15:25:00',5.53),('11288','2014-04-02','15:30:00',5.15),('11288','2014-04-02','15:35:00',5.11),('11288','2014-04-02','15:40:00',5.17),('11288','2014-04-02','15:45:00',5.34),('11288','2014-04-02','15:50:00',5.21),('11288','2014-04-02','15:55:00',4.54),('11288','2014-04-02','16:00:00',4.75),('11288','2014-04-02','16:05:00',4.7),('11288','2014-04-02','16:10:00',4.54),('11288','2014-04-02','16:15:00',4.41),('11288','2014-04-02','16:20:00',4.29),('11288','2014-04-02','16:25:00',3.97),('11288','2014-04-02','16:30:00',4.19),('11288','2014-04-02','16:35:00',4.05),('11288','2014-04-02','16:40:00',3.88),('11288','2014-04-02','16:45:00',3.73),('11288','2014-04-02','16:50:00',3.43),('11288','2014-04-02','16:55:00',3.4),('11288','2014-04-02','17:00:00',3.38),('11288','2014-04-02','17:05:00',3.04),('11288','2014-04-02','17:10:00',2.88),('11288','2014-04-02','17:15:00',2.56),('11288','2014-04-02','17:20:00',2.56),('11288','2014-04-02','17:25:00',2.41),('11288','2014-04-02','17:30:00',2.13),('11288','2014-04-02','17:35:00',2.11),('11288','2014-04-02','17:40:00',1.54),('11288','2014-04-02','17:45:00',1.53),('11288','2014-04-02','17:50:00',1.93),('11288','2014-04-02','17:55:00',1.67),('11288','2014-04-02','18:00:00',1.52),('11288','2014-04-02','18:05:00',1.02),('11288','2013-05-31','07:05:00',1.01),('11288','2013-05-31','07:10:00',1.13),('11288','2013-05-31','07:15:00',1.22),('11288','2013-05-31','07:20:00',1.33),('11288','2013-05-31','07:25:00',1.47),('11288','2013-05-31','07:30:00',1.58),('11288','2013-05-31','07:35:00',1.68),('11288','2013-05-31','07:40:00',1.82),('11288','2013-05-31','07:45:00',1.86),('11288','2013-05-31','07:50:00',2.18),('11288','2013-05-31','07:55:00',2.39),('11288','2013-05-31','08:00:00',2.38),('11288','2013-05-31','08:05:00',2.59),('11288','2013-05-31','08:10:00',2.73),('11288','2013-05-31','08:15:00',2.56),('11288','2013-05-31','08:20:00',2.77),('11288','2013-05-31','08:25:00',3.24),('11288','2013-05-31','08:30:00',2.72),('11288','2013-05-31','08:35:00',3.7),('11288','2013-05-31','08:40:00',1.66),('11288','2013-05-31','08:45:00',3.27),('11288','2013-05-31','08:50:00',3.39),('11288','2013-05-31','08:55:00',2.14),('11288','2013-05-31','09:00:00',1.57),('11288','2013-05-31','09:05:00',1.33),('11288','2013-05-31','09:10:00',1.76),('11288','2013-05-31','09:15:00',1.66),('11288','2013-05-31','09:20:00',1.63),('11288','2013-05-31','09:25:00',1.89),('11288','2013-05-31','09:30:00',4.22),('11288','2013-05-31','09:35:00',4.29),('11288','2013-05-31','09:40:00',3.47),('11288','2013-05-31','09:45:00',6.06),('11288','2013-05-31','09:50:00',5.36),('11288','2013-05-31','09:55:00',5.52),('11288','2013-05-31','10:00:00',5.63),('11288','2013-05-31','10:05:00',5.53),('11288','2013-05-31','10:10:00',5.17),('11288','2013-05-31','10:15:00',6.62),('11288','2013-05-31','10:20:00',5.6),('11288','2013-05-31','10:25:00',2.95),('11288','2013-05-31','10:30:00',3.77),('11288','2013-05-31','10:35:00',3.92),('11288','2013-05-31','10:40:00',7.29),('11288','2013-05-31','10:45:00',6.22),('11288','2013-05-31','10:50:00',4.62),('11288','2013-05-31','10:55:00',6.73),('11288','2013-05-31','11:00:00',2.7),('11288','2013-05-31','11:05:00',5.41),('11288','2013-05-31','11:10:00',8.42),('11288','2013-05-31','11:15:00',7.21),('11288','2013-05-31','11:20:00',2.39),('11288','2013-05-31','11:25:00',4.23),('11288','2013-05-31','11:30:00',4.58),('11288','2013-05-31','11:35:00',4.63),('11288','2013-05-31','11:40:00',1.61),('11288','2013-05-31','11:45:00',8.02),('11288','2013-05-31','11:50:00',5.38),('11288','2013-05-31','11:55:00',6.73),('11288','2013-05-31','12:00:00',3.46),('11288','2013-05-31','12:05:00',8.74),('11288','2013-05-31','12:10:00',5.87),('11288','2013-05-31','12:15:00',2.85),('11288','2013-05-31','12:20:00',3.43),('11288','2013-05-31','12:25:00',6.22),('11288','2013-05-31','12:30:00',3.06),('11288','2013-05-31','12:35:00',3.6),('11288','2013-05-31','12:40:00',6.66),('11288','2013-05-31','12:45:00',3.11),('11288','2013-05-31','12:50:00',1.69),('11288','2013-05-31','12:55:00',2.82),('11288','2013-05-31','13:00:00',8.94),('11288','2013-05-31','13:05:00',2.8),('11288','2013-05-31','13:10:00',1.25),('11288','2013-05-31','13:15:00',1.39),('11288','2013-05-31','13:20:00',2.41),('11288','2013-05-31','13:25:00',3.53),('11288','2013-05-31','13:30:00',7.58),('11288','2013-05-31','13:35:00',8.79),('11288','2013-05-31','13:40:00',3.71),('11288','2013-05-31','13:45:00',2.2),('11288','2013-05-31','13:50:00',1.23),('11288','2013-05-31','13:55:00',3),('11288','2013-05-31','14:00:00',3.15),('11288','2013-05-31','14:05:00',1.7),('11288','2013-05-31','14:10:00',1.33),('11288','2013-05-31','14:15:00',1.36),('11288','2013-05-31','14:20:00',1.58),('11288','2013-05-31','14:25:00',1.94),('11288','2013-05-31','14:30:00',1.5),('11288','2013-05-31','14:45:00',1.32),('11288','2013-05-31','14:50:00',1.63),('11288','2013-05-31','14:55:00',1.11),('11288','2013-05-31','15:00:00',1.97),('11288','2013-05-31','15:05:00',3.13),('11288','2013-05-31','15:10:00',3.52),('11288','2013-05-31','15:15:00',5.74),('11288','2013-05-31','15:20:00',8.04),('11288','2013-05-31','15:25:00',5.64),('11288','2013-05-31','15:30:00',4.24),('11288','2013-05-31','15:35:00',3.66),('11288','2013-05-31','15:40:00',3.13),('11288','2013-05-31','15:45:00',2.99),('11288','2013-05-31','15:50:00',4.4),('11288','2013-05-31','15:55:00',4.02),('11288','2013-05-31','16:00:00',2.69),('11288','2013-05-31','16:05:00',2.41),('11288','2013-05-31','16:10:00',1.81),('11288','2013-05-31','16:15:00',1.71),('11288','2013-05-31','16:20:00',2.1),('11288','2013-05-31','16:25:00',2.54),('11288','2013-05-31','16:30:00',2.24),('11288','2013-05-31','16:35:00',1.96),('11288','2013-05-31','16:40:00',2.27),('11288','2013-05-31','16:45:00',2.23),('11288','2013-05-31','16:50:00',1.55),('11288','2013-05-31','16:55:00',1.2),('11288','2013-05-31','17:00:00',1.15),('11288','2013-05-31','17:05:00',1.14),('11288','2013-05-31','17:10:00',1.08),('11288','2013-05-31','17:15:00',1.18),('11288','2013-05-31','17:20:00',1.34),('11288','2013-05-31','17:25:00',1.45),('11288','2013-05-31','17:30:00',1.42),('11288','2013-05-31','17:35:00',1.16),('11288','2013-05-31','17:40:00',1.03),('11288','2013-05-31','17:45:00',1.09),('11288','2013-05-30','07:40:00',1.25),('11288','2013-05-30','07:45:00',1.77),('11288','2013-05-30','07:50:00',2.13),('11288','2013-05-30','07:55:00',1.47),('11288','2013-05-30','08:00:00',1.27),('11288','2013-05-30','08:10:00',1.29),('11288','2013-05-30','08:15:00',1.4),('11288','2013-05-30','08:20:00',1.72),('11288','2013-05-30','08:25:00',2.66),('11288','2013-05-30','08:30:00',1.69),('11288','2013-05-30','08:35:00',1.99),('11288','2013-05-30','08:40:00',3.93),('11288','2013-05-30','08:45:00',3.95),('11288','2013-05-30','08:50:00',4.02),('11288','2013-05-30','08:55:00',4.11),('11288','2013-05-30','09:00:00',4.06),('11288','2013-05-30','09:05:00',4.42),('11288','2013-05-30','09:10:00',4.58),('11288','2013-05-30','09:15:00',4.33),('11288','2013-05-30','09:20:00',4.92),('11288','2013-05-30','09:25:00',5.08),('11288','2013-05-30','09:30:00',4.76),('11288','2013-05-30','09:35:00',5.4),('11288','2013-05-30','09:40:00',5.65),('11288','2013-05-30','09:45:00',5.2),('11288','2013-05-30','09:50:00',5.92),('11288','2013-05-30','09:55:00',3.39),('11288','2013-05-30','10:00:00',2.46),('11288','2013-05-30','10:05:00',2.12),('11288','2013-05-30','10:10:00',5.08),('11288','2013-05-30','10:15:00',4.63),('11288','2013-05-30','10:20:00',6.47),('11288','2013-05-30','10:25:00',2.23),('11288','2013-05-30','10:30:00',3.88),('11288','2013-05-30','10:35:00',3.57),('11288','2013-05-30','10:40:00',6.48),('11288','2013-05-30','10:45:00',6.96),('11288','2013-05-30','10:50:00',4.37),('11288','2013-05-30','10:55:00',7.54),('11288','2013-05-30','11:00:00',8.13),('11288','2013-05-30','11:05:00',8.44),('11288','2013-05-30','11:10:00',2.69),('11288','2013-05-30','11:15:00',6.06),('11288','2013-05-30','11:20:00',5.87),('11288','2013-05-30','11:25:00',4.13),('11288','2013-05-30','11:30:00',8.65),('11288','2013-05-30','11:35:00',6.91),('11288','2013-05-30','11:40:00',8.31),('11288','2013-05-30','11:45:00',6.63),('11288','2013-05-30','11:50:00',6.44),('11288','2013-05-30','11:55:00',4.52),('11288','2013-05-30','12:00:00',8.67),('11288','2013-05-30','12:05:00',6.22),('11288','2013-05-30','12:10:00',4.61),('11288','2013-05-30','12:15:00',5.96),('11288','2013-05-30','12:20:00',5.11),('11288','2013-05-30','12:25:00',8.88),('11288','2013-05-30','12:30:00',6.09),('11288','2013-05-30','12:35:00',5.68),('11288','2013-05-30','12:40:00',7.83),('11288','2013-05-30','12:45:00',6.74),('11288','2013-05-30','12:50:00',7.83),('11288','2013-05-30','12:55:00',7.88),('11288','2013-05-30','13:00:00',8.81),('11288','2013-05-30','13:05:00',5.53),('11288','2013-05-30','13:10:00',5.04),('11288','2013-05-30','13:15:00',2.98),('11288','2013-05-30','13:20:00',3.61),('11288','2013-05-30','13:25:00',3.4),('11288','2013-05-30','13:30:00',3.68),('11288','2013-05-30','13:35:00',4.44),('11288','2013-05-30','13:40:00',7.65),('11288','2013-05-30','13:45:00',6.73),('11288','2013-05-30','13:50:00',2.61),('11288','2013-05-30','13:55:00',4.08),('11288','2013-05-30','14:00:00',7),('11288','2013-05-30','14:05:00',8.91),('11288','2013-05-30','14:10:00',8.23),('11288','2013-05-30','14:15:00',8.87),('11288','2013-05-30','14:20:00',5.88),('11288','2013-05-30','14:25:00',7.87),('11288','2013-05-30','14:30:00',6.06),('11288','2013-05-30','14:35:00',7.29),('11288','2013-05-30','14:40:00',8.06),('11288','2013-05-30','14:45:00',8.03),('11288','2013-05-30','14:50:00',7.92),('11288','2013-05-30','14:55:00',6.68),('11288','2013-05-30','15:00:00',7.23),('11288','2013-05-30','15:05:00',5.29),('11288','2013-05-30','15:10:00',4.1),('11288','2013-05-30','15:15:00',6.45),('11288','2013-05-30','15:20:00',7.71),('11288','2013-05-30','15:25:00',7.51),('11288','2013-05-30','15:30:00',6.02),('11288','2013-05-30','15:35:00',6.91),('11288','2013-05-30','15:40:00',6.88),('11288','2013-05-30','15:45:00',7.34),('11288','2013-05-30','15:50:00',3.65),('11288','2013-05-30','15:55:00',7.56),('11288','2013-05-30','16:00:00',7.01),('11288','2013-05-30','16:05:00',7.3),('11288','2013-05-30','16:10:00',6.78),('11288','2013-05-30','16:15:00',6.39),('11288','2013-05-30','16:20:00',5.89),('11288','2013-05-30','16:25:00',4.61),('11288','2013-05-30','16:30:00',3.71),('11288','2013-05-30','16:35:00',3.83),('11288','2013-05-30','16:40:00',1.88),('11288','2013-05-30','16:45:00',4.74),('11288','2013-05-30','16:50:00',4.27),('11288','2013-05-30','16:55:00',3.97),('11288','2013-05-30','17:00:00',2.64),('11288','2013-05-30','17:05:00',2.99),('11288','2013-05-30','17:10:00',1.52),('11288','2013-05-30','17:15:00',1.84),('11288','2013-05-30','17:20:00',2.53),('11288','2013-05-30','17:25:00',1.72),('11288','2013-05-30','17:30:00',2.16),('11288','2013-05-30','17:35:00',1.24),('11288','2013-05-30','17:55:00',1.11),('11288','2013-05-30','18:00:00',1.89),('11288','2013-05-30','18:05:00',1.89),('11288','2013-05-30','18:10:00',2.09),('11288','2013-05-30','18:15:00',1.49),('11288','2013-05-30','18:20:00',1.37),('11288','2013-05-30','18:25:00',1.46),('11288','2013-05-30','18:30:00',1.74),('11288','2013-05-30','18:35:00',2.44),('11288','2013-05-30','18:40:00',2.35),('11288','2013-05-30','18:45:00',2.73),('11288','2013-05-30','18:50:00',2.26),('11288','2013-05-30','18:55:00',1.22),('11288','2013-05-30','19:00:00',1.08),('11288','2013-05-29','07:10:00',1.03),('11288','2013-05-29','07:15:00',1.13),('11288','2013-05-29','07:20:00',1.21),('11288','2013-05-29','07:25:00',1.28),('11288','2013-05-29','07:30:00',1.44),('11288','2013-05-29','07:35:00',1.52),('11288','2013-05-29','07:40:00',1.64),('11288','2013-05-29','07:45:00',1.68),('11288','2013-05-29','07:50:00',1.98),('11288','2013-05-29','07:55:00',2.23),('11288','2013-05-29','08:00:00',2.1),('11288','2013-05-29','08:05:00',2.5),('11288','2013-05-29','08:10:00',2.62),('11288','2013-05-29','08:15:00',2.6),('11288','2013-05-29','08:20:00',2.9),('11288','2013-05-29','08:25:00',3.06),('11288','2013-05-29','08:30:00',3.18),('11288','2013-05-29','08:35:00',3.42),('11288','2013-05-29','08:40:00',3.46),('11288','2013-05-29','08:45:00',3.65),('11288','2013-05-29','08:50:00',3.89),('11288','2013-05-29','08:55:00',3.97),('11288','2013-05-29','09:00:00',4),('11288','2013-05-29','09:05:00',4.26),('11288','2013-05-29','09:10:00',4.35),('11288','2013-05-29','09:15:00',4.51),('11288','2013-05-29','09:20:00',4.78),('11288','2013-05-29','09:25:00',4.82),('11288','2013-05-29','09:30:00',4.82),('11288','2013-05-29','09:35:00',5.08),('11288','2013-05-29','09:40:00',5.32),('11288','2013-05-29','09:45:00',5.47),('11288','2013-05-29','09:50:00',5.6),('11288','2013-05-29','09:55:00',5.75),('11288','2013-05-29','10:00:00',5.79),('11288','2013-05-29','10:05:00',5.96),('11288','2013-05-29','10:10:00',6.05),('11288','2013-05-29','10:15:00',6.17),('11288','2013-05-29','10:20:00',6.36),('11288','2013-05-29','10:25:00',6.46),('11288','2013-05-29','10:30:00',6.53),('11288','2013-05-29','10:35:00',6.64),('11288','2013-05-29','10:40:00',6.79),('11288','2013-05-29','10:45:00',6.87),('11288','2013-05-29','10:50:00',7.04),('11288','2013-05-29','10:55:00',7.06),('11288','2013-05-29','11:00:00',7.16),('11288','2013-05-29','11:05:00',7.35),('11288','2013-05-29','11:10:00',6.93),('11288','2013-05-29','11:15:00',6.95),('11288','2013-05-29','11:20:00',7.72),('11288','2013-05-29','11:25:00',7.13),('11288','2013-05-29','11:30:00',7.12),('11288','2013-05-29','11:35:00',5.9),('11288','2013-05-29','11:40:00',7.46),('11288','2013-05-29','11:45:00',5.28),('11288','2013-05-29','11:50:00',7.14),('11288','2013-05-29','11:55:00',6.88),('11288','2013-05-29','12:00:00',5.68),('11288','2013-05-29','12:05:00',7.25),('11288','2013-05-29','12:10:00',7.79),('11288','2013-05-29','12:15:00',6.24),('11288','2013-05-29','12:20:00',8.01),('11288','2013-05-29','12:25:00',8.04),('11288','2013-05-29','12:30:00',7.91),('11288','2013-05-29','12:35:00',8.06),('11288','2013-05-29','12:40:00',7.53),('11288','2013-05-29','12:45:00',6.75),('11288','2013-05-29','12:50:00',7.52),('11288','2013-05-29','12:55:00',7.05),('11288','2013-05-29','13:00:00',7.95),('11288','2013-05-29','13:05:00',6.97),('11288','2013-05-29','13:10:00',7.72),('11288','2013-05-29','13:15:00',5.78),('11288','2013-05-29','13:20:00',6.94),('11288','2013-05-29','13:25:00',8.46),('11288','2013-05-29','13:30:00',8.3),('11288','2013-05-29','13:35:00',6.45),('11288','2013-05-29','13:40:00',8.22),('11288','2013-05-29','13:45:00',7.33),('11288','2013-05-29','13:50:00',7.06),('11288','2013-05-29','13:55:00',6.83),('11288','2013-05-29','14:00:00',7.98),('11288','2013-05-29','14:05:00',7.54),('11288','2013-05-29','14:10:00',7.58),('11288','2013-05-29','14:15:00',7.73),('11288','2013-05-29','14:20:00',7.52),('11288','2013-05-29','14:25:00',7.79),('11288','2013-05-29','14:30:00',7.67),('11288','2013-05-29','14:35:00',5.14),('11288','2013-05-29','14:40:00',7.84),('11288','2013-05-29','14:45:00',7.43),('11288','2013-05-29','14:50:00',6.44),('11288','2013-05-29','14:55:00',7.09),('11288','2013-05-29','15:00:00',7.37),('11288','2013-05-29','15:05:00',6.85),('11288','2013-05-29','15:10:00',5.25),('11288','2013-05-29','15:15:00',5.26),('11288','2013-05-29','15:20:00',6.7),('11288','2013-05-29','15:25:00',4.88),('11288','2013-05-29','15:30:00',5.89),('11288','2013-05-29','15:35:00',5.25),('11288','2013-05-29','15:40:00',4.68),('11288','2013-05-29','15:45:00',5.45),('11288','2013-05-29','15:50:00',5.36),('11288','2013-05-29','15:55:00',4.89),('11288','2013-05-29','16:00:00',4.74),('11288','2013-05-29','16:05:00',4.87),('11288','2013-05-29','16:10:00',4.16),('11288','2013-05-29','16:15:00',4.06),('11288','2013-05-29','16:20:00',3.98),('11288','2013-05-29','16:25:00',4.02),('11288','2013-05-29','16:30:00',3.32),('11288','2013-05-29','16:35:00',3.44),('11288','2013-05-29','16:40:00',4.13),('11288','2013-05-29','16:45:00',3.74),('11288','2013-05-29','16:50:00',2.91),('11288','2013-05-29','16:55:00',2.71),('11288','2013-05-29','17:00:00',2.45),('11288','2013-05-29','17:05:00',1.32),('11288','2013-05-29','17:25:00',1.13),('11288','2013-05-29','17:30:00',1.39),('11288','2013-05-29','17:35:00',2.17),('11288','2013-05-29','17:40:00',2.83),('11288','2013-05-29','17:45:00',2.07),('11288','2013-05-29','17:50:00',1.53),('11288','2013-05-29','17:55:00',1.25),('11288','2013-05-29','18:00:00',1.79),('11288','2013-05-29','18:05:00',2.05),('11288','2013-05-29','18:10:00',2.19),('11288','2013-05-29','18:15:00',3.74),('11288','2013-05-29','18:20:00',2.53),('11288','2013-05-29','18:25:00',1.13),('11288','2013-05-29','18:50:00',1.01),('11288','2013-05-29','19:05:00',1.26),('11288','2013-05-29','19:10:00',1.19),('11288','2013-05-29','19:15:00',1.24),('11288','2013-05-28','07:10:00',1.15),('11288','2013-05-28','07:15:00',1.56),('11288','2013-05-28','07:20:00',1.76),('11288','2013-05-28','07:25:00',1.85),('11288','2013-05-28','07:30:00',1.5),('11288','2013-05-28','07:35:00',1.53),('11288','2013-05-28','07:40:00',1.79),('11288','2013-05-28','07:45:00',2.05),('11288','2013-05-28','07:50:00',2.14),('11288','2013-05-28','07:55:00',2.1),('11288','2013-05-28','08:00:00',2.18),('11288','2013-05-28','08:05:00',2.33),('11288','2013-05-28','08:10:00',2.63),('11288','2013-05-28','08:15:00',2.9),('11288','2013-05-28','08:20:00',3.1),('11288','2013-05-28','08:25:00',2.81),('11288','2013-05-28','08:30:00',3.19),('11288','2013-05-28','08:35:00',3.01),('11288','2013-05-28','08:40:00',2.71),('11288','2013-05-28','08:45:00',2.65),('11288','2013-05-28','08:50:00',2.96),('11288','2013-05-28','08:55:00',2.91),('11288','2013-05-28','09:00:00',3.01),('11288','2013-05-28','09:05:00',3.36),('11288','2013-05-28','09:10:00',3.05),('11288','2013-05-28','09:15:00',2.95),('11288','2013-05-28','09:20:00',3.43),('11288','2013-05-28','09:25:00',3.77),('11288','2013-05-28','09:30:00',4.04),('11288','2013-05-28','09:35:00',4.1),('11288','2013-05-28','09:40:00',3.96),('11288','2013-05-28','09:45:00',3.81),('11288','2013-05-28','09:50:00',3.92),('11288','2013-05-28','09:55:00',4.21),('11288','2013-05-28','10:00:00',3.88),('11288','2013-05-28','10:05:00',4.2),('11288','2013-05-28','10:10:00',4.61),('11288','2013-05-28','10:15:00',4.82),('11288','2013-05-28','10:20:00',5.01),('11288','2013-05-28','10:25:00',4.99),('11288','2013-05-28','10:30:00',5.4),('11288','2013-05-28','10:35:00',5.51),('11288','2013-05-28','10:40:00',4.88),('11288','2013-05-28','10:45:00',4.7),('11288','2013-05-28','10:50:00',5.03),('11288','2013-05-28','10:55:00',4.37),('11288','2013-05-28','11:00:00',4.39),('11288','2013-05-28','11:05:00',4.46),('11288','2013-05-28','11:10:00',4.26),('11288','2013-05-28','11:15:00',4.4),('11288','2013-05-28','11:20:00',3.95),('11288','2013-05-28','11:25:00',4.36),('11288','2013-05-28','11:30:00',7.13),('11288','2013-05-28','11:35:00',5.74),('11288','2013-05-28','11:40:00',7.06),('11288','2013-05-28','11:45:00',5.39),('11288','2013-05-28','11:50:00',2.06),('11288','2013-05-28','11:55:00',3.1),('11288','2013-05-28','12:00:00',2.8),('11288','2013-05-28','12:05:00',3.57),('11288','2013-05-28','12:10:00',5.22),('11288','2013-05-28','12:15:00',4.72),('11288','2013-05-28','12:20:00',4.26),('11288','2013-05-28','12:25:00',4.45),('11288','2013-05-28','12:30:00',4.82),('11288','2013-05-28','12:35:00',4.68),('11288','2013-05-28','12:40:00',4.84),('11288','2013-05-28','12:45:00',5.35),('11288','2013-05-28','12:50:00',4.76),('11288','2013-05-28','12:55:00',4.88),('11288','2013-05-28','13:00:00',4.96),('11288','2013-05-28','13:05:00',5.35),('11288','2013-05-28','13:10:00',5.51),('11288','2013-05-28','13:15:00',4.89),('11288','2013-05-28','13:20:00',5.36),('11288','2013-05-28','13:25:00',3.24),('11288','2013-05-28','13:30:00',3.89),('11288','2013-05-28','13:35:00',3.29),('11288','2013-05-28','13:40:00',3.77),('11288','2013-05-28','13:45:00',3.68),('11288','2013-05-28','13:50:00',4.74),('11288','2013-05-28','13:55:00',4.64),('11288','2013-05-28','14:00:00',4.75),('11288','2013-05-28','14:05:00',4.98),('11288','2013-05-28','14:10:00',7.05),('11288','2013-05-28','14:15:00',6.41),('11288','2013-05-28','14:20:00',4.54),('11288','2013-05-28','14:25:00',4.91),('11288','2013-05-28','14:30:00',6.09),('11288','2013-05-28','14:35:00',5.17),('11288','2013-05-28','14:40:00',5.79),('11288','2013-05-28','14:45:00',6.38),('11288','2013-05-28','14:50:00',5.09),('11288','2013-05-28','14:55:00',4.9),('11288','2013-05-28','15:00:00',4.66),('11288','2013-05-28','15:05:00',6),('11288','2013-05-28','15:10:00',3),('11288','2013-05-28','15:15:00',4.86),('11288','2013-05-28','15:20:00',5.35),('11288','2013-05-28','15:25:00',3.98),('11288','2013-05-28','15:30:00',2.74),('11288','2013-05-28','15:35:00',2.85),('11288','2013-05-28','15:40:00',4.91),('11288','2013-05-28','15:45:00',6.34),('11288','2013-05-28','15:50:00',5.42),('11288','2013-05-28','15:55:00',3.73),('11288','2013-05-28','16:00:00',2.89),('11288','2013-05-28','16:05:00',2.49),('11288','2013-05-28','16:10:00',2.55),('11288','2013-05-28','16:15:00',3.05),('11288','2013-05-28','16:20:00',4.46),('11288','2013-05-28','16:25:00',3.71),('11288','2013-05-28','16:30:00',4.65),('11288','2013-05-28','16:35:00',5.41),('11288','2013-05-28','16:40:00',5),('11288','2013-05-28','16:45:00',4.77),('11288','2013-05-28','16:50:00',4.71),('11288','2013-05-28','16:55:00',4.58),('11288','2013-05-28','17:00:00',4.42),('11288','2013-05-28','17:05:00',4.33),('11288','2013-05-28','17:10:00',4.18),('11288','2013-05-28','17:15:00',4.07),('11288','2013-05-28','17:20:00',3.92),('11288','2013-05-28','17:25:00',3.74),('11288','2013-05-28','17:30:00',3.63),('11288','2013-05-28','17:35:00',3.42),('11288','2013-05-28','17:40:00',3.33),('11288','2013-05-28','17:45:00',3.24),('11288','2013-05-28','17:50:00',3.11),('11288','2013-05-28','17:55:00',2.9),('11288','2013-05-28','18:00:00',2.97),('11288','2013-05-28','18:05:00',2.74),('11288','2013-05-28','18:10:00',1.44),('11288','2013-05-28','18:15:00',1.07),('11288','2013-05-28','18:30:00',1.24),('11288','2013-05-28','18:35:00',1.93),('11288','2013-05-28','18:40:00',1.83),('11288','2013-05-28','18:45:00',1.67),('11288','2013-05-28','18:50:00',1.56),('11288','2013-05-28','18:55:00',1.43),('11288','2013-05-28','19:00:00',1.29),('11288','2013-05-28','19:05:00',1.16),('11288','2013-05-28','19:10:00',1.05),('11288','2013-05-27','07:05:00',1.03),('11288','2013-05-27','07:10:00',1.03),('11288','2013-05-27','07:25:00',1.27),('11288','2013-05-27','07:30:00',1.55),('11288','2013-05-27','07:35:00',1.55),('11288','2013-05-27','07:40:00',1.67),('11288','2013-05-27','07:45:00',1.85),('11288','2013-05-27','07:50:00',2.11),('11288','2013-05-27','07:55:00',1.39),('11288','2013-05-27','08:00:00',2.32),('11288','2013-05-27','08:05:00',2.79),('11288','2013-05-27','08:10:00',2.52),('11288','2013-05-27','08:15:00',2.93),('11288','2013-05-27','08:20:00',2.11),('11288','2013-05-27','08:25:00',3.18),('11288','2013-05-27','08:30:00',3.37),('11288','2013-05-27','08:35:00',3.58),('11288','2013-05-27','08:40:00',3.69),('11288','2013-05-27','08:45:00',3.82),('11288','2013-05-27','08:50:00',3.95),('11288','2013-05-27','08:55:00',4.43),('11288','2013-05-27','09:00:00',4.57),('11288','2013-05-27','09:05:00',5.09),('11288','2013-05-27','09:10:00',2.81),('11288','2013-05-27','09:15:00',4.09),('11288','2013-05-27','09:20:00',2.69),('11288','2013-05-27','09:25:00',3.67),('11288','2013-05-27','09:30:00',5.36),('11288','2013-05-27','09:35:00',5.34),('11288','2013-05-27','09:40:00',5.59),('11288','2013-05-27','09:45:00',5.28),('11288','2013-05-27','09:50:00',4.4),('11288','2013-05-27','09:55:00',5.65),('11288','2013-05-27','10:00:00',4.26),('11288','2013-05-27','10:05:00',6.37),('11288','2013-05-27','10:10:00',6.56),('11288','2013-05-27','10:15:00',4.88),('11288','2013-05-27','10:20:00',3.11),('11288','2013-05-27','10:25:00',5.64),('11288','2013-05-27','10:30:00',4.26),('11288','2013-05-27','10:35:00',4.68),('11288','2013-05-27','10:40:00',8.01),('11288','2013-05-27','10:45:00',5.23),('11288','2013-05-27','10:50:00',5.15),('11288','2013-05-27','10:55:00',2.57),('11288','2013-05-27','11:00:00',6.04),('11288','2013-05-27','11:05:00',6.19),('11288','2013-05-27','11:10:00',7.7),('11288','2013-05-27','11:15:00',4.48),('11288','2013-05-27','11:20:00',6.98),('11288','2013-05-27','11:25:00',7.42),('11288','2013-05-27','11:30:00',5.53),('11288','2013-05-27','11:35:00',4.05),('11288','2013-05-27','11:40:00',7.3),('11288','2013-05-27','11:45:00',4.22),('11288','2013-05-27','11:50:00',4.83),('11288','2013-05-27','11:55:00',5.97),('11288','2013-05-27','12:00:00',7.71),('11288','2013-05-27','12:05:00',3.49),('11288','2013-05-27','12:10:00',8.78),('11288','2013-05-27','12:15:00',6.3),('11288','2013-05-27','12:20:00',8.04),('11288','2013-05-27','12:25:00',7.06),('11288','2013-05-27','12:30:00',7.91),('11288','2013-05-27','12:35:00',7.17),('11288','2013-05-27','12:40:00',8.64),('11288','2013-05-27','12:45:00',5.36),('11288','2013-05-27','12:50:00',7.35),('11288','2013-05-27','12:55:00',5.2),('11288','2013-05-27','13:00:00',3.33),('11288','2013-05-27','13:05:00',5.65),('11288','2013-05-27','13:10:00',7.46),('11288','2013-05-27','13:15:00',2.53),('11288','2013-05-27','13:20:00',8.36),('11288','2013-05-27','13:25:00',7.09),('11288','2013-05-27','13:30:00',7.87),('11288','2013-05-27','13:35:00',7.1),('11288','2013-05-27','13:40:00',8.26),('11288','2013-05-27','13:45:00',6.49),('11288','2013-05-27','13:50:00',8.2),('11288','2013-05-27','13:55:00',7.89),('11288','2013-05-27','14:00:00',7.56),('11288','2013-05-27','14:05:00',6.82),('11288','2013-05-27','14:10:00',7.22),('11288','2013-05-27','14:15:00',6.23),('11288','2013-05-27','14:20:00',5.93),('11288','2013-05-27','14:25:00',7.19),('11288','2013-05-27','14:30:00',7.81),('11288','2013-05-27','14:35:00',6.65),('11288','2013-05-27','14:40:00',6.01),('11288','2013-05-27','14:45:00',7.92),('11288','2013-05-27','14:50:00',7.64),('11288','2013-05-27','14:55:00',6.41),('11288','2013-05-27','15:00:00',4.94),('11288','2013-05-27','15:05:00',4.88),('11288','2013-05-27','15:10:00',7.48),('11288','2013-05-27','15:15:00',5.17),('11288','2013-05-27','15:20:00',6.73),('11288','2013-05-27','15:25:00',5.78),('11288','2013-05-27','15:30:00',6.61),('11288','2013-05-27','15:35:00',7.16),('11288','2013-05-27','15:40:00',6.14),('11288','2013-05-27','15:45:00',5.58),('11288','2013-05-27','15:50:00',6.79),('11288','2013-05-27','15:55:00',4.61),('11288','2013-05-27','16:00:00',5.37),('11288','2013-05-27','16:05:00',3.99),('11288','2013-05-27','16:10:00',4.31),('11288','2013-05-27','16:15:00',4.12),('11288','2013-05-27','16:20:00',6.69),('11288','2013-05-27','16:25:00',6.28),('11288','2013-05-27','16:30:00',5.87),('11288','2013-05-27','16:35:00',4.72),('11288','2013-05-27','16:40:00',2.5),('11288','2013-05-27','16:45:00',2.28),('11288','2013-05-27','16:50:00',2.38),('11288','2013-05-27','16:55:00',2.53),('11288','2013-05-27','17:00:00',2.64),('11288','2013-05-27','17:05:00',2.75),('11288','2013-05-27','17:10:00',3.33),('11288','2013-05-27','17:15:00',2.73),('11288','2013-05-27','17:20:00',2.38),('11288','2013-05-27','17:25:00',2.19),('11288','2013-05-27','17:30:00',2.14),('11288','2013-05-27','17:35:00',1.99),('11288','2013-05-27','17:40:00',1.85),('11288','2013-05-27','17:45:00',1.74),('11288','2013-05-27','17:50:00',1.66),('11288','2013-05-27','17:55:00',1.69),('11288','2013-05-27','18:00:00',1.66),('11288','2013-05-27','18:05:00',1.5),('11288','2013-05-27','18:10:00',1.61),('11288','2013-05-27','18:15:00',1.8),('11288','2013-05-27','18:20:00',2.35),('11288','2013-05-27','18:25:00',3.27),('11288','2013-05-27','18:30:00',2.66),('11288','2013-05-27','18:35:00',1.75),('11288','2013-05-27','18:40:00',1.4),('11288','2013-05-27','18:45:00',1.9),('11288','2013-05-27','18:50:00',1.36),('11288','2013-05-27','18:55:00',1.91),('11288','2013-05-27','19:00:00',2.01),('11288','2013-05-27','19:05:00',1.89),('11288','2013-05-27','19:10:00',1.67),('11288','2013-05-27','19:15:00',1.25),('11288','2013-05-27','19:20:00',1.1),('11288','2013-05-27','19:25:00',1.09),('11288','2013-05-27','19:30:00',1.11),('11288','2013-05-26','07:20:00',1.73),('11288','2013-05-26','07:35:00',1.52),('11288','2013-05-26','07:40:00',1.66),('11288','2013-05-26','07:45:00',2.2),('11288','2013-05-26','07:50:00',3.31),('11288','2013-05-26','08:00:00',1.37),('11288','2013-05-26','08:05:00',3.18),('11288','2013-05-26','08:10:00',2.6),('11288','2013-05-26','08:15:00',1.27),('11288','2013-05-26','08:20:00',1.74),('11288','2013-05-26','08:25:00',2.32),('11288','2013-05-26','08:30:00',3.53),('11288','2013-05-26','08:35:00',2.61),('11288','2013-05-26','08:40:00',3.56),('11288','2013-05-26','08:45:00',4.77),('11288','2013-05-26','08:50:00',4.56),('11288','2013-05-26','08:55:00',2.03),('11288','2013-05-26','09:00:00',2.66),('11288','2013-05-26','09:05:00',1.5),('11288','2013-05-26','09:10:00',4.62),('11288','2013-05-26','09:15:00',2.14),('11288','2013-05-26','09:20:00',1.59),('11288','2013-05-26','09:25:00',2.38),('11288','2013-05-26','09:30:00',1.46),('11288','2013-05-26','09:35:00',2.13),('11288','2013-05-26','09:40:00',2.79),('11288','2013-05-26','09:45:00',3.1),('11288','2013-05-26','09:50:00',1.32),('11288','2013-05-26','09:55:00',2.78),('11288','2013-05-26','10:00:00',1.64),('11288','2013-05-26','10:05:00',5.83),('11288','2013-05-26','10:10:00',6.58),('11288','2013-05-26','10:15:00',3.11),('11288','2013-05-26','10:20:00',5.68),('11288','2013-05-26','10:25:00',5.99),('11288','2013-05-26','10:30:00',7.1),('11288','2013-05-26','10:35:00',7.42),('11288','2013-05-26','10:40:00',7.21),('11288','2013-05-26','10:45:00',7.33),('11288','2013-05-26','10:50:00',7.58),('11288','2013-05-26','10:55:00',6.26),('11288','2013-05-26','11:00:00',7.27),('11288','2013-05-26','11:05:00',7.61),('11288','2013-05-26','11:10:00',7.65),('11288','2013-05-26','11:15:00',7.64),('11288','2013-05-26','11:20:00',7.59),('11288','2013-05-26','11:25:00',7.79),('11288','2013-05-26','11:30:00',7.79),('11288','2013-05-26','11:35:00',7.44),('11288','2013-05-26','11:40:00',7.73),('11288','2013-05-26','11:45:00',6.72),('11288','2013-05-26','11:50:00',8.07),('11288','2013-05-26','11:55:00',7.08),('11288','2013-05-26','12:00:00',8.1),('11288','2013-05-26','12:05:00',8.2),('11288','2013-05-26','12:10:00',5.87),('11288','2013-05-26','12:15:00',4.95),('11288','2013-05-26','12:20:00',6.39),('11288','2013-05-26','12:25:00',8.38),('11288','2013-05-26','12:30:00',8.37),('11288','2013-05-26','12:35:00',8.46),('11288','2013-05-26','12:40:00',8.8),('11288','2013-05-26','12:45:00',8.57),('11288','2013-05-26','12:50:00',8.25),('11288','2013-05-26','12:55:00',8.16),('11288','2013-05-26','13:00:00',7.39),('11288','2013-05-26','13:05:00',8.31),('11288','2013-05-26','13:10:00',8.34),('11288','2013-05-26','13:15:00',8.4),('11288','2013-05-26','13:20:00',8.34),('11288','2013-05-26','13:25:00',8.21),('11288','2013-05-26','13:30:00',7.83),('11288','2013-05-26','13:35:00',8.22),('11288','2013-05-26','13:40:00',8.15),('11288','2013-05-26','13:45:00',8.12),('11288','2013-05-26','13:50:00',8.07),('11288','2013-05-26','13:55:00',7.96),('11288','2013-05-26','14:00:00',8.05),('11288','2013-05-26','14:05:00',7.92),('11288','2013-05-26','14:10:00',7.89),('11288','2013-05-26','14:15:00',7.85),('11288','2013-05-26','14:20:00',7.8),('11288','2013-05-26','14:25:00',7.74),('11288','2013-05-26','14:30:00',7.61),('11288','2013-05-26','14:35:00',7.68),('11288','2013-05-26','14:40:00',7.65),('11288','2013-05-26','14:45:00',7.57),('11288','2013-05-26','14:50:00',7.52),('11288','2013-05-26','14:55:00',7.42),('11288','2013-05-26','15:00:00',7.36),('11288','2013-05-26','15:05:00',7.33),('11288','2013-05-26','15:10:00',7.27),('11288','2013-05-26','15:15:00',7.2),('11288','2013-05-26','15:20:00',7.17),('11288','2013-05-26','15:25:00',7.09),('11288','2013-05-26','15:30:00',7.05),('11288','2013-05-26','15:35:00',6.96),('11288','2013-05-26','15:40:00',6.87),('11288','2013-05-26','15:45:00',6.76),('11288','2013-05-26','15:50:00',6.68),('11288','2013-05-26','15:55:00',6.58),('11288','2013-05-26','16:00:00',6.49),('11288','2013-05-26','16:05:00',6.42),('11288','2013-05-26','16:10:00',6.29),('11288','2013-05-26','16:15:00',6.13),('11288','2013-05-26','16:20:00',6.06),('11288','2013-05-26','16:25:00',5.96),('11288','2013-05-26','16:30:00',5.8),('11288','2013-05-26','16:35:00',5.64),('11288','2013-05-26','16:40:00',5.53),('11288','2013-05-26','16:45:00',5.34),('11288','2013-05-26','16:50:00',5.26),('11288','2013-05-26','16:55:00',5.09),('11288','2013-05-26','17:00:00',4.98),('11288','2013-05-26','17:05:00',4.87),('11288','2013-05-26','17:10:00',4.7),('11288','2013-05-26','17:15:00',4.54),('11288','2013-05-26','17:20:00',4.41),('11288','2013-05-26','17:25:00',4.29),('11288','2013-05-26','17:30:00',4.12),('11288','2013-05-26','17:35:00',3.9),('11288','2013-05-26','17:40:00',3.81),('11288','2013-05-26','17:45:00',3.79),('11288','2013-05-26','17:50:00',3.61),('11288','2013-05-26','17:55:00',3.35),('11288','2013-05-26','18:00:00',3.29),('11288','2013-05-26','18:05:00',3.15),('11288','2013-05-26','18:10:00',3),('11288','2013-05-26','18:15:00',2.84),('11288','2013-05-26','18:20:00',2.68),('11288','2013-05-26','18:25:00',2.54),('11288','2013-05-26','18:30:00',2.36),('11288','2013-05-26','18:35:00',2.2),('11288','2013-05-26','18:40:00',2.05),('11288','2013-05-26','18:45:00',1.91),('11288','2013-05-26','18:50:00',1.77),('11288','2013-05-26','18:55:00',1.6),('11288','2013-05-26','19:00:00',1.42),('11288','2013-05-26','19:05:00',1.26),('11288','2013-05-26','19:10:00',1.15),('11288','2013-05-26','19:15:00',1.03),('11288','2013-05-25','07:15:00',1.32),('11288','2013-05-25','07:20:00',1.06),('11288','2013-05-25','07:25:00',1.22),('11288','2013-05-25','07:30:00',1.71),('11288','2013-05-25','07:35:00',2.53),('11288','2013-05-25','07:40:00',1.91),('11288','2013-05-25','07:50:00',1.37),('11288','2013-05-25','07:55:00',2.54),('11288','2013-05-25','08:00:00',3.27),('11288','2013-05-25','08:05:00',3.05),('11288','2013-05-25','08:10:00',2.08),('11288','2013-05-25','08:15:00',1.17),('11288','2013-05-25','08:20:00',2.87),('11288','2013-05-25','08:25:00',4.01),('11288','2013-05-25','08:30:00',4.15),('11288','2013-05-25','08:35:00',2.37),('11288','2013-05-25','08:40:00',2.76),('11288','2013-05-25','08:45:00',2.2),('11288','2013-05-25','08:50:00',3.38),('11288','2013-05-25','08:55:00',2.38),('11288','2013-05-25','09:00:00',4.1),('11288','2013-05-25','09:05:00',4.81),('11288','2013-05-25','09:10:00',5.14),('11288','2013-05-25','09:15:00',5.75),('11288','2013-05-25','09:20:00',2.63),('11288','2013-05-25','09:25:00',2.66),('11288','2013-05-25','09:30:00',1.85),('11288','2013-05-25','09:35:00',4.52),('11288','2013-05-25','09:40:00',6.08),('11288','2013-05-25','09:45:00',4.82),('11288','2013-05-25','09:50:00',6.06),('11288','2013-05-25','09:55:00',3.46),('11288','2013-05-25','10:00:00',1.6),('11288','2013-05-25','10:05:00',1.37),('11288','2013-05-25','10:10:00',2.26),('11288','2013-05-25','10:15:00',1.75),('11288','2013-05-25','10:20:00',1.01),('11288','2013-05-25','10:25:00',1.79),('11288','2013-05-25','10:30:00',1.68),('11288','2013-05-25','10:35:00',1.7),('11288','2013-05-25','10:40:00',3.02),('11288','2013-05-25','10:45:00',2.56),('11288','2013-05-25','10:50:00',2.49),('11288','2013-05-25','10:55:00',1.4),('11288','2013-05-25','11:00:00',2.39),('11288','2013-05-25','11:05:00',4.2),('11288','2013-05-25','11:10:00',7.46),('11288','2013-05-25','11:15:00',7.86),('11288','2013-05-25','11:20:00',3.83),('11288','2013-05-25','11:25:00',1.68),('11288','2013-05-25','11:30:00',1.01),('11288','2013-05-25','11:35:00',3.51),('11288','2013-05-25','11:40:00',3.42),('11288','2013-05-25','11:45:00',4.41),('11288','2013-05-25','11:50:00',3.88),('11288','2013-05-25','11:55:00',3.5),('11288','2013-05-25','12:00:00',3.03),('11288','2013-05-25','12:05:00',2.58),('11288','2013-05-25','12:10:00',3.18),('11288','2013-05-25','12:15:00',2.26),('11288','2013-05-25','12:20:00',2.92),('11288','2013-05-25','12:25:00',3.61),('11288','2013-05-25','12:30:00',2.44),('11288','2013-05-25','12:35:00',2.87),('11288','2013-05-25','12:40:00',3.35),('11288','2013-05-25','12:45:00',3.2),('11288','2013-05-25','12:50:00',2.64),('11288','2013-05-25','12:55:00',3.91),('11288','2013-05-25','13:00:00',2.01),('11288','2013-05-25','13:05:00',3.03),('11288','2013-05-25','13:10:00',2.68),('11288','2013-05-25','13:15:00',3.52),('11288','2013-05-25','13:20:00',3.59),('11288','2013-05-25','13:25:00',6.91),('11288','2013-05-25','13:30:00',2.4),('11288','2013-05-25','13:35:00',2.71),('11288','2013-05-25','13:40:00',3.98),('11288','2013-05-25','13:45:00',3.46),('11288','2013-05-25','13:50:00',4.49),('11288','2013-05-25','13:55:00',6.44),('11288','2013-05-25','14:00:00',5.8),('11288','2013-05-25','14:05:00',6.94),('11288','2013-05-25','14:10:00',8.19),('11288','2013-05-25','14:15:00',6.16),('11288','2013-05-25','14:20:00',6.95),('11288','2013-05-25','14:25:00',7.42),('11288','2013-05-25','14:30:00',5.67),('11288','2013-05-25','14:35:00',5.05),('11288','2013-05-25','14:40:00',2.33),('11288','2013-05-25','14:45:00',4.58),('11288','2013-05-25','14:50:00',2.21),('11288','2013-05-25','14:55:00',3.2),('11288','2013-05-25','15:00:00',7.51),('11288','2013-05-25','15:05:00',3.66),('11288','2013-05-25','15:10:00',3.97),('11288','2013-05-25','15:15:00',4.36),('11288','2013-05-25','15:20:00',2.98),('11288','2013-05-25','15:25:00',5.53),('11288','2013-05-25','15:30:00',5.78),('11288','2013-05-25','15:35:00',7.79),('11288','2013-05-25','15:40:00',6.81),('11288','2013-05-25','15:45:00',6.68),('11288','2013-05-25','15:50:00',7.49),('11288','2013-05-25','15:55:00',6.35),('11288','2013-05-25','16:00:00',4.51),('11288','2013-05-25','16:05:00',3.83),('11288','2013-05-25','16:10:00',6.67),('11288','2013-05-25','16:15:00',4.09),('11288','2013-05-25','16:20:00',2.54),('11288','2013-05-25','16:25:00',3.39),('11288','2013-05-25','16:30:00',4.89),('11288','2013-05-25','16:35:00',4.44),('11288','2013-05-25','16:40:00',5.66),('11288','2013-05-25','16:45:00',5.84),('11288','2013-05-25','16:50:00',2.6),('11288','2013-05-25','16:55:00',2.08),('11288','2013-05-25','17:00:00',1.64),('11288','2013-05-25','17:05:00',3.65),('11288','2013-05-25','17:10:00',4.34),('11288','2013-05-25','17:15:00',3.04),('11288','2013-05-25','17:20:00',3.29),('11288','2013-05-25','17:25:00',1.82),('11288','2013-05-25','17:30:00',1.68),('11288','2013-05-25','17:35:00',2.63),('11288','2013-05-25','17:40:00',1.79),('11288','2013-05-25','17:45:00',3.11),('11288','2013-05-25','17:50:00',2.16),('11288','2013-05-25','17:55:00',1.6),('11288','2013-05-25','18:00:00',1.63),('11288','2013-05-25','18:05:00',1.43),('11288','2013-05-25','18:10:00',1.92),('11288','2013-05-25','18:15:00',1.36),('11288','2013-05-25','18:20:00',1.68),('11288','2013-05-25','18:35:00',1.08),('11288','2013-05-24','07:00:00',1.41),('11288','2013-05-24','07:40:00',1.17),('11288','2013-05-24','07:50:00',1.01),('11288','2013-05-24','08:00:00',1.92),('11288','2013-05-24','08:05:00',2.69),('11288','2013-05-24','08:10:00',3.39),('11288','2013-05-24','08:15:00',3.26),('11288','2013-05-24','08:20:00',1.25),('11288','2013-05-24','08:25:00',2.44),('11288','2013-05-24','08:30:00',3.69),('11288','2013-05-24','08:35:00',2.04),('11288','2013-05-24','08:40:00',2.2),('11288','2013-05-24','08:45:00',3.27),('11288','2013-05-24','08:50:00',3.79),('11288','2013-05-24','08:55:00',4.17),('11288','2013-05-24','09:00:00',4.7),('11288','2013-05-24','09:05:00',5.23),('11288','2013-05-24','09:10:00',1.02),('11288','2013-05-24','09:15:00',1.49),('11288','2013-05-24','09:20:00',4.63),('11288','2013-05-24','09:25:00',2.77),('11288','2013-05-24','09:30:00',2.67),('11288','2013-05-24','09:35:00',1.4),('11288','2013-05-24','09:40:00',2.99),('11288','2013-05-24','09:45:00',2.26),('11288','2013-05-24','09:50:00',2.55),('11288','2013-05-24','09:55:00',6.03),('11288','2013-05-24','10:00:00',1.84),('11288','2013-05-24','10:05:00',1.52),('11288','2013-05-24','10:10:00',1.18),('11288','2013-05-24','10:20:00',2.67),('11288','2013-05-24','10:25:00',4.64),('11288','2013-05-24','10:30:00',6.8),('11288','2013-05-24','10:35:00',6.95),('11288','2013-05-24','10:40:00',6.4),('11288','2013-05-24','10:45:00',6.97),('11288','2013-05-24','10:50:00',4.62),('11288','2013-05-24','10:55:00',6.19),('11288','2013-05-24','11:00:00',5.01),('11288','2013-05-24','11:05:00',6.47),('11288','2013-05-24','11:10:00',7.66),('11288','2013-05-24','11:15:00',6.68),('11288','2013-05-24','11:20:00',7.5),('11288','2013-05-24','11:25:00',8.05),('11288','2013-05-24','11:30:00',4.16),('11288','2013-05-24','11:35:00',2.33),('11288','2013-05-24','11:40:00',1.76),('11288','2013-05-24','11:45:00',5.7),('11288','2013-05-24','11:50:00',8.64),('11288','2013-05-24','11:55:00',5.46),('11288','2013-05-24','12:00:00',4.63),('11288','2013-05-24','12:05:00',4.5),('11288','2013-05-24','12:10:00',6.41),('11288','2013-05-24','12:15:00',4.14),('11288','2013-05-24','12:20:00',4.12),('11288','2013-05-24','12:25:00',7.36),('11288','2013-05-24','12:30:00',7.87),('11288','2013-05-24','12:35:00',4.08),('11288','2013-05-24','12:40:00',4.82),('11288','2013-05-24','12:45:00',6.81),('11288','2013-05-24','12:50:00',5.16),('11288','2013-05-24','12:55:00',4.89),('11288','2013-05-24','13:00:00',4.38),('11288','2013-05-24','13:05:00',3.98),('11288','2013-05-24','13:10:00',4.77),('11288','2013-05-24','13:15:00',5.16),('11288','2013-05-24','13:20:00',5.43),('11288','2013-05-24','13:25:00',4.38),('11288','2013-05-24','13:30:00',4.12),('11288','2013-05-24','13:35:00',4.59),('11288','2013-05-24','13:40:00',3.96),('11288','2013-05-24','13:45:00',2.07),('11288','2013-05-24','13:50:00',2.55),('11288','2013-05-24','13:55:00',5.06),('11288','2013-05-24','14:00:00',3.97),('11288','2013-05-24','14:05:00',3.23),('11288','2013-05-24','14:10:00',2.6),('11288','2013-05-24','14:15:00',6.48),('11288','2013-05-24','14:20:00',5.51),('11288','2013-05-24','14:25:00',7.69),('11288','2013-05-24','14:30:00',4.12),('11288','2013-05-24','14:35:00',6.14),('11288','2013-05-24','14:40:00',3.63),('11288','2013-05-24','14:45:00',4.8),('11288','2013-05-24','14:50:00',2.57),('11288','2013-05-24','14:55:00',3.07),('11288','2013-05-24','15:00:00',5.32),('11288','2013-05-24','15:05:00',7.29),('11288','2013-05-24','15:10:00',5.23),('11288','2013-05-24','15:15:00',6.51),('11288','2013-05-24','15:20:00',6.77),('11288','2013-05-24','15:25:00',5.87),('11288','2013-05-24','15:30:00',7.63),('11288','2013-05-24','15:35:00',6.44),('11288','2013-05-24','15:40:00',5.74),('11288','2013-05-24','15:45:00',7.13),('11288','2013-05-24','15:50:00',8.37),('11288','2013-05-24','15:55:00',7.91),('11288','2013-05-24','16:00:00',3.85),('11288','2013-05-24','16:05:00',3.95),('11288','2013-05-24','16:10:00',4.24),('11288','2013-05-24','16:15:00',5.3),('11288','2013-05-24','16:20:00',3.83),('11288','2013-05-24','16:25:00',5.19),('11288','2013-05-24','16:30:00',4.61),('11288','2013-05-24','16:35:00',2.62),('11288','2013-05-24','16:40:00',1.18),('11288','2013-05-24','16:45:00',1.19),('11288','2013-05-24','16:50:00',2.8),('11288','2013-05-24','16:55:00',3.33),('11288','2013-05-24','17:00:00',2.49),('11288','2013-05-24','17:05:00',1.85),('11288','2013-05-24','17:10:00',1.48),('11288','2013-05-24','17:15:00',1.52),('11288','2013-05-24','17:20:00',1.93),('11288','2013-05-24','17:25:00',1.97),('11288','2013-05-24','17:30:00',2.07),('11288','2013-05-24','17:35:00',2.09),('11288','2013-05-24','17:40:00',1.79),('11288','2013-05-24','17:45:00',1.52),('11288','2013-05-24','17:50:00',1.1),('11288','2013-05-24','18:05:00',1.07),('11288','2013-05-24','18:10:00',1.06),('11288','2013-05-23','07:05:00',1.11),('11288','2013-05-23','07:10:00',1.52),('11288','2013-05-23','07:45:00',1.28),('11288','2013-05-23','07:50:00',1.66),('11288','2013-05-23','07:55:00',1.84),('11288','2013-05-23','08:00:00',2.17),('11288','2013-05-23','08:05:00',2.96),('11288','2013-05-23','08:10:00',1.6),('11288','2013-05-23','08:25:00',1.59),('11288','2013-05-23','08:30:00',3.8),('11288','2013-05-23','08:35:00',3.43),('11288','2013-05-23','08:40:00',3.86),('11288','2013-05-23','08:45:00',2.79),('11288','2013-05-23','08:50:00',1.23),('11288','2013-05-23','08:55:00',2.31),('11288','2013-05-23','09:00:00',4.87),('11288','2013-05-23','09:05:00',2.35),('11288','2013-05-23','09:15:00',2.27),('11288','2013-05-23','09:20:00',2.86),('11288','2013-05-23','09:25:00',5.63),('11288','2013-05-23','09:30:00',5.81),('11288','2013-05-23','09:35:00',4.94),('11288','2013-05-23','09:40:00',4.79),('11288','2013-05-23','09:45:00',2.72),('11288','2013-05-23','09:50:00',4.39),('11288','2013-05-23','09:55:00',2.92),('11288','2013-05-23','10:00:00',2.19),('11288','2013-05-23','10:05:00',6.74),('11288','2013-05-23','10:10:00',5.59),('11288','2013-05-23','10:15:00',7.01),('11288','2013-05-23','10:20:00',3.87),('11288','2013-05-23','10:25:00',6.61),('11288','2013-05-23','10:30:00',5.91),('11288','2013-05-23','10:35:00',6.57),('11288','2013-05-23','10:40:00',5.95),('11288','2013-05-23','10:45:00',7.13),('11288','2013-05-23','10:50:00',4.65),('11288','2013-05-23','10:55:00',6.43),('11288','2013-05-23','11:00:00',4.51),('11288','2013-05-23','11:05:00',6.08),('11288','2013-05-23','11:10:00',3.82),('11288','2013-05-23','11:15:00',3.97),('11288','2013-05-23','11:20:00',2.86),('11288','2013-05-23','11:25:00',4.87),('11288','2013-05-23','11:30:00',5.29),('11288','2013-05-23','11:35:00',7.01),('11288','2013-05-23','11:40:00',7.88),('11288','2013-05-23','11:45:00',4.1),('11288','2013-05-23','11:50:00',7.12),('11288','2013-05-23','11:55:00',8.59),('11288','2013-05-23','12:00:00',7.42),('11288','2013-05-23','12:05:00',8.22),('11288','2013-05-23','12:10:00',7.69),('11288','2013-05-23','12:15:00',4.48),('11288','2013-05-23','12:20:00',6.83),('11288','2013-05-23','12:25:00',8.16),('11288','2013-05-23','12:30:00',7.76),('11288','2013-05-23','12:35:00',3.32),('11288','2013-05-23','12:40:00',9.53),('11288','2013-05-23','12:45:00',5.47),('11288','2013-05-23','12:50:00',7.03),('11288','2013-05-23','12:55:00',8.22),('11288','2013-05-23','13:00:00',7.65),('11288','2013-05-23','13:05:00',5.82),('11288','2013-05-23','13:10:00',6.97),('11288','2013-05-23','13:15:00',6.96),('11288','2013-05-23','13:20:00',6.44),('11288','2013-05-23','13:25:00',7.18),('11288','2013-05-23','13:30:00',5.66),('11288','2013-05-23','13:35:00',3.9),('11288','2013-05-23','13:40:00',4.82),('11288','2013-05-23','13:45:00',6.11),('11288','2013-05-23','13:50:00',6.26),('11288','2013-05-23','13:55:00',7.81),('11288','2013-05-23','14:00:00',7.21),('11288','2013-05-23','14:05:00',8.2),('11288','2013-05-23','14:10:00',7.9),('11288','2013-05-23','14:15:00',6.25),('11288','2013-05-23','14:20:00',7.42),('11288','2013-05-23','14:25:00',5.58),('11288','2013-05-23','14:30:00',4.04),('11288','2013-05-23','14:35:00',8.47),('11288','2013-05-23','14:40:00',6.26),('11288','2013-05-23','14:45:00',3.56),('11288','2013-05-23','14:50:00',4.14),('11288','2013-05-23','14:55:00',6.24),('11288','2013-05-23','15:00:00',4.53),('11288','2013-05-23','15:05:00',4.08),('11288','2013-05-23','15:10:00',2.53),('11288','2013-05-23','15:15:00',3.32),('11288','2013-05-23','15:20:00',5.11),('11288','2013-05-23','15:25:00',2.39),('11288','2013-05-23','15:30:00',6.76),('11288','2013-05-23','15:35:00',5.13),('11288','2013-05-23','15:40:00',3.13),('11288','2013-05-23','15:45:00',3.88),('11288','2013-05-23','15:50:00',2.3),('11288','2013-05-23','15:55:00',3.96),('11288','2013-05-23','16:00:00',5.03),('11288','2013-05-23','16:05:00',6.77),('11288','2013-05-23','16:10:00',3.55),('11288','2013-05-23','16:15:00',5.2),('11288','2013-05-23','16:20:00',5.04),('11288','2013-05-23','16:25:00',5.28),('11288','2013-05-23','16:30:00',4.93),('11288','2013-05-23','16:35:00',2.57),('11288','2013-05-23','16:40:00',2.14),('11288','2013-05-23','16:45:00',3.5),('11288','2013-05-23','16:50:00',1.74),('11288','2013-05-23','16:55:00',1.21),('11288','2013-05-23','17:00:00',1.13),('11288','2013-05-23','17:05:00',2.34),('11288','2013-05-23','17:10:00',3.63),('11288','2013-05-23','17:15:00',4.13),('11288','2013-05-23','17:20:00',2.86),('11288','2013-05-23','17:25:00',1.62),('11288','2013-05-23','17:30:00',1.63),('11288','2013-05-23','17:35:00',3.32),('11288','2013-05-23','17:40:00',1.82),('11288','2013-05-23','17:45:00',1.81),('11288','2013-05-23','17:50:00',1.65),('11288','2013-05-23','17:55:00',2.72),('11288','2013-05-23','18:00:00',3.24),('11288','2013-05-23','18:05:00',3.98),('11288','2013-05-23','18:10:00',1.7),('11288','2013-05-23','18:40:00',1.09),('11288','2013-05-23','18:45:00',1.77),('11288','2013-05-23','18:50:00',2.11),('11288','2013-05-23','18:55:00',1.74),('11288','2013-05-23','19:00:00',1.24),('11288','2013-05-22','07:20:00',1.02),('11288','2013-05-22','07:25:00',1.2),('11288','2013-05-22','07:30:00',1.1),('11288','2013-05-22','07:35:00',1.07),('11288','2013-05-22','07:40:00',1.23),('11288','2013-05-22','07:45:00',1.41),('11288','2013-05-22','07:50:00',1.83),('11288','2013-05-22','07:55:00',1.94),('11288','2013-05-22','08:00:00',2.11),('11288','2013-05-22','08:05:00',2.34),('11288','2013-05-22','08:10:00',2.3),('11288','2013-05-22','08:15:00',3.43),('11288','2013-05-22','08:20:00',3.11),('11288','2013-05-22','08:25:00',2.97),('11288','2013-05-22','08:30:00',3.97),('11288','2013-05-22','08:35:00',4.68),('11288','2013-05-22','08:40:00',2.58),('11288','2013-05-22','08:45:00',3.02),('11288','2013-05-22','08:50:00',1.79),('11288','2013-05-22','09:10:00',1.25),('11288','2013-05-22','09:15:00',1.66),('11288','2013-05-22','09:20:00',1.68),('11288','2013-05-22','09:25:00',2.47),('11288','2013-05-22','09:30:00',5.06),('11288','2013-05-22','09:35:00',4.98),('11288','2013-05-22','09:40:00',4.87),('11288','2013-05-22','09:45:00',4.93),('11288','2013-05-22','09:50:00',5.08),('11288','2013-05-22','09:55:00',5.06),('11288','2013-05-22','10:00:00',5.33),('11288','2013-05-22','10:05:00',5.47),('11288','2013-05-22','10:10:00',5.57),('11288','2013-05-22','10:15:00',5.66),('11288','2013-05-22','10:20:00',5.44),('11288','2013-05-22','10:25:00',5.76),('11288','2013-05-22','10:30:00',5.96),('11288','2013-05-22','10:35:00',6.09),('11288','2013-05-22','10:40:00',6.43),('11288','2013-05-22','10:45:00',6.4),('11288','2013-05-22','10:50:00',6.37),('11288','2013-05-22','10:55:00',6.43),('11288','2013-05-22','11:00:00',6.52),('11288','2013-05-22','11:05:00',6.68),('11288','2013-05-22','11:10:00',5.02),('11288','2013-05-22','11:15:00',6.81),('11288','2013-05-22','11:20:00',6.81),('11288','2013-05-22','11:25:00',6.77),('11288','2013-05-22','11:30:00',5.61),('11288','2013-05-22','11:35:00',6.07),('11288','2013-05-22','11:40:00',5.4),('11288','2013-05-22','11:45:00',6.84),('11288','2013-05-22','11:50:00',3.94),('11288','2013-05-22','11:55:00',3.74),('11288','2013-05-22','12:00:00',5.3),('11288','2013-05-22','12:05:00',4.12),('11288','2013-05-22','12:10:00',4.14),('11288','2013-05-22','12:15:00',5.58),('11288','2013-05-22','12:20:00',6.71),('11288','2013-05-22','12:25:00',5.55),('11288','2013-05-22','12:30:00',3.83),('11288','2013-05-22','12:35:00',4.31),('11288','2013-05-22','12:40:00',2.83),('11288','2013-05-22','12:45:00',1.37),('11288','2013-05-22','13:00:00',1.85),('11288','2013-05-22','13:05:00',7.44),('11288','2013-05-22','13:10:00',4.6),('11288','2013-05-22','13:15:00',5.25),('11288','2013-05-22','13:20:00',5.2),('11288','2013-05-22','13:25:00',2.04),('11288','2013-05-22','13:30:00',3.16),('11288','2013-05-22','13:35:00',6.78),('11288','2013-05-22','13:40:00',4.59),('11288','2013-05-22','13:45:00',4.32),('11288','2013-05-22','13:50:00',3.08),('11288','2013-05-22','13:55:00',3.68),('11288','2013-05-22','14:00:00',4.85),('11288','2013-05-22','14:05:00',5.43),('11288','2013-05-22','14:10:00',7.64),('11288','2013-05-22','14:15:00',7.36),('11288','2013-05-22','14:20:00',7.18),('11288','2013-05-22','14:25:00',7.09),('11288','2013-05-22','14:30:00',6.97),('11288','2013-05-22','14:35:00',6.92),('11288','2013-05-22','14:40:00',6.95),('11288','2013-05-22','14:45:00',6.93),('11288','2013-05-22','14:50:00',6.86),('11288','2013-05-22','14:55:00',6.75),('11288','2013-05-22','15:00:00',6.66),('11288','2013-05-22','15:05:00',6.59),('11288','2013-05-22','15:10:00',6.38),('11288','2013-05-22','15:15:00',6.32),('11288','2013-05-22','15:20:00',4.73),('11288','2013-05-22','15:25:00',4.14),('11288','2013-05-22','15:30:00',3.4),('11288','2013-05-22','15:35:00',3.95),('11288','2013-05-22','15:40:00',6.22),('11288','2013-05-22','15:45:00',5.19),('11288','2013-05-22','15:50:00',6),('11288','2013-05-22','15:55:00',5.85),('11288','2013-05-22','16:00:00',5.72),('11288','2013-05-22','16:05:00',5.55),('11288','2013-05-22','16:10:00',5.46),('11288','2013-05-22','16:15:00',5.33),('11288','2013-05-22','16:20:00',5.22),('11288','2013-05-22','16:25:00',5.13),('11288','2013-05-22','16:30:00',4.9),('11288','2013-05-22','16:35:00',4.67),('11288','2013-05-22','16:40:00',4.72),('11288','2013-05-22','16:45:00',4.36),('11288','2013-05-22','16:50:00',1.82),('11288','2013-05-22','16:55:00',1.33),('11288','2013-05-22','17:00:00',1.3),('11288','2013-05-22','17:05:00',1.4),('11288','2013-05-22','17:10:00',1.26),('11288','2013-05-22','17:15:00',1.9),('11288','2013-05-22','17:20:00',2.21),('11288','2013-05-22','17:25:00',2.62),('11288','2013-05-22','17:30:00',2.35),('11288','2013-05-22','17:35:00',3.22),('11288','2013-05-22','17:40:00',1.59),('11288','2013-05-22','17:50:00',1.14),('11288','2013-05-22','17:55:00',2.86),('11288','2013-05-22','18:00:00',2.85),('11288','2013-05-22','18:05:00',1.52),('11288','2013-05-22','18:10:00',1.07),('11288','2013-05-22','18:25:00',1.33),('11288','2013-05-22','19:00:00',1.07),('11288','2013-05-22','19:05:00',1.08),('11288','2013-05-22','19:15:00',1.08),('11288','2014-04-01','08:10:00',1.01),('11288','2014-04-01','08:15:00',1.11),('11288','2014-04-01','08:20:00',1.13),('11288','2014-04-01','08:25:00',1.35),('11288','2014-04-01','08:30:00',1.46),('11288','2014-04-01','08:35:00',1.56),('11288','2014-04-01','08:40:00',1.8),('11288','2014-04-01','08:45:00',1.86),('11288','2014-04-01','08:50:00',1.99),('11288','2014-04-01','08:55:00',2.25),('11288','2014-04-01','09:00:00',2.4),('11288','2014-04-01','09:05:00',2.38),('11288','2014-04-01','09:10:00',2.62),('11288','2014-04-01','09:15:00',2.66),('11288','2014-04-01','09:20:00',2.78),('11288','2014-04-01','09:25:00',2.95),('11288','2014-04-01','09:30:00',3.11),('11288','2014-04-01','09:35:00',3.37),('11288','2014-04-01','09:40:00',3.58),('11288','2014-04-01','09:45:00',3.65),('11288','2014-04-01','09:50:00',3.94),('11288','2014-04-01','09:55:00',4.12),('11288','2014-04-01','10:00:00',4.2),('11288','2014-04-01','10:05:00',4.32),('11288','2014-04-01','10:10:00',4.52),('11288','2014-04-01','10:15:00',4.76),('11288','2014-04-01','10:20:00',4.85),('11288','2014-04-01','10:25:00',5.26),('11288','2014-04-01','10:30:00',5.38),('11288','2014-04-01','10:35:00',5.65),('11288','2014-04-01','10:40:00',5.44),('11288','2014-04-01','10:45:00',5.45),('11288','2014-04-01','10:50:00',5.39),('11288','2014-04-01','10:55:00',5.41),('11288','2014-04-01','11:00:00',5.54),('11288','2014-04-01','11:05:00',5.59),('11288','2014-04-01','11:10:00',5.69),('11288','2014-04-01','11:15:00',5.75),('11288','2014-04-01','11:20:00',5.87),('11288','2014-04-01','11:25:00',5.96),('11288','2014-04-01','11:30:00',5.99),('11288','2014-04-01','11:35:00',5.94),('11288','2014-04-01','11:40:00',6.03),('11288','2014-04-01','11:45:00',6.09),('11288','2014-04-01','11:50:00',6.11),('11288','2014-04-01','11:55:00',6.15),('11288','2014-04-01','12:00:00',6.29),('11288','2014-04-01','12:05:00',6.41),('11288','2014-04-01','12:10:00',6.48),('11288','2014-04-01','12:15:00',6.54),('11288','2014-04-01','12:20:00',6.61),('11288','2014-04-01','12:25:00',6.68),('11288','2014-04-01','12:30:00',6.74),('11288','2014-04-01','12:35:00',6.76),('11288','2014-04-01','12:40:00',6.79),('11288','2014-04-01','12:45:00',6.79),('11288','2014-04-01','12:50:00',6.03),('11288','2014-04-01','12:55:00',6.81),('11288','2014-04-01','13:00:00',6.84),('11288','2014-04-01','13:05:00',6.87),('11288','2014-04-01','13:10:00',6.85),('11288','2014-04-01','13:15:00',6.87),('11288','2014-04-01','13:20:00',6.67),('11288','2014-04-01','13:25:00',6.72),('11288','2014-04-01','13:30:00',6.77),('11288','2014-04-01','13:35:00',6.84),('11288','2014-04-01','13:40:00',5.87),('11288','2014-04-01','13:45:00',6.87),('11288','2014-04-01','13:50:00',6.72),('11288','2014-04-01','13:55:00',6.68),('11288','2014-04-01','14:00:00',6.66),('11288','2014-04-01','14:05:00',6.5),('11288','2014-04-01','14:10:00',5.6),('11288','2014-04-01','14:15:00',4.61),('11288','2014-04-01','14:20:00',5.2),('11288','2014-04-01','14:25:00',6.4),('11288','2014-04-01','14:30:00',6.54),('11288','2014-04-01','14:35:00',5.87),('11288','2014-04-01','14:40:00',5.07),('11288','2014-04-01','14:45:00',6.73),('11288','2014-04-01','14:50:00',6.39),('11288','2014-04-01','14:55:00',5.01),('11288','2014-04-01','15:00:00',5.48),('11288','2014-04-01','15:05:00',4.27),('11288','2014-04-01','15:10:00',5.17),('11288','2014-04-01','15:15:00',5.44),('11288','2014-04-01','15:20:00',3.2),('11288','2014-04-01','15:25:00',5.03),('11288','2014-04-01','15:30:00',5.09),('11288','2014-04-01','15:35:00',4.6),('11288','2014-04-01','15:40:00',5.67),('11288','2014-04-01','15:45:00',4.72),('11288','2014-04-01','15:50:00',5.78),('11288','2014-04-01','15:55:00',5.37),('11288','2014-04-01','16:00:00',4.07),('11288','2014-04-01','16:05:00',5.21),('11288','2014-04-01','16:10:00',4.82),('11288','2014-04-01','16:15:00',4.63),('11288','2014-04-01','16:20:00',2.44),('11288','2014-04-01','16:25:00',3.4),('11288','2014-04-01','16:30:00',4.57),('11288','2014-04-01','16:35:00',4.45),('11288','2014-04-01','16:40:00',3.77),('11288','2014-04-01','16:45:00',2.21),('11288','2014-04-01','16:50:00',2.6),('11288','2014-04-01','16:55:00',2.47),('11288','2014-04-01','17:00:00',2.79),('11288','2014-04-01','17:05:00',2.85),('11288','2014-04-01','17:10:00',2.68),('11288','2014-04-01','17:15:00',3.05),('11288','2014-04-01','17:20:00',2.83),('11288','2014-04-01','17:25:00',2.55),('11288','2014-04-01','17:30:00',2.48),('11288','2014-04-01','17:35:00',2.32),('11288','2014-04-01','17:40:00',2.18),('11288','2014-04-01','17:45:00',2.04),('11288','2014-04-01','17:50:00',1.89),('11288','2014-04-01','17:55:00',1.72),('11288','2014-04-01','18:00:00',1.57),('11288','2014-04-01','18:05:00',1.46),('11288','2014-04-01','18:10:00',1.26),('11288','2014-04-01','18:15:00',1.12),('11288','2013-05-21','07:10:00',1.05),('11288','2013-05-21','07:15:00',1.16),('11288','2013-05-21','07:20:00',1.24),('11288','2013-05-21','07:25:00',1.39),('11288','2013-05-21','07:30:00',1.67),('11288','2013-05-21','07:35:00',2.1),('11288','2013-05-21','07:40:00',2.43),('11288','2013-05-21','07:45:00',2.02),('11288','2013-05-21','07:50:00',1.64),('11288','2013-05-21','07:55:00',1.9),('11288','2013-05-21','08:00:00',1.93),('11288','2013-05-21','08:05:00',1.55),('11288','2013-05-21','08:10:00',2.49),('11288','2013-05-21','08:15:00',3.15),('11288','2013-05-21','08:20:00',2.87),('11288','2013-05-21','08:25:00',3.29),('11288','2013-05-21','08:30:00',2.39),('11288','2013-05-21','08:35:00',2.32),('11288','2013-05-21','08:40:00',2.66),('11288','2013-05-21','08:45:00',2.27),('11288','2013-05-21','08:50:00',2.51),('11288','2013-05-21','08:55:00',3.17),('11288','2013-05-21','09:00:00',2.68),('11288','2013-05-21','09:05:00',2.41),('11288','2013-05-21','09:10:00',2.67),('11288','2013-05-21','09:15:00',2.92),('11288','2013-05-21','09:20:00',4.28),('11288','2013-05-21','09:25:00',4.02),('11288','2013-05-21','09:30:00',3.3),('11288','2013-05-21','09:35:00',3.68),('11288','2013-05-21','09:40:00',3.43),('11288','2013-05-21','09:45:00',2.98),('11288','2013-05-21','09:50:00',2.93),('11288','2013-05-21','09:55:00',3.26),('11288','2013-05-21','10:00:00',3.56),('11288','2013-05-21','10:05:00',3.89),('11288','2013-05-21','10:10:00',4.03),('11288','2013-05-21','10:15:00',4.32),('11288','2013-05-21','10:20:00',3.52),('11288','2013-05-21','10:25:00',3.38),('11288','2013-05-21','10:30:00',3.16),('11288','2013-05-21','10:35:00',3.33),('11288','2013-05-21','10:40:00',3.68),('11288','2013-05-21','10:45:00',5.17),('11288','2013-05-21','10:50:00',3.66),('11288','2013-05-21','10:55:00',2.89),('11288','2013-05-21','11:00:00',3.4),('11288','2013-05-21','11:05:00',3.28),('11288','2013-05-21','11:10:00',5.15),('11288','2013-05-21','11:15:00',6.45),('11288','2013-05-21','11:20:00',6.32),('11288','2013-05-21','11:25:00',6.69),('11288','2013-05-21','11:30:00',5.18),('11288','2013-05-21','11:35:00',4.23),('11288','2013-05-21','11:40:00',4.65),('11288','2013-05-21','11:45:00',5.21),('11288','2013-05-21','11:50:00',4.97),('11288','2013-05-21','11:55:00',6.09),('11288','2013-05-21','12:00:00',5.68),('11288','2013-05-21','12:05:00',6.38),('11288','2013-05-21','12:10:00',4.72),('11288','2013-05-21','12:15:00',5.3),('11288','2013-05-21','12:20:00',4.17),('11288','2013-05-21','12:25:00',5.82),('11288','2013-05-21','12:30:00',6.76),('11288','2013-05-21','12:35:00',4.59),('11288','2013-05-21','12:40:00',7.37),('11288','2013-05-21','12:45:00',6.43),('11288','2013-05-21','12:50:00',4.74),('11288','2013-05-21','12:55:00',7.9),('11288','2013-05-21','13:00:00',6.81),('11288','2013-05-21','13:05:00',6.45),('11288','2013-05-21','13:10:00',4.43),('11288','2013-05-21','13:15:00',6.02),('11288','2013-05-21','13:20:00',5.44),('11288','2013-05-21','13:25:00',5.44),('11288','2013-05-21','13:30:00',4.93),('11288','2013-05-21','13:35:00',2.47),('11288','2013-05-21','13:40:00',1.5),('11288','2013-05-21','13:45:00',1.05),('11288','2013-05-21','14:00:00',1.17),('11288','2013-05-21','14:05:00',2.05),('11288','2013-05-21','14:10:00',3.16),('11288','2013-05-21','14:15:00',3.6),('11288','2013-05-21','14:20:00',3.02),('11288','2013-05-21','14:25:00',5.06),('11288','2013-05-21','14:30:00',4.46),('11288','2013-05-21','14:35:00',3.45),('11288','2013-05-21','14:40:00',3.33),('11288','2013-05-21','14:45:00',2.72),('11288','2013-05-21','14:50:00',1.74),('11288','2013-05-21','14:55:00',1.29),('11288','2013-05-21','15:05:00',1),('11288','2013-05-21','15:10:00',1.19),('11288','2013-05-21','15:15:00',2.1),('11288','2013-05-21','15:20:00',2.75),('11288','2013-05-21','15:25:00',2.78),('11288','2013-05-21','15:30:00',4.32),('11288','2013-05-21','15:35:00',2.9),('11288','2013-05-21','15:40:00',2.39),('11288','2013-05-21','15:45:00',2.46),('11288','2013-05-21','15:50:00',2.2),('11288','2013-05-21','15:55:00',2.12),('11288','2013-05-21','16:00:00',2.06),('11288','2013-05-21','16:05:00',2.12),('11288','2013-05-21','16:10:00',2.31),('11288','2013-05-21','16:15:00',1.94),('11288','2013-05-21','16:20:00',1.64),('11288','2013-05-21','16:25:00',2.29),('11288','2013-05-21','16:30:00',2.98),('11288','2013-05-21','16:35:00',3.42),('11288','2013-05-21','16:40:00',3.31),('11288','2013-05-21','16:45:00',2.9),('11288','2013-05-21','16:50:00',1.92),('11288','2013-05-21','16:55:00',1.03),('11288','2013-05-21','17:00:00',1.14),('11288','2013-05-21','17:05:00',1.33),('11288','2013-05-21','17:10:00',1.11),('11288','2013-05-20','07:05:00',1),('11288','2013-05-20','07:15:00',1.16),('11288','2013-05-20','07:20:00',1.21),('11288','2013-05-20','07:25:00',1.27),('11288','2013-05-20','07:30:00',1.53),('11288','2013-05-20','07:35:00',1.63),('11288','2013-05-20','07:40:00',1.72),('11288','2013-05-20','07:45:00',1.87),('11288','2013-05-20','07:50:00',2.02),('11288','2013-05-20','07:55:00',2.03),('11288','2013-05-20','08:00:00',2.2),('11288','2013-05-20','08:05:00',1.93),('11288','2013-05-20','08:10:00',2.02),('11288','2013-05-20','08:15:00',2.6),('11288','2013-05-20','08:20:00',2.6),('11288','2013-05-20','08:25:00',1.16),('11288','2013-05-20','08:30:00',1.18),('11288','2013-05-20','08:35:00',1.25),('11288','2013-05-20','08:40:00',1.46),('11288','2013-05-20','08:45:00',4.19),('11288','2013-05-20','08:50:00',4.95),('11288','2013-05-20','08:55:00',4.13),('11288','2013-05-20','09:00:00',4.88),('11288','2013-05-20','09:05:00',4.14),('11288','2013-05-20','09:10:00',5.42),('11288','2013-05-20','09:15:00',1.74),('11288','2013-05-20','09:20:00',3.21),('11288','2013-05-20','09:25:00',1.64),('11288','2013-05-20','09:30:00',2.01),('11288','2013-05-20','09:35:00',3.73),('11288','2013-05-20','09:40:00',1.12),('11288','2013-05-20','09:45:00',3.95),('11288','2013-05-20','09:50:00',3.11),('11288','2013-05-20','09:55:00',1.33),('11288','2013-05-20','10:00:00',2.97),('11288','2013-05-20','10:05:00',1.76),('11288','2013-05-20','10:10:00',4.53),('11288','2013-05-20','10:15:00',1.49),('11288','2013-05-20','10:20:00',1.37),('11288','2013-05-20','10:25:00',3.6),('11288','2013-05-20','10:30:00',5.73),('11288','2013-05-20','10:35:00',2.12),('11288','2013-05-20','10:40:00',3.71),('11288','2013-05-20','10:45:00',2.77),('11288','2013-05-20','10:50:00',3.61),('11288','2013-05-20','10:55:00',1.99),('11288','2013-05-20','11:00:00',7.19),('11288','2013-05-20','11:05:00',7.2),('11288','2013-05-20','11:10:00',7.6),('11288','2013-05-20','11:15:00',6.78),('11288','2013-05-20','11:20:00',4.29),('11288','2013-05-20','11:25:00',6.09),('11288','2013-05-20','11:30:00',6.68),('11288','2013-05-20','11:35:00',4.86),('11288','2013-05-20','11:40:00',3.26),('11288','2013-05-20','11:45:00',2.8),('11288','2013-05-20','11:50:00',3.73),('11288','2013-05-20','11:55:00',6.59),('11288','2013-05-20','12:00:00',4.67),('11288','2013-05-20','12:05:00',7.94),('11288','2013-05-20','12:10:00',4.19),('11288','2013-05-20','12:15:00',3.82),('11288','2013-05-20','12:20:00',6.86),('11288','2013-05-20','12:25:00',5.47),('11288','2013-05-20','12:30:00',3.23),('11288','2013-05-20','12:35:00',3.39),('11288','2013-05-20','12:40:00',9.18),('11288','2013-05-20','12:45:00',5.76),('11288','2013-05-20','12:50:00',3.32),('11288','2013-05-20','12:55:00',5.91),('11288','2013-05-20','13:00:00',6.55),('11288','2013-05-20','13:05:00',3.67),('11288','2013-05-20','13:10:00',3.08),('11288','2013-05-20','13:15:00',3.65),('11288','2013-05-20','13:20:00',5.79),('11288','2013-05-20','13:25:00',7.55),('11288','2013-05-20','13:30:00',2.05),('11288','2013-05-20','13:35:00',8.4),('11288','2013-05-20','13:40:00',2.16),('11288','2013-05-20','13:45:00',8.2),('11288','2013-05-20','13:50:00',6.22),('11288','2013-05-20','13:55:00',8.34),('11288','2013-05-20','14:00:00',6.09),('11288','2013-05-20','14:05:00',1.55),('11288','2013-05-20','14:10:00',6.51),('11288','2013-05-20','14:15:00',6.94),('11288','2013-05-20','14:20:00',2.38),('11288','2013-05-20','14:25:00',8.04),('11288','2013-05-20','14:30:00',7.2),('11288','2013-05-20','14:35:00',4.51),('11288','2013-05-20','14:40:00',3.9),('11288','2013-05-20','14:45:00',6.57),('11288','2013-05-20','14:50:00',5.03),('11288','2013-05-20','14:55:00',5.93),('11288','2013-05-20','15:00:00',3.3),('11288','2013-05-20','15:05:00',5.76),('11288','2013-05-20','15:10:00',7.57),('11288','2013-05-20','15:15:00',2.5),('11288','2013-05-20','15:20:00',7.12),('11288','2013-05-20','15:25:00',5.43),('11288','2013-05-20','15:30:00',7),('11288','2013-05-20','15:35:00',6.32),('11288','2013-05-20','15:40:00',3.71),('11288','2013-05-20','15:45:00',4.25),('11288','2013-05-20','15:50:00',3.65),('11288','2013-05-20','15:55:00',4.77),('11288','2013-05-20','16:00:00',3.41),('11288','2013-05-20','16:05:00',4.31),('11288','2013-05-20','16:10:00',4.19),('11288','2013-05-20','16:15:00',5.4),('11288','2013-05-20','16:20:00',5.93),('11288','2013-05-20','16:25:00',5.74),('11288','2013-05-20','16:30:00',5.45),('11288','2013-05-20','16:35:00',5.26),('11288','2013-05-20','16:40:00',5.15),('11288','2013-05-20','16:45:00',4.8),('11288','2013-05-20','16:50:00',4.72),('11288','2013-05-20','16:55:00',4.36),('11288','2013-05-20','17:00:00',4.29),('11288','2013-05-20','17:05:00',4.22),('11288','2013-05-20','17:10:00',3.23),('11288','2013-05-20','17:15:00',2.17),('11288','2013-05-20','17:20:00',3.37),('11288','2013-05-20','17:25:00',4.07),('11288','2013-05-20','17:30:00',3.8),('11288','2013-05-20','17:35:00',3.49),('11288','2013-05-20','17:40:00',3.28),('11288','2013-05-20','17:45:00',3.13),('11288','2013-05-20','17:50:00',3.08),('11288','2013-05-20','17:55:00',2.96),('11288','2013-05-20','18:00:00',2.82),('11288','2013-05-20','18:05:00',2.9),('11288','2013-05-20','18:10:00',2.35),('11288','2013-05-20','18:15:00',2.4),('11288','2013-05-20','18:20:00',2.32),('11288','2013-05-20','18:25:00',2.09),('11288','2013-05-20','18:30:00',1.96),('11288','2013-05-20','18:35:00',1.83),('11288','2013-05-20','18:40:00',1.54),('11288','2013-05-20','18:45:00',1.54),('11288','2013-05-20','18:50:00',1.4),('11288','2013-05-20','18:55:00',1.28),('11288','2013-05-20','19:00:00',1.14),('11288','2013-05-20','19:05:00',1.02),('11288','2013-05-19','08:00:00',1.13),('11288','2013-05-19','08:05:00',1.01),('11288','2013-05-19','08:10:00',1.21),('11288','2013-05-19','08:15:00',1.2),('11288','2013-05-19','08:20:00',1.14),('11288','2013-05-19','08:25:00',1.14),('11288','2013-05-19','08:30:00',1.7),('11288','2013-05-19','08:35:00',2.17),('11288','2013-05-19','08:40:00',1.67),('11288','2013-05-19','08:45:00',1.89),('11288','2013-05-19','08:50:00',2.35),('11288','2013-05-19','08:55:00',2.5),('11288','2013-05-19','09:00:00',2.26),('11288','2013-05-19','09:05:00',2.13),('11288','2013-05-19','09:10:00',2.42),('11288','2013-05-19','09:15:00',2.39),('11288','2013-05-19','09:20:00',1.57),('11288','2013-05-19','09:30:00',1.38),('11288','2013-05-19','09:35:00',1.61),('11288','2013-05-19','09:40:00',2.08),('11288','2013-05-19','09:45:00',2.3),('11288','2013-05-19','09:50:00',1.7),('11288','2013-05-19','09:55:00',2.02),('11288','2013-05-19','10:00:00',2.42),('11288','2013-05-19','10:05:00',3.08),('11288','2013-05-19','10:10:00',4.34),('11288','2013-05-19','10:15:00',4.58),('11288','2013-05-19','10:20:00',5.2),('11288','2013-05-19','10:25:00',4.35),('11288','2013-05-19','10:30:00',5.32),('11288','2013-05-19','10:35:00',6.45),('11288','2013-05-19','10:40:00',7.2),('11288','2013-05-19','10:45:00',7.41),('11288','2013-05-19','10:50:00',7.18),('11288','2013-05-19','10:55:00',7.96),('11288','2013-05-19','11:00:00',6.55),('11288','2013-05-19','11:05:00',3.61),('11288','2013-05-19','11:10:00',6.2),('11288','2013-05-19','11:15:00',7.36),('11288','2013-05-19','11:20:00',7.22),('11288','2013-05-19','11:25:00',7.34),('11288','2013-05-19','11:30:00',7.38),('11288','2013-05-19','11:35:00',7.4),('11288','2013-05-19','11:40:00',7.47),('11288','2013-05-19','11:45:00',7.56),('11288','2013-05-19','11:50:00',7.55),('11288','2013-05-19','11:55:00',7.72),('11288','2013-05-19','12:00:00',7.61),('11288','2013-05-19','12:05:00',7.63),('11288','2013-05-19','12:10:00',7.63),('11288','2013-05-19','12:15:00',7.88),('11288','2013-05-19','12:20:00',7.86),('11288','2013-05-19','12:25:00',5.28),('11288','2013-05-19','12:30:00',4.91),('11288','2013-05-19','12:35:00',5.26),('11288','2013-05-19','12:40:00',7.06),('11288','2013-05-19','12:45:00',6.87),('11288','2013-05-19','12:50:00',5.3),('11288','2013-05-19','12:55:00',4.41),('11288','2013-05-19','13:00:00',6.88),('11288','2013-05-19','13:05:00',7.08),('11288','2013-05-19','13:10:00',6.65),('11288','2013-05-19','13:15:00',6.2),('11288','2013-05-19','13:20:00',6.23),('11288','2013-05-19','13:25:00',7.44),('11288','2013-05-19','13:30:00',7.6),('11288','2013-05-19','13:35:00',7.53),('11288','2013-05-19','13:40:00',7.55),('11288','2013-05-19','13:45:00',7.54),('11288','2013-05-19','13:50:00',7.56),('11288','2013-05-19','13:55:00',7.5),('11288','2013-05-19','14:00:00',7.5),('11288','2013-05-19','14:05:00',7.47),('11288','2013-05-19','14:10:00',7.45),('11288','2013-05-19','14:15:00',7.41),('11288','2013-05-19','14:20:00',7.38),('11288','2013-05-19','14:25:00',7.37),('11288','2013-05-19','14:30:00',7.31),('11288','2013-05-19','14:35:00',7.23),('11288','2013-05-19','14:40:00',7.18),('11288','2013-05-19','14:45:00',7.16),('11288','2013-05-19','14:50:00',7.11),('11288','2013-05-19','14:55:00',7.07),('11288','2013-05-19','15:00:00',6.95),('11288','2013-05-19','15:05:00',6.96),('11288','2013-05-19','15:10:00',6.84),('11288','2013-05-19','15:15:00',6.8),('11288','2013-05-19','15:20:00',6.65),('11288','2013-05-19','15:25:00',6.71),('11288','2013-05-19','15:30:00',6.63),('11288','2013-05-19','15:35:00',6.48),('11288','2013-05-19','15:40:00',6.39),('11288','2013-05-19','15:45:00',6.33),('11288','2013-05-19','15:50:00',6.28),('11288','2013-05-19','15:55:00',6.14),('11288','2013-05-19','16:00:00',6.11),('11288','2013-05-19','16:05:00',5.97),('11288','2013-05-19','16:10:00',5.83),('11288','2013-05-19','16:15:00',5.75),('11288','2013-05-19','16:20:00',5.61),('11288','2013-05-19','16:25:00',5.53),('11288','2013-05-19','16:30:00',5.34),('11288','2013-05-19','16:35:00',5.25),('11288','2013-05-19','16:40:00',5.15),('11288','2013-05-19','16:45:00',5.03),('11288','2013-05-19','16:50:00',4.85),('11288','2013-05-19','16:55:00',4.67),('11288','2013-05-19','17:00:00',4.43),('11288','2013-05-19','17:05:00',4.41),('11288','2013-05-19','17:10:00',4.34),('11288','2013-05-19','17:15:00',4.21),('11288','2013-05-19','17:20:00',4.07),('11288','2013-05-19','17:25:00',3.91),('11288','2013-05-19','17:30:00',3.72),('11288','2013-05-19','17:35:00',3.59),('11288','2013-05-19','17:40:00',3.44),('11288','2013-05-19','17:45:00',3.28),('11288','2013-05-19','17:50:00',3.28),('11288','2013-05-19','17:55:00',3.16),('11288','2013-05-19','18:00:00',3.01),('11288','2013-05-19','18:05:00',2.85),('11288','2013-05-19','18:10:00',2.73),('11288','2013-05-19','18:15:00',2.56),('11288','2013-05-19','18:20:00',2.42),('11288','2013-05-19','18:25:00',2.27),('11288','2013-05-19','18:30:00',2.12),('11288','2013-05-19','18:35:00',2.01),('11288','2013-05-19','18:40:00',1.85),('11288','2013-05-19','18:45:00',1.68),('11288','2013-05-19','18:50:00',1.54),('11288','2013-05-19','18:55:00',1.38),('11288','2013-05-19','19:00:00',1.21),('11288','2013-05-19','19:05:00',1.05),('11288','2013-05-18','07:15:00',1.04),('11288','2013-05-18','07:20:00',1.14),('11288','2013-05-18','07:25:00',1.31),('11288','2013-05-18','07:30:00',1.41),('11288','2013-05-18','07:35:00',1.48),('11288','2013-05-18','07:40:00',1.7),('11288','2013-05-18','07:45:00',1.81),('11288','2013-05-18','07:50:00',1.93),('11288','2013-05-18','07:55:00',2.83),('11288','2013-05-18','08:00:00',3.16),('11288','2013-05-18','08:05:00',2.86),('11288','2013-05-18','08:10:00',1.83),('11288','2013-05-18','08:15:00',1.8),('11288','2013-05-18','08:20:00',2.58),('11288','2013-05-18','08:25:00',3.72),('11288','2013-05-18','08:30:00',3.58),('11288','2013-05-18','08:35:00',3.26),('11288','2013-05-18','08:40:00',3.57),('11288','2013-05-18','08:45:00',3.54),('11288','2013-05-18','08:50:00',3.54),('11288','2013-05-18','08:55:00',3.62),('11288','2013-05-18','09:00:00',3.89),('11288','2013-05-18','09:05:00',3.97),('11288','2013-05-18','09:10:00',4.25),('11288','2013-05-18','09:15:00',4.34),('11288','2013-05-18','09:20:00',4.43),('11288','2013-05-18','09:25:00',4.49),('11288','2013-05-18','09:30:00',4.71),('11288','2013-05-18','09:35:00',4.62),('11288','2013-05-18','09:40:00',4.88),('11288','2013-05-18','09:45:00',5.04),('11288','2013-05-18','09:50:00',4.92),('11288','2013-05-18','09:55:00',5.23),('11288','2013-05-18','10:00:00',5.44),('11288','2013-05-18','10:05:00',5.59),('11288','2013-05-18','10:10:00',5.59),('11288','2013-05-18','10:15:00',5.76),('11288','2013-05-18','10:20:00',5.86),('11288','2013-05-18','10:25:00',5.95),('11288','2013-05-18','10:30:00',5.97),('11288','2013-05-18','10:35:00',5.94),('11288','2013-05-18','10:40:00',6.13),('11288','2013-05-18','10:45:00',6.19),('11288','2013-05-18','10:50:00',6.32),('11288','2013-05-18','10:55:00',6.31),('11288','2013-05-18','11:00:00',6.72),('11288','2013-05-18','11:05:00',5.87),('11288','2013-05-18','11:10:00',5.5),('11288','2013-05-18','11:15:00',6.99),('11288','2013-05-18','11:20:00',6.76),('11288','2013-05-18','11:25:00',6.98),('11288','2013-05-18','11:30:00',6.35),('11288','2013-05-18','11:35:00',6.69),('11288','2013-05-18','11:40:00',6.82),('11288','2013-05-18','11:45:00',6.8),('11288','2013-05-18','11:50:00',6.57),('11288','2013-05-18','11:55:00',6.39),('11288','2013-05-18','12:00:00',6.71),('11288','2013-05-18','12:05:00',6.83),('11288','2013-05-18','12:10:00',6.8),('11288','2013-05-18','12:15:00',6.79),('11288','2013-05-18','12:20:00',6.91),('11288','2013-05-18','12:25:00',7.08),('11288','2013-05-18','12:30:00',5.31),('11288','2013-05-18','12:35:00',7.07),('11288','2013-05-18','12:40:00',6.99),('11288','2013-05-18','12:45:00',6.39),('11288','2013-05-18','12:50:00',7),('11288','2013-05-18','12:55:00',6.91),('11288','2013-05-18','13:00:00',6.97),('11288','2013-05-18','13:05:00',6.97),('11288','2013-05-18','13:10:00',7.02),('11288','2013-05-18','13:15:00',7.02),('11288','2013-05-18','13:20:00',7.03),('11288','2013-05-18','13:25:00',7.02),('11288','2013-05-18','13:30:00',7.04),('11288','2013-05-18','13:35:00',6.49),('11288','2013-05-18','13:40:00',7.02),('11288','2013-05-18','13:45:00',7.33),('11288','2013-05-18','13:50:00',6.36),('11288','2013-05-18','13:55:00',5.4),('11288','2013-05-18','14:00:00',5.02),('11288','2013-05-18','14:05:00',6.27),('11288','2013-05-18','14:10:00',7.42),('11288','2013-05-18','14:15:00',7.17),('11288','2013-05-18','14:20:00',7.14),('11288','2013-05-18','14:25:00',6.96),('11288','2013-05-18','14:30:00',6.88),('11288','2013-05-18','14:35:00',6.62),('11288','2013-05-18','14:40:00',7.11),('11288','2013-05-18','14:45:00',6.8),('11288','2013-05-18','14:50:00',6.82),('11288','2013-05-18','14:55:00',5.99),('11288','2013-05-18','15:00:00',6.13),('11288','2013-05-18','15:05:00',6.06),('11288','2013-05-18','15:10:00',5.97),('11288','2013-05-18','15:15:00',5.87),('11288','2013-05-18','15:20:00',5.77),('11288','2013-05-18','15:25:00',5.69),('11288','2013-05-18','15:30:00',5.64),('11288','2013-05-18','15:35:00',5.6),('11288','2013-05-18','15:40:00',5.48),('11288','2013-05-18','15:45:00',5.39),('11288','2013-05-18','15:50:00',5.32),('11288','2013-05-18','15:55:00',5.23),('11288','2013-05-18','16:00:00',5.14),('11288','2013-05-18','16:05:00',5.03),('11288','2013-05-18','16:10:00',4.91),('11288','2013-05-18','16:15:00',4.83),('11288','2013-05-18','16:20:00',4.76),('11288','2013-05-18','16:25:00',4.67),('11288','2013-05-18','16:30:00',4.5),('11288','2013-05-18','16:35:00',4.38),('11288','2013-05-18','16:40:00',4.28),('11288','2013-05-18','16:45:00',4.16),('11288','2013-05-18','16:50:00',4.01),('11288','2013-05-18','16:55:00',3.85),('11288','2013-05-18','17:00:00',3.68),('11288','2013-05-18','17:05:00',3.64),('11288','2013-05-18','17:10:00',3.52),('11288','2013-05-18','17:15:00',3.42),('11288','2013-05-18','17:20:00',3.31),('11288','2013-05-18','17:25:00',3.17),('11288','2013-05-18','17:30:00',3),('11288','2013-05-18','17:35:00',2.87),('11288','2013-05-18','17:40:00',2.77),('11288','2013-05-18','17:45:00',2.67),('11288','2013-05-18','17:50:00',2.62),('11288','2013-05-18','17:55:00',2.54),('11288','2013-05-18','18:00:00',2.38),('11288','2013-05-18','18:05:00',2.23),('11288','2013-05-18','18:10:00',2.08),('11288','2013-05-18','18:15:00',1.95),('11288','2013-05-18','18:20:00',1.85),('11288','2013-05-18','18:25:00',1.73),('11288','2013-05-18','18:30:00',1.6),('11288','2013-05-18','18:35:00',1.49),('11288','2013-05-18','18:40:00',1.38),('11288','2013-05-18','18:45:00',1.26),('11288','2013-05-18','18:50:00',1.15),('11288','2013-05-18','18:55:00',1.05),('11288','2013-05-17','07:05:00',1.21),('11288','2013-05-17','07:10:00',1.22),('11288','2013-05-17','07:15:00',1.01),('11288','2013-05-17','07:20:00',1.24),('11288','2013-05-17','07:35:00',1.16),('11288','2013-05-17','07:40:00',1.77),('11288','2013-05-17','07:45:00',1.73),('11288','2013-05-17','07:50:00',1.91),('11288','2013-05-17','07:55:00',1.89),('11288','2013-05-17','08:00:00',1.71),('11288','2013-05-17','08:05:00',1.76),('11288','2013-05-17','08:10:00',2.07),('11288','2013-05-17','08:15:00',3.05),('11288','2013-05-17','08:20:00',3.48),('11288','2013-05-17','08:25:00',2.81),('11288','2013-05-17','08:30:00',1.43),('11288','2013-05-17','08:35:00',1.05),('11288','2013-05-17','09:05:00',1.16),('11288','2013-05-17','09:10:00',1.3),('11288','2013-05-17','09:15:00',1.16),('11288','2013-05-17','09:20:00',1.63),('11288','2013-05-17','09:25:00',1.87),('11288','2013-05-17','10:15:00',1.35),('11288','2013-05-17','10:20:00',1.75),('11288','2013-05-17','10:25:00',2.52),('11288','2013-05-17','10:30:00',2.95),('11288','2013-05-17','10:35:00',2.31),('11288','2013-05-17','10:40:00',2.63),('11288','2013-05-17','10:45:00',2.85),('11288','2013-05-17','10:50:00',5.39),('11288','2013-05-17','10:55:00',5.21),('11288','2013-05-17','11:00:00',3.93),('11288','2013-05-17','11:05:00',3.51),('11288','2013-05-17','11:10:00',2.69),('11288','2013-05-17','11:15:00',3.66),('11288','2013-05-17','11:20:00',3.5),('11288','2013-05-17','11:25:00',3.04),('11288','2013-05-17','11:30:00',3.02),('11288','2013-05-17','11:35:00',3.75),('11288','2013-05-17','11:40:00',3.18),('11288','2013-05-17','11:45:00',7.72),('11288','2013-05-17','11:50:00',8.43),('11288','2013-05-17','11:55:00',7.01),('11288','2013-05-17','12:00:00',7.22),('11288','2013-05-17','12:05:00',6.73),('11288','2013-05-17','12:10:00',5.34),('11288','2013-05-17','12:15:00',4.86),('11288','2013-05-17','12:20:00',6.65),('11288','2013-05-17','12:25:00',5.25),('11288','2013-05-17','12:30:00',3.94),('11288','2013-05-17','12:35:00',6.32),('11288','2013-05-17','12:40:00',7.8),('11288','2013-05-17','12:45:00',8.21),('11288','2013-05-17','12:50:00',8.16),('11288','2013-05-17','12:55:00',7.24),('11288','2013-05-17','13:00:00',7.49),('11288','2013-05-17','13:05:00',7.5),('11288','2013-05-17','13:10:00',7.08),('11288','2013-05-17','13:15:00',7.93),('11288','2013-05-17','13:20:00',8.48),('11288','2013-05-17','13:25:00',7.11),('11288','2013-05-17','13:30:00',6.04),('11288','2013-05-17','13:35:00',7.69),('11288','2013-05-17','13:40:00',7.19),('11288','2013-05-17','13:45:00',6.85),('11288','2013-05-17','13:50:00',7.31),('11288','2013-05-17','13:55:00',7.73),('11288','2013-05-17','14:00:00',5.57),('11288','2013-05-17','14:05:00',6.34),('11288','2013-05-17','14:10:00',6.7),('11288','2013-05-17','14:15:00',7.24),('11288','2013-05-17','14:20:00',7.71),('11288','2013-05-17','14:25:00',6.32),('11288','2013-05-17','14:30:00',7.27),('11288','2013-05-17','14:35:00',7.09),('11288','2013-05-17','14:40:00',5.31),('11288','2013-05-17','14:45:00',5.78),('11288','2013-05-17','14:50:00',7.42),('11288','2013-05-17','14:55:00',4.76),('11288','2013-05-17','15:00:00',7.32),('11288','2013-05-17','15:05:00',4.73),('11288','2013-05-17','15:10:00',2.75),('11288','2013-05-17','15:15:00',6.04),('11288','2013-05-17','15:20:00',4),('11288','2013-05-17','15:25:00',2.86),('11288','2013-05-17','15:30:00',4.11),('11288','2013-05-17','15:35:00',5.35),('11288','2013-05-17','15:40:00',4.72),('11288','2013-05-17','15:45:00',3.99),('11288','2013-05-17','15:50:00',5.8),('11288','2013-05-17','15:55:00',7.12),('11288','2013-05-17','16:00:00',5.94),('11288','2013-05-17','16:05:00',4.48),('11288','2013-05-17','16:10:00',6.51),('11288','2013-05-17','16:15:00',4.47),('11288','2013-05-17','16:20:00',5.51),('11288','2013-05-17','16:25:00',5.58),('11288','2013-05-17','16:30:00',5.65),('11288','2013-05-17','16:35:00',6.08),('11288','2013-05-17','16:40:00',5.68),('11288','2013-05-17','16:45:00',5.24),('11288','2013-05-17','16:50:00',4.82),('11288','2013-05-17','16:55:00',4.58),('11288','2013-05-17','17:00:00',4.48),('11288','2013-05-17','17:05:00',4.3),('11288','2013-05-17','17:10:00',4.17),('11288','2013-05-17','17:15:00',4.06),('11288','2013-05-17','17:20:00',3.95),('11288','2013-05-17','17:25:00',3.8),('11288','2013-05-17','17:30:00',3.64),('11288','2013-05-17','17:35:00',3.5),('11288','2013-05-17','17:40:00',3.34),('11288','2013-05-17','17:45:00',3.19),('11288','2013-05-17','17:50:00',3.12),('11288','2013-05-17','17:55:00',3.04),('11288','2013-05-17','18:00:00',2.94),('11288','2013-05-17','18:05:00',2.75),('11288','2013-05-17','18:10:00',2.61),('11288','2013-05-17','18:15:00',2.45),('11288','2013-05-17','18:20:00',2.32),('11288','2013-05-17','18:25:00',2.17),('11288','2013-05-17','18:30:00',2.02),('11288','2013-05-17','18:35:00',1.93),('11288','2013-05-17','18:40:00',1.74),('11288','2013-05-17','18:45:00',1.59),('11288','2013-05-17','18:50:00',1.47),('11288','2013-05-17','18:55:00',1.25),('11288','2013-05-16','09:15:00',1.65),('11288','2013-05-16','09:20:00',2.07),('11288','2013-05-16','09:25:00',2.78),('11288','2013-05-16','09:30:00',2.86),('11288','2013-05-16','09:35:00',3.48),('11288','2013-05-16','09:40:00',3.73),('11288','2013-05-16','09:45:00',4.26),('11288','2013-05-16','09:50:00',2.34),('11288','2013-05-16','09:55:00',2.42),('11288','2013-05-16','10:00:00',2.85),('11288','2013-05-16','10:05:00',2.31),('11288','2013-05-16','10:10:00',2.18),('11288','2013-05-16','10:15:00',2.8),('11288','2013-05-16','10:20:00',3.73),('11288','2013-05-16','10:25:00',3.29),('11288','2013-05-16','10:30:00',3.44),('11288','2013-05-16','10:35:00',2.51),('11288','2013-05-16','10:40:00',2.44),('11288','2013-05-16','10:45:00',2.18),('11288','2013-05-16','10:50:00',2.49),('11288','2013-05-16','10:55:00',2.9),('11288','2013-05-16','11:00:00',7.03),('11288','2013-05-16','11:05:00',5.4),('11288','2013-05-16','11:10:00',5.44),('11288','2013-05-16','11:15:00',3.6),('11288','2013-05-16','11:20:00',2.04),('11288','2013-05-16','11:25:00',2.19),('11288','2013-05-16','11:30:00',2.7),('11288','2013-05-16','11:35:00',4.15),('11288','2013-05-16','11:40:00',6.21),('11288','2013-05-16','11:45:00',4.96),('11288','2013-05-16','11:50:00',5.17),('11288','2013-05-16','11:55:00',4.14),('11288','2013-05-16','12:00:00',3.13),('11288','2013-05-16','12:05:00',3.01),('11288','2013-05-16','12:10:00',3.04),('11288','2013-05-16','12:15:00',4.13),('11288','2013-05-16','12:20:00',3.39),('11288','2013-05-16','12:25:00',3.61),('11288','2013-05-16','12:30:00',6.05),('11288','2013-05-16','12:35:00',6.06),('11288','2013-05-16','12:40:00',7.26),('11288','2013-05-16','12:45:00',5.29),('11288','2013-05-16','12:50:00',4.56),('11288','2013-05-16','12:55:00',6.87),('11288','2013-05-16','13:00:00',6.84),('11288','2013-05-16','13:05:00',6.92),('11288','2013-05-16','13:10:00',6.78),('11288','2013-05-16','13:15:00',5.95),('11288','2013-05-16','13:20:00',5.18),('11288','2013-05-16','13:25:00',6.84),('11288','2013-05-16','13:30:00',6.73),('11288','2013-05-16','13:35:00',6.64),('11288','2013-05-16','13:40:00',6.56),('11288','2013-05-16','13:45:00',6.52),('11288','2013-05-16','13:50:00',6.56),('11288','2013-05-16','13:55:00',6.57),('11288','2013-05-16','14:00:00',6.53),('11288','2013-05-16','14:05:00',6.54),('11288','2013-05-16','14:10:00',6.47),('11288','2013-05-16','14:15:00',6.41),('11288','2013-05-16','14:20:00',6.31),('11288','2013-05-16','14:25:00',6.19),('11288','2013-05-16','14:30:00',6.22),('11288','2013-05-16','14:35:00',6.13),('11288','2013-05-16','14:40:00',6.07),('11288','2013-05-16','14:45:00',6.01),('11288','2013-05-16','14:50:00',5.47),('11288','2013-05-16','14:55:00',5.36),('11288','2013-05-16','15:00:00',5.92),('11288','2013-05-16','15:05:00',5.75),('11288','2013-05-16','15:10:00',5.64),('11288','2013-05-16','15:15:00',5.33),('11288','2013-05-16','15:20:00',5.67),('11288','2013-05-16','15:25:00',5.55),('11288','2013-05-16','15:30:00',5.39),('11288','2013-05-16','15:35:00',5.22),('11288','2013-05-16','15:40:00',5.41),('11288','2013-05-16','15:45:00',5.22),('11288','2013-05-16','15:50:00',5.19),('11288','2013-05-16','15:55:00',5.11),('11288','2013-05-16','16:00:00',5.04),('11288','2013-05-16','16:05:00',4.74),('11288','2013-05-16','16:10:00',4.83),('11288','2013-05-16','16:15:00',4.42),('11288','2013-05-16','16:20:00',4.76),('11288','2013-05-16','16:25:00',4.6),('11288','2013-05-16','16:30:00',4.53),('11288','2013-05-16','16:35:00',4.19),('11288','2013-05-16','16:40:00',2.7),('11288','2013-05-16','16:45:00',2.46),('11288','2013-05-16','16:50:00',3.23),('11288','2013-05-16','16:55:00',3.04),('11288','2013-05-16','17:00:00',2.49),('11288','2013-05-16','17:05:00',1.36),('11288','2013-05-16','17:10:00',1.49),('11288','2013-05-16','17:15:00',2.4),('11288','2013-05-16','17:20:00',2.65),('11288','2013-05-16','17:25:00',2.8),('11288','2013-05-16','17:30:00',3.09),('11288','2013-05-16','17:35:00',2.89),('11288','2013-05-16','17:40:00',2.45),('11288','2013-05-16','17:45:00',1.82),('11288','2013-05-16','17:50:00',1.13),('11288','2013-05-16','18:25:00',1.08),('11288','2013-05-16','18:30:00',1.24),('11288','2013-05-16','18:35:00',1.46),('11288','2013-05-16','18:40:00',1.5),('11288','2013-05-16','18:45:00',1.67),('11288','2013-05-16','18:50:00',1.74),('11288','2013-05-16','18:55:00',1.74),('11288','2013-05-16','19:00:00',1.8),('11288','2013-05-16','19:05:00',1.65),('11288','2013-05-16','19:10:00',1.36),('11288','2013-05-16','19:15:00',1.14),('11288','2013-05-15','07:20:00',1.1),('11288','2013-05-15','07:25:00',1.21),('11288','2013-05-15','07:30:00',1.36),('11288','2013-05-15','07:35:00',1.38),('11288','2013-05-15','07:40:00',1.63),('11288','2013-05-15','07:45:00',1.87),('11288','2013-05-15','07:50:00',1.89),('11288','2013-05-15','07:55:00',2),('11288','2013-05-15','08:00:00',2),('11288','2013-05-15','08:05:00',1.86),('11288','2013-05-15','08:10:00',2.1),('11288','2013-05-15','08:15:00',2.57),('11288','2013-05-15','08:20:00',2.54),('11288','2013-05-15','08:25:00',2.7),('11288','2013-05-15','08:30:00',2.92),('11288','2013-05-15','08:35:00',2.97),('11288','2013-05-15','08:40:00',3.13),('11288','2013-05-15','08:45:00',3.29),('11288','2013-05-15','08:50:00',3.3),('11288','2013-05-15','08:55:00',3.64),('11288','2013-05-15','09:00:00',3.54),('11288','2013-05-15','09:05:00',3.9),('11288','2013-05-15','09:10:00',3.89),('11288','2013-05-15','09:15:00',4.12),('11288','2013-05-15','09:20:00',4.03),('11288','2013-05-15','09:25:00',4.24),('11288','2013-05-15','09:30:00',4.61),('11288','2013-05-15','09:35:00',4.68),('11288','2013-05-15','09:40:00',4.64),('11288','2013-05-15','09:45:00',4.84),('11288','2013-05-15','09:50:00',4.85),('11288','2013-05-15','09:55:00',4.88),('11288','2013-05-15','10:00:00',5.19),('11288','2013-05-15','10:05:00',5.13),('11288','2013-05-15','10:10:00',5.26),('11288','2013-05-15','10:15:00',5.29),('11288','2013-05-15','10:20:00',5.53),('11288','2013-05-15','10:25:00',5.73),('11288','2013-05-15','10:30:00',5.61),('11288','2013-05-15','10:35:00',5.89),('11288','2013-05-15','10:40:00',6.06),('11288','2013-05-15','10:45:00',6.12),('11288','2013-05-15','10:50:00',6.1),('11288','2013-05-15','10:55:00',5.9),('11288','2013-05-15','11:00:00',5.96),('11288','2013-05-15','11:05:00',6.3),('11288','2013-05-15','11:10:00',6.38),('11288','2013-05-15','11:15:00',6.44),('11288','2013-05-15','11:20:00',6.13),('11288','2013-05-15','11:25:00',6.5),('11288','2013-05-15','11:30:00',6.6),('11288','2013-05-15','11:35:00',6.49),('11288','2013-05-15','11:40:00',5.3),('11288','2013-05-15','11:45:00',5.07),('11288','2013-05-15','11:50:00',4.19),('11288','2013-05-15','11:55:00',3.18),('11288','2013-05-15','12:00:00',3.58),('11288','2013-05-15','12:05:00',5.55),('11288','2013-05-15','12:10:00',8.3),('11288','2013-05-15','12:15:00',7.41),('11288','2013-05-15','12:20:00',5.14),('11288','2013-05-15','12:25:00',6.32),('11288','2013-05-15','12:30:00',5.01),('11288','2013-05-15','12:35:00',6.21),('11288','2013-05-15','12:40:00',7.77),('11288','2013-05-15','12:45:00',4.31),('11288','2013-05-15','12:50:00',4.37),('11288','2013-05-15','12:55:00',4.93),('11288','2013-05-15','13:00:00',4.8),('11288','2013-05-15','13:05:00',5.97),('11288','2013-05-15','13:10:00',4.61),('11288','2013-05-15','13:15:00',4.48),('11288','2013-05-15','13:20:00',4.8),('11288','2013-05-15','13:25:00',4.9),('11288','2013-05-15','13:30:00',4.91),('11288','2013-05-15','13:35:00',4.23),('11288','2013-05-15','13:40:00',4.69),('11288','2013-05-15','13:45:00',4.34),('11288','2013-05-15','13:50:00',3.75),('11288','2013-05-15','13:55:00',3.7),('11288','2013-05-15','14:00:00',3.23),('11288','2013-05-15','14:05:00',2.91),('11288','2013-05-15','14:10:00',3.08),('11288','2013-05-15','14:15:00',3.02),('11288','2013-05-15','14:20:00',3.24),('11288','2013-05-15','14:25:00',2.96),('11288','2013-05-15','14:30:00',2.64),('11288','2013-05-15','14:35:00',2.63),('11288','2013-05-15','14:40:00',2.85),('11288','2013-05-15','14:45:00',2.65),('11288','2013-05-15','14:50:00',2.6),('11288','2013-05-15','14:55:00',2.64),('11288','2013-05-15','15:00:00',2.56),('11288','2013-05-15','15:05:00',1.99),('11288','2013-05-15','15:10:00',1.56),('11288','2013-05-15','15:15:00',1.49),('11288','2013-05-15','15:20:00',1.41),('11288','2013-05-15','15:25:00',1.32),('11288','2013-05-15','15:30:00',1.41),('11288','2013-05-15','15:35:00',1.38),('11288','2013-05-15','15:40:00',1.52),('11288','2013-05-15','15:45:00',2.02),('11288','2013-05-15','15:50:00',2.77),('11288','2013-05-15','15:55:00',3.56),('11288','2013-05-15','16:00:00',3.35),('11288','2013-05-15','16:05:00',3.16),('11288','2013-05-15','16:10:00',2.82),('11288','2013-05-15','16:15:00',2.52),('11288','2013-05-15','16:20:00',2.75),('11288','2013-05-15','16:25:00',2.76),('11288','2013-05-15','16:30:00',2.43),('11288','2013-05-15','16:35:00',2.28),('11288','2013-05-15','16:40:00',2.15),('11288','2013-05-15','16:45:00',2.09),('11288','2013-05-15','16:50:00',2.16),('11288','2013-05-15','16:55:00',2.49),('11288','2013-05-15','17:00:00',2.96),('11288','2013-05-15','17:05:00',3.37),('11288','2013-05-15','17:10:00',4),('11288','2013-05-15','17:15:00',4.17),('11288','2013-05-15','17:20:00',2.87),('11288','2013-05-15','17:25:00',1.67),('11288','2013-05-15','17:30:00',1.8),('11288','2013-05-15','17:35:00',1.56),('11288','2013-05-15','17:40:00',1.44),('11288','2013-05-15','17:45:00',1.5),('11288','2013-05-15','17:50:00',1.53),('11288','2013-05-15','17:55:00',1.47),('11288','2013-05-15','18:00:00',1.33),('11288','2013-05-15','18:05:00',1.07),('11288','2013-05-14','07:20:00',1.08),('11288','2013-05-14','07:25:00',1.14),('11288','2013-05-14','07:30:00',1.25),('11288','2013-05-14','07:35:00',1.32),('11288','2013-05-14','07:40:00',1.43),('11288','2013-05-14','07:45:00',1.69),('11288','2013-05-14','07:50:00',1.82),('11288','2013-05-14','07:55:00',1.91),('11288','2013-05-14','08:00:00',2.07),('11288','2013-05-14','08:05:00',2.02),('11288','2013-05-14','08:10:00',2.19),('11288','2013-05-14','08:15:00',2.5),('11288','2013-05-14','08:20:00',2.73),('11288','2013-05-14','08:25:00',2.88),('11288','2013-05-14','08:30:00',3.01),('11288','2013-05-14','08:35:00',3.18),('11288','2013-05-14','08:40:00',3.18),('11288','2013-05-14','08:45:00',3.42),('11288','2013-05-14','08:50:00',3.46),('11288','2013-05-14','08:55:00',3.61),('11288','2013-05-14','09:00:00',3.79),('11288','2013-05-14','09:05:00',4.13),('11288','2013-05-14','09:10:00',4.18),('11288','2013-05-14','09:15:00',4.31),('11288','2013-05-14','09:20:00',4.36),('11288','2013-05-14','09:25:00',4.44),('11288','2013-05-14','09:30:00',4.65),('11288','2013-05-14','09:35:00',4.89),('11288','2013-05-14','09:40:00',4.85),('11288','2013-05-14','09:45:00',4.96),('11288','2013-05-14','09:50:00',5.34),('11288','2013-05-14','09:55:00',5.42),('11288','2013-05-14','10:00:00',5.53),('11288','2013-05-14','10:05:00',5.68),('11288','2013-05-14','10:10:00',5.81),('11288','2013-05-14','10:15:00',5.9),('11288','2013-05-14','10:20:00',5.98),('11288','2013-05-14','10:25:00',6.08),('11288','2013-05-14','10:30:00',6.09),('11288','2013-05-14','10:35:00',6.21),('11288','2013-05-14','10:40:00',6.28),('11288','2013-05-14','10:45:00',6.39),('11288','2013-05-14','10:50:00',6.47),('11288','2013-05-14','10:55:00',6.52),('11288','2013-05-14','11:00:00',6.56),('11288','2013-05-14','11:05:00',6.67),('11288','2013-05-14','11:10:00',6.73),('11288','2013-05-14','11:15:00',6.73),('11288','2013-05-14','11:20:00',6.77),('11288','2013-05-14','11:25:00',6.8),('11288','2013-05-14','11:30:00',6.79),('11288','2013-05-14','11:35:00',6.82),('11288','2013-05-14','11:40:00',6.82),('11288','2013-05-14','11:45:00',6.86),('11288','2013-05-14','11:50:00',6.98),('11288','2013-05-14','11:55:00',7.03),('11288','2013-05-14','12:00:00',7.03),('11288','2013-05-14','12:05:00',7.05),('11288','2013-05-14','12:10:00',7.07),('11288','2013-05-14','12:15:00',7.11),('11288','2013-05-14','12:20:00',7.23),('11288','2013-05-14','12:25:00',7.25),('11288','2013-05-14','12:30:00',7.27),('11288','2013-05-14','12:35:00',7.27),('11288','2013-05-14','12:40:00',7.31),('11288','2013-05-14','12:45:00',7.32),('11288','2013-05-14','12:50:00',7.28),('11288','2013-05-14','12:55:00',7.31),('11288','2013-05-14','13:00:00',7.34),('11288','2013-05-14','13:05:00',7.31),('11288','2013-05-14','13:10:00',7.25),('11288','2013-05-14','13:15:00',7.27),('11288','2013-05-14','13:20:00',7.16),('11288','2013-05-14','13:25:00',7.18),('11288','2013-05-14','13:30:00',7.13),('11288','2013-05-14','13:35:00',7.09),('11288','2013-05-14','13:40:00',7.13),('11288','2013-05-14','13:45:00',7.08),('11288','2013-05-14','13:50:00',7.05),('11288','2013-05-14','13:55:00',7.03),('11288','2013-05-14','14:00:00',7.02),('11288','2013-05-14','14:05:00',6.96),('11288','2013-05-14','14:10:00',6.89),('11288','2013-05-14','14:15:00',6.88),('11288','2013-05-14','14:20:00',6.8),('11288','2013-05-14','14:25:00',6.73),('11288','2013-05-14','14:30:00',6.73),('11288','2013-05-14','14:35:00',6.71),('11288','2013-05-14','14:40:00',6.73),('11288','2013-05-14','14:45:00',6.78),('11288','2013-05-14','14:50:00',6.78),('11288','2013-05-14','14:55:00',6.76),('11288','2013-05-14','15:00:00',6.71),('11288','2013-05-14','15:05:00',6.65),('11288','2013-05-14','15:10:00',6.59),('11288','2013-05-14','15:15:00',6.51),('11288','2013-05-14','15:20:00',6.47),('11288','2013-05-14','15:25:00',6.44),('11288','2013-05-14','15:30:00',6.36),('11288','2013-05-14','15:35:00',6.27),('11288','2013-05-14','15:40:00',6.19),('11288','2013-05-14','15:45:00',6.1),('11288','2013-05-14','15:50:00',6.01),('11288','2013-05-14','15:55:00',5.92),('11288','2013-05-14','16:00:00',5.81),('11288','2013-05-14','16:05:00',5.68),('11288','2013-05-14','16:10:00',5.56),('11288','2013-05-14','16:15:00',5.46),('11288','2013-05-14','16:20:00',5.36),('11288','2013-05-14','16:25:00',5.26),('11288','2013-05-14','16:30:00',5.11),('11288','2013-05-14','16:35:00',5),('11288','2013-05-14','16:40:00',4.88),('11288','2013-05-14','16:45:00',4.76),('11288','2013-05-14','16:50:00',4.59),('11288','2013-05-14','16:55:00',4.48),('11288','2013-05-14','17:00:00',4.27),('11288','2013-05-14','17:05:00',4.12),('11288','2013-05-14','17:10:00',4.01),('11288','2013-05-14','17:15:00',3.9),('11288','2013-05-14','17:20:00',3.75),('11288','2013-05-14','17:25:00',3.6),('11288','2013-05-14','17:30:00',3.45),('11288','2013-05-14','17:35:00',3.26),('11288','2013-05-14','17:40:00',3.13),('11288','2013-05-14','17:45:00',3.01),('11288','2013-05-14','17:50:00',2.88),('11288','2013-05-14','17:55:00',2.81),('11288','2013-05-14','18:00:00',2.74),('11288','2013-05-14','18:05:00',2.56),('11288','2013-05-14','18:10:00',2.41),('11288','2013-05-14','18:15:00',2.28),('11288','2013-05-14','18:20:00',2.13),('11288','2013-05-14','18:25:00',2.01),('11288','2013-05-14','18:30:00',1.87),('11288','2013-05-14','18:35:00',1.73),('11288','2013-05-14','18:40:00',1.62),('11288','2013-05-14','18:45:00',1.47),('11288','2013-05-14','18:50:00',1.31),('11288','2013-05-14','18:55:00',1.16),('11288','2013-05-13','07:15:00',1.02),('11288','2013-05-13','07:35:00',1.29),('11288','2013-05-13','07:40:00',1.55),('11288','2013-05-13','07:45:00',1.72),('11288','2013-05-13','07:50:00',1.84),('11288','2013-05-13','07:55:00',2),('11288','2013-05-13','08:00:00',1.94),('11288','2013-05-13','08:05:00',2.02),('11288','2013-05-13','08:10:00',2.29),('11288','2013-05-13','08:15:00',2.39),('11288','2013-05-13','08:20:00',2.44),('11288','2013-05-13','08:25:00',2.8),('11288','2013-05-13','08:30:00',2.88),('11288','2013-05-13','08:35:00',2.95),('11288','2013-05-13','08:40:00',3.14),('11288','2013-05-13','08:45:00',3.22),('11288','2013-05-13','08:50:00',3.22),('11288','2013-05-13','08:55:00',3.56),('11288','2013-05-13','09:00:00',3.53),('11288','2013-05-13','09:05:00',3.6),('11288','2013-05-13','09:10:00',4.03),('11288','2013-05-13','09:15:00',4.12),('11288','2013-05-13','09:20:00',4.31),('11288','2013-05-13','09:25:00',4.49),('11288','2013-05-13','09:30:00',4.59),('11288','2013-05-13','09:35:00',4.75),('11288','2013-05-13','09:40:00',4.86),('11288','2013-05-13','09:45:00',5.09),('11288','2013-05-13','09:50:00',4.95),('11288','2013-05-13','09:55:00',5.53),('11288','2013-05-13','10:00:00',5.52),('11288','2013-05-13','10:05:00',5.55),('11288','2013-05-13','10:10:00',5.6),('11288','2013-05-13','10:15:00',4.79),('11288','2013-05-13','10:20:00',2.85),('11288','2013-05-13','10:25:00',6.3),('11288','2013-05-13','10:30:00',6.44),('11288','2013-05-13','10:35:00',3.8),('11288','2013-05-13','10:40:00',3.07),('11288','2013-05-13','10:45:00',1.69),('11288','2013-05-13','10:50:00',2.48),('11288','2013-05-13','10:55:00',4.04),('11288','2013-05-13','11:00:00',7.29),('11288','2013-05-13','11:05:00',4.52),('11288','2013-05-13','11:10:00',5.25),('11288','2013-05-13','11:15:00',3.16),('11288','2013-05-13','11:20:00',2.72),('11288','2013-05-13','11:25:00',2.86),('11288','2013-05-13','11:30:00',2.8),('11288','2013-05-13','11:35:00',4.23),('11288','2013-05-13','11:40:00',7.13),('11288','2013-05-13','11:45:00',3.84),('11288','2013-05-13','11:50:00',5.28),('11288','2013-05-13','11:55:00',3.13),('11288','2013-05-13','12:00:00',3.48),('11288','2013-05-13','12:05:00',3.3),('11288','2013-05-13','12:10:00',7.38),('11288','2013-05-13','12:15:00',3.33),('11288','2013-05-13','12:20:00',2.14),('11288','2013-05-13','12:25:00',1.87),('11288','2013-05-13','12:30:00',2.19),('11288','2013-05-13','12:35:00',8),('11288','2013-05-13','12:40:00',8.24),('11288','2013-05-13','12:45:00',7.96),('11288','2013-05-13','12:50:00',7.85),('11288','2013-05-13','12:55:00',5.42),('11288','2013-05-13','13:00:00',6.03),('11288','2013-05-13','13:05:00',7.16),('11288','2013-05-13','13:10:00',6.98),('11288','2013-05-13','13:15:00',4.11),('11288','2013-05-13','13:20:00',7.38),('11288','2013-05-13','13:25:00',6.64),('11288','2013-05-13','13:30:00',4.67),('11288','2013-05-13','13:35:00',6.53),('11288','2013-05-13','13:40:00',8.11),('11288','2013-05-13','13:45:00',6.87),('11288','2013-05-13','13:50:00',4.72),('11288','2013-05-13','13:55:00',3.18),('11288','2013-05-13','14:00:00',4.98),('11288','2013-05-13','14:05:00',7.95),('11288','2013-05-13','14:10:00',7.88),('11288','2013-05-13','14:15:00',7.67),('11288','2013-05-13','14:20:00',7.44),('11288','2013-05-13','14:25:00',7.38),('11288','2013-05-13','14:30:00',5.73),('11288','2013-05-13','14:35:00',4.74),('11288','2013-05-13','14:40:00',2.09),('11288','2013-05-13','14:45:00',3.32),('11288','2013-05-13','14:50:00',7.04),('11288','2013-05-13','14:55:00',7.71),('11288','2013-05-13','15:00:00',7.74),('11288','2013-05-13','15:05:00',3.29),('11288','2013-05-13','15:10:00',2.26),('11288','2013-05-13','15:15:00',1.68),('11288','2013-05-13','15:20:00',1.79),('11288','2013-05-13','15:25:00',1.46),('11288','2013-05-13','15:30:00',1.52),('11288','2013-05-13','15:35:00',1.33),('11288','2013-05-13','15:40:00',2.28),('11288','2013-05-13','15:45:00',1.55),('11288','2013-05-13','15:50:00',1.69),('11288','2013-05-13','15:55:00',1.23),('11288','2013-05-13','16:00:00',3.67),('11288','2013-05-13','16:05:00',4.13),('11288','2013-05-13','16:10:00',3.25),('11288','2013-05-13','16:15:00',2.25),('11288','2013-05-13','16:20:00',2.39),('11288','2013-05-13','16:25:00',2.48),('11288','2013-05-13','16:30:00',3.37),('11288','2013-05-13','16:35:00',2.23),('11288','2013-05-13','16:40:00',2.43),('11288','2013-05-13','16:45:00',3.87),('11288','2013-05-13','16:50:00',4.69),('11288','2013-05-13','16:55:00',4.46),('11288','2013-05-13','17:00:00',4.69),('11288','2013-05-13','17:05:00',4.68),('11288','2013-05-13','17:10:00',2.11),('11288','2013-05-13','17:15:00',3.67),('11288','2013-05-13','17:20:00',4.7),('11288','2013-05-13','17:25:00',4.54),('11288','2013-05-13','17:30:00',4.7),('11288','2013-05-13','17:35:00',4.35),('11288','2013-05-13','17:40:00',4.06),('11288','2013-05-13','17:45:00',3.85),('11288','2013-05-13','17:50:00',3.51),('11288','2013-05-13','17:55:00',1.83),('11288','2013-05-13','18:00:00',2.54),('11288','2013-05-13','18:05:00',2.51),('11288','2013-05-13','18:10:00',1.67),('11288','2013-05-13','18:15:00',2.65),('11288','2013-05-13','18:20:00',2.26),('11288','2013-05-13','18:25:00',1.29),('11288','2013-05-12','07:35:00',1.29),('11288','2013-05-12','07:40:00',1.19),('11288','2013-05-12','07:45:00',1.51),('11288','2013-05-12','07:50:00',1.54),('11288','2013-05-12','07:55:00',1.41),('11288','2013-05-12','08:00:00',1.38),('11288','2013-05-12','08:05:00',1.67),('11288','2013-05-12','08:10:00',2.3),('11288','2013-05-12','08:15:00',2.22),('11288','2013-05-12','08:20:00',2.28),('11288','2013-05-12','08:25:00',2.7),('11288','2013-05-12','08:30:00',3.39),('11288','2013-05-12','08:35:00',1.56),('11288','2013-05-12','08:40:00',1.66),('11288','2013-05-12','08:45:00',2.81),('11288','2013-05-12','08:50:00',1.85),('11288','2013-05-12','08:55:00',1.94),('11288','2013-05-12','09:00:00',2.92),('11288','2013-05-12','09:05:00',4.9),('11288','2013-05-12','09:10:00',2.28),('11288','2013-05-12','09:15:00',3.23),('11288','2013-05-12','09:20:00',3.54),('11288','2013-05-12','09:25:00',2.5),('11288','2013-05-12','09:30:00',2.16),('11288','2013-05-12','09:35:00',2.05),('11288','2013-05-12','09:40:00',2.06),('11288','2013-05-12','09:45:00',2.82),('11288','2013-05-12','09:50:00',4.88),('11288','2013-05-12','09:55:00',5.99),('11288','2013-05-12','10:00:00',3.88),('11288','2013-05-12','10:05:00',4.71),('11288','2013-05-12','10:10:00',4.7),('11288','2013-05-12','10:15:00',4.96),('11288','2013-05-12','10:20:00',5.91),('11288','2013-05-12','10:25:00',5.5),('11288','2013-05-12','10:30:00',2.16),('11288','2013-05-12','10:35:00',1.88),('11288','2013-05-12','10:40:00',1.6),('11288','2013-05-12','10:45:00',2.46),('11288','2013-05-12','10:50:00',6.29),('11288','2013-05-12','10:55:00',4.61),('11288','2013-05-12','11:00:00',5.14),('11288','2013-05-12','11:05:00',7.35),('11288','2013-05-12','11:10:00',7.33),('11288','2013-05-12','11:15:00',7.22),('11288','2013-05-12','11:20:00',7.25),('11288','2013-05-12','11:25:00',6.66),('11288','2013-05-12','11:30:00',5.92),('11288','2013-05-12','11:35:00',7.95),('11288','2013-05-12','11:40:00',5.49),('11288','2013-05-12','11:45:00',4.76),('11288','2013-05-12','11:50:00',3.72),('11288','2013-05-12','11:55:00',2.49),('11288','2013-05-12','12:00:00',4.36),('11288','2013-05-12','12:05:00',6.32),('11288','2013-05-12','12:10:00',2.59),('11288','2013-05-12','12:15:00',2.14),('11288','2013-05-12','12:20:00',2.03),('11288','2013-05-12','12:25:00',2.03),('11288','2013-05-12','12:30:00',2.87),('11288','2013-05-12','12:35:00',5.81),('11288','2013-05-12','12:40:00',7.28),('11288','2013-05-12','12:45:00',4.68),('11288','2013-05-12','12:50:00',5.8),('11288','2013-05-12','12:55:00',3.44),('11288','2013-05-12','13:00:00',2.75),('11288','2013-05-12','13:05:00',3.77),('11288','2013-05-12','13:10:00',5.79),('11288','2013-05-12','13:15:00',3),('11288','2013-05-12','13:20:00',5.27),('11288','2013-05-12','13:25:00',5.06),('11288','2013-05-12','13:30:00',6.61),('11288','2013-05-12','13:35:00',7.69),('11288','2013-05-12','13:40:00',5.53),('11288','2013-05-12','13:45:00',6.76),('11288','2013-05-12','13:50:00',8.44),('11288','2013-05-12','13:55:00',3.5),('11288','2013-05-12','14:00:00',5.68),('11288','2013-05-12','14:05:00',7.24),('11288','2013-05-12','14:10:00',7.72),('11288','2013-05-12','14:15:00',6.44),('11288','2013-05-12','14:20:00',7.22),('11288','2013-05-12','14:25:00',7.48),('11288','2013-05-12','14:30:00',7.5),('11288','2013-05-12','14:35:00',7.36),('11288','2013-05-12','14:40:00',7.28),('11288','2013-05-12','14:45:00',7.08),('11288','2013-05-12','14:50:00',7.21),('11288','2013-05-12','14:55:00',7.18),('11288','2013-05-12','15:00:00',7.09),('11288','2013-05-12','15:05:00',6.69),('11288','2013-05-12','15:10:00',6.18),('11288','2013-05-12','15:15:00',5.91),('11288','2013-05-12','15:20:00',4.28),('11288','2013-05-12','15:25:00',5.81),('11288','2013-05-12','15:30:00',6.45),('11288','2013-05-12','15:35:00',6.29),('11288','2013-05-12','15:40:00',6.27),('11288','2013-05-12','15:45:00',6.15),('11288','2013-05-12','15:50:00',6),('11288','2013-05-12','15:55:00',5.83),('11288','2013-05-12','16:00:00',4.63),('11288','2013-05-12','16:05:00',5.62),('11288','2013-05-12','16:10:00',5.52),('11288','2013-05-12','16:15:00',5.42),('11288','2013-05-12','16:20:00',5.3),('11288','2013-05-12','16:25:00',5.16),('11288','2013-05-12','16:30:00',5.07),('11288','2013-05-12','16:35:00',4.91),('11288','2013-05-12','16:40:00',4.75),('11288','2013-05-12','16:45:00',4.99),('11288','2013-05-12','16:50:00',4.66),('11288','2013-05-12','16:55:00',5.14),('11288','2013-05-12','17:00:00',5.14),('11288','2013-05-12','17:05:00',5.06),('11288','2013-05-12','17:10:00',4.99),('11288','2013-05-12','17:15:00',5.21),('11288','2013-05-12','17:20:00',4.65),('11288','2013-05-12','17:25:00',3.88),('11288','2013-05-12','17:30:00',2.99),('11288','2013-05-12','17:35:00',4.06),('11288','2013-05-12','17:40:00',3.57),('11288','2013-05-12','17:45:00',2.58),('11288','2013-05-12','17:50:00',2.27),('11288','2013-05-12','17:55:00',1.64),('11288','2013-05-12','18:00:00',3.35),('11288','2013-05-12','18:05:00',3.04),('11288','2013-05-12','18:10:00',2.82),('11288','2013-05-12','18:15:00',2.87),('11288','2013-05-12','18:20:00',2.04),('11288','2013-05-12','18:25:00',2.35),('11288','2013-05-12','18:30:00',2.01),('11288','2013-05-12','18:35:00',2.02),('11288','2013-05-12','18:40:00',1.9),('11288','2013-05-12','18:45:00',1.27),('11288','2013-05-12','18:50:00',1.33),('11288','2013-05-12','18:55:00',1.03),('11288','2013-05-12','19:00:00',1.47),('11288','2013-05-12','19:05:00',1.05),('11288','2013-05-12','19:10:00',1.19),('11288','2013-05-12','19:15:00',1.22),('11288','2013-05-12','19:20:00',1.04),('11288','2014-03-31','08:10:00',1.01),('11288','2014-03-31','08:15:00',1.06),('11288','2014-03-31','08:20:00',1.22),('11288','2014-03-31','08:25:00',1.33),('11288','2014-03-31','08:30:00',1.42),('11288','2014-03-31','08:35:00',1.63),('11288','2014-03-31','08:40:00',1.77),('11288','2014-03-31','08:45:00',1.81),('11288','2014-03-31','08:50:00',2.06),('11288','2014-03-31','08:55:00',2.19),('11288','2014-03-31','09:00:00',2.37),('11288','2014-03-31','09:05:00',2.46),('11288','2014-03-31','09:10:00',2.6),('11288','2014-03-31','09:15:00',2.69),('11288','2014-03-31','09:20:00',2.88),('11288','2014-03-31','09:25:00',2.8),('11288','2014-03-31','09:30:00',2.86),('11288','2014-03-31','09:35:00',3.33),('11288','2014-03-31','09:40:00',3.31),('11288','2014-03-31','09:45:00',3.66),('11288','2014-03-31','09:50:00',3.86),('11288','2014-03-31','09:55:00',4.01),('11288','2014-03-31','10:00:00',4.1),('11288','2014-03-31','10:05:00',4.24),('11288','2014-03-31','10:10:00',4.43),('11288','2014-03-31','10:15:00',4.53),('11288','2014-03-31','10:20:00',4.7),('11288','2014-03-31','10:25:00',4.84),('11288','2014-03-31','10:30:00',4.89),('11288','2014-03-31','10:35:00',4.97),('11288','2014-03-31','10:40:00',5.06),('11288','2014-03-31','10:45:00',5.17),('11288','2014-03-31','10:50:00',5.24),('11288','2014-03-31','10:55:00',5.32),('11288','2014-03-31','11:00:00',5.38),('11288','2014-03-31','11:05:00',5.45),('11288','2014-03-31','11:10:00',5.54),('11288','2014-03-31','11:15:00',5.54),('11288','2014-03-31','11:20:00',5.58),('11288','2014-03-31','11:25:00',5.67),('11288','2014-03-31','11:30:00',5.72),('11288','2014-03-31','11:35:00',5.74),('11288','2014-03-31','11:40:00',5.8),('11288','2014-03-31','11:45:00',5.87),('11288','2014-03-31','11:50:00',5.93),('11288','2014-03-31','11:55:00',5.93),('11288','2014-03-31','12:00:00',6.01),('11288','2014-03-31','12:05:00',6.11),('11288','2014-03-31','12:10:00',6.21),('11288','2014-03-31','12:15:00',6.24),('11288','2014-03-31','12:20:00',6.22),('11288','2014-03-31','12:25:00',6.31),('11288','2014-03-31','12:30:00',6.35),('11288','2014-03-31','12:35:00',6.37),('11288','2014-03-31','12:40:00',6.38),('11288','2014-03-31','12:45:00',6.35),('11288','2014-03-31','12:50:00',6.35),('11288','2014-03-31','12:55:00',6.35),('11288','2014-03-31','13:00:00',6.38),('11288','2014-03-31','13:05:00',6.42),('11288','2014-03-31','13:10:00',6.43),('11288','2014-03-31','13:15:00',6.44),('11288','2014-03-31','13:20:00',6.43),('11288','2014-03-31','13:25:00',6.44),('11288','2014-03-31','13:30:00',6.44),('11288','2014-03-31','13:35:00',6.41),('11288','2014-03-31','13:40:00',6.42),('11288','2014-03-31','13:45:00',6.4),('11288','2014-03-31','13:50:00',6.38),('11288','2014-03-31','13:55:00',6.37),('11288','2014-03-31','14:00:00',6.33),('11288','2014-03-31','14:05:00',6.3),('11288','2014-03-31','14:10:00',6.3),('11288','2014-03-31','14:15:00',6.3),('11288','2014-03-31','14:20:00',6.23),('11288','2014-03-31','14:25:00',6.17),('11288','2014-03-31','14:30:00',6.14),('11288','2014-03-31','14:35:00',6.12),('11288','2014-03-31','14:40:00',6.1),('11288','2014-03-31','14:45:00',6.06),('11288','2014-03-31','14:50:00',6),('11288','2014-03-31','14:55:00',5.9),('11288','2014-03-31','15:00:00',5.87),('11288','2014-03-31','15:05:00',5.8),('11288','2014-03-31','15:10:00',5.74),('11288','2014-03-31','15:15:00',5.69),('11288','2014-03-31','15:20:00',5.64),('11288','2014-03-31','15:25:00',5.54),('11288','2014-03-31','15:30:00',5.46),('11288','2014-03-31','15:35:00',5.35),('11288','2014-03-31','15:40:00',5.25),('11288','2014-03-31','15:45:00',5.18),('11288','2014-03-31','15:50:00',5.02),('11288','2014-03-31','15:55:00',4.89),('11288','2014-03-31','16:00:00',4.79),('11288','2014-03-31','16:05:00',4.67),('11288','2014-03-31','16:10:00',4.53),('11288','2014-03-31','16:15:00',4.41),('11288','2014-03-31','16:20:00',4.31),('11288','2014-03-31','16:25:00',4.17),('11288','2014-03-31','16:30:00',4.05),('11288','2014-03-31','16:35:00',3.9),('11288','2014-03-31','16:40:00',3.8),('11288','2014-03-31','16:45:00',3.67),('11288','2014-03-31','16:50:00',3.52),('11288','2014-03-31','16:55:00',3.37),('11288','2014-03-31','17:00:00',3.2),('11288','2014-03-31','17:05:00',3.09),('11288','2014-03-31','17:10:00',2.94),('11288','2014-03-31','17:15:00',2.79),('11288','2014-03-31','17:20:00',2.63),('11288','2014-03-31','17:25:00',2.49),('11288','2014-03-31','17:30:00',2.35),('11288','2014-03-31','17:35:00',2.18),('11288','2014-03-31','17:40:00',2.08),('11288','2014-03-31','17:45:00',1.94),('11288','2014-03-31','17:50:00',1.8),('11288','2014-03-31','17:55:00',1.66),('11288','2014-03-31','18:00:00',1.53),('11288','2014-03-31','18:05:00',1.38),('11288','2014-03-31','18:10:00',1.25),('11288','2014-03-31','18:15:00',1.14),('11288','2014-03-31','18:20:00',1),('11288','2013-05-11','07:25:00',1.12),('11288','2013-05-11','07:30:00',1.28),('11288','2013-05-11','07:40:00',1.41),('11288','2013-05-11','07:45:00',1.7),('11288','2013-05-11','07:50:00',1.98),('11288','2013-05-11','07:55:00',2.24),('11288','2013-05-11','08:00:00',2.22),('11288','2013-05-11','08:05:00',1.98),('11288','2013-05-11','08:10:00',1.82),('11288','2013-05-11','08:15:00',2.24),('11288','2013-05-11','08:20:00',2.5),('11288','2013-05-11','08:25:00',1.47),('11288','2013-05-11','08:30:00',1.66),('11288','2013-05-11','08:35:00',1.57),('11288','2013-05-11','08:45:00',1.22),('11288','2013-05-11','08:50:00',1.57),('11288','2013-05-11','08:55:00',1.7),('11288','2013-05-11','09:00:00',1.75),('11288','2013-05-11','09:05:00',2.47),('11288','2013-05-11','09:10:00',2.24),('11288','2013-05-11','09:15:00',2.74),('11288','2013-05-11','09:20:00',3.53),('11288','2013-05-11','09:25:00',3.24),('11288','2013-05-11','09:30:00',5.51),('11288','2013-05-11','09:35:00',3.15),('11288','2013-05-11','09:40:00',2.46),('11288','2013-05-11','09:45:00',2.46),('11288','2013-05-11','09:50:00',2.46),('11288','2013-05-11','09:55:00',5.5),('11288','2013-05-11','10:00:00',4.34),('11288','2013-05-11','10:05:00',1.95),('11288','2013-05-11','10:10:00',1.41),('11288','2013-05-11','10:15:00',1.55),('11288','2013-05-11','10:20:00',1.87),('11288','2013-05-11','10:25:00',1.8),('11288','2013-05-11','10:30:00',2.56),('11288','2013-05-11','10:35:00',2.06),('11288','2013-05-11','10:40:00',1.57),('11288','2013-05-11','10:45:00',1.89),('11288','2013-05-11','10:50:00',2.85),('11288','2013-05-11','10:55:00',7.47),('11288','2013-05-11','11:00:00',7.15),('11288','2013-05-11','11:05:00',2.93),('11288','2013-05-11','11:10:00',1.99),('11288','2013-05-11','11:15:00',1.52),('11288','2013-05-11','11:20:00',1.52),('11288','2013-05-11','11:25:00',2.04),('11288','2013-05-11','11:30:00',6.07),('11288','2013-05-11','11:35:00',5.01),('11288','2013-05-11','11:40:00',6.1),('11288','2013-05-11','11:45:00',6.31),('11288','2013-05-11','11:50:00',2.36),('11288','2013-05-11','11:55:00',1.95),('11288','2013-05-11','12:00:00',3.25),('11288','2013-05-11','12:05:00',3.64),('11288','2013-05-11','12:10:00',2.42),('11288','2013-05-11','12:15:00',2.38),('11288','2013-05-11','12:20:00',5.93),('11288','2013-05-11','12:25:00',8.59),('11288','2013-05-11','12:30:00',3.69),('11288','2013-05-11','12:35:00',3.34),('11288','2013-05-11','12:40:00',3.09),('11288','2013-05-11','12:45:00',2.99),('11288','2013-05-11','12:50:00',2.93),('11288','2013-05-11','12:55:00',2.77),('11288','2013-05-11','13:00:00',3.55),('11288','2013-05-11','13:05:00',2.64),('11288','2013-05-11','13:10:00',1.71),('11288','2013-05-11','13:15:00',1.13),('11288','2013-05-11','13:20:00',1.57),('11288','2013-05-11','13:25:00',1.9),('11288','2013-05-11','13:30:00',1.93),('11288','2013-05-11','13:35:00',1.94),('11288','2013-05-11','13:40:00',1.22),('11288','2013-05-11','13:45:00',1.09),('11288','2013-05-11','13:50:00',1.73),('11288','2013-05-11','13:55:00',2.1),('11288','2013-05-11','14:00:00',3.52),('11288','2013-05-11','14:05:00',6.41),('11288','2013-05-11','14:10:00',4.56),('11288','2013-05-11','14:15:00',5.91),('11288','2013-05-11','14:20:00',7.46),('11288','2013-05-11','14:25:00',6),('11288','2013-05-11','14:30:00',3.05),('11288','2013-05-11','14:35:00',5.89),('11288','2013-05-11','14:40:00',6.53),('11288','2013-05-11','14:45:00',6.87),('11288','2013-05-11','14:50:00',7.5),('11288','2013-05-11','14:55:00',6.94),('11288','2013-05-11','15:00:00',7.02),('11288','2013-05-11','15:05:00',6.61),('11288','2013-05-11','15:10:00',6.61),('11288','2013-05-11','15:15:00',6.38),('11288','2013-05-11','15:20:00',6.16),('11288','2013-05-11','15:25:00',6.71),('11288','2013-05-11','15:30:00',5.92),('11288','2013-05-11','15:35:00',6.19),('11288','2013-05-11','15:40:00',6.49),('11288','2013-05-11','15:45:00',5.76),('11288','2013-05-11','15:50:00',6.28),('11288','2013-05-11','15:55:00',5.09),('11288','2013-05-11','16:00:00',4.47),('11288','2013-05-11','16:05:00',5.49),('11288','2013-05-11','16:10:00',4.11),('11288','2013-05-11','16:15:00',5.98),('11288','2013-05-11','16:20:00',5.41),('11288','2013-05-11','16:25:00',5.45),('11288','2013-05-11','16:30:00',5.09),('11288','2013-05-11','16:35:00',3.17),('11288','2013-05-11','16:40:00',5.01),('11288','2013-05-11','16:45:00',4.87),('11288','2013-05-11','16:50:00',4.05),('11288','2013-05-11','16:55:00',4.78),('11288','2013-05-11','17:00:00',4.55),('11288','2013-05-11','17:05:00',2.61),('11288','2013-05-11','17:10:00',3.63),('11288','2013-05-11','17:15:00',2.22),('11288','2013-05-11','17:20:00',2.65),('11288','2013-05-11','17:25:00',2.1),('11288','2013-05-11','17:30:00',3.24),('11288','2013-05-11','17:35:00',2.72),('11288','2013-05-11','17:40:00',3.07),('11288','2013-05-11','17:45:00',2.24),('11288','2013-05-11','17:50:00',1.5),('11288','2013-05-11','17:55:00',1.75),('11288','2013-05-11','18:00:00',1.76),('11288','2013-05-11','18:05:00',2.67),('11288','2013-05-11','18:10:00',3),('11288','2013-05-11','18:15:00',1.71),('11288','2013-05-11','18:20:00',1.81),('11288','2013-05-11','18:25:00',1.87),('11288','2013-05-11','18:30:00',2.01),('11288','2013-05-11','18:35:00',1.07),('11288','2013-05-11','18:40:00',1.52),('11288','2013-05-11','18:45:00',1.06),('11288','2013-05-11','19:00:00',1.04),('11288','2013-05-10','07:30:00',1.08),('11288','2013-05-10','07:35:00',1.35),('11288','2013-05-10','07:40:00',1.72),('11288','2013-05-10','07:45:00',1.42),('11288','2013-05-10','07:50:00',1.35),('11288','2013-05-10','07:55:00',1.91),('11288','2013-05-10','08:00:00',2.24),('11288','2013-05-10','08:05:00',2.63),('11288','2013-05-10','08:10:00',3.21),('11288','2013-05-10','08:15:00',3.27),('11288','2013-05-10','08:20:00',3.12),('11288','2013-05-10','08:25:00',3.15),('11288','2013-05-10','08:30:00',3.1),('11288','2013-05-10','08:35:00',3.14),('11288','2013-05-10','08:40:00',1.32),('11288','2013-05-10','08:45:00',1.03),('11288','2013-05-10','08:55:00',1.12),('11288','2013-05-10','09:00:00',2.41),('11288','2013-05-10','09:05:00',3.61),('11288','2013-05-10','09:10:00',4.31),('11288','2013-05-10','09:15:00',4.4),('11288','2013-05-10','09:20:00',4.16),('11288','2013-05-10','09:25:00',4.11),('11288','2013-05-10','09:30:00',4.18),('11288','2013-05-10','09:35:00',4.68),('11288','2013-05-10','09:40:00',4.48),('11288','2013-05-10','09:45:00',4.48),('11288','2013-05-10','09:50:00',4.46),('11288','2013-05-10','09:55:00',2.46),('11288','2013-05-10','10:00:00',2.4),('11288','2013-05-10','10:05:00',2.45),('11288','2013-05-10','10:10:00',2.93),('11288','2013-05-10','10:15:00',5.33),('11288','2013-05-10','10:20:00',2.09),('11288','2013-05-10','10:25:00',4.43),('11288','2013-05-10','10:30:00',6.49),('11288','2013-05-10','10:35:00',6.49),('11288','2013-05-10','10:40:00',6.7),('11288','2013-05-10','10:45:00',6.71),('11288','2013-05-10','10:50:00',6.46),('11288','2013-05-10','10:55:00',6.59),('11288','2013-05-10','11:00:00',6.63),('11288','2013-05-10','11:05:00',6.59),('11288','2013-05-10','11:10:00',6.5),('11288','2013-05-10','11:15:00',6.8),('11288','2013-05-10','11:20:00',7.23),('11288','2013-05-10','11:25:00',5.66),('11288','2013-05-10','11:30:00',6.52),('11288','2013-05-10','11:35:00',5.59),('11288','2013-05-10','11:40:00',5.62),('11288','2013-05-10','11:45:00',4.8),('11288','2013-05-10','11:50:00',5.97),('11288','2013-05-10','11:55:00',6.94),('11288','2013-05-10','12:00:00',4.77),('11288','2013-05-10','12:05:00',3.95),('11288','2013-05-10','12:10:00',4.06),('11288','2013-05-10','12:15:00',5.06),('11288','2013-05-10','12:20:00',4.66),('11288','2013-05-10','12:25:00',4.18),('11288','2013-05-10','12:30:00',3.66),('11288','2013-05-10','12:35:00',3.47),('11288','2013-05-10','12:40:00',6.6),('11288','2013-05-10','12:45:00',7.95),('11288','2013-05-10','12:50:00',5.01),('11288','2013-05-10','12:55:00',4.75),('11288','2013-05-10','13:00:00',6.24),('11288','2013-05-10','13:05:00',8.12),('11288','2013-05-10','13:10:00',9.29),('11288','2013-05-10','13:15:00',7.19),('11288','2013-05-10','13:20:00',5.62),('11288','2013-05-10','13:25:00',4.7),('11288','2013-05-10','13:30:00',5.88),('11288','2013-05-10','13:35:00',6.24),('11288','2013-05-10','13:40:00',6.49),('11288','2013-05-10','13:45:00',6.05),('11288','2013-05-10','13:50:00',3.79),('11288','2013-05-10','13:55:00',3.66),('11288','2013-05-10','14:00:00',3.42),('11288','2013-05-10','14:05:00',3.75),('11288','2013-05-10','14:10:00',4.52),('11288','2013-05-10','14:15:00',4.69),('11288','2013-05-10','14:20:00',4.49),('11288','2013-05-10','14:25:00',4.73),('11288','2013-05-10','14:30:00',4.49),('11288','2013-05-10','14:35:00',5.4),('11288','2013-05-10','14:40:00',4.9),('11288','2013-05-10','14:45:00',3.26),('11288','2013-05-10','14:50:00',2.54),('11288','2013-05-10','14:55:00',2.25),('11288','2013-05-10','15:00:00',2.19),('11288','2013-05-10','15:05:00',2.52),('11288','2013-05-10','15:10:00',3.51),('11288','2013-05-10','15:15:00',5.33),('11288','2013-05-10','15:20:00',4.21),('11288','2013-05-10','15:25:00',3.47),('11288','2013-05-10','15:30:00',3.4),('11288','2013-05-10','15:35:00',3.51),('11288','2013-05-10','15:40:00',3.63),('11288','2013-05-10','15:45:00',3.42),('11288','2013-05-10','15:50:00',3.11),('11288','2013-05-10','15:55:00',2.98),('11288','2013-05-10','16:00:00',2.94),('11288','2013-05-10','16:05:00',2.86),('11288','2013-05-10','16:10:00',2.75),('11288','2013-05-10','16:15:00',2.53),('11288','2013-05-10','16:20:00',2.34),('11288','2013-05-10','16:25:00',2.41),('11288','2013-05-10','16:30:00',2.6),('11288','2013-05-10','16:35:00',2.72),('11288','2013-05-10','16:40:00',2.56),('11288','2013-05-10','16:45:00',2.51),('11288','2013-05-10','16:50:00',2.38),('11288','2013-05-10','16:55:00',1.93),('11288','2013-05-10','17:00:00',1.63),('11288','2013-05-10','17:05:00',1.76),('11288','2013-05-10','17:10:00',2.32),('11288','2013-05-10','17:15:00',2.78),('11288','2013-05-10','17:20:00',3.85),('11288','2013-05-10','17:25:00',3.8),('11288','2013-05-10','17:30:00',3.46),('11288','2013-05-10','17:35:00',3.66),('11288','2013-05-10','17:40:00',2.43),('11288','2013-05-10','17:45:00',2.43),('11288','2013-05-10','17:50:00',1.9),('11288','2013-05-10','17:55:00',1.73),('11288','2013-05-10','18:00:00',1.66),('11288','2013-05-10','18:05:00',1.64),('11288','2013-05-10','18:10:00',1.47),('11288','2013-05-10','18:15:00',1.36),('11288','2013-05-10','18:20:00',1.36),('11288','2013-05-10','18:25:00',1.15),('11288','2013-05-09','07:25:00',1.09),('11288','2013-05-09','07:30:00',1.22),('11288','2013-05-09','07:35:00',1.32),('11288','2013-05-09','07:40:00',1.46),('11288','2013-05-09','07:45:00',1.56),('11288','2013-05-09','07:50:00',1.6),('11288','2013-05-09','07:55:00',1.81),('11288','2013-05-09','08:00:00',1.88),('11288','2013-05-09','08:05:00',1.92),('11288','2013-05-09','08:10:00',2.24),('11288','2013-05-09','08:15:00',2.17),('11288','2013-05-09','08:20:00',2.34),('11288','2013-05-09','08:25:00',2.75),('11288','2013-05-09','08:30:00',2.77),('11288','2013-05-09','08:35:00',2.92),('11288','2013-05-09','08:40:00',3.12),('11288','2013-05-09','08:45:00',3.29),('11288','2013-05-09','08:50:00',3.32),('11288','2013-05-09','08:55:00',3.55),('11288','2013-05-09','09:00:00',3.5),('11288','2013-05-09','09:05:00',3.81),('11288','2013-05-09','09:10:00',4.08),('11288','2013-05-09','09:15:00',4.14),('11288','2013-05-09','09:20:00',4.14),('11288','2013-05-09','09:25:00',4.45),('11288','2013-05-09','09:30:00',4.63),('11288','2013-05-09','09:35:00',4.65),('11288','2013-05-09','09:40:00',4.93),('11288','2013-05-09','09:45:00',4.86),('11288','2013-05-09','09:50:00',4.94),('11288','2013-05-09','09:55:00',5.27),('11288','2013-05-09','10:00:00',5.42),('11288','2013-05-09','10:05:00',5.56),('11288','2013-05-09','10:10:00',5.59),('11288','2013-05-09','10:15:00',5.72),('11288','2013-05-09','10:20:00',5.78),('11288','2013-05-09','10:25:00',5.8),('11288','2013-05-09','10:30:00',5.92),('11288','2013-05-09','10:35:00',5.99),('11288','2013-05-09','10:40:00',6.07),('11288','2013-05-09','10:45:00',6.16),('11288','2013-05-09','10:50:00',6.19),('11288','2013-05-09','10:55:00',6.33),('11288','2013-05-09','11:00:00',6.44),('11288','2013-05-09','11:05:00',6.51),('11288','2013-05-09','11:10:00',6.49),('11288','2013-05-09','11:15:00',6.56),('11288','2013-05-09','11:20:00',6.61),('11288','2013-05-09','11:25:00',6.64),('11288','2013-05-09','11:30:00',6.67),('11288','2013-05-09','11:35:00',6.68),('11288','2013-05-09','11:40:00',6.69),('11288','2013-05-09','11:45:00',6.79),('11288','2013-05-09','11:50:00',6.85),('11288','2013-05-09','11:55:00',6.9),('11288','2013-05-09','12:00:00',6.95),('11288','2013-05-09','12:05:00',6.99),('11288','2013-05-09','12:10:00',6.94),('11288','2013-05-09','12:15:00',7.12),('11288','2013-05-09','12:20:00',7.09),('11288','2013-05-09','12:25:00',7.14),('11288','2013-05-09','12:30:00',7.13),('11288','2013-05-09','12:35:00',7.18),('11288','2013-05-09','12:40:00',7.14),('11288','2013-05-09','12:45:00',7.21),('11288','2013-05-09','12:50:00',7.24),('11288','2013-05-09','12:55:00',7.21),('11288','2013-05-09','13:00:00',7.15),('11288','2013-05-09','13:05:00',7.19),('11288','2013-05-09','13:10:00',7.15),('11288','2013-05-09','13:15:00',7.15),('11288','2013-05-09','13:20:00',7.12),('11288','2013-05-09','13:25:00',7.05),('11288','2013-05-09','13:30:00',7.06),('11288','2013-05-09','13:35:00',7.09),('11288','2013-05-09','13:40:00',7.15),('11288','2013-05-09','13:45:00',7.22),('11288','2013-05-09','13:50:00',7.17),('11288','2013-05-09','13:55:00',7.25),('11288','2013-05-09','14:00:00',7.32),('11288','2013-05-09','14:05:00',5.92),('11288','2013-05-09','14:10:00',6.81),('11288','2013-05-09','14:15:00',6.7),('11288','2013-05-09','14:20:00',7.33),('11288','2013-05-09','14:25:00',5.68),('11288','2013-05-09','14:30:00',6.86),('11288','2013-05-09','14:35:00',6.8),('11288','2013-05-09','14:40:00',6.66),('11288','2013-05-09','14:45:00',6.7),('11288','2013-05-09','14:50:00',6.56),('11288','2013-05-09','14:55:00',6.67),('11288','2013-05-09','15:00:00',6.55),('11288','2013-05-09','15:05:00',6.51),('11288','2013-05-09','15:10:00',6.42),('11288','2013-05-09','15:15:00',6.38),('11288','2013-05-09','15:20:00',6.32),('11288','2013-05-09','15:25:00',6.23),('11288','2013-05-09','15:30:00',6.14),('11288','2013-05-09','15:35:00',6.08),('11288','2013-05-09','15:40:00',6),('11288','2013-05-09','15:45:00',5.95),('11288','2013-05-09','15:50:00',5.85),('11288','2013-05-09','15:55:00',5.73),('11288','2013-05-09','16:00:00',5.65),('11288','2013-05-09','16:05:00',5.54),('11288','2013-05-09','16:10:00',5.44),('11288','2013-05-09','16:15:00',5.29),('11288','2013-05-09','16:20:00',5.23),('11288','2013-05-09','16:25:00',5.08),('11288','2013-05-09','16:30:00',5),('11288','2013-05-09','16:35:00',4.85),('11288','2013-05-09','16:40:00',4.67),('11288','2013-05-09','16:45:00',4.51),('11288','2013-05-09','16:50:00',4.39),('11288','2013-05-09','16:55:00',4.27),('11288','2013-05-09','17:00:00',4.17),('11288','2013-05-09','17:05:00',3.97),('11288','2013-05-09','17:10:00',3.79),('11288','2013-05-09','17:15:00',3.73),('11288','2013-05-09','17:20:00',3.59),('11288','2013-05-09','17:25:00',3.46),('11288','2013-05-09','17:30:00',3.31),('11288','2013-05-09','17:35:00',3.09),('11288','2013-05-09','17:40:00',3.01),('11288','2013-05-09','17:45:00',2.86),('11288','2013-05-09','17:50:00',2.7),('11288','2013-05-09','17:55:00',2.57),('11288','2013-05-09','18:00:00',2.51),('11288','2013-05-09','18:05:00',2.43),('11288','2013-05-09','18:10:00',2.27),('11288','2013-05-09','18:15:00',2.14),('11288','2013-05-09','18:20:00',2.01),('11288','2013-05-09','18:25:00',1.86),('11288','2013-05-09','18:30:00',1.73),('11288','2013-05-09','18:35:00',1.58),('11288','2013-05-09','18:40:00',1.44),('11288','2013-05-09','18:45:00',1.31),('11288','2013-05-09','18:50:00',1.16),('11288','2013-05-09','18:55:00',1.01),('11288','2013-05-08','08:00:00',1.32),('11288','2013-05-08','08:05:00',2.24),('11288','2013-05-08','08:10:00',2.38),('11288','2013-05-08','08:15:00',2.34),('11288','2013-05-08','08:20:00',2.27),('11288','2013-05-08','08:25:00',2.63),('11288','2013-05-08','08:30:00',2.72),('11288','2013-05-08','08:35:00',3.02),('11288','2013-05-08','08:40:00',3.22),('11288','2013-05-08','08:45:00',3.01),('11288','2013-05-08','08:50:00',3.37),('11288','2013-05-08','08:55:00',2.16),('11288','2013-05-08','09:00:00',1.65),('11288','2013-05-08','09:05:00',1.31),('11288','2013-05-08','09:10:00',1.11),('11288','2013-05-08','09:30:00',1.45),('11288','2013-05-08','09:35:00',5.5),('11288','2013-05-08','09:40:00',6.2),('11288','2013-05-08','09:45:00',5.93),('11288','2013-05-08','09:50:00',4.59),('11288','2013-05-08','09:55:00',2.22),('11288','2013-05-08','10:00:00',3.71),('11288','2013-05-08','10:05:00',5.23),('11288','2013-05-08','10:10:00',2.56),('11288','2013-05-08','10:15:00',1.69),('11288','2013-05-08','10:20:00',1.86),('11288','2013-05-08','10:25:00',2),('11288','2013-05-08','10:30:00',3.13),('11288','2013-05-08','10:35:00',1.83),('11288','2013-05-08','10:40:00',2.08),('11288','2013-05-08','10:45:00',1.65),('11288','2013-05-08','10:50:00',3.16),('11288','2013-05-08','10:55:00',5.89),('11288','2013-05-08','11:00:00',2.69),('11288','2013-05-08','11:05:00',6.05),('11288','2013-05-08','11:10:00',5.64),('11288','2013-05-08','11:15:00',5.47),('11288','2013-05-08','11:20:00',5),('11288','2013-05-08','11:25:00',7.3),('11288','2013-05-08','11:30:00',7.41),('11288','2013-05-08','11:35:00',7.6),('11288','2013-05-08','11:40:00',5.71),('11288','2013-05-08','11:45:00',4.88),('11288','2013-05-08','11:50:00',3.95),('11288','2013-05-08','11:55:00',6.59),('11288','2013-05-08','12:00:00',2.29),('11288','2013-05-08','12:05:00',1.55),('11288','2013-05-08','12:10:00',1.44),('11288','2013-05-08','12:15:00',1.93),('11288','2013-05-08','12:20:00',4.02),('11288','2013-05-08','12:25:00',4.79),('11288','2013-05-08','12:30:00',2.38),('11288','2013-05-08','12:35:00',4.73),('11288','2013-05-08','12:40:00',3.37),('11288','2013-05-08','12:45:00',2.13),('11288','2013-05-08','12:50:00',4.78),('11288','2013-05-08','12:55:00',2.99),('11288','2013-05-08','13:00:00',2.45),('11288','2013-05-08','13:05:00',2.45),('11288','2013-05-08','13:10:00',8.58),('11288','2013-05-08','13:15:00',4.96),('11288','2013-05-08','13:20:00',2.08),('11288','2013-05-08','13:25:00',5.31),('11288','2013-05-08','13:30:00',1.94),('11288','2013-05-08','13:35:00',1.83),('11288','2013-05-08','13:40:00',4.72),('11288','2013-05-08','13:45:00',8.62),('11288','2013-05-08','13:50:00',8.66),('11288','2013-05-08','13:55:00',7.56),('11288','2013-05-08','14:00:00',8.1),('11288','2013-05-08','14:05:00',4.01),('11288','2013-05-08','14:10:00',2.67),('11288','2013-05-08','14:15:00',4.22),('11288','2013-05-08','14:20:00',2.81),('11288','2013-05-08','14:25:00',5.15),('11288','2013-05-08','14:30:00',5.83),('11288','2013-05-08','14:35:00',5.13),('11288','2013-05-08','14:40:00',3.36),('11288','2013-05-08','14:45:00',3.85),('11288','2013-05-08','14:50:00',7.43),('11288','2013-05-08','14:55:00',6.92),('11288','2013-05-08','15:00:00',6.86),('11288','2013-05-08','15:05:00',6.75),('11288','2013-05-08','15:10:00',6.64),('11288','2013-05-08','15:15:00',6.53),('11288','2013-05-08','15:20:00',6.45),('11288','2013-05-08','15:25:00',6.42),('11288','2013-05-08','15:30:00',6.28),('11288','2013-05-08','15:35:00',6.15),('11288','2013-05-08','15:40:00',6.04),('11288','2013-05-08','15:45:00',5.93),('11288','2013-05-08','15:50:00',5.91),('11288','2013-05-08','15:55:00',5.87),('11288','2013-05-08','16:00:00',5.84),('11288','2013-05-08','16:05:00',5.63),('11288','2013-05-08','16:10:00',5.11),('11288','2013-05-08','16:15:00',5.38),('11288','2013-05-08','16:20:00',5.29),('11288','2013-05-08','16:25:00',5.02),('11288','2013-05-08','16:30:00',5.18),('11288','2013-05-08','16:35:00',5.07),('11288','2013-05-08','16:40:00',2.59),('11288','2013-05-08','16:45:00',4.57),('11288','2013-05-08','16:50:00',2.85),('11288','2013-05-08','16:55:00',2.99),('11288','2013-05-08','17:00:00',4.45),('11288','2013-05-08','17:05:00',4.02),('11288','2013-05-08','17:10:00',4.26),('11288','2013-05-08','17:15:00',3.92),('11288','2013-05-08','17:20:00',3.53),('11288','2013-05-08','17:25:00',3.86),('11288','2013-05-08','17:30:00',3.93),('11288','2013-05-08','17:35:00',3.71),('11288','2013-05-08','17:40:00',3.63),('11288','2013-05-08','17:45:00',3.7),('11288','2013-05-08','17:50:00',3.7),('11288','2013-05-08','17:55:00',3.53),('11288','2013-05-08','18:00:00',2.13),('11288','2013-05-08','18:05:00',1.47),('11288','2013-05-08','18:10:00',1.56),('11288','2013-05-08','18:15:00',2.7),('11288','2013-05-08','18:20:00',2.59),('11288','2013-05-08','18:25:00',2.38),('11288','2013-05-08','18:30:00',2.04),('11288','2013-05-08','18:35:00',1.78),('11288','2013-05-07','07:30:00',1.18),('11288','2013-05-07','07:35:00',1.31),('11288','2013-05-07','07:40:00',1.44),('11288','2013-05-07','07:45:00',1.53),('11288','2013-05-07','07:50:00',1.53),('11288','2013-05-07','07:55:00',1.76),('11288','2013-05-07','08:00:00',1.85),('11288','2013-05-07','08:05:00',1.91),('11288','2013-05-07','08:10:00',2.07),('11288','2013-05-07','08:15:00',2.32),('11288','2013-05-07','08:20:00',2.27),('11288','2013-05-07','08:25:00',2.44),('11288','2013-05-07','08:30:00',2.78),('11288','2013-05-07','08:35:00',2.91),('11288','2013-05-07','08:40:00',3.02),('11288','2013-05-07','08:45:00',3.25),('11288','2013-05-07','08:50:00',2.75),('11288','2013-05-07','08:55:00',2.38),('11288','2013-05-07','09:00:00',3.91),('11288','2013-05-07','09:05:00',1.69),('11288','2013-05-07','09:10:00',4.62),('11288','2013-05-07','09:15:00',4.96),('11288','2013-05-07','09:20:00',2.18),('11288','2013-05-07','09:25:00',1.36),('11288','2013-05-07','09:30:00',2.68),('11288','2013-05-07','09:35:00',5.29),('11288','2013-05-07','09:40:00',2.43),('11288','2013-05-07','09:45:00',2.81),('11288','2013-05-07','09:50:00',3.29),('11288','2013-05-07','09:55:00',1.72),('11288','2013-05-07','10:00:00',1.46),('11288','2013-05-07','10:05:00',1.64),('11288','2013-05-07','10:10:00',1.07),('11288','2013-05-07','10:30:00',1),('11288','2013-05-07','10:35:00',1.14),('11288','2013-05-07','10:40:00',1.39),('11288','2013-05-07','10:45:00',1.36),('11288','2013-05-07','10:50:00',1.82),('11288','2013-05-07','10:55:00',2.2),('11288','2013-05-07','11:00:00',2.4),('11288','2013-05-07','11:05:00',2.49),('11288','2013-05-07','11:10:00',5.68),('11288','2013-05-07','11:15:00',3.43),('11288','2013-05-07','11:20:00',5.62),('11288','2013-05-07','11:25:00',1.51),('11288','2013-05-07','11:45:00',1.04),('11288','2013-05-07','11:50:00',1.26),('11288','2013-05-07','11:55:00',1.7),('11288','2013-05-07','12:00:00',3.62),('11288','2013-05-07','12:05:00',8.29),('11288','2013-05-07','12:10:00',4.37),('11288','2013-05-07','12:15:00',5.62),('11288','2013-05-07','12:20:00',7.89),('11288','2013-05-07','12:25:00',2.07),('11288','2013-05-07','12:30:00',1.64),('11288','2013-05-07','12:35:00',1.36),('11288','2013-05-07','12:40:00',1.62),('11288','2013-05-07','12:45:00',1.29),('11288','2013-05-07','12:50:00',1.35),('11288','2013-05-07','12:55:00',1.28),('11288','2013-05-07','13:00:00',1.15),('11288','2013-05-07','13:05:00',1.92),('11288','2013-05-07','13:10:00',2.51),('11288','2013-05-07','13:15:00',2.75),('11288','2013-05-07','13:20:00',3.17),('11288','2013-05-07','13:25:00',6.88),('11288','2013-05-07','13:30:00',6.63),('11288','2013-05-07','13:35:00',8.93),('11288','2013-05-07','13:40:00',8.69),('11288','2013-05-07','13:45:00',8.11),('11288','2013-05-07','13:50:00',6.54),('11288','2013-05-07','13:55:00',4.52),('11288','2013-05-07','14:00:00',7.81),('11288','2013-05-07','14:05:00',8.15),('11288','2013-05-07','14:10:00',7.68),('11288','2013-05-07','14:15:00',7.78),('11288','2013-05-07','14:20:00',4.46),('11288','2013-05-07','14:25:00',5.25),('11288','2013-05-07','14:30:00',3.38),('11288','2013-05-07','14:35:00',7.57),('11288','2013-05-07','14:40:00',6.35),('11288','2013-05-07','14:45:00',5.47),('11288','2013-05-07','14:50:00',7.06),('11288','2013-05-07','14:55:00',6.08),('11288','2013-05-07','15:00:00',6.73),('11288','2013-05-07','15:05:00',6.69),('11288','2013-05-07','15:10:00',6.61),('11288','2013-05-07','15:15:00',7.06),('11288','2013-05-07','15:20:00',7.31),('11288','2013-05-07','15:25:00',5.79),('11288','2013-05-07','15:30:00',4.65),('11288','2013-05-07','15:35:00',5.28),('11288','2013-05-07','15:40:00',6.06),('11288','2013-05-07','15:45:00',5.37),('11288','2013-05-07','15:50:00',3.2),('11288','2013-05-07','15:55:00',4.38),('11288','2013-05-07','16:00:00',6.68),('11288','2013-05-07','16:05:00',2.48),('11288','2013-05-07','16:10:00',3.62),('11288','2013-05-07','16:15:00',6.69),('11288','2013-05-07','16:20:00',6.76),('11288','2013-05-07','16:25:00',6.58),('11288','2013-05-07','16:30:00',6.14),('11288','2013-05-07','16:35:00',6.06),('11288','2013-05-07','16:40:00',5.93),('11288','2013-05-07','16:45:00',5.68),('11288','2013-05-07','16:50:00',5.12),('11288','2013-05-07','16:55:00',4.43),('11288','2013-05-07','17:00:00',5.17),('11288','2013-05-07','17:05:00',3.82),('11288','2013-05-07','17:10:00',2.28),('11288','2013-05-07','17:15:00',2.07),('11288','2013-05-07','17:20:00',2.19),('11288','2013-05-07','17:25:00',2.13),('11288','2013-05-07','17:30:00',1.88),('11288','2013-05-07','17:35:00',1.8),('11288','2013-05-07','17:40:00',1.68),('11288','2013-05-07','17:45:00',1.49),('11288','2013-05-07','17:50:00',1.26),('11288','2013-05-07','18:40:00',1.39),('11288','2013-05-07','18:45:00',1.38),('11288','2013-05-07','18:50:00',1.29),('11288','2013-05-06','08:10:00',1.07),('11288','2013-05-06','08:15:00',1.35),('11288','2013-05-06','08:20:00',1.51),('11288','2013-05-06','08:25:00',2.19),('11288','2013-05-06','08:30:00',2.28),('11288','2013-05-06','08:35:00',2.11),('11288','2013-05-06','08:40:00',1.92),('11288','2013-05-06','08:45:00',1.59),('11288','2013-05-06','08:50:00',2.71),('11288','2013-05-06','08:55:00',4.12),('11288','2013-05-06','09:00:00',3.99),('11288','2013-05-06','09:05:00',2.72),('11288','2013-05-06','09:10:00',2.72),('11288','2013-05-06','09:15:00',2.38),('11288','2013-05-06','09:20:00',2.91),('11288','2013-05-06','09:25:00',2.16),('11288','2013-05-06','09:30:00',1.73),('11288','2013-05-06','09:35:00',1.17),('11288','2013-05-06','09:50:00',1.5),('11288','2013-05-06','09:55:00',2.1),('11288','2013-05-06','10:00:00',3.34),('11288','2013-05-06','10:05:00',2.02),('11288','2013-05-06','10:10:00',1.9),('11288','2013-05-06','10:15:00',2.69),('11288','2013-05-06','10:20:00',4.31),('11288','2013-05-06','10:25:00',3.56),('11288','2013-05-06','10:30:00',3.55),('11288','2013-05-06','10:35:00',3.5),('11288','2013-05-06','10:40:00',3.35),('11288','2013-05-06','10:45:00',4.43),('11288','2013-05-06','10:50:00',3.59),('11288','2013-05-06','10:55:00',3.29),('11288','2013-05-06','11:00:00',3.16),('11288','2013-05-06','11:05:00',3.5),('11288','2013-05-06','11:10:00',3.48),('11288','2013-05-06','11:15:00',3.16),('11288','2013-05-06','11:20:00',3.63),('11288','2013-05-06','11:25:00',3.74),('11288','2013-05-06','11:30:00',2.02),('11288','2013-05-06','11:35:00',3.55),('11288','2013-05-06','11:40:00',3.75),('11288','2013-05-06','11:45:00',5.88),('11288','2013-05-06','11:50:00',3.81),('11288','2013-05-06','11:55:00',2.83),('11288','2013-05-06','12:00:00',3.13),('11288','2013-05-06','12:05:00',3.3),('11288','2013-05-06','12:10:00',3.91),('11288','2013-05-06','12:15:00',3.67),('11288','2013-05-06','12:20:00',4.37),('11288','2013-05-06','12:25:00',5.63),('11288','2013-05-06','12:30:00',6.84),('11288','2013-05-06','12:35:00',6.67),('11288','2013-05-06','12:40:00',2.85),('11288','2013-05-06','12:45:00',4.19),('11288','2013-05-06','12:50:00',6.26),('11288','2013-05-06','12:55:00',3.54),('11288','2013-05-06','13:00:00',3.72),('11288','2013-05-06','13:05:00',5.46),('11288','2013-05-06','13:10:00',6.94),('11288','2013-05-06','13:15:00',5.97),('11288','2013-05-06','13:20:00',5.88),('11288','2013-05-06','13:25:00',4.99),('11288','2013-05-06','13:30:00',5.24),('11288','2013-05-06','13:35:00',5.63),('11288','2013-05-06','13:40:00',6.42),('11288','2013-05-06','13:45:00',6.3),('11288','2013-05-06','13:50:00',7.76),('11288','2013-05-06','13:55:00',7.76),('11288','2013-05-06','14:00:00',8.01),('11288','2013-05-06','14:05:00',5.62),('11288','2013-05-06','14:10:00',5.66),('11288','2013-05-06','14:15:00',7.1),('11288','2013-05-06','14:20:00',7.43),('11288','2013-05-06','14:25:00',4.06),('11288','2013-05-06','14:30:00',7.86),('11288','2013-05-06','14:35:00',6.51),('11288','2013-05-06','14:40:00',6.37),('11288','2013-05-06','14:45:00',4.05),('11288','2013-05-06','14:50:00',5.86),('11288','2013-05-06','14:55:00',6.51),('11288','2013-05-06','15:00:00',3.43),('11288','2013-05-06','15:05:00',5.41),('11288','2013-05-06','15:10:00',3.11),('11288','2013-05-06','15:15:00',5.02),('11288','2013-05-06','15:20:00',4.05),('11288','2013-05-06','15:25:00',3.39),('11288','2013-05-06','15:30:00',5.31),('11288','2013-05-06','15:35:00',4.62),('11288','2013-05-06','15:40:00',2.36),('11288','2013-05-06','15:45:00',2.52),('11288','2013-05-06','15:50:00',4.28),('11288','2013-05-06','15:55:00',3.04),('11288','2013-05-06','16:00:00',2.89),('11288','2013-05-06','16:05:00',2.81),('11288','2013-05-06','16:10:00',2.41),('11288','2013-05-06','16:15:00',2.52),('11288','2013-05-06','16:20:00',4.13),('11288','2013-05-06','16:25:00',3.77),('11288','2013-05-06','16:30:00',4.33),('11288','2013-05-06','16:35:00',4.67),('11288','2013-05-06','16:40:00',4.35),('11288','2013-05-06','16:45:00',2.38),('11288','2013-05-06','16:50:00',5.09),('11288','2013-05-06','16:55:00',2.65),('11288','2013-05-06','17:00:00',1.18),('11288','2013-05-06','17:10:00',1.12),('11288','2013-05-06','17:15:00',2.78),('11288','2013-05-06','17:20:00',1.73),('11288','2013-05-06','17:25:00',1.29),('11288','2013-05-06','17:35:00',2.51),('11288','2013-05-06','17:40:00',2.26),('11288','2013-05-06','17:45:00',2.14),('11288','2013-05-06','17:50:00',1.74),('11288','2013-05-06','17:55:00',2.29),('11288','2013-05-06','18:00:00',2.03),('11288','2013-05-06','18:05:00',2.65),('11288','2013-05-06','18:10:00',1.02),('11288','2013-05-06','18:15:00',1.51),('11288','2013-05-06','18:20:00',2.48),('11288','2013-05-06','18:25:00',1.91),('11288','2013-05-06','18:30:00',1.66),('11288','2013-05-05','07:40:00',1.05),('11288','2013-05-05','07:45:00',1.42),('11288','2013-05-05','07:50:00',1.51),('11288','2013-05-05','07:55:00',1.57),('11288','2013-05-05','08:00:00',1.72),('11288','2013-05-05','08:05:00',1.91),('11288','2013-05-05','08:10:00',2.17),('11288','2013-05-05','08:15:00',2.33),('11288','2013-05-05','08:20:00',2.77),('11288','2013-05-05','08:25:00',3.47),('11288','2013-05-05','08:30:00',3.67),('11288','2013-05-05','08:35:00',3.57),('11288','2013-05-05','08:40:00',3.42),('11288','2013-05-05','08:45:00',2.73),('11288','2013-05-05','08:50:00',2.28),('11288','2013-05-05','08:55:00',2.38),('11288','2013-05-05','09:00:00',2.39),('11288','2013-05-05','09:05:00',2.39),('11288','2013-05-05','09:10:00',2.37),('11288','2013-05-05','09:15:00',2.22),('11288','2013-05-05','09:20:00',2.13),('11288','2013-05-05','09:25:00',2.49),('11288','2013-05-05','09:30:00',2.84),('11288','2013-05-05','09:35:00',2.73),('11288','2013-05-05','09:40:00',4.07),('11288','2013-05-05','09:45:00',5.2),('11288','2013-05-05','09:50:00',5.19),('11288','2013-05-05','09:55:00',5.17),('11288','2013-05-05','10:00:00',4.88),('11288','2013-05-05','10:05:00',4.58),('11288','2013-05-05','10:10:00',3.39),('11288','2013-05-05','10:15:00',5.34),('11288','2013-05-05','10:20:00',5.65),('11288','2013-05-05','10:25:00',3.62),('11288','2013-05-05','10:30:00',4.61),('11288','2013-05-05','10:35:00',5.01),('11288','2013-05-05','10:40:00',5.55),('11288','2013-05-05','10:45:00',4.84),('11288','2013-05-05','10:50:00',2.87),('11288','2013-05-05','10:55:00',2.49),('11288','2013-05-05','11:00:00',2.53),('11288','2013-05-05','11:05:00',2.88),('11288','2013-05-05','11:10:00',2.57),('11288','2013-05-05','11:15:00',2.91),('11288','2013-05-05','11:20:00',4.64),('11288','2013-05-05','11:25:00',5.27),('11288','2013-05-05','11:30:00',4.54),('11288','2013-05-05','11:35:00',6.15),('11288','2013-05-05','11:40:00',4.72),('11288','2013-05-05','11:45:00',4.38),('11288','2013-05-05','11:50:00',5.14),('11288','2013-05-05','11:55:00',6.66),('11288','2013-05-05','12:00:00',4.86),('11288','2013-05-05','12:05:00',4.94),('11288','2013-05-05','12:10:00',5.62),('11288','2013-05-05','12:15:00',5.88),('11288','2013-05-05','12:20:00',5.93),('11288','2013-05-05','12:25:00',6.7),('11288','2013-05-05','12:30:00',6.47),('11288','2013-05-05','12:35:00',7.06),('11288','2013-05-05','12:40:00',7.36),('11288','2013-05-05','12:45:00',7.54),('11288','2013-05-05','12:50:00',6.81),('11288','2013-05-05','12:55:00',7.24),('11288','2013-05-05','13:00:00',7.16),('11288','2013-05-05','13:05:00',6.89),('11288','2013-05-05','13:10:00',6.46),('11288','2013-05-05','13:15:00',4.68),('11288','2013-05-05','13:20:00',4.77),('11288','2013-05-05','13:25:00',3.24),('11288','2013-05-05','13:30:00',3.14),('11288','2013-05-05','13:35:00',7.5),('11288','2013-05-05','13:40:00',7.22),('11288','2013-05-05','13:45:00',7.04),('11288','2013-05-05','13:50:00',7.16),('11288','2013-05-05','13:55:00',7.14),('11288','2013-05-05','14:00:00',7.32),('11288','2013-05-05','14:05:00',6.79),('11288','2013-05-05','14:10:00',5.4),('11288','2013-05-05','14:15:00',6.15),('11288','2013-05-05','14:20:00',6.79),('11288','2013-05-05','14:25:00',6.34),('11288','2013-05-05','14:30:00',6.18),('11288','2013-05-05','14:35:00',6.13),('11288','2013-05-05','14:40:00',6.1),('11288','2013-05-05','14:45:00',6.05),('11288','2013-05-05','14:50:00',6),('11288','2013-05-05','14:55:00',5.95),('11288','2013-05-05','15:00:00',5.86),('11288','2013-05-05','15:05:00',5.8),('11288','2013-05-05','15:10:00',5.72),('11288','2013-05-05','15:15:00',5.68),('11288','2013-05-05','15:20:00',5.62),('11288','2013-05-05','15:25:00',5.59),('11288','2013-05-05','15:30:00',5.54),('11288','2013-05-05','15:35:00',5.5),('11288','2013-05-05','15:40:00',5.41),('11288','2013-05-05','15:45:00',5.34),('11288','2013-05-05','15:50:00',5.27),('11288','2013-05-05','15:55:00',5.17),('11288','2013-05-05','16:00:00',5.08),('11288','2013-05-05','16:05:00',4.96),('11288','2013-05-05','16:10:00',4.85),('11288','2013-05-05','16:15:00',4.79),('11288','2013-05-05','16:20:00',4.7),('11288','2013-05-05','16:25:00',4.59),('11288','2013-05-05','16:30:00',4.48),('11288','2013-05-05','16:35:00',4.37),('11288','2013-05-05','16:40:00',4.27),('11288','2013-05-05','16:45:00',4.11),('11288','2013-05-05','16:50:00',4),('11288','2013-05-05','16:55:00',3.88),('11288','2013-05-05','17:00:00',3.74),('11288','2013-05-05','17:05:00',3.59),('11288','2013-05-05','17:10:00',3.48),('11288','2013-05-05','17:15:00',3.33),('11288','2013-05-05','17:20:00',3.11),('11288','2013-05-05','17:25:00',2.88),('11288','2013-05-05','17:30:00',2.84),('11288','2013-05-05','17:35:00',2.74),('11288','2013-05-05','17:40:00',2.63),('11288','2013-05-05','17:45:00',2.45),('11288','2013-05-05','17:50:00',2.24),('11288','2013-05-05','17:55:00',2.08),('11288','2013-05-05','18:00:00',2.05),('11288','2013-05-05','18:05:00',2),('11288','2013-05-05','18:10:00',1.93),('11288','2013-05-05','18:15:00',1.82),('11288','2013-05-05','18:20:00',1.66),('11288','2013-05-05','18:25:00',1.54),('11288','2013-05-05','18:30:00',1.44),('11288','2013-05-05','18:35:00',1.36),('11288','2013-05-05','18:40:00',1.25),('11288','2013-05-05','18:45:00',1.1),('11288','2013-05-04','07:40:00',1.31),('11288','2013-05-04','07:45:00',1.31),('11288','2013-05-04','07:50:00',1.46),('11288','2013-05-04','07:55:00',1.67),('11288','2013-05-04','08:00:00',1.79),('11288','2013-05-04','08:05:00',1.92),('11288','2013-05-04','08:10:00',2.07),('11288','2013-05-04','08:15:00',2.11),('11288','2013-05-04','08:20:00',2.19),('11288','2013-05-04','08:25:00',2.35),('11288','2013-05-04','08:30:00',2.43),('11288','2013-05-04','08:35:00',2.47),('11288','2013-05-04','08:40:00',2.79),('11288','2013-05-04','08:45:00',2.83),('11288','2013-05-04','08:50:00',2.93),('11288','2013-05-04','08:55:00',3.11),('11288','2013-05-04','09:00:00',3.28),('11288','2013-05-04','09:05:00',3.45),('11288','2013-05-04','09:10:00',3.58),('11288','2013-05-04','09:15:00',3.74),('11288','2013-05-04','09:20:00',3.75),('11288','2013-05-04','09:25:00',3.97),('11288','2013-05-04','09:30:00',3.91),('11288','2013-05-04','09:35:00',4.1),('11288','2013-05-04','09:40:00',4.31),('11288','2013-05-04','09:45:00',4.39),('11288','2013-05-04','09:50:00',4.46),('11288','2013-05-04','09:55:00',4.59),('11288','2013-05-04','10:00:00',4.64),('11288','2013-05-04','10:05:00',4.63),('11288','2013-05-04','10:10:00',4.87),('11288','2013-05-04','10:15:00',4.99),('11288','2013-05-04','10:20:00',4.99),('11288','2013-05-04','10:25:00',5.02),('11288','2013-05-04','10:30:00',5.28),('11288','2013-05-04','10:35:00',5.33),('11288','2013-05-04','10:40:00',5.31),('11288','2013-05-04','10:45:00',5.37),('11288','2013-05-04','10:50:00',5.27),('11288','2013-05-04','10:55:00',5.4),('11288','2013-05-04','11:00:00',5.34),('11288','2013-05-04','11:05:00',5.33),('11288','2013-05-04','11:10:00',5.02),('11288','2013-05-04','11:15:00',5.05),('11288','2013-05-04','11:20:00',5.48),('11288','2013-05-04','11:25:00',5.42),('11288','2013-05-04','11:30:00',5.35),('11288','2013-05-04','11:35:00',5.38),('11288','2013-05-04','11:40:00',5.29),('11288','2013-05-04','11:45:00',5.5),('11288','2013-05-04','11:50:00',5.44),('11288','2013-05-04','11:55:00',5.51),('11288','2013-05-04','12:00:00',5.49),('11288','2013-05-04','12:05:00',5.68),('11288','2013-05-04','12:10:00',5.71),('11288','2013-05-04','12:15:00',5.9),('11288','2013-05-04','12:20:00',5.93),('11288','2013-05-04','12:25:00',6.02),('11288','2013-05-04','12:30:00',6.09),('11288','2013-05-04','12:35:00',6.11),('11288','2013-05-04','12:40:00',6.05),('11288','2013-05-04','12:45:00',6.13),('11288','2013-05-04','12:50:00',5.88),('11288','2013-05-04','12:55:00',5.85),('11288','2013-05-04','13:00:00',5.69),('11288','2013-05-04','13:05:00',5.15),('11288','2013-05-04','13:10:00',5.89),('11288','2013-05-04','13:15:00',6.35),('11288','2013-05-04','13:20:00',6.38),('11288','2013-05-04','13:25:00',6.06),('11288','2013-05-04','13:30:00',6.27),('11288','2013-05-04','13:35:00',5.72),('11288','2013-05-04','13:40:00',5.97),('11288','2013-05-04','13:45:00',5.91),('11288','2013-05-04','13:50:00',5.31),('11288','2013-05-04','13:55:00',5.42),('11288','2013-05-04','14:00:00',5.98),('11288','2013-05-04','14:05:00',5.75),('11288','2013-05-04','14:10:00',5.57),('11288','2013-05-04','14:15:00',5.81),('11288','2013-05-04','14:20:00',5.67),('11288','2013-05-04','14:25:00',5.33),('11288','2013-05-04','14:30:00',5.57),('11288','2013-05-04','14:35:00',5.19),('11288','2013-05-04','14:40:00',5.49),('11288','2013-05-04','14:45:00',5.31),('11288','2013-05-04','14:50:00',5.21),('11288','2013-05-04','14:55:00',5.33),('11288','2013-05-04','15:00:00',5.45),('11288','2013-05-04','15:05:00',5.53),('11288','2013-05-04','15:10:00',5.22),('11288','2013-05-04','15:15:00',5.34),('11288','2013-05-04','15:20:00',5.35),('11288','2013-05-04','15:25:00',5.34),('11288','2013-05-04','15:30:00',5.28),('11288','2013-05-04','15:35:00',5.02),('11288','2013-05-04','15:40:00',5.25),('11288','2013-05-04','15:45:00',5.12),('11288','2013-05-04','15:50:00',5.01),('11288','2013-05-04','15:55:00',4.92),('11288','2013-05-04','16:00:00',4.8),('11288','2013-05-04','16:05:00',4.67),('11288','2013-05-04','16:10:00',4.58),('11288','2013-05-04','16:15:00',4.51),('11288','2013-05-04','16:20:00',4.4),('11288','2013-05-04','16:25:00',4.26),('11288','2013-05-04','16:30:00',4.13),('11288','2013-05-04','16:35:00',4.04),('11288','2013-05-04','16:40:00',3.94),('11288','2013-05-04','16:45:00',3.81),('11288','2013-05-04','16:50:00',3.68),('11288','2013-05-04','16:55:00',3.57),('11288','2013-05-04','17:00:00',3.5),('11288','2013-05-04','17:05:00',3.28),('11288','2013-05-04','17:10:00',2.55),('11288','2013-05-04','17:15:00',3.01),('11288','2013-05-04','17:20:00',3),('11288','2013-05-04','17:25:00',2.8),('11288','2013-05-04','17:30:00',2.67),('11288','2013-05-04','17:35:00',2.47),('11288','2013-05-04','17:40:00',2.33),('11288','2013-05-04','17:45:00',2.3),('11288','2013-05-04','17:50:00',2.19),('11288','2013-05-04','17:55:00',2.13),('11288','2013-05-04','18:00:00',2.01),('11288','2013-05-04','18:05:00',1.91),('11288','2013-05-04','18:10:00',1.68),('11288','2013-05-04','18:15:00',1.37),('11288','2013-05-04','18:20:00',1.16),('11288','2013-05-04','18:25:00',1.03),('11288','2013-05-03','07:50:00',1.09),('11288','2013-05-03','07:55:00',1.16),('11288','2013-05-03','08:00:00',1.5),('11288','2013-05-03','08:05:00',2.05),('11288','2013-05-03','08:10:00',2.35),('11288','2013-05-03','08:15:00',2.59),('11288','2013-05-03','08:20:00',2.47),('11288','2013-05-03','08:25:00',2.63),('11288','2013-05-03','08:30:00',2.83),('11288','2013-05-03','08:35:00',2.93),('11288','2013-05-03','08:40:00',2.99),('11288','2013-05-03','08:45:00',3.05),('11288','2013-05-03','08:50:00',2.96),('11288','2013-05-03','08:55:00',2.88),('11288','2013-05-03','09:00:00',3.18),('11288','2013-05-03','09:05:00',3.6),('11288','2013-05-03','09:10:00',3.7),('11288','2013-05-03','09:15:00',3.86),('11288','2013-05-03','09:20:00',3.83),('11288','2013-05-03','09:25:00',4.04),('11288','2013-05-03','09:30:00',4.12),('11288','2013-05-03','09:35:00',4.34),('11288','2013-05-03','09:40:00',4.38),('11288','2013-05-03','09:45:00',4.43),('11288','2013-05-03','09:50:00',4.62),('11288','2013-05-03','09:55:00',4.74),('11288','2013-05-03','10:00:00',4.71),('11288','2013-05-03','10:05:00',4.89),('11288','2013-05-03','10:10:00',4.91),('11288','2013-05-03','10:15:00',4.88),('11288','2013-05-03','10:20:00',5.03),('11288','2013-05-03','10:25:00',4.96),('11288','2013-05-03','10:30:00',5.13),('11288','2013-05-03','10:35:00',5.44),('11288','2013-05-03','10:40:00',5.48),('11288','2013-05-03','10:45:00',5.59),('11288','2013-05-03','10:50:00',5.72),('11288','2013-05-03','10:55:00',5.82),('11288','2013-05-03','11:00:00',5.88),('11288','2013-05-03','11:05:00',5.92),('11288','2013-05-03','11:10:00',5.95),('11288','2013-05-03','11:15:00',6.02),('11288','2013-05-03','11:20:00',6.06),('11288','2013-05-03','11:25:00',6.12),('11288','2013-05-03','11:30:00',6.17),('11288','2013-05-03','11:35:00',6.18),('11288','2013-05-03','11:40:00',6.24),('11288','2013-05-03','11:45:00',6.26),('11288','2013-05-03','11:50:00',6.29),('11288','2013-05-03','11:55:00',6.38),('11288','2013-05-03','12:00:00',6.37),('11288','2013-05-03','12:05:00',6.36),('11288','2013-05-03','12:10:00',6.41),('11288','2013-05-03','12:15:00',6.4),('11288','2013-05-03','12:20:00',6.49),('11288','2013-05-03','12:25:00',6.51),('11288','2013-05-03','12:30:00',6.49),('11288','2013-05-03','12:35:00',6.48),('11288','2013-05-03','12:40:00',6.48),('11288','2013-05-03','12:45:00',6.41),('11288','2013-05-03','12:50:00',6.64),('11288','2013-05-03','12:55:00',6.61),('11288','2013-05-03','13:00:00',6.57),('11288','2013-05-03','13:05:00',6.56),('11288','2013-05-03','13:10:00',6.54),('11288','2013-05-03','13:15:00',6.5),('11288','2013-05-03','13:20:00',6.46),('11288','2013-05-03','13:25:00',6.44),('11288','2013-05-03','13:30:00',6.45),('11288','2013-05-03','13:35:00',6.39),('11288','2013-05-03','13:40:00',6.15),('11288','2013-05-03','13:45:00',6.22),('11288','2013-05-03','13:50:00',6.23),('11288','2013-05-03','13:55:00',6.26),('11288','2013-05-03','14:00:00',6.08),('11288','2013-05-03','14:05:00',5.96),('11288','2013-05-03','14:10:00',5.93),('11288','2013-05-03','14:15:00',5.86),('11288','2013-05-03','14:20:00',6.06),('11288','2013-05-03','14:25:00',6.02),('11288','2013-05-03','14:30:00',6.04),('11288','2013-05-03','14:35:00',5.96),('11288','2013-05-03','14:40:00',5.9),('11288','2013-05-03','14:45:00',5.88),('11288','2013-05-03','14:50:00',5.81),('11288','2013-05-03','14:55:00',5.82),('11288','2013-05-03','15:00:00',5.82),('11288','2013-05-03','15:05:00',5.71),('11288','2013-05-03','15:10:00',5.69),('11288','2013-05-03','15:15:00',5.67),('11288','2013-05-03','15:20:00',5.64),('11288','2013-05-03','15:25:00',5.58),('11288','2013-05-03','15:30:00',5.54),('11288','2013-05-03','15:35:00',5.43),('11288','2013-05-03','15:40:00',5.37),('11288','2013-05-03','15:45:00',5.28),('11288','2013-05-03','15:50:00',5.16),('11288','2013-05-03','15:55:00',5.09),('11288','2013-05-03','16:00:00',4.99),('11288','2013-05-03','16:05:00',4.9),('11288','2013-05-03','16:10:00',4.82),('11288','2013-05-03','16:15:00',4.67),('11288','2013-05-03','16:20:00',4.42),('11288','2013-05-03','16:25:00',4.41),('11288','2013-05-03','16:30:00',4.38),('11288','2013-05-03','16:35:00',4.26),('11288','2013-05-03','16:40:00',4.11),('11288','2013-05-03','16:45:00',3.97),('11288','2013-05-03','16:50:00',3.83),('11288','2013-05-03','16:55:00',3.74),('11288','2013-05-03','17:00:00',3.61),('11288','2013-05-03','17:05:00',3.46),('11288','2013-05-03','17:10:00',3.3),('11288','2013-05-03','17:15:00',3.19),('11288','2013-05-03','17:20:00',2.95),('11288','2013-05-03','17:25:00',2.75),('11288','2013-05-03','17:30:00',2.6),('11288','2013-05-03','17:35:00',2.54),('11288','2013-05-03','17:40:00',2.4),('11288','2013-05-03','17:45:00',2.26),('11288','2013-05-03','17:50:00',2.06),('11288','2013-05-03','17:55:00',1.94),('11288','2013-05-03','18:00:00',1.88),('11288','2013-05-03','18:05:00',1.83),('11288','2013-05-03','18:10:00',1.78),('11288','2013-05-03','18:15:00',1.69),('11288','2013-05-03','18:20:00',1.58),('11288','2013-05-03','18:25:00',1.45),('11288','2013-05-03','18:30:00',1.31),('11288','2013-05-03','18:35:00',1.18),('11288','2013-05-03','18:40:00',1.11),('11288','2013-05-02','08:35:00',1.14),('11288','2013-05-02','08:40:00',1.56),('11288','2013-05-02','08:45:00',1.41),('11288','2013-05-02','08:50:00',1.45),('11288','2013-05-02','08:55:00',2.28),('11288','2013-05-02','09:00:00',3.06),('11288','2013-05-02','09:05:00',2.27),('11288','2013-05-02','09:10:00',1.49),('11288','2013-05-02','09:15:00',1.48),('11288','2013-05-02','09:20:00',1.95),('11288','2013-05-02','09:25:00',3.07),('11288','2013-05-02','09:30:00',3.77),('11288','2013-05-02','09:35:00',3.24),('11288','2013-05-02','09:40:00',2.63),('11288','2013-05-02','09:45:00',4.5),('11288','2013-05-02','09:50:00',2.35),('11288','2013-05-02','09:55:00',1.84),('11288','2013-05-02','10:00:00',1.84),('11288','2013-05-02','10:05:00',2.57),('11288','2013-05-02','10:10:00',2.39),('11288','2013-05-02','10:15:00',2.5),('11288','2013-05-02','10:20:00',2.54),('11288','2013-05-02','10:25:00',3.02),('11288','2013-05-02','10:30:00',4.67),('11288','2013-05-02','10:35:00',4.35),('11288','2013-05-02','10:40:00',5.48),('11288','2013-05-02','10:45:00',4.83),('11288','2013-05-02','10:50:00',6.08),('11288','2013-05-02','10:55:00',6.47),('11288','2013-05-02','11:00:00',6.31),('11288','2013-05-02','11:05:00',5.86),('11288','2013-05-02','11:10:00',4.85),('11288','2013-05-02','11:15:00',4.78),('11288','2013-05-02','11:20:00',5.31),('11288','2013-05-02','11:25:00',6.08),('11288','2013-05-02','11:30:00',6.34),('11288','2013-05-02','11:35:00',6.09),('11288','2013-05-02','11:40:00',6.13),('11288','2013-05-02','11:45:00',6.11),('11288','2013-05-02','11:50:00',6.14),('11288','2013-05-02','11:55:00',6.21),('11288','2013-05-02','12:00:00',6.18),('11288','2013-05-02','12:05:00',6.16),('11288','2013-05-02','12:10:00',6.18),('11288','2013-05-02','12:15:00',6.22),('11288','2013-05-02','12:20:00',6.24),('11288','2013-05-02','12:25:00',6.25),('11288','2013-05-02','12:30:00',6.38),('11288','2013-05-02','12:35:00',6.46),('11288','2013-05-02','12:40:00',6.53),('11288','2013-05-02','12:45:00',6.63),('11288','2013-05-02','12:50:00',6.63),('11288','2013-05-02','12:55:00',6.73),('11288','2013-05-02','13:00:00',6.79),('11288','2013-05-02','13:05:00',6.85),('11288','2013-05-02','13:10:00',6.85),('11288','2013-05-02','13:15:00',6.83),('11288','2013-05-02','13:20:00',6.84),('11288','2013-05-02','13:25:00',6.85),('11288','2013-05-02','13:30:00',6.85),('11288','2013-05-02','13:35:00',6.81),('11288','2013-05-02','13:40:00',6.81),('11288','2013-05-02','13:45:00',6.73),('11288','2013-05-02','13:50:00',6.75),('11288','2013-05-02','13:55:00',6.73),('11288','2013-05-02','14:00:00',6.66),('11288','2013-05-02','14:05:00',6.56),('11288','2013-05-02','14:10:00',6.48),('11288','2013-05-02','14:15:00',6.43),('11288','2013-05-02','14:20:00',6.41),('11288','2013-05-02','14:25:00',6.39),('11288','2013-05-02','14:30:00',6.31),('11288','2013-05-02','14:35:00',6.25),('11288','2013-05-02','14:40:00',6.2),('11288','2013-05-02','14:45:00',6.15),('11288','2013-05-02','14:50:00',6.12),('11288','2013-05-02','14:55:00',6.08),('11288','2013-05-02','15:00:00',6.05),('11288','2013-05-02','15:05:00',5.96),('11288','2013-05-02','15:10:00',5.89),('11288','2013-05-02','15:15:00',5.78),('11288','2013-05-02','15:20:00',5.73),('11288','2013-05-02','15:25:00',5.6),('11288','2013-05-02','15:30:00',5.51),('11288','2013-05-02','15:35:00',5.46),('11288','2013-05-02','15:40:00',5.34),('11288','2013-05-02','15:45:00',5.29),('11288','2013-05-02','15:50:00',5.18),('11288','2013-05-02','15:55:00',5.1),('11288','2013-05-02','16:00:00',4.95),('11288','2013-05-02','16:05:00',4.88),('11288','2013-05-02','16:10:00',4.78),('11288','2013-05-02','16:15:00',4.67),('11288','2013-05-02','16:20:00',4.58),('11288','2013-05-02','16:25:00',4.44),('11288','2013-05-02','16:30:00',4.29),('11288','2013-05-02','16:35:00',4.21),('11288','2013-05-02','16:40:00',4.1),('11288','2013-05-02','16:45:00',3.95),('11288','2013-05-02','16:50:00',3.84),('11288','2013-05-02','16:55:00',3.73),('11288','2013-05-02','17:00:00',3.63),('11288','2013-05-02','17:05:00',3.5),('11288','2013-05-02','17:10:00',3.39),('11288','2013-05-02','17:15:00',3.26),('11288','2013-05-02','17:20:00',3.1),('11288','2013-05-02','17:25:00',2.9),('11288','2013-05-02','17:30:00',2.75),('11288','2013-05-02','17:35:00',2.7),('11288','2013-05-02','17:40:00',2.57),('11288','2013-05-02','17:45:00',2.44),('11288','2013-05-02','17:50:00',2.25),('11288','2013-05-02','17:55:00',2.06),('11288','2013-05-02','18:00:00',2.02),('11288','2013-05-02','18:05:00',1.91),('11288','2013-05-02','18:10:00',1.85),('11288','2013-05-02','18:15:00',1.78),('11288','2013-05-02','18:20:00',1.68),('11288','2013-05-02','18:25:00',1.5),('11288','2013-05-02','18:30:00',1.41),('11288','2013-05-02','18:35:00',1.3),('11288','2013-05-02','18:40:00',1.19),('11288','2013-05-02','18:45:00',1.04),('11288','2014-03-30','08:00:00',1.04),('11288','2014-03-30','08:05:00',1.1),('11288','2014-03-30','08:10:00',1.11),('11288','2014-03-30','08:15:00',1.32),('11288','2014-03-30','08:20:00',1.51),('11288','2014-03-30','08:25:00',1.6),('11288','2014-03-30','08:30:00',1.73),('11288','2014-03-30','08:35:00',1.78),('11288','2014-03-30','08:40:00',1.87),('11288','2014-03-30','08:45:00',1.89),('11288','2014-03-30','08:50:00',1.96),('11288','2014-03-30','08:55:00',2.06),('11288','2014-03-30','09:00:00',2.11),('11288','2014-03-30','09:05:00',2.11),('11288','2014-03-30','09:10:00',2.01),('11288','2014-03-30','09:15:00',2.23),('11288','2014-03-30','09:20:00',2.4),('11288','2014-03-30','09:25:00',2.7),('11288','2014-03-30','09:30:00',2.99),('11288','2014-03-30','09:35:00',3.23),('11288','2014-03-30','09:40:00',3.26),('11288','2014-03-30','09:45:00',3.49),('11288','2014-03-30','09:50:00',3.61),('11288','2014-03-30','09:55:00',3.51),('11288','2014-03-30','10:00:00',3.75),('11288','2014-03-30','10:05:00',4.11),('11288','2014-03-30','10:10:00',4.24),('11288','2014-03-30','10:15:00',4.14),('11288','2014-03-30','10:20:00',4.48),('11288','2014-03-30','10:25:00',4.69),('11288','2014-03-30','10:30:00',4.77),('11288','2014-03-30','10:35:00',4.93),('11288','2014-03-30','10:40:00',5.02),('11288','2014-03-30','10:45:00',5.04),('11288','2014-03-30','10:50:00',4.99),('11288','2014-03-30','10:55:00',5.05),('11288','2014-03-30','11:00:00',4.91),('11288','2014-03-30','11:05:00',4.88),('11288','2014-03-30','11:10:00',4.95),('11288','2014-03-30','11:15:00',4.81),('11288','2014-03-30','11:20:00',4.87),('11288','2014-03-30','11:25:00',5.24),('11288','2014-03-30','11:30:00',5.45),('11288','2014-03-30','11:35:00',5.47),('11288','2014-03-30','11:40:00',5.64),('11288','2014-03-30','11:45:00',5.79),('11288','2014-03-30','11:50:00',5.86),('11288','2014-03-30','11:55:00',6.02),('11288','2014-03-30','12:00:00',6.14),('11288','2014-03-30','12:05:00',6.33),('11288','2014-03-30','12:10:00',6.5),('11288','2014-03-30','12:15:00',6.65),('11288','2014-03-30','12:20:00',6.42),('11288','2014-03-30','12:25:00',6.36),('11288','2014-03-30','12:30:00',5.84),('11288','2014-03-30','12:35:00',6.18),('11288','2014-03-30','12:40:00',6.22),('11288','2014-03-30','12:45:00',6.2),('11288','2014-03-30','12:50:00',6.25),('11288','2014-03-30','12:55:00',6.38),('11288','2014-03-30','13:00:00',6.55),('11288','2014-03-30','13:05:00',6.62),('11288','2014-03-30','13:10:00',6.5),('11288','2014-03-30','13:15:00',6.57),('11288','2014-03-30','13:20:00',6.53),('11288','2014-03-30','13:25:00',6.52),('11288','2014-03-30','13:30:00',6.54),('11288','2014-03-30','13:35:00',6.55),('11288','2014-03-30','13:40:00',6.58),('11288','2014-03-30','13:45:00',6.57),('11288','2014-03-30','13:50:00',6.43),('11288','2014-03-30','13:55:00',6.28),('11288','2014-03-30','14:00:00',6.25),('11288','2014-03-30','14:05:00',6.18),('11288','2014-03-30','14:10:00',6.05),('11288','2014-03-30','14:15:00',6.05),('11288','2014-03-30','14:20:00',6.26),('11288','2014-03-30','14:25:00',6.34),('11288','2014-03-30','14:30:00',6.02),('11288','2014-03-30','14:35:00',5.36),('11288','2014-03-30','14:40:00',5.56),('11288','2014-03-30','14:45:00',4.89),('11288','2014-03-30','14:50:00',3.74),('11288','2014-03-30','14:55:00',2.72),('11288','2014-03-30','15:00:00',2.75),('11288','2014-03-30','15:05:00',2.95),('11288','2014-03-30','15:10:00',4.05),('11288','2014-03-30','15:15:00',4.93),('11288','2014-03-30','15:20:00',4.94),('11288','2014-03-30','15:25:00',5.22),('11288','2014-03-30','15:30:00',5.22),('11288','2014-03-30','15:35:00',5.13),('11288','2014-03-30','15:40:00',5.21),('11288','2014-03-30','15:45:00',5.13),('11288','2014-03-30','15:50:00',5.01),('11288','2014-03-30','15:55:00',4.88),('11288','2014-03-30','16:00:00',4.35),('11288','2014-03-30','16:05:00',4.26),('11288','2014-03-30','16:10:00',4.05),('11288','2014-03-30','16:15:00',4.51),('11288','2014-03-30','16:20:00',4.52),('11288','2014-03-30','16:25:00',4.33),('11288','2014-03-30','16:30:00',4.31),('11288','2014-03-30','16:35:00',4.19),('11288','2014-03-30','16:40:00',3.89),('11288','2014-03-30','16:45:00',3.46),('11288','2014-03-30','16:50:00',2.93),('11288','2014-03-30','16:55:00',2.88),('11288','2014-03-30','17:00:00',3.07),('11288','2014-03-30','17:05:00',3.22),('11288','2014-03-30','17:10:00',3.28),('11288','2014-03-30','17:15:00',3.13),('11288','2014-03-30','17:20:00',2.92),('11288','2014-03-30','17:25:00',2.59),('11288','2014-03-30','17:30:00',2.56),('11288','2014-03-30','17:35:00',2.36),('11288','2014-03-30','17:40:00',2.12),('11288','2014-03-30','17:45:00',2.06),('11288','2014-03-30','17:50:00',1.64),('11288','2014-03-30','17:55:00',1.31),('11288','2014-03-30','18:00:00',1.12),('11288','2014-03-30','18:05:00',1.18),('11288','2014-03-30','18:10:00',1.16),('11288','2013-05-01','07:35:00',1.14),('11288','2013-05-01','07:40:00',1.28),('11288','2013-05-01','07:45:00',1.4),('11288','2013-05-01','07:50:00',1.54),('11288','2013-05-01','07:55:00',1.66),('11288','2013-05-01','08:00:00',1.73),('11288','2013-05-01','08:05:00',1.83),('11288','2013-05-01','08:10:00',1.91),('11288','2013-05-01','08:15:00',2.1),('11288','2013-05-01','08:20:00',2.21),('11288','2013-05-01','08:25:00',2.33),('11288','2013-05-01','08:30:00',2.44),('11288','2013-05-01','08:35:00',2.63),('11288','2013-05-01','08:40:00',2.78),('11288','2013-05-01','08:45:00',2.89),('11288','2013-05-01','08:50:00',2.92),('11288','2013-05-01','08:55:00',3.08),('11288','2013-05-01','09:00:00',3.21),('11288','2013-05-01','09:05:00',3.45),('11288','2013-05-01','09:10:00',3.68),('11288','2013-05-01','09:15:00',3.77),('11288','2013-05-01','09:20:00',3.92),('11288','2013-05-01','09:25:00',3.98),('11288','2013-05-01','09:30:00',4.03),('11288','2013-05-01','09:35:00',4.17),('11288','2013-05-01','09:40:00',4.33),('11288','2013-05-01','09:45:00',4.41),('11288','2013-05-01','09:50:00',4.47),('11288','2013-05-01','09:55:00',4.54),('11288','2013-05-01','10:00:00',4.6),('11288','2013-05-01','10:05:00',4.65),('11288','2013-05-01','10:10:00',4.88),('11288','2013-05-01','10:15:00',4.91),('11288','2013-05-01','10:20:00',5.03),('11288','2013-05-01','10:25:00',5.15),('11288','2013-05-01','10:30:00',5.25),('11288','2013-05-01','10:35:00',5.38),('11288','2013-05-01','10:40:00',5.7),('11288','2013-05-01','10:45:00',5.84),('11288','2013-05-01','10:50:00',5.86),('11288','2013-05-01','10:55:00',5.9),('11288','2013-05-01','11:00:00',5.98),('11288','2013-05-01','11:05:00',5.95),('11288','2013-05-01','11:10:00',6.07),('11288','2013-05-01','11:15:00',5.59),('11288','2013-05-01','11:20:00',5.71),('11288','2013-05-01','11:25:00',5.52),('11288','2013-05-01','11:30:00',5.52),('11288','2013-05-01','11:35:00',5.65),('11288','2013-05-01','11:40:00',4.42),('11288','2013-05-01','11:45:00',4.47),('11288','2013-05-01','11:50:00',5.9),('11288','2013-05-01','11:55:00',6.52),('11288','2013-05-01','12:00:00',6.43),('11288','2013-05-01','12:05:00',6.37),('11288','2013-05-01','12:10:00',6.4),('11288','2013-05-01','12:15:00',6.35),('11288','2013-05-01','12:20:00',6.41),('11288','2013-05-01','12:25:00',6.47),('11288','2013-05-01','12:30:00',6.58),('11288','2013-05-01','12:35:00',6.7),('11288','2013-05-01','12:40:00',6.86),('11288','2013-05-01','12:45:00',6.01),('11288','2013-05-01','12:50:00',3.8),('11288','2013-05-01','12:55:00',2.66),('11288','2013-05-01','13:00:00',2.87),('11288','2013-05-01','13:05:00',3.53),('11288','2013-05-01','13:10:00',4.66),('11288','2013-05-01','13:15:00',7.47),('11288','2013-05-01','13:20:00',7.69),('11288','2013-05-01','13:25:00',7),('11288','2013-05-01','13:30:00',6.33),('11288','2013-05-01','13:35:00',7.47),('11288','2013-05-01','13:40:00',6.92),('11288','2013-05-01','13:45:00',7.22),('11288','2013-05-01','13:50:00',6.85),('11288','2013-05-01','13:55:00',6.62),('11288','2013-05-01','14:00:00',6.43),('11288','2013-05-01','14:05:00',6.4),('11288','2013-05-01','14:10:00',6.24),('11288','2013-05-01','14:15:00',5.62),('11288','2013-05-01','14:20:00',6.69),('11288','2013-05-01','14:25:00',6.64),('11288','2013-05-01','14:30:00',6.63),('11288','2013-05-01','14:35:00',6.23),('11288','2013-05-01','14:40:00',5.93),('11288','2013-05-01','14:45:00',5.89),('11288','2013-05-01','14:50:00',5.18),('11288','2013-05-01','14:55:00',4.75),('11288','2013-05-01','15:00:00',5.25),('11288','2013-05-01','15:05:00',5.73),('11288','2013-05-01','15:10:00',5.9),('11288','2013-05-01','15:15:00',5.63),('11288','2013-05-01','15:20:00',5.63),('11288','2013-05-01','15:25:00',5.51),('11288','2013-05-01','15:30:00',4.53),('11288','2013-05-01','15:35:00',4.11),('11288','2013-05-01','15:40:00',4.11),('11288','2013-05-01','15:45:00',4.03),('11288','2013-05-01','15:50:00',3.02),('11288','2013-05-01','15:55:00',3.09),('11288','2013-05-01','16:00:00',3.64),('11288','2013-05-01','16:05:00',3.43),('11288','2013-05-01','16:10:00',3.11),('11288','2013-05-01','16:15:00',2.88),('11288','2013-05-01','16:20:00',2.49),('11288','2013-05-01','16:25:00',2.04),('11288','2013-05-01','16:30:00',1.89),('11288','2013-05-01','16:35:00',1.99),('11288','2013-05-01','16:40:00',2.12),('11288','2013-05-01','16:45:00',1.97),('11288','2013-05-01','16:50:00',1.74),('11288','2013-05-01','16:55:00',1.61),('11288','2013-05-01','17:00:00',1.63),('11288','2013-05-01','17:05:00',1.65),('11288','2013-05-01','17:10:00',1.67),('11288','2013-05-01','17:15:00',1.66),('11288','2013-05-01','17:20:00',1.49),('11288','2013-05-01','17:25:00',1.25),('11288','2013-05-01','17:30:00',1.07),('11288','2013-04-30','08:25:00',1.06),('11288','2013-04-30','08:30:00',1.37),('11288','2013-04-30','08:35:00',1.62),('11288','2013-04-30','08:40:00',1.54),('11288','2013-04-30','08:45:00',1.63),('11288','2013-04-30','08:50:00',2.28),('11288','2013-04-30','08:55:00',2.98),('11288','2013-04-30','09:00:00',2.74),('11288','2013-04-30','09:05:00',2.53),('11288','2013-04-30','09:10:00',3.53),('11288','2013-04-30','09:15:00',4.27),('11288','2013-04-30','09:20:00',4.55),('11288','2013-04-30','09:25:00',4.75),('11288','2013-04-30','09:30:00',4.52),('11288','2013-04-30','09:35:00',3.68),('11288','2013-04-30','09:40:00',2.54),('11288','2013-04-30','09:45:00',3.75),('11288','2013-04-30','09:50:00',4.48),('11288','2013-04-30','09:55:00',4.9),('11288','2013-04-30','10:00:00',5.56),('11288','2013-04-30','10:05:00',4.79),('11288','2013-04-30','10:10:00',4.77),('11288','2013-04-30','10:15:00',3.69),('11288','2013-04-30','10:20:00',3.75),('11288','2013-04-30','10:25:00',5.81),('11288','2013-04-30','10:30:00',4.19),('11288','2013-04-30','10:35:00',3.2),('11288','2013-04-30','10:40:00',2.92),('11288','2013-04-30','10:45:00',2.39),('11288','2013-04-30','10:50:00',2.58),('11288','2013-04-30','10:55:00',2.76),('11288','2013-04-30','11:00:00',2.91),('11288','2013-04-30','11:05:00',3.28),('11288','2013-04-30','11:10:00',3.25),('11288','2013-04-30','11:15:00',3.49),('11288','2013-04-30','11:20:00',3.95),('11288','2013-04-30','11:25:00',3.57),('11288','2013-04-30','11:30:00',3.63),('11288','2013-04-30','11:35:00',3.94),('11288','2013-04-30','11:40:00',3.44),('11288','2013-04-30','11:45:00',2.95),('11288','2013-04-30','11:50:00',2.98),('11288','2013-04-30','11:55:00',3.07),('11288','2013-04-30','12:00:00',3.14),('11288','2013-04-30','12:05:00',3.23),('11288','2013-04-30','12:10:00',3.06),('11288','2013-04-30','12:15:00',2.83),('11288','2013-04-30','12:20:00',2.61),('11288','2013-04-30','12:25:00',2.45),('11288','2013-04-30','12:30:00',2.56),('11288','2013-04-30','12:35:00',5.19),('11288','2013-04-30','12:40:00',7.46),('11288','2013-04-30','12:45:00',7.65),('11288','2013-04-30','12:50:00',7.26),('11288','2013-04-30','12:55:00',6.6),('11288','2013-04-30','13:00:00',6.93),('11288','2013-04-30','13:05:00',6.88),('11288','2013-04-30','13:10:00',6.82),('11288','2013-04-30','13:15:00',6.74),('11288','2013-04-30','13:20:00',6.66),('11288','2013-04-30','13:25:00',6.6),('11288','2013-04-30','13:30:00',6.59),('11288','2013-04-30','13:35:00',6.58),('11288','2013-04-30','13:40:00',6.51),('11288','2013-04-30','13:45:00',6.42),('11288','2013-04-30','13:50:00',6.36),('11288','2013-04-30','13:55:00',6.31),('11288','2013-04-30','14:00:00',6.21),('11288','2013-04-30','14:05:00',6.25),('11288','2013-04-30','14:10:00',6.2),('11288','2013-04-30','14:15:00',6.17),('11288','2013-04-30','14:20:00',6.14),('11288','2013-04-30','14:25:00',6.14),('11288','2013-04-30','14:30:00',6.15),('11288','2013-04-30','14:35:00',6.09),('11288','2013-04-30','14:40:00',6.02),('11288','2013-04-30','14:45:00',5.97),('11288','2013-04-30','14:50:00',5.9),('11288','2013-04-30','14:55:00',5.82),('11288','2013-04-30','15:00:00',5.74),('11288','2013-04-30','15:05:00',5.61),('11288','2013-04-30','15:10:00',5.53),('11288','2013-04-30','15:15:00',5.45),('11288','2013-04-30','15:20:00',5.41),('11288','2013-04-30','15:25:00',5.26),('11288','2013-04-30','15:30:00',5.27),('11288','2013-04-30','15:35:00',5.2),('11288','2013-04-30','15:40:00',5.12),('11288','2013-04-30','15:45:00',5.04),('11288','2013-04-30','15:50:00',4.95),('11288','2013-04-30','15:55:00',4.85),('11288','2013-04-30','16:00:00',4.72),('11288','2013-04-30','16:05:00',4.64),('11288','2013-04-30','16:10:00',4.58),('11288','2013-04-30','16:15:00',4.44),('11288','2013-04-30','16:20:00',4.32),('11288','2013-04-30','16:25:00',4.23),('11288','2013-04-30','16:30:00',4.14),('11288','2013-04-30','16:35:00',3.77),('11288','2013-04-30','16:40:00',3.28),('11288','2013-04-30','16:45:00',3.13),('11288','2013-04-30','16:50:00',3.38),('11288','2013-04-30','16:55:00',3.5),('11288','2013-04-30','17:00:00',3.32),('11288','2013-04-30','17:05:00',3.18),('11288','2013-04-30','17:10:00',2.55),('11288','2013-04-30','17:15:00',1.51),('11288','2013-04-30','17:20:00',2.41),('11288','2013-04-30','17:25:00',2.59),('11288','2013-04-30','17:30:00',2.48),('11288','2013-04-30','17:35:00',2.43),('11288','2013-04-30','17:40:00',2.31),('11288','2013-04-30','17:45:00',2.19),('11288','2013-04-30','17:50:00',2.04),('11288','2013-04-30','17:55:00',1.89),('11288','2013-04-30','18:00:00',1.79),('11288','2013-04-30','18:05:00',1.72),('11288','2013-04-30','18:10:00',1.63),('11288','2013-04-30','18:15:00',1.52),('11288','2013-04-30','18:20:00',1.42),('11288','2013-04-30','18:25:00',1.32),('11288','2013-04-30','18:30:00',1.21),('11288','2013-04-30','18:35:00',1.1),('11288','2013-04-29','07:15:00',1.05),('11288','2013-04-29','07:20:00',1.26),('11288','2013-04-29','07:25:00',1.36),('11288','2013-04-29','07:30:00',1.33),('11288','2013-04-29','07:35:00',1.35),('11288','2013-04-29','07:40:00',1.3),('11288','2013-04-29','07:45:00',1.41),('11288','2013-04-29','07:50:00',1.55),('11288','2013-04-29','07:55:00',1.83),('11288','2013-04-29','08:00:00',1.99),('11288','2013-04-29','08:05:00',2.08),('11288','2013-04-29','08:10:00',2.02),('11288','2013-04-29','08:15:00',2.1),('11288','2013-04-29','08:20:00',2.28),('11288','2013-04-29','08:25:00',2.6),('11288','2013-04-29','08:30:00',2.83),('11288','2013-04-29','08:35:00',3.2),('11288','2013-04-29','08:40:00',3.25),('11288','2013-04-29','08:45:00',3.16),('11288','2013-04-29','08:50:00',3.3),('11288','2013-04-29','08:55:00',3.2),('11288','2013-04-29','09:00:00',2.8),('11288','2013-04-29','09:05:00',3.82),('11288','2013-04-29','09:10:00',4.09),('11288','2013-04-29','09:15:00',4.36),('11288','2013-04-29','09:20:00',4.02),('11288','2013-04-29','09:25:00',3.96),('11288','2013-04-29','09:30:00',4.1),('11288','2013-04-29','09:35:00',4.27),('11288','2013-04-29','09:40:00',4.38),('11288','2013-04-29','09:45:00',4.45),('11288','2013-04-29','09:50:00',4.65),('11288','2013-04-29','09:55:00',4.4),('11288','2013-04-29','10:00:00',4.58),('11288','2013-04-29','10:05:00',4.53),('11288','2013-04-29','10:10:00',4.44),('11288','2013-04-29','10:15:00',3.74),('11288','2013-04-29','10:20:00',3.98),('11288','2013-04-29','10:25:00',4.56),('11288','2013-04-29','10:30:00',4.94),('11288','2013-04-29','10:35:00',5.42),('11288','2013-04-29','10:40:00',5.53),('11288','2013-04-29','10:45:00',5.51),('11288','2013-04-29','10:50:00',5.33),('11288','2013-04-29','10:55:00',5.06),('11288','2013-04-29','11:00:00',5.7),('11288','2013-04-29','11:05:00',5.24),('11288','2013-04-29','11:10:00',5.13),('11288','2013-04-29','11:15:00',4.99),('11288','2013-04-29','11:20:00',5.86),('11288','2013-04-29','11:25:00',5.92),('11288','2013-04-29','11:30:00',6.12),('11288','2013-04-29','11:35:00',5.87),('11288','2013-04-29','11:40:00',6.02),('11288','2013-04-29','11:45:00',5.76),('11288','2013-04-29','11:50:00',6.47),('11288','2013-04-29','11:55:00',6.28),('11288','2013-04-29','12:00:00',6.58),('11288','2013-04-29','12:05:00',6.42),('11288','2013-04-29','12:10:00',6.33),('11288','2013-04-29','12:15:00',6.43),('11288','2013-04-29','12:20:00',6.39),('11288','2013-04-29','12:25:00',6.31),('11288','2013-04-29','12:30:00',6.54),('11288','2013-04-29','12:35:00',6.51),('11288','2013-04-29','12:40:00',6.63),('11288','2013-04-29','12:45:00',6.63),('11288','2013-04-29','12:50:00',6.52),('11288','2013-04-29','12:55:00',6.53),('11288','2013-04-29','13:00:00',6.71),('11288','2013-04-29','13:05:00',6.56),('11288','2013-04-29','13:10:00',6.36),('11288','2013-04-29','13:15:00',5.77),('11288','2013-04-29','13:20:00',6.57),('11288','2013-04-29','13:25:00',6.86),('11288','2013-04-29','13:30:00',6.56),('11288','2013-04-29','13:35:00',6.49),('11288','2013-04-29','13:40:00',6.5),('11288','2013-04-29','13:45:00',6.57),('11288','2013-04-29','13:50:00',6.35),('11288','2013-04-29','13:55:00',7.02),('11288','2013-04-29','14:00:00',6.43),('11288','2013-04-29','14:05:00',6.37),('11288','2013-04-29','14:10:00',6.53),('11288','2013-04-29','14:15:00',6.69),('11288','2013-04-29','14:20:00',6.72),('11288','2013-04-29','14:25:00',6.3),('11288','2013-04-29','14:30:00',6.08),('11288','2013-04-29','14:35:00',6.01),('11288','2013-04-29','14:40:00',5.68),('11288','2013-04-29','14:45:00',6.12),('11288','2013-04-29','14:50:00',6.01),('11288','2013-04-29','14:55:00',6.08),('11288','2013-04-29','15:00:00',5.93),('11288','2013-04-29','15:05:00',6.04),('11288','2013-04-29','15:10:00',5.35),('11288','2013-04-29','15:15:00',5.43),('11288','2013-04-29','15:20:00',5.83),('11288','2013-04-29','15:25:00',5.92),('11288','2013-04-29','15:30:00',5.73),('11288','2013-04-29','15:35:00',4.97),('11288','2013-04-29','15:40:00',4.64),('11288','2013-04-29','15:45:00',4.54),('11288','2013-04-29','15:50:00',4.78),('11288','2013-04-29','15:55:00',4.98),('11288','2013-04-29','16:00:00',4.88),('11288','2013-04-29','16:05:00',5.18),('11288','2013-04-29','16:10:00',5.02),('11288','2013-04-29','16:15:00',5.86),('11288','2013-04-29','16:20:00',5.22),('11288','2013-04-29','16:25:00',4.27),('11288','2013-04-29','16:30:00',4.36),('11288','2013-04-29','16:35:00',4.47),('11288','2013-04-29','16:40:00',4.59),('11288','2013-04-29','16:45:00',4.57),('11288','2013-04-29','16:50:00',4.7),('11288','2013-04-29','16:55:00',4.78),('11288','2013-04-29','17:00:00',4.35),('11288','2013-04-29','17:05:00',3.75),('11288','2013-04-29','17:10:00',3.89),('11288','2013-04-29','17:15:00',3.22),('11288','2013-04-29','17:20:00',2.81),('11288','2013-04-29','17:25:00',2.53),('11288','2013-04-29','17:30:00',2.51),('11288','2013-04-29','17:35:00',2.29),('11288','2013-04-29','17:40:00',1.97),('11288','2013-04-29','17:45:00',1.86),('11288','2013-04-29','17:50:00',2.26),('11288','2013-04-29','17:55:00',2.46),('11288','2013-04-29','18:00:00',2.34),('11288','2013-04-29','18:05:00',2.67),('11288','2013-04-29','18:10:00',2.46),('11288','2013-04-29','18:15:00',2.33),('11288','2013-04-29','18:20:00',2.05),('11288','2013-04-29','18:25:00',2.02),('11288','2013-04-29','18:30:00',1.73),('11288','2013-04-29','18:35:00',1.29),('11288','2013-04-29','18:40:00',1.13),('11288','2013-04-28','07:35:00',1.1),('11288','2013-04-28','07:40:00',1.21),('11288','2013-04-28','07:45:00',1.28),('11288','2013-04-28','07:50:00',1.46),('11288','2013-04-28','07:55:00',1.53),('11288','2013-04-28','08:00:00',1.59),('11288','2013-04-28','08:05:00',1.76),('11288','2013-04-28','08:10:00',1.87),('11288','2013-04-28','08:15:00',2.13),('11288','2013-04-28','08:20:00',2.26),('11288','2013-04-28','08:25:00',2.39),('11288','2013-04-28','08:30:00',2.31),('11288','2013-04-28','08:35:00',2.5),('11288','2013-04-28','08:40:00',2.79),('11288','2013-04-28','08:45:00',2.83),('11288','2013-04-28','08:50:00',2.99),('11288','2013-04-28','08:55:00',3.22),('11288','2013-04-28','09:00:00',3.46),('11288','2013-04-28','09:05:00',3.64),('11288','2013-04-28','09:10:00',3.75),('11288','2013-04-28','09:15:00',3.92),('11288','2013-04-28','09:20:00',4.06),('11288','2013-04-28','09:25:00',4.22),('11288','2013-04-28','09:30:00',4.34),('11288','2013-04-28','09:35:00',4.42),('11288','2013-04-28','09:40:00',4.46),('11288','2013-04-28','09:45:00',4.62),('11288','2013-04-28','09:50:00',4.71),('11288','2013-04-28','09:55:00',4.91),('11288','2013-04-28','10:00:00',4.96),('11288','2013-04-28','10:05:00',4.88),('11288','2013-04-28','10:10:00',5.05),('11288','2013-04-28','10:15:00',5.34),('11288','2013-04-28','10:20:00',5.41),('11288','2013-04-28','10:25:00',5.63),('11288','2013-04-28','10:30:00',5.54),('11288','2013-04-28','10:35:00',5.79),('11288','2013-04-28','10:40:00',5.34),('11288','2013-04-28','10:45:00',6.01),('11288','2013-04-28','10:50:00',6.02),('11288','2013-04-28','10:55:00',6.11),('11288','2013-04-28','11:00:00',6.17),('11288','2013-04-28','11:05:00',6.21),('11288','2013-04-28','11:10:00',6.28),('11288','2013-04-28','11:15:00',6.38),('11288','2013-04-28','11:20:00',6.29),('11288','2013-04-28','11:25:00',6.46),('11288','2013-04-28','11:30:00',6.44),('11288','2013-04-28','11:35:00',6.27),('11288','2013-04-28','11:40:00',6.41),('11288','2013-04-28','11:45:00',6.12),('11288','2013-04-28','11:50:00',6.17),('11288','2013-04-28','11:55:00',6.48),('11288','2013-04-28','12:00:00',5.69),('11288','2013-04-28','12:05:00',5.71),('11288','2013-04-28','12:10:00',6.35),('11288','2013-04-28','12:15:00',6.37),('11288','2013-04-28','12:20:00',6.41),('11288','2013-04-28','12:25:00',5.76),('11288','2013-04-28','12:30:00',5.44),('11288','2013-04-28','12:35:00',5.14),('11288','2013-04-28','12:40:00',5.18),('11288','2013-04-28','12:45:00',6.83),('11288','2013-04-28','12:50:00',6.63),('11288','2013-04-28','12:55:00',6.14),('11288','2013-04-28','13:00:00',6.37),('11288','2013-04-28','13:05:00',6.96),('11288','2013-04-28','13:10:00',6.83),('11288','2013-04-28','13:15:00',6.26),('11288','2013-04-28','13:20:00',6.52),('11288','2013-04-28','13:25:00',6.16),('11288','2013-04-28','13:30:00',5.83),('11288','2013-04-28','13:35:00',3.83),('11288','2013-04-28','13:40:00',2.84),('11288','2013-04-28','13:45:00',2.49),('11288','2013-04-28','13:50:00',2.5),('11288','2013-04-28','13:55:00',3.2),('11288','2013-04-28','14:00:00',3.52),('11288','2013-04-28','14:05:00',4.99),('11288','2013-04-28','14:10:00',6.01),('11288','2013-04-28','14:15:00',6.41),('11288','2013-04-28','14:20:00',6.36),('11288','2013-04-28','14:25:00',6.35),('11288','2013-04-28','14:30:00',6.51),('11288','2013-04-28','14:35:00',6.53),('11288','2013-04-28','14:40:00',6.43),('11288','2013-04-28','14:45:00',6.35),('11288','2013-04-28','14:50:00',6.26),('11288','2013-04-28','14:55:00',6.17),('11288','2013-04-28','15:00:00',6.14),('11288','2013-04-28','15:05:00',6.09),('11288','2013-04-28','15:10:00',6.01),('11288','2013-04-28','15:15:00',5.9),('11288','2013-04-28','15:20:00',5.82),('11288','2013-04-28','15:25:00',5.73),('11288','2013-04-28','15:30:00',5.68),('11288','2013-04-28','15:35:00',5.61),('11288','2013-04-28','15:40:00',5.52),('11288','2013-04-28','15:45:00',5.49),('11288','2013-04-28','15:50:00',5.4),('11288','2013-04-28','15:55:00',5.3),('11288','2013-04-28','16:00:00',5.18),('11288','2013-04-28','16:05:00',5.09),('11288','2013-04-28','16:10:00',4.97),('11288','2013-04-28','16:15:00',4.89),('11288','2013-04-28','16:20:00',4.74),('11288','2013-04-28','16:25:00',4.64),('11288','2013-04-28','16:30:00',4.53),('11288','2013-04-28','16:35:00',4.44),('11288','2013-04-28','16:40:00',4.26),('11288','2013-04-28','16:45:00',4.17),('11288','2013-04-28','16:50:00',4.05),('11288','2013-04-28','16:55:00',3.9),('11288','2013-04-28','17:00:00',3.79),('11288','2013-04-28','17:05:00',3.42),('11288','2013-04-28','17:10:00',3.36),('11288','2013-04-28','17:15:00',3.44),('11288','2013-04-28','17:20:00',3.24),('11288','2013-04-28','17:25:00',3.13),('11288','2013-04-28','17:30:00',2.62),('11288','2013-04-28','17:35:00',2.54),('11288','2013-04-28','17:40:00',2.47),('11288','2013-04-28','17:45:00',2.51),('11288','2013-04-28','17:50:00',2.37),('11288','2013-04-28','17:55:00',2.06),('11288','2013-04-28','18:00:00',2.05),('11288','2013-04-28','18:05:00',1.9),('11288','2013-04-28','18:10:00',1.3),('11288','2013-04-28','18:15:00',1.38),('11288','2013-04-28','18:20:00',1.66),('11288','2013-04-28','18:25:00',1.65),('11288','2013-04-28','18:30:00',1.33),('11288','2013-04-28','18:35:00',1.21),('11288','2013-04-28','18:40:00',1.12),('11288','2013-04-27','11:45:00',1.02),('11288','2013-04-27','11:50:00',1.19),('11288','2013-04-27','11:55:00',1.23),('11288','2013-04-27','12:00:00',1.32),('11288','2013-04-27','12:05:00',1.28),('11288','2013-04-27','12:10:00',1.13),('11288','2013-04-27','12:15:00',1.05),('11288','2013-04-27','12:25:00',1.01),('11288','2013-04-27','12:30:00',1.11),('11288','2013-04-27','12:35:00',1.23),('11288','2013-04-27','12:40:00',1.54),('11288','2013-04-27','12:45:00',1.64),('11288','2013-04-27','12:50:00',1.92),('11288','2013-04-27','12:55:00',2.5),('11288','2013-04-27','13:00:00',2.6),('11288','2013-04-27','13:05:00',1.96),('11288','2013-04-27','13:10:00',2.18),('11288','2013-04-27','13:15:00',2.8),('11288','2013-04-27','13:20:00',2.93),('11288','2013-04-27','13:25:00',2.09),('11288','2013-04-27','13:30:00',2.37),('11288','2013-04-27','13:35:00',2.92),('11288','2013-04-27','13:40:00',3.18),('11288','2013-04-27','13:45:00',2.22),('11288','2013-04-27','13:50:00',2.12),('11288','2013-04-27','13:55:00',1.4),('11288','2013-04-27','14:00:00',1.14),('11288','2013-04-27','14:05:00',1.21),('11288','2013-04-27','14:20:00',1.08),('11288','2013-04-27','14:25:00',2.45),('11288','2013-04-27','14:30:00',3.97),('11288','2013-04-27','14:35:00',3.17),('11288','2013-04-27','14:40:00',2.42),('11288','2013-04-27','14:45:00',2.01),('11288','2013-04-27','14:50:00',1.3),('11288','2013-04-27','14:55:00',1.67),('11288','2013-04-27','15:00:00',2.14),('11288','2013-04-27','15:05:00',3.63),('11288','2013-04-27','15:10:00',2.49),('11288','2013-04-27','15:15:00',1.81),('11288','2013-04-27','15:20:00',1.08),('11288','2013-04-27','15:50:00',1.5),('11288','2013-04-27','16:30:00',1.06),('11288','2013-04-27','16:35:00',1.19),('11288','2013-04-27','16:40:00',2),('11288','2013-04-27','16:45:00',2.52),('11288','2013-04-27','16:50:00',3.27),('11288','2013-04-27','16:55:00',3.91),('11288','2013-04-27','17:00:00',4.18),('11288','2013-04-27','17:05:00',2.49),('11288','2013-04-27','17:10:00',1.45),('11288','2013-04-27','17:15:00',1.14),('11288','2013-04-27','17:20:00',2.14),('11288','2013-04-27','17:25:00',1.12),('11288','2013-04-27','17:35:00',1.5),('11288','2013-04-27','17:40:00',2.27),('11288','2013-04-27','17:45:00',1.97),('11288','2013-04-27','17:50:00',1.06),('11288','2013-04-27','17:55:00',1.02),('11288','2013-04-27','18:00:00',1.06),('11288','2013-04-27','18:05:00',1.05),('11288','2013-04-27','18:15:00',1.01),('11288','2013-04-26','07:15:00',1),('11288','2013-04-26','07:20:00',1.08),('11288','2013-04-26','07:25:00',1.1),('11288','2013-04-26','07:30:00',1.08),('11288','2013-04-26','07:40:00',1.01),('11288','2013-04-26','07:45:00',1.02),('11288','2013-04-26','07:50:00',1.12),('11288','2013-04-26','07:55:00',1.2),('11288','2013-04-26','08:00:00',1.32),('11288','2013-04-26','08:05:00',1.62),('11288','2013-04-26','08:10:00',1.89),('11288','2013-04-26','08:15:00',2.07),('11288','2013-04-26','08:20:00',2.17),('11288','2013-04-26','08:25:00',2.31),('11288','2013-04-26','08:30:00',2.41),('11288','2013-04-26','08:35:00',2.55),('11288','2013-04-26','08:40:00',2.62),('11288','2013-04-26','08:45:00',2.77),('11288','2013-04-26','08:50:00',2.65),('11288','2013-04-26','08:55:00',2.33),('11288','2013-04-26','09:00:00',2.71),('11288','2013-04-26','09:05:00',3.23),('11288','2013-04-26','09:10:00',2.62),('11288','2013-04-26','09:15:00',2.16),('11288','2013-04-26','09:20:00',2.23),('11288','2013-04-26','09:25:00',3.44),('11288','2013-04-26','09:30:00',3.22),('11288','2013-04-26','09:35:00',2.93),('11288','2013-04-26','09:40:00',2.94),('11288','2013-04-26','09:45:00',3.85),('11288','2013-04-26','09:50:00',4.5),('11288','2013-04-26','09:55:00',2.98),('11288','2013-04-26','10:00:00',4.68),('11288','2013-04-26','10:05:00',5.1),('11288','2013-04-26','10:10:00',5.07),('11288','2013-04-26','10:15:00',5.33),('11288','2013-04-26','10:20:00',4.89),('11288','2013-04-26','10:25:00',5.24),('11288','2013-04-26','10:30:00',5.43),('11288','2013-04-26','10:35:00',5.8),('11288','2013-04-26','10:40:00',5.79),('11288','2013-04-26','10:45:00',5.68),('11288','2013-04-26','10:50:00',4.01),('11288','2013-04-26','10:55:00',3.31),('11288','2013-04-26','11:00:00',5.71),('11288','2013-04-26','11:05:00',5.88),('11288','2013-04-26','11:10:00',5.9),('11288','2013-04-26','11:15:00',4.82),('11288','2013-04-26','11:20:00',4.31),('11288','2013-04-26','11:25:00',5.52),('11288','2013-04-26','11:30:00',5.4),('11288','2013-04-26','11:35:00',6.17),('11288','2013-04-26','11:40:00',4.98),('11288','2013-04-26','11:45:00',5.9),('11288','2013-04-26','11:50:00',4.17),('11288','2013-04-26','11:55:00',4.32),('11288','2013-04-26','12:00:00',5.43),('11288','2013-04-26','12:05:00',4.45),('11288','2013-04-26','12:10:00',4.36),('11288','2013-04-26','12:15:00',4.93),('11288','2013-04-26','12:20:00',4.77),('11288','2013-04-26','12:25:00',3.13),('11288','2013-04-26','12:30:00',3.21),('11288','2013-04-26','12:35:00',4.42),('11288','2013-04-26','12:40:00',5.12),('11288','2013-04-26','12:45:00',4.71),('11288','2013-04-26','12:50:00',3.76),('11288','2013-04-26','12:55:00',3.24),('11288','2013-04-26','13:00:00',2.42),('11288','2013-04-26','13:05:00',2.4),('11288','2013-04-26','13:10:00',3.06),('11288','2013-04-26','13:15:00',4.63),('11288','2013-04-26','13:20:00',3.28),('11288','2013-04-26','13:25:00',3.86),('11288','2013-04-26','13:30:00',5.87),('11288','2013-04-26','13:35:00',4.36),('11288','2013-04-26','13:40:00',5.08),('11288','2013-04-26','13:45:00',4.28),('11288','2013-04-26','13:50:00',5.16),('11288','2013-04-26','13:55:00',5.01),('11288','2013-04-26','14:00:00',5.07),('11288','2013-04-26','14:05:00',6.07),('11288','2013-04-26','14:10:00',4.97),('11288','2013-04-26','14:15:00',5.76),('11288','2013-04-26','14:20:00',6),('11288','2013-04-26','14:25:00',6.55),('11288','2013-04-26','14:30:00',6.5),('11288','2013-04-26','14:35:00',4.36),('11288','2013-04-26','14:40:00',2.94),('11288','2013-04-26','14:45:00',2.8),('11288','2013-04-26','14:50:00',6.98),('11288','2013-04-26','14:55:00',6.82),('11288','2013-04-26','15:00:00',6.14),('11288','2013-04-26','15:05:00',3.39),('11288','2013-04-26','15:10:00',3.16),('11288','2013-04-26','15:15:00',3.28),('11288','2013-04-26','15:20:00',2.62),('11288','2013-04-26','15:25:00',3.04),('11288','2013-04-26','15:30:00',4.31),('11288','2013-04-26','15:35:00',3.39),('11288','2013-04-26','15:40:00',3.99),('11288','2013-04-26','15:45:00',4.3),('11288','2013-04-26','15:50:00',3.48),('11288','2013-04-26','15:55:00',1.92),('11288','2013-04-26','16:00:00',1.01),('11288','2013-04-26','16:35:00',1.07),('11288','2013-04-25','07:35:00',1.02),('11288','2013-04-25','07:40:00',1.06),('11288','2013-04-25','07:45:00',1.32),('11288','2013-04-25','07:50:00',1.28),('11288','2013-04-25','07:55:00',1.32),('11288','2013-04-25','08:00:00',1.52),('11288','2013-04-25','08:05:00',1.86),('11288','2013-04-25','08:10:00',1.85),('11288','2013-04-25','08:15:00',2.08),('11288','2013-04-25','08:20:00',1.77),('11288','2013-04-25','08:25:00',1.65),('11288','2013-04-25','08:30:00',1.74),('11288','2013-04-25','08:35:00',1.84),('11288','2013-04-25','08:40:00',1.99),('11288','2013-04-25','08:45:00',2.78),('11288','2013-04-25','08:50:00',3.58),('11288','2013-04-25','08:55:00',3.61),('11288','2013-04-25','09:00:00',3.11),('11288','2013-04-25','09:05:00',2.41),('11288','2013-04-25','09:10:00',2.47),('11288','2013-04-25','09:15:00',2.24),('11288','2013-04-25','09:20:00',2.49),('11288','2013-04-25','09:25:00',2.57),('11288','2013-04-25','09:30:00',2.45),('11288','2013-04-25','09:35:00',2.75),('11288','2013-04-25','09:40:00',3.63),('11288','2013-04-25','09:45:00',4.68),('11288','2013-04-25','09:50:00',5),('11288','2013-04-25','09:55:00',5.04),('11288','2013-04-25','10:00:00',5.09),('11288','2013-04-25','10:05:00',4.84),('11288','2013-04-25','10:10:00',4.49),('11288','2013-04-25','10:15:00',4.96),('11288','2013-04-25','10:20:00',5.31),('11288','2013-04-25','10:25:00',5.57),('11288','2013-04-25','10:30:00',5.8),('11288','2013-04-25','10:35:00',5.86),('11288','2013-04-25','10:40:00',5.9),('11288','2013-04-25','10:45:00',5.81),('11288','2013-04-25','10:50:00',5.83),('11288','2013-04-25','10:55:00',5.94),('11288','2013-04-25','11:00:00',6.21),('11288','2013-04-25','11:05:00',6.28),('11288','2013-04-25','11:10:00',6.34),('11288','2013-04-25','11:15:00',6.39),('11288','2013-04-25','11:20:00',6.45),('11288','2013-04-25','11:25:00',6.48),('11288','2013-04-25','11:30:00',6.48),('11288','2013-04-25','11:35:00',6.44),('11288','2013-04-25','11:40:00',6.63),('11288','2013-04-25','11:45:00',6.69),('11288','2013-04-25','11:50:00',6.68),('11288','2013-04-25','11:55:00',6.64),('11288','2013-04-25','12:00:00',6.54),('11288','2013-04-25','12:05:00',6.57),('11288','2013-04-25','12:10:00',6.73),('11288','2013-04-25','12:15:00',6.82),('11288','2013-04-25','12:20:00',6.8),('11288','2013-04-25','12:25:00',6.76),('11288','2013-04-25','12:30:00',6.85),('11288','2013-04-25','12:35:00',6.88),('11288','2013-04-25','12:40:00',6.9),('11288','2013-04-25','12:45:00',6.89),('11288','2013-04-25','12:50:00',6.84),('11288','2013-04-25','12:55:00',6.87),('11288','2013-04-25','13:00:00',6.93),('11288','2013-04-25','13:05:00',7.02),('11288','2013-04-25','13:10:00',6.96),('11288','2013-04-25','13:15:00',6.66),('11288','2013-04-25','13:20:00',6.13),('11288','2013-04-25','13:25:00',5.61),('11288','2013-04-25','13:30:00',4.46),('11288','2013-04-25','13:35:00',4.43),('11288','2013-04-25','13:40:00',4.12),('11288','2013-04-25','13:45:00',3.9),('11288','2013-04-25','13:50:00',3.78),('11288','2013-04-25','13:55:00',4.15),('11288','2013-04-25','14:00:00',4.1),('11288','2013-04-25','14:05:00',3.89),('11288','2013-04-25','14:10:00',4.15),('11288','2013-04-25','14:15:00',4.42),('11288','2013-04-25','14:20:00',4.46),('11288','2013-04-25','14:25:00',4.63),('11288','2013-04-25','14:30:00',5.52),('11288','2013-04-25','14:35:00',6.06),('11288','2013-04-25','14:40:00',5.94),('11288','2013-04-25','14:45:00',5.77),('11288','2013-04-25','14:50:00',5.45),('11288','2013-04-25','14:55:00',5.55),('11288','2013-04-25','15:00:00',5.29),('11288','2013-04-25','15:05:00',4.78),('11288','2013-04-25','15:10:00',4.93),('11288','2013-04-25','15:15:00',5.5),('11288','2013-04-25','15:20:00',5.87),('11288','2013-04-25','15:25:00',5.99),('11288','2013-04-25','15:30:00',5.81),('11288','2013-04-25','15:35:00',5.53),('11288','2013-04-25','15:40:00',5.06),('11288','2013-04-25','15:45:00',4.95),('11288','2013-04-25','15:50:00',4.53),('11288','2013-04-25','15:55:00',4.51),('11288','2013-04-25','16:00:00',4.36),('11288','2013-04-25','16:05:00',3.73),('11288','2013-04-25','16:10:00',3.89),('11288','2013-04-25','16:15:00',3.73),('11288','2013-04-25','16:20:00',3.95),('11288','2013-04-25','16:25:00',3.37),('11288','2013-04-25','16:30:00',3.39),('11288','2013-04-25','16:35:00',4.03),('11288','2013-04-25','16:40:00',3.57),('11288','2013-04-25','16:45:00',3.49),('11288','2013-04-25','16:50:00',3.04),('11288','2013-04-25','16:55:00',3.28),('11288','2013-04-25','17:00:00',3.08),('11288','2013-04-25','17:05:00',3.87),('11288','2013-04-25','17:10:00',3.98),('11288','2013-04-25','17:15:00',3.58),('11288','2013-04-25','17:20:00',3.56),('11288','2013-04-25','17:25:00',2.92),('11288','2013-04-25','17:30:00',2.35),('11288','2013-04-25','17:35:00',2.34),('11288','2013-04-25','17:40:00',2.33),('11288','2013-04-25','17:45:00',2.01),('11288','2013-04-25','17:50:00',1.71),('11288','2013-04-25','17:55:00',1.53),('11288','2013-04-25','18:00:00',1.48),('11288','2013-04-25','18:05:00',1.41),('11288','2013-04-25','18:10:00',1.31),('11288','2013-04-25','18:15:00',1.2),('11288','2013-04-25','18:20:00',1.09),('11288','2013-04-24','07:40:00',1),('11288','2013-04-24','07:45:00',1.05),('11288','2013-04-24','07:50:00',1.35),('11288','2013-04-24','07:55:00',1.47),('11288','2013-04-24','08:00:00',1.54),('11288','2013-04-24','08:05:00',1.65),('11288','2013-04-24','08:10:00',1.89),('11288','2013-04-24','08:15:00',2.08),('11288','2013-04-24','08:20:00',2.22),('11288','2013-04-24','08:25:00',2.31),('11288','2013-04-24','08:30:00',2.37),('11288','2013-04-24','08:35:00',2.4),('11288','2013-04-24','08:40:00',2.36),('11288','2013-04-24','08:45:00',2.53),('11288','2013-04-24','08:50:00',2.82),('11288','2013-04-24','08:55:00',2.92),('11288','2013-04-24','09:00:00',3.3),('11288','2013-04-24','09:05:00',3.72),('11288','2013-04-24','09:10:00',4),('11288','2013-04-24','09:15:00',3.54),('11288','2013-04-24','09:20:00',3.29),('11288','2013-04-24','09:25:00',4.46),('11288','2013-04-24','09:30:00',4.47),('11288','2013-04-24','09:35:00',4.81),('11288','2013-04-24','09:40:00',4.52),('11288','2013-04-24','09:45:00',4.51),('11288','2013-04-24','09:50:00',4.64),('11288','2013-04-24','09:55:00',4.93),('11288','2013-04-24','10:00:00',5.15),('11288','2013-04-24','10:05:00',5.41),('11288','2013-04-24','10:10:00',5.41),('11288','2013-04-24','10:15:00',5.46),('11288','2013-04-24','10:20:00',5.47),('11288','2013-04-24','10:25:00',5.46),('11288','2013-04-24','10:30:00',5.44),('11288','2013-04-24','10:35:00',5.57),('11288','2013-04-24','10:40:00',6.13),('11288','2013-04-24','10:45:00',6.14),('11288','2013-04-24','10:50:00',6.23),('11288','2013-04-24','10:55:00',6.4),('11288','2013-04-24','11:00:00',6.34),('11288','2013-04-24','11:05:00',6.29),('11288','2013-04-24','11:10:00',6.81),('11288','2013-04-24','11:15:00',6.8),('11288','2013-04-24','11:20:00',7.03),('11288','2013-04-24','11:25:00',7.04),('11288','2013-04-24','11:30:00',6.73),('11288','2013-04-24','11:35:00',6.36),('11288','2013-04-24','11:40:00',4.9),('11288','2013-04-24','11:45:00',4.44),('11288','2013-04-24','11:50:00',3.74),('11288','2013-04-24','11:55:00',5.66),('11288','2013-04-24','12:00:00',5.64),('11288','2013-04-24','12:05:00',4.1),('11288','2013-04-24','12:10:00',5.32),('11288','2013-04-24','12:15:00',7.02),('11288','2013-04-24','12:20:00',7.78),('11288','2013-04-24','12:25:00',6.58),('11288','2013-04-24','12:30:00',6.67),('11288','2013-04-24','12:35:00',6.9),('11288','2013-04-24','12:40:00',6.65),('11288','2013-04-24','12:45:00',6.67),('11288','2013-04-24','12:50:00',7.02),('11288','2013-04-24','12:55:00',6.89),('11288','2013-04-24','13:00:00',6.66),('11288','2013-04-24','13:05:00',6.06),('11288','2013-04-24','13:10:00',7.53),('11288','2013-04-24','13:15:00',7.14),('11288','2013-04-24','13:20:00',6.64),('11288','2013-04-24','13:25:00',7.08),('11288','2013-04-24','13:30:00',6.18),('11288','2013-04-24','13:35:00',6.94),('11288','2013-04-24','13:40:00',7.63),('11288','2013-04-24','13:45:00',6.31),('11288','2013-04-24','13:50:00',5.01),('11288','2013-04-24','13:55:00',7.26),('11288','2013-04-24','14:00:00',7.01),('11288','2013-04-24','14:05:00',5.03),('11288','2013-04-24','14:10:00',5.44),('11288','2013-04-24','14:15:00',7.1),('11288','2013-04-24','14:20:00',6.5),('11288','2013-04-24','14:25:00',6.67),('11288','2013-04-24','14:30:00',6.12),('11288','2013-04-24','14:35:00',5.74),('11288','2013-04-24','14:40:00',5.41),('11288','2013-04-24','14:45:00',5.32),('11288','2013-04-24','14:50:00',4.74),('11288','2013-04-24','14:55:00',4.18),('11288','2013-04-24','15:00:00',4.52),('11288','2013-04-24','15:05:00',4.17),('11288','2013-04-24','15:10:00',3.87),('11288','2013-04-24','15:15:00',4.13),('11288','2013-04-24','15:20:00',4.49),('11288','2013-04-24','15:25:00',3.66),('11288','2013-04-24','15:30:00',3.2),('11288','2013-04-24','15:35:00',3.11),('11288','2013-04-24','15:40:00',3.07),('11288','2013-04-24','15:45:00',3.08),('11288','2013-04-24','15:50:00',3.13),('11288','2013-04-24','15:55:00',4.08),('11288','2013-04-24','16:00:00',4.81),('11288','2013-04-24','16:05:00',4.9),('11288','2013-04-24','16:10:00',4.77),('11288','2013-04-24','16:15:00',4.55),('11288','2013-04-24','16:20:00',5.5),('11288','2013-04-24','16:25:00',4.28),('11288','2013-04-24','16:30:00',3.62),('11288','2013-04-24','16:35:00',3.42),('11288','2013-04-24','16:40:00',4.34),('11288','2013-04-24','16:45:00',4.42),('11288','2013-04-24','16:50:00',4.05),('11288','2013-04-24','16:55:00',4.69),('11288','2013-04-24','17:00:00',4.68),('11288','2013-04-24','17:05:00',4.4),('11288','2013-04-24','17:10:00',4.08),('11288','2013-04-24','17:15:00',2.92),('11288','2013-04-24','17:20:00',3.13),('11288','2013-04-24','17:25:00',2.5),('11288','2013-04-24','17:30:00',1.75),('11288','2013-04-24','17:35:00',1.33),('11288','2013-04-24','17:40:00',1.26),('11288','2013-04-24','17:45:00',1.62),('11288','2013-04-24','17:50:00',1.84),('11288','2013-04-24','17:55:00',2.3),('11288','2013-04-24','18:00:00',1.83),('11288','2013-04-24','18:05:00',1.9),('11288','2013-04-24','18:10:00',1.5),('11288','2013-04-24','18:15:00',1.21),('11288','2013-04-24','18:20:00',1.61),('11288','2013-04-24','18:25:00',1.52),('11288','2013-04-24','18:30:00',1.08),('11288','2013-04-23','07:35:00',1.01),('11288','2013-04-23','07:40:00',1.02),('11288','2013-04-23','07:45:00',1.19),('11288','2013-04-23','07:50:00',1.29),('11288','2013-04-23','07:55:00',1.37),('11288','2013-04-23','08:00:00',1.54),('11288','2013-04-23','08:05:00',1.64),('11288','2013-04-23','08:10:00',1.83),('11288','2013-04-23','08:15:00',1.97),('11288','2013-04-23','08:20:00',2.05),('11288','2013-04-23','08:25:00',2.09),('11288','2013-04-23','08:30:00',2.48),('11288','2013-04-23','08:35:00',2.46),('11288','2013-04-23','08:40:00',2.29),('11288','2013-04-23','08:45:00',2.86),('11288','2013-04-23','08:50:00',3.1),('11288','2013-04-23','08:55:00',3.21),('11288','2013-04-23','09:00:00',3.46),('11288','2013-04-23','09:05:00',3.66),('11288','2013-04-23','09:10:00',3.81),('11288','2013-04-23','09:15:00',4.04),('11288','2013-04-23','09:20:00',4.2),('11288','2013-04-23','09:25:00',4.29),('11288','2013-04-23','09:30:00',4.37),('11288','2013-04-23','09:35:00',4.52),('11288','2013-04-23','09:40:00',4.19),('11288','2013-04-23','09:45:00',4.32),('11288','2013-04-23','09:50:00',4.8),('11288','2013-04-23','09:55:00',4.77),('11288','2013-04-23','10:00:00',4.99),('11288','2013-04-23','10:05:00',5.39),('11288','2013-04-23','10:10:00',5.52),('11288','2013-04-23','10:15:00',5.64),('11288','2013-04-23','10:20:00',5.78),('11288','2013-04-23','10:25:00',5.92),('11288','2013-04-23','10:30:00',5.98),('11288','2013-04-23','10:35:00',6.12),('11288','2013-04-23','10:40:00',6.26),('11288','2013-04-23','10:45:00',6.16),('11288','2013-04-23','10:50:00',6.4),('11288','2013-04-23','10:55:00',6.47),('11288','2013-04-23','11:00:00',6.5),('11288','2013-04-23','11:05:00',6.51),('11288','2013-04-23','11:10:00',6.57),('11288','2013-04-23','11:15:00',6.61),('11288','2013-04-23','11:20:00',6.65),('11288','2013-04-23','11:25:00',6.67),('11288','2013-04-23','11:30:00',6.63),('11288','2013-04-23','11:35:00',6.68),('11288','2013-04-23','11:40:00',6.72),('11288','2013-04-23','11:45:00',6.77),('11288','2013-04-23','11:50:00',6.81),('11288','2013-04-23','11:55:00',6.87),('11288','2013-04-23','12:00:00',6.88),('11288','2013-04-23','12:05:00',6.91),('11288','2013-04-23','12:10:00',6.95),('11288','2013-04-23','12:15:00',6.95),('11288','2013-04-23','12:20:00',7.01),('11288','2013-04-23','12:25:00',7.11),('11288','2013-04-23','12:30:00',7.38),('11288','2013-04-23','12:35:00',7.7),('11288','2013-04-23','12:40:00',7.23),('11288','2013-04-23','12:45:00',6.09),('11288','2013-04-23','12:50:00',2.49),('11288','2013-04-23','12:55:00',7.02),('11288','2013-04-23','13:00:00',7.12);
INSERT INTO `solarlogmod` VALUES ('11288','2013-04-23','13:05:00',7.62),('11288','2013-04-23','13:10:00',5.39),('11288','2013-04-23','13:15:00',8.35),('11288','2013-04-23','13:20:00',7),('11288','2013-04-23','13:25:00',7.52),('11288','2013-04-23','13:30:00',7.29),('11288','2013-04-23','13:35:00',7.53),('11288','2013-04-23','13:40:00',7.36),('11288','2013-04-23','13:45:00',5.17),('11288','2013-04-23','13:50:00',6.87),('11288','2013-04-23','13:55:00',7.29),('11288','2013-04-23','14:00:00',6.41),('11288','2013-04-23','14:05:00',7.52),('11288','2013-04-23','14:10:00',6.82),('11288','2013-04-23','14:15:00',6.64),('11288','2013-04-23','14:20:00',6.42),('11288','2013-04-23','14:25:00',6.08),('11288','2013-04-23','14:30:00',6.96),('11288','2013-04-23','14:35:00',6.74),('11288','2013-04-23','14:40:00',6.89),('11288','2013-04-23','14:45:00',5.75),('11288','2013-04-23','14:50:00',3.66),('11288','2013-04-23','14:55:00',4.04),('11288','2013-04-23','15:00:00',4.26),('11288','2013-04-23','15:05:00',4.55),('11288','2013-04-23','15:10:00',5.46),('11288','2013-04-23','15:15:00',5.23),('11288','2013-04-23','15:20:00',4.82),('11288','2013-04-23','15:25:00',4.37),('11288','2013-04-23','15:30:00',4.29),('11288','2013-04-23','15:35:00',4.09),('11288','2013-04-23','15:40:00',3.79),('11288','2013-04-23','15:45:00',4.65),('11288','2013-04-23','15:50:00',3.46),('11288','2013-04-23','15:55:00',3.38),('11288','2013-04-23','16:00:00',4.37),('11288','2013-04-23','16:05:00',4.41),('11288','2013-04-23','16:10:00',4.29),('11288','2013-04-23','16:15:00',3.65),('11288','2013-04-23','16:20:00',2.42),('11288','2013-04-23','16:25:00',2.45),('11288','2013-04-23','16:30:00',2.13),('11288','2013-04-23','16:35:00',2.04),('11288','2013-04-23','16:40:00',2.03),('11288','2013-04-23','16:45:00',2.05),('11288','2013-04-23','16:50:00',1.82),('11288','2013-04-23','16:55:00',1.9),('11288','2013-04-23','17:00:00',2.02),('11288','2013-04-23','17:05:00',2.13),('11288','2013-04-23','17:10:00',2.85),('11288','2013-04-23','17:15:00',2.13),('11288','2013-04-23','17:20:00',1.74),('11288','2013-04-23','17:25:00',2.84),('11288','2013-04-23','17:30:00',2.4),('11288','2013-04-23','17:35:00',1.8),('11288','2013-04-23','17:40:00',1.49),('11288','2013-04-23','17:45:00',1.48),('11288','2013-04-23','17:50:00',1.19),('11288','2013-04-23','17:55:00',1),('11288','2013-04-23','18:00:00',1.06),('11288','2013-04-23','18:05:00',1.05),('11288','2013-04-22','08:45:00',1.1),('11288','2013-04-22','09:00:00',1.46),('11288','2013-04-22','09:05:00',1.4),('11288','2013-04-22','09:10:00',1.51),('11288','2013-04-22','09:15:00',1.31),('11288','2013-04-22','09:20:00',1.29),('11288','2013-04-22','09:25:00',1.58),('11288','2013-04-22','09:30:00',2.15),('11288','2013-04-22','09:35:00',1.86),('11288','2013-04-22','09:40:00',1.51),('11288','2013-04-22','09:45:00',1.12),('11288','2013-04-22','10:30:00',1.06),('11288','2013-04-22','10:35:00',3.79),('11288','2013-04-22','10:40:00',6.3),('11288','2013-04-22','10:45:00',7.49),('11288','2013-04-22','10:50:00',4.52),('11288','2013-04-22','10:55:00',4.29),('11288','2013-04-22','11:00:00',3.59),('11288','2013-04-22','11:05:00',3.22),('11288','2013-04-22','11:10:00',3.96),('11288','2013-04-22','11:15:00',2.49),('11288','2013-04-22','11:20:00',2.75),('11288','2013-04-22','11:25:00',3.38),('11288','2013-04-22','11:30:00',5.19),('11288','2013-04-22','11:35:00',7.54),('11288','2013-04-22','11:40:00',5.56),('11288','2013-04-22','11:45:00',4.09),('11288','2013-04-22','11:50:00',3.17),('11288','2013-04-22','11:55:00',6.54),('11288','2013-04-22','12:00:00',6.26),('11288','2013-04-22','12:05:00',5.79),('11288','2013-04-22','12:10:00',4.15),('11288','2013-04-22','12:15:00',4.02),('11288','2013-04-22','12:20:00',3.49),('11288','2013-04-22','12:25:00',3.1),('11288','2013-04-22','12:30:00',3.43),('11288','2013-04-22','12:35:00',3.79),('11288','2013-04-22','12:40:00',6.43),('11288','2013-04-22','12:45:00',5.92),('11288','2013-04-22','12:50:00',7.97),('11288','2013-04-22','12:55:00',7.88),('11288','2013-04-22','13:00:00',6.42),('11288','2013-04-22','13:05:00',6.96),('11288','2013-04-22','13:10:00',4.77),('11288','2013-04-22','13:15:00',6.38),('11288','2013-04-22','13:20:00',7.24),('11288','2013-04-22','13:25:00',3.79),('11288','2013-04-22','13:30:00',2.9),('11288','2013-04-22','13:35:00',3.44),('11288','2013-04-22','13:40:00',3.72),('11288','2013-04-22','13:45:00',2.58),('11288','2013-04-22','13:50:00',2.19),('11288','2013-04-22','13:55:00',4.05),('11288','2013-04-22','14:00:00',2.14),('11288','2013-04-22','14:05:00',3.83),('11288','2013-04-22','14:10:00',5.33),('11288','2013-04-22','14:15:00',7.86),('11288','2013-04-22','14:20:00',8.14),('11288','2013-04-22','14:25:00',5.77),('11288','2013-04-22','14:30:00',3.28),('11288','2013-04-22','14:35:00',6.28),('11288','2013-04-22','14:40:00',7.78),('11288','2013-04-22','14:45:00',7.1),('11288','2013-04-22','14:50:00',7.52),('11288','2013-04-22','14:55:00',5.21),('11288','2013-04-22','15:00:00',1.82),('11288','2013-04-22','15:05:00',2.73),('11288','2013-04-22','15:10:00',2.27),('11288','2013-04-22','15:15:00',2.04),('11288','2013-04-22','15:20:00',4.76),('11288','2013-04-22','15:25:00',6.15),('11288','2013-04-22','15:30:00',2.5),('11288','2013-04-22','15:35:00',4.97),('11288','2013-04-22','15:40:00',6.22),('11288','2013-04-22','15:45:00',7.28),('11288','2013-04-22','15:50:00',3.62),('11288','2013-04-22','15:55:00',2.02),('11288','2013-04-22','16:00:00',1.3),('11288','2013-04-22','16:05:00',1.38),('11288','2013-04-22','16:10:00',1.37),('11288','2013-04-22','16:15:00',1.28),('11288','2013-04-22','16:20:00',1.15),('11288','2013-04-22','16:35:00',1.17),('11288','2013-04-22','16:40:00',1.51),('11288','2013-04-22','16:45:00',1.93),('11288','2013-04-22','16:50:00',1.94),('11288','2013-04-22','16:55:00',1.11),('11288','2013-04-22','17:00:00',1.04),('11288','2013-04-22','17:05:00',1.04),('11288','2013-04-22','17:10:00',1.16),('11288','2013-04-22','17:25:00',1.23),('11288','2013-04-22','17:30:00',1.54),('11288','2013-04-22','17:35:00',1.64),('11288','2013-04-22','17:40:00',1.3),('11288','2013-04-22','18:05:00',1.02),('11288','2013-04-22','18:20:00',1.04),('11288','2013-04-22','18:25:00',1.15),('11288','2013-04-22','18:50:00',1.02),('11288','2014-03-29','07:15:00',1.03),('11288','2014-03-29','07:20:00',1.13),('11288','2014-03-29','07:25:00',1.2),('11288','2014-03-29','07:30:00',1.34),('11288','2014-03-29','07:35:00',1.44),('11288','2014-03-29','07:40:00',1.65),('11288','2014-03-29','07:45:00',1.75),('11288','2014-03-29','07:50:00',1.84),('11288','2014-03-29','07:55:00',2.1),('11288','2014-03-29','08:00:00',2.16),('11288','2014-03-29','08:05:00',2.23),('11288','2014-03-29','08:10:00',2.47),('11288','2014-03-29','08:15:00',2.6),('11288','2014-03-29','08:20:00',2.75),('11288','2014-03-29','08:25:00',2.93),('11288','2014-03-29','08:30:00',3.03),('11288','2014-03-29','08:35:00',3.17),('11288','2014-03-29','08:40:00',3.42),('11288','2014-03-29','08:45:00',3.52),('11288','2014-03-29','08:50:00',3.71),('11288','2014-03-29','08:55:00',3.9),('11288','2014-03-29','09:00:00',3.97),('11288','2014-03-29','09:05:00',4.12),('11288','2014-03-29','09:10:00',4.32),('11288','2014-03-29','09:15:00',4.46),('11288','2014-03-29','09:20:00',4.6),('11288','2014-03-29','09:25:00',4.77),('11288','2014-03-29','09:30:00',4.87),('11288','2014-03-29','09:35:00',4.96),('11288','2014-03-29','09:40:00',5.04),('11288','2014-03-29','09:45:00',5.09),('11288','2014-03-29','09:50:00',5.18),('11288','2014-03-29','09:55:00',5.28),('11288','2014-03-29','10:00:00',5.36),('11288','2014-03-29','10:05:00',5.46),('11288','2014-03-29','10:10:00',5.56),('11288','2014-03-29','10:15:00',5.68),('11288','2014-03-29','10:20:00',5.7),('11288','2014-03-29','10:25:00',5.78),('11288','2014-03-29','10:30:00',5.84),('11288','2014-03-29','10:35:00',5.86),('11288','2014-03-29','10:40:00',5.94),('11288','2014-03-29','10:45:00',5.94),('11288','2014-03-29','10:50:00',6.07),('11288','2014-03-29','10:55:00',6.12),('11288','2014-03-29','11:00:00',6.17),('11288','2014-03-29','11:05:00',6.23),('11288','2014-03-29','11:10:00',6.3),('11288','2014-03-29','11:15:00',6.42),('11288','2014-03-29','11:20:00',6.44),('11288','2014-03-29','11:25:00',6.45),('11288','2014-03-29','11:30:00',6.45),('11288','2014-03-29','11:35:00',6.44),('11288','2014-03-29','11:40:00',6.23),('11288','2014-03-29','11:45:00',6.55),('11288','2014-03-29','11:50:00',6.54),('11288','2014-03-29','11:55:00',6.49),('11288','2014-03-29','12:00:00',6.49),('11288','2014-03-29','12:05:00',6.54),('11288','2014-03-29','12:10:00',6.51),('11288','2014-03-29','12:15:00',6.52),('11288','2014-03-29','12:20:00',6.55),('11288','2014-03-29','12:25:00',6.54),('11288','2014-03-29','12:30:00',6.56),('11288','2014-03-29','12:35:00',6.51),('11288','2014-03-29','12:40:00',6.45),('11288','2014-03-29','12:45:00',6.45),('11288','2014-03-29','12:50:00',6.42),('11288','2014-03-29','12:55:00',6.34),('11288','2014-03-29','13:00:00',6.26),('11288','2014-03-29','13:05:00',6.34),('11288','2014-03-29','13:10:00',6.26),('11288','2014-03-29','13:15:00',6.23),('11288','2014-03-29','13:20:00',6.21),('11288','2014-03-29','13:25:00',6.07),('11288','2014-03-29','13:30:00',6.07),('11288','2014-03-29','13:35:00',5.96),('11288','2014-03-29','13:40:00',5.92),('11288','2014-03-29','13:45:00',5.86),('11288','2014-03-29','13:50:00',5.76),('11288','2014-03-29','13:55:00',5.73),('11288','2014-03-29','14:00:00',5.7),('11288','2014-03-29','14:05:00',5.61),('11288','2014-03-29','14:10:00',5.55),('11288','2014-03-29','14:15:00',5.47),('11288','2014-03-29','14:20:00',5.38),('11288','2014-03-29','14:25:00',4.79),('11288','2014-03-29','14:30:00',5.18),('11288','2014-03-29','14:35:00',4.9),('11288','2014-03-29','14:40:00',4.35),('11288','2014-03-29','14:45:00',4.87),('11288','2014-03-29','14:50:00',4.87),('11288','2014-03-29','14:55:00',4.79),('11288','2014-03-29','15:00:00',4.74),('11288','2014-03-29','15:05:00',4.55),('11288','2014-03-29','15:10:00',4.38),('11288','2014-03-29','15:15:00',4.32),('11288','2014-03-29','15:20:00',4.24),('11288','2014-03-29','15:25:00',4),('11288','2014-03-29','15:30:00',3.76),('11288','2014-03-29','15:35:00',3.66),('11288','2014-03-29','15:40:00',3.59),('11288','2014-03-29','15:45:00',3.49),('11288','2014-03-29','15:50:00',3.34),('11288','2014-03-29','15:55:00',3.2),('11288','2014-03-29','16:00:00',3.09),('11288','2014-03-29','16:05:00',2.93),('11288','2014-03-29','16:10:00',2.73),('11288','2014-03-29','16:15:00',2.63),('11288','2014-03-29','16:20:00',2.37),('11288','2014-03-29','16:25:00',2.35),('11288','2014-03-29','16:30:00',2.22),('11288','2014-03-29','16:35:00',1.98),('11288','2014-03-29','16:40:00',1.71),('11288','2014-03-29','16:45:00',1.37),('11288','2014-03-29','16:50:00',1.48),('11288','2014-03-29','16:55:00',1.52),('11288','2014-03-29','17:00:00',1.4),('11288','2014-03-29','17:05:00',1.25),('11288','2014-03-29','17:10:00',1.14),('11288','2014-03-29','17:15:00',1),('11288','2013-04-21','07:55:00',1.26),('11288','2013-04-21','08:00:00',1.41),('11288','2013-04-21','08:05:00',1.59),('11288','2013-04-21','08:10:00',1.76),('11288','2013-04-21','08:15:00',1.91),('11288','2013-04-21','08:20:00',1.84),('11288','2013-04-21','08:25:00',2.37),('11288','2013-04-21','08:30:00',2.64),('11288','2013-04-21','08:35:00',2.52),('11288','2013-04-21','08:40:00',2.06),('11288','2013-04-21','08:45:00',1.81),('11288','2013-04-21','08:50:00',2.05),('11288','2013-04-21','08:55:00',2.9),('11288','2013-04-21','09:00:00',3.16),('11288','2013-04-21','09:05:00',4.03),('11288','2013-04-21','09:10:00',3.17),('11288','2013-04-21','09:15:00',2.66),('11288','2013-04-21','09:20:00',2.43),('11288','2013-04-21','09:25:00',3.71),('11288','2013-04-21','09:30:00',4.53),('11288','2013-04-21','09:35:00',4.6),('11288','2013-04-21','09:40:00',4.71),('11288','2013-04-21','09:45:00',5.13),('11288','2013-04-21','09:50:00',5.25),('11288','2013-04-21','09:55:00',6.23),('11288','2013-04-21','10:00:00',3.91),('11288','2013-04-21','10:05:00',3.43),('11288','2013-04-21','10:10:00',2.94),('11288','2013-04-21','10:15:00',2.96),('11288','2013-04-21','10:20:00',6.41),('11288','2013-04-21','10:25:00',3.99),('11288','2013-04-21','10:30:00',3.41),('11288','2013-04-21','10:35:00',3.07),('11288','2013-04-21','10:40:00',4.03),('11288','2013-04-21','10:45:00',4.36),('11288','2013-04-21','10:50:00',3.9),('11288','2013-04-21','10:55:00',3.69),('11288','2013-04-21','11:00:00',6.8),('11288','2013-04-21','11:05:00',4.85),('11288','2013-04-21','11:10:00',5.76),('11288','2013-04-21','11:15:00',5.06),('11288','2013-04-21','11:20:00',5.25),('11288','2013-04-21','11:25:00',4.49),('11288','2013-04-21','11:30:00',4.37),('11288','2013-04-21','11:35:00',4.36),('11288','2013-04-21','11:40:00',4.88),('11288','2013-04-21','11:45:00',5.99),('11288','2013-04-21','11:50:00',4.75),('11288','2013-04-21','11:55:00',5.64),('11288','2013-04-21','12:00:00',3.99),('11288','2013-04-21','12:05:00',4.12),('11288','2013-04-21','12:10:00',3.85),('11288','2013-04-21','12:15:00',3.66),('11288','2013-04-21','12:20:00',3.31),('11288','2013-04-21','12:25:00',3.3),('11288','2013-04-21','12:30:00',3.56),('11288','2013-04-21','12:35:00',3.65),('11288','2013-04-21','12:40:00',3.65),('11288','2013-04-21','12:45:00',3.69),('11288','2013-04-21','12:50:00',3.52),('11288','2013-04-21','12:55:00',3.4),('11288','2013-04-21','13:00:00',3.98),('11288','2013-04-21','13:05:00',4.49),('11288','2013-04-21','13:10:00',4.37),('11288','2013-04-21','13:15:00',4.03),('11288','2013-04-21','13:20:00',3.82),('11288','2013-04-21','13:25:00',3.83),('11288','2013-04-21','13:30:00',5.65),('11288','2013-04-21','13:35:00',6.84),('11288','2013-04-21','13:40:00',5.12),('11288','2013-04-21','13:45:00',5.71),('11288','2013-04-21','13:50:00',5.15),('11288','2013-04-21','13:55:00',6.35),('11288','2013-04-21','14:00:00',6.81),('11288','2013-04-21','14:05:00',7.63),('11288','2013-04-21','14:10:00',6.69),('11288','2013-04-21','14:15:00',6.97),('11288','2013-04-21','14:20:00',7.42),('11288','2013-04-21','14:25:00',6.94),('11288','2013-04-21','14:30:00',6.29),('11288','2013-04-21','14:35:00',7.25),('11288','2013-04-21','14:40:00',7.11),('11288','2013-04-21','14:45:00',5.42),('11288','2013-04-21','14:50:00',3.61),('11288','2013-04-21','14:55:00',3.59),('11288','2013-04-21','15:00:00',3.46),('11288','2013-04-21','15:05:00',5.72),('11288','2013-04-21','15:10:00',6.56),('11288','2013-04-21','15:15:00',4.01),('11288','2013-04-21','15:20:00',2.87),('11288','2013-04-21','15:25:00',3.13),('11288','2013-04-21','15:30:00',2.83),('11288','2013-04-21','15:35:00',2.48),('11288','2013-04-21','15:40:00',2.58),('11288','2013-04-21','15:45:00',2.1),('11288','2013-04-21','15:50:00',1.72),('11288','2013-04-21','15:55:00',1.49),('11288','2013-04-21','16:00:00',1.34),('11288','2013-04-21','16:05:00',1.19),('11288','2013-04-21','16:10:00',1.21),('11288','2013-04-21','16:15:00',1.17),('11288','2013-04-21','16:55:00',1.16),('11288','2013-04-21','17:00:00',1.42),('11288','2013-04-21','17:05:00',1.37),('11288','2013-04-21','17:10:00',1.23),('11288','2013-04-21','17:15:00',1.24),('11288','2013-04-21','17:20:00',1.07),('11288','2013-04-20','07:30:00',1.18),('11288','2013-04-20','07:35:00',1.37),('11288','2013-04-20','07:40:00',1.48),('11288','2013-04-20','07:45:00',1.18),('11288','2013-04-20','07:50:00',1.26),('11288','2013-04-20','07:55:00',1.47),('11288','2013-04-20','08:00:00',1.7),('11288','2013-04-20','08:05:00',1.81),('11288','2013-04-20','08:10:00',1.83),('11288','2013-04-20','08:15:00',1.65),('11288','2013-04-20','08:20:00',1.66),('11288','2013-04-20','08:25:00',1.81),('11288','2013-04-20','08:30:00',1.99),('11288','2013-04-20','08:35:00',2.16),('11288','2013-04-20','08:40:00',2.48),('11288','2013-04-20','08:45:00',2.67),('11288','2013-04-20','08:50:00',2.66),('11288','2013-04-20','08:55:00',3.04),('11288','2013-04-20','09:00:00',3.32),('11288','2013-04-20','09:05:00',3.44),('11288','2013-04-20','09:10:00',3.14),('11288','2013-04-20','09:15:00',3.68),('11288','2013-04-20','09:20:00',4.19),('11288','2013-04-20','09:25:00',3.67),('11288','2013-04-20','09:30:00',3.64),('11288','2013-04-20','09:35:00',2.61),('11288','2013-04-20','09:40:00',1.59),('11288','2013-04-20','09:45:00',1.97),('11288','2013-04-20','09:50:00',1.63),('11288','2013-04-20','09:55:00',1.17),('11288','2013-04-20','10:30:00',1.17),('11288','2013-04-20','10:35:00',1.78),('11288','2013-04-20','10:40:00',2.64),('11288','2013-04-20','10:45:00',5.86),('11288','2013-04-20','10:50:00',5.12),('11288','2013-04-20','10:55:00',4.65),('11288','2013-04-20','11:00:00',5.52),('11288','2013-04-20','11:05:00',4.7),('11288','2013-04-20','11:10:00',6.56),('11288','2013-04-20','11:15:00',7.01),('11288','2013-04-20','11:20:00',5.43),('11288','2013-04-20','11:25:00',7.29),('11288','2013-04-20','11:30:00',5.28),('11288','2013-04-20','11:35:00',2.49),('11288','2013-04-20','11:40:00',3.3),('11288','2013-04-20','11:45:00',4.41),('11288','2013-04-20','11:50:00',7.67),('11288','2013-04-20','11:55:00',7.49),('11288','2013-04-20','12:00:00',3.59),('11288','2013-04-20','12:05:00',5.42),('11288','2013-04-20','12:10:00',7.42),('11288','2013-04-20','12:15:00',7.36),('11288','2013-04-20','12:20:00',6.92),('11288','2013-04-20','12:25:00',7.26),('11288','2013-04-20','12:30:00',4.37),('11288','2013-04-20','12:35:00',5.82),('11288','2013-04-20','12:40:00',7.5),('11288','2013-04-20','12:45:00',5.87),('11288','2013-04-20','12:50:00',4.35),('11288','2013-04-20','12:55:00',6.42),('11288','2013-04-20','13:00:00',2.07),('11288','2013-04-20','13:05:00',4.06),('11288','2013-04-20','13:10:00',6.47),('11288','2013-04-20','13:15:00',4.09),('11288','2013-04-20','13:20:00',4.39),('11288','2013-04-20','13:25:00',4.21),('11288','2013-04-20','13:30:00',5.26),('11288','2013-04-20','13:35:00',7.76),('11288','2013-04-20','13:40:00',4.23),('11288','2013-04-20','13:45:00',2.99),('11288','2013-04-20','13:50:00',3.49),('11288','2013-04-20','13:55:00',5.44),('11288','2013-04-20','14:00:00',3.19),('11288','2013-04-20','14:05:00',5.75),('11288','2013-04-20','14:10:00',7),('11288','2013-04-20','14:15:00',6.39),('11288','2013-04-20','14:20:00',6.43),('11288','2013-04-20','14:25:00',6.31),('11288','2013-04-20','14:30:00',6.24),('11288','2013-04-20','14:35:00',6.17),('11288','2013-04-20','14:40:00',6.2),('11288','2013-04-20','14:45:00',6.22),('11288','2013-04-20','14:50:00',6.23),('11288','2013-04-20','14:55:00',6.19),('11288','2013-04-20','15:00:00',6.11),('11288','2013-04-20','15:05:00',6.03),('11288','2013-04-20','15:10:00',3.59),('11288','2013-04-20','15:15:00',4.03),('11288','2013-04-20','15:20:00',5.34),('11288','2013-04-20','15:25:00',4.97),('11288','2013-04-20','15:30:00',2.15),('11288','2013-04-20','15:35:00',1.31),('11288','2013-04-20','15:40:00',1.32),('11288','2013-04-20','15:45:00',1.36),('11288','2013-04-20','15:50:00',1.29),('11288','2013-04-20','15:55:00',1.25),('11288','2013-04-20','16:00:00',1.46),('11288','2013-04-20','16:05:00',2.01),('11288','2013-04-20','16:10:00',3.43),('11288','2013-04-20','16:15:00',3.65),('11288','2013-04-20','16:20:00',3.62),('11288','2013-04-20','16:25:00',4.14),('11288','2013-04-20','16:30:00',4.25),('11288','2013-04-20','16:35:00',4.4),('11288','2013-04-20','16:40:00',4.82),('11288','2013-04-20','16:45:00',4.55),('11288','2013-04-20','16:50:00',4.11),('11288','2013-04-20','16:55:00',3.82),('11288','2013-04-20','17:00:00',3.65),('11288','2013-04-20','17:05:00',3.5),('11288','2013-04-20','17:10:00',3.38),('11288','2013-04-20','17:15:00',2.82),('11288','2013-04-20','17:20:00',3.14),('11288','2013-04-20','17:25:00',2.87),('11288','2013-04-20','17:30:00',3.09),('11288','2013-04-20','17:35:00',3.03),('11288','2013-04-20','17:40:00',2.65),('11288','2013-04-20','17:45:00',1.31),('11288','2013-04-20','17:50:00',1.71),('11288','2013-04-20','17:55:00',2.26),('11288','2013-04-20','18:00:00',1.83),('11288','2013-04-20','18:05:00',1.81),('11288','2013-04-20','18:10:00',2),('11288','2013-04-20','18:15:00',1.59),('11288','2013-04-20','18:20:00',1.18),('11288','2013-04-19','08:00:00',1.08),('11288','2013-04-19','08:05:00',1.35),('11288','2013-04-19','08:10:00',1.26),('11288','2013-04-19','08:15:00',1.39),('11288','2013-04-19','08:20:00',1.82),('11288','2013-04-19','08:25:00',1.9),('11288','2013-04-19','08:30:00',1.96),('11288','2013-04-19','08:35:00',2.24),('11288','2013-04-19','08:40:00',2.38),('11288','2013-04-19','08:45:00',2.6),('11288','2013-04-19','08:50:00',2.78),('11288','2013-04-19','08:55:00',2.93),('11288','2013-04-19','09:00:00',3.01),('11288','2013-04-19','09:05:00',3.15),('11288','2013-04-19','09:10:00',3.25),('11288','2013-04-19','09:15:00',3.3),('11288','2013-04-19','09:20:00',3.55),('11288','2013-04-19','09:25:00',3.58),('11288','2013-04-19','09:30:00',3.64),('11288','2013-04-19','09:35:00',3.89),('11288','2013-04-19','09:40:00',3.98),('11288','2013-04-19','09:45:00',4.01),('11288','2013-04-19','09:50:00',4.04),('11288','2013-04-19','09:55:00',4.2),('11288','2013-04-19','10:00:00',4.22),('11288','2013-04-19','10:05:00',4.42),('11288','2013-04-19','10:10:00',4.48),('11288','2013-04-19','10:15:00',4.61),('11288','2013-04-19','10:20:00',5.03),('11288','2013-04-19','10:25:00',5.16),('11288','2013-04-19','10:30:00',5.23),('11288','2013-04-19','10:35:00',4.71),('11288','2013-04-19','10:40:00',5.13),('11288','2013-04-19','10:45:00',5.33),('11288','2013-04-19','10:50:00',5.34),('11288','2013-04-19','10:55:00',5.32),('11288','2013-04-19','11:00:00',5.4),('11288','2013-04-19','11:05:00',5.42),('11288','2013-04-19','11:10:00',5.5),('11288','2013-04-19','11:15:00',5.51),('11288','2013-04-19','11:20:00',5.61),('11288','2013-04-19','11:25:00',5.68),('11288','2013-04-19','11:30:00',5.75),('11288','2013-04-19','11:35:00',5.8),('11288','2013-04-19','11:40:00',5.88),('11288','2013-04-19','11:45:00',5.91),('11288','2013-04-19','11:50:00',5.96),('11288','2013-04-19','11:55:00',6.07),('11288','2013-04-19','12:00:00',6.15),('11288','2013-04-19','12:05:00',6.19),('11288','2013-04-19','12:10:00',6.09),('11288','2013-04-19','12:15:00',6.04),('11288','2013-04-19','12:20:00',6.13),('11288','2013-04-19','12:25:00',6.27),('11288','2013-04-19','12:30:00',6.24),('11288','2013-04-19','12:35:00',6.24),('11288','2013-04-19','12:40:00',6.27),('11288','2013-04-19','12:45:00',6.28),('11288','2013-04-19','12:50:00',6.38),('11288','2013-04-19','12:55:00',6.28),('11288','2013-04-19','13:00:00',6.2),('11288','2013-04-19','13:05:00',6.34),('11288','2013-04-19','13:10:00',6.41),('11288','2013-04-19','13:15:00',6.32),('11288','2013-04-19','13:20:00',6.29),('11288','2013-04-19','13:25:00',6.38),('11288','2013-04-19','13:30:00',6.31),('11288','2013-04-19','13:35:00',6.28),('11288','2013-04-19','13:40:00',6.32),('11288','2013-04-19','13:45:00',6.14),('11288','2013-04-19','13:50:00',6.12),('11288','2013-04-19','13:55:00',6.14),('11288','2013-04-19','14:00:00',6.05),('11288','2013-04-19','14:05:00',6.08),('11288','2013-04-19','14:10:00',5.98),('11288','2013-04-19','14:15:00',6.05),('11288','2013-04-19','14:20:00',5.95),('11288','2013-04-19','14:25:00',5.94),('11288','2013-04-19','14:30:00',5.9),('11288','2013-04-19','14:35:00',5.91),('11288','2013-04-19','14:40:00',5.78),('11288','2013-04-19','14:45:00',5.77),('11288','2013-04-19','14:50:00',5.73),('11288','2013-04-19','14:55:00',5.63),('11288','2013-04-19','15:00:00',5.5),('11288','2013-04-19','15:05:00',5.46),('11288','2013-04-19','15:10:00',5.42),('11288','2013-04-19','15:15:00',5.34),('11288','2013-04-19','15:20:00',5.25),('11288','2013-04-19','15:25:00',5.22),('11288','2013-04-19','15:30:00',5.12),('11288','2013-04-19','15:35:00',5.06),('11288','2013-04-19','15:40:00',5.04),('11288','2013-04-19','15:45:00',4.95),('11288','2013-04-19','15:50:00',4.83),('11288','2013-04-19','15:55:00',4.72),('11288','2013-04-19','16:00:00',4.63),('11288','2013-04-19','16:05:00',4.52),('11288','2013-04-19','16:10:00',4.44),('11288','2013-04-19','16:15:00',4.34),('11288','2013-04-19','16:20:00',4.19),('11288','2013-04-19','16:25:00',4.12),('11288','2013-04-19','16:30:00',3.98),('11288','2013-04-19','16:35:00',3.82),('11288','2013-04-19','16:40:00',3.72),('11288','2013-04-19','16:45:00',3.6),('11288','2013-04-19','16:50:00',3.47),('11288','2013-04-19','16:55:00',3.3),('11288','2013-04-19','17:00:00',3.17),('11288','2013-04-19','17:05:00',3.04),('11288','2013-04-19','17:10:00',2.88),('11288','2013-04-19','17:15:00',2.76),('11288','2013-04-19','17:20:00',2.64),('11288','2013-04-19','17:25:00',2.5),('11288','2013-04-19','17:30:00',2.39),('11288','2013-04-19','17:35:00',2.24),('11288','2013-04-19','17:40:00',2.1),('11288','2013-04-19','17:45:00',1.96),('11288','2013-04-19','17:50:00',1.77),('11288','2013-04-19','17:55:00',1.68),('11288','2013-04-19','18:00:00',1.6),('11288','2013-04-19','18:05:00',1.47),('11288','2013-04-19','18:10:00',1.36),('11288','2013-04-19','18:15:00',1.25),('11288','2013-04-19','18:20:00',1.15),('11288','2013-04-19','18:25:00',1.09),('11288','2013-04-19','18:30:00',1.01),('11288','2013-04-18','07:55:00',1.03),('11288','2013-04-18','08:00:00',1.15),('11288','2013-04-18','08:05:00',1.3),('11288','2013-04-18','08:10:00',1.65),('11288','2013-04-18','08:15:00',1.73),('11288','2013-04-18','08:20:00',1.85),('11288','2013-04-18','08:25:00',1.82),('11288','2013-04-18','08:30:00',1.92),('11288','2013-04-18','08:35:00',2.11),('11288','2013-04-18','08:40:00',2.03),('11288','2013-04-18','08:45:00',2.17),('11288','2013-04-18','08:50:00',2.37),('11288','2013-04-18','08:55:00',2.65),('11288','2013-04-18','09:00:00',2.9),('11288','2013-04-18','09:05:00',3.08),('11288','2013-04-18','09:10:00',3.06),('11288','2013-04-18','09:15:00',3.15),('11288','2013-04-18','09:20:00',3.12),('11288','2013-04-18','09:25:00',3.21),('11288','2013-04-18','09:30:00',3.4),('11288','2013-04-18','09:35:00',3.89),('11288','2013-04-18','09:40:00',4.12),('11288','2013-04-18','09:45:00',4.12),('11288','2013-04-18','09:50:00',3.53),('11288','2013-04-18','09:55:00',3.52),('11288','2013-04-18','10:00:00',3.9),('11288','2013-04-18','10:05:00',4.16),('11288','2013-04-18','10:10:00',4.29),('11288','2013-04-18','10:15:00',5.02),('11288','2013-04-18','10:20:00',5.23),('11288','2013-04-18','10:25:00',5.19),('11288','2013-04-18','10:30:00',5.35),('11288','2013-04-18','10:35:00',5.43),('11288','2013-04-18','10:40:00',5.48),('11288','2013-04-18','10:45:00',5.54),('11288','2013-04-18','10:50:00',5.58),('11288','2013-04-18','10:55:00',5.63),('11288','2013-04-18','11:00:00',5.64),('11288','2013-04-18','11:05:00',5.69),('11288','2013-04-18','11:10:00',5.79),('11288','2013-04-18','11:15:00',5.85),('11288','2013-04-18','11:20:00',5.92),('11288','2013-04-18','11:25:00',5.96),('11288','2013-04-18','11:30:00',5.95),('11288','2013-04-18','11:35:00',6.01),('11288','2013-04-18','11:40:00',5.99),('11288','2013-04-18','11:45:00',5.98),('11288','2013-04-18','11:50:00',6.17),('11288','2013-04-18','11:55:00',6.32),('11288','2013-04-18','12:00:00',6.33),('11288','2013-04-18','12:05:00',6.43),('11288','2013-04-18','12:10:00',6.49),('11288','2013-04-18','12:15:00',6.44),('11288','2013-04-18','12:20:00',6.48),('11288','2013-04-18','12:25:00',6.56),('11288','2013-04-18','12:30:00',6.54),('11288','2013-04-18','12:35:00',6.56),('11288','2013-04-18','12:40:00',6.58),('11288','2013-04-18','12:45:00',6.55),('11288','2013-04-18','12:50:00',6.58),('11288','2013-04-18','12:55:00',6.64),('11288','2013-04-18','13:00:00',6.65),('11288','2013-04-18','13:05:00',6.55),('11288','2013-04-18','13:10:00',6.57),('11288','2013-04-18','13:15:00',6.62),('11288','2013-04-18','13:20:00',6.59),('11288','2013-04-18','13:25:00',6.61),('11288','2013-04-18','13:30:00',6.6),('11288','2013-04-18','13:35:00',6.62),('11288','2013-04-18','13:40:00',6.57),('11288','2013-04-18','13:45:00',6.53),('11288','2013-04-18','13:50:00',6.58),('11288','2013-04-18','13:55:00',6.53),('11288','2013-04-18','14:00:00',6.5),('11288','2013-04-18','14:05:00',6.49),('11288','2013-04-18','14:10:00',6.43),('11288','2013-04-18','14:15:00',6.41),('11288','2013-04-18','14:20:00',6.38),('11288','2013-04-18','14:25:00',6.35),('11288','2013-04-18','14:30:00',6.33),('11288','2013-04-18','14:35:00',6.25),('11288','2013-04-18','14:40:00',6.17),('11288','2013-04-18','14:45:00',6.1),('11288','2013-04-18','14:50:00',6.03),('11288','2013-04-18','14:55:00',5.99),('11288','2013-04-18','15:00:00',5.84),('11288','2013-04-18','15:05:00',5.83),('11288','2013-04-18','15:10:00',5.74),('11288','2013-04-18','15:15:00',5.67),('11288','2013-04-18','15:20:00',5.6),('11288','2013-04-18','15:25:00',5.55),('11288','2013-04-18','15:30:00',5.38),('11288','2013-04-18','15:35:00',5.36),('11288','2013-04-18','15:40:00',5.27),('11288','2013-04-18','15:45:00',5.21),('11288','2013-04-18','15:50:00',5.11),('11288','2013-04-18','15:55:00',4.95),('11288','2013-04-18','16:00:00',4.85),('11288','2013-04-18','16:05:00',4.75),('11288','2013-04-18','16:10:00',4.67),('11288','2013-04-18','16:15:00',4.53),('11288','2013-04-18','16:20:00',4.4),('11288','2013-04-18','16:25:00',4.26),('11288','2013-04-18','16:30:00',4.13),('11288','2013-04-18','16:35:00',3.97),('11288','2013-04-18','16:40:00',3.85),('11288','2013-04-18','16:45:00',3.77),('11288','2013-04-18','16:50:00',3.67),('11288','2013-04-18','16:55:00',3.51),('11288','2013-04-18','17:00:00',3.36),('11288','2013-04-18','17:05:00',3.19),('11288','2013-04-18','17:10:00',3.06),('11288','2013-04-18','17:15:00',2.95),('11288','2013-04-18','17:20:00',2.81),('11288','2013-04-18','17:25:00',2.68),('11288','2013-04-18','17:30:00',2.54),('11288','2013-04-18','17:35:00',2.42),('11288','2013-04-18','17:40:00',2.28),('11288','2013-04-18','17:45:00',2.14),('11288','2013-04-18','17:50:00',2.01),('11288','2013-04-18','17:55:00',1.89),('11288','2013-04-18','18:00:00',1.75),('11288','2013-04-18','18:05:00',1.61),('11288','2013-04-18','18:10:00',1.49),('11288','2013-04-18','18:15:00',1.33),('11288','2013-04-18','18:20:00',1.22),('11288','2013-04-18','18:25:00',1.09),('11288','2013-04-17','07:50:00',1.03),('11288','2013-04-17','07:55:00',1.12),('11288','2013-04-17','08:00:00',1.27),('11288','2013-04-17','08:05:00',1.4),('11288','2013-04-17','08:10:00',1.47),('11288','2013-04-17','08:15:00',1.54),('11288','2013-04-17','08:20:00',1.78),('11288','2013-04-17','08:25:00',1.77),('11288','2013-04-17','08:30:00',1.74),('11288','2013-04-17','08:35:00',2.1),('11288','2013-04-17','08:40:00',2.22),('11288','2013-04-17','08:45:00',2.49),('11288','2013-04-17','08:50:00',2.64),('11288','2013-04-17','08:55:00',2.75),('11288','2013-04-17','09:00:00',2.97),('11288','2013-04-17','09:05:00',3.12),('11288','2013-04-17','09:10:00',3.3),('11288','2013-04-17','09:15:00',3.46),('11288','2013-04-17','09:20:00',3.57),('11288','2013-04-17','09:25:00',3.68),('11288','2013-04-17','09:30:00',3.66),('11288','2013-04-17','09:35:00',3.85),('11288','2013-04-17','09:40:00',4.05),('11288','2013-04-17','09:45:00',4.18),('11288','2013-04-17','09:50:00',4.37),('11288','2013-04-17','09:55:00',4.47),('11288','2013-04-17','10:00:00',4.38),('11288','2013-04-17','10:05:00',4.43),('11288','2013-04-17','10:10:00',4.87),('11288','2013-04-17','10:15:00',5.01),('11288','2013-04-17','10:20:00',5.14),('11288','2013-04-17','10:25:00',5.27),('11288','2013-04-17','10:30:00',5.36),('11288','2013-04-17','10:35:00',5.44),('11288','2013-04-17','10:40:00',5.51),('11288','2013-04-17','10:45:00',5.54),('11288','2013-04-17','10:50:00',5.59),('11288','2013-04-17','10:55:00',5.66),('11288','2013-04-17','11:00:00',5.77),('11288','2013-04-17','11:05:00',5.79),('11288','2013-04-17','11:10:00',5.91),('11288','2013-04-17','11:15:00',5.98),('11288','2013-04-17','11:20:00',6),('11288','2013-04-17','11:25:00',6.03),('11288','2013-04-17','11:30:00',6.04),('11288','2013-04-17','11:35:00',6.08),('11288','2013-04-17','11:40:00',6.13),('11288','2013-04-17','11:45:00',6.15),('11288','2013-04-17','11:50:00',6.14),('11288','2013-04-17','11:55:00',6.27),('11288','2013-04-17','12:00:00',6.43),('11288','2013-04-17','12:05:00',6.44),('11288','2013-04-17','12:10:00',6.43),('11288','2013-04-17','12:15:00',6.46),('11288','2013-04-17','12:20:00',6.51),('11288','2013-04-17','12:25:00',6.57),('11288','2013-04-17','12:30:00',6.57),('11288','2013-04-17','12:35:00',6.63),('11288','2013-04-17','12:40:00',6.65),('11288','2013-04-17','12:45:00',6.64),('11288','2013-04-17','12:50:00',6.63),('11288','2013-04-17','12:55:00',6.58),('11288','2013-04-17','13:00:00',6.57),('11288','2013-04-17','13:05:00',6.57),('11288','2013-04-17','13:10:00',6.58),('11288','2013-04-17','13:15:00',6.69),('11288','2013-04-17','13:20:00',6.69),('11288','2013-04-17','13:25:00',6.67),('11288','2013-04-17','13:30:00',6.59),('11288','2013-04-17','13:35:00',6.59),('11288','2013-04-17','13:40:00',6.62),('11288','2013-04-17','13:45:00',6.64),('11288','2013-04-17','13:50:00',6.49),('11288','2013-04-17','13:55:00',6.78),('11288','2013-04-17','14:00:00',6.51),('11288','2013-04-17','14:05:00',7.06),('11288','2013-04-17','14:10:00',7.02),('11288','2013-04-17','14:15:00',6.56),('11288','2013-04-17','14:20:00',6.43),('11288','2013-04-17','14:25:00',5.99),('11288','2013-04-17','14:30:00',6.49),('11288','2013-04-17','14:35:00',6.7),('11288','2013-04-17','14:40:00',6.07),('11288','2013-04-17','14:45:00',6.02),('11288','2013-04-17','14:50:00',6.82),('11288','2013-04-17','14:55:00',6.56),('11288','2013-04-17','15:00:00',6.47),('11288','2013-04-17','15:05:00',6.56),('11288','2013-04-17','15:10:00',6.76),('11288','2013-04-17','15:15:00',6.15),('11288','2013-04-17','15:20:00',3.8),('11288','2013-04-17','15:25:00',2.85),('11288','2013-04-17','15:30:00',4.98),('11288','2013-04-17','15:35:00',5.61),('11288','2013-04-17','15:40:00',5.75),('11288','2013-04-17','15:45:00',5.71),('11288','2013-04-17','15:50:00',5.74),('11288','2013-04-17','15:55:00',5.44),('11288','2013-04-17','16:00:00',5.32),('11288','2013-04-17','16:05:00',4.08),('11288','2013-04-17','16:10:00',5.04),('11288','2013-04-17','16:15:00',4.88),('11288','2013-04-17','16:20:00',4.64),('11288','2013-04-17','16:25:00',4.5),('11288','2013-04-17','16:30:00',4.39),('11288','2013-04-17','16:35:00',4.33),('11288','2013-04-17','16:40:00',3.68),('11288','2013-04-17','16:45:00',4.08),('11288','2013-04-17','16:50:00',3.82),('11288','2013-04-17','16:55:00',3.6),('11288','2013-04-17','17:00:00',3.43),('11288','2013-04-17','17:05:00',3.3),('11288','2013-04-17','17:10:00',3.12),('11288','2013-04-17','17:15:00',3),('11288','2013-04-17','17:20:00',2.86),('11288','2013-04-17','17:25:00',2.72),('11288','2013-04-17','17:30:00',2.59),('11288','2013-04-17','17:35:00',2.45),('11288','2013-04-17','17:40:00',2.29),('11288','2013-04-17','17:45:00',2.17),('11288','2013-04-17','17:50:00',1.98),('11288','2013-04-17','17:55:00',1.85),('11288','2013-04-17','18:00:00',1.74),('11288','2013-04-17','18:05:00',1.62),('11288','2013-04-17','18:10:00',1.5),('11288','2013-04-17','18:15:00',1.38),('11288','2013-04-17','18:20:00',1.24),('11288','2013-04-17','18:25:00',1.13),('11288','2013-04-17','18:30:00',1.02),('11288','2013-04-16','08:00:00',1.18),('11288','2013-04-16','08:05:00',1.31),('11288','2013-04-16','08:10:00',1.48),('11288','2013-04-16','08:15:00',1.47),('11288','2013-04-16','08:20:00',1.19),('11288','2013-04-16','08:25:00',1.42),('11288','2013-04-16','08:30:00',1.33),('11288','2013-04-16','08:35:00',1.33),('11288','2013-04-16','08:40:00',1.41),('11288','2013-04-16','08:45:00',1.59),('11288','2013-04-16','08:50:00',1.8),('11288','2013-04-16','08:55:00',1.82),('11288','2013-04-16','09:00:00',1.41),('11288','2013-04-16','09:05:00',1.14),('11288','2013-04-16','09:10:00',2.44),('11288','2013-04-16','09:15:00',3.43),('11288','2013-04-16','09:20:00',2.17),('11288','2013-04-16','09:25:00',2.34),('11288','2013-04-16','09:30:00',2.58),('11288','2013-04-16','09:35:00',2.65),('11288','2013-04-16','09:40:00',2.52),('11288','2013-04-16','09:45:00',2.66),('11288','2013-04-16','09:50:00',2.45),('11288','2013-04-16','09:55:00',2.34),('11288','2013-04-16','10:00:00',2.21),('11288','2013-04-16','10:05:00',2.2),('11288','2013-04-16','10:10:00',2.34),('11288','2013-04-16','10:15:00',2.49),('11288','2013-04-16','10:20:00',2.62),('11288','2013-04-16','10:25:00',2.68),('11288','2013-04-16','10:30:00',2.68),('11288','2013-04-16','10:35:00',2.74),('11288','2013-04-16','10:40:00',2.7),('11288','2013-04-16','10:45:00',2.61),('11288','2013-04-16','10:50:00',2.64),('11288','2013-04-16','10:55:00',2.81),('11288','2013-04-16','11:00:00',3.03),('11288','2013-04-16','11:05:00',3.13),('11288','2013-04-16','11:10:00',3.1),('11288','2013-04-16','11:15:00',3.16),('11288','2013-04-16','11:20:00',3.24),('11288','2013-04-16','11:25:00',3.17),('11288','2013-04-16','11:30:00',3.08),('11288','2013-04-16','11:35:00',2.97),('11288','2013-04-16','11:40:00',3.19),('11288','2013-04-16','11:45:00',3.7),('11288','2013-04-16','11:50:00',3.97),('11288','2013-04-16','11:55:00',4.09),('11288','2013-04-16','12:00:00',4.26),('11288','2013-04-16','12:05:00',4.71),('11288','2013-04-16','12:10:00',5.16),('11288','2013-04-16','12:15:00',4.92),('11288','2013-04-16','12:20:00',4.95),('11288','2013-04-16','12:25:00',5.18),('11288','2013-04-16','12:30:00',3.87),('11288','2013-04-16','12:35:00',4.26),('11288','2013-04-16','12:40:00',5.34),('11288','2013-04-16','12:45:00',6.09),('11288','2013-04-16','12:50:00',5.39),('11288','2013-04-16','12:55:00',5.96),('11288','2013-04-16','13:00:00',6.64),('11288','2013-04-16','13:05:00',6.56),('11288','2013-04-16','13:10:00',6.42),('11288','2013-04-16','13:15:00',6.43),('11288','2013-04-16','13:20:00',6.49),('11288','2013-04-16','13:25:00',6.51),('11288','2013-04-16','13:30:00',6.43),('11288','2013-04-16','13:35:00',6.41),('11288','2013-04-16','13:40:00',6.39),('11288','2013-04-16','13:45:00',6.18),('11288','2013-04-16','13:50:00',6.31),('11288','2013-04-16','13:55:00',6.09),('11288','2013-04-16','14:00:00',6.22),('11288','2013-04-16','14:05:00',6.28),('11288','2013-04-16','14:10:00',6.21),('11288','2013-04-16','14:15:00',6.35),('11288','2013-04-16','14:20:00',6.1),('11288','2013-04-16','14:25:00',5.86),('11288','2013-04-16','14:30:00',5.77),('11288','2013-04-16','14:35:00',4.35),('11288','2013-04-16','14:40:00',5.83),('11288','2013-04-16','14:45:00',5.94),('11288','2013-04-16','14:50:00',5.84),('11288','2013-04-16','14:55:00',5.73),('11288','2013-04-16','15:00:00',5.72),('11288','2013-04-16','15:05:00',5.78),('11288','2013-04-16','15:10:00',5.78),('11288','2013-04-16','15:15:00',5.67),('11288','2013-04-16','15:20:00',5.57),('11288','2013-04-16','15:25:00',4.97),('11288','2013-04-16','15:30:00',4.93),('11288','2013-04-16','15:35:00',5.25),('11288','2013-04-16','15:40:00',5.18),('11288','2013-04-16','15:45:00',5.14),('11288','2013-04-16','15:50:00',5.02),('11288','2013-04-16','15:55:00',4.94),('11288','2013-04-16','16:00:00',4.77),('11288','2013-04-16','16:05:00',4.69),('11288','2013-04-16','16:10:00',4.56),('11288','2013-04-16','16:15:00',4.31),('11288','2013-04-16','16:20:00',4.36),('11288','2013-04-16','16:25:00',4.25),('11288','2013-04-16','16:30:00',4.19),('11288','2013-04-16','16:35:00',4.09),('11288','2013-04-16','16:40:00',4.18),('11288','2013-04-16','16:45:00',4.25),('11288','2013-04-16','16:50:00',3.93),('11288','2013-04-16','16:55:00',3.11),('11288','2013-04-16','17:00:00',3.25),('11288','2013-04-16','17:05:00',3.42),('11288','2013-04-16','17:10:00',3.38),('11288','2013-04-16','17:15:00',3.29),('11288','2013-04-16','17:20:00',3.18),('11288','2013-04-16','17:25:00',3.09),('11288','2013-04-16','17:30:00',2.79),('11288','2013-04-16','17:35:00',2.78),('11288','2013-04-16','17:40:00',2.72),('11288','2013-04-16','17:45:00',2.5),('11288','2013-04-16','17:50:00',2.25),('11288','2013-04-16','17:55:00',1.91),('11288','2013-04-16','18:00:00',1.47),('11288','2013-04-16','18:05:00',1.43),('11288','2013-04-16','18:10:00',1.36),('11288','2013-04-16','18:15:00',1.26),('11288','2013-04-16','18:20:00',1.05),('11288','2013-04-15','07:55:00',1.09),('11288','2013-04-15','08:00:00',1.19),('11288','2013-04-15','08:05:00',1.27),('11288','2013-04-15','08:10:00',1.41),('11288','2013-04-15','08:15:00',1.5),('11288','2013-04-15','08:20:00',1.61),('11288','2013-04-15','08:25:00',1.77),('11288','2013-04-15','08:30:00',1.85),('11288','2013-04-15','08:35:00',2.05),('11288','2013-04-15','08:40:00',2.28),('11288','2013-04-15','08:45:00',2.38),('11288','2013-04-15','08:50:00',2.59),('11288','2013-04-15','08:55:00',2.82),('11288','2013-04-15','09:00:00',2.94),('11288','2013-04-15','09:05:00',2.93),('11288','2013-04-15','09:10:00',3.2),('11288','2013-04-15','09:15:00',3.41),('11288','2013-04-15','09:20:00',3.46),('11288','2013-04-15','09:25:00',3.5),('11288','2013-04-15','09:30:00',3.78),('11288','2013-04-15','09:35:00',3.83),('11288','2013-04-15','09:40:00',4.02),('11288','2013-04-15','09:45:00',4.15),('11288','2013-04-15','09:50:00',4.07),('11288','2013-04-15','09:55:00',4.19),('11288','2013-04-15','10:00:00',4.57),('11288','2013-04-15','10:05:00',4.71),('11288','2013-04-15','10:10:00',4.84),('11288','2013-04-15','10:15:00',4.99),('11288','2013-04-15','10:20:00',5.12),('11288','2013-04-15','10:25:00',5.24),('11288','2013-04-15','10:30:00',5.32),('11288','2013-04-15','10:35:00',5.35),('11288','2013-04-15','10:40:00',5.46),('11288','2013-04-15','10:45:00',5.55),('11288','2013-04-15','10:50:00',5.59),('11288','2013-04-15','10:55:00',5.64),('11288','2013-04-15','11:00:00',5.73),('11288','2013-04-15','11:05:00',5.8),('11288','2013-04-15','11:10:00',5.89),('11288','2013-04-15','11:15:00',5.96),('11288','2013-04-15','11:20:00',5.99),('11288','2013-04-15','11:25:00',6.02),('11288','2013-04-15','11:30:00',6.04),('11288','2013-04-15','11:35:00',6.13),('11288','2013-04-15','11:40:00',6.15),('11288','2013-04-15','11:45:00',6.21),('11288','2013-04-15','11:50:00',6.26),('11288','2013-04-15','11:55:00',6.25),('11288','2013-04-15','12:00:00',6.4),('11288','2013-04-15','12:05:00',6.48),('11288','2013-04-15','12:10:00',6.48),('11288','2013-04-15','12:15:00',6.46),('11288','2013-04-15','12:20:00',6.46),('11288','2013-04-15','12:25:00',6.46),('11288','2013-04-15','12:30:00',6.53),('11288','2013-04-15','12:35:00',6.52),('11288','2013-04-15','12:40:00',6.58),('11288','2013-04-15','12:45:00',6.56),('11288','2013-04-15','12:50:00',6.52),('11288','2013-04-15','12:55:00',6.51),('11288','2013-04-15','13:00:00',6.53),('11288','2013-04-15','13:05:00',6.52),('11288','2013-04-15','13:10:00',6.53),('11288','2013-04-15','13:15:00',6.54),('11288','2013-04-15','13:20:00',6.48),('11288','2013-04-15','13:25:00',6.56),('11288','2013-04-15','13:30:00',6.58),('11288','2013-04-15','13:35:00',6.48),('11288','2013-04-15','13:40:00',6.45),('11288','2013-04-15','13:45:00',6.47),('11288','2013-04-15','13:50:00',6.5),('11288','2013-04-15','13:55:00',6.5),('11288','2013-04-15','14:00:00',6.52),('11288','2013-04-15','14:05:00',6.51),('11288','2013-04-15','14:10:00',6.46),('11288','2013-04-15','14:15:00',6.46),('11288','2013-04-15','14:20:00',6.45),('11288','2013-04-15','14:25:00',6.35),('11288','2013-04-15','14:30:00',6.33),('11288','2013-04-15','14:35:00',6.27),('11288','2013-04-15','14:40:00',6.22),('11288','2013-04-15','14:45:00',6.18),('11288','2013-04-15','14:50:00',6.1),('11288','2013-04-15','14:55:00',6.03),('11288','2013-04-15','15:00:00',5.96),('11288','2013-04-15','15:05:00',5.92),('11288','2013-04-15','15:10:00',5.86),('11288','2013-04-15','15:15:00',5.79),('11288','2013-04-15','15:20:00',5.71),('11288','2013-04-15','15:25:00',5.63),('11288','2013-04-15','15:30:00',5.58),('11288','2013-04-15','15:35:00',5.5),('11288','2013-04-15','15:40:00',5.41),('11288','2013-04-15','15:45:00',5.3),('11288','2013-04-15','15:50:00',5.2),('11288','2013-04-15','15:55:00',5.05),('11288','2013-04-15','16:00:00',4.96),('11288','2013-04-15','16:05:00',4.83),('11288','2013-04-15','16:10:00',4.72),('11288','2013-04-15','16:15:00',4.59),('11288','2013-04-15','16:20:00',4.47),('11288','2013-04-15','16:25:00',4.35),('11288','2013-04-15','16:30:00',4.22),('11288','2013-04-15','16:35:00',4.05),('11288','2013-04-15','16:40:00',3.94),('11288','2013-04-15','16:45:00',3.8),('11288','2013-04-15','16:50:00',3.7),('11288','2013-04-15','16:55:00',3.54),('11288','2013-04-15','17:00:00',3.42),('11288','2013-04-15','17:05:00',3.28),('11288','2013-04-15','17:10:00',3.13),('11288','2013-04-15','17:15:00',2.99),('11288','2013-04-15','17:20:00',2.83),('11288','2013-04-15','17:25:00',2.7),('11288','2013-04-15','17:30:00',2.56),('11288','2013-04-15','17:35:00',2.43),('11288','2013-04-15','17:40:00',2.28),('11288','2013-04-15','17:45:00',2.14),('11288','2013-04-15','17:50:00',2),('11288','2013-04-15','17:55:00',1.85),('11288','2013-04-15','18:00:00',1.74),('11288','2013-04-15','18:05:00',1.62),('11288','2013-04-15','18:10:00',1.49),('11288','2013-04-15','18:15:00',1.36),('11288','2013-04-15','18:20:00',1.23),('11288','2013-04-15','18:25:00',1.12),('11288','2013-04-14','07:50:00',1.01),('11288','2013-04-14','07:55:00',1.21),('11288','2013-04-14','08:00:00',1.3),('11288','2013-04-14','08:05:00',1.3),('11288','2013-04-14','08:10:00',1.5),('11288','2013-04-14','08:15:00',1.6),('11288','2013-04-14','08:20:00',1.63),('11288','2013-04-14','08:25:00',1.76),('11288','2013-04-14','08:30:00',1.92),('11288','2013-04-14','08:35:00',2.01),('11288','2013-04-14','08:40:00',2.28),('11288','2013-04-14','08:45:00',2.41),('11288','2013-04-14','08:50:00',2.62),('11288','2013-04-14','08:55:00',2.76),('11288','2013-04-14','09:00:00',2.9),('11288','2013-04-14','09:05:00',2.95),('11288','2013-04-14','09:10:00',3.14),('11288','2013-04-14','09:15:00',3.29),('11288','2013-04-14','09:20:00',3.34),('11288','2013-04-14','09:25:00',3.44),('11288','2013-04-14','09:30:00',3.76),('11288','2013-04-14','09:35:00',3.8),('11288','2013-04-14','09:40:00',3.98),('11288','2013-04-14','09:45:00',3.95),('11288','2013-04-14','09:50:00',3.94),('11288','2013-04-14','09:55:00',4.08),('11288','2013-04-14','10:00:00',4.37),('11288','2013-04-14','10:05:00',4.58),('11288','2013-04-14','10:10:00',4.76),('11288','2013-04-14','10:15:00',4.87),('11288','2013-04-14','10:20:00',4.92),('11288','2013-04-14','10:25:00',5.03),('11288','2013-04-14','10:30:00',5.16),('11288','2013-04-14','10:35:00',5.25),('11288','2013-04-14','10:40:00',5.37),('11288','2013-04-14','10:45:00',5.5),('11288','2013-04-14','10:50:00',5.55),('11288','2013-04-14','10:55:00',5.54),('11288','2013-04-14','11:00:00',5.63),('11288','2013-04-14','11:05:00',5.67),('11288','2013-04-14','11:10:00',5.74),('11288','2013-04-14','11:15:00',5.8),('11288','2013-04-14','11:20:00',5.92),('11288','2013-04-14','11:25:00',5.97),('11288','2013-04-14','11:30:00',5.97),('11288','2013-04-14','11:35:00',6.03),('11288','2013-04-14','11:40:00',6.05),('11288','2013-04-14','11:45:00',6.04),('11288','2013-04-14','11:50:00',6.08),('11288','2013-04-14','11:55:00',6.11),('11288','2013-04-14','12:00:00',6.28),('11288','2013-04-14','12:05:00',6.29),('11288','2013-04-14','12:10:00',6.33),('11288','2013-04-14','12:15:00',6.36),('11288','2013-04-14','12:20:00',6.42),('11288','2013-04-14','12:25:00',6.45),('11288','2013-04-14','12:30:00',6.46),('11288','2013-04-14','12:35:00',6.49),('11288','2013-04-14','12:40:00',5.57),('11288','2013-04-14','12:45:00',1.14),('11288','2013-04-14','12:50:00',4.37),('11288','2013-04-14','12:55:00',6.87),('11288','2013-04-14','13:00:00',6.77),('11288','2013-04-14','13:05:00',4.33),('11288','2013-04-14','13:10:00',6.82),('11288','2013-04-14','13:15:00',6.79),('11288','2013-04-14','13:20:00',6.78),('11288','2013-04-14','13:25:00',6.65),('11288','2013-04-14','13:30:00',6.64),('11288','2013-04-14','13:35:00',6.6),('11288','2013-04-14','13:40:00',6.49),('11288','2013-04-14','13:45:00',6.45),('11288','2013-04-14','13:50:00',6.33),('11288','2013-04-14','13:55:00',6.35),('11288','2013-04-14','14:00:00',6.32),('11288','2013-04-14','14:05:00',6.41),('11288','2013-04-14','14:10:00',6.34),('11288','2013-04-14','14:15:00',6.32),('11288','2013-04-14','14:20:00',6.2),('11288','2013-04-14','14:25:00',6.17),('11288','2013-04-14','14:30:00',6.17),('11288','2013-04-14','14:35:00',6.23),('11288','2013-04-14','14:40:00',6.24),('11288','2013-04-14','14:45:00',6.3),('11288','2013-04-14','14:50:00',6.26),('11288','2013-04-14','14:55:00',6.03),('11288','2013-04-14','15:00:00',6.02),('11288','2013-04-14','15:05:00',5.97),('11288','2013-04-14','15:10:00',5.9),('11288','2013-04-14','15:15:00',5),('11288','2013-04-14','15:20:00',5.43),('11288','2013-04-14','15:25:00',4.04),('11288','2013-04-14','15:30:00',5.43),('11288','2013-04-14','15:35:00',5.44),('11288','2013-04-14','15:40:00',5.52),('11288','2013-04-14','15:45:00',5.32),('11288','2013-04-14','15:50:00',5.27),('11288','2013-04-14','15:55:00',4.97),('11288','2013-04-14','16:00:00',4.55),('11288','2013-04-14','16:05:00',4.61),('11288','2013-04-14','16:10:00',4.45),('11288','2013-04-14','16:15:00',4.38),('11288','2013-04-14','16:20:00',4.23),('11288','2013-04-14','16:25:00',4.15),('11288','2013-04-14','16:30:00',4.07),('11288','2013-04-14','16:35:00',3.94),('11288','2013-04-14','16:40:00',3.84),('11288','2013-04-14','16:45:00',3.69),('11288','2013-04-14','16:50:00',3.57),('11288','2013-04-14','16:55:00',3.42),('11288','2013-04-14','17:00:00',3.28),('11288','2013-04-14','17:05:00',3.12),('11288','2013-04-14','17:10:00',3.02),('11288','2013-04-14','17:15:00',2.88),('11288','2013-04-14','17:20:00',2.72),('11288','2013-04-14','17:25:00',2.6),('11288','2013-04-14','17:30:00',2.44),('11288','2013-04-14','17:35:00',2.33),('11288','2013-04-14','17:40:00',2.19),('11288','2013-04-14','17:45:00',2.05),('11288','2013-04-14','17:50:00',1.93),('11288','2013-04-14','17:55:00',1.77),('11288','2013-04-14','18:00:00',1.63),('11288','2013-04-14','18:05:00',1.53),('11288','2013-04-14','18:10:00',1.42),('11288','2013-04-14','18:15:00',1.32),('11288','2013-04-14','18:20:00',1.2),('11288','2013-04-14','18:25:00',1.07),('11288','2013-04-13','07:50:00',1.04),('11288','2013-04-13','07:55:00',1.1),('11288','2013-04-13','08:00:00',1.21),('11288','2013-04-13','08:05:00',1.29),('11288','2013-04-13','08:10:00',1.43),('11288','2013-04-13','08:15:00',1.62),('11288','2013-04-13','08:20:00',1.61),('11288','2013-04-13','08:25:00',1.02),('11288','2013-04-13','08:40:00',1.17),('11288','2013-04-13','08:45:00',1.26),('11288','2013-04-13','08:50:00',1.76),('11288','2013-04-13','08:55:00',2.48),('11288','2013-04-13','09:00:00',1.85),('11288','2013-04-13','09:05:00',1.84),('11288','2013-04-13','09:10:00',2.52),('11288','2013-04-13','09:15:00',1.91),('11288','2013-04-13','09:20:00',2.39),('11288','2013-04-13','09:25:00',2.33),('11288','2013-04-13','09:30:00',3.49),('11288','2013-04-13','09:35:00',3.64),('11288','2013-04-13','09:40:00',3.49),('11288','2013-04-13','09:45:00',4.03),('11288','2013-04-13','09:50:00',4.19),('11288','2013-04-13','09:55:00',4.31),('11288','2013-04-13','10:00:00',4.47),('11288','2013-04-13','10:05:00',4.62),('11288','2013-04-13','10:10:00',4.35),('11288','2013-04-13','10:15:00',4.84),('11288','2013-04-13','10:20:00',5.35),('11288','2013-04-13','10:25:00',5.39),('11288','2013-04-13','10:30:00',4.23),('11288','2013-04-13','10:35:00',5.07),('11288','2013-04-13','10:40:00',5.92),('11288','2013-04-13','10:45:00',3.65),('11288','2013-04-13','10:50:00',6.28),('11288','2013-04-13','10:55:00',3.37),('11288','2013-04-13','11:00:00',2.67),('11288','2013-04-13','11:05:00',5.7),('11288','2013-04-13','11:10:00',5.8),('11288','2013-04-13','11:15:00',4.97),('11288','2013-04-13','11:20:00',3.01),('11288','2013-04-13','11:25:00',3.8),('11288','2013-04-13','11:30:00',6.12),('11288','2013-04-13','11:35:00',6.64),('11288','2013-04-13','11:40:00',4.42),('11288','2013-04-13','11:45:00',5.48),('11288','2013-04-13','11:50:00',6.18),('11288','2013-04-13','11:55:00',6.71),('11288','2013-04-13','12:00:00',6.94),('11288','2013-04-13','12:05:00',6.81),('11288','2013-04-13','12:10:00',6.83),('11288','2013-04-13','12:15:00',6.15),('11288','2013-04-13','12:20:00',6.92),('11288','2013-04-13','12:25:00',6.96),('11288','2013-04-13','12:30:00',6.76),('11288','2013-04-13','12:35:00',6.88),('11288','2013-04-13','12:40:00',6.86),('11288','2013-04-13','12:45:00',6.66),('11288','2013-04-13','12:50:00',6.57),('11288','2013-04-13','12:55:00',6.51),('11288','2013-04-13','13:00:00',6.59),('11288','2013-04-13','13:05:00',6.69),('11288','2013-04-13','13:10:00',7.04),('11288','2013-04-13','13:15:00',6.81),('11288','2013-04-13','13:20:00',6.78),('11288','2013-04-13','13:25:00',6.74),('11288','2013-04-13','13:30:00',5.77),('11288','2013-04-13','13:35:00',4.45),('11288','2013-04-13','13:40:00',6),('11288','2013-04-13','13:45:00',4.91),('11288','2013-04-13','13:50:00',2.69),('11288','2013-04-13','13:55:00',3.51),('11288','2013-04-13','14:00:00',3.83),('11288','2013-04-13','14:05:00',3.5),('11288','2013-04-13','14:10:00',5.15),('11288','2013-04-13','14:15:00',5.95),('11288','2013-04-13','14:20:00',5.78),('11288','2013-04-13','14:25:00',5.89),('11288','2013-04-13','14:30:00',5.68),('11288','2013-04-13','14:35:00',5.72),('11288','2013-04-13','14:40:00',5.9),('11288','2013-04-13','14:45:00',5.96),('11288','2013-04-13','14:50:00',5.7),('11288','2013-04-13','14:55:00',5.86),('11288','2013-04-13','15:00:00',5.2),('11288','2013-04-13','15:05:00',4.39),('11288','2013-04-13','15:10:00',4.99),('11288','2013-04-13','15:15:00',4.49),('11288','2013-04-13','15:20:00',4.65),('11288','2013-04-13','15:25:00',4.3),('11288','2013-04-13','15:30:00',4.36),('11288','2013-04-13','15:35:00',4.27),('11288','2013-04-13','15:40:00',4.41),('11288','2013-04-13','15:45:00',4.47),('11288','2013-04-13','15:50:00',4.31),('11288','2013-04-13','15:55:00',4.31),('11288','2013-04-13','16:00:00',4.21),('11288','2013-04-13','16:05:00',4),('11288','2013-04-13','16:10:00',3.83),('11288','2013-04-13','16:15:00',3.83),('11288','2013-04-13','16:20:00',3.74),('11288','2013-04-13','16:25:00',3.47),('11288','2013-04-13','16:30:00',3.27),('11288','2013-04-13','16:35:00',3.11),('11288','2013-04-13','16:40:00',2.92),('11288','2013-04-13','16:45:00',2.75),('11288','2013-04-13','16:50:00',2.8),('11288','2013-04-13','16:55:00',2.35),('11288','2013-04-13','17:00:00',2.04),('11288','2013-04-13','17:05:00',1.93),('11288','2013-04-13','17:10:00',2.48),('11288','2013-04-13','17:15:00',2.73),('11288','2013-04-13','17:20:00',2.46),('11288','2013-04-13','17:25:00',2.76),('11288','2013-04-13','17:30:00',2.41),('11288','2013-04-13','17:35:00',2.37),('11288','2013-04-13','17:40:00',2.24),('11288','2013-04-13','17:45:00',2.01),('11288','2013-04-13','17:50:00',1.78),('11288','2013-04-13','17:55:00',1.91),('11288','2013-04-13','18:00:00',1.45),('11288','2013-04-13','18:05:00',1.43),('11288','2013-04-13','18:10:00',1.3),('11288','2013-04-13','18:15:00',1.29),('11288','2013-04-13','18:20:00',1.27),('11288','2013-04-13','18:25:00',1.14),('11288','2013-04-13','18:30:00',1.03),('11288','2013-04-12','07:50:00',1.02),('11288','2013-04-12','07:55:00',1.57),('11288','2013-04-12','08:00:00',1.3),('11288','2013-04-12','08:05:00',1.47),('11288','2013-04-12','08:10:00',1.71),('11288','2013-04-12','08:15:00',1.4),('11288','2013-04-12','08:20:00',1.53),('11288','2013-04-12','08:25:00',1.38),('11288','2013-04-12','08:30:00',1.68),('11288','2013-04-12','08:35:00',1.63),('11288','2013-04-12','08:40:00',1.59),('11288','2013-04-12','08:45:00',2.32),('11288','2013-04-12','08:50:00',2.54),('11288','2013-04-12','08:55:00',2.91),('11288','2013-04-12','09:00:00',2.14),('11288','2013-04-12','09:05:00',1.95),('11288','2013-04-12','09:10:00',1.72),('11288','2013-04-12','09:15:00',2.62),('11288','2013-04-12','09:20:00',3.02),('11288','2013-04-12','09:25:00',3.34),('11288','2013-04-12','09:30:00',2.28),('11288','2013-04-12','09:35:00',2.07),('11288','2013-04-12','09:40:00',2.09),('11288','2013-04-12','09:45:00',1.76),('11288','2013-04-12','09:50:00',1.52),('11288','2013-04-12','09:55:00',1.63),('11288','2013-04-12','10:00:00',1.81),('11288','2013-04-12','10:05:00',2.42),('11288','2013-04-12','10:10:00',1.72),('11288','2013-04-12','10:15:00',3.01),('11288','2013-04-12','10:20:00',5.2),('11288','2013-04-12','10:25:00',3.64),('11288','2013-04-12','10:30:00',2.8),('11288','2013-04-12','10:35:00',5.07),('11288','2013-04-12','10:40:00',6.36),('11288','2013-04-12','10:45:00',7.35),('11288','2013-04-12','10:50:00',4.53),('11288','2013-04-12','10:55:00',2.29),('11288','2013-04-12','11:00:00',2.38),('11288','2013-04-12','11:05:00',3.33),('11288','2013-04-12','11:10:00',5.22),('11288','2013-04-12','11:15:00',5.97),('11288','2013-04-12','11:20:00',6.3),('11288','2013-04-12','11:25:00',7.23),('11288','2013-04-12','11:30:00',7.41),('11288','2013-04-12','11:35:00',3.19),('11288','2013-04-12','11:40:00',2.55),('11288','2013-04-12','11:45:00',3.34),('11288','2013-04-12','11:50:00',4.31),('11288','2013-04-12','11:55:00',5.74),('11288','2013-04-12','12:00:00',6.95),('11288','2013-04-12','12:05:00',6.96),('11288','2013-04-12','12:10:00',6.78),('11288','2013-04-12','12:15:00',7.04),('11288','2013-04-12','12:20:00',6.95),('11288','2013-04-12','12:25:00',6.99),('11288','2013-04-12','12:30:00',6.92),('11288','2013-04-12','12:35:00',6.8),('11288','2013-04-12','12:40:00',6.62),('11288','2013-04-12','12:45:00',6.81),('11288','2013-04-12','12:50:00',5.67),('11288','2013-04-12','12:55:00',6.8),('11288','2013-04-12','13:00:00',6.77),('11288','2013-04-12','13:05:00',6.69),('11288','2013-04-12','13:10:00',6.76),('11288','2013-04-12','13:15:00',6.83),('11288','2013-04-12','13:20:00',6.84),('11288','2013-04-12','13:25:00',6.84),('11288','2013-04-12','13:30:00',6.77),('11288','2013-04-12','13:35:00',6.88),('11288','2013-04-12','13:40:00',6.75),('11288','2013-04-12','13:45:00',6.79),('11288','2013-04-12','13:50:00',6.72),('11288','2013-04-12','13:55:00',6.73),('11288','2013-04-12','14:00:00',6.73),('11288','2013-04-12','14:05:00',6.67),('11288','2013-04-12','14:10:00',6.63),('11288','2013-04-12','14:15:00',6.56),('11288','2013-04-12','14:20:00',6.47),('11288','2013-04-12','14:25:00',6.45),('11288','2013-04-12','14:30:00',6.37),('11288','2013-04-12','14:35:00',6.3),('11288','2013-04-12','14:40:00',6.25),('11288','2013-04-12','14:45:00',6.16),('11288','2013-04-12','14:50:00',6.07),('11288','2013-04-12','14:55:00',6.02),('11288','2013-04-12','15:00:00',5.96),('11288','2013-04-12','15:05:00',5.87),('11288','2013-04-12','15:10:00',5.77),('11288','2013-04-12','15:15:00',5.74),('11288','2013-04-12','15:20:00',5.64),('11288','2013-04-12','15:25:00',5.52),('11288','2013-04-12','15:30:00',5.47),('11288','2013-04-12','15:35:00',5.37),('11288','2013-04-12','15:40:00',5.27),('11288','2013-04-12','15:45:00',5.2),('11288','2013-04-12','15:50:00',5.06),('11288','2013-04-12','15:55:00',4.93),('11288','2013-04-12','16:00:00',4.87),('11288','2013-04-12','16:05:00',4.75),('11288','2013-04-12','16:10:00',4.7),('11288','2013-04-12','16:15:00',4.03),('11288','2013-04-12','16:20:00',4.43),('11288','2013-04-12','16:25:00',4.29),('11288','2013-04-12','16:30:00',2.38),('11288','2013-04-12','16:35:00',1.91),('11288','2013-04-12','16:40:00',2.92),('11288','2013-04-12','16:45:00',3.94),('11288','2013-04-12','16:50:00',3.66),('11288','2013-04-12','16:55:00',3.49),('11288','2013-04-12','17:00:00',3.35),('11288','2013-04-12','17:05:00',3.16),('11288','2013-04-12','17:10:00',3.02),('11288','2013-04-12','17:15:00',2.91),('11288','2013-04-12','17:20:00',2.75),('11288','2013-04-12','17:25:00',2.67),('11288','2013-04-12','17:30:00',2.54),('11288','2013-04-12','17:35:00',2.15),('11288','2013-04-12','17:40:00',1.98),('11288','2013-04-12','17:45:00',2.03),('11288','2013-04-12','17:50:00',1.93),('11288','2013-04-12','17:55:00',1.81),('11288','2013-04-12','18:00:00',1.66),('11288','2013-04-12','18:05:00',1.5),('11288','2013-04-12','18:10:00',1.36),('11288','2013-04-12','18:15:00',1.23),('11288','2013-04-12','18:20:00',1.14),('11288','2014-03-28','07:15:00',1.05),('11288','2014-03-28','07:20:00',1.03),('11288','2014-03-28','07:25:00',1.06),('11288','2014-03-28','07:30:00',1.26),('11288','2014-03-28','07:35:00',1.4),('11288','2014-03-28','07:40:00',1.59),('11288','2014-03-28','07:45:00',1.82),('11288','2014-03-28','07:50:00',1.94),('11288','2014-03-28','07:55:00',2.01),('11288','2014-03-28','08:00:00',2.1),('11288','2014-03-28','08:05:00',2.16),('11288','2014-03-28','08:10:00',2.5),('11288','2014-03-28','08:15:00',2.6),('11288','2014-03-28','08:20:00',2.67),('11288','2014-03-28','08:25:00',3.01),('11288','2014-03-28','08:30:00',3.14),('11288','2014-03-28','08:35:00',3.09),('11288','2014-03-28','08:40:00',3.54),('11288','2014-03-28','08:45:00',3.62),('11288','2014-03-28','08:50:00',3.84),('11288','2014-03-28','08:55:00',4.09),('11288','2014-03-28','09:00:00',4.26),('11288','2014-03-28','09:05:00',4.46),('11288','2014-03-28','09:10:00',4.77),('11288','2014-03-28','09:15:00',4.85),('11288','2014-03-28','09:20:00',4.6),('11288','2014-03-28','09:25:00',5.46),('11288','2014-03-28','09:30:00',5.59),('11288','2014-03-28','09:35:00',5.21),('11288','2014-03-28','09:40:00',3.17),('11288','2014-03-28','09:45:00',3.16),('11288','2014-03-28','09:50:00',3.98),('11288','2014-03-28','09:55:00',5.85),('11288','2014-03-28','10:00:00',5.64),('11288','2014-03-28','10:05:00',5.77),('11288','2014-03-28','10:10:00',5.72),('11288','2014-03-28','10:15:00',4.27),('11288','2014-03-28','10:20:00',3.9),('11288','2014-03-28','10:25:00',5.59),('11288','2014-03-28','10:30:00',5.9),('11288','2014-03-28','10:35:00',5.82),('11288','2014-03-28','10:40:00',5.58),('11288','2014-03-28','10:45:00',4.73),('11288','2014-03-28','10:50:00',5.71),('11288','2014-03-28','10:55:00',6.31),('11288','2014-03-28','11:00:00',6.31),('11288','2014-03-28','11:05:00',6.01),('11288','2014-03-28','11:10:00',4.53),('11288','2014-03-28','11:15:00',3.8),('11288','2014-03-28','11:20:00',2.15),('11288','2014-03-28','11:25:00',4.47),('11288','2014-03-28','11:30:00',4.03),('11288','2014-03-28','11:35:00',2.93),('11288','2014-03-28','11:40:00',2.48),('11288','2014-03-28','11:45:00',4.8),('11288','2014-03-28','11:50:00',4.6),('11288','2014-03-28','11:55:00',2.41),('11288','2014-03-28','12:00:00',2.15),('11288','2014-03-28','12:05:00',6.57),('11288','2014-03-28','12:10:00',7.33),('11288','2014-03-28','12:15:00',7.57),('11288','2014-03-28','12:20:00',7.71),('11288','2014-03-28','12:25:00',3.12),('11288','2014-03-28','12:30:00',1.44),('11288','2014-03-28','12:35:00',4.85),('11288','2014-03-28','12:40:00',4.54),('11288','2014-03-28','12:45:00',7.15),('11288','2014-03-28','12:50:00',6.88),('11288','2014-03-28','12:55:00',4.25),('11288','2014-03-28','13:00:00',5.11),('11288','2014-03-28','13:05:00',5.48),('11288','2014-03-28','13:10:00',5.04),('11288','2014-03-28','13:15:00',3.32),('11288','2014-03-28','13:20:00',3.68),('11288','2014-03-28','13:25:00',2.99),('11288','2014-03-28','13:30:00',2.51),('11288','2014-03-28','13:35:00',6.19),('11288','2014-03-28','13:40:00',6.49),('11288','2014-03-28','13:45:00',6.52),('11288','2014-03-28','13:50:00',6.21),('11288','2014-03-28','13:55:00',6.06),('11288','2014-03-28','14:00:00',6.05),('11288','2014-03-28','14:05:00',5.92),('11288','2014-03-28','14:10:00',5.85),('11288','2014-03-28','14:15:00',5.8),('11288','2014-03-28','14:20:00',5.7),('11288','2014-03-28','14:25:00',5.64),('11288','2014-03-28','14:30:00',5.57),('11288','2014-03-28','14:35:00',5.49),('11288','2014-03-28','14:40:00',5.42),('11288','2014-03-28','14:45:00',5.3),('11288','2014-03-28','14:50:00',5.2),('11288','2014-03-28','14:55:00',5.12),('11288','2014-03-28','15:00:00',5.04),('11288','2014-03-28','15:05:00',4.94),('11288','2014-03-28','15:10:00',4.74),('11288','2014-03-28','15:15:00',4.62),('11288','2014-03-28','15:20:00',4.5),('11288','2014-03-28','15:25:00',4.35),('11288','2014-03-28','15:30:00',4.23),('11288','2014-03-28','15:35:00',4.12),('11288','2014-03-28','15:40:00',3.96),('11288','2014-03-28','15:45:00',3.92),('11288','2014-03-28','15:50:00',3.87),('11288','2014-03-28','15:55:00',3.48),('11288','2014-03-28','16:00:00',3.8),('11288','2014-03-28','16:05:00',3.85),('11288','2014-03-28','16:10:00',3.67),('11288','2014-03-28','16:15:00',3.5),('11288','2014-03-28','16:20:00',2.98),('11288','2014-03-28','16:25:00',2.62),('11288','2014-03-28','16:30:00',2.47),('11288','2014-03-28','16:35:00',1.41),('11288','2014-03-28','16:40:00',1.23),('11288','2014-03-28','16:45:00',1.77),('11288','2014-03-28','16:50:00',1.86),('11288','2014-03-28','16:55:00',1.02),('11288','2014-03-28','17:00:00',1.41),('11288','2014-03-28','17:05:00',1.21),('11288','2014-03-28','17:10:00',1.18),('11288','2014-03-28','17:15:00',1.17),('11288','2014-03-28','17:20:00',1.32),('11288','2013-04-11','07:55:00',1.01),('11288','2013-04-11','08:00:00',1.14),('11288','2013-04-11','08:05:00',1.23),('11288','2013-04-11','08:10:00',1.33),('11288','2013-04-11','08:15:00',1.48),('11288','2013-04-11','08:20:00',1.58),('11288','2013-04-11','08:25:00',1.69),('11288','2013-04-11','08:30:00',1.91),('11288','2013-04-11','08:35:00',2.01),('11288','2013-04-11','08:40:00',2.21),('11288','2013-04-11','08:45:00',2.43),('11288','2013-04-11','08:50:00',2.51),('11288','2013-04-11','08:55:00',2.67),('11288','2013-04-11','09:00:00',2.78),('11288','2013-04-11','09:05:00',2.94),('11288','2013-04-11','09:10:00',3.01),('11288','2013-04-11','09:15:00',3.16),('11288','2013-04-11','09:20:00',3.31),('11288','2013-04-11','09:25:00',3.48),('11288','2013-04-11','09:30:00',3.51),('11288','2013-04-11','09:35:00',3.63),('11288','2013-04-11','09:40:00',2.94),('11288','2013-04-11','09:45:00',3.83),('11288','2013-04-11','09:50:00',3.07),('11288','2013-04-11','09:55:00',1.9),('11288','2013-04-11','10:00:00',2.11),('11288','2013-04-11','10:05:00',1.29),('11288','2013-04-11','10:10:00',4.95),('11288','2013-04-11','10:15:00',4.93),('11288','2013-04-11','10:20:00',5.19),('11288','2013-04-11','10:25:00',5.58),('11288','2013-04-11','10:30:00',5.59),('11288','2013-04-11','10:35:00',5.98),('11288','2013-04-11','10:40:00',5.51),('11288','2013-04-11','10:45:00',5.2),('11288','2013-04-11','10:50:00',1.39),('11288','2013-04-11','10:55:00',1.77),('11288','2013-04-11','11:00:00',3.1),('11288','2013-04-11','11:05:00',4.53),('11288','2013-04-11','11:10:00',6.34),('11288','2013-04-11','11:15:00',4.93),('11288','2013-04-11','11:20:00',2.88),('11288','2013-04-11','11:25:00',5.41),('11288','2013-04-11','11:30:00',6.36),('11288','2013-04-11','11:35:00',5.77),('11288','2013-04-11','11:40:00',2.05),('11288','2013-04-11','11:45:00',4.19),('11288','2013-04-11','11:50:00',7.27),('11288','2013-04-11','11:55:00',7.62),('11288','2013-04-11','12:00:00',7.45),('11288','2013-04-11','12:05:00',7.34),('11288','2013-04-11','12:10:00',7.27),('11288','2013-04-11','12:15:00',5.71),('11288','2013-04-11','12:20:00',7.04),('11288','2013-04-11','12:25:00',6.98),('11288','2013-04-11','12:30:00',5.76),('11288','2013-04-11','12:35:00',5.85),('11288','2013-04-11','12:40:00',3.69),('11288','2013-04-11','12:45:00',4.12),('11288','2013-04-11','12:50:00',7.27),('11288','2013-04-11','12:55:00',7.17),('11288','2013-04-11','13:00:00',7.44),('11288','2013-04-11','13:05:00',7.29),('11288','2013-04-11','13:10:00',6.64),('11288','2013-04-11','13:15:00',4.23),('11288','2013-04-11','13:20:00',6.56),('11288','2013-04-11','13:25:00',6.93),('11288','2013-04-11','13:30:00',6.91),('11288','2013-04-11','13:35:00',6.86),('11288','2013-04-11','13:40:00',6.73),('11288','2013-04-11','13:45:00',6.62),('11288','2013-04-11','13:50:00',6.66),('11288','2013-04-11','13:55:00',6.67),('11288','2013-04-11','14:00:00',6.49),('11288','2013-04-11','14:05:00',6.69),('11288','2013-04-11','14:10:00',6.69),('11288','2013-04-11','14:15:00',6.63),('11288','2013-04-11','14:20:00',6.56),('11288','2013-04-11','14:25:00',6.43),('11288','2013-04-11','14:30:00',6.38),('11288','2013-04-11','14:35:00',6.41),('11288','2013-04-11','14:40:00',6.38),('11288','2013-04-11','14:45:00',6.23),('11288','2013-04-11','14:50:00',6.17),('11288','2013-04-11','14:55:00',6.06),('11288','2013-04-11','15:00:00',5.96),('11288','2013-04-11','15:05:00',5.86),('11288','2013-04-11','15:10:00',5.85),('11288','2013-04-11','15:15:00',5.77),('11288','2013-04-11','15:20:00',5.69),('11288','2013-04-11','15:25:00',5.6),('11288','2013-04-11','15:30:00',5.52),('11288','2013-04-11','15:35:00',5.44),('11288','2013-04-11','15:40:00',5.32),('11288','2013-04-11','15:45:00',5.24),('11288','2013-04-11','15:50:00',5.14),('11288','2013-04-11','15:55:00',5.02),('11288','2013-04-11','16:00:00',4.94),('11288','2013-04-11','16:05:00',4.83),('11288','2013-04-11','16:10:00',4.73),('11288','2013-04-11','16:15:00',4.57),('11288','2013-04-11','16:20:00',4.47),('11288','2013-04-11','16:25:00',4.36),('11288','2013-04-11','16:30:00',4.23),('11288','2013-04-11','16:35:00',4.09),('11288','2013-04-11','16:40:00',3.97),('11288','2013-04-11','16:45:00',3.86),('11288','2013-04-11','16:50:00',3.7),('11288','2013-04-11','16:55:00',3.58),('11288','2013-04-11','17:00:00',3.41),('11288','2013-04-11','17:05:00',3.25),('11288','2013-04-11','17:10:00',3.12),('11288','2013-04-11','17:15:00',2.98),('11288','2013-04-11','17:20:00',2.81),('11288','2013-04-11','17:25:00',2.7),('11288','2013-04-11','17:30:00',2.57),('11288','2013-04-11','17:35:00',2.43),('11288','2013-04-11','17:40:00',2.29),('11288','2013-04-11','17:45:00',2.14),('11288','2013-04-11','17:50:00',2.01),('11288','2013-04-11','17:55:00',1.82),('11288','2013-04-11','18:00:00',1.64),('11288','2013-04-11','18:05:00',1.49),('11288','2013-04-11','18:10:00',1.28),('11288','2013-04-11','18:15:00',1.31),('11288','2013-04-11','18:20:00',1.25),('11288','2013-04-11','18:25:00',1.14),('11288','2013-04-10','08:50:00',1.61),('11288','2013-04-10','08:55:00',2.56),('11288','2013-04-10','09:00:00',2.87),('11288','2013-04-10','09:05:00',3.2),('11288','2013-04-10','09:10:00',3.39),('11288','2013-04-10','09:15:00',3.4),('11288','2013-04-10','09:20:00',3.25),('11288','2013-04-10','09:25:00',3.55),('11288','2013-04-10','09:30:00',3.65),('11288','2013-04-10','09:35:00',3.87),('11288','2013-04-10','09:40:00',3.97),('11288','2013-04-10','09:45:00',3.98),('11288','2013-04-10','09:50:00',4.11),('11288','2013-04-10','09:55:00',4.05),('11288','2013-04-10','10:00:00',4.7),('11288','2013-04-10','10:05:00',4.89),('11288','2013-04-10','10:10:00',4.91),('11288','2013-04-10','10:15:00',5.4),('11288','2013-04-10','10:20:00',5.46),('11288','2013-04-10','10:25:00',5.55),('11288','2013-04-10','10:30:00',5.58),('11288','2013-04-10','10:35:00',5.68),('11288','2013-04-10','10:40:00',5.69),('11288','2013-04-10','10:45:00',5.77),('11288','2013-04-10','10:50:00',5.49),('11288','2013-04-10','10:55:00',5.68),('11288','2013-04-10','11:00:00',5.67),('11288','2013-04-10','11:05:00',5.62),('11288','2013-04-10','11:10:00',5.79),('11288','2013-04-10','11:15:00',5.79),('11288','2013-04-10','11:20:00',6.01),('11288','2013-04-10','11:25:00',6.31),('11288','2013-04-10','11:30:00',6.29),('11288','2013-04-10','11:35:00',6.37),('11288','2013-04-10','11:40:00',6.44),('11288','2013-04-10','11:45:00',6.48),('11288','2013-04-10','11:50:00',6.58),('11288','2013-04-10','11:55:00',6.58),('11288','2013-04-10','12:00:00',6.8),('11288','2013-04-10','12:05:00',6.96),('11288','2013-04-10','12:10:00',7.04),('11288','2013-04-10','12:15:00',7.01),('11288','2013-04-10','12:20:00',7.02),('11288','2013-04-10','12:25:00',7.07),('11288','2013-04-10','12:30:00',7.2),('11288','2013-04-10','12:35:00',6.35),('11288','2013-04-10','12:40:00',7.13),('11288','2013-04-10','12:45:00',7.17),('11288','2013-04-10','12:50:00',7.27),('11288','2013-04-10','12:55:00',6.49),('11288','2013-04-10','13:00:00',4.01),('11288','2013-04-10','13:05:00',4.79),('11288','2013-04-10','13:10:00',3.8),('11288','2013-04-10','13:15:00',6.6),('11288','2013-04-10','13:20:00',7.56),('11288','2013-04-10','13:25:00',7.31),('11288','2013-04-10','13:30:00',6.7),('11288','2013-04-10','13:35:00',6.24),('11288','2013-04-10','13:40:00',5.29),('11288','2013-04-10','13:45:00',4.67),('11288','2013-04-10','13:50:00',7.75),('11288','2013-04-10','13:55:00',4.12),('11288','2013-04-10','14:00:00',7.22),('11288','2013-04-10','14:05:00',6.98),('11288','2013-04-10','14:10:00',6.89),('11288','2013-04-10','14:15:00',6.75),('11288','2013-04-10','14:20:00',6.73),('11288','2013-04-10','14:25:00',6.81),('11288','2013-04-10','14:30:00',6.74),('11288','2013-04-10','14:35:00',5.5),('11288','2013-04-10','14:40:00',6.64),('11288','2013-04-10','14:45:00',6.73),('11288','2013-04-10','14:50:00',6.64),('11288','2013-04-10','14:55:00',6.15),('11288','2013-04-10','15:00:00',6.55),('11288','2013-04-10','15:05:00',4.35),('11288','2013-04-10','15:10:00',5.95),('11288','2013-04-10','15:15:00',5.85),('11288','2013-04-10','15:20:00',6.24),('11288','2013-04-10','15:25:00',5.8),('11288','2013-04-10','15:30:00',5.65),('11288','2013-04-10','15:35:00',5.62),('11288','2013-04-10','15:40:00',5.47),('11288','2013-04-10','15:45:00',5.37),('11288','2013-04-10','15:50:00',5.33),('11288','2013-04-10','15:55:00',5.23),('11288','2013-04-10','16:00:00',4),('11288','2013-04-10','16:05:00',5.11),('11288','2013-04-10','16:10:00',5),('11288','2013-04-10','16:15:00',5),('11288','2013-04-10','16:20:00',4.33),('11288','2013-04-10','16:25:00',4.55),('11288','2013-04-10','16:30:00',3.75),('11288','2013-04-10','16:35:00',2.85),('11288','2013-04-10','16:40:00',3.17),('11288','2013-04-10','16:45:00',4.14),('11288','2013-04-10','16:50:00',3.43),('11288','2013-04-10','16:55:00',3.62),('11288','2013-04-10','17:00:00',3.07),('11288','2013-04-10','17:05:00',2.66),('11288','2013-04-10','17:10:00',2.65),('11288','2013-04-10','17:15:00',2.88),('11288','2013-04-10','17:20:00',2.9),('11288','2013-04-10','17:25:00',2.61),('11288','2013-04-10','17:30:00',2.6),('11288','2013-04-10','17:35:00',2.05),('11288','2013-04-10','17:40:00',2.12),('11288','2013-04-10','17:45:00',2.25),('11288','2013-04-10','17:50:00',2.2),('11288','2013-04-10','17:55:00',1.79),('11288','2013-04-10','18:00:00',1.57),('11288','2013-04-10','18:05:00',1.17),('11288','2013-04-10','18:10:00',1.27),('11288','2013-04-09','07:50:00',1.04),('11288','2013-04-09','07:55:00',1.27),('11288','2013-04-09','08:00:00',1.17),('11288','2013-04-09','08:10:00',1.07),('11288','2013-04-09','08:15:00',1.04),('11288','2013-04-09','08:20:00',1.96),('11288','2013-04-09','08:25:00',1.39),('11288','2013-04-09','08:30:00',1.63),('11288','2013-04-09','08:35:00',1.4),('11288','2013-04-09','08:45:00',1.13),('11288','2013-04-09','08:50:00',1.02),('11288','2013-04-09','09:00:00',1.31),('11288','2013-04-09','09:05:00',1.67),('11288','2013-04-09','09:10:00',1.72),('11288','2013-04-09','09:15:00',1.85),('11288','2013-04-09','09:20:00',1.7),('11288','2013-04-09','09:25:00',1.94),('11288','2013-04-09','09:30:00',1.84),('11288','2013-04-09','09:35:00',1.46),('11288','2013-04-09','09:40:00',1.83),('11288','2013-04-09','09:45:00',3.07),('11288','2013-04-09','09:50:00',3.27),('11288','2013-04-09','09:55:00',4.27),('11288','2013-04-09','10:00:00',3.72),('11288','2013-04-09','10:05:00',2.24),('11288','2013-04-09','10:10:00',2.31),('11288','2013-04-09','10:15:00',3.85),('11288','2013-04-09','10:20:00',2.83),('11288','2013-04-09','10:25:00',1.21),('11288','2013-04-09','10:30:00',2.44),('11288','2013-04-09','10:35:00',3.57),('11288','2013-04-09','10:40:00',4.45),('11288','2013-04-09','10:45:00',6.52),('11288','2013-04-09','10:50:00',5.23),('11288','2013-04-09','10:55:00',6.65),('11288','2013-04-09','11:00:00',5.07),('11288','2013-04-09','11:05:00',5.71),('11288','2013-04-09','11:10:00',5.19),('11288','2013-04-09','11:15:00',1.42),('11288','2013-04-09','11:20:00',2.55),('11288','2013-04-09','11:25:00',5.25),('11288','2013-04-09','11:30:00',6.52),('11288','2013-04-09','11:35:00',3.11),('11288','2013-04-09','11:40:00',4.2),('11288','2013-04-09','11:45:00',4.48),('11288','2013-04-09','11:50:00',6.28),('11288','2013-04-09','11:55:00',5.44),('11288','2013-04-09','12:00:00',7.29),('11288','2013-04-09','12:05:00',7.35),('11288','2013-04-09','12:10:00',7.37),('11288','2013-04-09','12:15:00',7.22),('11288','2013-04-09','12:20:00',6.78),('11288','2013-04-09','12:25:00',6.97),('11288','2013-04-09','12:30:00',7.15),('11288','2013-04-09','12:35:00',7.19),('11288','2013-04-09','12:40:00',7.29),('11288','2013-04-09','12:45:00',6.43),('11288','2013-04-09','12:50:00',7.22),('11288','2013-04-09','12:55:00',6.38),('11288','2013-04-09','13:00:00',7.3),('11288','2013-04-09','13:05:00',7.41),('11288','2013-04-09','13:10:00',7.77),('11288','2013-04-09','13:15:00',5.51),('11288','2013-04-09','13:20:00',4.89),('11288','2013-04-09','13:25:00',6.39),('11288','2013-04-09','13:30:00',1.92),('11288','2013-04-09','13:35:00',3.98),('11288','2013-04-09','13:40:00',3.71),('11288','2013-04-09','13:45:00',5.21),('11288','2013-04-09','13:50:00',7.16),('11288','2013-04-09','13:55:00',6.93),('11288','2013-04-09','14:00:00',6.5),('11288','2013-04-09','14:05:00',5.06),('11288','2013-04-09','14:10:00',4.81),('11288','2013-04-09','14:15:00',5.61),('11288','2013-04-09','14:20:00',3.93),('11288','2013-04-09','14:25:00',5.04),('11288','2013-04-09','14:30:00',4.81),('11288','2013-04-09','14:35:00',5.65),('11288','2013-04-09','14:40:00',5.92),('11288','2013-04-09','14:45:00',5.81),('11288','2013-04-09','14:50:00',5.21),('11288','2013-04-09','14:55:00',3.68),('11288','2013-04-09','15:00:00',5.73),('11288','2013-04-09','15:05:00',5.6),('11288','2013-04-09','15:10:00',5.35),('11288','2013-04-09','15:15:00',5.4),('11288','2013-04-09','15:20:00',6.24),('11288','2013-04-09','15:25:00',5.96),('11288','2013-04-09','15:30:00',3.53),('11288','2013-04-09','15:35:00',6.13),('11288','2013-04-09','15:40:00',5.78),('11288','2013-04-09','15:45:00',5.77),('11288','2013-04-09','15:50:00',5.68),('11288','2013-04-09','15:55:00',4.61),('11288','2013-04-09','16:00:00',4.13),('11288','2013-04-09','16:05:00',4.76),('11288','2013-04-09','16:10:00',2.31),('11288','2013-04-09','16:15:00',2.33),('11288','2013-04-09','16:20:00',1.15),('11288','2013-04-09','16:25:00',1.98),('11288','2013-04-09','16:30:00',1.75),('11288','2013-04-09','16:35:00',2.22),('11288','2013-04-09','16:40:00',2),('11288','2013-04-09','16:45:00',2.24),('11288','2013-04-09','16:50:00',3.92),('11288','2013-04-09','16:55:00',2.19),('11288','2013-04-09','17:00:00',1.36),('11288','2013-04-09','17:05:00',1.12),('11288','2013-04-09','17:10:00',1.1),('11288','2013-04-09','17:15:00',1.82),('11288','2013-04-09','17:20:00',1.82),('11288','2013-04-09','17:25:00',1.39),('11288','2013-04-09','17:30:00',1.52),('11288','2013-04-09','17:35:00',1.37),('11288','2013-04-09','17:40:00',1.57),('11288','2013-04-09','17:45:00',1.23),('11288','2013-04-09','17:50:00',1.03),('11288','2013-04-09','18:00:00',1.06),('11288','2013-04-09','18:05:00',1.02),('11288','2013-04-09','18:15:00',1.34),('11288','2013-04-09','18:20:00',1.33),('11288','2013-04-08','08:05:00',1.12),('11288','2013-04-08','08:10:00',1.29),('11288','2013-04-08','08:15:00',1.42),('11288','2013-04-08','08:20:00',1.32),('11288','2013-04-08','08:25:00',1.3),('11288','2013-04-08','08:30:00',1.34),('11288','2013-04-08','08:35:00',1.35),('11288','2013-04-08','08:40:00',1.79),('11288','2013-04-08','08:45:00',1.74),('11288','2013-04-08','08:50:00',1.9),('11288','2013-04-08','08:55:00',2.2),('11288','2013-04-08','09:00:00',2.18),('11288','2013-04-08','09:05:00',2.25),('11288','2013-04-08','09:10:00',2.1),('11288','2013-04-08','09:15:00',2.93),('11288','2013-04-08','09:20:00',3.36),('11288','2013-04-08','09:25:00',3.35),('11288','2013-04-08','09:30:00',3.78),('11288','2013-04-08','09:35:00',4),('11288','2013-04-08','09:40:00',4.03),('11288','2013-04-08','09:45:00',4.15),('11288','2013-04-08','09:50:00',2.42),('11288','2013-04-08','09:55:00',3.06),('11288','2013-04-08','10:00:00',4.49),('11288','2013-04-08','10:05:00',4.12),('11288','2013-04-08','10:10:00',4.58),('11288','2013-04-08','10:15:00',4.87),('11288','2013-04-08','10:20:00',4.91),('11288','2013-04-08','10:25:00',4.93),('11288','2013-04-08','10:30:00',5.16),('11288','2013-04-08','10:35:00',4.97),('11288','2013-04-08','10:40:00',5.59),('11288','2013-04-08','10:45:00',5.83),('11288','2013-04-08','10:50:00',5.8),('11288','2013-04-08','10:55:00',5.58),('11288','2013-04-08','11:00:00',5.72),('11288','2013-04-08','11:05:00',5.06),('11288','2013-04-08','11:10:00',5.03),('11288','2013-04-08','11:15:00',4.25),('11288','2013-04-08','11:20:00',3.74),('11288','2013-04-08','11:25:00',3.41),('11288','2013-04-08','11:30:00',3.97),('11288','2013-04-08','11:35:00',5.01),('11288','2013-04-08','11:40:00',5.11),('11288','2013-04-08','11:45:00',4.7),('11288','2013-04-08','11:50:00',4.26),('11288','2013-04-08','11:55:00',3.99),('11288','2013-04-08','12:00:00',3.72),('11288','2013-04-08','12:05:00',3.63),('11288','2013-04-08','12:10:00',4.02),('11288','2013-04-08','12:15:00',4.66),('11288','2013-04-08','12:20:00',4.69),('11288','2013-04-08','12:25:00',4.56),('11288','2013-04-08','12:30:00',5.03),('11288','2013-04-08','12:35:00',4.11),('11288','2013-04-08','12:40:00',4.97),('11288','2013-04-08','12:45:00',6.1),('11288','2013-04-08','12:50:00',3.69),('11288','2013-04-08','12:55:00',3.05),('11288','2013-04-08','13:00:00',3.7),('11288','2013-04-08','13:05:00',4.27),('11288','2013-04-08','13:10:00',4.75),('11288','2013-04-08','13:15:00',5.59),('11288','2013-04-08','13:20:00',5.89),('11288','2013-04-08','13:25:00',5.4),('11288','2013-04-08','13:30:00',4.54),('11288','2013-04-08','13:35:00',3.04),('11288','2013-04-08','13:40:00',4.78),('11288','2013-04-08','13:45:00',4.7),('11288','2013-04-08','13:50:00',5.15),('11288','2013-04-08','13:55:00',6.41),('11288','2013-04-08','14:00:00',6.01),('11288','2013-04-08','14:05:00',5.44),('11288','2013-04-08','14:10:00',5.61),('11288','2013-04-08','14:15:00',6.21),('11288','2013-04-08','14:20:00',5.59),('11288','2013-04-08','14:25:00',6.49),('11288','2013-04-08','14:30:00',6.24),('11288','2013-04-08','14:35:00',5.71),('11288','2013-04-08','14:40:00',6.02),('11288','2013-04-08','14:45:00',6.18),('11288','2013-04-08','14:50:00',6),('11288','2013-04-08','14:55:00',5.99),('11288','2013-04-08','15:00:00',4.86),('11288','2013-04-08','15:05:00',4.53),('11288','2013-04-08','15:10:00',5.03),('11288','2013-04-08','15:15:00',4.64),('11288','2013-04-08','15:20:00',5.09),('11288','2013-04-08','15:25:00',5.8),('11288','2013-04-08','15:30:00',5.81),('11288','2013-04-08','15:35:00',5.56),('11288','2013-04-08','15:40:00',5.34),('11288','2013-04-08','15:45:00',5.3),('11288','2013-04-08','15:50:00',5.16),('11288','2013-04-08','15:55:00',5.06),('11288','2013-04-08','16:00:00',4.9),('11288','2013-04-08','16:05:00',4.61),('11288','2013-04-08','16:10:00',4.41),('11288','2013-04-08','16:15:00',4.62),('11288','2013-04-08','16:20:00',4.57),('11288','2013-04-08','16:25:00',4.36),('11288','2013-04-08','16:30:00',4.23),('11288','2013-04-08','16:35:00',4.08),('11288','2013-04-08','16:40:00',3.97),('11288','2013-04-08','16:45:00',3.88),('11288','2013-04-08','16:50:00',3.72),('11288','2013-04-08','16:55:00',3.57),('11288','2013-04-08','17:00:00',3.47),('11288','2013-04-08','17:05:00',3.3),('11288','2013-04-08','17:10:00',3.06),('11288','2013-04-08','17:15:00',2.89),('11288','2013-04-08','17:20:00',2.75),('11288','2013-04-08','17:25:00',2.8),('11288','2013-04-08','17:30:00',2.56),('11288','2013-04-08','17:35:00',2.37),('11288','2013-04-08','17:40:00',2.12),('11288','2013-04-08','17:45:00',1.99),('11288','2013-04-08','17:50:00',1.6),('11288','2013-04-08','17:55:00',1.44),('11288','2013-04-08','18:00:00',1.53),('11288','2013-04-08','18:15:00',1.21),('11288','2013-04-08','18:20:00',1.75),('11288','2013-04-08','18:25:00',1.52),('11288','2013-04-07','08:20:00',1.09),('11288','2013-04-07','08:25:00',1.25),('11288','2013-04-07','08:30:00',1.46),('11288','2013-04-07','08:35:00',1.59),('11288','2013-04-07','08:40:00',1.65),('11288','2013-04-07','08:45:00',1.68),('11288','2013-04-07','08:50:00',1.71),('11288','2013-04-07','08:55:00',1.85),('11288','2013-04-07','09:00:00',1.95),('11288','2013-04-07','09:05:00',2.08),('11288','2013-04-07','09:10:00',2.22),('11288','2013-04-07','09:15:00',2.28),('11288','2013-04-07','09:20:00',2.32),('11288','2013-04-07','09:25:00',2.32),('11288','2013-04-07','09:30:00',2.45),('11288','2013-04-07','09:35:00',2.36),('11288','2013-04-07','09:40:00',2.34),('11288','2013-04-07','09:45:00',2.44),('11288','2013-04-07','09:50:00',3.08),('11288','2013-04-07','09:55:00',3.3),('11288','2013-04-07','10:00:00',3.8),('11288','2013-04-07','10:05:00',4.28),('11288','2013-04-07','10:10:00',4.37),('11288','2013-04-07','10:15:00',4.47),('11288','2013-04-07','10:20:00',4.62),('11288','2013-04-07','10:25:00',4.72),('11288','2013-04-07','10:30:00',4.13),('11288','2013-04-07','10:35:00',4.19),('11288','2013-04-07','10:40:00',4.55),('11288','2013-04-07','10:45:00',4.44),('11288','2013-04-07','10:50:00',4.31),('11288','2013-04-07','10:55:00',3.81),('11288','2013-04-07','11:00:00',3.6),('11288','2013-04-07','11:05:00',3.2),('11288','2013-04-07','11:10:00',3.29),('11288','2013-04-07','11:15:00',4.4),('11288','2013-04-07','11:20:00',5.74),('11288','2013-04-07','11:25:00',6.09),('11288','2013-04-07','11:30:00',6.2),('11288','2013-04-07','11:35:00',5.73),('11288','2013-04-07','11:40:00',5.35),('11288','2013-04-07','11:45:00',4.29),('11288','2013-04-07','11:50:00',3.81),('11288','2013-04-07','11:55:00',3.96),('11288','2013-04-07','12:00:00',4.12),('11288','2013-04-07','12:05:00',4.14),('11288','2013-04-07','12:10:00',4.42),('11288','2013-04-07','12:15:00',4.36),('11288','2013-04-07','12:20:00',4.76),('11288','2013-04-07','12:25:00',5.18),('11288','2013-04-07','12:30:00',4.76),('11288','2013-04-07','12:35:00',4.81),('11288','2013-04-07','12:40:00',4.81),('11288','2013-04-07','12:45:00',4.12),('11288','2013-04-07','12:50:00',4.42),('11288','2013-04-07','12:55:00',4.42),('11288','2013-04-07','13:00:00',5.2),('11288','2013-04-07','13:05:00',5.71),('11288','2013-04-07','13:10:00',5.53),('11288','2013-04-07','13:15:00',4.99),('11288','2013-04-07','13:20:00',4.97),('11288','2013-04-07','13:25:00',5.38),('11288','2013-04-07','13:30:00',4.73),('11288','2013-04-07','13:35:00',5.19),('11288','2013-04-07','13:40:00',5.49),('11288','2013-04-07','13:45:00',4.92),('11288','2013-04-07','13:50:00',4.44),('11288','2013-04-07','13:55:00',4.82),('11288','2013-04-07','14:00:00',5.91),('11288','2013-04-07','14:05:00',5.67),('11288','2013-04-07','14:10:00',3.2),('11288','2013-04-07','14:15:00',4.09),('11288','2013-04-07','14:20:00',4.24),('11288','2013-04-07','14:25:00',3.21),('11288','2013-04-07','14:30:00',2.55),('11288','2013-04-07','14:35:00',3.34),('11288','2013-04-07','14:40:00',3.6),('11288','2013-04-07','14:45:00',3.43),('11288','2013-04-07','14:50:00',3.67),('11288','2013-04-07','14:55:00',4.39),('11288','2013-04-07','15:00:00',3.28),('11288','2013-04-07','15:05:00',3.63),('11288','2013-04-07','15:10:00',4.31),('11288','2013-04-07','15:15:00',3.91),('11288','2013-04-07','15:20:00',3.35),('11288','2013-04-07','15:25:00',3.46),('11288','2013-04-07','15:30:00',4.83),('11288','2013-04-07','15:35:00',4.56),('11288','2013-04-07','15:40:00',4.33),('11288','2013-04-07','15:45:00',2.89),('11288','2013-04-07','15:50:00',4.08),('11288','2013-04-07','15:55:00',4.09),('11288','2013-04-07','16:00:00',3.69),('11288','2013-04-07','16:05:00',3.18),('11288','2013-04-07','16:10:00',2.88),('11288','2013-04-07','16:15:00',2.36),('11288','2013-04-07','16:20:00',2.37),('11288','2013-04-07','16:25:00',2.13),('11288','2013-04-07','16:30:00',2.39),('11288','2013-04-07','16:35:00',2.85),('11288','2013-04-07','16:40:00',2.94),('11288','2013-04-07','16:45:00',3.19),('11288','2013-04-07','16:50:00',3.75),('11288','2013-04-07','16:55:00',3.51),('11288','2013-04-07','17:00:00',3.29),('11288','2013-04-07','17:05:00',3.21),('11288','2013-04-07','17:10:00',3.05),('11288','2013-04-07','17:15:00',2.24),('11288','2013-04-07','17:20:00',2.19),('11288','2013-04-07','17:25:00',2.83),('11288','2013-04-07','17:30:00',2.58),('11288','2013-04-07','17:35:00',2.57),('11288','2013-04-07','17:40:00',2.51),('11288','2013-04-07','17:45:00',2.43),('11288','2013-04-07','17:50:00',2.2),('11288','2013-04-07','17:55:00',1.88),('11288','2013-04-07','18:00:00',1.36),('11288','2013-04-06','08:00:00',1.02),('11288','2013-04-06','08:05:00',1.08),('11288','2013-04-06','08:10:00',1.17),('11288','2013-04-06','08:15:00',1.35),('11288','2013-04-06','08:20:00',1.48),('11288','2013-04-06','08:25:00',1.69),('11288','2013-04-06','08:30:00',1.85),('11288','2013-04-06','08:35:00',1.89),('11288','2013-04-06','08:40:00',2.05),('11288','2013-04-06','08:45:00',2.16),('11288','2013-04-06','08:50:00',2.39),('11288','2013-04-06','08:55:00',2.54),('11288','2013-04-06','09:00:00',2.66),('11288','2013-04-06','09:05:00',2.74),('11288','2013-04-06','09:10:00',2.88),('11288','2013-04-06','09:15:00',2.98),('11288','2013-04-06','09:20:00',3.12),('11288','2013-04-06','09:25:00',3.28),('11288','2013-04-06','09:30:00',3.48),('11288','2013-04-06','09:35:00',3.53),('11288','2013-04-06','09:40:00',3.77),('11288','2013-04-06','09:45:00',3.74),('11288','2013-04-06','09:50:00',3.64),('11288','2013-04-06','09:55:00',4.11),('11288','2013-04-06','10:00:00',4.38),('11288','2013-04-06','10:05:00',4.56),('11288','2013-04-06','10:10:00',4.68),('11288','2013-04-06','10:15:00',4.74),('11288','2013-04-06','10:20:00',4.88),('11288','2013-04-06','10:25:00',4.97),('11288','2013-04-06','10:30:00',5.11),('11288','2013-04-06','10:35:00',5.19),('11288','2013-04-06','10:40:00',5.23),('11288','2013-04-06','10:45:00',5.3),('11288','2013-04-06','10:50:00',5.38),('11288','2013-04-06','10:55:00',5.55),('11288','2013-04-06','11:00:00',5.64),('11288','2013-04-06','11:05:00',5.72),('11288','2013-04-06','11:10:00',5.81),('11288','2013-04-06','11:15:00',5.85),('11288','2013-04-06','11:20:00',5.87),('11288','2013-04-06','11:25:00',5.93),('11288','2013-04-06','11:30:00',5.89),('11288','2013-04-06','11:35:00',5.94),('11288','2013-04-06','11:40:00',6.01),('11288','2013-04-06','11:45:00',6.07),('11288','2013-04-06','11:50:00',6.14),('11288','2013-04-06','11:55:00',6.17),('11288','2013-04-06','12:00:00',6.24),('11288','2013-04-06','12:05:00',6.37),('11288','2013-04-06','12:10:00',6.42),('11288','2013-04-06','12:15:00',6.49),('11288','2013-04-06','12:20:00',6.52),('11288','2013-04-06','12:25:00',6.53),('11288','2013-04-06','12:30:00',6.59),('11288','2013-04-06','12:35:00',6.18),('11288','2013-04-06','12:40:00',6.6),('11288','2013-04-06','12:45:00',6.78),('11288','2013-04-06','12:50:00',6.79),('11288','2013-04-06','12:55:00',6.85),('11288','2013-04-06','13:00:00',4.48),('11288','2013-04-06','13:05:00',6.96),('11288','2013-04-06','13:10:00',7.15),('11288','2013-04-06','13:15:00',7.48),('11288','2013-04-06','13:20:00',4.69),('11288','2013-04-06','13:25:00',2.03),('11288','2013-04-06','13:30:00',5.38),('11288','2013-04-06','13:35:00',4.59),('11288','2013-04-06','13:40:00',2.23),('11288','2013-04-06','13:45:00',4.1),('11288','2013-04-06','13:50:00',7.02),('11288','2013-04-06','13:55:00',7.76),('11288','2013-04-06','14:00:00',6.49),('11288','2013-04-06','14:05:00',7.5),('11288','2013-04-06','14:10:00',7.17),('11288','2013-04-06','14:15:00',3.35),('11288','2013-04-06','14:20:00',3.29),('11288','2013-04-06','14:25:00',2.21),('11288','2013-04-06','14:30:00',5.36),('11288','2013-04-06','14:35:00',6.61),('11288','2013-04-06','14:40:00',6.54),('11288','2013-04-06','14:45:00',6.02),('11288','2013-04-06','14:50:00',6.11),('11288','2013-04-06','14:55:00',6.13),('11288','2013-04-06','15:00:00',5.94),('11288','2013-04-06','15:05:00',5.75),('11288','2013-04-06','15:10:00',5.63),('11288','2013-04-06','15:15:00',5.58),('11288','2013-04-06','15:20:00',5.55),('11288','2013-04-06','15:25:00',5.46),('11288','2013-04-06','15:30:00',5.16),('11288','2013-04-06','15:35:00',5.14),('11288','2013-04-06','15:40:00',5.01),('11288','2013-04-06','15:45:00',4.2),('11288','2013-04-06','15:50:00',4.25),('11288','2013-04-06','15:55:00',4.71),('11288','2013-04-06','16:00:00',4.43),('11288','2013-04-06','16:05:00',4.64),('11288','2013-04-06','16:10:00',4.64),('11288','2013-04-06','16:15:00',4.11),('11288','2013-04-06','16:20:00',3.36),('11288','2013-04-06','16:25:00',3.09),('11288','2013-04-06','16:30:00',3.7),('11288','2013-04-06','16:35:00',3.29),('11288','2013-04-06','16:40:00',2.9),('11288','2013-04-06','16:45:00',3.67),('11288','2013-04-06','16:50:00',3.35),('11288','2013-04-06','16:55:00',3.09),('11288','2013-04-06','17:00:00',3.01),('11288','2013-04-06','17:05:00',2.63),('11288','2013-04-06','17:10:00',2.32),('11288','2013-04-06','17:15:00',1.75),('11288','2013-04-06','17:20:00',1.53),('11288','2013-04-06','17:25:00',1.57),('11288','2013-04-06','17:30:00',1.54),('11288','2013-04-06','17:35:00',1.39),('11288','2013-04-06','17:40:00',1.35),('11288','2013-04-06','17:45:00',1.29),('11288','2013-04-06','17:50:00',1.27),('11288','2013-04-06','17:55:00',1.16),('11288','2013-04-06','18:00:00',1.04),('11288','2013-04-05','08:05:00',1.1),('11288','2013-04-05','08:10:00',1.24),('11288','2013-04-05','08:15:00',1.66),('11288','2013-04-05','08:20:00',1.82),('11288','2013-04-05','08:25:00',1.33),('11288','2013-04-05','08:30:00',1.02),('11288','2013-04-05','08:40:00',1.04),('11288','2013-04-05','08:45:00',1.08),('11288','2013-04-05','08:50:00',1.32),('11288','2013-04-05','08:55:00',1.58),('11288','2013-04-05','09:00:00',1.57),('11288','2013-04-05','09:05:00',3.18),('11288','2013-04-05','09:10:00',2.04),('11288','2013-04-05','09:15:00',3.04),('11288','2013-04-05','09:20:00',3.27),('11288','2013-04-05','09:25:00',1.77),('11288','2013-04-05','09:30:00',1.65),('11288','2013-04-05','09:35:00',2.2),('11288','2013-04-05','09:40:00',3.52),('11288','2013-04-05','09:45:00',2.75),('11288','2013-04-05','09:50:00',2.45),('11288','2013-04-05','09:55:00',1.83),('11288','2013-04-05','10:00:00',2.24),('11288','2013-04-05','10:05:00',2.03),('11288','2013-04-05','10:10:00',4.16),('11288','2013-04-05','10:15:00',4.35),('11288','2013-04-05','10:20:00',1.65),('11288','2013-04-05','10:25:00',5.1),('11288','2013-04-05','10:30:00',2.32),('11288','2013-04-05','10:35:00',2.8),('11288','2013-04-05','10:40:00',6.26),('11288','2013-04-05','10:45:00',2.41),('11288','2013-04-05','10:50:00',3.25),('11288','2013-04-05','10:55:00',4.17),('11288','2013-04-05','11:00:00',5.01),('11288','2013-04-05','11:05:00',5.25),('11288','2013-04-05','11:10:00',6.45),('11288','2013-04-05','11:15:00',5.7),('11288','2013-04-05','11:20:00',6.48),('11288','2013-04-05','11:25:00',5.13),('11288','2013-04-05','11:30:00',6.76),('11288','2013-04-05','11:35:00',6.48),('11288','2013-04-05','11:40:00',6.29),('11288','2013-04-05','11:45:00',6.11),('11288','2013-04-05','11:50:00',6.63),('11288','2013-04-05','11:55:00',6.88),('11288','2013-04-05','12:00:00',6.92),('11288','2013-04-05','12:05:00',4.88),('11288','2013-04-05','12:10:00',3.5),('11288','2013-04-05','12:15:00',4.89),('11288','2013-04-05','12:20:00',3.19),('11288','2013-04-05','12:25:00',4.42),('11288','2013-04-05','12:30:00',2.49),('11288','2013-04-05','12:35:00',2.8),('11288','2013-04-05','12:40:00',3.27),('11288','2013-04-05','12:45:00',4.92),('11288','2013-04-05','12:50:00',7.41),('11288','2013-04-05','12:55:00',4.98),('11288','2013-04-05','13:00:00',5.5),('11288','2013-04-05','13:05:00',5.78),('11288','2013-04-05','13:10:00',5.97),('11288','2013-04-05','13:15:00',7.79),('11288','2013-04-05','13:20:00',6.78),('11288','2013-04-05','13:25:00',4.5),('11288','2013-04-05','13:30:00',7.23),('11288','2013-04-05','13:35:00',6.21),('11288','2013-04-05','13:40:00',4.81),('11288','2013-04-05','13:45:00',6.31),('11288','2013-04-05','13:50:00',7.39),('11288','2013-04-05','13:55:00',5.14),('11288','2013-04-05','14:00:00',5.51),('11288','2013-04-05','14:05:00',7.51),('11288','2013-04-05','14:10:00',7.02),('11288','2013-04-05','14:15:00',6.15),('11288','2013-04-05','14:20:00',4.81),('11288','2013-04-05','14:25:00',6.56),('11288','2013-04-05','14:30:00',6.33),('11288','2013-04-05','14:35:00',6.09),('11288','2013-04-05','14:40:00',5.76),('11288','2013-04-05','14:45:00',5.03),('11288','2013-04-05','14:50:00',5.04),('11288','2013-04-05','14:55:00',7.55),('11288','2013-04-05','15:00:00',6.35),('11288','2013-04-05','15:05:00',6.47),('11288','2013-04-05','15:10:00',3.28),('11288','2013-04-05','15:15:00',2.85),('11288','2013-04-05','15:20:00',2.96),('11288','2013-04-05','15:25:00',3.17),('11288','2013-04-05','15:30:00',2.73),('11288','2013-04-05','15:35:00',2.12),('11288','2013-04-05','15:40:00',2),('11288','2013-04-05','15:45:00',2.52),('11288','2013-04-05','15:50:00',3.05),('11288','2013-04-05','15:55:00',2.88),('11288','2013-04-05','16:00:00',2.92),('11288','2013-04-05','16:05:00',2.79),('11288','2013-04-05','16:10:00',2.93),('11288','2013-04-05','16:15:00',3.23),('11288','2013-04-05','16:20:00',3.19),('11288','2013-04-05','16:25:00',2.41),('11288','2013-04-05','16:30:00',2.76),('11288','2013-04-05','16:35:00',3.35),('11288','2013-04-05','16:40:00',2.71),('11288','2013-04-05','16:45:00',3.57),('11288','2013-04-05','16:50:00',3.76),('11288','2013-04-05','16:55:00',2.16),('11288','2013-04-05','17:00:00',2.25),('11288','2013-04-05','17:05:00',2.15),('11288','2013-04-05','17:10:00',4.42),('11288','2013-04-05','17:15:00',3.83),('11288','2013-04-05','17:20:00',3.12),('11288','2013-04-05','17:25:00',3.21),('11288','2013-04-05','17:30:00',2.06),('11288','2013-04-05','17:35:00',2.4),('11288','2013-04-05','17:40:00',1.44),('11288','2013-04-05','17:50:00',1.75),('11288','2013-04-05','17:55:00',2.39),('11288','2013-04-05','18:00:00',1.37),('11288','2013-04-05','18:15:00',1.4),('11288','2013-04-05','18:20:00',1.12),('11288','2013-04-04','08:05:00',1.13),('11288','2013-04-04','08:10:00',1.06),('11288','2013-04-04','08:15:00',1.1),('11288','2013-04-04','08:20:00',1.14),('11288','2013-04-04','08:25:00',1.22),('11288','2013-04-04','08:30:00',1.32),('11288','2013-04-04','08:35:00',1.68),('11288','2013-04-04','08:40:00',1.47),('11288','2013-04-04','08:45:00',1.49),('11288','2013-04-04','08:50:00',1.59),('11288','2013-04-04','08:55:00',2.31),('11288','2013-04-04','09:00:00',2.88),('11288','2013-04-04','09:05:00',2.29),('11288','2013-04-04','09:10:00',2.36),('11288','2013-04-04','09:15:00',2.39),('11288','2013-04-04','09:20:00',2.1),('11288','2013-04-04','09:25:00',1.85),('11288','2013-04-04','09:30:00',2.77),('11288','2013-04-04','09:35:00',3.95),('11288','2013-04-04','09:40:00',3.84),('11288','2013-04-04','09:45:00',3.24),('11288','2013-04-04','09:50:00',2.01),('11288','2013-04-04','09:55:00',2.33),('11288','2013-04-04','10:00:00',3.19),('11288','2013-04-04','10:05:00',4.01),('11288','2013-04-04','10:10:00',3.31),('11288','2013-04-04','10:15:00',2.81),('11288','2013-04-04','10:20:00',3.5),('11288','2013-04-04','10:25:00',6.14),('11288','2013-04-04','10:30:00',4.75),('11288','2013-04-04','10:35:00',3.35),('11288','2013-04-04','10:40:00',5.69),('11288','2013-04-04','10:45:00',3.32),('11288','2013-04-04','10:50:00',3.86),('11288','2013-04-04','10:55:00',6.6),('11288','2013-04-04','11:00:00',4.1),('11288','2013-04-04','11:05:00',2.21),('11288','2013-04-04','11:10:00',2.01),('11288','2013-04-04','11:15:00',2.72),('11288','2013-04-04','11:20:00',2.43),('11288','2013-04-04','11:25:00',1.93),('11288','2013-04-04','11:30:00',2.15),('11288','2013-04-04','11:35:00',3.24),('11288','2013-04-04','11:40:00',4.97),('11288','2013-04-04','11:45:00',5.43),('11288','2013-04-04','11:50:00',5.24),('11288','2013-04-04','11:55:00',4.26),('11288','2013-04-04','12:00:00',4.6),('11288','2013-04-04','12:05:00',6.46),('11288','2013-04-04','12:10:00',6.28),('11288','2013-04-04','12:15:00',5.59),('11288','2013-04-04','12:20:00',5.45),('11288','2013-04-04','12:25:00',5.19),('11288','2013-04-04','12:30:00',6.79),('11288','2013-04-04','12:35:00',7.27),('11288','2013-04-04','12:40:00',7.09),('11288','2013-04-04','12:45:00',6.81),('11288','2013-04-04','12:50:00',4.51),('11288','2013-04-04','12:55:00',6.38),('11288','2013-04-04','13:00:00',6.45),('11288','2013-04-04','13:05:00',6.32),('11288','2013-04-04','13:10:00',6.61),('11288','2013-04-04','13:15:00',6.79),('11288','2013-04-04','13:20:00',6.56),('11288','2013-04-04','13:25:00',6.84),('11288','2013-04-04','13:30:00',6.57),('11288','2013-04-04','13:35:00',5.87),('11288','2013-04-04','13:40:00',5.06),('11288','2013-04-04','13:45:00',5.74),('11288','2013-04-04','13:50:00',5.46),('11288','2013-04-04','13:55:00',4.26),('11288','2013-04-04','14:00:00',4.68),('11288','2013-04-04','14:05:00',6.25),('11288','2013-04-04','14:10:00',6.59),('11288','2013-04-04','14:15:00',6.43),('11288','2013-04-04','14:20:00',6.35),('11288','2013-04-04','14:25:00',6.25),('11288','2013-04-04','14:30:00',6.22),('11288','2013-04-04','14:35:00',5.91),('11288','2013-04-04','14:40:00',6.14),('11288','2013-04-04','14:45:00',6.01),('11288','2013-04-04','14:50:00',6),('11288','2013-04-04','14:55:00',5.97),('11288','2013-04-04','15:00:00',5.92),('11288','2013-04-04','15:05:00',5.65),('11288','2013-04-04','15:10:00',5.42),('11288','2013-04-04','15:15:00',5.45),('11288','2013-04-04','15:20:00',5.47),('11288','2013-04-04','15:25:00',5.53),('11288','2013-04-04','15:30:00',5.46),('11288','2013-04-04','15:35:00',5.27),('11288','2013-04-04','15:40:00',5.22),('11288','2013-04-04','15:45:00',5.09),('11288','2013-04-04','15:50:00',4.91),('11288','2013-04-04','15:55:00',4.84),('11288','2013-04-04','16:00:00',4.73),('11288','2013-04-04','16:05:00',4.55),('11288','2013-04-04','16:10:00',4.32),('11288','2013-04-04','16:15:00',3.96),('11288','2013-04-04','16:20:00',3.98),('11288','2013-04-04','16:25:00',3.56),('11288','2013-04-04','16:30:00',3.22),('11288','2013-04-04','16:35:00',2.97),('11288','2013-04-04','16:40:00',3.28),('11288','2013-04-04','16:45:00',2.81),('11288','2013-04-04','16:50:00',2.63),('11288','2013-04-04','16:55:00',3),('11288','2013-04-04','17:00:00',2.8),('11288','2013-04-04','17:05:00',2.75),('11288','2013-04-04','17:10:00',2.49),('11288','2013-04-04','17:15:00',2.27),('11288','2013-04-04','17:20:00',1.64),('11288','2013-04-04','17:25:00',1.79),('11288','2013-04-04','17:30:00',1.32),('11288','2013-04-04','17:35:00',1.3),('11288','2013-04-04','17:40:00',1.45),('11288','2013-04-04','17:45:00',1.37),('11288','2013-04-04','17:50:00',1.68),('11288','2013-04-04','17:55:00',1.83),('11288','2013-04-04','18:00:00',1.51),('11288','2013-04-04','18:05:00',1.32),('11288','2013-04-03','08:05:00',1.03),('11288','2013-04-03','08:10:00',1.1),('11288','2013-04-03','08:15:00',1.32),('11288','2013-04-03','08:20:00',1.38),('11288','2013-04-03','08:25:00',1.28),('11288','2013-04-03','08:30:00',1.91),('11288','2013-04-03','08:40:00',1.37),('11288','2013-04-03','08:45:00',1.91),('11288','2013-04-03','08:50:00',2.44),('11288','2013-04-03','08:55:00',2.07),('11288','2013-04-03','09:00:00',2.5),('11288','2013-04-03','09:05:00',3.04),('11288','2013-04-03','09:10:00',2.84),('11288','2013-04-03','09:15:00',2.53),('11288','2013-04-03','09:20:00',3.55),('11288','2013-04-03','09:25:00',3.78),('11288','2013-04-03','09:30:00',3.69),('11288','2013-04-03','09:35:00',2.1),('11288','2013-04-03','09:40:00',3.89),('11288','2013-04-03','09:45:00',3.78),('11288','2013-04-03','09:50:00',4.33),('11288','2013-04-03','09:55:00',2.87),('11288','2013-04-03','10:00:00',2.96),('11288','2013-04-03','10:05:00',2.14),('11288','2013-04-03','10:10:00',2.89),('11288','2013-04-03','10:15:00',3.32),('11288','2013-04-03','10:20:00',5.51),('11288','2013-04-03','10:25:00',5.21),('11288','2013-04-03','10:30:00',7.01),('11288','2013-04-03','10:35:00',3.7),('11288','2013-04-03','10:40:00',2.78),('11288','2013-04-03','10:45:00',2.1),('11288','2013-04-03','10:50:00',2.32),('11288','2013-04-03','10:55:00',2.46),('11288','2013-04-03','11:00:00',5.46),('11288','2013-04-03','11:05:00',6.02),('11288','2013-04-03','11:10:00',5.24),('11288','2013-04-03','11:15:00',7.93),('11288','2013-04-03','11:20:00',4.33),('11288','2013-04-03','11:25:00',2.86),('11288','2013-04-03','11:30:00',3.76),('11288','2013-04-03','11:35:00',4.88),('11288','2013-04-03','11:40:00',2.75),('11288','2013-04-03','11:45:00',3.58),('11288','2013-04-03','11:50:00',6.68),('11288','2013-04-03','11:55:00',3.56),('11288','2013-04-03','12:00:00',4.94),('11288','2013-04-03','12:05:00',7.19),('11288','2013-04-03','12:10:00',6.84),('11288','2013-04-03','12:15:00',5.38),('11288','2013-04-03','12:20:00',7.77),('11288','2013-04-03','12:25:00',7.94),('11288','2013-04-03','12:30:00',7.76),('11288','2013-04-03','12:35:00',7.81),('11288','2013-04-03','12:40:00',8.07),('11288','2013-04-03','12:45:00',7.63),('11288','2013-04-03','12:50:00',7.89),('11288','2013-04-03','12:55:00',3.4),('11288','2013-04-03','13:05:00',7.26),('11288','2013-04-03','13:10:00',8.28),('11288','2013-04-03','13:15:00',7.94),('11288','2013-04-03','13:20:00',4.13),('11288','2013-04-03','13:25:00',4.89),('11288','2013-04-03','13:30:00',5.68),('11288','2013-04-03','13:35:00',6.24),('11288','2013-04-03','13:40:00',6.78),('11288','2013-04-03','13:45:00',4.36),('11288','2013-04-03','13:50:00',6.67),('11288','2013-04-03','13:55:00',5.62),('11288','2013-04-03','14:00:00',6),('11288','2013-04-03','14:05:00',4.79),('11288','2013-04-03','14:10:00',6.89),('11288','2013-04-03','14:15:00',3.62),('11288','2013-04-03','14:20:00',4.87),('11288','2013-04-03','14:25:00',3.83),('11288','2013-04-03','14:30:00',6.87),('11288','2013-04-03','14:35:00',6.69),('11288','2013-04-03','14:40:00',3.99),('11288','2013-04-03','14:45:00',4.92),('11288','2013-04-03','14:50:00',5.89),('11288','2013-04-03','14:55:00',7.59),('11288','2013-04-03','15:00:00',5.94),('11288','2013-04-03','15:05:00',5.68),('11288','2013-04-03','15:10:00',6.84),('11288','2013-04-03','15:15:00',5.87),('11288','2013-04-03','15:20:00',5.06),('11288','2013-04-03','15:25:00',6.08),('11288','2013-04-03','15:30:00',3.31),('11288','2013-04-03','15:35:00',5),('11288','2013-04-03','15:40:00',4.75),('11288','2013-04-03','15:45:00',5.56),('11288','2013-04-03','15:50:00',6.23),('11288','2013-04-03','15:55:00',5.96),('11288','2013-04-03','16:00:00',5.68),('11288','2013-04-03','16:05:00',5.63),('11288','2013-04-03','16:10:00',4.35),('11288','2013-04-03','16:15:00',5.2),('11288','2013-04-03','16:20:00',5.04),('11288','2013-04-03','16:25:00',4.9),('11288','2013-04-03','16:30:00',4.78),('11288','2013-04-03','16:35:00',4.68),('11288','2013-04-03','16:40:00',4.41),('11288','2013-04-03','16:45:00',4.23),('11288','2013-04-03','16:50:00',4.09),('11288','2013-04-03','16:55:00',3.96),('11288','2013-04-03','17:00:00',3.76),('11288','2013-04-03','17:05:00',3.54),('11288','2013-04-03','17:10:00',3.46),('11288','2013-04-03','17:15:00',3.3),('11288','2013-04-03','17:20:00',3.14),('11288','2013-04-03','17:25:00',2.95),('11288','2013-04-03','17:30:00',2.81),('11288','2013-04-03','17:35:00',2.61),('11288','2013-04-03','17:40:00',2.44),('11288','2013-04-03','17:45:00',2.28),('11288','2013-04-03','17:50:00',2.12),('11288','2013-04-03','17:55:00',1.96),('11288','2013-04-03','18:00:00',1.79),('11288','2013-04-03','18:05:00',1.63),('11288','2013-04-03','18:10:00',1.47),('11288','2013-04-03','18:15:00',1.29),('11288','2013-04-03','18:20:00',1.12),('11288','2013-04-02','08:35:00',1.01),('11288','2013-04-02','08:40:00',2.18),('11288','2013-04-02','08:45:00',2.51),('11288','2013-04-02','08:50:00',1.67),('11288','2013-04-02','08:55:00',1.71),('11288','2013-04-02','09:00:00',2.36),('11288','2013-04-02','09:05:00',2.41),('11288','2013-04-02','09:10:00',2.42),('11288','2013-04-02','09:15:00',2.59),('11288','2013-04-02','09:20:00',2.43),('11288','2013-04-02','09:25:00',1.65),('11288','2013-04-02','09:30:00',2.76),('11288','2013-04-02','09:35:00',3.98),('11288','2013-04-02','09:40:00',4.08),('11288','2013-04-02','09:45:00',3.92),('11288','2013-04-02','09:50:00',3.11),('11288','2013-04-02','09:55:00',3),('11288','2013-04-02','10:00:00',3.56),('11288','2013-04-02','10:05:00',2.82),('11288','2013-04-02','10:10:00',1.88),('11288','2013-04-02','10:15:00',2.42),('11288','2013-04-02','10:20:00',2.67),('11288','2013-04-02','10:25:00',3.47),('11288','2013-04-02','10:30:00',1.47),('11288','2013-04-02','10:35:00',5.46),('11288','2013-04-02','10:40:00',3.33),('11288','2013-04-02','10:45:00',3.92),('11288','2013-04-02','10:50:00',6.53),('11288','2013-04-02','10:55:00',2.19),('11288','2013-04-02','11:00:00',2),('11288','2013-04-02','11:05:00',4.86),('11288','2013-04-02','11:10:00',2.66),('11288','2013-04-02','11:15:00',2),('11288','2013-04-02','11:20:00',1.76),('11288','2013-04-02','11:25:00',2.11),('11288','2013-04-02','11:30:00',2.4),('11288','2013-04-02','11:35:00',1.99),('11288','2013-04-02','11:40:00',1.91),('11288','2013-04-02','11:45:00',4.24),('11288','2013-04-02','11:50:00',3.85),('11288','2013-04-02','11:55:00',1.86),('11288','2013-04-02','12:00:00',2.06),('11288','2013-04-02','12:05:00',4.87),('11288','2013-04-02','12:10:00',3.46),('11288','2013-04-02','12:15:00',3.87),('11288','2013-04-02','12:30:00',2.36),('11288','2013-04-02','12:35:00',3.29),('11288','2013-04-02','12:40:00',3.35),('11288','2013-04-02','12:45:00',4.22),('11288','2013-04-02','12:50:00',3.86),('11288','2013-04-02','12:55:00',4.07),('11288','2013-04-02','13:00:00',4.38),('11288','2013-04-02','13:05:00',4.56),('11288','2013-04-02','13:10:00',5.52),('11288','2013-04-02','13:15:00',4.21),('11288','2013-04-02','13:20:00',3.55),('11288','2013-04-02','13:25:00',5.96),('11288','2013-04-02','13:30:00',4.32),('11288','2013-04-02','13:35:00',3.52),('11288','2013-04-02','13:40:00',5.14),('11288','2013-04-02','13:45:00',4.83),('11288','2013-04-02','13:50:00',3.62),('11288','2013-04-02','13:55:00',3.82),('11288','2013-04-02','14:00:00',4.51),('11288','2013-04-02','14:05:00',3.61),('11288','2013-04-02','14:10:00',4.7),('11288','2013-04-02','14:15:00',3.96),('11288','2013-04-02','14:20:00',7.2),('11288','2013-04-02','14:25:00',6.9),('11288','2013-04-02','14:30:00',3.35),('11288','2013-04-02','14:35:00',3.47),('11288','2013-04-02','14:40:00',4.63),('11288','2013-04-02','14:45:00',4.65),('11288','2013-04-02','14:50:00',3.19),('11288','2013-04-02','14:55:00',2.89),('11288','2013-04-02','15:00:00',2.5),('11288','2013-04-02','15:05:00',1.34),('11288','2013-04-02','15:10:00',1.06),('11288','2013-04-02','15:15:00',1.26),('11288','2013-04-02','15:20:00',1.79),('11288','2013-04-02','15:30:00',1.06),('11288','2013-04-02','15:35:00',1.42),('11288','2013-04-02','15:40:00',1.71),('11288','2013-04-02','15:45:00',2.08),('11288','2013-04-02','15:50:00',1.16),('11288','2013-04-02','15:55:00',1.41),('11288','2013-04-02','16:00:00',2.06),('11288','2013-04-02','16:05:00',2.1),('11288','2013-04-02','16:10:00',1.63),('11288','2013-04-02','16:15:00',2.02),('11288','2013-04-02','16:20:00',1.83),('11288','2013-04-02','16:25:00',1.65),('11288','2013-04-02','16:30:00',1.84),('11288','2013-04-02','16:35:00',1.76),('11288','2013-04-02','16:40:00',1.63),('11288','2013-04-02','16:45:00',1.59),('11288','2013-04-02','16:50:00',1.03),('11288','2013-04-02','16:55:00',1.2),('11288','2013-04-02','17:00:00',1.65),('11288','2013-04-02','17:05:00',1.4),('11288','2013-04-02','17:35:00',1),('11288','2013-04-02','17:40:00',1.78),('11288','2013-04-02','17:45:00',1.54),('11288','2014-05-02','07:35:00',1.12),('11288','2014-05-02','07:40:00',1.2),('11288','2014-05-02','07:45:00',1.41),('11288','2014-05-02','07:50:00',1.47),('11288','2014-05-02','07:55:00',1.7),('11288','2014-05-02','08:00:00',1.97),('11288','2014-05-02','08:05:00',1.81),('11288','2014-05-02','08:10:00',1.59),('11288','2014-05-02','08:15:00',2.81),('11288','2014-05-02','08:20:00',2.56),('11288','2014-05-02','08:25:00',1.88),('11288','2014-05-02','08:30:00',1.2),('11288','2014-05-02','08:35:00',1.09),('11288','2014-05-02','08:40:00',1.6),('11288','2014-05-02','08:45:00',2.78),('11288','2014-05-02','08:50:00',2.47),('11288','2014-05-02','08:55:00',1.03),('11288','2014-05-02','09:05:00',1.24),('11288','2014-05-02','09:10:00',1.56),('11288','2014-05-02','09:15:00',2.23),('11288','2014-05-02','09:20:00',2.68),('11288','2014-05-02','09:25:00',3.26),('11288','2014-05-02','09:30:00',3.53),('11288','2014-05-02','09:35:00',3.35),('11288','2014-05-02','09:40:00',3.15),('11288','2014-05-02','09:45:00',2.92),('11288','2014-05-02','09:50:00',2.84),('11288','2014-05-02','09:55:00',2.74),('11288','2014-05-02','10:00:00',3.19),('11288','2014-05-02','10:05:00',3.65),('11288','2014-05-02','10:10:00',3.21),('11288','2014-05-02','10:15:00',2.93),('11288','2014-05-02','10:20:00',2.53),('11288','2014-05-02','10:25:00',2.21),('11288','2014-05-02','10:30:00',1.58),('11288','2014-05-02','10:35:00',1.58),('11288','2014-05-02','10:40:00',1.87),('11288','2014-05-02','10:45:00',2.28),('11288','2014-05-02','10:50:00',1.78),('11288','2014-05-02','10:55:00',1.26),('11288','2014-05-02','12:20:00',1.14),('11288','2014-05-02','12:25:00',1.58),('11288','2014-05-02','12:30:00',1.94),('11288','2014-05-02','12:35:00',2.09),('11288','2014-05-02','12:40:00',2.11),('11288','2014-05-02','12:45:00',2.85),('11288','2014-05-02','12:50:00',3.39),('11288','2014-05-02','12:55:00',2.58),('11288','2014-05-02','13:00:00',2.96),('11288','2014-05-02','13:05:00',3.39),('11288','2014-05-02','13:10:00',3.28),('11288','2014-05-02','13:15:00',4.49),('11288','2014-05-02','13:20:00',5.33),('11288','2014-05-02','13:25:00',6.97),('11288','2014-05-02','13:30:00',4.9),('11288','2014-05-02','13:35:00',4.65),('11288','2014-05-02','13:40:00',4.11),('11288','2014-05-02','13:45:00',3.49),('11288','2014-05-02','13:50:00',2.96),('11288','2014-05-02','13:55:00',2.31),('11288','2014-05-02','14:00:00',2.7),('11288','2014-05-02','14:05:00',4.28),('11288','2014-05-02','14:10:00',1.66),('11288','2014-05-02','14:25:00',1.48),('11288','2014-05-02','14:30:00',2.14),('11288','2014-05-02','14:35:00',3.16),('11288','2014-05-02','14:40:00',4.97),('11288','2014-05-02','14:45:00',2.66),('11288','2014-05-02','14:50:00',2.51),('11288','2014-05-02','14:55:00',3.58),('11288','2014-05-02','15:00:00',4.1),('11288','2014-05-02','15:05:00',3.4),('11288','2014-05-02','15:10:00',6.44),('11288','2014-05-02','15:15:00',4.35),('11288','2014-05-02','15:20:00',5.08),('11288','2014-05-02','15:25:00',2.49),('11288','2014-05-02','15:30:00',2.39),('11288','2014-05-02','15:35:00',5.28),('11288','2014-05-02','15:40:00',5.65),('11288','2014-05-02','15:45:00',2.24),('11288','2014-05-02','15:50:00',1.62),('11288','2014-05-02','15:55:00',1.5),('11288','2014-05-02','16:00:00',2.67),('11288','2014-05-02','16:05:00',2.86),('11288','2014-05-02','16:10:00',1.87),('11288','2014-05-02','16:15:00',2.49),('11288','2014-05-02','16:20:00',3.67),('11288','2014-05-02','16:50:00',1.08),('11288','2014-05-02','16:55:00',1.35),('11288','2014-05-02','17:00:00',1.02),('11288','2014-05-02','17:05:00',1.4),('11288','2014-05-02','17:10:00',1.16),('11288','2014-05-02','17:15:00',1.75),('11288','2014-05-02','17:20:00',1.86),('11288','2014-05-02','17:25:00',2.13),('11288','2014-05-02','17:30:00',1.62),('11288','2014-05-02','17:35:00',1.28),('11288','2014-05-02','17:40:00',1.06),('11288','2014-03-27','07:40:00',1),('11288','2014-03-27','07:45:00',1.32),('11288','2014-03-27','07:50:00',1.34),('11288','2014-03-27','07:55:00',1.98),('11288','2014-03-27','08:00:00',2.56),('11288','2014-03-27','08:05:00',2.6),('11288','2014-03-27','08:10:00',1.13),('11288','2014-03-27','09:10:00',1.52),('11288','2014-03-27','09:15:00',1.76),('11288','2014-03-27','09:20:00',1.63),('11288','2014-03-27','09:25:00',1.5),('11288','2014-03-27','09:30:00',1.26),('11288','2014-03-27','09:55:00',1.37),('11288','2014-03-27','10:00:00',1.53),('11288','2014-03-27','10:05:00',2.1),('11288','2014-03-27','10:10:00',2.27),('11288','2014-03-27','10:15:00',2.23),('11288','2014-03-27','10:20:00',3.04),('11288','2014-03-27','10:25:00',3.72),('11288','2014-03-27','10:30:00',3.59),('11288','2014-03-27','10:35:00',3.33),('11288','2014-03-27','10:40:00',3.48),('11288','2014-03-27','10:45:00',1.8),('11288','2014-03-27','10:50:00',1.51),('11288','2014-03-27','10:55:00',1.41),('11288','2014-03-27','11:00:00',1.3),('11288','2014-03-27','11:05:00',1.56),('11288','2014-03-27','11:10:00',5.6),('11288','2014-03-27','11:15:00',3.56),('11288','2014-03-27','11:20:00',2.25),('11288','2014-03-27','11:25:00',1.22),('11288','2014-03-27','11:45:00',1.11),('11288','2014-03-27','11:50:00',2.03),('11288','2014-03-27','11:55:00',2.52),('11288','2014-03-27','12:00:00',1.99),('11288','2014-03-27','12:05:00',2.03),('11288','2014-03-27','12:10:00',2.15),('11288','2014-03-27','12:15:00',1.69),('11288','2014-03-27','12:20:00',1.9),('11288','2014-03-27','12:50:00',1.05),('11288','2014-03-27','12:55:00',1.46),('11288','2014-03-27','13:00:00',1.77),('11288','2014-03-27','13:05:00',2.23),('11288','2014-03-27','13:10:00',3.03),('11288','2014-03-27','13:15:00',3.96),('11288','2014-03-27','13:20:00',4.17),('11288','2014-03-27','13:25:00',4.12),('11288','2014-03-27','13:30:00',3.54),('11288','2014-03-27','13:35:00',3.29),('11288','2014-03-27','13:40:00',3.1),('11288','2014-03-27','13:45:00',2.93),('11288','2014-03-27','13:50:00',3.93),('11288','2014-03-27','13:55:00',4.62),('11288','2014-03-27','14:00:00',3.42),('11288','2014-03-27','14:05:00',1.77),('11288','2014-03-27','14:10:00',1.39),('11288','2014-03-27','14:15:00',5.02),('11288','2014-03-27','14:20:00',6.1),('11288','2014-03-27','14:25:00',6.81),('11288','2014-03-27','14:30:00',5.76),('11288','2014-03-27','14:35:00',3.73),('11288','2014-03-27','14:40:00',3.21),('11288','2014-03-27','14:45:00',3.03),('11288','2014-03-27','14:50:00',3.8),('11288','2014-03-27','14:55:00',3.2),('11288','2014-03-27','15:00:00',5.89),('11288','2014-03-27','15:05:00',2.24),('11288','2014-03-27','15:20:00',1.92),('11288','2014-03-27','15:25:00',5.2),('11288','2014-03-27','15:30:00',4.42),('11288','2014-03-27','15:35:00',4.29),('11288','2014-03-27','15:40:00',2.03),('11288','2014-03-27','15:45:00',1.12),('11288','2014-03-27','15:50:00',1.67),('11288','2014-03-27','15:55:00',1.52),('11288','2014-03-27','16:00:00',1.59),('11288','2014-03-27','16:05:00',1.83),('11288','2014-03-27','16:10:00',2.15),('11288','2014-03-27','16:15:00',1.75),('11288','2014-03-27','16:20:00',1.55),('11288','2014-03-27','16:25:00',1.86),('11288','2014-03-27','16:30:00',2.12),('11288','2014-03-27','16:35:00',1.55),('11288','2014-03-27','16:40:00',1.6),('11288','2014-03-27','16:45:00',1.52),('11288','2014-03-27','16:50:00',1.13),('11288','2014-03-27','16:55:00',1.57),('11288','2014-03-27','17:00:00',1.35),('11288','2014-03-27','17:05:00',1.24),('11288','2013-04-01','08:25:00',1.5),('11288','2013-04-01','08:30:00',1.41),('11288','2013-04-01','08:35:00',1.88),('11288','2013-04-01','08:40:00',1.75),('11288','2013-04-01','08:45:00',1.34),('11288','2013-04-01','08:50:00',1.71),('11288','2013-04-01','08:55:00',1.76),('11288','2013-04-01','09:00:00',1.99),('11288','2013-04-01','09:05:00',2.66),('11288','2013-04-01','09:10:00',2.79),('11288','2013-04-01','09:15:00',1.87),('11288','2013-04-01','09:20:00',2.52),('11288','2013-04-01','09:25:00',3.15),('11288','2013-04-01','09:30:00',2.64),('11288','2013-04-01','09:35:00',3.07),('11288','2013-04-01','09:40:00',3.11),('11288','2013-04-01','09:45:00',4.21),('11288','2013-04-01','09:50:00',4.41),('11288','2013-04-01','09:55:00',4.18),('11288','2013-04-01','10:00:00',4.76),('11288','2013-04-01','10:05:00',4.85),('11288','2013-04-01','10:10:00',3.7),('11288','2013-04-01','10:15:00',4.51),('11288','2013-04-01','10:20:00',3.39),('11288','2013-04-01','10:25:00',4.61),('11288','2013-04-01','10:30:00',3.61),('11288','2013-04-01','10:35:00',2.17),('11288','2013-04-01','10:40:00',3.67),('11288','2013-04-01','10:45:00',5.16),('11288','2013-04-01','10:50:00',2.21),('11288','2013-04-01','10:55:00',2.77),('11288','2013-04-01','11:00:00',2.12),('11288','2013-04-01','11:05:00',2.61),('11288','2013-04-01','11:10:00',4.66),('11288','2013-04-01','11:15:00',3.34),('11288','2013-04-01','11:20:00',5.98),('11288','2013-04-01','11:25:00',3.1),('11288','2013-04-01','11:30:00',2.86),('11288','2013-04-01','11:35:00',3.37),('11288','2013-04-01','11:40:00',4.87),('11288','2013-04-01','11:45:00',4.89),('11288','2013-04-01','11:50:00',4.21),('11288','2013-04-01','11:55:00',3.76),('11288','2013-04-01','12:00:00',4.86),('11288','2013-04-01','12:05:00',3.39),('11288','2013-04-01','12:10:00',4.07),('11288','2013-04-01','12:15:00',3.4),('11288','2013-04-01','12:20:00',2.95),('11288','2013-04-01','12:25:00',3.32),('11288','2013-04-01','12:30:00',4.68),('11288','2013-04-01','12:35:00',4.22),('11288','2013-04-01','12:40:00',4.3),('11288','2013-04-01','12:45:00',4.85),('11288','2013-04-01','12:50:00',5.1),('11288','2013-04-01','12:55:00',5.26),('11288','2013-04-01','13:00:00',5.22),('11288','2013-04-01','13:05:00',5.54),('11288','2013-04-01','13:10:00',4.96),('11288','2013-04-01','13:15:00',5.44),('11288','2013-04-01','13:20:00',5),('11288','2013-04-01','13:25:00',4.81),('11288','2013-04-01','13:30:00',4.87),('11288','2013-04-01','13:35:00',4.81),('11288','2013-04-01','13:40:00',6.47),('11288','2013-04-01','13:45:00',6.62),('11288','2013-04-01','13:50:00',7.26),('11288','2013-04-01','13:55:00',6.63),('11288','2013-04-01','14:00:00',4.07),('11288','2013-04-01','14:05:00',3.34),('11288','2013-04-01','14:10:00',4.28),('11288','2013-04-01','14:15:00',4.7),('11288','2013-04-01','14:20:00',5.11),('11288','2013-04-01','14:25:00',7.03),('11288','2013-04-01','14:30:00',4.12),('11288','2013-04-01','14:35:00',3.7),('11288','2013-04-01','14:40:00',3.28),('11288','2013-04-01','14:45:00',3.41),('11288','2013-04-01','14:50:00',3.71),('11288','2013-04-01','14:55:00',3.87),('11288','2013-04-01','15:00:00',3.56),('11288','2013-04-01','15:05:00',3.57),('11288','2013-04-01','15:10:00',3.68),('11288','2013-04-01','15:15:00',3.91),('11288','2013-04-01','15:20:00',4.05),('11288','2013-04-01','15:25:00',4.04),('11288','2013-04-01','15:30:00',3.66),('11288','2013-04-01','15:35:00',4.54),('11288','2013-04-01','15:40:00',4.16),('11288','2013-04-01','15:45:00',4.44),('11288','2013-04-01','15:50:00',4.73),('11288','2013-04-01','15:55:00',3.51),('11288','2013-04-01','16:00:00',3.31),('11288','2013-04-01','16:05:00',2.75),('11288','2013-04-01','16:10:00',2.35),('11288','2013-04-01','16:15:00',1.94),('11288','2013-04-01','16:20:00',1.88),('11288','2013-04-01','16:25:00',1.74),('11288','2013-04-01','16:30:00',1.42),('11288','2013-04-01','16:35:00',1.48),('11288','2013-04-01','16:40:00',1.26),('11288','2013-04-01','16:45:00',1.04),('11288','2013-03-31','08:15:00',1.04),('11288','2013-03-31','08:20:00',1.44),('11288','2013-03-31','08:30:00',1.8),('11288','2013-03-31','08:35:00',1.75),('11288','2013-03-31','08:40:00',1.82),('11288','2013-03-31','08:45:00',2.05),('11288','2013-03-31','08:50:00',1.81),('11288','2013-03-31','08:55:00',2.07),('11288','2013-03-31','09:00:00',1.99),('11288','2013-03-31','09:05:00',1.97),('11288','2013-03-31','09:10:00',2.1),('11288','2013-03-31','09:15:00',2.6),('11288','2013-03-31','09:20:00',3.31),('11288','2013-03-31','09:25:00',3.77),('11288','2013-03-31','09:30:00',2.69),('11288','2013-03-31','09:35:00',3.14),('11288','2013-03-31','09:40:00',2.12),('11288','2013-03-31','09:45:00',3.13),('11288','2013-03-31','09:50:00',2.48),('11288','2013-03-31','09:55:00',3.37),('11288','2013-03-31','10:00:00',2.81),('11288','2013-03-31','10:05:00',1.11),('11288','2013-03-31','10:10:00',1.01),('11288','2013-03-31','10:15:00',1.96),('11288','2013-03-31','10:20:00',4.03),('11288','2013-03-31','10:25:00',4.25),('11288','2013-03-31','10:30:00',5.11),('11288','2013-03-31','10:35:00',4.72),('11288','2013-03-31','10:40:00',1.43),('11288','2013-03-31','10:45:00',2.37),('11288','2013-03-31','10:50:00',3.57),('11288','2013-03-31','10:55:00',1.67),('11288','2013-03-31','11:00:00',1.37),('11288','2013-03-31','11:05:00',1.39),('11288','2013-03-31','11:10:00',2.64),('11288','2013-03-31','11:15:00',2.35),('11288','2013-03-31','11:20:00',2.21),('11288','2013-03-31','11:25:00',2.69),('11288','2013-03-31','11:30:00',2.16),('11288','2013-03-31','11:35:00',2.79),('11288','2013-03-31','11:40:00',2.82),('11288','2013-03-31','11:45:00',2.47),('11288','2013-03-31','11:50:00',2.93),('11288','2013-03-31','11:55:00',3.08),('11288','2013-03-31','12:00:00',2.85),('11288','2013-03-31','12:05:00',2.72),('11288','2013-03-31','12:10:00',2.37),('11288','2013-03-31','12:15:00',2.69),('11288','2013-03-31','12:20:00',2.42),('11288','2013-03-31','12:25:00',3.13),('11288','2013-03-31','12:30:00',3.4),('11288','2013-03-31','12:35:00',5.05),('11288','2013-03-31','12:40:00',4.91),('11288','2013-03-31','12:45:00',2.84),('11288','2013-03-31','12:50:00',3.2),('11288','2013-03-31','12:55:00',3.76),('11288','2013-03-31','13:00:00',4.4),('11288','2013-03-31','13:05:00',3.91),('11288','2013-03-31','13:10:00',5.25),('11288','2013-03-31','13:15:00',4.67),('11288','2013-03-31','13:20:00',6.53),('11288','2013-03-31','13:25:00',3.61),('11288','2013-03-31','13:30:00',1.46),('11288','2013-03-31','13:35:00',1.47),('11288','2013-03-31','13:40:00',3.14),('11288','2013-03-31','13:45:00',2.9),('11288','2013-03-31','13:50:00',4.41),('11288','2013-03-31','13:55:00',3.38),('11288','2013-03-31','14:00:00',3.33),('11288','2013-03-31','14:05:00',4.75),('11288','2013-03-31','14:10:00',4.43),('11288','2013-03-31','14:15:00',5.52),('11288','2013-03-31','14:20:00',2.85),('11288','2013-03-31','14:25:00',3.41),('11288','2013-03-31','14:30:00',6.42),('11288','2013-03-31','14:35:00',7.2),('11288','2013-03-31','14:40:00',7.48),('11288','2013-03-31','14:45:00',5.97),('11288','2013-03-31','14:50:00',5.21),('11288','2013-03-31','14:55:00',5.36),('11288','2013-03-31','15:00:00',5.56),('11288','2013-03-31','15:05:00',4.05),('11288','2013-03-31','15:10:00',5.32),('11288','2013-03-31','15:15:00',5.85),('11288','2013-03-31','15:20:00',7.23),('11288','2013-03-31','15:25:00',4.81),('11288','2013-03-31','15:30:00',4.21),('11288','2013-03-31','15:35:00',5.3),('11288','2013-03-31','15:40:00',6.86),('11288','2013-03-31','15:45:00',4.05),('11288','2013-03-31','15:50:00',1.68),('11288','2013-03-31','15:55:00',2.28),('11288','2013-03-31','16:00:00',5.45),('11288','2013-03-31','16:05:00',2.05),('11288','2013-03-31','16:10:00',3.22),('11288','2013-03-31','16:15:00',3.81),('11288','2013-03-31','16:20:00',3.11),('11288','2013-03-31','16:25:00',2.27),('11288','2013-03-31','16:30:00',1.97),('11288','2013-03-31','16:35:00',2.08),('11288','2013-03-31','16:40:00',2.47),('11288','2013-03-31','16:45:00',2.01),('11288','2013-03-31','16:50:00',1.69),('11288','2013-03-31','16:55:00',1.54),('11288','2013-03-31','17:00:00',2.1),('11288','2013-03-31','17:05:00',2.1),('11288','2013-03-31','17:10:00',1.83),('11288','2013-03-31','17:15:00',1.51),('11288','2013-03-31','17:20:00',2),('11288','2013-03-31','17:25:00',2.08),('11288','2013-03-31','17:30:00',2.26),('11288','2013-03-31','17:35:00',2.07),('11288','2013-03-31','17:40:00',1.5),('11288','2013-03-31','17:45:00',1.81),('11288','2013-03-31','17:50:00',1.98),('11288','2013-03-31','17:55:00',2.48),('11288','2013-03-31','18:00:00',1.2),('11288','2013-03-31','18:15:00',1.94),('11288','2013-03-31','18:20:00',1.05),('11288','2013-03-30','07:30:00',1.11),('11288','2013-03-30','07:50:00',1.24),('11288','2013-03-30','07:55:00',1.57),('11288','2013-03-30','08:00:00',1.28),('11288','2013-03-30','08:05:00',1.14),('11288','2013-03-30','08:10:00',1.22),('11288','2013-03-30','08:15:00',1.5),('11288','2013-03-30','08:20:00',1.49),('11288','2013-03-30','08:25:00',1.65),('11288','2013-03-30','08:30:00',1.78),('11288','2013-03-30','08:35:00',2.09),('11288','2013-03-30','08:40:00',1.9),('11288','2013-03-30','08:45:00',1.48),('11288','2013-03-30','08:50:00',1.7),('11288','2013-03-30','08:55:00',1.43),('11288','2013-03-30','09:00:00',1.86),('11288','2013-03-30','09:05:00',2.88),('11288','2013-03-30','09:10:00',3.18),('11288','2013-03-30','09:15:00',3.66),('11288','2013-03-30','09:20:00',5.35),('11288','2013-03-30','09:25:00',2.7),('11288','2013-03-30','09:30:00',2.19),('11288','2013-03-30','09:35:00',2.37),('11288','2013-03-30','09:40:00',2.3),('11288','2013-03-30','09:45:00',2.03),('11288','2013-03-30','09:50:00',1.55),('11288','2013-03-30','09:55:00',2.38),('11288','2013-03-30','10:00:00',3.45),('11288','2013-03-30','10:05:00',3.24),('11288','2013-03-30','10:10:00',3.5),('11288','2013-03-30','10:15:00',3.06),('11288','2013-03-30','10:20:00',2.66),('11288','2013-03-30','10:25:00',2.69),('11288','2013-03-30','10:30:00',3.09),('11288','2013-03-30','10:35:00',3.69),('11288','2013-03-30','10:40:00',4.34),('11288','2013-03-30','10:45:00',5.36),('11288','2013-03-30','10:50:00',4.99),('11288','2013-03-30','10:55:00',3.93),('11288','2013-03-30','11:00:00',5.52),('11288','2013-03-30','11:05:00',6.94),('11288','2013-03-30','11:10:00',7.11),('11288','2013-03-30','11:15:00',5.79),('11288','2013-03-30','11:20:00',8.58),('11288','2013-03-30','11:25:00',6.17),('11288','2013-03-30','11:30:00',5.32),('11288','2013-03-30','11:35:00',6.22),('11288','2013-03-30','11:40:00',5.5),('11288','2013-03-30','11:45:00',6.5),('11288','2013-03-30','11:50:00',6.85),('11288','2013-03-30','11:55:00',6.98),('11288','2013-03-30','12:00:00',5.77),('11288','2013-03-30','12:05:00',4.14),('11288','2013-03-30','12:10:00',3.65),('11288','2013-03-30','12:15:00',3.65),('11288','2013-03-30','12:20:00',3.13),('11288','2013-03-30','12:25:00',1.68),('11288','2013-03-30','12:30:00',1.86),('11288','2013-03-30','12:35:00',1.55),('11288','2013-03-30','12:45:00',1.49),('11288','2013-03-30','12:50:00',1.09),('11288','2013-03-30','13:05:00',1.08),('11288','2013-03-30','13:10:00',5.33),('11288','2013-03-30','13:15:00',5.39),('11288','2013-03-30','13:20:00',3.28),('11288','2013-03-30','13:25:00',3.28),('11288','2013-03-30','13:30:00',1.78),('11288','2013-03-30','13:35:00',1.22),('11288','2013-03-30','13:40:00',1.62),('11288','2013-03-30','13:45:00',4.65),('11288','2013-03-30','13:50:00',5.83),('11288','2013-03-30','13:55:00',2.65),('11288','2013-03-30','14:00:00',3.79),('11288','2013-03-30','14:05:00',2.56),('11288','2013-03-30','14:10:00',1.86),('11288','2013-03-30','14:15:00',1.83),('11288','2013-03-30','14:20:00',2.46),('11288','2013-03-30','14:25:00',2.37),('11288','2013-03-30','14:30:00',3.77),('11288','2013-03-30','14:35:00',3.48),('11288','2013-03-30','14:40:00',2.21),('11288','2013-03-30','14:45:00',1.85),('11288','2013-03-30','14:50:00',2.46),('11288','2013-03-30','14:55:00',1.51),('11288','2013-03-30','15:00:00',1.14),('11288','2013-03-30','15:15:00',1.07),('11288','2013-03-30','15:20:00',1.59),('11288','2013-03-30','15:25:00',1.81),('11288','2013-03-30','15:30:00',1.65),('11288','2013-03-30','15:35:00',1.27),('11288','2013-03-30','15:40:00',1.53),('11288','2013-03-30','15:45:00',1.27),('11288','2013-03-30','15:50:00',1.25),('11288','2013-03-30','15:55:00',1.02),('11288','2013-03-29','07:15:00',1.07),('11288','2013-03-29','07:20:00',1.18),('11288','2013-03-29','07:25:00',1.29),('11288','2013-03-29','07:30:00',1.16),('11288','2013-03-29','07:35:00',1.43),('11288','2013-03-29','07:40:00',1.68),('11288','2013-03-29','07:45:00',2.11),('11288','2013-03-29','07:50:00',1.49),('11288','2013-03-29','07:55:00',1.66),('11288','2013-03-29','08:00:00',1.74),('11288','2013-03-29','08:05:00',2.07),('11288','2013-03-29','08:10:00',2.47),('11288','2013-03-29','08:15:00',2.77),('11288','2013-03-29','08:20:00',2.85),('11288','2013-03-29','08:25:00',2.84),('11288','2013-03-29','08:30:00',3.37),('11288','2013-03-29','08:35:00',3.47),('11288','2013-03-29','08:40:00',3.34),('11288','2013-03-29','08:45:00',3.6),('11288','2013-03-29','08:50:00',3.78),('11288','2013-03-29','08:55:00',3.32),('11288','2013-03-29','09:00:00',3.74),('11288','2013-03-29','09:05:00',4.3),('11288','2013-03-29','09:10:00',4.26),('11288','2013-03-29','09:15:00',4.95),('11288','2013-03-29','09:20:00',5.11),('11288','2013-03-29','09:25:00',5.02),('11288','2013-03-29','09:30:00',5.92),('11288','2013-03-29','09:35:00',5.77),('11288','2013-03-29','09:40:00',5.69),('11288','2013-03-29','09:45:00',5.09),('11288','2013-03-29','09:50:00',5.15),('11288','2013-03-29','09:55:00',5.67),('11288','2013-03-29','10:00:00',5.66),('11288','2013-03-29','10:05:00',5.44),('11288','2013-03-29','10:10:00',4.74),('11288','2013-03-29','10:15:00',5.75),('11288','2013-03-29','10:20:00',5.26),('11288','2013-03-29','10:25:00',5),('11288','2013-03-29','10:30:00',5.19),('11288','2013-03-29','10:35:00',4.64),('11288','2013-03-29','10:40:00',5.58),('11288','2013-03-29','10:45:00',4.44),('11288','2013-03-29','10:50:00',5.05),('11288','2013-03-29','10:55:00',5.5),('11288','2013-03-29','11:00:00',6.7),('11288','2013-03-29','11:05:00',6.23),('11288','2013-03-29','11:10:00',3.56),('11288','2013-03-29','11:15:00',4.09),('11288','2013-03-29','11:20:00',7.49),('11288','2013-03-29','11:25:00',7.33),('11288','2013-03-29','11:30:00',7.05),('11288','2013-03-29','11:35:00',6.83),('11288','2013-03-29','11:40:00',6.97),('11288','2013-03-29','11:45:00',6.99),('11288','2013-03-29','11:50:00',7.11),('11288','2013-03-29','11:55:00',7.17),('11288','2013-03-29','12:00:00',7.16),('11288','2013-03-29','12:05:00',7.31),('11288','2013-03-29','12:10:00',7.27),('11288','2013-03-29','12:15:00',6.76),('11288','2013-03-29','12:20:00',7.01),('11288','2013-03-29','12:25:00',7),('11288','2013-03-29','12:30:00',6.66),('11288','2013-03-29','12:35:00',6.8),('11288','2013-03-29','12:40:00',6.41),('11288','2013-03-29','12:45:00',6.42),('11288','2013-03-29','12:50:00',6.86),('11288','2013-03-29','12:55:00',6.72),('11288','2013-03-29','13:00:00',6.82),('11288','2013-03-29','13:05:00',6.06),('11288','2013-03-29','13:10:00',6.61),('11288','2013-03-29','13:15:00',6.08),('11288','2013-03-29','13:20:00',6.15),('11288','2013-03-29','13:25:00',7.13),('11288','2013-03-29','13:30:00',6.34),('11288','2013-03-29','13:35:00',5.42),('11288','2013-03-29','13:40:00',5.4),('11288','2013-03-29','13:45:00',5.95),('11288','2013-03-29','13:50:00',5.59),('11288','2013-03-29','13:55:00',5.87),('11288','2013-03-29','14:00:00',6.21),('11288','2013-03-29','14:05:00',4.91),('11288','2013-03-29','14:10:00',4.16),('11288','2013-03-29','14:15:00',4.19),('11288','2013-03-29','14:20:00',4.22),('11288','2013-03-29','14:25:00',4.45),('11288','2013-03-29','14:30:00',3.7),('11288','2013-03-29','14:35:00',3.61),('11288','2013-03-29','14:40:00',3.6),('11288','2013-03-29','14:45:00',3.3),('11288','2013-03-29','14:50:00',3.22),('11288','2013-03-29','14:55:00',3.14),('11288','2013-03-29','15:00:00',2.83),('11288','2013-03-29','15:05:00',2.8),('11288','2013-03-29','15:10:00',2.68),('11288','2013-03-29','15:15:00',2.65),('11288','2013-03-29','15:20:00',2.46),('11288','2013-03-29','15:25:00',2.27),('11288','2013-03-29','15:30:00',2.1),('11288','2013-03-29','15:35:00',2.01),('11288','2013-03-29','15:40:00',1.91),('11288','2013-03-29','15:45:00',1.87),('11288','2013-03-29','15:50:00',2.07),('11288','2013-03-29','15:55:00',2.34),('11288','2013-03-29','16:00:00',2.79),('11288','2013-03-29','16:05:00',2.65),('11288','2013-03-29','16:10:00',1.97),('11288','2013-03-29','16:15:00',1.81),('11288','2013-03-29','16:20:00',1.65),('11288','2013-03-29','16:25:00',1.83),('11288','2013-03-29','16:30:00',1.84),('11288','2013-03-29','16:35:00',2.11),('11288','2013-03-29','16:40:00',2.98),('11288','2013-03-29','16:45:00',2.54),('11288','2013-03-29','16:50:00',1.87),('11288','2013-03-29','16:55:00',1.67),('11288','2013-03-29','17:00:00',1.77),('11288','2013-03-29','17:05:00',1.24),('11288','2013-03-29','17:20:00',1.32),('11288','2013-03-29','17:25:00',1.3),('11288','2013-03-29','17:30:00',1.18),('11288','2013-03-28','07:30:00',1.04),('11288','2013-03-28','07:40:00',1.12),('11288','2013-03-28','08:40:00',1.02),('11288','2013-03-28','08:50:00',1.1),('11288','2013-03-28','08:55:00',1.27),('11288','2013-03-28','09:00:00',1.26),('11288','2013-03-28','09:05:00',1.82),('11288','2013-03-28','09:10:00',3.43),('11288','2013-03-28','09:15:00',4.24),('11288','2013-03-28','09:20:00',2.75),('11288','2013-03-28','09:25:00',2.65),('11288','2013-03-28','09:30:00',1.84),('11288','2013-03-28','09:35:00',1.66),('11288','2013-03-28','09:40:00',1.64),('11288','2013-03-28','09:45:00',1.96),('11288','2013-03-28','09:50:00',2.06),('11288','2013-03-28','09:55:00',1.86),('11288','2013-03-28','10:00:00',1.9),('11288','2013-03-28','10:05:00',1.66),('11288','2013-03-28','10:10:00',1.34),('11288','2013-03-28','10:15:00',1.14),('11288','2013-03-28','10:20:00',1.13),('11288','2013-03-28','10:25:00',1.19),('11288','2013-03-28','10:30:00',1.19),('11288','2013-03-28','10:35:00',1.06),('11288','2013-03-28','10:55:00',1.23),('11288','2013-03-28','11:00:00',1.6),('11288','2013-03-28','11:05:00',1.16),('11288','2013-03-28','11:10:00',1.02),('11288','2013-03-28','11:25:00',1.22),('11288','2013-03-28','11:30:00',1.82),('11288','2013-03-28','11:35:00',2.27),('11288','2013-03-28','11:40:00',2.76),('11288','2013-03-28','11:45:00',2.04),('11288','2013-03-28','11:50:00',2.35),('11288','2013-03-28','11:55:00',3.93),('11288','2013-03-28','12:00:00',2.35),('11288','2013-03-28','12:05:00',1.62),('11288','2013-03-28','12:10:00',1.98),('11288','2013-03-28','12:15:00',2.42),('11288','2013-03-28','12:20:00',1.69),('11288','2013-03-28','12:25:00',1.62),('11288','2013-03-28','12:30:00',2.23),('11288','2013-03-28','12:35:00',1.84),('11288','2013-03-28','12:40:00',2.57),('11288','2013-03-28','12:45:00',3.21),('11288','2013-03-28','12:50:00',6.16),('11288','2013-03-28','12:55:00',6.15),('11288','2013-03-28','13:00:00',5.14),('11288','2013-03-28','13:05:00',7.36),('11288','2013-03-28','13:10:00',7.49),('11288','2013-03-28','13:15:00',4.67),('11288','2013-03-28','13:20:00',4.54),('11288','2013-03-28','13:25:00',3.78),('11288','2013-03-28','13:30:00',5.26),('11288','2013-03-28','13:35:00',5.06),('11288','2013-03-28','13:40:00',3.62),('11288','2013-03-28','13:45:00',3.99),('11288','2013-03-28','13:50:00',4.08),('11288','2013-03-28','13:55:00',3.01),('11288','2013-03-28','14:00:00',3.4),('11288','2013-03-28','14:05:00',3.26),('11288','2013-03-28','14:10:00',2.2),('11288','2013-03-28','14:15:00',2.6),('11288','2013-03-28','14:20:00',3.4),('11288','2013-03-28','14:25:00',3.09),('11288','2013-03-28','14:30:00',4.52),('11288','2013-03-28','14:35:00',2.86),('11288','2013-03-28','14:40:00',1.9),('11288','2013-03-28','14:45:00',2.25),('11288','2013-03-28','14:50:00',1.75),('11288','2013-03-28','14:55:00',1.73),('11288','2013-03-28','15:00:00',2.25),('11288','2013-03-28','15:05:00',2.62),('11288','2013-03-28','15:10:00',4.2),('11288','2013-03-28','15:15:00',3.11),('11288','2013-03-28','15:20:00',3.07),('11288','2013-03-28','15:25:00',1.75),('11288','2013-03-28','15:30:00',2.62),('11288','2013-03-28','15:35:00',3.61),('11288','2013-03-28','15:40:00',2.81),('11288','2013-03-28','15:45:00',3.28),('11288','2013-03-28','15:50:00',2.52),('11288','2013-03-28','15:55:00',4.01),('11288','2013-03-28','16:00:00',2.08),('11288','2013-03-28','16:05:00',2.28),('11288','2013-03-28','16:10:00',2.72),('11288','2013-03-28','16:25:00',1.1),('11288','2013-03-28','16:30:00',1.61),('11288','2013-03-28','16:35:00',2.33),('11288','2013-03-28','16:40:00',1.74),('11288','2013-03-28','16:45:00',1.67),('11288','2013-03-28','16:50:00',1.14),('11288','2013-03-28','16:55:00',1.38),('11288','2013-03-28','17:00:00',2.32),('11288','2013-03-28','17:05:00',1.98),('11288','2013-03-28','17:10:00',1.54),('11288','2013-03-28','17:15:00',1.28),('11288','2013-03-28','17:20:00',1.04),('11288','2013-03-27','07:15:00',1.03),('11288','2013-03-27','07:20:00',1.04),('11288','2013-03-27','07:25:00',1.26),('11288','2013-03-27','07:30:00',1.31),('11288','2013-03-27','07:35:00',1.16),('11288','2013-03-27','07:40:00',1.43),('11288','2013-03-27','07:45:00',1.39),('11288','2013-03-27','07:50:00',1.09),('11288','2013-03-27','07:55:00',2.19),('11288','2013-03-27','08:00:00',2.43),('11288','2013-03-27','08:05:00',2.39),('11288','2013-03-27','08:10:00',2.29),('11288','2013-03-27','08:15:00',2.48),('11288','2013-03-27','08:20:00',2.24),('11288','2013-03-27','08:25:00',2.52),('11288','2013-03-27','08:30:00',3.09),('11288','2013-03-27','08:35:00',2.62),('11288','2013-03-27','08:40:00',2.09),('11288','2013-03-27','08:45:00',2.14),('11288','2013-03-27','08:50:00',2.99),('11288','2013-03-27','08:55:00',2.36),('11288','2013-03-27','09:00:00',2.52),('11288','2013-03-27','09:05:00',2.08),('11288','2013-03-27','09:10:00',1.33),('11288','2013-03-27','09:15:00',2.66),('11288','2013-03-27','09:20:00',2.89),('11288','2013-03-27','09:25:00',1.85),('11288','2013-03-27','09:30:00',1.56),('11288','2013-03-27','09:35:00',1.49),('11288','2013-03-27','09:40:00',1.9),('11288','2013-03-27','09:45:00',2.91),('11288','2013-03-27','09:50:00',2.72),('11288','2013-03-27','09:55:00',2.63),('11288','2013-03-27','10:00:00',2.56),('11288','2013-03-27','10:05:00',1.66),('11288','2013-03-27','10:10:00',2.68),('11288','2013-03-27','10:15:00',3.36),('11288','2013-03-27','10:20:00',2.64),('11288','2013-03-27','10:25:00',3.41),('11288','2013-03-27','10:30:00',4.24),('11288','2013-03-27','10:35:00',3.52),('11288','2013-03-27','10:40:00',4.1),('11288','2013-03-27','10:45:00',3.77),('11288','2013-03-27','10:50:00',4.2),('11288','2013-03-27','10:55:00',3.78),('11288','2013-03-27','11:00:00',3.29),('11288','2013-03-27','11:05:00',2.96),('11288','2013-03-27','11:10:00',3.06),('11288','2013-03-27','11:15:00',3.32),('11288','2013-03-27','11:20:00',3.35),('11288','2013-03-27','11:25:00',3.12),('11288','2013-03-27','11:30:00',3.46),('11288','2013-03-27','11:35:00',3.16),('11288','2013-03-27','11:40:00',2.91),('11288','2013-03-27','11:45:00',3.28),('11288','2013-03-27','11:50:00',3.17),('11288','2013-03-27','11:55:00',5.08),('11288','2013-03-27','12:00:00',4.66),('11288','2013-03-27','12:05:00',4.4),('11288','2013-03-27','12:10:00',3.75),('11288','2013-03-27','12:15:00',3.05),('11288','2013-03-27','12:20:00',3.39),('11288','2013-03-27','12:25:00',3.21),('11288','2013-03-27','12:30:00',7.23),('11288','2013-03-27','12:35:00',7.29),('11288','2013-03-27','12:40:00',7.42),('11288','2013-03-27','12:45:00',6.46),('11288','2013-03-27','12:50:00',4.91),('11288','2013-03-27','12:55:00',2.75),('11288','2013-03-27','13:00:00',2.63),('11288','2013-03-27','13:05:00',3.57),('11288','2013-03-27','13:10:00',3.89),('11288','2013-03-27','13:15:00',2.88),('11288','2013-03-27','13:20:00',2.44),('11288','2013-03-27','13:25:00',2.59),('11288','2013-03-27','13:30:00',2.88),('11288','2013-03-27','13:35:00',3.95),('11288','2013-03-27','13:40:00',3.01),('11288','2013-03-27','13:45:00',3.44),('11288','2013-03-27','13:50:00',3.55),('11288','2013-03-27','13:55:00',3.2),('11288','2013-03-27','14:00:00',3.17),('11288','2013-03-27','14:05:00',2.76),('11288','2013-03-27','14:10:00',2.83),('11288','2013-03-27','14:15:00',3.3),('11288','2013-03-27','14:20:00',3.94),('11288','2013-03-27','14:25:00',3.24),('11288','2013-03-27','14:30:00',2.67),('11288','2013-03-27','14:35:00',3.24),('11288','2013-03-27','14:40:00',4.61),('11288','2013-03-27','14:45:00',4.19),('11288','2013-03-27','14:50:00',2.94),('11288','2013-03-27','14:55:00',2.15),('11288','2013-03-27','15:00:00',1.75),('11288','2013-03-27','15:05:00',2.3),('11288','2013-03-27','15:10:00',2.32),('11288','2013-03-27','15:15:00',1.88),('11288','2013-03-27','15:20:00',1.76),('11288','2013-03-27','15:25:00',1.82),('11288','2013-03-27','15:30:00',1.56),('11288','2013-03-27','15:35:00',1.42),('11288','2013-03-27','15:40:00',1.13),('11288','2013-03-27','15:55:00',1.1),('11288','2013-03-27','16:00:00',1.19),('11288','2013-03-27','16:05:00',1.44),('11288','2013-03-27','16:10:00',1.59),('11288','2013-03-27','16:15:00',1.49),('11288','2013-03-27','16:20:00',1.47),('11288','2013-03-27','16:25:00',1.53),('11288','2013-03-27','16:30:00',1.52),('11288','2013-03-27','16:35:00',1.55),('11288','2013-03-27','16:40:00',1.79),('11288','2013-03-27','16:45:00',2.08),('11288','2013-03-27','16:50:00',1.89),('11288','2013-03-27','16:55:00',2.1),('11288','2013-03-27','17:00:00',2.09),('11288','2013-03-27','17:05:00',2.21),('11288','2013-03-27','17:10:00',1.82),('11288','2013-03-27','17:15:00',1.18),('11288','2013-03-26','07:15:00',1.01),('11288','2013-03-26','07:35:00',1.09),('11288','2013-03-26','07:40:00',1.36),('11288','2013-03-26','07:45:00',1.81),('11288','2013-03-26','07:50:00',2.64),('11288','2013-03-26','07:55:00',2.01),('11288','2013-03-26','08:00:00',1.22),('11288','2013-03-26','08:05:00',1.05),('11288','2013-03-26','08:10:00',1.23),('11288','2013-03-26','08:15:00',1.22),('11288','2013-03-26','08:20:00',1.13),('11288','2013-03-26','08:25:00',1.23),('11288','2013-03-26','08:30:00',1.8),('11288','2013-03-26','08:35:00',2.71),('11288','2013-03-26','08:40:00',2.75),('11288','2013-03-26','08:45:00',1.48),('11288','2013-03-26','08:50:00',1.25),('11288','2013-03-26','08:55:00',1.18),('11288','2013-03-26','09:00:00',1.13),('11288','2013-03-26','09:05:00',1.37),('11288','2013-03-26','09:10:00',2.31),('11288','2013-03-26','09:15:00',3.26),('11288','2013-03-26','09:20:00',1.86),('11288','2013-03-26','09:25:00',1.13),('11288','2013-03-26','09:50:00',2.63),('11288','2013-03-26','09:55:00',4),('11288','2013-03-26','10:00:00',1.98),('11288','2013-03-26','10:05:00',1.29),('11288','2013-03-26','10:10:00',1.43),('11288','2013-03-26','10:20:00',1.15),('11288','2013-03-26','10:25:00',1.17),('11288','2013-03-26','10:40:00',1.02),('11288','2013-03-26','10:45:00',1.33),('11288','2013-03-26','10:50:00',2.14),('11288','2013-03-26','10:55:00',1.91),('11288','2013-03-26','11:00:00',2.17),('11288','2013-03-26','11:05:00',2.13),('11288','2013-03-26','11:10:00',3.9),('11288','2013-03-26','11:15:00',3.19),('11288','2013-03-26','11:20:00',3.31),('11288','2013-03-26','11:25:00',1.81),('11288','2013-03-26','11:30:00',1.09),('11288','2013-03-26','11:45:00',2.38),('11288','2013-03-26','11:50:00',4.03),('11288','2013-03-26','11:55:00',2.11),('11288','2013-03-26','12:00:00',2.71),('11288','2013-03-26','12:05:00',2.31),('11288','2013-03-26','12:10:00',2.55),('11288','2013-03-26','12:15:00',2.64),('11288','2013-03-26','12:20:00',2.86),('11288','2013-03-26','12:25:00',3.9),('11288','2013-03-26','12:30:00',3.48),('11288','2013-03-26','12:35:00',5.45),('11288','2013-03-26','12:40:00',3.83),('11288','2013-03-26','12:45:00',4.48),('11288','2013-03-26','12:50:00',2.87),('11288','2013-03-26','12:55:00',2.19),('11288','2013-03-26','13:00:00',3.79),('11288','2013-03-26','13:05:00',4.33),('11288','2013-03-26','13:10:00',4.71),('11288','2013-03-26','13:15:00',2.89),('11288','2013-03-26','13:20:00',3.28),('11288','2013-03-26','13:25:00',3.59),('11288','2013-03-26','13:30:00',3.02),('11288','2013-03-26','13:35:00',3.94),('11288','2013-03-26','13:40:00',4.03),('11288','2013-03-26','13:45:00',3.54),('11288','2013-03-26','13:50:00',3),('11288','2013-03-26','13:55:00',2.83),('11288','2013-03-26','14:00:00',2.77),('11288','2013-03-26','14:05:00',2.73),('11288','2013-03-26','14:10:00',2.82),('11288','2013-03-26','14:15:00',2.64),('11288','2013-03-26','14:20:00',2.26),('11288','2013-03-26','14:25:00',2.07),('11288','2013-03-26','14:30:00',1.66),('11288','2013-03-26','14:35:00',1.57),('11288','2013-03-26','14:40:00',1.68),('11288','2013-03-26','14:45:00',1.7),('11288','2013-03-26','14:50:00',1.56),('11288','2013-03-26','14:55:00',1.54),('11288','2013-03-26','15:00:00',1.55),('11288','2013-03-26','15:05:00',1.62),('11288','2013-03-26','15:10:00',1.52),('11288','2013-03-26','15:15:00',1.43),('11288','2013-03-26','15:20:00',1.55),('11288','2013-03-26','15:25:00',1.56),('11288','2013-03-26','15:30:00',1.69),('11288','2013-03-26','15:35:00',1.81),('11288','2013-03-26','15:40:00',1.55),('11288','2013-03-26','15:45:00',1.01),('11288','2013-03-25','08:10:00',1.24),('11288','2013-03-25','08:15:00',1.53),('11288','2013-03-25','08:20:00',2.09),('11288','2013-03-25','08:25:00',2.79),('11288','2013-03-25','08:30:00',1.83),('11288','2013-03-25','08:35:00',1.03),('11288','2013-03-25','08:40:00',1.42),('11288','2013-03-25','08:45:00',1.62),('11288','2013-03-25','08:50:00',1.83),('11288','2013-03-25','08:55:00',2.29),('11288','2013-03-25','09:00:00',2.03),('11288','2013-03-25','09:05:00',2.01),('11288','2013-03-25','09:10:00',2.23),('11288','2013-03-25','09:15:00',2.18),('11288','2013-03-25','09:20:00',4.16),('11288','2013-03-25','09:25:00',3.82),('11288','2013-03-25','09:30:00',2.74),('11288','2013-03-25','09:35:00',1.84),('11288','2013-03-25','09:40:00',1.25),('11288','2013-03-25','09:45:00',2.32),('11288','2013-03-25','09:50:00',7.17),('11288','2013-03-25','09:55:00',6.23),('11288','2013-03-25','10:00:00',1.99),('11288','2013-03-25','10:05:00',2.36),('11288','2013-03-25','10:10:00',2.15),('11288','2013-03-25','10:15:00',2.22),('11288','2013-03-25','10:20:00',2.99),('11288','2013-03-25','10:25:00',4.47),('11288','2013-03-25','10:30:00',3.96),('11288','2013-03-25','10:35:00',3.52),('11288','2013-03-25','10:40:00',3.42),('11288','2013-03-25','10:45:00',4.79),('11288','2013-03-25','10:50:00',5.25),('11288','2013-03-25','10:55:00',6.57),('11288','2013-03-25','11:00:00',4.27),('11288','2013-03-25','11:05:00',4.51),('11288','2013-03-25','11:10:00',4.78),('11288','2013-03-25','11:15:00',5.08),('11288','2013-03-25','11:20:00',6.72),('11288','2013-03-25','11:25:00',6.94),('11288','2013-03-25','11:30:00',8.16),('11288','2013-03-25','11:35:00',4.96),('11288','2013-03-25','11:40:00',2.45),('11288','2013-03-25','11:45:00',2.94),('11288','2013-03-25','11:50:00',3.45),('11288','2013-03-25','11:55:00',5.8),('11288','2013-03-25','12:00:00',8),('11288','2013-03-25','12:05:00',6.78),('11288','2013-03-25','12:10:00',7.14),('11288','2013-03-25','12:15:00',6.18),('11288','2013-03-25','12:20:00',5.1),('11288','2013-03-25','12:25:00',6.21),('11288','2013-03-25','12:30:00',5.44),('11288','2013-03-25','12:35:00',4.89),('11288','2013-03-25','12:40:00',4.76),('11288','2013-03-25','12:45:00',4.68),('11288','2013-03-25','12:50:00',4.99),('11288','2013-03-25','12:55:00',5.71),('11288','2013-03-25','13:00:00',6.36),('11288','2013-03-25','13:05:00',8.25),('11288','2013-03-25','13:10:00',6.78),('11288','2013-03-25','13:15:00',7.14),('11288','2013-03-25','13:20:00',4.67),('11288','2013-03-25','13:25:00',3.1),('11288','2013-03-25','13:30:00',2.86),('11288','2013-03-25','13:35:00',2.06),('11288','2013-03-25','13:40:00',2.34),('11288','2013-03-25','13:45:00',3.78),('11288','2013-03-25','13:50:00',3.41),('11288','2013-03-25','13:55:00',2.86),('11288','2013-03-25','14:00:00',1.75),('11288','2013-03-25','14:05:00',2.56),('11288','2013-03-25','14:10:00',5.43),('11288','2013-03-25','14:15:00',3.06),('11288','2013-03-25','14:20:00',4.63),('11288','2013-03-25','14:25:00',6.24),('11288','2013-03-25','14:30:00',4.8),('11288','2013-03-25','14:35:00',2.72),('11288','2013-03-25','14:40:00',2.59),('11288','2013-03-25','14:45:00',3.55),('11288','2013-03-25','14:50:00',3.09),('11288','2013-03-25','14:55:00',4.77),('11288','2013-03-25','15:00:00',4.82),('11288','2013-03-25','15:05:00',4.88),('11288','2013-03-25','15:10:00',5.48),('11288','2013-03-25','15:15:00',4.24),('11288','2013-03-25','15:20:00',3.39),('11288','2013-03-25','15:25:00',3.88),('11288','2013-03-25','15:30:00',4),('11288','2013-03-25','15:35:00',3.75),('11288','2013-03-25','15:40:00',4.73),('11288','2013-03-25','15:45:00',4.74),('11288','2013-03-25','15:50:00',2.6),('11288','2013-03-25','15:55:00',4.09),('11288','2013-03-25','16:00:00',3.16),('11288','2013-03-25','16:05:00',1.73),('11288','2013-03-25','16:10:00',2.07),('11288','2013-03-25','16:15:00',1.62),('11288','2013-03-25','16:20:00',1.27),('11288','2013-03-25','16:25:00',1.01),('11288','2013-03-25','16:30:00',2.63),('11288','2013-03-25','16:35:00',2.91),('11288','2013-03-25','16:40:00',2.4),('11288','2013-03-25','16:45:00',1.73),('11288','2013-03-25','16:50:00',1.42),('11288','2013-03-24','07:20:00',1.03),('11288','2013-03-24','07:25:00',1.12),('11288','2013-03-24','07:30:00',1.07),('11288','2013-03-24','07:35:00',1.23),('11288','2013-03-24','07:40:00',1.29),('11288','2013-03-24','07:45:00',1.39),('11288','2013-03-24','07:50:00',1.6),('11288','2013-03-24','07:55:00',1.75),('11288','2013-03-24','08:00:00',1.96),('11288','2013-03-24','08:05:00',2.29),('11288','2013-03-24','08:10:00',2.35),('11288','2013-03-24','08:15:00',2.53),('11288','2013-03-24','08:20:00',2.75),('11288','2013-03-24','08:25:00',2.83),('11288','2013-03-24','08:30:00',2.94),('11288','2013-03-24','08:35:00',3.11),('11288','2013-03-24','08:40:00',3.37),('11288','2013-03-24','08:45:00',3.54),('11288','2013-03-24','08:50:00',3.64),('11288','2013-03-24','08:55:00',3.77),('11288','2013-03-24','09:00:00',3.89),('11288','2013-03-24','09:05:00',4.05),('11288','2013-03-24','09:10:00',4.18),('11288','2013-03-24','09:15:00',4.32),('11288','2013-03-24','09:20:00',4.49),('11288','2013-03-24','09:25:00',4.62),('11288','2013-03-24','09:30:00',4.72),('11288','2013-03-24','09:35:00',4.8),('11288','2013-03-24','09:40:00',4.94),('11288','2013-03-24','09:45:00',5.03),('11288','2013-03-24','09:50:00',5.08),('11288','2013-03-24','09:55:00',5.15),('11288','2013-03-24','10:00:00',5.22),('11288','2013-03-24','10:05:00',5.34),('11288','2013-03-24','10:10:00',5.43),('11288','2013-03-24','10:15:00',5.49),('11288','2013-03-24','10:20:00',5.55),('11288','2013-03-24','10:25:00',5.6),('11288','2013-03-24','10:30:00',5.65),('11288','2013-03-24','10:35:00',5.7),('11288','2013-03-24','10:40:00',5.75),('11288','2013-03-24','10:45:00',5.79),('11288','2013-03-24','10:50:00',5.83),('11288','2013-03-24','10:55:00',5.86),('11288','2013-03-24','11:00:00',5.93),('11288','2013-03-24','11:05:00',5.97),('11288','2013-03-24','11:10:00',6.01),('11288','2013-03-24','11:15:00',6.09),('11288','2013-03-24','11:20:00',6.13),('11288','2013-03-24','11:25:00',6.17),('11288','2013-03-24','11:30:00',6.2),('11288','2013-03-24','11:35:00',6.2),('11288','2013-03-24','11:40:00',6.24),('11288','2013-03-24','11:45:00',6.19),('11288','2013-03-24','11:50:00',6.22),('11288','2013-03-24','11:55:00',6.23),('11288','2013-03-24','12:00:00',6.26),('11288','2013-03-24','12:05:00',6.37),('11288','2013-03-24','12:10:00',6.46),('11288','2013-03-24','12:15:00',6.56),('11288','2013-03-24','12:20:00',6.6),('11288','2013-03-24','12:25:00',6.63),('11288','2013-03-24','12:30:00',6.68),('11288','2013-03-24','12:35:00',6.71),('11288','2013-03-24','12:40:00',6.65),('11288','2013-03-24','12:45:00',6.67),('11288','2013-03-24','12:50:00',6.61),('11288','2013-03-24','12:55:00',6.56),('11288','2013-03-24','13:00:00',6.51),('11288','2013-03-24','13:05:00',6.55),('11288','2013-03-24','13:10:00',6.52),('11288','2013-03-24','13:15:00',6.48),('11288','2013-03-24','13:20:00',6.47),('11288','2013-03-24','13:25:00',6.34),('11288','2013-03-24','13:30:00',6.29),('11288','2013-03-24','13:35:00',6.21),('11288','2013-03-24','13:40:00',6.2),('11288','2013-03-24','13:45:00',6.16),('11288','2013-03-24','13:50:00',6.06),('11288','2013-03-24','13:55:00',6.02),('11288','2013-03-24','14:00:00',5.96),('11288','2013-03-24','14:05:00',5.84),('11288','2013-03-24','14:10:00',5.77),('11288','2013-03-24','14:15:00',5.69),('11288','2013-03-24','14:20:00',5.58),('11288','2013-03-24','14:25:00',5.45),('11288','2013-03-24','14:30:00',5.3),('11288','2013-03-24','14:35:00',5.16),('11288','2013-03-24','14:40:00',5.1),('11288','2013-03-24','14:45:00',5.02),('11288','2013-03-24','14:50:00',4.69),('11288','2013-03-24','14:55:00',4.74),('11288','2013-03-24','15:00:00',4.56),('11288','2013-03-24','15:05:00',4.42),('11288','2013-03-24','15:10:00',4.11),('11288','2013-03-24','15:15:00',4.51),('11288','2013-03-24','15:20:00',4.31),('11288','2013-03-24','15:25:00',3.97),('11288','2013-03-24','15:30:00',3.58),('11288','2013-03-24','15:35:00',3.56),('11288','2013-03-24','15:40:00',3.55),('11288','2013-03-24','15:45:00',2.82),('11288','2013-03-24','15:50:00',2.07),('11288','2013-03-24','15:55:00',2.02),('11288','2013-03-24','16:00:00',2.07),('11288','2013-03-24','16:05:00',2.36),('11288','2013-03-24','16:10:00',1.8),('11288','2013-03-24','16:15:00',2.35),('11288','2013-03-24','16:20:00',1.91),('11288','2013-03-24','16:25:00',1.83),('11288','2013-03-24','16:30:00',1.98),('11288','2013-03-24','16:35:00',1.75),('11288','2013-03-24','16:40:00',1.44),('11288','2013-03-24','16:45:00',1.45),('11288','2013-03-24','16:50:00',1.17),('11288','2013-03-23','07:20:00',1.03),('11288','2013-03-23','07:30:00',1.15),('11288','2013-03-23','07:35:00',1.2),('11288','2013-03-23','07:40:00',1.33),('11288','2013-03-23','07:45:00',1.4),('11288','2013-03-23','07:50:00',1.5),('11288','2013-03-23','07:55:00',1.7),('11288','2013-03-23','08:00:00',2.02),('11288','2013-03-23','08:05:00',2.22),('11288','2013-03-23','08:10:00',2.41),('11288','2013-03-23','08:15:00',2.57),('11288','2013-03-23','08:20:00',2.63),('11288','2013-03-23','08:25:00',2.74),('11288','2013-03-23','08:30:00',2.88),('11288','2013-03-23','08:35:00',2.98),('11288','2013-03-23','08:40:00',3.17),('11288','2013-03-23','08:45:00',3.46),('11288','2013-03-23','08:50:00',3.76),('11288','2013-03-23','08:55:00',4),('11288','2013-03-23','09:00:00',4.13),('11288','2013-03-23','09:05:00',4.32),('11288','2013-03-23','09:10:00',4.34),('11288','2013-03-23','09:15:00',4.49),('11288','2013-03-23','09:20:00',4.57),('11288','2013-03-23','09:25:00',4.76),('11288','2013-03-23','09:30:00',4.78),('11288','2013-03-23','09:35:00',4.99),('11288','2013-03-23','09:40:00',4.9),('11288','2013-03-23','09:45:00',5.14),('11288','2013-03-23','09:50:00',5.31),('11288','2013-03-23','09:55:00',5.4),('11288','2013-03-23','10:00:00',5.35),('11288','2013-03-23','10:05:00',5.49),('11288','2013-03-23','10:10:00',5.74),('11288','2013-03-23','10:15:00',5.68),('11288','2013-03-23','10:20:00',5.53),('11288','2013-03-23','10:25:00',5.66),('11288','2013-03-23','10:30:00',5.9),('11288','2013-03-23','10:35:00',5.91),('11288','2013-03-23','10:40:00',5.89),('11288','2013-03-23','10:45:00',5.85),('11288','2013-03-23','10:50:00',5.79),('11288','2013-03-23','10:55:00',5.71),('11288','2013-03-23','11:00:00',5.74),('11288','2013-03-23','11:05:00',5.49),('11288','2013-03-23','11:10:00',5.01),('11288','2013-03-23','11:15:00',4.81),('11288','2013-03-23','11:20:00',5.81),('11288','2013-03-23','11:25:00',5.99),('11288','2013-03-23','11:30:00',6.01),('11288','2013-03-23','11:35:00',6.31),('11288','2013-03-23','11:40:00',6.26),('11288','2013-03-23','11:45:00',6.23),('11288','2013-03-23','11:50:00',6.01),('11288','2013-03-23','11:55:00',6.33),('11288','2013-03-23','12:00:00',6.37),('11288','2013-03-23','12:05:00',6.31),('11288','2013-03-23','12:10:00',6.52),('11288','2013-03-23','12:15:00',6.56),('11288','2013-03-23','12:20:00',6.61),('11288','2013-03-23','12:25:00',6.41),('11288','2013-03-23','12:30:00',6.52),('11288','2013-03-23','12:35:00',6.5),('11288','2013-03-23','12:40:00',6.29),('11288','2013-03-23','12:45:00',6.43),('11288','2013-03-23','12:50:00',6.46),('11288','2013-03-23','12:55:00',6.12),('11288','2013-03-23','13:00:00',5.3),('11288','2013-03-23','13:05:00',6.35),('11288','2013-03-23','13:10:00',6.36),('11288','2013-03-23','13:15:00',6.23),('11288','2013-03-23','13:20:00',6.25),('11288','2013-03-23','13:25:00',6.09),('11288','2013-03-23','13:30:00',5.99),('11288','2013-03-23','13:35:00',6.19),('11288','2013-03-23','13:40:00',6.1),('11288','2013-03-23','13:45:00',6.1),('11288','2013-03-23','13:50:00',5.99),('11288','2013-03-23','13:55:00',5.81),('11288','2013-03-23','14:00:00',5.69),('11288','2013-03-23','14:05:00',5.73),('11288','2013-03-23','14:10:00',5.49),('11288','2013-03-23','14:15:00',5.35),('11288','2013-03-23','14:20:00',5.55),('11288','2013-03-23','14:25:00',5.41),('11288','2013-03-23','14:30:00',5.43),('11288','2013-03-23','14:35:00',5.28),('11288','2013-03-23','14:40:00',5.09),('11288','2013-03-23','14:45:00',4.81),('11288','2013-03-23','14:50:00',4.76),('11288','2013-03-23','14:55:00',4.87),('11288','2013-03-23','15:00:00',4.68),('11288','2013-03-23','15:05:00',4.36),('11288','2013-03-23','15:10:00',4.43),('11288','2013-03-23','15:15:00',4.14),('11288','2013-03-23','15:20:00',4.18),('11288','2013-03-23','15:25:00',4.02),('11288','2013-03-23','15:30:00',3.71),('11288','2013-03-23','15:35:00',3.66),('11288','2013-03-23','15:40:00',3.51),('11288','2013-03-23','15:45:00',3.19),('11288','2013-03-23','15:50:00',3.06),('11288','2013-03-23','15:55:00',2.98),('11288','2013-03-23','16:00:00',2.74),('11288','2013-03-23','16:05:00',2.58),('11288','2013-03-23','16:10:00',3.09),('11288','2013-03-23','16:15:00',2.71),('11288','2013-03-23','16:20:00',2.36),('11288','2013-03-23','16:25:00',2.32),('11288','2013-03-23','16:30:00',1.77),('11288','2013-03-23','16:35:00',1.9),('11288','2013-03-23','16:40:00',1.66),('11288','2013-03-23','16:45:00',1.63),('11288','2013-03-23','16:50:00',1.37),('11288','2013-03-23','16:55:00',1.36),('11288','2013-03-23','17:00:00',1.56),('11288','2013-03-23','17:05:00',1.51),('11288','2013-03-23','17:10:00',1.32),('11288','2013-03-23','17:15:00',1.07),('11288','2014-03-26','07:20:00',1.02),('11288','2014-03-26','07:25:00',1.06),('11288','2014-03-26','07:30:00',1.25),('11288','2014-03-26','07:35:00',1.42),('11288','2014-03-26','07:40:00',1.58),('11288','2014-03-26','07:45:00',1.71),('11288','2014-03-26','07:50:00',1.74),('11288','2014-03-26','07:55:00',1.82),('11288','2014-03-26','08:00:00',2.1),('11288','2014-03-26','08:05:00',2.25),('11288','2014-03-26','08:10:00',2.49),('11288','2014-03-26','08:15:00',2.95),('11288','2014-03-26','08:20:00',2.46),('11288','2014-03-26','08:25:00',2.03),('11288','2014-03-26','08:30:00',1.85),('11288','2014-03-26','08:35:00',1.58),('11288','2014-03-26','08:40:00',1.87),('11288','2014-03-26','08:45:00',2.02),('11288','2014-03-26','08:50:00',2.39),('11288','2014-03-26','08:55:00',2.12),('11288','2014-03-26','09:00:00',2.38),('11288','2014-03-26','09:05:00',2.24),('11288','2014-03-26','09:10:00',2.63),('11288','2014-03-26','09:15:00',2.16),('11288','2014-03-26','09:20:00',1.76),('11288','2014-03-26','09:25:00',3.32),('11288','2014-03-26','09:30:00',4.84),('11288','2014-03-26','09:35:00',5.11),('11288','2014-03-26','09:40:00',5.17),('11288','2014-03-26','09:45:00',5.25),('11288','2014-03-26','09:50:00',5.31),('11288','2014-03-26','09:55:00',5.48),('11288','2014-03-26','10:00:00',5.8),('11288','2014-03-26','10:05:00',3.8),('11288','2014-03-26','10:10:00',6.36),('11288','2014-03-26','10:15:00',5.35),('11288','2014-03-26','10:20:00',3.47),('11288','2014-03-26','10:25:00',5.52),('11288','2014-03-26','10:30:00',4.38),('11288','2014-03-26','10:35:00',2.28),('11288','2014-03-26','10:40:00',1.43),('11288','2014-03-26','10:45:00',2.55),('11288','2014-03-26','10:50:00',4.89),('11288','2014-03-26','10:55:00',7.95),('11288','2014-03-26','11:00:00',5.33),('11288','2014-03-26','11:05:00',2.45),('11288','2014-03-26','11:10:00',6.77),('11288','2014-03-26','11:15:00',8.49),('11288','2014-03-26','11:20:00',2.94),('11288','2014-03-26','11:25:00',2.17),('11288','2014-03-26','11:30:00',2.92),('11288','2014-03-26','11:35:00',2.96),('11288','2014-03-26','11:40:00',3.3),('11288','2014-03-26','11:45:00',7.15),('11288','2014-03-26','11:50:00',6.23),('11288','2014-03-26','11:55:00',8.02),('11288','2014-03-26','12:00:00',7.36),('11288','2014-03-26','12:05:00',6.66),('11288','2014-03-26','12:10:00',5.7),('11288','2014-03-26','12:15:00',2.86),('11288','2014-03-26','12:20:00',3.25),('11288','2014-03-26','12:25:00',2.99),('11288','2014-03-26','12:30:00',2.98),('11288','2014-03-26','12:35:00',2.85),('11288','2014-03-26','12:40:00',3.68),('11288','2014-03-26','12:45:00',3.52),('11288','2014-03-26','12:50:00',2.68),('11288','2014-03-26','12:55:00',2.1),('11288','2014-03-26','13:00:00',2.36),('11288','2014-03-26','13:05:00',2.15),('11288','2014-03-26','13:10:00',1.67),('11288','2014-03-26','13:15:00',1.38),('11288','2014-03-26','13:20:00',6.29),('11288','2014-03-26','13:25:00',7.35),('11288','2014-03-26','13:30:00',5.33),('11288','2014-03-26','13:35:00',3.28),('11288','2014-03-26','13:40:00',2),('11288','2014-03-26','13:45:00',1.62),('11288','2014-03-26','13:50:00',1.72),('11288','2014-03-26','13:55:00',2.86),('11288','2014-03-26','14:00:00',7.79),('11288','2014-03-26','14:05:00',7.66),('11288','2014-03-26','14:10:00',3.75),('11288','2014-03-26','14:15:00',1.88),('11288','2014-03-26','14:20:00',1.72),('11288','2014-03-26','14:25:00',1.48),('11288','2014-03-26','14:30:00',1.3),('11288','2014-03-26','14:35:00',1.14),('11288','2014-03-26','14:40:00',1.63),('11288','2014-03-26','14:45:00',4.43),('11288','2014-03-26','14:50:00',5.12),('11288','2014-03-26','14:55:00',5.62),('11288','2014-03-26','15:00:00',4.89),('11288','2014-03-26','15:05:00',4.97),('11288','2014-03-26','15:10:00',5.07),('11288','2014-03-26','15:15:00',5.3),('11288','2014-03-26','15:20:00',4.86),('11288','2014-03-26','15:25:00',4.86),('11288','2014-03-26','15:30:00',4.88),('11288','2014-03-26','15:35:00',4.56),('11288','2014-03-26','15:40:00',3.76),('11288','2014-03-26','15:45:00',3.43),('11288','2014-03-26','15:50:00',2.64),('11288','2014-03-26','15:55:00',2.4),('11288','2014-03-26','16:00:00',2.07),('11288','2014-03-26','16:05:00',1.78),('11288','2014-03-26','16:10:00',2.21),('11288','2014-03-26','16:15:00',2.38),('11288','2014-03-26','16:20:00',1.9),('11288','2014-03-26','16:25:00',1.47),('11288','2014-03-26','16:30:00',1.19),('11288','2014-03-26','16:35:00',1.14),('11288','2013-03-22','07:30:00',1.04),('11288','2013-03-22','07:35:00',1.25),('11288','2013-03-22','07:40:00',1.33),('11288','2013-03-22','07:45:00',1.49),('11288','2013-03-22','07:50:00',1.6),('11288','2013-03-22','07:55:00',1.68),('11288','2013-03-22','08:00:00',1.94),('11288','2013-03-22','08:05:00',2.14),('11288','2013-03-22','08:10:00',2.32),('11288','2013-03-22','08:15:00',2.51),('11288','2013-03-22','08:20:00',2.59),('11288','2013-03-22','08:25:00',2.77),('11288','2013-03-22','08:30:00',2.83),('11288','2013-03-22','08:35:00',3.09),('11288','2013-03-22','08:40:00',3.29),('11288','2013-03-22','08:45:00',3.43),('11288','2013-03-22','08:50:00',3.71),('11288','2013-03-22','08:55:00',3.9),('11288','2013-03-22','09:00:00',4.01),('11288','2013-03-22','09:05:00',4.17),('11288','2013-03-22','09:10:00',4.27),('11288','2013-03-22','09:15:00',4.36),('11288','2013-03-22','09:20:00',4.53),('11288','2013-03-22','09:25:00',4.69),('11288','2013-03-22','09:30:00',4.82),('11288','2013-03-22','09:35:00',4.92),('11288','2013-03-22','09:40:00',5.08),('11288','2013-03-22','09:45:00',5.13),('11288','2013-03-22','09:50:00',5.2),('11288','2013-03-22','09:55:00',5.31),('11288','2013-03-22','10:00:00',5.4),('11288','2013-03-22','10:05:00',5.45),('11288','2013-03-22','10:10:00',5.52),('11288','2013-03-22','10:15:00',5.57),('11288','2013-03-22','10:20:00',5.73),('11288','2013-03-22','10:25:00',5.84),('11288','2013-03-22','10:30:00',5.87),('11288','2013-03-22','10:35:00',5.93),('11288','2013-03-22','10:40:00',5.99),('11288','2013-03-22','10:45:00',6.03),('11288','2013-03-22','10:50:00',6.12),('11288','2013-03-22','10:55:00',6.14),('11288','2013-03-22','11:00:00',6.24),('11288','2013-03-22','11:05:00',6.29),('11288','2013-03-22','11:10:00',6.33),('11288','2013-03-22','11:15:00',6.43),('11288','2013-03-22','11:20:00',6.5),('11288','2013-03-22','11:25:00',6.52),('11288','2013-03-22','11:30:00',6.6),('11288','2013-03-22','11:35:00',6.59),('11288','2013-03-22','11:40:00',6.68),('11288','2013-03-22','11:45:00',6.67),('11288','2013-03-22','11:50:00',6.69),('11288','2013-03-22','11:55:00',6.71),('11288','2013-03-22','12:00:00',6.72),('11288','2013-03-22','12:05:00',6.72),('11288','2013-03-22','12:10:00',6.76),('11288','2013-03-22','12:15:00',6.73),('11288','2013-03-22','12:20:00',6.74),('11288','2013-03-22','12:25:00',6.77),('11288','2013-03-22','12:30:00',6.75),('11288','2013-03-22','12:35:00',6.78),('11288','2013-03-22','12:40:00',6.72),('11288','2013-03-22','12:45:00',6.71),('11288','2013-03-22','12:50:00',6.59),('11288','2013-03-22','12:55:00',6.54),('11288','2013-03-22','13:00:00',6.66),('11288','2013-03-22','13:05:00',6.63),('11288','2013-03-22','13:10:00',6.65),('11288','2013-03-22','13:15:00',6.59),('11288','2013-03-22','13:20:00',6.52),('11288','2013-03-22','13:25:00',6.11),('11288','2013-03-22','13:30:00',6.04),('11288','2013-03-22','13:35:00',6.37),('11288','2013-03-22','13:40:00',5.57),('11288','2013-03-22','13:45:00',5.95),('11288','2013-03-22','13:50:00',6.3),('11288','2013-03-22','13:55:00',6.15),('11288','2013-03-22','14:00:00',6.03),('11288','2013-03-22','14:05:00',5.97),('11288','2013-03-22','14:10:00',5.92),('11288','2013-03-22','14:15:00',5.84),('11288','2013-03-22','14:20:00',5.72),('11288','2013-03-22','14:25:00',5.69),('11288','2013-03-22','14:30:00',5.59),('11288','2013-03-22','14:35:00',5.43),('11288','2013-03-22','14:40:00',5.36),('11288','2013-03-22','14:45:00',5.26),('11288','2013-03-22','14:50:00',5.14),('11288','2013-03-22','14:55:00',5.03),('11288','2013-03-22','15:00:00',4.91),('11288','2013-03-22','15:05:00',4.78),('11288','2013-03-22','15:10:00',4.18),('11288','2013-03-22','15:15:00',3.52),('11288','2013-03-22','15:20:00',3.27),('11288','2013-03-22','15:25:00',3.42),('11288','2013-03-22','15:30:00',3.34),('11288','2013-03-22','15:35:00',3.68),('11288','2013-03-22','15:40:00',3.45),('11288','2013-03-22','15:45:00',3.06),('11288','2013-03-22','15:50:00',3.32),('11288','2013-03-22','15:55:00',2.85),('11288','2013-03-22','16:00:00',2.25),('11288','2013-03-22','16:05:00',2.3),('11288','2013-03-22','16:10:00',2.62),('11288','2013-03-22','16:15:00',2.97),('11288','2013-03-22','16:20:00',2.42),('11288','2013-03-22','16:25:00',2.42),('11288','2013-03-22','16:30:00',2.6),('11288','2013-03-22','16:35:00',2.5),('11288','2013-03-22','16:40:00',2.4),('11288','2013-03-22','16:45:00',2.17),('11288','2013-03-22','16:50:00',2.07),('11288','2013-03-22','16:55:00',1.93),('11288','2013-03-22','17:00:00',1.7),('11288','2013-03-22','17:05:00',1.44),('11288','2013-03-22','17:10:00',1.29),('11288','2013-03-22','17:15:00',1.15),('11288','2013-03-22','17:20:00',1.04),('11288','2013-03-21','07:30:00',1.07),('11288','2013-03-21','07:40:00',1.3),('11288','2013-03-21','07:45:00',1.34),('11288','2013-03-21','07:50:00',1.77),('11288','2013-03-21','07:55:00',1.42),('11288','2013-03-21','08:00:00',1.1),('11288','2013-03-21','08:10:00',1.52),('11288','2013-03-21','08:15:00',2.15),('11288','2013-03-21','08:20:00',2.44),('11288','2013-03-21','08:25:00',2.63),('11288','2013-03-21','08:30:00',2.01),('11288','2013-03-21','08:35:00',2.71),('11288','2013-03-21','08:40:00',3.04),('11288','2013-03-21','08:45:00',1.98),('11288','2013-03-21','08:50:00',2.95),('11288','2013-03-21','08:55:00',4.08),('11288','2013-03-21','09:00:00',4.29),('11288','2013-03-21','09:05:00',4.94),('11288','2013-03-21','09:10:00',4.49),('11288','2013-03-21','09:15:00',3.23),('11288','2013-03-21','09:20:00',3.03),('11288','2013-03-21','09:25:00',2.77),('11288','2013-03-21','09:30:00',2.94),('11288','2013-03-21','09:35:00',5.18),('11288','2013-03-21','09:40:00',4.69),('11288','2013-03-21','09:45:00',5.57),('11288','2013-03-21','09:50:00',5.64),('11288','2013-03-21','09:55:00',5.76),('11288','2013-03-21','10:00:00',5.8),('11288','2013-03-21','10:05:00',5.85),('11288','2013-03-21','10:10:00',5.91),('11288','2013-03-21','10:15:00',5.97),('11288','2013-03-21','10:20:00',6),('11288','2013-03-21','10:25:00',6.07),('11288','2013-03-21','10:30:00',6.15),('11288','2013-03-21','10:35:00',6.25),('11288','2013-03-21','10:40:00',6.24),('11288','2013-03-21','10:45:00',6.22),('11288','2013-03-21','10:50:00',6.25),('11288','2013-03-21','10:55:00',5.99),('11288','2013-03-21','11:00:00',6.41),('11288','2013-03-21','11:05:00',6.5),('11288','2013-03-21','11:10:00',6.53),('11288','2013-03-21','11:15:00',6.68),('11288','2013-03-21','11:20:00',6.79),('11288','2013-03-21','11:25:00',6.88),('11288','2013-03-21','11:30:00',6.92),('11288','2013-03-21','11:35:00',6.93),('11288','2013-03-21','11:40:00',6.98),('11288','2013-03-21','11:45:00',7.04),('11288','2013-03-21','11:50:00',7.08),('11288','2013-03-21','11:55:00',7.09),('11288','2013-03-21','12:00:00',7.09),('11288','2013-03-21','12:05:00',7.09),('11288','2013-03-21','12:10:00',7.11),('11288','2013-03-21','12:15:00',7.11),('11288','2013-03-21','12:20:00',7.03),('11288','2013-03-21','12:25:00',7.13),('11288','2013-03-21','12:30:00',7.13),('11288','2013-03-21','12:35:00',7.08),('11288','2013-03-21','12:40:00',7.06),('11288','2013-03-21','12:45:00',6.95),('11288','2013-03-21','12:50:00',6.91),('11288','2013-03-21','12:55:00',6.84),('11288','2013-03-21','13:00:00',6.88),('11288','2013-03-21','13:05:00',6.82),('11288','2013-03-21','13:10:00',6.79),('11288','2013-03-21','13:15:00',6.75),('11288','2013-03-21','13:20:00',6.72),('11288','2013-03-21','13:25:00',6.66),('11288','2013-03-21','13:30:00',6.58),('11288','2013-03-21','13:35:00',6.54),('11288','2013-03-21','13:40:00',6.51),('11288','2013-03-21','13:45:00',6.46),('11288','2013-03-21','13:50:00',6.41),('11288','2013-03-21','13:55:00',6.34),('11288','2013-03-21','14:00:00',6.23),('11288','2013-03-21','14:05:00',6.13),('11288','2013-03-21','14:10:00',6.06),('11288','2013-03-21','14:15:00',5.98),('11288','2013-03-21','14:20:00',5.86),('11288','2013-03-21','14:25:00',5.76),('11288','2013-03-21','14:30:00',5.66),('11288','2013-03-21','14:35:00',5.55),('11288','2013-03-21','14:40:00',5.43),('11288','2013-03-21','14:45:00',5.36),('11288','2013-03-21','14:50:00',5.24),('11288','2013-03-21','14:55:00',5.13),('11288','2013-03-21','15:00:00',5.03),('11288','2013-03-21','15:05:00',4.9),('11288','2013-03-21','15:10:00',4.72),('11288','2013-03-21','15:15:00',4.63),('11288','2013-03-21','15:20:00',4.52),('11288','2013-03-21','15:25:00',4.34),('11288','2013-03-21','15:30:00',4.21),('11288','2013-03-21','15:35:00',4.09),('11288','2013-03-21','15:40:00',3.91),('11288','2013-03-21','15:45:00',3.75),('11288','2013-03-21','15:50:00',3.61),('11288','2013-03-21','15:55:00',3.44),('11288','2013-03-21','16:00:00',3.3),('11288','2013-03-21','16:05:00',3.14),('11288','2013-03-21','16:10:00',2.99),('11288','2013-03-21','16:15:00',2.82),('11288','2013-03-21','16:20:00',2.67),('11288','2013-03-21','16:25:00',2.47),('11288','2013-03-21','16:30:00',2.31),('11288','2013-03-21','16:35:00',2.15),('11288','2013-03-21','16:40:00',1.99),('11288','2013-03-21','16:45:00',1.87),('11288','2013-03-21','16:50:00',1.71),('11288','2013-03-21','16:55:00',1.52),('11288','2013-03-21','17:00:00',1.38),('11288','2013-03-21','17:05:00',1.22),('11288','2013-03-21','17:10:00',1.09),('11288','2013-03-20','07:30:00',1.1),('11288','2013-03-20','07:35:00',1.19),('11288','2013-03-20','07:40:00',1.2),('11288','2013-03-20','07:45:00',1.37),('11288','2013-03-20','07:50:00',1.4),('11288','2013-03-20','07:55:00',2.09),('11288','2013-03-20','08:00:00',1.66),('11288','2013-03-20','08:05:00',1.83),('11288','2013-03-20','08:10:00',2.19),('11288','2013-03-20','08:15:00',2.39),('11288','2013-03-20','08:20:00',2.58),('11288','2013-03-20','08:25:00',2.74),('11288','2013-03-20','08:30:00',2.93),('11288','2013-03-20','08:35:00',3.05),('11288','2013-03-20','08:40:00',3.06),('11288','2013-03-20','08:45:00',3.34),('11288','2013-03-20','08:50:00',3.54),('11288','2013-03-20','08:55:00',3.58),('11288','2013-03-20','09:00:00',3.83),('11288','2013-03-20','09:05:00',4.81),('11288','2013-03-20','09:10:00',4.17),('11288','2013-03-20','09:15:00',4.24),('11288','2013-03-20','09:20:00',4.44),('11288','2013-03-20','09:25:00',4.66),('11288','2013-03-20','09:30:00',4.76),('11288','2013-03-20','09:35:00',4.65),('11288','2013-03-20','09:40:00',4.97),('11288','2013-03-20','09:45:00',5.07),('11288','2013-03-20','09:50:00',5.16),('11288','2013-03-20','09:55:00',5.15),('11288','2013-03-20','10:00:00',5.34),('11288','2013-03-20','10:05:00',5.33),('11288','2013-03-20','10:10:00',4.52),('11288','2013-03-20','10:15:00',5.54),('11288','2013-03-20','10:20:00',4.07),('11288','2013-03-20','10:25:00',4.03),('11288','2013-03-20','10:30:00',4.53),('11288','2013-03-20','10:35:00',5.37),('11288','2013-03-20','10:40:00',4.27),('11288','2013-03-20','10:45:00',4.45),('11288','2013-03-20','10:50:00',4.64),('11288','2013-03-20','10:55:00',4.68),('11288','2013-03-20','11:00:00',4.83),('11288','2013-03-20','11:05:00',5.49),('11288','2013-03-20','11:10:00',4.01),('11288','2013-03-20','11:15:00',4.06),('11288','2013-03-20','11:20:00',4.57),('11288','2013-03-20','11:25:00',4.41),('11288','2013-03-20','11:30:00',4.13),('11288','2013-03-20','11:35:00',4.56),('11288','2013-03-20','11:40:00',3.68),('11288','2013-03-20','11:45:00',3.58),('11288','2013-03-20','11:50:00',3.54),('11288','2013-03-20','11:55:00',3.8),('11288','2013-03-20','12:00:00',3.81),('11288','2013-03-20','12:05:00',4.16),('11288','2013-03-20','12:10:00',3.42),('11288','2013-03-20','12:15:00',2.98),('11288','2013-03-20','12:20:00',2.72),('11288','2013-03-20','12:25:00',2.31),('11288','2013-03-20','12:30:00',1.94),('11288','2013-03-20','12:35:00',2.56),('11288','2013-03-20','12:40:00',1.74),('11288','2013-03-20','12:45:00',2.02),('11288','2013-03-20','12:50:00',2.72),('11288','2013-03-20','12:55:00',3.23),('11288','2013-03-20','13:00:00',3.31),('11288','2013-03-20','13:05:00',2.64),('11288','2013-03-20','13:10:00',2.55),('11288','2013-03-20','13:15:00',2.17),('11288','2013-03-20','13:20:00',2.31),('11288','2013-03-20','13:25:00',2.44),('11288','2013-03-20','13:30:00',2.63),('11288','2013-03-20','13:35:00',2.53),('11288','2013-03-20','13:40:00',3.19),('11288','2013-03-20','13:45:00',3.59),('11288','2013-03-20','13:50:00',3.03),('11288','2013-03-20','13:55:00',2.86),('11288','2013-03-20','14:00:00',2.84),('11288','2013-03-20','14:05:00',2.43),('11288','2013-03-20','14:10:00',2.33),('11288','2013-03-20','14:15:00',3.16),('11288','2013-03-20','14:20:00',3.75),('11288','2013-03-20','14:25:00',3.42),('11288','2013-03-20','14:30:00',2.99),('11288','2013-03-20','14:35:00',2.47),('11288','2013-03-20','14:40:00',1.98),('11288','2013-03-20','14:45:00',1.93),('11288','2013-03-20','14:50:00',1.53),('11288','2013-03-20','14:55:00',1.26),('11288','2013-03-20','15:00:00',1.38),('11288','2013-03-20','15:05:00',1.25),('11288','2013-03-20','15:10:00',1.12),('11288','2013-03-20','15:30:00',1.14),('11288','2013-03-19','07:05:00',1.08),('11288','2013-03-19','07:15:00',1.18),('11288','2013-03-19','07:35:00',1.09),('11288','2013-03-19','07:40:00',1.22),('11288','2013-03-19','07:45:00',1.38),('11288','2013-03-19','07:50:00',1.56),('11288','2013-03-19','07:55:00',1.59),('11288','2013-03-19','08:00:00',1.31),('11288','2013-03-19','08:05:00',1.71),('11288','2013-03-19','08:10:00',2.18),('11288','2013-03-19','08:15:00',2.39),('11288','2013-03-19','08:20:00',2.54),('11288','2013-03-19','08:25:00',2.59),('11288','2013-03-19','08:30:00',2.78),('11288','2013-03-19','08:35:00',2.62),('11288','2013-03-19','08:40:00',3.03),('11288','2013-03-19','08:45:00',3.22),('11288','2013-03-19','08:50:00',3.26),('11288','2013-03-19','08:55:00',3.75),('11288','2013-03-19','09:00:00',3.87),('11288','2013-03-19','09:05:00',4.03),('11288','2013-03-19','09:10:00',4.18),('11288','2013-03-19','09:15:00',4.36),('11288','2013-03-19','09:20:00',3.39),('11288','2013-03-19','09:25:00',4.39),('11288','2013-03-19','09:30:00',4.89),('11288','2013-03-19','09:35:00',4.89),('11288','2013-03-19','09:40:00',5.1),('11288','2013-03-19','09:45:00',4.75),('11288','2013-03-19','09:50:00',4.53),('11288','2013-03-19','09:55:00',5.09),('11288','2013-03-19','10:00:00',4.33),('11288','2013-03-19','10:05:00',5.55),('11288','2013-03-19','10:10:00',5.71),('11288','2013-03-19','10:15:00',5.75),('11288','2013-03-19','10:20:00',5.65),('11288','2013-03-19','10:25:00',4.48),('11288','2013-03-19','10:30:00',6.01),('11288','2013-03-19','10:35:00',6.07),('11288','2013-03-19','10:40:00',6.1),('11288','2013-03-19','10:45:00',6.21),('11288','2013-03-19','10:50:00',6.28),('11288','2013-03-19','10:55:00',6.38),('11288','2013-03-19','11:00:00',6.47),('11288','2013-03-19','11:05:00',6.45),('11288','2013-03-19','11:10:00',6.19),('11288','2013-03-19','11:15:00',6.57),('11288','2013-03-19','11:20:00',6.63),('11288','2013-03-19','11:25:00',6.6),('11288','2013-03-19','11:30:00',6.72),('11288','2013-03-19','11:35:00',4.06),('11288','2013-03-19','11:40:00',6.41),('11288','2013-03-19','11:45:00',6.13),('11288','2013-03-19','11:50:00',7.11),('11288','2013-03-19','11:55:00',6.95),('11288','2013-03-19','12:00:00',6.88),('11288','2013-03-19','12:05:00',6.82),('11288','2013-03-19','12:10:00',6.78),('11288','2013-03-19','12:15:00',6.5),('11288','2013-03-19','12:20:00',6.83),('11288','2013-03-19','12:25:00',6.65),('11288','2013-03-19','12:30:00',6.63),('11288','2013-03-19','12:35:00',6.78),('11288','2013-03-19','12:40:00',6.74),('11288','2013-03-19','12:45:00',6.58),('11288','2013-03-19','12:50:00',6.81),('11288','2013-03-19','12:55:00',6.78),('11288','2013-03-19','13:00:00',6.66),('11288','2013-03-19','13:05:00',6.61),('11288','2013-03-19','13:10:00',6.57),('11288','2013-03-19','13:15:00',6.49),('11288','2013-03-19','13:20:00',6.48),('11288','2013-03-19','13:25:00',6.42),('11288','2013-03-19','13:30:00',6.4),('11288','2013-03-19','13:35:00',6.32),('11288','2013-03-19','13:40:00',6.13),('11288','2013-03-19','13:45:00',6.21),('11288','2013-03-19','13:50:00',6.17),('11288','2013-03-19','13:55:00',6.07),('11288','2013-03-19','14:00:00',6.01),('11288','2013-03-19','14:05:00',5.92),('11288','2013-03-19','14:10:00',5.8),('11288','2013-03-19','14:15:00',5.75),('11288','2013-03-19','14:20:00',5.7),('11288','2013-03-19','14:25:00',5.61),('11288','2013-03-19','14:30:00',5.51),('11288','2013-03-19','14:35:00',5.42),('11288','2013-03-19','14:40:00',5.31),('11288','2013-03-19','14:45:00',5.18),('11288','2013-03-19','14:50:00',5.06),('11288','2013-03-19','14:55:00',4.94),('11288','2013-03-19','15:00:00',4.85),('11288','2013-03-19','15:05:00',4.68),('11288','2013-03-19','15:10:00',4.56),('11288','2013-03-19','15:15:00',4.44),('11288','2013-03-19','15:20:00',4.33),('11288','2013-03-19','15:25:00',4.17),('11288','2013-03-19','15:30:00',4.07),('11288','2013-03-19','15:35:00',3.93),('11288','2013-03-19','15:40:00',3.77),('11288','2013-03-19','15:45:00',3.64),('11288','2013-03-19','15:50:00',3.5),('11288','2013-03-19','15:55:00',3.33),('11288','2013-03-19','16:00:00',3.18),('11288','2013-03-19','16:05:00',3.01),('11288','2013-03-19','16:10:00',2.86),('11288','2013-03-19','16:15:00',2.67),('11288','2013-03-19','16:20:00',2.5),('11288','2013-03-19','16:25:00',2.34),('11288','2013-03-19','16:30:00',2.22),('11288','2013-03-19','16:35:00',2.08),('11288','2013-03-19','16:40:00',1.91),('11288','2013-03-19','16:45:00',1.57),('11288','2013-03-19','16:50:00',1.26),('11288','2013-03-19','16:55:00',1.36),('11288','2013-03-19','17:00:00',1.06),('11288','2013-03-19','17:15:00',1.08),('11288','2013-03-18','08:20:00',1.06),('11288','2013-03-18','08:25:00',1.22),('11288','2013-03-18','08:30:00',1.34),('11288','2013-03-18','08:35:00',1.26),('11288','2013-03-18','08:40:00',1.25),('11288','2013-03-18','08:45:00',1.77),('11288','2013-03-18','08:50:00',1.47),('11288','2013-03-18','08:55:00',1.27),('11288','2013-03-18','09:35:00',1.07),('11288','2013-03-18','09:40:00',1.23),('11288','2013-03-18','09:45:00',1.3),('11288','2013-03-18','09:50:00',1.37),('11288','2013-03-18','09:55:00',1.9),('11288','2013-03-18','10:00:00',2.35),('11288','2013-03-18','10:05:00',2.78),('11288','2013-03-18','10:10:00',2.72),('11288','2013-03-18','10:15:00',2.37),('11288','2013-03-18','10:20:00',2.81),('11288','2013-03-18','10:25:00',3.34),('11288','2013-03-18','10:30:00',3.22),('11288','2013-03-18','10:35:00',2.78),('11288','2013-03-18','10:40:00',2.63),('11288','2013-03-18','10:45:00',2.76),('11288','2013-03-18','10:50:00',2.59),('11288','2013-03-18','10:55:00',2.16),('11288','2013-03-18','11:00:00',2.36),('11288','2013-03-18','11:05:00',2.6),('11288','2013-03-18','11:10:00',2.95),('11288','2013-03-18','11:15:00',3.22),('11288','2013-03-18','11:20:00',3.3),('11288','2013-03-18','11:25:00',3.51),('11288','2013-03-18','11:30:00',4.28),('11288','2013-03-18','11:35:00',3.56),('11288','2013-03-18','11:40:00',3.3),('11288','2013-03-18','11:45:00',2.8),('11288','2013-03-18','11:50:00',2.34),('11288','2013-03-18','11:55:00',2.83),('11288','2013-03-18','12:00:00',2.92),('11288','2013-03-18','12:05:00',4.97),('11288','2013-03-18','12:10:00',4.76),('11288','2013-03-18','12:15:00',5.43),('11288','2013-03-18','12:20:00',5.02),('11288','2013-03-18','12:25:00',4.04),('11288','2013-03-18','12:30:00',5.73),('11288','2013-03-18','12:35:00',6.76),('11288','2013-03-18','12:40:00',4.89),('11288','2013-03-18','12:45:00',4.83),('11288','2013-03-18','12:50:00',6.32),('11288','2013-03-18','12:55:00',6.78),('11288','2013-03-18','13:00:00',6.6),('11288','2013-03-18','13:05:00',3.09),('11288','2013-03-18','13:10:00',2.3),('11288','2013-03-18','13:15:00',1.69),('11288','2013-03-18','13:20:00',2.15),('11288','2013-03-18','13:25:00',3.85),('11288','2013-03-18','13:30:00',2.35),('11288','2013-03-18','13:35:00',2.25),('11288','2013-03-18','13:40:00',3.93),('11288','2013-03-18','13:45:00',3.35),('11288','2013-03-18','13:50:00',3.02),('11288','2013-03-18','13:55:00',2.73),('11288','2013-03-18','14:00:00',3.12),('11288','2013-03-18','14:05:00',4.69),('11288','2013-03-18','14:10:00',4.03),('11288','2013-03-18','14:15:00',2.23),('11288','2013-03-18','14:20:00',2.39),('11288','2013-03-18','14:25:00',3.11),('11288','2013-03-18','14:30:00',1.57),('11288','2013-03-18','14:35:00',2.09),('11288','2013-03-18','14:40:00',2.21),('11288','2013-03-18','14:45:00',1.95),('11288','2013-03-18','14:50:00',1.15),('11288','2013-03-18','14:55:00',1.76),('11288','2013-03-18','15:00:00',1.96),('11288','2013-03-18','15:05:00',1.69),('11288','2013-03-18','15:10:00',1.22),('11288','2013-03-18','15:15:00',1.67),('11288','2013-03-18','15:20:00',1.21),('11288','2013-03-18','15:25:00',1.14),('11288','2013-03-18','15:30:00',1.06),('11288','2013-03-18','15:35:00',1.01),('11288','2013-03-17','07:50:00',1.13),('11288','2013-03-17','07:55:00',1.19),('11288','2013-03-17','08:00:00',1.3),('11288','2013-03-17','08:05:00',1.43),('11288','2013-03-17','08:10:00',1.62),('11288','2013-03-17','08:15:00',1.79),('11288','2013-03-17','08:20:00',1.99),('11288','2013-03-17','08:25:00',2.53),('11288','2013-03-17','08:30:00',2.4),('11288','2013-03-17','08:35:00',2.06),('11288','2013-03-17','08:40:00',2.18),('11288','2013-03-17','08:45:00',2.56),('11288','2013-03-17','08:50:00',2.48),('11288','2013-03-17','08:55:00',2.35),('11288','2013-03-17','09:00:00',2.33),('11288','2013-03-17','09:05:00',2.67),('11288','2013-03-17','09:10:00',3.07),('11288','2013-03-17','09:15:00',3.21),('11288','2013-03-17','09:20:00',2.72),('11288','2013-03-17','09:25:00',2.32),('11288','2013-03-17','09:30:00',2.61),('11288','2013-03-17','09:35:00',2.81),('11288','2013-03-17','09:40:00',2.79),('11288','2013-03-17','09:45:00',2.89),('11288','2013-03-17','09:50:00',3.2),('11288','2013-03-17','09:55:00',3.4),('11288','2013-03-17','10:00:00',3.74),('11288','2013-03-17','10:05:00',3.13),('11288','2013-03-17','10:10:00',3.13),('11288','2013-03-17','10:15:00',3.37),('11288','2013-03-17','10:20:00',3.45),('11288','2013-03-17','10:25:00',3.57),('11288','2013-03-17','10:30:00',3.47),('11288','2013-03-17','10:35:00',3.36),('11288','2013-03-17','10:40:00',3.19),('11288','2013-03-17','10:45:00',3.34),('11288','2013-03-17','10:50:00',3.15),('11288','2013-03-17','10:55:00',2.99),('11288','2013-03-17','11:00:00',2.84),('11288','2013-03-17','11:05:00',2.44),('11288','2013-03-17','11:10:00',2.42),('11288','2013-03-17','11:15:00',2.74),('11288','2013-03-17','11:20:00',3.11),('11288','2013-03-17','11:25:00',3.12),('11288','2013-03-17','11:30:00',2.85),('11288','2013-03-17','11:35:00',2.81),('11288','2013-03-17','11:40:00',2.67),('11288','2013-03-17','11:45:00',2.49),('11288','2013-03-17','11:50:00',2.31),('11288','2013-03-17','11:55:00',2.04),('11288','2013-03-17','12:00:00',1.97),('11288','2013-03-17','12:05:00',2.05),('11288','2013-03-17','12:10:00',2.69),('11288','2013-03-17','12:15:00',3.6),('11288','2013-03-17','12:20:00',4.33),('11288','2013-03-17','12:25:00',5.62),('11288','2013-03-17','12:30:00',5.84),('11288','2013-03-17','12:35:00',4.36),('11288','2013-03-17','12:40:00',4.51),('11288','2013-03-17','12:45:00',4.18),('11288','2013-03-17','12:50:00',3.77),('11288','2013-03-17','12:55:00',3.2),('11288','2013-03-17','13:00:00',3.82),('11288','2013-03-17','13:05:00',4.07),('11288','2013-03-17','13:10:00',4.64),('11288','2013-03-17','13:15:00',4.5),('11288','2013-03-17','13:20:00',3.78),('11288','2013-03-17','13:25:00',3.34),('11288','2013-03-17','13:30:00',4.82),('11288','2013-03-17','13:35:00',4.65),('11288','2013-03-17','13:40:00',3.6),('11288','2013-03-17','13:45:00',3.25),('11288','2013-03-17','13:50:00',2.69),('11288','2013-03-17','13:55:00',4.24),('11288','2013-03-17','14:00:00',3.76),('11288','2013-03-17','14:05:00',3.98),('11288','2013-03-17','14:10:00',4.66),('11288','2013-03-17','14:15:00',4.46),('11288','2013-03-17','14:20:00',5.08),('11288','2013-03-17','14:25:00',4.09),('11288','2013-03-17','14:30:00',3.92),('11288','2013-03-17','14:35:00',3.37),('11288','2013-03-17','14:40:00',2.53),('11288','2013-03-17','14:45:00',2.37),('11288','2013-03-17','14:50:00',2.06),('11288','2013-03-17','14:55:00',2.25),('11288','2013-03-17','15:00:00',2.92),('11288','2013-03-17','15:05:00',3.26),('11288','2013-03-17','15:10:00',4.08),('11288','2013-03-17','15:15:00',3.98),('11288','2013-03-17','15:20:00',4.87),('11288','2013-03-17','15:25:00',4.88),('11288','2013-03-17','15:30:00',2.7),('11288','2013-03-17','15:35:00',3.45),('11288','2013-03-17','15:40:00',2.69),('11288','2013-03-17','15:45:00',2.48),('11288','2013-03-17','15:50:00',1.39),('11288','2013-03-17','15:55:00',1.34),('11288','2013-03-17','16:00:00',1.08),('11288','2013-03-17','16:15:00',1.1),('11288','2013-03-17','16:20:00',1.12),('11288','2013-03-17','16:40:00',1.5),('11288','2013-03-17','16:45:00',1.88),('11288','2013-03-16','07:45:00',1.14),('11288','2013-03-16','07:50:00',1.43),('11288','2013-03-16','07:55:00',1.46),('11288','2013-03-16','08:00:00',1.3),('11288','2013-03-16','08:05:00',1.41),('11288','2013-03-16','08:10:00',2.41),('11288','2013-03-16','08:15:00',2.63),('11288','2013-03-16','08:20:00',2.7),('11288','2013-03-16','08:25:00',2.94),('11288','2013-03-16','08:30:00',3.04),('11288','2013-03-16','08:35:00',3.19),('11288','2013-03-16','08:40:00',3.28),('11288','2013-03-16','08:45:00',3.55),('11288','2013-03-16','08:50:00',3.83),('11288','2013-03-16','08:55:00',4.16),('11288','2013-03-16','09:00:00',4.32),('11288','2013-03-16','09:05:00',3.76),('11288','2013-03-16','09:10:00',3.91),('11288','2013-03-16','09:15:00',4.66),('11288','2013-03-16','09:20:00',4.18),('11288','2013-03-16','09:25:00',2.99),('11288','2013-03-16','09:30:00',4.42),('11288','2013-03-16','09:35:00',5.24),('11288','2013-03-16','09:40:00',4.62),('11288','2013-03-16','09:45:00',5.11),('11288','2013-03-16','09:50:00',5.47),('11288','2013-03-16','09:55:00',5.73),('11288','2013-03-16','10:00:00',4.97),('11288','2013-03-16','10:05:00',4.8),('11288','2013-03-16','10:10:00',5.75),('11288','2013-03-16','10:15:00',4.79),('11288','2013-03-16','10:20:00',3.93),('11288','2013-03-16','10:25:00',3.96),('11288','2013-03-16','10:30:00',3.53),('11288','2013-03-16','10:35:00',5.7),('11288','2013-03-16','10:40:00',6.38),('11288','2013-03-16','10:45:00',6.34),('11288','2013-03-16','10:50:00',6.4),('11288','2013-03-16','10:55:00',6.4),('11288','2013-03-16','11:00:00',6.48),('11288','2013-03-16','11:05:00',6.51),('11288','2013-03-16','11:10:00',6.56),('11288','2013-03-16','11:15:00',6.61),('11288','2013-03-16','11:20:00',6.71),('11288','2013-03-16','11:25:00',6.72),('11288','2013-03-16','11:30:00',6.8),('11288','2013-03-16','11:35:00',6.79),('11288','2013-03-16','11:40:00',6.77),('11288','2013-03-16','11:45:00',6.8),('11288','2013-03-16','11:50:00',6.83),('11288','2013-03-16','11:55:00',6.85),('11288','2013-03-16','12:00:00',6.85),('11288','2013-03-16','12:05:00',6.83),('11288','2013-03-16','12:10:00',6.76),('11288','2013-03-16','12:15:00',6.82),('11288','2013-03-16','12:20:00',6.8),('11288','2013-03-16','12:25:00',6.81),('11288','2013-03-16','12:30:00',6.84),('11288','2013-03-16','12:35:00',6.83),('11288','2013-03-16','12:40:00',6.76),('11288','2013-03-16','12:45:00',6.77),('11288','2013-03-16','12:50:00',6.76),('11288','2013-03-16','12:55:00',6.7),('11288','2013-03-16','13:00:00',6.64),('11288','2013-03-16','13:05:00',6.6),('11288','2013-03-16','13:10:00',6.54),('11288','2013-03-16','13:15:00',6.48),('11288','2013-03-16','13:20:00',6.65),('11288','2013-03-16','13:25:00',4.88),('11288','2013-03-16','13:30:00',1.64),('11288','2013-03-16','13:35:00',1.38),('11288','2013-03-16','13:40:00',2.78),('11288','2013-03-16','13:45:00',2.45),('11288','2013-03-16','13:50:00',4.26),('11288','2013-03-16','13:55:00',5.04),('11288','2013-03-16','14:00:00',6.49),('11288','2013-03-16','14:05:00',5.59),('11288','2013-03-16','14:10:00',1.88),('11288','2013-03-16','14:15:00',5.37),('11288','2013-03-16','14:20:00',3.23),('11288','2013-03-16','14:25:00',3),('11288','2013-03-16','14:30:00',6.15),('11288','2013-03-16','14:35:00',5.45),('11288','2013-03-16','14:40:00',5.84),('11288','2013-03-16','14:45:00',3.53),('11288','2013-03-16','14:50:00',1.53),('11288','2013-03-16','14:55:00',1.74),('11288','2013-03-16','15:00:00',1.12),('11288','2013-03-16','15:05:00',1.59),('11288','2013-03-16','15:20:00',1.02),('11288','2013-03-16','15:25:00',1.02),('11288','2013-03-16','15:35:00',1.2),('11288','2013-03-16','15:40:00',1.41),('11288','2013-03-16','15:45:00',1.45),('11288','2013-03-16','16:00:00',2.41),('11288','2013-03-16','16:05:00',2.76),('11288','2013-03-16','16:10:00',2.89),('11288','2013-03-16','16:15:00',2.99),('11288','2013-03-16','16:20:00',1.95),('11288','2013-03-16','16:25:00',1.19),('11288','2013-03-16','16:30:00',1.22),('11288','2013-03-16','16:35:00',1.61),('11288','2013-03-16','16:40:00',1.13),('11288','2013-03-16','16:45:00',1.17),('11288','2013-03-16','16:50:00',1.13),('11288','2013-03-16','16:55:00',1.65),('11288','2013-03-16','17:00:00',1.54),('11288','2013-03-16','17:05:00',1.42),('11288','2013-03-16','17:10:00',1.24),('11288','2013-03-16','17:15:00',1.16),('11288','2013-03-16','17:20:00',1.04),('11288','2013-03-15','10:00:00',1.19),('11288','2013-03-15','10:05:00',1.16),('11288','2013-03-15','10:10:00',1.14),('11288','2013-03-15','10:15:00',1.27),('11288','2013-03-15','10:20:00',1.18),('11288','2013-03-15','10:25:00',1.31),('11288','2013-03-15','10:30:00',1.76),('11288','2013-03-15','10:35:00',1.99),('11288','2013-03-15','10:40:00',2.21),('11288','2013-03-15','10:45:00',2.57),('11288','2013-03-15','10:50:00',2.6),('11288','2013-03-15','10:55:00',2.81),('11288','2013-03-15','11:00:00',2.78),('11288','2013-03-15','11:05:00',2.37),('11288','2013-03-15','11:10:00',2.4),('11288','2013-03-15','11:15:00',2.01),('11288','2013-03-15','11:20:00',2.4),('11288','2013-03-15','11:25:00',2.92),('11288','2013-03-15','11:30:00',3.22),('11288','2013-03-15','11:35:00',4.07),('11288','2013-03-15','11:40:00',4.16),('11288','2013-03-15','11:45:00',4.16),('11288','2013-03-15','11:50:00',3.67),('11288','2013-03-15','11:55:00',3.86),('11288','2013-03-15','12:00:00',3.51),('11288','2013-03-15','12:05:00',3.32),('11288','2013-03-15','12:10:00',3.59),('11288','2013-03-15','12:15:00',3.19),('11288','2013-03-15','12:20:00',3.12),('11288','2013-03-15','12:25:00',3.34),('11288','2013-03-15','12:30:00',3.51),('11288','2013-03-15','12:35:00',3.96),('11288','2013-03-15','12:40:00',3.34),('11288','2013-03-15','12:45:00',2.76),('11288','2013-03-15','12:50:00',2.6),('11288','2013-03-15','12:55:00',2.52),('11288','2013-03-15','13:00:00',2.33),('11288','2013-03-15','13:05:00',2.19),('11288','2013-03-15','13:10:00',2.29),('11288','2013-03-15','13:15:00',2.51),('11288','2013-03-15','13:20:00',2.7),('11288','2013-03-15','13:25:00',2.99),('11288','2013-03-15','13:30:00',2.85),('11288','2013-03-15','13:35:00',2.67),('11288','2013-03-15','13:40:00',2.77),('11288','2013-03-15','13:45:00',2.97),('11288','2013-03-15','13:50:00',2.42),('11288','2013-03-15','13:55:00',2.05),('11288','2013-03-15','14:00:00',1.86),('11288','2013-03-15','14:05:00',1.62),('11288','2013-03-15','14:10:00',1.4),('11288','2013-03-15','14:15:00',1.27),('11288','2013-03-15','14:20:00',1.16),('11288','2013-03-15','14:25:00',1.02),('11288','2013-03-15','14:40:00',1.06),('11288','2013-03-15','14:45:00',1.39),('11288','2013-03-15','14:50:00',1.91),('11288','2013-03-15','14:55:00',2.19),('11288','2013-03-15','15:00:00',2.35),('11288','2013-03-15','15:05:00',2.19),('11288','2013-03-15','15:10:00',2.19),('11288','2013-03-15','15:15:00',2.34),('11288','2013-03-15','15:20:00',2.46),('11288','2013-03-15','15:25:00',2.65),('11288','2013-03-15','15:30:00',2.26),('11288','2013-03-15','15:35:00',1.92),('11288','2013-03-15','15:40:00',1.62),('11288','2013-03-15','15:45:00',1.67),('11288','2013-03-15','15:50:00',1.61),('11288','2013-03-15','15:55:00',1.54),('11288','2013-03-15','16:00:00',1.7),('11288','2013-03-15','16:05:00',1.42),('11288','2013-03-15','16:10:00',1.28),('11288','2013-03-15','16:15:00',1.34),('11288','2013-03-15','16:20:00',1.08),('11288','2013-03-15','17:15:00',1.06),('11288','2013-03-14','08:20:00',1.23),('11288','2013-03-14','08:25:00',1.35),('11288','2013-03-14','08:30:00',1.1),('11288','2013-03-14','10:15:00',1.08),('11288','2013-03-14','11:20:00',1.05),('11288','2013-03-14','11:25:00',1.21),('11288','2013-03-14','11:30:00',1.46),('11288','2013-03-14','11:35:00',1.29),('11288','2013-03-14','11:40:00',1.24),('11288','2013-03-14','11:45:00',1.44),('11288','2013-03-14','11:50:00',1.47),('11288','2013-03-14','11:55:00',1.44),('11288','2013-03-14','12:00:00',1.29),('11288','2013-03-14','12:05:00',1.17),('11288','2013-03-14','12:10:00',1.11),('11288','2013-03-14','12:15:00',1.13),('11288','2013-03-14','12:20:00',1.19),('11288','2013-03-14','12:25:00',1.29),('11288','2013-03-14','12:30:00',1.34),('11288','2013-03-14','12:35:00',1.37),('11288','2013-03-14','12:40:00',1.47),('11288','2013-03-14','12:45:00',1.66),('11288','2013-03-14','12:50:00',1.8),('11288','2013-03-14','12:55:00',1.93),('11288','2013-03-14','13:00:00',1.74),('11288','2013-03-14','13:05:00',2),('11288','2013-03-14','13:10:00',2.09),('11288','2013-03-14','13:15:00',2.13),('11288','2013-03-14','13:20:00',2.14),('11288','2013-03-14','13:25:00',2.02),('11288','2013-03-14','13:30:00',2.16),('11288','2013-03-14','13:35:00',2.44),('11288','2013-03-14','13:40:00',2.38),('11288','2013-03-14','13:45:00',2.22),('11288','2013-03-14','13:50:00',2.45),('11288','2013-03-14','13:55:00',2.92),('11288','2013-03-14','14:00:00',2.72),('11288','2013-03-14','14:05:00',3.06),('11288','2013-03-14','14:10:00',2.72),('11288','2013-03-14','14:15:00',2.29),('11288','2013-03-14','14:20:00',2.24),('11288','2013-03-14','14:25:00',2.26),('11288','2013-03-14','14:30:00',1.86),('11288','2013-03-14','14:35:00',1.36),('11288','2013-03-14','14:40:00',1.01),('11288','2013-03-14','14:55:00',1.02),('11288','2013-03-14','15:00:00',1.06),('11288','2013-03-14','15:05:00',1.53),('11288','2013-03-14','15:10:00',2.34),('11288','2013-03-14','15:15:00',2.32),('11288','2013-03-14','15:20:00',2.22),('11288','2013-03-14','15:25:00',2.36),('11288','2013-03-14','15:30:00',2.35),('11288','2013-03-14','15:35:00',1.85),('11288','2013-03-14','15:40:00',1.32),('11288','2013-03-14','15:45:00',1.04),('11288','2013-03-14','16:30:00',1.08),('11288','2013-03-13','07:20:00',1.19),('11288','2013-03-13','08:05:00',1.1),('11288','2013-03-13','08:10:00',1.22),('11288','2013-03-13','08:25:00',1.24),('11288','2013-03-13','08:40:00',1.34),('11288','2013-03-13','08:45:00',1.56),('11288','2013-03-13','08:50:00',2.2),('11288','2013-03-13','08:55:00',1.97),('11288','2013-03-13','09:00:00',1.41),('11288','2013-03-13','09:05:00',1.6),('11288','2013-03-13','09:10:00',2.09),('11288','2013-03-13','09:15:00',1.61),('11288','2013-03-13','09:20:00',1.79),('11288','2013-03-13','09:25:00',1.65),('11288','2013-03-13','09:30:00',1.67),('11288','2013-03-13','09:35:00',1.38),('11288','2013-03-13','09:40:00',1.82),('11288','2013-03-13','09:45:00',1.83),('11288','2013-03-13','09:50:00',1.41),('11288','2013-03-13','10:00:00',1.46),('11288','2013-03-13','10:05:00',1.95),('11288','2013-03-13','10:10:00',2.44),('11288','2013-03-13','10:15:00',3.86),('11288','2013-03-13','10:20:00',2.88),('11288','2013-03-13','10:25:00',4.34),('11288','2013-03-13','10:30:00',5.31),('11288','2013-03-13','10:35:00',5.39),('11288','2013-03-13','10:40:00',3.85),('11288','2013-03-13','10:45:00',2.68),('11288','2013-03-13','10:50:00',2.16),('11288','2013-03-13','10:55:00',1.88),('11288','2013-03-13','11:00:00',1.92),('11288','2013-03-13','11:05:00',1.79),('11288','2013-03-13','11:10:00',2.3),('11288','2013-03-13','11:15:00',2.05),('11288','2013-03-13','11:20:00',1.61),('11288','2013-03-13','11:25:00',1.6),('11288','2013-03-13','11:30:00',2.37),('11288','2013-03-13','11:35:00',2.38),('11288','2013-03-13','11:40:00',2.36),('11288','2013-03-13','11:45:00',2.65),('11288','2013-03-13','11:50:00',2.35),('11288','2013-03-13','11:55:00',1.71),('11288','2013-03-13','12:25:00',1.08),('11288','2013-03-13','12:30:00',1.46),('11288','2013-03-13','12:35:00',1.62),('11288','2013-03-13','12:40:00',1.76),('11288','2013-03-13','12:45:00',2.12),('11288','2013-03-13','12:50:00',2.48),('11288','2013-03-13','12:55:00',2.27),('11288','2013-03-13','13:00:00',2.2),('11288','2013-03-13','13:05:00',2.1),('11288','2013-03-13','13:10:00',1.9),('11288','2013-03-13','13:15:00',1.64),('11288','2013-03-13','13:20:00',1.39),('11288','2013-03-13','13:25:00',1.33),('11288','2013-03-13','13:30:00',1.55),('11288','2013-03-13','13:35:00',1.97),('11288','2013-03-13','13:40:00',1.68),('11288','2013-03-13','13:45:00',1.56),('11288','2013-03-13','13:50:00',1.26),('11288','2013-03-13','13:55:00',1.2),('11288','2013-03-13','14:00:00',1.04),('11288','2013-03-13','14:05:00',1.05),('11288','2013-03-13','14:30:00',1.08),('11288','2013-03-13','14:35:00',1.12),('11288','2013-03-13','14:40:00',1.05),('11288','2013-03-13','14:45:00',1.3),('11288','2013-03-13','14:50:00',1.52),('11288','2013-03-13','14:55:00',1.32),('11288','2013-03-13','15:00:00',1.44),('11288','2013-03-13','15:05:00',1.58),('11288','2013-03-13','15:10:00',1.6),('11288','2013-03-13','15:15:00',1.14),('11288','2014-03-25','07:10:00',1.13),('11288','2014-03-25','07:15:00',1.35),('11288','2014-03-25','07:20:00',1.45),('11288','2014-03-25','07:25:00',1.79),('11288','2014-03-25','07:30:00',1.89),('11288','2014-03-25','07:35:00',1.64),('11288','2014-03-25','07:40:00',1.66),('11288','2014-03-25','07:45:00',1.85),('11288','2014-03-25','07:50:00',2.01),('11288','2014-03-25','07:55:00',2.05),('11288','2014-03-25','08:00:00',2.02),('11288','2014-03-25','08:05:00',2.09),('11288','2014-03-25','08:10:00',2.23),('11288','2014-03-25','08:15:00',2.34),('11288','2014-03-25','08:20:00',2.21),('11288','2014-03-25','08:25:00',2.05),('11288','2014-03-25','08:30:00',1.88),('11288','2014-03-25','08:35:00',1.94),('11288','2014-03-25','08:40:00',2.31),('11288','2014-03-25','08:45:00',2.86),('11288','2014-03-25','08:50:00',3.01),('11288','2014-03-25','08:55:00',3.16),('11288','2014-03-25','09:00:00',3.02),('11288','2014-03-25','09:05:00',3),('11288','2014-03-25','09:10:00',2.96),('11288','2014-03-25','09:15:00',3.81),('11288','2014-03-25','09:20:00',4.15),('11288','2014-03-25','09:25:00',3.6),('11288','2014-03-25','09:30:00',3.32),('11288','2014-03-25','09:35:00',3.12),('11288','2014-03-25','09:40:00',3.13),('11288','2014-03-25','09:45:00',2.95),('11288','2014-03-25','09:50:00',3.05),('11288','2014-03-25','09:55:00',3.37),('11288','2014-03-25','10:00:00',3.81),('11288','2014-03-25','10:05:00',4.1),('11288','2014-03-25','10:10:00',4.28),('11288','2014-03-25','10:15:00',4.6),('11288','2014-03-25','10:20:00',4.53),('11288','2014-03-25','10:25:00',4.4),('11288','2014-03-25','10:30:00',4.79),('11288','2014-03-25','10:35:00',4.03),('11288','2014-03-25','10:40:00',3.48),('11288','2014-03-25','10:45:00',3.3),('11288','2014-03-25','10:50:00',3.23),('11288','2014-03-25','10:55:00',3.24),('11288','2014-03-25','11:00:00',3.49),('11288','2014-03-25','11:05:00',3.9),('11288','2014-03-25','11:10:00',4.28),('11288','2014-03-25','11:15:00',4.82),('11288','2014-03-25','11:20:00',4.67),('11288','2014-03-25','11:25:00',4.17),('11288','2014-03-25','11:30:00',4.69),('11288','2014-03-25','11:35:00',3.99),('11288','2014-03-25','11:40:00',4.5),('11288','2014-03-25','11:45:00',3.17),('11288','2014-03-25','11:50:00',3.96),('11288','2014-03-25','11:55:00',2.83),('11288','2014-03-25','12:00:00',1.97),('11288','2014-03-25','12:05:00',1.36),('11288','2014-03-25','12:10:00',1.36),('11288','2014-03-25','12:15:00',1.68),('11288','2014-03-25','12:20:00',2.11),('11288','2014-03-25','12:25:00',2.18),('11288','2014-03-25','12:30:00',1.68),('11288','2014-03-25','12:35:00',1.52),('11288','2014-03-25','12:40:00',1.62),('11288','2014-03-25','12:45:00',1.34),('11288','2014-03-25','13:30:00',1.26),('11288','2014-03-25','13:35:00',1.63),('11288','2014-03-25','13:40:00',1.6),('11288','2014-03-25','13:45:00',1.41),('11288','2014-03-25','13:50:00',1.41),('11288','2014-03-25','13:55:00',1.38),('11288','2014-03-25','14:00:00',1.38),('11288','2014-03-25','14:05:00',1.47),('11288','2014-03-25','14:10:00',1.57),('11288','2014-03-25','14:15:00',1.61),('11288','2014-03-25','14:20:00',1.2),('11288','2014-03-25','14:30:00',1.05),('11288','2014-03-25','14:35:00',1.22),('11288','2014-03-25','14:40:00',1.24),('11288','2014-03-25','14:45:00',1.23),('11288','2014-03-25','14:50:00',1),('11288','2014-03-25','15:15:00',1.2),('11288','2014-03-25','15:20:00',1.15),('11288','2013-03-12','08:15:00',1.04),('11288','2013-03-12','08:20:00',1.85),('11288','2013-03-12','08:25:00',2.36),('11288','2013-03-12','08:30:00',2.75),('11288','2013-03-12','08:35:00',2.51),('11288','2013-03-12','08:40:00',2.87),('11288','2013-03-12','08:45:00',3.29),('11288','2013-03-12','08:50:00',1.73),('11288','2013-03-12','09:00:00',2.74),('11288','2013-03-12','09:05:00',3.84),('11288','2013-03-12','09:10:00',3.95),('11288','2013-03-12','09:15:00',4.05),('11288','2013-03-12','09:20:00',4.15),('11288','2013-03-12','09:25:00',4.31),('11288','2013-03-12','09:30:00',4.27),('11288','2013-03-12','09:35:00',4.53),('11288','2013-03-12','09:40:00',4.14),('11288','2013-03-12','09:45:00',3.14),('11288','2013-03-12','09:50:00',4.56),('11288','2013-03-12','09:55:00',5.2),('11288','2013-03-12','10:00:00',3.4),('11288','2013-03-12','10:05:00',5.32),('11288','2013-03-12','10:10:00',5.49),('11288','2013-03-12','10:15:00',3.8),('11288','2013-03-12','10:20:00',2.87),('11288','2013-03-12','10:25:00',4.83),('11288','2013-03-12','10:30:00',1.95),('11288','2013-03-12','10:35:00',3.22),('11288','2013-03-12','10:40:00',4.44),('11288','2013-03-12','10:45:00',2.42),('11288','2013-03-12','10:50:00',5.86),('11288','2013-03-12','10:55:00',6.25),('11288','2013-03-12','11:00:00',6.57),('11288','2013-03-12','11:05:00',4.95),('11288','2013-03-12','11:10:00',6.74),('11288','2013-03-12','11:15:00',5.94),('11288','2013-03-12','11:20:00',5.86),('11288','2013-03-12','11:25:00',2.63),('11288','2013-03-12','11:30:00',2.85),('11288','2013-03-12','11:35:00',3.8),('11288','2013-03-12','11:40:00',3.68),('11288','2013-03-12','11:45:00',4.1),('11288','2013-03-12','11:50:00',4.28),('11288','2013-03-12','11:55:00',3.82),('11288','2013-03-12','12:00:00',1.55),('11288','2013-03-12','12:05:00',1.95),('11288','2013-03-12','12:10:00',7.23),('11288','2013-03-12','12:15:00',3.49),('11288','2013-03-12','12:20:00',3.88),('11288','2013-03-12','12:25:00',4.87),('11288','2013-03-12','12:30:00',7.64),('11288','2013-03-12','12:35:00',4.87),('11288','2013-03-12','12:40:00',5.33),('11288','2013-03-12','12:45:00',2.47),('11288','2013-03-12','12:50:00',3.02),('11288','2013-03-12','12:55:00',4.72),('11288','2013-03-12','13:00:00',6.55),('11288','2013-03-12','13:05:00',4.26),('11288','2013-03-12','13:10:00',4.05),('11288','2013-03-12','13:15:00',3.22),('11288','2013-03-12','13:20:00',5.11),('11288','2013-03-12','13:25:00',3.13),('11288','2013-03-12','13:30:00',2.69),('11288','2013-03-12','13:35:00',3.14),('11288','2013-03-12','13:40:00',2.6),('11288','2013-03-12','13:45:00',2.15),('11288','2013-03-12','13:50:00',2.2),('11288','2013-03-12','13:55:00',2.83),('11288','2013-03-12','14:00:00',4.7),('11288','2013-03-12','14:05:00',4.43),('11288','2013-03-12','14:10:00',2.73),('11288','2013-03-12','14:15:00',2.16),('11288','2013-03-12','14:20:00',1.64),('11288','2013-03-12','14:30:00',1.02),('11288','2013-03-12','14:35:00',1.22),('11288','2013-03-12','15:00:00',1.79),('11288','2013-03-12','15:05:00',1.11),('11288','2013-03-12','15:10:00',1.63),('11288','2013-03-12','15:15:00',1.64),('11288','2013-03-12','15:20:00',1.83),('11288','2013-03-12','15:25:00',1.71),('11288','2013-03-12','15:30:00',1.1),('11288','2013-03-12','15:35:00',1.05),('11288','2013-03-11','07:35:00',1.14),('11288','2013-03-11','07:40:00',1.54),('11288','2013-03-11','08:10:00',1.82),('11288','2013-03-11','08:15:00',1.85),('11288','2013-03-11','08:20:00',1.96),('11288','2013-03-11','08:25:00',2.29),('11288','2013-03-11','08:30:00',2.49),('11288','2013-03-11','08:35:00',2.65),('11288','2013-03-11','08:40:00',2.81),('11288','2013-03-11','08:45:00',2.87),('11288','2013-03-11','08:50:00',2.97),('11288','2013-03-11','08:55:00',3.28),('11288','2013-03-11','09:00:00',3.46),('11288','2013-03-11','09:05:00',3.58),('11288','2013-03-11','09:10:00',3.73),('11288','2013-03-11','09:15:00',3.9),('11288','2013-03-11','09:20:00',3.43),('11288','2013-03-11','09:25:00',1.46),('11288','2013-03-11','09:30:00',2.34),('11288','2013-03-11','09:35:00',5.16),('11288','2013-03-11','09:40:00',4.13),('11288','2013-03-11','09:45:00',2.95),('11288','2013-03-11','09:50:00',1.53),('11288','2013-03-11','09:55:00',1.47),('11288','2013-03-11','10:00:00',1.49),('11288','2013-03-11','10:05:00',1.74),('11288','2013-03-11','10:10:00',2.01),('11288','2013-03-11','10:15:00',2.08),('11288','2013-03-11','10:20:00',2.35),('11288','2013-03-11','10:25:00',2.52),('11288','2013-03-11','10:30:00',2.4),('11288','2013-03-11','10:35:00',2.87),('11288','2013-03-11','10:40:00',3.64),('11288','2013-03-11','10:45:00',4.2),('11288','2013-03-11','10:50:00',4.85),('11288','2013-03-11','10:55:00',3.37),('11288','2013-03-11','11:00:00',2.81),('11288','2013-03-11','11:05:00',2.35),('11288','2013-03-11','11:10:00',2.5),('11288','2013-03-11','11:15:00',2.53),('11288','2013-03-11','11:20:00',2.23),('11288','2013-03-11','11:25:00',2.22),('11288','2013-03-11','11:30:00',3.87),('11288','2013-03-11','11:35:00',3.83),('11288','2013-03-11','11:40:00',3.38),('11288','2013-03-11','11:45:00',4.15),('11288','2013-03-11','11:50:00',4),('11288','2013-03-11','11:55:00',3.47),('11288','2013-03-11','12:00:00',3.18),('11288','2013-03-11','12:05:00',3.46),('11288','2013-03-11','12:10:00',3.19),('11288','2013-03-11','12:15:00',1.37),('11288','2013-03-11','12:20:00',1.39),('11288','2013-03-11','12:25:00',1.73),('11288','2013-03-11','12:30:00',1.89),('11288','2013-03-11','12:35:00',2.61),('11288','2013-03-11','12:40:00',2.08),('11288','2013-03-11','12:45:00',2.41),('11288','2013-03-11','12:50:00',3.92),('11288','2013-03-11','12:55:00',4.67),('11288','2013-03-11','13:00:00',2.95),('11288','2013-03-11','13:05:00',3.21),('11288','2013-03-11','13:10:00',5.78),('11288','2013-03-11','13:15:00',5.47),('11288','2013-03-11','13:20:00',6.89),('11288','2013-03-11','13:25:00',5.74),('11288','2013-03-11','13:30:00',5.83),('11288','2013-03-11','13:35:00',6.43),('11288','2013-03-11','13:40:00',4.63),('11288','2013-03-11','13:45:00',6.31),('11288','2013-03-11','13:50:00',6.11),('11288','2013-03-11','13:55:00',2.27),('11288','2013-03-11','14:00:00',1.64),('11288','2013-03-11','14:05:00',1.4),('11288','2013-03-11','14:10:00',1.35),('11288','2013-03-11','14:15:00',1.17),('11288','2013-03-11','14:20:00',2.23),('11288','2013-03-11','14:25:00',3.21),('11288','2013-03-11','14:30:00',2.22),('11288','2013-03-11','14:35:00',2.21),('11288','2013-03-11','14:40:00',2.7),('11288','2013-03-11','14:45:00',1.44),('11288','2013-03-11','14:50:00',1.13),('11288','2013-03-11','15:15:00',1.05),('11288','2013-03-11','15:20:00',1.17),('11288','2013-03-11','15:25:00',1.86),('11288','2013-03-11','15:30:00',3.61),('11288','2013-03-11','15:35:00',1.92),('11288','2013-03-11','15:40:00',3.25),('11288','2013-03-11','15:45:00',3.88),('11288','2013-03-11','15:50:00',2.9),('11288','2013-03-11','15:55:00',2.6),('11288','2013-03-11','16:00:00',2.39),('11288','2013-03-11','16:05:00',1.82),('11288','2013-03-11','16:10:00',2.1),('11288','2013-03-11','16:15:00',1.91),('11288','2013-03-11','16:20:00',2.14),('11288','2013-03-11','16:25:00',1.9),('11288','2013-03-11','16:30:00',2.01),('11288','2013-03-11','16:35:00',1.51),('11288','2013-03-11','16:40:00',1.83),('11288','2013-03-11','16:45:00',1.86),('11288','2013-03-11','16:50:00',1.14),('11288','2013-03-10','07:50:00',1.06),('11288','2013-03-10','07:55:00',1.36),('11288','2013-03-10','08:00:00',1.5),('11288','2013-03-10','08:05:00',1.68),('11288','2013-03-10','08:10:00',1.7),('11288','2013-03-10','08:15:00',1.85),('11288','2013-03-10','08:20:00',2.17),('11288','2013-03-10','08:25:00',2.3),('11288','2013-03-10','08:30:00',2.48),('11288','2013-03-10','08:35:00',2.66),('11288','2013-03-10','08:40:00',2.81),('11288','2013-03-10','08:45:00',2.88),('11288','2013-03-10','08:50:00',2.69),('11288','2013-03-10','08:55:00',3.28),('11288','2013-03-10','09:00:00',3.4),('11288','2013-03-10','09:05:00',3.55),('11288','2013-03-10','09:10:00',3.7),('11288','2013-03-10','09:15:00',3.81),('11288','2013-03-10','09:20:00',3.89),('11288','2013-03-10','09:25:00',4.04),('11288','2013-03-10','09:30:00',4.19),('11288','2013-03-10','09:35:00',4.29),('11288','2013-03-10','09:40:00',4.59),('11288','2013-03-10','09:45:00',4.67),('11288','2013-03-10','09:50:00',5.08),('11288','2013-03-10','09:55:00',4.93),('11288','2013-03-10','10:00:00',4.5),('11288','2013-03-10','10:05:00',4.17),('11288','2013-03-10','10:10:00',3.26),('11288','2013-03-10','10:15:00',4.4),('11288','2013-03-10','10:20:00',4.4),('11288','2013-03-10','10:25:00',5.7),('11288','2013-03-10','10:30:00',3.49),('11288','2013-03-10','10:35:00',2.22),('11288','2013-03-10','10:40:00',5.69),('11288','2013-03-10','10:45:00',5.74),('11288','2013-03-10','10:50:00',2.47),('11288','2013-03-10','10:55:00',3.4),('11288','2013-03-10','11:00:00',3.4),('11288','2013-03-10','11:05:00',5.33),('11288','2013-03-10','11:10:00',3.18),('11288','2013-03-10','11:15:00',3.91),('11288','2013-03-10','11:20:00',5.4),('11288','2013-03-10','11:25:00',4.5),('11288','2013-03-10','11:30:00',3.62),('11288','2013-03-10','11:35:00',4.38),('11288','2013-03-10','11:40:00',2.26),('11288','2013-03-10','11:45:00',2.39),('11288','2013-03-10','11:50:00',6.92),('11288','2013-03-10','11:55:00',6.5),('11288','2013-03-10','12:00:00',6.57),('11288','2013-03-10','12:05:00',6.25),('11288','2013-03-10','12:10:00',6.05),('11288','2013-03-10','12:15:00',3.6),('11288','2013-03-10','12:20:00',6.95),('11288','2013-03-10','12:25:00',4.6),('11288','2013-03-10','12:30:00',6.56),('11288','2013-03-10','12:35:00',6.56),('11288','2013-03-10','12:40:00',6.09),('11288','2013-03-10','12:45:00',6.46),('11288','2013-03-10','12:50:00',6.78),('11288','2013-03-10','12:55:00',6.25),('11288','2013-03-10','13:00:00',6.09),('11288','2013-03-10','13:05:00',5.99),('11288','2013-03-10','13:10:00',5.67),('11288','2013-03-10','13:15:00',6.06),('11288','2013-03-10','13:20:00',6.04),('11288','2013-03-10','13:25:00',5.83),('11288','2013-03-10','13:30:00',5.61),('11288','2013-03-10','13:35:00',5.71),('11288','2013-03-10','13:40:00',3.72),('11288','2013-03-10','13:45:00',4.02),('11288','2013-03-10','13:50:00',3.31),('11288','2013-03-10','13:55:00',3.08),('11288','2013-03-10','14:00:00',2.61),('11288','2013-03-10','14:05:00',3.64),('11288','2013-03-10','14:10:00',3.54),('11288','2013-03-10','14:15:00',4.76),('11288','2013-03-10','14:20:00',4.27),('11288','2013-03-10','14:25:00',3.09),('11288','2013-03-10','14:30:00',4.39),('11288','2013-03-10','14:35:00',5.32),('11288','2013-03-10','14:40:00',4.51),('11288','2013-03-10','14:45:00',2.84),('11288','2013-03-10','14:50:00',2.92),('11288','2013-03-10','14:55:00',2.48),('11288','2013-03-10','15:00:00',2.09),('11288','2013-03-10','15:05:00',2.48),('11288','2013-03-10','15:10:00',2.35),('11288','2013-03-10','15:15:00',1.57),('11288','2013-03-10','15:20:00',1.61),('11288','2013-03-10','15:25:00',1.01),('11288','2013-03-10','15:30:00',1),('11288','2013-03-10','15:35:00',1.06),('11288','2013-03-10','15:40:00',1.06),('11288','2013-03-10','15:45:00',1.08),('11288','2013-03-10','15:50:00',1.59),('11288','2013-03-10','15:55:00',1.3),('11288','2013-03-09','07:50:00',1.11),('11288','2013-03-09','07:55:00',1.2),('11288','2013-03-09','08:00:00',1.59),('11288','2013-03-09','08:05:00',1.59),('11288','2013-03-09','08:10:00',1.71),('11288','2013-03-09','08:15:00',1.85),('11288','2013-03-09','08:20:00',2.01),('11288','2013-03-09','08:25:00',2.23),('11288','2013-03-09','08:30:00',2.38),('11288','2013-03-09','08:35:00',2.59),('11288','2013-03-09','08:40:00',2.7),('11288','2013-03-09','08:45:00',2.62),('11288','2013-03-09','08:50:00',2.83),('11288','2013-03-09','08:55:00',3.19),('11288','2013-03-09','09:00:00',2.82),('11288','2013-03-09','09:05:00',1.91),('11288','2013-03-09','09:10:00',1.32),('11288','2013-03-09','09:15:00',1.79),('11288','2013-03-09','09:20:00',1.97),('11288','2013-03-09','09:25:00',4.01),('11288','2013-03-09','09:30:00',3.88),('11288','2013-03-09','09:35:00',3.47),('11288','2013-03-09','09:40:00',4.39),('11288','2013-03-09','09:45:00',5.36),('11288','2013-03-09','09:50:00',2.6),('11288','2013-03-09','09:55:00',4.09),('11288','2013-03-09','10:00:00',1.5),('11288','2013-03-09','10:05:00',1.82),('11288','2013-03-09','10:10:00',1.72),('11288','2013-03-09','10:15:00',2.13),('11288','2013-03-09','10:20:00',1.68),('11288','2013-03-09','10:25:00',1.58),('11288','2013-03-09','10:30:00',1.79),('11288','2013-03-09','10:35:00',2.59),('11288','2013-03-09','10:40:00',3.23),('11288','2013-03-09','10:45:00',5.44),('11288','2013-03-09','10:50:00',4.34),('11288','2013-03-09','10:55:00',4.47),('11288','2013-03-09','11:00:00',4.95),('11288','2013-03-09','11:05:00',6.08),('11288','2013-03-09','11:10:00',6.14),('11288','2013-03-09','11:15:00',6.24),('11288','2013-03-09','11:20:00',5.56),('11288','2013-03-09','11:25:00',5.27),('11288','2013-03-09','11:30:00',6.04),('11288','2013-03-09','11:35:00',6.27),('11288','2013-03-09','11:40:00',6.31),('11288','2013-03-09','11:45:00',6.26),('11288','2013-03-09','11:50:00',6.17),('11288','2013-03-09','11:55:00',4.99),('11288','2013-03-09','12:00:00',4.15),('11288','2013-03-09','12:05:00',1.78),('11288','2013-03-09','12:10:00',2.96),('11288','2013-03-09','12:15:00',2.88),('11288','2013-03-09','12:20:00',3.43),('11288','2013-03-09','12:25:00',3.13),('11288','2013-03-09','12:30:00',2.92),('11288','2013-03-09','12:35:00',2.8),('11288','2013-03-09','12:40:00',3.13),('11288','2013-03-09','12:45:00',3.65),('11288','2013-03-09','12:50:00',2.9),('11288','2013-03-09','12:55:00',6.4),('11288','2013-03-09','13:00:00',6.22),('11288','2013-03-09','13:05:00',6.05),('11288','2013-03-09','13:10:00',6.09),('11288','2013-03-09','13:15:00',6.55),('11288','2013-03-09','13:20:00',4.98),('11288','2013-03-09','13:25:00',3.98),('11288','2013-03-09','13:30:00',6.3),('11288','2013-03-09','13:35:00',5.51),('11288','2013-03-09','13:40:00',5.77),('11288','2013-03-09','13:45:00',5.85),('11288','2013-03-09','13:50:00',3.71),('11288','2013-03-09','13:55:00',1.48),('11288','2013-03-09','14:00:00',2.1),('11288','2013-03-09','14:05:00',3.09),('11288','2013-03-09','14:10:00',4.61),('11288','2013-03-09','14:15:00',5.59),('11288','2013-03-09','14:20:00',5.16),('11288','2013-03-09','14:25:00',5.02),('11288','2013-03-09','14:30:00',4.88),('11288','2013-03-09','14:35:00',4.79),('11288','2013-03-09','14:40:00',4.69),('11288','2013-03-09','14:45:00',4.54),('11288','2013-03-09','14:50:00',4.42),('11288','2013-03-09','14:55:00',4.35),('11288','2013-03-09','15:00:00',4.26),('11288','2013-03-09','15:05:00',4.11),('11288','2013-03-09','15:10:00',3.98),('11288','2013-03-09','15:15:00',3.86),('11288','2013-03-09','15:20:00',3.71),('11288','2013-03-09','15:25:00',3.56),('11288','2013-03-09','15:30:00',3.42),('11288','2013-03-09','15:35:00',3.2),('11288','2013-03-09','15:40:00',3.2),('11288','2013-03-09','15:45:00',3.07),('11288','2013-03-09','15:50:00',2.91),('11288','2013-03-09','15:55:00',2.55),('11288','2013-03-09','16:00:00',2.23),('11288','2013-03-09','16:05:00',2.14),('11288','2013-03-09','16:10:00',1.78),('11288','2013-03-09','16:15:00',2.25),('11288','2013-03-09','16:20:00',1.85),('11288','2013-03-09','16:25:00',2.07),('11288','2013-03-09','16:30:00',1.8),('11288','2013-03-09','16:35:00',1.45),('11288','2013-03-09','16:40:00',1.32),('11288','2013-03-09','16:45:00',1.03),('11288','2013-03-09','16:50:00',1.01),('11288','2013-03-08','08:10:00',1.38),('11288','2013-03-08','08:15:00',1.3),('11288','2013-03-08','08:25:00',1.67),('11288','2013-03-08','08:30:00',2.85),('11288','2013-03-08','08:35:00',2.62),('11288','2013-03-08','08:40:00',1.4),('11288','2013-03-08','08:45:00',1.43),('11288','2013-03-08','08:50:00',1.77),('11288','2013-03-08','08:55:00',1.39),('11288','2013-03-08','09:00:00',1.53),('11288','2013-03-08','09:05:00',1.18),('11288','2013-03-08','09:10:00',1.18),('11288','2013-03-08','09:15:00',1.38),('11288','2013-03-08','09:20:00',1.2),('11288','2013-03-08','09:25:00',1.43),('11288','2013-03-08','09:30:00',2.41),('11288','2013-03-08','09:35:00',3.25),('11288','2013-03-08','09:40:00',3.06),('11288','2013-03-08','09:45:00',2.48),('11288','2013-03-08','09:50:00',2.87),('11288','2013-03-08','09:55:00',2.02),('11288','2013-03-08','10:00:00',1.69),('11288','2013-03-08','10:05:00',1.88),('11288','2013-03-08','10:10:00',2.66),('11288','2013-03-08','10:15:00',2.6),('11288','2013-03-08','10:20:00',2.18),('11288','2013-03-08','10:25:00',2.74),('11288','2013-03-08','10:30:00',3.25),('11288','2013-03-08','10:35:00',4.05),('11288','2013-03-08','10:40:00',2.51),('11288','2013-03-08','10:45:00',2.05),('11288','2013-03-08','10:50:00',2.45),('11288','2013-03-08','10:55:00',2.18),('11288','2013-03-08','11:00:00',1.83),('11288','2013-03-08','11:05:00',1.18),('11288','2013-03-08','11:30:00',1.36),('11288','2013-03-08','11:35:00',3.55),('11288','2013-03-08','11:40:00',4.06),('11288','2013-03-08','11:45:00',3.2),('11288','2013-03-08','11:50:00',2.78),('11288','2013-03-08','11:55:00',3.6),('11288','2013-03-08','12:00:00',3.5),('11288','2013-03-08','12:05:00',2.3),('11288','2013-03-08','12:10:00',1.77),('11288','2013-03-08','12:15:00',1.86),('11288','2013-03-08','12:20:00',2.52),('11288','2013-03-08','12:25:00',2.14),('11288','2013-03-08','12:30:00',1.89),('11288','2013-03-08','12:35:00',3.02),('11288','2013-03-08','12:40:00',4.12),('11288','2013-03-08','12:45:00',3.53),('11288','2013-03-08','12:50:00',4.48),('11288','2013-03-08','12:55:00',4.12),('11288','2013-03-08','13:00:00',3.87),('11288','2013-03-08','13:05:00',4.06),('11288','2013-03-08','13:10:00',2.54),('11288','2013-03-08','13:15:00',2.09),('11288','2013-03-08','13:20:00',2.12),('11288','2013-03-08','13:25:00',2.71),('11288','2013-03-08','13:30:00',3.75),('11288','2013-03-08','13:35:00',2.75),('11288','2013-03-08','13:40:00',2.27),('11288','2013-03-08','13:45:00',1.28),('11288','2013-03-08','13:50:00',1.34),('11288','2013-03-08','13:55:00',1.66),('11288','2013-03-08','14:00:00',1.11),('11288','2013-03-08','16:55:00',1.16),('11288','2013-03-08','17:00:00',1.02),('11288','2013-03-08','17:05:00',1.27),('11288','2013-03-08','17:10:00',2.08),('11288','2013-03-08','17:15:00',1.28),('11288','2013-03-07','08:35:00',1.36),('11288','2013-03-07','08:40:00',1.9),('11288','2013-03-07','08:45:00',1.83),('11288','2013-03-07','08:50:00',2.01),('11288','2013-03-07','08:55:00',1.62),('11288','2013-03-07','09:00:00',1.57),('11288','2013-03-07','09:05:00',1.6),('11288','2013-03-07','09:10:00',1.06),('11288','2013-03-07','09:15:00',1.56),('11288','2013-03-07','09:20:00',1.48),('11288','2013-03-07','09:55:00',1.2),('11288','2013-03-07','10:25:00',1.39),('11288','2013-03-07','10:30:00',1.56),('11288','2013-03-07','10:50:00',2.29),('11288','2013-03-07','10:55:00',2.13),('11288','2013-03-07','11:00:00',2.21),('11288','2013-03-07','11:05:00',2.55),('11288','2013-03-07','11:10:00',1.84),('11288','2013-03-07','11:15:00',1.29),('11288','2013-03-07','11:20:00',1.08),('11288','2013-03-07','11:25:00',1.66),('11288','2013-03-07','11:30:00',3.61),('11288','2013-03-07','11:35:00',4.16),('11288','2013-03-07','11:40:00',3.96),('11288','2013-03-07','11:45:00',4.34),('11288','2013-03-07','11:50:00',3.8),('11288','2013-03-07','11:55:00',3.03),('11288','2013-03-07','12:00:00',2.17),('11288','2013-03-07','12:05:00',1.86),('11288','2013-03-07','12:25:00',2.21),('11288','2013-03-07','12:30:00',1.58),('11288','2013-03-07','12:35:00',1.3),('11288','2013-03-07','12:40:00',2.46),('11288','2013-03-07','12:45:00',3.47),('11288','2013-03-07','12:50:00',3.05),('11288','2013-03-07','12:55:00',2.75),('11288','2013-03-07','13:00:00',3.28),('11288','2013-03-07','13:05:00',3.24),('11288','2013-03-07','13:10:00',3.01),('11288','2013-03-07','13:15:00',3.39),('11288','2013-03-07','13:20:00',3.81),('11288','2013-03-07','13:25:00',3.39),('11288','2013-03-07','13:30:00',2.92),('11288','2013-03-07','13:35:00',2.67),('11288','2013-03-07','13:40:00',1.36),('11288','2013-03-07','13:55:00',1.42),('11288','2013-03-07','14:00:00',1.39),('11288','2013-03-07','14:05:00',1.75),('11288','2013-03-07','14:10:00',1.86),('11288','2013-03-07','14:15:00',1.37),('11288','2013-03-07','14:20:00',1.52),('11288','2013-03-07','14:25:00',1.48),('11288','2013-03-07','14:45:00',1.48),('11288','2013-03-07','15:20:00',1.38),('11288','2013-03-07','15:25:00',1.54),('11288','2013-03-07','15:30:00',1.36),('11288','2013-03-07','15:35:00',1.61),('11288','2013-03-07','15:40:00',1.58),('11288','2013-03-07','15:45:00',1.13),('11288','2013-03-07','16:05:00',1.26),('11288','2013-03-07','16:10:00',1.19),('11288','2013-03-07','16:15:00',1.13),('11288','2013-03-07','16:20:00',1.17),('11288','2013-03-07','16:25:00',1.02),('11288','2013-03-07','16:35:00',1.11),('11288','2013-03-07','16:40:00',1.59),('11288','2013-03-07','16:45:00',1.1),('11288','2013-03-06','09:10:00',1.07),('11288','2013-03-06','16:00:00',1.04),('11288','2013-03-06','16:05:00',1.05),('11288','2013-03-05','08:05:00',1.18),('11288','2013-03-05','08:10:00',1.39),('11288','2013-03-05','08:15:00',1.81),('11288','2013-03-05','08:20:00',1.32),('11288','2013-03-05','08:25:00',1.99),('11288','2013-03-05','08:30:00',2.71),('11288','2013-03-05','08:35:00',2.47),('11288','2013-03-05','08:40:00',2.55),('11288','2013-03-05','08:45:00',2.26),('11288','2013-03-05','08:50:00',2.54),('11288','2013-03-05','08:55:00',2.54),('11288','2013-03-05','09:00:00',2.62),('11288','2013-03-05','09:05:00',2.81),('11288','2013-03-05','09:10:00',2.62),('11288','2013-03-05','09:15:00',2.58),('11288','2013-03-05','09:20:00',2.65),('11288','2013-03-05','09:25:00',2.62),('11288','2013-03-05','09:30:00',2.75),('11288','2013-03-05','09:35:00',2.93),('11288','2013-03-05','09:40:00',3.09),('11288','2013-03-05','09:45:00',3.13),('11288','2013-03-05','09:50:00',3.07),('11288','2013-03-05','09:55:00',2.97),('11288','2013-03-05','10:00:00',2.81),('11288','2013-03-05','10:05:00',3.06),('11288','2013-03-05','10:10:00',3.15),('11288','2013-03-05','10:15:00',3.31),('11288','2013-03-05','10:20:00',3.59),('11288','2013-03-05','10:25:00',3.22),('11288','2013-03-05','10:30:00',3.21),('11288','2013-03-05','10:35:00',3.63),('11288','2013-03-05','10:40:00',3.65),('11288','2013-03-05','10:45:00',3.89),('11288','2013-03-05','10:50:00',4.28),('11288','2013-03-05','10:55:00',4.28),('11288','2013-03-05','11:00:00',3.98),('11288','2013-03-05','11:05:00',4.35),('11288','2013-03-05','11:10:00',4.47),('11288','2013-03-05','11:15:00',4.45),('11288','2013-03-05','11:20:00',4.4),('11288','2013-03-05','11:25:00',4.3),('11288','2013-03-05','11:30:00',4.42),('11288','2013-03-05','11:35:00',4.85),('11288','2013-03-05','11:40:00',5.2),('11288','2013-03-05','11:45:00',5.01),('11288','2013-03-05','11:50:00',5.01),('11288','2013-03-05','11:55:00',5.13),('11288','2013-03-05','12:00:00',5.2),('11288','2013-03-05','12:05:00',5.29),('11288','2013-03-05','12:10:00',5.56),('11288','2013-03-05','12:15:00',4.44),('11288','2013-03-05','12:20:00',5.16),('11288','2013-03-05','12:25:00',5.03),('11288','2013-03-05','12:30:00',4.26),('11288','2013-03-05','12:35:00',3.92),('11288','2013-03-05','12:40:00',4.07),('11288','2013-03-05','12:45:00',4.37),('11288','2013-03-05','12:50:00',3.85),('11288','2013-03-05','12:55:00',3.48),('11288','2013-03-05','13:00:00',3.01),('11288','2013-03-05','13:05:00',2.93),('11288','2013-03-05','13:10:00',3.15),('11288','2013-03-05','13:15:00',3.31),('11288','2013-03-05','13:20:00',3.16),('11288','2013-03-05','13:25:00',2.87),('11288','2013-03-05','13:30:00',2.64),('11288','2013-03-05','13:35:00',2.53),('11288','2013-03-05','13:40:00',2.39),('11288','2013-03-05','13:45:00',2.18),('11288','2013-03-05','13:50:00',1.99),('11288','2013-03-05','13:55:00',1.9),('11288','2013-03-05','14:00:00',1.9),('11288','2013-03-05','14:05:00',1.95),('11288','2013-03-05','14:10:00',2.02),('11288','2013-03-05','14:15:00',1.87),('11288','2013-03-05','14:20:00',1.77),('11288','2013-03-05','14:25:00',1.79),('11288','2013-03-05','14:30:00',1.73),('11288','2013-03-05','14:35:00',1.76),('11288','2013-03-05','14:40:00',1.82),('11288','2013-03-05','14:45:00',1.86),('11288','2013-03-05','14:50:00',1.81),('11288','2013-03-05','14:55:00',1.64),('11288','2013-03-05','15:00:00',1.48),('11288','2013-03-05','15:05:00',1.38),('11288','2013-03-05','15:10:00',1.13),('11288','2013-03-05','15:20:00',1.15),('11288','2013-03-05','15:25:00',1.34),('11288','2013-03-05','15:30:00',1.57),('11288','2013-03-05','15:35:00',1.61),('11288','2013-03-05','15:40:00',1.73),('11288','2013-03-05','15:45:00',2.07),('11288','2013-03-05','15:50:00',1.99),('11288','2013-03-05','15:55:00',1.67),('11288','2013-03-05','16:00:00',1.52),('11288','2013-03-05','16:05:00',1.32),('11288','2013-03-05','16:10:00',1.08),('11288','2013-03-04','07:50:00',1.04),('11288','2013-03-04','07:55:00',1.08),('11288','2013-03-04','08:00:00',1.28),('11288','2013-03-04','08:05:00',1.36),('11288','2013-03-04','08:10:00',1.51),('11288','2013-03-04','08:15:00',1.66),('11288','2013-03-04','08:20:00',1.81),('11288','2013-03-04','08:25:00',1.93),('11288','2013-03-04','08:30:00',2.16),('11288','2013-03-04','08:35:00',2.3),('11288','2013-03-04','08:40:00',2.27),('11288','2013-03-04','08:45:00',2.5),('11288','2013-03-04','08:50:00',2.71),('11288','2013-03-04','08:55:00',2.88),('11288','2013-03-04','09:00:00',3.07),('11288','2013-03-04','09:05:00',3.22),('11288','2013-03-04','09:10:00',3.39),('11288','2013-03-04','09:15:00',3.49),('11288','2013-03-04','09:20:00',3.64),('11288','2013-03-04','09:25:00',3.7),('11288','2013-03-04','09:30:00',3.72),('11288','2013-03-04','09:35:00',4),('11288','2013-03-04','09:40:00',4.08),('11288','2013-03-04','09:45:00',4.22),('11288','2013-03-04','09:50:00',4.36),('11288','2013-03-04','09:55:00',4.48),('11288','2013-03-04','10:00:00',4.53),('11288','2013-03-04','10:05:00',4.64),('11288','2013-03-04','10:10:00',4.79),('11288','2013-03-04','10:15:00',4.84),('11288','2013-03-04','10:20:00',4.95),('11288','2013-03-04','10:25:00',4.96),('11288','2013-03-04','10:30:00',5),('11288','2013-03-04','10:35:00',5.13),('11288','2013-03-04','10:40:00',5.14),('11288','2013-03-04','10:45:00',5.15),('11288','2013-03-04','10:50:00',5.19),('11288','2013-03-04','10:55:00',5.31),('11288','2013-03-04','11:00:00',5.36),('11288','2013-03-04','11:05:00',5.49),('11288','2013-03-04','11:10:00',5.55),('11288','2013-03-04','11:15:00',5.55),('11288','2013-03-04','11:20:00',5.55),('11288','2013-03-04','11:25:00',5.64),('11288','2013-03-04','11:30:00',5.61),('11288','2013-03-04','11:35:00',5.71),('11288','2013-03-04','11:40:00',5.83),('11288','2013-03-04','11:45:00',5.82),('11288','2013-03-04','11:50:00',5.8),('11288','2013-03-04','11:55:00',5.84),('11288','2013-03-04','12:00:00',5.89),('11288','2013-03-04','12:05:00',5.87),('11288','2013-03-04','12:10:00',5.89),('11288','2013-03-04','12:15:00',5.93),('11288','2013-03-04','12:20:00',5.83),('11288','2013-03-04','12:25:00',5.79),('11288','2013-03-04','12:30:00',5.77),('11288','2013-03-04','12:35:00',5.82),('11288','2013-03-04','12:40:00',5.81),('11288','2013-03-04','12:45:00',5.71),('11288','2013-03-04','12:50:00',5.59),('11288','2013-03-04','12:55:00',5.56),('11288','2013-03-04','13:00:00',5.59),('11288','2013-03-04','13:05:00',5.53),('11288','2013-03-04','13:10:00',5.58),('11288','2013-03-04','13:15:00',5.51),('11288','2013-03-04','13:20:00',5.41),('11288','2013-03-04','13:25:00',5.5),('11288','2013-03-04','13:30:00',5.61),('11288','2013-03-04','13:35:00',5.72),('11288','2013-03-04','13:40:00',5.41),('11288','2013-03-04','13:45:00',5.09),('11288','2013-03-04','13:50:00',5.16),('11288','2013-03-04','13:55:00',5.03),('11288','2013-03-04','14:00:00',4.99),('11288','2013-03-04','14:05:00',4.89),('11288','2013-03-04','14:10:00',4.56),('11288','2013-03-04','14:15:00',4.59),('11288','2013-03-04','14:20:00',4.56),('11288','2013-03-04','14:25:00',4.1),('11288','2013-03-04','14:30:00',4.46),('11288','2013-03-04','14:35:00',4.37),('11288','2013-03-04','14:40:00',4.17),('11288','2013-03-04','14:45:00',3.93),('11288','2013-03-04','14:50:00',3.96),('11288','2013-03-04','14:55:00',3.83),('11288','2013-03-04','15:00:00',3.78),('11288','2013-03-04','15:05:00',3.71),('11288','2013-03-04','15:10:00',3.55),('11288','2013-03-04','15:15:00',3.34),('11288','2013-03-04','15:20:00',3.29),('11288','2013-03-04','15:25:00',3.18),('11288','2013-03-04','15:30:00',3.02),('11288','2013-03-04','15:35:00',2.93),('11288','2013-03-04','15:40:00',2.84),('11288','2013-03-04','15:45:00',2.66),('11288','2013-03-04','15:50:00',2.54),('11288','2013-03-04','15:55:00',2.43),('11288','2013-03-04','16:00:00',2.31),('11288','2013-03-04','16:05:00',2.14),('11288','2013-03-04','16:10:00',1.9),('11288','2013-03-04','16:15:00',1.71),('11288','2013-03-04','16:20:00',1.71),('11288','2013-03-04','16:25:00',1.69),('11288','2013-03-04','16:30:00',1.57),('11288','2013-03-04','16:35:00',1.43),('11288','2013-03-04','16:40:00',1.29),('11288','2013-03-04','16:45:00',1.15),('11288','2013-03-04','16:50:00',1.04),('11288','2013-03-03','07:55:00',1.07),('11288','2013-03-03','08:00:00',1.11),('11288','2013-03-03','08:05:00',1.31),('11288','2013-03-03','08:10:00',1.47),('11288','2013-03-03','08:15:00',1.68),('11288','2013-03-03','08:20:00',1.83),('11288','2013-03-03','08:25:00',1.97),('11288','2013-03-03','08:30:00',2.14),('11288','2013-03-03','08:35:00',2.33),('11288','2013-03-03','08:40:00',2.53),('11288','2013-03-03','08:45:00',2.64),('11288','2013-03-03','08:50:00',2.82),('11288','2013-03-03','08:55:00',2.98),('11288','2013-03-03','09:00:00',3.16),('11288','2013-03-03','09:05:00',3.33),('11288','2013-03-03','09:10:00',3.48),('11288','2013-03-03','09:15:00',3.52),('11288','2013-03-03','09:20:00',3.6),('11288','2013-03-03','09:25:00',3.8),('11288','2013-03-03','09:30:00',3.94),('11288','2013-03-03','09:35:00',4.06),('11288','2013-03-03','09:40:00',4.16),('11288','2013-03-03','09:45:00',4.3),('11288','2013-03-03','09:50:00',4.47),('11288','2013-03-03','09:55:00',4.63),('11288','2013-03-03','10:00:00',4.75),('11288','2013-03-03','10:05:00',4.85),('11288','2013-03-03','10:10:00',4.98),('11288','2013-03-03','10:15:00',5.08),('11288','2013-03-03','10:20:00',5.14),('11288','2013-03-03','10:25:00',5.18),('11288','2013-03-03','10:30:00',5.28),('11288','2013-03-03','10:35:00',5.38),('11288','2013-03-03','10:40:00',5.44),('11288','2013-03-03','10:45:00',5.46),('11288','2013-03-03','10:50:00',5.46),('11288','2013-03-03','10:55:00',5.52),('11288','2013-03-03','11:00:00',5.63),('11288','2013-03-03','11:05:00',5.68),('11288','2013-03-03','11:10:00',5.68),('11288','2013-03-03','11:15:00',5.72),('11288','2013-03-03','11:20:00',5.75),('11288','2013-03-03','11:25:00',5.82),('11288','2013-03-03','11:30:00',5.95),('11288','2013-03-03','11:35:00',5.99),('11288','2013-03-03','11:40:00',5.98),('11288','2013-03-03','11:45:00',5.97),('11288','2013-03-03','11:50:00',5.97),('11288','2013-03-03','11:55:00',5.93),('11288','2013-03-03','12:00:00',6.02),('11288','2013-03-03','12:05:00',6.04),('11288','2013-03-03','12:10:00',6.05),('11288','2013-03-03','12:15:00',6.03),('11288','2013-03-03','12:20:00',5.98),('11288','2013-03-03','12:25:00',5.96),('11288','2013-03-03','12:30:00',5.97),('11288','2013-03-03','12:35:00',5.99),('11288','2013-03-03','12:40:00',6.03),('11288','2013-03-03','12:45:00',6.02),('11288','2013-03-03','12:50:00',5.93),('11288','2013-03-03','12:55:00',5.91),('11288','2013-03-03','13:00:00',5.88),('11288','2013-03-03','13:05:00',5.84),('11288','2013-03-03','13:10:00',5.8),('11288','2013-03-03','13:15:00',5.77),('11288','2013-03-03','13:20:00',5.73),('11288','2013-03-03','13:25:00',5.67),('11288','2013-03-03','13:30:00',5.62),('11288','2013-03-03','13:35:00',5.56),('11288','2013-03-03','13:40:00',5.52),('11288','2013-03-03','13:45:00',5.48),('11288','2013-03-03','13:50:00',5.37),('11288','2013-03-03','13:55:00',5.34),('11288','2013-03-03','14:00:00',5.27),('11288','2013-03-03','14:05:00',5.23),('11288','2013-03-03','14:10:00',5.14),('11288','2013-03-03','14:15:00',5.03),('11288','2013-03-03','14:20:00',4.95),('11288','2013-03-03','14:25:00',4.9),('11288','2013-03-03','14:30:00',4.82),('11288','2013-03-03','14:35:00',4.74),('11288','2013-03-03','14:40:00',4.6),('11288','2013-03-03','14:45:00',4.53),('11288','2013-03-03','14:50:00',4.4),('11288','2013-03-03','14:55:00',4.21),('11288','2013-03-03','15:00:00',4.1),('11288','2013-03-03','15:05:00',3.99),('11288','2013-03-03','15:10:00',3.86),('11288','2013-03-03','15:15:00',3.58),('11288','2013-03-03','15:20:00',3.65),('11288','2013-03-03','15:25:00',3.53),('11288','2013-03-03','15:30:00',3.31),('11288','2013-03-03','15:35:00',2.96),('11288','2013-03-03','15:40:00',3.07),('11288','2013-03-03','15:45:00',2.93),('11288','2013-03-03','15:50:00',2.78),('11288','2013-03-03','15:55:00',2.62),('11288','2013-03-03','16:00:00',2.5),('11288','2013-03-03','16:05:00',2.34),('11288','2013-03-03','16:10:00',2.16),('11288','2013-03-03','16:15:00',2.04),('11288','2013-03-03','16:20:00',1.82),('11288','2013-03-03','16:25:00',1.72),('11288','2013-03-03','16:30:00',1.6),('11288','2013-03-03','16:35:00',1.46),('11288','2013-03-03','16:40:00',1.32),('11288','2013-03-03','16:45:00',1.18),('11288','2013-03-03','16:50:00',1.07),('11288','2014-03-24','07:40:00',1.02),('11288','2014-03-24','07:45:00',2.05),('11288','2014-03-24','07:50:00',1.4),('11288','2014-03-24','07:55:00',1.44),('11288','2014-03-24','08:30:00',1.06),('11288','2014-03-24','08:35:00',1.53),('11288','2014-03-24','08:40:00',1.6),('11288','2014-03-24','08:45:00',1.2),('11288','2014-03-24','08:50:00',1.42),('11288','2014-03-24','08:55:00',2.61),('11288','2014-03-24','09:00:00',2.77),('11288','2014-03-24','09:05:00',1.72),('11288','2014-03-24','09:10:00',1.06),('11288','2014-03-24','09:15:00',1.8),('11288','2014-03-24','09:20:00',2.04),('11288','2014-03-24','09:25:00',1.62),('11288','2014-03-24','09:30:00',2.08),('11288','2014-03-24','09:35:00',1.59),('11288','2014-03-24','09:40:00',2.57),('11288','2014-03-24','09:45:00',1.81),('11288','2014-03-24','09:50:00',1.8),('11288','2014-03-24','09:55:00',1.25),('11288','2014-03-24','10:00:00',3.41),('11288','2014-03-24','10:05:00',3.53),('11288','2014-03-24','10:10:00',4.94),('11288','2014-03-24','10:15:00',3.29),('11288','2014-03-24','10:20:00',1.66),('11288','2014-03-24','10:25:00',1.37),('11288','2014-03-24','10:30:00',1.37),('11288','2014-03-24','10:35:00',2.49),('11288','2014-03-24','10:40:00',1.8),('11288','2014-03-24','10:45:00',3.51),('11288','2014-03-24','10:50:00',7.43),('11288','2014-03-24','10:55:00',5.34),('11288','2014-03-24','11:00:00',3.03),('11288','2014-03-24','11:05:00',3.6),('11288','2014-03-24','11:10:00',4.81),('11288','2014-03-24','11:15:00',5.42),('11288','2014-03-24','11:20:00',4.36),('11288','2014-03-24','11:25:00',5.5),('11288','2014-03-24','11:30:00',5.94),('11288','2014-03-24','11:35:00',2.56),('11288','2014-03-24','11:40:00',1.42),('11288','2014-03-24','11:45:00',1.11),('11288','2014-03-24','11:50:00',1.07),('11288','2014-03-24','11:55:00',1.41),('11288','2014-03-24','12:00:00',1.13),('11288','2014-03-24','12:20:00',1.1),('11288','2014-03-24','12:25:00',1.36),('11288','2014-03-24','12:30:00',2.17),('11288','2014-03-24','12:35:00',3.55),('11288','2014-03-24','12:40:00',3.53),('11288','2014-03-24','12:45:00',3.08),('11288','2014-03-24','12:50:00',2.62),('11288','2014-03-24','12:55:00',2.52),('11288','2014-03-24','13:00:00',2.55),('11288','2014-03-24','13:05:00',2.52),('11288','2014-03-24','13:10:00',2.15),('11288','2014-03-24','13:15:00',1.82),('11288','2014-03-24','13:20:00',1.87),('11288','2014-03-24','13:25:00',2.17),('11288','2014-03-24','13:30:00',2.5),('11288','2014-03-24','13:35:00',2.07),('11288','2014-03-24','13:40:00',1.31),('11288','2014-03-24','13:45:00',2.1),('11288','2014-03-24','13:50:00',2.44),('11288','2014-03-24','13:55:00',2.37),('11288','2014-03-24','14:00:00',2.05),('11288','2014-03-24','14:05:00',1.92),('11288','2014-03-24','14:10:00',2.31),('11288','2014-03-24','14:15:00',3),('11288','2014-03-24','14:20:00',3.76),('11288','2014-03-24','14:25:00',3.59),('11288','2014-03-24','14:30:00',3.43),('11288','2014-03-24','14:35:00',4.12),('11288','2014-03-24','14:40:00',4.96),('11288','2014-03-24','14:45:00',5.46),('11288','2014-03-24','14:50:00',5.41),('11288','2014-03-24','14:55:00',4.81),('11288','2014-03-24','15:00:00',4.31),('11288','2014-03-24','15:05:00',3.87),('11288','2014-03-24','15:10:00',3.42),('11288','2014-03-24','15:15:00',2.75),('11288','2014-03-24','15:20:00',2.82),('11288','2014-03-24','15:25:00',2.77),('11288','2014-03-24','15:30:00',2.71),('11288','2014-03-24','15:35:00',2.54),('11288','2014-03-24','15:40:00',2.15),('11288','2014-03-24','15:45:00',1.9),('11288','2014-03-24','15:50:00',2.12),('11288','2014-03-24','15:55:00',2.64),('11288','2014-03-24','16:00:00',3.48),('11288','2014-03-24','16:05:00',2.38),('11288','2014-03-24','16:10:00',1.93),('11288','2014-03-24','16:15:00',1.51),('11288','2013-03-02','08:50:00',1.07),('11288','2013-03-02','08:55:00',1.1),('11288','2013-03-02','09:00:00',1.18),('11288','2013-03-02','09:05:00',1.05),('11288','2013-03-02','09:40:00',1.15),('11288','2013-03-02','09:45:00',1.37),('11288','2013-03-02','09:50:00',1.45),('11288','2013-03-02','09:55:00',1.26),('11288','2013-03-02','10:00:00',1.17),('11288','2013-03-02','10:05:00',1.22),('11288','2013-03-02','10:10:00',1.1),('11288','2013-03-02','10:15:00',1.16),('11288','2013-03-02','10:20:00',1.39),('11288','2013-03-02','10:25:00',1.45),('11288','2013-03-02','10:30:00',1.55),('11288','2013-03-02','10:35:00',1.69),('11288','2013-03-02','10:40:00',1.81),('11288','2013-03-02','10:45:00',1.8),('11288','2013-03-02','10:50:00',2),('11288','2013-03-02','10:55:00',2.08),('11288','2013-03-02','11:00:00',2.22),('11288','2013-03-02','11:05:00',2.32),('11288','2013-03-02','11:10:00',2.4),('11288','2013-03-02','11:15:00',2.76),('11288','2013-03-02','11:20:00',2.47),('11288','2013-03-02','11:25:00',2.18),('11288','2013-03-02','11:30:00',2),('11288','2013-03-02','11:35:00',2.07),('11288','2013-03-02','11:40:00',2.32),('11288','2013-03-02','11:45:00',2.11),('11288','2013-03-02','11:50:00',2.17),('11288','2013-03-02','11:55:00',2.02),('11288','2013-03-02','12:00:00',1.99),('11288','2013-03-02','12:05:00',2.29),('11288','2013-03-02','12:10:00',2.26),('11288','2013-03-02','12:15:00',2.39),('11288','2013-03-02','12:20:00',2.23),('11288','2013-03-02','12:25:00',2.32),('11288','2013-03-02','12:30:00',2.6),('11288','2013-03-02','12:35:00',2.78),('11288','2013-03-02','12:40:00',3.07),('11288','2013-03-02','12:45:00',2.89),('11288','2013-03-02','12:50:00',2.69),('11288','2013-03-02','12:55:00',3.78),('11288','2013-03-02','13:00:00',3.45),('11288','2013-03-02','13:05:00',2.83),('11288','2013-03-02','13:10:00',2.04),('11288','2013-03-02','13:15:00',1.73),('11288','2013-03-02','13:20:00',1.65),('11288','2013-03-02','13:25:00',1.67),('11288','2013-03-02','13:30:00',1.84),('11288','2013-03-02','13:35:00',1.87),('11288','2013-03-02','13:40:00',2),('11288','2013-03-02','13:45:00',2.14),('11288','2013-03-02','13:50:00',2.08),('11288','2013-03-02','13:55:00',2.16),('11288','2013-03-02','14:00:00',2.41),('11288','2013-03-02','14:05:00',2.33),('11288','2013-03-02','14:10:00',2.05),('11288','2013-03-02','14:15:00',1.87),('11288','2013-03-02','14:20:00',1.8),('11288','2013-03-02','14:25:00',1.49),('11288','2013-03-02','14:30:00',1.09),('11288','2013-03-02','14:50:00',1.22),('11288','2013-03-02','14:55:00',1.37),('11288','2013-03-02','15:00:00',1.36),('11288','2013-03-02','15:05:00',1.56),('11288','2013-03-02','15:10:00',1.55),('11288','2013-03-02','15:15:00',1.49),('11288','2013-03-02','15:20:00',1.43),('11288','2013-03-02','15:25:00',1.36),('11288','2013-03-02','15:30:00',1.54),('11288','2013-03-02','15:35:00',1.49),('11288','2013-03-02','15:40:00',1.36),('11288','2013-03-02','15:45:00',1.55),('11288','2013-03-02','15:50:00',1.35),('11288','2013-03-02','15:55:00',1.33),('11288','2013-03-02','16:00:00',1.2),('11288','2013-03-02','16:05:00',1.04),('11288','2013-03-01','07:50:00',1.12),('11288','2013-03-01','07:55:00',1.35),('11288','2013-03-01','08:00:00',1.46),('11288','2013-03-01','08:05:00',1.35),('11288','2013-03-01','08:10:00',1.52),('11288','2013-03-01','08:15:00',1.63),('11288','2013-03-01','08:20:00',1.73),('11288','2013-03-01','08:25:00',1.77),('11288','2013-03-01','08:30:00',1.9),('11288','2013-03-01','08:35:00',2.01),('11288','2013-03-01','08:40:00',2.15),('11288','2013-03-01','08:45:00',2.25),('11288','2013-03-01','08:50:00',2.36),('11288','2013-03-01','08:55:00',2.55),('11288','2013-03-01','09:00:00',2.75),('11288','2013-03-01','09:05:00',2.94),('11288','2013-03-01','09:10:00',2.91),('11288','2013-03-01','09:15:00',3.01),('11288','2013-03-01','09:20:00',3.06),('11288','2013-03-01','09:25:00',3.05),('11288','2013-03-01','09:30:00',3.29),('11288','2013-03-01','09:35:00',3.23),('11288','2013-03-01','09:40:00',3.58),('11288','2013-03-01','09:45:00',3.78),('11288','2013-03-01','09:50:00',3.75),('11288','2013-03-01','09:55:00',3.86),('11288','2013-03-01','10:00:00',3.94),('11288','2013-03-01','10:05:00',3.95),('11288','2013-03-01','10:10:00',3.77),('11288','2013-03-01','10:15:00',3.35),('11288','2013-03-01','10:20:00',3.46),('11288','2013-03-01','10:25:00',3.66),('11288','2013-03-01','10:30:00',4.22),('11288','2013-03-01','10:35:00',4.2),('11288','2013-03-01','10:40:00',3.89),('11288','2013-03-01','10:45:00',3.67),('11288','2013-03-01','10:50:00',3.52),('11288','2013-03-01','10:55:00',3.36),('11288','2013-03-01','11:00:00',3),('11288','2013-03-01','11:05:00',2.77),('11288','2013-03-01','11:10:00',2.8),('11288','2013-03-01','11:15:00',3.11),('11288','2013-03-01','11:20:00',3.2),('11288','2013-03-01','11:25:00',3.19),('11288','2013-03-01','11:30:00',3.28),('11288','2013-03-01','11:35:00',3.26),('11288','2013-03-01','11:40:00',3.1),('11288','2013-03-01','11:45:00',3),('11288','2013-03-01','11:50:00',2.94),('11288','2013-03-01','11:55:00',2.83),('11288','2013-03-01','12:00:00',2.72),('11288','2013-03-01','12:05:00',2.57),('11288','2013-03-01','12:10:00',2.4),('11288','2013-03-01','12:15:00',2.19),('11288','2013-03-01','12:20:00',2.07),('11288','2013-03-01','12:25:00',2.07),('11288','2013-03-01','12:30:00',2.16),('11288','2013-03-01','12:35:00',2.13),('11288','2013-03-01','12:40:00',2.05),('11288','2013-03-01','12:45:00',2.06),('11288','2013-03-01','12:50:00',2.13),('11288','2013-03-01','12:55:00',2.26),('11288','2013-03-01','13:00:00',2.37),('11288','2013-03-01','13:05:00',2.4),('11288','2013-03-01','13:10:00',2.47),('11288','2013-03-01','13:15:00',2.64),('11288','2013-03-01','13:20:00',2.87),('11288','2013-03-01','13:25:00',3.07),('11288','2013-03-01','13:30:00',2.94),('11288','2013-03-01','13:35:00',2.76),('11288','2013-03-01','13:40:00',2.64),('11288','2013-03-01','13:45:00',2.63),('11288','2013-03-01','13:50:00',2.6),('11288','2013-03-01','13:55:00',2.51),('11288','2013-03-01','14:00:00',2.42),('11288','2013-03-01','14:05:00',2.32),('11288','2013-03-01','14:10:00',2.18),('11288','2013-03-01','14:15:00',2.07),('11288','2013-03-01','14:20:00',2),('11288','2013-03-01','14:25:00',2.02),('11288','2013-03-01','14:30:00',2.07),('11288','2013-03-01','14:35:00',2.06),('11288','2013-03-01','14:40:00',1.96),('11288','2013-03-01','14:45:00',1.84),('11288','2013-03-01','14:50:00',1.76),('11288','2013-03-01','14:55:00',1.75),('11288','2013-03-01','15:00:00',1.76),('11288','2013-03-01','15:05:00',1.69),('11288','2013-03-01','15:10:00',1.55),('11288','2013-03-01','15:15:00',1.43),('11288','2013-03-01','15:20:00',1.34),('11288','2013-03-01','15:25:00',1.2),('11288','2013-03-01','15:30:00',1.09),('11288','2013-03-01','15:35:00',1.12),('11288','2013-03-01','15:40:00',1.22),('11288','2013-03-01','15:45:00',1.18),('11288','2013-03-01','15:50:00',1.11),('11288','2013-03-01','15:55:00',1.06),('11288','2013-03-01','16:00:00',1.09),('11288','2013-03-01','16:05:00',1.08),('11288','2013-03-01','16:10:00',1.03),('11288','2013-02-28','07:55:00',1.01),('11288','2013-02-28','08:00:00',1.1),('11288','2013-02-28','08:05:00',1.13),('11288','2013-02-28','08:10:00',1.34),('11288','2013-02-28','08:15:00',1.45),('11288','2013-02-28','08:20:00',1.55),('11288','2013-02-28','08:25:00',1.72),('11288','2013-02-28','08:30:00',1.88),('11288','2013-02-28','08:35:00',1.89),('11288','2013-02-28','08:40:00',2.11),('11288','2013-02-28','08:45:00',2.31),('11288','2013-02-28','08:50:00',2.46),('11288','2013-02-28','08:55:00',2.65),('11288','2013-02-28','09:00:00',2.76),('11288','2013-02-28','09:05:00',2.87),('11288','2013-02-28','09:10:00',2.99),('11288','2013-02-28','09:15:00',3.14),('11288','2013-02-28','09:20:00',3.18),('11288','2013-02-28','09:25:00',3.36),('11288','2013-02-28','09:30:00',3.54),('11288','2013-02-28','09:35:00',3.65),('11288','2013-02-28','09:40:00',3.79),('11288','2013-02-28','09:45:00',3.93),('11288','2013-02-28','09:50:00',3.75),('11288','2013-02-28','09:55:00',4.11),('11288','2013-02-28','10:00:00',4.25),('11288','2013-02-28','10:05:00',4.38),('11288','2013-02-28','10:10:00',4.48),('11288','2013-02-28','10:15:00',4.53),('11288','2013-02-28','10:20:00',4.57),('11288','2013-02-28','10:25:00',4.67),('11288','2013-02-28','10:30:00',4.63),('11288','2013-02-28','10:35:00',4.72),('11288','2013-02-28','10:40:00',4.76),('11288','2013-02-28','10:45:00',4.79),('11288','2013-02-28','10:50:00',4.93),('11288','2013-02-28','10:55:00',4.99),('11288','2013-02-28','11:00:00',5.14),('11288','2013-02-28','11:05:00',5.23),('11288','2013-02-28','11:10:00',5.24),('11288','2013-02-28','11:15:00',5.29),('11288','2013-02-28','11:20:00',5.36),('11288','2013-02-28','11:25:00',5.43),('11288','2013-02-28','11:30:00',5.51),('11288','2013-02-28','11:35:00',5.45),('11288','2013-02-28','11:40:00',5.44),('11288','2013-02-28','11:45:00',5.36),('11288','2013-02-28','11:50:00',5.3),('11288','2013-02-28','11:55:00',5.45),('11288','2013-02-28','12:00:00',5.53),('11288','2013-02-28','12:05:00',5.56),('11288','2013-02-28','12:10:00',5.64),('11288','2013-02-28','12:15:00',5.5),('11288','2013-02-28','12:20:00',5.6),('11288','2013-02-28','12:25:00',5.6),('11288','2013-02-28','12:30:00',5.64),('11288','2013-02-28','12:35:00',5.65),('11288','2013-02-28','12:40:00',5.53),('11288','2013-02-28','12:45:00',5.47),('11288','2013-02-28','12:50:00',5.49),('11288','2013-02-28','12:55:00',5.48),('11288','2013-02-28','13:00:00',5.21),('11288','2013-02-28','13:05:00',5.49),('11288','2013-02-28','13:10:00',5.35),('11288','2013-02-28','13:15:00',5.26),('11288','2013-02-28','13:20:00',5.39),('11288','2013-02-28','13:25:00',5.34),('11288','2013-02-28','13:30:00',5.03),('11288','2013-02-28','13:35:00',5.25),('11288','2013-02-28','13:40:00',5.3),('11288','2013-02-28','13:45:00',5.4),('11288','2013-02-28','13:50:00',5.26),('11288','2013-02-28','13:55:00',4.74),('11288','2013-02-28','14:00:00',5.3),('11288','2013-02-28','14:05:00',5.18),('11288','2013-02-28','14:10:00',5.08),('11288','2013-02-28','14:15:00',4.93),('11288','2013-02-28','14:20:00',4.75),('11288','2013-02-28','14:25:00',4.59),('11288','2013-02-28','14:30:00',4.32),('11288','2013-02-28','14:35:00',4.05),('11288','2013-02-28','14:40:00',4.14),('11288','2013-02-28','14:45:00',4.08),('11288','2013-02-28','14:50:00',3.99),('11288','2013-02-28','14:55:00',3.8),('11288','2013-02-28','15:00:00',3.76),('11288','2013-02-28','15:05:00',3.63),('11288','2013-02-28','15:10:00',3.47),('11288','2013-02-28','15:15:00',3.29),('11288','2013-02-28','15:20:00',3.1),('11288','2013-02-28','15:25:00',2.98),('11288','2013-02-28','15:30:00',2.82),('11288','2013-02-28','15:35:00',2.71),('11288','2013-02-28','15:40:00',2.51),('11288','2013-02-28','15:45:00',2.51),('11288','2013-02-28','15:50:00',2.39),('11288','2013-02-28','15:55:00',2.23),('11288','2013-02-28','16:00:00',2.12),('11288','2013-02-28','16:05:00',1.97),('11288','2013-02-28','16:10:00',1.78),('11288','2013-02-28','16:15:00',1.69),('11288','2013-02-28','16:20:00',1.58),('11288','2013-02-28','16:25:00',1.44),('11288','2013-02-28','16:30:00',1.32),('11288','2013-02-28','16:35:00',1.26),('11288','2013-02-28','16:40:00',1.14),('11288','2013-02-28','16:45:00',1.04),('11288','2013-02-27','08:00:00',1.07),('11288','2013-02-27','08:05:00',1.16),('11288','2013-02-27','08:10:00',1.17),('11288','2013-02-27','08:15:00',1.38),('11288','2013-02-27','08:20:00',1.5),('11288','2013-02-27','08:25:00',1.63),('11288','2013-02-27','08:30:00',1.77),('11288','2013-02-27','08:35:00',1.8),('11288','2013-02-27','08:40:00',1.87),('11288','2013-02-27','08:45:00',2.22),('11288','2013-02-27','08:50:00',2.36),('11288','2013-02-27','08:55:00',2.48),('11288','2013-02-27','09:00:00',2.64),('11288','2013-02-27','09:05:00',2.78),('11288','2013-02-27','09:10:00',2.94),('11288','2013-02-27','09:15:00',3.01),('11288','2013-02-27','09:20:00',3.13),('11288','2013-02-27','09:25:00',3.19),('11288','2013-02-27','09:30:00',3.4),('11288','2013-02-27','09:35:00',3.55),('11288','2013-02-27','09:40:00',3.67),('11288','2013-02-27','09:45:00',3.78),('11288','2013-02-27','09:50:00',3.88),('11288','2013-02-27','09:55:00',4.02),('11288','2013-02-27','10:00:00',4.19),('11288','2013-02-27','10:05:00',4.27),('11288','2013-02-27','10:10:00',4.38),('11288','2013-02-27','10:15:00',4.48),('11288','2013-02-27','10:20:00',4.6),('11288','2013-02-27','10:25:00',4.64),('11288','2013-02-27','10:30:00',4.68),('11288','2013-02-27','10:35:00',4.8),('11288','2013-02-27','10:40:00',4.85),('11288','2013-02-27','10:45:00',4.86),('11288','2013-02-27','10:50:00',4.94),('11288','2013-02-27','10:55:00',4.99),('11288','2013-02-27','11:00:00',5.11),('11288','2013-02-27','11:05:00',5.12),('11288','2013-02-27','11:10:00',5.2),('11288','2013-02-27','11:15:00',5.25),('11288','2013-02-27','11:20:00',5.42),('11288','2013-02-27','11:25:00',5.15),('11288','2013-02-27','11:30:00',5.31),('11288','2013-02-27','11:35:00',5.54),('11288','2013-02-27','11:40:00',2.9),('11288','2013-02-27','11:45:00',3.9),('11288','2013-02-27','11:50:00',5.01),('11288','2013-02-27','11:55:00',5.32),('11288','2013-02-27','12:00:00',5.57),('11288','2013-02-27','12:05:00',3.48),('11288','2013-02-27','12:10:00',1.11),('11288','2013-02-27','12:15:00',3.9),('11288','2013-02-27','12:20:00',4.85),('11288','2013-02-27','12:25:00',2.58),('11288','2013-02-27','12:30:00',6.01),('11288','2013-02-27','12:35:00',5.89),('11288','2013-02-27','12:40:00',5.81),('11288','2013-02-27','12:45:00',5.82),('11288','2013-02-27','12:50:00',5.67),('11288','2013-02-27','12:55:00',5.64),('11288','2013-02-27','13:00:00',5.61),('11288','2013-02-27','13:05:00',5.62),('11288','2013-02-27','13:10:00',5.48),('11288','2013-02-27','13:15:00',5.56),('11288','2013-02-27','13:20:00',5.56),('11288','2013-02-27','13:25:00',5.66),('11288','2013-02-27','13:30:00',5.6),('11288','2013-02-27','13:35:00',5.48),('11288','2013-02-27','13:40:00',5.48),('11288','2013-02-27','13:45:00',5.42),('11288','2013-02-27','13:50:00',5.39),('11288','2013-02-27','13:55:00',5.3),('11288','2013-02-27','14:00:00',5.07),('11288','2013-02-27','14:05:00',4.91),('11288','2013-02-27','14:10:00',4.66),('11288','2013-02-27','14:15:00',4.73),('11288','2013-02-27','14:20:00',4),('11288','2013-02-27','14:25:00',3.6),('11288','2013-02-27','14:30:00',3.63),('11288','2013-02-27','14:35:00',4.52),('11288','2013-02-27','14:40:00',4.39),('11288','2013-02-27','14:45:00',4.37),('11288','2013-02-27','14:50:00',4.15),('11288','2013-02-27','14:55:00',3.85),('11288','2013-02-27','15:00:00',3.78),('11288','2013-02-27','15:05:00',3.84),('11288','2013-02-27','15:10:00',3.56),('11288','2013-02-27','15:15:00',3.47),('11288','2013-02-27','15:20:00',3.34),('11288','2013-02-27','15:25:00',3.17),('11288','2013-02-27','15:30:00',3.02),('11288','2013-02-27','15:35:00',2.89),('11288','2013-02-27','15:40:00',2.74),('11288','2013-02-27','15:45:00',2.66),('11288','2013-02-27','15:50:00',2.52),('11288','2013-02-27','15:55:00',2.4),('11288','2013-02-27','16:00:00',2.13),('11288','2013-02-27','16:05:00',2.1),('11288','2013-02-27','16:10:00',1.95),('11288','2013-02-27','16:15:00',1.72),('11288','2013-02-27','16:20:00',1.68),('11288','2013-02-27','16:25:00',1.51),('11288','2013-02-27','16:30:00',1.3),('11288','2013-02-27','16:35:00',1.26),('11288','2013-02-27','16:40:00',1.13),('11288','2013-02-27','16:45:00',1.02),('11288','2013-02-26','08:50:00',1.13),('11288','2013-02-26','08:55:00',1.29),('11288','2013-02-26','09:00:00',1.42),('11288','2013-02-26','09:05:00',1.53),('11288','2013-02-26','09:10:00',1.67),('11288','2013-02-26','09:15:00',1.77),('11288','2013-02-26','09:20:00',1.85),('11288','2013-02-26','09:25:00',1.98),('11288','2013-02-26','09:30:00',2.25),('11288','2013-02-26','09:35:00',2.66),('11288','2013-02-26','09:40:00',2.9),('11288','2013-02-26','09:45:00',2.87),('11288','2013-02-26','09:50:00',2.91),('11288','2013-02-26','09:55:00',3.33),('11288','2013-02-26','10:00:00',3.28),('11288','2013-02-26','10:05:00',3.21),('11288','2013-02-26','10:10:00',3.62),('11288','2013-02-26','10:15:00',3.92),('11288','2013-02-26','10:20:00',4.91),('11288','2013-02-26','10:25:00',4.6),('11288','2013-02-26','10:30:00',4.68),('11288','2013-02-26','10:35:00',4.58),('11288','2013-02-26','10:40:00',2.58),('11288','2013-02-26','10:45:00',2.7),('11288','2013-02-26','10:50:00',3.19),('11288','2013-02-26','10:55:00',2.99),('11288','2013-02-26','11:00:00',3.47),('11288','2013-02-26','11:05:00',3.64),('11288','2013-02-26','11:10:00',3.8),('11288','2013-02-26','11:15:00',3.16),('11288','2013-02-26','11:20:00',3.29),('11288','2013-02-26','11:25:00',2.98),('11288','2013-02-26','11:30:00',2.8),('11288','2013-02-26','11:35:00',2.61),('11288','2013-02-26','11:40:00',2.64),('11288','2013-02-26','11:45:00',2.83),('11288','2013-02-26','11:50:00',3.26),('11288','2013-02-26','11:55:00',3.38),('11288','2013-02-26','12:00:00',2.77),('11288','2013-02-26','12:05:00',2.7),('11288','2013-02-26','12:10:00',2.83),('11288','2013-02-26','12:15:00',2.65),('11288','2013-02-26','12:20:00',2.69),('11288','2013-02-26','12:25:00',2.48),('11288','2013-02-26','12:30:00',2.45),('11288','2013-02-26','12:35:00',2.27),('11288','2013-02-26','12:40:00',2.11),('11288','2013-02-26','12:45:00',1.93),('11288','2013-02-26','12:50:00',1.77),('11288','2013-02-26','12:55:00',1.91),('11288','2013-02-26','13:00:00',1.99),('11288','2013-02-26','13:05:00',1.79),('11288','2013-02-26','13:10:00',1.64),('11288','2013-02-26','13:15:00',1.71),('11288','2013-02-26','13:20:00',1.78),('11288','2013-02-26','13:25:00',1.81),('11288','2013-02-26','13:30:00',1.82),('11288','2013-02-26','13:35:00',1.86),('11288','2013-02-26','13:40:00',1.89),('11288','2013-02-26','13:45:00',1.83),('11288','2013-02-26','13:50:00',1.67),('11288','2013-02-26','13:55:00',1.56),('11288','2013-02-26','14:00:00',1.46),('11288','2013-02-26','14:05:00',1.34),('11288','2013-02-26','14:10:00',1.3),('11288','2013-02-26','14:15:00',1.32),('11288','2013-02-25','08:35:00',1.42),('11288','2013-02-25','08:40:00',1.62),('11288','2013-02-25','08:45:00',1.75),('11288','2013-02-25','08:50:00',1.61),('11288','2013-02-25','08:55:00',1.56),('11288','2013-02-25','09:00:00',1.77),('11288','2013-02-25','09:05:00',1.43),('11288','2013-02-25','09:10:00',1.73),('11288','2013-02-25','09:15:00',1.69),('11288','2013-02-25','09:20:00',1.95),('11288','2013-02-25','09:25:00',2.54),('11288','2013-02-25','09:30:00',2.71),('11288','2013-02-25','09:35:00',2.54),('11288','2013-02-25','09:40:00',1.94),('11288','2013-02-25','09:45:00',1.6),('11288','2013-02-25','09:50:00',1.15),('11288','2013-02-25','10:25:00',1.06),('11288','2013-02-25','10:35:00',1.02),('11288','2013-02-25','10:40:00',1.8),('11288','2013-02-25','10:45:00',3.28),('11288','2013-02-25','10:50:00',5.67),('11288','2013-02-25','10:55:00',7.23),('11288','2013-02-25','11:00:00',5.81),('11288','2013-02-25','11:05:00',3.48),('11288','2013-02-25','11:10:00',3.92),('11288','2013-02-25','11:15:00',3.87),('11288','2013-02-25','11:20:00',2.13),('11288','2013-02-25','11:25:00',2.12),('11288','2013-02-25','11:30:00',2.26),('11288','2013-02-25','11:35:00',2.36),('11288','2013-02-25','11:40:00',3.08),('11288','2013-02-25','11:45:00',3.23),('11288','2013-02-25','11:50:00',5.36),('11288','2013-02-25','11:55:00',7.48),('11288','2013-02-25','12:00:00',5.18),('11288','2013-02-25','12:05:00',4.14),('11288','2013-02-25','12:10:00',3.76),('11288','2013-02-25','12:15:00',3.72),('11288','2013-02-25','12:20:00',6.15),('11288','2013-02-25','12:25:00',6.87),('11288','2013-02-25','12:30:00',5.06),('11288','2013-02-25','12:35:00',5.19),('11288','2013-02-25','12:40:00',6.47),('11288','2013-02-25','12:45:00',4.39),('11288','2013-02-25','12:50:00',5.95),('11288','2013-02-25','12:55:00',5.58),('11288','2013-02-25','13:00:00',3.18),('11288','2013-02-25','13:05:00',4.6),('11288','2013-02-25','13:10:00',2.69),('11288','2013-02-25','13:15:00',3.92),('11288','2013-02-25','13:20:00',2.89),('11288','2013-02-25','13:25:00',3.12),('11288','2013-02-25','13:30:00',2.98),('11288','2013-02-25','13:35:00',2.42),('11288','2013-02-25','13:40:00',2.29),('11288','2013-02-25','13:45:00',1.88),('11288','2013-02-25','13:50:00',1.69),('11288','2013-02-25','13:55:00',1.46),('11288','2013-02-25','14:00:00',1.25),('11288','2013-02-25','14:35:00',1.29),('11288','2013-02-25','14:40:00',1.55),('11288','2013-02-25','14:45:00',1.5),('11288','2013-02-25','14:50:00',1.53),('11288','2013-02-25','14:55:00',1.47),('11288','2013-02-25','15:00:00',1.44),('11288','2013-02-25','15:05:00',1.49),('11288','2013-02-25','15:10:00',1.43),('11288','2013-02-25','15:15:00',1.34),('11288','2013-02-25','15:20:00',1.24),('11288','2013-02-25','15:55:00',1.15),('11288','2013-02-25','16:00:00',1.2),('11288','2013-02-25','16:05:00',1.1),('11288','2013-02-25','16:30:00',1.16),('11288','2013-02-25','16:35:00',1.31),('11288','2013-02-25','16:40:00',1.16),('11288','2013-02-25','16:45:00',1.03),('11288','2013-02-25','16:50:00',1.02),('11288','2013-02-25','16:55:00',1.11),('11288','2013-02-24','08:00:00',1.31),('11288','2013-02-24','08:05:00',1.06),('11288','2013-02-24','08:20:00',1.2),('11288','2013-02-24','08:25:00',1.28),('11288','2013-02-24','08:30:00',1.08),('11288','2013-02-24','08:45:00',1.4),('11288','2013-02-24','08:50:00',1.56),('11288','2013-02-24','08:55:00',1.52),('11288','2013-02-24','09:00:00',1.19),('11288','2013-02-24','09:05:00',1.01),('11288','2013-02-24','10:00:00',1.08),('11288','2013-02-24','10:25:00',1.07),('11288','2013-02-24','10:30:00',1.16),('11288','2013-02-24','10:35:00',1.32),('11288','2013-02-24','10:40:00',1.69),('11288','2013-02-24','10:45:00',1.9),('11288','2013-02-24','10:50:00',2.8),('11288','2013-02-24','10:55:00',2.51),('11288','2013-02-24','11:00:00',1.94),('11288','2013-02-24','11:05:00',1.84),('11288','2013-02-24','11:10:00',1.64),('11288','2013-02-24','11:15:00',1.73),('11288','2013-02-24','11:20:00',1.67),('11288','2013-02-24','11:25:00',1.76),('11288','2013-02-24','11:30:00',1.81),('11288','2013-02-24','11:35:00',1.53),('11288','2013-02-24','11:40:00',1.68),('11288','2013-02-24','11:45:00',1.72),('11288','2013-02-24','11:50:00',1.7),('11288','2013-02-24','11:55:00',1.63),('11288','2013-02-24','12:00:00',1.51),('11288','2013-02-24','12:05:00',1.49),('11288','2013-02-24','12:10:00',1.19),('11288','2013-02-24','12:30:00',1.36),('11288','2013-02-24','12:35:00',1.9),('11288','2013-02-24','12:40:00',2.07),('11288','2013-02-24','12:45:00',2.25),('11288','2013-02-24','12:50:00',1.83),('11288','2013-02-24','12:55:00',1.83),('11288','2013-02-24','13:00:00',2.28),('11288','2013-02-24','13:05:00',2.66),('11288','2013-02-24','13:10:00',2.74),('11288','2013-02-24','13:15:00',2.47),('11288','2013-02-24','13:20:00',2.71),('11288','2013-02-24','13:25:00',1.7),('11288','2013-02-24','13:30:00',2.14),('11288','2013-02-24','13:35:00',2.4),('11288','2013-02-24','13:40:00',2.22),('11288','2013-02-24','13:45:00',2.3),('11288','2013-02-24','13:50:00',1.85),('11288','2013-02-24','13:55:00',1.82),('11288','2013-02-24','14:00:00',1.92),('11288','2013-02-24','14:05:00',3.15),('11288','2013-02-24','14:10:00',2.25),('11288','2013-02-24','14:15:00',1.93),('11288','2013-02-24','14:20:00',1.74),('11288','2013-02-24','14:25:00',1.7),('11288','2013-02-24','14:30:00',2.13),('11288','2013-02-24','14:35:00',2.1),('11288','2013-02-24','14:40:00',1.41),('11288','2013-02-24','14:45:00',1.56),('11288','2013-02-24','14:50:00',1.24),('11288','2013-02-24','14:55:00',1.12),('11288','2013-02-24','15:00:00',1.25),('11288','2013-02-24','15:05:00',1.69),('11288','2013-02-24','15:10:00',3.75),('11288','2013-02-24','15:15:00',1.54),('11288','2013-02-24','15:20:00',2.41),('11288','2013-02-24','15:25:00',2.77),('11288','2013-02-24','15:30:00',2.68),('11288','2013-02-24','15:35:00',2.22),('11288','2013-02-24','15:40:00',1.68),('11288','2013-02-24','15:45:00',2.35),('11288','2013-02-24','15:50:00',1.33),('11288','2013-02-24','15:55:00',2.51),('11288','2013-02-24','16:00:00',2.51),('11288','2013-02-24','16:05:00',1.3),('11288','2013-02-24','16:20:00',1.05),('11288','2013-02-24','16:25:00',1.07),('11288','2013-02-24','16:40:00',1.4),('11288','2013-02-23','07:55:00',1.03),('11288','2013-02-23','08:00:00',1.17),('11288','2013-02-23','08:05:00',1.35),('11288','2013-02-23','08:10:00',1.67),('11288','2013-02-23','08:15:00',2.28),('11288','2013-02-23','08:20:00',1.6),('11288','2013-02-23','08:25:00',1.28),('11288','2013-02-23','08:30:00',1.19),('11288','2013-02-23','08:35:00',1.08),('11288','2013-02-23','08:45:00',1.15),('11288','2013-02-23','08:50:00',1.58),('11288','2013-02-23','08:55:00',1.91),('11288','2013-02-23','09:00:00',2.29),('11288','2013-02-23','09:05:00',2.23),('11288','2013-02-23','09:10:00',1.8),('11288','2013-02-23','09:15:00',1.49),('11288','2013-02-23','09:20:00',1.11),('11288','2013-02-23','09:30:00',1.25),('11288','2013-02-23','09:35:00',1.42),('11288','2013-02-23','09:40:00',1.91),('11288','2013-02-23','09:45:00',2.5),('11288','2013-02-23','09:50:00',2.52),('11288','2013-02-23','09:55:00',2.47),('11288','2013-02-23','10:00:00',1.96),('11288','2013-02-23','10:05:00',1.86),('11288','2013-02-23','10:10:00',1.63),('11288','2013-02-23','10:15:00',1.29),('11288','2013-02-23','10:20:00',1.48),('11288','2013-02-23','10:25:00',2.02),('11288','2013-02-23','10:30:00',1.9),('11288','2013-02-23','10:35:00',1.78),('11288','2013-02-23','10:40:00',1.51),('11288','2013-02-23','10:45:00',1.59),('11288','2013-02-23','10:50:00',1.8),('11288','2013-02-23','10:55:00',1.2),('11288','2013-02-23','11:00:00',1.05),('11288','2013-02-23','11:05:00',1.23),('11288','2013-02-23','11:10:00',1.14),('11288','2013-02-23','11:15:00',1.14),('11288','2013-02-23','11:20:00',1.41),('11288','2013-02-23','11:25:00',1.23),('11288','2013-02-23','11:30:00',1.24),('11288','2013-02-23','11:35:00',1.69),('11288','2013-02-23','11:40:00',1.61),('11288','2013-02-23','11:45:00',1.51),('11288','2013-02-23','11:50:00',1.24),('11288','2013-02-23','11:55:00',1.11),('11288','2013-02-23','12:00:00',1.01),('11288','2013-02-23','12:05:00',1.43),('11288','2013-02-23','12:10:00',1.37),('11288','2013-02-23','12:15:00',1.11),('11288','2013-02-23','12:20:00',1.22),('11288','2013-02-23','12:25:00',1.04),('11288','2013-02-23','12:30:00',1.09),('11288','2013-02-23','13:50:00',1.11),('11288','2013-02-23','13:55:00',1.88),('11288','2013-02-23','14:00:00',2.02),('11288','2013-02-23','14:05:00',3.43),('11288','2013-02-23','14:10:00',2.35),('11288','2013-02-23','14:45:00',1.56),('11288','2013-02-23','14:50:00',1.32),('11288','2013-02-23','15:05:00',1.01),('11288','2013-02-23','15:10:00',1.09),('11288','2013-02-22','09:35:00',1.54),('11288','2013-02-22','09:40:00',1.53),('11288','2013-02-22','09:45:00',1.05),('11288','2013-02-22','09:50:00',1.24),('11288','2013-02-22','10:00:00',1.01),('11288','2013-02-22','10:05:00',1.02),('11288','2013-02-22','10:15:00',1.24),('11288','2013-02-22','11:30:00',1.03),('11288','2013-02-22','11:35:00',1.21),('11288','2013-02-22','11:40:00',1.1),('11288','2013-02-22','11:55:00',1.05),('11288','2013-02-22','12:00:00',1.27),('11288','2013-02-22','12:05:00',1.08),('11288','2013-02-22','12:45:00',1.25),('11288','2013-02-22','12:50:00',1.57),('11288','2013-02-22','12:55:00',1.81),('11288','2013-02-22','13:00:00',1.27),('11288','2013-02-22','14:10:00',1.43),('11288','2013-02-22','14:15:00',1.83),('11288','2013-02-22','14:20:00',1.71),('11288','2013-02-22','14:30:00',1.67),('11288','2013-02-22','14:35:00',2.49),('11288','2013-02-22','14:40:00',2.46),('11288','2013-02-22','14:45:00',1.78),('11288','2013-02-22','14:50:00',2.11),('11288','2013-02-22','14:55:00',2.42),('11288','2013-02-22','15:00:00',1.5),('11288','2013-02-22','15:45:00',1.13),('11288','2013-02-22','15:50:00',1.6),('11288','2013-02-22','15:55:00',1.23),('11288','2013-02-22','16:00:00',1.11),('11288','2013-02-22','16:15:00',1.2),('11288','2013-02-22','16:20:00',2.16),('11288','2013-02-22','16:25:00',2.18),('11288','2013-02-22','16:30:00',1.57),('11288','2013-02-22','16:35:00',1.01),('11288','2013-02-21','09:40:00',1.11),('11288','2013-02-21','09:45:00',1.43),('11288','2013-02-21','09:50:00',1.49),('11288','2013-02-21','09:55:00',1.5),('11288','2013-02-21','10:00:00',1.39),('11288','2013-02-21','10:05:00',1.44),('11288','2013-02-21','10:10:00',1.46),('11288','2013-02-21','10:15:00',1.4),('11288','2013-02-21','10:20:00',1.42),('11288','2013-02-21','10:25:00',1.39),('11288','2013-02-21','10:30:00',1.42),('11288','2013-02-21','10:35:00',1.47),('11288','2013-02-21','10:40:00',1.49),('11288','2013-02-21','10:45:00',1.38),('11288','2013-02-21','10:50:00',1.41),('11288','2013-02-21','10:55:00',1.4),('11288','2013-02-21','11:00:00',1.26),('11288','2013-02-21','11:05:00',1.18),('11288','2013-02-21','11:10:00',1.18),('11288','2013-02-21','11:15:00',1.26),('11288','2013-02-21','11:20:00',1.51),('11288','2013-02-21','11:25:00',1.7),('11288','2013-02-21','11:30:00',1.8),('11288','2013-02-21','11:35:00',1.87),('11288','2013-02-21','11:40:00',1.84),('11288','2013-02-21','11:45:00',1.95),('11288','2013-02-21','11:50:00',2.15),('11288','2013-02-21','11:55:00',2.19),('11288','2013-02-21','12:00:00',2.15),('11288','2013-02-21','12:05:00',2.18),('11288','2013-02-21','12:10:00',2.25),('11288','2013-02-21','12:15:00',2.39),('11288','2013-02-21','12:20:00',2.52),('11288','2013-02-21','12:25:00',2.44),('11288','2013-02-21','12:30:00',2.3),('11288','2013-02-21','12:35:00',2.2),('11288','2013-02-21','12:40:00',2.15),('11288','2013-02-21','12:45:00',2.17),('11288','2013-02-21','12:50:00',2.21),('11288','2013-02-21','12:55:00',2.37),('11288','2013-02-21','13:00:00',2.35),('11288','2013-02-21','13:05:00',2.19),('11288','2013-02-21','13:10:00',2.11),('11288','2013-02-21','13:15:00',2.19),('11288','2013-02-21','13:20:00',2.27),('11288','2013-02-21','13:25:00',2.32),('11288','2013-02-21','13:30:00',2.34),('11288','2013-02-21','13:35:00',2.35),('11288','2013-02-21','13:40:00',2.25),('11288','2013-02-21','13:45:00',2.14),('11288','2013-02-21','13:50:00',2.18),('11288','2013-02-21','13:55:00',2.17),('11288','2013-02-21','14:00:00',2.19),('11288','2013-02-21','14:05:00',2.1),('11288','2013-02-21','14:10:00',1.92),('11288','2013-02-21','14:15:00',1.67),('11288','2013-02-21','14:20:00',1.51),('11288','2013-02-21','14:25:00',1.49),('11288','2013-02-21','14:30:00',1.57),('11288','2013-02-21','14:35:00',1.58),('11288','2013-02-21','14:40:00',1.52),('11288','2013-02-21','14:45:00',1.48),('11288','2013-02-21','14:50:00',1.41),('11288','2013-02-21','14:55:00',1.25),('11288','2013-02-21','15:00:00',1.11),('11288','2013-02-21','15:05:00',1.04),('11288','2013-02-21','15:10:00',1.07),('11288','2013-02-21','15:15:00',1.05),('11288','2013-02-21','15:20:00',1.02),('11288','2013-02-21','15:25:00',1.01),('11288','2013-02-21','15:30:00',1.04),('11288','2013-02-21','15:35:00',1.02),('11288','2013-02-21','15:40:00',1.08),('11288','2013-02-21','15:45:00',1.19),('11288','2013-02-21','15:50:00',1.36),('11288','2013-02-21','15:55:00',1.51),('11288','2013-02-21','16:00:00',1.64),('11288','2013-02-21','16:05:00',1.69),('11288','2013-02-21','16:10:00',1.47),('11288','2013-02-21','16:15:00',1.56),('11288','2013-02-21','16:20:00',1.97),('11288','2013-02-21','16:25:00',2.09),('11288','2013-02-21','16:30:00',1.86),('11288','2013-02-21','16:35:00',1.55),('11288','2013-02-21','16:40:00',1.25),('11288','2014-03-23','08:05:00',1.16),('11288','2014-03-23','08:10:00',1.25),('11288','2014-03-23','08:15:00',1.22),('11288','2014-03-23','08:20:00',1.37),('11288','2014-03-23','08:25:00',1.51),('11288','2014-03-23','08:30:00',1.7),('11288','2014-03-23','08:35:00',1.75),('11288','2014-03-23','08:40:00',1.36),('11288','2014-03-23','08:45:00',1.52),('11288','2014-03-23','08:50:00',1.93),('11288','2014-03-23','08:55:00',2.3),('11288','2014-03-23','09:00:00',1.7),('11288','2014-03-23','09:05:00',2.61),('11288','2014-03-23','09:10:00',4),('11288','2014-03-23','09:15:00',3.98),('11288','2014-03-23','09:20:00',2.85),('11288','2014-03-23','09:25:00',1.89),('11288','2014-03-23','09:30:00',2.5),('11288','2014-03-23','09:35:00',2.59),('11288','2014-03-23','09:40:00',2.21),('11288','2014-03-23','09:45:00',1.63),('11288','2014-03-23','09:50:00',1.49),('11288','2014-03-23','09:55:00',1.37),('11288','2014-03-23','10:00:00',1.28),('11288','2014-03-23','10:05:00',1.27),('11288','2014-03-23','10:10:00',1.38),('11288','2014-03-23','10:15:00',1.09),('11288','2014-03-23','10:20:00',1.35),('11288','2014-03-23','10:25:00',2.2),('11288','2014-03-23','10:30:00',1.6),('11288','2014-03-23','10:35:00',1.38),('11288','2014-03-23','10:40:00',2.25),('11288','2014-03-23','10:45:00',2.07),('11288','2014-03-23','10:50:00',2.4),('11288','2014-03-23','10:55:00',2.98),('11288','2014-03-23','11:00:00',2.17),('11288','2014-03-23','11:05:00',1.88),('11288','2014-03-23','11:10:00',2.44),('11288','2014-03-23','11:15:00',1.4),('11288','2014-03-23','11:20:00',1.45),('11288','2014-03-23','11:25:00',1.8),('11288','2014-03-23','11:30:00',1.44),('11288','2014-03-23','11:35:00',3.04),('11288','2014-03-23','11:40:00',5.97),('11288','2014-03-23','11:45:00',1.57),('11288','2014-03-23','11:55:00',1.55),('11288','2014-03-23','12:00:00',1.62),('11288','2014-03-23','12:30:00',1.16),('11288','2014-03-23','12:35:00',1.25),('11288','2014-03-23','13:10:00',1.03),('11288','2014-03-23','13:15:00',1.04),('11288','2014-03-23','13:40:00',1.95),('11288','2014-03-23','13:45:00',3.85),('11288','2014-03-23','13:50:00',2.79),('11288','2014-03-23','13:55:00',2.28),('11288','2014-03-23','14:00:00',1.59),('11288','2014-03-23','14:05:00',1.14),('11288','2014-03-23','14:15:00',1.28),('11288','2014-03-23','14:50:00',1.72),('11288','2014-03-23','14:55:00',1.45),('11288','2014-03-23','15:00:00',1.3),('11288','2014-03-23','15:05:00',1.83),('11288','2014-03-23','15:10:00',2.43),('11288','2014-03-23','15:15:00',2.62),('11288','2014-03-23','15:20:00',2.8),('11288','2014-03-23','15:25:00',2.74),('11288','2014-03-23','15:30:00',1.97),('11288','2014-03-23','15:35:00',1.6),('11288','2014-03-23','15:40:00',1.81),('11288','2013-02-20','08:20:00',1.23),('11288','2013-02-20','08:25:00',1.55),('11288','2013-02-20','08:30:00',1.68),('11288','2013-02-20','08:35:00',1.79),('11288','2013-02-20','08:40:00',1.98),('11288','2013-02-20','08:45:00',2.1),('11288','2013-02-20','08:50:00',2.24),('11288','2013-02-20','08:55:00',2.44),('11288','2013-02-20','09:00:00',2.55),('11288','2013-02-20','09:05:00',1.91),('11288','2013-02-20','09:10:00',2.58),('11288','2013-02-20','09:15:00',2.38),('11288','2013-02-20','09:20:00',2.36),('11288','2013-02-20','09:25:00',3.29),('11288','2013-02-20','09:30:00',2.17),('11288','2013-02-20','09:35:00',2.11),('11288','2013-02-20','09:40:00',1.84),('11288','2013-02-20','09:45:00',2.08),('11288','2013-02-20','09:50:00',2.6),('11288','2013-02-20','09:55:00',2.34),('11288','2013-02-20','10:00:00',2.3),('11288','2013-02-20','10:05:00',3.47),('11288','2013-02-20','10:10:00',2.16),('11288','2013-02-20','10:15:00',1.65),('11288','2013-02-20','10:20:00',1.44),('11288','2013-02-20','10:25:00',1.31),('11288','2013-02-20','10:30:00',1.1),('11288','2013-02-20','10:35:00',1.32),('11288','2013-02-20','10:40:00',1.73),('11288','2013-02-20','10:45:00',3.64),('11288','2013-02-20','10:50:00',3.87),('11288','2013-02-20','10:55:00',1.72),('11288','2013-02-20','11:00:00',1.48),('11288','2013-02-20','11:05:00',4.73),('11288','2013-02-20','11:10:00',5.77),('11288','2013-02-20','11:15:00',4.66),('11288','2013-02-20','11:20:00',5.2),('11288','2013-02-20','11:25:00',2.77),('11288','2013-02-20','11:30:00',2.27),('11288','2013-02-20','11:35:00',6.76),('11288','2013-02-20','11:40:00',6.39),('11288','2013-02-20','11:45:00',6.58),('11288','2013-02-20','11:50:00',5.16),('11288','2013-02-20','11:55:00',6.49),('11288','2013-02-20','12:00:00',1.62),('11288','2013-02-20','12:05:00',2.1),('11288','2013-02-20','12:10:00',4.7),('11288','2013-02-20','12:15:00',4.38),('11288','2013-02-20','12:20:00',4),('11288','2013-02-20','12:25:00',6.89),('11288','2013-02-20','12:30:00',6.92),('11288','2013-02-20','12:35:00',2.48),('11288','2013-02-20','12:40:00',1.72),('11288','2013-02-20','12:45:00',1.95),('11288','2013-02-20','12:50:00',2.14),('11288','2013-02-20','12:55:00',4.61),('11288','2013-02-20','13:00:00',5.7),('11288','2013-02-20','13:05:00',5.18),('11288','2013-02-20','13:10:00',5.98),('11288','2013-02-20','13:15:00',6.3),('11288','2013-02-20','13:20:00',1.88),('11288','2013-02-20','13:25:00',2.68),('11288','2013-02-20','13:30:00',2.69),('11288','2013-02-20','13:35:00',2.72),('11288','2013-02-20','13:40:00',2.98),('11288','2013-02-20','13:45:00',2.43),('11288','2013-02-20','13:50:00',2.17),('11288','2013-02-20','13:55:00',2.77),('11288','2013-02-20','14:00:00',2.09),('11288','2013-02-20','14:05:00',1.71),('11288','2013-02-20','14:10:00',1.67),('11288','2013-02-20','14:15:00',1.44),('11288','2013-02-20','14:20:00',1.19),('11288','2013-02-20','14:25:00',1.17),('11288','2013-02-20','14:30:00',1.58),('11288','2013-02-20','14:35:00',1.96),('11288','2013-02-20','14:40:00',2.39),('11288','2013-02-20','14:45:00',1.81),('11288','2013-02-20','14:50:00',1.69),('11288','2013-02-20','14:55:00',1.64),('11288','2013-02-20','15:00:00',1.65),('11288','2013-02-20','15:05:00',2.99),('11288','2013-02-20','15:10:00',3.63),('11288','2013-02-20','15:15:00',4.15),('11288','2013-02-20','15:20:00',3.86),('11288','2013-02-20','15:25:00',3.38),('11288','2013-02-20','15:30:00',2.59),('11288','2013-02-20','15:35:00',1.45),('11288','2013-02-20','15:40:00',1.08),('11288','2013-02-20','15:45:00',1.18),('11288','2013-02-20','15:50:00',1.44),('11288','2013-02-20','15:55:00',1.55),('11288','2013-02-20','16:00:00',1.53),('11288','2013-02-20','16:05:00',2.51),('11288','2013-02-20','16:10:00',2.43),('11288','2013-02-20','16:15:00',2.26),('11288','2013-02-20','16:20:00',1.93),('11288','2013-02-20','16:25:00',1.57),('11288','2013-02-20','16:30:00',1.18),('11288','2013-02-20','16:35:00',1.1),('11288','2013-02-19','08:10:00',1.1),('11288','2013-02-19','08:15:00',1.21),('11288','2013-02-19','08:20:00',1.2),('11288','2013-02-19','08:25:00',1.48),('11288','2013-02-19','08:30:00',1.65),('11288','2013-02-19','08:35:00',1.78),('11288','2013-02-19','08:40:00',1.93),('11288','2013-02-19','08:45:00',2.04),('11288','2013-02-19','08:50:00',2.17),('11288','2013-02-19','08:55:00',2.35),('11288','2013-02-19','09:00:00',2.45),('11288','2013-02-19','09:05:00',2.57),('11288','2013-02-19','09:10:00',2.58),('11288','2013-02-19','09:15:00',2.66),('11288','2013-02-19','09:20:00',2.89),('11288','2013-02-19','09:25:00',3.08),('11288','2013-02-19','09:30:00',3.25),('11288','2013-02-19','09:35:00',3.36),('11288','2013-02-19','09:40:00',3.46),('11288','2013-02-19','09:45:00',3.54),('11288','2013-02-19','09:50:00',3.55),('11288','2013-02-19','09:55:00',3.8),('11288','2013-02-19','10:00:00',3.94),('11288','2013-02-19','10:05:00',4.06),('11288','2013-02-19','10:10:00',4.16),('11288','2013-02-19','10:15:00',4.1),('11288','2013-02-19','10:20:00',4.37),('11288','2013-02-19','10:25:00',4.49),('11288','2013-02-19','10:30:00',4.54),('11288','2013-02-19','10:35:00',4.6),('11288','2013-02-19','10:40:00',4.63),('11288','2013-02-19','10:45:00',4.71),('11288','2013-02-19','10:50:00',4.78),('11288','2013-02-19','10:55:00',4.87),('11288','2013-02-19','11:00:00',4.93),('11288','2013-02-19','11:05:00',4.92),('11288','2013-02-19','11:10:00',4.96),('11288','2013-02-19','11:15:00',5.16),('11288','2013-02-19','11:20:00',5.19),('11288','2013-02-19','11:25:00',5.21),('11288','2013-02-19','11:30:00',5.33),('11288','2013-02-19','11:35:00',5.36),('11288','2013-02-19','11:40:00',5.34),('11288','2013-02-19','11:45:00',5.22),('11288','2013-02-19','11:50:00',5.13),('11288','2013-02-19','11:55:00',5.41),('11288','2013-02-19','12:00:00',5.26),('11288','2013-02-19','12:05:00',5.26),('11288','2013-02-19','12:10:00',5.44),('11288','2013-02-19','12:15:00',5.41),('11288','2013-02-19','12:20:00',5.38),('11288','2013-02-19','12:25:00',5.35),('11288','2013-02-19','12:30:00',5.34),('11288','2013-02-19','12:35:00',5.41),('11288','2013-02-19','12:40:00',5.39),('11288','2013-02-19','12:45:00',5.34),('11288','2013-02-19','12:50:00',5.37),('11288','2013-02-19','12:55:00',5.38),('11288','2013-02-19','13:00:00',5.35),('11288','2013-02-19','13:05:00',5.32),('11288','2013-02-19','13:10:00',5.28),('11288','2013-02-19','13:15:00',5.25),('11288','2013-02-19','13:20:00',5.22),('11288','2013-02-19','13:25:00',5.14),('11288','2013-02-19','13:30:00',5.09),('11288','2013-02-19','13:35:00',5.02),('11288','2013-02-19','13:40:00',4.98),('11288','2013-02-19','13:45:00',4.89),('11288','2013-02-19','13:50:00',4.82),('11288','2013-02-19','13:55:00',4.82),('11288','2013-02-19','14:00:00',4.7),('11288','2013-02-19','14:05:00',4.6),('11288','2013-02-19','14:10:00',4.32),('11288','2013-02-19','14:15:00',4.2),('11288','2013-02-19','14:20:00',4.22),('11288','2013-02-19','14:25:00',4.1),('11288','2013-02-19','14:30:00',3.99),('11288','2013-02-19','14:35:00',3.57),('11288','2013-02-19','14:40:00',3.89),('11288','2013-02-19','14:45:00',3.87),('11288','2013-02-19','14:50:00',3.74),('11288','2013-02-19','14:55:00',3.63),('11288','2013-02-19','15:00:00',3.52),('11288','2013-02-19','15:05:00',3.38),('11288','2013-02-19','15:10:00',3.3),('11288','2013-02-19','15:15:00',3.23),('11288','2013-02-19','15:20:00',3.06),('11288','2013-02-19','15:25:00',2.84),('11288','2013-02-19','15:30:00',2.72),('11288','2013-02-19','15:35:00',2.58),('11288','2013-02-19','15:40:00',2.5),('11288','2013-02-19','15:45:00',2.36),('11288','2013-02-19','15:50:00',2.09),('11288','2013-02-19','15:55:00',2.08),('11288','2013-02-19','16:00:00',1.95),('11288','2013-02-19','16:05:00',1.81),('11288','2013-02-19','16:10:00',1.65),('11288','2013-02-19','16:15:00',1.54),('11288','2013-02-19','16:20:00',1.41),('11288','2013-02-19','16:25:00',1.27),('11288','2013-02-19','16:30:00',1.17),('11288','2013-02-19','16:35:00',1.06),('11288','2013-02-18','08:10:00',1.07),('11288','2013-02-18','08:15:00',1.18),('11288','2013-02-18','08:20:00',1.26),('11288','2013-02-18','08:25:00',1.25),('11288','2013-02-18','08:30:00',1.52),('11288','2013-02-18','08:35:00',1.65),('11288','2013-02-18','08:40:00',1.78),('11288','2013-02-18','08:45:00',1.93),('11288','2013-02-18','08:50:00',2.05),('11288','2013-02-18','08:55:00',2.18),('11288','2013-02-18','09:00:00',2.33),('11288','2013-02-18','09:05:00',2.42),('11288','2013-02-18','09:10:00',2.4),('11288','2013-02-18','09:15:00',2.62),('11288','2013-02-18','09:20:00',2.67),('11288','2013-02-18','09:25:00',3.34),('11288','2013-02-18','09:30:00',2.03),('11288','2013-02-18','09:35:00',2.06),('11288','2013-02-18','09:40:00',1.47),('11288','2013-02-18','09:45:00',1.79),('11288','2013-02-18','09:50:00',1.79),('11288','2013-02-18','09:55:00',1.44),('11288','2013-02-18','10:00:00',1.37),('11288','2013-02-18','10:05:00',1.86),('11288','2013-02-18','10:30:00',1.17),('11288','2013-02-18','10:35:00',1.35),('11288','2013-02-18','10:40:00',1.55),('11288','2013-02-18','10:45:00',1.45),('11288','2013-02-18','10:50:00',1.31),('11288','2013-02-18','10:55:00',1.86),('11288','2013-02-18','11:00:00',2.16),('11288','2013-02-18','11:05:00',2.24),('11288','2013-02-18','11:10:00',2.37),('11288','2013-02-18','11:15:00',2.14),('11288','2013-02-18','11:20:00',2.71),('11288','2013-02-18','11:25:00',2.7),('11288','2013-02-18','11:30:00',2.54),('11288','2013-02-18','11:35:00',2.67),('11288','2013-02-18','11:40:00',2.57),('11288','2013-02-18','11:45:00',2.4),('11288','2013-02-18','11:50:00',2.59),('11288','2013-02-18','11:55:00',3.36),('11288','2013-02-18','12:00:00',3.51),('11288','2013-02-18','12:05:00',2.9),('11288','2013-02-18','12:10:00',2.68),('11288','2013-02-18','12:15:00',2.61),('11288','2013-02-18','12:20:00',2.56),('11288','2013-02-18','12:25:00',2.65),('11288','2013-02-18','12:30:00',2.41),('11288','2013-02-18','12:35:00',2.29),('11288','2013-02-18','12:40:00',2.41),('11288','2013-02-18','12:45:00',2.86),('11288','2013-02-18','12:50:00',2.79),('11288','2013-02-18','12:55:00',2.58),('11288','2013-02-18','13:00:00',2.58),('11288','2013-02-18','13:05:00',2.6),('11288','2013-02-18','13:10:00',2.51),('11288','2013-02-18','13:15:00',3.06),('11288','2013-02-18','13:20:00',2.48),('11288','2013-02-18','13:25:00',2.73),('11288','2013-02-18','13:30:00',2.57),('11288','2013-02-18','13:35:00',2.35),('11288','2013-02-18','13:40:00',2.36),('11288','2013-02-18','13:45:00',2.14),('11288','2013-02-18','13:50:00',2.2),('11288','2013-02-18','13:55:00',2.58),('11288','2013-02-18','14:00:00',2.6),('11288','2013-02-18','14:05:00',2.36),('11288','2013-02-18','14:10:00',2.08),('11288','2013-02-18','14:15:00',1.85),('11288','2013-02-18','14:20:00',1.96),('11288','2013-02-18','14:25:00',1.36),('11288','2013-02-18','14:30:00',1.06),('11288','2013-02-18','14:35:00',1.05),('11288','2013-02-18','14:40:00',1.09),('11288','2013-02-18','14:45:00',1.02),('11288','2013-02-18','15:00:00',1.09),('11288','2013-02-18','15:05:00',1.35),('11288','2013-02-18','15:10:00',1.16),('11288','2013-02-18','15:35:00',1.19),('11288','2013-02-18','15:40:00',1.13),('11288','2013-02-17','08:10:00',1.01),('11288','2013-02-17','08:15:00',1.16),('11288','2013-02-17','08:20:00',1.17),('11288','2013-02-17','08:25:00',1.42),('11288','2013-02-17','08:30:00',1.62),('11288','2013-02-17','08:35:00',1.83),('11288','2013-02-17','08:40:00',2),('11288','2013-02-17','08:45:00',2.02),('11288','2013-02-17','08:50:00',1.82),('11288','2013-02-17','08:55:00',2.17),('11288','2013-02-17','09:00:00',2.27),('11288','2013-02-17','09:05:00',2.22),('11288','2013-02-17','09:10:00',2.37),('11288','2013-02-17','09:15:00',2.59),('11288','2013-02-17','09:20:00',2.71),('11288','2013-02-17','09:25:00',2.82),('11288','2013-02-17','09:30:00',2.92),('11288','2013-02-17','09:35:00',3.02),('11288','2013-02-17','09:40:00',3.19),('11288','2013-02-17','09:45:00',3.29),('11288','2013-02-17','09:50:00',3.29),('11288','2013-02-17','09:55:00',3.48),('11288','2013-02-17','10:00:00',3.66),('11288','2013-02-17','10:05:00',3.77),('11288','2013-02-17','10:10:00',3.89),('11288','2013-02-17','10:15:00',3.79),('11288','2013-02-17','10:20:00',4.08),('11288','2013-02-17','10:25:00',4.17),('11288','2013-02-17','10:30:00',4.28),('11288','2013-02-17','10:35:00',4.37),('11288','2013-02-17','10:40:00',4.34),('11288','2013-02-17','10:45:00',4.46),('11288','2013-02-17','10:50:00',4.58),('11288','2013-02-17','10:55:00',4.65),('11288','2013-02-17','11:00:00',4.69),('11288','2013-02-17','11:05:00',4.69),('11288','2013-02-17','11:10:00',4.73),('11288','2013-02-17','11:15:00',4.93),('11288','2013-02-17','11:20:00',5.02),('11288','2013-02-17','11:25:00',5.07),('11288','2013-02-17','11:30:00',5.04),('11288','2013-02-17','11:35:00',5.08),('11288','2013-02-17','11:40:00',5.14),('11288','2013-02-17','11:45:00',5.09),('11288','2013-02-17','11:50:00',4.75),('11288','2013-02-17','11:55:00',5.02),('11288','2013-02-17','12:00:00',5.23),('11288','2013-02-17','12:05:00',5.21),('11288','2013-02-17','12:10:00',5.19),('11288','2013-02-17','12:15:00',5.23),('11288','2013-02-17','12:20:00',5.09),('11288','2013-02-17','12:25:00',5.2),('11288','2013-02-17','12:30:00',5.16),('11288','2013-02-17','12:35:00',5.15),('11288','2013-02-17','12:40:00',5.07),('11288','2013-02-17','12:45:00',5.13),('11288','2013-02-17','12:50:00',5.14),('11288','2013-02-17','12:55:00',5.16),('11288','2013-02-17','13:00:00',4.45),('11288','2013-02-17','13:05:00',3.32),('11288','2013-02-17','13:10:00',3.54),('11288','2013-02-17','13:15:00',3.45),('11288','2013-02-17','13:20:00',1.18),('11288','2013-02-17','13:25:00',3.3),('11288','2013-02-17','13:30:00',3.05),('11288','2013-02-17','13:35:00',1.42),('11288','2013-02-17','13:40:00',3.55),('11288','2013-02-17','13:45:00',4.26),('11288','2013-02-17','13:50:00',3.8),('11288','2013-02-17','13:55:00',2.54),('11288','2013-02-17','14:00:00',1.05),('11288','2013-02-17','14:05:00',2.18),('11288','2013-02-17','14:10:00',3.6),('11288','2013-02-17','14:15:00',2.1),('11288','2013-02-17','14:20:00',2.17),('11288','2013-02-17','14:25:00',3.26),('11288','2013-02-17','14:30:00',4.09),('11288','2013-02-17','14:35:00',3.16),('11288','2013-02-17','14:40:00',1.96),('11288','2013-02-17','14:45:00',1.02),('11288','2013-02-17','14:50:00',1.18),('11288','2013-02-17','14:55:00',1.7),('11288','2013-02-17','15:00:00',3.41),('11288','2013-02-17','15:05:00',3.78),('11288','2013-02-17','15:10:00',3.9),('11288','2013-02-17','15:15:00',3.66),('11288','2013-02-17','15:20:00',3.5),('11288','2013-02-17','15:25:00',3.17),('11288','2013-02-17','15:30:00',2.97),('11288','2013-02-17','15:35:00',2.94),('11288','2013-02-17','15:40:00',2.86),('11288','2013-02-17','15:45:00',2.61),('11288','2013-02-17','15:50:00',2.38),('11288','2013-02-17','15:55:00',2.13),('11288','2013-02-17','16:00:00',2.09),('11288','2013-02-17','16:05:00',1.9),('11288','2013-02-17','16:20:00',1.39),('11288','2013-02-17','16:25:00',1.8),('11288','2013-02-17','16:30:00',1.79),('11288','2013-02-17','16:35:00',1.26),('11288','2013-02-16','08:15:00',1.04),('11288','2013-02-16','08:20:00',1.08),('11288','2013-02-16','08:25:00',1.18),('11288','2013-02-16','08:30:00',1.41),('11288','2013-02-16','08:35:00',1.53),('11288','2013-02-16','08:40:00',1.67),('11288','2013-02-16','08:45:00',1.83),('11288','2013-02-16','09:05:00',1.64),('11288','2013-02-16','09:10:00',1.11),('11288','2013-02-16','09:15:00',2.4),('11288','2013-02-16','09:20:00',2.85),('11288','2013-02-16','09:25:00',2.87),('11288','2013-02-16','09:30:00',3.03),('11288','2013-02-16','09:35:00',3.2),('11288','2013-02-16','09:40:00',3.26),('11288','2013-02-16','09:45:00',3.36),('11288','2013-02-16','09:50:00',3.51),('11288','2013-02-16','09:55:00',3.6),('11288','2013-02-16','10:00:00',3.71),('11288','2013-02-16','10:05:00',3.8),('11288','2013-02-16','10:10:00',3.93),('11288','2013-02-16','10:15:00',3.97),('11288','2013-02-16','10:20:00',4.16),('11288','2013-02-16','10:25:00',4.29),('11288','2013-02-16','10:30:00',4.34),('11288','2013-02-16','10:35:00',4.43),('11288','2013-02-16','10:40:00',4.47),('11288','2013-02-16','10:45:00',4.6),('11288','2013-02-16','10:50:00',4.01),('11288','2013-02-16','10:55:00',4.22),('11288','2013-02-16','11:00:00',4.9),('11288','2013-02-16','11:05:00',4.77),('11288','2013-02-16','11:10:00',4.74),('11288','2013-02-16','11:15:00',4.89),('11288','2013-02-16','11:20:00',5.01),('11288','2013-02-16','11:25:00',5.08),('11288','2013-02-16','11:30:00',5.16),('11288','2013-02-16','11:35:00',5.19),('11288','2013-02-16','11:40:00',5.25),('11288','2013-02-16','11:45:00',5.24),('11288','2013-02-16','11:50:00',5.33),('11288','2013-02-16','11:55:00',5.34),('11288','2013-02-16','12:00:00',5.31),('11288','2013-02-16','12:05:00',5.37),('11288','2013-02-16','12:10:00',5.31),('11288','2013-02-16','12:15:00',5.35),('11288','2013-02-16','12:20:00',5.31),('11288','2013-02-16','12:25:00',5.29),('11288','2013-02-16','12:30:00',5.29),('11288','2013-02-16','12:35:00',5.32),('11288','2013-02-16','12:40:00',5.3),('11288','2013-02-16','12:45:00',5.3),('11288','2013-02-16','12:50:00',5.34),('11288','2013-02-16','12:55:00',5.31),('11288','2013-02-16','13:00:00',5.28),('11288','2013-02-16','13:05:00',5.26),('11288','2013-02-16','13:10:00',5.2),('11288','2013-02-16','13:15:00',5.18),('11288','2013-02-16','13:20:00',5.05),('11288','2013-02-16','13:25:00',5.05),('11288','2013-02-16','13:30:00',5),('11288','2013-02-16','13:35:00',4.95),('11288','2013-02-16','13:40:00',4.89),('11288','2013-02-16','13:45:00',4.98),('11288','2013-02-16','13:50:00',4.41),('11288','2013-02-16','13:55:00',4.87),('11288','2013-02-16','14:00:00',4.76),('11288','2013-02-16','14:05:00',4.66),('11288','2013-02-16','14:10:00',4.54),('11288','2013-02-16','14:15:00',4.52),('11288','2013-02-16','14:20:00',3.58),('11288','2013-02-16','14:25:00',1.57),('11288','2013-02-16','14:30:00',1.56),('11288','2013-02-16','14:35:00',1.66),('11288','2013-02-16','14:40:00',1.69),('11288','2013-02-16','14:45:00',1.84),('11288','2013-02-16','14:50:00',1.75),('11288','2013-02-16','14:55:00',1.71),('11288','2013-02-16','15:00:00',1.45),('11288','2013-02-16','15:05:00',1.47),('11288','2013-02-16','15:10:00',1.54),('11288','2013-02-16','15:15:00',1.7),('11288','2013-02-16','15:20:00',1.84),('11288','2013-02-16','15:25:00',1.93),('11288','2013-02-16','15:30:00',2.93),('11288','2013-02-16','15:35:00',3.28),('11288','2013-02-16','15:40:00',3.1),('11288','2013-02-16','15:45:00',2.07),('11288','2013-02-16','15:50:00',2.49),('11288','2013-02-16','15:55:00',2.2),('11288','2013-02-16','16:00:00',1.49),('11288','2013-02-16','16:05:00',1.82),('11288','2013-02-16','16:10:00',1.25),('11288','2013-02-16','16:15:00',1.08),('11288','2013-02-16','16:20:00',1.21),('11288','2013-02-16','16:25:00',1.19),('11288','2013-02-15','08:10:00',1.07),('11288','2013-02-15','08:15:00',1.05),('11288','2013-02-15','08:55:00',1.24),('11288','2013-02-15','09:00:00',1.29),('11288','2013-02-15','09:05:00',1.22),('11288','2013-02-15','09:10:00',1.22),('11288','2013-02-15','09:15:00',1.56),('11288','2013-02-15','09:20:00',2.33),('11288','2013-02-15','09:25:00',2.27),('11288','2013-02-15','09:30:00',1.79),('11288','2013-02-15','09:35:00',1.69),('11288','2013-02-15','09:40:00',1.58),('11288','2013-02-15','09:45:00',1.5),('11288','2013-02-15','09:50:00',1.89),('11288','2013-02-15','09:55:00',2.26),('11288','2013-02-15','10:00:00',2.79),('11288','2013-02-15','10:05:00',2.72),('11288','2013-02-15','10:10:00',1.92),('11288','2013-02-15','10:15:00',2.15),('11288','2013-02-15','10:20:00',2.66),('11288','2013-02-15','10:25:00',3.22),('11288','2013-02-15','10:30:00',3.32),('11288','2013-02-15','10:35:00',4.3),('11288','2013-02-15','10:40:00',3.99),('11288','2013-02-15','10:45:00',4.31),('11288','2013-02-15','10:50:00',4.56),('11288','2013-02-15','10:55:00',2.78),('11288','2013-02-15','11:00:00',2.97),('11288','2013-02-15','11:05:00',3.36),('11288','2013-02-15','11:10:00',3.07),('11288','2013-02-15','11:15:00',4.56),('11288','2013-02-15','11:20:00',4.79),('11288','2013-02-15','11:25:00',5.25),('11288','2013-02-15','11:30:00',4.89),('11288','2013-02-15','11:35:00',3.75),('11288','2013-02-15','11:40:00',3.04),('11288','2013-02-15','11:45:00',4.01),('11288','2013-02-15','11:50:00',5.4),('11288','2013-02-15','11:55:00',4.47),('11288','2013-02-15','12:00:00',4.4),('11288','2013-02-15','12:05:00',4.99),('11288','2013-02-15','12:10:00',5.31),('11288','2013-02-15','12:15:00',5.37),('11288','2013-02-15','12:20:00',5.82),('11288','2013-02-15','12:25:00',5.41),('11288','2013-02-15','12:30:00',5.44),('11288','2013-02-15','12:35:00',5.34),('11288','2013-02-15','12:40:00',5.28),('11288','2013-02-15','12:45:00',5.26),('11288','2013-02-15','12:50:00',4.99),('11288','2013-02-15','12:55:00',5.24),('11288','2013-02-15','13:00:00',5.15),('11288','2013-02-15','13:05:00',5.15),('11288','2013-02-15','13:10:00',5.22),('11288','2013-02-15','13:15:00',5.1),('11288','2013-02-15','13:20:00',4.94),('11288','2013-02-15','13:25:00',4.48),('11288','2013-02-15','13:30:00',3.51),('11288','2013-02-15','13:35:00',3.54),('11288','2013-02-15','13:40:00',4.7),('11288','2013-02-15','13:45:00',3.91),('11288','2013-02-15','13:50:00',4.32),('11288','2013-02-15','13:55:00',3.73),('11288','2013-02-15','14:00:00',3.34),('11288','2013-02-15','14:05:00',5.32),('11288','2013-02-15','14:10:00',5.16),('11288','2013-02-15','14:15:00',3.6),('11288','2013-02-15','14:20:00',3.62),('11288','2013-02-15','14:25:00',2.43),('11288','2013-02-15','14:30:00',2.3),('11288','2013-02-15','14:35:00',3.7),('11288','2013-02-15','14:40:00',4.16),('11288','2013-02-15','14:45:00',2.98),('11288','2013-02-15','14:50:00',2.09),('11288','2013-02-15','14:55:00',1.83),('11288','2013-02-15','15:00:00',2.73),('11288','2013-02-15','15:05:00',1.95),('11288','2013-02-15','15:10:00',2.04),('11288','2013-02-15','15:15:00',2.24),('11288','2013-02-15','15:20:00',1.86),('11288','2013-02-15','15:25:00',2.18),('11288','2013-02-15','15:30:00',2.27),('11288','2013-02-15','15:35:00',1.96),('11288','2013-02-15','15:40:00',2.03),('11288','2013-02-15','15:45:00',1.77),('11288','2013-02-15','15:50:00',1.47),('11288','2013-02-15','15:55:00',1.38),('11288','2013-02-15','16:00:00',1.3),('11288','2013-02-15','16:05:00',1.24),('11288','2013-02-15','16:10:00',1.15),('11288','2013-02-15','16:15:00',1.01),('11288','2013-02-14','08:15:00',1),('11288','2013-02-14','08:20:00',1.19),('11288','2013-02-14','08:25:00',1.31),('11288','2013-02-14','08:30:00',1.34),('11288','2013-02-14','08:35:00',1.56),('11288','2013-02-14','08:40:00',1.71),('11288','2013-02-14','08:45:00',1.85),('11288','2013-02-14','08:50:00',1.99),('11288','2013-02-14','08:55:00',2.14),('11288','2013-02-14','09:00:00',2.21),('11288','2013-02-14','09:05:00',2.37),('11288','2013-02-14','09:10:00',2.44),('11288','2013-02-14','09:15:00',2.57),('11288','2013-02-14','09:20:00',2.74),('11288','2013-02-14','09:25:00',2.87),('11288','2013-02-14','09:30:00',2.97),('11288','2013-02-14','09:35:00',3.18),('11288','2013-02-14','09:40:00',3.26),('11288','2013-02-14','09:45:00',3.27),('11288','2013-02-14','09:50:00',3.55),('11288','2013-02-14','09:55:00',3.69),('11288','2013-02-14','10:00:00',3.78),('11288','2013-02-14','10:05:00',3.93),('11288','2013-02-14','10:10:00',4.02),('11288','2013-02-14','10:15:00',4.02),('11288','2013-02-14','10:20:00',4.28),('11288','2013-02-14','10:25:00',4.36),('11288','2013-02-14','10:30:00',4.47),('11288','2013-02-14','10:35:00',4.53),('11288','2013-02-14','10:40:00',4.38),('11288','2013-02-14','10:45:00',4.61),('11288','2013-02-14','10:50:00',4.8),('11288','2013-02-14','10:55:00',4.86),('11288','2013-02-14','11:00:00',4.93),('11288','2013-02-14','11:05:00',4.93),('11288','2013-02-14','11:10:00',4.7),('11288','2013-02-14','11:15:00',4.51),('11288','2013-02-14','11:20:00',5.12),('11288','2013-02-14','11:25:00',5.2),('11288','2013-02-14','11:30:00',5.25),('11288','2013-02-14','11:35:00',5.27),('11288','2013-02-14','11:40:00',5.32),('11288','2013-02-14','11:45:00',5.21),('11288','2013-02-14','11:50:00',5.33),('11288','2013-02-14','11:55:00',5.37),('11288','2013-02-14','12:00:00',5.39),('11288','2013-02-14','12:05:00',5.4),('11288','2013-02-14','12:10:00',5.39),('11288','2013-02-14','12:15:00',5.43),('11288','2013-02-14','12:20:00',5.39),('11288','2013-02-14','12:25:00',5.38),('11288','2013-02-14','12:30:00',5.38),('11288','2013-02-14','12:35:00',5.38),('11288','2013-02-14','12:40:00',5.36),('11288','2013-02-14','12:45:00',5.32),('11288','2013-02-14','12:50:00',5.29),('11288','2013-02-14','12:55:00',5.27),('11288','2013-02-14','13:00:00',5.26),('11288','2013-02-14','13:05:00',5.22),('11288','2013-02-14','13:10:00',5.2),('11288','2013-02-14','13:15:00',5.18),('11288','2013-02-14','13:20:00',5.1),('11288','2013-02-14','13:25:00',5.08),('11288','2013-02-14','13:30:00',5.03),('11288','2013-02-14','13:35:00',4.99),('11288','2013-02-14','13:40:00',4.93),('11288','2013-02-14','13:45:00',4.84),('11288','2013-02-14','13:50:00',4.74),('11288','2013-02-14','13:55:00',4.65),('11288','2013-02-14','14:00:00',4.59),('11288','2013-02-14','14:05:00',4.55),('11288','2013-02-14','14:10:00',4.44),('11288','2013-02-14','14:15:00',4.35),('11288','2013-02-14','14:20:00',4.25),('11288','2013-02-14','14:25:00',4.17),('11288','2013-02-14','14:30:00',4.05),('11288','2013-02-14','14:35:00',3.93),('11288','2013-02-14','14:40:00',3.89),('11288','2013-02-14','14:45:00',3.79),('11288','2013-02-14','14:50:00',3.64),('11288','2013-02-14','14:55:00',3.51),('11288','2013-02-14','15:00:00',3.39),('11288','2013-02-14','15:05:00',3.24),('11288','2013-02-14','15:10:00',3.15),('11288','2013-02-14','15:15:00',3.03),('11288','2013-02-14','15:20:00',2.87),('11288','2013-02-14','15:25:00',2.73),('11288','2013-02-14','15:30:00',2.56),('11288','2013-02-14','15:35:00',2.39),('11288','2013-02-14','15:40:00',2.31),('11288','2013-02-14','15:45:00',2.17),('11288','2013-02-14','15:50:00',2.01),('11288','2013-02-14','15:55:00',1.77),('11288','2013-02-14','16:00:00',1.71),('11288','2013-02-14','16:05:00',1.6),('11288','2013-02-14','16:10:00',1.47),('11288','2013-02-14','16:15:00',1.31),('11288','2013-02-14','16:20:00',1.16),('11288','2013-02-14','16:25:00',1.09),('11288','2013-02-13','08:35:00',1.04),('11288','2013-02-13','08:40:00',1.08),('11288','2013-02-13','08:45:00',1.29),('11288','2013-02-13','08:50:00',1.41),('11288','2013-02-13','08:55:00',1.59),('11288','2013-02-13','09:00:00',1.76),('11288','2013-02-13','09:05:00',1.83),('11288','2013-02-13','09:10:00',1.85),('11288','2013-02-13','09:15:00',1.87),('11288','2013-02-13','09:20:00',1.82),('11288','2013-02-13','09:25:00',1.95),('11288','2013-02-13','09:30:00',2.31),('11288','2013-02-13','09:35:00',2.96),('11288','2013-02-13','09:40:00',2.93),('11288','2013-02-13','09:45:00',3.34),('11288','2013-02-13','09:50:00',3.4),('11288','2013-02-13','09:55:00',3.21),('11288','2013-02-13','10:00:00',3.41),('11288','2013-02-13','10:05:00',3.65),('11288','2013-02-13','10:10:00',3.95),('11288','2013-02-13','10:15:00',4.1),('11288','2013-02-13','10:20:00',4.24),('11288','2013-02-13','10:25:00',4.47),('11288','2013-02-13','10:30:00',4.68),('11288','2013-02-13','10:35:00',4.83),('11288','2013-02-13','10:40:00',4.54),('11288','2013-02-13','10:45:00',4.8),('11288','2013-02-13','10:50:00',5.1),('11288','2013-02-13','10:55:00',5.1),('11288','2013-02-13','11:00:00',5.08),('11288','2013-02-13','11:05:00',5.07),('11288','2013-02-13','11:10:00',4.84),('11288','2013-02-13','11:15:00',4.85),('11288','2013-02-13','11:20:00',4.65),('11288','2013-02-13','11:25:00',4.77),('11288','2013-02-13','11:30:00',4.61),('11288','2013-02-13','11:35:00',2.85),('11288','2013-02-13','11:40:00',2.32),('11288','2013-02-13','11:45:00',3.37),('11288','2013-02-13','11:50:00',3.53),('11288','2013-02-13','11:55:00',2.38),('11288','2013-02-13','12:00:00',2.3),('11288','2013-02-13','12:05:00',3.5),('11288','2013-02-13','12:10:00',4.22),('11288','2013-02-13','12:15:00',3.08),('11288','2013-02-13','12:20:00',3.9),('11288','2013-02-13','12:25:00',2.52),('11288','2013-02-13','12:30:00',1.95),('11288','2013-02-13','12:35:00',2.58),('11288','2013-02-13','12:40:00',2.56),('11288','2013-02-13','12:45:00',4.01),('11288','2013-02-13','12:50:00',4.29),('11288','2013-02-13','12:55:00',3.96),('11288','2013-02-13','13:00:00',4.46),('11288','2013-02-13','13:05:00',2.68),('11288','2013-02-13','13:10:00',2.94),('11288','2013-02-13','13:15:00',4.37),('11288','2013-02-13','13:20:00',5.1),('11288','2013-02-13','13:25:00',5.24),('11288','2013-02-13','13:30:00',5.27),('11288','2013-02-13','13:35:00',5.36),('11288','2013-02-13','13:40:00',4.89),('11288','2013-02-13','13:45:00',4.21),('11288','2013-02-13','13:50:00',4.07),('11288','2013-02-13','13:55:00',4.34),('11288','2013-02-13','14:00:00',4.37),('11288','2013-02-13','14:05:00',4.74),('11288','2013-02-13','14:10:00',4.58),('11288','2013-02-13','14:15:00',4.27),('11288','2013-02-13','14:20:00',4.03),('11288','2013-02-13','14:25:00',3.54),('11288','2013-02-13','14:30:00',3.96),('11288','2013-02-13','14:35:00',3.98),('11288','2013-02-13','14:40:00',3.99),('11288','2013-02-13','14:45:00',3.68),('11288','2013-02-13','14:50:00',3.66),('11288','2013-02-13','14:55:00',3.53),('11288','2013-02-13','15:00:00',3.39),('11288','2013-02-13','15:05:00',3.23),('11288','2013-02-13','15:10:00',3.11),('11288','2013-02-13','15:15:00',3),('11288','2013-02-13','15:20:00',2.82),('11288','2013-02-13','15:25:00',2.77),('11288','2013-02-13','15:30:00',2.62),('11288','2013-02-13','15:35:00',2.5),('11288','2013-02-13','15:40:00',2.29),('11288','2013-02-13','15:45:00',2.22),('11288','2013-02-13','15:50:00',2.04),('11288','2013-02-13','15:55:00',1.81),('11288','2013-02-13','16:00:00',1.73),('11288','2013-02-13','16:05:00',1.62),('11288','2013-02-13','16:10:00',1.51),('11288','2013-02-13','16:15:00',1.36),('11288','2013-02-13','16:20:00',1.23),('11288','2013-02-13','16:25:00',1.09),('11288','2013-02-12','12:10:00',1.07),('11288','2013-02-12','12:15:00',1.08),('11288','2013-02-12','12:20:00',1.06),('11288','2013-02-12','12:25:00',1.04),('11288','2013-02-12','12:30:00',1.05),('11288','2013-02-11','09:15:00',1.04),('11288','2013-02-11','09:20:00',1.01),('11288','2013-02-11','09:25:00',1.07),('11288','2013-02-11','09:30:00',1.34),('11288','2013-02-11','09:35:00',1.23),('11288','2013-02-11','10:00:00',1.05),('11288','2013-02-11','10:05:00',1.08),('11288','2013-02-11','10:10:00',1.17),('11288','2013-02-11','10:15:00',1.56),('11288','2013-02-11','10:20:00',1.86),('11288','2013-02-11','10:25:00',1.97),('11288','2013-02-11','10:30:00',2),('11288','2013-02-11','10:35:00',2.33),('11288','2013-02-11','10:40:00',2.01),('11288','2013-02-11','10:45:00',1.6),('11288','2013-02-11','10:50:00',1.33),('11288','2013-02-11','10:55:00',1.27),('11288','2013-02-11','11:00:00',1.85),('11288','2013-02-11','11:05:00',2.1),('11288','2013-02-11','11:10:00',2.57),('11288','2013-02-11','11:15:00',2.68),('11288','2013-02-11','11:20:00',2.03),('11288','2013-02-11','11:25:00',1.41),('11288','2013-02-11','11:35:00',1.18),('11288','2013-02-11','11:40:00',1.52),('11288','2013-02-11','11:45:00',2.29),('11288','2013-02-11','11:50:00',1.66),('11288','2013-02-11','11:55:00',1.05),('11288','2013-02-11','12:40:00',1.57),('11288','2013-02-11','12:45:00',2.4),('11288','2013-02-11','12:50:00',1.29),('11288','2013-02-11','12:55:00',1.26),('11288','2013-02-11','13:50:00',1.03),('11288','2013-02-11','13:55:00',1.69),('11288','2013-02-11','14:00:00',1.82),('11288','2013-02-11','14:05:00',1.97),('11288','2013-02-11','14:10:00',2.17),('11288','2013-02-11','14:15:00',1.8),('11288','2013-02-11','14:20:00',1.9),('11288','2013-02-11','14:25:00',2.85),('11288','2013-02-11','14:30:00',3.39),('11288','2013-02-11','14:35:00',2.17),('11288','2013-02-11','14:40:00',3),('11288','2013-02-11','14:45:00',2.37),('11288','2013-02-11','14:50:00',1.64),('11288','2013-02-11','14:55:00',1.39),('11288','2013-02-11','15:00:00',1.12),('11288','2013-02-11','15:05:00',1.53),('11288','2013-02-11','15:10:00',1.7),('11288','2013-02-11','15:15:00',1.15),('11288','2013-02-11','15:20:00',1.3),('11288','2013-02-11','15:25:00',1.21),('11288','2013-02-11','15:30:00',1.12),('11288','2013-02-11','15:35:00',1.19),('11288','2013-02-11','15:40:00',1.14),('11288','2013-02-11','15:45:00',1.32),('11288','2013-02-11','15:50:00',1.22),('11288','2014-03-22','07:35:00',1.53),('11288','2014-03-22','07:40:00',1.8),('11288','2014-03-22','07:45:00',1.96),('11288','2014-03-22','07:50:00',1.71),('11288','2014-03-22','07:55:00',1.05),('11288','2014-03-22','08:10:00',1.5),('11288','2014-03-22','08:15:00',1.99),('11288','2014-03-22','08:20:00',2.33),('11288','2014-03-22','08:25:00',2.39),('11288','2014-03-22','08:30:00',2.27),('11288','2014-03-22','08:35:00',1.67),('11288','2014-03-22','08:40:00',2.85),('11288','2014-03-22','08:45:00',3.23),('11288','2014-03-22','08:50:00',2.76),('11288','2014-03-22','08:55:00',3.34),('11288','2014-03-22','09:00:00',3.06),('11288','2014-03-22','09:05:00',2.33),('11288','2014-03-22','09:10:00',2.62),('11288','2014-03-22','09:15:00',2.21),('11288','2014-03-22','09:20:00',2.41),('11288','2014-03-22','09:25:00',3.21),('11288','2014-03-22','09:30:00',3.42),('11288','2014-03-22','09:35:00',2.17),('11288','2014-03-22','09:40:00',3.23),('11288','2014-03-22','09:45:00',4.7),('11288','2014-03-22','09:50:00',4.8),('11288','2014-03-22','09:55:00',4.81),('11288','2014-03-22','10:00:00',4.25),('11288','2014-03-22','10:05:00',3.06),('11288','2014-03-22','10:10:00',3.5),('11288','2014-03-22','10:15:00',3.14),('11288','2014-03-22','10:20:00',1.84),('11288','2014-03-22','10:25:00',1.57),('11288','2014-03-22','10:30:00',1.85),('11288','2014-03-22','10:35:00',2.76),('11288','2014-03-22','10:40:00',3.25),('11288','2014-03-22','10:45:00',4.16),('11288','2014-03-22','10:50:00',3.02),('11288','2014-03-22','10:55:00',2.26),('11288','2014-03-22','11:00:00',2.27),('11288','2014-03-22','11:05:00',1.98),('11288','2014-03-22','11:10:00',2.84),('11288','2014-03-22','11:15:00',3.26),('11288','2014-03-22','11:20:00',6.52),('11288','2014-03-22','11:25:00',7.21),('11288','2014-03-22','11:30:00',4.45),('11288','2014-03-22','11:35:00',4.22),('11288','2014-03-22','11:40:00',3.53),('11288','2014-03-22','11:45:00',2.5),('11288','2014-03-22','11:50:00',5.9),('11288','2014-03-22','11:55:00',6.49),('11288','2014-03-22','12:00:00',2.86),('11288','2014-03-22','12:05:00',2.33),('11288','2014-03-22','12:10:00',2.41),('11288','2014-03-22','12:15:00',4.86),('11288','2014-03-22','12:20:00',6.12),('11288','2014-03-22','12:25:00',2.6),('11288','2014-03-22','12:30:00',3.39),('11288','2014-03-22','12:35:00',3.85),('11288','2014-03-22','12:40:00',6.87),('11288','2014-03-22','12:45:00',4.6),('11288','2014-03-22','12:50:00',5.1),('11288','2014-03-22','12:55:00',3.54),('11288','2014-03-22','13:00:00',2.67),('11288','2014-03-22','13:05:00',6.49),('11288','2014-03-22','13:10:00',6.08),('11288','2014-03-22','13:15:00',6.01),('11288','2014-03-22','13:20:00',5.73),('11288','2014-03-22','13:25:00',4.6),('11288','2014-03-22','13:30:00',4.71),('11288','2014-03-22','13:35:00',5.18),('11288','2014-03-22','13:40:00',6.49),('11288','2014-03-22','13:45:00',4.98),('11288','2014-03-22','13:50:00',3.85),('11288','2014-03-22','13:55:00',4.9),('11288','2014-03-22','14:00:00',4.76),('11288','2014-03-22','14:05:00',4.71),('11288','2014-03-22','14:10:00',4.6),('11288','2014-03-22','14:15:00',3.76),('11288','2014-03-22','14:20:00',5.33),('11288','2014-03-22','14:25:00',5.18),('11288','2014-03-22','14:30:00',5.08),('11288','2014-03-22','14:35:00',4.97),('11288','2014-03-22','14:40:00',4.83),('11288','2014-03-22','14:45:00',4.69),('11288','2014-03-22','14:50:00',4.61),('11288','2014-03-22','14:55:00',4.49),('11288','2014-03-22','15:00:00',4.3),('11288','2014-03-22','15:05:00',4.25),('11288','2014-03-22','15:10:00',3.9),('11288','2014-03-22','15:15:00',4.01),('11288','2014-03-22','15:20:00',3.9),('11288','2014-03-22','15:25:00',2.97),('11288','2014-03-22','15:30:00',2.18),('11288','2014-03-22','15:35:00',3.54),('11288','2014-03-22','15:40:00',3.91),('11288','2014-03-22','15:45:00',3.98),('11288','2014-03-22','15:50:00',4.12),('11288','2014-03-22','15:55:00',3.61),('11288','2014-03-22','16:00:00',3.32),('11288','2014-03-22','16:05:00',2.87),('11288','2014-03-22','16:10:00',2.63),('11288','2014-03-22','16:15:00',2.41),('11288','2014-03-22','16:20:00',2.09),('11288','2014-03-22','16:25:00',1.9),('11288','2014-03-22','16:30:00',1.2),('11288','2014-03-22','16:40:00',1),('11288','2014-03-22','16:50:00',1.19),('11288','2014-03-22','16:55:00',1.3),('11288','2014-03-22','17:00:00',1.38),('11288','2013-02-10','09:05:00',1.05),('11288','2013-02-10','09:10:00',1.12),('11288','2013-02-10','09:15:00',1.25),('11288','2013-02-10','09:40:00',1.16),('11288','2013-02-10','09:45:00',2.23),('11288','2013-02-10','09:50:00',2.63),('11288','2013-02-10','09:55:00',1.45),('11288','2013-02-10','10:00:00',3.58),('11288','2013-02-10','10:05:00',3.76),('11288','2013-02-10','10:10:00',3.83),('11288','2013-02-10','10:15:00',4.03),('11288','2013-02-10','10:20:00',4.12),('11288','2013-02-10','10:25:00',4.24),('11288','2013-02-10','10:30:00',4.35),('11288','2013-02-10','10:35:00',4.31),('11288','2013-02-10','10:40:00',4.1),('11288','2013-02-10','10:45:00',4.45),('11288','2013-02-10','10:50:00',4.64),('11288','2013-02-10','10:55:00',4.72),('11288','2013-02-10','11:00:00',4.78),('11288','2013-02-10','11:05:00',4.75),('11288','2013-02-10','11:10:00',4.63),('11288','2013-02-10','11:15:00',4.86),('11288','2013-02-10','11:20:00',4.98),('11288','2013-02-10','11:25:00',5.05),('11288','2013-02-10','11:30:00',5.08),('11288','2013-02-10','11:35:00',5.12),('11288','2013-02-10','11:40:00',5.15),('11288','2013-02-10','11:45:00',5.05),('11288','2013-02-10','11:50:00',5.2),('11288','2013-02-10','11:55:00',5.21),('11288','2013-02-10','12:00:00',5.29),('11288','2013-02-10','12:05:00',5.3),('11288','2013-02-10','12:10:00',5.31),('11288','2013-02-10','12:15:00',5.37),('11288','2013-02-10','12:20:00',5.35),('11288','2013-02-10','12:25:00',5.34),('11288','2013-02-10','12:30:00',5.34),('11288','2013-02-10','12:35:00',5.31),('11288','2013-02-10','12:40:00',5.26),('11288','2013-02-10','12:45:00',5.22),('11288','2013-02-10','12:50:00',5.2),('11288','2013-02-10','12:55:00',5.18),('11288','2013-02-10','13:00:00',5.15),('11288','2013-02-10','13:05:00',5.03),('11288','2013-02-10','13:10:00',5.05),('11288','2013-02-10','13:15:00',4.98),('11288','2013-02-10','13:20:00',4.88),('11288','2013-02-10','13:25:00',4.88),('11288','2013-02-10','13:30:00',4.82),('11288','2013-02-10','13:35:00',4.77),('11288','2013-02-10','13:40:00',4.67),('11288','2013-02-10','13:45:00',4.54),('11288','2013-02-10','13:50:00',4.55),('11288','2013-02-10','13:55:00',4.41),('11288','2013-02-10','14:00:00',4.36),('11288','2013-02-10','14:05:00',4.37),('11288','2013-02-10','14:10:00',4.23),('11288','2013-02-10','14:15:00',4.16),('11288','2013-02-10','14:20:00',4.09),('11288','2013-02-10','14:25:00',3.99),('11288','2013-02-10','14:30:00',3.91),('11288','2013-02-10','14:35:00',3.5),('11288','2013-02-10','14:40:00',3.74),('11288','2013-02-10','14:45:00',3.4),('11288','2013-02-10','14:50:00',3.4),('11288','2013-02-10','14:55:00',2.88),('11288','2013-02-10','15:00:00',2.93),('11288','2013-02-10','15:05:00',3.03),('11288','2013-02-10','15:10:00',2.98),('11288','2013-02-10','15:15:00',2.75),('11288','2013-02-10','15:20:00',2.94),('11288','2013-02-10','15:25:00',3.21),('11288','2013-02-10','15:30:00',2.41),('11288','2013-02-10','15:35:00',2.75),('11288','2013-02-10','15:40:00',2.12),('11288','2013-02-10','15:45:00',1.1),('11288','2013-02-10','16:25:00',1.33),('11288','2013-02-10','16:30:00',1.34),('11288','2013-02-10','16:35:00',1.24),('11288','2013-02-09','09:10:00',1.06),('11288','2013-02-09','09:15:00',1.12),('11288','2013-02-09','09:20:00',1.15),('11288','2013-02-09','09:25:00',1.35),('11288','2013-02-09','09:30:00',1.6),('11288','2013-02-09','09:35:00',1.61),('11288','2013-02-09','09:40:00',1.33),('11288','2013-02-09','09:45:00',1.14),('11288','2013-02-09','09:50:00',1.12),('11288','2013-02-09','09:55:00',1.1),('11288','2013-02-09','10:00:00',1.03),('11288','2013-02-09','10:05:00',1),('11288','2013-02-09','10:30:00',1.03),('11288','2013-02-09','10:35:00',1.12),('11288','2013-02-09','10:40:00',1.29),('11288','2013-02-09','10:45:00',1.49),('11288','2013-02-09','10:50:00',1.7),('11288','2013-02-09','10:55:00',1.84),('11288','2013-02-09','11:00:00',1.96),('11288','2013-02-09','11:05:00',2.02),('11288','2013-02-09','11:10:00',2.08),('11288','2013-02-09','11:15:00',2.16),('11288','2013-02-09','11:20:00',2.23),('11288','2013-02-09','11:25:00',2.25),('11288','2013-02-09','11:30:00',2.27),('11288','2013-02-09','11:35:00',2.21),('11288','2013-02-09','11:40:00',2.16),('11288','2013-02-09','11:45:00',2.19),('11288','2013-02-09','11:50:00',2.16),('11288','2013-02-09','11:55:00',2.1),('11288','2013-02-09','12:00:00',2.14),('11288','2013-02-09','12:05:00',2.13),('11288','2013-02-09','12:10:00',2.08),('11288','2013-02-09','12:15:00',2.08),('11288','2013-02-09','12:20:00',2.11),('11288','2013-02-09','12:25:00',2.13),('11288','2013-02-09','12:30:00',2.18),('11288','2013-02-09','12:35:00',2.29),('11288','2013-02-09','12:40:00',2.34),('11288','2013-02-09','12:45:00',2.36),('11288','2013-02-09','12:50:00',2.36),('11288','2013-02-09','12:55:00',2.34),('11288','2013-02-09','13:00:00',2.5),('11288','2013-02-09','13:05:00',2.84),('11288','2013-02-09','13:10:00',3.12),('11288','2013-02-09','13:15:00',3.3),('11288','2013-02-09','13:20:00',3.67),('11288','2013-02-09','13:25:00',3.84),('11288','2013-02-09','13:30:00',4.1),('11288','2013-02-09','13:35:00',4.43),('11288','2013-02-09','13:40:00',4.35),('11288','2013-02-09','13:45:00',4.72),('11288','2013-02-09','13:50:00',4.72),('11288','2013-02-09','13:55:00',4.99),('11288','2013-02-09','14:00:00',4.56),('11288','2013-02-09','14:05:00',4.33),('11288','2013-02-09','14:10:00',3.87),('11288','2013-02-09','14:15:00',4.49),('11288','2013-02-09','14:20:00',5.33),('11288','2013-02-09','14:25:00',5.06),('11288','2013-02-09','14:30:00',4.49),('11288','2013-02-09','14:35:00',4.04),('11288','2013-02-09','14:40:00',3.64),('11288','2013-02-09','14:45:00',3.55),('11288','2013-02-09','14:50:00',3.4),('11288','2013-02-09','14:55:00',3.35),('11288','2013-02-09','15:00:00',3.2),('11288','2013-02-09','15:05:00',3.03),('11288','2013-02-09','15:10:00',2.89),('11288','2013-02-09','15:15:00',2.72),('11288','2013-02-09','15:20:00',2.63),('11288','2013-02-09','15:25:00',2.25),('11288','2013-02-09','15:30:00',2.33),('11288','2013-02-09','15:35:00',2.21),('11288','2013-02-09','15:40:00',1.97),('11288','2013-02-09','15:45:00',1.91),('11288','2013-02-09','15:50:00',1.86),('11288','2013-02-09','15:55:00',1.43),('11288','2013-02-09','16:20:00',1.14),('11288','2013-02-08','08:55:00',1.11),('11288','2013-02-08','09:00:00',1.05),('11288','2013-02-08','09:15:00',1.04),('11288','2013-02-08','09:20:00',1.26),('11288','2013-02-08','09:25:00',1.42),('11288','2013-02-08','09:30:00',1.5),('11288','2013-02-08','09:35:00',2.16),('11288','2013-02-08','09:40:00',2.73),('11288','2013-02-08','09:45:00',2.84),('11288','2013-02-08','09:50:00',3.94),('11288','2013-02-08','09:55:00',3.91),('11288','2013-02-08','10:00:00',4.15),('11288','2013-02-08','10:05:00',4.34),('11288','2013-02-08','10:10:00',4.42),('11288','2013-02-08','10:15:00',4.73),('11288','2013-02-08','10:20:00',3.43),('11288','2013-02-08','10:25:00',4.74),('11288','2013-02-08','10:30:00',3.04),('11288','2013-02-08','10:35:00',2.67),('11288','2013-02-08','10:40:00',4.34),('11288','2013-02-08','10:45:00',4.93),('11288','2013-02-08','10:50:00',5.13),('11288','2013-02-08','10:55:00',5.04),('11288','2013-02-08','11:00:00',4.92),('11288','2013-02-08','11:05:00',4.83),('11288','2013-02-08','11:10:00',4.91),('11288','2013-02-08','11:15:00',4.93),('11288','2013-02-08','11:20:00',4.96),('11288','2013-02-08','11:25:00',5.07),('11288','2013-02-08','11:30:00',5.09),('11288','2013-02-08','11:35:00',5.08),('11288','2013-02-08','11:40:00',5.12),('11288','2013-02-08','11:45:00',4.96),('11288','2013-02-08','11:50:00',5.03),('11288','2013-02-08','11:55:00',5.16),('11288','2013-02-08','12:00:00',5.16),('11288','2013-02-08','12:05:00',5.19),('11288','2013-02-08','12:10:00',5.21),('11288','2013-02-08','12:15:00',5.25),('11288','2013-02-08','12:20:00',5.21),('11288','2013-02-08','12:25:00',5.26),('11288','2013-02-08','12:30:00',5.22),('11288','2013-02-08','12:35:00',5.27),('11288','2013-02-08','12:40:00',5.33),('11288','2013-02-08','12:45:00',5.67),('11288','2013-02-08','12:50:00',3.17),('11288','2013-02-08','12:55:00',3.47),('11288','2013-02-08','13:00:00',3.45),('11288','2013-02-08','13:05:00',2.98),('11288','2013-02-08','13:10:00',3.17),('11288','2013-02-08','13:15:00',3.15),('11288','2013-02-08','13:20:00',3.24),('11288','2013-02-08','13:25:00',3.04),('11288','2013-02-08','13:30:00',3.04),('11288','2013-02-08','13:35:00',3.75),('11288','2013-02-08','13:40:00',3.12),('11288','2013-02-08','13:45:00',2.47),('11288','2013-02-08','13:50:00',2.59),('11288','2013-02-08','13:55:00',2.72),('11288','2013-02-08','14:00:00',2.47),('11288','2013-02-08','14:05:00',2.45),('11288','2013-02-08','14:10:00',2.3),('11288','2013-02-08','14:15:00',2.21),('11288','2013-02-08','14:20:00',2.34),('11288','2013-02-08','14:25:00',3.05),('11288','2013-02-08','14:30:00',3.72),('11288','2013-02-08','14:35:00',3.74),('11288','2013-02-08','14:40:00',5.19),('11288','2013-02-08','14:45:00',3.28),('11288','2013-02-08','14:50:00',3.88),('11288','2013-02-08','14:55:00',4.18),('11288','2013-02-08','15:00:00',4.31),('11288','2013-02-08','15:05:00',4.42),('11288','2013-02-08','15:10:00',4.06),('11288','2013-02-08','15:15:00',3.66),('11288','2013-02-08','15:20:00',1.91),('11288','2013-02-08','15:25:00',2.19),('11288','2013-02-08','15:30:00',2.11),('11288','2013-02-08','15:35:00',2.08),('11288','2013-02-08','15:40:00',2.12),('11288','2013-02-08','15:45:00',2.08),('11288','2013-02-08','15:50:00',1.92),('11288','2013-02-08','15:55:00',1.7),('11288','2013-02-08','16:00:00',1.51),('11288','2013-02-08','16:05:00',1.38),('11288','2013-02-08','16:10:00',1.32),('11288','2013-02-08','16:15:00',1.08),('11288','2013-02-07','09:20:00',1.06),('11288','2013-02-07','09:30:00',1.03),('11288','2013-02-07','09:35:00',1.06),('11288','2013-02-07','09:40:00',1.09),('11288','2013-02-07','09:45:00',1.2),('11288','2013-02-07','09:50:00',1.22),('11288','2013-02-07','10:25:00',1.3),('11288','2013-02-07','10:30:00',1.23),('11288','2013-02-07','10:35:00',2.02),('11288','2013-02-07','10:40:00',2.07),('11288','2013-02-07','10:45:00',1.79),('11288','2013-02-07','10:50:00',1.32),('11288','2013-02-07','10:55:00',2.25),('11288','2013-02-07','11:00:00',2.89),('11288','2013-02-07','11:05:00',2.02),('11288','2013-02-07','11:10:00',1.5),('11288','2013-02-07','12:20:00',2.46),('11288','2013-02-07','12:25:00',3.93),('11288','2013-02-07','12:30:00',3.2),('11288','2013-02-07','12:35:00',1.65),('11288','2013-02-07','12:40:00',1.16),('11288','2013-02-07','12:45:00',1.51),('11288','2013-02-07','12:50:00',1.54),('11288','2013-02-07','12:55:00',1.16),('11288','2013-02-07','13:00:00',1.02),('11288','2013-02-07','13:05:00',1.19),('11288','2013-02-07','13:10:00',1.48),('11288','2013-02-07','13:15:00',3.31),('11288','2013-02-07','13:20:00',2.46),('11288','2013-02-07','13:25:00',2.5),('11288','2013-02-07','13:30:00',1.76),('11288','2013-02-07','13:35:00',1.51),('11288','2013-02-07','13:40:00',1.65),('11288','2013-02-07','13:45:00',1.67),('11288','2013-02-07','13:50:00',1.77),('11288','2013-02-07','13:55:00',2.04),('11288','2013-02-07','14:00:00',2.48),('11288','2013-02-07','14:05:00',3.43),('11288','2013-02-07','14:10:00',5.12),('11288','2013-02-07','14:15:00',4.4),('11288','2013-02-07','14:20:00',3.6),('11288','2013-02-07','14:25:00',2),('11288','2013-02-07','14:30:00',1.72),('11288','2013-02-07','14:35:00',2.86),('11288','2013-02-07','14:40:00',3.36),('11288','2013-02-07','14:45:00',2.91),('11288','2013-02-07','14:50:00',2.11),('11288','2013-02-07','14:55:00',2.63),('11288','2013-02-07','15:00:00',3.26),('11288','2013-02-07','15:05:00',3.78),('11288','2013-02-07','15:10:00',3.95),('11288','2013-02-07','15:15:00',2.72),('11288','2013-02-07','15:20:00',2.04),('11288','2013-02-07','15:25:00',1.83),('11288','2013-02-07','15:30:00',1.34),('11288','2013-02-07','15:35:00',1.46),('11288','2013-02-07','15:40:00',1.21),('11288','2013-02-07','15:50:00',1.12),('11288','2013-02-06','08:30:00',1),('11288','2013-02-06','08:35:00',1.13),('11288','2013-02-06','08:40:00',1.37),('11288','2013-02-06','08:45:00',1.5),('11288','2013-02-06','08:50:00',1.77),('11288','2013-02-06','08:55:00',1.59),('11288','2013-02-06','09:00:00',1.78),('11288','2013-02-06','09:05:00',1.74),('11288','2013-02-06','09:10:00',1.99),('11288','2013-02-06','09:15:00',1.62),('11288','2013-02-06','09:20:00',1.79),('11288','2013-02-06','09:25:00',1.96),('11288','2013-02-06','09:30:00',2.3),('11288','2013-02-06','09:35:00',1.99),('11288','2013-02-06','09:40:00',2.39),('11288','2013-02-06','09:45:00',2.11),('11288','2013-02-06','09:50:00',2.17),('11288','2013-02-06','09:55:00',2.56),('11288','2013-02-06','10:00:00',2.29),('11288','2013-02-06','10:05:00',2.75),('11288','2013-02-06','10:10:00',2.32),('11288','2013-02-06','10:15:00',2.23),('11288','2013-02-06','10:20:00',2.11),('11288','2013-02-06','10:25:00',2.65),('11288','2013-02-06','10:30:00',2.51),('11288','2013-02-06','10:35:00',3.26),('11288','2013-02-06','10:40:00',2.21),('11288','2013-02-06','10:45:00',1.98),('11288','2013-02-06','10:50:00',3.17),('11288','2013-02-06','10:55:00',3.38),('11288','2013-02-06','11:00:00',2.91),('11288','2013-02-06','11:05:00',2.57),('11288','2013-02-06','11:10:00',2.81),('11288','2013-02-06','11:15:00',2.59),('11288','2013-02-06','11:20:00',3.37),('11288','2013-02-06','11:25:00',4.39),('11288','2013-02-06','11:30:00',2.66),('11288','2013-02-06','11:35:00',2.61),('11288','2013-02-06','11:40:00',2.87),('11288','2013-02-06','11:45:00',2.89),('11288','2013-02-06','11:50:00',2.99),('11288','2013-02-06','11:55:00',2.78),('11288','2013-02-06','12:00:00',2.41),('11288','2013-02-06','12:05:00',1.88),('11288','2013-02-06','12:10:00',1.53),('11288','2013-02-06','12:15:00',2.19),('11288','2013-02-06','12:20:00',1.98),('11288','2013-02-06','12:25:00',1.92),('11288','2013-02-06','12:30:00',1.61),('11288','2013-02-06','12:35:00',1.4),('11288','2013-02-06','12:40:00',1.25),('11288','2013-02-06','12:45:00',1.28),('11288','2013-02-06','12:50:00',1.25),('11288','2013-02-06','12:55:00',1.24),('11288','2013-02-06','13:00:00',1.11),('11288','2013-02-06','13:05:00',1.17),('11288','2013-02-06','13:10:00',1.32),('11288','2013-02-06','13:15:00',1.59),('11288','2013-02-06','13:20:00',1.76),('11288','2013-02-06','13:25:00',1.98),('11288','2013-02-06','13:30:00',2.28),('11288','2013-02-06','13:35:00',2.36),('11288','2013-02-06','13:40:00',1.97),('11288','2013-02-06','13:45:00',2.06),('11288','2013-02-06','13:50:00',2.7),('11288','2013-02-06','13:55:00',2.3),('11288','2013-02-06','14:00:00',2.52),('11288','2013-02-06','14:05:00',2.28),('11288','2013-02-06','14:10:00',1.29),('11288','2013-02-06','14:30:00',3.11),('11288','2013-02-06','14:35:00',3.12),('11288','2013-02-06','14:40:00',2.38),('11288','2013-02-06','14:45:00',1.1),('11288','2013-02-06','15:15:00',1.06),('11288','2013-02-06','15:20:00',1.07),('11288','2013-02-06','15:25:00',1.81),('11288','2013-02-06','15:45:00',1.11),('11288','2013-02-06','15:50:00',1.14),('11288','2013-02-05','08:25:00',1.07),('11288','2013-02-05','08:30:00',1.18),('11288','2013-02-05','08:35:00',1.24),('11288','2013-02-05','08:40:00',1.46),('11288','2013-02-05','08:45:00',1.55),('11288','2013-02-05','08:50:00',1.65),('11288','2013-02-05','08:55:00',1.76),('11288','2013-02-05','09:00:00',1.86),('11288','2013-02-05','09:05:00',1.94),('11288','2013-02-05','09:10:00',2.08),('11288','2013-02-05','09:15:00',2.24),('11288','2013-02-05','09:20:00',2.3),('11288','2013-02-05','09:25:00',2.45),('11288','2013-02-05','09:30:00',2.56),('11288','2013-02-05','09:35:00',2.59),('11288','2013-02-05','09:40:00',2.81),('11288','2013-02-05','09:45:00',2.9),('11288','2013-02-05','09:50:00',2.89),('11288','2013-02-05','09:55:00',3.14),('11288','2013-02-05','10:00:00',3.13),('11288','2013-02-05','10:05:00',3.08),('11288','2013-02-05','10:10:00',3.1),('11288','2013-02-05','10:15:00',3.21),('11288','2013-02-05','10:20:00',3.68),('11288','2013-02-05','10:25:00',3.75),('11288','2013-02-05','10:30:00',3.77),('11288','2013-02-05','10:35:00',3.6),('11288','2013-02-05','10:40:00',3.71),('11288','2013-02-05','10:45:00',3.97),('11288','2013-02-05','10:50:00',4.03),('11288','2013-02-05','10:55:00',4.12),('11288','2013-02-05','11:00:00',4.12),('11288','2013-02-05','11:05:00',3.94),('11288','2013-02-05','11:10:00',4.13),('11288','2013-02-05','11:15:00',4.31),('11288','2013-02-05','11:20:00',4.32),('11288','2013-02-05','11:25:00',4.58),('11288','2013-02-05','11:30:00',4.38),('11288','2013-02-05','11:35:00',4.21),('11288','2013-02-05','11:40:00',4.16),('11288','2013-02-05','11:45:00',3.69),('11288','2013-02-05','11:50:00',2.72),('11288','2013-02-05','11:55:00',2.37),('11288','2013-02-05','12:00:00',1.83),('11288','2013-02-05','12:05:00',2.64),('11288','2013-02-05','12:10:00',2.46),('11288','2013-02-05','12:15:00',2.51),('11288','2013-02-05','12:20:00',2.29),('11288','2013-02-05','12:25:00',2.24),('11288','2013-02-05','12:30:00',2.02),('11288','2013-02-05','12:35:00',3.82),('11288','2013-02-05','12:40:00',3.24),('11288','2013-02-05','12:45:00',3.82),('11288','2013-02-05','12:50:00',3.09),('11288','2013-02-05','12:55:00',1.63),('11288','2013-02-05','13:00:00',1.23),('11288','2013-02-05','13:05:00',1.49),('11288','2013-02-05','13:10:00',2.03),('11288','2013-02-05','13:15:00',2.39),('11288','2013-02-05','13:20:00',2.34),('11288','2013-02-05','13:25:00',2.44),('11288','2013-02-05','13:30:00',2.18),('11288','2013-02-05','13:35:00',1.78),('11288','2013-02-05','13:40:00',2.02),('11288','2013-02-05','13:45:00',2.42),('11288','2013-02-05','13:50:00',2.45),('11288','2013-02-05','13:55:00',2.17),('11288','2013-02-05','14:00:00',2.18),('11288','2013-02-05','14:05:00',2.12),('11288','2013-02-05','14:10:00',1.76),('11288','2013-02-05','14:15:00',1.88),('11288','2013-02-05','14:20:00',2.31),('11288','2013-02-05','14:25:00',2.93),('11288','2013-02-05','14:30:00',2.82),('11288','2013-02-05','14:35:00',2.36),('11288','2013-02-05','14:40:00',2.76),('11288','2013-02-05','14:45:00',1.88),('11288','2013-02-05','14:50:00',1.5),('11288','2013-02-05','14:55:00',1.27),('11288','2013-02-05','15:00:00',1.39),('11288','2013-02-05','15:05:00',1.77),('11288','2013-02-05','15:10:00',1.34),('11288','2013-02-05','15:15:00',1.16),('11288','2013-02-04','08:25:00',1.05),('11288','2013-02-04','08:30:00',1.18),('11288','2013-02-04','08:35:00',1.19),('11288','2013-02-04','08:40:00',1.41),('11288','2013-02-04','08:45:00',1.53),('11288','2013-02-04','08:50:00',1.63),('11288','2013-02-04','08:55:00',1.63),('11288','2013-02-04','09:00:00',1.92),('11288','2013-02-04','09:05:00',2.08),('11288','2013-02-04','09:10:00',2.24),('11288','2013-02-04','09:15:00',2.35),('11288','2013-02-04','09:20:00',2.35),('11288','2013-02-04','09:25:00',2.44),('11288','2013-02-04','09:30:00',2.59),('11288','2013-02-04','09:35:00',2.72),('11288','2013-02-04','09:40:00',2.79),('11288','2013-02-04','09:45:00',2.52),('11288','2013-02-04','09:50:00',2.88),('11288','2013-02-04','09:55:00',3.27),('11288','2013-02-04','10:00:00',3.36),('11288','2013-02-04','10:05:00',3.6),('11288','2013-02-04','10:10:00',3.71),('11288','2013-02-04','10:15:00',3.93),('11288','2013-02-04','10:20:00',3.75),('11288','2013-02-04','10:25:00',4),('11288','2013-02-04','10:30:00',3.68),('11288','2013-02-04','10:35:00',3.28),('11288','2013-02-04','10:40:00',3.48),('11288','2013-02-04','10:45:00',4.27),('11288','2013-02-04','10:50:00',4.38),('11288','2013-02-04','10:55:00',4.42),('11288','2013-02-04','11:00:00',4.4),('11288','2013-02-04','11:05:00',4.24),('11288','2013-02-04','11:10:00',4.46),('11288','2013-02-04','11:15:00',4.65),('11288','2013-02-04','11:20:00',4.73),('11288','2013-02-04','11:25:00',4.83),('11288','2013-02-04','11:30:00',4.83),('11288','2013-02-04','11:35:00',4.85),('11288','2013-02-04','11:40:00',4.86),('11288','2013-02-04','11:45:00',4.9),('11288','2013-02-04','11:50:00',4.93),('11288','2013-02-04','11:55:00',4.93),('11288','2013-02-04','12:00:00',4.92),('11288','2013-02-04','12:05:00',4.96),('11288','2013-02-04','12:10:00',4.97),('11288','2013-02-04','12:15:00',4.99),('11288','2013-02-04','12:20:00',4.72),('11288','2013-02-04','12:25:00',4.67),('11288','2013-02-04','12:30:00',4.91),('11288','2013-02-04','12:35:00',4.88),('11288','2013-02-04','12:40:00',4.85),('11288','2013-02-04','12:45:00',4.83),('11288','2013-02-04','12:50:00',4.84),('11288','2013-02-04','12:55:00',4.86),('11288','2013-02-04','13:00:00',4.84),('11288','2013-02-04','13:05:00',4.81),('11288','2013-02-04','13:10:00',4.75),('11288','2013-02-04','13:15:00',4.72),('11288','2013-02-04','13:20:00',4.63),('11288','2013-02-04','13:25:00',4.55),('11288','2013-02-04','13:30:00',4.56),('11288','2013-02-04','13:35:00',4.51),('11288','2013-02-04','13:40:00',4.45),('11288','2013-02-04','13:45:00',4.35),('11288','2013-02-04','13:50:00',4.29),('11288','2013-02-04','13:55:00',4.25),('11288','2013-02-04','14:00:00',4.18),('11288','2013-02-04','14:05:00',4.07),('11288','2013-02-04','14:10:00',4.02),('11288','2013-02-04','14:15:00',3.93),('11288','2013-02-04','14:20:00',3.85),('11288','2013-02-04','14:25:00',3.74),('11288','2013-02-04','14:30:00',3.64),('11288','2013-02-04','14:35:00',3.55),('11288','2013-02-04','14:40:00',3.45),('11288','2013-02-04','14:45:00',3.31),('11288','2013-02-04','14:50:00',3.23),('11288','2013-02-04','14:55:00',3.13),('11288','2013-02-04','15:00:00',2.97),('11288','2013-02-04','15:05:00',2.88),('11288','2013-02-04','15:10:00',2.76),('11288','2013-02-04','15:15:00',2.6),('11288','2013-02-04','15:20:00',2.49),('11288','2013-02-04','15:25:00',2.35),('11288','2013-02-04','15:30:00',2.23),('11288','2013-02-04','15:35:00',2.08),('11288','2013-02-04','15:40:00',1.89),('11288','2013-02-04','15:45:00',1.74),('11288','2013-02-04','15:50:00',1.63),('11288','2013-02-04','15:55:00',1.49),('11288','2013-02-04','16:00:00',1.35),('11288','2013-02-04','16:05:00',1.18),('11288','2013-02-04','16:10:00',1.08),('11288','2013-02-04','16:15:00',1.01),('11288','2013-02-03','08:40:00',1.16),('11288','2013-02-03','08:45:00',1.04),('11288','2013-02-03','08:50:00',1.02),('11288','2013-02-03','09:15:00',1.38),('11288','2013-02-03','09:20:00',1.74),('11288','2013-02-03','09:25:00',2.18),('11288','2013-02-03','09:30:00',1.67),('11288','2013-02-03','09:35:00',1.41),('11288','2013-02-03','09:40:00',1.99),('11288','2013-02-03','09:45:00',2.62),('11288','2013-02-03','09:50:00',2.63),('11288','2013-02-03','09:55:00',2.31),('11288','2013-02-03','10:00:00',3.09),('11288','2013-02-03','10:05:00',1.32),('11288','2013-02-03','10:15:00',1.17),('11288','2013-02-03','10:20:00',2.05),('11288','2013-02-03','10:25:00',1.25),('11288','2013-02-03','11:15:00',1.74),('11288','2013-02-03','11:20:00',2.48),('11288','2013-02-03','11:25:00',1.34),('11288','2013-02-03','11:40:00',1.07),('11288','2013-02-03','11:45:00',1.74),('11288','2013-02-03','11:50:00',2.33),('11288','2013-02-03','11:55:00',2.76),('11288','2013-02-03','12:00:00',2.41),('11288','2013-02-03','12:05:00',2.4),('11288','2013-02-03','12:10:00',2.37),('11288','2013-02-03','12:15:00',1.6),('11288','2013-02-03','12:20:00',1.25),('11288','2013-02-03','13:50:00',1.01),('11288','2013-02-03','14:55:00',1.08),('11288','2013-02-02','09:55:00',1.03),('11288','2013-02-02','10:05:00',1.01),('11288','2013-02-02','10:10:00',1.27),('11288','2013-02-02','10:15:00',2.11),('11288','2013-02-02','10:20:00',1.9),('11288','2013-02-02','10:25:00',2.04),('11288','2013-02-02','10:30:00',2.17),('11288','2013-02-02','10:35:00',2.26),('11288','2013-02-02','10:40:00',2.44),('11288','2013-02-02','10:45:00',2.54),('11288','2013-02-02','10:50:00',2.27),('11288','2013-02-02','10:55:00',3.08),('11288','2013-02-02','11:00:00',3.11),('11288','2013-02-02','11:05:00',2.88),('11288','2013-02-02','11:10:00',3.12),('11288','2013-02-02','11:15:00',3.13),('11288','2013-02-02','11:20:00',3.03),('11288','2013-02-02','11:25:00',3.77),('11288','2013-02-02','11:30:00',3.38),('11288','2013-02-02','11:35:00',3.22),('11288','2013-02-02','11:40:00',3.06),('11288','2013-02-02','11:45:00',2.27),('11288','2013-02-02','11:50:00',2.21),('11288','2013-02-02','11:55:00',2.08),('11288','2013-02-02','12:00:00',1.59),('11288','2013-02-02','12:05:00',1.22),('11288','2013-02-02','12:35:00',1.01),('11288','2013-02-02','12:50:00',1.55),('11288','2013-02-02','12:55:00',3.6),('11288','2013-02-02','13:00:00',2.82),('11288','2013-02-02','13:05:00',2.54),('11288','2013-02-02','13:10:00',3.85),('11288','2013-02-02','13:15:00',3.11),('11288','2013-02-02','13:20:00',2.85),('11288','2013-02-02','13:25:00',2.87),('11288','2013-02-02','13:30:00',2.64),('11288','2013-02-02','13:35:00',3.17),('11288','2013-02-02','13:40:00',3.63),('11288','2013-02-02','13:45:00',3.28),('11288','2013-02-02','13:50:00',3.06),('11288','2013-02-02','13:55:00',1.66),('11288','2013-02-02','14:00:00',1.01),('11288','2013-02-01','08:35:00',1.14),('11288','2013-02-01','08:40:00',1.04),('11288','2013-02-01','08:45:00',1.14),('11288','2013-02-01','08:55:00',1.36),('11288','2013-02-01','09:00:00',1.75),('11288','2013-02-01','09:05:00',2.22),('11288','2013-02-01','09:10:00',1.95),('11288','2013-02-01','09:15:00',1.04),('11288','2013-02-01','09:20:00',1.65),('11288','2013-02-01','09:25:00',2.05),('11288','2013-02-01','09:30:00',2.41),('11288','2013-02-01','09:35:00',2.99),('11288','2013-02-01','09:40:00',2.97),('11288','2013-02-01','09:45:00',1.66),('11288','2013-02-01','09:50:00',2.26),('11288','2013-02-01','09:55:00',2.54),('11288','2013-02-01','10:00:00',2.37),('11288','2013-02-01','10:05:00',2.35),('11288','2013-02-01','10:10:00',1.05),('11288','2013-02-01','10:15:00',2.35),('11288','2013-02-01','10:20:00',1.62),('11288','2013-02-01','10:25:00',1.9),('11288','2013-02-01','10:30:00',2.02),('11288','2013-02-01','10:35:00',1.72),('11288','2013-02-01','10:40:00',1.39),('11288','2013-02-01','10:45:00',2.36),('11288','2013-02-01','10:50:00',4.38),('11288','2013-02-01','10:55:00',4.01),('11288','2013-02-01','11:00:00',4.17),('11288','2013-02-01','11:05:00',4.3),('11288','2013-02-01','11:10:00',2.23),('11288','2013-02-01','11:15:00',2.97),('11288','2013-02-01','11:20:00',3.08),('11288','2013-02-01','11:25:00',1.72),('11288','2013-02-01','11:30:00',3.19),('11288','2013-02-01','11:35:00',2.5),('11288','2013-02-01','11:40:00',2.47),('11288','2013-02-01','11:45:00',3.02),('11288','2013-02-01','11:50:00',2.56),('11288','2013-02-01','11:55:00',2.03),('11288','2013-02-01','12:00:00',2.97),('11288','2013-02-01','12:05:00',4.32),('11288','2013-02-01','12:10:00',3.45),('11288','2013-02-01','12:15:00',5.23),('11288','2013-02-01','12:20:00',5.15),('11288','2013-02-01','12:25:00',4.17),('11288','2013-02-01','12:30:00',3.47),('11288','2013-02-01','12:35:00',3.51),('11288','2013-02-01','12:40:00',4.03),('11288','2013-02-01','12:45:00',4.26),('11288','2013-02-01','12:50:00',3.92),('11288','2013-02-01','12:55:00',3),('11288','2013-02-01','13:00:00',2.28),('11288','2013-02-01','13:05:00',4),('11288','2013-02-01','13:10:00',3.69),('11288','2013-02-01','13:15:00',3.97),('11288','2013-02-01','13:20:00',4.35),('11288','2013-02-01','13:25:00',3.01),('11288','2013-02-01','13:30:00',3),('11288','2013-02-01','13:35:00',2.97),('11288','2013-02-01','13:40:00',2.25),('11288','2013-02-01','13:45:00',1.74),('11288','2013-02-01','13:50:00',1.71),('11288','2013-02-01','13:55:00',1.89),('11288','2013-02-01','14:00:00',1.91),('11288','2013-02-01','14:05:00',2.08),('11288','2013-02-01','14:10:00',3.69),('11288','2013-02-01','14:15:00',3.69),('11288','2013-02-01','14:20:00',2.83),('11288','2013-02-01','14:25:00',2.83),('11288','2013-02-01','14:30:00',3.16),('11288','2013-02-01','14:35:00',3.37),('11288','2013-02-01','14:40:00',1.76),('11288','2013-02-01','14:45:00',1.13),('11288','2013-02-01','14:50:00',1.27),('11288','2013-02-01','14:55:00',1.35),('11288','2013-02-01','15:00:00',2.28),('11288','2013-02-01','15:05:00',2.57),('11288','2013-02-01','15:10:00',2.36),('11288','2013-02-01','15:15:00',2.24),('11288','2013-02-01','15:20:00',2.04),('11288','2013-02-01','15:25:00',1.54),('11288','2013-02-01','15:45:00',1.07),('11288','2013-02-01','15:50:00',1.48),('11288','2013-02-01','15:55:00',1.34),('11288','2014-03-21','07:35:00',1.09),('11288','2014-03-21','07:40:00',1.18),('11288','2014-03-21','07:45:00',1.3),('11288','2014-03-21','07:50:00',1.46),('11288','2014-03-21','07:55:00',1.51),('11288','2014-03-21','08:00:00',1.76),('11288','2014-03-21','08:05:00',1.89),('11288','2014-03-21','08:10:00',2.03),('11288','2014-03-21','08:15:00',2.16),('11288','2014-03-21','08:20:00',2.25),('11288','2014-03-21','08:25:00',2.38),('11288','2014-03-21','08:30:00',2.54),('11288','2014-03-21','08:35:00',2.72),('11288','2014-03-21','08:40:00',2.77),('11288','2014-03-21','08:45:00',3.02),('11288','2014-03-21','08:50:00',3.29),('11288','2014-03-21','08:55:00',3.45),('11288','2014-03-21','09:00:00',3.53),('11288','2014-03-21','09:05:00',3.66),('11288','2014-03-21','09:10:00',3.83),('11288','2014-03-21','09:15:00',3.97),('11288','2014-03-21','09:20:00',4.11),('11288','2014-03-21','09:25:00',4.04),('11288','2014-03-21','09:30:00',4.29),('11288','2014-03-21','09:35:00',4.39),('11288','2014-03-21','09:40:00',4.53),('11288','2014-03-21','09:45:00',4.56),('11288','2014-03-21','09:50:00',4.68),('11288','2014-03-21','09:55:00',4.71),('11288','2014-03-21','10:00:00',4.79),('11288','2014-03-21','10:05:00',4.91),('11288','2014-03-21','10:10:00',4.97),('11288','2014-03-21','10:15:00',5),('11288','2014-03-21','10:20:00',5.04),('11288','2014-03-21','10:25:00',5.15),('11288','2014-03-21','10:30:00',5.23),('11288','2014-03-21','10:35:00',5.3),('11288','2014-03-21','10:40:00',5.2),('11288','2014-03-21','10:45:00',5.21),('11288','2014-03-21','10:50:00',5.27),('11288','2014-03-21','10:55:00',5.28),('11288','2014-03-21','11:00:00',5.45),('11288','2014-03-21','11:05:00',5.43),('11288','2014-03-21','11:10:00',5.48),('11288','2014-03-21','11:15:00',5.6),('11288','2014-03-21','11:20:00',5.74),('11288','2014-03-21','11:25:00',5.72),('11288','2014-03-21','11:30:00',3.34),('11288','2014-03-21','11:35:00',4.2),('11288','2014-03-21','11:40:00',5.61),('11288','2014-03-21','11:45:00',6.24),('11288','2014-03-21','11:50:00',6.34),('11288','2014-03-21','11:55:00',5.77),('11288','2014-03-21','12:00:00',4.85),('11288','2014-03-21','12:05:00',6.1),('11288','2014-03-21','12:10:00',6.15),('11288','2014-03-21','12:15:00',6.11),('11288','2014-03-21','12:20:00',6),('11288','2014-03-21','12:25:00',5.93),('11288','2014-03-21','12:30:00',5.93),('11288','2014-03-21','12:35:00',5.97),('11288','2014-03-21','12:40:00',6.06),('11288','2014-03-21','12:45:00',6.08),('11288','2014-03-21','12:50:00',6.01),('11288','2014-03-21','12:55:00',5.93),('11288','2014-03-21','13:00:00',6.01),('11288','2014-03-21','13:05:00',5.91),('11288','2014-03-21','13:10:00',5.92),('11288','2014-03-21','13:15:00',5.87),('11288','2014-03-21','13:20:00',5.79),('11288','2014-03-21','13:25:00',5.75),('11288','2014-03-21','13:30:00',5.71),('11288','2014-03-21','13:35:00',5.64),('11288','2014-03-21','13:40:00',5.59),('11288','2014-03-21','13:45:00',5.59),('11288','2014-03-21','13:50:00',5.53),('11288','2014-03-21','13:55:00',5.46),('11288','2014-03-21','14:00:00',5.47),('11288','2014-03-21','14:05:00',5.41),('11288','2014-03-21','14:10:00',5.35),('11288','2014-03-21','14:15:00',5.28),('11288','2014-03-21','14:20:00',5.14),('11288','2014-03-21','14:25:00',5.05),('11288','2014-03-21','14:30:00',4.92),('11288','2014-03-21','14:35:00',4.72),('11288','2014-03-21','14:40:00',4.73),('11288','2014-03-21','14:45:00',4.44),('11288','2014-03-21','14:50:00',3.68),('11288','2014-03-21','14:55:00',1.58),('11288','2014-03-21','15:00:00',1.56),('11288','2014-03-21','15:05:00',3.24),('11288','2014-03-21','15:10:00',4.9),('11288','2014-03-21','15:15:00',4.81),('11288','2014-03-21','15:20:00',4.01),('11288','2014-03-21','15:25:00',4.77),('11288','2014-03-21','15:30:00',4.44),('11288','2014-03-21','15:35:00',4.18),('11288','2014-03-21','15:40:00',4.17),('11288','2014-03-21','15:45:00',4.08),('11288','2014-03-21','15:50:00',3.93),('11288','2014-03-21','15:55:00',3.79),('11288','2014-03-21','16:00:00',3.49),('11288','2014-03-21','16:05:00',3.23),('11288','2014-03-21','16:10:00',2.98),('11288','2014-03-21','16:15:00',2.72),('11288','2014-03-21','16:20:00',2.44),('11288','2014-03-21','16:25:00',2.21),('11288','2014-03-21','16:30:00',2.04),('11288','2014-03-21','16:35:00',1.87),('11288','2014-03-21','16:40:00',1.73),('11288','2014-03-21','16:45:00',1.6),('11288','2014-03-21','16:50:00',1.46),('11288','2014-03-21','16:55:00',1.31),('11288','2014-03-21','17:00:00',1.07),('11288','2013-01-31','09:00:00',1.05),('11288','2013-01-31','09:05:00',1.35),('11288','2013-01-31','09:10:00',1.4),('11288','2013-01-31','09:15:00',1.1),('11288','2013-01-31','09:20:00',1.39),('11288','2013-01-31','09:25:00',1.3),('11288','2013-01-31','09:30:00',2.1),('11288','2013-01-31','09:35:00',2.03),('11288','2013-01-31','09:40:00',2.09),('11288','2013-01-31','09:45:00',2.63),('11288','2013-01-31','09:50:00',2.65),('11288','2013-01-31','09:55:00',2.65),('11288','2013-01-31','10:00:00',2.8),('11288','2013-01-31','10:05:00',2.69),('11288','2013-01-31','10:10:00',2.84),('11288','2013-01-31','10:15:00',3.18),('11288','2013-01-31','10:20:00',3.35),('11288','2013-01-31','10:25:00',3.44),('11288','2013-01-31','10:30:00',2.95),('11288','2013-01-31','10:35:00',3.73),('11288','2013-01-31','10:40:00',2.91),('11288','2013-01-31','10:45:00',2.51),('11288','2013-01-31','10:50:00',4.75),('11288','2013-01-31','10:55:00',3.65),('11288','2013-01-31','11:00:00',2.05),('11288','2013-01-31','11:05:00',1.97),('11288','2013-01-31','11:10:00',3.73),('11288','2013-01-31','11:15:00',2.28),('11288','2013-01-31','11:20:00',4.56),('11288','2013-01-31','11:25:00',5.13),('11288','2013-01-31','11:30:00',4.96),('11288','2013-01-31','11:35:00',4.75),('11288','2013-01-31','11:40:00',4.45),('11288','2013-01-31','11:45:00',4.41),('11288','2013-01-31','11:50:00',4.46),('11288','2013-01-31','11:55:00',4.45),('11288','2013-01-31','12:00:00',4.42),('11288','2013-01-31','12:05:00',4.63),('11288','2013-01-31','12:10:00',4.5),('11288','2013-01-31','12:15:00',4.56),('11288','2013-01-31','12:20:00',4.49),('11288','2013-01-31','12:25:00',4.45),('11288','2013-01-31','12:30:00',4.42),('11288','2013-01-31','12:35:00',4.45),('11288','2013-01-31','12:40:00',4.45),('11288','2013-01-31','12:45:00',4.35),('11288','2013-01-31','12:50:00',4.34),('11288','2013-01-31','12:55:00',4.36),('11288','2013-01-31','13:00:00',4.36),('11288','2013-01-31','13:05:00',4.31),('11288','2013-01-31','13:10:00',4.27),('11288','2013-01-31','13:15:00',4.08),('11288','2013-01-31','13:20:00',4.09),('11288','2013-01-31','13:25:00',4.09),('11288','2013-01-31','13:30:00',3.97),('11288','2013-01-31','13:35:00',4.01),('11288','2013-01-31','13:40:00',3.85),('11288','2013-01-31','13:45:00',3.9),('11288','2013-01-31','13:50:00',3.97),('11288','2013-01-31','13:55:00',3.77),('11288','2013-01-31','14:00:00',3.64),('11288','2013-01-31','14:05:00',3.56),('11288','2013-01-31','14:10:00',3.45),('11288','2013-01-31','14:15:00',3.34),('11288','2013-01-31','14:20:00',3.28),('11288','2013-01-31','14:25:00',3.16),('11288','2013-01-31','14:30:00',3.11),('11288','2013-01-31','14:35:00',2.99),('11288','2013-01-31','14:40:00',2.94),('11288','2013-01-31','14:45:00',2.82),('11288','2013-01-31','14:50:00',2.75),('11288','2013-01-31','14:55:00',2.64),('11288','2013-01-31','15:00:00',2.5),('11288','2013-01-31','15:05:00',2.48),('11288','2013-01-31','15:10:00',2.34),('11288','2013-01-31','15:15:00',2.28),('11288','2013-01-31','15:20:00',2.17),('11288','2013-01-31','15:25:00',1.95),('11288','2013-01-31','15:30:00',1.82),('11288','2013-01-31','15:35:00',1.82),('11288','2013-01-31','15:40:00',1.68),('11288','2013-01-31','15:45:00',1.5),('11288','2013-01-31','15:50:00',1.35),('11288','2013-01-31','15:55:00',1.25),('11288','2013-01-31','16:00:00',1.03),('11288','2013-01-30','09:10:00',1.18),('11288','2013-01-30','09:15:00',1.09),('11288','2013-01-30','09:25:00',1.24),('11288','2013-01-30','09:30:00',1.45),('11288','2013-01-30','09:35:00',1.46),('11288','2013-01-30','09:40:00',1.34),('11288','2013-01-30','09:45:00',1.07),('11288','2013-01-30','10:00:00',1.91),('11288','2013-01-30','10:05:00',2.32),('11288','2013-01-30','10:10:00',2.86),('11288','2013-01-30','10:15:00',2.12),('11288','2013-01-30','10:20:00',3.1),('11288','2013-01-30','10:25:00',2.74),('11288','2013-01-30','10:30:00',2.6),('11288','2013-01-30','10:35:00',2.28),('11288','2013-01-30','10:40:00',2.04),('11288','2013-01-30','10:45:00',2.72),('11288','2013-01-30','10:50:00',3.67),('11288','2013-01-30','10:55:00',3.32),('11288','2013-01-30','11:00:00',3.92),('11288','2013-01-30','11:05:00',3.75),('11288','2013-01-30','11:10:00',3.84),('11288','2013-01-30','11:15:00',3.93),('11288','2013-01-30','11:20:00',4.02),('11288','2013-01-30','11:25:00',4.19),('11288','2013-01-30','11:30:00',4),('11288','2013-01-30','11:35:00',3.46),('11288','2013-01-30','11:40:00',3.59),('11288','2013-01-30','11:45:00',3.93),('11288','2013-01-30','11:50:00',3.83),('11288','2013-01-30','11:55:00',4.37),('11288','2013-01-30','12:00:00',4.23),('11288','2013-01-30','12:05:00',3.55),('11288','2013-01-30','12:10:00',2.21),('11288','2013-01-30','12:15:00',2.47),('11288','2013-01-30','12:20:00',2.3),('11288','2013-01-30','12:25:00',1.49),('11288','2013-01-30','12:30:00',1.52),('11288','2013-01-30','12:35:00',2.05),('11288','2013-01-30','12:40:00',1.85),('11288','2013-01-30','12:45:00',3.83),('11288','2013-01-30','12:50:00',5.47),('11288','2013-01-30','12:55:00',5.15),('11288','2013-01-30','13:00:00',5.12),('11288','2013-01-30','13:05:00',4.91),('11288','2013-01-30','13:10:00',4.68),('11288','2013-01-30','13:15:00',4.73),('11288','2013-01-30','13:20:00',4.55),('11288','2013-01-30','13:25:00',4.58),('11288','2013-01-30','13:30:00',4.62),('11288','2013-01-30','13:35:00',2.96),('11288','2013-01-30','13:40:00',3.01),('11288','2013-01-30','13:45:00',4.01),('11288','2013-01-30','13:50:00',4.35),('11288','2013-01-30','13:55:00',4.38),('11288','2013-01-30','14:00:00',4.36),('11288','2013-01-30','14:05:00',3.85),('11288','2013-01-30','14:10:00',2.05),('11288','2013-01-30','14:15:00',3.12),('11288','2013-01-30','14:20:00',2.93),('11288','2013-01-30','14:25:00',3.72),('11288','2013-01-30','14:30:00',3.39),('11288','2013-01-30','14:35:00',3.19),('11288','2013-01-30','14:40:00',3.52),('11288','2013-01-30','14:45:00',2.4),('11288','2013-01-30','14:50:00',1.52),('11288','2013-01-30','14:55:00',1.63),('11288','2013-01-30','15:00:00',1.86),('11288','2013-01-30','15:05:00',2.08),('11288','2013-01-30','15:10:00',1.53),('11288','2013-01-30','15:15:00',1.34),('11288','2013-01-30','15:20:00',1.16),('11288','2013-01-30','15:25:00',1.05),('11288','2013-01-30','15:30:00',1.05),('11288','2013-01-29','08:35:00',1.06),('11288','2013-01-29','08:40:00',1.01),('11288','2013-01-29','08:45:00',1.12),('11288','2013-01-29','08:50:00',1.36),('11288','2013-01-29','08:55:00',1.47),('11288','2013-01-29','09:00:00',1.6),('11288','2013-01-29','09:05:00',1.69),('11288','2013-01-29','09:10:00',1.78),('11288','2013-01-29','09:15:00',1.91),('11288','2013-01-29','09:20:00',2.07),('11288','2013-01-29','09:25:00',2.14),('11288','2013-01-29','09:30:00',2.25),('11288','2013-01-29','09:35:00',2.34),('11288','2013-01-29','09:40:00',2.44),('11288','2013-01-29','09:45:00',2.49),('11288','2013-01-29','09:50:00',2.72),('11288','2013-01-29','09:55:00',2.7),('11288','2013-01-29','10:00:00',2.65),('11288','2013-01-29','10:05:00',3.03),('11288','2013-01-29','10:10:00',3.15),('11288','2013-01-29','10:15:00',3.27),('11288','2013-01-29','10:20:00',3.41),('11288','2013-01-29','10:25:00',3.45),('11288','2013-01-29','10:30:00',3.37),('11288','2013-01-29','10:35:00',3.69),('11288','2013-01-29','10:40:00',3.82),('11288','2013-01-29','10:45:00',3.9),('11288','2013-01-29','10:50:00',3.96),('11288','2013-01-29','10:55:00',3.99),('11288','2013-01-29','11:00:00',3.9),('11288','2013-01-29','11:05:00',4.08),('11288','2013-01-29','11:10:00',4.12),('11288','2013-01-29','11:15:00',4.19),('11288','2013-01-29','11:20:00',4.27),('11288','2013-01-29','11:25:00',4.31),('11288','2013-01-29','11:30:00',4.23),('11288','2013-01-29','11:35:00',4.44),('11288','2013-01-29','11:40:00',4.36),('11288','2013-01-29','11:45:00',4.05),('11288','2013-01-29','11:50:00',4.41),('11288','2013-01-29','11:55:00',4.51),('11288','2013-01-29','12:00:00',4.52),('11288','2013-01-29','12:05:00',4.46),('11288','2013-01-29','12:10:00',4.59),('11288','2013-01-29','12:15:00',4.56),('11288','2013-01-29','12:20:00',4.51),('11288','2013-01-29','12:25:00',4.57),('11288','2013-01-29','12:30:00',4.57),('11288','2013-01-29','12:35:00',4.46),('11288','2013-01-29','12:40:00',4.51),('11288','2013-01-29','12:45:00',4.37),('11288','2013-01-29','12:50:00',4.3),('11288','2013-01-29','12:55:00',4.46),('11288','2013-01-29','13:00:00',4.45),('11288','2013-01-29','13:05:00',4.38),('11288','2013-01-29','13:10:00',4.27),('11288','2013-01-29','13:15:00',4.26),('11288','2013-01-29','13:20:00',4.17),('11288','2013-01-29','13:25:00',4.06),('11288','2013-01-29','13:30:00',4.12),('11288','2013-01-29','13:35:00',4.08),('11288','2013-01-29','13:40:00',3.92),('11288','2013-01-29','13:45:00',3.91),('11288','2013-01-29','13:50:00',3.86),('11288','2013-01-29','13:55:00',3.78),('11288','2013-01-29','14:00:00',3.69),('11288','2013-01-29','14:05:00',3.59),('11288','2013-01-29','14:10:00',3.48),('11288','2013-01-29','14:15:00',3.38),('11288','2013-01-29','14:20:00',3.3),('11288','2013-01-29','14:25:00',3.26),('11288','2013-01-29','14:30:00',3.22),('11288','2013-01-29','14:35:00',3.12),('11288','2013-01-29','14:40:00',3),('11288','2013-01-29','14:45:00',2.9),('11288','2013-01-29','14:50:00',2.84),('11288','2013-01-29','14:55:00',2.69),('11288','2013-01-29','15:00:00',2.55),('11288','2013-01-29','15:05:00',2.44),('11288','2013-01-29','15:10:00',2.36),('11288','2013-01-29','15:15:00',2.22),('11288','2013-01-29','15:20:00',2.03),('11288','2013-01-29','15:25:00',1.92),('11288','2013-01-29','15:30:00',1.8),('11288','2013-01-29','15:35:00',1.69),('11288','2013-01-29','15:40:00',1.6),('11288','2013-01-29','15:45:00',1.44),('11288','2013-01-29','15:50:00',1.25),('11288','2013-01-29','15:55:00',1.21),('11288','2013-01-29','16:00:00',1.11),('11288','2013-01-29','16:05:00',1.05),('11288','2013-01-28','10:50:00',1.02),('11288','2013-01-28','10:55:00',1.19),('11288','2013-01-28','11:00:00',1.4),('11288','2013-01-28','11:05:00',1.61),('11288','2013-01-28','11:10:00',1.65),('11288','2013-01-28','11:15:00',1.38),('11288','2013-01-28','11:20:00',1.37),('11288','2013-01-28','11:25:00',1.31),('11288','2013-01-28','11:30:00',1.16),('11288','2013-01-28','11:35:00',1.05),('11288','2013-01-28','11:40:00',1.03),('11288','2013-01-28','11:45:00',1.05),('11288','2013-01-28','12:30:00',1.11),('11288','2013-01-28','12:35:00',1.31),('11288','2013-01-28','12:40:00',1.65),('11288','2013-01-28','12:45:00',2.07),('11288','2013-01-28','12:50:00',2.33),('11288','2013-01-28','12:55:00',2.18),('11288','2013-01-28','13:00:00',1.99),('11288','2013-01-28','13:05:00',1.94),('11288','2013-01-28','13:10:00',1.78),('11288','2013-01-28','13:15:00',1.73),('11288','2013-01-28','13:20:00',1.73),('11288','2013-01-28','13:25:00',1.77),('11288','2013-01-28','13:30:00',1.71),('11288','2013-01-28','13:35:00',1.53),('11288','2013-01-28','13:40:00',1.39),('11288','2013-01-28','13:45:00',1.3),('11288','2013-01-28','13:50:00',1.22),('11288','2013-01-28','13:55:00',1.23),('11288','2013-01-28','14:00:00',1.31),('11288','2013-01-28','14:05:00',1.34),('11288','2013-01-28','14:10:00',1.3),('11288','2013-01-28','14:15:00',1.18),('11288','2013-01-28','14:20:00',1.08),('11288','2013-01-27','08:30:00',1.17),('11288','2013-01-27','08:35:00',1.39),('11288','2013-01-27','08:40:00',1.45),('11288','2013-01-27','08:45:00',1.31),('11288','2013-01-27','08:50:00',1.24),('11288','2013-01-27','08:55:00',1.59),('11288','2013-01-27','09:00:00',1.66),('11288','2013-01-27','09:05:00',1.71),('11288','2013-01-27','09:10:00',1.78),('11288','2013-01-27','09:15:00',1.85),('11288','2013-01-27','09:20:00',2.03),('11288','2013-01-27','09:25:00',2.07),('11288','2013-01-27','09:30:00',2.25),('11288','2013-01-27','09:35:00',2.37),('11288','2013-01-27','09:40:00',2.43),('11288','2013-01-27','09:45:00',2.49),('11288','2013-01-27','09:50:00',2.67),('11288','2013-01-27','09:55:00',2.64),('11288','2013-01-27','10:00:00',2.72),('11288','2013-01-27','10:05:00',2.93),('11288','2013-01-27','10:10:00',3.08),('11288','2013-01-27','10:15:00',3.2),('11288','2013-01-27','10:20:00',3.28),('11288','2013-01-27','10:25:00',3.29),('11288','2013-01-27','10:30:00',3.27),('11288','2013-01-27','10:35:00',3.54),('11288','2013-01-27','10:40:00',3.66),('11288','2013-01-27','10:45:00',3.74),('11288','2013-01-27','10:50:00',3.81),('11288','2013-01-27','10:55:00',3.84),('11288','2013-01-27','11:00:00',3.74),('11288','2013-01-27','11:05:00',3.97),('11288','2013-01-27','11:10:00',4.06),('11288','2013-01-27','11:15:00',4.11),('11288','2013-01-27','11:20:00',4.16),('11288','2013-01-27','11:25:00',4.25),('11288','2013-01-27','11:30:00',4.28),('11288','2013-01-27','11:35:00',4.29),('11288','2013-01-27','11:40:00',4.17),('11288','2013-01-27','11:45:00',3.89),('11288','2013-01-27','11:50:00',4.18),('11288','2013-01-27','11:55:00',4.4),('11288','2013-01-27','12:00:00',4.42),('11288','2013-01-27','12:05:00',4.42),('11288','2013-01-27','12:10:00',4.46),('11288','2013-01-27','12:15:00',4.47),('11288','2013-01-27','12:20:00',4.41),('11288','2013-01-27','12:25:00',4.45),('11288','2013-01-27','12:30:00',4.42),('11288','2013-01-27','12:35:00',4.39),('11288','2013-01-27','12:40:00',4.36),('11288','2013-01-27','12:45:00',4.31),('11288','2013-01-27','12:50:00',4.37),('11288','2013-01-27','12:55:00',4.38),('11288','2013-01-27','13:00:00',4.35),('11288','2013-01-27','13:05:00',4.35),('11288','2013-01-27','13:10:00',4.34),('11288','2013-01-27','13:15:00',4.25),('11288','2013-01-27','13:20:00',4.19),('11288','2013-01-27','13:25:00',4.08),('11288','2013-01-27','13:30:00',4),('11288','2013-01-27','13:35:00',3.93),('11288','2013-01-27','13:40:00',3.78),('11288','2013-01-27','13:45:00',3.75),('11288','2013-01-27','13:50:00',3.7),('11288','2013-01-27','13:55:00',3.56),('11288','2013-01-27','14:00:00',3.48),('11288','2013-01-27','14:05:00',3.42),('11288','2013-01-27','14:10:00',3.41),('11288','2013-01-27','14:15:00',3.32),('11288','2013-01-27','14:20:00',3.23),('11288','2013-01-27','14:25:00',3.11),('11288','2013-01-27','14:30:00',3),('11288','2013-01-27','14:35:00',2.9),('11288','2013-01-27','14:40:00',2.82),('11288','2013-01-27','14:45:00',2.79),('11288','2013-01-27','14:50:00',2.69),('11288','2013-01-27','14:55:00',2.59),('11288','2013-01-27','15:00:00',2.49),('11288','2013-01-27','15:05:00',2.34),('11288','2013-01-27','15:10:00',2.18),('11288','2013-01-27','15:15:00',2.04),('11288','2013-01-27','15:20:00',1.9),('11288','2013-01-27','15:25:00',1.82),('11288','2013-01-27','15:30:00',1.67),('11288','2013-01-27','15:35:00',1.56),('11288','2013-01-27','15:40:00',1.44),('11288','2013-01-27','15:45:00',1.31),('11288','2013-01-27','15:50:00',1.15),('11288','2013-01-27','15:55:00',1.15),('11288','2013-01-27','16:00:00',1.03),('11288','2013-01-26','08:55:00',1.29),('11288','2013-01-26','09:00:00',1.73),('11288','2013-01-26','09:05:00',1.65),('11288','2013-01-26','09:10:00',1.72),('11288','2013-01-26','09:15:00',1.72),('11288','2013-01-26','09:20:00',1.75),('11288','2013-01-26','09:25:00',1.6),('11288','2013-01-26','09:30:00',1.4),('11288','2013-01-26','09:35:00',1.55),('11288','2013-01-26','09:40:00',1.28),('11288','2013-01-26','09:45:00',1.23),('11288','2013-01-26','09:50:00',1.79),('11288','2013-01-26','09:55:00',1.76),('11288','2013-01-26','10:00:00',1.65),('11288','2013-01-26','10:05:00',1.38),('11288','2013-01-26','10:10:00',1.39),('11288','2013-01-26','10:15:00',1.81),('11288','2013-01-26','10:20:00',1.92),('11288','2013-01-26','10:25:00',2.04),('11288','2013-01-26','10:30:00',1.41),('11288','2013-01-26','10:35:00',1.43),('11288','2013-01-26','10:40:00',1.69),('11288','2013-01-26','10:45:00',1.8),('11288','2013-01-26','10:50:00',2.03),('11288','2013-01-26','10:55:00',1.74),('11288','2013-01-26','11:00:00',1.56),('11288','2013-01-26','11:05:00',1.93),('11288','2013-01-26','11:10:00',1.72),('11288','2013-01-26','11:15:00',1.72),('11288','2013-01-26','11:20:00',1.66),('11288','2013-01-26','11:25:00',1.85),('11288','2013-01-26','11:30:00',1.88),('11288','2013-01-26','11:35:00',1.65),('11288','2013-01-26','11:40:00',1.74),('11288','2013-01-26','11:45:00',1.61),('11288','2013-01-26','11:50:00',1.7),('11288','2013-01-26','11:55:00',1.54),('11288','2013-01-26','12:00:00',1.34),('11288','2013-01-26','12:05:00',1.36),('11288','2013-01-26','12:10:00',1.33),('11288','2013-01-26','12:15:00',1.38),('11288','2013-01-26','12:20:00',1.48),('11288','2013-01-26','12:25:00',1.67),('11288','2013-01-26','12:30:00',1.53),('11288','2013-01-26','12:35:00',1.53),('11288','2013-01-26','12:40:00',1.44),('11288','2013-01-26','12:45:00',1.51),('11288','2013-01-26','12:50:00',1.49),('11288','2013-01-26','12:55:00',1.13),('11288','2013-01-26','13:00:00',1.02),('11288','2013-01-26','13:05:00',1.29),('11288','2013-01-26','13:10:00',1.13),('11288','2013-01-26','13:30:00',1.04),('11288','2013-01-26','13:35:00',1.26),('11288','2013-01-26','13:40:00',1.31),('11288','2013-01-26','13:45:00',1.24),('11288','2013-01-26','13:50:00',1.13),('11288','2013-01-26','13:55:00',1.09),('11288','2013-01-26','14:20:00',1),('11288','2013-01-26','14:25:00',1.09),('11288','2013-01-26','14:30:00',1.04),('11288','2013-01-25','08:35:00',1.19),('11288','2013-01-25','08:40:00',1.31),('11288','2013-01-25','08:45:00',1.39),('11288','2013-01-25','08:50:00',1.35),('11288','2013-01-25','08:55:00',1.58),('11288','2013-01-25','09:00:00',1.73),('11288','2013-01-25','09:05:00',1.51),('11288','2013-01-25','09:10:00',1.8),('11288','2013-01-25','09:15:00',2.01),('11288','2013-01-25','09:20:00',2.15),('11288','2013-01-25','09:25:00',2.33),('11288','2013-01-25','09:30:00',2.47),('11288','2013-01-25','09:35:00',2.35),('11288','2013-01-25','09:40:00',2.29),('11288','2013-01-25','09:45:00',2.65),('11288','2013-01-25','09:50:00',3.05),('11288','2013-01-25','09:55:00',3.04),('11288','2013-01-25','10:00:00',3.14),('11288','2013-01-25','10:05:00',3.23),('11288','2013-01-25','10:10:00',3.32),('11288','2013-01-25','10:15:00',3.28),('11288','2013-01-25','10:20:00',3.4),('11288','2013-01-25','10:25:00',3.44),('11288','2013-01-25','10:30:00',2.72),('11288','2013-01-25','10:35:00',1.81),('11288','2013-01-25','10:40:00',3.98),('11288','2013-01-25','10:45:00',2.98),('11288','2013-01-25','10:50:00',3.58),('11288','2013-01-25','10:55:00',4.13),('11288','2013-01-25','11:00:00',2.6),('11288','2013-01-25','11:05:00',2.21),('11288','2013-01-25','11:10:00',3.74),('11288','2013-01-25','11:15:00',4.26),('11288','2013-01-25','11:20:00',4.28),('11288','2013-01-25','11:25:00',4.33),('11288','2013-01-25','11:30:00',4.46),('11288','2013-01-25','11:35:00',4.48),('11288','2013-01-25','11:40:00',4.4),('11288','2013-01-25','11:45:00',4.48),('11288','2013-01-25','11:50:00',4.56),('11288','2013-01-25','11:55:00',4.56),('11288','2013-01-25','12:00:00',4.5),('11288','2013-01-25','12:05:00',4.49),('11288','2013-01-25','12:10:00',4.55),('11288','2013-01-25','12:15:00',4.54),('11288','2013-01-25','12:20:00',4.32),('11288','2013-01-25','12:25:00',4.45),('11288','2013-01-25','12:30:00',4.14),('11288','2013-01-25','12:35:00',3.83),('11288','2013-01-25','12:40:00',4.26),('11288','2013-01-25','12:45:00',4.29),('11288','2013-01-25','12:50:00',4.23),('11288','2013-01-25','12:55:00',4.3),('11288','2013-01-25','13:00:00',4.18),('11288','2013-01-25','13:05:00',4.13),('11288','2013-01-25','13:10:00',4.12),('11288','2013-01-25','13:15:00',4.12),('11288','2013-01-25','13:20:00',4.09),('11288','2013-01-25','13:25:00',4.23),('11288','2013-01-25','13:30:00',4.32),('11288','2013-01-25','13:35:00',4.28),('11288','2013-01-25','13:40:00',4.12),('11288','2013-01-25','13:45:00',4.02),('11288','2013-01-25','13:50:00',3.88),('11288','2013-01-25','13:55:00',3.77),('11288','2013-01-25','14:00:00',3.63),('11288','2013-01-25','14:05:00',3.35),('11288','2013-01-25','14:10:00',3.27),('11288','2013-01-25','14:15:00',2.98),('11288','2013-01-25','14:20:00',2.98),('11288','2013-01-25','14:25:00',2.92),('11288','2013-01-25','14:30:00',2.75),('11288','2013-01-25','14:35:00',2.68),('11288','2013-01-25','14:40:00',2.55),('11288','2013-01-25','14:45:00',2.48),('11288','2013-01-25','14:50:00',2.4),('11288','2013-01-25','14:55:00',2.24),('11288','2013-01-25','15:00:00',2.14),('11288','2013-01-25','15:05:00',2.03),('11288','2013-01-25','15:10:00',1.9),('11288','2013-01-25','15:15:00',1.85),('11288','2013-01-25','15:20:00',1.81),('11288','2013-01-25','15:25:00',1.75),('11288','2013-01-25','15:30:00',1.77),('11288','2013-01-25','15:35:00',1.69),('11288','2013-01-25','15:40:00',1.54),('11288','2013-01-25','15:45:00',1.65),('11288','2013-01-25','15:50:00',1.5),('11288','2013-01-25','15:55:00',1.3),('11288','2013-01-24','08:50:00',1.08),('11288','2013-01-24','08:55:00',1.2),('11288','2013-01-24','09:00:00',1.15),('11288','2013-01-24','09:05:00',1.05),('11288','2013-01-24','09:10:00',1.04),('11288','2013-01-24','09:15:00',1.18),('11288','2013-01-24','09:20:00',1.34),('11288','2013-01-24','09:25:00',1.5),('11288','2013-01-24','09:30:00',1.46),('11288','2013-01-24','09:35:00',1.31),('11288','2013-01-24','09:40:00',1.55),('11288','2013-01-24','09:45:00',1.99),('11288','2013-01-24','09:50:00',2.66),('11288','2013-01-24','09:55:00',2.61),('11288','2013-01-24','10:00:00',2.87),('11288','2013-01-24','10:05:00',3.05),('11288','2013-01-24','10:10:00',3.3),('11288','2013-01-24','10:15:00',3.31),('11288','2013-01-24','10:20:00',3.41),('11288','2013-01-24','10:25:00',3.34),('11288','2013-01-24','10:30:00',3.35),('11288','2013-01-24','10:35:00',3.64),('11288','2013-01-24','10:40:00',3.79),('11288','2013-01-24','10:45:00',3.74),('11288','2013-01-24','10:50:00',3.69),('11288','2013-01-24','10:55:00',2.94),('11288','2013-01-24','11:00:00',2.08),('11288','2013-01-24','11:05:00',1.31),('11288','2013-01-24','12:35:00',1.24),('11288','2013-01-24','12:40:00',1.52),('11288','2013-01-24','12:45:00',1.71),('11288','2013-01-24','12:50:00',1.79),('11288','2013-01-24','12:55:00',1.76),('11288','2013-01-24','13:00:00',1.73),('11288','2013-01-24','13:05:00',1.69),('11288','2013-01-24','13:10:00',1.6),('11288','2013-01-24','13:15:00',1.54),('11288','2013-01-24','13:20:00',1.5),('11288','2013-01-24','13:25:00',1.54),('11288','2013-01-24','13:30:00',1.59),('11288','2013-01-24','13:35:00',1.56),('11288','2013-01-24','13:40:00',1.56),('11288','2013-01-24','13:45:00',1.59),('11288','2013-01-24','13:50:00',1.65),('11288','2013-01-24','13:55:00',1.79),('11288','2013-01-24','14:00:00',2.17),('11288','2013-01-24','14:05:00',2.05),('11288','2013-01-24','14:10:00',2.03),('11288','2013-01-24','14:15:00',2.25),('11288','2013-01-24','14:20:00',3.72),('11288','2013-01-24','14:25:00',4.77),('11288','2013-01-24','14:30:00',4.02),('11288','2013-01-24','14:35:00',2.59),('11288','2013-01-24','14:40:00',2.32),('11288','2013-01-24','14:45:00',2.75),('11288','2013-01-24','14:50:00',2.94),('11288','2013-01-24','14:55:00',2.8),('11288','2013-01-24','15:00:00',1.92),('11288','2013-01-24','15:05:00',1.41),('11288','2013-01-24','15:10:00',1.03),('11288','2013-01-24','15:15:00',1.17),('11288','2013-01-24','15:20:00',1.71),('11288','2013-01-24','15:25:00',1.69),('11288','2013-01-24','15:30:00',1.83),('11288','2013-01-24','15:35:00',1.33),('11288','2013-01-24','15:45:00',1.34),('11288','2013-01-24','15:50:00',1.27),('11288','2013-01-24','15:55:00',1.17),('11288','2013-01-24','16:00:00',1.03),('11288','2013-01-23','09:45:00',1.1),('11288','2013-01-23','09:50:00',1.33),('11288','2013-01-23','09:55:00',2.46),('11288','2013-01-23','10:00:00',1.51),('11288','2013-01-23','10:05:00',1.2),('11288','2013-01-23','10:10:00',1.04),('11288','2013-01-23','10:15:00',1.42),('11288','2013-01-23','10:20:00',1.39),('11288','2013-01-23','10:25:00',2.21),('11288','2013-01-23','10:30:00',3.55),('11288','2013-01-23','10:35:00',3.09),('11288','2013-01-23','10:40:00',2.53),('11288','2013-01-23','10:45:00',2.39),('11288','2013-01-23','10:50:00',3.32),('11288','2013-01-23','10:55:00',2.19),('11288','2013-01-23','11:00:00',1.29),('11288','2013-01-23','11:10:00',1.05),('11288','2013-01-22','08:45:00',1.07),('11288','2013-01-22','08:50:00',1.13),('11288','2013-01-22','08:55:00',1.21),('11288','2013-01-22','09:00:00',2.08),('11288','2013-01-22','09:05:00',1.64),('11288','2013-01-22','09:15:00',1),('11288','2013-01-22','09:25:00',1.22),('11288','2013-01-22','09:30:00',2.02),('11288','2013-01-22','09:35:00',2.33),('11288','2013-01-22','09:40:00',2.45),('11288','2013-01-22','09:45:00',3.36),('11288','2013-01-22','09:50:00',1.51),('11288','2013-01-22','09:55:00',2.21),('11288','2013-01-22','10:00:00',1.73),('11288','2013-01-22','10:05:00',2.51),('11288','2013-01-22','10:10:00',3.3),('11288','2013-01-22','10:15:00',2.69),('11288','2013-01-22','10:20:00',3.03),('11288','2013-01-22','10:25:00',3.45),('11288','2013-01-22','10:30:00',3.66),('11288','2013-01-22','10:35:00',3.83),('11288','2013-01-22','10:40:00',4.17),('11288','2013-01-22','10:45:00',3.49),('11288','2013-01-22','10:50:00',2.73),('11288','2013-01-22','10:55:00',1.97),('11288','2013-01-22','11:00:00',1.2),('11288','2013-01-22','11:05:00',1.43),('11288','2013-01-22','11:10:00',1.81),('11288','2013-01-22','11:15:00',2.12),('11288','2013-01-22','11:20:00',2.43),('11288','2013-01-22','11:25:00',1.55),('11288','2013-01-22','11:30:00',1.37),('11288','2013-01-22','11:35:00',1.35),('11288','2013-01-22','11:45:00',2.83),('11288','2013-01-22','11:50:00',3.09),('11288','2013-01-22','11:55:00',1.57),('11288','2013-01-22','12:00:00',1.59),('11288','2013-01-22','12:05:00',1.45),('11288','2013-01-22','12:10:00',4.63),('11288','2013-01-22','12:15:00',3.4),('11288','2013-01-22','12:20:00',3.22),('11288','2013-01-22','12:25:00',2.94),('11288','2013-01-22','12:30:00',1.73),('11288','2013-01-22','12:35:00',2.27),('11288','2013-01-22','12:40:00',4.22),('11288','2013-01-22','12:45:00',1.52),('11288','2013-01-22','12:50:00',2.2),('11288','2013-01-22','12:55:00',1.33),('11288','2013-01-22','13:00:00',4.51),('11288','2013-01-22','13:05:00',4.61),('11288','2013-01-22','13:10:00',3.62),('11288','2013-01-22','13:15:00',2.32),('11288','2013-01-22','13:20:00',3.01),('11288','2013-01-22','13:25:00',1.44),('11288','2013-01-22','13:30:00',1.2),('11288','2013-01-22','13:35:00',1.1),('11288','2013-01-22','13:40:00',1.76),('11288','2013-01-22','13:45:00',2.07),('11288','2013-01-22','13:50:00',1.66),('11288','2013-01-22','13:55:00',1.06),('11288','2013-01-22','14:00:00',1.37),('11288','2013-01-22','14:05:00',1.28),('11288','2013-01-22','14:10:00',2.45),('11288','2013-01-22','14:15:00',1.8),('11288','2013-01-22','14:20:00',1.68),('11288','2013-01-22','14:25:00',2.26),('11288','2013-01-22','14:30:00',1.11),('11288','2013-01-22','14:35:00',2.35),('11288','2013-01-22','14:40:00',2.5),('11288','2013-01-22','14:45:00',2.5),('11288','2013-01-22','14:50:00',1.6),('11288','2013-01-22','15:00:00',1.14),('11288','2013-01-22','15:05:00',1.02),('11288','2014-03-20','07:20:00',1.01),('11288','2014-03-20','07:25:00',1.06),('11288','2014-03-20','07:30:00',1.03),('11288','2014-03-20','07:35:00',1.22),('11288','2014-03-20','07:40:00',1.34),('11288','2014-03-20','07:45:00',1.41),('11288','2014-03-20','07:50:00',1.57),('11288','2014-03-20','07:55:00',1.66),('11288','2014-03-20','08:00:00',1.77),('11288','2014-03-20','08:05:00',1.99),('11288','2014-03-20','08:10:00',2.02),('11288','2014-03-20','08:15:00',2.16),('11288','2014-03-20','08:20:00',2.32),('11288','2014-03-20','08:25:00',2.38),('11288','2014-03-20','08:30:00',2.53),('11288','2014-03-20','08:35:00',2.76),('11288','2014-03-20','08:40:00',2.89),('11288','2014-03-20','08:45:00',3.02),('11288','2014-03-20','08:50:00',3.29),('11288','2014-03-20','08:55:00',3.44),('11288','2014-03-20','09:00:00',3.53),('11288','2014-03-20','09:05:00',3.69),('11288','2014-03-20','09:10:00',3.86),('11288','2014-03-20','09:15:00',3.94),('11288','2014-03-20','09:20:00',4.07),('11288','2014-03-20','09:25:00',4.15),('11288','2014-03-20','09:30:00',4.29),('11288','2014-03-20','09:35:00',4.43),('11288','2014-03-20','09:40:00',4.46),('11288','2014-03-20','09:45:00',4.5),('11288','2014-03-20','09:50:00',4.51),('11288','2014-03-20','09:55:00',4.59),('11288','2014-03-20','10:00:00',4.83),('11288','2014-03-20','10:05:00',5.01),('11288','2014-03-20','10:10:00',4.99),('11288','2014-03-20','10:15:00',5),('11288','2014-03-20','10:20:00',5.02),('11288','2014-03-20','10:25:00',5.11),('11288','2014-03-20','10:30:00',5.13),('11288','2014-03-20','10:35:00',4.97),('11288','2014-03-20','10:40:00',4.89),('11288','2014-03-20','10:45:00',5),('11288','2014-03-20','10:50:00',5.27),('11288','2014-03-20','10:55:00',5.57),('11288','2014-03-20','11:00:00',5.66),('11288','2014-03-20','11:05:00',5.62),('11288','2014-03-20','11:10:00',5.58),('11288','2014-03-20','11:15:00',5.36),('11288','2014-03-20','11:20:00',5.72),('11288','2014-03-20','11:25:00',5.72),('11288','2014-03-20','11:30:00',5.89),('11288','2014-03-20','11:35:00',6.02),('11288','2014-03-20','11:40:00',5.96),('11288','2014-03-20','11:45:00',5.91),('11288','2014-03-20','11:50:00',6.06),('11288','2014-03-20','11:55:00',5.44),('11288','2014-03-20','12:00:00',5.3),('11288','2014-03-20','12:05:00',5.85),('11288','2014-03-20','12:10:00',5.96),('11288','2014-03-20','12:15:00',5.93),('11288','2014-03-20','12:20:00',5.78),('11288','2014-03-20','12:25:00',5.6),('11288','2014-03-20','12:30:00',5.77),('11288','2014-03-20','12:35:00',5.86),('11288','2014-03-20','12:40:00',5.92),('11288','2014-03-20','12:45:00',6.02),('11288','2014-03-20','12:50:00',5.91),('11288','2014-03-20','12:55:00',5.9),('11288','2014-03-20','13:00:00',5.81),('11288','2014-03-20','13:05:00',5.72),('11288','2014-03-20','13:10:00',5.68),('11288','2014-03-20','13:15:00',5.58),('11288','2014-03-20','13:20:00',5.6),('11288','2014-03-20','13:25:00',5.39),('11288','2014-03-20','13:30:00',5.58),('11288','2014-03-20','13:35:00',5.37),('11288','2014-03-20','13:40:00',5.14),('11288','2014-03-20','13:45:00',4.96),('11288','2014-03-20','13:50:00',4.77),('11288','2014-03-20','13:55:00',4.37),('11288','2014-03-20','14:00:00',4.74),('11288','2014-03-20','14:05:00',5.14),('11288','2014-03-20','14:10:00',4.88),('11288','2014-03-20','14:15:00',4.63),('11288','2014-03-20','14:20:00',4.49),('11288','2014-03-20','14:25:00',4.47),('11288','2014-03-20','14:30:00',3.73),('11288','2014-03-20','14:35:00',3.61),('11288','2014-03-20','14:40:00',4),('11288','2014-03-20','14:45:00',3.85),('11288','2014-03-20','14:50:00',3.63),('11288','2014-03-20','14:55:00',3.53),('11288','2014-03-20','15:00:00',3.25),('11288','2014-03-20','15:05:00',3.29),('11288','2014-03-20','15:10:00',3.28),('11288','2014-03-20','15:15:00',3.16),('11288','2014-03-20','15:20:00',3.36),('11288','2014-03-20','15:25:00',3.03),('11288','2014-03-20','15:30:00',2.9),('11288','2014-03-20','15:35:00',2.75),('11288','2014-03-20','15:40:00',2.54),('11288','2014-03-20','15:45:00',2.54),('11288','2014-03-20','15:50:00',2.2),('11288','2014-03-20','15:55:00',2.02),('11288','2014-03-20','16:00:00',1.74),('11288','2014-03-20','16:05:00',1.57),('11288','2014-03-20','16:10:00',1.58),('11288','2014-03-20','16:15:00',1.51),('11288','2014-03-20','16:20:00',1.59),('11288','2014-03-20','16:25:00',1.61),('11288','2014-03-20','16:30:00',1.48),('11288','2014-03-20','16:35:00',1.37),('11288','2014-03-20','16:40:00',1.27),('11288','2013-01-21','10:10:00',1.19),('11288','2013-01-21','10:15:00',1.29),('11288','2013-01-21','10:20:00',1.12),('11288','2013-01-21','10:25:00',1.18),('11288','2013-01-21','10:30:00',1.11),('11288','2013-01-21','10:45:00',1.01),('11288','2013-01-21','10:55:00',1.24),('11288','2013-01-21','11:00:00',1.69),('11288','2013-01-21','11:05:00',1.58),('11288','2013-01-21','11:10:00',2.13),('11288','2013-01-21','11:15:00',2.27),('11288','2013-01-21','11:20:00',1.99),('11288','2013-01-21','11:25:00',1.85),('11288','2013-01-21','11:30:00',1.32),('11288','2013-01-21','11:40:00',1.59),('11288','2013-01-21','11:45:00',1.53),('11288','2013-01-21','11:50:00',3.02),('11288','2013-01-21','11:55:00',4.58),('11288','2013-01-21','12:00:00',4.27),('11288','2013-01-21','12:05:00',4.21),('11288','2013-01-21','12:10:00',4.24),('11288','2013-01-21','12:15:00',3.08),('11288','2013-01-21','12:20:00',1.97),('11288','2013-01-21','12:25:00',2.43),('11288','2013-01-21','12:30:00',1.19),('11288','2013-01-21','12:35:00',1.57),('11288','2013-01-21','12:40:00',1.55),('11288','2013-01-21','12:45:00',1.38),('11288','2013-01-21','12:50:00',2.47),('11288','2013-01-21','12:55:00',1.72),('11288','2013-01-21','13:00:00',1.78),('11288','2013-01-21','13:05:00',3.02),('11288','2013-01-21','13:10:00',2.34),('11288','2013-01-21','13:15:00',1.64),('11288','2013-01-21','13:20:00',1.59),('11288','2013-01-21','13:25:00',1.6),('11288','2013-01-21','13:30:00',4.15),('11288','2013-01-21','13:35:00',3.71),('11288','2013-01-21','13:40:00',3.65),('11288','2013-01-21','13:45:00',1.46),('11288','2013-01-21','13:50:00',3.52),('11288','2013-01-21','13:55:00',4.67),('11288','2013-01-21','14:00:00',2.88),('11288','2013-01-21','14:05:00',3.87),('11288','2013-01-21','14:10:00',3.17),('11288','2013-01-21','14:15:00',1.77),('11288','2013-01-21','14:20:00',3.21),('11288','2013-01-21','14:25:00',2.62),('11288','2013-01-21','14:30:00',2.07),('11288','2013-01-21','14:35:00',1.37),('11288','2013-01-21','14:40:00',1.03),('11288','2013-01-20','08:30:00',1.03),('11288','2013-01-20','08:35:00',1.09),('11288','2013-01-20','08:40:00',1.07),('11288','2013-01-20','10:00:00',1.01),('11288','2013-01-20','10:05:00',1.02),('11288','2013-01-20','10:25:00',1.1),('11288','2013-01-20','10:30:00',1.23),('11288','2013-01-20','10:35:00',1.06),('11288','2013-01-20','10:40:00',1.32),('11288','2013-01-20','10:45:00',1.5),('11288','2013-01-20','10:50:00',1.73),('11288','2013-01-20','10:55:00',1.85),('11288','2013-01-20','11:00:00',2.06),('11288','2013-01-20','11:05:00',2.15),('11288','2013-01-20','11:10:00',2.34),('11288','2013-01-20','11:15:00',2.83),('11288','2013-01-20','11:20:00',2.36),('11288','2013-01-20','11:25:00',3.06),('11288','2013-01-20','11:30:00',3.67),('11288','2013-01-20','11:35:00',2.95),('11288','2013-01-20','11:40:00',1.94),('11288','2013-01-20','11:45:00',1.84),('11288','2013-01-20','11:50:00',1.33),('11288','2013-01-20','11:55:00',1.01),('11288','2013-01-20','12:00:00',1.1),('11288','2013-01-20','12:05:00',1.06),('11288','2013-01-20','12:10:00',1.28),('11288','2013-01-20','12:15:00',1.55),('11288','2013-01-20','12:20:00',1.73),('11288','2013-01-20','12:25:00',1.78),('11288','2013-01-20','12:30:00',1.64),('11288','2013-01-20','12:35:00',1.51),('11288','2013-01-20','12:40:00',1.4),('11288','2013-01-20','12:45:00',1.37),('11288','2013-01-20','12:50:00',1.33),('11288','2013-01-20','12:55:00',1.31),('11288','2013-01-20','13:00:00',1.25),('11288','2013-01-20','13:05:00',1.2),('11288','2013-01-20','13:10:00',1.23),('11288','2013-01-20','13:15:00',1.36),('11288','2013-01-20','13:20:00',1.38),('11288','2013-01-20','13:25:00',1.38),('11288','2013-01-20','13:30:00',1.29),('11288','2013-01-20','13:35:00',1.45),('11288','2013-01-20','13:40:00',1.65),('11288','2013-01-20','13:45:00',1.6),('11288','2013-01-20','13:50:00',1.54),('11288','2013-01-20','13:55:00',1.35),('11288','2013-01-20','14:00:00',1.2),('11288','2013-01-20','14:05:00',1.06),('11288','2013-01-20','14:15:00',1.09),('11288','2013-01-20','14:20:00',1.29),('11288','2013-01-20','14:25:00',1.11),('11288','2013-01-19','09:00:00',1.04),('11288','2013-01-19','09:05:00',1.14),('11288','2013-01-19','09:10:00',1.52),('11288','2013-01-19','09:15:00',1.93),('11288','2013-01-19','09:20:00',1.82),('11288','2013-01-19','09:25:00',1.54),('11288','2013-01-19','09:30:00',1.32),('11288','2013-01-19','09:35:00',1.2),('11288','2013-01-19','09:40:00',1.09),('11288','2013-01-19','09:45:00',1.49),('11288','2013-01-19','09:50:00',1.89),('11288','2013-01-19','09:55:00',2.47),('11288','2013-01-19','10:00:00',2.33),('11288','2013-01-19','10:05:00',1.87),('11288','2013-01-19','10:10:00',1.3),('11288','2013-01-19','10:25:00',1.09),('11288','2013-01-19','10:30:00',1.05),('11288','2013-01-19','10:35:00',1.74),('11288','2013-01-19','10:40:00',2.01),('11288','2013-01-19','10:45:00',2.44),('11288','2013-01-19','10:50:00',2.29),('11288','2013-01-19','10:55:00',1.27),('11288','2013-01-19','11:00:00',1.44),('11288','2013-01-19','11:05:00',1.48),('11288','2013-01-19','11:10:00',1.63),('11288','2013-01-19','11:15:00',1.72),('11288','2013-01-19','11:20:00',2.13),('11288','2013-01-19','11:25:00',2.07),('11288','2013-01-19','11:30:00',1.65),('11288','2013-01-19','11:35:00',1.18),('11288','2013-01-19','11:40:00',1.02),('11288','2013-01-19','11:45:00',1.25),('11288','2013-01-19','11:50:00',1.33),('11288','2013-01-19','11:55:00',1.2),('11288','2013-01-19','12:05:00',1.1),('11288','2013-01-19','12:10:00',1.22),('11288','2013-01-19','12:15:00',1.28),('11288','2013-01-19','12:20:00',1.17),('11288','2013-01-19','14:30:00',1.06),('11288','2013-01-19','14:35:00',1.13),('11288','2013-01-18','08:45:00',1.13),('11288','2013-01-18','08:50:00',1.15),('11288','2013-01-18','08:58:00',1.09),('11288','2013-01-18','09:58:00',1.04),('11288','2013-01-18','10:00:00',1.07),('11288','2013-01-18','10:05:00',1.14),('11288','2013-01-18','10:10:00',1.53),('11288','2013-01-18','10:15:00',3.44),('11288','2013-01-18','10:20:00',3.78),('11288','2013-01-18','10:25:00',2.73),('11288','2013-01-18','10:30:00',2.22),('11288','2013-01-18','10:35:00',1.86),('11288','2013-01-18','10:40:00',1.52),('11288','2013-01-18','10:45:00',1.4),('11288','2013-01-18','10:50:00',1.44),('11288','2013-01-18','10:55:00',1.48),('11288','2013-01-18','11:00:00',1.56),('11288','2013-01-18','11:05:00',1.67),('11288','2013-01-18','11:10:00',1.62),('11288','2013-01-18','11:15:00',1.58),('11288','2013-01-18','11:20:00',1.42),('11288','2013-01-18','11:25:00',1.56),('11288','2013-01-18','11:30:00',1.96),('11288','2013-01-18','11:35:00',2.25),('11288','2013-01-18','11:40:00',2.04),('11288','2013-01-18','11:45:00',1.72),('11288','2013-01-18','11:50:00',1.48),('11288','2013-01-18','11:55:00',1.54),('11288','2013-01-18','12:00:00',1.66),('11288','2013-01-18','12:05:00',1.68),('11288','2013-01-18','12:10:00',1.89),('11288','2013-01-18','12:15:00',1.92),('11288','2013-01-18','12:20:00',1.92),('11288','2013-01-18','12:25:00',1.96),('11288','2013-01-18','12:30:00',1.95),('11288','2013-01-18','12:35:00',2.29),('11288','2013-01-18','12:40:00',2.4),('11288','2013-01-18','12:45:00',2.53),('11288','2013-01-18','12:50:00',3.14),('11288','2013-01-18','12:55:00',3.46),('11288','2013-01-18','13:00:00',4.27),('11288','2013-01-18','13:05:00',4.33),('11288','2013-01-18','13:10:00',3.99),('11288','2013-01-18','13:15:00',4.08),('11288','2013-01-18','13:20:00',3.26),('11288','2013-01-18','13:25:00',2.57),('11288','2013-01-18','13:30:00',2.39),('11288','2013-01-18','13:35:00',2.17),('11288','2013-01-18','13:40:00',3.27),('11288','2013-01-18','13:45:00',4.47),('11288','2013-01-18','13:50:00',4.48),('11288','2013-01-18','13:55:00',4.57),('11288','2013-01-18','14:00:00',4.38),('11288','2013-01-18','14:05:00',4.43),('11288','2013-01-18','14:10:00',3.76),('11288','2013-01-18','14:15:00',4.18),('11288','2013-01-18','14:20:00',3.46),('11288','2013-01-18','14:25:00',2.52),('11288','2013-01-18','14:30:00',2.06),('11288','2013-01-18','14:35:00',1.75),('11288','2013-01-18','14:40:00',1.61),('11288','2013-01-18','14:45:00',1.61),('11288','2013-01-18','14:50:00',1.64),('11288','2013-01-18','14:55:00',1.59),('11288','2013-01-18','15:00:00',1.38),('11288','2013-01-18','15:05:00',1.4),('11288','2013-01-18','15:10:00',1.35),('11288','2013-01-18','15:15:00',1.42),('11288','2013-01-18','15:20:00',1.14),('11288','2013-01-18','15:25:00',1.06),('11288','2013-01-18','15:30:00',1.07),('11288','2013-01-17','09:10:00',1.32),('11288','2013-01-17','09:15:00',1.34),('11288','2013-01-17','09:20:00',1.27),('11288','2013-01-17','09:25:00',1.12),('11288','2013-01-17','09:30:00',1.27),('11288','2013-01-17','09:35:00',1.34),('11288','2013-01-17','09:40:00',1.49),('11288','2013-01-17','09:45:00',1.76),('11288','2013-01-17','09:50:00',1.93),('11288','2013-01-17','09:55:00',1.87),('11288','2013-01-17','10:00:00',1.6),('11288','2013-01-17','10:05:00',1.7),('11288','2013-01-17','10:10:00',1.98),('11288','2013-01-17','10:15:00',2.23),('11288','2013-01-17','10:20:00',2.14),('11288','2013-01-17','10:25:00',2.55),('11288','2013-01-17','10:30:00',2.6),('11288','2013-01-17','10:35:00',2.49),('11288','2013-01-17','10:40:00',2.52),('11288','2013-01-17','10:45:00',2.59),('11288','2013-01-17','10:50:00',2.52),('11288','2013-01-17','10:55:00',2.79),('11288','2013-01-17','11:00:00',2.6),('11288','2013-01-17','11:05:00',2.58),('11288','2013-01-17','11:10:00',2.95),('11288','2013-01-17','11:15:00',2.88),('11288','2013-01-17','11:20:00',2.75),('11288','2013-01-17','11:25:00',2.41),('11288','2013-01-17','11:30:00',2.19),('11288','2013-01-17','11:35:00',2.43),('11288','2013-01-17','11:40:00',2.39),('11288','2013-01-17','11:45:00',2.25),('11288','2013-01-17','11:50:00',2.39),('11288','2013-01-17','11:55:00',2.55),('11288','2013-01-17','12:00:00',2.85),('11288','2013-01-17','12:05:00',2.87),('11288','2013-01-17','12:10:00',2.99),('11288','2013-01-17','12:15:00',3.26),('11288','2013-01-17','12:20:00',2.91),('11288','2013-01-17','12:25:00',2.7),('11288','2013-01-17','12:30:00',2.24),('11288','2013-01-17','12:35:00',2.62),('11288','2013-01-17','12:40:00',2.58),('11288','2013-01-17','12:45:00',2.32),('11288','2013-01-17','12:50:00',1.59),('11288','2013-01-17','12:55:00',2.02),('11288','2013-01-17','13:00:00',2.64),('11288','2013-01-17','13:05:00',2.3),('11288','2013-01-17','13:10:00',1.96),('11288','2013-01-17','13:15:00',2.39),('11288','2013-01-17','13:20:00',2.37),('11288','2013-01-17','13:25:00',2.1),('11288','2013-01-17','13:30:00',1.94),('11288','2013-01-17','13:35:00',2.45),('11288','2013-01-17','13:40:00',2.43),('11288','2013-01-17','13:45:00',2.24),('11288','2013-01-17','13:50:00',1.83),('11288','2013-01-17','13:55:00',1.48),('11288','2013-01-17','14:00:00',2.01),('11288','2013-01-17','14:05:00',1.81),('11288','2013-01-17','14:10:00',1.43),('11288','2013-01-17','14:15:00',1.02),('11288','2013-01-17','14:20:00',1.3),('11288','2013-01-17','14:25:00',1.61),('11288','2013-01-17','14:30:00',2.13),('11288','2013-01-17','14:35:00',2.57),('11288','2013-01-17','14:40:00',1.14),('11288','2013-01-17','14:55:00',1.3),('11288','2013-01-17','15:00:00',1.27),('11288','2013-01-16','09:15:00',1.53),('11288','2013-01-16','09:20:00',1.43),('11288','2013-01-16','09:25:00',2.02),('11288','2013-01-16','09:30:00',2.08),('11288','2013-01-16','09:35:00',2.18),('11288','2013-01-16','09:40:00',2.15),('11288','2013-01-16','09:45:00',1.36),('11288','2013-01-16','09:55:00',1.54),('11288','2013-01-16','10:00:00',1.51),('11288','2013-01-16','10:30:00',1.32),('11288','2013-01-16','10:35:00',2.58),('11288','2013-01-16','10:40:00',2.57),('11288','2013-01-16','10:45:00',2.7),('11288','2013-01-16','10:50:00',1.43),('11288','2013-01-16','10:55:00',2.43),('11288','2013-01-16','11:00:00',1.32),('11288','2013-01-16','11:05:00',1.32),('11288','2013-01-16','11:25:00',2.52),('11288','2013-01-16','12:00:00',3.01),('11288','2013-01-16','12:05:00',2.25),('11288','2013-01-16','12:10:00',3.11),('11288','2013-01-16','12:15:00',5.41),('11288','2013-01-16','12:20:00',4.8),('11288','2013-01-16','12:25:00',1.17),('11288','2013-01-16','13:00:00',1.12),('11288','2013-01-16','13:05:00',3.89),('11288','2013-01-16','13:10:00',5.18),('11288','2013-01-16','13:15:00',5.58),('11288','2013-01-16','13:20:00',3.82),('11288','2013-01-16','13:25:00',2.5),('11288','2013-01-16','13:30:00',1.1),('11288','2013-01-16','13:50:00',1.03),('11288','2013-01-16','13:55:00',4.3),('11288','2013-01-16','14:00:00',3.11),('11288','2013-01-16','14:05:00',2.12),('11288','2013-01-16','15:00:00',1.05),('11288','2013-01-16','15:05:00',1.52),('11288','2013-01-16','15:10:00',1.34),('11288','2013-01-15','09:15:00',1.13),('11288','2013-01-15','09:55:00',1.74),('11288','2013-01-15','10:00:00',1.73),('11288','2013-01-15','10:05:00',1.38),('11288','2013-01-15','10:10:00',2.15),('11288','2013-01-15','10:15:00',1.45),('11288','2013-01-15','10:20:00',1.57),('11288','2013-01-15','10:25:00',1.67),('11288','2013-01-15','10:30:00',1.25),('11288','2013-01-15','10:35:00',1.36),('11288','2013-01-15','10:40:00',1.6),('11288','2013-01-15','10:45:00',1.83),('11288','2013-01-15','10:50:00',2.24),('11288','2013-01-15','10:55:00',2.44),('11288','2013-01-15','11:00:00',2.42),('11288','2013-01-15','11:05:00',2.51),('11288','2013-01-15','11:10:00',2.55),('11288','2013-01-15','11:15:00',2.42),('11288','2013-01-15','11:20:00',2.48),('11288','2013-01-15','11:25:00',2.46),('11288','2013-01-15','11:30:00',2.36),('11288','2013-01-15','11:35:00',2.23),('11288','2013-01-15','11:40:00',2.03),('11288','2013-01-15','11:45:00',1.92),('11288','2013-01-15','11:50:00',1.85),('11288','2013-01-15','11:55:00',1.99),('11288','2013-01-15','12:00:00',1.86),('11288','2013-01-15','12:05:00',1.77),('11288','2013-01-15','12:10:00',1.72),('11288','2013-01-15','12:15:00',1.98),('11288','2013-01-15','12:20:00',2.22),('11288','2013-01-15','12:25:00',2.18),('11288','2013-01-15','12:30:00',2.08),('11288','2013-01-15','12:35:00',2.1),('11288','2013-01-15','12:40:00',2.34),('11288','2013-01-15','12:45:00',2.33),('11288','2013-01-15','12:50:00',2.37),('11288','2013-01-15','12:55:00',2.01),('11288','2013-01-15','13:00:00',1.72),('11288','2013-01-15','13:05:00',1.81),('11288','2013-01-15','13:10:00',1.82),('11288','2013-01-15','13:15:00',1.88),('11288','2013-01-15','13:20:00',1.88),('11288','2013-01-15','13:25:00',1.84),('11288','2013-01-15','13:30:00',2),('11288','2013-01-15','13:35:00',2.06),('11288','2013-01-15','13:40:00',2.33),('11288','2013-01-15','13:45:00',2.11),('11288','2013-01-15','13:50:00',2.01),('11288','2013-01-15','13:55:00',2.44),('11288','2013-01-15','14:00:00',3.03),('11288','2013-01-15','14:05:00',3.2),('11288','2013-01-15','14:10:00',2.29),('11288','2013-01-15','14:15:00',3.1),('11288','2013-01-15','14:20:00',2.78),('11288','2013-01-15','14:25:00',2.7),('11288','2013-01-15','14:30:00',2.99),('11288','2013-01-15','14:35:00',1.57),('11288','2013-01-15','14:40:00',1.87),('11288','2013-01-15','14:45:00',2.43),('11288','2013-01-15','14:50:00',1.61),('11288','2013-01-15','14:55:00',1.92),('11288','2013-01-15','15:00:00',2.25),('11288','2013-01-15','15:05:00',2.14),('11288','2013-01-15','15:10:00',1.72),('11288','2013-01-15','15:15:00',1.25),('11288','2013-01-15','15:20:00',1.44),('11288','2013-01-15','15:25:00',1.24),('11288','2013-01-15','15:30:00',1.22),('11288','2013-01-15','15:45:00',1.01),('11288','2013-01-15','15:50:00',1.03),('11288','2013-01-15','15:55:00',1.02),('11288','2013-01-15','16:00:00',1.03),('11288','2013-01-15','16:05:00',1.09),('11288','2013-01-15','16:10:00',1.01),('11288','2013-01-14','09:50:00',1.08),('11288','2013-01-14','10:25:00',1.07),('11288','2013-01-14','11:20:00',1.26),('11288','2013-01-14','11:25:00',1.28),('11288','2013-01-14','11:30:00',1.02),('11288','2013-01-14','11:50:00',1.14),('11288','2013-01-14','12:20:00',1.27),('11288','2013-01-14','12:25:00',1.6),('11288','2013-01-14','12:30:00',1.57),('11288','2013-01-14','12:35:00',1.51),('11288','2013-01-14','12:40:00',1.72),('11288','2013-01-14','12:45:00',1.92),('11288','2013-01-14','12:50:00',2.12),('11288','2013-01-14','12:55:00',2.08),('11288','2013-01-14','13:00:00',2.13),('11288','2013-01-14','13:05:00',2.04),('11288','2013-01-14','13:10:00',1.65),('11288','2013-01-14','13:15:00',1.49),('11288','2013-01-14','13:35:00',1.29),('11288','2013-01-14','13:40:00',1.01),('11288','2013-01-14','15:15:00',1.77),('11288','2013-01-14','15:20:00',1.53),('11288','2013-01-14','15:25:00',1.53),('11288','2013-01-13','09:10:00',1.04),('11288','2013-01-13','09:15:00',2.32),('11288','2013-01-13','09:20:00',2.41),('11288','2013-01-13','09:25:00',2.38),('11288','2013-01-13','09:30:00',2.44),('11288','2013-01-13','09:35:00',2.44),('11288','2013-01-13','09:40:00',1.61),('11288','2013-01-13','09:45:00',1.59),('11288','2013-01-13','09:50:00',2.08),('11288','2013-01-13','09:55:00',2.25),('11288','2013-01-13','10:00:00',2.36),('11288','2013-01-13','10:05:00',2.61),('11288','2013-01-13','10:10:00',1.62),('11288','2013-01-13','10:15:00',1.59),('11288','2013-01-13','10:20:00',1.84),('11288','2013-01-13','10:25:00',2.1),('11288','2013-01-13','10:30:00',2.62),('11288','2013-01-13','10:35:00',1.56),('11288','2013-01-13','10:40:00',1.01),('11288','2013-01-13','12:15:00',1.03),('11288','2013-01-13','12:20:00',1.08),('11288','2013-01-12','08:50:00',1.03),('11288','2013-01-12','08:55:00',1.23),('11288','2013-01-12','09:00:00',1.34),('11288','2013-01-12','09:05:00',1.44),('11288','2013-01-12','09:10:00',1.53),('11288','2013-01-12','09:15:00',1.63),('11288','2013-01-12','09:20:00',1.7),('11288','2013-01-12','09:25:00',1.79),('11288','2013-01-12','09:30:00',1.86),('11288','2013-01-12','09:35:00',1.9),('11288','2013-01-12','09:40:00',2),('11288','2013-01-12','09:45:00',2.07),('11288','2013-01-12','09:50:00',2.17),('11288','2013-01-12','09:55:00',2.25),('11288','2013-01-12','10:00:00',2.35),('11288','2013-01-12','10:05:00',2.43),('11288','2013-01-12','10:10:00',2.5),('11288','2013-01-12','10:15:00',2.51),('11288','2013-01-12','10:20:00',2.57),('11288','2013-01-12','10:25:00',2.83),('11288','2013-01-12','10:30:00',2.96),('11288','2013-01-12','10:35:00',3.03),('11288','2013-01-12','10:40:00',3.11),('11288','2013-01-12','10:45:00',3.18),('11288','2013-01-12','10:50:00',3.09),('11288','2013-01-12','10:55:00',3.25),('11288','2013-01-12','11:00:00',3.36),('11288','2013-01-12','11:05:00',3.41),('11288','2013-01-12','11:10:00',3.43),('11288','2013-01-12','11:15:00',3.46),('11288','2013-01-12','11:20:00',3.5),('11288','2013-01-12','11:25:00',3.57),('11288','2013-01-12','11:30:00',3.56),('11288','2013-01-12','11:35:00',3.4),('11288','2013-01-12','11:40:00',3.21),('11288','2013-01-12','11:45:00',3.63),('11288','2013-01-12','11:50:00',3.69),('11288','2013-01-12','11:55:00',3.71),('11288','2013-01-12','12:00:00',3.7),('11288','2013-01-12','12:05:00',3.66),('11288','2013-01-12','12:10:00',3.63),('11288','2013-01-12','12:15:00',3.57),('11288','2013-01-12','12:20:00',3.61),('11288','2013-01-12','12:25:00',3.58),('11288','2013-01-12','12:30:00',3.58),('11288','2013-01-12','12:35:00',3.57),('11288','2013-01-12','12:40:00',3.05),('11288','2013-01-12','12:45:00',3.01),('11288','2013-01-12','12:50:00',2.21),('11288','2013-01-12','12:55:00',1.8),('11288','2013-01-12','13:00:00',3.25),('11288','2013-01-12','13:05:00',3.63),('11288','2013-01-12','13:10:00',3.48),('11288','2013-01-12','13:15:00',2.08),('11288','2013-01-12','13:20:00',1.46),('11288','2013-01-12','13:25:00',2.27),('11288','2013-01-12','13:30:00',2.76),('11288','2013-01-12','13:35:00',1.94),('11288','2013-01-12','13:40:00',1.38),('11288','2013-01-12','13:45:00',2.82),('11288','2013-01-12','13:50:00',3.04),('11288','2013-01-12','13:55:00',3.22),('11288','2013-01-12','14:00:00',2.31),('11288','2013-01-12','14:05:00',3.17),('11288','2013-01-12','14:10:00',2.19),('11288','2013-01-12','14:15:00',1.69),('11288','2013-01-12','14:20:00',2.08),('11288','2013-01-12','14:25:00',2.02),('11288','2013-01-12','14:30:00',2.29),('11288','2013-01-12','14:35:00',2.23),('11288','2013-01-12','14:40:00',2.14),('11288','2013-01-12','14:45:00',2.04),('11288','2013-01-12','14:50:00',1.94),('11288','2013-01-12','14:55:00',1.85),('11288','2013-01-12','15:00:00',1.73),('11288','2013-01-12','15:05:00',1.46),('11288','2013-01-12','15:10:00',1.23),('11288','2013-01-12','15:15:00',1.34),('11288','2013-01-12','15:20:00',1.08),('11288','2014-03-19','08:25:00',1.04),('11288','2014-03-19','08:30:00',1.14),('11288','2014-03-19','08:35:00',1.25),('11288','2014-03-19','08:40:00',1.39),('11288','2014-03-19','08:45:00',1.6),('11288','2014-03-19','08:50:00',1.69),('11288','2014-03-19','08:55:00',1.7),('11288','2014-03-19','09:00:00',1.8),('11288','2014-03-19','09:05:00',2.15),('11288','2014-03-19','09:10:00',2.39),('11288','2014-03-19','09:15:00',2.79),('11288','2014-03-19','09:20:00',2.75),('11288','2014-03-19','09:25:00',4.25),('11288','2014-03-19','09:30:00',4.66),('11288','2014-03-19','09:35:00',5.26),('11288','2014-03-19','09:40:00',4.56),('11288','2014-03-19','09:45:00',3.9),('11288','2014-03-19','09:50:00',4.21),('11288','2014-03-19','09:55:00',2.72),('11288','2014-03-19','10:00:00',2.2),('11288','2014-03-19','10:05:00',1.65),('11288','2014-03-19','10:10:00',1.45),('11288','2014-03-19','10:15:00',1.44),('11288','2014-03-19','10:20:00',1.61),('11288','2014-03-19','10:25:00',1.86),('11288','2014-03-19','10:30:00',2.74),('11288','2014-03-19','10:35:00',4.32),('11288','2014-03-19','10:40:00',2.82),('11288','2014-03-19','10:45:00',2.61),('11288','2014-03-19','10:50:00',2.49),('11288','2014-03-19','10:55:00',3.16),('11288','2014-03-19','11:00:00',6.4),('11288','2014-03-19','11:05:00',5.95),('11288','2014-03-19','11:10:00',3.2),('11288','2014-03-19','11:15:00',3.15),('11288','2014-03-19','11:20:00',2.83),('11288','2014-03-19','11:25:00',3.08),('11288','2014-03-19','11:30:00',4),('11288','2014-03-19','11:35:00',4.83),('11288','2014-03-19','11:40:00',3.39),('11288','2014-03-19','11:45:00',3.15),('11288','2014-03-19','11:50:00',2.9),('11288','2014-03-19','11:55:00',2.84),('11288','2014-03-19','12:00:00',3.61),('11288','2014-03-19','12:05:00',5.47),('11288','2014-03-19','12:10:00',4.59),('11288','2014-03-19','12:15:00',3.03),('11288','2014-03-19','12:20:00',6.18),('11288','2014-03-19','12:25:00',4.77),('11288','2014-03-19','12:30:00',5.47),('11288','2014-03-19','12:35:00',3.94),('11288','2014-03-19','12:40:00',6.11),('11288','2014-03-19','12:45:00',5.61),('11288','2014-03-19','12:50:00',3.32),('11288','2014-03-19','12:55:00',6.26),('11288','2014-03-19','13:00:00',5.92),('11288','2014-03-19','13:05:00',5.77),('11288','2014-03-19','13:10:00',5.73),('11288','2014-03-19','13:15:00',5.57),('11288','2014-03-19','13:20:00',5.26),('11288','2014-03-19','13:25:00',5.04),('11288','2014-03-19','13:30:00',5.59),('11288','2014-03-19','13:35:00',5.61),('11288','2014-03-19','13:40:00',5.4),('11288','2014-03-19','13:45:00',5.39),('11288','2014-03-19','13:50:00',5.19),('11288','2014-03-19','13:55:00',5.38),('11288','2014-03-19','14:00:00',5.03),('11288','2014-03-19','14:05:00',5.36),('11288','2014-03-19','14:10:00',5.23),('11288','2014-03-19','14:15:00',5.07),('11288','2014-03-19','14:20:00',5.01),('11288','2014-03-19','14:25:00',4.94),('11288','2014-03-19','14:30:00',4.78),('11288','2014-03-19','14:35:00',4.86),('11288','2014-03-19','14:40:00',4.75),('11288','2014-03-19','14:45:00',4.62),('11288','2014-03-19','14:50:00',4.44),('11288','2014-03-19','14:55:00',4.37),('11288','2014-03-19','15:00:00',4.26),('11288','2014-03-19','15:05:00',4.12),('11288','2014-03-19','15:10:00',4.03),('11288','2014-03-19','15:15:00',3.94),('11288','2014-03-19','15:20:00',3.8),('11288','2014-03-19','15:25:00',3.72),('11288','2014-03-19','15:30:00',3.57),('11288','2014-03-19','15:35:00',3.36),('11288','2014-03-19','15:40:00',3.33),('11288','2014-03-19','15:45:00',3.21),('11288','2014-03-19','15:50:00',3.03),('11288','2014-03-19','15:55:00',2.96),('11288','2014-03-19','16:00:00',2.76),('11288','2014-03-19','16:05:00',2.65),('11288','2014-03-19','16:10:00',2.51),('11288','2014-03-19','16:15:00',2.34),('11288','2014-03-19','16:20:00',2.19),('11288','2014-03-19','16:25:00',1.94),('11288','2014-03-19','16:30:00',1.83),('11288','2014-03-19','16:35:00',1.65),('11288','2014-03-19','16:40:00',1.52),('11288','2014-03-19','16:45:00',1.46),('11288','2014-03-19','16:50:00',1.22),('11288','2014-03-19','16:55:00',1.14),('11288','2013-01-11','09:45:00',1.21),('11288','2013-01-11','09:55:00',1.2),('11288','2013-01-11','10:00:00',1.63),('11288','2013-01-11','10:05:00',2.12),('11288','2013-01-11','10:10:00',2.07),('11288','2013-01-11','10:15:00',2.17),('11288','2013-01-11','10:20:00',2.26),('11288','2013-01-11','10:25:00',2.29),('11288','2013-01-11','10:30:00',2.59),('11288','2013-01-11','10:35:00',2.92),('11288','2013-01-11','10:40:00',2.99),('11288','2013-01-11','10:45:00',2.99),('11288','2013-01-11','10:50:00',2.99),('11288','2013-01-11','10:55:00',3.12),('11288','2013-01-11','11:00:00',3.27),('11288','2013-01-11','11:05:00',3.3),('11288','2013-01-11','11:10:00',3.39),('11288','2013-01-11','11:15:00',3.37),('11288','2013-01-11','11:20:00',3.35),('11288','2013-01-11','11:25:00',2.05),('11288','2013-01-11','11:30:00',2.06),('11288','2013-01-11','11:35:00',2.09),('11288','2013-01-11','11:40:00',1.96),('11288','2013-01-11','11:45:00',2.48),('11288','2013-01-11','11:50:00',2.28),('11288','2013-01-11','11:55:00',2.12),('11288','2013-01-11','12:00:00',1.77),('11288','2013-01-11','12:05:00',1.29),('11288','2013-01-11','12:15:00',1.17),('11288','2013-01-11','12:20:00',1.18),('11288','2013-01-11','12:50:00',1.54),('11288','2013-01-11','12:55:00',3.46),('11288','2013-01-11','13:00:00',2.33),('11288','2013-01-11','13:05:00',1.95),('11288','2013-01-11','13:10:00',2.77),('11288','2013-01-11','13:15:00',1.92),('11288','2013-01-11','13:20:00',1.46),('11288','2013-01-11','13:25:00',1.2),('11288','2013-01-11','13:30:00',2.02),('11288','2013-01-11','13:35:00',3.76),('11288','2013-01-11','13:40:00',2.46),('11288','2013-01-11','13:45:00',1.61),('11288','2013-01-11','14:20:00',2.33),('11288','2013-01-11','14:25:00',1.87),('11288','2013-01-11','14:30:00',1.39),('11288','2013-01-11','14:35:00',1.35),('11288','2013-01-11','14:40:00',1.26),('11288','2013-01-11','14:45:00',2),('11288','2013-01-11','14:50:00',2.03),('11288','2013-01-11','14:55:00',1.36),('11288','2013-01-11','15:00:00',1.83),('11288','2013-01-11','15:05:00',1.77),('11288','2013-01-11','15:45:00',1.03),('11288','2013-01-10','10:05:00',1.01),('11288','2013-01-10','10:25:00',1.01),('11288','2013-01-10','11:20:00',1.04),('11288','2013-01-10','11:25:00',1.49),('11288','2013-01-10','11:30:00',1.84),('11288','2013-01-10','11:35:00',1.48),('11288','2013-01-10','11:45:00',1.12),('11288','2013-01-10','11:50:00',1.64),('11288','2013-01-10','11:55:00',2.16),('11288','2013-01-10','12:00:00',2.18),('11288','2013-01-10','12:05:00',2.13),('11288','2013-01-10','12:10:00',1.86),('11288','2013-01-10','12:15:00',1.53),('11288','2013-01-10','12:20:00',1.11),('11288','2013-01-10','12:45:00',1.02),('11288','2013-01-10','13:15:00',1.14),('11288','2013-01-10','13:20:00',1.01),('11288','2013-01-10','13:40:00',1),('11288','2013-01-10','13:45:00',1.17),('11288','2013-01-10','13:50:00',1.04),('11288','2013-01-10','13:55:00',1.19),('11288','2013-01-10','14:00:00',1.29),('11288','2013-01-10','14:05:00',1.07),('11288','2013-01-09','09:35:00',1.08),('11288','2013-01-09','09:40:00',1.43),('11288','2013-01-09','09:45:00',1.09),('11288','2013-01-09','09:50:00',1.11),('11288','2013-01-09','09:55:00',1.15),('11288','2013-01-09','10:00:00',1.18),('11288','2013-01-09','10:05:00',1.15),('11288','2013-01-09','10:10:00',1.1),('11288','2013-01-09','10:15:00',1.08),('11288','2013-01-09','10:20:00',1.11),('11288','2013-01-09','10:25:00',1.31),('11288','2013-01-09','10:30:00',1.57),('11288','2013-01-09','10:35:00',1.67),('11288','2013-01-09','10:40:00',1.68),('11288','2013-01-09','10:45:00',1.79),('11288','2013-01-09','10:50:00',1.98),('11288','2013-01-09','10:55:00',1.93),('11288','2013-01-09','11:00:00',1.82),('11288','2013-01-09','11:05:00',2.01),('11288','2013-01-09','11:10:00',2.69),('11288','2013-01-09','11:15:00',2.63),('11288','2013-01-09','11:20:00',2.03),('11288','2013-01-09','11:25:00',2.08),('11288','2013-01-09','11:30:00',2.07),('11288','2013-01-09','11:35:00',2.02),('11288','2013-01-09','11:40:00',1.93),('11288','2013-01-09','11:45:00',1.95),('11288','2013-01-09','11:50:00',2.12),('11288','2013-01-09','11:55:00',2.12),('11288','2013-01-09','12:00:00',1.99),('11288','2013-01-09','12:05:00',2.04),('11288','2013-01-09','12:10:00',2.02),('11288','2013-01-09','12:15:00',2.01),('11288','2013-01-09','12:20:00',1.94),('11288','2013-01-09','12:25:00',1.77),('11288','2013-01-09','12:30:00',1.75),('11288','2013-01-09','12:35:00',1.84),('11288','2013-01-09','12:40:00',1.77),('11288','2013-01-09','12:45:00',1.78),('11288','2013-01-09','12:50:00',1.89),('11288','2013-01-09','12:55:00',2.09),('11288','2013-01-09','13:00:00',2.06),('11288','2013-01-09','13:05:00',2.03),('11288','2013-01-09','13:10:00',2.06),('11288','2013-01-09','13:15:00',1.96),('11288','2013-01-09','13:20:00',1.65),('11288','2013-01-09','13:25:00',1.49),('11288','2013-01-09','13:30:00',1.43),('11288','2013-01-09','13:35:00',1.5),('11288','2013-01-09','13:40:00',1.55),('11288','2013-01-09','13:45:00',1.48),('11288','2013-01-09','13:50:00',1.35),('11288','2013-01-09','13:55:00',1.34),('11288','2013-01-09','14:00:00',1.39),('11288','2013-01-09','14:05:00',1.27),('11288','2013-01-09','14:10:00',1.22),('11288','2013-01-09','14:15:00',1.09),('11288','2013-01-09','14:20:00',1),('11288','2013-01-08','08:35:00',1.09),('11288','2013-01-08','08:40:00',1.26),('11288','2013-01-08','08:45:00',1.45),('11288','2013-01-08','08:50:00',1.42),('11288','2013-01-08','08:55:00',1.81),('11288','2013-01-08','09:00:00',1.96),('11288','2013-01-08','09:05:00',1.91),('11288','2013-01-08','09:10:00',1.28),('11288','2013-01-08','09:15:00',1.61),('11288','2013-01-08','09:20:00',1.74),('11288','2013-01-08','09:25:00',1.98),('11288','2013-01-08','09:30:00',1.84),('11288','2013-01-08','09:35:00',1.68),('11288','2013-01-08','09:40:00',2.08),('11288','2013-01-08','09:45:00',2.52),('11288','2013-01-08','09:50:00',2.66),('11288','2013-01-08','09:55:00',2.68),('11288','2013-01-08','10:00:00',2.6),('11288','2013-01-08','10:05:00',2.42),('11288','2013-01-08','10:10:00',2.47),('11288','2013-01-08','10:15:00',2.39),('11288','2013-01-08','10:20:00',2.32),('11288','2013-01-08','10:25:00',2.51),('11288','2013-01-08','10:30:00',2.61),('11288','2013-01-08','10:35:00',2.76),('11288','2013-01-08','10:40:00',3.07),('11288','2013-01-08','10:45:00',2.93),('11288','2013-01-08','10:50:00',2.89),('11288','2013-01-08','10:55:00',3.12),('11288','2013-01-08','11:00:00',3.17),('11288','2013-01-08','11:05:00',3.28),('11288','2013-01-08','11:10:00',3.39),('11288','2013-01-08','11:15:00',3.4),('11288','2013-01-08','11:20:00',3.46),('11288','2013-01-08','11:25:00',3.54),('11288','2013-01-08','11:30:00',3.53),('11288','2013-01-08','11:35:00',3.32),('11288','2013-01-08','11:40:00',3.35),('11288','2013-01-08','11:45:00',4.38),('11288','2013-01-08','11:50:00',3.2),('11288','2013-01-08','11:55:00',2.73),('11288','2013-01-08','12:00:00',2.65),('11288','2013-01-08','12:05:00',2.53),('11288','2013-01-08','12:10:00',2.66),('11288','2013-01-08','12:15:00',2.56),('11288','2013-01-08','12:20:00',2.24),('11288','2013-01-08','12:25:00',2.16),('11288','2013-01-08','12:30:00',2.08),('11288','2013-01-08','12:35:00',2.02),('11288','2013-01-08','12:40:00',2.47),('11288','2013-01-08','12:45:00',2.94),('11288','2013-01-08','12:50:00',3.14),('11288','2013-01-08','12:55:00',2.41),('11288','2013-01-08','13:00:00',1.8),('11288','2013-01-08','13:05:00',1.48),('11288','2013-01-08','13:10:00',1.42),('11288','2013-01-08','13:15:00',1.28),('11288','2013-01-08','13:20:00',1.59),('11288','2013-01-08','13:25:00',1.42),('11288','2013-01-08','13:30:00',1.24),('11288','2013-01-08','13:35:00',1.3),('11288','2013-01-08','13:40:00',1.65),('11288','2013-01-08','13:45:00',2.14),('11288','2013-01-08','13:50:00',2.38),('11288','2013-01-08','13:55:00',3.03),('11288','2013-01-08','14:00:00',1.75),('11288','2013-01-08','14:05:00',1.7),('11288','2013-01-08','14:10:00',1.38),('11288','2013-01-08','14:15:00',1.37),('11288','2013-01-08','14:20:00',1.26),('11288','2013-01-08','14:25:00',1.47),('11288','2013-01-08','14:30:00',1.52),('11288','2013-01-08','14:35:00',1.58),('11288','2013-01-08','14:40:00',1.71),('11288','2013-01-08','14:45:00',1.16),('11288','2013-01-08','14:55:00',1.02),('11288','2013-01-08','15:05:00',1.17),('11288','2013-01-08','15:10:00',1.11),('11288','2013-01-08','15:15:00',1.2),('11288','2013-01-08','15:35:00',1.09),('11288','2013-01-08','15:40:00',1),('11288','2013-01-07','08:50:00',1.09),('11288','2013-01-07','08:55:00',1.14),('11288','2013-01-07','09:00:00',1.3),('11288','2013-01-07','09:05:00',1.24),('11288','2013-01-07','09:10:00',1.13),('11288','2013-01-07','09:15:00',1.17),('11288','2013-01-07','09:20:00',1.6),('11288','2013-01-07','09:25:00',1.77),('11288','2013-01-07','09:30:00',1.83),('11288','2013-01-07','09:35:00',1.89),('11288','2013-01-07','09:40:00',1.93),('11288','2013-01-07','09:45:00',2.05),('11288','2013-01-07','09:50:00',2.12),('11288','2013-01-07','09:55:00',2.2),('11288','2013-01-07','10:00:00',2.32),('11288','2013-01-07','10:05:00',2.48),('11288','2013-01-07','10:10:00',2.51),('11288','2013-01-07','10:15:00',2.69),('11288','2013-01-07','10:20:00',2.74),('11288','2013-01-07','10:25:00',2.85),('11288','2013-01-07','10:30:00',2.89),('11288','2013-01-07','10:35:00',2.94),('11288','2013-01-07','10:40:00',3.07),('11288','2013-01-07','10:45:00',3.09),('11288','2013-01-07','10:50:00',3.04),('11288','2013-01-07','10:55:00',3.2),('11288','2013-01-07','11:00:00',3.25),('11288','2013-01-07','11:05:00',3.33),('11288','2013-01-07','11:10:00',3.38),('11288','2013-01-07','11:15:00',3.44),('11288','2013-01-07','11:20:00',3.47),('11288','2013-01-07','11:25:00',3.53),('11288','2013-01-07','11:30:00',3.42),('11288','2013-01-07','11:35:00',3.16),('11288','2013-01-07','11:40:00',3.18),('11288','2013-01-07','11:45:00',3.52),('11288','2013-01-07','11:50:00',3.61),('11288','2013-01-07','11:55:00',3.58),('11288','2013-01-07','12:00:00',3.59),('11288','2013-01-07','12:05:00',3.6),('11288','2013-01-07','12:10:00',3.5),('11288','2013-01-07','12:15:00',3.58),('11288','2013-01-07','12:20:00',3.62),('11288','2013-01-07','12:25:00',3.62),('11288','2013-01-07','12:30:00',3.59),('11288','2013-01-07','12:35:00',3.61),('11288','2013-01-07','12:40:00',3.54),('11288','2013-01-07','12:45:00',3.51),('11288','2013-01-07','12:50:00',3.52),('11288','2013-01-07','12:55:00',3.48),('11288','2013-01-07','13:00:00',3.43),('11288','2013-01-07','13:05:00',3.38),('11288','2013-01-07','13:10:00',3.31),('11288','2013-01-07','13:15:00',3.23),('11288','2013-01-07','13:20:00',3.17),('11288','2013-01-07','13:25:00',3.14),('11288','2013-01-07','13:30:00',3.14),('11288','2013-01-07','13:35:00',3.03),('11288','2013-01-07','13:40:00',3.01),('11288','2013-01-07','13:45:00',2.94),('11288','2013-01-07','13:50:00',2.82),('11288','2013-01-07','13:55:00',2.74),('11288','2013-01-07','14:00:00',2.71),('11288','2013-01-07','14:05:00',2.6),('11288','2013-01-07','14:10:00',2.51),('11288','2013-01-07','14:15:00',2.42),('11288','2013-01-07','14:20:00',2.4),('11288','2013-01-07','14:25:00',2.31),('11288','2013-01-07','14:30:00',2.2),('11288','2013-01-07','14:35:00',2.09),('11288','2013-01-07','14:40:00',2.01),('11288','2013-01-07','14:45:00',1.92),('11288','2013-01-07','14:50:00',1.82),('11288','2013-01-07','14:55:00',1.73),('11288','2013-01-07','15:00:00',1.6),('11288','2013-01-07','15:05:00',1.45),('11288','2013-01-07','15:10:00',1.17),('11288','2013-01-07','15:15:00',1.27),('11288','2013-01-07','15:20:00',1.19),('11288','2013-01-07','15:25:00',1.05),('11288','2013-01-07','15:30:00',1.05),('11288','2013-01-06','08:50:00',1.09),('11288','2013-01-06','08:55:00',1.13),('11288','2013-01-06','09:00:00',1.3),('11288','2013-01-06','09:05:00',1.39),('11288','2013-01-06','09:10:00',1.49),('11288','2013-01-06','09:15:00',1.61),('11288','2013-01-06','09:20:00',1.69),('11288','2013-01-06','09:25:00',1.77),('11288','2013-01-06','09:30:00',1.85),('11288','2013-01-06','09:35:00',1.9),('11288','2013-01-06','09:40:00',1.97),('11288','2013-01-06','09:45:00',2.1),('11288','2013-01-06','09:50:00',2.18),('11288','2013-01-06','09:55:00',2.24),('11288','2013-01-06','10:00:00',2.35),('11288','2013-01-06','10:05:00',2.43),('11288','2013-01-06','10:10:00',2.44),('11288','2013-01-06','10:15:00',2.58),('11288','2013-01-06','10:20:00',2.65),('11288','2013-01-06','10:25:00',2.8),('11288','2013-01-06','10:30:00',2.9),('11288','2013-01-06','10:35:00',2.98),('11288','2013-01-06','10:40:00',3.07),('11288','2013-01-06','10:45:00',3.04),('11288','2013-01-06','10:50:00',2.98),('11288','2013-01-06','10:55:00',3.23),('11288','2013-01-06','11:00:00',3.3),('11288','2013-01-06','11:05:00',3.33),('11288','2013-01-06','11:10:00',3.41),('11288','2013-01-06','11:15:00',3.43),('11288','2013-01-06','11:20:00',3.47),('11288','2013-01-06','11:25:00',3.53),('11288','2013-01-06','11:30:00',3.51),('11288','2013-01-06','11:35:00',3.55),('11288','2013-01-06','11:40:00',3.55),('11288','2013-01-06','11:45:00',3.58),('11288','2013-01-06','11:50:00',3.6),('11288','2013-01-06','11:55:00',3.62),('11288','2013-01-06','12:00:00',3.64),('11288','2013-01-06','12:05:00',3.62),('11288','2013-01-06','12:10:00',3.53),('11288','2013-01-06','12:15:00',3.54),('11288','2013-01-06','12:20:00',3.58),('11288','2013-01-06','12:25:00',3.57),('11288','2013-01-06','12:30:00',3.54),('11288','2013-01-06','12:35:00',3.48),('11288','2013-01-06','12:40:00',3.46),('11288','2013-01-06','12:45:00',3.48),('11288','2013-01-06','12:50:00',3.53),('11288','2013-01-06','12:55:00',3.53),('11288','2013-01-06','13:00:00',3.51),('11288','2013-01-06','13:05:00',3.46),('11288','2013-01-06','13:10:00',3.39),('11288','2013-01-06','13:15:00',3.35),('11288','2013-01-06','13:20:00',3.29),('11288','2013-01-06','13:25:00',3.25),('11288','2013-01-06','13:30:00',3.21),('11288','2013-01-06','13:35:00',3.16),('11288','2013-01-06','13:40:00',3.1),('11288','2013-01-06','13:45:00',3.03),('11288','2013-01-06','13:50:00',2.92),('11288','2013-01-06','13:55:00',2.84),('11288','2013-01-06','14:00:00',2.82),('11288','2013-01-06','14:05:00',2.79),('11288','2013-01-06','14:10:00',2.6),('11288','2013-01-06','14:15:00',2.51),('11288','2013-01-06','14:20:00',2.46),('11288','2013-01-06','14:25:00',2.26),('11288','2013-01-06','14:30:00',2.16),('11288','2013-01-06','14:35:00',2.07),('11288','2013-01-06','14:40:00',1.98),('11288','2013-01-06','14:45:00',1.88),('11288','2013-01-06','14:50:00',1.75),('11288','2013-01-06','14:55:00',1.67),('11288','2013-01-06','15:00:00',1.57),('11288','2013-01-06','15:05:00',1.41),('11288','2013-01-06','15:10:00',1.18),('11288','2013-01-06','15:15:00',1.21),('11288','2013-01-06','15:20:00',1.18),('11288','2013-01-06','15:25:00',1.02),('11288','2013-01-05','09:10:00',1.05),('11288','2013-01-05','09:15:00',1.05),('11288','2013-01-05','09:20:00',1.03),('11288','2013-01-05','09:25:00',1.12),('11288','2013-01-05','09:30:00',1.11),('11288','2013-01-05','09:35:00',1.24),('11288','2013-01-05','09:40:00',1.33),('11288','2013-01-05','09:45:00',1.3),('11288','2013-01-05','09:50:00',1.3),('11288','2013-01-05','09:55:00',1.38),('11288','2013-01-05','10:00:00',1.5),('11288','2013-01-05','10:05:00',1.62),('11288','2013-01-05','10:10:00',1.69),('11288','2013-01-05','10:15:00',1.77),('11288','2013-01-05','10:20:00',1.67),('11288','2013-01-05','10:25:00',1.59),('11288','2013-01-05','10:30:00',1.63),('11288','2013-01-05','10:35:00',1.8),('11288','2013-01-05','10:40:00',1.84),('11288','2013-01-05','10:45:00',1.78),('11288','2013-01-05','10:50:00',1.93),('11288','2013-01-05','10:55:00',2.79),('11288','2013-01-05','11:00:00',2.56),('11288','2013-01-05','11:05:00',2.89),('11288','2013-01-05','11:10:00',2.96),('11288','2013-01-05','11:15:00',2.49),('11288','2013-01-05','11:20:00',3.33),('11288','2013-01-05','11:25:00',3.59),('11288','2013-01-05','11:30:00',3.56),('11288','2013-01-05','11:35:00',3.39),('11288','2013-01-05','11:40:00',3.21),('11288','2013-01-05','11:45:00',3.33),('11288','2013-01-05','11:50:00',2.96),('11288','2013-01-05','11:55:00',2.7),('11288','2013-01-05','12:00:00',2.48),('11288','2013-01-05','12:05:00',2.48),('11288','2013-01-05','12:10:00',2.49),('11288','2013-01-05','12:15:00',2.54),('11288','2013-01-05','12:20:00',2.31),('11288','2013-01-05','12:25:00',1.97),('11288','2013-01-05','12:30:00',1.93),('11288','2013-01-05','12:35:00',2.42),('11288','2013-01-05','12:40:00',3.07),('11288','2013-01-05','12:45:00',3.35),('11288','2013-01-05','12:50:00',2.42),('11288','2013-01-05','12:55:00',2.08),('11288','2013-01-05','13:00:00',2.09),('11288','2013-01-05','13:05:00',2.09),('11288','2013-01-05','13:10:00',1.97),('11288','2013-01-05','13:15:00',1.71),('11288','2013-01-05','13:20:00',1.56),('11288','2013-01-05','13:25:00',1.83),('11288','2013-01-05','13:30:00',2.67),('11288','2013-01-05','13:35:00',2.23),('11288','2013-01-05','13:40:00',1.79),('11288','2013-01-05','13:45:00',1.55),('11288','2013-01-05','13:50:00',1.7),('11288','2013-01-05','13:55:00',2.01),('11288','2013-01-05','14:00:00',1.78),('11288','2013-01-05','14:05:00',2.48),('11288','2013-01-05','14:10:00',2.25),('11288','2013-01-05','14:15:00',1.88),('11288','2013-01-05','14:20:00',1.66),('11288','2013-01-05','14:25:00',1.15),('11288','2013-01-05','14:30:00',1.68),('11288','2013-01-05','14:35:00',1.67),('11288','2013-01-05','14:40:00',1.74),('11288','2013-01-05','14:45:00',1.91),('11288','2013-01-05','14:50:00',1.32),('11288','2013-01-05','14:55:00',1.14),('11288','2013-01-05','15:00:00',1.67),('11288','2013-01-05','15:05:00',1.34),('11288','2013-01-04','08:45:00',1.15),('11288','2013-01-04','08:50:00',1.29),('11288','2013-01-04','08:55:00',1.23),('11288','2013-01-04','09:00:00',1.37),('11288','2013-01-04','09:05:00',1.39),('11288','2013-01-04','09:10:00',1.49),('11288','2013-01-04','09:15:00',1.37),('11288','2013-01-04','09:20:00',1.58),('11288','2013-01-04','09:25:00',1.46),('11288','2013-01-04','09:30:00',1.52),('11288','2013-01-04','09:35:00',1.42),('11288','2013-01-04','09:40:00',1.39),('11288','2013-01-04','09:45:00',1.49),('11288','2013-01-04','09:50:00',1.84),('11288','2013-01-04','09:55:00',1.93),('11288','2013-01-04','10:00:00',2.57),('11288','2013-01-04','10:05:00',2.68),('11288','2013-01-04','10:10:00',2.3),('11288','2013-01-04','10:15:00',2.6),('11288','2013-01-04','10:20:00',2.48),('11288','2013-01-04','10:25:00',2.58),('11288','2013-01-04','10:30:00',2.96),('11288','2013-01-04','10:35:00',3.06),('11288','2013-01-04','10:40:00',3.2),('11288','2013-01-04','10:45:00',3.34),('11288','2013-01-04','10:50:00',3.61),('11288','2013-01-04','10:55:00',3.9),('11288','2013-01-04','11:00:00',3.57),('11288','2013-01-04','11:05:00',2.5),('11288','2013-01-04','11:10:00',1.71),('11288','2013-01-04','11:15:00',1.65),('11288','2013-01-04','11:20:00',1.59),('11288','2013-01-04','11:25:00',1.37),('11288','2013-01-04','11:30:00',1.21),('11288','2013-01-04','11:35:00',1.28),('11288','2013-01-04','11:40:00',1.3),('11288','2013-01-04','11:45:00',2.03),('11288','2013-01-04','11:50:00',3.16),('11288','2013-01-04','11:55:00',4.08),('11288','2013-01-04','12:00:00',4.61),('11288','2013-01-04','12:05:00',3.88),('11288','2013-01-04','12:10:00',3.06),('11288','2013-01-04','12:15:00',2.18),('11288','2013-01-04','12:20:00',1.62),('11288','2013-01-04','12:25:00',1.61),('11288','2013-01-04','12:30:00',2.88),('11288','2013-01-04','12:35:00',2.44),('11288','2013-01-04','12:40:00',3.62),('11288','2013-01-04','12:45:00',3.68),('11288','2013-01-04','12:50:00',3.77),('11288','2013-01-04','12:55:00',3.66),('11288','2013-01-04','13:00:00',3.53),('11288','2013-01-04','13:05:00',3.31),('11288','2013-01-04','13:10:00',2.01),('11288','2013-01-04','13:15:00',2.99),('11288','2013-01-04','13:20:00',3.12),('11288','2013-01-04','13:25:00',3.06),('11288','2013-01-04','13:30:00',3.03),('11288','2013-01-04','13:35:00',2.99),('11288','2013-01-04','13:40:00',2.87),('11288','2013-01-04','13:45:00',2.76),('11288','2013-01-04','13:50:00',2.7),('11288','2013-01-04','13:55:00',2.66),('11288','2013-01-04','14:00:00',2.55),('11288','2013-01-04','14:05:00',2.47),('11288','2013-01-04','14:10:00',2.4),('11288','2013-01-04','14:15:00',2.3),('11288','2013-01-04','14:20:00',2.28),('11288','2013-01-04','14:25:00',2.19),('11288','2013-01-04','14:30:00',2.07),('11288','2013-01-04','14:35:00',1.91),('11288','2013-01-04','14:40:00',1.83),('11288','2013-01-04','14:45:00',1.76),('11288','2013-01-04','14:50:00',1.66),('11288','2013-01-04','14:55:00',1.57),('11288','2013-01-04','15:00:00',1.49),('11288','2013-01-04','15:05:00',1.32),('11288','2013-01-04','15:10:00',1.02),('11288','2013-01-04','15:15:00',1.12),('11288','2013-01-04','15:20:00',1.09),('11288','2013-01-03','08:50:00',1.06),('11288','2013-01-03','08:55:00',1.1),('11288','2013-01-03','09:00:00',1.29),('11288','2013-01-03','09:05:00',1.39),('11288','2013-01-03','09:10:00',1.5),('11288','2013-01-03','09:15:00',1.6),('11288','2013-01-03','09:20:00',1.71),('11288','2013-01-03','09:25:00',1.81),('11288','2013-01-03','09:30:00',1.89),('11288','2013-01-03','09:35:00',1.96),('11288','2013-01-03','09:40:00',2.14),('11288','2013-01-03','09:45:00',2.36),('11288','2013-01-03','09:50:00',2.62),('11288','2013-01-03','09:55:00',2.85),('11288','2013-01-03','10:00:00',3.01),('11288','2013-01-03','10:05:00',3.18),('11288','2013-01-03','10:10:00',2.55),('11288','2013-01-03','10:15:00',3.04),('11288','2013-01-03','10:20:00',3.17),('11288','2013-01-03','10:25:00',3.5),('11288','2013-01-03','10:30:00',3.03),('11288','2013-01-03','10:35:00',2.82),('11288','2013-01-03','10:40:00',2.52),('11288','2013-01-03','10:45:00',2.44),('11288','2013-01-03','10:50:00',2.51),('11288','2013-01-03','10:55:00',2.43),('11288','2013-01-03','11:00:00',2.61),('11288','2013-01-03','11:05:00',2.47),('11288','2013-01-03','11:10:00',2.56),('11288','2013-01-03','11:15:00',2.28),('11288','2013-01-03','11:20:00',2.05),('11288','2013-01-03','11:25:00',1.6),('11288','2013-01-03','11:30:00',1.7),('11288','2013-01-03','11:35:00',1.69),('11288','2013-01-03','11:40:00',3.53),('11288','2013-01-03','11:45:00',3.71),('11288','2013-01-03','11:50:00',3.71),('11288','2013-01-03','11:55:00',3.67),('11288','2013-01-03','12:00:00',3.63),('11288','2013-01-03','12:05:00',3.61),('11288','2013-01-03','12:10:00',3.5),('11288','2013-01-03','12:15:00',3.35),('11288','2013-01-03','12:20:00',3.62),('11288','2013-01-03','12:25:00',3.61),('11288','2013-01-03','12:30:00',3.58),('11288','2013-01-03','12:35:00',3.56),('11288','2013-01-03','12:40:00',3.51),('11288','2013-01-03','12:45:00',3.51),('11288','2013-01-03','12:50:00',3.49),('11288','2013-01-03','12:55:00',3.45),('11288','2013-01-03','13:00:00',3.42),('11288','2013-01-03','13:05:00',3.36),('11288','2013-01-03','13:10:00',3.3),('11288','2013-01-03','13:15:00',3.24),('11288','2013-01-03','13:20:00',3.21),('11288','2013-01-03','13:25:00',3.15),('11288','2013-01-03','13:30:00',3.09),('11288','2013-01-03','13:35:00',3.04),('11288','2013-01-03','13:40:00',3),('11288','2013-01-03','13:45:00',2.91),('11288','2013-01-03','13:50:00',2.83),('11288','2013-01-03','13:55:00',2.74),('11288','2013-01-03','14:00:00',2.66),('11288','2013-01-03','14:05:00',2.59),('11288','2013-01-03','14:10:00',2.5),('11288','2013-01-03','14:15:00',2.43),('11288','2013-01-03','14:20:00',2.38),('11288','2013-01-03','14:25:00',2.27),('11288','2013-01-03','14:30:00',2.18),('11288','2013-01-03','14:35:00',2.08),('11288','2013-01-03','14:40:00',1.98),('11288','2013-01-03','14:45:00',1.89),('11288','2013-01-03','14:50:00',1.79),('11288','2013-01-03','14:55:00',1.71),('11288','2013-01-03','15:00:00',1.61),('11288','2013-01-03','15:05:00',1.45),('11288','2013-01-03','15:10:00',1.19),('11288','2013-01-03','15:15:00',1.21),('11288','2013-01-03','15:20:00',1.1),('11288','2013-01-02','09:40:00',1.11),('11288','2013-01-02','09:45:00',1.13),('11288','2013-01-02','09:50:00',1.08),('11288','2013-01-02','09:55:00',1.08),('11288','2013-01-02','10:00:00',1.19),('11288','2013-01-02','10:05:00',1.05),('11288','2013-01-02','11:10:00',1.11),('11288','2013-01-02','13:30:00',1.01),('11288','2013-01-02','13:40:00',1.51),('11288','2013-01-02','13:45:00',1.47),('11288','2013-01-02','13:50:00',1.37),('11288','2013-01-02','13:55:00',1.29),('11288','2013-01-02','14:00:00',1.21),('11288','2014-03-18','07:45:00',1.1),('11288','2014-03-18','07:50:00',1.56),('11288','2014-03-18','07:55:00',1.48),('11288','2014-03-18','08:00:00',1.32),('11288','2014-03-18','08:05:00',1.31),('11288','2014-03-18','08:10:00',1.48),('11288','2014-03-18','08:15:00',1.78),('11288','2014-03-18','08:20:00',2.08),('11288','2014-03-18','08:25:00',1.83),('11288','2014-03-18','08:30:00',1.67),('11288','2014-03-18','08:35:00',1.23),('11288','2014-03-18','08:40:00',1.47),('11288','2014-03-18','08:45:00',1.52),('11288','2014-03-18','08:50:00',3.14),('11288','2014-03-18','08:55:00',3.35),('11288','2014-03-18','09:00:00',3.15),('11288','2014-03-18','09:05:00',2.49),('11288','2014-03-18','09:10:00',3.21),('11288','2014-03-18','09:15:00',3.14),('11288','2014-03-18','09:20:00',3.2),('11288','2014-03-18','09:25:00',2.4),('11288','2014-03-18','09:30:00',3.94),('11288','2014-03-18','09:35:00',2.24),('11288','2014-03-18','09:40:00',1.9),('11288','2014-03-18','09:45:00',3.68),('11288','2014-03-18','09:50:00',2.78),('11288','2014-03-18','09:55:00',2.04),('11288','2014-03-18','10:00:00',3.96),('11288','2014-03-18','10:05:00',4.5),('11288','2014-03-18','10:10:00',4.13),('11288','2014-03-18','10:15:00',4.58),('11288','2014-03-18','10:20:00',5.14),('11288','2014-03-18','10:25:00',5.45),('11288','2014-03-18','10:30:00',4.77),('11288','2014-03-18','10:35:00',4.2),('11288','2014-03-18','10:40:00',3.59),('11288','2014-03-18','10:45:00',4.18),('11288','2014-03-18','10:50:00',4.8),('11288','2014-03-18','10:55:00',4.42),('11288','2014-03-18','11:00:00',3.33),('11288','2014-03-18','11:05:00',3.84),('11288','2014-03-18','11:10:00',2.83),('11288','2014-03-18','11:15:00',4.22),('11288','2014-03-18','11:20:00',4.75),('11288','2014-03-18','11:25:00',4.44),('11288','2014-03-18','11:30:00',4.81),('11288','2014-03-18','11:35:00',6.79),('11288','2014-03-18','11:40:00',3.07),('11288','2014-03-18','11:45:00',5.54),('11288','2014-03-18','11:50:00',4.63),('11288','2014-03-18','11:55:00',3.49),('11288','2014-03-18','12:00:00',4.4),('11288','2014-03-18','12:05:00',6.59),('11288','2014-03-18','12:10:00',3.12),('11288','2014-03-18','12:15:00',3.18),('11288','2014-03-18','12:20:00',2.44),('11288','2014-03-18','12:25:00',2.14),('11288','2014-03-18','12:30:00',3.27),('11288','2014-03-18','12:35:00',2.6),('11288','2014-03-18','12:40:00',3.86),('11288','2014-03-18','12:45:00',6.73),('11288','2014-03-18','12:50:00',6.42),('11288','2014-03-18','12:55:00',6.19),('11288','2014-03-18','13:00:00',6.15),('11288','2014-03-18','13:05:00',6.01),('11288','2014-03-18','13:10:00',5.99),('11288','2014-03-18','13:15:00',5.98),('11288','2014-03-18','13:20:00',5.23),('11288','2014-03-18','13:25:00',4.89),('11288','2014-03-18','13:30:00',5.69),('11288','2014-03-18','13:35:00',5.64),('11288','2014-03-18','13:40:00',5.65),('11288','2014-03-18','13:45:00',5.51),('11288','2014-03-18','13:50:00',5.51),('11288','2014-03-18','13:55:00',5.48),('11288','2014-03-18','14:00:00',5.35),('11288','2014-03-18','14:05:00',5.37),('11288','2014-03-18','14:10:00',5.31),('11288','2014-03-18','14:15:00',5.21),('11288','2014-03-18','14:20:00',5.12),('11288','2014-03-18','14:25:00',5.07),('11288','2014-03-18','14:30:00',5),('11288','2014-03-18','14:35:00',4.92),('11288','2014-03-18','14:40:00',4.77),('11288','2014-03-18','14:45:00',4.67),('11288','2014-03-18','14:50:00',4.58),('11288','2014-03-18','14:55:00',4.48),('11288','2014-03-18','15:00:00',4.33),('11288','2014-03-18','15:05:00',4.24),('11288','2014-03-18','15:10:00',4.12),('11288','2014-03-18','15:15:00',4.02),('11288','2014-03-18','15:20:00',3.89),('11288','2014-03-18','15:25:00',3.73),('11288','2014-03-18','15:30:00',3.61),('11288','2014-03-18','15:40:00',3.3),('11288','2014-03-18','15:45:00',3.2),('11288','2014-03-18','15:50:00',3.01),('11288','2014-03-18','15:57:00',2.87),('11288','2014-03-18','16:00:00',2.74),('11288','2014-03-18','16:05:00',2.6),('11288','2014-03-18','16:10:00',2.47),('11288','2014-03-18','16:15:00',2.27),('11288','2014-03-18','16:20:00',2.14),('11288','2014-03-18','16:25:00',2.03),('11288','2014-03-18','16:30:00',1.88),('11288','2014-03-18','16:35:00',1.74),('11288','2014-03-18','16:40:00',1.63),('11288','2014-03-18','16:45:00',1.5),('11288','2014-03-18','16:50:00',1.34),('11288','2014-03-18','16:55:00',1.24),('11288','2014-03-18','17:00:00',1.06),('11288','2013-01-01','08:50:00',1.06),('11288','2013-01-01','08:55:00',1.09),('11288','2013-01-01','09:00:00',1.27),('11288','2013-01-01','09:05:00',1.35),('11288','2013-01-01','09:10:00',1.45),('11288','2013-01-01','09:15:00',1.53),('11288','2013-01-01','09:20:00',1.66),('11288','2013-01-01','09:25:00',1.75),('11288','2013-01-01','09:30:00',1.82),('11288','2013-01-01','09:35:00',1.88),('11288','2013-01-01','09:40:00',1.96),('11288','2013-01-01','09:45:00',2.04),('11288','2013-01-01','09:50:00',2.13),('11288','2013-01-01','09:55:00',2.21),('11288','2013-01-01','10:00:00',2.26),('11288','2013-01-01','10:05:00',2.28),('11288','2013-01-01','10:10:00',2.24),('11288','2013-01-01','10:15:00',2.46),('11288','2013-01-01','10:20:00',2.59),('11288','2013-01-01','10:25:00',2.69),('11288','2013-01-01','10:30:00',2.77),('11288','2013-01-01','10:35:00',2.88),('11288','2013-01-01','10:40:00',3.01),('11288','2013-01-01','10:45:00',3.47),('11288','2013-01-01','10:50:00',3.71),('11288','2013-01-01','10:55:00',1.61),('11288','2013-01-01','11:00:00',1.22),('11288','2013-01-01','11:05:00',3.16),('11288','2013-01-01','11:10:00',3.1),('11288','2013-01-01','11:15:00',2.21),('11288','2013-01-01','11:20:00',2.21),('11288','2013-01-01','11:25:00',2.71),('11288','2013-01-01','11:30:00',3.97),('11288','2013-01-01','11:35:00',2.36),('11288','2013-01-01','11:40:00',2.75),('11288','2013-01-01','11:45:00',3.42),('11288','2013-01-01','11:50:00',2.25),('11288','2013-01-01','11:55:00',1.99),('11288','2013-01-01','12:00:00',2.24),('11288','2013-01-01','12:05:00',1.93),('11288','2013-01-01','12:10:00',2.12),('11288','2013-01-01','12:15:00',2.1),('11288','2013-01-01','12:20:00',2.15),('11288','2013-01-01','12:25:00',1.89),('11288','2013-01-01','12:30:00',1.81),('11288','2013-01-01','12:35:00',1.63),('11288','2013-01-01','12:40:00',1.97),('11288','2013-01-01','12:45:00',2.2),('11288','2013-01-01','12:50:00',2.49),('11288','2013-01-01','12:55:00',2.03),('11288','2013-01-01','13:00:00',1.91),('11288','2013-01-01','13:05:00',1.69),('11288','2013-01-01','13:10:00',1.41),('11288','2013-01-01','13:15:00',1.44),('11288','2013-01-01','13:20:00',1.46),('11288','2013-01-01','13:25:00',1.25),('11288','2013-01-01','13:30:00',1.07),('11288','2012-12-31','09:00:00',1.15),('11288','2012-12-31','09:05:00',1.19),('11288','2012-12-31','09:10:00',1.32),('11288','2012-12-31','09:15:00',1.6),('11288','2012-12-31','09:20:00',1.68),('11288','2012-12-31','09:25:00',1.93),('11288','2012-12-31','09:30:00',2.06),('11288','2012-12-31','10:00:00',1.73),('11288','2012-12-31','10:05:00',1.4),('11288','2012-12-31','10:10:00',2.45),('11288','2012-12-31','10:15:00',2.72),('11288','2012-12-31','10:20:00',2.79),('11288','2012-12-31','10:25:00',2.95),('11288','2012-12-31','10:30:00',3),('11288','2012-12-31','10:35:00',3.07),('11288','2012-12-31','10:40:00',3.09),('11288','2012-12-31','10:45:00',3.07),('11288','2012-12-31','10:50:00',3.16),('11288','2012-12-31','10:55:00',3.25),('11288','2012-12-31','11:00:00',3.32),('11288','2012-12-31','11:05:00',3.27),('11288','2012-12-31','11:10:00',3.28),('11288','2012-12-31','11:15:00',3.45),('11288','2012-12-31','11:20:00',3.5),('11288','2012-12-31','11:25:00',3.51),('11288','2012-12-31','11:30:00',3.31),('11288','2012-12-31','11:35:00',3.14),('11288','2012-12-31','11:40:00',3.59),('11288','2012-12-31','11:45:00',3.67),('11288','2012-12-31','11:50:00',3.68),('11288','2012-12-31','11:55:00',3.68),('11288','2012-12-31','12:00:00',3.67),('11288','2012-12-31','12:05:00',3.68),('11288','2012-12-31','12:10:00',3.73),('11288','2012-12-31','12:15:00',3.72),('11288','2012-12-31','12:20:00',3.72),('11288','2012-12-31','12:25:00',3.69),('11288','2012-12-31','12:30:00',3.68),('11288','2012-12-31','12:35:00',3.64),('11288','2012-12-31','12:40:00',3.58),('11288','2012-12-31','12:45:00',3.61),('11288','2012-12-31','12:50:00',3.58),('11288','2012-12-31','12:55:00',3.53),('11288','2012-12-31','13:00:00',3.47),('11288','2012-12-31','13:05:00',3.41),('11288','2012-12-31','13:10:00',3.36),('11288','2012-12-31','13:15:00',3.32),('11288','2012-12-31','13:20:00',3.29),('11288','2012-12-31','13:25:00',3.2),('11288','2012-12-31','13:30:00',3.16),('11288','2012-12-31','13:35:00',3.1),('11288','2012-12-31','13:40:00',3.05),('11288','2012-12-31','13:45:00',2.94),('11288','2012-12-31','13:50:00',2.81),('11288','2012-12-31','13:55:00',2.75),('11288','2012-12-31','14:00:00',2.69),('11288','2012-12-31','14:05:00',2.57),('11288','2012-12-31','14:10:00',2.5),('11288','2012-12-31','14:15:00',2.44),('11288','2012-12-31','14:20:00',2.34),('11288','2012-12-31','14:25:00',2.22),('11288','2012-12-31','14:30:00',2.13),('11288','2012-12-31','14:35:00',2.04),('11288','2012-12-31','14:40:00',1.96),('11288','2012-12-31','14:45:00',1.86),('11288','2012-12-31','14:50:00',1.77),('11288','2012-12-31','14:55:00',1.66),('11288','2012-12-31','15:00:00',1.58),('11288','2012-12-31','15:05:00',1.41),('11288','2012-12-31','15:10:00',1.32),('11288','2012-12-31','15:15:00',1.21),('11288','2012-12-31','15:20:00',1.06),('11288','2012-12-30','08:45:00',1),('11288','2012-12-30','08:50:00',1.11),('11288','2012-12-30','08:55:00',1.13),('11288','2012-12-30','09:00:00',1.3),('11288','2012-12-30','09:05:00',1.4),('11288','2012-12-30','09:10:00',1.5),('11288','2012-12-30','09:15:00',1.61),('11288','2012-12-30','09:20:00',1.72),('11288','2012-12-30','09:25:00',1.8),('11288','2012-12-30','09:30:00',1.89),('11288','2012-12-30','09:35:00',1.95),('11288','2012-12-30','09:40:00',2.03),('11288','2012-12-30','09:45:00',2.11),('11288','2012-12-30','09:50:00',2.19),('11288','2012-12-30','09:55:00',2.25),('11288','2012-12-30','10:00:00',2.32),('11288','2012-12-30','10:05:00',2.33),('11288','2012-12-30','10:10:00',2.29),('11288','2012-12-30','10:15:00',2.59),('11288','2012-12-30','10:20:00',2.72),('11288','2012-12-30','10:25:00',2.81),('11288','2012-12-30','10:30:00',2.88),('11288','2012-12-30','10:35:00',2.95),('11288','2012-12-30','10:40:00',2.98),('11288','2012-12-30','10:45:00',3.08),('11288','2012-12-30','10:50:00',3.15),('11288','2012-12-30','10:55:00',3.22),('11288','2012-12-30','11:00:00',3.28),('11288','2012-12-30','11:05:00',3.36),('11288','2012-12-30','11:10:00',3.4),('11288','2012-12-30','11:15:00',3.43),('11288','2012-12-30','11:20:00',3.47),('11288','2012-12-30','11:25:00',3.42),('11288','2012-12-30','11:30:00',3.49),('11288','2012-12-30','11:35:00',3.54),('11288','2012-12-30','11:40:00',3.55),('11288','2012-12-30','11:45:00',3.62),('11288','2012-12-30','11:50:00',3.63),('11288','2012-12-30','11:55:00',3.64),('11288','2012-12-30','12:00:00',3.64),('11288','2012-12-30','12:05:00',3.57),('11288','2012-12-30','12:10:00',3.39),('11288','2012-12-30','12:15:00',3.56),('11288','2012-12-30','12:20:00',3.59),('11288','2012-12-30','12:25:00',3.56),('11288','2012-12-30','12:30:00',3.53),('11288','2012-12-30','12:35:00',3.52),('11288','2012-12-30','12:40:00',3.47),('11288','2012-12-30','12:45:00',3.44),('11288','2012-12-30','12:50:00',3.41),('11288','2012-12-30','12:55:00',3.43),('11288','2012-12-30','13:00:00',3.43),('11288','2012-12-30','13:05:00',3.38),('11288','2012-12-30','13:10:00',3.32),('11288','2012-12-30','13:15:00',3.3),('11288','2012-12-30','13:20:00',3.27),('11288','2012-12-30','13:25:00',3.2),('11288','2012-12-30','13:30:00',3.11),('11288','2012-12-30','13:35:00',3.08),('11288','2012-12-30','13:40:00',3.03),('11288','2012-12-30','13:45:00',2.92),('11288','2012-12-30','13:50:00',2.84),('11288','2012-12-30','13:55:00',2.78),('11288','2012-12-30','14:00:00',2.7),('11288','2012-12-30','14:05:00',2.61),('11288','2012-12-30','14:10:00',2.53),('11288','2012-12-30','14:15:00',2.44),('11288','2012-12-30','14:20:00',2.34),('11288','2012-12-30','14:25:00',2.23),('11288','2012-12-30','14:30:00',2.13),('11288','2012-12-30','14:35:00',2.03),('11288','2012-12-30','14:40:00',1.92),('11288','2012-12-30','14:45:00',1.83),('11288','2012-12-30','14:50:00',1.73),('11288','2012-12-30','14:55:00',1.63),('11288','2012-12-30','15:00:00',1.54),('11288','2012-12-30','15:05:00',1.37),('11288','2012-12-30','15:10:00',1.16),('11288','2012-12-30','15:15:00',1.2),('11288','2012-12-30','15:20:00',1.05),('11288','2012-12-29','08:50:00',1.1),('11288','2012-12-29','08:55:00',1.09),('11288','2012-12-29','09:00:00',1.26),('11288','2012-12-29','09:05:00',1.36),('11288','2012-12-29','09:10:00',1.45),('11288','2012-12-29','09:15:00',1.55),('11288','2012-12-29','09:20:00',1.66),('11288','2012-12-29','09:25:00',1.74),('11288','2012-12-29','09:30:00',1.8),('11288','2012-12-29','09:35:00',1.88),('11288','2012-12-29','09:40:00',1.97),('11288','2012-12-29','09:45:00',2.08),('11288','2012-12-29','09:50:00',2.2),('11288','2012-12-29','09:55:00',2.28),('11288','2012-12-29','10:00:00',2.35),('11288','2012-12-29','10:05:00',2.38),('11288','2012-12-29','10:10:00',2.29),('11288','2012-12-29','10:15:00',2.61),('11288','2012-12-29','10:20:00',2.76),('11288','2012-12-29','10:25:00',2.85),('11288','2012-12-29','10:30:00',2.9),('11288','2012-12-29','10:35:00',2.96),('11288','2012-12-29','10:40:00',2.96),('11288','2012-12-29','10:45:00',3.09),('11288','2012-12-29','10:50:00',3.21),('11288','2012-12-29','10:55:00',3.29),('11288','2012-12-29','11:00:00',3.32),('11288','2012-12-29','11:05:00',3.38),('11288','2012-12-29','11:10:00',3.42),('11288','2012-12-29','11:15:00',3.46),('11288','2012-12-29','11:20:00',3.53),('11288','2012-12-29','11:25:00',3.46),('11288','2012-12-29','11:30:00',3.5),('11288','2012-12-29','11:35:00',3.61),('11288','2012-12-29','11:40:00',3.62),('11288','2012-12-29','11:45:00',3.64),('11288','2012-12-29','11:50:00',3.66),('11288','2012-12-29','11:55:00',3.66),('11288','2012-12-29','12:00:00',3.67),('11288','2012-12-29','12:05:00',3.64),('11288','2012-12-29','12:10:00',3.48),('11288','2012-12-29','12:15:00',3.61),('11288','2012-12-29','12:20:00',3.65),('11288','2012-12-29','12:25:00',3.64),('11288','2012-12-29','12:30:00',3.61),('11288','2012-12-29','12:35:00',3.58),('11288','2012-12-29','12:40:00',3.58),('11288','2012-12-29','12:45:00',3.57),('11288','2012-12-29','12:50:00',3.49),('11288','2012-12-29','12:55:00',3.48),('11288','2012-12-29','13:00:00',3.48),('11288','2012-12-29','13:05:00',3.44),('11288','2012-12-29','13:10:00',3.39),('11288','2012-12-29','13:15:00',3.33),('11288','2012-12-29','13:20:00',3.28),('11288','2012-12-29','13:25:00',3.22),('11288','2012-12-29','13:30:00',3.17),('11288','2012-12-29','13:35:00',3.13),('11288','2012-12-29','13:40:00',3.06),('11288','2012-12-29','13:45:00',2.93),('11288','2012-12-29','13:50:00',2.84),('11288','2012-12-29','13:55:00',2.78),('11288','2012-12-29','14:00:00',2.72),('11288','2012-12-29','14:05:00',2.62),('11288','2012-12-29','14:10:00',2.55),('11288','2012-12-29','14:15:00',2.46),('11288','2012-12-29','14:20:00',2.38),('11288','2012-12-29','14:25:00',2.27),('11288','2012-12-29','14:30:00',2.16),('11288','2012-12-29','14:35:00',2.06),('11288','2012-12-29','14:40:00',1.96),('11288','2012-12-29','14:45:00',1.86),('11288','2012-12-29','14:50:00',1.77),('11288','2012-12-29','14:55:00',1.66),('11288','2012-12-29','15:00:00',1.58),('11288','2012-12-29','15:05:00',1.39),('11288','2012-12-29','15:10:00',1.22),('11288','2012-12-29','15:15:00',1.23),('11288','2012-12-29','15:20:00',1.04),('11288','2012-12-28','08:50:00',1.02),('11288','2012-12-28','08:55:00',1.09),('11288','2012-12-28','09:00:00',1.19),('11288','2012-12-28','09:05:00',1.33),('11288','2012-12-28','09:10:00',1.43),('11288','2012-12-28','09:15:00',1.56),('11288','2012-12-28','09:20:00',1.65),('11288','2012-12-28','09:25:00',1.72),('11288','2012-12-28','09:30:00',1.74),('11288','2012-12-28','09:35:00',1.82),('11288','2012-12-28','09:40:00',1.91),('11288','2012-12-28','09:45:00',1.97),('11288','2012-12-28','09:50:00',2.06),('11288','2012-12-28','09:55:00',2.1),('11288','2012-12-28','10:00:00',2.15),('11288','2012-12-28','10:05:00',2.2),('11288','2012-12-28','10:10:00',2.13),('11288','2012-12-28','10:15:00',2.24),('11288','2012-12-28','10:20:00',2.58),('11288','2012-12-28','10:25:00',2.7),('11288','2012-12-28','10:30:00',2.73),('11288','2012-12-28','10:35:00',2.85),('11288','2012-12-28','10:40:00',2.82),('11288','2012-12-28','10:45:00',2.83),('11288','2012-12-28','10:50:00',3),('11288','2012-12-28','10:55:00',3.12),('11288','2012-12-28','11:00:00',3.15),('11288','2012-12-28','11:05:00',3.21),('11288','2012-12-28','11:10:00',3.3),('11288','2012-12-28','11:15:00',3.34),('11288','2012-12-28','11:20:00',3.35),('11288','2012-12-28','11:25:00',3.33),('11288','2012-12-28','11:30:00',3.2),('11288','2012-12-28','11:35:00',3.39),('11288','2012-12-28','11:40:00',3.47),('11288','2012-12-28','11:45:00',3.26),('11288','2012-12-28','11:50:00',3.48),('11288','2012-12-28','11:55:00',3.57),('11288','2012-12-28','12:00:00',3.64),('11288','2012-12-28','12:05:00',3.5),('11288','2012-12-28','12:10:00',3.44),('11288','2012-12-28','12:15:00',3.53),('11288','2012-12-28','12:20:00',3.52),('11288','2012-12-28','12:25:00',3.53),('11288','2012-12-28','12:30:00',3.49),('11288','2012-12-28','12:35:00',3.42),('11288','2012-12-28','12:40:00',3.44),('11288','2012-12-28','12:45:00',3.42),('11288','2012-12-28','12:50:00',3.37),('11288','2012-12-28','12:55:00',3.22),('11288','2012-12-28','13:00:00',3.23),('11288','2012-12-28','13:05:00',3.21),('11288','2012-12-28','13:10:00',3.18),('11288','2012-12-28','13:15:00',3.14),('11288','2012-12-28','13:20:00',3.07),('11288','2012-12-28','13:25:00',3.05),('11288','2012-12-28','13:30:00',2.86),('11288','2012-12-28','13:35:00',2.33),('11288','2012-12-28','13:40:00',2.81),('11288','2012-12-28','13:45:00',2.71),('11288','2012-12-28','13:50:00',2.64),('11288','2012-12-28','13:55:00',2.54),('11288','2012-12-28','14:00:00',2.47),('11288','2012-12-28','14:05:00',2.31),('11288','2012-12-28','14:10:00',2.28),('11288','2012-12-28','14:15:00',2.24),('11288','2012-12-28','14:20:00',2.13),('11288','2012-12-28','14:25:00',2.03),('11288','2012-12-28','14:30:00',1.92),('11288','2012-12-28','14:35:00',1.15),('11288','2012-12-28','14:40:00',1.58),('11288','2012-12-28','14:45:00',1.71),('11288','2012-12-28','14:50:00',1.61),('11288','2012-12-28','14:55:00',1.51),('11288','2012-12-28','15:00:00',1.44),('11288','2012-12-28','15:05:00',1.27),('11288','2012-12-28','15:10:00',1.08),('11288','2012-12-28','15:15:00',1.12),('11288','2012-12-28','15:20:00',1.02),('11288','2012-12-27','09:15:00',1.03),('11288','2012-12-27','09:20:00',1.41),('11288','2012-12-27','09:25:00',1.65),('11288','2012-12-27','09:30:00',1.81),('11288','2012-12-27','09:35:00',1.95),('11288','2012-12-27','09:40:00',1.95),('11288','2012-12-27','09:45:00',2.16),('11288','2012-12-27','09:50:00',2.52),('11288','2012-12-27','09:55:00',2.23),('11288','2012-12-27','10:00:00',1.93),('11288','2012-12-27','10:05:00',2.1),('11288','2012-12-27','10:10:00',2.11),('11288','2012-12-27','10:15:00',2.21),('11288','2012-12-27','10:20:00',2.4),('11288','2012-12-27','10:25:00',2.51),('11288','2012-12-27','10:30:00',2.61),('11288','2012-12-27','10:35:00',2.55),('11288','2012-12-27','10:40:00',2.68),('11288','2012-12-27','10:45:00',2.74),('11288','2012-12-27','10:50:00',2.93),('11288','2012-12-27','10:55:00',1.97),('11288','2012-12-27','11:00:00',2.55),('11288','2012-12-27','11:05:00',2.59),('11288','2012-12-27','11:10:00',2.18),('11288','2012-12-27','11:15:00',1.38),('11288','2012-12-27','11:20:00',1.09),('11288','2012-12-27','11:50:00',3.12),('11288','2012-12-27','11:55:00',3.27),('11288','2012-12-27','12:00:00',3.53),('11288','2012-12-27','12:05:00',3.64),('11288','2012-12-27','12:10:00',3.37),('11288','2012-12-27','12:15:00',1.97),('11288','2012-12-27','12:20:00',1.9),('11288','2012-12-27','12:25:00',2.99),('11288','2012-12-27','12:30:00',3.39),('11288','2012-12-27','12:35:00',3.36),('11288','2012-12-27','12:40:00',3.53),('11288','2012-12-27','12:45:00',3.94),('11288','2012-12-27','12:50:00',3.37),('11288','2012-12-27','12:55:00',3),('11288','2012-12-27','13:00:00',3.43),('11288','2012-12-27','13:05:00',3.57),('11288','2012-12-27','13:10:00',3.54),('11288','2012-12-27','13:15:00',3.74),('11288','2012-12-27','13:20:00',3.7),('11288','2012-12-27','13:25:00',3.53),('11288','2012-12-27','13:30:00',2.97),('11288','2012-12-27','13:55:00',1.2),('11288','2012-12-27','14:00:00',2.94),('11288','2012-12-27','14:05:00',2.48),('11288','2012-12-27','14:10:00',2.6),('11288','2012-12-27','14:15:00',1.95),('11288','2012-12-27','14:20:00',2.1),('11288','2012-12-27','14:25:00',2.12),('11288','2012-12-27','14:30:00',2.04),('11288','2012-12-27','14:35:00',1.9),('11288','2012-12-27','14:40:00',1.81),('11288','2012-12-27','14:45:00',1.04),('11288','2012-12-27','14:55:00',1.61),('11288','2012-12-27','15:00:00',1.42),('11288','2012-12-27','15:05:00',1.19),('11288','2012-12-26','09:15:00',1.12),('11288','2012-12-26','09:20:00',1.47),('11288','2012-12-26','09:25:00',1.75),('11288','2012-12-26','09:30:00',1.78),('11288','2012-12-26','09:35:00',1.85),('11288','2012-12-26','09:40:00',1.94),('11288','2012-12-26','09:45:00',2.01),('11288','2012-12-26','09:50:00',2.09),('11288','2012-12-26','09:55:00',2.15),('11288','2012-12-26','10:00:00',2.19),('11288','2012-12-26','10:05:00',2.24),('11288','2012-12-26','10:10:00',2.32),('11288','2012-12-26','10:15:00',2.41),('11288','2012-12-26','10:20:00',2.55),('11288','2012-12-26','10:25:00',2.6),('11288','2012-12-26','10:30:00',2.66),('11288','2012-12-26','10:35:00',2.72),('11288','2012-12-26','10:40:00',2.71),('11288','2012-12-26','10:45:00',2.68),('11288','2012-12-26','10:50:00',2.9),('11288','2012-12-26','10:55:00',2.97),('11288','2012-12-26','11:00:00',3.03),('11288','2012-12-26','11:05:00',3.08),('11288','2012-12-26','11:10:00',3.11),('11288','2012-12-26','11:15:00',3.13),('11288','2012-12-26','11:20:00',3.2),('11288','2012-12-26','11:25:00',3.11),('11288','2012-12-26','11:30:00',2.93),('11288','2012-12-26','11:35:00',2.95),('11288','2012-12-26','11:40:00',3.33),('11288','2012-12-26','11:45:00',3.36),('11288','2012-12-26','11:50:00',3.43),('11288','2012-12-26','11:55:00',3.49),('11288','2012-12-26','12:00:00',3.5),('11288','2012-12-26','12:05:00',3.48),('11288','2012-12-26','12:10:00',3.51),('11288','2012-12-26','12:15:00',3.47),('11288','2012-12-26','12:20:00',3.5),('11288','2012-12-26','12:25:00',3.51),('11288','2012-12-26','12:30:00',3.48),('11288','2012-12-26','12:35:00',3.42),('11288','2012-12-26','12:40:00',3.44),('11288','2012-12-26','12:45:00',3.43),('11288','2012-12-26','12:50:00',3.29),('11288','2012-12-26','12:55:00',2.93),('11288','2012-12-26','13:00:00',3.38),('11288','2012-12-26','13:05:00',2.35),('11288','2012-12-26','13:10:00',3.33),('11288','2012-12-26','13:15:00',3),('11288','2012-12-26','13:20:00',3.46),('11288','2012-12-26','13:25:00',3.17),('11288','2012-12-26','13:30:00',3.6),('11288','2012-12-26','13:35:00',3.68),('11288','2012-12-26','13:40:00',3.66),('11288','2012-12-26','13:45:00',3.6),('11288','2012-12-26','13:50:00',2.89),('11288','2012-12-26','13:55:00',3.13),('11288','2012-12-26','14:00:00',2.92),('11288','2012-12-26','14:05:00',2.82),('11288','2012-12-26','14:10:00',1.86),('11288','2012-12-25','10:05:00',1.11),('11288','2012-12-25','10:10:00',1.24),('11288','2012-12-25','10:15:00',1.26),('11288','2012-12-25','10:20:00',1.31),('11288','2012-12-25','10:25:00',1.37),('11288','2012-12-25','10:30:00',1.35),('11288','2012-12-25','10:35:00',1.31),('11288','2012-12-25','10:40:00',1.26),('11288','2012-12-25','10:45:00',1.27),('11288','2012-12-25','10:50:00',1.26),('11288','2012-12-25','10:55:00',1.28),('11288','2012-12-25','11:00:00',1.33),('11288','2012-12-25','11:05:00',1.44),('11288','2012-12-25','11:10:00',1.52),('11288','2012-12-25','11:15:00',1.42),('11288','2012-12-25','11:20:00',1.51),('11288','2012-12-25','11:25:00',1.65),('11288','2012-12-25','11:30:00',1.58),('11288','2012-12-25','11:35:00',1.57),('11288','2012-12-25','11:40:00',1.5),('11288','2012-12-25','11:45:00',1.55),('11288','2012-12-25','11:50:00',1.52),('11288','2012-12-25','11:55:00',1.61),('11288','2012-12-25','12:00:00',1.59),('11288','2012-12-25','12:05:00',1.43),('11288','2012-12-25','12:10:00',1.4),('11288','2012-12-25','12:15:00',1.44),('11288','2012-12-25','12:20:00',1.52),('11288','2012-12-25','12:25:00',1.48),('11288','2012-12-25','12:30:00',1.39),('11288','2012-12-25','12:35:00',1.28),('11288','2012-12-25','12:40:00',1.33),('11288','2012-12-25','12:45:00',1.28),('11288','2012-12-25','12:50:00',1.33),('11288','2012-12-25','12:55:00',1.35),('11288','2012-12-25','13:00:00',1.34),('11288','2012-12-25','13:05:00',1.45),('11288','2012-12-25','13:10:00',1.63),('11288','2012-12-25','13:15:00',1.68),('11288','2012-12-25','13:20:00',1.61),('11288','2012-12-25','13:25:00',1.46),('11288','2012-12-25','13:30:00',1.28),('11288','2012-12-25','13:35:00',1.22),('11288','2012-12-25','13:40:00',1.18),('11288','2012-12-25','13:45:00',1.01),('11288','2012-12-25','14:55:00',1.09),('11288','2012-12-25','15:00:00',1.07),('11288','2012-12-24','11:15:00',1.09),('11288','2012-12-24','11:20:00',1.11),('11288','2012-12-24','11:25:00',1.1),('11288','2012-12-24','11:30:00',1.18),('11288','2012-12-24','11:35:00',1.2),('11288','2012-12-24','11:40:00',1.14),('11288','2012-12-24','11:45:00',1.05),('11288','2012-12-24','11:55:00',1.06),('11288','2012-12-24','12:00:00',1.22),('11288','2012-12-24','12:05:00',1.41),('11288','2012-12-24','12:10:00',1.45),('11288','2012-12-24','12:15:00',1.37),('11288','2012-12-24','12:20:00',1.37),('11288','2012-12-24','12:25:00',1.36),('11288','2012-12-24','12:30:00',1.3),('11288','2012-12-24','12:35:00',1.29),('11288','2012-12-24','12:40:00',1.31),('11288','2012-12-24','12:45:00',1.23),('11288','2012-12-24','12:50:00',1.16),('11288','2012-12-24','12:55:00',1.14),('11288','2012-12-24','13:00:00',1.09),('11288','2012-12-24','13:10:00',1.01),('11288','2012-12-23','08:45:00',1.02),('11288','2012-12-23','08:50:00',1.06),('11288','2012-12-23','08:55:00',1.24),('11288','2012-12-23','09:00:00',1.35),('11288','2012-12-23','09:05:00',1.47),('11288','2012-12-23','09:10:00',1.57),('11288','2012-12-23','09:15:00',1.62),('11288','2012-12-23','09:20:00',1.7),('11288','2012-12-23','09:25:00',1.8),('11288','2012-12-23','09:30:00',1.84),('11288','2012-12-23','09:35:00',1.92),('11288','2012-12-23','09:40:00',2.02),('11288','2012-12-23','09:45:00',2.1),('11288','2012-12-23','09:50:00',2.16),('11288','2012-12-23','09:55:00',2.22),('11288','2012-12-23','10:00:00',2.25),('11288','2012-12-23','10:05:00',2.24),('11288','2012-12-23','10:10:00',2.3),('11288','2012-12-23','10:15:00',2.57),('11288','2012-12-23','10:20:00',2.67),('11288','2012-12-23','10:25:00',2.65),('11288','2012-12-23','10:30:00',2.64),('11288','2012-12-23','10:35:00',2.71),('11288','2012-12-23','10:40:00',2.79),('11288','2012-12-23','10:45:00',2.96),('11288','2012-12-23','10:50:00',2.96),('11288','2012-12-23','10:55:00',2.87),('11288','2012-12-23','11:00:00',3.11),('11288','2012-12-23','11:05:00',3.17),('11288','2012-12-23','11:10:00',3.18),('11288','2012-12-23','11:15:00',3.28),('11288','2012-12-23','11:20:00',3.37),('11288','2012-12-23','11:25:00',3.05),('11288','2012-12-23','11:30:00',3.23),('11288','2012-12-23','11:35:00',3.44),('11288','2012-12-23','11:40:00',3.5),('11288','2012-12-23','11:45:00',3.45),('11288','2012-12-23','11:50:00',3.59),('11288','2012-12-23','11:55:00',3.36),('11288','2012-12-23','12:00:00',3.17),('11288','2012-12-23','12:05:00',3.12),('11288','2012-12-23','12:10:00',3.02),('11288','2012-12-23','12:15:00',2.42),('11288','2012-12-23','12:20:00',2.93),('11288','2012-12-23','12:25:00',1.63),('11288','2012-12-23','12:30:00',1.83),('11288','2012-12-23','12:35:00',1.9),('11288','2012-12-23','12:40:00',2.18),('11288','2012-12-23','12:45:00',1.61),('11288','2012-12-23','12:50:00',1.92),('11288','2012-12-23','12:55:00',2.92),('11288','2012-12-23','13:00:00',3.44),('11288','2012-12-23','13:05:00',2.93),('11288','2012-12-23','13:10:00',2.98),('11288','2012-12-23','13:15:00',2.52),('11288','2012-12-23','13:20:00',2.06),('11288','2012-12-23','13:25:00',1.83),('11288','2012-12-23','13:30:00',1.68),('11288','2012-12-23','13:35:00',1.77),('11288','2012-12-23','13:40:00',2.06),('11288','2012-12-23','13:45:00',2.25),('11288','2012-12-23','13:50:00',2.03),('11288','2012-12-23','13:55:00',1.91),('11288','2012-12-23','14:00:00',2.66),('11288','2012-12-23','14:05:00',2.36),('11288','2012-12-23','14:10:00',2.13),('11288','2012-12-23','14:15:00',2.22),('11288','2012-12-23','14:20:00',1.7),('11288','2012-12-23','14:25:00',1.36),('11288','2012-12-23','14:30:00',1.29),('11288','2012-12-23','14:35:00',1.57),('11288','2012-12-23','14:40:00',1.73),('11288','2012-12-23','14:45:00',1.71),('11288','2012-12-23','14:50:00',1.24),('11288','2014-05-01','07:50:00',1.18),('11288','2014-05-01','07:55:00',1.54),('11288','2014-05-01','08:00:00',1.62),('11288','2014-05-01','08:05:00',1.79),('11288','2014-05-01','08:10:00',1.87),('11288','2014-05-01','08:15:00',2.12),('11288','2014-05-01','08:20:00',2.24),('11288','2014-05-01','08:25:00',2.36),('11288','2014-05-01','08:30:00',2.25),('11288','2014-05-01','08:35:00',2.4),('11288','2014-05-01','08:40:00',2.83),('11288','2014-05-01','08:45:00',2.79),('11288','2014-05-01','08:50:00',3.19),('11288','2014-05-01','08:55:00',3.49),('11288','2014-05-01','09:00:00',2.16),('11288','2014-05-01','09:05:00',2.29),('11288','2014-05-01','09:10:00',3.7),('11288','2014-05-01','09:15:00',3.29),('11288','2014-05-01','09:20:00',2.32),('11288','2014-05-01','09:25:00',3.08),('11288','2014-05-01','09:30:00',4.6),('11288','2014-05-01','09:35:00',5.03),('11288','2014-05-01','09:40:00',5.68),('11288','2014-05-01','09:45:00',3.95),('11288','2014-05-01','09:50:00',4.35),('11288','2014-05-01','09:55:00',4.52),('11288','2014-05-01','10:00:00',2.9),('11288','2014-05-01','10:05:00',2.27),('11288','2014-05-01','10:10:00',2.99),('11288','2014-05-01','10:15:00',5.43),('11288','2014-05-01','10:20:00',4.82),('11288','2014-05-01','10:25:00',2.12),('11288','2014-05-01','10:30:00',4.57),('11288','2014-05-01','10:35:00',5.39),('11288','2014-05-01','10:40:00',4.64),('11288','2014-05-01','10:45:00',6.27),('11288','2014-05-01','10:50:00',6.85),('11288','2014-05-01','10:55:00',7.19),('11288','2014-05-01','11:00:00',3.8),('11288','2014-05-01','11:05:00',3.87),('11288','2014-05-01','11:10:00',5.7),('11288','2014-05-01','11:15:00',1.52),('11288','2014-05-01','11:20:00',2.89),('11288','2014-05-01','11:25:00',7.65),('11288','2014-05-01','11:30:00',6.25),('11288','2014-05-01','11:35:00',7.09),('11288','2014-05-01','11:40:00',1.95),('11288','2014-05-01','11:45:00',6.88),('11288','2014-05-01','11:50:00',7.83),('11288','2014-05-01','11:55:00',3.48),('11288','2014-05-01','12:00:00',1.63),('11288','2014-05-01','12:05:00',5.38),('11288','2014-05-01','12:10:00',7.79),('11288','2014-05-01','12:15:00',7.51),('11288','2014-05-01','12:20:00',7.6),('11288','2014-05-01','12:25:00',7.69),('11288','2014-05-01','12:30:00',3.15),('11288','2014-05-01','12:35:00',6.03),('11288','2014-05-01','12:40:00',8.01),('11288','2014-05-01','12:45:00',4.71),('11288','2014-05-01','12:50:00',7.31),('11288','2014-05-01','12:55:00',7.69),('11288','2014-05-01','13:00:00',7.88),('11288','2014-05-01','13:05:00',7.64),('11288','2014-05-01','13:10:00',7.82),('11288','2014-05-01','13:15:00',7.6),('11288','2014-05-01','13:20:00',6.43),('11288','2014-05-01','13:25:00',3.76),('11288','2014-05-01','13:30:00',2.75),('11288','2014-05-01','13:35:00',3.3),('11288','2014-05-01','13:40:00',7.84),('11288','2014-05-01','13:45:00',8.06),('11288','2014-05-01','13:50:00',8.1),('11288','2014-05-01','13:55:00',6.46),('11288','2014-05-01','14:00:00',5.7),('11288','2014-05-01','14:05:00',7.53),('11288','2014-05-01','14:10:00',7.3),('11288','2014-05-01','14:15:00',7.18),('11288','2014-05-01','14:20:00',7.04),('11288','2014-05-01','14:25:00',7.01),('11288','2014-05-01','14:30:00',6.74),('11288','2014-05-01','14:35:00',6.67),('11288','2014-05-01','14:40:00',7.12),('11288','2014-05-01','14:45:00',7.13),('11288','2014-05-01','14:50:00',7.04),('11288','2014-05-01','14:55:00',6.24),('11288','2014-05-01','15:00:00',6.27),('11288','2014-05-01','15:05:00',6.98),('11288','2014-05-01','15:10:00',6.38),('11288','2014-05-01','15:15:00',5.2),('11288','2014-05-01','15:20:00',6.48),('11288','2014-05-01','15:25:00',6.34),('11288','2014-05-01','15:30:00',6.21),('11288','2014-05-01','15:35:00',6.12),('11288','2014-05-01','15:40:00',6.05),('11288','2014-05-01','15:45:00',5.79),('11288','2014-05-01','15:50:00',5.95),('11288','2014-05-01','15:55:00',5.66),('11288','2014-05-01','16:00:00',5.66),('11288','2014-05-01','16:05:00',5.61),('11288','2014-05-01','16:10:00',5.35),('11288','2014-05-01','16:15:00',5.31),('11288','2014-05-01','16:20:00',5.03),('11288','2014-05-01','16:25:00',4.59),('11288','2014-05-01','16:30:00',4.84),('11288','2014-05-01','16:35:00',4.9),('11288','2014-05-01','16:40:00',4.57),('11288','2014-05-01','16:45:00',3.83),('11288','2014-05-01','16:50:00',3.25),('11288','2014-05-01','16:55:00',4.07),('11288','2014-05-01','17:00:00',3.86),('11288','2014-05-01','17:05:00',3.68),('11288','2014-05-01','17:10:00',4),('11288','2014-05-01','17:15:00',3.76),('11288','2014-05-01','17:20:00',3.55),('11288','2014-05-01','17:25:00',3.39),('11288','2014-05-01','17:30:00',3.27),('11288','2014-05-01','17:35:00',3.13),('11288','2014-05-01','17:40:00',2.96),('11288','2014-05-01','17:45:00',2.8),('11288','2014-05-01','17:50:00',2.59),('11288','2014-05-01','17:55:00',2.43),('11288','2014-05-01','18:00:00',2.45),('11288','2014-05-01','18:05:00',2.26),('11288','2014-05-01','18:10:00',2.06),('11288','2014-05-01','18:15:00',2.03),('11288','2014-05-01','18:20:00',1.92),('11288','2014-05-01','18:25:00',1.74),('11288','2014-05-01','18:30:00',1.59),('11288','2014-05-01','18:35:00',1.41),('11288','2014-05-01','18:40:00',1.29),('11288','2014-05-01','18:45:00',1.12),('11288','2014-03-17','08:30:00',1.06),('11288','2014-03-17','08:35:00',1.07),('11288','2014-03-17','08:40:00',1.22),('11288','2014-03-17','08:45:00',1.29),('11288','2014-03-17','08:50:00',1.39),('11288','2014-03-17','08:55:00',1.46),('11288','2014-03-17','09:00:00',1.6),('11288','2014-03-17','09:05:00',1.65),('11288','2014-03-17','09:10:00',1.86),('11288','2014-03-17','09:15:00',2.11),('11288','2014-03-17','09:20:00',2.13),('11288','2014-03-17','09:25:00',2.55),('11288','2014-03-17','09:30:00',2.69),('11288','2014-03-17','09:35:00',2.32),('11288','2014-03-17','09:40:00',2.11),('11288','2014-03-17','09:45:00',2.23),('11288','2014-03-17','09:50:00',3.56),('11288','2014-03-17','09:55:00',3.16),('11288','2014-03-17','10:00:00',3.29),('11288','2014-03-17','10:05:00',2.98),('11288','2014-03-17','10:10:00',2.78),('11288','2014-03-17','10:15:00',2.97),('11288','2014-03-17','10:20:00',3.16),('11288','2014-03-17','10:25:00',2.77),('11288','2014-03-17','10:30:00',2.42),('11288','2014-03-17','10:35:00',2.2),('11288','2014-03-17','10:40:00',2.51),('11288','2014-03-17','10:45:00',3.01),('11288','2014-03-17','10:50:00',2.53),('11288','2014-03-17','10:55:00',2.58),('11288','2014-03-17','11:00:00',2.74),('11288','2014-03-17','11:05:00',2.42),('11288','2014-03-17','11:10:00',3.42),('11288','2014-03-17','11:15:00',2.43),('11288','2014-03-17','11:20:00',2.29),('11288','2014-03-17','11:25:00',3.01),('11288','2014-03-17','11:30:00',2.62),('11288','2014-03-17','11:35:00',2.43),('11288','2014-03-17','11:40:00',2.15),('11288','2014-03-17','11:45:00',3.02),('11288','2014-03-17','11:50:00',3.07),('11288','2014-03-17','11:55:00',3.07),('11288','2014-03-17','12:00:00',3.02),('11288','2014-03-17','12:05:00',2.83),('11288','2014-03-17','12:10:00',2.4),('11288','2014-03-17','12:15:00',2.97),('11288','2014-03-17','12:20:00',6.61),('11288','2014-03-17','12:25:00',2.68),('11288','2014-03-17','12:30:00',2.92),('11288','2014-03-17','12:35:00',2.94),('11288','2014-03-17','12:40:00',5.31),('11288','2014-03-17','12:45:00',5.18),('11288','2014-03-17','12:50:00',4.92),('11288','2014-03-17','12:55:00',5.46),('11288','2014-03-17','13:00:00',2.88),('11288','2014-03-17','13:05:00',3.42),('11288','2014-03-17','13:10:00',5.28),('11288','2014-03-17','13:15:00',6.06),('11288','2014-03-17','13:20:00',4.86),('11288','2014-03-17','13:25:00',5.53),('11288','2014-03-17','13:30:00',5.74),('11288','2014-03-17','13:35:00',5.12),('11288','2014-03-17','13:40:00',5.36),('11288','2014-03-17','13:45:00',4.55),('11288','2014-03-17','13:50:00',5.42),('11288','2014-03-17','13:55:00',3.98),('11288','2014-03-17','14:00:00',5.32),('11288','2014-03-17','14:05:00',3.53),('11288','2014-03-17','14:10:00',2.12),('11288','2014-03-17','14:15:00',4.54),('11288','2014-03-17','14:20:00',3.52),('11288','2014-03-17','14:25:00',4.99),('11288','2014-03-17','14:30:00',2.89),('11288','2014-03-17','14:35:00',4.05),('11288','2014-03-17','14:40:00',4.76),('11288','2014-03-17','14:45:00',4.74),('11288','2014-03-17','14:50:00',4.86),('11288','2014-03-17','14:55:00',4.55),('11288','2014-03-17','15:00:00',4.55),('11288','2014-03-17','15:05:00',4.28),('11288','2014-03-17','15:10:00',4.16),('11288','2014-03-17','15:15:00',2.02),('11288','2014-03-17','15:20:00',3.82),('11288','2014-03-17','15:25:00',3.73),('11288','2014-03-17','15:30:00',3.47),('11288','2014-03-17','15:35:00',3.28),('11288','2014-03-17','15:40:00',3.17),('11288','2014-03-17','15:45:00',2.28),('11288','2014-03-17','15:50:00',2.27),('11288','2014-03-17','15:55:00',2.38),('11288','2014-03-17','16:00:00',2.53),('11288','2014-03-17','16:05:00',2.38),('11288','2014-03-17','16:10:00',1.03),('11288','2014-03-17','16:15:00',1.49),('11288','2014-03-17','16:20:00',2.1),('11288','2014-03-17','16:25:00',1.97),('11288','2014-03-17','16:30:00',1.85),('11288','2014-03-17','16:35:00',1.9),('11288','2014-03-17','16:40:00',1.58),('11288','2014-03-17','16:45:00',1.62),('11288','2014-03-17','16:50:00',1.44),('11288','2012-12-22','09:30:00',1.19),('11288','2012-12-22','09:35:00',1.37),('11288','2012-12-22','09:40:00',1.38),('11288','2012-12-22','09:45:00',1.13),('11288','2012-12-22','09:50:00',1.17),('11288','2012-12-22','09:55:00',1.27),('11288','2012-12-22','10:00:00',1.3),('11288','2012-12-22','10:05:00',1.34),('11288','2012-12-22','10:10:00',1.4),('11288','2012-12-22','10:15:00',1.38),('11288','2012-12-22','10:20:00',1.34),('11288','2012-12-22','10:25:00',1.69),('11288','2012-12-22','10:30:00',2.18),('11288','2012-12-22','10:35:00',3.3),('11288','2012-12-22','10:40:00',3.12),('11288','2012-12-22','10:45:00',3.64),('11288','2012-12-22','10:50:00',3.53),('11288','2012-12-22','10:55:00',2.23),('11288','2012-12-22','11:00:00',1.09),('11288','2012-12-22','11:20:00',1.15),('11288','2012-12-22','11:30:00',1.18),('11288','2012-12-22','11:35:00',2.07),('11288','2012-12-22','11:40:00',3.98),('11288','2012-12-22','11:45:00',4.38),('11288','2012-12-22','11:50:00',3.18),('11288','2012-12-22','11:55:00',2.63),('11288','2012-12-22','12:00:00',3.01),('11288','2012-12-22','12:05:00',1.53),('11288','2012-12-22','12:10:00',1.55),('11288','2012-12-22','12:15:00',1.68),('11288','2012-12-22','12:20:00',1.21),('11288','2012-12-22','12:25:00',1.38),('11288','2012-12-22','12:30:00',2.75),('11288','2012-12-22','12:35:00',2.22),('11288','2012-12-22','12:40:00',3.31),('11288','2012-12-22','12:45:00',4.53),('11288','2012-12-22','12:50:00',4.06),('11288','2012-12-22','12:55:00',3.68),('11288','2012-12-22','13:00:00',3.96),('11288','2012-12-22','13:05:00',3.29),('11288','2012-12-22','13:10:00',4.18),('11288','2012-12-22','13:15:00',4.4),('11288','2012-12-22','13:20:00',4.36),('11288','2012-12-22','13:25:00',4.22),('11288','2012-12-22','13:30:00',3.88),('11288','2012-12-22','13:35:00',3.81),('11288','2012-12-22','13:40:00',1.71),('11288','2012-12-22','13:45:00',1.47),('11288','2012-12-22','13:50:00',1.58),('11288','2012-12-22','13:55:00',1.59),('11288','2012-12-22','14:00:00',1.57),('11288','2012-12-22','14:05:00',1.47),('11288','2012-12-22','14:10:00',1.74),('11288','2012-12-22','14:15:00',1.55),('11288','2012-12-22','14:20:00',1.51),('11288','2012-12-22','15:00:00',1.03),('11288','2014-03-16','07:35:00',1.06),('11288','2014-03-16','07:40:00',1.12),('11288','2014-03-16','07:45:00',1.1),('11288','2014-03-16','07:50:00',1.27),('11288','2014-03-16','07:55:00',1.48),('11288','2014-03-16','08:00:00',1.65),('11288','2014-03-16','08:05:00',1.8),('11288','2014-03-16','08:10:00',1.85),('11288','2014-03-16','08:15:00',1.89),('11288','2014-03-16','08:20:00',2.03),('11288','2014-03-16','08:25:00',2.17),('11288','2014-03-16','08:30:00',2.25),('11288','2014-03-16','08:35:00',2.42),('11288','2014-03-16','08:40:00',2.52),('11288','2014-03-16','08:45:00',2.66),('11288','2014-03-16','08:50:00',2.85),('11288','2014-03-16','08:55:00',2.84),('11288','2014-03-16','09:00:00',2.75),('11288','2014-03-16','09:05:00',3.09),('11288','2014-03-16','09:10:00',3.32),('11288','2014-03-16','09:15:00',3.57),('11288','2014-03-16','09:20:00',3.67),('11288','2014-03-16','09:25:00',3.63),('11288','2014-03-16','09:30:00',3.77),('11288','2014-03-16','09:35:00',3.77),('11288','2014-03-16','09:40:00',3.84),('11288','2014-03-16','09:45:00',4.11),('11288','2014-03-16','09:50:00',4.41),('11288','2014-03-16','09:55:00',4.35),('11288','2014-03-16','10:00:00',4.3),('11288','2014-03-16','10:05:00',4.43),('11288','2014-03-16','10:10:00',4.57),('11288','2014-03-16','10:15:00',4.68),('11288','2014-03-16','10:20:00',4.71),('11288','2014-03-16','10:25:00',4.75),('11288','2014-03-16','10:30:00',4.78),('11288','2014-03-16','10:35:00',4.86),('11288','2014-03-16','10:40:00',4.96),('11288','2014-03-16','10:45:00',5.01),('11288','2014-03-16','10:50:00',5.03),('11288','2014-03-16','10:55:00',5.18),('11288','2014-03-16','11:00:00',5.32),('11288','2014-03-16','11:05:00',5.37),('11288','2014-03-16','11:10:00',5.33),('11288','2014-03-16','11:15:00',5.39),('11288','2014-03-16','11:20:00',5.47),('11288','2014-03-16','11:25:00',5.59),('11288','2014-03-16','11:30:00',5.55),('11288','2014-03-16','11:35:00',5.51),('11288','2014-03-16','11:40:00',5.48),('11288','2014-03-16','11:45:00',5.44),('11288','2014-03-16','11:50:00',5.46),('11288','2014-03-16','11:55:00',5.42),('11288','2014-03-16','12:00:00',5.52),('11288','2014-03-16','12:05:00',5.66),('11288','2014-03-16','12:10:00',5.56),('11288','2014-03-16','12:15:00',5.41),('11288','2014-03-16','12:20:00',5.49),('11288','2014-03-16','12:25:00',5.6),('11288','2014-03-16','12:30:00',5.6),('11288','2014-03-16','12:35:00',5.66),('11288','2014-03-16','12:40:00',5.58),('11288','2014-03-16','12:45:00',5.56),('11288','2014-03-16','12:50:00',5.47),('11288','2014-03-16','12:55:00',5.5),('11288','2014-03-16','13:00:00',5.37),('11288','2014-03-16','13:05:00',5.39),('11288','2014-03-16','13:10:00',5.27),('11288','2014-03-16','13:15:00',5.23),('11288','2014-03-16','13:20:00',5.16),('11288','2014-03-16','13:25:00',5.18),('11288','2014-03-16','13:30:00',5.3),('11288','2014-03-16','13:35:00',5.21),('11288','2014-03-16','13:40:00',5.35),('11288','2014-03-16','13:45:00',5.17),('11288','2014-03-16','13:50:00',5.17),('11288','2014-03-16','13:55:00',5.16),('11288','2014-03-16','14:00:00',5.02),('11288','2014-03-16','14:05:00',4.94),('11288','2014-03-16','14:10:00',4.78),('11288','2014-03-16','14:15:00',4.69),('11288','2014-03-16','14:20:00',4.71),('11288','2014-03-16','14:25:00',4.64),('11288','2014-03-16','14:30:00',4.6),('11288','2014-03-16','14:35:00',4.51),('11288','2014-03-16','14:40:00',4.39),('11288','2014-03-16','14:45:00',4.31),('11288','2014-03-16','14:50:00',4.06),('11288','2014-03-16','14:55:00',3.99),('11288','2014-03-16','15:00:00',4.15),('11288','2014-03-16','15:05:00',3.92),('11288','2014-03-16','15:10:00',3.61),('11288','2014-03-16','15:15:00',3.46),('11288','2014-03-16','15:20:00',2.91),('11288','2014-03-16','15:25:00',3.25),('11288','2014-03-16','15:30:00',2.97),('11288','2014-03-16','15:35:00',2.8),('11288','2014-03-16','15:40:00',2.23),('11288','2014-03-16','15:45:00',2.07),('11288','2014-03-16','15:50:00',2.33),('11288','2014-03-16','15:55:00',2.11),('11288','2014-03-16','16:00:00',1.8),('11288','2014-03-16','16:05:00',2.13),('11288','2014-03-16','16:10:00',2.26),('11288','2014-03-16','16:15:00',2.19),('11288','2014-03-16','16:20:00',1.99),('11288','2014-03-16','16:25:00',1.96),('11288','2014-03-16','16:30:00',1.96),('11288','2014-03-16','16:35:00',1.79),('11288','2014-03-16','16:40:00',1.55),('11288','2014-03-16','16:45:00',1.38),('11288','2014-03-16','16:50:00',1.27),('11288','2014-03-16','16:55:00',1.05),('11288','2014-03-15','07:35:00',1.01),('11288','2014-03-15','07:40:00',1.09),('11288','2014-03-15','07:45:00',1.08),('11288','2014-03-15','07:50:00',1.28),('11288','2014-03-15','07:55:00',1.39),('11288','2014-03-15','08:00:00',1.51),('11288','2014-03-15','08:05:00',1.64),('11288','2014-03-15','08:10:00',1.75),('11288','2014-03-15','08:15:00',1.85),('11288','2014-03-15','08:20:00',1.97),('11288','2014-03-15','08:25:00',2.11),('11288','2014-03-15','08:30:00',2.21),('11288','2014-03-15','08:35:00',2.37),('11288','2014-03-15','08:40:00',2.51),('11288','2014-03-15','08:45:00',2.65),('11288','2014-03-15','08:50:00',2.74),('11288','2014-03-15','08:55:00',2.74),('11288','2014-03-15','09:00:00',2.74),('11288','2014-03-15','09:05:00',3.08),('11288','2014-03-15','09:10:00',3.32),('11288','2014-03-15','09:15:00',3.47),('11288','2014-03-15','09:20:00',3.57),('11288','2014-03-15','09:25:00',3.68),('11288','2014-03-15','09:30:00',3.77),('11288','2014-03-15','09:35:00',3.87),('11288','2014-03-15','09:40:00',3.97),('11288','2014-03-15','09:45:00',4.06),('11288','2014-03-15','09:50:00',4.13),('11288','2014-03-15','09:55:00',4.17),('11288','2014-03-15','10:00:00',4.28),('11288','2014-03-15','10:05:00',4.4),('11288','2014-03-15','10:10:00',4.47),('11288','2014-03-15','10:15:00',4.54),('11288','2014-03-15','10:20:00',4.61),('11288','2014-03-15','10:25:00',4.61),('11288','2014-03-15','10:30:00',4.73),('11288','2014-03-15','10:35:00',4.73),('11288','2014-03-15','10:40:00',4.8),('11288','2014-03-15','10:45:00',4.91),('11288','2014-03-15','10:50:00',4.91),('11288','2014-03-15','10:55:00',4.94),('11288','2014-03-15','11:00:00',5.1),('11288','2014-03-15','11:05:00',5.15),('11288','2014-03-15','11:10:00',5.11),('11288','2014-03-15','11:15:00',5.31),('11288','2014-03-15','11:20:00',5.33),('11288','2014-03-15','11:25:00',5.48),('11288','2014-03-15','11:30:00',5.35),('11288','2014-03-15','11:35:00',5.45),('11288','2014-03-15','11:40:00',5.46),('11288','2014-03-15','11:45:00',5.56),('11288','2014-03-15','11:50:00',5.45),('11288','2014-03-15','11:55:00',5.46),('11288','2014-03-15','12:00:00',5.48),('11288','2014-03-15','12:05:00',5.46),('11288','2014-03-15','12:10:00',5.56),('11288','2014-03-15','12:15:00',5.62),('11288','2014-03-15','12:20:00',5.52),('11288','2014-03-15','12:25:00',5.63),('11288','2014-03-15','12:30:00',5.7),('11288','2014-03-15','12:35:00',5.67),('11288','2014-03-15','12:40:00',5.67),('11288','2014-03-15','12:45:00',5.65),('11288','2014-03-15','12:50:00',5.64),('11288','2014-03-15','12:55:00',5.6),('11288','2014-03-15','13:00:00',5.62),('11288','2014-03-15','13:05:00',5.57),('11288','2014-03-15','13:10:00',5.58),('11288','2014-03-15','13:15:00',5.55),('11288','2014-03-15','13:20:00',5.48),('11288','2014-03-15','13:25:00',5.43),('11288','2014-03-15','13:30:00',5.44),('11288','2014-03-15','13:35:00',5.42),('11288','2014-03-15','13:40:00',5.39),('11288','2014-03-15','13:45:00',5.32),('11288','2014-03-15','13:50:00',5.29),('11288','2014-03-15','13:55:00',5.26),('11288','2014-03-15','14:00:00',5.2),('11288','2014-03-15','14:05:00',5.17),('11288','2014-03-15','14:10:00',5.1),('11288','2014-03-15','14:15:00',4.99),('11288','2014-03-15','14:20:00',4.92),('11288','2014-03-15','14:25:00',4.83),('11288','2014-03-15','14:30:00',4.73),('11288','2014-03-15','14:35:00',4.63),('11288','2014-03-15','14:40:00',4.53),('11288','2014-03-15','14:45:00',4.37),('11288','2014-03-15','14:50:00',4.25),('11288','2014-03-15','14:55:00',4.21),('11288','2014-03-15','15:00:00',4.12),('11288','2014-03-15','15:05:00',3.96),('11288','2014-03-15','15:10:00',3.82),('11288','2014-03-15','15:15:00',3.7),('11288','2014-03-15','15:20:00',3.54),('11288','2014-03-15','15:25:00',3.41),('11288','2014-03-15','15:30:00',3.28),('11288','2014-03-15','15:35:00',3.17),('11288','2014-03-15','15:40:00',3),('11288','2014-03-15','15:45:00',2.89),('11288','2014-03-15','15:50:00',2.74),('11288','2014-03-15','15:55:00',2.59),('11288','2014-03-15','16:00:00',2.45),('11288','2014-03-15','16:05:00',2.23),('11288','2014-03-15','16:10:00',2.15),('11288','2014-03-15','16:15:00',2.02),('11288','2014-03-15','16:20:00',1.87),('11288','2014-03-15','16:25:00',1.73),('11288','2014-03-15','16:30:00',1.59),('11288','2014-03-15','16:35:00',1.43),('11288','2014-03-15','16:40:00',1.33),('11288','2014-03-15','16:45:00',1.24),('11288','2014-03-15','16:50:00',1.12),('11288','2014-03-15','16:55:00',1.03),('11288','2014-03-14','07:40:00',1),('11288','2014-03-14','07:45:00',1.1),('11288','2014-03-14','07:50:00',1.21),('11288','2014-03-14','07:55:00',1.29),('11288','2014-03-14','08:00:00',1.4),('11288','2014-03-14','08:05:00',1.49),('11288','2014-03-14','08:10:00',1.6),('11288','2014-03-14','08:15:00',1.75),('11288','2014-03-14','08:20:00',1.88),('11288','2014-03-14','08:25:00',1.96),('11288','2014-03-14','08:30:00',2.05),('11288','2014-03-14','08:35:00',2.07),('11288','2014-03-14','08:40:00',2.01),('11288','2014-03-14','08:45:00',1.82),('11288','2014-03-14','08:50:00',1.77),('11288','2014-03-14','08:55:00',1.86),('11288','2014-03-14','09:00:00',2.02),('11288','2014-03-14','09:05:00',2.27),('11288','2014-03-14','09:10:00',2.47),('11288','2014-03-14','09:15:00',2.57),('11288','2014-03-14','09:20:00',2.53),('11288','2014-03-14','09:25:00',2.59),('11288','2014-03-14','09:30:00',2.6),('11288','2014-03-14','09:35:00',2.94),('11288','2014-03-14','09:40:00',3.59),('11288','2014-03-14','09:45:00',4.28),('11288','2014-03-14','09:50:00',5.04),('11288','2014-03-14','09:55:00',5.25),('11288','2014-03-14','10:00:00',5.4),('11288','2014-03-14','10:05:00',5.39),('11288','2014-03-14','10:10:00',5.26),('11288','2014-03-14','10:15:00',5.16),('11288','2014-03-14','10:20:00',5.05),('11288','2014-03-14','10:25:00',4.76),('11288','2014-03-14','10:30:00',4.75),('11288','2014-03-14','10:35:00',5.02),('11288','2014-03-14','10:40:00',5.21),('11288','2014-03-14','10:45:00',4.43),('11288','2014-03-14','10:50:00',3.04),('11288','2014-03-14','10:55:00',4.21),('11288','2014-03-14','11:00:00',4.95),('11288','2014-03-14','11:05:00',5.27),('11288','2014-03-14','11:10:00',5.79),('11288','2014-03-14','11:15:00',5.81),('11288','2014-03-14','11:20:00',5.61),('11288','2014-03-14','11:25:00',5.47),('11288','2014-03-14','11:30:00',5.51),('11288','2014-03-14','11:35:00',5.59),('11288','2014-03-14','11:40:00',5.72),('11288','2014-03-14','11:45:00',5.85),('11288','2014-03-14','11:50:00',5.98),('11288','2014-03-14','11:55:00',5.93),('11288','2014-03-14','12:00:00',5.92),('11288','2014-03-14','12:05:00',5.9),('11288','2014-03-14','12:10:00',5.52),('11288','2014-03-14','12:15:00',5.34),('11288','2014-03-14','12:20:00',4.3),('11288','2014-03-14','12:25:00',3.73),('11288','2014-03-14','12:30:00',3.46),('11288','2014-03-14','12:35:00',2.98),('11288','2014-03-14','12:40:00',3.55),('11288','2014-03-14','12:45:00',4.17),('11288','2014-03-14','12:50:00',4.78),('11288','2014-03-14','12:55:00',5.13),('11288','2014-03-14','13:00:00',3.42),('11288','2014-03-14','13:05:00',3.22),('11288','2014-03-14','13:10:00',3.74),('11288','2014-03-14','13:15:00',4.06),('11288','2014-03-14','13:20:00',4.61),('11288','2014-03-14','13:25:00',4.14),('11288','2014-03-14','13:30:00',3.87),('11288','2014-03-14','13:35:00',3.37),('11288','2014-03-14','13:40:00',3.41),('11288','2014-03-14','13:45:00',3.6),('11288','2014-03-14','13:50:00',3.67),('11288','2014-03-14','13:55:00',3.37),('11288','2014-03-14','14:00:00',4.09),('11288','2014-03-14','14:05:00',4.6),('11288','2014-03-14','14:10:00',4.35),('11288','2014-03-14','14:15:00',4.62),('11288','2014-03-14','14:20:00',4.62),('11288','2014-03-14','14:25:00',4.18),('11288','2014-03-14','14:30:00',4.04),('11288','2014-03-14','14:35:00',3.9),('11288','2014-03-14','14:40:00',3.15),('11288','2014-03-14','14:45:00',2.67),('11288','2014-03-14','14:50:00',2.5),('11288','2014-03-14','14:55:00',2.3),('11288','2014-03-14','15:00:00',2.15),('11288','2014-03-14','15:05:00',2.17),('11288','2014-03-14','15:10:00',2.03),('11288','2014-03-14','15:15:00',1.95),('11288','2014-03-14','15:20:00',2.06),('11288','2014-03-14','15:25:00',2.15),('11288','2014-03-14','15:30:00',2.29),('11288','2014-03-14','15:35:00',2.63),('11288','2014-03-14','15:40:00',2.48),('11288','2014-03-14','15:45:00',2.07),('11288','2014-03-14','15:50:00',1.9),('11288','2014-03-14','15:55:00',1.92),('11288','2014-03-14','16:00:00',1.8),('11288','2014-03-14','16:05:00',1.8),('11288','2014-03-14','16:10:00',1.53),('11288','2014-03-14','16:15:00',1.34),('11288','2014-03-14','16:20:00',1.2),('11288','2014-03-14','16:25:00',1.11),('11288','2014-03-14','16:30:00',1.06),('11288','2014-03-14','16:35:00',1),('11288','2014-03-13','07:40:00',1.04),('11288','2014-03-13','07:45:00',1.08),('11288','2014-03-13','07:50:00',1.26),('11288','2014-03-13','07:55:00',1.38),('11288','2014-03-13','08:00:00',1.54),('11288','2014-03-13','08:05:00',1.73),('11288','2014-03-13','08:10:00',1.9),('11288','2014-03-13','08:15:00',1.97),('11288','2014-03-13','08:20:00',2.15),('11288','2014-03-13','08:25:00',2.34),('11288','2014-03-13','08:30:00',2.49),('11288','2014-03-13','08:35:00',2.66),('11288','2014-03-13','08:40:00',2.76),('11288','2014-03-13','08:45:00',2.9),('11288','2014-03-13','08:50:00',3.06),('11288','2014-03-13','08:55:00',3.29),('11288','2014-03-13','09:00:00',3.48),('11288','2014-03-13','09:05:00',3.63),('11288','2014-03-13','09:10:00',3.74),('11288','2014-03-13','09:15:00',3.82),('11288','2014-03-13','09:20:00',3.94),('11288','2014-03-13','09:25:00',4.03),('11288','2014-03-13','09:30:00',4.15),('11288','2014-03-13','09:35:00',4.28),('11288','2014-03-13','09:40:00',4.44),('11288','2014-03-13','09:45:00',4.54),('11288','2014-03-13','09:50:00',4.66),('11288','2014-03-13','09:55:00',4.74),('11288','2014-03-13','10:00:00',4.84),('11288','2014-03-13','10:05:00',4.89),('11288','2014-03-13','10:10:00',5.01),('11288','2014-03-13','10:15:00',5.07),('11288','2014-03-13','10:20:00',5.12),('11288','2014-03-13','10:25:00',5.16),('11288','2014-03-13','10:30:00',5.21),('11288','2014-03-13','10:35:00',5.27),('11288','2014-03-13','10:40:00',5.32),('11288','2014-03-13','10:45:00',5.38),('11288','2014-03-13','10:50:00',5.41),('11288','2014-03-13','10:55:00',5.47),('11288','2014-03-13','11:00:00',5.57),('11288','2014-03-13','11:05:00',5.58),('11288','2014-03-13','11:10:00',5.63),('11288','2014-03-13','11:15:00',5.66),('11288','2014-03-13','11:20:00',5.77),('11288','2014-03-13','11:25:00',5.84),('11288','2014-03-13','11:30:00',5.85),('11288','2014-03-13','11:35:00',5.86),('11288','2014-03-13','11:40:00',5.92),('11288','2014-03-13','11:45:00',5.9),('11288','2014-03-13','11:50:00',5.92),('11288','2014-03-13','11:55:00',5.95),('11288','2014-03-13','12:00:00',5.96),('11288','2014-03-13','12:05:00',6),('11288','2014-03-13','12:10:00',5.96),('11288','2014-03-13','12:15:00',5.95),('11288','2014-03-13','12:20:00',5.88),('11288','2014-03-13','12:25:00',5.87),('11288','2014-03-13','12:30:00',5.85),('11288','2014-03-13','12:35:00',5.85),('11288','2014-03-13','12:40:00',5.83),('11288','2014-03-13','12:45:00',5.8),('11288','2014-03-13','12:50:00',5.77),('11288','2014-03-13','12:55:00',5.71),('11288','2014-03-13','13:00:00',5.68),('11288','2014-03-13','13:05:00',5.65),('11288','2014-03-13','13:10:00',5.54),('11288','2014-03-13','13:15:00',5.55),('11288','2014-03-13','13:20:00',5.55),('11288','2014-03-13','13:25:00',5.55),('11288','2014-03-13','13:30:00',5.51),('11288','2014-03-13','13:35:00',5.46),('11288','2014-03-13','13:40:00',5.41),('11288','2014-03-13','13:45:00',5.34),('11288','2014-03-13','13:50:00',5.3),('11288','2014-03-13','13:55:00',5.21),('11288','2014-03-13','14:00:00',5.13),('11288','2014-03-13','14:05:00',5.05),('11288','2014-03-13','14:10:00',5.01),('11288','2014-03-13','14:15:00',4.96),('11288','2014-03-13','14:20:00',4.89),('11288','2014-03-13','14:25:00',4.82),('11288','2014-03-13','14:30:00',4.71),('11288','2014-03-13','14:35:00',4.6),('11288','2014-03-13','14:40:00',4.53),('11288','2014-03-13','14:45:00',4.36),('11288','2014-03-13','14:50:00',4.27),('11288','2014-03-13','14:55:00',4.16),('11288','2014-03-13','15:00:00',4.06),('11288','2014-03-13','15:05:00',3.88),('11288','2014-03-13','15:10:00',3.77),('11288','2014-03-13','15:15:00',3.67),('11288','2014-03-13','15:20:00',3.56),('11288','2014-03-13','15:25:00',3.41),('11288','2014-03-13','15:30:00',3.3),('11288','2014-03-13','15:35:00',3.18),('11288','2014-03-13','15:40:00',3.02),('11288','2014-03-13','15:45:00',2.88),('11288','2014-03-13','15:50:00',2.76),('11288','2014-03-13','15:55:00',2.63),('11288','2014-03-13','16:00:00',2.45),('11288','2014-03-13','16:05:00',2.27),('11288','2014-03-13','16:10:00',2.15),('11288','2014-03-13','16:15:00',2.01),('11288','2014-03-13','16:20:00',1.86),('11288','2014-03-13','16:25:00',1.77),('11288','2014-03-13','16:30:00',1.63),('11288','2014-03-13','16:35:00',1.48),('11288','2014-03-13','16:40:00',1.38),('11288','2014-03-13','16:45:00',1.27),('11288','2014-03-13','16:50:00',1.14),('11288','2014-03-13','16:55:00',1.02),('11288','2014-03-12','07:50:00',1.15),('11288','2014-03-12','07:55:00',1.25),('11288','2014-03-12','08:00:00',1.4),('11288','2014-03-12','08:05:00',1.6),('11288','2014-03-12','08:10:00',1.79),('11288','2014-03-12','08:15:00',1.85),('11288','2014-03-12','08:20:00',2.1),('11288','2014-03-12','08:25:00',2.25),('11288','2014-03-12','08:30:00',2.42),('11288','2014-03-12','08:35:00',2.54),('11288','2014-03-12','08:40:00',2.73),('11288','2014-03-12','08:45:00',2.83),('11288','2014-03-12','08:50:00',3.01),('11288','2014-03-12','08:55:00',3.23),('11288','2014-03-12','09:00:00',3.42),('11288','2014-03-12','09:05:00',3.51),('11288','2014-03-12','09:10:00',3.63),('11288','2014-03-12','09:15:00',3.75),('11288','2014-03-12','09:20:00',3.9),('11288','2014-03-12','09:25:00',4.03),('11288','2014-03-12','09:30:00',4.13),('11288','2014-03-12','09:35:00',4.23),('11288','2014-03-12','09:40:00',4.38),('11288','2014-03-12','09:45:00',4.47),('11288','2014-03-12','09:50:00',4.59),('11288','2014-03-12','09:55:00',4.69),('11288','2014-03-12','10:00:00',4.8),('11288','2014-03-12','10:05:00',4.87),('11288','2014-03-12','10:10:00',4.96),('11288','2014-03-12','10:15:00',5.04),('11288','2014-03-12','10:20:00',5.08),('11288','2014-03-12','10:25:00',5.16),('11288','2014-03-12','10:30:00',5.22),('11288','2014-03-12','10:35:00',5.29),('11288','2014-03-12','10:40:00',5.37),('11288','2014-03-12','10:45:00',5.45),('11288','2014-03-12','10:50:00',5.53),('11288','2014-03-12','10:55:00',5.6),('11288','2014-03-12','11:00:00',5.68),('11288','2014-03-12','11:05:00',5.74),('11288','2014-03-12','11:10:00',5.8),('11288','2014-03-12','11:15:00',5.85),('11288','2014-03-12','11:20:00',5.94),('11288','2014-03-12','11:25:00',6.03),('11288','2014-03-12','11:30:00',6.06),('11288','2014-03-12','11:35:00',6.08),('11288','2014-03-12','11:40:00',6.1),('11288','2014-03-12','11:45:00',6.11),('11288','2014-03-12','11:50:00',6.1),('11288','2014-03-12','11:55:00',6.12),('11288','2014-03-12','12:00:00',6.15),('11288','2014-03-12','12:05:00',6.09),('11288','2014-03-12','12:10:00',6.1),('11288','2014-03-12','12:15:00',6.06),('11288','2014-03-12','12:20:00',6.03),('11288','2014-03-12','12:25:00',6.06),('11288','2014-03-12','12:30:00',6.03),('11288','2014-03-12','12:35:00',6.01),('11288','2014-03-12','12:40:00',6.01),('11288','2014-03-12','12:45:00',5.95),('11288','2014-03-12','12:50:00',5.94),('11288','2014-03-12','12:55:00',5.92),('11288','2014-03-12','13:00:00',5.91),('11288','2014-03-12','13:05:00',5.88),('11288','2014-03-12','13:10:00',5.81),('11288','2014-03-12','13:15:00',5.73),('11288','2014-03-12','13:20:00',5.71),('11288','2014-03-12','13:25:00',5.68),('11288','2014-03-12','13:30:00',5.62),('11288','2014-03-12','13:35:00',5.54),('11288','2014-03-12','13:40:00',5.48),('11288','2014-03-12','13:45:00',5.47),('11288','2014-03-12','13:50:00',5.39),('11288','2014-03-12','13:55:00',5.33),('11288','2014-03-12','14:00:00',5.31),('11288','2014-03-12','14:05:00',5.25),('11288','2014-03-12','14:10:00',5.18),('11288','2014-03-12','14:15:00',5.1),('11288','2014-03-12','14:20:00',5.02),('11288','2014-03-12','14:25:00',4.94),('11288','2014-03-12','14:30:00',4.85),('11288','2014-03-12','14:35:00',4.65),('11288','2014-03-12','14:40:00',4.49),('11288','2014-03-12','14:45:00',4.35),('11288','2014-03-12','14:50:00',4.21),('11288','2014-03-12','14:55:00',4.2),('11288','2014-03-12','15:00:00',3.78),('11288','2014-03-12','15:05:00',3.81),('11288','2014-03-12','15:10:00',3.75),('11288','2014-03-12','15:15:00',3.64),('11288','2014-03-12','15:20:00',3.49),('11288','2014-03-12','15:25:00',3.31),('11288','2014-03-12','15:30:00',3.2),('11288','2014-03-12','15:35:00',3.08),('11288','2014-03-12','15:40:00',3.02),('11288','2014-03-12','15:45:00',2.89),('11288','2014-03-12','15:50:00',2.76),('11288','2014-03-12','15:55:00',2.62),('11288','2014-03-12','16:00:00',2.52),('11288','2014-03-12','16:05:00',2.37),('11288','2014-03-12','16:10:00',2.18),('11288','2014-03-12','16:15:00',2.08),('11288','2014-03-12','16:20:00',1.91),('11288','2014-03-12','16:25:00',1.78),('11288','2014-03-12','16:30:00',1.59),('11288','2014-03-12','16:35:00',1.52),('11288','2014-03-12','16:40:00',1.39),('11288','2014-03-12','16:45:00',1.27),('11288','2014-03-12','16:50:00',1.13),('11288','2014-03-12','16:55:00',1.01),('11288','2014-03-11','07:45:00',1.01),('11288','2014-03-11','07:55:00',1.05),('11288','2014-03-11','08:00:00',1.01),('11288','2014-03-11','10:10:00',1.05),('11288','2014-03-11','10:15:00',1.28),('11288','2014-03-11','10:20:00',1.61),('11288','2014-03-11','10:25:00',1.69),('11288','2014-03-11','10:30:00',1.73),('11288','2014-03-11','10:35:00',1.74),('11288','2014-03-11','10:40:00',1.73),('11288','2014-03-11','10:45:00',1.67),('11288','2014-03-11','10:50:00',1.53),('11288','2014-03-11','10:55:00',1.59),('11288','2014-03-11','11:00:00',1.79),('11288','2014-03-11','11:05:00',1.88),('11288','2014-03-11','11:10:00',1.84),('11288','2014-03-11','11:15:00',1.88),('11288','2014-03-11','11:20:00',1.75),('11288','2014-03-11','11:25:00',1.67),('11288','2014-03-11','11:30:00',1.57),('11288','2014-03-11','11:35:00',1.66),('11288','2014-03-11','11:40:00',1.76),('11288','2014-03-11','11:45:00',1.85),('11288','2014-03-11','11:50:00',1.63),('11288','2014-03-11','11:55:00',1.75),('11288','2014-03-11','12:00:00',1.87),('11288','2014-03-11','12:05:00',1.87),('11288','2014-03-11','12:10:00',1.93),('11288','2014-03-11','12:15:00',2.18),('11288','2014-03-11','12:20:00',2.36),('11288','2014-03-11','12:25:00',2.17),('11288','2014-03-11','12:30:00',2.11),('11288','2014-03-11','12:35:00',2.26),('11288','2014-03-11','12:40:00',2.46),('11288','2014-03-11','12:45:00',2.43),('11288','2014-03-11','12:50:00',2.31),('11288','2014-03-11','12:55:00',2.17),('11288','2014-03-11','13:00:00',2.11),('11288','2014-03-11','13:05:00',2.37),('11288','2014-03-11','13:10:00',2.38),('11288','2014-03-11','13:15:00',2.25),('11288','2014-03-11','13:20:00',2.34),('11288','2014-03-11','13:25:00',2.06),('11288','2014-03-11','13:30:00',2.03),('11288','2014-03-11','13:35:00',1.93),('11288','2014-03-11','13:40:00',1.98),('11288','2014-03-11','13:45:00',2.43),('11288','2014-03-11','13:50:00',2.84),('11288','2014-03-11','13:55:00',3.26),('11288','2014-03-11','14:00:00',3.37),('11288','2014-03-11','14:05:00',3.35),('11288','2014-03-11','14:10:00',3.93),('11288','2014-03-11','14:15:00',4.29),('11288','2014-03-11','14:20:00',4.27),('11288','2014-03-11','14:25:00',3.26),('11288','2014-03-11','14:30:00',2.45),('11288','2014-03-11','14:35:00',2.61),('11288','2014-03-11','14:40:00',2.44),('11288','2014-03-11','14:45:00',2.57),('11288','2014-03-11','14:50:00',2.37),('11288','2014-03-11','14:55:00',2.32),('11288','2014-03-11','15:00:00',2.66),('11288','2014-03-11','15:05:00',2.81),('11288','2014-03-11','15:10:00',3.09),('11288','2014-03-11','15:15:00',2.92),('11288','2014-03-11','15:20:00',2.9),('11288','2014-03-11','15:25:00',2.36),('11288','2014-03-11','15:30:00',2.22),('11288','2014-03-11','15:35:00',2.02),('11288','2014-03-11','15:40:00',1.94),('11288','2014-03-11','15:45:00',1.86),('11288','2014-03-11','15:50:00',1.88),('11288','2014-03-11','15:55:00',1.58),('11288','2014-03-11','16:00:00',1.44),('11288','2014-03-11','16:05:00',1.37),('11288','2014-03-11','16:10:00',1.41),('11288','2014-03-11','16:15:00',1.33),('11288','2014-03-11','16:20:00',1.32),('11288','2014-03-11','16:25:00',1.17),('11288','2014-03-11','16:30:00',1.07),('11288','2014-03-10','08:15:00',1.04),('11288','2014-03-10','08:20:00',1.11),('11288','2014-03-10','08:25:00',1.2),('11288','2014-03-10','08:30:00',1.29),('11288','2014-03-10','08:35:00',1.48),('11288','2014-03-10','08:40:00',1.63),('11288','2014-03-10','08:45:00',1.62),('11288','2014-03-10','08:50:00',1.69),('11288','2014-03-10','08:55:00',1.7),('11288','2014-03-10','09:00:00',1.73),('11288','2014-03-10','09:05:00',1.87),('11288','2014-03-10','09:10:00',1.85),('11288','2014-03-10','09:15:00',1.71),('11288','2014-03-10','09:20:00',1.61),('11288','2014-03-10','09:25:00',1.7),('11288','2014-03-10','09:30:00',1.79),('11288','2014-03-10','09:35:00',1.84),('11288','2014-03-10','09:40:00',1.93),('11288','2014-03-10','09:45:00',1.77),('11288','2014-03-10','09:50:00',1.58),('11288','2014-03-10','09:55:00',1.52),('11288','2014-03-10','10:00:00',1.38),('11288','2014-03-10','10:05:00',1.45),('11288','2014-03-10','10:10:00',1.78),('11288','2014-03-10','10:15:00',2.05),('11288','2014-03-10','10:20:00',1.74),('11288','2014-03-10','10:25:00',1.55),('11288','2014-03-10','10:30:00',1.86),('11288','2014-03-10','10:35:00',2.23),('11288','2014-03-10','10:40:00',1.65),('11288','2014-03-10','10:45:00',1.1),('11288','2014-03-10','11:05:00',1),('11288','2014-03-10','11:10:00',1.23),('11288','2014-03-10','11:15:00',1.6),('11288','2014-03-10','11:20:00',1.8),('11288','2014-03-10','11:25:00',1.66),('11288','2014-03-10','11:30:00',1.46),('11288','2014-03-10','12:20:00',1.05),('11288','2014-03-10','12:25:00',1.1),('11288','2014-03-10','12:30:00',1.22),('11288','2014-03-10','12:35:00',1.41),('11288','2014-03-10','12:40:00',1.58),('11288','2014-03-10','12:45:00',1.8),('11288','2014-03-10','12:50:00',1.99),('11288','2014-03-10','12:55:00',2.12),('11288','2014-03-10','13:00:00',2.21),('11288','2014-03-10','13:05:00',2.26),('11288','2014-03-10','13:10:00',2.38),('11288','2014-03-10','13:15:00',2.59),('11288','2014-03-10','13:20:00',2.62),('11288','2014-03-10','13:25:00',2.39),('11288','2014-03-10','13:30:00',2.07),('11288','2014-03-10','13:35:00',1.71),('11288','2014-03-10','13:40:00',1.52),('11288','2014-03-10','13:45:00',1.37),('11288','2014-03-10','13:50:00',2.06),('11288','2014-03-10','13:55:00',2.39),('11288','2014-03-10','14:00:00',2),('11288','2014-03-10','14:05:00',2.97),('11288','2014-03-10','14:10:00',3.5),('11288','2014-03-10','14:15:00',4.91),('11288','2014-03-10','14:20:00',3.49),('11288','2014-03-10','14:25:00',2.78),('11288','2014-03-10','14:30:00',2.39),('11288','2014-03-10','14:35:00',3.13),('11288','2014-03-10','14:40:00',4.56),('11288','2014-03-10','14:45:00',4.67),('11288','2014-03-10','14:50:00',4.32),('11288','2014-03-10','14:55:00',2.23),('11288','2014-03-10','15:00:00',2.92),('11288','2014-03-10','15:05:00',2.47),('11288','2014-03-10','15:10:00',1.67),('11288','2014-03-10','15:15:00',2.15),('11288','2014-03-10','15:20:00',2.82),('11288','2014-03-10','15:25:00',3.67),('11288','2014-03-10','15:30:00',2.88),('11288','2014-03-10','15:35:00',2.05),('11288','2014-03-10','15:40:00',1.71),('11288','2014-03-10','15:45:00',1.5),('11288','2014-03-10','15:50:00',1.53),('11288','2014-03-10','15:55:00',1.34),('11288','2014-03-10','16:00:00',1.44),('11288','2014-03-10','16:05:00',1.57),('11288','2014-03-10','16:10:00',1.29),('11288','2014-03-10','16:15:00',1.07),('11288','2014-03-10','16:20:00',1.16),('11288','2014-03-10','16:25:00',1.25),('11288','2014-03-10','16:30:00',1.5),('11288','2014-03-10','16:35:00',1.25),('11288','2014-03-10','16:55:00',1.37),('11288','2014-03-10','17:00:00',1.17),('11288','2014-03-09','07:55:00',1.08),('11288','2014-03-09','08:00:00',1.3),('11288','2014-03-09','08:05:00',1.43),('11288','2014-03-09','08:10:00',1.53),('11288','2014-03-09','08:15:00',1.79),('11288','2014-03-09','08:20:00',1.9),('11288','2014-03-09','08:25:00',1.95),('11288','2014-03-09','08:30:00',1.74),('11288','2014-03-09','08:35:00',1.79),('11288','2014-03-09','08:40:00',1.69),('11288','2014-03-09','08:45:00',1.67),('11288','2014-03-09','08:50:00',1.38),('11288','2014-03-09','08:55:00',2.4),('11288','2014-03-09','09:00:00',3.02),('11288','2014-03-09','09:05:00',2.86),('11288','2014-03-09','09:10:00',1.6),('11288','2014-03-09','09:15:00',3.64),('11288','2014-03-09','09:20:00',3.82),('11288','2014-03-09','09:25:00',4.04),('11288','2014-03-09','09:30:00',4.19),('11288','2014-03-09','09:35:00',4.51),('11288','2014-03-09','09:40:00',4.61),('11288','2014-03-09','09:45:00',4.75),('11288','2014-03-09','09:50:00',4.81),('11288','2014-03-09','09:55:00',4.86),('11288','2014-03-09','10:00:00',4.87),('11288','2014-03-09','10:05:00',4.95),('11288','2014-03-09','10:10:00',5.09),('11288','2014-03-09','10:15:00',5.14),('11288','2014-03-09','10:20:00',5.14),('11288','2014-03-09','10:25:00',5.21),('11288','2014-03-09','10:30:00',5.33),('11288','2014-03-09','10:35:00',5.43),('11288','2014-03-09','10:40:00',5.44),('11288','2014-03-09','10:45:00',5.5),('11288','2014-03-09','10:50:00',5.66),('11288','2014-03-09','10:55:00',5.8),('11288','2014-03-09','11:00:00',6.16),('11288','2014-03-09','11:05:00',6.06),('11288','2014-03-09','11:10:00',6.36),('11288','2014-03-09','11:15:00',6.63),('11288','2014-03-09','11:20:00',4.78),('11288','2014-03-09','11:25:00',3.03),('11288','2014-03-09','11:30:00',2.25),('11288','2014-03-09','11:35:00',3.97),('11288','2014-03-09','11:40:00',3.81),('11288','2014-03-09','11:45:00',2.67),('11288','2014-03-09','11:50:00',5.34),('11288','2014-03-09','11:55:00',5.01),('11288','2014-03-09','12:00:00',6.19),('11288','2014-03-09','12:05:00',6.07),('11288','2014-03-09','12:10:00',7.13),('11288','2014-03-09','12:15:00',6.91),('11288','2014-03-09','12:20:00',6.95),('11288','2014-03-09','12:25:00',6.73),('11288','2014-03-09','12:30:00',6.78),('11288','2014-03-09','12:35:00',7.07),('11288','2014-03-09','12:40:00',6.68),('11288','2014-03-09','12:45:00',6.46),('11288','2014-03-09','12:50:00',6.5),('11288','2014-03-09','12:55:00',6.55),('11288','2014-03-09','13:00:00',6.69),('11288','2014-03-09','13:05:00',6.76),('11288','2014-03-09','13:10:00',6.5),('11288','2014-03-09','13:15:00',6.28),('11288','2014-03-09','13:20:00',6.21),('11288','2014-03-09','13:25:00',5.94),('11288','2014-03-09','13:30:00',6.05),('11288','2014-03-09','13:35:00',5.75),('11288','2014-03-09','13:40:00',2.2),('11288','2014-03-09','13:45:00',1.66),('11288','2014-03-09','13:50:00',4.83),('11288','2014-03-09','13:55:00',1.79),('11288','2014-03-09','14:00:00',2.24),('11288','2014-03-09','14:05:00',5.52),('11288','2014-03-09','14:10:00',5.46),('11288','2014-03-09','14:15:00',5.29),('11288','2014-03-09','14:20:00',2.6),('11288','2014-03-09','14:25:00',5.52),('11288','2014-03-09','14:30:00',2.9),('11288','2014-03-09','14:35:00',1.75),('11288','2014-03-09','14:40:00',1.35),('11288','2014-03-09','14:45:00',3.07),('11288','2014-03-09','14:50:00',2.6),('11288','2014-03-09','14:55:00',4.54),('11288','2014-03-09','15:00:00',4.36),('11288','2014-03-09','15:05:00',3.85),('11288','2014-03-09','15:10:00',3.85),('11288','2014-03-09','15:15:00',3.89),('11288','2014-03-09','15:20:00',3.78),('11288','2014-03-09','15:25:00',3.72),('11288','2014-03-09','15:30:00',3.63),('11288','2014-03-09','15:35:00',3.43),('11288','2014-03-09','15:40:00',3.23),('11288','2014-03-09','15:45:00',2.8),('11288','2014-03-09','15:50:00',1.02),('11288','2014-03-09','15:55:00',1.98),('11288','2014-03-09','16:00:00',2.62),('11288','2014-03-09','16:05:00',2.49),('11288','2014-03-09','16:10:00',1.8),('11288','2014-03-09','16:15:00',1.59),('11288','2014-03-09','16:20:00',1.48),('11288','2014-03-09','16:25:00',1.63),('11288','2014-03-09','16:30:00',1.67),('11288','2014-03-09','16:35:00',1.59),('11288','2014-03-09','16:40:00',1.5),('11288','2014-03-09','16:45:00',1.25),('11288','2014-03-09','16:50:00',1.11),('11288','2014-03-08','07:55:00',1.14),('11288','2014-03-08','08:00:00',1.27),('11288','2014-03-08','08:05:00',1.39),('11288','2014-03-08','08:10:00',1.45),('11288','2014-03-08','08:15:00',1.71),('11288','2014-03-08','08:20:00',1.9),('11288','2014-03-08','08:25:00',2.1),('11288','2014-03-08','08:30:00',2.25),('11288','2014-03-08','08:35:00',2.39),('11288','2014-03-08','08:40:00',2.54),('11288','2014-03-08','08:45:00',2.68),('11288','2014-03-08','08:50:00',2.83),('11288','2014-03-08','08:55:00',2.97),('11288','2014-03-08','09:00:00',3.16),('11288','2014-03-08','09:05:00',3.32),('11288','2014-03-08','09:10:00',3.46),('11288','2014-03-08','09:15:00',3.59),('11288','2014-03-08','09:20:00',3.66),('11288','2014-03-08','09:25:00',3.84),('11288','2014-03-08','09:30:00',3.94),('11288','2014-03-08','09:35:00',4.09),('11288','2014-03-08','09:40:00',4.21),('11288','2014-03-08','09:45:00',4.35),('11288','2014-03-08','09:50:00',4.48),('11288','2014-03-08','09:55:00',4.59),('11288','2014-03-08','10:00:00',4.69),('11288','2014-03-08','10:05:00',4.79),('11288','2014-03-08','10:10:00',4.86),('11288','2014-03-08','10:15:00',4.94),('11288','2014-03-08','10:20:00',5.01),('11288','2014-03-08','10:25:00',5.08),('11288','2014-03-08','10:30:00',5.18),('11288','2014-03-08','10:35:00',5.25),('11288','2014-03-08','10:40:00',5.34),('11288','2014-03-08','10:45:00',5.41),('11288','2014-03-08','10:50:00',5.44),('11288','2014-03-08','10:55:00',5.5),('11288','2014-03-08','11:00:00',5.59),('11288','2014-03-08','11:05:00',5.65),('11288','2014-03-08','11:10:00',5.68),('11288','2014-03-08','11:15:00',5.8),('11288','2014-03-08','11:20:00',5.91),('11288','2014-03-08','11:25:00',6.13),('11288','2014-03-08','11:30:00',6.45),('11288','2014-03-08','11:35:00',6.38),('11288','2014-03-08','11:40:00',4.72),('11288','2014-03-08','11:45:00',3),('11288','2014-03-08','11:50:00',2.45),('11288','2014-03-08','11:55:00',4.92),('11288','2014-03-08','12:00:00',3.53),('11288','2014-03-08','12:05:00',1.77),('11288','2014-03-08','12:10:00',1.81),('11288','2014-03-08','12:15:00',1.94),('11288','2014-03-08','12:20:00',2.25),('11288','2014-03-08','12:25:00',2.53),('11288','2014-03-08','12:30:00',2.71),('11288','2014-03-08','12:35:00',5.41),('11288','2014-03-08','12:40:00',3.46),('11288','2014-03-08','12:45:00',4.03),('11288','2014-03-08','12:50:00',3.87),('11288','2014-03-08','12:55:00',5.37),('11288','2014-03-08','13:00:00',3.6),('11288','2014-03-08','13:05:00',2.92),('11288','2014-03-08','13:10:00',2.61),('11288','2014-03-08','13:15:00',2.12),('11288','2014-03-08','13:20:00',1.78),('11288','2014-03-08','13:25:00',1.81),('11288','2014-03-08','13:30:00',2.7),('11288','2014-03-08','13:35:00',2.85),('11288','2014-03-08','13:40:00',3.74),('11288','2014-03-08','13:45:00',4.29),('11288','2014-03-08','13:50:00',3.99),('11288','2014-03-08','13:55:00',2.46),('11288','2014-03-08','14:00:00',1.96),('11288','2014-03-08','14:05:00',1.88),('11288','2014-03-08','14:10:00',1.76),('11288','2014-03-08','14:15:00',1.44),('11288','2014-03-08','14:20:00',1.34),('11288','2014-03-08','14:25:00',1.28),('11288','2014-03-08','14:30:00',1.35),('11288','2014-03-08','14:35:00',1.65),('11288','2014-03-08','14:40:00',1.81),('11288','2014-03-08','14:45:00',1.71),('11288','2014-03-08','14:50:00',1.75),('11288','2014-03-08','14:55:00',1.83),('11288','2014-03-08','15:00:00',1.65),('11288','2014-03-08','15:05:00',1.48),('11288','2014-03-08','15:10:00',1.64),('11288','2014-03-08','15:15:00',2.1),('11288','2014-03-08','15:20:00',2.52),('11288','2014-03-08','15:25:00',2.32),('11288','2014-03-08','15:30:00',3.14),('11288','2014-03-08','15:35:00',1.35),('11288','2014-03-08','15:40:00',1.14),('11288','2014-03-08','15:45:00',1.18),('11288','2014-03-08','15:50:00',1.43),('11288','2014-03-08','15:55:00',1.51),('11288','2014-03-08','16:00:00',1.62),('11288','2014-03-08','16:05:00',1.36),('11288','2014-03-08','16:10:00',1.09),('11288','2014-03-08','16:15:00',1.11),('11288','2014-03-08','16:20:00',1.23),('11288','2014-03-08','16:25:00',1.14),('11288','2014-03-08','16:30:00',1.5),('11288','2014-03-08','16:35:00',1.58),('11288','2014-03-08','16:40:00',1.31),('11288','2014-03-08','16:45:00',1.23),('11288','2014-03-08','16:50:00',1.17),('11288','2014-03-08','16:55:00',1.01),('11288','2014-04-30','07:35:00',1.04),('11288','2014-04-30','07:40:00',1.08),('11288','2014-04-30','07:45:00',1.23),('11288','2014-04-30','07:50:00',1.37),('11288','2014-04-30','07:55:00',1.44),('11288','2014-04-30','08:00:00',1.48),('11288','2014-04-30','08:05:00',1.59),('11288','2014-04-30','08:10:00',1.69),('11288','2014-04-30','08:15:00',1.93),('11288','2014-04-30','08:20:00',2.1),('11288','2014-04-30','08:25:00',1.91),('11288','2014-04-30','08:30:00',2.11),('11288','2014-04-30','08:35:00',2.53),('11288','2014-04-30','08:40:00',2.69),('11288','2014-04-30','08:45:00',2.65),('11288','2014-04-30','08:50:00',2.8),('11288','2014-04-30','08:55:00',2.94),('11288','2014-04-30','09:00:00',3.73),('11288','2014-04-30','09:05:00',3.91),('11288','2014-04-30','09:10:00',3.36),('11288','2014-04-30','09:15:00',2.75),('11288','2014-04-30','09:20:00',3.78),('11288','2014-04-30','09:25:00',3.23),('11288','2014-04-30','09:30:00',2.6),('11288','2014-04-30','09:35:00',4.66),('11288','2014-04-30','09:40:00',4.82),('11288','2014-04-30','09:45:00',4.07),('11288','2014-04-30','09:50:00',3.74),('11288','2014-04-30','09:55:00',5.39),('11288','2014-04-30','10:00:00',5.62),('11288','2014-04-30','10:05:00',4.39),('11288','2014-04-30','10:10:00',4.55),('11288','2014-04-30','10:15:00',4.09),('11288','2014-04-30','10:20:00',2.85),('11288','2014-04-30','10:25:00',3.15),('11288','2014-04-30','10:30:00',3.72),('11288','2014-04-30','10:35:00',3.48),('11288','2014-04-30','10:40:00',3.94),('11288','2014-04-30','10:45:00',2.84),('11288','2014-04-30','10:50:00',3.6),('11288','2014-04-30','10:55:00',7.71),('11288','2014-04-30','11:00:00',6.32),('11288','2014-04-30','11:05:00',4.36),('11288','2014-04-30','11:10:00',5.65),('11288','2014-04-30','11:15:00',3.37),('11288','2014-04-30','11:20:00',3.56),('11288','2014-04-30','11:25:00',3.81),('11288','2014-04-30','11:30:00',3.94),('11288','2014-04-30','11:35:00',5.61),('11288','2014-04-30','11:40:00',4.27),('11288','2014-04-30','11:45:00',4.37),('11288','2014-04-30','11:50:00',7.27),('11288','2014-04-30','11:55:00',7.05),('11288','2014-04-30','12:00:00',4.16),('11288','2014-04-30','12:05:00',2.52),('11288','2014-04-30','12:10:00',2.65),('11288','2014-04-30','12:15:00',3.27),('11288','2014-04-30','12:20:00',2.93),('11288','2014-04-30','12:25:00',3.01),('11288','2014-04-30','12:30:00',5.15),('11288','2014-04-30','12:35:00',3.44),('11288','2014-04-30','12:40:00',2.48),('11288','2014-04-30','12:45:00',2.37),('11288','2014-04-30','12:50:00',4),('11288','2014-04-30','12:55:00',6.89),('11288','2014-04-30','13:00:00',6.94),('11288','2014-04-30','13:05:00',3.73),('11288','2014-04-30','13:10:00',5.37),('11288','2014-04-30','13:15:00',4.2),('11288','2014-04-30','13:20:00',4.17),('11288','2014-04-30','13:25:00',7.37),('11288','2014-04-30','13:30:00',3.64),('11288','2014-04-30','13:35:00',4.4),('11288','2014-04-30','13:40:00',5.85),('11288','2014-04-30','13:45:00',5.6),('11288','2014-04-30','13:50:00',4.54),('11288','2014-04-30','13:55:00',6.31),('11288','2014-04-30','14:00:00',3.5),('11288','2014-04-30','14:05:00',3.17),('11288','2014-04-30','14:10:00',2.85),('11288','2014-04-30','14:15:00',3.47),('11288','2014-04-30','14:20:00',7.14),('11288','2014-04-30','14:25:00',7.24),('11288','2014-04-30','14:30:00',8.59),('11288','2014-04-30','14:35:00',5.55),('11288','2014-04-30','14:40:00',3.38),('11288','2014-04-30','14:45:00',2.57),('11288','2014-04-30','14:50:00',3.02),('11288','2014-04-30','14:55:00',3.21),('11288','2014-04-30','15:00:00',2.76),('11288','2014-04-30','15:05:00',2.72),('11288','2014-04-30','15:10:00',2.79),('11288','2014-04-30','15:15:00',2.45),('11288','2014-04-30','15:20:00',2.19),('11288','2014-04-30','15:25:00',2.39),('11288','2014-04-30','15:30:00',3.11),('11288','2014-04-30','15:35:00',5.68),('11288','2014-04-30','15:40:00',7.41),('11288','2014-04-30','15:45:00',5.94),('11288','2014-04-30','15:50:00',6.27),('11288','2014-04-30','15:55:00',3.83),('11288','2014-04-30','16:00:00',3.03),('11288','2014-04-30','16:05:00',3.22),('11288','2014-04-30','16:10:00',4.12),('11288','2014-04-30','16:15:00',6.11),('11288','2014-04-30','16:20:00',2.67),('11288','2014-04-30','16:25:00',3.87),('11288','2014-04-30','16:30:00',4.01),('11288','2014-04-30','16:35:00',3.15),('11288','2014-04-30','16:40:00',3.97),('11288','2014-04-30','16:45:00',2.41),('11288','2014-04-30','16:50:00',3.3),('11288','2014-04-30','16:55:00',3.38),('11288','2014-04-30','17:00:00',3.86),('11288','2014-04-30','17:05:00',2.5),('11288','2014-04-30','17:10:00',2.15),('11288','2014-04-30','17:15:00',1.86),('11288','2014-04-30','17:20:00',1.6),('11288','2014-04-30','17:25:00',1.25),('11288','2014-04-30','17:30:00',1.56),('11288','2014-04-30','17:35:00',2.07),('11288','2014-04-30','17:40:00',1.86),('11288','2014-04-30','17:45:00',1.28),('11288','2014-04-30','17:50:00',1.68),('11288','2014-04-30','17:55:00',1.33),('11288','2014-04-30','18:00:00',1.02),('11288','2014-04-30','18:45:00',1.05),('11288','2014-03-07','09:35:00',1.27),('11288','2014-03-07','09:40:00',1.18),('11288','2014-03-07','09:55:00',1.24),('11288','2014-03-07','10:00:00',1.25),('11288','2014-03-07','10:05:00',1.12),('11288','2014-03-07','10:10:00',1.21),('11288','2014-03-07','10:15:00',1.13),('11288','2014-03-07','10:20:00',1.31),('11288','2014-03-07','10:25:00',1.13),('11288','2014-03-07','10:30:00',1.26),('11288','2014-03-07','10:35:00',1.48),('11288','2014-03-07','10:40:00',1.37),('11288','2014-03-07','10:45:00',1.27),('11288','2014-03-07','10:50:00',1.33),('11288','2014-03-07','10:55:00',1.45),('11288','2014-03-07','11:00:00',1.72),('11288','2014-03-07','11:05:00',1.5),('11288','2014-03-07','11:10:00',1.22),('11288','2014-03-07','11:15:00',1.34),('11288','2014-03-07','11:20:00',1.79),('11288','2014-03-07','11:25:00',1.77),('11288','2014-03-07','11:30:00',2.03),('11288','2014-03-07','11:35:00',1.89),('11288','2014-03-07','11:40:00',1.65),('11288','2014-03-07','11:45:00',3.12),('11288','2014-03-07','11:50:00',5.81),('11288','2014-03-07','11:55:00',6.36),('11288','2014-03-07','12:00:00',7.42),('11288','2014-03-07','12:05:00',6.66),('11288','2014-03-07','12:10:00',6.79),('11288','2014-03-07','12:15:00',6.51),('11288','2014-03-07','12:20:00',6.52),('11288','2014-03-07','12:25:00',6.48),('11288','2014-03-07','12:30:00',2.66),('11288','2014-03-07','12:35:00',4.46),('11288','2014-03-07','12:40:00',3.71),('11288','2014-03-07','12:45:00',1.42),('11288','2014-03-07','12:50:00',2.6),('11288','2014-03-07','12:55:00',2.46),('11288','2014-03-07','13:00:00',6.1),('11288','2014-03-07','13:05:00',6.11),('11288','2014-03-07','13:10:00',3.38),('11288','2014-03-07','13:15:00',2.63),('11288','2014-03-07','13:20:00',4.22),('11288','2014-03-07','13:25:00',5.66),('11288','2014-03-07','13:30:00',5.68),('11288','2014-03-07','13:35:00',4.54),('11288','2014-03-07','13:40:00',4.51),('11288','2014-03-07','13:45:00',4.03),('11288','2014-03-07','13:50:00',2.72),('11288','2014-03-07','13:55:00',2.15),('11288','2014-03-07','14:00:00',2.06),('11288','2014-03-07','14:05:00',1.98),('11288','2014-03-07','14:10:00',2),('11288','2014-03-07','14:15:00',1.98),('11288','2014-03-07','14:20:00',1.95),('11288','2014-03-07','14:25:00',1.9),('11288','2014-03-07','14:30:00',2),('11288','2014-03-07','14:35:00',2.1),('11288','2014-03-07','14:40:00',2.24),('11288','2014-03-07','14:45:00',2.28),('11288','2014-03-07','14:50:00',2.83),('11288','2014-03-07','14:55:00',3.92),('11288','2014-03-07','15:00:00',4.67),('11288','2014-03-07','15:05:00',5.01),('11288','2014-03-07','15:10:00',4.99),('11288','2014-03-07','15:15:00',5.02),('11288','2014-03-07','15:20:00',4.95),('11288','2014-03-07','15:25:00',4.66),('11288','2014-03-07','15:30:00',4.33),('11288','2014-03-07','15:35:00',4.08),('11288','2014-03-07','15:40:00',3.13),('11288','2014-03-07','15:45:00',2.74),('11288','2014-03-07','15:50:00',2.48),('11288','2014-03-07','15:55:00',2.28),('11288','2014-03-07','16:00:00',2.62),('11288','2014-03-07','16:05:00',2.4),('11288','2014-03-07','16:10:00',2.3),('11288','2014-03-07','16:15:00',2.43),('11288','2014-03-07','16:20:00',2.09),('11288','2014-03-07','16:25:00',1.92),('11288','2014-03-07','16:30:00',1.85),('11288','2014-03-07','16:35:00',1.78),('11288','2014-03-07','16:40:00',1.78),('11288','2014-03-07','16:45:00',1.75),('11288','2014-03-07','16:50:00',1.63),('11288','2014-03-07','16:55:00',1.53),('11288','2014-03-07','17:00:00',1.46),('11288','2014-03-07','17:05:00',1.34),('11288','2014-03-07','17:10:00',1.17),('11288','2014-03-07','17:15:00',1),('11288','2014-03-06','08:00:00',1.48),('11288','2014-03-06','08:05:00',1.77),('11288','2014-03-06','08:10:00',1.88),('11288','2014-03-06','08:15:00',2.17),('11288','2014-03-06','08:20:00',2.45),('11288','2014-03-06','08:25:00',2),('11288','2014-03-06','08:30:00',1.38),('11288','2014-03-06','08:35:00',1.1),('11288','2014-03-06','08:40:00',1.01),('11288','2014-03-06','08:45:00',1.51),('11288','2014-03-06','08:50:00',1.4),('11288','2014-03-06','08:55:00',1.49),('11288','2014-03-06','09:00:00',1.62),('11288','2014-03-06','09:05:00',1.58),('11288','2014-03-06','09:10:00',1.53),('11288','2014-03-06','09:15:00',1.83),('11288','2014-03-06','09:20:00',2.01),('11288','2014-03-06','09:25:00',1.69),('11288','2014-03-06','09:30:00',1.64),('11288','2014-03-06','09:35:00',1.98),('11288','2014-03-06','09:40:00',2.23),('11288','2014-03-06','09:45:00',2.47),('11288','2014-03-06','09:50:00',2.8),('11288','2014-03-06','09:55:00',3.47),('11288','2014-03-06','10:00:00',3.76),('11288','2014-03-06','10:05:00',3.91),('11288','2014-03-06','10:10:00',4.05),('11288','2014-03-06','10:15:00',4.77),('11288','2014-03-06','10:20:00',4.98),('11288','2014-03-06','10:25:00',2.76),('11288','2014-03-06','10:30:00',1.67),('11288','2014-03-06','10:35:00',1.87),('11288','2014-03-06','10:40:00',3.88),('11288','2014-03-06','10:45:00',1.87),('11288','2014-03-06','10:50:00',2.62),('11288','2014-03-06','10:55:00',2.24),('11288','2014-03-06','11:00:00',4.6),('11288','2014-03-06','11:05:00',5.29),('11288','2014-03-06','11:10:00',5.18),('11288','2014-03-06','11:15:00',3.56),('11288','2014-03-06','11:20:00',4.35),('11288','2014-03-06','11:25:00',4.16),('11288','2014-03-06','11:30:00',3),('11288','2014-03-06','11:35:00',2.39),('11288','2014-03-06','11:40:00',3.23),('11288','2014-03-06','11:45:00',4.89),('11288','2014-03-06','11:50:00',5.99),('11288','2014-03-06','11:55:00',6.11),('11288','2014-03-06','12:00:00',2.8),('11288','2014-03-06','12:05:00',3.47),('11288','2014-03-06','12:10:00',6.73),('11288','2014-03-06','12:15:00',4.51),('11288','2014-03-06','12:20:00',2.29),('11288','2014-03-06','12:25:00',3.03),('11288','2014-03-06','12:30:00',5.9),('11288','2014-03-06','12:35:00',3.49),('11288','2014-03-06','12:40:00',2.54),('11288','2014-03-06','12:45:00',1.84),('11288','2014-03-06','12:50:00',1.85),('11288','2014-03-06','12:55:00',2.3),('11288','2014-03-06','13:00:00',3.46),('11288','2014-03-06','13:05:00',2.5),('11288','2014-03-06','13:10:00',2.25),('11288','2014-03-06','13:15:00',2.33),('11288','2014-03-06','13:20:00',1.99),('11288','2014-03-06','13:25:00',1.78),('11288','2014-03-06','13:30:00',1.99),('11288','2014-03-06','13:35:00',1.9),('11288','2014-03-06','13:40:00',2.04),('11288','2014-03-06','13:45:00',1.87),('11288','2014-03-06','13:50:00',1.72),('11288','2014-03-06','13:55:00',1.63),('11288','2014-03-06','14:00:00',1.66),('11288','2014-03-06','14:05:00',1.9),('11288','2014-03-06','14:10:00',1.97),('11288','2014-03-06','14:15:00',1.85),('11288','2014-03-06','14:20:00',2.18),('11288','2014-03-06','14:25:00',2.09),('11288','2014-03-06','14:30:00',1.93),('11288','2014-03-06','14:35:00',3.03),('11288','2014-03-06','14:40:00',2.3),('11288','2014-03-06','14:45:00',1.45),('11288','2014-03-06','14:50:00',1.58),('11288','2014-03-06','14:55:00',1.6),('11288','2014-03-06','15:00:00',1.83),('11288','2014-03-06','15:05:00',2.34),('11288','2014-03-06','15:10:00',2.11),('11288','2014-03-06','15:15:00',1.56),('11288','2014-03-06','15:20:00',1.19),('11288','2014-03-06','15:25:00',1.12),('11288','2014-03-06','15:30:00',1.11),('11288','2014-03-06','15:35:00',1.18),('11288','2014-03-06','15:40:00',1.03),('11288','2014-03-06','16:00:00',1.11),('11288','2014-03-06','16:05:00',1.13),('11288','2014-03-06','16:10:00',1.11),('11288','2014-03-06','16:15:00',1.08),('11288','2014-03-06','16:20:00',1.15),('11288','2014-03-06','16:25:00',1.1),('11288','2014-03-06','16:30:00',1.03),('11288','2014-03-06','16:50:00',1.35),('11288','2014-03-06','16:55:00',1.17),('11288','2014-03-05','07:35:00',1.07),('11288','2014-03-05','07:40:00',1.12),('11288','2014-03-05','07:45:00',1.29),('11288','2014-03-05','07:50:00',1.43),('11288','2014-03-05','07:55:00',1.54),('11288','2014-03-05','08:00:00',1.43),('11288','2014-03-05','08:05:00',1.48),('11288','2014-03-05','08:10:00',1.52),('11288','2014-03-05','08:15:00',1.85),('11288','2014-03-05','08:20:00',1.46),('11288','2014-03-05','08:30:00',1.01),('11288','2014-03-05','08:35:00',3.18),('11288','2014-03-05','08:40:00',2.32),('11288','2014-03-05','08:45:00',2.26),('11288','2014-03-05','08:50:00',2.2),('11288','2014-03-05','08:55:00',1.07),('11288','2014-03-05','09:00:00',2.53),('11288','2014-03-05','09:05:00',3.47),('11288','2014-03-05','09:10:00',1.28),('11288','2014-03-05','09:15:00',3.15),('11288','2014-03-05','09:20:00',3.78),('11288','2014-03-05','09:25:00',3.81),('11288','2014-03-05','09:30:00',3.91),('11288','2014-03-05','09:35:00',4.09),('11288','2014-03-05','09:40:00',4.15),('11288','2014-03-05','09:45:00',4.27),('11288','2014-03-05','09:50:00',4.4),('11288','2014-03-05','09:55:00',4.51),('11288','2014-03-05','10:00:00',4.6),('11288','2014-03-05','10:05:00',4.72),('11288','2014-03-05','10:10:00',4.21),('11288','2014-03-05','10:15:00',4.95),('11288','2014-03-05','10:20:00',4.8),('11288','2014-03-05','10:25:00',5.06),('11288','2014-03-05','10:30:00',5.09),('11288','2014-03-05','10:35:00',5.11),('11288','2014-03-05','10:40:00',5.2),('11288','2014-03-05','10:45:00',5.21),('11288','2014-03-05','10:50:00',5.26),('11288','2014-03-05','10:55:00',5.36),('11288','2014-03-05','11:00:00',5.43),('11288','2014-03-05','11:05:00',5.52),('11288','2014-03-05','11:10:00',5.58),('11288','2014-03-05','11:15:00',5.7),('11288','2014-03-05','11:20:00',5.76),('11288','2014-03-05','11:25:00',5.89),('11288','2014-03-05','11:30:00',6),('11288','2014-03-05','11:35:00',6.19),('11288','2014-03-05','11:40:00',6.11),('11288','2014-03-05','11:45:00',6.16),('11288','2014-03-05','11:50:00',6.03),('11288','2014-03-05','11:55:00',5.24),('11288','2014-03-05','12:00:00',5.41),('11288','2014-03-05','12:05:00',4.86),('11288','2014-03-05','12:10:00',3.76),('11288','2014-03-05','12:15:00',2.12),('11288','2014-03-05','12:20:00',1.42),('11288','2014-03-05','12:25:00',1.47),('11288','2014-03-05','12:30:00',1.79),('11288','2014-03-05','12:35:00',3.08),('11288','2014-03-05','12:40:00',3.2),('11288','2014-03-05','12:45:00',1.92),('11288','2014-03-05','12:50:00',2.49),('11288','2014-03-05','12:55:00',2.36),('11288','2014-03-05','13:00:00',2.86),('11288','2014-03-05','13:05:00',3.76),('11288','2014-03-05','13:10:00',5.63),('11288','2014-03-05','13:15:00',4.38),('11288','2014-03-05','13:20:00',3.81),('11288','2014-03-05','13:25:00',2.18),('11288','2014-03-05','13:30:00',2.22),('11288','2014-03-05','13:35:00',2.19),('11288','2014-03-05','13:40:00',2.7),('11288','2014-03-05','13:45:00',2.63),('11288','2014-03-05','13:50:00',2.24),('11288','2014-03-05','13:55:00',1.99),('11288','2014-03-05','14:00:00',1.86),('11288','2014-03-05','14:05:00',1.99),('11288','2014-03-05','14:10:00',1.86),('11288','2014-03-05','14:15:00',2.06),('11288','2014-03-05','14:20:00',2.17),('11288','2014-03-05','14:25:00',2.77),('11288','2014-03-05','14:30:00',2.49),('11288','2014-03-05','14:35:00',2.11),('11288','2014-03-05','14:40:00',3.23),('11288','2014-03-05','14:45:00',4.45),('11288','2014-03-05','14:50:00',5.27),('11288','2014-03-05','14:55:00',3.79),('11288','2014-03-05','15:00:00',1.74),('11288','2014-03-05','15:05:00',1.47),('11288','2014-03-05','15:10:00',1.46),('11288','2014-03-05','15:15:00',1.43),('11288','2014-03-05','15:20:00',1.31),('11288','2014-03-05','15:25:00',1.35),('11288','2014-03-05','15:30:00',1.68),('11288','2014-03-05','15:35:00',2.06),('11288','2014-03-05','15:40:00',2.06),('11288','2014-03-05','15:45:00',2.74),('11288','2014-03-05','15:50:00',2.22),('11288','2014-03-05','15:55:00',3.14),('11288','2014-03-05','16:00:00',3.92),('11288','2014-03-05','16:05:00',3.54),('11288','2014-03-05','16:10:00',3.07),('11288','2014-03-05','16:15:00',2.32),('11288','2014-03-05','16:20:00',1.08),('11288','2014-03-04','08:50:00',1.07),('11288','2014-03-04','09:00:00',1.2),('11288','2014-03-04','09:05:00',1.92),('11288','2014-03-04','09:10:00',1.97),('11288','2014-03-04','09:15:00',3.05),('11288','2014-03-04','09:20:00',2.99),('11288','2014-03-04','09:25:00',1.59),('11288','2014-03-04','09:30:00',1.75),('11288','2014-03-04','09:35:00',1.76),('11288','2014-03-04','09:40:00',2.17),('11288','2014-03-04','09:45:00',1.73),('11288','2014-03-04','09:50:00',1.41),('11288','2014-03-04','09:55:00',3.23),('11288','2014-03-04','10:00:00',2.35),('11288','2014-03-04','10:05:00',1.71),('11288','2014-03-04','10:10:00',1.14),('11288','2014-03-04','10:20:00',1.77),('11288','2014-03-04','10:25:00',5.31),('11288','2014-03-04','10:30:00',3),('11288','2014-03-04','10:35:00',5.02),('11288','2014-03-04','10:40:00',6.34),('11288','2014-03-04','10:45:00',5.74),('11288','2014-03-04','10:50:00',1.61),('11288','2014-03-04','10:55:00',5.65),('11288','2014-03-04','11:00:00',2.76),('11288','2014-03-04','11:05:00',3.34),('11288','2014-03-04','11:10:00',6.67),('11288','2014-03-04','11:15:00',7.3),('11288','2014-03-04','11:20:00',4.09),('11288','2014-03-04','11:25:00',1.78),('11288','2014-03-04','11:30:00',1.85),('11288','2014-03-04','11:35:00',1.33),('11288','2014-03-04','11:40:00',1.74),('11288','2014-03-04','11:45:00',3.39),('11288','2014-03-04','11:50:00',7.8),('11288','2014-03-04','11:55:00',6.55),('11288','2014-03-04','12:00:00',6.35),('11288','2014-03-04','12:05:00',6.19),('11288','2014-03-04','12:10:00',6.14),('11288','2014-03-04','12:15:00',6.06),('11288','2014-03-04','12:20:00',6.05),('11288','2014-03-04','12:25:00',6.09),('11288','2014-03-04','12:30:00',5.92),('11288','2014-03-04','12:35:00',5.89),('11288','2014-03-04','12:40:00',5.94),('11288','2014-03-04','12:45:00',3.82),('11288','2014-03-04','12:50:00',4.92),('11288','2014-03-04','12:55:00',4.32),('11288','2014-03-04','13:00:00',5.75),('11288','2014-03-04','13:05:00',5.13),('11288','2014-03-04','13:10:00',6.43),('11288','2014-03-04','13:15:00',3.43),('11288','2014-03-04','13:20:00',2.95),('11288','2014-03-04','13:25:00',1.7),('11288','2014-03-04','13:30:00',1.82),('11288','2014-03-04','13:35:00',1.33),('11288','2014-03-04','13:40:00',1.15),('11288','2014-03-04','13:45:00',2.06),('11288','2014-03-04','13:50:00',2.21),('11288','2014-03-04','13:55:00',1.92),('11288','2014-03-04','14:00:00',1.22),('11288','2014-03-04','14:05:00',2.94),('11288','2014-03-04','14:10:00',4.13),('11288','2014-03-04','14:15:00',5.52),('11288','2014-03-04','14:20:00',3.17),('11288','2014-03-04','14:25:00',5.51),('11288','2014-03-04','14:30:00',4.95),('11288','2014-03-04','14:35:00',4.74),('11288','2014-03-04','14:40:00',4.53),('11288','2014-03-04','14:45:00',4.39),('11288','2014-03-04','14:50:00',4.58),('11288','2014-03-04','14:55:00',2.83),('11288','2014-03-04','15:00:00',4.38),('11288','2014-03-04','15:05:00',4.15),('11288','2014-03-04','15:10:00',3.84),('11288','2014-03-04','15:15:00',3.23),('11288','2014-03-04','15:20:00',2.13),('11288','2014-03-04','15:25:00',2.72),('11288','2014-03-04','15:30:00',1.75),('11288','2014-03-04','15:35:00',3.57),('11288','2014-03-04','15:40:00',3.06),('11288','2014-03-04','15:45:00',2.44),('11288','2014-03-04','15:50:00',2.18),('11288','2014-03-04','16:00:00',1.12),('11288','2014-03-04','16:05:00',1.65),('11288','2014-03-04','16:10:00',1.58),('11288','2014-03-04','16:15:00',1.38),('11288','2014-03-04','16:20:00',1.7),('11288','2014-03-04','16:25:00',1.84),('11288','2014-03-04','16:30:00',1.18),('11288','2014-03-04','16:35:00',1.13),('11288','2014-03-04','16:40:00',1.25),('11288','2014-03-04','16:45:00',1.35),('11288','2014-03-04','16:50:00',1.21),('11288','2014-03-03','08:10:00',1.49),('11288','2014-03-03','08:15:00',1.65),('11288','2014-03-03','08:20:00',1.8),('11288','2014-03-03','08:25:00',1.96),('11288','2014-03-03','08:30:00',2.1),('11288','2014-03-03','08:35:00',2.22),('11288','2014-03-03','08:40:00',2.43),('11288','2014-03-03','08:45:00',2.56),('11288','2014-03-03','08:50:00',2.54),('11288','2014-03-03','08:55:00',2.9),('11288','2014-03-03','09:00:00',2.98),('11288','2014-03-03','09:05:00',2.99),('11288','2014-03-03','09:10:00',2.79),('11288','2014-03-03','09:15:00',3.04),('11288','2014-03-03','09:20:00',3.47),('11288','2014-03-03','09:25:00',3.63),('11288','2014-03-03','09:30:00',3.66),('11288','2014-03-03','09:35:00',3.56),('11288','2014-03-03','09:40:00',3.06),('11288','2014-03-03','09:45:00',3.48),('11288','2014-03-03','09:50:00',3.64),('11288','2014-03-03','09:55:00',3.92),('11288','2014-03-03','10:00:00',4.21),('11288','2014-03-03','10:05:00',4.51),('11288','2014-03-03','10:10:00',4.62),('11288','2014-03-03','10:15:00',4.72),('11288','2014-03-03','10:20:00',4.76),('11288','2014-03-03','10:25:00',4.77),('11288','2014-03-03','10:30:00',4.87),('11288','2014-03-03','10:35:00',4.94),('11288','2014-03-03','10:40:00',5.01),('11288','2014-03-03','10:45:00',5.02),('11288','2014-03-03','10:50:00',5.01),('11288','2014-03-03','10:55:00',5.1),('11288','2014-03-03','11:00:00',5.24),('11288','2014-03-03','11:05:00',5.26),('11288','2014-03-03','11:10:00',5.3),('11288','2014-03-03','11:15:00',5.35),('11288','2014-03-03','11:20:00',5.4),('11288','2014-03-03','11:25:00',5.49),('11288','2014-03-03','11:30:00',5.67),('11288','2014-03-03','11:35:00',2.98),('11288','2014-03-03','11:40:00',5.89),('11288','2014-03-03','11:45:00',5.82),('11288','2014-03-03','11:50:00',5.82),('11288','2014-03-03','11:55:00',5.8),('11288','2014-03-03','12:00:00',5.83),('11288','2014-03-03','12:05:00',5.89),('11288','2014-03-03','12:10:00',5.86),('11288','2014-03-03','12:15:00',5.88),('11288','2014-03-03','12:20:00',5.86),('11288','2014-03-03','12:25:00',5.83),('11288','2014-03-03','12:30:00',5.83),('11288','2014-03-03','12:35:00',5.8),('11288','2014-03-03','12:40:00',5.83),('11288','2014-03-03','12:45:00',5.84),('11288','2014-03-03','12:50:00',5.75),('11288','2014-03-03','12:55:00',5.69),('11288','2014-03-03','13:00:00',5.66),('11288','2014-03-03','13:05:00',5.64),('11288','2014-03-03','13:10:00',5.62),('11288','2014-03-03','13:15:00',5.63),('11288','2014-03-03','13:20:00',5.62),('11288','2014-03-03','13:25:00',5.48),('11288','2014-03-03','13:30:00',5.49),('11288','2014-03-03','13:35:00',5.45),('11288','2014-03-03','13:40:00',5.42),('11288','2014-03-03','13:45:00',5.4),('11288','2014-03-03','13:50:00',5.3),('11288','2014-03-03','13:55:00',5.24),('11288','2014-03-03','14:00:00',5.18),('11288','2014-03-03','14:05:00',5.16),('11288','2014-03-03','14:10:00',5.13),('11288','2014-03-03','14:15:00',5.05),('11288','2014-03-03','14:20:00',4.61),('11288','2014-03-03','14:25:00',4.72),('11288','2014-03-03','14:30:00',4.75),('11288','2014-03-03','14:35:00',4.66),('11288','2014-03-03','14:40:00',4.51),('11288','2014-03-03','14:45:00',4.4),('11288','2014-03-03','14:50:00',4.29),('11288','2014-03-03','14:55:00',4.15),('11288','2014-03-03','15:00:00',4.01),('11288','2014-03-03','15:05:00',3.94),('11288','2014-03-03','15:10:00',3.72),('11288','2014-03-03','15:15:00',3.67),('11288','2014-03-03','15:20:00',3.56),('11288','2014-03-03','15:25:00',3.45),('11288','2014-03-03','15:30:00',3.25),('11288','2014-03-03','15:35:00',2.87),('11288','2014-03-03','15:40:00',2.96),('11288','2014-03-03','15:45:00',2.83),('11288','2014-03-03','15:50:00',2.7),('11288','2014-03-03','15:55:00',2.48),('11288','2014-03-03','16:00:00',2.4),('11288','2014-03-03','16:05:00',2.24),('11288','2014-03-03','16:10:00',2.02),('11288','2014-03-03','16:15:00',1.98),('11288','2014-03-03','16:20:00',1.75),('11288','2014-03-03','16:25:00',1.56),('11288','2014-03-03','16:30:00',1.52),('11288','2014-03-03','16:35:00',1.4),('11288','2014-03-03','16:40:00',1.24),('11288','2014-03-03','16:45:00',1.12),('11288','2014-03-02','08:00:00',1.12),('11288','2014-03-02','08:05:00',1.31),('11288','2014-03-02','08:10:00',2.22),('11288','2014-03-02','08:15:00',2.15),('11288','2014-03-02','08:20:00',2.06),('11288','2014-03-02','08:25:00',1.93),('11288','2014-03-02','08:30:00',2.05),('11288','2014-03-02','08:35:00',1.99),('11288','2014-03-02','08:40:00',2.18),('11288','2014-03-02','08:45:00',2.47),('11288','2014-03-02','08:50:00',2.61),('11288','2014-03-02','08:55:00',2.78),('11288','2014-03-02','09:00:00',3.02),('11288','2014-03-02','09:05:00',3.21),('11288','2014-03-02','09:10:00',3.45),('11288','2014-03-02','09:15:00',3.54),('11288','2014-03-02','09:20:00',2.84),('11288','2014-03-02','09:25:00',3.93),('11288','2014-03-02','09:30:00',4.15),('11288','2014-03-02','09:35:00',4.12),('11288','2014-03-02','09:40:00',3.33),('11288','2014-03-02','09:45:00',1.23),('11288','2014-03-02','09:50:00',1.26),('11288','2014-03-02','09:55:00',2.19),('11288','2014-03-02','10:00:00',2.66),('11288','2014-03-02','10:05:00',2.76),('11288','2014-03-02','10:10:00',2.37),('11288','2014-03-02','10:15:00',2.24),('11288','2014-03-02','10:20:00',2.28),('11288','2014-03-02','10:25:00',2.58),('11288','2014-03-02','10:30:00',2.7),('11288','2014-03-02','10:35:00',4.06),('11288','2014-03-02','10:40:00',2.84),('11288','2014-03-02','10:45:00',1.69),('11288','2014-03-02','10:50:00',2.74),('11288','2014-03-02','10:55:00',2.3),('11288','2014-03-02','11:00:00',5.23),('11288','2014-03-02','11:05:00',3.85),('11288','2014-03-02','11:10:00',2.65),('11288','2014-03-02','11:15:00',2.28),('11288','2014-03-02','11:20:00',3.1),('11288','2014-03-02','11:25:00',3.28),('11288','2014-03-02','11:30:00',3.98),('11288','2014-03-02','11:35:00',4.63),('11288','2014-03-02','11:40:00',4.65),('11288','2014-03-02','11:45:00',7.46),('11288','2014-03-02','11:50:00',6.96),('11288','2014-03-02','11:55:00',6.11),('11288','2014-03-02','12:00:00',4.04),('11288','2014-03-02','12:05:00',3.16),('11288','2014-03-02','12:10:00',3.29),('11288','2014-03-02','12:15:00',4.09),('11288','2014-03-02','12:20:00',3.73),('11288','2014-03-02','12:25:00',3.75),('11288','2014-03-02','12:30:00',2.46),('11288','2014-03-02','12:35:00',2.03),('11288','2014-03-02','12:40:00',1.59),('11288','2014-03-02','12:45:00',1.65),('11288','2014-03-02','12:50:00',1.92),('11288','2014-03-02','12:55:00',2.3),('11288','2014-03-02','13:00:00',2.57),('11288','2014-03-02','13:05:00',2.68),('11288','2014-03-02','13:10:00',2.58),('11288','2014-03-02','13:15:00',2.29),('11288','2014-03-02','13:20:00',2.13),('11288','2014-03-02','13:25:00',2.04),('11288','2014-03-02','13:30:00',1.95),('11288','2014-03-02','13:35:00',1.78),('11288','2014-03-02','13:40:00',1.6),('11288','2014-03-02','13:45:00',1.61),('11288','2014-03-02','13:50:00',1.81),('11288','2014-03-02','13:55:00',1.94),('11288','2014-03-02','14:00:00',2.3),('11288','2014-03-02','14:05:00',2.48),('11288','2014-03-02','14:10:00',2.35),('11288','2014-03-02','14:15:00',2.24),('11288','2014-03-02','14:20:00',2.07),('11288','2014-03-02','14:25:00',2.07),('11288','2014-03-02','14:30:00',2.14),('11288','2014-03-02','14:35:00',2.15),('11288','2014-03-02','14:40:00',2.11),('11288','2014-03-02','14:45:00',2.18),('11288','2014-03-02','14:50:00',2.18),('11288','2014-03-02','14:55:00',2.15),('11288','2014-03-02','15:00:00',2.22),('11288','2014-03-02','15:05:00',2.33),('11288','2014-03-02','15:10:00',2.36),('11288','2014-03-02','15:15:00',2.32),('11288','2014-03-02','15:20:00',2.33),('11288','2014-03-02','15:25:00',2.26),('11288','2014-03-02','15:30:00',2.31),('11288','2014-03-02','15:35:00',2.25),('11288','2014-03-02','15:40:00',2.23),('11288','2014-03-02','15:45:00',1.91),('11288','2014-03-02','15:50:00',1.76),('11288','2014-03-02','15:55:00',1.59),('11288','2014-03-02','16:00:00',1.44),('11288','2014-03-02','16:05:00',1.3),('11288','2014-03-02','16:10:00',1.14),('11288','2014-03-02','16:15:00',1.01),('11288','2014-03-01','12:30:00',1.06),('11288','2014-03-01','12:40:00',1.1),('11288','2014-03-01','14:40:00',1.18),('11288','2014-03-01','14:45:00',1.35),('11288','2014-03-01','14:50:00',1.26),('11288','2014-03-01','14:55:00',1.13),('11288','2014-02-28','07:55:00',1.16),('11288','2014-02-28','08:00:00',1.57),('11288','2014-02-28','08:05:00',1.61),('11288','2014-02-28','08:10:00',1.23),('11288','2014-02-28','08:15:00',1.39),('11288','2014-02-28','08:20:00',2.13),('11288','2014-02-28','08:25:00',1.57),('11288','2014-02-28','08:30:00',1.21),('11288','2014-02-28','08:35:00',2.46),('11288','2014-02-28','09:10:00',1.55),('11288','2014-02-28','09:15:00',1.97),('11288','2014-02-28','09:20:00',1.94),('11288','2014-02-28','09:25:00',2.37),('11288','2014-02-28','09:30:00',2.73),('11288','2014-02-28','09:35:00',1.01),('11288','2014-02-28','09:40:00',3.16),('11288','2014-02-28','09:45:00',4.24),('11288','2014-02-28','09:50:00',5.18),('11288','2014-02-28','09:55:00',3.36),('11288','2014-02-28','10:00:00',1.99),('11288','2014-02-28','10:05:00',2.09),('11288','2014-02-28','10:10:00',2.47),('11288','2014-02-28','10:15:00',1.99),('11288','2014-02-28','10:20:00',2.9),('11288','2014-02-28','10:25:00',3.82),('11288','2014-02-28','10:30:00',5.33),('11288','2014-02-28','10:35:00',4.19),('11288','2014-02-28','10:40:00',2.16),('11288','2014-02-28','10:45:00',1.39),('11288','2014-02-28','11:00:00',1.11),('11288','2014-02-28','11:05:00',1.55),('11288','2014-02-28','11:10:00',1.63),('11288','2014-02-28','11:15:00',1.91),('11288','2014-02-28','11:20:00',2.44),('11288','2014-02-28','11:25:00',2.34),('11288','2014-02-28','11:30:00',1.9),('11288','2014-02-28','11:35:00',1.39),('11288','2014-02-28','11:40:00',1.33),('11288','2014-02-28','11:45:00',1.73),('11288','2014-02-28','11:50:00',1.96),('11288','2014-02-28','11:55:00',2.11),('11288','2014-02-28','12:00:00',2.68),('11288','2014-02-28','12:05:00',3.79),('11288','2014-02-28','12:10:00',3.3),('11288','2014-02-28','12:15:00',1.97),('11288','2014-02-28','12:20:00',1.85),('11288','2014-02-28','12:25:00',3.5),('11288','2014-02-28','12:30:00',3.26),('11288','2014-02-28','12:35:00',5.89),('11288','2014-02-28','12:40:00',3.69),('11288','2014-02-28','12:45:00',2.26),('11288','2014-02-28','12:50:00',4.13),('11288','2014-02-28','12:55:00',2.78),('11288','2014-02-28','13:00:00',4.22),('11288','2014-02-28','13:05:00',3.09),('11288','2014-02-28','13:10:00',2.78),('11288','2014-02-28','13:15:00',1.85),('11288','2014-02-28','13:45:00',2.14),('11288','2014-02-28','13:50:00',7.13),('11288','2014-02-28','13:55:00',3.89),('11288','2014-02-28','14:00:00',2.44),('11288','2014-02-28','14:05:00',1.57),('11288','2014-02-28','14:10:00',1.45),('11288','2014-02-28','14:15:00',2.16),('11288','2014-02-28','14:20:00',2.63),('11288','2014-02-28','14:25:00',4.15),('11288','2014-02-28','14:30:00',3.28),('11288','2014-02-28','14:35:00',2.55),('11288','2014-02-28','14:40:00',2.38),('11288','2014-02-28','14:45:00',2.26),('11288','2014-02-28','14:50:00',2.46),('11288','2014-02-28','14:55:00',2.66),('11288','2014-02-28','15:00:00',3.63),('11288','2014-02-28','15:05:00',2.28),('11288','2014-02-28','15:10:00',1.13),('11288','2014-02-28','15:20:00',1.33),('11288','2014-02-28','15:25:00',3.46),('11288','2014-02-28','15:30:00',3.36),('11288','2014-02-28','15:35:00',2.98),('11288','2014-02-28','15:40:00',2.91),('11288','2014-02-28','15:45:00',1.31),('11288','2014-02-28','16:10:00',1.77),('11288','2014-02-28','16:15:00',2.83),('11288','2014-02-28','16:20:00',2.25),('11288','2014-02-28','16:25:00',1.18),('11288','2014-02-28','16:35:00',1.34),('11288','2014-02-28','16:40:00',1.73),('11288','2014-02-28','16:45:00',1.99),('11288','2014-02-28','16:50:00',1.74),('11288','2014-02-27','10:25:00',1.09),('11288','2014-02-27','10:30:00',1.52),('11288','2014-02-27','10:35:00',1.77),('11288','2014-02-27','10:40:00',2.08),('11288','2014-02-27','10:45:00',2.25),('11288','2014-02-27','10:50:00',2.34),('11288','2014-02-27','10:55:00',2.42),('11288','2014-02-27','11:00:00',2.76),('11288','2014-02-27','11:05:00',3.02),('11288','2014-02-27','11:10:00',2.85),('11288','2014-02-27','11:15:00',2.8),('11288','2014-02-27','11:20:00',2.54),('11288','2014-02-27','11:25:00',2.91),('11288','2014-02-27','11:30:00',3.39),('11288','2014-02-27','11:35:00',3.08),('11288','2014-02-27','11:40:00',2.64),('11288','2014-02-27','11:45:00',2.28),('11288','2014-02-27','11:50:00',2.25),('11288','2014-02-27','11:55:00',2.34),('11288','2014-02-27','12:00:00',2.26),('11288','2014-02-27','12:05:00',2.21),('11288','2014-02-27','12:10:00',2.04),('11288','2014-02-27','12:15:00',2.22),('11288','2014-02-27','12:20:00',2.35),('11288','2014-02-27','12:25:00',2.37),('11288','2014-02-27','12:30:00',2.2),('11288','2014-02-27','12:35:00',2.14),('11288','2014-02-27','12:40:00',2.1),('11288','2014-02-27','12:45:00',2.09),('11288','2014-02-27','12:50:00',2.06),('11288','2014-02-27','12:55:00',2.11),('11288','2014-02-27','13:00:00',2.22),('11288','2014-02-27','13:05:00',2.05),('11288','2014-02-27','13:10:00',2.15),('11288','2014-02-27','13:15:00',2.32),('11288','2014-02-27','13:20:00',2.32),('11288','2014-02-27','13:25:00',2.43),('11288','2014-02-27','13:30:00',2.76),('11288','2014-02-27','13:35:00',2.95),('11288','2014-02-27','13:40:00',3),('11288','2014-02-27','13:45:00',2.98),('11288','2014-02-27','13:50:00',3.07),('11288','2014-02-27','13:55:00',3.37),('11288','2014-02-27','14:00:00',3.36),('11288','2014-02-27','14:05:00',2.97),('11288','2014-02-27','14:10:00',2.67),('11288','2014-02-27','14:15:00',2.52),('11288','2014-02-27','14:20:00',2.54),('11288','2014-02-27','14:25:00',2.53),('11288','2014-02-27','14:30:00',2.58),('11288','2014-02-27','14:35:00',2.45),('11288','2014-02-27','14:40:00',2.21),('11288','2014-02-27','14:45:00',2.31),('11288','2014-02-27','14:50:00',2.19),('11288','2014-02-27','14:55:00',2.03),('11288','2014-02-27','15:00:00',2.12),('11288','2014-02-27','15:05:00',2.07),('11288','2014-02-27','15:10:00',2.16),('11288','2014-02-27','15:15:00',2.45),('11288','2014-02-27','15:20:00',2.57),('11288','2014-02-27','15:25:00',2.27),('11288','2014-02-27','15:30:00',2.21),('11288','2014-02-27','15:35:00',2.21),('11288','2014-02-27','15:40:00',1.77),('11288','2014-02-27','15:45:00',1.4),('11288','2014-02-27','15:50:00',1.14),('11288','2014-02-27','15:55:00',1.02),('11288','2014-02-27','16:00:00',1.08),('11288','2014-02-27','16:05:00',1.04),('11288','2014-02-27','16:30:00',1.02),('11288','2014-02-27','16:35:00',1.3),('11288','2014-02-27','16:40:00',1.74),('11288','2014-02-27','16:45:00',1.84),('11288','2014-02-27','16:50:00',1.89),('11288','2014-02-27','16:55:00',1.66),('11288','2014-02-27','17:00:00',1.35),('11288','2014-02-27','17:05:00',1.09),('11288','2014-02-26','08:00:00',1.05),('11288','2014-02-26','08:05:00',1.14),('11288','2014-02-26','08:10:00',1.22),('11288','2014-02-26','08:15:00',1.48),('11288','2014-02-26','08:20:00',1.57),('11288','2014-02-26','08:25:00',1.68),('11288','2014-02-26','08:30:00',1.78),('11288','2014-02-26','08:35:00',1.81),('11288','2014-02-26','08:40:00',2.08),('11288','2014-02-26','08:45:00',2.64),('11288','2014-02-26','08:50:00',2.57),('11288','2014-02-26','08:55:00',2.56),('11288','2014-02-26','09:00:00',2.66),('11288','2014-02-26','09:05:00',2.66),('11288','2014-02-26','09:10:00',2.81),('11288','2014-02-26','09:15:00',2.94),('11288','2014-02-26','09:20:00',3.16),('11288','2014-02-26','09:25:00',3.59),('11288','2014-02-26','09:30:00',2.74),('11288','2014-02-26','09:35:00',2.44),('11288','2014-02-26','09:40:00',2.54),('11288','2014-02-26','09:45:00',2.61),('11288','2014-02-26','09:50:00',2.6),('11288','2014-02-26','09:55:00',2.16),('11288','2014-02-26','10:00:00',2.09),('11288','2014-02-26','10:05:00',1.65),('11288','2014-02-26','10:10:00',1.39),('11288','2014-02-26','10:15:00',1.47),('11288','2014-02-26','10:20:00',1.62),('11288','2014-02-26','10:25:00',1.47),('11288','2014-02-26','10:30:00',1.52),('11288','2014-02-26','10:35:00',1.41),('11288','2014-02-26','10:40:00',1.26),('11288','2014-02-26','10:45:00',1.05),('11288','2014-02-26','10:50:00',1.08),('11288','2014-02-26','10:55:00',1.42),('11288','2014-02-26','11:00:00',1.85),('11288','2014-02-26','11:05:00',1.86),('11288','2014-02-26','11:10:00',1.83),('11288','2014-02-26','11:15:00',1.71),('11288','2014-02-26','11:20:00',1.18),('11288','2014-02-26','11:25:00',1.13),('11288','2014-02-26','11:30:00',1.42),('11288','2014-02-26','11:35:00',1.36),('11288','2014-02-26','11:40:00',1.25),('11288','2014-02-26','11:45:00',1.6),('11288','2014-02-26','11:50:00',1.94),('11288','2014-02-26','11:55:00',2.11),('11288','2014-02-26','12:00:00',2.4),('11288','2014-02-26','12:05:00',2.52),('11288','2014-02-26','12:10:00',2.38),('11288','2014-02-26','12:15:00',2.05),('11288','2014-02-26','12:20:00',2.47),('11288','2014-02-26','12:25:00',3.28),('11288','2014-02-26','12:30:00',4.51),('11288','2014-02-26','12:35:00',4.3),('11288','2014-02-26','12:40:00',6.02),('11288','2014-02-26','12:45:00',4.66),('11288','2014-02-26','12:50:00',5.14),('11288','2014-02-26','12:55:00',5.65),('11288','2014-02-26','13:00:00',4.3),('11288','2014-02-26','13:05:00',4.09),('11288','2014-02-26','13:10:00',4.63),('11288','2014-02-26','13:15:00',4.67),('11288','2014-02-26','13:20:00',4.25),('11288','2014-02-26','13:25:00',4.93),('11288','2014-02-26','13:30:00',5.79),('11288','2014-02-26','13:35:00',5.2),('11288','2014-02-26','13:40:00',5.46),('11288','2014-02-26','13:45:00',2.88),('11288','2014-02-26','13:50:00',2.4),('11288','2014-02-26','13:55:00',4.85),('11288','2014-02-26','14:00:00',5.52),('11288','2014-02-26','14:05:00',2.27),('11288','2014-02-26','14:10:00',3.36),('11288','2014-02-26','14:15:00',5.34),('11288','2014-02-26','14:20:00',5.15),('11288','2014-02-26','14:25:00',4.86),('11288','2014-02-26','14:30:00',1.75),('11288','2014-02-26','14:35:00',4.99),('11288','2014-02-26','14:40:00',4.59),('11288','2014-02-26','14:45:00',3.92),('11288','2014-02-26','14:50:00',4.25),('11288','2014-02-26','14:55:00',4.4),('11288','2014-02-26','15:00:00',2.8),('11288','2014-02-26','15:05:00',3.66),('11288','2014-02-26','15:10:00',3.73),('11288','2014-02-26','15:15:00',3.18),('11288','2014-02-26','15:20:00',2.56),('11288','2014-02-26','15:25:00',1.98),('11288','2014-02-26','15:30:00',1.93),('11288','2014-02-26','15:35:00',2.42),('11288','2014-02-26','15:40:00',2.37),('11288','2014-02-26','15:45:00',1.85),('11288','2014-02-26','15:50:00',1.92),('11288','2014-02-26','15:55:00',2.19),('11288','2014-02-26','16:00:00',2.49),('11288','2014-02-26','16:05:00',2.23),('11288','2014-02-26','16:10:00',1.41),('11288','2014-02-26','16:15:00',1.38),('11288','2014-02-26','16:20:00',1.32),('11288','2014-04-29','09:40:00',1.04),('11288','2014-04-29','09:45:00',1.43),('11288','2014-04-29','09:50:00',1.91),('11288','2014-04-29','09:55:00',2.08),('11288','2014-04-29','10:00:00',2.16),('11288','2014-04-29','10:05:00',3.51),('11288','2014-04-29','10:10:00',6.24),('11288','2014-04-29','10:15:00',4.83),('11288','2014-04-29','10:20:00',5.22),('11288','2014-04-29','10:25:00',6.67),('11288','2014-04-29','10:30:00',6.22),('11288','2014-04-29','10:35:00',6.35),('11288','2014-04-29','10:40:00',6.52),('11288','2014-04-29','10:45:00',6.54),('11288','2014-04-29','10:50:00',6.7),('11288','2014-04-29','10:55:00',6.3),('11288','2014-04-29','11:00:00',6.61),('11288','2014-04-29','11:05:00',6.63),('11288','2014-04-29','11:10:00',5.58),('11288','2014-04-29','11:15:00',7.4),('11288','2014-04-29','11:20:00',4.06),('11288','2014-04-29','11:25:00',4.68),('11288','2014-04-29','11:30:00',2.52),('11288','2014-04-29','11:35:00',4.9),('11288','2014-04-29','11:40:00',6.14),('11288','2014-04-29','11:45:00',2.41),('11288','2014-04-29','11:50:00',1.9),('11288','2014-04-29','11:55:00',2.01),('11288','2014-04-29','12:00:00',2.84),('11288','2014-04-29','12:05:00',3.08),('11288','2014-04-29','12:10:00',3.1),('11288','2014-04-29','12:15:00',3.03),('11288','2014-04-29','12:20:00',4.72),('11288','2014-04-29','12:25:00',2.96),('11288','2014-04-29','12:30:00',2.73),('11288','2014-04-29','12:35:00',3.23),('11288','2014-04-29','12:40:00',3.06),('11288','2014-04-29','12:45:00',5.89),('11288','2014-04-29','12:50:00',3.16),('11288','2014-04-29','12:55:00',3.27),('11288','2014-04-29','13:00:00',4.6),('11288','2014-04-29','13:05:00',5.27),('11288','2014-04-29','13:10:00',5.06),('11288','2014-04-29','13:15:00',5.13),('11288','2014-04-29','13:20:00',6.01),('11288','2014-04-29','13:25:00',6.95),('11288','2014-04-29','13:30:00',4.02),('11288','2014-04-29','13:35:00',2.56),('11288','2014-04-29','13:40:00',2.92),('11288','2014-04-29','13:45:00',5.01),('11288','2014-04-29','13:50:00',4.77),('11288','2014-04-29','13:55:00',1.79),('11288','2014-04-29','14:00:00',1.01),('11288','2014-04-29','14:25:00',1.01),('11288','2014-04-29','14:40:00',1.15),('11288','2014-04-29','14:45:00',1.13),('11288','2014-04-29','14:55:00',1.02),('11288','2014-04-29','15:00:00',1.21),('11288','2014-04-29','15:05:00',1.65),('11288','2014-04-29','15:10:00',1.37),('11288','2014-04-29','15:15:00',1.05),('11288','2014-04-29','15:20:00',1.02),('11288','2014-04-29','15:25:00',1.33),('11288','2014-04-29','15:30:00',1.48),('11288','2014-04-29','15:35:00',1.51),('11288','2014-04-29','15:40:00',1.12),('11288','2014-04-29','16:05:00',1.1),('11288','2014-04-29','16:10:00',1.26),('11288','2014-04-29','16:15:00',1.52),('11288','2014-04-29','16:20:00',1.62),('11288','2014-04-29','16:25:00',1.73),('11288','2014-04-29','16:30:00',1.49),('11288','2014-04-29','16:35:00',1.25),('11288','2014-04-29','16:40:00',1.07),('11288','2014-04-29','16:45:00',1.04),('11288','2014-04-29','16:50:00',1.13),('11288','2014-04-29','16:55:00',1.35),('11288','2014-04-29','17:00:00',1.64),('11288','2014-04-29','17:05:00',2.11),('11288','2014-04-29','17:10:00',1.95),('11288','2014-04-29','17:15:00',1.59),('11288','2014-04-29','17:20:00',2.12),('11288','2014-04-29','17:25:00',2.42),('11288','2014-04-29','17:30:00',2.38),('11288','2014-04-29','17:35:00',1.63),('11288','2014-04-29','17:40:00',3.07),('11288','2014-04-29','17:45:00',2.86),('11288','2014-04-29','17:50:00',1.71),('11288','2014-04-29','18:00:00',1.16),('11288','2014-04-29','18:05:00',1.36),('11288','2014-02-25','08:05:00',1.06),('11288','2014-02-25','08:10:00',1.08),('11288','2014-02-25','08:15:00',1.33),('11288','2014-02-25','08:20:00',1.49),('11288','2014-02-25','08:25:00',1.58),('11288','2014-02-25','08:30:00',1.73),('11288','2014-02-25','08:35:00',1.87),('11288','2014-02-25','08:40:00',2.01),('11288','2014-02-25','08:45:00',2.18),('11288','2014-02-25','08:50:00',2.25),('11288','2014-02-25','08:55:00',2.36),('11288','2014-02-25','09:00:00',2.54),('11288','2014-02-25','09:05:00',2.65),('11288','2014-02-25','09:10:00',2.81),('11288','2014-02-25','09:15:00',2.91),('11288','2014-02-25','09:20:00',3.07),('11288','2014-02-25','09:25:00',3.12),('11288','2014-02-25','09:30:00',3.27),('11288','2014-02-25','09:35:00',3.39),('11288','2014-02-25','09:40:00',3.5),('11288','2014-02-25','09:45:00',3.6),('11288','2014-02-25','09:50:00',3.64),('11288','2014-02-25','09:55:00',3.76),('11288','2014-02-25','10:00:00',3.94),('11288','2014-02-25','10:05:00',4.08),('11288','2014-02-25','10:10:00',4.18),('11288','2014-02-25','10:15:00',4.25),('11288','2014-02-25','10:20:00',4.33),('11288','2014-02-25','10:25:00',4.4),('11288','2014-02-25','10:30:00',4.45),('11288','2014-02-25','10:35:00',4.51),('11288','2014-02-25','10:40:00',4.58),('11288','2014-02-25','10:45:00',4.62),('11288','2014-02-25','10:50:00',4.65),('11288','2014-02-25','10:55:00',4.77),('11288','2014-02-25','11:00:00',4.76),('11288','2014-02-25','11:05:00',4.81),('11288','2014-02-25','11:10:00',4.84),('11288','2014-02-25','11:15:00',4.96),('11288','2014-02-25','11:20:00',4.97),('11288','2014-02-25','11:25:00',5.02),('11288','2014-02-25','11:30:00',5.07),('11288','2014-02-25','11:35:00',5.13),('11288','2014-02-25','11:40:00',5.18),('11288','2014-02-25','11:45:00',5.13),('11288','2014-02-25','11:50:00',5.19),('11288','2014-02-25','11:55:00',5.15),('11288','2014-02-25','12:00:00',5.18),('11288','2014-02-25','12:05:00',5.23),('11288','2014-02-25','12:10:00',5.3),('11288','2014-02-25','12:15:00',5.29),('11288','2014-02-25','12:20:00',5.35),('11288','2014-02-25','12:25:00',5.35),('11288','2014-02-25','12:30:00',5.28),('11288','2014-02-25','12:35:00',5.23),('11288','2014-02-25','12:40:00',5.27),('11288','2014-02-25','12:45:00',5.22),('11288','2014-02-25','12:50:00',5.23),('11288','2014-02-25','12:55:00',5.16),('11288','2014-02-25','13:00:00',5.06),('11288','2014-02-25','13:05:00',4.96),('11288','2014-02-25','13:10:00',2.91),('11288','2014-02-25','13:15:00',1.28),('11288','2014-02-25','13:20:00',1.38),('11288','2014-02-25','13:25:00',1.45),('11288','2014-02-25','13:30:00',1.48),('11288','2014-02-25','13:35:00',2.07),('11288','2014-02-25','13:40:00',2.27),('11288','2014-02-25','13:45:00',2.04),('11288','2014-02-25','13:50:00',1.85),('11288','2014-02-25','13:55:00',2.24),('11288','2014-02-25','14:00:00',2.13),('11288','2014-02-25','14:05:00',1.94),('11288','2014-02-25','14:10:00',1.87),('11288','2014-02-25','14:15:00',1.93),('11288','2014-02-25','14:20:00',2.04),('11288','2014-02-25','14:25:00',2.89),('11288','2014-02-25','14:30:00',3.22),('11288','2014-02-25','14:35:00',4.05),('11288','2014-02-25','14:40:00',4.4),('11288','2014-02-25','14:45:00',4.34),('11288','2014-02-25','14:50:00',3.04),('11288','2014-02-25','14:55:00',1.75),('11288','2014-02-25','15:00:00',3.14),('11288','2014-02-25','15:05:00',3.64),('11288','2014-02-25','15:10:00',3.48),('11288','2014-02-25','15:15:00',3.25),('11288','2014-02-25','15:20:00',3.12),('11288','2014-02-25','15:25:00',2.53),('11288','2014-02-25','15:30:00',2.46),('11288','2014-02-25','15:35:00',2.22),('11288','2014-02-25','15:40:00',2.28),('11288','2014-02-25','15:45:00',1.51),('11288','2014-02-25','15:50:00',1.3),('11288','2014-02-25','15:55:00',1.44),('11288','2014-02-25','16:00:00',1.21),('11288','2014-02-25','16:05:00',1.39),('11288','2014-02-25','16:10:00',1.27),('11288','2014-02-25','16:15:00',1.36),('11288','2014-02-25','16:20:00',1.4),('11288','2014-02-25','16:25:00',1.12),('11288','2014-02-24','08:00:00',1.1),('11288','2014-02-24','08:05:00',1.42),('11288','2014-02-24','08:10:00',1.47),('11288','2014-02-24','08:15:00',1.79),('11288','2014-02-24','08:20:00',1.9),('11288','2014-02-24','08:25:00',1.95),('11288','2014-02-24','08:30:00',1.83),('11288','2014-02-24','08:35:00',2.12),('11288','2014-02-24','08:40:00',1.65),('11288','2014-02-24','08:45:00',1.49),('11288','2014-02-24','08:50:00',1.81),('11288','2014-02-24','08:55:00',2.11),('11288','2014-02-24','09:00:00',2.34),('11288','2014-02-24','09:05:00',2.59),('11288','2014-02-24','09:10:00',2.66),('11288','2014-02-24','09:15:00',2.78),('11288','2014-02-24','09:20:00',3),('11288','2014-02-24','09:25:00',3.09),('11288','2014-02-24','09:30:00',3.22),('11288','2014-02-24','09:35:00',3.37),('11288','2014-02-24','09:40:00',3.49),('11288','2014-02-24','09:45:00',3.62),('11288','2014-02-24','09:50:00',3.57),('11288','2014-02-24','09:55:00',3.74),('11288','2014-02-24','10:00:00',3.94),('11288','2014-02-24','10:05:00',4.08),('11288','2014-02-24','10:10:00',4.18),('11288','2014-02-24','10:15:00',4.27),('11288','2014-02-24','10:20:00',4.37),('11288','2014-02-24','10:25:00',4.47),('11288','2014-02-24','10:30:00',4.54),('11288','2014-02-24','10:35:00',4.61),('11288','2014-02-24','10:40:00',4.64),('11288','2014-02-24','10:45:00',4.66),('11288','2014-02-24','10:50:00',4.79),('11288','2014-02-24','10:55:00',4.89),('11288','2014-02-24','11:00:00',4.92),('11288','2014-02-24','11:05:00',4.98),('11288','2014-02-24','11:10:00',5.04),('11288','2014-02-24','11:15:00',5.12),('11288','2014-02-24','11:20:00',5.18),('11288','2014-02-24','11:25:00',5.32),('11288','2014-02-24','11:30:00',5.84),('11288','2014-02-24','11:35:00',4.19),('11288','2014-02-24','11:40:00',4.51),('11288','2014-02-24','11:45:00',5.34),('11288','2014-02-24','11:50:00',5.36),('11288','2014-02-24','11:55:00',4.22),('11288','2014-02-24','12:00:00',5.27),('11288','2014-02-24','12:05:00',5.55),('11288','2014-02-24','12:10:00',5.6),('11288','2014-02-24','12:15:00',5.51),('11288','2014-02-24','12:20:00',5.56),('11288','2014-02-24','12:25:00',5.4),('11288','2014-02-24','12:30:00',1.81),('11288','2014-02-24','12:35:00',6.02),('11288','2014-02-24','12:40:00',6.11),('11288','2014-02-24','12:45:00',5.97),('11288','2014-02-24','12:50:00',5.76),('11288','2014-02-24','12:55:00',3.86),('11288','2014-02-24','13:00:00',4.86),('11288','2014-02-24','13:05:00',4.05),('11288','2014-02-24','13:10:00',5.95),('11288','2014-02-24','13:15:00',4.58),('11288','2014-02-24','13:20:00',1.99),('11288','2014-02-24','13:25:00',1.63),('11288','2014-02-24','13:30:00',1.45),('11288','2014-02-24','13:35:00',1.4),('11288','2014-02-24','13:40:00',1.39),('11288','2014-02-24','13:45:00',1.35),('11288','2014-02-24','13:50:00',1.31),('11288','2014-02-24','13:55:00',1.39),('11288','2014-02-24','14:00:00',1.51),('11288','2014-02-24','14:05:00',1.61),('11288','2014-02-24','14:10:00',1.75),('11288','2014-02-24','14:15:00',1.79),('11288','2014-02-24','14:20:00',1.75),('11288','2014-02-24','14:25:00',1.78),('11288','2014-02-24','14:30:00',1.87),('11288','2014-02-24','14:35:00',1.81),('11288','2014-02-24','14:40:00',1.74),('11288','2014-02-24','14:45:00',1.82),('11288','2014-02-24','14:50:00',1.81),('11288','2014-02-24','14:55:00',1.52),('11288','2014-02-24','15:00:00',1.41),('11288','2014-02-24','15:05:00',1.45),('11288','2014-02-24','15:10:00',1.6),('11288','2014-02-24','15:15:00',1.76),('11288','2014-02-24','15:20:00',1.96),('11288','2014-02-24','15:25:00',2.02),('11288','2014-02-24','15:30:00',1.65),('11288','2014-02-24','15:35:00',3.36),('11288','2014-02-24','15:40:00',3.47),('11288','2014-02-24','15:45:00',3.09),('11288','2014-02-24','15:50:00',3.16),('11288','2014-02-24','15:55:00',2.97),('11288','2014-02-24','16:00:00',2.66),('11288','2014-02-24','16:05:00',2.8),('11288','2014-02-24','16:10:00',2.53),('11288','2014-02-24','16:15:00',2.3),('11288','2014-02-24','16:20:00',1.92),('11288','2014-02-24','16:25:00',1.55),('11288','2014-02-24','16:30:00',1.15),('11288','2014-02-23','08:05:00',1.04),('11288','2014-02-23','08:10:00',1.14),('11288','2014-02-23','08:15:00',1.14),('11288','2014-02-23','08:20:00',1.41),('11288','2014-02-23','08:25:00',1.52),('11288','2014-02-23','08:30:00',1.57),('11288','2014-02-23','08:35:00',1.81),('11288','2014-02-23','08:40:00',1.93),('11288','2014-02-23','08:45:00',2.07),('11288','2014-02-23','08:50:00',2.2),('11288','2014-02-23','08:55:00',2.33),('11288','2014-02-23','09:00:00',2.45),('11288','2014-02-23','09:05:00',2.6),('11288','2014-02-23','09:10:00',2.71),('11288','2014-02-23','09:15:00',2.69),('11288','2014-02-23','09:20:00',3.03),('11288','2014-02-23','09:25:00',2.77),('11288','2014-02-23','09:30:00',2.81),('11288','2014-02-23','09:35:00',3.26),('11288','2014-02-23','09:40:00',3.46),('11288','2014-02-23','09:45:00',3.58),('11288','2014-02-23','09:50:00',3.57),('11288','2014-02-23','09:55:00',3.74),('11288','2014-02-23','10:00:00',3.86),('11288','2014-02-23','10:05:00',3.98),('11288','2014-02-23','10:10:00',4.06),('11288','2014-02-23','10:15:00',4.05),('11288','2014-02-23','10:20:00',4.2),('11288','2014-02-23','10:25:00',4.36),('11288','2014-02-23','10:30:00',4.4),('11288','2014-02-23','10:35:00',4.44),('11288','2014-02-23','10:40:00',4.48),('11288','2014-02-23','10:45:00',4.5),('11288','2014-02-23','10:50:00',4.67),('11288','2014-02-23','10:55:00',4.74),('11288','2014-02-23','11:00:00',4.84),('11288','2014-02-23','11:05:00',4.88),('11288','2014-02-23','11:10:00',4.96),('11288','2014-02-23','11:15:00',5.15),('11288','2014-02-23','11:20:00',5.18),('11288','2014-02-23','11:25:00',5.17),('11288','2014-02-23','11:30:00',5.26),('11288','2014-02-23','11:35:00',5.22),('11288','2014-02-23','11:40:00',4.91),('11288','2014-02-23','11:45:00',5.53),('11288','2014-02-23','11:50:00',5.66),('11288','2014-02-23','11:55:00',5.54),('11288','2014-02-23','12:00:00',5.56),('11288','2014-02-23','12:05:00',2.44),('11288','2014-02-23','12:10:00',2.79),('11288','2014-02-23','12:15:00',5.76),('11288','2014-02-23','12:20:00',5.38),('11288','2014-02-23','12:25:00',3.52),('11288','2014-02-23','12:30:00',4.33),('11288','2014-02-23','12:35:00',5.84),('11288','2014-02-23','12:40:00',3.3),('11288','2014-02-23','12:45:00',4.02),('11288','2014-02-23','12:50:00',2.95),('11288','2014-02-23','12:55:00',3.16),('11288','2014-02-23','13:00:00',4.24),('11288','2014-02-23','13:05:00',5.5),('11288','2014-02-23','13:10:00',5.39),('11288','2014-02-23','13:15:00',5.3),('11288','2014-02-23','13:20:00',5.27),('11288','2014-02-23','13:25:00',5.24),('11288','2014-02-23','13:30:00',5.1),('11288','2014-02-23','13:35:00',4.98),('11288','2014-02-23','13:40:00',4.31),('11288','2014-02-23','13:45:00',3.84),('11288','2014-02-23','13:50:00',4.38),('11288','2014-02-23','13:55:00',1.88),('11288','2014-02-23','14:00:00',1.28),('11288','2014-02-23','14:05:00',4.32),('11288','2014-02-23','14:10:00',4.97),('11288','2014-02-23','14:15:00',3.72),('11288','2014-02-23','14:20:00',2.58),('11288','2014-02-23','14:25:00',4.02),('11288','2014-02-23','14:30:00',5.52),('11288','2014-02-23','14:35:00',4.46),('11288','2014-02-23','14:40:00',3.58),('11288','2014-02-23','14:45:00',2.72),('11288','2014-02-23','14:50:00',3.43),('11288','2014-02-23','14:55:00',1.91),('11288','2014-02-23','15:00:00',1.53),('11288','2014-02-22','09:00:00',1.05),('11288','2014-02-22','09:05:00',1.64),('11288','2014-02-22','09:10:00',1.68),('11288','2014-02-22','09:20:00',1.21),('11288','2014-02-22','09:25:00',1.45),('11288','2014-02-22','09:30:00',1.28),('11288','2014-02-22','09:35:00',1.52),('11288','2014-02-22','09:40:00',1.5),('11288','2014-02-22','09:45:00',1.53),('11288','2014-02-22','09:50:00',1.7),('11288','2014-02-22','09:55:00',1.67),('11288','2014-02-22','10:00:00',2.6),('11288','2014-02-22','10:05:00',2.73),('11288','2014-02-22','10:10:00',4.1),('11288','2014-02-22','10:15:00',3.27),('11288','2014-02-22','10:20:00',2.39),('11288','2014-02-22','10:25:00',3.48),('11288','2014-02-22','10:30:00',3.47),('11288','2014-02-22','10:35:00',2.98),('11288','2014-02-22','10:40:00',2.49),('11288','2014-02-22','10:45:00',5.09),('11288','2014-02-22','10:50:00',4.74),('11288','2014-02-22','10:55:00',1.79),('11288','2014-02-22','11:00:00',1.26),('11288','2014-02-22','11:05:00',1.1),('11288','2014-02-22','11:10:00',1.59),('11288','2014-02-22','11:15:00',1.18),('11288','2014-02-22','11:50:00',1.14),('11288','2014-02-22','11:55:00',1.4),('11288','2014-02-22','12:00:00',1.7),('11288','2014-02-22','12:05:00',2.52),('11288','2014-02-22','12:10:00',2.86),('11288','2014-02-22','12:15:00',3.13),('11288','2014-02-22','12:20:00',3.16),('11288','2014-02-22','12:25:00',2.79),('11288','2014-02-22','12:30:00',1.94),('11288','2014-02-22','12:35:00',2.14),('11288','2014-02-22','12:40:00',2.6),('11288','2014-02-22','12:45:00',5.47),('11288','2014-02-22','12:50:00',5.52),('11288','2014-02-22','12:55:00',2.58),('11288','2014-02-22','13:00:00',2.46),('11288','2014-02-22','13:05:00',4.14),('11288','2014-02-22','13:10:00',7.02),('11288','2014-02-22','13:15:00',4.25),('11288','2014-02-22','13:20:00',2.55),('11288','2014-02-22','13:25:00',1.57),('11288','2014-02-22','13:30:00',2.07),('11288','2014-02-22','13:35:00',3.31),('11288','2014-02-22','13:40:00',2.89),('11288','2014-02-22','13:45:00',2.6),('11288','2014-02-22','13:50:00',2.86),('11288','2014-02-22','13:55:00',5.35),('11288','2014-02-22','14:00:00',5.22),('11288','2014-02-22','14:05:00',2.29),('11288','2014-02-22','14:10:00',3.44),('11288','2014-02-22','14:15:00',4.37),('11288','2014-02-22','14:20:00',4.69),('11288','2014-02-22','14:25:00',3.82),('11288','2014-02-22','14:30:00',2.88),('11288','2014-02-22','14:35:00',3.12),('11288','2014-02-22','14:40:00',3.86),('11288','2014-02-22','14:45:00',4.43),('11288','2014-02-22','14:50:00',3.59),('11288','2014-02-22','14:55:00',1.62),('11288','2014-02-22','15:00:00',2.18),('11288','2014-02-22','15:05:00',3.6),('11288','2014-02-22','15:10:00',1.58),('11288','2014-02-22','15:15:00',1.54),('11288','2014-02-22','15:20:00',1.35),('11288','2014-02-22','15:25:00',1.22),('11288','2014-02-22','15:30:00',2.72),('11288','2014-02-22','15:35:00',1.64),('11288','2014-02-22','15:40:00',1.58),('11288','2014-02-22','15:45:00',2.57),('11288','2014-02-22','15:50:00',1.69),('11288','2014-02-22','15:55:00',1.42),('11288','2014-02-22','16:00:00',1.73),('11288','2014-02-22','16:10:00',1.8),('11288','2014-02-22','16:15:00',1.63),('11288','2014-02-22','16:20:00',1.47),('11288','2014-02-22','16:25:00',1.28),('11288','2014-02-22','16:30:00',1.17),('11288','2014-02-22','16:35:00',1.09),('11288','2014-02-21','08:35:00',1.1),('11288','2014-02-21','08:40:00',1.19),('11288','2014-02-21','08:45:00',1.28),('11288','2014-02-21','08:50:00',1.34),('11288','2014-02-21','08:55:00',1.41),('11288','2014-02-21','09:00:00',1.37),('11288','2014-02-21','09:05:00',1.35),('11288','2014-02-21','09:10:00',1.36),('11288','2014-02-21','09:15:00',1.46),('11288','2014-02-21','09:20:00',1.6),('11288','2014-02-21','09:25:00',1.59),('11288','2014-02-21','09:30:00',1.57),('11288','2014-02-21','09:35:00',1.69),('11288','2014-02-21','09:40:00',1.84),('11288','2014-02-21','09:45:00',2.06),('11288','2014-02-21','09:50:00',2.13),('11288','2014-02-21','09:55:00',2.04),('11288','2014-02-21','10:00:00',2.08),('11288','2014-02-21','10:05:00',2.37),('11288','2014-02-21','10:10:00',2.22),('11288','2014-02-21','10:15:00',2.57),('11288','2014-02-21','10:20:00',3.29),('11288','2014-02-21','10:25:00',3.56),('11288','2014-02-21','10:30:00',3.78),('11288','2014-02-21','10:35:00',2.86),('11288','2014-02-21','10:40:00',2.81),('11288','2014-02-21','10:45:00',2.62),('11288','2014-02-21','10:50:00',2.87),('11288','2014-02-21','10:55:00',3.49),('11288','2014-02-21','11:00:00',2.75),('11288','2014-02-21','11:05:00',2.72),('11288','2014-02-21','11:10:00',2.62),('11288','2014-02-21','11:15:00',2.85),('11288','2014-02-21','11:20:00',2.63),('11288','2014-02-21','11:25:00',2.75),('11288','2014-02-21','11:30:00',2.83),('11288','2014-02-21','11:35:00',2.88),('11288','2014-02-21','11:40:00',3.08),('11288','2014-02-21','11:45:00',2.69),('11288','2014-02-21','11:50:00',2.53),('11288','2014-02-21','11:55:00',2.67),('11288','2014-02-21','12:00:00',2.54),('11288','2014-02-21','12:05:00',5.29),('11288','2014-02-21','12:10:00',5.87),('11288','2014-02-21','12:15:00',5.31),('11288','2014-02-21','12:20:00',5.3),('11288','2014-02-21','12:25:00',3.61),('11288','2014-02-21','12:30:00',2.4),('11288','2014-02-21','12:35:00',2.07),('11288','2014-02-21','12:40:00',1.73),('11288','2014-02-21','12:45:00',1.4),('11288','2014-02-21','12:50:00',1.28),('11288','2014-02-21','12:55:00',1),('11288','2014-02-21','13:40:00',1.01),('11288','2014-02-21','13:45:00',1.13),('11288','2014-02-21','13:50:00',1.18),('11288','2014-02-21','13:55:00',1.11),('11288','2014-02-21','14:10:00',1.02),('11288','2014-02-21','14:15:00',1.12),('11288','2014-02-21','14:20:00',1.24),('11288','2014-02-21','14:25:00',1.31),('11288','2014-02-21','14:30:00',1.34),('11288','2014-02-21','14:35:00',1.39),('11288','2014-02-21','14:40:00',1.55),('11288','2014-02-21','14:45:00',1.71),('11288','2014-02-21','14:50:00',1.69),('11288','2014-02-21','14:55:00',1.77),('11288','2014-02-21','15:00:00',1.89),('11288','2014-02-21','15:05:00',2.21),('11288','2014-02-21','15:10:00',1.75),('11288','2014-02-21','15:15:00',1),('11288','2014-02-21','15:20:00',1.1),('11288','2014-02-21','15:25:00',1.23),('11288','2014-02-21','15:30:00',1.44),('11288','2014-02-21','15:35:00',2.43),('11288','2014-02-21','15:40:00',2.47),('11288','2014-02-21','15:45:00',2.28),('11288','2014-02-21','15:50:00',2.06),('11288','2014-02-21','15:55:00',1.99),('11288','2014-02-21','16:00:00',1.88),('11288','2014-02-21','16:05:00',1.72),('11288','2014-02-21','16:10:00',1.52),('11288','2014-02-21','16:15:00',1.36),('11288','2014-02-21','16:20:00',1.28),('11288','2014-02-21','16:25:00',1.18),('11288','2014-02-21','16:30:00',1.04),('11288','2014-02-20','10:10:00',1.04),('11288','2014-02-20','10:45:00',1.24),('11288','2014-02-20','10:50:00',1.25),('11288','2014-02-20','10:55:00',1.4),('11288','2014-02-20','11:15:00',1.18),('11288','2014-02-20','11:20:00',1.95),('11288','2014-02-20','11:25:00',2.13),('11288','2014-02-20','11:30:00',2.12),('11288','2014-02-20','11:35:00',1.69),('11288','2014-02-20','11:40:00',1.22),('11288','2014-02-20','11:45:00',1.3),('11288','2014-02-20','11:50:00',1.35),('11288','2014-02-20','11:55:00',1.41),('11288','2014-02-20','12:00:00',1.58),('11288','2014-02-20','12:05:00',1.34),('11288','2014-02-20','12:10:00',1.35),('11288','2014-02-20','12:15:00',1.37),('11288','2014-02-20','12:20:00',1.65),('11288','2014-02-20','12:25:00',1.92),('11288','2014-02-20','12:30:00',1.81),('11288','2014-02-20','12:35:00',1.9),('11288','2014-02-20','12:40:00',2.13),('11288','2014-02-20','12:45:00',1.91),('11288','2014-02-20','12:50:00',1.87),('11288','2014-02-20','12:55:00',2.15),('11288','2014-02-20','13:00:00',2.54),('11288','2014-02-20','13:05:00',1.5),('11288','2014-02-20','13:10:00',1.32),('11288','2014-02-20','13:15:00',2.13),('11288','2014-02-20','13:20:00',1.69),('11288','2014-02-20','13:25:00',1.48),('11288','2014-02-20','13:30:00',2.17),('11288','2014-02-20','13:35:00',1.87),('11288','2014-02-20','13:40:00',1.33),('11288','2014-02-20','13:45:00',1.19),('11288','2014-02-20','13:50:00',1.13),('11288','2014-02-20','13:55:00',1.29),('11288','2014-02-20','14:00:00',1.75),('11288','2014-02-20','14:05:00',1.3),('11288','2014-02-20','14:15:00',1.16),('11288','2014-02-19','08:35:00',1.07),('11288','2014-02-19','08:40:00',1.16),('11288','2014-02-19','08:45:00',1.29),('11288','2014-02-19','08:50:00',1.19),('11288','2014-02-19','08:55:00',1.16),('11288','2014-02-19','09:00:00',1.25),('11288','2014-02-19','09:05:00',1.27),('11288','2014-02-19','09:10:00',1.24),('11288','2014-02-19','09:15:00',1.39),('11288','2014-02-19','09:20:00',1.55),('11288','2014-02-19','09:25:00',1.74),('11288','2014-02-19','09:30:00',1.79),('11288','2014-02-19','09:35:00',2),('11288','2014-02-19','09:40:00',2.16),('11288','2014-02-19','09:45:00',2.5),('11288','2014-02-19','09:50:00',2.37),('11288','2014-02-19','09:55:00',2.24),('11288','2014-02-19','10:00:00',2.18),('11288','2014-02-19','10:05:00',2.19),('11288','2014-02-19','10:10:00',2.36),('11288','2014-02-19','10:15:00',2.48),('11288','2014-02-19','10:20:00',2.28),('11288','2014-02-19','10:25:00',2.34),('11288','2014-02-19','10:30:00',2.47),('11288','2014-02-19','10:35:00',2.6),('11288','2014-02-19','10:40:00',2.93),('11288','2014-02-19','10:45:00',3.2),('11288','2014-02-19','10:50:00',3.01),('11288','2014-02-19','10:55:00',2.71),('11288','2014-02-19','11:00:00',2.49),('11288','2014-02-19','11:05:00',2.55),('11288','2014-02-19','11:10:00',2.85),('11288','2014-02-19','11:15:00',2.82),('11288','2014-02-19','11:20:00',3.03),('11288','2014-02-19','11:25:00',2.82),('11288','2014-02-19','11:30:00',2.63),('11288','2014-02-19','11:35:00',2.76),('11288','2014-02-19','11:40:00',2.56),('11288','2014-02-19','11:45:00',2.51),('11288','2014-02-19','11:50:00',2.55),('11288','2014-02-19','11:55:00',2.22),('11288','2014-02-19','12:00:00',2.26),('11288','2014-02-19','12:05:00',2.43),('11288','2014-02-19','12:10:00',2.35),('11288','2014-02-19','12:15:00',2.25),('11288','2014-02-19','12:20:00',1.99),('11288','2014-02-19','12:25:00',2.37),('11288','2014-02-19','12:30:00',2.62),('11288','2014-02-19','12:35:00',2.11),('11288','2014-02-19','12:40:00',2.02),('11288','2014-02-19','12:45:00',2.05),('11288','2014-02-19','12:50:00',1.66),('11288','2014-02-19','12:55:00',1.49),('11288','2014-02-19','13:00:00',1.66),('11288','2014-02-19','13:05:00',1.77),('11288','2014-02-19','13:10:00',1.78),('11288','2014-02-19','13:15:00',2.04),('11288','2014-02-19','13:20:00',1.96),('11288','2014-02-19','13:25:00',2.6),('11288','2014-02-19','13:30:00',2.58),('11288','2014-02-19','13:35:00',2.8),('11288','2014-02-19','13:40:00',2.61),('11288','2014-02-19','13:45:00',3.33),('11288','2014-02-19','13:50:00',3.38),('11288','2014-02-19','13:55:00',3.02),('11288','2014-02-19','14:00:00',2.81),('11288','2014-02-19','14:05:00',2.94),('11288','2014-02-19','14:10:00',2.4),('11288','2014-02-19','14:15:00',2.24),('11288','2014-02-19','14:20:00',3.35),('11288','2014-02-19','14:25:00',2.63),('11288','2014-02-19','14:30:00',2.54),('11288','2014-02-19','14:35:00',2.69),('11288','2014-02-19','14:40:00',2.24),('11288','2014-02-19','14:45:00',2.15),('11288','2014-02-19','14:50:00',2.69),('11288','2014-02-19','14:55:00',2.26),('11288','2014-02-19','15:00:00',1.77),('11288','2014-02-19','15:05:00',1.9),('11288','2014-02-19','15:10:00',1.95),('11288','2014-02-19','15:15:00',2.15),('11288','2014-02-19','15:20:00',1.69),('11288','2014-02-19','15:25:00',1.9),('11288','2014-02-19','15:30:00',1.66),('11288','2014-02-19','15:35:00',1.47),('11288','2014-02-19','15:40:00',1.56),('11288','2014-02-19','15:45:00',1.61),('11288','2014-02-19','15:50:00',1.94),('11288','2014-02-19','15:55:00',1.59),('11288','2014-02-19','16:00:00',1.4),('11288','2014-02-19','16:05:00',1.32),('11288','2014-02-19','16:10:00',1.21),('11288','2014-02-19','16:15:00',1.19),('11288','2014-02-18','08:10:00',1),('11288','2014-02-18','08:15:00',1.12),('11288','2014-02-18','08:20:00',1.13),('11288','2014-02-18','08:25:00',1.35),('11288','2014-02-18','08:30:00',1.46),('11288','2014-02-18','08:35:00',1.54),('11288','2014-02-18','08:40:00',1.7),('11288','2014-02-18','08:45:00',1.82),('11288','2014-02-18','08:50:00',1.87),('11288','2014-02-18','08:55:00',2.1),('11288','2014-02-18','09:00:00',2.22),('11288','2014-02-18','09:05:00',2.27),('11288','2014-02-18','09:10:00',2.42),('11288','2014-02-18','09:15:00',2.51),('11288','2014-02-18','09:20:00',2.65),('11288','2014-02-18','09:25:00',2.74),('11288','2014-02-18','09:30:00',2.9),('11288','2014-02-18','09:35:00',2.97),('11288','2014-02-18','09:40:00',3.11),('11288','2014-02-18','09:45:00',3.17),('11288','2014-02-18','09:50:00',3.2),('11288','2014-02-18','09:55:00',3.43),('11288','2014-02-18','10:00:00',3.56),('11288','2014-02-18','10:05:00',3.67),('11288','2014-02-18','10:10:00',3.72),('11288','2014-02-18','10:15:00',3.68),('11288','2014-02-18','10:20:00',3.88),('11288','2014-02-18','10:25:00',3.99),('11288','2014-02-18','10:30:00',4.06),('11288','2014-02-18','10:35:00',4.1),('11288','2014-02-18','10:40:00',4.11),('11288','2014-02-18','10:45:00',4.2),('11288','2014-02-18','10:50:00',4.32),('11288','2014-02-18','10:55:00',4.4),('11288','2014-02-18','11:00:00',4.45),('11288','2014-02-18','11:05:00',3.73),('11288','2014-02-18','11:10:00',3.62),('11288','2014-02-18','11:15:00',3.57),('11288','2014-02-18','11:20:00',4.14),('11288','2014-02-18','11:25:00',4.62),('11288','2014-02-18','11:30:00',4.1),('11288','2014-02-18','11:35:00',3.97),('11288','2014-02-18','11:40:00',3.33),('11288','2014-02-18','11:45:00',3.32),('11288','2014-02-18','11:50:00',2.85),('11288','2014-02-18','11:55:00',2.57),('11288','2014-02-18','12:00:00',2.56),('11288','2014-02-18','12:05:00',2.6),('11288','2014-02-18','12:10:00',2.94),('11288','2014-02-18','12:15:00',3.09),('11288','2014-02-18','12:20:00',3.1),('11288','2014-02-18','12:25:00',3.49),('11288','2014-02-18','12:30:00',3.68),('11288','2014-02-18','12:35:00',2.92),('11288','2014-02-18','12:40:00',2.72),('11288','2014-02-18','12:45:00',2.65),('11288','2014-02-18','12:50:00',2.8),('11288','2014-02-18','12:55:00',2.94),('11288','2014-02-18','13:00:00',2.43),('11288','2014-02-18','13:05:00',2.31),('11288','2014-02-18','13:10:00',2.45),('11288','2014-02-18','13:15:00',3.08),('11288','2014-02-18','13:20:00',3.31),('11288','2014-02-18','13:25:00',3.89),('11288','2014-02-18','13:30:00',2.84),('11288','2014-02-18','13:35:00',2.43),('11288','2014-02-18','13:40:00',3.09),('11288','2014-02-18','13:45:00',3.45),('11288','2014-02-18','13:50:00',2.74),('11288','2014-02-18','13:55:00',2.72),('11288','2014-02-18','14:00:00',3.01),('11288','2014-02-18','14:05:00',4.24),('11288','2014-02-18','14:10:00',2.58),('11288','2014-02-18','14:15:00',2.11),('11288','2014-02-18','14:20:00',1.94),('11288','2014-02-18','14:25:00',1.99),('11288','2014-02-18','14:30:00',2.41),('11288','2014-02-18','14:35:00',2.33),('11288','2014-02-18','14:40:00',1.99),('11288','2014-02-18','14:45:00',1.84),('11288','2014-02-18','14:50:00',1.73),('11288','2014-02-18','14:55:00',1.66),('11288','2014-02-18','15:00:00',1.57),('11288','2014-02-18','15:05:00',1.49),('11288','2014-02-18','15:10:00',1.47),('11288','2014-02-18','15:15:00',1.38),('11288','2014-02-18','15:20:00',1.24),('11288','2014-02-18','15:25:00',1.28),('11288','2014-02-18','15:30:00',1.43),('11288','2014-02-18','15:35:00',1.72),('11288','2014-02-18','15:40:00',2.01),('11288','2014-02-18','15:45:00',2.1),('11288','2014-02-18','15:50:00',1.72),('11288','2014-02-18','15:55:00',1.52),('11288','2014-02-18','16:00:00',1.52),('11288','2014-02-18','16:05:00',1.64),('11288','2014-02-18','16:10:00',1.4),('11288','2014-02-18','16:15:00',1.06),('11288','2014-02-17','08:15:00',1.06),('11288','2014-02-17','08:20:00',1.06),('11288','2014-02-17','08:25:00',1.27),('11288','2014-02-17','08:30:00',1.39),('11288','2014-02-17','08:35:00',1.47),('11288','2014-02-17','08:40:00',1.59),('11288','2014-02-17','08:45:00',1.7),('11288','2014-02-17','08:50:00',1.78),('11288','2014-02-17','08:55:00',1.9),('11288','2014-02-17','09:00:00',1.99),('11288','2014-02-17','09:05:00',2.06),('11288','2014-02-17','09:10:00',2.15),('11288','2014-02-17','09:15:00',2.33),('11288','2014-02-17','09:20:00',2.44),('11288','2014-02-17','09:25:00',2.55),('11288','2014-02-17','09:30:00',2.72),('11288','2014-02-17','09:35:00',2.83),('11288','2014-02-17','09:40:00',2.93),('11288','2014-02-17','09:45:00',2.96),('11288','2014-02-17','09:50:00',2.93),('11288','2014-02-17','09:55:00',3.09),('11288','2014-02-17','10:00:00',3.3),('11288','2014-02-17','10:05:00',3.41),('11288','2014-02-17','10:10:00',3.46),('11288','2014-02-17','10:15:00',3.39),('11288','2014-02-17','10:20:00',3.56),('11288','2014-02-17','10:25:00',3.64),('11288','2014-02-17','10:30:00',3.74),('11288','2014-02-17','10:35:00',3.75),('11288','2014-02-17','10:40:00',3.69),('11288','2014-02-17','10:45:00',3.78),('11288','2014-02-17','10:50:00',3.9),('11288','2014-02-17','10:55:00',3.96),('11288','2014-02-17','11:00:00',3.99),('11288','2014-02-17','11:05:00',4.03),('11288','2014-02-17','11:10:00',4.05),('11288','2014-02-17','11:15:00',4.21),('11288','2014-02-17','11:20:00',4.32),('11288','2014-02-17','11:25:00',4.44),('11288','2014-02-17','11:30:00',4.5),('11288','2014-02-17','11:35:00',4.58),('11288','2014-02-17','11:40:00',4.61),('11288','2014-02-17','11:45:00',4.59),('11288','2014-02-17','11:50:00',4.34),('11288','2014-02-17','11:55:00',4.14),('11288','2014-02-17','12:00:00',4.7),('11288','2014-02-17','12:05:00',4.7),('11288','2014-02-17','12:10:00',4.72),('11288','2014-02-17','12:15:00',4.69),('11288','2014-02-17','12:20:00',4.49),('11288','2014-02-17','12:25:00',4.6),('11288','2014-02-17','12:30:00',4.65),('11288','2014-02-17','12:35:00',4.64),('11288','2014-02-17','12:40:00',4.62),('11288','2014-02-17','12:45:00',4.59),('11288','2014-02-17','12:50:00',4.55),('11288','2014-02-17','12:55:00',4.52),('11288','2014-02-17','13:00:00',4.53),('11288','2014-02-17','13:05:00',4.48),('11288','2014-02-17','13:10:00',4.46),('11288','2014-02-17','13:15:00',4.42),('11288','2014-02-17','13:20:00',4.38),('11288','2014-02-17','13:25:00',4.37),('11288','2014-02-17','13:30:00',4.37),('11288','2014-02-17','13:35:00',4.31),('11288','2014-02-17','13:40:00',4.27),('11288','2014-02-17','13:45:00',4.14),('11288','2014-02-17','13:50:00',4.13),('11288','2014-02-17','13:55:00',4.07),('11288','2014-02-17','14:00:00',4.01),('11288','2014-02-17','14:05:00',3.98),('11288','2014-02-17','14:10:00',3.78),('11288','2014-02-17','14:15:00',3.63),('11288','2014-02-17','14:20:00',3.76),('11288','2014-02-17','14:25:00',3.6),('11288','2014-02-17','14:30:00',3.47),('11288','2014-02-17','14:35:00',3.36),('11288','2014-02-17','14:40:00',3.1),('11288','2014-02-17','14:45:00',3.35),('11288','2014-02-17','14:50:00',3.16),('11288','2014-02-17','14:55:00',3.07),('11288','2014-02-17','15:00:00',2.9),('11288','2014-02-17','15:05:00',2.82),('11288','2014-02-17','15:10:00',2.73),('11288','2014-02-17','15:15:00',2.74),('11288','2014-02-17','15:20:00',2.66),('11288','2014-02-17','15:25:00',2.43),('11288','2014-02-17','15:30:00',2.36),('11288','2014-02-17','15:35:00',2.22),('11288','2014-02-17','15:40:00',2.05),('11288','2014-02-17','15:45:00',1.98),('11288','2014-02-17','15:50:00',1.83),('11288','2014-02-17','15:55:00',1.64),('11288','2014-02-17','16:00:00',1.54),('11288','2014-02-17','16:05:00',1.48),('11288','2014-02-17','16:10:00',1.36),('11288','2014-02-17','16:15:00',1.22),('11288','2014-02-17','16:20:00',1.13),('11288','2014-02-17','16:25:00',1.04),('11288','2014-02-16','08:15:00',1.08),('11288','2014-02-16','08:20:00',1.06),('11288','2014-02-16','08:25:00',1.34),('11288','2014-02-16','08:30:00',1.47),('11288','2014-02-16','08:35:00',1.59),('11288','2014-02-16','08:40:00',1.64),('11288','2014-02-16','08:45:00',1.85),('11288','2014-02-16','08:50:00',1.76),('11288','2014-02-16','08:55:00',2.03),('11288','2014-02-16','09:00:00',2.22),('11288','2014-02-16','09:05:00',2.22),('11288','2014-02-16','09:10:00',2.23),('11288','2014-02-16','09:15:00',1.94),('11288','2014-02-16','09:20:00',2.57),('11288','2014-02-16','09:25:00',2.54),('11288','2014-02-16','09:30:00',2.65),('11288','2014-02-16','09:35:00',2.23),('11288','2014-02-16','09:40:00',2.95),('11288','2014-02-16','09:45:00',3.09),('11288','2014-02-16','09:50:00',3.28),('11288','2014-02-16','09:55:00',3.24),('11288','2014-02-16','10:00:00',3.23),('11288','2014-02-16','10:05:00',3.58),('11288','2014-02-16','10:10:00',3.7),('11288','2014-02-16','10:15:00',3.79),('11288','2014-02-16','10:20:00',3.94),('11288','2014-02-16','10:25:00',4.04),('11288','2014-02-16','10:30:00',4.12),('11288','2014-02-16','10:35:00',4.27),('11288','2014-02-16','10:40:00',4.24),('11288','2014-02-16','10:45:00',4.29),('11288','2014-02-16','10:50:00',3.72),('11288','2014-02-16','10:55:00',3.86),('11288','2014-02-16','11:00:00',4.44),('11288','2014-02-16','11:05:00',4.49),('11288','2014-02-16','11:10:00',4.27),('11288','2014-02-16','11:15:00',4.52),('11288','2014-02-16','11:20:00',4.33),('11288','2014-02-16','11:25:00',4.45),('11288','2014-02-16','11:30:00',4.52),('11288','2014-02-16','11:35:00',4.72),('11288','2014-02-16','11:40:00',4.7),('11288','2014-02-16','11:45:00',4.18),('11288','2014-02-16','11:50:00',4.29),('11288','2014-02-16','11:55:00',3.91),('11288','2014-02-16','12:00:00',4.82),('11288','2014-02-16','12:05:00',4.77),('11288','2014-02-16','12:10:00',4.77),('11288','2014-02-16','12:15:00',4.8),('11288','2014-02-16','12:20:00',4.63),('11288','2014-02-16','12:25:00',4.69),('11288','2014-02-16','12:30:00',4.71),('11288','2014-02-16','12:35:00',4.71),('11288','2014-02-16','12:40:00',4.65),('11288','2014-02-16','12:45:00',4.69),('11288','2014-02-16','12:50:00',4.68),('11288','2014-02-16','12:55:00',4.66),('11288','2014-02-16','13:00:00',4.67),('11288','2014-02-16','13:05:00',4.66),('11288','2014-02-16','13:10:00',4.46),('11288','2014-02-16','13:15:00',4.55),('11288','2014-02-16','13:20:00',4.49),('11288','2014-02-16','13:25:00',4.41),('11288','2014-02-16','13:30:00',4.43),('11288','2014-02-16','13:35:00',4.34),('11288','2014-02-16','13:40:00',4.42),('11288','2014-02-16','13:45:00',4.42),('11288','2014-02-16','13:50:00',4.31),('11288','2014-02-16','13:55:00',4.3),('11288','2014-02-16','14:00:00',4.29),('11288','2014-02-16','14:05:00',4.23),('11288','2014-02-16','14:10:00',4.12),('11288','2014-02-16','14:15:00',4),('11288','2014-02-16','14:20:00',3.97),('11288','2014-02-16','14:25:00',3.93),('11288','2014-02-16','14:30:00',3.81),('11288','2014-02-16','14:35:00',3.72),('11288','2014-02-16','14:40:00',3.58),('11288','2014-02-16','14:45:00',3.52),('11288','2014-02-16','14:50:00',3.4),('11288','2014-02-16','14:55:00',3.32),('11288','2014-02-16','15:00:00',3.19),('11288','2014-02-16','15:05:00',3.11),('11288','2014-02-16','15:10:00',2.97),('11288','2014-02-16','15:15:00',2.85),('11288','2014-02-16','15:20:00',2.69),('11288','2014-02-16','15:25:00',2.57),('11288','2014-02-16','15:30:00',2.42),('11288','2014-02-16','15:35:00',2.07),('11288','2014-02-16','15:40:00',1.89),('11288','2014-02-16','15:45:00',2.12),('11288','2014-02-16','15:50:00',1.64),('11288','2014-02-16','16:10:00',1.06),('11288','2014-02-16','16:15:00',1.34),('11288','2014-02-16','16:20:00',1.51),('11288','2014-02-16','16:25:00',1.59),('11288','2014-02-16','16:30:00',1.45),('11288','2014-02-16','16:35:00',1.09),('11288','2014-04-28','07:45:00',1.09),('11288','2014-04-28','07:50:00',1.12),('11288','2014-04-28','07:55:00',1.28),('11288','2014-04-28','08:00:00',1.43),('11288','2014-04-28','08:15:00',2.29),('11288','2014-04-28','08:20:00',2.47),('11288','2014-04-28','08:25:00',2.82),('11288','2014-04-28','08:30:00',2.11),('11288','2014-04-28','08:35:00',2.14),('11288','2014-04-28','08:40:00',2.19),('11288','2014-04-28','08:45:00',2.16),('11288','2014-04-28','08:50:00',2.28),('11288','2014-04-28','08:55:00',1.97),('11288','2014-04-28','09:00:00',1.74),('11288','2014-04-28','09:05:00',2.9),('11288','2014-04-28','09:10:00',4.49),('11288','2014-04-28','09:15:00',4.94),('11288','2014-04-28','09:20:00',3.1),('11288','2014-04-28','09:25:00',2.8),('11288','2014-04-28','09:30:00',4.86),('11288','2014-04-28','09:35:00',4.41),('11288','2014-04-28','09:40:00',2.91),('11288','2014-04-28','09:45:00',2.96),('11288','2014-04-28','09:50:00',2.74),('11288','2014-04-28','09:55:00',2.58),('11288','2014-04-28','10:00:00',4.14),('11288','2014-04-28','10:05:00',4.02),('11288','2014-04-28','10:10:00',4.04),('11288','2014-04-28','10:15:00',3.27),('11288','2014-04-28','10:20:00',2.61),('11288','2014-04-28','10:25:00',1.59),('11288','2014-04-28','10:35:00',1.19),('11288','2014-04-28','10:40:00',2.14),('11288','2014-04-28','10:45:00',3.06),('11288','2014-04-28','10:50:00',3.37),('11288','2014-04-28','10:55:00',3.07),('11288','2014-04-28','11:00:00',3.56),('11288','2014-04-28','11:05:00',4.31),('11288','2014-04-28','11:10:00',4.84),('11288','2014-04-28','11:15:00',4.41),('11288','2014-04-28','11:20:00',3.81),('11288','2014-04-28','11:25:00',3.35),('11288','2014-04-28','11:30:00',3.28),('11288','2014-04-28','11:35:00',2.86),('11288','2014-04-28','11:40:00',2.64),('11288','2014-04-28','11:45:00',3.02),('11288','2014-04-28','11:50:00',3.48),('11288','2014-04-28','11:55:00',3.61),('11288','2014-04-28','12:00:00',3.1),('11288','2014-04-28','12:05:00',2.69),('11288','2014-04-28','12:10:00',3.89),('11288','2014-04-28','12:15:00',4.83),('11288','2014-04-28','12:20:00',4.92),('11288','2014-04-28','12:25:00',4.8),('11288','2014-04-28','12:30:00',4.91),('11288','2014-04-28','12:35:00',4.38),('11288','2014-04-28','12:40:00',3.67),('11288','2014-04-28','12:45:00',3.5),('11288','2014-04-28','12:50:00',3.98),('11288','2014-04-28','12:55:00',3.93),('11288','2014-04-28','13:00:00',4.07),('11288','2014-04-28','13:05:00',6.55),('11288','2014-04-28','13:10:00',4.47),('11288','2014-04-28','13:15:00',3.9),('11288','2014-04-28','13:20:00',4.51),('11288','2014-04-28','13:25:00',5.72),('11288','2014-04-28','13:30:00',8.93),('11288','2014-04-28','13:35:00',5.38),('11288','2014-04-28','13:40:00',3.17),('11288','2014-04-28','13:45:00',7.73),('11288','2014-04-28','13:50:00',6.78),('11288','2014-04-28','13:55:00',3.64),('11288','2014-04-28','14:00:00',3.12),('11288','2014-04-28','14:05:00',6.01),('11288','2014-04-28','14:10:00',6.58),('11288','2014-04-28','14:15:00',4.59),('11288','2014-04-28','14:20:00',7.52),('11288','2014-04-28','14:25:00',5.25),('11288','2014-04-28','14:30:00',5.5),('11288','2014-04-28','14:35:00',3.74),('11288','2014-04-28','14:40:00',5.47),('11288','2014-04-28','14:45:00',4.74),('11288','2014-04-28','14:50:00',5.97),('11288','2014-04-28','14:55:00',4.94),('11288','2014-04-28','15:00:00',6.91),('11288','2014-04-28','15:05:00',6.32),('11288','2014-04-28','15:10:00',2.28),('11288','2014-04-28','15:15:00',2.32),('11288','2014-04-28','15:20:00',2.25),('11288','2014-04-28','15:25:00',3.35),('11288','2014-04-28','15:30:00',3.65),('11288','2014-04-28','15:35:00',7.54),('11288','2014-04-28','15:40:00',5.44),('11288','2014-04-28','15:45:00',5.43),('11288','2014-04-28','15:50:00',2.28),('11288','2014-04-28','15:55:00',2.66),('11288','2014-04-28','16:00:00',4.8),('11288','2014-04-28','16:05:00',4.65),('11288','2014-04-28','16:10:00',6.33),('11288','2014-04-28','16:15:00',4.05),('11288','2014-04-28','16:20:00',3.02),('11288','2014-04-28','16:25:00',3.96),('11288','2014-04-28','16:30:00',5.12),('11288','2014-04-28','16:35:00',4.06),('11288','2014-04-28','16:40:00',1.34),('11288','2014-04-28','16:45:00',1.19),('11288','2014-04-28','16:50:00',1.66),('11288','2014-04-28','16:55:00',2.2),('11288','2014-04-28','17:00:00',1.45),('11288','2014-04-28','17:20:00',1.57),('11288','2014-04-28','17:25:00',1.77),('11288','2014-04-28','17:30:00',1.7),('11288','2014-04-28','17:35:00',2.55),('11288','2014-04-28','17:40:00',2.26),('11288','2014-04-28','17:45:00',1.37),('11288','2014-04-28','17:50:00',1.38),('11288','2014-04-28','17:55:00',1.21),('11288','2014-04-28','18:35:00',1.02),('11288','2014-02-15','08:20:00',1.08),('11288','2014-02-15','08:25:00',1.17),('11288','2014-02-15','08:30:00',1.35),('11288','2014-02-15','08:35:00',1.44),('11288','2014-02-15','08:40:00',1.55),('11288','2014-02-15','08:45:00',1.68),('11288','2014-02-15','08:50:00',1.68),('11288','2014-02-15','08:55:00',1.76),('11288','2014-02-15','09:00:00',1.99),('11288','2014-02-15','09:05:00',1.99),('11288','2014-02-15','09:10:00',2.2),('11288','2014-02-15','09:15:00',2.34),('11288','2014-02-15','09:20:00',2.4),('11288','2014-02-15','09:25:00',2.55),('11288','2014-02-15','09:30:00',2.69),('11288','2014-02-15','09:35:00',2.8),('11288','2014-02-15','09:40:00',2.88),('11288','2014-02-15','09:45:00',3.05),('11288','2014-02-15','09:50:00',3.14),('11288','2014-02-15','09:55:00',3.23),('11288','2014-02-15','10:00:00',3.33),('11288','2014-02-15','10:05:00',3.46),('11288','2014-02-15','10:10:00',3.53),('11288','2014-02-15','10:15:00',3.63),('11288','2014-02-15','10:20:00',3.7),('11288','2014-02-15','10:25:00',3.77),('11288','2014-02-15','10:30:00',3.8),('11288','2014-02-15','10:35:00',3.85),('11288','2014-02-15','10:40:00',3.73),('11288','2014-02-15','10:45:00',4),('11288','2014-02-15','10:50:00',4.1),('11288','2014-02-15','10:55:00',4.15),('11288','2014-02-15','11:00:00',3.95),('11288','2014-02-15','11:05:00',4.41),('11288','2014-02-15','11:10:00',4.38),('11288','2014-02-15','11:15:00',3.95),('11288','2014-02-15','11:20:00',2.41),('11288','2014-02-15','11:25:00',4.86),('11288','2014-02-15','11:30:00',2.75),('11288','2014-02-15','11:35:00',5.09),('11288','2014-02-15','11:40:00',5.77),('11288','2014-02-15','11:45:00',5.21),('11288','2014-02-15','11:50:00',4.44),('11288','2014-02-15','11:55:00',2.7),('11288','2014-02-15','12:00:00',2.25),('11288','2014-02-15','12:05:00',2.47),('11288','2014-02-15','12:10:00',4.6),('11288','2014-02-15','12:15:00',4.77),('11288','2014-02-15','12:20:00',5.23),('11288','2014-02-15','12:25:00',1.81),('11288','2014-02-15','12:30:00',5.04),('11288','2014-02-15','12:35:00',5.66),('11288','2014-02-15','12:40:00',5.58),('11288','2014-02-15','12:45:00',5.34),('11288','2014-02-15','12:50:00',4.66),('11288','2014-02-15','12:55:00',2.72),('11288','2014-02-15','13:00:00',5.27),('11288','2014-02-15','13:05:00',5.4),('11288','2014-02-15','13:10:00',5.25),('11288','2014-02-15','13:15:00',4.71),('11288','2014-02-15','13:20:00',4.83),('11288','2014-02-15','13:25:00',4.69),('11288','2014-02-15','13:30:00',4.59),('11288','2014-02-15','13:35:00',4.51),('11288','2014-02-15','13:40:00',4.48),('11288','2014-02-15','13:45:00',4.35),('11288','2014-02-15','13:50:00',4.37),('11288','2014-02-15','13:55:00',4.21),('11288','2014-02-15','14:00:00',4.17),('11288','2014-02-15','14:05:00',4.14),('11288','2014-02-15','14:10:00',3.97),('11288','2014-02-15','14:15:00',3.94),('11288','2014-02-15','14:20:00',3.83),('11288','2014-02-15','14:25:00',3.73),('11288','2014-02-15','14:30:00',3.67),('11288','2014-02-15','14:35:00',3.55),('11288','2014-02-15','14:40:00',3.42),('11288','2014-02-15','14:45:00',3.37),('11288','2014-02-15','14:50:00',3.25),('11288','2014-02-15','14:55:00',3.04),('11288','2014-02-15','15:00:00',3.11),('11288','2014-02-15','15:05:00',2.97),('11288','2014-02-15','15:10:00',2.88),('11288','2014-02-15','15:15:00',2.75),('11288','2014-02-15','15:20:00',2.64),('11288','2014-02-15','15:25:00',2.52),('11288','2014-02-15','15:30:00',2.39),('11288','2014-02-15','15:35:00',2.28),('11288','2014-02-15','15:40:00',2.15),('11288','2014-02-15','15:45:00',2.01),('11288','2014-02-15','15:50:00',1.88),('11288','2014-02-15','15:55:00',1.67),('11288','2014-02-15','16:00:00',1.62),('11288','2014-02-15','16:05:00',1.5),('11288','2014-02-15','16:10:00',1.38),('11288','2014-02-15','16:15:00',1.22),('11288','2014-02-15','16:20:00',1.14),('11288','2014-02-15','16:25:00',1.04),('11288','2014-02-14','08:45:00',1.01),('11288','2014-02-14','08:50:00',1.8),('11288','2014-02-14','08:55:00',1.91),('11288','2014-02-14','09:00:00',2),('11288','2014-02-14','09:05:00',2.05),('11288','2014-02-14','09:10:00',1.76),('11288','2014-02-14','09:15:00',1.95),('11288','2014-02-14','09:20:00',1.54),('11288','2014-02-14','09:25:00',1.76),('11288','2014-02-14','09:30:00',2.67),('11288','2014-02-14','09:35:00',2.43),('11288','2014-02-14','09:40:00',1.72),('11288','2014-02-14','09:45:00',1.48),('11288','2014-02-14','09:50:00',3.53),('11288','2014-02-14','09:55:00',3.27),('11288','2014-02-14','10:00:00',2.94),('11288','2014-02-14','10:05:00',3.66),('11288','2014-02-14','10:10:00',3.38),('11288','2014-02-14','10:15:00',2.62),('11288','2014-02-14','10:20:00',4.02),('11288','2014-02-14','10:25:00',4.05),('11288','2014-02-14','10:30:00',4.11),('11288','2014-02-14','10:35:00',4),('11288','2014-02-14','10:40:00',4.11),('11288','2014-02-14','10:45:00',4.28),('11288','2014-02-14','10:50:00',4.45),('11288','2014-02-14','10:55:00',4.45),('11288','2014-02-14','11:00:00',4.44),('11288','2014-02-14','11:05:00',4.51),('11288','2014-02-14','11:10:00',4.29),('11288','2014-02-14','11:15:00',4.18),('11288','2014-02-14','11:20:00',4.63),('11288','2014-02-14','11:25:00',4.83),('11288','2014-02-14','11:30:00',4.87),('11288','2014-02-14','11:35:00',4.81),('11288','2014-02-14','11:40:00',4.93),('11288','2014-02-14','11:45:00',4.84),('11288','2014-02-14','11:50:00',4.85),('11288','2014-02-14','11:55:00',4.98),('11288','2014-02-14','12:00:00',4.68),('11288','2014-02-14','12:05:00',4.7),('11288','2014-02-14','12:10:00',5.08),('11288','2014-02-14','12:15:00',5.04),('11288','2014-02-14','12:20:00',4.96),('11288','2014-02-14','12:25:00',5),('11288','2014-02-14','12:30:00',5),('11288','2014-02-14','12:35:00',4.98),('11288','2014-02-14','12:40:00',4.95),('11288','2014-02-14','12:45:00',4.9),('11288','2014-02-14','12:50:00',4.82),('11288','2014-02-14','12:55:00',4.84),('11288','2014-02-14','13:00:00',4.85),('11288','2014-02-14','13:05:00',4.83),('11288','2014-02-14','13:10:00',4.82),('11288','2014-02-14','13:15:00',4.75),('11288','2014-02-14','13:20:00',4.66),('11288','2014-02-14','13:25:00',4.68),('11288','2014-02-14','13:30:00',4.59),('11288','2014-02-14','13:35:00',4.58),('11288','2014-02-14','13:40:00',4.52),('11288','2014-02-14','13:45:00',4.44),('11288','2014-02-14','13:50:00',4.35),('11288','2014-02-14','13:55:00',4.32),('11288','2014-02-14','14:00:00',4.27),('11288','2014-02-14','14:05:00',4.2),('11288','2014-02-14','14:10:00',4.08),('11288','2014-02-14','14:15:00',3.97),('11288','2014-02-14','14:20:00',3.92),('11288','2014-02-14','14:25:00',3.84),('11288','2014-02-14','14:30:00',3.75),('11288','2014-02-14','14:35:00',3.61),('11288','2014-02-14','14:40:00',3.55),('11288','2014-02-14','14:45:00',3.43),('11288','2014-02-14','14:50:00',3.32),('11288','2014-02-14','14:55:00',3.22),('11288','2014-02-14','15:00:00',3.09),('11288','2014-02-14','15:05:00',2.95),('11288','2014-02-14','15:10:00',2.88),('11288','2014-02-14','15:15:00',2.78),('11288','2014-02-14','15:20:00',2.65),('11288','2014-02-14','15:25:00',2.53),('11288','2014-02-14','15:30:00',2.38),('11288','2014-02-14','15:35:00',2.16),('11288','2014-02-14','15:40:00',2.13),('11288','2014-02-14','15:45:00',1.97),('11288','2014-02-14','15:50:00',1.84),('11288','2014-02-14','15:55:00',1.62),('11288','2014-02-14','16:00:00',1.59),('11288','2014-02-14','16:05:00',1.48),('11288','2014-02-14','16:10:00',1.31),('11288','2014-02-14','16:15:00',1.2),('11288','2014-02-14','16:20:00',1.05),('11288','2014-02-13','08:15:00',1.04),('11288','2014-02-13','08:20:00',1.15),('11288','2014-02-13','08:25:00',1.14),('11288','2014-02-13','08:30:00',1.33),('11288','2014-02-13','08:35:00',1.41),('11288','2014-02-13','08:40:00',1.55),('11288','2014-02-13','08:45:00',1.67),('11288','2014-02-13','08:50:00',1.78),('11288','2014-02-13','08:55:00',1.87),('11288','2014-02-13','09:00:00',2.01),('11288','2014-02-13','09:05:00',2.16),('11288','2014-02-13','09:10:00',2.13),('11288','2014-02-13','09:15:00',2.3),('11288','2014-02-13','09:20:00',2.44),('11288','2014-02-13','09:25:00',2.59),('11288','2014-02-13','09:30:00',2.71),('11288','2014-02-13','09:35:00',2.85),('11288','2014-02-13','09:40:00',2.9),('11288','2014-02-13','09:45:00',2.95),('11288','2014-02-13','09:50:00',3.14),('11288','2014-02-13','09:55:00',3.28),('11288','2014-02-13','10:00:00',3.41),('11288','2014-02-13','10:05:00',3.49),('11288','2014-02-13','10:10:00',3.57),('11288','2014-02-13','10:15:00',3.51),('11288','2014-02-13','10:20:00',3.74),('11288','2014-02-13','10:25:00',3.84),('11288','2014-02-13','10:30:00',3.94),('11288','2014-02-13','10:35:00',3.98),('11288','2014-02-13','10:40:00',3.8),('11288','2014-02-13','10:45:00',4.07),('11288','2014-02-13','10:50:00',4.19),('11288','2014-02-13','10:55:00',4.24),('11288','2014-02-13','11:00:00',4.27),('11288','2014-02-13','11:05:00',4.34),('11288','2014-02-13','11:10:00',4.18),('11288','2014-02-13','11:15:00',4.22),('11288','2014-02-13','11:20:00',4.76),('11288','2014-02-13','11:25:00',4.82),('11288','2014-02-13','11:30:00',3.74),('11288','2014-02-13','11:35:00',2.88),('11288','2014-02-13','11:40:00',3.92),('11288','2014-02-13','11:45:00',4.65),('11288','2014-02-13','11:50:00',4.74),('11288','2014-02-13','11:55:00',4.29),('11288','2014-02-13','12:00:00',2.95),('11288','2014-02-13','12:05:00',3.42),('11288','2014-02-13','12:10:00',3.05),('11288','2014-02-13','12:15:00',3.56),('11288','2014-02-13','12:20:00',3.21),('11288','2014-02-13','12:25:00',5.26),('11288','2014-02-13','12:30:00',5.88),('11288','2014-02-13','12:35:00',5.66),('11288','2014-02-13','12:40:00',2.24),('11288','2014-02-13','12:45:00',3.18),('11288','2014-02-13','12:50:00',3.95),('11288','2014-02-13','12:55:00',4.94),('11288','2014-02-13','13:00:00',5.06),('11288','2014-02-13','13:05:00',4.94),('11288','2014-02-13','13:10:00',4.84),('11288','2014-02-13','13:15:00',4.81),('11288','2014-02-13','13:20:00',4.73),('11288','2014-02-13','13:25:00',4.72),('11288','2014-02-13','13:30:00',4.68),('11288','2014-02-13','13:35:00',4.6),('11288','2014-02-13','13:40:00',4.53),('11288','2014-02-13','13:45:00',4.49),('11288','2014-02-13','13:50:00',4.43),('11288','2014-02-13','13:55:00',4.37),('11288','2014-02-13','14:00:00',4.33),('11288','2014-02-13','14:05:00',4.27),('11288','2014-02-13','14:10:00',4.14),('11288','2014-02-13','14:15:00',4.05),('11288','2014-02-13','14:20:00',3.98),('11288','2014-02-13','14:25:00',3.9),('11288','2014-02-13','14:30:00',3.8),('11288','2014-02-13','14:35:00',3.74),('11288','2014-02-13','14:40:00',1.86),('11288','2014-02-13','14:45:00',2.52),('11288','2014-02-13','14:50:00',3.54),('11288','2014-02-13','14:55:00',3.58),('11288','2014-02-13','15:00:00',2.33),('11288','2014-02-13','15:05:00',3.15),('11288','2014-02-13','15:10:00',2.82),('11288','2014-02-13','15:15:00',2.46),('11288','2014-02-13','15:20:00',2.72),('11288','2014-02-13','15:25:00',1.92),('11288','2014-02-13','15:30:00',1.82),('11288','2014-02-13','15:35:00',1.51),('11288','2014-02-13','15:40:00',2.06),('11288','2014-02-13','15:45:00',1.68),('11288','2014-02-13','15:50:00',1.19),('11288','2014-02-13','16:00:00',1.13),('11288','2014-02-13','16:05:00',1.44),('11288','2014-02-13','16:10:00',1.62),('11288','2014-02-12','08:45:00',1.03),('11288','2014-02-12','08:50:00',1.54),('11288','2014-02-12','08:55:00',1.38),('11288','2014-02-12','09:10:00',1.93),('11288','2014-02-12','09:15:00',2.35),('11288','2014-02-12','09:20:00',2.2),('11288','2014-02-12','09:25:00',1.92),('11288','2014-02-12','09:30:00',1.18),('11288','2014-02-12','09:35:00',1.18),('11288','2014-02-12','09:40:00',2.13),('11288','2014-02-12','09:45:00',2.48),('11288','2014-02-12','09:50:00',2.87),('11288','2014-02-12','09:55:00',1.65),('11288','2014-02-12','10:00:00',1.83),('11288','2014-02-12','10:05:00',2.59),('11288','2014-02-12','10:10:00',2.35),('11288','2014-02-12','10:15:00',1.96),('11288','2014-02-12','10:20:00',1.87),('11288','2014-02-12','10:25:00',1.98),('11288','2014-02-12','10:30:00',2.43),('11288','2014-02-12','10:35:00',2.57),('11288','2014-02-12','10:40:00',2.35),('11288','2014-02-12','10:45:00',3.02),('11288','2014-02-12','10:50:00',2.33),('11288','2014-02-12','10:55:00',2.38),('11288','2014-02-12','11:00:00',2.55),('11288','2014-02-12','11:05:00',3.47),('11288','2014-02-12','11:10:00',2.58),('11288','2014-02-12','11:15:00',2.42),('11288','2014-02-12','11:20:00',2.35),('11288','2014-02-12','11:25:00',2.47),('11288','2014-02-12','11:30:00',2.51),('11288','2014-02-12','11:35:00',2.81),('11288','2014-02-12','11:40:00',1.82),('11288','2014-02-12','11:45:00',1.47),('11288','2014-02-12','11:50:00',1.33),('11288','2014-02-12','11:55:00',1.2),('11288','2014-02-12','12:00:00',1.27),('11288','2014-02-12','12:05:00',1.63),('11288','2014-02-12','12:10:00',2.13),('11288','2014-02-12','12:15:00',2.29),('11288','2014-02-12','12:20:00',2.33),('11288','2014-02-12','12:25:00',2.42),('11288','2014-02-12','12:30:00',2.52),('11288','2014-02-12','12:35:00',2.43),('11288','2014-02-12','12:40:00',2.4),('11288','2014-02-12','12:45:00',2.66),('11288','2014-02-12','12:50:00',2.9),('11288','2014-02-12','12:55:00',2.96),('11288','2014-02-12','13:00:00',3.16),('11288','2014-02-12','13:05:00',2.98),('11288','2014-02-12','13:10:00',2.66),('11288','2014-02-12','13:15:00',2.22),('11288','2014-02-12','13:20:00',2.19),('11288','2014-02-12','13:25:00',2.54),('11288','2014-02-12','13:30:00',4.09),('11288','2014-02-12','13:35:00',4.43),('11288','2014-02-12','13:40:00',4.21),('11288','2014-02-12','13:45:00',3.57),('11288','2014-02-12','13:50:00',3.71),('11288','2014-02-12','13:55:00',2.87),('11288','2014-02-12','14:00:00',4.54),('11288','2014-02-12','14:05:00',4.76),('11288','2014-02-12','14:10:00',4.53),('11288','2014-02-12','14:15:00',4.34),('11288','2014-02-12','14:20:00',3.85),('11288','2014-02-12','14:25:00',2.52),('11288','2014-02-12','14:30:00',3.02),('11288','2014-02-12','14:35:00',3.32),('11288','2014-02-12','14:40:00',2.92),('11288','2014-02-12','14:45:00',4.03),('11288','2014-02-12','14:50:00',3.8),('11288','2014-02-12','14:55:00',3.11),('11288','2014-02-12','15:00:00',2.29),('11288','2014-02-12','15:05:00',1.37),('11288','2014-02-12','15:10:00',2.17),('11288','2014-02-12','15:15:00',2.52),('11288','2014-02-12','15:20:00',2.61),('11288','2014-02-12','15:25:00',1.73),('11288','2014-02-12','15:30:00',2.56),('11288','2014-02-12','15:35:00',2.88),('11288','2014-02-12','15:40:00',2.77),('11288','2014-02-12','15:45:00',1.58),('11288','2014-02-12','15:50:00',2.03),('11288','2014-02-12','15:55:00',1.36),('11288','2014-02-12','16:00:00',1.11),('11288','2014-02-11','09:00:00',1.14),('11288','2014-02-11','09:05:00',1.21),('11288','2014-02-11','09:10:00',1.18),('11288','2014-02-11','09:15:00',1.4),('11288','2014-02-11','09:20:00',1.84),('11288','2014-02-11','09:25:00',2.02),('11288','2014-02-11','09:30:00',2.04),('11288','2014-02-11','09:35:00',2.1),('11288','2014-02-11','09:40:00',2.02),('11288','2014-02-11','09:45:00',2.03),('11288','2014-02-11','09:50:00',2.09),('11288','2014-02-11','09:55:00',2.06),('11288','2014-02-11','10:00:00',1.87),('11288','2014-02-11','10:05:00',1.59),('11288','2014-02-11','10:15:00',2.46),('11288','2014-02-11','10:20:00',2.94),('11288','2014-02-11','10:25:00',3.02),('11288','2014-02-11','10:30:00',3.27),('11288','2014-02-11','10:35:00',2.85),('11288','2014-02-11','10:40:00',3.42),('11288','2014-02-11','10:45:00',3.37),('11288','2014-02-11','10:50:00',3.67),('11288','2014-02-11','10:55:00',2.81),('11288','2014-02-11','11:00:00',3.49),('11288','2014-02-11','11:05:00',3.23),('11288','2014-02-11','11:10:00',3.3),('11288','2014-02-11','11:15:00',2.87),('11288','2014-02-11','11:20:00',2.67),('11288','2014-02-11','11:25:00',2.58),('11288','2014-02-11','11:30:00',3.08),('11288','2014-02-11','11:35:00',2.81),('11288','2014-02-11','11:40:00',2.82),('11288','2014-02-11','11:45:00',3.41),('11288','2014-02-11','11:50:00',2.63),('11288','2014-02-11','11:55:00',2.02),('11288','2014-02-11','12:00:00',2.28),('11288','2014-02-11','12:05:00',2.96),('11288','2014-02-11','12:10:00',3.12),('11288','2014-02-11','12:15:00',2.77),('11288','2014-02-11','12:20:00',2.91),('11288','2014-02-11','12:25:00',3.71),('11288','2014-02-11','12:30:00',3.55),('11288','2014-02-11','12:35:00',3.22),('11288','2014-02-11','12:40:00',2.5),('11288','2014-02-11','12:45:00',2.89),('11288','2014-02-11','12:50:00',2.38),('11288','2014-02-11','12:55:00',2.88),('11288','2014-02-11','13:00:00',2.95),('11288','2014-02-11','13:05:00',3.56),('11288','2014-02-11','13:10:00',4.39),('11288','2014-02-11','13:15:00',4.19),('11288','2014-02-11','13:20:00',4.67),('11288','2014-02-11','13:25:00',4.21),('11288','2014-02-11','13:30:00',3.91),('11288','2014-02-11','13:35:00',3.64),('11288','2014-02-11','13:40:00',4.28),('11288','2014-02-11','13:45:00',3.18),('11288','2014-02-11','13:50:00',2.66),('11288','2014-02-11','13:55:00',2.3),('11288','2014-02-11','14:00:00',2.96),('11288','2014-02-11','14:05:00',3.3),('11288','2014-02-11','14:10:00',2.53),('11288','2014-02-11','14:15:00',3.21),('11288','2014-02-11','14:20:00',2.45),('11288','2014-02-11','14:25:00',2.3),('11288','2014-02-11','14:30:00',2.38),('11288','2014-02-11','14:35:00',2.27),('11288','2014-02-11','14:40:00',1.91),('11288','2014-02-11','14:45:00',1.93),('11288','2014-02-11','14:50:00',1.58),('11288','2014-02-11','14:55:00',1.59),('11288','2014-02-11','15:00:00',1.56),('11288','2014-02-11','15:05:00',1.62),('11288','2014-02-11','15:10:00',1.67),('11288','2014-02-11','15:15:00',2.14),('11288','2014-02-11','15:20:00',2.26),('11288','2014-02-11','15:25:00',1.84),('11288','2014-02-11','15:30:00',1.43),('11288','2014-02-11','15:35:00',1.43),('11288','2014-02-11','15:40:00',1.37),('11288','2014-02-11','15:45:00',1.14),('11288','2014-02-11','15:50:00',1.01),('11288','2014-02-11','15:55:00',1.02),('11288','2014-02-11','16:00:00',1.16),('11288','2014-02-11','16:05:00',1.43),('11288','2014-02-11','16:10:00',1.39),('11288','2014-02-11','16:15:00',1.25),('11288','2014-02-11','16:20:00',1.21),('11288','2014-02-11','16:25:00',1.35),('11288','2014-02-11','16:30:00',1.31),('11288','2014-02-11','16:35:00',1.14),('11288','2014-02-11','16:40:00',1.03),('11288','2014-02-10','10:30:00',1.02),('11288','2014-02-10','12:25:00',1.63),('11288','2014-02-10','12:30:00',1.3),('11288','2014-02-10','12:35:00',1.07),('11288','2014-02-10','12:50:00',1.21),('11288','2014-02-10','12:55:00',1.78),('11288','2014-02-10','13:00:00',2.28),('11288','2014-02-10','13:05:00',1.91),('11288','2014-02-10','13:10:00',1.47),('11288','2014-02-10','13:15:00',1.44),('11288','2014-02-10','13:20:00',1.31),('11288','2014-02-10','13:25:00',1.21),('11288','2014-02-10','13:30:00',1.4),('11288','2014-02-10','13:35:00',1.55),('11288','2014-02-10','13:40:00',1.54),('11288','2014-02-10','13:45:00',1.53),('11288','2014-02-10','13:50:00',1.47),('11288','2014-02-10','13:55:00',1.7),('11288','2014-02-10','14:00:00',1.76),('11288','2014-02-10','14:05:00',1.54),('11288','2014-02-10','14:10:00',1.49),('11288','2014-02-10','14:15:00',1.52),('11288','2014-02-10','14:20:00',1.56),('11288','2014-02-10','14:25:00',1.63),('11288','2014-02-10','14:30:00',1.76),('11288','2014-02-10','14:35:00',1.88),('11288','2014-02-10','14:40:00',1.95),('11288','2014-02-10','14:45:00',1.75),('11288','2014-02-10','14:50:00',1.49),('11288','2014-02-10','14:55:00',1.33),('11288','2014-02-10','15:00:00',1.31),('11288','2014-02-10','15:05:00',1.42),('11288','2014-02-10','15:10:00',1.35),('11288','2014-02-10','15:15:00',1.31),('11288','2014-02-10','15:20:00',1.33),('11288','2014-02-10','15:25:00',1.43),('11288','2014-02-10','15:30:00',1.34),('11288','2014-02-10','15:35:00',1.09),('11288','2014-02-09','11:00:00',1.34),('11288','2014-02-09','11:05:00',1.19),('11288','2014-02-09','11:15:00',1.06),('11288','2014-02-09','11:20:00',1.21),('11288','2014-02-09','11:25:00',1.81),('11288','2014-02-09','11:30:00',2),('11288','2014-02-09','11:35:00',2.47),('11288','2014-02-09','11:40:00',1.32),('11288','2014-02-09','11:55:00',1.04),('11288','2014-02-09','12:15:00',1.65),('11288','2014-02-09','12:20:00',1.61),('11288','2014-02-09','12:25:00',2.61),('11288','2014-02-09','12:30:00',2.48),('11288','2014-02-09','12:35:00',1.56),('11288','2014-02-09','12:40:00',1.53),('11288','2014-02-09','12:45:00',3.58),('11288','2014-02-09','12:50:00',1.16),('11288','2014-02-09','12:55:00',3.27),('11288','2014-02-09','13:00:00',3.08),('11288','2014-02-09','13:05:00',4.76),('11288','2014-02-09','13:10:00',3.15),('11288','2014-02-09','13:15:00',2.24),('11288','2014-02-09','13:20:00',1.2),('11288','2014-02-09','13:25:00',1.81),('11288','2014-02-09','13:30:00',1.46),('11288','2014-02-09','13:35:00',1.43),('11288','2014-02-09','13:40:00',2.21),('11288','2014-02-09','13:45:00',3.51),('11288','2014-02-09','13:50:00',2.21),('11288','2014-02-09','13:55:00',3.38),('11288','2014-02-09','14:00:00',2.45),('11288','2014-02-09','14:05:00',4.04),('11288','2014-02-09','14:10:00',3.13),('11288','2014-02-09','14:15:00',1.9),('11288','2014-02-09','14:20:00',1.66),('11288','2014-02-09','14:25:00',2.33),('11288','2014-02-09','14:30:00',2.97),('11288','2014-02-09','14:35:00',2.77),('11288','2014-02-09','14:40:00',1.96),('11288','2014-02-09','14:45:00',1.46),('11288','2014-02-09','14:50:00',2.81),('11288','2014-02-09','14:55:00',1.42),('11288','2014-02-09','15:00:00',1.35),('11288','2014-02-09','15:10:00',1.27),('11288','2014-02-09','15:15:00',2.18),('11288','2014-02-09','15:20:00',2.12),('11288','2014-02-09','15:25:00',2.06),('11288','2014-02-09','15:30:00',1.23),('11288','2014-02-09','15:35:00',1.51),('11288','2014-02-09','15:40:00',1.15),('11288','2014-02-09','15:45:00',1.42),('11288','2014-02-09','15:50:00',1.46),('11288','2014-02-09','15:55:00',1.3),('11288','2014-02-09','16:05:00',1.12),('11288','2014-02-09','16:10:00',1.06),('11288','2014-02-08','09:40:00',1.09),('11288','2014-02-08','09:45:00',1.71),('11288','2014-02-08','09:50:00',3.04),('11288','2014-02-08','09:55:00',1.28),('11288','2014-02-08','10:00:00',1.04),('11288','2014-02-08','10:05:00',1.23),('11288','2014-02-08','10:10:00',1.21),('11288','2014-02-08','10:15:00',1.9),('11288','2014-02-08','10:20:00',1.73),('11288','2014-02-08','10:25:00',1.84),('11288','2014-02-08','10:30:00',3.36),('11288','2014-02-08','10:35:00',3.47),('11288','2014-02-08','10:40:00',1.48),('11288','2014-02-08','10:45:00',2.09),('11288','2014-02-08','10:50:00',2.72),('11288','2014-02-08','10:55:00',2.81),('11288','2014-02-08','11:00:00',2.71),('11288','2014-02-08','11:05:00',3.56),('11288','2014-02-08','11:10:00',3.03),('11288','2014-02-08','11:15:00',3.07),('11288','2014-02-08','11:20:00',1.69),('11288','2014-02-08','11:25:00',1.24),('11288','2014-02-08','11:30:00',3.29),('11288','2014-02-08','11:35:00',5.98),('11288','2014-02-08','11:40:00',2.43),('11288','2014-02-08','11:45:00',1.21),('11288','2014-02-08','11:50:00',3.11),('11288','2014-02-08','11:55:00',4.85),('11288','2014-02-08','12:00:00',1.19),('11288','2014-02-08','12:05:00',1.66),('11288','2014-02-08','12:10:00',3.86),('11288','2014-02-08','12:15:00',4.7),('11288','2014-02-08','12:20:00',1.54),('11288','2014-02-08','12:25:00',4.07),('11288','2014-02-08','12:30:00',4.72),('11288','2014-02-08','12:35:00',3.36),('11288','2014-02-08','12:40:00',3.19),('11288','2014-02-08','12:45:00',4.71),('11288','2014-02-08','12:50:00',3.38),('11288','2014-02-08','12:55:00',3),('11288','2014-02-08','13:00:00',3.76),('11288','2014-02-08','13:05:00',1.72),('11288','2014-02-08','13:10:00',3.63),('11288','2014-02-08','13:15:00',5.74),('11288','2014-02-08','13:20:00',5.39),('11288','2014-02-08','13:25:00',4.55),('11288','2014-02-08','13:30:00',3.42),('11288','2014-02-08','13:35:00',3.09),('11288','2014-02-08','13:40:00',3.54),('11288','2014-02-08','13:45:00',4.78),('11288','2014-02-08','13:50:00',3.66),('11288','2014-02-08','13:55:00',4.34),('11288','2014-02-08','14:00:00',4.3),('11288','2014-02-08','14:05:00',4.3),('11288','2014-02-08','14:10:00',4.18),('11288','2014-02-08','14:15:00',1.48),('11288','2014-02-08','14:20:00',3.54),('11288','2014-02-08','14:25:00',2.36),('11288','2014-02-08','14:30:00',3.9),('11288','2014-02-08','14:35:00',2.43),('11288','2014-02-08','14:40:00',2.25),('11288','2014-02-08','14:45:00',1.68),('11288','2014-02-08','14:50:00',3.15),('11288','2014-02-08','14:55:00',2.12),('11288','2014-02-08','15:00:00',1.08),('11288','2014-02-08','15:10:00',1.24),('11288','2014-02-08','15:15:00',2.12),('11288','2014-02-08','15:20:00',2.77),('11288','2014-02-08','15:35:00',1.13),('11288','2014-02-08','15:40:00',2.45),('11288','2014-02-08','15:45:00',2.03),('11288','2014-02-08','15:50:00',1.77),('11288','2014-02-08','15:55:00',1.2),('11288','2014-02-07','08:30:00',1.1),('11288','2014-02-07','08:35:00',1.15),('11288','2014-02-07','08:40:00',1.38),('11288','2014-02-07','08:45:00',1.51),('11288','2014-02-07','08:50:00',1.61),('11288','2014-02-07','08:55:00',1.7),('11288','2014-02-07','09:00:00',1.77),('11288','2014-02-07','09:05:00',1.89),('11288','2014-02-07','09:10:00',1.98),('11288','2014-02-07','09:15:00',2.03),('11288','2014-02-07','09:20:00',2.16),('11288','2014-02-07','09:25:00',2.37),('11288','2014-02-07','09:30:00',2.43),('11288','2014-02-07','09:35:00',2.49),('11288','2014-02-07','09:40:00',2.58),('11288','2014-02-07','09:45:00',2.75),('11288','2014-02-07','09:50:00',2.73),('11288','2014-02-07','09:55:00',2.96),('11288','2014-02-07','10:00:00',3),('11288','2014-02-07','10:05:00',2.94),('11288','2014-02-07','10:10:00',3.26),('11288','2014-02-07','10:15:00',3.51),('11288','2014-02-07','10:20:00',3.63),('11288','2014-02-07','10:25:00',3.13),('11288','2014-02-07','10:30:00',3.7),('11288','2014-02-07','10:35:00',4.09),('11288','2014-02-07','10:40:00',2.35),('11288','2014-02-07','10:45:00',3.53),('11288','2014-02-07','10:50:00',3.45),('11288','2014-02-07','10:55:00',3.51),('11288','2014-02-07','11:00:00',3.63),('11288','2014-02-07','11:05:00',4.43),('11288','2014-02-07','11:10:00',4.85),('11288','2014-02-07','11:15:00',4.93),('11288','2014-02-07','11:20:00',4.36),('11288','2014-02-07','11:25:00',3.69),('11288','2014-02-07','11:30:00',4.44),('11288','2014-02-07','11:35:00',4.62),('11288','2014-02-07','11:40:00',4.89),('11288','2014-02-07','11:45:00',3.54),('11288','2014-02-07','11:50:00',5.09),('11288','2014-02-07','11:55:00',3.89),('11288','2014-02-07','12:00:00',3.67),('11288','2014-02-07','12:05:00',2.88),('11288','2014-02-07','12:10:00',3.48),('11288','2014-02-07','12:15:00',5.64),('11288','2014-02-07','12:20:00',4.2),('11288','2014-02-07','12:25:00',2.32),('11288','2014-02-07','12:30:00',2.54),('11288','2014-02-07','12:35:00',1.84),('11288','2014-02-07','12:40:00',2.7),('11288','2014-02-07','12:45:00',2.9),('11288','2014-02-07','12:50:00',5.5),('11288','2014-02-07','12:55:00',3.74),('11288','2014-02-07','13:00:00',2.03),('11288','2014-02-07','13:05:00',4.25),('11288','2014-02-07','13:10:00',4.45),('11288','2014-02-07','13:15:00',2.7),('11288','2014-02-07','13:20:00',2.89),('11288','2014-02-07','13:25:00',1.78),('11288','2014-02-07','13:30:00',2.66),('11288','2014-02-07','13:35:00',2.84),('11288','2014-02-07','13:40:00',1.65),('11288','2014-02-07','13:45:00',4.3),('11288','2014-02-07','13:50:00',4.24),('11288','2014-02-07','13:55:00',4.55),('11288','2014-02-07','14:00:00',2.83),('11288','2014-02-07','14:05:00',3.71),('11288','2014-02-07','14:10:00',4.22),('11288','2014-02-07','14:15:00',4.19),('11288','2014-02-07','14:20:00',3.09),('11288','2014-02-07','14:25:00',2.95),('11288','2014-02-07','14:30:00',3.24),('11288','2014-02-07','14:35:00',3.6),('11288','2014-02-07','14:40:00',3.57),('11288','2014-02-07','14:45:00',3.45),('11288','2014-02-07','14:50:00',3.32),('11288','2014-02-07','14:55:00',3.16),('11288','2014-02-07','15:00:00',2.97),('11288','2014-02-07','15:05:00',2.83),('11288','2014-02-07','15:10:00',2.71),('11288','2014-02-07','15:15:00',2.56),('11288','2014-02-07','15:20:00',2.54),('11288','2014-02-07','15:25:00',2.18),('11288','2014-02-07','15:30:00',2.19),('11288','2014-02-07','15:35:00',2.07),('11288','2014-02-07','15:40:00',1.93),('11288','2014-02-07','15:45:00',1.8),('11288','2014-02-07','15:50:00',1.64),('11288','2014-02-07','15:55:00',1.5),('11288','2014-02-07','16:00:00',1.33),('11288','2014-02-07','16:05:00',1.15),('11288','2014-02-07','16:10:00',1.11),('11288','2014-02-07','16:15:00',1.03),('11288','2014-02-06','08:40:00',1.26),('11288','2014-02-06','08:45:00',1.49),('11288','2014-02-06','08:50:00',1.72),('11288','2014-02-06','08:55:00',2.02),('11288','2014-02-06','09:00:00',2.45),('11288','2014-02-06','09:05:00',2.7),('11288','2014-02-06','09:10:00',2.47),('11288','2014-02-06','09:15:00',2.15),('11288','2014-02-06','09:20:00',1.03),('11288','2014-02-06','09:30:00',1.73),('11288','2014-02-06','09:35:00',2.35),('11288','2014-02-06','09:40:00',2.64),('11288','2014-02-06','09:45:00',2.77),('11288','2014-02-06','09:50:00',2.74),('11288','2014-02-06','09:55:00',3),('11288','2014-02-06','10:00:00',3.03),('11288','2014-02-06','10:05:00',3.02),('11288','2014-02-06','10:10:00',3.25),('11288','2014-02-06','10:15:00',3.43),('11288','2014-02-06','10:20:00',3.53),('11288','2014-02-06','10:25:00',3.54),('11288','2014-02-06','10:30:00',3.45),('11288','2014-02-06','10:35:00',3.03),('11288','2014-02-06','10:40:00',3.45),('11288','2014-02-06','10:45:00',2.73),('11288','2014-02-06','10:50:00',2.64),('11288','2014-02-06','10:55:00',2.5),('11288','2014-02-06','11:00:00',1.08),('11288','2014-02-06','11:05:00',2.87),('11288','2014-02-06','11:10:00',2.27),('11288','2014-02-06','11:15:00',2.34),('11288','2014-02-06','11:20:00',4.9),('11288','2014-02-06','11:25:00',2.94),('11288','2014-02-06','11:30:00',5.18),('11288','2014-02-06','11:35:00',4.75),('11288','2014-02-06','11:40:00',4.62),('11288','2014-02-06','11:45:00',4.47),('11288','2014-02-06','11:50:00',4.15),('11288','2014-02-06','11:55:00',4.65),('11288','2014-02-06','12:00:00',4.82),('11288','2014-02-06','12:05:00',4.9),('11288','2014-02-06','12:10:00',4.86),('11288','2014-02-06','12:15:00',4.9),('11288','2014-02-06','12:20:00',4.81),('11288','2014-02-06','12:25:00',4.81),('11288','2014-02-06','12:30:00',4.8),('11288','2014-02-06','12:35:00',4.48),('11288','2014-02-06','12:40:00',4.7),('11288','2014-02-06','12:45:00',4.82),('11288','2014-02-06','12:50:00',4.7),('11288','2014-02-06','12:55:00',4.7),('11288','2014-02-06','13:00:00',4.71),('11288','2014-02-06','13:05:00',4.15),('11288','2014-02-06','13:10:00',4.82),('11288','2014-02-06','13:15:00',4.68),('11288','2014-02-06','13:20:00',4.62),('11288','2014-02-06','13:25:00',3.06),('11288','2014-02-06','13:30:00',4.46),('11288','2014-02-06','13:35:00',4.62),('11288','2014-02-06','13:40:00',4.3),('11288','2014-02-06','13:45:00',4.3),('11288','2014-02-06','13:50:00',4.35),('11288','2014-02-06','13:55:00',4.25),('11288','2014-02-06','14:00:00',4.05),('11288','2014-02-06','14:05:00',4.12),('11288','2014-02-06','14:10:00',3.95),('11288','2014-02-06','14:15:00',3.79),('11288','2014-02-06','14:20:00',3.74),('11288','2014-02-06','14:25:00',3.76),('11288','2014-02-06','14:30:00',3.71),('11288','2014-02-06','14:35:00',3.23),('11288','2014-02-06','14:40:00',3.16),('11288','2014-02-06','14:45:00',2.19),('11288','2014-02-06','14:50:00',2.79),('11288','2014-02-06','14:55:00',2.52),('11288','2014-02-06','15:00:00',2.92),('11288','2014-02-06','15:05:00',2.83),('11288','2014-02-06','15:10:00',2.7),('11288','2014-02-06','15:15:00',2.57),('11288','2014-02-06','15:20:00',2.52),('11288','2014-02-06','15:25:00',2.27),('11288','2014-02-06','15:30:00',2.12),('11288','2014-02-06','15:35:00',2),('11288','2014-02-06','15:40:00',1.81),('11288','2014-02-06','15:45:00',1.69),('11288','2014-02-06','15:50:00',1.58),('11288','2014-02-06','15:55:00',1.43),('11288','2014-02-06','16:00:00',1.28),('11288','2014-02-06','16:05:00',1.13),('11288','2014-02-06','16:10:00',1.08),('11288','2014-04-27','08:45:00',1.01),('11288','2014-04-27','08:50:00',1.62),('11288','2014-04-27','08:55:00',1.71),('11288','2014-04-27','09:10:00',1.17),('11288','2014-04-27','09:15:00',1.6),('11288','2014-04-27','09:20:00',1.59),('11288','2014-04-27','09:25:00',1.21),('11288','2014-04-27','09:30:00',1.06),('11288','2014-04-27','09:40:00',1.26),('11288','2014-04-27','09:45:00',1.33),('11288','2014-04-27','09:50:00',1.15),('11288','2014-04-27','09:55:00',1.56),('11288','2014-04-27','10:00:00',2.14),('11288','2014-04-27','10:05:00',2.29),('11288','2014-04-27','10:10:00',2.07),('11288','2014-04-27','10:15:00',2.12),('11288','2014-04-27','10:20:00',2.01),('11288','2014-04-27','10:25:00',1.77),('11288','2014-04-27','10:30:00',1.12),('11288','2014-04-27','10:55:00',1.42),('11288','2014-04-27','11:00:00',1.78),('11288','2014-04-27','11:05:00',2.13),('11288','2014-04-27','11:10:00',2.14),('11288','2014-04-27','11:15:00',2.2),('11288','2014-04-27','11:20:00',1.58),('11288','2014-04-27','11:25:00',1.18),('11288','2014-04-27','11:30:00',1.74),('11288','2014-04-27','11:35:00',2.6),('11288','2014-04-27','11:40:00',3.09),('11288','2014-04-27','11:45:00',6.67),('11288','2014-04-27','11:50:00',5.73),('11288','2014-04-27','11:55:00',4.89),('11288','2014-04-27','12:00:00',4.4),('11288','2014-04-27','12:05:00',5.05),('11288','2014-04-27','12:10:00',5.45),('11288','2014-04-27','12:15:00',5.64),('11288','2014-04-27','12:20:00',4.84),('11288','2014-04-27','12:25:00',4.76),('11288','2014-04-27','12:30:00',4.47),('11288','2014-04-27','12:35:00',4.5),('11288','2014-04-27','12:40:00',4.12),('11288','2014-04-27','12:45:00',4.83),('11288','2014-04-27','12:50:00',3.78),('11288','2014-04-27','12:55:00',4.07),('11288','2014-04-27','13:00:00',4.61),('11288','2014-04-27','13:05:00',3.75),('11288','2014-04-27','13:10:00',3.27),('11288','2014-04-27','13:15:00',3.45),('11288','2014-04-27','13:20:00',4.26),('11288','2014-04-27','13:25:00',3.83),('11288','2014-04-27','13:30:00',3.57),('11288','2014-04-27','13:35:00',3.15),('11288','2014-04-27','13:40:00',3.05),('11288','2014-04-27','13:45:00',3.07),('11288','2014-04-27','13:50:00',3.02),('11288','2014-04-27','13:55:00',2.82),('11288','2014-04-27','14:00:00',3.55),('11288','2014-04-27','14:05:00',3.91),('11288','2014-04-27','14:10:00',2.71),('11288','2014-04-27','14:15:00',2.74),('11288','2014-04-27','14:20:00',3.33),('11288','2014-04-27','14:25:00',3.98),('11288','2014-04-27','14:30:00',4.05),('11288','2014-04-27','14:35:00',4.18),('11288','2014-04-27','14:40:00',4.28),('11288','2014-04-27','14:45:00',3.55),('11288','2014-04-27','14:50:00',3.42),('11288','2014-04-27','14:55:00',3.64),('11288','2014-04-27','15:00:00',3.99),('11288','2014-04-27','15:05:00',5.72),('11288','2014-04-27','15:10:00',7),('11288','2014-04-27','15:15:00',4.61),('11288','2014-04-27','15:20:00',3.17),('11288','2014-04-27','15:25:00',1.97),('11288','2014-04-27','15:30:00',1.63),('11288','2014-04-27','15:35:00',1.84),('11288','2014-04-27','15:40:00',1.9),('11288','2014-04-27','15:45:00',1.56),('11288','2014-04-27','15:50:00',1.61),('11288','2014-04-27','15:55:00',1.01),('11288','2014-02-05','10:10:00',1.69),('11288','2014-02-05','10:15:00',3.01),('11288','2014-02-05','10:20:00',3.84),('11288','2014-02-05','10:25:00',3.12),('11288','2014-02-05','10:30:00',1.26),('11288','2014-02-05','10:35:00',1.71),('11288','2014-02-05','10:40:00',2.27),('11288','2014-02-05','10:45:00',1.13),('11288','2014-02-05','10:50:00',1.41),('11288','2014-02-05','10:55:00',1.9),('11288','2014-02-05','11:00:00',1.03),('11288','2014-02-05','11:10:00',2.35),('11288','2014-02-05','11:15:00',3.89),('11288','2014-02-05','11:20:00',4.88),('11288','2014-02-05','11:25:00',2.79),('11288','2014-02-05','11:30:00',1.88),('11288','2014-02-05','11:35:00',1.15),('11288','2014-02-05','12:50:00',1.4),('11288','2014-02-05','12:55:00',2.32),('11288','2014-02-05','13:00:00',1.83),('11288','2014-02-05','13:05:00',2.13),('11288','2014-02-05','13:10:00',2.6),('11288','2014-02-05','13:15:00',2.04),('11288','2014-02-05','13:20:00',2.51),('11288','2014-02-05','13:25:00',2.7),('11288','2014-02-05','13:30:00',2.69),('11288','2014-02-05','13:35:00',3.2),('11288','2014-02-05','13:40:00',3.31),('11288','2014-02-05','13:45:00',3.2),('11288','2014-02-05','13:50:00',2.91),('11288','2014-02-05','13:55:00',2.08),('11288','2014-02-05','14:00:00',1.56),('11288','2014-02-05','14:05:00',1.04),('11288','2014-02-05','14:15:00',1.17),('11288','2014-02-05','14:25:00',1.45),('11288','2014-02-05','14:30:00',4.15),('11288','2014-02-05','14:35:00',2.63),('11288','2014-02-05','14:40:00',1.53),('11288','2014-02-05','14:45:00',1.22),('11288','2014-02-05','14:50:00',1.19),('11288','2014-02-05','14:55:00',1.03),('11288','2014-02-05','15:00:00',1.05),('11288','2014-02-05','15:05:00',1.02),('11288','2014-02-04','08:50:00',1.04),('11288','2014-02-04','08:55:00',1.09),('11288','2014-02-04','09:00:00',1.17),('11288','2014-02-04','09:05:00',1.28),('11288','2014-02-04','09:10:00',1.39),('11288','2014-02-04','09:15:00',1.73),('11288','2014-02-04','09:20:00',2.14),('11288','2014-02-04','09:25:00',2.14),('11288','2014-02-04','09:30:00',2.33),('11288','2014-02-04','09:35:00',2.14),('11288','2014-02-04','09:40:00',2.4),('11288','2014-02-04','09:45:00',2.19),('11288','2014-02-04','09:50:00',2.84),('11288','2014-02-04','09:55:00',1.71),('11288','2014-02-04','10:00:00',2.88),('11288','2014-02-04','10:05:00',3.49),('11288','2014-02-04','10:10:00',2.77),('11288','2014-02-04','10:15:00',2.53),('11288','2014-02-04','10:20:00',1.71),('11288','2014-02-04','10:25:00',1.09),('11288','2014-02-04','10:30:00',1.18),('11288','2014-02-04','10:35:00',1.48),('11288','2014-02-04','10:40:00',1.89),('11288','2014-02-04','10:45:00',2.59),('11288','2014-02-04','10:50:00',3.24),('11288','2014-02-04','10:55:00',4.24),('11288','2014-02-04','11:00:00',4.69),('11288','2014-02-04','11:05:00',2.49),('11288','2014-02-04','11:10:00',1.94),('11288','2014-02-04','11:15:00',1.6),('11288','2014-02-04','11:20:00',2.05),('11288','2014-02-04','11:25:00',1.51),('11288','2014-02-04','11:30:00',1.78),('11288','2014-02-04','11:35:00',1.41),('11288','2014-02-04','11:40:00',1.31),('11288','2014-02-04','11:45:00',1.22),('11288','2014-02-04','11:50:00',3.13),('11288','2014-02-04','11:55:00',5.31),('11288','2014-02-04','12:00:00',3.15),('11288','2014-02-04','12:05:00',2.94),('11288','2014-02-04','12:10:00',3.36),('11288','2014-02-04','12:15:00',2.75),('11288','2014-02-04','12:20:00',2.75),('11288','2014-02-04','12:25:00',2.23),('11288','2014-02-04','12:30:00',1.61),('11288','2014-02-04','12:35:00',1.27),('11288','2014-02-04','12:40:00',1.2),('11288','2014-02-04','12:45:00',2.07),('11288','2014-02-04','12:50:00',1.96),('11288','2014-02-04','12:55:00',1.88),('11288','2014-02-04','13:00:00',2.24),('11288','2014-02-04','13:05:00',2.26),('11288','2014-02-04','13:10:00',2.07),('11288','2014-02-04','13:15:00',2.31),('11288','2014-02-04','13:20:00',2.86),('11288','2014-02-04','13:25:00',2.49),('11288','2014-02-04','13:30:00',2.15),('11288','2014-02-04','13:35:00',1.88),('11288','2014-02-04','13:40:00',1.8),('11288','2014-02-04','13:45:00',1.6),('11288','2014-02-04','13:50:00',1.72),('11288','2014-02-04','13:55:00',1.55),('11288','2014-02-04','14:00:00',1.1),('11288','2014-02-04','14:05:00',1.05),('11288','2014-02-04','14:10:00',1.42),('11288','2014-02-04','14:15:00',1.44),('11288','2014-02-04','14:20:00',1.33),('11288','2014-02-03','09:20:00',1.04),('11288','2014-02-03','09:25:00',1.1),('11288','2014-02-03','09:30:00',1.14),('11288','2014-02-03','09:35:00',1.25),('11288','2014-02-03','09:40:00',1.37),('11288','2014-02-03','09:45:00',1.54),('11288','2014-02-03','09:50:00',1.76),('11288','2014-02-03','09:55:00',1.58),('11288','2014-02-03','10:00:00',1.42),('11288','2014-02-03','10:05:00',1.45),('11288','2014-02-03','10:10:00',1.66),('11288','2014-02-03','10:15:00',1.92),('11288','2014-02-03','10:20:00',1.79),('11288','2014-02-03','10:25:00',1.82),('11288','2014-02-03','10:30:00',1.84),('11288','2014-02-03','10:35:00',1.85),('11288','2014-02-03','10:40:00',1.94),('11288','2014-02-03','10:45:00',2.01),('11288','2014-02-03','10:50:00',1.97),('11288','2014-02-03','10:55:00',1.93),('11288','2014-02-03','11:00:00',1.78),('11288','2014-02-03','11:05:00',1.76),('11288','2014-02-03','11:10:00',1.78),('11288','2014-02-03','11:15:00',1.75),('11288','2014-02-03','11:20:00',1.85),('11288','2014-02-03','11:25:00',2.04),('11288','2014-02-03','11:30:00',2.26),('11288','2014-02-03','11:35:00',2.33),('11288','2014-02-03','11:40:00',2.33),('11288','2014-02-03','11:45:00',2.37),('11288','2014-02-03','11:50:00',2.33),('11288','2014-02-03','11:55:00',2.15),('11288','2014-02-03','12:00:00',1.91),('11288','2014-02-03','12:05:00',1.82),('11288','2014-02-03','12:10:00',1.81),('11288','2014-02-03','12:15:00',1.95),('11288','2014-02-03','12:20:00',1.95),('11288','2014-02-03','12:25:00',1.82),('11288','2014-02-03','12:30:00',1.74),('11288','2014-02-03','12:35:00',1.39),('11288','2014-02-03','12:40:00',1.3),('11288','2014-02-03','13:00:00',1.01),('11288','2014-02-03','13:05:00',1.01),('11288','2014-02-03','13:10:00',1.08),('11288','2014-02-03','13:15:00',1.21),('11288','2014-02-03','13:20:00',1.29),('11288','2014-02-03','13:25:00',1.49),('11288','2014-02-03','13:30:00',1.64),('11288','2014-02-03','13:35:00',1.65),('11288','2014-02-03','13:40:00',1.58),('11288','2014-02-03','13:45:00',1.5),('11288','2014-02-03','13:50:00',1.48),('11288','2014-02-03','13:55:00',1.41),('11288','2014-02-03','14:00:00',1.46),('11288','2014-02-03','14:05:00',1.57),('11288','2014-02-03','14:10:00',1.63),('11288','2014-02-03','14:15:00',1.6),('11288','2014-02-03','14:20:00',1.46),('11288','2014-02-03','14:25:00',1.58),('11288','2014-02-03','14:30:00',1.67),('11288','2014-02-03','14:35:00',1.67),('11288','2014-02-03','14:40:00',1.69),('11288','2014-02-03','14:45:00',1.61),('11288','2014-02-03','14:50:00',1.52),('11288','2014-02-03','14:55:00',1.33),('11288','2014-02-02','11:25:00',1.17),('11288','2014-02-02','11:30:00',1.29),('11288','2014-02-02','11:35:00',1.23),('11288','2014-02-02','11:40:00',1.26),('11288','2014-02-02','11:45:00',1.35),('11288','2014-02-02','11:50:00',1.45),('11288','2014-02-02','11:55:00',1.64),('11288','2014-02-02','12:00:00',1.8),('11288','2014-02-02','12:05:00',1.84),('11288','2014-02-02','12:10:00',1.8),('11288','2014-02-02','12:15:00',1.61),('11288','2014-02-02','12:20:00',1.4),('11288','2014-02-02','12:25:00',1.25),('11288','2014-02-02','12:30:00',1.27),('11288','2014-02-02','12:35:00',1.25),('11288','2014-02-02','12:40:00',1.12),('11288','2014-02-02','12:45:00',1),('11288','2014-02-02','13:15:00',1.08),('11288','2014-02-02','13:20:00',1.24),('11288','2014-02-02','13:25:00',1.23),('11288','2014-02-02','13:30:00',1.03),('11288','2014-02-02','13:55:00',1.01),('11288','2014-02-02','14:05:00',1),('11288','2014-02-02','14:20:00',1.05),('11288','2014-02-02','14:25:00',1.02),('11288','2014-02-02','15:05:00',1.03),('11288','2014-02-02','15:10:00',1.03),('11288','2014-02-01','08:50:00',1.05),('11288','2014-02-01','09:15:00',1.11),('11288','2014-02-01','09:20:00',1.11),('11288','2014-02-01','09:25:00',1.17),('11288','2014-02-01','09:30:00',1.01),('11288','2014-02-01','10:15:00',1.2),('11288','2014-02-01','10:20:00',1.38),('11288','2014-02-01','10:25:00',1.27),('11288','2014-02-01','10:30:00',1.2),('11288','2014-02-01','10:35:00',1.19),('11288','2014-02-01','10:40:00',1.27),('11288','2014-02-01','10:45:00',1.38),('11288','2014-02-01','10:50:00',1.48),('11288','2014-02-01','10:55:00',1.64),('11288','2014-02-01','11:00:00',2.08),('11288','2014-02-01','11:05:00',1.82),('11288','2014-02-01','11:10:00',1.39),('11288','2014-02-01','11:15:00',1.73),('11288','2014-02-01','11:20:00',2.8),('11288','2014-02-01','11:25:00',2.22),('11288','2014-02-01','11:30:00',2.36),('11288','2014-02-01','11:35:00',2.61),('11288','2014-02-01','11:40:00',1.41),('11288','2014-02-01','11:45:00',1.05),('11288','2014-02-01','11:50:00',1.11),('11288','2014-02-01','11:55:00',2.66),('11288','2014-02-01','12:00:00',2.09),('11288','2014-02-01','12:05:00',2.1),('11288','2014-02-01','12:10:00',3.22),('11288','2014-02-01','12:15:00',2.33),('11288','2014-02-01','12:20:00',3.53),('11288','2014-02-01','12:25:00',2.7),('11288','2014-02-01','12:30:00',1.32),('11288','2014-02-01','12:35:00',1.82),('11288','2014-02-01','12:40:00',2.26),('11288','2014-02-01','12:45:00',3.34),('11288','2014-02-01','12:50:00',3.24),('11288','2014-02-01','12:55:00',2.74),('11288','2014-02-01','13:00:00',2.72),('11288','2014-02-01','13:05:00',2.03),('11288','2014-02-01','13:10:00',1.61),('11288','2014-02-01','13:15:00',1.23),('11288','2014-02-01','13:20:00',1.27),('11288','2014-02-01','13:25:00',1.37),('11288','2014-02-01','13:30:00',1.6),('11288','2014-02-01','13:35:00',1.47),('11288','2014-02-01','13:40:00',1.15),('11288','2014-02-01','13:45:00',1.13),('11288','2014-02-01','13:50:00',1.05),('11288','2014-01-31','10:15:00',1.01),('11288','2014-01-31','10:20:00',1.16),('11288','2014-01-31','10:25:00',1.26),('11288','2014-01-31','10:30:00',1.53),('11288','2014-01-31','10:35:00',1.36),('11288','2014-01-31','11:35:00',1.09),('11288','2014-01-31','11:40:00',1.26),('11288','2014-01-31','11:45:00',1.34),('11288','2014-01-31','11:50:00',1.39),('11288','2014-01-31','11:55:00',1.25),('11288','2014-01-31','12:00:00',1.07),('11288','2014-01-31','12:05:00',1.03),('11288','2014-01-31','12:10:00',1.14),('11288','2014-01-31','12:15:00',1.27),('11288','2014-01-31','12:20:00',1.21),('11288','2014-01-31','12:25:00',1.29),('11288','2014-01-31','12:30:00',1.33),('11288','2014-01-31','12:35:00',1.44),('11288','2014-01-31','12:40:00',1.15),('11288','2014-01-31','13:40:00',1.01),('11288','2014-01-31','13:45:00',1.31),('11288','2014-01-31','13:50:00',1.55),('11288','2014-01-31','13:55:00',1.26),('11288','2014-01-31','14:10:00',1.02),('11288','2014-01-31','14:15:00',1.15),('11288','2014-01-31','14:20:00',1.12),('11288','2014-01-31','14:45:00',1.31),('11288','2014-01-30','08:55:00',1),('11288','2014-01-30','09:00:00',1.08),('11288','2014-01-30','09:05:00',1.15),('11288','2014-01-30','09:10:00',1.22),('11288','2014-01-30','09:15:00',1.34),('11288','2014-01-30','09:20:00',1.44),('11288','2014-01-30','09:25:00',1.46),('11288','2014-01-30','09:30:00',1.36),('11288','2014-01-30','09:35:00',1.3),('11288','2014-01-30','09:40:00',1.28),('11288','2014-01-30','09:45:00',1.34),('11288','2014-01-30','09:50:00',2.01),('11288','2014-01-30','09:55:00',2.65),('11288','2014-01-30','10:00:00',2.44),('11288','2014-01-30','10:05:00',1.82),('11288','2014-01-30','10:10:00',2.47),('11288','2014-01-30','10:15:00',3.19),('11288','2014-01-30','10:20:00',2.74),('11288','2014-01-30','10:25:00',3.39),('11288','2014-01-30','10:30:00',3.58),('11288','2014-01-30','10:35:00',3.45),('11288','2014-01-30','10:40:00',3.52),('11288','2014-01-30','10:45:00',3.28),('11288','2014-01-30','10:50:00',4.07),('11288','2014-01-30','10:55:00',4.79),('11288','2014-01-30','11:00:00',4.67),('11288','2014-01-30','11:05:00',3.93),('11288','2014-01-30','11:10:00',3.59),('11288','2014-01-30','11:15:00',3.62),('11288','2014-01-30','11:20:00',2.43),('11288','2014-01-30','11:25:00',3.72),('11288','2014-01-30','11:30:00',3.45),('11288','2014-01-30','11:35:00',3.89),('11288','2014-01-30','11:40:00',3.58),('11288','2014-01-30','11:45:00',4.27),('11288','2014-01-30','11:50:00',4.45),('11288','2014-01-30','11:55:00',4.4),('11288','2014-01-30','12:00:00',3.86),('11288','2014-01-30','12:05:00',4.7),('11288','2014-01-30','12:10:00',4.98),('11288','2014-01-30','12:15:00',4.43),('11288','2014-01-30','12:20:00',4.95),('11288','2014-01-30','12:25:00',3.94),('11288','2014-01-30','12:30:00',3.65),('11288','2014-01-30','12:35:00',3.81),('11288','2014-01-30','12:40:00',3.61),('11288','2014-01-30','12:45:00',4.4),('11288','2014-01-30','12:50:00',4.43),('11288','2014-01-30','12:55:00',4.35),('11288','2014-01-30','13:00:00',4.51),('11288','2014-01-30','13:05:00',4.79),('11288','2014-01-30','13:10:00',4.07),('11288','2014-01-30','13:15:00',4.44),('11288','2014-01-30','13:20:00',3.73),('11288','2014-01-30','13:25:00',3.97),('11288','2014-01-30','13:30:00',3.27),('11288','2014-01-30','13:35:00',3.01),('11288','2014-01-30','13:40:00',3.85),('11288','2014-01-30','13:45:00',4.2),('11288','2014-01-30','13:50:00',3.81),('11288','2014-01-30','13:55:00',3.31),('11288','2014-01-30','14:00:00',3.3),('11288','2014-01-30','14:05:00',3.07),('11288','2014-01-30','14:10:00',3.08),('11288','2014-01-30','14:15:00',2.7),('11288','2014-01-30','14:20:00',2.46),('11288','2014-01-30','14:25:00',2.61),('11288','2014-01-30','14:30:00',2.71),('11288','2014-01-30','14:35:00',2.62),('11288','2014-01-30','14:40:00',2.93),('11288','2014-01-30','14:45:00',2.74),('11288','2014-01-30','14:50:00',2.91),('11288','2014-01-30','14:55:00',2.71),('11288','2014-01-30','15:00:00',2.55),('11288','2014-01-30','15:05:00',2.49),('11288','2014-01-30','15:10:00',2.33),('11288','2014-01-30','15:15:00',2.19),('11288','2014-01-30','15:20:00',2.2),('11288','2014-01-30','15:25:00',2.15),('11288','2014-01-30','15:30:00',1.87),('11288','2014-01-30','15:35:00',1.85),('11288','2014-01-30','15:40:00',1.7),('11288','2014-01-30','15:45:00',1.11),('11288','2014-01-29','09:05:00',1),('11288','2014-01-29','09:10:00',1.24),('11288','2014-01-29','09:15:00',1.49),('11288','2014-01-29','09:20:00',1.97),('11288','2014-01-29','09:25:00',1.51),('11288','2014-01-29','09:30:00',1.96),('11288','2014-01-29','09:35:00',2.69),('11288','2014-01-29','09:40:00',2.4),('11288','2014-01-29','09:45:00',2.66),('11288','2014-01-29','09:50:00',2.45),('11288','2014-01-29','09:55:00',2.5),('11288','2014-01-29','10:00:00',2.03),('11288','2014-01-29','10:05:00',2.13),('11288','2014-01-29','10:10:00',2.81),('11288','2014-01-29','10:15:00',2.88),('11288','2014-01-29','10:20:00',2.19),('11288','2014-01-29','10:25:00',3.72),('11288','2014-01-29','10:30:00',4.03),('11288','2014-01-29','10:35:00',3.71),('11288','2014-01-29','10:40:00',3.44),('11288','2014-01-29','10:45:00',3.24),('11288','2014-01-29','10:50:00',3.33),('11288','2014-01-29','10:55:00',2.98),('11288','2014-01-29','11:00:00',3.08),('11288','2014-01-29','11:05:00',3.31),('11288','2014-01-29','11:10:00',2.9),('11288','2014-01-29','11:15:00',2.97),('11288','2014-01-29','11:20:00',3.18),('11288','2014-01-29','11:25:00',3.19),('11288','2014-01-29','11:30:00',4.16),('11288','2014-01-29','11:35:00',3.6),('11288','2014-01-29','11:40:00',2.04),('11288','2014-01-29','11:45:00',2.01),('11288','2014-01-29','11:50:00',1.37),('11288','2014-01-29','12:45:00',2.15),('11288','2014-01-29','12:50:00',4.5),('11288','2014-01-29','12:55:00',4.82),('11288','2014-01-29','13:00:00',2.76),('11288','2014-01-29','13:05:00',2.17),('11288','2014-01-29','13:30:00',1.64),('11288','2014-01-29','13:35:00',3),('11288','2014-01-29','13:40:00',4.24),('11288','2014-01-29','13:45:00',2.99),('11288','2014-01-29','13:50:00',3.55),('11288','2014-01-29','13:55:00',4.03),('11288','2014-01-29','14:00:00',1.74),('11288','2014-01-29','14:30:00',1.48),('11288','2014-01-29','14:35:00',1.35),('11288','2014-01-29','14:40:00',1.65),('11288','2014-01-29','14:45:00',1.13),('11288','2014-01-29','15:00:00',1.02),('11288','2014-01-29','15:05:00',1.2),('11288','2014-01-29','15:10:00',1.81),('11288','2014-01-29','15:15:00',2.39),('11288','2014-01-29','15:20:00',1.71),('11288','2014-01-29','15:25:00',1.07),('11288','2014-01-28','09:05:00',1.31),('11288','2014-01-28','09:10:00',1.62),('11288','2014-01-28','09:15:00',1.83),('11288','2014-01-28','09:20:00',1.86),('11288','2014-01-28','09:25:00',1.91),('11288','2014-01-28','09:30:00',1.96),('11288','2014-01-28','09:35:00',2.18),('11288','2014-01-28','09:40:00',1.92),('11288','2014-01-28','09:45:00',2.28),('11288','2014-01-28','09:50:00',2.55),('11288','2014-01-28','09:55:00',2.71),('11288','2014-01-28','10:00:00',2.75),('11288','2014-01-28','10:05:00',2.7),('11288','2014-01-28','10:10:00',2.67),('11288','2014-01-28','10:15:00',2.91),('11288','2014-01-28','10:20:00',3.21),('11288','2014-01-28','10:25:00',3.35),('11288','2014-01-28','10:30:00',3.33),('11288','2014-01-28','10:35:00',3.53),('11288','2014-01-28','10:40:00',3.65),('11288','2014-01-28','10:45:00',3.44),('11288','2014-01-28','10:50:00',3.78),('11288','2014-01-28','10:55:00',2.47),('11288','2014-01-28','11:00:00',2.85),('11288','2014-01-28','11:05:00',3.63),('11288','2014-01-28','11:10:00',3.79),('11288','2014-01-28','11:15:00',2.12),('11288','2014-01-28','11:20:00',1.38),('11288','2014-01-28','11:25:00',3.46),('11288','2014-01-28','11:30:00',2.38),('11288','2014-01-28','11:35:00',3.32),('11288','2014-01-28','11:40:00',4.97),('11288','2014-01-28','11:45:00',4.81),('11288','2014-01-28','11:50:00',2.43),('11288','2014-01-28','11:55:00',1.81),('11288','2014-01-28','12:00:00',3.93),('11288','2014-01-28','12:05:00',3.74),('11288','2014-01-28','12:10:00',3.1),('11288','2014-01-28','12:15:00',2.9),('11288','2014-01-28','12:20:00',2.02),('11288','2014-01-28','12:25:00',1.98),('11288','2014-01-28','12:30:00',2.01),('11288','2014-01-28','12:35:00',2.58),('11288','2014-01-28','12:40:00',2.65),('11288','2014-01-28','12:45:00',3.73),('11288','2014-01-28','12:50:00',3.71),('11288','2014-01-28','12:55:00',4.55),('11288','2014-01-28','13:00:00',4.89),('11288','2014-01-28','13:05:00',4.88),('11288','2014-01-28','13:10:00',3.43),('11288','2014-01-28','13:15:00',4.2),('11288','2014-01-28','13:20:00',3.96),('11288','2014-01-28','13:25:00',4.11),('11288','2014-01-28','13:30:00',4.43),('11288','2014-01-28','13:35:00',4.53),('11288','2014-01-28','13:40:00',4.27),('11288','2014-01-28','13:45:00',4.1),('11288','2014-01-28','13:50:00',3.95),('11288','2014-01-28','13:55:00',3.84),('11288','2014-01-28','14:00:00',3.73),('11288','2014-01-28','14:05:00',3.64),('11288','2014-01-28','14:10:00',3.59),('11288','2014-01-28','14:15:00',3.55),('11288','2014-01-28','14:20:00',3.46),('11288','2014-01-28','14:25:00',3.44),('11288','2014-01-28','14:30:00',3.42),('11288','2014-01-28','14:35:00',3.15),('11288','2014-01-28','14:40:00',3.01),('11288','2014-01-28','14:45:00',2.93),('11288','2014-01-28','14:50:00',2.8),('11288','2014-01-28','14:55:00',2.67),('11288','2014-01-28','15:00:00',2.54),('11288','2014-01-28','15:05:00',2.42),('11288','2014-01-28','15:10:00',2.27),('11288','2014-01-28','15:15:00',2.14),('11288','2014-01-28','15:20:00',1.99),('11288','2014-01-28','15:25:00',1.87),('11288','2014-01-28','15:30:00',1.75),('11288','2014-01-28','15:35:00',1.61),('11288','2014-01-28','15:40:00',1.48),('11288','2014-01-28','15:45:00',1.34),('11288','2014-01-28','15:50:00',1.08),('11288','2014-01-28','15:55:00',1.12),('11288','2014-01-28','16:00:00',1.02),('11288','2014-01-27','09:40:00',1.22),('11288','2014-01-27','09:45:00',1.27),('11288','2014-01-27','09:50:00',1.41),('11288','2014-01-27','09:55:00',1.36),('11288','2014-01-27','10:00:00',1.4),('11288','2014-01-27','10:05:00',1.42),('11288','2014-01-27','10:35:00',1.6),('11288','2014-01-27','10:40:00',1.45),('11288','2014-01-27','10:45:00',1.59),('11288','2014-01-27','10:50:00',1.41),('11288','2014-01-27','10:55:00',1.46),('11288','2014-01-27','11:00:00',1.67),('11288','2014-01-27','11:05:00',1.87),('11288','2014-01-27','11:10:00',1.59),('11288','2014-01-27','11:15:00',1.48),('11288','2014-01-27','11:20:00',1.86),('11288','2014-01-27','11:25:00',1.85),('11288','2014-01-27','11:30:00',1.5),('11288','2014-01-27','11:35:00',1.24),('11288','2014-01-27','11:40:00',1.39),('11288','2014-01-27','11:45:00',1.04),('11288','2014-01-27','11:50:00',1.05),('11288','2014-01-27','12:00:00',1.14),('11288','2014-01-27','12:05:00',1.32),('11288','2014-01-27','12:10:00',1.13),('11288','2014-01-27','12:45:00',1.18),('11288','2014-01-27','12:50:00',1.43),('11288','2014-01-27','12:55:00',1.4),('11288','2014-01-27','13:00:00',1.28),('11288','2014-01-27','13:05:00',1.4),('11288','2014-01-27','13:10:00',1.31),('11288','2014-01-27','13:15:00',1.1),('11288','2014-01-27','13:20:00',1.12),('11288','2014-01-27','13:25:00',1.19),('11288','2014-01-27','13:30:00',1.38),('11288','2014-01-27','13:35:00',1.13),('12374','2013-06-20','06:40:00',1),('12374','2013-06-20','06:50:00',1.19),('12374','2013-06-20','06:55:00',1.29),('12374','2013-06-20','07:00:00',1.39),('12374','2013-06-20','07:05:00',1.34),('12374','2013-06-20','07:10:00',1.61),('12374','2013-06-20','07:15:00',1.72),('12374','2013-06-20','07:20:00',1.92),('12374','2013-06-20','07:25:00',2.09),('12374','2013-06-20','07:30:00',2.26),('12374','2013-06-20','07:35:00',2.41),('12374','2013-06-20','07:40:00',2.57),('12374','2013-06-20','07:45:00',2.72),('12374','2013-06-20','07:50:00',2.86),('12374','2013-06-20','07:55:00',3.04),('12374','2013-06-20','08:00:00',3.2),('12374','2013-06-20','08:05:00',3.36),('12374','2013-06-20','08:10:00',3.5),('12374','2013-06-20','08:15:00',3.65),('12374','2013-06-20','08:20:00',3.8),('12374','2013-06-20','08:25:00',4),('12374','2013-06-20','08:30:00',4.17),('12374','2013-06-20','08:35:00',4.33),('12374','2013-06-20','08:40:00',4.49),('12374','2013-06-20','08:45:00',4.64),('12374','2013-06-20','08:50:00',4.78),('12374','2013-06-20','08:55:00',4.9),('12374','2013-06-20','09:00:00',5.07),('12374','2013-06-20','09:05:00',5.18),('12374','2013-06-20','09:10:00',5.34),('12374','2013-06-20','09:15:00',5.47),('12374','2013-06-20','09:20:00',5.59),('12374','2013-06-20','09:25:00',5.68),('12374','2013-06-20','09:30:00',5.79),('12374','2013-06-20','09:35:00',5.91),('12374','2013-06-20','09:40:00',6.06),('12374','2013-06-20','09:45:00',6.16),('12374','2013-06-20','09:50:00',6.29),('12374','2013-06-20','09:55:00',6.42),('12374','2013-06-20','10:00:00',6.54),('12374','2013-06-20','10:05:00',6.6),('12374','2013-06-20','10:10:00',6.76),('12374','2013-06-20','10:15:00',6.84),('12374','2013-06-20','10:20:00',6.91),('12374','2013-06-20','10:25:00',7),('12374','2013-06-20','10:30:00',7.05),('12374','2013-06-20','10:35:00',7.13),('12374','2013-06-20','10:40:00',7.31),('12374','2013-06-20','10:45:00',7.42),('12374','2013-06-20','10:50:00',7.54),('12374','2013-06-20','10:55:00',7.62),('12374','2013-06-20','11:00:00',7.73),('12374','2013-06-20','11:05:00',7.78),('12374','2013-06-20','11:10:00',7.88),('12374','2013-06-20','11:15:00',7.93),('12374','2013-06-20','11:20:00',7.97),('12374','2013-06-20','11:25:00',1.6),('12374','2013-06-20','11:30:00',2.88),('12374','2013-06-20','11:35:00',8.12),('12374','2013-06-20','11:40:00',8.25),('12374','2013-06-20','11:45:00',8.35),('12374','2013-06-20','11:50:00',6.03),('12374','2013-06-20','11:55:00',7.72),('12374','2013-06-20','12:00:00',8.57),('12374','2013-06-20','12:05:00',8.66),('12374','2013-06-20','12:10:00',7.64),('12374','2013-06-20','12:15:00',6.36),('12374','2013-06-20','12:20:00',8.73),('12374','2013-06-20','12:25:00',8.7),('12374','2013-06-20','12:30:00',8.76),('12374','2013-06-20','12:35:00',5.94),('12374','2013-06-20','12:40:00',8.35),('12374','2013-06-20','12:45:00',8.79),('12374','2013-06-20','12:50:00',8.72),('12374','2013-06-20','12:55:00',6.66),('12374','2013-06-20','13:00:00',7.48),('12374','2013-06-20','13:05:00',8.78),('12374','2013-06-20','13:10:00',8.79),('12374','2013-06-20','13:15:00',8.78),('12374','2013-06-20','13:20:00',8.76),('12374','2013-06-20','13:25:00',8.78),('12374','2013-06-20','13:30:00',8.78),('12374','2013-06-20','13:35:00',8.75),('12374','2013-06-20','13:40:00',8.76),('12374','2013-06-20','13:45:00',8.78),('12374','2013-06-20','13:50:00',8.78),('12374','2013-06-20','13:55:00',8.75),('12374','2013-06-20','14:00:00',8.71),('12374','2013-06-20','14:05:00',8.69),('12374','2013-06-20','14:10:00',8.7),('12374','2013-06-20','14:15:00',8.64),('12374','2013-06-20','14:20:00',8.59),('12374','2013-06-20','14:25:00',8.48),('12374','2013-06-20','14:30:00',8.44),('12374','2013-06-20','14:35:00',8.44),('12374','2013-06-20','14:40:00',8.43),('12374','2013-06-20','14:45:00',8.31),('12374','2013-06-20','14:50:00',8.18),('12374','2013-06-20','14:55:00',8.05),('12374','2013-06-20','15:00:00',8.04),('12374','2013-06-20','15:05:00',8.01),('12374','2013-06-20','15:10:00',7.91),('12374','2013-06-20','15:15:00',7.82),('12374','2013-06-20','15:20:00',7.74),('12374','2013-06-20','15:25:00',7.64),('12374','2013-06-20','15:30:00',7.54),('12374','2013-06-20','15:35:00',7.38),('12374','2013-06-20','15:40:00',7.32),('12374','2013-06-20','15:45:00',7.22),('12374','2013-06-20','15:50:00',7.09),('12374','2013-06-20','15:55:00',6.98),('12374','2013-06-20','16:00:00',6.9),('12374','2013-06-20','16:05:00',6.87),('12374','2013-06-20','16:10:00',6.75),('12374','2013-06-20','16:15:00',6.6),('12374','2013-06-20','16:20:00',6.48),('12374','2013-06-20','16:25:00',6.36),('12374','2013-06-20','16:30:00',6.24),('12374','2013-06-20','16:35:00',6.11),('12374','2013-06-19','06:50:00',1.13),('12374','2013-06-19','06:55:00',1.23),('12374','2013-06-19','07:00:00',1.36),('12374','2013-06-19','07:05:00',1.3),('12374','2013-06-19','07:10:00',1.58),('12374','2013-06-19','07:15:00',1.69),('12374','2013-06-19','07:20:00',1.87),('12374','2013-06-19','07:25:00',2.02),('12374','2013-06-19','07:30:00',2.2),('12374','2013-06-19','07:35:00',2.36),('12374','2013-06-19','07:40:00',2.51),('12374','2013-06-19','07:45:00',2.66),('12374','2013-06-19','07:50:00',2.8),('12374','2013-06-19','07:55:00',2.97),('12374','2013-06-19','08:00:00',3.12),('12374','2013-06-19','08:05:00',3.26),('12374','2013-06-19','08:10:00',3.42),('12374','2013-06-19','08:15:00',3.58),('12374','2013-06-19','08:20:00',3.74),('12374','2013-06-19','08:25:00',3.91),('12374','2013-06-19','08:30:00',4.07),('12374','2013-06-19','08:35:00',4.21),('12374','2013-06-19','08:40:00',4.38),('12374','2013-06-19','08:45:00',4.54),('12374','2013-06-19','08:50:00',4.69),('12374','2013-06-19','08:55:00',4.84),('12374','2013-06-19','09:00:00',4.98),('12374','2013-06-19','09:05:00',5.1),('12374','2013-06-19','09:10:00',5.22),('12374','2013-06-19','09:15:00',5.35),('12374','2013-06-19','09:20:00',5.47),('12374','2013-06-19','09:25:00',5.61),('12374','2013-06-19','09:30:00',5.74),('12374','2013-06-19','09:35:00',5.87),('12374','2013-06-19','09:40:00',5.96),('12374','2013-06-19','09:45:00',6.07),('12374','2013-06-19','09:50:00',6.15),('12374','2013-06-19','09:55:00',6.29),('12374','2013-06-19','10:00:00',6.38),('12374','2013-06-19','10:05:00',6.48),('12374','2013-06-19','10:10:00',6.56),('12374','2013-06-19','10:15:00',6.68),('12374','2013-06-19','10:20:00',6.83),('12374','2013-06-19','10:25:00',6.97),('12374','2013-06-19','10:30:00',7.08),('12374','2013-06-19','10:35:00',7.19),('12374','2013-06-19','10:40:00',7.27),('12374','2013-06-19','10:45:00',7.35),('12374','2013-06-19','10:50:00',7.43),('12374','2013-06-19','10:55:00',7.54),('12374','2013-06-19','11:00:00',7.6),('12374','2013-06-19','11:05:00',7.65),('12374','2013-06-19','11:10:00',7.79),('12374','2013-06-19','11:15:00',7.88),('12374','2013-06-19','11:20:00',7.98),('12374','2013-06-19','11:25:00',8.05),('12374','2013-06-19','11:30:00',8.12),('12374','2013-06-19','11:35:00',8.21),('12374','2013-06-19','11:40:00',8.28),('12374','2013-06-19','11:45:00',8.35),('12374','2013-06-19','11:50:00',8.39),('12374','2013-06-19','11:55:00',8.38),('12374','2013-06-19','12:00:00',8.49),('12374','2013-06-19','12:05:00',8.56),('12374','2013-06-19','12:10:00',8.61),('12374','2013-06-19','12:15:00',8.64),('12374','2013-06-19','12:20:00',8.71),('12374','2013-06-19','12:25:00',8.72),('12374','2013-06-19','12:30:00',8.73),('12374','2013-06-19','12:35:00',8.76),('12374','2013-06-19','12:40:00',8.82),('12374','2013-06-19','12:45:00',8.84),('12374','2013-06-19','12:50:00',8.77),('12374','2013-06-19','12:55:00',8.82),('12374','2013-06-19','13:00:00',8.8),('12374','2013-06-19','13:05:00',8.83),('12374','2013-06-19','13:10:00',8.81),('12374','2013-06-19','13:15:00',8.83),('12374','2013-06-19','13:20:00',8.82),('12374','2013-06-19','13:25:00',8.88),('12374','2013-06-19','13:30:00',8.86),('12374','2013-06-19','13:35:00',8.82),('12374','2013-06-19','13:40:00',8.81),('12374','2013-06-19','13:45:00',8.79),('12374','2013-06-19','13:50:00',8.77),('12374','2013-06-19','13:55:00',8.77),('12374','2013-06-19','14:00:00',8.68),('12374','2013-06-19','14:05:00',8.69),('12374','2013-06-19','14:10:00',8.56),('12374','2013-06-19','14:15:00',8.59),('12374','2013-06-19','14:20:00',8.51),('12374','2013-06-19','14:25:00',8.45),('12374','2013-06-19','14:30:00',8.39),('12374','2013-06-19','14:35:00',8.33),('12374','2013-06-19','14:40:00',8.26),('12374','2013-06-19','14:45:00',8.18),('12374','2013-06-19','14:50:00',8.1),('12374','2013-06-19','14:55:00',8.02),('12374','2013-06-19','15:00:00',7.94),('12374','2013-06-19','15:05:00',7.87),('12374','2013-06-19','15:10:00',7.8),('12374','2013-06-19','15:15:00',7.71),('12374','2013-06-19','15:20:00',7.61),('12374','2013-06-19','15:25:00',7.5),('12374','2013-06-19','15:30:00',7.44),('12374','2013-06-19','15:35:00',7.36),('12374','2013-06-19','15:40:00',7.26),('12374','2013-06-19','15:45:00',7.16),('12374','2013-06-19','15:50:00',7.07),('12374','2013-06-19','15:55:00',6.95),('12374','2013-06-19','16:00:00',6.84),('12374','2013-06-19','16:05:00',6.72),('12374','2013-06-19','16:10:00',6.6),('12374','2013-06-19','16:15:00',6.48),('12374','2013-06-19','16:20:00',6.38),('12374','2013-06-19','16:25:00',6.27),('12374','2013-06-19','16:30:00',6.15),('12374','2013-06-19','16:35:00',6.03),('12374','2013-06-19','16:40:00',5.9),('12374','2013-06-19','16:45:00',5.74),('12374','2013-06-19','16:50:00',5.58),('12374','2013-06-19','16:55:00',5.45),('12374','2013-06-19','17:00:00',5.37),('12374','2013-06-19','17:05:00',5.18),('12374','2013-06-19','17:10:00',5.06),('12374','2013-06-19','17:15:00',4.92),('12374','2013-06-19','17:20:00',4.66),('12374','2013-06-19','17:25:00',4.46),('12374','2013-06-19','17:30:00',4.22),('12374','2013-06-19','17:35:00',4.01),('12374','2013-06-19','17:40:00',3.92),('12374','2013-06-19','17:45:00',3.7),('12374','2013-06-19','17:50:00',3.56),('12374','2013-06-19','17:55:00',3.31),('12374','2013-06-19','18:00:00',3.22),('12374','2013-06-19','18:05:00',3.06),('12374','2013-06-19','18:10:00',2.89),('12374','2013-06-19','18:15:00',2.53),('12374','2013-06-19','18:20:00',2.25),('12374','2013-06-19','18:25:00',2.22),('12374','2013-06-19','18:30:00',2.1),('12374','2013-06-19','18:35:00',1.96),('12374','2013-06-19','18:40:00',1.86),('12374','2013-06-19','18:45:00',1.7),('12374','2013-06-19','18:50:00',1.63),('12374','2013-06-19','18:55:00',1.58),('12374','2013-06-19','19:00:00',1.51),('12374','2013-06-19','19:05:00',1.43),('12374','2013-06-19','19:10:00',1.35),('12374','2013-06-19','19:15:00',1.27),('12374','2013-06-19','19:20:00',1.2),('12374','2013-06-19','19:25:00',1.13),('12374','2013-06-19','19:30:00',1.03),('12374','2013-06-18','06:50:00',1.13),('12374','2013-06-18','06:55:00',1.22),('12374','2013-06-18','07:00:00',1.36),('12374','2013-06-18','07:05:00',1.31),('12374','2013-06-18','07:10:00',1.58),('12374','2013-06-18','07:15:00',1.68),('12374','2013-06-18','07:20:00',1.86),('12374','2013-06-18','07:25:00',2),('12374','2013-06-18','07:30:00',2.19),('12374','2013-06-18','07:35:00',2.33),('12374','2013-06-18','07:40:00',2.5),('12374','2013-06-18','07:45:00',2.67),('12374','2013-06-18','07:50:00',2.84),('12374','2013-06-18','07:55:00',3),('12374','2013-06-18','08:00:00',3.16),('12374','2013-06-18','08:05:00',3.31),('12374','2013-06-18','08:10:00',3.48),('12374','2013-06-18','08:15:00',3.64),('12374','2013-06-18','08:20:00',3.79),('12374','2013-06-18','08:25:00',3.97),('12374','2013-06-18','08:30:00',4.13),('12374','2013-06-18','08:35:00',4.29),('12374','2013-06-18','08:40:00',4.47),('12374','2013-06-18','08:45:00',4.64),('12374','2013-06-18','08:50:00',4.76),('12374','2013-06-18','08:55:00',4.89),('12374','2013-06-18','09:00:00',5.01),('12374','2013-06-18','09:05:00',5.17),('12374','2013-06-18','09:10:00',5.32),('12374','2013-06-18','09:15:00',5.44),('12374','2013-06-18','09:20:00',5.55),('12374','2013-06-18','09:25:00',5.64),('12374','2013-06-18','09:30:00',5.76),('12374','2013-06-18','09:35:00',5.92),('12374','2013-06-18','09:40:00',6.02),('12374','2013-06-18','09:45:00',6.17),('12374','2013-06-18','09:50:00',6.27),('12374','2013-06-18','09:55:00',6.4),('12374','2013-06-18','10:00:00',6.51),('12374','2013-06-18','10:05:00',6.61),('12374','2013-06-18','10:10:00',6.7),('12374','2013-06-18','10:15:00',6.8),('12374','2013-06-18','10:20:00',6.9),('12374','2013-06-18','10:25:00',6.99),('12374','2013-06-18','10:30:00',7.06),('12374','2013-06-18','10:35:00',7.14),('12374','2013-06-18','10:40:00',7.22),('12374','2013-06-18','10:45:00',7.29),('12374','2013-06-18','10:50:00',7.36),('12374','2013-06-18','10:55:00',7.44),('12374','2013-06-18','11:00:00',7.52),('12374','2013-06-18','11:05:00',7.6),('12374','2013-06-18','11:10:00',7.64),('12374','2013-06-18','11:15:00',7.74),('12374','2013-06-18','11:20:00',7.84),('12374','2013-06-18','11:25:00',7.94),('12374','2013-06-18','11:30:00',7.97),('12374','2013-06-18','11:35:00',8.05),('12374','2013-06-18','11:40:00',8.13),('12374','2013-06-18','11:45:00',8.21),('12374','2013-06-18','11:50:00',8.24),('12374','2013-06-18','11:55:00',8.29),('12374','2013-06-18','12:00:00',8.35),('12374','2013-06-18','12:05:00',8.38),('12374','2013-06-18','12:10:00',8.42),('12374','2013-06-18','12:15:00',8.46),('12374','2013-06-18','12:20:00',8.5),('12374','2013-06-18','12:25:00',8.53),('12374','2013-06-18','12:30:00',8.57),('12374','2013-06-18','12:35:00',8.6),('12374','2013-06-18','12:40:00',8.67),('12374','2013-06-18','12:45:00',8.68),('12374','2013-06-18','12:50:00',8.69),('12374','2013-06-18','12:55:00',8.67),('12374','2013-06-18','13:00:00',8.66),('12374','2013-06-18','13:05:00',8.64),('12374','2013-06-18','13:10:00',8.71),('12374','2013-06-18','13:15:00',8.78),('12374','2013-06-18','13:20:00',8.79),('12374','2013-06-18','13:25:00',8.75),('12374','2013-06-18','13:30:00',8.72),('12374','2013-06-18','13:35:00',8.74),('12374','2013-06-18','13:40:00',8.77),('12374','2013-06-18','13:45:00',8.77),('12374','2013-06-18','13:50:00',8.69),('12374','2013-06-18','13:55:00',8.77),('12374','2013-06-18','14:00:00',8.69),('12374','2013-06-18','14:05:00',8.66),('12374','2013-06-18','14:10:00',8.65),('12374','2013-06-18','14:15:00',8.62),('12374','2013-06-18','14:20:00',8.56),('12374','2013-06-18','14:25:00',8.54),('12374','2013-06-18','14:30:00',8.46),('12374','2013-06-18','14:35:00',8.49),('12374','2013-06-18','14:40:00',8.5),('12374','2013-06-18','14:45:00',8.49),('12374','2013-06-18','14:50:00',8.45),('12374','2013-06-18','14:55:00',8.44),('12374','2013-06-18','15:00:00',8.42),('12374','2013-06-18','15:05:00',8.4),('12374','2013-06-18','15:10:00',8.38),('12374','2013-06-18','15:15:00',8.32),('12374','2013-06-18','15:20:00',8.23),('12374','2013-06-18','15:25:00',8.11),('12374','2013-06-18','15:30:00',7.98),('12374','2013-06-18','15:35:00',7.84),('12374','2013-06-18','15:40:00',7.67),('12374','2013-06-18','15:45:00',7.48),('12374','2013-06-18','15:50:00',7.33),('12374','2013-06-18','15:55:00',7.16),('12374','2013-06-18','16:00:00',7),('12374','2013-06-18','16:05:00',6.81),('12374','2013-06-18','16:10:00',6.68),('12374','2013-06-18','16:15:00',6.54),('12374','2013-06-18','16:20:00',6.42),('12374','2013-06-18','16:25:00',6.29),('12374','2013-06-18','16:30:00',6.26),('12374','2013-06-18','16:35:00',6.14),('12374','2013-06-18','16:40:00',6.02),('12374','2013-06-18','16:45:00',5.9),('12374','2013-06-18','16:50:00',5.78),('12374','2013-06-18','16:55:00',5.66),('12374','2013-06-18','17:00:00',5.53),('12374','2013-06-18','17:05:00',5.34),('12374','2013-06-18','17:10:00',5.16),('12374','2013-06-18','17:15:00',5),('12374','2013-06-18','17:20:00',4.71),('12374','2013-06-18','17:25:00',4.47),('12374','2013-06-18','17:30:00',4.25),('12374','2013-06-18','17:35:00',4.12),('12374','2013-06-18','17:40:00',3.93),('12374','2013-06-18','17:45:00',3.7),('12374','2013-06-18','17:50:00',3.57),('12374','2013-06-18','17:55:00',3.39),('12374','2013-06-18','18:00:00',3.24),('12374','2013-06-18','18:05:00',3.09),('12374','2013-06-18','18:10:00',2.9),('12374','2013-06-18','18:15:00',2.55),('12374','2013-06-18','18:20:00',2.29),('12374','2013-06-18','18:25:00',2.26),('12374','2013-06-18','18:30:00',2.14),('12374','2013-06-18','18:35:00',1.98),('12374','2013-06-18','18:40:00',1.89),('12374','2013-06-18','18:45:00',1.73),('12374','2013-06-18','18:50:00',1.64),('12374','2013-06-18','18:55:00',1.6),('12374','2013-06-18','19:00:00',1.53),('12374','2013-06-18','19:05:00',1.46),('12374','2013-06-18','19:10:00',1.39),('12374','2013-06-18','19:15:00',1.31),('12374','2013-06-18','19:20:00',1.24),('12374','2013-06-18','19:25:00',1.16),('12374','2013-06-18','19:30:00',1.07),('12374','2013-06-17','06:45:00',1.09),('12374','2013-06-17','06:50:00',1.19),('12374','2013-06-17','06:55:00',1.28),('12374','2013-06-17','07:00:00',1.42),('12374','2013-06-17','07:05:00',1.36),('12374','2013-06-17','07:10:00',1.66),('12374','2013-06-17','07:15:00',1.77),('12374','2013-06-17','07:20:00',1.96),('12374','2013-06-17','07:25:00',2.13),('12374','2013-06-17','07:30:00',2.32),('12374','2013-06-17','07:35:00',2.47),('12374','2013-06-17','07:40:00',2.63),('12374','2013-06-17','07:45:00',2.79),('12374','2013-06-17','07:50:00',2.94),('12374','2013-06-17','07:55:00',3.13),('12374','2013-06-17','08:00:00',3.29),('12374','2013-06-17','08:05:00',3.43),('12374','2013-06-17','08:10:00',3.59),('12374','2013-06-17','08:15:00',3.76),('12374','2013-06-17','08:20:00',3.92),('12374','2013-06-17','08:25:00',4.08),('12374','2013-06-17','08:30:00',4.25),('12374','2013-06-17','08:35:00',4.39),('12374','2013-06-17','08:40:00',4.56),('12374','2013-06-17','08:45:00',4.71),('12374','2013-06-17','08:50:00',4.84),('12374','2013-06-17','08:55:00',4.97),('12374','2013-06-17','09:00:00',5.11),('12374','2013-06-17','09:05:00',5.25),('12374','2013-06-17','09:10:00',5.4),('12374','2013-06-17','09:15:00',5.52),('12374','2013-06-17','09:20:00',5.64),('12374','2013-06-17','09:25:00',5.76),('12374','2013-06-17','09:30:00',5.87),('12374','2013-06-17','09:35:00',5.95),('12374','2013-06-17','09:40:00',6.04),('12374','2013-06-17','09:45:00',6.14),('12374','2013-06-17','09:50:00',6.28),('12374','2013-06-17','09:55:00',6.37),('12374','2013-06-17','10:00:00',6.5),('12374','2013-06-17','10:05:00',6.63),('12374','2013-06-17','10:10:00',6.81),('12374','2013-06-17','10:15:00',6.9),('12374','2013-06-17','10:20:00',6.96),('12374','2013-06-17','10:25:00',7.07),('12374','2013-06-17','10:30:00',7.14),('12374','2013-06-17','10:35:00',7.25),('12374','2013-06-17','10:40:00',7.42),('12374','2013-06-17','10:45:00',7.53),('12374','2013-06-17','10:50:00',7.6),('12374','2013-06-17','10:55:00',7.64),('12374','2013-06-17','11:00:00',7.8),('12374','2013-06-17','11:05:00',7.89),('12374','2013-06-17','11:10:00',7.98),('12374','2013-06-17','11:15:00',8.04),('12374','2013-06-17','11:20:00',8.12),('12374','2013-06-17','11:25:00',8.18),('12374','2013-06-17','11:30:00',8.26),('12374','2013-06-17','11:35:00',8.3),('12374','2013-06-17','11:40:00',8.35),('12374','2013-06-17','11:45:00',8.4),('12374','2013-06-17','11:50:00',8.43),('12374','2013-06-17','11:55:00',8.52),('12374','2013-06-17','12:00:00',8.57),('12374','2013-06-17','12:05:00',8.6),('12374','2013-06-17','12:10:00',8.6),('12374','2013-06-17','12:15:00',8.66),('12374','2013-06-17','12:20:00',8.7),('12374','2013-06-17','12:25:00',8.77),('12374','2013-06-17','12:30:00',8.79),('12374','2013-06-17','12:35:00',8.79),('12374','2013-06-17','12:40:00',8.79),('12374','2013-06-17','12:45:00',8.81),('12374','2013-06-17','12:50:00',8.78),('12374','2013-06-17','12:55:00',8.82),('12374','2013-06-17','13:00:00',8.88),('12374','2013-06-17','13:05:00',8.87),('12374','2013-06-17','13:10:00',8.85),('12374','2013-06-17','13:15:00',8.79),('12374','2013-06-17','13:20:00',8.79),('12374','2013-06-17','13:25:00',8.79),('12374','2013-06-17','13:30:00',8.77),('12374','2013-06-17','13:35:00',8.76),('12374','2013-06-17','13:40:00',8.73),('12374','2013-06-17','13:45:00',8.69),('12374','2013-06-17','13:50:00',8.7),('12374','2013-06-17','13:55:00',8.68),('12374','2013-06-17','14:00:00',8.68),('12374','2013-06-17','14:05:00',8.66),('12374','2013-06-17','14:10:00',8.63),('12374','2013-06-17','14:15:00',8.54),('12374','2013-06-17','14:20:00',8.47),('12374','2013-06-17','14:25:00',8.42),('12374','2013-06-17','14:30:00',8.38),('12374','2013-06-17','14:35:00',8.3),('12374','2013-06-17','14:40:00',8.22),('12374','2013-06-17','14:45:00',8.14),('12374','2013-06-17','14:50:00',8.04),('12374','2013-06-17','14:55:00',8.02),('12374','2013-06-17','15:00:00',7.93),('12374','2013-06-17','15:05:00',7.83),('12374','2013-06-17','15:10:00',7.78),('12374','2013-06-17','15:15:00',7.72),('12374','2013-06-17','15:20:00',7.65),('12374','2013-06-17','15:25:00',7.56),('12374','2013-06-17','15:30:00',7.48),('12374','2013-06-17','15:35:00',7.38),('12374','2013-06-17','15:40:00',7.28),('12374','2013-06-17','15:45:00',7.2),('12374','2013-06-17','15:50:00',7.1),('12374','2013-06-17','15:55:00',7),('12374','2013-06-17','16:00:00',6.88),('12374','2013-06-17','16:05:00',6.76),('12374','2013-06-17','16:10:00',6.65),('12374','2013-06-17','16:15:00',6.52),('12374','2013-06-17','16:20:00',6.41),('12374','2013-06-17','16:25:00',6.29),('12374','2013-06-17','16:30:00',6.17),('12374','2013-06-17','16:35:00',6.06),('12374','2013-06-17','16:40:00',5.9),('12374','2013-06-17','16:45:00',5.73),('12374','2013-06-17','16:50:00',5.61),('12374','2013-06-17','16:55:00',5.49),('12374','2013-06-17','17:00:00',5.36),('12374','2013-06-17','17:05:00',5.23),('12374','2013-06-17','17:10:00',5.09),('12374','2013-06-17','17:15:00',4.94),('12374','2013-06-17','17:20:00',4.68),('12374','2013-06-17','17:25:00',4.51),('12374','2013-06-17','17:30:00',4.3),('12374','2013-06-17','17:35:00',4.11),('12374','2013-06-17','17:40:00',4.02),('12374','2013-06-17','17:45:00',3.84),('12374','2013-06-17','17:50:00',3.65),('12374','2013-06-17','17:55:00',3.43),('12374','2013-06-17','18:00:00',3.32),('12374','2013-06-17','18:05:00',3.16),('12374','2013-06-17','18:10:00',2.99),('12374','2013-06-17','18:15:00',2.61),('12374','2013-06-17','18:20:00',2.38),('12374','2013-06-17','18:25:00',2.34),('12374','2013-06-17','18:30:00',2.19),('12374','2013-06-17','18:35:00',2.03),('12374','2013-06-17','18:40:00',1.93),('12374','2013-06-17','18:45:00',1.77),('12374','2013-06-17','18:50:00',1.67),('12374','2013-06-17','18:55:00',1.64),('12374','2013-06-17','19:00:00',1.57),('12374','2013-06-17','19:05:00',1.5),('12374','2013-06-17','19:10:00',1.43),('12374','2013-06-17','19:15:00',1.35),('12374','2013-06-17','19:20:00',1.28),('12374','2013-06-17','19:25:00',1.19),('12374','2013-06-17','19:30:00',1.09),('12374','2013-06-17','19:35:00',1.02),('12374','2013-06-16','06:45:00',1.13),('12374','2013-06-16','06:50:00',1.24),('12374','2013-06-16','06:55:00',1.34),('12374','2013-06-16','07:00:00',1.5),('12374','2013-06-16','07:05:00',1.4),('12374','2013-06-16','07:10:00',1.76),('12374','2013-06-16','07:15:00',1.91),('12374','2013-06-16','07:20:00',2.05),('12374','2013-06-16','07:25:00',2.2),('12374','2013-06-16','07:30:00',2.38),('12374','2013-06-16','07:35:00',2.55),('12374','2013-06-16','07:40:00',2.71),('12374','2013-06-16','07:45:00',2.88),('12374','2013-06-16','07:50:00',3.02),('12374','2013-06-16','07:55:00',3.18),('12374','2013-06-16','08:00:00',3.31),('12374','2013-06-16','08:05:00',3.49),('12374','2013-06-16','08:10:00',3.62),('12374','2013-06-16','08:15:00',3.76),('12374','2013-06-16','08:20:00',3.96),('12374','2013-06-16','08:25:00',4.13),('12374','2013-06-16','08:30:00',4.31),('12374','2013-06-16','08:35:00',4.45),('12374','2013-06-16','08:40:00',4.56),('12374','2013-06-16','08:45:00',4.58),('12374','2013-06-16','08:55:00',2.47),('12374','2013-06-16','09:00:00',5.08),('12374','2013-06-16','09:05:00',5.14),('12374','2013-06-16','09:10:00',5.4),('12374','2013-06-16','09:15:00',4.73),('12374','2013-06-16','09:20:00',5.6),('12374','2013-06-16','09:25:00',5.13),('12374','2013-06-16','09:30:00',5.93),('12374','2013-06-16','09:35:00',5.32),('12374','2013-06-16','09:40:00',5.76),('12374','2013-06-16','09:45:00',6.08),('12374','2013-06-16','09:50:00',5.9),('12374','2013-06-16','09:55:00',6.32),('12374','2013-06-16','10:00:00',5.53),('12374','2013-06-16','10:05:00',6.66),('12374','2013-06-16','10:10:00',6.15),('12374','2013-06-16','10:15:00',6.95),('12374','2013-06-16','10:20:00',5.69),('12374','2013-06-16','10:25:00',6.97),('12374','2013-06-16','10:30:00',7.07),('12374','2013-06-16','10:35:00',7.05),('12374','2013-06-16','10:40:00',7.51),('12374','2013-06-16','10:45:00',7.57),('12374','2013-06-16','10:50:00',7.65),('12374','2013-06-16','10:55:00',7.79),('12374','2013-06-16','11:00:00',7.91),('12374','2013-06-16','11:05:00',7.95),('12374','2013-06-16','11:10:00',8.02),('12374','2013-06-16','11:15:00',8.14),('12374','2013-06-16','11:20:00',8.23),('12374','2013-06-16','11:25:00',8.28),('12374','2013-06-16','11:30:00',8.35),('12374','2013-06-16','11:35:00',8.35),('12374','2013-06-16','11:40:00',8.42),('12374','2013-06-16','11:45:00',8.48),('12374','2013-06-16','11:50:00',8.59),('12374','2013-06-16','11:55:00',8.62),('12374','2013-06-16','12:00:00',8.71),('12374','2013-06-16','12:05:00',8.77),('12374','2013-06-16','12:10:00',8.84),('12374','2013-06-16','12:15:00',8.89),('12374','2013-06-16','12:20:00',8.92),('12374','2013-06-16','12:25:00',8.92),('12374','2013-06-16','12:30:00',8.91),('12374','2013-06-16','12:35:00',8.95),('12374','2013-06-16','12:40:00',8.92),('12374','2013-06-16','12:45:00',8.95),('12374','2013-06-16','12:50:00',8.96),('12374','2013-06-16','12:55:00',8.95),('12374','2013-06-16','13:00:00',8.97),('12374','2013-06-16','13:05:00',9),('12374','2013-06-16','13:10:00',2.15),('12374','2013-06-16','13:40:00',7.9),('12374','2013-06-16','13:45:00',8.86),('12374','2013-06-16','13:50:00',8.81),('12374','2013-06-16','13:55:00',8.15),('12374','2013-06-16','14:00:00',6.15),('12374','2013-06-16','14:05:00',8.71),('12374','2013-06-16','14:10:00',8.77),('12374','2013-06-16','14:15:00',8.75),('12374','2013-06-16','14:20:00',5.66),('12374','2013-06-16','14:25:00',8.48),('12374','2013-06-16','14:30:00',8.57),('12374','2013-06-16','14:35:00',8.46),('12374','2013-06-16','14:40:00',6.5),('12374','2013-06-16','14:45:00',7.02),('12374','2013-06-16','14:50:00',8.22),('12374','2013-06-16','14:55:00',8.18),('12374','2013-06-16','15:00:00',6.7),('12374','2013-06-16','15:05:00',6.65),('12374','2013-06-16','15:10:00',7.79),('12374','2013-06-16','15:15:00',7.75),('12374','2013-06-16','15:20:00',7.69),('12374','2013-06-16','15:25:00',7.67),('12374','2013-06-16','15:30:00',7.57),('12374','2013-06-16','15:35:00',7.41),('12374','2013-06-16','15:40:00',7.38),('12374','2013-06-16','15:45:00',7.24),('12374','2013-06-16','15:50:00',7.14),('12374','2013-06-16','15:55:00',7.02),('12374','2013-06-16','16:00:00',6.9),('12374','2013-06-16','16:05:00',6.73),('12374','2013-06-16','16:10:00',6.6),('12374','2013-06-16','16:15:00',6.52),('12374','2013-06-16','16:20:00',6.4),('12374','2013-06-16','16:25:00',6.31),('12374','2013-06-16','16:30:00',6.18),('12374','2013-06-16','16:35:00',6.06),('12374','2013-06-16','16:40:00',5.92),('12374','2013-06-16','16:45:00',5.74),('12374','2013-06-16','16:50:00',5.64),('12374','2013-06-16','16:55:00',5.48),('12374','2013-06-16','17:00:00',5.3),('12374','2013-06-16','17:05:00',5.16),('12374','2013-06-16','17:10:00',5.02),('12374','2013-06-16','17:15:00',4.87),('12374','2013-06-16','17:20:00',4.61),('12374','2013-06-16','17:25:00',4.46),('12374','2013-06-16','17:30:00',4.29),('12374','2013-06-16','17:35:00',4.08),('12374','2013-06-16','17:40:00',3.9),('12374','2013-06-16','17:45:00',3.71),('12374','2013-06-16','17:50:00',3.53),('12374','2013-06-16','17:55:00',3.36),('12374','2013-06-16','18:00:00',3.21),('12374','2013-06-16','18:05:00',3.02),('12374','2013-06-16','18:10:00',2.88),('12374','2013-06-16','18:15:00',2.5),('12374','2013-06-16','18:20:00',2.27),('12374','2013-06-16','18:25:00',2.24),('12374','2013-06-16','18:30:00',2.09),('12374','2013-06-16','18:35:00',1.94),('12374','2013-06-16','18:40:00',1.85),('12374','2013-06-16','18:45:00',1.69),('12374','2013-06-16','18:50:00',1.6),('12374','2013-06-16','18:55:00',1.55),('12374','2013-06-16','19:00:00',1.48),('12374','2013-06-16','19:05:00',1.4),('12374','2013-06-16','19:10:00',1.33),('12374','2013-06-16','19:15:00',1.27),('12374','2013-06-16','19:20:00',1.2),('12374','2013-06-16','19:25:00',1.13),('12374','2013-06-16','19:30:00',1.05),('12374','2013-06-15','07:35:00',1.2),('12374','2013-06-15','07:40:00',1.47),('12374','2013-06-15','07:45:00',1.64),('12374','2013-06-15','07:50:00',1.41),('12374','2013-06-15','07:55:00',1.54),('12374','2013-06-15','08:00:00',1.89),('12374','2013-06-15','08:05:00',2.24),('12374','2013-06-15','08:10:00',2.08),('12374','2013-06-15','08:15:00',2.1),('12374','2013-06-15','08:20:00',3.09),('12374','2013-06-15','08:25:00',3.53),('12374','2013-06-15','08:30:00',3.23),('12374','2013-06-15','08:35:00',2.9),('12374','2013-06-15','08:40:00',3.04),('12374','2013-06-15','08:45:00',3.1),('12374','2013-06-15','08:50:00',4.62),('12374','2013-06-15','08:55:00',4.12),('12374','2013-06-15','09:00:00',3.13),('12374','2013-06-15','09:05:00',5.23),('12374','2013-06-15','09:10:00',4.71),('12374','2013-06-15','09:15:00',5.37),('12374','2013-06-15','09:20:00',5.43),('12374','2013-06-15','09:25:00',3.58),('12374','2013-06-15','09:30:00',3.71),('12374','2013-06-15','09:35:00',3.48),('12374','2013-06-15','09:40:00',4.09),('12374','2013-06-15','09:45:00',4.35),('12374','2013-06-15','09:50:00',3.82),('12374','2013-06-15','09:55:00',3.58),('12374','2013-06-15','10:00:00',3.28),('12374','2013-06-15','10:05:00',2.99),('12374','2013-06-15','10:10:00',3.32),('12374','2013-06-15','10:15:00',3.89),('12374','2013-06-15','10:20:00',3.59),('12374','2013-06-15','10:25:00',6.12),('12374','2013-06-15','10:30:00',4.68),('12374','2013-06-15','10:35:00',5.76),('12374','2013-06-15','10:40:00',7),('12374','2013-06-15','10:45:00',7.79),('12374','2013-06-15','10:50:00',7.76),('12374','2013-06-15','10:55:00',7.89),('12374','2013-06-15','11:00:00',7.87),('12374','2013-06-15','11:05:00',8.03),('12374','2013-06-15','11:10:00',8.17),('12374','2013-06-15','11:15:00',8.1),('12374','2013-06-15','11:20:00',8.34),('12374','2013-06-15','11:25:00',8.42),('12374','2013-06-15','11:30:00',8.27),('12374','2013-06-15','11:35:00',7.41),('12374','2013-06-15','11:40:00',8.32),('12374','2013-06-15','11:45:00',8.79),('12374','2013-06-15','11:50:00',8.61),('12374','2013-06-15','11:55:00',8.14),('12374','2013-06-15','12:00:00',8.51),('12374','2013-06-15','12:05:00',8.88),('12374','2013-06-15','12:10:00',8.39),('12374','2013-06-15','12:15:00',8.05),('12374','2013-06-15','12:20:00',7.94),('12374','2013-06-15','12:25:00',6.17),('12374','2013-06-15','12:30:00',9.16),('12374','2013-06-15','12:35:00',9.05),('12374','2013-06-15','12:40:00',8.66),('12374','2013-06-15','12:45:00',7.54),('12374','2013-06-15','12:50:00',8.97),('12374','2013-06-15','12:55:00',8.94),('12374','2013-06-15','13:00:00',8.87),('12374','2013-06-15','13:05:00',6.54),('12374','2013-06-15','13:10:00',8.61),('12374','2013-06-15','13:15:00',7.76),('12374','2013-06-15','13:20:00',8.27),('12374','2013-06-15','13:25:00',7.43),('12374','2013-06-15','13:30:00',8.5),('12374','2013-06-15','13:35:00',5.52),('12374','2013-06-15','13:40:00',7.78),('12374','2013-06-15','13:45:00',6.89),('12374','2013-06-15','13:50:00',6.89),('12374','2013-06-15','13:55:00',7.18),('12374','2013-06-15','14:00:00',8.81),('12374','2013-06-15','14:05:00',6.41),('12374','2013-06-15','14:10:00',9.15),('12374','2013-06-15','14:15:00',8.59),('12374','2013-06-15','14:20:00',8.73),('12374','2013-06-15','14:25:00',8.43),('12374','2013-06-15','14:30:00',8.58),('12374','2013-06-15','14:35:00',7.86),('12374','2013-06-15','14:40:00',7.06),('12374','2013-06-15','14:45:00',8.63),('12374','2013-06-15','14:50:00',8.33),('12374','2013-06-15','14:55:00',8.05),('12374','2013-06-15','15:00:00',8.02),('12374','2013-06-15','15:05:00',7.84),('12374','2013-06-15','15:10:00',7.84),('12374','2013-06-15','15:15:00',7.77),('12374','2013-06-15','15:20:00',7.65),('12374','2013-06-15','15:25:00',7.47),('12374','2013-06-15','15:30:00',7.43),('12374','2013-06-15','15:35:00',7.31),('12374','2013-06-15','15:40:00',7.21),('12374','2013-06-15','15:45:00',7.17),('12374','2013-06-15','15:50:00',7.11),('12374','2013-06-15','15:55:00',6.99),('12374','2013-06-15','16:00:00',6.87),('12374','2013-06-15','16:05:00',6.79),('12374','2013-06-15','16:10:00',6.68),('12374','2013-06-15','16:15:00',6.57),('12374','2013-06-15','16:20:00',6.42),('12374','2013-06-15','16:25:00',6.29),('12374','2013-06-15','16:30:00',6.11),('12374','2013-06-15','16:35:00',6.01),('12374','2013-06-15','16:40:00',5.85),('12374','2013-06-15','16:45:00',5.68),('12374','2013-06-15','16:50:00',5.56),('12374','2013-06-15','16:55:00',5.44),('12374','2013-06-15','17:00:00',5.27),('12374','2013-06-15','17:05:00',5.14),('12374','2013-06-15','17:10:00',5),('12374','2013-06-15','17:15:00',4.84),('12374','2013-06-15','17:20:00',4.57),('12374','2013-06-15','17:25:00',4.37),('12374','2013-06-15','17:30:00',4.28),('12374','2013-06-15','17:35:00',4.07),('12374','2013-06-15','17:40:00',3.77),('12374','2013-06-15','17:45:00',3.73),('12374','2013-06-15','17:50:00',3.53),('12374','2013-06-15','17:55:00',3.26),('12374','2013-06-15','18:00:00',3.19),('12374','2013-06-15','18:05:00',3.03),('12374','2013-06-15','18:10:00',2.84),('12374','2013-06-15','18:15:00',2.47),('12374','2013-06-15','18:20:00',2.28),('12374','2013-06-15','18:25:00',2.16),('12374','2013-06-15','18:30:00',2.07),('12374','2013-06-15','18:35:00',1.93),('12374','2013-06-15','18:40:00',1.83),('12374','2013-06-15','18:45:00',1.69),('12374','2013-06-15','18:50:00',1.62),('12374','2013-06-15','18:55:00',1.58),('12374','2013-06-15','19:00:00',1.5),('12374','2013-06-15','19:05:00',1.42),('12374','2013-06-15','19:10:00',1.32),('12374','2013-06-15','19:15:00',1.24),('12374','2013-06-15','19:20:00',1.15),('12374','2013-06-15','19:25:00',1.09),('12374','2013-06-14','06:36:00',1.06),('12374','2013-06-14','06:45:00',1.25),('12374','2013-06-14','06:51:00',1.32),('12374','2013-06-14','06:55:00',1.49),('12374','2013-06-14','07:01:00',1.54),('12374','2013-06-14','07:05:00',1.71),('12374','2013-06-14','07:10:00',1.89),('12374','2013-06-14','07:16:00',2),('12374','2013-06-14','07:20:00',2.21),('12374','2013-06-14','07:26:00',2.33),('12374','2013-06-14','07:30:00',2.59),('12374','2013-06-14','07:36:00',2.72),('12374','2013-06-14','07:40:00',2.93),('12374','2013-06-14','07:46:00',3.04),('12374','2013-06-14','07:50:00',3.25),('12374','2013-06-14','07:56:00',3.37),('12374','2013-06-14','08:00:00',3.59),('12374','2013-06-14','08:06:00',3.72),('12374','2013-06-14','08:10:00',3.93),('12374','2013-06-14','08:16:00',4.03),('12374','2013-06-14','08:20:00',4.2),('12374','2013-06-14','08:26:00',4.29),('12374','2013-06-14','08:30:00',4.51),('12374','2013-06-14','08:36:00',4.63),('12374','2013-06-14','08:40:00',4.82),('12374','2013-06-14','08:46:00',4.92),('12374','2013-06-14','08:50:00',5.03),('12374','2013-06-14','08:55:00',5.19),('12374','2013-06-14','09:00:00',5.32),('12374','2013-06-14','09:05:00',5.47),('12374','2013-06-14','09:10:00',5.58),('12374','2013-06-14','09:15:00',5.68),('12374','2013-06-14','09:20:00',5.82),('12374','2013-06-14','09:25:00',5.92),('12374','2013-06-14','09:30:00',6.04),('12374','2013-06-14','09:35:00',6.16),('12374','2013-06-14','09:40:00',6.28),('12374','2013-06-14','09:45:00',6.43),('12374','2013-06-14','09:50:00',6.59),('12374','2013-06-14','09:55:00',6.76),('12374','2013-06-14','10:00:00',6.86),('12374','2013-06-14','10:05:00',6.89),('12374','2013-06-14','10:10:00',6.94),('12374','2013-06-14','10:15:00',7.12),('12374','2013-06-14','10:20:00',7.29),('12374','2013-06-14','10:25:00',7.43),('12374','2013-06-14','10:30:00',7.58),('12374','2013-06-14','10:35:00',7.15),('12374','2013-06-14','10:40:00',7.61),('12374','2013-06-14','10:45:00',7.48),('12374','2013-06-14','10:50:00',7.6),('12374','2013-06-14','10:55:00',7.78),('12374','2013-06-14','11:00:00',8.14),('12374','2013-06-14','11:05:00',8.37),('12374','2013-06-14','11:10:00',8.43),('12374','2013-06-14','11:15:00',8.28),('12374','2013-06-14','11:20:00',8.1),('12374','2013-06-14','11:25:00',8.47),('12374','2013-06-14','11:30:00',8.56),('12374','2013-06-14','11:35:00',8.64),('12374','2013-06-14','11:40:00',8.69),('12374','2013-06-14','11:45:00',8.76),('12374','2013-06-14','11:50:00',8.81),('12374','2013-06-14','11:55:00',8.86),('12374','2013-06-14','12:00:00',8.93),('12374','2013-06-14','12:05:00',8.92),('12374','2013-06-14','12:10:00',8.95),('12374','2013-06-14','12:15:00',9.02),('12374','2013-06-14','12:20:00',8.98),('12374','2013-06-14','12:25:00',9.07),('12374','2013-06-14','12:30:00',9.12),('12374','2013-06-14','12:35:00',9.1),('12374','2013-06-14','12:40:00',9.09),('12374','2013-06-14','12:45:00',9.09),('12374','2013-06-14','12:50:00',9.11),('12374','2013-06-14','12:55:00',9.12),('12374','2013-06-14','13:00:00',9.17),('12374','2013-06-14','13:05:00',9.15),('12374','2013-06-14','13:10:00',9.21),('12374','2013-06-14','13:15:00',9.17),('12374','2013-06-14','13:20:00',8.96),('12374','2013-06-14','13:25:00',8.95),('12374','2013-06-14','13:30:00',8.84),('12374','2013-06-14','13:35:00',9.01),('12374','2013-06-14','13:40:00',9),('12374','2013-06-14','13:45:00',8.65),('12374','2013-06-14','13:50:00',8.64),('12374','2013-06-14','13:55:00',8.67),('12374','2013-06-14','14:00:00',8.77),('12374','2013-06-14','14:05:00',8.76),('12374','2013-06-14','14:10:00',8.9),('12374','2013-06-14','14:15:00',8.91),('12374','2013-06-14','14:20:00',8.87),('12374','2013-06-14','14:25:00',8.84),('12374','2013-06-14','14:30:00',8.79),('12374','2013-06-14','14:35:00',8.7),('12374','2013-06-14','14:40:00',8.63),('12374','2013-06-14','14:45:00',8.56),('12374','2013-06-14','14:50:00',8.47),('12374','2013-06-14','14:55:00',8.38),('12374','2013-06-14','15:00:00',8.3),('12374','2013-06-14','15:05:00',8.21),('12374','2013-06-14','15:10:00',8.09),('12374','2013-06-14','15:15:00',7.98),('12374','2013-06-14','15:20:00',7.86),('12374','2013-06-14','15:25:00',7.8),('12374','2013-06-14','15:30:00',7.7),('12374','2013-06-14','15:35:00',7.67),('12374','2013-06-14','15:40:00',7.56),('12374','2013-06-14','15:45:00',7.46),('12374','2013-06-14','15:50:00',7.34),('12374','2013-06-14','15:55:00',7.2),('12374','2013-06-14','16:00:00',7.05),('12374','2013-06-14','16:05:00',6.93),('12374','2013-06-14','16:10:00',6.81),('12374','2013-06-14','16:15:00',6.73),('12374','2013-06-14','16:20:00',6.6),('12374','2013-06-14','16:25:00',6.48),('12374','2013-06-14','16:30:00',6.23),('12374','2013-06-14','16:35:00',6.13),('12374','2013-06-14','16:40:00',6.01),('12374','2013-06-14','16:45:00',5.85),('12374','2013-06-14','16:50:00',5.75),('12374','2013-06-14','16:55:00',5.67),('12374','2013-06-14','17:00:00',5.52),('12374','2013-06-14','17:05:00',5.4),('12374','2013-06-14','17:10:00',5.21),('12374','2013-06-14','17:15:00',5.02),('12374','2013-06-14','17:20:00',4.79),('12374','2013-06-14','17:25:00',4.59),('12374','2013-06-14','17:30:00',4.37),('12374','2013-06-14','17:35:00',4.18),('12374','2013-06-14','17:40:00',4.07),('12374','2013-06-14','17:45:00',3.84),('12374','2013-06-14','17:50:00',3.68),('12374','2013-06-14','17:55:00',3.43),('12374','2013-06-14','18:00:00',3.37),('12374','2013-06-14','18:05:00',3.16),('12374','2013-06-14','18:10:00',2.97),('12374','2013-06-14','18:15:00',2.52),('12374','2013-06-14','18:20:00',2.35),('12374','2013-06-14','18:25:00',2.32),('12374','2013-06-14','18:30:00',2.18),('12374','2013-06-14','18:35:00',2),('12374','2013-06-14','18:40:00',1.89),('12374','2013-06-14','18:45:00',1.74),('12374','2013-06-14','18:50:00',1.66),('12374','2013-06-14','18:55:00',1.6),('12374','2013-06-14','19:00:00',1.54),('12374','2013-06-14','19:05:00',1.46),('12374','2013-06-14','19:10:00',1.39),('12374','2013-06-14','19:15:00',1.31),('12374','2013-06-14','19:20:00',1.23),('12374','2013-06-14','19:25:00',1.15),('12374','2013-06-14','19:30:00',1.04),('12374','2013-06-07','06:35:00',1.07),('12374','2013-06-07','06:45:00',1.23),('12374','2013-06-07','06:50:00',1.34),('12374','2013-06-07','06:55:00',1.48),('12374','2013-06-07','07:00:00',1.59),('12374','2013-06-07','07:05:00',1.44),('12374','2013-06-07','07:10:00',1.89),('12374','2013-06-07','07:15:00',2.05),('12374','2013-06-07','07:20:00',2.21),('12374','2013-06-07','07:25:00',2.39),('12374','2013-06-07','07:30:00',2.59),('12374','2013-06-07','07:35:00',2.76),('12374','2013-06-07','07:40:00',2.91),('12374','2013-06-07','07:45:00',3.08),('12374','2013-06-07','07:50:00',3.26),('12374','2013-06-07','07:55:00',3.42),('12374','2013-06-07','08:00:00',3.6),('12374','2013-06-07','08:05:00',3.76),('12374','2013-06-07','08:10:00',3.95),('12374','2013-06-07','08:15:00',4.1),('12374','2013-06-07','08:20:00',4.2),('12374','2013-06-07','08:25:00',4.36),('12374','2013-06-07','08:30:00',4.53),('12374','2013-06-07','08:35:00',4.68),('12374','2013-06-07','08:40:00',4.82),('12374','2013-06-07','08:45:00',4.97),('12374','2013-06-07','08:50:00',5.12),('12374','2013-06-07','08:55:00',5.26),('12374','2013-06-07','09:00:00',5.41),('12374','2013-06-07','09:05:00',5.53),('12374','2013-06-07','09:10:00',5.68),('12374','2013-06-07','09:15:00',5.82),('12374','2013-06-07','09:20:00',5.95),('12374','2013-06-07','09:25:00',6.04),('12374','2013-06-07','09:30:00',6.24),('12374','2013-06-07','09:35:00',6.37),('12374','2013-06-07','09:40:00',6.49),('12374','2013-06-07','09:45:00',6.62),('12374','2013-06-07','09:50:00',6.74),('12374','2013-06-07','09:55:00',6.85),('12374','2013-06-07','10:00:00',6.98),('12374','2013-06-07','10:05:00',7.1),('12374','2013-06-07','10:10:00',7.21),('12374','2013-06-07','10:15:00',7.32),('12374','2013-06-07','10:20:00',7.41),('12374','2013-06-07','10:25:00',7.52),('12374','2013-06-07','10:30:00',7.56),('12374','2013-06-07','10:35:00',7.69),('12374','2013-06-07','10:40:00',7.78),('12374','2013-06-07','10:45:00',7.84),('12374','2013-06-07','10:50:00',7.94),('12374','2013-06-07','10:55:00',8.02),('12374','2013-06-07','11:00:00',8.1),('12374','2013-06-07','11:05:00',8.17),('12374','2013-06-07','11:10:00',8.23),('12374','2013-06-07','11:15:00',8.31),('12374','2013-06-07','11:20:00',8.3),('12374','2013-06-07','11:25:00',8.42),('12374','2013-06-07','11:30:00',8.45),('12374','2013-06-07','11:35:00',8.48),('12374','2013-06-07','11:40:00',8.53),('12374','2013-06-07','11:45:00',8.57),('12374','2013-06-07','11:50:00',8.57),('12374','2013-06-07','11:55:00',8.69),('12374','2013-06-07','12:00:00',8.82),('12374','2013-06-07','12:05:00',8.93),('12374','2013-06-07','12:10:00',8.97),('12374','2013-06-07','12:15:00',8.99),('12374','2013-06-07','12:20:00',8.94),('12374','2013-06-07','12:25:00',8.88),('12374','2013-06-07','12:30:00',8.98),('12374','2013-06-07','12:35:00',9.04),('12374','2013-06-07','12:40:00',9.07),('12374','2013-06-07','12:45:00',9.1),('12374','2013-06-07','12:50:00',9.1),('12374','2013-06-07','12:55:00',9.1),('12374','2013-06-07','13:00:00',9.03),('12374','2013-06-07','13:05:00',9.06),('12374','2013-06-07','13:10:00',9.07),('12374','2013-06-07','13:15:00',9.15),('12374','2013-06-07','13:20:00',9.08),('12374','2013-06-07','13:25:00',9.07),('12374','2013-06-07','13:30:00',9.13),('12374','2013-06-07','13:35:00',9.07),('12374','2013-06-07','13:40:00',9.12),('12374','2013-06-07','13:45:00',9.09),('12374','2013-06-07','13:50:00',9.02),('12374','2013-06-07','13:55:00',8.99),('12374','2013-06-07','14:00:00',8.93),('12374','2013-06-07','14:05:00',8.87),('12374','2013-06-07','14:10:00',8.9),('12374','2013-06-07','14:15:00',8.87),('12374','2013-06-07','14:20:00',8.82),('12374','2013-06-07','14:25:00',8.84),('12374','2013-06-07','14:30:00',8.77),('12374','2013-06-07','14:35:00',8.7),('12374','2013-06-07','14:40:00',8.63),('12374','2013-06-07','14:45:00',8.55),('12374','2013-06-07','14:50:00',8.45),('12374','2013-06-07','14:55:00',8.38),('12374','2013-06-07','15:00:00',8.3),('12374','2013-06-07','15:05:00',8.19),('12374','2013-06-07','15:10:00',8.12),('12374','2013-06-07','15:15:00',8.03),('12374','2013-06-07','15:20:00',7.95),('12374','2013-06-07','15:25:00',7.85),('12374','2013-06-07','15:30:00',7.74),('12374','2013-06-07','15:35:00',7.64),('12374','2013-06-07','15:40:00',7.54),('12374','2013-06-07','15:45:00',7.43),('12374','2013-06-07','15:50:00',7.33),('12374','2013-06-07','15:55:00',7.22),('12374','2013-06-07','16:00:00',7.07),('12374','2013-06-07','16:05:00',6.95),('12374','2013-06-07','16:10:00',6.83),('12374','2013-06-07','16:15:00',6.76),('12374','2013-06-07','16:20:00',6.63),('12374','2013-06-07','16:25:00',6.48),('12374','2013-06-07','16:30:00',6.36),('12374','2013-06-07','16:35:00',6.25),('12374','2013-06-07','16:40:00',6.11),('12374','2013-06-07','16:45:00',5.96),('12374','2013-06-07','16:50:00',5.84),('12374','2013-06-07','16:55:00',5.7),('12374','2013-06-07','17:00:00',5.6),('12374','2013-06-07','17:05:00',5.59),('12374','2013-06-07','17:10:00',5.6),('12374','2013-06-07','17:15:00',5.22),('12374','2013-06-07','17:20:00',5.49),('12374','2013-06-07','17:25:00',5.39),('12374','2013-06-07','17:30:00',4.82),('12374','2013-06-07','17:35:00',4.26),('12374','2013-06-07','17:40:00',2.99),('12374','2013-06-07','17:45:00',4.57),('12374','2013-06-06','06:55:00',1.52),('12374','2013-06-06','07:00:00',1.53),('12374','2013-06-06','07:05:00',1.53),('12374','2013-06-06','07:10:00',1.6),('12374','2013-06-06','07:15:00',1.36),('12374','2013-06-06','07:20:00',1.7),('12374','2013-06-06','07:25:00',2.31),('12374','2013-06-06','07:30:00',2.4),('12374','2013-06-06','07:35:00',2.72),('12374','2013-06-06','07:40:00',2.32),('12374','2013-06-06','07:45:00',3.17),('12374','2013-06-06','07:50:00',3.28),('12374','2013-06-06','07:55:00',3.52),('12374','2013-06-06','08:00:00',3.64),('12374','2013-06-06','08:05:00',3.4),('12374','2013-06-06','08:10:00',3.9),('12374','2013-06-06','08:15:00',4.13),('12374','2013-06-06','08:20:00',4.28),('12374','2013-06-06','08:25:00',4.41),('12374','2013-06-06','08:30:00',4.56),('12374','2013-06-06','08:35:00',4.72),('12374','2013-06-06','08:40:00',4.87),('12374','2013-06-06','08:45:00',4.91),('12374','2013-06-06','08:50:00',5.13),('12374','2013-06-06','08:55:00',5.27),('12374','2013-06-06','09:00:00',5.42),('12374','2013-06-06','09:05:00',5.56),('12374','2013-06-06','09:10:00',5.65),('12374','2013-06-06','09:15:00',5.78),('12374','2013-06-06','09:20:00',5.92),('12374','2013-06-06','09:25:00',6.03),('12374','2013-06-06','09:30:00',6.13),('12374','2013-06-06','09:35:00',6.22),('12374','2013-06-06','09:40:00',6.36),('12374','2013-06-06','09:45:00',6.53),('12374','2013-06-06','09:50:00',6.66),('12374','2013-06-06','09:55:00',6.79),('12374','2013-06-06','10:00:00',6.9),('12374','2013-06-06','10:05:00',7),('12374','2013-06-06','10:10:00',7.14),('12374','2013-06-06','10:15:00',7.32),('12374','2013-06-06','10:20:00',7.65),('12374','2013-06-06','10:25:00',5.21),('12374','2013-06-06','10:30:00',4.88),('12374','2013-06-06','10:35:00',7.94),('12374','2013-06-06','10:40:00',7.67),('12374','2013-06-06','10:45:00',7.12),('12374','2013-06-06','10:50:00',8.09),('12374','2013-06-06','10:55:00',7.83),('12374','2013-06-06','11:00:00',7.26),('12374','2013-06-06','11:05:00',8.18),('12374','2013-06-06','11:10:00',8.33),('12374','2013-06-06','11:15:00',8.43),('12374','2013-06-06','11:20:00',8.28),('12374','2013-06-06','11:25:00',8.46),('12374','2013-06-06','11:30:00',8.59),('12374','2013-06-06','11:35:00',8.61),('12374','2013-06-06','11:40:00',8.66),('12374','2013-06-06','11:45:00',8.7),('12374','2013-06-06','11:50:00',8.75),('12374','2013-06-06','11:55:00',8.86),('12374','2013-06-06','12:00:00',8.92),('12374','2013-06-06','12:05:00',8.96),('12374','2013-06-06','12:10:00',8.99),('12374','2013-06-06','12:15:00',9),('12374','2013-06-06','12:20:00',9.01),('12374','2013-06-06','12:25:00',9.04),('12374','2013-06-06','12:30:00',9.14),('12374','2013-06-06','12:35:00',9.1),('12374','2013-06-06','12:40:00',9.11),('12374','2013-06-06','12:45:00',9.12),('12374','2013-06-06','12:50:00',9.15),('12374','2013-06-06','12:55:00',9.17),('12374','2013-06-06','13:00:00',9.19),('12374','2013-06-06','13:05:00',9.16),('12374','2013-06-06','13:10:00',9.2),('12374','2013-06-06','13:15:00',9.18),('12374','2013-06-06','13:20:00',9.18),('12374','2013-06-06','13:25:00',9.16),('12374','2013-06-06','13:30:00',9.04),('12374','2013-06-06','13:35:00',9.24),('12374','2013-06-06','13:40:00',9.24),('12374','2013-06-06','13:45:00',9.08),('12374','2013-06-06','13:50:00',8.95),('12374','2013-06-06','13:55:00',8.98),('12374','2013-06-06','14:00:00',8.98),('12374','2013-06-06','14:05:00',8.98),('12374','2013-06-06','14:10:00',8.82),('12374','2013-06-06','14:15:00',8.8),('12374','2013-06-06','14:20:00',8.79),('12374','2013-06-06','14:25:00',8.75),('12374','2013-06-06','14:30:00',8.82),('12374','2013-06-06','14:35:00',8.72),('12374','2013-06-06','14:40:00',8.6),('12374','2013-06-06','14:45:00',8.61),('12374','2013-06-06','14:50:00',8.43),('12374','2013-06-06','14:55:00',8.41),('12374','2013-06-06','15:00:00',8.3),('12374','2013-06-06','15:05:00',8.22),('12374','2013-06-06','15:10:00',8.16),('12374','2013-06-06','15:15:00',8.06),('12374','2013-06-06','15:20:00',7.94),('12374','2013-06-06','15:25:00',7.86),('12374','2013-06-06','15:30:00',7.7),('12374','2013-06-06','15:35:00',7.58),('12374','2013-06-06','15:40:00',7.47),('12374','2013-06-06','15:45:00',7.43),('12374','2013-06-06','15:50:00',7.32),('12374','2013-06-06','15:55:00',7.19),('12374','2013-06-06','16:00:00',7.09),('12374','2013-06-06','16:05:00',6.98),('12374','2013-06-06','16:10:00',6.86),('12374','2013-06-06','16:15:00',6.72),('12374','2013-06-06','16:20:00',6.59),('12374','2013-06-06','16:25:00',6.46),('12374','2013-06-06','16:30:00',6.31),('12374','2013-06-06','16:35:00',6.16),('12374','2013-06-06','16:40:00',6.04),('12374','2013-06-06','16:45:00',5.9),('12374','2013-06-06','16:50:00',5.78),('12374','2013-06-06','16:55:00',5.64),('12374','2013-06-06','17:00:00',5.5),('12374','2013-06-06','17:05:00',5.32),('12374','2013-06-06','17:10:00',5.16),('12374','2013-06-06','17:15:00',4.97),('12374','2013-06-06','17:20:00',4.73),('12374','2013-06-06','17:25:00',4.59),('12374','2013-06-06','17:30:00',4.39),('12374','2013-06-06','17:35:00',4.1),('12374','2013-06-06','17:40:00',4.01),('12374','2013-06-06','17:45:00',3.79),('12374','2013-06-06','17:50:00',3.59),('12374','2013-06-06','17:55:00',3.41),('12374','2013-06-06','18:00:00',3.21),('12374','2013-06-06','18:05:00',3.08),('12374','2013-06-06','18:10:00',2.86),('12374','2013-06-06','18:15:00',2.4),('12374','2013-06-06','18:20:00',2.28),('12374','2013-06-06','18:25:00',2.26),('12374','2013-06-06','18:30:00',2.04),('12374','2013-06-06','18:35:00',1.91),('12374','2013-06-06','18:40:00',1.84),('12374','2013-06-06','18:45:00',1.71),('12374','2013-06-06','18:50:00',1.63),('12374','2013-06-06','18:55:00',1.56),('12374','2013-06-06','19:00:00',1.51),('12374','2013-06-06','19:05:00',1.42),('12374','2013-06-06','19:10:00',1.34),('12374','2013-06-06','19:15:00',1.25),('12374','2013-06-06','19:20:00',1.17),('12374','2013-06-06','19:25:00',1.08),('12374','2013-06-05','06:55:00',1.08),('12374','2013-06-05','07:00:00',1.19),('12374','2013-06-05','07:05:00',2.04),('12374','2013-06-05','07:10:00',2.04),('12374','2013-06-05','07:15:00',2.15),('12374','2013-06-05','07:20:00',2.05),('12374','2013-06-05','07:25:00',1.75),('12374','2013-06-05','07:30:00',2.51),('12374','2013-06-05','07:35:00',2.71),('12374','2013-06-05','07:40:00',2.98),('12374','2013-06-05','07:45:00',3.15),('12374','2013-06-05','07:50:00',3.37),('12374','2013-06-05','07:55:00',3.68),('12374','2013-06-05','08:00:00',3.73),('12374','2013-06-05','08:05:00',3.77),('12374','2013-06-05','08:10:00',3.23),('12374','2013-06-05','08:15:00',4.11),('12374','2013-06-05','08:20:00',4.18),('12374','2013-06-05','08:25:00',4.31),('12374','2013-06-05','08:30:00',4.5),('12374','2013-06-05','08:35:00',4.65),('12374','2013-06-05','08:40:00',4.83),('12374','2013-06-05','08:45:00',4.97),('12374','2013-06-05','08:50:00',5.11),('12374','2013-06-05','08:55:00',5.31),('12374','2013-06-05','09:00:00',5.41),('12374','2013-06-05','09:05:00',5.51),('12374','2013-06-05','09:10:00',5.69),('12374','2013-06-05','09:15:00',6.05),('12374','2013-06-05','09:20:00',5.4),('12374','2013-06-05','09:25:00',6.02),('12374','2013-06-05','09:30:00',6.58),('12374','2013-06-05','09:35:00',2.96),('12374','2013-06-05','09:40:00',4.27),('12374','2013-06-05','09:45:00',3.87),('12374','2013-06-05','09:50:00',5.86),('12374','2013-06-05','09:55:00',5.68),('12374','2013-06-05','10:00:00',7.9),('12374','2013-06-05','10:05:00',5),('12374','2013-06-05','10:10:00',4.41),('12374','2013-06-05','10:15:00',4.15),('12374','2013-06-05','10:20:00',7.38),('12374','2013-06-05','10:25:00',6.88),('12374','2013-06-05','10:30:00',6.99),('12374','2013-06-05','10:35:00',2.64),('12374','2013-06-05','10:40:00',2),('12374','2013-06-05','10:45:00',2.08),('12374','2013-06-05','10:50:00',2.37),('12374','2013-06-05','10:55:00',3.68),('12374','2013-06-05','11:00:00',4.44),('12374','2013-06-05','11:05:00',8.46),('12374','2013-06-05','11:10:00',8.4),('12374','2013-06-05','11:15:00',8.47),('12374','2013-06-05','11:20:00',8.41),('12374','2013-06-05','11:25:00',8.62),('12374','2013-06-05','11:30:00',8.63),('12374','2013-06-05','11:35:00',8.77),('12374','2013-06-05','11:40:00',8.82),('12374','2013-06-05','11:45:00',8.87),('12374','2013-06-05','11:50:00',8.85),('12374','2013-06-05','11:55:00',8.85),('12374','2013-06-05','12:00:00',8.89),('12374','2013-06-05','12:05:00',9.02),('12374','2013-06-05','12:10:00',8.99),('12374','2013-06-05','12:15:00',9.05),('12374','2013-06-05','12:20:00',9.01),('12374','2013-06-05','12:25:00',9.13),('12374','2013-06-05','12:30:00',9.13),('12374','2013-06-05','12:35:00',9.15),('12374','2013-06-05','12:40:00',9.04),('12374','2013-06-05','12:45:00',9.05),('12374','2013-06-05','12:50:00',9.13),('12374','2013-06-05','12:55:00',9.19),('12374','2013-06-05','13:00:00',9.18),('12374','2013-06-05','13:05:00',9.21),('12374','2013-06-05','13:10:00',8.98),('12374','2013-06-05','13:15:00',7.89),('12374','2013-06-05','13:20:00',8.99),('12374','2013-06-05','13:25:00',9.14),('12374','2013-06-05','13:30:00',9.3),('12374','2013-06-05','13:35:00',9.24),('12374','2013-06-05','13:40:00',9.15),('12374','2013-06-05','13:45:00',9.27),('12374','2013-06-05','13:50:00',9.02),('12374','2013-06-05','13:55:00',9.12),('12374','2013-06-05','14:00:00',9.17),('12374','2013-06-05','14:05:00',9.11),('12374','2013-06-05','14:10:00',9.01),('12374','2013-06-05','14:15:00',8.54),('12374','2013-06-05','14:20:00',8.55),('12374','2013-06-05','14:25:00',9.01),('12374','2013-06-05','14:30:00',8.88),('12374','2013-06-05','14:35:00',8.89),('12374','2013-06-05','14:40:00',8.52),('12374','2013-06-05','14:45:00',8.9),('12374','2013-06-05','14:50:00',8.75),('12374','2013-06-05','14:55:00',5.58),('12374','2013-06-05','15:00:00',8.33),('12374','2013-06-05','15:05:00',7.81),('12374','2013-06-05','15:10:00',8.4),('12374','2013-06-05','15:15:00',8.12),('12374','2013-06-05','15:20:00',8.08),('12374','2013-06-05','15:25:00',7.88),('12374','2013-06-05','15:30:00',8),('12374','2013-06-05','15:35:00',6.48),('12374','2013-06-05','15:40:00',7.19),('12374','2013-06-05','15:45:00',6.31),('12374','2013-06-05','15:50:00',7.05),('12374','2013-06-05','15:55:00',7.79),('12374','2013-06-05','16:00:00',6.58),('12374','2013-06-05','16:05:00',7.33),('12374','2013-06-05','16:10:00',7.16),('12374','2013-06-05','16:15:00',6.86),('12374','2013-06-05','16:20:00',6.84),('12374','2013-06-05','16:25:00',6.77),('12374','2013-06-05','16:30:00',5.34),('12374','2013-06-05','16:35:00',6.09),('12374','2013-06-05','16:40:00',6.31),('12374','2013-06-05','16:45:00',6.15),('12374','2013-06-05','16:50:00',4.33),('12374','2013-06-05','16:55:00',5.46),('12374','2013-06-05','17:00:00',3.27),('12374','2013-06-05','17:05:00',4.28),('12374','2013-06-05','17:10:00',2.97),('12374','2013-06-05','17:15:00',2.53),('12374','2013-06-05','17:20:00',3.98),('12374','2013-06-05','17:25:00',4.24),('12374','2013-06-05','17:30:00',3.94),('12374','2013-06-05','17:35:00',3.87),('12374','2013-06-05','17:40:00',4.21),('12374','2013-06-05','17:45:00',4),('12374','2013-06-05','17:50:00',3.79),('12374','2013-06-05','17:55:00',3.37),('12374','2013-06-05','18:00:00',3.26),('12374','2013-06-05','18:05:00',3.1),('12374','2013-06-05','18:10:00',3),('12374','2013-06-05','18:15:00',2.87),('12374','2013-06-05','18:20:00',2.65),('12374','2013-06-05','18:25:00',1.85),('12374','2013-06-05','18:30:00',1.95),('12374','2013-06-05','18:35:00',2.23),('12374','2013-06-05','18:40:00',1.99),('12374','2013-06-05','18:45:00',1.8),('12374','2013-06-05','18:50:00',1.71),('12374','2013-06-05','18:55:00',1.64),('12374','2013-06-05','19:00:00',1.55),('12374','2013-06-05','19:05:00',1.48),('12374','2013-06-05','19:10:00',1.4),('12374','2013-06-05','19:15:00',1.34),('12374','2013-06-05','19:20:00',1.27),('12374','2013-06-05','19:25:00',1.17),('12374','2013-06-05','19:30:00',1.07),('12374','2013-06-04','06:50:00',1.08),('12374','2013-06-04','06:55:00',1.21),('12374','2013-06-04','07:00:00',1.48),('12374','2013-06-04','07:05:00',1.61),('12374','2013-06-04','07:10:00',1.79),('12374','2013-06-04','07:15:00',2.55),('12374','2013-06-04','07:20:00',3.22),('12374','2013-06-04','07:25:00',3),('12374','2013-06-04','07:30:00',2.35),('12374','2013-06-04','07:35:00',2.8),('12374','2013-06-04','07:40:00',2.43),('12374','2013-06-04','07:45:00',2.06),('12374','2013-06-04','07:50:00',2.88),('12374','2013-06-04','07:55:00',3.4),('12374','2013-06-04','08:00:00',3.05),('12374','2013-06-04','08:05:00',3.57),('12374','2013-06-04','08:10:00',2.8),('12374','2013-06-04','08:15:00',2.72),('12374','2013-06-04','08:20:00',2.37),('12374','2013-06-04','08:25:00',1.98),('12374','2013-06-04','08:30:00',1.45),('12374','2013-06-04','08:35:00',1.38),('12374','2013-06-04','08:40:00',1.7),('12374','2013-06-04','08:45:00',2.17),('12374','2013-06-04','08:50:00',2.45),('12374','2013-06-04','08:55:00',2.26),('12374','2013-06-04','09:00:00',2.63),('12374','2013-06-04','09:05:00',3.42),('12374','2013-06-04','09:10:00',3.6),('12374','2013-06-04','09:15:00',3.3),('12374','2013-06-04','09:20:00',3.72),('12374','2013-06-04','09:25:00',4.05),('12374','2013-06-04','09:30:00',3.58),('12374','2013-06-04','09:35:00',4.13),('12374','2013-06-04','09:40:00',4.44),('12374','2013-06-04','09:45:00',4.34),('12374','2013-06-04','09:50:00',3.08),('12374','2013-06-04','09:55:00',3.03),('12374','2013-06-04','10:00:00',3.11),('12374','2013-06-04','10:05:00',3.74),('12374','2013-06-04','10:10:00',4.18),('12374','2013-06-04','10:15:00',3.36),('12374','2013-06-04','10:20:00',3.61),('12374','2013-06-04','10:25:00',4.01),('12374','2013-06-04','10:30:00',4.72),('12374','2013-06-04','10:35:00',6.32),('12374','2013-06-04','10:40:00',4.9),('12374','2013-06-04','10:45:00',6.06),('12374','2013-06-04','10:50:00',5),('12374','2013-06-04','10:55:00',3.35),('12374','2013-06-04','11:00:00',3.83),('12374','2013-06-04','11:05:00',3.81),('12374','2013-06-04','11:10:00',3.53),('12374','2013-06-04','11:15:00',3.06),('12374','2013-06-04','11:20:00',3.83),('12374','2013-06-04','11:25:00',5.03),('12374','2013-06-04','11:30:00',6.48),('12374','2013-06-04','11:35:00',5.77),('12374','2013-06-04','11:40:00',4.57),('12374','2013-06-04','11:45:00',5.55),('12374','2013-06-04','11:50:00',6.6),('12374','2013-06-04','11:55:00',4.57),('12374','2013-06-04','12:00:00',5.16),('12374','2013-06-04','12:05:00',8.28),('12374','2013-06-04','12:10:00',5.08),('12374','2013-06-04','12:15:00',4.58),('12374','2013-06-04','12:20:00',4.43),('12374','2013-06-04','12:25:00',4.02),('12374','2013-06-04','12:30:00',3.06),('12374','2013-06-04','12:35:00',3.09),('12374','2013-06-04','12:40:00',3.73),('12374','2013-06-04','12:45:00',5.08),('12374','2013-06-04','12:50:00',6.38),('12374','2013-06-04','12:55:00',8.22),('12374','2013-06-04','13:00:00',8.66),('12374','2013-06-04','13:05:00',9.16),('12374','2013-06-04','13:10:00',9.17),('12374','2013-06-04','13:15:00',8.36),('12374','2013-06-04','13:20:00',8.52),('12374','2013-06-04','13:25:00',8.14),('12374','2013-06-04','13:30:00',8.73),('12374','2013-06-04','13:35:00',8.77),('12374','2013-06-04','13:40:00',8.91),('12374','2013-06-04','13:45:00',9.51),('12374','2013-06-04','13:50:00',9.37),('12374','2013-06-04','13:55:00',9.3),('12374','2013-06-04','14:00:00',8.82),('12374','2013-06-04','14:05:00',7.27),('12374','2013-06-04','14:10:00',7.72),('12374','2013-06-04','14:15:00',8.42),('12374','2013-06-04','14:20:00',8.53),('12374','2013-06-04','14:25:00',9.07),('12374','2013-06-04','14:30:00',6.65),('12374','2013-06-04','14:35:00',5.44),('12374','2013-06-04','14:40:00',8),('12374','2013-06-04','14:45:00',8.93),('12374','2013-06-04','14:50:00',9.2),('12374','2013-06-04','14:55:00',9.26),('12374','2013-06-04','15:00:00',9.11),('12374','2013-06-04','15:05:00',8.76),('12374','2013-06-04','15:10:00',7.4),('12374','2013-06-04','15:15:00',7.4),('12374','2013-06-04','15:20:00',6.88),('12374','2013-06-04','15:25:00',6.51),('12374','2013-06-04','15:30:00',5.69),('12374','2013-06-04','15:35:00',7.75),('12374','2013-06-04','15:40:00',7.63),('12374','2013-06-04','15:45:00',5.02),('12374','2013-06-04','15:50:00',5.88),('12374','2013-06-04','15:55:00',7.2),('12374','2013-06-04','16:00:00',7.14),('12374','2013-06-04','16:05:00',7.39),('12374','2013-06-04','16:10:00',5.39),('12374','2013-06-04','16:15:00',3.82),('12374','2013-06-04','16:20:00',3.13),('12374','2013-06-04','16:25:00',3.06),('12374','2013-06-04','16:30:00',2.86),('12374','2013-06-04','16:35:00',2.66),('12374','2013-06-04','16:40:00',2.66),('12374','2013-06-04','16:45:00',2.5),('12374','2013-06-04','16:50:00',2.28),('12374','2013-06-04','16:55:00',2.09),('12374','2013-06-04','17:00:00',1.94),('12374','2013-06-04','17:05:00',1.87),('12374','2013-06-04','17:10:00',1.84),('12374','2013-06-04','17:15:00',1.91),('12374','2013-06-04','17:20:00',2.11),('12374','2013-06-04','17:25:00',2.3),('12374','2013-06-04','17:30:00',2.47),('12374','2013-06-04','17:35:00',2.81),('12374','2013-06-04','17:40:00',3.14),('12374','2013-06-04','17:45:00',3.43),('12374','2013-06-04','17:50:00',3.26),('12374','2013-06-04','17:55:00',2.51),('12374','2013-06-04','18:00:00',1.79),('12374','2013-06-04','18:05:00',1.75),('12374','2013-06-04','18:10:00',1.91),('12374','2013-06-04','18:15:00',1.86),('12374','2013-06-04','18:20:00',1.77),('12374','2013-06-04','18:25:00',1.5),('12374','2013-06-04','18:30:00',1.23),('12374','2013-06-04','18:35:00',1.09),('12374','2013-06-03','06:35:00',1.03),('12374','2013-06-03','06:40:00',1.33),('12374','2013-06-03','06:45:00',1.62),('12374','2013-06-03','06:50:00',1.73),('12374','2013-06-03','06:55:00',1.89),('12374','2013-06-03','07:00:00',2.05),('12374','2013-06-03','07:05:00',2.36),('12374','2013-06-03','07:10:00',2.45),('12374','2013-06-03','07:15:00',2.47),('12374','2013-06-03','07:20:00',1.61),('12374','2013-06-03','07:25:00',1.33),('12374','2013-06-03','07:30:00',1.45),('12374','2013-06-03','07:35:00',1.18),('12374','2013-06-03','07:40:00',1.22),('12374','2013-06-03','07:45:00',1.34),('12374','2013-06-03','07:50:00',1.76),('12374','2013-06-03','07:55:00',1.92),('12374','2013-06-03','08:00:00',1.99),('12374','2013-06-03','08:05:00',2.22),('12374','2013-06-03','08:10:00',2.07),('12374','2013-06-03','08:15:00',1.95),('12374','2013-06-03','08:20:00',1.91),('12374','2013-06-03','08:25:00',1.83),('12374','2013-06-03','08:30:00',3.25),('12374','2013-06-03','08:35:00',4.36),('12374','2013-06-03','08:40:00',3.05),('12374','2013-06-03','08:45:00',4.99),('12374','2013-06-03','08:50:00',3.74),('12374','2013-06-03','08:55:00',2.33),('12374','2013-06-03','09:00:00',3.69),('12374','2013-06-03','09:05:00',3.62),('12374','2013-06-03','09:10:00',2.93),('12374','2013-06-03','09:15:00',2.69),('12374','2013-06-03','09:20:00',2.58),('12374','2013-06-03','09:25:00',2.96),('12374','2013-06-03','09:30:00',3.44),('12374','2013-06-03','09:35:00',3.09),('12374','2013-06-03','09:40:00',3.07),('12374','2013-06-03','09:45:00',3.19),('12374','2013-06-03','09:50:00',3.88),('12374','2013-06-03','09:55:00',5.47),('12374','2013-06-03','10:00:00',4.7),('12374','2013-06-03','10:05:00',6.37),('12374','2013-06-03','10:10:00',4.37),('12374','2013-06-03','10:15:00',5.86),('12374','2013-06-03','10:20:00',4.35),('12374','2013-06-03','10:25:00',4.05),('12374','2013-06-03','10:30:00',6.57),('12374','2013-06-03','10:35:00',6.34),('12374','2013-06-03','10:40:00',6.97),('12374','2013-06-03','10:45:00',5.83),('12374','2013-06-03','10:50:00',7.7),('12374','2013-06-03','10:55:00',4.45),('12374','2013-06-03','11:00:00',4.36),('12374','2013-06-03','11:05:00',3.38),('12374','2013-06-03','11:10:00',3.33),('12374','2013-06-03','11:15:00',4.03),('12374','2013-06-03','11:20:00',9.74),('12374','2013-06-03','11:25:00',8.2),('12374','2013-06-03','11:30:00',4.62),('12374','2013-06-03','11:35:00',4.42),('12374','2013-06-03','11:40:00',3.01),('12374','2013-06-03','11:45:00',4.92),('12374','2013-06-03','11:50:00',4.51),('12374','2013-06-03','11:55:00',6.07),('12374','2013-06-03','12:00:00',4.94),('12374','2013-06-03','12:05:00',8.62),('12374','2013-06-03','12:10:00',9.49),('12374','2013-06-03','12:15:00',9.33),('12374','2013-06-03','12:20:00',8.93),('12374','2013-06-03','12:25:00',8.79),('12374','2013-06-03','12:30:00',5.07),('12374','2013-06-03','12:35:00',6.49),('12374','2013-06-03','12:40:00',8.98),('12374','2013-06-03','12:45:00',8.44),('12374','2013-06-03','12:50:00',9.26),('12374','2013-06-03','12:55:00',9.63),('12374','2013-06-03','13:00:00',6.64),('12374','2013-06-03','13:05:00',7.5),('12374','2013-06-03','13:10:00',4.85),('12374','2013-06-03','13:15:00',4.36),('12374','2013-06-03','13:20:00',5.14),('12374','2013-06-03','13:25:00',9.42),('12374','2013-06-03','13:30:00',9.3),('12374','2013-06-03','13:35:00',9.33),('12374','2013-06-03','13:40:00',9.22),('12374','2013-06-03','13:45:00',9.26),('12374','2013-06-03','13:50:00',9.35),('12374','2013-06-03','13:55:00',9.51),('12374','2013-06-03','14:00:00',8.33),('12374','2013-06-03','14:05:00',4.47),('12374','2013-06-03','14:10:00',3.31),('12374','2013-06-03','14:15:00',4.2),('12374','2013-06-03','14:20:00',9.03),('12374','2013-06-03','14:25:00',8.45),('12374','2013-06-03','14:30:00',8.73),('12374','2013-06-03','14:35:00',8.76),('12374','2013-06-03','14:40:00',8.9),('12374','2013-06-03','14:45:00',7.99),('12374','2013-06-03','14:50:00',6.93),('12374','2013-06-03','14:55:00',8.36),('12374','2013-06-03','15:00:00',8.17),('12374','2013-06-03','15:05:00',7.59),('12374','2013-06-03','15:10:00',8.02),('12374','2013-06-03','15:15:00',7.21),('12374','2013-06-03','15:20:00',7.18),('12374','2013-06-03','15:25:00',7.9),('12374','2013-06-03','15:30:00',6.44),('12374','2013-06-03','15:35:00',7.69),('12374','2013-06-03','15:40:00',7.62),('12374','2013-06-03','15:45:00',7.52),('12374','2013-06-03','15:50:00',7.38),('12374','2013-06-03','15:55:00',7.21),('12374','2013-06-03','16:00:00',7.11),('12374','2013-06-03','16:05:00',6.94),('12374','2013-06-03','16:10:00',6.7),('12374','2013-06-03','16:15:00',6.92),('12374','2013-06-03','16:20:00',6.55),('12374','2013-06-03','16:25:00',5.76),('12374','2013-06-03','16:30:00',4.39),('12374','2013-06-03','16:35:00',4.38),('12374','2013-06-03','16:40:00',3.86),('12374','2013-06-03','16:45:00',5.29),('12374','2013-06-03','16:50:00',5.28),('12374','2013-06-03','16:55:00',4.99),('12374','2013-06-03','17:00:00',4.33),('12374','2013-06-03','17:05:00',3.65),('12374','2013-06-03','17:10:00',3.96),('12374','2013-06-03','17:15:00',3.88),('12374','2013-06-03','17:20:00',3.12),('12374','2013-06-03','17:25:00',2.68),('12374','2013-06-03','17:30:00',2.49),('12374','2013-06-03','17:35:00',2.41),('12374','2013-06-03','17:40:00',2.35),('12374','2013-06-03','17:45:00',2.29),('12374','2013-06-03','17:50:00',2.09),('12374','2013-06-03','17:55:00',1.68),('12374','2013-06-03','18:00:00',1.49),('12374','2013-06-03','18:05:00',1.4),('12374','2013-06-03','18:10:00',1.44),('12374','2013-06-03','18:15:00',1.5),('12374','2013-06-03','18:20:00',1.49),('12374','2013-06-03','18:25:00',1.47),('12374','2013-06-03','18:30:00',1.41),('12374','2013-06-03','18:35:00',1.21),('12374','2013-06-02','07:45:00',1.06),('12374','2013-06-02','07:50:00',1.44),('12374','2013-06-02','07:55:00',1.6),('12374','2013-06-02','08:00:00',1.12),('12374','2013-06-02','08:05:00',2.54),('12374','2013-06-02','08:10:00',4.68),('12374','2013-06-02','08:15:00',4.68),('12374','2013-06-02','08:20:00',4.65),('12374','2013-06-02','08:25:00',4.64),('12374','2013-06-02','08:30:00',4.79),('12374','2013-06-02','08:35:00',5),('12374','2013-06-02','08:40:00',5.37),('12374','2013-06-02','08:45:00',5.41),('12374','2013-06-02','08:50:00',5.28),('12374','2013-06-02','08:55:00',5.42),('12374','2013-06-02','09:00:00',5.49),('12374','2013-06-02','09:05:00',5.57),('12374','2013-06-02','09:10:00',5.69),('12374','2013-06-02','09:15:00',5.87),('12374','2013-06-02','09:20:00',6),('12374','2013-06-02','09:25:00',6.14),('12374','2013-06-02','09:30:00',6.25),('12374','2013-06-02','09:35:00',6.38),('12374','2013-06-02','09:40:00',5.94),('12374','2013-06-02','09:45:00',6.7),('12374','2013-06-02','09:50:00',6.6),('12374','2013-06-02','09:55:00',6.92),('12374','2013-06-02','10:00:00',7.07),('12374','2013-06-02','10:05:00',7.14),('12374','2013-06-02','10:10:00',7.31),('12374','2013-06-02','10:15:00',7.51),('12374','2013-06-02','10:20:00',8.1),('12374','2013-06-02','10:25:00',6.11),('12374','2013-06-02','10:30:00',4.28),('12374','2013-06-02','10:35:00',5.51),('12374','2013-06-02','10:40:00',4.77),('12374','2013-06-02','10:45:00',3.65),('12374','2013-06-02','10:50:00',8.79),('12374','2013-06-02','10:55:00',8.79),('12374','2013-06-02','11:00:00',8.57),('12374','2013-06-02','11:05:00',8.39),('12374','2013-06-02','11:10:00',8.49),('12374','2013-06-02','11:15:00',8.55),('12374','2013-06-02','11:20:00',8.61),('12374','2013-06-02','11:25:00',8.68),('12374','2013-06-02','11:30:00',8.79),('12374','2013-06-02','11:35:00',8.82),('12374','2013-06-02','11:40:00',8.91),('12374','2013-06-02','11:45:00',8.99),('12374','2013-06-02','11:50:00',8.98),('12374','2013-06-02','11:55:00',8.98),('12374','2013-06-02','12:00:00',9.03),('12374','2013-06-02','12:05:00',9.04),('12374','2013-06-02','12:10:00',9.06),('12374','2013-06-02','12:15:00',9.12),('12374','2013-06-02','12:20:00',9.11),('12374','2013-06-02','12:25:00',9.14),('12374','2013-06-02','12:30:00',9.27),('12374','2013-06-02','12:35:00',9.21),('12374','2013-06-02','12:40:00',9.22),('12374','2013-06-02','12:45:00',9.29),('12374','2013-06-02','12:50:00',9.29),('12374','2013-06-02','12:55:00',9.26),('12374','2013-06-02','13:00:00',9.29),('12374','2013-06-02','13:05:00',9.27),('12374','2013-06-02','13:10:00',9.23),('12374','2013-06-02','13:15:00',9.26),('12374','2013-06-02','13:20:00',9.25),('12374','2013-06-02','13:25:00',9.21),('12374','2013-06-02','13:30:00',9.12),('12374','2013-06-02','13:35:00',9.14),('12374','2013-06-02','13:40:00',9.18),('12374','2013-06-02','13:45:00',7.32),('12374','2013-06-02','13:50:00',6.83),('12374','2013-06-02','13:55:00',8.81),('12374','2013-06-02','14:00:00',6.92),('12374','2013-06-02','14:05:00',7.53),('12374','2013-06-02','14:10:00',6.1),('12374','2013-06-02','14:15:00',5.9),('12374','2013-06-02','14:20:00',7.67),('12374','2013-06-02','14:25:00',8.01),('12374','2013-06-02','14:30:00',7.16),('12374','2013-06-02','14:35:00',6.26),('12374','2013-06-02','14:40:00',7.62),('12374','2013-06-02','14:45:00',5.83),('12374','2013-06-02','14:50:00',6.08),('12374','2013-06-02','14:55:00',7.85),('12374','2013-06-02','15:00:00',6.1),('12374','2013-06-02','15:05:00',8.01),('12374','2013-06-02','15:10:00',8.16),('12374','2013-06-02','15:15:00',7.92),('12374','2013-06-02','15:20:00',8.23),('12374','2013-06-02','15:25:00',7.57),('12374','2013-06-02','15:30:00',7.45),('12374','2013-06-02','15:35:00',7.83),('12374','2013-06-02','15:40:00',7.59),('12374','2013-06-02','15:45:00',5.68),('12374','2013-06-02','15:50:00',5.25),('12374','2013-06-02','15:55:00',3.58),('12374','2013-06-02','16:00:00',4.65),('12374','2013-06-02','16:05:00',3.88),('12374','2013-06-02','16:10:00',3.61),('12374','2013-06-02','16:15:00',3.03),('12374','2013-06-02','16:20:00',2.68),('12374','2013-06-02','16:25:00',2.81),('12374','2013-06-02','16:30:00',3.02),('12374','2013-06-02','16:35:00',2.98),('12374','2013-06-02','16:40:00',2.77),('12374','2013-06-02','16:45:00',2.42),('12374','2013-06-02','16:50:00',2.41),('12374','2013-06-02','16:55:00',2.23),('12374','2013-06-02','17:00:00',2.05),('12374','2013-06-02','17:05:00',2.26),('12374','2013-06-02','17:10:00',2.24),('12374','2013-06-02','17:15:00',2.6),('12374','2013-06-02','17:20:00',2.32),('12374','2013-06-02','17:25:00',1.95),('12374','2013-06-02','17:30:00',1.96),('12374','2013-06-02','17:35:00',1.94),('12374','2013-06-02','17:40:00',1.87),('12374','2013-06-02','17:45:00',1.86),('12374','2013-06-02','17:50:00',1.77),('12374','2013-06-02','17:55:00',1.78),('12374','2013-06-02','18:00:00',1.75),('12374','2013-06-02','18:05:00',1.76),('12374','2013-06-02','18:10:00',1.79),('12374','2013-06-02','18:15:00',1.64),('12374','2013-06-02','18:20:00',1.89),('12374','2013-06-02','18:25:00',1.7),('12374','2013-06-02','18:30:00',1.43),('12374','2013-06-02','18:35:00',1.36),('12374','2013-06-02','18:40:00',1.28),('12374','2013-06-02','18:45:00',1.33),('12374','2013-06-02','18:50:00',1.32),('12374','2013-06-02','18:55:00',1.12),('12374','2013-06-02','19:05:00',1.16),('12374','2013-06-02','19:10:00',1.49),('12374','2013-06-02','19:25:00',1.24),('12374','2013-06-02','19:30:00',1.2),('12374','2013-06-02','19:35:00',1.12),('12374','2013-06-01','06:35:00',1.43),('12374','2013-06-01','06:40:00',1.47),('12374','2013-06-01','06:45:00',1.24),('12374','2013-06-01','07:15:00',2.31),('12374','2013-06-01','07:20:00',1.12),('12374','2013-06-01','07:35:00',1.07),('12374','2013-06-01','07:40:00',2.65),('12374','2013-06-01','07:45:00',3.85),('12374','2013-06-01','07:50:00',3.17),('12374','2013-06-01','07:55:00',3.06),('12374','2013-06-01','08:00:00',2.93),('12374','2013-06-01','08:05:00',2.34),('12374','2013-06-01','08:10:00',2.5),('12374','2013-06-01','08:15:00',1.95),('12374','2013-06-01','08:20:00',3.56),('12374','2013-06-01','08:25:00',2.8),('12374','2013-06-01','08:30:00',1.6),('12374','2013-06-01','08:35:00',2.18),('12374','2013-06-01','08:40:00',2.66),('12374','2013-06-01','08:45:00',2.85),('12374','2013-06-01','08:50:00',2.37),('12374','2013-06-01','08:55:00',3.04),('12374','2013-06-01','09:00:00',3.32),('12374','2013-06-01','09:05:00',2.93),('12374','2013-06-01','09:10:00',3.25),('12374','2013-06-01','09:15:00',3),('12374','2013-06-01','09:20:00',3.34),('12374','2013-06-01','09:25:00',4.57),('12374','2013-06-01','09:30:00',6.84),('12374','2013-06-01','09:35:00',6.01),('12374','2013-06-01','09:40:00',2.66),('12374','2013-06-01','09:45:00',3.44),('12374','2013-06-01','09:50:00',4.28),('12374','2013-06-01','09:55:00',3.92),('12374','2013-06-01','10:00:00',4.33),('12374','2013-06-01','10:05:00',3.34),('12374','2013-06-01','10:10:00',2.84),('12374','2013-06-01','10:15:00',2.15),('12374','2013-06-01','10:20:00',1.28),('12374','2013-06-01','10:25:00',1.47),('12374','2013-06-01','10:30:00',1.62),('12374','2013-06-01','10:35:00',1.83),('12374','2013-06-01','10:40:00',2.96),('12374','2013-06-01','10:45:00',2.75),('12374','2013-06-01','10:50:00',1.6),('12374','2013-06-01','10:55:00',2.39),('12374','2013-06-01','11:00:00',2.94),('12374','2013-06-01','11:05:00',3.05),('12374','2013-06-01','11:10:00',3.24),('12374','2013-06-01','11:15:00',3.39),('12374','2013-06-01','11:20:00',2.96),('12374','2013-06-01','11:25:00',2.67),('12374','2013-06-01','11:30:00',2.32),('12374','2013-06-01','11:35:00',2.13),('12374','2013-06-01','11:40:00',2.2),('12374','2013-06-01','11:45:00',3.02),('12374','2013-06-01','11:50:00',3.04),('12374','2013-06-01','11:55:00',4.07),('12374','2013-06-01','12:00:00',3.73),('12374','2013-06-01','12:05:00',5.54),('12374','2013-06-01','12:10:00',8.24),('12374','2013-06-01','12:15:00',4.59),('12374','2013-06-01','12:20:00',3.51),('12374','2013-06-01','12:25:00',3.8),('12374','2013-06-01','12:30:00',3.54),('12374','2013-06-01','12:35:00',4.43),('12374','2013-06-01','12:40:00',5.61),('12374','2013-06-01','12:45:00',6.01),('12374','2013-06-01','12:50:00',5.79),('12374','2013-06-01','12:55:00',5.01),('12374','2013-06-01','13:00:00',4.61),('12374','2013-06-01','13:05:00',4.71),('12374','2013-06-01','13:10:00',4.82),('12374','2013-06-01','13:15:00',4.96),('12374','2013-06-01','13:20:00',4.73),('12374','2013-06-01','13:25:00',4.35),('12374','2013-06-01','13:30:00',4.5),('12374','2013-06-01','13:35:00',5.57),('12374','2013-06-01','13:40:00',5.48),('12374','2013-06-01','13:45:00',5.03),('12374','2013-06-01','13:50:00',5.07),('12374','2013-06-01','13:55:00',4.51),('12374','2013-06-01','14:00:00',3.31),('12374','2013-06-01','14:05:00',3.29),('12374','2013-06-01','14:10:00',3.46),('12374','2013-06-01','14:15:00',3.49),('12374','2013-06-01','14:20:00',3),('12374','2013-06-01','14:25:00',2.59),('12374','2013-06-01','14:30:00',3.48),('12374','2013-06-01','14:35:00',2.93),('12374','2013-06-01','14:40:00',3.48),('12374','2013-06-01','14:45:00',3.84),('12374','2013-06-01','14:50:00',3.38),('12374','2013-06-01','14:55:00',2.99),('12374','2013-06-01','15:00:00',3.03),('12374','2013-06-01','15:05:00',2.79),('12374','2013-06-01','15:10:00',2.7),('12374','2013-06-01','15:15:00',2.68),('12374','2013-06-01','15:20:00',2.77),('12374','2013-06-01','15:25:00',3.39),('12374','2013-06-01','15:30:00',3.48),('12374','2013-06-01','15:35:00',3.17),('12374','2013-06-01','15:40:00',2.78),('12374','2013-06-01','15:45:00',3.26),('12374','2013-06-01','15:50:00',3.33),('12374','2013-06-01','15:55:00',2.73),('12374','2013-06-01','16:00:00',2.44),('12374','2013-06-01','16:05:00',2.33),('12374','2013-06-01','16:10:00',2.1),('12374','2013-06-01','16:15:00',1.8),('12374','2013-06-01','16:20:00',1.59),('12374','2013-06-01','16:25:00',1.42),('12374','2013-06-01','16:30:00',1.19),('12374','2013-06-01','16:35:00',1.02),('12374','2013-06-01','16:40:00',1.09),('12374','2013-06-01','16:45:00',1.38),('12374','2013-06-01','16:50:00',1.85),('12374','2013-06-01','16:55:00',2.56),('12374','2013-06-01','17:00:00',2.78),('12374','2013-06-01','17:05:00',2.42),('12374','2013-06-01','17:10:00',1.75),('12374','2013-06-01','17:15:00',1.5),('12374','2013-06-01','17:20:00',2.34),('12374','2013-06-01','17:25:00',4.41),('12374','2013-06-01','17:30:00',5.53),('12374','2013-06-01','17:35:00',4.01),('12374','2013-06-01','17:40:00',2.58),('12374','2013-06-01','17:45:00',4.03),('12374','2013-06-01','17:50:00',3.85),('12374','2013-06-01','17:55:00',3.8),('12374','2013-06-01','18:00:00',2.78),('12374','2013-06-01','18:05:00',3.04),('12374','2013-06-01','18:10:00',3.02),('12374','2013-06-01','18:15:00',1.03),('12374','2013-06-01','18:30:00',1.77),('12374','2013-06-01','18:35:00',1.38),('12374','2013-06-01','18:55:00',1.27),('12374','2013-06-01','19:00:00',1.94),('12374','2013-06-01','19:05:00',2.01),('12374','2013-06-01','19:10:00',1.83),('12374','2013-06-01','19:15:00',1.8),('12374','2013-06-01','19:20:00',1.55),('12374','2013-06-01','19:25:00',1.78),('12374','2013-06-01','19:30:00',1.58),('12374','2013-05-31','06:35:00',1.02),('12374','2013-05-31','06:40:00',1.16),('12374','2013-05-31','06:45:00',1.16),('12374','2013-05-31','06:50:00',1.33),('12374','2013-05-31','06:55:00',1.12),('12374','2013-05-31','07:00:00',1.64),('12374','2013-05-31','07:05:00',1.83),('12374','2013-05-31','07:10:00',1.69),('12374','2013-05-31','07:15:00',2.23),('12374','2013-05-31','07:20:00',2.53),('12374','2013-05-31','07:25:00',2.79),('12374','2013-05-31','07:30:00',2.65),('12374','2013-05-31','07:35:00',3.25),('12374','2013-05-31','07:40:00',3.97),('12374','2013-05-31','07:45:00',4.54),('12374','2013-05-31','07:50:00',2.57),('12374','2013-05-31','07:55:00',1.28),('12374','2013-05-31','08:05:00',2.2),('12374','2013-05-31','08:10:00',4.36),('12374','2013-05-31','08:15:00',4.35),('12374','2013-05-31','08:20:00',4.14),('12374','2013-05-31','08:25:00',4.93),('12374','2013-05-31','08:30:00',4.59),('12374','2013-05-31','08:35:00',5.43),('12374','2013-05-31','08:40:00',2.47),('12374','2013-05-31','08:45:00',3.36),('12374','2013-05-31','08:50:00',2.85),('12374','2013-05-31','08:55:00',4.75),('12374','2013-05-31','09:00:00',4.12),('12374','2013-05-31','09:05:00',6.08),('12374','2013-05-31','09:10:00',6.05),('12374','2013-05-31','09:15:00',6.1),('12374','2013-05-31','09:20:00',6.23),('12374','2013-05-31','09:25:00',6.47),('12374','2013-05-31','09:30:00',6.37),('12374','2013-05-31','09:35:00',5.76),('12374','2013-05-31','09:40:00',5.71),('12374','2013-05-31','09:45:00',3.5),('12374','2013-05-31','09:50:00',4.54),('12374','2013-05-31','09:55:00',5.92),('12374','2013-05-31','10:00:00',7.51),('12374','2013-05-31','10:05:00',5.35),('12374','2013-05-31','10:10:00',3.31),('12374','2013-05-31','10:15:00',3.35),('12374','2013-05-31','10:20:00',2.92),('12374','2013-05-31','10:25:00',5.14),('12374','2013-05-31','10:30:00',7.99),('12374','2013-05-31','10:35:00',4.68),('12374','2013-05-31','10:40:00',2.1),('12374','2013-05-31','10:45:00',6.93),('12374','2013-05-31','10:50:00',8.31),('12374','2013-05-31','10:55:00',8.83),('12374','2013-05-31','11:00:00',8.78),('12374','2013-05-31','11:05:00',7.72),('12374','2013-05-31','11:10:00',7.51),('12374','2013-05-31','11:15:00',7.8),('12374','2013-05-31','11:20:00',7.54),('12374','2013-05-31','11:25:00',9.01),('12374','2013-05-31','11:30:00',9.14),('12374','2013-05-31','11:35:00',7.56),('12374','2013-05-31','11:40:00',6.69),('12374','2013-05-31','11:45:00',2.47),('12374','2013-05-31','11:50:00',2.73),('12374','2013-05-31','11:55:00',4.86),('12374','2013-05-31','12:00:00',1.23),('12374','2013-05-31','12:05:00',5),('12374','2013-05-31','12:10:00',6.43),('12374','2013-05-31','12:15:00',8.72),('12374','2013-05-31','12:20:00',6.9),('12374','2013-05-31','12:25:00',4.75),('12374','2013-05-31','12:30:00',5.27),('12374','2013-05-31','12:35:00',4.41),('12374','2013-05-31','12:40:00',3.41),('12374','2013-05-31','12:45:00',2.27),('12374','2013-05-31','12:50:00',2.42),('12374','2013-05-31','12:55:00',2.55),('12374','2013-05-31','13:00:00',2.51),('12374','2013-05-31','13:05:00',3.77),('12374','2013-05-31','13:10:00',6.51),('12374','2013-05-31','13:15:00',7.39),('12374','2013-05-31','13:20:00',7.89),('12374','2013-05-31','13:25:00',6.3),('12374','2013-05-31','13:30:00',3.7),('12374','2013-05-31','13:35:00',3.98),('12374','2013-05-31','13:40:00',4.18),('12374','2013-05-31','13:45:00',3.74),('12374','2013-05-31','13:50:00',5.16),('12374','2013-05-31','13:55:00',6.83),('12374','2013-05-31','14:00:00',6.44),('12374','2013-05-31','14:05:00',5.16),('12374','2013-05-31','14:10:00',4.5),('12374','2013-05-31','14:15:00',4.76),('12374','2013-05-31','14:20:00',6.27),('12374','2013-05-31','14:25:00',5.3),('12374','2013-05-31','14:30:00',2.03),('12374','2013-05-31','14:35:00',1.05),('12374','2013-05-31','14:40:00',1.52),('12374','2013-05-31','14:45:00',1.74),('12374','2013-05-31','14:50:00',3.34),('12374','2013-05-31','14:55:00',3.51),('12374','2013-05-31','15:00:00',1.68),('12374','2013-05-31','15:05:00',1.72),('12374','2013-05-31','15:10:00',2.61),('12374','2013-05-31','15:15:00',2.8),('12374','2013-05-31','15:20:00',3.01),('12374','2013-05-31','15:25:00',2.7),('12374','2013-05-31','15:30:00',2.26),('12374','2013-05-31','15:35:00',2.73),('12374','2013-05-31','15:40:00',4.22),('12374','2013-05-31','15:45:00',2.92),('12374','2013-05-31','15:50:00',2.29),('12374','2013-05-31','15:55:00',3.33),('12374','2013-05-31','16:00:00',4.02),('12374','2013-05-31','16:05:00',4.11),('12374','2013-05-31','16:10:00',3.8),('12374','2013-05-31','16:15:00',3.75),('12374','2013-05-31','16:20:00',3.51),('12374','2013-05-31','16:25:00',3.35),('12374','2013-05-31','16:30:00',3.06),('12374','2013-05-31','16:35:00',2.97),('12374','2013-05-31','16:40:00',2.74),('12374','2013-05-31','16:45:00',2.27),('12374','2013-05-31','16:50:00',1.68),('12374','2013-05-31','16:55:00',1.78),('12374','2013-05-31','17:00:00',1.94),('12374','2013-05-31','17:05:00',1.8),('12374','2013-05-31','17:10:00',1.49),('12374','2013-05-31','17:15:00',1.35),('12374','2013-05-31','17:20:00',1.57),('12374','2013-05-31','17:25:00',1.54),('12374','2013-05-31','17:30:00',1.32),('12374','2013-05-31','17:35:00',1.16),('12374','2013-05-31','17:55:00',1.13),('12374','2013-05-31','18:00:00',1.47),('12374','2013-05-31','18:05:00',1.23),('12374','2013-05-31','18:10:00',1.03),('12374','2013-05-31','18:15:00',1.07),('12374','2013-05-31','18:40:00',1.09),('12374','2013-05-31','18:45:00',1.08),('12374','2013-05-30','07:05:00',2.06),('12374','2013-05-30','07:10:00',2.15),('12374','2013-05-30','07:15:00',1.96),('12374','2013-05-30','07:20:00',3.31),('12374','2013-05-30','07:25:00',2.7),('12374','2013-05-30','07:30:00',1.78),('12374','2013-05-30','07:35:00',1.99),('12374','2013-05-30','07:40:00',3.36),('12374','2013-05-30','07:45:00',3.33),('12374','2013-05-30','07:50:00',3.42),('12374','2013-05-30','07:55:00',2.85),('12374','2013-05-30','08:00:00',2.61),('12374','2013-05-30','08:05:00',4.1),('12374','2013-05-30','08:10:00',4.08),('12374','2013-05-30','08:15:00',4.13),('12374','2013-05-30','08:20:00',4.41),('12374','2013-05-30','08:25:00',4.59),('12374','2013-05-30','08:30:00',4.65),('12374','2013-05-30','08:35:00',4.82),('12374','2013-05-30','08:40:00',4.93),('12374','2013-05-30','08:45:00',5.12),('12374','2013-05-30','08:50:00',5.39),('12374','2013-05-30','08:55:00',5.34),('12374','2013-05-30','09:00:00',5.58),('12374','2013-05-30','09:05:00',5.72),('12374','2013-05-30','09:10:00',5.96),('12374','2013-05-30','09:15:00',6),('12374','2013-05-30','09:20:00',5.99),('12374','2013-05-30','09:25:00',5.88),('12374','2013-05-30','09:30:00',6.98),('12374','2013-05-30','09:35:00',4.36),('12374','2013-05-30','09:40:00',3.62),('12374','2013-05-30','09:45:00',4.34),('12374','2013-05-30','09:50:00',6.64),('12374','2013-05-30','09:55:00',7.04),('12374','2013-05-30','10:00:00',7.92),('12374','2013-05-30','10:05:00',7.81),('12374','2013-05-30','10:10:00',6.81),('12374','2013-05-30','10:15:00',8.45),('12374','2013-05-30','10:20:00',7.43),('12374','2013-05-30','10:25:00',6.71),('12374','2013-05-30','10:30:00',6.01),('12374','2013-05-30','10:35:00',6.22),('12374','2013-05-30','10:40:00',6.9),('12374','2013-05-30','10:45:00',6.42),('12374','2013-05-30','10:50:00',2.67),('12374','2013-05-30','10:55:00',3.17),('12374','2013-05-30','11:00:00',8.48),('12374','2013-05-30','11:05:00',9.11),('12374','2013-05-30','11:10:00',8.99),('12374','2013-05-30','11:15:00',8.93),('12374','2013-05-30','11:20:00',9.15),('12374','2013-05-30','11:25:00',9.37),('12374','2013-05-30','11:30:00',8.87),('12374','2013-05-30','11:35:00',9.29),('12374','2013-05-30','11:40:00',9.08),('12374','2013-05-30','11:45:00',8.91),('12374','2013-05-30','11:50:00',9.61),('12374','2013-05-30','11:55:00',9.32),('12374','2013-05-30','12:00:00',7.33),('12374','2013-05-30','12:05:00',9.45),('12374','2013-05-30','12:10:00',9.41),('12374','2013-05-30','12:15:00',9.45),('12374','2013-05-30','12:20:00',9.45),('12374','2013-05-30','12:25:00',9.44),('12374','2013-05-30','12:30:00',9.45),('12374','2013-05-30','12:35:00',9.51),('12374','2013-05-30','12:40:00',9.51),('12374','2013-05-30','12:45:00',9.51),('12374','2013-05-30','12:50:00',9.48),('12374','2013-05-30','12:55:00',9.47),('12374','2013-05-30','13:00:00',9.55),('12374','2013-05-30','13:05:00',9.69),('12374','2013-05-30','13:10:00',9.6),('12374','2013-05-30','13:15:00',9.54),('12374','2013-05-30','13:20:00',5.7),('12374','2013-05-30','13:25:00',5.68),('12374','2013-05-30','13:30:00',8.26),('12374','2013-05-30','13:35:00',8.57),('12374','2013-05-30','13:40:00',7.35),('12374','2013-05-30','13:45:00',5.48),('12374','2013-05-30','13:50:00',7),('12374','2013-05-30','13:55:00',7.8),('12374','2013-05-30','14:00:00',6.68),('12374','2013-05-30','14:05:00',9.71),('12374','2013-05-30','14:10:00',5.9),('12374','2013-05-30','14:15:00',7.35),('12374','2013-05-30','14:20:00',3.13),('12374','2013-05-30','14:25:00',7.78),('12374','2013-05-30','14:30:00',8.44),('12374','2013-05-30','14:35:00',8.78),('12374','2013-05-30','14:40:00',5.02),('12374','2013-05-30','14:45:00',6.05),('12374','2013-05-30','14:50:00',4.22),('12374','2013-05-30','14:55:00',4.33),('12374','2013-05-30','15:00:00',4.1),('12374','2013-05-30','15:05:00',7.35),('12374','2013-05-30','15:10:00',7.29),('12374','2013-05-30','15:15:00',3.31),('12374','2013-05-30','15:20:00',3.57),('12374','2013-05-30','15:25:00',4),('12374','2013-05-30','15:30:00',4.69),('12374','2013-05-30','15:35:00',3.44),('12374','2013-05-30','15:40:00',2.49),('12374','2013-05-30','15:45:00',3.19),('12374','2013-05-30','15:50:00',3.78),('12374','2013-05-30','15:55:00',3.14),('12374','2013-05-30','16:00:00',3),('12374','2013-05-30','16:05:00',3.97),('12374','2013-05-30','16:10:00',5.43),('12374','2013-05-30','16:15:00',5.26),('12374','2013-05-30','16:20:00',6.24),('12374','2013-05-30','16:25:00',8.04),('12374','2013-05-30','16:30:00',3.73),('12374','2013-05-30','16:35:00',2.96),('12374','2013-05-30','16:40:00',2.33),('12374','2013-05-30','16:45:00',1.78),('12374','2013-05-30','16:50:00',1.57),('12374','2013-05-30','16:55:00',3.99),('12374','2013-05-30','17:00:00',6.92),('12374','2013-05-30','17:05:00',6.23),('12374','2013-05-30','17:10:00',5.21),('12374','2013-05-30','17:15:00',5.44),('12374','2013-05-30','17:20:00',3.93),('12374','2013-05-30','17:25:00',2.49),('12374','2013-05-30','17:30:00',2.96),('12374','2013-05-30','17:35:00',3.18),('12374','2013-05-30','17:40:00',1.56),('12374','2013-05-30','17:45:00',1.51),('12374','2013-05-30','17:50:00',2.94),('12374','2013-05-30','17:55:00',4),('12374','2013-05-30','18:00:00',2.11),('12374','2013-05-30','18:05:00',1.58),('12374','2013-05-30','18:10:00',1.4),('12374','2013-05-30','18:15:00',1.18),('12374','2013-05-30','19:05:00',1.06),('12374','2013-05-29','06:40:00',1.11),('12374','2013-05-29','06:45:00',1.17),('12374','2013-05-29','06:50:00',1.23),('12374','2013-05-29','06:55:00',1.48),('12374','2013-05-29','07:00:00',1.61),('12374','2013-05-29','07:05:00',1.75),('12374','2013-05-29','07:10:00',1.62),('12374','2013-05-29','07:15:00',2.03),('12374','2013-05-29','07:20:00',2.24),('12374','2013-05-29','07:25:00',2.45),('12374','2013-05-29','07:30:00',2.62),('12374','2013-05-29','07:35:00',2.79),('12374','2013-05-29','07:40:00',2.95),('12374','2013-05-29','07:45:00',3.13),('12374','2013-05-29','07:50:00',3.29),('12374','2013-05-29','07:55:00',3.46),('12374','2013-05-29','08:00:00',3.62),('12374','2013-05-29','08:05:00',3.81),('12374','2013-05-29','08:10:00',4),('12374','2013-05-29','08:15:00',4.16),('12374','2013-05-29','08:20:00',4.3),('12374','2013-05-29','08:25:00',4.49),('12374','2013-05-29','08:30:00',4.68),('12374','2013-05-29','08:35:00',4.85),('12374','2013-05-29','08:40:00',5),('12374','2013-05-29','08:45:00',5.17),('12374','2013-05-29','08:50:00',5.12),('12374','2013-05-29','08:55:00',5.28),('12374','2013-05-29','09:00:00',5.65),('12374','2013-05-29','09:05:00',5.77),('12374','2013-05-29','09:10:00',5.89),('12374','2013-05-29','09:15:00',5.77),('12374','2013-05-29','09:20:00',6.02),('12374','2013-05-29','09:25:00',6.14),('12374','2013-05-29','09:30:00',6.23),('12374','2013-05-29','09:35:00',6.34),('12374','2013-05-29','09:40:00',6.57),('12374','2013-05-29','09:45:00',6.78),('12374','2013-05-29','09:50:00',6.96),('12374','2013-05-29','09:55:00',6.73),('12374','2013-05-29','10:00:00',7.1),('12374','2013-05-29','10:05:00',7.21),('12374','2013-05-29','10:10:00',7.32),('12374','2013-05-29','10:15:00',7.39),('12374','2013-05-29','10:20:00',7.51),('12374','2013-05-29','10:25:00',7.64),('12374','2013-05-29','10:30:00',7.74),('12374','2013-05-29','10:35:00',7.86),('12374','2013-05-29','10:40:00',7.97),('12374','2013-05-29','10:45:00',8.08),('12374','2013-05-29','10:50:00',8.19),('12374','2013-05-29','10:55:00',8.26),('12374','2013-05-29','11:00:00',8.38),('12374','2013-05-29','11:05:00',8.43),('12374','2013-05-29','11:10:00',8.56),('12374','2013-05-29','11:15:00',8.64),('12374','2013-05-29','11:20:00',8.78),('12374','2013-05-29','11:25:00',8.81),('12374','2013-05-29','11:30:00',8.92),('12374','2013-05-29','11:35:00',9.09),('12374','2013-05-29','11:40:00',9.23),('12374','2013-05-29','11:45:00',8.96),('12374','2013-05-29','11:50:00',9.2),('12374','2013-05-29','11:55:00',9.06),('12374','2013-05-29','12:00:00',9.02),('12374','2013-05-29','12:05:00',9.16),('12374','2013-05-29','12:10:00',9.31),('12374','2013-05-29','12:15:00',9.34),('12374','2013-05-29','12:20:00',9.36),('12374','2013-05-29','12:25:00',9.35),('12374','2013-05-29','12:30:00',9.35),('12374','2013-05-29','12:35:00',9.32),('12374','2013-05-29','12:40:00',9.37),('12374','2013-05-29','12:45:00',9.43),('12374','2013-05-29','12:50:00',9.42),('12374','2013-05-29','12:55:00',9.43),('12374','2013-05-29','13:00:00',9.41),('12374','2013-05-29','13:05:00',9.33),('12374','2013-05-29','13:10:00',9.4),('12374','2013-05-29','13:15:00',9.39),('12374','2013-05-29','13:20:00',9.44),('12374','2013-05-29','13:25:00',9.49),('12374','2013-05-29','13:30:00',9.51),('12374','2013-05-29','13:35:00',9.46),('12374','2013-05-29','13:40:00',9.44),('12374','2013-05-29','13:45:00',9.33),('12374','2013-05-29','13:50:00',9.21),('12374','2013-05-29','13:55:00',9.27),('12374','2013-05-29','14:00:00',9.21),('12374','2013-05-29','14:05:00',9.16),('12374','2013-05-29','14:10:00',9.12),('12374','2013-05-29','14:15:00',9.18),('12374','2013-05-29','14:20:00',9.13),('12374','2013-05-29','14:25:00',8.68),('12374','2013-05-29','14:30:00',8.89),('12374','2013-05-29','14:35:00',9.05),('12374','2013-05-29','14:40:00',4.28),('12374','2013-05-29','14:45:00',4.06),('12374','2013-05-29','14:50:00',7.9),('12374','2013-05-29','14:55:00',6.79),('12374','2013-05-29','15:00:00',8.98),('12374','2013-05-29','15:05:00',8.62),('12374','2013-05-29','15:10:00',8.45),('12374','2013-05-29','15:15:00',8.2),('12374','2013-05-29','15:20:00',7.99),('12374','2013-05-29','15:25:00',8.09),('12374','2013-05-29','15:30:00',7.97),('12374','2013-05-29','15:35:00',7.92),('12374','2013-05-29','15:40:00',4.87),('12374','2013-05-29','15:45:00',4.22),('12374','2013-05-29','15:50:00',5.04),('12374','2013-05-29','15:55:00',5.13),('12374','2013-05-29','16:00:00',6.39),('12374','2013-05-29','16:05:00',4.27),('12374','2013-05-29','16:10:00',4.33),('12374','2013-05-29','16:15:00',3.8),('12374','2013-05-29','16:20:00',3.49),('12374','2013-05-29','16:25:00',3.09),('12374','2013-05-29','16:30:00',3.26),('12374','2013-05-29','16:35:00',2.85),('12374','2013-05-29','16:40:00',3.76),('12374','2013-05-29','16:45:00',3.61),('12374','2013-05-29','16:50:00',3.51),('12374','2013-05-29','16:55:00',3.12),('12374','2013-05-29','17:00:00',3.39),('12374','2013-05-29','17:05:00',3.46),('12374','2013-05-29','17:10:00',3.19),('12374','2013-05-29','17:15:00',2.55),('12374','2013-05-29','17:20:00',1.26),('12374','2013-05-29','17:30:00',1.11),('12374','2013-05-29','17:35:00',1.2),('12374','2013-05-29','17:45:00',1.2),('12374','2013-05-29','17:50:00',1.07),('12374','2013-05-29','18:00:00',1.05),('12374','2013-05-29','18:20:00',1.36),('12374','2013-05-29','18:25:00',1.91),('12374','2013-05-29','18:30:00',2.83),('12374','2013-05-29','18:35:00',2.04),('12374','2013-05-29','18:40:00',1.37),('12374','2013-05-29','18:45:00',1.16),('12374','2013-05-29','18:50:00',1.03),('12374','2013-05-29','18:55:00',1.93),('12374','2013-05-29','19:00:00',1.01),('12374','2013-05-29','19:05:00',1.24),('12374','2013-05-29','19:10:00',1.65),('12374','2013-05-29','19:15:00',1.64),('12374','2013-05-29','19:20:00',1.49),('12374','2013-05-28','06:45:00',1.21),('12374','2013-05-28','06:50:00',1.48),('12374','2013-05-28','06:55:00',1.55),('12374','2013-05-28','07:00:00',2),('12374','2013-05-28','07:05:00',2.14),('12374','2013-05-28','07:10:00',1.92),('12374','2013-05-28','07:15:00',1.68),('12374','2013-05-28','07:20:00',1.97),('12374','2013-05-28','07:25:00',2.01),('12374','2013-05-28','07:30:00',2.51),('12374','2013-05-28','07:35:00',2.58),('12374','2013-05-28','07:40:00',1.65),('12374','2013-05-28','07:45:00',1.79),('12374','2013-05-28','07:50:00',2.34),('12374','2013-05-28','07:55:00',3.37),('12374','2013-05-28','08:00:00',3.76),('12374','2013-05-28','08:05:00',2.7),('12374','2013-05-28','08:10:00',2.47),('12374','2013-05-28','08:15:00',3.03),('12374','2013-05-28','08:20:00',4.14),('12374','2013-05-28','08:25:00',4.19),('12374','2013-05-28','08:30:00',4.29),('12374','2013-05-28','08:35:00',3.67),('12374','2013-05-28','08:40:00',4.13),('12374','2013-05-28','08:45:00',5.38),('12374','2013-05-28','08:50:00',5.5),('12374','2013-05-28','08:55:00',4.88),('12374','2013-05-28','09:00:00',5.06),('12374','2013-05-28','09:05:00',4.68),('12374','2013-05-28','09:10:00',3.7),('12374','2013-05-28','09:15:00',5.8),('12374','2013-05-28','09:20:00',6),('12374','2013-05-28','09:25:00',5.12),('12374','2013-05-28','09:30:00',6.06),('12374','2013-05-28','09:35:00',5.55),('12374','2013-05-28','09:40:00',4.86),('12374','2013-05-28','09:45:00',5.13),('12374','2013-05-28','09:50:00',5.63),('12374','2013-05-28','09:55:00',5.34),('12374','2013-05-28','10:00:00',4.58),('12374','2013-05-28','10:05:00',4.58),('12374','2013-05-28','10:10:00',6.03),('12374','2013-05-28','10:15:00',6.75),('12374','2013-05-28','10:20:00',5.87),('12374','2013-05-28','10:25:00',4.64),('12374','2013-05-28','10:30:00',6.01),('12374','2013-05-28','10:35:00',6.51),('12374','2013-05-28','10:40:00',5.67),('12374','2013-05-28','10:45:00',6.05),('12374','2013-05-28','10:50:00',6.88),('12374','2013-05-28','10:55:00',3.57),('12374','2013-05-28','11:00:00',3),('12374','2013-05-28','11:05:00',3.36),('12374','2013-05-28','11:10:00',6.54),('12374','2013-05-28','11:15:00',8.12),('12374','2013-05-28','11:20:00',8.26),('12374','2013-05-28','11:25:00',8.5),('12374','2013-05-28','11:30:00',8.8),('12374','2013-05-28','11:35:00',4.24),('12374','2013-05-28','11:40:00',4.16),('12374','2013-05-28','11:45:00',5.26),('12374','2013-05-28','11:50:00',4.33),('12374','2013-05-28','11:55:00',4.1),('12374','2013-05-28','12:00:00',4.61),('12374','2013-05-28','12:05:00',5.02),('12374','2013-05-28','12:10:00',4.81),('12374','2013-05-28','12:15:00',3.76),('12374','2013-05-28','12:20:00',4.4),('12374','2013-05-28','12:25:00',4.72),('12374','2013-05-28','12:30:00',4.81),('12374','2013-05-28','12:35:00',4.88),('12374','2013-05-28','12:40:00',7.33),('12374','2013-05-28','12:45:00',8.97),('12374','2013-05-28','12:50:00',4.82),('12374','2013-05-28','12:55:00',3.63),('12374','2013-05-28','13:00:00',5.32),('12374','2013-05-28','13:05:00',8.08),('12374','2013-05-28','13:10:00',8.46),('12374','2013-05-28','13:15:00',7.73),('12374','2013-05-28','13:20:00',7.49),('12374','2013-05-28','13:25:00',7.84),('12374','2013-05-28','13:30:00',4.77),('12374','2013-05-28','13:35:00',5.15),('12374','2013-05-28','13:40:00',4.49),('12374','2013-05-28','13:45:00',5.31),('12374','2013-05-28','13:50:00',6.25),('12374','2013-05-28','13:55:00',5.36),('12374','2013-05-28','14:00:00',4.3),('12374','2013-05-28','14:05:00',5.84),('12374','2013-05-28','14:10:00',6.97),('12374','2013-05-28','14:15:00',6.94),('12374','2013-05-28','14:20:00',7.85),('12374','2013-05-28','14:25:00',6.98),('12374','2013-05-28','14:30:00',5.93),('12374','2013-05-28','14:35:00',8.63),('12374','2013-05-28','14:40:00',7.26),('12374','2013-05-28','14:45:00',7.72),('12374','2013-05-28','14:50:00',8.18),('12374','2013-05-28','14:55:00',5.09),('12374','2013-05-28','15:00:00',4.19),('12374','2013-05-28','15:05:00',4.11),('12374','2013-05-28','15:10:00',4.34),('12374','2013-05-28','15:15:00',5.17),('12374','2013-05-28','15:20:00',6.75),('12374','2013-05-28','15:25:00',6.64),('12374','2013-05-28','15:30:00',7.71),('12374','2013-05-28','15:35:00',6.55),('12374','2013-05-28','15:40:00',4.19),('12374','2013-05-28','15:45:00',2.7),('12374','2013-05-28','15:50:00',2.25),('12374','2013-05-28','15:55:00',2.28),('12374','2013-05-28','16:00:00',2.14),('12374','2013-05-28','16:05:00',2.22),('12374','2013-05-28','16:10:00',2.27),('12374','2013-05-28','16:15:00',2.22),('12374','2013-05-28','16:20:00',2.16),('12374','2013-05-28','16:25:00',2.41),('12374','2013-05-28','16:30:00',2.69),('12374','2013-05-28','16:35:00',2.91),('12374','2013-05-28','16:40:00',2.95),('12374','2013-05-28','16:45:00',2.97),('12374','2013-05-28','16:50:00',3),('12374','2013-05-28','16:55:00',3.17),('12374','2013-05-28','17:00:00',5.46),('12374','2013-05-28','17:05:00',4.86),('12374','2013-05-28','17:10:00',3.8),('12374','2013-05-28','17:15:00',2.56),('12374','2013-05-28','17:20:00',2.17),('12374','2013-05-28','17:25:00',2.44),('12374','2013-05-28','17:30:00',2.79),('12374','2013-05-28','17:35:00',2.79),('12374','2013-05-28','17:40:00',2.29),('12374','2013-05-28','17:45:00',2.22),('12374','2013-05-28','17:50:00',2.23),('12374','2013-05-28','17:55:00',2.49),('12374','2013-05-28','18:00:00',2.21),('12374','2013-05-28','18:05:00',1.78),('12374','2013-05-28','18:10:00',1.68),('12374','2013-05-28','18:15:00',2.63),('12374','2013-05-28','18:20:00',2.76),('12374','2013-05-28','18:25:00',1.71),('12374','2013-05-28','18:30:00',1.18),('12374','2013-05-28','18:35:00',1.96),('12374','2013-05-27','07:00:00',1.07),('12374','2013-05-27','07:45:00',2.85),('12374','2013-05-27','07:50:00',3.51),('12374','2013-05-27','07:55:00',3.61),('12374','2013-05-27','08:00:00',3.77),('12374','2013-05-27','08:05:00',3.92),('12374','2013-05-27','08:10:00',4.09),('12374','2013-05-27','08:15:00',4.23),('12374','2013-05-27','08:20:00',4.34),('12374','2013-05-27','08:25:00',4.49),('12374','2013-05-27','08:30:00',4.66),('12374','2013-05-27','08:35:00',4.8),('12374','2013-05-27','08:40:00',4.94),('12374','2013-05-27','08:45:00',5.05),('12374','2013-05-27','08:50:00',5.16),('12374','2013-05-27','08:55:00',5.39),('12374','2013-05-27','09:00:00',5.52),('12374','2013-05-27','09:05:00',5.65),('12374','2013-05-27','09:10:00',5.72),('12374','2013-05-27','09:15:00',5.94),('12374','2013-05-27','09:20:00',6.06),('12374','2013-05-27','09:25:00',6.17),('12374','2013-05-27','09:30:00',6.27),('12374','2013-05-27','09:35:00',6.49),('12374','2013-05-27','09:40:00',6.61),('12374','2013-05-27','09:45:00',6.73),('12374','2013-05-27','09:50:00',5.23),('12374','2013-05-27','09:55:00',5.66),('12374','2013-05-27','10:00:00',7.24),('12374','2013-05-27','10:05:00',7.35),('12374','2013-05-27','10:10:00',7.36),('12374','2013-05-27','10:15:00',7.52),('12374','2013-05-27','10:20:00',7.67),('12374','2013-05-27','10:25:00',7.77),('12374','2013-05-27','10:30:00',7.89),('12374','2013-05-27','10:35:00',7.96),('12374','2013-05-27','10:40:00',7.41),('12374','2013-05-27','10:45:00',7.69),('12374','2013-05-27','10:50:00',8.35),('12374','2013-05-27','10:55:00',7.22),('12374','2013-05-27','11:00:00',8.68),('12374','2013-05-27','11:05:00',9.66),('12374','2013-05-27','11:10:00',7.38),('12374','2013-05-27','11:15:00',8.18),('12374','2013-05-27','11:20:00',5.53),('12374','2013-05-27','11:25:00',7.63),('12374','2013-05-27','11:30:00',7.99),('12374','2013-05-27','11:35:00',6.63),('12374','2013-05-27','11:40:00',9.28),('12374','2013-05-27','11:45:00',9.18),('12374','2013-05-27','11:50:00',9.23),('12374','2013-05-27','11:55:00',9.27),('12374','2013-05-27','12:00:00',9.25),('12374','2013-05-27','12:05:00',9.33),('12374','2013-05-27','12:10:00',9.32),('12374','2013-05-27','12:15:00',9.34),('12374','2013-05-27','12:20:00',9.32),('12374','2013-05-27','12:25:00',9.25),('12374','2013-05-27','12:30:00',9.13),('12374','2013-05-27','12:35:00',9.29),('12374','2013-05-27','12:40:00',9.39),('12374','2013-05-27','12:45:00',9.38),('12374','2013-05-27','12:50:00',9.38),('12374','2013-05-27','12:55:00',9.39),('12374','2013-05-27','13:00:00',9.28),('12374','2013-05-27','13:05:00',9.32),('12374','2013-05-27','13:10:00',9.52),('12374','2013-05-27','13:15:00',9.23),('12374','2013-05-27','13:20:00',9.07),('12374','2013-05-27','13:25:00',9.49),('12374','2013-05-27','13:30:00',9.49),('12374','2013-05-27','13:35:00',9.39),('12374','2013-05-27','13:40:00',9.3),('12374','2013-05-27','13:45:00',9.28),('12374','2013-05-27','13:50:00',9.4),('12374','2013-05-27','13:55:00',9.3),('12374','2013-05-27','14:00:00',9.25),('12374','2013-05-27','14:05:00',9.12),('12374','2013-05-27','14:10:00',9.19),('12374','2013-05-27','14:15:00',9.11),('12374','2013-05-27','14:20:00',9.19),('12374','2013-05-27','14:25:00',9.11),('12374','2013-05-27','14:30:00',9.06),('12374','2013-05-27','14:35:00',9.03),('12374','2013-05-27','14:40:00',8.5),('12374','2013-05-27','14:45:00',6.68),('12374','2013-05-27','14:50:00',7.87),('12374','2013-05-27','14:55:00',9.31),('12374','2013-05-27','15:00:00',7.06),('12374','2013-05-27','15:05:00',7.01),('12374','2013-05-27','15:10:00',8.69),('12374','2013-05-27','15:15:00',8.3),('12374','2013-05-27','15:20:00',8.27),('12374','2013-05-27','15:25:00',7.07),('12374','2013-05-27','15:30:00',5.58),('12374','2013-05-27','15:35:00',5.74),('12374','2013-05-27','15:40:00',6.28),('12374','2013-05-27','15:45:00',6.69),('12374','2013-05-27','15:50:00',6.46),('12374','2013-05-27','15:55:00',6.46),('12374','2013-05-27','16:00:00',5.96),('12374','2013-05-27','16:05:00',7.65),('12374','2013-05-27','16:10:00',7.52),('12374','2013-05-27','16:15:00',6.66),('12374','2013-05-27','16:20:00',5.21),('12374','2013-05-27','16:25:00',5.1),('12374','2013-05-27','16:30:00',6.48),('12374','2013-05-27','16:35:00',3.7),('12374','2013-05-27','16:40:00',6.61),('12374','2013-05-27','16:45:00',4.86),('12374','2013-05-27','16:50:00',3.14),('12374','2013-05-27','16:55:00',2.9),('12374','2013-05-27','17:00:00',2.87),('12374','2013-05-27','17:05:00',2.79),('12374','2013-05-27','17:10:00',2.75),('12374','2013-05-27','17:15:00',2.98),('12374','2013-05-27','17:20:00',2.76),('12374','2013-05-27','17:25:00',2.62),('12374','2013-05-27','17:30:00',3.05),('12374','2013-05-27','17:35:00',2.59),('12374','2013-05-27','17:40:00',2.18),('12374','2013-05-27','17:45:00',2.09),('12374','2013-05-27','17:50:00',2.1),('12374','2013-05-27','17:55:00',2.07),('12374','2013-05-27','18:00:00',2.05),('12374','2013-05-27','18:05:00',2.12),('12374','2013-05-27','18:10:00',3.18),('12374','2013-05-27','18:15:00',3.79),('12374','2013-05-27','18:20:00',3.43),('12374','2013-05-27','18:25:00',2.93),('12374','2013-05-27','18:30:00',2.65),('12374','2013-05-27','18:35:00',2.19),('12374','2013-05-27','18:40:00',1.78),('12374','2013-05-27','18:45:00',2.44),('12374','2013-05-27','18:50:00',2.35),('12374','2013-05-27','18:55:00',2.09),('12374','2013-05-27','19:00:00',1.79),('12374','2013-05-27','19:05:00',1.54),('12374','2013-05-27','19:10:00',1.47),('12374','2013-05-27','19:15:00',1.43),('12374','2013-05-27','19:20:00',1.33),('12374','2013-05-27','19:25:00',1.07),('12374','2013-05-27','19:30:00',1.17),('12374','2013-05-27','19:35:00',1.03),('12374','2013-05-26','07:05:00',1.56),('12374','2013-05-26','07:10:00',2.03),('12374','2013-05-26','07:15:00',2.28),('12374','2013-05-26','07:20:00',2.16),('12374','2013-05-26','07:55:00',1.33),('12374','2013-05-26','08:00:00',1.69),('12374','2013-05-26','08:05:00',1.85),('12374','2013-05-26','08:10:00',1.25),('12374','2013-05-26','08:15:00',1.61),('12374','2013-05-26','08:20:00',1.98),('12374','2013-05-26','08:25:00',1.56),('12374','2013-05-26','08:30:00',1.31),('12374','2013-05-26','08:35:00',1.74),('12374','2013-05-26','08:40:00',1.42),('12374','2013-05-26','08:55:00',4.35),('12374','2013-05-26','09:00:00',4.91),('12374','2013-05-26','09:05:00',5.05),('12374','2013-05-26','09:10:00',5.92),('12374','2013-05-26','09:15:00',6.11),('12374','2013-05-26','09:20:00',6.24),('12374','2013-05-26','09:25:00',6.37),('12374','2013-05-26','09:30:00',6.51),('12374','2013-05-26','09:35:00',6.63),('12374','2013-05-26','09:40:00',6.77),('12374','2013-05-26','09:45:00',6.94),('12374','2013-05-26','09:50:00',7.04),('12374','2013-05-26','09:55:00',7.2),('12374','2013-05-26','10:00:00',7.33),('12374','2013-05-26','10:05:00',7.48),('12374','2013-05-26','10:10:00',7.59),('12374','2013-05-26','10:15:00',7.72),('12374','2013-05-26','10:20:00',7.79),('12374','2013-05-26','10:25:00',7.86),('12374','2013-05-26','10:30:00',8.07),('12374','2013-05-26','10:35:00',8.2),('12374','2013-05-26','10:40:00',8.31),('12374','2013-05-26','10:45:00',8.42),('12374','2013-05-26','10:50:00',8.51),('12374','2013-05-26','10:55:00',8.61),('12374','2013-05-26','11:00:00',8.69),('12374','2013-05-26','11:05:00',8.77),('12374','2013-05-26','11:10:00',8.89),('12374','2013-05-26','11:15:00',8.94),('12374','2013-05-26','11:20:00',9.01),('12374','2013-05-26','11:25:00',9.13),('12374','2013-05-26','11:30:00',9.22),('12374','2013-05-26','11:35:00',9.25),('12374','2013-05-26','11:40:00',9.28),('12374','2013-05-26','11:45:00',9.31),('12374','2013-05-26','11:50:00',9.33),('12374','2013-05-26','11:55:00',9.34),('12374','2013-05-26','12:00:00',9.37),('12374','2013-05-26','12:05:00',9.33),('12374','2013-05-26','12:10:00',9.41),('12374','2013-05-26','12:15:00',9.52),('12374','2013-05-26','12:20:00',9.57),('12374','2013-05-26','12:25:00',9.62),('12374','2013-05-26','12:30:00',9.65),('12374','2013-05-26','12:35:00',9.79),('12374','2013-05-26','12:40:00',9.97),('12374','2013-05-26','12:45:00',9.77),('12374','2013-05-26','12:50:00',9.72),('12374','2013-05-26','12:55:00',9.73),('12374','2013-05-26','13:00:00',8.6),('12374','2013-05-26','13:05:00',8.37),('12374','2013-05-26','13:10:00',6.24),('12374','2013-05-26','13:15:00',6.94),('12374','2013-05-26','13:20:00',9.57),('12374','2013-05-26','13:25:00',9.63),('12374','2013-05-26','13:30:00',9.56),('12374','2013-05-26','13:35:00',9.54),('12374','2013-05-26','13:40:00',9.49),('12374','2013-05-26','13:45:00',9.52),('12374','2013-05-26','13:50:00',9.46),('12374','2013-05-26','13:55:00',9.47),('12374','2013-05-26','14:00:00',9.47),('12374','2013-05-26','14:05:00',9.38),('12374','2013-05-26','14:10:00',9.34),('12374','2013-05-26','14:15:00',9.32),('12374','2013-05-26','14:20:00',9.24),('12374','2013-05-26','14:25:00',9.19),('12374','2013-05-26','14:30:00',9.17),('12374','2013-05-26','14:35:00',9.1),('12374','2013-05-26','14:40:00',9.06),('12374','2013-05-26','14:45:00',8.99),('12374','2013-05-26','14:50:00',8.86),('12374','2013-05-26','14:55:00',8.79),('12374','2013-05-26','15:00:00',8.68),('12374','2013-05-26','15:05:00',8.54),('12374','2013-05-26','15:10:00',8.51),('12374','2013-05-26','15:15:00',8.39),('12374','2013-05-26','15:20:00',8.3),('12374','2013-05-26','15:25:00',8.18),('12374','2013-05-26','15:30:00',8.08),('12374','2013-05-26','15:35:00',7.93),('12374','2013-05-26','15:40:00',7.8),('12374','2013-05-26','15:45:00',7.66),('12374','2013-05-26','15:50:00',7.55),('12374','2013-05-26','15:55:00',7.44),('12374','2013-05-26','16:00:00',7.31),('12374','2013-05-26','16:05:00',7.17),('12374','2013-05-26','16:10:00',7.03),('12374','2013-05-26','16:15:00',6.87),('12374','2013-05-26','16:20:00',6.68),('12374','2013-05-26','16:25:00',6.63),('12374','2013-05-26','16:30:00',6.49),('12374','2013-05-26','16:35:00',6.33),('12374','2013-05-26','16:40:00',6.22),('12374','2013-05-26','16:45:00',6.04),('12374','2013-05-26','16:50:00',5.83),('12374','2013-05-26','16:55:00',5.69),('12374','2013-05-26','17:00:00',5.54),('12374','2013-05-26','17:05:00',5.38),('12374','2013-05-26','17:10:00',5.24),('12374','2013-05-26','17:15:00',5.1),('12374','2013-05-26','17:20:00',4.94),('12374','2013-05-26','17:25:00',4.68),('12374','2013-05-26','17:30:00',4.36),('12374','2013-05-26','17:35:00',4.27),('12374','2013-05-26','17:40:00',4.11),('12374','2013-05-26','17:45:00',3.86),('12374','2013-05-26','17:50:00',3.61),('12374','2013-05-26','17:55:00',3.5),('12374','2013-05-26','18:00:00',3.28),('12374','2013-05-26','18:05:00',3.16),('12374','2013-05-26','18:10:00',2.95),('12374','2013-05-26','18:15:00',2.56),('12374','2013-05-26','18:20:00',2.33),('12374','2013-05-26','18:25:00',2.3),('12374','2013-05-26','18:30:00',2.14),('12374','2013-05-26','18:35:00',2.07),('12374','2013-05-26','18:40:00',1.91),('12374','2013-05-26','18:45:00',1.74),('12374','2013-05-26','18:50:00',1.66),('12374','2013-05-26','18:55:00',1.58),('12374','2013-05-26','19:00:00',1.51),('12374','2013-05-26','19:05:00',1.44),('12374','2013-05-26','19:10:00',1.36),('12374','2013-05-26','19:15:00',1.29),('12374','2013-05-26','19:20:00',1.22),('12374','2013-05-26','19:25:00',1.13),('12374','2013-05-26','19:30:00',1.05),('12374','2013-05-25','06:35:00',1.22),('12374','2013-05-25','06:40:00',1.15),('12374','2013-05-25','06:45:00',1.39),('12374','2013-05-25','06:50:00',1.11),('12374','2013-05-25','07:30:00',1.46),('12374','2013-05-25','07:35:00',3.09),('12374','2013-05-25','07:40:00',2.22),('12374','2013-05-25','07:45:00',3.27),('12374','2013-05-25','07:50:00',3.43),('12374','2013-05-25','07:55:00',3.64),('12374','2013-05-25','08:00:00',4.07),('12374','2013-05-25','08:05:00',2.96),('12374','2013-05-25','08:10:00',4.22),('12374','2013-05-25','08:15:00',2.28),('12374','2013-05-25','08:20:00',3.62),('12374','2013-05-25','08:25:00',2.5),('12374','2013-05-25','08:30:00',3.87),('12374','2013-05-25','08:35:00',4.55),('12374','2013-05-25','08:40:00',3.03),('12374','2013-05-25','08:45:00',2.46),('12374','2013-05-25','08:50:00',2.21),('12374','2013-05-25','08:55:00',3.42),('12374','2013-05-25','09:00:00',5.71),('12374','2013-05-25','09:05:00',5.42),('12374','2013-05-25','09:10:00',4.93),('12374','2013-05-25','09:15:00',2.69),('12374','2013-05-25','09:20:00',1.6),('12374','2013-05-25','09:25:00',1.27),('12374','2013-05-25','09:35:00',1.06),('12374','2013-05-25','09:40:00',1.11),('12374','2013-05-25','09:45:00',1.7),('12374','2013-05-25','09:50:00',1.42),('12374','2013-05-25','09:55:00',2.15),('12374','2013-05-25','10:00:00',3.43),('12374','2013-05-25','10:05:00',4.11),('12374','2013-05-25','10:10:00',2.22),('12374','2013-05-25','10:15:00',1.71),('12374','2013-05-25','10:20:00',1.6),('12374','2013-05-25','10:25:00',2.31),('12374','2013-05-25','10:30:00',2.83),('12374','2013-05-25','10:35:00',2.71),('12374','2013-05-25','10:40:00',2.17),('12374','2013-05-25','10:45:00',2.12),('12374','2013-05-25','10:50:00',2.17),('12374','2013-05-25','10:55:00',2.51),('12374','2013-05-25','11:00:00',2.85),('12374','2013-05-25','11:05:00',3.5),('12374','2013-05-25','11:10:00',3.9),('12374','2013-05-25','11:15:00',7.86),('12374','2013-05-25','11:20:00',5.84),('12374','2013-05-25','11:25:00',1.48),('12374','2013-05-25','11:30:00',2.89),('12374','2013-05-25','11:35:00',3.85),('12374','2013-05-25','11:40:00',3.21),('12374','2013-05-25','11:45:00',2.85),('12374','2013-05-25','11:50:00',2.04),('12374','2013-05-25','11:55:00',1.86),('12374','2013-05-25','12:00:00',1.97),('12374','2013-05-25','12:05:00',1.16),('12374','2013-05-25','12:10:00',1.47),('12374','2013-05-25','12:15:00',1.67),('12374','2013-05-25','12:20:00',2.78),('12374','2013-05-25','12:25:00',2.8),('12374','2013-05-25','12:30:00',2.47),('12374','2013-05-25','12:35:00',4.26),('12374','2013-05-25','12:40:00',5.7),('12374','2013-05-25','12:45:00',6.09),('12374','2013-05-25','12:50:00',9.59),('12374','2013-05-25','12:55:00',8.73),('12374','2013-05-25','13:00:00',2.83),('12374','2013-05-25','13:05:00',1.97),('12374','2013-05-25','13:10:00',8),('12374','2013-05-25','13:15:00',9.11),('12374','2013-05-25','13:20:00',6.84),('12374','2013-05-25','13:25:00',9.36),('12374','2013-05-25','13:30:00',8.87),('12374','2013-05-25','13:35:00',9.54),('12374','2013-05-25','13:40:00',7.55),('12374','2013-05-25','13:45:00',9.83),('12374','2013-05-25','13:50:00',2.99),('12374','2013-05-25','14:10:00',6.91),('12374','2013-05-25','14:15:00',8.93),('12374','2013-05-25','14:20:00',9.15),('12374','2013-05-25','14:25:00',9.15),('12374','2013-05-25','14:30:00',4.76),('12374','2013-05-25','14:35:00',6.53),('12374','2013-05-25','14:40:00',4.24),('12374','2013-05-25','14:45:00',7.02),('12374','2013-05-25','14:50:00',4.85),('12374','2013-05-25','14:55:00',8.51),('12374','2013-05-25','15:00:00',9.03),('12374','2013-05-25','15:05:00',8.41),('12374','2013-05-25','15:10:00',6.59),('12374','2013-05-25','15:15:00',6.99),('12374','2013-05-25','15:20:00',8.46),('12374','2013-05-25','15:25:00',7.83),('12374','2013-05-25','15:30:00',5.49),('12374','2013-05-25','15:35:00',5.17),('12374','2013-05-25','15:40:00',6.08),('12374','2013-05-25','15:45:00',5.43),('12374','2013-05-25','15:50:00',5.95),('12374','2013-05-25','15:55:00',6.62),('12374','2013-05-25','16:00:00',6.84),('12374','2013-05-25','16:05:00',7.36),('12374','2013-05-25','16:10:00',7.3),('12374','2013-05-25','16:15:00',7.09),('12374','2013-05-25','16:20:00',6.5),('12374','2013-05-25','16:25:00',6.82),('12374','2013-05-25','16:30:00',6.62),('12374','2013-05-25','16:35:00',6.47),('12374','2013-05-25','16:40:00',6.32),('12374','2013-05-25','16:45:00',6.06),('12374','2013-05-25','16:50:00',5.88),('12374','2013-05-25','16:55:00',5.74),('12374','2013-05-25','17:00:00',4.67),('12374','2013-05-25','17:05:00',5.47),('12374','2013-05-25','17:10:00',4.69),('12374','2013-05-25','17:15:00',3.12),('12374','2013-05-25','17:25:00',3.08),('12374','2013-05-25','17:30:00',2.12),('12374','2013-05-25','17:35:00',2.97),('12374','2013-05-25','17:40:00',2.13),('12374','2013-05-25','17:45:00',1.99),('12374','2013-05-25','17:50:00',1.26),('12374','2013-05-25','18:40:00',1.66),('12374','2013-05-25','18:45:00',1.16),('12374','2013-05-24','07:25:00',1),('12374','2013-05-24','07:30:00',1.13),('12374','2013-05-24','07:35:00',1.82),('12374','2013-05-24','07:40:00',3.19),('12374','2013-05-24','07:45:00',2.64),('12374','2013-05-24','07:50:00',2.55),('12374','2013-05-24','07:55:00',2.81),('12374','2013-05-24','08:00:00',3.13),('12374','2013-05-24','08:05:00',3.8),('12374','2013-05-24','08:10:00',3.18),('12374','2013-05-24','08:15:00',1.49),('12374','2013-05-24','08:20:00',2.53),('12374','2013-05-24','08:25:00',4.98),('12374','2013-05-24','08:30:00',5.01),('12374','2013-05-24','08:35:00',2.82),('12374','2013-05-24','08:40:00',4.95),('12374','2013-05-24','08:45:00',1.83),('12374','2013-05-24','08:50:00',4.71),('12374','2013-05-24','08:55:00',5.17),('12374','2013-05-24','09:00:00',2.76),('12374','2013-05-24','09:05:00',4.38),('12374','2013-05-24','09:10:00',4.25),('12374','2013-05-24','09:15:00',3.88),('12374','2013-05-24','09:20:00',6.39),('12374','2013-05-24','09:25:00',6.29),('12374','2013-05-24','09:30:00',5.99),('12374','2013-05-24','09:35:00',5.5),('12374','2013-05-24','09:40:00',6.83),('12374','2013-05-24','09:45:00',5.61),('12374','2013-05-24','09:50:00',2.41),('12374','2013-05-24','09:55:00',3.93),('12374','2013-05-24','10:00:00',7.31),('12374','2013-05-24','10:05:00',7.56),('12374','2013-05-24','10:10:00',7.72),('12374','2013-05-24','10:15:00',7.55),('12374','2013-05-24','10:20:00',3.05),('12374','2013-05-24','10:25:00',7.14),('12374','2013-05-24','10:30:00',8.16),('12374','2013-05-24','10:35:00',8.08),('12374','2013-05-24','10:40:00',7.97),('12374','2013-05-24','10:45:00',8.99),('12374','2013-05-24','10:50:00',8.6),('12374','2013-05-24','10:55:00',6.34),('12374','2013-05-24','11:00:00',6.79),('12374','2013-05-24','11:05:00',6.43),('12374','2013-05-24','11:10:00',8.62),('12374','2013-05-24','11:15:00',4.91),('12374','2013-05-24','11:20:00',6.73),('12374','2013-05-24','11:25:00',9.68),('12374','2013-05-24','11:30:00',9.63),('12374','2013-05-24','11:35:00',9.51),('12374','2013-05-24','11:40:00',8.77),('12374','2013-05-24','11:45:00',9.33),('12374','2013-05-24','11:50:00',9.75),('12374','2013-05-24','11:55:00',9.51),('12374','2013-05-24','12:00:00',6.56),('12374','2013-05-24','12:05:00',9.94),('12374','2013-05-24','12:10:00',9.96),('12374','2013-05-24','12:15:00',9.73),('12374','2013-05-24','12:20:00',6.17),('12374','2013-05-24','12:25:00',8.61),('12374','2013-05-24','12:30:00',7.58),('12374','2013-05-24','12:35:00',7.07),('12374','2013-05-24','12:40:00',5.4),('12374','2013-05-24','12:45:00',8.03),('12374','2013-05-24','12:50:00',5.9),('12374','2013-05-24','12:55:00',5.53),('12374','2013-05-24','13:00:00',5.68),('12374','2013-05-24','13:05:00',7.7),('12374','2013-05-24','13:10:00',8.39),('12374','2013-05-24','13:15:00',7.21),('12374','2013-05-24','13:20:00',7.8),('12374','2013-05-24','13:25:00',8.67),('12374','2013-05-24','13:30:00',2.6),('12374','2013-05-24','13:35:00',2.26),('12374','2013-05-24','13:40:00',3.55),('12374','2013-05-24','13:45:00',7.2),('12374','2013-05-24','13:50:00',8.77),('12374','2013-05-24','13:55:00',2.52),('12374','2013-05-24','14:00:00',5.03),('12374','2013-05-24','14:05:00',3.11),('12374','2013-05-24','14:10:00',6.31),('12374','2013-05-24','14:15:00',6.66),('12374','2013-05-24','14:20:00',9.16),('12374','2013-05-24','14:25:00',9.14),('12374','2013-05-24','14:30:00',6.66),('12374','2013-05-24','14:35:00',4.59),('12374','2013-05-24','14:40:00',4.54),('12374','2013-05-24','14:45:00',6.65),('12374','2013-05-24','14:50:00',8.94),('12374','2013-05-24','14:55:00',6.98),('12374','2013-05-24','15:00:00',8.76),('12374','2013-05-24','15:05:00',9.14),('12374','2013-05-24','15:10:00',9),('12374','2013-05-24','15:15:00',8.84),('12374','2013-05-24','15:20:00',4.75),('12374','2013-05-24','15:25:00',7.04),('12374','2013-05-24','15:30:00',5.22),('12374','2013-05-24','15:35:00',3.37),('12374','2013-05-24','15:40:00',5.41),('12374','2013-05-24','15:45:00',3.77),('12374','2013-05-24','15:50:00',2.02),('12374','2013-05-24','15:55:00',2.86),('12374','2013-05-24','16:00:00',3.61),('12374','2013-05-24','16:05:00',3.61),('12374','2013-05-24','16:10:00',3.39),('12374','2013-05-24','16:15:00',2.76),('12374','2013-05-24','16:20:00',2.67),('12374','2013-05-24','16:25:00',2.34),('12374','2013-05-24','16:30:00',2.32),('12374','2013-05-24','16:35:00',2.55),('12374','2013-05-24','16:40:00',2.79),('12374','2013-05-24','16:45:00',2.86),('12374','2013-05-24','16:50:00',4.06),('12374','2013-05-24','16:55:00',6),('12374','2013-05-24','17:00:00',6.96),('12374','2013-05-24','17:05:00',5.28),('12374','2013-05-24','17:10:00',2.71),('12374','2013-05-24','17:15:00',2.97),('12374','2013-05-24','17:20:00',3.11),('12374','2013-05-24','17:25:00',2.6),('12374','2013-05-24','17:30:00',2.49),('12374','2013-05-24','17:35:00',3.14),('12374','2013-05-24','17:40:00',1.88),('12374','2013-05-24','17:45:00',1.84),('12374','2013-05-24','17:50:00',2.3),('12374','2013-05-24','17:55:00',2.05),('12374','2013-05-24','18:00:00',1.38),('12374','2013-05-23','07:20:00',1.33),('12374','2013-05-23','07:25:00',2.47),('12374','2013-05-23','07:30:00',2.65),('12374','2013-05-23','07:35:00',2.63),('12374','2013-05-23','07:40:00',1.44),('12374','2013-05-23','07:50:00',2.21),('12374','2013-05-23','07:55:00',1.13),('12374','2013-05-23','08:00:00',1.14),('12374','2013-05-23','08:05:00',1.62),('12374','2013-05-23','08:10:00',1.38),('12374','2013-05-23','08:15:00',1.35),('12374','2013-05-23','08:20:00',1.37),('12374','2013-05-23','08:25:00',1.71),('12374','2013-05-23','08:30:00',2.53),('12374','2013-05-23','08:35:00',2.63),('12374','2013-05-23','08:40:00',3.36),('12374','2013-05-23','08:45:00',3.11),('12374','2013-05-23','08:50:00',3.49),('12374','2013-05-23','08:55:00',5.23),('12374','2013-05-23','09:00:00',5.61),('12374','2013-05-23','09:05:00',5.66),('12374','2013-05-23','09:10:00',5.66),('12374','2013-05-23','09:15:00',6.02),('12374','2013-05-23','09:20:00',6.09),('12374','2013-05-23','09:25:00',6.6),('12374','2013-05-23','09:30:00',5.31),('12374','2013-05-23','09:35:00',4.36),('12374','2013-05-23','09:40:00',5.13),('12374','2013-05-23','09:45:00',3.86),('12374','2013-05-23','09:50:00',5.79),('12374','2013-05-23','09:55:00',6.94),('12374','2013-05-23','10:00:00',3.89),('12374','2013-05-23','10:05:00',7.1),('12374','2013-05-23','10:10:00',6.09),('12374','2013-05-23','10:15:00',4.73),('12374','2013-05-23','10:20:00',7.97),('12374','2013-05-23','10:25:00',5.18),('12374','2013-05-23','10:30:00',8.22),('12374','2013-05-23','10:35:00',7.36),('12374','2013-05-23','10:40:00',7.13),('12374','2013-05-23','10:45:00',7.06),('12374','2013-05-23','10:50:00',5.94),('12374','2013-05-23','10:55:00',8.18),('12374','2013-05-23','11:00:00',6.4),('12374','2013-05-23','11:05:00',8.41),('12374','2013-05-23','11:10:00',8.14),('12374','2013-05-23','11:15:00',4.67),('12374','2013-05-23','11:20:00',5.07),('12374','2013-05-23','11:25:00',7.16),('12374','2013-05-23','11:30:00',5.68),('12374','2013-05-23','11:35:00',9.33),('12374','2013-05-23','11:40:00',9.87),('12374','2013-05-23','11:45:00',8.25),('12374','2013-05-23','11:50:00',5.87),('12374','2013-05-23','11:55:00',5.26),('12374','2013-05-23','12:00:00',4.86),('12374','2013-05-23','12:05:00',6.6),('12374','2013-05-23','12:10:00',7.68),('12374','2013-05-23','12:15:00',9.69),('12374','2013-05-23','12:20:00',6.23),('12374','2013-05-23','15:40:00',7.09),('12374','2013-05-23','15:45:00',7.78),('12374','2013-05-23','15:50:00',6.37),('12374','2013-05-23','15:55:00',5.95),('12374','2013-05-23','16:00:00',5.78),('12374','2013-05-23','16:05:00',4.97),('12374','2013-05-23','16:10:00',3.11),('12374','2013-05-23','16:15:00',2.46),('12374','2013-05-23','16:20:00',2.11),('12374','2013-05-23','16:25:00',2.4),('12374','2013-05-23','16:30:00',3),('12374','2013-05-23','16:35:00',3.43),('12374','2013-05-23','16:40:00',3.47),('12374','2013-05-23','16:45:00',2.99),('12374','2013-05-23','16:50:00',3.29),('12374','2013-05-23','16:55:00',3.13),('12374','2013-05-23','17:00:00',2.71),('12374','2013-05-23','17:05:00',2.97),('12374','2013-05-23','17:10:00',3.63),('12374','2013-05-23','17:15:00',4.28),('12374','2013-05-23','17:20:00',4.68),('12374','2013-05-23','17:25:00',3.06),('12374','2013-05-23','17:30:00',1.41),('12374','2013-05-23','17:45:00',1.05),('12374','2013-05-23','17:50:00',1.11),('12374','2013-05-23','17:55:00',1.24),('12374','2013-05-23','18:00:00',1.05),('12374','2013-05-23','18:10:00',1.3),('12374','2013-05-23','18:15:00',1.43),('12374','2013-05-23','18:20:00',1.43),('12374','2013-05-22','07:35:00',1.03),('12374','2013-05-22','07:40:00',1.15),('12374','2013-05-22','07:45:00',1.3),('12374','2013-05-22','07:50:00',1.26),('12374','2013-05-22','07:55:00',1.6),('12374','2013-05-22','08:00:00',2.36),('12374','2013-05-22','08:05:00',3.41),('12374','2013-05-22','08:10:00',2.89),('12374','2013-05-22','08:15:00',4.68),('12374','2013-05-22','08:20:00',3.51),('12374','2013-05-22','08:50:00',3.5),('12374','2013-05-22','08:55:00',5.15),('12374','2013-05-22','09:00:00',2.97),('12374','2013-05-22','09:05:00',2.86),('12374','2013-05-22','09:10:00',2.88),('12374','2013-05-22','09:15:00',2.27),('12374','2013-05-22','09:20:00',1.33),('12374','2013-05-22','09:25:00',3.2),('12374','2013-05-22','09:30:00',5.92),('12374','2013-05-22','09:35:00',4.27),('12374','2013-05-22','09:40:00',5.91),('12374','2013-05-22','09:45:00',6.61),('12374','2013-05-22','09:50:00',6.59),('12374','2013-05-22','09:55:00',6.7),('12374','2013-05-22','10:00:00',6.84),('12374','2013-05-22','10:05:00',7.04),('12374','2013-05-22','10:10:00',5.35),('12374','2013-05-22','10:15:00',7.47),('12374','2013-05-22','10:20:00',5.71),('12374','2013-05-22','10:25:00',6.09),('12374','2013-05-22','10:30:00',5.9),('12374','2013-05-22','10:35:00',4.89),('12374','2013-05-22','10:40:00',5.04),('12374','2013-05-22','10:45:00',6.21),('12374','2013-05-22','10:50:00',7.11),('12374','2013-05-22','10:55:00',8.53),('12374','2013-05-22','11:00:00',6.6),('12374','2013-05-22','11:05:00',6.08),('12374','2013-05-22','11:10:00',6.11),('12374','2013-05-22','11:15:00',8.14),('12374','2013-05-22','11:20:00',7.5),('12374','2013-05-22','11:25:00',8.41),('12374','2013-05-22','11:30:00',7.76),('12374','2013-05-22','11:35:00',7.2),('12374','2013-05-22','11:40:00',8.88),('12374','2013-05-22','11:45:00',7.23),('12374','2013-05-22','11:50:00',9.15),('12374','2013-05-22','11:55:00',8.51),('12374','2013-05-22','12:00:00',7.17),('12374','2013-05-22','12:05:00',4.85),('12374','2013-05-22','12:10:00',4.17),('12374','2013-05-22','12:15:00',4.73),('12374','2013-05-22','12:20:00',5.08),('12374','2013-05-22','12:25:00',5.33),('12374','2013-05-22','12:30:00',5.28),('12374','2013-05-22','12:35:00',3.69),('12374','2013-05-22','12:40:00',2.81),('12374','2013-05-22','12:45:00',2.84),('12374','2013-05-22','12:50:00',3.43),('12374','2013-05-22','12:55:00',2.62),('12374','2013-05-22','13:00:00',1.68),('12374','2013-05-22','13:05:00',1.15),('12374','2013-05-22','13:25:00',1.69),('12374','2013-05-22','13:30:00',2.89),('12374','2013-05-22','13:35:00',3.77),('12374','2013-05-22','13:40:00',5.6),('12374','2013-05-22','13:45:00',3.98),('12374','2013-05-22','13:50:00',5.75),('12374','2013-05-22','13:55:00',6.69),('12374','2013-05-22','14:00:00',6.77),('12374','2013-05-22','14:05:00',8.09),('12374','2013-05-22','14:10:00',8.73),('12374','2013-05-22','14:15:00',8.85),('12374','2013-05-22','14:20:00',8.7),('12374','2013-05-22','14:25:00',8.76),('12374','2013-05-22','14:30:00',8.68),('12374','2013-05-22','14:35:00',8.59),('12374','2013-05-22','14:40:00',8.48),('12374','2013-05-22','14:45:00',8.42),('12374','2013-05-22','14:50:00',8.31),('12374','2013-05-22','14:55:00',8.23),('12374','2013-05-22','15:00:00',8.13),('12374','2013-05-22','15:05:00',8),('12374','2013-05-22','15:10:00',7.93),('12374','2013-05-22','15:15:00',7.74),('12374','2013-05-22','15:20:00',7.73),('12374','2013-05-22','15:25:00',7.63),('12374','2013-05-22','15:30:00',7.65),('12374','2013-05-22','15:35:00',7.76),('12374','2013-05-22','15:40:00',7.02),('12374','2013-05-22','15:45:00',6.75),('12374','2013-05-22','15:50:00',7.12),('12374','2013-05-22','15:55:00',6.88),('12374','2013-05-22','16:00:00',6.7),('12374','2013-05-22','16:05:00',6.57),('12374','2013-05-22','16:10:00',6.47),('12374','2013-05-22','16:15:00',6.31),('12374','2013-05-22','16:20:00',6.19),('12374','2013-05-22','16:25:00',6.05),('12374','2013-05-22','16:30:00',5.93),('12374','2013-05-22','16:35:00',5.85),('12374','2013-05-22','16:40:00',6.03),('12374','2013-05-22','16:45:00',6.35),('12374','2013-05-22','16:50:00',4.85),('12374','2013-05-22','16:55:00',3.64),('12374','2013-05-22','17:00:00',4.75),('12374','2013-05-22','17:05:00',3),('12374','2013-05-22','17:10:00',4.09),('12374','2013-05-22','17:15:00',2.26),('12374','2013-05-22','17:20:00',1.56),('12374','2013-05-22','17:25:00',3.25),('12374','2013-05-22','17:30:00',4.15),('12374','2013-05-22','17:35:00',3.57),('12374','2013-05-22','17:40:00',3.84),('12374','2013-05-22','17:45:00',3.9),('12374','2013-05-22','17:50:00',2.9),('12374','2013-05-22','17:55:00',3.21),('12374','2013-05-22','18:00:00',3.25),('12374','2013-05-22','18:05:00',2.84),('12374','2013-05-22','18:10:00',2.53),('12374','2013-05-22','18:15:00',2.36),('12374','2013-05-22','18:20:00',2.15),('12374','2013-05-22','18:25:00',2.12),('12374','2013-05-22','18:30:00',2.09),('12374','2013-05-22','18:35:00',2.02),('12374','2013-05-22','18:40:00',1.91),('12374','2013-05-22','18:45:00',1.72),('12374','2013-05-22','18:50:00',1.6),('12374','2013-05-22','18:55:00',1.47),('12374','2013-05-22','19:00:00',1.3),('12374','2013-05-22','19:05:00',1.21),('12374','2013-05-21','06:45:00',1.11),('12374','2013-05-21','06:50:00',1.14),('12374','2013-05-21','06:55:00',1.31),('12374','2013-05-21','07:00:00',1.48),('12374','2013-05-21','07:05:00',1.61),('12374','2013-05-21','07:10:00',1.73),('12374','2013-05-21','07:15:00',1.74),('12374','2013-05-21','07:20:00',2.2),('12374','2013-05-21','07:25:00',2.35),('12374','2013-05-21','07:30:00',2.52),('12374','2013-05-21','07:35:00',2.68),('12374','2013-05-21','07:40:00',2.87),('12374','2013-05-21','07:45:00',3.16),('12374','2013-05-21','07:50:00',3.56),('12374','2013-05-21','07:55:00',3.74),('12374','2013-05-21','08:00:00',3.96),('12374','2013-05-21','08:05:00',3.13),('12374','2013-05-21','08:10:00',2.25),('12374','2013-05-21','08:15:00',2.31),('12374','2013-05-21','08:20:00',2.51),('12374','2013-05-21','08:25:00',2.4),('12374','2013-05-21','08:30:00',2.05),('12374','2013-05-21','08:35:00',2.45),('12374','2013-05-21','08:40:00',3.38),('12374','2013-05-21','08:45:00',2.25),('12374','2013-05-21','08:50:00',2.03),('12374','2013-05-21','08:55:00',2.14),('12374','2013-05-21','09:00:00',2.55),('12374','2013-05-21','09:05:00',2.87),('12374','2013-05-21','09:10:00',2.81),('12374','2013-05-21','09:15:00',3.1),('12374','2013-05-21','09:20:00',3.52),('12374','2013-05-21','09:25:00',3.9),('12374','2013-05-21','09:30:00',3.45),('12374','2013-05-21','09:35:00',3.18),('12374','2013-05-21','09:40:00',2.69),('12374','2013-05-21','09:45:00',2.86),('12374','2013-05-21','09:50:00',5.03),('12374','2013-05-21','09:55:00',6.36),('12374','2013-05-21','10:00:00',4.45),('12374','2013-05-21','10:05:00',3.73),('12374','2013-05-21','10:10:00',3.47),('12374','2013-05-21','10:15:00',3.86),('12374','2013-05-21','10:20:00',5.88),('12374','2013-05-21','10:25:00',5.12),('12374','2013-05-21','10:30:00',5.77),('12374','2013-05-21','10:35:00',5.05),('12374','2013-05-21','10:40:00',4.32),('12374','2013-05-21','10:45:00',3.29),('12374','2013-05-21','10:50:00',2.93),('12374','2013-05-21','10:55:00',4.73),('12374','2013-05-21','11:00:00',5.5),('12374','2013-05-21','11:05:00',6.28),('12374','2013-05-21','11:10:00',7.6),('12374','2013-05-21','11:15:00',7.71),('12374','2013-05-21','11:20:00',8.37),('12374','2013-05-21','11:25:00',8.52),('12374','2013-05-21','11:30:00',8.14),('12374','2013-05-21','11:35:00',6.89),('12374','2013-05-21','11:40:00',3.3),('12374','2013-05-21','11:45:00',4.09),('12374','2013-05-21','11:50:00',9.37),('12374','2013-05-21','11:55:00',9.26),('12374','2013-05-21','12:00:00',8.23),('12374','2013-05-21','12:05:00',7.13),('12374','2013-05-21','12:10:00',3.46),('12374','2013-05-21','12:15:00',3.55),('12374','2013-05-21','12:20:00',4.63),('12374','2013-05-21','12:25:00',4.91),('12374','2013-05-21','12:30:00',6.2),('12374','2013-05-21','12:35:00',6.18),('12374','2013-05-21','12:40:00',6.67),('12374','2013-05-21','12:45:00',8.66),('12374','2013-05-21','12:50:00',9.12),('12374','2013-05-21','12:55:00',4.76),('12374','2013-05-21','13:00:00',4.58),('12374','2013-05-21','13:05:00',4.03),('12374','2013-05-21','13:10:00',5.02),('12374','2013-05-21','13:15:00',6.55),('12374','2013-05-21','13:20:00',6.61),('12374','2013-05-21','13:25:00',5.57),('12374','2013-05-21','13:30:00',3.91),('12374','2013-05-21','13:35:00',3.59),('12374','2013-05-21','13:40:00',2.41),('12374','2013-05-21','13:45:00',1.75),('12374','2013-05-21','13:50:00',1.63),('12374','2013-05-21','13:55:00',1.04),('12374','2013-05-21','14:25:00',1.85),('12374','2013-05-21','14:30:00',2.71),('12374','2013-05-21','14:35:00',3.23),('12374','2013-05-21','14:40:00',2.2),('12374','2013-05-21','14:45:00',1.31),('12374','2013-05-21','15:10:00',1.3),('12374','2013-05-21','15:15:00',1.51),('12374','2013-05-21','15:20:00',1.42),('12374','2013-05-21','15:25:00',1.62),('12374','2013-05-21','15:30:00',2),('12374','2013-05-21','15:35:00',1.4),('12374','2013-05-21','15:40:00',1.45),('12374','2013-05-21','15:45:00',2.73),('12374','2013-05-21','15:50:00',3.87),('12374','2013-05-21','15:55:00',2.84),('12374','2013-05-21','16:00:00',1.8),('12374','2013-05-21','16:05:00',1.78),('12374','2013-05-21','16:10:00',1.71),('12374','2013-05-21','16:15:00',1.93),('12374','2013-05-21','16:20:00',1.45),('12374','2013-05-21','16:25:00',1.35),('12374','2013-05-21','16:30:00',1.04),('12374','2013-05-21','16:50:00',1.13),('12374','2013-05-21','16:55:00',1.37),('12374','2013-05-20','07:25:00',1.25),('12374','2013-05-20','07:30:00',1.89),('12374','2013-05-20','07:35:00',2.69),('12374','2013-05-20','07:40:00',2.87),('12374','2013-05-20','07:45:00',3.03),('12374','2013-05-20','07:50:00',3.19),('12374','2013-05-20','07:55:00',3.38),('12374','2013-05-20','08:00:00',3.58),('12374','2013-05-20','08:05:00',3.75),('12374','2013-05-20','08:10:00',3.9),('12374','2013-05-20','08:15:00',4.1),('12374','2013-05-20','08:20:00',4.27),('12374','2013-05-20','08:25:00',4.41),('12374','2013-05-20','08:30:00',4.55),('12374','2013-05-20','08:35:00',4.65),('12374','2013-05-20','08:40:00',4.81),('12374','2013-05-20','08:45:00',4.92),('12374','2013-05-20','08:50:00',5.08),('12374','2013-05-20','08:55:00',5.27),('12374','2013-05-20','09:00:00',5.41),('12374','2013-05-20','09:05:00',5.56),('12374','2013-05-20','09:10:00',5.72),('12374','2013-05-20','09:15:00',5.78),('12374','2013-05-20','09:20:00',5.97),('12374','2013-05-20','09:25:00',6.13),('12374','2013-05-20','09:30:00',6.29),('12374','2013-05-20','09:35:00',6.67),('12374','2013-05-20','09:40:00',7),('12374','2013-05-20','09:45:00',6.88),('12374','2013-05-20','09:50:00',1.97),('12374','2013-05-20','09:55:00',1.4),('12374','2013-05-20','10:00:00',5.88),('12374','2013-05-20','10:05:00',5.16),('12374','2013-05-20','10:10:00',7.47),('12374','2013-05-20','10:15:00',7.54),('12374','2013-05-20','10:20:00',7.59),('12374','2013-05-20','10:25:00',7.68),('12374','2013-05-20','10:30:00',7.53),('12374','2013-05-20','10:35:00',7.84),('12374','2013-05-20','10:40:00',7.99),('12374','2013-05-20','10:45:00',8.1),('12374','2013-05-20','10:50:00',8.18),('12374','2013-05-20','10:55:00',8.26),('12374','2013-05-20','11:00:00',8.36),('12374','2013-05-20','11:05:00',8.43),('12374','2013-05-20','11:10:00',8.49),('12374','2013-05-20','11:15:00',8.61),('12374','2013-05-20','11:20:00',8.67),('12374','2013-05-20','11:25:00',8.73),('12374','2013-05-20','11:30:00',8.81),('12374','2013-05-20','11:35:00',8.87),('12374','2013-05-20','11:40:00',8.91),('12374','2013-05-20','11:45:00',9.04),('12374','2013-05-20','11:50:00',9.13),('12374','2013-05-20','11:55:00',9.14),('12374','2013-05-20','12:00:00',9.18),('12374','2013-05-20','12:05:00',9.19),('12374','2013-05-20','12:10:00',9.2),('12374','2013-05-20','12:15:00',9.21),('12374','2013-05-20','12:20:00',9.28),('12374','2013-05-20','12:25:00',9.34),('12374','2013-05-20','12:30:00',9.34),('12374','2013-05-20','12:35:00',9.38),('12374','2013-05-20','12:40:00',9.37),('12374','2013-05-20','12:45:00',9.33),('12374','2013-05-20','12:50:00',9.37),('12374','2013-05-20','12:55:00',9.4),('12374','2013-05-20','13:00:00',9.37),('12374','2013-05-20','13:05:00',9.36),('12374','2013-05-20','13:10:00',9.38),('12374','2013-05-20','13:15:00',9.38),('12374','2013-05-20','13:20:00',9.3),('12374','2013-05-20','13:25:00',9.24),('12374','2013-05-20','13:30:00',9.24),('12374','2013-05-20','13:35:00',9.24),('12374','2013-05-20','13:40:00',9.32),('12374','2013-05-20','13:45:00',9.3),('12374','2013-05-20','13:50:00',9.29),('12374','2013-05-20','13:55:00',9.26),('12374','2013-05-20','14:00:00',9.23),('12374','2013-05-20','14:05:00',9.18),('12374','2013-05-20','14:10:00',9.11),('12374','2013-05-20','14:15:00',9.04),('12374','2013-05-20','14:20:00',8.99),('12374','2013-05-20','14:25:00',8.93),('12374','2013-05-20','14:30:00',8.85),('12374','2013-05-20','14:35:00',8.76),('12374','2013-05-20','14:40:00',8.73),('12374','2013-05-20','14:45:00',8.65),('12374','2013-05-20','14:50:00',8.56),('12374','2013-05-20','14:55:00',8.38),('12374','2013-05-20','15:00:00',8.29),('12374','2013-05-20','15:05:00',8.26),('12374','2013-05-20','15:10:00',8.09),('12374','2013-05-20','15:15:00',8.03),('12374','2013-05-20','15:20:00',7.93),('12374','2013-05-20','15:25:00',7.84),('12374','2013-05-20','15:30:00',7.81),('12374','2013-05-20','15:35:00',7.64),('12374','2013-05-20','15:40:00',7.56),('12374','2013-05-20','15:45:00',7.48),('12374','2013-05-20','15:50:00',7.22),('12374','2013-05-20','15:55:00',7.15),('12374','2013-05-20','16:00:00',7.16),('12374','2013-05-20','16:05:00',5.93),('12374','2013-05-20','16:10:00',5.23),('12374','2013-05-20','16:15:00',3.69),('12374','2013-05-20','16:20:00',3.97),('12374','2013-05-20','16:25:00',3.47),('12374','2013-05-20','16:30:00',4.47),('12374','2013-05-20','16:35:00',5.95),('12374','2013-05-20','16:40:00',4.95),('12374','2013-05-20','16:45:00',3.48),('12374','2013-05-20','16:50:00',1.91),('12374','2013-05-20','16:55:00',1.97),('12374','2013-05-20','17:00:00',2.35),('12374','2013-05-20','17:05:00',3.32),('12374','2013-05-20','17:10:00',6.33),('12374','2013-05-20','17:15:00',5.15),('12374','2013-05-20','17:20:00',2.91),('12374','2013-05-20','17:25:00',4.55),('12374','2013-05-20','17:30:00',4.2),('12374','2013-05-20','17:35:00',4.03),('12374','2013-05-20','17:40:00',3.92),('12374','2013-05-20','17:45:00',3.74),('12374','2013-05-20','17:50:00',3.6),('12374','2013-05-20','17:55:00',3.09),('12374','2013-05-20','18:00:00',3.71),('12374','2013-05-20','18:05:00',2.65),('12374','2013-05-20','18:10:00',2.54),('12374','2013-05-20','18:15:00',2.52),('12374','2013-05-20','18:20:00',2.3),('12374','2013-05-20','18:25:00',2.16),('12374','2013-05-20','18:30:00',1.97),('12374','2013-05-20','18:35:00',1.89),('12374','2013-05-20','18:40:00',1.71),('12374','2013-05-20','18:45:00',1.63),('12374','2013-05-20','18:50:00',1.55),('12374','2013-05-20','18:55:00',1.46),('12374','2013-05-20','19:00:00',1.38),('12374','2013-05-20','19:05:00',1.22),('12374','2013-05-20','19:10:00',1.05),('12374','2013-05-19','07:35:00',1.17),('12374','2013-05-19','07:40:00',1.17),('12374','2013-05-19','07:45:00',1.15),('12374','2013-05-19','07:50:00',1.26),('12374','2013-05-19','07:55:00',1.48),('12374','2013-05-19','08:00:00',1.61),('12374','2013-05-19','08:05:00',1.9),('12374','2013-05-19','08:10:00',1.9),('12374','2013-05-19','08:15:00',2.39),('12374','2013-05-19','08:20:00',2.48),('12374','2013-05-19','08:25:00',3.85),('12374','2013-05-19','08:30:00',4.33),('12374','2013-05-19','08:35:00',4.18),('12374','2013-05-19','08:40:00',4.51),('12374','2013-05-19','08:45:00',4.7),('12374','2013-05-19','08:50:00',5.17),('12374','2013-05-19','08:55:00',5.19),('12374','2013-05-19','09:00:00',5.28),('12374','2013-05-19','09:05:00',5.53),('12374','2013-05-19','09:10:00',5.49),('12374','2013-05-19','09:15:00',5.62),('12374','2013-05-19','09:20:00',6.19),('12374','2013-05-19','09:25:00',5.16),('12374','2013-05-19','09:30:00',4.28),('12374','2013-05-19','09:35:00',5.7),('12374','2013-05-19','09:40:00',6.39),('12374','2013-05-19','09:45:00',6.54),('12374','2013-05-19','09:50:00',6.69),('12374','2013-05-19','09:55:00',6.85),('12374','2013-05-19','10:00:00',6.96),('12374','2013-05-19','10:05:00',7.07),('12374','2013-05-19','10:10:00',7.19),('12374','2013-05-19','10:15:00',7.32),('12374','2013-05-19','10:20:00',7.45),('12374','2013-05-19','10:25:00',7.55),('12374','2013-05-19','10:30:00',7.69),('12374','2013-05-19','10:35:00',7.93),('12374','2013-05-19','10:40:00',7.91),('12374','2013-05-19','10:45:00',8.02),('12374','2013-05-19','10:50:00',8.14),('12374','2013-05-19','10:55:00',8.27),('12374','2013-05-19','11:00:00',8.33),('12374','2013-05-19','11:05:00',8.48),('12374','2013-05-19','11:10:00',8.59),('12374','2013-05-19','11:15:00',8.73),('12374','2013-05-19','11:20:00',8.8),('12374','2013-05-19','11:25:00',8.56),('12374','2013-05-19','11:30:00',8.18),('12374','2013-05-19','11:35:00',9.05),('12374','2013-05-19','11:40:00',6.27),('12374','2013-05-19','11:45:00',7.26),('12374','2013-05-19','11:50:00',6.67),('12374','2013-05-19','11:55:00',6.82),('12374','2013-05-19','12:00:00',8.19),('12374','2013-05-19','12:05:00',7.61),('12374','2013-05-19','12:10:00',8.41),('12374','2013-05-19','12:15:00',9.7),('12374','2013-05-19','12:20:00',9.54),('12374','2013-05-19','12:25:00',9.41),('12374','2013-05-19','12:30:00',9.44),('12374','2013-05-19','12:35:00',9.46),('12374','2013-05-19','12:40:00',9.43),('12374','2013-05-19','12:45:00',9.5),('12374','2013-05-19','12:50:00',9.46),('12374','2013-05-19','12:55:00',9.53),('12374','2013-05-19','13:00:00',9.47),('12374','2013-05-19','13:05:00',9.49),('12374','2013-05-19','13:10:00',9.48),('12374','2013-05-19','13:15:00',9.47),('12374','2013-05-19','13:20:00',9.4),('12374','2013-05-19','13:25:00',9.46),('12374','2013-05-19','13:30:00',9.49),('12374','2013-05-19','13:35:00',9.43),('12374','2013-05-19','13:40:00',9.42),('12374','2013-05-19','13:45:00',9.43),('12374','2013-05-19','13:50:00',9.35),('12374','2013-05-19','13:55:00',9.36),('12374','2013-05-19','14:00:00',9.37),('12374','2013-05-19','14:05:00',9.33),('12374','2013-05-19','14:10:00',9.32),('12374','2013-05-19','14:15:00',9.27),('12374','2013-05-19','14:20:00',9.22),('12374','2013-05-19','14:25:00',9.11),('12374','2013-05-19','14:30:00',9.04),('12374','2013-05-19','14:35:00',9.03),('12374','2013-05-19','14:40:00',8.95),('12374','2013-05-19','14:45:00',8.9),('12374','2013-05-19','14:50:00',8.84),('12374','2013-05-19','14:55:00',8.75),('12374','2013-05-19','15:00:00',8.65),('12374','2013-05-19','15:05:00',8.53),('12374','2013-05-19','15:10:00',8.39),('12374','2013-05-19','15:15:00',8.27),('12374','2013-05-19','15:20:00',8.11),('12374','2013-05-19','15:25:00',8.04),('12374','2013-05-19','15:30:00',7.97),('12374','2013-05-19','15:35:00',7.82),('12374','2013-05-19','15:40:00',7.72),('12374','2013-05-19','15:45:00',7.6),('12374','2013-05-19','15:50:00',7.48),('12374','2013-05-19','15:55:00',7.36),('12374','2013-05-19','16:00:00',7.22),('12374','2013-05-19','16:05:00',7.12),('12374','2013-05-19','16:10:00',6.96),('12374','2013-05-19','16:15:00',6.82),('12374','2013-05-19','16:20:00',6.68),('12374','2013-05-19','16:25:00',6.53),('12374','2013-05-19','16:30:00',6.38),('12374','2013-05-19','16:35:00',6.24),('12374','2013-05-19','16:40:00',6.07),('12374','2013-05-19','16:45:00',5.92),('12374','2013-05-19','16:50:00',5.8),('12374','2013-05-19','16:55:00',5.61),('12374','2013-05-19','17:00:00',5.48),('12374','2013-05-19','17:05:00',5.32),('12374','2013-05-19','17:10:00',5.1),('12374','2013-05-19','17:15:00',5),('12374','2013-05-19','17:20:00',4.86),('12374','2013-05-19','17:25:00',4.65),('12374','2013-05-19','17:30:00',4.31),('12374','2013-05-19','17:35:00',4.14),('12374','2013-05-19','17:40:00',4.05),('12374','2013-05-19','17:45:00',3.78),('12374','2013-05-19','17:50:00',3.58),('12374','2013-05-19','17:55:00',3.39),('12374','2013-05-19','18:00:00',3.26),('12374','2013-05-19','18:05:00',3.06),('12374','2013-05-19','18:10:00',2.88),('12374','2013-05-19','18:15:00',2.59),('12374','2013-05-19','18:20:00',2.31),('12374','2013-05-19','18:25:00',2.26),('12374','2013-05-19','18:30:00',2.12),('12374','2013-05-19','18:35:00',2.01),('12374','2013-05-19','18:40:00',1.82),('12374','2013-05-19','18:45:00',1.7),('12374','2013-05-19','18:50:00',1.59),('12374','2013-05-19','18:55:00',1.52),('12374','2013-05-19','19:00:00',1.45),('12374','2013-05-19','19:05:00',1.36),('12374','2013-05-19','19:10:00',1.29),('12374','2013-05-19','19:15:00',1.21),('12374','2013-05-19','19:20:00',1.12),('12374','2013-05-19','19:25:00',1.04),('12374','2013-05-18','06:40:00',1),('12374','2013-05-18','06:45:00',1.14),('12374','2013-05-18','06:50:00',1.1),('12374','2013-05-18','06:55:00',1.38),('12374','2013-05-18','07:00:00',1.53),('12374','2013-05-18','07:05:00',1.66),('12374','2013-05-18','07:10:00',1.81),('12374','2013-05-18','07:15:00',1.71),('12374','2013-05-18','07:20:00',2.17),('12374','2013-05-18','07:25:00',2.35),('12374','2013-05-18','07:30:00',2.5),('12374','2013-05-18','07:35:00',2.62),('12374','2013-05-18','07:40:00',2.85),('12374','2013-05-18','07:45:00',3.04),('12374','2013-05-18','07:50:00',3.18),('12374','2013-05-18','07:55:00',3.33),('12374','2013-05-18','08:00:00',3.46),('12374','2013-05-18','08:05:00',3.7),('12374','2013-05-18','08:10:00',3.92),('12374','2013-05-18','08:15:00',4.07),('12374','2013-05-18','08:20:00',4.32),('12374','2013-05-18','08:25:00',4.15),('12374','2013-05-18','08:30:00',3.72),('12374','2013-05-18','08:35:00',4.44),('12374','2013-05-18','08:40:00',4.76),('12374','2013-05-18','08:45:00',5.32),('12374','2013-05-18','08:50:00',5.07),('12374','2013-05-18','08:55:00',5.43),('12374','2013-05-18','09:00:00',5.12),('12374','2013-05-18','09:05:00',5.86),('12374','2013-05-18','09:10:00',5.27),('12374','2013-05-18','09:15:00',5.91),('12374','2013-05-18','09:20:00',5.98),('12374','2013-05-18','09:25:00',6.11),('12374','2013-05-18','09:30:00',6.22),('12374','2013-05-18','09:35:00',6.37),('12374','2013-05-18','09:40:00',6.5),('12374','2013-05-18','09:45:00',6.6),('12374','2013-05-18','09:50:00',6.77),('12374','2013-05-18','09:55:00',6.87),('12374','2013-05-18','10:00:00',6.96),('12374','2013-05-18','10:05:00',7.06),('12374','2013-05-18','10:10:00',7.2),('12374','2013-05-18','10:15:00',7.52),('12374','2013-05-18','10:20:00',6.85),('12374','2013-05-18','10:25:00',6.26),('12374','2013-05-18','10:30:00',6.69),('12374','2013-05-18','10:35:00',7.8),('12374','2013-05-18','10:40:00',7.89),('12374','2013-05-18','10:45:00',8.07),('12374','2013-05-18','10:50:00',8.13),('12374','2013-05-18','10:55:00',4.7),('12374','2013-05-18','11:00:00',7.71),('12374','2013-05-18','11:05:00',7.47),('12374','2013-05-18','11:10:00',7.94),('12374','2013-05-18','11:15:00',8.6),('12374','2013-05-18','11:20:00',7.47),('12374','2013-05-18','11:25:00',3.15),('12374','2013-05-18','11:30:00',9.12),('12374','2013-05-18','11:35:00',8.78),('12374','2013-05-18','11:40:00',8.66),('12374','2013-05-18','11:45:00',8.74),('12374','2013-05-18','11:50:00',8.74),('12374','2013-05-18','11:55:00',8.73),('12374','2013-05-18','12:00:00',8.74),('12374','2013-05-18','12:05:00',8.82),('12374','2013-05-18','12:10:00',8.86),('12374','2013-05-18','12:15:00',8.72),('12374','2013-05-18','12:20:00',6.94),('12374','2013-05-18','12:25:00',8.41),('12374','2013-05-18','12:30:00',8.79),('12374','2013-05-18','12:35:00',3),('12374','2013-05-18','12:40:00',3.24),('12374','2013-05-18','12:45:00',9.65),('12374','2013-05-18','12:50:00',9.39),('12374','2013-05-18','12:55:00',9.09),('12374','2013-05-18','13:00:00',9.04),('12374','2013-05-18','13:05:00',9.07),('12374','2013-05-18','13:10:00',9.04),('12374','2013-05-18','13:15:00',9.03),('12374','2013-05-18','13:20:00',9.06),('12374','2013-05-18','13:25:00',8.8),('12374','2013-05-18','13:30:00',8.74),('12374','2013-05-18','13:35:00',9),('12374','2013-05-18','13:40:00',8.95),('12374','2013-05-18','13:45:00',8.93),('12374','2013-05-18','13:50:00',8.9),('12374','2013-05-18','13:55:00',8.87),('12374','2013-05-18','14:00:00',8.63),('12374','2013-05-18','14:05:00',7.42),('12374','2013-05-18','14:10:00',8.84),('12374','2013-05-18','14:15:00',8.85),('12374','2013-05-18','14:20:00',8.28),('12374','2013-05-18','14:25:00',7.39),('12374','2013-05-18','14:30:00',7.64),('12374','2013-05-18','14:35:00',8.05),('12374','2013-05-18','14:40:00',7.54),('12374','2013-05-18','14:45:00',8.29),('12374','2013-05-18','14:50:00',8.43),('12374','2013-05-18','14:55:00',6.81),('12374','2013-05-18','15:00:00',8.12),('12374','2013-05-18','15:05:00',7.92),('12374','2013-05-18','15:10:00',7.69),('12374','2013-05-18','15:15:00',7.42),('12374','2013-05-18','15:20:00',7.46),('12374','2013-05-18','15:25:00',7.37),('12374','2013-05-18','15:30:00',7.22),('12374','2013-05-18','15:35:00',7.13),('12374','2013-05-18','15:40:00',6.94),('12374','2013-05-18','15:45:00',6.83),('12374','2013-05-18','15:50:00',6.72),('12374','2013-05-18','15:55:00',6.6),('12374','2013-05-18','16:00:00',6.48),('12374','2013-05-18','16:05:00',6.36),('12374','2013-05-18','16:10:00',6.22),('12374','2013-05-18','16:15:00',5.97),('12374','2013-05-18','16:20:00',5.72),('12374','2013-05-18','16:25:00',5.81),('12374','2013-05-18','16:30:00',5.65),('12374','2013-05-18','16:35:00',5.52),('12374','2013-05-18','16:40:00',5.38),('12374','2013-05-18','16:45:00',5.21),('12374','2013-05-18','16:50:00',5.08),('12374','2013-05-18','16:55:00',4.9),('12374','2013-05-18','17:00:00',4.71),('12374','2013-05-18','17:05:00',4.56),('12374','2013-05-18','17:10:00',4.41),('12374','2013-05-18','17:15:00',4.27),('12374','2013-05-18','17:20:00',4.11),('12374','2013-05-18','17:25:00',3.93),('12374','2013-05-18','17:30:00',3.7),('12374','2013-05-18','17:35:00',3.49),('12374','2013-05-18','17:40:00',3.26),('12374','2013-05-18','17:45:00',3.08),('12374','2013-05-18','17:50:00',2.99),('12374','2013-05-18','17:55:00',2.83),('12374','2013-05-18','18:00:00',2.61),('12374','2013-05-18','18:05:00',2.53),('12374','2013-05-18','18:10:00',2.31),('12374','2013-05-18','18:15:00',2.19),('12374','2013-05-18','18:20:00',2.06),('12374','2013-05-18','18:25:00',1.91),('12374','2013-05-18','18:30:00',1.81),('12374','2013-05-18','18:35:00',1.72),('12374','2013-05-18','18:40:00',1.6),('12374','2013-05-18','18:45:00',1.5),('12374','2013-05-18','18:50:00',1.4),('12374','2013-05-18','18:55:00',1.3),('12374','2013-05-18','19:00:00',1.18),('12374','2013-05-18','19:05:00',1.05),('12374','2013-05-17','07:05:00',1.26),('12374','2013-05-17','07:10:00',1.07),('12374','2013-05-17','07:25:00',2.28),('12374','2013-05-17','07:30:00',1.3),('12374','2013-05-17','07:35:00',1.33),('12374','2013-05-17','07:40:00',1.82),('12374','2013-05-17','07:45:00',2.13),('12374','2013-05-17','07:50:00',4.13),('12374','2013-05-17','07:55:00',3.67),('12374','2013-05-17','08:00:00',1.17),('12374','2013-05-17','08:15:00',1.21),('12374','2013-05-17','08:55:00',1.24),('12374','2013-05-17','09:00:00',1.25),('12374','2013-05-17','09:05:00',1.14),('12374','2013-05-17','09:10:00',1.02),('12374','2013-05-17','09:20:00',1.38),('12374','2013-05-17','09:25:00',1.11),('12374','2013-05-17','09:30:00',1.31),('12374','2013-05-17','09:50:00',1),('12374','2013-05-17','09:55:00',1.69),('12374','2013-05-17','10:00:00',2.35),('12374','2013-05-17','10:05:00',2.6),('12374','2013-05-17','10:10:00',3.33),('12374','2013-05-17','10:15:00',3.27),('12374','2013-05-17','10:20:00',4.49),('12374','2013-05-17','10:25:00',4.18),('12374','2013-05-17','10:30:00',4.98),('12374','2013-05-17','10:35:00',6.14),('12374','2013-05-17','10:40:00',5.22),('12374','2013-05-17','10:45:00',5.02),('12374','2013-05-17','10:50:00',5.81),('12374','2013-05-17','10:55:00',5.43),('12374','2013-05-17','11:00:00',5.41),('12374','2013-05-17','11:05:00',7.31),('12374','2013-05-17','11:10:00',4.38),('12374','2013-05-17','11:15:00',5.12),('12374','2013-05-17','11:20:00',5.77),('12374','2013-05-17','11:25:00',5.81),('12374','2013-05-17','11:30:00',5.57),('12374','2013-05-17','11:35:00',5.82),('12374','2013-05-17','11:40:00',5.72),('12374','2013-05-17','11:45:00',4.82),('12374','2013-05-17','11:50:00',3.82),('12374','2013-05-17','11:55:00',4.27),('12374','2013-05-17','12:00:00',7.14),('12374','2013-05-17','12:05:00',8.37),('12374','2013-05-17','12:10:00',7.82),('12374','2013-05-17','12:15:00',5.6),('12374','2013-05-17','12:20:00',7.51),('12374','2013-05-17','12:25:00',8.82),('12374','2013-05-17','12:30:00',9.44),('12374','2013-05-17','12:35:00',8.66),('12374','2013-05-17','12:40:00',8.52),('12374','2013-05-17','12:45:00',8.32),('12374','2013-05-17','12:50:00',9.46),('12374','2013-05-17','12:55:00',9.48),('12374','2013-05-17','13:00:00',9.47),('12374','2013-05-17','13:05:00',9.48),('12374','2013-05-17','13:10:00',9.45),('12374','2013-05-17','13:15:00',9.45),('12374','2013-05-17','13:20:00',9.18),('12374','2013-05-17','13:25:00',9.05),('12374','2013-05-17','13:30:00',9.24),('12374','2013-05-17','13:35:00',9.31),('12374','2013-05-17','13:40:00',8.41),('12374','2013-05-17','13:45:00',8.95),('12374','2013-05-17','13:50:00',8.6),('12374','2013-05-17','13:55:00',7.61),('12374','2013-05-17','14:00:00',7.73),('12374','2013-05-17','14:05:00',9.27),('12374','2013-05-17','14:10:00',7.58),('12374','2013-05-17','14:15:00',8.02),('12374','2013-05-17','14:20:00',9.37),('12374','2013-05-17','14:25:00',8.65),('12374','2013-05-17','14:30:00',7.25),('12374','2013-05-17','14:35:00',6.47),('12374','2013-05-17','14:40:00',7.18),('12374','2013-05-17','14:45:00',8.69),('12374','2013-05-17','14:50:00',8.85),('12374','2013-05-17','14:55:00',8.6),('12374','2013-05-17','15:00:00',8.5),('12374','2013-05-17','15:05:00',8.39),('12374','2013-05-17','15:10:00',8.29),('12374','2013-05-17','15:15:00',8.19),('12374','2013-05-17','15:20:00',8.07),('12374','2013-05-17','15:25:00',7.97),('12374','2013-05-17','15:30:00',7.87),('12374','2013-05-17','15:35:00',7.74),('12374','2013-05-17','15:40:00',7.62),('12374','2013-05-17','15:45:00',7.48),('12374','2013-05-17','15:50:00',7.35),('12374','2013-05-17','15:55:00',7.22),('12374','2013-05-17','16:00:00',7.08),('12374','2013-05-17','16:05:00',6.95),('12374','2013-05-17','16:10:00',6.83),('12374','2013-05-17','16:15:00',6.67),('12374','2013-05-17','16:20:00',6.55),('12374','2013-05-17','16:25:00',6.41),('12374','2013-05-17','16:30:00',6.29),('12374','2013-05-17','16:35:00',6.15),('12374','2013-05-17','16:40:00',5.98),('12374','2013-05-17','16:45:00',5.8),('12374','2013-05-17','16:50:00',5.67),('12374','2013-05-17','16:55:00',5.52),('12374','2013-05-17','17:00:00',5.32),('12374','2013-05-17','17:05:00',5.16),('12374','2013-05-17','17:10:00',5.01),('12374','2013-05-17','17:15:00',4.87),('12374','2013-05-17','17:20:00',4.71),('12374','2013-05-17','17:25:00',4.55),('12374','2013-05-17','17:30:00',4.34),('12374','2013-05-17','17:35:00',4.04),('12374','2013-05-17','17:40:00',3.89),('12374','2013-05-17','17:45:00',3.6),('12374','2013-05-17','17:50:00',3.49),('12374','2013-05-17','17:55:00',3.26),('12374','2013-05-17','18:00:00',3.16),('12374','2013-05-17','18:05:00',2.93),('12374','2013-05-17','18:10:00',2.72),('12374','2013-05-17','18:15:00',2.44),('12374','2013-05-17','18:20:00',2.33),('12374','2013-05-17','18:25:00',2.1),('12374','2013-05-17','18:30:00',1.79),('12374','2013-05-17','18:35:00',1.32),('12374','2013-05-17','18:40:00',1.44),('12374','2013-05-17','18:45:00',1.59),('12374','2013-05-17','18:50:00',1.57),('12374','2013-05-17','18:55:00',1.48),('12374','2013-05-17','19:05:00',1),('12374','2013-05-17','19:10:00',1.02),('12374','2013-05-16','09:10:00',1.33),('12374','2013-05-16','09:20:00',2.09),('12374','2013-05-16','09:25:00',2.03),('12374','2013-05-16','09:30:00',2.75),('12374','2013-05-16','09:35:00',3.53),('12374','2013-05-16','09:40:00',3.85),('12374','2013-05-16','09:45:00',6.5),('12374','2013-05-16','09:50:00',6.86),('12374','2013-05-16','09:55:00',6.46),('12374','2013-05-16','10:00:00',2.53),('12374','2013-05-16','10:05:00',4.43),('12374','2013-05-16','10:10:00',4.25),('12374','2013-05-16','10:15:00',3.77),('12374','2013-05-16','10:20:00',3.65),('12374','2013-05-16','10:25:00',3.07),('12374','2013-05-16','10:30:00',1.68),('12374','2013-05-16','10:35:00',1.18),('12374','2013-05-16','10:40:00',1.46),('12374','2013-05-16','10:45:00',3.82),('12374','2013-05-16','10:55:00',2.1),('12374','2013-05-16','11:00:00',2.84),('12374','2013-05-16','11:05:00',1.95),('12374','2013-05-16','11:10:00',1.15),('12374','2013-05-16','11:15:00',1.12),('12374','2013-05-16','11:20:00',1.54),('12374','2013-05-16','11:25:00',2.41),('12374','2013-05-16','11:30:00',2.42),('12374','2013-05-16','11:35:00',2.22),('12374','2013-05-16','11:40:00',3.26),('12374','2013-05-16','11:45:00',3.34),('12374','2013-05-16','11:50:00',2.95),('12374','2013-05-16','11:55:00',2.72),('12374','2013-05-16','12:00:00',2.05),('12374','2013-05-16','12:05:00',2.13),('12374','2013-05-16','12:10:00',3.42),('12374','2013-05-16','12:15:00',3.34),('12374','2013-05-16','12:20:00',4.39),('12374','2013-05-16','12:25:00',4.17),('12374','2013-05-16','12:30:00',4.82),('12374','2013-05-16','12:35:00',4.54),('12374','2013-05-16','12:40:00',3.24),('12374','2013-05-16','12:45:00',4.36),('12374','2013-05-16','12:50:00',4.93),('12374','2013-05-16','12:55:00',8.45),('12374','2013-05-16','13:00:00',9.04),('12374','2013-05-16','13:05:00',8.88),('12374','2013-05-16','13:10:00',6.59),('12374','2013-05-16','13:15:00',6.97),('12374','2013-05-16','13:20:00',9.02),('12374','2013-05-16','13:25:00',8.86),('12374','2013-05-16','13:30:00',8.81),('12374','2013-05-16','13:35:00',8.68),('12374','2013-05-16','13:40:00',8.71),('12374','2013-05-16','13:45:00',8.66),('12374','2013-05-16','13:50:00',8.63),('12374','2013-05-16','13:55:00',8.56),('12374','2013-05-16','14:00:00',8.47),('12374','2013-05-16','14:05:00',8.4),('12374','2013-05-16','14:10:00',8.41),('12374','2013-05-16','14:15:00',8.3),('12374','2013-05-16','14:20:00',8.26),('12374','2013-05-16','14:25:00',8.18),('12374','2013-05-16','14:30:00',8.21),('12374','2013-05-16','14:35:00',8.15),('12374','2013-05-16','14:40:00',7.97),('12374','2013-05-16','14:45:00',7.95),('12374','2013-05-16','14:50:00',7.88),('12374','2013-05-16','14:55:00',7.78),('12374','2013-05-16','15:00:00',7.69),('12374','2013-05-16','15:05:00',7.54),('12374','2013-05-16','15:10:00',7.48),('12374','2013-05-16','15:15:00',7.38),('12374','2013-05-16','15:20:00',7.26),('12374','2013-05-16','15:25:00',7.18),('12374','2013-05-16','15:30:00',7.03),('12374','2013-05-16','15:35:00',6.92),('12374','2013-05-16','15:40:00',6.8),('12374','2013-05-16','15:45:00',6.68),('12374','2013-05-16','15:50:00',6.39),('12374','2013-05-16','15:55:00',6.38),('12374','2013-05-16','16:00:00',6.2),('12374','2013-05-16','16:05:00',5.92),('12374','2013-05-16','16:10:00',6),('12374','2013-05-16','16:15:00',5.78),('12374','2013-05-16','16:20:00',5.75),('12374','2013-05-16','16:25:00',5.56),('12374','2013-05-16','16:30:00',5.35),('12374','2013-05-16','16:35:00',5.25),('12374','2013-05-16','16:40:00',5.09),('12374','2013-05-16','16:45:00',4.94),('12374','2013-05-16','16:50:00',3.77),('12374','2013-05-16','16:55:00',3.89),('12374','2013-05-16','17:00:00',3.15),('12374','2013-05-16','17:05:00',3.39),('12374','2013-05-16','17:10:00',3.69),('12374','2013-05-16','17:15:00',3.97),('12374','2013-05-16','17:20:00',4.14),('12374','2013-05-16','17:25:00',3.33),('12374','2013-05-16','17:30:00',3.05),('12374','2013-05-16','17:35:00',3.28),('12374','2013-05-16','17:40:00',3.4),('12374','2013-05-16','17:45:00',3.43),('12374','2013-05-16','17:50:00',2.91),('12374','2013-05-16','17:55:00',2.71),('12374','2013-05-16','18:00:00',2.66),('12374','2013-05-16','18:05:00',2.4),('12374','2013-05-16','18:10:00',1.71),('12374','2013-05-16','18:15:00',1.25),('12374','2013-05-15','07:00:00',1.04),('12374','2013-05-15','07:05:00',1.34),('12374','2013-05-15','07:10:00',1.59),('12374','2013-05-15','07:15:00',1.7),('12374','2013-05-15','07:20:00',2.56),('12374','2013-05-15','07:25:00',2.29),('12374','2013-05-15','07:30:00',2.68),('12374','2013-05-15','07:35:00',2.7),('12374','2013-05-15','07:40:00',2.9),('12374','2013-05-15','07:45:00',2.75),('12374','2013-05-15','07:50:00',3.02),('12374','2013-05-15','07:55:00',3.04),('12374','2013-05-15','08:00:00',3.6),('12374','2013-05-15','08:05:00',3.64),('12374','2013-05-15','08:10:00',3.87),('12374','2013-05-15','08:15:00',4.04),('12374','2013-05-15','08:20:00',4.23),('12374','2013-05-15','08:25:00',4.36),('12374','2013-05-15','08:30:00',4.47),('12374','2013-05-15','08:35:00',4.57),('12374','2013-05-15','08:40:00',4.75),('12374','2013-05-15','08:45:00',4.93),('12374','2013-05-15','08:50:00',4.95),('12374','2013-05-15','08:55:00',5.22),('12374','2013-05-15','09:00:00',5.26),('12374','2013-05-15','09:05:00',5.35),('12374','2013-05-15','09:10:00',5.44),('12374','2013-05-15','09:15:00',5.62),('12374','2013-05-15','09:20:00',5.95),('12374','2013-05-15','09:25:00',5.98),('12374','2013-05-15','09:30:00',5.86),('12374','2013-05-15','09:35:00',6.14),('12374','2013-05-15','09:40:00',6.44),('12374','2013-05-15','09:45:00',6.6),('12374','2013-05-15','09:50:00',6.7),('12374','2013-05-15','09:55:00',6.66),('12374','2013-05-15','10:00:00',6.9),('12374','2013-05-15','10:05:00',7.04),('12374','2013-05-15','10:10:00',7.18),('12374','2013-05-15','10:15:00',7.3),('12374','2013-05-15','10:20:00',7.39),('12374','2013-05-15','10:25:00',7.38),('12374','2013-05-15','10:30:00',7.5),('12374','2013-05-15','10:35:00',7.66),('12374','2013-05-15','10:40:00',7.71),('12374','2013-05-15','10:45:00',7.69),('12374','2013-05-15','10:50:00',7.99),('12374','2013-05-15','10:55:00',8.1),('12374','2013-05-15','11:00:00',7.93),('12374','2013-05-15','11:05:00',8.29),('12374','2013-05-15','11:10:00',8.17),('12374','2013-05-15','11:15:00',8.23),('12374','2013-05-15','11:20:00',8.71),('12374','2013-05-15','11:25:00',8.81),('12374','2013-05-15','11:30:00',9),('12374','2013-05-15','11:35:00',7.46),('12374','2013-05-15','11:40:00',8.52),('12374','2013-05-15','11:45:00',8.96),('12374','2013-05-15','11:50:00',8.45),('12374','2013-05-15','11:55:00',8.04),('12374','2013-05-15','12:00:00',7.03),('12374','2013-05-15','12:05:00',6.32),('12374','2013-05-15','12:10:00',8.07),('12374','2013-05-15','12:15:00',8.57),('12374','2013-05-15','12:20:00',7.3),('12374','2013-05-15','12:25:00',6.23),('12374','2013-05-15','12:30:00',5.31),('12374','2013-05-15','12:35:00',4.22),('12374','2013-05-15','12:40:00',3.92),('12374','2013-05-15','12:45:00',3.77),('12374','2013-05-15','12:50:00',3.76),('12374','2013-05-15','12:55:00',3.69),('12374','2013-05-15','13:00:00',3.73),('12374','2013-05-15','13:05:00',4.02),('12374','2013-05-15','13:10:00',4.55),('12374','2013-05-15','13:15:00',5.32),('12374','2013-05-15','13:20:00',5.54),('12374','2013-05-15','13:25:00',5.18),('12374','2013-05-15','13:30:00',4.69),('12374','2013-05-15','13:35:00',4.16),('12374','2013-05-15','13:40:00',4.16),('12374','2013-05-15','13:45:00',4.29),('12374','2013-05-15','13:50:00',3.41),('12374','2013-05-15','13:55:00',2.9),('12374','2013-05-15','14:00:00',3.15),('12374','2013-05-15','14:05:00',3.64),('12374','2013-05-15','14:10:00',4.14),('12374','2013-05-15','14:15:00',3.78),('12374','2013-05-15','14:20:00',3.44),('12374','2013-05-15','14:25:00',3.29),('12374','2013-05-15','14:30:00',3.29),('12374','2013-05-15','14:35:00',3.33),('12374','2013-05-15','14:40:00',3.05),('12374','2013-05-15','14:45:00',2.84),('12374','2013-05-15','14:50:00',2.76),('12374','2013-05-15','14:55:00',2.41),('12374','2013-05-15','15:00:00',2.2),('12374','2013-05-15','15:05:00',2.09),('12374','2013-05-15','15:10:00',2.15),('12374','2013-05-15','15:15:00',2.05),('12374','2013-05-15','15:20:00',2.13),('12374','2013-05-15','15:25:00',2.45),('12374','2013-05-15','15:30:00',2.71),('12374','2013-05-15','15:35:00',2.63),('12374','2013-05-15','15:40:00',3.58),('12374','2013-05-15','15:45:00',5.36),('12374','2013-05-15','15:50:00',6.39),('12374','2013-05-15','15:55:00',6.38),('12374','2013-05-15','16:00:00',7.09),('12374','2013-05-15','16:05:00',4.83),('12374','2013-05-15','16:10:00',3.76),('12374','2013-05-15','16:15:00',3.38),('12374','2013-05-15','16:20:00',4.22),('12374','2013-05-15','16:25:00',4.73),('12374','2013-05-15','16:30:00',5.08),('12374','2013-05-15','16:35:00',3.79),('12374','2013-05-15','16:40:00',3.35),('12374','2013-05-15','16:45:00',4.82),('12374','2013-05-15','16:50:00',4.68),('12374','2013-05-15','16:55:00',3.83),('12374','2013-05-15','17:00:00',4.54),('12374','2013-05-15','17:05:00',5.25),('12374','2013-05-15','17:10:00',5.62),('12374','2013-05-15','17:15:00',3.41),('12374','2013-05-15','17:20:00',2.21),('12374','2013-05-15','17:25:00',1.79),('12374','2013-05-15','17:30:00',1.54),('12374','2013-05-15','17:35:00',1.35),('12374','2013-05-15','17:40:00',1.01),('12374','2013-05-15','18:40:00',1.09),('12374','2013-05-15','18:45:00',1.1),('12374','2013-05-14','06:40:00',1.06),('12374','2013-05-14','06:45:00',1.18),('12374','2013-05-14','06:50:00',1.26),('12374','2013-05-14','06:55:00',1.19),('12374','2013-05-14','07:00:00',1.51),('12374','2013-05-14','07:05:00',1.68),('12374','2013-05-14','07:10:00',1.76),('12374','2013-05-14','07:15:00',2),('12374','2013-05-14','07:20:00',1.87),('12374','2013-05-14','07:25:00',2.38),('12374','2013-05-14','07:30:00',2.55),('12374','2013-05-14','07:35:00',2.72),('12374','2013-05-14','07:41:00',2.87),('12374','2013-05-14','07:45:00',3.09),('12374','2013-05-14','07:50:00',3.25),('12374','2013-05-14','07:55:00',3.42),('12374','2013-05-14','08:00:00',3.58),('12374','2013-05-14','08:05:00',3.75),('12374','2013-05-14','08:10:00',3.92),('12374','2013-05-14','08:15:00',4.07),('12374','2013-05-14','08:20:00',4.21),('12374','2013-05-14','08:25:00',4.36),('12374','2013-05-14','08:30:00',4.5),('12374','2013-05-14','08:35:00',4.66),('12374','2013-05-14','08:40:00',4.77),('12374','2013-05-14','08:45:00',4.96),('12374','2013-05-14','08:50:00',5.09),('12374','2013-05-14','08:55:00',5.25),('12374','2013-05-14','09:00:00',5.4),('12374','2013-05-14','09:05:00',5.54),('12374','2013-05-14','09:10:00',5.68),('12374','2013-05-14','09:15:00',5.81),('12374','2013-05-14','09:20:00',5.96),('12374','2013-05-14','09:25:00',6.1),('12374','2013-05-14','09:30:00',6.2),('12374','2013-05-14','09:35:00',6.36),('12374','2013-05-14','09:40:00',6.46),('12374','2013-05-14','09:45:00',6.54),('12374','2013-05-14','09:50:00',6.71),('12374','2013-05-14','09:55:00',6.84),('12374','2013-05-14','10:00:00',6.96),('12374','2013-05-14','10:05:00',7.08),('12374','2013-05-14','10:10:00',7.2),('12374','2013-05-14','10:15:00',7.32),('12374','2013-05-14','10:20:00',7.37),('12374','2013-05-14','10:25:00',7.48),('12374','2013-05-14','10:30:00',7.58),('12374','2013-05-14','10:35:00',7.71),('12374','2013-05-14','10:40:00',7.8),('12374','2013-05-14','10:45:00',7.87),('12374','2013-05-14','10:50:00',7.96),('12374','2013-05-14','10:55:00',8.04),('12374','2013-05-14','11:00:00',8.15),('12374','2013-05-14','11:05:00',8.15),('12374','2013-05-14','11:10:00',8.3),('12374','2013-05-14','11:15:00',8.44),('12374','2013-05-14','11:20:00',8.57),('12374','2013-05-14','11:25:00',8.67),('12374','2013-05-14','11:30:00',8.73),('12374','2013-05-14','11:35:00',8.79),('12374','2013-05-14','11:40:00',8.88),('12374','2013-05-14','11:45:00',8.95),('12374','2013-05-14','11:50:00',9),('12374','2013-05-14','11:55:00',9.04),('12374','2013-05-14','12:00:00',9.08),('12374','2013-05-14','12:05:00',9.07),('12374','2013-05-14','12:10:00',9.11),('12374','2013-05-14','12:15:00',9.13),('12374','2013-05-14','12:20:00',9.17),('12374','2013-05-14','12:25:00',9.15),('12374','2013-05-14','12:30:00',9.2),('12374','2013-05-14','12:35:00',9.22),('12374','2013-05-14','12:40:00',9.2),('12374','2013-05-14','12:45:00',9.28),('12374','2013-05-14','12:50:00',9.27),('12374','2013-05-14','12:55:00',9.25),('12374','2013-05-14','13:00:00',9.22),('12374','2013-05-14','13:05:00',9.22),('12374','2013-05-14','13:10:00',9.2),('12374','2013-05-14','13:15:00',9.26),('12374','2013-05-14','13:20:00',9.26),('12374','2013-05-14','13:25:00',9.22),('12374','2013-05-14','13:30:00',9.1),('12374','2013-05-14','13:35:00',9.14),('12374','2013-05-14','13:40:00',9.17),('12374','2013-05-14','13:45:00',9.13),('12374','2013-05-14','13:50:00',9.05),('12374','2013-05-14','13:55:00',8.85),('12374','2013-05-14','14:00:00',8.83),('12374','2013-05-14','14:05:00',8.86),('12374','2013-05-14','14:10:00',9.02),('12374','2013-05-14','14:15:00',9),('12374','2013-05-14','14:20:00',8.94),('12374','2013-05-14','14:25:00',8.87),('12374','2013-05-14','14:30:00',8.77),('12374','2013-05-14','14:35:00',8.68),('12374','2013-05-14','14:40:00',8.65),('12374','2013-05-14','14:45:00',8.61),('12374','2013-05-14','14:50:00',8.5),('12374','2013-05-14','14:55:00',8.42),('12374','2013-05-14','15:00:00',8.31),('12374','2013-05-14','15:05:00',8.25),('12374','2013-05-14','15:10:00',8.16),('12374','2013-05-14','15:15:00',8.05),('12374','2013-05-14','15:20:00',7.97),('12374','2013-05-14','15:25:00',7.87),('12374','2013-05-14','15:30:00',7.75),('12374','2013-05-14','15:35:00',7.62),('12374','2013-05-14','15:40:00',7.49),('12374','2013-05-14','15:45:00',7.37),('12374','2013-05-14','15:50:00',7.25),('12374','2013-05-14','15:55:00',7.13),('12374','2013-05-14','16:00:00',6.95),('12374','2013-05-14','16:05:00',6.77),('12374','2013-05-14','16:10:00',6.69),('12374','2013-05-14','16:15:00',6.6),('12374','2013-05-14','16:20:00',6.47),('12374','2013-05-14','16:25:00',6.33),('12374','2013-05-14','16:30:00',6.2),('12374','2013-05-14','16:35:00',6.05),('12374','2013-05-14','16:40:00',5.88),('12374','2013-05-14','16:45:00',5.66),('12374','2013-05-14','16:50:00',5.51),('12374','2013-05-14','16:55:00',5.37),('12374','2013-05-14','17:00:00',5.29),('12374','2013-05-14','17:05:00',5.13),('12374','2013-05-14','17:10:00',4.98),('12374','2013-05-14','17:15:00',4.77),('12374','2013-05-14','17:20:00',4.63),('12374','2013-05-14','17:25:00',4.41),('12374','2013-05-14','17:30:00',4.26),('12374','2013-05-14','17:35:00',4.03),('12374','2013-05-14','17:40:00',3.83),('12374','2013-05-14','17:45:00',3.54),('12374','2013-05-14','17:50:00',3.41),('12374','2013-05-14','17:55:00',3.19),('12374','2013-05-14','18:00:00',2.97),('12374','2013-05-14','18:05:00',2.82),('12374','2013-05-14','18:10:00',2.73),('12374','2013-05-14','18:15:00',2.51),('12374','2013-05-14','18:20:00',2.16),('12374','2013-05-14','18:25:00',2.09),('12374','2013-05-14','18:30:00',1.91),('12374','2013-05-14','18:35:00',1.78),('12374','2013-05-14','18:40:00',1.71),('12374','2013-05-14','18:45:00',1.57),('12374','2013-05-14','18:50:00',1.44),('12374','2013-05-14','18:55:00',1.39),('12374','2013-05-14','19:00:00',1.35),('12374','2013-05-14','19:05:00',1.28),('12374','2013-05-14','19:10:00',1.12),('12374','2013-05-14','19:15:00',1.09),('12374','2013-05-13','06:55:00',1.18),('12374','2013-05-13','07:00:00',1.19),('12374','2013-05-13','07:05:00',1.42),('12374','2013-05-13','07:10:00',1.64),('12374','2013-05-13','07:15:00',2.04),('12374','2013-05-13','07:20:00',1.99),('12374','2013-05-13','07:25:00',2.1),('12374','2013-05-13','07:30:00',2.36),('12374','2013-05-13','07:35:00',2.78),('12374','2013-05-13','07:40:00',2.44),('12374','2013-05-13','07:45:00',1.78),('12374','2013-05-13','07:50:00',3.19),('12374','2013-05-13','07:55:00',3.21),('12374','2013-05-13','08:00:00',3.28),('12374','2013-05-13','08:05:00',3.21),('12374','2013-05-13','08:10:00',3.41),('12374','2013-05-13','08:15:00',3.88),('12374','2013-05-13','08:20:00',4.07),('12374','2013-05-13','08:25:00',4.24),('12374','2013-05-13','08:30:00',4.41),('12374','2013-05-13','08:35:00',4.53),('12374','2013-05-13','08:40:00',4.65),('12374','2013-05-13','08:45:00',4.79),('12374','2013-05-13','08:50:00',4.98),('12374','2013-05-13','08:55:00',5.12),('12374','2013-05-13','09:00:00',5.3),('12374','2013-05-13','09:05:00',5.46),('12374','2013-05-13','09:10:00',5.62),('12374','2013-05-13','09:15:00',5.8),('12374','2013-05-13','09:20:00',6.04),('12374','2013-05-13','09:25:00',6.23),('12374','2013-05-13','09:30:00',6.31),('12374','2013-05-13','09:35:00',6.43),('12374','2013-05-13','09:40:00',6.71),('12374','2013-05-13','16:20:00',3.94),('12374','2013-05-13','16:25:00',6.27),('12374','2013-05-13','16:30:00',6.17),('12374','2013-05-13','16:35:00',6.03),('12374','2013-05-13','16:40:00',4.37),('12374','2013-05-13','16:45:00',5.63),('12374','2013-05-13','16:50:00',5.55),('12374','2013-05-13','16:55:00',5.42),('12374','2013-05-13','17:00:00',4.67),('12374','2013-05-13','17:05:00',4.39),('12374','2013-05-13','17:10:00',4.88),('12374','2013-05-13','17:15:00',4.75),('12374','2013-05-13','17:20:00',4.21),('12374','2013-05-13','17:25:00',3.75),('12374','2013-05-13','17:30:00',4.28),('12374','2013-05-13','17:35:00',4.02),('12374','2013-05-13','17:40:00',3.75),('12374','2013-05-13','17:45:00',3.18),('12374','2013-05-13','17:50:00',2.96),('12374','2013-05-13','17:55:00',1.53),('12374','2013-05-13','18:05:00',1.95),('12374','2013-05-13','18:10:00',2.27),('12374','2013-05-13','18:15:00',2.3),('12374','2013-05-13','18:20:00',2.38),('12374','2013-05-13','18:25:00',2.28),('12374','2013-05-13','18:30:00',1.85),('12374','2013-05-13','18:35:00',1.82),('12374','2013-05-13','18:40:00',1.92),('12374','2013-05-13','18:45:00',1.88),('12374','2013-05-13','18:50:00',1.81),('12374','2013-05-13','18:55:00',1.77),('12374','2013-05-13','19:00:00',1.6),('12374','2013-05-13','19:05:00',1.72),('12374','2013-05-13','19:10:00',1.53),('12374','2013-05-13','19:15:00',1.35),('12374','2013-05-13','19:20:00',1.18),('12374','2013-05-13','19:25:00',1.1),('12374','2013-05-12','07:05:00',1.02),('12374','2013-05-12','07:10:00',1.17),('12374','2013-05-12','07:15:00',1.13),('12374','2013-05-12','07:20:00',1.1),('12374','2013-05-12','07:25:00',1.07),('12374','2013-05-12','07:30:00',1.35),('12374','2013-05-12','07:35:00',1.53),('12374','2013-05-12','07:40:00',1.68),('12374','2013-05-12','07:45:00',2.05),('12374','2013-05-12','07:50:00',2.93),('12374','2013-05-12','07:55:00',2.3),('12374','2013-05-12','08:00:00',2.8),('12374','2013-05-12','08:05:00',3.33),('12374','2013-05-12','08:10:00',2.25),('12374','2013-05-12','08:15:00',2.03),('12374','2013-05-12','08:20:00',2.77),('12374','2013-05-12','08:25:00',4.39),('12374','2013-05-12','08:30:00',4.79),('12374','2013-05-12','08:35:00',4.91),('12374','2013-05-12','08:40:00',4.41),('12374','2013-05-12','08:45:00',5.17),('12374','2013-05-12','08:50:00',5.16),('12374','2013-05-12','08:55:00',5.8),('12374','2013-05-12','09:00:00',6.08),('12374','2013-05-12','09:05:00',6.54),('12374','2013-05-12','09:10:00',4.07),('12374','2013-05-12','09:15:00',3.32),('12374','2013-05-12','09:20:00',3.73),('12374','2013-05-12','09:25:00',2),('12374','2013-05-12','09:30:00',2.36),('12374','2013-05-12','09:35:00',6.52),('12374','2013-05-12','09:40:00',6.58),('12374','2013-05-12','09:45:00',6.64),('12374','2013-05-12','09:50:00',6.76),('12374','2013-05-12','09:55:00',6.87),('12374','2013-05-12','10:00:00',7.16),('12374','2013-05-12','10:05:00',7.32),('12374','2013-05-12','10:10:00',6.61),('12374','2013-05-12','10:15:00',7.64),('12374','2013-05-12','10:20:00',7.13),('12374','2013-05-12','10:25:00',7.55),('12374','2013-05-12','10:30:00',7.7),('12374','2013-05-12','10:35:00',7.83),('12374','2013-05-12','10:40:00',7.82),('12374','2013-05-12','10:45:00',7.95),('12374','2013-05-12','10:50:00',8.06),('12374','2013-05-12','10:55:00',7.76),('12374','2013-05-12','11:00:00',8.28),('12374','2013-05-12','11:05:00',8.3),('12374','2013-05-12','11:10:00',8.41),('12374','2013-05-12','11:15:00',8.43),('12374','2013-05-12','11:20:00',8.53),('12374','2013-05-12','11:25:00',8.67),('12374','2013-05-12','11:30:00',8.71),('12374','2013-05-12','11:35:00',8.76),('12374','2013-05-12','11:40:00',8.87),('12374','2013-05-12','11:45:00',8.9),('12374','2013-05-12','11:50:00',8.95),('12374','2013-05-12','11:55:00',8.99),('12374','2013-05-12','12:00:00',9.03),('12374','2013-05-12','12:05:00',9.1),('12374','2013-05-12','12:10:00',9.06),('12374','2013-05-12','12:15:00',9.08),('12374','2013-05-12','12:20:00',9.15),('12374','2013-05-12','12:25:00',9.19),('12374','2013-05-12','12:30:00',9.25),('12374','2013-05-12','12:35:00',9.28),('12374','2013-05-12','12:40:00',9.28),('12374','2013-05-12','12:45:00',9.29),('12374','2013-05-12','12:50:00',9.31),('12374','2013-05-12','12:55:00',9.28),('12374','2013-05-12','13:00:00',9.25),('12374','2013-05-12','13:05:00',9.23),('12374','2013-05-12','13:10:00',9.25),('12374','2013-05-12','13:15:00',9.27),('12374','2013-05-12','13:20:00',9.34),('12374','2013-05-12','13:25:00',9.28),('12374','2013-05-12','13:30:00',9.25),('12374','2013-05-12','13:35:00',9.27),('12374','2013-05-12','13:40:00',9.22),('12374','2013-05-12','13:45:00',9.11),('12374','2013-05-12','13:50:00',9.03),('12374','2013-05-12','13:55:00',9.02),('12374','2013-05-12','14:00:00',9.16),('12374','2013-05-12','14:05:00',9.1),('12374','2013-05-12','14:10:00',8.97),('12374','2013-05-12','14:15:00',9.03),('12374','2013-05-12','14:20:00',8.93),('12374','2013-05-12','14:25:00',8.91),('12374','2013-05-12','14:30:00',8.96),('12374','2013-05-12','14:35:00',8.79),('12374','2013-05-12','14:40:00',8.6),('12374','2013-05-12','14:45:00',8.57),('12374','2013-05-12','14:50:00',8.44),('12374','2013-05-12','14:55:00',8.39),('12374','2013-05-12','15:00:00',8.25),('12374','2013-05-12','15:05:00',8.15),('12374','2013-05-12','15:10:00',8.03),('12374','2013-05-12','15:15:00',7.86),('12374','2013-05-12','15:20:00',7.78),('12374','2013-05-12','15:25:00',7.71),('12374','2013-05-12','15:30:00',7.65),('12374','2013-05-12','15:35:00',7.59),('12374','2013-05-12','15:40:00',7.43),('12374','2013-05-12','15:45:00',6.86),('12374','2013-05-12','15:50:00',7.05),('12374','2013-05-12','15:55:00',6.52),('12374','2013-05-12','16:00:00',7.26),('12374','2013-05-12','16:05:00',6.94),('12374','2013-05-12','16:10:00',6.8),('12374','2013-05-12','16:15:00',6.7),('12374','2013-05-12','16:20:00',6.59),('12374','2013-05-12','16:25:00',6.36),('12374','2013-05-12','16:30:00',6.35),('12374','2013-05-12','16:35:00',5.97),('12374','2013-05-12','16:40:00',6.1),('12374','2013-05-12','16:45:00',5.33),('12374','2013-05-12','16:50:00',4.85),('12374','2013-05-12','16:55:00',5.64),('12374','2013-05-12','17:00:00',5.49),('12374','2013-05-12','17:05:00',5.67),('12374','2013-05-12','17:10:00',4.48),('12374','2013-05-12','17:15:00',4.94),('12374','2013-05-12','17:20:00',4.9),('12374','2013-05-12','17:25:00',4.84),('12374','2013-05-12','17:30:00',4.93),('12374','2013-05-12','17:35:00',4.91),('12374','2013-05-12','17:40:00',3.79),('12374','2013-05-12','17:45:00',4.43),('12374','2013-05-12','17:50:00',3.98),('12374','2013-05-12','17:55:00',3.64),('12374','2013-05-12','18:00:00',3.41),('12374','2013-05-12','18:05:00',3.13),('12374','2013-05-12','18:10:00',2.92),('12374','2013-05-12','18:15:00',2.9),('12374','2013-05-12','18:20:00',2.56),('12374','2013-05-12','18:25:00',2.5),('12374','2013-05-12','18:30:00',2.58),('12374','2013-05-12','18:35:00',2.69),('12374','2013-05-12','18:40:00',2.66),('12374','2013-05-12','18:45:00',2.5),('12374','2013-05-12','18:50:00',2.33),('12374','2013-05-12','18:55:00',1.89),('12374','2013-05-12','19:00:00',1.34),('12374','2013-05-12','19:05:00',1.26),('12374','2013-05-12','19:10:00',1.16),('12374','2013-05-12','19:15:00',1.15),('12374','2013-05-12','19:20:00',1.07),('12374','2013-05-12','19:25:00',1.02),('12374','2013-05-11','07:30:00',1.39),('12374','2013-05-11','07:35:00',1.85),('12374','2013-05-11','07:40:00',2.61),('12374','2013-05-11','07:45:00',2.91),('12374','2013-05-11','07:50:00',3.29),('12374','2013-05-11','07:55:00',3.83),('12374','2013-05-11','08:00:00',3.27),('12374','2013-05-11','08:05:00',3.79),('12374','2013-05-11','08:10:00',3.45),('12374','2013-05-11','08:15:00',2.22),('12374','2013-05-11','08:20:00',1.27),('12374','2013-05-11','08:25:00',2.25),('12374','2013-05-11','08:30:00',4.73),('12374','2013-05-11','08:35:00',4.14),('12374','2013-05-11','08:40:00',5.19),('12374','2013-05-11','08:45:00',3.77),('12374','2013-05-11','08:50:00',3.08),('12374','2013-05-11','08:55:00',4.72),('12374','2013-05-11','09:00:00',2.67),('12374','2013-05-11','09:05:00',3.1),('12374','2013-05-11','09:10:00',4.44),('12374','2013-05-11','09:15:00',6.02),('12374','2013-05-11','09:20:00',6.04),('12374','2013-05-11','09:25:00',5.95),('12374','2013-05-11','09:30:00',2.27),('12374','2013-05-11','09:35:00',1.17),('12374','2013-05-11','09:40:00',2.68),('12374','2013-05-11','09:45:00',6.14),('12374','2013-05-11','09:50:00',4.49),('12374','2013-05-11','09:55:00',4.74),('12374','2013-05-11','10:00:00',4.17),('12374','2013-05-11','10:05:00',6.24),('12374','2013-05-11','10:10:00',6.75),('12374','2013-05-11','10:15:00',7.8),('12374','2013-05-11','10:20:00',8.32),('12374','2013-05-11','10:25:00',7.97),('12374','2013-05-11','10:30:00',5.89),('12374','2013-05-11','10:35:00',5.46),('12374','2013-05-11','10:40:00',5.84),('12374','2013-05-11','10:45:00',5.6),('12374','2013-05-11','10:50:00',6.87),('12374','2013-05-11','10:55:00',8.06),('12374','2013-05-11','11:00:00',5.61),('12374','2013-05-11','11:05:00',8.83),('12374','2013-05-11','11:10:00',8.63),('12374','2013-05-11','11:15:00',8.58),('12374','2013-05-11','11:20:00',6.62),('12374','2013-05-11','11:25:00',8.97),('12374','2013-05-11','11:30:00',7.7),('12374','2013-05-11','11:35:00',4.85),('12374','2013-05-11','11:40:00',5.96),('12374','2013-05-11','11:45:00',5.89),('12374','2013-05-11','11:50:00',6.82),('12374','2013-05-11','11:55:00',7.52),('12374','2013-05-11','12:00:00',7.34),('12374','2013-05-11','12:05:00',7.06),('12374','2013-05-11','12:10:00',5.87),('12374','2013-05-11','12:15:00',6.14),('12374','2013-05-11','12:20:00',8.48),('12374','2013-05-11','12:25:00',8.32),('12374','2013-05-11','12:30:00',8.8),('12374','2013-05-11','12:35:00',8.02),('12374','2013-05-11','12:40:00',4.65),('12374','2013-05-11','12:45:00',4.12),('12374','2013-05-11','12:50:00',3.7),('12374','2013-05-11','12:55:00',4.35),('12374','2013-05-11','13:00:00',4.38),('12374','2013-05-11','13:05:00',5.32),('12374','2013-05-11','13:10:00',4.68),('12374','2013-05-11','13:15:00',5.87),('12374','2013-05-11','13:20:00',8.96),('12374','2013-05-11','13:25:00',6.88),('12374','2013-05-11','13:30:00',6.07),('12374','2013-05-11','13:35:00',5.88),('12374','2013-05-11','13:40:00',8.9),('12374','2013-05-11','13:45:00',9.51),('12374','2013-05-11','13:50:00',9.31),('12374','2013-05-11','13:55:00',9.16),('12374','2013-05-11','14:00:00',9.12),('12374','2013-05-11','14:05:00',9.18),('12374','2013-05-11','14:10:00',9.06),('12374','2013-05-11','14:15:00',9.02),('12374','2013-05-11','14:20:00',9),('12374','2013-05-11','14:25:00',8.92),('12374','2013-05-11','14:30:00',8.86),('12374','2013-05-11','14:35:00',8.79),('12374','2013-05-11','14:40:00',8.76),('12374','2013-05-11','14:45:00',8.18),('12374','2013-05-11','14:50:00',7.27),('12374','2013-05-11','14:55:00',8.79),('12374','2013-05-11','15:00:00',7.47),('12374','2013-05-11','15:05:00',7.93),('12374','2013-05-11','15:10:00',8.13),('12374','2013-05-11','15:15:00',7.62),('12374','2013-05-11','15:20:00',7.39),('12374','2013-05-11','15:25:00',5.72),('12374','2013-05-11','15:30:00',6.88),('12374','2013-05-11','15:35:00',7.39),('12374','2013-05-11','15:40:00',5.19),('12374','2013-05-11','15:45:00',6.06),('12374','2013-05-11','15:50:00',6.1),('12374','2013-05-11','15:55:00',6.61),('12374','2013-05-11','16:00:00',4.27),('12374','2013-05-11','16:05:00',6.18),('12374','2013-05-11','16:10:00',4.89),('12374','2013-05-11','16:15:00',5.88),('12374','2013-05-11','16:20:00',5.51),('12374','2013-05-11','16:25:00',5.07),('12374','2013-05-11','16:30:00',6.3),('12374','2013-05-11','16:35:00',5.56),('12374','2013-05-11','16:40:00',5.54),('12374','2013-05-11','16:45:00',5.74),('12374','2013-05-11','16:50:00',5.51),('12374','2013-05-11','16:55:00',4.95),('12374','2013-05-11','17:00:00',4.31),('12374','2013-05-11','17:05:00',4.74),('12374','2013-05-11','17:10:00',4.95),('12374','2013-05-11','17:15:00',4.7),('12374','2013-05-11','17:20:00',4.8),('12374','2013-05-11','17:25:00',4.49),('12374','2013-05-11','17:30:00',4.01),('12374','2013-05-11','17:35:00',2.78),('12374','2013-05-11','17:40:00',4.01),('12374','2013-05-11','17:45:00',3.41),('12374','2013-05-11','17:50:00',3.58),('12374','2013-05-11','17:55:00',3.15),('12374','2013-05-11','18:00:00',2.72),('12374','2013-05-11','18:05:00',2.99),('12374','2013-05-11','18:10:00',2.66),('12374','2013-05-11','18:15:00',2.49),('12374','2013-05-11','18:20:00',2.31),('12374','2013-05-11','18:25:00',2.16),('12374','2013-05-11','18:30:00',1.96),('12374','2013-05-11','18:35:00',1.95),('12374','2013-05-11','18:40:00',1.84),('12374','2013-05-11','18:45:00',1.68),('12374','2013-05-11','18:50:00',1.56),('12374','2013-05-11','18:55:00',1.62),('12374','2013-05-11','19:00:00',1.58),('12374','2013-05-11','19:05:00',1.57),('12374','2013-05-11','19:10:00',1.33),('12374','2013-05-11','19:15:00',1.12),('12374','2013-05-10','06:45:00',1.01),('12374','2013-05-10','06:50:00',1.13),('12374','2013-05-10','06:55:00',1.35),('12374','2013-05-10','07:00:00',1.18),('12374','2013-05-10','07:05:00',1.22),('12374','2013-05-10','07:10:00',1.58),('12374','2013-05-10','07:15:00',2.15),('12374','2013-05-10','07:20:00',2.38),('12374','2013-05-10','07:25:00',2.5),('12374','2013-05-10','07:30:00',2.24),('12374','2013-05-10','07:35:00',2.25),('12374','2013-05-10','07:40:00',1.77),('12374','2013-05-10','07:45:00',1.52),('12374','2013-05-10','07:50:00',1.84),('12374','2013-05-10','07:55:00',1.89),('12374','2013-05-10','08:00:00',1.52),('12374','2013-05-10','08:05:00',2.53),('12374','2013-05-10','08:10:00',3.64),('12374','2013-05-10','08:15:00',3.8),('12374','2013-05-10','08:20:00',3.41),('12374','2013-05-10','08:25:00',3.05),('12374','2013-05-10','08:30:00',4.27),('12374','2013-05-10','08:35:00',3.97),('12374','2013-05-10','08:40:00',4.32),('12374','2013-05-10','08:45:00',5.23),('12374','2013-05-10','08:50:00',4.64),('12374','2013-05-10','08:55:00',4.56),('12374','2013-05-10','09:00:00',3.94),('12374','2013-05-10','09:05:00',2.98),('12374','2013-05-10','09:10:00',3.11),('12374','2013-05-10','09:15:00',4.89),('12374','2013-05-10','09:20:00',4.75),('12374','2013-05-10','09:25:00',6.62),('12374','2013-05-10','09:30:00',5.64),('12374','2013-05-10','09:35:00',6.75),('12374','2013-05-10','09:40:00',4.05),('12374','2013-05-10','09:45:00',6.32),('12374','2013-05-10','09:50:00',3.95),('12374','2013-05-10','09:55:00',6.35),('12374','2013-05-10','10:00:00',5.16),('12374','2013-05-10','10:05:00',5.83),('12374','2013-05-10','10:10:00',7.49),('12374','2013-05-10','10:15:00',7.05),('12374','2013-05-10','10:20:00',6.96),('12374','2013-05-10','10:25:00',6.53),('12374','2013-05-10','10:30:00',7.12),('12374','2013-05-10','10:35:00',7),('12374','2013-05-10','10:40:00',6.26),('12374','2013-05-10','10:45:00',7.41),('12374','2013-05-10','10:50:00',7.5),('12374','2013-05-10','10:55:00',5.89),('12374','2013-05-10','11:00:00',7.53),('12374','2013-05-10','11:05:00',6.03),('12374','2013-05-10','11:10:00',4.92),('12374','2013-05-10','11:15:00',4.41),('12374','2013-05-10','11:20:00',7.29),('12374','2013-05-10','11:25:00',7.79),('12374','2013-05-10','11:30:00',9.19),('12374','2013-05-10','11:35:00',6.9),('12374','2013-05-10','11:40:00',8.35),('12374','2013-05-10','11:45:00',8.37),('12374','2013-05-10','11:50:00',8.85),('12374','2013-05-10','11:55:00',7.09),('12374','2013-05-10','12:00:00',7.57),('12374','2013-05-10','12:05:00',7.94),('12374','2013-05-10','12:10:00',9.49),('12374','2013-05-10','12:15:00',9.22),('12374','2013-05-10','12:20:00',9.29),('12374','2013-05-10','12:25:00',7.9),('12374','2013-05-10','12:30:00',6.94),('12374','2013-05-10','12:35:00',4.91),('12374','2013-05-10','12:40:00',4.99),('12374','2013-05-10','12:45:00',6.12),('12374','2013-05-10','12:50:00',9.18),('12374','2013-05-10','12:55:00',9.75),('12374','2013-05-10','13:00:00',8.57),('12374','2013-05-10','13:05:00',9.44),('12374','2013-05-10','13:10:00',9.2),('12374','2013-05-10','13:15:00',7.97),('12374','2013-05-10','13:20:00',7.25),('12374','2013-05-10','13:25:00',5.84),('12374','2013-05-10','13:30:00',5.99),('12374','2013-05-10','13:35:00',5.87),('12374','2013-05-10','13:40:00',5.29),('12374','2013-05-10','13:45:00',4.75),('12374','2013-05-10','13:50:00',5.26),('12374','2013-05-10','13:55:00',5.4),('12374','2013-05-10','14:00:00',5.61),('12374','2013-05-10','14:05:00',6.1),('12374','2013-05-10','14:10:00',5.52),('12374','2013-05-10','14:15:00',5.1),('12374','2013-05-10','14:20:00',4.84),('12374','2013-05-10','14:25:00',5.09),('12374','2013-05-10','14:30:00',5.06),('12374','2013-05-10','14:35:00',5.13),('12374','2013-05-10','14:40:00',5.28),('12374','2013-05-10','14:45:00',4.53),('12374','2013-05-10','14:50:00',4.74),('12374','2013-05-10','14:55:00',5.71),('12374','2013-05-10','15:00:00',6.42),('12374','2013-05-10','15:05:00',5.68),('12374','2013-05-10','15:10:00',4.65),('12374','2013-05-10','15:15:00',4.37),('12374','2013-05-10','15:20:00',3.98),('12374','2013-05-10','15:25:00',3.95),('12374','2013-05-10','15:30:00',4.18),('12374','2013-05-10','15:35:00',4.19),('12374','2013-05-10','15:40:00',4.21),('12374','2013-05-10','15:45:00',3.56),('12374','2013-05-10','15:50:00',3.12),('12374','2013-05-10','15:55:00',3.33),('12374','2013-05-10','16:00:00',4.51),('12374','2013-05-10','16:05:00',4.16),('12374','2013-05-10','16:10:00',4.42),('12374','2013-05-10','16:15:00',4.2),('12374','2013-05-10','16:20:00',3.99),('12374','2013-05-10','16:25:00',3.98),('12374','2013-05-10','16:30:00',3.92),('12374','2013-05-10','16:35:00',3.94),('12374','2013-05-10','16:40:00',3.83),('12374','2013-05-10','16:45:00',3.42),('12374','2013-05-10','16:50:00',3.03),('12374','2013-05-10','16:55:00',3.04),('12374','2013-05-10','17:00:00',3.1),('12374','2013-05-10','17:05:00',2.79),('12374','2013-05-10','17:10:00',2.45),('12374','2013-05-10','17:15:00',2.36),('12374','2013-05-10','17:20:00',2.46),('12374','2013-05-10','17:25:00',2.32),('12374','2013-05-10','17:30:00',1.81),('12374','2013-05-10','17:35:00',1.42),('12374','2013-05-10','17:40:00',1.32),('12374','2013-05-10','17:45:00',1.18),('12374','2013-05-10','17:50:00',1.13),('12374','2013-05-10','17:55:00',1.2),('12374','2013-05-10','18:00:00',1.39),('12374','2013-05-10','18:05:00',1.61),('12374','2013-05-10','18:10:00',1.36),('12374','2013-05-10','18:15:00',1.16),('12374','2013-05-10','18:20:00',1.08),('12374','2013-05-09','06:55:00',1.07),('12374','2013-05-09','07:00:00',1.27),('12374','2013-05-09','07:05:00',1.24),('12374','2013-05-09','07:10:00',1.64),('12374','2013-05-09','07:15:00',1.83),('12374','2013-05-09','07:20:00',1.94),('12374','2013-05-09','07:25:00',1.89),('12374','2013-05-09','07:30:00',2.32),('12374','2013-05-09','07:35:00',2.51),('12374','2013-05-09','07:40:00',2.69),('12374','2013-05-09','07:45:00',2.85),('12374','2013-05-09','07:50:00',3.02),('12374','2013-05-09','07:55:00',3.2),('12374','2013-05-09','08:00:00',3.35),('12374','2013-05-09','08:05:00',3.51),('12374','2013-05-09','08:10:00',3.67),('12374','2013-05-09','08:15:00',3.85),('12374','2013-05-09','08:20:00',4.04),('12374','2013-05-09','08:25:00',4.21),('12374','2013-05-09','08:30:00',4.36),('12374','2013-05-09','08:35:00',4.51),('12374','2013-05-09','08:40:00',4.64),('12374','2013-05-09','08:45:00',4.8),('12374','2013-05-09','08:50:00',4.92),('12374','2013-05-09','08:55:00',5.09),('12374','2013-05-09','09:00:00',5.27),('12374','2013-05-09','09:05:00',5.42),('12374','2013-05-09','09:10:00',5.56),('12374','2013-05-09','09:15:00',5.7),('12374','2013-05-09','09:20:00',5.84),('12374','2013-05-09','09:25:00',5.95),('12374','2013-05-09','09:30:00',6.09),('12374','2013-05-09','09:35:00',6.24),('12374','2013-05-09','09:40:00',6.36),('12374','2013-05-09','09:45:00',6.44),('12374','2013-05-09','09:50:00',6.57),('12374','2013-05-09','09:55:00',6.66),('12374','2013-05-09','10:00:00',6.83),('12374','2013-05-09','10:05:00',6.93),('12374','2013-05-09','10:10:00',7.03),('12374','2013-05-09','10:15:00',7.1),('12374','2013-05-09','10:20:00',7.24),('12374','2013-05-09','10:25:00',7.34),('12374','2013-05-09','10:30:00',7.33),('12374','2013-05-09','10:35:00',7.52),('12374','2013-05-09','10:40:00',7.72),('12374','2013-05-09','10:45:00',7.87),('12374','2013-05-09','10:50:00',7.93),('12374','2013-05-09','10:55:00',7.95),('12374','2013-05-09','11:00:00',8.05),('12374','2013-05-09','11:05:00',8.16),('12374','2013-05-09','11:10:00',8.25),('12374','2013-05-09','11:15:00',8.28),('12374','2013-05-09','11:20:00',8.32),('12374','2013-05-09','11:25:00',8.38),('12374','2013-05-09','11:30:00',8.55),('12374','2013-05-09','11:35:00',8.65),('12374','2013-05-09','11:40:00',8.74),('12374','2013-05-09','11:45:00',8.81),('12374','2013-05-09','11:50:00',8.88),('12374','2013-05-09','11:55:00',8.96),('12374','2013-05-09','12:00:00',8.97),('12374','2013-05-09','12:05:00',9.03),('12374','2013-05-09','12:10:00',9.04),('12374','2013-05-09','12:15:00',9.06),('12374','2013-05-09','12:20:00',9.11),('12374','2013-05-09','12:25:00',9.12),('12374','2013-05-09','12:30:00',9.12),('12374','2013-05-09','12:35:00',9.19),('12374','2013-05-09','12:40:00',9.15),('12374','2013-05-09','12:45:00',9.21),('12374','2013-05-09','12:50:00',9.24),('12374','2013-05-09','12:55:00',9.21),('12374','2013-05-09','13:00:00',9.16),('12374','2013-05-09','13:05:00',9.18),('12374','2013-05-09','13:10:00',9.17),('12374','2013-05-09','13:15:00',9.21),('12374','2013-05-09','13:20:00',9.23),('12374','2013-05-09','13:25:00',9.23),('12374','2013-05-09','13:30:00',9.25),('12374','2013-05-09','13:35:00',9.21),('12374','2013-05-09','13:40:00',9.19),('12374','2013-05-09','13:45:00',9.19),('12374','2013-05-09','13:50:00',9.15),('12374','2013-05-09','13:55:00',9.09),('12374','2013-05-09','14:00:00',9.06),('12374','2013-05-09','14:05:00',8.96),('12374','2013-05-09','14:10:00',8.93),('12374','2013-05-09','14:15:00',8.74),('12374','2013-05-09','14:20:00',8.86),('12374','2013-05-09','14:25:00',8.8),('12374','2013-05-09','14:30:00',8.66),('12374','2013-05-09','14:35:00',8.58),('12374','2013-05-09','14:40:00',8.48),('12374','2013-05-09','14:45:00',8.36),('12374','2013-05-09','14:50:00',8.39),('12374','2013-05-09','14:55:00',8.14),('12374','2013-05-09','15:00:00',8.22),('12374','2013-05-09','15:05:00',8.15),('12374','2013-05-09','15:10:00',8.05),('12374','2013-05-09','15:15:00',7.94),('12374','2013-05-09','15:20:00',7.74),('12374','2013-05-09','15:25:00',7.66),('12374','2013-05-09','15:30:00',7.6),('12374','2013-05-09','15:35:00',7.5),('12374','2013-05-09','15:40:00',7.4),('12374','2013-05-09','15:45:00',7.27),('12374','2013-05-09','15:50:00',7.03),('12374','2013-05-09','15:55:00',6.92),('12374','2013-05-09','16:00:00',6.82),('12374','2013-05-09','16:05:00',6.74),('12374','2013-05-09','16:10:00',6.56),('12374','2013-05-09','16:15:00',6.43),('12374','2013-05-09','16:20:00',6.35),('12374','2013-05-09','16:25:00',6.23),('12374','2013-05-09','16:30:00',6.08),('12374','2013-05-09','16:35:00',5.94),('12374','2013-05-09','16:40:00',5.79),('12374','2013-05-09','16:45:00',5.65),('12374','2013-05-09','16:50:00',5.44),('12374','2013-05-09','16:55:00',5.28),('12374','2013-05-09','17:00:00',5.12),('12374','2013-05-09','17:05:00',4.97),('12374','2013-05-09','17:10:00',4.83),('12374','2013-05-09','17:15:00',4.65),('12374','2013-05-09','17:20:00',4.52),('12374','2013-05-09','17:25:00',4.3),('12374','2013-05-09','17:30:00',4.12),('12374','2013-05-09','17:35:00',3.93),('12374','2013-05-09','17:40:00',3.68),('12374','2013-05-09','17:45:00',3.52),('12374','2013-05-09','17:50:00',3.33),('12374','2013-05-09','17:55:00',3.1),('12374','2013-05-09','18:00:00',2.95),('12374','2013-05-09','18:05:00',2.72),('12374','2013-05-09','18:10:00',2.61),('12374','2013-05-09','18:15:00',2.46),('12374','2013-05-09','18:20:00',2.17),('12374','2013-05-09','18:25:00',1.94),('12374','2013-05-09','18:30:00',1.83),('12374','2013-05-09','18:35:00',1.76),('12374','2013-05-09','18:40:00',1.56),('12374','2013-05-09','18:45:00',1.56),('12374','2013-05-09','18:50:00',1.11),('12374','2013-05-09','18:55:00',1.34),('12374','2013-05-09','19:00:00',1.2),('12374','2013-05-09','19:05:00',1.11),('12374','2013-05-08','07:05:00',1.05),('12374','2013-05-08','07:15:00',1.5),('12374','2013-05-08','07:20:00',1.9),('12374','2013-05-08','07:25:00',2.02),('12374','2013-05-08','07:30:00',2.23),('12374','2013-05-08','07:35:00',2.09),('12374','2013-05-08','07:40:00',2.54),('12374','2013-05-08','07:45:00',2.7),('12374','2013-05-08','07:50:00',2.91),('12374','2013-05-08','07:55:00',3.12),('12374','2013-05-08','08:00:00',3.3),('12374','2013-05-08','08:05:00',3.51),('12374','2013-05-08','08:10:00',3.64),('12374','2013-05-08','08:15:00',3.32),('12374','2013-05-08','08:20:00',4.04),('12374','2013-05-08','08:25:00',4.15),('12374','2013-05-08','08:30:00',4.41),('12374','2013-05-08','08:35:00',4.42),('12374','2013-05-08','08:40:00',4.68),('12374','2013-05-08','08:45:00',4.81),('12374','2013-05-08','08:50:00',5.03),('12374','2013-05-08','08:55:00',4.9),('12374','2013-05-08','09:00:00',5.04),('12374','2013-05-08','09:05:00',5.96),('12374','2013-05-08','09:10:00',5.73),('12374','2013-05-08','09:15:00',3.89),('12374','2013-05-08','09:20:00',1.86),('12374','2013-05-08','09:25:00',4.79),('12374','2013-05-08','09:30:00',5.16),('12374','2013-05-08','09:35:00',7.4),('12374','2013-05-08','09:40:00',7.41),('12374','2013-05-08','09:45:00',7.41),('12374','2013-05-08','09:50:00',7.4),('12374','2013-05-08','09:55:00',7.44),('12374','2013-05-08','10:00:00',7.26),('12374','2013-05-08','10:05:00',2.5),('12374','2013-05-08','10:10:00',2.48),('12374','2013-05-08','10:15:00',2.56),('12374','2013-05-08','10:20:00',5.31),('12374','2013-05-08','10:25:00',2.84),('12374','2013-05-08','10:30:00',5.3),('12374','2013-05-08','10:35:00',7),('12374','2013-05-08','10:40:00',7.68),('12374','2013-05-08','10:45:00',8.19),('12374','2013-05-08','10:50:00',8.16),('12374','2013-05-08','10:55:00',8.12),('12374','2013-05-08','11:00:00',8.24),('12374','2013-05-08','11:05:00',8.25),('12374','2013-05-08','11:10:00',8.26),('12374','2013-05-08','11:15:00',8.38),('12374','2013-05-08','11:20:00',8.45),('12374','2013-05-08','11:25:00',8.55),('12374','2013-05-08','11:30:00',8.63),('12374','2013-05-08','11:35:00',8.71),('12374','2013-05-08','11:40:00',8.73),('12374','2013-05-08','11:45:00',8.87),('12374','2013-05-08','11:50:00',8.94),('12374','2013-05-08','11:55:00',8.99),('12374','2013-05-08','12:00:00',9.01),('12374','2013-05-08','12:05:00',9.11),('12374','2013-05-08','12:10:00',9.19),('12374','2013-05-08','12:15:00',9.17),('12374','2013-05-08','12:20:00',9.18),('12374','2013-05-08','12:25:00',9.24),('12374','2013-05-08','12:30:00',9.23),('12374','2013-05-08','12:35:00',9.28),('12374','2013-05-08','12:40:00',9.27),('12374','2013-05-08','12:45:00',9.22),('12374','2013-05-08','12:50:00',9.23),('12374','2013-05-08','12:55:00',9.24),('12374','2013-05-08','13:00:00',9.17),('12374','2013-05-08','13:05:00',9.27),('12374','2013-05-08','13:10:00',9.31),('12374','2013-05-08','13:15:00',9.26),('12374','2013-05-08','13:20:00',9.24),('12374','2013-05-08','13:25:00',9.3),('12374','2013-05-08','13:30:00',9.31),('12374','2013-05-08','13:35:00',9.26),('12374','2013-05-08','13:40:00',9.17),('12374','2013-05-08','13:45:00',9.1),('12374','2013-05-08','13:50:00',9.05),('12374','2013-05-08','13:55:00',9.12),('12374','2013-05-08','14:00:00',9.12),('12374','2013-05-08','14:05:00',9.11),('12374','2013-05-08','14:10:00',9.01),('12374','2013-05-08','14:15:00',8.97),('12374','2013-05-08','14:20:00',8.94),('12374','2013-05-08','14:25:00',8.89),('12374','2013-05-08','14:30:00',8.8),('12374','2013-05-08','14:35:00',8.69),('12374','2013-05-08','14:40:00',8.68),('12374','2013-05-08','14:45:00',8.67),('12374','2013-05-08','14:50:00',8.56),('12374','2013-05-08','14:55:00',8.46),('12374','2013-05-08','15:00:00',8.15),('12374','2013-05-08','15:05:00',8.17),('12374','2013-05-08','15:10:00',8.04),('12374','2013-05-08','15:15:00',7.94),('12374','2013-05-08','15:20:00',7.84),('12374','2013-05-08','15:25:00',7.74),('12374','2013-05-08','15:30:00',7.68),('12374','2013-05-08','15:35:00',7.66),('12374','2013-05-08','15:40:00',6.71),('12374','2013-05-08','15:45:00',2.75),('12374','2013-05-08','15:50:00',3.5),('12374','2013-05-08','15:55:00',5.37),('12374','2013-05-08','16:00:00',4.87),('12374','2013-05-08','16:05:00',3.91),('12374','2013-05-08','16:10:00',3.81),('12374','2013-05-08','16:15:00',5.92),('12374','2013-05-08','16:20:00',3.91),('12374','2013-05-08','16:25:00',3.58),('12374','2013-05-08','16:30:00',4.79),('12374','2013-05-08','16:35:00',3.51),('12374','2013-05-08','16:40:00',4.01),('12374','2013-05-08','16:45:00',2.76),('12374','2013-05-08','16:50:00',4.1),('12374','2013-05-08','16:55:00',5.83),('12374','2013-05-08','17:00:00',5.9),('12374','2013-05-08','17:05:00',5.78),('12374','2013-05-08','17:10:00',5.59),('12374','2013-05-08','17:15:00',5.36),('12374','2013-05-08','17:20:00',2.87),('12374','2013-05-08','17:25:00',3.13),('12374','2013-05-08','17:30:00',2.34),('12374','2013-05-08','17:35:00',1.42),('12374','2013-05-08','17:40:00',1.44),('12374','2013-05-08','17:45:00',1.49),('12374','2013-05-08','17:50:00',1.34),('12374','2013-05-08','17:55:00',2.35),('12374','2013-05-08','18:00:00',1.17),('12374','2013-05-08','18:05:00',1.35),('12374','2013-05-08','18:10:00',1.86),('12374','2013-05-08','18:15:00',2.31),('12374','2013-05-08','18:20:00',2.27),('12374','2013-05-08','18:25:00',2.23),('12374','2013-05-08','18:30:00',1.78),('12374','2013-05-08','18:35:00',1.71),('12374','2013-05-08','18:40:00',1.85),('12374','2013-05-08','18:45:00',1.17),('12374','2013-05-07','07:30:00',1.42),('12374','2013-05-07','07:35:00',2.64),('12374','2013-05-07','07:40:00',2.8),('12374','2013-05-07','07:45:00',2.95),('12374','2013-05-07','07:50:00',3.1),('12374','2013-05-07','07:55:00',3.34),('12374','2013-05-07','08:00:00',3.45),('12374','2013-05-07','08:05:00',3.6),('12374','2013-05-07','08:10:00',3.78),('12374','2013-05-07','08:15:00',3.95),('12374','2013-05-07','08:20:00',4.11),('12374','2013-05-07','08:25:00',4.32),('12374','2013-05-07','08:30:00',4.47),('12374','2013-05-07','08:35:00',4.51),('12374','2013-05-07','08:40:00',4.13),('12374','2013-05-07','08:45:00',4.04),('12374','2013-05-07','08:50:00',4.93),('12374','2013-05-07','08:55:00',5.18),('12374','2013-05-07','09:00:00',5.32),('12374','2013-05-07','09:05:00',5.51),('12374','2013-05-07','09:10:00',5.26),('12374','2013-05-07','09:15:00',5.92),('12374','2013-05-07','09:20:00',5.48),('12374','2013-05-07','09:25:00',6.25),('12374','2013-05-07','09:30:00',5.82),('12374','2013-05-07','09:35:00',4.06),('12374','2013-05-07','09:40:00',5.02),('12374','2013-05-07','09:45:00',3.5),('12374','2013-05-07','09:50:00',7.57),('12374','2013-05-07','09:55:00',7.41),('12374','2013-05-07','10:00:00',7.31),('12374','2013-05-07','10:05:00',7.59),('12374','2013-05-07','10:10:00',7.73),('12374','2013-05-07','10:15:00',7.82),('12374','2013-05-07','10:20:00',8.16),('12374','2013-05-07','10:25:00',7.62),('12374','2013-05-07','10:30:00',4.31),('12374','2013-05-07','10:35:00',7.96),('12374','2013-05-07','10:40:00',2.89),('12374','2013-05-07','10:45:00',1.79),('12374','2013-05-07','10:50:00',2.16),('12374','2013-05-07','10:55:00',4.3),('12374','2013-05-07','11:00:00',6.09),('12374','2013-05-07','11:05:00',4.33),('12374','2013-05-07','11:10:00',5.48),('12374','2013-05-07','11:15:00',8.78),('12374','2013-05-07','11:20:00',8.75),('12374','2013-05-07','11:25:00',8.79),('12374','2013-05-07','11:30:00',8.81),('12374','2013-05-07','11:35:00',8.9),('12374','2013-05-07','11:40:00',8.96),('12374','2013-05-07','11:45:00',9.07),('12374','2013-05-07','11:50:00',9.31),('12374','2013-05-07','11:55:00',9.26),('12374','2013-05-07','12:00:00',8.64),('12374','2013-05-07','12:05:00',9.38),('12374','2013-05-07','12:10:00',8.69),('12374','2013-05-07','12:15:00',9),('12374','2013-05-07','12:20:00',7.63),('12374','2013-05-07','12:25:00',8.36),('12374','2013-05-07','12:30:00',8.11),('12374','2013-05-07','12:35:00',5.81),('12374','2013-05-07','12:40:00',8.69),('12374','2013-05-07','12:45:00',9.05),('12374','2013-05-07','12:50:00',8.94),('12374','2013-05-07','12:55:00',9.22),('12374','2013-05-07','13:00:00',8.91),('12374','2013-05-07','13:05:00',9.37),('12374','2013-05-07','13:10:00',8.66),('12374','2013-05-07','13:15:00',9.37),('12374','2013-05-07','13:20:00',9.45),('12374','2013-05-07','13:25:00',9.23),('12374','2013-05-07','13:30:00',8.96),('12374','2013-05-07','13:35:00',9.51),('12374','2013-05-07','13:40:00',8.06),('12374','2013-05-07','13:45:00',8.57),('12374','2013-05-07','13:50:00',8.17),('12374','2013-05-07','13:55:00',9.19),('12374','2013-05-07','14:00:00',9.4),('12374','2013-05-07','14:05:00',9.55),('12374','2013-05-07','14:10:00',7.68),('12374','2013-05-07','14:15:00',8.26),('12374','2013-05-07','14:20:00',9.05),('12374','2013-05-07','14:25:00',8.93),('12374','2013-05-07','14:30:00',8.22),('12374','2013-05-07','14:35:00',8.47),('12374','2013-05-07','14:40:00',8.96),('12374','2013-05-07','14:45:00',8.83),('12374','2013-05-07','14:50:00',8.26),('12374','2013-05-07','14:55:00',6.75),('12374','2013-05-07','15:00:00',5.53),('12374','2013-05-07','15:05:00',8.27),('12374','2013-05-07','15:10:00',7.85),('12374','2013-05-07','15:15:00',8.06),('12374','2013-05-07','15:20:00',7.77),('12374','2013-05-07','15:25:00',7.75),('12374','2013-05-07','15:30:00',7.04),('12374','2013-05-07','15:35:00',6.99),('12374','2013-05-07','15:40:00',6.93),('12374','2013-05-07','15:45:00',6.14),('12374','2013-05-07','15:50:00',6.23),('12374','2013-05-07','15:55:00',6.39),('12374','2013-05-07','16:00:00',6.95),('12374','2013-05-07','16:05:00',7.07),('12374','2013-05-07','16:10:00',7.32),('12374','2013-05-07','16:15:00',7.44),('12374','2013-05-07','16:20:00',7.34),('12374','2013-05-07','16:25:00',4.91),('12374','2013-05-07','16:30:00',5.03),('12374','2013-05-07','16:35:00',5.11),('12374','2013-05-07','16:40:00',4.49),('12374','2013-05-07','16:45:00',4.78),('12374','2013-05-07','16:50:00',4.63),('12374','2013-05-07','16:55:00',5.38),('12374','2013-05-07','17:00:00',4.76),('12374','2013-05-07','17:05:00',2.85),('12374','2013-05-07','17:10:00',2.62),('12374','2013-05-07','17:15:00',2.18),('12374','2013-05-07','17:20:00',2.03),('12374','2013-05-07','17:25:00',2),('12374','2013-05-07','17:30:00',2.37),('12374','2013-05-07','17:35:00',3.62),('12374','2013-05-07','17:40:00',5.11),('12374','2013-05-07','17:45:00',4.92),('12374','2013-05-07','17:50:00',4.47),('12374','2013-05-07','17:55:00',3.4),('12374','2013-05-07','18:00:00',2.75),('12374','2013-05-07','18:05:00',1.85),('12374','2013-05-07','18:10:00',1.48),('12374','2013-05-07','18:15:00',1.2),('12374','2013-05-07','18:20:00',1.11),('12374','2013-05-06','10:05:00',2.39),('12374','2013-05-06','10:10:00',2.46),('12374','2013-05-06','10:15:00',2.23),('12374','2013-05-06','10:20:00',2.88),('12374','2013-05-06','10:25:00',3.66),('12374','2013-05-06','10:30:00',3.32),('12374','2013-05-06','10:35:00',2.14),('12374','2013-05-06','10:40:00',2.26),('12374','2013-05-06','10:45:00',2.31),('12374','2013-05-06','10:50:00',2.36),('12374','2013-05-06','10:55:00',3.28),('12374','2013-05-06','11:00:00',5.15),('12374','2013-05-06','11:05:00',4.73),('12374','2013-05-06','11:10:00',5.5),('12374','2013-05-06','11:15:00',6.15),('12374','2013-05-06','11:20:00',8.19),('12374','2013-05-06','11:25:00',7.36),('12374','2013-05-06','11:30:00',6.87),('12374','2013-05-06','11:35:00',7.42),('12374','2013-05-06','11:40:00',8.9),('12374','2013-05-06','11:45:00',9.26),('12374','2013-05-06','11:50:00',9.09),('12374','2013-05-06','11:55:00',9.15),('12374','2013-05-06','12:00:00',8.97),('12374','2013-05-06','12:05:00',9.06),('12374','2013-05-06','12:10:00',9.04),('12374','2013-05-06','12:15:00',8.86),('12374','2013-05-06','12:20:00',8.62),('12374','2013-05-06','12:25:00',9.25),('12374','2013-05-06','12:30:00',9.33),('12374','2013-05-06','12:35:00',9.38),('12374','2013-05-06','12:40:00',9.17),('12374','2013-05-06','12:45:00',9.4),('12374','2013-05-06','12:50:00',8.62),('12374','2013-05-06','12:55:00',8.93),('12374','2013-05-06','13:00:00',9.49),('12374','2013-05-06','13:05:00',8.01),('12374','2013-05-06','13:10:00',9.39),('12374','2013-05-06','13:15:00',9.4),('12374','2013-05-06','13:20:00',9.38),('12374','2013-05-06','13:25:00',9.37),('12374','2013-05-06','13:30:00',7.55),('12374','2013-05-06','13:35:00',9.59),('12374','2013-05-06','13:40:00',9.03),('12374','2013-05-06','13:45:00',7.51),('12374','2013-05-06','13:50:00',7.43),('12374','2013-05-06','13:55:00',6.42),('12374','2013-05-06','14:00:00',5.54),('12374','2013-05-06','14:05:00',7.9),('12374','2013-05-06','14:10:00',5.49),('12374','2013-05-06','14:15:00',7.24),('12374','2013-05-06','14:20:00',9.17),('12374','2013-05-06','14:25:00',8.34),('12374','2013-05-06','14:30:00',7.83),('12374','2013-05-06','14:35:00',7.25),('12374','2013-05-06','14:40:00',8.51),('12374','2013-05-06','14:45:00',8.09),('12374','2013-05-06','14:50:00',8.65),('12374','2013-05-06','14:55:00',8.77),('12374','2013-05-06','15:00:00',8.32),('12374','2013-05-06','15:05:00',7.99),('12374','2013-05-06','15:10:00',8.19),('12374','2013-05-06','15:15:00',7.08),('12374','2013-05-06','15:20:00',5.8),('12374','2013-05-06','15:25:00',5.59),('12374','2013-05-06','15:30:00',7.04),('12374','2013-05-06','15:35:00',7.55),('12374','2013-05-06','15:40:00',7.65),('12374','2013-05-06','15:45:00',7.4),('12374','2013-05-06','15:50:00',7.36),('12374','2013-05-06','15:55:00',7.38),('12374','2013-05-06','16:00:00',5.23),('12374','2013-05-06','16:05:00',5.45),('12374','2013-05-06','16:10:00',2.92),('12374','2013-05-06','16:15:00',2.68),('12374','2013-05-06','16:20:00',3.42),('12374','2013-05-06','16:25:00',3.4),('12374','2013-05-06','16:30:00',2.23),('12374','2013-05-06','16:35:00',3.28),('12374','2013-05-06','16:40:00',4),('12374','2013-05-06','16:45:00',4.55),('12374','2013-05-06','16:50:00',3.98),('12374','2013-05-06','16:55:00',2.97),('12374','2013-05-06','17:00:00',3.86),('12374','2013-05-06','17:05:00',3.32),('12374','2013-05-06','17:10:00',1.63),('12374','2013-05-06','17:15:00',1.01),('12374','2013-05-06','17:20:00',1.5),('12374','2013-05-06','17:25:00',1.95),('12374','2013-05-06','17:30:00',1.56),('12374','2013-05-06','17:35:00',1.75),('12374','2013-05-06','17:40:00',2.33),('12374','2013-05-06','17:45:00',1.73),('12374','2013-05-06','17:50:00',1.44),('12374','2013-05-06','17:55:00',2.37),('12374','2013-05-06','18:00:00',1.49),('12374','2013-05-06','18:05:00',2.66),('12374','2013-05-06','18:10:00',1.3),('12374','2013-05-06','18:15:00',1.02),('12374','2013-05-06','18:25:00',1.07),('12374','2013-05-06','18:30:00',1.11),('12374','2013-05-06','18:35:00',1.17),('12374','2013-05-06','18:40:00',1.19),('12374','2013-05-06','19:00:00',1.1),('12374','2013-05-06','19:05:00',1.5),('12374','2013-05-06','19:10:00',1.67),('12374','2013-05-06','19:15:00',1.39),('12374','2013-05-05','07:05:00',1.35),('12374','2013-05-05','07:10:00',1.51),('12374','2013-05-05','07:15:00',1.72),('12374','2013-05-05','07:20:00',1.81),('12374','2013-05-05','07:25:00',2.34),('12374','2013-05-05','07:30:00',2.39),('12374','2013-05-05','07:35:00',2.54),('12374','2013-05-05','07:40:00',2.09),('12374','2013-05-05','07:45:00',2.34),('12374','2013-05-05','07:50:00',1.9),('12374','2013-05-05','07:55:00',1.44),('12374','2013-05-05','08:00:00',1.48),('12374','2013-05-05','08:05:00',1.51),('12374','2013-05-05','08:10:00',1.56),('12374','2013-05-05','08:15:00',1.62),('12374','2013-05-05','08:20:00',1.56),('12374','2013-05-05','08:25:00',1.62),('12374','2013-05-05','08:30:00',2.28),('12374','2013-05-05','08:35:00',3.32),('12374','2013-05-05','08:40:00',3.5),('12374','2013-05-05','08:45:00',2.87),('12374','2013-05-05','08:50:00',3.29),('12374','2013-05-05','08:55:00',2.05),('12374','2013-05-05','09:00:00',1.96),('12374','2013-05-05','09:05:00',4.32),('12374','2013-05-05','09:10:00',4.37),('12374','2013-05-05','09:15:00',4.25),('12374','2013-05-05','09:20:00',5.97),('12374','2013-05-05','09:25:00',6.29),('12374','2013-05-05','09:30:00',6.79),('12374','2013-05-05','09:35:00',6.47),('12374','2013-05-05','09:40:00',6.15),('12374','2013-05-05','09:45:00',3.64),('12374','2013-05-05','09:50:00',5.45),('12374','2013-05-05','09:55:00',1.85),('12374','2013-05-05','10:00:00',1.27),('12374','2013-05-05','10:05:00',1.48),('12374','2013-05-05','10:10:00',2.75),('12374','2013-05-05','10:15:00',6.71),('12374','2013-05-05','10:20:00',6.52),('12374','2013-05-05','10:25:00',5.1),('12374','2013-05-05','10:30:00',3.58),('12374','2013-05-05','10:35:00',3.41),('12374','2013-05-05','10:40:00',2.69),('12374','2013-05-05','10:45:00',2.76),('12374','2013-05-05','10:50:00',5.16),('12374','2013-05-05','10:55:00',4.78),('12374','2013-05-05','11:00:00',7.34),('12374','2013-05-05','11:05:00',7.79),('12374','2013-05-05','11:10:00',6.79),('12374','2013-05-05','11:15:00',5.97),('12374','2013-05-05','11:20:00',6.73),('12374','2013-05-05','11:25:00',5.28),('12374','2013-05-05','11:30:00',7.04),('12374','2013-05-05','11:35:00',4.67),('12374','2013-05-05','11:40:00',6.34),('12374','2013-05-05','11:45:00',5.74),('12374','2013-05-05','11:50:00',7.02),('12374','2013-05-05','11:55:00',7.69),('12374','2013-05-05','12:00:00',7.47),('12374','2013-05-05','12:05:00',9.83),('12374','2013-05-05','12:10:00',9.35),('12374','2013-05-05','12:15:00',8.82),('12374','2013-05-05','12:20:00',9.17),('12374','2013-05-05','12:25:00',9.08),('12374','2013-05-05','12:30:00',9.17),('12374','2013-05-05','12:35:00',9.22),('12374','2013-05-05','12:40:00',9.31),('12374','2013-05-05','12:45:00',9.58),('12374','2013-05-05','12:50:00',9.57),('12374','2013-05-05','12:55:00',9.38),('12374','2013-05-05','13:00:00',9.34),('12374','2013-05-05','13:05:00',9.34),('12374','2013-05-05','13:10:00',9.16),('12374','2013-05-05','13:15:00',9.39),('12374','2013-05-05','13:20:00',9.31),('12374','2013-05-05','13:25:00',9.5),('12374','2013-05-05','13:30:00',7.27),('12374','2013-05-05','13:35:00',5.26),('12374','2013-05-05','13:40:00',4.68),('12374','2013-05-05','13:45:00',5.08),('12374','2013-05-05','13:50:00',5.33),('12374','2013-05-05','13:55:00',6.35),('12374','2013-05-05','14:00:00',7.5),('12374','2013-05-05','14:05:00',9.04),('12374','2013-05-05','14:10:00',8.87),('12374','2013-05-05','14:15:00',8.69),('12374','2013-05-05','14:20:00',8.65),('12374','2013-05-05','14:25:00',8.54),('12374','2013-05-05','14:30:00',8.4),('12374','2013-05-05','14:35:00',8.29),('12374','2013-05-05','14:40:00',8.15),('12374','2013-05-05','14:45:00',8.12),('12374','2013-05-05','14:50:00',8.09),('12374','2013-05-05','14:55:00',8.03),('12374','2013-05-05','15:00:00',7.95),('12374','2013-05-05','15:05:00',6.14),('12374','2013-05-05','15:10:00',8.04),('12374','2013-05-05','15:15:00',7.79),('12374','2013-05-05','15:20:00',7.65),('12374','2013-05-05','15:25:00',7.46),('12374','2013-05-05','15:30:00',7.38),('12374','2013-05-05','15:35:00',7.26),('12374','2013-05-05','15:40:00',7.13),('12374','2013-05-05','15:45:00',7.01),('12374','2013-05-05','15:50:00',6.91),('12374','2013-05-05','15:55:00',6.76),('12374','2013-05-05','16:00:00',6.64),('12374','2013-05-05','16:05:00',6.52),('12374','2013-05-05','16:10:00',6.39),('12374','2013-05-05','16:15:00',6.25),('12374','2013-05-05','16:20:00',6.11),('12374','2013-05-05','16:25:00',5.99),('12374','2013-05-05','16:30:00',5.88),('12374','2013-05-05','16:35:00',5.75),('12374','2013-05-05','16:40:00',5.59),('12374','2013-05-05','16:45:00',5.41),('12374','2013-05-05','16:50:00',5.27),('12374','2013-05-05','16:55:00',5.14),('12374','2013-05-05','17:00:00',5),('12374','2013-05-05','17:05:00',4.84),('12374','2013-05-05','17:10:00',4.67),('12374','2013-05-05','17:15:00',4.49),('12374','2013-05-05','17:20:00',4.31),('12374','2013-05-05','17:25:00',4.09),('12374','2013-05-05','17:30:00',3.93),('12374','2013-05-05','17:35:00',3.74),('12374','2013-05-05','17:40:00',3.49),('12374','2013-05-05','17:45:00',3.3),('12374','2013-05-05','17:50:00',3.13),('12374','2013-05-05','17:55:00',2.86),('12374','2013-05-05','18:00:00',2.79),('12374','2013-05-05','18:05:00',2.6),('12374','2013-05-05','18:10:00',2.45),('12374','2013-05-05','18:15:00',2.28),('12374','2013-05-05','18:20:00',2.09),('12374','2013-05-05','18:25:00',1.84),('12374','2013-05-05','18:30:00',1.74),('12374','2013-05-05','18:35:00',1.62),('12374','2013-05-05','18:40:00',1.53),('12374','2013-05-05','18:45:00',1.42),('12374','2013-05-05','18:50:00',1.33),('12374','2013-05-05','18:55:00',1.23),('12374','2013-05-05','19:00:00',1.12),('12374','2013-05-05','19:05:00',1.01),('12374','2013-05-04','07:00:00',1.1),('12374','2013-05-04','07:05:00',1.2),('12374','2013-05-04','07:10:00',1.46),('12374','2013-05-04','07:15:00',1.61),('12374','2013-05-04','07:20:00',1.7),('12374','2013-05-04','07:25:00',1.7),('12374','2013-05-04','07:30:00',2.06),('12374','2013-05-04','07:35:00',2.29),('12374','2013-05-04','07:40:00',2.58),('12374','2013-05-04','07:45:00',2.8),('12374','2013-05-04','07:50:00',2.5),('12374','2013-05-04','07:55:00',2.76),('12374','2013-05-04','08:00:00',2.31),('12374','2013-05-04','08:05:00',3.06),('12374','2013-05-04','08:10:00',3.32),('12374','2013-05-04','08:15:00',3.78),('12374','2013-05-04','08:20:00',3.72),('12374','2013-05-04','08:25:00',3.56),('12374','2013-05-04','08:30:00',2.84),('12374','2013-05-04','08:35:00',3.47),('12374','2013-05-04','08:40:00',2.9),('12374','2013-05-04','08:45:00',3.91),('12374','2013-05-04','08:50:00',5.59),('12374','2013-05-04','08:55:00',5.75),('12374','2013-05-04','09:00:00',5.53),('12374','2013-05-04','09:05:00',4.95),('12374','2013-05-04','09:10:00',5.62),('12374','2013-05-04','09:15:00',4.92),('12374','2013-05-04','09:20:00',5.42),('12374','2013-05-04','09:25:00',5.61),('12374','2013-05-04','09:30:00',5.66),('12374','2013-05-04','09:35:00',5.95),('12374','2013-05-04','09:40:00',6.05),('12374','2013-05-04','09:45:00',6.22),('12374','2013-05-04','09:50:00',6.31),('12374','2013-05-04','09:55:00',6.41),('12374','2013-05-04','10:00:00',6.54),('12374','2013-05-04','10:05:00',6.7),('12374','2013-05-04','10:10:00',6.76),('12374','2013-05-04','10:15:00',6.92),('12374','2013-05-04','10:20:00',7.04),('12374','2013-05-04','10:25:00',7.13),('12374','2013-05-04','10:30:00',7.18),('12374','2013-05-04','10:35:00',7.3),('12374','2013-05-04','10:40:00',7.4),('12374','2013-05-04','10:45:00',7.56),('12374','2013-05-04','10:50:00',7.66),('12374','2013-05-04','10:55:00',7.78),('12374','2013-05-04','11:00:00',7.89),('12374','2013-05-04','11:05:00',7.98),('12374','2013-05-04','11:10:00',7.86),('12374','2013-05-04','11:15:00',7.64),('12374','2013-05-04','11:20:00',7.33),('12374','2013-05-04','11:25:00',8.14),('12374','2013-05-04','11:30:00',8.28),('12374','2013-05-04','11:35:00',8.25),('12374','2013-05-04','11:40:00',8.11),('12374','2013-05-04','11:45:00',8.07),('12374','2013-05-04','11:50:00',8.24),('12374','2013-05-04','11:55:00',8.16),('12374','2013-05-04','12:00:00',7.86),('12374','2013-05-04','12:05:00',8.07),('12374','2013-05-04','12:10:00',8.19),('12374','2013-05-04','12:15:00',8.17),('12374','2013-05-04','12:20:00',8.34),('12374','2013-05-04','12:25:00',8.14),('12374','2013-05-04','12:30:00',7.99),('12374','2013-05-04','12:35:00',8),('12374','2013-05-04','12:40:00',7.96),('12374','2013-05-04','12:45:00',8.01),('12374','2013-05-04','12:50:00',7.76),('12374','2013-05-04','12:55:00',8.46),('12374','2013-05-04','13:00:00',8.74),('12374','2013-05-04','13:05:00',8.79),('12374','2013-05-04','13:10:00',8.79),('12374','2013-05-04','13:15:00',8.72),('12374','2013-05-04','13:20:00',8.66),('12374','2013-05-04','13:25:00',8.73),('12374','2013-05-04','13:30:00',8.48),('12374','2013-05-04','13:35:00',8.64),('12374','2013-05-04','13:40:00',8.3),('12374','2013-05-04','13:45:00',8.39),('12374','2013-05-04','13:50:00',8.57),('12374','2013-05-04','13:55:00',8.19),('12374','2013-05-04','14:00:00',8.11),('12374','2013-05-04','14:05:00',7.84),('12374','2013-05-04','14:10:00',8.42),('12374','2013-05-04','14:15:00',8.34),('12374','2013-05-04','14:20:00',7.87),('12374','2013-05-04','14:25:00',7.91),('12374','2013-05-04','14:30:00',7.63),('12374','2013-05-04','14:35:00',8.01),('12374','2013-05-04','14:40:00',7.95),('12374','2013-05-04','14:45:00',7.1),('12374','2013-05-04','14:50:00',6.92),('12374','2013-05-04','14:55:00',7.66),('12374','2013-05-04','15:00:00',7.63),('12374','2013-05-04','15:05:00',7.61),('12374','2013-05-04','15:10:00',7.64),('12374','2013-05-04','15:15:00',7.15),('12374','2013-05-04','15:20:00',6.5),('12374','2013-05-04','15:25:00',7.38),('12374','2013-05-04','15:30:00',7.17),('12374','2013-05-04','15:35:00',7.12),('12374','2013-05-04','15:40:00',7.13),('12374','2013-05-04','15:45:00',6.97),('12374','2013-05-04','15:50:00',6.8),('12374','2013-05-04','15:55:00',6.69),('12374','2013-05-04','16:00:00',6.53),('12374','2013-05-04','16:05:00',6.41),('12374','2013-05-04','16:10:00',6.32),('12374','2013-05-04','16:15:00',6.2),('12374','2013-05-04','16:20:00',6.09),('12374','2013-05-04','16:25:00',5.91),('12374','2013-05-04','16:30:00',5.77),('12374','2013-05-04','16:35:00',5.62),('12374','2013-05-04','16:40:00',5.48),('12374','2013-05-04','16:45:00',5.32),('12374','2013-05-04','16:50:00',5.18),('12374','2013-05-04','16:55:00',5.02),('12374','2013-05-04','17:00:00',4.86),('12374','2013-05-04','17:05:00',4.69),('12374','2013-05-04','17:10:00',4.54),('12374','2013-05-04','17:15:00',4.45),('12374','2013-05-04','17:20:00',4.33),('12374','2013-05-04','17:25:00',4.06),('12374','2013-05-04','17:30:00',3.85),('12374','2013-05-04','17:35:00',3.68),('12374','2013-05-04','17:40:00',3.45),('12374','2013-05-04','17:45:00',3.22),('12374','2013-05-04','17:50:00',2.71),('12374','2013-05-04','17:55:00',2.61),('12374','2013-05-04','18:00:00',2.36),('12374','2013-05-04','18:05:00',1.13),('12374','2013-05-04','18:10:00',1.2),('12374','2013-05-04','18:15:00',1.61),('12374','2013-05-04','18:20:00',1.75),('12374','2013-05-04','18:25:00',1.53),('12374','2013-05-04','18:30:00',1.42),('12374','2013-05-04','18:35:00',1.38),('12374','2013-05-04','18:40:00',1.16),('12374','2013-05-03','07:05:00',1.19),('12374','2013-05-03','07:10:00',1.42),('12374','2013-05-03','07:15:00',1.79),('12374','2013-05-03','07:20:00',1.87),('12374','2013-05-03','07:25:00',1.97),('12374','2013-05-03','07:30:00',1.78),('12374','2013-05-03','07:35:00',1.24),('12374','2013-05-03','07:40:00',1.18),('12374','2013-05-03','07:45:00',1.24),('12374','2013-05-03','07:50:00',1.78),('12374','2013-05-03','07:55:00',2.73),('12374','2013-05-03','08:00:00',2.79),('12374','2013-05-03','08:05:00',3.02),('12374','2013-05-03','08:10:00',3.21),('12374','2013-05-03','08:15:00',3.33),('12374','2013-05-03','08:20:00',3.52),('12374','2013-05-03','08:25:00',3.9),('12374','2013-05-03','08:30:00',4.12),('12374','2013-05-03','08:35:00',4.41),('12374','2013-05-03','08:40:00',4.57),('12374','2013-05-03','08:45:00',4.66),('12374','2013-05-03','08:50:00',4.76),('12374','2013-05-03','08:55:00',4.87),('12374','2013-05-03','09:00:00',5.05),('12374','2013-05-03','09:05:00',5.22),('12374','2013-05-03','09:10:00',5.4),('12374','2013-05-03','09:15:00',5.54),('12374','2013-05-03','09:20:00',5.69),('12374','2013-05-03','09:25:00',5.83),('12374','2013-05-03','09:30:00',5.93),('12374','2013-05-03','09:35:00',6.08),('12374','2013-05-03','09:40:00',6.22),('12374','2013-05-03','09:45:00',6.34),('12374','2013-05-03','09:50:00',6.43),('12374','2013-05-03','09:55:00',6.59),('12374','2013-05-03','10:00:00',6.68),('12374','2013-05-03','10:05:00',6.76),('12374','2013-05-03','10:10:00',6.9),('12374','2013-05-03','10:15:00',7.02),('12374','2013-05-03','10:20:00',7.14),('12374','2013-05-03','10:25:00',7.27),('12374','2013-05-03','10:30:00',7.37),('12374','2013-05-03','10:35:00',7.47),('12374','2013-05-03','10:40:00',7.54),('12374','2013-05-03','10:45:00',7.62),('12374','2013-05-03','10:50:00',7.72),('12374','2013-05-03','10:55:00',7.82),('12374','2013-05-03','11:00:00',7.92),('12374','2013-05-03','11:05:00',8.05),('12374','2013-05-03','11:10:00',8.15),('12374','2013-05-03','11:15:00',8.25),('12374','2013-05-03','11:20:00',8.28),('12374','2013-05-03','11:25:00',8.34),('12374','2013-05-03','11:30:00',8.41),('12374','2013-05-03','11:35:00',8.45),('12374','2013-05-03','11:40:00',8.48),('12374','2013-05-03','11:45:00',8.59),('12374','2013-05-03','11:50:00',8.67),('12374','2013-05-03','11:55:00',8.72),('12374','2013-05-03','12:00:00',8.75),('12374','2013-05-03','12:05:00',8.79),('12374','2013-05-03','12:10:00',8.87),('12374','2013-05-03','12:15:00',8.89),('12374','2013-05-03','12:20:00',8.91),('12374','2013-05-03','12:25:00',8.96),('12374','2013-05-03','12:30:00',8.96),('12374','2013-05-03','12:35:00',8.99),('12374','2013-05-03','12:40:00',9.01),('12374','2013-05-03','12:45:00',8.98),('12374','2013-05-03','12:50:00',8.93),('12374','2013-05-03','12:55:00',9.02),('12374','2013-05-03','13:00:00',9.05),('12374','2013-05-03','13:05:00',8.93),('12374','2013-05-03','13:10:00',8.6),('12374','2013-05-03','13:15:00',8.85),('12374','2013-05-03','13:20:00',9.05),('12374','2013-05-03','13:25:00',9.05),('12374','2013-05-03','13:30:00',8.93),('12374','2013-05-03','13:35:00',8.95),('12374','2013-05-03','13:40:00',9.03),('12374','2013-05-03','13:45:00',9.03),('12374','2013-05-03','13:50:00',8.96),('12374','2013-05-03','13:55:00',8.93),('12374','2013-05-03','14:00:00',8.88),('12374','2013-05-03','14:05:00',8.81),('12374','2013-05-03','14:10:00',8.81),('12374','2013-05-03','14:15:00',8.76),('12374','2013-05-03','14:20:00',8.68),('12374','2013-05-03','14:25:00',8.62),('12374','2013-05-03','14:30:00',8.55),('12374','2013-05-03','14:35:00',8.35),('12374','2013-05-03','14:40:00',8.32),('12374','2013-05-03','14:45:00',8.25),('12374','2013-05-03','14:50:00',8.14),('12374','2013-05-03','14:55:00',8.08),('12374','2013-05-03','15:00:00',7.98),('12374','2013-05-03','15:05:00',7.93),('12374','2013-05-03','15:10:00',7.81),('12374','2013-05-03','15:15:00',7.67),('12374','2013-05-03','15:20:00',7.6),('12374','2013-05-03','15:25:00',7.35),('12374','2013-05-03','15:30:00',7.37),('12374','2013-05-03','15:35:00',7.29),('12374','2013-05-03','15:40:00',6.97),('12374','2013-05-03','15:45:00',6.96),('12374','2013-05-03','15:50:00',6.85),('12374','2013-05-03','15:55:00',6.71),('12374','2013-05-03','16:00:00',6.6),('12374','2013-05-03','16:05:00',6.46),('12374','2013-05-03','16:10:00',6.35),('12374','2013-05-03','16:15:00',6.28),('12374','2013-05-03','16:20:00',6.12),('12374','2013-05-03','16:25:00',5.96),('12374','2013-05-03','16:30:00',5.87),('12374','2013-05-03','16:35:00',5.71),('12374','2013-05-03','16:40:00',5.51),('12374','2013-05-03','16:45:00',5.4),('12374','2013-05-03','16:50:00',5.21),('12374','2013-05-03','16:55:00',5.08),('12374','2013-05-03','17:00:00',4.88),('12374','2013-05-03','17:05:00',4.73),('12374','2013-05-03','17:10:00',4.56),('12374','2013-05-03','17:15:00',4.38),('12374','2013-05-03','17:20:00',4.16),('12374','2013-05-03','17:25:00',3.99),('12374','2013-05-03','17:30:00',3.83),('12374','2013-05-03','17:35:00',3.68),('12374','2013-05-03','17:40:00',3.48),('12374','2013-05-03','17:45:00',3.3),('12374','2013-05-03','17:50:00',3.07),('12374','2013-05-03','17:55:00',2.91),('12374','2013-05-03','18:00:00',2.7),('12374','2013-05-03','18:05:00',2.52),('12374','2013-05-03','18:10:00',2.34),('12374','2013-05-03','18:15:00',2.15),('12374','2013-05-03','18:20:00',2),('12374','2013-05-03','18:25:00',1.79),('12374','2013-05-03','18:30:00',1.65),('12374','2013-05-03','18:35:00',1.55),('12374','2013-05-03','18:40:00',1.46),('12374','2013-05-03','18:45:00',1.36),('12374','2013-05-03','18:50:00',1.25),('12374','2013-05-03','18:55:00',1.15),('12374','2013-05-02','08:30:00',1.05),('12374','2013-05-02','09:05:00',1.26),('12374','2013-05-02','09:10:00',1.65),('12374','2013-05-02','09:15:00',2.37),('12374','2013-05-02','09:20:00',1.64),('12374','2013-05-02','09:45:00',1.3),('12374','2013-05-02','09:50:00',3.42),('12374','2013-05-02','09:55:00',3.67),('12374','2013-05-02','10:00:00',5.23),('12374','2013-05-02','10:05:00',3.22),('12374','2013-05-02','10:10:00',5.65),('12374','2013-05-02','10:15:00',4.36),('12374','2013-05-02','10:20:00',4.11),('12374','2013-05-02','10:25:00',5.25),('12374','2013-05-02','10:30:00',7.37),('12374','2013-05-02','10:35:00',6.93),('12374','2013-05-02','10:40:00',5.81),('12374','2013-05-02','10:45:00',5.63),('12374','2013-05-02','10:50:00',5.81),('12374','2013-05-02','10:55:00',5.94),('12374','2013-05-02','11:00:00',4.4),('12374','2013-05-02','11:05:00',4.38),('12374','2013-05-02','11:10:00',5.13),('12374','2013-05-02','11:15:00',5.79),('12374','2013-05-02','11:20:00',7.85),('12374','2013-05-02','11:25:00',5.27),('12374','2013-05-02','11:30:00',5.1),('12374','2013-05-02','11:35:00',5),('12374','2013-05-02','11:40:00',4.46),('12374','2013-05-02','11:45:00',4.87),('12374','2013-05-02','11:50:00',5.54),('12374','2013-05-02','11:55:00',5.28),('12374','2013-05-02','12:00:00',4.71),('12374','2013-05-02','12:05:00',4.91),('12374','2013-05-02','12:10:00',6.58),('12374','2013-05-02','12:15:00',9.42),('12374','2013-05-02','12:20:00',8.71),('12374','2013-05-02','12:25:00',7.95),('12374','2013-05-02','12:30:00',7.61),('12374','2013-05-02','12:35:00',6.57),('12374','2013-05-02','12:40:00',6.56),('12374','2013-05-02','12:45:00',6.89),('12374','2013-05-02','12:50:00',8.26),('12374','2013-05-02','12:55:00',9.19),('12374','2013-05-02','13:00:00',9.22),('12374','2013-05-02','13:05:00',8.12),('12374','2013-05-02','13:10:00',9.05),('12374','2013-05-02','13:15:00',8.86),('12374','2013-05-02','13:20:00',8.87),('12374','2013-05-02','13:25:00',8.9),('12374','2013-05-02','13:30:00',8.95),('12374','2013-05-02','13:35:00',8.95),('12374','2013-05-02','13:40:00',8.94),('12374','2013-05-02','13:45:00',8.87),('12374','2013-05-02','13:50:00',8.83),('12374','2013-05-02','13:55:00',8.8),('12374','2013-05-02','14:00:00',8.73),('12374','2013-05-02','14:05:00',8.67),('12374','2013-05-02','14:10:00',8.68),('12374','2013-05-02','14:15:00',8.62),('12374','2013-05-02','14:20:00',8.52),('12374','2013-05-02','14:25:00',8.44),('12374','2013-05-02','14:30:00',8.4),('12374','2013-05-02','14:35:00',8.38),('12374','2013-05-02','14:40:00',8.32),('12374','2013-05-02','14:45:00',8.24),('12374','2013-05-02','14:50:00',8.16),('12374','2013-05-02','14:55:00',8.06),('12374','2013-05-02','15:00:00',7.99),('12374','2013-05-02','15:05:00',7.85),('12374','2013-05-02','15:10:00',7.72),('12374','2013-05-02','15:15:00',7.65),('12374','2013-05-02','15:20:00',7.52),('12374','2013-05-02','15:25:00',7.45),('12374','2013-05-02','15:30:00',7.37),('12374','2013-05-02','15:35:00',7.24),('12374','2013-05-02','15:40:00',7.07),('12374','2013-05-02','15:45:00',6.95),('12374','2013-05-02','15:50:00',6.8),('12374','2013-05-02','15:55:00',6.75),('12374','2013-05-02','16:00:00',6.62),('12374','2013-05-02','16:05:00',6.5),('12374','2013-05-02','16:10:00',6.33),('12374','2013-05-02','16:15:00',6.16),('12374','2013-05-02','16:20:00',6.04),('12374','2013-05-02','16:25:00',5.98),('12374','2013-05-02','16:30:00',5.85),('12374','2013-05-02','16:35:00',5.69),('12374','2013-05-02','16:40:00',5.51),('12374','2013-05-02','16:45:00',5.37),('12374','2013-05-02','16:50:00',5.22),('12374','2013-05-02','16:55:00',5.07),('12374','2013-05-02','17:00:00',4.93),('12374','2013-05-02','17:05:00',4.78),('12374','2013-05-02','17:10:00',4.59),('12374','2013-05-02','17:15:00',4.41),('12374','2013-05-02','17:20:00',4.23),('12374','2013-05-02','17:25:00',3.86),('12374','2013-05-02','17:30:00',3.84),('12374','2013-05-02','17:35:00',3.64),('12374','2013-05-02','17:40:00',3.49),('12374','2013-05-02','17:45:00',3.31),('12374','2013-05-02','17:50:00',3.08),('12374','2013-05-02','17:55:00',2.91),('12374','2013-05-02','18:00:00',2.7),('12374','2013-05-02','18:05:00',2.55),('12374','2013-05-02','18:10:00',2.29),('12374','2013-05-02','18:15:00',2.17),('12374','2013-05-02','18:20:00',2.06),('12374','2013-05-02','18:25:00',1.84),('12374','2013-05-02','18:30:00',1.69),('12374','2013-05-02','18:35:00',1.59),('12374','2013-05-02','18:40:00',1.49),('12374','2013-05-02','18:45:00',1.39),('12374','2013-05-02','18:50:00',1.29),('12374','2013-05-02','18:55:00',1.19),('12374','2013-05-02','19:00:00',1.09),('12374','2013-05-01','07:15:00',1.11),('12374','2013-05-01','07:20:00',1.3),('12374','2013-05-01','07:25:00',1.47),('12374','2013-05-01','07:30:00',1.59),('12374','2013-05-01','07:35:00',1.81),('12374','2013-05-01','07:40:00',1.82),('12374','2013-05-01','07:45:00',2.11),('12374','2013-05-01','07:50:00',2.23),('12374','2013-05-01','07:55:00',2.4),('12374','2013-05-01','08:00:00',2.6),('12374','2013-05-01','08:05:00',2.81),('12374','2013-05-01','08:10:00',2.98),('12374','2013-05-01','08:15:00',3.21),('12374','2013-05-01','08:20:00',3.4),('12374','2013-05-01','08:25:00',3.56),('12374','2013-05-01','08:30:00',3.71),('12374','2013-05-01','08:35:00',3.9),('12374','2013-05-01','08:40:00',4.08),('12374','2013-05-01','08:45:00',4.3),('12374','2013-05-01','08:50:00',4.49),('12374','2013-05-01','08:55:00',4.62),('12374','2013-05-01','09:00:00',4.7),('12374','2013-05-01','09:05:00',4.8),('12374','2013-05-01','09:10:00',5.04),('12374','2013-05-01','09:15:00',5.2),('12374','2013-05-01','09:20:00',5.36),('12374','2013-05-01','09:25:00',5.47),('12374','2013-05-01','09:30:00',5.54),('12374','2013-05-01','09:35:00',5.62),('12374','2013-05-01','09:40:00',5.75),('12374','2013-05-01','09:45:00',5.92),('12374','2013-05-01','09:50:00',6.06),('12374','2013-05-01','09:55:00',6.24),('12374','2013-05-01','10:00:00',6.38),('12374','2013-05-01','10:05:00',6.48),('12374','2013-05-01','10:10:00',6.63),('12374','2013-05-01','10:15:00',6.8),('12374','2013-05-01','10:20:00',6.93),('12374','2013-05-01','10:25:00',7),('12374','2013-05-01','10:30:00',7.1),('12374','2013-05-01','10:35:00',7.24),('12374','2013-05-01','10:40:00',7.35),('12374','2013-05-01','10:45:00',7.43),('12374','2013-05-01','10:50:00',7.51),('12374','2013-05-01','10:55:00',7.54),('12374','2013-05-01','11:00:00',7.6),('12374','2013-05-01','11:05:00',7.73),('12374','2013-05-01','11:10:00',7.77),('12374','2013-05-01','11:15:00',7.82),('12374','2013-05-01','11:20:00',7.9),('12374','2013-05-01','11:25:00',7.94),('12374','2013-05-01','11:30:00',8.11),('12374','2013-05-01','11:35:00',8.17),('12374','2013-05-01','11:40:00',8.25),('12374','2013-05-01','11:45:00',8.28),('12374','2013-05-01','11:50:00',8.3),('12374','2013-05-01','11:55:00',8.31),('12374','2013-05-01','12:00:00',8.36),('12374','2013-05-01','12:05:00',8.47),('12374','2013-05-01','12:10:00',8.65),('12374','2013-05-01','12:15:00',6.16),('12374','2013-05-01','12:20:00',6.18),('12374','2013-05-01','12:25:00',5.37),('12374','2013-05-01','12:30:00',5.63),('12374','2013-05-01','12:35:00',5.11),('12374','2013-05-01','12:40:00',4.15),('12374','2013-05-01','12:45:00',6.28),('12374','2013-05-01','12:50:00',8.46),('12374','2013-05-01','12:55:00',8.76),('12374','2013-05-01','13:00:00',8.26),('12374','2013-05-01','13:05:00',6.56),('12374','2013-05-01','13:10:00',6.97),('12374','2013-05-01','13:15:00',8.62),('12374','2013-05-01','13:20:00',8.63),('12374','2013-05-01','13:25:00',8.8),('12374','2013-05-01','13:30:00',8.84),('12374','2013-05-01','13:35:00',8.82),('12374','2013-05-01','13:40:00',8.69),('12374','2013-05-01','13:45:00',8.71),('12374','2013-05-01','13:50:00',8.48),('12374','2013-05-01','13:55:00',7.49),('12374','2013-05-01','14:00:00',7.95),('12374','2013-05-01','14:05:00',8.78),('12374','2013-05-01','14:10:00',7.1),('12374','2013-05-01','14:15:00',6.36),('12374','2013-05-01','14:20:00',7.65),('12374','2013-05-01','14:25:00',7.38),('12374','2013-05-01','14:30:00',8.68),('12374','2013-05-01','14:35:00',8.44),('12374','2013-05-01','14:40:00',7.96),('12374','2013-05-01','14:45:00',8.04),('12374','2013-05-01','14:50:00',4.6),('12374','2013-05-01','14:55:00',3.88),('12374','2013-05-01','15:00:00',5.4),('12374','2013-05-01','15:05:00',4.53),('12374','2013-05-01','15:10:00',5),('12374','2013-05-01','15:15:00',4.82),('12374','2013-05-01','15:20:00',4.42),('12374','2013-05-01','15:25:00',4.53),('12374','2013-05-01','15:30:00',4.24),('12374','2013-05-01','15:35:00',4.68),('12374','2013-05-01','15:40:00',5.02),('12374','2013-05-01','15:45:00',4.68),('12374','2013-05-01','15:50:00',4.35),('12374','2013-05-01','15:55:00',3.54),('12374','2013-05-01','16:00:00',3.49),('12374','2013-05-01','16:05:00',4.57),('12374','2013-05-01','16:10:00',5.15),('12374','2013-05-01','16:15:00',4.8),('12374','2013-05-01','16:20:00',4.05),('12374','2013-05-01','16:25:00',2.91),('12374','2013-05-01','16:30:00',2.66),('12374','2013-05-01','16:35:00',2.58),('12374','2013-05-01','16:40:00',2.27),('12374','2013-05-01','16:45:00',1.99),('12374','2013-05-01','16:50:00',1.96),('12374','2013-05-01','16:55:00',2),('12374','2013-05-01','17:00:00',1.88),('12374','2013-05-01','17:05:00',1.6),('12374','2013-05-01','17:10:00',1.32),('12374','2013-05-01','17:15:00',1.11),('12374','2013-04-30','07:55:00',1.01),('12374','2013-04-30','08:00:00',1.58),('12374','2013-04-30','08:05:00',2.15),('12374','2013-04-30','08:10:00',2.17),('12374','2013-04-30','08:15:00',2.11),('12374','2013-04-30','08:20:00',1.96),('12374','2013-04-30','08:25:00',1.61),('12374','2013-04-30','08:30:00',1.74),('12374','2013-04-30','08:35:00',1.75),('12374','2013-04-30','08:40:00',1.72),('12374','2013-04-30','08:45:00',1.84),('12374','2013-04-30','08:50:00',2.04),('12374','2013-04-30','08:55:00',2.72),('12374','2013-04-30','09:00:00',3.24),('12374','2013-04-30','09:05:00',4.29),('12374','2013-04-30','09:10:00',4.43),('12374','2013-04-30','09:15:00',4.47),('12374','2013-04-30','09:20:00',3.8),('12374','2013-04-30','09:25:00',3.01),('12374','2013-04-30','09:30:00',4.77),('12374','2013-04-30','09:35:00',5.57),('12374','2013-04-30','09:40:00',4.83),('12374','2013-04-30','09:45:00',3.8),('12374','2013-04-30','09:50:00',3.13),('12374','2013-04-30','09:55:00',3.08),('12374','2013-04-30','10:00:00',1.9),('12374','2013-04-30','10:05:00',1.42),('12374','2013-04-30','10:10:00',1.38),('12374','2013-04-30','10:15:00',1.37),('12374','2013-04-30','10:20:00',1.48),('12374','2013-04-30','10:25:00',1.61),('12374','2013-04-30','10:30:00',1.75),('12374','2013-04-30','10:35:00',2.59),('12374','2013-04-30','10:40:00',3.66),('12374','2013-04-30','10:45:00',3.42),('12374','2013-04-30','10:50:00',3.66),('12374','2013-04-30','10:55:00',4.26),('12374','2013-04-30','11:00:00',5.06),('12374','2013-04-30','11:05:00',5.8),('12374','2013-04-30','11:10:00',5.22),('12374','2013-04-30','11:15:00',3.85),('12374','2013-04-30','11:20:00',4.23),('12374','2013-04-30','11:25:00',6.74),('12374','2013-04-30','11:30:00',5.34),('12374','2013-04-30','11:35:00',4.83),('12374','2013-04-30','11:40:00',5.44),('12374','2013-04-30','11:45:00',8),('12374','2013-04-30','11:50:00',7.9),('12374','2013-04-30','11:55:00',6.13),('12374','2013-04-30','12:00:00',4.38),('12374','2013-04-30','12:05:00',4.73),('12374','2013-04-30','12:10:00',4.24),('12374','2013-04-30','12:15:00',3.95),('12374','2013-04-30','12:20:00',4.36),('12374','2013-04-30','12:25:00',5.42),('12374','2013-04-30','12:30:00',6.1),('12374','2013-04-30','12:35:00',6.18),('12374','2013-04-30','12:40:00',7.27),('12374','2013-04-30','12:45:00',8.29),('12374','2013-04-30','12:50:00',8.55),('12374','2013-04-30','12:55:00',8.75),('12374','2013-04-30','13:00:00',8.5),('12374','2013-04-30','13:05:00',9.06),('12374','2013-04-30','13:10:00',8.9),('12374','2013-04-30','13:15:00',8.95),('12374','2013-04-30','13:20:00',8.89),('12374','2013-04-30','13:25:00',8.87),('12374','2013-04-30','13:30:00',8.83),('12374','2013-04-30','13:35:00',8.76),('12374','2013-04-30','13:40:00',8.68),('12374','2013-04-30','13:45:00',8.65),('12374','2013-04-30','13:50:00',8.59),('12374','2013-04-30','13:55:00',8.58),('12374','2013-04-30','14:00:00',8.52),('12374','2013-04-30','14:05:00',8.46),('12374','2013-04-30','14:10:00',8.38),('12374','2013-04-30','14:15:00',8.36),('12374','2013-04-30','14:20:00',8.28),('12374','2013-04-30','14:25:00',8.19),('12374','2013-04-30','14:30:00',8.09),('12374','2013-04-30','14:35:00',8.02),('12374','2013-04-30','14:40:00',7.96),('12374','2013-04-30','14:45:00',7.86),('12374','2013-04-30','14:50:00',7.74),('12374','2013-04-30','14:55:00',7.6),('12374','2013-04-30','15:00:00',7.45),('12374','2013-04-30','15:05:00',7.38),('12374','2013-04-30','15:10:00',7.2),('12374','2013-04-30','15:15:00',6.95),('12374','2013-04-30','15:20:00',7),('12374','2013-04-30','15:25:00',6.95),('12374','2013-04-30','15:30:00',6.88),('12374','2013-04-30','15:35:00',6.91),('12374','2013-04-30','15:40:00',6.43),('12374','2013-04-30','15:45:00',3.93),('12374','2013-04-30','15:50:00',5.27),('12374','2013-04-30','15:55:00',6.64),('12374','2013-04-30','16:00:00',5.89),('12374','2013-04-30','16:05:00',5.7),('12374','2013-04-30','16:10:00',6.33),('12374','2013-04-30','16:15:00',4.86),('12374','2013-04-30','16:20:00',4.06),('12374','2013-04-30','16:25:00',3.56),('12374','2013-04-30','16:30:00',3.84),('12374','2013-04-30','16:35:00',3.78),('12374','2013-04-30','16:40:00',3.36),('12374','2013-04-30','16:45:00',3.25),('12374','2013-04-30','16:50:00',3.32),('12374','2013-04-30','16:55:00',3.96),('12374','2013-04-30','17:00:00',3.85),('12374','2013-04-30','17:05:00',3.07),('12374','2013-04-30','17:10:00',3.81),('12374','2013-04-30','17:15:00',3.85),('12374','2013-04-30','17:20:00',2.69),('12374','2013-04-30','17:25:00',3.34),('12374','2013-04-30','17:30:00',3.25),('12374','2013-04-30','17:35:00',3.04),('12374','2013-04-30','17:40:00',2.8),('12374','2013-04-30','17:45:00',2.58),('12374','2013-04-30','17:50:00',2.44),('12374','2013-04-30','17:55:00',2.22),('12374','2013-04-30','18:00:00',2.06),('12374','2013-04-30','18:05:00',1.97),('12374','2013-04-30','18:10:00',1.55),('12374','2013-04-30','18:15:00',1.56),('12374','2013-04-30','18:20:00',1.5),('12374','2013-04-30','18:25:00',1.49),('12374','2013-04-30','18:30:00',1.42),('12374','2013-04-30','18:35:00',1.32),('12374','2013-04-30','18:40:00',1.15),('12374','2013-04-29','07:10:00',1.04),('12374','2013-04-29','07:15:00',1.25),('12374','2013-04-29','07:20:00',1.38),('12374','2013-04-29','07:25:00',1.36),('12374','2013-04-29','07:30:00',1.27),('12374','2013-04-29','07:35:00',1.47),('12374','2013-04-29','07:40:00',1.73),('12374','2013-04-29','07:45:00',1.99),('12374','2013-04-29','07:50:00',2.38),('12374','2013-04-29','07:55:00',2.48),('12374','2013-04-29','08:00:00',2.56),('12374','2013-04-29','08:05:00',2.75),('12374','2013-04-29','08:10:00',2.51),('12374','2013-04-29','08:15:00',2.46),('12374','2013-04-29','08:20:00',2.93),('12374','2013-04-29','08:25:00',2.84),('12374','2013-04-29','08:30:00',3.19),('12374','2013-04-29','08:35:00',3.44),('12374','2013-04-29','08:40:00',3.3),('12374','2013-04-29','08:45:00',4.12),('12374','2013-04-29','08:50:00',4.42),('12374','2013-04-29','08:55:00',4.5),('12374','2013-04-29','09:00:00',4.69),('12374','2013-04-29','09:05:00',5.09),('12374','2013-04-29','09:10:00',5.34),('12374','2013-04-29','09:15:00',4.82),('12374','2013-04-29','09:20:00',5.22),('12374','2013-04-29','09:25:00',4.94),('12374','2013-04-29','09:30:00',5.17),('12374','2013-04-29','09:35:00',5.42),('12374','2013-04-29','09:40:00',5.7),('12374','2013-04-29','09:45:00',5.85),('12374','2013-04-29','09:50:00',6.05),('12374','2013-04-29','09:55:00',6.07),('12374','2013-04-29','10:00:00',6.21),('12374','2013-04-29','10:05:00',6.15),('12374','2013-04-29','10:10:00',6.02),('12374','2013-04-29','10:15:00',6.25),('12374','2013-04-29','10:20:00',6.08),('12374','2013-04-29','10:25:00',6.59),('12374','2013-04-29','10:30:00',6.63),('12374','2013-04-29','10:35:00',6.39),('12374','2013-04-29','10:40:00',6.81),('12374','2013-04-29','10:45:00',7.18),('12374','2013-04-29','10:50:00',7.49),('12374','2013-04-29','10:55:00',7.17),('12374','2013-04-29','11:00:00',7.44),('12374','2013-04-29','11:05:00',7.57),('12374','2013-04-29','11:10:00',7.57),('12374','2013-04-29','11:15:00',7.67),('12374','2013-04-29','11:20:00',7.94),('12374','2013-04-29','11:25:00',8.17),('12374','2013-04-29','11:30:00',8.18),('12374','2013-04-29','11:35:00',8.11),('12374','2013-04-29','11:40:00',7.72),('12374','2013-04-29','11:45:00',7.98),('12374','2013-04-29','11:50:00',8.34),('12374','2013-04-29','11:55:00',8.21),('12374','2013-04-29','12:00:00',8.4),('12374','2013-04-29','12:05:00',8.52),('12374','2013-04-29','12:10:00',8.63),('12374','2013-04-29','12:15:00',8.66),('12374','2013-04-29','12:20:00',8.62),('12374','2013-04-29','12:25:00',8.85),('12374','2013-04-29','12:30:00',8.82),('12374','2013-04-29','12:35:00',8.66),('12374','2013-04-29','12:40:00',8.51),('12374','2013-04-29','12:45:00',8.68),('12374','2013-04-29','12:50:00',8.69),('12374','2013-04-29','12:55:00',8.81),('12374','2013-04-29','13:00:00',8.88),('12374','2013-04-29','13:05:00',8.86),('12374','2013-04-29','13:10:00',8.62),('12374','2013-04-29','13:15:00',8.42),('12374','2013-04-29','13:20:00',8.5),('12374','2013-04-29','13:25:00',8.12),('12374','2013-04-29','13:30:00',8.09),('12374','2013-04-29','13:35:00',8.35),('12374','2013-04-29','13:40:00',8.28),('12374','2013-04-29','13:45:00',7.76),('12374','2013-04-29','13:50:00',7.7),('12374','2013-04-29','13:55:00',7.33),('12374','2013-04-29','14:00:00',7.35),('12374','2013-04-29','14:05:00',6.99),('12374','2013-04-29','14:10:00',6.93),('12374','2013-04-29','14:15:00',7.1),('12374','2013-04-29','14:20:00',7.26),('12374','2013-04-29','14:25:00',7.28),('12374','2013-04-29','14:30:00',6.75),('12374','2013-04-29','14:35:00',6.9),('12374','2013-04-29','14:40:00',7.2),('12374','2013-04-29','14:45:00',7.19),('12374','2013-04-29','14:50:00',6.59),('12374','2013-04-29','14:55:00',6.73),('12374','2013-04-29','15:00:00',7.07),('12374','2013-04-29','15:05:00',6.99),('12374','2013-04-29','15:10:00',6.35),('12374','2013-04-29','15:15:00',6.17),('12374','2013-04-29','15:20:00',5.95),('12374','2013-04-29','15:25:00',6.19),('12374','2013-04-29','15:30:00',5.91),('12374','2013-04-29','15:35:00',6.25),('12374','2013-04-29','15:40:00',6.52),('12374','2013-04-29','15:45:00',6.53),('12374','2013-04-29','15:50:00',6.07),('12374','2013-04-29','15:55:00',5.97),('12374','2013-04-29','16:00:00',5.97),('12374','2013-04-29','16:05:00',5.9),('12374','2013-04-29','16:10:00',6.1),('12374','2013-04-29','16:15:00',6.14),('12374','2013-04-29','16:20:00',6.29),('12374','2013-04-29','16:25:00',5.86),('12374','2013-04-29','16:30:00',6),('12374','2013-04-29','16:35:00',5.9),('12374','2013-04-29','16:40:00',5.07),('12374','2013-04-29','16:45:00',5.49),('12374','2013-04-29','16:50:00',5.52),('12374','2013-04-29','16:55:00',4.56),('12374','2013-04-29','17:00:00',2.72),('12374','2013-04-29','17:05:00',3.44),('12374','2013-04-29','17:10:00',4.46),('12374','2013-04-29','17:15:00',4.71),('12374','2013-04-29','17:20:00',4.52),('12374','2013-04-29','17:25:00',4.26),('12374','2013-04-29','17:30:00',4.12),('12374','2013-04-29','17:35:00',3.86),('12374','2013-04-29','17:40:00',3.79),('12374','2013-04-29','17:45:00',3.42),('12374','2013-04-29','17:50:00',3.39),('12374','2013-04-29','17:55:00',2.94),('12374','2013-04-29','18:00:00',3.06),('12374','2013-04-29','18:05:00',2.86),('12374','2013-04-29','18:10:00',2.41),('12374','2013-04-29','18:15:00',2.22),('12374','2013-04-29','18:20:00',2.04),('12374','2013-04-29','18:25:00',1.83),('12374','2013-04-29','18:30:00',1.53),('12374','2013-04-29','18:35:00',1.33),('12374','2013-04-28','07:00:00',1.01),('12374','2013-04-28','07:05:00',1.17),('12374','2013-04-28','07:10:00',1.31),('12374','2013-04-28','07:15:00',1.33),('12374','2013-04-28','07:20:00',1.69),('12374','2013-04-28','07:25:00',1.87),('12374','2013-04-28','07:30:00',2.04),('12374','2013-04-28','07:35:00',2.13),('12374','2013-04-28','07:40:00',2.06),('12374','2013-04-28','07:45:00',2.55),('12374','2013-04-28','07:50:00',2.7),('12374','2013-04-28','07:55:00',2.88),('12374','2013-04-28','08:00:00',3.11),('12374','2013-04-28','08:05:00',3.34),('12374','2013-04-28','08:10:00',3.62),('12374','2013-04-28','08:15:00',3.63),('12374','2013-04-28','08:20:00',3.01),('12374','2013-04-28','08:25:00',3.77),('12374','2013-04-28','08:30:00',4.19),('12374','2013-04-28','08:35:00',4.32),('12374','2013-04-28','08:40:00',4.49),('12374','2013-04-28','08:45:00',4.62),('12374','2013-04-28','08:50:00',4.77),('12374','2013-04-28','08:55:00',4.96),('12374','2013-04-28','09:00:00',5.11),('12374','2013-04-28','09:05:00',5.24),('12374','2013-04-28','09:10:00',5.39),('12374','2013-04-28','09:15:00',5.56),('12374','2013-04-28','09:20:00',5.7),('12374','2013-04-28','09:25:00',5.79),('12374','2013-04-28','09:30:00',5.93),('12374','2013-04-28','09:35:00',6.1),('12374','2013-04-28','09:40:00',6.24),('12374','2013-04-28','09:45:00',6.37),('12374','2013-04-28','09:50:00',6.51),('12374','2013-04-28','09:55:00',6.64),('12374','2013-04-28','10:00:00',6.77),('12374','2013-04-28','10:05:00',6.89),('12374','2013-04-28','10:10:00',7),('12374','2013-04-28','10:15:00',7.13),('12374','2013-04-28','10:20:00',7.15),('12374','2013-04-28','10:25:00',7.14),('12374','2013-04-28','10:30:00',7.28),('12374','2013-04-28','10:35:00',7.57),('12374','2013-04-28','10:40:00',7.55),('12374','2013-04-28','10:45:00',7.51),('12374','2013-04-28','10:50:00',7.66),('12374','2013-04-28','10:55:00',7.87),('12374','2013-04-28','11:00:00',8.01),('12374','2013-04-28','11:05:00',8.1),('12374','2013-04-28','11:10:00',8.22),('12374','2013-04-28','11:15:00',7.5),('12374','2013-04-28','11:20:00',7.58),('12374','2013-04-28','11:25:00',8.27),('12374','2013-04-28','11:30:00',8.21),('12374','2013-04-28','11:35:00',8.39),('12374','2013-04-28','11:40:00',8.58),('12374','2013-04-28','11:45:00',7.97),('12374','2013-04-28','11:50:00',7.84),('12374','2013-04-28','11:55:00',7.99),('12374','2013-04-28','12:00:00',8.39),('12374','2013-04-28','12:05:00',8.62),('12374','2013-04-28','12:10:00',8.16),('12374','2013-04-28','12:15:00',8.44),('12374','2013-04-28','12:20:00',8.47),('12374','2013-04-28','12:25:00',9.12),('12374','2013-04-28','12:30:00',8.34),('12374','2013-04-28','12:35:00',7.79),('12374','2013-04-28','12:40:00',7.99),('12374','2013-04-28','12:45:00',8.72),('12374','2013-04-28','12:50:00',9.16),('12374','2013-04-28','12:55:00',8.76),('12374','2013-04-28','13:00:00',8.65),('12374','2013-04-28','13:05:00',8.58),('12374','2013-04-28','13:10:00',8.49),('12374','2013-04-28','13:15:00',9.01),('12374','2013-04-28','13:20:00',9.09),('12374','2013-04-28','13:25:00',8.68),('12374','2013-04-28','13:30:00',8.1),('12374','2013-04-28','13:35:00',8.41),('12374','2013-04-28','13:40:00',8.76),('12374','2013-04-28','13:45:00',8.99),('12374','2013-04-28','13:50:00',8.94),('12374','2013-04-28','13:55:00',8.77),('12374','2013-04-28','14:00:00',8.77),('12374','2013-04-28','14:05:00',8.71),('12374','2013-04-28','14:10:00',8.65),('12374','2013-04-28','14:15:00',8.53),('12374','2013-04-28','14:20:00',8.47),('12374','2013-04-28','14:25:00',8.37),('12374','2013-04-28','14:30:00',8.32),('12374','2013-04-28','14:35:00',8.3),('12374','2013-04-28','14:40:00',8.21),('12374','2013-04-28','14:45:00',8.09),('12374','2013-04-28','14:50:00',7.93),('12374','2013-04-28','14:55:00',7.86),('12374','2013-04-28','15:00:00',7.82),('12374','2013-04-28','15:05:00',7.75),('12374','2013-04-28','15:10:00',7.66),('12374','2013-04-28','15:15:00',7.55),('12374','2013-04-28','15:20:00',7.45),('12374','2013-04-28','15:25:00',7.3),('12374','2013-04-28','15:30:00',7.23),('12374','2013-04-28','15:35:00',7.12),('12374','2013-04-28','15:40:00',6.99),('12374','2013-04-28','15:45:00',6.86),('12374','2013-04-28','15:50:00',6.71),('12374','2013-04-28','15:55:00',6.64),('12374','2013-04-28','16:00:00',6.48),('12374','2013-04-28','16:05:00',6.39),('12374','2013-04-28','16:10:00',6.2),('12374','2013-04-28','16:15:00',6.05),('12374','2013-04-28','16:20:00',5.92),('12374','2013-04-28','16:25:00',5.79),('12374','2013-04-28','16:30:00',5.61),('12374','2013-04-28','16:35:00',5.5),('12374','2013-04-28','16:40:00',5.35),('12374','2013-04-28','16:45:00',5.2),('12374','2013-04-28','16:50:00',5.05),('12374','2013-04-28','16:55:00',4.87),('12374','2013-04-28','17:00:00',4.42),('12374','2013-04-28','17:05:00',4.43),('12374','2013-04-28','17:10:00',4.35),('12374','2013-04-28','17:15:00',4.35),('12374','2013-04-28','17:20:00',4.03),('12374','2013-04-28','17:25:00',3.77),('12374','2013-04-28','17:30:00',3.69),('12374','2013-04-28','17:35:00',3.08),('12374','2013-04-28','17:40:00',3.32),('12374','2013-04-28','17:45:00',3.19),('12374','2013-04-28','17:50:00',2.91),('12374','2013-04-28','17:55:00',2.59),('12374','2013-04-28','18:00:00',2.13),('12374','2013-04-28','18:05:00',1.88),('12374','2013-04-28','18:10:00',2.1),('12374','2013-04-28','18:15:00',1.77),('12374','2013-04-28','18:20:00',1.67),('12374','2013-04-28','18:25:00',1.32),('12374','2013-04-28','18:30:00',1.27),('12374','2013-04-28','18:35:00',1.25),('12374','2013-04-28','18:40:00',1.24),('12374','2013-04-28','18:45:00',1.38),('12374','2013-04-28','18:50:00',1.39),('12374','2013-04-28','18:55:00',1.34),('12374','2013-04-28','19:00:00',1.15),('12374','2013-04-28','19:05:00',1.03),('12374','2013-04-27','07:30:00',1.07),('12374','2013-04-27','07:35:00',1.24),('12374','2013-04-27','07:40:00',1.34),('12374','2013-04-27','07:45:00',1.45),('12374','2013-04-27','07:50:00',1.22),('12374','2013-04-27','12:00:00',1.1),('12374','2013-04-27','12:05:00',1.11),('12374','2013-04-27','12:10:00',1.74),('12374','2013-04-27','12:15:00',1.56),('12374','2013-04-27','12:20:00',1.62),('12374','2013-04-27','12:25:00',1.35),('12374','2013-04-27','12:30:00',1.41),('12374','2013-04-27','12:35:00',1.98),('12374','2013-04-27','12:40:00',3.17),('12374','2013-04-27','12:45:00',3.08),('12374','2013-04-27','12:50:00',3.13),('12374','2013-04-27','12:55:00',4.02),('12374','2013-04-27','13:00:00',2.77),('12374','2013-04-27','13:05:00',3.21),('12374','2013-04-27','13:10:00',3.26),('12374','2013-04-27','13:15:00',2.39),('12374','2013-04-27','13:20:00',2.27),('12374','2013-04-27','13:25:00',2.15),('12374','2013-04-27','13:30:00',2.21),('12374','2013-04-27','13:35:00',2.19),('12374','2013-04-27','13:40:00',2.91),('12374','2013-04-27','13:45:00',1.76),('12374','2013-04-27','13:50:00',1.73),('12374','2013-04-27','13:55:00',1.67),('12374','2013-04-27','14:00:00',2.45),('12374','2013-04-27','14:05:00',5.16),('12374','2013-04-27','14:10:00',4.08),('12374','2013-04-27','14:15:00',3.29),('12374','2013-04-27','14:20:00',4.03),('12374','2013-04-27','14:25:00',3.65),('12374','2013-04-27','14:30:00',1.97),('12374','2013-04-27','14:35:00',1.88),('12374','2013-04-27','14:40:00',2.16),('12374','2013-04-27','14:45:00',2.16),('12374','2013-04-27','14:50:00',1.78),('12374','2013-04-27','14:55:00',1.16),('12374','2013-04-27','15:30:00',1.24),('12374','2013-04-27','15:35:00',1.9),('12374','2013-04-27','15:40:00',1.38),('12374','2013-04-27','16:15:00',1.3),('12374','2013-04-27','16:20:00',3.45),('12374','2013-04-27','16:25:00',3.55),('12374','2013-04-27','16:30:00',1.91),('12374','2013-04-27','16:35:00',3.65),('12374','2013-04-27','16:40:00',3.52),('12374','2013-04-27','16:45:00',3.22),('12374','2013-04-27','16:50:00',3.09),('12374','2013-04-27','16:55:00',3.59),('12374','2013-04-27','17:00:00',2.55),('12374','2013-04-27','17:05:00',2.32),('12374','2013-04-27','17:10:00',1.83),('12374','2013-04-27','17:15:00',1.05),('12374','2013-04-27','17:20:00',1.14),('12374','2013-04-27','17:25:00',2.2),('12374','2013-04-27','17:30:00',1.89),('12374','2013-04-27','17:35:00',1.32),('12374','2013-04-27','17:50:00',1.21),('12374','2013-04-27','17:55:00',1.53),('12374','2013-04-27','18:00:00',1.58),('12374','2013-04-27','18:05:00',1.49),('12374','2013-04-27','18:20:00',1.05),('12374','2013-04-26','07:35:00',1.05),('12374','2013-04-26','07:40:00',1.16),('12374','2013-04-26','07:45:00',1.48),('12374','2013-04-26','07:50:00',1.77),('12374','2013-04-26','07:55:00',2.13),('12374','2013-04-26','08:00:00',2.38),('12374','2013-04-26','08:05:00',2.65),('12374','2013-04-26','08:10:00',2.91),('12374','2013-04-26','08:15:00',3.02),('12374','2013-04-26','08:20:00',3.12),('12374','2013-04-26','08:25:00',3.34),('12374','2013-04-26','08:30:00',3.43),('12374','2013-04-26','08:35:00',2.9),('12374','2013-04-26','08:40:00',2.6),('12374','2013-04-26','08:45:00',2.41),('12374','2013-04-26','08:50:00',2.43),('12374','2013-04-26','08:55:00',2.2),('12374','2013-04-26','09:00:00',2.51),('12374','2013-04-26','09:05:00',3.62),('12374','2013-04-26','09:10:00',4.22),('12374','2013-04-26','09:15:00',4.98),('12374','2013-04-26','09:20:00',5.37),('12374','2013-04-26','09:25:00',5.49),('12374','2013-04-26','09:30:00',5.65),('12374','2013-04-26','09:35:00',5.85),('12374','2013-04-26','09:40:00',6.16),('12374','2013-04-26','09:45:00',6.65),('12374','2013-04-26','09:50:00',7.2),('12374','2013-04-26','09:55:00',6.93),('12374','2013-04-26','10:00:00',4.77),('12374','2013-04-26','10:05:00',5.3),('12374','2013-04-26','10:10:00',5.19),('12374','2013-04-26','10:15:00',5.5),('12374','2013-04-26','10:20:00',5.55),('12374','2013-04-26','10:25:00',5.51),('12374','2013-04-26','10:30:00',5.79),('12374','2013-04-26','10:35:00',5.11),('12374','2013-04-26','10:40:00',4.94),('12374','2013-04-26','10:45:00',5.82),('12374','2013-04-26','10:50:00',6.13),('12374','2013-04-26','10:55:00',6.49),('12374','2013-04-26','11:00:00',5.56),('12374','2013-04-26','11:05:00',5.7),('12374','2013-04-26','11:10:00',5.39),('12374','2013-04-26','11:15:00',5.02),('12374','2013-04-26','11:20:00',4.79),('12374','2013-04-26','11:25:00',4.53),('12374','2013-04-26','11:30:00',4.53),('12374','2013-04-26','11:35:00',5.03),('12374','2013-04-26','11:40:00',5.52),('12374','2013-04-26','11:45:00',7.15),('12374','2013-04-26','11:50:00',5.01),('12374','2013-04-26','11:55:00',3.57),('12374','2013-04-26','12:00:00',3.73),('12374','2013-04-26','12:05:00',6.77),('12374','2013-04-26','12:10:00',7.35),('12374','2013-04-26','12:15:00',7.52),('12374','2013-04-26','12:20:00',8.94),('12374','2013-04-26','12:25:00',7.33),('12374','2013-04-26','12:30:00',9.04),('12374','2013-04-26','12:35:00',8.19),('12374','2013-04-26','12:40:00',6.53),('12374','2013-04-26','12:45:00',4.97),('12374','2013-04-26','12:50:00',4.16),('12374','2013-04-26','12:55:00',5.21),('12374','2013-04-26','13:00:00',4.4),('12374','2013-04-26','13:05:00',4.65),('12374','2013-04-26','13:10:00',4.26),('12374','2013-04-26','13:15:00',3.53),('12374','2013-04-26','13:20:00',5.16),('12374','2013-04-26','13:25:00',6.06),('12374','2013-04-26','13:30:00',4.73),('12374','2013-04-26','13:35:00',9.29),('12374','2013-04-26','13:40:00',5.99),('12374','2013-04-26','13:45:00',5.76),('12374','2013-04-26','13:50:00',7.21),('12374','2013-04-26','13:55:00',5.67),('12374','2013-04-26','14:00:00',5.41),('12374','2013-04-26','14:05:00',6.99),('12374','2013-04-26','14:10:00',7.89),('12374','2013-04-26','14:15:00',7.79),('12374','2013-04-26','14:20:00',3.77),('12374','2013-04-26','14:25:00',3.9),('12374','2013-04-26','14:30:00',2.99),('12374','2013-04-26','14:35:00',2.93),('12374','2013-04-26','14:40:00',3.96),('12374','2013-04-26','14:45:00',3.45),('12374','2013-04-26','14:50:00',4.39),('12374','2013-04-26','14:55:00',3.36),('12374','2013-04-26','15:00:00',2.15),('12374','2013-04-26','15:05:00',2.28),('12374','2013-04-26','15:10:00',1.87),('12374','2013-04-25','07:30:00',1.02),('12374','2013-04-25','07:35:00',1.17),('12374','2013-04-25','07:40:00',1.33),('12374','2013-04-25','07:45:00',1.74),('12374','2013-04-25','07:50:00',1.83),('12374','2013-04-25','07:55:00',1.65),('12374','2013-04-25','08:00:00',1.72),('12374','2013-04-25','08:05:00',1.7),('12374','2013-04-25','08:10:00',1.87),('12374','2013-04-25','08:15:00',1.76),('12374','2013-04-25','08:20:00',2.06),('12374','2013-04-25','08:25:00',2.94),('12374','2013-04-25','08:30:00',2.58),('12374','2013-04-25','08:35:00',2.23),('12374','2013-04-25','08:40:00',2.58),('12374','2013-04-25','08:45:00',3.47),('12374','2013-04-25','08:50:00',4.14),('12374','2013-04-25','08:55:00',3.29),('12374','2013-04-25','09:00:00',3.07),('12374','2013-04-25','09:05:00',3.62),('12374','2013-04-25','09:10:00',3.22),('12374','2013-04-25','09:15:00',4.22),('12374','2013-04-25','09:20:00',5.42),('12374','2013-04-25','09:25:00',5.5),('12374','2013-04-25','09:30:00',5.45),('12374','2013-04-25','09:35:00',5.89),('12374','2013-04-25','09:40:00',6.06),('12374','2013-04-25','09:45:00',5.17),('12374','2013-04-25','09:50:00',5.74),('12374','2013-04-25','09:55:00',4.65),('12374','2013-04-25','10:00:00',5.71),('12374','2013-04-25','10:05:00',6.11),('12374','2013-04-25','10:10:00',6.23),('12374','2013-04-25','10:15:00',6.38),('12374','2013-04-25','10:20:00',6.81),('12374','2013-04-25','10:25:00',6.82),('12374','2013-04-25','10:30:00',6.98),('12374','2013-04-25','10:35:00',7.3),('12374','2013-04-25','10:40:00',7.45),('12374','2013-04-25','10:45:00',7.56),('12374','2013-04-25','10:50:00',7.98),('12374','2013-04-25','10:55:00',5.61),('12374','2013-04-25','11:00:00',4.45),('12374','2013-04-25','11:05:00',5.4),('12374','2013-04-25','11:10:00',8.41),('12374','2013-04-25','11:15:00',8.22),('12374','2013-04-25','11:20:00',6.95),('12374','2013-04-25','11:25:00',7.97),('12374','2013-04-25','11:30:00',7.22),('12374','2013-04-25','11:35:00',7.96),('12374','2013-04-25','11:40:00',8.95),('12374','2013-04-25','11:45:00',8.85),('12374','2013-04-25','11:50:00',8.88),('12374','2013-04-25','11:55:00',8.88),('12374','2013-04-25','12:00:00',9.02),('12374','2013-04-25','12:05:00',8.54),('12374','2013-04-25','12:10:00',9.09),('12374','2013-04-25','12:15:00',9.22),('12374','2013-04-25','12:20:00',9.32),('12374','2013-04-25','12:25:00',9.38),('12374','2013-04-25','12:30:00',9.5),('12374','2013-04-25','12:35:00',6.73),('12374','2013-04-25','12:40:00',6.07),('12374','2013-04-25','12:45:00',7.07),('12374','2013-04-25','12:50:00',6.74),('12374','2013-04-25','12:55:00',7.08),('12374','2013-04-25','13:00:00',7.71),('12374','2013-04-25','13:05:00',7.08),('12374','2013-04-25','13:10:00',6.34),('12374','2013-04-25','13:15:00',7.22),('12374','2013-04-25','13:20:00',4.78),('12374','2013-04-25','13:25:00',3.93),('12374','2013-04-25','13:30:00',3.72),('12374','2013-04-25','13:35:00',3.65),('12374','2013-04-25','13:40:00',3.73),('12374','2013-04-25','13:45:00',3.89),('12374','2013-04-25','13:50:00',4.17),('12374','2013-04-25','13:55:00',4.25),('12374','2013-04-25','14:00:00',4.32),('12374','2013-04-25','14:05:00',5.11),('12374','2013-04-25','14:10:00',6.88),('12374','2013-04-25','14:15:00',8.94),('12374','2013-04-25','14:20:00',7.03),('12374','2013-04-25','14:25:00',7.42),('12374','2013-04-25','14:30:00',8.24),('12374','2013-04-25','14:35:00',8.27),('12374','2013-04-25','14:40:00',6.64),('12374','2013-04-25','14:45:00',7.44),('12374','2013-04-25','14:50:00',6.64),('12374','2013-04-25','14:55:00',6.36),('12374','2013-04-25','15:00:00',7.6),('12374','2013-04-25','15:05:00',7.75),('12374','2013-04-25','15:10:00',7.23),('12374','2013-04-25','15:15:00',7.13),('12374','2013-04-25','15:20:00',6.65),('12374','2013-04-25','15:25:00',6.24),('12374','2013-04-25','15:30:00',7.16),('12374','2013-04-25','15:35:00',6.83),('12374','2013-04-25','15:40:00',5.27),('12374','2013-04-25','15:45:00',4.67),('12374','2013-04-25','15:50:00',4.63),('12374','2013-04-25','15:55:00',4.58),('12374','2013-04-25','16:00:00',4.4),('12374','2013-04-25','16:05:00',4.73),('12374','2013-04-25','16:10:00',4.77),('12374','2013-04-25','16:15:00',4.19),('12374','2013-04-25','16:20:00',4.7),('12374','2013-04-25','16:25:00',4.51),('12374','2013-04-25','16:30:00',3.4),('12374','2013-04-25','16:35:00',3.48),('12374','2013-04-25','16:40:00',3.09),('12374','2013-04-25','16:45:00',2.85),('12374','2013-04-25','16:50:00',2.81),('12374','2013-04-25','16:55:00',2.75),('12374','2013-04-25','17:00:00',2.63),('12374','2013-04-25','17:05:00',2.48),('12374','2013-04-25','17:10:00',2.32),('12374','2013-04-25','17:15:00',2.24),('12374','2013-04-25','17:20:00',2.19),('12374','2013-04-25','17:25:00',2.18),('12374','2013-04-25','17:30:00',2.19),('12374','2013-04-25','17:35:00',2.15),('12374','2013-04-25','17:40:00',2.23),('12374','2013-04-25','17:45:00',2.29),('12374','2013-04-25','17:50:00',2.13),('12374','2013-04-25','17:55:00',1.91),('12374','2013-04-25','18:00:00',1.7),('12374','2013-04-25','18:05:00',1.52),('12374','2013-04-25','18:10:00',1.35),('12374','2013-04-25','18:15:00',1.2),('12374','2013-04-25','18:20:00',1.09),('12374','2013-04-25','18:25:00',1.04),('12374','2013-04-24','07:35:00',1.26),('12374','2013-04-24','07:40:00',1.44),('12374','2013-04-24','07:45:00',1.4),('12374','2013-04-24','07:50:00',1.67),('12374','2013-04-24','07:55:00',1.88),('12374','2013-04-24','08:00:00',2.01),('12374','2013-04-24','08:05:00',2.59),('12374','2013-04-24','08:10:00',3.15),('12374','2013-04-24','08:15:00',3.39),('12374','2013-04-24','08:20:00',3.27),('12374','2013-04-24','08:25:00',3.57),('12374','2013-04-24','08:30:00',3.69),('12374','2013-04-24','08:35:00',3.95),('12374','2013-04-24','08:40:00',4.12),('12374','2013-04-24','08:45:00',4.43),('12374','2013-04-24','08:50:00',4.82),('12374','2013-04-24','08:55:00',5.02),('12374','2013-04-24','09:00:00',4.58),('12374','2013-04-24','09:05:00',4.05),('12374','2013-04-24','09:10:00',4.72),('12374','2013-04-24','09:15:00',3.98),('12374','2013-04-24','09:20:00',4.35),('12374','2013-04-24','09:25:00',4.71),('12374','2013-04-24','09:30:00',4.21),('12374','2013-04-24','09:35:00',4.17),('12374','2013-04-24','09:40:00',4.65),('12374','2013-04-24','09:45:00',4.67),('12374','2013-04-24','09:50:00',5.61),('12374','2013-04-24','09:55:00',5.9),('12374','2013-04-24','10:00:00',6.08),('12374','2013-04-24','10:05:00',5.63),('12374','2013-04-24','10:10:00',7.11),('12374','2013-04-24','10:15:00',7.56),('12374','2013-04-24','10:20:00',7.54),('12374','2013-04-24','10:25:00',7.68),('12374','2013-04-24','10:30:00',7.43),('12374','2013-04-24','10:35:00',7.23),('12374','2013-04-24','10:40:00',7.4),('12374','2013-04-24','10:45:00',7.79),('12374','2013-04-24','10:50:00',7.68),('12374','2013-04-24','10:55:00',7.69),('12374','2013-04-24','11:00:00',7.68),('12374','2013-04-24','11:05:00',7.75),('12374','2013-04-24','11:10:00',6.79),('12374','2013-04-24','11:15:00',6.52),('12374','2013-04-24','11:20:00',7.61),('12374','2013-04-24','11:25:00',8.52),('12374','2013-04-24','11:30:00',9.56),('12374','2013-04-24','11:35:00',9.55),('12374','2013-04-24','11:40:00',7.98),('12374','2013-04-24','11:45:00',7.41),('12374','2013-04-24','11:50:00',4.96),('12374','2013-04-24','11:55:00',6.87),('12374','2013-04-24','12:00:00',7.18),('12374','2013-04-24','12:05:00',7.6),('12374','2013-04-24','12:10:00',8.59),('12374','2013-04-24','12:15:00',8.34),('12374','2013-04-24','12:20:00',8.32),('12374','2013-04-24','12:25:00',8.49),('12374','2013-04-24','12:30:00',8.55),('12374','2013-04-24','12:35:00',8.67),('12374','2013-04-24','12:40:00',9.23),('12374','2013-04-24','12:45:00',9.1),('12374','2013-04-24','12:50:00',9.5),('12374','2013-04-24','12:55:00',9.71),('12374','2013-04-24','13:00:00',9.58),('12374','2013-04-24','13:05:00',8.78),('12374','2013-04-24','13:10:00',9.44),('12374','2013-04-24','13:15:00',9.55),('12374','2013-04-24','13:20:00',8.93),('12374','2013-04-24','13:25:00',9.7),('12374','2013-04-24','13:30:00',9.6),('12374','2013-04-24','13:35:00',8.81),('12374','2013-04-24','13:40:00',6.66),('12374','2013-04-24','13:45:00',5.41),('12374','2013-04-24','13:50:00',5.48),('12374','2013-04-24','13:55:00',7.52),('12374','2013-04-24','14:00:00',8.04),('12374','2013-04-24','14:05:00',7.96),('12374','2013-04-24','14:10:00',8.2),('12374','2013-04-24','14:15:00',8.98),('12374','2013-04-24','14:20:00',8.5),('12374','2013-04-24','14:25:00',8.6),('12374','2013-04-24','14:30:00',8.32),('12374','2013-04-24','14:35:00',8.39),('12374','2013-04-24','14:40:00',7.66),('12374','2013-04-24','14:45:00',6.11),('12374','2013-04-24','14:50:00',5.49),('12374','2013-04-24','14:55:00',5.45),('12374','2013-04-24','15:00:00',4.56),('12374','2013-04-24','15:05:00',4.72),('12374','2013-04-24','15:10:00',5.05),('12374','2013-04-24','15:15:00',4.97),('12374','2013-04-24','15:20:00',5.54),('12374','2013-04-24','15:25:00',5.8),('12374','2013-04-24','15:30:00',6.25),('12374','2013-04-24','15:35:00',6.58),('12374','2013-04-24','15:40:00',6.18),('12374','2013-04-24','15:45:00',3.78),('12374','2013-04-24','15:50:00',5.06),('12374','2013-04-24','15:55:00',5.57),('12374','2013-04-24','16:00:00',5.76),('12374','2013-04-24','16:05:00',5.01),('12374','2013-04-24','16:10:00',5.41),('12374','2013-04-24','16:15:00',4.51),('12374','2013-04-24','16:20:00',4.12),('12374','2013-04-24','16:25:00',4.16),('12374','2013-04-24','16:30:00',4.66),('12374','2013-04-24','16:35:00',4.77),('12374','2013-04-24','16:40:00',5.06),('12374','2013-04-24','16:45:00',5.15),('12374','2013-04-24','16:50:00',5.08),('12374','2013-04-24','16:55:00',5.23),('12374','2013-04-24','17:00:00',5.3),('12374','2013-04-24','17:05:00',4.97),('12374','2013-04-24','17:10:00',4.29),('12374','2013-04-24','17:15:00',3.5),('12374','2013-04-24','17:20:00',3.9),('12374','2013-04-24','17:25:00',3.78),('12374','2013-04-24','17:30:00',3.66),('12374','2013-04-24','17:35:00',3.58),('12374','2013-04-24','17:40:00',3.45),('12374','2013-04-24','17:45:00',2.71),('12374','2013-04-24','17:50:00',2.03),('12374','2013-04-24','17:55:00',2.35),('12374','2013-04-24','18:00:00',1.94),('12374','2013-04-24','18:05:00',2.28),('12374','2013-04-24','18:10:00',2.32),('12374','2013-04-24','18:15:00',2.37),('12374','2013-04-24','18:20:00',2.27),('12374','2013-04-24','18:25:00',2.1),('12374','2013-04-24','18:30:00',1.87),('12374','2013-04-24','18:35:00',1.67),('12374','2013-04-24','18:40:00',1.55),('12374','2013-04-24','18:45:00',1.24),('12374','2013-04-24','18:50:00',1.06),('12374','2013-04-23','07:05:00',1.19),('12374','2013-04-23','07:10:00',1.34),('12374','2013-04-23','07:15:00',1.51),('12374','2013-04-23','07:20:00',1.65),('12374','2013-04-23','07:25:00',1.63),('12374','2013-04-23','07:30:00',2.02),('12374','2013-04-23','07:35:00',2.21),('12374','2013-04-23','07:40:00',2.29),('12374','2013-04-23','07:45:00',2.22),('12374','2013-04-23','07:50:00',2.75),('12374','2013-04-23','07:55:00',2.95),('12374','2013-04-23','08:00:00',3.12),('12374','2013-04-23','08:05:00',3.31),('12374','2013-04-23','08:10:00',3.5),('12374','2013-04-23','08:15:00',3.68),('12374','2013-04-23','08:20:00',3.86),('12374','2013-04-23','08:25:00',4.04),('12374','2013-04-23','08:30:00',4.21),('12374','2013-04-23','08:35:00',4.37),('12374','2013-04-23','08:40:00',4.52),('12374','2013-04-23','08:45:00',4.63),('12374','2013-04-23','08:50:00',4.8),('12374','2013-04-23','08:55:00',4.95),('12374','2013-04-23','09:00:00',5.07),('12374','2013-04-23','09:05:00',5.23),('12374','2013-04-23','09:10:00',5.43),('12374','2013-04-23','09:15:00',5.58),('12374','2013-04-23','09:20:00',5.75),('12374','2013-04-23','09:25:00',5.89),('12374','2013-04-23','09:30:00',6.02),('12374','2013-04-23','09:35:00',6.19),('12374','2013-04-23','09:40:00',6.35),('12374','2013-04-23','09:45:00',6.49),('12374','2013-04-23','09:50:00',6.63),('12374','2013-04-23','09:55:00',6.76),('12374','2013-04-23','10:00:00',6.86),('12374','2013-04-23','10:05:00',7.02),('12374','2013-04-23','10:10:00',7.14),('12374','2013-04-23','10:15:00',7.27),('12374','2013-04-23','10:20:00',7.39),('12374','2013-04-23','10:25:00',7.52),('12374','2013-04-23','10:30:00',7.59),('12374','2013-04-23','10:35:00',7.81),('12374','2013-04-23','10:40:00',7.7),('12374','2013-04-23','10:45:00',8),('12374','2013-04-23','10:50:00',8.01),('12374','2013-04-23','10:55:00',8.14),('12374','2013-04-23','11:00:00',8.15),('12374','2013-04-23','11:05:00',8.2),('12374','2013-04-23','11:10:00',8.38),('12374','2013-04-23','11:15:00',8.42),('12374','2013-04-23','11:20:00',7.78),('12374','2013-04-23','11:25:00',8.59),('12374','2013-04-23','11:30:00',8.61),('12374','2013-04-23','11:35:00',8.72),('12374','2013-04-23','11:40:00',8.76),('12374','2013-04-23','11:45:00',8.82),('12374','2013-04-23','11:50:00',8.89),('12374','2013-04-23','11:55:00',8.97),('12374','2013-04-23','12:00:00',9.01),('12374','2013-04-23','12:05:00',9.02),('12374','2013-04-23','12:10:00',9.1),('12374','2013-04-23','12:15:00',9.16),('12374','2013-04-23','12:20:00',9.18),('12374','2013-04-23','12:25:00',9.22),('12374','2013-04-23','12:30:00',9.2),('12374','2013-04-23','12:35:00',9.08),('12374','2013-04-23','12:40:00',9.21),('12374','2013-04-23','12:45:00',9.15),('12374','2013-04-23','12:50:00',9.11),('12374','2013-04-23','12:55:00',9.23),('12374','2013-04-23','13:00:00',9.1),('12374','2013-04-23','13:05:00',9.13),('12374','2013-04-23','13:10:00',9.15),('12374','2013-04-23','13:15:00',9.16),('12374','2013-04-23','13:20:00',8.8),('12374','2013-04-23','13:25:00',8.68),('12374','2013-04-23','13:30:00',8.4),('12374','2013-04-23','13:35:00',7.87),('12374','2013-04-23','13:40:00',9.2),('12374','2013-04-23','13:45:00',8.8),('12374','2013-04-23','13:50:00',9.15),('12374','2013-04-23','13:55:00',8.73),('12374','2013-04-23','14:00:00',8.71),('12374','2013-04-23','14:05:00',8.62),('12374','2013-04-23','14:10:00',7.8),('12374','2013-04-23','14:15:00',8.19),('12374','2013-04-23','14:20:00',8.61),('12374','2013-04-23','14:25:00',9.14),('12374','2013-04-23','14:30:00',8.82),('12374','2013-04-23','14:35:00',7.77),('12374','2013-04-23','14:40:00',7.52),('12374','2013-04-23','14:45:00',7.77),('12374','2013-04-23','14:50:00',8.01),('12374','2013-04-23','14:55:00',8.61),('12374','2013-04-23','15:00:00',8.78),('12374','2013-04-23','15:05:00',7.68),('12374','2013-04-23','15:10:00',4.34),('12374','2013-04-23','15:15:00',4.77),('12374','2013-04-23','15:20:00',5.4),('12374','2013-04-23','15:25:00',6.19),('12374','2013-04-23','15:30:00',6.52),('12374','2013-04-23','15:35:00',6.45),('12374','2013-04-23','15:40:00',6.66),('12374','2013-04-23','15:45:00',7.15),('12374','2013-04-23','15:50:00',6.83),('12374','2013-04-23','15:55:00',6.5),('12374','2013-04-23','16:00:00',6.06),('12374','2013-04-23','16:05:00',6.09),('12374','2013-04-23','16:10:00',5.69),('12374','2013-04-23','16:15:00',5.2),('12374','2013-04-23','16:20:00',4.99),('12374','2013-04-23','16:25:00',4.99),('12374','2013-04-23','16:30:00',5.01),('12374','2013-04-23','16:35:00',5.25),('12374','2013-04-23','16:40:00',5.22),('12374','2013-04-23','16:45:00',4.83),('12374','2013-04-23','16:50:00',5.18),('12374','2013-04-23','16:55:00',4.82),('12374','2013-04-23','17:00:00',4.17),('12374','2013-04-23','17:05:00',4.87),('12374','2013-04-23','17:10:00',4.87),('12374','2013-04-23','17:15:00',4.45),('12374','2013-04-23','17:20:00',4.25),('12374','2013-04-23','17:25:00',4.08),('12374','2013-04-23','17:30:00',4.02),('12374','2013-04-23','17:35:00',4.29),('12374','2013-04-23','17:40:00',3.86),('12374','2013-04-23','17:45:00',2.98),('12374','2013-04-23','17:50:00',1.94),('12374','2013-04-23','17:55:00',1.98),('12374','2013-04-23','18:00:00',1.7),('12374','2013-04-23','18:05:00',1.66),('12374','2013-04-23','18:10:00',1.53),('12374','2013-04-23','18:15:00',1.63),('12374','2013-04-23','18:20:00',1.08),('12374','2013-04-23','18:30:00',1.37),('12374','2013-04-23','18:35:00',1.48),('12374','2013-04-23','18:40:00',1.22),('12374','2013-04-22','07:45:00',1.27),('12374','2013-04-22','07:50:00',1.05),('12374','2013-04-22','08:15:00',1.06),('12374','2013-04-22','08:20:00',1.09),('12374','2013-04-22','08:35:00',1.02),('12374','2013-04-22','09:30:00',1),('12374','2013-04-22','09:35:00',1.15),('12374','2013-04-22','09:40:00',1.11),('12374','2013-04-22','09:55:00',1.03),('12374','2013-04-22','10:00:00',1.19),('12374','2013-04-22','10:30:00',1.3),('12374','2013-04-22','10:35:00',2.26),('12374','2013-04-22','10:40:00',2.48),('12374','2013-04-22','10:45:00',2.41),('12374','2013-04-22','10:50:00',3.41),('12374','2013-04-22','10:55:00',3.73),('12374','2013-04-22','11:00:00',3.7),('12374','2013-04-22','11:05:00',8.14),('12374','2013-04-22','11:10:00',9.05),('12374','2013-04-22','11:15:00',8.03),('12374','2013-04-22','11:20:00',6.16),('12374','2013-04-22','11:25:00',7.53),('12374','2013-04-22','11:30:00',7.22),('12374','2013-04-22','11:35:00',6.27),('12374','2013-04-22','11:40:00',5.76),('12374','2013-04-22','11:45:00',3.97),('12374','2013-04-22','11:50:00',4.4),('12374','2013-04-22','11:55:00',7.63),('12374','2013-04-22','12:00:00',9.81),('12374','2013-04-22','12:05:00',7.62),('12374','2013-04-22','12:10:00',9.57),('12374','2013-04-22','12:15:00',9.67),('12374','2013-04-22','12:20:00',9.52),('12374','2013-04-22','12:25:00',9.61),('12374','2013-04-22','12:30:00',9.79),('12374','2013-04-22','12:35:00',9.89),('12374','2013-04-22','12:40:00',9.89),('12374','2013-04-22','12:45:00',9.97),('12374','2013-04-22','12:50:00',9.88),('12374','2013-04-22','12:55:00',9.94),('12374','2013-04-22','13:00:00',9.03),('12374','2013-04-22','13:05:00',9.5),('12374','2013-04-22','13:10:00',9.29),('12374','2013-04-22','13:15:00',9.8),('12374','2013-04-22','13:20:00',9.8),('12374','2013-04-22','13:25:00',5.61),('12374','2013-04-22','13:30:00',4.35),('12374','2013-04-22','13:35:00',2.61),('12374','2013-04-22','13:40:00',3.37),('12374','2013-04-22','13:45:00',6.57),('12374','2013-04-22','13:50:00',6.99),('12374','2013-04-22','13:55:00',5.28),('12374','2013-04-22','14:00:00',3.13),('12374','2013-04-22','14:05:00',2.11),('12374','2013-04-22','14:45:00',1.02),('12374','2013-04-22','14:50:00',1.05),('12374','2013-04-22','14:55:00',1.06),('12374','2013-04-22','15:00:00',3.72),('12374','2013-04-22','15:05:00',9.91),('12374','2013-04-22','15:10:00',7.97),('12374','2013-04-22','15:15:00',9.74),('12374','2013-04-22','15:20:00',8.83),('12374','2013-04-22','15:25:00',8.52),('12374','2013-04-22','15:30:00',8.34),('12374','2013-04-22','15:35:00',8.13),('12374','2013-04-22','15:40:00',7.92),('12374','2013-04-22','15:45:00',7.81),('12374','2013-04-22','15:50:00',7.59),('12374','2013-04-22','15:55:00',7.37),('12374','2013-04-22','16:00:00',4.9),('12374','2013-04-22','16:05:00',4.44),('12374','2013-04-22','16:10:00',2.8),('12374','2013-04-22','16:15:00',5.26),('12374','2013-04-22','16:20:00',6.55),('12374','2013-04-22','16:25:00',6.43),('12374','2013-04-22','16:30:00',5.91),('12374','2013-04-22','16:35:00',5.28),('12374','2013-04-22','16:40:00',5.69),('12374','2013-04-22','16:45:00',3.7),('12374','2013-04-22','16:50:00',2.77),('12374','2013-04-22','16:55:00',3.05),('12374','2013-04-22','17:00:00',5.3),('12374','2013-04-22','17:05:00',5.96),('12374','2013-04-22','17:10:00',4.15),('12374','2013-04-22','17:15:00',3.34),('12374','2013-04-22','17:20:00',2.91),('12374','2013-04-22','17:25:00',2.36),('12374','2013-04-22','17:30:00',1.71),('12374','2013-04-22','17:35:00',1.58),('12374','2013-04-22','17:40:00',1.57),('12374','2013-04-22','17:45:00',1.51),('12374','2013-04-22','17:50:00',1.48),('12374','2013-04-22','17:55:00',1.5),('12374','2013-04-22','18:00:00',1.44),('12374','2013-04-22','18:05:00',1.87),('12374','2013-04-22','18:10:00',2.95),('12374','2013-04-22','18:15:00',2.72),('12374','2013-04-22','18:20:00',1.16),('12374','2013-04-21','07:45:00',1.13),('12374','2013-04-21','07:50:00',1.67),('12374','2013-04-21','07:55:00',1.35),('12374','2013-04-21','08:00:00',1.39),('12374','2013-04-21','08:05:00',1.71),('12374','2013-04-21','08:10:00',2.24),('12374','2013-04-21','08:15:00',2.77),('12374','2013-04-21','08:20:00',2.56),('12374','2013-04-21','08:25:00',2.64),('12374','2013-04-21','08:30:00',4.03),('12374','2013-04-21','08:35:00',3.21),('12374','2013-04-21','08:40:00',4.87),('12374','2013-04-21','08:45:00',5.67),('12374','2013-04-21','08:50:00',5.72),('12374','2013-04-21','08:55:00',4.33),('12374','2013-04-21','09:00:00',2.36),('12374','2013-04-21','09:05:00',2.24),('12374','2013-04-21','09:10:00',2.27),('12374','2013-04-21','09:15:00',2.26),('12374','2013-04-21','09:20:00',3.31),('12374','2013-04-21','09:25:00',3.24),('12374','2013-04-21','09:30:00',5.09),('12374','2013-04-21','09:35:00',6.11),('12374','2013-04-21','09:40:00',6.35),('12374','2013-04-21','09:45:00',6.41),('12374','2013-04-21','09:50:00',6.48),('12374','2013-04-21','09:55:00',6.61),('12374','2013-04-21','10:00:00',6.71),('12374','2013-04-21','10:05:00',6.86),('12374','2013-04-21','10:10:00',6.98),('12374','2013-04-21','10:15:00',7.1),('12374','2013-04-21','10:20:00',7.25),('12374','2013-04-21','10:25:00',7.37),('12374','2013-04-21','10:30:00',7.46),('12374','2013-04-21','10:35:00',7.56),('12374','2013-04-21','10:40:00',7.59),('12374','2013-04-21','10:45:00',7.79),('12374','2013-04-21','10:50:00',7.91),('12374','2013-04-21','10:55:00',7.96),('12374','2013-04-21','11:00:00',8.06),('12374','2013-04-21','11:05:00',8.16),('12374','2013-04-21','11:10:00',8.27),('12374','2013-04-21','11:15:00',8.37),('12374','2013-04-21','11:20:00',8.56),('12374','2013-04-21','11:25:00',8.69),('12374','2013-04-21','11:30:00',8.87),('12374','2013-04-21','11:35:00',9.08),('12374','2013-04-21','11:40:00',9.29),('12374','2013-04-21','11:45:00',6.38),('12374','2013-04-21','11:50:00',6.02),('12374','2013-04-21','11:55:00',7.12),('12374','2013-04-21','12:00:00',9.76),('12374','2013-04-21','12:05:00',9.66),('12374','2013-04-21','12:10:00',9.78),('12374','2013-04-21','12:15:00',8.68),('12374','2013-04-21','12:20:00',5.13),('12374','2013-04-21','12:25:00',7.53),('12374','2013-04-21','12:30:00',9.56),('12374','2013-04-21','12:35:00',9.69),('12374','2013-04-21','12:40:00',9.27),('12374','2013-04-21','12:45:00',9.36),('12374','2013-04-21','12:50:00',9.51),('12374','2013-04-21','12:55:00',9.51),('12374','2013-04-21','13:00:00',9.42),('12374','2013-04-21','13:05:00',9.41),('12374','2013-04-21','13:10:00',9.38),('12374','2013-04-21','13:15:00',9.39),('12374','2013-04-21','13:20:00',9.28),('12374','2013-04-21','13:25:00',8.64),('12374','2013-04-21','13:30:00',9.29),('12374','2013-04-21','13:35:00',9.26),('12374','2013-04-21','13:40:00',9.24),('12374','2013-04-21','13:45:00',9.13),('12374','2013-04-21','13:50:00',9.17),('12374','2013-04-21','13:55:00',9.19),('12374','2013-04-21','14:00:00',9.27),('12374','2013-04-21','14:05:00',9.07),('12374','2013-04-21','14:10:00',8.96),('12374','2013-04-21','14:15:00',8.91),('12374','2013-04-21','14:20:00',8.59),('12374','2013-04-21','14:25:00',8.75),('12374','2013-04-21','14:30:00',8.79),('12374','2013-04-21','14:35:00',7.73),('12374','2013-04-21','14:40:00',6.56),('12374','2013-04-21','14:45:00',8.75),('12374','2013-04-21','14:50:00',8.93),('12374','2013-04-21','14:55:00',8.71),('12374','2013-04-21','15:00:00',8.26),('12374','2013-04-21','15:05:00',8.11),('12374','2013-04-21','15:10:00',7.99),('12374','2013-04-21','15:15:00',7.84),('12374','2013-04-21','15:20:00',7.8),('12374','2013-04-21','15:25:00',7.71),('12374','2013-04-21','15:30:00',7.68),('12374','2013-04-21','15:35:00',5.53),('12374','2013-04-21','15:40:00',6.85),('12374','2013-04-21','15:45:00',5.44),('12374','2013-04-21','15:50:00',5.72),('12374','2013-04-21','15:55:00',3.87),('12374','2013-04-21','16:00:00',4.63),('12374','2013-04-21','16:05:00',4.51),('12374','2013-04-21','16:10:00',4.04),('12374','2013-04-21','16:15:00',5.51),('12374','2013-04-21','16:20:00',4.55),('12374','2013-04-21','16:25:00',3.57),('12374','2013-04-21','16:30:00',3.11),('12374','2013-04-21','16:35:00',2.58),('12374','2013-04-21','16:40:00',2.56),('12374','2013-04-21','16:45:00',2.42),('12374','2013-04-21','16:50:00',2.25),('12374','2013-04-21','16:55:00',1.93),('12374','2013-04-21','17:00:00',1.64),('12374','2013-04-21','17:05:00',1.43),('12374','2013-04-21','17:10:00',1.28),('12374','2013-04-21','17:15:00',1.29),('12374','2013-04-21','17:20:00',1.16),('12374','2013-04-21','17:25:00',1.06),('12374','2013-04-21','17:30:00',1.01),('12374','2013-04-20','08:05:00',1.07),('12374','2013-04-20','08:10:00',1.28),('12374','2013-04-20','08:15:00',1.48),('12374','2013-04-20','08:20:00',1.71),('12374','2013-04-20','08:25:00',1.8),('12374','2013-04-20','08:30:00',1.73),('12374','2013-04-20','08:35:00',1.8),('12374','2013-04-20','08:40:00',2.07),('12374','2013-04-20','08:45:00',2.13),('12374','2013-04-20','08:50:00',2.13),('12374','2013-04-20','08:55:00',2.08),('12374','2013-04-20','09:00:00',1.9),('12374','2013-04-20','09:05:00',1.61),('12374','2013-04-20','09:10:00',1.59),('12374','2013-04-20','09:15:00',1.51),('12374','2013-04-20','09:20:00',1.47),('12374','2013-04-20','09:25:00',1.63),('12374','2013-04-20','09:30:00',1.8),('12374','2013-04-20','09:35:00',1.81),('12374','2013-04-20','09:40:00',1.78),('12374','2013-04-20','09:45:00',1.64),('12374','2013-04-20','09:50:00',1.64),('12374','2013-04-20','09:55:00',1.79),('12374','2013-04-20','10:00:00',1.93),('12374','2013-04-20','10:05:00',2.37),('12374','2013-04-20','10:10:00',2.52),('12374','2013-04-20','10:15:00',3.09),('12374','2013-04-20','10:20:00',3.35),('12374','2013-04-20','10:25:00',3.13),('12374','2013-04-20','10:30:00',2.95),('12374','2013-04-20','10:35:00',3.07),('12374','2013-04-20','10:40:00',3.19),('12374','2013-04-20','10:45:00',3.35),('12374','2013-04-20','10:50:00',3.48),('12374','2013-04-20','10:55:00',3.54),('12374','2013-04-20','11:00:00',3.84),('12374','2013-04-20','11:05:00',3.79),('12374','2013-04-20','11:10:00',4.01),('12374','2013-04-20','11:15:00',4.39),('12374','2013-04-20','11:20:00',4.73),('12374','2013-04-20','11:25:00',8.25),('12374','2013-04-20','11:30:00',8.86),('12374','2013-04-20','11:35:00',9.73),('12374','2013-04-20','11:40:00',9.69),('12374','2013-04-20','11:45:00',9.33),('12374','2013-04-20','11:50:00',9.04),('12374','2013-04-20','11:55:00',9.35),('12374','2013-04-20','12:00:00',9.59),('12374','2013-04-20','12:05:00',9.83),('12374','2013-04-20','12:10:00',6.65),('12374','2013-04-20','12:15:00',6.14),('12374','2013-04-20','12:20:00',6.12),('12374','2013-04-20','12:25:00',5.15),('12374','2013-04-20','12:30:00',5.08),('12374','2013-04-20','12:35:00',3.83),('12374','2013-04-20','12:40:00',6.64),('12374','2013-04-20','12:45:00',7.65),('12374','2013-04-20','12:50:00',3.33),('12374','2013-04-20','12:55:00',2.42),('12374','2013-04-20','13:00:00',2.12),('12374','2013-04-20','13:05:00',2.36),('12374','2013-04-20','13:10:00',2.82),('12374','2013-04-20','13:15:00',3.2),('12374','2013-04-20','13:20:00',3.88),('12374','2013-04-20','13:25:00',6.88),('12374','2013-04-20','13:30:00',8.15),('12374','2013-04-20','13:35:00',6.6),('12374','2013-04-20','13:40:00',8.63),('12374','2013-04-20','13:45:00',9.34),('12374','2013-04-20','13:50:00',9.05),('12374','2013-04-20','13:55:00',9.55),('12374','2013-04-20','14:00:00',7.22),('12374','2013-04-20','14:05:00',8.8),('12374','2013-04-20','14:10:00',8.4),('12374','2013-04-20','14:15:00',7.33),('12374','2013-04-20','14:20:00',3.84),('12374','2013-04-20','14:25:00',3.86),('12374','2013-04-20','14:30:00',4.42),('12374','2013-04-20','14:35:00',4.89),('12374','2013-04-20','14:40:00',4.6),('12374','2013-04-20','14:45:00',4.7),('12374','2013-04-20','14:50:00',3.3),('12374','2013-04-20','14:55:00',2.49),('12374','2013-04-20','15:00:00',2.19),('12374','2013-04-20','15:05:00',2.21),('12374','2013-04-20','15:10:00',2.28),('12374','2013-04-20','15:15:00',2.56),('12374','2013-04-20','15:20:00',3.05),('12374','2013-04-20','15:25:00',3.69),('12374','2013-04-20','15:30:00',6.35),('12374','2013-04-20','15:35:00',8.5),('12374','2013-04-20','15:40:00',8.49),('12374','2013-04-20','15:45:00',7.89),('12374','2013-04-20','15:50:00',7.41),('12374','2013-04-20','15:55:00',7.11),('12374','2013-04-20','16:00:00',6.77),('12374','2013-04-20','16:05:00',6.3),('12374','2013-04-20','16:10:00',6.17),('12374','2013-04-20','16:15:00',4.83),('12374','2013-04-20','16:20:00',2.74),('12374','2013-04-20','16:25:00',1.77),('12374','2013-04-20','16:30:00',4.93),('12374','2013-04-20','16:35:00',6.26),('12374','2013-04-20','16:40:00',5.03),('12374','2013-04-20','16:45:00',5.37),('12374','2013-04-20','16:50:00',5.25),('12374','2013-04-20','16:55:00',5.08),('12374','2013-04-20','17:00:00',4.89),('12374','2013-04-20','17:05:00',4.77),('12374','2013-04-20','17:10:00',4.51),('12374','2013-04-20','17:15:00',3.62),('12374','2013-04-20','17:20:00',2.02),('12374','2013-04-20','17:25:00',2.22),('12374','2013-04-20','17:30:00',1.77),('12374','2013-04-20','17:35:00',2.27),('12374','2013-04-20','17:40:00',2.65),('12374','2013-04-20','17:45:00',1.95),('12374','2013-04-20','17:50:00',1.41),('12374','2013-04-20','17:55:00',1.41),('12374','2013-04-20','18:00:00',1.46),('12374','2013-04-20','18:05:00',1.45),('12374','2013-04-20','18:10:00',1.22),('12374','2013-04-20','18:15:00',1.24),('12374','2013-04-20','18:20:00',1.07),('12374','2013-04-20','18:40:00',1.02),('12374','2013-04-20','18:45:00',1.07),('12374','2013-04-20','18:50:00',1.25),('12374','2013-04-20','18:55:00',1.16),('12374','2013-04-19','07:35:00',1.02),('12374','2013-04-19','07:40:00',1.42),('12374','2013-04-19','07:45:00',1.21),('12374','2013-04-19','07:55:00',1.56),('12374','2013-04-19','08:00:00',2.56),('12374','2013-04-19','08:05:00',2.74),('12374','2013-04-19','08:10:00',2.93),('12374','2013-04-19','08:15:00',3.08),('12374','2013-04-19','08:20:00',3.25),('12374','2013-04-19','08:25:00',3.33),('12374','2013-04-19','08:30:00',3.57),('12374','2013-04-19','08:35:00',3.82),('12374','2013-04-19','08:40:00',3.98),('12374','2013-04-19','08:45:00',4.12),('12374','2013-04-19','08:50:00',4.36),('12374','2013-04-19','08:55:00',4.54),('12374','2013-04-19','09:00:00',4.71),('12374','2013-04-19','09:05:00',4.89),('12374','2013-04-19','09:10:00',5.01),('12374','2013-04-19','09:15:00',5.14),('12374','2013-04-19','09:20:00',5.28),('12374','2013-04-19','09:25:00',5.49),('12374','2013-04-19','09:30:00',5.62),('12374','2013-04-19','09:35:00',5.74),('12374','2013-04-19','09:40:00',5.92),('12374','2013-04-19','09:45:00',5.12),('12374','2013-04-19','09:50:00',6.05),('12374','2013-04-19','09:55:00',6.47),('12374','2013-04-19','10:00:00',6.6),('12374','2013-04-19','10:05:00',4.89),('12374','2013-04-19','10:10:00',6.37),('12374','2013-04-19','10:15:00',7.17),('12374','2013-04-19','10:20:00',7.11),('12374','2013-04-19','10:25:00',7.37),('12374','2013-04-19','10:30:00',7.26),('12374','2013-04-19','10:35:00',7.32),('12374','2013-04-19','10:40:00',6.32),('12374','2013-04-19','10:45:00',4.07),('12374','2013-04-19','10:50:00',7.09),('12374','2013-04-19','10:55:00',7.7),('12374','2013-04-19','11:00:00',7.9),('12374','2013-04-19','11:05:00',7.52),('12374','2013-04-19','11:10:00',8),('12374','2013-04-19','11:15:00',7.65),('12374','2013-04-19','11:20:00',7.99),('12374','2013-04-19','11:25:00',8.16),('12374','2013-04-19','11:30:00',8.23),('12374','2013-04-19','11:35:00',8.32),('12374','2013-04-19','11:40:00',8.27),('12374','2013-04-19','11:45:00',8.44),('12374','2013-04-19','11:50:00',8.5),('12374','2013-04-19','11:55:00',8.56),('12374','2013-04-19','12:00:00',8.65),('12374','2013-04-19','12:05:00',8.71),('12374','2013-04-19','12:10:00',8.69),('12374','2013-04-19','12:15:00',8.83),('12374','2013-04-19','12:20:00',8.88),('12374','2013-04-19','12:25:00',8.93),('12374','2013-04-19','12:30:00',8.94),('12374','2013-04-19','12:35:00',9.01),('12374','2013-04-19','12:40:00',8.96),('12374','2013-04-19','12:45:00',8.97),('12374','2013-04-19','12:50:00',9),('12374','2013-04-19','12:55:00',8.99),('12374','2013-04-19','13:00:00',8.98),('12374','2013-04-19','13:05:00',8.95),('12374','2013-04-19','13:10:00',9.04),('12374','2013-04-19','13:15:00',9.07),('12374','2013-04-19','13:20:00',9.1),('12374','2013-04-19','13:25:00',9.04),('12374','2013-04-19','13:30:00',9.01),('12374','2013-04-19','13:35:00',8.98),('12374','2013-04-19','13:40:00',8.99),('12374','2013-04-19','13:45:00',8.95),('12374','2013-04-19','13:50:00',8.93),('12374','2013-04-19','13:55:00',8.78),('12374','2013-04-19','14:00:00',8.82),('12374','2013-04-19','14:05:00',8.77),('12374','2013-04-19','14:10:00',8.69),('12374','2013-04-19','14:15:00',8.64),('12374','2013-04-19','14:20:00',8.55),('12374','2013-04-19','14:25:00',8.46),('12374','2013-04-19','14:30:00',8.38),('12374','2013-04-19','14:35:00',8.33),('12374','2013-04-19','14:40:00',8.23),('12374','2013-04-19','14:45:00',8.14),('12374','2013-04-19','14:50:00',8.08),('12374','2013-04-19','14:55:00',7.99),('12374','2013-04-19','15:00:00',7.92),('12374','2013-04-19','15:05:00',7.81),('12374','2013-04-19','15:10:00',7.66),('12374','2013-04-19','15:15:00',7.55),('12374','2013-04-19','15:20:00',7.46),('12374','2013-04-19','15:25:00',7.37),('12374','2013-04-19','15:30:00',7.28),('12374','2013-04-19','15:35:00',7.16),('12374','2013-04-19','15:40:00',7),('12374','2013-04-19','15:45:00',6.92),('12374','2013-04-19','15:50:00',6.77),('12374','2013-04-19','15:55:00',6.63),('12374','2013-04-19','16:00:00',6.53),('12374','2013-04-19','16:05:00',6.38),('12374','2013-04-19','16:10:00',6.2),('12374','2013-04-19','16:15:00',6.13),('12374','2013-04-19','16:20:00',5.94),('12374','2013-04-19','16:25:00',5.76),('12374','2013-04-19','16:30:00',5.38),('12374','2013-04-19','16:35:00',5.49),('12374','2013-04-19','16:40:00',5.14),('12374','2013-04-19','16:45:00',5.05),('12374','2013-04-19','16:50:00',5.17),('12374','2013-04-19','16:55:00',4.89),('12374','2013-04-19','17:00:00',4.57),('12374','2013-04-19','17:05:00',4.57),('12374','2013-04-19','17:10:00',4.33),('12374','2013-04-19','17:15:00',3.62),('12374','2013-04-19','17:20:00',3.81),('12374','2013-04-19','17:25:00',3.78),('12374','2013-04-19','17:30:00',3.67),('12374','2013-04-19','17:35:00',3.08),('12374','2013-04-19','17:40:00',3.69),('12374','2013-04-19','17:45:00',3.64),('12374','2013-04-19','17:50:00',2.85),('12374','2013-04-19','17:55:00',2.41),('12374','2013-04-19','18:00:00',2.48),('12374','2013-04-19','18:05:00',2.28),('12374','2013-04-19','18:10:00',2.04),('12374','2013-04-19','18:15:00',1.87),('12374','2013-04-19','18:20:00',1.77),('12374','2013-04-19','18:25:00',1.53),('12374','2013-04-19','18:30:00',1.38),('12374','2013-04-19','18:35:00',1.26),('12374','2013-04-19','18:40:00',1.18),('12374','2013-04-18','07:50:00',1.02),('12374','2013-04-18','07:55:00',1.42),('12374','2013-04-18','08:00:00',1.88),('12374','2013-04-18','08:05:00',2.44),('12374','2013-04-18','08:10:00',2.93),('12374','2013-04-18','08:15:00',2.97),('12374','2013-04-18','08:20:00',3.4),('12374','2013-04-18','08:25:00',3.44),('12374','2013-04-18','08:30:00',4.04),('12374','2013-04-18','08:35:00',3.75),('12374','2013-04-18','08:40:00',3.78),('12374','2013-04-18','08:45:00',3.39),('12374','2013-04-18','08:50:00',3.24),('12374','2013-04-18','08:55:00',3.96),('12374','2013-04-18','09:00:00',4.63),('12374','2013-04-18','09:05:00',5.06),('12374','2013-04-18','09:10:00',5.24),('12374','2013-04-18','09:15:00',5.37),('12374','2013-04-18','09:20:00',5.53),('12374','2013-04-18','09:25:00',5.66),('12374','2013-04-18','09:30:00',5.74),('12374','2013-04-18','09:35:00',5.87),('12374','2013-04-18','09:40:00',5.94),('12374','2013-04-18','09:45:00',6.08),('12374','2013-04-18','09:50:00',6.19),('12374','2013-04-18','09:55:00',6.31),('12374','2013-04-18','10:00:00',6.46),('12374','2013-04-18','10:05:00',6.62),('12374','2013-04-18','10:10:00',6.74),('12374','2013-04-18','10:15:00',6.85),('12374','2013-04-18','10:20:00',6.92),('12374','2013-04-18','10:25:00',7.02),('12374','2013-04-18','10:30:00',7.11),('12374','2013-04-18','10:35:00',6.15),('12374','2013-04-18','10:45:00',5.28),('12374','2013-04-18','10:50:00',7.47),('12374','2013-04-18','10:55:00',7.6),('12374','2013-04-18','11:00:00',7.62),('12374','2013-04-18','11:05:00',5.05),('12374','2013-04-18','11:10:00',7.81),('12374','2013-04-18','11:15:00',8),('12374','2013-04-18','11:20:00',8.12),('12374','2013-04-18','11:25:00',6.06),('12374','2013-04-18','11:30:00',7.45),('12374','2013-04-18','11:35:00',8.35),('12374','2013-04-18','11:40:00',8.41),('12374','2013-04-18','11:45:00',7.16),('12374','2013-04-18','11:50:00',6.77),('12374','2013-04-18','11:55:00',8.66),('12374','2013-04-18','12:00:00',8.72),('12374','2013-04-18','12:05:00',8.12),('12374','2013-04-18','12:10:00',6.57),('12374','2013-04-18','12:15:00',8.31),('12374','2013-04-18','12:20:00',8.96),('12374','2013-04-18','12:25:00',9),('12374','2013-04-18','12:30:00',9.07),('12374','2013-04-18','12:35:00',9.04),('12374','2013-04-18','12:40:00',9.07),('12374','2013-04-18','12:45:00',9.09),('12374','2013-04-18','12:50:00',9.09),('12374','2013-04-18','12:55:00',9.08),('12374','2013-04-18','13:00:00',9.13),('12374','2013-04-18','13:05:00',9.12),('12374','2013-04-18','13:10:00',9.05),('12374','2013-04-18','13:15:00',9.06),('12374','2013-04-18','13:20:00',9.01),('12374','2013-04-18','13:25:00',8.92),('12374','2013-04-18','13:30:00',8.78),('12374','2013-04-18','13:35:00',9.06),('12374','2013-04-18','13:40:00',9.02),('12374','2013-04-18','13:45:00',9.02),('12374','2013-04-18','13:50:00',8.9),('12374','2013-04-18','13:55:00',8.86),('12374','2013-04-18','14:00:00',8.65),('12374','2013-04-18','14:05:00',8.74),('12374','2013-04-18','14:10:00',8.56),('12374','2013-04-18','14:15:00',8.57),('12374','2013-04-18','14:20:00',8.52),('12374','2013-04-18','14:25:00',8.42),('12374','2013-04-18','14:30:00',8.41),('12374','2013-04-18','14:35:00',8.29),('12374','2013-04-18','14:40:00',8.2),('12374','2013-04-18','14:45:00',8.23),('12374','2013-04-18','14:50:00',8.11),('12374','2013-04-18','14:55:00',7.85),('12374','2013-04-18','15:00:00',7.66),('12374','2013-04-18','15:05:00',7.48),('12374','2013-04-18','15:10:00',7.69),('12374','2013-04-18','15:15:00',7.46),('12374','2013-04-18','15:20:00',7.49),('12374','2013-04-18','15:25:00',7.38),('12374','2013-04-18','15:30:00',7.2),('12374','2013-04-18','15:35:00',7),('12374','2013-04-18','15:40:00',6.98),('12374','2013-04-18','15:45:00',6.9),('12374','2013-04-18','15:50:00',6.77),('12374','2013-04-18','15:55:00',6.62),('12374','2013-04-18','16:00:00',6.53),('12374','2013-04-18','16:05:00',6.42),('12374','2013-04-18','16:10:00',6.29),('12374','2013-04-18','16:15:00',6.11),('12374','2013-04-18','16:20:00',5.93),('12374','2013-04-18','16:25:00',5.8),('12374','2013-04-18','16:30:00',5.68),('12374','2013-04-18','16:35:00',5.56),('12374','2013-04-18','16:40:00',5.38),('12374','2013-04-18','16:45:00',5.25),('12374','2013-04-18','16:50:00',5.09),('12374','2013-04-18','16:55:00',4.93),('12374','2013-04-18','17:00:00',4.71),('12374','2013-04-18','17:05:00',4.54),('12374','2013-04-18','17:10:00',4.36),('12374','2013-04-18','17:15:00',4.17),('12374','2013-04-18','17:20:00',3.93),('12374','2013-04-18','17:25:00',3.76),('12374','2013-04-18','17:30:00',3.59),('12374','2013-04-18','17:35:00',3.36),('12374','2013-04-18','17:40:00',3.19),('12374','2013-04-18','17:45:00',2.98),('12374','2013-04-18','17:50:00',2.8),('12374','2013-04-18','17:55:00',2.63),('12374','2013-04-18','18:00:00',2.44),('12374','2013-04-18','18:05:00',2.25),('12374','2013-04-18','18:10:00',1.98),('12374','2013-04-18','18:15:00',1.86),('12374','2013-04-18','18:20:00',1.71),('12374','2013-04-18','18:25:00',1.54),('12374','2013-04-18','18:30:00',1.39),('12374','2013-04-18','18:35:00',1.29),('12374','2013-04-18','18:40:00',1.2),('12374','2013-04-18','18:45:00',1.1),('12374','2013-04-18','18:50:00',1.01),('12374','2013-04-17','07:20:00',1.02),('12374','2013-04-17','07:25:00',1.09),('12374','2013-04-17','07:35:00',1.02),('12374','2013-04-17','07:40:00',1.14),('12374','2013-04-17','07:45:00',1.06),('12374','2013-04-17','07:50:00',1.27),('12374','2013-04-17','07:55:00',1.71),('12374','2013-04-17','08:00:00',1.9),('12374','2013-04-17','08:05:00',2.29),('12374','2013-04-17','08:10:00',2.81),('12374','2013-04-17','08:15:00',3.22),('12374','2013-04-17','08:20:00',3.42),('12374','2013-04-17','08:25:00',3.61),('12374','2013-04-17','08:30:00',3.76),('12374','2013-04-17','08:35:00',3.93),('12374','2013-04-17','08:40:00',4.11),('12374','2013-04-17','08:45:00',4.29),('12374','2013-04-17','08:50:00',4.48),('12374','2013-04-17','08:55:00',4.65),('12374','2013-04-17','09:00:00',4.79),('12374','2013-04-17','09:05:00',4.91),('12374','2013-04-17','09:10:00',5.07),('12374','2013-04-17','09:15:00',5.21),('12374','2013-04-17','09:20:00',5.35),('12374','2013-04-17','09:25:00',5.51),('12374','2013-04-17','09:30:00',5.65),('12374','2013-04-17','09:35:00',5.8),('12374','2013-04-17','09:40:00',5.94),('12374','2013-04-17','09:45:00',6.05),('12374','2013-04-17','09:50:00',6.21),('12374','2013-04-17','09:55:00',6.29),('12374','2013-04-17','10:00:00',6.46),('12374','2013-04-17','10:05:00',6.59),('12374','2013-04-17','10:10:00',6.71),('12374','2013-04-17','10:15:00',6.82),('12374','2013-04-17','10:20:00',6.93),('12374','2013-04-17','10:25:00',7.04),('12374','2013-04-17','10:30:00',7.16),('12374','2013-04-17','10:35:00',7.26),('12374','2013-04-17','10:40:00',7.32),('12374','2013-04-17','10:45:00',7.45),('12374','2013-04-17','10:50:00',7.52),('12374','2013-04-17','10:55:00',7.56),('12374','2013-04-17','11:00:00',7.7),('12374','2013-04-17','11:05:00',7.74),('12374','2013-04-17','11:10:00',7.84),('12374','2013-04-17','11:15:00',7.98),('12374','2013-04-17','11:20:00',8.13),('12374','2013-04-17','11:25:00',8.17),('12374','2013-04-17','11:30:00',8.25),('12374','2013-04-17','11:35:00',8.29),('12374','2013-04-17','11:40:00',8.43),('12374','2013-04-17','11:45:00',8.56),('12374','2013-04-17','11:50:00',8.63),('12374','2013-04-17','11:55:00',8.68),('12374','2013-04-17','12:00:00',8.77),('12374','2013-04-17','12:05:00',8.83),('12374','2013-04-17','12:10:00',8.86),('12374','2013-04-17','12:15:00',8.89),('12374','2013-04-17','12:20:00',9.01),('12374','2013-04-17','12:25:00',8.99),('12374','2013-04-17','12:30:00',9.02),('12374','2013-04-17','12:35:00',8.95),('12374','2013-04-17','12:40:00',9.02),('12374','2013-04-17','12:45:00',8.94),('12374','2013-04-17','12:50:00',9),('12374','2013-04-17','12:55:00',9.1),('12374','2013-04-17','13:00:00',8.6),('12374','2013-04-17','13:05:00',8.55),('12374','2013-04-17','13:10:00',8.76),('12374','2013-04-17','13:15:00',8.21),('12374','2013-04-17','13:20:00',8.24),('12374','2013-04-17','13:25:00',8.13),('12374','2013-04-17','13:30:00',8.1),('12374','2013-04-17','13:35:00',9.08),('12374','2013-04-17','13:40:00',8.81),('12374','2013-04-17','13:45:00',8.43),('12374','2013-04-17','13:50:00',8.32),('12374','2013-04-17','13:55:00',8),('12374','2013-04-17','14:00:00',6.93),('12374','2013-04-17','14:05:00',8.01),('12374','2013-04-17','14:10:00',8.45),('12374','2013-04-17','14:15:00',8.21),('12374','2013-04-17','14:20:00',8.76),('12374','2013-04-17','14:25:00',8.76),('12374','2013-04-17','14:30:00',8.71),('12374','2013-04-17','14:35:00',8.73),('12374','2013-04-17','14:40:00',8.77),('12374','2013-04-17','14:45:00',8.91),('12374','2013-04-17','14:50:00',8.54),('12374','2013-04-17','14:55:00',7.7),('12374','2013-04-17','15:00:00',7.46),('12374','2013-04-17','15:05:00',7.1),('12374','2013-04-17','15:10:00',8.02),('12374','2013-04-17','15:15:00',8.61),('12374','2013-04-17','15:20:00',7.97),('12374','2013-04-17','15:25:00',8.25),('12374','2013-04-17','15:30:00',7.98),('12374','2013-04-17','15:35:00',7.69),('12374','2013-04-17','15:40:00',7.58),('12374','2013-04-17','15:45:00',7.3),('12374','2013-04-17','15:50:00',6.78),('12374','2013-04-17','15:55:00',6.81),('12374','2013-04-17','16:00:00',6.65),('12374','2013-04-17','16:05:00',6.44),('12374','2013-04-17','16:10:00',6.34),('12374','2013-04-17','16:15:00',6.19),('12374','2013-04-17','16:20:00',6.03),('12374','2013-04-17','16:25:00',5.86),('12374','2013-04-17','16:30:00',5.71),('12374','2013-04-17','16:35:00',5.56),('12374','2013-04-17','16:40:00',5.38),('12374','2013-04-17','16:45:00',5.24),('12374','2013-04-17','16:50:00',5.11),('12374','2013-04-17','16:55:00',4.97),('12374','2013-04-17','17:00:00',4.77),('12374','2013-04-17','17:05:00',4.58),('12374','2013-04-17','17:10:00',4.39),('12374','2013-04-17','17:15:00',4.2),('12374','2013-04-17','17:20:00',3.97),('12374','2013-04-17','17:25:00',3.83),('12374','2013-04-17','17:30:00',3.63),('12374','2013-04-17','17:35:00',3.47),('12374','2013-04-17','17:40:00',3.32),('12374','2013-04-17','17:45:00',3.13),('12374','2013-04-17','17:50:00',2.98),('12374','2013-04-17','17:55:00',2.79),('12374','2013-04-17','18:00:00',2.61),('12374','2013-04-17','18:05:00',2.39),('12374','2013-04-17','18:10:00',2.17),('12374','2013-04-17','18:15:00',2.02),('12374','2013-04-17','18:20:00',1.82),('12374','2013-04-17','18:25:00',1.58),('12374','2013-04-17','18:30:00',1.44),('12374','2013-04-17','18:35:00',1.3),('12374','2013-04-17','18:40:00',1.21),('12374','2013-04-17','18:45:00',1.12),('12374','2013-04-17','18:50:00',1.03),('12374','2013-04-16','07:15:00',1.04),('12374','2013-04-16','07:20:00',1.09),('12374','2013-04-16','07:25:00',1.13),('12374','2013-04-16','07:30:00',1.22),('12374','2013-04-16','07:40:00',1.05),('12374','2013-04-16','07:45:00',1.16),('12374','2013-04-16','07:50:00',1.28),('12374','2013-04-16','07:55:00',1.55),('12374','2013-04-16','08:00:00',1.82),('12374','2013-04-16','08:05:00',2.04),('12374','2013-04-16','08:10:00',2.63),('12374','2013-04-16','08:15:00',3.03),('12374','2013-04-16','08:20:00',3.22),('12374','2013-04-16','08:25:00',3.4),('12374','2013-04-16','08:30:00',3.47),('12374','2013-04-16','08:35:00',2.72),('12374','2013-04-16','08:40:00',2.34),('12374','2013-04-16','08:45:00',1.55),('12374','2013-04-16','08:50:00',2.66),('12374','2013-04-16','08:55:00',4.48),('12374','2013-04-16','09:00:00',4.86),('12374','2013-04-16','09:05:00',4.71),('12374','2013-04-16','09:10:00',3.94),('12374','2013-04-16','09:15:00',5.88),('12374','2013-04-16','09:20:00',4.27),('12374','2013-04-16','09:25:00',3.08),('12374','2013-04-16','09:30:00',3.45),('12374','2013-04-16','09:35:00',4.3),('12374','2013-04-16','09:40:00',3.55),('12374','2013-04-16','09:45:00',3.7),('12374','2013-04-16','09:50:00',3.13),('12374','2013-04-16','09:55:00',3.13),('12374','2013-04-16','10:00:00',3.41),('12374','2013-04-16','10:05:00',3.27),('12374','2013-04-16','10:10:00',2.96),('12374','2013-04-16','10:15:00',2.81),('12374','2013-04-16','10:20:00',3.1),('12374','2013-04-16','10:25:00',3.09),('12374','2013-04-16','10:30:00',2.71),('12374','2013-04-16','10:35:00',2.57),('12374','2013-04-16','10:40:00',2.82),('12374','2013-04-16','10:45:00',2.87),('12374','2013-04-16','10:50:00',2.85),('12374','2013-04-16','10:55:00',2.75),('12374','2013-04-16','11:00:00',2.73),('12374','2013-04-16','11:05:00',2.9),('12374','2013-04-16','11:10:00',3.23),('12374','2013-04-16','11:15:00',3.68),('12374','2013-04-16','11:20:00',3.95),('12374','2013-04-16','11:25:00',4.38),('12374','2013-04-16','11:30:00',5.25),('12374','2013-04-16','11:35:00',5.78),('12374','2013-04-16','11:40:00',5.82),('12374','2013-04-16','11:45:00',6.43),('12374','2013-04-16','11:50:00',6.1),('12374','2013-04-16','11:55:00',7.19),('12374','2013-04-16','12:00:00',7.35),('12374','2013-04-16','12:05:00',7.39),('12374','2013-04-16','12:10:00',7.6),('12374','2013-04-16','12:15:00',6.64),('12374','2013-04-16','12:20:00',8.43),('12374','2013-04-16','12:25:00',9.67),('12374','2013-04-16','12:30:00',7.65),('12374','2013-04-16','12:35:00',6.81),('12374','2013-04-16','12:40:00',8.68),('12374','2013-04-16','12:45:00',9.01),('12374','2013-04-16','12:50:00',8.95),('12374','2013-04-16','12:55:00',8.99),('12374','2013-04-16','13:00:00',9.05),('12374','2013-04-16','13:05:00',9.17),('12374','2013-04-16','13:10:00',9.16),('12374','2013-04-16','13:15:00',9.15),('12374','2013-04-16','13:20:00',9.04),('12374','2013-04-16','13:25:00',9.03),('12374','2013-04-16','13:30:00',9.09),('12374','2013-04-16','13:35:00',8.83),('12374','2013-04-16','13:40:00',8.74),('12374','2013-04-16','13:45:00',8.29),('12374','2013-04-16','13:50:00',8.58),('12374','2013-04-16','13:55:00',9.07),('12374','2013-04-16','14:00:00',9.08),('12374','2013-04-16','14:05:00',8.93),('12374','2013-04-16','14:10:00',8.96),('12374','2013-04-16','14:15:00',7.28),('12374','2013-04-16','14:20:00',8.64),('12374','2013-04-16','14:25:00',8.38),('12374','2013-04-16','14:30:00',8.49),('12374','2013-04-16','14:35:00',8.26),('12374','2013-04-16','14:40:00',6.11),('12374','2013-04-16','14:45:00',3.68),('12374','2013-04-16','14:50:00',5.46),('12374','2013-04-16','14:55:00',8.45),('12374','2013-04-16','15:00:00',8.26),('12374','2013-04-16','15:05:00',7.8),('12374','2013-04-16','15:10:00',7.59),('12374','2013-04-16','15:15:00',6.3),('12374','2013-04-16','15:20:00',7.3),('12374','2013-04-16','15:25:00',6.07),('12374','2013-04-16','15:30:00',6.26),('12374','2013-04-16','15:35:00',7.11),('12374','2013-04-16','15:40:00',7.06),('12374','2013-04-16','15:45:00',6.91),('12374','2013-04-16','15:50:00',6.78),('12374','2013-04-16','15:55:00',6.68),('12374','2013-04-16','16:00:00',6.57),('12374','2013-04-16','16:05:00',6.49),('12374','2013-04-16','16:10:00',5.93),('12374','2013-04-16','16:15:00',4.2),('12374','2013-04-16','16:20:00',4.61),('12374','2013-04-16','16:25:00',5.15),('12374','2013-04-16','16:30:00',5.89),('12374','2013-04-16','16:35:00',5.63),('12374','2013-04-16','16:40:00',5.62),('12374','2013-04-16','16:45:00',5.37),('12374','2013-04-16','16:50:00',5.08),('12374','2013-04-16','16:55:00',4.84),('12374','2013-04-16','17:00:00',4.6),('12374','2013-04-16','17:05:00',4.47),('12374','2013-04-16','17:10:00',4.32),('12374','2013-04-16','17:15:00',4.14),('12374','2013-04-16','17:20:00',3.93),('12374','2013-04-16','17:25:00',3.77),('12374','2013-04-16','17:30:00',3.58),('12374','2013-04-16','17:35:00',3.35),('12374','2013-04-16','17:40:00',3.25),('12374','2013-04-16','17:45:00',3.05),('12374','2013-04-16','17:50:00',2.89),('12374','2013-04-16','17:55:00',2.74),('12374','2013-04-16','18:00:00',2.56),('12374','2013-04-16','18:05:00',2.38),('12374','2013-04-16','18:10:00',2.13),('12374','2013-04-16','18:15:00',1.87),('12374','2013-04-16','18:20:00',1.68),('12374','2013-04-16','18:25:00',1.46),('12374','2013-04-16','18:30:00',1.28),('12374','2013-04-16','18:35:00',1.04),('12374','2013-04-15','07:25:00',1.06),('12374','2013-04-15','07:30:00',1.18),('12374','2013-04-15','07:35:00',1.15),('12374','2013-04-15','07:40:00',1.38),('12374','2013-04-15','07:45:00',1.07),('12374','2013-04-15','07:50:00',1.24),('12374','2013-04-15','07:55:00',1.55),('12374','2013-04-15','08:00:00',1.84),('12374','2013-04-15','08:05:00',2.18),('12374','2013-04-15','08:10:00',2.74),('12374','2013-04-15','08:15:00',3.21),('12374','2013-04-15','08:20:00',3.43),('12374','2013-04-15','08:25:00',3.63),('12374','2013-04-15','08:30:00',3.81),('12374','2013-04-15','08:35:00',3.98),('12374','2013-04-15','08:40:00',4.16),('12374','2013-04-15','08:45:00',4.31),('12374','2013-04-15','08:50:00',4.5),('12374','2013-04-15','08:55:00',4.65),('12374','2013-04-15','09:00:00',4.79),('12374','2013-04-15','09:05:00',4.92),('12374','2013-04-15','09:10:00',5.1),('12374','2013-04-15','09:15:00',5.09),('12374','2013-04-15','09:20:00',5.24),('12374','2013-04-15','09:25:00',5.45),('12374','2013-04-15','09:30:00',5.64),('12374','2013-04-15','09:35:00',5.74),('12374','2013-04-15','09:40:00',5.91),('12374','2013-04-15','09:45:00',6.03),('12374','2013-04-15','09:50:00',6.19),('12374','2013-04-15','09:55:00',6.33),('12374','2013-04-15','10:00:00',6.47),('12374','2013-04-15','10:05:00',6.58),('12374','2013-04-15','10:10:00',6.67),('12374','2013-04-15','10:15:00',6.72),('12374','2013-04-15','10:20:00',6.92),('12374','2013-04-15','10:25:00',7.04),('12374','2013-04-15','10:30:00',7.14),('12374','2013-04-15','10:35:00',7.18),('12374','2013-04-15','10:40:00',7.3),('12374','2013-04-15','10:45:00',7.38),('12374','2013-04-15','10:50:00',7.44),('12374','2013-04-15','10:55:00',7.56),('12374','2013-04-15','11:00:00',7.61),('12374','2013-04-15','11:05:00',7.72),('12374','2013-04-15','11:10:00',7.76),('12374','2013-04-15','11:15:00',7.91),('12374','2013-04-15','11:20:00',8),('12374','2013-04-15','11:25:00',8.1),('12374','2013-04-15','11:30:00',8.2),('12374','2013-04-15','11:35:00',8.27),('12374','2013-04-15','11:40:00',8.33),('12374','2013-04-15','11:45:00',8.43),('12374','2013-04-15','11:50:00',8.46),('12374','2013-04-15','11:55:00',8.52),('12374','2013-04-15','12:00:00',8.6),('12374','2013-04-15','12:05:00',8.67),('12374','2013-04-15','12:10:00',8.7),('12374','2013-04-15','12:15:00',8.83),('12374','2013-04-15','12:20:00',8.91),('12374','2013-04-15','12:25:00',8.98),('12374','2013-04-15','12:30:00',9.02),('12374','2013-04-15','12:35:00',9.06),('12374','2013-04-15','12:40:00',9.09),('12374','2013-04-15','12:45:00',9.05),('12374','2013-04-15','12:50:00',9.09),('12374','2013-04-15','12:55:00',9.09),('12374','2013-04-15','13:00:00',9.13),('12374','2013-04-15','13:05:00',9.18),('12374','2013-04-15','13:10:00',9.19),('12374','2013-04-15','13:15:00',9.19),('12374','2013-04-15','13:20:00',9.16),('12374','2013-04-15','13:25:00',8.92),('12374','2013-04-15','13:30:00',9.15),('12374','2013-04-15','13:35:00',9.04),('12374','2013-04-15','13:40:00',9),('12374','2013-04-15','13:45:00',9),('12374','2013-04-15','13:50:00',9.01),('12374','2013-04-15','13:55:00',8.98),('12374','2013-04-15','14:00:00',8.83),('12374','2013-04-15','14:05:00',8.87),('12374','2013-04-15','14:10:00',8.79),('12374','2013-04-15','14:15:00',8.73),('12374','2013-04-15','14:20:00',8.65),('12374','2013-04-15','14:25:00',8.59),('12374','2013-04-15','14:30:00',8.49),('12374','2013-04-15','14:35:00',8.37),('12374','2013-04-15','14:40:00',8.3),('12374','2013-04-15','14:45:00',8.25),('12374','2013-04-15','14:50:00',8.14),('12374','2013-04-15','14:55:00',8.06),('12374','2013-04-15','15:00:00',7.97),('12374','2013-04-15','15:05:00',7.87),('12374','2013-04-15','15:10:00',7.76),('12374','2013-04-15','15:15:00',7.65),('12374','2013-04-15','15:20:00',7.52),('12374','2013-04-15','15:25:00',7.41),('12374','2013-04-15','15:30:00',7.3),('12374','2013-04-15','15:35:00',7.19),('12374','2013-04-15','15:40:00',7.08),('12374','2013-04-15','15:45:00',6.94),('12374','2013-04-15','15:50:00',6.81),('12374','2013-04-15','15:55:00',6.68),('12374','2013-04-15','16:00:00',6.56),('12374','2013-04-15','16:05:00',6.42),('12374','2013-04-15','16:10:00',6.29),('12374','2013-04-15','16:15:00',6.12),('12374','2013-04-15','16:20:00',6.01),('12374','2013-04-15','16:25:00',5.87),('12374','2013-04-15','16:30:00',5.74),('12374','2013-04-15','16:35:00',5.59),('12374','2013-04-15','16:40:00',5.45),('12374','2013-04-15','16:45:00',5.25),('12374','2013-04-15','16:50:00',5.09),('12374','2013-04-15','16:55:00',4.92),('12374','2013-04-15','17:00:00',4.74),('12374','2013-04-15','17:05:00',4.58),('12374','2013-04-15','17:10:00',4.42),('12374','2013-04-15','17:15:00',4.21),('12374','2013-04-15','17:20:00',3.99),('12374','2013-04-15','17:25:00',3.84),('12374','2013-04-15','17:30:00',3.67),('12374','2013-04-15','17:35:00',3.48),('12374','2013-04-15','17:40:00',3.33),('12374','2013-04-15','17:45:00',3.15),('12374','2013-04-15','17:50:00',2.99),('12374','2013-04-15','17:55:00',2.82),('12374','2013-04-15','18:00:00',2.65),('12374','2013-04-15','18:05:00',2.44),('12374','2013-04-15','18:10:00',2.23),('12374','2013-04-15','18:15:00',2.02),('12374','2013-04-15','18:20:00',1.81),('12374','2013-04-15','18:25:00',1.64),('12374','2013-04-15','18:30:00',1.49),('12374','2013-04-15','18:35:00',1.34),('12374','2013-04-15','18:40:00',1.23),('12374','2013-04-15','18:45:00',1.14),('12374','2013-04-15','18:50:00',1.05),('12374','2013-04-14','07:30:00',1.22),('12374','2013-04-14','07:35:00',1.13),('12374','2013-04-14','07:40:00',1.42),('12374','2013-04-14','07:45:00',1.37),('12374','2013-04-14','07:50:00',1.48),('12374','2013-04-14','07:55:00',1.55),('12374','2013-04-14','08:00:00',1.73),('12374','2013-04-14','08:05:00',2.05),('12374','2013-04-14','08:10:00',2.56),('12374','2013-04-14','08:15:00',3.05),('12374','2013-04-14','08:20:00',3.24),('12374','2013-04-14','08:25:00',3.46),('12374','2013-04-14','08:30:00',3.65),('12374','2013-04-14','08:35:00',3.82),('12374','2013-04-14','08:40:00',3.99),('12374','2013-04-14','08:45:00',4.14),('12374','2013-04-14','08:50:00',4.29),('12374','2013-04-14','08:55:00',4.45),('12374','2013-04-14','09:00:00',4.63),('12374','2013-04-14','09:05:00',4.78),('12374','2013-04-14','09:10:00',4.94),('12374','2013-04-14','09:15:00',5.08),('12374','2013-04-14','09:20:00',5.23),('12374','2013-04-14','09:25:00',5.37),('12374','2013-04-14','09:30:00',5.51),('12374','2013-04-14','09:35:00',5.65),('12374','2013-04-14','09:40:00',5.81),('12374','2013-04-14','09:45:00',5.99),('12374','2013-04-14','09:50:00',6.12),('12374','2013-04-14','09:55:00',6.24),('12374','2013-04-14','10:00:00',6.36),('12374','2013-04-14','10:05:00',6.5),('12374','2013-04-14','10:10:00',6.62),('12374','2013-04-14','10:15:00',6.68),('12374','2013-04-14','10:20:00',6.81),('12374','2013-04-14','10:25:00',6.96),('12374','2013-04-14','10:30:00',7.06),('12374','2013-04-14','10:35:00',7.16),('12374','2013-04-14','10:40:00',7.24),('12374','2013-04-14','10:45:00',7.36),('12374','2013-04-14','10:50:00',7.47),('12374','2013-04-14','10:55:00',7.55),('12374','2013-04-14','11:00:00',7.55),('12374','2013-04-14','11:05:00',7.68),('12374','2013-04-14','11:10:00',7.79),('12374','2013-04-14','11:15:00',7.82),('12374','2013-04-14','11:20:00',7.98),('12374','2013-04-14','11:25:00',8.1),('12374','2013-04-14','11:30:00',8.21),('12374','2013-04-14','11:35:00',8.32),('12374','2013-04-14','11:40:00',8.38),('12374','2013-04-14','11:45:00',8.5),('12374','2013-04-14','11:50:00',8.58),('12374','2013-04-14','11:55:00',8.61),('12374','2013-04-14','12:00:00',8.65),('12374','2013-04-14','12:05:00',8.71),('12374','2013-04-14','12:10:00',8.8),('12374','2013-04-14','12:15:00',8.87),('12374','2013-04-14','12:20:00',8.9),('12374','2013-04-14','12:25:00',8.93),('12374','2013-04-14','12:30:00',8.97),('12374','2013-04-14','12:35:00',9.02),('12374','2013-04-14','12:40:00',9.03),('12374','2013-04-14','12:45:00',9.04),('12374','2013-04-14','12:50:00',9.03),('12374','2013-04-14','12:55:00',9),('12374','2013-04-14','13:00:00',9.09),('12374','2013-04-14','13:05:00',9.12),('12374','2013-04-14','13:10:00',9.05),('12374','2013-04-14','13:15:00',8.92),('12374','2013-04-14','13:20:00',9.08),('12374','2013-04-14','13:25:00',9.1),('12374','2013-04-14','13:30:00',9.09),('12374','2013-04-14','13:35:00',9.08),('12374','2013-04-14','13:40:00',9.06),('12374','2013-04-14','13:45:00',8.97),('12374','2013-04-14','13:50:00',8.88),('12374','2013-04-14','13:55:00',8.8),('12374','2013-04-14','14:00:00',8.77),('12374','2013-04-14','14:05:00',8.76),('12374','2013-04-14','14:10:00',8.67),('12374','2013-04-14','14:15:00',8.62),('12374','2013-04-14','14:20:00',8.56),('12374','2013-04-14','14:25:00',8.52),('12374','2013-04-14','14:30:00',8.44),('12374','2013-04-14','14:35:00',8.33),('12374','2013-04-14','14:40:00',8.22),('12374','2013-04-14','14:45:00',8.13),('12374','2013-04-14','14:50:00',8.03),('12374','2013-04-14','14:55:00',7.97),('12374','2013-04-14','15:00:00',7.86),('12374','2013-04-14','15:05:00',7.76),('12374','2013-04-14','15:10:00',7.68),('12374','2013-04-14','15:15:00',7.57),('12374','2013-04-14','15:20:00',7.46),('12374','2013-04-14','15:25:00',7.38),('12374','2013-04-14','15:30:00',7.24),('12374','2013-04-14','15:35:00',7.15),('12374','2013-04-14','15:40:00',7.01),('12374','2013-04-14','15:45:00',6.89),('12374','2013-04-14','15:50:00',6.77),('12374','2013-04-14','15:55:00',6.64),('12374','2013-04-14','16:00:00',6.51),('12374','2013-04-14','16:05:00',6.39),('12374','2013-04-14','16:10:00',6.24),('12374','2013-04-14','16:15:00',6.1),('12374','2013-04-14','16:20:00',5.96),('12374','2013-04-14','16:25:00',5.76),('12374','2013-04-14','16:30:00',5.61),('12374','2013-04-14','16:35:00',5.46),('12374','2013-04-14','16:40:00',5.33),('12374','2013-04-14','16:45:00',5.18),('12374','2013-04-14','16:50:00',5.05),('12374','2013-04-14','16:55:00',4.88),('12374','2013-04-14','17:00:00',4.71),('12374','2013-04-14','17:05:00',4.52),('12374','2013-04-14','17:10:00',4.37),('12374','2013-04-14','17:15:00',4.17),('12374','2013-04-14','17:20:00',3.95),('12374','2013-04-14','17:25:00',3.8),('12374','2013-04-14','17:30:00',3.61),('12374','2013-04-14','17:35:00',3.42),('12374','2013-04-14','17:40:00',3.27),('12374','2013-04-14','17:45:00',3.08),('12374','2013-04-14','17:50:00',2.94),('12374','2013-04-14','17:55:00',2.75),('12374','2013-04-14','18:00:00',2.58),('12374','2013-04-14','18:05:00',2.35),('12374','2013-04-14','18:10:00',2.19),('12374','2013-04-14','18:15:00',1.96),('12374','2013-04-14','18:20:00',1.76),('12374','2013-04-14','18:25:00',1.56),('12374','2013-04-14','18:30:00',1.44),('12374','2013-04-14','18:35:00',1.33),('12374','2013-04-14','18:40:00',1.22),('12374','2013-04-14','18:45:00',1.13),('12374','2013-04-14','18:50:00',1.02),('12374','2013-04-13','07:35:00',1),('12374','2013-04-13','07:40:00',1.19),('12374','2013-04-13','07:55:00',1),('12374','2013-04-13','08:00:00',1.7),('12374','2013-04-13','08:05:00',2.09),('12374','2013-04-13','08:10:00',2.3),('12374','2013-04-13','08:15:00',2.98),('12374','2013-04-13','08:20:00',3.24),('12374','2013-04-13','08:25:00',3.45),('12374','2013-04-13','08:30:00',3.61),('12374','2013-04-13','08:35:00',3.68),('12374','2013-04-13','08:40:00',3.85),('12374','2013-04-13','08:45:00',4.14),('12374','2013-04-13','08:50:00',4.59),('12374','2013-04-13','08:55:00',4.87),('12374','2013-04-13','09:00:00',5.16),('12374','2013-04-13','09:05:00',5.24),('12374','2013-04-13','09:10:00',5.1),('12374','2013-04-13','09:15:00',2.97),('12374','2013-04-13','09:20:00',5.94),('12374','2013-04-13','09:25:00',6.26),('12374','2013-04-13','09:30:00',4.71),('12374','2013-04-13','09:35:00',3.85),('12374','2013-04-13','09:40:00',5.26),('12374','2013-04-13','09:45:00',6.17),('12374','2013-04-13','09:50:00',6.43),('12374','2013-04-13','09:55:00',6.17),('12374','2013-04-13','10:00:00',5.55),('12374','2013-04-13','10:05:00',6.56),('12374','2013-04-13','10:10:00',6.67),('12374','2013-04-13','10:15:00',6.82),('12374','2013-04-13','10:20:00',6.87),('12374','2013-04-13','10:25:00',7.03),('12374','2013-04-13','10:30:00',7.11),('12374','2013-04-13','10:35:00',7.24),('12374','2013-04-13','10:40:00',7.2),('12374','2013-04-13','10:45:00',7.01),('12374','2013-04-13','10:50:00',7.5),('12374','2013-04-13','10:55:00',7.68),('12374','2013-04-13','11:00:00',7.84),('12374','2013-04-13','11:05:00',7.77),('12374','2013-04-13','11:10:00',8.02),('12374','2013-04-13','11:15:00',8.07),('12374','2013-04-13','11:20:00',8),('12374','2013-04-13','11:25:00',7.17),('12374','2013-04-13','11:30:00',7.98),('12374','2013-04-13','11:35:00',8.16),('12374','2013-04-13','11:40:00',8.31),('12374','2013-04-13','11:45:00',8.47),('12374','2013-04-13','11:50:00',8.53),('12374','2013-04-13','11:55:00',8.57),('12374','2013-04-13','12:00:00',8.67),('12374','2013-04-13','12:05:00',8.67),('12374','2013-04-13','12:10:00',8.9),('12374','2013-04-13','12:15:00',8.85),('12374','2013-04-13','12:20:00',8.83),('12374','2013-04-13','12:25:00',9.03),('12374','2013-04-13','12:30:00',9.15),('12374','2013-04-13','12:35:00',9.05),('12374','2013-04-13','12:40:00',9.01),('12374','2013-04-13','12:45:00',9.13),('12374','2013-04-13','12:50:00',8.83),('12374','2013-04-13','12:55:00',8.24),('12374','2013-04-13','13:00:00',7.99),('12374','2013-04-13','13:05:00',7.85),('12374','2013-04-13','13:10:00',8.3),('12374','2013-04-13','13:15:00',8.69),('12374','2013-04-13','13:20:00',8.49),('12374','2013-04-13','13:25:00',8.42),('12374','2013-04-13','13:30:00',8.32),('12374','2013-04-13','13:35:00',7.84),('12374','2013-04-13','13:40:00',7.8),('12374','2013-04-13','13:45:00',8.2),('12374','2013-04-13','13:50:00',8.23),('12374','2013-04-13','13:55:00',8.32),('12374','2013-04-13','14:00:00',8.26),('12374','2013-04-13','14:05:00',8.12),('12374','2013-04-13','14:10:00',7.95),('12374','2013-04-13','14:15:00',7.86),('12374','2013-04-13','14:20:00',7.73),('12374','2013-04-13','14:25:00',7.87),('12374','2013-04-13','14:30:00',7.9),('12374','2013-04-13','14:35:00',7.85),('12374','2013-04-13','14:40:00',7.59),('12374','2013-04-13','14:45:00',7.12),('12374','2013-04-13','14:50:00',6.4),('12374','2013-04-13','14:55:00',6.62),('12374','2013-04-13','15:00:00',6.69),('12374','2013-04-13','15:05:00',6.62),('12374','2013-04-13','15:10:00',6.61),('12374','2013-04-13','15:15:00',6.94),('12374','2013-04-13','15:20:00',6.75),('12374','2013-04-13','15:25:00',6.92),('12374','2013-04-13','15:30:00',6.46),('12374','2013-04-13','15:35:00',6.03),('12374','2013-04-13','15:40:00',6.43),('12374','2013-04-13','15:45:00',5.71),('12374','2013-04-13','15:50:00',5.67),('12374','2013-04-13','15:55:00',5.43),('12374','2013-04-13','16:00:00',5.59),('12374','2013-04-13','16:05:00',4.68),('12374','2013-04-13','16:10:00',4.08),('12374','2013-04-13','16:15:00',4.74),('12374','2013-04-13','16:20:00',4.54),('12374','2013-04-13','16:25:00',4.99),('12374','2013-04-13','16:30:00',5.43),('12374','2013-04-13','16:35:00',5.35),('12374','2013-04-13','16:40:00',5.36),('12374','2013-04-13','16:45:00',5.1),('12374','2013-04-13','16:50:00',5.1),('12374','2013-04-13','16:55:00',5.1),('12374','2013-04-13','17:00:00',4.01),('12374','2013-04-13','17:05:00',3.57),('12374','2013-04-13','17:10:00',2.3),('12374','2013-04-13','17:15:00',2.48),('12374','2013-04-13','17:20:00',3),('12374','2013-04-13','17:25:00',3.03),('12374','2013-04-13','17:30:00',4.48),('12374','2013-04-13','17:35:00',3.09),('12374','2013-04-13','17:40:00',2.62),('12374','2013-04-13','17:45:00',2.12),('12374','2013-04-13','17:50:00',1.48),('12374','2013-04-13','17:55:00',1.43),('12374','2013-04-13','18:00:00',1.62),('12374','2013-04-13','18:05:00',1.98),('12374','2013-04-13','18:10:00',1.57),('12374','2013-04-13','18:15:00',1.04),('12374','2013-04-13','18:20:00',1.27),('12374','2013-04-13','18:25:00',1.53),('12374','2013-04-13','18:30:00',1.42),('12374','2013-04-13','18:35:00',1.03),('12374','2013-04-13','18:40:00',1.08),('12374','2013-04-13','18:45:00',1.11),('12374','2013-04-12','08:20:00',1.11),('12374','2013-04-12','08:25:00',1.17),('12374','2013-04-12','08:30:00',1.47),('12374','2013-04-12','08:35:00',2.22),('12374','2013-04-12','08:40:00',1.17),('12374','2013-04-12','08:45:00',2.17),('12374','2013-04-12','08:50:00',2.17),('12374','2013-04-12','08:55:00',4.2),('12374','2013-04-12','09:00:00',2.67),('12374','2013-04-12','09:05:00',1.71),('12374','2013-04-12','09:10:00',4.15),('12374','2013-04-12','09:15:00',3.37),('12374','2013-04-12','09:20:00',1.67),('12374','2013-04-12','09:25:00',1.64),('12374','2013-04-12','09:30:00',4.71),('12374','2013-04-12','09:35:00',4.55),('12374','2013-04-12','09:40:00',3.55),('12374','2013-04-12','09:45:00',4.66),('12374','2013-04-12','09:50:00',5.12),('12374','2013-04-12','09:55:00',4.01),('12374','2013-04-12','10:00:00',2.25),('12374','2013-04-12','10:05:00',1.89),('12374','2013-04-12','10:10:00',1.93),('12374','2013-04-12','10:15:00',1.75),('12374','2013-04-12','10:20:00',1.54),('12374','2013-04-12','10:25:00',2.31),('12374','2013-04-12','10:30:00',5.98),('12374','2013-04-12','10:35:00',2.35),('12374','2013-04-12','10:40:00',2.54),('12374','2013-04-12','10:45:00',2.23),('12374','2013-04-12','10:50:00',3.04),('12374','2013-04-12','10:55:00',5.19),('12374','2013-04-12','11:00:00',6.62),('12374','2013-04-12','11:05:00',4.12),('12374','2013-04-12','11:10:00',4.4),('12374','2013-04-12','11:15:00',7.36),('12374','2013-04-12','11:20:00',8.17),('12374','2013-04-12','11:25:00',7.04),('12374','2013-04-12','11:30:00',5.15),('12374','2013-04-12','11:35:00',5.16),('12374','2013-04-12','11:40:00',6.99),('12374','2013-04-12','11:45:00',9.47),('12374','2013-04-12','11:50:00',5.76),('12374','2013-04-12','11:55:00',4.43),('12374','2013-04-12','12:00:00',3.46),('12374','2013-04-12','12:05:00',4.31),('12374','2013-04-12','12:10:00',5.04),('12374','2013-04-12','12:15:00',6.34),('12374','2013-04-12','12:20:00',8.42),('12374','2013-04-12','12:25:00',8.8),('12374','2013-04-12','12:30:00',7.14),('12374','2013-04-12','12:35:00',9.39),('12374','2013-04-12','12:40:00',9.03),('12374','2013-04-12','12:45:00',7.06),('12374','2013-04-12','12:50:00',9.4),('12374','2013-04-12','12:55:00',9.26),('12374','2013-04-12','13:00:00',9.49),('12374','2013-04-12','13:05:00',9.47),('12374','2013-04-12','13:10:00',9.33),('12374','2013-04-12','13:15:00',9.31),('12374','2013-04-12','13:20:00',9.35),('12374','2013-04-12','13:25:00',9.3),('12374','2013-04-12','13:30:00',8.75),('12374','2013-04-12','13:35:00',9.45),('12374','2013-04-12','13:40:00',9.4),('12374','2013-04-12','13:45:00',9.43),('12374','2013-04-12','13:50:00',9.84),('12374','2013-04-12','13:55:00',9.43),('12374','2013-04-12','14:00:00',6.46),('12374','2013-04-12','14:05:00',8.66),('12374','2013-04-12','14:10:00',9),('12374','2013-04-12','14:15:00',7.82),('12374','2013-04-12','14:20:00',8.82),('12374','2013-04-12','14:25:00',8.79),('12374','2013-04-12','14:30:00',8.63),('12374','2013-04-12','14:35:00',8.46),('12374','2013-04-12','14:40:00',8.34),('12374','2013-04-12','14:45:00',8.3),('12374','2013-04-12','14:50:00',8.2),('12374','2013-04-12','14:55:00',8.09),('12374','2013-04-12','15:00:00',7.99),('12374','2013-04-12','15:05:00',7.87),('12374','2013-04-12','15:10:00',7.77),('12374','2013-04-12','15:15:00',7.66),('12374','2013-04-12','15:20:00',7.57),('12374','2013-04-12','15:25:00',7.46),('12374','2013-04-12','15:30:00',7.35),('12374','2013-04-12','15:35:00',7.21),('12374','2013-04-12','15:40:00',7.06),('12374','2013-04-12','15:45:00',6.95),('12374','2013-04-12','15:50:00',6.82),('12374','2013-04-12','15:55:00',6.68),('12374','2013-04-12','16:00:00',6.54),('12374','2013-04-12','16:05:00',6.4),('12374','2013-04-12','16:10:00',6.28),('12374','2013-04-12','16:15:00',5.98),('12374','2013-04-12','16:20:00',3.7),('12374','2013-04-12','16:25:00',3.93),('12374','2013-04-12','16:30:00',3.98),('12374','2013-04-12','16:35:00',3.44),('12374','2013-04-12','16:40:00',3.43),('12374','2013-04-12','16:45:00',3.15),('12374','2013-04-12','16:50:00',2.88),('12374','2013-04-12','16:55:00',2.8),('12374','2013-04-12','17:00:00',2.67),('12374','2013-04-12','17:05:00',2.35),('12374','2013-04-12','17:10:00',2.32),('12374','2013-04-12','17:15:00',2.4),('12374','2013-04-12','17:20:00',2.93),('12374','2013-04-12','17:25:00',2.68),('12374','2013-04-12','17:30:00',2.44),('12374','2013-04-12','17:35:00',2.48),('12374','2013-04-12','17:40:00',1.53),('12374','2013-04-12','17:45:00',1.46),('12374','2013-04-12','17:50:00',1.34),('12374','2013-04-12','17:55:00',1.12),('12374','2013-04-11','07:25:00',1.05),('12374','2013-04-11','07:30:00',1.2),('12374','2013-04-11','07:35:00',1.37),('12374','2013-04-11','07:40:00',1.43),('12374','2013-04-11','07:45:00',1.54),('12374','2013-04-11','07:50:00',1.22),('12374','2013-04-11','07:55:00',1.41),('12374','2013-04-11','08:00:00',1.17),('12374','2013-04-11','08:05:00',1.95),('12374','2013-04-11','08:10:00',2.32),('12374','2013-04-11','08:15:00',2.51),('12374','2013-04-11','08:20:00',3.24),('12374','2013-04-11','08:25:00',3.33),('12374','2013-04-11','08:30:00',3.31),('12374','2013-04-11','08:35:00',3.81),('12374','2013-04-11','08:40:00',3.96),('12374','2013-04-11','08:45:00',4.11),('12374','2013-04-11','08:50:00',4.19),('12374','2013-04-11','08:55:00',3.63),('12374','2013-04-11','09:00:00',4.67),('12374','2013-04-11','09:05:00',4.84),('12374','2013-04-11','09:10:00',4.97),('12374','2013-04-11','09:15:00',5.14),('12374','2013-04-11','09:20:00',5.31),('12374','2013-04-11','09:25:00',5.46),('12374','2013-04-11','09:30:00',5.57),('12374','2013-04-11','09:35:00',3.6),('12374','2013-04-11','09:40:00',6.27),('12374','2013-04-11','09:45:00',6.41),('12374','2013-04-11','09:50:00',6.32),('12374','2013-04-11','09:55:00',6.53),('12374','2013-04-11','10:00:00',6.69),('12374','2013-04-11','10:05:00',6.85),('12374','2013-04-11','10:10:00',7.14),('12374','2013-04-11','10:15:00',7.21),('12374','2013-04-11','10:20:00',7.53),('12374','2013-04-11','10:25:00',2.76),('12374','2013-04-11','10:30:00',3.8),('12374','2013-04-11','10:35:00',5.5),('12374','2013-04-11','10:40:00',5.48),('12374','2013-04-11','10:45:00',3.74),('12374','2013-04-11','10:50:00',6.95),('12374','2013-04-11','10:55:00',8),('12374','2013-04-11','11:00:00',7.98),('12374','2013-04-11','11:05:00',8.07),('12374','2013-04-11','11:10:00',8.06),('12374','2013-04-11','11:15:00',8.11),('12374','2013-04-11','11:20:00',8.28),('12374','2013-04-11','11:25:00',8.33),('12374','2013-04-11','11:30:00',8.44),('12374','2013-04-11','11:35:00',8.51),('12374','2013-04-11','11:40:00',8.6),('12374','2013-04-11','11:45:00',8.72),('12374','2013-04-11','11:50:00',8.79),('12374','2013-04-11','11:55:00',9.04),('12374','2013-04-11','12:00:00',8.06),('12374','2013-04-11','12:05:00',6.83),('12374','2013-04-11','12:10:00',6.35),('12374','2013-04-11','12:15:00',9.42),('12374','2013-04-11','12:20:00',7.23),('12374','2013-04-11','12:25:00',9.3),('12374','2013-04-11','12:30:00',9.23),('12374','2013-04-11','12:35:00',9.27),('12374','2013-04-11','12:40:00',9.26),('12374','2013-04-11','12:45:00',9.26),('12374','2013-04-11','12:50:00',8.93),('12374','2013-04-11','12:55:00',9.3),('12374','2013-04-11','13:00:00',8.78),('12374','2013-04-11','13:05:00',9.41),('12374','2013-04-11','13:10:00',9.31),('12374','2013-04-11','13:15:00',9.32),('12374','2013-04-11','13:20:00',9.29),('12374','2013-04-11','13:25:00',9.25),('12374','2013-04-11','13:30:00',9.24),('12374','2013-04-11','13:35:00',9.25),('12374','2013-04-11','13:40:00',9.18),('12374','2013-04-11','13:45:00',9.09),('12374','2013-04-11','13:50:00',9.04),('12374','2013-04-11','13:55:00',9.05),('12374','2013-04-11','14:00:00',9.05),('12374','2013-04-11','14:05:00',8.96),('12374','2013-04-11','14:10:00',8.91),('12374','2013-04-11','14:15:00',8.88),('12374','2013-04-11','14:20:00',8.78),('12374','2013-04-11','14:25:00',8.7),('12374','2013-04-11','14:30:00',8.64),('12374','2013-04-11','14:35:00',8.55),('12374','2013-04-11','14:40:00',8.49),('12374','2013-04-11','14:45:00',8.37),('12374','2013-04-11','14:50:00',8.26),('12374','2013-04-11','14:55:00',8.14),('12374','2013-04-11','15:00:00',8.03),('12374','2013-04-11','15:05:00',7.93),('12374','2013-04-11','15:10:00',7.86),('12374','2013-04-11','15:15:00',7.78),('12374','2013-04-11','15:20:00',7.65),('12374','2013-04-11','15:25:00',7.55),('12374','2013-04-11','15:30:00',7.43),('12374','2013-04-11','15:35:00',7.31),('12374','2013-04-11','15:40:00',7.18),('12374','2013-04-11','15:45:00',7.06),('12374','2013-04-11','15:50:00',6.93),('12374','2013-04-11','15:55:00',6.82),('12374','2013-04-11','16:00:00',6.67),('12374','2013-04-11','16:05:00',6.53),('12374','2013-04-11','16:10:00',6.39),('12374','2013-04-11','16:15:00',6.27),('12374','2013-04-11','16:20:00',6.11),('12374','2013-04-11','16:25:00',5.94),('12374','2013-04-11','16:30:00',5.83),('12374','2013-04-11','16:35:00',5.67),('12374','2013-04-11','16:40:00',5.51),('12374','2013-04-11','16:45:00',5.34),('12374','2013-04-11','16:50:00',5.13),('12374','2013-04-11','16:55:00',5.02),('12374','2013-04-11','17:00:00',4.86),('12374','2013-04-11','17:05:00',4.68),('12374','2013-04-11','17:10:00',4.51),('12374','2013-04-11','17:15:00',4.32),('12374','2013-04-11','17:20:00',4.12),('12374','2013-04-11','17:25:00',3.92),('12374','2013-04-11','17:30:00',3.77),('12374','2013-04-11','17:35:00',3.6),('12374','2013-04-11','17:40:00',3.38),('12374','2013-04-11','17:45:00',3.11),('12374','2013-04-11','17:50:00',2.88),('12374','2013-04-11','17:55:00',2.62),('12374','2013-04-11','18:00:00',2.29),('12374','2013-04-11','18:05:00',2.4),('12374','2013-04-11','18:10:00',2.26),('12374','2013-04-11','18:15:00',2.1),('12374','2013-04-11','18:20:00',1.76),('12374','2013-04-11','18:25:00',1.58),('12374','2013-04-11','18:30:00',1.45),('12374','2013-04-11','18:35:00',1.24),('12374','2013-04-10','08:25:00',1.07),('12374','2013-04-10','08:30:00',1.53),('12374','2013-04-10','08:35:00',2.59),('12374','2013-04-10','08:40:00',3.59),('12374','2013-04-10','08:45:00',3.91),('12374','2013-04-10','08:50:00',4.39),('12374','2013-04-10','08:55:00',3.25),('12374','2013-04-10','09:00:00',1.67),('12374','2013-04-10','09:05:00',2.76),('12374','2013-04-10','09:10:00',1.23),('12374','2013-04-10','09:15:00',1.44),('12374','2013-04-10','09:20:00',1.01),('12374','2013-04-10','09:25:00',1.22),('12374','2013-04-10','09:30:00',2.22),('12374','2013-04-10','09:35:00',2.29),('12374','2013-04-10','09:40:00',3.13),('12374','2013-04-10','09:45:00',2.58),('12374','2013-04-10','09:50:00',1.67),('12374','2013-04-10','09:55:00',1.65),('12374','2013-04-10','10:00:00',1.28),('12374','2013-04-10','10:30:00',1.64),('12374','2013-04-10','10:35:00',1.86),('12374','2013-04-10','10:40:00',2.84),('12374','2013-04-10','10:45:00',4.55),('12374','2013-04-10','10:50:00',7.33),('12374','2013-04-10','10:55:00',7.96),('12374','2013-04-10','11:00:00',6.03),('12374','2013-04-10','11:05:00',7.04),('12374','2013-04-10','11:10:00',5.96),('12374','2013-04-10','11:15:00',6.55),('12374','2013-04-10','11:20:00',7.81),('12374','2013-04-10','11:25:00',8.46),('12374','2013-04-10','11:30:00',8.29),('12374','2013-04-10','11:35:00',9.36),('12374','2013-04-10','11:40:00',8.33),('12374','2013-04-10','11:45:00',8.54),('12374','2013-04-10','11:50:00',7.13),('12374','2013-04-10','11:55:00',4.34),('12374','2013-04-10','12:00:00',4.77),('12374','2013-04-10','12:05:00',5.99),('12374','2013-04-10','12:10:00',6.05),('12374','2013-04-10','12:15:00',5.54),('12374','2013-04-10','12:20:00',7.01),('12374','2013-04-10','12:25:00',4.88),('12374','2013-04-10','12:30:00',8.73),('12374','2013-04-10','12:35:00',7.16),('12374','2013-04-10','12:40:00',6.6),('12374','2013-04-10','12:45:00',9.65),('12374','2013-04-10','12:50:00',8.73),('12374','2013-04-10','12:55:00',9.01),('12374','2013-04-10','13:00:00',7.03),('12374','2013-04-10','13:05:00',8.16),('12374','2013-04-10','13:10:00',6.87),('12374','2013-04-10','13:15:00',7.39),('12374','2013-04-10','13:20:00',8.89),('12374','2013-04-10','13:25:00',9.33),('12374','2013-04-10','13:30:00',8.68),('12374','2013-04-10','13:35:00',7.47),('12374','2013-04-10','13:40:00',7.63),('12374','2013-04-10','13:45:00',9.18),('12374','2013-04-10','13:50:00',8.6),('12374','2013-04-10','13:55:00',8.94),('12374','2013-04-10','14:00:00',8.47),('12374','2013-04-10','14:05:00',7.35),('12374','2013-04-10','14:10:00',9.26),('12374','2013-04-10','14:15:00',9.05),('12374','2013-04-10','14:20:00',8.48),('12374','2013-04-10','14:25:00',8.64),('12374','2013-04-10','14:30:00',8.23),('12374','2013-04-10','14:35:00',8.35),('12374','2013-04-10','14:40:00',8.41),('12374','2013-04-10','14:45:00',7.57),('12374','2013-04-10','14:50:00',8.35),('12374','2013-04-10','14:55:00',8.21),('12374','2013-04-10','15:00:00',8.09),('12374','2013-04-10','15:05:00',7.86),('12374','2013-04-10','15:10:00',7.95),('12374','2013-04-10','15:15:00',7.82),('12374','2013-04-10','15:20:00',7.76),('12374','2013-04-10','15:25:00',7.06),('12374','2013-04-10','15:30:00',7.57),('12374','2013-04-10','15:35:00',7.35),('12374','2013-04-10','15:40:00',7.21),('12374','2013-04-10','15:45:00',7.06),('12374','2013-04-10','15:50:00',6.99),('12374','2013-04-10','15:55:00',6.81),('12374','2013-04-10','16:00:00',6.74),('12374','2013-04-10','16:05:00',4.97),('12374','2013-04-10','16:10:00',6.57),('12374','2013-04-10','16:15:00',6.14),('12374','2013-04-10','16:20:00',6.08),('12374','2013-04-10','16:25:00',5.24),('12374','2013-04-10','16:30:00',5.69),('12374','2013-04-10','16:35:00',5.63),('12374','2013-04-10','16:40:00',5.43),('12374','2013-04-10','16:45:00',5.22),('12374','2013-04-10','16:50:00',5.08),('12374','2013-04-10','16:55:00',5.05),('12374','2013-04-10','17:00:00',4.74),('12374','2013-04-10','17:05:00',4.55),('12374','2013-04-10','17:10:00',4.43),('12374','2013-04-10','17:15:00',4.1),('12374','2013-04-10','17:20:00',4.09),('12374','2013-04-10','17:25:00',4.02),('12374','2013-04-10','17:30:00',3.29),('12374','2013-04-10','17:35:00',3.61),('12374','2013-04-10','17:40:00',3.44),('12374','2013-04-10','17:45:00',3.25),('12374','2013-04-10','17:50:00',3),('12374','2013-04-10','17:55:00',2.81),('12374','2013-04-10','18:00:00',2.72),('12374','2013-04-10','18:05:00',2.39),('12374','2013-04-10','18:10:00',1.69),('12374','2013-04-10','18:15:00',1.85),('12374','2013-04-10','18:20:00',1.01),('12374','2013-04-10','18:25:00',1.27),('12374','2013-04-09','07:40:00',1.22),('12374','2013-04-09','08:15:00',2.21),('12374','2013-04-09','08:20:00',3),('12374','2013-04-09','08:25:00',3.34),('12374','2013-04-09','08:30:00',2.7),('12374','2013-04-09','08:35:00',2.28),('12374','2013-04-09','08:40:00',1.18),('12374','2013-04-09','08:45:00',1.56),('12374','2013-04-09','08:50:00',1.34),('12374','2013-04-09','08:55:00',1.43),('12374','2013-04-09','09:00:00',2.42),('12374','2013-04-09','09:05:00',3.57),('12374','2013-04-09','09:10:00',3.71),('12374','2013-04-09','09:15:00',4.5),('12374','2013-04-09','09:20:00',5.23),('12374','2013-04-09','09:25:00',5.34),('12374','2013-04-09','09:30:00',5.56),('12374','2013-04-09','09:35:00',5.77),('12374','2013-04-09','09:40:00',5.91),('12374','2013-04-09','09:45:00',6),('12374','2013-04-09','09:50:00',6.18),('12374','2013-04-09','09:55:00',6.32),('12374','2013-04-09','10:00:00',6.45),('12374','2013-04-09','10:05:00',6.64),('12374','2013-04-09','10:10:00',6.83),('12374','2013-04-09','10:15:00',6.48),('12374','2013-04-09','10:20:00',7.12),('12374','2013-04-09','10:25:00',7.24),('12374','2013-04-09','10:30:00',7.37),('12374','2013-04-09','10:35:00',7.44),('12374','2013-04-09','10:40:00',7.17),('12374','2013-04-09','10:45:00',5.24),('12374','2013-04-09','10:50:00',7.53),('12374','2013-04-09','10:55:00',9.26),('12374','2013-04-09','11:00:00',3.83),('12374','2013-04-09','11:05:00',3.19),('12374','2013-04-09','11:10:00',6.92),('12374','2013-04-09','11:15:00',7.43),('12374','2013-04-09','11:20:00',7.42),('12374','2013-04-09','11:25:00',6.18),('12374','2013-04-09','11:30:00',5.2),('12374','2013-04-09','11:35:00',8.46),('12374','2013-04-09','11:40:00',9.18),('12374','2013-04-09','11:45:00',8.29),('12374','2013-04-09','11:50:00',7.82),('12374','2013-04-09','11:55:00',7.66),('12374','2013-04-09','12:00:00',8.55),('12374','2013-04-09','12:05:00',9.41),('12374','2013-04-09','12:10:00',7.32),('12374','2013-04-09','12:15:00',8.68),('12374','2013-04-09','12:20:00',9.1),('12374','2013-04-09','12:25:00',8.7),('12374','2013-04-09','12:30:00',5.47),('12374','2013-04-09','12:35:00',8.6),('12374','2013-04-09','12:40:00',9.56),('12374','2013-04-09','12:45:00',9.44),('12374','2013-04-09','12:50:00',9.51),('12374','2013-04-09','12:55:00',9.6),('12374','2013-04-09','13:00:00',8.07),('12374','2013-04-09','13:05:00',9.01),('12374','2013-04-09','13:10:00',8.91),('12374','2013-04-09','13:15:00',7.39),('12374','2013-04-09','13:20:00',7.69),('12374','2013-04-09','13:25:00',8.85),('12374','2013-04-09','13:30:00',9.2),('12374','2013-04-09','13:35:00',9.4),('12374','2013-04-09','13:40:00',8.96),('12374','2013-04-09','13:45:00',8.13),('12374','2013-04-09','13:50:00',8.86),('12374','2013-04-09','13:55:00',9.08),('12374','2013-04-09','14:00:00',8.05),('12374','2013-04-09','14:05:00',8.15),('12374','2013-04-09','14:10:00',7.14),('12374','2013-04-09','14:15:00',8.19),('12374','2013-04-09','14:20:00',8.38),('12374','2013-04-09','14:25:00',8.31),('12374','2013-04-09','14:30:00',8.4),('12374','2013-04-09','14:35:00',7.9),('12374','2013-04-09','14:40:00',8.54),('12374','2013-04-09','14:45:00',7.6),('12374','2013-04-09','14:50:00',7.76),('12374','2013-04-09','14:55:00',8.17),('12374','2013-04-09','15:00:00',8.31),('12374','2013-04-09','15:05:00',7.73),('12374','2013-04-09','15:10:00',7.94),('12374','2013-04-09','15:15:00',7.71),('12374','2013-04-09','15:20:00',7.89),('12374','2013-04-09','15:25:00',6.77),('12374','2013-04-09','15:30:00',7.37),('12374','2013-04-09','15:35:00',6.77),('12374','2013-04-09','15:40:00',7.04),('12374','2013-04-09','15:45:00',6.93),('12374','2013-04-09','15:50:00',6.91),('12374','2013-04-09','15:55:00',6.96),('12374','2013-04-09','16:00:00',6.73),('12374','2013-04-09','16:05:00',6.42),('12374','2013-04-09','16:10:00',6.38),('12374','2013-04-09','16:15:00',5.6),('12374','2013-04-09','16:20:00',5.04),('12374','2013-04-09','16:25:00',5.53),('12374','2013-04-09','16:30:00',5.53),('12374','2013-04-09','16:35:00',5.88),('12374','2013-04-09','16:40:00',5.54),('12374','2013-04-09','16:45:00',5.36),('12374','2013-04-09','16:50:00',5.55),('12374','2013-04-09','16:55:00',5.25),('12374','2013-04-09','17:00:00',5.21),('12374','2013-04-09','17:05:00',4.89),('12374','2013-04-09','17:10:00',4.8),('12374','2013-04-09','17:15:00',3.84),('12374','2013-04-09','17:20:00',3.44),('12374','2013-04-09','17:25:00',2.96),('12374','2013-04-09','17:30:00',3.02),('12374','2013-04-09','17:35:00',2.82),('12374','2013-04-09','17:40:00',2.26),('12374','2013-04-09','17:45:00',2.31),('12374','2013-04-09','17:50:00',3.17),('12374','2013-04-09','17:55:00',2.64),('12374','2013-04-09','18:00:00',2.48),('12374','2013-04-09','18:05:00',1.73),('12374','2013-04-09','18:10:00',1.21),('12374','2013-04-09','18:15:00',1.13),('12374','2013-04-09','18:20:00',1.12),('12374','2013-04-08','07:40:00',1.24),('12374','2013-04-08','07:50:00',1.28),('12374','2013-04-08','07:55:00',1.29),('12374','2013-04-08','08:05:00',1.06),('12374','2013-04-08','08:10:00',1.22),('12374','2013-04-08','08:15:00',1.69),('12374','2013-04-08','08:20:00',3.31),('12374','2013-04-08','08:25:00',3.53),('12374','2013-04-08','08:30:00',3.42),('12374','2013-04-08','08:35:00',3.76),('12374','2013-04-08','08:40:00',3.92),('12374','2013-04-08','08:45:00',4.09),('12374','2013-04-08','08:50:00',4.42),('12374','2013-04-08','08:55:00',4.64),('12374','2013-04-08','09:00:00',4.81),('12374','2013-04-08','09:05:00',5.15),('12374','2013-04-08','09:10:00',5.06),('12374','2013-04-08','09:15:00',5.31),('12374','2013-04-08','09:20:00',5.6),('12374','2013-04-08','09:25:00',5.82),('12374','2013-04-08','09:30:00',6.03),('12374','2013-04-08','09:35:00',5.86),('12374','2013-04-08','09:40:00',3.95),('12374','2013-04-08','09:45:00',5.57),('12374','2013-04-08','09:50:00',6.37),('12374','2013-04-08','09:55:00',6.28),('12374','2013-04-08','10:00:00',6.63),('12374','2013-04-08','10:05:00',6.67),('12374','2013-04-08','10:10:00',6.47),('12374','2013-04-08','10:15:00',6.64),('12374','2013-04-08','10:20:00',6.83),('12374','2013-04-08','10:25:00',6.71),('12374','2013-04-08','10:30:00',6.88),('12374','2013-04-08','10:35:00',7.34),('12374','2013-04-08','10:40:00',6.83),('12374','2013-04-08','10:45:00',6.97),('12374','2013-04-08','10:50:00',7.24),('12374','2013-04-08','10:55:00',6.34),('12374','2013-04-08','11:00:00',5.52),('12374','2013-04-08','11:05:00',5.5),('12374','2013-04-08','11:10:00',4.58),('12374','2013-04-08','11:15:00',5.27),('12374','2013-04-08','11:20:00',5.62),('12374','2013-04-08','11:25:00',6.67),('12374','2013-04-08','11:30:00',5.9),('12374','2013-04-08','11:35:00',6.65),('12374','2013-04-08','11:40:00',7.21),('12374','2013-04-08','11:45:00',8.03),('12374','2013-04-08','11:50:00',7.51),('12374','2013-04-08','11:55:00',6.81),('12374','2013-04-08','12:00:00',7.85),('12374','2013-04-08','12:05:00',7.53),('12374','2013-04-08','12:10:00',6.57),('12374','2013-04-08','12:15:00',7.35),('12374','2013-04-08','12:20:00',6.73),('12374','2013-04-08','12:25:00',5.93),('12374','2013-04-08','12:30:00',6.73),('12374','2013-04-08','12:35:00',7.05),('12374','2013-04-08','12:40:00',6.65),('12374','2013-04-08','12:45:00',7.61),('12374','2013-04-08','12:50:00',8.38),('12374','2013-04-08','12:55:00',7.83),('12374','2013-04-08','13:00:00',7.65),('12374','2013-04-08','13:05:00',7.74),('12374','2013-04-08','13:10:00',6.31),('12374','2013-04-08','13:15:00',7.05),('12374','2013-04-08','13:20:00',7.91),('12374','2013-04-08','13:25:00',5.92),('12374','2013-04-08','13:30:00',8.28),('12374','2013-04-08','13:35:00',7.42),('12374','2013-04-08','13:40:00',7.91),('12374','2013-04-08','13:45:00',8.78),('12374','2013-04-08','13:50:00',6.7),('12374','2013-04-08','13:55:00',6.71),('12374','2013-04-08','14:00:00',8),('12374','2013-04-08','14:05:00',8.01),('12374','2013-04-08','14:10:00',7.71),('12374','2013-04-08','14:15:00',8.05),('12374','2013-04-08','14:20:00',7.49),('12374','2013-04-08','14:25:00',7.74),('12374','2013-04-08','14:30:00',7.13),('12374','2013-04-08','14:35:00',8.05),('12374','2013-04-08','14:40:00',8.47),('12374','2013-04-08','14:45:00',6.95),('12374','2013-04-08','14:50:00',6.21),('12374','2013-04-08','14:55:00',6.2),('12374','2013-04-08','15:00:00',6.77),('12374','2013-04-08','15:05:00',6.7),('12374','2013-04-08','15:10:00',5.56),('12374','2013-04-08','15:15:00',7.96),('12374','2013-04-08','15:20:00',7.92),('12374','2013-04-08','15:25:00',7.61),('12374','2013-04-08','15:30:00',7.42),('12374','2013-04-08','15:35:00',7.34),('12374','2013-04-08','15:40:00',7.25),('12374','2013-04-08','15:45:00',5.72),('12374','2013-04-08','15:50:00',5.1),('12374','2013-04-08','15:55:00',6.69),('12374','2013-04-08','16:00:00',6.7),('12374','2013-04-08','16:05:00',6.52),('12374','2013-04-08','16:10:00',6.33),('12374','2013-04-08','16:15:00',6.21),('12374','2013-04-08','16:20:00',6.05),('12374','2013-04-08','16:25:00',5.91),('12374','2013-04-08','16:30:00',5.73),('12374','2013-04-08','16:35:00',5.61),('12374','2013-04-08','16:40:00',5.45),('12374','2013-04-08','16:45:00',5.34),('12374','2013-04-08','16:50:00',5.12),('12374','2013-04-08','16:55:00',4.87),('12374','2013-04-08','17:00:00',4.64),('12374','2013-04-08','17:05:00',4.53),('12374','2013-04-08','17:10:00',4.22),('12374','2013-04-08','17:15:00',4.26),('12374','2013-04-08','17:20:00',3.09),('12374','2013-04-08','17:25:00',3.49),('12374','2013-04-08','17:30:00',3.48),('12374','2013-04-08','17:35:00',3.37),('12374','2013-04-08','17:40:00',2.7),('12374','2013-04-08','17:45:00',2.25),('12374','2013-04-08','17:50:00',1.74),('12374','2013-04-08','17:55:00',1.65),('12374','2013-04-08','18:00:00',3.19),('12374','2013-04-08','18:05:00',3.07),('12374','2013-04-08','18:10:00',2.48),('12374','2013-04-08','18:15:00',1.93),('12374','2013-04-08','18:20:00',1.74),('12374','2013-04-08','18:25:00',1.56),('12374','2013-04-08','18:30:00',1.1),('12374','2013-04-07','07:35:00',1.32),('12374','2013-04-07','07:40:00',1.62),('12374','2013-04-07','07:45:00',1.74),('12374','2013-04-07','07:50:00',1.68),('12374','2013-04-07','07:55:00',1.65),('12374','2013-04-07','08:00:00',1.68),('12374','2013-04-07','08:05:00',1.96),('12374','2013-04-07','08:10:00',1.92),('12374','2013-04-07','08:15:00',2.41),('12374','2013-04-07','08:20:00',3.12),('12374','2013-04-07','08:25:00',3.33),('12374','2013-04-07','08:30:00',3.43),('12374','2013-04-07','08:35:00',3.63),('12374','2013-04-07','08:40:00',3.75),('12374','2013-04-07','08:45:00',3.76),('12374','2013-04-07','08:50:00',3.95),('12374','2013-04-07','08:55:00',4.03),('12374','2013-04-07','09:00:00',3.97),('12374','2013-04-07','09:05:00',4.08),('12374','2013-04-07','09:10:00',4.18),('12374','2013-04-07','09:15:00',4.45),('12374','2013-04-07','09:20:00',4.85),('12374','2013-04-07','09:25:00',5.08),('12374','2013-04-07','09:30:00',5.05),('12374','2013-04-07','09:35:00',5.21),('12374','2013-04-07','09:40:00',5.42),('12374','2013-04-07','09:45:00',5.55),('12374','2013-04-07','09:50:00',5.69),('12374','2013-04-07','09:55:00',5.81),('12374','2013-04-07','10:00:00',5.83),('12374','2013-04-07','10:05:00',5.99),('12374','2013-04-07','10:10:00',6.08),('12374','2013-04-07','10:15:00',6.41),('12374','2013-04-07','10:20:00',6.55),('12374','2013-04-07','10:25:00',6.63),('12374','2013-04-07','10:30:00',6.59),('12374','2013-04-07','10:35:00',6.4),('12374','2013-04-07','10:40:00',6.76),('12374','2013-04-07','10:45:00',7.21),('12374','2013-04-07','10:50:00',7.42),('12374','2013-04-07','10:55:00',7.59),('12374','2013-04-07','11:00:00',7.51),('12374','2013-04-07','11:05:00',7.58),('12374','2013-04-07','11:10:00',7.75),('12374','2013-04-07','11:15:00',7.65),('12374','2013-04-07','11:20:00',7.77),('12374','2013-04-07','11:25:00',7.77),('12374','2013-04-07','11:30:00',7.16),('12374','2013-04-07','11:35:00',7.38),('12374','2013-04-07','11:40:00',7.45),('12374','2013-04-07','11:45:00',6.4),('12374','2013-04-07','11:50:00',6.42),('12374','2013-04-07','11:55:00',6.34),('12374','2013-04-07','12:00:00',7.18),('12374','2013-04-07','12:05:00',8.11),('12374','2013-04-07','12:10:00',8),('12374','2013-04-07','12:15:00',7.5),('12374','2013-04-07','12:20:00',7.25),('12374','2013-04-07','12:25:00',7.13),('12374','2013-04-07','12:30:00',6.91),('12374','2013-04-07','12:35:00',6.93),('12374','2013-04-07','12:40:00',7.14),('12374','2013-04-07','12:45:00',6.36),('12374','2013-04-07','12:50:00',6.66),('12374','2013-04-07','12:55:00',6.74),('12374','2013-04-07','13:00:00',6.47),('12374','2013-04-07','13:05:00',6.12),('12374','2013-04-07','13:10:00',6.05),('12374','2013-04-07','13:15:00',5.77),('12374','2013-04-07','13:20:00',5.91),('12374','2013-04-07','13:25:00',6.18),('12374','2013-04-07','13:30:00',6.31),('12374','2013-04-07','13:35:00',6.44),('12374','2013-04-07','13:40:00',6.51),('12374','2013-04-07','13:45:00',6.51),('12374','2013-04-07','13:50:00',6.56),('12374','2013-04-07','13:55:00',6.54),('12374','2013-04-07','14:00:00',6.86),('12374','2013-04-07','14:05:00',6.99),('12374','2013-04-07','14:10:00',7.43),('12374','2013-04-07','14:15:00',6.88),('12374','2013-04-07','14:20:00',6.85),('12374','2013-04-07','14:25:00',6.41),('12374','2013-04-07','14:30:00',5.97),('12374','2013-04-07','14:35:00',5.58),('12374','2013-04-07','14:40:00',5.38),('12374','2013-04-07','14:45:00',5.43),('12374','2013-04-07','14:50:00',5.82),('12374','2013-04-07','14:55:00',6.19),('12374','2013-04-07','15:00:00',6.54),('12374','2013-04-07','15:05:00',6.92),('12374','2013-04-07','15:10:00',7.25),('12374','2013-04-07','15:15:00',7.36),('12374','2013-04-07','15:20:00',7.52),('12374','2013-04-07','15:25:00',7.62),('12374','2013-04-07','15:30:00',7.72),('12374','2013-04-07','15:35:00',7.76),('12374','2013-04-07','15:40:00',7.6),('12374','2013-04-07','15:45:00',7.54),('12374','2013-04-07','15:50:00',7.46),('12374','2013-04-07','15:55:00',7.29),('12374','2013-04-07','16:00:00',7.13),('12374','2013-04-07','16:05:00',6.96),('12374','2013-04-07','16:10:00',6.73),('12374','2013-04-07','16:15:00',6.56),('12374','2013-04-07','16:20:00',6.5),('12374','2013-04-07','16:25:00',6.36),('12374','2013-04-07','16:30:00',6.08),('12374','2013-04-07','16:35:00',5.9),('12374','2013-04-07','16:40:00',5.72),('12374','2013-04-07','16:45:00',5.53),('12374','2013-04-07','16:50:00',5.33),('12374','2013-04-07','16:55:00',5.13),('12374','2013-04-07','17:00:00',4.44),('12374','2013-04-07','17:05:00',2.13),('12374','2013-04-07','17:10:00',1.41),('12374','2013-04-07','17:15:00',1.03),('12374','2013-04-06','07:30:00',1.05),('12374','2013-04-06','07:35:00',1.41),('12374','2013-04-06','07:40:00',1.56),('12374','2013-04-06','07:45:00',1.4),('12374','2013-04-06','07:50:00',1.45),('12374','2013-04-06','07:55:00',1.49),('12374','2013-04-06','08:00:00',1.46),('12374','2013-04-06','08:05:00',1.6),('12374','2013-04-06','08:10:00',1.9),('12374','2013-04-06','08:15:00',2.42),('12374','2013-04-06','08:20:00',2.96),('12374','2013-04-06','08:25:00',3.31),('12374','2013-04-06','08:30:00',3.5),('12374','2013-04-06','08:35:00',3.68),('12374','2013-04-06','08:40:00',3.83),('12374','2013-04-06','08:45:00',4.01),('12374','2013-04-06','08:50:00',4.21),('12374','2013-04-06','08:55:00',4.35),('12374','2013-04-06','09:00:00',4.54),('12374','2013-04-06','09:05:00',4.75),('12374','2013-04-06','09:10:00',4.9),('12374','2013-04-06','09:15:00',5.06),('12374','2013-04-06','09:20:00',5.21),('12374','2013-04-06','09:25:00',5.36),('12374','2013-04-06','09:30:00',5.54),('12374','2013-04-06','09:35:00',5.8),('12374','2013-04-06','09:40:00',5.56),('12374','2013-04-06','09:45:00',6),('12374','2013-04-06','09:50:00',6.15),('12374','2013-04-06','09:55:00',6.27),('12374','2013-04-06','10:00:00',6.21),('12374','2013-04-06','10:05:00',1.24),('12374','2013-04-06','10:10:00',2.08),('12374','2013-04-06','10:15:00',7.25),('12374','2013-04-06','10:20:00',6.87),('12374','2013-04-06','10:25:00',7.25),('12374','2013-04-06','10:30:00',7.29),('12374','2013-04-06','10:35:00',7.42),('12374','2013-04-06','10:40:00',7.52),('12374','2013-04-06','10:45:00',6.45),('12374','2013-04-06','10:50:00',2.64),('12374','2013-04-06','10:55:00',7.88),('12374','2013-04-06','11:00:00',7.28),('12374','2013-04-06','11:05:00',6.38),('12374','2013-04-06','11:10:00',8.23),('12374','2013-04-06','11:15:00',8.14),('12374','2013-04-06','11:20:00',8.51),('12374','2013-04-06','11:25:00',8.63),('12374','2013-04-06','11:30:00',8.57),('12374','2013-04-06','11:35:00',8.6),('12374','2013-04-06','11:40:00',8.46),('12374','2013-04-06','11:45:00',8.62),('12374','2013-04-06','11:50:00',8.7),('12374','2013-04-06','11:55:00',8.74),('12374','2013-04-06','12:00:00',8.78),('12374','2013-04-06','12:05:00',8.87),('12374','2013-04-06','12:10:00',8.77),('12374','2013-04-06','12:15:00',8.96),('12374','2013-04-06','12:20:00',9),('12374','2013-04-06','12:25:00',9.03),('12374','2013-04-06','12:30:00',9.13),('12374','2013-04-06','12:35:00',9.17),('12374','2013-04-06','12:40:00',9.13),('12374','2013-04-06','12:45:00',9.22),('12374','2013-04-06','12:50:00',9.24),('12374','2013-04-06','12:55:00',9.2),('12374','2013-04-06','13:00:00',9.2),('12374','2013-04-06','13:05:00',9.28),('12374','2013-04-06','13:10:00',9.33),('12374','2013-04-06','13:15:00',9.29),('12374','2013-04-06','13:20:00',9.29),('12374','2013-04-06','13:25:00',9.3),('12374','2013-04-06','13:30:00',9.26),('12374','2013-04-06','13:35:00',9.23),('12374','2013-04-06','13:40:00',9.19),('12374','2013-04-06','13:45:00',9.16),('12374','2013-04-06','13:50:00',9.11),('12374','2013-04-06','13:55:00',9),('12374','2013-04-06','14:00:00',8.92),('12374','2013-04-06','14:05:00',8.89),('12374','2013-04-06','14:10:00',8.83),('12374','2013-04-06','14:15:00',8.74),('12374','2013-04-06','14:20:00',8.68),('12374','2013-04-06','14:25:00',8.56),('12374','2013-04-06','14:30:00',8.52),('12374','2013-04-06','14:35:00',8.48),('12374','2013-04-06','14:40:00',8.41),('12374','2013-04-06','14:45:00',8.32),('12374','2013-04-06','14:50:00',8.25),('12374','2013-04-06','14:55:00',8.11),('12374','2013-04-06','15:00:00',8.01),('12374','2013-04-06','15:05:00',7.9),('12374','2013-04-06','15:10:00',7.75),('12374','2013-04-06','15:15:00',7.58),('12374','2013-04-06','15:20:00',7.49),('12374','2013-04-06','15:25:00',7.52),('12374','2013-04-06','15:30:00',7.45),('12374','2013-04-06','15:35:00',7.16),('12374','2013-04-06','15:40:00',6.75),('12374','2013-04-06','15:45:00',6.66),('12374','2013-04-06','15:50:00',6.42),('12374','2013-04-06','15:55:00',6.22),('12374','2013-04-06','16:00:00',6.73),('12374','2013-04-06','16:05:00',6.63),('12374','2013-04-06','16:10:00',6.47),('12374','2013-04-06','16:15:00',6.04),('12374','2013-04-06','16:20:00',5.79),('12374','2013-04-06','16:25:00',5.97),('12374','2013-04-06','16:30:00',5.43),('12374','2013-04-06','16:35:00',4.67),('12374','2013-04-06','16:40:00',3.92),('12374','2013-04-06','16:45:00',3.11),('12374','2013-04-06','16:50:00',4.83),('12374','2013-04-06','16:55:00',5.33),('12374','2013-04-06','17:00:00',5.11),('12374','2013-04-06','17:05:00',4.86),('12374','2013-04-06','17:10:00',4.3),('12374','2013-04-06','17:15:00',3.88),('12374','2013-04-06','17:20:00',4.68),('12374','2013-04-06','17:25:00',4.34),('12374','2013-04-06','17:30:00',3.38),('12374','2013-04-06','17:35:00',3),('12374','2013-04-06','17:40:00',2.6),('12374','2013-04-06','17:45:00',2.12),('12374','2013-04-06','17:50:00',2.01),('12374','2013-04-06','17:55:00',1.92),('12374','2013-04-06','18:00:00',1.7),('12374','2013-04-06','18:05:00',1.49),('12374','2013-04-06','18:10:00',1.46),('12374','2013-04-06','18:15:00',1.31),('12374','2013-04-06','18:20:00',1.16),('12374','2013-04-06','18:25:00',1.04),('12374','2013-04-05','08:00:00',1.08),('12374','2013-04-05','08:05:00',1.63),('12374','2013-04-05','08:10:00',2.63),('12374','2013-04-05','08:15:00',1.88),('12374','2013-04-05','08:20:00',1.84),('12374','2013-04-05','08:25:00',3.81),('12374','2013-04-05','08:30:00',2.47),('12374','2013-04-05','08:35:00',2.05),('12374','2013-04-05','08:40:00',2.39),('12374','2013-04-05','08:45:00',4.91),('12374','2013-04-05','08:50:00',4.98),('12374','2013-04-05','08:55:00',4.29),('12374','2013-04-05','09:00:00',3.18),('12374','2013-04-05','09:05:00',5.13),('12374','2013-04-05','09:10:00',4.7),('12374','2013-04-05','09:15:00',4.51),('12374','2013-04-05','09:20:00',5.05),('12374','2013-04-05','09:25:00',5.41),('12374','2013-04-05','09:30:00',4.93),('12374','2013-04-05','09:35:00',5.28),('12374','2013-04-05','09:40:00',4.35),('12374','2013-04-05','09:45:00',3.32),('12374','2013-04-05','09:50:00',5.11),('12374','2013-04-05','09:55:00',5.44),('12374','2013-04-05','10:00:00',6.09),('12374','2013-04-05','10:05:00',6.69),('12374','2013-04-05','10:10:00',6.29),('12374','2013-04-05','10:15:00',6.86),('12374','2013-04-05','10:20:00',6.95),('12374','2013-04-05','10:25:00',7.07),('12374','2013-04-05','10:30:00',7.19),('12374','2013-04-05','10:35:00',7.3),('12374','2013-04-05','10:40:00',7.41),('12374','2013-04-05','10:45:00',7.54),('12374','2013-04-05','10:50:00',7.66),('12374','2013-04-05','10:55:00',7.78),('12374','2013-04-05','11:00:00',7.89),('12374','2013-04-05','11:05:00',8.03),('12374','2013-04-05','11:10:00',8.13),('12374','2013-04-05','11:15:00',8.21),('12374','2013-04-05','11:20:00',8.32),('12374','2013-04-05','11:25:00',7.85),('12374','2013-04-05','11:30:00',6.99),('12374','2013-04-05','11:35:00',8.51),('12374','2013-04-05','11:40:00',8.81),('12374','2013-04-05','11:45:00',9.1),('12374','2013-04-05','11:50:00',9),('12374','2013-04-05','11:55:00',8.89),('12374','2013-04-05','12:00:00',8.96),('12374','2013-04-05','12:05:00',9.06),('12374','2013-04-05','12:10:00',8.45),('12374','2013-04-05','12:15:00',6.74),('12374','2013-04-05','12:20:00',7.45),('12374','2013-04-05','12:25:00',9.38),('12374','2013-04-05','12:30:00',9.59),('12374','2013-04-05','12:35:00',9.3),('12374','2013-04-05','12:40:00',9.23),('12374','2013-04-05','12:45:00',9.54),('12374','2013-04-05','12:50:00',9.32),('12374','2013-04-05','12:55:00',9.29),('12374','2013-04-05','13:00:00',8.63),('12374','2013-04-05','13:05:00',9.13),('12374','2013-04-05','13:10:00',9.3),('12374','2013-04-05','13:15:00',9.34),('12374','2013-04-05','13:20:00',9.4),('12374','2013-04-05','13:25:00',9.21),('12374','2013-04-05','13:30:00',8.99),('12374','2013-04-05','13:35:00',6.49),('12374','2013-04-05','13:40:00',8.97),('12374','2013-04-05','13:45:00',4.53),('12374','2013-04-05','13:50:00',6.81),('12374','2013-04-05','13:55:00',4.48),('12374','2013-04-05','14:00:00',3.61),('12374','2013-04-05','14:05:00',3.79),('12374','2013-04-05','14:10:00',2.92),('12374','2013-04-05','14:15:00',2.78),('12374','2013-04-05','14:20:00',2.51),('12374','2013-04-05','14:25:00',2.15),('12374','2013-04-05','14:30:00',2.21),('12374','2013-04-05','14:35:00',2.47),('12374','2013-04-05','14:40:00',3.05),('12374','2013-04-05','14:45:00',2.65),('12374','2013-04-05','14:50:00',2.43),('12374','2013-04-05','14:55:00',3.65),('12374','2013-04-05','15:00:00',3.31),('12374','2013-04-05','15:05:00',3.34),('12374','2013-04-05','15:10:00',3.85),('12374','2013-04-05','15:15:00',2.73),('12374','2013-04-05','15:20:00',3.17),('12374','2013-04-05','15:25:00',3.43),('12374','2013-04-05','15:30:00',4.2),('12374','2013-04-05','15:35:00',2.68),('12374','2013-04-05','15:40:00',2.32),('12374','2013-04-05','15:45:00',2.41),('12374','2013-04-05','15:50:00',2.49),('12374','2013-04-05','15:55:00',5.46),('12374','2013-04-05','16:00:00',5.26),('12374','2013-04-05','16:05:00',6.41),('12374','2013-04-05','16:10:00',6.86),('12374','2013-04-05','16:15:00',6.58),('12374','2013-04-05','16:20:00',6.31),('12374','2013-04-05','16:25:00',6.01),('12374','2013-04-05','16:30:00',5.8),('12374','2013-04-05','16:35:00',5.67),('12374','2013-04-05','16:40:00',5.52),('12374','2013-04-05','16:45:00',5.34),('12374','2013-04-05','16:50:00',5.15),('12374','2013-04-05','16:55:00',5),('12374','2013-04-05','17:00:00',3.09),('12374','2013-04-05','17:05:00',4.08),('12374','2013-04-05','17:10:00',3.63),('12374','2013-04-05','17:15:00',4.34),('12374','2013-04-05','17:20:00',4.11),('12374','2013-04-05','17:25:00',3.9),('12374','2013-04-05','17:30:00',3.68),('12374','2013-04-05','17:35:00',3.53),('12374','2013-04-05','17:40:00',3.38),('12374','2013-04-05','17:45:00',3.19),('12374','2013-04-05','17:50:00',3.03),('12374','2013-04-05','17:55:00',2.8),('12374','2013-04-05','18:00:00',2.44),('12374','2013-04-05','18:05:00',2.25),('12374','2013-04-05','18:10:00',2.03),('12374','2013-04-05','18:15:00',1.87),('12374','2013-04-05','18:20:00',1.68),('12374','2013-04-05','18:25:00',1.49),('12374','2013-04-05','18:30:00',1.33),('12374','2013-04-05','18:35:00',1.21),('12374','2013-04-05','18:40:00',1.12),('12374','2013-04-05','18:45:00',1.01),('12374','2013-04-04','08:10:00',1.08),('12374','2013-04-04','08:15:00',1.18),('12374','2013-04-04','08:20:00',1.4),('12374','2013-04-04','08:25:00',1.61),('12374','2013-04-04','08:30:00',1.47),('12374','2013-04-04','08:35:00',1.84),('12374','2013-04-04','08:40:00',2.25),('12374','2013-04-04','08:45:00',2.12),('12374','2013-04-04','08:50:00',1.48),('12374','2013-04-04','08:55:00',1.62),('12374','2013-04-04','09:00:00',1.72),('12374','2013-04-04','09:05:00',2.03),('12374','2013-04-04','09:10:00',1.74),('12374','2013-04-04','09:15:00',1.52),('12374','2013-04-04','09:20:00',1.38),('12374','2013-04-04','09:30:00',1.03),('12374','2013-04-04','09:35:00',1.32),('12374','2013-04-04','09:40:00',2.14),('12374','2013-04-04','09:45:00',1.99),('12374','2013-04-04','09:50:00',2.11),('12374','2013-04-04','09:55:00',2.31),('12374','2013-04-04','10:00:00',2.18),('12374','2013-04-04','10:05:00',2.75),('12374','2013-04-04','10:10:00',5.04),('12374','2013-04-04','10:15:00',4.6),('12374','2013-04-04','10:20:00',4.31),('12374','2013-04-04','10:25:00',3.01),('12374','2013-04-04','10:30:00',2.81),('12374','2013-04-04','10:35:00',3.61),('12374','2013-04-04','10:40:00',4.36),('12374','2013-04-04','10:45:00',4.69),('12374','2013-04-04','10:50:00',3.76),('12374','2013-04-04','10:55:00',2.82),('12374','2013-04-04','11:00:00',2),('12374','2013-04-04','11:05:00',1.97),('12374','2013-04-04','11:10:00',1.77),('12374','2013-04-04','11:15:00',1.5),('12374','2013-04-04','11:20:00',1.81),('12374','2013-04-04','11:25:00',2.42),('12374','2013-04-04','11:30:00',3.59),('12374','2013-04-04','11:35:00',3.7),('12374','2013-04-04','11:40:00',3.71),('12374','2013-04-04','11:45:00',3.86),('12374','2013-04-04','11:50:00',4.75),('12374','2013-04-04','11:55:00',5.56),('12374','2013-04-04','12:00:00',7.56),('12374','2013-04-04','12:05:00',7.98),('12374','2013-04-04','12:10:00',7.61),('12374','2013-04-04','12:15:00',6.69),('12374','2013-04-04','12:20:00',6.02),('12374','2013-04-04','12:25:00',7.64),('12374','2013-04-04','12:30:00',7.7),('12374','2013-04-04','12:35:00',3.68),('12374','2013-04-04','12:40:00',3.94),('12374','2013-04-04','12:45:00',6.53),('12374','2013-04-04','12:50:00',6.15),('12374','2013-04-04','12:55:00',4.18),('12374','2013-04-04','13:00:00',4.88),('12374','2013-04-04','13:05:00',6.61),('12374','2013-04-04','13:10:00',5.41),('12374','2013-04-04','13:15:00',3.71),('12374','2013-04-04','13:20:00',4.32),('12374','2013-04-04','13:25:00',4.76),('12374','2013-04-04','13:30:00',4.18),('12374','2013-04-04','13:35:00',3.41),('12374','2013-04-04','13:40:00',5.09),('12374','2013-04-04','13:45:00',3.66),('12374','2013-04-04','13:50:00',3.16),('12374','2013-04-04','13:55:00',5.04),('12374','2013-04-04','14:00:00',5.71),('12374','2013-04-04','14:05:00',8.21),('12374','2013-04-04','14:10:00',8.04),('12374','2013-04-04','14:15:00',7.07),('12374','2013-04-04','14:20:00',7.16),('12374','2013-04-04','14:25:00',8.35),('12374','2013-04-04','14:30:00',7.89),('12374','2013-04-04','14:35:00',7.34),('12374','2013-04-04','14:40:00',4.63),('12374','2013-04-04','14:45:00',6.18),('12374','2013-04-04','14:50:00',7.14),('12374','2013-04-04','14:55:00',3.59),('12374','2013-04-04','15:00:00',6.84),('12374','2013-04-04','15:05:00',8.05),('12374','2013-04-04','15:10:00',8.19),('12374','2013-04-04','15:15:00',8.05),('12374','2013-04-04','15:20:00',6.94),('12374','2013-04-04','15:25:00',6.94),('12374','2013-04-04','15:30:00',6.4),('12374','2013-04-04','15:35:00',6.75),('12374','2013-04-04','15:40:00',6.67),('12374','2013-04-04','15:45:00',6.43),('12374','2013-04-04','15:50:00',6.29),('12374','2013-04-04','15:55:00',5.69),('12374','2013-04-04','16:00:00',5),('12374','2013-04-04','16:05:00',5.39),('12374','2013-04-04','16:10:00',4.86),('12374','2013-04-04','16:15:00',4.35),('12374','2013-04-04','16:20:00',3.68),('12374','2013-04-04','16:25:00',3.86),('12374','2013-04-04','16:30:00',4.8),('12374','2013-04-04','16:35:00',3.22),('12374','2013-04-04','16:40:00',3.27),('12374','2013-04-04','16:45:00',3.88),('12374','2013-04-04','16:50:00',3.26),('12374','2013-04-04','16:55:00',3.28),('12374','2013-04-04','17:00:00',3.4),('12374','2013-04-04','17:05:00',3.28),('12374','2013-04-04','17:10:00',2.61),('12374','2013-04-04','17:15:00',2.71),('12374','2013-04-04','17:20:00',2.66),('12374','2013-04-04','17:25:00',2.42),('12374','2013-04-04','17:30:00',2.67),('12374','2013-04-04','17:35:00',2.5),('12374','2013-04-04','17:40:00',2.08),('12374','2013-04-04','17:45:00',1.92),('12374','2013-04-04','17:50:00',2.39),('12374','2013-04-04','17:55:00',1.65),('12374','2013-04-04','18:00:00',1.48),('12374','2013-04-04','18:05:00',1.28),('12374','2013-04-03','07:35:00',1.07),('12374','2013-04-03','07:41:00',1.69),('12374','2013-04-03','07:45:00',1.9),('12374','2013-04-03','07:50:00',1.94),('12374','2013-04-03','07:55:00',1.96),('12374','2013-04-03','08:00:00',1.98),('12374','2013-04-03','08:05:00',1.23),('12374','2013-04-03','08:15:00',1.68),('12374','2013-04-03','08:20:00',2.18),('12374','2013-04-03','08:25:00',3.25),('12374','2013-04-03','08:30:00',3.59),('12374','2013-04-03','08:35:00',3.78),('12374','2013-04-03','08:40:00',4.17),('12374','2013-04-03','08:45:00',4.73),('12374','2013-04-03','08:50:00',4.88),('12374','2013-04-03','08:55:00',4.53),('12374','2013-04-03','09:00:00',3.73),('12374','2013-04-03','09:05:00',3.84),('12374','2013-04-03','09:10:00',5.44),('12374','2013-04-03','09:15:00',5.03),('12374','2013-04-03','09:20:00',5.44),('12374','2013-04-03','09:25:00',5.92),('12374','2013-04-03','09:30:00',6.18),('12374','2013-04-03','09:35:00',5.16),('12374','2013-04-03','09:40:00',2.47),('12374','2013-04-03','09:45:00',4.27),('12374','2013-04-03','09:50:00',3.94),('12374','2013-04-03','09:55:00',5.79),('12374','2013-04-03','10:00:00',3.79),('12374','2013-04-03','10:05:00',3.75),('12374','2013-04-03','10:10:00',3.58),('12374','2013-04-03','10:15:00',4.57),('12374','2013-04-03','10:20:00',4.73),('12374','2013-04-03','10:25:00',8.03),('12374','2013-04-03','10:30:00',7.05),('12374','2013-04-03','10:35:00',6.52),('12374','2013-04-03','10:40:00',6.38),('12374','2013-04-03','10:45:00',4.86),('12374','2013-04-03','10:50:00',7.14),('12374','2013-04-03','10:55:00',8.01),('12374','2013-04-03','11:00:00',8.19),('12374','2013-04-03','11:05:00',8.32),('12374','2013-04-03','11:10:00',8.42),('12374','2013-04-03','11:15:00',8.33),('12374','2013-04-03','11:20:00',8.34),('12374','2013-04-03','11:25:00',8.43),('12374','2013-04-03','11:30:00',8.35),('12374','2013-04-03','11:35:00',8.66),('12374','2013-04-03','11:40:00',6.17),('12374','2013-04-03','11:45:00',6.22),('12374','2013-04-03','11:50:00',9.33),('12374','2013-04-03','11:55:00',9.17),('12374','2013-04-03','12:00:00',8.86),('12374','2013-04-03','12:05:00',4.57),('12374','2013-04-03','12:10:00',8.72),('12374','2013-04-03','12:15:00',9.51),('12374','2013-04-03','12:20:00',9.5),('12374','2013-04-03','12:25:00',9.14),('12374','2013-04-03','12:30:00',6.09),('12374','2013-04-03','12:35:00',7.08),('12374','2013-04-03','12:40:00',6.29),('12374','2013-04-03','12:45:00',5.1),('12374','2013-04-03','12:50:00',7.04),('12374','2013-04-03','12:55:00',9.59),('12374','2013-04-03','13:00:00',9.86),('12374','2013-04-03','13:05:00',9.94),('12374','2013-04-03','13:10:00',9.9),('12374','2013-04-03','13:15:00',9.89),('12374','2013-04-03','13:20:00',9.66),('12374','2013-04-03','13:25:00',9.64),('12374','2013-04-03','13:30:00',9.53),('12374','2013-04-03','13:35:00',9.56),('12374','2013-04-03','13:40:00',8.9),('12374','2013-04-03','13:45:00',9.61),('12374','2013-04-03','13:50:00',9.86),('12374','2013-04-03','13:55:00',9.65),('12374','2013-04-03','14:00:00',9.72),('12374','2013-04-03','14:05:00',9.17),('12374','2013-04-03','14:10:00',6.98),('12374','2013-04-03','14:15:00',5.43),('12374','2013-04-03','14:20:00',5.73),('12374','2013-04-03','14:25:00',6.55),('12374','2013-04-03','14:30:00',8.16),('12374','2013-04-03','14:35:00',9.19),('12374','2013-04-03','14:40:00',9.33),('12374','2013-04-03','14:45:00',9.01),('12374','2013-04-03','14:50:00',7.77),('12374','2013-04-03','14:55:00',6.7),('12374','2013-04-03','15:00:00',8.34),('12374','2013-04-03','15:05:00',8.18),('12374','2013-04-03','15:10:00',8.08),('12374','2013-04-03','15:15:00',7.95),('12374','2013-04-03','15:20:00',7.86),('12374','2013-04-03','15:25:00',7.8),('12374','2013-04-03','15:30:00',3.42),('12374','2013-04-03','15:35:00',8.29),('12374','2013-04-03','15:40:00',7.92),('12374','2013-04-03','15:45:00',8.4),('12374','2013-04-03','15:50:00',7.74),('12374','2013-04-03','15:55:00',7.02),('12374','2013-04-03','16:00:00',6.82),('12374','2013-04-03','16:05:00',6.68),('12374','2013-04-03','16:10:00',6.69),('12374','2013-04-03','16:15:00',6.39),('12374','2013-04-03','16:20:00',6.12),('12374','2013-04-03','16:25:00',5.97),('12374','2013-04-03','16:30:00',5.84),('12374','2013-04-03','16:35:00',5.73),('12374','2013-04-03','16:40:00',5.56),('12374','2013-04-03','16:45:00',5.34),('12374','2013-04-03','16:50:00',5.18),('12374','2013-04-03','16:55:00',5.07),('12374','2013-04-03','17:00:00',4.91),('12374','2013-04-03','17:05:00',4.81),('12374','2013-04-03','17:10:00',4.68),('12374','2013-04-03','17:15:00',4.49),('12374','2013-04-03','17:20:00',4.26),('12374','2013-04-03','17:25:00',4),('12374','2013-04-03','17:30:00',3.76),('12374','2013-04-03','17:35:00',3.62),('12374','2013-04-03','17:40:00',3.44),('12374','2013-04-03','17:45:00',3.2),('12374','2013-04-03','17:50:00',3.03),('12374','2013-04-03','17:55:00',2.68),('12374','2013-04-03','18:00:00',2.39),('12374','2013-04-03','18:05:00',2.2),('12374','2013-04-03','18:10:00',2.04),('12374','2013-04-03','18:15:00',1.84),('12374','2013-04-03','18:20:00',1.63),('12374','2013-04-03','18:25:00',1.43),('12374','2013-04-03','18:30:00',1.27),('12374','2013-04-03','18:35:00',1.2),('12374','2013-04-03','18:40:00',1.15),('12374','2013-04-03','18:45:00',1.09),('12374','2013-04-02','08:20:00',2.03),('12374','2013-04-02','08:25:00',1.91),('12374','2013-04-02','08:30:00',1.15),('12374','2013-04-02','08:45:00',1.32),('12374','2013-04-02','08:50:00',4.26),('12374','2013-04-02','08:55:00',4.03),('12374','2013-04-02','09:00:00',2.83),('12374','2013-04-02','09:05:00',4.37),('12374','2013-04-02','09:10:00',5.63),('12374','2013-04-02','09:15:00',5.03),('12374','2013-04-02','09:20:00',5.3),('12374','2013-04-02','09:25:00',5.3),('12374','2013-04-02','09:30:00',5.32),('12374','2013-04-02','09:35:00',5.68),('12374','2013-04-02','09:40:00',6.08),('12374','2013-04-02','09:45:00',6.01),('12374','2013-04-02','09:50:00',5.71),('12374','2013-04-02','09:55:00',6.22),('12374','2013-04-02','10:00:00',5.73),('12374','2013-04-02','10:05:00',6.62),('12374','2013-04-02','10:10:00',6.71),('12374','2013-04-02','10:15:00',6.68),('12374','2013-04-02','10:20:00',5.57),('12374','2013-04-02','10:25:00',7.28),('12374','2013-04-02','10:30:00',6.88),('12374','2013-04-02','10:35:00',7.25),('12374','2013-04-02','10:40:00',7.67),('12374','2013-04-02','10:45:00',7.97),('12374','2013-04-02','10:50:00',7.66),('12374','2013-04-02','10:55:00',7.88),('12374','2013-04-02','11:00:00',8.06),('12374','2013-04-02','11:05:00',2.53),('12374','2013-04-02','11:10:00',3.84),('12374','2013-04-02','11:15:00',9.87),('12374','2013-04-02','11:20:00',9.09),('12374','2013-04-02','11:25:00',3.34),('12374','2013-04-02','11:30:00',1.41),('12374','2013-04-02','11:35:00',1.06),('12374','2013-04-02','11:40:00',2.47),('12374','2013-04-02','11:45:00',7.07),('12374','2013-04-02','11:50:00',5.5),('12374','2013-04-02','11:55:00',9.18),('12374','2013-04-02','12:00:00',4.2),('12374','2013-04-02','12:05:00',2.45),('12374','2013-04-02','12:10:00',3.02),('12374','2013-04-02','12:15:00',1.61),('12374','2013-04-02','12:20:00',1.53),('12374','2013-04-02','12:25:00',5.53),('12374','2013-04-02','12:30:00',2.45),('12374','2013-04-02','12:35:00',5.56),('12374','2013-04-02','12:40:00',4.77),('12374','2013-04-02','12:45:00',5.65),('12374','2013-04-02','12:50:00',3.83),('12374','2013-04-02','12:55:00',4.76),('12374','2013-04-02','13:00:00',5.21),('12374','2013-04-02','13:05:00',3.96),('12374','2013-04-02','13:10:00',2.61),('12374','2013-04-02','13:15:00',2.68),('12374','2013-04-02','13:20:00',3.06),('12374','2013-04-02','13:25:00',2.68),('12374','2013-04-02','13:30:00',4.33),('12374','2013-04-02','13:35:00',5.07),('12374','2013-04-02','13:40:00',4.49),('12374','2013-04-02','13:45:00',8.85),('12374','2013-04-02','13:50:00',7.32),('12374','2013-04-02','13:55:00',9.74),('12374','2013-04-02','14:00:00',9.06),('12374','2013-04-02','14:05:00',6.2),('12374','2013-04-02','14:10:00',4.49),('12374','2013-04-02','14:15:00',1.37),('12374','2013-04-02','14:20:00',4.2),('12374','2013-04-02','14:25:00',9.15),('12374','2013-04-02','14:30:00',5.99),('12374','2013-04-02','14:35:00',3.78),('12374','2013-04-02','14:40:00',2.37),('12374','2013-04-02','14:45:00',1.42),('12374','2013-04-02','14:50:00',1.09),('12374','2013-04-02','14:55:00',1.84),('12374','2013-04-02','15:00:00',3.32),('12374','2013-04-02','15:05:00',3.07),('12374','2013-04-02','15:10:00',2.31),('12374','2013-04-02','15:15:00',2.29),('12374','2013-04-02','15:20:00',1.92),('12374','2013-04-02','15:25:00',1.15),('12374','2013-04-02','16:00:00',1.16),('12374','2013-04-02','16:05:00',1.07),('12374','2013-04-02','16:10:00',1.3),('12374','2013-04-02','16:15:00',1.41),('12374','2013-04-02','16:20:00',1.64),('12374','2013-04-02','16:25:00',2.35),('12374','2013-04-02','16:30:00',2.59),('12374','2013-04-02','16:35:00',2.23),('12374','2013-04-02','16:40:00',1.88),('12374','2013-04-02','16:45:00',1.27),('12374','2013-04-01','07:35:00',1.2),('12374','2013-04-01','07:41:00',1.31),('12374','2013-04-01','07:45:00',1.61),('12374','2013-04-01','07:50:00',1.68),('12374','2013-04-01','07:55:00',1.81),('12374','2013-04-01','08:00:00',1.54),('12374','2013-04-01','08:05:00',1.95),('12374','2013-04-01','08:10:00',2.39),('12374','2013-04-01','08:15:00',2.44),('12374','2013-04-01','08:20:00',2.45),('12374','2013-04-01','08:25:00',1.64),('12374','2013-04-01','08:30:00',4.14),('12374','2013-04-01','08:35:00',3.18),('12374','2013-04-01','08:40:00',1.09),('12374','2013-04-01','08:45:00',1.19),('12374','2013-04-01','08:50:00',1.42),('12374','2013-04-01','08:55:00',1.7),('12374','2013-04-01','09:00:00',2.13),('12374','2013-04-01','09:05:00',3.56),('12374','2013-04-01','09:10:00',1.71),('12374','2013-04-01','09:15:00',1.65),('12374','2013-04-01','09:20:00',2.1),('12374','2013-04-01','09:25:00',2.38),('12374','2013-04-01','09:30:00',4.5),('12374','2013-04-01','09:35:00',3.62),('12374','2013-04-01','09:40:00',3.08),('12374','2013-04-01','09:47:00',2.97),('12374','2013-04-01','09:50:00',5.62),('12374','2013-04-01','09:55:00',5.92),('12374','2013-04-01','10:00:00',6.85),('12374','2013-04-01','10:05:00',5.83),('12374','2013-04-01','10:10:00',4.18),('12374','2013-04-01','10:15:00',6.68),('12374','2013-04-01','10:20:00',5.18),('12374','2013-04-01','10:25:00',5.32),('12374','2013-04-01','10:30:00',5.65),('12374','2013-04-01','10:35:00',6.15),('12374','2013-04-01','10:40:00',5.34),('12374','2013-04-01','10:45:00',6.08),('12374','2013-04-01','10:50:00',6.27),('12374','2013-04-01','10:55:00',6.07),('12374','2013-04-01','11:00:00',6.85),('12374','2013-04-01','11:05:00',6.09),('12374','2013-04-01','11:10:00',5.24),('12374','2013-04-01','11:15:00',4.57),('12374','2013-04-01','11:20:00',5.1),('12374','2013-04-01','11:25:00',4.51),('12374','2013-04-01','11:30:00',5.22),('12374','2013-04-01','11:35:00',6.26),('12374','2013-04-01','11:40:00',5.83),('12374','2013-04-01','11:45:00',7.87),('12374','2013-04-01','11:50:00',6.68),('12374','2013-04-01','11:55:00',6.98),('12374','2013-04-01','12:00:00',5.06),('12374','2013-04-01','12:05:00',4.18),('12374','2013-04-01','12:10:00',4.77),('12374','2013-04-01','12:15:00',6.17),('12374','2013-04-01','12:20:00',6.95),('12374','2013-04-01','12:25:00',4.94),('12374','2013-04-01','12:30:00',4.26),('12374','2013-04-01','12:35:00',3.98),('12374','2013-04-01','12:40:00',4.33),('12374','2013-04-01','12:45:00',4.86),('12374','2013-04-01','12:50:00',5.02),('12374','2013-04-01','12:55:00',5.45),('12374','2013-04-01','13:00:00',5.53),('12374','2013-04-01','13:05:00',4.78),('12374','2013-04-01','13:10:00',6.72),('12374','2013-04-01','13:15:00',6.42),('12374','2013-04-01','13:20:00',5.87),('12374','2013-04-01','13:25:00',4.75),('12374','2013-04-01','13:30:00',4.4),('12374','2013-04-01','13:35:00',4.28),('12374','2013-04-01','13:40:00',4.76),('12374','2013-04-01','13:45:00',4.28),('12374','2013-04-01','13:50:00',3.6),('12374','2013-04-01','13:55:00',4.08),('12374','2013-04-01','14:00:00',6.49),('12374','2013-04-01','14:05:00',6.79),('12374','2013-04-01','14:10:00',6.55),('12374','2013-04-01','14:15:00',4.23),('12374','2013-04-01','14:20:00',4.66),('12374','2013-04-01','14:25:00',5.25),('12374','2013-04-01','14:30:00',4.29),('12374','2013-04-01','14:35:00',3.47),('12374','2013-04-01','14:40:00',3.11),('12374','2013-04-01','14:45:00',3.9),('12374','2013-04-01','14:50:00',4.55),('12374','2013-04-01','14:55:00',4.21),('12374','2013-04-01','15:00:00',3.97),('12374','2013-04-01','15:05:00',3.46),('12374','2013-04-01','15:10:00',2.85),('12374','2013-04-01','15:15:00',2.39),('12374','2013-04-01','15:20:00',2.92),('12374','2013-04-01','15:25:00',3.67),('12374','2013-04-01','15:30:00',3.18),('12374','2013-04-01','15:35:00',2.58),('12374','2013-04-01','15:40:00',2.46),('12374','2013-04-01','15:45:00',2.71),('12374','2013-04-01','15:50:00',3.55),('12374','2013-04-01','15:55:00',4.57),('12374','2013-04-01','16:00:00',3.95),('12374','2013-04-01','16:05:00',3.75),('12374','2013-04-01','16:10:00',2.73),('12374','2013-04-01','16:15:00',2.1),('12374','2013-04-01','16:20:00',1.74),('12374','2013-04-01','16:25:00',1.66),('12374','2013-04-01','16:30:00',1.8),('12374','2013-04-01','16:35:00',1.6),('12374','2013-04-01','16:40:00',1.37),('12374','2013-04-01','16:45:00',1.01),('12374','2013-03-31','08:40:00',1.2),('12374','2013-03-31','08:45:00',1.83),('12374','2013-03-31','09:00:00',1.32),('12374','2013-03-31','09:05:00',1.95),('12374','2013-03-31','09:10:00',2.69),('12374','2013-03-31','09:15:00',2.25),('12374','2013-03-31','09:20:00',3.12),('12374','2013-03-31','09:25:00',2.35),('12374','2013-03-31','09:30:00',1.6),('12374','2013-03-31','09:35:00',2.45),('12374','2013-03-31','09:40:00',2.89),('12374','2013-03-31','09:45:00',2.14),('12374','2013-03-31','09:50:00',2.11),('12374','2013-03-31','09:55:00',2.04),('12374','2013-03-31','10:00:00',3.88),('12374','2013-03-31','10:05:00',3.44),('12374','2013-03-31','10:10:00',2.77),('12374','2013-03-31','10:15:00',2.09),('12374','2013-03-31','10:20:00',1.44);
INSERT INTO `solarlogmod` VALUES ('12374','2013-03-31','10:25:00',1.19),('12374','2013-03-31','10:30:00',1.92),('12374','2013-03-31','10:35:00',2.22),('12374','2013-03-31','10:40:00',1.8),('12374','2013-03-31','10:45:00',1.84),('12374','2013-03-31','10:50:00',1.47),('12374','2013-03-31','10:55:00',1.56),('12374','2013-03-31','11:00:00',1.48),('12374','2013-03-31','11:05:00',1.58),('12374','2013-03-31','11:10:00',2.67),('12374','2013-03-31','11:15:00',2.65),('12374','2013-03-31','11:20:00',3.11),('12374','2013-03-31','11:25:00',2.22),('12374','2013-03-31','11:30:00',1.85),('12374','2013-03-31','11:35:00',2.2),('12374','2013-03-31','11:40:00',2.51),('12374','2013-03-31','11:45:00',2.22),('12374','2013-03-31','11:50:00',2.66),('12374','2013-03-31','11:55:00',1.87),('12374','2013-03-31','12:00:00',1.76),('12374','2013-03-31','12:05:00',1.83),('12374','2013-03-31','12:10:00',2.07),('12374','2013-03-31','12:15:00',2.17),('12374','2013-03-31','12:20:00',1.93),('12374','2013-03-31','12:25:00',2.8),('12374','2013-03-31','12:30:00',2.15),('12374','2013-03-31','12:35:00',1.78),('12374','2013-03-31','12:40:00',2.46),('12374','2013-03-31','12:45:00',3.32),('12374','2013-03-31','12:50:00',3.46),('12374','2013-03-31','12:55:00',4.45),('12374','2013-03-31','13:00:00',4.83),('12374','2013-03-31','13:05:00',4.7),('12374','2013-03-31','13:10:00',6.69),('12374','2013-03-31','13:15:00',9.9),('12374','2013-03-31','13:20:00',9.13),('12374','2013-03-31','13:25:00',8.76),('12374','2013-03-31','13:30:00',9.68),('12374','2013-03-31','13:35:00',8.49),('12374','2013-03-31','13:40:00',7.19),('12374','2013-03-31','13:45:00',6.24),('12374','2013-03-31','13:50:00',7.37),('12374','2013-03-31','13:55:00',7.7),('12374','2013-03-31','14:00:00',9.72),('12374','2013-03-31','14:05:00',9.7),('12374','2013-03-31','14:10:00',7.82),('12374','2013-03-31','14:15:00',6.86),('12374','2013-03-31','14:20:00',7.93),('12374','2013-03-31','14:25:00',6.99),('12374','2013-03-31','14:30:00',4.54),('12374','2013-03-31','14:35:00',4.23),('12374','2013-03-31','14:40:00',4.27),('12374','2013-03-31','14:45:00',2.59),('12374','2013-03-31','14:50:00',3.55),('12374','2013-03-31','14:55:00',7.6),('12374','2013-03-31','15:00:00',8.37),('12374','2013-03-31','15:05:00',5.51),('12374','2013-03-31','15:10:00',8.61),('12374','2013-03-31','15:15:00',8.59),('12374','2013-03-31','15:20:00',7.93),('12374','2013-03-31','15:25:00',8.27),('12374','2013-03-31','15:30:00',5),('12374','2013-03-31','15:35:00',5.4),('12374','2013-03-31','15:40:00',4.23),('12374','2013-03-31','15:45:00',4.17),('12374','2013-03-31','15:50:00',3.64),('12374','2013-03-31','15:55:00',3.94),('12374','2013-03-31','16:00:00',2.92),('12374','2013-03-31','16:05:00',2.19),('12374','2013-03-31','16:10:00',2.55),('12374','2013-03-31','16:15:00',3.17),('12374','2013-03-31','16:20:00',3.29),('12374','2013-03-31','16:25:00',1.81),('12374','2013-03-31','16:40:00',1.59),('12374','2013-03-31','16:45:00',1.61),('12374','2013-03-31','17:15:00',1.45),('12374','2013-03-31','17:20:00',3.63),('12374','2013-03-31','17:25:00',5.93),('12374','2013-03-31','17:30:00',3.62),('12374','2013-03-31','17:35:00',2.72),('12374','2013-03-31','17:40:00',2.96),('12374','2013-03-31','17:45:00',3.79),('12374','2013-03-31','17:50:00',3.18),('12374','2013-03-31','17:55:00',2.42),('12374','2013-03-31','18:00:00',1.27),('12374','2013-03-31','18:05:00',2.05),('12374','2013-03-31','18:10:00',2.34),('12374','2013-03-31','18:15:00',1.63),('12374','2013-03-30','09:10:00',1.31),('12374','2013-03-30','09:15:00',1.41),('12374','2013-03-30','09:20:00',1.47),('12374','2013-03-30','09:25:00',1.26),('12374','2013-03-30','09:30:00',1.37),('12374','2013-03-30','09:35:00',1.29),('12374','2013-03-30','09:40:00',1.95),('12374','2013-03-30','09:45:00',1.27),('12374','2013-03-30','09:50:00',1.5),('12374','2013-03-30','09:55:00',1.31),('12374','2013-03-30','10:00:00',2.01),('12374','2013-03-30','10:05:00',1.91),('12374','2013-03-30','10:10:00',2.65),('12374','2013-03-30','10:15:00',4.28),('12374','2013-03-30','10:20:00',4.01),('12374','2013-03-30','10:25:00',5.16),('12374','2013-03-30','10:30:00',5.01),('12374','2013-03-30','10:35:00',4.75),('12374','2013-03-30','10:40:00',4.08),('12374','2013-03-30','10:45:00',3.04),('12374','2013-03-30','10:50:00',2.38),('12374','2013-03-30','10:55:00',2.01),('12374','2013-03-30','11:00:00',1.8),('12374','2013-03-30','11:05:00',1.95),('12374','2013-03-30','11:10:00',1.87),('12374','2013-03-30','11:15:00',1.75),('12374','2013-03-30','11:20:00',1.69),('12374','2013-03-30','11:25:00',1.68),('12374','2013-03-30','11:30:00',1.54),('12374','2013-03-30','11:35:00',2.05),('12374','2013-03-30','11:40:00',2.04),('12374','2013-03-30','11:45:00',2.07),('12374','2013-03-30','11:50:00',1.81),('12374','2013-03-30','11:55:00',1.92),('12374','2013-03-30','12:00:00',1.61),('12374','2013-03-30','12:05:00',1.21),('12374','2013-03-30','12:10:00',1.69),('12374','2013-03-30','12:15:00',1.61),('12374','2013-03-30','12:20:00',1.09),('12374','2013-03-30','12:50:00',1.02),('12374','2013-03-30','12:55:00',1.52),('12374','2013-03-30','13:00:00',1.81),('12374','2013-03-30','13:05:00',2.27),('12374','2013-03-30','13:10:00',1.94),('12374','2013-03-30','13:15:00',2),('12374','2013-03-30','13:20:00',1.56),('12374','2013-03-30','13:25:00',1.31),('12374','2013-03-30','13:35:00',1.19),('12374','2013-03-30','13:40:00',1.39),('12374','2013-03-30','13:45:00',1.71),('12374','2013-03-30','13:50:00',2.39),('12374','2013-03-30','13:55:00',4.04),('12374','2013-03-30','14:00:00',4.3),('12374','2013-03-30','14:05:00',4.98),('12374','2013-03-30','14:10:00',4.79),('12374','2013-03-30','14:15:00',5.11),('12374','2013-03-30','14:20:00',4.79),('12374','2013-03-30','14:25:00',4.64),('12374','2013-03-30','14:30:00',4.89),('12374','2013-03-30','14:35:00',4.89),('12374','2013-03-30','14:40:00',3.09),('12374','2013-03-30','14:45:00',2.44),('12374','2013-03-30','14:50:00',2.06),('12374','2013-03-30','14:55:00',1.4),('12374','2013-03-30','15:00:00',1.56),('12374','2013-03-30','15:05:00',1.23),('12374','2013-03-29','06:55:00',1.25),('12374','2013-03-29','07:00:00',1.94),('12374','2013-03-29','07:05:00',1.57),('12374','2013-03-29','07:10:00',1.69),('12374','2013-03-29','07:20:00',1.59),('12374','2013-03-29','07:25:00',1.2),('12374','2013-03-29','07:30:00',1.28),('12374','2013-03-29','07:55:00',1.28),('12374','2013-03-29','08:00:00',2.01),('12374','2013-03-29','08:05:00',2.35),('12374','2013-03-29','08:10:00',2.56),('12374','2013-03-29','08:15:00',3.28),('12374','2013-03-29','08:20:00',3.19),('12374','2013-03-29','08:25:00',2.9),('12374','2013-03-29','08:30:00',2.56),('12374','2013-03-29','08:35:00',3.92),('12374','2013-03-29','08:40:00',5.86),('12374','2013-03-29','08:45:00',5.84),('12374','2013-03-29','08:50:00',6.03),('12374','2013-03-29','08:55:00',4.48),('12374','2013-03-29','09:00:00',5.09),('12374','2013-03-29','09:05:00',6.42),('12374','2013-03-29','09:10:00',6.03),('12374','2013-03-29','09:15:00',6.4),('12374','2013-03-29','09:20:00',5.75),('12374','2013-03-29','09:25:00',6.87),('12374','2013-03-29','09:30:00',6.93),('12374','2013-03-29','09:35:00',5.5),('12374','2013-03-29','09:40:00',6.1),('12374','2013-03-29','09:45:00',7.22),('12374','2013-03-29','09:50:00',5.27),('12374','2013-03-29','09:55:00',3.47),('12374','2013-03-29','10:00:00',4.01),('12374','2013-03-29','10:05:00',2.99),('12374','2013-03-29','10:10:00',7.15),('12374','2013-03-29','10:15:00',7.11),('12374','2013-03-29','10:20:00',7.31),('12374','2013-03-29','10:25:00',7.63),('12374','2013-03-29','10:30:00',7.54),('12374','2013-03-29','10:35:00',7.45),('12374','2013-03-29','10:40:00',8.56),('12374','2013-03-29','10:45:00',8.59),('12374','2013-03-29','10:50:00',8.52),('12374','2013-03-29','10:55:00',8.62),('12374','2013-03-29','11:00:00',8.55),('12374','2013-03-29','11:05:00',8.7),('12374','2013-03-29','11:10:00',8.86),('12374','2013-03-29','11:15:00',8.95),('12374','2013-03-29','11:20:00',9),('12374','2013-03-29','11:25:00',9.04),('12374','2013-03-29','11:30:00',9.09),('12374','2013-03-29','11:35:00',9.18),('12374','2013-03-29','11:40:00',9.22),('12374','2013-03-29','11:45:00',9.24),('12374','2013-03-29','11:50:00',9.24),('12374','2013-03-29','11:55:00',9.22),('12374','2013-03-29','12:00:00',9.25),('12374','2013-03-29','12:05:00',9.27),('12374','2013-03-29','12:10:00',9.38),('12374','2013-03-29','12:15:00',9.39),('12374','2013-03-29','12:20:00',9.38),('12374','2013-03-29','12:25:00',9.26),('12374','2013-03-29','12:30:00',9.32),('12374','2013-03-29','12:35:00',9.33),('12374','2013-03-29','12:40:00',9.32),('12374','2013-03-29','12:45:00',9.25),('12374','2013-03-29','12:50:00',9.2),('12374','2013-03-29','12:55:00',8.67),('12374','2013-03-29','13:00:00',9.15),('12374','2013-03-29','13:05:00',9.03),('12374','2013-03-29','13:10:00',8.84),('12374','2013-03-29','13:15:00',8.15),('12374','2013-03-29','13:20:00',7.53),('12374','2013-03-29','13:25:00',7.68),('12374','2013-03-29','13:30:00',7.85),('12374','2013-03-29','13:35:00',7.23),('12374','2013-03-29','13:40:00',7.42),('12374','2013-03-29','13:45:00',7.47),('12374','2013-03-29','13:50:00',6.13),('12374','2013-03-29','13:55:00',4.9),('12374','2013-03-29','14:00:00',4.57),('12374','2013-03-29','14:05:00',4.74),('12374','2013-03-29','14:10:00',4.31),('12374','2013-03-29','14:15:00',3.98),('12374','2013-03-29','14:20:00',3.81),('12374','2013-03-29','14:25:00',3.8),('12374','2013-03-29','14:30:00',4.18),('12374','2013-03-29','14:35:00',4.24),('12374','2013-03-29','14:40:00',3.82),('12374','2013-03-29','14:45:00',3.74),('12374','2013-03-29','14:50:00',3.37),('12374','2013-03-29','14:55:00',3.16),('12374','2013-03-29','15:00:00',2.9),('12374','2013-03-29','15:05:00',2.64),('12374','2013-03-29','15:10:00',2.45),('12374','2013-03-29','15:15:00',2.37),('12374','2013-03-29','15:20:00',2.41),('12374','2013-03-29','15:25:00',2.65),('12374','2013-03-29','15:30:00',3.05),('12374','2013-03-29','15:35:00',3.88),('12374','2013-03-29','15:40:00',5.44),('12374','2013-03-29','15:45:00',5.59),('12374','2013-03-29','15:50:00',3.42),('12374','2013-03-29','15:55:00',2.49),('12374','2013-03-29','16:00:00',2.39),('12374','2013-03-29','16:05:00',3.74),('12374','2013-03-29','16:10:00',3.42),('12374','2013-03-29','16:15:00',2.68),('12374','2013-03-29','16:20:00',2.75),('12374','2013-03-29','16:25:00',2.79),('12374','2013-03-29','16:30:00',3.54),('12374','2013-03-29','16:35:00',2.83),('12374','2013-03-29','16:40:00',3.37),('12374','2013-03-29','16:45:00',2.63),('12374','2013-03-29','16:50:00',1.99),('12374','2013-03-29','16:55:00',2),('12374','2013-03-29','17:00:00',2.19),('12374','2013-03-29','17:05:00',1.77),('12374','2013-03-29','17:10:00',2.23),('12374','2013-03-29','17:15:00',1.36),('12374','2013-03-29','17:20:00',1.74),('12374','2013-03-29','17:25:00',1.11),('12374','2013-03-28','08:35:00',1.06),('12374','2013-03-28','08:40:00',1.74),('12374','2013-03-28','08:45:00',1.99),('12374','2013-03-28','08:50:00',2.39),('12374','2013-03-28','08:55:00',2.18),('12374','2013-03-28','09:00:00',2.01),('12374','2013-03-28','09:05:00',1.5),('12374','2013-03-28','09:10:00',1.5),('12374','2013-03-28','09:17:00',2.25),('12374','2013-03-28','09:20:00',2.3),('12374','2013-03-28','09:25:00',2.27),('12374','2013-03-28','09:30:00',2.27),('12374','2013-03-28','09:35:00',2.68),('12374','2013-03-28','09:40:00',3.29),('12374','2013-03-28','09:45:00',3.06),('12374','2013-03-28','09:50:00',2.39),('12374','2013-03-28','09:55:00',2.7),('12374','2013-03-28','10:00:00',2.81),('12374','2013-03-28','10:05:00',1.83),('12374','2013-03-28','10:10:00',1.77),('12374','2013-03-28','10:15:00',1.79),('12374','2013-03-28','10:20:00',1.52),('12374','2013-03-28','10:25:00',1.7),('12374','2013-03-28','10:30:00',1.06),('12374','2013-03-28','10:40:00',1.02),('12374','2013-03-28','10:45:00',1.04),('12374','2013-03-28','10:55:00',1.25),('12374','2013-03-28','11:00:00',1.51),('12374','2013-03-28','11:05:00',1.46),('12374','2013-03-28','11:10:00',1.13),('12374','2013-03-28','11:15:00',1.2),('12374','2013-03-28','11:20:00',1.32),('12374','2013-03-28','11:25:00',1.52),('12374','2013-03-28','11:30:00',2.08),('12374','2013-03-28','11:35:00',2.3),('12374','2013-03-28','11:40:00',2.08),('12374','2013-03-28','11:45:00',2.25),('12374','2013-03-28','11:50:00',2.27),('12374','2013-03-28','11:55:00',2.14),('12374','2013-03-28','12:00:00',1.64),('12374','2013-03-28','12:05:00',1.68),('12374','2013-03-28','12:10:00',1.76),('12374','2013-03-28','12:15:00',1.36),('12374','2013-03-28','12:20:00',1.77),('12374','2013-03-28','12:25:00',2.26),('12374','2013-03-28','12:30:00',2.28),('12374','2013-03-28','12:35:00',2.44),('12374','2013-03-28','12:40:00',2.25),('12374','2013-03-28','12:45:00',2.36),('12374','2013-03-28','12:50:00',2.36),('12374','2013-03-28','12:55:00',1.85),('12374','2013-03-28','13:00:00',1.75),('12374','2013-03-28','13:05:00',2.36),('12374','2013-03-28','13:10:00',2.23),('12374','2013-03-28','13:15:00',2.27),('12374','2013-03-28','13:20:00',2.89),('12374','2013-03-28','13:25:00',2.29),('12374','2013-03-28','13:30:00',1.31),('12374','2013-03-28','13:35:00',1.2),('12374','2013-03-28','13:40:00',2.07),('12374','2013-03-28','13:45:00',3.44),('12374','2013-03-28','13:50:00',2.15),('12374','2013-03-28','13:55:00',1.37),('12374','2013-03-28','14:20:00',2.38),('12374','2013-03-28','14:25:00',2.28),('12374','2013-03-28','14:30:00',1.48),('12374','2013-03-28','14:45:00',1.3),('12374','2013-03-28','15:10:00',2.23),('12374','2013-03-28','15:15:00',1.98),('12374','2013-03-28','15:30:00',1.59),('12374','2013-03-28','15:35:00',2.98),('12374','2013-03-28','15:40:00',2.36),('12374','2013-03-28','15:45:00',1.11),('12374','2013-03-28','16:55:00',1.14),('12374','2013-03-28','17:00:00',1.28),('12374','2013-03-28','17:05:00',1.43),('12374','2013-03-28','17:10:00',1.01),('12374','2013-03-27','06:55:00',1.26),('12374','2013-03-27','07:00:00',1.4),('12374','2013-03-27','07:05:00',1.48),('12374','2013-03-27','07:10:00',1.62),('12374','2013-03-27','07:15:00',2.29),('12374','2013-03-27','07:20:00',1.99),('12374','2013-03-27','07:25:00',1.9),('12374','2013-03-27','07:30:00',3.07),('12374','2013-03-27','07:35:00',2.96),('12374','2013-03-27','07:40:00',3.04),('12374','2013-03-27','07:45:00',2.53),('12374','2013-03-27','07:50:00',2.35),('12374','2013-03-27','07:55:00',3.61),('12374','2013-03-27','08:00:00',3.89),('12374','2013-03-27','08:05:00',3.15),('12374','2013-03-27','08:10:00',2.28),('12374','2013-03-27','08:15:00',2.14),('12374','2013-03-27','08:20:00',2.23),('12374','2013-03-27','08:25:00',3),('12374','2013-03-27','08:30:00',4.81),('12374','2013-03-27','08:35:00',3.62),('12374','2013-03-27','08:40:00',2.91),('12374','2013-03-27','08:45:00',3.14),('12374','2013-03-27','08:50:00',4.02),('12374','2013-03-27','08:55:00',4.15),('12374','2013-03-27','09:00:00',4.84),('12374','2013-03-27','09:05:00',6.55),('12374','2013-03-27','09:10:00',5.28),('12374','2013-03-27','09:15:00',6.1),('12374','2013-03-27','09:20:00',6.7),('12374','2013-03-27','09:25:00',7.8),('12374','2013-03-27','09:30:00',5.54),('12374','2013-03-27','09:35:00',6.68),('12374','2013-03-27','09:40:00',7.59),('12374','2013-03-27','09:45:00',6.38),('12374','2013-03-27','09:50:00',7.24),('12374','2013-03-27','09:55:00',8.39),('12374','2013-03-27','10:00:00',8.59),('12374','2013-03-27','10:05:00',7.7),('12374','2013-03-27','10:10:00',6.03),('12374','2013-03-27','10:15:00',5.83),('12374','2013-03-27','10:20:00',5.04),('12374','2013-03-27','10:25:00',5.25),('12374','2013-03-27','10:30:00',7.22),('12374','2013-03-27','10:35:00',6.03),('12374','2013-03-27','10:40:00',4.44),('12374','2013-03-27','10:45:00',4.37),('12374','2013-03-27','10:50:00',3.75),('12374','2013-03-27','10:55:00',3.21),('12374','2013-03-27','11:00:00',3.65),('12374','2013-03-27','11:05:00',4.44),('12374','2013-03-27','11:10:00',4.09),('12374','2013-03-27','11:15:00',4.23),('12374','2013-03-27','11:20:00',4.2),('12374','2013-03-27','11:25:00',4.5),('12374','2013-03-27','11:30:00',6.23),('12374','2013-03-27','11:35:00',6.82),('12374','2013-03-27','11:40:00',5.96),('12374','2013-03-27','11:45:00',8.49),('12374','2013-03-27','11:50:00',7.83),('12374','2013-03-27','11:55:00',7.32),('12374','2013-03-27','12:00:00',7.37),('12374','2013-03-27','12:05:00',8.16),('12374','2013-03-27','12:10:00',8.96),('12374','2013-03-27','12:15:00',8.53),('12374','2013-03-27','12:20:00',5.72),('12374','2013-03-27','12:25:00',6.15),('12374','2013-03-27','12:30:00',8.5),('12374','2013-03-27','12:35:00',7.5),('12374','2013-03-27','12:40:00',6.68),('12374','2013-03-27','12:45:00',6.26),('12374','2013-03-27','12:50:00',7.34),('12374','2013-03-27','12:55:00',6.22),('12374','2013-03-27','13:00:00',7.67),('12374','2013-03-27','13:05:00',8.22),('12374','2013-03-27','13:10:00',6.96),('12374','2013-03-27','13:15:00',6.59),('12374','2013-03-27','13:20:00',4.99),('12374','2013-03-27','13:25:00',4.81),('12374','2013-03-27','13:30:00',5.94),('12374','2013-03-27','13:35:00',4.36),('12374','2013-03-27','13:40:00',3.46),('12374','2013-03-27','13:45:00',5.74),('12374','2013-03-27','13:50:00',6.82),('12374','2013-03-27','13:55:00',5.69),('12374','2013-03-27','14:00:00',5.54),('12374','2013-03-27','14:05:00',5.56),('12374','2013-03-27','14:10:00',5.69),('12374','2013-03-27','14:15:00',5.66),('12374','2013-03-27','14:20:00',5.28),('12374','2013-03-27','14:25:00',6.27),('12374','2013-03-27','14:30:00',5.95),('12374','2013-03-27','14:35:00',5.45),('12374','2013-03-27','14:40:00',5.37),('12374','2013-03-27','14:45:00',6.27),('12374','2013-03-27','14:50:00',7.31),('12374','2013-03-27','14:55:00',6.79),('12374','2013-03-27','15:00:00',4.1),('12374','2013-03-27','15:05:00',2.8),('12374','2013-03-27','15:10:00',2.94),('12374','2013-03-27','15:15:00',4.48),('12374','2013-03-27','15:20:00',4.35),('12374','2013-03-27','15:25:00',5.24),('12374','2013-03-27','15:30:00',3.73),('12374','2013-03-27','15:35:00',3.92),('12374','2013-03-27','15:40:00',3.06),('12374','2013-03-27','15:45:00',2.82),('12374','2013-03-27','15:50:00',2.76),('12374','2013-03-27','15:55:00',2.63),('12374','2013-03-27','16:00:00',2.72),('12374','2013-03-27','16:05:00',4.07),('12374','2013-03-27','16:10:00',3.68),('12374','2013-03-27','16:15:00',2.45),('12374','2013-03-27','16:20:00',2.32),('12374','2013-03-27','16:25:00',1.93),('12374','2013-03-27','16:30:00',2.2),('12374','2013-03-27','16:35:00',1.58),('12374','2013-03-27','16:40:00',1.2),('12374','2013-03-26','06:45:00',1.05),('12374','2013-03-26','07:00:00',1.05),('12374','2013-03-26','07:30:00',1.03),('12374','2013-03-26','08:00:00',1.19),('12374','2013-03-26','08:05:00',1.19),('12374','2013-03-26','08:10:00',1.41),('12374','2013-03-26','08:15:00',1.67),('12374','2013-03-26','08:20:00',2.46),('12374','2013-03-26','08:25:00',1.77),('12374','2013-03-26','08:30:00',1.34),('12374','2013-03-26','08:35:00',1.9),('12374','2013-03-26','08:40:00',1.8),('12374','2013-03-26','08:45:00',1.42),('12374','2013-03-26','08:55:00',1.68),('12374','2013-03-26','09:00:00',1.97),('12374','2013-03-26','09:05:00',3.58),('12374','2013-03-26','09:10:00',4.24),('12374','2013-03-26','09:15:00',3.26),('12374','2013-03-26','09:20:00',3.61),('12374','2013-03-26','09:25:00',4.8),('12374','2013-03-26','09:30:00',2.13),('12374','2013-03-26','09:35:00',1.9),('12374','2013-03-26','09:40:00',1.02),('12374','2013-03-26','09:45:00',1.97),('12374','2013-03-26','09:50:00',2.46),('12374','2013-03-26','09:55:00',2.05),('12374','2013-03-26','10:00:00',2.19),('12374','2013-03-26','10:05:00',2.27),('12374','2013-03-26','10:10:00',3.74),('12374','2013-03-26','10:15:00',6.62),('12374','2013-03-26','10:20:00',4.61),('12374','2013-03-26','10:25:00',4.22),('12374','2013-03-26','10:30:00',3.46),('12374','2013-03-26','10:35:00',3.61),('12374','2013-03-26','10:40:00',3.21),('12374','2013-03-26','10:45:00',3.74),('12374','2013-03-26','10:50:00',3.86),('12374','2013-03-26','10:55:00',3.6),('12374','2013-03-26','11:00:00',2.64),('12374','2013-03-26','11:05:00',1.78),('12374','2013-03-26','11:10:00',1.86),('12374','2013-03-26','11:15:00',1.77),('12374','2013-03-26','11:20:00',1.47),('12374','2013-03-26','11:25:00',1.22),('12374','2013-03-26','11:30:00',1.19),('12374','2013-03-26','11:35:00',2.64),('12374','2013-03-26','11:40:00',3.31),('12374','2013-03-26','11:45:00',3.48),('12374','2013-03-26','11:50:00',2.55),('12374','2013-03-26','11:55:00',2.62),('12374','2013-03-26','12:00:00',4.27),('12374','2013-03-26','12:05:00',5.63),('12374','2013-03-26','12:10:00',5.07),('12374','2013-03-26','12:15:00',5.31),('12374','2013-03-26','12:20:00',7.44),('12374','2013-03-26','12:25:00',9.01),('12374','2013-03-26','12:30:00',8.61),('12374','2013-03-26','12:35:00',4.74),('12374','2013-03-26','12:40:00',3.12),('12374','2013-03-26','12:45:00',3.97),('12374','2013-03-26','12:50:00',3.33),('12374','2013-03-26','12:55:00',2.74),('12374','2013-03-26','13:00:00',3.36),('12374','2013-03-26','13:05:00',3.21),('12374','2013-03-26','13:10:00',2.73),('12374','2013-03-26','13:15:00',1.89),('12374','2013-03-26','13:20:00',2.26),('12374','2013-03-26','13:25:00',4.67),('12374','2013-03-26','13:30:00',4.15),('12374','2013-03-26','13:35:00',2.5),('12374','2013-03-26','13:40:00',2.9),('12374','2013-03-26','13:45:00',2.86),('12374','2013-03-26','13:50:00',2.08),('12374','2013-03-26','13:55:00',1.75),('12374','2013-03-26','14:00:00',1.64),('12374','2013-03-26','14:05:00',2.97),('12374','2013-03-26','14:10:00',3.23),('12374','2013-03-26','14:15:00',3.48),('12374','2013-03-26','14:20:00',2.94),('12374','2013-03-26','14:25:00',2.75),('12374','2013-03-26','14:30:00',2.76),('12374','2013-03-26','14:35:00',2.61),('12374','2013-03-26','14:40:00',2.19),('12374','2013-03-26','14:45:00',2.3),('12374','2013-03-26','14:50:00',2.21),('12374','2013-03-26','14:55:00',2.12),('12374','2013-03-26','15:00:00',2.3),('12374','2013-03-26','15:05:00',2.15),('12374','2013-03-26','15:10:00',2.07),('12374','2013-03-26','15:15:00',2.29),('12374','2013-03-26','15:20:00',2.61),('12374','2013-03-26','15:25:00',2.51),('12374','2013-03-26','15:30:00',1.68),('12374','2013-03-26','15:35:00',1.46),('12374','2013-03-26','15:40:00',1.64),('12374','2013-03-26','15:45:00',1.38),('12374','2013-03-25','07:40:00',1.01),('12374','2013-03-25','07:45:00',1.79),('12374','2013-03-25','07:50:00',3.29),('12374','2013-03-25','07:55:00',2.92),('12374','2013-03-25','08:00:00',2.27),('12374','2013-03-25','08:05:00',1.91),('12374','2013-03-25','08:10:00',2.3),('12374','2013-03-25','08:15:00',4.99),('12374','2013-03-25','08:20:00',5.31),('12374','2013-03-25','08:25:00',5.66),('12374','2013-03-25','08:30:00',5.67),('12374','2013-03-25','08:35:00',4.73),('12374','2013-03-25','08:40:00',4.9),('12374','2013-03-25','08:45:00',7.21),('12374','2013-03-25','08:50:00',6.25),('12374','2013-03-25','08:55:00',3.64),('12374','2013-03-25','09:00:00',1.78),('12374','2013-03-25','09:05:00',2.01),('12374','2013-03-25','09:10:00',1.92),('12374','2013-03-25','09:15:00',2.25),('12374','2013-03-25','09:20:00',2.79),('12374','2013-03-25','09:25:00',4.24),('12374','2013-03-25','09:30:00',5.89),('12374','2013-03-25','09:35:00',5.77),('12374','2013-03-25','09:40:00',4.11),('12374','2013-03-25','09:45:00',4.48),('12374','2013-03-25','09:50:00',4.17),('12374','2013-03-25','09:55:00',3.27),('12374','2013-03-25','10:00:00',4.24),('12374','2013-03-25','10:05:00',2.64),('12374','2013-03-25','10:10:00',5.18),('12374','2013-03-25','10:15:00',4.49),('12374','2013-03-25','10:20:00',8.22),('12374','2013-03-25','10:25:00',8.63),('12374','2013-03-25','10:30:00',7.44),('12374','2013-03-25','10:35:00',7.1),('12374','2013-03-25','10:40:00',8.92),('12374','2013-03-25','10:45:00',8.01),('12374','2013-03-25','10:50:00',8.28),('12374','2013-03-25','10:55:00',8.07),('12374','2013-03-25','11:00:00',7.38),('12374','2013-03-25','11:05:00',6.4),('12374','2013-03-25','11:10:00',6.43),('12374','2013-03-25','11:15:00',5.03),('12374','2013-03-25','11:20:00',5.76),('12374','2013-03-25','11:25:00',7.06),('12374','2013-03-25','11:30:00',9.5),('12374','2013-03-25','11:35:00',8.31),('12374','2013-03-25','11:40:00',5.06),('12374','2013-03-25','11:45:00',5.24),('12374','2013-03-25','11:50:00',9.65),('12374','2013-03-25','11:55:00',8.53),('12374','2013-03-25','12:00:00',7.92),('12374','2013-03-25','12:05:00',8.74),('12374','2013-03-25','12:10:00',8.83),('12374','2013-03-25','12:15:00',9.88),('12374','2013-03-25','12:20:00',8.64),('12374','2013-03-25','12:25:00',7.92),('12374','2013-03-25','12:30:00',9.78),('12374','2013-03-25','12:35:00',6.45),('12374','2013-03-25','12:40:00',8.66),('12374','2013-03-25','12:45:00',9.59),('12374','2013-03-25','12:50:00',9.09),('12374','2013-03-25','12:55:00',4.44),('12374','2013-03-25','13:00:00',2.96),('12374','2013-03-25','13:05:00',3.45),('12374','2013-03-25','13:10:00',5.72),('12374','2013-03-25','13:15:00',7.23),('12374','2013-03-25','13:20:00',8.56),('12374','2013-03-25','13:25:00',7.49),('12374','2013-03-25','13:30:00',8.61),('12374','2013-03-25','13:35:00',6.27),('12374','2013-03-25','13:40:00',6.82),('12374','2013-03-25','13:45:00',7.5),('12374','2013-03-25','13:50:00',6.98),('12374','2013-03-25','13:55:00',8.07),('12374','2013-03-25','14:00:00',6.57),('12374','2013-03-25','14:05:00',6.14),('12374','2013-03-25','14:10:00',4.73),('12374','2013-03-25','14:15:00',6.53),('12374','2013-03-25','14:20:00',5.59),('12374','2013-03-25','14:25:00',4.99),('12374','2013-03-25','14:30:00',4.71),('12374','2013-03-25','14:35:00',4.06),('12374','2013-03-25','14:40:00',4.36),('12374','2013-03-25','14:45:00',5.24),('12374','2013-03-25','14:50:00',5.04),('12374','2013-03-25','14:55:00',4.44),('12374','2013-03-25','15:00:00',6),('12374','2013-03-25','15:05:00',6.59),('12374','2013-03-25','15:10:00',6.49),('12374','2013-03-25','15:15:00',6.38),('12374','2013-03-25','15:20:00',4.86),('12374','2013-03-25','15:25:00',3.63),('12374','2013-03-25','15:30:00',5.33),('12374','2013-03-25','15:35:00',3.62),('12374','2013-03-25','15:40:00',3.92),('12374','2013-03-25','15:45:00',4.63),('12374','2013-03-25','15:50:00',4.75),('12374','2013-03-25','15:55:00',3.68),('12374','2013-03-25','16:00:00',5.32),('12374','2013-03-25','16:05:00',4.36),('12374','2013-03-25','16:10:00',4.3),('12374','2013-03-25','16:15:00',4.23),('12374','2013-03-25','16:20:00',3.56),('12374','2013-03-25','16:25:00',2.38),('12374','2013-03-25','16:30:00',1.62),('12374','2013-03-25','16:35:00',1.64),('12374','2013-03-25','16:40:00',2.21),('12374','2013-03-25','16:45:00',3.03),('12374','2013-03-25','16:50:00',2.36),('12374','2013-03-25','16:55:00',1.82),('12374','2013-03-25','17:00:00',1.6),('12374','2013-03-25','17:05:00',1.38),('12374','2013-03-25','17:10:00',1.12),('12374','2013-03-24','06:50:00',1.06),('12374','2013-03-24','06:55:00',1.28),('12374','2013-03-24','07:00:00',1.62),('12374','2013-03-24','07:05:00',1.84),('12374','2013-03-24','07:10:00',1.91),('12374','2013-03-24','07:15:00',2),('12374','2013-03-24','07:20:00',2.04),('12374','2013-03-24','07:25:00',2.28),('12374','2013-03-24','07:30:00',2.44),('12374','2013-03-24','07:35:00',2.9),('12374','2013-03-24','07:40:00',2.7),('12374','2013-03-24','07:45:00',3.14),('12374','2013-03-24','07:50:00',3.28),('12374','2013-03-24','07:55:00',3.78),('12374','2013-03-24','08:00:00',3.81),('12374','2013-03-24','08:05:00',3.9),('12374','2013-03-24','08:10:00',4.1),('12374','2013-03-24','08:15:00',4.32),('12374','2013-03-24','08:20:00',4.6),('12374','2013-03-24','08:25:00',4.81),('12374','2013-03-24','08:30:00',4.95),('12374','2013-03-24','08:35:00',5.11),('12374','2013-03-24','08:40:00',5.32),('12374','2013-03-24','08:45:00',5.49),('12374','2013-03-24','08:50:00',5.63),('12374','2013-03-24','08:55:00',5.8),('12374','2013-03-24','09:00:00',5.95),('12374','2013-03-24','09:05:00',6.07),('12374','2013-03-24','09:10:00',6.26),('12374','2013-03-24','09:15:00',6.4),('12374','2013-03-24','09:20:00',6.52),('12374','2013-03-24','09:25:00',6.61),('12374','2013-03-24','09:30:00',6.73),('12374','2013-03-24','09:35:00',6.9),('12374','2013-03-24','09:40:00',7.01),('12374','2013-03-24','09:45:00',7.11),('12374','2013-03-24','09:50:00',7.2),('12374','2013-03-24','09:55:00',7.31),('12374','2013-03-24','10:00:00',7.43),('12374','2013-03-24','10:05:00',7.56),('12374','2013-03-24','10:10:00',7.65),('12374','2013-03-24','10:15:00',7.76),('12374','2013-03-24','10:20:00',7.82),('12374','2013-03-24','10:25:00',7.91),('12374','2013-03-24','10:30:00',7.99),('12374','2013-03-24','10:35:00',8.08),('12374','2013-03-24','10:40:00',8.18),('12374','2013-03-24','10:45:00',8.27),('12374','2013-03-24','10:50:00',8.34),('12374','2013-03-24','10:55:00',8.41),('12374','2013-03-24','11:00:00',8.47),('12374','2013-03-24','11:05:00',8.54),('12374','2013-03-24','11:10:00',8.54),('12374','2013-03-24','11:15:00',8.58),('12374','2013-03-24','11:20:00',8.63),('12374','2013-03-24','11:25:00',8.71),('12374','2013-03-24','11:30:00',8.75),('12374','2013-03-24','11:35:00',8.74),('12374','2013-03-24','11:40:00',8.72),('12374','2013-03-24','11:45:00',8.78),('12374','2013-03-24','11:50:00',8.83),('12374','2013-03-24','11:55:00',8.79),('12374','2013-03-24','12:00:00',8.78),('12374','2013-03-24','12:05:00',8.79),('12374','2013-03-24','12:10:00',8.76),('12374','2013-03-24','12:15:00',8.79),('12374','2013-03-24','12:20:00',8.78),('12374','2013-03-24','12:25:00',8.72),('12374','2013-03-24','12:30:00',8.68),('12374','2013-03-24','12:35:00',8.58),('12374','2013-03-24','12:40:00',8.56),('12374','2013-03-24','12:45:00',8.59),('12374','2013-03-24','12:50:00',8.61),('12374','2013-03-24','12:55:00',8.61),('12374','2013-03-24','13:00:00',8.66),('12374','2013-03-24','13:05:00',8.56),('12374','2013-03-24','13:10:00',8.51),('12374','2013-03-24','13:15:00',8.47),('12374','2013-03-24','13:20:00',8.38),('12374','2013-03-24','13:25:00',8.23),('12374','2013-03-24','13:30:00',8.14),('12374','2013-03-24','13:35:00',8.05),('12374','2013-03-24','13:40:00',7.95),('12374','2013-03-24','13:45:00',7.96),('12374','2013-03-24','13:50:00',7.86),('12374','2013-03-24','13:55:00',7.78),('12374','2013-03-24','14:00:00',7.73),('12374','2013-03-24','14:05:00',7.71),('12374','2013-03-24','14:10:00',6.26),('12374','2013-03-24','14:15:00',6.75),('12374','2013-03-24','14:20:00',7.17),('12374','2013-03-24','14:25:00',7.09),('12374','2013-03-24','14:30:00',7.01),('12374','2013-03-24','14:35:00',5.75),('12374','2013-03-24','14:40:00',6.89),('12374','2013-03-24','14:45:00',6.53),('12374','2013-03-24','14:50:00',6.38),('12374','2013-03-24','14:55:00',6),('12374','2013-03-24','15:00:00',5.58),('12374','2013-03-24','15:05:00',3.74),('12374','2013-03-24','15:10:00',5.08),('12374','2013-03-24','15:15:00',3.95),('12374','2013-03-24','15:20:00',4.75),('12374','2013-03-24','15:25:00',3.52),('12374','2013-03-24','15:30:00',3.2),('12374','2013-03-24','15:35:00',4.7),('12374','2013-03-24','15:40:00',1.99),('12374','2013-03-24','15:45:00',2.6),('12374','2013-03-24','15:50:00',4.42),('12374','2013-03-24','15:55:00',2.69),('12374','2013-03-24','16:00:00',1.66),('12374','2013-03-24','16:05:00',2.87),('12374','2013-03-24','16:10:00',2.97),('12374','2013-03-24','16:15:00',2.27),('12374','2013-03-24','16:20:00',2.4),('12374','2013-03-24','16:25:00',1.81),('12374','2013-03-24','16:30:00',1.45),('12374','2013-03-24','16:35:00',1.51),('12374','2013-03-24','16:40:00',1.43),('12374','2013-03-24','16:45:00',1.51),('12374','2013-03-24','16:50:00',1.63),('12374','2013-03-24','16:55:00',1.45),('12374','2013-03-24','17:00:00',1.22),('12374','2013-03-24','17:05:00',1.02),('12374','2013-03-23','06:50:00',1.22),('12374','2013-03-23','06:55:00',1.4),('12374','2013-03-23','07:00:00',1.61),('12374','2013-03-23','07:05:00',1.67),('12374','2013-03-23','07:10:00',1.53),('12374','2013-03-23','07:15:00',1.54),('12374','2013-03-23','07:20:00',2),('12374','2013-03-23','07:25:00',1.86),('12374','2013-03-23','07:30:00',2.12),('12374','2013-03-23','07:35:00',2.87),('12374','2013-03-23','07:40:00',3.17),('12374','2013-03-23','07:45:00',3.34),('12374','2013-03-23','07:50:00',3.74),('12374','2013-03-23','07:55:00',3.79),('12374','2013-03-23','08:00:00',3.98),('12374','2013-03-23','08:05:00',4.13),('12374','2013-03-23','08:10:00',4.42),('12374','2013-03-23','08:15:00',4.58),('12374','2013-03-23','08:20:00',4.81),('12374','2013-03-23','08:25:00',4.97),('12374','2013-03-23','08:30:00',4.94),('12374','2013-03-23','08:35:00',5.17),('12374','2013-03-23','08:40:00',5.49),('12374','2013-03-23','08:45:00',5.49),('12374','2013-03-23','08:50:00',5.64),('12374','2013-03-23','08:55:00',5.75),('12374','2013-03-23','09:00:00',5.87),('12374','2013-03-23','09:05:00',6.12),('12374','2013-03-23','09:10:00',6.37),('12374','2013-03-23','09:15:00',6.46),('12374','2013-03-23','09:20:00',6.5),('12374','2013-03-23','09:25:00',6.65),('12374','2013-03-23','09:30:00',6.75),('12374','2013-03-23','09:35:00',7),('12374','2013-03-23','09:40:00',7.13),('12374','2013-03-23','09:45:00',7.18),('12374','2013-03-23','09:50:00',7.21),('12374','2013-03-23','09:55:00',7.18),('12374','2013-03-23','10:00:00',6.68),('12374','2013-03-23','10:05:00',7.21),('12374','2013-03-23','10:10:00',7.35),('12374','2013-03-23','10:15:00',7.37),('12374','2013-03-23','10:20:00',7.29),('12374','2013-03-23','10:25:00',7.04),('12374','2013-03-23','10:30:00',7.15),('12374','2013-03-23','10:35:00',7.73),('12374','2013-03-23','10:40:00',7.94),('12374','2013-03-23','10:45:00',8.22),('12374','2013-03-23','10:50:00',7.89),('12374','2013-03-23','10:55:00',8.41),('12374','2013-03-23','11:00:00',8.5),('12374','2013-03-23','11:05:00',8.1),('12374','2013-03-23','11:10:00',8.34),('12374','2013-03-23','11:15:00',8.23),('12374','2013-03-23','11:20:00',8.65),('12374','2013-03-23','11:25:00',8.64),('12374','2013-03-23','11:30:00',8.73),('12374','2013-03-23','11:35:00',8.58),('12374','2013-03-23','11:40:00',8.79),('12374','2013-03-23','11:45:00',8.07),('12374','2013-03-23','11:50:00',8.64),('12374','2013-03-23','11:55:00',8.93),('12374','2013-03-23','12:00:00',8.85),('12374','2013-03-23','12:05:00',9),('12374','2013-03-23','12:10:00',8.86),('12374','2013-03-23','12:15:00',8.96),('12374','2013-03-23','12:20:00',8.92),('12374','2013-03-23','12:25:00',8.89),('12374','2013-03-23','12:30:00',8.95),('12374','2013-03-23','12:35:00',8.78),('12374','2013-03-23','12:40:00',8.74),('12374','2013-03-23','12:45:00',8.73),('12374','2013-03-23','12:50:00',8.67),('12374','2013-03-23','12:55:00',8.69),('12374','2013-03-23','13:00:00',8.73),('12374','2013-03-23','13:05:00',8.5),('12374','2013-03-23','13:10:00',8.55),('12374','2013-03-23','13:15:00',8.42),('12374','2013-03-23','13:20:00',8.42),('12374','2013-03-23','13:25:00',8.39),('12374','2013-03-23','13:30:00',8.19),('12374','2013-03-23','13:35:00',8.08),('12374','2013-03-23','13:40:00',8.05),('12374','2013-03-23','13:45:00',8.27),('12374','2013-03-23','13:50:00',8.1),('12374','2013-03-23','13:55:00',7.68),('12374','2013-03-23','14:00:00',7.84),('12374','2013-03-23','14:05:00',7.73),('12374','2013-03-23','14:10:00',7.68),('12374','2013-03-23','14:15:00',7.2),('12374','2013-03-23','14:20:00',7.17),('12374','2013-03-23','14:25:00',6.93),('12374','2013-03-23','14:30:00',6.69),('12374','2013-03-23','14:35:00',6.58),('12374','2013-03-23','14:40:00',6.28),('12374','2013-03-23','14:45:00',6.79),('12374','2013-03-23','14:50:00',6.58),('12374','2013-03-23','14:55:00',6.06),('12374','2013-03-23','15:00:00',6.28),('12374','2013-03-23','15:05:00',6.36),('12374','2013-03-23','15:10:00',6.02),('12374','2013-03-23','15:15:00',5.67),('12374','2013-03-23','15:20:00',5.01),('12374','2013-03-23','15:25:00',4.73),('12374','2013-03-23','15:30:00',5.04),('12374','2013-03-23','15:35:00',5.02),('12374','2013-03-23','15:40:00',5.12),('12374','2013-03-23','15:45:00',4.35),('12374','2013-03-23','15:50:00',4.33),('12374','2013-03-23','15:55:00',4.01),('12374','2013-03-23','16:00:00',4.23),('12374','2013-03-23','16:05:00',3.85),('12374','2013-03-23','16:10:00',4.1),('12374','2013-03-23','16:15:00',3.52),('12374','2013-03-23','16:20:00',3.63),('12374','2013-03-23','16:25:00',3.78),('12374','2013-03-23','16:30:00',2.82),('12374','2013-03-23','16:35:00',2.44),('12374','2013-03-23','16:40:00',2.63),('12374','2013-03-23','16:45:00',2.02),('12374','2013-03-23','16:50:00',1.83),('12374','2013-03-23','16:55:00',1.93),('12374','2013-03-23','17:00:00',1.87),('12374','2013-03-23','17:05:00',1.38),('12374','2013-03-23','17:10:00',1.28),('12374','2013-03-23','17:15:00',1.32),('12374','2013-03-23','17:20:00',1.08),('12374','2013-03-22','06:40:00',1),('12374','2013-03-22','06:45:00',1.2),('12374','2013-03-22','06:50:00',1.25),('12374','2013-03-22','06:55:00',1.6),('12374','2013-03-22','07:00:00',1.79),('12374','2013-03-22','07:05:00',1.88),('12374','2013-03-22','07:10:00',1.75),('12374','2013-03-22','07:15:00',1.75),('12374','2013-03-22','07:20:00',1.97),('12374','2013-03-22','07:25:00',2.09),('12374','2013-03-22','07:30:00',2.22),('12374','2013-03-22','07:35:00',2.7),('12374','2013-03-22','07:40:00',3.41),('12374','2013-03-22','07:45:00',3.62),('12374','2013-03-22','07:50:00',3.79),('12374','2013-03-22','07:55:00',3.99),('12374','2013-03-22','08:00:00',4.18),('12374','2013-03-22','08:05:00',4.35),('12374','2013-03-22','08:10:00',4.51),('12374','2013-03-22','08:15:00',4.68),('12374','2013-03-22','08:20:00',4.84),('12374','2013-03-22','08:25:00',5),('12374','2013-03-22','08:30:00',5.14),('12374','2013-03-22','08:35:00',5.28),('12374','2013-03-22','08:40:00',5.42),('12374','2013-03-22','08:45:00',5.56),('12374','2013-03-22','08:50:00',5.71),('12374','2013-03-22','08:55:00',5.84),('12374','2013-03-22','09:00:00',5.98),('12374','2013-03-22','09:05:00',6.13),('12374','2013-03-22','09:10:00',6.33),('12374','2013-03-22','09:15:00',6.46),('12374','2013-03-22','09:20:00',6.58),('12374','2013-03-22','09:25:00',6.71),('12374','2013-03-22','09:30:00',6.83),('12374','2013-03-22','09:35:00',6.96),('12374','2013-03-22','09:40:00',7.08),('12374','2013-03-22','09:45:00',7.16),('12374','2013-03-22','09:50:00',7.3),('12374','2013-03-22','09:55:00',7.41),('12374','2013-03-22','10:00:00',7.52),('12374','2013-03-22','10:05:00',7.63),('12374','2013-03-22','10:10:00',7.71),('12374','2013-03-22','10:15:00',7.8),('12374','2013-03-22','10:20:00',7.88),('12374','2013-03-22','10:25:00',7.94),('12374','2013-03-22','10:30:00',8.02),('12374','2013-03-22','10:35:00',8.12),('12374','2013-03-22','10:40:00',8.23),('12374','2013-03-22','10:45:00',8.28),('12374','2013-03-22','10:50:00',8.31),('12374','2013-03-22','10:55:00',8.28),('12374','2013-03-22','11:00:00',8.51),('12374','2013-03-22','11:05:00',8.63),('12374','2013-03-22','11:10:00',8.72),('12374','2013-03-22','11:15:00',8.79),('12374','2013-03-22','11:20:00',8.81),('12374','2013-03-22','11:25:00',8.9),('12374','2013-03-22','11:30:00',8.98),('12374','2013-03-22','11:35:00',9.06),('12374','2013-03-22','11:40:00',9.1),('12374','2013-03-22','11:45:00',9.16),('12374','2013-03-22','11:50:00',9.16),('12374','2013-03-22','11:55:00',9.25),('12374','2013-03-22','12:00:00',9.27),('12374','2013-03-22','12:05:00',9.27),('12374','2013-03-22','12:10:00',9.23),('12374','2013-03-22','12:15:00',9.23),('12374','2013-03-22','12:20:00',9.22),('12374','2013-03-22','12:25:00',9.23),('12374','2013-03-22','12:30:00',9.19),('12374','2013-03-22','12:35:00',8.88),('12374','2013-03-22','12:40:00',8.8),('12374','2013-03-22','12:45:00',9.25),('12374','2013-03-22','12:50:00',9.17),('12374','2013-03-22','12:55:00',9.11),('12374','2013-03-22','13:00:00',9.03),('12374','2013-03-22','13:05:00',8.93),('12374','2013-03-22','13:10:00',8.35),('12374','2013-03-22','13:15:00',8.53),('12374','2013-03-22','13:20:00',8.39),('12374','2013-03-22','13:25:00',7.05),('12374','2013-03-22','13:30:00',7.74),('12374','2013-03-22','13:35:00',8.49),('12374','2013-03-22','13:40:00',8.33),('12374','2013-03-22','13:45:00',8.25),('12374','2013-03-22','13:50:00',8.11),('12374','2013-03-22','13:55:00',7.99),('12374','2013-03-22','14:00:00',7.92),('12374','2013-03-22','14:05:00',7.76),('12374','2013-03-22','14:10:00',7.7),('12374','2013-03-22','14:15:00',7.67),('12374','2013-03-22','14:20:00',7.5),('12374','2013-03-22','14:25:00',7.36),('12374','2013-03-22','14:30:00',7.31),('12374','2013-03-22','14:35:00',7.2),('12374','2013-03-22','14:40:00',7.12),('12374','2013-03-22','14:45:00',6.99),('12374','2013-03-22','14:50:00',6.87),('12374','2013-03-22','14:55:00',6.76),('12374','2013-03-22','15:00:00',6.52),('12374','2013-03-22','15:05:00',5.92),('12374','2013-03-22','15:10:00',5.99),('12374','2013-03-22','15:15:00',5.66),('12374','2013-03-22','15:20:00',5.57),('12374','2013-03-22','15:25:00',5.79),('12374','2013-03-22','15:30:00',5.64),('12374','2013-03-22','15:35:00',5.51),('12374','2013-03-22','15:40:00',4.62),('12374','2013-03-22','15:45:00',3.2),('12374','2013-03-22','15:50:00',3.2),('12374','2013-03-22','15:55:00',3.06),('12374','2013-03-22','16:00:00',3.48),('12374','2013-03-22','16:05:00',3.13),('12374','2013-03-22','16:10:00',1.95),('12374','2013-03-22','16:15:00',2.54),('12374','2013-03-22','16:20:00',3.85),('12374','2013-03-22','16:25:00',2.67),('12374','2013-03-22','16:30:00',2.95),('12374','2013-03-22','16:35:00',2.81),('12374','2013-03-22','16:40:00',3.12),('12374','2013-03-22','16:45:00',2.63),('12374','2013-03-22','16:50:00',2.1),('12374','2013-03-22','16:55:00',2.17),('12374','2013-03-22','17:00:00',1.96),('12374','2013-03-22','17:05:00',1.84),('12374','2013-03-22','17:10:00',1.6),('12374','2013-03-22','17:15:00',1.23),('12374','2013-03-22','17:20:00',1.08),('12374','2013-03-22','17:30:00',1.01),('12374','2013-03-21','07:40:00',2.46),('12374','2013-03-21','07:45:00',4.32),('12374','2013-03-21','07:50:00',3.79),('12374','2013-03-21','07:55:00',1.81),('12374','2013-03-21','08:00:00',1.93),('12374','2013-03-21','08:05:00',2.12),('12374','2013-03-21','08:10:00',3.47),('12374','2013-03-21','08:15:00',3.49),('12374','2013-03-21','08:20:00',4.81),('12374','2013-03-21','08:25:00',4.93),('12374','2013-03-21','08:30:00',5.03),('12374','2013-03-21','08:35:00',3.74),('12374','2013-03-21','08:40:00',5.41),('12374','2013-03-21','08:45:00',5.56),('12374','2013-03-21','08:50:00',5.71),('12374','2013-03-21','08:55:00',4.49),('12374','2013-03-21','09:00:00',5.62),('12374','2013-03-21','09:05:00',6.17),('12374','2013-03-21','09:10:00',6.36),('12374','2013-03-21','09:15:00',6.52),('12374','2013-03-21','09:20:00',6.65),('12374','2013-03-21','09:25:00',6.77),('12374','2013-03-21','09:30:00',6.88),('12374','2013-03-21','09:35:00',7),('12374','2013-03-21','09:40:00',7.15),('12374','2013-03-21','09:45:00',7.23),('12374','2013-03-21','09:50:00',7.32),('12374','2013-03-21','09:55:00',7.49),('12374','2013-03-21','10:00:00',7.55),('12374','2013-03-21','10:05:00',7.67),('12374','2013-03-21','10:10:00',7.75),('12374','2013-03-21','10:15:00',7.9),('12374','2013-03-21','10:20:00',8),('12374','2013-03-21','10:25:00',8.15),('12374','2013-03-21','10:30:00',8.3),('12374','2013-03-21','10:35:00',8.41),('12374','2013-03-21','10:40:00',8.51),('12374','2013-03-21','10:45:00',8.57),('12374','2013-03-21','10:50:00',8.69),('12374','2013-03-21','10:55:00',8.77),('12374','2013-03-21','11:00:00',8.88),('12374','2013-03-21','11:05:00',8.98),('12374','2013-03-21','11:10:00',9.04),('12374','2013-03-21','11:15:00',9.04),('12374','2013-03-21','11:20:00',9.18),('12374','2013-03-21','11:25:00',9.25),('12374','2013-03-21','11:30:00',9.27),('12374','2013-03-21','11:35:00',9.35),('12374','2013-03-21','11:40:00',9.44),('12374','2013-03-21','11:45:00',9.44),('12374','2013-03-21','11:50:00',9.46),('12374','2013-03-21','11:55:00',9.44),('12374','2013-03-21','12:00:00',9.48),('12374','2013-03-21','12:05:00',9.54),('12374','2013-03-21','12:10:00',9.57),('12374','2013-03-21','12:15:00',9.56),('12374','2013-03-21','12:20:00',9.55),('12374','2013-03-21','12:25:00',9.52),('12374','2013-03-21','12:30:00',9.48),('12374','2013-03-21','12:35:00',9.39),('12374','2013-03-21','12:40:00',9.31),('12374','2013-03-21','12:45:00',9.28),('12374','2013-03-21','12:50:00',9.25),('12374','2013-03-21','12:55:00',9.22),('12374','2013-03-21','13:00:00',9.15),('12374','2013-03-21','13:05:00',9.09),('12374','2013-03-21','13:10:00',9.07),('12374','2013-03-21','13:15:00',9.02),('12374','2013-03-21','13:20:00',8.91),('12374','2013-03-21','13:25:00',8.82),('12374','2013-03-21','13:30:00',8.73),('12374','2013-03-21','13:35:00',8.58),('12374','2013-03-21','13:40:00',8.53),('12374','2013-03-21','13:45:00',8.4),('12374','2013-03-21','13:50:00',8.28),('12374','2013-03-21','13:55:00',8.19),('12374','2013-03-21','14:00:00',8.08),('12374','2013-03-21','14:05:00',7.95),('12374','2013-03-21','14:10:00',7.85),('12374','2013-03-21','14:15:00',7.7),('12374','2013-03-21','14:20:00',7.59),('12374','2013-03-21','14:25:00',7.5),('12374','2013-03-21','14:30:00',7.42),('12374','2013-03-21','14:35:00',7.27),('12374','2013-03-21','14:40:00',7.15),('12374','2013-03-21','14:45:00',7.02),('12374','2013-03-21','14:50:00',6.89),('12374','2013-03-21','14:55:00',6.77),('12374','2013-03-21','15:00:00',6.6),('12374','2013-03-21','15:05:00',6.49),('12374','2013-03-21','15:10:00',6.34),('12374','2013-03-21','15:15:00',6.18),('12374','2013-03-21','15:20:00',5.96),('12374','2013-03-21','15:25:00',5.78),('12374','2013-03-21','15:30:00',5.63),('12374','2013-03-21','15:35:00',5.47),('12374','2013-03-21','15:40:00',5.32),('12374','2013-03-21','15:45:00',5.17),('12374','2013-03-21','15:50:00',5),('12374','2013-03-21','15:55:00',4.82),('12374','2013-03-21','16:00:00',4.62),('12374','2013-03-21','16:05:00',4.46),('12374','2013-03-21','16:10:00',4.31),('12374','2013-03-21','16:15:00',4.12),('12374','2013-03-21','16:20:00',3.68),('12374','2013-03-21','16:25:00',3.76),('12374','2013-03-21','16:30:00',3.52),('12374','2013-03-21','16:35:00',3.39),('12374','2013-03-21','16:40:00',3.02),('12374','2013-03-21','16:45:00',2.63),('12374','2013-03-21','16:50:00',2.37),('12374','2013-03-21','16:55:00',2.04),('12374','2013-03-21','17:00:00',1.64),('12374','2013-03-21','17:05:00',1.47),('12374','2013-03-21','17:10:00',1.26),('12374','2013-03-21','17:15:00',1.15),('12374','2013-03-21','17:20:00',1.03),('12374','2013-03-20','06:50:00',1.08),('12374','2013-03-20','06:55:00',1.27),('12374','2013-03-20','07:00:00',1.59),('12374','2013-03-20','07:05:00',1.8),('12374','2013-03-20','07:10:00',1.97),('12374','2013-03-20','07:15:00',1.66),('12374','2013-03-20','07:20:00',1.96),('12374','2013-03-20','07:25:00',2.25),('12374','2013-03-20','07:30:00',1.45),('12374','2013-03-20','07:35:00',1.78),('12374','2013-03-20','07:40:00',2.23),('12374','2013-03-20','07:45:00',3.07),('12374','2013-03-20','07:50:00',3.39),('12374','2013-03-20','07:55:00',3.77),('12374','2013-03-20','08:00:00',4.04),('12374','2013-03-20','08:05:00',4.2),('12374','2013-03-20','08:10:00',4.39),('12374','2013-03-20','08:15:00',4.67),('12374','2013-03-20','08:20:00',4.93),('12374','2013-03-20','08:25:00',2.73),('12374','2013-03-20','08:30:00',2.28),('12374','2013-03-20','08:35:00',4.23),('12374','2013-03-20','08:40:00',5.4),('12374','2013-03-20','08:45:00',5.34),('12374','2013-03-20','08:50:00',5.65),('12374','2013-03-20','08:55:00',5.92),('12374','2013-03-20','09:00:00',5.96),('12374','2013-03-20','09:05:00',5.87),('12374','2013-03-20','09:10:00',6.08),('12374','2013-03-20','09:15:00',6.22),('12374','2013-03-20','09:20:00',6.32),('12374','2013-03-20','09:25:00',5.08),('12374','2013-03-20','09:30:00',6.75),('12374','2013-03-20','09:35:00',6.89),('12374','2013-03-20','09:40:00',6.87),('12374','2013-03-20','09:45:00',6.88),('12374','2013-03-20','09:50:00',7.53),('12374','2013-03-20','09:55:00',7.43),('12374','2013-03-20','10:00:00',7.49),('12374','2013-03-20','10:05:00',7.63),('12374','2013-03-20','10:10:00',7.71),('12374','2013-03-20','10:15:00',7.87),('12374','2013-03-20','10:20:00',7.77),('12374','2013-03-20','10:25:00',7.07),('12374','2013-03-20','10:30:00',7.46),('12374','2013-03-20','10:35:00',8.1),('12374','2013-03-20','10:40:00',7.78),('12374','2013-03-20','10:45:00',4.49),('12374','2013-03-20','10:50:00',3.58),('12374','2013-03-20','10:55:00',4.56),('12374','2013-03-20','11:00:00',5.9),('12374','2013-03-20','11:05:00',6.09),('12374','2013-03-20','11:10:00',7.28),('12374','2013-03-20','11:15:00',5.62),('12374','2013-03-20','11:20:00',5.45),('12374','2013-03-20','11:25:00',5.89),('12374','2013-03-20','11:30:00',5.6),('12374','2013-03-20','11:35:00',5.82),('12374','2013-03-20','11:40:00',4.61),('12374','2013-03-20','11:45:00',5.07),('12374','2013-03-20','11:50:00',3.76),('12374','2013-03-20','11:55:00',3.34),('12374','2013-03-20','12:00:00',4.7),('12374','2013-03-20','12:05:00',6.13),('12374','2013-03-20','12:10:00',5.02),('12374','2013-03-20','12:15:00',2.7),('12374','2013-03-20','12:20:00',2.88),('12374','2013-03-20','12:25:00',2.88),('12374','2013-03-20','12:30:00',2.93),('12374','2013-03-20','12:35:00',2.62),('12374','2013-03-20','12:40:00',2.37),('12374','2013-03-20','12:45:00',2.35),('12374','2013-03-20','12:50:00',3.31),('12374','2013-03-20','12:55:00',2.21),('12374','2013-03-20','13:00:00',1.52),('12374','2013-03-20','13:05:00',1.91),('12374','2013-03-20','13:10:00',2.26),('12374','2013-03-20','13:15:00',2.47),('12374','2013-03-20','13:20:00',2.27),('12374','2013-03-20','13:25:00',2.49),('12374','2013-03-20','13:30:00',2.61),('12374','2013-03-20','13:35:00',2.6),('12374','2013-03-20','13:40:00',3.11),('12374','2013-03-20','13:45:00',3.18),('12374','2013-03-20','13:50:00',3.16),('12374','2013-03-20','13:55:00',2.87),('12374','2013-03-20','14:00:00',2.78),('12374','2013-03-20','14:05:00',2.33),('12374','2013-03-20','14:10:00',2.09),('12374','2013-03-20','14:15:00',1.64),('12374','2013-03-20','14:20:00',1.46),('12374','2013-03-20','14:25:00',1.6),('12374','2013-03-20','14:30:00',1.73),('12374','2013-03-20','14:35:00',1.7),('12374','2013-03-20','14:40:00',1.18),('12374','2013-03-20','14:45:00',1.03),('12374','2013-03-20','14:50:00',1.07),('12374','2013-03-19','06:50:00',1.15),('12374','2013-03-19','06:55:00',1.26),('12374','2013-03-19','07:00:00',1.52),('12374','2013-03-19','07:05:00',1.75),('12374','2013-03-19','07:10:00',1.93),('12374','2013-03-19','07:15:00',1.74),('12374','2013-03-19','07:20:00',1.83),('12374','2013-03-19','07:25:00',2.03),('12374','2013-03-19','07:30:00',2.17),('12374','2013-03-19','07:35:00',2.29),('12374','2013-03-19','07:40:00',2.76),('12374','2013-03-19','07:45:00',3.34),('12374','2013-03-19','07:50:00',3.55),('12374','2013-03-19','07:55:00',3.75),('12374','2013-03-19','08:00:00',3.95),('12374','2013-03-19','08:05:00',4.12),('12374','2013-03-19','08:10:00',4.29),('12374','2013-03-19','08:15:00',4.46),('12374','2013-03-19','08:20:00',4.63),('12374','2013-03-19','08:25:00',4.8),('12374','2013-03-19','08:30:00',4.97),('12374','2013-03-19','08:35:00',5.2),('12374','2013-03-19','08:40:00',5.3),('12374','2013-03-19','08:45:00',5.46),('12374','2013-03-19','08:50:00',5.63),('12374','2013-03-19','08:55:00',5.8),('12374','2013-03-19','09:00:00',5.98),('12374','2013-03-19','09:05:00',6.12),('12374','2013-03-19','09:10:00',6.22),('12374','2013-03-19','09:15:00',6.38),('12374','2013-03-19','09:20:00',6.56),('12374','2013-03-19','09:25:00',6.66),('12374','2013-03-19','09:30:00',6.8),('12374','2013-03-19','09:35:00',6.93),('12374','2013-03-19','09:40:00',7.05),('12374','2013-03-19','09:45:00',7.18),('12374','2013-03-19','09:50:00',7.32),('12374','2013-03-19','09:55:00',7.4),('12374','2013-03-19','10:00:00',7.69),('12374','2013-03-19','10:05:00',7.67),('12374','2013-03-19','10:10:00',7.82),('12374','2013-03-19','10:15:00',7.9),('12374','2013-03-19','10:20:00',8.05),('12374','2013-03-19','10:25:00',8.1),('12374','2013-03-19','10:30:00',8.21),('12374','2013-03-19','10:35:00',8.34),('12374','2013-03-19','10:40:00',8.43),('12374','2013-03-19','10:45:00',8.53),('12374','2013-03-19','10:50:00',8.63),('12374','2013-03-19','10:55:00',8.67),('12374','2013-03-19','11:00:00',8.78),('12374','2013-03-19','11:05:00',8.91),('12374','2013-03-19','11:10:00',8.96),('12374','2013-03-19','11:15:00',9.03),('12374','2013-03-19','11:20:00',9.09),('12374','2013-03-19','11:25:00',9.13),('12374','2013-03-19','11:30:00',9.2),('12374','2013-03-19','11:35:00',9.31),('12374','2013-03-19','11:40:00',9.36),('12374','2013-03-19','11:45:00',9.38),('12374','2013-03-19','11:50:00',9.38),('12374','2013-03-19','11:55:00',9.39),('12374','2013-03-19','12:00:00',9.39),('12374','2013-03-19','12:05:00',9.39),('12374','2013-03-19','12:10:00',9.36),('12374','2013-03-19','12:15:00',9.31),('12374','2013-03-19','12:20:00',9.3),('12374','2013-03-19','12:25:00',9.32),('12374','2013-03-19','12:30:00',9.31),('12374','2013-03-19','12:35:00',9.32),('12374','2013-03-19','12:40:00',9.29),('12374','2013-03-19','12:45:00',9.26),('12374','2013-03-19','12:50:00',9.07),('12374','2013-03-19','12:55:00',9.03),('12374','2013-03-19','13:00:00',9.09),('12374','2013-03-19','13:05:00',8.95),('12374','2013-03-19','13:10:00',8.81),('12374','2013-03-19','13:15:00',8.78),('12374','2013-03-19','13:20:00',8.45),('12374','2013-03-19','13:25:00',8.54),('12374','2013-03-19','13:30:00',8.6),('12374','2013-03-19','13:35:00',8.21),('12374','2013-03-19','13:40:00',8.07),('12374','2013-03-19','13:45:00',8.33),('12374','2013-03-19','13:50:00',8.23),('12374','2013-03-19','13:55:00',8.11),('12374','2013-03-19','14:00:00',8.03),('12374','2013-03-19','14:05:00',7.94),('12374','2013-03-19','14:10:00',7.81),('12374','2013-03-19','14:15:00',7.69),('12374','2013-03-19','14:20:00',7.49),('12374','2013-03-19','14:25:00',7.37),('12374','2013-03-19','14:30:00',7.26),('12374','2013-03-19','14:35:00',7.21),('12374','2013-03-19','14:40:00',7.08),('12374','2013-03-19','14:45:00',6.97),('12374','2013-03-19','14:50:00',6.85),('12374','2013-03-19','14:55:00',6.69),('12374','2013-03-19','15:00:00',6.56),('12374','2013-03-19','15:05:00',6.4),('12374','2013-03-19','15:10:00',6.23),('12374','2013-03-19','15:15:00',6.08),('12374','2013-03-19','15:20:00',5.93),('12374','2013-03-19','15:25:00',5.73),('12374','2013-03-19','15:30:00',5.62),('12374','2013-03-19','15:35:00',5.46),('12374','2013-03-19','15:40:00',5.33),('12374','2013-03-19','15:45:00',5.15),('12374','2013-03-19','15:50:00',4.95),('12374','2013-03-19','15:55:00',4.8),('12374','2013-03-19','16:00:00',4.65),('12374','2013-03-19','16:05:00',4.47),('12374','2013-03-19','16:10:00',4.29),('12374','2013-03-19','16:15:00',4.11),('12374','2013-03-19','16:20:00',3.93),('12374','2013-03-19','16:25:00',3.77),('12374','2013-03-19','16:30:00',3.56),('12374','2013-03-19','16:35:00',3.4),('12374','2013-03-19','16:40:00',2.76),('12374','2013-03-19','16:45:00',2.36),('12374','2013-03-19','16:50:00',2.17),('12374','2013-03-19','16:55:00',1.83),('12374','2013-03-19','17:00:00',1.49),('12374','2013-03-19','17:15:00',1.04),('12374','2013-03-18','07:40:00',1.04),('12374','2013-03-18','07:45:00',1.3),('12374','2013-03-18','07:50:00',1.75),('12374','2013-03-18','07:55:00',1.38),('12374','2013-03-18','08:00:00',1.59),('12374','2013-03-18','08:05:00',1.55),('12374','2013-03-18','08:10:00',1.44),('12374','2013-03-18','08:15:00',1.05),('12374','2013-03-18','08:40:00',1.09),('12374','2013-03-18','08:45:00',1.14),('12374','2013-03-18','08:50:00',1.01),('12374','2013-03-18','08:55:00',1.03),('12374','2013-03-18','09:20:00',1.04),('12374','2013-03-18','09:25:00',1.02),('12374','2013-03-18','09:35:00',1.11),('12374','2013-03-18','09:40:00',1.27),('12374','2013-03-18','09:45:00',1.68),('12374','2013-03-18','09:50:00',2.07),('12374','2013-03-18','09:55:00',2.03),('12374','2013-03-18','10:00:00',2.07),('12374','2013-03-18','10:05:00',2.89),('12374','2013-03-18','10:10:00',2.85),('12374','2013-03-18','10:15:00',2.2),('12374','2013-03-18','10:20:00',2.11),('12374','2013-03-18','10:25:00',2.21),('12374','2013-03-18','10:30:00',2.29),('12374','2013-03-18','10:35:00',2.03),('12374','2013-03-18','10:40:00',1.66),('12374','2013-03-18','10:45:00',1.74),('12374','2013-03-18','10:50:00',2.42),('12374','2013-03-18','10:55:00',3),('12374','2013-03-18','11:00:00',3.57),('12374','2013-03-18','11:05:00',3.55),('12374','2013-03-18','11:10:00',3.49),('12374','2013-03-18','11:15:00',3.79),('12374','2013-03-18','11:20:00',3.67),('12374','2013-03-18','11:25:00',2.68),('12374','2013-03-18','11:30:00',2.22),('12374','2013-03-18','11:35:00',2.01),('12374','2013-03-18','11:40:00',2.3),('12374','2013-03-18','11:45:00',2.37),('12374','2013-03-18','11:50:00',2.5),('12374','2013-03-18','11:55:00',2.39),('12374','2013-03-18','12:00:00',2.38),('12374','2013-03-18','12:05:00',2.81),('12374','2013-03-18','12:10:00',2.46),('12374','2013-03-18','12:15:00',1.95),('12374','2013-03-18','12:20:00',2.32),('12374','2013-03-18','12:25:00',2.09),('12374','2013-03-18','12:30:00',2.05),('12374','2013-03-18','12:35:00',1.64),('12374','2013-03-18','12:40:00',1.48),('12374','2013-03-18','12:45:00',1.49),('12374','2013-03-18','12:50:00',1.53),('12374','2013-03-18','12:55:00',1.81),('12374','2013-03-18','13:00:00',3.11),('12374','2013-03-18','13:05:00',2.69),('12374','2013-03-18','13:10:00',2.16),('12374','2013-03-18','13:15:00',1.89),('12374','2013-03-18','13:20:00',1.64),('12374','2013-03-18','13:25:00',1.77),('12374','2013-03-18','13:30:00',1.33),('12374','2013-03-18','13:35:00',1.02),('12374','2013-03-18','13:40:00',1.35),('12374','2013-03-18','13:45:00',2.16),('12374','2013-03-18','13:50:00',5.2),('12374','2013-03-18','13:55:00',6.17),('12374','2013-03-18','14:00:00',2.03),('12374','2013-03-18','14:05:00',1.6),('12374','2013-03-18','14:10:00',1.1),('12374','2013-03-17','08:00:00',1.23),('12374','2013-03-17','08:05:00',1.64),('12374','2013-03-17','08:10:00',1.69),('12374','2013-03-17','08:15:00',1.61),('12374','2013-03-17','08:20:00',1.76),('12374','2013-03-17','08:25:00',2.15),('12374','2013-03-17','08:30:00',2.52),('12374','2013-03-17','08:35:00',3.08),('12374','2013-03-17','08:40:00',2.81),('12374','2013-03-17','08:45:00',2.77),('12374','2013-03-17','08:50:00',3.17),('12374','2013-03-17','08:55:00',3.04),('12374','2013-03-17','09:00:00',2.93),('12374','2013-03-17','09:05:00',3.43),('12374','2013-03-17','09:10:00',3.2),('12374','2013-03-17','09:15:00',2.58),('12374','2013-03-17','09:20:00',2.98),('12374','2013-03-17','09:25:00',3.24),('12374','2013-03-17','09:30:00',3.5),('12374','2013-03-17','09:35:00',3.28),('12374','2013-03-17','09:40:00',3.02),('12374','2013-03-17','09:45:00',2.67),('12374','2013-03-17','09:50:00',2.38),('12374','2013-03-17','09:55:00',2.28),('12374','2013-03-17','10:00:00',2.51),('12374','2013-03-17','10:05:00',2.74),('12374','2013-03-17','10:10:00',2.91),('12374','2013-03-17','10:15:00',3.2),('12374','2013-03-17','10:20:00',3.47),('12374','2013-03-17','10:25:00',3.63),('12374','2013-03-17','10:30:00',3.29),('12374','2013-03-17','10:35:00',3.01),('12374','2013-03-17','10:40:00',2.89),('12374','2013-03-17','10:45:00',2.66),('12374','2013-03-17','10:50:00',2.49),('12374','2013-03-17','10:55:00',2.62),('12374','2013-03-17','11:00:00',3.12),('12374','2013-03-17','11:05:00',3.56),('12374','2013-03-17','11:10:00',3.95),('12374','2013-03-17','11:15:00',4.33),('12374','2013-03-17','11:20:00',4.25),('12374','2013-03-17','11:25:00',4.01),('12374','2013-03-17','11:30:00',3.92),('12374','2013-03-17','11:35:00',3.68),('12374','2013-03-17','11:40:00',3.53),('12374','2013-03-17','11:45:00',2.8),('12374','2013-03-17','11:50:00',3.27),('12374','2013-03-17','11:55:00',3.58),('12374','2013-03-17','12:00:00',3.8),('12374','2013-03-17','12:05:00',4.86),('12374','2013-03-17','12:10:00',5.2),('12374','2013-03-17','12:15:00',4.88),('12374','2013-03-17','12:20:00',4.57),('12374','2013-03-17','12:25:00',5.15),('12374','2013-03-17','12:30:00',5.39),('12374','2013-03-17','12:35:00',4.73),('12374','2013-03-17','12:40:00',4.06),('12374','2013-03-17','12:45:00',3.52),('12374','2013-03-17','12:50:00',3.26),('12374','2013-03-17','12:55:00',3.11),('12374','2013-03-17','13:00:00',2.68),('12374','2013-03-17','13:05:00',2.84),('12374','2013-03-17','13:10:00',2.9),('12374','2013-03-17','13:15:00',2.74),('12374','2013-03-17','13:20:00',2.03),('12374','2013-03-17','13:25:00',2.09),('12374','2013-03-17','13:30:00',1.75),('12374','2013-03-17','13:35:00',1.82),('12374','2013-03-17','13:40:00',2.63),('12374','2013-03-17','13:45:00',2.74),('12374','2013-03-17','13:50:00',2.87),('12374','2013-03-17','13:55:00',3.13),('12374','2013-03-17','14:00:00',3.06),('12374','2013-03-17','14:05:00',2.79),('12374','2013-03-17','14:10:00',3.14),('12374','2013-03-17','14:15:00',4.07),('12374','2013-03-17','14:20:00',4.37),('12374','2013-03-17','14:25:00',4.2),('12374','2013-03-17','14:30:00',3.58),('12374','2013-03-17','14:35:00',2.92),('12374','2013-03-17','14:40:00',3.07),('12374','2013-03-17','14:45:00',3.53),('12374','2013-03-17','14:50:00',3.7),('12374','2013-03-17','14:55:00',3.63),('12374','2013-03-17','15:00:00',3.02),('12374','2013-03-17','15:05:00',3.46),('12374','2013-03-17','15:10:00',3.62),('12374','2013-03-17','15:15:00',3.04),('12374','2013-03-17','15:20:00',2.55),('12374','2013-03-17','15:25:00',2.27),('12374','2013-03-17','15:30:00',2.25),('12374','2013-03-17','15:35:00',1.85),('12374','2013-03-17','16:30:00',1.41),('12374','2013-03-17','16:35:00',1.1),('12374','2013-03-16','07:20:00',1.14),('12374','2013-03-16','07:25:00',1.47),('12374','2013-03-16','07:30:00',1.76),('12374','2013-03-16','07:35:00',1.45),('12374','2013-03-16','07:40:00',1.49),('12374','2013-03-16','07:45:00',1.6),('12374','2013-03-16','07:50:00',1.67),('12374','2013-03-16','07:55:00',1.82),('12374','2013-03-16','08:00:00',2.01),('12374','2013-03-16','08:05:00',3.18),('12374','2013-03-16','08:10:00',2.73),('12374','2013-03-16','08:15:00',2.24),('12374','2013-03-16','08:20:00',5.25),('12374','2013-03-16','08:25:00',5.06),('12374','2013-03-16','08:30:00',5.13),('12374','2013-03-16','08:35:00',5.27),('12374','2013-03-16','08:40:00',5.38),('12374','2013-03-16','08:45:00',5.48),('12374','2013-03-16','08:50:00',5.63),('12374','2013-03-16','08:55:00',5.77),('12374','2013-03-16','09:00:00',5.92),('12374','2013-03-16','09:05:00',6.1),('12374','2013-03-16','09:10:00',5.49),('12374','2013-03-16','09:15:00',6.51),('12374','2013-03-16','09:20:00',3.16),('12374','2013-03-16','09:25:00',4.89),('12374','2013-03-16','09:30:00',2.52),('12374','2013-03-16','09:35:00',3.31),('12374','2013-03-16','09:40:00',7.17),('12374','2013-03-16','09:45:00',7.34),('12374','2013-03-16','09:50:00',7.45),('12374','2013-03-16','09:55:00',7.51),('12374','2013-03-16','10:00:00',7.59),('12374','2013-03-16','10:05:00',7.7),('12374','2013-03-16','10:10:00',7.79),('12374','2013-03-16','10:15:00',7.92),('12374','2013-03-16','10:20:00',7.97),('12374','2013-03-16','10:25:00',8.1),('12374','2013-03-16','10:30:00',8.19),('12374','2013-03-16','10:35:00',8.25),('12374','2013-03-16','10:40:00',8.39),('12374','2013-03-16','10:45:00',8.45),('12374','2013-03-16','10:50:00',8.53),('12374','2013-03-16','10:55:00',8.65),('12374','2013-03-16','11:00:00',8.69),('12374','2013-03-16','11:05:00',8.77),('12374','2013-03-16','11:10:00',8.8),('12374','2013-03-16','11:15:00',8.91),('12374','2013-03-16','11:20:00',8.94),('12374','2013-03-16','11:25:00',8.95),('12374','2013-03-16','11:30:00',9.09),('12374','2013-03-16','11:35:00',9.21),('12374','2013-03-16','11:40:00',9.2),('12374','2013-03-16','11:45:00',9.18),('12374','2013-03-16','11:50:00',9.22),('12374','2013-03-16','11:55:00',9.21),('12374','2013-03-16','12:00:00',9.28),('12374','2013-03-16','12:05:00',9.34),('12374','2013-03-16','12:10:00',9.38),('12374','2013-03-16','12:15:00',9.37),('12374','2013-03-16','12:20:00',9.45),('12374','2013-03-16','12:25:00',9.55),('12374','2013-03-16','12:30:00',9.78),('12374','2013-03-16','12:35:00',9.7),('12374','2013-03-16','12:40:00',8.99),('12374','2013-03-16','12:45:00',9.58),('12374','2013-03-16','12:50:00',9.2),('12374','2013-03-16','12:55:00',9.4),('12374','2013-03-16','13:00:00',9.34),('12374','2013-03-16','13:05:00',9.55),('12374','2013-03-16','13:10:00',9.69),('12374','2013-03-16','13:15:00',7.11),('12374','2013-03-16','13:20:00',8.69),('12374','2013-03-16','13:25:00',3.81),('12374','2013-03-16','13:30:00',7.06),('12374','2013-03-16','13:35:00',8.03),('12374','2013-03-16','13:40:00',9.39),('12374','2013-03-16','13:45:00',9.53),('12374','2013-03-16','13:50:00',8.63),('12374','2013-03-16','13:55:00',8.81),('12374','2013-03-16','14:00:00',7.88),('12374','2013-03-16','14:05:00',8.55),('12374','2013-03-16','14:10:00',8.24),('12374','2013-03-16','14:15:00',7.91),('12374','2013-03-16','14:20:00',7.82),('12374','2013-03-16','14:25:00',7.75),('12374','2013-03-16','14:30:00',7.73),('12374','2013-03-16','14:35:00',7.66),('12374','2013-03-16','14:40:00',7.53),('12374','2013-03-16','14:45:00',7.52),('12374','2013-03-16','14:50:00',7.3),('12374','2013-03-16','14:55:00',6.96),('12374','2013-03-16','15:00:00',6.66),('12374','2013-03-16','15:05:00',6.44),('12374','2013-03-16','15:10:00',6.28),('12374','2013-03-16','15:15:00',6.13),('12374','2013-03-16','15:20:00',5.95),('12374','2013-03-16','15:25:00',5.81),('12374','2013-03-16','15:30:00',5.59),('12374','2013-03-16','15:35:00',5.48),('12374','2013-03-16','15:40:00',5.29),('12374','2013-03-16','15:45:00',5.1),('12374','2013-03-16','15:50:00',4.95),('12374','2013-03-16','15:55:00',4.79),('12374','2013-03-16','16:00:00',4.6),('12374','2013-03-16','16:05:00',4.44),('12374','2013-03-16','16:10:00',4.22),('12374','2013-03-16','16:15:00',4.09),('12374','2013-03-16','16:20:00',3.94),('12374','2013-03-16','16:25:00',3.73),('12374','2013-03-16','16:30:00',3.47),('12374','2013-03-16','16:35:00',3.19),('12374','2013-03-16','16:40:00',2.79),('12374','2013-03-16','16:45:00',2.51),('12374','2013-03-16','16:50:00',2.15),('12374','2013-03-16','16:55:00',1.73),('12374','2013-03-16','17:00:00',1.42),('12374','2013-03-16','17:05:00',1.2),('12374','2013-03-16','17:10:00',1.05),('12374','2013-03-15','07:50:00',1.09),('12374','2013-03-15','07:55:00',1.16),('12374','2013-03-15','08:00:00',1.36),('12374','2013-03-15','08:05:00',1.35),('12374','2013-03-15','08:10:00',1.21),('12374','2013-03-15','08:15:00',1.26),('12374','2013-03-15','08:20:00',1.37),('12374','2013-03-15','08:25:00',1.2),('12374','2013-03-15','08:30:00',1.35),('12374','2013-03-15','08:35:00',1.44),('12374','2013-03-15','08:40:00',1.37),('12374','2013-03-15','08:45:00',1.39),('12374','2013-03-15','08:50:00',1.49),('12374','2013-03-15','08:55:00',1.57),('12374','2013-03-15','09:00:00',1.5),('12374','2013-03-15','09:05:00',1.36),('12374','2013-03-15','09:10:00',1.07),('12374','2013-03-15','09:15:00',1.01),('12374','2013-03-15','09:20:00',1.12),('12374','2013-03-15','09:25:00',1.25),('12374','2013-03-15','09:30:00',1.41),('12374','2013-03-15','09:35:00',1.55),('12374','2013-03-15','09:40:00',1.58),('12374','2013-03-15','09:45:00',1.51),('12374','2013-03-15','09:50:00',1.51),('12374','2013-03-15','09:55:00',1.55),('12374','2013-03-15','10:00:00',1.49),('12374','2013-03-15','10:05:00',1.45),('12374','2013-03-15','10:10:00',1.42),('12374','2013-03-15','10:15:00',1.36),('12374','2013-03-15','10:20:00',1.47),('12374','2013-03-15','10:25:00',1.7),('12374','2013-03-15','10:30:00',1.84),('12374','2013-03-15','10:35:00',2.1),('12374','2013-03-15','10:40:00',2.74),('12374','2013-03-15','10:45:00',3.29),('12374','2013-03-15','10:50:00',2.95),('12374','2013-03-15','10:55:00',2.67),('12374','2013-03-15','11:00:00',2.52),('12374','2013-03-15','11:05:00',2.67),('12374','2013-03-15','11:10:00',3.1),('12374','2013-03-15','11:15:00',3.3),('12374','2013-03-15','11:20:00',3.19),('12374','2013-03-15','11:25:00',3.43),('12374','2013-03-15','11:30:00',3.76),('12374','2013-03-15','11:35:00',3.89),('12374','2013-03-15','11:40:00',3.94),('12374','2013-03-15','11:45:00',4.06),('12374','2013-03-15','11:50:00',4.33),('12374','2013-03-15','11:55:00',3.86),('12374','2013-03-15','12:00:00',3.39),('12374','2013-03-15','12:05:00',3.37),('12374','2013-03-15','12:10:00',3.69),('12374','2013-03-15','12:15:00',4.56),('12374','2013-03-15','12:20:00',4.4),('12374','2013-03-15','12:25:00',4.21),('12374','2013-03-15','12:30:00',4.67),('12374','2013-03-15','12:35:00',4.5),('12374','2013-03-15','12:40:00',3.71),('12374','2013-03-15','12:45:00',4.1),('12374','2013-03-15','12:50:00',3.79),('12374','2013-03-15','12:55:00',4.39),('12374','2013-03-15','13:00:00',4.49),('12374','2013-03-15','13:05:00',4.19),('12374','2013-03-15','13:10:00',4.09),('12374','2013-03-15','13:15:00',3.19),('12374','2013-03-15','13:20:00',2.57),('12374','2013-03-15','13:25:00',2.15),('12374','2013-03-15','13:30:00',2.04),('12374','2013-03-15','13:35:00',2.12),('12374','2013-03-15','13:40:00',2.66),('12374','2013-03-15','13:45:00',3.73),('12374','2013-03-15','13:50:00',5.15),('12374','2013-03-15','13:55:00',3.61),('12374','2013-03-15','14:00:00',3.11),('12374','2013-03-15','14:05:00',3.06),('12374','2013-03-15','14:10:00',2.84),('12374','2013-03-15','14:15:00',2.92),('12374','2013-03-15','14:20:00',3.29),('12374','2013-03-15','14:25:00',3.55),('12374','2013-03-15','14:30:00',4.12),('12374','2013-03-15','14:35:00',4.89),('12374','2013-03-15','14:40:00',4.65),('12374','2013-03-15','14:45:00',4),('12374','2013-03-15','14:50:00',3.79),('12374','2013-03-15','14:55:00',3.42),('12374','2013-03-15','15:00:00',2.77),('12374','2013-03-15','15:05:00',2.05),('12374','2013-03-15','15:10:00',2.95),('12374','2013-03-15','15:15:00',2.76),('12374','2013-03-15','15:20:00',2.59),('12374','2013-03-15','15:25:00',2.17),('12374','2013-03-15','15:30:00',2.07),('12374','2013-03-15','15:35:00',1.81),('12374','2013-03-15','15:40:00',1.16),('12374','2013-03-15','15:45:00',1.19),('12374','2013-03-15','15:50:00',1.31),('12374','2013-03-15','16:35:00',1.23),('12374','2013-03-15','16:40:00',2.27),('12374','2013-03-15','16:45:00',2.57),('12374','2013-03-15','16:50:00',2.51),('12374','2013-03-15','16:55:00',1.77),('12374','2013-03-15','17:00:00',1.43),('12374','2013-03-15','17:05:00',1.08),('12374','2013-03-15','17:10:00',1.21),('12374','2013-03-15','17:15:00',1.13),('12374','2013-03-14','07:10:00',1.11),('12374','2013-03-14','07:15:00',1.17),('12374','2013-03-14','07:20:00',1.04),('12374','2013-03-14','07:25:00',1.05),('12374','2013-03-14','07:30:00',1.05),('12374','2013-03-14','07:35:00',1),('12374','2013-03-14','10:30:00',1.06),('12374','2013-03-14','10:35:00',1.12),('12374','2013-03-14','10:40:00',1.26),('12374','2013-03-14','10:45:00',1.45),('12374','2013-03-14','10:50:00',1.44),('12374','2013-03-14','10:55:00',1.47),('12374','2013-03-14','11:00:00',1.5),('12374','2013-03-14','11:05:00',1.55),('12374','2013-03-14','11:10:00',1.46),('12374','2013-03-14','11:15:00',1.53),('12374','2013-03-14','11:20:00',1.62),('12374','2013-03-14','11:25:00',1.97),('12374','2013-03-14','11:30:00',2.36),('12374','2013-03-14','11:35:00',2.31),('12374','2013-03-14','11:40:00',2.28),('12374','2013-03-14','11:45:00',2.17),('12374','2013-03-14','11:50:00',1.47),('12374','2013-03-14','11:55:00',2.34),('12374','2013-03-14','12:00:00',2.33),('12374','2013-03-14','12:05:00',2.09),('12374','2013-03-14','12:10:00',1.8),('12374','2013-03-14','12:15:00',1.62),('12374','2013-03-14','12:20:00',1.18),('12374','2013-03-14','12:40:00',1.14),('12374','2013-03-14','12:45:00',1.43),('12374','2013-03-14','12:50:00',1.69),('12374','2013-03-14','12:55:00',2.53),('12374','2013-03-14','13:00:00',3.14),('12374','2013-03-14','13:05:00',3.71),('12374','2013-03-14','13:10:00',4.67),('12374','2013-03-14','13:15:00',4.8),('12374','2013-03-14','13:20:00',2.59),('12374','2013-03-14','13:25:00',1.64),('12374','2013-03-14','13:30:00',1.37),('12374','2013-03-14','13:35:00',1.1),('12374','2013-03-14','13:45:00',1.1),('12374','2013-03-14','13:50:00',1.26),('12374','2013-03-14','13:55:00',1.14),('12374','2013-03-14','14:00:00',1.27),('12374','2013-03-14','14:05:00',1.39),('12374','2013-03-14','14:10:00',1.55),('12374','2013-03-14','14:15:00',1.98),('12374','2013-03-14','14:20:00',2.49),('12374','2013-03-14','14:25:00',2.24),('12374','2013-03-14','14:30:00',1.97),('12374','2013-03-14','14:35:00',1.47),('12374','2013-03-14','14:40:00',1.17),('12374','2013-03-14','15:25:00',1.2),('12374','2013-03-14','15:30:00',1.03),('12374','2013-03-14','15:50:00',1.47),('12374','2013-03-14','15:55:00',1.84),('12374','2013-03-14','16:00:00',1.82),('12374','2013-03-14','16:05:00',1.52),('12374','2013-03-14','16:10:00',1.09),('12374','2013-03-14','16:40:00',1.02),('12374','2013-03-14','16:55:00',1.27),('12374','2013-03-14','17:00:00',1.17),('12374','2013-03-14','17:05:00',1.01),('12374','2013-03-13','08:00:00',1.15),('12374','2013-03-13','08:05:00',1.29),('12374','2013-03-13','08:10:00',1.3),('12374','2013-03-13','08:15:00',1.14),('12374','2013-03-13','08:20:00',1.58),('12374','2013-03-13','08:25:00',1.7),('12374','2013-03-13','08:30:00',1.51),('12374','2013-03-13','08:35:00',1.21),('12374','2013-03-13','08:40:00',1.23),('12374','2013-03-13','08:45:00',1.16),('12374','2013-03-13','09:10:00',1.04),('12374','2013-03-13','09:15:00',2.03),('12374','2013-03-13','09:20:00',2.57),('12374','2013-03-13','09:25:00',2.49),('12374','2013-03-13','09:30:00',3.46),('12374','2013-03-13','09:35:00',5.3),('12374','2013-03-13','09:40:00',5.13),('12374','2013-03-13','09:45:00',5.62),('12374','2013-03-13','09:50:00',5.38),('12374','2013-03-13','09:55:00',5.6),('12374','2013-03-13','10:00:00',5.43),('12374','2013-03-13','10:05:00',5.76),('12374','2013-03-13','10:10:00',7.22),('12374','2013-03-13','10:15:00',7.52),('12374','2013-03-13','10:20:00',6.8),('12374','2013-03-13','10:25:00',7.6),('12374','2013-03-13','10:30:00',6.87),('12374','2013-03-13','10:35:00',6.37),('12374','2013-03-13','10:40:00',6.44),('12374','2013-03-13','10:45:00',6.17),('12374','2013-03-13','10:50:00',4.56),('12374','2013-03-13','10:55:00',4.42),('12374','2013-03-13','11:00:00',4.33),('12374','2013-03-13','11:05:00',4.22),('12374','2013-03-13','11:10:00',4.89),('12374','2013-03-13','11:15:00',4.19),('12374','2013-03-13','11:20:00',3.37),('12374','2013-03-13','11:25:00',2.65),('12374','2013-03-13','11:30:00',1.81),('12374','2013-03-13','11:35:00',1.9),('12374','2013-03-13','11:40:00',1.39),('12374','2013-03-13','11:45:00',1.47),('12374','2013-03-13','11:50:00',2.24),('12374','2013-03-13','11:55:00',2.71),('12374','2013-03-13','12:00:00',2.12),('12374','2013-03-13','12:05:00',1.47),('12374','2013-03-13','12:20:00',1.64),('12374','2013-03-13','12:25:00',2.04),('12374','2013-03-13','12:30:00',2.46),('12374','2013-03-13','12:35:00',2.32),('12374','2013-03-13','12:40:00',1.85),('12374','2013-03-13','12:45:00',1.94),('12374','2013-03-13','12:50:00',2.07),('12374','2013-03-13','12:55:00',1.96),('12374','2013-03-13','13:00:00',1.78),('12374','2013-03-13','13:05:00',1.8),('12374','2013-03-13','13:10:00',1.82),('12374','2013-03-13','13:15:00',1.84),('12374','2013-03-13','13:20:00',1.82),('12374','2013-03-13','13:25:00',1.72),('12374','2013-03-13','13:30:00',1.8),('12374','2013-03-13','13:35:00',2.1),('12374','2013-03-13','13:40:00',2.03),('12374','2013-03-13','13:45:00',1.58),('12374','2013-03-13','13:50:00',1.18),('12374','2013-03-12','07:30:00',1.03),('12374','2013-03-12','07:35:00',2.35),('12374','2013-03-12','07:40:00',2.77),('12374','2013-03-12','07:45:00',2.89),('12374','2013-03-12','07:50:00',3.17),('12374','2013-03-12','07:55:00',3.17),('12374','2013-03-12','08:00:00',3.76),('12374','2013-03-12','08:05:00',3.45),('12374','2013-03-12','08:10:00',3.69),('12374','2013-03-12','08:15:00',3.51),('12374','2013-03-12','08:20:00',3.91),('12374','2013-03-12','08:25:00',4.09),('12374','2013-03-12','08:30:00',4.18),('12374','2013-03-12','08:35:00',4.8),('12374','2013-03-12','08:40:00',4.93),('12374','2013-03-12','08:45:00',5.08),('12374','2013-03-12','08:50:00',5.25),('12374','2013-03-12','08:55:00',5.41),('12374','2013-03-12','09:00:00',5.56),('12374','2013-03-12','09:05:00',5.69),('12374','2013-03-12','09:10:00',5.84),('12374','2013-03-12','09:15:00',5.98),('12374','2013-03-12','09:20:00',6.11),('12374','2013-03-12','09:25:00',6.24),('12374','2013-03-12','09:30:00',6.41),('12374','2013-03-12','09:35:00',6.57),('12374','2013-03-12','09:40:00',6.7),('12374','2013-03-12','09:45:00',6.83),('12374','2013-03-12','09:50:00',6.95),('12374','2013-03-12','09:55:00',7.06),('12374','2013-03-12','10:00:00',7.16),('12374','2013-03-12','10:05:00',7.31),('12374','2013-03-12','10:10:00',7.41),('12374','2013-03-12','10:15:00',7.57),('12374','2013-03-12','10:20:00',7.67),('12374','2013-03-12','10:25:00',7.77),('12374','2013-03-12','10:30:00',7.9),('12374','2013-03-12','10:35:00',8.01),('12374','2013-03-12','10:40:00',8.11),('12374','2013-03-12','10:45:00',8.29),('12374','2013-03-12','10:50:00',8.46),('12374','2013-03-12','10:55:00',7.48),('12374','2013-03-12','11:00:00',5.88),('12374','2013-03-12','11:05:00',8.57),('12374','2013-03-12','11:10:00',5.49),('12374','2013-03-12','11:15:00',4.62),('12374','2013-03-12','11:20:00',5.8),('12374','2013-03-12','11:25:00',2.89),('12374','2013-03-12','11:30:00',1.47),('12374','2013-03-12','11:40:00',1.19),('12374','2013-03-12','11:45:00',2.58),('12374','2013-03-12','11:55:00',1.21),('12374','2013-03-12','12:05:00',1.49),('12374','2013-03-12','12:10:00',4.21),('12374','2013-03-12','12:15:00',9.79),('12374','2013-03-12','12:20:00',9.41),('12374','2013-03-12','12:25:00',9.18),('12374','2013-03-12','12:30:00',9.25),('12374','2013-03-12','12:35:00',9.4),('12374','2013-03-12','12:40:00',8.92),('12374','2013-03-12','12:45:00',9.36),('12374','2013-03-12','12:50:00',8.99),('12374','2013-03-12','12:55:00',8.61),('12374','2013-03-12','13:00:00',6.16),('12374','2013-03-12','13:05:00',3.21),('12374','2013-03-12','13:10:00',3.98),('12374','2013-03-12','13:15:00',6.88),('12374','2013-03-12','13:20:00',6.83),('12374','2013-03-12','13:25:00',7.62),('12374','2013-03-12','13:30:00',8.1),('12374','2013-03-12','13:35:00',6.76),('12374','2013-03-12','13:40:00',5.44),('12374','2013-03-12','13:45:00',4.8),('12374','2013-03-12','13:50:00',4.18),('12374','2013-03-12','13:55:00',6.19),('12374','2013-03-12','14:00:00',9.71),('12374','2013-03-12','14:05:00',6.59),('12374','2013-03-12','14:10:00',2.88),('12374','2013-03-12','14:15:00',3.07),('12374','2013-03-12','14:20:00',3.29),('12374','2013-03-12','14:25:00',2.14),('12374','2013-03-12','14:30:00',1.5),('12374','2013-03-12','14:45:00',4.46),('12374','2013-03-12','14:50:00',4.56),('12374','2013-03-12','14:55:00',3.05),('12374','2013-03-12','15:00:00',2.55),('12374','2013-03-12','15:05:00',2.47),('12374','2013-03-12','15:10:00',2.75),('12374','2013-03-12','15:15:00',4.95),('12374','2013-03-12','15:20:00',3.84),('12374','2013-03-12','15:25:00',2.89),('12374','2013-03-12','15:30:00',2.68),('12374','2013-03-12','15:35:00',3.04),('12374','2013-03-12','15:40:00',2.27),('12374','2013-03-12','15:45:00',2.48),('12374','2013-03-12','15:50:00',2.46),('12374','2013-03-12','15:55:00',2.69),('12374','2013-03-12','16:00:00',4.6),('12374','2013-03-12','16:05:00',1.86),('12374','2013-03-12','16:10:00',1.74),('12374','2013-03-12','16:15:00',3.35),('12374','2013-03-12','16:20:00',2.02),('12374','2013-03-12','16:25:00',1.32),('12374','2013-03-12','16:30:00',1.4),('12374','2013-03-12','16:35:00',1.35),('12374','2013-03-12','16:40:00',1.01),('12374','2013-03-11','07:05:00',1.09),('12374','2013-03-11','07:10:00',1.25),('12374','2013-03-11','07:15:00',1.52),('12374','2013-03-11','07:20:00',1.66),('12374','2013-03-11','07:25:00',1.64),('12374','2013-03-11','07:30:00',1.58),('12374','2013-03-11','07:35:00',1.31),('12374','2013-03-11','07:45:00',1.05),('12374','2013-03-11','07:50:00',1.18),('12374','2013-03-11','07:55:00',1.48),('12374','2013-03-11','08:00:00',1.45),('12374','2013-03-11','08:05:00',1.17),('12374','2013-03-11','08:10:00',3.97),('12374','2013-03-11','08:15:00',4.75),('12374','2013-03-11','08:20:00',2.21),('12374','2013-03-11','08:25:00',2.18),('12374','2013-03-11','08:30:00',1.63),('12374','2013-03-11','08:35:00',1.83),('12374','2013-03-11','08:40:00',3.43),('12374','2013-03-11','08:45:00',3.61),('12374','2013-03-11','08:50:00',4.12),('12374','2013-03-11','08:55:00',5.55),('12374','2013-03-11','09:00:00',5.68),('12374','2013-03-11','09:05:00',5.83),('12374','2013-03-11','09:10:00',5.91),('12374','2013-03-11','09:15:00',5.78),('12374','2013-03-11','09:20:00',6.35),('12374','2013-03-11','09:25:00',6.61),('12374','2013-03-11','09:30:00',6.81),('12374','2013-03-11','09:35:00',6.91),('12374','2013-03-11','09:40:00',6.34),('12374','2013-03-11','09:45:00',7.08),('12374','2013-03-11','09:50:00',7.13),('12374','2013-03-11','09:55:00',7.45),('12374','2013-03-11','10:00:00',5.7),('12374','2013-03-11','10:05:00',4.52),('12374','2013-03-11','10:10:00',3.93),('12374','2013-03-11','10:15:00',6.85),('12374','2013-03-11','10:20:00',7.85),('12374','2013-03-11','10:25:00',7.89),('12374','2013-03-11','10:30:00',7.94),('12374','2013-03-11','10:35:00',8.32),('12374','2013-03-11','10:40:00',8.9),('12374','2013-03-11','10:45:00',8.04),('12374','2013-03-11','10:50:00',5.39),('12374','2013-03-11','10:55:00',7.56),('12374','2013-03-11','11:00:00',4.65),('12374','2013-03-11','11:05:00',5.64),('12374','2013-03-11','11:10:00',5.48),('12374','2013-03-11','11:15:00',3.76),('12374','2013-03-11','11:20:00',3.63),('12374','2013-03-11','11:25:00',4.77),('12374','2013-03-11','11:30:00',4.19),('12374','2013-03-11','11:35:00',5.2),('12374','2013-03-11','11:40:00',4.55),('12374','2013-03-11','11:45:00',4.12),('12374','2013-03-11','11:50:00',3.84),('12374','2013-03-11','11:55:00',3.87),('12374','2013-03-11','12:00:00',4.08),('12374','2013-03-11','12:05:00',5.52),('12374','2013-03-11','12:10:00',4.65),('12374','2013-03-11','12:15:00',6.59),('12374','2013-03-11','12:20:00',7),('12374','2013-03-11','12:25:00',7.36),('12374','2013-03-11','12:30:00',8.63),('12374','2013-03-11','12:35:00',7.31),('12374','2013-03-11','12:40:00',8.99),('12374','2013-03-11','12:45:00',9.18),('12374','2013-03-11','12:50:00',8.78),('12374','2013-03-11','12:55:00',8.92),('12374','2013-03-11','13:00:00',8.79),('12374','2013-03-11','13:05:00',9.18),('12374','2013-03-11','13:10:00',8.78),('12374','2013-03-11','13:15:00',8.58),('12374','2013-03-11','13:20:00',8.56),('12374','2013-03-11','13:25:00',8.45),('12374','2013-03-11','13:30:00',8.44),('12374','2013-03-11','13:35:00',8.84),('12374','2013-03-11','13:40:00',5.96),('12374','2013-03-11','13:45:00',5.7),('12374','2013-03-11','13:50:00',6.21),('12374','2013-03-11','13:55:00',8.28),('12374','2013-03-11','14:00:00',7.81),('12374','2013-03-11','14:05:00',7.83),('12374','2013-03-11','14:10:00',6.93),('12374','2013-03-11','14:15:00',6),('12374','2013-03-11','14:20:00',3.95),('12374','2013-03-11','14:25:00',3.85),('12374','2013-03-11','14:30:00',3.68),('12374','2013-03-11','14:35:00',3.04),('12374','2013-03-11','14:40:00',4.48),('12374','2013-03-11','14:45:00',2.69),('12374','2013-03-11','14:50:00',2.53),('12374','2013-03-11','14:55:00',2.42),('12374','2013-03-11','15:00:00',2.51),('12374','2013-03-11','15:05:00',2.54),('12374','2013-03-11','15:10:00',2.59),('12374','2013-03-11','15:15:00',2.34),('12374','2013-03-11','15:20:00',3),('12374','2013-03-11','15:25:00',4.49),('12374','2013-03-11','15:30:00',4.16),('12374','2013-03-11','15:35:00',5.72),('12374','2013-03-11','15:40:00',4.51),('12374','2013-03-11','15:45:00',5.09),('12374','2013-03-11','15:50:00',4.63),('12374','2013-03-11','15:55:00',3.46),('12374','2013-03-11','16:00:00',1.57),('12374','2013-03-11','16:05:00',1.36),('12374','2013-03-11','16:10:00',2.01),('12374','2013-03-11','16:15:00',2.74),('12374','2013-03-11','16:20:00',1.36),('12374','2013-03-11','16:25:00',1.16),('12374','2013-03-11','16:30:00',1.3),('12374','2013-03-11','16:35:00',1.25),('12374','2013-03-11','16:40:00',1.27),('12374','2013-03-11','16:45:00',2.33),('12374','2013-03-11','16:50:00',1.98),('12374','2013-03-11','16:55:00',1.71),('12374','2013-03-11','17:00:00',1.49),('12374','2013-03-11','17:05:00',1.06),('12374','2013-03-10','07:05:00',1.24),('12374','2013-03-10','07:10:00',1.42),('12374','2013-03-10','07:15:00',1.76),('12374','2013-03-10','07:20:00',1.7),('12374','2013-03-10','07:25:00',2.08),('12374','2013-03-10','07:30:00',2.03),('12374','2013-03-10','07:35:00',2.19),('12374','2013-03-10','07:40:00',2.55),('12374','2013-03-10','07:45:00',2.89),('12374','2013-03-10','07:50:00',2.91),('12374','2013-03-10','07:55:00',2.95),('12374','2013-03-10','08:00:00',3.45),('12374','2013-03-10','08:05:00',3.65),('12374','2013-03-10','08:10:00',3.85),('12374','2013-03-10','08:15:00',4),('12374','2013-03-10','08:20:00',4.16),('12374','2013-03-10','08:25:00',4.33),('12374','2013-03-10','08:30:00',4.51),('12374','2013-03-10','08:35:00',4.5),('12374','2013-03-10','08:40:00',4.61),('12374','2013-03-10','08:45:00',4.68),('12374','2013-03-10','08:50:00',2.93),('12374','2013-03-10','08:55:00',5.93),('12374','2013-03-10','09:00:00',5.85),('12374','2013-03-10','09:05:00',5.83),('12374','2013-03-10','09:10:00',5.89),('12374','2013-03-10','09:15:00',6.05),('12374','2013-03-10','09:20:00',6.3),('12374','2013-03-10','09:25:00',6.32),('12374','2013-03-10','09:30:00',6.12),('12374','2013-03-10','09:35:00',6.52),('12374','2013-03-10','09:40:00',6.62),('12374','2013-03-10','09:45:00',6.76),('12374','2013-03-10','09:50:00',6.87),('12374','2013-03-10','09:55:00',6.9),('12374','2013-03-10','10:00:00',7.09),('12374','2013-03-10','10:05:00',7.21),('12374','2013-03-10','10:10:00',7.32),('12374','2013-03-10','10:15:00',7.45),('12374','2013-03-10','10:20:00',7.57),('12374','2013-03-10','10:25:00',7.65),('12374','2013-03-10','10:30:00',7.73),('12374','2013-03-10','10:35:00',7.81),('12374','2013-03-10','10:40:00',7.9),('12374','2013-03-10','10:45:00',8.05),('12374','2013-03-10','10:50:00',8.13),('12374','2013-03-10','10:55:00',8.17),('12374','2013-03-10','11:00:00',8.28),('12374','2013-03-10','11:05:00',8.35),('12374','2013-03-10','11:10:00',8.42),('12374','2013-03-10','11:15:00',8.41),('12374','2013-03-10','11:20:00',8.47),('12374','2013-03-10','11:25:00',8.57),('12374','2013-03-10','11:30:00',8.66),('12374','2013-03-10','11:35:00',8.77),('12374','2013-03-10','11:40:00',8.74),('12374','2013-03-10','11:45:00',8.81),('12374','2013-03-10','11:50:00',8.84),('12374','2013-03-10','11:55:00',8.88),('12374','2013-03-10','12:00:00',8.93),('12374','2013-03-10','12:05:00',8.92),('12374','2013-03-10','12:10:00',8.9),('12374','2013-03-10','12:15:00',8.89),('12374','2013-03-10','12:20:00',8.9),('12374','2013-03-10','12:25:00',8.92),('12374','2013-03-10','12:30:00',8.9),('12374','2013-03-10','12:35:00',8.92),('12374','2013-03-10','12:40:00',8.94),('12374','2013-03-10','12:45:00',8.95),('12374','2013-03-10','12:50:00',8.35),('12374','2013-03-10','12:55:00',8.68),('12374','2013-03-10','13:00:00',7.45),('12374','2013-03-10','13:05:00',6.95),('12374','2013-03-10','13:10:00',6.02),('12374','2013-03-10','13:15:00',4.9),('12374','2013-03-10','13:20:00',2.99),('12374','2013-03-10','13:25:00',4.03),('12374','2013-03-10','13:30:00',4.9),('12374','2013-03-10','13:35:00',4.24),('12374','2013-03-10','13:40:00',3.49),('12374','2013-03-10','13:45:00',2.37),('12374','2013-03-10','13:50:00',2.19),('12374','2013-03-10','13:55:00',1.92),('12374','2013-03-10','14:00:00',1.96),('12374','2013-03-10','14:05:00',2.5),('12374','2013-03-10','14:10:00',3.09),('12374','2013-03-10','14:15:00',2.81),('12374','2013-03-10','14:20:00',2.26),('12374','2013-03-10','14:25:00',3.02),('12374','2013-03-10','14:30:00',3.95),('12374','2013-03-10','14:35:00',3.59),('12374','2013-03-10','14:40:00',3.02),('12374','2013-03-10','14:45:00',2.45),('12374','2013-03-10','14:50:00',1.88),('12374','2013-03-10','14:55:00',1.49),('12374','2013-03-10','15:00:00',1.48),('12374','2013-03-10','15:05:00',1.32),('12374','2013-03-09','07:30:00',1.56),('12374','2013-03-09','07:35:00',2.19),('12374','2013-03-09','07:40:00',2.54),('12374','2013-03-09','07:45:00',2.81),('12374','2013-03-09','07:50:00',3),('12374','2013-03-09','07:55:00',2.69),('12374','2013-03-09','08:00:00',3.19),('12374','2013-03-09','08:05:00',3.67),('12374','2013-03-09','08:10:00',3.84),('12374','2013-03-09','08:15:00',2.92),('12374','2013-03-09','08:20:00',3.79),('12374','2013-03-09','08:25:00',4.33),('12374','2013-03-09','08:30:00',4.42),('12374','2013-03-09','08:35:00',4.66),('12374','2013-03-09','08:40:00',4.75),('12374','2013-03-09','08:45:00',4.9),('12374','2013-03-09','08:50:00',5.03),('12374','2013-03-09','08:55:00',5.21),('12374','2013-03-09','09:00:00',5.37),('12374','2013-03-09','09:05:00',5.54),('12374','2013-03-09','09:10:00',5.73),('12374','2013-03-09','09:15:00',5.87),('12374','2013-03-09','09:20:00',6.01),('12374','2013-03-09','09:25:00',6.15),('12374','2013-03-09','09:30:00',6.3),('12374','2013-03-09','09:35:00',6.46),('12374','2013-03-09','09:40:00',6.6),('12374','2013-03-09','09:45:00',6.67),('12374','2013-03-09','09:50:00',6.86),('12374','2013-03-09','09:55:00',7.02),('12374','2013-03-09','10:00:00',7.12),('12374','2013-03-09','10:05:00',7.23),('12374','2013-03-09','10:10:00',7.34),('12374','2013-03-09','10:15:00',7.43),('12374','2013-03-09','10:20:00',7.53),('12374','2013-03-09','10:25:00',7.65),('12374','2013-03-09','10:30:00',7.67),('12374','2013-03-09','10:35:00',7.81),('12374','2013-03-09','10:40:00',7.92),('12374','2013-03-09','10:45:00',8.03),('12374','2013-03-09','10:50:00',8.11),('12374','2013-03-09','10:55:00',8.2),('12374','2013-03-09','11:00:00',8.31),('12374','2013-03-09','11:05:00',8.4),('12374','2013-03-09','11:10:00',8.46),('12374','2013-03-09','11:15:00',8.5),('12374','2013-03-09','11:20:00',8.63),('12374','2013-03-09','11:25:00',8.68),('12374','2013-03-09','11:30:00',8.76),('12374','2013-03-09','11:35:00',8.76),('12374','2013-03-09','11:40:00',8.79),('12374','2013-03-09','11:45:00',8.84),('12374','2013-03-09','11:50:00',8.85),('12374','2013-03-09','11:55:00',8.9),('12374','2013-03-09','12:00:00',8.93),('12374','2013-03-09','12:05:00',8.94),('12374','2013-03-09','12:10:00',8.89),('12374','2013-03-09','12:15:00',7.65),('12374','2013-03-09','12:20:00',9.17),('12374','2013-03-09','12:25:00',8.06),('12374','2013-03-09','12:30:00',8.33),('12374','2013-03-09','12:35:00',9.14),('12374','2013-03-09','12:40:00',9.23),('12374','2013-03-09','12:45:00',8.04),('12374','2013-03-09','12:50:00',8.49),('12374','2013-03-09','12:55:00',8.72),('12374','2013-03-09','13:00:00',8.66),('12374','2013-03-09','13:05:00',7.94),('12374','2013-03-09','13:10:00',8),('12374','2013-03-09','13:15:00',4.63),('12374','2013-03-09','13:20:00',7.91),('12374','2013-03-09','13:25:00',8.05),('12374','2013-03-09','13:30:00',7.66),('12374','2013-03-09','13:35:00',7.81),('12374','2013-03-09','13:40:00',7.89),('12374','2013-03-09','13:45:00',7.81),('12374','2013-03-09','13:50:00',7.72),('12374','2013-03-09','13:55:00',7.65),('12374','2013-03-09','14:00:00',7.55),('12374','2013-03-09','14:05:00',7.43),('12374','2013-03-09','14:10:00',7.35),('12374','2013-03-09','14:15:00',7),('12374','2013-03-09','14:20:00',7.09),('12374','2013-03-09','14:25:00',6.98),('12374','2013-03-09','14:30:00',6.86),('12374','2013-03-09','14:35:00',6.76),('12374','2013-03-09','14:40:00',6.64),('12374','2013-03-09','14:45:00',6.53),('12374','2013-03-09','14:50:00',6.39),('12374','2013-03-09','14:55:00',6.22),('12374','2013-03-09','15:00:00',6.02),('12374','2013-03-09','15:05:00',5.88),('12374','2013-03-09','15:10:00',5.77),('12374','2013-03-09','15:15:00',5.62),('12374','2013-03-09','15:20:00',5.47),('12374','2013-03-09','15:25:00',5.33),('12374','2013-03-09','15:30:00',5.25),('12374','2013-03-09','15:35:00',5.11),('12374','2013-03-09','15:40:00',4.69),('12374','2013-03-09','15:45:00',4.25),('12374','2013-03-09','15:50:00',3.39),('12374','2013-03-09','15:55:00',3.47),('12374','2013-03-09','16:00:00',3.33),('12374','2013-03-09','16:05:00',2.09),('12374','2013-03-09','16:10:00',1.94),('12374','2013-03-09','16:15:00',1.14),('12374','2013-03-09','16:20:00',1.91),('12374','2013-03-09','16:25:00',1.96),('12374','2013-03-09','16:30:00',1.67),('12374','2013-03-09','16:35:00',1.65),('12374','2013-03-09','16:40:00',1.19),('12374','2013-03-09','16:45:00',1.17),('12374','2013-03-09','16:50:00',1.27),('12374','2013-03-08','08:10:00',1.21),('12374','2013-03-08','08:15:00',1.58),('12374','2013-03-08','08:20:00',1.17),('12374','2013-03-08','08:45:00',1.37),('12374','2013-03-08','08:50:00',2.01),('12374','2013-03-08','08:55:00',2.39),('12374','2013-03-08','09:00:00',2.17),('12374','2013-03-08','09:05:00',1.95),('12374','2013-03-08','09:10:00',1.94),('12374','2013-03-08','09:15:00',1.92),('12374','2013-03-08','09:20:00',1.64),('12374','2013-03-08','09:25:00',1.23),('12374','2013-03-08','09:30:00',1.85),('12374','2013-03-08','09:35:00',1.66),('12374','2013-03-08','09:40:00',1.9),('12374','2013-03-08','09:45:00',2.03),('12374','2013-03-08','09:50:00',1.6),('12374','2013-03-08','09:55:00',1.4),('12374','2013-03-08','10:00:00',1.45),('12374','2013-03-08','10:05:00',1.64),('12374','2013-03-08','10:10:00',3.21),('12374','2013-03-08','10:15:00',4.93),('12374','2013-03-08','10:20:00',2.73),('12374','2013-03-08','10:25:00',1.8),('12374','2013-03-08','10:30:00',1.16),('12374','2013-03-08','10:35:00',1.22),('12374','2013-03-08','10:40:00',1.54),('12374','2013-03-08','10:45:00',1.63),('12374','2013-03-08','11:05:00',1.33),('12374','2013-03-08','11:25:00',1.62),('12374','2013-03-08','11:30:00',2.09),('12374','2013-03-08','11:35:00',1.69),('12374','2013-03-08','11:40:00',1.54),('12374','2013-03-08','11:50:00',1.24),('12374','2013-03-08','11:55:00',1.37),('12374','2013-03-08','12:15:00',1.17),('12374','2013-03-08','12:20:00',1.55),('12374','2013-03-08','12:25:00',1.21),('12374','2013-03-08','12:30:00',1.56),('12374','2013-03-08','12:35:00',1.46),('12374','2013-03-08','12:40:00',1.18),('12374','2013-03-08','12:45:00',1.01),('12374','2013-03-08','13:15:00',1.38),('12374','2013-03-08','13:20:00',1.39),('12374','2013-03-08','13:25:00',1.51),('12374','2013-03-08','13:30:00',3.01),('12374','2013-03-08','13:35:00',1.97),('12374','2013-03-08','13:40:00',1.18),('12374','2013-03-07','08:35:00',1.5),('12374','2013-03-07','08:40:00',1.57),('12374','2013-03-07','08:45:00',2.38),('12374','2013-03-07','08:50:00',2.43),('12374','2013-03-07','08:55:00',1.65),('12374','2013-03-07','09:00:00',1.18),('12374','2013-03-07','09:30:00',1.26),('12374','2013-03-07','09:35:00',1.18),('12374','2013-03-07','09:40:00',1.55),('12374','2013-03-07','09:45:00',2.19),('12374','2013-03-07','09:50:00',2.34),('12374','2013-03-07','09:55:00',2.58),('12374','2013-03-07','10:00:00',2.64),('12374','2013-03-07','10:05:00',2.49),('12374','2013-03-07','10:10:00',2.13),('12374','2013-03-07','10:15:00',2.23),('12374','2013-03-07','10:20:00',2.05),('12374','2013-03-07','10:25:00',2.16),('12374','2013-03-07','10:30:00',3.3),('12374','2013-03-07','10:35:00',3.39),('12374','2013-03-07','10:40:00',1.91),('12374','2013-03-07','10:45:00',2.13),('12374','2013-03-07','10:50:00',2.45),('12374','2013-03-07','10:55:00',2.45),('12374','2013-03-07','11:00:00',3.12),('12374','2013-03-07','11:05:00',3.32),('12374','2013-03-07','11:10:00',3.4),('12374','2013-03-07','11:15:00',3.87),('12374','2013-03-07','11:20:00',4.51),('12374','2013-03-07','11:25:00',5),('12374','2013-03-07','11:30:00',6.82),('12374','2013-03-07','11:35:00',5.69),('12374','2013-03-07','11:40:00',6.5),('12374','2013-03-07','11:45:00',7.85),('12374','2013-03-07','11:50:00',7.42),('12374','2013-03-07','11:55:00',6.02),('12374','2013-03-07','12:00:00',5.41),('12374','2013-03-07','12:05:00',3.59),('12374','2013-03-07','12:10:00',2.69),('12374','2013-03-07','12:15:00',2.06),('12374','2013-03-07','12:20:00',2.47),('12374','2013-03-07','12:25:00',3.13),('12374','2013-03-07','12:30:00',3.5),('12374','2013-03-07','12:35:00',4.32),('12374','2013-03-07','12:40:00',5.11),('12374','2013-03-07','12:45:00',6.18),('12374','2013-03-07','12:50:00',5.48),('12374','2013-03-07','12:55:00',4.58),('12374','2013-03-07','13:00:00',3.65),('12374','2013-03-07','13:05:00',4.64),('12374','2013-03-07','13:10:00',3.97),('12374','2013-03-07','13:15:00',3.66),('12374','2013-03-07','13:20:00',3.27),('12374','2013-03-07','13:25:00',3.42),('12374','2013-03-07','13:30:00',3.8),('12374','2013-03-07','13:35:00',4.13),('12374','2013-03-07','13:40:00',3.41),('12374','2013-03-07','13:45:00',2.3),('12374','2013-03-07','13:50:00',1.73),('12374','2013-03-07','14:30:00',1.5),('12374','2013-03-07','14:35:00',1.63),('12374','2013-03-07','14:40:00',2.08),('12374','2013-03-07','14:45:00',1.88),('12374','2013-03-07','14:50:00',1.58),('12374','2013-03-07','14:55:00',1.68),('12374','2013-03-07','15:00:00',2.5),('12374','2013-03-07','15:05:00',2.73),('12374','2013-03-07','15:10:00',2.17),('12374','2013-03-07','15:15:00',1.83),('12374','2013-03-07','15:20:00',1.89),('12374','2013-03-07','15:25:00',1.24),('12374','2013-03-07','15:35:00',1.08),('12374','2013-03-07','15:40:00',1.11),('12374','2013-03-07','15:45:00',1.12),('12374','2013-03-07','15:55:00',1.22),('12374','2013-03-07','16:05:00',1.06),('12374','2013-03-07','16:10:00',1.14),('12374','2013-03-07','16:15:00',1.1),('12374','2013-03-07','16:25:00',1.04),('12374','2013-03-06','09:35:00',1.12),('12374','2013-03-06','09:40:00',1.47),('12374','2013-03-06','09:45:00',1.36),('12374','2013-03-06','09:50:00',1.37),('12374','2013-03-06','09:55:00',1.07),('12374','2013-03-05','07:35:00',1.05),('12374','2013-03-05','07:40:00',1.2),('12374','2013-03-05','07:50:00',1.19),('12374','2013-03-05','07:55:00',2.43),('12374','2013-03-05','08:00:00',2.39),('12374','2013-03-05','08:05:00',2.62),('12374','2013-03-05','08:10:00',2.61),('12374','2013-03-05','08:15:00',2.57),('12374','2013-03-05','08:20:00',3.38),('12374','2013-03-05','08:25:00',4.07),('12374','2013-03-05','08:30:00',3.5),('12374','2013-03-05','08:35:00',3.4),('12374','2013-03-05','08:40:00',3.6),('12374','2013-03-05','08:45:00',2.98),('12374','2013-03-05','08:50:00',2.35),('12374','2013-03-05','08:55:00',2.15),('12374','2013-03-05','09:00:00',2.18),('12374','2013-03-05','09:05:00',2.38),('12374','2013-03-05','09:10:00',2.56),('12374','2013-03-05','09:15:00',2.56),('12374','2013-03-05','09:20:00',2.64),('12374','2013-03-05','09:25:00',2.77),('12374','2013-03-05','09:30:00',2.75),('12374','2013-03-05','09:35:00',2.71),('12374','2013-03-05','09:40:00',2.97),('12374','2013-03-05','09:45:00',3.83),('12374','2013-03-05','09:50:00',5.82),('12374','2013-03-05','09:55:00',3.19),('12374','2013-03-05','10:00:00',3.27),('12374','2013-03-05','10:05:00',4.09),('12374','2013-03-05','10:10:00',4.38),('12374','2013-03-05','10:15:00',4.47),('12374','2013-03-05','10:20:00',4.35),('12374','2013-03-05','10:25:00',5.26),('12374','2013-03-05','10:30:00',5.67),('12374','2013-03-05','10:35:00',5.51),('12374','2013-03-05','10:40:00',5.32),('12374','2013-03-05','10:45:00',5.49),('12374','2013-03-05','10:50:00',5.92),('12374','2013-03-05','10:55:00',6.55),('12374','2013-03-05','11:00:00',6.01),('12374','2013-03-05','11:05:00',5.96),('12374','2013-03-05','11:10:00',5.79),('12374','2013-03-05','11:15:00',5.1),('12374','2013-03-05','11:20:00',4.87),('12374','2013-03-05','11:25:00',5.48),('12374','2013-03-05','11:30:00',5.9),('12374','2013-03-05','11:35:00',6.53),('12374','2013-03-05','11:40:00',6.68),('12374','2013-03-05','11:45:00',7.09),('12374','2013-03-05','11:50:00',6.84),('12374','2013-03-05','11:55:00',6.19),('12374','2013-03-05','12:00:00',5.71),('12374','2013-03-05','12:05:00',5.92),('12374','2013-03-05','12:10:00',5.61),('12374','2013-03-05','12:15:00',5.35),('12374','2013-03-05','12:20:00',5.5),('12374','2013-03-05','12:25:00',5.15),('12374','2013-03-05','12:30:00',4.57),('12374','2013-03-05','12:35:00',4.88),('12374','2013-03-05','12:40:00',5.03),('12374','2013-03-05','12:45:00',4.21),('12374','2013-03-05','12:50:00',3.45),('12374','2013-03-05','12:55:00',3.32),('12374','2013-03-05','13:00:00',3.37),('12374','2013-03-05','13:05:00',3.16),('12374','2013-03-05','13:10:00',2.84),('12374','2013-03-05','13:15:00',2.56),('12374','2013-03-05','13:20:00',2.25),('12374','2013-03-05','13:25:00',1.96),('12374','2013-03-05','13:30:00',2),('12374','2013-03-05','13:35:00',2.05),('12374','2013-03-05','13:40:00',2.17),('12374','2013-03-05','13:45:00',2.46),('12374','2013-03-05','13:50:00',2.42),('12374','2013-03-05','13:55:00',2.41),('12374','2013-03-05','14:00:00',2.85),('12374','2013-03-05','14:05:00',3.02),('12374','2013-03-05','14:10:00',2.98),('12374','2013-03-05','14:15:00',2.92),('12374','2013-03-05','14:20:00',2.74),('12374','2013-03-05','14:25:00',2.46),('12374','2013-03-05','14:30:00',2.21),('12374','2013-03-05','14:35:00',2.11),('12374','2013-03-05','14:40:00',2.11),('12374','2013-03-05','14:45:00',2.08),('12374','2013-03-05','14:50:00',2.06),('12374','2013-03-05','14:55:00',1.95),('12374','2013-03-05','15:00:00',1.79),('12374','2013-03-05','15:05:00',1.4),('12374','2013-03-05','15:10:00',1.36),('12374','2013-03-05','15:15:00',1.67),('12374','2013-03-05','15:20:00',1.63),('12374','2013-03-05','15:25:00',1.67),('12374','2013-03-05','15:30:00',1.71),('12374','2013-03-05','15:35:00',1.82),('12374','2013-03-05','15:40:00',2.24),('12374','2013-03-05','15:45:00',2.76),('12374','2013-03-05','15:50:00',2.56),('12374','2013-03-05','15:55:00',1.97),('12374','2013-03-05','16:00:00',1.52),('12374','2013-03-05','16:05:00',1.28),('12374','2013-03-05','16:10:00',1.14),('12374','2013-03-05','16:15:00',1.01),('12374','2013-03-04','07:20:00',1.16),('12374','2013-03-04','07:25:00',1.45),('12374','2013-03-04','07:30:00',1.67),('12374','2013-03-04','07:35:00',1.79),('12374','2013-03-04','07:40:00',1.97),('12374','2013-03-04','07:45:00',2.42),('12374','2013-03-04','07:50:00',2.6),('12374','2013-03-04','07:55:00',2.82),('12374','2013-03-04','08:00:00',2.8),('12374','2013-03-04','08:05:00',2.89),('12374','2013-03-04','08:10:00',3.39),('12374','2013-03-04','08:15:00',3.58),('12374','2013-03-04','08:20:00',3.78),('12374','2013-03-04','08:25:00',3.95),('12374','2013-03-04','08:30:00',4.04),('12374','2013-03-04','08:35:00',4.27),('12374','2013-03-04','08:40:00',4.41),('12374','2013-03-04','08:45:00',4.61),('12374','2013-03-04','08:50:00',4.78),('12374','2013-03-04','08:55:00',4.9),('12374','2013-03-04','09:00:00',5.12),('12374','2013-03-04','09:05:00',5.3),('12374','2013-03-04','09:10:00',5.48),('12374','2013-03-04','09:15:00',5.67),('12374','2013-03-04','09:20:00',5.83),('12374','2013-03-04','09:25:00',5.97),('12374','2013-03-04','09:30:00',6.14),('12374','2013-03-04','09:35:00',6.25),('12374','2013-03-04','09:40:00',6.43),('12374','2013-03-04','09:45:00',6.56),('12374','2013-03-04','09:50:00',6.69),('12374','2013-03-04','09:55:00',6.77),('12374','2013-03-04','10:00:00',6.87),('12374','2013-03-04','10:05:00',7.02),('12374','2013-03-04','10:10:00',7.11),('12374','2013-03-04','10:15:00',7.23),('12374','2013-03-04','10:20:00',7.36),('12374','2013-03-04','10:25:00',7.46),('12374','2013-03-04','10:30:00',7.54),('12374','2013-03-04','10:35:00',7.56),('12374','2013-03-04','10:40:00',7.58),('12374','2013-03-04','10:45:00',7.72),('12374','2013-03-04','10:50:00',7.7),('12374','2013-03-04','10:55:00',7.93),('12374','2013-03-04','11:00:00',8.03),('12374','2013-03-04','11:05:00',8.1),('12374','2013-03-04','11:10:00',8.11),('12374','2013-03-04','11:15:00',8.1),('12374','2013-03-04','11:20:00',8.16),('12374','2013-03-04','11:25:00',8.24),('12374','2013-03-04','11:30:00',8.27),('12374','2013-03-04','11:35:00',8.18),('12374','2013-03-04','11:40:00',8.14),('12374','2013-03-04','11:45:00',8.36),('12374','2013-03-04','11:50:00',8.4),('12374','2013-03-04','11:55:00',8.38),('12374','2013-03-04','12:00:00',8.39),('12374','2013-03-04','12:05:00',8.38),('12374','2013-03-04','12:10:00',8.46),('12374','2013-03-04','12:15:00',8.56),('12374','2013-03-04','12:20:00',8.64),('12374','2013-03-04','12:25:00',8.64),('12374','2013-03-04','12:30:00',8.59),('12374','2013-03-04','12:35:00',8.61),('12374','2013-03-04','12:40:00',8.59),('12374','2013-03-04','12:45:00',8.53),('12374','2013-03-04','12:50:00',8.53),('12374','2013-03-04','12:55:00',8.56),('12374','2013-03-04','13:00:00',8.22),('12374','2013-03-04','13:05:00',8.35),('12374','2013-03-04','13:10:00',8.37),('12374','2013-03-04','13:15:00',7.56),('12374','2013-03-04','13:20:00',8.25),('12374','2013-03-04','13:25:00',8.09),('12374','2013-03-04','13:30:00',7.97),('12374','2013-03-04','13:35:00',7.9),('12374','2013-03-04','13:40:00',7.81),('12374','2013-03-04','13:45:00',7.72),('12374','2013-03-04','13:50:00',7.53),('12374','2013-03-04','13:55:00',7.53),('12374','2013-03-04','14:00:00',7.42),('12374','2013-03-04','14:05:00',7.31),('12374','2013-03-04','14:10:00',7.2),('12374','2013-03-04','14:15:00',7.12),('12374','2013-03-04','14:20:00',6.98),('12374','2013-03-04','14:25:00',6.91),('12374','2013-03-04','14:30:00',6.82),('12374','2013-03-04','14:35:00',6.73),('12374','2013-03-04','14:40:00',6.57),('12374','2013-03-04','14:45:00',6.45),('12374','2013-03-04','14:50:00',6.28),('12374','2013-03-04','14:55:00',6.16),('12374','2013-03-04','15:00:00',6.01),('12374','2013-03-04','15:05:00',5.84),('12374','2013-03-04','15:10:00',5.67),('12374','2013-03-04','15:15:00',5.54),('12374','2013-03-04','15:20:00',5.37),('12374','2013-03-04','15:25:00',5.2),('12374','2013-03-04','15:30:00',5.06),('12374','2013-03-04','15:35:00',4.93),('12374','2013-03-04','15:40:00',4.75),('12374','2013-03-04','15:45:00',4.56),('12374','2013-03-04','15:50:00',4.45),('12374','2013-03-04','15:55:00',4.32),('12374','2013-03-04','16:00:00',4.1),('12374','2013-03-04','16:05:00',3.85),('12374','2013-03-04','16:10:00',3.61),('12374','2013-03-04','16:15:00',3.45),('12374','2013-03-04','16:20:00',3.29),('12374','2013-03-04','16:25:00',3.05),('12374','2013-03-04','16:30:00',2.91),('12374','2013-03-04','16:35:00',2.66),('12374','2013-03-04','16:40:00',2.41),('12374','2013-03-04','16:45:00',2.16),('12374','2013-03-04','16:50:00',1.86),('12374','2013-03-04','16:55:00',1.53),('12374','2013-03-04','17:00:00',1.26),('12374','2013-03-03','07:10:00',1.07),('12374','2013-03-03','07:15:00',1.36),('12374','2013-03-03','07:20:00',1.57),('12374','2013-03-03','07:25:00',1.7),('12374','2013-03-03','07:30:00',2.06),('12374','2013-03-03','07:35:00',2.28),('12374','2013-03-03','07:40:00',2.39),('12374','2013-03-03','07:45:00',2.44),('12374','2013-03-03','07:50:00',2.94),('12374','2013-03-03','07:55:00',3.14),('12374','2013-03-03','08:00:00',3.04),('12374','2013-03-03','08:05:00',3.37),('12374','2013-03-03','08:10:00',3.44),('12374','2013-03-03','08:15:00',3.91),('12374','2013-03-03','08:20:00',4.1),('12374','2013-03-03','08:25:00',4.28),('12374','2013-03-03','08:30:00',4.44),('12374','2013-03-03','08:35:00',4.61),('12374','2013-03-03','08:40:00',4.78),('12374','2013-03-03','08:45:00',4.94),('12374','2013-03-03','08:50:00',5.11),('12374','2013-03-03','08:55:00',5.25),('12374','2013-03-03','09:00:00',5.44),('12374','2013-03-03','09:05:00',5.59),('12374','2013-03-03','09:10:00',5.75),('12374','2013-03-03','09:15:00',5.89),('12374','2013-03-03','09:20:00',6.02),('12374','2013-03-03','09:25:00',6.16),('12374','2013-03-03','09:30:00',6.29),('12374','2013-03-03','09:35:00',6.39),('12374','2013-03-03','09:40:00',6.58),('12374','2013-03-03','09:45:00',6.71),('12374','2013-03-03','09:50:00',6.84),('12374','2013-03-03','09:55:00',6.95),('12374','2013-03-03','10:00:00',7.06),('12374','2013-03-03','10:05:00',7.19),('12374','2013-03-03','10:10:00',7.32),('12374','2013-03-03','10:15:00',7.42),('12374','2013-03-03','10:20:00',7.51),('12374','2013-03-03','10:25:00',7.65),('12374','2013-03-03','10:30:00',7.74),('12374','2013-03-03','10:35:00',7.84),('12374','2013-03-03','10:40:00',7.86),('12374','2013-03-03','10:45:00',7.95),('12374','2013-03-03','10:50:00',8.02),('12374','2013-03-03','10:55:00',8.16),('12374','2013-03-03','11:00:00',8.22),('12374','2013-03-03','11:05:00',8.29),('12374','2013-03-03','11:10:00',8.33),('12374','2013-03-03','11:15:00',8.32),('12374','2013-03-03','11:20:00',8.32),('12374','2013-03-03','11:25:00',8.37),('12374','2013-03-03','11:30:00',8.49),('12374','2013-03-03','11:35:00',8.45),('12374','2013-03-03','11:40:00',8.55),('12374','2013-03-03','11:45:00',8.54),('12374','2013-03-03','11:50:00',8.55),('12374','2013-03-03','11:55:00',8.62),('12374','2013-03-03','12:00:00',8.6),('12374','2013-03-03','12:05:00',8.65),('12374','2013-03-03','12:10:00',8.63),('12374','2013-03-03','12:15:00',8.54),('12374','2013-03-03','12:20:00',8.53),('12374','2013-03-03','12:25:00',8.53),('12374','2013-03-03','12:30:00',8.53),('12374','2013-03-03','12:35:00',8.52),('12374','2013-03-03','12:40:00',8.5),('12374','2013-03-03','12:45:00',8.49),('12374','2013-03-03','12:50:00',8.5),('12374','2013-03-03','12:55:00',8.52),('12374','2013-03-03','13:00:00',8.48),('12374','2013-03-03','13:05:00',8.44),('12374','2013-03-03','13:10:00',8.34),('12374','2013-03-03','13:15:00',8.29),('12374','2013-03-03','13:20:00',8.22),('12374','2013-03-03','13:25:00',8.11),('12374','2013-03-03','13:30:00',8),('12374','2013-03-03','13:35:00',7.93),('12374','2013-03-03','13:40:00',7.76),('12374','2013-03-03','13:45:00',7.78),('12374','2013-03-03','13:50:00',7.69),('12374','2013-03-03','13:55:00',7.6),('12374','2013-03-03','14:00:00',7.48),('12374','2013-03-03','14:05:00',7.37),('12374','2013-03-03','14:10:00',7.26),('12374','2013-03-03','14:15:00',7.17),('12374','2013-03-03','14:20:00',7.07),('12374','2013-03-03','14:25:00',6.95),('12374','2013-03-03','14:30:00',6.84),('12374','2013-03-03','14:35:00',6.72),('12374','2013-03-03','14:40:00',6.59),('12374','2013-03-03','14:45:00',6.45),('12374','2013-03-03','14:50:00',6.33),('12374','2013-03-03','14:55:00',6.2),('12374','2013-03-03','15:00:00',6.07),('12374','2013-03-03','15:05:00',5.91),('12374','2013-03-03','15:10:00',5.75),('12374','2013-03-03','15:15:00',5.6),('12374','2013-03-03','15:20:00',5.41),('12374','2013-03-03','15:25:00',5.21),('12374','2013-03-03','15:30:00',5.07),('12374','2013-03-03','15:35:00',4.91),('12374','2013-03-03','15:40:00',4.75),('12374','2013-03-03','15:45:00',4.59),('12374','2013-03-03','15:50:00',4.43),('12374','2013-03-03','15:55:00',4.25),('12374','2013-03-03','16:00:00',4.09),('12374','2013-03-03','16:05:00',3.93),('12374','2013-03-03','16:10:00',3.72),('12374','2013-03-03','16:15:00',3.56),('12374','2013-03-03','16:20:00',3.39),('12374','2013-03-03','16:25:00',3.2),('12374','2013-03-03','16:30:00',2.98),('12374','2013-03-03','16:35:00',2.71),('12374','2013-03-03','16:40:00',2.47),('12374','2013-03-03','16:45:00',2.19),('12374','2013-03-03','16:50:00',1.89),('12374','2013-03-03','16:55:00',1.59),('12374','2013-03-03','17:00:00',1.3),('12374','2013-03-02','09:35:00',1.07),('12374','2013-03-02','09:55:00',1.07),('12374','2013-03-02','10:00:00',1.16),('12374','2013-03-02','10:05:00',1.25),('12374','2013-03-02','10:10:00',1.25),('12374','2013-03-02','10:15:00',1.55),('12374','2013-03-02','10:20:00',1.47),('12374','2013-03-02','10:25:00',1.35),('12374','2013-03-02','10:30:00',1.46),('12374','2013-03-02','10:35:00',1.87),('12374','2013-03-02','10:40:00',2.03),('12374','2013-03-02','10:45:00',2.2),('12374','2013-03-02','10:50:00',2.64),('12374','2013-03-02','10:55:00',3.26),('12374','2013-03-02','11:00:00',3.44),('12374','2013-03-02','11:05:00',3.62),('12374','2013-03-02','11:10:00',3.74),('12374','2013-03-02','11:15:00',4.01),('12374','2013-03-02','11:20:00',3.83),('12374','2013-03-02','11:25:00',3.46),('12374','2013-03-02','11:30:00',3.26),('12374','2013-03-02','11:35:00',3.65),('12374','2013-03-02','11:40:00',3.93),('12374','2013-03-02','11:45:00',2.97),('12374','2013-03-02','11:50:00',3.22),('12374','2013-03-02','11:55:00',3.24),('12374','2013-03-02','12:00:00',3.16),('12374','2013-03-02','12:05:00',4.24),('12374','2013-03-02','12:10:00',3.32),('12374','2013-03-02','12:15:00',3.43),('12374','2013-03-02','12:20:00',5.26),('12374','2013-03-02','12:25:00',3.74),('12374','2013-03-02','12:30:00',3.62),('12374','2013-03-02','12:35:00',4.22),('12374','2013-03-02','12:40:00',4.85),('12374','2013-03-02','12:45:00',6.57),('12374','2013-03-02','12:50:00',8.12),('12374','2013-03-02','12:55:00',8.12),('12374','2013-03-02','13:00:00',7.01),('12374','2013-03-02','13:05:00',5.46),('12374','2013-03-02','13:10:00',5.84),('12374','2013-03-02','13:15:00',4.48),('12374','2013-03-02','13:20:00',6.38),('12374','2013-03-02','13:25:00',4.62),('12374','2013-03-02','13:30:00',3.12),('12374','2013-03-02','13:35:00',2.77),('12374','2013-03-02','13:40:00',2.87),('12374','2013-03-02','13:45:00',2.81),('12374','2013-03-02','13:50:00',3.06),('12374','2013-03-02','13:55:00',3.33),('12374','2013-03-02','14:00:00',3.13),('12374','2013-03-02','14:05:00',2.6),('12374','2013-03-02','14:10:00',2.39),('12374','2013-03-02','14:15:00',2.3),('12374','2013-03-02','14:20:00',2.21),('12374','2013-03-02','14:25:00',1.91),('12374','2013-03-02','14:30:00',1.8),('12374','2013-03-02','14:35:00',1.86),('12374','2013-03-02','14:40:00',2.26),('12374','2013-03-02','14:45:00',2.44),('12374','2013-03-02','14:50:00',2.85),('12374','2013-03-02','14:55:00',2.91),('12374','2013-03-02','15:00:00',2.73),('12374','2013-03-02','15:05:00',2.77),('12374','2013-03-02','15:10:00',3.03),('12374','2013-03-02','15:15:00',2.42),('12374','2013-03-02','15:20:00',2.1),('12374','2013-03-02','15:25:00',1.8),('12374','2013-03-02','15:30:00',1.64),('12374','2013-03-02','15:35:00',1.71),('12374','2013-03-02','15:40:00',1.75),('12374','2013-03-02','15:45:00',1.75),('12374','2013-03-02','15:50:00',1.81),('12374','2013-03-02','15:55:00',1.72),('12374','2013-03-02','16:00:00',1.28),('12374','2013-03-01','07:45:00',1.04),('12374','2013-03-01','07:50:00',1.31),('12374','2013-03-01','07:55:00',1.55),('12374','2013-03-01','08:00:00',1.77),('12374','2013-03-01','08:05:00',1.71),('12374','2013-03-01','08:10:00',1.7),('12374','2013-03-01','08:15:00',1.5),('12374','2013-03-01','08:20:00',1.66),('12374','2013-03-01','08:25:00',1.82),('12374','2013-03-01','08:30:00',1.83),('12374','2013-03-01','08:35:00',1.87),('12374','2013-03-01','08:40:00',1.98),('12374','2013-03-01','08:45:00',2.12),('12374','2013-03-01','08:50:00',2.26),('12374','2013-03-01','08:55:00',2.42),('12374','2013-03-01','09:00:00',2.67),('12374','2013-03-01','09:05:00',2.87),('12374','2013-03-01','09:10:00',3),('12374','2013-03-01','09:15:00',3.16),('12374','2013-03-01','09:20:00',3.98),('12374','2013-03-01','09:25:00',4.44),('12374','2013-03-01','09:30:00',4.62),('12374','2013-03-01','09:35:00',4.68),('12374','2013-03-01','09:40:00',4.43),('12374','2013-03-01','09:45:00',4.44),('12374','2013-03-01','09:50:00',4.34),('12374','2013-03-01','09:55:00',4.43),('12374','2013-03-01','10:00:00',4.21),('12374','2013-03-01','10:05:00',4.36),('12374','2013-03-01','10:10:00',4.52),('12374','2013-03-01','10:15:00',4.23),('12374','2013-03-01','10:20:00',3.78),('12374','2013-03-01','10:25:00',3.51),('12374','2013-03-01','10:30:00',3.44),('12374','2013-03-01','10:35:00',3.35),('12374','2013-03-01','10:40:00',3.27),('12374','2013-03-01','10:45:00',3.24),('12374','2013-03-01','10:50:00',3.23),('12374','2013-03-01','10:55:00',3.19),('12374','2013-03-01','11:00:00',3.11),('12374','2013-03-01','11:05:00',3.07),('12374','2013-03-01','11:10:00',3.09),('12374','2013-03-01','11:15:00',3.2),('12374','2013-03-01','11:20:00',3.29),('12374','2013-03-01','11:25:00',3.34),('12374','2013-03-01','11:30:00',3.38),('12374','2013-03-01','11:35:00',3.44),('12374','2013-03-01','11:40:00',3.59),('12374','2013-03-01','11:45:00',3.59),('12374','2013-03-01','11:50:00',3.45),('12374','2013-03-01','11:55:00',3.29),('12374','2013-03-01','12:00:00',3.16),('12374','2013-03-01','12:05:00',3.11),('12374','2013-03-01','12:10:00',3.1),('12374','2013-03-01','12:15:00',3.16),('12374','2013-03-01','12:20:00',3.27),('12374','2013-03-01','12:25:00',3.28),('12374','2013-03-01','12:30:00',3.13),('12374','2013-03-01','12:35:00',3.04),('12374','2013-03-01','12:40:00',3.22),('12374','2013-03-01','12:45:00',3.66),('12374','2013-03-01','12:50:00',3.82),('12374','2013-03-01','12:55:00',3.69),('12374','2013-03-01','13:00:00',3.52),('12374','2013-03-01','13:05:00',3.36),('12374','2013-03-01','13:10:00',3.26),('12374','2013-03-01','13:15:00',3.14),('12374','2013-03-01','13:20:00',2.96),('12374','2013-03-01','13:25:00',2.83),('12374','2013-03-01','13:30:00',2.82),('12374','2013-03-01','13:35:00',2.69),('12374','2013-03-01','13:40:00',2.5),('12374','2013-03-01','13:45:00',2.27),('12374','2013-03-01','13:50:00',2.11),('12374','2013-03-01','13:55:00',2),('12374','2013-03-01','14:00:00',2),('12374','2013-03-01','14:05:00',2.03),('12374','2013-03-01','14:10:00',2.01),('12374','2013-03-01','14:15:00',2.05),('12374','2013-03-01','14:20:00',2.16),('12374','2013-03-01','14:25:00',2.22),('12374','2013-03-01','14:30:00',2.21),('12374','2013-03-01','14:35:00',2.16),('12374','2013-03-01','14:40:00',2.07),('12374','2013-03-01','14:45:00',2.04),('12374','2013-03-01','14:50:00',2.01),('12374','2013-03-01','14:55:00',1.96),('12374','2013-03-01','15:00:00',1.96),('12374','2013-03-01','15:05:00',1.97),('12374','2013-03-01','15:10:00',1.85),('12374','2013-03-01','15:15:00',1.61),('12374','2013-03-01','15:20:00',1.35),('12374','2013-03-01','15:25:00',1.17),('12374','2013-03-01','15:30:00',1.14),('12374','2013-03-01','15:35:00',1.11),('12374','2013-03-01','15:40:00',1),('12374','2013-03-01','15:55:00',1.1),('12374','2013-03-01','16:00:00',1.06),('12374','2013-02-28','07:25:00',1.04),('12374','2013-02-28','07:30:00',1.2),('12374','2013-02-28','07:35:00',1.46),('12374','2013-02-28','07:40:00',1.68),('12374','2013-02-28','07:45:00',1.78),('12374','2013-02-28','07:50:00',1.96),('12374','2013-02-28','07:55:00',2.29),('12374','2013-02-28','08:00:00',2.5),('12374','2013-02-28','08:05:00',2.49),('12374','2013-02-28','08:10:00',2.88),('12374','2013-02-28','08:15:00',2.84),('12374','2013-02-28','08:20:00',3.29),('12374','2013-02-28','08:25:00',3.47),('12374','2013-02-28','08:30:00',3.66),('12374','2013-02-28','08:35:00',3.89),('12374','2013-02-28','08:40:00',4.06),('12374','2013-02-28','08:45:00',4.18),('12374','2013-02-28','08:50:00',4.33),('12374','2013-02-28','08:55:00',4.56),('12374','2013-02-28','09:00:00',4.73),('12374','2013-02-28','09:05:00',4.87),('12374','2013-02-28','09:10:00',5.02),('12374','2013-02-28','09:15:00',5.18),('12374','2013-02-28','09:20:00',5.42),('12374','2013-02-28','09:25:00',5.6),('12374','2013-02-28','09:30:00',5.73),('12374','2013-02-28','09:35:00',5.9),('12374','2013-02-28','09:40:00',6.07),('12374','2013-02-28','09:45:00',6.22),('12374','2013-02-28','09:50:00',6.39),('12374','2013-02-28','09:55:00',6.54),('12374','2013-02-28','10:00:00',6.67),('12374','2013-02-28','10:05:00',6.78),('12374','2013-02-28','10:10:00',6.9),('12374','2013-02-28','10:15:00',7.01),('12374','2013-02-28','10:20:00',7.13),('12374','2013-02-28','10:25:00',7.16),('12374','2013-02-28','10:30:00',7.23),('12374','2013-02-28','10:35:00',7.36),('12374','2013-02-28','10:40:00',7.39),('12374','2013-02-28','10:45:00',7.35),('12374','2013-02-28','10:50:00',7.68),('12374','2013-02-28','10:55:00',7.74),('12374','2013-02-28','11:00:00',7.79),('12374','2013-02-28','11:05:00',7.61),('12374','2013-02-28','11:10:00',6.65),('12374','2013-02-28','11:15:00',6.22),('12374','2013-02-28','11:20:00',7.83),('12374','2013-02-28','11:25:00',8.09),('12374','2013-02-28','11:30:00',8.12),('12374','2013-02-28','11:35:00',8.18),('12374','2013-02-28','11:40:00',8.23),('12374','2013-02-28','11:45:00',8.24),('12374','2013-02-28','11:50:00',8.24),('12374','2013-02-28','11:55:00',8.27),('12374','2013-02-28','12:00:00',8.18),('12374','2013-02-28','12:05:00',8.21),('12374','2013-02-28','12:10:00',8.12),('12374','2013-02-28','12:15:00',8.2),('12374','2013-02-28','12:20:00',8.06),('12374','2013-02-28','12:25:00',8.04),('12374','2013-02-28','12:30:00',8.14),('12374','2013-02-28','12:35:00',8.11),('12374','2013-02-28','12:40:00',7.85),('12374','2013-02-28','12:45:00',8.08),('12374','2013-02-28','12:50:00',8.11),('12374','2013-02-28','12:55:00',8.02),('12374','2013-02-28','13:00:00',7.98),('12374','2013-02-28','13:05:00',7.87),('12374','2013-02-28','13:10:00',7.84),('12374','2013-02-28','13:15:00',7.84),('12374','2013-02-28','13:20:00',7.82),('12374','2013-02-28','13:25:00',7.69),('12374','2013-02-28','13:30:00',7.64),('12374','2013-02-28','13:35:00',7.5),('12374','2013-02-28','13:40:00',7.52),('12374','2013-02-28','13:45:00',7.47),('12374','2013-02-28','13:50:00',7.41),('12374','2013-02-28','13:55:00',7.36),('12374','2013-02-28','14:00:00',7.3),('12374','2013-02-28','14:05:00',7.15),('12374','2013-02-28','14:10:00',7.05),('12374','2013-02-28','14:15:00',6.98),('12374','2013-02-28','14:20:00',6.86),('12374','2013-02-28','14:25:00',6.74),('12374','2013-02-28','14:30:00',6.6),('12374','2013-02-28','14:35:00',6.46),('12374','2013-02-28','14:40:00',6.35),('12374','2013-02-28','14:45:00',6.12),('12374','2013-02-28','14:50:00',5.84),('12374','2013-02-28','14:55:00',5.69),('12374','2013-02-28','15:00:00',5.62),('12374','2013-02-28','15:05:00',5.52),('12374','2013-02-28','15:10:00',5.3),('12374','2013-02-28','15:15:00',5.03),('12374','2013-02-28','15:20:00',4.87),('12374','2013-02-28','15:25:00',4.72),('12374','2013-02-28','15:30:00',4.59),('12374','2013-02-28','15:35:00',4.32),('12374','2013-02-28','15:40:00',4.26),('12374','2013-02-28','15:45:00',4.08),('12374','2013-02-28','15:50:00',3.9),('12374','2013-02-28','15:55:00',3.72),('12374','2013-02-28','16:00:00',3.54),('12374','2013-02-28','16:05:00',3.42),('12374','2013-02-28','16:10:00',3.22),('12374','2013-02-28','16:15:00',3.07),('12374','2013-02-28','16:20:00',2.93),('12374','2013-02-28','16:25:00',2.75),('12374','2013-02-28','16:30:00',2.59),('12374','2013-02-28','16:35:00',2.34),('12374','2013-02-28','16:40:00',2.15),('12374','2013-02-28','16:45:00',1.9),('12374','2013-02-28','16:50:00',1.68),('12374','2013-02-28','16:55:00',1.39),('12374','2013-02-28','17:00:00',1.13),('12374','2013-02-27','07:25:00',1),('12374','2013-02-27','07:30:00',1.23),('12374','2013-02-27','07:35:00',1.43),('12374','2013-02-27','07:40:00',1.69),('12374','2013-02-27','07:45:00',1.91),('12374','2013-02-27','07:50:00',2),('12374','2013-02-27','07:55:00',2.17),('12374','2013-02-27','08:00:00',2.52),('12374','2013-02-27','08:05:00',2.73),('12374','2013-02-27','08:10:00',2.72),('12374','2013-02-27','08:15:00',3.02),('12374','2013-02-27','08:20:00',3.17),('12374','2013-02-27','08:25:00',3.53),('12374','2013-02-27','08:30:00',3.73),('12374','2013-02-27','08:35:00',3.93),('12374','2013-02-27','08:40:00',4.09),('12374','2013-02-27','08:45:00',4.25),('12374','2013-02-27','08:50:00',4.43),('12374','2013-02-27','08:55:00',4.6),('12374','2013-02-27','09:00:00',4.76),('12374','2013-02-27','09:05:00',4.93),('12374','2013-02-27','09:10:00',5.11),('12374','2013-02-27','09:15:00',5.26),('12374','2013-02-27','09:20:00',5.44),('12374','2013-02-27','09:25:00',5.61),('12374','2013-02-27','09:30:00',5.77),('12374','2013-02-27','09:35:00',5.93),('12374','2013-02-27','09:40:00',6.09),('12374','2013-02-27','09:45:00',6.26),('12374','2013-02-27','09:50:00',6.4),('12374','2013-02-27','09:55:00',6.52),('12374','2013-02-27','10:00:00',6.6),('12374','2013-02-27','10:05:00',6.75),('12374','2013-02-27','10:10:00',6.86),('12374','2013-02-27','10:15:00',6.96),('12374','2013-02-27','10:20:00',7.02),('12374','2013-02-27','10:25:00',7.07),('12374','2013-02-27','10:30:00',7.16),('12374','2013-02-27','10:35:00',7.22),('12374','2013-02-27','10:40:00',7.36),('12374','2013-02-27','10:45:00',7.46),('12374','2013-02-27','10:50:00',7.59),('12374','2013-02-27','10:55:00',7.66),('12374','2013-02-27','11:00:00',7.74),('12374','2013-02-27','11:05:00',7.78),('12374','2013-02-27','11:10:00',7.83),('12374','2013-02-27','11:15:00',7.77),('12374','2013-02-27','11:20:00',7.9),('12374','2013-02-27','11:25:00',8.07),('12374','2013-02-27','11:30:00',8.11),('12374','2013-02-27','11:35:00',8.08),('12374','2013-02-27','11:40:00',7.67),('12374','2013-02-27','11:45:00',8.17),('12374','2013-02-27','11:50:00',8.48),('12374','2013-02-27','11:55:00',8.65),('12374','2013-02-27','12:00:00',5.04),('12374','2013-02-27','12:05:00',2.34),('12374','2013-02-27','12:10:00',6.2),('12374','2013-02-27','12:15:00',8.58),('12374','2013-02-27','12:20:00',8.53),('12374','2013-02-27','12:25:00',8.39),('12374','2013-02-27','12:30:00',8.39),('12374','2013-02-27','12:35:00',8.31),('12374','2013-02-27','12:40:00',8.34),('12374','2013-02-27','12:45:00',8.32),('12374','2013-02-27','12:50:00',8.25),('12374','2013-02-27','12:55:00',8.14),('12374','2013-02-27','13:00:00',8.11),('12374','2013-02-27','13:05:00',8.02),('12374','2013-02-27','13:10:00',8.02),('12374','2013-02-27','13:15:00',7.98),('12374','2013-02-27','13:20:00',7.96),('12374','2013-02-27','13:25:00',7.9),('12374','2013-02-27','13:30:00',7.84),('12374','2013-02-27','13:35:00',7.75),('12374','2013-02-27','13:40:00',7.67),('12374','2013-02-27','13:45:00',7.6),('12374','2013-02-27','13:50:00',7.46),('12374','2013-02-27','13:55:00',7.38),('12374','2013-02-27','14:00:00',7.23),('12374','2013-02-27','14:05:00',7.06),('12374','2013-02-27','14:10:00',7.07),('12374','2013-02-27','14:15:00',6.89),('12374','2013-02-27','14:20:00',6.81),('12374','2013-02-27','14:25:00',6.72),('12374','2013-02-27','14:30:00',6.55),('12374','2013-02-27','14:35:00',6.45),('12374','2013-02-27','14:40:00',6.33),('12374','2013-02-27','14:45:00',6.17),('12374','2013-02-27','14:50:00',6.01),('12374','2013-02-27','14:55:00',5.86),('12374','2013-02-27','15:00:00',5.66),('12374','2013-02-27','15:05:00',5.55),('12374','2013-02-27','15:10:00',5.44),('12374','2013-02-27','15:15:00',5.33),('12374','2013-02-27','15:20:00',5.15),('12374','2013-02-27','15:25:00',4.99),('12374','2013-02-27','15:30:00',4.84),('12374','2013-02-27','15:35:00',4.69),('12374','2013-02-27','15:40:00',4.5),('12374','2013-02-27','15:45:00',4.35),('12374','2013-02-27','15:50:00',4.19),('12374','2013-02-27','15:55:00',4),('12374','2013-02-27','16:00:00',3.88),('12374','2013-02-27','16:05:00',3.7),('12374','2013-02-27','16:10:00',3.47),('12374','2013-02-27','16:15:00',3.33),('12374','2013-02-27','16:20:00',3.12),('12374','2013-02-27','16:25:00',2.87),('12374','2013-02-27','16:30:00',2.69),('12374','2013-02-27','16:35:00',2.46),('12374','2013-02-27','16:40:00',2.26),('12374','2013-02-27','16:45:00',1.98),('12374','2013-02-27','16:50:00',1.72),('12374','2013-02-27','16:55:00',1.39),('12374','2013-02-27','17:00:00',1.18),('12374','2013-02-26','08:40:00',1.05),('12374','2013-02-26','08:45:00',1.19),('12374','2013-02-26','08:50:00',1.37),('12374','2013-02-26','08:55:00',1.57),('12374','2013-02-26','09:00:00',1.75),('12374','2013-02-26','09:05:00',1.88),('12374','2013-02-26','09:10:00',1.96),('12374','2013-02-26','09:16:00',2.03),('12374','2013-02-26','09:20:00',2.22),('12374','2013-02-26','09:25:00',2.45),('12374','2013-02-26','09:30:00',2.76),('12374','2013-02-26','09:35:00',3.13),('12374','2013-02-26','09:40:00',3.3),('12374','2013-02-26','09:45:00',3.67),('12374','2013-02-26','09:50:00',4.12),('12374','2013-02-26','09:55:00',4.53),('12374','2013-02-26','10:00:00',5.49),('12374','2013-02-26','10:05:00',6.27),('12374','2013-02-26','10:10:00',6.29),('12374','2013-02-26','10:15:00',6.82),('12374','2013-02-26','10:20:00',7.1),('12374','2013-02-26','10:25:00',7.28),('12374','2013-02-26','10:30:00',7.3),('12374','2013-02-26','10:35:00',7.41),('12374','2013-02-26','10:40:00',7.33),('12374','2013-02-26','10:45:00',7.48),('12374','2013-02-26','10:50:00',7.67),('12374','2013-02-26','10:55:00',6.84),('12374','2013-02-26','11:00:00',7.81),('12374','2013-02-26','11:05:00',7.68),('12374','2013-02-26','11:10:00',4.41),('12374','2013-02-26','11:15:00',6.28),('12374','2013-02-26','11:20:00',4.32),('12374','2013-02-26','11:25:00',4.07),('12374','2013-02-26','11:30:00',4.4),('12374','2013-02-26','11:35:00',4.98),('12374','2013-02-26','11:40:00',5.11),('12374','2013-02-26','11:45:00',5.21),('12374','2013-02-26','11:50:00',7.42),('12374','2013-02-26','11:55:00',9.7),('12374','2013-02-26','12:00:00',9.1),('12374','2013-02-26','12:05:00',6.2),('12374','2013-02-26','12:10:00',5.18),('12374','2013-02-26','12:15:00',6.12),('12374','2013-02-26','12:20:00',5.61),('12374','2013-02-26','12:25:00',8.12),('12374','2013-02-26','12:30:00',8.88),('12374','2013-02-26','12:35:00',5.64),('12374','2013-02-26','12:40:00',5.46),('12374','2013-02-26','12:45:00',6.12),('12374','2013-02-26','12:50:00',4.51),('12374','2013-02-26','12:55:00',4.74),('12374','2013-02-26','13:00:00',7.69),('12374','2013-02-26','13:05:00',5.2),('12374','2013-02-26','13:10:00',7.1),('12374','2013-02-26','13:15:00',6.01),('12374','2013-02-26','13:20:00',3.26),('12374','2013-02-26','13:25:00',2.18),('12374','2013-02-26','13:30:00',1.98),('12374','2013-02-26','13:35:00',1.86),('12374','2013-02-26','13:40:00',1.78),('12374','2013-02-26','13:45:00',1.7),('12374','2013-02-26','13:50:00',1.71),('12374','2013-02-26','13:55:00',1.79),('12374','2013-02-26','14:00:00',1.87),('12374','2013-02-26','14:05:00',2.04),('12374','2013-02-26','14:10:00',2.25),('12374','2013-02-26','14:15:00',2.41),('12374','2013-02-26','14:20:00',2.36),('12374','2013-02-26','14:25:00',2.32),('12374','2013-02-26','14:30:00',2.27),('12374','2013-02-26','14:35:00',2.07),('12374','2013-02-26','14:40:00',2.06),('12374','2013-02-26','14:45:00',1.92),('12374','2013-02-26','14:50:00',1.82),('12374','2013-02-26','14:55:00',1.88),('12374','2013-02-26','15:00:00',1.25),('12374','2013-02-26','15:05:00',1.02),('12374','2013-02-25','08:20:00',1.2),('12374','2013-02-25','08:30:00',1.07),('12374','2013-02-25','08:35:00',1.34),('12374','2013-02-25','08:40:00',1.5),('12374','2013-02-25','08:45:00',1.2),('12374','2013-02-25','09:10:00',1.91),('12374','2013-02-25','09:15:00',3.31),('12374','2013-02-25','09:20:00',4.38),('12374','2013-02-25','09:25:00',3.23),('12374','2013-02-25','09:30:00',4.45),('12374','2013-02-25','09:35:00',2.44),('12374','2013-02-25','09:40:00',5.05),('12374','2013-02-25','09:45:00',4.09),('12374','2013-02-25','09:50:00',4.05),('12374','2013-02-25','09:55:00',3.69),('12374','2013-02-25','10:00:00',5.44),('12374','2013-02-25','10:05:00',4.21),('12374','2013-02-25','10:10:00',4.49),('12374','2013-02-25','10:15:00',5.8),('12374','2013-02-25','10:20:00',6.67),('12374','2013-02-25','10:25:00',5.11),('12374','2013-02-25','10:30:00',5.54),('12374','2013-02-25','10:35:00',7.25),('12374','2013-02-25','10:40:00',6.92),('12374','2013-02-25','10:45:00',7.62),('12374','2013-02-25','10:50:00',8.22),('12374','2013-02-25','10:55:00',8.22),('12374','2013-02-25','11:00:00',8.24),('12374','2013-02-25','11:05:00',8.2),('12374','2013-02-25','11:10:00',8.28),('12374','2013-02-25','11:15:00',8.44),('12374','2013-02-25','11:20:00',8.61),('12374','2013-02-25','11:25:00',6.87),('12374','2013-02-25','11:30:00',8.08),('12374','2013-02-25','11:35:00',9.46),('12374','2013-02-25','11:40:00',7.08),('12374','2013-02-25','11:45:00',7.57),('12374','2013-02-25','11:50:00',9.12),('12374','2013-02-25','11:55:00',8.88),('12374','2013-02-25','12:00:00',8.14),('12374','2013-02-25','12:05:00',5.66),('12374','2013-02-25','12:10:00',3.52),('12374','2013-02-25','12:15:00',3.94),('12374','2013-02-25','12:20:00',4.57),('12374','2013-02-25','12:25:00',5.74),('12374','2013-02-25','12:30:00',6.44),('12374','2013-02-25','12:35:00',5.47),('12374','2013-02-25','12:40:00',3.53),('12374','2013-02-25','12:45:00',2.86),('12374','2013-02-25','12:50:00',3.07),('12374','2013-02-25','12:55:00',3.87),('12374','2013-02-25','13:00:00',3.95),('12374','2013-02-25','13:05:00',4.5),('12374','2013-02-25','13:10:00',4.15),('12374','2013-02-25','13:15:00',3.22),('12374','2013-02-25','13:20:00',2.68),('12374','2013-02-25','13:25:00',2.55),('12374','2013-02-25','13:30:00',2.44),('12374','2013-02-25','13:35:00',2.39),('12374','2013-02-25','13:40:00',2.72),('12374','2013-02-25','13:45:00',3.48),('12374','2013-02-25','13:50:00',4.02),('12374','2013-02-25','13:55:00',4.68),('12374','2013-02-25','14:00:00',5.29),('12374','2013-02-25','14:05:00',6.58),('12374','2013-02-25','14:10:00',6.25),('12374','2013-02-25','14:15:00',6.9),('12374','2013-02-25','14:20:00',4.79),('12374','2013-02-25','14:25:00',6.83),('12374','2013-02-25','14:30:00',5.34),('12374','2013-02-25','14:35:00',1.97),('12374','2013-02-25','14:40:00',3.72),('12374','2013-02-25','14:45:00',2.68),('12374','2013-02-25','14:50:00',2.66),('12374','2013-02-25','14:55:00',3.34),('12374','2013-02-25','15:00:00',2.71),('12374','2013-02-25','15:05:00',4.08),('12374','2013-02-25','15:10:00',3.57),('12374','2013-02-25','15:15:00',2.43),('12374','2013-02-25','15:20:00',2.17),('12374','2013-02-25','15:25:00',2.08),('12374','2013-02-25','15:30:00',1.89),('12374','2013-02-25','15:35:00',1.69),('12374','2013-02-25','15:40:00',1.54),('12374','2013-02-25','15:45:00',1.46),('12374','2013-02-25','15:50:00',1.23),('12374','2013-02-25','16:10:00',1.5),('12374','2013-02-25','16:20:00',2.07),('12374','2013-02-25','16:25:00',1.75),('12374','2013-02-24','08:35:00',1.23),('12374','2013-02-24','08:40:00',1.34),('12374','2013-02-24','08:45:00',1.14),('12374','2013-02-24','08:50:00',1.05),('12374','2013-02-24','08:55:00',1.09),('12374','2013-02-24','09:00:00',1.25),('12374','2013-02-24','09:05:00',1.5),('12374','2013-02-24','09:10:00',1.76),('12374','2013-02-24','09:15:00',1.7),('12374','2013-02-24','09:20:00',1.39),('12374','2013-02-24','09:25:00',1.92),('12374','2013-02-24','09:30:00',1.93),('12374','2013-02-24','09:35:00',1.47),('12374','2013-02-24','09:40:00',1.46),('12374','2013-02-24','09:45:00',1.64),('12374','2013-02-24','09:50:00',1.75),('12374','2013-02-24','09:55:00',2.1),('12374','2013-02-24','10:00:00',1.66),('12374','2013-02-24','10:05:00',1.75),('12374','2013-02-24','10:10:00',1.7),('12374','2013-02-24','10:15:00',2.26),('12374','2013-02-24','10:20:00',2.7),('12374','2013-02-24','10:25:00',2.94),('12374','2013-02-24','10:30:00',3.34),('12374','2013-02-24','10:35:00',2.98),('12374','2013-02-24','10:40:00',2.11),('12374','2013-02-24','10:45:00',1.83),('12374','2013-02-24','10:50:00',1.98),('12374','2013-02-24','10:55:00',2.21),('12374','2013-02-24','11:00:00',2.03),('12374','2013-02-24','11:05:00',1.84),('12374','2013-02-24','11:10:00',2.12),('12374','2013-02-24','11:15:00',2.56),('12374','2013-02-24','11:20:00',2.94),('12374','2013-02-24','11:25:00',2.88),('12374','2013-02-24','11:30:00',2.4),('12374','2013-02-24','11:35:00',2.82),('12374','2013-02-24','11:40:00',3.65),('12374','2013-02-24','11:45:00',4.36),('12374','2013-02-24','11:50:00',5),('12374','2013-02-24','11:55:00',5.53),('12374','2013-02-24','12:00:00',3.95),('12374','2013-02-24','12:05:00',4.98),('12374','2013-02-24','12:10:00',5.95),('12374','2013-02-24','12:15:00',3.98),('12374','2013-02-24','12:20:00',5.91),('12374','2013-02-24','12:25:00',8.07),('12374','2013-02-24','12:30:00',3.57),('12374','2013-02-24','12:35:00',5.81),('12374','2013-02-24','12:40:00',6.74),('12374','2013-02-24','12:45:00',4.13),('12374','2013-02-24','12:50:00',3.62),('12374','2013-02-24','12:55:00',8.61),('12374','2013-02-24','13:00:00',3.88),('12374','2013-02-24','13:05:00',9.63),('12374','2013-02-24','13:10:00',8.76),('12374','2013-02-24','13:15:00',5.9),('12374','2013-02-24','13:20:00',8.73),('12374','2013-02-24','13:25:00',8.61),('12374','2013-02-24','13:30:00',5.8),('12374','2013-02-24','13:35:00',4.98),('12374','2013-02-24','13:40:00',7.33),('12374','2013-02-24','13:45:00',3.26),('12374','2013-02-24','13:50:00',2.2),('12374','2013-02-24','13:55:00',2.65),('12374','2013-02-24','14:00:00',2.48),('12374','2013-02-24','14:05:00',2.15),('12374','2013-02-24','14:10:00',2.24),('12374','2013-02-24','14:15:00',2.16),('12374','2013-02-24','14:20:00',6.33),('12374','2013-02-24','14:25:00',7.61),('12374','2013-02-24','14:30:00',4.82),('12374','2013-02-24','14:35:00',7.01),('12374','2013-02-24','14:40:00',6.01),('12374','2013-02-24','14:45:00',3.59),('12374','2013-02-24','14:50:00',6.21),('12374','2013-02-24','14:55:00',6.99),('12374','2013-02-24','15:00:00',3.9),('12374','2013-02-24','15:05:00',2.06),('12374','2013-02-24','15:10:00',6.5),('12374','2013-02-24','15:15:00',3.91),('12374','2013-02-24','15:20:00',4.51),('12374','2013-02-24','15:25:00',3.41),('12374','2013-02-24','15:30:00',2.81),('12374','2013-02-24','15:35:00',5.12),('12374','2013-02-24','15:40:00',3.75),('12374','2013-02-24','15:45:00',4.56),('12374','2013-02-24','15:50:00',4.68),('12374','2013-02-24','15:55:00',3.48),('12374','2013-02-24','16:00:00',2.41),('12374','2013-02-23','07:25:00',1.24),('12374','2013-02-23','07:30:00',1.56),('12374','2013-02-23','07:35:00',1.88),('12374','2013-02-23','07:40:00',2.25),('12374','2013-02-23','07:45:00',2.92),('12374','2013-02-23','07:50:00',2.87),('12374','2013-02-23','07:55:00',2.8),('12374','2013-02-23','08:00:00',3.6),('12374','2013-02-23','08:05:00',2.66),('12374','2013-02-23','08:10:00',1.33),('12374','2013-02-23','08:15:00',1.07),('12374','2013-02-23','08:40:00',1.12),('12374','2013-02-23','08:45:00',1.34),('12374','2013-02-23','08:50:00',1.57),('12374','2013-02-23','08:55:00',1.4),('12374','2013-02-23','09:00:00',1.2),('12374','2013-02-23','09:05:00',1.09),('12374','2013-02-23','09:10:00',1.08),('12374','2013-02-23','09:15:00',1.09),('12374','2013-02-23','09:30:00',1.05),('12374','2013-02-23','09:35:00',1.01),('12374','2013-02-23','09:40:00',1.22),('12374','2013-02-23','09:45:00',1.58),('12374','2013-02-23','09:50:00',1.26),('12374','2013-02-23','10:20:00',1.13),('12374','2013-02-23','10:25:00',2.4),('12374','2013-02-23','10:30:00',1.74),('12374','2013-02-23','10:35:00',1.09),('12374','2013-02-23','10:40:00',1.12),('12374','2013-02-23','10:45:00',1.07),('12374','2013-02-23','10:50:00',1.32),('12374','2013-02-23','11:05:00',1.16),('12374','2013-02-23','11:10:00',1.67),('12374','2013-02-23','11:15:00',1.55),('12374','2013-02-23','11:25:00',1.31),('12374','2013-02-23','11:30:00',1.93),('12374','2013-02-23','11:35:00',1.32),('12374','2013-02-23','11:50:00',1.05),('12374','2013-02-23','12:05:00',1.02),('12374','2013-02-23','12:10:00',1.38),('12374','2013-02-22','11:10:00',1.11),('12374','2013-02-22','11:15:00',1.65),('12374','2013-02-22','11:20:00',1.68),('12374','2013-02-22','11:25:00',1.4),('12374','2013-02-22','11:55:00',1.14),('12374','2013-02-22','12:00:00',1.78),('12374','2013-02-22','12:05:00',1.97),('12374','2013-02-22','12:10:00',1.83),('12374','2013-02-22','12:15:00',2),('12374','2013-02-22','12:20:00',2.12),('12374','2013-02-22','12:25:00',1.63),('12374','2013-02-22','12:30:00',1.09),('12374','2013-02-22','13:00:00',1.33),('12374','2013-02-22','13:05:00',2.08),('12374','2013-02-22','13:10:00',1.11),('12374','2013-02-22','13:40:00',2.47),('12374','2013-02-22','13:45:00',3.31),('12374','2013-02-22','13:50:00',2.6),('12374','2013-02-22','13:55:00',3.12),('12374','2013-02-22','14:00:00',2.23),('12374','2013-02-22','14:10:00',1.15),('12374','2013-02-22','14:15:00',1.3),('12374','2013-02-22','14:25:00',1.68),('12374','2013-02-22','14:30:00',3.67),('12374','2013-02-22','14:35:00',3.14),('12374','2013-02-22','14:40:00',4.02),('12374','2013-02-22','14:45:00',5.4),('12374','2013-02-22','14:50:00',5.36),('12374','2013-02-22','14:55:00',4.09),('12374','2013-02-22','15:00:00',2.78),('12374','2013-02-22','15:05:00',2.3),('12374','2013-02-22','15:10:00',1.39),('12374','2013-02-22','15:45:00',2.58),('12374','2013-02-22','15:50:00',1.59),('12374','2013-02-22','15:55:00',1.33),('12374','2013-02-22','16:00:00',1.23),('12374','2013-02-22','16:05:00',1.29),('12374','2013-02-22','16:10:00',2.41),('12374','2013-02-22','16:15:00',2.9),('12374','2013-02-21','09:15:00',1.09),('12374','2013-02-21','09:20:00',1.24),('12374','2013-02-21','09:25:00',1.38),('12374','2013-02-21','09:30:00',1.44),('12374','2013-02-21','09:35:00',1.47),('12374','2013-02-21','09:40:00',1.52),('12374','2013-02-21','09:45:00',1.53),('12374','2013-02-21','09:50:00',1.62),('12374','2013-02-21','09:55:00',1.71),('12374','2013-02-21','10:00:00',1.79),('12374','2013-02-21','10:05:00',1.91),('12374','2013-02-21','10:10:00',2.01),('12374','2013-02-21','10:15:00',1.97),('12374','2013-02-21','10:20:00',1.97),('12374','2013-02-21','10:25:00',2.06),('12374','2013-02-21','10:30:00',2.17),('12374','2013-02-21','10:35:00',2.15),('12374','2013-02-21','10:40:00',2.08),('12374','2013-02-21','10:45:00',1.92),('12374','2013-02-21','10:50:00',1.75),('12374','2013-02-21','10:55:00',1.72),('12374','2013-02-21','11:00:00',1.64),('12374','2013-02-21','11:05:00',1.67),('12374','2013-02-21','11:10:00',1.81),('12374','2013-02-21','11:15:00',1.94),('12374','2013-02-21','11:20:00',2.13),('12374','2013-02-21','11:25:00',2.15),('12374','2013-02-21','11:30:00',2.22),('12374','2013-02-21','11:35:00',2.25),('12374','2013-02-21','11:40:00',2.27),('12374','2013-02-21','11:45:00',2.39),('12374','2013-02-21','11:50:00',2.51),('12374','2013-02-21','11:55:00',2.62),('12374','2013-02-21','12:00:00',2.61),('12374','2013-02-21','12:05:00',2.68),('12374','2013-02-21','12:10:00',2.74),('12374','2013-02-21','12:15:00',2.6),('12374','2013-02-21','12:20:00',2.36),('12374','2013-02-21','12:25:00',2.1),('12374','2013-02-21','12:30:00',1.88),('12374','2013-02-21','12:35:00',1.55),('12374','2013-02-21','12:40:00',1.46),('12374','2013-02-21','12:45:00',1.58),('12374','2013-02-21','12:50:00',1.83),('12374','2013-02-21','12:55:00',2.09),('12374','2013-02-21','13:00:00',2.5),('12374','2013-02-21','13:05:00',2.97),('12374','2013-02-21','13:10:00',3),('12374','2013-02-21','13:15:00',4.06),('12374','2013-02-21','13:20:00',4.8),('12374','2013-02-21','13:25:00',3.61),('12374','2013-02-21','13:30:00',3.36),('12374','2013-02-21','13:35:00',3.04),('12374','2013-02-21','13:40:00',3.16),('12374','2013-02-21','13:45:00',3.69),('12374','2013-02-21','13:50:00',3.35),('12374','2013-02-21','13:55:00',3.33),('12374','2013-02-21','14:00:00',3.88),('12374','2013-02-21','14:05:00',4.16),('12374','2013-02-21','14:10:00',3.08),('12374','2013-02-21','14:15:00',2.71),('12374','2013-02-21','14:20:00',2.41),('12374','2013-02-21','14:25:00',2.24),('12374','2013-02-21','14:30:00',2.17),('12374','2013-02-21','14:35:00',2.23),('12374','2013-02-21','14:40:00',2.68),('12374','2013-02-21','14:45:00',3.61),('12374','2013-02-21','14:50:00',5.6),('12374','2013-02-21','14:55:00',6.63),('12374','2013-02-21','15:00:00',6.23),('12374','2013-02-21','15:05:00',5.98),('12374','2013-02-21','15:10:00',5.66),('12374','2013-02-21','15:15:00',5.35),('12374','2013-02-21','15:20:00',5.12),('12374','2013-02-21','15:25:00',4.91),('12374','2013-02-21','15:30:00',4.66),('12374','2013-02-21','15:35:00',4.44),('12374','2013-02-21','15:40:00',4.28),('12374','2013-02-21','15:45:00',4.15),('12374','2013-02-21','15:50:00',3.95),('12374','2013-02-21','15:55:00',3.77),('12374','2013-02-21','16:00:00',3.61),('12374','2013-02-21','16:05:00',3.32),('12374','2013-02-21','16:10:00',3.19),('12374','2013-02-21','16:15:00',3.05),('12374','2013-02-21','16:20:00',2.85),('12374','2013-02-21','16:25:00',2.65),('12374','2013-02-21','16:30:00',2.5),('12374','2013-02-21','16:35:00',2.29),('12374','2013-02-21','16:40:00',2.07),('12374','2013-02-21','16:45:00',1.85),('12374','2013-02-21','16:50:00',1.66),('12374','2013-02-21','16:55:00',1.45),('12374','2013-02-21','17:00:00',1.2),('12374','2013-02-20','08:15:00',1.17),('12374','2013-02-20','08:20:00',2.41),('12374','2013-02-20','08:25:00',2.43),('12374','2013-02-20','08:30:00',3.46),('12374','2013-02-20','08:35:00',3.76),('12374','2013-02-20','08:40:00',3.91),('12374','2013-02-20','08:45:00',4.05),('12374','2013-02-20','08:50:00',4.22),('12374','2013-02-20','08:55:00',4.37),('12374','2013-02-20','09:00:00',4.53),('12374','2013-02-20','09:05:00',4.13),('12374','2013-02-20','09:10:00',3.72),('12374','2013-02-20','09:15:00',4.36),('12374','2013-02-20','09:20:00',4.17),('12374','2013-02-20','09:25:00',4.67),('12374','2013-02-20','09:30:00',5.54),('12374','2013-02-20','09:35:00',5.72),('12374','2013-02-20','09:40:00',5.81),('12374','2013-02-20','09:45:00',6.04),('12374','2013-02-20','09:50:00',6.31),('12374','2013-02-20','09:55:00',5.88),('12374','2013-02-20','10:00:00',5.4),('12374','2013-02-20','10:05:00',3.17),('12374','2013-02-20','10:10:00',2.52),('12374','2013-02-20','10:15:00',2.95),('12374','2013-02-20','10:20:00',4),('12374','2013-02-20','10:25:00',5.19),('12374','2013-02-20','10:30:00',7.68),('12374','2013-02-20','10:35:00',5.99),('12374','2013-02-20','10:40:00',4.69),('12374','2013-02-20','10:45:00',7.45),('12374','2013-02-20','10:50:00',4.79),('12374','2013-02-20','10:55:00',7.43),('12374','2013-02-20','11:00:00',4.02),('12374','2013-02-20','11:05:00',6.47),('12374','2013-02-20','11:10:00',8.93),('12374','2013-02-20','11:15:00',9.17),('12374','2013-02-20','11:20:00',8.57),('12374','2013-02-20','11:25:00',2.59),('12374','2013-02-20','11:30:00',3.41),('12374','2013-02-20','11:35:00',4.84),('12374','2013-02-20','11:40:00',8.19),('12374','2013-02-20','11:45:00',8.26),('12374','2013-02-20','11:50:00',5.19),('12374','2013-02-20','11:55:00',5.94),('12374','2013-02-20','12:00:00',5.14),('12374','2013-02-20','12:05:00',5.06),('12374','2013-02-20','12:10:00',4.04),('12374','2013-02-20','12:15:00',8.62),('12374','2013-02-20','12:20:00',9.47),('12374','2013-02-20','12:25:00',5.41),('12374','2013-02-20','12:30:00',7.83),('12374','2013-02-20','12:35:00',7.01),('12374','2013-02-20','12:40:00',6.32),('12374','2013-02-20','12:45:00',9.11),('12374','2013-02-20','12:50:00',8.61),('12374','2013-02-20','12:55:00',8.34),('12374','2013-02-20','13:00:00',8.14),('12374','2013-02-20','13:05:00',8.34),('12374','2013-02-20','13:10:00',8.2),('12374','2013-02-20','13:15:00',8.03),('12374','2013-02-20','13:20:00',7.93),('12374','2013-02-20','13:25:00',7.18),('12374','2013-02-20','13:30:00',7.58),('12374','2013-02-20','13:35:00',7.81),('12374','2013-02-20','13:40:00',7.75),('12374','2013-02-20','13:45:00',7.32),('12374','2013-02-20','13:50:00',7.54),('12374','2013-02-20','13:55:00',7.33),('12374','2013-02-20','14:00:00',6.9),('12374','2013-02-20','14:05:00',7.17),('12374','2013-02-20','14:10:00',7.17),('12374','2013-02-20','14:15:00',7.17),('12374','2013-02-20','14:20:00',7.07),('12374','2013-02-20','14:25:00',6.77),('12374','2013-02-20','14:30:00',6.61),('12374','2013-02-20','14:35:00',6.4),('12374','2013-02-20','14:40:00',6.39),('12374','2013-02-20','14:45:00',5.85),('12374','2013-02-20','14:50:00',4.23),('12374','2013-02-20','14:55:00',5.09),('12374','2013-02-20','15:00:00',4.41),('12374','2013-02-20','15:05:00',3.73),('12374','2013-02-20','15:10:00',4.64),('12374','2013-02-20','15:15:00',5.23),('12374','2013-02-20','15:20:00',3.6),('12374','2013-02-20','15:25:00',3),('12374','2013-02-20','15:30:00',3.77),('12374','2013-02-20','15:35:00',3.89),('12374','2013-02-20','15:40:00',3.72),('12374','2013-02-20','15:45:00',3.98),('12374','2013-02-20','15:51:00',4.16),('12374','2013-02-20','15:55:00',3.54),('12374','2013-02-20','16:00:00',3.62),('12374','2013-02-20','16:05:00',3.51),('12374','2013-02-20','16:10:00',2.84),('12374','2013-02-20','16:15:00',3.47),('12374','2013-02-20','16:20:00',3),('12374','2013-02-20','16:25:00',1.95),('12374','2013-02-20','16:30:00',2.6),('12374','2013-02-20','16:35:00',2.85),('12374','2013-02-20','16:40:00',2.54),('12374','2013-02-20','16:45:00',2.39),('12374','2013-02-20','16:50:00',2.14),('12374','2013-02-20','16:55:00',1.52),('12374','2013-02-20','17:00:00',1.24),('12374','2013-02-19','07:35:00',1.08),('12374','2013-02-19','07:40:00',1.31),('12374','2013-02-19','07:45:00',1.73),('12374','2013-02-19','07:50:00',1.98),('12374','2013-02-19','07:55:00',2.19),('12374','2013-02-19','08:00:00',2.38),('12374','2013-02-19','08:05:00',2.48),('12374','2013-02-19','08:10:00',2.87),('12374','2013-02-19','08:15:00',3.08),('12374','2013-02-19','08:20:00',2.91),('12374','2013-02-19','08:25:00',3.14),('12374','2013-02-19','08:30:00',3.61),('12374','2013-02-19','08:35:00',3.81),('12374','2013-02-19','08:40:00',3.96),('12374','2013-02-19','08:45:00',4.12),('12374','2013-02-19','08:50:00',4.3),('12374','2013-02-19','08:55:00',4.41),('12374','2013-02-19','09:00:00',4.59),('12374','2013-02-19','09:05:00',4.77),('12374','2013-02-19','09:10:00',4.9),('12374','2013-02-19','09:15:00',5.05),('12374','2013-02-19','09:20:00',5.2),('12374','2013-02-19','09:25:00',5.37),('12374','2013-02-19','09:30:00',5.53),('12374','2013-02-19','09:35:00',5.69),('12374','2013-02-19','09:40:00',5.82),('12374','2013-02-19','09:45:00',5.99),('12374','2013-02-19','09:50:00',6.11),('12374','2013-02-19','09:55:00',6.3),('12374','2013-02-19','10:00:00',6.42),('12374','2013-02-19','10:05:00',6.57),('12374','2013-02-19','10:10:00',6.67),('12374','2013-02-19','10:15:00',6.78),('12374','2013-02-19','10:20:00',6.89),('12374','2013-02-19','10:25:00',7.01),('12374','2013-02-19','10:30:00',7.09),('12374','2013-02-19','10:35:00',7.2),('12374','2013-02-19','10:40:00',7.25),('12374','2013-02-19','10:45:00',7.36),('12374','2013-02-19','10:50:00',7.44),('12374','2013-02-19','10:55:00',7.48),('12374','2013-02-19','11:00:00',7.57),('12374','2013-02-19','11:05:00',7.6),('12374','2013-02-19','11:10:00',7.63),('12374','2013-02-19','11:15:00',7.67),('12374','2013-02-19','11:20:00',7.75),('12374','2013-02-19','11:25:00',7.78),('12374','2013-02-19','11:30:00',7.76),('12374','2013-02-19','11:35:00',7.82),('12374','2013-02-19','11:40:00',7.9),('12374','2013-02-19','11:45:00',7.88),('12374','2013-02-19','11:50:00',7.88),('12374','2013-02-19','11:55:00',7.89),('12374','2013-02-19','12:00:00',8.03),('12374','2013-02-19','12:05:00',8.09),('12374','2013-02-19','12:10:00',8.11),('12374','2013-02-19','12:15:00',8.11),('12374','2013-02-19','12:20:00',8.05),('12374','2013-02-19','12:25:00',8),('12374','2013-02-19','12:30:00',7.97),('12374','2013-02-19','12:35:00',8),('12374','2013-02-19','12:40:00',7.97),('12374','2013-02-19','12:45:00',7.92),('12374','2013-02-19','12:50:00',7.88),('12374','2013-02-19','12:55:00',7.91),('12374','2013-02-19','13:00:00',7.85),('12374','2013-02-19','13:05:00',7.78),('12374','2013-02-19','13:10:00',7.8),('12374','2013-02-19','13:15:00',7.73),('12374','2013-02-19','13:20:00',7.67),('12374','2013-02-19','13:25:00',7.65),('12374','2013-02-19','13:30:00',7.55),('12374','2013-02-19','13:35:00',7.51),('12374','2013-02-19','13:40:00',7.39),('12374','2013-02-19','13:45:00',7.31),('12374','2013-02-19','13:50:00',7.27),('12374','2013-02-19','13:55:00',7.21),('12374','2013-02-19','14:00:00',7.14),('12374','2013-02-19','14:05:00',6.99),('12374','2013-02-19','14:10:00',6.94),('12374','2013-02-19','14:15:00',6.8),('12374','2013-02-19','14:20:00',6.7),('12374','2013-02-19','14:25:00',6.58),('12374','2013-02-19','14:30:00',6.42),('12374','2013-02-19','14:35:00',6.32),('12374','2013-02-19','14:40:00',6.16),('12374','2013-02-19','14:45:00',6.02),('12374','2013-02-19','14:50:00',5.89),('12374','2013-02-19','14:55:00',5.76),('12374','2013-02-19','15:00:00',5.56),('12374','2013-02-19','15:05:00',5.44),('12374','2013-02-19','15:10:00',5.32),('12374','2013-02-19','15:15:00',5.16),('12374','2013-02-19','15:20:00',5.01),('12374','2013-02-19','15:25:00',4.83),('12374','2013-02-19','15:30:00',4.68),('12374','2013-02-19','15:35:00',4.53),('12374','2013-02-19','15:40:00',4.38),('12374','2013-02-19','15:45:00',4.21),('12374','2013-02-19','15:50:00',4.03),('12374','2013-02-19','15:55:00',3.87),('12374','2013-02-19','16:00:00',3.67),('12374','2013-02-19','16:05:00',3.43),('12374','2013-02-19','16:10:00',3.29),('12374','2013-02-19','16:15:00',3.09),('12374','2013-02-19','16:20:00',2.82),('12374','2013-02-19','16:25:00',2.51),('12374','2013-02-19','16:30:00',2.48),('12374','2013-02-19','16:35:00',2.3),('12374','2013-02-19','16:40:00',2.07),('12374','2013-02-19','16:45:00',1.81),('12374','2013-02-19','16:50:00',1.59),('12374','2013-02-19','16:55:00',1.37),('12374','2013-02-19','17:00:00',1.11),('12374','2013-02-18','08:05:00',1.5),('12374','2013-02-18','08:10:00',2.61),('12374','2013-02-18','08:15:00',2.42),('12374','2013-02-18','08:20:00',2.78),('12374','2013-02-18','08:25:00',3.04),('12374','2013-02-18','08:30:00',3.27),('12374','2013-02-18','08:35:00',3.61),('12374','2013-02-18','08:40:00',3.29),('12374','2013-02-18','08:45:00',3.98),('12374','2013-02-18','08:50:00',3.92),('12374','2013-02-18','08:55:00',4.44),('12374','2013-02-18','09:00:00',4.56),('12374','2013-02-18','09:05:00',4.66),('12374','2013-02-18','09:10:00',2.34),('12374','2013-02-18','09:15:00',2.39),('12374','2013-02-18','09:20:00',1.88),('12374','2013-02-18','09:25:00',3.86),('12374','2013-02-18','09:30:00',3.35),('12374','2013-02-18','09:35:00',6.1),('12374','2013-02-18','09:40:00',4.42),('12374','2013-02-18','09:45:00',5.63),('12374','2013-02-18','09:50:00',4.86),('12374','2013-02-18','09:55:00',3.25),('12374','2013-02-18','10:00:00',2.13),('12374','2013-02-18','10:05:00',4.35),('12374','2013-02-18','10:10:00',7.36),('12374','2013-02-18','10:15:00',6.49),('12374','2013-02-18','10:20:00',6.73),('12374','2013-02-18','10:25:00',6.3),('12374','2013-02-18','10:30:00',6.62),('12374','2013-02-18','10:35:00',7.04),('12374','2013-02-18','10:40:00',7.41),('12374','2013-02-18','10:45:00',7.76),('12374','2013-02-18','10:50:00',7.08),('12374','2013-02-18','10:55:00',5.37),('12374','2013-02-18','11:00:00',4.71),('12374','2013-02-18','11:05:00',5.39),('12374','2013-02-18','11:10:00',4.58),('12374','2013-02-18','11:15:00',6.69),('12374','2013-02-18','11:20:00',6.85),('12374','2013-02-18','11:25:00',7.03),('12374','2013-02-18','11:30:00',7.79),('12374','2013-02-18','11:35:00',3.61),('12374','2013-02-18','11:40:00',3.45),('12374','2013-02-18','11:45:00',3.31),('12374','2013-02-18','11:50:00',3.63),('12374','2013-02-18','11:55:00',3.38),('12374','2013-02-18','12:00:00',3.04),('12374','2013-02-18','12:05:00',3.4),('12374','2013-02-18','12:10:00',3.9),('12374','2013-02-18','12:15:00',3.8),('12374','2013-02-18','12:20:00',4.39),('12374','2013-02-18','12:25:00',4.83),('12374','2013-02-18','12:30:00',4.84),('12374','2013-02-18','12:35:00',4.8),('12374','2013-02-18','12:40:00',4.71),('12374','2013-02-18','12:45:00',5),('12374','2013-02-18','12:50:00',4.47),('12374','2013-02-18','12:55:00',4.23),('12374','2013-02-18','13:00:00',3.53),('12374','2013-02-18','13:05:00',3.44),('12374','2013-02-18','13:10:00',3.43),('12374','2013-02-18','13:15:00',3.14),('12374','2013-02-18','13:20:00',3.13),('12374','2013-02-18','13:25:00',3.64),('12374','2013-02-18','13:30:00',3.57),('12374','2013-02-18','13:35:00',3.72),('12374','2013-02-18','13:40:00',3.94),('12374','2013-02-18','13:45:00',3.16),('12374','2013-02-18','13:50:00',2.57),('12374','2013-02-18','13:55:00',2.33),('12374','2013-02-18','14:00:00',2.5),('12374','2013-02-18','14:05:00',2.87),('12374','2013-02-18','14:10:00',3.77),('12374','2013-02-18','14:15:00',3.37),('12374','2013-02-18','14:20:00',3.52),('12374','2013-02-18','14:25:00',3.8),('12374','2013-02-18','14:30:00',2.44),('12374','2013-02-18','14:35:00',2.25),('12374','2013-02-18','14:40:00',2.58),('12374','2013-02-18','14:45:00',3.24),('12374','2013-02-18','14:50:00',3.63),('12374','2013-02-18','14:55:00',5.92),('12374','2013-02-18','15:00:00',2.63),('12374','2013-02-18','15:05:00',1.86),('12374','2013-02-18','15:10:00',1.57),('12374','2013-02-18','15:15:00',1.27),('12374','2013-02-18','15:20:00',1.37),('12374','2013-02-18','15:25:00',1.15),('12374','2013-02-18','15:50:00',1.04),('12374','2013-02-17','07:45:00',1.19),('12374','2013-02-17','07:50:00',1.49),('12374','2013-02-17','07:55:00',1.74),('12374','2013-02-17','08:00:00',1.89),('12374','2013-02-17','08:05:00',2.05),('12374','2013-02-17','08:10:00',2.35),('12374','2013-02-17','08:15:00',2.6),('12374','2013-02-17','08:20:00',2.2),('12374','2013-02-17','08:25:00',2.47),('12374','2013-02-17','08:30:00',2.31),('12374','2013-02-17','08:35:00',3.17),('12374','2013-02-17','08:40:00',3.56),('12374','2013-02-17','08:45:00',3.72),('12374','2013-02-17','08:50:00',3.86),('12374','2013-02-17','08:55:00',3.92),('12374','2013-02-17','09:00:00',4.09),('12374','2013-02-17','09:05:00',3.2),('12374','2013-02-17','09:10:00',4.23),('12374','2013-02-17','09:15:00',4.67),('12374','2013-02-17','09:20:00',4.81),('12374','2013-02-17','09:25:00',4.96),('12374','2013-02-17','09:30:00',5.11),('12374','2013-02-17','09:35:00',5.3),('12374','2013-02-17','09:40:00',5.47),('12374','2013-02-17','09:45:00',5.65),('12374','2013-02-17','09:50:00',5.83),('12374','2013-02-17','09:55:00',5.99),('12374','2013-02-17','10:00:00',6.08),('12374','2013-02-17','10:05:00',6.23),('12374','2013-02-17','10:10:00',6.4),('12374','2013-02-17','10:15:00',6.51),('12374','2013-02-17','10:20:00',6.56),('12374','2013-02-17','10:25:00',6.68),('12374','2013-02-17','10:30:00',6.83),('12374','2013-02-17','10:35:00',6.92),('12374','2013-02-17','10:40:00',7),('12374','2013-02-17','10:45:00',7.11),('12374','2013-02-17','10:50:00',7.17),('12374','2013-02-17','10:55:00',7.2),('12374','2013-02-17','11:00:00',7.33),('12374','2013-02-17','11:05:00',7.4),('12374','2013-02-17','11:10:00',7.41),('12374','2013-02-17','11:15:00',7.5),('12374','2013-02-17','11:20:00',7.56),('12374','2013-02-17','11:25:00',7.6),('12374','2013-02-17','11:30:00',7.66),('12374','2013-02-17','11:35:00',7.69),('12374','2013-02-17','11:40:00',7.75),('12374','2013-02-17','11:45:00',7.82),('12374','2013-02-17','11:50:00',7.76),('12374','2013-02-17','11:55:00',8.08),('12374','2013-02-17','12:00:00',8.46),('12374','2013-02-17','12:05:00',8.05),('12374','2013-02-17','12:10:00',8.01),('12374','2013-02-17','12:15:00',7.99),('12374','2013-02-17','12:20:00',8.19),('12374','2013-02-17','12:25:00',8.07),('12374','2013-02-17','12:30:00',8.05),('12374','2013-02-17','12:35:00',8.3),('12374','2013-02-17','12:40:00',7.72),('12374','2013-02-17','12:45:00',4.82),('12374','2013-02-17','12:50:00',6.44),('12374','2013-02-17','12:55:00',7.55),('12374','2013-02-17','13:00:00',7.79),('12374','2013-02-17','13:05:00',7.71),('12374','2013-02-17','13:10:00',7.59),('12374','2013-02-17','13:15:00',7.17),('12374','2013-02-17','13:20:00',7.57),('12374','2013-02-17','13:25:00',7.93),('12374','2013-02-17','13:30:00',8.37),('12374','2013-02-17','13:35:00',7.99),('12374','2013-02-17','13:40:00',8.32),('12374','2013-02-17','13:45:00',7.87),('12374','2013-02-17','13:50:00',4.23),('12374','2013-02-17','13:55:00',3.35),('12374','2013-02-17','14:00:00',3.07),('12374','2013-02-17','14:05:00',3.71),('12374','2013-02-17','14:10:00',4.72),('12374','2013-02-17','14:15:00',4.13),('12374','2013-02-17','14:20:00',6.58),('12374','2013-02-17','14:25:00',5.64),('12374','2013-02-17','14:30:00',5.37),('12374','2013-02-17','14:35:00',5.32),('12374','2013-02-17','14:40:00',4.96),('12374','2013-02-17','14:45:00',5.83),('12374','2013-02-17','14:50:00',4.7),('12374','2013-02-17','14:55:00',4.8),('12374','2013-02-17','15:00:00',5.55),('12374','2013-02-17','15:05:00',5.42),('12374','2013-02-17','15:10:00',5.44),('12374','2013-02-17','15:15:00',2.63),('12374','2013-02-17','15:20:00',1.8),('12374','2013-02-17','15:25:00',1.88),('12374','2013-02-17','15:30:00',2.12),('12374','2013-02-17','15:35:00',1.89),('12374','2013-02-17','15:40:00',1.73),('12374','2013-02-17','15:45:00',1.63),('12374','2013-02-17','15:50:00',1.37),('12374','2013-02-17','15:55:00',1.06),('12374','2013-02-16','08:05:00',1.05),('12374','2013-02-16','08:10:00',1.25),('12374','2013-02-16','08:15:00',1.73),('12374','2013-02-16','08:20:00',1.83),('12374','2013-02-16','08:25:00',1.84),('12374','2013-02-16','08:30:00',1.62),('12374','2013-02-16','08:35:00',1.68),('12374','2013-02-16','08:40:00',1.68),('12374','2013-02-16','08:45:00',1.6),('12374','2013-02-16','08:50:00',1.8),('12374','2013-02-16','08:55:00',3.34),('12374','2013-02-16','09:00:00',2.52),('12374','2013-02-16','09:05:00',4.05),('12374','2013-02-16','09:10:00',4.5),('12374','2013-02-16','09:15:00',5.04),('12374','2013-02-16','09:20:00',4.97),('12374','2013-02-16','09:25:00',5.19),('12374','2013-02-16','09:30:00',5.19),('12374','2013-02-16','09:35:00',5.29),('12374','2013-02-16','09:40:00',5.51),('12374','2013-02-16','09:45:00',5.67),('12374','2013-02-16','09:50:00',5.86),('12374','2013-02-16','09:55:00',6.04),('12374','2013-02-16','10:00:00',6.13),('12374','2013-02-16','10:05:00',6.41),('12374','2013-02-16','10:10:00',6.22),('12374','2013-02-16','10:15:00',6.21),('12374','2013-02-16','10:20:00',6.82),('12374','2013-02-16','10:25:00',6.31),('12374','2013-02-16','10:30:00',5.45),('12374','2013-02-16','10:35:00',5.77),('12374','2013-02-16','10:40:00',7.1),('12374','2013-02-16','10:45:00',6.16),('12374','2013-02-16','10:50:00',7.34),('12374','2013-02-16','10:55:00',7.28),('12374','2013-02-16','11:00:00',7.44),('12374','2013-02-16','11:05:00',7.48),('12374','2013-02-16','11:10:00',7.35),('12374','2013-02-16','11:15:00',7.94),('12374','2013-02-16','11:20:00',7.3),('12374','2013-02-16','11:25:00',7.34),('12374','2013-02-16','11:30:00',8.11),('12374','2013-02-16','11:35:00',8.33),('12374','2013-02-16','11:40:00',8.26),('12374','2013-02-16','11:45:00',8.14),('12374','2013-02-16','11:50:00',8.31),('12374','2013-02-16','11:55:00',8.4),('12374','2013-02-16','12:00:00',8.66),('12374','2013-02-16','12:05:00',9.04),('12374','2013-02-16','12:10:00',6.87),('12374','2013-02-16','12:15:00',8.24),('12374','2013-02-16','12:20:00',8.67),('12374','2013-02-16','12:25:00',4.67),('12374','2013-02-16','12:30:00',8.11),('12374','2013-02-16','12:35:00',5.27),('12374','2013-02-16','12:40:00',4.04),('12374','2013-02-16','12:45:00',3.13),('12374','2013-02-16','12:50:00',3.38),('12374','2013-02-16','12:55:00',3.76),('12374','2013-02-16','13:00:00',5.17),('12374','2013-02-16','13:05:00',5.13),('12374','2013-02-16','13:10:00',4.27),('12374','2013-02-16','13:15:00',7.11),('12374','2013-02-16','13:20:00',8.94),('12374','2013-02-16','13:25:00',8.57),('12374','2013-02-16','13:30:00',8.38),('12374','2013-02-16','13:35:00',7.46),('12374','2013-02-16','13:40:00',8.37),('12374','2013-02-16','13:45:00',7.39),('12374','2013-02-16','13:50:00',6.95),('12374','2013-02-16','13:55:00',4.04),('12374','2013-02-16','14:00:00',2.62),('12374','2013-02-16','14:05:00',2.58),('12374','2013-02-16','14:10:00',2.43),('12374','2013-02-16','14:15:00',2.32),('12374','2013-02-16','14:20:00',2.27),('12374','2013-02-16','14:25:00',2.25),('12374','2013-02-16','14:30:00',2.1),('12374','2013-02-16','14:35:00',1.98),('12374','2013-02-16','14:40:00',1.95),('12374','2013-02-16','14:45:00',1.98),('12374','2013-02-16','14:50:00',1.98),('12374','2013-02-16','14:55:00',1.94),('12374','2013-02-16','15:00:00',1.94),('12374','2013-02-16','15:05:00',1.83),('12374','2013-02-16','15:10:00',1.77),('12374','2013-02-16','15:15:00',1.77),('12374','2013-02-16','15:20:00',1.71),('12374','2013-02-16','15:25:00',1.69),('12374','2013-02-16','15:30:00',1.96),('12374','2013-02-16','15:35:00',2.22),('12374','2013-02-16','15:40:00',2),('12374','2013-02-16','15:45:00',1.88),('12374','2013-02-16','15:50:00',2.4),('12374','2013-02-16','15:55:00',2.19),('12374','2013-02-16','16:00:00',1.64),('12374','2013-02-16','16:05:00',1.3),('12374','2013-02-15','07:40:00',1.01),('12374','2013-02-15','08:00:00',1.33),('12374','2013-02-15','08:40:00',1.14),('12374','2013-02-15','08:45:00',1.29),('12374','2013-02-15','08:50:00',1.75),('12374','2013-02-15','08:55:00',2.5),('12374','2013-02-15','09:00:00',4.38),('12374','2013-02-15','09:05:00',5.13),('12374','2013-02-15','09:10:00',4.01),('12374','2013-02-15','09:15:00',2.79),('12374','2013-02-15','09:20:00',4.66),('12374','2013-02-15','09:25:00',4.47),('12374','2013-02-15','09:30:00',5.71),('12374','2013-02-15','09:35:00',3.01),('12374','2013-02-15','09:40:00',4.01),('12374','2013-02-15','09:45:00',4.12),('12374','2013-02-15','09:50:00',3.87),('12374','2013-02-15','09:55:00',4.65),('12374','2013-02-15','10:00:00',3.97),('12374','2013-02-15','10:05:00',4.98),('12374','2013-02-15','10:10:00',5.41),('12374','2013-02-15','10:15:00',4.77),('12374','2013-02-15','10:20:00',5.41),('12374','2013-02-15','10:25:00',4.64),('12374','2013-02-15','10:30:00',2.81),('12374','2013-02-15','10:35:00',6.24),('12374','2013-02-15','10:50:00',6.98),('12374','2013-02-15','10:55:00',7.64),('12374','2013-02-15','11:00:00',8.06),('12374','2013-02-15','11:05:00',6.72),('12374','2013-02-15','11:10:00',4.31),('12374','2013-02-15','11:15:00',6.36),('12374','2013-02-15','11:20:00',5.86),('12374','2013-02-15','11:25:00',7.37),('12374','2013-02-15','11:30:00',5.43),('12374','2013-02-15','11:35:00',7.8),('12374','2013-02-15','11:40:00',5.17),('12374','2013-02-15','11:45:00',6.2),('12374','2013-02-15','11:50:00',5.73),('12374','2013-02-15','11:55:00',6.87),('12374','2013-02-15','12:00:00',6.96),('12374','2013-02-15','12:05:00',7.48),('12374','2013-02-15','12:10:00',5),('12374','2013-02-15','12:15:00',5.41),('12374','2013-02-15','12:20:00',7.77),('12374','2013-02-15','12:25:00',7.55),('12374','2013-02-15','12:30:00',6.51),('12374','2013-02-15','12:35:00',7.9),('12374','2013-02-15','12:40:00',8.22),('12374','2013-02-15','12:45:00',5.9),('12374','2013-02-15','12:50:00',6.61),('12374','2013-02-15','12:55:00',5.61),('12374','2013-02-15','13:00:00',8.35),('12374','2013-02-15','13:05:00',8.43),('12374','2013-02-15','13:10:00',5.94),('12374','2013-02-15','13:15:00',5.65),('12374','2013-02-15','13:20:00',4.39),('12374','2013-02-15','13:25:00',5.06),('12374','2013-02-15','13:30:00',8.32),('12374','2013-02-15','13:35:00',8),('12374','2013-02-15','13:40:00',6.77),('12374','2013-02-15','13:45:00',6.62),('12374','2013-02-15','13:50:00',7.4),('12374','2013-02-15','13:55:00',7.69),('12374','2013-02-15','14:00:00',6.56),('12374','2013-02-15','14:05:00',5.87),('12374','2013-02-15','14:10:00',6.21),('12374','2013-02-15','14:15:00',7.41),('12374','2013-02-15','14:20:00',7.37),('12374','2013-02-15','14:25:00',6.34),('12374','2013-02-15','14:30:00',5.27),('12374','2013-02-15','14:35:00',5.31),('12374','2013-02-15','14:40:00',3.94),('12374','2013-02-15','14:45:00',3.91),('12374','2013-02-15','14:50:00',5.35),('12374','2013-02-15','14:55:00',5.04),('12374','2013-02-15','15:00:00',3.96),('12374','2013-02-15','15:05:00',3.01),('12374','2013-02-15','15:10:00',2.42),('12374','2013-02-15','15:15:00',2.53),('12374','2013-02-15','15:20:00',2.89),('12374','2013-02-15','15:25:00',2.5),('12374','2013-02-15','15:30:00',2.24),('12374','2013-02-15','15:35:00',2.05),('12374','2013-02-15','15:40:00',1.94),('12374','2013-02-15','15:45:00',1.89),('12374','2013-02-15','15:50:00',2.08),('12374','2013-02-15','15:55:00',2.36),('12374','2013-02-15','16:00:00',2.31),('12374','2013-02-15','16:05:00',2.12),('12374','2013-02-15','16:10:00',1.85),('12374','2013-02-15','16:15:00',2.32),('12374','2013-02-15','16:20:00',2.54),('12374','2013-02-15','16:25:00',2.15),('12374','2013-02-15','16:30:00',1.72),('12374','2013-02-15','16:35:00',1.26),('12374','2013-02-14','07:40:00',1),('12374','2013-02-14','07:45:00',1.21),('12374','2013-02-14','07:50:00',1.59),('12374','2013-02-14','07:55:00',2.02),('12374','2013-02-14','08:00:00',2.29),('12374','2013-02-14','08:05:00',2.32),('12374','2013-02-14','08:10:00',2.4),('12374','2013-02-14','08:15:00',2.66),('12374','2013-02-14','08:20:00',3.03),('12374','2013-02-14','08:25:00',3.2),('12374','2013-02-14','08:30:00',2.91),('12374','2013-02-14','08:35:00',3.03),('12374','2013-02-14','08:40:00',3.41),('12374','2013-02-14','08:45:00',3.44),('12374','2013-02-14','08:50:00',3.62),('12374','2013-02-14','08:55:00',3.53),('12374','2013-02-14','09:00:00',4),('12374','2013-02-14','09:05:00',4.59),('12374','2013-02-14','09:10:00',4.68),('12374','2013-02-14','09:15:00',4.84),('12374','2013-02-14','09:20:00',4.92),('12374','2013-02-14','09:25:00',4.94),('12374','2013-02-14','09:30:00',5.17),('12374','2013-02-14','09:35:00',5.51),('12374','2013-02-14','09:40:00',5.7),('12374','2013-02-14','09:45:00',5.83),('12374','2013-02-14','09:50:00',5.99),('12374','2013-02-14','09:55:00',6.14),('12374','2013-02-14','10:00:00',6.29),('12374','2013-02-14','10:05:00',6.39),('12374','2013-02-14','10:10:00',6.57),('12374','2013-02-14','10:15:00',6.68),('12374','2013-02-14','10:20:00',6.8),('12374','2013-02-14','10:25:00',6.91),('12374','2013-02-14','10:30:00',7.01),('12374','2013-02-14','10:35:00',7.1),('12374','2013-02-14','10:40:00',7.21),('12374','2013-02-14','10:45:00',7.31),('12374','2013-02-14','10:50:00',7.39),('12374','2013-02-14','10:55:00',7.46),('12374','2013-02-14','11:00:00',7.56),('12374','2013-02-14','11:05:00',7.56),('12374','2013-02-14','11:10:00',7.61),('12374','2013-02-14','11:15:00',7.68),('12374','2013-02-14','11:20:00',7.75),('12374','2013-02-14','11:25:00',7.82),('12374','2013-02-14','11:30:00',7.89),('12374','2013-02-14','11:35:00',7.91),('12374','2013-02-14','11:40:00',7.92),('12374','2013-02-14','11:45:00',7.95),('12374','2013-02-14','11:50:00',7.9),('12374','2013-02-14','11:55:00',7.92),('12374','2013-02-14','12:00:00',7.95),('12374','2013-02-14','12:05:00',8.03),('12374','2013-02-14','12:10:00',8.01),('12374','2013-02-14','12:15:00',8.04),('12374','2013-02-14','12:20:00',8.03),('12374','2013-02-14','12:25:00',8.01),('12374','2013-02-14','12:30:00',7.94),('12374','2013-02-14','12:35:00',7.93),('12374','2013-02-14','12:40:00',7.91),('12374','2013-02-14','12:45:00',7.91),('12374','2013-02-14','12:50:00',7.88),('12374','2013-02-14','12:55:00',7.85),('12374','2013-02-14','13:00:00',7.8),('12374','2013-02-14','13:05:00',7.76),('12374','2013-02-14','13:10:00',7.66),('12374','2013-02-14','13:15:00',7.62),('12374','2013-02-14','13:20:00',7.52),('12374','2013-02-14','13:25:00',7.47),('12374','2013-02-14','13:30:00',7.39),('12374','2013-02-14','13:35:00',7.31),('12374','2013-02-14','13:40:00',7.22),('12374','2013-02-14','13:45:00',7.11),('12374','2013-02-14','13:50:00',7.04),('12374','2013-02-14','13:55:00',6.93),('12374','2013-02-14','14:00:00',6.81),('12374','2013-02-14','14:05:00',6.72),('12374','2013-02-14','14:10:00',6.62),('12374','2013-02-14','14:15:00',6.5),('12374','2013-02-14','14:20:00',6.37),('12374','2013-02-14','14:25:00',6.24),('12374','2013-02-14','14:30:00',6.14),('12374','2013-02-14','14:35:00',5.91),('12374','2013-02-14','14:40:00',5.85),('12374','2013-02-14','14:45:00',5.72),('12374','2013-02-14','14:50:00',5.55),('12374','2013-02-14','14:55:00',5.38),('12374','2013-02-14','15:00:00',5.22),('12374','2013-02-14','15:05:00',5.06),('12374','2013-02-14','15:10:00',4.93),('12374','2013-02-14','15:15:00',4.79),('12374','2013-02-14','15:20:00',4.66),('12374','2013-02-14','15:25:00',4.46),('12374','2013-02-14','15:30:00',4.29),('12374','2013-02-14','15:35:00',4.17),('12374','2013-02-14','15:40:00',4.04),('12374','2013-02-14','15:45:00',3.86),('12374','2013-02-14','15:50:00',3.68),('12374','2013-02-14','15:55:00',3.49),('12374','2013-02-14','16:00:00',3.32),('12374','2013-02-14','16:05:00',3.17),('12374','2013-02-14','16:10:00',2.97),('12374','2013-02-14','16:15:00',2.78),('12374','2013-02-14','16:20:00',2.5),('12374','2013-02-14','16:25:00',2.37),('12374','2013-02-14','16:30:00',2.15),('12374','2013-02-14','16:35:00',1.98),('12374','2013-02-14','16:40:00',1.78),('12374','2013-02-14','16:45:00',1.71),('12374','2013-02-14','16:50:00',1.53),('12374','2013-02-14','16:55:00',1.2),('12374','2013-02-13','08:15:00',1.03),('12374','2013-02-13','08:20:00',1.17),('12374','2013-02-13','08:25:00',1.35),('12374','2013-02-13','08:30:00',1.52),('12374','2013-02-13','08:35:00',1.62),('12374','2013-02-13','08:40:00',2.17),('12374','2013-02-13','08:45:00',2.5),('12374','2013-02-13','08:50:00',2.57),('12374','2013-02-13','08:55:00',2.06),('12374','2013-02-13','09:00:00',1.86),('12374','2013-02-13','09:05:00',2.03),('12374','2013-02-13','09:10:00',2.22),('12374','2013-02-13','09:15:00',3.12),('12374','2013-02-13','09:20:00',2.8),('12374','2013-02-13','09:25:00',2.53),('12374','2013-02-13','09:30:00',3.68),('12374','2013-02-13','09:35:00',4.84),('12374','2013-02-13','09:40:00',4.87),('12374','2013-02-13','09:45:00',5.49),('12374','2013-02-13','09:50:00',5.41),('12374','2013-02-13','09:55:00',5.84),('12374','2013-02-13','10:00:00',6.16),('12374','2013-02-13','10:05:00',6.65),('12374','2013-02-13','10:10:00',6.9),('12374','2013-02-13','10:15:00',7.08),('12374','2013-02-13','10:20:00',6.53),('12374','2013-02-13','10:25:00',6.03),('12374','2013-02-13','10:30:00',6.34),('12374','2013-02-13','10:35:00',7.15),('12374','2013-02-13','10:40:00',7.34),('12374','2013-02-13','10:45:00',7.19),('12374','2013-02-13','10:50:00',7.39),('12374','2013-02-13','10:55:00',7.36),('12374','2013-02-13','11:00:00',7.64),('12374','2013-02-13','11:05:00',7.46),('12374','2013-02-13','11:10:00',7.82),('12374','2013-02-13','11:15:00',7.87),('12374','2013-02-13','11:20:00',7.35),('12374','2013-02-13','11:25:00',7.1),('12374','2013-02-13','11:30:00',7.04),('12374','2013-02-13','11:35:00',7.79),('12374','2013-02-13','11:40:00',7.09),('12374','2013-02-13','11:45:00',7.77),('12374','2013-02-13','11:50:00',7.78),('12374','2013-02-13','11:55:00',6.73),('12374','2013-02-13','12:00:00',7.43),('12374','2013-02-13','12:05:00',3.24),('12374','2013-02-13','12:10:00',3.03),('12374','2013-02-13','12:15:00',2.9),('12374','2013-02-13','12:20:00',4.32),('12374','2013-02-13','12:25:00',7.31),('12374','2013-02-13','12:30:00',7.56),('12374','2013-02-13','12:35:00',8.05),('12374','2013-02-13','12:40:00',8.15),('12374','2013-02-13','12:45:00',7.79),('12374','2013-02-13','12:50:00',7.91),('12374','2013-02-13','12:55:00',7.89),('12374','2013-02-13','13:00:00',7.68),('12374','2013-02-13','13:05:00',7.08),('12374','2013-02-13','13:10:00',7.09),('12374','2013-02-13','13:15:00',7.13),('12374','2013-02-13','13:20:00',7),('12374','2013-02-13','13:25:00',5.8),('12374','2013-02-13','13:30:00',4.96),('12374','2013-02-13','13:35:00',5.89),('12374','2013-02-13','13:40:00',7.01),('12374','2013-02-13','13:45:00',7.56),('12374','2013-02-13','13:50:00',7.13),('12374','2013-02-13','13:55:00',6.75),('12374','2013-02-13','14:00:00',7.15),('12374','2013-02-13','14:05:00',7.07),('12374','2013-02-13','14:10:00',6.35),('12374','2013-02-13','14:15:00',5.62),('12374','2013-02-13','14:20:00',5.45),('12374','2013-02-13','14:25:00',5.16),('12374','2013-02-13','14:30:00',5.06),('12374','2013-02-13','14:35:00',5.11),('12374','2013-02-13','14:40:00',5.53),('12374','2013-02-13','14:45:00',5.72),('12374','2013-02-13','14:50:00',5.99),('12374','2013-02-13','14:55:00',5.71),('12374','2013-02-13','15:00:00',5.45),('12374','2013-02-13','15:05:00',4.69),('12374','2013-02-13','15:10:00',4.86),('12374','2013-02-13','15:15:00',4.96),('12374','2013-02-13','15:20:00',4.81),('12374','2013-02-13','15:25:00',4.5),('12374','2013-02-13','15:30:00',3.83),('12374','2013-02-13','15:35:00',3.97),('12374','2013-02-13','15:40:00',3.7),('12374','2013-02-13','15:45:00',3.98),('12374','2013-02-13','15:50:00',3.87),('12374','2013-02-13','15:55:00',3.64),('12374','2013-02-13','16:00:00',3.44),('12374','2013-02-13','16:05:00',3.31),('12374','2013-02-13','16:10:00',3.19),('12374','2013-02-13','16:15:00',3),('12374','2013-02-13','16:20:00',2.6),('12374','2013-02-13','16:25:00',2.59),('12374','2013-02-13','16:30:00',2.42),('12374','2013-02-13','16:35:00',2.23),('12374','2013-02-13','16:40:00',2.03),('12374','2013-02-13','16:45:00',1.83),('12374','2013-02-13','16:50:00',1.61),('12374','2013-02-13','16:55:00',1.27),('12374','2013-02-12','10:40:00',1.02),('12374','2013-02-12','11:20:00',1.04),('12374','2013-02-12','11:25:00',1.13),('12374','2013-02-12','11:30:00',1.23),('12374','2013-02-12','11:35:00',1.26),('12374','2013-02-12','11:40:00',1.17),('12374','2013-02-12','11:45:00',1.05),('12374','2013-02-12','11:50:00',1.04),('12374','2013-02-12','11:55:00',1.03),('12374','2013-02-12','12:00:00',1),('12374','2013-02-12','12:05:00',1.01),('12374','2013-02-12','12:10:00',1.03),('12374','2013-02-12','12:15:00',1),('12374','2013-02-12','12:20:00',1.09),('12374','2013-02-12','12:25:00',1.15),('12374','2013-02-12','12:30:00',1.15),('12374','2013-02-12','12:35:00',1.15),('12374','2013-02-12','12:40:00',1.09),('12374','2013-02-12','13:40:00',1.08),('12374','2013-02-12','13:45:00',1.16),('12374','2013-02-12','13:50:00',1.26),('12374','2013-02-12','13:55:00',1.31),('12374','2013-02-12','14:00:00',1.25),('12374','2013-02-12','14:05:00',1.2),('12374','2013-02-12','14:10:00',1.16),('12374','2013-02-12','14:15:00',1.08),('12374','2013-02-12','14:20:00',1.09),('12374','2013-02-12','14:25:00',1.02),('12374','2013-02-12','15:10:00',1.12),('12374','2013-02-12','15:15:00',1.08),('12374','2013-02-11','08:55:00',1.01),('12374','2013-02-11','09:00:00',1.2),('12374','2013-02-11','09:05:00',1.2),('12374','2013-02-11','09:10:00',1.25),('12374','2013-02-11','09:15:00',1.39),('12374','2013-02-11','09:20:00',1.31),('12374','2013-02-11','09:25:00',1.35),('12374','2013-02-11','09:30:00',1.73),('12374','2013-02-11','09:35:00',2.11),('12374','2013-02-11','09:40:00',2.48),('12374','2013-02-11','09:45:00',2.63),('12374','2013-02-11','09:50:00',2.12),('12374','2013-02-11','09:55:00',1.92),('12374','2013-02-11','10:00:00',2.26),('12374','2013-02-11','10:05:00',2.19),('12374','2013-02-11','10:10:00',1.71),('12374','2013-02-11','10:15:00',1.8),('12374','2013-02-11','10:20:00',1.64),('12374','2013-02-11','11:50:00',1.29),('12374','2013-02-11','11:55:00',1.34),('12374','2013-02-11','12:45:00',1.37),('12374','2013-02-11','13:45:00',1.49),('12374','2013-02-11','14:00:00',1.17),('12374','2013-02-11','14:05:00',1.43),('12374','2013-02-11','14:10:00',1.61),('12374','2013-02-11','14:15:00',1.31),('12374','2013-02-11','14:20:00',1.15),('12374','2013-02-11','14:25:00',1.2),('12374','2013-02-11','14:35:00',1.03),('12374','2013-02-11','15:55:00',1.12),('12374','2013-02-10','08:45:00',1.07),('12374','2013-02-10','08:50:00',1.55),('12374','2013-02-10','08:55:00',1.78),('12374','2013-02-10','09:00:00',3.2),('12374','2013-02-10','09:05:00',4.27),('12374','2013-02-10','09:10:00',4.62),('12374','2013-02-10','09:15:00',4.91),('12374','2013-02-10','09:20:00',3.12),('12374','2013-02-10','09:25:00',4.49),('12374','2013-02-10','09:30:00',5.3),('12374','2013-02-10','09:35:00',5.44),('12374','2013-02-10','09:40:00',5.56),('12374','2013-02-10','09:45:00',5.68),('12374','2013-02-10','09:50:00',5.86),('12374','2013-02-10','09:55:00',6.14),('12374','2013-02-10','10:00:00',6.51),('12374','2013-02-10','10:05:00',6.83),('12374','2013-02-10','10:10:00',6.3),('12374','2013-02-10','10:15:00',6.88),('12374','2013-02-10','10:20:00',6.81),('12374','2013-02-10','10:25:00',6.84),('12374','2013-02-10','10:30:00',6.95),('12374','2013-02-10','10:35:00',7),('12374','2013-02-10','10:40:00',7.14),('12374','2013-02-10','10:45:00',7.16),('12374','2013-02-10','10:50:00',7.18),('12374','2013-02-10','10:55:00',7.33),('12374','2013-02-10','11:00:00',7.12),('12374','2013-02-10','11:05:00',6.89),('12374','2013-02-10','11:10:00',7.55),('12374','2013-02-10','11:15:00',7.62),('12374','2013-02-10','11:20:00',7.7),('12374','2013-02-10','11:25:00',7.67),('12374','2013-02-10','11:30:00',7.78),('12374','2013-02-10','11:35:00',7.81),('12374','2013-02-10','11:40:00',7.85),('12374','2013-02-10','11:45:00',7.84),('12374','2013-02-10','11:50:00',7.83),('12374','2013-02-10','11:55:00',7.85),('12374','2013-02-10','12:00:00',7.87),('12374','2013-02-10','12:05:00',7.9),('12374','2013-02-10','12:10:00',7.9),('12374','2013-02-10','12:15:00',7.92),('12374','2013-02-10','12:20:00',7.88),('12374','2013-02-10','12:25:00',7.8),('12374','2013-02-10','12:30:00',7.8),('12374','2013-02-10','12:35:00',7.83),('12374','2013-02-10','12:40:00',7.89),('12374','2013-02-10','12:45:00',7.96),('12374','2013-02-10','12:50:00',7.94),('12374','2013-02-10','12:55:00',7.78),('12374','2013-02-10','13:00:00',7.69),('12374','2013-02-10','13:05:00',7.77),('12374','2013-02-10','13:10:00',7.63),('12374','2013-02-10','13:15:00',7.66),('12374','2013-02-10','13:20:00',7.53),('12374','2013-02-10','13:25:00',7.56),('12374','2013-02-10','13:30:00',7.54),('12374','2013-02-10','13:35:00',7.59),('12374','2013-02-10','13:40:00',7.73),('12374','2013-02-10','13:45:00',7.95),('12374','2013-02-10','13:50:00',8.19),('12374','2013-02-10','13:55:00',8.12),('12374','2013-02-10','14:00:00',8.07),('12374','2013-02-10','14:05:00',7.86),('12374','2013-02-10','14:10:00',7.61),('12374','2013-02-10','14:15:00',7.64),('12374','2013-02-10','14:20:00',7.6),('12374','2013-02-10','14:25:00',7.39),('12374','2013-02-10','14:30:00',7.12),('12374','2013-02-10','14:35:00',6.81),('12374','2013-02-10','14:40:00',6.61),('12374','2013-02-10','14:45:00',6.39),('12374','2013-02-10','14:50:00',6.22),('12374','2013-02-10','14:55:00',6.5),('12374','2013-02-10','15:00:00',6.7),('12374','2013-02-10','15:05:00',6.77),('12374','2013-02-10','15:10:00',6.64),('12374','2013-02-10','15:15:00',6.42),('12374','2013-02-10','15:20:00',6.29),('12374','2013-02-10','15:25:00',3.64),('12374','2013-02-10','15:30:00',2.34),('12374','2013-02-10','15:35:00',3.53),('12374','2013-02-10','15:40:00',4.87),('12374','2013-02-10','15:45:00',3.6),('12374','2013-02-10','15:50:00',1.88),('12374','2013-02-10','15:55:00',1.49),('12374','2013-02-10','16:00:00',1.87),('12374','2013-02-10','16:05:00',3.09),('12374','2013-02-10','16:10:00',3.92),('12374','2013-02-10','16:15:00',3.54),('12374','2013-02-10','16:20:00',2.98),('12374','2013-02-10','16:25:00',2.86),('12374','2013-02-10','16:30:00',2.69),('12374','2013-02-10','16:35:00',2.65),('12374','2013-02-10','16:40:00',2.4),('12374','2013-02-10','16:45:00',2.02),('12374','2013-02-10','16:50:00',1.62),('12374','2013-02-09','09:05:00',1.05),('12374','2013-02-09','09:10:00',1.17),('12374','2013-02-09','09:15:00',1.23),('12374','2013-02-09','09:20:00',1.24),('12374','2013-02-09','09:25:00',1.31),('12374','2013-02-09','09:30:00',1.41),('12374','2013-02-09','09:35:00',1.51),('12374','2013-02-09','09:40:00',1.64),('12374','2013-02-09','09:45:00',1.83),('12374','2013-02-09','09:50:00',2),('12374','2013-02-09','09:55:00',2.1),('12374','2013-02-09','10:00:00',2.15),('12374','2013-02-09','10:05:00',2.24),('12374','2013-02-09','10:10:00',2.22),('12374','2013-02-09','10:15:00',2.23),('12374','2013-02-09','10:20:00',2.21),('12374','2013-02-09','10:25:00',2.19),('12374','2013-02-09','10:30:00',2.3),('12374','2013-02-09','10:35:00',2.36),('12374','2013-02-09','10:40:00',2.37),('12374','2013-02-09','10:45:00',2.28),('12374','2013-02-09','10:50:00',2.28),('12374','2013-02-09','10:55:00',2.4),('12374','2013-02-09','11:00:00',2.51),('12374','2013-02-09','11:05:00',2.66),('12374','2013-02-09','11:10:00',2.71),('12374','2013-02-09','11:15:00',2.69),('12374','2013-02-09','11:20:00',2.7),('12374','2013-02-09','11:25:00',2.75),('12374','2013-02-09','11:30:00',2.73),('12374','2013-02-09','11:35:00',2.77),('12374','2013-02-09','11:40:00',2.88),('12374','2013-02-09','11:45:00',2.9),('12374','2013-02-09','11:50:00',3.02),('12374','2013-02-09','11:55:00',3.12),('12374','2013-02-09','12:00:00',3.49),('12374','2013-02-09','12:05:00',3.83),('12374','2013-02-09','12:10:00',3.54),('12374','2013-02-09','12:15:00',3.34),('12374','2013-02-09','12:20:00',3.35),('12374','2013-02-09','12:25:00',3.47),('12374','2013-02-09','12:30:00',3.79),('12374','2013-02-09','12:35:00',4.34),('12374','2013-02-09','12:40:00',4.76),('12374','2013-02-09','12:45:00',5.45),('12374','2013-02-09','12:50:00',6.24),('12374','2013-02-09','12:55:00',6.78),('12374','2013-02-09','13:00:00',7.56),('12374','2013-02-09','13:05:00',8.22),('12374','2013-02-09','13:10:00',6.95),('12374','2013-02-09','13:15:00',4.87),('12374','2013-02-09','13:20:00',4.78),('12374','2013-02-09','13:25:00',5.7),('12374','2013-02-09','13:30:00',8.4),('12374','2013-02-09','13:35:00',8.09),('12374','2013-02-09','13:40:00',6.78),('12374','2013-02-09','13:45:00',6.19),('12374','2013-02-09','13:50:00',4.16),('12374','2013-02-09','13:55:00',2.58),('12374','2013-02-09','14:00:00',5.52),('12374','2013-02-09','14:05:00',4.21),('12374','2013-02-09','14:10:00',7.02),('12374','2013-02-09','14:15:00',7.03),('12374','2013-02-09','14:20:00',6.16),('12374','2013-02-09','14:25:00',6.09),('12374','2013-02-09','14:30:00',6.24),('12374','2013-02-09','14:35:00',6.09),('12374','2013-02-09','14:40:00',5.83),('12374','2013-02-09','14:45:00',5.7),('12374','2013-02-09','14:50:00',5.6),('12374','2013-02-09','14:55:00',5.41),('12374','2013-02-09','15:00:00',5.29),('12374','2013-02-09','15:05:00',5.14),('12374','2013-02-09','15:10:00',4.96),('12374','2013-02-09','15:15:00',4.8),('12374','2013-02-09','15:20:00',4.64),('12374','2013-02-09','15:25:00',4.45),('12374','2013-02-09','15:30:00',4.29),('12374','2013-02-09','15:35:00',4.15),('12374','2013-02-09','15:40:00',4.01),('12374','2013-02-09','15:45:00',3.86),('12374','2013-02-09','15:50:00',3.74),('12374','2013-02-09','15:55:00',3.73),('12374','2013-02-09','16:00:00',3.77),('12374','2013-02-09','16:05:00',3.89),('12374','2013-02-09','16:10:00',3.93),('12374','2013-02-09','16:15:00',3.98),('12374','2013-02-09','16:20:00',4.2),('12374','2013-02-09','16:25:00',4.25),('12374','2013-02-09','16:30:00',3.88),('12374','2013-02-09','16:35:00',3.25),('12374','2013-02-09','16:40:00',2.57),('12374','2013-02-09','16:45:00',1.78),('12374','2013-02-09','16:50:00',1.1),('12374','2013-02-08','08:15:00',1.83),('12374','2013-02-08','08:20:00',2.19),('12374','2013-02-08','08:25:00',2.06),('12374','2013-02-08','08:30:00',3.87),('12374','2013-02-08','08:35:00',2.76),('12374','2013-02-08','08:40:00',3.11),('12374','2013-02-08','08:45:00',4.38),('12374','2013-02-08','08:50:00',5.13),('12374','2013-02-08','08:55:00',5.37),('12374','2013-02-08','09:00:00',5.46),('12374','2013-02-08','09:05:00',5.54),('12374','2013-02-08','09:10:00',5.89),('12374','2013-02-08','09:15:00',5.65),('12374','2013-02-08','09:20:00',5.51),('12374','2013-02-08','09:25:00',5.39),('12374','2013-02-08','09:30:00',5.45),('12374','2013-02-08','09:35:00',5.55),('12374','2013-02-08','09:40:00',6.03),('12374','2013-02-08','09:45:00',6.41),('12374','2013-02-08','09:50:00',6.27),('12374','2013-02-08','09:55:00',6.19),('12374','2013-02-08','10:00:00',6.15),('12374','2013-02-08','10:05:00',6.33),('12374','2013-02-08','10:10:00',6.39),('12374','2013-02-08','10:15:00',6.6),('12374','2013-02-08','10:20:00',6.63),('12374','2013-02-08','10:25:00',6.74),('12374','2013-02-08','10:30:00',6.84),('12374','2013-02-08','10:35:00',6.99),('12374','2013-02-08','10:40:00',7.13),('12374','2013-02-08','10:45:00',7.24),('12374','2013-02-08','10:50:00',7.39),('12374','2013-02-08','10:55:00',7.63),('12374','2013-02-08','11:00:00',8.07),('12374','2013-02-08','11:05:00',8.82),('12374','2013-02-08','11:10:00',8.3),('12374','2013-02-08','11:15:00',7.55),('12374','2013-02-08','11:20:00',7.58),('12374','2013-02-08','11:25:00',7.01),('12374','2013-02-08','11:30:00',4.45),('12374','2013-02-08','11:35:00',6.86),('12374','2013-02-08','11:40:00',7.12),('12374','2013-02-08','11:45:00',8.64),('12374','2013-02-08','11:50:00',6.34),('12374','2013-02-08','11:55:00',5.05),('12374','2013-02-08','12:00:00',7.72),('12374','2013-02-08','12:05:00',8.62),('12374','2013-02-08','12:10:00',8.06),('12374','2013-02-08','12:15:00',7.73),('12374','2013-02-08','12:20:00',8.22),('12374','2013-02-08','12:25:00',8.41),('12374','2013-02-08','12:30:00',8.79),('12374','2013-02-08','12:35:00',8.66),('12374','2013-02-08','12:40:00',6.64),('12374','2013-02-08','12:45:00',4.88),('12374','2013-02-08','12:50:00',4.15),('12374','2013-02-08','12:55:00',6.06),('12374','2013-02-08','13:00:00',5.13),('12374','2013-02-08','13:05:00',4.51),('12374','2013-02-08','13:10:00',2.84),('12374','2013-02-08','13:15:00',2.09),('12374','2013-02-08','13:20:00',1.64),('12374','2013-02-08','13:25:00',1.69),('12374','2013-02-08','13:30:00',2.05),('12374','2013-02-08','13:35:00',2.42),('12374','2013-02-08','13:40:00',2.68),('12374','2013-02-08','13:45:00',2.36),('12374','2013-02-08','13:50:00',2.21),('12374','2013-02-08','13:55:00',2.61),('12374','2013-02-08','14:00:00',2.53),('12374','2013-02-08','14:05:00',2.47),('12374','2013-02-08','14:10:00',2.9),('12374','2013-02-08','14:15:00',4.41),('12374','2013-02-08','14:20:00',2.19),('12374','2013-02-08','14:25:00',1.67),('12374','2013-02-08','14:30:00',1.55),('12374','2013-02-08','14:35:00',1.76),('12374','2013-02-08','14:40:00',2.37),('12374','2013-02-08','14:45:00',2.77),('12374','2013-02-08','14:50:00',2.48),('12374','2013-02-08','14:55:00',2.44),('12374','2013-02-08','15:00:00',1.79),('12374','2013-02-08','15:05:00',1.72),('12374','2013-02-08','15:10:00',1.47),('12374','2013-02-08','15:15:00',1.2),('12374','2013-02-08','15:20:00',1.2),('12374','2013-02-08','15:25:00',1.38),('12374','2013-02-08','15:30:00',1.48),('12374','2013-02-08','15:35:00',1.59),('12374','2013-02-08','15:40:00',1.49),('12374','2013-02-08','15:45:00',1.19),('12374','2013-02-07','08:45:00',1.11),('12374','2013-02-07','08:50:00',1.32),('12374','2013-02-07','08:55:00',1.31),('12374','2013-02-07','09:00:00',3.99),('12374','2013-02-07','09:05:00',4.52),('12374','2013-02-07','09:10:00',4.06),('12374','2013-02-07','09:15:00',1.66),('12374','2013-02-07','09:20:00',1.41),('12374','2013-02-07','09:55:00',1.59),('12374','2013-02-07','10:00:00',3.52),('12374','2013-02-07','10:05:00',6.71),('12374','2013-02-07','10:10:00',7.67),('12374','2013-02-07','10:15:00',6.96),('12374','2013-02-07','10:20:00',6.39),('12374','2013-02-07','10:25:00',7.25),('12374','2013-02-07','10:30:00',2.56),('12374','2013-02-07','10:35:00',1.17),('12374','2013-02-07','11:00:00',1.21),('12374','2013-02-07','11:05:00',4.32),('12374','2013-02-07','11:10:00',6.26),('12374','2013-02-07','11:15:00',7.8),('12374','2013-02-07','11:20:00',7.8),('12374','2013-02-07','11:25:00',7.84),('12374','2013-02-07','11:30:00',7.95),('12374','2013-02-07','11:35:00',8.06),('12374','2013-02-07','11:40:00',8),('12374','2013-02-07','11:45:00',6.63),('12374','2013-02-07','11:50:00',1.26),('12374','2013-02-07','11:55:00',3.33),('12374','2013-02-07','12:00:00',6.18),('12374','2013-02-07','12:05:00',5.8),('12374','2013-02-07','12:10:00',7.26),('12374','2013-02-07','12:15:00',8.35),('12374','2013-02-07','12:20:00',7.91),('12374','2013-02-07','12:25:00',4.9),('12374','2013-02-07','12:30:00',7.43),('12374','2013-02-07','12:35:00',8.43),('12374','2013-02-07','12:40:00',8.32),('12374','2013-02-07','12:45:00',7.61),('12374','2013-02-07','12:50:00',8.88),('12374','2013-02-07','12:55:00',7.8),('12374','2013-02-07','13:00:00',8.21),('12374','2013-02-07','13:05:00',8.59),('12374','2013-02-07','13:10:00',7.67),('12374','2013-02-07','13:15:00',6.37),('12374','2013-02-07','13:20:00',2.39),('12374','2013-02-07','13:25:00',2.27),('12374','2013-02-07','13:30:00',3.11),('12374','2013-02-07','13:35:00',8.53),('12374','2013-02-07','13:40:00',8.75),('12374','2013-02-07','13:45:00',5.72),('12374','2013-02-07','13:50:00',6.98),('12374','2013-02-07','13:55:00',4.86),('12374','2013-02-07','14:00:00',6.21),('12374','2013-02-07','14:05:00',7.62),('12374','2013-02-07','14:10:00',6.77),('12374','2013-02-07','14:15:00',7.37),('12374','2013-02-07','14:20:00',5.76),('12374','2013-02-07','14:25:00',7.55),('12374','2013-02-07','14:30:00',6.02),('12374','2013-02-07','14:35:00',3.85),('12374','2013-02-07','14:40:00',5.47),('12374','2013-02-07','14:45:00',3.14),('12374','2013-02-07','14:50:00',2.51),('12374','2013-02-07','14:55:00',4.66),('12374','2013-02-07','15:00:00',5.89),('12374','2013-02-07','15:05:00',5.04),('12374','2013-02-07','15:10:00',3.22),('12374','2013-02-07','15:15:00',2.36),('12374','2013-02-07','15:20:00',1.6),('12374','2013-02-07','15:25:00',1.35),('12374','2013-02-07','16:45:00',2.08),('12374','2013-02-07','16:50:00',2.45),('12374','2013-02-07','16:55:00',1.43),('12374','2013-02-06','08:15:00',1.16),('12374','2013-02-06','08:20:00',1.02),('12374','2013-02-06','08:25:00',1),('12374','2013-02-06','08:30:00',1.45),('12374','2013-02-06','08:35:00',1.38),('12374','2013-02-06','08:40:00',1.5),('12374','2013-02-06','08:45:00',1.78),('12374','2013-02-06','08:50:00',1.74),('12374','2013-02-06','08:55:00',1.85),('12374','2013-02-06','09:00:00',2.27),('12374','2013-02-06','09:05:00',1.8),('12374','2013-02-06','09:10:00',1.58),('12374','2013-02-06','09:15:00',1.58),('12374','2013-02-06','09:20:00',1.69),('12374','2013-02-06','09:25:00',1.74),('12374','2013-02-06','09:30:00',1.66),('12374','2013-02-06','09:35:00',1.55),('12374','2013-02-06','09:40:00',1.8),('12374','2013-02-06','09:45:00',2),('12374','2013-02-06','09:50:00',1.97),('12374','2013-02-06','09:55:00',1.81),('12374','2013-02-06','10:00:00',1.8),('12374','2013-02-06','10:05:00',1.88),('12374','2013-02-06','10:10:00',2.04),('12374','2013-02-06','10:15:00',2.11),('12374','2013-02-06','10:20:00',3.91),('12374','2013-02-06','10:25:00',3.28),('12374','2013-02-06','10:30:00',3.79),('12374','2013-02-06','10:35:00',3.56),('12374','2013-02-06','10:40:00',3.02),('12374','2013-02-06','10:45:00',2.9),('12374','2013-02-06','10:50:00',2.38),('12374','2013-02-06','10:55:00',2.3),('12374','2013-02-06','11:00:00',2.52),('12374','2013-02-06','11:05:00',2.22),('12374','2013-02-06','11:10:00',1.63),('12374','2013-02-06','11:15:00',2.28),('12374','2013-02-06','11:20:00',2.66),('12374','2013-02-06','11:25:00',2.13),('12374','2013-02-06','11:30:00',1.81),('12374','2013-02-06','11:35:00',2.24),('12374','2013-02-06','11:40:00',1.89),('12374','2013-02-06','11:45:00',1.15),('12374','2013-02-06','11:50:00',1.36),('12374','2013-02-06','12:00:00',2.18),('12374','2013-02-06','12:05:00',3.06),('12374','2013-02-06','12:10:00',2.78),('12374','2013-02-06','12:15:00',2.22),('12374','2013-02-06','12:20:00',2.31),('12374','2013-02-06','12:25:00',2.32),('12374','2013-02-06','12:30:00',4.11),('12374','2013-02-06','12:35:00',5.92),('12374','2013-02-06','12:40:00',3.87),('12374','2013-02-06','12:45:00',3.25),('12374','2013-02-06','12:50:00',3.25),('12374','2013-02-06','12:55:00',2.31),('12374','2013-02-06','13:00:00',2.21),('12374','2013-02-06','13:05:00',2.54),('12374','2013-02-06','13:10:00',1.86),('12374','2013-02-06','13:45:00',1.13),('12374','2013-02-06','13:50:00',1.03),('12374','2013-02-06','14:15:00',1.22),('12374','2013-02-06','14:20:00',3.85),('12374','2013-02-06','14:25:00',1.16),('12374','2013-02-06','14:30:00',1.23),('12374','2013-02-06','14:35:00',6.62),('12374','2013-02-06','14:40:00',4.83),('12374','2013-02-06','14:45:00',3.6),('12374','2013-02-06','14:50:00',2.19),('12374','2013-02-06','14:55:00',4.92),('12374','2013-02-06','15:00:00',6.5),('12374','2013-02-06','15:05:00',5.53),('12374','2013-02-06','15:10:00',3.22),('12374','2013-02-06','15:15:00',3.32),('12374','2013-02-06','15:20:00',3.86),('12374','2013-02-06','15:25:00',2.85),('12374','2013-02-06','15:30:00',1.52),('12374','2013-02-06','15:35:00',1.35),('12374','2013-02-06','15:40:00',1.21),('12374','2013-02-06','15:45:00',1.11),('12374','2013-02-06','15:50:00',1.1),('12374','2013-02-06','15:55:00',1.07),('12374','2013-02-06','16:00:00',1.05),('12374','2013-02-06','16:05:00',1.01),('12374','2013-02-06','16:30:00',1.68),('12374','2013-02-06','16:35:00',1.94),('12374','2013-02-06','16:40:00',1.99),('12374','2013-02-06','16:45:00',1.8),('12374','2013-02-06','16:50:00',1.26),('12374','2013-02-05','07:55:00',1.21),('12374','2013-02-05','08:00:00',1.5),('12374','2013-02-05','08:05:00',1.75),('12374','2013-02-05','08:10:00',2),('12374','2013-02-05','08:15:00',2.07),('12374','2013-02-05','08:20:00',2.22),('12374','2013-02-05','08:25:00',2.63),('12374','2013-02-05','08:30:00',2.88),('12374','2013-02-05','08:35:00',2.75),('12374','2013-02-05','08:40:00',3.08),('12374','2013-02-05','08:45:00',3.51),('12374','2013-02-05','08:50:00',3.74),('12374','2013-02-05','08:55:00',3.92),('12374','2013-02-05','09:00:00',4.09),('12374','2013-02-05','09:05:00',4.23),('12374','2013-02-05','09:10:00',4.39),('12374','2013-02-05','09:15:00',4.39),('12374','2013-02-05','09:20:00',4.66),('12374','2013-02-05','09:25:00',4.76),('12374','2013-02-05','09:30:00',4.9),('12374','2013-02-05','09:35:00',5.02),('12374','2013-02-05','09:40:00',5.11),('12374','2013-02-05','09:45:00',5.27),('12374','2013-02-05','09:50:00',5.45),('12374','2013-02-05','09:55:00',5.58),('12374','2013-02-05','10:00:00',5.74),('12374','2013-02-05','10:05:00',5.91),('12374','2013-02-05','10:10:00',6.03),('12374','2013-02-05','10:15:00',6.13),('12374','2013-02-05','10:20:00',6.22),('12374','2013-02-05','10:25:00',6.3),('12374','2013-02-05','10:30:00',6.47),('12374','2013-02-05','10:35:00',6.57),('12374','2013-02-05','10:40:00',6.72),('12374','2013-02-05','10:45:00',6.82),('12374','2013-02-05','10:50:00',6.83),('12374','2013-02-05','10:55:00',6.85),('12374','2013-02-05','11:00:00',7.16),('12374','2013-02-05','11:05:00',7.17),('12374','2013-02-05','11:10:00',6.82),('12374','2013-02-05','11:15:00',7.18),('12374','2013-02-05','11:20:00',7.1),('12374','2013-02-05','11:25:00',7.27),('12374','2013-02-05','11:30:00',7.21),('12374','2013-02-05','11:35:00',6.82),('12374','2013-02-05','11:40:00',6.42),('12374','2013-02-05','11:45:00',3.78),('12374','2013-02-05','11:50:00',2.97),('12374','2013-02-05','11:55:00',3.12),('12374','2013-02-05','12:00:00',3.71),('12374','2013-02-05','12:05:00',5.24),('12374','2013-02-05','12:10:00',4.47),('12374','2013-02-05','12:15:00',4.1),('12374','2013-02-05','12:20:00',3.63),('12374','2013-02-05','12:25:00',3.3),('12374','2013-02-05','12:30:00',3.49),('12374','2013-02-05','12:35:00',2.95),('12374','2013-02-05','12:40:00',3.6),('12374','2013-02-05','12:45:00',3.5),('12374','2013-02-05','12:50:00',3.24),('12374','2013-02-05','12:55:00',2.78),('12374','2013-02-05','13:00:00',2.63),('12374','2013-02-05','13:05:00',2.68),('12374','2013-02-05','13:10:00',3.15),('12374','2013-02-05','13:15:00',3.44),('12374','2013-02-05','13:20:00',3.36),('12374','2013-02-05','13:25:00',3.53),('12374','2013-02-05','13:30:00',4.21),('12374','2013-02-05','13:35:00',3.93),('12374','2013-02-05','13:40:00',4.61),('12374','2013-02-05','13:45:00',3.37),('12374','2013-02-05','13:50:00',3.54),('12374','2013-02-05','13:55:00',3.89),('12374','2013-02-05','14:00:00',4.1),('12374','2013-02-05','14:05:00',4.9),('12374','2013-02-05','14:10:00',4.59),('12374','2013-02-05','14:15:00',6.11),('12374','2013-02-05','14:20:00',5.01),('12374','2013-02-05','14:25:00',4.24),('12374','2013-02-05','14:30:00',3.11),('12374','2013-02-05','14:35:00',2.9),('12374','2013-02-05','14:40:00',2.67),('12374','2013-02-05','14:45:00',2.43),('12374','2013-02-05','14:50:00',1.7),('12374','2013-02-05','14:55:00',1.09),('12374','2013-02-04','07:50:00',1.12),('12374','2013-02-04','07:55:00',1.42),('12374','2013-02-04','08:00:00',1.77),('12374','2013-02-04','08:05:00',2.1),('12374','2013-02-04','08:10:00',2.31),('12374','2013-02-04','08:15:00',2.36),('12374','2013-02-04','08:20:00',2.31),('12374','2013-02-04','08:25:00',2.88),('12374','2013-02-04','08:30:00',3.05),('12374','2013-02-04','08:35:00',2.99),('12374','2013-02-04','08:40:00',3.44),('12374','2013-02-04','08:45:00',3.45),('12374','2013-02-04','08:50:00',4.03),('12374','2013-02-04','08:55:00',4.19),('12374','2013-02-04','09:00:00',4.33),('12374','2013-02-04','09:05:00',4.15),('12374','2013-02-04','09:10:00',4.36),('12374','2013-02-04','09:15:00',4.6),('12374','2013-02-04','09:20:00',3.95),('12374','2013-02-04','09:25:00',4.02),('12374','2013-02-04','09:30:00',4.99),('12374','2013-02-04','09:35:00',5.18),('12374','2013-02-04','09:40:00',5.62),('12374','2013-02-04','09:45:00',5.68),('12374','2013-02-04','09:50:00',5.48),('12374','2013-02-04','09:55:00',5.05),('12374','2013-02-04','10:00:00',5.35),('12374','2013-02-04','10:05:00',6.12),('12374','2013-02-04','10:10:00',6.15),('12374','2013-02-04','10:15:00',6.38),('12374','2013-02-04','10:20:00',6.24),('12374','2013-02-04','10:25:00',6.61),('12374','2013-02-04','10:30:00',6.29),('12374','2013-02-04','10:35:00',6.37),('12374','2013-02-04','10:40:00',6.89),('12374','2013-02-04','10:45:00',6.95),('12374','2013-02-04','10:50:00',7.03),('12374','2013-02-04','10:55:00',7.12),('12374','2013-02-04','11:00:00',7.14),('12374','2013-02-04','11:05:00',7.25),('12374','2013-02-04','11:10:00',7.29),('12374','2013-02-04','11:15:00',7.34),('12374','2013-02-04','11:20:00',7.38),('12374','2013-02-04','11:25:00',7.43),('12374','2013-02-04','11:30:00',7.49),('12374','2013-02-04','11:35:00',7.52),('12374','2013-02-04','11:40:00',7.56),('12374','2013-02-04','11:45:00',7.59),('12374','2013-02-04','11:50:00',7.6),('12374','2013-02-04','11:55:00',7.63),('12374','2013-02-04','12:00:00',7.64),('12374','2013-02-04','12:05:00',7.65),('12374','2013-02-04','12:10:00',7.65),('12374','2013-02-04','12:15:00',7.61),('12374','2013-02-04','12:20:00',7.59),('12374','2013-02-04','12:25:00',7.58),('12374','2013-02-04','12:30:00',7.61),('12374','2013-02-04','12:35:00',7.54),('12374','2013-02-04','12:40:00',7.48),('12374','2013-02-04','12:45:00',7.43),('12374','2013-02-04','12:50:00',7.38),('12374','2013-02-04','12:55:00',7.31),('12374','2013-02-04','13:00:00',7.25),('12374','2013-02-04','13:05:00',7.22),('12374','2013-02-04','13:10:00',7.17),('12374','2013-02-04','13:15:00',7.06),('12374','2013-02-04','13:20:00',7.02),('12374','2013-02-04','13:25:00',6.96),('12374','2013-02-04','13:30:00',6.9),('12374','2013-02-04','13:35:00',6.83),('12374','2013-02-04','13:40:00',6.76),('12374','2013-02-04','13:45:00',6.7),('12374','2013-02-04','13:50:00',6.59),('12374','2013-02-04','13:55:00',6.48),('12374','2013-02-04','14:00:00',6.4),('12374','2013-02-04','14:05:00',6.3),('12374','2013-02-04','14:10:00',6.21),('12374','2013-02-04','14:15:00',6.1),('12374','2013-02-04','14:20:00',5.99),('12374','2013-02-04','14:25:00',5.89),('12374','2013-02-04','14:30:00',5.78),('12374','2013-02-04','14:35:00',5.64),('12374','2013-02-04','14:40:00',5.51),('12374','2013-02-04','14:45:00',5.35),('12374','2013-02-04','14:50:00',5.23),('12374','2013-02-04','14:55:00',5.1),('12374','2013-02-04','15:00:00',4.97),('12374','2013-02-04','15:05:00',4.82),('12374','2013-02-04','15:10:00',4.7),('12374','2013-02-04','15:15:00',4.55),('12374','2013-02-04','15:20:00',4.42),('12374','2013-02-04','15:25:00',4.29),('12374','2013-02-04','15:30:00',4.16),('12374','2013-02-04','15:35:00',4.02),('12374','2013-02-04','15:40:00',3.88),('12374','2013-02-04','15:45:00',3.73),('12374','2013-02-04','15:50:00',3.57),('12374','2013-02-04','15:55:00',3.42),('12374','2013-02-04','16:00:00',3.22),('12374','2013-02-04','16:05:00',3.04),('12374','2013-02-04','16:10:00',2.86),('12374','2013-02-04','16:15:00',2.67),('12374','2013-02-04','16:20:00',2.49),('12374','2013-02-04','16:25:00',2.28),('12374','2013-02-04','16:30:00',2.07),('12374','2013-02-04','16:35:00',1.9),('12374','2013-02-04','16:40:00',1.7),('12374','2013-02-04','16:45:00',1.43),('12374','2013-02-04','16:50:00',1.11),('12374','2013-02-03','08:50:00',1.02),('12374','2013-02-03','09:40:00',1.56),('12374','2013-02-03','09:45:00',1.93),('12374','2013-02-03','09:50:00',1.44),('12374','2013-02-03','09:55:00',1.04),('12374','2013-02-03','11:35:00',1.29),('12374','2013-02-03','11:40:00',2.01),('12374','2013-02-03','11:45:00',2.09),('12374','2013-02-03','11:50:00',1.87),('12374','2013-02-03','11:55:00',1.45),('12374','2013-02-02','08:45:00',1.03),('12374','2013-02-02','08:50:00',1.51),('12374','2013-02-02','08:55:00',1.14),('12374','2013-02-02','09:00:00',1.17),('12374','2013-02-02','09:10:00',1.09),('12374','2013-02-02','09:15:00',1.18),('12374','2013-02-02','09:30:00',1.37),('12374','2013-02-02','09:35:00',1.9),('12374','2013-02-02','09:40:00',2.76),('12374','2013-02-02','09:45:00',3.05),('12374','2013-02-02','09:50:00',2.43),('12374','2013-02-02','09:55:00',2.97),('12374','2013-02-02','10:00:00',2.95),('12374','2013-02-02','10:05:00',1.8),('12374','2013-02-02','10:10:00',1.12),('12374','2013-02-02','10:15:00',1.2),('12374','2013-02-02','10:20:00',1.38),('12374','2013-02-02','10:25:00',2.27),('12374','2013-02-02','10:30:00',1.59),('12374','2013-02-02','10:35:00',2.41),('12374','2013-02-02','10:40:00',3.46),('12374','2013-02-02','10:45:00',3.62),('12374','2013-02-02','10:50:00',4.23),('12374','2013-02-02','10:55:00',3.96),('12374','2013-02-02','11:00:00',3.5),('12374','2013-02-02','11:05:00',1.84),('12374','2013-02-02','11:10:00',1.79),('12374','2013-02-02','11:15:00',1.65),('12374','2013-02-02','11:20:00',1.6),('12374','2013-02-02','11:25:00',1.01),('12374','2013-02-02','11:45:00',1.18),('12374','2013-02-02','11:50:00',1.04),('12374','2013-02-02','12:00:00',1.16),('12374','2013-02-02','12:05:00',1.4),('12374','2013-02-02','12:20:00',1.12),('12374','2013-02-02','12:25:00',1.93),('12374','2013-02-02','12:30:00',5.03),('12374','2013-02-02','12:35:00',2.26),('12374','2013-02-02','12:40:00',1.46),('12374','2013-02-02','12:45:00',1.96),('12374','2013-02-02','12:50:00',1.99),('12374','2013-02-02','12:55:00',1.47),('12374','2013-02-02','13:00:00',2.68),('12374','2013-02-02','13:05:00',1.21),('12374','2013-02-02','14:10:00',1.08),('12374','2013-02-01','08:15:00',1.25),('12374','2013-02-01','08:20:00',1.43),('12374','2013-02-01','08:25:00',1.69),('12374','2013-02-01','08:40:00',1.14),('12374','2013-02-01','08:50:00',1.12),('12374','2013-02-01','08:55:00',1.71),('12374','2013-02-01','09:00:00',1.84),('12374','2013-02-01','09:05:00',1.88),('12374','2013-02-01','09:10:00',3.5),('12374','2013-02-01','09:15:00',3.61),('12374','2013-02-01','09:20:00',1.75),('12374','2013-02-01','09:25:00',3.31),('12374','2013-02-01','09:30:00',3.24),('12374','2013-02-01','09:35:00',1.86),('12374','2013-02-01','09:40:00',1.3),('12374','2013-02-01','09:55:00',1.5),('12374','2013-02-01','10:00:00',5.26),('12374','2013-02-01','10:05:00',4.26),('12374','2013-02-01','10:10:00',2.59),('12374','2013-02-01','10:15:00',3.2),('12374','2013-02-01','10:20:00',1.88),('12374','2013-02-01','10:25:00',2.91),('12374','2013-02-01','10:30:00',2.29),('12374','2013-02-01','10:35:00',3.03),('12374','2013-02-01','10:40:00',6.15),('12374','2013-02-01','10:45:00',6.55),('12374','2013-02-01','10:50:00',6.23),('12374','2013-02-01','10:55:00',5.3),('12374','2013-02-01','11:00:00',5.28),('12374','2013-02-01','11:05:00',5.76),('12374','2013-02-01','11:10:00',4.33),('12374','2013-02-01','11:15:00',2.85),('12374','2013-02-01','11:20:00',3.23),('12374','2013-02-01','11:25:00',9.16),('12374','2013-02-01','11:30:00',8.47),('12374','2013-02-01','11:35:00',7.65),('12374','2013-02-01','11:40:00',7.64),('12374','2013-02-01','11:45:00',7.99),('12374','2013-02-01','11:50:00',7.8),('12374','2013-02-01','11:55:00',7.24),('12374','2013-02-01','12:00:00',7.21),('12374','2013-02-01','12:05:00',6.17),('12374','2013-02-01','12:10:00',6.44),('12374','2013-02-01','12:15:00',4.28),('12374','2013-02-01','12:20:00',5.4),('12374','2013-02-01','12:25:00',7.49),('12374','2013-02-01','12:30:00',7.15),('12374','2013-02-01','12:35:00',7.02),('12374','2013-02-01','12:40:00',6.98),('12374','2013-02-01','12:45:00',6.86),('12374','2013-02-01','12:50:00',6.77),('12374','2013-02-01','12:55:00',6.49),('12374','2013-02-01','13:00:00',6.24),('12374','2013-02-01','13:05:00',6.8),('12374','2013-02-01','13:10:00',6.5),('12374','2013-02-01','13:15:00',6.23),('12374','2013-02-01','13:20:00',5.61),('12374','2013-02-01','13:25:00',6.07),('12374','2013-02-01','13:30:00',6.39),('12374','2013-02-01','13:35:00',5.42),('12374','2013-02-01','13:40:00',6.28),('12374','2013-02-01','13:45:00',6.37),('12374','2013-02-01','13:50:00',6.12),('12374','2013-02-01','13:55:00',6.04),('12374','2013-02-01','14:00:00',6.02),('12374','2013-02-01','14:05:00',5.94),('12374','2013-02-01','14:10:00',5.66),('12374','2013-02-01','14:15:00',5.66),('12374','2013-02-01','14:20:00',5.47),('12374','2013-02-01','14:25:00',5.45),('12374','2013-02-01','14:30:00',5.35),('12374','2013-02-01','14:35:00',5.21),('12374','2013-02-01','14:40:00',5.05),('12374','2013-02-01','14:45:00',4.9),('12374','2013-02-01','14:50:00',4.84),('12374','2013-02-01','14:55:00',4.72),('12374','2013-02-01','15:00:00',4.61),('12374','2013-02-01','15:05:00',4.39),('12374','2013-02-01','15:10:00',4.32),('12374','2013-02-01','15:15:00',4.16),('12374','2013-02-01','15:20:00',3.91),('12374','2013-02-01','15:25:00',3.83),('12374','2013-02-01','15:30:00',3.58),('12374','2013-02-01','15:35:00',3.4),('12374','2013-02-01','15:40:00',3.13),('12374','2013-02-01','15:45:00',2.78),('12374','2013-02-01','15:50:00',2.52),('12374','2013-02-01','15:55:00',1.8),('12374','2013-02-01','16:00:00',1.44),('12374','2013-02-01','16:05:00',1.17),('12374','2013-02-01','16:10:00',1.24),('12374','2013-02-01','16:15:00',1.12),('12374','2013-02-01','16:20:00',1.03),('12374','2013-02-01','16:25:00',1.12),('12374','2013-01-31','08:35:00',1.63),('12374','2013-01-31','08:40:00',2.85),('12374','2013-01-31','08:45:00',2.67),('12374','2013-01-31','08:50:00',3.14),('12374','2013-01-31','08:55:00',3.21),('12374','2013-01-31','09:00:00',3.6),('12374','2013-01-31','09:05:00',3.75),('12374','2013-01-31','09:10:00',3.93),('12374','2013-01-31','09:15:00',4.1),('12374','2013-01-31','09:20:00',4.18),('12374','2013-01-31','09:25:00',4.39),('12374','2013-01-31','09:30:00',4.46),('12374','2013-01-31','09:35:00',4.58),('12374','2013-01-31','09:40:00',4.65),('12374','2013-01-31','09:45:00',4.75),('12374','2013-01-31','09:50:00',5.02),('12374','2013-01-31','09:55:00',5.2),('12374','2013-01-31','10:00:00',5.22),('12374','2013-01-31','10:05:00',5.13),('12374','2013-01-31','10:10:00',5.36),('12374','2013-01-31','10:15:00',5.58),('12374','2013-01-31','10:20:00',5.72),('12374','2013-01-31','10:25:00',5.94),('12374','2013-01-31','10:30:00',5.98),('12374','2013-01-31','10:35:00',6.11),('12374','2013-01-31','10:40:00',6.19),('12374','2013-01-31','10:45:00',6.27),('12374','2013-01-31','10:50:00',6.35),('12374','2013-01-31','10:55:00',6.46),('12374','2013-01-31','11:00:00',6.42),('12374','2013-01-31','11:05:00',6.39),('12374','2013-01-31','11:10:00',6.44),('12374','2013-01-31','11:15:00',6.71),('12374','2013-01-31','11:20:00',6.65),('12374','2013-01-31','11:25:00',6.67),('12374','2013-01-31','11:30:00',6.76),('12374','2013-01-31','11:35:00',6.89),('12374','2013-01-31','11:40:00',6.84),('12374','2013-01-31','11:45:00',7.01),('12374','2013-01-31','11:50:00',7),('12374','2013-01-31','11:55:00',6.89),('12374','2013-01-31','12:00:00',7),('12374','2013-01-31','12:05:00',6.97),('12374','2013-01-31','12:10:00',6.94),('12374','2013-01-31','12:15:00',7.03),('12374','2013-01-31','12:20:00',6.93),('12374','2013-01-31','12:25:00',6.91),('12374','2013-01-31','12:30:00',6.93),('12374','2013-01-31','12:35:00',6.99),('12374','2013-01-31','12:40:00',6.97),('12374','2013-01-31','12:45:00',6.85),('12374','2013-01-31','12:50:00',6.91),('12374','2013-01-31','12:55:00',6.83),('12374','2013-01-31','13:00:00',6.76),('12374','2013-01-31','13:05:00',6.7),('12374','2013-01-31','13:10:00',6.67),('12374','2013-01-31','13:15:00',6.62),('12374','2013-01-31','13:20:00',6.47),('12374','2013-01-31','13:25:00',6.37),('12374','2013-01-31','13:30:00',6.36),('12374','2013-01-31','13:35:00',6.37),('12374','2013-01-31','13:40:00',6.24),('12374','2013-01-31','13:45:00',6.06),('12374','2013-01-31','13:50:00',6.04),('12374','2013-01-31','13:55:00',5.97),('12374','2013-01-31','14:00:00',5.86),('12374','2013-01-31','14:05:00',5.77),('12374','2013-01-31','14:10:00',5.69),('12374','2013-01-31','14:15:00',5.57),('12374','2013-01-31','14:20:00',5.49),('12374','2013-01-31','14:25:00',5.36),('12374','2013-01-31','14:30:00',5.25),('12374','2013-01-31','14:35:00',5.12),('12374','2013-01-31','14:40:00',5.08),('12374','2013-01-31','14:45:00',4.84),('12374','2013-01-31','14:50:00',4.61),('12374','2013-01-31','14:55:00',4.54),('12374','2013-01-31','15:00:00',4.5),('12374','2013-01-31','15:05:00',4.39),('12374','2013-01-31','15:10:00',4.25),('12374','2013-01-31','15:15:00',3.72),('12374','2013-01-31','15:20:00',4.18),('12374','2013-01-31','15:25:00',3.99),('12374','2013-01-31','15:30:00',3.67),('12374','2013-01-31','15:35:00',3.09),('12374','2013-01-31','15:40:00',2.5),('12374','2013-01-31','15:45:00',2.23),('12374','2013-01-31','15:50:00',2.97),('12374','2013-01-31','15:55:00',2.64),('12374','2013-01-31','16:00:00',2.52),('12374','2013-01-31','16:05:00',2.14),('12374','2013-01-31','16:10:00',2.22),('12374','2013-01-31','16:15:00',2.29),('12374','2013-01-31','16:20:00',2.14),('12374','2013-01-31','16:25:00',1.91),('12374','2013-01-31','16:30:00',1.75),('12374','2013-01-31','16:35:00',1.57),('12374','2013-01-31','16:40:00',1.39),('12374','2013-01-30','08:30:00',1.06),('12374','2013-01-30','08:35:00',1.92),('12374','2013-01-30','08:40:00',1.96),('12374','2013-01-30','08:45:00',1.98),('12374','2013-01-30','08:50:00',3.21),('12374','2013-01-30','08:55:00',3.51),('12374','2013-01-30','09:00:00',3.86),('12374','2013-01-30','09:05:00',4.74),('12374','2013-01-30','09:10:00',3.95),('12374','2013-01-30','09:15:00',2.27),('12374','2013-01-30','09:20:00',2.11),('12374','2013-01-30','09:25:00',1.81),('12374','2013-01-30','09:30:00',4.49),('12374','2013-01-30','09:35:00',2.46),('12374','2013-01-30','09:40:00',4.32),('12374','2013-01-30','09:45:00',2.02),('12374','2013-01-30','09:50:00',1.82),('12374','2013-01-30','09:55:00',1.74),('12374','2013-01-30','10:00:00',2.72),('12374','2013-01-30','10:05:00',2.32),('12374','2013-01-30','10:10:00',2.02),('12374','2013-01-30','10:15:00',4.67),('12374','2013-01-30','10:20:00',4.77),('12374','2013-01-30','10:25:00',3.62),('12374','2013-01-30','10:30:00',5.62),('12374','2013-01-30','10:35:00',5.66),('12374','2013-01-30','10:40:00',6.27),('12374','2013-01-30','10:45:00',6.36),('12374','2013-01-30','10:50:00',6.4),('12374','2013-01-30','10:55:00',6.52),('12374','2013-01-30','11:00:00',6.6),('12374','2013-01-30','11:05:00',6.68),('12374','2013-01-30','11:10:00',6.65),('12374','2013-01-30','11:15:00',6.64),('12374','2013-01-30','11:20:00',6.77),('12374','2013-01-30','11:25:00',6.83),('12374','2013-01-30','11:30:00',6.83),('12374','2013-01-30','11:35:00',7.01),('12374','2013-01-30','11:40:00',6.86),('12374','2013-01-30','11:45:00',7.13),('12374','2013-01-30','11:50:00',6.15),('12374','2013-01-30','11:55:00',3.81),('12374','2013-01-30','12:00:00',3.49),('12374','2013-01-30','12:05:00',3.76),('12374','2013-01-30','12:10:00',4.44),('12374','2013-01-30','12:15:00',5.62),('12374','2013-01-30','12:20:00',7.29),('12374','2013-01-30','12:25:00',4.76),('12374','2013-01-30','12:30:00',3.07),('12374','2013-01-30','12:35:00',3.57),('12374','2013-01-30','12:40:00',3.69),('12374','2013-01-30','12:45:00',3.85),('12374','2013-01-30','12:50:00',4.19),('12374','2013-01-30','12:55:00',6),('12374','2013-01-30','13:00:00',6.16),('12374','2013-01-30','13:05:00',6.17),('12374','2013-01-30','13:10:00',6.75),('12374','2013-01-30','13:15:00',6.14),('12374','2013-01-30','13:20:00',6.18),('12374','2013-01-30','13:25:00',6.3),('12374','2013-01-30','13:30:00',6.34),('12374','2013-01-30','13:35:00',6.15),('12374','2013-01-30','13:40:00',5.96),('12374','2013-01-30','13:45:00',5.42),('12374','2013-01-30','13:50:00',4.68),('12374','2013-01-30','13:55:00',4.2),('12374','2013-01-30','14:00:00',4.56),('12374','2013-01-30','14:05:00',4.99),('12374','2013-01-30','14:10:00',4.61),('12374','2013-01-30','14:15:00',3.46),('12374','2013-01-30','14:20:00',2.49),('12374','2013-01-30','14:25:00',3.07),('12374','2013-01-30','14:30:00',2.95),('12374','2013-01-30','14:35:00',2.99),('12374','2013-01-30','14:40:00',2.72),('12374','2013-01-30','14:45:00',2.82),('12374','2013-01-30','14:50:00',2.81),('12374','2013-01-30','14:55:00',2.68),('12374','2013-01-30','15:00:00',2.39),('12374','2013-01-30','15:05:00',2.07),('12374','2013-01-30','15:10:00',1.9),('12374','2013-01-30','15:15:00',1.74),('12374','2013-01-30','15:20:00',1.67),('12374','2013-01-30','15:25:00',1.69),('12374','2013-01-30','15:30:00',1.84),('12374','2013-01-30','15:35:00',1.92),('12374','2013-01-30','15:40:00',1.73),('12374','2013-01-30','15:45:00',1.57),('12374','2013-01-30','15:50:00',1.58),('12374','2013-01-30','15:55:00',1.7),('12374','2013-01-30','16:00:00',2.58),('12374','2013-01-30','16:05:00',2.37),('12374','2013-01-30','16:10:00',1.29),('12374','2013-01-30','16:15:00',1.37),('12374','2013-01-30','16:35:00',1.08),('12374','2013-01-29','08:00:00',1.3),('12374','2013-01-29','08:05:00',1.29),('12374','2013-01-29','08:10:00',1.57),('12374','2013-01-29','08:15:00',1.78),('12374','2013-01-29','08:20:00',1.3),('12374','2013-01-29','08:25:00',1.29),('12374','2013-01-29','08:30:00',1.58),('12374','2013-01-29','08:35:00',2.42),('12374','2013-01-29','08:40:00',2.88),('12374','2013-01-29','08:45:00',2.82),('12374','2013-01-29','08:50:00',3.1),('12374','2013-01-29','08:55:00',3.37),('12374','2013-01-29','09:00:00',3.59),('12374','2013-01-29','09:05:00',3.88),('12374','2013-01-29','09:10:00',4),('12374','2013-01-29','09:15:00',4.13),('12374','2013-01-29','09:20:00',4.29),('12374','2013-01-29','09:25:00',4.43),('12374','2013-01-29','09:30:00',4.54),('12374','2013-01-29','09:35:00',4.67),('12374','2013-01-29','09:40:00',4.77),('12374','2013-01-29','09:45:00',4.79),('12374','2013-01-29','09:50:00',5.02),('12374','2013-01-29','09:55:00',5.17),('12374','2013-01-29','10:00:00',5.3),('12374','2013-01-29','10:05:00',5.48),('12374','2013-01-29','10:10:00',5.89),('12374','2013-01-29','10:15:00',4.73),('12374','2013-01-29','10:20:00',4.17),('12374','2013-01-29','10:25:00',7.21),('12374','2013-01-29','10:30:00',2.65),('12374','2013-01-29','10:35:00',2.72),('12374','2013-01-29','10:40:00',2.76),('12374','2013-01-29','10:45:00',2.75),('12374','2013-01-29','10:50:00',3.51),('12374','2013-01-29','10:55:00',4.79),('12374','2013-01-29','11:00:00',7.19),('12374','2013-01-29','11:05:00',6.86),('12374','2013-01-29','11:10:00',6.82),('12374','2013-01-29','11:15:00',6.92),('12374','2013-01-29','11:20:00',6.91),('12374','2013-01-29','11:25:00',6.52),('12374','2013-01-29','11:30:00',6.57),('12374','2013-01-29','11:35:00',6.4),('12374','2013-01-29','11:40:00',6.83),('12374','2013-01-29','11:45:00',6.58),('12374','2013-01-29','11:50:00',5.21),('12374','2013-01-29','11:55:00',7.25),('12374','2013-01-29','12:00:00',6.99),('12374','2013-01-29','12:05:00',6.98),('12374','2013-01-29','12:10:00',7.02),('12374','2013-01-29','12:15:00',7.02),('12374','2013-01-29','12:20:00',7),('12374','2013-01-29','12:25:00',7.03),('12374','2013-01-29','12:30:00',7.02),('12374','2013-01-29','12:35:00',6.8),('12374','2013-01-29','12:40:00',6.75),('12374','2013-01-29','12:45:00',6.78),('12374','2013-01-29','12:50:00',6.87),('12374','2013-01-29','12:55:00',6.86),('12374','2013-01-29','13:00:00',6.8),('12374','2013-01-29','13:05:00',6.73),('12374','2013-01-29','13:10:00',6.67),('12374','2013-01-29','13:15:00',6.58),('12374','2013-01-29','13:20:00',6.52),('12374','2013-01-29','13:25:00',6.52),('12374','2013-01-29','13:30:00',6.61),('12374','2013-01-29','13:35:00',7.02),('12374','2013-01-29','13:40:00',6.61),('12374','2013-01-29','13:45:00',6.4),('12374','2013-01-29','13:50:00',6.26),('12374','2013-01-29','13:55:00',6.31),('12374','2013-01-29','14:00:00',6.23),('12374','2013-01-29','14:05:00',6.05),('12374','2013-01-29','14:10:00',5.94),('12374','2013-01-29','14:15:00',5.85),('12374','2013-01-29','14:20:00',5.73),('12374','2013-01-29','14:25:00',5.6),('12374','2013-01-29','14:30:00',5.6),('12374','2013-01-29','14:35:00',4.17),('12374','2013-01-29','14:40:00',4.97),('12374','2013-01-29','14:45:00',5.08),('12374','2013-01-29','14:50:00',4.88),('12374','2013-01-29','14:55:00',4.76),('12374','2013-01-29','15:00:00',4.63),('12374','2013-01-29','15:05:00',4.48),('12374','2013-01-29','15:10:00',4.36),('12374','2013-01-29','15:15:00',4.22),('12374','2013-01-29','15:20:00',4.07),('12374','2013-01-29','15:25:00',3.96),('12374','2013-01-29','15:30:00',3.84),('12374','2013-01-29','15:35:00',3.62),('12374','2013-01-29','15:40:00',3.51),('12374','2013-01-29','15:45:00',3.36),('12374','2013-01-29','15:50:00',3.2),('12374','2013-01-29','15:55:00',3),('12374','2013-01-29','16:00:00',2.86),('12374','2013-01-29','16:05:00',2.7),('12374','2013-01-29','16:10:00',2.52),('12374','2013-01-29','16:15:00',2.33),('12374','2013-01-29','16:20:00',2.18),('12374','2013-01-29','16:25:00',1.93),('12374','2013-01-29','16:30:00',1.78),('12374','2013-01-29','16:35:00',1.59),('12374','2013-01-29','16:40:00',1.31),('12374','2013-01-28','10:15:00',1.06),('12374','2013-01-28','10:20:00',1.21),('12374','2013-01-28','10:25:00',1.39),('12374','2013-01-28','10:30:00',1.72),('12374','2013-01-28','10:35:00',1.66),('12374','2013-01-28','10:40:00',1.24),('12374','2013-01-28','10:45:00',1.08),('12374','2013-01-28','10:50:00',1.21),('12374','2013-01-28','10:55:00',1.29),('12374','2013-01-28','11:00:00',1.27),('12374','2013-01-28','11:50:00',1.18),('12374','2013-01-28','11:55:00',1.36),('12374','2013-01-28','12:00:00',1.59),('12374','2013-01-28','12:05:00',1.91),('12374','2013-01-28','12:10:00',1.92),('12374','2013-01-28','12:15:00',1.87),('12374','2013-01-28','12:20:00',1.89),('12374','2013-01-28','12:25:00',1.97),('12374','2013-01-28','12:30:00',1.87),('12374','2013-01-28','12:35:00',1.68),('12374','2013-01-28','12:40:00',1.53),('12374','2013-01-28','12:45:00',1.61),('12374','2013-01-28','12:50:00',1.75),('12374','2013-01-28','12:55:00',1.66),('12374','2013-01-28','13:00:00',1.75),('12374','2013-01-28','13:05:00',1.85),('12374','2013-01-28','13:10:00',1.78),('12374','2013-01-28','13:15:00',1.49),('12374','2013-01-28','13:20:00',1.29),('12374','2013-01-28','13:25:00',1.23),('12374','2013-01-28','13:30:00',1.19),('12374','2013-01-28','13:35:00',1.09),('12374','2013-01-28','13:40:00',1.18),('12374','2013-01-28','13:45:00',1.23),('12374','2013-01-28','13:50:00',1.22),('12374','2013-01-28','13:55:00',1.27),('12374','2013-01-28','14:00:00',1.34),('12374','2013-01-28','14:05:00',1.4),('12374','2013-01-28','14:10:00',1.3),('12374','2013-01-28','14:15:00',1.03),('12374','2013-01-27','08:15:00',1.01),('12374','2013-01-27','08:50:00',1.31),('12374','2013-01-27','08:55:00',2.23),('12374','2013-01-27','09:00:00',2.77),('12374','2013-01-27','09:05:00',3.76),('12374','2013-01-27','09:10:00',2.13),('12374','2013-01-27','09:15:00',2.73),('12374','2013-01-27','09:20:00',4.23),('12374','2013-01-27','09:25:00',4.33),('12374','2013-01-27','09:30:00',4.45),('12374','2013-01-27','09:35:00',4.47),('12374','2013-01-27','09:40:00',4.6),('12374','2013-01-27','09:45:00',4.74),('12374','2013-01-27','09:50:00',4.84),('12374','2013-01-27','09:55:00',4.92),('12374','2013-01-27','10:00:00',5.18),('12374','2013-01-27','10:05:00',5.3),('12374','2013-01-27','10:10:00',5.45),('12374','2013-01-27','10:15:00',5.57),('12374','2013-01-27','10:20:00',5.71),('12374','2013-01-27','10:25:00',5.8),('12374','2013-01-27','10:30:00',5.94),('12374','2013-01-27','10:35:00',6.06),('12374','2013-01-27','10:40:00',6.21),('12374','2013-01-27','10:45:00',6.32),('12374','2013-01-27','10:50:00',6.38),('12374','2013-01-27','10:55:00',6.43),('12374','2013-01-27','11:00:00',6.54),('12374','2013-01-27','11:05:00',6.67),('12374','2013-01-27','11:10:00',6.79),('12374','2013-01-27','11:15:00',6.83),('12374','2013-01-27','11:20:00',6.81),('12374','2013-01-27','11:25:00',6.86),('12374','2013-01-27','11:30:00',6.86),('12374','2013-01-27','11:35:00',6.89),('12374','2013-01-27','11:40:00',6.9),('12374','2013-01-27','11:45:00',6.94),('12374','2013-01-27','11:50:00',6.96),('12374','2013-01-27','11:55:00',7.03),('12374','2013-01-27','12:00:00',7.11),('12374','2013-01-27','12:05:00',6.99),('12374','2013-01-27','12:10:00',7.05),('12374','2013-01-27','12:15:00',7.05),('12374','2013-01-27','12:20:00',6.96),('12374','2013-01-27','12:25:00',6.97),('12374','2013-01-27','12:30:00',7),('12374','2013-01-27','12:35:00',7.02),('12374','2013-01-27','12:40:00',6.96),('12374','2013-01-27','12:45:00',6.9),('12374','2013-01-27','12:50:00',6.88),('12374','2013-01-27','12:55:00',6.81),('12374','2013-01-27','13:00:00',6.75),('12374','2013-01-27','13:05:00',6.66),('12374','2013-01-27','13:10:00',6.58),('12374','2013-01-27','13:15:00',6.54),('12374','2013-01-27','13:20:00',6.44),('12374','2013-01-27','13:25:00',6.3),('12374','2013-01-27','13:30:00',6.23),('12374','2013-01-27','13:35:00',6.2),('12374','2013-01-27','13:40:00',6.14),('12374','2013-01-27','13:45:00',6.11),('12374','2013-01-27','13:50:00',5.99),('12374','2013-01-27','13:55:00',5.78),('12374','2013-01-27','14:00:00',5.78),('12374','2013-01-27','14:05:00',5.67),('12374','2013-01-27','14:10:00',5.6),('12374','2013-01-27','14:15:00',5.5),('12374','2013-01-27','14:20:00',5.4),('12374','2013-01-27','14:25:00',5.24),('12374','2013-01-27','14:30:00',5.19),('12374','2013-01-27','14:35:00',4.97),('12374','2013-01-27','14:40:00',4.76),('12374','2013-01-27','14:45:00',4.68),('12374','2013-01-27','14:50:00',4.68),('12374','2013-01-27','14:55:00',4.38),('12374','2013-01-27','15:00:00',4.37),('12374','2013-01-27','15:05:00',4.28),('12374','2013-01-27','15:10:00',4.1),('12374','2013-01-27','15:15:00',3.96),('12374','2013-01-27','15:20:00',3.73),('12374','2013-01-27','15:25:00',3.14),('12374','2013-01-27','15:30:00',3.38),('12374','2013-01-27','15:35:00',3.4),('12374','2013-01-27','15:40:00',3.18),('12374','2013-01-27','15:45:00',3.05),('12374','2013-01-27','15:50:00',2.86),('12374','2013-01-27','15:55:00',2.63),('12374','2013-01-27','16:00:00',2.45),('12374','2013-01-27','16:05:00',2.24),('12374','2013-01-27','16:10:00',1.99),('12374','2013-01-27','16:15:00',1.88),('12374','2013-01-27','16:20:00',1.7),('12374','2013-01-27','16:25:00',1.47),('12374','2013-01-27','16:30:00',1.32),('12374','2013-01-27','16:35:00',1.08),('12374','2013-01-26','09:45:00',1.2),('12374','2013-01-26','09:50:00',1.61),('12374','2013-01-26','09:55:00',1.71),('12374','2013-01-26','10:00:00',1.78),('12374','2013-01-26','10:05:00',1.62),('12374','2013-01-26','10:10:00',1.78),('12374','2013-01-26','10:15:00',1.88),('12374','2013-01-26','10:20:00',2.11),('12374','2013-01-26','10:25:00',2.01),('12374','2013-01-26','10:30:00',2.35),('12374','2013-01-26','10:35:00',2.24),('12374','2013-01-26','10:40:00',2.32),('12374','2013-01-26','10:45:00',2.33),('12374','2013-01-26','10:50:00',2.25),('12374','2013-01-26','10:55:00',2.13),('12374','2013-01-26','11:00:00',2.05),('12374','2013-01-26','11:05:00',2.12),('12374','2013-01-26','11:10:00',4.71),('12374','2013-01-26','11:15:00',7.38),('12374','2013-01-26','11:20:00',4.45),('12374','2013-01-26','11:25:00',3.15),('12374','2013-01-26','11:30:00',3.76),('12374','2013-01-26','11:35:00',3.58),('12374','2013-01-26','11:40:00',3.62),('12374','2013-01-26','11:45:00',4.2),('12374','2013-01-26','11:50:00',3.54),('12374','2013-01-26','11:55:00',2.84),('12374','2013-01-26','12:00:00',2.64),('12374','2013-01-26','12:05:00',2.09),('12374','2013-01-26','12:10:00',1.77),('12374','2013-01-26','12:15:00',2.09),('12374','2013-01-26','12:20:00',2.16),('12374','2013-01-26','12:25:00',2.23),('12374','2013-01-26','12:30:00',2.36),('12374','2013-01-26','12:35:00',2.45),('12374','2013-01-26','12:40:00',2.87),('12374','2013-01-26','12:45:00',3.36),('12374','2013-01-26','12:50:00',2.82),('12374','2013-01-26','12:55:00',2.77),('12374','2013-01-26','13:00:00',2.59),('12374','2013-01-26','13:05:00',2.58),('12374','2013-01-26','13:10:00',2.61),('12374','2013-01-26','13:15:00',2.63),('12374','2013-01-26','13:20:00',2.45),('12374','2013-01-26','13:25:00',2.25),('12374','2013-01-26','13:30:00',2.12),('12374','2013-01-26','13:35:00',2.23),('12374','2013-01-26','13:40:00',2.18),('12374','2013-01-26','13:45:00',1.97),('12374','2013-01-26','13:50:00',1.94),('12374','2013-01-26','13:55:00',1.84),('12374','2013-01-26','14:00:00',1.66),('12374','2013-01-26','14:05:00',1.51),('12374','2013-01-26','14:10:00',1.47),('12374','2013-01-26','14:15:00',1.28),('12374','2013-01-26','14:45:00',1.01),('12374','2013-01-26','15:15:00',1.04),('12374','2013-01-26','15:20:00',1.07),('12374','2013-01-26','15:25:00',1.01),('12374','2013-01-25','08:05:00',1.13),('12374','2013-01-25','08:10:00',1.25),('12374','2013-01-25','08:15:00',1.27),('12374','2013-01-25','08:20:00',1.57),('12374','2013-01-25','08:25:00',1.78),('12374','2013-01-25','08:30:00',2.38),('12374','2013-01-25','08:35:00',2.91),('12374','2013-01-25','08:40:00',2.37),('12374','2013-01-25','08:45:00',2.9),('12374','2013-01-25','08:50:00',3.71),('12374','2013-01-25','08:55:00',3.61),('12374','2013-01-25','09:00:00',4.02),('12374','2013-01-25','09:05:00',4.56),('12374','2013-01-25','09:10:00',4.79),('12374','2013-01-25','09:15:00',4.96),('12374','2013-01-25','09:20:00',4.59),('12374','2013-01-25','09:25:00',4.71),('12374','2013-01-25','09:30:00',4.65),('12374','2013-01-25','09:35:00',3.66),('12374','2013-01-25','09:40:00',3.29),('12374','2013-01-25','09:45:00',3.53),('12374','2013-01-25','09:50:00',4.16),('12374','2013-01-25','09:55:00',4.68),('12374','2013-01-25','10:00:00',5.72),('12374','2013-01-25','10:05:00',5.97),('12374','2013-01-25','10:10:00',5.27),('12374','2013-01-25','10:15:00',3.81),('12374','2013-01-25','10:20:00',4.93),('12374','2013-01-25','10:25:00',5.88),('12374','2013-01-25','10:30:00',6.39),('12374','2013-01-25','10:35:00',5.71),('12374','2013-01-25','10:40:00',5.33),('12374','2013-01-25','10:45:00',4.93),('12374','2013-01-25','10:50:00',4.17),('12374','2013-01-25','10:55:00',3.07),('12374','2013-01-25','11:00:00',2.74),('12374','2013-01-25','11:05:00',3.65),('12374','2013-01-25','11:10:00',4.2),('12374','2013-01-25','11:15:00',3.83),('12374','2013-01-25','11:20:00',2.75),('12374','2013-01-25','11:25:00',3.01),('12374','2013-01-25','11:30:00',5.42),('12374','2013-01-25','11:35:00',7.1),('12374','2013-01-25','11:40:00',7.3),('12374','2013-01-25','11:45:00',7.15),('12374','2013-01-25','11:50:00',7.23),('12374','2013-01-25','11:55:00',7.26),('12374','2013-01-25','12:00:00',7.26),('12374','2013-01-25','12:05:00',7.21),('12374','2013-01-25','12:10:00',7.01),('12374','2013-01-25','12:15:00',7.28),('12374','2013-01-25','12:20:00',7.27),('12374','2013-01-25','12:25:00',7.25),('12374','2013-01-25','12:30:00',7.25),('12374','2013-01-25','12:35:00',7.17),('12374','2013-01-25','12:40:00',7.12),('12374','2013-01-25','12:45:00',7.09),('12374','2013-01-25','12:50:00',7.16),('12374','2013-01-25','12:55:00',7.1),('12374','2013-01-25','13:00:00',7.04),('12374','2013-01-25','13:05:00',7.07),('12374','2013-01-25','13:10:00',6.91),('12374','2013-01-25','13:15:00',6.5),('12374','2013-01-25','13:20:00',6.72),('12374','2013-01-25','13:25:00',6.7),('12374','2013-01-25','13:30:00',6.6),('12374','2013-01-25','13:35:00',6.55),('12374','2013-01-25','13:40:00',6.4),('12374','2013-01-25','13:45:00',6.26),('12374','2013-01-25','13:50:00',6.14),('12374','2013-01-25','13:55:00',6.08),('12374','2013-01-25','14:00:00',5.5),('12374','2013-01-25','14:05:00',5.45),('12374','2013-01-25','14:10:00',5.59),('12374','2013-01-25','14:15:00',5.46),('12374','2013-01-25','14:20:00',4.95),('12374','2013-01-25','14:25:00',4.9),('12374','2013-01-25','14:30:00',4.9),('12374','2013-01-25','14:35:00',4.81),('12374','2013-01-25','14:40:00',4.68),('12374','2013-01-25','14:45:00',4.65),('12374','2013-01-25','14:50:00',4.56),('12374','2013-01-25','14:55:00',4.52),('12374','2013-01-25','15:00:00',4.34),('12374','2013-01-25','15:05:00',4.28),('12374','2013-01-25','15:10:00',4.18),('12374','2013-01-25','15:15:00',4.07),('12374','2013-01-25','15:20:00',3.63),('12374','2013-01-25','15:25:00',3.79),('12374','2013-01-25','15:30:00',3.67),('12374','2013-01-25','15:35:00',3.65),('12374','2013-01-25','15:40:00',3.48),('12374','2013-01-25','15:45:00',2.87),('12374','2013-01-25','15:50:00',3.6),('12374','2013-01-25','15:55:00',3.21),('12374','2013-01-25','16:00:00',2.79),('12374','2013-01-25','16:05:00',1.6),('12374','2013-01-25','16:10:00',1.29),('12374','2013-01-25','16:15:00',1.21),('12374','2013-01-25','16:20:00',1),('12374','2013-01-24','08:45:00',1.11),('12374','2013-01-24','08:50:00',1.36),('12374','2013-01-24','08:55:00',1.86),('12374','2013-01-24','09:00:00',1.46),('12374','2013-01-24','09:05:00',1.3),('12374','2013-01-24','09:10:00',1.34),('12374','2013-01-24','09:15:00',1.51),('12374','2013-01-24','09:20:00',2.12),('12374','2013-01-24','09:25:00',3.84),('12374','2013-01-24','09:30:00',5.04),('12374','2013-01-24','09:35:00',5.36),('12374','2013-01-24','09:40:00',5.05),('12374','2013-01-24','09:45:00',5.79),('12374','2013-01-24','09:50:00',5.46),('12374','2013-01-24','09:55:00',4.99),('12374','2013-01-24','10:00:00',4.65),('12374','2013-01-24','10:05:00',4.13),('12374','2013-01-24','10:10:00',4.09),('12374','2013-01-24','10:15:00',5.81),('12374','2013-01-24','10:20:00',6.35),('12374','2013-01-24','10:25:00',6.43),('12374','2013-01-24','10:30:00',6.45),('12374','2013-01-24','10:35:00',6.49),('12374','2013-01-24','10:40:00',6.56),('12374','2013-01-24','10:45:00',6.55),('12374','2013-01-24','10:50:00',6.25),('12374','2013-01-24','10:55:00',5.86),('12374','2013-01-24','11:00:00',6.26),('12374','2013-01-24','11:05:00',6.68),('12374','2013-01-24','11:10:00',6.95),('12374','2013-01-24','11:15:00',6.65),('12374','2013-01-24','11:20:00',7.06),('12374','2013-01-24','11:25:00',7.34),('12374','2013-01-24','11:30:00',7.36),('12374','2013-01-24','11:35:00',7.58),('12374','2013-01-24','11:40:00',7.62),('12374','2013-01-24','11:45:00',6.76),('12374','2013-01-24','11:50:00',2.41),('12374','2013-01-24','11:55:00',1.55),('12374','2013-01-24','12:00:00',1.52),('12374','2013-01-24','12:05:00',1.5),('12374','2013-01-24','12:10:00',1.51),('12374','2013-01-24','12:15:00',1.54),('12374','2013-01-24','12:20:00',1.56),('12374','2013-01-24','12:25:00',1.57),('12374','2013-01-24','12:30:00',1.62),('12374','2013-01-24','12:35:00',1.66),('12374','2013-01-24','12:40:00',1.74),('12374','2013-01-24','12:45:00',1.85),('12374','2013-01-24','12:50:00',1.98),('12374','2013-01-24','12:55:00',2.16),('12374','2013-01-24','13:00:00',2.33),('12374','2013-01-24','13:05:00',2.62),('12374','2013-01-24','13:10:00',2.78),('12374','2013-01-24','13:15:00',2.93),('12374','2013-01-24','13:20:00',7.12),('12374','2013-01-24','13:25:00',7.21),('12374','2013-01-24','13:30:00',6.89),('12374','2013-01-24','13:35:00',7.31),('12374','2013-01-24','13:40:00',7.17),('12374','2013-01-24','13:45:00',6.3),('12374','2013-01-24','13:50:00',5.68),('12374','2013-01-24','13:55:00',3.49),('12374','2013-01-24','14:00:00',2.48),('12374','2013-01-24','14:05:00',3.68),('12374','2013-01-24','14:10:00',4.22),('12374','2013-01-24','14:15:00',6.42),('12374','2013-01-24','14:20:00',6.37),('12374','2013-01-24','14:25:00',6.14),('12374','2013-01-24','14:30:00',5.15),('12374','2013-01-24','14:35:00',3.81),('12374','2013-01-24','14:40:00',2.98),('12374','2013-01-24','14:45:00',2.47),('12374','2013-01-24','14:50:00',1.93),('12374','2013-01-24','14:55:00',2.16),('12374','2013-01-24','15:00:00',3.08),('12374','2013-01-24','15:05:00',4.43),('12374','2013-01-24','15:10:00',5.22),('12374','2013-01-24','15:15:00',5),('12374','2013-01-24','15:20:00',4.72),('12374','2013-01-24','15:25:00',4.4),('12374','2013-01-24','15:30:00',4),('12374','2013-01-24','15:35:00',3.28),('12374','2013-01-24','15:40:00',2.36),('12374','2013-01-24','15:45:00',2.42),('12374','2013-01-24','15:55:00',1.12),('12374','2013-01-24','16:00:00',1.95),('12374','2013-01-24','16:05:00',2.86),('12374','2013-01-24','16:10:00',1.96),('12374','2013-01-23','08:45:00',2.45),('12374','2013-01-23','08:50:00',2.79),('12374','2013-01-23','08:55:00',3.34),('12374','2013-01-23','09:00:00',3.3),('12374','2013-01-23','09:05:00',4.1),('12374','2013-01-23','09:10:00',4.58),('12374','2013-01-23','09:15:00',3.22),('12374','2013-01-23','09:20:00',2.43),('12374','2013-01-23','09:25:00',2.62),('12374','2013-01-23','09:30:00',2.02),('12374','2013-01-23','09:35:00',1.62),('12374','2013-01-23','09:50:00',1.01),('12374','2013-01-23','09:55:00',1.03),('12374','2013-01-23','10:35:00',1.19),('12374','2013-01-23','10:40:00',1.91),('12374','2013-01-23','10:45:00',2.1),('12374','2013-01-23','10:50:00',1.95),('12374','2013-01-23','10:55:00',1.11),('12374','2013-01-23','11:10:00',1.1),('12374','2013-01-23','11:40:00',1.44),('12374','2013-01-23','11:45:00',1.53),('12374','2013-01-23','11:50:00',1.29),('12374','2013-01-23','11:55:00',1.22),('12374','2013-01-23','12:15:00',1.48),('12374','2013-01-23','12:20:00',2.21),('12374','2013-01-23','12:25:00',2.42),('12374','2013-01-23','12:30:00',1.8),('12374','2013-01-23','13:10:00',1.06),('12374','2013-01-22','08:25:00',1.45),('12374','2013-01-22','08:30:00',1.56),('12374','2013-01-22','08:35:00',1.1),('12374','2013-01-22','08:40:00',1.2),('12374','2013-01-22','09:00:00',1.03),('12374','2013-01-22','09:10:00',1.12),('12374','2013-01-22','09:25:00',1.95),('12374','2013-01-22','09:30:00',2.98),('12374','2013-01-22','09:35:00',4.34),('12374','2013-01-22','09:40:00',4.28),('12374','2013-01-22','09:45:00',2.47),('12374','2013-01-22','09:50:00',3.33),('12374','2013-01-22','09:55:00',5.23),('12374','2013-01-22','10:00:00',5.62),('12374','2013-01-22','10:05:00',5.87),('12374','2013-01-22','10:10:00',7.05),('12374','2013-01-22','10:15:00',3.57),('12374','2013-01-22','10:20:00',1.82),('12374','2013-01-22','10:25:00',3.7),('12374','2013-01-22','10:30:00',2.79),('12374','2013-01-22','10:35:00',2.9),('12374','2013-01-22','10:40:00',3.14),('12374','2013-01-22','10:45:00',4.68),('12374','2013-01-22','10:50:00',3.62),('12374','2013-01-22','10:55:00',1.96),('12374','2013-01-22','11:00:00',2.74),('12374','2013-01-22','11:05:00',2.28),('12374','2013-01-22','11:10:00',6.28),('12374','2013-01-22','11:15:00',7.13),('12374','2013-01-22','11:20:00',3.67),('12374','2013-01-22','11:25:00',4.99),('12374','2013-01-22','11:30:00',4.09),('12374','2013-01-22','11:35:00',3.12),('12374','2013-01-22','11:40:00',7.21),('12374','2013-01-22','11:45:00',4.67),('12374','2013-01-22','11:50:00',4.67),('12374','2013-01-22','11:55:00',2.95),('12374','2013-01-22','12:00:00',3.44),('12374','2013-01-22','12:05:00',8.04),('12374','2013-01-22','12:10:00',5.32),('12374','2013-01-22','12:15:00',2.48),('12374','2013-01-22','12:20:00',6.38),('12374','2013-01-22','12:25:00',7.38),('12374','2013-01-22','12:30:00',6.2),('12374','2013-01-22','12:35:00',7.27),('12374','2013-01-22','12:40:00',7.29),('12374','2013-01-22','12:45:00',7.71),('12374','2013-01-22','12:50:00',5.39),('12374','2013-01-22','12:55:00',7.37),('12374','2013-01-22','13:00:00',7.34),('12374','2013-01-22','13:05:00',7.36),('12374','2013-01-22','13:10:00',7.04),('12374','2013-01-22','13:15:00',7.05),('12374','2013-01-22','13:20:00',6.83),('12374','2013-01-22','13:25:00',5.27),('12374','2013-01-22','13:30:00',3.11),('12374','2013-01-22','13:35:00',7.68),('12374','2013-01-22','13:40:00',6.72),('12374','2013-01-22','13:45:00',5.9),('12374','2013-01-22','13:50:00',5.4),('12374','2013-01-22','13:55:00',5.54),('12374','2013-01-22','14:00:00',5.32),('12374','2013-01-22','14:05:00',6.43),('12374','2013-01-22','14:10:00',2.9),('12374','2013-01-22','14:15:00',3.07),('12374','2013-01-22','14:20:00',5.17),('12374','2013-01-22','14:26:00',6.3),('12374','2013-01-22','14:30:00',2.74),('12374','2013-01-22','14:35:00',1.73),('12374','2013-01-22','14:45:00',1.66),('12374','2013-01-22','15:00:00',1.16),('12374','2013-01-21','09:30:00',1.07),('12374','2013-01-21','09:35:00',1.42),('12374','2013-01-21','09:40:00',1.2),('12374','2013-01-21','10:00:00',1.2),('12374','2013-01-21','10:05:00',1.36),('12374','2013-01-21','10:10:00',1.25),('12374','2013-01-21','10:15:00',1.45),('12374','2013-01-21','10:20:00',2.01),('12374','2013-01-21','10:25:00',2.5),('12374','2013-01-21','10:30:00',2.35),('12374','2013-01-21','10:35:00',1.55),('12374','2013-01-21','10:40:00',1.25),('12374','2013-01-21','10:45:00',1.3),('12374','2013-01-21','10:50:00',1.2),('12374','2013-01-21','10:55:00',1.44),('12374','2013-01-21','11:00:00',1.83),('12374','2013-01-21','11:05:00',1.84),('12374','2013-01-21','11:10:00',2.91),('12374','2013-01-21','11:15:00',2),('12374','2013-01-21','11:20:00',6.09),('12374','2013-01-21','11:25:00',6.58),('12374','2013-01-21','11:30:00',6.63),('12374','2013-01-21','11:35:00',6.62),('12374','2013-01-21','11:40:00',6.54),('12374','2013-01-21','11:45:00',5.67),('12374','2013-01-21','11:50:00',6.95),('12374','2013-01-21','11:55:00',6.95),('12374','2013-01-21','12:00:00',3.79),('12374','2013-01-21','12:05:00',2.24),('12374','2013-01-21','12:10:00',2.26),('12374','2013-01-21','12:15:00',3.42),('12374','2013-01-21','12:20:00',3.29),('12374','2013-01-21','12:25:00',3.63),('12374','2013-01-21','12:30:00',3.54),('12374','2013-01-21','12:35:00',2.39),('12374','2013-01-21','12:40:00',1.39),('12374','2013-01-21','12:45:00',1.32),('12374','2013-01-21','12:50:00',1.34),('12374','2013-01-21','12:55:00',2.27),('12374','2013-01-21','13:05:00',1.73),('12374','2013-01-21','13:10:00',6.05),('12374','2013-01-21','13:15:00',6.94),('12374','2013-01-21','13:20:00',6.66),('12374','2013-01-21','13:25:00',4.72),('12374','2013-01-21','13:30:00',5.74),('12374','2013-01-21','13:35:00',6.3),('12374','2013-01-21','13:40:00',6.36),('12374','2013-01-21','13:45:00',5.03),('12374','2013-01-21','13:50:00',5.51),('12374','2013-01-21','13:55:00',6.05),('12374','2013-01-21','14:00:00',5.9),('12374','2013-01-21','14:05:00',5.19),('12374','2013-01-21','14:10:00',4),('12374','2013-01-21','14:20:00',1.56),('12374','2013-01-21','14:25:00',1.36),('12374','2013-01-21','14:40:00',1.3),('12374','2013-01-21','14:45:00',1.63),('12374','2013-01-21','14:50:00',1.28),('12374','2013-01-21','14:55:00',1.25),('12374','2013-01-21','15:00:00',1.96),('12374','2013-01-21','15:05:00',5.36),('12374','2013-01-21','15:10:00',3.31),('12374','2013-01-21','15:15:00',3),('12374','2013-01-21','15:20:00',1.49),('12374','2013-01-20','10:30:00',1.08),('12374','2013-01-20','10:35:00',1.15),('12374','2013-01-20','10:40:00',1.37),('12374','2013-01-20','10:45:00',1.21),('12374','2013-01-20','10:50:00',1.2),('12374','2013-01-20','11:05:00',1.04),('12374','2013-01-20','11:10:00',1.03),('12374','2013-01-20','11:20:00',1.11),('12374','2013-01-20','11:25:00',1.27),('12374','2013-01-20','11:30:00',1.17),('12374','2013-01-20','11:35:00',1.21),('12374','2013-01-20','11:40:00',1.17),('12374','2013-01-20','11:45:00',1.14),('12374','2013-01-20','11:55:00',1.01),('12374','2013-01-20','12:00:00',1.03),('12374','2013-01-20','12:15:00',1.09),('12374','2013-01-20','12:20:00',1.05),('12374','2013-01-20','12:25:00',1.1),('12374','2013-01-20','12:30:00',1.12),('12374','2013-01-20','12:35:00',1.11),('12374','2013-01-20','12:40:00',1.14),('12374','2013-01-20','12:45:00',1.21),('12374','2013-01-20','12:50:00',1.26),('12374','2013-01-20','12:55:00',1.16),('12374','2013-01-20','13:15:00',1.01),('12374','2013-01-20','13:20:00',1.13),('12374','2013-01-20','13:25:00',1.43),('12374','2013-01-20','13:30:00',1.46),('12374','2013-01-20','13:35:00',1.31),('12374','2013-01-20','13:40:00',1.24),('12374','2013-01-20','13:45:00',1.26),('12374','2013-01-20','13:50:00',1.16),('12374','2013-01-20','13:55:00',1.1),('12374','2013-01-19','08:50:00',1.2),('12374','2013-01-19','08:55:00',1.44),('12374','2013-01-19','09:00:00',1.52),('12374','2013-01-19','09:05:00',1.08),('12374','2013-01-19','09:25:00',1.22),('12374','2013-01-19','09:30:00',1.67),('12374','2013-01-19','09:35:00',2.24),('12374','2013-01-19','09:40:00',2.52),('12374','2013-01-19','09:45:00',2.08),('12374','2013-01-19','09:50:00',1.33),('12374','2013-01-19','10:15:00',1.35),('12374','2013-01-19','10:20:00',1.43),('12374','2013-01-19','10:25:00',1.17),('12374','2013-01-19','10:50:00',1.01),('12374','2013-01-19','10:55:00',1.41),('12374','2013-01-19','11:00:00',1.57),('12374','2013-01-19','11:05:00',1.63),('12374','2013-01-19','11:10:00',1.5),('12374','2013-01-19','11:15:00',1.18),('12374','2013-01-19','11:20:00',1.09),('12374','2013-01-19','11:25:00',1.21),('12374','2013-01-19','11:30:00',1.07),('12374','2013-01-19','11:35:00',1.11),('12374','2013-01-19','11:40:00',1.53),('12374','2013-01-19','11:45:00',1.69),('12374','2013-01-19','11:50:00',1.5),('12374','2013-01-19','11:55:00',1.22),('12374','2013-01-19','12:00:00',1.18),('12374','2013-01-19','14:05:00',1.32),('12374','2013-01-19','14:10:00',1.14),('12374','2013-01-19','14:45:00',1.06),('12374','2013-01-19','14:50:00',1.04),('12374','2013-01-18','09:35:00',1),('12374','2013-01-18','09:40:00',1.19),('12374','2013-01-18','09:45:00',1.27),('12374','2013-01-18','09:50:00',1.29),('12374','2013-01-18','09:55:00',1.6),('12374','2013-01-18','10:00:00',2.63),('12374','2013-01-18','10:05:00',2.77),('12374','2013-01-18','10:10:00',1.83),('12374','2013-01-18','10:15:00',1.44),('12374','2013-01-18','10:20:00',1.11),('12374','2013-01-18','10:25:00',1.01),('12374','2013-01-18','10:30:00',1.12),('12374','2013-01-18','10:35:00',1.38),('12374','2013-01-18','10:40:00',1.55),('12374','2013-01-18','10:45:00',1.73),('12374','2013-01-18','10:50:00',1.98),('12374','2013-01-18','10:55:00',2.12),('12374','2013-01-18','11:00:00',2.49),('12374','2013-01-18','11:05:00',3.15),('12374','2013-01-18','11:10:00',2.92),('12374','2013-01-18','11:15:00',2.78),('12374','2013-01-18','11:20:00',2.47),('12374','2013-01-18','11:25:00',2.63),('12374','2013-01-18','11:30:00',2.72),('12374','2013-01-18','11:35:00',2.72),('12374','2013-01-18','11:40:00',2.85),('12374','2013-01-18','11:45:00',3.09),('12374','2013-01-18','11:50:00',3.63),('12374','2013-01-18','11:55:00',4.42),('12374','2013-01-18','12:00:00',3.97),('12374','2013-01-18','12:05:00',4.3),('12374','2013-01-18','12:10:00',4.97),('12374','2013-01-18','12:15:00',4.51),('12374','2013-01-18','12:20:00',4.07),('12374','2013-01-18','12:25:00',5.51),('12374','2013-01-18','12:30:00',3.38),('12374','2013-01-18','12:35:00',3.48),('12374','2013-01-18','12:40:00',3.08),('12374','2013-01-18','12:45:00',3.13),('12374','2013-01-18','12:50:00',3.74),('12374','2013-01-18','12:55:00',3.35),('12374','2013-01-18','13:00:00',4.69),('12374','2013-01-18','13:05:00',4.72),('12374','2013-01-18','13:10:00',3.72),('12374','2013-01-18','13:15:00',3.63),('12374','2013-01-18','13:20:00',3.4),('12374','2013-01-18','13:25:00',2.75),('12374','2013-01-18','13:30:00',5.26),('12374','2013-01-18','13:35:00',6.38),('12374','2013-01-18','13:40:00',6.21),('12374','2013-01-18','13:45:00',6.12),('12374','2013-01-18','13:50:00',5.92),('12374','2013-01-18','13:55:00',5.74),('12374','2013-01-18','14:00:00',5.63),('12374','2013-01-18','14:05:00',5.66),('12374','2013-01-18','14:10:00',6),('12374','2013-01-18','14:15:00',6.26),('12374','2013-01-18','14:20:00',6.3),('12374','2013-01-18','14:25:00',3.45),('12374','2013-01-18','14:30:00',5.47),('12374','2013-01-18','14:35:00',3.12),('12374','2013-01-18','14:40:00',2.95),('12374','2013-01-18','14:45:00',2.9),('12374','2013-01-18','14:50:00',2.45),('12374','2013-01-18','14:55:00',1.96),('12374','2013-01-18','15:00:00',1.98),('12374','2013-01-18','15:05:00',3.02),('12374','2013-01-18','15:10:00',3.47),('12374','2013-01-18','15:15:00',3.68),('12374','2013-01-18','15:20:00',4.06),('12374','2013-01-18','15:25:00',3.74),('12374','2013-01-18','15:30:00',3.75),('12374','2013-01-18','15:35:00',3.45),('12374','2013-01-18','15:40:00',3.16),('12374','2013-01-18','15:45:00',2.71),('12374','2013-01-18','15:50:00',2.44),('12374','2013-01-18','15:55:00',2.22),('12374','2013-01-18','16:00:00',2.12),('12374','2013-01-18','16:05:00',1.93),('12374','2013-01-18','16:10:00',1.76),('12374','2013-01-18','16:15:00',1.57),('12374','2013-01-18','16:20:00',1.4),('12374','2013-01-18','16:25:00',1.26),('12374','2013-01-18','16:30:00',1.15),('12374','2013-01-17','09:10:00',1),('12374','2013-01-17','09:15:00',1.2),('12374','2013-01-17','09:20:00',1.66),('12374','2013-01-17','09:25:00',1.95),('12374','2013-01-17','09:30:00',2.1),('12374','2013-01-17','09:35:00',2.12),('12374','2013-01-17','09:40:00',2.25),('12374','2013-01-17','09:45:00',2.39),('12374','2013-01-17','09:50:00',2.29),('12374','2013-01-17','09:55:00',2.16),('12374','2013-01-17','10:00:00',2.21),('12374','2013-01-17','10:05:00',2.56),('12374','2013-01-17','10:10:00',2.78),('12374','2013-01-17','10:15:00',2.98),('12374','2013-01-17','10:20:00',3.09),('12374','2013-01-17','10:25:00',3.05),('12374','2013-01-17','10:30:00',4.02),('12374','2013-01-17','10:35:00',3.8),('12374','2013-01-17','10:40:00',3.49),('12374','2013-01-17','10:45:00',3.57),('12374','2013-01-17','10:50:00',3.87),('12374','2013-01-17','10:55:00',5.46),('12374','2013-01-17','11:00:00',6.3),('12374','2013-01-17','11:05:00',5.23),('12374','2013-01-17','11:10:00',5.58),('12374','2013-01-17','11:15:00',5.41),('12374','2013-01-17','11:20:00',4.79),('12374','2013-01-17','11:25:00',4.38),('12374','2013-01-17','11:30:00',5.37),('12374','2013-01-17','11:35:00',5.34),('12374','2013-01-17','11:40:00',5.2),('12374','2013-01-17','11:45:00',5.42),('12374','2013-01-17','11:50:00',5.16),('12374','2013-01-17','11:55:00',5.67),('12374','2013-01-17','12:00:00',5.73),('12374','2013-01-17','12:05:00',4.98),('12374','2013-01-17','12:10:00',3.44),('12374','2013-01-17','12:15:00',5.28),('12374','2013-01-17','12:20:00',5.54),('12374','2013-01-17','12:25:00',5.09),('12374','2013-01-17','12:30:00',5.58),('12374','2013-01-17','12:35:00',3.03),('12374','2013-01-17','12:40:00',1.71),('12374','2013-01-17','12:45:00',4.34),('12374','2013-01-17','12:50:00',4.38),('12374','2013-01-17','12:55:00',3.58),('12374','2013-01-17','13:00:00',4.94),('12374','2013-01-17','13:05:00',4.27),('12374','2013-01-17','13:10:00',4.15),('12374','2013-01-17','13:15:00',5.55),('12374','2013-01-17','13:20:00',4.7),('12374','2013-01-17','13:25:00',1.49),('12374','2013-01-17','13:30:00',2.83),('12374','2013-01-17','13:35:00',4.27),('12374','2013-01-17','13:40:00',3.23),('12374','2013-01-17','13:45:00',2.57),('12374','2013-01-17','13:50:00',5.23),('12374','2013-01-17','13:55:00',3.49),('12374','2013-01-17','14:00:00',2.45),('12374','2013-01-17','14:05:00',5.64),('12374','2013-01-17','14:10:00',6.07),('12374','2013-01-17','14:15:00',4.37),('12374','2013-01-17','14:20:00',2.49),('12374','2013-01-17','14:25:00',2.02),('12374','2013-01-17','14:30:00',1.89),('12374','2013-01-17','14:35:00',1.82),('12374','2013-01-17','14:40:00',1.65),('12374','2013-01-17','14:45:00',1.7),('12374','2013-01-17','14:50:00',1.78),('12374','2013-01-17','14:55:00',1.66),('12374','2013-01-17','15:00:00',1.43),('12374','2013-01-17','15:05:00',1.41),('12374','2013-01-17','15:10:00',1.26),('12374','2013-01-17','15:15:00',1.17),('12374','2013-01-16','08:45:00',1.34),('12374','2013-01-16','08:50:00',1.23),('12374','2013-01-16','08:55:00',1.03),('12374','2013-01-16','09:05:00',1.24),('12374','2013-01-16','09:20:00',1.14),('12374','2013-01-16','09:50:00',3.83),('12374','2013-01-16','09:55:00',3.3),('12374','2013-01-16','10:10:00',4.64),('12374','2013-01-16','10:15:00',6.78),('12374','2013-01-16','10:20:00',4.23),('12374','2013-01-16','10:25:00',4.16),('12374','2013-01-16','10:30:00',4.98),('12374','2013-01-16','10:35:00',4.67),('12374','2013-01-16','10:50:00',1.16),('12374','2013-01-16','10:55:00',1.56),('12374','2013-01-16','11:00:00',1.85),('12374','2013-01-16','11:05:00',2.82),('12374','2013-01-16','11:10:00',1.76),('12374','2013-01-16','11:15:00',1.89),('12374','2013-01-16','11:20:00',1.9),('12374','2013-01-16','11:25:00',1.75),('12374','2013-01-16','11:30:00',1.71),('12374','2013-01-16','11:35:00',1.53),('12374','2013-01-16','11:40:00',1.66),('12374','2013-01-16','11:45:00',1.06),('12374','2013-01-16','11:50:00',1.04),('12374','2013-01-16','11:55:00',2.48),('12374','2013-01-16','12:15:00',1.66),('12374','2013-01-16','12:20:00',1.23),('12374','2013-01-16','13:00:00',2.69),('12374','2013-01-16','13:35:00',1.14),('12374','2013-01-16','13:40:00',1.16),('12374','2013-01-16','13:45:00',1.35),('12374','2013-01-16','13:50:00',1.48),('12374','2013-01-16','14:10:00',2.35),('12374','2013-01-16','14:15:00',3.76),('12374','2013-01-16','14:20:00',1.58),('12374','2013-01-16','14:25:00',1.22),('12374','2013-01-16','14:30:00',1.8),('12374','2013-01-16','14:35:00',3.78),('12374','2013-01-16','14:40:00',2.47),('12374','2013-01-16','14:45:00',1.26),('12374','2013-01-16','15:20:00',2.88),('12374','2013-01-16','15:25:00',4.02),('12374','2013-01-16','15:30:00',2.79),('12374','2013-01-16','15:40:00',1.52),('12374','2013-01-16','15:45:00',2.63),('12374','2013-01-16','15:50:00',2.61),('12374','2013-01-16','15:55:00',2.01),('12374','2013-01-15','08:35:00',1.61),('12374','2013-01-15','08:40:00',2.18),('12374','2013-01-15','08:45:00',2.59),('12374','2013-01-15','08:50:00',2.9),('12374','2013-01-15','08:55:00',2.81),('12374','2013-01-15','09:00:00',3.23),('12374','2013-01-15','09:05:00',3.25),('12374','2013-01-15','09:10:00',3.6),('12374','2013-01-15','09:15:00',3.73),('12374','2013-01-15','09:20:00',3.87),('12374','2013-01-15','09:25:00',4.02),('12374','2013-01-15','09:30:00',4.21),('12374','2013-01-15','09:35:00',4.43),('12374','2013-01-15','09:40:00',4.58),('12374','2013-01-15','09:45:00',4.77),('12374','2013-01-15','09:50:00',2.85),('12374','2013-01-15','09:55:00',1.11),('12374','2013-01-15','10:00:00',3.66),('12374','2013-01-15','10:05:00',3.16),('12374','2013-01-15','10:15:00',1.49),('12374','2013-01-15','10:20:00',2.79),('12374','2013-01-15','10:25:00',2.98),('12374','2013-01-15','10:30:00',2.65),('12374','2013-01-15','10:35:00',5.94),('12374','2013-01-15','10:40:00',5.06),('12374','2013-01-15','10:45:00',4.97),('12374','2013-01-15','10:50:00',5.63),('12374','2013-01-15','10:55:00',3.71),('12374','2013-01-15','11:00:00',3.18),('12374','2013-01-15','11:05:00',2.67),('12374','2013-01-15','11:10:00',3.43),('12374','2013-01-15','11:15:00',3.89),('12374','2013-01-15','11:20:00',3.76),('12374','2013-01-15','11:25:00',4.22),('12374','2013-01-15','11:30:00',4.12),('12374','2013-01-15','11:35:00',4.44),('12374','2013-01-15','11:40:00',4.81),('12374','2013-01-15','11:45:00',5.8),('12374','2013-01-15','11:50:00',5.15),('12374','2013-01-15','11:55:00',4.11),('12374','2013-01-15','12:00:00',3.27),('12374','2013-01-15','12:05:00',3.08),('12374','2013-01-15','12:10:00',3.39),('12374','2013-01-15','12:15:00',3.28),('12374','2013-01-15','12:20:00',3.29),('12374','2013-01-15','12:25:00',3.2),('12374','2013-01-15','12:30:00',3.32),('12374','2013-01-15','12:35:00',3.4),('12374','2013-01-15','12:40:00',3.52),('12374','2013-01-15','12:45:00',3.51),('12374','2013-01-15','12:50:00',3.66),('12374','2013-01-15','12:55:00',3.41),('12374','2013-01-15','13:00:00',3.75),('12374','2013-01-15','13:05:00',3.74),('12374','2013-01-15','13:10:00',3.93),('12374','2013-01-15','13:15:00',4.28),('12374','2013-01-15','13:20:00',3.62),('12374','2013-01-15','13:25:00',3.95),('12374','2013-01-15','13:30:00',4.19),('12374','2013-01-15','13:35:00',5.54),('12374','2013-01-15','13:40:00',5.17),('12374','2013-01-15','13:45:00',5.47),('12374','2013-01-15','13:50:00',4.85),('12374','2013-01-15','13:55:00',4.28),('12374','2013-01-15','14:00:00',4.09),('12374','2013-01-15','14:05:00',2.38),('12374','2013-01-15','14:10:00',1.86),('12374','2013-01-15','14:15:00',2.47),('12374','2013-01-15','14:20:00',3.88),('12374','2013-01-15','14:25:00',6.36),('12374','2013-01-15','14:30:00',4.99),('12374','2013-01-15','14:35:00',4.72),('12374','2013-01-15','14:40:00',4.64),('12374','2013-01-15','14:45:00',4.25),('12374','2013-01-15','14:50:00',4.43),('12374','2013-01-15','14:55:00',4.31),('12374','2013-01-15','15:00:00',4.11),('12374','2013-01-15','15:05:00',4.05),('12374','2013-01-15','15:10:00',4.06),('12374','2013-01-15','15:15:00',3.9),('12374','2013-01-15','15:20:00',3.72),('12374','2013-01-15','15:25:00',3.59),('12374','2013-01-15','15:30:00',3.67),('12374','2013-01-15','15:35:00',3.48),('12374','2013-01-15','15:40:00',3.09),('12374','2013-01-15','15:45:00',2.94),('12374','2013-01-15','15:50:00',2.72),('12374','2013-01-15','15:55:00',2.69),('12374','2013-01-15','16:00:00',2.57),('12374','2013-01-15','16:05:00',2.41),('12374','2013-01-15','16:10:00',2.24),('12374','2013-01-15','16:15:00',2.02),('12374','2013-01-15','16:20:00',1.77),('12374','2013-01-15','16:25:00',1.57),('12374','2013-01-15','16:30:00',1.29),('12374','2013-01-14','11:00:00',1.08),('12374','2013-01-14','11:05:00',1.05),('12374','2013-01-14','14:05:00',1.13),('12374','2013-01-13','08:50:00',1.02),('12374','2013-01-13','08:55:00',1.12),('12374','2013-01-13','09:35:00',1.23),('12374','2013-01-13','09:40:00',1.74),('12374','2013-01-13','09:45:00',1.63),('12374','2013-01-13','09:50:00',1.42),('12374','2013-01-13','09:55:00',3.15),('12374','2013-01-13','10:00:00',3.66),('12374','2013-01-13','10:05:00',5.84),('12374','2013-01-13','10:10:00',6.49),('12374','2013-01-13','10:15:00',2.35),('12374','2013-01-13','10:40:00',1.02),('12374','2013-01-13','10:45:00',1.05),('12374','2013-01-13','10:55:00',1.16),('12374','2013-01-13','11:10:00',1.7),('12374','2013-01-13','11:15:00',1.62),('12374','2013-01-13','11:55:00',1.02),('12374','2013-01-12','08:15:00',1.09),('12374','2013-01-12','08:20:00',1.33),('12374','2013-01-12','08:25:00',1.58),('12374','2013-01-12','08:30:00',1.8),('12374','2013-01-12','08:35:00',2.03),('12374','2013-01-12','08:40:00',2.24),('12374','2013-01-12','08:45:00',2.47),('12374','2013-01-12','08:50:00',2.47),('12374','2013-01-12','08:55:00',2.88),('12374','2013-01-12','09:00:00',2.86),('12374','2013-01-12','09:05:00',3.27),('12374','2013-01-12','09:10:00',3.47),('12374','2013-01-12','09:15:00',3.63),('12374','2013-01-12','09:20:00',3.76),('12374','2013-01-12','09:25:00',3.86),('12374','2013-01-12','09:30:00',4.07),('12374','2013-01-12','09:35:00',4.22),('12374','2013-01-12','09:40:00',4.37),('12374','2013-01-12','09:45:00',4.49),('12374','2013-01-12','09:50:00',4.63),('12374','2013-01-12','09:55:00',4.76),('12374','2013-01-12','10:00:00',4.88),('12374','2013-01-12','10:05:00',5),('12374','2013-01-12','10:10:00',5.13),('12374','2013-01-12','10:15:00',5.25),('12374','2013-01-12','10:20:00',5.36),('12374','2013-01-12','10:25:00',5.44),('12374','2013-01-12','10:30:00',5.54),('12374','2013-01-12','10:35:00',5.65),('12374','2013-01-12','10:40:00',5.68),('12374','2013-01-12','10:45:00',5.78),('12374','2013-01-12','10:50:00',5.86),('12374','2013-01-12','10:55:00',5.92),('12374','2013-01-12','11:00:00',6.02),('12374','2013-01-12','11:05:00',6.1),('12374','2013-01-12','11:10:00',6.14),('12374','2013-01-12','11:15:00',6.21),('12374','2013-01-12','11:20:00',6.26),('12374','2013-01-12','11:25:00',6.28),('12374','2013-01-12','11:30:00',6.3),('12374','2013-01-12','11:35:00',6.32),('12374','2013-01-12','11:40:00',6.34),('12374','2013-01-12','11:45:00',6.36),('12374','2013-01-12','11:50:00',6.39),('12374','2013-01-12','11:55:00',6.42),('12374','2013-01-12','12:00:00',6.46),('12374','2013-01-12','12:05:00',6.41),('12374','2013-01-12','12:10:00',6.4),('12374','2013-01-12','12:15:00',6.37),('12374','2013-01-12','12:20:00',6.36),('12374','2013-01-12','12:25:00',6.34),('12374','2013-01-12','12:30:00',6.3),('12374','2013-01-12','12:35:00',6.29),('12374','2013-01-12','12:40:00',6.34),('12374','2013-01-12','12:45:00',6.32),('12374','2013-01-12','12:50:00',6.17),('12374','2013-01-12','12:55:00',6.08),('12374','2013-01-12','13:00:00',6.12),('12374','2013-01-12','13:05:00',6.22),('12374','2013-01-12','13:10:00',6.3),('12374','2013-01-12','13:15:00',6.23),('12374','2013-01-12','13:20:00',6.14),('12374','2013-01-12','13:25:00',5.92),('12374','2013-01-12','13:30:00',5.88),('12374','2013-01-12','13:35:00',5.76),('12374','2013-01-12','13:40:00',5.65),('12374','2013-01-12','13:45:00',5.52),('12374','2013-01-12','13:50:00',5.39),('12374','2013-01-12','13:55:00',5.37),('12374','2013-01-12','14:00:00',5.31),('12374','2013-01-12','14:05:00',5.25),('12374','2013-01-12','14:10:00',5.12),('12374','2013-01-12','14:15:00',5.05),('12374','2013-01-12','14:20:00',4.92),('12374','2013-01-12','14:25:00',4.67),('12374','2013-01-12','14:30:00',4.64),('12374','2013-01-12','14:35:00',4.55),('12374','2013-01-12','14:40:00',4.38),('12374','2013-01-12','14:45:00',4.2),('12374','2013-01-12','14:50:00',4.05),('12374','2013-01-12','14:55:00',3.98),('12374','2013-01-12','15:00:00',3.82),('12374','2013-01-12','15:05:00',3.65),('12374','2013-01-12','15:10:00',3.51),('12374','2013-01-12','15:15:00',3.38),('12374','2013-01-12','15:20:00',3.25),('12374','2013-01-12','15:25:00',3.09),('12374','2013-01-12','15:30:00',2.94),('12374','2013-01-12','15:35:00',2.77),('12374','2013-01-12','15:40:00',2.56),('12374','2013-01-12','15:45:00',2.38),('12374','2013-01-12','15:50:00',2.14),('12374','2013-01-12','15:55:00',1.85),('12374','2013-01-11','09:15:00',1.11),('12374','2013-01-11','09:20:00',2.56),('12374','2013-01-11','09:25:00',3.63),('12374','2013-01-11','09:30:00',3.67),('12374','2013-01-11','09:35:00',3.8),('12374','2013-01-11','09:40:00',1.49),('12374','2013-01-11','09:45:00',1.94),('12374','2013-01-11','09:50:00',3.85),('12374','2013-01-11','09:55:00',4.29),('12374','2013-01-11','10:00:00',4.37),('12374','2013-01-11','10:05:00',4.22),('12374','2013-01-11','10:10:00',4.38),('12374','2013-01-11','10:15:00',4.7),('12374','2013-01-11','10:20:00',4.64),('12374','2013-01-11','10:25:00',4.93),('12374','2013-01-11','10:30:00',5.09),('12374','2013-01-11','10:35:00',4.91),('12374','2013-01-11','10:40:00',5.01),('12374','2013-01-11','10:45:00',5.16),('12374','2013-01-11','10:50:00',5.42),('12374','2013-01-11','10:55:00',5.43),('12374','2013-01-11','11:00:00',5.56),('12374','2013-01-11','11:05:00',5.71),('12374','2013-01-11','11:10:00',5.91),('12374','2013-01-11','11:15:00',5.28),('12374','2013-01-11','11:20:00',3.14),('12374','2013-01-11','11:25:00',2.85),('12374','2013-01-11','11:30:00',2.28),('12374','2013-01-11','11:35:00',1.99),('12374','2013-01-11','11:40:00',1.77),('12374','2013-01-11','11:45:00',1.98),('12374','2013-01-11','11:50:00',2.03),('12374','2013-01-11','11:55:00',1.84),('12374','2013-01-11','12:00:00',1.22),('12374','2013-01-11','12:05:00',1.04),('12374','2013-01-11','12:15:00',1.27),('12374','2013-01-11','12:20:00',1.61),('12374','2013-01-11','12:25:00',2.46),('12374','2013-01-11','12:30:00',2.32),('12374','2013-01-11','12:35:00',2.16),('12374','2013-01-11','12:40:00',1.9),('12374','2013-01-11','12:45:00',1.28),('12374','2013-01-11','13:10:00',1.27),('12374','2013-01-11','13:15:00',5.57),('12374','2013-01-11','13:20:00',4.22),('12374','2013-01-11','13:25:00',4.58),('12374','2013-01-11','13:30:00',3.28),('12374','2013-01-11','13:35:00',4.19),('12374','2013-01-11','13:40:00',2),('12374','2013-01-11','14:15:00',2.32),('12374','2013-01-11','14:20:00',3.92),('12374','2013-01-11','14:25:00',3.59),('12374','2013-01-11','14:30:00',3.75),('12374','2013-01-11','14:35:00',3.62),('12374','2013-01-11','14:40:00',1.82),('12374','2013-01-11','14:50:00',1.81),('12374','2013-01-11','14:55:00',2.1),('12374','2013-01-11','15:00:00',3.22),('12374','2013-01-11','15:05:00',3.43),('12374','2013-01-11','15:25:00',1.48),('12374','2013-01-11','15:30:00',2.52),('12374','2013-01-11','15:35:00',2.27),('12374','2013-01-11','15:40:00',1.07),('12374','2013-01-10','10:20:00',1.11),('12374','2013-01-10','10:25:00',1.23),('12374','2013-01-10','10:30:00',1.38),('12374','2013-01-10','10:35:00',1.3),('12374','2013-01-10','10:40:00',1.25),('12374','2013-01-10','10:45:00',1.18),('12374','2013-01-10','10:50:00',1.15),('12374','2013-01-10','10:55:00',1.09),('12374','2013-01-10','11:00:00',1.43),('12374','2013-01-10','11:05:00',1.43),('12374','2013-01-10','11:10:00',1.42),('12374','2013-01-10','11:15:00',1.17),('12374','2013-01-10','11:50:00',1.14),('12374','2013-01-10','11:55:00',1.38),('12374','2013-01-10','12:00:00',1.55),('12374','2013-01-10','12:05:00',1.7),('12374','2013-01-10','12:10:00',1.74),('12374','2013-01-10','12:15:00',1.41),('12374','2013-01-10','12:20:00',1.3),('12374','2013-01-10','12:25:00',1.27),('12374','2013-01-10','12:30:00',1.13),('12374','2013-01-10','12:50:00',1.25),('12374','2013-01-10','12:55:00',1.44),('12374','2013-01-10','13:00:00',1.05),('12374','2013-01-10','13:05:00',1.02),('12374','2013-01-10','13:15:00',1.49),('12374','2013-01-10','13:20:00',1.83),('12374','2013-01-10','13:25:00',1.56),('12374','2013-01-10','13:30:00',1.43),('12374','2013-01-10','13:35:00',1.5),('12374','2013-01-10','13:40:00',1.34),('12374','2013-01-10','13:45:00',1.12),('12374','2013-01-10','14:25:00',1.07),('12374','2013-01-10','14:30:00',1.16),('12374','2013-01-10','14:35:00',1.05),('12374','2013-01-09','09:10:00',1.02),('12374','2013-01-09','09:15:00',1.09),('12374','2013-01-09','09:20:00',1.27),('12374','2013-01-09','09:25:00',1.73),('12374','2013-01-09','09:30:00',1.5),('12374','2013-01-09','09:35:00',1.56),('12374','2013-01-09','09:40:00',1.98),('12374','2013-01-09','09:45:00',2.09),('12374','2013-01-09','09:50:00',2.72),('12374','2013-01-09','09:55:00',1.9),('12374','2013-01-09','10:00:00',1.83),('12374','2013-01-09','10:05:00',1.64),('12374','2013-01-09','10:10:00',1.6),('12374','2013-01-09','10:15:00',1.7),('12374','2013-01-09','10:20:00',2.28),('12374','2013-01-09','10:25:00',1.8),('12374','2013-01-09','10:30:00',1.88),('12374','2013-01-09','10:35:00',2.21),('12374','2013-01-09','10:40:00',2.3),('12374','2013-01-09','10:45:00',2.3),('12374','2013-01-09','10:50:00',1.9),('12374','2013-01-09','10:55:00',1.79),('12374','2013-01-09','11:00:00',1.81),('12374','2013-01-09','11:05:00',1.89),('12374','2013-01-09','11:10:00',1.89),('12374','2013-01-09','11:15:00',2.09),('12374','2013-01-09','11:20:00',2.07),('12374','2013-01-09','11:25:00',1.96),('12374','2013-01-09','11:30:00',2.13),('12374','2013-01-09','11:35:00',2.89),('12374','2013-01-09','11:40:00',3.66),('12374','2013-01-09','11:45:00',3.74),('12374','2013-01-09','11:50:00',3.64),('12374','2013-01-09','11:55:00',4.01),('12374','2013-01-09','12:00:00',4.43),('12374','2013-01-09','12:05:00',5.67),('12374','2013-01-09','12:10:00',4.56),('12374','2013-01-09','12:15:00',4.7),('12374','2013-01-09','12:20:00',5.32),('12374','2013-01-09','12:25:00',4.32),('12374','2013-01-09','12:30:00',3.51),('12374','2013-01-09','12:35:00',3.96),('12374','2013-01-09','12:40:00',4.53),('12374','2013-01-09','12:45:00',3.54),('12374','2013-01-09','12:50:00',4.06),('12374','2013-01-09','12:55:00',3.72),('12374','2013-01-09','13:00:00',4.31),('12374','2013-01-09','13:05:00',5.04),('12374','2013-01-09','13:10:00',5.25),('12374','2013-01-09','13:15:00',4.88),('12374','2013-01-09','13:20:00',4.94),('12374','2013-01-09','13:25:00',5.25),('12374','2013-01-09','13:30:00',5.6),('12374','2013-01-09','13:35:00',3.28),('12374','2013-01-09','13:40:00',2.23),('12374','2013-01-09','13:45:00',1.87),('12374','2013-01-09','13:50:00',1.78),('12374','2013-01-09','13:55:00',2.03),('12374','2013-01-09','14:00:00',3.06),('12374','2013-01-09','14:05:00',3.52),('12374','2013-01-09','14:10:00',3.25),('12374','2013-01-09','14:15:00',2.35),('12374','2013-01-09','14:20:00',2.04),('12374','2013-01-09','14:25:00',1.95),('12374','2013-01-09','14:30:00',2.18),('12374','2013-01-09','14:35:00',2.24),('12374','2013-01-09','14:40:00',2),('12374','2013-01-09','14:45:00',2.63),('12374','2013-01-09','14:50:00',3.18),('12374','2013-01-09','14:55:00',2.23),('12374','2013-01-09','15:00:00',1.38),('12374','2013-01-09','15:05:00',1.25),('12374','2013-01-09','15:10:00',1.23),('12374','2013-01-09','15:15:00',1.57),('12374','2013-01-09','15:20:00',1.67),('12374','2013-01-09','15:25:00',3.29),('12374','2013-01-09','15:30:00',3.08),('12374','2013-01-09','15:35:00',2.75),('12374','2013-01-09','15:40:00',2.11),('12374','2013-01-09','15:45:00',1.85),('12374','2013-01-09','15:50:00',2.18),('12374','2013-01-09','15:55:00',1.96),('12374','2013-01-09','16:00:00',1.65),('12374','2013-01-09','16:05:00',1.42),('12374','2013-01-09','16:10:00',1.2),('12374','2013-01-09','16:15:00',1),('12374','2013-01-08','08:15:00',1.03),('12374','2013-01-08','08:20:00',1.3),('12374','2013-01-08','08:25:00',1.37),('12374','2013-01-08','08:30:00',1.07),('12374','2013-01-08','08:55:00',1.07),('12374','2013-01-08','09:00:00',1.25),('12374','2013-01-08','09:05:00',1.43),('12374','2013-01-08','09:10:00',1.38),('12374','2013-01-08','09:15:00',1.42),('12374','2013-01-08','09:20:00',1.52),('12374','2013-01-08','09:25:00',1.6),('12374','2013-01-08','09:30:00',1.68),('12374','2013-01-08','09:35:00',1.62),('12374','2013-01-08','09:40:00',1.61),('12374','2013-01-08','09:45:00',1.49),('12374','2013-01-08','09:50:00',1.54),('12374','2013-01-08','09:55:00',1.76),('12374','2013-01-08','10:00:00',1.67),('12374','2013-01-08','10:05:00',1.87),('12374','2013-01-08','10:10:00',3.31),('12374','2013-01-08','10:15:00',4.5),('12374','2013-01-08','10:20:00',4.61),('12374','2013-01-08','10:25:00',4.57),('12374','2013-01-08','10:30:00',4.86),('12374','2013-01-08','10:35:00',4.93),('12374','2013-01-08','10:40:00',5.53),('12374','2013-01-08','10:45:00',5.58),('12374','2013-01-08','10:50:00',5.71),('12374','2013-01-08','10:55:00',5.75),('12374','2013-01-08','11:00:00',5.85),('12374','2013-01-08','11:05:00',5.99),('12374','2013-01-08','11:10:00',6.05),('12374','2013-01-08','11:15:00',6.11),('12374','2013-01-08','11:20:00',6.2),('12374','2013-01-08','11:25:00',6.2),('12374','2013-01-08','11:30:00',6.08),('12374','2013-01-08','11:35:00',6.06),('12374','2013-01-08','11:40:00',6.11),('12374','2013-01-08','11:45:00',6.24),('12374','2013-01-08','11:50:00',6.72),('12374','2013-01-08','11:55:00',7.49),('12374','2013-01-08','12:00:00',5.09),('12374','2013-01-08','12:05:00',5.15),('12374','2013-01-08','12:10:00',5.71),('12374','2013-01-08','12:15:00',3.79),('12374','2013-01-08','12:20:00',3.36),('12374','2013-01-08','12:25:00',3.06),('12374','2013-01-08','12:30:00',3.2),('12374','2013-01-08','12:35:00',3.3),('12374','2013-01-08','12:40:00',2.08),('12374','2013-01-08','12:45:00',1.8),('12374','2013-01-08','12:50:00',1.23),('12374','2013-01-08','12:55:00',1.22),('12374','2013-01-08','13:00:00',1.41),('12374','2013-01-08','13:05:00',1.4),('12374','2013-01-08','13:10:00',1.28),('12374','2013-01-08','13:15:00',1.79),('12374','2013-01-08','13:20:00',2.25),('12374','2013-01-08','13:25:00',2.23),('12374','2013-01-08','13:30:00',1.5),('12374','2013-01-08','13:35:00',1.21),('12374','2013-01-08','13:40:00',1.05),('12374','2013-01-08','14:00:00',1.27),('12374','2013-01-08','14:05:00',1.44),('12374','2013-01-08','14:10:00',1.49),('12374','2013-01-08','14:15:00',1.87),('12374','2013-01-08','14:20:00',2.72),('12374','2013-01-08','14:25:00',5.31),('12374','2013-01-08','14:30:00',4.98),('12374','2013-01-08','14:35:00',4.89),('12374','2013-01-08','14:40:00',3.74),('12374','2013-01-08','14:45:00',3.38),('12374','2013-01-08','14:50:00',1.89),('12374','2013-01-08','14:55:00',2.09),('12374','2013-01-08','15:00:00',1.06),('12374','2013-01-08','15:05:00',1.74),('12374','2013-01-08','15:10:00',3.18),('12374','2013-01-08','15:15:00',3.04),('12374','2013-01-08','15:20:00',2.62),('12374','2013-01-08','15:25:00',2.01),('12374','2013-01-07','08:20:00',1),('12374','2013-01-07','08:25:00',1.2),('12374','2013-01-07','08:30:00',1.49),('12374','2013-01-07','08:35:00',1.71),('12374','2013-01-07','08:40:00',1.84),('12374','2013-01-07','08:45:00',2.12),('12374','2013-01-07','08:50:00',2.33),('12374','2013-01-07','08:55:00',2.32),('12374','2013-01-07','09:00:00',2.54),('12374','2013-01-07','09:05:00',2.88),('12374','2013-01-07','09:10:00',3.04),('12374','2013-01-07','09:15:00',3.26),('12374','2013-01-07','09:20:00',3.42),('12374','2013-01-07','09:25:00',3.56),('12374','2013-01-07','09:30:00',3.7),('12374','2013-01-07','09:35:00',3.84),('12374','2013-01-07','09:40:00',3.98),('12374','2013-01-07','09:45:00',4.11),('12374','2013-01-07','09:50:00',4.26),('12374','2013-01-07','09:55:00',4.49),('12374','2013-01-07','10:00:00',4.6),('12374','2013-01-07','10:05:00',4.74),('12374','2013-01-07','10:10:00',4.92),('12374','2013-01-07','10:15:00',5.04),('12374','2013-01-07','10:20:00',5.14),('12374','2013-01-07','10:25:00',5.29),('12374','2013-01-07','10:30:00',5.4),('12374','2013-01-07','10:35:00',5.47),('12374','2013-01-07','10:40:00',5.56),('12374','2013-01-07','10:45:00',5.62),('12374','2013-01-07','10:50:00',5.69),('12374','2013-01-07','10:55:00',5.78),('12374','2013-01-07','11:00:00',5.83),('12374','2013-01-07','11:05:00',5.92),('12374','2013-01-07','11:10:00',5.97),('12374','2013-01-07','11:15:00',5.97),('12374','2013-01-07','11:20:00',6.01),('12374','2013-01-07','11:25:00',6.05),('12374','2013-01-07','11:30:00',6.07),('12374','2013-01-07','11:35:00',6.1),('12374','2013-01-07','11:40:00',6.16),('12374','2013-01-07','11:45:00',6.1),('12374','2013-01-07','11:50:00',6.09),('12374','2013-01-07','11:55:00',6.14),('12374','2013-01-07','12:00:00',6.1),('12374','2013-01-07','12:05:00',6.15),('12374','2013-01-07','12:10:00',6.17),('12374','2013-01-07','12:15:00',6.13),('12374','2013-01-07','12:20:00',6.12),('12374','2013-01-07','12:25:00',6.07),('12374','2013-01-07','12:30:00',6.08),('12374','2013-01-07','12:35:00',6.08),('12374','2013-01-07','12:40:00',6.01),('12374','2013-01-07','12:45:00',5.97),('12374','2013-01-07','12:50:00',5.95),('12374','2013-01-07','12:55:00',5.93),('12374','2013-01-07','13:00:00',5.86),('12374','2013-01-07','13:05:00',5.85),('12374','2013-01-07','13:10:00',5.78),('12374','2013-01-07','13:15:00',5.63),('12374','2013-01-07','13:20:00',5.59),('12374','2013-01-07','13:25:00',5.5),('12374','2013-01-07','13:30:00',5.37),('12374','2013-01-07','13:35:00',5.31),('12374','2013-01-07','13:40:00',5.3),('12374','2013-01-07','13:45:00',5.2),('12374','2013-01-07','13:50:00',5.13),('12374','2013-01-07','13:55:00',5.05),('12374','2013-01-07','14:00:00',4.92),('12374','2013-01-07','14:05:00',4.78),('12374','2013-01-07','14:10:00',4.61),('12374','2013-01-07','14:15:00',4.55),('12374','2013-01-07','14:20:00',4.46),('12374','2013-01-07','14:25:00',4.39),('12374','2013-01-07','14:30:00',4.26),('12374','2013-01-07','14:35:00',4.16),('12374','2013-01-07','14:40:00',4.06),('12374','2013-01-07','14:45:00',3.98),('12374','2013-01-07','14:50:00',3.83),('12374','2013-01-07','14:55:00',3.76),('12374','2013-01-07','15:00:00',3.6),('12374','2013-01-07','15:05:00',3.43),('12374','2013-01-07','15:10:00',3.33),('12374','2013-01-07','15:15:00',3.15),('12374','2013-01-07','15:20:00',3.03),('12374','2013-01-07','15:25:00',2.85),('12374','2013-01-07','15:30:00',2.74),('12374','2013-01-07','15:35:00',2.54),('12374','2013-01-07','15:40:00',2.37),('12374','2013-01-07','15:45:00',2.16),('12374','2013-01-07','15:50:00',2.09),('12374','2013-01-07','15:55:00',1.92),('12374','2013-01-07','16:00:00',1.71),('12374','2013-01-07','16:05:00',1.52),('12374','2013-01-07','16:10:00',1.3),('12374','2013-01-07','16:15:00',1.14),('12374','2013-01-06','08:20:00',1.19),('12374','2013-01-06','08:25:00',1.37),('12374','2013-01-06','08:30:00',1.64),('12374','2013-01-06','08:35:00',1.9),('12374','2013-01-06','08:40:00',1.87),('12374','2013-01-06','08:45:00',2.24),('12374','2013-01-06','08:50:00',2.35),('12374','2013-01-06','08:55:00',2.43),('12374','2013-01-06','09:00:00',2.68),('12374','2013-01-06','09:05:00',3.05),('12374','2013-01-06','09:10:00',3.28),('12374','2013-01-06','09:15:00',3.33),('12374','2013-01-06','09:20:00',3.52),('12374','2013-01-06','09:25:00',3.77),('12374','2013-01-06','09:30:00',3.87),('12374','2013-01-06','09:35:00',3.92),('12374','2013-01-06','09:40:00',4.15),('12374','2013-01-06','09:45:00',4.3),('12374','2013-01-06','09:50:00',4.38),('12374','2013-01-06','09:55:00',4.52),('12374','2013-01-06','10:00:00',4.63),('12374','2013-01-06','10:05:00',4.7),('12374','2013-01-06','10:10:00',4.85),('12374','2013-01-06','10:15:00',4.98),('12374','2013-01-06','10:20:00',5.11),('12374','2013-01-06','10:25:00',5.19),('12374','2013-01-06','10:30:00',5.23),('12374','2013-01-06','10:35:00',5.33),('12374','2013-01-06','10:40:00',5.43),('12374','2013-01-06','10:45:00',5.5),('12374','2013-01-06','10:50:00',5.6),('12374','2013-01-06','10:55:00',5.7),('12374','2013-01-06','11:00:00',5.77),('12374','2013-01-06','11:05:00',5.84),('12374','2013-01-06','11:10:00',5.89),('12374','2013-01-06','11:15:00',5.9),('12374','2013-01-06','11:20:00',5.99),('12374','2013-01-06','11:25:00',6.04),('12374','2013-01-06','11:30:00',6.12),('12374','2013-01-06','11:35:00',6.17),('12374','2013-01-06','11:40:00',6.2),('12374','2013-01-06','11:45:00',6.23),('12374','2013-01-06','11:50:00',6.26),('12374','2013-01-06','11:55:00',6.24),('12374','2013-01-06','12:00:00',6.22),('12374','2013-01-06','12:05:00',6.21),('12374','2013-01-06','12:10:00',6.2),('12374','2013-01-06','12:15:00',6.13),('12374','2013-01-06','12:20:00',6.17),('12374','2013-01-06','12:25:00',6.15),('12374','2013-01-06','12:30:00',6.12),('12374','2013-01-06','12:35:00',6.07),('12374','2013-01-06','12:40:00',6.06),('12374','2013-01-06','12:45:00',6.03),('12374','2013-01-06','12:50:00',6.03),('12374','2013-01-06','12:55:00',5.96),('12374','2013-01-06','13:00:00',5.93),('12374','2013-01-06','13:05:00',5.84),('12374','2013-01-06','13:10:00',5.72),('12374','2013-01-06','13:15:00',5.67),('12374','2013-01-06','13:20:00',5.65),('12374','2013-01-06','13:25:00',5.53),('12374','2013-01-06','13:30:00',5.45),('12374','2013-01-06','13:35:00',5.37),('12374','2013-01-06','13:40:00',5.19),('12374','2013-01-06','13:45:00',5.11),('12374','2013-01-06','13:50:00',5),('12374','2013-01-06','13:55:00',4.92),('12374','2013-01-06','14:00:00',4.79),('12374','2013-01-06','14:05:00',4.72),('12374','2013-01-06','14:10:00',4.56),('12374','2013-01-06','14:15:00',4.48),('12374','2013-01-06','14:20:00',4.29),('12374','2013-01-06','14:25:00',4.17),('12374','2013-01-06','14:30:00',4.06),('12374','2013-01-06','14:35:00',3.97),('12374','2013-01-06','14:40:00',3.89),('12374','2013-01-06','14:45:00',3.79),('12374','2013-01-06','14:50:00',3.63),('12374','2013-01-06','14:55:00',3.48),('12374','2013-01-06','15:00:00',3.29),('12374','2013-01-06','15:05:00',3.15),('12374','2013-01-06','15:10:00',3.02),('12374','2013-01-06','15:15:00',2.85),('12374','2013-01-06','15:20:00',2.7),('12374','2013-01-06','15:25:00',2.57),('12374','2013-01-06','15:30:00',2.42),('12374','2013-01-06','15:35:00',2.25),('12374','2013-01-06','15:40:00',2.06),('12374','2013-01-06','15:45:00',1.88),('12374','2013-01-06','15:50:00',1.76),('12374','2013-01-06','15:55:00',1.63),('12374','2013-01-06','16:00:00',1.44),('12374','2013-01-06','16:05:00',1.07),('12374','2013-01-05','08:30:00',1.06),('12374','2013-01-05','08:35:00',1.34),('12374','2013-01-05','08:40:00',1.36),('12374','2013-01-05','08:45:00',1.05),('12374','2013-01-05','08:50:00',1.73),('12374','2013-01-05','08:55:00',1.96),('12374','2013-01-05','09:00:00',2.08),('12374','2013-01-05','09:25:00',1.06),('12374','2013-01-05','09:30:00',1.4),('12374','2013-01-05','09:35:00',1.73),('12374','2013-01-05','09:40:00',1.95),('12374','2013-01-05','09:45:00',2.04),('12374','2013-01-05','09:50:00',2.15),('12374','2013-01-05','09:55:00',1.81),('12374','2013-01-05','10:00:00',1.8),('12374','2013-01-05','10:05:00',1.92),('12374','2013-01-05','10:10:00',2.37),('12374','2013-01-05','10:15:00',3.44),('12374','2013-01-05','10:20:00',3.98),('12374','2013-01-05','10:25:00',3.9),('12374','2013-01-05','10:30:00',3.55),('12374','2013-01-05','10:35:00',3.7),('12374','2013-01-05','10:40:00',4.05),('12374','2013-01-05','10:45:00',3.68),('12374','2013-01-05','10:50:00',3.55),('12374','2013-01-05','10:55:00',3.64),('12374','2013-01-05','11:00:00',4.56),('12374','2013-01-05','11:05:00',5.35),('12374','2013-01-05','11:10:00',5.89),('12374','2013-01-05','11:15:00',5.43),('12374','2013-01-05','11:20:00',5.73),('12374','2013-01-05','11:25:00',5.7),('12374','2013-01-05','11:30:00',5.7),('12374','2013-01-05','11:35:00',5.98),('12374','2013-01-05','11:40:00',5.99),('12374','2013-01-05','11:45:00',6.01),('12374','2013-01-05','11:50:00',5.57),('12374','2013-01-05','11:55:00',5.55),('12374','2013-01-05','12:00:00',4.57),('12374','2013-01-05','12:05:00',4.51),('12374','2013-01-05','12:10:00',4.51),('12374','2013-01-05','12:15:00',4.43),('12374','2013-01-05','12:20:00',4.3),('12374','2013-01-05','12:25:00',3.64),('12374','2013-01-05','12:30:00',3.52),('12374','2013-01-05','12:35:00',4.25),('12374','2013-01-05','12:40:00',3.39),('12374','2013-01-05','12:45:00',4.05),('12374','2013-01-05','12:50:00',4.86),('12374','2013-01-05','12:55:00',6.24),('12374','2013-01-05','13:00:00',5.66),('12374','2013-01-05','13:05:00',5.95),('12374','2013-01-05','13:10:00',4.12),('12374','2013-01-05','13:15:00',5.01),('12374','2013-01-05','13:20:00',5.57),('12374','2013-01-05','13:25:00',5.48),('12374','2013-01-05','13:30:00',4.8),('12374','2013-01-05','13:35:00',5.23),('12374','2013-01-05','13:40:00',4.83),('12374','2013-01-05','13:45:00',4.84),('12374','2013-01-05','13:50:00',4.76),('12374','2013-01-05','13:55:00',4.25),('12374','2013-01-05','14:00:00',4.5),('12374','2013-01-05','14:05:00',4.46),('12374','2013-01-05','14:10:00',3.95),('12374','2013-01-05','14:15:00',3.92),('12374','2013-01-05','14:20:00',4.34),('12374','2013-01-05','14:25:00',3.42),('12374','2013-01-05','14:30:00',3.67),('12374','2013-01-05','14:35:00',3.44),('12374','2013-01-05','14:40:00',2.61),('12374','2013-01-05','14:45:00',2.89),('12374','2013-01-05','14:50:00',3.38),('12374','2013-01-05','14:55:00',3.5),('12374','2013-01-05','15:00:00',3.56),('12374','2013-01-05','15:05:00',2.43),('12374','2013-01-05','15:10:00',3.39),('12374','2013-01-05','15:15:00',2.99),('12374','2013-01-05','15:20:00',2.34),('12374','2013-01-05','15:25:00',1.83),('12374','2013-01-05','15:30:00',2.3),('12374','2013-01-05','15:35:00',2.14),('12374','2013-01-05','15:40:00',1.9),('12374','2013-01-05','15:45:00',1.68),('12374','2013-01-05','15:50:00',1.56),('12374','2013-01-05','15:55:00',1.39),('12374','2013-01-05','16:00:00',1.24),('12374','2013-01-05','16:05:00',1.11),('12374','2013-01-04','08:25:00',1.02),('12374','2013-01-04','08:30:00',1.07),('12374','2013-01-04','08:35:00',1.31),('12374','2013-01-04','08:40:00',1.33),('12374','2013-01-04','08:45:00',1.51),('12374','2013-01-04','08:50:00',1.06),('12374','2013-01-04','08:55:00',1.4),('12374','2013-01-04','09:00:00',2.13),('12374','2013-01-04','09:05:00',2.74),('12374','2013-01-04','09:10:00',1.88),('12374','2013-01-04','09:15:00',2.78),('12374','2013-01-04','09:20:00',2.79),('12374','2013-01-04','09:25:00',3.15),('12374','2013-01-04','09:30:00',3.67),('12374','2013-01-04','09:35:00',3.96),('12374','2013-01-04','09:40:00',4.25),('12374','2013-01-04','09:45:00',4.64),('12374','2013-01-04','09:50:00',4.96),('12374','2013-01-04','09:55:00',4.93),('12374','2013-01-04','10:00:00',4.36),('12374','2013-01-04','10:05:00',2.25),('12374','2013-01-04','10:10:00',1.42),('12374','2013-01-04','10:15:00',1.53),('12374','2013-01-04','10:20:00',1.67),('12374','2013-01-04','10:25:00',3.26),('12374','2013-01-04','10:30:00',5.28),('12374','2013-01-04','10:35:00',5.46),('12374','2013-01-04','10:40:00',5.86),('12374','2013-01-04','10:45:00',6.11),('12374','2013-01-04','10:50:00',6.37),('12374','2013-01-04','10:55:00',5.43),('12374','2013-01-04','11:00:00',5.18),('12374','2013-01-04','11:05:00',5.55),('12374','2013-01-04','11:10:00',4.06),('12374','2013-01-04','11:15:00',2.16),('12374','2013-01-04','11:20:00',1.81),('12374','2013-01-04','11:25:00',1.99),('12374','2013-01-04','11:30:00',2.45),('12374','2013-01-04','11:35:00',1.81),('12374','2013-01-04','11:40:00',1.27),('12374','2013-01-04','11:45:00',3.43),('12374','2013-01-04','11:50:00',5.51),('12374','2013-01-04','11:55:00',6.99),('12374','2013-01-04','12:00:00',5.45),('12374','2013-01-04','12:05:00',3.78),('12374','2013-01-04','12:10:00',1.88),('12374','2013-01-04','12:15:00',2.1),('12374','2013-01-04','12:20:00',2.13),('12374','2013-01-04','12:25:00',6.57),('12374','2013-01-04','12:30:00',6.28),('12374','2013-01-04','12:35:00',6.19),('12374','2013-01-04','12:40:00',6.18),('12374','2013-01-04','12:45:00',6.2),('12374','2013-01-04','12:50:00',6.13),('12374','2013-01-04','12:55:00',5.93),('12374','2013-01-04','13:00:00',5.3),('12374','2013-01-04','13:05:00',4.7),('12374','2013-01-04','13:10:00',5.58),('12374','2013-01-04','13:15:00',5.46),('12374','2013-01-04','13:20:00',5.42),('12374','2013-01-04','13:25:00',5.35),('12374','2013-01-04','13:30:00',5.32),('12374','2013-01-04','13:35:00',4.98),('12374','2013-01-04','13:40:00',4.69),('12374','2013-01-04','13:45:00',4.67),('12374','2013-01-04','13:50:00',5.01),('12374','2013-01-04','13:55:00',4.49),('12374','2013-01-04','14:00:00',4.49),('12374','2013-01-04','14:05:00',4.33),('12374','2013-01-04','14:10:00',4.29),('12374','2013-01-04','14:15:00',4.32),('12374','2013-01-04','14:20:00',4.16),('12374','2013-01-04','14:25:00',3.93),('12374','2013-01-04','14:30:00',3.81),('12374','2013-01-04','14:35:00',3.87),('12374','2013-01-04','14:40:00',3.74),('12374','2013-01-04','14:45:00',3.56),('12374','2013-01-04','14:50:00',3.49),('12374','2013-01-04','14:55:00',3.4),('12374','2013-01-04','15:00:00',3.41),('12374','2013-01-04','15:05:00',3.36),('12374','2013-01-04','15:10:00',3.1),('12374','2013-01-04','15:15:00',2.87),('12374','2013-01-04','15:20:00',2.79),('12374','2013-01-04','15:25:00',2.71),('12374','2013-01-04','15:30:00',2.39),('12374','2013-01-04','15:35:00',1.52),('12374','2013-01-04','15:40:00',2),('12374','2013-01-04','15:45:00',1.74),('12374','2013-01-04','15:50:00',2.04),('12374','2013-01-04','15:55:00',1.69),('12374','2013-01-04','16:00:00',1.56),('12374','2013-01-04','16:05:00',1.39),('12374','2013-01-04','16:10:00',1.2),('12374','2013-01-03','08:20:00',1.14),('12374','2013-01-03','09:00:00',1.17),('12374','2013-01-03','09:05:00',1.36),('12374','2013-01-03','09:10:00',2.33),('12374','2013-01-03','09:15:00',2.89),('12374','2013-01-03','09:20:00',2.09),('12374','2013-01-03','09:25:00',1.9),('12374','2013-01-03','09:30:00',2.17),('12374','2013-01-03','09:35:00',2.32),('12374','2013-01-03','09:40:00',2.73),('12374','2013-01-03','09:45:00',2.89),('12374','2013-01-03','09:50:00',2.64),('12374','2013-01-03','09:55:00',2.98),('12374','2013-01-03','10:00:00',2.91),('12374','2013-01-03','10:05:00',2.83),('12374','2013-01-03','10:10:00',2.7),('12374','2013-01-03','10:15:00',2.73),('12374','2013-01-03','10:20:00',2.77),('12374','2013-01-03','10:25:00',2.6),('12374','2013-01-03','10:30:00',2.68),('12374','2013-01-03','10:35:00',2.88),('12374','2013-01-03','10:40:00',2.95),('12374','2013-01-03','10:45:00',2.88),('12374','2013-01-03','10:50:00',2.87),('12374','2013-01-03','10:55:00',2.96),('12374','2013-01-03','11:00:00',3.09),('12374','2013-01-03','11:05:00',3.39),('12374','2013-01-03','11:10:00',3.57),('12374','2013-01-03','11:15:00',4.02),('12374','2013-01-03','11:20:00',4.03),('12374','2013-01-03','11:25:00',4.08),('12374','2013-01-03','11:30:00',4.08),('12374','2013-01-03','11:35:00',4.68),('12374','2013-01-03','11:40:00',4.28),('12374','2013-01-03','11:45:00',6.15),('12374','2013-01-03','11:50:00',6.47),('12374','2013-01-03','11:55:00',6.23),('12374','2013-01-03','12:00:00',6.14),('12374','2013-01-03','12:05:00',6.1),('12374','2013-01-03','12:10:00',6.11),('12374','2013-01-03','12:15:00',6.08),('12374','2013-01-03','12:20:00',6.09),('12374','2013-01-03','12:25:00',6.03),('12374','2013-01-03','12:30:00',6.03),('12374','2013-01-03','12:35:00',6.01),('12374','2013-01-03','12:40:00',5.95),('12374','2013-01-03','12:45:00',5.93),('12374','2013-01-03','12:50:00',5.83),('12374','2013-01-03','12:55:00',5.8),('12374','2013-01-03','13:00:00',5.7),('12374','2013-01-03','13:05:00',5.64),('12374','2013-01-03','13:10:00',5.6),('12374','2013-01-03','13:15:00',5.54),('12374','2013-01-03','13:20:00',5.49),('12374','2013-01-03','13:25:00',5.4),('12374','2013-01-03','13:30:00',5.32),('12374','2013-01-03','13:35:00',5.2),('12374','2013-01-03','13:40:00',5.11),('12374','2013-01-03','13:45:00',5.04),('12374','2013-01-03','13:50:00',4.97),('12374','2013-01-03','13:55:00',4.84),('12374','2013-01-03','14:00:00',4.77),('12374','2013-01-03','14:05:00',4.73),('12374','2013-01-03','14:10:00',4.61),('12374','2013-01-03','14:15:00',4.46),('12374','2013-01-03','14:20:00',4.39),('12374','2013-01-03','14:25:00',4.27),('12374','2013-01-03','14:30:00',4.13),('12374','2013-01-03','14:35:00',4),('12374','2013-01-03','14:40:00',3.9),('12374','2013-01-03','14:45:00',3.82),('12374','2013-01-03','14:50:00',3.69),('12374','2013-01-03','14:55:00',3.53),('12374','2013-01-03','15:00:00',3.4),('12374','2013-01-03','15:05:00',3.26),('12374','2013-01-03','15:10:00',3.09),('12374','2013-01-03','15:15:00',2.89),('12374','2013-01-03','15:20:00',2.49),('12374','2013-01-03','15:25:00',2.38),('12374','2013-01-03','15:30:00',2.37),('12374','2013-01-03','15:35:00',2.28),('12374','2013-01-03','15:40:00',2),('12374','2013-01-03','15:45:00',1.81),('12374','2013-01-03','15:50:00',1.54),('12374','2013-01-03','15:55:00',1.34),('12374','2013-01-03','16:00:00',1.18),('12374','2013-01-03','16:05:00',1.05),('12374','2013-01-02','10:05:00',1.03),('12374','2013-01-02','10:10:00',2.5),('12374','2013-01-02','10:15:00',2.73),('12374','2013-01-02','10:20:00',2.31),('12374','2013-01-02','10:25:00',2.05),('12374','2013-01-02','10:30:00',2.17),('12374','2013-01-02','10:35:00',3.44),('12374','2013-01-02','10:40:00',4.11),('12374','2013-01-02','10:45:00',3.07),('12374','2013-01-02','10:50:00',2.42),('12374','2013-01-02','10:55:00',2.02),('12374','2013-01-02','11:00:00',1.91),('12374','2013-01-02','11:05:00',2.12),('12374','2013-01-02','11:10:00',2.86),('12374','2013-01-02','11:15:00',3.2),('12374','2013-01-02','11:20:00',3.38),('12374','2013-01-02','11:25:00',3.45),('12374','2013-01-02','11:30:00',4.09),('12374','2013-01-02','11:35:00',4.19),('12374','2013-01-02','11:40:00',6.04),('12374','2013-01-02','11:45:00',5.85),('12374','2013-01-02','11:50:00',4.5),('12374','2013-01-02','11:55:00',2.23),('12374','2013-01-02','12:00:00',1.81),('12374','2013-01-02','12:05:00',1.9),('12374','2013-01-02','12:10:00',2.25),('12374','2013-01-02','12:15:00',2.2),('12374','2013-01-02','12:20:00',2.09),('12374','2013-01-02','12:25:00',1.99),('12374','2013-01-02','12:30:00',2.41),('12374','2013-01-02','12:35:00',2.79),('12374','2013-01-02','12:40:00',2.62),('12374','2013-01-02','12:45:00',2.34),('12374','2013-01-02','12:50:00',2.14),('12374','2013-01-02','12:55:00',2.48),('12374','2013-01-02','13:00:00',2.57),('12374','2013-01-02','13:05:00',2.86),('12374','2013-01-02','13:10:00',3.1),('12374','2013-01-02','13:15:00',2.72),('12374','2013-01-02','13:20:00',2.76),('12374','2013-01-02','13:25:00',2.81),('12374','2013-01-02','13:30:00',3.68),('12374','2013-01-02','13:35:00',3.99),('12374','2013-01-02','13:40:00',3.39),('12374','2013-01-02','13:45:00',3.15),('12374','2013-01-02','13:50:00',2.8),('12374','2013-01-02','13:55:00',3.63),('12374','2013-01-02','14:00:00',2.74),('12374','2013-01-02','14:05:00',2.29),('12374','2013-01-02','14:10:00',2.25),('12374','2013-01-02','14:15:00',2.19),('12374','2013-01-02','14:20:00',2.04),('12374','2013-01-02','14:25:00',1.51),('12374','2013-01-02','14:30:00',1.11),('12374','2013-01-01','08:15:00',1),('12374','2013-01-01','08:20:00',1.34),('12374','2013-01-01','08:25:00',1.58),('12374','2013-01-01','08:30:00',1.81),('12374','2013-01-01','08:35:00',2.11),('12374','2013-01-01','08:40:00',1.44),('12374','2013-01-01','08:45:00',1.29),('12374','2013-01-01','08:50:00',1.06),('12374','2013-01-01','08:55:00',1.26),('12374','2013-01-01','09:00:00',1.43),('12374','2013-01-01','09:05:00',1.25),('12374','2013-01-01','09:10:00',1.9),('12374','2013-01-01','09:15:00',3.91),('12374','2013-01-01','09:20:00',3.6),('12374','2013-01-01','09:25:00',3.21),('12374','2013-01-01','09:30:00',2.32),('12374','2013-01-01','09:35:00',1.72),('12374','2013-01-01','09:40:00',1.7),('12374','2013-01-01','09:45:00',1.47),('12374','2013-01-01','09:50:00',2.41),('12374','2013-01-01','09:55:00',4.29),('12374','2013-01-01','10:00:00',1.97),('12374','2013-01-01','10:05:00',1.7),('12374','2013-01-01','10:10:00',1.64),('12374','2013-01-01','10:15:00',1.92),('12374','2013-01-01','10:20:00',1.76),('12374','2013-01-01','10:25:00',2.13),('12374','2013-01-01','10:30:00',2.42),('12374','2013-01-01','10:35:00',2.25),('12374','2013-01-01','10:40:00',2.12),('12374','2013-01-01','10:45:00',2.29),('12374','2013-01-01','10:50:00',2.82),('12374','2013-01-01','10:55:00',2.91),('12374','2013-01-01','11:00:00',2.25),('12374','2013-01-01','11:05:00',2.62),('12374','2013-01-01','11:10:00',2.93),('12374','2013-01-01','11:15:00',2.21),('12374','2013-01-01','11:20:00',1.74),('12374','2013-01-01','11:25:00',1.26),('12374','2013-01-01','11:30:00',1.14),('12374','2013-01-01','11:35:00',1.79),('12374','2013-01-01','11:40:00',1.88),('12374','2013-01-01','11:45:00',1.6),('12374','2013-01-01','11:50:00',1.17),('12374','2013-01-01','12:50:00',1.08),('12374','2013-01-01','12:55:00',1.9),('12374','2013-01-01','13:00:00',1.89),('12374','2013-01-01','13:05:00',2.03),('12374','2013-01-01','13:10:00',2.16),('12374','2013-01-01','13:15:00',1.95),('12374','2013-01-01','13:20:00',2.12),('12374','2013-01-01','13:25:00',2.58),('12374','2013-01-01','13:30:00',2.61),('12374','2013-01-01','13:35:00',3.7),('12374','2013-01-01','13:40:00',3.34),('12374','2013-01-01','13:45:00',2.16),('12374','2013-01-01','13:50:00',4.93),('12374','2013-01-01','13:55:00',3.48),('12374','2013-01-01','14:00:00',4.45),('12374','2013-01-01','14:05:00',4.38),('12374','2013-01-01','14:10:00',4.6),('12374','2013-01-01','14:15:00',4.42),('12374','2013-01-01','14:20:00',4.23),('12374','2013-01-01','14:25:00',4.08),('12374','2013-01-01','14:30:00',3.95),('12374','2013-01-01','14:35:00',3.83),('12374','2013-01-01','14:40:00',3.78),('12374','2013-01-01','14:45:00',3.65),('12374','2013-01-01','14:50:00',3.43),('12374','2013-01-01','14:55:00',3.1),('12374','2013-01-01','15:00:00',3.18),('12374','2013-01-01','15:05:00',3.06),('12374','2013-01-01','15:10:00',2.93),('12374','2013-01-01','15:15:00',2.83),('12374','2013-01-01','15:20:00',2.62),('12374','2013-01-01','15:25:00',2.36),('12374','2013-01-01','15:30:00',1.08),('12374','2012-12-31','08:35:00',2.13),('12374','2012-12-31','08:40:00',2.43),('12374','2012-12-31','08:45:00',2.49),('12374','2012-12-31','08:50:00',2.59),('12374','2012-12-31','08:55:00',2.83),('12374','2012-12-31','09:00:00',3.2),('12374','2012-12-31','09:05:00',3.31),('12374','2012-12-31','09:10:00',3.51),('12374','2012-12-31','09:15:00',3.45),('12374','2012-12-31','09:20:00',3.75),('12374','2012-12-31','09:25:00',4.04),('12374','2012-12-31','09:30:00',4.1),('12374','2012-12-31','09:35:00',4.03),('12374','2012-12-31','09:40:00',3.8),('12374','2012-12-31','09:45:00',4.17),('12374','2012-12-31','09:50:00',4.28),('12374','2012-12-31','09:55:00',4.22),('12374','2012-12-31','10:00:00',4.02),('12374','2012-12-31','10:05:00',4.48),('12374','2012-12-31','10:10:00',4.79),('12374','2012-12-31','10:15:00',5.13),('12374','2012-12-31','10:20:00',5.37),('12374','2012-12-31','10:25:00',5.55),('12374','2012-12-31','10:30:00',5.66),('12374','2012-12-31','10:35:00',5.72),('12374','2012-12-31','10:40:00',5.7),('12374','2012-12-31','10:45:00',5.83),('12374','2012-12-31','10:50:00',5.9),('12374','2012-12-31','10:55:00',5.97),('12374','2012-12-31','11:00:00',6.04),('12374','2012-12-31','11:05:00',6.1),('12374','2012-12-31','11:10:00',6.15),('12374','2012-12-31','11:15:00',6.17),('12374','2012-12-31','11:20:00',6.24),('12374','2012-12-31','11:25:00',6.29),('12374','2012-12-31','11:30:00',6.32),('12374','2012-12-31','11:35:00',6.32),('12374','2012-12-31','11:40:00',6.34),('12374','2012-12-31','11:45:00',6.36),('12374','2012-12-31','11:50:00',6.37),('12374','2012-12-31','11:55:00',6.33),('12374','2012-12-31','12:00:00',6.4),('12374','2012-12-31','12:05:00',6.4),('12374','2012-12-31','12:10:00',6.38),('12374','2012-12-31','12:15:00',6.34),('12374','2012-12-31','12:20:00',6.35),('12374','2012-12-31','12:25:00',6.31),('12374','2012-12-31','12:30:00',6.31),('12374','2012-12-31','12:35:00',6.27),('12374','2012-12-31','12:40:00',6.21),('12374','2012-12-31','12:45:00',6.17),('12374','2012-12-31','12:50:00',6.11),('12374','2012-12-31','12:55:00',6.07),('12374','2012-12-31','13:00:00',6.01),('12374','2012-12-31','13:05:00',5.94),('12374','2012-12-31','13:10:00',5.88),('12374','2012-12-31','13:15:00',5.81),('12374','2012-12-31','13:20:00',5.7),('12374','2012-12-31','13:25:00',5.64),('12374','2012-12-31','13:30:00',5.58),('12374','2012-12-31','13:35:00',5.5),('12374','2012-12-31','13:40:00',5.4),('12374','2012-12-31','13:45:00',5.33),('12374','2012-12-31','13:50:00',5.23),('12374','2012-12-31','13:55:00',5.14),('12374','2012-12-31','14:00:00',5.03),('12374','2012-12-31','14:05:00',4.93),('12374','2012-12-31','14:10:00',4.74),('12374','2012-12-31','14:15:00',4.71),('12374','2012-12-31','14:20:00',4.62),('12374','2012-12-31','14:25:00',4.51),('12374','2012-12-31','14:30:00',4.38),('12374','2012-12-31','14:35:00',4.25),('12374','2012-12-31','14:40:00',4.14),('12374','2012-12-31','14:45:00',4.03),('12374','2012-12-31','14:50:00',3.91),('12374','2012-12-31','14:55:00',3.79),('12374','2012-12-31','15:00:00',3.66),('12374','2012-12-31','15:05:00',3.52),('12374','2012-12-31','15:10:00',3.35),('12374','2012-12-31','15:15:00',3.2),('12374','2012-12-31','15:20:00',3.06),('12374','2012-12-31','15:25:00',2.9),('12374','2012-12-31','15:30:00',2.77),('12374','2012-12-31','15:35:00',2.61),('12374','2012-12-31','15:40:00',2.41),('12374','2012-12-31','15:45:00',2.21),('12374','2012-12-31','15:50:00',1.95),('12374','2012-12-31','15:55:00',1.78),('12374','2012-12-31','16:00:00',1.58),('12374','2012-12-31','16:05:00',1.43),('12374','2012-12-31','16:10:00',1.26),('12374','2012-12-31','16:15:00',1.09),('12374','2012-12-30','08:20:00',1.25),('12374','2012-12-30','08:25:00',1.47),('12374','2012-12-30','08:30:00',1.72),('12374','2012-12-30','08:35:00',2.13),('12374','2012-12-30','08:40:00',2.12),('12374','2012-12-30','08:45:00',2.41),('12374','2012-12-30','08:50:00',2.62),('12374','2012-12-30','08:55:00',2.57),('12374','2012-12-30','09:00:00',2.84),('12374','2012-12-30','09:05:00',3.17),('12374','2012-12-30','09:10:00',3.32),('12374','2012-12-30','09:15:00',3.54),('12374','2012-12-30','09:20:00',3.73),('12374','2012-12-30','09:25:00',3.87),('12374','2012-12-30','09:30:00',4.02),('12374','2012-12-30','09:35:00',4.19),('12374','2012-12-30','09:40:00',4.39),('12374','2012-12-30','09:45:00',4.55),('12374','2012-12-30','09:50:00',4.68),('12374','2012-12-30','09:55:00',4.79),('12374','2012-12-30','10:00:00',4.95),('12374','2012-12-30','10:05:00',5.08),('12374','2012-12-30','10:10:00',5.23),('12374','2012-12-30','10:15:00',5.34),('12374','2012-12-30','10:20:00',5.44),('12374','2012-12-30','10:25:00',5.54),('12374','2012-12-30','10:30:00',5.62),('12374','2012-12-30','10:35:00',5.69),('12374','2012-12-30','10:40:00',5.76),('12374','2012-12-30','10:45:00',5.81),('12374','2012-12-30','10:50:00',5.87),('12374','2012-12-30','10:55:00',5.94),('12374','2012-12-30','11:00:00',6.03),('12374','2012-12-30','11:05:00',6.08),('12374','2012-12-30','11:10:00',6.14),('12374','2012-12-30','11:15:00',6.16),('12374','2012-12-30','11:20:00',6.2),('12374','2012-12-30','11:25:00',6.23),('12374','2012-12-30','11:30:00',6.24),('12374','2012-12-30','11:35:00',6.22),('12374','2012-12-30','11:40:00',6.22),('12374','2012-12-30','11:45:00',6.2),('12374','2012-12-30','11:50:00',6.17),('12374','2012-12-30','11:55:00',6.23),('12374','2012-12-30','12:00:00',6.28),('12374','2012-12-30','12:05:00',6.29),('12374','2012-12-30','12:10:00',6.31),('12374','2012-12-30','12:15:00',6.28),('12374','2012-12-30','12:20:00',6.25),('12374','2012-12-30','12:25:00',6.33),('12374','2012-12-30','12:30:00',6.35),('12374','2012-12-30','12:35:00',6.31),('12374','2012-12-30','12:40:00',6.26),('12374','2012-12-30','12:45:00',6.2),('12374','2012-12-30','12:50:00',6.14),('12374','2012-12-30','12:55:00',6.08),('12374','2012-12-30','13:00:00',5.91),('12374','2012-12-30','13:05:00',5.92),('12374','2012-12-30','13:10:00',5.85),('12374','2012-12-30','13:15:00',5.77),('12374','2012-12-30','13:20:00',5.7),('12374','2012-12-30','13:25:00',5.62),('12374','2012-12-30','13:30:00',5.54),('12374','2012-12-30','13:35:00',5.45),('12374','2012-12-30','13:40:00',5.37),('12374','2012-12-30','13:45:00',5.27),('12374','2012-12-30','13:50:00',5.19),('12374','2012-12-30','13:55:00',5.08),('12374','2012-12-30','14:00:00',4.96),('12374','2012-12-30','14:05:00',4.87),('12374','2012-12-30','14:10:00',4.77),('12374','2012-12-30','14:15:00',4.65),('12374','2012-12-30','14:20:00',4.53),('12374','2012-12-30','14:25:00',4.42),('12374','2012-12-30','14:30:00',4.32),('12374','2012-12-30','14:35:00',4.2),('12374','2012-12-30','14:40:00',4.07),('12374','2012-12-30','14:45:00',3.93),('12374','2012-12-30','14:50:00',3.84),('12374','2012-12-30','14:55:00',3.72),('12374','2012-12-30','15:00:00',3.6),('12374','2012-12-30','15:05:00',3.46),('12374','2012-12-30','15:10:00',3.33),('12374','2012-12-30','15:15:00',3.18),('12374','2012-12-30','15:20:00',3.04),('12374','2012-12-30','15:25:00',2.86),('12374','2012-12-30','15:30:00',2.71),('12374','2012-12-30','15:35:00',2.53),('12374','2012-12-30','15:40:00',2.32),('12374','2012-12-30','15:45:00',2.17),('12374','2012-12-30','15:50:00',2),('12374','2012-12-30','15:55:00',1.81),('12374','2012-12-30','16:00:00',1.59),('12374','2012-12-30','16:05:00',1.4),('12374','2012-12-30','16:10:00',1.22),('12374','2012-12-29','08:20:00',1.23),('12374','2012-12-29','08:25:00',1.46),('12374','2012-12-29','08:30:00',1.67),('12374','2012-12-29','08:35:00',2.05),('12374','2012-12-29','08:40:00',2.13),('12374','2012-12-29','08:45:00',2.4),('12374','2012-12-29','08:50:00',2.59),('12374','2012-12-29','08:55:00',2.52),('12374','2012-12-29','09:00:00',2.64),('12374','2012-12-29','09:05:00',3.1),('12374','2012-12-29','09:10:00',3.16),('12374','2012-12-29','09:15:00',3.39),('12374','2012-12-29','09:20:00',3.67),('12374','2012-12-29','09:25:00',3.86),('12374','2012-12-29','09:30:00',4),('12374','2012-12-29','09:35:00',4.17),('12374','2012-12-29','09:40:00',4.33),('12374','2012-12-29','09:45:00',4.51),('12374','2012-12-29','09:50:00',4.62),('12374','2012-12-29','09:55:00',4.74),('12374','2012-12-29','10:00:00',4.85),('12374','2012-12-29','10:05:00',4.97),('12374','2012-12-29','10:10:00',5.09),('12374','2012-12-29','10:15:00',5.23),('12374','2012-12-29','10:20:00',5.32),('12374','2012-12-29','10:25:00',5.4),('12374','2012-12-29','10:30:00',5.47),('12374','2012-12-29','10:35:00',5.56),('12374','2012-12-29','10:40:00',5.64),('12374','2012-12-29','10:45:00',5.71),('12374','2012-12-29','10:50:00',5.79),('12374','2012-12-29','10:55:00',5.86),('12374','2012-12-29','11:00:00',5.92),('12374','2012-12-29','11:05:00',6),('12374','2012-12-29','11:10:00',6.06),('12374','2012-12-29','11:15:00',6.14),('12374','2012-12-29','11:20:00',6.21),('12374','2012-12-29','11:25:00',6.24),('12374','2012-12-29','11:30:00',6.26),('12374','2012-12-29','11:35:00',6.29),('12374','2012-12-29','11:40:00',6.29),('12374','2012-12-29','11:45:00',6.25),('12374','2012-12-29','11:50:00',6.22),('12374','2012-12-29','11:55:00',6.23),('12374','2012-12-29','12:00:00',6.23),('12374','2012-12-29','12:05:00',6.24),('12374','2012-12-29','12:10:00',6.27),('12374','2012-12-29','12:15:00',6.29),('12374','2012-12-29','12:20:00',6.25),('12374','2012-12-29','12:25:00',6.17),('12374','2012-12-29','12:30:00',6.07),('12374','2012-12-29','12:35:00',6.13),('12374','2012-12-29','12:40:00',6.08),('12374','2012-12-29','12:45:00',6.06),('12374','2012-12-29','12:50:00',6.02),('12374','2012-12-29','12:55:00',5.97),('12374','2012-12-29','13:00:00',5.94),('12374','2012-12-29','13:05:00',5.86),('12374','2012-12-29','13:10:00',5.81),('12374','2012-12-29','13:15:00',5.75),('12374','2012-12-29','13:20:00',5.68),('12374','2012-12-29','13:25:00',5.63),('12374','2012-12-29','13:30:00',5.55),('12374','2012-12-29','13:35:00',5.47),('12374','2012-12-29','13:40:00',5.41),('12374','2012-12-29','13:45:00',5.32),('12374','2012-12-29','13:50:00',5.22),('12374','2012-12-29','13:55:00',5.16),('12374','2012-12-29','14:00:00',5.08),('12374','2012-12-29','14:05:00',4.99),('12374','2012-12-29','14:10:00',4.88),('12374','2012-12-29','14:15:00',4.76),('12374','2012-12-29','14:20:00',4.66),('12374','2012-12-29','14:25:00',4.55),('12374','2012-12-29','14:30:00',4.43),('12374','2012-12-29','14:35:00',4.31),('12374','2012-12-29','14:40:00',4.18),('12374','2012-12-29','14:45:00',4.03),('12374','2012-12-29','14:50:00',3.94),('12374','2012-12-29','14:55:00',3.82),('12374','2012-12-29','15:00:00',3.69),('12374','2012-12-29','15:05:00',3.55),('12374','2012-12-29','15:10:00',3.41),('12374','2012-12-29','15:15:00',3.28),('12374','2012-12-29','15:20:00',3.14),('12374','2012-12-29','15:25:00',2.98),('12374','2012-12-29','15:30:00',2.81),('12374','2012-12-29','15:35:00',2.63),('12374','2012-12-29','15:40:00',2.4),('12374','2012-12-29','15:45:00',2.25),('12374','2012-12-29','15:50:00',2.06),('12374','2012-12-29','15:55:00',1.88),('12374','2012-12-29','16:00:00',1.67),('12374','2012-12-29','16:05:00',1.5),('12374','2012-12-29','16:10:00',1.29),('12374','2012-12-29','16:15:00',1.09),('12374','2012-12-28','08:30:00',1.24),('12374','2012-12-28','08:35:00',1.5),('12374','2012-12-28','08:40:00',1.61),('12374','2012-12-28','08:45:00',1.93),('12374','2012-12-28','08:50:00',2.19),('12374','2012-12-28','08:55:00',2.25),('12374','2012-12-28','09:00:00',2.57),('12374','2012-12-28','09:05:00',2.62),('12374','2012-12-28','09:10:00',2.56),('12374','2012-12-28','09:15:00',2.83),('12374','2012-12-28','09:20:00',2.99),('12374','2012-12-28','09:25:00',3.33),('12374','2012-12-28','09:30:00',3.58),('12374','2012-12-28','09:35:00',3.88),('12374','2012-12-28','09:40:00',4.03),('12374','2012-12-28','09:45:00',4.15),('12374','2012-12-28','09:50:00',4.28),('12374','2012-12-28','09:55:00',4.45),('12374','2012-12-28','10:00:00',4.61),('12374','2012-12-28','10:05:00',4.7),('12374','2012-12-28','10:10:00',4.88),('12374','2012-12-28','10:15:00',5.02),('12374','2012-12-28','10:20:00',5.03),('12374','2012-12-28','10:25:00',5.14),('12374','2012-12-28','10:30:00',5.25),('12374','2012-12-28','10:35:00',5.38),('12374','2012-12-28','10:40:00',5.46),('12374','2012-12-28','10:45:00',5.53),('12374','2012-12-28','10:50:00',5.58),('12374','2012-12-28','10:55:00',5.63),('12374','2012-12-28','11:00:00',5.71),('12374','2012-12-28','11:05:00',5.8),('12374','2012-12-28','11:10:00',5.79),('12374','2012-12-28','11:15:00',5.88),('12374','2012-12-28','11:20:00',5.9),('12374','2012-12-28','11:25:00',5.97),('12374','2012-12-28','11:30:00',5.98),('12374','2012-12-28','11:35:00',5.95),('12374','2012-12-28','11:40:00',5.97),('12374','2012-12-28','11:45:00',5.97),('12374','2012-12-28','11:50:00',6.01),('12374','2012-12-28','11:55:00',6.07),('12374','2012-12-28','12:00:00',6.01),('12374','2012-12-28','12:05:00',6.12),('12374','2012-12-28','12:10:00',6.14),('12374','2012-12-28','12:15:00',6.16),('12374','2012-12-28','12:20:00',6.13),('12374','2012-12-28','12:25:00',6.05),('12374','2012-12-28','12:30:00',6),('12374','2012-12-28','12:35:00',5.94),('12374','2012-12-28','12:40:00',5.95),('12374','2012-12-28','12:45:00',5.95),('12374','2012-12-28','12:50:00',5.88),('12374','2012-12-28','12:55:00',5.87),('12374','2012-12-28','13:00:00',5.81),('12374','2012-12-28','13:05:00',5.72),('12374','2012-12-28','13:10:00',5.64),('12374','2012-12-28','13:15:00',5.53),('12374','2012-12-28','13:20:00',5.53),('12374','2012-12-28','13:25:00',5.44),('12374','2012-12-28','13:30:00',5.3),('12374','2012-12-28','13:35:00',5.22),('12374','2012-12-28','13:40:00',5.08),('12374','2012-12-28','13:45:00',5.01),('12374','2012-12-28','13:50:00',4.94),('12374','2012-12-28','13:55:00',4.85),('12374','2012-12-28','14:00:00',4.76),('12374','2012-12-28','14:05:00',4.64),('12374','2012-12-28','14:10:00',4.51),('12374','2012-12-28','14:15:00',4.4),('12374','2012-12-28','14:20:00',4.26),('12374','2012-12-28','14:25:00',4.21),('12374','2012-12-28','14:30:00',4.09),('12374','2012-12-28','14:35:00',3.97),('12374','2012-12-28','14:40:00',3.85),('12374','2012-12-28','14:45:00',3.74),('12374','2012-12-28','14:50:00',3.62),('12374','2012-12-28','14:55:00',3.5),('12374','2012-12-28','15:00:00',3.35),('12374','2012-12-28','15:05:00',3.21),('12374','2012-12-28','15:10:00',3.09),('12374','2012-12-28','15:15:00',2.94),('12374','2012-12-28','15:20:00',2.78),('12374','2012-12-28','15:25:00',2.61),('12374','2012-12-28','15:30:00',2.45),('12374','2012-12-28','15:35:00',2.25),('12374','2012-12-28','15:40:00',2.02),('12374','2012-12-28','15:45:00',1.89),('12374','2012-12-28','15:50:00',1.68),('12374','2012-12-28','15:55:00',1.51),('12374','2012-12-28','16:00:00',1.35),('12374','2012-12-28','16:05:00',1.2),('12374','2012-12-28','16:10:00',1.02),('12374','2012-12-27','08:25:00',1.03),('12374','2012-12-27','08:30:00',1.26),('12374','2012-12-27','08:35:00',1.29),('12374','2012-12-27','09:00:00',1.93),('12374','2012-12-27','09:05:00',2),('12374','2012-12-27','09:10:00',1.79),('12374','2012-12-27','09:15:00',1.28),('12374','2012-12-27','09:20:00',1.08),('12374','2012-12-27','09:25:00',1.35),('12374','2012-12-27','09:30:00',3.59),('12374','2012-12-27','09:35:00',3.84),('12374','2012-12-27','09:40:00',3.92),('12374','2012-12-27','09:45:00',4.02),('12374','2012-12-27','09:50:00',4.1),('12374','2012-12-27','09:55:00',4.24),('12374','2012-12-27','10:00:00',4.33),('12374','2012-12-27','10:05:00',4.49),('12374','2012-12-27','10:10:00',4.64),('12374','2012-12-27','10:15:00',4.67),('12374','2012-12-27','10:20:00',4.8),('12374','2012-12-27','10:25:00',4.88),('12374','2012-12-27','10:30:00',4.89),('12374','2012-12-27','10:35:00',5.04),('12374','2012-12-27','10:40:00',5.17),('12374','2012-12-27','10:45:00',5.23),('12374','2012-12-27','10:50:00',5.28),('12374','2012-12-27','10:55:00',5.39),('12374','2012-12-27','11:00:00',5.4),('12374','2012-12-27','11:05:00',5.49),('12374','2012-12-27','11:10:00',5.6),('12374','2012-12-27','11:15:00',5.66),('12374','2012-12-27','11:20:00',5.68),('12374','2012-12-27','11:25:00',5.66),('12374','2012-12-27','11:30:00',5.68),('12374','2012-12-27','11:35:00',5.9),('12374','2012-12-27','11:40:00',5.46),('12374','2012-12-27','11:45:00',5.79),('12374','2012-12-27','11:50:00',6.03),('12374','2012-12-27','11:55:00',5.87),('12374','2012-12-27','12:00:00',5.79),('12374','2012-12-27','12:05:00',5.73),('12374','2012-12-27','12:10:00',5.85),('12374','2012-12-27','12:15:00',5.93),('12374','2012-12-27','12:20:00',5.91),('12374','2012-12-27','12:25:00',5.92),('12374','2012-12-27','12:30:00',5.89),('12374','2012-12-27','12:35:00',5.89),('12374','2012-12-27','12:40:00',5.91),('12374','2012-12-27','12:45:00',5.87),('12374','2012-12-27','12:50:00',5.89),('12374','2012-12-27','12:55:00',5.8),('12374','2012-12-27','13:00:00',5.69),('12374','2012-12-27','13:05:00',5.62),('12374','2012-12-27','13:10:00',5.58),('12374','2012-12-27','13:15:00',5.57),('12374','2012-12-27','13:20:00',5.48),('12374','2012-12-27','13:25:00',5.42),('12374','2012-12-27','13:30:00',4.58),('12374','2012-12-27','13:35:00',1.26),('12374','2012-12-27','13:40:00',1.9),('12374','2012-12-27','13:45:00',2.2),('12374','2012-12-27','13:50:00',1.91),('12374','2012-12-27','13:55:00',2.28),('12374','2012-12-27','14:00:00',2.2),('12374','2012-12-27','14:05:00',2.24),('12374','2012-12-27','14:10:00',2.3),('12374','2012-12-27','14:15:00',1.71),('12374','2012-12-27','14:20:00',2.17),('12374','2012-12-27','14:25:00',4.05),('12374','2012-12-27','14:30:00',4.04),('12374','2012-12-27','14:35:00',4.05),('12374','2012-12-27','14:40:00',3.88),('12374','2012-12-27','14:45:00',3.7),('12374','2012-12-27','14:50:00',4),('12374','2012-12-27','14:55:00',3.71),('12374','2012-12-27','15:00:00',3.56),('12374','2012-12-27','15:05:00',3.43),('12374','2012-12-27','15:10:00',3.3),('12374','2012-12-27','15:15:00',3.18),('12374','2012-12-27','15:20:00',2.69),('12374','2012-12-27','15:25:00',2.54),('12374','2012-12-27','15:30:00',2.73),('12374','2012-12-27','15:35:00',2.81),('12374','2012-12-27','15:40:00',1.59),('12374','2012-12-27','15:45:00',1.39),('12374','2012-12-27','15:50:00',1.89),('12374','2012-12-27','15:55:00',1.85),('12374','2012-12-27','16:00:00',1.44),('12374','2012-12-26','08:45:00',1.02),('12374','2012-12-26','09:00:00',2.08),('12374','2012-12-26','09:05:00',2.49),('12374','2012-12-26','09:10:00',2.75),('12374','2012-12-26','09:15:00',3.09),('12374','2012-12-26','09:20:00',3.24),('12374','2012-12-26','09:25:00',3.44),('12374','2012-12-26','09:30:00',3.69),('12374','2012-12-26','09:35:00',3.98),('12374','2012-12-26','09:40:00',4.02),('12374','2012-12-26','09:45:00',4.01),('12374','2012-12-26','09:50:00',4.49),('12374','2012-12-26','09:55:00',4.78),('12374','2012-12-26','10:00:00',4.74),('12374','2012-12-26','10:05:00',1.79),('12374','2012-12-26','10:10:00',1.47),('12374','2012-12-26','10:15:00',1.34),('12374','2012-12-26','10:20:00',1.23),('12374','2012-12-26','10:25:00',1.07),('12374','2012-12-26','10:30:00',1.02),('12374','2012-12-26','10:35:00',1.01),('12374','2012-12-26','10:40:00',1.11),('12374','2012-12-26','10:45:00',1.09),('12374','2012-12-26','11:15:00',1.12),('12374','2012-12-26','11:20:00',1.19),('12374','2012-12-26','11:25:00',1.16),('12374','2012-12-26','11:30:00',1.12),('12374','2012-12-26','11:35:00',1.11),('12374','2012-12-26','11:40:00',1.03),('12374','2012-12-26','11:55:00',1.21),('12374','2012-12-26','12:00:00',1.43),('12374','2012-12-26','12:05:00',1.4),('12374','2012-12-26','12:10:00',1.19),('12374','2012-12-26','12:15:00',1.14),('12374','2012-12-26','12:20:00',1.18),('12374','2012-12-26','12:25:00',1.22),('12374','2012-12-26','12:30:00',1.1),('12374','2012-12-26','12:35:00',1.24),('12374','2012-12-26','12:40:00',1.25),('12374','2012-12-26','12:45:00',1.05),('12374','2012-12-26','13:20:00',1.21),('12374','2012-12-26','13:25:00',1.42),('12374','2012-12-26','13:30:00',1.61),('12374','2012-12-26','13:35:00',1.47),('12374','2012-12-26','13:40:00',1.14),('12374','2012-12-26','14:40:00',1.01),('12374','2012-12-26','14:45:00',1.01),('12374','2012-12-26','14:50:00',1.04),('12374','2012-12-26','14:55:00',1.19),('12374','2012-12-26','15:00:00',1.24),('12374','2012-12-25','09:35:00',1.05),('12374','2012-12-25','09:40:00',1.13),('12374','2012-12-25','09:45:00',1.13),('12374','2012-12-25','09:50:00',1.21),('12374','2012-12-25','09:55:00',1.18),('12374','2012-12-25','10:00:00',1.12),('12374','2012-12-25','10:05:00',1.18),('12374','2012-12-25','10:10:00',1.23),('12374','2012-12-25','10:15:00',1.26),('12374','2012-12-25','10:20:00',1.3),('12374','2012-12-25','10:25:00',1.34),('12374','2012-12-25','10:30:00',1.31),('12374','2012-12-25','10:35:00',1.32),('12374','2012-12-25','10:40:00',1.34),('12374','2012-12-25','10:45:00',1.26),('12374','2012-12-25','10:50:00',1.24),('12374','2012-12-25','10:55:00',1.15),('12374','2012-12-25','11:00:00',1.21),('12374','2012-12-25','11:05:00',1.3),('12374','2012-12-25','11:10:00',1.3),('12374','2012-12-25','11:15:00',1.42),('12374','2012-12-25','11:20:00',1.26),('12374','2012-12-25','11:25:00',1.37),('12374','2012-12-25','11:30:00',1.69),('12374','2012-12-25','11:35:00',1.73),('12374','2012-12-25','11:40:00',1.93),('12374','2012-12-25','11:45:00',1.82),('12374','2012-12-25','11:50:00',1.7),('12374','2012-12-25','11:55:00',1.97),('12374','2012-12-25','12:00:00',1.85),('12374','2012-12-25','12:05:00',1.72),('12374','2012-12-25','12:10:00',1.67),('12374','2012-12-25','12:15:00',1.67),('12374','2012-12-25','12:20:00',1.33),('12374','2012-12-25','12:25:00',1.43),('12374','2012-12-25','12:30:00',1.5),('12374','2012-12-25','12:35:00',1.67),('12374','2012-12-25','12:40:00',1.93),('12374','2012-12-25','12:45:00',2.28),('12374','2012-12-25','12:50:00',2.76),('12374','2012-12-25','12:55:00',3.05),('12374','2012-12-25','13:00:00',2.87),('12374','2012-12-25','13:05:00',2.41),('12374','2012-12-25','13:10:00',2.01),('12374','2012-12-25','13:15:00',1.92),('12374','2012-12-25','13:20:00',2.17),('12374','2012-12-25','13:25:00',2.26),('12374','2012-12-25','13:30:00',2.15),('12374','2012-12-25','13:35:00',2.14),('12374','2012-12-25','13:40:00',1.57),('12374','2012-12-25','13:45:00',1.84),('12374','2012-12-25','13:50:00',1.55),('12374','2012-12-25','13:55:00',1.41),('12374','2012-12-25','14:00:00',1.18),('12374','2012-12-25','14:05:00',1.1),('12374','2012-12-25','14:10:00',1.44),('12374','2012-12-25','14:15:00',1.85),('12374','2012-12-25','14:20:00',1.91),('12374','2012-12-25','14:25:00',1.72),('12374','2012-12-25','14:30:00',1.34),('12374','2012-12-25','14:35:00',1.22),('12374','2012-12-25','14:40:00',1.07),('12374','2012-12-25','15:00:00',1.11),('12374','2012-12-25','15:05:00',1.09),('12374','2012-12-25','15:10:00',1.29),('12374','2012-12-25','15:15:00',1.45),('12374','2012-12-25','15:20:00',1.14),('12374','2012-12-25','15:25:00',1.07),('12374','2012-12-25','15:30:00',1.24),('12374','2012-12-25','15:35:00',1.22),('12374','2012-12-25','15:40:00',1.07),('12374','2012-12-25','15:45:00',1.1),('12374','2012-12-24','10:35:00',1.03),('12374','2012-12-24','10:40:00',1.12),('12374','2012-12-24','10:45:00',1.22),('12374','2012-12-24','10:50:00',1.23),('12374','2012-12-24','10:55:00',1.31),('12374','2012-12-24','11:00:00',1.43),('12374','2012-12-24','11:05:00',1.37),('12374','2012-12-24','11:10:00',1.38),('12374','2012-12-24','11:15:00',1.34),('12374','2012-12-24','11:20:00',1.34),('12374','2012-12-24','11:25:00',1.41),('12374','2012-12-24','11:30:00',1.52),('12374','2012-12-24','11:35:00',1.51),('12374','2012-12-24','11:40:00',1.51),('12374','2012-12-24','11:45:00',1.57),('12374','2012-12-24','11:50:00',1.57),('12374','2012-12-24','11:55:00',1.5),('12374','2012-12-24','12:00:00',1.53),('12374','2012-12-24','12:05:00',1.41),('12374','2012-12-24','12:10:00',1.24),('12374','2012-12-24','12:15:00',1.34),('12374','2012-12-24','12:20:00',1.33),('12374','2012-12-24','12:25:00',1.36),('12374','2012-12-24','12:30:00',1.33),('12374','2012-12-24','12:35:00',1.27),('12374','2012-12-24','12:40:00',1.23),('12374','2012-12-24','12:45:00',1.2),('12374','2012-12-24','12:50:00',1.26),('12374','2012-12-24','12:55:00',1.17),('12374','2012-12-24','13:00:00',1.11),('12374','2012-12-24','13:05:00',1.11),('12374','2012-12-24','13:10:00',1.18),('12374','2012-12-24','13:15:00',1.25),('12374','2012-12-24','13:20:00',1.28),('12374','2012-12-24','13:25:00',1.3),('12374','2012-12-24','13:30:00',1.23),('12374','2012-12-24','13:35:00',1.14),('12374','2012-12-24','13:40:00',1.03),('12374','2012-12-23','08:20:00',1.21),('12374','2012-12-23','08:25:00',1.49),('12374','2012-12-23','08:30:00',1.77),('12374','2012-12-23','08:35:00',1.92),('12374','2012-12-23','08:40:00',2.15),('12374','2012-12-23','08:45:00',2.33),('12374','2012-12-23','08:50:00',2.29),('12374','2012-12-23','08:55:00',2.68),('12374','2012-12-23','09:00:00',2.68),('12374','2012-12-23','09:05:00',2.9),('12374','2012-12-23','09:10:00',3.06),('12374','2012-12-23','09:15:00',3.2),('12374','2012-12-23','09:20:00',3.37),('12374','2012-12-23','09:25:00',3.52),('12374','2012-12-23','09:30:00',3.75),('12374','2012-12-23','09:35:00',4),('12374','2012-12-23','09:40:00',4.26),('12374','2012-12-23','09:45:00',4.21),('12374','2012-12-23','09:50:00',4.31),('12374','2012-12-23','09:55:00',4.44),('12374','2012-12-23','10:00:00',4.58),('12374','2012-12-23','10:05:00',4.85),('12374','2012-12-23','10:10:00',4.99),('12374','2012-12-23','10:15:00',5.09),('12374','2012-12-23','10:20:00',5.2),('12374','2012-12-23','10:25:00',5.23),('12374','2012-12-23','10:30:00',5.35),('12374','2012-12-23','10:35:00',5.37),('12374','2012-12-23','10:40:00',5.33),('12374','2012-12-23','10:45:00',5.55),('12374','2012-12-23','10:50:00',5.63),('12374','2012-12-23','10:55:00',5.57),('12374','2012-12-23','11:00:00',5.67),('12374','2012-12-23','11:05:00',5.86),('12374','2012-12-23','11:10:00',5.66),('12374','2012-12-23','11:15:00',5.6),('12374','2012-12-23','11:20:00',5.34),('12374','2012-12-23','11:25:00',5.79),('12374','2012-12-23','11:30:00',6.05),('12374','2012-12-23','11:35:00',6.03),('12374','2012-12-23','11:40:00',5.56),('12374','2012-12-23','11:45:00',6.09),('12374','2012-12-23','11:50:00',6.05),('12374','2012-12-23','11:55:00',5.63),('12374','2012-12-23','12:00:00',5.28),('12374','2012-12-23','12:05:00',5.99),('12374','2012-12-23','12:10:00',5.95),('12374','2012-12-23','12:15:00',5.89),('12374','2012-12-23','12:20:00',5.68),('12374','2012-12-23','12:25:00',5.43),('12374','2012-12-23','12:30:00',5.23),('12374','2012-12-23','12:35:00',6),('12374','2012-12-23','12:40:00',5.97),('12374','2012-12-23','12:45:00',5.93),('12374','2012-12-23','12:50:00',5.91),('12374','2012-12-23','12:55:00',4.58),('12374','2012-12-23','13:00:00',4.56),('12374','2012-12-23','13:05:00',4.66),('12374','2012-12-23','13:10:00',4.64),('12374','2012-12-23','13:15:00',5.17),('12374','2012-12-23','13:20:00',4.2),('12374','2012-12-23','13:25:00',4.45),('12374','2012-12-23','13:30:00',3.16),('12374','2012-12-23','13:35:00',2.26),('12374','2012-12-23','13:40:00',3.6),('12374','2012-12-23','13:45:00',5.04),('12374','2012-12-23','13:50:00',5),('12374','2012-12-23','13:55:00',4.68),('12374','2012-12-23','14:00:00',3.99),('12374','2012-12-23','14:05:00',3.33),('12374','2012-12-23','14:10:00',2.55),('12374','2012-12-23','14:15:00',2.45),('12374','2012-12-23','14:20:00',2.27),('12374','2012-12-23','14:25:00',2.26),('12374','2012-12-23','14:30:00',3.03),('12374','2012-12-23','14:35:00',3.59),('12374','2012-12-23','14:40:00',3.96),('12374','2012-12-23','14:45:00',4.11),('12374','2012-12-23','14:50:00',3.79),('12374','2012-12-23','14:55:00',3.7),('12374','2012-12-23','15:00:00',3.39),('12374','2012-12-23','15:05:00',3.17),('12374','2012-12-23','15:10:00',3.12),('12374','2012-12-23','15:15:00',2.03),('12374','2012-12-23','15:20:00',1.06),('12374','2012-12-23','15:25:00',1.1),('12374','2012-12-23','15:30:00',2.34),('12374','2012-12-23','15:35:00',2.39),('12374','2012-12-23','15:40:00',2.23),('12374','2012-12-23','15:45:00',2.02),('12374','2012-12-23','15:50:00',1.71),('12374','2012-12-23','15:55:00',1.42),('12374','2012-12-22','10:00:00',1.03),('12374','2012-12-22','10:05:00',1.07),('12374','2012-12-22','10:10:00',1.12),('12374','2012-12-22','10:15:00',1.23),('12374','2012-12-22','10:20:00',1.4),('12374','2012-12-22','10:25:00',1.64),('12374','2012-12-22','10:30:00',1.87),('12374','2012-12-22','10:35:00',1.74),('12374','2012-12-22','10:40:00',1.58),('12374','2012-12-22','10:45:00',1.54),('12374','2012-12-22','10:50:00',1.8),('12374','2012-12-22','10:55:00',1.9),('12374','2012-12-22','11:00:00',1.96),('12374','2012-12-22','11:05:00',2.16),('12374','2012-12-22','11:10:00',2.18),('12374','2012-12-22','11:15:00',2.73),('12374','2012-12-22','11:20:00',2.89),('12374','2012-12-22','11:25:00',3.84),('12374','2012-12-22','11:30:00',4.72),('12374','2012-12-22','11:35:00',5.56),('12374','2012-12-22','11:40:00',6.68),('12374','2012-12-22','11:45:00',4.25),('12374','2012-12-22','11:50:00',3.37),('12374','2012-12-22','11:55:00',1.96),('12374','2012-12-22','12:00:00',2.28),('12374','2012-12-22','12:05:00',1.91),('12374','2012-12-22','12:10:00',2.8),('12374','2012-12-22','12:15:00',1.47),('12374','2012-12-22','12:20:00',2.94),('12374','2012-12-22','12:25:00',1.79),('12374','2012-12-22','12:30:00',1.44),('12374','2012-12-22','12:35:00',1.08),('12374','2012-12-22','12:45:00',1.01),('12374','2012-12-22','12:50:00',1.1),('12374','2012-12-22','12:55:00',1.24),('12374','2012-12-22','13:00:00',1.7),('12374','2012-12-22','13:05:00',1.9),('12374','2012-12-22','13:10:00',1.5),('12374','2012-12-22','13:15:00',1.86),('12374','2012-12-22','13:20:00',1.22),('12374','2012-12-22','13:25:00',1.18),('12374','2012-12-22','13:30:00',1.43),('12374','2012-12-22','13:35:00',1.48),('12374','2012-12-22','13:40:00',4.4),('12374','2012-12-22','13:45:00',2.16),('12374','2012-12-22','13:50:00',1.37),('12374','2012-12-22','14:00:00',3.17),('12374','2012-12-22','14:05:00',5.05),('12374','2012-12-22','14:10:00',4.99),('12374','2012-12-22','14:15:00',4.62),('12374','2012-12-22','14:20:00',4.09),('12374','2012-12-22','14:25:00',4.57),('12374','2012-12-22','14:30:00',4.63),('12374','2012-12-22','14:35:00',4.62),('12374','2012-12-22','14:40:00',4.17),('12374','2012-12-22','14:45:00',3.42),('12374','2012-12-22','14:50:00',2.62),('12374','2012-12-22','14:55:00',3.46),('12374','2012-12-22','15:00:00',3.31),('12374','2012-12-22','15:05:00',2.53),('12374','2012-12-22','15:10:00',2.77),('12374','2012-12-22','15:15:00',2.48),('12374','2012-12-22','15:20:00',2.83),('12374','2012-12-22','15:25:00',2.52),('12374','2012-12-22','15:30:00',2.55),('12374','2012-12-22','15:35:00',2.27),('12374','2012-12-22','15:40:00',2.06),('12374','2012-12-22','15:45:00',1.9),('12374','2012-12-22','15:50:00',1.7),('12374','2012-12-22','15:55:00',1.51),('12374','2012-12-22','16:00:00',1.32),('12374','2012-12-22','16:05:00',1.14),('12664','2014-05-05','07:50:00',1.06),('12664','2014-05-05','07:55:00',1.15),('12664','2014-05-05','08:00:00',1.24),('12664','2014-05-05','08:05:00',1.34),('12664','2014-05-05','08:10:00',1.43),('12664','2014-05-05','08:15:00',1.53),('12664','2014-05-05','08:20:00',1.64),('12664','2014-05-05','08:25:00',1.74),('12664','2014-05-05','08:30:00',1.82),('12664','2014-05-05','08:35:00',1.91),('12664','2014-05-05','08:40:00',2),('12664','2014-05-05','08:45:00',2.09),('12664','2014-05-05','08:50:00',2.18),('12664','2014-05-05','08:55:00',2.26),('12664','2014-05-05','09:00:00',2.33),('12664','2014-05-05','09:05:00',2.42),('12664','2014-05-05','09:10:00',2.49),('12664','2014-05-05','09:15:00',2.56),('12664','2014-05-05','09:20:00',2.65),('12664','2014-05-05','09:25:00',2.73),('12664','2014-05-05','09:30:00',2.8),('12664','2014-05-05','09:35:00',2.88),('12664','2014-05-05','09:40:00',2.95),('12664','2014-05-05','09:45:00',3),('12664','2014-05-05','09:50:00',3.06),('12664','2014-05-05','09:55:00',3.14),('12664','2014-05-05','10:00:00',3.2),('12664','2014-05-05','10:05:00',3.27),('12664','2014-05-05','10:10:00',3.34),('12664','2014-05-05','10:15:00',3.39),('12664','2014-05-05','10:20:00',3.44),('12664','2014-05-05','10:25:00',3.49),('12664','2014-05-05','10:30:00',3.53),('12664','2014-05-05','10:35:00',3.59),('12664','2014-05-05','10:40:00',3.66),('12664','2014-05-05','10:45:00',3.69),('12664','2014-05-05','10:50:00',3.72),('12664','2014-05-05','10:55:00',3.74),('12664','2014-05-05','11:00:00',3.79),('12664','2014-05-05','11:05:00',3.84),('12664','2014-05-05','11:10:00',3.88),('12664','2014-05-05','11:15:00',3.92),('12664','2014-05-05','11:20:00',3.96),('12664','2014-05-05','11:25:00',4),('12664','2014-05-05','11:30:00',4.07),('12664','2014-05-05','11:35:00',4.11),('12664','2014-05-05','11:40:00',4.18),('12664','2014-05-05','11:45:00',4.24),('12664','2014-05-05','11:50:00',4.28),('12664','2014-05-05','11:55:00',4.26),('12664','2014-05-05','12:00:00',4.36),('12664','2014-05-05','12:05:00',4.27),('12664','2014-05-05','12:10:00',4.29),('12664','2014-05-05','12:15:00',4.22),('12664','2014-05-05','12:20:00',4.26),('12664','2014-05-05','12:25:00',4.29),('12664','2014-05-05','12:30:00',4.28),('12664','2014-05-05','12:35:00',4.29),('12664','2014-05-05','12:40:00',4.28),('12664','2014-05-05','12:45:00',4.27),('12664','2014-05-05','12:50:00',4.24),('12664','2014-05-05','12:55:00',4.22),('12664','2014-05-05','13:00:00',4.19),('12664','2014-05-05','13:05:00',4.2),('12664','2014-05-05','13:10:00',4.2),('12664','2014-05-05','13:15:00',4.29),('12664','2014-05-05','13:20:00',3.61),('12664','2014-05-05','13:25:00',4.29),('12664','2014-05-05','13:30:00',1.61),('12664','2014-05-05','13:40:00',1.27),('12664','2014-05-05','13:45:00',4.41),('12664','2014-05-05','13:50:00',4.85),('12664','2014-05-05','13:55:00',4.1),('12664','2014-05-05','14:00:00',2.55),('12664','2014-05-05','14:05:00',4.52),('12664','2014-05-05','14:10:00',4.51),('12664','2014-05-05','14:15:00',4.35),('12664','2014-05-05','14:20:00',4.24),('12664','2014-05-05','14:25:00',4.24),('12664','2014-05-05','14:30:00',4.26),('12664','2014-05-05','14:35:00',4.16),('12664','2014-05-05','14:40:00',4.08),('12664','2014-05-05','14:45:00',3.58),('12664','2014-05-05','14:50:00',4.07),('12664','2014-05-05','14:55:00',4.03),('12664','2014-05-05','15:00:00',3.88),('12664','2014-05-05','15:05:00',3.82),('12664','2014-05-05','15:10:00',3.77),('12664','2014-05-05','15:15:00',3.75),('12664','2014-05-05','15:20:00',3.64),('12664','2014-05-05','15:25:00',3.55),('12664','2014-05-05','15:30:00',3.56),('12664','2014-05-05','15:35:00',3.51),('12664','2014-05-05','15:40:00',3.46),('12664','2014-05-05','15:45:00',3.41),('12664','2014-05-05','15:50:00',3.35),('12664','2014-05-05','15:55:00',3.29),('12664','2014-05-05','16:00:00',3.21),('12664','2014-05-05','16:05:00',3.14),('12664','2014-05-05','16:10:00',3.09),('12664','2014-05-05','16:15:00',3.04),('12664','2014-05-05','16:20:00',2.97),('12664','2014-05-05','16:25:00',2.88),('12664','2014-05-05','16:30:00',2.79),('12664','2014-05-05','16:35:00',2.74),('12664','2014-05-05','16:40:00',2.67),('12664','2014-05-05','16:45:00',2.58),('12664','2014-05-05','16:50:00',2.5),('12664','2014-05-05','16:55:00',2.41),('12664','2014-05-05','17:00:00',2.31),('12664','2014-05-05','17:05:00',2.24),('12664','2014-05-05','17:10:00',2.15),('12664','2014-05-05','17:15:00',2.06),('12664','2014-05-05','17:20:00',1.98),('12664','2014-05-05','17:25:00',1.91),('12664','2014-05-05','17:30:00',1.9),('12664','2014-05-05','17:35:00',1.75),('12664','2014-05-05','17:40:00',1.6),('12664','2014-05-05','17:45:00',1.52),('12664','2014-05-05','17:50:00',1.47),('12664','2014-05-05','17:55:00',1.33),('12664','2014-05-05','18:00:00',1.24),('12664','2014-05-05','18:05:00',1.16),('12664','2014-05-05','18:10:00',1.08),('12664','2014-05-04','07:40:00',1.12),('12664','2014-05-04','07:45:00',1.27),('12664','2014-05-04','07:50:00',1.22),('12664','2014-05-04','07:55:00',1.21),('12664','2014-05-04','08:00:00',1.31),('12664','2014-05-04','08:05:00',1.49),('12664','2014-05-04','08:10:00',1.53),('12664','2014-05-04','08:15:00',1.65),('12664','2014-05-04','08:20:00',1.78),('12664','2014-05-04','08:25:00',1.38),('12664','2014-05-04','08:30:00',1.3),('12664','2014-05-04','08:45:00',1.84),('12664','2014-05-04','08:50:00',1.19),('12664','2014-05-04','08:55:00',1.25),('12664','2014-05-04','09:05:00',1.05),('12664','2014-05-04','09:10:00',1.4),('12664','2014-05-04','09:15:00',1.84),('12664','2014-05-04','09:20:00',2.1),('12664','2014-05-04','09:25:00',1.89),('12664','2014-05-04','09:30:00',3.53),('12664','2014-05-04','09:35:00',2.79),('12664','2014-05-04','09:40:00',2.26),('12664','2014-05-04','09:45:00',1.39),('12664','2014-05-04','09:50:00',3.45),('12664','2014-05-04','09:55:00',4.08),('12664','2014-05-04','10:00:00',3.92),('12664','2014-05-04','10:05:00',3.37),('12664','2014-05-04','10:10:00',2.59),('12664','2014-05-04','10:15:00',3.49),('12664','2014-05-04','10:20:00',2.32),('12664','2014-05-04','10:25:00',2.16),('12664','2014-05-04','10:30:00',1.78),('12664','2014-05-04','10:35:00',1.8),('12664','2014-05-04','10:40:00',1.82),('12664','2014-05-04','10:45:00',1.87),('12664','2014-05-04','10:50:00',2.19),('12664','2014-05-04','10:55:00',4.14),('12664','2014-05-04','11:00:00',3.88),('12664','2014-05-04','11:05:00',2.72),('12664','2014-05-04','11:10:00',3.55),('12664','2014-05-04','11:15:00',4.24),('12664','2014-05-04','11:20:00',4.13),('12664','2014-05-04','11:25:00',4.12),('12664','2014-05-04','11:30:00',4.21),('12664','2014-05-04','11:35:00',4.34),('12664','2014-05-04','11:40:00',2.65),('12664','2014-05-04','11:45:00',1.6),('12664','2014-05-04','11:50:00',1.66),('12664','2014-05-04','11:55:00',1.65),('12664','2014-05-04','12:00:00',2.05),('12664','2014-05-04','12:05:00',4.79),('12664','2014-05-04','12:10:00',4.63),('12664','2014-05-04','12:15:00',4.65),('12664','2014-05-04','12:20:00',4.23),('12664','2014-05-04','12:25:00',2.01),('12664','2014-05-04','12:30:00',1.14),('12664','2014-05-04','12:35:00',1.02),('12664','2014-05-04','12:40:00',1.33),('12664','2014-05-04','12:45:00',1.92),('12664','2014-05-04','12:50:00',2.32),('12664','2014-05-04','12:55:00',1.82),('12664','2014-05-04','13:00:00',1.65),('12664','2014-05-04','13:05:00',1.42),('12664','2014-05-04','13:10:00',1.36),('12664','2014-05-04','13:15:00',1.28),('12664','2014-05-04','13:20:00',1.28),('12664','2014-05-04','13:25:00',1.32),('12664','2014-05-04','13:30:00',1.33),('12664','2014-05-04','13:35:00',1.42),('12664','2014-05-04','13:40:00',1.62),('12664','2014-05-04','13:45:00',4.03),('12664','2014-05-04','13:50:00',1.65),('12664','2014-05-04','13:55:00',1.14),('12664','2014-05-04','14:20:00',1.07),('12664','2014-05-04','14:25:00',1.25),('12664','2014-05-04','14:30:00',1.25),('12664','2014-05-04','14:35:00',1.41),('12664','2014-05-04','14:40:00',1.98),('12664','2014-05-04','14:45:00',2.72),('12664','2014-05-04','14:50:00',3.49),('12664','2014-05-04','14:55:00',4.31),('12664','2014-05-04','15:00:00',4.27),('12664','2014-05-04','15:05:00',4.38),('12664','2014-05-04','15:10:00',2.82),('12664','2014-05-04','15:15:00',1.56),('12664','2014-05-04','15:20:00',1.63),('12664','2014-05-04','15:25:00',2.24),('12664','2014-05-04','15:30:00',1.4),('12664','2014-05-04','17:35:00',1.08),('12664','2014-04-25','08:15:00',1.22),('12664','2014-04-25','08:20:00',1.32),('12664','2014-04-25','08:25:00',1.37),('12664','2014-04-25','08:30:00',1.45),('12664','2014-04-25','08:35:00',1.56),('12664','2014-04-25','08:40:00',1.65),('12664','2014-04-25','08:45:00',1.73),('12664','2014-04-25','08:50:00',1.45),('12664','2014-04-25','08:55:00',1.16),('12664','2014-04-25','09:40:00',1.19),('12664','2014-04-25','09:45:00',1.5),('12664','2014-04-25','09:50:00',1.32),('12664','2014-04-25','09:55:00',1.2),('12664','2014-04-25','10:00:00',1.24),('12664','2014-04-25','10:05:00',1.29),('12664','2014-04-25','10:10:00',1.64),('12664','2014-04-25','10:15:00',2.05),('12664','2014-04-25','10:20:00',1.51),('12664','2014-04-25','10:35:00',1.23),('12664','2014-04-25','10:40:00',2.05),('12664','2014-04-25','10:45:00',1.27),('12664','2014-04-25','10:55:00',1.56),('12664','2014-04-25','11:00:00',2.26),('12664','2014-04-25','11:05:00',2.25),('12664','2014-04-25','11:10:00',2.31),('12664','2014-04-25','11:15:00',1.67),('12664','2014-04-25','11:20:00',1.66),('12664','2014-04-25','11:25:00',3.44),('12664','2014-04-25','11:30:00',4.07),('12664','2014-04-25','11:35:00',4.13),('12664','2014-04-25','11:40:00',2.34),('12664','2014-04-25','11:45:00',1.33),('12664','2014-04-25','11:55:00',2.96),('12664','2014-04-25','12:00:00',2.96),('12664','2014-04-25','12:05:00',1.55),('12664','2014-04-25','12:10:00',2.03),('12664','2014-04-25','12:15:00',4.38),('12664','2014-04-25','12:20:00',1.56),('12664','2014-04-25','12:25:00',2.56),('12664','2014-04-25','12:30:00',2.42),('12664','2014-04-25','12:35:00',2),('12664','2014-04-25','12:40:00',1.83),('12664','2014-04-25','12:45:00',1.6),('12664','2014-04-25','12:50:00',1.25),('12664','2014-04-25','12:55:00',3.7),('12664','2014-04-25','13:00:00',4.16),('12664','2014-04-25','13:05:00',4.03),('12664','2014-04-25','13:10:00',3.88),('12664','2014-04-25','13:15:00',4.53),('12664','2014-04-25','13:20:00',3.51),('12664','2014-04-25','13:25:00',4.39),('12664','2014-04-25','13:30:00',4.34),('12664','2014-04-25','13:35:00',4.31),('12664','2014-04-25','13:40:00',4.16),('12664','2014-04-25','13:45:00',2.57),('12664','2014-04-25','13:50:00',3.42),('12664','2014-04-25','13:55:00',3.98),('12664','2014-04-25','14:00:00',3.72),('12664','2014-04-25','14:05:00',4),('12664','2014-04-25','14:10:00',3.93),('12664','2014-04-25','14:15:00',3.91),('12664','2014-04-25','14:20:00',3.89),('12664','2014-04-25','14:25:00',3.89),('12664','2014-04-25','14:30:00',3.84),('12664','2014-04-25','14:35:00',3.8),('12664','2014-04-25','14:40:00',3.77),('12664','2014-04-25','14:45:00',3.75),('12664','2014-04-25','14:50:00',3.71),('12664','2014-04-25','14:55:00',3.67),('12664','2014-04-25','15:00:00',3.6),('12664','2014-04-25','15:05:00',3.58),('12664','2014-04-25','15:10:00',3.5),('12664','2014-04-25','15:15:00',3.39),('12664','2014-04-25','15:20:00',3.18),('12664','2014-04-25','15:25:00',3.38),('12664','2014-04-25','15:30:00',3.37),('12664','2014-04-25','15:35:00',3.31),('12664','2014-04-25','15:40:00',3.25),('12664','2014-04-25','15:45:00',3.16),('12664','2014-04-25','15:50:00',3.13),('12664','2014-04-25','15:55:00',3.06),('12664','2014-04-25','16:00:00',2.88),('12664','2014-04-25','16:05:00',2.85),('12664','2014-04-25','16:10:00',2.59),('12664','2014-04-25','16:15:00',2.5),('12664','2014-04-25','16:20:00',2.66),('12664','2014-04-25','16:25:00',2.42),('12664','2014-04-25','16:30:00',2.24),('12664','2014-04-25','16:35:00',2.48),('12664','2014-04-25','16:40:00',2.42),('12664','2014-04-25','16:45:00',2.19),('12664','2014-04-25','16:50:00',1.93),('12664','2014-04-25','16:55:00',1.53),('12664','2014-04-25','17:00:00',1.72),('12664','2014-04-25','17:05:00',1.75),('12664','2014-04-25','17:10:00',1.79),('12664','2014-04-25','17:15:00',1.81),('12664','2014-04-25','17:20:00',1.49),('12664','2014-04-25','17:25:00',1.44),('12664','2014-04-25','17:30:00',1.41),('12664','2014-04-25','17:35:00',1.04),('12664','2014-01-25','09:45:00',1.17),('12664','2014-01-25','09:50:00',1.41),('12664','2014-01-25','09:55:00',1.44),('12664','2014-01-25','10:00:00',2.98),('12664','2014-01-25','10:05:00',3),('12664','2014-01-25','10:10:00',2.23),('12664','2014-01-25','10:15:00',2.63),('12664','2014-01-25','10:20:00',2.52),('12664','2014-01-25','10:25:00',2.41),('12664','2014-01-25','10:30:00',2.26),('12664','2014-01-25','10:35:00',1.87),('12664','2014-01-25','10:40:00',1.93),('12664','2014-01-25','10:45:00',2.34),('12664','2014-01-25','10:50:00',2.82),('12664','2014-01-25','10:55:00',2.97),('12664','2014-01-25','11:00:00',2.92),('12664','2014-01-25','11:05:00',2.81),('12664','2014-01-25','11:10:00',2.84),('12664','2014-01-25','11:15:00',3.54),('12664','2014-01-25','11:20:00',3.89),('12664','2014-01-25','11:25:00',3.97),('12664','2014-01-25','11:30:00',3.37),('12664','2014-01-25','11:35:00',2.3),('12664','2014-01-25','11:40:00',2.4),('12664','2014-01-25','11:45:00',2.06),('12664','2014-01-25','11:50:00',1.84),('12664','2014-01-25','11:55:00',1.76),('12664','2014-01-25','12:00:00',2.11),('12664','2014-01-25','12:05:00',2.11),('12664','2014-01-25','12:10:00',1.88),('12664','2014-01-25','12:15:00',1.77),('12664','2014-01-25','12:20:00',1.78),('12664','2014-01-25','12:25:00',1.93),('12664','2014-01-25','12:30:00',1.92),('12664','2014-01-25','12:35:00',2.04),('12664','2014-01-25','12:40:00',2.05),('12664','2014-01-25','12:45:00',2.22),('12664','2014-01-25','12:50:00',1.71),('12664','2014-01-25','12:55:00',1.77),('12664','2014-01-25','13:00:00',2.84),('12664','2014-01-25','13:05:00',3.05),('12664','2014-01-25','13:10:00',2.9),('12664','2014-01-25','13:15:00',3.19),('12664','2014-01-25','13:20:00',3.15),('12664','2014-01-25','13:25:00',3.13),('12664','2014-01-25','13:30:00',3.04),('12664','2014-01-25','13:35:00',3.08),('12664','2014-01-25','13:40:00',3.11),('12664','2014-01-25','13:45:00',3.06),('12664','2014-01-25','13:50:00',2.74),('12664','2014-01-25','13:55:00',2.89),('12664','2014-01-25','14:00:00',2.34),('12664','2014-01-25','14:05:00',2.49),('12664','2014-01-25','14:10:00',2.58),('12664','2014-01-25','14:15:00',2.79),('12664','2014-01-25','14:20:00',2.7),('12664','2014-01-25','14:25:00',2.65),('12664','2014-01-25','14:30:00',2.61),('12664','2014-01-25','14:35:00',2.36),('12664','2014-01-25','14:40:00',2.54),('12664','2014-01-25','14:45:00',1.58),('12664','2014-01-25','15:00:00',1.67),('12664','2014-01-25','15:05:00',2.07),('12664','2014-01-25','15:10:00',1.96),('12664','2014-01-25','15:15:00',1.86),('12664','2014-01-25','15:20:00',1.75),('12664','2014-01-25','15:25:00',1.65),('12664','2014-01-25','15:30:00',1.57),('12664','2014-01-25','15:35:00',1.48),('12664','2014-01-25','15:40:00',1.39),('12664','2014-01-25','15:45:00',1.3),('12664','2014-01-25','15:50:00',1.21),('12664','2014-01-25','15:55:00',1.12),('12664','2014-01-25','16:00:00',1.03),('12664','2014-01-24','10:00:00',1.59),('12664','2014-01-24','10:05:00',2.48),('12664','2014-01-24','10:10:00',2.14),('12664','2014-01-24','10:15:00',2.96),('12664','2014-01-24','10:20:00',1.05),('12664','2014-01-24','10:25:00',1.02),('12664','2014-01-24','10:30:00',1.45),('12664','2014-01-24','10:35:00',2.55),('12664','2014-01-24','10:40:00',1.71),('12664','2014-01-24','10:45:00',1.28),('12664','2014-01-24','10:55:00',1.3),('12664','2014-01-24','11:00:00',2.38),('12664','2014-01-24','11:25:00',1.5),('12664','2014-01-24','11:35:00',3.18),('12664','2014-01-24','11:40:00',3.73),('12664','2014-01-24','11:45:00',3.44),('12664','2014-01-24','11:50:00',3.15),('12664','2014-01-24','11:55:00',2.58),('12664','2014-01-24','12:00:00',2.49),('12664','2014-01-24','12:05:00',2.35),('12664','2014-01-24','12:15:00',2.9),('12664','2014-01-24','12:20:00',1.68),('12664','2014-01-24','12:35:00',2),('12664','2014-01-24','12:40:00',1.42),('12664','2014-01-24','12:45:00',1.51),('12664','2014-01-24','13:00:00',1.38),('12664','2014-01-24','13:05:00',1.43),('12664','2014-01-24','13:10:00',2.77),('12664','2014-01-24','13:15:00',1.41),('12664','2014-01-24','13:20:00',2.2),('12664','2014-01-24','13:25:00',3.35),('12664','2014-01-24','13:30:00',3.22),('12664','2014-01-24','13:35:00',2.48),('12664','2014-01-24','13:40:00',1.31),('12664','2014-01-24','13:50:00',1.3),('12664','2014-01-24','14:00:00',1.02),('12664','2014-01-24','14:05:00',3.5),('12664','2014-01-24','14:10:00',2.5),('12664','2014-01-24','14:15:00',1.97),('12664','2014-01-24','14:20:00',2.88),('12664','2014-01-24','14:25:00',1.78),('12664','2014-01-24','14:30:00',1.93),('12664','2014-01-24','14:35:00',1.68),('12664','2014-01-24','14:40:00',1.74),('12664','2014-01-24','14:45:00',2.29),('12664','2014-01-24','14:50:00',1.27),('12664','2014-01-22','11:15:00',1.01),('12664','2014-01-22','12:40:00',1.5),('12664','2014-01-22','12:45:00',2.13),('12664','2014-01-22','12:50:00',1.08),('12664','2014-01-22','16:00:00',1.05),('12664','2014-01-22','16:05:00',1.1),('12664','2014-01-22','16:10:00',1.11),('12664','2014-01-21','10:25:00',1.07),('12664','2014-01-21','10:55:00',1.76),('12664','2014-01-21','11:25:00',2.43),('12664','2014-01-21','11:30:00',2.14),('12664','2014-01-21','11:35:00',3.25),('12664','2014-01-21','11:40:00',2.89),('12664','2014-01-21','11:50:00',1.69),('12664','2014-01-21','11:55:00',1.81),('12664','2014-01-21','12:00:00',1.7),('12664','2014-01-21','12:05:00',1.07),('12664','2014-01-21','12:10:00',1.41),('12664','2014-01-21','12:15:00',1.77),('12664','2014-01-21','12:20:00',1.6),('12664','2014-01-21','12:25:00',1.39),('12664','2014-01-21','12:30:00',1.41),('12664','2014-01-21','12:55:00',1.11),('12664','2014-01-21','13:00:00',1.06),('12664','2014-01-21','13:05:00',1.47),('12664','2014-01-21','13:10:00',1.19),('12664','2014-01-21','13:45:00',1.03),('12664','2014-01-21','15:15:00',1.39),('12664','2014-01-21','15:30:00',1.57),('12664','2014-01-21','15:35:00',1.13),('12664','2014-01-20','12:00:00',1.01),('12664','2014-01-20','12:50:00',1.73),('12664','2014-01-20','12:55:00',1.39),('12664','2014-01-20','13:20:00',1.07),('12664','2014-01-20','13:25:00',1.89),('12664','2014-01-20','13:30:00',1.35),('12664','2014-01-20','13:35:00',1.96),('12664','2014-01-20','14:15:00',1.04),('12664','2014-01-20','14:20:00',1.15),('12664','2014-01-19','11:50:00',1.1),('12664','2014-01-19','11:55:00',1.16),('12664','2014-01-19','12:00:00',1.02),('12664','2014-01-19','12:25:00',1.01),('12664','2014-01-19','13:10:00',1.05),('12664','2014-01-19','14:15:00',1.36),('12664','2014-01-19','14:20:00',1.68),('12664','2014-01-19','14:25:00',1.39),('12664','2014-01-19','14:30:00',1.02),('12664','2014-01-18','09:45:00',1.24),('12664','2014-01-18','09:50:00',1.65),('12664','2014-01-18','09:55:00',1.52),('12664','2014-01-18','10:00:00',1.13),('12664','2014-01-18','10:05:00',1.16),('12664','2014-01-18','10:10:00',2.45),('12664','2014-01-18','10:15:00',2.88),('12664','2014-01-18','10:20:00',2.01),('12664','2014-01-18','10:25:00',1.77),('12664','2014-01-18','10:30:00',1.73),('12664','2014-01-18','10:35:00',1.95),('12664','2014-01-18','10:40:00',2.1),('12664','2014-01-18','10:45:00',1.09),('12664','2014-01-18','10:50:00',1.08),('12664','2014-01-18','11:00:00',1.89),('12664','2014-01-18','11:05:00',2.42),('12664','2014-01-18','11:15:00',1.77),('12664','2014-01-18','11:20:00',3.08),('12664','2014-01-18','11:25:00',3.06),('12664','2014-01-18','11:30:00',3.07),('12664','2014-01-18','11:35:00',2.35),('12664','2014-01-18','11:40:00',1.8),('12664','2014-01-18','11:45:00',1.23),('12664','2014-01-18','11:50:00',1.02),('12664','2014-01-18','11:55:00',1.97),('12664','2014-01-18','12:00:00',2.89),('12664','2014-01-18','12:05:00',2.22),('12664','2014-01-18','12:10:00',3.16),('12664','2014-01-18','12:15:00',3.04),('12664','2014-01-18','12:20:00',3.07),('12664','2014-01-18','12:25:00',3.13),('12664','2014-01-18','12:30:00',3.1),('12664','2014-01-18','12:35:00',2.96),('12664','2014-01-18','12:40:00',2.73),('12664','2014-01-18','12:45:00',2.91),('12664','2014-01-18','12:50:00',2.2),('12664','2014-01-18','12:55:00',2.26),('12664','2014-01-18','13:00:00',2.73),('12664','2014-01-18','13:05:00',2.25),('12664','2014-01-18','13:10:00',2.64),('12664','2014-01-18','13:15:00',2.72),('12664','2014-01-18','13:20:00',3.28),('12664','2014-01-18','13:25:00',2.97),('12664','2014-01-18','13:30:00',2.68),('12664','2014-01-18','13:35:00',2.98),('12664','2014-01-18','13:40:00',2.73),('12664','2014-01-18','13:45:00',2.81),('12664','2014-01-18','13:50:00',2.19),('12664','2014-01-18','13:55:00',1.83),('12664','2014-01-18','14:00:00',2.68),('12664','2014-01-18','14:05:00',2.53),('12664','2014-01-18','14:10:00',2.31),('12664','2014-01-18','14:15:00',2.36),('12664','2014-01-18','14:20:00',2.34),('12664','2014-01-18','14:25:00',2.26),('12664','2014-01-18','14:30:00',2.19),('12664','2014-01-18','14:35:00',2.12),('12664','2014-01-18','14:40:00',2.06),('12664','2014-01-18','14:45:00',2),('12664','2014-01-18','14:50:00',1.88),('12664','2014-01-18','15:25:00',1.17),('12664','2014-01-18','15:50:00',1.11),('12664','2014-01-17','08:55:00',1.16),('12664','2014-01-17','09:00:00',1.24),('12664','2014-01-17','09:05:00',1.13),('12664','2014-01-17','09:10:00',1.34),('12664','2014-01-17','09:15:00',1.17),('12664','2014-01-17','09:30:00',1.31),('12664','2014-01-17','09:35:00',1.51),('12664','2014-01-17','09:40:00',2.33),('12664','2014-01-17','09:45:00',1.03),('12664','2014-01-16','09:00:00',1.02),('12664','2014-01-16','09:05:00',1.15),('12664','2014-01-16','09:10:00',1.19),('12664','2014-01-16','09:15:00',1.69),('12664','2014-01-16','09:20:00',1.81),('12664','2014-01-16','09:25:00',1.85),('12664','2014-01-16','09:30:00',1.92),('12664','2014-01-16','09:35:00',1.93),('12664','2014-01-16','09:40:00',1.65),('12664','2014-01-16','09:45:00',1.24),('12664','2014-01-16','10:05:00',1.17),('12664','2014-01-16','10:10:00',1.33),('12664','2014-01-16','10:15:00',1.33),('12664','2014-01-16','10:20:00',1.71),('12664','2014-01-16','10:25:00',2.42),('12664','2014-01-16','10:30:00',2.82),('12664','2014-01-16','10:35:00',1.9),('12664','2014-01-16','10:40:00',1.81),('12664','2014-01-16','10:45:00',2.17),('12664','2014-01-16','10:50:00',2.18),('12664','2014-01-16','10:55:00',2.17),('12664','2014-01-16','11:00:00',2.37),('12664','2014-01-16','11:05:00',2.45),('12664','2014-01-16','11:10:00',2.23),('12664','2014-01-16','11:15:00',1.96),('12664','2014-01-16','11:20:00',2.05),('12664','2014-01-16','11:25:00',1.92),('12664','2014-01-16','11:30:00',1.94),('12664','2014-01-16','11:35:00',2.03),('12664','2014-01-16','11:40:00',1.93),('12664','2014-01-16','11:45:00',2.02),('12664','2014-01-16','11:50:00',2.18),('12664','2014-01-16','11:55:00',2.02),('12664','2014-01-16','12:00:00',2.04),('12664','2014-01-16','12:05:00',2.1),('12664','2014-01-16','12:10:00',1.91),('12664','2014-01-16','12:15:00',1.7),('12664','2014-01-16','12:20:00',1.62),('12664','2014-01-16','12:25:00',1.76),('12664','2014-01-16','12:30:00',2.09),('12664','2014-01-16','12:35:00',2.08),('12664','2014-01-16','12:40:00',2.11),('12664','2014-01-16','12:45:00',2.27),('12664','2014-01-16','12:50:00',2.41),('12664','2014-01-16','12:55:00',2.51),('12664','2014-01-16','13:00:00',2.6),('12664','2014-01-16','13:05:00',2.57),('12664','2014-01-16','13:10:00',2.57),('12664','2014-01-16','13:15:00',2.58),('12664','2014-01-16','13:20:00',2.59),('12664','2014-01-16','13:25:00',2.5),('12664','2014-01-16','13:30:00',2.64),('12664','2014-01-16','13:35:00',2.7),('12664','2014-01-16','13:40:00',2.87),('12664','2014-01-16','13:45:00',1.19),('12664','2014-01-16','13:50:00',1.12),('12664','2014-01-16','13:55:00',1.12),('12664','2014-01-16','14:00:00',1.07),('12664','2014-01-16','15:00:00',1.07),('12664','2014-04-24','08:00:00',1),('12664','2014-04-24','08:05:00',1.08),('12664','2014-04-24','08:10:00',1.16),('12664','2014-04-24','08:15:00',1.25),('12664','2014-04-24','08:20:00',1.35),('12664','2014-04-24','08:25:00',1.44),('12664','2014-04-24','08:30:00',1.52),('12664','2014-04-24','08:35:00',1.63),('12664','2014-04-24','08:40:00',1.71),('12664','2014-04-24','08:45:00',1.8),('12664','2014-04-24','08:50:00',1.88),('12664','2014-04-24','08:55:00',1.95),('12664','2014-04-24','09:00:00',2.04),('12664','2014-04-24','09:05:00',2.12),('12664','2014-04-24','09:10:00',2.21),('12664','2014-04-24','09:15:00',2.13),('12664','2014-04-24','09:20:00',2.34),('12664','2014-04-24','09:25:00',2.42),('12664','2014-04-24','09:30:00',2.51),('12664','2014-04-24','09:35:00',2.58),('12664','2014-04-24','09:40:00',2.65),('12664','2014-04-24','09:45:00',2.72),('12664','2014-04-24','09:50:00',2.78),('12664','2014-04-24','09:55:00',2.85),('12664','2014-04-24','10:00:00',2.91),('12664','2014-04-24','10:05:00',2.96),('12664','2014-04-24','10:10:00',3.01),('12664','2014-04-24','10:15:00',3.06),('12664','2014-04-24','10:20:00',3.12),('12664','2014-04-24','10:25:00',3.15),('12664','2014-04-24','10:30:00',3.21),('12664','2014-04-24','10:35:00',3.29),('12664','2014-04-24','10:40:00',3.42),('12664','2014-04-24','10:45:00',3.53),('12664','2014-04-24','10:50:00',3.25),('12664','2014-04-24','10:55:00',1.01),('12664','2014-04-24','11:00:00',2.62),('12664','2014-04-24','11:05:00',3.8),('12664','2014-04-24','11:10:00',3.69),('12664','2014-04-24','11:15:00',3.75),('12664','2014-04-24','11:20:00',2.99),('12664','2014-04-24','11:25:00',3.47),('12664','2014-04-24','11:30:00',3.93),('12664','2014-04-24','11:35:00',3.74),('12664','2014-04-24','11:45:00',3.37),('12664','2014-04-24','11:50:00',3.65),('12664','2014-04-24','11:55:00',3.96),('12664','2014-04-24','12:00:00',4),('12664','2014-04-24','12:05:00',4.03),('12664','2014-04-24','12:10:00',3.81),('12664','2014-04-24','12:15:00',3.77),('12664','2014-04-24','12:20:00',3.99),('12664','2014-04-24','12:25:00',3.95),('12664','2014-04-24','12:30:00',4),('12664','2014-04-24','12:35:00',3.98),('12664','2014-04-24','12:40:00',4.06),('12664','2014-04-24','12:45:00',4.07),('12664','2014-04-24','12:50:00',4.05),('12664','2014-04-24','12:55:00',4.05),('12664','2014-04-24','13:00:00',4.09),('12664','2014-04-24','13:05:00',3.62),('12664','2014-04-24','13:10:00',3.69),('12664','2014-04-24','13:15:00',4.21),('12664','2014-04-24','13:20:00',4.15),('12664','2014-04-24','13:25:00',4.16),('12664','2014-04-24','13:30:00',3.87),('12664','2014-04-24','13:35:00',1.06),('12664','2014-04-24','13:40:00',4.05),('12664','2014-04-24','13:45:00',4.17),('12664','2014-04-24','13:50:00',4.11),('12664','2014-04-24','13:55:00',4.09),('12664','2014-04-24','14:00:00',4.04),('12664','2014-04-24','14:05:00',4.07),('12664','2014-04-24','14:10:00',4.04),('12664','2014-04-24','14:15:00',4.02),('12664','2014-04-24','14:20:00',4.03),('12664','2014-04-24','14:25:00',4.05),('12664','2014-04-24','14:30:00',4.1),('12664','2014-04-24','14:35:00',4.06),('12664','2014-04-24','14:40:00',3.98),('12664','2014-04-24','14:45:00',3.88),('12664','2014-04-24','14:50:00',3.81),('12664','2014-04-24','14:55:00',3.8),('12664','2014-04-24','15:00:00',3.89),('12664','2014-04-24','15:05:00',4.03),('12664','2014-04-24','15:10:00',4.25),('12664','2014-04-24','15:15:00',4.21),('12664','2014-04-24','15:20:00',3.58),('12664','2014-04-24','15:25:00',2.63),('12664','2014-04-24','15:30:00',3.76),('12664','2014-04-24','15:35:00',2.94),('12664','2014-04-24','15:40:00',2.3),('12664','2014-04-24','15:45:00',3.84),('12664','2014-04-24','15:50:00',3.42),('12664','2014-04-24','15:55:00',2.79),('12664','2014-04-24','16:00:00',3.22),('12664','2014-04-24','16:05:00',3.06),('12664','2014-04-24','16:10:00',3.28),('12664','2014-04-24','16:15:00',2),('12664','2014-04-24','16:20:00',2.05),('12664','2014-04-24','16:25:00',3.05),('12664','2014-04-24','16:30:00',2.05),('12664','2014-04-24','16:35:00',3.08),('12664','2014-04-24','16:40:00',1.45),('12664','2014-04-24','16:45:00',1.09),('12664','2014-04-24','16:50:00',1.16),('12664','2014-04-24','16:55:00',1.22),('12664','2014-04-24','17:00:00',1.13),('12664','2014-04-24','17:05:00',1.19),('12664','2014-04-24','17:10:00',1.23),('12664','2014-04-24','17:15:00',1.21),('12664','2014-04-24','17:20:00',1.18),('12664','2014-04-24','17:25:00',1.07),('12664','2014-01-15','09:30:00',1.03),('12664','2014-01-15','09:35:00',1.06),('12664','2014-01-15','09:55:00',1.79),('12664','2014-01-15','10:00:00',2.21),('12664','2014-01-15','10:05:00',2.48),('12664','2014-01-15','10:10:00',2.48),('12664','2014-01-15','10:15:00',2.53),('12664','2014-01-15','10:20:00',2.59),('12664','2014-01-15','10:25:00',2.63),('12664','2014-01-15','10:30:00',2.7),('12664','2014-01-15','10:35:00',2.28),('12664','2014-01-15','10:40:00',1.71),('12664','2014-01-15','10:45:00',1.47),('12664','2014-01-15','10:50:00',1.1),('12664','2014-01-15','10:55:00',1.52),('12664','2014-01-15','11:00:00',2.56),('12664','2014-01-15','11:05:00',2.71),('12664','2014-01-15','11:10:00',2.84),('12664','2014-01-15','11:15:00',2.75),('12664','2014-01-15','11:20:00',2.96),('12664','2014-01-15','11:25:00',2.77),('12664','2014-01-15','11:30:00',1.85),('12664','2014-01-15','11:35:00',1.34),('12664','2014-01-15','11:40:00',1.23),('12664','2014-01-15','11:45:00',1.23),('12664','2014-01-15','11:50:00',1.72),('12664','2014-01-15','11:55:00',1.79),('12664','2014-01-15','12:00:00',1.53),('12664','2014-01-15','12:05:00',1.59),('12664','2014-01-15','12:10:00',2.14),('12664','2014-01-15','12:15:00',1.92),('12664','2014-01-15','12:20:00',1.42),('12664','2014-01-15','12:25:00',1.99),('12664','2014-01-15','12:30:00',3.2),('12664','2014-01-15','12:35:00',3.17),('12664','2014-01-15','12:40:00',2.59),('12664','2014-01-15','12:45:00',2.57),('12664','2014-01-15','12:50:00',3.07),('12664','2014-01-15','12:55:00',3.19),('12664','2014-01-15','13:00:00',3.15),('12664','2014-01-15','13:05:00',3.11),('12664','2014-01-15','13:10:00',3.07),('12664','2014-01-15','13:15:00',3.09),('12664','2014-01-15','13:20:00',3.02),('12664','2014-01-15','13:25:00',2.98),('12664','2014-01-15','13:30:00',2.9),('12664','2014-01-15','13:35:00',1.42),('12664','2014-01-15','13:40:00',2.07),('12664','2014-01-15','13:45:00',2.74),('12664','2014-01-15','13:50:00',2.69),('12664','2014-01-15','13:55:00',1.57),('12664','2014-01-15','14:00:00',1.13),('12664','2014-01-15','14:05:00',2.64),('12664','2014-01-15','14:10:00',2.45),('12664','2014-01-15','14:15:00',2.41),('12664','2014-01-15','14:20:00',2.31),('12664','2014-01-15','14:25:00',2.24),('12664','2014-01-15','14:30:00',2.2),('12664','2014-01-15','14:35:00',2.16),('12664','2014-01-15','14:40:00',2.09),('12664','2014-01-15','14:45:00',2.02),('12664','2014-01-15','14:50:00',1.94),('12664','2014-01-15','15:00:00',1.08),('12664','2014-01-15','15:05:00',1.77),('12664','2014-01-15','15:10:00',1.64),('12664','2014-01-15','15:15:00',1.53),('12664','2014-01-15','15:20:00',1.52),('12664','2014-01-15','15:25:00',1.42),('12664','2014-01-15','15:30:00',1.33),('12664','2014-01-15','15:35:00',1.25),('12664','2014-01-15','15:40:00',1.17),('12664','2014-01-15','15:45:00',1.06),('12664','2014-01-14','10:20:00',1.04),('12664','2014-01-14','10:25:00',1.72),('12664','2014-01-14','10:30:00',1.89),('12664','2014-01-14','10:35:00',1.3),('12664','2014-01-14','10:40:00',1.04),('12664','2014-01-13','09:05:00',1.44),('12664','2014-01-13','09:10:00',1.54),('12664','2014-01-13','09:15:00',1.56),('12664','2014-01-13','09:20:00',1.63),('12664','2014-01-13','09:25:00',1.69),('12664','2014-01-13','09:30:00',1.75),('12664','2014-01-13','09:35:00',1.81),('12664','2014-01-13','09:40:00',1.88),('12664','2014-01-13','09:45:00',1.92),('12664','2014-01-13','09:50:00',1.96),('12664','2014-01-13','09:55:00',2.01),('12664','2014-01-13','10:00:00',2.07),('12664','2014-01-13','10:05:00',2.12),('12664','2014-01-13','10:10:00',2.18),('12664','2014-01-13','10:15:00',2.24),('12664','2014-01-13','10:20:00',2.3),('12664','2014-01-13','10:25:00',2.35),('12664','2014-01-13','10:30:00',2.39),('12664','2014-01-13','10:35:00',2.41),('12664','2014-01-13','10:40:00',2.45),('12664','2014-01-13','10:45:00',2.47),('12664','2014-01-13','10:50:00',2.51),('12664','2014-01-13','10:55:00',2.53),('12664','2014-01-13','11:00:00',2.51),('12664','2014-01-13','11:05:00',2.56),('12664','2014-01-13','11:10:00',2.58),('12664','2014-01-13','11:15:00',2.65),('12664','2014-01-13','11:20:00',2.66),('12664','2014-01-13','11:25:00',2.67),('12664','2014-01-13','11:30:00',2.68),('12664','2014-01-13','11:35:00',2.72),('12664','2014-01-13','11:40:00',2.71),('12664','2014-01-13','11:45:00',2.72),('12664','2014-01-13','11:50:00',2.75),('12664','2014-01-13','11:55:00',2.74),('12664','2014-01-13','12:00:00',2.71),('12664','2014-01-13','12:05:00',2.71),('12664','2014-01-13','12:10:00',2.7),('12664','2014-01-13','12:15:00',2.71),('12664','2014-01-13','12:20:00',2.72),('12664','2014-01-13','12:25:00',2.69),('12664','2014-01-13','12:30:00',2.64),('12664','2014-01-13','12:35:00',2.64),('12664','2014-01-13','12:40:00',2.71),('12664','2014-01-13','12:45:00',2.71),('12664','2014-01-13','12:50:00',2.61),('12664','2014-01-13','12:55:00',2.66),('12664','2014-01-13','13:00:00',2.65),('12664','2014-01-13','13:05:00',2.62),('12664','2014-01-13','13:10:00',2.54),('12664','2014-01-13','13:15:00',2.42),('12664','2014-01-13','13:20:00',2.29),('12664','2014-01-13','13:25:00',2.38),('12664','2014-01-13','13:30:00',2.41),('12664','2014-01-13','13:35:00',2.39),('12664','2014-01-13','13:40:00',2.41),('12664','2014-01-13','13:45:00',2.37),('12664','2014-01-13','13:50:00',2.4),('12664','2014-01-13','13:55:00',2.36),('12664','2014-01-13','14:00:00',2.37),('12664','2014-01-13','14:05:00',2.24),('12664','2014-01-13','14:10:00',2.11),('12664','2014-01-13','14:15:00',2.02),('12664','2014-01-13','14:20:00',2.03),('12664','2014-01-13','14:25:00',1.94),('12664','2014-01-13','14:30:00',1.9),('12664','2014-01-13','14:35:00',1.89),('12664','2014-01-13','14:40:00',1.84),('12664','2014-01-13','14:45:00',1.77),('12664','2014-01-13','14:50:00',1.68),('12664','2014-01-13','14:55:00',1.62),('12664','2014-01-13','15:00:00',1.59),('12664','2014-01-13','15:05:00',1.46),('12664','2014-01-13','15:10:00',1.42),('12664','2014-01-13','15:15:00',1.36),('12664','2014-01-13','15:20:00',1.27),('12664','2014-01-13','15:25:00',1.21),('12664','2014-01-13','15:30:00',1.14),('12664','2014-01-13','15:35:00',1.04),('12664','2014-01-12','10:30:00',1.04),('12664','2014-01-12','10:35:00',1.16),('12664','2014-01-12','10:40:00',1.33),('12664','2014-01-12','10:45:00',1.37),('12664','2014-01-12','10:50:00',1.41),('12664','2014-01-12','10:55:00',1.41),('12664','2014-01-12','11:00:00',1.53),('12664','2014-01-12','11:05:00',1.61),('12664','2014-01-12','11:10:00',1.74),('12664','2014-01-12','11:15:00',1.98),('12664','2014-01-12','11:20:00',1.94),('12664','2014-01-12','11:25:00',1.79),('12664','2014-01-12','11:30:00',2.46),('12664','2014-01-12','11:35:00',2.2),('12664','2014-01-12','11:40:00',1.41),('12664','2014-01-12','11:45:00',1.97),('12664','2014-01-12','11:50:00',2.29),('12664','2014-01-12','11:55:00',1.63),('12664','2014-01-12','12:00:00',1.65),('12664','2014-01-12','12:05:00',1.37),('12664','2014-01-12','12:10:00',1.23),('12664','2014-01-12','12:15:00',1.19),('12664','2014-01-12','12:20:00',1.14),('12664','2014-01-12','12:25:00',1.1),('12664','2014-01-12','12:30:00',1.08),('12664','2014-01-12','12:35:00',1.02),('12664','2014-01-12','13:20:00',1.04),('12664','2014-01-12','13:25:00',1.09),('12664','2014-01-12','13:30:00',1.27),('12664','2014-01-12','13:35:00',1.22),('12664','2014-01-12','13:40:00',1.2),('12664','2014-01-12','13:45:00',1.12),('12664','2014-01-12','13:50:00',1.05),('12664','2014-01-12','13:55:00',1),('12664','2014-01-11','09:45:00',1.25),('12664','2014-01-11','09:50:00',1.41),('12664','2014-01-11','09:55:00',1.4),('12664','2014-01-11','10:00:00',1.25),('12664','2014-01-11','10:05:00',1.41),('12664','2014-01-11','10:10:00',1.79),('12664','2014-01-11','10:15:00',1.73),('12664','2014-01-11','10:20:00',1.81),('12664','2014-01-11','10:25:00',1.73),('12664','2014-01-11','10:30:00',1.94),('12664','2014-01-11','10:35:00',2.14),('12664','2014-01-11','10:40:00',2.42),('12664','2014-01-11','10:45:00',2.52),('12664','2014-01-11','10:50:00',2.58),('12664','2014-01-11','10:55:00',2.64),('12664','2014-01-11','11:00:00',2.66),('12664','2014-01-11','11:05:00',2.26),('12664','2014-01-11','11:10:00',2),('12664','2014-01-11','11:15:00',2.01),('12664','2014-01-11','11:20:00',2.09),('12664','2014-01-11','11:25:00',1.86),('12664','2014-01-11','11:30:00',2.14),('12664','2014-01-11','11:35:00',2.3),('12664','2014-01-11','11:40:00',2.07),('12664','2014-01-11','11:45:00',2.05),('12664','2014-01-11','11:50:00',2.18),('12664','2014-01-11','11:55:00',2.23),('12664','2014-01-11','12:00:00',2.07),('12664','2014-01-11','12:05:00',2.2),('12664','2014-01-11','12:10:00',2.78),('12664','2014-01-11','12:15:00',2.53),('12664','2014-01-11','12:20:00',1.44),('12664','2014-01-11','12:25:00',1.84),('12664','2014-01-11','12:30:00',1.7),('12664','2014-01-11','12:35:00',1.8),('12664','2014-01-11','12:40:00',2.14),('12664','2014-01-11','12:45:00',1.26),('12664','2014-01-11','12:50:00',1.66),('12664','2014-01-11','12:55:00',1.79),('12664','2014-01-11','13:00:00',1.92),('12664','2014-01-11','13:05:00',1.66),('12664','2014-01-11','13:10:00',1.58),('12664','2014-01-11','13:15:00',1.9),('12664','2014-01-11','13:20:00',1.77),('12664','2014-01-11','13:25:00',1.49),('12664','2014-01-11','13:30:00',1.68),('12664','2014-01-11','13:35:00',1.11),('12664','2014-01-11','13:40:00',1.09),('12664','2014-01-11','13:50:00',1.09),('12664','2014-01-11','13:55:00',1.19),('12664','2014-01-11','14:00:00',1.24),('12664','2014-01-09','09:55:00',1.09),('12664','2014-01-09','10:00:00',1.03),('12664','2014-01-09','10:35:00',1.11),('12664','2014-01-09','10:40:00',1.11),('12664','2014-01-09','10:45:00',1.23),('12664','2014-01-09','10:50:00',1.24),('12664','2014-01-09','10:55:00',1.2),('12664','2014-01-09','11:00:00',1.31),('12664','2014-01-09','11:05:00',1.35),('12664','2014-01-09','11:10:00',1.36),('12664','2014-01-09','11:15:00',1.43),('12664','2014-01-09','11:20:00',1.42),('12664','2014-01-09','11:25:00',1.43),('12664','2014-01-09','11:30:00',1.51),('12664','2014-01-09','11:35:00',1.54),('12664','2014-01-09','11:40:00',1.74),('12664','2014-01-09','11:45:00',1.71),('12664','2014-01-09','11:50:00',1.44),('12664','2014-01-09','11:55:00',1.37),('12664','2014-01-09','12:00:00',1.33),('12664','2014-01-09','12:05:00',1.42),('12664','2014-01-09','12:10:00',1.26),('12664','2014-01-09','12:15:00',1.32),('12664','2014-01-09','12:20:00',1.36),('12664','2014-01-09','12:25:00',1.36),('12664','2014-01-09','12:30:00',1.36),('12664','2014-01-09','12:35:00',1.32),('12664','2014-01-09','12:40:00',1.31),('12664','2014-01-09','12:45:00',1.65),('12664','2014-01-09','12:50:00',1.38),('12664','2014-01-09','12:55:00',1.38),('12664','2014-01-09','13:00:00',1.32),('12664','2014-01-09','13:05:00',1.37),('12664','2014-01-09','13:10:00',1.66),('12664','2014-01-09','13:15:00',1.66),('12664','2014-01-09','13:20:00',1.54),('12664','2014-01-09','13:25:00',1.52),('12664','2014-01-09','13:30:00',1.38),('12664','2014-01-09','13:35:00',1.48),('12664','2014-01-09','13:40:00',1.23),('12664','2014-01-09','13:45:00',1.05),('12664','2014-01-09','14:10:00',1.19),('12664','2014-01-09','14:15:00',1.04),('12664','2014-01-09','14:25:00',1.12),('12664','2014-01-08','08:55:00',1.14),('12664','2014-01-08','09:00:00',1.23),('12664','2014-01-08','09:05:00',1.34),('12664','2014-01-08','09:10:00',1.42),('12664','2014-01-08','09:15:00',1.46),('12664','2014-01-08','09:20:00',1.56),('12664','2014-01-08','09:25:00',1.62),('12664','2014-01-08','09:30:00',1.61),('12664','2014-01-08','09:35:00',1.81),('12664','2014-01-08','09:40:00',1.84),('12664','2014-01-08','09:45:00',1.92),('12664','2014-01-08','09:50:00',2.01),('12664','2014-01-08','09:55:00',1.96),('12664','2014-01-08','10:00:00',1.82),('12664','2014-01-08','10:05:00',1.96),('12664','2014-01-08','10:10:00',2.13),('12664','2014-01-08','10:15:00',2.26),('12664','2014-01-08','10:20:00',2.32),('12664','2014-01-08','10:25:00',2.35),('12664','2014-01-08','10:30:00',2.33),('12664','2014-01-08','10:35:00',2.3),('12664','2014-01-08','10:40:00',2.34),('12664','2014-01-08','10:45:00',2.44),('12664','2014-01-08','10:50:00',2.47),('12664','2014-01-08','10:55:00',2.51),('12664','2014-01-08','11:00:00',2.56),('12664','2014-01-08','11:05:00',2.57),('12664','2014-01-08','11:10:00',2.61),('12664','2014-01-08','11:15:00',2.61),('12664','2014-01-08','11:20:00',2.6),('12664','2014-01-08','11:25:00',2.71),('12664','2014-01-08','11:30:00',2.78),('12664','2014-01-08','11:35:00',2.82),('12664','2014-01-08','11:40:00',2.75),('12664','2014-01-08','11:45:00',2.79),('12664','2014-01-08','11:50:00',2.72),('12664','2014-01-08','11:55:00',2.71),('12664','2014-01-08','12:00:00',2.71),('12664','2014-01-08','12:05:00',2.76),('12664','2014-01-08','12:10:00',2.76),('12664','2014-01-08','12:15:00',2.81),('12664','2014-01-08','12:20:00',2.77),('12664','2014-01-08','12:25:00',2.78),('12664','2014-01-08','12:30:00',2.78),('12664','2014-01-08','12:35:00',2.66),('12664','2014-01-08','12:40:00',2.52),('12664','2014-01-08','12:45:00',2.65),('12664','2014-01-08','12:50:00',2.64),('12664','2014-01-08','12:55:00',2.7),('12664','2014-01-08','13:00:00',2.64),('12664','2014-01-08','13:05:00',2.59),('12664','2014-01-08','13:10:00',2.54),('12664','2014-01-08','13:15:00',2.57),('12664','2014-01-08','13:20:00',2.62),('12664','2014-01-08','13:25:00',2.56),('12664','2014-01-08','13:30:00',2.55),('12664','2014-01-08','13:35:00',2.52),('12664','2014-01-08','13:40:00',2.53),('12664','2014-01-08','13:45:00',2.37),('12664','2014-01-08','13:50:00',2.27),('12664','2014-01-08','13:55:00',2.16),('12664','2014-01-08','14:00:00',2.04),('12664','2014-01-08','14:05:00',2.08),('12664','2014-01-08','14:10:00',2.1),('12664','2014-01-08','14:15:00',2.21),('12664','2014-01-08','14:20:00',2.01),('12664','2014-01-08','14:25:00',1.97),('12664','2014-01-08','14:30:00',1.91),('12664','2014-01-08','14:35:00',1.79),('12664','2014-01-08','14:40:00',1.68),('12664','2014-01-08','14:45:00',1.62),('12664','2014-01-08','14:50:00',1.36),('12664','2014-01-08','14:55:00',1.3),('12664','2014-01-08','15:00:00',1.22),('12664','2014-01-08','15:05:00',1.14),('12664','2014-01-08','15:10:00',1.01),('12664','2014-01-08','15:15:00',1.13),('12664','2014-01-08','15:20:00',1.15),('12664','2014-01-08','15:25:00',1.08),('12664','2014-01-08','15:30:00',1.03),('12664','2014-01-08','15:35:00',1.08),('12664','2014-01-07','08:45:00',1.05),('12664','2014-01-07','08:50:00',1.13),('12664','2014-01-07','08:55:00',1.22),('12664','2014-01-07','09:00:00',1.29),('12664','2014-01-07','09:05:00',1.36),('12664','2014-01-07','09:10:00',1.44),('12664','2014-01-07','09:15:00',1.51),('12664','2014-01-07','09:20:00',1.58),('12664','2014-01-07','09:25:00',1.68),('12664','2014-01-07','09:30:00',1.75),('12664','2014-01-07','09:35:00',1.82),('12664','2014-01-07','09:40:00',1.9),('12664','2014-01-07','09:45:00',1.97),('12664','2014-01-07','09:50:00',2.05),('12664','2014-01-07','09:55:00',2.12),('12664','2014-01-07','10:00:00',2.18),('12664','2014-01-07','10:05:00',2.25),('12664','2014-01-07','10:10:00',2.29),('12664','2014-01-07','10:15:00',2.33),('12664','2014-01-07','10:20:00',2.39),('12664','2014-01-07','10:25:00',2.44),('12664','2014-01-07','10:30:00',2.43),('12664','2014-01-07','10:35:00',2.51),('12664','2014-01-07','10:40:00',2.51),('12664','2014-01-07','10:45:00',2.5),('12664','2014-01-07','10:50:00',2.58),('12664','2014-01-07','10:55:00',2.58),('12664','2014-01-07','11:00:00',2.63),('12664','2014-01-07','11:05:00',2.67),('12664','2014-01-07','11:10:00',2.7),('12664','2014-01-07','11:15:00',2.72),('12664','2014-01-07','11:20:00',2.75),('12664','2014-01-07','11:25:00',2.78),('12664','2014-01-07','11:30:00',2.83),('12664','2014-01-07','11:35:00',2.87),('12664','2014-01-07','11:40:00',2.89),('12664','2014-01-07','11:45:00',2.9),('12664','2014-01-07','11:50:00',2.85),('12664','2014-01-07','11:55:00',2.92),('12664','2014-01-07','12:00:00',2.93),('12664','2014-01-07','12:05:00',2.91),('12664','2014-01-07','12:10:00',2.94),('12664','2014-01-07','12:15:00',2.93),('12664','2014-01-07','12:20:00',2.94),('12664','2014-01-07','12:25:00',2.94),('12664','2014-01-07','12:30:00',2.93),('12664','2014-01-07','12:35:00',2.94),('12664','2014-01-07','12:40:00',2.86),('12664','2014-01-07','12:45:00',2.89),('12664','2014-01-07','12:50:00',2.92),('12664','2014-01-07','12:55:00',2.89),('12664','2014-01-07','13:00:00',2.82),('12664','2014-01-07','13:05:00',2.8),('12664','2014-01-07','13:10:00',2.69),('12664','2014-01-07','13:15:00',2.6),('12664','2014-01-07','13:20:00',2.6),('12664','2014-01-07','13:25:00',2.58),('12664','2014-01-07','13:30:00',2.57),('12664','2014-01-07','13:35:00',2.41),('12664','2014-01-07','13:40:00',2.51),('12664','2014-01-07','13:45:00',2.48),('12664','2014-01-07','13:50:00',2.45),('12664','2014-01-07','13:55:00',2.38),('12664','2014-01-07','14:00:00',2.29),('12664','2014-01-07','14:05:00',2.17),('12664','2014-01-07','14:10:00',2.19),('12664','2014-01-07','14:15:00',2.14),('12664','2014-01-07','14:20:00',2.12),('12664','2014-01-07','14:25:00',2.11),('12664','2014-01-07','14:30:00',2.02),('12664','2014-01-07','14:35:00',2.01),('12664','2014-01-07','14:40:00',1.96),('12664','2014-01-07','14:45:00',1.71),('12664','2014-01-07','14:50:00',1.75),('12664','2014-01-07','14:55:00',1.65),('12664','2014-01-07','15:00:00',1.66),('12664','2014-01-07','15:05:00',1.59),('12664','2014-01-07','15:10:00',1.47),('12664','2014-01-07','15:15:00',1.41),('12664','2014-01-07','15:20:00',1.26),('12664','2014-01-07','15:25:00',1.17),('12664','2014-01-07','15:30:00',1.03),('12664','2014-01-06','10:35:00',1.05),('12664','2014-01-06','10:40:00',1.05),('12664','2014-01-06','10:50:00',1.04),('12664','2014-01-06','10:55:00',1.03),('12664','2014-01-06','11:30:00',2.06),('12664','2014-01-06','11:35:00',2.51),('12664','2014-01-06','11:40:00',2.98),('12664','2014-01-06','11:45:00',3.01),('12664','2014-01-06','11:50:00',2.91),('12664','2014-01-06','11:55:00',2.98),('12664','2014-01-06','12:00:00',2.97),('12664','2014-01-06','12:05:00',2.93),('12664','2014-01-06','12:10:00',2.67),('12664','2014-01-06','12:15:00',1.03),('12664','2014-01-06','12:20:00',2.76),('12664','2014-01-06','12:25:00',2.88),('12664','2014-01-06','12:30:00',2.8),('12664','2014-01-06','12:35:00',2.8),('12664','2014-01-06','12:40:00',2.81),('12664','2014-01-06','12:45:00',2.77),('12664','2014-01-06','12:50:00',2.73),('12664','2014-01-06','12:55:00',2.73),('12664','2014-01-06','13:00:00',2.72),('12664','2014-01-06','13:05:00',2.73),('12664','2014-01-06','13:10:00',2.75),('12664','2014-01-06','13:15:00',2.73),('12664','2014-01-06','13:20:00',2.7),('12664','2014-01-06','13:25:00',2.7),('12664','2014-01-06','13:30:00',2.69),('12664','2014-01-06','13:35:00',2.22),('12664','2014-01-06','13:40:00',2.12),('12664','2014-01-06','13:45:00',2.29),('12664','2014-01-06','13:50:00',2.56),('12664','2014-01-06','13:55:00',2.48),('12664','2014-01-06','14:00:00',2.43),('12664','2014-01-06','14:05:00',2.37),('12664','2014-01-06','14:10:00',2.28),('12664','2014-01-06','14:15:00',2.22),('12664','2014-01-06','14:20:00',2.17),('12664','2014-01-06','14:25:00',2.56),('12664','2014-01-06','14:30:00',2.58),('12664','2014-01-06','14:35:00',2.25),('12664','2014-01-06','14:40:00',2),('12664','2014-01-06','14:45:00',2.31),('12664','2014-01-06','14:50:00',2.17),('12664','2014-01-06','14:55:00',1.9),('12664','2014-01-06','15:00:00',1.79),('12664','2014-01-06','15:05:00',1.66),('12664','2014-01-06','15:10:00',1.36),('12664','2014-01-06','15:20:00',1.4),('12664','2014-01-06','15:25:00',1.21),('12664','2014-01-06','15:35:00',1.24),('12664','2014-01-06','15:40:00',1.12),('12664','2014-01-06','15:45:00',1.05),('12664','2014-04-23','10:50:00',1.03),('12664','2014-04-23','10:55:00',1.1),('12664','2014-04-23','11:00:00',1.11),('12664','2014-04-23','11:05:00',1.09),('12664','2014-04-23','11:10:00',1.09),('12664','2014-04-23','11:15:00',1.01),('12664','2014-04-23','13:25:00',1.03),('12664','2014-04-23','13:30:00',1.06),('12664','2014-04-23','13:35:00',1.21),('12664','2014-04-23','13:40:00',1.32),('12664','2014-04-23','13:45:00',1.43),('12664','2014-04-23','13:50:00',1.41),('12664','2014-04-23','13:55:00',1.35),('12664','2014-04-23','14:00:00',1.4),('12664','2014-04-23','14:05:00',1.4),('12664','2014-04-23','14:10:00',1.39),('12664','2014-04-23','14:15:00',1.35),('12664','2014-04-23','14:20:00',1.3),('12664','2014-04-23','14:25:00',1.24),('12664','2014-04-23','14:30:00',1.18),('12664','2014-04-23','14:35:00',1.03),('12664','2014-04-23','15:25:00',1.02),('12664','2014-04-23','15:30:00',1.07),('12664','2014-04-23','15:35:00',1.06),('12664','2014-01-03','08:40:00',1.07),('12664','2014-01-03','08:45:00',1.19),('12664','2014-01-03','08:50:00',1.18),('12664','2014-01-03','08:55:00',1.21),('12664','2014-01-03','09:00:00',1.3),('12664','2014-01-03','09:05:00',1.4),('12664','2014-01-03','09:10:00',1.51),('12664','2014-01-03','09:15:00',1.68),('12664','2014-01-03','09:20:00',1.94),('12664','2014-01-03','09:25:00',2.09),('12664','2014-01-03','09:30:00',1.98),('12664','2014-01-03','09:35:00',1.08),('12664','2014-01-03','09:45:00',1.51),('12664','2014-01-03','09:50:00',1.86),('12664','2014-01-03','09:55:00',2.4),('12664','2014-01-03','10:00:00',2.61),('12664','2014-01-03','10:05:00',2.32),('12664','2014-01-03','10:10:00',1.41),('12664','2014-01-03','10:15:00',1.13),('12664','2014-01-03','10:20:00',1.02),('12664','2014-01-03','10:25:00',1.08),('12664','2014-01-03','10:30:00',1.09),('12664','2014-01-03','10:35:00',1.08),('12664','2014-01-03','10:40:00',1.51),('12664','2014-01-03','10:45:00',1.18),('12664','2014-01-03','10:50:00',1.06),('12664','2014-01-03','11:00:00',1.04),('12664','2014-01-03','11:05:00',1.08),('12664','2014-01-03','11:50:00',1.17),('12664','2014-01-03','11:55:00',1.26),('12664','2014-01-03','12:00:00',1.64),('12664','2014-01-03','12:05:00',2.53),('12664','2014-01-03','12:10:00',2.64),('12664','2014-01-03','12:15:00',2.86),('12664','2014-01-03','12:20:00',2.99),('12664','2014-01-03','12:25:00',2.26),('12664','2014-01-03','12:30:00',2.08),('12664','2014-01-03','12:35:00',2.16),('12664','2014-01-03','12:40:00',2.45),('12664','2014-01-03','12:45:00',1.71),('12664','2014-01-03','12:50:00',2.63),('12664','2014-01-03','12:55:00',2.42),('12664','2014-01-03','13:00:00',1.99),('12664','2014-01-03','13:05:00',1.98),('12664','2014-01-03','13:10:00',1.58),('12664','2014-01-03','13:15:00',1.46),('12664','2014-01-03','13:20:00',1.65),('12664','2014-01-03','13:25:00',1.75),('12664','2014-01-03','13:30:00',1.42),('12664','2014-01-03','13:35:00',1.4),('12664','2014-01-03','13:40:00',1.37),('12664','2014-01-03','13:45:00',1.21),('12664','2014-01-03','13:50:00',1.04),('12664','2014-01-02','08:45:00',1),('12664','2014-01-02','08:50:00',1.14),('12664','2014-01-02','08:55:00',1.22),('12664','2014-01-02','09:00:00',1.31),('12664','2014-01-02','09:05:00',1.37),('12664','2014-01-02','09:10:00',1.46),('12664','2014-01-02','09:15:00',1.55),('12664','2014-01-02','09:20:00',1.63),('12664','2014-01-02','09:25:00',1.71),('12664','2014-01-02','09:30:00',1.79),('12664','2014-01-02','09:35:00',1.86),('12664','2014-01-02','09:40:00',1.94),('12664','2014-01-02','09:45:00',2.01),('12664','2014-01-02','09:50:00',2.08),('12664','2014-01-02','09:55:00',2.14),('12664','2014-01-02','10:00:00',2.19),('12664','2014-01-02','10:05:00',2.26),('12664','2014-01-02','10:10:00',2.34),('12664','2014-01-02','10:15:00',2.36),('12664','2014-01-02','10:20:00',2.41),('12664','2014-01-02','10:25:00',2.48),('12664','2014-01-02','10:30:00',2.52),('12664','2014-01-02','10:35:00',2.58),('12664','2014-01-02','10:40:00',2.63),('12664','2014-01-02','10:45:00',2.69),('12664','2014-01-02','10:50:00',1.53),('12664','2014-01-02','10:55:00',1.63),('12664','2014-01-02','11:00:00',1.66),('12664','2014-01-02','11:05:00',1.67),('12664','2014-01-02','11:10:00',1.39),('12664','2014-01-02','11:15:00',1.26),('12664','2014-01-02','11:20:00',1.38),('12664','2014-01-02','11:25:00',1.44),('12664','2014-01-02','11:30:00',1.57),('12664','2014-01-02','11:35:00',1.49),('12664','2014-01-02','11:40:00',1.3),('12664','2014-01-02','11:45:00',1.28),('12664','2014-01-02','11:50:00',1.14),('12664','2014-01-02','11:55:00',1.15),('12664','2014-01-02','12:00:00',1.08),('12664','2014-01-02','12:35:00',1.09),('12664','2014-01-02','12:40:00',1.33),('12664','2014-01-02','12:45:00',1.65),('12664','2014-01-02','12:50:00',3.16),('12664','2014-01-02','12:55:00',2.45),('12664','2014-01-02','13:00:00',1.09),('12664','2014-01-02','13:10:00',1.33),('12664','2014-01-02','13:25:00',1.02),('12664','2014-01-01','08:40:00',1.02),('12664','2014-01-01','08:50:00',1.02),('12664','2014-01-01','11:15:00',1.05),('12664','2014-01-01','11:20:00',1.03),('12664','2014-01-01','11:25:00',1.02),('12664','2014-01-01','11:30:00',1.03),('12664','2014-01-01','11:35:00',1.13),('12664','2014-01-01','11:40:00',1.19),('12664','2014-01-01','11:45:00',1.23),('12664','2014-01-01','11:50:00',1.26),('12664','2014-01-01','11:55:00',1.25),('12664','2014-01-01','12:00:00',1.29),('12664','2014-01-01','12:05:00',1.32),('12664','2014-01-01','12:10:00',1.35),('12664','2014-01-01','12:15:00',1.26),('12664','2014-01-01','12:20:00',1.33),('12664','2014-01-01','12:25:00',1.47),('12664','2014-01-01','12:30:00',1.97),('12664','2014-01-01','12:35:00',3.48),('12664','2014-01-01','12:40:00',2.14),('12664','2014-01-01','12:45:00',1.38),('12664','2014-01-01','12:50:00',1.31),('12664','2014-01-01','12:55:00',1.38),('12664','2014-01-01','13:00:00',1.24),('12664','2014-01-01','13:05:00',1.12),('12664','2014-01-01','13:10:00',1.21),('12664','2014-01-01','13:15:00',1.3),('12664','2014-01-01','13:20:00',1.23),('12664','2014-01-01','13:25:00',1.47),('12664','2014-01-01','13:30:00',1.68),('12664','2014-01-01','13:35:00',3.03),('12664','2014-01-01','13:40:00',2.96),('12664','2014-01-01','13:45:00',2.79),('12664','2014-01-01','13:50:00',2.59),('12664','2014-01-01','13:55:00',1.85),('12664','2014-01-01','14:00:00',2.56),('12664','2014-01-01','14:05:00',1.76),('12664','2014-01-01','14:10:00',2.15),('12664','2014-01-01','14:15:00',1.46),('12664','2014-01-01','14:20:00',1.13),('12664','2014-01-01','14:35:00',1.04),('12664','2014-01-01','14:40:00',1.03),('12664','2014-01-01','15:00:00',1.43),('12664','2014-01-01','15:05:00',1.53),('12664','2014-01-01','15:10:00',1.42),('12664','2014-01-01','15:15:00',1.29),('12664','2014-01-01','15:20:00',1.18),('12664','2014-01-01','15:25:00',1.06),('12664','2013-12-31','08:45:00',1.23),('12664','2013-12-31','08:50:00',1.38),('12664','2013-12-31','08:55:00',1.52),('12664','2013-12-31','09:00:00',1.57),('12664','2013-12-31','09:05:00',1.59),('12664','2013-12-31','09:10:00',1.63),('12664','2013-12-31','09:15:00',1.72),('12664','2013-12-31','09:20:00',1.81),('12664','2013-12-31','09:25:00',1.99),('12664','2013-12-31','09:30:00',1.67),('12664','2013-12-31','09:35:00',1.43),('12664','2013-12-31','10:10:00',1.08),('12664','2013-12-31','11:05:00',1.17),('12664','2013-12-31','11:10:00',1.24),('12664','2013-12-31','11:15:00',1.26),('12664','2013-12-31','11:20:00',1.37),('12664','2013-12-31','11:25:00',1.96),('12664','2013-12-31','11:30:00',1.49),('12664','2013-12-31','11:35:00',1.78),('12664','2013-12-31','11:40:00',2.21),('12664','2013-12-31','11:45:00',2.77),('12664','2013-12-31','11:50:00',2.27),('12664','2013-12-31','11:55:00',3.16),('12664','2013-12-31','12:00:00',3.03),('12664','2013-12-31','12:05:00',2.98),('12664','2013-12-31','12:10:00',2.94),('12664','2013-12-31','12:15:00',2.93),('12664','2013-12-31','12:20:00',2.94),('12664','2013-12-31','12:25:00',2.91),('12664','2013-12-31','12:30:00',2.89),('12664','2013-12-31','12:35:00',2.88),('12664','2013-12-31','12:40:00',2.88),('12664','2013-12-31','12:45:00',2.86),('12664','2013-12-31','12:50:00',2.84),('12664','2013-12-31','12:55:00',2.81),('12664','2013-12-31','13:00:00',2.78),('12664','2013-12-31','13:05:00',2.76),('12664','2013-12-31','13:10:00',2.74),('12664','2013-12-31','13:15:00',2.72),('12664','2013-12-31','13:20:00',2.66),('12664','2013-12-31','13:25:00',2.61),('12664','2013-12-31','13:30:00',2.58),('12664','2013-12-31','13:35:00',2.56),('12664','2013-12-31','13:40:00',2.52),('12664','2013-12-31','13:45:00',2.47),('12664','2013-12-31','13:50:00',2.4),('12664','2013-12-31','13:55:00',2.37),('12664','2013-12-31','14:00:00',2.32),('12664','2013-12-31','14:05:00',2.26),('12664','2013-12-31','14:10:00',2.2),('12664','2013-12-31','14:15:00',2.14),('12664','2013-12-31','14:20:00',2.08),('12664','2013-12-31','14:25:00',2.03),('12664','2013-12-31','14:30:00',1.96),('12664','2013-12-31','14:35:00',1.9),('12664','2013-12-31','14:40:00',1.82),('12664','2013-12-31','14:45:00',1.75),('12664','2013-12-31','14:50:00',1.69),('12664','2013-12-31','14:55:00',1.58),('12664','2013-12-31','15:00:00',1.5),('12664','2013-12-31','15:05:00',1.42),('12664','2013-12-31','15:10:00',1.35),('12664','2013-12-31','15:15:00',1.28),('12664','2013-12-31','15:20:00',1.21),('12664','2013-12-31','15:25:00',1.13),('12664','2013-12-31','15:30:00',1.04),('12664','2013-12-29','09:00:00',1.12),('12664','2013-12-29','09:05:00',1.21),('12664','2013-12-29','09:10:00',1.38),('12664','2013-12-29','09:15:00',1.47),('12664','2013-12-29','09:20:00',1.56),('12664','2013-12-29','09:25:00',1.45),('12664','2013-12-29','09:30:00',1.22),('12664','2013-12-29','09:35:00',1.24),('12664','2013-12-29','09:45:00',1.19),('12664','2013-12-29','09:50:00',1.96),('12664','2013-12-29','09:55:00',1.42),('12664','2013-12-29','10:00:00',1.39),('12664','2013-12-29','10:05:00',2.32),('12664','2013-12-29','10:10:00',2.56),('12664','2013-12-29','10:15:00',2.32),('12664','2013-12-29','10:20:00',1.39),('12664','2013-12-29','10:25:00',2.28),('12664','2013-12-29','10:30:00',1.61),('12664','2013-12-29','10:35:00',1.58),('12664','2013-12-29','10:40:00',2.91),('12664','2013-12-29','10:45:00',3.12),('12664','2013-12-29','10:50:00',2.42),('12664','2013-12-29','10:55:00',1.61),('12664','2013-12-29','11:00:00',2.46),('12664','2013-12-29','11:05:00',1.55),('12664','2013-12-29','11:10:00',2.73),('12664','2013-12-29','11:15:00',2.71),('12664','2013-12-29','11:20:00',1.41),('12664','2013-12-29','11:25:00',1.46),('12664','2013-12-29','11:30:00',1.11),('12664','2013-12-29','11:35:00',1.09),('12664','2013-12-28','08:40:00',1.01),('12664','2013-12-28','08:45:00',1.1),('12664','2013-12-28','08:50:00',1.18),('12664','2013-12-28','08:55:00',1.26),('12664','2013-12-28','09:00:00',1.33),('12664','2013-12-28','09:05:00',1.43),('12664','2013-12-28','09:10:00',1.52),('12664','2013-12-28','09:15:00',1.62),('12664','2013-12-28','09:20:00',1.69),('12664','2013-12-28','09:25:00',1.77),('12664','2013-12-28','09:30:00',1.86),('12664','2013-12-28','09:35:00',1.94),('12664','2013-12-28','09:40:00',2),('12664','2013-12-28','09:45:00',2.06),('12664','2013-12-28','09:50:00',2.11),('12664','2013-12-28','09:55:00',2.16),('12664','2013-12-28','10:00:00',2.23),('12664','2013-12-28','10:05:00',2.3),('12664','2013-12-28','10:10:00',2.37),('12664','2013-12-28','10:15:00',2.42),('12664','2013-12-28','10:20:00',2.47),('12664','2013-12-28','10:25:00',2.52),('12664','2013-12-28','10:30:00',2.56),('12664','2013-12-28','10:35:00',2.6),('12664','2013-12-28','10:40:00',2.64),('12664','2013-12-28','10:45:00',2.68),('12664','2013-12-28','10:50:00',2.71),('12664','2013-12-28','10:55:00',2.74),('12664','2013-12-28','11:00:00',2.74),('12664','2013-12-28','11:05:00',2.79),('12664','2013-12-28','11:10:00',2.8),('12664','2013-12-28','11:15:00',2.81),('12664','2013-12-28','11:20:00',2.8),('12664','2013-12-28','11:25:00',2.84),('12664','2013-12-28','11:30:00',2.87),('12664','2013-12-28','11:35:00',2.87),('12664','2013-12-28','11:40:00',2.88),('12664','2013-12-28','11:45:00',2.9),('12664','2013-12-28','11:50:00',2.89),('12664','2013-12-28','11:55:00',2.94),('12664','2013-12-28','12:00:00',2.93),('12664','2013-12-28','12:05:00',2.92),('12664','2013-12-28','12:10:00',2.9),('12664','2013-12-28','12:15:00',2.92),('12664','2013-12-28','12:20:00',2.92),('12664','2013-12-28','12:25:00',2.88),('12664','2013-12-28','12:30:00',2.87),('12664','2013-12-28','12:35:00',2.82),('12664','2013-12-28','12:40:00',2.79),('12664','2013-12-28','12:45:00',2.76),('12664','2013-12-28','12:50:00',2.74),('12664','2013-12-28','12:55:00',2.74),('12664','2013-12-28','13:00:00',2.72),('12664','2013-12-28','13:05:00',2.68),('12664','2013-12-28','13:10:00',2.67),('12664','2013-12-28','13:15:00',2.68),('12664','2013-12-28','13:20:00',2.6),('12664','2013-12-28','13:25:00',2.56),('12664','2013-12-28','13:30:00',2.53),('12664','2013-12-28','13:35:00',2.49),('12664','2013-12-28','13:40:00',2.47),('12664','2013-12-28','13:45:00',2.44),('12664','2013-12-28','13:50:00',2.38),('12664','2013-12-28','13:55:00',2.35),('12664','2013-12-28','14:00:00',2.29),('12664','2013-12-28','14:05:00',2.24),('12664','2013-12-28','14:10:00',2.2),('12664','2013-12-28','14:15:00',2.15),('12664','2013-12-28','14:20:00',2.08),('12664','2013-12-28','14:25:00',2.02),('12664','2013-12-28','14:30:00',2),('12664','2013-12-28','14:35:00',1.74),('12664','2013-12-28','14:40:00',1.31),('12664','2013-12-28','14:45:00',1.51),('12664','2013-12-28','14:50:00',1.64),('12664','2013-12-28','14:55:00',1.73),('12664','2013-12-28','15:00:00',1.63),('12664','2013-12-28','15:05:00',1.52),('12664','2013-12-28','15:10:00',1.41),('12664','2013-12-28','15:15:00',1.33),('12664','2013-12-28','15:20:00',1.25),('12664','2013-12-28','15:25:00',1.09),('12664','2013-12-28','15:30:00',1.08),('12664','2013-12-27','11:45:00',1.04),('12664','2013-12-27','11:50:00',1.3),('12664','2013-12-27','11:55:00',1.49),('12664','2013-12-27','12:00:00',2.11),('12664','2013-12-27','12:05:00',1.92),('12664','2013-12-27','12:10:00',1.48),('12664','2013-12-27','12:35:00',1.29),('12664','2013-12-27','12:40:00',2.08),('12664','2013-12-27','12:45:00',2.15),('12664','2013-12-27','12:50:00',2.02),('12664','2013-12-27','12:55:00',2.33),('12664','2013-12-27','13:00:00',2.66),('12664','2013-12-27','13:05:00',2.7),('12664','2013-12-27','13:10:00',2.65),('12664','2013-12-27','13:15:00',2.59),('12664','2013-12-27','13:20:00',2.64),('12664','2013-12-27','13:25:00',2.48),('12664','2013-12-27','13:30:00',1.67),('12664','2013-12-27','13:35:00',1.43),('12664','2013-12-27','13:40:00',1.25),('12664','2013-12-27','13:45:00',1.17),('12664','2013-12-27','13:50:00',1.21),('12664','2013-12-27','13:55:00',1.33),('12664','2013-12-27','14:00:00',1.82),('12664','2013-12-27','14:05:00',2.37),('12664','2013-12-27','14:10:00',1.9),('12664','2013-12-27','14:15:00',1.16),('12664','2013-12-27','14:20:00',1.12),('12664','2013-12-27','14:25:00',1.14),('12664','2013-12-27','14:30:00',1.21),('12664','2013-12-27','14:35:00',1.35),('12664','2014-04-22','08:05:00',1.03),('12664','2014-04-22','08:10:00',1.13),('12664','2014-04-22','08:15:00',1.22),('12664','2014-04-22','08:20:00',1.32),('12664','2014-04-22','08:25:00',1.42),('12664','2014-04-22','08:30:00',1.49),('12664','2014-04-22','08:35:00',1.51),('12664','2014-04-22','08:40:00',1.51),('12664','2014-04-22','08:45:00',1.71),('12664','2014-04-22','08:50:00',1.8),('12664','2014-04-22','08:55:00',1.7),('12664','2014-04-22','09:00:00',1.89),('12664','2014-04-22','09:05:00',1.69),('12664','2014-04-22','09:10:00',1.97),('12664','2014-04-22','09:15:00',2.14),('12664','2014-04-22','09:20:00',2.5),('12664','2014-04-22','09:25:00',2.58),('12664','2014-04-22','09:30:00',2.43),('12664','2014-04-22','09:35:00',2.57),('12664','2014-04-22','09:40:00',2.4),('12664','2014-04-22','09:45:00',2.62),('12664','2014-04-22','09:50:00',1.08),('12664','2014-04-22','09:55:00',1.14),('12664','2014-04-22','10:00:00',1.44),('12664','2014-04-22','10:05:00',1.42),('12664','2014-04-22','10:10:00',1.52),('12664','2014-04-22','10:15:00',2.02),('12664','2014-04-22','10:20:00',2.54),('12664','2014-04-22','10:25:00',1.5),('12664','2014-04-22','10:30:00',1.87),('12664','2014-04-22','10:35:00',1.86),('12664','2014-04-22','10:40:00',2.88),('12664','2014-04-22','10:45:00',2.78),('12664','2014-04-22','10:50:00',2.5),('12664','2014-04-22','10:55:00',3.22),('12664','2014-04-22','11:00:00',3.35),('12664','2014-04-22','11:05:00',2.54),('12664','2014-04-22','11:10:00',1.66),('12664','2014-04-22','11:15:00',1.55),('12664','2014-04-22','11:20:00',1.18),('12664','2014-04-22','11:25:00',1.03),('12664','2014-04-22','11:50:00',1.1),('12664','2014-04-22','12:05:00',1.04),('12664','2014-04-22','12:10:00',1.03),('12664','2014-04-22','12:15:00',1.07),('12664','2014-04-22','12:20:00',1.11),('12664','2014-04-22','12:25:00',1.17),('12664','2014-04-22','12:30:00',1),('12664','2014-04-22','13:05:00',1.1),('12664','2014-04-22','13:10:00',1.28),('12664','2014-04-22','13:15:00',1.2),('12664','2014-04-22','13:20:00',1.22),('12664','2014-04-22','13:25:00',1.88),('12664','2014-04-22','13:30:00',2.46),('12664','2014-04-22','13:35:00',2.57),('12664','2014-04-22','13:40:00',2.69),('12664','2014-04-22','13:45:00',3.42),('12664','2014-04-22','13:50:00',2.23),('12664','2014-04-22','13:55:00',2.01),('12664','2014-04-22','14:00:00',2.14),('12664','2014-04-22','14:05:00',3.85),('12664','2014-04-22','14:10:00',3.15),('12664','2014-04-22','14:15:00',2.96),('12664','2014-04-22','14:20:00',1.69),('12664','2014-04-22','14:25:00',1.85),('12664','2014-04-22','14:30:00',2.16),('12664','2014-04-22','14:35:00',2.06),('12664','2014-04-22','14:40:00',1.6),('12664','2014-04-22','14:45:00',2.06),('12664','2014-04-22','14:50:00',2.81),('12664','2014-04-22','14:55:00',2.12),('12664','2014-04-22','15:00:00',1.41),('12664','2014-04-22','15:05:00',1.43),('12664','2014-04-22','15:10:00',1.24),('12664','2014-04-22','15:15:00',1.45),('12664','2014-04-22','15:20:00',1.53),('12664','2014-04-22','15:25:00',2.22),('12664','2014-04-22','15:30:00',2.04),('12664','2014-04-22','15:35:00',2.77),('12664','2014-04-22','15:40:00',2.47),('12664','2014-04-22','15:45:00',2.4),('12664','2014-04-22','15:50:00',2.25),('12664','2014-04-22','15:55:00',2.35),('12664','2014-04-22','16:00:00',2.67),('12664','2014-04-22','16:05:00',1.63),('12664','2014-04-22','16:10:00',1.36),('12664','2014-04-22','16:15:00',1.31),('12664','2014-04-22','16:20:00',1.37),('12664','2014-04-22','16:25:00',1.29),('12664','2014-04-22','16:30:00',1.2),('12664','2014-04-22','16:35:00',1.22),('12664','2014-04-22','16:40:00',1.26),('12664','2014-04-22','16:45:00',1.24),('12664','2014-04-22','16:50:00',1.21),('12664','2014-04-22','16:55:00',1.28),('12664','2014-04-22','17:00:00',1.57),('12664','2014-04-22','17:05:00',1.01),('12664','2013-12-25','09:05:00',1.26),('12664','2013-12-25','09:10:00',1.16),('12664','2013-12-25','10:40:00',1.05),('12664','2013-12-25','10:45:00',1.01),('12664','2013-12-25','11:05:00',1.86),('12664','2013-12-25','11:10:00',2.16),('12664','2013-12-25','11:15:00',1.38),('12664','2013-12-25','11:20:00',2.19),('12664','2013-12-25','11:25:00',1.45),('12664','2013-12-25','11:35:00',1.15),('12664','2013-12-25','11:50:00',2.21),('12664','2013-12-25','11:55:00',2.57),('12664','2013-12-25','12:00:00',1.12),('12664','2013-12-25','12:05:00',1.52),('12664','2013-12-25','12:10:00',2.06),('12664','2013-12-25','12:25:00',1),('12664','2013-12-25','12:30:00',1.93),('12664','2013-12-25','12:35:00',2.24),('12664','2013-12-25','12:40:00',1.65),('12664','2013-12-25','12:45:00',1.5),('12664','2013-12-25','12:55:00',1.06),('12664','2013-12-25','13:00:00',1.09),('12664','2013-12-25','13:35:00',1.1),('12664','2013-12-25','13:40:00',1.33),('12664','2013-12-25','13:45:00',1.3),('12664','2013-12-25','13:50:00',1.17),('12664','2013-12-25','15:10:00',1.01),('12664','2013-12-25','15:15:00',1.16),('12664','2013-12-24','08:55:00',1.04),('12664','2013-12-24','09:00:00',1.22),('12664','2013-12-24','09:05:00',1.31),('12664','2013-12-24','09:10:00',1.4),('12664','2013-12-24','09:15:00',1.47),('12664','2013-12-24','09:20:00',1.54),('12664','2013-12-24','09:25:00',1.62),('12664','2013-12-24','09:30:00',1.69),('12664','2013-12-24','09:35:00',1.74),('12664','2013-12-24','09:40:00',1.81),('12664','2013-12-24','09:45:00',1.88),('12664','2013-12-24','09:50:00',1.94),('12664','2013-12-24','09:55:00',2.01),('12664','2013-12-24','10:00:00',2.07),('12664','2013-12-24','10:05:00',2.12),('12664','2013-12-24','10:10:00',2.18),('12664','2013-12-24','10:15:00',2.22),('12664','2013-12-24','10:20:00',2.25),('12664','2013-12-24','10:25:00',2.31),('12664','2013-12-24','10:30:00',2.35),('12664','2013-12-24','10:35:00',2.37),('12664','2013-12-24','10:40:00',2.39),('12664','2013-12-24','10:45:00',2.42),('12664','2013-12-24','10:50:00',2.44),('12664','2013-12-24','10:55:00',2.46),('12664','2013-12-24','11:00:00',2.51),('12664','2013-12-24','11:05:00',2.51),('12664','2013-12-24','11:10:00',2.52),('12664','2013-12-24','11:15:00',2.56),('12664','2013-12-24','11:20:00',2.54),('12664','2013-12-24','11:25:00',2.55),('12664','2013-12-24','11:30:00',2.47),('12664','2013-12-24','11:35:00',2.47),('12664','2013-12-24','11:40:00',2.48),('12664','2013-12-24','11:45:00',2.51),('12664','2013-12-24','11:50:00',2.55),('12664','2013-12-24','11:55:00',2.6),('12664','2013-12-24','12:00:00',2.59),('12664','2013-12-24','12:05:00',2.62),('12664','2013-12-24','12:10:00',2.62),('12664','2013-12-24','12:15:00',2.61),('12664','2013-12-24','12:20:00',2.59),('12664','2013-12-24','12:25:00',2.59),('12664','2013-12-24','12:30:00',2.57),('12664','2013-12-24','12:35:00',2.56),('12664','2013-12-24','12:40:00',2.54),('12664','2013-12-24','12:45:00',2.54),('12664','2013-12-24','12:50:00',2.5),('12664','2013-12-24','12:55:00',2.39),('12664','2013-12-24','13:00:00',2.35),('12664','2013-12-24','13:05:00',2.35),('12664','2013-12-24','13:10:00',2.33),('12664','2013-12-24','13:15:00',2.23),('12664','2013-12-24','13:20:00',2.19),('12664','2013-12-24','13:25:00',2.14),('12664','2013-12-24','13:30:00',2.17),('12664','2013-12-24','13:35:00',2.13),('12664','2013-12-24','13:40:00',2.09),('12664','2013-12-24','13:45:00',2.05),('12664','2013-12-24','13:50:00',2.01),('12664','2013-12-24','13:55:00',1.96),('12664','2013-12-24','14:00:00',1.88),('12664','2013-12-24','14:05:00',1.81),('12664','2013-12-24','14:10:00',1.72),('12664','2013-12-24','14:15:00',1.65),('12664','2013-12-24','14:20:00',1.55),('12664','2013-12-24','14:25:00',1.51),('12664','2013-12-24','14:30:00',1.48),('12664','2013-12-24','14:35:00',1.46),('12664','2013-12-24','14:40:00',1.37),('12664','2013-12-24','14:45:00',1.29),('12664','2013-12-24','14:50:00',1.26),('12664','2013-12-24','14:55:00',1.21),('12664','2013-12-24','15:00:00',1.14),('12664','2013-12-24','15:05:00',1.08),('12664','2013-12-24','15:10:00',1.03),('12664','2013-12-23','09:10:00',1.06),('12664','2013-12-23','09:15:00',1.35),('12664','2013-12-23','09:20:00',1.24),('12664','2013-12-23','09:25:00',1.21),('12664','2013-12-23','09:30:00',1.33),('12664','2013-12-23','09:35:00',1.05),('12664','2013-12-23','09:40:00',1.06),('12664','2013-12-23','09:55:00',1.04),('12664','2013-12-23','10:00:00',1.17),('12664','2013-12-23','10:05:00',1.22),('12664','2013-12-23','10:10:00',1.77),('12664','2013-12-23','10:15:00',1.8),('12664','2013-12-23','10:20:00',2.13),('12664','2013-12-23','10:25:00',2.39),('12664','2013-12-23','10:30:00',2.4),('12664','2013-12-23','10:35:00',1.97),('12664','2013-12-23','10:40:00',2),('12664','2013-12-23','10:45:00',2.47),('12664','2013-12-23','10:50:00',2.46),('12664','2013-12-23','10:55:00',2.54),('12664','2013-12-23','11:00:00',2.53),('12664','2013-12-23','11:05:00',2.32),('12664','2013-12-23','11:10:00',2.58),('12664','2013-12-23','11:15:00',2.33),('12664','2013-12-23','11:20:00',2.57),('12664','2013-12-23','11:25:00',2.77),('12664','2013-12-23','11:30:00',2.99),('12664','2013-12-23','11:35:00',2.98),('12664','2013-12-23','11:40:00',2.89),('12664','2013-12-23','11:45:00',2.56),('12664','2013-12-23','11:50:00',2.89),('12664','2013-12-23','11:55:00',2.98),('12664','2013-12-23','12:00:00',2.93),('12664','2013-12-23','12:05:00',2.9),('12664','2013-12-23','12:10:00',2.85),('12664','2013-12-23','12:15:00',2.8),('12664','2013-12-23','12:20:00',2.76),('12664','2013-12-23','12:25:00',2.73),('12664','2013-12-23','12:30:00',2.67),('12664','2013-12-23','12:35:00',2.65),('12664','2013-12-23','12:40:00',2.64),('12664','2013-12-23','12:45:00',2.57),('12664','2013-12-23','12:50:00',2.57),('12664','2013-12-23','12:55:00',2.53),('12664','2013-12-23','13:00:00',2.5),('12664','2013-12-23','13:05:00',2.48),('12664','2013-12-23','13:10:00',2.49),('12664','2013-12-23','13:15:00',2.44),('12664','2013-12-23','13:20:00',2.45),('12664','2013-12-23','13:25:00',2.46),('12664','2013-12-23','13:30:00',2.44),('12664','2013-12-23','13:35:00',2.37),('12664','2013-12-23','13:40:00',2.13),('12664','2013-12-23','13:45:00',1.79),('12664','2013-12-23','13:50:00',2.27),('12664','2013-12-23','13:55:00',2.27),('12664','2013-12-23','14:00:00',2.2),('12664','2013-12-23','14:05:00',2.13),('12664','2013-12-23','14:10:00',2.07),('12664','2013-12-23','14:15:00',2.01),('12664','2013-12-23','14:20:00',1.92),('12664','2013-12-23','14:25:00',1.86),('12664','2013-12-23','14:30:00',1.79),('12664','2013-12-23','14:35:00',1.74),('12664','2013-12-23','14:40:00',1.68),('12664','2013-12-23','14:45:00',1.59),('12664','2013-12-23','14:50:00',1.52),('12664','2013-12-23','14:55:00',1.44),('12664','2013-12-23','15:00:00',1.34),('12664','2013-12-23','15:05:00',1.28),('12664','2013-12-23','15:10:00',1.21),('12664','2013-12-23','15:15:00',1.12),('12664','2013-12-23','15:20:00',1.01),('12664','2013-12-22','09:10:00',1.04),('12664','2013-12-22','09:15:00',1.22),('12664','2013-12-22','09:20:00',1.13),('12664','2013-12-22','09:25:00',1.27),('12664','2013-12-22','09:30:00',1.48),('12664','2013-12-22','09:35:00',1.96),('12664','2013-12-22','09:40:00',2.36),('12664','2013-12-22','09:45:00',2.39),('12664','2013-12-22','09:50:00',2.56),('12664','2013-12-22','09:55:00',2.67),('12664','2013-12-22','10:00:00',2.6),('12664','2013-12-22','10:05:00',2.52),('12664','2013-12-22','10:10:00',2.46),('12664','2013-12-22','10:15:00',2.58),('12664','2013-12-22','10:20:00',2.55),('12664','2013-12-22','10:25:00',2.44),('12664','2013-12-22','10:30:00',2.29),('12664','2013-12-22','10:35:00',2.23),('12664','2013-12-22','10:40:00',2.42),('12664','2013-12-22','10:45:00',2.2),('12664','2013-12-22','10:50:00',2.45),('12664','2013-12-22','10:55:00',2.54),('12664','2013-12-22','11:00:00',2.41),('12664','2013-12-22','11:05:00',2.69),('12664','2013-12-22','11:10:00',2.52),('12664','2013-12-22','11:15:00',2.53),('12664','2013-12-22','11:20:00',2.77),('12664','2013-12-22','11:25:00',2.57),('12664','2013-12-22','11:30:00',2.34),('12664','2013-12-22','11:35:00',2.66),('12664','2013-12-22','11:40:00',2.68),('12664','2013-12-22','11:45:00',2.45),('12664','2013-12-22','11:50:00',1.85),('12664','2013-12-22','11:55:00',1.61),('12664','2013-12-22','12:00:00',1.16),('12664','2013-12-22','12:20:00',1),('12664','2013-12-22','12:25:00',1.23),('12664','2013-12-22','12:30:00',1.26),('12664','2013-12-22','12:35:00',1.48),('12664','2013-12-22','12:40:00',1.7),('12664','2013-12-22','12:45:00',1.7),('12664','2013-12-22','12:50:00',1.44),('12664','2013-12-22','12:55:00',1.78),('12664','2013-12-22','13:00:00',2.6),('12664','2013-12-22','13:05:00',2.66),('12664','2013-12-22','13:10:00',2.73),('12664','2013-12-22','13:15:00',2.62),('12664','2013-12-22','13:20:00',2.25),('12664','2013-12-22','13:25:00',2.68),('12664','2013-12-22','13:30:00',2.42),('12664','2013-12-22','13:35:00',2.33),('12664','2013-12-22','13:40:00',2.22),('12664','2013-12-22','13:45:00',1.56),('12664','2013-12-22','13:50:00',1.53),('12664','2013-12-22','13:55:00',1.38),('12664','2013-12-22','14:00:00',1.49),('12664','2013-12-22','14:05:00',1.56),('12664','2013-12-22','14:10:00',1.52),('12664','2013-12-22','14:15:00',1.48),('12664','2013-12-22','14:20:00',1.13),('12664','2013-12-22','14:30:00',1.21),('12664','2013-12-22','14:35:00',1.64),('12664','2013-12-22','14:40:00',1.78),('12664','2013-12-22','14:45:00',1.62),('12664','2013-12-22','14:50:00',1.05),('12664','2013-12-22','15:10:00',1.1),('12664','2013-12-21','08:45:00',1.06),('12664','2013-12-21','08:50:00',1.16),('12664','2013-12-21','08:55:00',1.24),('12664','2013-12-21','09:00:00',1.3),('12664','2013-12-21','09:05:00',1.38),('12664','2013-12-21','09:10:00',1.45),('12664','2013-12-21','09:15:00',1.54),('12664','2013-12-21','09:20:00',1.63),('12664','2013-12-21','09:25:00',1.71),('12664','2013-12-21','09:30:00',1.79),('12664','2013-12-21','09:35:00',1.85),('12664','2013-12-21','09:40:00',1.92),('12664','2013-12-21','09:45:00',1.99),('12664','2013-12-21','09:50:00',2.05),('12664','2013-12-21','09:55:00',2.1),('12664','2013-12-21','10:00:00',2.14),('12664','2013-12-21','10:05:00',2.19),('12664','2013-12-21','10:10:00',2.23),('12664','2013-12-21','10:15:00',2.28),('12664','2013-12-21','10:20:00',2.32),('12664','2013-12-21','10:25:00',2.37),('12664','2013-12-21','10:30:00',2.42),('12664','2013-12-21','10:35:00',2.46),('12664','2013-12-21','10:40:00',2.5),('12664','2013-12-21','10:45:00',2.54),('12664','2013-12-21','10:50:00',2.57),('12664','2013-12-21','10:55:00',2.6),('12664','2013-12-21','11:00:00',2.64),('12664','2013-12-21','11:05:00',2.67),('12664','2013-12-21','11:10:00',2.72),('12664','2013-12-21','11:15:00',2.73),('12664','2013-12-21','11:20:00',2.74),('12664','2013-12-21','11:25:00',2.77),('12664','2013-12-21','11:30:00',2.78),('12664','2013-12-21','11:35:00',2.8),('12664','2013-12-21','11:40:00',2.8),('12664','2013-12-21','11:45:00',2.81),('12664','2013-12-21','11:50:00',2.83),('12664','2013-12-21','11:55:00',2.83),('12664','2013-12-21','12:00:00',2.81),('12664','2013-12-21','12:05:00',2.81),('12664','2013-12-21','12:10:00',2.81),('12664','2013-12-21','12:15:00',2.79),('12664','2013-12-21','12:20:00',2.78),('12664','2013-12-21','12:25:00',2.77),('12664','2013-12-21','12:30:00',2.75),('12664','2013-12-21','12:35:00',2.73),('12664','2013-12-21','12:40:00',2.71),('12664','2013-12-21','12:45:00',2.72),('12664','2013-12-21','12:50:00',2.71),('12664','2013-12-21','12:55:00',2.69),('12664','2013-12-21','13:00:00',2.69),('12664','2013-12-21','13:05:00',2.64),('12664','2013-12-21','13:10:00',2.61),('12664','2013-12-21','13:15:00',2.6),('12664','2013-12-21','13:20:00',2.57),('12664','2013-12-21','13:25:00',2.54),('12664','2013-12-21','13:30:00',2.52),('12664','2013-12-21','13:35:00',2.48),('12664','2013-12-21','13:40:00',2.44),('12664','2013-12-21','13:45:00',2.4),('12664','2013-12-21','13:50:00',2.37),('12664','2013-12-21','13:55:00',2.32),('12664','2013-12-21','14:00:00',2.26),('12664','2013-12-21','14:05:00',2.18),('12664','2013-12-21','14:10:00',2.11),('12664','2013-12-21','14:15:00',2.06),('12664','2013-12-21','14:20:00',2),('12664','2013-12-21','14:25:00',1.92),('12664','2013-12-21','14:30:00',1.84),('12664','2013-12-21','14:35:00',1.77),('12664','2013-12-21','14:40:00',1.69),('12664','2013-12-21','14:45:00',1.62),('12664','2013-12-21','14:50:00',1.54),('12664','2013-12-21','14:55:00',1.47),('12664','2013-12-21','15:00:00',1.4),('12664','2013-12-21','15:05:00',1.32),('12664','2013-12-21','15:10:00',1.24),('12664','2013-12-21','15:15:00',1.17),('12664','2013-12-21','15:20:00',1.08),('12664','2013-12-20','08:50:00',1.1),('12664','2013-12-20','08:55:00',1.18),('12664','2013-12-20','09:00:00',1.26),('12664','2013-12-20','09:05:00',1.36),('12664','2013-12-20','09:10:00',1.43),('12664','2013-12-20','09:15:00',1.5),('12664','2013-12-20','09:20:00',1.56),('12664','2013-12-20','09:25:00',1.62),('12664','2013-12-20','09:30:00',1.69),('12664','2013-12-20','09:35:00',1.75),('12664','2013-12-20','09:40:00',1.81),('12664','2013-12-20','09:45:00',1.89),('12664','2013-12-20','09:50:00',1.91),('12664','2013-12-20','09:55:00',1.97),('12664','2013-12-20','10:00:00',2.06),('12664','2013-12-20','10:05:00',2.11),('12664','2013-12-20','10:10:00',2.12),('12664','2013-12-20','10:15:00',2.15),('12664','2013-12-20','10:20:00',2.23),('12664','2013-12-20','10:25:00',2.3),('12664','2013-12-20','10:30:00',2.34),('12664','2013-12-20','10:35:00',2.35),('12664','2013-12-20','10:40:00',2.37),('12664','2013-12-20','10:45:00',2.43),('12664','2013-12-20','10:50:00',2.46),('12664','2013-12-20','10:55:00',2.5),('12664','2013-12-20','11:00:00',2.53),('12664','2013-12-20','11:05:00',2.56),('12664','2013-12-20','11:10:00',2.59),('12664','2013-12-20','11:15:00',2.58),('12664','2013-12-20','11:20:00',2.58),('12664','2013-12-20','11:25:00',2.63),('12664','2013-12-20','11:30:00',2.62),('12664','2013-12-20','11:35:00',2.61),('12664','2013-12-20','11:40:00',2.64),('12664','2013-12-20','11:45:00',2.63),('12664','2013-12-20','11:50:00',2.63),('12664','2013-12-20','11:55:00',2.64),('12664','2013-12-20','12:00:00',2.68),('12664','2013-12-20','12:05:00',2.67),('12664','2013-12-20','12:10:00',2.65),('12664','2013-12-20','12:15:00',2.66),('12664','2013-12-20','12:20:00',2.62),('12664','2013-12-20','12:25:00',2.59),('12664','2013-12-20','12:30:00',2.57),('12664','2013-12-20','12:35:00',2.56),('12664','2013-12-20','12:40:00',2.51),('12664','2013-12-20','12:45:00',2.46),('12664','2013-12-20','12:50:00',2.49),('12664','2013-12-20','12:55:00',2.45),('12664','2013-12-20','13:00:00',2.4),('12664','2013-12-20','13:05:00',2.36),('12664','2013-12-20','13:10:00',2.4),('12664','2013-12-20','13:15:00',2.3),('12664','2013-12-20','13:20:00',2.15),('12664','2013-12-20','13:25:00',2.25),('12664','2013-12-20','13:30:00',1.52),('12664','2013-12-20','13:35:00',1.67),('12664','2013-12-20','13:40:00',1.96),('12664','2013-12-20','13:45:00',1.67),('12664','2013-12-20','13:55:00',1.5),('12664','2013-12-20','14:00:00',1.14),('12664','2013-12-20','14:15:00',1.57),('12664','2013-12-20','14:25:00',1.04),('12664','2013-12-20','14:30:00',1.48),('12664','2013-12-20','14:35:00',1.46),('12664','2013-12-20','14:40:00',1.34),('12664','2013-12-20','14:45:00',1.26),('12664','2013-12-19','09:10:00',1.26),('12664','2013-12-19','09:25:00',1.13),('12664','2013-12-19','09:40:00',1.48),('12664','2013-12-19','09:45:00',1.75),('12664','2013-12-19','09:50:00',1.31),('12664','2013-12-19','09:55:00',1.08),('12664','2013-12-19','10:35:00',1.38),('12664','2013-12-19','10:40:00',1.07),('12664','2013-12-19','10:55:00',1.17),('12664','2013-12-19','11:00:00',1.13),('12664','2013-12-19','12:20:00',1.3),('12664','2013-12-19','12:25:00',1.07),('12664','2013-12-19','13:35:00',1.09),('12664','2013-12-19','13:40:00',1.12),('12664','2013-12-19','14:20:00',1.67),('12664','2013-12-19','14:25:00',1),('12664','2013-12-19','14:30:00',1.36),('12664','2013-12-19','14:35:00',1.92),('12664','2013-12-19','14:40:00',1.8),('12664','2013-12-19','14:45:00',1.49),('12664','2013-12-19','14:50:00',1.29),('12664','2013-12-19','15:00:00',1.01),('12664','2013-12-19','15:05:00',1.08),('12664','2013-12-18','08:40:00',1.04),('12664','2013-12-18','08:45:00',1.11),('12664','2013-12-18','08:50:00',1.22),('12664','2013-12-18','08:55:00',1.31),('12664','2013-12-18','09:00:00',1.39),('12664','2013-12-18','09:05:00',1.47),('12664','2013-12-18','09:10:00',1.54),('12664','2013-12-18','09:15:00',1.63),('12664','2013-12-18','09:20:00',1.71),('12664','2013-12-18','09:25:00',1.78),('12664','2013-12-18','09:30:00',1.86),('12664','2013-12-18','09:35:00',1.94),('12664','2013-12-18','09:40:00',2),('12664','2013-12-18','09:45:00',2.09),('12664','2013-12-18','09:50:00',2.13),('12664','2013-12-18','09:55:00',2.2),('12664','2013-12-18','10:00:00',2.24),('12664','2013-12-18','10:05:00',2.28),('12664','2013-12-18','10:10:00',2.35),('12664','2013-12-18','10:15:00',2.37),('12664','2013-12-18','10:20:00',2.39),('12664','2013-12-18','10:25:00',2.46),('12664','2013-12-18','10:30:00',2.5),('12664','2013-12-18','10:35:00',2.53),('12664','2013-12-18','10:40:00',2.54),('12664','2013-12-18','10:45:00',2.57),('12664','2013-12-18','10:50:00',2.59),('12664','2013-12-18','10:55:00',2.63),('12664','2013-12-18','11:00:00',2.66),('12664','2013-12-18','11:05:00',2.7),('12664','2013-12-18','11:10:00',2.72),('12664','2013-12-18','11:15:00',2.76),('12664','2013-12-18','11:20:00',2.78),('12664','2013-12-18','11:25:00',2.81),('12664','2013-12-18','11:30:00',2.83),('12664','2013-12-18','11:35:00',2.83),('12664','2013-12-18','11:40:00',2.83),('12664','2013-12-18','11:45:00',2.82),('12664','2013-12-18','11:50:00',2.83),('12664','2013-12-18','11:55:00',2.83),('12664','2013-12-18','12:00:00',2.84),('12664','2013-12-18','12:05:00',2.84),('12664','2013-12-18','12:10:00',2.84),('12664','2013-12-18','12:15:00',2.83),('12664','2013-12-18','12:20:00',2.83),('12664','2013-12-18','12:25:00',2.81),('12664','2013-12-18','12:30:00',2.81),('12664','2013-12-18','12:35:00',2.78),('12664','2013-12-18','12:40:00',2.76),('12664','2013-12-18','12:45:00',2.74),('12664','2013-12-18','12:50:00',2.73),('12664','2013-12-18','12:55:00',2.71),('12664','2013-12-18','13:00:00',2.67),('12664','2013-12-18','13:05:00',2.63),('12664','2013-12-18','13:10:00',2.62),('12664','2013-12-18','13:15:00',2.6),('12664','2013-12-18','13:20:00',2.56),('12664','2013-12-18','13:25:00',2.54),('12664','2013-12-18','13:30:00',2.44),('12664','2013-12-18','13:35:00',2.39),('12664','2013-12-18','13:40:00',2.37),('12664','2013-12-18','13:45:00',2.35),('12664','2013-12-18','13:50:00',2.3),('12664','2013-12-18','13:55:00',2.23),('12664','2013-12-18','14:00:00',2.15),('12664','2013-12-18','14:05:00',2.1),('12664','2013-12-18','14:10:00',2.03),('12664','2013-12-18','14:15:00',1.95),('12664','2013-12-18','14:20:00',1.9),('12664','2013-12-18','14:25:00',1.84),('12664','2013-12-18','14:30:00',1.77),('12664','2013-12-18','14:35:00',1.67),('12664','2013-12-18','14:40:00',1.64),('12664','2013-12-18','14:45:00',1.59),('12664','2013-12-18','14:50:00',1.52),('12664','2013-12-18','14:55:00',1.47),('12664','2013-12-18','15:00:00',1.38),('12664','2013-12-18','15:05:00',1.29),('12664','2013-12-18','15:10:00',1.2),('12664','2013-12-18','15:15:00',1.11),('12664','2013-12-18','15:20:00',1.04),('12664','2013-12-17','08:30:00',1.02),('12664','2013-12-17','08:35:00',1.11),('12664','2013-12-17','08:40:00',1.2),('12664','2013-12-17','08:45:00',1.29),('12664','2013-12-17','08:50:00',1.38),('12664','2013-12-17','08:55:00',1.46),('12664','2013-12-17','09:00:00',1.55),('12664','2013-12-17','09:05:00',1.64),('12664','2013-12-17','09:10:00',1.73),('12664','2013-12-17','09:15:00',1.8),('12664','2013-12-17','09:20:00',1.89),('12664','2013-12-17','09:25:00',1.96),('12664','2013-12-17','09:30:00',2.01),('12664','2013-12-17','09:35:00',2.08),('12664','2013-12-17','09:40:00',2.14),('12664','2013-12-17','09:45:00',2.18),('12664','2013-12-17','09:50:00',2.25),('12664','2013-12-17','09:55:00',2.3),('12664','2013-12-17','10:00:00',2.37),('12664','2013-12-17','10:05:00',2.42),('12664','2013-12-17','10:10:00',2.46),('12664','2013-12-17','10:15:00',2.5),('12664','2013-12-17','10:20:00',2.56),('12664','2013-12-17','10:25:00',2.59),('12664','2013-12-17','10:30:00',2.61),('12664','2013-12-17','10:35:00',2.66),('12664','2013-12-17','10:40:00',2.68),('12664','2013-12-17','10:45:00',2.72),('12664','2013-12-17','10:50:00',2.75),('12664','2013-12-17','10:55:00',2.81),('12664','2013-12-17','11:00:00',2.83),('12664','2013-12-17','11:05:00',2.85),('12664','2013-12-17','11:10:00',2.86),('12664','2013-12-17','11:15:00',2.88),('12664','2013-12-17','11:20:00',2.88),('12664','2013-12-17','11:25:00',2.9),('12664','2013-12-17','11:30:00',2.92),('12664','2013-12-17','11:35:00',2.94),('12664','2013-12-17','11:40:00',2.95),('12664','2013-12-17','11:45:00',2.98),('12664','2013-12-17','11:50:00',2.99),('12664','2013-12-17','11:55:00',2.98),('12664','2013-12-17','12:00:00',2.99),('12664','2013-12-17','12:05:00',3),('12664','2013-12-17','12:10:00',2.99),('12664','2013-12-17','12:15:00',2.97),('12664','2013-12-17','12:20:00',2.97),('12664','2013-12-17','12:25:00',2.96),('12664','2013-12-17','12:30:00',2.94),('12664','2013-12-17','12:35:00',2.93),('12664','2013-12-17','12:40:00',2.91),('12664','2013-12-17','12:45:00',2.88),('12664','2013-12-17','12:50:00',2.87),('12664','2013-12-17','12:55:00',2.85),('12664','2013-12-17','13:00:00',2.83),('12664','2013-12-17','13:05:00',2.8),('12664','2013-12-17','13:10:00',2.75),('12664','2013-12-17','13:15:00',2.71),('12664','2013-12-17','13:20:00',2.69),('12664','2013-12-17','13:25:00',2.62),('12664','2013-12-17','13:30:00',2.56),('12664','2013-12-17','13:35:00',2.53),('12664','2013-12-17','13:40:00',2.48),('12664','2013-12-17','13:45:00',2.42),('12664','2013-12-17','13:50:00',2.38),('12664','2013-12-17','13:55:00',2.31),('12664','2013-12-17','14:00:00',2.23),('12664','2013-12-17','14:05:00',2.19),('12664','2013-12-17','14:10:00',2.12),('12664','2013-12-17','14:15:00',2.08),('12664','2013-12-17','14:20:00',2.02),('12664','2013-12-17','14:25:00',1.96),('12664','2013-12-17','14:30:00',1.88),('12664','2013-12-17','14:35:00',1.79),('12664','2013-12-17','14:40:00',1.7),('12664','2013-12-17','14:45:00',1.62),('12664','2013-12-17','14:50:00',1.55),('12664','2013-12-17','14:55:00',1.47),('12664','2013-12-17','15:00:00',1.4),('12664','2013-12-17','15:05:00',1.32),('12664','2013-12-17','15:10:00',1.24),('12664','2013-12-17','15:15:00',1.17),('12664','2013-12-17','15:20:00',1.09),('12664','2013-12-17','15:25:00',1.01),('12664','2014-04-21','08:50:00',1.28),('12664','2014-04-21','08:55:00',1.29),('12664','2014-04-21','09:00:00',1.25),('12664','2014-04-21','09:05:00',1.05),('12664','2014-04-21','09:10:00',1.15),('12664','2014-04-21','09:15:00',1.25),('12664','2014-04-21','09:25:00',2.27),('12664','2014-04-21','09:30:00',2.83),('12664','2014-04-21','09:35:00',2.08),('12664','2014-04-21','09:40:00',1.55),('12664','2014-04-21','09:50:00',1.01),('12664','2014-04-21','09:55:00',1.19),('12664','2014-04-21','10:00:00',1.29),('12664','2014-04-21','10:05:00',1.37),('12664','2014-04-21','10:10:00',1.93),('12664','2014-04-21','10:15:00',2.86),('12664','2014-04-21','10:20:00',2.24),('12664','2014-04-21','10:25:00',3.37),('12664','2014-04-21','10:30:00',3.3),('12664','2014-04-21','10:35:00',3.23),('12664','2014-04-21','10:40:00',3.34),('12664','2014-04-21','10:45:00',3.35),('12664','2014-04-21','10:50:00',3.36),('12664','2014-04-21','10:55:00',3.41),('12664','2014-04-21','11:00:00',3.44),('12664','2014-04-21','11:05:00',3.47),('12664','2014-04-21','11:10:00',3.51),('12664','2014-04-21','11:15:00',3.57),('12664','2014-04-21','11:20:00',3.61),('12664','2014-04-21','11:25:00',3.62),('12664','2014-04-21','11:30:00',3.65),('12664','2014-04-21','11:35:00',3.69),('12664','2014-04-21','11:40:00',3.75),('12664','2014-04-21','11:45:00',3.77),('12664','2014-04-21','11:50:00',3.79),('12664','2014-04-21','11:55:00',3.84),('12664','2014-04-21','12:00:00',3.87),('12664','2014-04-21','12:05:00',3.91),('12664','2014-04-21','12:10:00',3.94),('12664','2014-04-21','12:15:00',3.99),('12664','2014-04-21','12:20:00',4.01),('12664','2014-04-21','12:25:00',4.01),('12664','2014-04-21','12:30:00',4),('12664','2014-04-21','12:35:00',4),('12664','2014-04-21','12:40:00',4.01),('12664','2014-04-21','12:45:00',4.02),('12664','2014-04-21','12:50:00',4.02),('12664','2014-04-21','12:55:00',4.04),('12664','2014-04-21','13:00:00',4.05),('12664','2014-04-21','13:05:00',4.03),('12664','2014-04-21','13:10:00',4.05),('12664','2014-04-21','13:15:00',4.05),('12664','2014-04-21','13:20:00',4.06),('12664','2014-04-21','13:25:00',4.07),('12664','2014-04-21','13:30:00',4.09),('12664','2014-04-21','13:35:00',4.07),('12664','2014-04-21','13:40:00',4.07),('12664','2014-04-21','13:45:00',4.07),('12664','2014-04-21','13:50:00',4.06),('12664','2014-04-21','13:55:00',4.05),('12664','2014-04-21','14:00:00',4.02),('12664','2014-04-21','14:05:00',4.02),('12664','2014-04-21','14:10:00',4),('12664','2014-04-21','14:15:00',3.97),('12664','2014-04-21','14:20:00',3.94),('12664','2014-04-21','14:25:00',3.92),('12664','2014-04-21','14:30:00',3.89),('12664','2014-04-21','14:35:00',3.86),('12664','2014-04-21','14:40:00',3.82),('12664','2014-04-21','14:45:00',3.78),('12664','2014-04-21','14:50:00',3.74),('12664','2014-04-21','14:55:00',3.71),('12664','2014-04-21','15:00:00',3.66),('12664','2014-04-21','15:05:00',3.62),('12664','2014-04-21','15:10:00',3.57),('12664','2014-04-21','15:15:00',3.53),('12664','2014-04-21','15:20:00',3.48),('12664','2014-04-21','15:25:00',3.42),('12664','2014-04-21','15:30:00',3.37),('12664','2014-04-21','15:35:00',3.32),('12664','2014-04-21','15:40:00',3.27),('12664','2014-04-21','15:45:00',3.2),('12664','2014-04-21','15:50:00',3.14),('12664','2014-04-21','15:55:00',3.07),('12664','2014-04-21','16:00:00',2.67),('12664','2014-04-21','16:05:00',3.43),('12664','2014-04-21','16:10:00',2.97),('12664','2014-04-21','16:15:00',2.83),('12664','2014-04-21','16:20:00',2.72),('12664','2014-04-21','16:25:00',2.7),('12664','2014-04-21','16:30:00',2.65),('12664','2014-04-21','16:35:00',2.58),('12664','2014-04-21','16:40:00',2.5),('12664','2014-04-21','16:45:00',2.42),('12664','2014-04-21','16:50:00',2.35),('12664','2014-04-21','16:55:00',2.27),('12664','2014-04-21','17:00:00',2.19),('12664','2014-04-21','17:05:00',2.11),('12664','2014-04-21','17:10:00',2.02),('12664','2014-04-21','17:15:00',1.95),('12664','2014-04-21','17:20:00',1.87),('12664','2014-04-21','17:25:00',1.78),('12664','2014-04-21','17:30:00',1.7),('12664','2014-04-21','17:35:00',1.6),('12664','2014-04-21','17:40:00',1.51),('12664','2014-04-21','17:45:00',1.41),('12664','2014-04-21','17:50:00',1.3),('12664','2014-04-21','17:55:00',1.2),('12664','2014-04-21','18:00:00',1.11),('12664','2014-04-21','18:05:00',1.01),('12664','2013-12-16','08:35:00',1.06),('12664','2013-12-16','08:40:00',1.14),('12664','2013-12-16','08:45:00',1.23),('12664','2013-12-16','08:50:00',1.31),('12664','2013-12-16','08:55:00',1.4),('12664','2013-12-16','09:00:00',1.49),('12664','2013-12-16','09:05:00',1.57),('12664','2013-12-16','09:10:00',1.66),('12664','2013-12-16','09:15:00',1.73),('12664','2013-12-16','09:20:00',1.8),('12664','2013-12-16','09:25:00',1.87),('12664','2013-12-16','09:30:00',1.95),('12664','2013-12-16','09:35:00',2.02),('12664','2013-12-16','09:40:00',2.1),('12664','2013-12-16','09:45:00',2.18),('12664','2013-12-16','09:50:00',2.25),('12664','2013-12-16','09:55:00',2.3),('12664','2013-12-16','10:00:00',2.35),('12664','2013-12-16','10:05:00',2.39),('12664','2013-12-16','10:10:00',2.43),('12664','2013-12-16','10:15:00',2.48),('12664','2013-12-16','10:20:00',2.51),('12664','2013-12-16','10:25:00',2.56),('12664','2013-12-16','10:30:00',2.6),('12664','2013-12-16','10:35:00',2.63),('12664','2013-12-16','10:40:00',2.65),('12664','2013-12-16','10:45:00',2.68),('12664','2013-12-16','10:50:00',2.75),('12664','2013-12-16','10:55:00',2.77),('12664','2013-12-16','11:00:00',2.78),('12664','2013-12-16','11:05:00',2.8),('12664','2013-12-16','11:10:00',2.84),('12664','2013-12-16','11:15:00',2.87),('12664','2013-12-16','11:20:00',2.91),('12664','2013-12-16','11:25:00',2.92),('12664','2013-12-16','11:30:00',2.95),('12664','2013-12-16','11:35:00',2.96),('12664','2013-12-16','11:40:00',2.95),('12664','2013-12-16','11:45:00',2.96),('12664','2013-12-16','11:50:00',2.92),('12664','2013-12-16','11:55:00',2.91),('12664','2013-12-16','12:00:00',2.91),('12664','2013-12-16','12:05:00',2.95),('12664','2013-12-16','12:10:00',2.94),('12664','2013-12-16','12:15:00',2.92),('12664','2013-12-16','12:20:00',2.93),('12664','2013-12-16','12:25:00',2.84),('12664','2013-12-16','12:30:00',2.85),('12664','2013-12-16','12:35:00',2.84),('12664','2013-12-16','12:40:00',2.78),('12664','2013-12-16','12:45:00',2.78),('12664','2013-12-16','12:50:00',2.76),('12664','2013-12-16','12:55:00',2.78),('12664','2013-12-16','13:00:00',2.79),('12664','2013-12-16','13:05:00',2.77),('12664','2013-12-16','13:10:00',2.73),('12664','2013-12-16','13:15:00',2.7),('12664','2013-12-16','13:20:00',2.65),('12664','2013-12-16','13:25:00',2.59),('12664','2013-12-16','13:30:00',2.56),('12664','2013-12-16','13:35:00',2.52),('12664','2013-12-16','13:40:00',2.48),('12664','2013-12-16','13:45:00',2.43),('12664','2013-12-16','13:50:00',2.4),('12664','2013-12-16','13:55:00',2.34),('12664','2013-12-16','14:00:00',2.29),('12664','2013-12-16','14:05:00',2.23),('12664','2013-12-16','14:10:00',2.15),('12664','2013-12-16','14:15:00',2.08),('12664','2013-12-16','14:20:00',2.01),('12664','2013-12-16','14:25:00',1.93),('12664','2013-12-16','14:30:00',1.87),('12664','2013-12-16','14:35:00',1.81),('12664','2013-12-16','14:40:00',1.7),('12664','2013-12-16','14:45:00',1.64),('12664','2013-12-16','14:50:00',1.56),('12664','2013-12-16','14:55:00',1.5),('12664','2013-12-16','15:00:00',1.42),('12664','2013-12-16','15:05:00',1.35),('12664','2013-12-16','15:10:00',1.28),('12664','2013-12-16','15:15:00',1.2),('12664','2013-12-16','15:20:00',1.11),('12664','2013-12-16','15:25:00',1.01),('12664','2013-12-15','10:25:00',1.43),('12664','2013-12-15','11:10:00',1.01),('12664','2013-12-15','11:15:00',1.06),('12664','2013-12-15','12:00:00',1.03),('12664','2013-12-14','08:40:00',1.02),('12664','2013-12-14','08:45:00',1.05),('12664','2013-12-14','08:50:00',1.13),('12664','2013-12-14','08:55:00',1.23),('12664','2013-12-14','09:00:00',1.35),('12664','2013-12-14','09:05:00',1.46),('12664','2013-12-14','09:10:00',1.55),('12664','2013-12-14','09:15:00',1.63),('12664','2013-12-14','09:20:00',1.7),('12664','2013-12-14','09:25:00',1.78),('12664','2013-12-14','09:30:00',1.86),('12664','2013-12-14','09:35:00',1.92),('12664','2013-12-14','09:40:00',1.99),('12664','2013-12-14','09:45:00',2.06),('12664','2013-12-14','09:50:00',2.1),('12664','2013-12-14','09:55:00',2.15),('12664','2013-12-14','10:00:00',2.2),('12664','2013-12-14','10:05:00',2.27),('12664','2013-12-14','10:10:00',2.31),('12664','2013-12-14','10:15:00',2.36),('12664','2013-12-14','10:20:00',2.41),('12664','2013-12-14','10:25:00',2.47),('12664','2013-12-14','10:30:00',2.51),('12664','2013-12-14','10:35:00',2.53),('12664','2013-12-14','10:40:00',2.56),('12664','2013-12-14','10:45:00',2.6),('12664','2013-12-14','10:50:00',2.61),('12664','2013-12-14','10:55:00',2.65),('12664','2013-12-14','11:00:00',2.66),('12664','2013-12-14','11:05:00',2.63),('12664','2013-12-14','11:10:00',2.65),('12664','2013-12-14','11:15:00',2.67),('12664','2013-12-14','11:20:00',2.72),('12664','2013-12-14','11:25:00',2.71),('12664','2013-12-14','11:30:00',2.69),('12664','2013-12-14','11:35:00',2.72),('12664','2013-12-14','11:40:00',2.73),('12664','2013-12-14','11:45:00',2.73),('12664','2013-12-14','11:50:00',2.73),('12664','2013-12-14','11:55:00',2.75),('12664','2013-12-14','12:00:00',2.77),('12664','2013-12-14','12:05:00',2.82),('12664','2013-12-14','12:10:00',2.81),('12664','2013-12-14','12:15:00',2.78),('12664','2013-12-14','12:20:00',2.78),('12664','2013-12-14','12:25:00',2.77),('12664','2013-12-14','12:30:00',2.76),('12664','2013-12-14','12:35:00',2.73),('12664','2013-12-14','12:40:00',2.68),('12664','2013-12-14','12:45:00',2.63),('12664','2013-12-14','12:50:00',2.63),('12664','2013-12-14','12:55:00',2.56),('12664','2013-12-14','13:00:00',2.51),('12664','2013-12-14','13:05:00',2.48),('12664','2013-12-14','13:10:00',2.52),('12664','2013-12-14','13:15:00',2.46),('12664','2013-12-14','13:20:00',2.39),('12664','2013-12-14','13:25:00',2.37),('12664','2013-12-14','13:30:00',2.37),('12664','2013-12-14','13:35:00',2.34),('12664','2013-12-14','13:40:00',2.33),('12664','2013-12-14','13:45:00',2.26),('12664','2013-12-14','13:50:00',2.19),('12664','2013-12-14','13:55:00',2.18),('12664','2013-12-14','14:00:00',2.11),('12664','2013-12-14','14:05:00',2.1),('12664','2013-12-14','14:10:00',2.05),('12664','2013-12-14','14:15:00',1.99),('12664','2013-12-14','14:20:00',1.91),('12664','2013-12-14','14:25:00',1.83),('12664','2013-12-14','14:30:00',1.74),('12664','2013-12-14','14:35:00',1.66),('12664','2013-12-14','14:40:00',1.58),('12664','2013-12-14','14:45:00',1.51),('12664','2013-12-14','14:50:00',1.46),('12664','2013-12-14','14:55:00',1.4),('12664','2013-12-14','15:00:00',1.32),('12664','2013-12-14','15:05:00',1.24),('12664','2013-12-14','15:10:00',1.11),('12664','2013-12-14','15:15:00',1.05),('12664','2013-12-13','08:50:00',1.05),('12664','2013-12-13','08:55:00',1.13),('12664','2013-12-13','09:00:00',1.22),('12664','2013-12-13','09:05:00',1.31),('12664','2013-12-13','09:10:00',1.38),('12664','2013-12-13','09:15:00',1.44),('12664','2013-12-13','09:20:00',1.53),('12664','2013-12-13','09:25:00',1.61),('12664','2013-12-13','09:30:00',1.68),('12664','2013-12-13','09:35:00',1.76),('12664','2013-12-13','09:40:00',1.84),('12664','2013-12-13','09:45:00',1.92),('12664','2013-12-13','09:50:00',1.99),('12664','2013-12-13','09:55:00',2.05),('12664','2013-12-13','10:00:00',2.09),('12664','2013-12-13','10:05:00',2.14),('12664','2013-12-13','10:10:00',2.18),('12664','2013-12-13','10:15:00',2.21),('12664','2013-12-13','10:20:00',2.26),('12664','2013-12-13','10:25:00',2.3),('12664','2013-12-13','10:30:00',2.35),('12664','2013-12-13','10:35:00',2.4),('12664','2013-12-13','10:40:00',2.42),('12664','2013-12-13','10:45:00',2.48),('12664','2013-12-13','10:50:00',2.46),('12664','2013-12-13','10:55:00',2.45),('12664','2013-12-13','11:00:00',2.47),('12664','2013-12-13','11:05:00',2.49),('12664','2013-12-13','11:10:00',2.55),('12664','2013-12-13','11:15:00',2.62),('12664','2013-12-13','11:20:00',2.62),('12664','2013-12-13','11:25:00',2.65),('12664','2013-12-13','11:30:00',2.67),('12664','2013-12-13','11:35:00',2.68),('12664','2013-12-13','11:40:00',2.66),('12664','2013-12-13','11:45:00',2.59),('12664','2013-12-13','11:50:00',2.63),('12664','2013-12-13','11:55:00',2.61),('12664','2013-12-13','12:00:00',2.6),('12664','2013-12-13','12:05:00',2.63),('12664','2013-12-13','12:10:00',2.61),('12664','2013-12-13','12:15:00',2.62),('12664','2013-12-13','12:20:00',2.64),('12664','2013-12-13','12:25:00',2.6),('12664','2013-12-13','12:30:00',2.61),('12664','2013-12-13','12:35:00',2.62),('12664','2013-12-13','12:40:00',2.6),('12664','2013-12-13','12:45:00',2.63),('12664','2013-12-13','12:50:00',2.62),('12664','2013-12-13','12:55:00',2.55),('12664','2013-12-13','13:00:00',2.52),('12664','2013-12-13','13:05:00',2.46),('12664','2013-12-13','13:10:00',2.43),('12664','2013-12-13','13:15:00',2.45),('12664','2013-12-13','13:20:00',2.43),('12664','2013-12-13','13:25:00',2.47),('12664','2013-12-13','13:30:00',2.41),('12664','2013-12-13','13:35:00',2.28),('12664','2013-12-13','13:40:00',2.27),('12664','2013-12-13','13:45:00',2.24),('12664','2013-12-13','13:50:00',2.22),('12664','2013-12-13','13:55:00',2.19),('12664','2013-12-13','14:00:00',2.14),('12664','2013-12-13','14:05:00',2.06),('12664','2013-12-13','14:10:00',2),('12664','2013-12-13','14:15:00',1.95),('12664','2013-12-13','14:20:00',1.94),('12664','2013-12-13','14:25:00',1.87),('12664','2013-12-13','14:30:00',1.76),('12664','2013-12-13','14:35:00',1.67),('12664','2013-12-13','14:40:00',1.62),('12664','2013-12-13','14:45:00',1.55),('12664','2013-12-13','14:50:00',1.48),('12664','2013-12-13','14:55:00',1.41),('12664','2013-12-13','15:00:00',1.33),('12664','2013-12-13','15:05:00',1.28),('12664','2013-12-13','15:10:00',1.18),('12664','2013-12-13','15:15:00',1.08),('12664','2013-12-13','15:20:00',1),('12664','2013-12-12','08:40:00',1.01),('12664','2013-12-12','08:45:00',1.12),('12664','2013-12-12','08:50:00',1.21),('12664','2013-12-12','08:55:00',1.29),('12664','2013-12-12','09:00:00',1.38),('12664','2013-12-12','09:05:00',1.46),('12664','2013-12-12','09:10:00',1.53),('12664','2013-12-12','09:15:00',1.61),('12664','2013-12-12','09:20:00',1.69),('12664','2013-12-12','09:25:00',1.76),('12664','2013-12-12','09:30:00',1.84),('12664','2013-12-12','09:35:00',1.89),('12664','2013-12-12','09:40:00',1.95),('12664','2013-12-12','09:45:00',2.02),('12664','2013-12-12','09:50:00',2.08),('12664','2013-12-12','09:55:00',2.13),('12664','2013-12-12','10:00:00',2.16),('12664','2013-12-12','10:05:00',2.22),('12664','2013-12-12','10:10:00',2.28),('12664','2013-12-12','10:15:00',2.33),('12664','2013-12-12','10:20:00',2.38),('12664','2013-12-12','10:25:00',2.42),('12664','2013-12-12','10:30:00',2.45),('12664','2013-12-12','10:35:00',2.49),('12664','2013-12-12','10:40:00',2.52),('12664','2013-12-12','10:45:00',2.55),('12664','2013-12-12','10:50:00',2.58),('12664','2013-12-12','10:55:00',2.6),('12664','2013-12-12','11:00:00',2.63),('12664','2013-12-12','11:05:00',2.67),('12664','2013-12-12','11:10:00',2.69),('12664','2013-12-12','11:15:00',2.71),('12664','2013-12-12','11:20:00',2.72),('12664','2013-12-12','11:25:00',2.76),('12664','2013-12-12','11:30:00',2.77),('12664','2013-12-12','11:35:00',2.8),('12664','2013-12-12','11:40:00',2.79),('12664','2013-12-12','11:45:00',2.78),('12664','2013-12-12','11:50:00',2.79),('12664','2013-12-12','11:55:00',2.78),('12664','2013-12-12','12:00:00',2.77),('12664','2013-12-12','12:05:00',2.79),('12664','2013-12-12','12:10:00',2.8),('12664','2013-12-12','12:15:00',2.78),('12664','2013-12-12','12:20:00',2.76),('12664','2013-12-12','12:25:00',2.76),('12664','2013-12-12','12:30:00',2.75),('12664','2013-12-12','12:35:00',2.73),('12664','2013-12-12','12:40:00',2.72),('12664','2013-12-12','12:45:00',2.71),('12664','2013-12-12','12:50:00',2.69),('12664','2013-12-12','12:55:00',2.67),('12664','2013-12-12','13:00:00',2.63),('12664','2013-12-12','13:05:00',2.6),('12664','2013-12-12','13:10:00',2.58),('12664','2013-12-12','13:15:00',2.54),('12664','2013-12-12','13:20:00',2.48),('12664','2013-12-12','13:25:00',2.49),('12664','2013-12-12','13:30:00',2.45),('12664','2013-12-12','13:35:00',2.37),('12664','2013-12-12','13:40:00',2.31),('12664','2013-12-12','13:45:00',2.27),('12664','2013-12-12','13:50:00',2.21),('12664','2013-12-12','13:55:00',2.16),('12664','2013-12-12','14:00:00',2.13),('12664','2013-12-12','14:05:00',2.09),('12664','2013-12-12','14:10:00',2.01),('12664','2013-12-12','14:15:00',1.93),('12664','2013-12-12','14:20:00',1.87),('12664','2013-12-12','14:25:00',1.81),('12664','2013-12-12','14:30:00',1.74),('12664','2013-12-12','14:35:00',1.67),('12664','2013-12-12','14:40:00',1.59),('12664','2013-12-12','14:45:00',1.49),('12664','2013-12-12','14:50:00',1.4),('12664','2013-12-12','14:55:00',1.32),('12664','2013-12-12','15:00:00',1.25),('12664','2013-12-12','15:05:00',1.18),('12664','2013-12-12','15:10:00',1.09),('12664','2013-12-12','15:15:00',1),('12664','2013-12-11','08:35:00',1.08),('12664','2013-12-11','08:40:00',1.17),('12664','2013-12-11','08:45:00',1.26),('12664','2013-12-11','08:50:00',1.35),('12664','2013-12-11','08:55:00',1.42),('12664','2013-12-11','09:00:00',1.5),('12664','2013-12-11','09:05:00',1.58),('12664','2013-12-11','09:10:00',1.67),('12664','2013-12-11','09:15:00',1.75),('12664','2013-12-11','09:20:00',1.82),('12664','2013-12-11','09:25:00',1.89),('12664','2013-12-11','09:30:00',1.98),('12664','2013-12-11','09:35:00',2.04),('12664','2013-12-11','09:40:00',2.09),('12664','2013-12-11','09:45:00',2.15),('12664','2013-12-11','09:50:00',2.2),('12664','2013-12-11','09:55:00',2.24),('12664','2013-12-11','10:00:00',2.3),('12664','2013-12-11','10:05:00',2.36),('12664','2013-12-11','10:10:00',2.41),('12664','2013-12-11','10:15:00',2.46),('12664','2013-12-11','10:20:00',2.53),('12664','2013-12-11','10:25:00',2.58),('12664','2013-12-11','10:30:00',2.64),('12664','2013-12-11','10:35:00',2.68),('12664','2013-12-11','10:40:00',2.7),('12664','2013-12-11','10:45:00',2.68),('12664','2013-12-11','10:50:00',2.71),('12664','2013-12-11','10:55:00',2.75),('12664','2013-12-11','11:00:00',2.8),('12664','2013-12-11','11:05:00',2.82),('12664','2013-12-11','11:10:00',2.84),('12664','2013-12-11','11:15:00',2.84),('12664','2013-12-11','11:20:00',2.82),('12664','2013-12-11','11:25:00',2.83),('12664','2013-12-11','11:30:00',2.83),('12664','2013-12-11','11:35:00',2.88),('12664','2013-12-11','11:40:00',2.88),('12664','2013-12-11','11:45:00',2.9),('12664','2013-12-11','11:50:00',2.91),('12664','2013-12-11','11:55:00',2.92),('12664','2013-12-11','12:00:00',2.9),('12664','2013-12-11','12:05:00',2.91),('12664','2013-12-11','12:10:00',2.9),('12664','2013-12-11','12:15:00',2.86),('12664','2013-12-11','12:20:00',2.84),('12664','2013-12-11','12:25:00',2.82),('12664','2013-12-11','12:30:00',2.83),('12664','2013-12-11','12:35:00',2.78),('12664','2013-12-11','12:40:00',2.75),('12664','2013-12-11','12:45:00',2.78),('12664','2013-12-11','12:50:00',2.79),('12664','2013-12-11','12:55:00',2.8),('12664','2013-12-11','13:00:00',2.78),('12664','2013-12-11','13:05:00',2.73),('12664','2013-12-11','13:10:00',2.71),('12664','2013-12-11','13:15:00',2.65),('12664','2013-12-11','13:20:00',2.63),('12664','2013-12-11','13:25:00',2.6),('12664','2013-12-11','13:30:00',2.55),('12664','2013-12-11','13:35:00',2.5),('12664','2013-12-11','13:40:00',2.41),('12664','2013-12-11','13:45:00',2.34),('12664','2013-12-11','13:50:00',2.32),('12664','2013-12-11','13:55:00',2.27),('12664','2013-12-11','14:00:00',2.22),('12664','2013-12-11','14:05:00',2.18),('12664','2013-12-11','14:10:00',2.13),('12664','2013-12-11','14:15:00',2.08),('12664','2013-12-11','14:20:00',2.01),('12664','2013-12-11','14:25:00',1.92),('12664','2013-12-11','14:30:00',1.86),('12664','2013-12-11','14:35:00',1.8),('12664','2013-12-11','14:40:00',1.7),('12664','2013-12-11','14:45:00',1.62),('12664','2013-12-11','14:50:00',1.54),('12664','2013-12-11','14:55:00',1.45),('12664','2013-12-11','15:00:00',1.36),('12664','2013-12-11','15:05:00',1.28),('12664','2013-12-11','15:10:00',1.19),('12664','2013-12-11','15:15:00',1.09),('12664','2013-12-11','15:20:00',1.02),('12664','2013-12-10','08:35:00',1.08),('12664','2013-12-10','08:40:00',1.18),('12664','2013-12-10','08:45:00',1.27),('12664','2013-12-10','08:50:00',1.36),('12664','2013-12-10','08:55:00',1.45),('12664','2013-12-10','09:00:00',1.53),('12664','2013-12-10','09:05:00',1.63),('12664','2013-12-10','09:10:00',1.7),('12664','2013-12-10','09:15:00',1.79),('12664','2013-12-10','09:20:00',1.87),('12664','2013-12-10','09:25:00',1.94),('12664','2013-12-10','09:30:00',2),('12664','2013-12-10','09:35:00',2.06),('12664','2013-12-10','09:40:00',2.14),('12664','2013-12-10','09:45:00',2.22),('12664','2013-12-10','09:50:00',2.29),('12664','2013-12-10','09:55:00',2.34),('12664','2013-12-10','10:00:00',2.39),('12664','2013-12-10','10:05:00',2.44),('12664','2013-12-10','10:10:00',2.48),('12664','2013-12-10','10:15:00',2.51),('12664','2013-12-10','10:20:00',2.53),('12664','2013-12-10','10:25:00',2.58),('12664','2013-12-10','10:30:00',2.61),('12664','2013-12-10','10:35:00',2.66),('12664','2013-12-10','10:40:00',2.68),('12664','2013-12-10','10:45:00',2.71),('12664','2013-12-10','10:50:00',2.75),('12664','2013-12-10','10:55:00',2.78),('12664','2013-12-10','11:00:00',2.82),('12664','2013-12-10','11:05:00',2.84),('12664','2013-12-10','11:10:00',2.86),('12664','2013-12-10','11:15:00',2.87),('12664','2013-12-10','11:20:00',2.89),('12664','2013-12-10','11:25:00',2.9),('12664','2013-12-10','11:30:00',2.89),('12664','2013-12-10','11:35:00',2.9),('12664','2013-12-10','11:40:00',2.9),('12664','2013-12-10','11:45:00',2.9),('12664','2013-12-10','11:50:00',2.91),('12664','2013-12-10','11:55:00',2.92),('12664','2013-12-10','12:00:00',2.91),('12664','2013-12-10','12:05:00',2.88),('12664','2013-12-10','12:10:00',2.89),('12664','2013-12-10','12:15:00',2.93),('12664','2013-12-10','12:20:00',2.93),('12664','2013-12-10','12:25:00',2.91),('12664','2013-12-10','12:30:00',2.91),('12664','2013-12-10','12:35:00',2.9),('12664','2013-12-10','12:40:00',2.89),('12664','2013-12-10','12:45:00',2.88),('12664','2013-12-10','12:50:00',2.84),('12664','2013-12-10','12:55:00',2.82),('12664','2013-12-10','13:00:00',2.76),('12664','2013-12-10','13:05:00',2.76),('12664','2013-12-10','13:10:00',2.73),('12664','2013-12-10','13:15:00',2.69),('12664','2013-12-10','13:20:00',2.64),('12664','2013-12-10','13:25:00',2.59),('12664','2013-12-10','13:30:00',2.53),('12664','2013-12-10','13:35:00',2.49),('12664','2013-12-10','13:40:00',2.43),('12664','2013-12-10','13:45:00',2.39),('12664','2013-12-10','13:50:00',2.33),('12664','2013-12-10','13:55:00',2.29),('12664','2013-12-10','14:00:00',2.24),('12664','2013-12-10','14:05:00',2.18),('12664','2013-12-10','14:10:00',2.1),('12664','2013-12-10','14:15:00',2.06),('12664','2013-12-10','14:20:00',2),('12664','2013-12-10','14:25:00',1.94),('12664','2013-12-10','14:30:00',1.85),('12664','2013-12-10','14:35:00',1.78),('12664','2013-12-10','14:40:00',1.6),('12664','2013-12-10','14:45:00',1.53),('12664','2013-12-10','14:50:00',1.52),('12664','2013-12-10','14:55:00',1.4),('12664','2013-12-10','15:00:00',1.35),('12664','2013-12-10','15:05:00',1.3),('12664','2013-12-10','15:10:00',1.17),('12664','2013-12-10','15:15:00',1.09),('12664','2013-12-10','15:20:00',1.06),('12664','2013-12-09','09:15:00',1.65),('12664','2013-12-09','09:20:00',1.77),('12664','2013-12-09','09:25:00',1.87),('12664','2013-12-09','09:30:00',1.92),('12664','2013-12-09','09:35:00',2.1),('12664','2013-12-09','09:40:00',2.3),('12664','2013-12-09','09:45:00',2.54),('12664','2013-12-09','09:50:00',2.44),('12664','2013-12-09','09:55:00',2.59),('12664','2013-12-09','10:00:00',1.22),('12664','2013-12-09','12:25:00',1.81),('12664','2013-12-09','12:35:00',1.21),('12664','2013-12-09','12:40:00',1.75),('12664','2013-12-09','12:45:00',2.95),('12664','2013-12-09','12:50:00',2.71),('12664','2013-12-09','12:55:00',2.07),('12664','2013-12-09','13:00:00',2.62),('12664','2013-12-09','13:05:00',2.35),('12664','2013-12-09','13:10:00',2.29),('12664','2013-12-09','13:15:00',2.55),('12664','2013-12-09','13:20:00',3.25),('12664','2013-12-09','13:25:00',2.25),('12664','2013-12-09','13:30:00',1.47),('12664','2013-12-09','13:35:00',1.76),('12664','2013-12-09','13:40:00',1.49),('12664','2013-12-09','13:45:00',1.22),('12664','2013-12-08','09:10:00',1.22),('12664','2013-12-08','12:20:00',1.3),('12664','2013-12-08','12:25:00',1.01),('12664','2013-12-08','12:35:00',1.06),('12664','2013-12-08','12:40:00',1.13),('12664','2013-12-08','12:45:00',1.29),('12664','2013-12-08','12:50:00',1.1),('12664','2013-12-08','14:50:00',1.08),('12664','2013-12-08','14:55:00',1.56),('12664','2013-12-08','15:00:00',1.33),('12664','2013-12-08','15:05:00',1.23),('12664','2013-12-08','15:10:00',1.16),('12664','2013-12-08','15:15:00',1.06),('12664','2013-12-07','08:30:00',1.05),('12664','2013-12-07','08:35:00',1.14),('12664','2013-12-07','08:40:00',1.22),('12664','2013-12-07','08:45:00',1.3),('12664','2013-12-07','08:50:00',1.38),('12664','2013-12-07','08:55:00',1.47),('12664','2013-12-07','09:00:00',1.55),('12664','2013-12-07','09:05:00',1.63),('12664','2013-12-07','09:10:00',1.71),('12664','2013-12-07','09:15:00',1.79),('12664','2013-12-07','09:20:00',1.87),('12664','2013-12-07','09:25:00',1.95),('12664','2013-12-07','09:30:00',2.03),('12664','2013-12-07','09:35:00',2.1),('12664','2013-12-07','09:40:00',2.16),('12664','2013-12-07','09:45:00',2.22),('12664','2013-12-07','09:50:00',2.28),('12664','2013-12-07','09:55:00',2.34),('12664','2013-12-07','10:00:00',2.38),('12664','2013-12-07','10:05:00',2.43),('12664','2013-12-07','10:10:00',2.48),('12664','2013-12-07','10:15:00',2.51),('12664','2013-12-07','10:20:00',2.55),('12664','2013-12-07','10:25:00',2.59),('12664','2013-12-07','10:30:00',2.63),('12664','2013-12-07','10:35:00',2.66),('12664','2013-12-07','10:40:00',2.69),('12664','2013-12-07','10:45:00',2.72),('12664','2013-12-07','10:50:00',2.74),('12664','2013-12-07','10:55:00',2.75),('12664','2013-12-07','11:00:00',2.74),('12664','2013-12-07','11:05:00',2.75),('12664','2013-12-07','11:10:00',2.76),('12664','2013-12-07','11:15:00',2.8),('12664','2013-12-07','11:20:00',2.8),('12664','2013-12-07','11:25:00',2.79),('12664','2013-12-07','11:30:00',2.81),('12664','2013-12-07','11:35:00',2.82),('12664','2013-12-07','11:40:00',2.83),('12664','2013-12-07','11:45:00',2.85),('12664','2013-12-07','11:50:00',2.84),('12664','2013-12-07','11:55:00',2.83),('12664','2013-12-07','12:00:00',2.83),('12664','2013-12-07','12:05:00',2.81),('12664','2013-12-07','12:10:00',2.78),('12664','2013-12-07','12:15:00',2.75),('12664','2013-12-07','12:20:00',2.72),('12664','2013-12-07','12:25:00',2.71),('12664','2013-12-07','12:30:00',2.67),('12664','2013-12-07','12:35:00',2.69),('12664','2013-12-07','12:40:00',2.64),('12664','2013-12-07','12:45:00',2.62),('12664','2013-12-07','12:50:00',2.59),('12664','2013-12-07','12:55:00',2.56),('12664','2013-12-07','13:00:00',2.57),('12664','2013-12-07','13:05:00',2.52),('12664','2013-12-07','13:10:00',2.52),('12664','2013-12-07','13:15:00',2.53),('12664','2013-12-07','13:20:00',2.5),('12664','2013-12-07','13:25:00',2.46),('12664','2013-12-07','13:30:00',2.41),('12664','2013-12-07','13:35:00',2.36),('12664','2013-12-07','13:40:00',2.29),('12664','2013-12-07','13:45:00',2.21),('12664','2013-12-07','13:50:00',2.14),('12664','2013-12-07','13:55:00',2.08),('12664','2013-12-07','14:00:00',2.03),('12664','2013-12-07','14:05:00',2.01),('12664','2013-12-07','14:10:00',1.92),('12664','2013-12-07','14:15:00',1.88),('12664','2013-12-07','14:20:00',1.82),('12664','2013-12-07','14:25:00',1.77),('12664','2013-12-07','14:30:00',1.74),('12664','2013-12-07','14:35:00',1.69),('12664','2013-12-07','14:40:00',1.61),('12664','2013-12-07','14:45:00',1.53),('12664','2013-12-07','14:50:00',1.44),('12664','2013-12-07','14:55:00',1.36),('12664','2013-12-07','15:00:00',1.3),('12664','2013-12-07','15:05:00',1.21),('12664','2013-12-07','15:10:00',1.13),('12664','2013-12-07','15:15:00',1.06),('12664','2014-04-20','08:00:00',1.03),('12664','2014-04-20','08:05:00',1.29),('12664','2014-04-20','08:10:00',1.58),('12664','2014-04-20','08:15:00',1.83),('12664','2014-04-20','08:20:00',2.37),('12664','2014-04-20','08:25:00',1.12),('12664','2014-04-20','08:40:00',1.32),('12664','2014-04-20','08:45:00',1.87),('12664','2014-04-20','08:50:00',1.92),('12664','2014-04-20','08:55:00',2.06),('12664','2014-04-20','09:00:00',2.14),('12664','2014-04-20','09:05:00',2.24),('12664','2014-04-20','09:10:00',2.35),('12664','2014-04-20','09:15:00',2.48),('12664','2014-04-20','09:20:00',2.3),('12664','2014-04-20','09:25:00',2.1),('12664','2014-04-20','09:30:00',2.63),('12664','2014-04-20','09:35:00',3.07),('12664','2014-04-20','09:40:00',3.19),('12664','2014-04-20','09:45:00',2.91),('12664','2014-04-20','09:50:00',2.08),('12664','2014-04-20','09:55:00',1.39),('12664','2014-04-20','10:00:00',2.39),('12664','2014-04-20','10:05:00',2.16),('12664','2014-04-20','10:10:00',2.55),('12664','2014-04-20','10:15:00',2.63),('12664','2014-04-20','10:20:00',2.41),('12664','2014-04-20','10:25:00',2.92),('12664','2014-04-20','10:30:00',2.18),('12664','2014-04-20','10:35:00',2.08),('12664','2014-04-20','10:40:00',2.12),('12664','2014-04-20','10:45:00',2.7),('12664','2014-04-20','10:50:00',3.59),('12664','2014-04-20','10:55:00',3.86),('12664','2014-04-20','11:00:00',3.59),('12664','2014-04-20','11:05:00',3.23),('12664','2014-04-20','11:10:00',3.48),('12664','2014-04-20','11:15:00',3.94),('12664','2014-04-20','11:20:00',3.86),('12664','2014-04-20','11:25:00',4.05),('12664','2014-04-20','11:30:00',3.98),('12664','2014-04-20','11:35:00',4.07),('12664','2014-04-20','11:40:00',4.09),('12664','2014-04-20','11:45:00',4.07),('12664','2014-04-20','11:50:00',4.04),('12664','2014-04-20','11:55:00',4.08),('12664','2014-04-20','12:00:00',4.12),('12664','2014-04-20','12:05:00',4.1),('12664','2014-04-20','12:10:00',4.12),('12664','2014-04-20','12:15:00',4.12),('12664','2014-04-20','12:20:00',4.16),('12664','2014-04-20','12:25:00',4.17),('12664','2014-04-20','12:30:00',4.17),('12664','2014-04-20','12:35:00',4.2),('12664','2014-04-20','12:40:00',4.2),('12664','2014-04-20','12:45:00',4.14),('12664','2014-04-20','12:50:00',4.18),('12664','2014-04-20','12:55:00',4.2),('12664','2014-04-20','13:00:00',4.19),('12664','2014-04-20','13:05:00',4.23),('12664','2014-04-20','13:10:00',4.27),('12664','2014-04-20','13:15:00',3.93),('12664','2014-04-20','13:20:00',4.21),('12664','2014-04-20','13:25:00',4.16),('12664','2014-04-20','13:30:00',4.15),('12664','2014-04-20','13:35:00',4.15),('12664','2014-04-20','13:40:00',4.12),('12664','2014-04-20','13:45:00',4.17),('12664','2014-04-20','13:50:00',3.71),('12664','2014-04-20','13:55:00',4.11),('12664','2014-04-20','14:00:00',4.09),('12664','2014-04-20','14:05:00',3.81),('12664','2014-04-20','14:10:00',3.6),('12664','2014-04-20','14:15:00',3.86),('12664','2014-04-20','14:20:00',2.68),('12664','2014-04-20','14:25:00',2.46),('12664','2014-04-20','14:30:00',2.26),('12664','2014-04-20','14:35:00',2.13),('12664','2014-04-20','14:40:00',2.05),('12664','2014-04-20','14:45:00',2.2),('12664','2014-04-20','14:50:00',2.59),('12664','2014-04-20','14:55:00',2.65),('12664','2014-04-20','15:00:00',3.91),('12664','2014-04-20','15:05:00',4),('12664','2014-04-20','15:10:00',3.44),('12664','2014-04-20','15:15:00',3.68),('12664','2014-04-20','15:20:00',3.6),('12664','2014-04-20','15:25:00',3.52),('12664','2014-04-20','15:30:00',3.43),('12664','2014-04-20','15:35:00',3.51),('12664','2014-04-20','15:40:00',3.53),('12664','2014-04-20','15:45:00',2.38),('12664','2014-04-20','15:50:00',3.41),('12664','2014-04-20','15:55:00',3.21),('12664','2014-04-20','16:00:00',3.12),('12664','2014-04-20','16:05:00',3.07),('12664','2014-04-20','16:10:00',2.99),('12664','2014-04-20','16:15:00',2.99),('12664','2014-04-20','16:20:00',2.94),('12664','2014-04-20','16:25:00',2.9),('12664','2014-04-20','16:30:00',2.71),('12664','2014-04-20','16:35:00',2.82),('12664','2014-04-20','16:40:00',2.27),('12664','2014-04-20','16:45:00',1.98),('12664','2014-04-20','16:50:00',2.59),('12664','2014-04-20','16:55:00',2.38),('12664','2014-04-20','17:00:00',2.25),('12664','2014-04-20','17:05:00',2.14),('12664','2014-04-20','17:10:00',2.05),('12664','2014-04-20','17:15:00',1.95),('12664','2014-04-20','17:20:00',1.85),('12664','2014-04-20','17:25:00',1.76),('12664','2014-04-20','17:30:00',1.67),('12664','2014-04-20','17:35:00',1.58),('12664','2014-04-20','17:40:00',1.47),('12664','2014-04-20','17:45:00',1.38),('12664','2014-04-20','17:50:00',1.29),('12664','2014-04-20','17:55:00',1.19),('12664','2014-04-20','18:00:00',1.1),('12664','2014-04-20','18:05:00',1.01),('12664','2013-12-06','10:10:00',1.04),('12664','2013-12-06','10:15:00',1.1),('12664','2013-12-06','11:00:00',1.03),('12664','2013-12-06','11:10:00',1.25),('12664','2013-12-06','11:15:00',1.25),('12664','2013-12-06','11:20:00',2.19),('12664','2013-12-06','11:25:00',1.96),('12664','2013-12-06','11:30:00',2.35),('12664','2013-12-06','11:35:00',2.65),('12664','2013-12-06','11:40:00',2.81),('12664','2013-12-06','11:45:00',2.34),('12664','2013-12-06','11:50:00',1.9),('12664','2013-12-06','11:55:00',2.53),('12664','2013-12-06','12:00:00',2.78),('12664','2013-12-06','12:05:00',2.26),('12664','2013-12-06','12:10:00',2.15),('12664','2013-12-06','12:15:00',2.27),('12664','2013-12-06','12:20:00',1.3),('12664','2013-12-06','12:25:00',1.2),('12664','2013-12-06','12:30:00',1.22),('12664','2013-12-06','12:35:00',1.13),('12664','2013-12-06','12:40:00',1.05),('12664','2013-12-06','14:55:00',1.6),('12664','2013-12-06','15:00:00',1.51),('12664','2013-12-06','15:05:00',1.4),('12664','2013-12-06','15:10:00',1.42),('12664','2013-12-06','15:15:00',1.25),('12664','2013-12-05','08:30:00',1.05),('12664','2013-12-05','08:35:00',1.14),('12664','2013-12-05','08:40:00',1.24),('12664','2013-12-05','08:45:00',1.32),('12664','2013-12-05','08:50:00',1.4),('12664','2013-12-05','08:55:00',1.48),('12664','2013-12-05','09:00:00',1.57),('12664','2013-12-05','09:05:00',1.67),('12664','2013-12-05','09:10:00',1.76),('12664','2013-12-05','09:15:00',1.82),('12664','2013-12-05','09:20:00',1.89),('12664','2013-12-05','09:25:00',1.97),('12664','2013-12-05','09:30:00',2.04),('12664','2013-12-05','09:35:00',2.11),('12664','2013-12-05','09:40:00',2.19),('12664','2013-12-05','09:45:00',2.25),('12664','2013-12-05','09:50:00',2.3),('12664','2013-12-05','09:55:00',2.34),('12664','2013-12-05','10:00:00',2.39),('12664','2013-12-05','10:05:00',2.43),('12664','2013-12-05','10:10:00',2.49),('12664','2013-12-05','10:15:00',2.54),('12664','2013-12-05','10:20:00',2.59),('12664','2013-12-05','10:25:00',2.63),('12664','2013-12-05','10:30:00',2.66),('12664','2013-12-05','10:35:00',2.69),('12664','2013-12-05','10:40:00',2.73),('12664','2013-12-05','10:45:00',2.75),('12664','2013-12-05','10:50:00',2.75),('12664','2013-12-05','10:55:00',2.8),('12664','2013-12-05','11:00:00',2.8),('12664','2013-12-05','11:05:00',2.81),('12664','2013-12-05','11:10:00',2.82),('12664','2013-12-05','11:15:00',2.83),('12664','2013-12-05','11:20:00',2.89),('12664','2013-12-05','11:25:00',2.88),('12664','2013-12-05','11:30:00',2.86),('12664','2013-12-05','11:35:00',2.88),('12664','2013-12-05','11:40:00',2.88),('12664','2013-12-05','11:45:00',2.89),('12664','2013-12-05','11:50:00',2.92),('12664','2013-12-05','11:55:00',2.89),('12664','2013-12-05','12:00:00',2.9),('12664','2013-12-05','12:05:00',2.9),('12664','2013-12-05','12:10:00',2.94),('12664','2013-12-05','12:15:00',2.91),('12664','2013-12-05','12:20:00',2.87),('12664','2013-12-05','12:25:00',2.87),('12664','2013-12-05','12:30:00',2.9),('12664','2013-12-05','12:35:00',2.88),('12664','2013-12-05','12:40:00',2.85),('12664','2013-12-05','12:45:00',2.83),('12664','2013-12-05','12:50:00',2.84),('12664','2013-12-05','12:55:00',2.82),('12664','2013-12-05','13:00:00',2.79),('12664','2013-12-05','13:05:00',2.74),('12664','2013-12-05','13:10:00',2.62),('12664','2013-12-05','13:15:00',2.64),('12664','2013-12-05','13:20:00',2.54),('12664','2013-12-05','13:25:00',2.53),('12664','2013-12-05','13:30:00',2.55),('12664','2013-12-05','13:35:00',2.48),('12664','2013-12-05','13:40:00',2.47),('12664','2013-12-05','13:45:00',2.43),('12664','2013-12-05','13:50:00',2.45),('12664','2013-12-05','13:55:00',2.31),('12664','2013-12-05','14:00:00',2.27),('12664','2013-12-05','14:05:00',2.14),('12664','2013-12-05','14:10:00',2.06),('12664','2013-12-05','14:15:00',2.08),('12664','2013-12-05','14:20:00',1.96),('12664','2013-12-05','14:25:00',1.92),('12664','2013-12-05','14:30:00',1.8),('12664','2013-12-05','14:35:00',1.73),('12664','2013-12-05','14:40:00',1.67),('12664','2013-12-05','14:45:00',1.6),('12664','2013-12-05','14:50:00',1.54),('12664','2013-12-05','14:55:00',1.45),('12664','2013-12-05','15:00:00',1.35),('12664','2013-12-05','15:05:00',1.16),('12664','2013-12-05','15:10:00',1.13),('12664','2013-12-05','15:15:00',1.08),('12664','2013-12-04','08:20:00',1.07),('12664','2013-12-04','08:25:00',1.17),('12664','2013-12-04','08:30:00',1.27),('12664','2013-12-04','08:35:00',1.36),('12664','2013-12-04','08:40:00',1.47),('12664','2013-12-04','08:45:00',1.56),('12664','2013-12-04','08:50:00',1.65),('12664','2013-12-04','08:55:00',1.74),('12664','2013-12-04','09:00:00',1.82),('12664','2013-12-04','09:05:00',1.91),('12664','2013-12-04','09:10:00',1.98),('12664','2013-12-04','09:15:00',2.06),('12664','2013-12-04','09:20:00',2.13),('12664','2013-12-04','09:25:00',2.19),('12664','2013-12-04','09:30:00',2.26),('12664','2013-12-04','09:35:00',2.33),('12664','2013-12-04','09:40:00',2.39),('12664','2013-12-04','09:45:00',2.45),('12664','2013-12-04','09:50:00',2.5),('12664','2013-12-04','09:55:00',2.56),('12664','2013-12-04','10:00:00',2.61),('12664','2013-12-04','10:05:00',2.66),('12664','2013-12-04','10:10:00',2.71),('12664','2013-12-04','10:15:00',2.76),('12664','2013-12-04','10:20:00',2.81),('12664','2013-12-04','10:25:00',2.85),('12664','2013-12-04','10:30:00',2.86),('12664','2013-12-04','10:35:00',2.9),('12664','2013-12-04','10:40:00',2.93),('12664','2013-12-04','10:45:00',2.97),('12664','2013-12-04','10:50:00',2.98),('12664','2013-12-04','10:55:00',3.02),('12664','2013-12-04','11:00:00',3.05),('12664','2013-12-04','11:05:00',3.07),('12664','2013-12-04','11:10:00',3.09),('12664','2013-12-04','11:15:00',3.09),('12664','2013-12-04','11:20:00',3.09),('12664','2013-12-04','11:25:00',3.09),('12664','2013-12-04','11:30:00',3.11),('12664','2013-12-04','11:35:00',3.13),('12664','2013-12-04','11:40:00',3.14),('12664','2013-12-04','11:45:00',3.15),('12664','2013-12-04','11:50:00',3.16),('12664','2013-12-04','11:55:00',3.16),('12664','2013-12-04','12:00:00',3.17),('12664','2013-12-04','12:05:00',3.16),('12664','2013-12-04','12:10:00',3.14),('12664','2013-12-04','12:15:00',3.12),('12664','2013-12-04','12:20:00',3.1),('12664','2013-12-04','12:25:00',3.08),('12664','2013-12-04','12:30:00',3.07),('12664','2013-12-04','12:35:00',3.03),('12664','2013-12-04','12:40:00',3.03),('12664','2013-12-04','12:45:00',3.02),('12664','2013-12-04','12:50:00',2.96),('12664','2013-12-04','12:55:00',2.95),('12664','2013-12-04','13:00:00',2.92),('12664','2013-12-04','13:05:00',2.89),('12664','2013-12-04','13:10:00',2.86),('12664','2013-12-04','13:15:00',2.83),('12664','2013-12-04','13:20:00',2.78),('12664','2013-12-04','13:25:00',2.74),('12664','2013-12-04','13:30:00',2.69),('12664','2013-12-04','13:35:00',2.66),('12664','2013-12-04','13:40:00',2.63),('12664','2013-12-04','13:45:00',2.58),('12664','2013-12-04','13:50:00',2.53),('12664','2013-12-04','13:55:00',2.47),('12664','2013-12-04','14:00:00',2.41),('12664','2013-12-04','14:05:00',2.34),('12664','2013-12-04','14:10:00',2.29),('12664','2013-12-04','14:15:00',2.23),('12664','2013-12-04','14:20:00',2.17),('12664','2013-12-04','14:25:00',2.1),('12664','2013-12-04','14:30:00',2.03),('12664','2013-12-04','14:35:00',1.96),('12664','2013-12-04','14:40:00',1.89),('12664','2013-12-04','14:45:00',1.81),('12664','2013-12-04','14:50:00',1.73),('12664','2013-12-04','14:55:00',1.64),('12664','2013-12-04','15:00:00',1.55),('12664','2013-12-04','15:05:00',1.46),('12664','2013-12-04','15:10:00',1.37),('12664','2013-12-04','15:15:00',1.29),('12664','2013-12-04','15:20:00',1.19),('12664','2013-12-04','15:25:00',1.09),('12664','2013-12-03','08:55:00',1.35),('12664','2013-12-03','09:00:00',1.29),('12664','2013-12-03','09:05:00',1.08),('12664','2013-12-03','09:20:00',1.01),('12664','2013-12-03','09:25:00',1.34),('12664','2013-12-03','09:30:00',1.42),('12664','2013-12-03','09:35:00',1.62),('12664','2013-12-03','09:40:00',1.73),('12664','2013-12-03','09:45:00',2.07),('12664','2013-12-03','09:50:00',2.08),('12664','2013-12-03','09:55:00',2.54),('12664','2013-12-03','10:00:00',2.6),('12664','2013-12-03','10:05:00',2.65),('12664','2013-12-03','10:10:00',2.71),('12664','2013-12-03','10:15:00',2.74),('12664','2013-12-03','10:20:00',2.78),('12664','2013-12-03','10:25:00',2.81),('12664','2013-12-03','10:30:00',2.85),('12664','2013-12-03','10:35:00',2.89),('12664','2013-12-03','10:40:00',2.9),('12664','2013-12-03','10:45:00',2.93),('12664','2013-12-03','10:50:00',2.95),('12664','2013-12-03','10:55:00',3),('12664','2013-12-03','11:00:00',3.05),('12664','2013-12-03','11:05:00',3.09),('12664','2013-12-03','11:10:00',3.14),('12664','2013-12-03','11:15:00',3.18),('12664','2013-12-03','11:20:00',3.2),('12664','2013-12-03','11:25:00',3.22),('12664','2013-12-03','11:30:00',3.21),('12664','2013-12-03','11:35:00',3.22),('12664','2013-12-03','11:40:00',3.22),('12664','2013-12-03','11:45:00',3.24),('12664','2013-12-03','11:50:00',3.25),('12664','2013-12-03','11:55:00',3.23),('12664','2013-12-03','12:00:00',3.25),('12664','2013-12-03','12:05:00',3.28),('12664','2013-12-03','12:10:00',3.3),('12664','2013-12-03','12:15:00',3.3),('12664','2013-12-03','12:20:00',3.31),('12664','2013-12-03','12:25:00',3.35),('12664','2013-12-03','12:30:00',3.37),('12664','2013-12-03','12:35:00',3.39),('12664','2013-12-03','12:40:00',3.42),('12664','2013-12-03','12:45:00',3.45),('12664','2013-12-03','12:50:00',3.5),('12664','2013-12-03','12:55:00',3.58),('12664','2013-12-03','13:00:00',3.67),('12664','2013-12-03','13:05:00',3.69),('12664','2013-12-03','13:10:00',3.63),('12664','2013-12-03','13:15:00',3.55),('12664','2013-12-03','13:20:00',3.14),('12664','2013-12-03','13:25:00',2),('12664','2013-12-03','13:30:00',1.7),('12664','2013-12-03','13:35:00',1.95),('12664','2013-12-03','13:40:00',1.54),('12664','2013-12-03','13:45:00',1.17),('12664','2013-12-03','13:50:00',1.23),('12664','2013-12-03','13:55:00',1.26),('12664','2013-12-03','14:00:00',1.29),('12664','2013-12-03','14:05:00',1.53),('12664','2013-12-03','14:10:00',2.22),('12664','2013-12-03','14:15:00',2.05),('12664','2013-12-03','14:20:00',2.2),('12664','2013-12-03','14:25:00',2.07),('12664','2013-12-03','14:30:00',2.02),('12664','2013-12-03','14:35:00',1.95),('12664','2013-12-03','14:40:00',1.72),('12664','2013-12-03','14:45:00',1.47),('12664','2013-12-03','14:50:00',1.65),('12664','2013-12-03','14:55:00',1.6),('12664','2013-12-03','15:00:00',1.51),('12664','2013-12-03','15:05:00',1.41),('12664','2013-12-03','15:10:00',1.32),('12664','2013-12-03','15:15:00',1.23),('12664','2013-12-03','15:20:00',1.14),('12664','2013-12-03','15:25:00',1.04),('12664','2013-12-01','11:35:00',1.6),('12664','2013-12-01','11:40:00',2.31),('12664','2013-12-01','11:45:00',2.5),('12664','2013-12-01','11:50:00',2.17),('12664','2013-12-01','11:55:00',1.97),('12664','2013-12-01','12:00:00',2.75),('12664','2013-12-01','12:05:00',2.6),('12664','2013-12-01','12:10:00',2.45),('12664','2013-12-01','12:15:00',2.08),('12664','2013-12-01','12:20:00',1.44),('12664','2013-12-01','12:25:00',1.54),('12664','2013-11-30','09:05:00',1.1),('12664','2013-11-30','09:10:00',1.77),('12664','2013-11-30','09:15:00',1.71),('12664','2013-11-30','09:20:00',1.69),('12664','2013-11-30','09:25:00',1.76),('12664','2013-11-30','09:30:00',1.85),('12664','2013-11-30','09:35:00',1.46),('12664','2013-11-30','09:40:00',1.3),('12664','2013-11-30','09:45:00',1.09),('12664','2013-11-30','09:50:00',1.01),('12664','2013-11-30','10:20:00',1.2),('12664','2013-11-30','10:25:00',1.11),('12664','2013-11-30','10:30:00',1.04),('12664','2013-11-30','10:35:00',1.03),('12664','2013-11-30','10:40:00',1.07),('12664','2013-11-30','10:45:00',1.07),('12664','2013-11-30','10:50:00',1.1),('12664','2013-11-30','10:55:00',1.32),('12664','2013-11-30','11:00:00',1.32),('12664','2013-11-30','11:05:00',1.2),('12664','2013-11-30','11:10:00',1.27),('12664','2013-11-30','11:15:00',1.32),('12664','2013-11-30','11:20:00',1.31),('12664','2013-11-30','11:25:00',1.2),('12664','2013-11-30','11:30:00',1.24),('12664','2013-11-30','11:35:00',1.11),('12664','2013-11-29','08:20:00',1.09),('12664','2013-11-29','08:25:00',1.17),('12664','2013-11-29','08:30:00',1.26),('12664','2013-11-29','08:35:00',1.36),('12664','2013-11-29','08:40:00',1.45),('12664','2013-11-29','08:45:00',1.54),('12664','2013-11-29','08:50:00',1.62),('12664','2013-11-29','08:55:00',1.71),('12664','2013-11-29','09:00:00',1.79),('12664','2013-11-29','09:05:00',1.87),('12664','2013-11-29','09:10:00',1.94),('12664','2013-11-29','09:15:00',2.01),('12664','2013-11-29','09:20:00',2.09),('12664','2013-11-29','09:25:00',2.15),('12664','2013-11-29','09:30:00',2.21),('12664','2013-11-29','09:35:00',2.27),('12664','2013-11-29','09:40:00',2.32),('12664','2013-11-29','09:45:00',2.38),('12664','2013-11-29','09:50:00',2.44),('12664','2013-11-29','09:55:00',2.5),('12664','2013-11-29','10:00:00',2.57),('12664','2013-11-29','10:05:00',2.63),('12664','2013-11-29','10:10:00',2.69),('12664','2013-11-29','10:15:00',2.72),('12664','2013-11-29','10:20:00',2.76),('12664','2013-11-29','10:25:00',2.82),('12664','2013-11-29','10:30:00',2.86),('12664','2013-11-29','10:35:00',2.89),('12664','2013-11-29','10:40:00',2.91),('12664','2013-11-29','10:45:00',2.93),('12664','2013-11-29','10:50:00',2.96),('12664','2013-11-29','10:55:00',2.99),('12664','2013-11-29','11:00:00',3.03),('12664','2013-11-29','11:05:00',3.05),('12664','2013-11-29','11:10:00',3.08),('12664','2013-11-29','11:15:00',3.1),('12664','2013-11-29','11:20:00',3.12),('12664','2013-11-29','11:25:00',3.14),('12664','2013-11-29','11:30:00',3.17),('12664','2013-11-29','11:35:00',3.19),('12664','2013-11-29','11:40:00',3.18),('12664','2013-11-29','11:45:00',3.18),('12664','2013-11-29','11:50:00',3.2),('12664','2013-11-29','11:55:00',3.17),('12664','2013-11-29','12:00:00',3.18),('12664','2013-11-29','12:05:00',3.17),('12664','2013-11-29','12:10:00',3.17),('12664','2013-11-29','12:15:00',3.17),('12664','2013-11-29','12:20:00',3.17),('12664','2013-11-29','12:25:00',3.16),('12664','2013-11-29','12:30:00',3.14),('12664','2013-11-29','12:35:00',3.12),('12664','2013-11-29','12:40:00',3.1),('12664','2013-11-29','12:45:00',3.07),('12664','2013-11-29','12:50:00',3.04),('12664','2013-11-29','12:55:00',3.02),('12664','2013-11-29','13:00:00',2.96),('12664','2013-11-29','13:05:00',2.95),('12664','2013-11-29','13:10:00',2.89),('12664','2013-11-29','13:15:00',2.82),('12664','2013-11-29','13:20:00',2.79),('12664','2013-11-29','13:25:00',2.76),('12664','2013-11-29','13:30:00',2.73),('12664','2013-11-29','13:35:00',2.67),('12664','2013-11-29','13:40:00',2.6),('12664','2013-11-29','13:45:00',2.55),('12664','2013-11-29','13:50:00',2.5),('12664','2013-11-29','13:55:00',2.42),('12664','2013-11-29','14:00:00',2.37),('12664','2013-11-29','14:05:00',2.3),('12664','2013-11-29','14:10:00',2.24),('12664','2013-11-29','14:15:00',2.18),('12664','2013-11-29','14:20:00',2.14),('12664','2013-11-29','14:25:00',2.06),('12664','2013-11-29','14:30:00',1.98),('12664','2013-11-29','14:35:00',1.9),('12664','2013-11-29','14:40:00',1.83),('12664','2013-11-29','14:45:00',1.75),('12664','2013-11-29','14:50:00',1.66),('12664','2013-11-29','14:55:00',1.57),('12664','2013-11-29','15:00:00',1.48),('12664','2013-11-29','15:05:00',1.4),('12664','2013-11-29','15:10:00',1.31),('12664','2013-11-29','15:15:00',1.22),('12664','2013-11-29','15:20:00',1.13),('12664','2013-11-29','15:25:00',1.04),('12664','2013-11-27','08:55:00',1.08),('12664','2013-11-27','09:00:00',1.25),('12664','2013-11-27','09:05:00',1.25),('12664','2013-11-27','09:10:00',1.12),('12664','2013-11-27','09:25:00',1.43),('12664','2013-11-27','09:30:00',1.56),('12664','2013-11-27','09:35:00',1.37),('12664','2013-11-27','09:40:00',1.11),('12664','2013-11-27','09:45:00',1.01),('12664','2013-11-27','10:00:00',1.02),('12664','2013-11-27','10:05:00',1.11),('12664','2013-11-27','10:10:00',1.17),('12664','2013-11-27','10:15:00',1.3),('12664','2013-11-27','10:20:00',1.51),('12664','2013-11-27','10:25:00',1.52),('12664','2013-11-27','10:30:00',1.29),('12664','2013-11-27','10:35:00',1.35),('12664','2013-11-27','10:40:00',1.22),('12664','2013-11-27','10:45:00',1.26),('12664','2013-11-27','10:50:00',1.26),('12664','2013-11-27','10:55:00',1.25),('12664','2013-11-27','11:00:00',1.35),('12664','2013-11-27','11:05:00',1.59),('12664','2013-11-27','11:10:00',1.67),('12664','2013-11-27','11:15:00',1.68),('12664','2013-11-27','11:20:00',2.52),('12664','2013-11-27','11:25:00',1.68),('12664','2013-11-27','11:30:00',1.69),('12664','2013-11-27','11:35:00',1.96),('12664','2013-11-27','11:40:00',1.76),('12664','2013-11-27','11:45:00',2.54),('12664','2013-11-27','11:50:00',3.73),('12664','2013-11-27','11:55:00',2.12),('12664','2013-11-27','12:00:00',1.57),('12664','2013-11-27','12:05:00',1.73),('12664','2013-11-27','12:10:00',2.74),('12664','2013-11-27','12:15:00',2.59),('12664','2013-11-27','12:20:00',2.08),('12664','2013-11-27','12:25:00',2.24),('12664','2013-11-27','12:30:00',2.21),('12664','2013-11-27','12:35:00',1.99),('12664','2013-11-27','12:40:00',1.7),('12664','2013-11-27','12:45:00',1.57),('12664','2013-11-27','12:50:00',1.21),('12664','2013-11-27','13:10:00',1.06),('12664','2013-11-27','13:15:00',1.09),('12664','2013-11-27','13:20:00',1.05),('12664','2013-11-27','13:25:00',1.17),('12664','2013-11-27','13:30:00',1.11),('12664','2014-04-19','08:10:00',1.04),('12664','2014-04-19','08:15:00',1.08),('12664','2014-04-19','08:20:00',1.11),('12664','2014-04-19','08:25:00',1.06),('12664','2014-04-19','08:30:00',1.07),('12664','2014-04-19','09:25:00',1.07),('12664','2014-04-19','10:35:00',2.32),('12664','2014-04-19','10:40:00',1.61),('12664','2014-04-19','10:45:00',1.61),('12664','2014-04-19','10:50:00',1.75),('12664','2014-04-19','10:55:00',1.2),('12664','2014-04-19','11:00:00',1.15),('12664','2014-04-19','11:05:00',1.79),('12664','2014-04-19','11:10:00',3.02),('12664','2014-04-19','11:15:00',3.71),('12664','2014-04-19','11:20:00',3.14),('12664','2014-04-19','11:25:00',2.26),('12664','2014-04-19','11:30:00',3.16),('12664','2014-04-19','11:35:00',2.67),('12664','2014-04-19','11:40:00',1.98),('12664','2014-04-19','11:45:00',1.24),('12664','2014-04-19','14:35:00',1.17),('12664','2014-04-19','14:40:00',1.15),('12664','2014-04-19','15:00:00',1.46),('12664','2014-04-19','15:25:00',1.07),('12664','2014-04-19','15:40:00',1.89),('12664','2014-04-19','15:45:00',3.44),('12664','2014-04-19','15:50:00',2.53),('12664','2014-04-19','15:55:00',2.15),('12664','2014-04-19','16:00:00',1.19),('12664','2014-04-19','16:05:00',1.43),('12664','2014-04-19','16:10:00',1.31),('12664','2014-04-19','16:15:00',1.57),('12664','2014-04-19','16:20:00',1.75),('12664','2014-04-19','16:25:00',2.5),('12664','2014-04-19','16:30:00',1.41),('12664','2014-04-19','16:35:00',1.25),('12664','2014-04-19','16:40:00',1.24),('12664','2014-04-19','17:00:00',1.26),('12664','2014-04-19','17:05:00',1.16),('12664','2014-04-19','17:10:00',1.03),('12664','2014-04-19','17:15:00',1.33),('12664','2014-04-19','17:20:00',1.23),('12664','2013-11-26','08:40:00',1.32),('12664','2013-11-26','09:00:00',1.02),('12664','2013-11-26','09:05:00',1.58),('12664','2013-11-26','09:20:00',1.11),('12664','2013-11-26','09:25:00',1.15),('12664','2013-11-26','09:30:00',1.25),('12664','2013-11-26','09:35:00',1.21),('12664','2013-11-26','09:40:00',1.52),('12664','2013-11-26','09:45:00',1.75),('12664','2013-11-26','09:50:00',1.9),('12664','2013-11-26','09:55:00',2.91),('12664','2013-11-26','10:00:00',1.27),('12664','2013-11-26','10:15:00',1.08),('12664','2013-11-26','10:20:00',1.11),('12664','2013-11-26','10:25:00',2.91),('12664','2013-11-26','10:30:00',3.32),('12664','2013-11-26','10:35:00',3.36),('12664','2013-11-26','10:40:00',3.41),('12664','2013-11-26','10:45:00',3.48),('12664','2013-11-26','10:50:00',3.5),('12664','2013-11-26','10:55:00',3.5),('12664','2013-11-26','11:00:00',3.59),('12664','2013-11-26','11:05:00',3.77),('12664','2013-11-26','11:10:00',1.67),('12664','2013-11-26','11:15:00',2.24),('12664','2013-11-26','11:20:00',2.65),('12664','2013-11-26','11:25:00',1.9),('12664','2013-11-26','11:30:00',3.26),('12664','2013-11-26','11:35:00',1.97),('12664','2013-11-26','11:40:00',3.01),('12664','2013-11-26','11:45:00',3.37),('12664','2013-11-26','11:50:00',3.66),('12664','2013-11-26','11:55:00',3.88),('12664','2013-11-26','12:00:00',3.53),('12664','2013-11-26','12:05:00',3.42),('12664','2013-11-26','12:10:00',1.82),('12664','2013-11-26','12:15:00',3.31),('12664','2013-11-26','12:20:00',2.7),('12664','2013-11-26','12:25:00',2.38),('12664','2013-11-26','12:30:00',3.62),('12664','2013-11-26','12:35:00',3.49),('12664','2013-11-26','12:40:00',3.45),('12664','2013-11-26','12:45:00',3.39),('12664','2013-11-26','12:50:00',3.36),('12664','2013-11-26','12:55:00',3.32),('12664','2013-11-26','13:00:00',3.28),('12664','2013-11-26','13:05:00',3.24),('12664','2013-11-26','13:10:00',3.21),('12664','2013-11-26','13:15:00',3.16),('12664','2013-11-26','13:20:00',3.13),('12664','2013-11-26','13:25:00',3.09),('12664','2013-11-26','13:30:00',3.09),('12664','2013-11-26','13:35:00',2.72),('12664','2013-11-26','13:40:00',2.89),('12664','2013-11-26','13:45:00',2.89),('12664','2013-11-26','13:50:00',2.57),('12664','2013-11-26','13:55:00',3.03),('12664','2013-11-26','14:00:00',2.86),('12664','2013-11-26','14:05:00',2.97),('12664','2013-11-26','14:10:00',2.8),('12664','2013-11-26','14:15:00',2.76),('12664','2013-11-26','14:20:00',2.25),('12664','2013-11-26','14:25:00',1.42),('12664','2013-11-26','14:30:00',2.3),('12664','2013-11-26','14:35:00',2.35),('12664','2013-11-26','14:40:00',1.86),('12664','2013-11-26','14:45:00',1.53),('12664','2013-11-26','14:50:00',1.98),('12664','2013-11-26','14:55:00',1.25),('12664','2013-11-26','15:05:00',1.42),('12664','2013-11-26','15:10:00',1.58),('12664','2013-11-26','15:15:00',1.47),('12664','2013-11-26','15:20:00',1.38),('12664','2013-11-26','15:25:00',1.27),('12664','2013-11-26','15:30:00',1.16),('12664','2013-11-26','15:35:00',1.06),('12664','2013-11-25','08:10:00',1.1),('12664','2013-11-25','08:15:00',1.29),('12664','2013-11-25','08:20:00',1.42),('12664','2013-11-25','08:25:00',1.37),('12664','2013-11-25','08:30:00',1.69),('12664','2013-11-25','08:35:00',1.87),('12664','2013-11-25','08:40:00',2.07),('12664','2013-11-25','08:45:00',2.18),('12664','2013-11-25','08:50:00',2.11),('12664','2013-11-25','08:55:00',1.35),('12664','2013-11-25','09:35:00',1.04),('12664','2013-11-25','09:45:00',1),('12664','2013-11-25','10:00:00',1.35),('12664','2013-11-25','10:05:00',2.02),('12664','2013-11-25','10:10:00',3.16),('12664','2013-11-25','10:15:00',2.62),('12664','2013-11-25','10:20:00',1.96),('12664','2013-11-25','10:25:00',1.31),('12664','2013-11-25','10:30:00',1.83),('12664','2013-11-25','10:35:00',3.63),('12664','2013-11-25','10:40:00',3.17),('12664','2013-11-25','10:45:00',2.71),('12664','2013-11-25','10:50:00',3.05),('12664','2013-11-25','10:55:00',3.2),('12664','2013-11-25','11:00:00',3.21),('12664','2013-11-25','11:05:00',3.35),('12664','2013-11-25','11:10:00',2.92),('12664','2013-11-25','11:15:00',1.24),('12664','2013-11-25','11:20:00',3.23),('12664','2013-11-25','11:25:00',1.57),('12664','2013-11-25','11:30:00',1.6),('12664','2013-11-25','11:35:00',2.97),('12664','2013-11-25','11:40:00',3.32),('12664','2013-11-25','11:45:00',3.58),('12664','2013-11-25','11:50:00',3.41),('12664','2013-11-25','11:55:00',2.04),('12664','2013-11-25','12:00:00',1.68),('12664','2013-11-25','12:05:00',1.51),('12664','2013-11-25','12:10:00',1.45),('12664','2013-11-25','12:15:00',1.98),('12664','2013-11-25','12:20:00',1.75),('12664','2013-11-25','12:25:00',1.55),('12664','2013-11-25','12:30:00',1.24),('12664','2013-11-25','12:35:00',1.09),('12664','2013-11-25','12:40:00',1.19),('12664','2013-11-25','12:45:00',3.18),('12664','2013-11-25','12:50:00',2.49),('12664','2013-11-25','12:55:00',2.59),('12664','2013-11-25','13:00:00',1.97),('12664','2013-11-25','13:05:00',2),('12664','2013-11-25','13:10:00',3.73),('12664','2013-11-25','13:15:00',3.82),('12664','2013-11-25','13:20:00',3.76),('12664','2013-11-25','13:25:00',1.58),('12664','2013-11-25','13:30:00',1.03),('12664','2013-11-25','13:35:00',1.08),('12664','2013-11-25','13:40:00',1.31),('12664','2013-11-25','13:45:00',1.24),('12664','2013-11-25','13:50:00',1.11),('12664','2013-11-24','10:00:00',1.32),('12664','2013-11-24','10:05:00',1.62),('12664','2013-11-24','10:10:00',1.46),('12664','2013-11-24','10:15:00',1.26),('12664','2013-11-24','10:20:00',1.24),('12664','2013-11-24','10:25:00',1.79),('12664','2013-11-24','10:30:00',2.39),('12664','2013-11-24','10:35:00',2.07),('12664','2013-11-24','10:40:00',1.84),('12664','2013-11-24','10:45:00',1.17),('12664','2013-11-24','11:00:00',1.02),('12664','2013-11-24','11:05:00',1.21),('12664','2013-11-24','11:10:00',1.18),('12664','2013-11-24','11:15:00',1.23),('12664','2013-11-24','11:20:00',1.58),('12664','2013-11-24','11:25:00',1.37),('12664','2013-11-24','11:30:00',1.25),('12664','2013-11-24','11:35:00',1.13),('12664','2013-11-24','11:40:00',1.04),('12664','2013-11-24','12:40:00',1.1),('12664','2013-11-24','12:45:00',1.26),('12664','2013-11-24','12:50:00',1.44),('12664','2013-11-24','12:55:00',1.86),('12664','2013-11-24','13:00:00',2.35),('12664','2013-11-24','13:05:00',1.77),('12664','2013-11-24','13:10:00',1.46),('12664','2013-11-24','13:15:00',1.55),('12664','2013-11-24','13:20:00',1.44),('12664','2013-11-24','13:25:00',1.29),('12664','2013-11-24','13:30:00',1.18),('12664','2013-11-24','13:35:00',1.15),('12664','2013-11-24','13:40:00',1.12),('12664','2013-11-24','13:45:00',1.04),('12664','2013-11-23','08:40:00',1.55),('12664','2013-11-23','10:25:00',1.23),('12664','2013-11-23','10:30:00',2.78),('12664','2013-11-23','10:35:00',1.07),('12664','2013-11-22','12:15:00',1.18),('12664','2013-11-22','12:20:00',1.45),('12664','2013-11-22','12:25:00',1.37),('12664','2013-11-21','08:05:00',1.02),('12664','2013-11-21','09:40:00',1.36),('12664','2013-11-21','09:45:00',2.4),('12664','2013-11-21','09:50:00',2.74),('12664','2013-11-21','09:55:00',2.84),('12664','2013-11-21','10:00:00',2.91),('12664','2013-11-21','10:05:00',2.89),('12664','2013-11-21','10:10:00',2.76),('12664','2013-11-21','10:15:00',3.12),('12664','2013-11-21','10:20:00',2.88),('12664','2013-11-21','10:25:00',3.11),('12664','2013-11-21','10:30:00',1.16),('12664','2013-11-21','10:35:00',2.52),('12664','2013-11-21','10:40:00',1.58),('12664','2013-11-21','10:45:00',2.27),('12664','2013-11-21','10:50:00',2.3),('12664','2013-11-21','10:55:00',2.88),('12664','2013-11-21','11:00:00',1.57),('12664','2013-11-21','11:05:00',3.11),('12664','2013-11-21','11:10:00',2.08),('12664','2013-11-21','11:15:00',3.05),('12664','2013-11-21','11:20:00',2.89),('12664','2013-11-21','11:25:00',3.34),('12664','2013-11-21','11:30:00',3.36),('12664','2013-11-21','11:35:00',3.35),('12664','2013-11-21','11:40:00',3.35),('12664','2013-11-21','11:45:00',3.34),('12664','2013-11-21','11:50:00',3.36),('12664','2013-11-21','11:55:00',3.43),('12664','2013-11-21','12:00:00',3.65),('12664','2013-11-21','12:05:00',3.63),('12664','2013-11-21','12:10:00',3.88),('12664','2013-11-21','12:15:00',3.01),('12664','2013-11-21','12:20:00',2.73),('12664','2013-11-21','12:25:00',1.31),('12664','2013-11-21','12:35:00',1.64),('12664','2013-11-21','12:50:00',1.22),('12664','2013-11-21','12:55:00',3.28),('12664','2013-11-21','13:00:00',2.5),('12664','2013-11-21','13:05:00',2.57),('12664','2013-11-21','13:10:00',3.04),('12664','2013-11-21','13:15:00',1.76),('12664','2013-11-21','13:20:00',1.94),('12664','2013-11-21','13:25:00',3.06),('12664','2013-11-21','13:30:00',2.88),('12664','2013-11-21','13:35:00',2.9),('12664','2013-11-21','13:40:00',2.66),('12664','2013-11-21','13:45:00',2.87),('12664','2013-11-21','13:50:00',2.77),('12664','2013-11-21','13:55:00',1.43),('12664','2013-11-21','14:05:00',2.12),('12664','2013-11-21','14:10:00',2.42),('12664','2013-11-21','14:15:00',1.94),('12664','2013-11-21','14:20:00',2.3),('12664','2013-11-21','14:25:00',2.25),('12664','2013-11-21','14:30:00',1.98),('12664','2013-11-21','14:35:00',2.06),('12664','2013-11-21','14:40:00',1.99),('12664','2013-11-21','14:45:00',1.9),('12664','2013-11-21','14:50:00',1.79),('12664','2013-11-21','14:55:00',1.69),('12664','2013-11-21','15:00:00',1.62),('12664','2013-11-21','15:05:00',1.53),('12664','2013-11-21','15:10:00',1.31),('12664','2013-11-20','08:50:00',1.87),('12664','2013-11-20','08:55:00',1.93),('12664','2013-11-20','09:00:00',1.96),('12664','2013-11-20','09:05:00',2.01),('12664','2013-11-20','09:10:00',2.16),('12664','2013-11-20','09:15:00',2.14),('12664','2013-11-20','09:20:00',1.75),('12664','2013-11-20','11:50:00',1.73),('12664','2013-11-20','12:10:00',1.24),('12664','2013-11-20','12:15:00',1.89),('12664','2013-11-20','12:20:00',2.52),('12664','2013-11-20','12:25:00',1.25),('12664','2013-11-20','12:55:00',1.18),('12664','2013-11-20','13:00:00',1.64),('12664','2013-11-20','13:10:00',1.03),('12664','2013-11-20','13:15:00',1.09),('12664','2013-11-20','13:20:00',1.58),('12664','2013-11-20','13:25:00',1.5),('12664','2013-11-20','13:30:00',1.61),('12664','2013-11-20','13:35:00',1.72),('12664','2013-11-20','13:45:00',1.63),('12664','2013-11-20','13:50:00',1.38),('12664','2013-11-20','14:15:00',1.05),('12664','2013-11-20','14:30:00',1.15),('12664','2013-11-20','14:35:00',2.29),('12664','2013-11-20','14:40:00',1.2),('12664','2013-11-20','14:45:00',1.48),('12664','2013-11-20','14:50:00',1.82),('12664','2013-11-20','14:55:00',1.79),('12664','2013-11-20','15:00:00',1.73),('12664','2013-11-20','15:05:00',1.78),('12664','2013-11-20','15:10:00',1.33),('12664','2013-11-20','15:15:00',1.35),('12664','2013-11-20','15:20:00',1.28),('12664','2013-11-20','15:30:00',1.04),('12664','2013-11-20','15:35:00',1.01),('12664','2013-11-19','08:15:00',1.17),('12664','2013-11-19','08:35:00',1.09),('12664','2013-11-19','09:15:00',1.38),('12664','2013-11-19','09:35:00',2.36),('12664','2013-11-19','09:40:00',2.36),('12664','2013-11-19','09:45:00',2.5),('12664','2013-11-19','09:50:00',2.55),('12664','2013-11-19','09:55:00',2.66),('12664','2013-11-19','10:00:00',2.74),('12664','2013-11-19','10:05:00',2.5),('12664','2013-11-19','10:10:00',2.87),('12664','2013-11-19','10:15:00',2.23),('12664','2013-11-19','10:55:00',1.51),('12664','2013-11-19','11:00:00',1.41),('12664','2013-11-19','11:10:00',1.31),('12664','2013-11-19','11:15:00',1.29),('12664','2013-11-19','11:20:00',1.95),('12664','2013-11-19','11:25:00',1.48),('12664','2013-11-19','11:30:00',3.03),('12664','2013-11-19','11:35:00',2.65),('12664','2013-11-19','11:40:00',2.03),('12664','2013-11-19','11:45:00',2.77),('12664','2013-11-19','11:50:00',3.11),('12664','2013-11-19','11:55:00',2.92),('12664','2013-11-19','12:00:00',2.94),('12664','2013-11-19','12:05:00',2.96),('12664','2013-11-19','12:10:00',2.84),('12664','2013-11-19','12:15:00',2.89),('12664','2013-11-19','12:20:00',2.88),('12664','2013-11-19','12:25:00',1.76),('12664','2013-11-19','12:30:00',2.97),('12664','2013-11-19','12:35:00',2.32),('12664','2013-11-19','12:45:00',3.18),('12664','2013-11-19','12:50:00',2.94),('12664','2013-11-19','13:10:00',1.3),('12664','2013-11-19','13:15:00',2.67),('12664','2013-11-19','13:30:00',1.11),('12664','2013-11-19','15:15:00',1.28),('12664','2013-11-19','15:20:00',1.77),('12664','2013-11-19','15:25:00',1.82),('12664','2013-11-19','15:30:00',1.67),('12664','2013-11-19','15:35:00',1.21),('12664','2013-11-18','08:05:00',1.03),('12664','2013-11-18','08:40:00',1.15),('12664','2013-11-18','08:55:00',1.11),('12664','2013-11-18','09:15:00',1.31),('12664','2013-11-18','09:20:00',1.67),('12664','2013-11-18','09:25:00',1.69),('12664','2013-11-18','09:30:00',2.2),('12664','2013-11-18','09:35:00',2.05),('12664','2013-11-18','09:40:00',1.32),('12664','2013-11-18','09:55:00',1),('12664','2013-11-18','10:00:00',1.34),('12664','2013-11-18','10:05:00',1.54),('12664','2013-11-18','10:10:00',1.63),('12664','2013-11-18','10:15:00',1.76),('12664','2013-11-18','10:20:00',1.48),('12664','2013-11-18','10:25:00',1.14),('12664','2013-11-18','10:30:00',1.04),('12664','2013-11-18','10:35:00',1.14),('12664','2013-11-18','10:40:00',1.31),('12664','2013-11-18','10:45:00',1.31),('12664','2013-11-18','10:50:00',1.2),('12664','2013-11-18','11:25:00',1.08),('12664','2013-11-18','11:30:00',1.14),('12664','2013-11-18','11:35:00',1.18),('12664','2013-11-18','11:40:00',1.17),('12664','2013-11-18','11:45:00',1.21),('12664','2013-11-18','11:50:00',1.31),('12664','2013-11-18','11:55:00',1.38),('12664','2013-11-18','12:00:00',1.49),('12664','2013-11-18','12:05:00',1.4),('12664','2013-11-18','12:10:00',1.38),('12664','2013-11-18','12:15:00',1.43),('12664','2013-11-18','12:20:00',1.72),('12664','2013-11-18','12:25:00',2.06),('12664','2013-11-18','12:30:00',1.94),('12664','2013-11-18','12:35:00',1.51),('12664','2013-11-18','12:40:00',1.26),('12664','2013-11-18','12:45:00',1.01),('12664','2013-11-18','13:10:00',1.02),('12664','2013-11-18','13:40:00',1.04),('12664','2013-11-18','13:45:00',1.17),('12664','2013-11-18','13:50:00',1.09),('12664','2013-11-17','08:55:00',1.38),('12664','2013-11-17','09:00:00',2.23),('12664','2013-11-17','09:05:00',2.19),('12664','2013-11-17','09:10:00',2.28),('12664','2013-11-17','09:15:00',2.29),('12664','2013-11-17','09:20:00',2.26),('12664','2013-11-17','09:25:00',1.64),('12664','2013-11-17','09:30:00',1.5),('12664','2013-11-17','09:35:00',2.57),('12664','2013-11-17','09:40:00',2.59),('12664','2013-11-17','09:45:00',2.57),('12664','2013-11-17','09:50:00',2.57),('12664','2013-11-17','09:55:00',2.59),('12664','2013-11-17','10:00:00',2.63),('12664','2013-11-17','10:05:00',2.67),('12664','2013-11-17','10:10:00',2.71),('12664','2013-11-17','10:15:00',2.76),('12664','2013-11-17','10:20:00',2.79),('12664','2013-11-17','10:25:00',2.83),('12664','2013-11-17','10:30:00',2.87),('12664','2013-11-17','10:35:00',2.89),('12664','2013-11-17','10:40:00',2.93),('12664','2013-11-17','10:45:00',2.95),('12664','2013-11-17','10:50:00',2.99),('12664','2013-11-17','10:55:00',2.98),('12664','2013-11-17','11:00:00',2.99),('12664','2013-11-17','11:05:00',3.02),('12664','2013-11-17','11:10:00',3.04),('12664','2013-11-17','11:15:00',3.06),('12664','2013-11-17','11:20:00',3.05),('12664','2013-11-17','11:25:00',3.06),('12664','2013-11-17','11:30:00',3.08),('12664','2013-11-17','11:35:00',3.08),('12664','2013-11-17','11:40:00',3.07),('12664','2013-11-17','11:45:00',3.06),('12664','2013-11-17','11:50:00',3.05),('12664','2013-11-17','11:55:00',3.06),('12664','2013-11-17','12:00:00',3.07),('12664','2013-11-17','12:05:00',3.07),('12664','2013-11-17','12:10:00',3.02),('12664','2013-11-17','12:15:00',3.06),('12664','2013-11-17','12:20:00',3.15),('12664','2013-11-17','12:25:00',3.19),('12664','2013-11-17','12:30:00',3.03),('12664','2013-11-17','12:35:00',2.98),('12664','2013-11-17','12:40:00',2.96),('12664','2013-11-17','12:45:00',2.93),('12664','2013-11-17','12:50:00',2.91),('12664','2013-11-17','12:55:00',2.88),('12664','2013-11-17','13:00:00',2.86),('12664','2013-11-17','13:05:00',2.83),('12664','2013-11-17','13:10:00',2.79),('12664','2013-11-17','13:15:00',2.78),('12664','2013-11-17','13:20:00',2.79),('12664','2013-11-17','13:25:00',2.8),('12664','2013-11-17','13:30:00',2.77),('12664','2013-11-17','13:35:00',2.72),('12664','2013-11-17','13:40:00',2.59),('12664','2013-11-17','13:45:00',2.49),('12664','2013-11-17','13:50:00',1.99),('12664','2013-11-17','13:55:00',2.39),('12664','2013-11-17','14:00:00',2.28),('12664','2013-11-17','14:05:00',2.06),('12664','2013-11-17','14:10:00',2.26),('12664','2013-11-17','14:15:00',2.18),('12664','2013-11-17','14:20:00',2.02),('12664','2013-11-17','14:25:00',1.85),('12664','2013-11-17','14:30:00',1.97),('12664','2013-11-17','14:35:00',1),('12664','2013-11-17','15:05:00',1.47),('12664','2013-11-17','15:10:00',1.44),('12664','2013-11-17','15:15:00',1.32),('12664','2013-11-17','15:20:00',1.23),('12664','2013-11-17','15:25:00',1.15),('12664','2013-11-17','15:30:00',1.04),('12664','2014-04-18','08:10:00',1.35),('12664','2014-04-18','08:20:00',1.2),('12664','2014-04-18','08:35:00',1.24),('12664','2014-04-18','08:40:00',1),('12664','2014-04-18','08:45:00',2.11),('12664','2014-04-18','08:50:00',1.56),('12664','2014-04-18','08:55:00',1.04),('12664','2014-04-18','09:05:00',1),('12664','2014-04-18','09:10:00',1.99),('12664','2014-04-18','09:15:00',2.72),('12664','2014-04-18','09:20:00',2.21),('12664','2014-04-18','09:25:00',1.89),('12664','2014-04-18','09:30:00',2.01),('12664','2014-04-18','09:35:00',1.88),('12664','2014-04-18','09:40:00',2.76),('12664','2014-04-18','09:45:00',2.49),('12664','2014-04-18','09:50:00',2.27),('12664','2014-04-18','09:55:00',1.54),('12664','2014-04-18','10:00:00',1.48),('12664','2014-04-18','10:05:00',1.31),('12664','2014-04-18','10:10:00',1.4),('12664','2014-04-18','10:15:00',1.25),('12664','2014-04-18','10:20:00',1.59),('12664','2014-04-18','10:25:00',1.33),('12664','2014-04-18','10:30:00',1.25),('12664','2014-04-18','10:35:00',1.57),('12664','2014-04-18','10:40:00',2.83),('12664','2014-04-18','10:45:00',2.78),('12664','2014-04-18','10:50:00',3.37),('12664','2014-04-18','10:55:00',3.43),('12664','2014-04-18','11:00:00',2.54),('12664','2014-04-18','11:05:00',2.42),('12664','2014-04-18','11:10:00',2.11),('12664','2014-04-18','11:15:00',2.26),('12664','2014-04-18','11:20:00',2.01),('12664','2014-04-18','11:25:00',2.48),('12664','2014-04-18','11:30:00',3.36),('12664','2014-04-18','11:35:00',2.94),('12664','2014-04-18','11:40:00',2.69),('12664','2014-04-18','11:45:00',3.44),('12664','2014-04-18','11:50:00',2.32),('12664','2014-04-18','11:55:00',1.91),('12664','2014-04-18','12:00:00',2.1),('12664','2014-04-18','12:05:00',2.57),('12664','2014-04-18','12:10:00',4.71),('12664','2014-04-18','12:15:00',3.69),('12664','2014-04-18','12:20:00',4.28),('12664','2014-04-18','12:25:00',3.23),('12664','2014-04-18','12:30:00',4.22),('12664','2014-04-18','12:35:00',4.48),('12664','2014-04-18','12:40:00',3.87),('12664','2014-04-18','12:45:00',4.31),('12664','2014-04-18','12:50:00',3.2),('12664','2014-04-18','12:55:00',2.17),('12664','2014-04-18','13:00:00',3.14),('12664','2014-04-18','13:05:00',2.89),('12664','2014-04-18','13:10:00',3.67),('12664','2014-04-18','13:15:00',2.21),('12664','2014-04-18','13:20:00',1.95),('12664','2014-04-18','13:25:00',1.73),('12664','2014-04-18','13:30:00',1.32),('12664','2014-04-18','13:35:00',1.34),('12664','2014-04-18','13:40:00',1.6),('12664','2014-04-18','13:45:00',1.42),('12664','2014-04-18','13:50:00',1.13),('12664','2014-04-18','13:55:00',1.19),('12664','2014-04-18','14:00:00',1.37),('12664','2014-04-18','14:05:00',1.32),('12664','2014-04-18','14:10:00',1.34),('12664','2014-04-18','14:15:00',1.57),('12664','2014-04-18','14:20:00',1.61),('12664','2014-04-18','14:25:00',1.65),('12664','2014-04-18','14:30:00',2.33),('12664','2014-04-18','14:35:00',2.49),('12664','2014-04-18','14:40:00',2.3),('12664','2014-04-18','14:45:00',1.9),('12664','2014-04-18','14:50:00',1.99),('12664','2014-04-18','14:55:00',3.52),('12664','2014-04-18','15:00:00',3.25),('12664','2014-04-18','15:05:00',3.82),('12664','2014-04-18','15:10:00',3.08),('12664','2014-04-18','15:15:00',3.74),('12664','2014-04-18','15:20:00',3.57),('12664','2014-04-18','15:25:00',2.22),('12664','2014-04-18','15:30:00',3.83),('12664','2014-04-18','15:35:00',2.91),('12664','2014-04-18','15:40:00',2.37),('12664','2014-04-18','15:45:00',3.58),('12664','2014-04-18','15:50:00',3.3),('12664','2014-04-18','15:55:00',3.39),('12664','2014-04-18','16:00:00',2.3),('12664','2014-04-18','16:05:00',3.45),('12664','2014-04-18','16:10:00',3.04),('12664','2014-04-18','16:15:00',3.33),('12664','2014-04-18','16:20:00',3.04),('12664','2014-04-18','16:25:00',2.96),('12664','2014-04-18','16:30:00',2.97),('12664','2014-04-18','16:35:00',2.75),('12664','2014-04-18','16:40:00',2.8),('12664','2014-04-18','16:45:00',1.67),('12664','2014-04-18','16:50:00',1.95),('12664','2014-04-18','16:55:00',2.44),('12664','2014-04-18','17:00:00',2.32),('12664','2014-04-18','17:05:00',2.2),('12664','2014-04-18','17:10:00',2.09),('12664','2014-04-18','17:15:00',1.94),('12664','2014-04-18','17:20:00',1.91),('12664','2014-04-18','17:25:00',1.51),('12664','2014-04-18','17:35:00',1.62),('12664','2014-04-18','17:40:00',1.52),('12664','2014-04-18','17:45:00',1.4),('12664','2014-04-18','17:50:00',1.31),('12664','2014-04-18','17:55:00',1.2),('12664','2014-04-18','18:00:00',1.13),('12664','2014-04-18','18:05:00',1.02),('12664','2013-11-16','12:55:00',1.34),('12664','2013-11-16','13:00:00',1.3),('12664','2013-11-16','13:05:00',1.39),('12664','2013-11-16','13:10:00',1.18),('12664','2013-11-16','13:15:00',1.09),('12664','2013-11-15','09:50:00',1.23),('12664','2013-11-15','09:55:00',1.18),('12664','2013-11-15','10:00:00',1.04),('12664','2013-11-15','10:05:00',1.17),('12664','2013-11-15','10:10:00',1.1),('12664','2013-11-15','10:15:00',1.16),('12664','2013-11-15','10:20:00',1.26),('12664','2013-11-15','10:25:00',1.22),('12664','2013-11-15','10:30:00',1.31),('12664','2013-11-15','10:35:00',1.44),('12664','2013-11-15','10:40:00',1.13),('12664','2013-11-15','11:00:00',1.07),('12664','2013-11-15','11:05:00',1.32),('12664','2013-11-15','11:10:00',1.51),('12664','2013-11-15','11:15:00',1.47),('12664','2013-11-15','11:20:00',1.23),('12664','2013-11-15','11:25:00',1.05),('12664','2013-11-15','11:30:00',1.08),('12664','2013-11-15','11:35:00',1.51),('12664','2013-11-15','11:40:00',2.4),('12664','2013-11-15','11:45:00',1.53),('12664','2013-11-15','11:50:00',2.7),('12664','2013-11-15','11:55:00',1.75),('12664','2013-11-15','12:00:00',1.28),('12664','2013-11-15','12:05:00',1.05),('12664','2013-11-14','08:50:00',1.77),('12664','2013-11-14','08:55:00',1.86),('12664','2013-11-14','09:00:00',1.06),('12664','2013-11-14','09:15:00',1.8),('12664','2013-11-14','09:20:00',2.33),('12664','2013-11-14','09:25:00',2.32),('12664','2013-11-14','09:30:00',2.34),('12664','2013-11-14','09:35:00',2.41),('12664','2013-11-14','09:40:00',2.49),('12664','2013-11-14','09:45:00',2.52),('12664','2013-11-14','09:50:00',2.56),('12664','2013-11-14','09:55:00',2.55),('12664','2013-11-14','10:00:00',2.59),('12664','2013-11-14','10:05:00',2.48),('12664','2013-11-14','10:10:00',2.55),('12664','2013-11-14','10:15:00',2.56),('12664','2013-11-14','10:20:00',2.42),('12664','2013-11-14','10:25:00',2.46),('12664','2013-11-14','10:30:00',2.68),('12664','2013-11-14','10:35:00',2.81),('12664','2013-11-14','10:40:00',2.86),('12664','2013-11-14','10:45:00',2.92),('12664','2013-11-14','10:50:00',2.95),('12664','2013-11-14','10:55:00',3.11),('12664','2013-11-14','11:00:00',3.2),('12664','2013-11-14','11:05:00',3.3),('12664','2013-11-14','11:10:00',3.07),('12664','2013-11-14','11:15:00',3.3),('12664','2013-11-14','11:20:00',3.24),('12664','2013-11-14','11:25:00',3.24),('12664','2013-11-14','11:30:00',2.93),('12664','2013-11-14','11:35:00',2.15),('12664','2013-11-14','11:40:00',2.55),('12664','2013-11-14','11:45:00',2.38),('12664','2013-11-14','11:50:00',1.16),('12664','2013-11-14','11:55:00',1.12),('12664','2013-11-14','12:00:00',1.12),('12664','2013-11-14','12:05:00',1.08),('12664','2013-11-14','12:10:00',1.09),('12664','2013-11-14','12:15:00',1.05),('12664','2013-11-14','12:20:00',1.15),('12664','2013-11-14','12:25:00',1.46),('12664','2013-11-14','12:30:00',1.72),('12664','2013-11-14','12:35:00',1.87),('12664','2013-11-14','12:40:00',1.61),('12664','2013-11-14','12:45:00',1.54),('12664','2013-11-14','12:50:00',1.7),('12664','2013-11-14','12:55:00',2.99),('12664','2013-11-14','13:00:00',2.33),('12664','2013-11-14','13:05:00',1.03),('12664','2013-11-14','13:10:00',2.07),('12664','2013-11-14','13:15:00',1.63),('12664','2013-11-14','13:20:00',2.71),('12664','2013-11-14','13:25:00',3.25),('12664','2013-11-14','13:30:00',2.86),('12664','2013-11-14','13:35:00',2.49),('12664','2013-11-14','13:40:00',2.87),('12664','2013-11-14','13:45:00',2.85),('12664','2013-11-14','13:50:00',2.66),('12664','2013-11-14','13:55:00',1.53),('12664','2013-11-14','14:00:00',1.16),('12664','2013-11-14','14:05:00',1.38),('12664','2013-11-14','14:10:00',1.5),('12664','2013-11-13','10:05:00',1.06),('12664','2013-11-13','10:10:00',1.36),('12664','2013-11-13','10:50:00',1.12),('12664','2013-11-13','10:55:00',1.11),('12664','2013-11-13','11:00:00',1.18),('12664','2013-11-13','11:05:00',3.19),('12664','2013-11-13','11:10:00',4.11),('12664','2013-11-13','11:15:00',4.11),('12664','2013-11-13','11:20:00',2.39),('12664','2013-11-13','11:25:00',3.02),('12664','2013-11-13','11:30:00',2.21),('12664','2013-11-13','11:35:00',1.23),('12664','2013-11-13','11:40:00',1.27),('12664','2013-11-13','11:55:00',1.04),('12664','2013-11-13','12:00:00',2),('12664','2013-11-13','12:05:00',2.14),('12664','2013-11-13','12:10:00',1.17),('12664','2013-11-13','12:15:00',1.01),('12664','2013-11-13','12:50:00',1.03),('12664','2013-11-13','12:55:00',1.08),('12664','2013-11-13','13:00:00',1.07),('12664','2013-11-13','13:05:00',1.11),('12664','2013-11-13','13:10:00',1.28),('12664','2013-11-13','13:15:00',1.43),('12664','2013-11-13','13:20:00',1.71),('12664','2013-11-13','13:25:00',1.82),('12664','2013-11-13','13:30:00',1.08),('12664','2013-11-13','13:45:00',1.04),('12664','2013-11-13','13:50:00',1.26),('12664','2013-11-13','13:55:00',1.4),('12664','2013-11-13','14:00:00',1.7),('12664','2013-11-13','14:05:00',2.02),('12664','2013-11-13','14:10:00',2.1),('12664','2013-11-13','14:15:00',1.86),('12664','2013-11-13','14:20:00',1.82),('12664','2013-11-13','14:25:00',1.66),('12664','2013-11-13','14:30:00',1.73),('12664','2013-11-13','14:35:00',1.47),('12664','2013-11-12','11:40:00',2.46),('12664','2013-11-12','11:45:00',1.79),('12664','2013-11-12','12:00:00',1.78),('12664','2013-11-12','12:05:00',3.05),('12664','2013-11-12','12:10:00',1.22),('12664','2013-11-12','12:35:00',2.03),('12664','2013-11-12','12:40:00',2.66),('12664','2013-11-12','12:45:00',2.1),('12664','2013-11-12','12:50:00',1.89),('12664','2013-11-12','12:55:00',1.43),('12664','2013-11-12','13:00:00',1.74),('12664','2013-11-12','13:05:00',1.54),('12664','2013-11-12','13:10:00',1.44),('12664','2013-11-12','13:15:00',1.76),('12664','2013-11-12','13:20:00',2.11),('12664','2013-11-12','13:25:00',1.84),('12664','2013-11-12','13:30:00',1.79),('12664','2013-11-12','13:35:00',2.03),('12664','2013-11-12','13:40:00',1.97),('12664','2013-11-12','13:45:00',2.5),('12664','2013-11-12','13:50:00',2.12),('12664','2013-11-12','13:55:00',1.95),('12664','2013-11-12','14:00:00',1.9),('12664','2013-11-12','14:05:00',1.43),('12664','2013-11-12','14:10:00',1.49),('12664','2013-11-12','14:15:00',3.04),('12664','2013-11-12','14:20:00',3.03),('12664','2013-11-12','14:25:00',2.18),('12664','2013-11-12','14:30:00',1.2),('12664','2013-11-12','14:35:00',1.1),('12664','2013-11-12','14:40:00',1.59),('12664','2013-11-12','14:45:00',2.48),('12664','2013-11-12','14:50:00',2.18),('12664','2013-11-12','14:55:00',1.28),('12664','2013-11-12','15:10:00',1),('12664','2013-11-12','15:15:00',1.04),('12664','2013-11-12','15:20:00',1.41),('12664','2013-11-12','15:25:00',1.52),('12664','2013-11-12','15:30:00',1.19),('12664','2013-11-11','08:55:00',1.24),('12664','2013-11-11','10:55:00',1.51),('12664','2013-11-11','11:00:00',1.28),('12664','2013-11-11','11:05:00',1.01),('12664','2013-11-11','11:15:00',2.7),('12664','2013-11-11','11:20:00',2.39),('12664','2013-11-11','11:25:00',3.71),('12664','2013-11-11','11:30:00',3.44),('12664','2013-11-11','11:35:00',1.06),('12664','2013-11-11','11:40:00',1.76),('12664','2013-11-11','11:45:00',2.11),('12664','2013-11-11','11:50:00',4.29),('12664','2013-11-11','11:55:00',2.25),('12664','2013-11-11','12:05:00',1.75),('12664','2013-11-11','12:10:00',4.07),('12664','2013-11-11','12:15:00',3.34),('12664','2013-11-11','12:20:00',3.41),('12664','2013-11-11','12:25:00',3.88),('12664','2013-11-11','12:30:00',2.97),('12664','2013-11-11','12:35:00',2.7),('12664','2013-11-11','12:40:00',3.63),('12664','2013-11-11','12:45:00',2.14),('12664','2013-11-11','12:50:00',1.26),('12664','2013-11-11','12:55:00',1.53),('12664','2013-11-11','13:00:00',2.54),('12664','2013-11-11','13:05:00',3.3),('12664','2013-11-11','13:10:00',2.43),('12664','2013-11-11','13:15:00',3.2),('12664','2013-11-11','13:20:00',3.12),('12664','2013-11-11','13:25:00',2.18),('12664','2013-11-11','13:30:00',1.37),('12664','2013-11-11','13:50:00',1.21),('12664','2013-11-11','13:55:00',2.3),('12664','2013-11-11','14:00:00',1.26),('12664','2013-11-11','14:05:00',1.14),('12664','2013-11-11','14:10:00',3.04),('12664','2013-11-11','14:15:00',2.84),('12664','2013-11-11','14:20:00',2.62),('12664','2013-11-11','14:25:00',1.56),('12664','2013-11-11','14:30:00',1.57),('12664','2013-11-11','14:35:00',2.25),('12664','2013-11-11','14:40:00',2.18),('12664','2013-11-11','14:45:00',2.13),('12664','2013-11-11','14:50:00',1.89),('12664','2013-11-11','14:55:00',1.6),('12664','2013-11-11','15:00:00',1.42),('12664','2013-11-11','15:05:00',1.24),('12664','2013-11-10','07:45:00',1.09),('12664','2013-11-10','07:55:00',1.32),('12664','2013-11-10','08:00:00',1.1),('12664','2013-11-10','08:10:00',1.01),('12664','2013-11-10','08:15:00',1.43),('12664','2013-11-10','08:20:00',1.3),('12664','2013-11-10','08:25:00',1.62),('12664','2013-11-10','08:30:00',1.06),('12664','2013-11-10','08:35:00',2.04),('12664','2013-11-10','08:40:00',1.57),('12664','2013-11-10','08:45:00',1.62),('12664','2013-11-10','08:50:00',1.32),('12664','2013-11-10','08:55:00',1.6),('12664','2013-11-10','09:00:00',1.59),('12664','2013-11-10','09:05:00',1.35),('12664','2013-11-10','09:10:00',1.75),('12664','2013-11-10','09:15:00',2.16),('12664','2013-11-10','09:20:00',2.2),('12664','2013-11-10','09:25:00',1.29),('12664','2013-11-10','09:30:00',2.21),('12664','2013-11-10','09:35:00',2.48),('12664','2013-11-10','09:40:00',2.52),('12664','2013-11-10','09:45:00',2.65),('12664','2013-11-10','09:50:00',2.66),('12664','2013-11-10','09:55:00',2.42),('12664','2013-11-10','10:00:00',2.64),('12664','2013-11-10','10:05:00',2.71),('12664','2013-11-10','10:10:00',2.08),('12664','2013-11-10','10:15:00',1.56),('12664','2013-11-10','10:20:00',1.88),('12664','2013-11-10','10:25:00',1.76),('12664','2013-11-10','10:30:00',2.06),('12664','2013-11-10','10:35:00',2.78),('12664','2013-11-10','10:40:00',1.82),('12664','2013-11-10','10:45:00',1.82),('12664','2013-11-10','10:50:00',2.63),('12664','2013-11-10','11:10:00',1.52),('12664','2013-11-10','11:15:00',2.42),('12664','2013-11-10','11:20:00',2.08),('12664','2013-11-10','11:25:00',2.02),('12664','2013-11-10','11:30:00',2.83),('12664','2013-11-10','11:35:00',2.42),('12664','2013-11-10','11:40:00',2.08),('12664','2013-11-10','11:45:00',1.84),('12664','2013-11-10','11:50:00',2.82),('12664','2013-11-10','11:55:00',2.54),('12664','2013-11-10','12:00:00',1.28),('12664','2013-11-10','12:05:00',3.41),('12664','2013-11-10','12:10:00',2.09),('12664','2013-11-10','12:15:00',2.96),('12664','2013-11-10','12:20:00',3.34),('12664','2013-11-10','12:25:00',2.51),('12664','2013-11-10','12:30:00',3.32),('12664','2013-11-10','12:35:00',2.98),('12664','2013-11-10','12:40:00',1.04),('12664','2013-11-10','12:50:00',2.03),('12664','2013-11-10','12:55:00',1.49),('12664','2013-11-10','13:00:00',1.2),('12664','2013-11-10','13:05:00',2.41),('12664','2013-11-10','13:10:00',1.73),('12664','2013-11-10','13:25:00',3.04),('12664','2013-11-10','13:30:00',2.82),('12664','2013-11-10','13:35:00',1.21),('12664','2013-11-09','09:05:00',1.14),('12664','2013-11-09','09:10:00',1.33),('12664','2013-11-09','09:15:00',1.28),('12664','2013-11-09','09:20:00',1.4),('12664','2013-11-09','09:25:00',1.73),('12664','2013-11-09','09:30:00',1.69),('12664','2013-11-09','09:35:00',2.32),('12664','2013-11-09','09:40:00',1.89),('12664','2013-11-09','09:45:00',2.17),('12664','2013-11-09','09:50:00',2.04),('12664','2013-11-09','09:55:00',2.95),('12664','2013-11-09','10:00:00',1.68),('12664','2013-11-09','10:10:00',1.4),('12664','2013-11-09','10:15:00',2.12),('12664','2013-11-09','10:20:00',3.07),('12664','2013-11-09','10:25:00',1.1),('12664','2013-11-09','10:30:00',1.22),('12664','2013-11-09','10:35:00',2.59),('12664','2013-11-09','10:40:00',2.06),('12664','2013-11-09','10:50:00',1.15),('12664','2013-11-09','10:55:00',2.69),('12664','2013-11-09','11:00:00',3.14),('12664','2013-11-09','11:05:00',1.17),('12664','2013-11-09','11:10:00',1.09),('12664','2013-11-09','11:15:00',1.09),('12664','2013-11-09','11:20:00',1.89),('12664','2013-11-09','11:25:00',2.34),('12664','2013-11-09','11:30:00',2.28),('12664','2013-11-09','11:35:00',3.77),('12664','2013-11-09','11:40:00',3.84),('12664','2013-11-09','11:45:00',3.25),('12664','2013-11-09','11:50:00',1.7),('12664','2013-11-09','11:55:00',1.8),('12664','2013-11-09','12:00:00',3.85),('12664','2013-11-09','12:05:00',2.02),('12664','2013-11-09','12:10:00',1.28),('12664','2013-11-09','12:30:00',1.05),('12664','2013-11-09','12:35:00',1.12),('12664','2013-11-09','12:40:00',1.18),('12664','2013-11-09','12:45:00',1.24),('12664','2013-11-09','12:50:00',2.78),('12664','2013-11-09','12:55:00',2.75),('12664','2013-11-09','13:00:00',3.39),('12664','2013-11-09','13:05:00',2.46),('12664','2013-11-09','13:10:00',1.84),('12664','2013-11-09','13:15:00',1.7),('12664','2013-11-09','13:20:00',3.01),('12664','2013-11-09','13:25:00',3.21),('12664','2013-11-09','13:30:00',1.85),('12664','2013-11-09','13:35:00',3.77),('12664','2013-11-09','13:40:00',2.35),('12664','2013-11-09','13:45:00',2.07),('12664','2013-11-09','13:50:00',1.24),('12664','2013-11-09','13:55:00',2.34),('12664','2013-11-09','14:15:00',1.03),('12664','2013-11-09','14:20:00',1.03),('12664','2013-11-09','14:30:00',1.75),('12664','2013-11-09','14:35:00',2.12),('12664','2013-11-09','14:40:00',1.59),('12664','2013-11-09','14:45:00',1.42),('12664','2013-11-09','15:20:00',1.54),('12664','2013-11-09','15:25:00',1.19),('12664','2013-11-09','15:35:00',1.07),('12664','2013-11-08','08:55:00',1.29),('12664','2013-11-08','09:10:00',1.95),('12664','2013-11-08','09:15:00',1.67),('12664','2013-11-08','09:20:00',2.09),('12664','2013-11-08','09:25:00',2.05),('12664','2013-11-08','09:30:00',2.45),('12664','2013-11-08','09:35:00',2.56),('12664','2013-11-08','09:40:00',2.5),('12664','2013-11-08','09:45:00',2.54),('12664','2013-11-08','09:50:00',1.59),('12664','2013-11-08','09:55:00',2.8),('12664','2013-11-08','10:00:00',2.06),('12664','2013-11-08','10:05:00',3.02),('12664','2013-11-08','10:10:00',1),('12664','2013-11-08','10:15:00',1.96),('12664','2013-11-08','10:20:00',3.23),('12664','2013-11-08','10:25:00',3.3),('12664','2013-11-08','10:30:00',3.34),('12664','2013-11-08','10:35:00',3.36),('12664','2013-11-08','10:40:00',3.46),('12664','2013-11-08','10:45:00',1.65),('12664','2013-11-08','10:50:00',2.02),('12664','2013-11-08','10:55:00',2.73),('12664','2013-11-08','11:00:00',1.83),('12664','2013-11-08','11:05:00',2),('12664','2013-11-08','11:10:00',3.65),('12664','2013-11-08','11:15:00',2.68),('12664','2013-11-08','11:20:00',3.46),('12664','2013-11-08','11:25:00',3.71),('12664','2013-11-08','11:30:00',3.62),('12664','2013-11-08','11:35:00',2.78),('12664','2013-11-08','11:40:00',1.98),('12664','2013-11-08','11:45:00',2.46),('12664','2013-11-08','11:50:00',2.95),('12664','2013-11-08','11:55:00',3.49),('12664','2013-11-08','12:00:00',3.3),('12664','2013-11-08','12:05:00',3.24),('12664','2013-11-08','12:10:00',3.23),('12664','2013-11-08','12:15:00',3.02),('12664','2013-11-08','12:20:00',3.42),('12664','2013-11-08','12:25:00',2.62),('12664','2013-11-08','12:30:00',3.37),('12664','2013-11-08','12:35:00',3.3),('12664','2013-11-08','12:40:00',3.23),('12664','2013-11-08','12:45:00',3.29),('12664','2013-11-08','12:50:00',2.19),('12664','2013-11-08','12:55:00',3.2),('12664','2013-11-08','13:00:00',3.27),('12664','2013-11-08','13:05:00',3.11),('12664','2013-11-08','13:10:00',3.09),('12664','2013-11-08','13:15:00',2.76),('12664','2013-11-08','13:20:00',2.56),('12664','2013-11-08','13:25:00',3.05),('12664','2013-11-08','13:30:00',2.88),('12664','2013-11-08','13:35:00',2.29),('12664','2013-11-08','13:40:00',2.58),('12664','2013-11-08','13:45:00',2.82),('12664','2013-11-08','13:50:00',2.65),('12664','2013-11-08','13:55:00',2.6),('12664','2013-11-08','14:00:00',2.37),('12664','2013-11-08','14:05:00',2.06),('12664','2013-11-08','14:10:00',2.39),('12664','2013-11-08','14:15:00',1.38),('12664','2013-11-08','14:20:00',1.36),('12664','2013-11-08','14:25:00',2.29),('12664','2013-11-08','14:30:00',2.04),('12664','2013-11-08','14:35:00',2.18),('12664','2013-11-08','14:40:00',2.11),('12664','2013-11-08','14:45:00',1.24),('12664','2013-11-08','14:50:00',1.92),('12664','2013-11-08','14:55:00',1.68),('12664','2013-11-08','15:00:00',1.16),('12664','2013-11-08','15:05:00',1.36),('12664','2013-11-08','15:10:00',1.24),('12664','2013-11-08','15:15:00',1.53),('12664','2013-11-08','15:20:00',1.43),('12664','2013-11-08','15:25:00',1.28),('12664','2013-11-08','15:30:00',1.05),('12664','2013-11-08','15:35:00',1.02),('12664','2013-11-07','07:55:00',1.03),('12664','2013-11-07','08:00:00',1.12),('12664','2013-11-07','08:05:00',1.2),('12664','2013-11-07','08:10:00',1.29),('12664','2013-11-07','08:15:00',1.38),('12664','2013-11-07','08:20:00',1.47),('12664','2013-11-07','08:25:00',1.55),('12664','2013-11-07','08:30:00',1.63),('12664','2013-11-07','08:35:00',1.72),('12664','2013-11-07','08:40:00',1.8),('12664','2013-11-07','08:45:00',1.88),('12664','2013-11-07','08:50:00',1.97),('12664','2013-11-07','08:55:00',2.04),('12664','2013-11-07','09:00:00',2.11),('12664','2013-11-07','09:05:00',2.18),('12664','2013-11-07','09:10:00',2.24),('12664','2013-11-07','09:15:00',2.31),('12664','2013-11-07','09:20:00',2.37),('12664','2013-11-07','09:25:00',2.42),('12664','2013-11-07','09:30:00',2.48),('12664','2013-11-07','09:35:00',2.54),('12664','2013-11-07','09:40:00',2.59),('12664','2013-11-07','09:45:00',2.64),('12664','2013-11-07','09:50:00',2.68),('12664','2013-11-07','09:55:00',2.73),('12664','2013-11-07','10:00:00',2.78),('12664','2013-11-07','10:05:00',2.82),('12664','2013-11-07','10:10:00',2.86),('12664','2013-11-07','10:15:00',2.9),('12664','2013-11-07','10:20:00',2.93),('12664','2013-11-07','10:25:00',2.96),('12664','2013-11-07','10:30:00',2.99),('12664','2013-11-07','10:35:00',3.01),('12664','2013-11-07','10:40:00',3.02),('12664','2013-11-07','10:45:00',3.04),('12664','2013-11-07','10:50:00',3.05),('12664','2013-11-07','10:55:00',3.07),('12664','2013-11-07','11:00:00',3.06),('12664','2013-11-07','11:05:00',3.07),('12664','2013-11-07','11:10:00',3.08),('12664','2013-11-07','11:15:00',3.08),('12664','2013-11-07','11:20:00',3.11),('12664','2013-11-07','11:25:00',3.13),('12664','2013-11-07','11:30:00',3.14),('12664','2013-11-07','11:35:00',3.16),('12664','2013-11-07','11:40:00',3.13),('12664','2013-11-07','11:45:00',3.06),('12664','2013-11-07','11:50:00',3.09),('12664','2013-11-07','11:55:00',2.51),('12664','2013-11-07','12:00:00',2.17),('12664','2013-11-07','12:05:00',3.34),('12664','2013-11-07','12:10:00',3.28),('12664','2013-11-07','12:15:00',1.16),('12664','2013-11-07','12:20:00',2.12),('12664','2013-11-07','12:25:00',3.78),('12664','2013-11-07','12:30:00',1.94),('12664','2013-11-07','12:35:00',1.65),('12664','2013-11-07','12:40:00',3.56),('12664','2013-11-07','12:45:00',3.41),('12664','2013-11-07','12:50:00',3.19),('12664','2013-11-07','12:55:00',2.79),('12664','2013-11-07','13:00:00',2.33),('12664','2013-11-07','13:05:00',1.61),('12664','2013-11-07','13:10:00',2.29),('12664','2013-11-07','13:15:00',3.15),('12664','2013-11-07','13:20:00',2.88),('12664','2013-11-07','13:25:00',2.83),('12664','2013-11-07','13:30:00',2.77),('12664','2013-11-07','13:35:00',2.72),('12664','2013-11-07','13:40:00',2.72),('12664','2013-11-07','13:45:00',2.69),('12664','2013-11-07','13:50:00',2.61),('12664','2013-11-07','13:55:00',2.59),('12664','2013-11-07','14:00:00',2.4),('12664','2013-11-07','14:05:00',2.52),('12664','2013-11-07','14:10:00',1.82),('12664','2013-11-07','14:15:00',2.35),('12664','2013-11-07','14:20:00',2.22),('12664','2013-11-07','14:25:00',2.23),('12664','2013-11-07','14:30:00',2.17),('12664','2013-11-07','14:35:00',2.08),('12664','2013-11-07','14:40:00',2),('12664','2013-11-07','14:45:00',1.92),('12664','2013-11-07','14:50:00',1.85),('12664','2013-11-07','14:55:00',1.73),('12664','2013-11-07','15:00:00',1.69),('12664','2013-11-07','15:05:00',1.6),('12664','2013-11-07','15:10:00',1.52),('12664','2013-11-07','15:15:00',1.43),('12664','2013-11-07','15:20:00',1.34),('12664','2013-11-07','15:25:00',1.25),('12664','2013-11-07','15:30:00',1.15),('12664','2013-11-07','15:35:00',1.06),('12664','2014-04-17','08:00:00',1),('12664','2014-04-17','08:05:00',1),('12664','2014-04-17','08:15:00',1.2),('12664','2014-04-17','08:20:00',1.41),('12664','2014-04-17','08:25:00',1.49),('12664','2014-04-17','08:30:00',1.6),('12664','2014-04-17','08:35:00',1.69),('12664','2014-04-17','08:40:00',1.79),('12664','2014-04-17','08:45:00',1.9),('12664','2014-04-17','08:50:00',1.99),('12664','2014-04-17','08:55:00',2.1),('12664','2014-04-17','09:00:00',2.21),('12664','2014-04-17','09:05:00',2.3),('12664','2014-04-17','09:10:00',2.39),('12664','2014-04-17','09:15:00',2.48),('12664','2014-04-17','09:20:00',2.56),('12664','2014-04-17','09:25:00',2.66),('12664','2014-04-17','09:30:00',2.73),('12664','2014-04-17','09:35:00',2.8),('12664','2014-04-17','09:40:00',2.88),('12664','2014-04-17','09:45:00',2.95),('12664','2014-04-17','09:50:00',3.05),('12664','2014-04-17','09:55:00',3.14),('12664','2014-04-17','10:00:00',3.26),('12664','2014-04-17','10:05:00',2.92),('12664','2014-04-17','10:10:00',2.85),('12664','2014-04-17','10:15:00',2.65),('12664','2014-04-17','10:20:00',2.87),('12664','2014-04-17','10:25:00',1.93),('12664','2014-04-17','10:30:00',3.62),('12664','2014-04-17','10:35:00',3.38),('12664','2014-04-17','10:40:00',2.49),('12664','2014-04-17','10:45:00',2.92),('12664','2014-04-17','10:50:00',2.36),('12664','2014-04-17','10:55:00',2.08),('12664','2014-04-17','11:00:00',2.86),('12664','2014-04-17','11:05:00',2.49),('12664','2014-04-17','11:10:00',2.57),('12664','2014-04-17','11:15:00',3.32),('12664','2014-04-17','11:20:00',1.96),('12664','2014-04-17','11:25:00',3.03),('12664','2014-04-17','11:30:00',2.08),('12664','2014-04-17','11:35:00',3.4),('12664','2014-04-17','11:40:00',3.61),('12664','2014-04-17','11:45:00',2.52),('12664','2014-04-17','11:50:00',2.22),('12664','2014-04-17','11:55:00',2.02),('12664','2014-04-17','12:00:00',2.44),('12664','2014-04-17','12:05:00',2.05),('12664','2014-04-17','12:10:00',2.54),('12664','2014-04-17','12:15:00',2.59),('12664','2014-04-17','12:20:00',3.59),('12664','2014-04-17','12:25:00',3.74),('12664','2014-04-17','12:30:00',3.92),('12664','2014-04-17','12:35:00',4.22),('12664','2014-04-17','12:40:00',4.34),('12664','2014-04-17','12:45:00',4.4),('12664','2014-04-17','12:50:00',4.39),('12664','2014-04-17','12:55:00',4.41),('12664','2014-04-17','13:00:00',4.38),('12664','2014-04-17','13:05:00',4.35),('12664','2014-04-17','13:10:00',4.34),('12664','2014-04-17','13:15:00',3.87),('12664','2014-04-17','13:20:00',3.95),('12664','2014-04-17','13:25:00',3.08),('12664','2014-04-17','13:30:00',2.18),('12664','2014-04-17','13:35:00',4.71),('12664','2014-04-17','13:40:00',4.84),('12664','2014-04-17','13:45:00',3.7),('12664','2014-04-17','13:50:00',4.76),('12664','2014-04-17','13:55:00',4.58),('12664','2014-04-17','14:00:00',4.52),('12664','2014-04-17','14:05:00',3.91),('12664','2014-04-17','14:10:00',2.87),('12664','2014-04-17','14:15:00',2.8),('12664','2014-04-17','14:20:00',1.8),('12664','2014-04-17','14:25:00',1.69),('12664','2014-04-17','14:30:00',1.68),('12664','2014-04-17','14:35:00',2.39),('12664','2014-04-17','14:40:00',3.42),('12664','2014-04-17','14:45:00',3.43),('12664','2014-04-17','14:50:00',1.61),('12664','2014-04-17','14:55:00',1.36),('12664','2014-04-17','15:00:00',1.12),('12664','2014-04-17','15:05:00',1.21),('12664','2014-04-17','15:10:00',1.33),('12664','2014-04-17','15:15:00',1.12),('12664','2014-04-17','15:20:00',1.03),('12664','2014-04-17','15:50:00',1.1),('12664','2014-04-17','16:35:00',1.04),('12664','2014-04-17','16:40:00',1.33),('12664','2014-04-17','16:45:00',1.54),('12664','2014-04-17','16:50:00',1.52),('12664','2014-04-17','16:55:00',1.2),('12664','2014-04-17','17:15:00',1.04),('12664','2014-04-17','17:20:00',1.3),('12664','2014-04-17','17:25:00',1.59),('12664','2014-04-17','17:30:00',1.48),('12664','2014-04-17','17:35:00',1.37),('12664','2014-04-17','17:40:00',1.22),('12664','2013-11-06','08:10:00',1.42),('12664','2013-11-06','08:15:00',1.56),('12664','2013-11-06','08:30:00',1.28),('12664','2013-11-06','08:35:00',1.85),('12664','2013-11-06','08:40:00',1.92),('12664','2013-11-06','08:45:00',1.99),('12664','2013-11-06','08:50:00',2.13),('12664','2013-11-06','08:55:00',1.57),('12664','2013-11-06','09:00:00',1.56),('12664','2013-11-06','09:05:00',1.69),('12664','2013-11-06','09:10:00',2.49),('12664','2013-11-06','09:15:00',2.35),('12664','2013-11-06','09:20:00',2.52),('12664','2013-11-06','09:25:00',2.55),('12664','2013-11-06','09:30:00',2.6),('12664','2013-11-06','09:35:00',2.65),('12664','2013-11-06','09:40:00',2.7),('12664','2013-11-06','09:45:00',2.74),('12664','2013-11-06','09:50:00',2.79),('12664','2013-11-06','09:55:00',2.82),('12664','2013-11-06','10:00:00',2.86),('12664','2013-11-06','10:05:00',2.89),('12664','2013-11-06','10:10:00',2.93),('12664','2013-11-06','10:15:00',2.95),('12664','2013-11-06','10:20:00',2.99),('12664','2013-11-06','10:25:00',3.04),('12664','2013-11-06','10:30:00',3.06),('12664','2013-11-06','10:35:00',3.09),('12664','2013-11-06','10:40:00',3.13),('12664','2013-11-06','10:45:00',3.15),('12664','2013-11-06','10:50:00',3.17),('12664','2013-11-06','10:55:00',3.19),('12664','2013-11-06','11:00:00',3.22),('12664','2013-11-06','11:05:00',3.24),('12664','2013-11-06','11:10:00',3.25),('12664','2013-11-06','11:15:00',3.25),('12664','2013-11-06','11:20:00',3.26),('12664','2013-11-06','11:25:00',3.28),('12664','2013-11-06','11:30:00',3.29),('12664','2013-11-06','11:35:00',3.3),('12664','2013-11-06','11:40:00',3.31),('12664','2013-11-06','11:45:00',3.31),('12664','2013-11-06','11:50:00',3.3),('12664','2013-11-06','11:55:00',3.29),('12664','2013-11-06','12:00:00',3.31),('12664','2013-11-06','12:05:00',3.32),('12664','2013-11-06','12:10:00',3.33),('12664','2013-11-06','12:15:00',3.31),('12664','2013-11-06','12:20:00',3.3),('12664','2013-11-06','12:25:00',3.26),('12664','2013-11-06','12:30:00',3.26),('12664','2013-11-06','12:35:00',3.22),('12664','2013-11-06','12:40:00',3.2),('12664','2013-11-06','12:45:00',3.16),('12664','2013-11-06','12:50:00',3.13),('12664','2013-11-06','12:55:00',3.09),('12664','2013-11-06','13:00:00',3.07),('12664','2013-11-06','13:05:00',3.07),('12664','2013-11-06','13:10:00',3.05),('12664','2013-11-06','13:15:00',3.01),('12664','2013-11-06','13:20:00',2.97),('12664','2013-11-06','13:25:00',2.92),('12664','2013-11-06','13:30:00',2.86),('12664','2013-11-06','13:35:00',2.81),('12664','2013-11-06','13:40:00',2.76),('12664','2013-11-06','13:45:00',2.73),('12664','2013-11-06','13:50:00',2.68),('12664','2013-11-06','13:55:00',2.64),('12664','2013-11-06','14:00:00',2.59),('12664','2013-11-06','14:05:00',2.53),('12664','2013-11-06','14:10:00',2.47),('12664','2013-11-06','14:15:00',2.42),('12664','2013-11-06','14:20:00',2.35),('12664','2013-11-06','14:25:00',2.28),('12664','2013-11-06','14:30:00',2.22),('12664','2013-11-06','14:35:00',2.14),('12664','2013-11-06','14:40:00',2.05),('12664','2013-11-06','14:45:00',1.98),('12664','2013-11-06','14:50:00',1.89),('12664','2013-11-06','14:55:00',1.79),('12664','2013-11-06','15:00:00',1.72),('12664','2013-11-06','15:05:00',1.63),('12664','2013-11-06','15:10:00',1.54),('12664','2013-11-06','15:15:00',1.46),('12664','2013-11-06','15:20:00',1.39),('12664','2013-11-06','15:25:00',1.29),('12664','2013-11-06','15:30:00',1.2),('12664','2013-11-06','15:35:00',1.12),('12664','2013-11-06','15:40:00',1.04),('12664','2013-11-05','10:20:00',1),('12664','2013-11-05','10:30:00',1.08),('12664','2013-11-05','10:35:00',1.06),('12664','2013-11-05','10:40:00',1.27),('12664','2013-11-05','10:45:00',1.21),('12664','2013-11-05','11:30:00',1.03),('12664','2013-11-05','11:35:00',1.35),('12664','2013-11-05','11:40:00',1.36),('12664','2013-11-05','11:45:00',1.1),('12664','2013-11-05','12:20:00',1.03),('12664','2013-11-05','12:25:00',1.19),('12664','2013-11-05','12:30:00',1.01),('12664','2013-11-05','12:35:00',1.05),('12664','2013-11-05','13:05:00',1.14),('12664','2013-11-05','13:10:00',1.25),('12664','2013-11-05','13:15:00',1.38),('12664','2013-11-05','13:20:00',1.55),('12664','2013-11-05','13:25:00',1.42),('12664','2013-11-05','13:30:00',1.61),('12664','2013-11-05','13:35:00',2.13),('12664','2013-11-05','13:40:00',2.15),('12664','2013-11-05','13:45:00',2.01),('12664','2013-11-05','13:50:00',2.41),('12664','2013-11-05','13:55:00',2.35),('12664','2013-11-05','14:00:00',2.25),('12664','2013-11-05','14:05:00',1.94),('12664','2013-11-05','14:10:00',2.65),('12664','2013-11-05','14:15:00',3.16),('12664','2013-11-05','14:20:00',2.83),('12664','2013-11-05','14:25:00',2.46),('12664','2013-11-05','14:30:00',1.86),('12664','2013-11-05','14:35:00',2.02),('12664','2013-11-05','14:40:00',2.16),('12664','2013-11-05','14:45:00',1.62),('12664','2013-11-05','14:50:00',1.44),('12664','2013-11-05','15:25:00',1.18),('12664','2013-11-05','15:30:00',1.41),('12664','2013-11-05','15:35:00',1.22),('12664','2013-11-05','15:40:00',1.12),('12664','2013-11-05','15:45:00',1.06),('12664','2013-11-04','08:00:00',1.1),('12664','2013-11-04','08:05:00',1.18),('12664','2013-11-04','08:10:00',1.28),('12664','2013-11-04','08:15:00',1.37),('12664','2013-11-04','08:20:00',1.47),('12664','2013-11-04','08:25:00',1.59),('12664','2013-11-04','08:30:00',1.68),('12664','2013-11-04','08:35:00',1.22),('12664','2013-11-04','08:40:00',1.38),('12664','2013-11-04','08:45:00',1.86),('12664','2013-11-04','08:50:00',2.04),('12664','2013-11-04','08:55:00',2.11),('12664','2013-11-04','09:00:00',2.32),('12664','2013-11-04','09:05:00',2.46),('12664','2013-11-04','09:10:00',2.64),('12664','2013-11-04','09:15:00',2.66),('12664','2013-11-04','09:20:00',2.71),('12664','2013-11-04','09:25:00',2.7),('12664','2013-11-04','09:30:00',2.66),('12664','2013-11-04','09:35:00',2.76),('12664','2013-11-04','09:40:00',2.61),('12664','2013-11-04','09:45:00',2.81),('12664','2013-11-04','09:50:00',2.36),('12664','2013-11-04','09:55:00',3.04),('12664','2013-11-04','10:00:00',3.07),('12664','2013-11-04','10:05:00',2.99),('12664','2013-11-04','10:10:00',3.06),('12664','2013-11-04','10:15:00',1.19),('12664','2013-11-04','10:20:00',1.99),('12664','2013-11-04','10:35:00',2.4),('12664','2013-11-04','10:40:00',3.49),('12664','2013-11-04','10:45:00',3.56),('12664','2013-11-04','10:50:00',3.31),('12664','2013-11-04','10:55:00',1.88),('12664','2013-11-04','11:05:00',1.53),('12664','2013-11-04','11:10:00',3.67),('12664','2013-11-04','11:15:00',3.52),('12664','2013-11-04','11:20:00',3.62),('12664','2013-11-04','11:25:00',1.89),('12664','2013-11-04','11:40:00',1.71),('12664','2013-11-04','11:45:00',3.91),('12664','2013-11-04','11:50:00',3.77),('12664','2013-11-04','11:55:00',3.61),('12664','2013-11-04','12:00:00',3.49),('12664','2013-11-04','12:05:00',3.65),('12664','2013-11-04','12:10:00',3.54),('12664','2013-11-04','12:15:00',3.39),('12664','2013-11-04','12:20:00',3.49),('12664','2013-11-04','12:25:00',3.46),('12664','2013-11-04','12:30:00',3.5),('12664','2013-11-04','12:35:00',3.54),('12664','2013-11-04','12:40:00',3.22),('12664','2013-11-04','12:45:00',1.97),('12664','2013-11-04','12:50:00',3.6),('12664','2013-11-04','12:55:00',3.2),('12664','2013-11-04','13:00:00',2.5),('12664','2013-11-04','13:05:00',3.49),('12664','2013-11-04','13:10:00',3.25),('12664','2013-11-04','13:15:00',3.41),('12664','2013-11-04','13:20:00',1.95),('12664','2013-11-04','13:25:00',2.64),('12664','2013-11-04','13:30:00',1.13),('12664','2013-11-04','13:35:00',2.8),('12664','2013-11-04','13:40:00',2.68),('12664','2013-11-04','13:45:00',2.32),('12664','2013-11-04','13:50:00',1.3),('12664','2013-11-04','13:55:00',1.77),('12664','2013-11-04','14:05:00',2.37),('12664','2013-11-04','14:25:00',1.07),('12664','2013-11-04','14:30:00',1.42),('12664','2013-11-04','14:35:00',1.87),('12664','2013-11-04','14:40:00',1.53),('12664','2013-11-04','14:55:00',2.18),('12664','2013-11-04','15:00:00',1.25),('12664','2013-11-04','15:05:00',1.08),('12664','2013-11-04','15:10:00',1.46),('12664','2013-11-04','15:15:00',1.11),('12664','2013-11-04','15:20:00',1.38),('12664','2013-11-04','15:25:00',1.21),('12664','2013-11-04','15:30:00',1.09),('12664','2013-11-03','08:15:00',1.06),('12664','2013-11-03','08:20:00',1.03),('12664','2013-11-03','08:25:00',1.2),('12664','2013-11-03','08:30:00',1.66),('12664','2013-11-03','08:35:00',1.76),('12664','2013-11-03','08:40:00',2.02),('12664','2013-11-03','08:45:00',2.03),('12664','2013-11-03','08:50:00',1.55),('12664','2013-11-03','09:00:00',1.45),('12664','2013-11-03','09:05:00',1.6),('12664','2013-11-03','09:10:00',1.65),('12664','2013-11-03','09:15:00',1.84),('12664','2013-11-03','09:20:00',1.75),('12664','2013-11-03','09:25:00',2.01),('12664','2013-11-03','09:30:00',2.28),('12664','2013-11-03','09:35:00',1.81),('12664','2013-11-03','09:50:00',2.5),('12664','2013-11-03','09:55:00',2.64),('12664','2013-11-03','10:00:00',2.35),('12664','2013-11-03','10:05:00',2.85),('12664','2013-11-03','10:10:00',2.92),('12664','2013-11-03','10:15:00',2.9),('12664','2013-11-03','10:20:00',2.97),('12664','2013-11-03','10:25:00',2.65),('12664','2013-11-03','10:30:00',1.32),('12664','2013-11-03','10:40:00',1.33),('12664','2013-11-03','11:00:00',1.1),('12664','2013-11-03','11:05:00',3.15),('12664','2013-11-03','11:10:00',3.22),('12664','2013-11-03','11:15:00',3.47),('12664','2013-11-03','11:20:00',3.34),('12664','2013-11-03','11:25:00',1.62),('12664','2013-11-03','11:30:00',2.42),('12664','2013-11-03','11:35:00',2.37),('12664','2013-11-03','11:40:00',3.51),('12664','2013-11-03','11:45:00',2.38),('12664','2013-11-03','11:50:00',1.1),('12664','2013-11-03','11:55:00',1.66),('12664','2013-11-03','12:00:00',1.42),('12664','2013-11-03','12:05:00',3.34),('12664','2013-11-03','12:10:00',3.71),('12664','2013-11-03','12:15:00',3.36),('12664','2013-11-03','12:20:00',2.04),('12664','2013-11-03','12:55:00',1.07),('12664','2013-11-03','13:00:00',1.08),('12664','2013-11-03','13:05:00',1.06),('12664','2013-11-03','13:10:00',1.2),('12664','2013-11-03','13:15:00',1.09),('12664','2013-11-03','13:20:00',1.1),('12664','2013-11-03','13:55:00',1.01),('12664','2013-11-03','14:00:00',2.45),('12664','2013-11-03','14:05:00',1.33),('12664','2013-11-03','14:15:00',1.27),('12664','2013-11-03','14:20:00',2.74),('12664','2013-11-03','14:25:00',1.71),('12664','2013-11-03','14:30:00',2.01),('12664','2013-11-03','14:35:00',1.7),('12664','2013-11-03','14:40:00',1.77),('12664','2013-11-03','14:50:00',1.52),('12664','2013-11-03','14:55:00',1.07),('12664','2013-11-02','08:00:00',1.02),('12664','2013-11-02','08:05:00',1.11),('12664','2013-11-02','08:10:00',1.21),('12664','2013-11-02','08:15:00',1.3),('12664','2013-11-02','08:20:00',1.4),('12664','2013-11-02','08:25:00',1.49),('12664','2013-11-02','08:30:00',1.57),('12664','2013-11-02','08:35:00',1.66),('12664','2013-11-02','08:40:00',1.75),('12664','2013-11-02','08:45:00',1.86),('12664','2013-11-02','08:50:00',2.15),('12664','2013-11-02','08:55:00',2.38),('12664','2013-11-02','09:00:00',2.02),('12664','2013-11-02','09:05:00',2.35),('12664','2013-11-02','09:10:00',2.01),('12664','2013-11-02','09:15:00',2.08),('12664','2013-11-02','09:20:00',2.08),('12664','2013-11-02','09:25:00',2.44),('12664','2013-11-02','09:30:00',2.47),('12664','2013-11-02','09:35:00',2.64),('12664','2013-11-02','09:40:00',2.83),('12664','2013-11-02','09:45:00',1.25),('12664','2013-11-02','09:50:00',1.94),('12664','2013-11-02','09:55:00',3),('12664','2013-11-02','10:00:00',1.78),('12664','2013-11-02','10:05:00',1.53),('12664','2013-11-02','10:50:00',1.17),('12664','2013-11-02','10:55:00',1.36),('12664','2013-11-02','11:00:00',1.62),('12664','2013-11-02','11:05:00',2.2),('12664','2013-11-02','11:10:00',4.1),('12664','2013-11-02','11:15:00',3.7),('12664','2013-11-02','11:20:00',2.94),('12664','2013-11-02','11:25:00',2.19),('12664','2013-11-02','11:30:00',2.72),('12664','2013-11-02','11:35:00',3.8),('12664','2013-11-02','11:40:00',3.74),('12664','2013-11-02','11:45:00',3.18),('12664','2013-11-02','11:50:00',3.48),('12664','2013-11-02','11:55:00',3.32),('12664','2013-11-02','12:00:00',1.73),('12664','2013-11-02','12:05:00',1.64),('12664','2013-11-02','12:10:00',1.67),('12664','2013-11-02','12:15:00',1.17),('12664','2013-11-02','12:25:00',1.26),('12664','2013-11-02','12:30:00',1.49),('12664','2013-11-02','12:35:00',2.74),('12664','2013-11-02','12:40:00',1.84),('12664','2013-11-02','12:45:00',1.04),('12664','2013-11-02','12:55:00',2.77),('12664','2013-11-02','13:00:00',3.21),('12664','2013-11-02','13:05:00',2.97),('12664','2013-11-02','13:10:00',2.06),('12664','2013-11-02','13:30:00',1.67),('12664','2013-11-02','13:35:00',1.92),('12664','2013-11-02','13:40:00',2.13),('12664','2013-11-02','13:45:00',2.78),('12664','2013-11-02','13:50:00',3.27),('12664','2013-11-02','13:55:00',2.79),('12664','2013-11-02','14:00:00',2.7),('12664','2013-11-02','14:05:00',2.54),('12664','2013-11-02','14:10:00',2.44),('12664','2013-11-02','14:15:00',2.4),('12664','2013-11-02','14:20:00',2.33),('12664','2013-11-02','14:25:00',2.25),('12664','2013-11-02','14:30:00',2.19),('12664','2013-11-02','14:35:00',2.14),('12664','2013-11-02','14:40:00',2.04),('12664','2013-11-02','14:45:00',1.96),('12664','2013-11-02','14:50:00',1.97),('12664','2013-11-02','14:55:00',1.82),('12664','2013-11-02','15:00:00',1.87),('12664','2013-11-02','15:05:00',1.65),('12664','2013-11-02','15:10:00',1.15),('12664','2013-11-02','15:20:00',1.47),('12664','2013-11-02','15:45:00',1.2),('12664','2013-11-02','15:50:00',1.09),('12664','2013-11-01','08:20:00',1.16),('12664','2013-11-01','08:25:00',1.33),('12664','2013-11-01','08:30:00',1.51),('12664','2013-11-01','08:35:00',1.55),('12664','2013-11-01','08:40:00',1.44),('12664','2013-11-01','08:45:00',1.3),('12664','2013-11-01','08:50:00',1.4),('12664','2013-11-01','08:55:00',1.7),('12664','2013-11-01','09:00:00',2.04),('12664','2013-11-01','09:05:00',2.1),('12664','2013-11-01','09:10:00',2.15),('12664','2013-11-01','09:15:00',2.21),('12664','2013-11-01','09:20:00',2.27),('12664','2013-11-01','09:25:00',2.35),('12664','2013-11-01','09:30:00',2.41),('12664','2013-11-01','09:35:00',2.47),('12664','2013-11-01','09:40:00',2.53),('12664','2013-11-01','09:45:00',2.58),('12664','2013-11-01','09:50:00',2.64),('12664','2013-11-01','09:55:00',2.69),('12664','2013-11-01','10:00:00',2.75),('12664','2013-11-01','10:05:00',2.82),('12664','2013-11-01','10:10:00',2.88),('12664','2013-11-01','10:15:00',2.92),('12664','2013-11-01','10:20:00',2.94),('12664','2013-11-01','10:25:00',3),('12664','2013-11-01','10:30:00',3.08),('12664','2013-11-01','10:35:00',3.12),('12664','2013-11-01','10:40:00',3.17),('12664','2013-11-01','10:45:00',3.14),('12664','2013-11-01','10:50:00',3.11),('12664','2013-11-01','10:55:00',3.24),('12664','2013-11-01','11:00:00',3.23),('12664','2013-11-01','11:05:00',3.17),('12664','2013-11-01','11:10:00',2.57),('12664','2013-11-01','11:15:00',2.6),('12664','2013-11-01','11:20:00',2.64),('12664','2013-11-01','11:25:00',3.09),('12664','2013-11-01','11:30:00',3.11),('12664','2013-11-01','11:35:00',2.65),('12664','2013-11-01','11:40:00',2.73),('12664','2013-11-01','11:45:00',2.84),('12664','2013-11-01','11:50:00',3.21),('12664','2013-11-01','11:55:00',3.35),('12664','2013-11-01','12:00:00',3.29),('12664','2013-11-01','12:05:00',2.74),('12664','2013-11-01','12:10:00',2.71),('12664','2013-11-01','12:15:00',2.55),('12664','2013-11-01','12:20:00',3.13),('12664','2013-11-01','12:25:00',3.33),('12664','2013-11-01','12:30:00',2.93),('12664','2013-11-01','12:35:00',1.41),('12664','2013-11-01','12:50:00',2.01),('12664','2013-11-01','12:55:00',2.3),('12664','2013-11-01','13:00:00',2.1),('12664','2013-11-01','13:05:00',1.77),('12664','2013-11-01','13:10:00',1.49),('12664','2013-11-01','13:15:00',1.57),('12664','2013-11-01','13:20:00',1.74),('12664','2013-11-01','13:25:00',1.35),('12664','2013-11-01','13:30:00',1.12),('12664','2013-11-01','13:35:00',1.15),('12664','2013-11-01','13:40:00',1.05),('12664','2013-11-01','14:00:00',1.5),('12664','2013-11-01','14:05:00',1.53),('12664','2013-10-31','08:20:00',1.14),('12664','2013-10-31','08:25:00',1.38),('12664','2013-10-31','08:30:00',1.66),('12664','2013-10-31','08:35:00',1.69),('12664','2013-10-31','08:40:00',1.18),('12664','2013-10-31','08:55:00',1.06),('12664','2013-10-31','09:10:00',2.07),('12664','2013-10-31','09:15:00',2.16),('12664','2013-10-31','09:20:00',1.91),('12664','2013-10-31','09:25:00',1.9),('12664','2013-10-31','09:30:00',2.1),('12664','2013-10-31','09:35:00',2.2),('12664','2013-10-31','09:40:00',2.18),('12664','2013-10-31','09:45:00',2.13),('12664','2013-10-31','09:50:00',2.25),('12664','2013-10-31','09:55:00',2.36),('12664','2013-10-31','10:00:00',2.44),('12664','2013-10-31','10:05:00',2.49),('12664','2013-10-31','10:10:00',2.55),('12664','2013-10-31','10:15:00',2.55),('12664','2013-10-31','10:20:00',2.39),('12664','2013-10-31','10:25:00',2.25),('12664','2013-10-31','10:30:00',2.52),('12664','2013-10-31','10:35:00',2.99),('12664','2013-10-31','10:40:00',3.12),('12664','2013-10-31','10:45:00',3.11),('12664','2013-10-31','10:50:00',2.81),('12664','2013-10-31','10:55:00',2.51),('12664','2013-10-31','11:00:00',2.35),('12664','2013-10-31','11:05:00',2.51),('12664','2013-10-31','11:10:00',2.73),('12664','2013-10-31','11:15:00',2.79),('12664','2013-10-31','11:20:00',2.81),('12664','2013-10-31','11:25:00',2.76),('12664','2013-10-31','11:30:00',2.64),('12664','2013-10-31','11:35:00',2.54),('12664','2013-10-31','11:40:00',2.57),('12664','2013-10-31','11:45:00',2.39),('12664','2013-10-31','11:50:00',3.02),('12664','2013-10-31','11:55:00',3.12),('12664','2013-10-31','12:00:00',3.24),('12664','2013-10-31','12:05:00',3.19),('12664','2013-10-31','12:10:00',3.16),('12664','2013-10-31','12:15:00',3.16),('12664','2013-10-31','12:20:00',3.16),('12664','2013-10-31','12:25:00',3.11),('12664','2013-10-31','12:30:00',3.05),('12664','2013-10-31','12:35:00',3.02),('12664','2013-10-31','12:40:00',2.9),('12664','2013-10-31','12:45:00',2.91),('12664','2013-10-31','12:50:00',2.97),('12664','2013-10-31','12:55:00',2.95),('12664','2013-10-31','13:00:00',2.95),('12664','2013-10-31','13:05:00',2.95),('12664','2013-10-31','13:10:00',2.9),('12664','2013-10-31','13:15:00',2.83),('12664','2013-10-31','13:20:00',2.77),('12664','2013-10-31','13:25:00',2.68),('12664','2013-10-31','13:30:00',2.61),('12664','2013-10-31','13:35:00',2.59),('12664','2013-10-31','13:40:00',2.6),('12664','2013-10-31','13:45:00',2.62),('12664','2013-10-31','13:50:00',2.56),('12664','2013-10-31','13:55:00',2.51),('12664','2013-10-31','14:00:00',2.35),('12664','2013-10-31','14:05:00',2.03),('12664','2013-10-31','14:10:00',2.31),('12664','2013-10-31','14:15:00',2.26),('12664','2013-10-31','14:20:00',2.15),('12664','2013-10-31','14:25:00',1.81),('12664','2013-10-31','14:30:00',1.98),('12664','2013-10-31','14:35:00',1.86),('12664','2013-10-31','14:40:00',1.77),('12664','2013-10-31','14:45:00',1.7),('12664','2013-10-31','14:50:00',1.65),('12664','2013-10-31','14:55:00',1.63),('12664','2013-10-31','15:00:00',1.5),('12664','2013-10-31','15:05:00',1.34),('12664','2013-10-31','15:10:00',1.23),('12664','2013-10-31','15:15:00',1.18),('12664','2013-10-31','15:20:00',1.11),('12664','2013-10-31','15:25:00',1.06),('12664','2013-10-30','08:05:00',1.03),('12664','2013-10-30','08:10:00',1.1),('12664','2013-10-30','08:15:00',1.18),('12664','2013-10-30','08:20:00',1.28),('12664','2013-10-30','08:25:00',1.33),('12664','2013-10-30','08:30:00',1.41),('12664','2013-10-30','08:35:00',1.53),('12664','2013-10-30','08:40:00',1.56),('12664','2013-10-30','08:45:00',1.62),('12664','2013-10-30','08:50:00',1.66),('12664','2013-10-30','08:55:00',1.84),('12664','2013-10-30','09:00:00',1.9),('12664','2013-10-30','09:05:00',2.02),('12664','2013-10-30','09:10:00',2.1),('12664','2013-10-30','09:15:00',2.16),('12664','2013-10-30','09:20:00',2.18),('12664','2013-10-30','09:25:00',2.12),('12664','2013-10-30','09:30:00',1.96),('12664','2013-10-30','09:35:00',2.06),('12664','2013-10-30','09:40:00',2.34),('12664','2013-10-30','09:45:00',2.43),('12664','2013-10-30','09:50:00',2.26),('12664','2013-10-30','09:55:00',2.5),('12664','2013-10-30','10:00:00',2.4),('12664','2013-10-30','10:05:00',2.53),('12664','2013-10-30','10:10:00',2.29),('12664','2013-10-30','10:15:00',1.48),('12664','2013-10-30','10:20:00',1.26),('12664','2013-10-30','10:25:00',1.55),('12664','2013-10-30','10:30:00',2.7),('12664','2013-10-30','10:35:00',2.08),('12664','2013-10-30','10:40:00',2.82),('12664','2013-10-30','10:45:00',2.73),('12664','2013-10-30','10:50:00',2.77),('12664','2013-10-30','10:55:00',2.44),('12664','2013-10-30','11:00:00',2),('12664','2013-10-30','11:05:00',1.33),('12664','2013-10-30','11:10:00',2.39),('12664','2013-10-30','11:15:00',2.54),('12664','2013-10-30','11:20:00',2.99),('12664','2013-10-30','11:25:00',2.48),('12664','2013-10-30','11:30:00',1.74),('12664','2013-10-30','11:35:00',2.07),('12664','2013-10-30','11:40:00',1.53),('12664','2013-10-30','11:45:00',2.58),('12664','2013-10-30','11:50:00',3.07),('12664','2013-10-30','11:55:00',3.12),('12664','2013-10-30','12:00:00',2.77),('12664','2013-10-30','12:05:00',2.24),('12664','2013-10-30','12:10:00',1.24),('12664','2013-10-30','12:15:00',1.33),('12664','2013-10-30','12:20:00',1.39),('12664','2013-10-30','12:25:00',2.71),('12664','2013-10-30','12:30:00',1.91),('12664','2013-10-30','12:35:00',1.22),('12664','2013-10-30','12:40:00',2.96),('12664','2013-10-30','12:45:00',2.93),('12664','2013-10-30','12:50:00',2.86),('12664','2013-10-30','12:55:00',2.09),('12664','2013-10-30','13:10:00',1.88),('12664','2013-10-30','13:15:00',2.84),('12664','2013-10-30','13:20:00',2.96),('12664','2013-10-30','13:25:00',2.91),('12664','2013-10-30','13:30:00',2.73),('12664','2013-10-30','13:35:00',1.22),('12664','2013-10-30','13:45:00',2.35),('12664','2013-10-30','13:50:00',1.88),('12664','2013-10-30','14:25:00',1.33),('12664','2013-10-30','14:30:00',1.53),('12664','2013-10-30','14:45:00',1.38),('12664','2013-10-30','14:50:00',2.15),('12664','2013-10-30','14:55:00',1.85),('12664','2013-10-30','15:00:00',1.67),('12664','2013-10-30','15:05:00',1.14),('12664','2013-10-30','15:10:00',1.17),('12664','2013-10-30','15:15:00',1.19),('12664','2013-10-30','15:20:00',1.21),('12664','2013-10-29','08:15:00',1.26),('12664','2013-10-29','08:20:00',1.35),('12664','2013-10-29','08:25:00',1.53),('12664','2013-10-29','08:30:00',1.61),('12664','2013-10-29','08:35:00',1.7),('12664','2013-10-29','08:40:00',1.76),('12664','2013-10-29','08:45:00',1.83),('12664','2013-10-29','08:50:00',1.91),('12664','2013-10-29','08:55:00',1.98),('12664','2013-10-29','09:00:00',2.04),('12664','2013-10-29','09:05:00',2.11),('12664','2013-10-29','09:10:00',2.17),('12664','2013-10-29','09:15:00',2.26),('12664','2013-10-29','09:20:00',2.31),('12664','2013-10-29','09:25:00',2.33),('12664','2013-10-29','09:30:00',2.4),('12664','2013-10-29','09:35:00',2.43),('12664','2013-10-29','09:40:00',2.52),('12664','2013-10-29','09:45:00',2.52),('12664','2013-10-29','09:50:00',2.58),('12664','2013-10-29','09:55:00',2.63),('12664','2013-10-29','10:00:00',2.66),('12664','2013-10-29','10:05:00',2.77),('12664','2013-10-29','10:10:00',2.92),('12664','2013-10-29','10:15:00',2.95),('12664','2013-10-29','10:20:00',3.08),('12664','2013-10-29','10:25:00',2.79),('12664','2013-10-29','10:30:00',3.06),('12664','2013-10-29','10:35:00',2.84),('12664','2013-10-29','10:40:00',3.35),('12664','2013-10-29','10:45:00',2.56),('12664','2013-10-29','10:50:00',3.23),('12664','2013-10-29','10:55:00',3.35),('12664','2013-10-29','11:00:00',2.98),('12664','2013-10-29','11:05:00',1.44),('12664','2013-10-29','11:10:00',1.16),('12664','2013-10-29','11:15:00',1.87),('12664','2013-10-29','11:20:00',3.69),('12664','2013-10-29','11:25:00',3.51),('12664','2013-10-29','11:30:00',3.35),('12664','2013-10-29','11:35:00',3.48),('12664','2013-10-29','11:40:00',3.55),('12664','2013-10-29','11:45:00',3.54),('12664','2013-10-29','11:50:00',2.64),('12664','2013-10-29','11:55:00',1.67),('12664','2013-10-29','12:00:00',2.9),('12664','2013-10-29','12:05:00',3.25),('12664','2013-10-29','12:10:00',2.92),('12664','2013-10-29','12:15:00',2.97),('12664','2013-10-29','12:20:00',2.84),('12664','2013-10-29','12:25:00',2.64),('12664','2013-10-29','12:30:00',2.02),('12664','2013-10-29','12:35:00',1.29),('12664','2013-10-29','12:40:00',2.32),('12664','2013-10-29','12:45:00',3.06),('12664','2013-10-29','12:50:00',3.08),('12664','2013-10-29','12:55:00',2.26),('12664','2013-10-29','13:00:00',2.8),('12664','2013-10-29','13:05:00',2),('12664','2013-10-29','13:10:00',2.04),('12664','2013-10-29','13:15:00',2.18),('12664','2013-10-29','13:20:00',1.91),('12664','2013-10-29','13:25:00',2.23),('12664','2013-10-29','13:30:00',1.68),('12664','2013-10-29','13:35:00',1.48),('12664','2013-10-29','13:40:00',1.79),('12664','2013-10-29','13:45:00',2.76),('12664','2013-10-29','13:50:00',1.55),('12664','2013-10-29','13:55:00',1.56),('12664','2013-10-29','14:00:00',2.29),('12664','2013-10-29','14:05:00',2.45),('12664','2013-10-29','14:10:00',2.35),('12664','2013-10-29','14:15:00',2.2),('12664','2013-10-29','14:20:00',2.23),('12664','2013-10-29','14:25:00',2.13),('12664','2013-10-29','14:30:00',2.09),('12664','2013-10-29','14:35:00',2.04),('12664','2013-10-29','14:40:00',1.95),('12664','2013-10-29','14:45:00',1.9),('12664','2013-10-29','14:50:00',1.78),('12664','2013-10-29','14:55:00',1.71),('12664','2013-10-29','15:00:00',1.66),('12664','2013-10-29','15:05:00',1.58),('12664','2013-10-29','15:10:00',1.48),('12664','2013-10-29','15:15:00',1.4),('12664','2013-10-29','15:20:00',1.31),('12664','2013-10-29','15:25:00',1.2),('12664','2013-10-29','15:30:00',1.13),('12664','2013-10-29','15:35:00',1.04),('12664','2013-10-28','08:35:00',1.37),('12664','2013-10-28','08:40:00',1.62),('12664','2013-10-28','08:45:00',1.62),('12664','2013-10-28','08:50:00',1.11),('12664','2013-10-28','08:55:00',1.28),('12664','2013-10-28','09:00:00',1.95),('12664','2013-10-28','09:05:00',2.12),('12664','2013-10-28','09:10:00',2.1),('12664','2013-10-28','09:15:00',1.97),('12664','2013-10-28','09:20:00',2.3),('12664','2013-10-28','09:25:00',2.44),('12664','2013-10-28','09:30:00',2.6),('12664','2013-10-28','09:35:00',2.62),('12664','2013-10-28','09:40:00',1.08),('12664','2013-10-28','10:30:00',2.91),('12664','2013-10-28','10:35:00',3.15),('12664','2013-10-28','10:40:00',3.14),('12664','2013-10-28','10:45:00',3.11),('12664','2013-10-28','10:50:00',3.14),('12664','2013-10-28','10:55:00',3.16),('12664','2013-10-28','11:00:00',3.15),('12664','2013-10-28','11:05:00',3.17),('12664','2013-10-28','11:10:00',3.17),('12664','2013-10-28','11:15:00',3.15),('12664','2013-10-28','11:20:00',3.19),('12664','2013-10-28','11:25:00',3.22),('12664','2013-10-28','11:30:00',3.24),('12664','2013-10-28','11:35:00',3.24),('12664','2013-10-28','11:40:00',3.25),('12664','2013-10-28','11:45:00',3.23),('12664','2013-10-28','11:50:00',3.23),('12664','2013-10-28','11:55:00',3.2),('12664','2013-10-28','12:00:00',3.33),('12664','2013-10-28','12:05:00',2.41),('12664','2013-10-28','12:10:00',2.86),('12664','2013-10-28','12:15:00',3.68),('12664','2013-10-28','12:20:00',2.15),('12664','2013-10-28','12:25:00',3.14),('12664','2013-10-28','12:30:00',3.49),('12664','2013-10-28','12:35:00',3.26),('12664','2013-10-28','12:40:00',3.22),('12664','2013-10-28','12:45:00',3.19),('12664','2013-10-28','12:50:00',3.19),('12664','2013-10-28','12:55:00',3.18),('12664','2013-10-28','13:00:00',3.14),('12664','2013-10-28','13:05:00',3.11),('12664','2013-10-28','13:10:00',3.05),('12664','2013-10-28','13:15:00',3),('12664','2013-10-28','13:20:00',2.96),('12664','2013-10-28','13:25:00',2.94),('12664','2013-10-28','13:30:00',2.86),('12664','2013-10-28','13:35:00',2.84),('12664','2013-10-28','13:40:00',2.84),('12664','2013-10-28','13:45:00',2.84),('12664','2013-10-28','13:50:00',2.77),('12664','2013-10-28','13:55:00',2.67),('12664','2013-10-28','14:00:00',2.63),('12664','2013-10-28','14:05:00',2.59),('12664','2013-10-28','14:10:00',2.5),('12664','2013-10-28','14:15:00',2.49),('12664','2013-10-28','14:20:00',1.75),('12664','2013-10-28','14:25:00',2.28),('12664','2013-10-28','14:30:00',2.22),('12664','2013-10-28','14:35:00',2.16),('12664','2013-10-28','14:40:00',2),('12664','2013-10-28','14:45:00',2.01),('12664','2013-10-28','14:50:00',1.91),('12664','2013-10-28','14:55:00',1.86),('12664','2013-10-28','15:00:00',1.76),('12664','2013-10-28','15:05:00',1.7),('12664','2013-10-28','15:10:00',1.62),('12664','2013-10-28','15:15:00',1.3),('12664','2013-10-28','15:20:00',1.62),('12664','2013-10-28','15:25:00',1.55),('12664','2013-10-28','15:30:00',1.2),('12664','2013-10-28','15:40:00',1.08),('12664','2014-04-16','08:05:00',1.09),('12664','2014-04-16','08:10:00',1.19),('12664','2014-04-16','08:15:00',1.29),('12664','2014-04-16','08:20:00',1.38),('12664','2014-04-16','08:25:00',1.14),('12664','2014-04-16','08:30:00',1.06),('12664','2014-04-16','08:35:00',1.16),('12664','2014-04-16','08:40:00',1.8),('12664','2014-04-16','08:45:00',1.94),('12664','2014-04-16','08:50:00',2.02),('12664','2014-04-16','08:55:00',2.12),('12664','2014-04-16','09:00:00',2.21),('12664','2014-04-16','09:05:00',2.31),('12664','2014-04-16','09:10:00',2.39),('12664','2014-04-16','09:15:00',2.47),('12664','2014-04-16','09:20:00',2.55),('12664','2014-04-16','09:25:00',2.59),('12664','2014-04-16','09:30:00',2.63),('12664','2014-04-16','09:35:00',2.86),('12664','2014-04-16','09:40:00',2.18),('12664','2014-04-16','09:45:00',2.59),('12664','2014-04-16','09:50:00',3.16),('12664','2014-04-16','09:55:00',3.17),('12664','2014-04-16','10:00:00',3.24),('12664','2014-04-16','10:05:00',3.28),('12664','2014-04-16','10:10:00',3.33),('12664','2014-04-16','10:15:00',3.38),('12664','2014-04-16','10:20:00',3.43),('12664','2014-04-16','10:25:00',3.52),('12664','2014-04-16','10:30:00',3.5),('12664','2014-04-16','10:35:00',3.66),('12664','2014-04-16','10:40:00',3.57),('12664','2014-04-16','10:45:00',4.01),('12664','2014-04-16','10:50:00',2.17),('12664','2014-04-16','10:55:00',3.12),('12664','2014-04-16','11:00:00',1.62),('12664','2014-04-16','11:05:00',1.67),('12664','2014-04-16','11:10:00',1.25),('12664','2014-04-16','11:15:00',2.55),('12664','2014-04-16','11:20:00',2.62),('12664','2014-04-16','11:25:00',3.17),('12664','2014-04-16','11:30:00',2.02),('12664','2014-04-16','11:35:00',1.5),('12664','2014-04-16','11:40:00',1.57),('12664','2014-04-16','11:45:00',1.43),('12664','2014-04-16','11:50:00',2.87),('12664','2014-04-16','11:55:00',3.92),('12664','2014-04-16','12:00:00',4.97),('12664','2014-04-16','12:05:00',3.19),('12664','2014-04-16','12:10:00',2.06),('12664','2014-04-16','12:15:00',3.28),('12664','2014-04-16','12:20:00',2.84),('12664','2014-04-16','12:25:00',3.8),('12664','2014-04-16','12:30:00',4.61),('12664','2014-04-16','12:35:00',4.95),('12664','2014-04-16','12:40:00',4.45),('12664','2014-04-16','12:45:00',5.03),('12664','2014-04-16','12:50:00',5.01),('12664','2014-04-16','12:55:00',4.74),('12664','2014-04-16','13:00:00',4.75),('12664','2014-04-16','13:05:00',2.76),('12664','2014-04-16','13:10:00',4.11),('12664','2014-04-16','13:15:00',3.31),('12664','2014-04-16','13:20:00',2.55),('12664','2014-04-16','13:25:00',1.65),('12664','2014-04-16','13:30:00',1.63),('12664','2014-04-16','13:35:00',2.59),('12664','2014-04-16','13:40:00',4.76),('12664','2014-04-16','13:45:00',4.9),('12664','2014-04-16','13:50:00',3.8),('12664','2014-04-16','13:55:00',1.88),('12664','2014-04-16','14:00:00',2.47),('12664','2014-04-16','14:05:00',4.62),('12664','2014-04-16','14:10:00',4.31),('12664','2014-04-16','14:15:00',2.03),('12664','2014-04-16','14:20:00',4.26),('12664','2014-04-16','14:25:00',3.87),('12664','2014-04-16','14:30:00',3.62),('12664','2014-04-16','14:35:00',3.65),('12664','2014-04-16','14:40:00',4.56),('12664','2014-04-16','14:45:00',2.61),('12664','2014-04-16','14:50:00',4.64),('12664','2014-04-16','14:55:00',4.41),('12664','2014-04-16','15:00:00',4.65),('12664','2014-04-16','15:05:00',1.86),('12664','2014-04-16','15:10:00',1.44),('12664','2014-04-16','15:15:00',1.21),('12664','2014-04-16','15:25:00',1),('12664','2014-04-16','15:30:00',1.21),('12664','2014-04-16','15:35:00',1.1),('12664','2014-04-16','15:40:00',1.31),('12664','2014-04-16','15:45:00',3.74),('12664','2014-04-16','15:50:00',3.44),('12664','2014-04-16','15:55:00',3.16),('12664','2014-04-16','16:00:00',3.65),('12664','2014-04-16','16:05:00',3.41),('12664','2014-04-16','16:10:00',3.25),('12664','2014-04-16','16:15:00',3.13),('12664','2014-04-16','16:20:00',1.61),('12664','2014-04-16','16:25:00',2.64),('12664','2014-04-16','16:30:00',2.96),('12664','2014-04-16','16:35:00',2.84),('12664','2014-04-16','16:40:00',2.75),('12664','2014-04-16','16:45:00',2.66),('12664','2014-04-16','16:50:00',2.57),('12664','2014-04-16','16:55:00',2.49),('12664','2014-04-16','17:00:00',2.41),('12664','2014-04-16','17:05:00',2.31),('12664','2014-04-16','17:10:00',2.24),('12664','2014-04-16','17:15:00',2.1),('12664','2014-04-16','17:20:00',1.98),('12664','2014-04-16','17:25:00',1.88),('12664','2014-04-16','17:30:00',1.78),('12664','2014-04-16','17:35:00',1.67),('12664','2014-04-16','17:40:00',1.57),('12664','2014-04-16','17:45:00',1.47),('12664','2014-04-16','17:50:00',1.38),('12664','2014-04-16','17:55:00',1.31),('12664','2014-04-16','18:00:00',1.25),('12664','2014-04-16','18:05:00',1.19),('12664','2014-04-16','18:10:00',1.02),('12664','2013-10-27','10:10:00',1.04),('12664','2013-10-27','10:15:00',1.02),('12664','2013-10-27','10:20:00',1.17),('12664','2013-10-27','10:25:00',1.47),('12664','2013-10-27','10:30:00',2.03),('12664','2013-10-27','10:35:00',1.47),('12664','2013-10-27','10:40:00',1.34),('12664','2013-10-27','10:45:00',1.07),('12664','2013-10-27','10:55:00',1.41),('12664','2013-10-27','11:00:00',1.53),('12664','2013-10-27','11:05:00',1.44),('12664','2013-10-27','11:10:00',1.37),('12664','2013-10-27','11:15:00',1.42),('12664','2013-10-27','11:20:00',1.38),('12664','2013-10-27','11:25:00',1.39),('12664','2013-10-27','11:30:00',1.64),('12664','2013-10-27','11:35:00',2.1),('12664','2013-10-27','11:40:00',1.82),('12664','2013-10-27','11:45:00',2.05),('12664','2013-10-27','11:50:00',1.93),('12664','2013-10-27','11:55:00',1.77),('12664','2013-10-27','12:00:00',1.87),('12664','2013-10-27','12:05:00',2.58),('12664','2013-10-27','12:10:00',2.52),('12664','2013-10-27','12:15:00',1.82),('12664','2013-10-27','12:20:00',2.82),('12664','2013-10-27','12:25:00',2.3),('12664','2013-10-27','12:30:00',1.54),('12664','2013-10-27','12:40:00',2.48),('12664','2013-10-27','12:45:00',2.76),('12664','2013-10-27','12:50:00',1.15),('12664','2013-10-27','12:55:00',1.17),('12664','2013-10-27','13:00:00',1.61),('12664','2013-10-27','13:05:00',1.68),('12664','2013-10-27','13:10:00',1.71),('12664','2013-10-27','13:15:00',2.09),('12664','2013-10-27','13:35:00',1.49),('12664','2013-10-27','13:40:00',1.37),('12664','2013-10-27','13:45:00',1.35),('12664','2013-10-27','13:50:00',1.12),('12664','2013-10-27','13:55:00',1.05),('12664','2013-10-27','14:10:00',1.7),('12664','2013-10-27','14:15:00',2.01),('12664','2013-10-27','14:20:00',2.59),('12664','2013-10-27','14:25:00',2.31),('12664','2013-10-27','14:30:00',2.15),('12664','2013-10-27','14:35:00',1.68),('12664','2013-10-27','14:40:00',1.1),('12664','2013-10-27','14:45:00',1.67),('12664','2013-10-27','14:50:00',1.91),('12664','2013-10-27','14:55:00',1.79),('12664','2013-10-27','15:00:00',1.83),('12664','2013-10-27','15:05:00',1.73),('12664','2013-10-27','15:10:00',1.62),('12664','2013-10-27','15:15:00',1.5),('12664','2013-10-27','15:20:00',1.26),('12664','2013-10-27','15:25:00',1.11),('12664','2013-10-27','15:40:00',1.07),('12664','2013-10-27','15:45:00',1),('12664','2013-10-26','08:55:00',1.09),('12664','2013-10-26','09:00:00',1.17),('12664','2013-10-26','09:05:00',1.26),('12664','2013-10-26','09:10:00',1.35),('12664','2013-10-26','09:15:00',1.43),('12664','2013-10-26','09:20:00',1.52),('12664','2013-10-26','09:25:00',1.61),('12664','2013-10-26','09:30:00',1.71),('12664','2013-10-26','09:35:00',1.77),('12664','2013-10-26','09:40:00',1.84),('12664','2013-10-26','09:45:00',1.9),('12664','2013-10-26','09:50:00',1.98),('12664','2013-10-26','09:55:00',2.04),('12664','2013-10-26','10:00:00',2.11),('12664','2013-10-26','10:05:00',2.17),('12664','2013-10-26','10:10:00',2.22),('12664','2013-10-26','10:15:00',2.28),('12664','2013-10-26','10:20:00',2.34),('12664','2013-10-26','10:25:00',2.4),('12664','2013-10-26','10:30:00',2.46),('12664','2013-10-26','10:35:00',2.5),('12664','2013-10-26','10:40:00',2.56),('12664','2013-10-26','10:45:00',2.6),('12664','2013-10-26','10:50:00',2.67),('12664','2013-10-26','10:55:00',2.71),('12664','2013-10-26','11:00:00',2.74),('12664','2013-10-26','11:05:00',2.77),('12664','2013-10-26','11:10:00',2.86),('12664','2013-10-26','11:15:00',2.88),('12664','2013-10-26','11:20:00',2.91),('12664','2013-10-26','11:25:00',2.93),('12664','2013-10-26','11:30:00',2.96),('12664','2013-10-26','11:35:00',2.99),('12664','2013-10-26','11:40:00',3.01),('12664','2013-10-26','11:45:00',3.07),('12664','2013-10-26','11:50:00',3.04),('12664','2013-10-26','11:55:00',3.06),('12664','2013-10-26','12:00:00',3.12),('12664','2013-10-26','12:05:00',3.11),('12664','2013-10-26','12:10:00',3.07),('12664','2013-10-26','12:15:00',3.07),('12664','2013-10-26','12:20:00',3.13),('12664','2013-10-26','12:25:00',3.21),('12664','2013-10-26','12:30:00',3.15),('12664','2013-10-26','12:35:00',3.15),('12664','2013-10-26','12:40:00',3.16),('12664','2013-10-26','12:45:00',3.22),('12664','2013-10-26','12:50:00',3.14),('12664','2013-10-26','12:55:00',3.17),('12664','2013-10-26','13:00:00',3.14),('12664','2013-10-26','13:05:00',3.13),('12664','2013-10-26','13:10:00',3.14),('12664','2013-10-26','13:15:00',3.14),('12664','2013-10-26','13:20:00',3.13),('12664','2013-10-26','13:25:00',3.14),('12664','2013-10-26','13:30:00',3.11),('12664','2013-10-26','13:35:00',3.09),('12664','2013-10-26','13:40:00',3.12),('12664','2013-10-26','13:45:00',3.04),('12664','2013-10-26','13:50:00',2.99),('12664','2013-10-26','13:55:00',3.03),('12664','2013-10-26','14:00:00',2.92),('12664','2013-10-26','14:05:00',2.94),('12664','2013-10-26','14:10:00',2.88),('12664','2013-10-26','14:15:00',2.84),('12664','2013-10-26','14:20:00',2.89),('12664','2013-10-26','14:25:00',2.65),('12664','2013-10-26','14:30:00',2.78),('12664','2013-10-26','14:35:00',2.68),('12664','2013-10-26','14:40:00',2.7),('12664','2013-10-26','14:45:00',2.54),('12664','2013-10-26','14:50:00',2.42),('12664','2013-10-26','15:00:00',1.58),('12664','2013-10-26','15:05:00',2.37),('12664','2013-10-26','15:10:00',2.21),('12664','2013-10-26','15:15:00',1.91),('12664','2013-10-26','15:20:00',2.16),('12664','2013-10-26','15:25:00',2.02),('12664','2013-10-26','15:30:00',2.06),('12664','2013-10-26','15:35:00',2),('12664','2013-10-26','15:40:00',1.89),('12664','2013-10-26','15:45:00',1.83),('12664','2013-10-26','15:50:00',1.76),('12664','2013-10-26','15:55:00',1.67),('12664','2013-10-26','16:00:00',1.6),('12664','2013-10-26','16:05:00',1.52),('12664','2013-10-26','16:10:00',1.44),('12664','2013-10-26','16:15:00',1.4),('12664','2013-10-26','16:20:00',1.28),('12664','2013-10-26','16:25:00',1.2),('12664','2013-10-26','16:30:00',1.12),('12664','2013-10-26','16:35:00',1.05),('12664','2013-10-25','08:50:00',1),('12664','2013-10-25','08:55:00',1.1),('12664','2013-10-25','09:00:00',1.18),('12664','2013-10-25','09:05:00',1.26),('12664','2013-10-25','09:10:00',1.35),('12664','2013-10-25','09:15:00',1.44),('12664','2013-10-25','09:20:00',1.54),('12664','2013-10-25','09:25:00',1.62),('12664','2013-10-25','09:30:00',1.71),('12664','2013-10-25','09:35:00',1.79),('12664','2013-10-25','09:40:00',1.87),('12664','2013-10-25','09:45:00',1.94),('12664','2013-10-25','09:50:00',2.01),('12664','2013-10-25','09:55:00',2.08),('12664','2013-10-25','10:00:00',2.15),('12664','2013-10-25','10:05:00',2.23),('12664','2013-10-25','10:10:00',2.29),('12664','2013-10-25','10:15:00',2.34),('12664','2013-10-25','10:20:00',2.42),('12664','2013-10-25','10:25:00',2.48),('12664','2013-10-25','10:30:00',2.53),('12664','2013-10-25','10:35:00',2.6),('12664','2013-10-25','10:40:00',2.63),('12664','2013-10-25','10:45:00',2.66),('12664','2013-10-25','10:50:00',2.74),('12664','2013-10-25','10:55:00',2.79),('12664','2013-10-25','11:00:00',2.83),('12664','2013-10-25','11:05:00',2.86),('12664','2013-10-25','11:10:00',2.9),('12664','2013-10-25','11:15:00',2.94),('12664','2013-10-25','11:20:00',3),('12664','2013-10-25','11:25:00',3.04),('12664','2013-10-25','11:30:00',3.04),('12664','2013-10-25','11:35:00',3.07),('12664','2013-10-25','11:40:00',3.12),('12664','2013-10-25','11:45:00',3.15),('12664','2013-10-25','11:50:00',3.17),('12664','2013-10-25','11:55:00',3.19),('12664','2013-10-25','12:00:00',3.2),('12664','2013-10-25','12:05:00',3.24),('12664','2013-10-25','12:10:00',3.24),('12664','2013-10-25','12:15:00',3.24),('12664','2013-10-25','12:20:00',3.24),('12664','2013-10-25','12:25:00',3.27),('12664','2013-10-25','12:30:00',3.28),('12664','2013-10-25','12:35:00',3.31),('12664','2013-10-25','12:40:00',3.3),('12664','2013-10-25','12:45:00',3.31),('12664','2013-10-25','12:50:00',3.31),('12664','2013-10-25','12:55:00',3.31),('12664','2013-10-25','13:00:00',3.28),('12664','2013-10-25','13:05:00',3.28),('12664','2013-10-25','13:10:00',3.25),('12664','2013-10-25','13:15:00',3.22),('12664','2013-10-25','13:20:00',3.23),('12664','2013-10-25','13:25:00',3.2),('12664','2013-10-25','13:30:00',3.18),('12664','2013-10-25','13:35:00',3.19),('12664','2013-10-25','13:40:00',3.19),('12664','2013-10-25','13:45:00',3.17),('12664','2013-10-25','13:50:00',3.12),('12664','2013-10-25','13:55:00',3.05),('12664','2013-10-25','14:00:00',3.01),('12664','2013-10-25','14:05:00',3.01),('12664','2013-10-25','14:10:00',2.98),('12664','2013-10-25','14:15:00',2.92),('12664','2013-10-25','14:20:00',2.78),('12664','2013-10-25','14:25:00',2.9),('12664','2013-10-25','14:30:00',2.82),('12664','2013-10-25','14:35:00',2.8),('12664','2013-10-25','14:40:00',2.73),('12664','2013-10-25','14:45:00',2.7),('12664','2013-10-25','14:50:00',2.64),('12664','2013-10-25','14:55:00',2.6),('12664','2013-10-25','15:00:00',2.56),('12664','2013-10-25','15:05:00',2.45),('12664','2013-10-25','15:10:00',2.34),('12664','2013-10-25','15:15:00',2.26),('12664','2013-10-25','15:20:00',2.22),('12664','2013-10-25','15:25:00',2.21),('12664','2013-10-25','15:30:00',2.19),('12664','2013-10-25','15:35:00',2.15),('12664','2013-10-25','15:40:00',2.08),('12664','2013-10-25','15:45:00',2.02),('12664','2013-10-25','15:50:00',1.97),('12664','2013-10-25','15:55:00',1.9),('12664','2013-10-25','16:00:00',1.81),('12664','2013-10-25','16:05:00',1.74),('12664','2013-10-25','16:10:00',1.68),('12664','2013-10-25','16:15:00',1.58),('12664','2013-10-25','16:20:00',1.49),('12664','2013-10-25','16:25:00',1.4),('12664','2013-10-25','16:30:00',1.31),('12664','2013-10-25','16:35:00',1.22),('12664','2013-10-25','16:40:00',1.13),('12664','2013-10-25','16:45:00',1.03),('12664','2013-10-24','08:55:00',1.26),('12664','2013-10-24','09:00:00',1.46),('12664','2013-10-24','09:05:00',1.45),('12664','2013-10-24','09:10:00',1.02),('12664','2013-10-24','09:25:00',1.02),('12664','2013-10-24','09:40:00',1.02),('12664','2013-10-24','09:45:00',1.02),('12664','2013-10-24','10:25:00',1.35),('12664','2013-10-24','10:30:00',2.72),('12664','2013-10-24','10:35:00',3.43),('12664','2013-10-24','10:40:00',3.43),('12664','2013-10-24','10:45:00',3.03),('12664','2013-10-24','10:50:00',1.69),('12664','2013-10-24','10:55:00',2.07),('12664','2013-10-24','11:00:00',1.3),('12664','2013-10-24','11:05:00',1.54),('12664','2013-10-24','11:10:00',1.29),('12664','2013-10-24','11:15:00',1.29),('12664','2013-10-24','11:20:00',1.05),('12664','2013-10-24','11:25:00',1.26),('12664','2013-10-24','11:30:00',2.71),('12664','2013-10-24','11:35:00',3.86),('12664','2013-10-24','11:40:00',3.3),('12664','2013-10-24','11:45:00',3.13),('12664','2013-10-24','11:50:00',1.77),('12664','2013-10-24','11:55:00',1.28),('12664','2013-10-24','12:00:00',1.32),('12664','2013-10-24','12:05:00',1.4),('12664','2013-10-24','12:10:00',1.57),('12664','2013-10-24','12:15:00',1.87),('12664','2013-10-24','12:20:00',1.89),('12664','2013-10-24','12:25:00',1.88),('12664','2013-10-24','12:30:00',1.74),('12664','2013-10-24','12:35:00',1.57),('12664','2013-10-24','12:40:00',1.59),('12664','2013-10-24','12:45:00',1.55),('12664','2013-10-24','12:50:00',1.5),('12664','2013-10-24','12:55:00',1.4),('12664','2013-10-24','13:00:00',1.33),('12664','2013-10-24','13:05:00',1.25),('12664','2013-10-24','13:10:00',1.23),('12664','2013-10-24','13:15:00',1.2),('12664','2013-10-24','13:20:00',1.19),('12664','2013-10-24','13:25:00',1.21),('12664','2013-10-24','13:30:00',1.25),('12664','2013-10-24','13:35:00',1.29),('12664','2013-10-24','13:40:00',1.44),('12664','2013-10-24','13:45:00',2.6),('12664','2013-10-24','13:50:00',1.24),('12664','2013-10-24','13:55:00',1.25),('12664','2013-10-24','14:00:00',1.49),('12664','2013-10-24','14:05:00',1.57),('12664','2013-10-24','14:10:00',1.25),('12664','2013-10-24','14:15:00',1.28),('12664','2013-10-24','14:20:00',1.38),('12664','2013-10-24','14:25:00',1.94),('12664','2013-10-24','14:30:00',2.13),('12664','2013-10-24','14:35:00',2.38),('12664','2013-10-24','14:40:00',1.17),('12664','2013-10-24','14:50:00',1.1),('12664','2013-10-24','14:55:00',1.5),('12664','2013-10-24','15:00:00',1.69),('12664','2013-10-24','15:05:00',1.11),('12664','2013-10-24','15:10:00',1.11),('12664','2013-10-24','15:15:00',1.05),('12664','2013-10-24','15:20:00',1.23),('12664','2013-10-24','15:25:00',1.18),('12664','2013-10-24','15:30:00',2.38),('12664','2013-10-24','15:35:00',2.6),('12664','2013-10-24','15:40:00',2.48),('12664','2013-10-24','15:45:00',2.07),('12664','2013-10-23','10:30:00',1),('12664','2013-10-23','10:35:00',1.01),('12664','2013-10-23','10:40:00',1.2),('12664','2013-10-23','10:45:00',1.23),('12664','2013-10-23','10:50:00',2.31),('12664','2013-10-23','10:55:00',1.63),('12664','2013-10-23','11:00:00',2.65),('12664','2013-10-23','11:05:00',2.77),('12664','2013-10-23','11:10:00',2.76),('12664','2013-10-23','11:15:00',2.99),('12664','2013-10-23','11:20:00',2.84),('12664','2013-10-23','11:25:00',3),('12664','2013-10-23','11:30:00',2.93),('12664','2013-10-23','11:35:00',1.99),('12664','2013-10-23','11:40:00',3.05),('12664','2013-10-23','11:45:00',2.5),('12664','2013-10-23','11:50:00',1.52),('12664','2013-10-23','11:55:00',2.45),('12664','2013-10-23','12:00:00',2.96),('12664','2013-10-23','12:05:00',2.44),('12664','2013-10-23','12:10:00',2.84),('12664','2013-10-23','12:15:00',3.06),('12664','2013-10-23','12:20:00',3.07),('12664','2013-10-23','12:25:00',3.25),('12664','2013-10-23','12:30:00',3.28),('12664','2013-10-23','12:35:00',3.22),('12664','2013-10-23','12:40:00',3.19),('12664','2013-10-23','12:45:00',3.21),('12664','2013-10-23','12:50:00',3.18),('12664','2013-10-23','12:55:00',3.16),('12664','2013-10-23','13:00:00',3.19),('12664','2013-10-23','13:05:00',3.19),('12664','2013-10-23','13:10:00',3.19),('12664','2013-10-23','13:15:00',3.07),('12664','2013-10-23','13:20:00',3.08),('12664','2013-10-23','13:25:00',3.12),('12664','2013-10-23','13:30:00',3.09),('12664','2013-10-23','13:35:00',3.12),('12664','2013-10-23','13:40:00',3.11),('12664','2013-10-23','13:45:00',3.02),('12664','2013-10-23','13:50:00',2.97),('12664','2013-10-23','13:55:00',2.97),('12664','2013-10-23','14:00:00',2.94),('12664','2013-10-23','14:05:00',2.94),('12664','2013-10-23','14:10:00',2.89),('12664','2013-10-23','14:15:00',2.78),('12664','2013-10-23','14:20:00',2.75),('12664','2013-10-23','14:25:00',2.64),('12664','2013-10-23','14:30:00',2.54),('12664','2013-10-23','14:35:00',2.48),('12664','2013-10-23','14:40:00',2.45),('12664','2013-10-23','14:45:00',2.44),('12664','2013-10-23','14:50:00',2.22),('12664','2013-10-23','14:55:00',2.43),('12664','2013-10-23','15:00:00',2.29),('12664','2013-10-23','15:05:00',2.22),('12664','2013-10-23','15:10:00',1.99),('12664','2013-10-23','15:15:00',2.22),('12664','2013-10-23','15:20:00',2.06),('12664','2013-10-23','15:25:00',1.91),('12664','2013-10-23','15:30:00',1.81),('12664','2013-10-23','15:35:00',1.83),('12664','2013-10-23','15:40:00',1.99),('12664','2013-10-23','15:45:00',1.88),('12664','2013-10-23','15:50:00',1.75),('12664','2013-10-23','15:55:00',1.41),('12664','2013-10-23','16:05:00',1.16),('12664','2013-10-23','16:10:00',1.1),('12664','2013-10-23','16:15:00',1.23),('12664','2013-10-23','16:20:00',1.25),('12664','2013-10-23','16:25:00',1.25),('12664','2013-10-23','16:30:00',1.31),('12664','2013-10-23','16:35:00',1.24),('12664','2013-10-23','16:40:00',1.09),('12664','2013-10-22','08:55:00',1.05),('12664','2013-10-22','09:00:00',1.14),('12664','2013-10-22','09:05:00',1.22),('12664','2013-10-22','09:10:00',1.31),('12664','2013-10-22','09:15:00',1.39),('12664','2013-10-22','09:20:00',1.47),('12664','2013-10-22','09:25:00',1.56),('12664','2013-10-22','09:30:00',1.65),('12664','2013-10-22','09:35:00',1.72),('12664','2013-10-22','09:40:00',1.79),('12664','2013-10-22','09:45:00',1.86),('12664','2013-10-22','09:50:00',1.93),('12664','2013-10-22','09:55:00',2.03),('12664','2013-10-22','10:00:00',2.1),('12664','2013-10-22','10:05:00',2.18),('12664','2013-10-22','10:10:00',2.23),('12664','2013-10-22','10:15:00',2.28),('12664','2013-10-22','10:20:00',2.35),('12664','2013-10-22','10:25:00',2.42),('12664','2013-10-22','10:30:00',2.45),('12664','2013-10-22','10:35:00',2.52),('12664','2013-10-22','10:40:00',2.57),('12664','2013-10-22','10:45:00',2.62),('12664','2013-10-22','10:50:00',2.63),('12664','2013-10-22','10:55:00',2.64),('12664','2013-10-22','11:00:00',2.66),('12664','2013-10-22','11:05:00',2.71),('12664','2013-10-22','11:10:00',2.75),('12664','2013-10-22','11:15:00',2.8),('12664','2013-10-22','11:20:00',2.83),('12664','2013-10-22','11:25:00',2.87),('12664','2013-10-22','11:30:00',2.88),('12664','2013-10-22','11:35:00',2.89),('12664','2013-10-22','11:40:00',2.92),('12664','2013-10-22','11:45:00',2.89),('12664','2013-10-22','11:50:00',3.03),('12664','2013-10-22','11:55:00',2.99),('12664','2013-10-22','12:00:00',3.02),('12664','2013-10-22','12:05:00',3.05),('12664','2013-10-22','12:10:00',3.06),('12664','2013-10-22','12:15:00',3.03),('12664','2013-10-22','12:20:00',3.05),('12664','2013-10-22','12:25:00',3.05),('12664','2013-10-22','12:30:00',3.12),('12664','2013-10-22','12:35:00',3.1),('12664','2013-10-22','12:40:00',3.17),('12664','2013-10-22','12:45:00',3.13),('12664','2013-10-22','12:50:00',2.91),('12664','2013-10-22','12:55:00',3.09),('12664','2013-10-22','13:00:00',3.15),('12664','2013-10-22','13:05:00',3.21),('12664','2013-10-22','13:10:00',3.17),('12664','2013-10-22','13:15:00',3.14),('12664','2013-10-22','13:20:00',3.16),('12664','2013-10-22','13:25:00',3.22),('12664','2013-10-22','13:30:00',3.16),('12664','2013-10-22','13:35:00',3.14),('12664','2013-10-22','13:40:00',3.22),('12664','2013-10-22','13:45:00',2.23),('12664','2013-10-22','13:50:00',3),('12664','2013-10-22','13:55:00',3.08),('12664','2013-10-22','14:00:00',3.05),('12664','2013-10-22','14:05:00',3.09),('12664','2013-10-22','14:10:00',2.94),('12664','2013-10-22','14:15:00',2.86),('12664','2013-10-22','14:20:00',2.8),('12664','2013-10-22','14:25:00',2.27),('12664','2013-10-22','14:30:00',2.53),('12664','2013-10-22','14:35:00',2.14),('12664','2013-10-22','14:40:00',2.66),('12664','2013-10-22','14:45:00',2.64),('12664','2013-10-22','14:50:00',2.64),('12664','2013-10-22','14:55:00',2.6),('12664','2013-10-22','15:00:00',2.48),('12664','2013-10-22','15:05:00',2.42),('12664','2013-10-22','15:10:00',2.32),('12664','2013-10-22','15:15:00',2.34),('12664','2013-10-22','15:20:00',2.22),('12664','2013-10-22','15:25:00',2.19),('12664','2013-10-22','15:30:00',2.07),('12664','2013-10-22','15:35:00',2.04),('12664','2013-10-22','15:40:00',1.97),('12664','2013-10-22','15:45:00',1.91),('12664','2013-10-22','15:50:00',1.82),('12664','2013-10-22','15:55:00',1.78),('12664','2013-10-22','16:00:00',1.69),('12664','2013-10-22','16:05:00',1.6),('12664','2013-10-22','16:10:00',1.54),('12664','2013-10-22','16:15:00',1.47),('12664','2013-10-22','16:20:00',1.38),('12664','2013-10-22','16:25:00',1.31),('12664','2013-10-22','16:30:00',1.23),('12664','2013-10-22','16:35:00',1.14),('12664','2013-10-22','16:40:00',1.06),('12664','2013-10-21','09:05:00',1.12),('12664','2013-10-21','09:10:00',1.43),('12664','2013-10-21','09:15:00',1.61),('12664','2013-10-21','09:20:00',1.58),('12664','2013-10-21','09:25:00',1.57),('12664','2013-10-21','09:30:00',1.44),('12664','2013-10-21','09:35:00',1.7),('12664','2013-10-21','09:40:00',1.68),('12664','2013-10-21','09:45:00',1.78),('12664','2013-10-21','09:50:00',1.93),('12664','2013-10-21','09:55:00',2.11),('12664','2013-10-21','10:00:00',2.11),('12664','2013-10-21','10:05:00',2.13),('12664','2013-10-21','10:10:00',2.13),('12664','2013-10-21','10:15:00',2.17),('12664','2013-10-21','10:20:00',2.55),('12664','2013-10-21','10:25:00',2.48),('12664','2013-10-21','10:30:00',2.56),('12664','2013-10-21','10:35:00',2.63),('12664','2013-10-21','10:40:00',2.69),('12664','2013-10-21','10:45:00',2.77),('12664','2013-10-21','10:50:00',2.81),('12664','2013-10-21','10:55:00',2.51),('12664','2013-10-21','11:00:00',2.96),('12664','2013-10-21','11:05:00',2.97),('12664','2013-10-21','11:10:00',3),('12664','2013-10-21','11:15:00',3.02),('12664','2013-10-21','11:20:00',2.95),('12664','2013-10-21','11:25:00',3.02),('12664','2013-10-21','11:30:00',3),('12664','2013-10-21','11:35:00',2.87),('12664','2013-10-21','11:40:00',3.09),('12664','2013-10-21','11:45:00',3.14),('12664','2013-10-21','11:50:00',3.16),('12664','2013-10-21','11:55:00',3.17),('12664','2013-10-21','12:00:00',3.19),('12664','2013-10-21','12:05:00',3.19),('12664','2013-10-21','12:10:00',3.18),('12664','2013-10-21','12:15:00',3.18),('12664','2013-10-21','12:20:00',3.19),('12664','2013-10-21','12:25:00',3.27),('12664','2013-10-21','12:30:00',3.34),('12664','2013-10-21','12:35:00',3.2),('12664','2013-10-21','12:40:00',3.27),('12664','2013-10-21','12:45:00',3.25),('12664','2013-10-21','12:50:00',3.23),('12664','2013-10-21','12:55:00',3.22),('12664','2013-10-21','13:00:00',3.05),('12664','2013-10-21','13:05:00',3.18),('12664','2013-10-21','13:10:00',3.14),('12664','2013-10-21','13:15:00',2.91),('12664','2013-10-21','13:20:00',3.13),('12664','2013-10-21','13:25:00',3.09),('12664','2013-10-21','13:30:00',3.13),('12664','2013-10-21','13:35:00',3.11),('12664','2013-10-21','13:40:00',3.12),('12664','2013-10-21','13:45:00',2.98),('12664','2013-10-21','13:50:00',2.94),('12664','2013-10-21','13:55:00',2.9),('12664','2013-10-21','14:00:00',3.06),('12664','2013-10-21','14:05:00',3.03),('12664','2013-10-21','14:10:00',2.99),('12664','2013-10-21','14:15:00',2.96),('12664','2013-10-21','14:20:00',2.9),('12664','2013-10-21','14:25:00',2.91),('12664','2013-10-21','14:30:00',2.85),('12664','2013-10-21','14:35:00',2.8),('12664','2013-10-21','14:40:00',2.76),('12664','2013-10-21','14:45:00',2.7),('12664','2013-10-21','14:50:00',2.63),('12664','2013-10-21','14:55:00',2.56),('12664','2013-10-21','15:00:00',2.5),('12664','2013-10-21','15:05:00',2.4),('12664','2013-10-21','15:10:00',2.34),('12664','2013-10-21','15:15:00',2.38),('12664','2013-10-21','15:20:00',2.35),('12664','2013-10-21','15:25:00',2.3),('12664','2013-10-21','15:30:00',2.23),('12664','2013-10-21','15:35:00',2.17),('12664','2013-10-21','15:40:00',2.09),('12664','2013-10-21','15:45:00',2.02),('12664','2013-10-21','15:50:00',1.92),('12664','2013-10-21','15:55:00',1.86),('12664','2013-10-21','16:00:00',1.78),('12664','2013-10-21','16:05:00',1.7),('12664','2013-10-21','16:10:00',1.66),('12664','2013-10-21','16:15:00',1.54),('12664','2013-10-21','16:20:00',1.46),('12664','2013-10-21','16:25:00',1.37),('12664','2013-10-21','16:30:00',1.29),('12664','2013-10-21','16:35:00',1.24),('12664','2013-10-21','16:40:00',1.17),('12664','2013-10-21','16:45:00',1.07),('12664','2013-10-20','08:50:00',1.26),('12664','2013-10-20','08:55:00',1.24),('12664','2013-10-20','09:00:00',1.32),('12664','2013-10-20','09:05:00',1.44),('12664','2013-10-20','09:10:00',1.52),('12664','2013-10-20','09:15:00',1.58),('12664','2013-10-20','09:20:00',1.67),('12664','2013-10-20','09:25:00',1.74),('12664','2013-10-20','09:30:00',1.83),('12664','2013-10-20','09:35:00',1.9),('12664','2013-10-20','09:40:00',1.99),('12664','2013-10-20','09:45:00',2.07),('12664','2013-10-20','09:50:00',2.13),('12664','2013-10-20','09:55:00',2.21),('12664','2013-10-20','10:00:00',2.28),('12664','2013-10-20','10:05:00',2.36),('12664','2013-10-20','10:10:00',2.41),('12664','2013-10-20','10:15:00',2.47),('12664','2013-10-20','10:20:00',2.54),('12664','2013-10-20','10:25:00',2.59),('12664','2013-10-20','10:30:00',2.66),('12664','2013-10-20','10:35:00',2.72),('12664','2013-10-20','10:40:00',2.77),('12664','2013-10-20','10:45:00',2.82),('12664','2013-10-20','10:50:00',2.85),('12664','2013-10-20','10:55:00',2.91),('12664','2013-10-20','11:00:00',2.94),('12664','2013-10-20','11:05:00',2.97),('12664','2013-10-20','11:10:00',3.02),('12664','2013-10-20','11:15:00',3.05),('12664','2013-10-20','11:20:00',3.12),('12664','2013-10-20','11:25:00',3.1),('12664','2013-10-20','11:30:00',2.94),('12664','2013-10-20','11:35:00',3.04),('12664','2013-10-20','11:40:00',3.23),('12664','2013-10-20','11:45:00',3.25),('12664','2013-10-20','11:50:00',3.14),('12664','2013-10-20','11:55:00',3.28),('12664','2013-10-20','12:00:00',3.26),('12664','2013-10-20','12:05:00',3.34),('12664','2013-10-20','12:10:00',3.29),('12664','2013-10-20','12:15:00',2.84),('12664','2013-10-20','12:20:00',3.38),('12664','2013-10-20','12:25:00',3.44),('12664','2013-10-20','12:30:00',2.15),('12664','2013-10-20','12:35:00',2.76),('12664','2013-10-20','12:40:00',3.63),('12664','2013-10-20','12:45:00',1.87),('12664','2013-10-20','12:50:00',2.48),('12664','2013-10-20','12:55:00',2.12),('12664','2013-10-20','13:00:00',1.6),('12664','2013-10-20','13:05:00',1.06),('12664','2013-10-20','13:10:00',2.14),('12664','2013-10-20','13:15:00',3.85),('12664','2013-10-20','13:20:00',2.94),('12664','2013-10-20','13:25:00',3.7),('12664','2013-10-20','13:30:00',3.6),('12664','2013-10-20','13:35:00',3.52),('12664','2013-10-20','13:40:00',3.53),('12664','2013-10-20','13:45:00',3.64),('12664','2013-10-20','13:50:00',2.5),('12664','2013-10-20','13:55:00',3.39),('12664','2013-10-20','14:00:00',3.55),('12664','2013-10-20','14:05:00',3.54),('12664','2013-10-20','14:10:00',3.51),('12664','2013-10-20','14:15:00',3.48),('12664','2013-10-20','14:20:00',3.27),('12664','2013-10-20','14:25:00',2.02),('12664','2013-10-20','14:30:00',2.57),('12664','2013-10-20','14:35:00',1.88),('12664','2013-10-20','14:40:00',2.3),('12664','2013-10-20','14:45:00',2.78),('12664','2013-10-20','14:50:00',2.93),('12664','2013-10-20','14:55:00',2.62),('12664','2013-10-20','15:00:00',1.61),('12664','2013-10-20','15:05:00',1.62),('12664','2013-10-20','15:10:00',2.79),('12664','2013-10-20','15:15:00',2.75),('12664','2013-10-20','15:20:00',2.72),('12664','2013-10-20','15:25:00',2.6),('12664','2013-10-20','15:30:00',1.52),('12664','2013-10-20','15:35:00',1.54),('12664','2013-10-20','15:40:00',1.97),('12664','2013-10-20','15:45:00',2.58),('12664','2013-10-20','15:50:00',2.49),('12664','2013-10-20','15:55:00',2.27),('12664','2013-10-20','16:05:00',2.01),('12664','2013-10-20','16:10:00',1.96),('12664','2013-10-20','16:15:00',1.82),('12664','2013-10-20','16:20:00',1.7),('12664','2013-10-20','16:25:00',1.59),('12664','2013-10-20','16:30:00',1.5),('12664','2013-10-20','16:35:00',1.4),('12664','2013-10-20','16:40:00',1.29),('12664','2013-10-20','16:45:00',1.18),('12664','2013-10-20','16:50:00',1.1),('12664','2013-10-20','16:55:00',1.01),('12664','2013-10-19','08:35:00',1.02),('12664','2013-10-19','08:40:00',1.08),('12664','2013-10-19','08:45:00',1.23),('12664','2013-10-19','08:50:00',1.35),('12664','2013-10-19','08:55:00',1.21),('12664','2013-10-19','09:00:00',1.39),('12664','2013-10-19','09:05:00',1.8),('12664','2013-10-19','09:10:00',1.9),('12664','2013-10-19','09:15:00',2.01),('12664','2013-10-19','09:20:00',2.1),('12664','2013-10-19','09:25:00',2.2),('12664','2013-10-19','09:30:00',2.31),('12664','2013-10-19','09:35:00',2.39),('12664','2013-10-19','09:40:00',2.31),('12664','2013-10-19','09:45:00',2.44),('12664','2013-10-19','09:50:00',2.55),('12664','2013-10-19','09:55:00',2.54),('12664','2013-10-19','10:00:00',2.51),('12664','2013-10-19','10:05:00',2.61),('12664','2013-10-19','10:10:00',2.65),('12664','2013-10-19','10:15:00',2.71),('12664','2013-10-19','10:20:00',2.84),('12664','2013-10-19','10:25:00',2.92),('12664','2013-10-19','10:30:00',2.97),('12664','2013-10-19','10:35:00',2.99),('12664','2013-10-19','10:40:00',3.04),('12664','2013-10-19','10:45:00',2.89),('12664','2013-10-19','10:50:00',2.98),('12664','2013-10-19','10:55:00',3.02),('12664','2013-10-19','11:00:00',2.51),('12664','2013-10-19','11:05:00',3),('12664','2013-10-19','11:10:00',3.24),('12664','2013-10-19','11:15:00',3.36),('12664','2013-10-19','11:20:00',3.38),('12664','2013-10-19','11:25:00',3.37),('12664','2013-10-19','11:30:00',3.38),('12664','2013-10-19','11:35:00',3.45),('12664','2013-10-19','11:40:00',3.28),('12664','2013-10-19','11:45:00',3.37),('12664','2013-10-19','11:50:00',3.49),('12664','2013-10-19','11:55:00',3.46),('12664','2013-10-19','12:00:00',3.54),('12664','2013-10-19','12:05:00',3.58),('12664','2013-10-19','12:10:00',3.51),('12664','2013-10-19','12:15:00',3.33),('12664','2013-10-19','12:20:00',3.63),('12664','2013-10-19','12:25:00',3.63),('12664','2013-10-19','12:30:00',3.55),('12664','2013-10-19','12:35:00',3.76),('12664','2013-10-19','12:40:00',4),('12664','2013-10-19','12:45:00',4.09),('12664','2013-10-19','12:50:00',3.9),('12664','2013-10-19','12:55:00',3.45),('12664','2013-10-19','13:00:00',3.64),('12664','2013-10-19','13:05:00',2.9),('12664','2013-10-19','13:10:00',2.77),('12664','2013-10-19','13:15:00',2.83),('12664','2013-10-19','13:20:00',2.64),('12664','2013-10-19','13:25:00',2.95),('12664','2013-10-19','13:30:00',2.83),('12664','2013-10-19','13:35:00',2.8),('12664','2013-10-19','13:40:00',3.65),('12664','2013-10-19','13:45:00',3.77),('12664','2013-10-19','13:50:00',3.05),('12664','2013-10-19','13:55:00',3.03),('12664','2013-10-19','14:00:00',3.24),('12664','2013-10-19','14:05:00',3.06),('12664','2013-10-19','14:10:00',2.07),('12664','2013-10-19','14:15:00',3.42),('12664','2013-10-19','14:20:00',3.23),('12664','2013-10-19','14:25:00',3.25),('12664','2013-10-19','14:30:00',3.23),('12664','2013-10-19','14:35:00',3.17),('12664','2013-10-19','14:40:00',2.95),('12664','2013-10-19','14:45:00',2.89),('12664','2013-10-19','14:50:00',2.82),('12664','2013-10-19','14:55:00',2.74),('12664','2013-10-19','15:00:00',2.78),('12664','2013-10-19','15:05:00',2.64),('12664','2013-10-19','15:10:00',2.58),('12664','2013-10-19','15:15:00',2.56),('12664','2013-10-19','15:20:00',2.53),('12664','2013-10-19','15:25:00',2.39),('12664','2013-10-19','15:30:00',2.21),('12664','2013-10-19','15:35:00',1.93),('12664','2013-10-19','15:40:00',2.28),('12664','2013-10-19','15:45:00',2.38),('12664','2013-10-19','15:50:00',2.23),('12664','2013-10-19','15:55:00',1.99),('12664','2013-10-19','16:00:00',2.05),('12664','2013-10-19','16:05:00',2.02),('12664','2013-10-19','16:10:00',1.22),('12664','2013-10-19','16:15:00',1.33),('12664','2013-10-19','16:20:00',1.83),('12664','2013-10-19','16:25:00',1.87),('12664','2013-10-19','16:30:00',1.46),('12664','2013-10-19','16:35:00',1.51),('12664','2013-10-19','16:40:00',1.45),('12664','2013-10-19','16:45:00',1.2),('12664','2013-10-19','16:50:00',1.06),('12664','2013-10-18','08:40:00',1.06),('12664','2013-10-18','08:45:00',1.17),('12664','2013-10-18','08:50:00',1.2),('12664','2013-10-18','08:55:00',1.3),('12664','2013-10-18','09:00:00',1.51),('12664','2013-10-18','09:05:00',1.63),('12664','2013-10-18','09:10:00',1.69),('12664','2013-10-18','09:15:00',1.81),('12664','2013-10-18','09:20:00',1.92),('12664','2013-10-18','09:25:00',2.01),('12664','2013-10-18','09:30:00',2.12),('12664','2013-10-18','09:35:00',2.2),('12664','2013-10-18','09:40:00',2.28),('12664','2013-10-18','09:45:00',2.35),('12664','2013-10-18','09:50:00',2.42),('12664','2013-10-18','09:55:00',2.45),('12664','2013-10-18','10:00:00',2.54),('12664','2013-10-18','10:05:00',2.6),('12664','2013-10-18','10:10:00',2.65),('12664','2013-10-18','10:15:00',2.73),('12664','2013-10-18','10:20:00',2.77),('12664','2013-10-18','10:25:00',2.86),('12664','2013-10-18','10:30:00',2.9),('12664','2013-10-18','10:35:00',2.96),('12664','2013-10-18','10:40:00',3),('12664','2013-10-18','10:45:00',3.07),('12664','2013-10-18','10:50:00',3.12),('12664','2013-10-18','10:55:00',3.12),('12664','2013-10-18','11:00:00',3.11),('12664','2013-10-18','11:05:00',3.08),('12664','2013-10-18','11:10:00',3.08),('12664','2013-10-18','11:15:00',3.22),('12664','2013-10-18','11:20:00',3.19),('12664','2013-10-18','11:25:00',3.32),('12664','2013-10-18','11:30:00',3.34),('12664','2013-10-18','11:35:00',3.49),('12664','2013-10-18','11:40:00',3.45),('12664','2013-10-18','11:45:00',3.48),('12664','2013-10-18','11:50:00',3.51),('12664','2013-10-18','11:55:00',3.43),('12664','2013-10-18','12:00:00',3.53),('12664','2013-10-18','12:05:00',3.54),('12664','2013-10-18','12:10:00',3.51),('12664','2013-10-18','12:15:00',3.46),('12664','2013-10-18','12:20:00',3.51),('12664','2013-10-18','12:25:00',3.57),('12664','2013-10-18','12:30:00',3.51),('12664','2013-10-18','12:35:00',3.51),('12664','2013-10-18','12:40:00',3.51),('12664','2013-10-18','12:45:00',3.44),('12664','2013-10-18','12:50:00',3.47),('12664','2013-10-18','12:55:00',3.47),('12664','2013-10-18','13:00:00',3.38),('12664','2013-10-18','13:05:00',3.39),('12664','2013-10-18','13:10:00',3.48),('12664','2013-10-18','13:15:00',3.47),('12664','2013-10-18','13:20:00',3.56),('12664','2013-10-18','13:25:00',3.55),('12664','2013-10-18','13:30:00',3.5),('12664','2013-10-18','13:35:00',3.48),('12664','2013-10-18','13:40:00',3.37),('12664','2013-10-18','13:45:00',3.29),('12664','2013-10-18','13:50:00',3.36),('12664','2013-10-18','13:55:00',3.14),('12664','2013-10-18','14:00:00',3.26),('12664','2013-10-18','14:05:00',3.29),('12664','2013-10-18','14:10:00',3.26),('12664','2013-10-18','14:15:00',3.23),('12664','2013-10-18','14:20:00',3.22),('12664','2013-10-18','14:25:00',3.22),('12664','2013-10-18','14:30:00',3.07),('12664','2013-10-18','14:35:00',3.08),('12664','2013-10-18','14:40:00',3.06),('12664','2013-10-18','14:45:00',3.01),('12664','2013-10-18','14:50:00',2.98),('12664','2013-10-18','14:55:00',2.83),('12664','2013-10-18','15:00:00',2.47),('12664','2013-10-18','15:05:00',2.5),('12664','2013-10-18','15:10:00',2.62),('12664','2013-10-18','15:15:00',2.79),('12664','2013-10-18','15:20:00',2.61),('12664','2013-10-18','15:25:00',2.61),('12664','2013-10-18','15:30:00',2.58),('12664','2013-10-18','15:35:00',2.39),('12664','2013-10-18','15:40:00',2.2),('12664','2013-10-18','15:45:00',2.22),('12664','2013-10-18','15:50:00',2.09),('12664','2013-10-18','15:55:00',2.12),('12664','2013-10-18','16:00:00',1.99),('12664','2013-10-18','16:05:00',1.92),('12664','2013-10-18','16:10:00',1.78),('12664','2013-10-18','16:15:00',1.69),('12664','2013-10-18','16:20:00',1.31),('12664','2013-10-18','16:25:00',1.23),('12664','2013-10-18','16:30:00',1.2),('12664','2014-05-03','07:50:00',1.05),('12664','2014-05-03','07:55:00',1.16),('12664','2014-05-03','08:00:00',1.31),('12664','2014-05-03','08:05:00',1.41),('12664','2014-05-03','08:10:00',1.52),('12664','2014-05-03','08:15:00',1.65),('12664','2014-05-03','08:20:00',1.86),('12664','2014-05-03','08:25:00',1.87),('12664','2014-05-03','08:30:00',2.04),('12664','2014-05-03','08:35:00',1.77),('12664','2014-05-03','08:40:00',1.83),('12664','2014-05-03','08:45:00',2),('12664','2014-05-03','08:50:00',2.13),('12664','2014-05-03','08:55:00',2.74),('12664','2014-05-03','09:00:00',2.26),('12664','2014-05-03','09:05:00',3.09),('12664','2014-05-03','09:10:00',2.03),('12664','2014-05-03','09:15:00',1.53),('12664','2014-05-03','09:20:00',3.27),('12664','2014-05-03','09:25:00',2.82),('12664','2014-05-03','09:30:00',3.03),('12664','2014-05-03','09:35:00',2.46),('12664','2014-05-03','09:40:00',2.97),('12664','2014-05-03','09:45:00',1.16),('12664','2014-05-03','09:50:00',1.22),('12664','2014-05-03','09:55:00',1.35),('12664','2014-05-03','10:00:00',1.51),('12664','2014-05-03','10:05:00',3.06),('12664','2014-05-03','10:10:00',2.05),('12664','2014-05-03','10:15:00',2.2),('12664','2014-05-03','10:20:00',1.23),('12664','2014-05-03','10:25:00',1.1),('12664','2014-05-03','10:30:00',1.04),('12664','2014-05-03','10:35:00',1.23),('12664','2014-05-03','10:40:00',2.21),('12664','2014-05-03','10:45:00',3.37),('12664','2014-05-03','10:55:00',1.23),('12664','2014-05-03','11:00:00',1.42),('12664','2014-05-03','11:05:00',2.45),('12664','2014-05-03','11:45:00',2.54),('12664','2014-05-03','11:50:00',2.69),('12664','2014-05-03','11:55:00',2.01),('12664','2014-05-03','12:00:00',2.63),('12664','2014-05-03','12:05:00',2.67),('12664','2014-05-03','12:10:00',2.17),('12664','2014-05-03','12:15:00',1.9),('12664','2014-05-03','12:20:00',1.99),('12664','2014-05-03','12:25:00',1.88),('12664','2014-05-03','12:30:00',1.44),('12664','2014-05-03','12:35:00',1.39),('12664','2014-05-03','12:40:00',1.7),('12664','2014-05-03','12:45:00',1.86),('12664','2014-05-03','12:50:00',1.92),('12664','2014-05-03','12:55:00',1.69),('12664','2014-05-03','13:00:00',2.19),('12664','2014-05-03','13:05:00',2.05),('12664','2014-05-03','13:10:00',2.05),('12664','2014-05-03','13:15:00',2.14),('12664','2014-05-03','13:20:00',2),('12664','2014-05-03','13:25:00',1.78),('12664','2014-05-03','13:30:00',1.54),('12664','2014-05-03','13:35:00',1.37),('12664','2014-05-03','13:40:00',1.08),('12664','2014-05-03','13:50:00',1.13),('12664','2014-05-03','13:55:00',1.46),('12664','2014-05-03','14:00:00',1.24),('12664','2014-05-03','14:05:00',1.1),('12664','2014-05-03','14:10:00',2.02),('12664','2014-05-03','14:15:00',2.85),('12664','2014-05-03','14:20:00',3.11),('12664','2014-05-03','14:25:00',3.28),('12664','2014-05-03','14:30:00',2.95),('12664','2014-05-03','14:35:00',2.58),('12664','2014-05-03','14:40:00',1.66),('12664','2014-05-03','17:20:00',1.04),('12664','2014-05-03','17:25:00',1.34),('12664','2014-05-03','17:30:00',1.51),('12664','2014-05-03','17:35:00',1.53),('12664','2014-05-03','17:40:00',1.21),('12664','2014-05-03','17:45:00',1.08),('12664','2014-05-03','17:50:00',1.02),('12664','2014-05-03','17:55:00',1.02),('12664','2014-05-03','18:00:00',1.09),('12664','2014-05-03','18:05:00',1.09),('12664','2014-05-03','18:15:00',1.03),('12664','2014-04-15','08:50:00',1.62),('12664','2014-04-15','08:55:00',1.47),('12664','2014-04-15','09:00:00',1.66),('12664','2014-04-15','09:05:00',1.7),('12664','2014-04-15','09:10:00',1.8),('12664','2014-04-15','09:15:00',1.61),('12664','2014-04-15','09:20:00',1.39),('12664','2014-04-15','09:25:00',1.02),('12664','2014-04-15','09:30:00',2.01),('12664','2014-04-15','09:35:00',1.2),('12664','2014-04-15','09:40:00',2.77),('12664','2014-04-15','09:45:00',2.79),('12664','2014-04-15','09:50:00',1.14),('12664','2014-04-15','10:00:00',2.3),('12664','2014-04-15','10:05:00',1.66),('12664','2014-04-15','10:10:00',3.83),('12664','2014-04-15','10:15:00',3.12),('12664','2014-04-15','10:20:00',1.99),('12664','2014-04-15','10:25:00',2.08),('12664','2014-04-15','10:30:00',3.65),('12664','2014-04-15','10:35:00',2.41),('12664','2014-04-15','10:40:00',2.83),('12664','2014-04-15','10:45:00',2.9),('12664','2014-04-15','10:50:00',1.88),('12664','2014-04-15','10:55:00',1.89),('12664','2014-04-15','11:00:00',2.26),('12664','2014-04-15','11:05:00',2.57),('12664','2014-04-15','11:10:00',2.18),('12664','2014-04-15','11:15:00',1.94),('12664','2014-04-15','11:25:00',1.4),('12664','2014-04-15','11:30:00',1.25),('12664','2014-04-15','11:35:00',1.15),('12664','2014-04-15','11:40:00',1.35),('12664','2014-04-15','11:45:00',1.38),('12664','2014-04-15','11:50:00',1.59),('12664','2014-04-15','11:55:00',2.04),('12664','2014-04-15','12:10:00',2.15),('12664','2014-04-15','12:15:00',3.07),('12664','2014-04-15','12:20:00',1.7),('12664','2014-04-15','12:25:00',1.04),('12664','2014-04-15','13:05:00',1.8),('12664','2014-04-15','13:10:00',1.39),('12664','2014-04-15','13:15:00',1.58),('12664','2014-04-15','13:40:00',1.21),('12664','2014-04-15','13:45:00',2.96),('12664','2014-04-15','13:50:00',3.92),('12664','2014-04-15','13:55:00',3.42),('12664','2014-04-15','14:00:00',3.67),('12664','2014-04-15','14:05:00',2.74),('12664','2014-04-15','14:10:00',2.13),('12664','2014-04-15','14:15:00',1.82),('12664','2014-04-15','14:20:00',2.12),('12664','2014-04-15','14:25:00',2.13),('12664','2014-04-15','14:30:00',2.08),('12664','2014-04-15','14:35:00',1.82),('12664','2014-04-15','14:40:00',3.38),('12664','2014-04-15','14:45:00',1.42),('12664','2014-04-15','14:50:00',2.12),('12664','2014-04-15','14:55:00',2.68),('12664','2014-04-15','15:00:00',1.49),('12664','2014-04-15','15:05:00',2.5),('12664','2014-04-15','15:10:00',4.5),('12664','2014-04-15','15:15:00',3.14),('12664','2014-04-15','15:20:00',3.45),('12664','2014-04-15','15:25:00',2.52),('12664','2014-04-15','15:30:00',2.28),('12664','2014-04-15','15:35:00',2.21),('12664','2014-04-15','15:40:00',1.81),('12664','2014-04-15','15:45:00',1.53),('12664','2014-04-15','15:50:00',1.31),('12664','2014-04-15','15:55:00',1.24),('12664','2014-04-15','16:00:00',1.36),('12664','2014-04-15','16:05:00',1.27),('12664','2014-04-15','16:10:00',1.11),('12664','2013-10-17','08:35:00',1.05),('12664','2013-10-17','08:40:00',1.14),('12664','2013-10-17','08:45:00',1.24),('12664','2013-10-17','08:50:00',1.34),('12664','2013-10-17','08:55:00',1.44),('12664','2013-10-17','09:00:00',1.55),('12664','2013-10-17','09:05:00',1.64),('12664','2013-10-17','09:10:00',1.73),('12664','2013-10-17','09:15:00',1.82),('12664','2013-10-17','09:20:00',1.91),('12664','2013-10-17','09:25:00',2),('12664','2013-10-17','09:30:00',2.09),('12664','2013-10-17','09:35:00',2.17),('12664','2013-10-17','09:40:00',2.25),('12664','2013-10-17','09:45:00',2.32),('12664','2013-10-17','09:50:00',2.4),('12664','2013-10-17','09:55:00',2.46),('12664','2013-10-17','10:00:00',2.54),('12664','2013-10-17','10:05:00',2.61),('12664','2013-10-17','10:10:00',2.68),('12664','2013-10-17','10:15:00',2.75),('12664','2013-10-17','10:20:00',2.81),('12664','2013-10-17','10:25:00',2.89),('12664','2013-10-17','10:30:00',2.96),('12664','2013-10-17','10:35:00',3.03),('12664','2013-10-17','10:40:00',3.09),('12664','2013-10-17','10:45:00',3.14),('12664','2013-10-17','10:50:00',3.17),('12664','2013-10-17','10:55:00',3.21),('12664','2013-10-17','11:00:00',3.25),('12664','2013-10-17','11:05:00',3.29),('12664','2013-10-17','11:10:00',3.32),('12664','2013-10-17','11:15:00',3.35),('12664','2013-10-17','11:20:00',3.37),('12664','2013-10-17','11:25:00',3.4),('12664','2013-10-17','11:30:00',3.44),('12664','2013-10-17','11:35:00',3.49),('12664','2013-10-17','11:40:00',3.52),('12664','2013-10-17','11:45:00',3.53),('12664','2013-10-17','11:50:00',3.57),('12664','2013-10-17','11:55:00',3.61),('12664','2013-10-17','12:00:00',3.62),('12664','2013-10-17','12:05:00',3.64),('12664','2013-10-17','12:10:00',3.67),('12664','2013-10-17','12:15:00',3.66),('12664','2013-10-17','12:20:00',3.67),('12664','2013-10-17','12:25:00',3.68),('12664','2013-10-17','12:30:00',3.68),('12664','2013-10-17','12:35:00',3.68),('12664','2013-10-17','12:40:00',3.7),('12664','2013-10-17','12:45:00',3.69),('12664','2013-10-17','12:50:00',3.68),('12664','2013-10-17','12:55:00',3.7),('12664','2013-10-17','13:00:00',3.7),('12664','2013-10-17','13:05:00',3.69),('12664','2013-10-17','13:10:00',3.69),('12664','2013-10-17','13:15:00',3.66),('12664','2013-10-17','13:20:00',3.65),('12664','2013-10-17','13:25:00',3.65),('12664','2013-10-17','13:30:00',3.64),('12664','2013-10-17','13:35:00',3.62),('12664','2013-10-17','13:40:00',3.59),('12664','2013-10-17','13:45:00',3.56),('12664','2013-10-17','13:50:00',3.53),('12664','2013-10-17','13:55:00',3.5),('12664','2013-10-17','14:00:00',3.5),('12664','2013-10-17','14:05:00',3.44),('12664','2013-10-17','14:10:00',3.38),('12664','2013-10-17','14:15:00',3.36),('12664','2013-10-17','14:20:00',3.32),('12664','2013-10-17','14:25:00',3.28),('12664','2013-10-17','14:30:00',3.25),('12664','2013-10-17','14:35:00',3.21),('12664','2013-10-17','14:40:00',3.18),('12664','2013-10-17','14:45:00',3.12),('12664','2013-10-17','14:50:00',3.07),('12664','2013-10-17','14:55:00',3.01),('12664','2013-10-17','15:00:00',2.97),('12664','2013-10-17','15:05:00',2.92),('12664','2013-10-17','15:10:00',2.88),('12664','2013-10-17','15:15:00',2.82),('12664','2013-10-17','15:20:00',2.76),('12664','2013-10-17','15:25:00',2.69),('12664','2013-10-17','15:30:00',2.63),('12664','2013-10-17','15:35:00',2.55),('12664','2013-10-17','15:40:00',2.47),('12664','2013-10-17','15:45:00',2.41),('12664','2013-10-17','15:50:00',2.33),('12664','2013-10-17','15:55:00',2.25),('12664','2013-10-17','16:00:00',2.18),('12664','2013-10-17','16:05:00',2.1),('12664','2013-10-17','16:10:00',2.01),('12664','2013-10-17','16:15:00',1.92),('12664','2013-10-17','16:20:00',1.85),('12664','2013-10-17','16:25:00',1.76),('12664','2013-10-17','16:30:00',1.67),('12664','2013-10-17','16:35:00',1.59),('12664','2013-10-17','16:40:00',1.51),('12664','2013-10-17','16:45:00',1.41),('12664','2013-10-17','16:50:00',1.32),('12664','2013-10-17','16:55:00',1.23),('12664','2013-10-17','17:00:00',1.07),('12664','2013-10-16','09:40:00',1.62),('12664','2013-10-16','09:55:00',1.06),('12664','2013-10-16','11:05:00',1.2),('12664','2013-10-16','11:40:00',1.17),('12664','2013-10-16','11:45:00',1.7),('12664','2013-10-16','12:00:00',1.69),('12664','2013-10-16','12:05:00',1.5),('12664','2013-10-16','12:10:00',1.64),('12664','2013-10-16','12:15:00',1.66),('12664','2013-10-16','12:25:00',1.37),('12664','2013-10-16','12:30:00',1.42),('12664','2013-10-16','12:40:00',1.12),('12664','2013-10-16','12:45:00',1.77),('12664','2013-10-16','12:50:00',1.28),('12664','2013-10-16','12:55:00',1.19),('12664','2013-10-16','13:00:00',1.31),('12664','2013-10-16','13:10:00',1.21),('12664','2013-10-16','13:15:00',2.94),('12664','2013-10-16','13:20:00',1.7),('12664','2013-10-16','13:25:00',1.73),('12664','2013-10-16','13:30:00',1.75),('12664','2013-10-16','13:35:00',1.31),('12664','2013-10-16','13:40:00',2.96),('12664','2013-10-16','13:45:00',3.7),('12664','2013-10-16','13:50:00',2.92),('12664','2013-10-16','13:55:00',1.17),('12664','2013-10-16','14:00:00',3.8),('12664','2013-10-16','14:05:00',2.49),('12664','2013-10-16','14:10:00',3.54),('12664','2013-10-16','14:15:00',3.49),('12664','2013-10-16','14:20:00',3.3),('12664','2013-10-16','14:25:00',2.71),('12664','2013-10-16','14:30:00',3.28),('12664','2013-10-16','14:35:00',3.06),('12664','2013-10-16','14:40:00',3.23),('12664','2013-10-16','14:45:00',2.36),('12664','2013-10-16','14:50:00',3.07),('12664','2013-10-16','14:55:00',3.08),('12664','2013-10-16','15:00:00',2.98),('12664','2013-10-16','15:05:00',2.66),('12664','2013-10-16','15:10:00',2.87),('12664','2013-10-16','15:15:00',2.65),('12664','2013-10-16','15:20:00',2.81),('12664','2013-10-16','15:25:00',2.75),('12664','2013-10-16','15:30:00',2.63),('12664','2013-10-16','15:35:00',2.54),('12664','2013-10-16','15:40:00',2.49),('12664','2013-10-16','15:45:00',2.42),('12664','2013-10-16','15:50:00',2.32),('12664','2013-10-16','15:55:00',2.12),('12664','2013-10-16','16:00:00',2.16),('12664','2013-10-16','16:05:00',2.09),('12664','2013-10-16','16:10:00',2),('12664','2013-10-16','16:15:00',1.88),('12664','2013-10-16','16:20:00',1.81),('12664','2013-10-16','16:25:00',1.73),('12664','2013-10-16','16:30:00',1.66),('12664','2013-10-16','16:35:00',1.56),('12664','2013-10-16','16:40:00',1.46),('12664','2013-10-16','16:45:00',1.37),('12664','2013-10-16','16:50:00',1.27),('12664','2013-10-16','16:55:00',1.18),('12664','2013-10-16','17:00:00',1.09),('12664','2013-10-15','09:20:00',1.02),('12664','2013-10-15','09:25:00',1.01),('12664','2013-10-15','09:30:00',1.05),('12664','2013-10-15','09:35:00',1.23),('12664','2013-10-15','09:40:00',2.02),('12664','2013-10-15','09:45:00',2.41),('12664','2013-10-15','09:50:00',2.31),('12664','2013-10-15','09:55:00',2.55),('12664','2013-10-15','10:00:00',2.35),('12664','2013-10-15','10:05:00',2.09),('12664','2013-10-15','10:10:00',1.25),('12664','2013-10-15','10:15:00',1.5),('12664','2013-10-15','10:20:00',2.31),('12664','2013-10-15','10:25:00',2.47),('12664','2013-10-15','10:30:00',2.25),('12664','2013-10-15','10:35:00',2.82),('12664','2013-10-15','10:40:00',2.57),('12664','2013-10-15','10:45:00',1.98),('12664','2013-10-15','10:50:00',1.88),('12664','2013-10-15','10:55:00',1.94),('12664','2013-10-15','11:00:00',2.32),('12664','2013-10-15','11:05:00',3.04),('12664','2013-10-15','11:10:00',2.92),('12664','2013-10-15','11:15:00',2.73),('12664','2013-10-15','11:20:00',2.52),('12664','2013-10-15','11:25:00',2.65),('12664','2013-10-15','11:30:00',2.13),('12664','2013-10-15','11:35:00',1.62),('12664','2013-10-15','11:40:00',1.64),('12664','2013-10-15','11:45:00',1.72),('12664','2013-10-15','11:50:00',1.64),('12664','2013-10-15','11:55:00',1.51),('12664','2013-10-15','12:00:00',1.46),('12664','2013-10-15','12:05:00',1.47),('12664','2013-10-15','12:10:00',1.44),('12664','2013-10-15','12:15:00',1.52),('12664','2013-10-15','12:20:00',1.38),('12664','2013-10-15','12:25:00',1.3),('12664','2013-10-15','12:30:00',1.34),('12664','2013-10-15','12:35:00',1.38),('12664','2013-10-15','12:40:00',1.47),('12664','2013-10-15','12:45:00',1.3),('12664','2013-10-15','12:50:00',1.23),('12664','2013-10-15','12:55:00',1.22),('12664','2013-10-15','13:00:00',1.59),('12664','2013-10-15','13:05:00',1.74),('12664','2013-10-15','13:10:00',2.03),('12664','2013-10-15','13:15:00',2.96),('12664','2013-10-15','13:20:00',2.96),('12664','2013-10-15','13:25:00',1.88),('12664','2013-10-15','13:30:00',1.72),('12664','2013-10-15','13:35:00',1.71),('12664','2013-10-15','13:40:00',1.65),('12664','2013-10-15','13:45:00',1.43),('12664','2013-10-15','13:50:00',1.23),('12664','2013-10-15','13:55:00',1.12),('12664','2013-10-15','14:00:00',1.15),('12664','2013-10-15','14:05:00',1.29),('12664','2013-10-15','14:10:00',1.87),('12664','2013-10-15','14:15:00',2.02),('12664','2013-10-15','14:20:00',2.71),('12664','2013-10-15','14:25:00',1.82),('12664','2013-10-15','14:30:00',1.65),('12664','2013-10-15','14:35:00',2.22),('12664','2013-10-15','14:40:00',2.6),('12664','2013-10-15','14:45:00',2.17),('12664','2013-10-15','14:50:00',2.09),('12664','2013-10-15','14:55:00',1.42),('12664','2013-10-15','15:00:00',1.6),('12664','2013-10-15','15:05:00',1.43),('12664','2013-10-15','15:10:00',1.24),('12664','2013-10-15','15:15:00',1.02),('12664','2013-10-15','15:30:00',1.03),('12664','2013-10-15','15:35:00',1.11),('12664','2013-10-15','15:40:00',1.04),('12664','2013-10-15','16:20:00',1.05),('12664','2013-10-15','16:25:00',1.22),('12664','2013-10-15','16:30:00',1.28),('12664','2013-10-14','08:40:00',1.06),('12664','2013-10-14','08:45:00',1.08),('12664','2013-10-14','08:50:00',1.23),('12664','2013-10-14','08:55:00',1.3),('12664','2013-10-14','09:00:00',1),('12664','2013-10-14','09:15:00',1.58),('12664','2013-10-14','09:20:00',2),('12664','2013-10-14','09:25:00',2.08),('12664','2013-10-14','09:30:00',1.83),('12664','2013-10-14','09:35:00',1.14),('12664','2013-10-14','09:40:00',1.88),('12664','2013-10-14','09:45:00',1.86),('12664','2013-10-14','09:50:00',2.2),('12664','2013-10-14','09:55:00',2.25),('12664','2013-10-14','10:00:00',2.45),('12664','2013-10-14','10:05:00',2.51),('12664','2013-10-14','10:10:00',2.56),('12664','2013-10-14','10:15:00',2.64),('12664','2013-10-14','10:20:00',2.7),('12664','2013-10-14','10:25:00',2.75),('12664','2013-10-14','10:30:00',2.78),('12664','2013-10-14','10:35:00',2.77),('12664','2013-10-14','10:40:00',2.83),('12664','2013-10-14','10:45:00',2.82),('12664','2013-10-14','10:50:00',2.96),('12664','2013-10-14','10:55:00',3.01),('12664','2013-10-14','11:00:00',3),('12664','2013-10-14','11:05:00',2.98),('12664','2013-10-14','11:10:00',3.13),('12664','2013-10-14','11:15:00',3.05),('12664','2013-10-14','11:20:00',3.2),('12664','2013-10-14','11:25:00',3.29),('12664','2013-10-14','11:30:00',3.27),('12664','2013-10-14','11:35:00',3.27),('12664','2013-10-14','11:40:00',3.23),('12664','2013-10-14','11:45:00',3.22),('12664','2013-10-14','11:50:00',3.3),('12664','2013-10-14','11:55:00',3.34),('12664','2013-10-14','12:00:00',3.37),('12664','2013-10-14','12:05:00',3.41),('12664','2013-10-14','12:10:00',3.39),('12664','2013-10-14','12:15:00',3.24),('12664','2013-10-14','12:20:00',3.35),('12664','2013-10-14','12:25:00',3.43),('12664','2013-10-14','12:30:00',3.47),('12664','2013-10-14','12:35:00',3.46),('12664','2013-10-14','12:40:00',3.45),('12664','2013-10-14','12:45:00',3.47),('12664','2013-10-14','12:50:00',3.48),('12664','2013-10-14','12:55:00',3.45),('12664','2013-10-14','13:00:00',3.45),('12664','2013-10-14','13:05:00',3.45),('12664','2013-10-14','13:10:00',3.42),('12664','2013-10-14','13:15:00',3.39),('12664','2013-10-14','13:20:00',3.4),('12664','2013-10-14','13:25:00',3.38),('12664','2013-10-14','13:30:00',3.36),('12664','2013-10-14','13:35:00',3.33),('12664','2013-10-14','13:40:00',3.32),('12664','2013-10-14','13:45:00',3.3),('12664','2013-10-14','13:50:00',3.28),('12664','2013-10-14','13:55:00',3.26),('12664','2013-10-14','14:00:00',3.22),('12664','2013-10-14','14:05:00',3.18),('12664','2013-10-14','14:10:00',3.16),('12664','2013-10-14','14:15:00',3.12),('12664','2013-10-14','14:20:00',3.1),('12664','2013-10-14','14:25:00',3.06),('12664','2013-10-14','14:30:00',3.02),('12664','2013-10-14','14:35:00',2.98),('12664','2013-10-14','14:40:00',2.93),('12664','2013-10-14','14:45:00',2.92),('12664','2013-10-14','14:50:00',2.88),('12664','2013-10-14','14:55:00',2.83),('12664','2013-10-14','15:00:00',2.78),('12664','2013-10-14','15:05:00',2.73),('12664','2013-10-14','15:10:00',2.68),('12664','2013-10-14','15:15:00',2.62),('12664','2013-10-14','15:20:00',2.55),('12664','2013-10-14','15:25:00',2.5),('12664','2013-10-14','15:30:00',2.41),('12664','2013-10-14','15:35:00',2.35),('12664','2013-10-14','15:40:00',2.24),('12664','2013-10-14','15:45:00',2.12),('12664','2013-10-14','15:50:00',1.62),('12664','2013-10-14','15:55:00',1.52),('12664','2013-10-14','16:00:00',1.14),('12664','2013-10-14','16:05:00',1.1),('12664','2013-10-14','16:10:00',1.05),('12664','2013-10-14','16:35:00',1.15),('12664','2013-10-14','16:40:00',1.41),('12664','2013-10-14','16:45:00',1.13),('12664','2013-10-13','08:50:00',1.05),('12664','2013-10-13','08:55:00',1.17),('12664','2013-10-13','09:00:00',1.14),('12664','2013-10-13','09:05:00',1.16),('12664','2013-10-13','09:10:00',1.62),('12664','2013-10-13','09:15:00',1.78),('12664','2013-10-13','09:20:00',1.76),('12664','2013-10-13','09:25:00',1.33),('12664','2013-10-13','09:30:00',1.56),('12664','2013-10-13','09:35:00',1.42),('12664','2013-10-13','09:40:00',1.8),('12664','2013-10-13','09:45:00',2.17),('12664','2013-10-13','09:50:00',2.55),('12664','2013-10-13','09:55:00',1.92),('12664','2013-10-13','10:00:00',1.87),('12664','2013-10-13','10:05:00',2.09),('12664','2013-10-13','10:10:00',1.82),('12664','2013-10-13','10:15:00',1.49),('12664','2013-10-13','10:20:00',1.45),('12664','2013-10-13','10:25:00',1.63),('12664','2013-10-13','10:30:00',2.98),('12664','2013-10-13','10:35:00',3.6),('12664','2013-10-13','10:40:00',2.91),('12664','2013-10-13','10:45:00',2.97),('12664','2013-10-13','10:50:00',2.16),('12664','2013-10-13','10:55:00',1.98),('12664','2013-10-13','11:00:00',2.13),('12664','2013-10-13','11:05:00',2.25),('12664','2013-10-13','11:10:00',2.94),('12664','2013-10-13','11:15:00',2.9),('12664','2013-10-13','11:20:00',2.96),('12664','2013-10-13','11:25:00',3.15),('12664','2013-10-13','11:30:00',2.85),('12664','2013-10-13','11:35:00',3.4),('12664','2013-10-13','11:40:00',3.34),('12664','2013-10-13','11:45:00',3.24),('12664','2013-10-13','11:50:00',3.29),('12664','2013-10-13','11:55:00',3.44),('12664','2013-10-13','12:00:00',3.49),('12664','2013-10-13','12:05:00',3.5),('12664','2013-10-13','12:10:00',3.49),('12664','2013-10-13','12:15:00',3.51),('12664','2013-10-13','12:20:00',3.51),('12664','2013-10-13','12:25:00',3.31),('12664','2013-10-13','12:30:00',3.49),('12664','2013-10-13','12:35:00',3.57),('12664','2013-10-13','12:40:00',3.51),('12664','2013-10-13','12:45:00',3.5),('12664','2013-10-13','12:50:00',3.51),('12664','2013-10-13','12:55:00',3.15),('12664','2013-10-13','13:00:00',3.49),('12664','2013-10-13','13:05:00',3.54),('12664','2013-10-13','13:10:00',3.58),('12664','2013-10-13','13:15:00',3.56),('12664','2013-10-13','13:20:00',3.39),('12664','2013-10-13','13:25:00',3.34),('12664','2013-10-13','13:30:00',3.56),('12664','2013-10-13','13:35:00',3.53),('12664','2013-10-13','13:40:00',3.56),('12664','2013-10-13','13:45:00',3.33),('12664','2013-10-13','13:50:00',3.48),('12664','2013-10-13','13:55:00',3.35),('12664','2013-10-13','14:00:00',2.57),('12664','2013-10-13','14:05:00',3.72),('12664','2013-10-13','14:10:00',3.12),('12664','2013-10-13','14:15:00',3.63),('12664','2013-10-13','14:20:00',3.51),('12664','2013-10-13','14:25:00',3.27),('12664','2013-10-13','14:30:00',2.88),('12664','2013-10-13','14:35:00',2.05),('12664','2013-10-13','14:40:00',2.57),('12664','2013-10-13','14:45:00',2.88),('12664','2013-10-13','14:50:00',2.64),('12664','2013-10-13','14:55:00',2.52),('12664','2013-10-13','15:00:00',2.64),('12664','2013-10-13','15:05:00',2.84),('12664','2013-10-13','15:10:00',2.77),('12664','2013-10-13','15:15:00',2.72),('12664','2013-10-13','15:20:00',2.31),('12664','2013-10-13','15:25:00',2.13),('12664','2013-10-13','15:30:00',1.9),('12664','2013-10-13','15:35:00',1.58),('12664','2013-10-13','15:40:00',1.4),('12664','2013-10-13','15:45:00',1.8),('12664','2013-10-13','15:50:00',1.78),('12664','2013-10-13','15:55:00',2.02),('12664','2013-10-13','16:00:00',2.06),('12664','2013-10-13','16:05:00',2.24),('12664','2013-10-13','16:10:00',2.08),('12664','2013-10-13','16:15:00',1.98),('12664','2013-10-13','16:20:00',1.85),('12664','2013-10-13','16:25:00',1.51),('12664','2013-10-13','16:30:00',1.29),('12664','2013-10-13','16:35:00',1.48),('12664','2013-10-13','16:40:00',1.06),('12664','2013-10-12','11:15:00',1.03),('12664','2013-10-12','11:20:00',1.28),('12664','2013-10-12','11:25:00',1.33),('12664','2013-10-12','11:30:00',1.83),('12664','2013-10-12','11:35:00',1.74),('12664','2013-10-12','11:40:00',1.46),('12664','2013-10-12','11:45:00',1.23),('12664','2013-10-12','12:10:00',1.17),('12664','2013-10-12','12:15:00',1.7),('12664','2013-10-12','12:20:00',3.6),('12664','2013-10-12','12:25:00',3.21),('12664','2013-10-12','12:30:00',2.92),('12664','2013-10-12','12:35:00',3.66),('12664','2013-10-12','12:40:00',3.59),('12664','2013-10-12','12:45:00',3.55),('12664','2013-10-12','12:50:00',3.11),('12664','2013-10-12','12:55:00',3.07),('12664','2013-10-12','13:00:00',2.21),('12664','2013-10-12','13:15:00',1.17),('12664','2013-10-12','13:20:00',1.38),('12664','2013-10-12','13:25:00',1.39),('12664','2013-10-12','16:15:00',1.16),('12664','2013-10-12','16:20:00',1.57),('12664','2013-10-12','16:25:00',1.38),('12664','2013-10-12','16:30:00',1.19),('12664','2013-10-12','16:35:00',1.55),('12664','2013-10-12','16:40:00',1.36),('12664','2013-10-11','08:30:00',1.04),('12664','2013-10-11','08:35:00',1.22),('12664','2013-10-11','08:40:00',1.36),('12664','2013-10-11','08:45:00',1.1),('12664','2013-10-11','08:50:00',1.39),('12664','2013-10-11','08:55:00',1.49),('12664','2013-10-11','09:00:00',1.58),('12664','2013-10-11','09:05:00',1.65),('12664','2013-10-11','09:10:00',1.73),('12664','2013-10-11','09:15:00',1.83),('12664','2013-10-11','09:20:00',1.97),('12664','2013-10-11','09:25:00',2.18),('12664','2013-10-11','09:30:00',2.2),('12664','2013-10-11','09:35:00',2.32),('12664','2013-10-11','09:40:00',2.36),('12664','2013-10-11','09:45:00',2.4),('12664','2013-10-11','09:50:00',2.48),('12664','2013-10-11','09:55:00',2.57),('12664','2013-10-11','10:00:00',2.66),('12664','2013-10-11','10:05:00',2.43),('12664','2013-10-11','10:10:00',2.11),('12664','2013-10-11','10:15:00',2.19),('12664','2013-10-11','10:20:00',1.05),('12664','2013-10-11','10:25:00',1.92),('12664','2013-10-11','10:30:00',2.72),('12664','2013-10-11','10:35:00',1.77),('12664','2013-10-11','10:40:00',1.15),('12664','2013-10-11','10:45:00',1.63),('12664','2013-10-11','10:50:00',2.28),('12664','2013-10-11','10:55:00',1.5),('12664','2013-10-11','11:00:00',3.98),('12664','2013-10-11','11:05:00',2.22),('12664','2013-10-11','11:10:00',1.34),('12664','2013-10-11','11:15:00',1.45),('12664','2013-10-11','11:20:00',1.27),('12664','2013-10-11','11:25:00',1.11),('12664','2013-10-11','11:30:00',1.12),('12664','2013-10-11','11:35:00',1.29),('12664','2013-10-11','11:40:00',1.24),('12664','2013-10-11','11:45:00',1.05),('12664','2013-10-11','12:05:00',2.59),('12664','2013-10-11','12:10:00',4.15),('12664','2013-10-11','12:15:00',4.71),('12664','2013-10-11','12:20:00',2.97),('12664','2013-10-11','12:25:00',1.73),('12664','2013-10-11','12:35:00',1.52),('12664','2013-10-11','12:40:00',2.14),('12664','2013-10-11','12:45:00',2.65),('12664','2013-10-11','12:50:00',3.33),('12664','2013-10-11','12:55:00',3.39),('12664','2013-10-11','13:00:00',2.53),('12664','2013-10-11','13:05:00',2.37),('12664','2013-10-11','13:10:00',1.18),('12664','2013-10-11','13:15:00',1.94),('12664','2013-10-11','13:20:00',2.03),('12664','2013-10-11','13:25:00',1.9),('12664','2013-10-11','13:30:00',1.95),('12664','2013-10-11','13:35:00',1.54),('12664','2013-10-11','14:35:00',1.19),('12664','2013-10-11','14:40:00',2.41),('12664','2013-10-11','14:45:00',1.38),('12664','2013-10-11','16:55:00',1.21),('12664','2013-10-10','08:30:00',1.02),('12664','2013-10-10','08:35:00',1.12),('12664','2013-10-10','08:40:00',1.3),('12664','2013-10-10','08:45:00',1.4),('12664','2013-10-10','08:50:00',1.47),('12664','2013-10-10','08:55:00',1.6),('12664','2013-10-10','09:00:00',1.74),('12664','2013-10-10','09:05:00',1.87),('12664','2013-10-10','09:10:00',1.84),('12664','2013-10-10','09:15:00',1.9),('12664','2013-10-10','09:20:00',1.97),('12664','2013-10-10','09:25:00',2.04),('12664','2013-10-10','09:30:00',2.13),('12664','2013-10-10','09:35:00',2.22),('12664','2013-10-10','09:40:00',2.25),('12664','2013-10-10','09:45:00',2.36),('12664','2013-10-10','09:50:00',2.42),('12664','2013-10-10','09:55:00',2.46),('12664','2013-10-10','10:00:00',2.56),('12664','2013-10-10','10:05:00',2.64),('12664','2013-10-10','10:10:00',2.57),('12664','2013-10-10','10:15:00',2.87),('12664','2013-10-10','10:20:00',1.43),('12664','2013-10-10','10:25:00',3),('12664','2013-10-10','10:30:00',2.89),('12664','2013-10-10','10:35:00',2.61),('12664','2013-10-10','10:40:00',2.27),('12664','2013-10-10','10:45:00',2.22),('12664','2013-10-10','10:50:00',3.51),('12664','2013-10-10','10:55:00',1.07),('12664','2013-10-10','11:00:00',1.56),('12664','2013-10-10','11:05:00',2.33),('12664','2013-10-10','11:30:00',1.28),('12664','2013-10-10','11:35:00',1.34),('12664','2013-10-10','11:40:00',3.06),('12664','2013-10-10','11:45:00',2.63),('12664','2013-10-10','11:50:00',2.53),('12664','2013-10-10','11:55:00',1.23),('12664','2013-10-10','12:00:00',2.78),('12664','2013-10-10','12:05:00',4.73),('12664','2013-10-10','12:10:00',4.45),('12664','2013-10-10','12:15:00',4.24),('12664','2013-10-10','12:20:00',4.36),('12664','2013-10-10','12:30:00',1.22),('12664','2013-10-10','12:35:00',2.03),('12664','2013-10-10','12:40:00',3.24),('12664','2013-10-10','12:45:00',3.37),('12664','2013-10-10','12:50:00',4.13),('12664','2013-10-10','12:55:00',3.95),('12664','2013-10-10','13:00:00',3.81),('12664','2013-10-10','13:05:00',4.3),('12664','2013-10-10','13:10:00',4.17),('12664','2013-10-10','13:15:00',3.75),('12664','2013-10-10','13:20:00',3.54),('12664','2013-10-10','13:25:00',3.93),('12664','2013-10-10','13:30:00',1.61),('12664','2013-10-10','13:35:00',4.15),('12664','2013-10-10','13:40:00',4.34),('12664','2013-10-10','13:45:00',4.23),('12664','2013-10-10','13:50:00',3.59),('12664','2013-10-10','13:55:00',3.69),('12664','2013-10-10','14:00:00',2.26),('12664','2013-10-10','14:05:00',4.3),('12664','2013-10-10','14:10:00',2.88),('12664','2013-10-10','14:15:00',2.29),('12664','2013-10-10','14:20:00',2.07),('12664','2013-10-10','14:25:00',3.29),('12664','2013-10-10','14:30:00',3.12),('12664','2013-10-10','14:35:00',2.26),('12664','2013-10-10','14:40:00',2.5),('12664','2013-10-10','14:45:00',3.72),('12664','2013-10-10','14:50:00',3.53),('12664','2013-10-10','14:55:00',3.58),('12664','2013-10-10','15:00:00',3.51),('12664','2013-10-10','15:05:00',3.43),('12664','2013-10-10','15:10:00',3.4),('12664','2013-10-10','15:15:00',3.48),('12664','2013-10-10','15:20:00',3.03),('12664','2013-10-10','15:25:00',2.03),('12664','2013-10-10','15:30:00',3.38),('12664','2013-10-10','15:35:00',2.8),('12664','2013-10-10','15:40:00',1.01),('12664','2013-10-10','15:45:00',1.3),('12664','2013-10-10','15:50:00',2.27),('12664','2013-10-10','15:55:00',2.51),('12664','2013-10-10','16:05:00',1.67),('12664','2013-10-10','16:15:00',2.5),('12664','2013-10-10','16:20:00',2.19),('12664','2013-10-10','16:25:00',1.63),('12664','2013-10-10','16:30:00',1.61),('12664','2013-10-10','16:35:00',1.26),('12664','2013-10-10','16:45:00',1.7),('12664','2013-10-10','16:50:00',1.64),('12664','2013-10-10','16:55:00',1.42),('12664','2013-10-10','17:00:00',1.3),('12664','2013-10-10','17:10:00',1.14),('12664','2013-10-09','08:35:00',1.24),('12664','2013-10-09','08:40:00',1.3),('12664','2013-10-09','08:45:00',1.4),('12664','2013-10-09','08:50:00',1.48),('12664','2013-10-09','08:55:00',1.59),('12664','2013-10-09','09:00:00',1.69),('12664','2013-10-09','09:05:00',1.81),('12664','2013-10-09','09:10:00',1.92),('12664','2013-10-09','09:15:00',1.73),('12664','2013-10-09','09:20:00',2.17),('12664','2013-10-09','09:25:00',2.32),('12664','2013-10-09','09:30:00',1.79),('12664','2013-10-09','09:35:00',2.38),('12664','2013-10-09','09:40:00',2.68),('12664','2013-10-09','09:45:00',2.98),('12664','2013-10-09','09:50:00',2.99),('12664','2013-10-09','09:55:00',3.14),('12664','2013-10-09','10:00:00',2.18),('12664','2013-10-09','10:05:00',1.43),('12664','2013-10-09','10:10:00',1.34),('12664','2013-10-09','10:15:00',2.91),('12664','2013-10-09','10:20:00',3.09),('12664','2013-10-09','10:25:00',3.17),('12664','2013-10-09','10:30:00',2.9),('12664','2013-10-09','10:35:00',3.19),('12664','2013-10-09','10:40:00',1.02),('12664','2013-10-09','10:45:00',3.48),('12664','2013-10-09','10:50:00',2.18),('12664','2013-10-09','10:55:00',2.78),('12664','2013-10-09','11:00:00',2.49),('12664','2013-10-09','11:35:00',1.34),('12664','2013-10-09','11:40:00',1.35),('12664','2013-10-09','11:45:00',1.09),('12664','2013-10-09','12:20:00',2.83),('12664','2013-10-09','12:25:00',4.02),('12664','2013-10-09','12:30:00',4.39),('12664','2013-10-09','12:35:00',2.3),('12664','2013-10-09','12:40:00',1.71),('12664','2013-10-09','13:00:00',2.16),('12664','2013-10-09','13:05:00',3.26),('12664','2013-10-09','13:10:00',3.96),('12664','2013-10-09','13:15:00',3.86),('12664','2013-10-09','13:20:00',3.63),('12664','2013-10-09','13:25:00',3.71),('12664','2013-10-09','13:30:00',4),('12664','2013-10-09','13:35:00',4.05),('12664','2013-10-09','13:40:00',4.01),('12664','2013-10-09','13:45:00',4.03),('12664','2013-10-09','13:50:00',2.96),('12664','2013-10-09','13:55:00',2.9),('12664','2013-10-09','14:00:00',3.44),('12664','2013-10-09','14:05:00',2.36),('12664','2013-10-09','14:10:00',3.57),('12664','2013-10-09','14:15:00',3.34),('12664','2013-10-09','14:20:00',3.32),('12664','2013-10-09','14:25:00',2.1),('12664','2013-10-09','14:30:00',4.16),('12664','2013-10-09','14:35:00',3.76),('12664','2013-10-09','14:40:00',3.51),('12664','2013-10-09','14:45:00',3.23),('12664','2013-10-09','14:50:00',2.65),('12664','2013-10-09','14:55:00',3.11),('12664','2013-10-09','15:00:00',3.45),('12664','2013-10-09','15:05:00',1.97),('12664','2013-10-09','15:10:00',2.03),('12664','2013-10-09','15:15:00',1.39),('12664','2013-10-09','15:20:00',2.66),('12664','2013-10-09','15:25:00',2.36),('12664','2013-10-09','15:40:00',1.61),('12664','2013-10-09','15:45:00',1.35),('12664','2013-10-09','15:50:00',1.17),('12664','2013-10-09','15:55:00',1.59),('12664','2013-10-09','16:10:00',1.93),('12664','2013-10-09','16:15:00',2.75),('12664','2013-10-09','16:20:00',1.8),('12664','2013-10-09','16:35:00',1.41),('12664','2013-10-09','16:40:00',1.65),('12664','2013-10-09','16:45:00',1.28),('12664','2013-10-09','16:50:00',1.74),('12664','2013-10-08','08:10:00',1.04),('12664','2013-10-08','09:20:00',1.66),('12664','2013-10-08','09:45:00',2.33),('12664','2013-10-08','09:50:00',2.64),('12664','2013-10-08','09:55:00',3.18),('12664','2013-10-08','10:00:00',3.19),('12664','2013-10-08','10:05:00',1.86),('12664','2013-10-08','10:50:00',1.04),('12664','2013-10-08','10:55:00',1.09),('12664','2013-10-08','11:00:00',1.02),('12664','2013-10-08','12:35:00',1.76),('12664','2013-10-08','12:40:00',1.26),('12664','2013-10-08','12:50:00',1.22),('12664','2013-10-08','12:55:00',1.53),('12664','2013-10-08','13:00:00',1.24),('12664','2013-10-08','13:05:00',1.93),('12664','2013-10-08','13:10:00',4.44),('12664','2013-10-08','13:15:00',1.91),('12664','2013-10-08','13:20:00',2.19),('12664','2013-10-08','13:25:00',1.96),('12664','2013-10-08','13:30:00',1.22),('12664','2013-10-08','13:45:00',1.37),('12664','2013-10-08','13:50:00',1.23),('12664','2013-10-08','13:55:00',1.09),('12664','2013-10-08','14:25:00',1.3),('12664','2013-10-08','14:30:00',2.15),('12664','2013-10-08','14:35:00',3.75),('12664','2013-10-08','14:40:00',3.56),('12664','2013-10-08','14:45:00',3.41),('12664','2013-10-08','14:50:00',3.42),('12664','2013-10-08','14:55:00',3.32),('12664','2013-10-08','15:00:00',3.25),('12664','2013-10-08','15:05:00',3.01),('12664','2013-10-08','15:10:00',1.8),('12664','2013-10-08','15:15:00',1.35),('12664','2014-04-14','08:10:00',1.08),('12664','2014-04-14','08:15:00',1.17),('12664','2014-04-14','08:20:00',1.26),('12664','2014-04-14','08:25:00',1.36),('12664','2014-04-14','08:30:00',1.46),('12664','2014-04-14','08:35:00',1.56),('12664','2014-04-14','08:40:00',1.66),('12664','2014-04-14','08:45:00',1.75),('12664','2014-04-14','08:50:00',1.84),('12664','2014-04-14','08:55:00',1.93),('12664','2014-04-14','09:00:00',2.02),('12664','2014-04-14','09:05:00',2.1),('12664','2014-04-14','09:10:00',2.19),('12664','2014-04-14','09:15:00',2.27),('12664','2014-04-14','09:20:00',2.36),('12664','2014-04-14','09:25:00',2.44),('12664','2014-04-14','09:30:00',2.52),('12664','2014-04-14','09:35:00',2.6),('12664','2014-04-14','09:40:00',2.67),('12664','2014-04-14','09:45:00',2.73),('12664','2014-04-14','09:50:00',2.81),('12664','2014-04-14','09:55:00',2.88),('12664','2014-04-14','10:00:00',2.94),('12664','2014-04-14','10:05:00',3.01),('12664','2014-04-14','10:10:00',3.07),('12664','2014-04-14','10:15:00',3.14),('12664','2014-04-14','10:20:00',3.2),('12664','2014-04-14','10:25:00',3.26),('12664','2014-04-14','10:30:00',3.3),('12664','2014-04-14','10:35:00',3.36),('12664','2014-04-14','10:40:00',3.43),('12664','2014-04-14','10:45:00',3.48),('12664','2014-04-14','10:50:00',3.53),('12664','2014-04-14','10:55:00',3.58),('12664','2014-04-14','11:00:00',3.62),('12664','2014-04-14','11:05:00',3.66),('12664','2014-04-14','11:10:00',3.72),('12664','2014-04-14','11:15:00',3.76),('12664','2014-04-14','11:20:00',3.79),('12664','2014-04-14','11:25:00',3.81),('12664','2014-04-14','11:30:00',3.84),('12664','2014-04-14','11:35:00',3.88),('12664','2014-04-14','11:40:00',3.88),('12664','2014-04-14','11:45:00',3.92),('12664','2014-04-14','11:50:00',3.97),('12664','2014-04-14','11:55:00',4),('12664','2014-04-14','12:00:00',3.99),('12664','2014-04-14','12:05:00',4.02),('12664','2014-04-14','12:10:00',4.04),('12664','2014-04-14','12:15:00',4.04),('12664','2014-04-14','12:20:00',4.04),('12664','2014-04-14','12:25:00',4.06),('12664','2014-04-14','12:30:00',4.08),('12664','2014-04-14','12:35:00',4.12),('12664','2014-04-14','12:40:00',4.13),('12664','2014-04-14','12:45:00',4.17),('12664','2014-04-14','12:50:00',4.19),('12664','2014-04-14','12:55:00',4.21),('12664','2014-04-14','13:00:00',4.21),('12664','2014-04-14','13:05:00',4.2),('12664','2014-04-14','13:10:00',4.2),('12664','2014-04-14','13:15:00',4.2),('12664','2014-04-14','13:20:00',4.2),('12664','2014-04-14','13:25:00',4.21),('12664','2014-04-14','13:30:00',4.2),('12664','2014-04-14','13:35:00',4.18),('12664','2014-04-14','13:40:00',4.18),('12664','2014-04-14','13:45:00',4.17),('12664','2014-04-14','13:50:00',4.17),('12664','2014-04-14','13:55:00',4.15),('12664','2014-04-14','14:00:00',4.12),('12664','2014-04-14','14:05:00',4.11),('12664','2014-04-14','14:10:00',4.1),('12664','2014-04-14','14:15:00',4.06),('12664','2014-04-14','14:20:00',4.03),('12664','2014-04-14','14:25:00',4),('12664','2014-04-14','14:30:00',3.96),('12664','2014-04-14','14:35:00',3.95),('12664','2014-04-14','14:40:00',3.92),('12664','2014-04-14','14:45:00',3.9),('12664','2014-04-14','14:50:00',3.85),('12664','2014-04-14','14:55:00',3.78),('12664','2014-04-14','15:00:00',3.75),('12664','2014-04-14','15:05:00',3.73),('12664','2014-04-14','15:10:00',3.68),('12664','2014-04-14','15:15:00',3.64),('12664','2014-04-14','15:20:00',3.61),('12664','2014-04-14','15:25:00',3.55),('12664','2014-04-14','15:30:00',3.49),('12664','2014-04-14','15:35:00',3.43),('12664','2014-04-14','15:40:00',3.36),('12664','2014-04-14','15:45:00',3.31),('12664','2014-04-14','15:50:00',3.24),('12664','2014-04-14','15:55:00',3.18),('12664','2014-04-14','16:00:00',3.11),('12664','2014-04-14','16:05:00',3.03),('12664','2014-04-14','16:10:00',2.96),('12664','2014-04-14','16:15:00',2.9),('12664','2014-04-14','16:20:00',2.82),('12664','2014-04-14','16:25:00',2.75),('12664','2014-04-14','16:30:00',2.68),('12664','2014-04-14','16:35:00',2.59),('12664','2014-04-14','16:40:00',2.51),('12664','2014-04-14','16:45:00',2.42),('12664','2014-04-14','16:50:00',2.35),('12664','2014-04-14','16:55:00',2.27),('12664','2014-04-14','17:00:00',2.17),('12664','2014-04-14','17:05:00',2.1),('12664','2014-04-14','17:10:00',2),('12664','2014-04-14','17:15:00',1.9),('12664','2014-04-14','17:20:00',1.81),('12664','2014-04-14','17:25:00',1.72),('12664','2014-04-14','17:30:00',1.61),('12664','2014-04-14','17:35:00',1.51),('12664','2014-04-14','17:40:00',1.42),('12664','2014-04-14','17:45:00',1.33),('12664','2014-04-14','17:50:00',1.22),('12664','2014-04-14','17:55:00',1.14),('12664','2014-04-14','18:00:00',1.04),('12664','2013-10-07','08:30:00',1.06),('12664','2013-10-07','08:35:00',1.16),('12664','2013-10-07','08:40:00',1.23),('12664','2013-10-07','08:45:00',1.36),('12664','2013-10-07','08:50:00',1.46),('12664','2013-10-07','08:55:00',1.57),('12664','2013-10-07','09:00:00',1.53),('12664','2013-10-07','09:20:00',1.88),('12664','2013-10-07','09:25:00',2.23),('12664','2013-10-07','09:30:00',2.31),('12664','2013-10-07','09:35:00',2.27),('12664','2013-10-07','09:40:00',2.46),('12664','2013-10-07','09:45:00',2.76),('12664','2013-10-07','09:50:00',2.74),('12664','2013-10-07','09:55:00',2.65),('12664','2013-10-07','10:00:00',2.61),('12664','2013-10-07','10:05:00',2.68),('12664','2013-10-07','10:10:00',2.75),('12664','2013-10-07','10:15:00',2.79),('12664','2013-10-07','10:20:00',2.83),('12664','2013-10-07','10:25:00',2.9),('12664','2013-10-07','10:30:00',2.96),('12664','2013-10-07','10:35:00',3.01),('12664','2013-10-07','10:40:00',3.08),('12664','2013-10-07','10:45:00',3.13),('12664','2013-10-07','10:50:00',3.18),('12664','2013-10-07','10:55:00',3.23),('12664','2013-10-07','11:00:00',3.26),('12664','2013-10-07','11:05:00',3.3),('12664','2013-10-07','11:10:00',3.35),('12664','2013-10-07','11:15:00',3.32),('12664','2013-10-07','11:20:00',3.45),('12664','2013-10-07','11:25:00',3.47),('12664','2013-10-07','11:30:00',3.52),('12664','2013-10-07','11:35:00',3.63),('12664','2013-10-07','11:40:00',3.79),('12664','2013-10-07','11:45:00',3.84),('12664','2013-10-07','11:50:00',3.85),('12664','2013-10-07','11:55:00',3.8),('12664','2013-10-07','12:00:00',3.07),('12664','2013-10-07','12:05:00',2.75),('12664','2013-10-07','12:10:00',4.07),('12664','2013-10-07','12:15:00',4.23),('12664','2013-10-07','12:20:00',3.62),('12664','2013-10-07','12:25:00',2.1),('12664','2013-10-07','12:30:00',2.58),('12664','2013-10-07','12:35:00',2.64),('12664','2013-10-07','12:40:00',1.71),('12664','2013-10-07','12:45:00',1.72),('12664','2013-10-07','12:55:00',3.24),('12664','2013-10-07','13:00:00',3.48),('12664','2013-10-07','13:05:00',4.53),('12664','2013-10-07','13:10:00',4.23),('12664','2013-10-07','13:15:00',3.61),('12664','2013-10-07','13:20:00',1.71),('12664','2013-10-07','13:25:00',2.19),('12664','2013-10-07','13:30:00',1.41),('12664','2013-10-07','13:35:00',2.56),('12664','2013-10-07','13:40:00',1.14),('12664','2013-10-07','13:50:00',1.94),('12664','2013-10-07','13:55:00',4.74),('12664','2013-10-07','14:00:00',3.16),('12664','2013-10-07','14:05:00',3.22),('12664','2013-10-07','14:10:00',1.73),('12664','2013-10-07','14:15:00',3.23),('12664','2013-10-07','14:20:00',3.19),('12664','2013-10-07','14:25:00',2.75),('12664','2013-10-07','14:30:00',2.39),('12664','2013-10-07','14:35:00',3.2),('12664','2013-10-07','14:40:00',2.53),('12664','2013-10-07','14:45:00',1.29),('12664','2013-10-07','14:50:00',3.52),('12664','2013-10-07','14:55:00',3.66),('12664','2013-10-07','15:00:00',3.49),('12664','2013-10-07','15:05:00',3.55),('12664','2013-10-07','15:10:00',3.54),('12664','2013-10-07','15:15:00',3.16),('12664','2013-10-07','15:20:00',2.06),('12664','2013-10-07','15:25:00',2.44),('12664','2013-10-07','15:30:00',2.92),('12664','2013-10-07','15:35:00',2.73),('12664','2013-10-07','15:40:00',2.32),('12664','2013-10-07','15:45:00',2.84),('12664','2013-10-07','15:50:00',2.74),('12664','2013-10-07','15:55:00',2.62),('12664','2013-10-07','16:00:00',2.5),('12664','2013-10-07','16:05:00',2.42),('12664','2013-10-07','16:10:00',2.31),('12664','2013-10-07','16:15:00',2.12),('12664','2013-10-07','16:20:00',2.14),('12664','2013-10-07','16:25:00',2.03),('12664','2013-10-07','16:30:00',1.92),('12664','2013-10-07','16:35:00',1.83),('12664','2013-10-07','16:40:00',1.73),('12664','2013-10-07','16:45:00',1.64),('12664','2013-10-07','16:50:00',1.55),('12664','2013-10-07','16:55:00',1.46),('12664','2013-10-07','17:00:00',1.36),('12664','2013-10-07','17:05:00',1.27),('12664','2013-10-07','17:10:00',1.16),('12664','2013-10-07','17:15:00',1.06),('12664','2013-10-06','09:05:00',1.41),('12664','2013-10-06','09:20:00',1.17),('12664','2013-10-06','09:25:00',1.88),('12664','2013-10-06','09:30:00',2.42),('12664','2013-10-06','09:35:00',2.44),('12664','2013-10-06','09:40:00',2.12),('12664','2013-10-06','09:45:00',2.1),('12664','2013-10-06','09:50:00',2.5),('12664','2013-10-06','09:55:00',2.63),('12664','2013-10-06','10:00:00',2.51),('12664','2013-10-06','10:05:00',2.27),('12664','2013-10-06','10:10:00',2.26),('12664','2013-10-06','10:15:00',2.26),('12664','2013-10-06','10:20:00',2.53),('12664','2013-10-06','10:25:00',2.46),('12664','2013-10-06','10:30:00',2.4),('12664','2013-10-06','10:35:00',2.47),('12664','2013-10-06','10:40:00',1.74),('12664','2013-10-06','10:45:00',2.37),('12664','2013-10-06','10:50:00',2.58),('12664','2013-10-06','10:55:00',3.03),('12664','2013-10-06','11:00:00',3.18),('12664','2013-10-06','11:05:00',2.84),('12664','2013-10-06','11:10:00',3.17),('12664','2013-10-06','11:15:00',2.93),('12664','2013-10-06','11:20:00',2.97),('12664','2013-10-06','11:25:00',2.79),('12664','2013-10-06','11:30:00',1.54),('12664','2013-10-06','11:35:00',1.44),('12664','2013-10-06','11:40:00',2.32),('12664','2013-10-06','11:45:00',2.66),('12664','2013-10-06','11:50:00',2.92),('12664','2013-10-06','11:55:00',2.86),('12664','2013-10-06','12:00:00',3.36),('12664','2013-10-06','12:05:00',3.56),('12664','2013-10-06','12:10:00',3.44),('12664','2013-10-06','12:15:00',3.17),('12664','2013-10-06','12:20:00',2.57),('12664','2013-10-06','12:25:00',3.29),('12664','2013-10-06','12:30:00',2.99),('12664','2013-10-06','12:35:00',3.29),('12664','2013-10-06','12:40:00',3.32),('12664','2013-10-06','12:45:00',3.47),('12664','2013-10-06','12:50:00',1.5),('12664','2013-10-06','12:55:00',3.23),('12664','2013-10-06','13:00:00',3.87),('12664','2013-10-06','13:05:00',3.82),('12664','2013-10-06','13:10:00',2.9),('12664','2013-10-06','13:15:00',2.17),('12664','2013-10-06','13:20:00',1.53),('12664','2013-10-06','13:25:00',1.43),('12664','2013-10-06','13:50:00',1.18),('12664','2013-10-06','13:55:00',2.29),('12664','2013-10-06','14:00:00',1.22),('12664','2013-10-06','14:05:00',1.29),('12664','2013-10-06','14:10:00',1.01),('12664','2013-10-06','14:15:00',1.27),('12664','2013-10-06','14:20:00',1.87),('12664','2013-10-06','14:25:00',2.94),('12664','2013-10-06','14:30:00',2.21),('12664','2013-10-06','14:35:00',2.61),('12664','2013-10-06','14:40:00',1.73),('12664','2013-10-06','14:45:00',1.52),('12664','2013-10-06','14:50:00',2.11),('12664','2013-10-06','14:55:00',2.2),('12664','2013-10-06','15:00:00',2.17),('12664','2013-10-06','15:05:00',1.99),('12664','2013-10-06','15:10:00',1.96),('12664','2013-10-06','15:15:00',1.64),('12664','2013-10-06','15:20:00',1.14),('12664','2013-10-06','15:25:00',1.01),('12664','2013-10-06','17:05:00',1.04),('12664','2013-10-06','17:10:00',1.08),('12664','2013-10-05','15:55:00',1.08),('12664','2013-10-05','16:00:00',1.31),('12664','2013-10-05','16:05:00',1.17),('12664','2013-10-05','16:10:00',1.11),('12664','2013-10-05','16:15:00',1.09),('12664','2013-10-05','16:45:00',1.08),('12664','2013-10-05','16:50:00',1.12),('12664','2013-10-05','16:55:00',1.14),('12664','2013-10-04','09:20:00',1.24),('12664','2013-10-04','09:25:00',1.29),('12664','2013-10-04','09:30:00',1.07),('12664','2013-10-04','09:35:00',1.04),('12664','2013-10-04','09:40:00',1.19),('12664','2013-10-04','09:45:00',1.34),('12664','2013-10-04','09:50:00',1.46),('12664','2013-10-04','09:55:00',1.21),('12664','2013-10-04','10:00:00',1.27),('12664','2013-10-04','10:05:00',1.32),('12664','2013-10-04','10:10:00',1.4),('12664','2013-10-04','10:15:00',1.39),('12664','2013-10-04','10:20:00',1.69),('12664','2013-10-04','10:25:00',2.06),('12664','2013-10-04','10:30:00',2.32),('12664','2013-10-04','10:35:00',2.73),('12664','2013-10-04','10:40:00',3.09),('12664','2013-10-04','10:45:00',2.21),('12664','2013-10-04','10:50:00',1.8),('12664','2013-10-04','10:55:00',2.21),('12664','2013-10-04','11:00:00',1.86),('12664','2013-10-04','11:05:00',1.53),('12664','2013-10-04','11:10:00',2.52),('12664','2013-10-04','11:15:00',2.75),('12664','2013-10-04','11:20:00',2.84),('12664','2013-10-04','11:25:00',2.61),('12664','2013-10-04','11:30:00',3.26),('12664','2013-10-04','11:35:00',3.23),('12664','2013-10-04','11:40:00',3.72),('12664','2013-10-04','11:45:00',3.64),('12664','2013-10-04','11:50:00',3.69),('12664','2013-10-04','11:55:00',3.72),('12664','2013-10-04','12:00:00',3.75),('12664','2013-10-04','12:05:00',3.61),('12664','2013-10-04','12:10:00',3.75),('12664','2013-10-04','12:15:00',3.75),('12664','2013-10-04','12:20:00',3.76),('12664','2013-10-04','12:25:00',3.83),('12664','2013-10-04','12:30:00',3.82),('12664','2013-10-04','12:35:00',3.75),('12664','2013-10-04','12:40:00',3.71),('12664','2013-10-04','12:45:00',3.75),('12664','2013-10-04','12:50:00',3.68),('12664','2013-10-04','12:55:00',3.72),('12664','2013-10-04','13:00:00',3.76),('12664','2013-10-04','13:05:00',3.74),('12664','2013-10-04','13:10:00',3.81),('12664','2013-10-04','13:15:00',3.76),('12664','2013-10-04','13:20:00',3.6),('12664','2013-10-04','13:25:00',3.75),('12664','2013-10-04','13:30:00',3.72),('12664','2013-10-04','13:35:00',3.68),('12664','2013-10-04','13:40:00',3.62),('12664','2013-10-04','13:45:00',3.58),('12664','2013-10-04','13:50:00',3.61),('12664','2013-10-04','13:55:00',3.61),('12664','2013-10-04','14:00:00',3.56),('12664','2013-10-04','14:05:00',3.18),('12664','2013-10-04','14:10:00',2.98),('12664','2013-10-04','14:15:00',3.29),('12664','2013-10-04','14:20:00',3.34),('12664','2013-10-04','14:25:00',2.86),('12664','2013-10-04','14:30:00',2.14),('12664','2013-10-04','14:35:00',1.76),('12664','2013-10-04','14:40:00',2.19),('12664','2013-10-04','14:45:00',2.43),('12664','2013-10-04','14:50:00',2.62),('12664','2013-10-04','14:55:00',2.36),('12664','2013-10-04','15:00:00',2.49),('12664','2013-10-04','15:05:00',2.24),('12664','2013-10-04','15:10:00',1.99),('12664','2013-10-04','15:15:00',1.45),('12664','2013-10-04','15:20:00',2.18),('12664','2013-10-04','15:25:00',1.62),('12664','2013-10-04','15:30:00',1.4),('12664','2013-10-04','15:35:00',1.21),('12664','2013-10-04','15:55:00',1.2),('12664','2013-10-04','16:00:00',1.19),('12664','2013-10-03','08:25:00',1.08),('12664','2013-10-03','08:30:00',1.19),('12664','2013-10-03','08:35:00',1.29),('12664','2013-10-03','08:40:00',1.39),('12664','2013-10-03','08:45:00',1.48),('12664','2013-10-03','08:50:00',1.57),('12664','2013-10-03','08:55:00',1.66),('12664','2013-10-03','09:00:00',1.77),('12664','2013-10-03','09:05:00',1.89),('12664','2013-10-03','09:10:00',1.97),('12664','2013-10-03','09:15:00',2.07),('12664','2013-10-03','09:20:00',2.18),('12664','2013-10-03','09:25:00',2.27),('12664','2013-10-03','09:30:00',2.35),('12664','2013-10-03','09:35:00',2.43),('12664','2013-10-03','09:40:00',2.52),('12664','2013-10-03','09:45:00',2.61),('12664','2013-10-03','09:50:00',2.68),('12664','2013-10-03','09:55:00',2.76),('12664','2013-10-03','10:00:00',2.85),('12664','2013-10-03','10:05:00',2.92),('12664','2013-10-03','10:10:00',2.96),('12664','2013-10-03','10:15:00',3.04),('12664','2013-10-03','10:20:00',3.1),('12664','2013-10-03','10:25:00',3.18),('12664','2013-10-03','10:30:00',3.23),('12664','2013-10-03','10:35:00',3.29),('12664','2013-10-03','10:40:00',3.36),('12664','2013-10-03','10:45:00',3.39),('12664','2013-10-03','10:50:00',3.44),('12664','2013-10-03','10:55:00',3.48),('12664','2013-10-03','11:00:00',3.52),('12664','2013-10-03','11:05:00',3.58),('12664','2013-10-03','11:10:00',3.64),('12664','2013-10-03','11:15:00',3.71),('12664','2013-10-03','11:20:00',3.73),('12664','2013-10-03','11:25:00',3.76),('12664','2013-10-03','11:30:00',3.8),('12664','2013-10-03','11:35:00',3.83),('12664','2013-10-03','11:40:00',3.84),('12664','2013-10-03','11:45:00',3.83),('12664','2013-10-03','11:50:00',3.85),('12664','2013-10-03','11:55:00',3.88),('12664','2013-10-03','12:00:00',3.87),('12664','2013-10-03','12:05:00',3.91),('12664','2013-10-03','12:10:00',3.92),('12664','2013-10-03','12:15:00',3.94),('12664','2013-10-03','12:20:00',3.93),('12664','2013-10-03','12:25:00',3.99),('12664','2013-10-03','12:30:00',3.99),('12664','2013-10-03','12:35:00',3.99),('12664','2013-10-03','12:40:00',4),('12664','2013-10-03','12:45:00',3.99),('12664','2013-10-03','12:50:00',4),('12664','2013-10-03','12:55:00',4),('12664','2013-10-03','13:00:00',3.94),('12664','2013-10-03','13:05:00',3.99),('12664','2013-10-03','13:10:00',3.99),('12664','2013-10-03','13:15:00',3.96),('12664','2013-10-03','13:20:00',3.95),('12664','2013-10-03','13:25:00',3.96),('12664','2013-10-03','13:30:00',3.96),('12664','2013-10-03','13:35:00',3.93),('12664','2013-10-03','13:40:00',3.91),('12664','2013-10-03','13:45:00',3.87),('12664','2013-10-03','13:50:00',3.86),('12664','2013-10-03','13:55:00',3.82),('12664','2013-10-03','14:00:00',3.78),('12664','2013-10-03','14:05:00',3.75),('12664','2013-10-03','14:10:00',3.72),('12664','2013-10-03','14:15:00',3.68),('12664','2013-10-03','14:20:00',3.64),('12664','2013-10-03','14:25:00',3.6),('12664','2013-10-03','14:30:00',3.57),('12664','2013-10-03','14:35:00',3.54),('12664','2013-10-03','14:40:00',3.49),('12664','2013-10-03','14:45:00',3.42),('12664','2013-10-03','14:50:00',3.35),('12664','2013-10-03','14:55:00',3.3),('12664','2013-10-03','15:00:00',3.28),('12664','2013-10-03','15:05:00',3.21),('12664','2013-10-03','15:10:00',3.16),('12664','2013-10-03','15:15:00',3.08),('12664','2013-10-03','15:20:00',3.03),('12664','2013-10-03','15:25:00',2.99),('12664','2013-10-03','15:30:00',2.94),('12664','2013-10-03','15:35:00',2.86),('12664','2013-10-03','15:40:00',2.78),('12664','2013-10-03','15:45:00',2.71),('12664','2013-10-03','15:50:00',2.66),('12664','2013-10-03','15:55:00',2.59),('12664','2013-10-03','16:00:00',2.52),('12664','2013-10-03','16:05:00',2.42),('12664','2013-10-03','16:10:00',2.36),('12664','2013-10-03','16:15:00',2.3),('12664','2013-10-03','16:20:00',2.2),('12664','2013-10-03','16:25:00',2.11),('12664','2013-10-03','16:30:00',2.02),('12664','2013-10-03','16:35:00',1.95),('12664','2013-10-03','16:40:00',1.85),('12664','2013-10-03','16:45:00',1.75),('12664','2013-10-03','16:50:00',1.65),('12664','2013-10-03','16:55:00',1.55),('12664','2013-10-03','17:00:00',1.45),('12664','2013-10-03','17:05:00',1.36),('12664','2013-10-03','17:10:00',1.26),('12664','2013-10-03','17:15:00',1.16),('12664','2013-10-03','17:20:00',1.06),('12664','2013-10-02','08:25:00',1.03),('12664','2013-10-02','08:30:00',1.13),('12664','2013-10-02','08:35:00',1.23),('12664','2013-10-02','08:40:00',1.33),('12664','2013-10-02','08:45:00',1.42),('12664','2013-10-02','08:50:00',1.51),('12664','2013-10-02','08:55:00',1.61),('12664','2013-10-02','09:00:00',1.7),('12664','2013-10-02','09:05:00',1.8),('12664','2013-10-02','09:10:00',1.88),('12664','2013-10-02','09:15:00',1.96),('12664','2013-10-02','09:20:00',2.04),('12664','2013-10-02','09:25:00',2.13),('12664','2013-10-02','09:30:00',2.2),('12664','2013-10-02','09:35:00',2.28),('12664','2013-10-02','09:40:00',2.39),('12664','2013-10-02','09:45:00',2.47),('12664','2013-10-02','09:50:00',2.54),('12664','2013-10-02','09:55:00',2.6),('12664','2013-10-02','10:00:00',2.66),('12664','2013-10-02','10:05:00',2.72),('12664','2013-10-02','10:10:00',2.78),('12664','2013-10-02','10:15:00',2.85),('12664','2013-10-02','10:20:00',2.91),('12664','2013-10-02','10:25:00',2.97),('12664','2013-10-02','10:30:00',3.03),('12664','2013-10-02','10:35:00',3.08),('12664','2013-10-02','10:40:00',3.14),('12664','2013-10-02','10:45:00',3.2),('12664','2013-10-02','10:50:00',3.26),('12664','2013-10-02','10:55:00',3.27),('12664','2013-10-02','11:00:00',3.32),('12664','2013-10-02','11:05:00',3.37),('12664','2013-10-02','11:10:00',3.41),('12664','2013-10-02','11:15:00',3.42),('12664','2013-10-02','11:20:00',3.49),('12664','2013-10-02','11:25:00',3.52),('12664','2013-10-02','11:30:00',3.57),('12664','2013-10-02','11:35:00',3.59),('12664','2013-10-02','11:40:00',3.64),('12664','2013-10-02','11:45:00',3.67),('12664','2013-10-02','11:50:00',3.69),('12664','2013-10-02','11:55:00',3.72),('12664','2013-10-02','12:00:00',3.72),('12664','2013-10-02','12:05:00',3.72),('12664','2013-10-02','12:10:00',3.74),('12664','2013-10-02','12:15:00',3.75),('12664','2013-10-02','12:20:00',3.74),('12664','2013-10-02','12:25:00',3.76),('12664','2013-10-02','12:30:00',3.81),('12664','2013-10-02','12:35:00',3.81),('12664','2013-10-02','12:40:00',3.82),('12664','2013-10-02','12:45:00',3.82),('12664','2013-10-02','12:50:00',3.83),('12664','2013-10-02','12:55:00',3.84),('12664','2013-10-02','13:00:00',3.87),('12664','2013-10-02','13:05:00',3.84),('12664','2013-10-02','13:10:00',3.82),('12664','2013-10-02','13:15:00',3.79),('12664','2013-10-02','13:20:00',3.79),('12664','2013-10-02','13:25:00',3.78),('12664','2013-10-02','13:30:00',3.75),('12664','2013-10-02','13:35:00',3.76),('12664','2013-10-02','13:40:00',3.76),('12664','2013-10-02','13:45:00',3.7),('12664','2013-10-02','13:50:00',3.69),('12664','2013-10-02','13:55:00',3.79),('12664','2013-10-02','14:00:00',3.81),('12664','2013-10-02','14:05:00',3.73),('12664','2013-10-02','14:10:00',3.7),('12664','2013-10-02','14:15:00',3.69),('12664','2013-10-02','14:20:00',3.62),('12664','2013-10-02','14:25:00',3.54),('12664','2013-10-02','14:30:00',3.5),('12664','2013-10-02','14:35:00',3.43),('12664','2013-10-02','14:40:00',3.41),('12664','2013-10-02','14:45:00',3.39),('12664','2013-10-02','14:50:00',3.33),('12664','2013-10-02','14:55:00',3.26),('12664','2013-10-02','15:00:00',3.26),('12664','2013-10-02','15:05:00',3.17),('12664','2013-10-02','15:10:00',3.11),('12664','2013-10-02','15:15:00',3.06),('12664','2013-10-02','15:20:00',3.01),('12664','2013-10-02','15:25:00',2.94),('12664','2013-10-02','15:30:00',2.88),('12664','2013-10-02','15:35:00',2.81),('12664','2013-10-02','15:40:00',2.74),('12664','2013-10-02','15:45:00',2.68),('12664','2013-10-02','15:50:00',2.58),('12664','2013-10-02','15:55:00',2.51),('12664','2013-10-02','16:00:00',2.46),('12664','2013-10-02','16:05:00',2.39),('12664','2013-10-02','16:20:00',2.08),('12664','2013-10-02','16:25:00',2.03),('12664','2013-10-02','16:30:00',1.93),('12664','2013-10-02','16:35:00',1.86),('12664','2013-10-02','16:40:00',1.78),('12664','2013-10-02','16:45:00',1.68),('12664','2013-10-02','16:50:00',1.59),('12664','2013-10-02','16:55:00',1.49),('12664','2013-10-02','17:00:00',1.39),('12664','2013-10-02','17:05:00',1.31),('12664','2013-10-02','17:10:00',1.21),('12664','2013-10-02','17:15:00',1.11),('12664','2013-10-02','17:20:00',1.02),('12664','2013-10-01','08:25:00',1.02),('12664','2013-10-01','08:30:00',1.13),('12664','2013-10-01','08:35:00',1.23),('12664','2013-10-01','08:40:00',1.33),('12664','2013-10-01','08:45:00',1.43),('12664','2013-10-01','08:50:00',1.52),('12664','2013-10-01','08:55:00',1.61),('12664','2013-10-01','09:00:00',1.71),('12664','2013-10-01','09:05:00',1.79),('12664','2013-10-01','09:10:00',1.86),('12664','2013-10-01','09:15:00',1.94),('12664','2013-10-01','09:20:00',2.01),('12664','2013-10-01','09:25:00',2.07),('12664','2013-10-01','09:30:00',2.19),('12664','2013-10-01','09:35:00',2.28),('12664','2013-10-01','09:40:00',2.38),('12664','2013-10-01','09:45:00',2.46),('12664','2013-10-01','09:50:00',2.53),('12664','2013-10-01','09:55:00',2.61),('12664','2013-10-01','10:00:00',2.67),('12664','2013-10-01','10:05:00',2.74),('12664','2013-10-01','10:10:00',2.82),('12664','2013-10-01','10:15:00',2.87),('12664','2013-10-01','10:20:00',2.96),('12664','2013-10-01','10:25:00',3),('12664','2013-10-01','10:30:00',3.02),('12664','2013-10-01','10:35:00',3.1),('12664','2013-10-01','10:40:00',3.17),('12664','2013-10-01','10:45:00',3.24),('12664','2013-10-01','10:50:00',3.25),('12664','2013-10-01','10:55:00',3.26),('12664','2013-10-01','11:00:00',2.34),('12664','2013-10-01','11:05:00',2.02),('12664','2013-10-01','11:10:00',3.46),('12664','2013-10-01','11:15:00',3.11),('12664','2013-10-01','11:20:00',2.8),('12664','2013-10-01','11:25:00',3.8),('12664','2013-10-01','11:30:00',3.83),('12664','2013-10-01','11:35:00',3.67),('12664','2013-10-01','11:40:00',3.8),('12664','2013-10-01','11:45:00',3.91),('12664','2013-10-01','11:50:00',4.05),('12664','2013-10-01','11:55:00',1.65),('12664','2013-10-01','12:00:00',2.04),('12664','2013-10-01','12:05:00',3.92),('12664','2013-10-01','12:10:00',3.06),('12664','2013-10-01','12:15:00',1.97),('12664','2013-10-01','12:20:00',1.17),('12664','2013-10-01','12:25:00',3.6),('12664','2013-10-01','12:30:00',3.5),('12664','2013-10-01','12:35:00',1.11),('12664','2013-10-01','12:40:00',4.32),('12664','2013-10-01','12:45:00',3.86),('12664','2013-10-01','12:50:00',3.41),('12664','2013-10-01','12:55:00',2.54),('12664','2013-10-01','13:00:00',3.04),('12664','2013-10-01','13:10:00',3.2),('12664','2013-10-01','13:15:00',2.19),('12664','2013-10-01','13:20:00',4.09),('12664','2013-10-01','13:25:00',4.19),('12664','2013-10-01','13:30:00',4.1),('12664','2013-10-01','13:35:00',3.97),('12664','2013-10-01','13:40:00',3.8),('12664','2013-10-01','13:45:00',3.77),('12664','2013-10-01','13:50:00',3.73),('12664','2013-10-01','13:55:00',3.71),('12664','2013-10-01','14:00:00',3.65),('12664','2013-10-01','14:05:00',3.61),('12664','2013-10-01','14:10:00',3.6),('12664','2013-10-01','14:15:00',3.56),('12664','2013-10-01','14:20:00',3.54),('12664','2013-10-01','14:25:00',3.5),('12664','2013-10-01','14:30:00',3.45),('12664','2013-10-01','14:35:00',3.46),('12664','2013-10-01','14:40:00',3.4),('12664','2013-10-01','14:45:00',3.37),('12664','2013-10-01','14:50:00',3.33),('12664','2013-10-01','14:55:00',3.29),('12664','2013-10-01','15:00:00',3.24),('12664','2013-10-01','15:05:00',3.18),('12664','2013-10-01','15:10:00',3.13),('12664','2013-10-01','15:15:00',3.07),('12664','2013-10-01','15:20:00',3.02),('12664','2013-10-01','15:25:00',2.97),('12664','2013-10-01','15:30:00',2.91),('12664','2013-10-01','15:35:00',2.81),('12664','2013-10-01','15:40:00',2.75),('12664','2013-10-01','15:45:00',2.68),('12664','2013-10-01','15:50:00',2.62),('12664','2013-10-01','15:55:00',2.57),('12664','2013-10-01','16:00:00',2.5),('12664','2013-10-01','16:05:00',2.43),('12664','2013-10-01','16:10:00',2.37),('12664','2013-10-01','16:15:00',2.28),('12664','2013-10-01','16:20:00',2.2),('12664','2013-10-01','16:25:00',2.11),('12664','2013-10-01','16:30:00',2),('12664','2013-10-01','16:35:00',1.91),('12664','2013-10-01','16:40:00',1.85),('12664','2013-10-01','16:45:00',1.75),('12664','2013-10-01','16:50:00',1.66),('12664','2013-10-01','16:55:00',1.57),('12664','2013-10-01','17:00:00',1.45),('12664','2013-10-01','17:05:00',1.35),('12664','2013-10-01','17:10:00',1.25),('12664','2013-10-01','17:15:00',1.15),('12664','2013-10-01','17:20:00',1.07),('12664','2013-09-30','09:30:00',1.03),('12664','2013-09-30','09:35:00',1.29),('12664','2013-09-30','09:40:00',2.15),('12664','2013-09-30','09:45:00',2.07),('12664','2013-09-30','09:50:00',1.01),('12664','2013-09-30','10:05:00',1.01),('12664','2013-09-30','10:10:00',1.11),('12664','2013-09-30','10:15:00',1.12),('12664','2013-09-30','10:20:00',1.23),('12664','2013-09-30','10:25:00',1.46),('12664','2013-09-30','10:30:00',1.67),('12664','2013-09-30','10:35:00',2.01),('12664','2013-09-30','10:40:00',3),('12664','2013-09-30','10:45:00',3.05),('12664','2013-09-30','10:50:00',2.77),('12664','2013-09-30','10:55:00',3.06),('12664','2013-09-30','11:00:00',3.51),('12664','2013-09-30','11:05:00',3.58),('12664','2013-09-30','11:10:00',3.59),('12664','2013-09-30','11:15:00',2.34),('12664','2013-09-30','11:20:00',3.41),('12664','2013-09-30','11:25:00',3.49),('12664','2013-09-30','11:30:00',3.81),('12664','2013-09-30','11:35:00',3.32),('12664','2013-09-30','11:40:00',2.06),('12664','2013-09-30','11:45:00',1.8),('12664','2013-09-30','11:50:00',1.38),('12664','2013-09-30','11:55:00',3.02),('12664','2013-09-30','12:00:00',3.93),('12664','2013-09-30','12:05:00',3.99),('12664','2013-09-30','12:10:00',3.96),('12664','2013-09-30','12:15:00',3.92),('12664','2013-09-30','12:20:00',3.91),('12664','2013-09-30','12:25:00',3.72),('12664','2013-09-30','12:30:00',3.95),('12664','2013-09-30','12:35:00',3.97),('12664','2013-09-30','12:40:00',3.97),('12664','2013-09-30','12:45:00',3.86),('12664','2013-09-30','12:50:00',4.25),('12664','2013-09-30','12:55:00',4.25),('12664','2013-09-30','13:00:00',3.43),('12664','2013-09-30','13:05:00',2.62),('12664','2013-09-30','13:10:00',4.38),('12664','2013-09-30','13:15:00',3.99),('12664','2013-09-30','13:20:00',3.85),('12664','2013-09-30','13:25:00',4.26),('12664','2013-09-30','13:30:00',4.42),('12664','2013-09-30','13:35:00',3.84),('12664','2013-09-30','13:40:00',1.74),('12664','2013-09-30','14:00:00',1.17),('12664','2013-09-30','14:05:00',1.21),('12664','2013-09-30','14:10:00',1.07),('12664','2013-09-30','14:25:00',2.53),('12664','2013-09-30','14:30:00',4.11),('12664','2013-09-30','14:35:00',4.77),('12664','2013-09-30','14:40:00',4.37),('12664','2013-09-30','14:45:00',2.62),('12664','2013-09-30','14:50:00',2.83),('12664','2013-09-30','14:55:00',3.57),('12664','2013-09-30','15:00:00',2.33),('12664','2013-09-30','15:05:00',1.31),('12664','2013-09-30','15:10:00',2.57),('12664','2013-09-30','15:15:00',1.88),('12664','2013-09-30','15:20:00',1.07),('12664','2013-09-30','15:25:00',1.37),('12664','2013-09-30','15:50:00',3.02),('12664','2013-09-30','15:55:00',2.86),('12664','2013-09-30','16:00:00',2.8),('12664','2013-09-30','16:05:00',1.96),('12664','2013-09-30','16:10:00',1.51),('12664','2013-09-30','16:15:00',1.52),('12664','2013-09-30','16:20:00',1.51),('12664','2013-09-30','16:25:00',2.69),('12664','2013-09-30','16:30:00',1.8),('12664','2013-09-30','16:35:00',1.64),('12664','2013-09-30','16:40:00',2.1),('12664','2013-09-30','16:45:00',1.97),('12664','2013-09-30','16:50:00',1.78),('12664','2013-09-30','16:55:00',1.31),('12664','2013-09-30','17:00:00',1.07),('12664','2013-09-30','17:10:00',1.31),('12664','2013-09-30','17:15:00',1.13),('12664','2013-09-30','17:20:00',1.19),('12664','2013-09-29','08:40:00',1.03),('12664','2013-09-29','08:45:00',1.1),('12664','2013-09-29','09:50:00',1.16),('12664','2013-09-29','09:55:00',1.89),('12664','2013-09-29','10:00:00',2.24),('12664','2013-09-29','10:05:00',2.2),('12664','2013-09-29','10:10:00',2.41),('12664','2013-09-29','10:15:00',2.03),('12664','2013-09-29','10:20:00',2.46),('12664','2013-09-29','10:25:00',2.54),('12664','2013-09-29','10:30:00',2.53),('12664','2013-09-29','10:35:00',2.71),('12664','2013-09-29','10:40:00',2.7),('12664','2013-09-29','10:45:00',2.9),('12664','2013-09-29','10:50:00',2.96),('12664','2013-09-29','10:55:00',2.87),('12664','2013-09-29','11:00:00',2.89),('12664','2013-09-29','11:05:00',2.72),('12664','2013-09-29','11:10:00',2.83),('12664','2013-09-29','11:15:00',2.98),('12664','2013-09-29','11:20:00',2.94),('12664','2013-09-29','11:25:00',2.93),('12664','2013-09-29','11:30:00',3.04),('12664','2013-09-29','11:35:00',3.12),('12664','2013-09-29','11:40:00',3.29),('12664','2013-09-29','11:45:00',3.22),('12664','2013-09-29','11:50:00',3.01),('12664','2013-09-29','11:55:00',3.11),('12664','2013-09-29','12:00:00',3.46),('12664','2013-09-29','12:05:00',3.27),('12664','2013-09-29','12:10:00',2.91),('12664','2013-09-29','12:15:00',1.94),('12664','2013-09-29','12:25:00',1.02),('12664','2013-09-29','12:30:00',1.18),('12664','2013-09-29','12:35:00',1.61),('12664','2013-09-29','12:40:00',1.3),('12664','2013-09-29','12:45:00',1.34),('12664','2013-09-29','12:50:00',1.34),('12664','2013-09-29','13:20:00',1.43),('12664','2013-09-29','13:25:00',2.38),('12664','2013-09-29','13:30:00',1.92),('12664','2013-09-29','13:35:00',2.03),('12664','2013-09-29','13:40:00',2.67),('12664','2013-09-29','13:45:00',2.27),('12664','2013-09-29','13:50:00',2.06),('12664','2013-09-29','13:55:00',1.56),('12664','2013-09-29','14:00:00',1.39),('12664','2013-09-29','14:05:00',1.23),('12664','2013-09-29','14:10:00',1.02),('12664','2013-09-29','14:20:00',1.09),('12664','2013-09-29','14:25:00',1.06),('12664','2013-09-29','14:50:00',1.77),('12664','2013-09-29','15:15:00',1.26),('12664','2013-09-29','15:20:00',1.15),('12664','2013-09-29','15:25:00',1.5),('12664','2013-09-29','15:55:00',1.16),('12664','2013-09-29','16:25:00',1.47),('12664','2013-09-29','16:30:00',1.31),('12664','2013-09-28','08:35:00',1.09),('12664','2013-09-28','08:40:00',1.18),('12664','2013-09-28','08:45:00',1.27),('12664','2013-09-28','08:50:00',1.41),('12664','2013-09-28','08:55:00',1.5),('12664','2013-09-28','09:00:00',1.59),('12664','2013-09-28','09:05:00',1.67),('12664','2013-09-28','09:10:00',1.76),('12664','2013-09-28','09:15:00',1.85),('12664','2013-09-28','09:20:00',1.92),('12664','2013-09-28','09:25:00',2.01),('12664','2013-09-28','09:30:00',1.97),('12664','2013-09-28','09:35:00',1.98),('12664','2013-09-28','09:40:00',2.03),('12664','2013-09-28','09:45:00',2.04),('12664','2013-09-28','10:30:00',1.8),('12664','2013-09-28','10:35:00',3.33),('12664','2013-09-28','10:40:00',3.46),('12664','2013-09-28','10:45:00',3.4),('12664','2013-09-28','10:50:00',3.55),('12664','2013-09-28','10:55:00',3.65),('12664','2013-09-28','11:00:00',3.35),('12664','2013-09-28','11:05:00',3.68),('12664','2013-09-28','11:10:00',3.67),('12664','2013-09-28','11:15:00',1.29),('12664','2013-09-28','11:25:00',3.06),('12664','2013-09-28','11:30:00',2.26),('12664','2013-09-28','11:40:00',1.31),('12664','2013-09-28','11:45:00',3.86),('12664','2013-09-28','11:50:00',3.77),('12664','2013-09-28','11:55:00',3.64),('12664','2013-09-28','12:00:00',1.36),('12664','2013-09-28','12:05:00',3.67),('12664','2013-09-28','12:10:00',4.21),('12664','2013-09-28','12:15:00',4.17),('12664','2013-09-28','12:20:00',4.06),('12664','2013-09-28','12:25:00',3.92),('12664','2013-09-28','12:30:00',3.95),('12664','2013-09-28','12:35:00',3.86),('12664','2013-09-28','12:40:00',3.82),('12664','2013-09-28','12:45:00',3.82),('12664','2013-09-28','12:50:00',3.82),('12664','2013-09-28','12:55:00',3.81),('12664','2013-09-28','13:00:00',3.89),('12664','2013-09-28','13:05:00',3.66),('12664','2013-09-28','13:10:00',3.35),('12664','2013-09-28','13:15:00',3.63),('12664','2013-09-28','13:20:00',3.76),('12664','2013-09-28','13:25:00',3.73),('12664','2013-09-28','13:30:00',3.73),('12664','2013-09-28','13:35:00',3.73),('12664','2013-09-28','13:40:00',3.73),('12664','2013-09-28','13:45:00',3.67),('12664','2013-09-28','13:50:00',3.62),('12664','2013-09-28','13:55:00',2.23),('12664','2013-09-28','14:00:00',3.63),('12664','2013-09-28','14:05:00',3.73),('12664','2013-09-28','14:10:00',3.51),('12664','2013-09-28','14:15:00',3.56),('12664','2013-09-28','14:20:00',3.51),('12664','2013-09-28','14:25:00',3.64),('12664','2013-09-28','14:30:00',3.71),('12664','2013-09-28','14:35:00',3.39),('12664','2013-09-28','14:40:00',2.48),('12664','2013-09-28','14:45:00',3.38),('12664','2013-09-28','14:50:00',2.39),('12664','2013-09-28','14:55:00',2.85),('12664','2013-09-28','15:00:00',2.85),('12664','2013-09-28','15:05:00',2.85),('12664','2013-09-28','15:10:00',3.06),('12664','2013-09-28','15:15:00',2.95),('12664','2013-09-28','15:20:00',2.41),('12664','2013-09-28','15:25:00',2.97),('12664','2013-09-28','15:30:00',1.85),('12664','2013-09-28','15:35:00',2.97),('12664','2013-09-28','15:40:00',2.69),('12664','2013-09-28','15:45:00',2.59),('12664','2013-09-28','15:50:00',2.51),('12664','2013-09-28','15:55:00',2.46),('12664','2013-09-28','16:00:00',2.37),('12664','2013-09-28','16:05:00',2.34),('12664','2013-09-28','16:10:00',2.29),('12664','2013-09-28','16:15:00',2.22),('12664','2013-09-28','16:20:00',1.67),('12664','2013-09-28','16:25:00',1.64),('12664','2013-09-28','16:30:00',1.97),('12664','2013-09-28','16:35:00',1.9),('12664','2013-09-28','16:40:00',1.78),('12664','2013-09-28','16:45:00',1.69),('12664','2013-09-28','16:50:00',1.58),('12664','2013-09-28','16:55:00',1.48),('12664','2013-09-28','17:00:00',1.41),('12664','2013-09-28','17:05:00',1.32),('12664','2013-09-28','17:10:00',1.23),('12664','2013-09-28','17:15:00',1.14),('12664','2013-09-28','17:20:00',1.06),('12664','2014-04-13','09:30:00',1),('12664','2014-04-13','09:35:00',1.13),('12664','2014-04-13','09:40:00',1.55),('12664','2014-04-13','09:45:00',1.34),('12664','2014-04-13','09:50:00',1.73),('12664','2014-04-13','09:55:00',1.74),('12664','2014-04-13','10:00:00',3.04),('12664','2014-04-13','10:05:00',2.91),('12664','2014-04-13','10:10:00',1.71),('12664','2014-04-13','10:15:00',1.81),('12664','2014-04-13','10:20:00',1.73),('12664','2014-04-13','10:25:00',2),('12664','2014-04-13','10:30:00',3.07),('12664','2014-04-13','10:35:00',3.53),('12664','2014-04-13','10:40:00',3.6),('12664','2014-04-13','10:45:00',3.44),('12664','2014-04-13','10:50:00',3.1),('12664','2014-04-13','10:55:00',1.27),('12664','2014-04-13','11:00:00',3.74),('12664','2014-04-13','11:05:00',3.41),('12664','2014-04-13','11:10:00',2.08),('12664','2014-04-13','11:15:00',1.55),('12664','2014-04-13','11:20:00',1.14),('12664','2014-04-13','11:25:00',1.68),('12664','2014-04-13','11:30:00',1.65),('12664','2014-04-13','11:35:00',1.84),('12664','2014-04-13','11:40:00',1.76),('12664','2014-04-13','11:45:00',3.84),('12664','2014-04-13','11:50:00',2.55),('12664','2014-04-13','11:55:00',1.65),('12664','2014-04-13','12:00:00',1.51),('12664','2014-04-13','12:05:00',1.36),('12664','2014-04-13','12:10:00',1.3),('12664','2014-04-13','12:50:00',1.26),('12664','2014-04-13','12:55:00',1.77),('12664','2014-04-13','13:00:00',4.11),('12664','2014-04-13','13:05:00',4.67),('12664','2014-04-13','13:10:00',4),('12664','2014-04-13','13:15:00',4.12),('12664','2014-04-13','13:20:00',2.97),('12664','2014-04-13','13:25:00',4.11),('12664','2014-04-13','13:30:00',3.82),('12664','2014-04-13','13:35:00',2.21),('12664','2014-04-13','13:40:00',2.23),('12664','2014-04-13','13:45:00',1.92),('12664','2014-04-13','13:50:00',1.92),('12664','2014-04-13','13:55:00',1.97),('12664','2014-04-13','14:00:00',2.68),('12664','2014-04-13','14:05:00',2.49),('12664','2014-04-13','14:10:00',1.88),('12664','2014-04-13','14:15:00',1.52),('12664','2014-04-13','14:20:00',1.53),('12664','2014-04-13','14:25:00',1.51),('12664','2014-04-13','14:30:00',1.52),('12664','2014-04-13','14:35:00',1.84),('12664','2014-04-13','14:40:00',2.44),('12664','2014-04-13','14:45:00',3.67),('12664','2014-04-13','14:50:00',3.35),('12664','2014-04-13','14:55:00',3.86),('12664','2014-04-13','15:00:00',3.88),('12664','2014-04-13','15:05:00',3.33),('12664','2014-04-13','15:10:00',3.23),('12664','2014-04-13','15:15:00',3.57),('12664','2014-04-13','15:20:00',3.5),('12664','2014-04-13','15:25:00',3.02),('12664','2014-04-13','15:30:00',1.71),('12664','2014-04-13','15:35:00',1.79),('12664','2014-04-13','15:40:00',1.68),('12664','2014-04-13','15:45:00',2),('12664','2014-04-13','15:50:00',1.66),('12664','2014-04-13','15:55:00',1.38),('12664','2014-04-13','16:00:00',1.34),('12664','2014-04-13','16:05:00',1.15),('12664','2014-04-13','16:10:00',1.2),('12664','2014-04-13','16:15:00',1.45),('12664','2014-04-13','16:20:00',1.15),('12664','2014-04-13','16:25:00',1.04),('12664','2014-04-13','16:30:00',1.38),('12664','2014-04-13','16:35:00',2.16),('12664','2014-04-13','16:40:00',2.67),('12664','2014-04-13','16:45:00',2.56),('12664','2014-04-13','16:50:00',1.83),('12664','2014-04-13','16:55:00',2),('12664','2014-04-13','17:00:00',1.47),('12664','2014-04-13','17:05:00',1.62),('12664','2014-04-13','17:10:00',1.27),('12664','2014-04-13','17:15:00',1.02),('12664','2014-04-13','17:30:00',1.04),('12664','2014-04-13','17:35:00',1.13),('12664','2014-04-13','17:40:00',1.16),('12664','2014-04-13','17:45:00',1.13),('12664','2014-04-13','17:50:00',1.18),('12664','2014-04-13','17:55:00',1.03),('12664','2013-09-27','08:45:00',1.1),('12664','2013-09-27','08:50:00',1.13),('12664','2013-09-27','09:00:00',1.39),('12664','2013-09-27','09:05:00',1.68),('12664','2013-09-27','09:10:00',2.08),('12664','2013-09-27','09:15:00',2.18),('12664','2013-09-27','09:20:00',1.23),('12664','2013-09-27','10:00:00',1.16),('12664','2013-09-27','10:05:00',1.69),('12664','2013-09-27','10:10:00',2.33),('12664','2013-09-27','10:15:00',2.29),('12664','2013-09-27','10:20:00',2.49),('12664','2013-09-27','10:25:00',1.49),('12664','2013-09-27','10:30:00',2.88),('12664','2013-09-27','10:35:00',3.1),('12664','2013-09-27','10:40:00',2.97),('12664','2013-09-27','10:45:00',3.09),('12664','2013-09-27','10:50:00',3.12),('12664','2013-09-27','10:55:00',3.14),('12664','2013-09-27','11:00:00',3.17),('12664','2013-09-27','11:05:00',3.27),('12664','2013-09-27','11:10:00',3.29),('12664','2013-09-27','11:15:00',3.35),('12664','2013-09-27','11:20:00',3.41),('12664','2013-09-27','11:25:00',3.12),('12664','2013-09-27','11:30:00',2.21),('12664','2013-09-27','11:35:00',1.94),('12664','2013-09-27','11:40:00',1.39),('12664','2013-09-27','11:45:00',1.71),('12664','2013-09-27','11:50:00',3.2),('12664','2013-09-27','11:55:00',4.26),('12664','2013-09-27','12:00:00',3.29),('12664','2013-09-27','12:05:00',3.53),('12664','2013-09-27','12:10:00',2.6),('12664','2013-09-27','12:15:00',3.79),('12664','2013-09-27','12:20:00',3.93),('12664','2013-09-27','12:25:00',4.09),('12664','2013-09-27','12:30:00',1.39),('12664','2013-09-27','12:40:00',1.84),('12664','2013-09-27','12:45:00',1.63),('12664','2013-09-27','12:50:00',1.04),('12664','2013-09-27','12:55:00',1.9),('12664','2013-09-27','13:00:00',1.64),('12664','2013-09-27','13:05:00',4.25),('12664','2013-09-27','13:10:00',3.35),('12664','2013-09-27','13:15:00',4.23),('12664','2013-09-27','13:20:00',4.2),('12664','2013-09-27','13:25:00',3.08),('12664','2013-09-27','13:30:00',3.97),('12664','2013-09-27','13:35:00',4.02),('12664','2013-09-27','13:40:00',3.94),('12664','2013-09-27','13:45:00',1.93),('12664','2013-09-27','13:50:00',2.56),('12664','2013-09-27','13:55:00',3.46),('12664','2013-09-27','14:00:00',2.67),('12664','2013-09-27','14:05:00',3.07),('12664','2013-09-27','14:10:00',3.78),('12664','2013-09-27','14:15:00',3.64),('12664','2013-09-27','14:20:00',3.01),('12664','2013-09-27','14:25:00',3.35),('12664','2013-09-27','14:30:00',3.61),('12664','2013-09-27','14:35:00',3.63),('12664','2013-09-27','14:40:00',3.46),('12664','2013-09-27','14:45:00',3.47),('12664','2013-09-27','14:50:00',3.38),('12664','2013-09-27','14:55:00',3.34),('12664','2013-09-27','15:00:00',3.2),('12664','2013-09-27','15:05:00',3.1),('12664','2013-09-27','15:10:00',2.75),('12664','2013-09-27','15:15:00',3.14),('12664','2013-09-27','15:20:00',3.02),('12664','2013-09-27','15:25:00',2.96),('12664','2013-09-27','15:30:00',3.01),('12664','2013-09-27','15:35:00',2.02),('12664','2013-09-27','15:40:00',2.52),('12664','2013-09-27','15:45:00',2.8),('12664','2013-09-27','15:50:00',2.56),('12664','2013-09-27','15:55:00',2.75),('12664','2013-09-27','16:00:00',2.59),('12664','2013-09-27','16:05:00',2.4),('12664','2013-09-27','16:10:00',2.17),('12664','2013-09-27','16:15:00',1.59),('12664','2013-09-27','16:20:00',2.23),('12664','2013-09-27','16:25:00',2.11),('12664','2013-09-27','16:30:00',2.05),('12664','2013-09-27','16:35:00',1.97),('12664','2013-09-27','16:40:00',1.87),('12664','2013-09-27','16:45:00',1.75),('12664','2013-09-27','16:50:00',1.65),('12664','2013-09-27','16:55:00',1.66),('12664','2013-09-27','17:00:00',1.26),('12664','2013-09-27','17:05:00',1.39),('12664','2013-09-27','17:15:00',1),('12664','2013-09-27','17:20:00',1.29),('12664','2013-09-27','17:25:00',1.08),('12664','2013-09-26','08:25:00',1.05),('12664','2013-09-26','08:30:00',1.16),('12664','2013-09-26','08:35:00',1.25),('12664','2013-09-26','08:40:00',1.34),('12664','2013-09-26','08:45:00',1.45),('12664','2013-09-26','08:50:00',1.52),('12664','2013-09-26','08:55:00',1.62),('12664','2013-09-26','09:00:00',1.73),('12664','2013-09-26','09:05:00',1.84),('12664','2013-09-26','09:10:00',1.95),('12664','2013-09-26','09:15:00',1.98),('12664','2013-09-26','09:20:00',2.05),('12664','2013-09-26','09:25:00',2.13),('12664','2013-09-26','09:30:00',2.21),('12664','2013-09-26','09:35:00',2.3),('12664','2013-09-26','09:40:00',2.36),('12664','2013-09-26','09:45:00',2.43),('12664','2013-09-26','09:50:00',2.51),('12664','2013-09-26','09:55:00',2.59),('12664','2013-09-26','10:00:00',2.66),('12664','2013-09-26','10:05:00',2.74),('12664','2013-09-26','10:10:00',2.76),('12664','2013-09-26','10:15:00',2.82),('12664','2013-09-26','10:20:00',2.86),('12664','2013-09-26','10:25:00',2.89),('12664','2013-09-26','10:30:00',2.95),('12664','2013-09-26','10:35:00',2.97),('12664','2013-09-26','10:40:00',3.03),('12664','2013-09-26','10:45:00',3.07),('12664','2013-09-26','10:50:00',3.11),('12664','2013-09-26','10:55:00',3.14),('12664','2013-09-26','11:00:00',3.23),('12664','2013-09-26','11:05:00',3.33),('12664','2013-09-26','11:10:00',3.4),('12664','2013-09-26','11:15:00',3.44),('12664','2013-09-26','11:20:00',3.38),('12664','2013-09-26','11:25:00',3.42),('12664','2013-09-26','11:30:00',3.59),('12664','2013-09-26','11:35:00',3.68),('12664','2013-09-26','11:40:00',3.58),('12664','2013-09-26','11:45:00',2.75),('12664','2013-09-26','11:50:00',3.63),('12664','2013-09-26','11:55:00',3.77),('12664','2013-09-26','12:00:00',3.93),('12664','2013-09-26','12:05:00',3.81),('12664','2013-09-26','12:10:00',3.68),('12664','2013-09-26','12:15:00',3.56),('12664','2013-09-26','12:20:00',3.43),('12664','2013-09-26','12:25:00',2.99),('12664','2013-09-26','12:30:00',1.35),('12664','2013-09-26','12:35:00',1.7),('12664','2013-09-26','12:40:00',2.1),('12664','2013-09-26','12:45:00',3.33),('12664','2013-09-26','12:50:00',2.74),('12664','2013-09-26','12:55:00',3.6),('12664','2013-09-26','13:00:00',3.94),('12664','2013-09-26','13:05:00',3.56),('12664','2013-09-26','13:10:00',3.18),('12664','2013-09-26','13:15:00',2.07),('12664','2013-09-26','13:20:00',1.64),('12664','2013-09-26','13:25:00',1.58),('12664','2013-09-26','13:30:00',1.66),('12664','2013-09-26','13:35:00',1.71),('12664','2013-09-26','13:40:00',3.71),('12664','2013-09-26','13:45:00',3.28),('12664','2013-09-26','13:50:00',3.64),('12664','2013-09-26','13:55:00',3.51),('12664','2013-09-26','14:00:00',2.29),('12664','2013-09-26','14:05:00',3.53),('12664','2013-09-26','14:10:00',3.74),('12664','2013-09-26','14:15:00',1.86),('12664','2013-09-26','14:20:00',2.88),('12664','2013-09-26','14:25:00',3.91),('12664','2013-09-26','14:30:00',3.49),('12664','2013-09-26','14:35:00',3.44),('12664','2013-09-26','14:40:00',3.45),('12664','2013-09-26','14:45:00',3.46),('12664','2013-09-26','14:50:00',3.42),('12664','2013-09-26','14:55:00',3.46),('12664','2013-09-26','15:00:00',3.56),('12664','2013-09-26','15:05:00',3.4),('12664','2013-09-26','15:10:00',3.36),('12664','2013-09-26','15:15:00',3.23),('12664','2013-09-26','15:20:00',3.1),('12664','2013-09-26','15:25:00',3.01),('12664','2013-09-26','15:30:00',2.97),('12664','2013-09-26','15:35:00',2.85),('12664','2013-09-26','15:40:00',2.8),('12664','2013-09-26','15:45:00',2.79),('12664','2013-09-26','15:50:00',2.69),('12664','2013-09-26','15:55:00',2.54),('12664','2013-09-26','16:00:00',2.51),('12664','2013-09-26','16:05:00',1.89),('12664','2013-09-26','16:10:00',2.32),('12664','2013-09-26','16:15:00',2.05),('12664','2013-09-26','16:20:00',2.23),('12664','2013-09-26','16:25:00',2.12),('12664','2013-09-26','16:30:00',2.05),('12664','2013-09-26','16:35:00',1.95),('12664','2013-09-26','16:40:00',1.85),('12664','2013-09-26','16:45:00',1.77),('12664','2013-09-26','16:50:00',1.68),('12664','2013-09-26','16:55:00',1.62),('12664','2013-09-26','17:00:00',1.54),('12664','2013-09-26','17:05:00',1.57),('12664','2013-09-26','17:10:00',1.52),('12664','2013-09-26','17:15:00',1.29),('12664','2013-09-26','17:20:00',1.19),('12664','2013-09-26','17:25:00',1.08),('12664','2013-09-25','08:20:00',1.18),('12664','2013-09-25','08:25:00',1.12),('12664','2013-09-25','08:35:00',1.25),('12664','2013-09-25','08:40:00',1.07),('12664','2013-09-25','08:45:00',1.29),('12664','2013-09-25','08:50:00',1.44),('12664','2013-09-25','08:55:00',1.17),('12664','2013-09-25','10:00:00',1.14),('12664','2013-09-25','10:05:00',1.49),('12664','2013-09-25','10:10:00',2.86),('12664','2013-09-25','10:15:00',2.97),('12664','2013-09-25','10:20:00',3.03),('12664','2013-09-25','10:25:00',3.05),('12664','2013-09-25','10:30:00',3.13),('12664','2013-09-25','10:35:00',3.25),('12664','2013-09-25','10:40:00',3.57),('12664','2013-09-25','10:45:00',1.65),('12664','2013-09-25','10:50:00',2.7),('12664','2013-09-25','10:55:00',2.78),('12664','2013-09-25','11:10:00',2.94),('12664','2013-09-25','11:15:00',3.99),('12664','2013-09-25','11:20:00',4.06),('12664','2013-09-25','11:25:00',3.32),('12664','2013-09-25','11:30:00',1.67),('12664','2013-09-25','11:35:00',4.25),('12664','2013-09-25','11:40:00',2.79),('12664','2013-09-25','11:55:00',1.51),('12664','2013-09-25','12:00:00',3.29),('12664','2013-09-25','12:05:00',3.99),('12664','2013-09-25','12:10:00',4.19),('12664','2013-09-25','12:15:00',3.26),('12664','2013-09-25','12:20:00',3.82),('12664','2013-09-25','12:25:00',4.19),('12664','2013-09-25','12:30:00',4.11),('12664','2013-09-25','12:35:00',4.12),('12664','2013-09-25','12:40:00',4.21),('12664','2013-09-25','12:45:00',4.3),('12664','2013-09-25','12:50:00',4.36),('12664','2013-09-25','12:55:00',3.72),('12664','2013-09-25','13:00:00',4.23),('12664','2013-09-25','13:05:00',1.4),('12664','2013-09-25','13:10:00',1.51),('12664','2013-09-25','13:15:00',3.72),('12664','2013-09-25','13:20:00',4.19),('12664','2013-09-25','13:25:00',4.26),('12664','2013-09-25','13:30:00',4.12),('12664','2013-09-25','13:35:00',1.79),('12664','2013-09-25','13:40:00',2.65),('12664','2013-09-25','13:45:00',4.46),('12664','2013-09-25','13:50:00',4.23),('12664','2013-09-25','13:55:00',4.15),('12664','2013-09-25','14:00:00',4.07),('12664','2013-09-25','14:05:00',3.09),('12664','2013-09-25','14:10:00',3.71),('12664','2013-09-25','14:15:00',1.74),('12664','2013-09-25','14:20:00',1.22),('12664','2013-09-25','14:25:00',2.27),('12664','2013-09-25','14:30:00',4.02),('12664','2013-09-25','14:35:00',3.1),('12664','2013-09-25','14:45:00',1.19),('12664','2013-09-25','14:50:00',2.91),('12664','2013-09-25','14:55:00',3.66),('12664','2013-09-25','15:00:00',3.22),('12664','2013-09-25','15:05:00',2.97),('12664','2013-09-25','15:10:00',3.34),('12664','2013-09-25','15:15:00',3.16),('12664','2013-09-25','15:20:00',3.31),('12664','2013-09-25','15:25:00',3.21),('12664','2013-09-25','15:30:00',2.71),('12664','2013-09-25','15:35:00',3.22),('12664','2013-09-25','15:40:00',3.05),('12664','2013-09-25','15:45:00',2.81),('12664','2013-09-25','15:50:00',2.91),('12664','2013-09-25','15:55:00',2.89),('12664','2013-09-25','16:00:00',2.11),('12664','2013-09-25','16:05:00',2.15),('12664','2013-09-25','16:10:00',2.65),('12664','2013-09-25','16:15:00',2.45),('12664','2013-09-25','16:20:00',2.28),('12664','2013-09-25','16:25:00',2.31),('12664','2013-09-25','16:30:00',2.18),('12664','2013-09-25','16:35:00',2.11),('12664','2013-09-25','16:40:00',2.01),('12664','2013-09-25','16:45:00',1.9),('12664','2013-09-25','16:50:00',1.82),('12664','2013-09-25','16:55:00',1.71),('12664','2013-09-25','17:00:00',1.64),('12664','2013-09-25','17:05:00',1.54),('12664','2013-09-25','17:10:00',1.44),('12664','2013-09-25','17:15:00',1.34),('12664','2013-09-25','17:20:00',1.25),('12664','2013-09-25','17:25:00',1.15),('12664','2013-09-25','17:30:00',1.06),('12664','2013-09-24','08:20:00',1.05),('12664','2013-09-24','08:25:00',1.16),('12664','2013-09-24','08:30:00',1.26),('12664','2013-09-24','08:35:00',1.36),('12664','2013-09-24','08:40:00',1.45),('12664','2013-09-24','08:45:00',1.54),('12664','2013-09-24','08:50:00',1.64),('12664','2013-09-24','08:55:00',1.73),('12664','2013-09-24','09:00:00',1.83),('12664','2013-09-24','09:05:00',1.92),('12664','2013-09-24','09:10:00',2.01),('12664','2013-09-24','09:15:00',2.1),('12664','2013-09-24','09:20:00',2.17),('12664','2013-09-24','09:25:00',2.25),('12664','2013-09-24','09:30:00',2.34),('12664','2013-09-24','09:35:00',2.42),('12664','2013-09-24','09:40:00',2.49),('12664','2013-09-24','09:45:00',2.55),('12664','2013-09-24','09:50:00',2.63),('12664','2013-09-24','09:55:00',2.71),('12664','2013-09-24','10:00:00',2.77),('12664','2013-09-24','10:05:00',2.85),('12664','2013-09-24','10:10:00',2.92),('12664','2013-09-24','10:15:00',3),('12664','2013-09-24','10:20:00',3.07),('12664','2013-09-24','10:25:00',3.12),('12664','2013-09-24','10:30:00',3.17),('12664','2013-09-24','10:35:00',3.21),('12664','2013-09-24','10:40:00',3.28),('12664','2013-09-24','10:45:00',3.32),('12664','2013-09-24','10:50:00',3.36),('12664','2013-09-24','10:55:00',3.41),('12664','2013-09-24','11:00:00',3.44),('12664','2013-09-24','11:05:00',3.47),('12664','2013-09-24','11:10:00',3.52),('12664','2013-09-24','11:15:00',3.57),('12664','2013-09-24','11:20:00',3.59),('12664','2013-09-24','11:25:00',3.62),('12664','2013-09-24','11:30:00',3.65),('12664','2013-09-24','11:35:00',3.68),('12664','2013-09-24','11:40:00',3.7),('12664','2013-09-24','11:45:00',3.7),('12664','2013-09-24','11:50:00',3.74),('12664','2013-09-24','11:55:00',3.77),('12664','2013-09-24','12:00:00',3.8),('12664','2013-09-24','12:05:00',3.8),('12664','2013-09-24','12:10:00',3.82),('12664','2013-09-24','12:15:00',3.85),('12664','2013-09-24','12:20:00',3.88),('12664','2013-09-24','12:25:00',3.89),('12664','2013-09-24','12:30:00',3.87),('12664','2013-09-24','12:35:00',3.89),('12664','2013-09-24','12:40:00',3.89),('12664','2013-09-24','12:45:00',3.88),('12664','2013-09-24','12:50:00',3.9),('12664','2013-09-24','12:55:00',3.91),('12664','2013-09-24','13:00:00',3.91),('12664','2013-09-24','13:05:00',3.9),('12664','2013-09-24','13:10:00',3.88),('12664','2013-09-24','13:15:00',3.89),('12664','2013-09-24','13:20:00',3.85),('12664','2013-09-24','13:25:00',3.84),('12664','2013-09-24','13:30:00',3.88),('12664','2013-09-24','13:35:00',3.84),('12664','2013-09-24','13:40:00',3.81),('12664','2013-09-24','13:45:00',3.81),('12664','2013-09-24','13:50:00',3.8),('12664','2013-09-24','13:55:00',3.82),('12664','2013-09-24','14:00:00',3.82),('12664','2013-09-24','14:05:00',3.79),('12664','2013-09-24','14:10:00',3.77),('12664','2013-09-24','14:15:00',3.75),('12664','2013-09-24','14:20:00',3.69),('12664','2013-09-24','14:25:00',3.68),('12664','2013-09-24','14:30:00',3.62),('12664','2013-09-24','14:35:00',3.61),('12664','2013-09-24','14:40:00',3.58),('12664','2013-09-24','14:45:00',3.55),('12664','2013-09-24','14:50:00',3.48),('12664','2013-09-24','14:55:00',3.41),('12664','2013-09-24','15:00:00',3.37),('12664','2013-09-24','15:05:00',3.36),('12664','2013-09-24','15:10:00',3.27),('12664','2013-09-24','15:15:00',3.22),('12664','2013-09-24','15:20:00',3.21),('12664','2013-09-24','15:25:00',3.15),('12664','2013-09-24','15:30:00',3.09),('12664','2013-09-24','15:35:00',3.02),('12664','2013-09-24','15:40:00',2.96),('12664','2013-09-24','15:45:00',2.9),('12664','2013-09-24','15:50:00',2.83),('12664','2013-09-24','15:55:00',2.75),('12664','2013-09-24','16:00:00',2.69),('12664','2013-09-24','16:05:00',2.63),('12664','2013-09-24','16:10:00',2.54),('12664','2013-09-24','16:15:00',2.46),('12664','2013-09-24','16:20:00',2.38),('12664','2013-09-24','16:25:00',2.3),('12664','2013-09-24','16:30:00',2.22),('12664','2013-09-24','16:35:00',2.13),('12664','2013-09-24','16:40:00',2.06),('12664','2013-09-24','16:45:00',1.98),('12664','2013-09-24','16:50:00',1.89),('12664','2013-09-24','16:55:00',1.81),('12664','2013-09-24','17:00:00',1.7),('12664','2013-09-24','17:05:00',1.61),('12664','2013-09-24','17:10:00',1.51),('12664','2013-09-24','17:15:00',1.41),('12664','2013-09-24','17:20:00',1.32),('12664','2013-09-24','17:25:00',1.22),('12664','2013-09-24','17:30:00',1.11),('12664','2013-09-24','17:35:00',1.01),('12664','2013-09-23','08:20:00',1.1),('12664','2013-09-23','08:25:00',1.2),('12664','2013-09-23','08:30:00',1.31),('12664','2013-09-23','08:35:00',1.41),('12664','2013-09-23','08:40:00',1.51),('12664','2013-09-23','08:45:00',1.61),('12664','2013-09-23','08:50:00',1.71),('12664','2013-09-23','08:55:00',1.8),('12664','2013-09-23','09:00:00',1.89),('12664','2013-09-23','09:05:00',1.98),('12664','2013-09-23','09:10:00',2.08),('12664','2013-09-23','09:15:00',2.16),('12664','2013-09-23','09:20:00',2.25),('12664','2013-09-23','09:25:00',2.33),('12664','2013-09-23','09:30:00',2.4),('12664','2013-09-23','09:35:00',2.48),('12664','2013-09-23','09:40:00',2.56),('12664','2013-09-23','09:45:00',2.64),('12664','2013-09-23','09:50:00',2.71),('12664','2013-09-23','09:55:00',2.77),('12664','2013-09-23','10:00:00',2.83),('12664','2013-09-23','10:05:00',2.88),('12664','2013-09-23','10:10:00',2.94),('12664','2013-09-23','10:15:00',3.01),('12664','2013-09-23','10:20:00',3.07),('12664','2013-09-23','10:25:00',3.12),('12664','2013-09-23','10:30:00',3.18),('12664','2013-09-23','10:35:00',3.24),('12664','2013-09-23','10:40:00',3.29),('12664','2013-09-23','10:45:00',3.38),('12664','2013-09-23','10:50:00',3.43),('12664','2013-09-23','10:55:00',3.49),('12664','2013-09-23','11:00:00',3.56),('12664','2013-09-23','11:05:00',3.6),('12664','2013-09-23','11:10:00',3.6),('12664','2013-09-23','11:15:00',3.63),('12664','2013-09-23','11:20:00',3.66),('12664','2013-09-23','11:25:00',3.68),('12664','2013-09-23','11:30:00',3.71),('12664','2013-09-23','11:35:00',3.75),('12664','2013-09-23','11:40:00',3.8),('12664','2013-09-23','11:45:00',3.83),('12664','2013-09-23','11:50:00',3.84),('12664','2013-09-23','11:55:00',3.86),('12664','2013-09-23','12:00:00',3.85),('12664','2013-09-23','12:05:00',3.85),('12664','2013-09-23','12:10:00',3.88),('12664','2013-09-23','12:15:00',3.94),('12664','2013-09-23','12:20:00',3.93),('12664','2013-09-23','12:25:00',3.85),('12664','2013-09-23','12:30:00',3.92),('12664','2013-09-23','12:35:00',3.98),('12664','2013-09-23','12:40:00',3.98),('12664','2013-09-23','12:45:00',3.97),('12664','2013-09-23','12:50:00',3.96),('12664','2013-09-23','12:55:00',3.95),('12664','2013-09-23','13:00:00',3.92),('12664','2013-09-23','13:05:00',3.93),('12664','2013-09-23','13:10:00',3.89),('12664','2013-09-23','13:15:00',3.86),('12664','2013-09-23','13:20:00',3.9),('12664','2013-09-23','13:25:00',3.84),('12664','2013-09-23','13:30:00',3.82),('12664','2013-09-23','13:35:00',3.82),('12664','2013-09-23','13:40:00',3.79),('12664','2013-09-23','13:45:00',3.76),('12664','2013-09-23','13:50:00',3.76),('12664','2013-09-23','13:55:00',3.72),('12664','2013-09-23','14:00:00',3.56),('12664','2013-09-23','14:05:00',3.66),('12664','2013-09-23','14:10:00',3.67),('12664','2013-09-23','14:15:00',3.63),('12664','2013-09-23','14:20:00',3.66),('12664','2013-09-23','14:25:00',3.6),('12664','2013-09-23','14:30:00',3.53),('12664','2013-09-23','14:35:00',3.46),('12664','2013-09-23','14:40:00',3.46),('12664','2013-09-23','14:45:00',3.4),('12664','2013-09-23','14:50:00',3.36),('12664','2013-09-23','14:55:00',3.3),('12664','2013-09-23','15:00:00',3.26),('12664','2013-09-23','15:05:00',3.18),('12664','2013-09-23','15:10:00',3.18),('12664','2013-09-23','15:15:00',3.15),('12664','2013-09-23','15:20:00',3.08),('12664','2013-09-23','15:25:00',3.02),('12664','2013-09-23','15:30:00',3),('12664','2013-09-23','15:35:00',2.94),('12664','2013-09-23','15:40:00',2.89),('12664','2013-09-23','15:45:00',2.8),('12664','2013-09-23','15:50:00',2.74),('12664','2013-09-23','15:55:00',2.67),('12664','2013-09-23','16:00:00',2.57),('12664','2013-09-23','16:05:00',2.55),('12664','2013-09-23','16:10:00',2.49),('12664','2013-09-23','16:15:00',2.42),('12664','2013-09-23','16:20:00',2.34),('12664','2013-09-23','16:25:00',2.26),('12664','2013-09-23','16:30:00',2.18),('12664','2013-09-23','16:35:00',2.08),('12664','2013-09-23','16:40:00',2.01),('12664','2013-09-23','16:45:00',1.93),('12664','2013-09-23','16:50:00',1.84),('12664','2013-09-23','16:55:00',1.75),('12664','2013-09-23','17:00:00',1.66),('12664','2013-09-23','17:05:00',1.55),('12664','2013-09-23','17:10:00',1.46),('12664','2013-09-23','17:15:00',1.37),('12664','2013-09-23','17:20:00',1.28),('12664','2013-09-23','17:25:00',1.17),('12664','2013-09-23','17:30:00',1.08),('12664','2013-09-22','08:20:00',1.04),('12664','2013-09-22','08:25:00',1.14),('12664','2013-09-22','08:30:00',1.25),('12664','2013-09-22','08:35:00',1.35),('12664','2013-09-22','08:40:00',1.46),('12664','2013-09-22','08:45:00',1.56),('12664','2013-09-22','08:50:00',1.67),('12664','2013-09-22','08:55:00',1.76),('12664','2013-09-22','09:00:00',1.86),('12664','2013-09-22','09:05:00',1.95),('12664','2013-09-22','09:10:00',2.04),('12664','2013-09-22','09:15:00',2.12),('12664','2013-09-22','09:20:00',2.21),('12664','2013-09-22','09:25:00',2.3),('12664','2013-09-22','09:30:00',2.4),('12664','2013-09-22','09:35:00',2.49),('12664','2013-09-22','09:40:00',2.57),('12664','2013-09-22','09:45:00',2.64),('12664','2013-09-22','09:50:00',2.72),('12664','2013-09-22','09:55:00',2.79),('12664','2013-09-22','10:00:00',2.86),('12664','2013-09-22','10:05:00',2.92),('12664','2013-09-22','10:10:00',2.99),('12664','2013-09-22','10:15:00',3.08),('12664','2013-09-22','10:20:00',3.16),('12664','2013-09-22','10:25:00',3.22),('12664','2013-09-22','10:30:00',3.27),('12664','2013-09-22','10:35:00',3.32),('12664','2013-09-22','10:40:00',3.37),('12664','2013-09-22','10:45:00',3.43),('12664','2013-09-22','10:50:00',3.5),('12664','2013-09-22','10:55:00',3.55),('12664','2013-09-22','11:00:00',3.59),('12664','2013-09-22','11:05:00',3.63),('12664','2013-09-22','11:10:00',3.68),('12664','2013-09-22','11:15:00',3.69),('12664','2013-09-22','11:20:00',3.73),('12664','2013-09-22','11:25:00',3.77),('12664','2013-09-22','11:30:00',3.79),('12664','2013-09-22','11:35:00',3.81),('12664','2013-09-22','11:40:00',3.84),('12664','2013-09-22','11:45:00',3.86),('12664','2013-09-22','11:50:00',3.89),('12664','2013-09-22','11:55:00',3.9),('12664','2013-09-22','12:00:00',3.9),('12664','2013-09-22','12:05:00',3.93),('12664','2013-09-22','12:10:00',3.98),('12664','2013-09-22','12:15:00',3.99),('12664','2013-09-22','12:20:00',4.01),('12664','2013-09-22','12:25:00',4.02),('12664','2013-09-22','12:30:00',4.02),('12664','2013-09-22','12:35:00',4.05),('12664','2013-09-22','12:40:00',4.05),('12664','2013-09-22','12:45:00',4.04),('12664','2013-09-22','12:50:00',4.07),('12664','2013-09-22','12:55:00',4.06),('12664','2013-09-22','13:00:00',4.05),('12664','2013-09-22','13:05:00',4.07),('12664','2013-09-22','13:10:00',4.05),('12664','2013-09-22','13:15:00',4.03),('12664','2013-09-22','13:20:00',4.05),('12664','2013-09-22','13:25:00',4.07),('12664','2013-09-22','13:30:00',4.14),('12664','2013-09-22','13:35:00',4.26),('12664','2013-09-22','13:40:00',4.25),('12664','2013-09-22','13:45:00',4.25),('12664','2013-09-22','13:50:00',3.81),('12664','2013-09-22','13:55:00',2.96),('12664','2013-09-22','14:00:00',4.29),('12664','2013-09-22','14:05:00',4.07),('12664','2013-09-22','14:10:00',3.96),('12664','2013-09-22','14:15:00',3.87),('12664','2013-09-22','14:20:00',3.93),('12664','2013-09-22','14:25:00',4),('12664','2013-09-22','14:30:00',3.28),('12664','2013-09-22','14:35:00',2.83),('12664','2013-09-22','14:40:00',2.24),('12664','2013-09-22','14:45:00',3.86),('12664','2013-09-22','14:50:00',3.74),('12664','2013-09-22','14:55:00',3.55),('12664','2013-09-22','15:00:00',1.29),('12664','2013-09-22','15:05:00',1.22),('12664','2013-09-22','15:10:00',2.65),('12664','2013-09-22','15:15:00',2.52),('12664','2013-09-22','15:20:00',2.22),('12664','2013-09-22','15:25:00',1.31),('12664','2013-09-22','15:30:00',1.61),('12664','2013-09-22','15:35:00',2.88),('12664','2013-09-22','15:40:00',2.9),('12664','2013-09-22','15:45:00',3.13),('12664','2013-09-22','15:50:00',3.13),('12664','2013-09-22','15:55:00',2.51),('12664','2013-09-22','16:00:00',2.42),('12664','2013-09-22','16:05:00',3.19),('12664','2013-09-22','16:10:00',2.35),('12664','2013-09-22','16:15:00',1.71),('12664','2013-09-22','16:20:00',1.71),('12664','2013-09-22','16:25:00',1.13),('12664','2013-09-22','16:35:00',1.24),('12664','2013-09-22','16:40:00',1.87),('12664','2013-09-22','16:45:00',1.63),('12664','2013-09-22','16:50:00',2.34),('12664','2013-09-22','16:55:00',2.05),('12664','2013-09-22','17:00:00',1.68),('12664','2013-09-22','17:05:00',1.66),('12664','2013-09-22','17:10:00',1.56),('12664','2013-09-22','17:15:00',1.47),('12664','2013-09-22','17:20:00',1.4),('12664','2013-09-22','17:25:00',1.3),('12664','2013-09-22','17:30:00',1.15),('12664','2013-09-22','17:35:00',1.01),('12664','2013-09-21','08:20:00',1.06),('12664','2013-09-21','08:25:00',1.16),('12664','2013-09-21','08:30:00',1.26),('12664','2013-09-21','08:35:00',1.36),('12664','2013-09-21','08:40:00',1.46),('12664','2013-09-21','08:45:00',1.55),('12664','2013-09-21','08:50:00',1.65),('12664','2013-09-21','08:55:00',1.74),('12664','2013-09-21','09:00:00',1.83),('12664','2013-09-21','09:05:00',1.92),('12664','2013-09-21','09:10:00',2),('12664','2013-09-21','09:15:00',2.1),('12664','2013-09-21','09:20:00',2.19),('12664','2013-09-21','09:25:00',2.28),('12664','2013-09-21','09:30:00',2.36),('12664','2013-09-21','09:35:00',2.44),('12664','2013-09-21','09:40:00',2.53),('12664','2013-09-21','09:45:00',2.6),('12664','2013-09-21','09:50:00',2.61),('12664','2013-09-21','09:55:00',2.72),('12664','2013-09-21','10:00:00',2.79),('12664','2013-09-21','10:05:00',2.86),('12664','2013-09-21','10:10:00',2.91),('12664','2013-09-21','10:15:00',2.97),('12664','2013-09-21','10:20:00',3.03),('12664','2013-09-21','10:25:00',3.09),('12664','2013-09-21','10:30:00',3.14),('12664','2013-09-21','10:35:00',3.2),('12664','2013-09-21','10:40:00',3.25),('12664','2013-09-21','10:45:00',3.29),('12664','2013-09-21','10:50:00',3.35),('12664','2013-09-21','10:55:00',3.38),('12664','2013-09-21','11:00:00',3.42),('12664','2013-09-21','11:05:00',3.46),('12664','2013-09-21','11:10:00',3.5),('12664','2013-09-21','11:15:00',3.53),('12664','2013-09-21','11:20:00',3.57),('12664','2013-09-21','11:25:00',3.6),('12664','2013-09-21','11:30:00',3.64),('12664','2013-09-21','11:35:00',3.67),('12664','2013-09-21','11:40:00',3.7),('12664','2013-09-21','11:45:00',3.54),('12664','2013-09-21','11:50:00',3.75),('12664','2013-09-21','11:55:00',3.81),('12664','2013-09-21','12:00:00',3.83),('12664','2013-09-21','12:05:00',3.84),('12664','2013-09-21','12:10:00',3.8),('12664','2013-09-21','12:15:00',3.29),('12664','2013-09-21','12:20:00',3.07),('12664','2013-09-21','12:25:00',3.98),('12664','2013-09-21','12:30:00',3.8),('12664','2013-09-21','12:35:00',3.66),('12664','2013-09-21','12:40:00',3.23),('12664','2013-09-21','12:45:00',3.94),('12664','2013-09-21','12:50:00',3.64),('12664','2013-09-21','12:55:00',2.69),('12664','2013-09-21','13:00:00',3.85),('12664','2013-09-21','13:05:00',3.69),('12664','2013-09-21','13:10:00',3.87),('12664','2013-09-21','13:15:00',3.26),('12664','2013-09-21','13:20:00',2.87),('12664','2013-09-21','13:25:00',3.61),('12664','2013-09-21','13:30:00',3.14),('12664','2013-09-21','13:35:00',3.44),('12664','2013-09-21','13:40:00',3.85),('12664','2013-09-21','13:45:00',3.85),('12664','2013-09-21','13:50:00',3.81),('12664','2013-09-21','13:55:00',3.75),('12664','2013-09-21','14:00:00',3.59),('12664','2013-09-21','14:05:00',3.74),('12664','2013-09-21','14:10:00',3.5),('12664','2013-09-21','14:15:00',3.64),('12664','2013-09-21','14:20:00',3.64),('12664','2013-09-21','14:25:00',3.57),('12664','2013-09-21','14:30:00',3.51),('12664','2013-09-21','14:35:00',3.44),('12664','2013-09-21','14:40:00',3.46),('12664','2013-09-21','14:45:00',3.41),('12664','2013-09-21','14:50:00',3.37),('12664','2013-09-21','14:55:00',3.34),('12664','2013-09-21','15:00:00',3.04),('12664','2013-09-21','15:05:00',3.27),('12664','2013-09-21','15:10:00',3.2),('12664','2013-09-21','15:15:00',3.11),('12664','2013-09-21','15:20:00',3.07),('12664','2013-09-21','15:25:00',3.03),('12664','2013-09-21','15:30:00',2.95),('12664','2013-09-21','15:35:00',2.92),('12664','2013-09-21','15:40:00',2.9),('12664','2013-09-21','15:45:00',2.84),('12664','2013-09-21','15:50:00',2.73),('12664','2013-09-21','15:55:00',1.84),('12664','2013-09-21','16:00:00',2.12),('12664','2013-09-21','16:05:00',1.49),('12664','2013-09-21','16:10:00',2.1),('12664','2013-09-21','16:15:00',1.42),('12664','2013-09-21','16:20:00',1.11),('12664','2013-09-21','16:25:00',1.83),('12664','2013-09-21','16:30:00',1.72),('12664','2013-09-21','16:45:00',1.14),('12664','2013-09-21','16:55:00',1.1),('12664','2013-09-21','17:00:00',1.13),('12664','2013-09-21','17:05:00',1.02),('12664','2013-09-21','17:10:00',1.36),('12664','2013-09-21','17:35:00',1),('12664','2013-09-20','08:40:00',1.13),('12664','2013-09-20','08:45:00',1.58),('12664','2013-09-20','09:40:00',1.05),('12664','2013-09-20','09:45:00',1.2),('12664','2013-09-20','09:50:00',1.44),('12664','2013-09-20','09:55:00',1.34),('12664','2013-09-20','10:00:00',1.46),('12664','2013-09-20','10:05:00',1.88),('12664','2013-09-20','10:10:00',1.82),('12664','2013-09-20','10:15:00',3.66),('12664','2013-09-20','10:20:00',2.98),('12664','2013-09-20','10:25:00',2.56),('12664','2013-09-20','10:30:00',2.01),('12664','2013-09-20','10:35:00',2.04),('12664','2013-09-20','10:40:00',2.1),('12664','2013-09-20','10:45:00',2.27),('12664','2013-09-20','10:50:00',3.07),('12664','2013-09-20','10:55:00',3.18),('12664','2013-09-20','11:00:00',2.76),('12664','2013-09-20','11:05:00',2.97),('12664','2013-09-20','11:10:00',2.33),('12664','2013-09-20','11:15:00',2.25),('12664','2013-09-20','11:20:00',2.77),('12664','2013-09-20','11:25:00',2.47),('12664','2013-09-20','11:30:00',2.64),('12664','2013-09-20','11:35:00',2.54),('12664','2013-09-20','11:40:00',4.09),('12664','2013-09-20','11:45:00',3.1),('12664','2013-09-20','11:50:00',3.09),('12664','2013-09-20','11:55:00',2.83),('12664','2013-09-20','12:00:00',4.44),('12664','2013-09-20','12:05:00',4.2),('12664','2013-09-20','12:10:00',4.05),('12664','2013-09-20','12:15:00',4.01),('12664','2013-09-20','12:20:00',4.02),('12664','2013-09-20','12:25:00',4.16),('12664','2013-09-20','12:30:00',4.06),('12664','2013-09-20','12:35:00',3.97),('12664','2013-09-20','12:40:00',3.46),('12664','2013-09-20','12:45:00',4.03),('12664','2013-09-20','12:50:00',3.98),('12664','2013-09-20','12:55:00',3.87),('12664','2013-09-20','13:00:00',3.84),('12664','2013-09-20','13:05:00',3.87),('12664','2013-09-20','13:10:00',3.88),('12664','2013-09-20','13:15:00',3.87),('12664','2013-09-20','13:20:00',3.87),('12664','2013-09-20','13:25:00',3.88),('12664','2013-09-20','13:30:00',3.9),('12664','2013-09-20','13:35:00',3.91),('12664','2013-09-20','13:40:00',3.87),('12664','2013-09-20','13:45:00',3.63),('12664','2013-09-20','13:50:00',3.77),('12664','2013-09-20','13:55:00',3.49),('12664','2013-09-20','14:00:00',3.91),('12664','2013-09-20','14:05:00',2.47),('12664','2013-09-20','14:10:00',3.94),('12664','2013-09-20','14:15:00',3.81),('12664','2013-09-20','14:20:00',3.77),('12664','2013-09-20','14:25:00',3.75),('12664','2013-09-20','14:30:00',3.7),('12664','2013-09-20','14:35:00',3.69),('12664','2013-09-20','14:40:00',3.73),('12664','2013-09-20','14:45:00',3.37),('12664','2013-09-20','14:50:00',2.35),('12664','2013-09-20','14:55:00',2.38),('12664','2013-09-20','15:00:00',1.95),('12664','2013-09-20','15:05:00',2.92),('12664','2013-09-20','15:10:00',2.16),('12664','2013-09-20','15:15:00',2.7),('12664','2013-09-20','15:20:00',2.17),('12664','2013-09-20','15:25:00',1.95),('12664','2013-09-20','15:30:00',1.63),('12664','2013-09-20','15:35:00',1.47),('12664','2013-09-20','15:40:00',2.86),('12664','2013-09-20','15:45:00',2.47),('12664','2013-09-20','15:50:00',2.2),('12664','2013-09-20','15:55:00',2.39),('12664','2013-09-20','16:00:00',2.9),('12664','2013-09-20','16:05:00',2.93),('12664','2013-09-20','16:10:00',2.88),('12664','2013-09-20','16:15:00',2.33),('12664','2013-09-20','16:20:00',1.83),('12664','2013-09-20','16:25:00',1.28),('12664','2013-09-20','16:30:00',1.28),('12664','2013-09-20','16:40:00',1.48),('12664','2013-09-20','16:45:00',1.99),('12664','2013-09-20','16:50:00',1.95),('12664','2013-09-20','16:55:00',2.05),('12664','2013-09-20','17:00:00',1.92),('12664','2013-09-20','17:05:00',1.85),('12664','2013-09-20','17:10:00',1.8),('12664','2013-09-20','17:15:00',1.78),('12664','2013-09-20','17:20:00',1.75),('12664','2013-09-20','17:25:00',1.36),('12664','2013-09-20','17:30:00',1.61),('12664','2013-09-20','17:35:00',1.6),('12664','2013-09-20','17:40:00',1.52),('12664','2013-09-20','17:45:00',1.47),('12664','2013-09-20','17:50:00',1.03),('12664','2013-09-19','08:25:00',1.14),('12664','2013-09-19','08:30:00',1.28),('12664','2013-09-19','08:35:00',1.52),('12664','2013-09-19','08:40:00',1.51),('12664','2013-09-19','08:50:00',1.02),('12664','2013-09-19','08:55:00',1.27),('12664','2013-09-19','09:00:00',1.81),('12664','2013-09-19','09:05:00',1.83),('12664','2013-09-19','09:15:00',1.07),('12664','2013-09-19','09:20:00',1.22),('12664','2013-09-19','09:25:00',1.62),('12664','2013-09-19','09:30:00',1.19),('12664','2013-09-19','09:35:00',1.85),('12664','2013-09-19','09:40:00',2.94),('12664','2013-09-19','09:45:00',2.21),('12664','2013-09-19','09:50:00',1.8),('12664','2013-09-19','09:55:00',1.22),('12664','2013-09-19','10:00:00',1.75),('12664','2013-09-19','10:05:00',1.81),('12664','2013-09-19','10:10:00',2.58),('12664','2013-09-19','10:15:00',2.95),('12664','2013-09-19','10:20:00',2.96),('12664','2013-09-19','10:25:00',1.1),('12664','2013-09-19','10:40:00',1.1),('12664','2013-09-19','10:45:00',1.5),('12664','2013-09-19','10:50:00',1.67),('12664','2013-09-19','10:55:00',3.74),('12664','2013-09-19','11:00:00',3.78),('12664','2013-09-19','11:05:00',1.81),('12664','2013-09-19','11:10:00',1.27),('12664','2013-09-19','11:15:00',4.05),('12664','2013-09-19','11:20:00',3.73),('12664','2013-09-19','11:25:00',3.13),('12664','2013-09-19','11:30:00',2.78),('12664','2013-09-19','11:35:00',2.77),('12664','2013-09-19','11:40:00',2.15),('12664','2013-09-19','11:45:00',3.43),('12664','2013-09-19','11:50:00',4.36),('12664','2013-09-19','11:55:00',3.19),('12664','2013-09-19','12:00:00',3.11),('12664','2013-09-19','12:05:00',3.44),('12664','2013-09-19','12:10:00',2.67),('12664','2013-09-19','12:15:00',2.39),('12664','2013-09-19','12:20:00',3.21),('12664','2013-09-19','12:25:00',4.32),('12664','2013-09-19','12:30:00',4.39),('12664','2013-09-19','12:35:00',2.33),('12664','2013-09-19','12:40:00',1.31),('12664','2013-09-19','12:45:00',4.44),('12664','2013-09-19','12:50:00',4.46),('12664','2013-09-19','12:55:00',4.57),('12664','2013-09-19','13:00:00',2.32),('12664','2013-09-19','13:05:00',4.42),('12664','2013-09-19','13:10:00',4.32),('12664','2013-09-19','13:15:00',4.31),('12664','2013-09-19','13:20:00',4.23),('12664','2013-09-19','13:25:00',4.25),('12664','2013-09-19','13:30:00',3.89),('12664','2013-09-19','13:35:00',2.66),('12664','2013-09-19','13:40:00',2.28),('12664','2013-09-19','13:45:00',4.41),('12664','2013-09-19','13:50:00',4.42),('12664','2013-09-19','13:55:00',4.13),('12664','2013-09-19','14:00:00',4.03),('12664','2013-09-19','14:05:00',3.94),('12664','2013-09-19','14:10:00',3.9),('12664','2013-09-19','14:15:00',3.87),('12664','2013-09-19','14:20:00',3.86),('12664','2013-09-19','14:25:00',3.8),('12664','2013-09-19','14:30:00',3.66),('12664','2013-09-19','14:35:00',3.53),('12664','2013-09-19','14:40:00',3.39),('12664','2013-09-19','14:45:00',3.68),('12664','2013-09-19','14:50:00',3.71),('12664','2013-09-19','14:55:00',3.63),('12664','2013-09-19','15:00:00',3.42),('12664','2013-09-19','15:05:00',3.63),('12664','2013-09-19','15:10:00',3.55),('12664','2013-09-19','15:15:00',3.34),('12664','2013-09-19','15:20:00',2.94),('12664','2013-09-19','15:25:00',3.08),('12664','2013-09-19','15:30:00',3.34),('12664','2013-09-19','15:35:00',2.99),('12664','2013-09-19','15:40:00',2.49),('12664','2013-09-19','15:45:00',1.81),('12664','2013-09-19','15:50:00',2.39),('12664','2013-09-19','15:55:00',1.88),('12664','2013-09-19','16:00:00',1.16),('12664','2013-09-19','16:05:00',1.67),('12664','2013-09-19','16:10:00',2.33),('12664','2013-09-19','16:15:00',2.27),('12664','2013-09-19','16:20:00',2.39),('12664','2013-09-19','16:25:00',2.39),('12664','2013-09-19','16:30:00',1.97),('12664','2013-09-19','16:35:00',1.74),('12664','2013-09-19','16:40:00',2.24),('12664','2013-09-19','16:45:00',2.01),('12664','2013-09-19','16:50:00',1.81),('12664','2013-09-19','16:55:00',1.84),('12664','2013-09-19','17:00:00',1.7),('12664','2013-09-19','17:05:00',1.63),('12664','2013-09-19','17:10:00',1.61),('12664','2013-09-19','17:15:00',1.44),('12664','2013-09-19','17:20:00',1.33),('12664','2013-09-19','17:25:00',1.19),('12664','2013-09-18','08:20:00',1.06),('12664','2013-09-18','08:25:00',1.15),('12664','2013-09-18','08:30:00',1.24),('12664','2013-09-18','08:50:00',1.03),('12664','2013-09-18','09:10:00',1.18),('12664','2013-09-18','09:15:00',1.53),('12664','2013-09-18','09:20:00',2.2),('12664','2013-09-18','09:25:00',1.61),('12664','2013-09-18','09:40:00',1.32),('12664','2013-09-18','09:45:00',3.19),('12664','2013-09-18','09:50:00',2.96),('12664','2013-09-18','09:55:00',2.78),('12664','2013-09-18','10:00:00',2.79),('12664','2013-09-18','10:05:00',2.84),('12664','2013-09-18','10:10:00',2.92),('12664','2013-09-18','10:15:00',2.99),('12664','2013-09-18','10:20:00',3.04),('12664','2013-09-18','10:25:00',3.11),('12664','2013-09-18','10:30:00',3.16),('12664','2013-09-18','10:35:00',3.21),('12664','2013-09-18','10:40:00',3.26),('12664','2013-09-18','10:45:00',3.32),('12664','2013-09-18','10:50:00',3.37),('12664','2013-09-18','10:55:00',3.43),('12664','2013-09-18','11:00:00',3.49),('12664','2013-09-18','11:05:00',3.58),('12664','2013-09-18','11:10:00',3.68),('12664','2013-09-18','11:15:00',3.82),('12664','2013-09-18','11:20:00',3.39),('12664','2013-09-18','11:25:00',3.86),('12664','2013-09-18','11:30:00',3.88),('12664','2013-09-18','11:35:00',3.82),('12664','2013-09-18','11:40:00',2.38),('12664','2013-09-18','11:45:00',4.03),('12664','2013-09-18','11:50:00',3.68),('12664','2013-09-18','11:55:00',3.86),('12664','2013-09-18','12:00:00',4),('12664','2013-09-18','12:05:00',4.08),('12664','2013-09-18','12:10:00',4.33),('12664','2013-09-18','12:15:00',4.52),('12664','2013-09-18','12:20:00',4.54),('12664','2013-09-18','12:25:00',4.36),('12664','2013-09-18','12:30:00',2.7),('12664','2013-09-18','12:35:00',2.09),('12664','2013-09-18','12:40:00',1.35),('12664','2013-09-18','12:45:00',2.46),('12664','2013-09-18','12:50:00',4.69),('12664','2013-09-18','12:55:00',3.97),('12664','2013-09-18','13:00:00',1.37),('12664','2013-09-18','13:05:00',3.48),('12664','2013-09-18','13:10:00',4.43),('12664','2013-09-18','13:15:00',4.28),('12664','2013-09-18','13:20:00',4.31),('12664','2013-09-18','13:25:00',4.01),('12664','2013-09-18','13:35:00',3.77),('12664','2013-09-18','13:40:00',3.7),('12664','2013-09-18','13:50:00',4.69),('12664','2013-09-18','13:55:00',4.64),('12664','2013-09-18','14:00:00',4.37),('12664','2013-09-18','14:05:00',1.81),('12664','2013-09-18','14:10:00',2.6),('12664','2013-09-18','14:15:00',3.37),('12664','2013-09-18','14:20:00',3.31),('12664','2013-09-18','14:25:00',3.47),('12664','2013-09-18','14:30:00',3.91),('12664','2013-09-18','14:35:00',3.86),('12664','2013-09-18','14:40:00',3.61),('12664','2013-09-18','14:45:00',2.1),('12664','2013-09-18','14:50:00',2.84),('12664','2013-09-18','14:55:00',1.99),('12664','2013-09-18','15:00:00',2.41),('12664','2013-09-18','15:05:00',2.32),('12664','2013-09-18','15:10:00',1.53),('12664','2013-09-18','15:15:00',1.02),('12664','2013-09-18','15:20:00',1.75),('12664','2013-09-18','15:25:00',3.7),('12664','2013-09-18','15:30:00',1.76),('12664','2013-09-18','15:40:00',3.05),('12664','2013-09-18','15:45:00',3.13),('12664','2013-09-18','15:50:00',3.19),('12664','2013-09-18','15:55:00',1.62),('12664','2013-09-18','16:00:00',2.79),('12664','2013-09-18','16:05:00',1.18),('12664','2013-09-18','16:10:00',3.11),('12664','2013-09-18','16:15:00',2.67),('12664','2013-09-18','16:20:00',2.32),('12664','2013-09-18','16:25:00',2.31),('12664','2013-09-18','16:30:00',2.15),('12664','2013-09-18','16:35:00',2.16),('12664','2013-09-18','16:40:00',1.86),('12664','2013-09-18','16:45:00',1.86),('12664','2013-09-18','16:50:00',1.96),('12664','2013-09-18','16:55:00',1.12),('12664','2013-09-18','17:00:00',1.58),('12664','2013-09-18','17:05:00',1.32),('12664','2013-09-18','17:10:00',1.7),('12664','2013-09-18','17:20:00',1.51),('12664','2013-09-18','17:25:00',1.47),('12664','2013-09-18','17:30:00',1.27),('12664','2013-09-18','17:35:00',1.14),('12664','2014-04-12','08:40:00',1.31),('12664','2014-04-12','08:45:00',1.44),('12664','2014-04-12','08:50:00',1.12),('12664','2014-04-12','08:55:00',1.17),('12664','2014-04-12','09:00:00',1.4),('12664','2014-04-12','09:05:00',1.85),('12664','2014-04-12','09:10:00',1.8),('12664','2014-04-12','09:15:00',1.18),('12664','2014-04-12','09:20:00',1.3),('12664','2014-04-12','09:25:00',1.57),('12664','2014-04-12','09:30:00',2.07),('12664','2014-04-12','09:35:00',1.5),('12664','2014-04-12','09:40:00',1.43),('12664','2014-04-12','09:45:00',1.44),('12664','2014-04-12','09:50:00',1.5),('12664','2014-04-12','09:55:00',1.7),('12664','2014-04-12','10:00:00',2.23),('12664','2014-04-12','10:05:00',2.21),('12664','2014-04-12','10:10:00',1.55),('12664','2014-04-12','10:15:00',1.54),('12664','2014-04-12','10:20:00',1.83),('12664','2014-04-12','10:25:00',1.89),('12664','2014-04-12','10:30:00',1.77),('12664','2014-04-12','10:35:00',1.78),('12664','2014-04-12','10:40:00',2.25),('12664','2014-04-12','10:45:00',2.69),('12664','2014-04-12','10:50:00',2.95),('12664','2014-04-12','10:55:00',3.49),('12664','2014-04-12','11:00:00',3.52),('12664','2014-04-12','11:05:00',3.88),('12664','2014-04-12','11:10:00',3.06),('12664','2014-04-12','11:15:00',3.25),('12664','2014-04-12','11:20:00',2.29),('12664','2014-04-12','11:25:00',1.49),('12664','2014-04-12','11:30:00',1.39),('12664','2014-04-12','11:35:00',1.48),('12664','2014-04-12','11:40:00',1.96),('12664','2014-04-12','11:45:00',3.25),('12664','2014-04-12','11:50:00',1.99),('12664','2014-04-12','11:55:00',2.04),('12664','2014-04-12','12:00:00',2.87),('12664','2014-04-12','12:05:00',1.74),('12664','2014-04-12','12:10:00',1.71),('12664','2014-04-12','12:15:00',3.12),('12664','2014-04-12','12:20:00',3.03),('12664','2014-04-12','12:25:00',2.59),('12664','2014-04-12','12:30:00',2.74),('12664','2014-04-12','12:35:00',3.26),('12664','2014-04-12','12:40:00',3.13),('12664','2014-04-12','12:45:00',3.82),('12664','2014-04-12','12:50:00',3.05),('12664','2014-04-12','12:55:00',3.04),('12664','2014-04-12','13:00:00',3.52),('12664','2014-04-12','13:05:00',2.35),('12664','2014-04-12','13:10:00',3.21),('12664','2014-04-12','13:15:00',3.78),('12664','2014-04-12','13:20:00',4.16),('12664','2014-04-12','13:25:00',2.31),('12664','2014-04-12','13:30:00',4.44),('12664','2014-04-12','13:35:00',2.21),('12664','2014-04-12','13:40:00',1.3),('12664','2014-04-12','13:45:00',3.17),('12664','2014-04-12','13:50:00',4.12),('12664','2014-04-12','13:55:00',2.68),('12664','2014-04-12','14:00:00',3.31),('12664','2014-04-12','14:05:00',3.35),('12664','2014-04-12','14:10:00',2.19),('12664','2014-04-12','14:15:00',3.48),('12664','2014-04-12','14:20:00',3.22),('12664','2014-04-12','14:25:00',2.54),('12664','2014-04-12','14:30:00',2.92),('12664','2014-04-12','14:35:00',3.15),('12664','2014-04-12','14:40:00',3.54),('12664','2014-04-12','14:45:00',3.28),('12664','2014-04-12','14:50:00',3.29),('12664','2014-04-12','14:55:00',3.24),('12664','2014-04-12','15:00:00',3.46),('12664','2014-04-12','15:05:00',3.34),('12664','2014-04-12','15:10:00',3.16),('12664','2014-04-12','15:15:00',2.96),('12664','2014-04-12','15:20:00',2.07),('12664','2014-04-12','15:25:00',2.47),('12664','2014-04-12','15:30:00',2.95),('12664','2014-04-12','15:35:00',3.01),('12664','2014-04-12','15:40:00',3.41),('12664','2014-04-12','15:45:00',3.25),('12664','2014-04-12','15:50:00',3.22),('12664','2014-04-12','15:55:00',3.21),('12664','2014-04-12','16:00:00',3.11),('12664','2014-04-12','16:05:00',3.1),('12664','2014-04-12','16:10:00',2.96),('12664','2014-04-12','16:15:00',2.83),('12664','2014-04-12','16:20:00',2.19),('12664','2014-04-12','16:25:00',1.64),('12664','2014-04-12','16:30:00',2.06),('12664','2014-04-12','16:35:00',1.8),('12664','2014-04-12','16:40:00',2.83),('12664','2014-04-12','16:45:00',2.42),('12664','2014-04-12','16:50:00',2.71),('12664','2014-04-12','16:55:00',2.38),('12664','2014-04-12','17:00:00',2.13),('12664','2014-04-12','17:05:00',2.09),('12664','2014-04-12','17:10:00',1.93),('12664','2014-04-12','17:15:00',1.52),('12664','2014-04-12','17:20:00',1.84),('12664','2014-04-12','17:25:00',1.75),('12664','2014-04-12','17:30:00',1.69),('12664','2014-04-12','17:35:00',1.65),('12664','2014-04-12','17:40:00',1.44),('12664','2014-04-12','17:45:00',1.72),('12664','2014-04-12','17:50:00',1.32),('12664','2014-04-12','17:55:00',1.26),('12664','2014-04-12','18:05:00',1.04),('12664','2013-09-17','09:25:00',1),('12664','2013-09-17','09:30:00',1.13),('12664','2013-09-17','09:40:00',2.84),('12664','2013-09-17','09:45:00',1.16),('12664','2013-09-17','09:50:00',2.29),('12664','2013-09-17','09:55:00',2.08),('12664','2013-09-17','10:00:00',2.18),('12664','2013-09-17','10:05:00',2.14),('12664','2013-09-17','10:15:00',2.35),('12664','2013-09-17','10:20:00',3.94),('12664','2013-09-17','10:25:00',1.69),('12664','2013-09-17','10:30:00',1.67),('12664','2013-09-17','10:35:00',2.67),('12664','2013-09-17','10:40:00',3.97),('12664','2013-09-17','10:45:00',2.02),('12664','2013-09-17','10:50:00',2.12),('12664','2013-09-17','10:55:00',1.94),('12664','2013-09-17','11:00:00',1.77),('12664','2013-09-17','11:05:00',3.27),('12664','2013-09-17','11:10:00',2.09),('12664','2013-09-17','11:15:00',1.49),('12664','2013-09-17','11:20:00',1.68),('12664','2013-09-17','11:25:00',2.2),('12664','2013-09-17','11:30:00',2.36),('12664','2013-09-17','11:35:00',3.7),('12664','2013-09-17','11:40:00',3.47),('12664','2013-09-17','11:45:00',2.37),('12664','2013-09-17','11:50:00',3.11),('12664','2013-09-17','11:55:00',4.44),('12664','2013-09-17','12:00:00',1.74),('12664','2013-09-17','12:05:00',1.28),('12664','2013-09-17','12:10:00',1.76),('12664','2013-09-17','12:15:00',1.83),('12664','2013-09-17','12:20:00',1.48),('12664','2013-09-17','12:25:00',1.09),('12664','2013-09-17','12:30:00',3.28),('12664','2013-09-17','12:35:00',1.59),('12664','2013-09-17','12:40:00',3.88),('12664','2013-09-17','12:45:00',3.68),('12664','2013-09-17','12:50:00',3.43),('12664','2013-09-17','12:55:00',3.26),('12664','2013-09-17','13:00:00',3.48),('12664','2013-09-17','13:05:00',2.85),('12664','2013-09-17','13:10:00',2.52),('12664','2013-09-17','13:15:00',2.16),('12664','2013-09-17','13:20:00',2.11),('12664','2013-09-17','13:25:00',1.63),('12664','2013-09-17','13:30:00',1.07),('12664','2013-09-17','13:35:00',2.34),('12664','2013-09-17','13:40:00',4.33),('12664','2013-09-17','13:50:00',2.41),('12664','2013-09-17','13:55:00',2.14),('12664','2013-09-17','14:05:00',2.41),('12664','2013-09-17','14:10:00',1.47),('12664','2013-09-17','14:15:00',1.1),('12664','2013-09-17','14:25:00',1.26),('12664','2013-09-17','14:30:00',1.95),('12664','2013-09-17','14:45:00',1.18),('12664','2013-09-17','14:50:00',3.29),('12664','2013-09-17','14:55:00',3.84),('12664','2013-09-17','15:00:00',3.26),('12664','2013-09-17','15:05:00',2.48),('12664','2013-09-17','15:10:00',2.36),('12664','2013-09-17','15:15:00',1.11),('12664','2013-09-17','15:30:00',1.21),('12664','2013-09-17','15:35:00',1.12),('12664','2013-09-17','15:40:00',1.64),('12664','2013-09-17','15:45:00',1.9),('12664','2013-09-17','15:50:00',1.87),('12664','2013-09-17','15:55:00',2.6),('12664','2013-09-17','16:00:00',2.61),('12664','2013-09-17','16:05:00',1.86),('12664','2013-09-17','16:10:00',1.84),('12664','2013-09-17','16:15:00',1.1),('12664','2013-09-17','16:35:00',1.15),('12664','2013-09-17','16:40:00',1.63),('12664','2013-09-17','16:45:00',1.78),('12664','2013-09-17','16:50:00',1.04),('12664','2013-09-17','16:55:00',1.44),('12664','2013-09-17','17:00:00',1.84),('12664','2013-09-17','17:05:00',1.69),('12664','2013-09-17','17:10:00',1.84),('12664','2013-09-17','17:15:00',1.51),('12664','2013-09-17','17:20:00',1.46),('12664','2013-09-17','17:25:00',1.29),('12664','2013-09-17','17:30:00',1.39),('12664','2013-09-17','17:35:00',1.15),('12664','2013-09-16','08:20:00',1.1),('12664','2013-09-16','08:25:00',1.2),('12664','2013-09-16','08:35:00',1.41),('12664','2013-09-16','08:40:00',1.51),('12664','2013-09-16','08:45:00',1.76),('12664','2013-09-16','08:50:00',1.41),('12664','2013-09-16','09:05:00',1.41),('12664','2013-09-16','09:10:00',1.9),('12664','2013-09-16','09:15:00',2.23),('12664','2013-09-16','09:20:00',2.32),('12664','2013-09-16','09:25:00',2.25),('12664','2013-09-16','09:30:00',2.39),('12664','2013-09-16','09:35:00',2.47),('12664','2013-09-16','09:40:00',2.55),('12664','2013-09-16','09:45:00',2.64),('12664','2013-09-16','09:50:00',2.79),('12664','2013-09-16','09:55:00',2.69),('12664','2013-09-16','10:00:00',2.87),('12664','2013-09-16','10:05:00',3.08),('12664','2013-09-16','10:10:00',1.82),('12664','2013-09-16','10:15:00',2.08),('12664','2013-09-16','10:30:00',1.49),('12664','2013-09-16','10:35:00',3.76),('12664','2013-09-16','10:40:00',2.38),('12664','2013-09-16','10:45:00',1.35),('12664','2013-09-16','10:50:00',1.18),('12664','2013-09-16','10:55:00',3.22),('12664','2013-09-16','11:00:00',1.52),('12664','2013-09-16','11:10:00',3.42),('12664','2013-09-16','11:15:00',4.37),('12664','2013-09-16','11:20:00',4.4),('12664','2013-09-16','11:25:00',4.36),('12664','2013-09-16','11:30:00',4.14),('12664','2013-09-16','11:35:00',3.25),('12664','2013-09-16','11:40:00',3.16),('12664','2013-09-16','11:45:00',4.05),('12664','2013-09-16','11:50:00',4.23),('12664','2013-09-16','11:55:00',4.29),('12664','2013-09-16','12:00:00',1.35),('12664','2013-09-16','12:05:00',1.72),('12664','2013-09-16','12:10:00',4.05),('12664','2013-09-16','12:15:00',4.4),('12664','2013-09-16','12:20:00',4.32),('12664','2013-09-16','12:25:00',4.29),('12664','2013-09-16','12:30:00',3.71),('12664','2013-09-16','12:35:00',1.8),('12664','2013-09-16','12:40:00',1.77),('12664','2013-09-16','12:45:00',1.84),('12664','2013-09-16','12:50:00',3.24),('12664','2013-09-16','12:55:00',2.74),('12664','2013-09-16','13:00:00',1.91),('12664','2013-09-16','13:05:00',3.86),('12664','2013-09-16','13:10:00',4.25),('12664','2013-09-16','13:15:00',4.24),('12664','2013-09-16','13:20:00',4.2),('12664','2013-09-16','13:25:00',4.19),('12664','2013-09-16','13:30:00',4.26),('12664','2013-09-16','13:35:00',2.08),('12664','2013-09-16','13:40:00',3.19),('12664','2013-09-16','13:45:00',3.82),('12664','2013-09-16','13:50:00',4.22),('12664','2013-09-16','13:55:00',4.24),('12664','2013-09-16','14:00:00',4.08),('12664','2013-09-16','14:05:00',3.94),('12664','2013-09-16','14:10:00',3.93),('12664','2013-09-16','14:15:00',3.9),('12664','2013-09-16','14:20:00',3.85),('12664','2013-09-16','14:25:00',3.83),('12664','2013-09-16','14:30:00',3.77),('12664','2013-09-16','14:35:00',3.71),('12664','2013-09-16','14:40:00',3.71),('12664','2013-09-16','14:45:00',3.69),('12664','2013-09-16','14:50:00',3.67),('12664','2013-09-16','14:55:00',3.65),('12664','2013-09-16','15:00:00',3.59),('12664','2013-09-16','15:05:00',3.54),('12664','2013-09-16','15:10:00',3.51),('12664','2013-09-16','15:15:00',3.44),('12664','2013-09-16','15:20:00',3.39),('12664','2013-09-16','15:25:00',3.33),('12664','2013-09-16','15:30:00',3.29),('12664','2013-09-16','15:35:00',3.22),('12664','2013-09-16','15:40:00',3.16),('12664','2013-09-16','15:45:00',3.09),('12664','2013-09-16','15:50:00',3.02),('12664','2013-09-16','15:55:00',2.9),('12664','2013-09-16','16:00:00',2.96),('12664','2013-09-16','16:05:00',2.83),('12664','2013-09-16','16:10:00',2.75),('12664','2013-09-16','16:15:00',2.68),('12664','2013-09-16','16:20:00',2.61),('12664','2013-09-16','16:25:00',2.53),('12664','2013-09-16','16:30:00',2.45),('12664','2013-09-16','16:35:00',2.38),('12664','2013-09-16','16:40:00',2.29),('12664','2013-09-16','16:45:00',2.2),('12664','2013-09-16','16:50:00',2.1),('12664','2013-09-16','16:55:00',2.01),('12664','2013-09-16','17:00:00',1.79),('12664','2013-09-16','17:05:00',1.79),('12664','2013-09-16','17:10:00',1.34),('12664','2013-09-16','17:15:00',1.65),('12664','2013-09-16','17:20:00',1.12),('12664','2013-09-16','17:30:00',1.21),('12664','2013-09-16','17:35:00',1.3),('12664','2013-09-16','17:40:00',1.15),('12664','2013-09-16','17:45:00',1.02),('12664','2013-09-15','08:15:00',1.06),('12664','2013-09-15','08:20:00',1.17),('12664','2013-09-15','08:25:00',1.28),('12664','2013-09-15','08:30:00',1.38),('12664','2013-09-15','08:35:00',1.5),('12664','2013-09-15','08:40:00',1.62),('12664','2013-09-15','08:45:00',1.71),('12664','2013-09-15','08:50:00',1.65),('12664','2013-09-15','08:55:00',1.78),('12664','2013-09-15','09:00:00',1.85),('12664','2013-09-15','09:05:00',1.97),('12664','2013-09-15','09:10:00',2.1),('12664','2013-09-15','09:15:00',2.18),('12664','2013-09-15','09:20:00',2.22),('12664','2013-09-15','09:25:00',2.24),('12664','2013-09-15','09:30:00',2.36),('12664','2013-09-15','09:35:00',2.46),('12664','2013-09-15','09:40:00',2.5),('12664','2013-09-15','09:45:00',2.61),('12664','2013-09-15','09:50:00',2.66),('12664','2013-09-15','09:55:00',2.81),('12664','2013-09-15','10:00:00',2.88),('12664','2013-09-15','10:05:00',2.84),('12664','2013-09-15','10:10:00',2.7),('12664','2013-09-15','10:15:00',2.9),('12664','2013-09-15','10:20:00',2.98),('12664','2013-09-15','10:25:00',2.96),('12664','2013-09-15','10:30:00',3.05),('12664','2013-09-15','10:35:00',3.27),('12664','2013-09-15','10:40:00',3.3),('12664','2013-09-15','10:45:00',3.13),('12664','2013-09-15','10:50:00',3.4),('12664','2013-09-15','10:55:00',1.97),('12664','2013-09-15','11:00:00',2.69),('12664','2013-09-15','11:05:00',1.11),('12664','2013-09-15','11:10:00',2.52),('12664','2013-09-15','11:15:00',2.83),('12664','2013-09-15','11:20:00',4.33),('12664','2013-09-15','11:25:00',1.67),('12664','2013-09-15','11:35:00',1.57),('12664','2013-09-15','11:40:00',3.87),('12664','2013-09-15','11:45:00',4.5),('12664','2013-09-15','11:50:00',4.07),('12664','2013-09-15','11:55:00',2.09),('12664','2013-09-15','12:00:00',1.71),('12664','2013-09-15','12:05:00',1.57),('12664','2013-09-15','12:10:00',1.4),('12664','2013-09-15','12:15:00',1.43),('12664','2013-09-15','12:20:00',1.43),('12664','2013-09-15','12:25:00',1.32),('12664','2013-09-15','12:30:00',1.22),('12664','2013-09-15','12:35:00',1.27),('12664','2013-09-15','12:40:00',1.15),('12664','2013-09-15','12:45:00',1.36),('12664','2013-09-15','12:50:00',1.37),('12664','2013-09-15','12:55:00',1.26),('12664','2013-09-15','13:00:00',1.35),('12664','2013-09-15','13:05:00',1.33),('12664','2013-09-15','13:10:00',1.07),('12664','2013-09-15','13:15:00',1.16),('12664','2013-09-15','13:20:00',1.38),('12664','2013-09-15','13:25:00',1.24),('12664','2013-09-15','13:30:00',1.82),('12664','2013-09-15','13:35:00',2.23),('12664','2013-09-15','13:40:00',3.47),('12664','2013-09-15','13:45:00',3.08),('12664','2013-09-15','13:50:00',1.68),('12664','2013-09-15','13:55:00',1.83),('12664','2013-09-15','14:00:00',1.52),('12664','2013-09-15','14:05:00',1.51),('12664','2013-09-15','14:10:00',1.76),('12664','2013-09-15','14:15:00',1.75),('12664','2013-09-15','14:20:00',1.48),('12664','2013-09-15','14:25:00',1.36),('12664','2013-09-15','14:30:00',1.25),('12664','2013-09-15','14:35:00',1.17),('12664','2013-09-15','14:40:00',1.17),('12664','2013-09-15','14:45:00',1.23),('12664','2013-09-15','14:50:00',1.19),('12664','2013-09-15','14:55:00',1.14),('12664','2013-09-15','15:00:00',1.18),('12664','2013-09-15','15:05:00',1.18),('12664','2013-09-15','15:10:00',1.59),('12664','2013-09-15','15:15:00',1.93),('12664','2013-09-15','15:20:00',1.64),('12664','2013-09-15','15:25:00',1.01),('12664','2013-09-14','08:15:00',1.01),('12664','2013-09-14','08:20:00',1.11),('12664','2013-09-14','08:25:00',1.21),('12664','2013-09-14','08:30:00',1.31),('12664','2013-09-14','08:35:00',1.41),('12664','2013-09-14','08:40:00',1.52),('12664','2013-09-14','08:45:00',1.6),('12664','2013-09-14','08:50:00',1.71),('12664','2013-09-14','08:55:00',1.81),('12664','2013-09-14','09:00:00',1.89),('12664','2013-09-14','09:05:00',1.97),('12664','2013-09-14','09:10:00',2.05),('12664','2013-09-14','09:15:00',2.14),('12664','2013-09-14','09:20:00',2.22),('12664','2013-09-14','09:25:00',2.32),('12664','2013-09-14','09:30:00',2.4),('12664','2013-09-14','09:35:00',2.5),('12664','2013-09-14','09:40:00',2.59),('12664','2013-09-14','09:45:00',2.62),('12664','2013-09-14','09:50:00',2.71),('12664','2013-09-14','09:55:00',2.8),('12664','2013-09-14','10:00:00',2.88),('12664','2013-09-14','10:05:00',2.85),('12664','2013-09-14','10:10:00',2.94),('12664','2013-09-14','10:15:00',2.98),('12664','2013-09-14','10:20:00',3.1),('12664','2013-09-14','10:25:00',3),('12664','2013-09-14','10:30:00',3.29),('12664','2013-09-14','10:35:00',3.35),('12664','2013-09-14','10:40:00',3.15),('12664','2013-09-14','10:45:00',3.41),('12664','2013-09-14','10:55:00',2.99),('12664','2013-09-14','11:00:00',3.11),('12664','2013-09-14','11:05:00',3.71),('12664','2013-09-14','11:10:00',3.66),('12664','2013-09-14','11:15:00',3.71),('12664','2013-09-14','11:20:00',3.73),('12664','2013-09-14','11:25:00',3.78),('12664','2013-09-14','11:30:00',3.79),('12664','2013-09-14','11:35:00',3.84),('12664','2013-09-14','11:40:00',3.88),('12664','2013-09-14','11:45:00',3.92),('12664','2013-09-14','11:50:00',3.91),('12664','2013-09-14','11:55:00',3.92),('12664','2013-09-14','12:00:00',3.96),('12664','2013-09-14','12:05:00',3.99),('12664','2013-09-14','12:10:00',4.07),('12664','2013-09-14','12:15:00',4.12),('12664','2013-09-14','12:20:00',4.14),('12664','2013-09-14','12:25:00',4.04),('12664','2013-09-14','12:30:00',4.06),('12664','2013-09-14','12:35:00',4.17),('12664','2013-09-14','12:40:00',4.23),('12664','2013-09-14','12:45:00',4.21),('12664','2013-09-14','12:50:00',4.27),('12664','2013-09-14','12:55:00',4.18),('12664','2013-09-14','13:00:00',4.3),('12664','2013-09-14','13:05:00',4.3),('12664','2013-09-14','13:10:00',4.15),('12664','2013-09-14','13:15:00',4.1),('12664','2013-09-14','13:20:00',4.06),('12664','2013-09-14','13:25:00',4.04),('12664','2013-09-14','13:30:00',4.06),('12664','2013-09-14','13:35:00',4),('12664','2013-09-14','13:40:00',2.32),('12664','2013-09-14','13:45:00',2.15),('12664','2013-09-14','13:50:00',2.46),('12664','2013-09-14','13:55:00',3.08),('12664','2013-09-14','14:00:00',3.72),('12664','2013-09-14','14:05:00',3.84),('12664','2013-09-14','14:10:00',4.11),('12664','2013-09-14','14:15:00',3.93),('12664','2013-09-14','14:20:00',3.85),('12664','2013-09-14','14:25:00',3.79),('12664','2013-09-14','14:30:00',3.69),('12664','2013-09-14','14:35:00',3.72),('12664','2013-09-14','14:40:00',3.69),('12664','2013-09-14','14:45:00',3.66),('12664','2013-09-14','14:50:00',3.62),('12664','2013-09-14','14:55:00',3.57),('12664','2013-09-14','15:00:00',3.52),('12664','2013-09-14','15:05:00',3.48),('12664','2013-09-14','15:10:00',3.44),('12664','2013-09-14','15:15:00',3.39),('12664','2013-09-14','15:20:00',3.34),('12664','2013-09-14','15:25:00',3.26),('12664','2013-09-14','15:30:00',3.21),('12664','2013-09-14','15:35:00',3.14),('12664','2013-09-14','15:40:00',3.11),('12664','2013-09-14','15:45:00',3.03),('12664','2013-09-14','15:50:00',2.97),('12664','2013-09-14','15:55:00',2.9),('12664','2013-09-14','16:00:00',2.82),('12664','2013-09-14','16:05:00',2.78),('12664','2013-09-14','16:10:00',2.66),('12664','2013-09-14','16:15:00',2.54),('12664','2013-09-14','16:20:00',2.58),('12664','2013-09-14','16:25:00',2.51),('12664','2013-09-14','16:30:00',2.42),('12664','2013-09-14','16:35:00',2.34),('12664','2013-09-14','16:40:00',2.25),('12664','2013-09-14','16:45:00',2.14),('12664','2013-09-14','16:50:00',2.08),('12664','2013-09-14','16:55:00',2),('12664','2013-09-14','17:00:00',1.93),('12664','2013-09-14','17:05:00',1.82),('12664','2013-09-14','17:10:00',1.72),('12664','2013-09-14','17:15:00',1.66),('12664','2013-09-14','17:20:00',1.55),('12664','2013-09-14','17:25:00',1.38),('12664','2013-09-14','17:30:00',1.33),('12664','2013-09-14','17:35:00',1.23),('12664','2013-09-14','17:40:00',1.13),('12664','2013-09-14','17:45:00',1.03),('12664','2013-09-13','09:30:00',1.04),('12664','2013-09-13','09:35:00',1.17),('12664','2013-09-13','09:40:00',1.2),('12664','2013-09-13','09:45:00',1.26),('12664','2013-09-13','09:50:00',1.54),('12664','2013-09-13','09:55:00',2.1),('12664','2013-09-13','10:00:00',3.24),('12664','2013-09-13','10:05:00',2.38),('12664','2013-09-13','10:10:00',2.2),('12664','2013-09-13','10:15:00',2.18),('12664','2013-09-13','10:20:00',2.26),('12664','2013-09-13','10:25:00',2.17),('12664','2013-09-13','10:30:00',3.41),('12664','2013-09-13','10:35:00',3.39),('12664','2013-09-13','10:40:00',3.41),('12664','2013-09-13','10:45:00',3.43),('12664','2013-09-13','10:50:00',3.47),('12664','2013-09-13','10:55:00',3.51),('12664','2013-09-13','11:00:00',3.56),('12664','2013-09-13','11:05:00',3.6),('12664','2013-09-13','11:10:00',3.63),('12664','2013-09-13','11:15:00',3.66),('12664','2013-09-13','11:20:00',3.69),('12664','2013-09-13','11:25:00',3.73),('12664','2013-09-13','11:30:00',3.76),('12664','2013-09-13','11:35:00',3.79),('12664','2013-09-13','11:40:00',3.82),('12664','2013-09-13','11:45:00',3.86),('12664','2013-09-13','11:50:00',3.89),('12664','2013-09-13','11:55:00',3.93),('12664','2013-09-13','12:00:00',3.93),('12664','2013-09-13','12:05:00',3.95),('12664','2013-09-13','12:10:00',4),('12664','2013-09-13','12:15:00',4.05),('12664','2013-09-13','12:20:00',4.09),('12664','2013-09-13','12:25:00',4.13),('12664','2013-09-13','12:30:00',4.11),('12664','2013-09-13','12:35:00',4.22),('12664','2013-09-13','12:40:00',2.46),('12664','2013-09-13','12:45:00',3.53),('12664','2013-09-13','12:50:00',4.17),('12664','2013-09-13','12:55:00',3.77),('12664','2013-09-13','13:00:00',3.84),('12664','2013-09-13','13:05:00',1.73),('12664','2013-09-13','13:10:00',4.06),('12664','2013-09-13','13:15:00',4.13),('12664','2013-09-13','13:20:00',4.06),('12664','2013-09-13','13:25:00',4.02),('12664','2013-09-13','13:30:00',4.04),('12664','2013-09-13','13:35:00',4.04),('12664','2013-09-13','13:40:00',4.03),('12664','2013-09-13','13:45:00',4),('12664','2013-09-13','13:50:00',4),('12664','2013-09-13','13:55:00',3.93),('12664','2013-09-13','14:00:00',3.89),('12664','2013-09-13','14:05:00',3.91),('12664','2013-09-13','14:10:00',3.91),('12664','2013-09-13','14:15:00',3.83),('12664','2013-09-13','14:20:00',3.82),('12664','2013-09-13','14:25:00',3.82),('12664','2013-09-13','14:30:00',3.79),('12664','2013-09-13','14:35:00',3.8),('12664','2013-09-13','14:40:00',3.76),('12664','2013-09-13','14:45:00',3.74),('12664','2013-09-13','14:50:00',3.71),('12664','2013-09-13','14:55:00',3.64),('12664','2013-09-13','15:00:00',3.62),('12664','2013-09-13','15:05:00',3.55),('12664','2013-09-13','15:10:00',3.52),('12664','2013-09-13','15:15:00',3.46),('12664','2013-09-13','15:20:00',3.42),('12664','2013-09-13','15:25:00',3.36),('12664','2013-09-13','15:30:00',3.3),('12664','2013-09-13','15:35:00',3.24),('12664','2013-09-13','15:40:00',3.19),('12664','2013-09-13','15:45:00',3.13),('12664','2013-09-13','15:50:00',3.07),('12664','2013-09-13','15:55:00',2.99),('12664','2013-09-13','16:00:00',2.92),('12664','2013-09-13','16:05:00',2.85),('12664','2013-09-13','16:10:00',2.79),('12664','2013-09-13','16:15:00',2.71),('12664','2013-09-13','16:20:00',2.63),('12664','2013-09-13','16:25:00',2.56),('12664','2013-09-13','16:30:00',2.47),('12664','2013-09-13','16:35:00',2.38),('12664','2013-09-13','16:40:00',2.31),('12664','2013-09-13','16:45:00',2.21),('12664','2013-09-13','16:50:00',2.13),('12664','2013-09-13','16:55:00',2.03),('12664','2013-09-13','17:00:00',1.95),('12664','2013-09-13','17:05:00',1.85),('12664','2013-09-13','17:10:00',1.76),('12664','2013-09-13','17:15:00',1.66),('12664','2013-09-13','17:20:00',1.57),('12664','2013-09-13','17:25:00',1.48),('12664','2013-09-13','17:30:00',1.37),('12664','2013-09-13','17:35:00',1.27),('12664','2013-09-13','17:40:00',1.17),('12664','2013-09-13','17:45:00',1.08),('12664','2013-09-12','08:20:00',1.23),('12664','2013-09-12','08:50:00',1.48),('12664','2013-09-12','08:55:00',1.83),('12664','2013-09-12','09:00:00',1.95),('12664','2013-09-12','09:05:00',1.71),('12664','2013-09-12','09:10:00',1.45),('12664','2013-09-12','09:15:00',1.41),('12664','2013-09-12','09:20:00',2.03),('12664','2013-09-12','09:25:00',1.32),('12664','2013-09-12','09:30:00',1.66),('12664','2013-09-12','09:35:00',1.58),('12664','2013-09-12','09:40:00',1.01),('12664','2013-09-12','09:45:00',1),('12664','2013-09-12','09:50:00',2.36),('12664','2013-09-12','09:55:00',2.07),('12664','2013-09-12','10:00:00',2.1),('12664','2013-09-12','10:05:00',2.49),('12664','2013-09-12','10:10:00',1.57),('12664','2013-09-12','10:15:00',1.17),('12664','2013-09-12','10:20:00',1.16),('12664','2013-09-12','10:25:00',2.29),('12664','2013-09-12','10:30:00',2.32),('12664','2013-09-12','10:35:00',2.87),('12664','2013-09-12','10:40:00',2.71),('12664','2013-09-12','10:45:00',2.95),('12664','2013-09-12','10:50:00',3.17),('12664','2013-09-12','10:55:00',4.56),('12664','2013-09-12','11:00:00',3.31),('12664','2013-09-12','11:05:00',1.11),('12664','2013-09-12','11:35:00',1.05),('12664','2013-09-12','11:40:00',1.84),('12664','2013-09-12','11:45:00',2.25),('12664','2013-09-12','11:50:00',3.21),('12664','2013-09-12','11:55:00',3.76),('12664','2013-09-12','12:00:00',4.37),('12664','2013-09-12','12:05:00',4.4),('12664','2013-09-12','12:10:00',4.31),('12664','2013-09-12','12:15:00',2.23),('12664','2013-09-12','12:20:00',3.25),('12664','2013-09-12','12:25:00',3.85),('12664','2013-09-12','12:30:00',4.18),('12664','2013-09-12','12:35:00',3.42),('12664','2013-09-12','12:40:00',3.16),('12664','2013-09-12','12:45:00',3.93),('12664','2013-09-12','12:50:00',3.77),('12664','2013-09-12','12:55:00',4.55),('12664','2013-09-12','13:00:00',4.27),('12664','2013-09-12','13:05:00',4.46),('12664','2013-09-12','13:10:00',3.8),('12664','2013-09-12','13:15:00',1.83),('12664','2013-09-12','13:20:00',2.01),('12664','2013-09-12','13:25:00',4.54),('12664','2013-09-12','13:30:00',3.67),('12664','2013-09-12','13:35:00',3.44),('12664','2013-09-12','13:40:00',4.3),('12664','2013-09-12','13:45:00',4.16),('12664','2013-09-12','13:50:00',3.88),('12664','2013-09-12','13:55:00',3.74),('12664','2013-09-12','14:00:00',4),('12664','2013-09-12','14:05:00',4.15),('12664','2013-09-12','14:10:00',4.13),('12664','2013-09-12','14:15:00',4.13),('12664','2013-09-12','14:20:00',4.13),('12664','2013-09-12','14:25:00',2.39),('12664','2013-09-12','14:30:00',4),('12664','2013-09-12','14:35:00',4.29),('12664','2013-09-12','14:40:00',4.14),('12664','2013-09-12','14:45:00',3.99),('12664','2013-09-12','14:50:00',3.47),('12664','2013-09-12','14:55:00',3.86),('12664','2013-09-12','15:00:00',3.7),('12664','2013-09-12','15:05:00',3.7),('12664','2013-09-12','15:10:00',3.63),('12664','2013-09-12','15:15:00',3.59),('12664','2013-09-12','15:20:00',3.55),('12664','2013-09-12','15:25:00',3.51),('12664','2013-09-12','15:30:00',3.45),('12664','2013-09-12','15:35:00',3.37),('12664','2013-09-12','15:40:00',3.32),('12664','2013-09-12','15:45:00',3.29),('12664','2013-09-12','15:50:00',2.45),('12664','2013-09-12','15:55:00',2.93),('12664','2013-09-12','16:00:00',3.08),('12664','2013-09-12','16:05:00',3.02),('12664','2013-09-12','16:10:00',2.65),('12664','2013-09-12','16:15:00',2.9),('12664','2013-09-12','16:20:00',2.24),('12664','2013-09-12','16:25:00',2.74),('12664','2013-09-12','16:30:00',2.74),('12664','2013-09-12','16:35:00',1.4),('12664','2013-09-12','16:40:00',2.61),('12664','2013-09-12','16:45:00',2.25),('12664','2013-09-12','16:50:00',2.34),('12664','2013-09-12','16:55:00',2.2),('12664','2013-09-12','17:00:00',1.55),('12664','2013-09-12','17:05:00',2.01),('12664','2013-09-12','17:10:00',1.88),('12664','2013-09-12','17:15:00',1.77),('12664','2013-09-12','17:20:00',1.67),('12664','2013-09-12','17:25:00',1.59),('12664','2013-09-12','17:30:00',1.46),('12664','2013-09-12','17:35:00',1.34),('12664','2013-09-12','17:40:00',1.24),('12664','2013-09-12','17:45:00',1.09),('12664','2013-09-11','08:00:00',1.21),('12664','2013-09-11','09:45:00',1.06),('12664','2013-09-11','09:50:00',1.33),('12664','2013-09-11','09:55:00',1.22),('12664','2013-09-11','10:00:00',1.96),('12664','2013-09-11','10:05:00',3.02),('12664','2013-09-11','10:10:00',3.03),('12664','2013-09-11','10:15:00',3.08),('12664','2013-09-11','10:20:00',3.09),('12664','2013-09-11','10:25:00',3.12),('12664','2013-09-11','10:30:00',3.03),('12664','2013-09-11','10:35:00',3.22),('12664','2013-09-11','10:40:00',2.13),('12664','2013-09-11','10:45:00',2.4),('12664','2013-09-11','10:50:00',2.22),('12664','2013-09-11','10:55:00',1.81),('12664','2013-09-11','11:00:00',3.02),('12664','2013-09-11','11:05:00',4.22),('12664','2013-09-11','11:10:00',2.37),('12664','2013-09-11','11:15:00',3.32),('12664','2013-09-11','11:20:00',3.89),('12664','2013-09-11','11:25:00',1.99),('12664','2013-09-11','11:30:00',4.4),('12664','2013-09-11','11:35:00',4.18),('12664','2013-09-11','11:40:00',4.28),('12664','2013-09-11','11:45:00',4.22),('12664','2013-09-11','11:50:00',3.93),('12664','2013-09-11','11:55:00',4.2),('12664','2013-09-11','12:00:00',3.62),('12664','2013-09-11','12:05:00',3.7),('12664','2013-09-11','12:10:00',1.94),('12664','2013-09-11','12:15:00',3.36),('12664','2013-09-11','12:20:00',3.44),('12664','2013-09-11','12:25:00',4.75),('12664','2013-09-11','12:30:00',2.88),('12664','2013-09-11','12:35:00',3.68),('12664','2013-09-11','12:40:00',3.5),('12664','2013-09-11','12:45:00',3.05),('12664','2013-09-11','12:50:00',4.26),('12664','2013-09-11','12:55:00',3.58),('12664','2013-09-11','13:00:00',2.33),('12664','2013-09-11','13:05:00',4.32),('12664','2013-09-11','13:10:00',4.35),('12664','2013-09-11','13:15:00',3.93),('12664','2013-09-11','13:20:00',3.28),('12664','2013-09-11','13:25:00',4.48),('12664','2013-09-11','13:30:00',2.77),('12664','2013-09-11','13:35:00',2.88),('12664','2013-09-11','13:40:00',3.21),('12664','2013-09-11','13:45:00',3.52),('12664','2013-09-11','13:50:00',3.6),('12664','2013-09-11','13:55:00',4.45),('12664','2013-09-11','14:00:00',4.21),('12664','2013-09-11','14:05:00',4.11),('12664','2013-09-11','14:10:00',3.97),('12664','2013-09-11','14:15:00',3.84),('12664','2013-09-11','14:20:00',3.67),('12664','2013-09-11','14:25:00',1.76),('12664','2013-09-11','14:30:00',2.71),('12664','2013-09-11','14:35:00',1.81),('12664','2013-09-11','14:40:00',3.4),('12664','2013-09-11','14:45:00',1.15),('12664','2013-09-11','14:50:00',1.14),('12664','2013-09-11','14:55:00',1.38),('12664','2013-09-11','15:00:00',3.18),('12664','2013-09-11','15:05:00',2.09),('12664','2013-09-11','15:10:00',1.62),('12664','2013-09-11','15:15:00',1.37),('12664','2013-09-11','15:20:00',1.51),('12664','2013-09-11','15:25:00',2.33),('12664','2013-09-11','15:30:00',2.16),('12664','2013-09-11','15:35:00',3.43),('12664','2013-09-11','15:40:00',1.35),('12664','2013-09-11','15:45:00',2.15),('12664','2013-09-11','16:00:00',3.2),('12664','2013-09-11','16:05:00',3.08),('12664','2013-09-11','16:10:00',3.14),('12664','2013-09-11','16:15:00',2.41),('12664','2013-09-11','16:25:00',2.54),('12664','2013-09-11','16:30:00',2.58),('12664','2013-09-11','16:35:00',1.88),('12664','2013-09-11','16:40:00',2.22),('12664','2013-09-11','16:45:00',1.6),('12664','2013-09-11','16:50:00',2.29),('12664','2013-09-11','16:55:00',1.79),('12664','2013-09-11','17:00:00',2.02),('12664','2013-09-11','17:05:00',1.92),('12664','2013-09-11','17:10:00',1.82),('12664','2013-09-11','17:15:00',1.75),('12664','2013-09-11','17:20:00',1.76),('12664','2013-09-11','17:25:00',1.37),('12664','2013-09-11','17:30:00',1.25),('12664','2013-09-11','17:35:00',1.37),('12664','2013-09-11','17:40:00',1.25),('12664','2013-09-11','17:45:00',1.14),('12664','2013-09-11','17:50:00',1.04),('12664','2013-09-10','08:45:00',1.11),('12664','2013-09-10','08:50:00',1.64),('12664','2013-09-10','08:55:00',2),('12664','2013-09-10','09:00:00',1.17),('12664','2013-09-10','09:05:00',1.25),('12664','2013-09-10','09:10:00',2.52),('12664','2013-09-10','09:15:00',1.56),('12664','2013-09-10','09:20:00',2.07),('12664','2013-09-10','09:25:00',1.45),('12664','2013-09-10','09:30:00',1.14),('12664','2013-09-10','09:35:00',1.24),('12664','2013-09-10','09:40:00',1.12),('12664','2013-09-10','09:45:00',1.18),('12664','2013-09-10','09:50:00',1.14),('12664','2013-09-10','10:35:00',1.14),('12664','2013-09-10','10:40:00',1.39),('12664','2013-09-10','10:45:00',1.42),('12664','2013-09-10','10:50:00',1.3),('12664','2013-09-10','10:55:00',1.96),('12664','2013-09-10','11:00:00',2.23),('12664','2013-09-10','11:05:00',1.31),('12664','2013-09-10','11:20:00',1.28),('12664','2013-09-10','11:25:00',1.41),('12664','2013-09-10','11:40:00',1.02),('12664','2013-09-10','11:45:00',1.29),('12664','2013-09-10','11:55:00',1.32),('12664','2013-09-10','12:00:00',1.08),('12664','2013-09-10','12:05:00',1.19),('12664','2013-09-10','12:10:00',1.36),('12664','2013-09-10','12:15:00',1.75),('12664','2013-09-10','12:20:00',1.52),('12664','2013-09-10','12:25:00',1.36),('12664','2013-09-10','13:00:00',1.01),('12664','2013-09-10','13:15:00',1.04),('12664','2013-09-10','13:20:00',1.07),('12664','2013-09-10','13:25:00',1.13),('12664','2013-09-10','13:30:00',1.07),('12664','2013-09-10','13:35:00',1.56),('12664','2013-09-10','13:40:00',1.9),('12664','2013-09-10','13:45:00',2.13),('12664','2013-09-10','13:50:00',2.77),('12664','2013-09-10','13:55:00',2.16),('12664','2013-09-10','14:00:00',1.69),('12664','2013-09-10','14:05:00',1.35),('12664','2013-09-10','14:10:00',1.57),('12664','2013-09-10','14:15:00',1.77),('12664','2013-09-10','14:20:00',1.96),('12664','2013-09-10','14:25:00',2.3),('12664','2013-09-10','14:30:00',2.08),('12664','2013-09-10','14:35:00',1.47),('12664','2013-09-10','14:40:00',1.9),('12664','2013-09-10','14:45:00',2.01),('12664','2013-09-10','14:50:00',2),('12664','2013-09-10','14:55:00',2.27),('12664','2013-09-10','15:00:00',2.36),('12664','2013-09-10','15:05:00',2.58),('12664','2013-09-10','15:10:00',2.48),('12664','2013-09-10','15:15:00',2.35),('12664','2013-09-10','15:20:00',1.5),('12664','2013-09-10','15:25:00',1.7),('12664','2013-09-10','15:30:00',1.57),('12664','2013-09-10','15:35:00',1.29),('12664','2013-09-10','15:40:00',1.22),('12664','2013-09-10','15:45:00',1.27),('12664','2013-09-10','15:50:00',1.13),('12664','2013-09-10','16:45:00',1.18),('12664','2013-09-09','08:55:00',1.12),('12664','2013-09-09','09:00:00',1.13),('12664','2013-09-09','09:35:00',1.15),('12664','2013-09-09','09:40:00',1.44),('12664','2013-09-09','09:45:00',1.37),('12664','2013-09-09','09:50:00',1.22),('12664','2013-09-09','09:55:00',1.23),('12664','2013-09-09','10:00:00',1.22),('12664','2013-09-09','10:15:00',1.13),('12664','2013-09-09','10:20:00',1.18),('12664','2013-09-09','10:25:00',1.31),('12664','2013-09-09','10:30:00',1.61),('12664','2013-09-09','10:35:00',1.74),('12664','2013-09-09','10:40:00',1.76),('12664','2013-09-09','10:45:00',2.48),('12664','2013-09-09','10:50:00',2.67),('12664','2013-09-09','10:55:00',2.75),('12664','2013-09-09','11:00:00',2.37),('12664','2013-09-09','11:05:00',1.83),('12664','2013-09-09','11:10:00',2.04),('12664','2013-09-09','11:15:00',2.45),('12664','2013-09-09','11:20:00',1.73),('12664','2013-09-09','11:25:00',1.9),('12664','2013-09-09','11:30:00',2.17),('12664','2013-09-09','11:35:00',1.67),('12664','2013-09-09','11:40:00',1.55),('12664','2013-09-09','11:45:00',1.9),('12664','2013-09-09','11:50:00',3.46),('12664','2013-09-09','11:55:00',3.34),('12664','2013-09-09','12:00:00',2.78),('12664','2013-09-09','12:05:00',1.59),('12664','2013-09-09','12:10:00',1.75),('12664','2013-09-09','12:15:00',1.91),('12664','2013-09-09','12:20:00',2.05),('12664','2013-09-09','12:25:00',2.27),('12664','2013-09-09','12:30:00',2.14),('12664','2013-09-09','12:35:00',2.11),('12664','2013-09-09','12:40:00',2.31),('12664','2013-09-09','12:45:00',2.05),('12664','2013-09-09','12:50:00',2.26),('12664','2013-09-09','12:55:00',1.97),('12664','2013-09-09','13:00:00',2.16),('12664','2013-09-09','13:05:00',3.48),('12664','2013-09-09','13:10:00',3.78),('12664','2013-09-09','13:15:00',3.04),('12664','2013-09-09','13:20:00',3.08),('12664','2013-09-09','13:25:00',3.38),('12664','2013-09-09','13:30:00',3.5),('12664','2013-09-09','13:35:00',3.72),('12664','2013-09-09','13:40:00',2.63),('12664','2013-09-09','13:45:00',2.83),('12664','2013-09-09','13:50:00',3.67),('12664','2013-09-09','13:55:00',1.32),('12664','2013-09-09','14:00:00',2.21),('12664','2013-09-09','14:05:00',3.89),('12664','2013-09-09','14:10:00',3.16),('12664','2013-09-09','14:15:00',2.42),('12664','2013-09-09','14:20:00',3.67),('12664','2013-09-09','14:25:00',3.6),('12664','2013-09-09','14:30:00',2.07),('12664','2013-09-09','14:35:00',3.27),('12664','2013-09-09','14:40:00',1.33),('12664','2013-09-09','14:45:00',2.43),('12664','2013-09-09','14:50:00',1.59),('12664','2013-09-09','14:55:00',2.72),('12664','2013-09-09','15:00:00',2.98),('12664','2013-09-09','15:05:00',3.65),('12664','2013-09-09','15:10:00',3.45),('12664','2013-09-09','15:15:00',2.69),('12664','2013-09-09','15:20:00',2.69),('12664','2013-09-09','15:25:00',3.1),('12664','2013-09-09','15:30:00',1.88),('12664','2013-09-09','15:35:00',2.45),('12664','2013-09-09','15:40:00',1.48),('12664','2013-09-09','15:45:00',1.6),('12664','2013-09-09','15:50:00',2.15),('12664','2013-09-09','15:55:00',1.48),('12664','2013-09-09','16:00:00',1.11),('12664','2013-09-09','16:05:00',1.57),('12664','2013-09-09','16:10:00',1.09),('12664','2013-09-09','16:15:00',2.13),('12664','2013-09-09','16:20:00',1.23),('12664','2013-09-09','16:35:00',1.19),('12664','2013-09-09','16:40:00',1.09),('12664','2013-09-09','16:45:00',1.76),('12664','2013-09-09','16:50:00',1.37),('12664','2013-09-09','18:05:00',1.08),('12664','2013-09-08','08:55:00',1.5),('12664','2013-09-08','09:00:00',1.76),('12664','2013-09-08','09:05:00',1.9),('12664','2013-09-08','09:10:00',1.81),('12664','2013-09-08','09:15:00',1.59),('12664','2013-09-08','09:20:00',2.01),('12664','2013-09-08','09:25:00',2.14),('12664','2013-09-08','09:30:00',2.19),('12664','2013-09-08','09:35:00',2.28),('12664','2013-09-08','09:40:00',2.37),('12664','2013-09-08','09:45:00',2.41),('12664','2013-09-08','09:50:00',2.49),('12664','2013-09-08','09:55:00',2.57),('12664','2013-09-08','10:00:00',2.65),('12664','2013-09-08','10:05:00',2.71),('12664','2013-09-08','10:10:00',2.69),('12664','2013-09-08','10:15:00',2.81),('12664','2013-09-08','10:20:00',2.9),('12664','2013-09-08','10:25:00',2.94),('12664','2013-09-08','10:30:00',2.98),('12664','2013-09-08','10:35:00',3.08),('12664','2013-09-08','10:40:00',3.01),('12664','2013-09-08','10:45:00',3.05),('12664','2013-09-08','10:50:00',3.2),('12664','2013-09-08','10:55:00',3.31),('12664','2013-09-08','11:00:00',3.29),('12664','2013-09-08','11:05:00',3.22),('12664','2013-09-08','11:10:00',3.19),('12664','2013-09-08','11:15:00',3.27),('12664','2013-09-08','11:20:00',3.27),('12664','2013-09-08','11:25:00',3.38),('12664','2013-09-08','11:30:00',3.36),('12664','2013-09-08','11:35:00',3.36),('12664','2013-09-08','11:40:00',3.42),('12664','2013-09-08','11:45:00',3.49),('12664','2013-09-08','11:50:00',3.51),('12664','2013-09-08','11:55:00',3.35),('12664','2013-09-08','12:00:00',3.47),('12664','2013-09-08','12:05:00',3.5),('12664','2013-09-08','12:10:00',3.71),('12664','2013-09-08','12:15:00',3.7),('12664','2013-09-08','12:20:00',3.68),('12664','2013-09-08','12:25:00',3.74),('12664','2013-09-08','12:30:00',3.77),('12664','2013-09-08','12:35:00',3.64),('12664','2013-09-08','12:40:00',3.73),('12664','2013-09-08','12:45:00',3.66),('12664','2013-09-08','12:50:00',3.64),('12664','2013-09-08','12:55:00',3.66),('12664','2013-09-08','13:00:00',3.73),('12664','2013-09-08','13:05:00',3.71),('12664','2013-09-08','13:10:00',3.51),('12664','2013-09-08','13:15:00',3.61),('12664','2013-09-08','13:20:00',3.45),('12664','2013-09-08','13:25:00',3.24),('12664','2013-09-08','13:30:00',3.19),('12664','2013-09-08','13:35:00',2.35),('12664','2013-09-08','13:40:00',2.3),('12664','2013-09-08','13:45:00',2.52),('12664','2013-09-08','13:50:00',3.58),('12664','2013-09-08','13:55:00',3.22),('12664','2013-09-08','14:00:00',3.26),('12664','2013-09-08','14:05:00',3.45),('12664','2013-09-08','14:10:00',2.84),('12664','2013-09-08','14:15:00',3.24),('12664','2013-09-08','14:20:00',3.3),('12664','2013-09-08','14:25:00',3.49),('12664','2013-09-08','14:30:00',3.75),('12664','2013-09-08','14:35:00',3.57),('12664','2013-09-08','14:40:00',3.74),('12664','2013-09-08','14:45:00',3.36),('12664','2013-09-08','14:50:00',3.24),('12664','2013-09-08','14:55:00',3.55),('12664','2013-09-08','15:00:00',2.96),('12664','2013-09-08','15:05:00',1.97),('12664','2013-09-08','15:10:00',2.8),('12664','2013-09-08','15:15:00',3.45),('12664','2013-09-08','15:20:00',3.47),('12664','2013-09-08','15:25:00',3.36),('12664','2013-09-08','15:30:00',3.24),('12664','2013-09-08','15:35:00',2.88),('12664','2013-09-08','15:40:00',3.12),('12664','2013-09-08','15:45:00',3),('12664','2013-09-08','15:50:00',2.42),('12664','2013-09-08','15:55:00',2.63),('12664','2013-09-08','16:00:00',2.3),('12664','2013-09-08','16:05:00',2.08),('12664','2013-09-08','16:10:00',2.49),('12664','2013-09-08','16:15:00',2.54),('12664','2013-09-08','16:20:00',2.19),('12664','2013-09-08','16:25:00',2.17),('12664','2013-09-08','16:30:00',2.15),('12664','2013-09-08','16:35:00',1.66),('12664','2013-09-08','16:40:00',2.05),('12664','2013-09-08','16:45:00',1.16),('12664','2013-09-08','16:55:00',1.55),('12664','2013-09-08','17:00:00',2.1),('12664','2013-09-08','17:05:00',1.89),('12664','2013-09-08','17:10:00',1.75),('12664','2013-09-08','17:15:00',1.54),('12664','2013-09-08','17:20:00',1.5),('12664','2013-09-08','17:25:00',1.08),('12664','2013-09-08','17:40:00',1.15),('12664','2013-09-08','17:45:00',1.07),('12664','2014-04-11','08:30:00',1.21),('12664','2014-04-11','08:35:00',1.04),('12664','2014-04-11','08:45:00',1.21),('12664','2014-04-11','08:50:00',1.13),('12664','2014-04-11','08:55:00',1.95),('12664','2014-04-11','09:00:00',1.99),('12664','2014-04-11','09:05:00',2.05),('12664','2014-04-11','09:10:00',2.13),('12664','2014-04-11','09:15:00',2.2),('12664','2014-04-11','09:20:00',2.3),('12664','2014-04-11','09:25:00',2.39),('12664','2014-04-11','09:30:00',2.46),('12664','2014-04-11','09:35:00',2.52),('12664','2014-04-11','09:40:00',2.61),('12664','2014-04-11','09:45:00',2.71),('12664','2014-04-11','09:50:00',2.79),('12664','2014-04-11','09:55:00',2.85),('12664','2014-04-11','10:00:00',2.92),('12664','2014-04-11','10:05:00',2.99),('12664','2014-04-11','10:10:00',3.05),('12664','2014-04-11','10:15:00',3.13),('12664','2014-04-11','10:20:00',3.2),('12664','2014-04-11','10:25:00',3.24),('12664','2014-04-11','10:30:00',3.29),('12664','2014-04-11','10:35:00',3.36),('12664','2014-04-11','10:40:00',3.41),('12664','2014-04-11','10:45:00',3.47),('12664','2014-04-11','10:50:00',3.51),('12664','2014-04-11','10:55:00',3.56),('12664','2014-04-11','11:00:00',3.62),('12664','2014-04-11','11:05:00',3.68),('12664','2014-04-11','11:10:00',3.71),('12664','2014-04-11','11:15:00',3.76),('12664','2014-04-11','11:20:00',3.79),('12664','2014-04-11','11:25:00',3.84),('12664','2014-04-11','11:30:00',3.88),('12664','2014-04-11','11:35:00',3.91),('12664','2014-04-11','11:40:00',3.92),('12664','2014-04-11','11:45:00',3.94),('12664','2014-04-11','11:50:00',3.99),('12664','2014-04-11','11:55:00',3.18),('12664','2014-04-11','12:00:00',4.08),('12664','2014-04-11','12:05:00',4.14),('12664','2014-04-11','12:10:00',4.16),('12664','2014-04-11','12:15:00',4.02),('12664','2014-04-11','12:20:00',4.24),('12664','2014-04-11','12:25:00',3.43),('12664','2014-04-11','12:30:00',4.55),('12664','2014-04-11','12:35:00',4.45),('12664','2014-04-11','12:40:00',4.71),('12664','2014-04-11','12:45:00',4.49),('12664','2014-04-11','12:50:00',2.67),('12664','2014-04-11','12:55:00',3.12),('12664','2014-04-11','13:00:00',3.85),('12664','2014-04-11','13:05:00',4.16),('12664','2014-04-11','13:10:00',4.45),('12664','2014-04-11','13:15:00',1.71),('12664','2014-04-11','13:20:00',1.43),('12664','2014-04-11','13:25:00',4.78),('12664','2014-04-11','13:30:00',3.1),('12664','2014-04-11','13:35:00',4.7),('12664','2014-04-11','13:40:00',4.45),('12664','2014-04-11','13:45:00',4.3),('12664','2014-04-11','13:50:00',3.46),('12664','2014-04-11','13:55:00',4.51),('12664','2014-04-11','14:00:00',4.44),('12664','2014-04-11','14:05:00',3.41),('12664','2014-04-11','14:10:00',2.05),('12664','2014-04-11','14:15:00',3.49),('12664','2014-04-11','14:20:00',2.96),('12664','2014-04-11','14:25:00',3.78),('12664','2014-04-11','14:30:00',3.41),('12664','2014-04-11','14:35:00',2.71),('12664','2014-04-11','14:40:00',3.05),('12664','2014-04-11','14:45:00',1.32),('12664','2014-04-11','14:50:00',2.92),('12664','2014-04-11','14:55:00',2.75),('12664','2014-04-11','15:00:00',2.23),('12664','2014-04-11','15:05:00',2.36),('12664','2014-04-11','15:10:00',1.74),('12664','2014-04-11','15:15:00',3.21),('12664','2014-04-11','15:20:00',3.53),('12664','2014-04-11','15:25:00',3.01),('12664','2014-04-11','15:30:00',3.49),('12664','2014-04-11','15:35:00',3.22),('12664','2014-04-11','15:40:00',2.68),('12664','2014-04-11','15:45:00',3.02),('12664','2014-04-11','15:50:00',3.01),('12664','2014-04-11','15:55:00',3),('12664','2014-04-11','16:00:00',3.13),('12664','2014-04-11','16:05:00',3.05),('12664','2014-04-11','16:10:00',2.92),('12664','2014-04-11','16:15:00',2.14),('12664','2014-04-11','16:20:00',2.88),('12664','2014-04-11','16:25:00',2.8),('12664','2014-04-11','16:30:00',2.78),('12664','2014-04-11','16:35:00',2.61),('12664','2014-04-11','16:40:00',2.72),('12664','2014-04-11','16:45:00',2.56),('12664','2014-04-11','16:50:00',2.51),('12664','2014-04-11','16:55:00',2.07),('12664','2014-04-11','17:00:00',1.4),('12664','2014-04-11','17:05:00',2.16),('12664','2014-04-11','17:10:00',1.9),('12664','2014-04-11','17:15:00',1.34),('12664','2014-04-11','17:20:00',1.5),('12664','2014-04-11','17:25:00',1.66),('12664','2014-04-11','17:30:00',1.29),('12664','2014-04-11','17:35:00',1.76),('12664','2014-04-11','17:40:00',1.52),('12664','2014-04-11','17:45:00',1.32),('12664','2014-04-11','17:50:00',1.25),('12664','2014-04-11','17:55:00',1.24),('12664','2014-04-11','18:00:00',1.05),('12664','2014-04-11','18:05:00',1.05),('12664','2013-09-07','08:15:00',1),('12664','2013-09-07','08:20:00',1.09),('12664','2013-09-07','08:25:00',1.18),('12664','2013-09-07','08:30:00',1.27),('12664','2013-09-07','08:35:00',1.36),('12664','2013-09-07','08:40:00',1.46),('12664','2013-09-07','08:45:00',1.55),('12664','2013-09-07','08:50:00',1.63),('12664','2013-09-07','08:55:00',1.73),('12664','2013-09-07','09:00:00',1.82),('12664','2013-09-07','09:05:00',1.89),('12664','2013-09-07','09:10:00',1.99),('12664','2013-09-07','09:15:00',2.06),('12664','2013-09-07','09:20:00',2.13),('12664','2013-09-07','09:25:00',2.19),('12664','2013-09-07','09:30:00',2.27),('12664','2013-09-07','09:35:00',2.35),('12664','2013-09-07','09:40:00',2.41),('12664','2013-09-07','09:45:00',2.49),('12664','2013-09-07','09:50:00',2.57),('12664','2013-09-07','09:55:00',2.64),('12664','2013-09-07','10:00:00',2.71),('12664','2013-09-07','10:05:00',2.77),('12664','2013-09-07','10:10:00',2.81),('12664','2013-09-07','10:15:00',2.88),('12664','2013-09-07','10:20:00',2.93),('12664','2013-09-07','10:25:00',2.97),('12664','2013-09-07','10:30:00',3.04),('12664','2013-09-07','10:35:00',3.08),('12664','2013-09-07','10:40:00',3.12),('12664','2013-09-07','10:45:00',3.13),('12664','2013-09-07','10:50:00',3.2),('12664','2013-09-07','10:55:00',3.26),('12664','2013-09-07','11:00:00',3.29),('12664','2013-09-07','11:05:00',3.36),('12664','2013-09-07','11:10:00',3.44),('12664','2013-09-07','11:15:00',3.42),('12664','2013-09-07','11:20:00',3.47),('12664','2013-09-07','11:25:00',3.52),('12664','2013-09-07','11:30:00',3.53),('12664','2013-09-07','11:35:00',3.57),('12664','2013-09-07','11:40:00',3.58),('12664','2013-09-07','11:45:00',3.61),('12664','2013-09-07','11:50:00',3.63),('12664','2013-09-07','11:55:00',3.66),('12664','2013-09-07','12:00:00',3.66),('12664','2013-09-07','12:05:00',3.71),('12664','2013-09-07','12:10:00',3.64),('12664','2013-09-07','12:15:00',3.64),('12664','2013-09-07','12:20:00',3.73),('12664','2013-09-07','12:25:00',3.75),('12664','2013-09-07','12:30:00',3.75),('12664','2013-09-07','12:35:00',3.7),('12664','2013-09-07','12:40:00',3.75),('12664','2013-09-07','12:45:00',3.82),('12664','2013-09-07','12:50:00',3.82),('12664','2013-09-07','12:55:00',3.78),('12664','2013-09-07','13:00:00',3.84),('12664','2013-09-07','13:05:00',3.88),('12664','2013-09-07','13:10:00',3.81),('12664','2013-09-07','13:15:00',3.79),('12664','2013-09-07','13:20:00',3.8),('12664','2013-09-07','13:25:00',3.75),('12664','2013-09-07','13:30:00',3.78),('12664','2013-09-07','13:35:00',3.84),('12664','2013-09-07','13:40:00',3.88),('12664','2013-09-07','13:45:00',3.87),('12664','2013-09-07','13:50:00',3.83),('12664','2013-09-07','13:55:00',3.79),('12664','2013-09-07','14:00:00',3.83),('12664','2013-09-07','14:05:00',3.79),('12664','2013-09-07','14:10:00',3.78),('12664','2013-09-07','14:15:00',3.78),('12664','2013-09-07','14:20:00',3.74),('12664','2013-09-07','14:25:00',3.72),('12664','2013-09-07','14:30:00',3.71),('12664','2013-09-07','14:35:00',3.67),('12664','2013-09-07','14:40:00',3.65),('12664','2013-09-07','14:45:00',3.62),('12664','2013-09-07','14:50:00',3.57),('12664','2013-09-07','14:55:00',3.52),('12664','2013-09-07','15:00:00',3.48),('12664','2013-09-07','15:05:00',3.43),('12664','2013-09-07','15:10:00',3.4),('12664','2013-09-07','15:15:00',3.37),('12664','2013-09-07','15:20:00',3.3),('12664','2013-09-07','15:25:00',3.25),('12664','2013-09-07','15:30:00',3.21),('12664','2013-09-07','15:35:00',3.15),('12664','2013-09-07','15:40:00',3.09),('12664','2013-09-07','15:45:00',3.04),('12664','2013-09-07','15:50:00',2.98),('12664','2013-09-07','15:55:00',2.91),('12664','2013-09-07','16:00:00',2.83),('12664','2013-09-07','16:05:00',2.78),('12664','2013-09-07','16:10:00',2.71),('12664','2013-09-07','16:15:00',2.64),('12664','2013-09-07','16:20:00',2.55),('12664','2013-09-07','16:25:00',2.47),('12664','2013-09-07','16:30:00',2.4),('12664','2013-09-07','16:35:00',2.33),('12664','2013-09-07','16:40:00',2.25),('12664','2013-09-07','16:45:00',2.17),('12664','2013-09-07','16:50:00',2.07),('12664','2013-09-07','16:55:00',1.99),('12664','2013-09-07','17:00:00',1.91),('12664','2013-09-07','17:05:00',1.83),('12664','2013-09-07','17:10:00',1.74),('12664','2013-09-07','17:15:00',1.64),('12664','2013-09-07','17:20:00',1.53),('12664','2013-09-07','17:25:00',1.43),('12664','2013-09-07','17:30:00',1.36),('12664','2013-09-07','17:35:00',1.26),('12664','2013-09-07','17:40:00',1.18),('12664','2013-09-07','17:45:00',1.09),('12664','2013-09-07','17:50:00',1),('12664','2013-09-06','08:15:00',1.05),('12664','2013-09-06','08:20:00',1.14),('12664','2013-09-06','08:25:00',1.23),('12664','2013-09-06','08:30:00',1.32),('12664','2013-09-06','08:35:00',1.41),('12664','2013-09-06','08:40:00',1.5),('12664','2013-09-06','08:45:00',1.57),('12664','2013-09-06','08:50:00',1.63),('12664','2013-09-06','08:55:00',1.71),('12664','2013-09-06','09:00:00',1.8),('12664','2013-09-06','09:05:00',1.91),('12664','2013-09-06','09:10:00',2.01),('12664','2013-09-06','09:15:00',2.08),('12664','2013-09-06','09:20:00',2.16),('12664','2013-09-06','09:25:00',2.24),('12664','2013-09-06','09:30:00',2.32),('12664','2013-09-06','09:35:00',2.4),('12664','2013-09-06','09:40:00',2.49),('12664','2013-09-06','09:45:00',2.56),('12664','2013-09-06','09:50:00',2.64),('12664','2013-09-06','09:55:00',2.71),('12664','2013-09-06','10:00:00',2.76),('12664','2013-09-06','10:05:00',2.84),('12664','2013-09-06','10:10:00',2.9),('12664','2013-09-06','10:15:00',2.95),('12664','2013-09-06','10:20:00',3),('12664','2013-09-06','10:25:00',3.07),('12664','2013-09-06','10:30:00',3.14),('12664','2013-09-06','10:35:00',3.18),('12664','2013-09-06','10:40:00',3.23),('12664','2013-09-06','10:45:00',3.27),('12664','2013-09-06','10:50:00',3.32),('12664','2013-09-06','10:55:00',3.39),('12664','2013-09-06','11:00:00',3.42),('12664','2013-09-06','11:05:00',3.43),('12664','2013-09-06','11:10:00',3.47),('12664','2013-09-06','11:15:00',3.5),('12664','2013-09-06','11:20:00',3.55),('12664','2013-09-06','11:25:00',3.57),('12664','2013-09-06','11:30:00',3.59),('12664','2013-09-06','11:35:00',3.61),('12664','2013-09-06','11:40:00',3.63),('12664','2013-09-06','11:45:00',3.64),('12664','2013-09-06','11:50:00',3.7),('12664','2013-09-06','11:55:00',3.68),('12664','2013-09-06','12:00:00',3.7),('12664','2013-09-06','12:05:00',3.73),('12664','2013-09-06','12:10:00',3.74),('12664','2013-09-06','12:15:00',3.79),('12664','2013-09-06','12:20:00',3.81),('12664','2013-09-06','12:25:00',3.83),('12664','2013-09-06','12:30:00',3.79),('12664','2013-09-06','12:35:00',3.81),('12664','2013-09-06','12:40:00',3.78),('12664','2013-09-06','12:45:00',3.82),('12664','2013-09-06','12:50:00',3.82),('12664','2013-09-06','12:55:00',3.84),('12664','2013-09-06','13:00:00',3.83),('12664','2013-09-06','13:05:00',3.83),('12664','2013-09-06','13:10:00',3.82),('12664','2013-09-06','13:15:00',3.81),('12664','2013-09-06','13:20:00',3.82),('12664','2013-09-06','13:25:00',3.81),('12664','2013-09-06','13:30:00',3.76),('12664','2013-09-06','13:35:00',3.76),('12664','2013-09-06','13:40:00',3.74),('12664','2013-09-06','13:45:00',3.71),('12664','2013-09-06','13:50:00',3.67),('12664','2013-09-06','13:55:00',3.66),('12664','2013-09-06','14:00:00',3.64),('12664','2013-09-06','14:05:00',3.66),('12664','2013-09-06','14:10:00',3.63),('12664','2013-09-06','14:15:00',3.67),('12664','2013-09-06','14:20:00',3.6),('12664','2013-09-06','14:25:00',3.63),('12664','2013-09-06','14:30:00',3.67),('12664','2013-09-06','14:35:00',3.61),('12664','2013-09-06','14:40:00',3.57),('12664','2013-09-06','14:45:00',3.53),('12664','2013-09-06','14:50:00',3.5),('12664','2013-09-06','14:55:00',3.44),('12664','2013-09-06','15:00:00',3.41),('12664','2013-09-06','15:05:00',3.4),('12664','2013-09-06','15:10:00',3.35),('12664','2013-09-06','15:15:00',3.3),('12664','2013-09-06','15:20:00',3.28),('12664','2013-09-06','15:25:00',3.23),('12664','2013-09-06','15:30:00',3.19),('12664','2013-09-06','15:35:00',3.14),('12664','2013-09-06','15:40:00',3.1),('12664','2013-09-06','15:45:00',3.05),('12664','2013-09-06','15:50:00',2.97),('12664','2013-09-06','15:55:00',2.9),('12664','2013-09-06','16:00:00',2.83),('12664','2013-09-06','16:05:00',2.77),('12664','2013-09-06','16:10:00',2.73),('12664','2013-09-06','16:15:00',2.66),('12664','2013-09-06','16:20:00',2.61),('12664','2013-09-06','16:25:00',2.52),('12664','2013-09-06','16:30:00',2.44),('12664','2013-09-06','16:35:00',2.37),('12664','2013-09-06','16:40:00',2.27),('12664','2013-09-06','16:45:00',2.18),('12664','2013-09-06','16:50:00',2.1),('12664','2013-09-06','16:55:00',2.02),('12664','2013-09-06','17:00:00',1.92),('12664','2013-09-06','17:05:00',1.82),('12664','2013-09-06','17:10:00',1.72),('12664','2013-09-06','17:15:00',1.62),('12664','2013-09-06','17:20:00',1.52),('12664','2013-09-06','17:25:00',1.44),('12664','2013-09-06','17:30:00',1.36),('12664','2013-09-06','17:35:00',1.25),('12664','2013-09-06','17:40:00',1.17),('12664','2013-09-06','17:45:00',1.08),('12664','2013-09-05','08:10:00',1.05),('12664','2013-09-05','08:15:00',1.16),('12664','2013-09-05','08:20:00',1.26),('12664','2013-09-05','08:25:00',1.35),('12664','2013-09-05','08:30:00',1.45),('12664','2013-09-05','08:35:00',1.54),('12664','2013-09-05','08:40:00',1.63),('12664','2013-09-05','08:45:00',1.72),('12664','2013-09-05','08:50:00',1.82),('12664','2013-09-05','08:55:00',1.91),('12664','2013-09-05','09:00:00',1.99),('12664','2013-09-05','09:05:00',2.07),('12664','2013-09-05','09:10:00',2.14),('12664','2013-09-05','09:15:00',2.23),('12664','2013-09-05','09:20:00',2.31),('12664','2013-09-05','09:25:00',2.39),('12664','2013-09-05','09:30:00',2.45),('12664','2013-09-05','09:35:00',2.5),('12664','2013-09-05','09:40:00',2.56),('12664','2013-09-05','09:45:00',2.63),('12664','2013-09-05','09:50:00',2.7),('12664','2013-09-05','09:55:00',2.79),('12664','2013-09-05','10:00:00',2.88),('12664','2013-09-05','10:05:00',2.95),('12664','2013-09-05','10:10:00',2.98),('12664','2013-09-05','10:15:00',3.03),('12664','2013-09-05','10:20:00',3.09),('12664','2013-09-05','10:25:00',3.17),('12664','2013-09-05','10:30:00',3.22),('12664','2013-09-05','10:35:00',3.27),('12664','2013-09-05','10:40:00',3.32),('12664','2013-09-05','10:45:00',3.36),('12664','2013-09-05','10:50:00',3.4),('12664','2013-09-05','10:55:00',3.45),('12664','2013-09-05','11:00:00',3.47),('12664','2013-09-05','11:05:00',3.51),('12664','2013-09-05','11:10:00',3.52),('12664','2013-09-05','11:15:00',3.54),('12664','2013-09-05','11:20:00',3.61),('12664','2013-09-05','11:25:00',3.65),('12664','2013-09-05','11:30:00',3.7),('12664','2013-09-05','11:35:00',3.72),('12664','2013-09-05','11:40:00',3.75),('12664','2013-09-05','11:45:00',3.8),('12664','2013-09-05','11:50:00',3.82),('12664','2013-09-05','11:55:00',3.86),('12664','2013-09-05','12:00:00',3.84),('12664','2013-09-05','12:05:00',3.86),('12664','2013-09-05','12:10:00',3.9),('12664','2013-09-05','12:15:00',3.94),('12664','2013-09-05','12:20:00',3.95),('12664','2013-09-05','12:25:00',3.94),('12664','2013-09-05','12:30:00',3.92),('12664','2013-09-05','12:35:00',3.95),('12664','2013-09-05','12:40:00',3.96),('12664','2013-09-05','12:45:00',3.95),('12664','2013-09-05','12:50:00',3.95),('12664','2013-09-05','12:55:00',3.93),('12664','2013-09-05','13:00:00',3.93),('12664','2013-09-05','13:05:00',3.94),('12664','2013-09-05','13:10:00',3.94),('12664','2013-09-05','13:15:00',3.92),('12664','2013-09-05','13:20:00',3.91),('12664','2013-09-05','13:25:00',3.91),('12664','2013-09-05','13:30:00',3.88),('12664','2013-09-05','13:35:00',3.84),('12664','2013-09-05','13:40:00',3.82),('12664','2013-09-05','13:45:00',3.82),('12664','2013-09-05','13:50:00',3.82),('12664','2013-09-05','13:55:00',3.8),('12664','2013-09-05','14:00:00',3.8),('12664','2013-09-05','14:05:00',3.79),('12664','2013-09-05','14:10:00',3.8),('12664','2013-09-05','14:15:00',3.82),('12664','2013-09-05','14:20:00',3.81),('12664','2013-09-05','14:25:00',3.78),('12664','2013-09-05','14:30:00',3.76),('12664','2013-09-05','14:35:00',3.71),('12664','2013-09-05','14:40:00',3.67),('12664','2013-09-05','14:45:00',3.65),('12664','2013-09-05','14:50:00',3.62),('12664','2013-09-05','14:55:00',3.59),('12664','2013-09-05','15:00:00',3.57),('12664','2013-09-05','15:05:00',3.53),('12664','2013-09-05','15:10:00',3.47),('12664','2013-09-05','15:15:00',3.43),('12664','2013-09-05','15:20:00',3.37),('12664','2013-09-05','15:25:00',3.32),('12664','2013-09-05','15:30:00',3.29),('12664','2013-09-05','15:35:00',3.24),('12664','2013-09-05','15:40:00',3.17),('12664','2013-09-05','15:45:00',3.1),('12664','2013-09-05','15:50:00',3.04),('12664','2013-09-05','15:55:00',3),('12664','2013-09-05','16:00:00',2.93),('12664','2013-09-05','16:05:00',2.86),('12664','2013-09-05','16:10:00',2.8),('12664','2013-09-05','16:15:00',2.75),('12664','2013-09-05','16:20:00',2.7),('12664','2013-09-05','16:25:00',2.64),('12664','2013-09-05','16:30:00',2.56),('12664','2013-09-05','16:35:00',2.51),('12664','2013-09-05','16:40:00',2.44),('12664','2013-09-05','16:45:00',2.39),('12664','2013-09-05','16:50:00',2.33),('12664','2013-09-05','16:55:00',2.02),('12664','2013-09-05','17:00:00',1.4),('12664','2013-09-05','17:05:00',1.38),('12664','2013-09-05','17:10:00',1.43),('12664','2013-09-05','17:15:00',1.23),('12664','2013-09-05','17:20:00',1.29),('12664','2013-09-05','17:25:00',1.29),('12664','2013-09-05','17:30:00',1.26),('12664','2013-09-05','17:35:00',1.42),('12664','2013-09-05','17:40:00',1.42),('12664','2013-09-05','17:45:00',1.42),('12664','2013-09-05','17:50:00',1.25),('12664','2013-09-05','17:55:00',1.2),('12664','2013-09-04','08:10:00',1.06),('12664','2013-09-04','08:15:00',1.16),('12664','2013-09-04','08:20:00',1.26),('12664','2013-09-04','08:25:00',1.36),('12664','2013-09-04','08:30:00',1.45),('12664','2013-09-04','08:35:00',1.55),('12664','2013-09-04','08:40:00',1.64),('12664','2013-09-04','08:45:00',1.74),('12664','2013-09-04','08:50:00',1.83),('12664','2013-09-04','08:55:00',1.92),('12664','2013-09-04','09:00:00',2),('12664','2013-09-04','09:05:00',2.09),('12664','2013-09-04','09:10:00',2.18),('12664','2013-09-04','09:15:00',2.26),('12664','2013-09-04','09:20:00',2.34),('12664','2013-09-04','09:25:00',2.43),('12664','2013-09-04','09:30:00',2.5),('12664','2013-09-04','09:35:00',2.58),('12664','2013-09-04','09:40:00',2.64),('12664','2013-09-04','09:45:00',2.71),('12664','2013-09-04','09:50:00',2.78),('12664','2013-09-04','09:55:00',2.83),('12664','2013-09-04','10:00:00',2.91),('12664','2013-09-04','10:05:00',2.99),('12664','2013-09-04','10:10:00',3.05),('12664','2013-09-04','10:15:00',3.11),('12664','2013-09-04','10:20:00',3.16),('12664','2013-09-04','10:25:00',3.2),('12664','2013-09-04','10:30:00',3.24),('12664','2013-09-04','10:35:00',3.28),('12664','2013-09-04','10:40:00',3.32),('12664','2013-09-04','10:45:00',3.35),('12664','2013-09-04','10:50:00',3.4),('12664','2013-09-04','10:55:00',3.44),('12664','2013-09-04','11:00:00',3.49),('12664','2013-09-04','11:05:00',3.53),('12664','2013-09-04','11:10:00',3.6),('12664','2013-09-04','11:15:00',3.65),('12664','2013-09-04','11:20:00',3.7),('12664','2013-09-04','11:25:00',3.71),('12664','2013-09-04','11:30:00',3.74),('12664','2013-09-04','11:35:00',3.76),('12664','2013-09-04','11:40:00',3.81),('12664','2013-09-04','11:45:00',3.83),('12664','2013-09-04','11:50:00',3.87),('12664','2013-09-04','11:55:00',3.88),('12664','2013-09-04','12:00:00',3.9),('12664','2013-09-04','12:05:00',3.95),('12664','2013-09-04','12:10:00',3.94),('12664','2013-09-04','12:15:00',3.96),('12664','2013-09-04','12:20:00',3.98),('12664','2013-09-04','12:25:00',4.02),('12664','2013-09-04','12:30:00',4.04),('12664','2013-09-04','12:35:00',4.08),('12664','2013-09-04','12:40:00',4.07),('12664','2013-09-04','12:45:00',4.04),('12664','2013-09-04','12:50:00',4.03),('12664','2013-09-04','12:55:00',4.03),('12664','2013-09-04','13:00:00',4.05),('12664','2013-09-04','13:05:00',4.03),('12664','2013-09-04','13:10:00',4.03),('12664','2013-09-04','13:15:00',4.05),('12664','2013-09-04','13:20:00',4.05),('12664','2013-09-04','13:25:00',4.03),('12664','2013-09-04','13:30:00',3.99),('12664','2013-09-04','13:35:00',4),('12664','2013-09-04','13:40:00',3.98),('12664','2013-09-04','13:45:00',3.96),('12664','2013-09-04','13:50:00',3.94),('12664','2013-09-04','13:55:00',3.91),('12664','2013-09-04','14:00:00',3.9),('12664','2013-09-04','14:05:00',3.91),('12664','2013-09-04','14:10:00',3.88),('12664','2013-09-04','14:15:00',3.83),('12664','2013-09-04','14:20:00',3.8),('12664','2013-09-04','14:25:00',3.75),('12664','2013-09-04','14:30:00',3.75),('12664','2013-09-04','14:35:00',3.74),('12664','2013-09-04','14:40:00',3.72),('12664','2013-09-04','14:45:00',3.7),('12664','2013-09-04','14:50:00',3.66),('12664','2013-09-04','14:55:00',3.62),('12664','2013-09-04','15:00:00',3.58),('12664','2013-09-04','15:05:00',3.53),('12664','2013-09-04','15:10:00',3.49),('12664','2013-09-04','15:15:00',3.43),('12664','2013-09-04','15:20:00',3.36),('12664','2013-09-04','15:25:00',3.33),('12664','2013-09-04','15:30:00',3.27),('12664','2013-09-04','15:35:00',3.23),('12664','2013-09-04','15:40:00',3.1),('12664','2013-09-04','15:45:00',3.06),('12664','2013-09-04','15:50:00',2.45),('12664','2013-09-04','15:55:00',3.03),('12664','2013-09-04','16:00:00',2.98),('12664','2013-09-04','16:05:00',2.91),('12664','2013-09-04','16:10:00',2.83),('12664','2013-09-04','16:15:00',2.76),('12664','2013-09-04','16:20:00',2.7),('12664','2013-09-04','16:25:00',2.61),('12664','2013-09-04','16:30:00',2.51),('12664','2013-09-04','16:35:00',2.42),('12664','2013-09-04','16:40:00',2.35),('12664','2013-09-04','16:45:00',2.25),('12664','2013-09-04','16:50:00',2.18),('12664','2013-09-04','16:55:00',2.08),('12664','2013-09-04','17:00:00',1.98),('12664','2013-09-04','17:05:00',1.82),('12664','2013-09-04','17:10:00',1.83),('12664','2013-09-04','17:15:00',1.75),('12664','2013-09-04','17:20:00',1.67),('12664','2013-09-04','17:25:00',1.58),('12664','2013-09-04','17:30:00',1.5),('12664','2013-09-04','17:35:00',1.39),('12664','2013-09-04','17:40:00',1.3),('12664','2013-09-04','17:45:00',1.21),('12664','2013-09-04','17:50:00',1.12),('12664','2013-09-04','17:55:00',1.02),('12664','2013-09-03','08:15:00',1.04),('12664','2013-09-03','08:20:00',1.13),('12664','2013-09-03','08:25:00',1.22),('12664','2013-09-03','08:30:00',1.31),('12664','2013-09-03','08:35:00',1.4),('12664','2013-09-03','08:40:00',1.49),('12664','2013-09-03','08:45:00',1.58),('12664','2013-09-03','08:50:00',1.66),('12664','2013-09-03','08:55:00',1.75),('12664','2013-09-03','09:00:00',1.84),('12664','2013-09-03','09:05:00',1.92),('12664','2013-09-03','09:10:00',2.02),('12664','2013-09-03','09:15:00',2.1),('12664','2013-09-03','09:20:00',2.18),('12664','2013-09-03','09:25:00',2.26),('12664','2013-09-03','09:30:00',2.35),('12664','2013-09-03','09:35:00',2.44),('12664','2013-09-03','09:40:00',2.52),('12664','2013-09-03','09:45:00',2.58),('12664','2013-09-03','09:50:00',2.63),('12664','2013-09-03','09:55:00',2.7),('12664','2013-09-03','10:00:00',2.77),('12664','2013-09-03','10:05:00',2.83),('12664','2013-09-03','10:10:00',2.9),('12664','2013-09-03','10:15:00',2.95),('12664','2013-09-03','10:20:00',2.99),('12664','2013-09-03','10:25:00',3.04),('12664','2013-09-03','10:30:00',3.11),('12664','2013-09-03','10:35:00',3.17),('12664','2013-09-03','10:40:00',3.23),('12664','2013-09-03','10:45:00',3.28),('12664','2013-09-03','10:50:00',3.32),('12664','2013-09-03','10:55:00',3.35),('12664','2013-09-03','11:00:00',3.4),('12664','2013-09-03','11:05:00',3.43),('12664','2013-09-03','11:10:00',3.47),('12664','2013-09-03','11:15:00',3.5),('12664','2013-09-03','11:20:00',3.54),('12664','2013-09-03','11:25:00',3.58),('12664','2013-09-03','11:30:00',3.63),('12664','2013-09-03','11:35:00',3.67),('12664','2013-09-03','11:40:00',3.67),('12664','2013-09-03','11:45:00',3.7),('12664','2013-09-03','11:50:00',3.7),('12664','2013-09-03','11:55:00',3.71),('12664','2013-09-03','12:00:00',3.75),('12664','2013-09-03','12:05:00',3.79),('12664','2013-09-03','12:10:00',3.8),('12664','2013-09-03','12:15:00',3.84),('12664','2013-09-03','12:20:00',3.82),('12664','2013-09-03','12:25:00',3.87),('12664','2013-09-03','12:30:00',3.93),('12664','2013-09-03','12:35:00',3.97),('12664','2013-09-03','12:40:00',3.97),('12664','2013-09-03','12:45:00',3.96),('12664','2013-09-03','12:50:00',3.98),('12664','2013-09-03','12:55:00',3.98),('12664','2013-09-03','13:00:00',3.99),('12664','2013-09-03','13:05:00',4),('12664','2013-09-03','13:10:00',4),('12664','2013-09-03','13:15:00',4.01),('12664','2013-09-03','13:20:00',3.99),('12664','2013-09-03','13:25:00',3.96),('12664','2013-09-03','13:30:00',3.92),('12664','2013-09-03','13:35:00',3.92),('12664','2013-09-03','13:40:00',3.92),('12664','2013-09-03','13:45:00',3.92),('12664','2013-09-03','13:50:00',3.91),('12664','2013-09-03','13:55:00',3.9),('12664','2013-09-03','14:00:00',3.91),('12664','2013-09-03','14:05:00',3.89),('12664','2013-09-03','14:10:00',3.86),('12664','2013-09-03','14:15:00',3.83),('12664','2013-09-03','14:20:00',3.78),('12664','2013-09-03','14:25:00',3.72),('12664','2013-09-03','14:30:00',3.68),('12664','2013-09-03','14:35:00',3.7),('12664','2013-09-03','14:40:00',3.66),('12664','2013-09-03','14:45:00',3.64),('12664','2013-09-03','14:50:00',3.59),('12664','2013-09-03','14:55:00',3.55),('12664','2013-09-03','15:00:00',3.51),('12664','2013-09-03','15:05:00',3.45),('12664','2013-09-03','15:10:00',3.42),('12664','2013-09-03','15:15:00',3.36),('12664','2013-09-03','15:20:00',3.32),('12664','2013-09-03','15:25:00',3.27),('12664','2013-09-03','15:30:00',3.2),('12664','2013-09-03','15:35:00',3.15),('12664','2013-09-03','15:40:00',3.1),('12664','2013-09-03','15:45:00',3.08),('12664','2013-09-03','15:50:00',3.01),('12664','2013-09-03','15:55:00',2.96),('12664','2013-09-03','16:00:00',2.88),('12664','2013-09-03','16:05:00',2.81),('12664','2013-09-03','16:10:00',2.76),('12664','2013-09-03','16:15:00',2.7),('12664','2013-09-03','16:20:00',2.63),('12664','2013-09-03','16:25:00',2.55),('12664','2013-09-03','16:30:00',2.47),('12664','2013-09-03','16:35:00',2.42),('12664','2013-09-03','16:40:00',2.34),('12664','2013-09-03','16:45:00',2.28),('12664','2013-09-03','16:50:00',2.19),('12664','2013-09-03','16:55:00',2.11),('12664','2013-09-03','17:00:00',2.03),('12664','2013-09-03','17:05:00',1.96),('12664','2013-09-03','17:10:00',1.87),('12664','2013-09-03','17:15:00',1.66),('12664','2013-09-03','17:20:00',1.52),('12664','2013-09-03','17:25:00',1.43),('12664','2013-09-03','17:30:00',1.42),('12664','2013-09-03','17:35:00',1.34),('12664','2013-09-03','17:40:00',1.27),('12664','2013-09-03','17:45:00',1.18),('12664','2013-09-03','17:50:00',1.1),('12664','2013-09-02','08:15:00',1.09),('12664','2013-09-02','08:20:00',1.18),('12664','2013-09-02','08:25:00',1.28),('12664','2013-09-02','08:30:00',1.37),('12664','2013-09-02','08:35:00',1.46),('12664','2013-09-02','08:40:00',1.55),('12664','2013-09-02','08:45:00',1.64),('12664','2013-09-02','08:50:00',1.74),('12664','2013-09-02','08:55:00',1.83),('12664','2013-09-02','09:00:00',1.92),('12664','2013-09-02','09:05:00',2.01),('12664','2013-09-02','09:10:00',2.09),('12664','2013-09-02','09:15:00',2.17),('12664','2013-09-02','09:20:00',2.26),('12664','2013-09-02','09:25:00',2.34),('12664','2013-09-02','09:30:00',2.41),('12664','2013-09-02','09:35:00',2.49),('12664','2013-09-02','09:40:00',2.57),('12664','2013-09-02','09:45:00',2.63),('12664','2013-09-02','09:50:00',2.7),('12664','2013-09-02','09:55:00',2.75),('12664','2013-09-02','10:00:00',2.81),('12664','2013-09-02','10:05:00',2.88),('12664','2013-09-02','10:10:00',2.96),('12664','2013-09-02','10:15:00',3.02),('12664','2013-09-02','10:20:00',3.09),('12664','2013-09-02','10:25:00',3.15),('12664','2013-09-02','10:30:00',3.21),('12664','2013-09-02','10:35:00',3.26),('12664','2013-09-02','10:40:00',3.31),('12664','2013-09-02','10:45:00',3.36),('12664','2013-09-02','10:50:00',3.4),('12664','2013-09-02','10:55:00',3.44),('12664','2013-09-02','11:00:00',3.46),('12664','2013-09-02','11:05:00',3.5),('12664','2013-09-02','11:10:00',3.54),('12664','2013-09-02','11:15:00',3.58),('12664','2013-09-02','11:20:00',3.6),('12664','2013-09-02','11:25:00',3.64),('12664','2013-09-02','11:30:00',3.68),('12664','2013-09-02','11:35:00',3.71),('12664','2013-09-02','11:40:00',3.73),('12664','2013-09-02','11:45:00',3.72),('12664','2013-09-02','11:50:00',3.76),('12664','2013-09-02','11:55:00',3.81),('12664','2013-09-02','12:00:00',3.86),('12664','2013-09-02','12:05:00',3.84),('12664','2013-09-02','12:10:00',3.86),('12664','2013-09-02','12:15:00',3.9),('12664','2013-09-02','12:20:00',3.91),('12664','2013-09-02','12:25:00',3.92),('12664','2013-09-02','12:30:00',3.9),('12664','2013-09-02','12:35:00',3.91),('12664','2013-09-02','12:40:00',3.92),('12664','2013-09-02','12:45:00',3.93),('12664','2013-09-02','12:50:00',3.95),('12664','2013-09-02','12:55:00',3.92),('12664','2013-09-02','13:00:00',3.92),('12664','2013-09-02','13:05:00',3.93),('12664','2013-09-02','13:10:00',3.92),('12664','2013-09-02','13:15:00',3.89),('12664','2013-09-02','13:20:00',3.9),('12664','2013-09-02','13:25:00',3.89),('12664','2013-09-02','13:30:00',3.91),('12664','2013-09-02','13:35:00',3.92),('12664','2013-09-02','13:40:00',3.87),('12664','2013-09-02','13:45:00',3.82),('12664','2013-09-02','13:50:00',3.82),('12664','2013-09-02','13:55:00',3.85),('12664','2013-09-02','14:00:00',3.94),('12664','2013-09-02','14:05:00',3.88),('12664','2013-09-02','14:10:00',3.83),('12664','2013-09-02','14:15:00',3.77),('12664','2013-09-02','14:20:00',3.75),('12664','2013-09-02','14:25:00',3.74),('12664','2013-09-02','14:30:00',3.67),('12664','2013-09-02','14:35:00',3.66),('12664','2013-09-02','14:40:00',3.62),('12664','2013-09-02','14:45:00',3.61),('12664','2013-09-02','14:50:00',3.59),('12664','2013-09-02','14:55:00',3.47),('12664','2013-09-02','15:00:00',3.06),('12664','2013-09-02','15:05:00',3.48),('12664','2013-09-02','15:10:00',3.44),('12664','2013-09-02','15:15:00',3.39),('12664','2013-09-02','15:20:00',3.41),('12664','2013-09-02','15:25:00',3.4),('12664','2013-09-02','15:30:00',3.29),('12664','2013-09-02','15:35:00',3.24),('12664','2013-09-02','15:40:00',3.18),('12664','2013-09-02','15:45:00',3.07),('12664','2013-09-02','15:50:00',3.04),('12664','2013-09-02','15:55:00',2.98),('12664','2013-09-02','16:00:00',2.94),('12664','2013-09-02','16:05:00',2.91),('12664','2013-09-02','16:10:00',2.83),('12664','2013-09-02','16:15:00',2.76),('12664','2013-09-02','16:20:00',2.64),('12664','2013-09-02','16:25:00',2.59),('12664','2013-09-02','16:30:00',2.52),('12664','2013-09-02','16:35:00',2.45),('12664','2013-09-02','16:40:00',2.39),('12664','2013-09-02','16:45:00',2.3),('12664','2013-09-02','16:50:00',2.21),('12664','2013-09-02','16:55:00',2.12),('12664','2013-09-02','17:00:00',2.02),('12664','2013-09-02','17:05:00',1.93),('12664','2013-09-02','17:10:00',1.84),('12664','2013-09-02','17:15:00',1.73),('12664','2013-09-02','17:20:00',1.66),('12664','2013-09-02','17:25:00',1.58),('12664','2013-09-02','17:30:00',1.48),('12664','2013-09-02','17:35:00',1.39),('12664','2013-09-02','17:40:00',1.3),('12664','2013-09-02','17:45:00',1.21),('12664','2013-09-02','17:50:00',1.13),('12664','2013-09-02','17:55:00',1.02),('12664','2013-09-01','08:10:00',1.04),('12664','2013-09-01','08:15:00',1.15),('12664','2013-09-01','08:20:00',1.25),('12664','2013-09-01','08:25:00',1.34),('12664','2013-09-01','08:30:00',1.43),('12664','2013-09-01','08:35:00',1.52),('12664','2013-09-01','08:40:00',1.6),('12664','2013-09-01','08:45:00',1.7),('12664','2013-09-01','08:50:00',1.78),('12664','2013-09-01','08:55:00',1.86),('12664','2013-09-01','09:00:00',1.96),('12664','2013-09-01','09:05:00',2.05),('12664','2013-09-01','09:10:00',2.13),('12664','2013-09-01','09:15:00',2.22),('12664','2013-09-01','09:20:00',2.3),('12664','2013-09-01','09:25:00',2.38),('12664','2013-09-01','09:30:00',2.47),('12664','2013-09-01','09:35:00',2.53),('12664','2013-09-01','09:40:00',2.62),('12664','2013-09-01','09:45:00',2.69),('12664','2013-09-01','09:50:00',2.76),('12664','2013-09-01','09:55:00',2.83),('12664','2013-09-01','10:00:00',2.89),('12664','2013-09-01','10:05:00',2.95),('12664','2013-09-01','10:10:00',3.01),('12664','2013-09-01','10:15:00',3.08),('12664','2013-09-01','10:20:00',3.13),('12664','2013-09-01','10:25:00',3.18),('12664','2013-09-01','10:30:00',3.22),('12664','2013-09-01','10:35:00',3.27),('12664','2013-09-01','10:40:00',3.32),('12664','2013-09-01','10:45:00',3.35),('12664','2013-09-01','10:50:00',3.41),('12664','2013-09-01','10:55:00',3.47),('12664','2013-09-01','11:00:00',3.5),('12664','2013-09-01','11:05:00',3.56),('12664','2013-09-01','11:10:00',3.6),('12664','2013-09-01','11:15:00',3.65),('12664','2013-09-01','11:20:00',3.68),('12664','2013-09-01','11:25:00',3.7),('12664','2013-09-01','11:30:00',3.75),('12664','2013-09-01','11:35:00',3.77),('12664','2013-09-01','11:40:00',3.81),('12664','2013-09-01','11:45:00',3.84),('12664','2013-09-01','11:50:00',3.88),('12664','2013-09-01','11:55:00',3.88),('12664','2013-09-01','12:00:00',3.89),('12664','2013-09-01','12:05:00',3.93),('12664','2013-09-01','12:10:00',3.96),('12664','2013-09-01','12:15:00',3.96),('12664','2013-09-01','12:20:00',3.95),('12664','2013-09-01','12:25:00',4.01),('12664','2013-09-01','12:30:00',4),('12664','2013-09-01','12:35:00',4.01),('12664','2013-09-01','12:40:00',4),('12664','2013-09-01','12:45:00',4.01),('12664','2013-09-01','12:50:00',4),('12664','2013-09-01','12:55:00',3.87),('12664','2013-09-01','13:00:00',4.03),('12664','2013-09-01','13:05:00',3.6),('12664','2013-09-01','13:10:00',3.53),('12664','2013-09-01','13:15:00',3.9),('12664','2013-09-01','13:20:00',3.58),('12664','2013-09-01','13:25:00',3.57),('12664','2013-09-01','13:30:00',3.53),('12664','2013-09-01','13:35:00',3.86),('12664','2013-09-01','13:40:00',4.09),('12664','2013-09-01','13:45:00',4.06),('12664','2013-09-01','13:50:00',3.91),('12664','2013-09-01','13:55:00',3.65),('12664','2013-09-01','14:00:00',3.89),('12664','2013-09-01','14:05:00',3.69),('12664','2013-09-01','14:10:00',3.67),('12664','2013-09-01','14:15:00',3.73),('12664','2013-09-01','14:20:00',3.56),('12664','2013-09-01','14:25:00',3.43),('12664','2013-09-01','14:30:00',3.05),('12664','2013-09-01','14:35:00',2.92),('12664','2013-09-01','14:40:00',3.58),('12664','2013-09-01','14:45:00',3.59),('12664','2013-09-01','14:50:00',3.54),('12664','2013-09-01','14:55:00',3.57),('12664','2013-09-01','15:00:00',3.49),('12664','2013-09-01','15:05:00',3.37),('12664','2013-09-01','15:10:00',3.2),('12664','2013-09-01','15:15:00',3.18),('12664','2013-09-01','15:20:00',3.16),('12664','2013-09-01','15:25:00',2.99),('12664','2013-09-01','15:30:00',2.72),('12664','2013-09-01','15:35:00',2.76),('12664','2013-09-01','15:40:00',2.82),('12664','2013-09-01','15:45:00',2.74),('12664','2013-09-01','15:50:00',2.44),('12664','2013-09-01','15:55:00',2.1),('12664','2013-09-01','16:00:00',2.42),('12664','2013-09-01','16:05:00',2.69),('12664','2013-09-01','16:10:00',2.67),('12664','2013-09-01','16:15:00',2.64),('12664','2013-09-01','16:20:00',2.65),('12664','2013-09-01','16:25:00',2.57),('12664','2013-09-01','16:30:00',2.56),('12664','2013-09-01','16:35:00',2.35),('12664','2013-09-01','16:40:00',2.08),('12664','2013-09-01','16:45:00',2.09),('12664','2013-09-01','16:50:00',1.98),('12664','2013-09-01','16:55:00',2.01),('12664','2013-09-01','17:00:00',2),('12664','2013-09-01','17:05:00',2.03),('12664','2013-09-01','17:10:00',1.96),('12664','2013-09-01','17:15:00',1.88),('12664','2013-09-01','17:20:00',1.7),('12664','2013-09-01','17:25:00',1.65),('12664','2013-09-01','17:30:00',1.6),('12664','2013-09-01','17:35:00',1.38),('12664','2013-09-01','17:40:00',1.33),('12664','2013-09-01','17:45:00',1.47),('12664','2013-09-01','17:50:00',1.32),('12664','2013-09-01','17:55:00',1.22),('12664','2013-09-01','18:00:00',1.08),('12664','2013-09-01','18:05:00',1.02),('12664','2013-08-31','08:15:00',1.03),('12664','2013-08-31','08:20:00',1.17),('12664','2013-08-31','08:25:00',1.4),('12664','2013-08-31','08:30:00',1.48),('12664','2013-08-31','08:35:00',1.56),('12664','2013-08-31','08:40:00',1.66),('12664','2013-08-31','08:45:00',1.84),('12664','2013-08-31','08:50:00',2.01),('12664','2013-08-31','08:55:00',2.16),('12664','2013-08-31','09:00:00',1.79),('12664','2013-08-31','09:05:00',1.17),('12664','2013-08-31','09:10:00',1.9),('12664','2013-08-31','09:15:00',2.34),('12664','2013-08-31','09:20:00',2.42),('12664','2013-08-31','09:25:00',2.55),('12664','2013-08-31','09:30:00',2.65),('12664','2013-08-31','09:35:00',2.6),('12664','2013-08-31','09:40:00',2.52),('12664','2013-08-31','09:45:00',2.67),('12664','2013-08-31','09:50:00',2.98),('12664','2013-08-31','09:55:00',2.88),('12664','2013-08-31','10:00:00',3.02),('12664','2013-08-31','10:05:00',3.11),('12664','2013-08-31','10:10:00',3.11),('12664','2013-08-31','10:15:00',3.13),('12664','2013-08-31','10:20:00',3.16),('12664','2013-08-31','10:25:00',3.24),('12664','2013-08-31','10:30:00',3.29),('12664','2013-08-31','10:35:00',3.27),('12664','2013-08-31','10:40:00',3.38),('12664','2013-08-31','10:45:00',3.44),('12664','2013-08-31','10:50:00',3.54),('12664','2013-08-31','10:55:00',3.61),('12664','2013-08-31','11:00:00',3.66),('12664','2013-08-31','11:05:00',3.71),('12664','2013-08-31','11:10:00',3.75),('12664','2013-08-31','11:15:00',3.79),('12664','2013-08-31','11:20:00',3.83),('12664','2013-08-31','11:25:00',3.85),('12664','2013-08-31','11:30:00',3.87),('12664','2013-08-31','11:35:00',3.87),('12664','2013-08-31','11:40:00',3.89),('12664','2013-08-31','11:45:00',3.92),('12664','2013-08-31','11:50:00',3.95),('12664','2013-08-31','11:55:00',3.96),('12664','2013-08-31','12:00:00',4),('12664','2013-08-31','12:05:00',4.01),('12664','2013-08-31','12:10:00',4.02),('12664','2013-08-31','12:15:00',4.03),('12664','2013-08-31','12:20:00',4.05),('12664','2013-08-31','12:25:00',4.07),('12664','2013-08-31','12:30:00',4.04),('12664','2013-08-31','12:35:00',4.04),('12664','2013-08-31','12:40:00',4.08),('12664','2013-08-31','12:45:00',4.05),('12664','2013-08-31','12:50:00',4.05),('12664','2013-08-31','12:55:00',4.06),('12664','2013-08-31','13:00:00',4.05),('12664','2013-08-31','13:05:00',4),('12664','2013-08-31','13:10:00',4.02),('12664','2013-08-31','13:15:00',4.05),('12664','2013-08-31','13:20:00',4.02),('12664','2013-08-31','13:25:00',4),('12664','2013-08-31','13:30:00',3.94),('12664','2013-08-31','13:35:00',3.96),('12664','2013-08-31','13:40:00',3.94),('12664','2013-08-31','13:45:00',3.89),('12664','2013-08-31','13:50:00',3.87),('12664','2013-08-31','13:55:00',3.88),('12664','2013-08-31','14:00:00',3.84),('12664','2013-08-31','14:05:00',3.85),('12664','2013-08-31','14:10:00',3.85),('12664','2013-08-31','14:15:00',3.79),('12664','2013-08-31','14:20:00',3.76),('12664','2013-08-31','14:25:00',3.74),('12664','2013-08-31','14:30:00',3.64),('12664','2013-08-31','14:35:00',3.64),('12664','2013-08-31','14:40:00',3.61),('12664','2013-08-31','14:45:00',3.54),('12664','2013-08-31','14:50:00',3.48),('12664','2013-08-31','14:55:00',3.47),('12664','2013-08-31','15:00:00',3.45),('12664','2013-08-31','15:05:00',3.41),('12664','2013-08-31','15:10:00',3.37),('12664','2013-08-31','15:15:00',3.3),('12664','2013-08-31','15:20:00',3.27),('12664','2013-08-31','15:25:00',3.24),('12664','2013-08-31','15:30:00',3.2),('12664','2013-08-31','15:35:00',3.14),('12664','2013-08-31','15:40:00',3.04),('12664','2013-08-31','15:45:00',3.01),('12664','2013-08-31','15:50:00',2.98),('12664','2013-08-31','15:55:00',2.96),('12664','2013-08-31','16:00:00',2.89),('12664','2013-08-31','16:05:00',2.83),('12664','2013-08-31','16:10:00',2.72),('12664','2013-08-31','16:15:00',2.63),('12664','2013-08-31','16:20:00',2.51),('12664','2013-08-31','16:25:00',2.56),('12664','2013-08-31','16:30:00',2.48),('12664','2013-08-31','16:35:00',2.34),('12664','2013-08-31','16:40:00',2.25),('12664','2013-08-31','16:45:00',2.2),('12664','2013-08-31','16:50:00',2.22),('12664','2013-08-31','16:55:00',2.16),('12664','2013-08-31','17:00:00',2.09),('12664','2013-08-31','17:05:00',2.02),('12664','2013-08-31','17:10:00',1.94),('12664','2013-08-31','17:15:00',1.8),('12664','2013-08-31','17:20:00',1.66),('12664','2013-08-31','17:25:00',1.52),('12664','2013-08-31','17:30:00',1.5),('12664','2013-08-31','17:35:00',1.47),('12664','2013-08-31','17:40:00',1.34),('12664','2013-08-31','17:45:00',1.25),('12664','2013-08-30','08:00:00',1.02),('12664','2013-08-30','08:05:00',1.18),('12664','2013-08-30','08:10:00',1.15),('12664','2013-08-30','08:15:00',1.19),('12664','2013-08-30','08:20:00',1.27),('12664','2013-08-30','08:25:00',1.3),('12664','2013-08-30','08:30:00',1.34),('12664','2013-08-30','08:35:00',1.38),('12664','2013-08-30','08:40:00',1.34),('12664','2013-08-30','08:45:00',1.19),('12664','2013-08-30','08:50:00',1.2),('12664','2013-08-30','08:55:00',1.45),('12664','2013-08-30','09:00:00',1.52),('12664','2013-08-30','09:05:00',1.44),('12664','2013-08-30','09:10:00',1.25),('12664','2013-08-30','09:15:00',1.14),('12664','2013-08-30','09:20:00',1.2),('12664','2013-08-30','09:25:00',1.32),('12664','2013-08-30','09:30:00',1.41),('12664','2013-08-30','09:35:00',1.73),('12664','2013-08-30','09:40:00',1.7),('12664','2013-08-30','09:45:00',1.8),('12664','2013-08-30','09:50:00',1.98),('12664','2013-08-30','09:55:00',1.95),('12664','2013-08-30','10:00:00',1.78),('12664','2013-08-30','10:05:00',1.83),('12664','2013-08-30','10:10:00',2),('12664','2013-08-30','10:15:00',2.05),('12664','2013-08-30','10:20:00',1.89),('12664','2013-08-30','10:25:00',2.17),('12664','2013-08-30','10:30:00',2.13),('12664','2013-08-30','10:35:00',2.08),('12664','2013-08-30','10:40:00',2.03),('12664','2013-08-30','10:45:00',2.12),('12664','2013-08-30','10:50:00',2.07),('12664','2013-08-30','10:55:00',2.04),('12664','2013-08-30','11:00:00',2.16),('12664','2013-08-30','11:05:00',2.36),('12664','2013-08-30','11:10:00',2.49),('12664','2013-08-30','11:15:00',2.4),('12664','2013-08-30','11:20:00',2.58),('12664','2013-08-30','11:25:00',2.64),('12664','2013-08-30','11:30:00',2.75),('12664','2013-08-30','11:35:00',2.62),('12664','2013-08-30','11:40:00',2.92),('12664','2013-08-30','11:45:00',3.04),('12664','2013-08-30','11:50:00',2.89),('12664','2013-08-30','11:55:00',2.77),('12664','2013-08-30','12:00:00',2.36),('12664','2013-08-30','12:05:00',2.68),('12664','2013-08-30','12:10:00',2.55),('12664','2013-08-30','12:15:00',2.56),('12664','2013-08-30','12:20:00',2.96),('12664','2013-08-30','12:25:00',3.22),('12664','2013-08-30','12:30:00',3.4),('12664','2013-08-30','12:35:00',3.25),('12664','2013-08-30','12:40:00',3.31),('12664','2013-08-30','12:45:00',3.2),('12664','2013-08-30','12:50:00',2.99),('12664','2013-08-30','12:55:00',2.88),('12664','2013-08-30','13:00:00',2.69),('12664','2013-08-30','13:05:00',2.53),('12664','2013-08-30','13:10:00',2.69),('12664','2013-08-30','13:15:00',2.91),('12664','2013-08-30','13:20:00',3.22),('12664','2013-08-30','13:25:00',4.28),('12664','2013-08-30','13:30:00',3.97),('12664','2013-08-30','13:35:00',3.85),('12664','2013-08-30','13:40:00',4.12),('12664','2013-08-30','13:45:00',3.94),('12664','2013-08-30','13:50:00',3.8),('12664','2013-08-30','13:55:00',3.92),('12664','2013-08-30','14:00:00',3.95),('12664','2013-08-30','14:05:00',4.04),('12664','2013-08-30','14:10:00',3.98),('12664','2013-08-30','14:15:00',3.75),('12664','2013-08-30','14:20:00',3.7),('12664','2013-08-30','14:25:00',3.61),('12664','2013-08-30','14:30:00',3.89),('12664','2013-08-30','14:35:00',3.63),('12664','2013-08-30','14:40:00',3.51),('12664','2013-08-30','14:45:00',2.96),('12664','2013-08-30','14:50:00',2.96),('12664','2013-08-30','14:55:00',3.17),('12664','2013-08-30','15:00:00',2.84),('12664','2013-08-30','15:05:00',2.73),('12664','2013-08-30','15:10:00',2.81),('12664','2013-08-30','15:15:00',2.87),('12664','2013-08-30','15:20:00',2.8),('12664','2013-08-30','15:25:00',2.66),('12664','2013-08-30','15:30:00',2.44),('12664','2013-08-30','15:35:00',2.6),('12664','2013-08-30','15:40:00',2.83),('12664','2013-08-30','15:45:00',2.51),('12664','2013-08-30','15:50:00',2.3),('12664','2013-08-30','15:55:00',2.07),('12664','2013-08-30','16:00:00',1.86),('12664','2013-08-30','16:05:00',1.95),('12664','2013-08-30','16:10:00',2.26),('12664','2013-08-30','16:15:00',2.15),('12664','2013-08-30','16:20:00',2.04),('12664','2013-08-30','16:25:00',1.89),('12664','2013-08-30','16:30:00',2.04),('12664','2013-08-30','16:35:00',2.12),('12664','2013-08-30','16:40:00',2.17),('12664','2013-08-30','16:45:00',2.19),('12664','2013-08-30','16:50:00',2.32),('12664','2013-08-30','16:55:00',1.41),('12664','2013-08-30','17:00:00',1.33),('12664','2013-08-30','17:05:00',1.17),('12664','2013-08-30','17:10:00',1.03),('12664','2013-08-30','17:15:00',1.45),('12664','2013-08-30','17:20:00',1.7),('12664','2013-08-30','17:25:00',1.44),('12664','2013-08-30','17:30:00',1.23),('12664','2013-08-30','17:35:00',1.15),('12664','2013-08-30','17:40:00',1.23),('12664','2013-08-30','17:45:00',1.52),('12664','2013-08-30','17:50:00',1.4),('12664','2013-08-30','17:55:00',1.12),('12664','2013-08-29','08:05:00',1.01),('12664','2013-08-29','08:10:00',1.15),('12664','2013-08-29','08:15:00',1.27),('12664','2013-08-29','08:20:00',1.45),('12664','2013-08-29','08:25:00',1.68),('12664','2013-08-29','08:30:00',1.92),('12664','2013-08-29','08:35:00',1.76),('12664','2013-08-29','08:40:00',1.22),('12664','2013-08-29','08:45:00',1.1),('12664','2013-08-29','08:50:00',1.21),('12664','2013-08-29','08:55:00',1.44),('12664','2013-08-29','09:00:00',1.33),('12664','2013-08-29','09:05:00',1.29),('12664','2013-08-29','09:10:00',1.33),('12664','2013-08-29','09:15:00',1.35),('12664','2013-08-29','09:20:00',1.49),('12664','2013-08-29','09:25:00',1.58),('12664','2013-08-29','09:30:00',1.61),('12664','2013-08-29','09:35:00',1.75),('12664','2013-08-29','09:40:00',1.52),('12664','2013-08-29','09:45:00',1.33),('12664','2013-08-29','09:50:00',1.36),('12664','2013-08-29','09:55:00',1.36),('12664','2013-08-29','10:00:00',1.39),('12664','2013-08-29','10:05:00',1.37),('12664','2013-08-29','10:10:00',1.34),('12664','2013-08-29','10:15:00',1.36),('12664','2013-08-29','10:20:00',1.41),('12664','2013-08-29','10:25:00',1.44),('12664','2013-08-29','10:30:00',1.42),('12664','2013-08-29','10:35:00',1.27),('12664','2013-08-29','10:40:00',1.18),('12664','2013-08-29','10:45:00',1.19),('12664','2013-08-29','10:50:00',1.35),('12664','2013-08-29','10:55:00',1.54),('12664','2013-08-29','11:00:00',1.51),('12664','2013-08-29','11:05:00',1.87),('12664','2013-08-29','11:10:00',2.05),('12664','2013-08-29','11:15:00',1.78),('12664','2013-08-29','11:20:00',1.46),('12664','2013-08-29','11:25:00',1.26),('12664','2013-08-29','11:30:00',1.25),('12664','2013-08-29','11:35:00',1.44),('12664','2013-08-29','11:40:00',1.63),('12664','2013-08-29','11:45:00',1.73),('12664','2013-08-29','11:50:00',1.81),('12664','2013-08-29','11:55:00',1.85),('12664','2013-08-29','12:00:00',2.11),('12664','2013-08-29','12:05:00',2.89),('12664','2013-08-29','12:10:00',3.63),('12664','2013-08-29','12:15:00',2.97),('12664','2013-08-29','12:20:00',3.03),('12664','2013-08-29','12:25:00',2.71),('12664','2013-08-29','12:30:00',2.72),('12664','2013-08-29','12:35:00',4.39),('12664','2013-08-29','12:40:00',4.65),('12664','2013-08-29','12:45:00',4.1),('12664','2013-08-29','12:50:00',2.93),('12664','2013-08-29','12:55:00',2.71),('12664','2013-08-29','13:00:00',2.89),('12664','2013-08-29','13:05:00',2.09),('12664','2013-08-29','13:10:00',2.08),('12664','2013-08-29','13:15:00',2.18),('12664','2013-08-29','13:20:00',1.98),('12664','2013-08-29','13:25:00',1.72),('12664','2013-08-29','13:30:00',1.68),('12664','2013-08-29','13:35:00',1.82),('12664','2013-08-29','13:40:00',1.65),('12664','2013-08-29','13:45:00',1.65),('12664','2013-08-29','13:50:00',2.52),('12664','2013-08-29','13:55:00',2.57),('12664','2013-08-29','14:00:00',1.76),('12664','2013-08-29','14:05:00',1.42),('12664','2013-08-29','14:10:00',1.24),('12664','2013-08-29','14:15:00',1.06),('12664','2013-08-29','14:20:00',1.02),('12664','2013-08-29','14:25:00',1.01),('12664','2013-08-29','14:30:00',1.05),('12664','2013-08-29','14:35:00',1.18),('12664','2013-08-29','14:40:00',1.29),('12664','2013-08-29','14:45:00',1.37),('12664','2013-08-29','14:50:00',1.54),('12664','2013-08-29','14:55:00',2.56),('12664','2013-08-29','15:00:00',2.74),('12664','2013-08-29','15:05:00',1.64),('12664','2013-08-29','15:10:00',1.3),('12664','2013-08-29','15:15:00',1.63),('12664','2013-08-29','15:20:00',2.03),('12664','2013-08-29','15:25:00',2.37),('12664','2013-08-29','15:30:00',2.27),('12664','2013-08-29','15:35:00',2.02),('12664','2013-08-29','15:40:00',1.84),('12664','2013-08-29','15:45:00',1.92),('12664','2013-08-29','15:50:00',2.37),('12664','2013-08-29','15:55:00',3.24),('12664','2013-08-29','16:00:00',3.79),('12664','2013-08-29','16:05:00',3.35),('12664','2013-08-29','16:10:00',3.07),('12664','2013-08-29','16:15:00',2.83),('12664','2013-08-29','16:20:00',2.59),('12664','2013-08-29','16:25:00',2.83),('12664','2013-08-29','16:30:00',2.74),('12664','2013-08-29','16:35:00',2.62),('12664','2013-08-29','16:40:00',2.54),('12664','2013-08-29','16:45:00',2.46),('12664','2013-08-29','16:50:00',2.36),('12664','2013-08-29','16:55:00',2.29),('12664','2013-08-29','17:00:00',2.2),('12664','2013-08-29','17:05:00',2.12),('12664','2013-08-29','17:10:00',2.04),('12664','2013-08-29','17:15:00',1.95),('12664','2013-08-29','17:20:00',1.86),('12664','2013-08-29','17:25:00',1.76),('12664','2013-08-29','17:30:00',1.66),('12664','2013-08-29','17:35:00',1.56),('12664','2013-08-29','17:40:00',1.46),('12664','2013-08-29','17:45:00',1.37),('12664','2013-08-29','17:50:00',1.28),('12664','2013-08-29','17:55:00',1.18),('12664','2013-08-29','18:00:00',1.09),('12664','2014-04-10','08:10:00',1.04),('12664','2014-04-10','08:15:00',1.14),('12664','2014-04-10','08:20:00',1.25),('12664','2014-04-10','08:25:00',1.35),('12664','2014-04-10','08:30:00',1.45),('12664','2014-04-10','08:35:00',1.55),('12664','2014-04-10','08:40:00',1.65),('12664','2014-04-10','08:45:00',1.75),('12664','2014-04-10','08:50:00',1.84),('12664','2014-04-10','08:55:00',1.9),('12664','2014-04-10','09:00:00',2.01),('12664','2014-04-10','09:05:00',2.09),('12664','2014-04-10','09:10:00',2.15),('12664','2014-04-10','09:15:00',2.17),('12664','2014-04-10','09:20:00',2.3),('12664','2014-04-10','09:25:00',2.43),('12664','2014-04-10','09:30:00',2.51),('12664','2014-04-10','09:35:00',2.58),('12664','2014-04-10','09:40:00',2.64),('12664','2014-04-10','09:45:00',2.73),('12664','2014-04-10','09:50:00',2.8),('12664','2014-04-10','09:55:00',2.85),('12664','2014-04-10','10:00:00',2.91),('12664','2014-04-10','10:05:00',3),('12664','2014-04-10','10:10:00',3.06),('12664','2014-04-10','10:15:00',3.05),('12664','2014-04-10','10:20:00',3.13),('12664','2014-04-10','10:25:00',3.18),('12664','2014-04-10','10:30:00',3.26),('12664','2014-04-10','10:35:00',3.4),('12664','2014-04-10','10:40:00',3.38),('12664','2014-04-10','10:45:00',3.42),('12664','2014-04-10','10:50:00',3.4),('12664','2014-04-10','10:55:00',3.48),('12664','2014-04-10','11:00:00',3.61),('12664','2014-04-10','11:05:00',3.59),('12664','2014-04-10','11:10:00',3.71),('12664','2014-04-10','11:15:00',3.72),('12664','2014-04-10','11:20:00',3.86),('12664','2014-04-10','11:25:00',3.89),('12664','2014-04-10','11:30:00',3.95),('12664','2014-04-10','11:35:00',3.81),('12664','2014-04-10','11:40:00',3.98),('12664','2014-04-10','11:45:00',3.95),('12664','2014-04-10','11:50:00',3.93),('12664','2014-04-10','11:55:00',3.93),('12664','2014-04-10','12:00:00',3.68),('12664','2014-04-10','12:05:00',3.73),('12664','2014-04-10','12:10:00',4.02),('12664','2014-04-10','12:15:00',4.05),('12664','2014-04-10','12:20:00',3.96),('12664','2014-04-10','12:25:00',3.91),('12664','2014-04-10','12:30:00',3.76),('12664','2014-04-10','12:35:00',3.95),('12664','2014-04-10','12:40:00',3.89),('12664','2014-04-10','12:45:00',3.94),('12664','2014-04-10','12:50:00',3.99),('12664','2014-04-10','12:55:00',4.07),('12664','2014-04-10','13:00:00',3.82),('12664','2014-04-10','13:05:00',3.92),('12664','2014-04-10','13:10:00',4.14),('12664','2014-04-10','13:15:00',3.98),('12664','2014-04-10','13:20:00',3.88),('12664','2014-04-10','13:25:00',4.03),('12664','2014-04-10','13:30:00',4.09),('12664','2014-04-10','13:35:00',4.08),('12664','2014-04-10','13:40:00',3.94),('12664','2014-04-10','13:45:00',4.04),('12664','2014-04-10','13:50:00',4.01),('12664','2014-04-10','13:55:00',3.98),('12664','2014-04-10','14:00:00',3.94),('12664','2014-04-10','14:05:00',3.84),('12664','2014-04-10','14:10:00',3.86),('12664','2014-04-10','14:15:00',3.93),('12664','2014-04-10','14:20:00',3.9),('12664','2014-04-10','14:25:00',3.86),('12664','2014-04-10','14:30:00',3.82),('12664','2014-04-10','14:35:00',3.73),('12664','2014-04-10','14:40:00',3.77),('12664','2014-04-10','14:45:00',3.31),('12664','2014-04-10','14:50:00',3.74),('12664','2014-04-10','14:55:00',3.67),('12664','2014-04-10','15:00:00',3.61),('12664','2014-04-10','15:05:00',3.61),('12664','2014-04-10','15:10:00',3.51),('12664','2014-04-10','15:15:00',3.42),('12664','2014-04-10','15:20:00',3.29),('12664','2014-04-10','15:25:00',3.34),('12664','2014-04-10','15:30:00',2.94),('12664','2014-04-10','15:35:00',2.83),('12664','2014-04-10','15:40:00',3.09),('12664','2014-04-10','15:45:00',3.03),('12664','2014-04-10','15:50:00',2.93),('12664','2014-04-10','15:55:00',3.11),('12664','2014-04-10','16:00:00',3.06),('12664','2014-04-10','16:05:00',3.01),('12664','2014-04-10','16:10:00',3.08),('12664','2014-04-10','16:15:00',3),('12664','2014-04-10','16:20:00',2.75),('12664','2014-04-10','16:25:00',2.79),('12664','2014-04-10','16:30:00',2.78),('12664','2014-04-10','16:35:00',2.67),('12664','2014-04-10','16:40:00',2.6),('12664','2014-04-10','16:45:00',2.46),('12664','2014-04-10','16:50:00',2.43),('12664','2014-04-10','16:55:00',2.3),('12664','2014-04-10','17:00:00',2.19),('12664','2014-04-10','17:05:00',2.15),('12664','2014-04-10','17:10:00',2.03),('12664','2014-04-10','17:15:00',1.93),('12664','2014-04-10','17:20:00',1.83),('12664','2014-04-10','17:25:00',1.72),('12664','2014-04-10','17:30:00',1.62),('12664','2014-04-10','17:35:00',1.52),('12664','2014-04-10','17:40:00',1.42),('12664','2014-04-10','17:45:00',1.32),('12664','2014-04-10','17:50:00',1.22),('12664','2014-04-10','17:55:00',1.13),('12664','2014-04-10','18:00:00',1.03),('12664','2013-08-28','08:05:00',1.01),('12664','2013-08-28','08:10:00',1.37),('12664','2013-08-28','08:15:00',1.3),('12664','2013-08-28','08:20:00',1.16),('12664','2013-08-28','08:25:00',1.35),('12664','2013-08-28','08:30:00',1.16),('12664','2013-08-28','08:50:00',1.92),('12664','2013-08-28','08:55:00',1.97),('12664','2013-08-28','09:00:00',2.05),('12664','2013-08-28','09:05:00',2.12),('12664','2013-08-28','09:10:00',2.17),('12664','2013-08-28','09:15:00',1.52),('12664','2013-08-28','09:20:00',1.19),('12664','2013-08-28','09:25:00',1.22),('12664','2013-08-28','09:30:00',1.74),('12664','2013-08-28','09:35:00',2.27),('12664','2013-08-28','09:40:00',2.3),('12664','2013-08-28','09:45:00',2.61),('12664','2013-08-28','09:50:00',2.83),('12664','2013-08-28','09:55:00',2.89),('12664','2013-08-28','10:00:00',2.97),('12664','2013-08-28','10:05:00',3.02),('12664','2013-08-28','10:10:00',3.06),('12664','2013-08-28','10:15:00',3.14),('12664','2013-08-28','10:20:00',3.2),('12664','2013-08-28','10:25:00',3.26),('12664','2013-08-28','10:30:00',3.34),('12664','2013-08-28','10:35:00',3.39),('12664','2013-08-28','10:40:00',3.59),('12664','2013-08-28','10:45:00',3.61),('12664','2013-08-28','10:50:00',3.68),('12664','2013-08-28','10:55:00',3.79),('12664','2013-08-28','11:00:00',3.89),('12664','2013-08-28','11:05:00',4),('12664','2013-08-28','11:10:00',3.71),('12664','2013-08-28','11:15:00',3.9),('12664','2013-08-28','11:20:00',3.93),('12664','2013-08-28','11:25:00',2.57),('12664','2013-08-28','11:30:00',3.56),('12664','2013-08-28','11:35:00',3.99),('12664','2013-08-28','11:40:00',3.08),('12664','2013-08-28','11:45:00',2.15),('12664','2013-08-28','11:50:00',4.69),('12664','2013-08-28','11:55:00',4.56),('12664','2013-08-28','12:00:00',4.38),('12664','2013-08-28','12:05:00',4.33),('12664','2013-08-28','12:10:00',4.3),('12664','2013-08-28','12:15:00',4.34),('12664','2013-08-28','12:20:00',4.16),('12664','2013-08-28','12:25:00',4.33),('12664','2013-08-28','12:30:00',4.36),('12664','2013-08-28','12:35:00',4.28),('12664','2013-08-28','12:40:00',4.3),('12664','2013-08-28','12:45:00',4.13),('12664','2013-08-28','12:50:00',4.19),('12664','2013-08-28','12:55:00',4.44),('12664','2013-08-28','13:00:00',4.36),('12664','2013-08-28','13:05:00',4.23),('12664','2013-08-28','13:10:00',4.31),('12664','2013-08-28','13:15:00',4.34),('12664','2013-08-28','13:20:00',4.29),('12664','2013-08-28','13:25:00',3.91),('12664','2013-08-28','13:30:00',4.42),('12664','2013-08-28','13:35:00',4.4),('12664','2013-08-28','13:40:00',4.4),('12664','2013-08-28','13:45:00',4.35),('12664','2013-08-28','13:50:00',4.2),('12664','2013-08-28','13:55:00',4.28),('12664','2013-08-28','14:00:00',4.23),('12664','2013-08-28','14:05:00',4.14),('12664','2013-08-28','14:10:00',4.18),('12664','2013-08-28','14:15:00',4.12),('12664','2013-08-28','14:20:00',4.14),('12664','2013-08-28','14:25:00',4.13),('12664','2013-08-28','14:30:00',4.09),('12664','2013-08-28','14:35:00',4.04),('12664','2013-08-28','14:40:00',4.01),('12664','2013-08-28','14:45:00',4.03),('12664','2013-08-28','14:50:00',3.96),('12664','2013-08-28','14:55:00',3.97),('12664','2013-08-28','15:00:00',3.88),('12664','2013-08-28','15:05:00',3.72),('12664','2013-08-28','15:10:00',3.85),('12664','2013-08-28','15:15:00',3.81),('12664','2013-08-28','15:20:00',3.46),('12664','2013-08-28','15:25:00',3.57),('12664','2013-08-28','15:30:00',3.38),('12664','2013-08-28','15:35:00',3.59),('12664','2013-08-28','15:40:00',3.52),('12664','2013-08-28','15:45:00',3.4),('12664','2013-08-28','15:50:00',3.37),('12664','2013-08-28','15:55:00',3.34),('12664','2013-08-28','16:00:00',3.24),('12664','2013-08-28','16:05:00',3.17),('12664','2013-08-28','16:10:00',3.11),('12664','2013-08-28','16:15:00',3.03),('12664','2013-08-28','16:20:00',2.97),('12664','2013-08-28','16:25:00',2.89),('12664','2013-08-28','16:30:00',2.81),('12664','2013-08-28','16:35:00',2.72),('12664','2013-08-28','16:40:00',2.62),('12664','2013-08-28','16:45:00',2.54),('12664','2013-08-28','16:50:00',2.44),('12664','2013-08-28','16:55:00',2.4),('12664','2013-08-28','17:00:00',1.17),('12664','2013-08-28','17:05:00',1.09),('12664','2013-08-28','17:10:00',2.04),('12664','2013-08-28','17:15:00',1.91),('12664','2013-08-28','17:20:00',2.21),('12664','2013-08-28','17:25:00',1.18),('12664','2013-08-28','17:35:00',1.91),('12664','2013-08-28','17:50:00',1.45),('12664','2013-08-28','17:55:00',1.18),('12664','2013-08-27','08:20:00',1.06),('12664','2013-08-27','08:25:00',1.02),('12664','2013-08-27','08:45:00',1),('12664','2013-08-27','08:50:00',1.45),('12664','2013-08-27','08:55:00',1.17),('12664','2013-08-27','09:00:00',1.05),('12664','2013-08-27','09:05:00',1.4),('12664','2013-08-27','09:10:00',1.99),('12664','2013-08-27','09:15:00',1.96),('12664','2013-08-27','09:20:00',2.16),('12664','2013-08-27','09:25:00',2.49),('12664','2013-08-27','09:30:00',2.54),('12664','2013-08-27','09:35:00',1.73),('12664','2013-08-27','09:40:00',1.35),('12664','2013-08-27','09:45:00',1.58),('12664','2013-08-27','09:50:00',1.91),('12664','2013-08-27','09:55:00',1.59),('12664','2013-08-27','10:00:00',2.09),('12664','2013-08-27','10:05:00',2.9),('12664','2013-08-27','10:10:00',3.1),('12664','2013-08-27','10:15:00',3.11),('12664','2013-08-27','10:20:00',3.09),('12664','2013-08-27','10:25:00',3.11),('12664','2013-08-27','10:30:00',3.19),('12664','2013-08-27','10:35:00',3.27),('12664','2013-08-27','10:40:00',3.3),('12664','2013-08-27','10:45:00',3.36),('12664','2013-08-27','10:50:00',3.39),('12664','2013-08-27','10:55:00',3.32),('12664','2013-08-27','11:00:00',3.35),('12664','2013-08-27','11:05:00',3.48),('12664','2013-08-27','11:10:00',3.57),('12664','2013-08-27','11:15:00',3.55),('12664','2013-08-27','11:20:00',3.59),('12664','2013-08-27','11:25:00',3.76),('12664','2013-08-27','11:30:00',3.62),('12664','2013-08-27','11:35:00',3.69),('12664','2013-08-27','11:40:00',3.48),('12664','2013-08-27','11:45:00',2.89),('12664','2013-08-27','11:50:00',3.24),('12664','2013-08-27','11:55:00',3.63),('12664','2013-08-27','12:00:00',1.79),('12664','2013-08-27','12:05:00',3.07),('12664','2013-08-27','12:10:00',3.55),('12664','2013-08-27','12:15:00',3.81),('12664','2013-08-27','12:20:00',4.07),('12664','2013-08-27','12:25:00',3.85),('12664','2013-08-27','12:30:00',4.15),('12664','2013-08-27','12:35:00',2.63),('12664','2013-08-27','12:40:00',4.07),('12664','2013-08-27','12:45:00',3.09),('12664','2013-08-27','12:50:00',2.54),('12664','2013-08-27','12:55:00',1.7),('12664','2013-08-27','13:00:00',1.59),('12664','2013-08-27','13:05:00',2.02),('12664','2013-08-27','13:10:00',3.12),('12664','2013-08-27','13:15:00',2.35),('12664','2013-08-27','13:20:00',2.74),('12664','2013-08-27','13:25:00',2.86),('12664','2013-08-27','13:30:00',2.21),('12664','2013-08-27','13:35:00',2.15),('12664','2013-08-27','13:40:00',2.35),('12664','2013-08-27','13:45:00',3.3),('12664','2013-08-27','13:50:00',3.41),('12664','2013-08-27','13:55:00',2.75),('12664','2013-08-27','14:00:00',2.28),('12664','2013-08-27','14:05:00',3.77),('12664','2013-08-27','14:10:00',3.56),('12664','2013-08-27','14:15:00',2.47),('12664','2013-08-27','14:20:00',1.82),('12664','2013-08-27','14:25:00',1.44),('12664','2013-08-27','14:30:00',1.39),('12664','2013-08-27','14:35:00',1.39),('12664','2013-08-27','14:40:00',1.3),('12664','2013-08-27','14:45:00',1.08),('12664','2013-08-27','15:50:00',1.84),('12664','2013-08-27','15:55:00',2.51),('12664','2013-08-27','16:00:00',1.75),('12664','2013-08-27','16:05:00',1.67),('12664','2013-08-27','16:10:00',1.65),('12664','2013-08-27','16:15:00',1.6),('12664','2013-08-27','16:20:00',2.05),('12664','2013-08-27','16:40:00',1.47),('12664','2013-08-27','16:45:00',1.06),('12664','2013-08-27','17:00:00',1.42),('12664','2013-08-27','17:05:00',1.13),('12664','2013-08-27','17:35:00',1.03),('12664','2013-08-27','17:45:00',1.14),('12664','2013-08-26','08:05:00',1.04),('12664','2013-08-26','08:20:00',1.4),('12664','2013-08-26','08:25:00',1.35),('12664','2013-08-26','08:30:00',1.34),('12664','2013-08-26','08:35:00',1.54),('12664','2013-08-26','08:40:00',1.63),('12664','2013-08-26','08:45:00',1.71),('12664','2013-08-26','08:50:00',1.8),('12664','2013-08-26','08:55:00',1.89),('12664','2013-08-26','09:00:00',1.96),('12664','2013-08-26','09:05:00',2.05),('12664','2013-08-26','09:10:00',2.14),('12664','2013-08-26','09:15:00',2.22),('12664','2013-08-26','09:20:00',2.27),('12664','2013-08-26','09:25:00',2.35),('12664','2013-08-26','09:30:00',2.41),('12664','2013-08-26','09:35:00',2.55),('12664','2013-08-26','09:40:00',2.66),('12664','2013-08-26','09:45:00',2.71),('12664','2013-08-26','09:50:00',2.76),('12664','2013-08-26','09:55:00',2.82),('12664','2013-08-26','10:00:00',2.91),('12664','2013-08-26','10:05:00',2.96),('12664','2013-08-26','10:10:00',3.02),('12664','2013-08-26','10:15:00',3.09),('12664','2013-08-26','10:20:00',2.94),('12664','2013-08-26','10:25:00',2.83),('12664','2013-08-26','10:30:00',3.25),('12664','2013-08-26','10:35:00',3.34),('12664','2013-08-26','10:40:00',3.36),('12664','2013-08-26','10:45:00',3.41),('12664','2013-08-26','10:50:00',3.45),('12664','2013-08-26','10:55:00',3.49),('12664','2013-08-26','11:00:00',3.56),('12664','2013-08-26','11:05:00',3.6),('12664','2013-08-26','11:10:00',3.63),('12664','2013-08-26','11:15:00',3.67),('12664','2013-08-26','11:20:00',3.7),('12664','2013-08-26','11:25:00',3.72),('12664','2013-08-26','11:30:00',3.76),('12664','2013-08-26','11:35:00',3.78),('12664','2013-08-26','11:40:00',3.79),('12664','2013-08-26','11:45:00',3.84),('12664','2013-08-26','11:50:00',3.88),('12664','2013-08-26','11:55:00',3.89),('12664','2013-08-26','12:00:00',3.87),('12664','2013-08-26','12:05:00',3.9),('12664','2013-08-26','12:10:00',3.89),('12664','2013-08-26','12:15:00',3.91),('12664','2013-08-26','12:20:00',3.94),('12664','2013-08-26','12:25:00',3.96),('12664','2013-08-26','12:30:00',3.91),('12664','2013-08-26','12:35:00',3.63),('12664','2013-08-26','12:40:00',2.78),('12664','2013-08-26','12:45:00',4.34),('12664','2013-08-26','12:50:00',4.2),('12664','2013-08-26','12:55:00',4.38),('12664','2013-08-26','13:00:00',2.62),('12664','2013-08-26','13:05:00',2.94),('12664','2013-08-26','13:10:00',3.06),('12664','2013-08-26','13:15:00',3.11),('12664','2013-08-26','13:20:00',3.44),('12664','2013-08-26','13:25:00',2.47),('12664','2013-08-26','13:30:00',2.86),('12664','2013-08-26','13:35:00',3.86),('12664','2013-08-26','13:40:00',4.22),('12664','2013-08-26','13:45:00',3.94),('12664','2013-08-26','13:50:00',3.51),('12664','2013-08-26','13:55:00',3.14),('12664','2013-08-26','14:00:00',4.03),('12664','2013-08-26','14:05:00',3.12),('12664','2013-08-26','14:10:00',4.34),('12664','2013-08-26','14:15:00',3.75),('12664','2013-08-26','14:20:00',3.71),('12664','2013-08-26','14:25:00',3.87),('12664','2013-08-26','14:30:00',3.86),('12664','2013-08-26','14:35:00',3.84),('12664','2013-08-26','14:40:00',3.77),('12664','2013-08-26','14:45:00',2.58),('12664','2013-08-26','14:50:00',3.17),('12664','2013-08-26','14:55:00',1.75),('12664','2013-08-26','15:00:00',2.02),('12664','2013-08-26','15:05:00',1.17),('12664','2013-08-26','15:10:00',1.02),('12664','2013-08-26','15:35:00',1.35),('12664','2013-08-26','15:40:00',1.96),('12664','2013-08-26','15:45:00',1.31),('12664','2013-08-26','15:50:00',1.48),('12664','2013-08-26','15:55:00',1.99),('12664','2013-08-26','16:00:00',2.8),('12664','2013-08-26','16:05:00',3.29),('12664','2013-08-26','16:10:00',2.96),('12664','2013-08-26','16:15:00',2.81),('12664','2013-08-26','16:20:00',2.75),('12664','2013-08-26','16:25:00',2.64),('12664','2013-08-26','16:30:00',2.58),('12664','2013-08-26','16:35:00',2.51),('12664','2013-08-26','16:40:00',2.37),('12664','2013-08-26','16:45:00',2.31),('12664','2013-08-26','16:50:00',2.24),('12664','2013-08-26','16:55:00',2.17),('12664','2013-08-26','17:00:00',1.91),('12664','2013-08-26','17:05:00',1.98),('12664','2013-08-26','17:10:00',1.91),('12664','2013-08-26','17:15:00',1.83),('12664','2013-08-26','17:20:00',1.14),('12664','2013-08-26','17:25:00',1.33),('12664','2013-08-26','17:30:00',1.07),('12664','2013-08-26','17:45:00',1.54),('12664','2013-08-26','17:50:00',1.45),('12664','2013-08-26','17:55:00',1.27),('12664','2013-08-26','18:00:00',1.08),('12664','2013-08-25','07:55:00',1.01),('12664','2013-08-25','08:00:00',1.14),('12664','2013-08-25','08:25:00',1.31),('12664','2013-08-25','08:30:00',1.48),('12664','2013-08-25','08:35:00',1.46),('12664','2013-08-25','08:40:00',1.32),('12664','2013-08-25','09:00:00',1.12),('12664','2013-08-25','09:05:00',1.11),('12664','2013-08-25','09:10:00',2.2),('12664','2013-08-25','09:15:00',1.81),('12664','2013-08-25','09:20:00',2.15),('12664','2013-08-25','09:25:00',2.69),('12664','2013-08-25','09:30:00',2.87),('12664','2013-08-25','09:35:00',2.94),('12664','2013-08-25','09:40:00',3.19),('12664','2013-08-25','09:45:00',2.81),('12664','2013-08-25','09:50:00',2.54),('12664','2013-08-25','09:55:00',1.72),('12664','2013-08-25','15:05:00',1.15),('12664','2013-08-25','15:10:00',1.23),('12664','2013-08-25','15:15:00',1.46),('12664','2013-08-25','15:20:00',1.87),('12664','2013-08-25','15:25:00',2.82),('12664','2013-08-25','15:30:00',4.44),('12664','2013-08-25','15:35:00',3.88),('12664','2013-08-25','15:40:00',4.01),('12664','2013-08-25','15:45:00',3.72),('12664','2013-08-25','15:50:00',3.44),('12664','2013-08-25','15:55:00',3.69),('12664','2013-08-25','16:00:00',2.92),('12664','2013-08-25','16:05:00',2.3),('12664','2013-08-25','16:10:00',3),('12664','2013-08-25','16:15:00',2.92),('12664','2013-08-25','16:20:00',2.81),('12664','2013-08-25','16:25:00',2.73),('12664','2013-08-25','16:30:00',2.69),('12664','2013-08-25','16:35:00',2.48),('12664','2013-08-25','16:40:00',1.7),('12664','2013-08-25','16:45:00',1.87),('12664','2013-08-25','16:50:00',2.71),('12664','2013-08-25','16:55:00',2.46),('12664','2013-08-25','17:00:00',2.4),('12664','2013-08-25','17:05:00',2.29),('12664','2013-08-25','17:10:00',2.11),('12664','2013-08-25','17:15:00',1.95),('12664','2013-08-25','17:20:00',1.85),('12664','2013-08-25','17:25:00',1.76),('12664','2013-08-25','17:30:00',1.47),('12664','2013-08-25','17:35:00',1.38),('12664','2013-08-25','17:40:00',1.43),('12664','2013-08-25','17:45:00',1.34),('12664','2013-08-25','17:50:00',1.11),('12664','2013-08-25','18:10:00',1.03),('12664','2013-08-24','08:15:00',1.07),('12664','2013-08-24','08:20:00',1.16),('12664','2013-08-24','08:25:00',1.23),('12664','2013-08-24','08:30:00',1.32),('12664','2013-08-24','08:35:00',1.4),('12664','2013-08-24','08:40:00',1.52),('12664','2013-08-24','08:45:00',1.63),('12664','2013-08-24','08:50:00',1.72),('12664','2013-08-24','08:55:00',1.82),('12664','2013-08-24','09:00:00',1.88),('12664','2013-08-24','09:05:00',1.98),('12664','2013-08-24','09:10:00',2.07),('12664','2013-08-24','09:15:00',2.15),('12664','2013-08-24','09:20:00',2.23),('12664','2013-08-24','09:25:00',2.31),('12664','2013-08-24','09:30:00',2.39),('12664','2013-08-24','09:35:00',2.46),('12664','2013-08-24','09:40:00',2.52),('12664','2013-08-24','09:45:00',2.59),('12664','2013-08-24','09:50:00',2.67),('12664','2013-08-24','09:55:00',2.77),('12664','2013-08-24','10:00:00',2.82),('12664','2013-08-24','10:05:00',2.86),('12664','2013-08-24','10:10:00',2.94),('12664','2013-08-24','10:15:00',3.01),('12664','2013-08-24','10:20:00',3.06),('12664','2013-08-24','10:25:00',3.1),('12664','2013-08-24','10:30:00',3.07),('12664','2013-08-24','10:35:00',3.19),('12664','2013-08-24','10:40:00',3.26),('12664','2013-08-24','10:45:00',3.3),('12664','2013-08-24','10:50:00',3.33),('12664','2013-08-24','10:55:00',3.36),('12664','2013-08-24','11:00:00',3.38),('12664','2013-08-24','11:05:00',3.38),('12664','2013-08-24','11:10:00',3.17),('12664','2013-08-24','11:15:00',3.24),('12664','2013-08-24','11:20:00',3.15),('12664','2013-08-24','11:25:00',3.66),('12664','2013-08-24','11:30:00',3.64),('12664','2013-08-24','11:35:00',3.75),('12664','2013-08-24','11:40:00',3.79),('12664','2013-08-24','11:45:00',3.82),('12664','2013-08-24','11:50:00',3.87),('12664','2013-08-24','11:55:00',3.86),('12664','2013-08-24','12:00:00',3.88),('12664','2013-08-24','12:05:00',3.89),('12664','2013-08-24','12:10:00',3.88),('12664','2013-08-24','12:15:00',3.89),('12664','2013-08-24','12:20:00',3.92),('12664','2013-08-24','12:25:00',3.91),('12664','2013-08-24','12:30:00',3.97),('12664','2013-08-24','12:35:00',4),('12664','2013-08-24','12:40:00',4),('12664','2013-08-24','12:45:00',4.01),('12664','2013-08-24','12:50:00',4.01),('12664','2013-08-24','12:55:00',4.04),('12664','2013-08-24','13:00:00',4.03),('12664','2013-08-24','13:05:00',4.04),('12664','2013-08-24','13:10:00',4.04),('12664','2013-08-24','13:15:00',4.04),('12664','2013-08-24','13:20:00',4.01),('12664','2013-08-24','13:25:00',4.02),('12664','2013-08-24','13:30:00',4.02),('12664','2013-08-24','13:35:00',3.98),('12664','2013-08-24','13:40:00',3.96),('12664','2013-08-24','13:45:00',3.99),('12664','2013-08-24','13:50:00',3.94),('12664','2013-08-24','13:55:00',3.94),('12664','2013-08-24','14:00:00',3.93),('12664','2013-08-24','14:05:00',3.9),('12664','2013-08-24','14:10:00',3.87),('12664','2013-08-24','14:15:00',3.86),('12664','2013-08-24','14:20:00',3.82),('12664','2013-08-24','14:25:00',3.8),('12664','2013-08-24','14:30:00',3.79),('12664','2013-08-24','14:35:00',3.75),('12664','2013-08-24','14:40:00',3.72),('12664','2013-08-24','14:45:00',3.69),('12664','2013-08-24','14:50:00',3.68),('12664','2013-08-24','14:55:00',3.63),('12664','2013-08-24','15:00:00',3.59),('12664','2013-08-24','15:05:00',3.55),('12664','2013-08-24','15:10:00',3.52),('12664','2013-08-24','15:15:00',3.49),('12664','2013-08-24','15:20:00',3.41),('12664','2013-08-24','15:25:00',3.35),('12664','2013-08-24','15:30:00',3.3),('12664','2013-08-24','15:35:00',3.26),('12664','2013-08-24','15:40:00',3.2),('12664','2013-08-24','15:45:00',3.16),('12664','2013-08-24','15:50:00',3.11),('12664','2013-08-24','15:55:00',3.06),('12664','2013-08-24','16:00:00',2.99),('12664','2013-08-24','16:05:00',2.94),('12664','2013-08-24','16:10:00',2.88),('12664','2013-08-24','16:15:00',2.82),('12664','2013-08-24','16:20:00',2.76),('12664','2013-08-24','16:25:00',2.68),('12664','2013-08-24','16:30:00',2.6),('12664','2013-08-24','16:35:00',2.53),('12664','2013-08-24','16:40:00',2.46),('12664','2013-08-24','16:45:00',2.39),('12664','2013-08-24','16:50:00',2.3),('12664','2013-08-24','16:55:00',2.23),('12664','2013-08-24','17:00:00',2.15),('12664','2013-08-24','17:05:00',2.07),('12664','2013-08-24','17:10:00',1.98),('12664','2013-08-24','17:15:00',1.91),('12664','2013-08-24','17:20:00',1.83),('12664','2013-08-24','17:25:00',1.73),('12664','2013-08-24','17:30:00',1.64),('12664','2013-08-24','17:35:00',1.55),('12664','2013-08-24','17:40:00',1.46),('12664','2013-08-24','17:45:00',1.38),('12664','2013-08-24','17:50:00',1.3),('12664','2013-08-24','17:55:00',1.19),('12664','2013-08-24','18:00:00',1.1),('12664','2013-08-24','18:05:00',1.02),('12664','2013-08-23','08:20:00',1.07),('12664','2013-08-23','08:25:00',1.13),('12664','2013-08-23','08:30:00',1.23),('12664','2013-08-23','08:35:00',1.3),('12664','2013-08-23','08:40:00',1.58),('12664','2013-08-23','08:45:00',1.67),('12664','2013-08-23','08:50:00',1.65),('12664','2013-08-23','08:55:00',1.55),('12664','2013-08-23','09:00:00',1.75),('12664','2013-08-23','09:05:00',1.82),('12664','2013-08-23','09:10:00',1.96),('12664','2013-08-23','09:15:00',2.01),('12664','2013-08-23','09:20:00',2.09),('12664','2013-08-23','09:25:00',2.12),('12664','2013-08-23','09:30:00',2.18),('12664','2013-08-23','09:35:00',2.23),('12664','2013-08-23','09:40:00',2.31),('12664','2013-08-23','09:45:00',2.41),('12664','2013-08-23','09:50:00',2.48),('12664','2013-08-23','09:55:00',2.54),('12664','2013-08-23','10:00:00',2.61),('12664','2013-08-23','10:05:00',2.62),('12664','2013-08-23','10:10:00',2.7),('12664','2013-08-23','10:15:00',2.78),('12664','2013-08-23','10:20:00',2.81),('12664','2013-08-23','10:25:00',2.88),('12664','2013-08-23','10:30:00',2.94),('12664','2013-08-23','10:35:00',2.99),('12664','2013-08-23','10:40:00',3.06),('12664','2013-08-23','10:45:00',3.07),('12664','2013-08-23','10:50:00',3.13),('12664','2013-08-23','10:55:00',3.18),('12664','2013-08-23','11:00:00',3.26),('12664','2013-08-23','11:05:00',3.27),('12664','2013-08-23','11:10:00',3.15),('12664','2013-08-23','11:15:00',3.47),('12664','2013-08-23','11:20:00',3.5),('12664','2013-08-23','11:25:00',3.37),('12664','2013-08-23','11:30:00',3.05),('12664','2013-08-23','11:35:00',3.82),('12664','2013-08-23','11:40:00',2.88),('12664','2013-08-23','11:45:00',1.19),('12664','2013-08-23','11:50:00',2.92),('12664','2013-08-23','11:55:00',2.22),('12664','2013-08-23','12:00:00',4.08),('12664','2013-08-23','12:05:00',2.78),('12664','2013-08-23','12:10:00',1.27),('12664','2013-08-23','12:15:00',1.64),('12664','2013-08-23','12:20:00',3.15),('12664','2013-08-23','12:25:00',1.94),('12664','2013-08-23','12:30:00',3.99),('12664','2013-08-23','12:35:00',2.48),('12664','2013-08-23','12:40:00',2.86),('12664','2013-08-23','12:45:00',4.04),('12664','2013-08-23','12:50:00',4.02),('12664','2013-08-23','12:55:00',3.99),('12664','2013-08-23','13:00:00',3.95),('12664','2013-08-23','13:05:00',4.02),('12664','2013-08-23','13:10:00',3.99),('12664','2013-08-23','13:15:00',4.02),('12664','2013-08-23','13:20:00',4),('12664','2013-08-23','13:25:00',3.97),('12664','2013-08-23','13:30:00',3.98),('12664','2013-08-23','13:35:00',4),('12664','2013-08-23','13:40:00',4),('12664','2013-08-23','13:45:00',3.98),('12664','2013-08-23','13:50:00',3.96),('12664','2013-08-23','13:55:00',3.96),('12664','2013-08-23','14:00:00',3.96),('12664','2013-08-23','14:05:00',3.93),('12664','2013-08-23','14:10:00',3.9),('12664','2013-08-23','14:15:00',3.89),('12664','2013-08-23','14:20:00',3.87),('12664','2013-08-23','14:25:00',3.86),('12664','2013-08-23','14:30:00',3.81),('12664','2013-08-23','14:35:00',3.78),('12664','2013-08-23','14:40:00',3.74),('12664','2013-08-23','14:45:00',3.7),('12664','2013-08-23','14:50:00',3.59),('12664','2013-08-23','14:55:00',3.45),('12664','2013-08-23','15:00:00',3.54),('12664','2013-08-23','15:05:00',3.52),('12664','2013-08-23','15:10:00',3.1),('12664','2013-08-23','15:15:00',2.86),('12664','2013-08-23','15:20:00',3.14),('12664','2013-08-23','15:25:00',3.26),('12664','2013-08-23','15:30:00',3.26),('12664','2013-08-23','15:35:00',3.33),('12664','2013-08-23','15:40:00',2.92),('12664','2013-08-23','15:45:00',2.96),('12664','2013-08-23','15:50:00',2.79),('12664','2013-08-23','15:55:00',2.7),('12664','2013-08-23','16:00:00',2.64),('12664','2013-08-23','16:05:00',2.58),('12664','2013-08-23','16:10:00',2.47),('12664','2013-08-23','16:15:00',2.56),('12664','2013-08-23','16:20:00',2.56),('12664','2013-08-23','16:25:00',2.39),('12664','2013-08-23','16:30:00',2.55),('12664','2013-08-23','16:35:00',2.59),('12664','2013-08-23','16:40:00',2.55),('12664','2013-08-23','16:45:00',2.43),('12664','2013-08-23','16:50:00',2.32),('12664','2013-08-23','16:55:00',2.24),('12664','2013-08-23','17:00:00',2.14),('12664','2013-08-23','17:05:00',2.02),('12664','2013-08-23','17:10:00',1.95),('12664','2013-08-23','17:15:00',1.88),('12664','2013-08-23','17:20:00',1.81),('12664','2013-08-23','17:25:00',1.71),('12664','2013-08-23','17:30:00',1.6),('12664','2013-08-23','17:35:00',1.54),('12664','2013-08-23','17:40:00',1.46),('12664','2013-08-23','17:45:00',1.39),('12664','2013-08-23','17:50:00',1.16),('12664','2013-08-23','18:00:00',1.02),('12664','2013-08-23','18:05:00',1.03),('12664','2013-08-22','08:10:00',1.02),('12664','2013-08-22','08:15:00',1.1),('12664','2013-08-22','08:20:00',1.17),('12664','2013-08-22','08:25:00',1.24),('12664','2013-08-22','08:30:00',1.33),('12664','2013-08-22','08:35:00',1.4),('12664','2013-08-22','08:40:00',1.49),('12664','2013-08-22','08:45:00',1.61),('12664','2013-08-22','08:50:00',1.71),('12664','2013-08-22','08:55:00',1.79),('12664','2013-08-22','09:00:00',1.88),('12664','2013-08-22','09:05:00',1.72),('12664','2013-08-22','09:10:00',1.68),('12664','2013-08-22','09:15:00',2.17),('12664','2013-08-22','09:20:00',2.28),('12664','2013-08-22','09:25:00',2.39),('12664','2013-08-22','09:30:00',2.48),('12664','2013-08-22','09:35:00',2.39),('12664','2013-08-22','09:40:00',2.55),('12664','2013-08-22','09:45:00',2.59),('12664','2013-08-22','09:50:00',2.8),('12664','2013-08-22','09:55:00',2.86),('12664','2013-08-22','10:00:00',2.86),('12664','2013-08-22','10:05:00',2.32),('12664','2013-08-22','10:10:00',2.45),('12664','2013-08-22','10:15:00',1.97),('12664','2013-08-22','10:20:00',2.87),('12664','2013-08-22','10:25:00',2.87),('12664','2013-08-22','10:30:00',3.19),('12664','2013-08-22','10:35:00',3.12),('12664','2013-08-22','10:40:00',3.23),('12664','2013-08-22','10:45:00',3.23),('12664','2013-08-22','10:50:00',3.26),('12664','2013-08-22','10:55:00',3.2),('12664','2013-08-22','11:00:00',3.36),('12664','2013-08-22','11:05:00',3.41),('12664','2013-08-22','11:10:00',3.43),('12664','2013-08-22','11:15:00',3.47),('12664','2013-08-22','11:20:00',3.53),('12664','2013-08-22','11:25:00',3.56),('12664','2013-08-22','11:30:00',3.59),('12664','2013-08-22','11:35:00',3.61),('12664','2013-08-22','11:40:00',3.65),('12664','2013-08-22','11:45:00',3.67),('12664','2013-08-22','11:50:00',3.68),('12664','2013-08-22','11:55:00',3.67),('12664','2013-08-22','12:00:00',3.72),('12664','2013-08-22','12:05:00',3.72),('12664','2013-08-22','12:10:00',3.73),('12664','2013-08-22','12:15:00',3.75),('12664','2013-08-22','12:20:00',3.75),('12664','2013-08-22','12:25:00',3.78),('12664','2013-08-22','12:30:00',3.79),('12664','2013-08-22','12:35:00',3.8),('12664','2013-08-22','12:40:00',3.78),('12664','2013-08-22','12:45:00',3.78),('12664','2013-08-22','12:50:00',3.79),('12664','2013-08-22','12:55:00',3.78),('12664','2013-08-22','13:00:00',3.78),('12664','2013-08-22','13:05:00',3.77),('12664','2013-08-22','13:10:00',3.77),('12664','2013-08-22','13:15:00',3.76),('12664','2013-08-22','13:20:00',3.77),('12664','2013-08-22','13:25:00',3.76),('12664','2013-08-22','13:30:00',3.74),('12664','2013-08-22','13:35:00',3.74),('12664','2013-08-22','13:40:00',3.75),('12664','2013-08-22','13:45:00',3.7),('12664','2013-08-22','13:50:00',3.63),('12664','2013-08-22','13:55:00',3.62),('12664','2013-08-22','14:00:00',3.66),('12664','2013-08-22','14:05:00',3.69),('12664','2013-08-22','14:10:00',3.49),('12664','2013-08-22','14:15:00',2.07),('12664','2013-08-22','14:20:00',3.57),('12664','2013-08-22','14:25:00',3.59),('12664','2013-08-22','14:30:00',3.64),('12664','2013-08-22','14:35:00',3.53),('12664','2013-08-22','14:40:00',3.53),('12664','2013-08-22','14:45:00',3.47),('12664','2013-08-22','14:50:00',3.46),('12664','2013-08-22','14:55:00',3.47),('12664','2013-08-22','15:00:00',3.47),('12664','2013-08-22','15:05:00',3.48),('12664','2013-08-22','15:10:00',3.4),('12664','2013-08-22','15:15:00',3.38),('12664','2013-08-22','15:20:00',3.32),('12664','2013-08-22','15:25:00',3.29),('12664','2013-08-22','15:30:00',3.26),('12664','2013-08-22','15:35:00',3.19),('12664','2013-08-22','15:40:00',3.13),('12664','2013-08-22','15:45:00',3.08),('12664','2013-08-22','15:50:00',3.02),('12664','2013-08-22','15:55:00',2.94),('12664','2013-08-22','16:00:00',2.88),('12664','2013-08-22','16:05:00',2.83),('12664','2013-08-22','16:10:00',2.78),('12664','2013-08-22','16:15:00',2.7),('12664','2013-08-22','16:20:00',2.6),('12664','2013-08-22','16:25:00',2.51),('12664','2013-08-22','16:30:00',2.46),('12664','2013-08-22','16:35:00',2.38),('12664','2013-08-22','16:40:00',2.31),('12664','2013-08-22','16:45:00',2.24),('12664','2013-08-22','16:50:00',2.12),('12664','2013-08-22','16:55:00',2.07),('12664','2013-08-22','17:00:00',2),('12664','2013-08-22','17:05:00',1.93),('12664','2013-08-22','17:10:00',1.86),('12664','2013-08-22','17:15:00',1.76),('12664','2013-08-22','17:20:00',1.68),('12664','2013-08-22','17:25:00',1.6),('12664','2013-08-22','17:30:00',1.53),('12664','2013-08-22','17:35:00',1.44),('12664','2013-08-22','17:40:00',1.35),('12664','2013-08-22','17:45:00',1.28),('12664','2013-08-22','17:50:00',1.21),('12664','2013-08-22','17:55:00',1.13),('12664','2013-08-22','18:00:00',1.04),('12664','2013-08-21','09:10:00',1.09),('12664','2013-08-21','09:15:00',1.35),('12664','2013-08-21','09:20:00',1.49),('12664','2013-08-21','09:25:00',2.22),('12664','2013-08-21','09:30:00',1.9),('12664','2013-08-21','09:35:00',1.22),('12664','2013-08-21','09:50:00',1.02),('12664','2013-08-21','09:55:00',1.06),('12664','2013-08-21','10:00:00',1.16),('12664','2013-08-21','10:05:00',1.69),('12664','2013-08-21','10:10:00',2.83),('12664','2013-08-21','10:15:00',2.79),('12664','2013-08-21','10:20:00',2.88),('12664','2013-08-21','10:25:00',2.97),('12664','2013-08-21','10:30:00',3.05),('12664','2013-08-21','10:35:00',3.11),('12664','2013-08-21','10:40:00',3.29),('12664','2013-08-21','10:45:00',3.38),('12664','2013-08-21','10:50:00',3.31),('12664','2013-08-21','10:55:00',3.31),('12664','2013-08-21','11:00:00',3.71),('12664','2013-08-21','11:05:00',2.72),('12664','2013-08-21','11:10:00',3.52),('12664','2013-08-21','11:15:00',2.25),('12664','2013-08-21','11:20:00',2.7),('12664','2013-08-21','11:25:00',2.81),('12664','2013-08-21','11:30:00',3.19),('12664','2013-08-21','11:35:00',4.5),('12664','2013-08-21','11:40:00',4.06),('12664','2013-08-21','11:45:00',4.12),('12664','2013-08-21','11:50:00',3.98),('12664','2013-08-21','11:55:00',4),('12664','2013-08-21','12:00:00',3.91),('12664','2013-08-21','12:05:00',4),('12664','2013-08-21','12:10:00',4),('12664','2013-08-21','12:15:00',4.01),('12664','2013-08-21','12:20:00',3.84),('12664','2013-08-21','12:25:00',3.98),('12664','2013-08-21','12:30:00',4),('12664','2013-08-21','12:35:00',3.78),('12664','2013-08-21','12:40:00',3.7),('12664','2013-08-21','12:45:00',2.61),('12664','2013-08-21','12:50:00',2.88),('12664','2013-08-21','12:55:00',3.77),('12664','2013-08-21','13:00:00',3.75),('12664','2013-08-21','13:05:00',3.74),('12664','2013-08-21','13:10:00',3.81),('12664','2013-08-21','13:15:00',3.88),('12664','2013-08-21','13:20:00',3.8),('12664','2013-08-21','13:25:00',3.69),('12664','2013-08-21','13:30:00',3.72),('12664','2013-08-21','13:35:00',3.83),('12664','2013-08-21','13:40:00',3.92),('12664','2013-08-21','13:45:00',3.94),('12664','2013-08-21','13:50:00',3.94),('12664','2013-08-21','13:55:00',3.91),('12664','2013-08-21','14:00:00',3.88),('12664','2013-08-21','14:05:00',3.88),('12664','2013-08-21','14:10:00',3.88),('12664','2013-08-21','14:15:00',3.83),('12664','2013-08-21','14:20:00',3.64),('12664','2013-08-21','14:25:00',3.25),('12664','2013-08-21','14:30:00',3.53),('12664','2013-08-21','14:35:00',3.41),('12664','2013-08-21','14:40:00',3.17),('12664','2013-08-21','14:45:00',3.49),('12664','2013-08-21','14:50:00',2.74),('12664','2013-08-21','14:55:00',3.47),('12664','2013-08-21','15:00:00',3.52),('12664','2013-08-21','15:05:00',3.51),('12664','2013-08-21','15:10:00',3.39),('12664','2013-08-21','15:15:00',3.2),('12664','2013-08-21','15:20:00',2.95),('12664','2013-08-21','15:25:00',2.87),('12664','2013-08-21','15:30:00',2.91),('12664','2013-08-21','15:35:00',2.92),('12664','2013-08-21','15:40:00',2.67),('12664','2013-08-21','15:45:00',2.69),('12664','2013-08-21','15:50:00',2.67),('12664','2013-08-21','15:55:00',2.73),('12664','2013-08-21','16:00:00',2.82),('12664','2013-08-21','16:05:00',2.68),('12664','2013-08-21','16:10:00',2.85),('12664','2013-08-21','16:15:00',2.85),('12664','2013-08-21','16:20:00',2.77),('12664','2013-08-21','16:25:00',2.65),('12664','2013-08-21','16:30:00',2.58),('12664','2013-08-21','16:35:00',2.58),('12664','2013-08-21','16:40:00',2.5),('12664','2013-08-21','16:45:00',2.44),('12664','2013-08-21','16:50:00',2.37),('12664','2013-08-21','16:55:00',2.34),('12664','2013-08-21','17:00:00',2.29),('12664','2013-08-21','17:05:00',2.19),('12664','2013-08-21','17:10:00',2.13),('12664','2013-08-21','17:15:00',2.05),('12664','2013-08-21','17:20:00',1.97),('12664','2013-08-21','17:25:00',1.9),('12664','2013-08-21','17:30:00',1.85),('12664','2013-08-21','17:35:00',1.75),('12664','2013-08-21','17:40:00',1.67),('12664','2013-08-21','17:45:00',1.6),('12664','2013-08-21','17:50:00',1.52),('12664','2013-08-21','17:55:00',1.42),('12664','2013-08-21','18:00:00',1.34),('12664','2013-08-21','18:05:00',1.25),('12664','2013-08-21','18:10:00',1.16),('12664','2013-08-21','18:15:00',1.04),('12664','2013-08-20','08:45:00',1.02),('12664','2013-08-20','08:50:00',1.18),('12664','2013-08-20','08:55:00',1.11),('12664','2013-08-20','09:15:00',1.33),('12664','2013-08-20','09:20:00',2.35),('12664','2013-08-20','09:25:00',2.18),('12664','2013-08-20','09:30:00',2.47),('12664','2013-08-20','09:35:00',2.63),('12664','2013-08-20','09:55:00',1.18),('12664','2013-08-20','10:00:00',2.59),('12664','2013-08-20','10:05:00',3.34),('12664','2013-08-20','10:10:00',3.15),('12664','2013-08-20','10:15:00',2.07),('12664','2013-08-20','10:20:00',1.76),('12664','2013-08-20','10:25:00',2.05),('12664','2013-08-20','10:30:00',1.97),('12664','2013-08-20','10:35:00',1.07),('12664','2013-08-20','10:40:00',1.01),('12664','2013-08-20','10:45:00',1.28),('12664','2013-08-20','10:50:00',3.28),('12664','2013-08-20','10:55:00',3.82),('12664','2013-08-20','11:00:00',3.59),('12664','2013-08-20','11:05:00',3.01),('12664','2013-08-20','11:10:00',4.28),('12664','2013-08-20','11:15:00',4.08),('12664','2013-08-20','11:20:00',2.53),('12664','2013-08-20','11:25:00',3.33),('12664','2013-08-20','11:30:00',4.09),('12664','2013-08-20','11:35:00',4.33),('12664','2013-08-20','11:40:00',3.39),('12664','2013-08-20','11:45:00',2.97),('12664','2013-08-20','11:50:00',2.25),('12664','2013-08-20','11:55:00',2.43),('12664','2013-08-20','12:00:00',1.76),('12664','2013-08-20','12:05:00',1.91),('12664','2013-08-20','12:10:00',1.77),('12664','2013-08-20','12:15:00',1.61),('12664','2013-08-20','12:20:00',1.7),('12664','2013-08-20','12:25:00',1.79),('12664','2013-08-20','12:30:00',1.74),('12664','2013-08-20','12:35:00',2.92),('12664','2013-08-20','12:40:00',2.23),('12664','2013-08-20','12:45:00',1.77),('12664','2013-08-20','12:50:00',2.08),('12664','2013-08-20','12:55:00',1.95),('12664','2013-08-20','13:00:00',1.62),('12664','2013-08-20','13:05:00',1.5),('12664','2013-08-20','13:10:00',1.92),('12664','2013-08-20','13:15:00',2.37),('12664','2013-08-20','13:20:00',1.95),('12664','2013-08-20','13:25:00',2.36),('12664','2013-08-20','13:30:00',2.44),('12664','2013-08-20','13:35:00',2.37),('12664','2013-08-20','13:40:00',4.56),('12664','2013-08-20','13:45:00',4.53),('12664','2013-08-20','13:50:00',4.23),('12664','2013-08-20','13:55:00',4.19),('12664','2013-08-20','14:00:00',3.77),('12664','2013-08-20','14:05:00',4.26),('12664','2013-08-20','14:10:00',4.03),('12664','2013-08-20','14:15:00',3.76),('12664','2013-08-20','14:20:00',2.95),('12664','2013-08-20','14:25:00',4.13),('12664','2013-08-20','14:30:00',3.66),('12664','2013-08-20','14:35:00',3.67),('12664','2013-08-20','14:40:00',4.09),('12664','2013-08-20','14:45:00',4),('12664','2013-08-20','14:50:00',3.92),('12664','2013-08-20','14:55:00',4.02),('12664','2013-08-20','15:00:00',3.89),('12664','2013-08-20','15:05:00',3.75),('12664','2013-08-20','15:10:00',2.91),('12664','2013-08-20','15:15:00',2.75),('12664','2013-08-20','15:20:00',2.88),('12664','2013-08-20','15:25:00',4.01),('12664','2013-08-20','15:30:00',2.83),('12664','2013-08-20','15:35:00',1.66),('12664','2013-08-20','15:40:00',1.41),('12664','2013-08-20','15:45:00',3.41),('12664','2013-08-20','15:50:00',3.7),('12664','2013-08-20','15:55:00',3.49),('12664','2013-08-20','16:00:00',3.33),('12664','2013-08-20','16:05:00',3.39),('12664','2013-08-20','16:10:00',3.44),('12664','2013-08-20','16:15:00',3.46),('12664','2013-08-20','16:20:00',3.44),('12664','2013-08-20','16:25:00',3.38),('12664','2013-08-20','16:30:00',3.11),('12664','2013-08-20','16:35:00',3.04),('12664','2013-08-20','16:40:00',1.66),('12664','2013-08-20','16:45:00',2.39),('12664','2013-08-20','16:50:00',2.53),('12664','2013-08-20','16:55:00',2.21),('12664','2013-08-20','17:00:00',2.1),('12664','2013-08-20','17:05:00',2.22),('12664','2013-08-20','17:10:00',2.15),('12664','2013-08-20','17:15:00',2.05),('12664','2013-08-20','17:25:00',1.92),('12664','2013-08-20','17:30:00',1.76),('12664','2013-08-20','17:35:00',1.7),('12664','2013-08-20','17:40:00',1.57),('12664','2013-08-20','17:45:00',1.47),('12664','2013-08-20','17:50:00',1.36),('12664','2013-08-20','17:55:00',1.25),('12664','2013-08-20','18:00:00',1.18),('12664','2013-08-20','18:05:00',1.1),('12664','2013-08-20','18:10:00',1.01),('12664','2013-08-19','08:15:00',1.07),('12664','2013-08-19','08:20:00',1.18),('12664','2013-08-19','08:25:00',1.34),('12664','2013-08-19','08:30:00',1.41),('12664','2013-08-19','08:35:00',1.48),('12664','2013-08-19','08:40:00',1.55),('12664','2013-08-19','08:45:00',1.66),('12664','2013-08-19','08:50:00',1.77),('12664','2013-08-19','08:55:00',1.87),('12664','2013-08-19','09:00:00',1.94),('12664','2013-08-19','09:05:00',2.03),('12664','2013-08-19','09:10:00',2.12),('12664','2013-08-19','09:15:00',2.21),('12664','2013-08-19','09:20:00',2.3),('12664','2013-08-19','09:25:00',2.36),('12664','2013-08-19','09:30:00',2.44),('12664','2013-08-19','09:35:00',2.49),('12664','2013-08-19','09:40:00',2.57),('12664','2013-08-19','09:45:00',2.65),('12664','2013-08-19','09:50:00',2.69),('12664','2013-08-19','09:55:00',2.75),('12664','2013-08-19','10:00:00',2.82),('12664','2013-08-19','10:05:00',2.88),('12664','2013-08-19','10:10:00',2.92),('12664','2013-08-19','10:15:00',2.98),('12664','2013-08-19','10:20:00',3.06),('12664','2013-08-19','10:25:00',3.12),('12664','2013-08-19','10:30:00',3.17),('12664','2013-08-19','10:35:00',3.21),('12664','2013-08-19','10:40:00',3.25),('12664','2013-08-19','10:45:00',3.3),('12664','2013-08-19','10:50:00',3.34),('12664','2013-08-19','10:55:00',3.37),('12664','2013-08-19','11:00:00',3.41),('12664','2013-08-19','11:05:00',3.45),('12664','2013-08-19','11:10:00',3.48),('12664','2013-08-19','11:15:00',3.52),('12664','2013-08-19','11:20:00',3.55),('12664','2013-08-19','11:25:00',3.55),('12664','2013-08-19','11:30:00',3.6),('12664','2013-08-19','11:35:00',3.69),('12664','2013-08-19','11:40:00',3.7),('12664','2013-08-19','11:45:00',3.73),('12664','2013-08-19','11:50:00',3.8),('12664','2013-08-19','11:55:00',3.81),('12664','2013-08-19','12:00:00',3.86),('12664','2013-08-19','12:05:00',3.82),('12664','2013-08-19','12:10:00',3.78),('12664','2013-08-19','12:15:00',3.87),('12664','2013-08-19','12:20:00',3.89),('12664','2013-08-19','12:25:00',3.98),('12664','2013-08-19','12:30:00',4),('12664','2013-08-19','12:35:00',4),('12664','2013-08-19','12:40:00',4.02),('12664','2013-08-19','12:45:00',3.99),('12664','2013-08-19','12:50:00',3.98),('12664','2013-08-19','12:55:00',4.02),('12664','2013-08-19','13:00:00',4.03),('12664','2013-08-19','13:05:00',4),('12664','2013-08-19','13:10:00',4.05),('12664','2013-08-19','13:15:00',4.04),('12664','2013-08-19','13:20:00',4.04),('12664','2013-08-19','13:25:00',4.05),('12664','2013-08-19','13:30:00',4.06),('12664','2013-08-19','13:35:00',4.05),('12664','2013-08-19','13:40:00',4.05),('12664','2013-08-19','13:45:00',4.02),('12664','2013-08-19','13:50:00',4.02),('12664','2013-08-19','13:55:00',4),('12664','2013-08-19','14:00:00',4.01),('12664','2013-08-19','14:05:00',4),('12664','2013-08-19','14:10:00',3.96),('12664','2013-08-19','14:15:00',3.96),('12664','2013-08-19','14:20:00',3.93),('12664','2013-08-19','14:25:00',3.93),('12664','2013-08-19','14:30:00',3.9),('12664','2013-08-19','14:35:00',3.88),('12664','2013-08-19','14:40:00',3.85),('12664','2013-08-19','14:45:00',3.83),('12664','2013-08-19','14:50:00',3.77),('12664','2013-08-19','14:55:00',3.73),('12664','2013-08-19','15:00:00',3.73),('12664','2013-08-19','15:05:00',3.68),('12664','2013-08-19','15:10:00',3.63),('12664','2013-08-19','15:15:00',3.59),('12664','2013-08-19','15:20:00',3.55),('12664','2013-08-19','15:25:00',3.5),('12664','2013-08-19','15:30:00',3.45),('12664','2013-08-19','15:35:00',3.41),('12664','2013-08-19','15:40:00',3.36),('12664','2013-08-19','15:45:00',3.28),('12664','2013-08-19','15:50:00',3.24),('12664','2013-08-19','15:55:00',3.18),('12664','2013-08-19','16:00:00',3.12),('12664','2013-08-19','16:05:00',3.06),('12664','2013-08-19','16:10:00',2.99),('12664','2013-08-19','16:15:00',2.92),('12664','2013-08-19','16:20:00',2.87),('12664','2013-08-19','16:25:00',2.81),('12664','2013-08-19','16:30:00',2.73),('12664','2013-08-19','16:35:00',2.65),('12664','2013-08-19','16:40:00',2.58),('12664','2013-08-19','16:45:00',2.51),('12664','2013-08-19','16:50:00',2.44),('12664','2013-08-19','16:55:00',2.35),('12664','2013-08-19','17:00:00',2.27),('12664','2013-08-19','17:05:00',2.18),('12664','2013-08-19','17:10:00',2.1),('12664','2013-08-19','17:15:00',2.03),('12664','2013-08-19','17:20:00',1.95),('12664','2013-08-19','17:25:00',1.86),('12664','2013-08-19','17:30:00',1.78),('12664','2013-08-19','17:35:00',1.68),('12664','2013-08-19','17:40:00',1.59),('12664','2013-08-19','17:45:00',1.5),('12664','2013-08-19','17:50:00',1.42),('12664','2013-08-19','17:55:00',1.33),('12664','2013-08-19','18:00:00',1.24),('12664','2013-08-19','18:05:00',1.14),('12664','2013-08-19','18:10:00',1.05),('12664','2014-04-09','10:00:00',1.1),('12664','2014-04-09','10:05:00',2.11),('12664','2014-04-09','10:10:00',2.86),('12664','2014-04-09','10:15:00',2.3),('12664','2014-04-09','10:20:00',2.32),('12664','2014-04-09','10:25:00',1.98),('12664','2014-04-09','10:30:00',1.22),('12664','2014-04-09','10:35:00',3.53),('12664','2014-04-09','10:40:00',3.65),('12664','2014-04-09','10:45:00',3.62),('12664','2014-04-09','10:50:00',3.23),('12664','2014-04-09','10:55:00',1.69),('12664','2014-04-09','11:00:00',3.97),('12664','2014-04-09','11:05:00',3.12),('12664','2014-04-09','11:10:00',2.38),('12664','2014-04-09','11:15:00',3.61),('12664','2014-04-09','11:20:00',3.93),('12664','2014-04-09','11:25:00',4.39),('12664','2014-04-09','11:30:00',1.66),('12664','2014-04-09','11:35:00',3.14),('12664','2014-04-09','11:40:00',3.86),('12664','2014-04-09','11:45:00',1.91),('12664','2014-04-09','11:50:00',1.53),('12664','2014-04-09','11:55:00',4.42),('12664','2014-04-09','12:00:00',3.38),('12664','2014-04-09','12:05:00',2.78),('12664','2014-04-09','12:10:00',1.55),('12664','2014-04-09','12:15:00',1.17),('12664','2014-04-09','12:20:00',1.2),('12664','2014-04-09','12:25:00',1.12),('12664','2014-04-09','13:40:00',1.06),('12664','2014-04-09','13:45:00',1.15),('12664','2014-04-09','13:50:00',1.13),('12664','2014-04-09','13:55:00',1.33),('12664','2014-04-09','14:00:00',1.26),('12664','2014-04-09','14:05:00',1.09),('12664','2014-04-09','14:10:00',1.09),('12664','2014-04-09','14:15:00',2.51),('12664','2014-04-09','14:20:00',3.23),('12664','2014-04-09','14:25:00',2.75),('12664','2014-04-09','14:30:00',1.91),('12664','2014-04-09','14:35:00',3.51),('12664','2014-04-09','14:40:00',1.34),('12664','2014-04-09','14:45:00',2.6),('12664','2014-04-09','14:50:00',1.17),('12664','2014-04-09','14:55:00',1.09),('12664','2014-04-09','15:00:00',1.08),('12664','2014-04-09','15:30:00',1.64),('12664','2014-04-09','15:35:00',2.89),('12664','2014-04-09','15:40:00',3.48),('12664','2014-04-09','15:45:00',3.29),('12664','2014-04-09','15:50:00',3.22),('12664','2014-04-09','15:55:00',2.96),('12664','2014-04-09','16:00:00',2.97),('12664','2014-04-09','16:05:00',2.86),('12664','2014-04-09','16:10:00',2.83),('12664','2014-04-09','16:15:00',2.74),('12664','2014-04-09','16:20:00',2.67),('12664','2014-04-09','16:25:00',2.58),('12664','2014-04-09','16:30:00',2.53),('12664','2014-04-09','16:35:00',2.47),('12664','2014-04-09','16:40:00',2.38),('12664','2014-04-09','16:45:00',2.28),('12664','2014-04-09','16:50:00',2.26),('12664','2014-04-09','16:55:00',2.31),('12664','2014-04-09','17:00:00',2.19),('12664','2014-04-09','17:05:00',1.22),('12664','2014-04-09','17:10:00',1.84),('12664','2014-04-09','17:15:00',1.63),('12664','2014-04-09','17:20:00',1.25),('12664','2014-04-09','17:30:00',1.38),('12664','2014-04-09','17:35:00',1.69),('12664','2014-04-09','17:40:00',1.2),('12664','2014-04-09','17:45:00',1.22),('12664','2014-04-09','17:50:00',1.19),('12664','2013-08-18','08:05:00',1.05),('12664','2013-08-18','08:10:00',1.14),('12664','2013-08-18','08:15:00',1.23),('12664','2013-08-18','08:20:00',1.31),('12664','2013-08-18','08:25:00',1.41),('12664','2013-08-18','08:30:00',1.49),('12664','2013-08-18','08:35:00',1.58),('12664','2013-08-18','08:40:00',1.66),('12664','2013-08-18','08:45:00',1.74),('12664','2013-08-18','08:50:00',1.82),('12664','2013-08-18','08:55:00',1.9),('12664','2013-08-18','09:00:00',1.98),('12664','2013-08-18','09:05:00',2.07),('12664','2013-08-18','09:10:00',2.15),('12664','2013-08-18','09:15:00',2.22),('12664','2013-08-18','09:20:00',2.3),('12664','2013-08-18','09:25:00',2.38),('12664','2013-08-18','09:30:00',2.48),('12664','2013-08-18','09:35:00',2.47),('12664','2013-08-18','09:40:00',2.56),('12664','2013-08-18','09:45:00',2.43),('12664','2013-08-18','09:50:00',2.7),('12664','2013-08-18','09:55:00',2.8),('12664','2013-08-18','10:00:00',2.86),('12664','2013-08-18','10:05:00',2.92),('12664','2013-08-18','10:10:00',2.97),('12664','2013-08-18','10:15:00',3.03),('12664','2013-08-18','10:20:00',3.08),('12664','2013-08-18','10:25:00',3.14),('12664','2013-08-18','10:30:00',3.19),('12664','2013-08-18','10:35:00',3.25),('12664','2013-08-18','10:40:00',3.28),('12664','2013-08-18','10:45:00',3.32),('12664','2013-08-18','10:50:00',3.36),('12664','2013-08-18','10:55:00',3.37),('12664','2013-08-18','11:00:00',3.41),('12664','2013-08-18','11:05:00',3.46),('12664','2013-08-18','11:10:00',3.51),('12664','2013-08-18','11:15:00',3.55),('12664','2013-08-18','11:20:00',3.61),('12664','2013-08-18','11:25:00',3.64),('12664','2013-08-18','11:30:00',3.61),('12664','2013-08-18','11:35:00',3.68),('12664','2013-08-18','11:40:00',3.67),('12664','2013-08-18','11:45:00',3.71),('12664','2013-08-18','11:50:00',3.77),('12664','2013-08-18','11:55:00',3.79),('12664','2013-08-18','12:00:00',3.82),('12664','2013-08-18','12:05:00',3.83),('12664','2013-08-18','12:10:00',3.87),('12664','2013-08-18','12:15:00',3.86),('12664','2013-08-18','12:20:00',3.95),('12664','2013-08-18','12:25:00',3.81),('12664','2013-08-18','12:30:00',3.21),('12664','2013-08-18','12:35:00',4.14),('12664','2013-08-18','12:40:00',4.05),('12664','2013-08-18','12:45:00',3.99),('12664','2013-08-18','12:50:00',4.03),('12664','2013-08-18','12:55:00',4.06),('12664','2013-08-18','13:00:00',4.08),('12664','2013-08-18','13:05:00',4.03),('12664','2013-08-18','13:10:00',4.04),('12664','2013-08-18','13:15:00',4.01),('12664','2013-08-18','13:20:00',4.02),('12664','2013-08-18','13:25:00',4.03),('12664','2013-08-18','13:30:00',4.01),('12664','2013-08-18','13:35:00',4.01),('12664','2013-08-18','13:40:00',4.04),('12664','2013-08-18','13:45:00',4.05),('12664','2013-08-18','13:50:00',4.03),('12664','2013-08-18','13:55:00',4.03),('12664','2013-08-18','14:00:00',4.02),('12664','2013-08-18','14:05:00',4.03),('12664','2013-08-18','14:10:00',3.97),('12664','2013-08-18','14:15:00',3.95),('12664','2013-08-18','14:20:00',3.94),('12664','2013-08-18','14:25:00',3.9),('12664','2013-08-18','14:30:00',3.9),('12664','2013-08-18','14:35:00',3.86),('12664','2013-08-18','14:40:00',3.8),('12664','2013-08-18','14:45:00',3.79),('12664','2013-08-18','14:50:00',3.75),('12664','2013-08-18','14:55:00',3.73),('12664','2013-08-18','15:00:00',3.71),('12664','2013-08-18','15:05:00',3.67),('12664','2013-08-18','15:10:00',3.62),('12664','2013-08-18','15:15:00',3.56),('12664','2013-08-18','15:20:00',3.52),('12664','2013-08-18','15:25:00',3.46),('12664','2013-08-18','15:30:00',3.41),('12664','2013-08-18','15:35:00',3.37),('12664','2013-08-18','15:40:00',3.33),('12664','2013-08-18','15:45:00',3.28),('12664','2013-08-18','15:50:00',3.22),('12664','2013-08-18','15:55:00',3.17),('12664','2013-08-18','16:00:00',3.12),('12664','2013-08-18','16:05:00',3.07),('12664','2013-08-18','16:10:00',3.02),('12664','2013-08-18','16:15:00',2.95),('12664','2013-08-18','16:20:00',2.89),('12664','2013-08-18','16:25:00',2.81),('12664','2013-08-18','16:30:00',2.75),('12664','2013-08-18','16:35:00',2.68),('12664','2013-08-18','16:40:00',2.61),('12664','2013-08-18','16:45:00',2.54),('12664','2013-08-18','16:50:00',2.46),('12664','2013-08-18','16:55:00',2.39),('12664','2013-08-18','17:00:00',2.31),('12664','2013-08-18','17:05:00',2.22),('12664','2013-08-18','17:10:00',2.14),('12664','2013-08-18','17:15:00',2.06),('12664','2013-08-18','17:20:00',1.98),('12664','2013-08-18','17:25:00',1.89),('12664','2013-08-18','17:30:00',1.8),('12664','2013-08-18','17:35:00',1.71),('12664','2013-08-18','17:40:00',1.62),('12664','2013-08-18','17:45:00',1.53),('12664','2013-08-18','17:50:00',1.43),('12664','2013-08-18','17:55:00',1.34),('12664','2013-08-18','18:00:00',1.25),('12664','2013-08-18','18:05:00',1.16),('12664','2013-08-18','18:10:00',1.07),('12664','2013-08-17','08:05:00',1.02),('12664','2013-08-17','08:10:00',1.11),('12664','2013-08-17','08:15:00',1.2),('12664','2013-08-17','08:20:00',1.29),('12664','2013-08-17','08:25:00',1.39),('12664','2013-08-17','08:30:00',1.48),('12664','2013-08-17','08:35:00',1.58),('12664','2013-08-17','08:40:00',1.67),('12664','2013-08-17','08:45:00',1.76),('12664','2013-08-17','08:50:00',1.86),('12664','2013-08-17','08:55:00',1.95),('12664','2013-08-17','09:00:00',2.03),('12664','2013-08-17','09:05:00',2.1),('12664','2013-08-17','09:10:00',2.19),('12664','2013-08-17','09:15:00',2.27),('12664','2013-08-17','09:20:00',2.34),('12664','2013-08-17','09:25:00',2.42),('12664','2013-08-17','09:30:00',2.5),('12664','2013-08-17','09:35:00',2.57),('12664','2013-08-17','09:40:00',2.64),('12664','2013-08-17','09:45:00',2.71),('12664','2013-08-17','09:50:00',2.77),('12664','2013-08-17','09:55:00',2.82),('12664','2013-08-17','10:00:00',2.89),('12664','2013-08-17','10:05:00',2.95),('12664','2013-08-17','10:10:00',3.01),('12664','2013-08-17','10:15:00',3.06),('12664','2013-08-17','10:20:00',3.08),('12664','2013-08-17','10:25:00',3.15),('12664','2013-08-17','10:30:00',3.19),('12664','2013-08-17','10:35:00',3.24),('12664','2013-08-17','10:40:00',3.3),('12664','2013-08-17','10:45:00',3.35),('12664','2013-08-17','10:50:00',3.39),('12664','2013-08-17','10:55:00',3.42),('12664','2013-08-17','11:00:00',3.46),('12664','2013-08-17','11:05:00',3.52),('12664','2013-08-17','11:10:00',3.58),('12664','2013-08-17','11:15:00',3.59),('12664','2013-08-17','11:20:00',3.64),('12664','2013-08-17','11:25:00',3.69),('12664','2013-08-17','11:30:00',3.72),('12664','2013-08-17','11:35:00',3.72),('12664','2013-08-17','11:40:00',3.74),('12664','2013-08-17','11:45:00',3.76),('12664','2013-08-17','11:50:00',3.76),('12664','2013-08-17','11:55:00',3.78),('12664','2013-08-17','12:00:00',3.79),('12664','2013-08-17','12:05:00',3.72),('12664','2013-08-17','12:10:00',3.85),('12664','2013-08-17','12:15:00',3.9),('12664','2013-08-17','12:20:00',3.91),('12664','2013-08-17','12:25:00',3.91),('12664','2013-08-17','12:30:00',3.88),('12664','2013-08-17','12:35:00',3.95),('12664','2013-08-17','12:40:00',3.97),('12664','2013-08-17','12:45:00',3.98),('12664','2013-08-17','12:50:00',3.88),('12664','2013-08-17','12:55:00',3.95),('12664','2013-08-17','13:00:00',3.97),('12664','2013-08-17','13:05:00',3.95),('12664','2013-08-17','13:10:00',4.03),('12664','2013-08-17','13:15:00',4.03),('12664','2013-08-17','13:20:00',3.59),('12664','2013-08-17','13:25:00',3.97),('12664','2013-08-17','13:30:00',4.06),('12664','2013-08-17','13:35:00',3.81),('12664','2013-08-17','13:40:00',4.01),('12664','2013-08-17','13:45:00',4.02),('12664','2013-08-17','13:50:00',3.98),('12664','2013-08-17','13:55:00',3.96),('12664','2013-08-17','14:00:00',3.96),('12664','2013-08-17','14:05:00',3.93),('12664','2013-08-17','14:10:00',3.93),('12664','2013-08-17','14:15:00',3.94),('12664','2013-08-17','14:20:00',3.92),('12664','2013-08-17','14:25:00',3.9),('12664','2013-08-17','14:30:00',3.87),('12664','2013-08-17','14:35:00',3.83),('12664','2013-08-17','14:40:00',3.8),('12664','2013-08-17','14:45:00',3.78),('12664','2013-08-17','14:50:00',3.73),('12664','2013-08-17','14:55:00',3.71),('12664','2013-08-17','15:00:00',3.72),('12664','2013-08-17','15:05:00',3.68),('12664','2013-08-17','15:10:00',3.64),('12664','2013-08-17','15:15:00',3.6),('12664','2013-08-17','15:20:00',3.56),('12664','2013-08-17','15:25:00',3.52),('12664','2013-08-17','15:30:00',3.47),('12664','2013-08-17','15:35:00',3.42),('12664','2013-08-17','15:40:00',3.38),('12664','2013-08-17','15:45:00',3.33),('12664','2013-08-17','15:50:00',3.27),('12664','2013-08-17','15:55:00',3.21),('12664','2013-08-17','16:00:00',3.16),('12664','2013-08-17','16:05:00',3.09),('12664','2013-08-17','16:10:00',3.04),('12664','2013-08-17','16:15:00',2.98),('12664','2013-08-17','16:20:00',2.93),('12664','2013-08-17','16:25:00',2.87),('12664','2013-08-17','16:30:00',2.79),('12664','2013-08-17','16:35:00',2.74),('12664','2013-08-17','16:40:00',2.66),('12664','2013-08-17','16:45:00',2.58),('12664','2013-08-17','16:50:00',2.49),('12664','2013-08-17','16:55:00',2.44),('12664','2013-08-17','17:00:00',2.31),('12664','2013-08-17','17:05:00',2.26),('12664','2013-08-17','17:10:00',2.17),('12664','2013-08-17','17:15:00',2.08),('12664','2013-08-17','17:20:00',2.05),('12664','2013-08-17','17:25:00',1.95),('12664','2013-08-17','17:30:00',1.86),('12664','2013-08-17','17:35:00',1.77),('12664','2013-08-17','17:40:00',1.7),('12664','2013-08-17','17:45:00',1.59),('12664','2013-08-17','17:50:00',1.5),('12664','2013-08-17','17:55:00',1.4),('12664','2013-08-17','18:00:00',1.32),('12664','2013-08-17','18:05:00',1.21),('12664','2013-08-17','18:10:00',1.12),('12664','2013-08-17','18:15:00',1.03),('12664','2013-08-16','08:05:00',1.06),('12664','2013-08-16','08:10:00',1.15),('12664','2013-08-16','08:15:00',1.24),('12664','2013-08-16','08:20:00',1.33),('12664','2013-08-16','08:25:00',1.42),('12664','2013-08-16','08:30:00',1.51),('12664','2013-08-16','08:35:00',1.6),('12664','2013-08-16','08:40:00',1.69),('12664','2013-08-16','08:45:00',1.78),('12664','2013-08-16','08:50:00',1.87),('12664','2013-08-16','08:55:00',1.96),('12664','2013-08-16','09:00:00',2.04),('12664','2013-08-16','09:05:00',2.13),('12664','2013-08-16','09:10:00',2.22),('12664','2013-08-16','09:15:00',2.3),('12664','2013-08-16','09:20:00',2.38),('12664','2013-08-16','09:25:00',2.46),('12664','2013-08-16','09:30:00',2.53),('12664','2013-08-16','09:35:00',2.61),('12664','2013-08-16','09:40:00',2.68),('12664','2013-08-16','09:45:00',2.74),('12664','2013-08-16','09:50:00',2.81),('12664','2013-08-16','09:55:00',2.89),('12664','2013-08-16','10:00:00',2.96),('12664','2013-08-16','10:05:00',3.02),('12664','2013-08-16','10:10:00',3.08),('12664','2013-08-16','10:15:00',3.15),('12664','2013-08-16','10:20:00',3.21),('12664','2013-08-16','10:25:00',3.26),('12664','2013-08-16','10:30:00',3.32),('12664','2013-08-16','10:35:00',3.38),('12664','2013-08-16','10:40:00',3.43),('12664','2013-08-16','10:45:00',3.49),('12664','2013-08-16','10:50:00',3.53),('12664','2013-08-16','10:55:00',3.59),('12664','2013-08-16','11:00:00',3.6),('12664','2013-08-16','11:05:00',3.64),('12664','2013-08-16','11:10:00',3.67),('12664','2013-08-16','11:15:00',3.7),('12664','2013-08-16','11:20:00',3.72),('12664','2013-08-16','11:25:00',3.76),('12664','2013-08-16','11:30:00',3.79),('12664','2013-08-16','11:35:00',3.81),('12664','2013-08-16','11:40:00',3.84),('12664','2013-08-16','11:45:00',3.88),('12664','2013-08-16','11:50:00',3.89),('12664','2013-08-16','11:55:00',3.9),('12664','2013-08-16','12:00:00',3.93),('12664','2013-08-16','12:05:00',3.96),('12664','2013-08-16','12:10:00',3.97),('12664','2013-08-16','12:15:00',3.99),('12664','2013-08-16','12:20:00',4.01),('12664','2013-08-16','12:25:00',4.02),('12664','2013-08-16','12:30:00',4.01),('12664','2013-08-16','12:35:00',4.01),('12664','2013-08-16','12:40:00',4.01),('12664','2013-08-16','12:45:00',4.02),('12664','2013-08-16','12:50:00',4.01),('12664','2013-08-16','12:55:00',4.02),('12664','2013-08-16','13:00:00',4.02),('12664','2013-08-16','13:05:00',4),('12664','2013-08-16','13:10:00',4),('12664','2013-08-16','13:15:00',4),('12664','2013-08-16','13:20:00',4.01),('12664','2013-08-16','13:25:00',3.99),('12664','2013-08-16','13:30:00',3.96),('12664','2013-08-16','13:35:00',3.96),('12664','2013-08-16','13:40:00',3.97),('12664','2013-08-16','13:45:00',3.95),('12664','2013-08-16','13:50:00',3.94),('12664','2013-08-16','13:55:00',3.92),('12664','2013-08-16','14:00:00',3.91),('12664','2013-08-16','14:05:00',3.89),('12664','2013-08-16','14:10:00',3.88),('12664','2013-08-16','14:15:00',3.86),('12664','2013-08-16','14:20:00',3.82),('12664','2013-08-16','14:25:00',3.82),('12664','2013-08-16','14:30:00',3.8),('12664','2013-08-16','14:35:00',3.76),('12664','2013-08-16','14:40:00',3.7),('12664','2013-08-16','14:45:00',3.61),('12664','2013-08-16','14:50:00',3.65),('12664','2013-08-16','14:55:00',3.68),('12664','2013-08-16','15:00:00',3.68),('12664','2013-08-16','15:05:00',3.67),('12664','2013-08-16','15:10:00',3.62),('12664','2013-08-16','15:15:00',3.59),('12664','2013-08-16','15:20:00',3.56),('12664','2013-08-16','15:25:00',3.51),('12664','2013-08-16','15:30:00',3.47),('12664','2013-08-16','15:35:00',3.42),('12664','2013-08-16','15:40:00',3.36),('12664','2013-08-16','15:45:00',3.31),('12664','2013-08-16','15:50:00',3.24),('12664','2013-08-16','15:55:00',3.2),('12664','2013-08-16','16:00:00',3.14),('12664','2013-08-16','16:05:00',3.07),('12664','2013-08-16','16:10:00',3.01),('12664','2013-08-16','16:15:00',2.96),('12664','2013-08-16','16:20:00',2.89),('12664','2013-08-16','16:25:00',2.82),('12664','2013-08-16','16:30:00',2.76),('12664','2013-08-16','16:35:00',2.69),('12664','2013-08-16','16:40:00',2.63),('12664','2013-08-16','16:45:00',2.56),('12664','2013-08-16','16:50:00',2.47),('12664','2013-08-16','16:55:00',2.4),('12664','2013-08-16','17:00:00',2.31),('12664','2013-08-16','17:05:00',2.23),('12664','2013-08-16','17:10:00',2.14),('12664','2013-08-16','17:15:00',2.06),('12664','2013-08-16','17:20:00',1.93),('12664','2013-08-16','17:25:00',1.88),('12664','2013-08-16','17:30:00',1.8),('12664','2013-08-16','17:35:00',1.72),('12664','2013-08-16','17:40:00',1.63),('12664','2013-08-16','17:45:00',1.54),('12664','2013-08-16','17:50:00',1.45),('12664','2013-08-16','17:55:00',1.36),('12664','2013-08-16','18:00:00',1.28),('12664','2013-08-16','18:05:00',1.19),('12664','2013-08-16','18:10:00',1.1),('12664','2013-08-16','18:15:00',1.02),('12664','2013-08-15','08:10:00',1.29),('12664','2013-08-15','08:15:00',1.56),('12664','2013-08-15','08:20:00',1.05),('12664','2013-08-15','08:25:00',1.35),('12664','2013-08-15','08:30:00',1.65),('12664','2013-08-15','08:35:00',1.69),('12664','2013-08-15','08:40:00',1.28),('12664','2013-08-15','08:45:00',1.25),('12664','2013-08-15','08:50:00',1.84),('12664','2013-08-15','08:55:00',1.98),('12664','2013-08-15','09:00:00',2.07),('12664','2013-08-15','09:05:00',2.16),('12664','2013-08-15','09:10:00',2.26),('12664','2013-08-15','09:15:00',2.33),('12664','2013-08-15','09:20:00',2.41),('12664','2013-08-15','09:25:00',2.46),('12664','2013-08-15','09:30:00',2.54),('12664','2013-08-15','09:35:00',2.63),('12664','2013-08-15','09:40:00',2.72),('12664','2013-08-15','09:45:00',2.8),('12664','2013-08-15','09:50:00',2.86),('12664','2013-08-15','09:55:00',2.92),('12664','2013-08-15','10:00:00',2.99),('12664','2013-08-15','10:05:00',3.06),('12664','2013-08-15','10:10:00',3.1),('12664','2013-08-15','10:15:00',3.14),('12664','2013-08-15','10:20:00',3.19),('12664','2013-08-15','10:25:00',3.25),('12664','2013-08-15','10:30:00',3.31),('12664','2013-08-15','10:35:00',3.37),('12664','2013-08-15','10:40:00',3.42),('12664','2013-08-15','10:45:00',3.47),('12664','2013-08-15','10:50:00',3.53),('12664','2013-08-15','10:55:00',3.6),('12664','2013-08-15','11:00:00',3.67),('12664','2013-08-15','11:05:00',3.72),('12664','2013-08-15','11:10:00',3.77),('12664','2013-08-15','11:15:00',3.83),('12664','2013-08-15','11:20:00',3.89),('12664','2013-08-15','11:25:00',3.95),('12664','2013-08-15','11:30:00',3.82),('12664','2013-08-15','11:35:00',3.4),('12664','2013-08-15','11:40:00',3.59),('12664','2013-08-15','11:45:00',3.6),('12664','2013-08-15','11:50:00',3.86),('12664','2013-08-15','11:55:00',3.11),('12664','2013-08-15','12:00:00',2.78),('12664','2013-08-15','12:05:00',3.19),('12664','2013-08-15','12:10:00',3.36),('12664','2013-08-15','12:15:00',3.75),('12664','2013-08-15','12:20:00',4.01),('12664','2013-08-15','12:25:00',4.04),('12664','2013-08-15','12:30:00',4),('12664','2013-08-15','12:35:00',4.06),('12664','2013-08-15','12:40:00',4.13),('12664','2013-08-15','12:45:00',4.17),('12664','2013-08-15','12:50:00',4.11),('12664','2013-08-15','12:55:00',3.94),('12664','2013-08-15','13:00:00',3.69),('12664','2013-08-15','13:05:00',3.72),('12664','2013-08-15','13:10:00',3.84),('12664','2013-08-15','13:15:00',3.79),('12664','2013-08-15','13:20:00',3.85),('12664','2013-08-15','13:25:00',3.86),('12664','2013-08-15','13:30:00',3.87),('12664','2013-08-15','13:35:00',3.73),('12664','2013-08-15','13:40:00',3.74),('12664','2013-08-15','13:45:00',3.96),('12664','2013-08-15','13:50:00',4.02),('12664','2013-08-15','13:55:00',3.86),('12664','2013-08-15','14:00:00',3.68),('12664','2013-08-15','14:05:00',3.65),('12664','2013-08-15','14:10:00',3.43),('12664','2013-08-15','14:15:00',3.73),('12664','2013-08-15','14:20:00',3.54),('12664','2013-08-15','14:25:00',3.8),('12664','2013-08-15','14:30:00',3.77),('12664','2013-08-15','14:35:00',3.68),('12664','2013-08-15','14:40:00',3.74),('12664','2013-08-15','14:45:00',3.69),('12664','2013-08-15','14:50:00',3.59),('12664','2013-08-15','14:55:00',3.52),('12664','2013-08-15','15:00:00',3.31),('12664','2013-08-15','15:05:00',3.5),('12664','2013-08-15','15:10:00',3.36),('12664','2013-08-15','15:15:00',3.38),('12664','2013-08-15','15:20:00',3.39),('12664','2013-08-15','15:25:00',3.4),('12664','2013-08-15','15:30:00',3.35),('12664','2013-08-15','15:35:00',3.34),('12664','2013-08-15','15:40:00',3.2),('12664','2013-08-15','15:45:00',3.09),('12664','2013-08-15','15:50:00',3.11),('12664','2013-08-15','15:55:00',3.1),('12664','2013-08-15','16:00:00',2.99),('12664','2013-08-15','16:05:00',2.99),('12664','2013-08-15','16:10:00',2.93),('12664','2013-08-15','16:15:00',2.88),('12664','2013-08-15','16:20:00',2.81),('12664','2013-08-15','16:25:00',2.78),('12664','2013-08-15','16:30:00',2.72),('12664','2013-08-15','16:35:00',2.65),('12664','2013-08-15','16:40:00',2.6),('12664','2013-08-15','16:45:00',2.51),('12664','2013-08-15','16:50:00',2.41),('12664','2013-08-15','16:55:00',2.35),('12664','2013-08-15','17:00:00',2.25),('12664','2013-08-15','17:05:00',2.17),('12664','2013-08-15','17:10:00',2.1),('12664','2013-08-15','17:15:00',2.03),('12664','2013-08-15','17:20:00',1.94),('12664','2013-08-15','17:25:00',1.85),('12664','2013-08-15','17:30:00',1.76),('12664','2013-08-15','17:35:00',1.66),('12664','2013-08-15','17:40:00',1.6),('12664','2013-08-15','17:45:00',1.51),('12664','2013-08-15','17:50:00',1.44),('12664','2013-08-15','17:55:00',1.34),('12664','2013-08-15','18:00:00',1.25),('12664','2013-08-15','18:05:00',1.13),('12664','2013-08-15','18:10:00',1.04),('12664','2013-08-14','08:05:00',1.04),('12664','2013-08-14','08:10:00',1.12),('12664','2013-08-14','08:15:00',1.17),('12664','2013-08-14','08:20:00',1.3),('12664','2013-08-14','08:25:00',1.22),('12664','2013-08-14','08:30:00',1.22),('12664','2013-08-14','08:35:00',1.61),('12664','2013-08-14','08:40:00',1.64),('12664','2013-08-14','08:45:00',1.74),('12664','2013-08-14','08:50:00',1.83),('12664','2013-08-14','08:55:00',1.84),('12664','2013-08-14','09:00:00',2.02),('12664','2013-08-14','09:05:00',1.6),('12664','2013-08-14','09:10:00',1.18),('12664','2013-08-14','09:15:00',1.03),('12664','2013-08-14','09:30:00',1.36),('12664','2013-08-14','09:35:00',2.62),('12664','2013-08-14','09:40:00',3.01),('12664','2013-08-14','09:45:00',2.06),('12664','2013-08-14','09:50:00',1.9),('12664','2013-08-14','09:55:00',1.88),('12664','2013-08-14','10:00:00',1.53),('12664','2013-08-14','10:10:00',1.11),('12664','2013-08-14','10:15:00',3.14),('12664','2013-08-14','10:20:00',3.61),('12664','2013-08-14','10:25:00',3.59),('12664','2013-08-14','10:30:00',2.3),('12664','2013-08-14','10:35:00',1.12),('12664','2013-08-14','10:40:00',1.11),('12664','2013-08-14','10:45:00',1.09),('12664','2013-08-14','10:50:00',2.09),('12664','2013-08-14','10:55:00',3.75),('12664','2013-08-14','11:00:00',3.77),('12664','2013-08-14','11:05:00',3.87),('12664','2013-08-14','11:10:00',2.77),('12664','2013-08-14','11:15:00',1.29),('12664','2013-08-14','11:20:00',1.04),('12664','2013-08-14','11:25:00',1.11),('12664','2013-08-14','11:30:00',1.39),('12664','2013-08-14','11:35:00',3.37),('12664','2013-08-14','11:40:00',3.68),('12664','2013-08-14','11:45:00',2.44),('12664','2013-08-14','11:50:00',3.3),('12664','2013-08-14','11:55:00',2.57),('12664','2013-08-14','12:00:00',3.7),('12664','2013-08-14','12:05:00',3.91),('12664','2013-08-14','12:10:00',2.99),('12664','2013-08-14','12:15:00',4.44),('12664','2013-08-14','12:20:00',4.36),('12664','2013-08-14','12:25:00',4.09),('12664','2013-08-14','12:30:00',4.35),('12664','2013-08-14','12:35:00',3.88),('12664','2013-08-14','12:40:00',3.68),('12664','2013-08-14','12:45:00',3.32),('12664','2013-08-14','12:50:00',3.25),('12664','2013-08-14','12:55:00',3.23),('12664','2013-08-14','13:00:00',3.46),('12664','2013-08-14','13:05:00',3.76),('12664','2013-08-14','13:10:00',3.71),('12664','2013-08-14','13:15:00',3.94),('12664','2013-08-14','13:20:00',3.61),('12664','2013-08-14','13:25:00',4.18),('12664','2013-08-14','13:30:00',4.23),('12664','2013-08-14','13:35:00',4.03),('12664','2013-08-14','13:40:00',4.17),('12664','2013-08-14','13:45:00',4.12),('12664','2013-08-14','13:50:00',4.14),('12664','2013-08-14','13:55:00',4.11),('12664','2013-08-14','14:00:00',4.07),('12664','2013-08-14','14:05:00',4.1),('12664','2013-08-14','14:10:00',3.97),('12664','2013-08-14','14:15:00',3.96),('12664','2013-08-14','14:20:00',3.98),('12664','2013-08-14','14:25:00',3.87),('12664','2013-08-14','14:30:00',3.87),('12664','2013-08-14','14:35:00',3.87),('12664','2013-08-14','14:40:00',3.84),('12664','2013-08-14','14:45:00',3.78),('12664','2013-08-14','14:50:00',3.77),('12664','2013-08-14','14:55:00',3.75),('12664','2013-08-14','15:00:00',3.72),('12664','2013-08-14','15:05:00',3.68),('12664','2013-08-14','15:10:00',3.64),('12664','2013-08-14','15:15:00',3.62),('12664','2013-08-14','15:20:00',3.58),('12664','2013-08-14','15:25:00',3.52),('12664','2013-08-14','15:30:00',3.52),('12664','2013-08-14','15:35:00',3.46),('12664','2013-08-14','15:40:00',3.4),('12664','2013-08-14','15:45:00',3.33),('12664','2013-08-14','15:50:00',3.27),('12664','2013-08-14','15:55:00',3.2),('12664','2013-08-14','16:00:00',3.17),('12664','2013-08-14','16:05:00',3.1),('12664','2013-08-14','16:10:00',3.03),('12664','2013-08-14','16:15:00',2.99),('12664','2013-08-14','16:20:00',2.95),('12664','2013-08-14','16:25:00',2.87),('12664','2013-08-14','16:30:00',2.78),('12664','2013-08-14','16:35:00',2.72),('12664','2013-08-14','16:40:00',2.66),('12664','2013-08-14','16:45:00',2.6),('12664','2013-08-14','16:50:00',2.51),('12664','2013-08-14','16:55:00',2.43),('12664','2013-08-14','17:00:00',2.34),('12664','2013-08-14','17:05:00',2.27),('12664','2013-08-14','17:10:00',2.19),('12664','2013-08-14','17:15:00',2.09),('12664','2013-08-14','17:20:00',2.01),('12664','2013-08-14','17:25:00',1.91),('12664','2013-08-14','17:30:00',1.83),('12664','2013-08-14','17:35:00',1.76),('12664','2013-08-14','17:40:00',1.67),('12664','2013-08-14','17:45:00',1.57),('12664','2013-08-14','17:50:00',1.48),('12664','2013-08-14','17:55:00',1.4),('12664','2013-08-14','18:00:00',1.32),('12664','2013-08-14','18:05:00',1.22),('12664','2013-08-14','18:10:00',1.11),('12664','2013-08-14','18:15:00',1.03),('12664','2013-08-13','08:05:00',1.05),('12664','2013-08-13','08:10:00',1.16),('12664','2013-08-13','08:15:00',1.26),('12664','2013-08-13','08:20:00',1.36),('12664','2013-08-13','08:25:00',1.44),('12664','2013-08-13','08:30:00',1.53),('12664','2013-08-13','08:35:00',1.63),('12664','2013-08-13','08:40:00',1.71),('12664','2013-08-13','08:45:00',1.8),('12664','2013-08-13','08:50:00',1.89),('12664','2013-08-13','08:55:00',1.98),('12664','2013-08-13','09:00:00',2.06),('12664','2013-08-13','09:05:00',2.14),('12664','2013-08-13','09:10:00',2.21),('12664','2013-08-13','09:15:00',2.26),('12664','2013-08-13','09:20:00',2.39),('12664','2013-08-13','09:25:00',2.45),('12664','2013-08-13','09:30:00',2.53),('12664','2013-08-13','09:35:00',2.53),('12664','2013-08-13','09:40:00',2.62),('12664','2013-08-13','09:45:00',2.77),('12664','2013-08-13','09:50:00',2.57),('12664','2013-08-13','09:55:00',2.24),('12664','2013-08-13','10:00:00',3.16),('12664','2013-08-13','10:05:00',3.3),('12664','2013-08-13','10:10:00',3.32),('12664','2013-08-13','10:15:00',3.39),('12664','2013-08-13','10:20:00',3.49),('12664','2013-08-13','10:25:00',1.65),('12664','2013-08-13','10:30:00',1.59),('12664','2013-08-13','10:35:00',3.56),('12664','2013-08-13','10:40:00',3.6),('12664','2013-08-13','10:45:00',3.59),('12664','2013-08-13','10:50:00',2.59),('12664','2013-08-13','10:55:00',1.87),('12664','2013-08-13','11:00:00',3.56),('12664','2013-08-13','11:05:00',3.69),('12664','2013-08-13','11:10:00',3.71),('12664','2013-08-13','11:15:00',3.69),('12664','2013-08-13','11:20:00',3.71),('12664','2013-08-13','11:25:00',3.76),('12664','2013-08-13','11:30:00',3.72),('12664','2013-08-13','11:35:00',3.69),('12664','2013-08-13','11:40:00',3.69),('12664','2013-08-13','11:45:00',3.81),('12664','2013-08-13','11:50:00',3.91),('12664','2013-08-13','11:55:00',4.09),('12664','2013-08-13','12:00:00',4.18),('12664','2013-08-13','12:05:00',3.56),('12664','2013-08-13','12:10:00',4.23),('12664','2013-08-13','12:15:00',4.18),('12664','2013-08-13','12:20:00',4.1),('12664','2013-08-13','12:25:00',3.83),('12664','2013-08-13','12:30:00',4.26),('12664','2013-08-13','12:35:00',2.16),('12664','2013-08-13','12:40:00',1.04),('12664','2013-08-13','12:45:00',2.42),('12664','2013-08-13','12:50:00',3.95),('12664','2013-08-13','12:55:00',4.29),('12664','2013-08-13','13:00:00',4.13),('12664','2013-08-13','13:05:00',4.18),('12664','2013-08-13','13:10:00',4.12),('12664','2013-08-13','13:15:00',4.14),('12664','2013-08-13','13:20:00',4.06),('12664','2013-08-13','13:25:00',4.05),('12664','2013-08-13','13:30:00',4.05),('12664','2013-08-13','13:35:00',3.93),('12664','2013-08-13','13:40:00',3.83),('12664','2013-08-13','13:45:00',3.79),('12664','2013-08-13','13:50:00',3.96),('12664','2013-08-13','13:55:00',3.94),('12664','2013-08-13','14:00:00',3.88),('12664','2013-08-13','14:05:00',3.92),('12664','2013-08-13','14:10:00',3.99),('12664','2013-08-13','14:15:00',3.91),('12664','2013-08-13','14:20:00',3.88),('12664','2013-08-13','14:25:00',3.9),('12664','2013-08-13','14:30:00',3.9),('12664','2013-08-13','14:35:00',3.86),('12664','2013-08-13','14:40:00',3.82),('12664','2013-08-13','14:45:00',3.84),('12664','2013-08-13','14:50:00',3.79),('12664','2013-08-13','14:55:00',3.77),('12664','2013-08-13','15:00:00',3.74),('12664','2013-08-13','15:05:00',3.69),('12664','2013-08-13','15:10:00',3.65),('12664','2013-08-13','15:15:00',3.62),('12664','2013-08-13','15:20:00',3.58),('12664','2013-08-13','15:25:00',3.56),('12664','2013-08-13','15:30:00',3.49),('12664','2013-08-13','15:35:00',3.42),('12664','2013-08-13','15:40:00',3.4),('12664','2013-08-13','15:45:00',3.33),('12664','2013-08-13','15:50:00',3.31),('12664','2013-08-13','15:55:00',3.24),('12664','2013-08-13','16:00:00',3.18),('12664','2013-08-13','16:05:00',3.15),('12664','2013-08-13','16:10:00',3.06),('12664','2013-08-13','16:15:00',2.96),('12664','2013-08-13','16:20:00',2.89),('12664','2013-08-13','16:25:00',2.86),('12664','2013-08-13','16:30:00',2.8),('12664','2013-08-13','16:35:00',2.72),('12664','2013-08-13','16:40:00',2.63),('12664','2013-08-13','16:45:00',2.58),('12664','2013-08-13','16:50:00',2.52),('12664','2013-08-13','16:55:00',2.45),('12664','2013-08-13','17:00:00',2.37),('12664','2013-08-13','17:05:00',2.29),('12664','2013-08-13','17:10:00',2.22),('12664','2013-08-13','17:15:00',2.13),('12664','2013-08-13','17:20:00',2.03),('12664','2013-08-13','17:25:00',1.93),('12664','2013-08-13','17:30:00',1.85),('12664','2013-08-13','17:35:00',1.76),('12664','2013-08-13','17:40:00',1.67),('12664','2013-08-13','17:45:00',1.58),('12664','2013-08-13','17:50:00',1.49),('12664','2013-08-13','17:55:00',1.4),('12664','2013-08-13','18:00:00',1.31),('12664','2013-08-13','18:05:00',1.22),('12664','2013-08-13','18:10:00',1.13),('12664','2013-08-13','18:15:00',1.05),('12664','2013-08-12','08:05:00',1.08),('12664','2013-08-12','08:10:00',1.16),('12664','2013-08-12','08:15:00',1.25),('12664','2013-08-12','08:20:00',1.34),('12664','2013-08-12','08:25:00',1.42),('12664','2013-08-12','08:30:00',1.51),('12664','2013-08-12','08:35:00',1.6),('12664','2013-08-12','08:40:00',1.68),('12664','2013-08-12','08:45:00',1.77),('12664','2013-08-12','08:50:00',1.85),('12664','2013-08-12','08:55:00',1.93),('12664','2013-08-12','09:00:00',2.02),('12664','2013-08-12','09:05:00',2.1),('12664','2013-08-12','09:10:00',2.19),('12664','2013-08-12','09:15:00',2.25),('12664','2013-08-12','09:20:00',2.33),('12664','2013-08-12','09:25:00',2.41),('12664','2013-08-12','09:30:00',2.48),('12664','2013-08-12','09:35:00',2.56),('12664','2013-08-12','09:40:00',2.63),('12664','2013-08-12','09:45:00',2.69),('12664','2013-08-12','09:50:00',2.74),('12664','2013-08-12','09:55:00',2.8),('12664','2013-08-12','10:00:00',2.86),('12664','2013-08-12','10:05:00',2.91),('12664','2013-08-12','10:10:00',2.97),('12664','2013-08-12','10:15:00',3.02),('12664','2013-08-12','10:20:00',3.09),('12664','2013-08-12','10:25:00',3.13),('12664','2013-08-12','10:30:00',3.21),('12664','2013-08-12','10:35:00',3.26),('12664','2013-08-12','10:40:00',3.3),('12664','2013-08-12','10:45:00',3.32),('12664','2013-08-12','10:50:00',3.39),('12664','2013-08-12','10:55:00',3.39),('12664','2013-08-12','11:00:00',3.46),('12664','2013-08-12','11:05:00',3.48),('12664','2013-08-12','11:10:00',3.54),('12664','2013-08-12','11:15:00',3.56),('12664','2013-08-12','11:20:00',3.23),('12664','2013-08-12','11:25:00',3.38),('12664','2013-08-12','11:30:00',3.88),('12664','2013-08-12','11:35:00',3.89),('12664','2013-08-12','11:40:00',3.59),('12664','2013-08-12','11:45:00',3.41),('12664','2013-08-12','11:50:00',3.45),('12664','2013-08-12','11:55:00',4.08),('12664','2013-08-12','12:00:00',3.22),('12664','2013-08-12','12:05:00',4.18),('12664','2013-08-12','12:10:00',4.23),('12664','2013-08-12','12:15:00',4.05),('12664','2013-08-12','12:20:00',1.53),('12664','2013-08-12','12:25:00',2.79),('12664','2013-08-12','12:30:00',4.29),('12664','2013-08-12','12:35:00',1.78),('12664','2013-08-12','12:40:00',4.31),('12664','2013-08-12','12:45:00',4.4),('12664','2013-08-12','12:50:00',2.02),('12664','2013-08-12','12:55:00',1.3),('12664','2013-08-12','13:00:00',1.65),('12664','2013-08-12','13:05:00',2.31),('12664','2013-08-12','13:10:00',4.73),('12664','2013-08-12','13:15:00',2),('12664','2013-08-12','13:20:00',2.79),('12664','2013-08-12','13:25:00',4.25),('12664','2013-08-12','13:30:00',4.35),('12664','2013-08-12','13:35:00',2.96),('12664','2013-08-12','13:40:00',3.73),('12664','2013-08-12','13:45:00',3.81),('12664','2013-08-12','13:50:00',4.55),('12664','2013-08-12','13:55:00',4.35),('12664','2013-08-12','14:00:00',2.61),('12664','2013-08-12','14:05:00',2.28),('12664','2013-08-12','14:10:00',2.78),('12664','2013-08-12','14:15:00',4),('12664','2013-08-12','14:20:00',3.84),('12664','2013-08-12','14:25:00',3.58),('12664','2013-08-12','14:30:00',3.41),('12664','2013-08-12','14:35:00',4.04),('12664','2013-08-12','14:40:00',3.73),('12664','2013-08-12','14:45:00',3.8),('12664','2013-08-12','14:50:00',3.79),('12664','2013-08-12','14:55:00',3.78),('12664','2013-08-12','15:00:00',3.75),('12664','2013-08-12','15:05:00',3.73),('12664','2013-08-12','15:10:00',3.69),('12664','2013-08-12','15:15:00',3.6),('12664','2013-08-12','15:20:00',3.35),('12664','2013-08-12','15:25:00',3.47),('12664','2013-08-12','15:30:00',3.05),('12664','2013-08-12','15:35:00',3.42),('12664','2013-08-12','15:40:00',3.35),('12664','2013-08-12','15:45:00',3.35),('12664','2013-08-12','15:50:00',3.27),('12664','2013-08-12','15:55:00',3.2),('12664','2013-08-12','16:00:00',3.18),('12664','2013-08-12','16:05:00',3.12),('12664','2013-08-12','16:10:00',3.03),('12664','2013-08-12','16:15:00',3),('12664','2013-08-12','16:20:00',2.9),('12664','2013-08-12','16:25:00',2.86),('12664','2013-08-12','16:30:00',2.77),('12664','2013-08-12','16:35:00',2.74),('12664','2013-08-12','16:40:00',2.68),('12664','2013-08-12','16:45:00',2.6),('12664','2013-08-12','16:50:00',2.51),('12664','2013-08-12','16:55:00',2.44),('12664','2013-08-12','17:00:00',2.32),('12664','2013-08-12','17:05:00',2.27),('12664','2013-08-12','17:10:00',2.16),('12664','2013-08-12','17:15:00',2.11),('12664','2013-08-12','17:20:00',2.01),('12664','2013-08-12','17:25:00',1.94),('12664','2013-08-12','17:30:00',1.87),('12664','2013-08-12','17:35:00',1.78),('12664','2013-08-12','17:40:00',1.69),('12664','2013-08-12','17:45:00',1.6),('12664','2013-08-12','17:50:00',1.51),('12664','2013-08-12','17:55:00',1.43),('12664','2013-08-12','18:00:00',1.33),('12664','2013-08-12','18:05:00',1.25),('12664','2013-08-12','18:10:00',1.17),('12664','2013-08-12','18:15:00',1.08),('12664','2013-08-11','08:00:00',1.02),('12664','2013-08-11','08:05:00',1.11),('12664','2013-08-11','08:10:00',1.2),('12664','2013-08-11','08:15:00',1.29),('12664','2013-08-11','08:20:00',1.38),('12664','2013-08-11','08:25:00',1.47),('12664','2013-08-11','08:30:00',1.55),('12664','2013-08-11','08:35:00',1.64),('12664','2013-08-11','08:40:00',1.73),('12664','2013-08-11','08:45:00',1.82),('12664','2013-08-11','08:50:00',1.91),('12664','2013-08-11','08:55:00',2),('12664','2013-08-11','09:00:00',2.07),('12664','2013-08-11','09:05:00',2.17),('12664','2013-08-11','09:10:00',2.25),('12664','2013-08-11','09:15:00',2.32),('12664','2013-08-11','09:20:00',2.4),('12664','2013-08-11','09:25:00',2.48),('12664','2013-08-11','09:30:00',2.55),('12664','2013-08-11','09:35:00',2.63),('12664','2013-08-11','09:40:00',2.68),('12664','2013-08-11','09:45:00',2.76),('12664','2013-08-11','09:50:00',2.83),('12664','2013-08-11','09:55:00',2.9),('12664','2013-08-11','10:00:00',2.96),('12664','2013-08-11','10:05:00',3.02),('12664','2013-08-11','10:10:00',3.08),('12664','2013-08-11','10:15:00',3.13),('12664','2013-08-11','10:20:00',3.19),('12664','2013-08-11','10:25:00',3.25),('12664','2013-08-11','10:30:00',3.31),('12664','2013-08-11','10:35:00',3.37),('12664','2013-08-11','10:40:00',3.4),('12664','2013-08-11','10:45:00',3.47),('12664','2013-08-11','10:50:00',3.49),('12664','2013-08-11','10:55:00',3.53),('12664','2013-08-11','11:00:00',3.55),('12664','2013-08-11','11:05:00',3.62),('12664','2013-08-11','11:10:00',3.66),('12664','2013-08-11','11:15:00',3.68),('12664','2013-08-11','11:20:00',3.72),('12664','2013-08-11','11:25:00',3.76),('12664','2013-08-11','11:30:00',3.8),('12664','2013-08-11','11:35:00',3.82),('12664','2013-08-11','11:40:00',3.83),('12664','2013-08-11','11:45:00',3.83),('12664','2013-08-11','11:50:00',3.84),('12664','2013-08-11','11:55:00',3.88),('12664','2013-08-11','12:00:00',3.9),('12664','2013-08-11','12:05:00',3.91),('12664','2013-08-11','12:10:00',3.95),('12664','2013-08-11','12:15:00',3.97),('12664','2013-08-11','12:20:00',3.98),('12664','2013-08-11','12:25:00',3.99),('12664','2013-08-11','12:30:00',4),('12664','2013-08-11','12:35:00',4),('12664','2013-08-11','12:40:00',4),('12664','2013-08-11','12:45:00',4.03),('12664','2013-08-11','12:50:00',4.02),('12664','2013-08-11','12:55:00',4.03),('12664','2013-08-11','13:00:00',4.04),('12664','2013-08-11','13:05:00',4.05),('12664','2013-08-11','13:10:00',4),('12664','2013-08-11','13:15:00',4.01),('12664','2013-08-11','13:20:00',3.96),('12664','2013-08-11','13:25:00',3.99),('12664','2013-08-11','13:30:00',3.99),('12664','2013-08-11','13:35:00',3.96),('12664','2013-08-11','13:40:00',3.96),('12664','2013-08-11','13:45:00',3.94),('12664','2013-08-11','13:50:00',3.91),('12664','2013-08-11','13:55:00',3.89),('12664','2013-08-11','14:00:00',3.91),('12664','2013-08-11','14:05:00',3.92),('12664','2013-08-11','14:10:00',3.87),('12664','2013-08-11','14:15:00',3.83),('12664','2013-08-11','14:20:00',3.85),('12664','2013-08-11','14:25:00',3.85),('12664','2013-08-11','14:30:00',3.83),('12664','2013-08-11','14:35:00',3.79),('12664','2013-08-11','14:40:00',3.76),('12664','2013-08-11','14:45:00',3.73),('12664','2013-08-11','14:50:00',3.71),('12664','2013-08-11','14:55:00',3.67),('12664','2013-08-11','15:00:00',3.63),('12664','2013-08-11','15:05:00',3.55),('12664','2013-08-11','15:10:00',3.52),('12664','2013-08-11','15:15:00',3.5),('12664','2013-08-11','15:20:00',3.51),('12664','2013-08-11','15:25:00',3.49),('12664','2013-08-11','15:30:00',3.45),('12664','2013-08-11','15:35:00',3.4),('12664','2013-08-11','15:40:00',3.38),('12664','2013-08-11','15:45:00',3.34),('12664','2013-08-11','15:50:00',3.29),('12664','2013-08-11','15:55:00',3.24),('12664','2013-08-11','16:00:00',3.19),('12664','2013-08-11','16:05:00',3.12),('12664','2013-08-11','16:10:00',3.05),('12664','2013-08-11','16:15:00',3.01),('12664','2013-08-11','16:20:00',2.94),('12664','2013-08-11','16:25:00',2.85),('12664','2013-08-11','16:30:00',2.77),('12664','2013-08-11','16:35:00',2.69),('12664','2013-08-11','16:40:00',2.63),('12664','2013-08-11','16:45:00',2.56),('12664','2013-08-11','16:50:00',2.5),('12664','2013-08-11','16:55:00',2.43),('12664','2013-08-11','17:00:00',2.34),('12664','2013-08-11','17:05:00',2.26),('12664','2013-08-11','17:10:00',2.18),('12664','2013-08-11','17:15:00',2.11),('12664','2013-08-11','17:20:00',2.02),('12664','2013-08-11','17:25:00',1.94),('12664','2013-08-11','17:30:00',1.84),('12664','2013-08-11','17:35:00',1.77),('12664','2013-08-11','17:40:00',1.68),('12664','2013-08-11','17:45:00',1.59),('12664','2013-08-11','17:50:00',1.5),('12664','2013-08-11','17:55:00',1.41),('12664','2013-08-11','18:00:00',1.33),('12664','2013-08-11','18:05:00',1.23),('12664','2013-08-11','18:10:00',1.15),('12664','2013-08-11','18:15:00',1.06),('12664','2013-08-10','08:00:00',1.04),('12664','2013-08-10','08:05:00',1.14),('12664','2013-08-10','08:10:00',1.23),('12664','2013-08-10','08:15:00',1.32),('12664','2013-08-10','08:20:00',1.41),('12664','2013-08-10','08:25:00',1.51),('12664','2013-08-10','08:30:00',1.6),('12664','2013-08-10','08:35:00',1.69),('12664','2013-08-10','08:40:00',1.78),('12664','2013-08-10','08:45:00',1.85),('12664','2013-08-10','08:50:00',1.94),('12664','2013-08-10','08:55:00',2.02),('12664','2013-08-10','09:00:00',2.1),('12664','2013-08-10','09:05:00',2.17),('12664','2013-08-10','09:10:00',2.26),('12664','2013-08-10','09:15:00',2.34),('12664','2013-08-10','09:20:00',2.42),('12664','2013-08-10','09:25:00',2.5),('12664','2013-08-10','09:30:00',2.58),('12664','2013-08-10','09:35:00',2.66),('12664','2013-08-10','09:40:00',2.73),('12664','2013-08-10','09:45:00',2.8),('12664','2013-08-10','09:50:00',2.86),('12664','2013-08-10','09:55:00',2.91),('12664','2013-08-10','10:00:00',2.98),('12664','2013-08-10','10:05:00',3.04),('12664','2013-08-10','10:10:00',3.09),('12664','2013-08-10','10:15:00',3.13),('12664','2013-08-10','10:20:00',3.19),('12664','2013-08-10','10:25:00',3.25),('12664','2013-08-10','10:30:00',3.31),('12664','2013-08-10','10:35:00',3.37),('12664','2013-08-10','10:40:00',3.42),('12664','2013-08-10','10:45:00',3.48),('12664','2013-08-10','10:50:00',3.53),('12664','2013-08-10','10:55:00',3.56),('12664','2013-08-10','11:00:00',3.66),('12664','2013-08-10','11:05:00',3.7),('12664','2013-08-10','11:10:00',3.65),('12664','2013-08-10','11:15:00',3.76),('12664','2013-08-10','11:20:00',3.77),('12664','2013-08-10','11:25:00',3.77),('12664','2013-08-10','11:30:00',3.79),('12664','2013-08-10','11:35:00',3.83),('12664','2013-08-10','11:40:00',3.84),('12664','2013-08-10','11:45:00',3.85),('12664','2013-08-10','11:50:00',3.88),('12664','2013-08-10','11:55:00',4.02),('12664','2013-08-10','12:00:00',4.14),('12664','2013-08-10','12:05:00',3.96),('12664','2013-08-10','12:10:00',3.95),('12664','2013-08-10','12:15:00',4.01),('12664','2013-08-10','12:20:00',3.94),('12664','2013-08-10','12:25:00',4.05),('12664','2013-08-10','12:30:00',4.07),('12664','2013-08-10','12:35:00',4.14),('12664','2013-08-10','12:40:00',4.2),('12664','2013-08-10','12:45:00',4.34),('12664','2013-08-10','12:50:00',4.28),('12664','2013-08-10','12:55:00',4.18),('12664','2013-08-10','13:00:00',4.08),('12664','2013-08-10','13:05:00',4.01),('12664','2013-08-10','13:10:00',4.11),('12664','2013-08-10','13:15:00',4.18),('12664','2013-08-10','13:20:00',4.2),('12664','2013-08-10','13:25:00',4.18),('12664','2013-08-10','13:30:00',3.98),('12664','2013-08-10','13:35:00',4.26),('12664','2013-08-10','13:40:00',4.32),('12664','2013-08-10','13:45:00',3.63),('12664','2013-08-10','13:50:00',2.08),('12664','2013-08-10','13:55:00',2.42),('12664','2013-08-10','14:00:00',4.47),('12664','2013-08-10','14:05:00',3.04),('12664','2013-08-10','14:10:00',1.74),('12664','2013-08-10','15:35:00',1.14),('12664','2013-08-10','15:40:00',1.39),('12664','2013-08-10','15:45:00',1.66),('12664','2013-08-10','15:50:00',2.71),('12664','2013-08-10','15:55:00',3.57),('12664','2013-08-10','16:00:00',2.65),('12664','2013-08-10','16:05:00',1.25),('12664','2013-08-10','16:10:00',1.04),('12664','2013-08-10','16:15:00',1.09),('12664','2013-08-10','16:20:00',1.21),('12664','2013-08-10','16:25:00',1.19),('12664','2013-08-10','16:30:00',1.02),('12664','2013-08-10','16:45:00',1.04),('12664','2013-08-10','16:50:00',1.35),('12664','2013-08-10','16:55:00',1.43),('12664','2013-08-10','17:00:00',2.28),('12664','2013-08-10','17:05:00',1.58),('12664','2013-08-10','17:25:00',1.98),('12664','2013-08-10','17:30:00',1.24),('12664','2013-08-10','17:35:00',1.24),('12664','2013-08-09','08:30:00',1.12),('12664','2013-08-09','08:35:00',1.21),('12664','2013-08-09','08:40:00',1.52),('12664','2013-08-09','08:45:00',1.63),('12664','2013-08-09','08:50:00',1.76),('12664','2013-08-09','08:55:00',1.9),('12664','2013-08-09','09:00:00',1.59),('12664','2013-08-09','09:05:00',1.22),('12664','2013-08-09','09:10:00',1.41),('12664','2013-08-09','09:15:00',1.47),('12664','2013-08-09','09:20:00',1.41),('12664','2013-08-09','09:25:00',1.16),('12664','2013-08-09','09:30:00',2.62),('12664','2013-08-09','09:35:00',2.77),('12664','2013-08-09','09:40:00',2.7),('12664','2013-08-09','09:45:00',2.59),('12664','2013-08-09','09:50:00',2.78),('12664','2013-08-09','09:55:00',2.76),('12664','2013-08-09','10:00:00',2.74),('12664','2013-08-09','10:05:00',2.71),('12664','2013-08-09','10:10:00',2.73),('12664','2013-08-09','10:15:00',2.77),('12664','2013-08-09','10:20:00',2.84),('12664','2013-08-09','10:25:00',2.89),('12664','2013-08-09','10:30:00',2.96),('12664','2013-08-09','10:35:00',3.01),('12664','2013-08-09','10:40:00',3.04),('12664','2013-08-09','10:45:00',3.13),('12664','2013-08-09','10:50:00',3.19),('12664','2013-08-09','10:55:00',3.23),('12664','2013-08-09','11:00:00',3.21),('12664','2013-08-09','11:05:00',3.26),('12664','2013-08-09','11:10:00',3.3),('12664','2013-08-09','11:15:00',3.32),('12664','2013-08-09','11:20:00',3.38),('12664','2013-08-09','11:25:00',3.4),('12664','2013-08-09','11:30:00',3.43),('12664','2013-08-09','11:35:00',3.52),('12664','2013-08-09','11:40:00',3.54),('12664','2013-08-09','11:45:00',3.52),('12664','2013-08-09','11:50:00',3.6),('12664','2013-08-09','11:55:00',3.65),('12664','2013-08-09','12:00:00',3.68),('12664','2013-08-09','12:05:00',3.73),('12664','2013-08-09','12:10:00',3.84),('12664','2013-08-09','12:15:00',3.96),('12664','2013-08-09','12:20:00',4.09),('12664','2013-08-09','12:25:00',3.22),('12664','2013-08-09','12:30:00',3.66),('12664','2013-08-09','12:35:00',3.9),('12664','2013-08-09','12:40:00',3.37),('12664','2013-08-09','12:45:00',2.49),('12664','2013-08-09','12:50:00',1.05),('12664','2013-08-09','12:55:00',1.01),('12664','2013-08-09','13:15:00',1.13),('12664','2013-08-09','13:20:00',1.33),('12664','2013-08-09','13:25:00',1.54),('12664','2013-08-09','13:30:00',1.59),('12664','2013-08-09','13:35:00',1.52),('12664','2013-08-09','13:40:00',1.4),('12664','2013-08-09','13:45:00',1.05),('12664','2013-08-09','13:55:00',1.08),('12664','2013-08-09','14:00:00',1.03),('12664','2013-08-09','15:10:00',1.11),('12664','2013-08-09','15:15:00',2.11),('12664','2013-08-09','15:30:00',1.11),('12664','2013-08-09','15:35:00',1.16),('12664','2013-08-09','15:40:00',1.7),('12664','2013-08-09','15:45:00',2.89),('12664','2013-08-09','15:50:00',2.44),('12664','2013-08-09','15:55:00',1.27),('12664','2013-08-09','16:50:00',1.94),('12664','2014-04-08','08:25:00',1.02),('12664','2014-04-08','08:30:00',1.25),('12664','2014-04-08','08:35:00',1.24),('12664','2014-04-08','08:40:00',1.27),('12664','2014-04-08','08:45:00',1.52),('12664','2014-04-08','08:50:00',1.63),('12664','2014-04-08','08:55:00',1.73),('12664','2014-04-08','09:00:00',1.83),('12664','2014-04-08','09:05:00',1.91),('12664','2014-04-08','09:10:00',1.98),('12664','2014-04-08','09:15:00',2.06),('12664','2014-04-08','09:20:00',2.15),('12664','2014-04-08','09:25:00',2.17),('12664','2014-04-08','09:30:00',2.21),('12664','2014-04-08','09:35:00',2.3),('12664','2014-04-08','09:40:00',2.38),('12664','2014-04-08','09:45:00',2.42),('12664','2014-04-08','09:50:00',2.44),('12664','2014-04-08','09:55:00',2.64),('12664','2014-04-08','10:00:00',2.73),('12664','2014-04-08','10:05:00',2.8),('12664','2014-04-08','10:10:00',2.86),('12664','2014-04-08','10:15:00',2.92),('12664','2014-04-08','10:20:00',2.97),('12664','2014-04-08','10:25:00',3.02),('12664','2014-04-08','10:30:00',3.1),('12664','2014-04-08','10:35:00',3.14),('12664','2014-04-08','10:40:00',3.2),('12664','2014-04-08','10:45:00',3.28),('12664','2014-04-08','10:50:00',3.33),('12664','2014-04-08','10:55:00',3.39),('12664','2014-04-08','11:00:00',3.4),('12664','2014-04-08','11:05:00',3.44),('12664','2014-04-08','11:10:00',3.47),('12664','2014-04-08','11:15:00',3.51),('12664','2014-04-08','11:20:00',3.59),('12664','2014-04-08','11:25:00',3.59),('12664','2014-04-08','11:30:00',3.55),('12664','2014-04-08','11:35:00',3.66),('12664','2014-04-08','11:40:00',3.65),('12664','2014-04-08','11:45:00',3.59),('12664','2014-04-08','11:50:00',3.66),('12664','2014-04-08','11:55:00',3.67),('12664','2014-04-08','12:00:00',3.66),('12664','2014-04-08','12:05:00',3.64),('12664','2014-04-08','12:10:00',3.39),('12664','2014-04-08','12:15:00',3.31),('12664','2014-04-08','12:20:00',3.84),('12664','2014-04-08','12:25:00',3.41),('12664','2014-04-08','12:30:00',3.46),('12664','2014-04-08','12:35:00',4.11),('12664','2014-04-08','12:40:00',3.33),('12664','2014-04-08','12:45:00',3.89),('12664','2014-04-08','12:50:00',3.72),('12664','2014-04-08','12:55:00',3.84),('12664','2014-04-08','13:00:00',3.82),('12664','2014-04-08','13:05:00',3.88),('12664','2014-04-08','13:10:00',3.99),('12664','2014-04-08','13:15:00',4),('12664','2014-04-08','13:20:00',4.02),('12664','2014-04-08','13:25:00',3.99),('12664','2014-04-08','13:30:00',4.03),('12664','2014-04-08','13:35:00',3.98),('12664','2014-04-08','13:40:00',4.03),('12664','2014-04-08','13:45:00',3.98),('12664','2014-04-08','13:50:00',3.76),('12664','2014-04-08','13:55:00',3.65),('12664','2014-04-08','14:00:00',3.64),('12664','2014-04-08','14:05:00',3.83),('12664','2014-04-08','14:10:00',3.93),('12664','2014-04-08','14:15:00',3.88),('12664','2014-04-08','14:20:00',3.53),('12664','2014-04-08','14:25:00',3.26),('12664','2014-04-08','14:30:00',3.81),('12664','2014-04-08','14:35:00',2.97),('12664','2014-04-08','14:40:00',3.56),('12664','2014-04-08','14:45:00',3.84),('12664','2014-04-08','14:50:00',3.75),('12664','2014-04-08','14:55:00',3.65),('12664','2014-04-08','15:00:00',3.6),('12664','2014-04-08','15:05:00',3.54),('12664','2014-04-08','15:10:00',3.4),('12664','2014-04-08','15:15:00',3.4),('12664','2014-04-08','15:20:00',3.4),('12664','2014-04-08','15:25:00',3.28),('12664','2014-04-08','15:30:00',3.25),('12664','2014-04-08','15:35:00',3.06),('12664','2014-04-08','15:40:00',3.13),('12664','2014-04-08','15:45:00',3.12),('12664','2014-04-08','15:50:00',3.04),('12664','2014-04-08','15:55:00',2.95),('12664','2014-04-08','16:00:00',2.99),('12664','2014-04-08','16:05:00',2.86),('12664','2014-04-08','16:10:00',2.67),('12664','2014-04-08','16:15:00',2.7),('12664','2014-04-08','16:20:00',2.49),('12664','2014-04-08','16:25:00',2.57),('12664','2014-04-08','16:30:00',2.5),('12664','2014-04-08','16:35:00',2.39),('12664','2014-04-08','16:40:00',2.3),('12664','2014-04-08','16:45:00',2.32),('12664','2014-04-08','16:50:00',2.06),('12664','2014-04-08','16:55:00',1.97),('12664','2014-04-08','17:00:00',2.02),('12664','2014-04-08','17:05:00',1.93),('12664','2014-04-08','17:10:00',1.82),('12664','2014-04-08','17:15:00',1.73),('12664','2014-04-08','17:20:00',1.58),('12664','2014-04-08','17:25:00',1.45),('12664','2014-04-08','17:30:00',1.37),('12664','2014-04-08','17:35:00',1.34),('12664','2014-04-08','17:40:00',1.27),('12664','2014-04-08','17:45:00',1.18),('12664','2014-04-08','17:50:00',1),('12664','2013-08-08','08:10:00',1.07),('12664','2013-08-08','08:15:00',1.16),('12664','2013-08-08','08:20:00',1.24),('12664','2013-08-08','08:25:00',1.32),('12664','2013-08-08','08:30:00',1.4),('12664','2013-08-08','08:35:00',1.48),('12664','2013-08-08','08:40:00',1.44),('12664','2013-08-08','08:45:00',1.65),('12664','2013-08-08','08:50:00',1.73),('12664','2013-08-08','08:55:00',1.81),('12664','2013-08-08','09:00:00',1.89),('12664','2013-08-08','09:05:00',1.96),('12664','2013-08-08','09:10:00',2.03),('12664','2013-08-08','09:15:00',2.11),('12664','2013-08-08','09:20:00',2.18),('12664','2013-08-08','09:25:00',2.25),('12664','2013-08-08','09:30:00',2.33),('12664','2013-08-08','09:35:00',2.39),('12664','2013-08-08','09:40:00',2.45),('12664','2013-08-08','09:45:00',2.53),('12664','2013-08-08','09:50:00',2.6),('12664','2013-08-08','09:55:00',2.65),('12664','2013-08-08','10:00:00',2.72),('12664','2013-08-08','10:05:00',2.77),('12664','2013-08-08','10:10:00',2.82),('12664','2013-08-08','10:15:00',2.9),('12664','2013-08-08','10:20:00',2.95),('12664','2013-08-08','10:25:00',2.98),('12664','2013-08-08','10:30:00',3.04),('12664','2013-08-08','10:35:00',3.08),('12664','2013-08-08','10:40:00',3.11),('12664','2013-08-08','10:45:00',3.13),('12664','2013-08-08','10:50:00',3.22),('12664','2013-08-08','10:55:00',3.23),('12664','2013-08-08','11:00:00',3.26),('12664','2013-08-08','11:05:00',3.32),('12664','2013-08-08','11:10:00',3.38),('12664','2013-08-08','11:15:00',3.45),('12664','2013-08-08','11:20:00',3.46),('12664','2013-08-08','11:25:00',3.21),('12664','2013-08-08','11:30:00',3.34),('12664','2013-08-08','11:35:00',3.54),('12664','2013-08-08','11:40:00',3.56),('12664','2013-08-08','11:45:00',3.57),('12664','2013-08-08','12:20:00',3.76),('12664','2013-08-08','12:25:00',3.82),('12664','2013-08-08','12:30:00',3.85),('12664','2013-08-08','12:35:00',3.89),('12664','2013-08-08','12:40:00',3.91),('12664','2013-08-08','12:45:00',3.91),('12664','2013-08-08','12:50:00',3.91),('12664','2013-08-08','12:55:00',3.92),('12664','2013-08-08','13:00:00',3.93),('12664','2013-08-08','13:05:00',3.93),('12664','2013-08-08','13:10:00',3.91),('12664','2013-08-08','13:15:00',3.92),('12664','2013-08-08','13:20:00',3.93),('12664','2013-08-08','13:25:00',3.91),('12664','2013-08-08','13:30:00',3.91),('12664','2013-08-08','13:35:00',3.9),('12664','2013-08-08','13:40:00',3.9),('12664','2013-08-08','13:45:00',3.87),('12664','2013-08-08','13:50:00',3.87),('12664','2013-08-08','13:55:00',3.86),('12664','2013-08-08','14:00:00',3.83),('12664','2013-08-08','14:05:00',3.79),('12664','2013-08-08','14:10:00',3.78),('12664','2013-08-08','14:15:00',3.76),('12664','2013-08-08','15:20:00',3.31),('12664','2013-08-08','15:30:00',3.25),('12664','2013-08-08','15:35:00',3.21),('12664','2013-08-08','15:40:00',3.18),('12664','2013-08-08','15:45:00',3.13),('12664','2013-08-08','15:50:00',3.07),('12664','2013-08-08','15:55:00',3),('12664','2013-08-08','16:00:00',2.95),('12664','2013-08-08','16:05:00',2.9),('12664','2013-08-08','16:10:00',2.86),('12664','2013-08-08','16:15:00',2.81),('12664','2013-08-08','16:30:00',2.58),('12664','2013-08-08','16:35:00',2.53),('12664','2013-08-08','16:40:00',2.47),('12664','2013-08-08','16:45:00',2.42),('12664','2013-08-08','16:50:00',2.34),('12664','2013-08-08','16:55:00',2.27),('12664','2013-08-08','17:00:00',2.21),('12664','2013-08-08','17:05:00',2.13),('12664','2013-08-08','17:10:00',2.06),('12664','2013-08-08','17:15:00',1.98),('12664','2013-08-08','17:20:00',1.9),('12664','2013-08-08','17:25:00',1.82),('12664','2013-08-08','17:30:00',1.74),('12664','2013-08-08','17:35:00',1.58),('12664','2013-08-08','17:40:00',1.5),('12664','2013-08-08','17:45:00',1.41),('12664','2013-08-08','17:50:00',1.26),('12664','2013-08-08','17:55:00',1.33),('12664','2013-08-08','18:00:00',1.25),('12664','2013-08-08','18:05:00',1.16),('12664','2013-08-08','18:10:00',1.08),('12664','2013-08-07','08:05:00',1.05),('12664','2013-08-07','08:10:00',1.13),('12664','2013-08-07','08:15:00',1.21),('12664','2013-08-07','08:20:00',1.29),('12664','2013-08-07','08:25:00',1.38),('12664','2013-08-07','08:30:00',1.46),('12664','2013-08-07','08:35:00',1.55),('12664','2013-08-07','08:40:00',1.63),('12664','2013-08-07','08:45:00',1.7),('12664','2013-08-07','08:50:00',1.79),('12664','2013-08-07','08:55:00',1.87),('12664','2013-08-07','09:00:00',1.94),('12664','2013-08-07','09:05:00',2.02),('12664','2013-08-07','09:10:00',2.09),('12664','2013-08-07','09:15:00',2.17),('12664','2013-08-07','09:20:00',2.24),('12664','2013-08-07','09:25:00',2.29),('12664','2013-08-07','09:30:00',2.36),('12664','2013-08-07','09:35:00',2.44),('12664','2013-08-07','09:40:00',2.54),('12664','2013-08-07','09:45:00',2.59),('12664','2013-08-07','09:50:00',2.66),('12664','2013-08-07','09:55:00',2.73),('12664','2013-08-07','10:00:00',2.78),('12664','2013-08-07','10:05:00',2.84),('12664','2013-08-07','10:10:00',2.87),('12664','2013-08-07','10:15:00',2.93),('12664','2013-08-07','10:20:00',2.97),('12664','2013-08-07','10:25:00',3),('12664','2013-08-07','10:30:00',3.04),('12664','2013-08-07','10:35:00',3.11),('12664','2013-08-07','10:40:00',3.22),('12664','2013-08-07','10:45:00',3.29),('12664','2013-08-07','10:50:00',3.31),('12664','2013-08-07','10:55:00',3.32),('12664','2013-08-07','11:00:00',3.36),('12664','2013-08-07','11:05:00',3.39),('12664','2013-08-07','11:10:00',3.43),('12664','2013-08-07','11:15:00',3.43),('12664','2013-08-07','11:20:00',3.45),('12664','2013-08-07','11:25:00',3.47),('12664','2013-08-07','11:30:00',3.51),('12664','2013-08-07','11:35:00',3.57),('12664','2013-08-07','11:40:00',3.57),('12664','2013-08-07','11:45:00',3.58),('12664','2013-08-07','11:50:00',3.63),('12664','2013-08-07','11:55:00',3.63),('12664','2013-08-07','12:00:00',3.67),('12664','2013-08-07','12:05:00',3.71),('12664','2013-08-07','12:10:00',3.64),('12664','2013-08-07','12:15:00',3.69),('12664','2013-08-07','12:20:00',3.75),('12664','2013-08-07','12:25:00',3.82),('12664','2013-08-07','12:30:00',3.86),('12664','2013-08-07','12:35:00',3.89),('12664','2013-08-07','12:40:00',3.91),('12664','2013-08-07','12:45:00',3.87),('12664','2013-08-07','12:50:00',3.87),('12664','2013-08-07','12:55:00',3.91),('12664','2013-08-07','13:00:00',3.91),('12664','2013-08-07','13:05:00',3.92),('12664','2013-08-07','13:10:00',3.91),('12664','2013-08-07','13:15:00',3.91),('12664','2013-08-07','13:20:00',3.88),('12664','2013-08-07','13:25:00',3.92),('12664','2013-08-07','13:30:00',3.96),('12664','2013-08-07','13:35:00',3.94),('12664','2013-08-07','13:40:00',3.91),('12664','2013-08-07','13:45:00',3.91),('12664','2013-08-07','13:50:00',3.92),('12664','2013-08-07','13:55:00',3.92),('12664','2013-08-07','14:00:00',3.91),('12664','2013-08-07','14:05:00',3.89),('12664','2013-08-07','14:10:00',3.88),('12664','2013-08-07','14:15:00',3.84),('12664','2013-08-07','14:20:00',3.82),('12664','2013-08-07','14:25:00',3.78),('12664','2013-08-07','14:30:00',3.8),('12664','2013-08-07','14:35:00',3.77),('12664','2013-08-07','14:40:00',3.74),('12664','2013-08-07','14:45:00',3.7),('12664','2013-08-07','14:50:00',3.66),('12664','2013-08-07','14:55:00',3.64),('12664','2013-08-07','15:00:00',3.62),('12664','2013-08-07','15:05:00',3.57),('12664','2013-08-07','15:10:00',3.54),('12664','2013-08-07','15:15:00',3.51),('12664','2013-08-07','15:20:00',3.45),('12664','2013-08-07','15:25:00',3.42),('12664','2013-08-07','15:30:00',3.37),('12664','2013-08-07','15:35:00',3.33),('12664','2013-08-07','15:40:00',3.28),('12664','2013-08-07','15:45:00',3.23),('12664','2013-08-07','15:50:00',3.19),('12664','2013-08-07','15:55:00',3.13),('12664','2013-08-07','16:00:00',3.09),('12664','2013-08-07','16:05:00',3.02),('12664','2013-08-07','16:10:00',2.95),('12664','2013-08-07','16:15:00',2.88),('12664','2013-08-07','16:20:00',2.82),('12664','2013-08-07','16:25:00',2.76),('12664','2013-08-07','16:30:00',2.69),('12664','2013-08-07','16:35:00',2.62),('12664','2013-08-07','16:40:00',2.56),('12664','2013-08-07','16:45:00',2.49),('12664','2013-08-07','16:50:00',2.42),('12664','2013-08-07','16:55:00',2.34),('12664','2013-08-07','17:00:00',2.27),('12664','2013-08-07','17:05:00',2.19),('12664','2013-08-07','17:10:00',2.11),('12664','2013-08-07','17:15:00',2.03),('12664','2013-08-07','17:20:00',1.96),('12664','2013-08-07','17:25:00',1.89),('12664','2013-08-07','17:30:00',1.79),('12664','2013-08-07','17:35:00',1.72),('12664','2013-08-07','17:40:00',1.64),('12664','2013-08-07','17:45:00',1.55),('12664','2013-08-07','17:50:00',1.47),('12664','2013-08-07','17:55:00',1.4),('12664','2013-08-07','18:00:00',1.32),('12664','2013-08-07','18:05:00',1.23),('12664','2013-08-07','18:10:00',1.13),('12664','2013-08-07','18:15:00',1.05),('12664','2013-08-06','08:05:00',1.03),('12664','2013-08-06','08:10:00',1.11),('12664','2013-08-06','08:15:00',1.2),('12664','2013-08-06','08:20:00',1.28),('12664','2013-08-06','08:25:00',1.36),('12664','2013-08-06','08:30:00',1.45),('12664','2013-08-06','08:35:00',1.53),('12664','2013-08-06','08:40:00',1.6),('12664','2013-08-06','08:45:00',1.69),('12664','2013-08-06','08:50:00',1.77),('12664','2013-08-06','08:55:00',1.86),('12664','2013-08-06','09:00:00',1.94),('12664','2013-08-06','09:05:00',2.02),('12664','2013-08-06','09:10:00',2.08),('12664','2013-08-06','09:15:00',2.15),('12664','2013-08-06','09:20:00',2.23),('12664','2013-08-06','09:25:00',2.31),('12664','2013-08-06','09:30:00',2.39),('12664','2013-08-06','09:35:00',2.46),('12664','2013-08-06','09:40:00',2.53),('12664','2013-08-06','09:45:00',2.59),('12664','2013-08-06','09:50:00',2.66),('12664','2013-08-06','09:55:00',2.72),('12664','2013-08-06','10:00:00',2.74),('12664','2013-08-06','10:05:00',2.81),('12664','2013-08-06','10:10:00',2.88),('12664','2013-08-06','10:15:00',2.95),('12664','2013-08-06','10:20:00',2.99),('12664','2013-08-06','10:25:00',3.02),('12664','2013-08-06','10:30:00',3.08),('12664','2013-08-06','10:35:00',3.12),('12664','2013-08-06','10:40:00',3.18),('12664','2013-08-06','10:45:00',3.23),('12664','2013-08-06','10:50:00',3.26),('12664','2013-08-06','10:55:00',3.3),('12664','2013-08-06','11:00:00',3.34),('12664','2013-08-06','11:05:00',3.32),('12664','2013-08-06','11:10:00',3.4),('12664','2013-08-06','11:15:00',3.42),('12664','2013-08-06','11:20:00',3.42),('12664','2013-08-06','11:25:00',3.48),('12664','2013-08-06','11:30:00',3.51),('12664','2013-08-06','11:35:00',3.59),('12664','2013-08-06','11:40:00',3.61),('12664','2013-08-06','11:45:00',3.64),('12664','2013-08-06','11:50:00',3.68),('12664','2013-08-06','11:55:00',3.67),('12664','2013-08-06','12:00:00',3.66),('12664','2013-08-06','12:05:00',3.68),('12664','2013-08-06','12:10:00',3.66),('12664','2013-08-06','12:15:00',3.72),('12664','2013-08-06','12:20:00',3.73),('12664','2013-08-06','12:25:00',3.76),('12664','2013-08-06','12:30:00',3.81),('12664','2013-08-06','12:35:00',3.88),('12664','2013-08-06','12:40:00',3.9),('12664','2013-08-06','12:45:00',3.9),('12664','2013-08-06','12:50:00',3.91),('12664','2013-08-06','12:55:00',3.93),('12664','2013-08-06','13:00:00',3.94),('12664','2013-08-06','13:05:00',3.94),('12664','2013-08-06','13:10:00',3.96),('12664','2013-08-06','13:15:00',3.97),('12664','2013-08-06','13:20:00',3.99),('12664','2013-08-06','13:25:00',3.96),('12664','2013-08-06','13:30:00',3.96),('12664','2013-08-06','13:35:00',3.97),('12664','2013-08-06','13:40:00',3.98),('12664','2013-08-06','13:45:00',3.97),('12664','2013-08-06','13:50:00',3.97),('12664','2013-08-06','13:55:00',3.95),('12664','2013-08-06','14:00:00',3.97),('12664','2013-08-06','14:05:00',3.96),('12664','2013-08-06','14:10:00',3.92),('12664','2013-08-06','14:15:00',3.91),('12664','2013-08-06','14:20:00',3.87),('12664','2013-08-06','14:25:00',3.84),('12664','2013-08-06','14:30:00',3.83),('12664','2013-08-06','14:35:00',3.82),('12664','2013-08-06','14:40:00',3.8),('12664','2013-08-06','14:45:00',3.78),('12664','2013-08-06','14:50:00',3.72),('12664','2013-08-06','14:55:00',3.71),('12664','2013-08-06','15:00:00',3.67),('12664','2013-08-06','15:05:00',3.65),('12664','2013-08-06','15:10:00',3.61),('12664','2013-08-06','15:15:00',3.57),('12664','2013-08-06','15:20:00',3.52),('12664','2013-08-06','15:25:00',3.48),('12664','2013-08-06','15:30:00',3.43),('12664','2013-08-06','15:35:00',3.37),('12664','2013-08-06','15:40:00',3.32),('12664','2013-08-06','15:45:00',3.28),('12664','2013-08-06','15:50:00',3.23),('12664','2013-08-06','15:55:00',3.19),('12664','2013-08-06','16:00:00',3.12),('12664','2013-08-06','16:05:00',3.06),('12664','2013-08-06','16:10:00',2.99),('12664','2013-08-06','16:15:00',2.93),('12664','2013-08-06','16:20:00',2.87),('12664','2013-08-06','16:25:00',2.8),('12664','2013-08-06','16:30:00',2.73),('12664','2013-08-06','16:35:00',2.68),('12664','2013-08-06','16:40:00',2.62),('12664','2013-08-06','16:45:00',2.55),('12664','2013-08-06','16:50:00',2.49),('12664','2013-08-06','16:55:00',2.41),('12664','2013-08-06','17:00:00',2.34),('12664','2013-08-06','17:05:00',2.27),('12664','2013-08-06','17:10:00',2.18),('12664','2013-08-06','17:15:00',2.09),('12664','2013-08-06','17:20:00',2.02),('12664','2013-08-06','17:25:00',1.93),('12664','2013-08-06','17:30:00',1.85),('12664','2013-08-06','17:35:00',1.77),('12664','2013-08-06','17:40:00',1.68),('12664','2013-08-06','17:45:00',1.59),('12664','2013-08-06','17:50:00',1.51),('12664','2013-08-06','17:55:00',1.42),('12664','2013-08-06','18:00:00',1.33),('12664','2013-08-06','18:05:00',1.25),('12664','2013-08-06','18:10:00',1.16),('12664','2013-08-06','18:15:00',1.08),('12664','2013-08-05','08:05:00',1.05),('12664','2013-08-05','08:10:00',1.13),('12664','2013-08-05','08:15:00',1.22),('12664','2013-08-05','08:20:00',1.3),('12664','2013-08-05','08:25:00',1.39),('12664','2013-08-05','08:30:00',1.47),('12664','2013-08-05','08:35:00',1.55),('12664','2013-08-05','08:40:00',1.63),('12664','2013-08-05','08:45:00',1.71),('12664','2013-08-05','08:50:00',1.82),('12664','2013-08-05','08:55:00',1.91),('12664','2013-08-05','09:00:00',1.97),('12664','2013-08-05','09:05:00',2.06),('12664','2013-08-05','09:10:00',2.13),('12664','2013-08-05','09:15:00',2.21),('12664','2013-08-05','09:20:00',2.28),('12664','2013-08-05','09:25:00',2.37),('12664','2013-08-05','09:30:00',2.43),('12664','2013-08-05','09:35:00',2.51),('12664','2013-08-05','09:40:00',2.57),('12664','2013-08-05','09:45:00',2.64),('12664','2013-08-05','09:50:00',2.7),('12664','2013-08-05','09:55:00',2.75),('12664','2013-08-05','10:00:00',2.82),('12664','2013-08-05','10:05:00',2.87),('12664','2013-08-05','10:10:00',2.93),('12664','2013-08-05','10:15:00',2.99),('12664','2013-08-05','10:20:00',3.05),('12664','2013-08-05','10:25:00',3.1),('12664','2013-08-05','10:30:00',3.15),('12664','2013-08-05','10:35:00',3.17),('12664','2013-08-05','10:40:00',3.24),('12664','2013-08-05','10:45:00',3.31),('12664','2013-08-05','10:50:00',3.34),('12664','2013-08-05','10:55:00',3.4),('12664','2013-08-05','11:00:00',3.43),('12664','2013-08-05','11:05:00',3.47),('12664','2013-08-05','11:10:00',3.51),('12664','2013-08-05','11:15:00',3.56),('12664','2013-08-05','11:20:00',3.6),('12664','2013-08-05','11:25:00',3.65),('12664','2013-08-05','11:30:00',3.69),('12664','2013-08-05','11:35:00',3.71),('12664','2013-08-05','11:40:00',3.74),('12664','2013-08-05','11:45:00',3.77),('12664','2013-08-05','11:50:00',3.77),('12664','2013-08-05','11:55:00',3.78),('12664','2013-08-05','12:00:00',3.82),('12664','2013-08-05','12:05:00',3.83),('12664','2013-08-05','12:10:00',3.81),('12664','2013-08-05','12:15:00',3.88),('12664','2013-08-05','12:20:00',3.88),('12664','2013-08-05','12:25:00',3.88),('12664','2013-08-05','12:30:00',3.91),('12664','2013-08-05','12:35:00',3.93),('12664','2013-08-05','12:40:00',3.92),('12664','2013-08-05','12:45:00',3.92),('12664','2013-08-05','12:50:00',3.93),('12664','2013-08-05','12:55:00',3.93),('12664','2013-08-05','13:00:00',3.94),('12664','2013-08-05','13:05:00',3.97),('12664','2013-08-05','13:10:00',4),('12664','2013-08-05','13:15:00',3.97),('12664','2013-08-05','13:20:00',3.96),('12664','2013-08-05','13:25:00',3.94),('12664','2013-08-05','13:30:00',3.94),('12664','2013-08-05','13:35:00',3.94),('12664','2013-08-05','13:40:00',3.9),('12664','2013-08-05','13:45:00',3.88),('12664','2013-08-05','13:50:00',3.92),('12664','2013-08-05','13:55:00',3.91),('12664','2013-08-05','14:00:00',3.9),('12664','2013-08-05','14:05:00',3.86),('12664','2013-08-05','14:10:00',3.83),('12664','2013-08-05','14:15:00',3.84),('12664','2013-08-05','14:20:00',3.78),('12664','2013-08-05','14:25:00',3.79),('12664','2013-08-05','14:30:00',3.77),('12664','2013-08-05','14:35:00',3.73),('12664','2013-08-05','14:40:00',3.71),('12664','2013-08-05','14:45:00',3.68),('12664','2013-08-05','14:50:00',3.68),('12664','2013-08-05','14:55:00',3.65),('12664','2013-08-05','15:00:00',3.6),('12664','2013-08-05','15:05:00',3.57),('12664','2013-08-05','15:10:00',3.54),('12664','2013-08-05','15:15:00',3.5),('12664','2013-08-05','15:20:00',3.47),('12664','2013-08-05','15:25:00',3.44),('12664','2013-08-05','15:30:00',3.4),('12664','2013-08-05','15:35:00',3.34),('12664','2013-08-05','15:40:00',3.29),('12664','2013-08-05','15:45:00',3.26),('12664','2013-08-05','15:50:00',3.21),('12664','2013-08-05','15:55:00',3.16),('12664','2013-08-05','16:00:00',3.1),('12664','2013-08-05','16:05:00',3.04),('12664','2013-08-05','16:10:00',2.99),('12664','2013-08-05','16:15:00',2.95),('12664','2013-08-05','16:20:00',2.88),('12664','2013-08-05','16:25:00',2.82),('12664','2013-08-05','16:30:00',2.74),('12664','2013-08-05','16:35:00',2.67),('12664','2013-08-05','16:40:00',2.6),('12664','2013-08-05','16:45:00',2.53),('12664','2013-08-05','16:50:00',2.45),('12664','2013-08-05','16:55:00',2.36),('12664','2013-08-05','17:00:00',2.28),('12664','2013-08-05','17:05:00',2.22),('12664','2013-08-05','17:10:00',2.14),('12664','2013-08-05','17:15:00',2.06),('12664','2013-08-05','17:20:00',1.97),('12664','2013-08-05','17:25:00',1.9),('12664','2013-08-05','17:30:00',1.8),('12664','2013-08-05','17:35:00',1.73),('12664','2013-08-05','17:40:00',1.64),('12664','2013-08-05','17:45:00',1.55),('12664','2013-08-05','17:50:00',1.48),('12664','2013-08-05','17:55:00',1.38),('12664','2013-08-05','18:00:00',1.32),('12664','2013-08-05','18:05:00',1.23),('12664','2013-08-05','18:10:00',1.15),('12664','2013-08-05','18:15:00',1.07),('12664','2013-08-04','08:00:00',1.06),('12664','2013-08-04','08:05:00',1.16),('12664','2013-08-04','08:10:00',1.24),('12664','2013-08-04','08:15:00',1.32),('12664','2013-08-04','08:20:00',1.41),('12664','2013-08-04','08:25:00',1.5),('12664','2013-08-04','08:30:00',1.59),('12664','2013-08-04','08:35:00',1.67),('12664','2013-08-04','08:40:00',1.77),('12664','2013-08-04','08:45:00',1.85),('12664','2013-08-04','08:50:00',1.93),('12664','2013-08-04','08:55:00',2.01),('12664','2013-08-04','09:00:00',2.09),('12664','2013-08-04','09:05:00',2.16),('12664','2013-08-04','09:10:00',2.23),('12664','2013-08-04','09:15:00',2.31),('12664','2013-08-04','09:20:00',2.39),('12664','2013-08-04','09:25:00',2.46),('12664','2013-08-04','09:30:00',2.52),('12664','2013-08-04','09:35:00',2.6),('12664','2013-08-04','09:40:00',2.67),('12664','2013-08-04','09:45:00',2.74),('12664','2013-08-04','09:50:00',2.79),('12664','2013-08-04','09:55:00',2.86),('12664','2013-08-04','10:00:00',2.92),('12664','2013-08-04','10:05:00',2.97),('12664','2013-08-04','10:10:00',3.03),('12664','2013-08-04','10:15:00',3.09),('12664','2013-08-04','10:20:00',3.13),('12664','2013-08-04','10:25:00',3.18),('12664','2013-08-04','10:30:00',3.21),('12664','2013-08-04','10:35:00',3.26),('12664','2013-08-04','10:40:00',3.33),('12664','2013-08-04','10:45:00',3.39),('12664','2013-08-04','10:50:00',3.45),('12664','2013-08-04','10:55:00',3.51),('12664','2013-08-04','11:00:00',3.56),('12664','2013-08-04','11:05:00',3.57),('12664','2013-08-04','11:10:00',3.6),('12664','2013-08-04','11:15:00',3.6),('12664','2013-08-04','11:20:00',3.67),('12664','2013-08-04','11:25:00',3.72),('12664','2013-08-04','11:30:00',3.69),('12664','2013-08-04','11:35:00',3.73),('12664','2013-08-04','11:40:00',3.79),('12664','2013-08-04','11:45:00',3.8),('12664','2013-08-04','11:50:00',3.84),('12664','2013-08-04','11:55:00',3.84),('12664','2013-08-04','12:00:00',3.86),('12664','2013-08-04','12:05:00',3.91),('12664','2013-08-04','12:10:00',3.9),('12664','2013-08-04','12:15:00',3.93),('12664','2013-08-04','12:20:00',3.97),('12664','2013-08-04','12:25:00',3.99),('12664','2013-08-04','12:30:00',3.98),('12664','2013-08-04','12:35:00',4.01),('12664','2013-08-04','12:40:00',4),('12664','2013-08-04','12:45:00',4.01),('12664','2013-08-04','12:50:00',4.05),('12664','2013-08-04','12:55:00',4.03),('12664','2013-08-04','13:00:00',4.04),('12664','2013-08-04','13:05:00',4.06),('12664','2013-08-04','13:10:00',4.05),('12664','2013-08-04','13:15:00',4.07),('12664','2013-08-04','13:20:00',4.06),('12664','2013-08-04','13:25:00',4.07),('12664','2013-08-04','13:30:00',4.06),('12664','2013-08-04','13:35:00',4.05),('12664','2013-08-04','13:40:00',4.06),('12664','2013-08-04','13:45:00',4.06),('12664','2013-08-04','13:50:00',4.04),('12664','2013-08-04','13:55:00',4.01),('12664','2013-08-04','14:00:00',4),('12664','2013-08-04','14:05:00',3.97),('12664','2013-08-04','14:10:00',3.95),('12664','2013-08-04','14:15:00',3.95),('12664','2013-08-04','14:20:00',3.94),('12664','2013-08-04','14:25:00',3.94),('12664','2013-08-04','14:30:00',3.92),('12664','2013-08-04','14:35:00',3.88),('12664','2013-08-04','14:40:00',3.81),('12664','2013-08-04','14:45:00',3.7),('12664','2013-08-04','14:50:00',3.59),('12664','2013-08-04','14:55:00',3.57),('12664','2013-08-04','15:00:00',3.55),('12664','2013-08-04','15:05:00',3.69),('12664','2013-08-04','15:10:00',3.67),('12664','2013-08-04','15:15:00',3.64),('12664','2013-08-04','15:20:00',3.59),('12664','2013-08-04','15:25:00',3.56),('12664','2013-08-04','15:30:00',3.53),('12664','2013-08-04','15:35:00',3.5),('12664','2013-08-04','15:40:00',3.45),('12664','2013-08-04','15:45:00',3.35),('12664','2013-08-04','15:50:00',3.32),('12664','2013-08-04','15:55:00',3.26),('12664','2013-08-04','16:00:00',3.21),('12664','2013-08-04','16:05:00',3.16),('12664','2013-08-04','16:10:00',3.09),('12664','2013-08-04','16:15:00',3.04),('12664','2013-08-04','16:20:00',2.97),('12664','2013-08-04','16:25:00',2.89),('12664','2013-08-04','16:30:00',2.83),('12664','2013-08-04','16:35:00',2.75),('12664','2013-08-04','16:40:00',2.67),('12664','2013-08-04','16:45:00',2.61),('12664','2013-08-04','16:50:00',2.53),('12664','2013-08-04','16:55:00',2.45),('12664','2013-08-04','17:00:00',2.38),('12664','2013-08-04','17:05:00',2.3),('12664','2013-08-04','17:10:00',2.21),('12664','2013-08-04','17:15:00',2.13),('12664','2013-08-04','17:20:00',2.05),('12664','2013-08-04','17:25:00',1.96),('12664','2013-08-04','17:30:00',1.88),('12664','2013-08-04','17:35:00',1.79),('12664','2013-08-04','17:40:00',1.69),('12664','2013-08-04','17:45:00',1.59),('12664','2013-08-04','17:50:00',1.5),('12664','2013-08-04','17:55:00',1.43),('12664','2013-08-04','18:00:00',1.34),('12664','2013-08-04','18:05:00',1.26),('12664','2013-08-04','18:10:00',1.17),('12664','2013-08-04','18:15:00',1.08),('12664','2013-08-03','08:00:00',1.05),('12664','2013-08-03','08:05:00',1.14),('12664','2013-08-03','08:10:00',1.23),('12664','2013-08-03','08:15:00',1.32),('12664','2013-08-03','08:20:00',1.41),('12664','2013-08-03','08:25:00',1.5),('12664','2013-08-03','08:30:00',1.59),('12664','2013-08-03','08:35:00',1.68),('12664','2013-08-03','08:40:00',1.76),('12664','2013-08-03','08:45:00',1.84),('12664','2013-08-03','08:50:00',1.92),('12664','2013-08-03','08:55:00',2),('12664','2013-08-03','09:00:00',2.08),('12664','2013-08-03','09:05:00',2.16),('12664','2013-08-03','09:10:00',2.23),('12664','2013-08-03','09:15:00',2.31),('12664','2013-08-03','09:20:00',2.37),('12664','2013-08-03','09:25:00',2.44),('12664','2013-08-03','09:30:00',2.51),('12664','2013-08-03','09:35:00',2.59),('12664','2013-08-03','09:40:00',2.64),('12664','2013-08-03','09:45:00',2.72),('12664','2013-08-03','09:50:00',2.8),('12664','2013-08-03','09:55:00',2.85),('12664','2013-08-03','10:00:00',2.91),('12664','2013-08-03','10:05:00',2.99),('12664','2013-08-03','10:10:00',3.03),('12664','2013-08-03','10:15:00',3.1),('12664','2013-08-03','10:20:00',3.16),('12664','2013-08-03','10:25:00',3.2),('12664','2013-08-03','10:30:00',3.26),('12664','2013-08-03','10:35:00',3.32),('12664','2013-08-03','10:40:00',3.36),('12664','2013-08-03','10:45:00',3.42),('12664','2013-08-03','10:50:00',3.44),('12664','2013-08-03','10:55:00',3.48),('12664','2013-08-03','11:00:00',3.53),('12664','2013-08-03','11:05:00',3.55),('12664','2013-08-03','11:10:00',3.61),('12664','2013-08-03','11:15:00',3.61),('12664','2013-08-03','11:20:00',3.6),('12664','2013-08-03','11:25:00',3.66),('12664','2013-08-03','11:30:00',3.69),('12664','2013-08-03','11:35:00',3.71),('12664','2013-08-03','11:40:00',3.69),('12664','2013-08-03','11:45:00',3.75),('12664','2013-08-03','11:50:00',3.8),('12664','2013-08-03','11:55:00',3.81),('12664','2013-08-03','12:00:00',3.75),('12664','2013-08-03','12:05:00',3.74),('12664','2013-08-03','12:10:00',3.81),('12664','2013-08-03','12:15:00',3.86),('12664','2013-08-03','12:20:00',3.93),('12664','2013-08-03','12:25:00',3.96),('12664','2013-08-03','12:30:00',3.95),('12664','2013-08-03','12:35:00',3.89),('12664','2013-08-03','12:40:00',3.92),('12664','2013-08-03','12:45:00',4.02),('12664','2013-08-03','12:50:00',4.04),('12664','2013-08-03','12:55:00',4.01),('12664','2013-08-03','13:00:00',4.03),('12664','2013-08-03','13:05:00',3.99),('12664','2013-08-03','13:10:00',3.99),('12664','2013-08-03','13:15:00',3.98),('12664','2013-08-03','13:20:00',3.96),('12664','2013-08-03','13:25:00',3.94),('12664','2013-08-03','13:30:00',3.98),('12664','2013-08-03','13:35:00',3.89),('12664','2013-08-03','13:40:00',3.88),('12664','2013-08-03','13:45:00',3.93),('12664','2013-08-03','13:50:00',3.95),('12664','2013-08-03','13:55:00',3.93),('12664','2013-08-03','14:00:00',3.98),('12664','2013-08-03','14:05:00',4.01),('12664','2013-08-03','14:10:00',3.95),('12664','2013-08-03','14:15:00',3.93),('12664','2013-08-03','14:20:00',3.9),('12664','2013-08-03','14:25:00',3.9),('12664','2013-08-03','14:30:00',3.89),('12664','2013-08-03','14:35:00',3.86),('12664','2013-08-03','14:40:00',3.85),('12664','2013-08-03','14:45:00',3.82),('12664','2013-08-03','14:50:00',3.79),('12664','2013-08-03','14:55:00',3.77),('12664','2013-08-03','15:00:00',3.73),('12664','2013-08-03','15:05:00',3.69),('12664','2013-08-03','15:10:00',3.65),('12664','2013-08-03','15:15:00',3.61),('12664','2013-08-03','15:20:00',3.57),('12664','2013-08-03','15:25:00',3.54),('12664','2013-08-03','15:30:00',3.49),('12664','2013-08-03','15:35:00',3.46),('12664','2013-08-03','15:40:00',3.41),('12664','2013-08-03','15:45:00',3.36),('12664','2013-08-03','15:50:00',3.3),('12664','2013-08-03','15:55:00',3.24),('12664','2013-08-03','16:00:00',3.19),('12664','2013-08-03','16:05:00',3.13),('12664','2013-08-03','16:10:00',3.08),('12664','2013-08-03','16:15:00',3.02),('12664','2013-08-03','16:20:00',2.96),('12664','2013-08-03','16:25:00',2.89),('12664','2013-08-03','16:30:00',2.81),('12664','2013-08-03','16:35:00',2.74),('12664','2013-08-03','16:40:00',2.67),('12664','2013-08-03','16:45:00',2.6),('12664','2013-08-03','16:50:00',2.53),('12664','2013-08-03','16:55:00',2.46),('12664','2013-08-03','17:00:00',2.39),('12664','2013-08-03','17:05:00',2.32),('12664','2013-08-03','17:10:00',2.24),('12664','2013-08-03','17:15:00',2.17),('12664','2013-08-03','17:20:00',2.1),('12664','2013-08-03','17:25:00',2),('12664','2013-08-03','17:30:00',1.92),('12664','2013-08-03','17:35:00',1.83),('12664','2013-08-03','17:40:00',1.74),('12664','2013-08-03','17:45:00',1.67),('12664','2013-08-03','17:50:00',1.57),('12664','2013-08-03','17:55:00',1.48),('12664','2013-08-03','18:00:00',1.39),('12664','2013-08-03','18:05:00',1.31),('12664','2013-08-03','18:10:00',1.23),('12664','2013-08-03','18:15:00',1.14),('12664','2013-08-03','18:20:00',1.06),('12664','2013-08-02','07:55:00',1.03),('12664','2013-08-02','08:00:00',1.12),('12664','2013-08-02','08:05:00',1.21),('12664','2013-08-02','08:10:00',1.31),('12664','2013-08-02','08:15:00',1.4),('12664','2013-08-02','08:20:00',1.49),('12664','2013-08-02','08:25:00',1.58),('12664','2013-08-02','08:30:00',1.68),('12664','2013-08-02','08:35:00',1.76),('12664','2013-08-02','08:40:00',1.85),('12664','2013-08-02','08:45:00',1.93),('12664','2013-08-02','08:50:00',2.01),('12664','2013-08-02','08:55:00',2.09),('12664','2013-08-02','09:00:00',2.18),('12664','2013-08-02','09:05:00',2.26),('12664','2013-08-02','09:10:00',2.33),('12664','2013-08-02','09:15:00',2.41),('12664','2013-08-02','09:20:00',2.49),('12664','2013-08-02','09:25:00',2.55),('12664','2013-08-02','09:30:00',2.63),('12664','2013-08-02','09:35:00',2.7),('12664','2013-08-02','09:40:00',2.77),('12664','2013-08-02','09:45:00',2.83),('12664','2013-08-02','09:50:00',2.89),('12664','2013-08-02','09:55:00',2.95),('12664','2013-08-02','10:00:00',2.99),('12664','2013-08-02','10:05:00',3.06),('12664','2013-08-02','10:10:00',3.11),('12664','2013-08-02','10:15:00',3.15),('12664','2013-08-02','10:20:00',3.21),('12664','2013-08-02','10:25:00',3.25),('12664','2013-08-02','10:30:00',3.3),('12664','2013-08-02','10:35:00',3.34),('12664','2013-08-02','10:40:00',3.38),('12664','2013-08-02','10:45:00',3.45),('12664','2013-08-02','10:50:00',3.5),('12664','2013-08-02','10:55:00',3.53),('12664','2013-08-02','11:00:00',3.56),('12664','2013-08-02','11:05:00',3.61),('12664','2013-08-02','11:10:00',3.64),('12664','2013-08-02','11:15:00',3.67),('12664','2013-08-02','11:20:00',3.71),('12664','2013-08-02','11:25:00',3.74),('12664','2013-08-02','11:30:00',3.77),('12664','2013-08-02','11:35:00',3.8),('12664','2013-08-02','11:40:00',3.81),('12664','2013-08-02','11:45:00',3.85),('12664','2013-08-02','11:50:00',3.87),('12664','2013-08-02','11:55:00',3.88),('12664','2013-08-02','12:00:00',3.88),('12664','2013-08-02','12:05:00',3.91),('12664','2013-08-02','12:10:00',3.93),('12664','2013-08-02','12:15:00',3.94),('12664','2013-08-02','12:20:00',3.95),('12664','2013-08-02','12:25:00',3.96),('12664','2013-08-02','12:30:00',3.99),('12664','2013-08-02','12:35:00',4.01),('12664','2013-08-02','12:40:00',4),('12664','2013-08-02','12:45:00',4.02),('12664','2013-08-02','12:50:00',4.02),('12664','2013-08-02','12:55:00',4.06),('12664','2013-08-02','13:00:00',4.05),('12664','2013-08-02','13:05:00',4.07),('12664','2013-08-02','13:10:00',4.07),('12664','2013-08-02','13:15:00',4.05),('12664','2013-08-02','13:20:00',4.04),('12664','2013-08-02','13:25:00',4.01),('12664','2013-08-02','13:30:00',4),('12664','2013-08-02','13:35:00',4),('12664','2013-08-02','13:40:00',3.97),('12664','2013-08-02','13:45:00',3.94),('12664','2013-08-02','13:50:00',3.94),('12664','2013-08-02','13:55:00',3.93),('12664','2013-08-02','14:00:00',3.89),('12664','2013-08-02','14:05:00',3.92),('12664','2013-08-02','14:10:00',3.86),('12664','2013-08-02','14:15:00',3.85),('12664','2013-08-02','14:20:00',3.86),('12664','2013-08-02','14:25:00',3.87),('12664','2013-08-02','14:30:00',3.85),('12664','2013-08-02','14:35:00',3.83),('12664','2013-08-02','14:40:00',3.79),('12664','2013-08-02','14:45:00',3.79),('12664','2013-08-02','14:50:00',3.76),('12664','2013-08-02','14:55:00',3.71),('12664','2013-08-02','15:00:00',3.66),('12664','2013-08-02','15:05:00',3.68),('12664','2013-08-02','15:10:00',3.65),('12664','2013-08-02','15:15:00',3.62),('12664','2013-08-02','15:20:00',3.59),('12664','2013-08-02','15:25:00',3.53),('12664','2013-08-02','15:30:00',3.49),('12664','2013-08-02','15:35:00',3.46),('12664','2013-08-02','15:40:00',3.43),('12664','2013-08-02','15:45:00',3.4),('12664','2013-08-02','15:50:00',3.34),('12664','2013-08-02','15:55:00',3.31),('12664','2013-08-02','16:00:00',3.25),('12664','2013-08-02','16:05:00',3.18),('12664','2013-08-02','16:10:00',3.1),('12664','2013-08-02','16:15:00',3.04),('12664','2013-08-02','16:20:00',2.97),('12664','2013-08-02','16:25:00',2.9),('12664','2013-08-02','16:30:00',2.83),('12664','2013-08-02','16:35:00',2.77),('12664','2013-08-02','16:40:00',2.71),('12664','2013-08-02','16:45:00',2.66),('12664','2013-08-02','16:50:00',2.6),('12664','2013-08-02','16:55:00',2.49),('12664','2013-08-02','17:00:00',2.39),('12664','2013-08-02','17:05:00',2.33),('12664','2013-08-02','17:10:00',2.28),('12664','2013-08-02','17:15:00',2.2),('12664','2013-08-02','17:20:00',2.13),('12664','2013-08-02','17:25:00',2.04),('12664','2013-08-02','17:30:00',1.95),('12664','2013-08-02','17:35:00',1.87),('12664','2013-08-02','17:40:00',1.76),('12664','2013-08-02','17:45:00',1.68),('12664','2013-08-02','17:50:00',1.6),('12664','2013-08-02','17:55:00',1.51),('12664','2013-08-02','18:00:00',1.43),('12664','2013-08-02','18:05:00',1.34),('12664','2013-08-02','18:10:00',1.26),('12664','2013-08-02','18:15:00',1.18),('12664','2013-08-02','18:20:00',1.08),('12664','2013-08-01','07:55:00',1.05),('12664','2013-08-01','08:00:00',1.15),('12664','2013-08-01','08:05:00',1.24),('12664','2013-08-01','08:10:00',1.33),('12664','2013-08-01','08:15:00',1.42),('12664','2013-08-01','08:20:00',1.51),('12664','2013-08-01','08:25:00',1.61),('12664','2013-08-01','08:30:00',1.7),('12664','2013-08-01','08:35:00',1.8),('12664','2013-08-01','08:40:00',1.87),('12664','2013-08-01','08:45:00',1.93),('12664','2013-08-01','08:50:00',2.01),('12664','2013-08-01','08:55:00',2.13),('12664','2013-08-01','09:00:00',2.21),('12664','2013-08-01','09:05:00',2.28),('12664','2013-08-01','09:10:00',2.37),('12664','2013-08-01','09:15:00',2.45),('12664','2013-08-01','09:20:00',2.53),('12664','2013-08-01','09:25:00',2.61),('12664','2013-08-01','09:30:00',2.69),('12664','2013-08-01','09:35:00',2.77),('12664','2013-08-01','09:40:00',2.86),('12664','2013-08-01','09:45:00',2.93),('12664','2013-08-01','09:50:00',3.01),('12664','2013-08-01','09:55:00',3.08),('12664','2013-08-01','10:00:00',3.15),('12664','2013-08-01','10:05:00',3.22),('12664','2013-08-01','10:10:00',3.28),('12664','2013-08-01','10:15:00',3.33),('12664','2013-08-01','10:20:00',3.39),('12664','2013-08-01','10:25:00',3.45),('12664','2013-08-01','10:30:00',3.5),('12664','2013-08-01','10:35:00',3.54),('12664','2013-08-01','10:40:00',3.63),('12664','2013-08-01','10:45:00',3.67),('12664','2013-08-01','10:50:00',3.73),('12664','2013-08-01','10:55:00',3.75),('12664','2013-08-01','11:00:00',3.77),('12664','2013-08-01','11:05:00',3.84),('12664','2013-08-01','11:10:00',3.89),('12664','2013-08-01','11:15:00',3.92),('12664','2013-08-01','11:20:00',3.96),('12664','2013-08-01','11:25:00',3.99),('12664','2013-08-01','11:30:00',4.04),('12664','2013-08-01','11:35:00',4.05),('12664','2013-08-01','11:40:00',4.08),('12664','2013-08-01','11:45:00',4.11),('12664','2013-08-01','11:50:00',4.12),('12664','2013-08-01','11:55:00',4.14),('12664','2013-08-01','12:00:00',4.16),('12664','2013-08-01','12:05:00',4.18),('12664','2013-08-01','12:10:00',4.21),('12664','2013-08-01','12:15:00',4.24),('12664','2013-08-01','12:20:00',4.26),('12664','2013-08-01','12:25:00',4.28),('12664','2013-08-01','12:30:00',4.29),('12664','2013-08-01','12:35:00',4.26),('12664','2013-08-01','12:40:00',4.29),('12664','2013-08-01','12:45:00',4.3),('12664','2013-08-01','12:50:00',4.29),('12664','2013-08-01','12:55:00',4.28),('12664','2013-08-01','13:00:00',4.27),('12664','2013-08-01','13:05:00',4.27),('12664','2013-08-01','13:10:00',4.27),('12664','2013-08-01','13:15:00',4.28),('12664','2013-08-01','13:20:00',4.3),('12664','2013-08-01','13:25:00',4.29),('12664','2013-08-01','13:30:00',4.27),('12664','2013-08-01','13:35:00',4.27),('12664','2013-08-01','13:40:00',4.26),('12664','2013-08-01','13:45:00',4.26),('12664','2013-08-01','13:50:00',4.22),('12664','2013-08-01','13:55:00',4.2),('12664','2013-08-01','14:00:00',4.22),('12664','2013-08-01','14:05:00',4.22),('12664','2013-08-01','14:10:00',4.17),('12664','2013-08-01','14:15:00',4.12),('12664','2013-08-01','14:20:00',4.09),('12664','2013-08-01','14:25:00',4.09),('12664','2013-08-01','14:30:00',4.06),('12664','2013-08-01','14:35:00',4.04),('12664','2013-08-01','14:40:00',4.01),('12664','2013-08-01','14:45:00',3.94),('12664','2013-08-01','14:50:00',3.93),('12664','2013-08-01','14:55:00',3.92),('12664','2013-08-01','15:00:00',3.88),('12664','2013-08-01','15:05:00',3.83),('12664','2013-08-01','15:10:00',3.79),('12664','2013-08-01','15:15:00',3.76),('12664','2013-08-01','15:20:00',3.7),('12664','2013-08-01','15:25:00',3.64),('12664','2013-08-01','15:30:00',3.6),('12664','2013-08-01','15:35:00',3.55),('12664','2013-08-01','15:40:00',3.52),('12664','2013-08-01','15:45:00',3.47),('12664','2013-08-01','15:50:00',3.39),('12664','2013-08-01','15:55:00',3.33),('12664','2013-08-01','16:00:00',3.27),('12664','2013-08-01','16:05:00',3.21),('12664','2013-08-01','16:10:00',3.15),('12664','2013-08-01','16:15:00',3.09),('12664','2013-08-01','16:20:00',3.01),('12664','2013-08-01','16:25:00',2.96),('12664','2013-08-01','16:30:00',2.88),('12664','2013-08-01','16:35:00',2.81),('12664','2013-08-01','16:40:00',2.75),('12664','2013-08-01','16:45:00',2.68),('12664','2013-08-01','16:50:00',2.6),('12664','2013-08-01','16:55:00',2.53),('12664','2013-08-01','17:00:00',2.45),('12664','2013-08-01','17:05:00',2.38),('12664','2013-08-01','17:10:00',2.3),('12664','2013-08-01','17:15:00',2.22),('12664','2013-08-01','17:20:00',2.15),('12664','2013-08-01','17:25:00',2.06),('12664','2013-08-01','17:30:00',1.99),('12664','2013-08-01','17:35:00',1.88),('12664','2013-08-01','17:40:00',1.79),('12664','2013-08-01','17:45:00',1.7),('12664','2013-08-01','17:50:00',1.6),('12664','2013-08-01','17:55:00',1.51),('12664','2013-08-01','18:00:00',1.44),('12664','2013-08-01','18:05:00',1.34),('12664','2013-08-01','18:10:00',1.25),('12664','2013-08-01','18:15:00',1.18),('12664','2013-08-01','18:20:00',1.1),('12664','2013-08-01','18:25:00',1),('12664','2013-07-31','07:55:00',1.08),('12664','2013-07-31','08:00:00',1.17),('12664','2013-07-31','08:05:00',1.26),('12664','2013-07-31','08:10:00',1.35),('12664','2013-07-31','08:15:00',1.43),('12664','2013-07-31','08:20:00',1.53),('12664','2013-07-31','08:25:00',1.62),('12664','2013-07-31','08:30:00',1.71),('12664','2013-07-31','08:35:00',1.8),('12664','2013-07-31','08:40:00',1.88),('12664','2013-07-31','08:45:00',1.97),('12664','2013-07-31','08:50:00',2.05),('12664','2013-07-31','08:55:00',2.13),('12664','2013-07-31','09:00:00',2.21),('12664','2013-07-31','09:05:00',2.29),('12664','2013-07-31','09:10:00',2.37),('12664','2013-07-31','09:15:00',2.44),('12664','2013-07-31','09:20:00',2.51),('12664','2013-07-31','09:25:00',2.59),('12664','2013-07-31','09:30:00',2.66),('12664','2013-07-31','09:35:00',2.73),('12664','2013-07-31','09:40:00',2.81),('12664','2013-07-31','09:45:00',2.88),('12664','2013-07-31','09:50:00',2.94),('12664','2013-07-31','09:55:00',3),('12664','2013-07-31','10:00:00',3.07),('12664','2013-07-31','10:05:00',3.11),('12664','2013-07-31','10:10:00',3.17),('12664','2013-07-31','10:15:00',3.23),('12664','2013-07-31','10:20:00',3.3),('12664','2013-07-31','10:25:00',3.36),('12664','2013-07-31','10:30:00',3.43),('12664','2013-07-31','10:35:00',3.51),('12664','2013-07-31','10:40:00',3.56),('12664','2013-07-31','10:45:00',3.6),('12664','2013-07-31','10:50:00',3.66),('12664','2013-07-31','10:55:00',3.71),('12664','2013-07-31','11:00:00',3.77),('12664','2013-07-31','11:05:00',3.8),('12664','2013-07-31','11:10:00',3.82),('12664','2013-07-31','11:15:00',3.86),('12664','2013-07-31','11:20:00',3.89),('12664','2013-07-31','11:25:00',3.95),('12664','2013-07-31','11:30:00',3.96),('12664','2013-07-31','11:35:00',4.01),('12664','2013-07-31','11:40:00',4.07),('12664','2013-07-31','11:45:00',4.07),('12664','2013-07-31','11:50:00',4.09),('12664','2013-07-31','11:55:00',4.11),('12664','2013-07-31','12:00:00',4.16),('12664','2013-07-31','12:05:00',4.16),('12664','2013-07-31','12:10:00',4.15),('12664','2013-07-31','12:15:00',4.2),('12664','2013-07-31','12:20:00',4.21),('12664','2013-07-31','12:25:00',4.23),('12664','2013-07-31','12:30:00',4.25),('12664','2013-07-31','12:35:00',4.27),('12664','2013-07-31','12:40:00',4.26),('12664','2013-07-31','12:45:00',4.27),('12664','2013-07-31','12:50:00',4.26),('12664','2013-07-31','12:55:00',4.26),('12664','2013-07-31','13:00:00',4.25),('12664','2013-07-31','13:05:00',4.24),('12664','2013-07-31','13:10:00',4.27),('12664','2013-07-31','13:15:00',4.29),('12664','2013-07-31','13:20:00',4.27),('12664','2013-07-31','13:25:00',4.29),('12664','2013-07-31','13:30:00',4.27),('12664','2013-07-31','13:35:00',4.24),('12664','2013-07-31','13:40:00',4.25),('12664','2013-07-31','13:45:00',4.22),('12664','2013-07-31','13:50:00',4.18),('12664','2013-07-31','13:55:00',4.18),('12664','2013-07-31','14:00:00',4.22),('12664','2013-07-31','14:05:00',4.21),('12664','2013-07-31','14:10:00',4.16),('12664','2013-07-31','14:15:00',4.18),('12664','2013-07-31','14:20:00',4.14),('12664','2013-07-31','14:25:00',4.07),('12664','2013-07-31','14:30:00',4.04),('12664','2013-07-31','14:35:00',4.01),('12664','2013-07-31','14:40:00',3.97),('12664','2013-07-31','14:45:00',3.92),('12664','2013-07-31','14:50:00',3.89),('12664','2013-07-31','14:55:00',3.88),('12664','2013-07-31','15:00:00',3.54),('12664','2013-07-31','15:05:00',2.8),('12664','2013-07-31','15:10:00',3.31),('12664','2013-07-31','15:15:00',3.8),('12664','2013-07-31','15:20:00',3.67),('12664','2013-07-31','15:25:00',3.59),('12664','2013-07-31','15:30:00',3.55),('12664','2013-07-31','15:35:00',3.46),('12664','2013-07-31','15:40:00',3.4),('12664','2013-07-31','15:45:00',3.41),('12664','2013-07-31','15:50:00',2.79),('12664','2013-07-31','15:55:00',1.78),('12664','2013-07-31','16:00:00',3.31),('12664','2013-07-31','16:05:00',3.28),('12664','2013-07-31','16:10:00',3.22),('12664','2013-07-31','16:15:00',3.19),('12664','2013-07-31','16:20:00',3.02),('12664','2013-07-31','16:25:00',2.35),('12664','2013-07-31','16:30:00',2.69),('12664','2013-07-31','16:35:00',2.91),('12664','2013-07-31','16:40:00',2.84),('12664','2013-07-31','16:45:00',2.75),('12664','2013-07-31','16:50:00',2.72),('12664','2013-07-31','16:55:00',2.42),('12664','2013-07-31','17:00:00',1.82),('12664','2013-07-31','17:05:00',1.24),('12664','2013-07-31','17:10:00',1.99),('12664','2013-07-31','17:15:00',2.16),('12664','2013-07-31','17:20:00',2.2),('12664','2013-07-31','17:25:00',2.11),('12664','2013-07-31','17:30:00',2.01),('12664','2013-07-31','17:35:00',1.89),('12664','2013-07-31','17:40:00',1.83),('12664','2013-07-31','17:45:00',1.73),('12664','2013-07-31','17:50:00',1.64),('12664','2013-07-31','17:55:00',1.54),('12664','2013-07-31','18:00:00',1.47),('12664','2013-07-31','18:05:00',1.39),('12664','2013-07-31','18:10:00',1.29),('12664','2013-07-31','18:15:00',1.22),('12664','2013-07-31','18:20:00',1.14),('12664','2013-07-31','18:25:00',1.05),('12664','2013-07-30','08:00:00',1.12),('12664','2013-07-30','08:05:00',1.23),('12664','2013-07-30','08:10:00',1.32),('12664','2013-07-30','08:15:00',1.4),('12664','2013-07-30','08:20:00',1.48),('12664','2013-07-30','08:25:00',1.57),('12664','2013-07-30','08:30:00',1.67),('12664','2013-07-30','08:35:00',1.78),('12664','2013-07-30','08:40:00',1.86),('12664','2013-07-30','08:45:00',1.93),('12664','2013-07-30','08:50:00',2.09),('12664','2013-07-30','08:55:00',2.2),('12664','2013-07-30','09:00:00',2.34),('12664','2013-07-30','09:05:00',2.46),('12664','2013-07-30','09:10:00',2.47),('12664','2013-07-30','09:15:00',2.12),('12664','2013-07-30','09:20:00',1.37),('12664','2013-07-30','09:25:00',1.37),('12664','2013-07-30','09:30:00',1.59),('12664','2013-07-30','09:45:00',1.98),('12664','2013-07-30','09:50:00',3.01),('12664','2013-07-30','09:55:00',1.55),('12664','2013-07-30','10:25:00',2.37),('12664','2013-07-30','10:30:00',3.67),('12664','2013-07-30','10:35:00',3.63),('12664','2013-07-30','10:40:00',3.61),('12664','2013-07-30','10:45:00',3.62),('12664','2013-07-30','10:50:00',3.6),('12664','2013-07-30','10:55:00',3.62),('12664','2013-07-30','11:00:00',3.67),('12664','2013-07-30','11:05:00',3.72),('12664','2013-07-30','11:10:00',3.78),('12664','2013-07-30','11:15:00',3.8),('12664','2013-07-30','11:20:00',3.92),('12664','2013-07-30','11:25:00',3.14),('12664','2013-07-30','11:30:00',1.08),('12664','2013-07-30','11:35:00',2.9),('12664','2013-07-30','11:40:00',2.45),('12664','2013-07-30','11:45:00',1.57),('12664','2013-07-30','11:50:00',2.13),('12664','2013-07-30','11:55:00',3.84),('12664','2013-07-30','12:00:00',4.28),('12664','2013-07-30','12:05:00',4.2),('12664','2013-07-30','12:10:00',4.25),('12664','2013-07-30','12:15:00',4.17),('12664','2013-07-30','12:20:00',4.13),('12664','2013-07-30','12:25:00',4.16),('12664','2013-07-30','12:30:00',3.84),('12664','2013-07-30','12:35:00',3.34),('12664','2013-07-30','12:40:00',3.88),('12664','2013-07-30','12:45:00',2.94),('12664','2013-07-30','12:50:00',4.31),('12664','2013-07-30','12:55:00',4.53),('12664','2013-07-30','13:00:00',2.58),('12664','2013-07-30','13:05:00',3.18),('12664','2013-07-30','13:10:00',4.4),('12664','2013-07-30','13:15:00',4.43),('12664','2013-07-30','13:20:00',4.34),('12664','2013-07-30','13:25:00',4.28),('12664','2013-07-30','13:30:00',4.24),('12664','2013-07-30','13:35:00',4.23),('12664','2013-07-30','13:40:00',2.97),('12664','2013-07-30','13:45:00',3.81),('12664','2013-07-30','13:50:00',4.3),('12664','2013-07-30','13:55:00',4.24),('12664','2013-07-30','14:00:00',4.07),('12664','2013-07-30','14:05:00',3.99),('12664','2013-07-30','14:10:00',4.1),('12664','2013-07-30','14:15:00',4.05),('12664','2013-07-30','14:20:00',3.92),('12664','2013-07-30','14:25:00',4.05),('12664','2013-07-30','14:30:00',3.92),('12664','2013-07-30','14:35:00',3.99),('12664','2013-07-30','14:40:00',3.96),('12664','2013-07-30','14:45:00',3.92),('12664','2013-07-30','14:50:00',3.85),('12664','2013-07-30','14:55:00',3.86),('12664','2013-07-30','15:00:00',3.83),('12664','2013-07-30','15:05:00',3.74),('12664','2013-07-30','15:10:00',3.7),('12664','2013-07-30','15:15:00',3.66),('12664','2013-07-30','15:20:00',3.62),('12664','2013-07-30','15:25:00',3.58),('12664','2013-07-30','15:30:00',3.52),('12664','2013-07-30','15:35:00',3.48),('12664','2013-07-30','15:40:00',3.46),('12664','2013-07-30','15:45:00',3.4),('12664','2013-07-30','15:50:00',3.34),('12664','2013-07-30','15:55:00',3.27),('12664','2013-07-30','16:00:00',3.22),('12664','2013-07-30','16:05:00',3.18),('12664','2013-07-30','16:10:00',3.11),('12664','2013-07-30','16:15:00',3.02),('12664','2013-07-30','16:20:00',2.94),('12664','2013-07-30','16:25:00',2.9),('12664','2013-07-30','16:30:00',2.82),('12664','2013-07-30','16:35:00',2.72),('12664','2013-07-30','16:40:00',2.7),('12664','2013-07-30','16:45:00',2.66),('12664','2013-07-30','16:50:00',2.54),('12664','2013-07-30','16:55:00',2.47),('12664','2013-07-30','17:00:00',2.42),('12664','2013-07-30','17:05:00',2.33),('12664','2013-07-30','17:10:00',2.26),('12664','2013-07-30','17:15:00',2.18),('12664','2013-07-30','17:20:00',2.11),('12664','2013-07-30','17:25:00',2.02),('12664','2013-07-30','17:30:00',1.94),('12664','2013-07-30','17:35:00',1.85),('12664','2013-07-30','17:40:00',1.78),('12664','2013-07-30','17:45:00',1.68),('12664','2013-07-30','17:50:00',1.59),('12664','2013-07-30','17:55:00',1.51),('12664','2013-07-30','18:00:00',1.43),('12664','2013-07-30','18:05:00',1.33),('12664','2013-07-30','18:10:00',1.25),('12664','2013-07-30','18:15:00',1.17),('12664','2013-07-30','18:20:00',1.08),('12664','2014-04-07','08:25:00',1.11),('12664','2014-04-07','08:30:00',1.05),('12664','2014-04-07','09:35:00',1.01),('12664','2014-04-07','09:40:00',1.04),('12664','2014-04-07','09:45:00',1.05),('12664','2014-04-07','09:50:00',1.06),('12664','2014-04-07','09:55:00',1.08),('12664','2014-04-07','10:00:00',1.08),('12664','2014-04-07','10:05:00',1.09),('12664','2014-04-07','10:10:00',1.12),('12664','2014-04-07','10:15:00',1.14),('12664','2014-04-07','10:20:00',1.14),('12664','2014-04-07','10:25:00',1.12),('12664','2014-04-07','10:30:00',1.14),('12664','2014-04-07','10:35:00',1.19),('12664','2014-04-07','10:40:00',1.27),('12664','2014-04-07','10:45:00',1.32),('12664','2014-04-07','10:50:00',1.35),('12664','2014-04-07','10:55:00',1.39),('12664','2014-04-07','11:00:00',1.4),('12664','2014-04-07','11:05:00',1.41),('12664','2014-04-07','11:10:00',1.46),('12664','2014-04-07','11:15:00',1.49),('12664','2014-04-07','11:20:00',1.52),('12664','2014-04-07','11:25:00',1.56),('12664','2014-04-07','11:30:00',1.46),('12664','2014-04-07','11:35:00',1.4),('12664','2014-04-07','11:40:00',1.39),('12664','2014-04-07','11:45:00',1.42),('12664','2014-04-07','11:50:00',1.53),('12664','2014-04-07','11:55:00',1.78),('12664','2014-04-07','12:00:00',2.19),('12664','2014-04-07','12:05:00',3.25),('12664','2014-04-07','12:10:00',4.07),('12664','2014-04-07','12:15:00',4.15),('12664','2014-04-07','12:20:00',3.68),('12664','2014-04-07','12:25:00',2.05),('12664','2014-04-07','12:30:00',2.5),('12664','2014-04-07','12:35:00',4.13),('12664','2014-04-07','12:40:00',4),('12664','2014-04-07','12:45:00',3.9),('12664','2014-04-07','12:50:00',3.85),('12664','2014-04-07','12:55:00',3.83),('12664','2014-04-07','13:00:00',3.84),('12664','2014-04-07','13:05:00',3.79),('12664','2014-04-07','13:10:00',3.79),('12664','2014-04-07','13:15:00',3.79),('12664','2014-04-07','13:20:00',3.78),('12664','2014-04-07','13:25:00',3.76),('12664','2014-04-07','13:30:00',3.78),('12664','2014-04-07','13:35:00',3.85),('12664','2014-04-07','13:40:00',3.82),('12664','2014-04-07','13:45:00',3.76),('12664','2014-04-07','13:50:00',3.72),('12664','2014-04-07','13:55:00',3.74),('12664','2014-04-07','14:00:00',3.7),('12664','2014-04-07','14:05:00',3.7),('12664','2014-04-07','14:10:00',3.71),('12664','2014-04-07','14:15:00',3.7),('12664','2014-04-07','14:20:00',3.68),('12664','2014-04-07','14:25:00',3.64),('12664','2014-04-07','14:30:00',3.63),('12664','2014-04-07','14:35:00',3.53),('12664','2014-04-07','14:40:00',3.45),('12664','2014-04-07','14:45:00',3.68),('12664','2014-04-07','14:50:00',3.56),('12664','2014-04-07','14:55:00',3.5),('12664','2014-04-07','15:00:00',3.48),('12664','2014-04-07','15:05:00',3.43),('12664','2014-04-07','15:10:00',3.41),('12664','2014-04-07','15:15:00',3.35),('12664','2014-04-07','15:20:00',3.28),('12664','2014-04-07','15:25:00',3.24),('12664','2014-04-07','15:30:00',3.19),('12664','2014-04-07','15:35:00',3.15),('12664','2014-04-07','15:40:00',3.09),('12664','2014-04-07','15:45:00',3.07),('12664','2014-04-07','15:50:00',3.03),('12664','2014-04-07','15:55:00',2.96),('12664','2014-04-07','16:00:00',2.94),('12664','2014-04-07','16:05:00',3.01),('12664','2014-04-07','16:10:00',2.41),('12664','2014-04-07','16:35:00',1.37),('12664','2014-04-07','16:45:00',1.95),('12664','2014-04-07','16:50:00',2.15),('12664','2014-04-07','16:55:00',2.26),('12664','2014-04-07','17:00:00',2.23),('12664','2014-04-07','17:05:00',2.29),('12664','2014-04-07','17:10:00',2.25),('12664','2014-04-07','17:15:00',2.13),('12664','2014-04-07','17:20:00',2.11),('12664','2014-04-07','17:25:00',1.9),('12664','2014-04-07','17:30:00',1.84),('12664','2014-04-07','17:35:00',1.8),('12664','2014-04-07','17:40:00',1.66),('12664','2014-04-07','17:45:00',1.41),('12664','2014-04-07','17:50:00',1.06),('12664','2013-07-29','08:00:00',1.04),('12664','2013-07-29','08:05:00',1.09),('12664','2013-07-29','08:10:00',1.17),('12664','2013-07-29','08:15:00',1.27),('12664','2013-07-29','08:20:00',1.37),('12664','2013-07-29','08:25:00',1.45),('12664','2013-07-29','08:30:00',1.54),('12664','2013-07-29','08:35:00',1.63),('12664','2013-07-29','08:40:00',1.72),('12664','2013-07-29','08:45:00',1.78),('12664','2013-07-29','08:50:00',1.86),('12664','2013-07-29','08:55:00',1.93),('12664','2013-07-29','09:00:00',2.03),('12664','2013-07-29','09:05:00',2.1),('12664','2013-07-29','09:10:00',2.17),('12664','2013-07-29','09:15:00',2.27),('12664','2013-07-29','09:20:00',2.34),('12664','2013-07-29','09:25:00',2.43),('12664','2013-07-29','09:30:00',2.5),('12664','2013-07-29','09:35:00',2.56),('12664','2013-07-29','09:40:00',2.63),('12664','2013-07-29','09:45:00',2.68),('12664','2013-07-29','09:50:00',2.76),('12664','2013-07-29','09:55:00',2.81),('12664','2013-07-29','10:00:00',2.86),('12664','2013-07-29','10:05:00',2.93),('12664','2013-07-29','10:10:00',2.99),('12664','2013-07-29','10:15:00',3),('12664','2013-07-29','10:20:00',3.06),('12664','2013-07-29','10:25:00',3.14),('12664','2013-07-29','10:30:00',3.19),('12664','2013-07-29','10:35:00',3.22),('12664','2013-07-29','10:40:00',3.25),('12664','2013-07-29','10:45:00',3.3),('12664','2013-07-29','10:50:00',3.36),('12664','2013-07-29','10:55:00',3.39),('12664','2013-07-29','11:00:00',3.44),('12664','2013-07-29','11:05:00',3.49),('12664','2013-07-29','11:10:00',3.53),('12664','2013-07-29','11:15:00',3.54),('12664','2013-07-29','11:20:00',3.59),('12664','2013-07-29','11:25:00',3.62),('12664','2013-07-29','11:30:00',3.63),('12664','2013-07-29','11:35:00',3.67),('12664','2013-07-29','11:40:00',3.68),('12664','2013-07-29','11:45:00',3.72),('12664','2013-07-29','11:50:00',3.77),('12664','2013-07-29','11:55:00',3.79),('12664','2013-07-29','12:00:00',3.78),('12664','2013-07-29','12:05:00',3.84),('12664','2013-07-29','12:10:00',3.84),('12664','2013-07-29','12:15:00',3.83),('12664','2013-07-29','12:20:00',3.88),('12664','2013-07-29','12:25:00',3.89),('12664','2013-07-29','12:30:00',3.9),('12664','2013-07-29','12:35:00',3.91),('12664','2013-07-29','12:40:00',3.92),('12664','2013-07-29','12:45:00',3.93),('12664','2013-07-29','12:50:00',3.98),('12664','2013-07-29','12:55:00',4.04),('12664','2013-07-29','13:00:00',4.05),('12664','2013-07-29','13:05:00',4.04),('12664','2013-07-29','13:10:00',4.07),('12664','2013-07-29','13:15:00',4.09),('12664','2013-07-29','13:20:00',4.1),('12664','2013-07-29','13:25:00',4.12),('12664','2013-07-29','13:30:00',4.12),('12664','2013-07-29','13:35:00',4.11),('12664','2013-07-29','13:40:00',4.07),('12664','2013-07-29','13:45:00',4.07),('12664','2013-07-29','13:50:00',4.06),('12664','2013-07-29','13:55:00',4.05),('12664','2013-07-29','14:00:00',4.04),('12664','2013-07-29','14:05:00',4.01),('12664','2013-07-29','14:10:00',4.02),('12664','2013-07-29','14:15:00',3.99),('12664','2013-07-29','14:20:00',3.95),('12664','2013-07-29','14:25:00',3.93),('12664','2013-07-29','14:30:00',3.9),('12664','2013-07-29','14:35:00',3.88),('12664','2013-07-29','14:40:00',3.85),('12664','2013-07-29','14:45:00',3.84),('12664','2013-07-29','14:50:00',3.78),('12664','2013-07-29','14:55:00',3.74),('12664','2013-07-29','15:00:00',3.71),('12664','2013-07-29','15:05:00',3.68),('12664','2013-07-29','15:10:00',3.65),('12664','2013-07-29','15:15:00',3.61),('12664','2013-07-29','15:20:00',3.57),('12664','2013-07-29','15:25:00',3.56),('12664','2013-07-29','15:30:00',3.55),('12664','2013-07-29','15:35:00',3.55),('12664','2013-07-29','15:40:00',2.59),('12664','2013-07-29','15:45:00',2.88),('12664','2013-07-29','15:50:00',2.18),('12664','2013-07-29','15:55:00',2.61),('12664','2013-07-29','16:00:00',2.94),('12664','2013-07-29','16:05:00',2.61),('12664','2013-07-29','16:10:00',2.99),('12664','2013-07-29','16:15:00',2.86),('12664','2013-07-29','16:20:00',2.25),('12664','2013-07-29','16:25:00',2.96),('12664','2013-07-29','16:30:00',3.01),('12664','2013-07-29','16:35:00',2.81),('12664','2013-07-29','16:40:00',2.59),('12664','2013-07-29','16:45:00',1.98),('12664','2013-07-29','16:50:00',1.25),('12664','2013-07-29','16:55:00',1.34),('12664','2013-07-29','17:00:00',1.89),('12664','2013-07-29','17:05:00',1.87),('12664','2013-07-29','17:10:00',2.66),('12664','2013-07-29','17:15:00',2.05),('12664','2013-07-29','17:20:00',1.76),('12664','2013-07-29','17:25:00',1.42),('12664','2013-07-29','17:35:00',1.44),('12664','2013-07-29','17:40:00',2.14),('12664','2013-07-29','17:45:00',1.79),('12664','2013-07-29','17:50:00',1.35),('12664','2013-07-29','18:00:00',1.35),('12664','2013-07-29','18:05:00',1.35),('12664','2013-07-29','18:10:00',1.34),('12664','2013-07-29','18:15:00',1.27),('12664','2013-07-29','18:20:00',1.14),('12664','2013-07-29','18:25:00',1.04),('12664','2013-07-28','08:00:00',1.04),('12664','2013-07-28','08:05:00',1.12),('12664','2013-07-28','08:10:00',1.21),('12664','2013-07-28','08:15:00',1.29),('12664','2013-07-28','08:20:00',1.37),('12664','2013-07-28','08:25:00',1.46),('12664','2013-07-28','08:30:00',1.55),('12664','2013-07-28','08:35:00',1.61),('12664','2013-07-28','08:40:00',1.7),('12664','2013-07-28','08:45:00',1.82),('12664','2013-07-28','08:50:00',1.89),('12664','2013-07-28','08:55:00',1.97),('12664','2013-07-28','09:00:00',2.06),('12664','2013-07-28','09:05:00',2.11),('12664','2013-07-28','09:10:00',2.18),('12664','2013-07-28','09:15:00',2.25),('12664','2013-07-28','09:20:00',2.34),('12664','2013-07-28','09:25:00',2.42),('12664','2013-07-28','09:30:00',2.44),('12664','2013-07-28','09:35:00',2.53),('12664','2013-07-28','09:40:00',2.61),('12664','2013-07-28','09:45:00',2.66),('12664','2013-07-28','09:50:00',2.73),('12664','2013-07-28','09:55:00',2.78),('12664','2013-07-28','10:00:00',2.86),('12664','2013-07-28','10:05:00',2.9),('12664','2013-07-28','10:10:00',2.94),('12664','2013-07-28','10:15:00',2.97),('12664','2013-07-28','10:20:00',3),('12664','2013-07-28','10:25:00',3.1),('12664','2013-07-28','10:30:00',3.16),('12664','2013-07-28','10:35:00',3.19),('12664','2013-07-28','10:40:00',3.2),('12664','2013-07-28','10:45:00',3.28),('12664','2013-07-28','10:50:00',3.3),('12664','2013-07-28','10:55:00',3.38),('12664','2013-07-28','11:00:00',3.44),('12664','2013-07-28','11:05:00',3.48),('12664','2013-07-28','11:10:00',3.5),('12664','2013-07-28','11:15:00',3.51),('12664','2013-07-28','11:20:00',3.6),('12664','2013-07-28','11:25:00',3.63),('12664','2013-07-28','11:30:00',3.65),('12664','2013-07-28','11:35:00',3.59),('12664','2013-07-28','11:40:00',3.65),('12664','2013-07-28','11:45:00',3.73),('12664','2013-07-28','11:50:00',3.8),('12664','2013-07-28','11:55:00',3.81),('12664','2013-07-28','12:00:00',3.8),('12664','2013-07-28','12:05:00',3.85),('12664','2013-07-28','12:10:00',3.85),('12664','2013-07-28','12:15:00',3.84),('12664','2013-07-28','12:20:00',3.9),('12664','2013-07-28','12:25:00',3.94),('12664','2013-07-28','12:30:00',3.91),('12664','2013-07-28','12:35:00',3.95),('12664','2013-07-28','12:40:00',4.01),('12664','2013-07-28','12:45:00',3.96),('12664','2013-07-28','12:50:00',3.99),('12664','2013-07-28','12:55:00',3.99),('12664','2013-07-28','13:00:00',4.01),('12664','2013-07-28','13:05:00',4.04),('12664','2013-07-28','13:10:00',4.02),('12664','2013-07-28','13:15:00',4.01),('12664','2013-07-28','13:20:00',4.02),('12664','2013-07-28','13:25:00',4.02),('12664','2013-07-28','13:30:00',4.05),('12664','2013-07-28','13:35:00',4.03),('12664','2013-07-28','13:40:00',4.03),('12664','2013-07-28','13:45:00',4),('12664','2013-07-28','13:50:00',4),('12664','2013-07-28','13:55:00',3.98),('12664','2013-07-28','14:00:00',3.97),('12664','2013-07-28','14:05:00',3.95),('12664','2013-07-28','14:10:00',3.95),('12664','2013-07-28','14:15:00',3.93),('12664','2013-07-28','14:20:00',3.92),('12664','2013-07-28','14:25:00',3.9),('12664','2013-07-28','14:30:00',3.89),('12664','2013-07-28','14:35:00',3.86),('12664','2013-07-28','14:40:00',3.82),('12664','2013-07-28','14:45:00',3.78),('12664','2013-07-28','14:50:00',3.74),('12664','2013-07-28','14:55:00',3.71),('12664','2013-07-28','15:00:00',3.65),('12664','2013-07-28','15:05:00',3.62),('12664','2013-07-28','15:10:00',3.6),('12664','2013-07-28','15:15:00',3.57),('12664','2013-07-28','15:20:00',3.54),('12664','2013-07-28','15:25:00',3.5),('12664','2013-07-28','15:30:00',3.47),('12664','2013-07-28','15:35:00',3.44),('12664','2013-07-28','15:40:00',3.4),('12664','2013-07-28','15:45:00',3.37),('12664','2013-07-28','15:50:00',3.32),('12664','2013-07-28','15:55:00',3.26),('12664','2013-07-28','16:00:00',3.21),('12664','2013-07-28','16:05:00',3.17),('12664','2013-07-28','16:10:00',3.11),('12664','2013-07-28','16:15:00',3.05),('12664','2013-07-28','16:20:00',2.99),('12664','2013-07-28','16:25:00',2.92),('12664','2013-07-28','16:30:00',2.86),('12664','2013-07-28','16:35:00',2.79),('12664','2013-07-28','16:40:00',2.73),('12664','2013-07-28','16:45:00',2.67),('12664','2013-07-28','16:50:00',2.58),('12664','2013-07-28','16:55:00',2.51),('12664','2013-07-28','17:00:00',2.45),('12664','2013-07-28','17:05:00',2.37),('12664','2013-07-28','17:10:00',2.29),('12664','2013-07-28','17:15:00',2.21),('12664','2013-07-28','17:20:00',2.14),('12664','2013-07-28','17:25:00',2.06),('12664','2013-07-28','17:30:00',1.98),('12664','2013-07-28','17:35:00',1.89),('12664','2013-07-28','17:40:00',1.81),('12664','2013-07-28','17:45:00',1.72),('12664','2013-07-28','17:50:00',1.63),('12664','2013-07-28','17:55:00',1.54),('12664','2013-07-28','18:00:00',1.44),('12664','2013-07-28','18:05:00',1.36),('12664','2013-07-28','18:10:00',1.28),('12664','2013-07-28','18:15:00',1.19),('12664','2013-07-28','18:20:00',1.12),('12664','2013-07-28','18:25:00',1.02),('12664','2013-07-27','08:00:00',1.07),('12664','2013-07-27','08:05:00',1.15),('12664','2013-07-27','08:10:00',1.22),('12664','2013-07-27','08:15:00',1.3),('12664','2013-07-27','08:20:00',1.4),('12664','2013-07-27','08:25:00',1.48),('12664','2013-07-27','08:30:00',1.57),('12664','2013-07-27','08:35:00',1.67),('12664','2013-07-27','08:40:00',1.76),('12664','2013-07-27','08:45:00',1.83),('12664','2013-07-27','08:50:00',1.91),('12664','2013-07-27','08:55:00',1.99),('12664','2013-07-27','09:00:00',2.07),('12664','2013-07-27','09:05:00',2.17),('12664','2013-07-27','09:10:00',2.24),('12664','2013-07-27','09:15:00',2.32),('12664','2013-07-27','09:20:00',2.41),('12664','2013-07-27','09:25:00',2.47),('12664','2013-07-27','09:30:00',2.52),('12664','2013-07-27','09:35:00',2.6),('12664','2013-07-27','09:40:00',2.66),('12664','2013-07-27','09:45:00',2.73),('12664','2013-07-27','09:50:00',2.79),('12664','2013-07-27','09:55:00',2.85),('12664','2013-07-27','10:00:00',2.94),('12664','2013-07-27','10:05:00',3),('12664','2013-07-27','10:10:00',3.06),('12664','2013-07-27','10:15:00',3.11),('12664','2013-07-27','10:20:00',3.14),('12664','2013-07-27','10:25:00',3.2),('12664','2013-07-27','10:30:00',3.22),('12664','2013-07-27','10:35:00',3.29),('12664','2013-07-27','10:40:00',3.31),('12664','2013-07-27','10:45:00',3.35),('12664','2013-07-27','10:50:00',3.4),('12664','2013-07-27','10:55:00',3.47),('12664','2013-07-27','11:00:00',3.54),('12664','2013-07-27','11:05:00',3.59),('12664','2013-07-27','11:10:00',3.6),('12664','2013-07-27','11:15:00',3.62),('12664','2013-07-27','11:20:00',3.63),('12664','2013-07-27','11:25:00',3.68),('12664','2013-07-27','11:30:00',3.7),('12664','2013-07-27','11:35:00',3.7),('12664','2013-07-27','11:40:00',3.71),('12664','2013-07-27','11:45:00',3.71),('12664','2013-07-27','11:50:00',3.71),('12664','2013-07-27','11:55:00',3.85),('12664','2013-07-27','12:00:00',3.74),('12664','2013-07-27','12:05:00',3.73),('12664','2013-07-27','12:10:00',3.93),('12664','2013-07-27','12:15:00',3.88),('12664','2013-07-27','12:20:00',3.87),('12664','2013-07-27','12:25:00',3.84),('12664','2013-07-27','12:30:00',4.05),('12664','2013-07-27','12:35:00',3.97),('12664','2013-07-27','12:40:00',3.92),('12664','2013-07-27','12:45:00',3.99),('12664','2013-07-27','12:50:00',4.06),('12664','2013-07-27','12:55:00',4.02),('12664','2013-07-27','13:00:00',4.07),('12664','2013-07-27','13:05:00',4.06),('12664','2013-07-27','13:10:00',4.05),('12664','2013-07-27','13:15:00',4.06),('12664','2013-07-27','13:20:00',4.07),('12664','2013-07-27','13:25:00',4.05),('12664','2013-07-27','13:30:00',4.01),('12664','2013-07-27','13:35:00',4.06),('12664','2013-07-27','13:40:00',4.03),('12664','2013-07-27','13:45:00',4.05),('12664','2013-07-27','13:50:00',4.03),('12664','2013-07-27','13:55:00',4),('12664','2013-07-27','14:00:00',4),('12664','2013-07-27','14:05:00',4.02),('12664','2013-07-27','14:10:00',3.99),('12664','2013-07-27','14:15:00',3.97),('12664','2013-07-27','14:20:00',3.95),('12664','2013-07-27','14:25:00',3.95),('12664','2013-07-27','14:30:00',3.89),('12664','2013-07-27','14:35:00',3.86),('12664','2013-07-27','14:40:00',3.84),('12664','2013-07-27','14:45:00',3.78),('12664','2013-07-27','14:50:00',3.78),('12664','2013-07-27','14:55:00',3.77),('12664','2013-07-27','15:00:00',3.73),('12664','2013-07-27','15:05:00',3.69),('12664','2013-07-27','15:10:00',3.67),('12664','2013-07-27','15:15:00',3.64),('12664','2013-07-27','15:20:00',3.6),('12664','2013-07-27','15:25:00',3.54),('12664','2013-07-27','15:30:00',3.48),('12664','2013-07-27','15:35:00',3.45),('12664','2013-07-27','15:40:00',3.42),('12664','2013-07-27','15:45:00',3.36),('12664','2013-07-27','15:50:00',3.3),('12664','2013-07-27','15:55:00',3.25),('12664','2013-07-27','16:00:00',3.19),('12664','2013-07-27','16:05:00',3.16),('12664','2013-07-27','16:10:00',3.1),('12664','2013-07-27','16:15:00',3.05),('12664','2013-07-27','16:20:00',2.98),('12664','2013-07-27','16:25:00',2.93),('12664','2013-07-27','16:30:00',2.87),('12664','2013-07-27','16:35:00',2.82),('12664','2013-07-27','16:40:00',2.75),('12664','2013-07-27','16:45:00',2.7),('12664','2013-07-27','16:50:00',2.61),('12664','2013-07-27','16:55:00',2.53),('12664','2013-07-27','17:00:00',2.46),('12664','2013-07-27','17:05:00',2.38),('12664','2013-07-27','17:10:00',2.31),('12664','2013-07-27','17:15:00',2.23),('12664','2013-07-27','17:20:00',2.15),('12664','2013-07-27','17:25:00',2.07),('12664','2013-07-27','17:30:00',1.97),('12664','2013-07-27','17:35:00',1.9),('12664','2013-07-27','17:40:00',1.8),('12664','2013-07-27','17:45:00',1.72),('12664','2013-07-27','17:50:00',1.64),('12664','2013-07-27','17:55:00',1.56),('12664','2013-07-27','18:00:00',1.47),('12664','2013-07-27','18:05:00',1.38),('12664','2013-07-27','18:10:00',1.3),('12664','2013-07-27','18:15:00',1.21),('12664','2013-07-27','18:20:00',1.13),('12664','2013-07-27','18:25:00',1.04),('12664','2013-07-26','08:00:00',1.08),('12664','2013-07-26','08:05:00',1.21),('12664','2013-07-26','08:10:00',1.36),('12664','2013-07-26','08:15:00',1.26),('12664','2013-07-26','08:20:00',1),('12664','2013-07-26','08:25:00',1.5),('12664','2013-07-26','08:30:00',1.68),('12664','2013-07-26','08:35:00',1.64),('12664','2013-07-26','08:40:00',1.47),('12664','2013-07-26','08:45:00',1.97),('12664','2013-07-26','08:50:00',1.78),('12664','2013-07-26','08:55:00',1.98),('12664','2013-07-26','09:00:00',1.95),('12664','2013-07-26','09:05:00',2.11),('12664','2013-07-26','09:10:00',2.24),('12664','2013-07-26','09:15:00',2.25),('12664','2013-07-26','09:20:00',2.28),('12664','2013-07-26','09:25:00',2.34),('12664','2013-07-26','09:30:00',2.5),('12664','2013-07-26','09:35:00',2.59),('12664','2013-07-26','09:40:00',2.65),('12664','2013-07-26','09:45:00',2.71),('12664','2013-07-26','09:50:00',2.79),('12664','2013-07-26','09:55:00',2.82),('12664','2013-07-26','10:00:00',2.89),('12664','2013-07-26','10:05:00',2.94),('12664','2013-07-26','10:10:00',2.97),('12664','2013-07-26','10:15:00',3.04),('12664','2013-07-26','10:20:00',3.13),('12664','2013-07-26','10:25:00',3.23),('12664','2013-07-26','10:30:00',3.22),('12664','2013-07-26','10:35:00',3.3),('12664','2013-07-26','10:40:00',3.29),('12664','2013-07-26','10:45:00',3.31),('12664','2013-07-26','10:50:00',3.46),('12664','2013-07-26','10:55:00',3.47),('12664','2013-07-26','11:00:00',3.48),('12664','2013-07-26','11:05:00',3.44),('12664','2013-07-26','11:10:00',3.58),('12664','2013-07-26','11:15:00',3.47),('12664','2013-07-26','11:20:00',3.36),('12664','2013-07-26','11:25:00',3.64),('12664','2013-07-26','11:30:00',3.68),('12664','2013-07-26','11:35:00',3.73),('12664','2013-07-26','11:40:00',3.77),('12664','2013-07-26','11:45:00',3.63),('12664','2013-07-26','11:50:00',3.92),('12664','2013-07-26','11:55:00',3.66),('12664','2013-07-26','12:00:00',2.55),('12664','2013-07-26','12:05:00',2.74),('12664','2013-07-26','12:10:00',4.27),('12664','2013-07-26','12:15:00',4.25),('12664','2013-07-26','12:20:00',4.24),('12664','2013-07-26','12:25:00',4.29),('12664','2013-07-26','12:30:00',4.17),('12664','2013-07-26','12:35:00',3.82),('12664','2013-07-26','12:40:00',3.53),('12664','2013-07-26','12:45:00',4.03),('12664','2013-07-26','12:50:00',4.25),('12664','2013-07-26','12:55:00',4.32),('12664','2013-07-26','13:00:00',4.11),('12664','2013-07-26','13:05:00',4.22),('12664','2013-07-26','13:10:00',3.71),('12664','2013-07-26','13:15:00',4.17),('12664','2013-07-26','13:20:00',4.41),('12664','2013-07-26','13:25:00',4.27),('12664','2013-07-26','13:30:00',4.16),('12664','2013-07-26','13:35:00',4.03),('12664','2013-07-26','13:40:00',3.98),('12664','2013-07-26','13:45:00',4.02),('12664','2013-07-26','13:50:00',3.56),('12664','2013-07-26','13:55:00',4.15),('12664','2013-07-26','14:00:00',3.58),('12664','2013-07-26','14:05:00',4.11),('12664','2013-07-26','14:10:00',4.07),('12664','2013-07-26','14:15:00',3.99),('12664','2013-07-26','14:20:00',4.01),('12664','2013-07-26','14:25:00',3.96),('12664','2013-07-26','14:30:00',3.96),('12664','2013-07-26','14:35:00',3.91),('12664','2013-07-26','14:40:00',3.89),('12664','2013-07-26','14:45:00',3.84),('12664','2013-07-26','14:50:00',3.82),('12664','2013-07-26','14:55:00',3.81),('12664','2013-07-26','15:00:00',3.75),('12664','2013-07-26','15:05:00',3.71),('12664','2013-07-26','15:10:00',3.66),('12664','2013-07-26','15:15:00',3.63),('12664','2013-07-26','15:20:00',3.6),('12664','2013-07-26','15:25:00',3.52),('12664','2013-07-26','15:30:00',3.48),('12664','2013-07-26','15:35:00',3.48),('12664','2013-07-26','15:40:00',3.45),('12664','2013-07-26','15:45:00',3.39),('12664','2013-07-26','15:50:00',3.33),('12664','2013-07-26','15:55:00',3.28),('12664','2013-07-26','16:00:00',3.23),('12664','2013-07-26','16:05:00',3.2),('12664','2013-07-26','16:10:00',3.13),('12664','2013-07-26','16:15:00',3.02),('12664','2013-07-26','16:20:00',2.98),('12664','2013-07-26','16:25:00',2.91),('12664','2013-07-26','16:30:00',2.83),('12664','2013-07-26','16:35:00',2.74),('12664','2013-07-26','16:40:00',2.7),('12664','2013-07-26','16:45:00',2.61),('12664','2013-07-26','16:50:00',2.51),('12664','2013-07-26','16:55:00',2.46),('12664','2013-07-26','17:00:00',2.39),('12664','2013-07-26','17:05:00',2.35),('12664','2013-07-26','17:10:00',2.28),('12664','2013-07-26','17:15:00',2.22),('12664','2013-07-26','17:20:00',2.13),('12664','2013-07-26','17:25:00',2.05),('12664','2013-07-26','17:30:00',1.96),('12664','2013-07-26','17:35:00',1.87),('12664','2013-07-26','17:40:00',1.76),('12664','2013-07-26','17:45:00',1.69),('12664','2013-07-26','17:50:00',1.59),('12664','2013-07-26','17:55:00',1.5),('12664','2013-07-26','18:00:00',1.45),('12664','2013-07-26','18:05:00',1.34),('12664','2013-07-26','18:10:00',1.27),('12664','2013-07-26','18:15:00',1.19),('12664','2013-07-26','18:20:00',1.1),('12664','2013-07-26','18:25:00',1.03),('12664','2013-07-25','08:00:00',1.07),('12664','2013-07-25','08:05:00',1.15),('12664','2013-07-25','08:10:00',1.21),('12664','2013-07-25','08:15:00',1.31),('12664','2013-07-25','08:20:00',1.39),('12664','2013-07-25','08:25:00',1.47),('12664','2013-07-25','08:30:00',1.57),('12664','2013-07-25','08:35:00',1.64),('12664','2013-07-25','08:40:00',1.72),('12664','2013-07-25','08:45:00',1.84),('12664','2013-07-25','08:50:00',1.89),('12664','2013-07-25','08:55:00',1.98),('12664','2013-07-25','09:00:00',2.11),('12664','2013-07-25','09:05:00',2.29),('12664','2013-07-25','09:10:00',2.33),('12664','2013-07-25','09:15:00',2.42),('12664','2013-07-25','09:20:00',2.38),('12664','2013-07-25','09:25:00',2.53),('12664','2013-07-25','09:30:00',1.62),('12664','2013-07-25','09:35:00',2.36),('12664','2013-07-25','09:40:00',2.73),('12664','2013-07-25','09:45:00',2.96),('12664','2013-07-25','09:50:00',2.95),('12664','2013-07-25','09:55:00',2.72),('12664','2013-07-25','10:00:00',2.4),('12664','2013-07-25','10:05:00',3.05),('12664','2013-07-25','10:10:00',3.12),('12664','2013-07-25','10:15:00',3.21),('12664','2013-07-25','10:20:00',3.32),('12664','2013-07-25','10:25:00',3.41),('12664','2013-07-25','10:30:00',3.41),('12664','2013-07-25','10:35:00',3.43),('12664','2013-07-25','10:40:00',3.31),('12664','2013-07-25','10:45:00',3.47),('12664','2013-07-25','10:50:00',3.47),('12664','2013-07-25','10:55:00',3.57),('12664','2013-07-25','11:00:00',3.64),('12664','2013-07-25','11:05:00',3.73),('12664','2013-07-25','11:10:00',3.55),('12664','2013-07-25','11:15:00',3.82),('12664','2013-07-25','11:20:00',3.46),('12664','2013-07-25','11:25:00',3.44),('12664','2013-07-25','11:30:00',3.79),('12664','2013-07-25','11:35:00',3.83),('12664','2013-07-25','11:40:00',3.83),('12664','2013-07-25','11:45:00',3.85),('12664','2013-07-25','11:50:00',3.87),('12664','2013-07-25','11:55:00',3.97),('12664','2013-07-25','12:00:00',4.04),('12664','2013-07-25','12:05:00',4.08),('12664','2013-07-25','12:10:00',1.25),('12664','2013-07-25','12:15:00',2.89),('12664','2013-07-25','12:20:00',4.17),('12664','2013-07-25','12:25:00',3.96),('12664','2013-07-25','12:30:00',4.1),('12664','2013-07-25','12:35:00',3.98),('12664','2013-07-25','12:40:00',3.92),('12664','2013-07-25','12:45:00',4.16),('12664','2013-07-25','12:50:00',4.13),('12664','2013-07-25','12:55:00',4.15),('12664','2013-07-25','13:00:00',4.17),('12664','2013-07-25','13:05:00',4.17),('12664','2013-07-25','13:10:00',4.16),('12664','2013-07-25','13:15:00',4.16),('12664','2013-07-25','13:20:00',4.19),('12664','2013-07-25','13:25:00',4.18),('12664','2013-07-25','13:30:00',4.19),('12664','2013-07-25','13:35:00',4.2),('12664','2013-07-25','13:40:00',4.22),('12664','2013-07-25','13:45:00',4.19),('12664','2013-07-25','13:50:00',4.21),('12664','2013-07-25','13:55:00',4.18),('12664','2013-07-25','14:00:00',4.2),('12664','2013-07-25','14:05:00',4.14),('12664','2013-07-25','14:10:00',4.16),('12664','2013-07-25','14:15:00',4.15),('12664','2013-07-25','14:20:00',4.11),('12664','2013-07-25','14:25:00',4.09),('12664','2013-07-25','14:30:00',4.08),('12664','2013-07-25','14:35:00',4.06),('12664','2013-07-25','14:40:00',4.02),('12664','2013-07-25','14:45:00',3.98),('12664','2013-07-25','14:50:00',3.95),('12664','2013-07-25','14:55:00',3.95),('12664','2013-07-25','15:00:00',3.89),('12664','2013-07-25','15:05:00',3.88),('12664','2013-07-25','15:10:00',3.85),('12664','2013-07-25','15:15:00',3.8),('12664','2013-07-25','15:20:00',3.77),('12664','2013-07-25','15:25:00',3.7),('12664','2013-07-25','15:30:00',3.68),('12664','2013-07-25','15:35:00',3.64),('12664','2013-07-25','15:40:00',3.59),('12664','2013-07-25','15:45:00',3.52),('12664','2013-07-25','15:50:00',3.5),('12664','2013-07-25','15:55:00',3.43),('12664','2013-07-25','16:00:00',3.37),('12664','2013-07-25','16:05:00',3.33),('12664','2013-07-25','16:10:00',3.26),('12664','2013-07-25','16:15:00',3.2),('12664','2013-07-25','16:20:00',3.15),('12664','2013-07-25','16:25:00',3.06),('12664','2013-07-25','16:30:00',2.99),('12664','2013-07-25','16:35:00',2.96),('12664','2013-07-25','16:40:00',2.89),('12664','2013-07-25','16:45:00',2.82),('12664','2013-07-25','16:50:00',2.69),('12664','2013-07-25','16:55:00',2.66),('12664','2013-07-25','17:00:00',2.59),('12664','2013-07-25','17:05:00',2.52),('12664','2013-07-25','17:10:00',2.39),('12664','2013-07-25','17:15:00',2.33),('12664','2013-07-25','17:20:00',2.24),('12664','2013-07-25','17:25:00',2.18),('12664','2013-07-25','17:30:00',2.06),('12664','2013-07-25','17:35:00',2),('12664','2013-07-25','17:40:00',1.91),('12664','2013-07-25','17:45:00',1.79),('12664','2013-07-25','17:50:00',1.71),('12664','2013-07-25','17:55:00',1.63),('12664','2013-07-25','18:00:00',1.55),('12664','2013-07-25','18:05:00',1.44),('12664','2013-07-25','18:10:00',1.37),('12664','2013-07-25','18:15:00',1.26),('12664','2013-07-25','18:20:00',1.17),('12664','2013-07-25','18:25:00',1.09),('12664','2013-07-25','18:30:00',1),('12664','2013-07-24','07:55:00',1.08),('12664','2013-07-24','08:00:00',1.34),('12664','2013-07-24','08:05:00',1.27),('12664','2013-07-24','08:10:00',1.4),('12664','2013-07-24','08:20:00',1.37),('12664','2013-07-24','08:25:00',1.22),('12664','2013-07-24','08:45:00',1.11),('12664','2013-07-24','08:50:00',1.1),('12664','2013-07-24','08:55:00',1.48),('12664','2013-07-24','09:00:00',1.52),('12664','2013-07-24','09:05:00',2.34),('12664','2013-07-24','09:10:00',2.56),('12664','2013-07-24','09:15:00',2.11),('12664','2013-07-24','09:20:00',2.32),('12664','2013-07-24','09:25:00',2.03),('12664','2013-07-24','09:30:00',1.26),('12664','2013-07-24','09:35:00',1.19),('12664','2013-07-24','09:40:00',1.3),('12664','2013-07-24','09:45:00',2.35),('12664','2013-07-24','09:50:00',2.04),('12664','2013-07-24','09:55:00',2.8),('12664','2013-07-24','10:00:00',2.6),('12664','2013-07-24','10:05:00',1.75),('12664','2013-07-24','10:10:00',1.2),('12664','2013-07-24','10:15:00',1.44),('12664','2013-07-24','10:20:00',1.57),('12664','2013-07-24','10:25:00',3.64),('12664','2013-07-24','10:30:00',3.5),('12664','2013-07-24','10:35:00',2.36),('12664','2013-07-24','10:40:00',1.83),('12664','2013-07-24','10:45:00',3.58),('12664','2013-07-24','10:50:00',2.64),('12664','2013-07-24','10:55:00',3.82),('12664','2013-07-24','11:00:00',3.83),('12664','2013-07-24','11:05:00',3.67),('12664','2013-07-24','11:10:00',3.48),('12664','2013-07-24','11:15:00',3.9),('12664','2013-07-24','11:20:00',3.6),('12664','2013-07-24','11:25:00',1.34),('12664','2013-07-24','11:30:00',3.92),('12664','2013-07-24','11:35:00',3.89),('12664','2013-07-24','11:40:00',4.01),('12664','2013-07-24','11:45:00',4.04),('12664','2013-07-24','11:50:00',4.1),('12664','2013-07-24','11:55:00',4.11),('12664','2013-07-24','12:00:00',4.07),('12664','2013-07-24','12:05:00',4.11),('12664','2013-07-24','12:10:00',4.2),('12664','2013-07-24','12:15:00',4.12),('12664','2013-07-24','12:20:00',3.96),('12664','2013-07-24','12:25:00',4.3),('12664','2013-07-24','12:30:00',4.19),('12664','2013-07-24','12:35:00',4.12),('12664','2013-07-24','12:40:00',4.22),('12664','2013-07-24','12:45:00',4.06),('12664','2013-07-24','12:50:00',4.2),('12664','2013-07-24','12:55:00',4.18),('12664','2013-07-24','13:00:00',4.24),('12664','2013-07-24','13:05:00',4.18),('12664','2013-07-24','13:10:00',4.14),('12664','2013-07-24','13:15:00',4.19),('12664','2013-07-24','13:20:00',4.19),('12664','2013-07-24','13:25:00',4.13),('12664','2013-07-24','13:30:00',4.24),('12664','2013-07-24','13:35:00',4.23),('12664','2013-07-24','13:40:00',4.21),('12664','2013-07-24','13:45:00',4.17),('12664','2013-07-24','13:50:00',4.21),('12664','2013-07-24','13:55:00',4.18),('12664','2013-07-24','14:00:00',4.17),('12664','2013-07-24','14:05:00',4.15),('12664','2013-07-24','14:10:00',4.1),('12664','2013-07-24','14:15:00',4.15),('12664','2013-07-24','14:20:00',4.13),('12664','2013-07-24','14:25:00',4.16),('12664','2013-07-24','14:30:00',4.07),('12664','2013-07-24','14:35:00',4.13),('12664','2013-07-24','14:40:00',3.96),('12664','2013-07-24','14:45:00',3.98),('12664','2013-07-24','14:50:00',3.98),('12664','2013-07-24','14:55:00',3.98),('12664','2013-07-24','15:00:00',3.96),('12664','2013-07-24','15:05:00',3.86),('12664','2013-07-24','15:10:00',3.87),('12664','2013-07-24','15:15:00',3.86),('12664','2013-07-24','15:20:00',3.65),('12664','2013-07-24','15:25:00',3.66),('12664','2013-07-24','15:30:00',3.7),('12664','2013-07-24','15:35:00',3.49),('12664','2013-07-24','15:40:00',3.2),('12664','2013-07-24','15:45:00',3.45),('12664','2013-07-24','15:50:00',3.37),('12664','2013-07-24','15:55:00',3.14),('12664','2013-07-24','16:00:00',3.38),('12664','2013-07-24','16:05:00',3.24),('12664','2013-07-24','16:10:00',3.31),('12664','2013-07-24','16:15:00',3.29),('12664','2013-07-24','16:20:00',3.27),('12664','2013-07-24','16:25:00',3.21),('12664','2013-07-24','16:30:00',3.2),('12664','2013-07-24','16:35:00',3.17),('12664','2013-07-24','16:40:00',3.11),('12664','2013-07-24','16:45:00',3.15),('12664','2013-07-24','16:50:00',3),('12664','2013-07-24','16:55:00',2.93),('12664','2013-07-24','17:00:00',2.84),('12664','2013-07-24','17:05:00',2.64),('12664','2013-07-24','17:10:00',2.51),('12664','2013-07-24','17:15:00',2.41),('12664','2013-07-24','17:20:00',2.27),('12664','2013-07-24','17:25:00',2.14),('12664','2013-07-24','17:30:00',2.1),('12664','2013-07-24','17:35:00',2),('12664','2013-07-24','17:40:00',1.9),('12664','2013-07-24','17:45:00',1.79),('12664','2013-07-24','17:50:00',1.7),('12664','2013-07-24','17:55:00',1.67),('12664','2013-07-24','18:00:00',1.57),('12664','2013-07-24','18:05:00',1.22),('12664','2013-07-24','18:10:00',1.28),('12664','2013-07-24','18:15:00',1.16),('12664','2013-07-24','18:20:00',1.16),('12664','2013-07-23','07:50:00',1.03),('12664','2013-07-23','07:55:00',1.12),('12664','2013-07-23','08:00:00',1.2),('12664','2013-07-23','08:05:00',1.28),('12664','2013-07-23','08:20:00',1.55),('12664','2013-07-23','08:25:00',1.64),('12664','2013-07-23','08:30:00',1.71),('12664','2013-07-23','08:35:00',1.77),('12664','2013-07-23','08:40:00',1.85),('12664','2013-07-23','08:45:00',1.93),('12664','2013-07-23','08:50:00',2.01),('12664','2013-07-23','08:55:00',2.08),('12664','2013-07-23','09:00:00',2.14),('12664','2013-07-23','09:05:00',2.25),('12664','2013-07-23','09:10:00',2.35),('12664','2013-07-23','09:15:00',2.41),('12664','2013-07-23','09:20:00',2.5),('12664','2013-07-23','09:25:00',2.58),('12664','2013-07-23','09:30:00',2.67),('12664','2013-07-23','09:35:00',2.73),('12664','2013-07-23','09:40:00',2.8),('12664','2013-07-23','09:45:00',2.82),('12664','2013-07-23','09:50:00',2.87),('12664','2013-07-23','09:55:00',2.93),('12664','2013-07-23','10:00:00',2.96),('12664','2013-07-23','10:05:00',3.04),('12664','2013-07-23','10:10:00',3.09),('12664','2013-07-23','10:15:00',3.12),('12664','2013-07-23','10:20:00',3.18),('12664','2013-07-23','10:25:00',3.21),('12664','2013-07-23','10:30:00',3.25),('12664','2013-07-23','10:35:00',3.29),('12664','2013-07-23','10:40:00',3.31),('12664','2013-07-23','10:45:00',3.35),('12664','2013-07-23','10:50:00',3.34),('12664','2013-07-23','10:55:00',3.37),('12664','2013-07-23','11:00:00',3.4),('12664','2013-07-23','11:05:00',3.56),('12664','2013-07-23','11:10:00',3.56),('12664','2013-07-23','11:15:00',3.56),('12664','2013-07-23','11:20:00',3.55),('12664','2013-07-23','11:25:00',3.57),('12664','2013-07-23','11:30:00',3.33),('12664','2013-07-23','11:35:00',1.23),('12664','2013-07-23','11:40:00',1.4),('12664','2013-07-23','11:45:00',2.98),('12664','2013-07-23','11:50:00',1.18),('12664','2013-07-23','11:55:00',1.38),('12664','2013-07-23','12:00:00',4.11),('12664','2013-07-23','12:05:00',4.09),('12664','2013-07-23','12:10:00',3.72),('12664','2013-07-23','12:15:00',4.15),('12664','2013-07-23','12:20:00',4.13),('12664','2013-07-23','12:25:00',1.94),('12664','2013-07-23','12:30:00',1.03),('12664','2013-07-23','12:35:00',2.32),('12664','2013-07-23','12:40:00',4.5),('12664','2013-07-23','12:45:00',4.44),('12664','2013-07-23','12:50:00',3.94),('12664','2013-07-23','12:55:00',3.97),('12664','2013-07-23','13:00:00',4.33),('12664','2013-07-23','13:05:00',4.32),('12664','2013-07-23','13:10:00',4.27),('12664','2013-07-23','13:15:00',3.86),('12664','2013-07-23','13:20:00',2.14),('12664','2013-07-23','13:25:00',4.41),('12664','2013-07-23','13:30:00',4.4),('12664','2013-07-23','13:35:00',4.34),('12664','2013-07-23','13:40:00',4.21),('12664','2013-07-23','13:45:00',4.29),('12664','2013-07-23','13:50:00',2.77),('12664','2013-07-23','13:55:00',4),('12664','2013-07-23','14:00:00',4.18),('12664','2013-07-23','14:05:00',4.44),('12664','2013-07-23','14:10:00',4.16),('12664','2013-07-23','14:15:00',4.2),('12664','2013-07-23','14:20:00',4.23),('12664','2013-07-23','14:25:00',4.13),('12664','2013-07-23','14:30:00',4.14),('12664','2013-07-23','14:35:00',4.07),('12664','2013-07-23','14:40:00',4.03),('12664','2013-07-23','14:45:00',4.01),('12664','2013-07-23','14:50:00',3.95),('12664','2013-07-23','14:55:00',3.95),('12664','2013-07-23','15:00:00',3.92),('12664','2013-07-23','15:05:00',3.86),('12664','2013-07-23','15:10:00',3.82),('12664','2013-07-23','15:15:00',3.73),('12664','2013-07-23','15:20:00',3.71),('12664','2013-07-23','15:25:00',3.63),('12664','2013-07-23','15:30:00',3.59),('12664','2013-07-23','15:35:00',3.56),('12664','2013-07-23','15:40:00',3.51),('12664','2013-07-23','15:45:00',3.48),('12664','2013-07-23','15:50:00',3.26),('12664','2013-07-23','15:55:00',3.39),('12664','2013-07-23','16:00:00',3.33),('12664','2013-07-23','16:05:00',3.28),('12664','2013-07-23','16:10:00',3.23),('12664','2013-07-23','16:15:00',3.18),('12664','2013-07-23','16:20:00',3.11),('12664','2013-07-23','16:25:00',3.04),('12664','2013-07-23','16:30:00',2.97),('12664','2013-07-23','16:35:00',2.9),('12664','2013-07-23','16:40:00',2.82),('12664','2013-07-23','16:45:00',2.75),('12664','2013-07-23','16:50:00',2.68),('12664','2013-07-23','16:55:00',2.6),('12664','2013-07-23','17:00:00',2.52),('12664','2013-07-23','17:05:00',2.46),('12664','2013-07-23','17:10:00',2.39),('12664','2013-07-23','17:15:00',2.3),('12664','2013-07-23','17:20:00',2.22),('12664','2013-07-23','17:25:00',2.12),('12664','2013-07-23','17:30:00',2.04),('12664','2013-07-23','17:35:00',1.96),('12664','2013-07-23','17:40:00',1.88),('12664','2013-07-23','17:45:00',1.79),('12664','2013-07-23','17:50:00',1.7),('12664','2013-07-23','17:55:00',1.62),('12664','2013-07-23','18:00:00',1.54),('12664','2013-07-23','18:05:00',1.46),('12664','2013-07-23','18:10:00',1.38),('12664','2013-07-23','18:15:00',1.29),('12664','2013-07-23','18:20:00',1.22),('12664','2013-07-23','18:25:00',1.13),('12664','2013-07-23','18:30:00',1.03),('12664','2013-07-22','07:50:00',1),('12664','2013-07-22','07:55:00',1.1),('12664','2013-07-22','08:00:00',1.19),('12664','2013-07-22','08:05:00',1.27),('12664','2013-07-22','08:10:00',1.36),('12664','2013-07-22','08:15:00',1.45),('12664','2013-07-22','08:20:00',1.54),('12664','2013-07-22','08:25:00',1.62),('12664','2013-07-22','08:30:00',1.7),('12664','2013-07-22','08:35:00',1.78),('12664','2013-07-22','08:40:00',1.87),('12664','2013-07-22','08:45:00',1.95),('12664','2013-07-22','08:50:00',2.05),('12664','2013-07-22','08:55:00',2.13),('12664','2013-07-22','09:00:00',2.2),('12664','2013-07-22','09:05:00',2.28),('12664','2013-07-22','09:10:00',2.36),('12664','2013-07-22','09:15:00',2.43),('12664','2013-07-22','09:20:00',2.5),('12664','2013-07-22','09:25:00',2.58),('12664','2013-07-22','09:30:00',2.67),('12664','2013-07-22','09:35:00',2.73),('12664','2013-07-22','09:40:00',2.8),('12664','2013-07-22','09:45:00',2.86),('12664','2013-07-22','09:50:00',2.93),('12664','2013-07-22','09:55:00',2.99),('12664','2013-07-22','10:00:00',3.06),('12664','2013-07-22','10:05:00',3.13),('12664','2013-07-22','10:10:00',3.19),('12664','2013-07-22','10:15:00',3.23),('12664','2013-07-22','10:20:00',3.28),('12664','2013-07-22','10:25:00',3.33),('12664','2013-07-22','10:30:00',3.38),('12664','2013-07-22','10:35:00',3.43),('12664','2013-07-22','10:40:00',3.47),('12664','2013-07-22','10:45:00',3.52),('12664','2013-07-22','10:50:00',3.54),('12664','2013-07-22','10:55:00',3.57),('12664','2013-07-22','11:00:00',3.63),('12664','2013-07-22','11:05:00',3.67),('12664','2013-07-22','11:10:00',3.71),('12664','2013-07-22','11:15:00',3.73),('12664','2013-07-22','11:20:00',3.76),('12664','2013-07-22','11:25:00',3.77),('12664','2013-07-22','11:30:00',3.8),('12664','2013-07-22','11:35:00',3.85),('12664','2013-07-22','11:40:00',3.88),('12664','2013-07-22','11:45:00',3.91),('12664','2013-07-22','11:50:00',3.94),('12664','2013-07-22','11:55:00',3.97),('12664','2013-07-22','12:00:00',3.96),('12664','2013-07-22','12:05:00',3.97),('12664','2013-07-22','12:10:00',4),('12664','2013-07-22','12:15:00',4.04),('12664','2013-07-22','12:20:00',4.07),('12664','2013-07-22','12:25:00',4.07),('12664','2013-07-22','12:30:00',4.08),('12664','2013-07-22','12:35:00',4.08),('12664','2013-07-22','12:40:00',4.04),('12664','2013-07-22','12:45:00',4.04),('12664','2013-07-22','12:50:00',4.07),('12664','2013-07-22','12:55:00',4.08),('12664','2013-07-22','13:00:00',4.11),('12664','2013-07-22','13:05:00',4.09),('12664','2013-07-22','13:10:00',4.06),('12664','2013-07-22','13:15:00',4.06),('12664','2013-07-22','13:20:00',4.08),('12664','2013-07-22','13:25:00',4.08),('12664','2013-07-22','13:30:00',4.07),('12664','2013-07-22','13:35:00',4.05),('12664','2013-07-22','13:40:00',4.1),('12664','2013-07-22','13:45:00',4.09),('12664','2013-07-22','13:50:00',4.09),('12664','2013-07-22','13:55:00',4.05),('12664','2013-07-22','14:00:00',4.01),('12664','2013-07-22','14:05:00',4.02),('12664','2013-07-22','14:10:00',4.02),('12664','2013-07-22','14:15:00',3.95),('12664','2013-07-22','14:20:00',3.93),('12664','2013-07-22','14:25:00',3.94),('12664','2013-07-22','14:30:00',3.91),('12664','2013-07-22','14:35:00',3.89),('12664','2013-07-22','14:40:00',3.93),('12664','2013-07-22','14:45:00',3.92),('12664','2013-07-22','14:50:00',3.86),('12664','2013-07-22','14:55:00',3.85),('12664','2013-07-22','15:00:00',3.81),('12664','2013-07-22','15:05:00',3.67),('12664','2013-07-22','15:10:00',3.65),('12664','2013-07-22','15:15:00',3),('12664','2013-07-22','15:20:00',3.03),('12664','2013-07-22','15:25:00',3.75),('12664','2013-07-22','15:30:00',1.39),('12664','2013-07-22','15:35:00',1.61),('12664','2013-07-22','15:40:00',1.14),('12664','2013-07-22','15:45:00',1.18),('12664','2013-07-22','15:50:00',3.09),('12664','2013-07-22','15:55:00',3),('12664','2013-07-22','16:00:00',2.62),('12664','2013-07-22','16:05:00',3.42),('12664','2013-07-22','16:10:00',3.29),('12664','2013-07-22','16:15:00',3.14),('12664','2013-07-22','16:20:00',3.05),('12664','2013-07-22','16:25:00',2.95),('12664','2013-07-22','16:30:00',2.91),('12664','2013-07-22','16:35:00',2.8),('12664','2013-07-22','16:40:00',2.46),('12664','2013-07-22','16:45:00',2),('12664','2013-07-22','16:50:00',2.62),('12664','2013-07-22','16:55:00',2.54),('12664','2013-07-22','17:00:00',2.46),('12664','2013-07-22','17:05:00',2.39),('12664','2013-07-22','17:10:00',2.33),('12664','2013-07-22','17:15:00',2.22),('12664','2013-07-22','17:20:00',2.15),('12664','2013-07-22','17:25:00',2.09),('12664','2013-07-22','17:30:00',2),('12664','2013-07-22','17:35:00',1.94),('12664','2013-07-22','17:40:00',1.86),('12664','2013-07-22','17:45:00',1.79),('12664','2013-07-22','17:50:00',1.7),('12664','2013-07-22','17:55:00',1.63),('12664','2013-07-22','18:00:00',1.58),('12664','2013-07-22','18:05:00',1.48),('12664','2013-07-22','18:10:00',1.35),('12664','2013-07-22','18:15:00',1.25),('12664','2013-07-22','18:20:00',1.06),('12664','2013-07-22','18:25:00',1.07),('12664','2013-07-22','18:30:00',1.02),('12664','2013-07-21','07:55:00',1.03),('12664','2013-07-21','08:00:00',1.11),('12664','2013-07-21','08:05:00',1.2),('12664','2013-07-21','08:10:00',1.26),('12664','2013-07-21','08:15:00',1.36),('12664','2013-07-21','08:20:00',1.45),('12664','2013-07-21','08:25:00',1.54),('12664','2013-07-21','08:30:00',1.63),('12664','2013-07-21','08:35:00',1.71),('12664','2013-07-21','08:40:00',1.8),('12664','2013-07-21','08:45:00',1.86),('12664','2013-07-21','08:50:00',1.93),('12664','2013-07-21','08:55:00',2.01),('12664','2013-07-21','09:00:00',2.1),('12664','2013-07-21','09:05:00',2.2),('12664','2013-07-21','09:10:00',2.27),('12664','2013-07-21','09:15:00',2.36),('12664','2013-07-21','09:20:00',2.44),('12664','2013-07-21','09:25:00',2.48),('12664','2013-07-21','09:30:00',2.56),('12664','2013-07-21','09:35:00',2.65),('12664','2013-07-21','09:40:00',2.7),('12664','2013-07-21','09:45:00',2.76),('12664','2013-07-21','09:50:00',2.83),('12664','2013-07-21','09:55:00',2.89),('12664','2013-07-21','10:00:00',2.94),('12664','2013-07-21','10:05:00',3),('12664','2013-07-21','10:10:00',3.07),('12664','2013-07-21','10:15:00',3.1),('12664','2013-07-21','10:20:00',3.17),('12664','2013-07-21','10:25:00',3.25),('12664','2013-07-21','10:30:00',3.29),('12664','2013-07-21','10:35:00',3.34),('12664','2013-07-21','10:40:00',3.38),('12664','2013-07-21','10:45:00',3.43),('12664','2013-07-21','10:50:00',3.49),('12664','2013-07-21','10:55:00',3.5),('12664','2013-07-21','11:00:00',3.51),('12664','2013-07-21','11:05:00',3.56),('12664','2013-07-21','11:10:00',3.58),('12664','2013-07-21','11:15:00',3.63),('12664','2013-07-21','11:20:00',3.7),('12664','2013-07-21','11:25:00',3.73),('12664','2013-07-21','11:30:00',3.76),('12664','2013-07-21','11:35:00',3.77),('12664','2013-07-21','11:40:00',3.78),('12664','2013-07-21','11:45:00',3.82),('12664','2013-07-21','11:50:00',3.86),('12664','2013-07-21','11:55:00',3.86),('12664','2013-07-21','12:00:00',3.94),('12664','2013-07-21','12:05:00',3.96),('12664','2013-07-21','12:10:00',4.12),('12664','2013-07-21','12:15:00',4.55),('12664','2013-07-21','12:20:00',3.54),('12664','2013-07-21','12:25:00',3.4),('12664','2013-07-21','12:30:00',2.47),('12664','2013-07-21','12:35:00',2.28),('12664','2013-07-21','12:40:00',2.03),('12664','2013-07-21','12:45:00',2.08),('12664','2013-07-21','12:50:00',2.12),('12664','2013-07-21','12:55:00',2.09),('12664','2013-07-21','13:00:00',1.91),('12664','2013-07-21','13:05:00',1.93),('12664','2013-07-21','13:10:00',2.08),('12664','2013-07-21','13:15:00',2.07),('12664','2013-07-21','13:20:00',2.04),('12664','2013-07-21','13:25:00',2.19),('12664','2013-07-21','13:30:00',3.43),('12664','2013-07-21','13:35:00',3.7),('12664','2013-07-21','13:40:00',3.66),('12664','2013-07-21','13:45:00',4.25),('12664','2013-07-21','13:50:00',2.55),('12664','2013-07-21','13:55:00',4.17),('12664','2013-07-21','14:00:00',2.36),('12664','2013-07-21','14:05:00',3.5),('12664','2013-07-21','14:10:00',2.53),('12664','2013-07-21','14:15:00',1.89),('12664','2013-07-21','14:20:00',1.59),('12664','2013-07-21','14:25:00',1.58),('12664','2013-07-21','14:30:00',1.36),('12664','2013-07-21','14:35:00',1.21),('12664','2013-07-21','14:40:00',1.24),('12664','2013-07-21','14:45:00',1.57),('12664','2013-07-21','14:50:00',2.96),('12664','2013-07-21','14:55:00',2.3),('12664','2013-07-21','15:00:00',1.5),('12664','2013-07-21','15:05:00',1.26),('12664','2013-07-21','15:10:00',1.23),('12664','2013-07-21','15:15:00',1.23),('12664','2013-07-21','15:20:00',1.37),('12664','2013-07-21','15:25:00',1.4),('12664','2013-07-21','15:30:00',1.52),('12664','2013-07-21','15:35:00',1.59),('12664','2013-07-21','15:40:00',2.21),('12664','2013-07-21','15:45:00',2.26),('12664','2013-07-21','15:50:00',2.92),('12664','2013-07-21','15:55:00',2.01),('12664','2013-07-21','16:00:00',1.67),('12664','2013-07-21','16:05:00',1.18),('12664','2013-07-21','16:35:00',1.13),('12664','2013-07-21','16:40:00',1.17),('12664','2013-07-21','16:45:00',1.13),('12664','2013-07-21','16:50:00',1.07),('12664','2013-07-21','16:55:00',1.05),('12664','2013-07-21','17:00:00',1.38),('12664','2013-07-21','17:05:00',2.05),('12664','2013-07-21','17:10:00',1.4),('12664','2013-07-21','17:15:00',1.02),('12664','2013-07-20','07:50:00',1.02),('12664','2013-07-20','07:55:00',1.11),('12664','2013-07-20','08:00:00',1.2),('12664','2013-07-20','08:05:00',1.29),('12664','2013-07-20','08:10:00',1.38),('12664','2013-07-20','08:15:00',1.48),('12664','2013-07-20','08:20:00',1.56),('12664','2013-07-20','08:25:00',1.65),('12664','2013-07-20','08:30:00',1.74),('12664','2013-07-20','08:35:00',1.83),('12664','2013-07-20','08:40:00',1.93),('12664','2013-07-20','08:45:00',2.03),('12664','2013-07-20','08:50:00',2.11),('12664','2013-07-20','08:55:00',2.19),('12664','2013-07-20','09:00:00',2.31),('12664','2013-07-20','09:05:00',2.42),('12664','2013-07-20','09:10:00',2.51),('12664','2013-07-20','09:15:00',2.56),('12664','2013-07-20','09:20:00',2.48),('12664','2013-07-20','09:25:00',2.56),('12664','2013-07-20','09:30:00',2.71),('12664','2013-07-20','09:35:00',2.62),('12664','2013-07-20','09:40:00',2.4),('12664','2013-07-20','09:45:00',2.65),('12664','2013-07-20','09:50:00',2.74),('12664','2013-07-20','09:55:00',3.04),('12664','2013-07-20','10:00:00',3.08),('12664','2013-07-20','10:05:00',3.11),('12664','2013-07-20','10:10:00',3.16),('12664','2013-07-20','10:15:00',3.2),('12664','2013-07-20','10:20:00',3.25),('12664','2013-07-20','10:25:00',3.31),('12664','2013-07-20','10:30:00',3.38),('12664','2013-07-20','10:35:00',3.44),('12664','2013-07-20','10:40:00',3.5),('12664','2013-07-20','10:45:00',3.54),('12664','2013-07-20','10:50:00',3.59),('12664','2013-07-20','10:55:00',3.61),('12664','2013-07-20','11:00:00',3.65),('12664','2013-07-20','11:05:00',3.68),('12664','2013-07-20','11:10:00',3.72),('12664','2013-07-20','11:15:00',3.75),('12664','2013-07-20','11:20:00',3.76),('12664','2013-07-20','11:25:00',3.81),('12664','2013-07-20','11:30:00',3.85),('12664','2013-07-20','11:35:00',3.87),('12664','2013-07-20','11:40:00',3.92),('12664','2013-07-20','11:45:00',3.93),('12664','2013-07-20','11:50:00',3.96),('12664','2013-07-20','11:55:00',3.98),('12664','2013-07-20','12:00:00',4),('12664','2013-07-20','12:05:00',4),('12664','2013-07-20','12:10:00',4.03),('12664','2013-07-20','12:15:00',4.1),('12664','2013-07-20','12:20:00',4.08),('12664','2013-07-20','12:25:00',4.09),('12664','2013-07-20','12:30:00',4.04),('12664','2013-07-20','12:35:00',4.11),('12664','2013-07-20','12:40:00',4.09),('12664','2013-07-20','12:45:00',4.09),('12664','2013-07-20','12:50:00',4.12),('12664','2013-07-20','12:55:00',4.14),('12664','2013-07-20','13:00:00',4.08),('12664','2013-07-20','13:05:00',4.09),('12664','2013-07-20','13:10:00',4.09),('12664','2013-07-20','13:15:00',4.15),('12664','2013-07-20','13:20:00',4.13),('12664','2013-07-20','13:25:00',4.18),('12664','2013-07-20','13:30:00',4.27),('12664','2013-07-20','13:35:00',4.33),('12664','2013-07-20','13:40:00',4.31),('12664','2013-07-20','13:45:00',4.16),('12664','2013-07-20','13:50:00',4.12),('12664','2013-07-20','13:55:00',4.09),('12664','2013-07-20','14:00:00',4.02),('12664','2013-07-20','14:05:00',4.05),('12664','2013-07-20','14:10:00',4.05),('12664','2013-07-20','14:15:00',4.05),('12664','2013-07-20','14:20:00',4.06),('12664','2013-07-20','14:25:00',4.01),('12664','2013-07-20','14:30:00',3.95),('12664','2013-07-20','14:35:00',3.96),('12664','2013-07-20','14:40:00',3.94),('12664','2013-07-20','14:45:00',3.93),('12664','2013-07-20','14:50:00',3.94),('12664','2013-07-20','14:55:00',3.85),('12664','2013-07-20','15:00:00',3.87),('12664','2013-07-20','15:05:00',3.82),('12664','2013-07-20','15:10:00',3.76),('12664','2013-07-20','15:15:00',3.77),('12664','2013-07-20','15:20:00',3.71),('12664','2013-07-20','15:25:00',3.68),('12664','2013-07-20','15:30:00',3.62),('12664','2013-07-20','15:35:00',3.59),('12664','2013-07-20','15:40:00',3.55),('12664','2013-07-20','15:45:00',3.51),('12664','2013-07-20','15:50:00',3.47),('12664','2013-07-20','15:55:00',3.41),('12664','2013-07-20','16:00:00',3.37),('12664','2013-07-20','16:05:00',3.29),('12664','2013-07-20','16:10:00',3.21),('12664','2013-07-20','16:15:00',3.17),('12664','2013-07-20','16:20:00',3.11),('12664','2013-07-20','16:25:00',3.06),('12664','2013-07-20','16:30:00',2.98),('12664','2013-07-20','16:35:00',2.92),('12664','2013-07-20','16:40:00',2.85),('12664','2013-07-20','16:45:00',2.77),('12664','2013-07-20','16:50:00',2.71),('12664','2013-07-20','16:55:00',2.65),('12664','2013-07-20','17:00:00',2.58),('12664','2013-07-20','17:05:00',2.48),('12664','2013-07-20','17:10:00',2.4),('12664','2013-07-20','17:15:00',2.33),('12664','2013-07-20','17:20:00',2.24),('12664','2013-07-20','17:25:00',2.16),('12664','2013-07-20','17:30:00',2.08),('12664','2013-07-20','17:35:00',2),('12664','2013-07-20','17:40:00',1.93),('12664','2013-07-20','17:45:00',1.83),('12664','2013-07-20','17:50:00',1.74),('12664','2013-07-20','17:55:00',1.64),('12664','2013-07-20','18:00:00',1.56),('12664','2013-07-20','18:05:00',1.46),('12664','2013-07-20','18:10:00',1.38),('12664','2013-07-20','18:15:00',1.31),('12664','2013-07-20','18:20:00',1.21),('12664','2013-07-20','18:25:00',1.11),('12664','2013-07-20','18:30:00',1.02),('12664','2014-04-06','08:20:00',1.09),('12664','2014-04-06','08:25:00',1.2),('12664','2014-04-06','08:30:00',1.31),('12664','2014-04-06','08:35:00',1.4),('12664','2014-04-06','08:40:00',1.5),('12664','2014-04-06','08:45:00',1.59),('12664','2014-04-06','08:50:00',1.68),('12664','2014-04-06','08:55:00',1.79),('12664','2014-04-06','09:00:00',1.87),('12664','2014-04-06','09:05:00',1.99),('12664','2014-04-06','09:10:00',2.11),('12664','2014-04-06','09:15:00',2.23),('12664','2014-04-06','09:20:00',2.35),('12664','2014-04-06','09:25:00',2.4),('12664','2014-04-06','09:30:00',2.36),('12664','2014-04-06','09:35:00',2.02),('12664','2014-04-06','09:40:00',1.92),('12664','2014-04-06','09:45:00',2.06),('12664','2014-04-06','09:50:00',1.98),('12664','2014-04-06','09:55:00',3.01),('12664','2014-04-06','10:00:00',3.73),('12664','2014-04-06','10:05:00',3.6),('12664','2014-04-06','10:10:00',3.13),('12664','2014-04-06','10:15:00',1.73),('12664','2014-04-06','10:20:00',3.15),('12664','2014-04-06','10:25:00',3.85),('12664','2014-04-06','10:30:00',4.13),('12664','2014-04-06','10:35:00',4.19),('12664','2014-04-06','10:40:00',4.21),('12664','2014-04-06','10:45:00',4.11),('12664','2014-04-06','10:50:00',4.18),('12664','2014-04-06','10:55:00',4.18),('12664','2014-04-06','11:00:00',3.96),('12664','2014-04-06','11:05:00',3.9),('12664','2014-04-06','11:10:00',3.89),('12664','2014-04-06','11:15:00',3.52),('12664','2014-04-06','11:20:00',2.68),('12664','2014-04-06','11:25:00',1.71),('12664','2014-04-06','11:30:00',2.65),('12664','2014-04-06','11:35:00',4.03),('12664','2014-04-06','11:40:00',4.23),('12664','2014-04-06','11:45:00',4.09),('12664','2014-04-06','11:50:00',4.05),('12664','2014-04-06','11:55:00',4.04),('12664','2014-04-06','12:00:00',4.07),('12664','2014-04-06','12:05:00',4.05),('12664','2014-04-06','12:10:00',4.05),('12664','2014-04-06','12:15:00',4.11),('12664','2014-04-06','12:20:00',3.97),('12664','2014-04-06','12:25:00',3.91),('12664','2014-04-06','12:30:00',4.08),('12664','2014-04-06','12:35:00',4.07),('12664','2014-04-06','12:40:00',4.11),('12664','2014-04-06','12:45:00',4.1),('12664','2014-04-06','12:50:00',4.24),('12664','2014-04-06','12:55:00',2.32),('12664','2014-04-06','13:00:00',4.23),('12664','2014-04-06','13:05:00',4.24),('12664','2014-04-06','13:10:00',4.31),('12664','2014-04-06','13:15:00',4.36),('12664','2014-04-06','13:20:00',4.33),('12664','2014-04-06','13:25:00',4.22),('12664','2014-04-06','13:30:00',4.07),('12664','2014-04-06','13:35:00',3.5),('12664','2014-04-06','13:40:00',4.11),('12664','2014-04-06','13:45:00',4.07),('12664','2014-04-06','13:50:00',4.07),('12664','2014-04-06','13:55:00',3.99),('12664','2014-04-06','14:00:00',4),('12664','2014-04-06','14:05:00',3.98),('12664','2014-04-06','14:10:00',3.99),('12664','2014-04-06','14:15:00',3.98),('12664','2014-04-06','14:20:00',3.95),('12664','2014-04-06','14:25:00',3.92),('12664','2014-04-06','14:30:00',3.78),('12664','2014-04-06','14:35:00',2.79),('12664','2014-04-06','14:40:00',4),('12664','2014-04-06','14:45:00',3.86),('12664','2014-04-06','14:50:00',3.89),('12664','2014-04-06','14:55:00',3.84),('12664','2014-04-06','15:00:00',1.85),('12664','2014-04-06','15:05:00',1.05),('12664','2014-04-06','15:20:00',1.61),('12664','2014-04-06','15:30:00',2.57),('12664','2014-04-06','16:05:00',2.68),('12664','2014-04-06','16:10:00',3.56),('12664','2014-04-06','16:15:00',2.05),('12664','2014-04-06','16:45:00',2.06),('12664','2014-04-06','16:50:00',3),('12664','2014-04-06','16:55:00',2.87),('12664','2014-04-06','17:00:00',1.85),('12664','2014-04-06','17:20:00',1.08),('12664','2014-04-06','17:25:00',1.73),('12664','2014-04-06','17:30:00',1.66),('12664','2014-04-06','17:35:00',1.57),('12664','2014-04-06','17:40:00',1.44),('12664','2014-04-06','17:45:00',1.33),('12664','2014-04-06','17:50:00',1.23),('12664','2014-04-06','17:55:00',1.11),('12664','2014-04-06','18:00:00',1.03),('12664','2013-07-19','07:55:00',1.04),('12664','2013-07-19','08:00:00',1.12),('12664','2013-07-19','08:05:00',1.2),('12664','2013-07-19','08:10:00',1.29),('12664','2013-07-19','08:15:00',1.36),('12664','2013-07-19','08:20:00',1.44),('12664','2013-07-19','08:25:00',1.53),('12664','2013-07-19','08:30:00',1.63),('12664','2013-07-19','08:35:00',1.71),('12664','2013-07-19','08:40:00',1.79),('12664','2013-07-19','08:45:00',1.87),('12664','2013-07-19','08:50:00',1.96),('12664','2013-07-19','08:55:00',2.03),('12664','2013-07-19','09:00:00',1.98),('12664','2013-07-19','09:05:00',2.18),('12664','2013-07-19','09:10:00',2.28),('12664','2013-07-19','09:15:00',2.35),('12664','2013-07-19','09:20:00',2.37),('12664','2013-07-19','09:25:00',2.47),('12664','2013-07-19','09:30:00',2.53),('12664','2013-07-19','09:35:00',2.59),('12664','2013-07-19','09:40:00',2.66),('12664','2013-07-19','09:45:00',2.71),('12664','2013-07-19','09:50:00',2.76),('12664','2013-07-19','09:55:00',2.79),('12664','2013-07-19','10:00:00',2.85),('12664','2013-07-19','10:05:00',2.92),('12664','2013-07-19','10:10:00',2.75),('12664','2013-07-19','10:15:00',3.02),('12664','2013-07-19','10:20:00',3.11),('12664','2013-07-19','10:25:00',3.18),('12664','2013-07-19','10:30:00',3.19),('12664','2013-07-19','10:35:00',3.23),('12664','2013-07-19','10:40:00',3.31),('12664','2013-07-19','10:45:00',3.38),('12664','2013-07-19','10:50:00',3.37),('12664','2013-07-19','10:55:00',3.46),('12664','2013-07-19','11:00:00',3.49),('12664','2013-07-19','11:05:00',3.55),('12664','2013-07-19','11:10:00',3.62),('12664','2013-07-19','11:15:00',3.62),('12664','2013-07-19','11:20:00',3.63),('12664','2013-07-19','11:25:00',3.6),('12664','2013-07-19','11:30:00',2.82),('12664','2013-07-19','11:35:00',3.48),('12664','2013-07-19','11:40:00',3.75),('12664','2013-07-19','11:45:00',3.83),('12664','2013-07-19','11:50:00',3.82),('12664','2013-07-19','11:55:00',3.81),('12664','2013-07-19','12:00:00',3.95),('12664','2013-07-19','12:05:00',3.95),('12664','2013-07-19','12:10:00',3.97),('12664','2013-07-19','12:15:00',3.98),('12664','2013-07-19','12:20:00',4.05),('12664','2013-07-19','12:25:00',4.05),('12664','2013-07-19','12:30:00',4.03),('12664','2013-07-19','12:35:00',4.05),('12664','2013-07-19','12:40:00',4.08),('12664','2013-07-19','12:45:00',4.11),('12664','2013-07-19','12:50:00',4.1),('12664','2013-07-19','12:55:00',4.17),('12664','2013-07-19','13:00:00',4.15),('12664','2013-07-19','13:05:00',4.24),('12664','2013-07-19','13:10:00',4.23),('12664','2013-07-19','13:15:00',4.24),('12664','2013-07-19','13:20:00',4.24),('12664','2013-07-19','13:25:00',4.23),('12664','2013-07-19','13:30:00',4.23),('12664','2013-07-19','13:35:00',4.24),('12664','2013-07-19','13:40:00',4.23),('12664','2013-07-19','13:45:00',4.25),('12664','2013-07-19','13:50:00',4.03),('12664','2013-07-19','13:55:00',3.98),('12664','2013-07-19','14:00:00',4.21),('12664','2013-07-19','14:05:00',4.2),('12664','2013-07-19','14:10:00',4.17),('12664','2013-07-19','14:15:00',4.18),('12664','2013-07-19','14:20:00',4.16),('12664','2013-07-19','14:25:00',4.12),('12664','2013-07-19','14:30:00',4.12),('12664','2013-07-19','14:35:00',4.12),('12664','2013-07-19','14:40:00',3.75),('12664','2013-07-19','14:45:00',3.49),('12664','2013-07-19','14:50:00',4),('12664','2013-07-19','14:55:00',3.78),('12664','2013-07-19','15:00:00',4.03),('12664','2013-07-19','15:05:00',3.73),('12664','2013-07-19','15:10:00',1.59),('12664','2013-07-19','15:15:00',3.01),('12664','2013-07-19','15:20:00',2.09),('12664','2013-07-19','15:25:00',3.09),('12664','2013-07-19','15:30:00',3.52),('12664','2013-07-19','15:35:00',3.85),('12664','2013-07-19','15:40:00',3.68),('12664','2013-07-19','15:45:00',3.61),('12664','2013-07-19','15:50:00',3.5),('12664','2013-07-19','15:55:00',3.42),('12664','2013-07-19','16:00:00',3.34),('12664','2013-07-19','16:05:00',3.37),('12664','2013-07-19','16:10:00',3.06),('12664','2013-07-19','16:15:00',3.19),('12664','2013-07-19','16:20:00',3.15),('12664','2013-07-19','16:25:00',3.09),('12664','2013-07-19','16:30:00',2.96),('12664','2013-07-19','16:35:00',2.91),('12664','2013-07-19','16:40:00',2.96),('12664','2013-07-19','16:45:00',2.9),('12664','2013-07-19','16:50:00',2.83),('12664','2013-07-19','16:55:00',2.78),('12664','2013-07-19','17:00:00',2.55),('12664','2013-07-19','17:05:00',1.73),('12664','2013-07-19','17:10:00',1.53),('12664','2013-07-19','17:15:00',1.45),('12664','2013-07-19','17:20:00',1.69),('12664','2013-07-19','17:25:00',1.62),('12664','2013-07-19','17:30:00',1.37),('12664','2013-07-19','17:35:00',1.37),('12664','2013-07-19','17:40:00',1.34),('12664','2013-07-19','17:45:00',1.17),('12664','2013-07-19','17:50:00',1.04),('12664','2013-07-18','07:50:00',1.04),('12664','2013-07-18','07:55:00',1.12),('12664','2013-07-18','08:00:00',1.21),('12664','2013-07-18','08:05:00',1.29),('12664','2013-07-18','08:10:00',1.38),('12664','2013-07-18','08:15:00',1.46),('12664','2013-07-18','08:20:00',1.55),('12664','2013-07-18','08:25:00',1.63),('12664','2013-07-18','08:30:00',1.72),('12664','2013-07-18','08:35:00',1.8),('12664','2013-07-18','08:40:00',1.89),('12664','2013-07-18','08:45:00',1.98),('12664','2013-07-18','08:50:00',2.07),('12664','2013-07-18','08:55:00',2.15),('12664','2013-07-18','09:00:00',2.24),('12664','2013-07-18','09:05:00',2.3),('12664','2013-07-18','09:10:00',2.39),('12664','2013-07-18','09:15:00',2.46),('12664','2013-07-18','09:20:00',2.52),('12664','2013-07-18','09:25:00',2.6),('12664','2013-07-18','09:30:00',2.67),('12664','2013-07-18','09:35:00',2.71),('12664','2013-07-18','09:40:00',2.79),('12664','2013-07-18','09:45:00',2.86),('12664','2013-07-18','09:50:00',2.93),('12664','2013-07-18','09:55:00',2.98),('12664','2013-07-18','10:00:00',3.05),('12664','2013-07-18','10:05:00',3.12),('12664','2013-07-18','10:10:00',3.17),('12664','2013-07-18','10:15:00',3.22),('12664','2013-07-18','10:20:00',3.28),('12664','2013-07-18','10:25:00',3.33),('12664','2013-07-18','10:30:00',3.39),('12664','2013-07-18','10:35:00',3.45),('12664','2013-07-18','10:40:00',3.48),('12664','2013-07-18','10:45:00',3.51),('12664','2013-07-18','10:50:00',3.51),('12664','2013-07-18','10:55:00',3.55),('12664','2013-07-18','11:00:00',3.61),('12664','2013-07-18','11:05:00',3.65),('12664','2013-07-18','11:10:00',3.65),('12664','2013-07-18','11:15:00',3.68),('12664','2013-07-18','11:20:00',3.72),('12664','2013-07-18','11:25:00',3.76),('12664','2013-07-18','11:30:00',3.78),('12664','2013-07-18','11:35:00',3.8),('12664','2013-07-18','11:40:00',3.81),('12664','2013-07-18','11:45:00',3.85),('12664','2013-07-18','11:50:00',3.89),('12664','2013-07-18','11:55:00',3.95),('12664','2013-07-18','12:00:00',3.98),('12664','2013-07-18','12:05:00',3.99),('12664','2013-07-18','12:10:00',4.02),('12664','2013-07-18','12:15:00',4.05),('12664','2013-07-18','12:20:00',4.06),('12664','2013-07-18','12:25:00',4.12),('12664','2013-07-18','12:30:00',4.12),('12664','2013-07-18','12:35:00',4.12),('12664','2013-07-18','12:40:00',4.12),('12664','2013-07-18','12:45:00',4.16),('12664','2013-07-18','12:50:00',4.16),('12664','2013-07-18','12:55:00',4.15),('12664','2013-07-18','13:00:00',4.14),('12664','2013-07-18','13:05:00',4.14),('12664','2013-07-18','13:10:00',4.12),('12664','2013-07-18','13:15:00',4.14),('12664','2013-07-18','13:20:00',4.13),('12664','2013-07-18','13:25:00',4.15),('12664','2013-07-18','13:30:00',4.18),('12664','2013-07-18','13:35:00',4.18),('12664','2013-07-18','13:40:00',4.16),('12664','2013-07-18','13:45:00',4.17),('12664','2013-07-18','13:50:00',4.21),('12664','2013-07-18','13:55:00',4.19),('12664','2013-07-18','14:00:00',4.14),('12664','2013-07-18','14:05:00',4.18),('12664','2013-07-18','14:10:00',4.14),('12664','2013-07-18','14:15:00',4.1),('12664','2013-07-18','14:20:00',4.1),('12664','2013-07-18','14:25:00',4.05),('12664','2013-07-18','14:30:00',4.03),('12664','2013-07-18','14:35:00',4),('12664','2013-07-18','14:40:00',3.98),('12664','2013-07-18','14:45:00',3.97),('12664','2013-07-18','14:50:00',3.9),('12664','2013-07-18','14:55:00',3.87),('12664','2013-07-18','15:00:00',3.82),('12664','2013-07-18','15:05:00',3.8),('12664','2013-07-18','15:10:00',3.77),('12664','2013-07-18','15:15:00',3.73),('12664','2013-07-18','15:20:00',3.68),('12664','2013-07-18','15:25:00',3.63),('12664','2013-07-18','15:30:00',3.6),('12664','2013-07-18','15:35:00',3.57),('12664','2013-07-18','15:40:00',3.54),('12664','2013-07-18','15:45:00',3.48),('12664','2013-07-18','15:50:00',3.41),('12664','2013-07-18','15:55:00',3.37),('12664','2013-07-18','16:00:00',3.3),('12664','2013-07-18','16:05:00',3.22),('12664','2013-07-18','16:10:00',3.15),('12664','2013-07-18','16:15:00',3.11),('12664','2013-07-18','16:20:00',3.06),('12664','2013-07-18','16:25:00',2.99),('12664','2013-07-18','16:30:00',2.92),('12664','2013-07-18','16:35:00',2.86),('12664','2013-07-18','16:40:00',2.79),('12664','2013-07-18','16:45:00',2.73),('12664','2013-07-18','16:50:00',2.67),('12664','2013-07-18','16:55:00',2.58),('12664','2013-07-18','17:00:00',2.48),('12664','2013-07-18','17:05:00',2.4),('12664','2013-07-18','17:10:00',2.34),('12664','2013-07-18','17:15:00',2.28),('12664','2013-07-18','17:20:00',2.17),('12664','2013-07-18','17:25:00',1.88),('12664','2013-07-18','17:30:00',1.98),('12664','2013-07-18','17:35:00',1.9),('12664','2013-07-18','17:40:00',1.8),('12664','2013-07-18','17:45:00',1.68),('12664','2013-07-18','17:50:00',1.67),('12664','2013-07-18','17:55:00',1.66),('12664','2013-07-18','18:00:00',1.44),('12664','2013-07-18','18:05:00',1.2),('12664','2013-07-18','18:10:00',1.2),('12664','2013-07-17','07:50:00',1.08),('12664','2013-07-17','07:55:00',1.18),('12664','2013-07-17','08:00:00',1.27),('12664','2013-07-17','08:05:00',1.36),('12664','2013-07-17','08:10:00',1.44),('12664','2013-07-17','08:15:00',1.52),('12664','2013-07-17','08:20:00',1.62),('12664','2013-07-17','08:25:00',1.7),('12664','2013-07-17','08:30:00',1.78),('12664','2013-07-17','08:35:00',1.88),('12664','2013-07-17','08:40:00',1.96),('12664','2013-07-17','08:45:00',2.05),('12664','2013-07-17','08:50:00',2.12),('12664','2013-07-17','08:55:00',2.19),('12664','2013-07-17','09:00:00',2.28),('12664','2013-07-17','09:05:00',2.34),('12664','2013-07-17','09:10:00',2.43),('12664','2013-07-17','09:15:00',2.5),('12664','2013-07-17','09:20:00',2.58),('12664','2013-07-17','09:25:00',2.65),('12664','2013-07-17','09:30:00',2.73),('12664','2013-07-17','09:35:00',2.79),('12664','2013-07-17','09:40:00',2.86),('12664','2013-07-17','09:45:00',2.92),('12664','2013-07-17','09:50:00',2.99),('12664','2013-07-17','09:55:00',3.05),('12664','2013-07-17','10:00:00',3.12),('12664','2013-07-17','10:05:00',3.2),('12664','2013-07-17','10:10:00',3.24),('12664','2013-07-17','10:15:00',3.3),('12664','2013-07-17','10:20:00',3.37),('12664','2013-07-17','10:25:00',3.41),('12664','2013-07-17','10:30:00',3.46),('12664','2013-07-17','10:35:00',3.54),('12664','2013-07-17','10:40:00',3.59),('12664','2013-07-17','10:45:00',3.62),('12664','2013-07-17','10:50:00',3.67),('12664','2013-07-17','10:55:00',3.7),('12664','2013-07-17','11:00:00',3.75),('12664','2013-07-17','11:05:00',3.78),('12664','2013-07-17','11:10:00',3.8),('12664','2013-07-17','11:15:00',3.86),('12664','2013-07-17','11:20:00',3.9),('12664','2013-07-17','11:25:00',3.93),('12664','2013-07-17','11:30:00',3.95),('12664','2013-07-17','11:35:00',3.99),('12664','2013-07-17','11:40:00',4),('12664','2013-07-17','11:45:00',4.04),('12664','2013-07-17','11:50:00',4.06),('12664','2013-07-17','11:55:00',4.04),('12664','2013-07-17','12:00:00',4.09),('12664','2013-07-17','12:05:00',4.11),('12664','2013-07-17','12:10:00',4.15),('12664','2013-07-17','12:15:00',4.15),('12664','2013-07-17','12:20:00',4.13),('12664','2013-07-17','12:25:00',4.16),('12664','2013-07-17','12:30:00',4.17),('12664','2013-07-17','12:35:00',4.18),('12664','2013-07-17','12:40:00',4.2),('12664','2013-07-17','12:45:00',4.23),('12664','2013-07-17','12:50:00',4.24),('12664','2013-07-17','12:55:00',4.23),('12664','2013-07-17','13:00:00',4.23),('12664','2013-07-17','13:05:00',4.2),('12664','2013-07-17','13:10:00',4.19),('12664','2013-07-17','13:15:00',4.19),('12664','2013-07-17','13:20:00',4.14),('12664','2013-07-17','13:25:00',4.12),('12664','2013-07-17','13:30:00',4.13),('12664','2013-07-17','13:35:00',4.14),('12664','2013-07-17','13:40:00',4.13),('12664','2013-07-17','13:45:00',4.11),('12664','2013-07-17','13:50:00',4.12),('12664','2013-07-17','13:55:00',4.1),('12664','2013-07-17','14:00:00',4.11),('12664','2013-07-17','14:05:00',4.1),('12664','2013-07-17','14:10:00',4.09),('12664','2013-07-17','14:15:00',4.02),('12664','2013-07-17','14:20:00',4.02),('12664','2013-07-17','14:25:00',4.03),('12664','2013-07-17','14:30:00',4.04),('12664','2013-07-17','14:35:00',3.89),('12664','2013-07-17','14:40:00',3.91),('12664','2013-07-17','14:45:00',3.94),('12664','2013-07-17','14:50:00',3.91),('12664','2013-07-17','14:55:00',3.86),('12664','2013-07-17','15:00:00',3.81),('12664','2013-07-17','15:05:00',3.8),('12664','2013-07-17','15:10:00',3.73),('12664','2013-07-17','15:15:00',3.71),('12664','2013-07-17','15:20:00',3.66),('12664','2013-07-17','15:25:00',3.61),('12664','2013-07-17','15:30:00',3.62),('12664','2013-07-17','15:35:00',3.63),('12664','2013-07-17','15:40:00',3.63),('12664','2013-07-17','15:45:00',3.55),('12664','2013-07-17','15:50:00',3.54),('12664','2013-07-17','15:55:00',3.08),('12664','2013-07-17','16:00:00',3.22),('12664','2013-07-17','16:05:00',3.3),('12664','2013-07-17','16:10:00',3.27),('12664','2013-07-17','16:15:00',3.21),('12664','2013-07-17','16:20:00',3.1),('12664','2013-07-17','16:25:00',3.07),('12664','2013-07-17','16:30:00',3.01),('12664','2013-07-17','16:35:00',2.94),('12664','2013-07-17','16:40:00',2.8),('12664','2013-07-17','16:45:00',2.76),('12664','2013-07-17','16:50:00',2.71),('12664','2013-07-17','16:55:00',2.62),('12664','2013-07-17','17:00:00',2.55),('12664','2013-07-17','17:05:00',2.46),('12664','2013-07-17','17:10:00',2.39),('12664','2013-07-17','17:15:00',2.32),('12664','2013-07-17','17:20:00',2.24),('12664','2013-07-17','17:25:00',2.17),('12664','2013-07-17','17:30:00',2.09),('12664','2013-07-17','17:35:00',2.01),('12664','2013-07-17','17:40:00',1.94),('12664','2013-07-17','17:45:00',1.84),('12664','2013-07-17','17:50:00',1.76),('12664','2013-07-17','17:55:00',1.67),('12664','2013-07-17','18:00:00',1.58),('12664','2013-07-17','18:05:00',1.5),('12664','2013-07-17','18:10:00',1.4),('12664','2013-07-17','18:15:00',1.31),('12664','2013-07-17','18:20:00',1.21),('12664','2013-07-17','18:25:00',1.11),('12664','2013-07-17','18:30:00',1.04),('12664','2013-07-16','07:50:00',1.08),('12664','2013-07-16','07:55:00',1.16),('12664','2013-07-16','08:00:00',1.24),('12664','2013-07-16','08:05:00',1.31),('12664','2013-07-16','08:10:00',1.41),('12664','2013-07-16','08:15:00',1.49),('12664','2013-07-16','08:20:00',1.58),('12664','2013-07-16','08:25:00',1.68),('12664','2013-07-16','08:30:00',1.75),('12664','2013-07-16','08:35:00',1.84),('12664','2013-07-16','08:40:00',1.92),('12664','2013-07-16','08:45:00',2.01),('12664','2013-07-16','08:50:00',2.09),('12664','2013-07-16','08:55:00',2.18),('12664','2013-07-16','09:00:00',2.26),('12664','2013-07-16','09:05:00',2.34),('12664','2013-07-16','09:10:00',2.41),('12664','2013-07-16','09:15:00',2.48),('12664','2013-07-16','09:20:00',2.54),('12664','2013-07-16','09:25:00',2.61),('12664','2013-07-16','09:30:00',2.67),('12664','2013-07-16','09:35:00',2.76),('12664','2013-07-16','09:40:00',2.83),('12664','2013-07-16','09:45:00',2.88),('12664','2013-07-16','09:50:00',2.93),('12664','2013-07-16','09:55:00',2.99),('12664','2013-07-16','10:00:00',3.04),('12664','2013-07-16','10:05:00',3.12),('12664','2013-07-16','10:10:00',3.16),('12664','2013-07-16','10:15:00',3.2),('12664','2013-07-16','10:20:00',3.26),('12664','2013-07-16','10:25:00',3.32),('12664','2013-07-16','10:30:00',3.37),('12664','2013-07-16','10:35:00',3.4),('12664','2013-07-16','10:40:00',3.43),('12664','2013-07-16','10:45:00',3.5),('12664','2013-07-16','10:50:00',3.55),('12664','2013-07-16','10:55:00',3.61),('12664','2013-07-16','11:00:00',3.64),('12664','2013-07-16','11:05:00',3.7),('12664','2013-07-16','11:10:00',3.74),('12664','2013-07-16','11:15:00',3.77),('12664','2013-07-16','11:20:00',3.8),('12664','2013-07-16','11:25:00',3.84),('12664','2013-07-16','11:30:00',3.89),('12664','2013-07-16','11:35:00',3.92),('12664','2013-07-16','11:40:00',3.97),('12664','2013-07-16','11:45:00',3.97),('12664','2013-07-16','11:50:00',3.95),('12664','2013-07-16','11:55:00',3.98),('12664','2013-07-16','12:00:00',4),('12664','2013-07-16','12:05:00',4.05),('12664','2013-07-16','12:10:00',4.08),('12664','2013-07-16','12:15:00',4.11),('12664','2013-07-16','12:20:00',4.14),('12664','2013-07-16','12:25:00',4.16),('12664','2013-07-16','12:30:00',4.14),('12664','2013-07-16','12:35:00',4.12),('12664','2013-07-16','12:40:00',4.16),('12664','2013-07-16','12:45:00',4.2),('12664','2013-07-16','12:50:00',4.21),('12664','2013-07-16','12:55:00',4.2),('12664','2013-07-16','13:00:00',4.19),('12664','2013-07-16','13:05:00',4.21),('12664','2013-07-16','13:10:00',4.2),('12664','2013-07-16','13:15:00',4.18),('12664','2013-07-16','13:20:00',4.16),('12664','2013-07-16','13:25:00',4.18),('12664','2013-07-16','13:30:00',4.15),('12664','2013-07-16','13:35:00',4.14),('12664','2013-07-16','13:40:00',4.18),('12664','2013-07-16','13:45:00',4.12),('12664','2013-07-16','13:50:00',4.09),('12664','2013-07-16','13:55:00',4.09),('12664','2013-07-16','14:00:00',4.09),('12664','2013-07-16','14:05:00',4.06),('12664','2013-07-16','14:10:00',4.06),('12664','2013-07-16','14:15:00',4.03),('12664','2013-07-16','14:20:00',4.03),('12664','2013-07-16','14:25:00',3.98),('12664','2013-07-16','14:30:00',3.92),('12664','2013-07-16','14:35:00',3.06),('12664','2013-07-16','14:40:00',3.09),('12664','2013-07-16','14:45:00',3.21),('12664','2013-07-16','14:50:00',3.99),('12664','2013-07-16','14:55:00',3.88),('12664','2013-07-16','15:00:00',3.83),('12664','2013-07-16','15:05:00',3.76),('12664','2013-07-16','15:10:00',3.7),('12664','2013-07-16','15:15:00',3.7),('12664','2013-07-16','15:20:00',3.64),('12664','2013-07-16','15:25:00',3.61),('12664','2013-07-16','15:30:00',3.57),('12664','2013-07-16','15:35:00',3.52),('12664','2013-07-16','15:40:00',3.52),('12664','2013-07-16','15:45:00',3.49),('12664','2013-07-16','15:50:00',3.45),('12664','2013-07-16','15:55:00',3.39),('12664','2013-07-16','16:00:00',3.37),('12664','2013-07-16','16:05:00',3.29),('12664','2013-07-16','16:10:00',2.49),('12664','2013-07-16','16:15:00',2.06),('12664','2013-07-16','16:20:00',2.93),('12664','2013-07-16','16:25:00',3.02),('12664','2013-07-16','16:30:00',3.06),('12664','2013-07-16','16:35:00',2.96),('12664','2013-07-16','16:40:00',2.9),('12664','2013-07-16','16:45:00',2.89),('12664','2013-07-16','16:50:00',2.77),('12664','2013-07-16','16:55:00',1.35),('12664','2013-07-16','17:00:00',2.62),('12664','2013-07-16','17:05:00',2.41),('12664','2013-07-16','17:10:00',2.24),('12664','2013-07-16','17:15:00',2.3),('12664','2013-07-16','17:20:00',2.14),('12664','2013-07-16','17:25:00',2.19),('12664','2013-07-16','17:30:00',2.14),('12664','2013-07-16','17:35:00',1.81),('12664','2013-07-16','17:40:00',1.87),('12664','2013-07-16','17:45:00',1.85),('12664','2013-07-16','17:50:00',1.77),('12664','2013-07-16','17:55:00',1.16),('12664','2013-07-16','18:00:00',1.39),('12664','2013-07-16','18:05:00',1.52),('12664','2013-07-16','18:30:00',1.05),('12664','2013-07-15','07:45:00',1.02),('12664','2013-07-15','07:50:00',1.11),('12664','2013-07-15','07:55:00',1.19),('12664','2013-07-15','08:00:00',1.28),('12664','2013-07-15','08:05:00',1.38),('12664','2013-07-15','08:10:00',1.47),('12664','2013-07-15','08:15:00',1.56),('12664','2013-07-15','08:20:00',1.65),('12664','2013-07-15','08:25:00',1.73),('12664','2013-07-15','08:30:00',1.83),('12664','2013-07-15','08:35:00',1.91),('12664','2013-07-15','08:40:00',2),('12664','2013-07-15','08:45:00',2.07),('12664','2013-07-15','08:50:00',2.16),('12664','2013-07-15','08:55:00',2.24),('12664','2013-07-15','09:00:00',2.33),('12664','2013-07-15','09:05:00',2.41),('12664','2013-07-15','09:10:00',2.49),('12664','2013-07-15','09:15:00',2.57),('12664','2013-07-15','09:20:00',2.64),('12664','2013-07-15','09:25:00',2.71),('12664','2013-07-15','09:30:00',2.76),('12664','2013-07-15','09:35:00',2.83),('12664','2013-07-15','09:40:00',2.9),('12664','2013-07-15','09:45:00',2.95),('12664','2013-07-15','09:50:00',3.02),('12664','2013-07-15','09:55:00',3.09),('12664','2013-07-15','10:00:00',3.14),('12664','2013-07-15','10:05:00',3.18),('12664','2013-07-15','10:10:00',3.24),('12664','2013-07-15','10:15:00',3.3),('12664','2013-07-15','10:20:00',3.34),('12664','2013-07-15','10:25:00',3.38),('12664','2013-07-15','10:30:00',3.43),('12664','2013-07-15','10:35:00',3.49),('12664','2013-07-15','10:40:00',3.53),('12664','2013-07-15','10:45:00',3.56),('12664','2013-07-15','10:50:00',3.61),('12664','2013-07-15','10:55:00',3.68),('12664','2013-07-15','11:00:00',3.71),('12664','2013-07-15','11:05:00',3.77),('12664','2013-07-15','11:10:00',3.82),('12664','2013-07-15','11:15:00',3.85),('12664','2013-07-15','11:20:00',3.88),('12664','2013-07-15','11:25:00',3.92),('12664','2013-07-15','11:30:00',3.95),('12664','2013-07-15','11:35:00',4.01),('12664','2013-07-15','11:40:00',4.01),('12664','2013-07-15','11:45:00',4.02),('12664','2013-07-15','11:50:00',4.04),('12664','2013-07-15','11:55:00',4.07),('12664','2013-07-15','12:00:00',4.09),('12664','2013-07-15','12:05:00',4.06),('12664','2013-07-15','12:10:00',4.08),('12664','2013-07-15','12:15:00',4.1),('12664','2013-07-15','12:20:00',4.11),('12664','2013-07-15','12:25:00',4.1),('12664','2013-07-15','12:30:00',4.11),('12664','2013-07-15','12:35:00',4.13),('12664','2013-07-15','12:40:00',4.15),('12664','2013-07-15','12:45:00',4.17),('12664','2013-07-15','12:50:00',4.13),('12664','2013-07-15','12:55:00',4.15),('12664','2013-07-15','13:00:00',4.15),('12664','2013-07-15','13:05:00',4.19),('12664','2013-07-15','13:10:00',4.18),('12664','2013-07-15','13:15:00',4.2),('12664','2013-07-15','13:20:00',4.21),('12664','2013-07-15','13:25:00',4.25),('12664','2013-07-15','13:30:00',4.24),('12664','2013-07-15','13:35:00',4.21),('12664','2013-07-15','13:40:00',4.18),('12664','2013-07-15','13:45:00',4.17),('12664','2013-07-15','13:50:00',4.21),('12664','2013-07-15','13:55:00',4.19),('12664','2013-07-15','14:00:00',4.2),('12664','2013-07-15','14:05:00',4.23),('12664','2013-07-15','14:10:00',4.23),('12664','2013-07-15','14:15:00',4.25),('12664','2013-07-15','14:20:00',4.21),('12664','2013-07-15','14:25:00',4.18),('12664','2013-07-15','14:30:00',4.06),('12664','2013-07-15','14:35:00',4.05),('12664','2013-07-15','14:40:00',4.02),('12664','2013-07-15','14:45:00',3.98),('12664','2013-07-15','14:50:00',3.9),('12664','2013-07-15','14:55:00',3.87),('12664','2013-07-15','15:00:00',3.84),('12664','2013-07-15','15:05:00',3.83),('12664','2013-07-15','15:10:00',3.82),('12664','2013-07-15','15:15:00',3.79),('12664','2013-07-15','15:20:00',3.67),('12664','2013-07-15','15:25:00',3.62),('12664','2013-07-15','15:30:00',3.6),('12664','2013-07-15','15:35:00',3.63),('12664','2013-07-15','15:40:00',3.3),('12664','2013-07-15','15:45:00',3.43),('12664','2013-07-15','15:50:00',3.46),('12664','2013-07-15','15:55:00',3.41),('12664','2013-07-15','16:00:00',3.36),('12664','2013-07-15','16:05:00',3.29),('12664','2013-07-15','16:10:00',3.22),('12664','2013-07-15','16:15:00',3.14),('12664','2013-07-15','16:20:00',3.08),('12664','2013-07-15','16:25:00',3.01),('12664','2013-07-15','16:30:00',2.87),('12664','2013-07-15','16:35:00',2.78),('12664','2013-07-15','16:40:00',2.73),('12664','2013-07-15','16:45:00',2.67),('12664','2013-07-15','16:50:00',2.63),('12664','2013-07-15','16:55:00',2.59),('12664','2013-07-15','17:00:00',2.53),('12664','2013-07-15','17:05:00',2.46),('12664','2013-07-15','17:10:00',2.38),('12664','2013-07-15','17:15:00',2.3),('12664','2013-07-15','17:20:00',2.22),('12664','2013-07-15','17:25:00',2.14),('12664','2013-07-15','17:30:00',2.05),('12664','2013-07-15','17:35:00',1.95),('12664','2013-07-15','17:40:00',1.88),('12664','2013-07-15','17:45:00',1.8),('12664','2013-07-15','17:50:00',1.68),('12664','2013-07-15','17:55:00',1.63),('12664','2013-07-15','18:00:00',1.54),('12664','2013-07-15','18:05:00',1.43),('12664','2013-07-15','18:10:00',1.36),('12664','2013-07-15','18:15:00',1.29),('12664','2013-07-15','18:20:00',1.22),('12664','2013-07-15','18:25:00',1.14),('12664','2013-07-15','18:30:00',1.06),('12664','2013-07-14','07:50:00',1.03),('12664','2013-07-14','07:55:00',1.23),('12664','2013-07-14','08:00:00',1.21),('12664','2013-07-14','08:05:00',1.6),('12664','2013-07-14','08:10:00',1.8),('12664','2013-07-14','08:15:00',1.49),('12664','2013-07-14','08:20:00',1.31),('12664','2013-07-14','08:25:00',1.03),('12664','2013-07-14','08:30:00',1.45),('12664','2013-07-14','08:35:00',1.23),('12664','2013-07-14','08:40:00',1),('12664','2013-07-14','08:45:00',1.02),('12664','2013-07-14','08:50:00',1.02),('12664','2013-07-14','08:55:00',1.13),('12664','2013-07-14','09:00:00',1.08),('12664','2013-07-14','09:05:00',1.26),('12664','2013-07-14','09:10:00',1.37),('12664','2013-07-14','09:15:00',2.05),('12664','2013-07-14','09:20:00',2.59),('12664','2013-07-14','09:25:00',1.31),('12664','2013-07-14','09:30:00',1.46),('12664','2013-07-14','09:35:00',1.5),('12664','2013-07-14','09:40:00',1.56),('12664','2013-07-14','09:45:00',1.74),('12664','2013-07-14','09:50:00',1.78),('12664','2013-07-14','09:55:00',1.6),('12664','2013-07-14','10:00:00',1.7),('12664','2013-07-14','10:05:00',1.37),('12664','2013-07-14','10:10:00',1.71),('12664','2013-07-14','10:15:00',2.61),('12664','2013-07-14','10:20:00',3.3),('12664','2013-07-14','10:25:00',2.86),('12664','2013-07-14','10:30:00',2.69),('12664','2013-07-14','10:35:00',3),('12664','2013-07-14','10:40:00',2.59),('12664','2013-07-14','10:45:00',2.87),('12664','2013-07-14','10:50:00',3.62),('12664','2013-07-14','10:55:00',3.92),('12664','2013-07-14','11:00:00',3.6),('12664','2013-07-14','11:05:00',3.41),('12664','2013-07-14','11:10:00',2.98),('12664','2013-07-14','11:15:00',3.09),('12664','2013-07-14','11:20:00',2.94),('12664','2013-07-14','11:25:00',4.17),('12664','2013-07-14','11:30:00',4.21),('12664','2013-07-14','11:35:00',3.13),('12664','2013-07-14','11:40:00',4.18),('12664','2013-07-14','11:45:00',4.23),('12664','2013-07-14','11:50:00',4.25),('12664','2013-07-14','11:55:00',4.12),('12664','2013-07-14','12:00:00',1.79),('12664','2013-07-14','12:05:00',1.16),('12664','2013-07-14','12:10:00',1.27),('12664','2013-07-14','12:15:00',3.51),('12664','2013-07-14','12:20:00',4.58),('12664','2013-07-14','12:25:00',4.58),('12664','2013-07-14','12:30:00',4.42),('12664','2013-07-14','12:35:00',1.44),('12664','2013-07-14','12:40:00',4.59),('12664','2013-07-14','12:45:00',4.61),('12664','2013-07-14','12:50:00',4.38),('12664','2013-07-14','12:55:00',4.47),('12664','2013-07-14','13:00:00',4.44),('12664','2013-07-14','13:05:00',4.23),('12664','2013-07-14','13:10:00',4.27),('12664','2013-07-14','13:15:00',4.27),('12664','2013-07-14','13:20:00',4.29),('12664','2013-07-14','13:25:00',4.33),('12664','2013-07-14','13:30:00',4.32),('12664','2013-07-14','13:35:00',4.33),('12664','2013-07-14','13:40:00',4.35),('12664','2013-07-14','13:45:00',4.36),('12664','2013-07-14','13:50:00',4.37),('12664','2013-07-14','13:55:00',4.36),('12664','2013-07-14','14:00:00',4.37),('12664','2013-07-14','14:05:00',4.38),('12664','2013-07-14','14:10:00',4.39),('12664','2013-07-14','14:15:00',4.31),('12664','2013-07-14','14:20:00',4.24),('12664','2013-07-14','14:25:00',4.21),('12664','2013-07-14','14:30:00',4.18),('12664','2013-07-14','14:35:00',4.11),('12664','2013-07-14','14:40:00',4.1),('12664','2013-07-14','14:45:00',4.07),('12664','2013-07-14','14:50:00',4.01),('12664','2013-07-14','14:55:00',3.99),('12664','2013-07-14','15:00:00',4),('12664','2013-07-14','15:05:00',3.97),('12664','2013-07-14','15:10:00',3.9),('12664','2013-07-14','15:15:00',3.89),('12664','2013-07-14','15:20:00',3.83),('12664','2013-07-14','15:25:00',3.81),('12664','2013-07-14','15:30:00',3.77),('12664','2013-07-14','15:35:00',3.72),('12664','2013-07-14','15:40:00',3.67),('12664','2013-07-14','15:45:00',3.55),('12664','2013-07-14','15:50:00',3.52),('12664','2013-07-14','15:55:00',3.48),('12664','2013-07-14','16:00:00',3.35),('12664','2013-07-14','16:05:00',3.14),('12664','2013-07-14','16:10:00',2.53),('12664','2013-07-14','16:15:00',2.76),('12664','2013-07-14','16:20:00',3.25),('12664','2013-07-14','16:25:00',2.93),('12664','2013-07-14','16:30:00',2.01),('12664','2013-07-14','16:35:00',2.2),('12664','2013-07-14','16:40:00',3.1),('12664','2013-07-14','16:45:00',2.36),('12664','2013-07-14','16:50:00',3.06),('12664','2013-07-14','16:55:00',2.05),('12664','2013-07-14','17:00:00',1.88),('12664','2013-07-14','17:05:00',2.4),('12664','2013-07-14','17:15:00',1.63),('12664','2013-07-14','17:20:00',1.75),('12664','2013-07-14','17:25:00',2.42),('12664','2013-07-14','17:30:00',1.61),('12664','2013-07-14','17:35:00',2.3),('12664','2013-07-14','17:40:00',2.19),('12664','2013-07-14','17:45:00',1.55),('12664','2013-07-14','17:50:00',1.6),('12664','2013-07-14','17:55:00',1.02),('12664','2013-07-14','18:30:00',1.01),('12664','2013-07-13','07:50:00',1.06),('12664','2013-07-13','07:55:00',1.12),('12664','2013-07-13','08:00:00',1.18),('12664','2013-07-13','08:05:00',1.28),('12664','2013-07-13','08:10:00',1.38),('12664','2013-07-13','08:15:00',1.46),('12664','2013-07-13','08:20:00',1.53),('12664','2013-07-13','08:25:00',1.63),('12664','2013-07-13','08:30:00',1.73),('12664','2013-07-13','08:35:00',1.83),('12664','2013-07-13','08:40:00',1.92),('12664','2013-07-13','08:45:00',2),('12664','2013-07-13','08:50:00',2.08),('12664','2013-07-13','08:55:00',2.14),('12664','2013-07-13','09:00:00',2.24),('12664','2013-07-13','09:05:00',2.27),('12664','2013-07-13','09:10:00',2.4),('12664','2013-07-13','09:15:00',2.43),('12664','2013-07-13','09:20:00',2.49),('12664','2013-07-13','09:25:00',2.51),('12664','2013-07-13','09:30:00',2.68),('12664','2013-07-13','09:35:00',2.71),('12664','2013-07-13','09:40:00',2.75),('12664','2013-07-13','09:45:00',2.83),('12664','2013-07-13','09:50:00',2.93),('12664','2013-07-13','09:55:00',2.97),('12664','2013-07-13','10:00:00',2.92),('12664','2013-07-13','10:05:00',3.02),('12664','2013-07-13','10:10:00',2.6),('12664','2013-07-13','10:15:00',3.17),('12664','2013-07-13','10:20:00',3.36),('12664','2013-07-13','10:25:00',3.51),('12664','2013-07-13','10:30:00',3.49),('12664','2013-07-13','10:35:00',3.5),('12664','2013-07-13','10:40:00',3.68),('12664','2013-07-13','10:45:00',3.73),('12664','2013-07-13','10:50:00',3.01),('12664','2013-07-13','10:55:00',1.77),('12664','2013-07-13','11:00:00',3.97),('12664','2013-07-13','11:05:00',4.21),('12664','2013-07-13','11:10:00',3.07),('12664','2013-07-13','11:15:00',1.68),('12664','2013-07-13','11:20:00',1.69),('12664','2013-07-13','11:25:00',1.6),('12664','2013-07-13','11:30:00',1.81),('12664','2013-07-13','11:35:00',4.03),('12664','2013-07-13','11:40:00',1.36),('12664','2013-07-13','11:45:00',4.31),('12664','2013-07-13','11:50:00',3.97),('12664','2013-07-13','11:55:00',1.35),('12664','2013-07-13','12:00:00',4.09),('12664','2013-07-13','12:05:00',2.09),('12664','2013-07-13','12:10:00',3.51),('12664','2013-07-13','12:15:00',2.19),('12664','2013-07-13','12:20:00',3.36),('12664','2013-07-13','12:25:00',4.45),('12664','2013-07-13','12:30:00',4.45),('12664','2013-07-13','12:35:00',3.42),('12664','2013-07-13','12:40:00',4.15),('12664','2013-07-13','12:45:00',4.13),('12664','2013-07-13','12:50:00',3.97),('12664','2013-07-13','12:55:00',4.27),('12664','2013-07-13','13:00:00',4.25),('12664','2013-07-13','13:05:00',4.33),('12664','2013-07-13','13:10:00',3.83),('12664','2013-07-13','13:15:00',4.37),('12664','2013-07-13','13:20:00',4.16),('12664','2013-07-13','13:25:00',4.28),('12664','2013-07-13','13:30:00',4.31),('12664','2013-07-13','13:35:00',4.3),('12664','2013-07-13','13:40:00',4.29),('12664','2013-07-13','13:45:00',4.32),('12664','2013-07-13','13:50:00',4.3),('12664','2013-07-13','13:55:00',4.29),('12664','2013-07-13','14:00:00',4.28),('12664','2013-07-13','14:05:00',4.24),('12664','2013-07-13','14:10:00',4.25),('12664','2013-07-13','14:15:00',4.26),('12664','2013-07-13','14:20:00',4.24),('12664','2013-07-13','14:25:00',4.2),('12664','2013-07-13','14:30:00',4.2),('12664','2013-07-13','14:35:00',4.13),('12664','2013-07-13','14:40:00',4.11),('12664','2013-07-13','14:45:00',4.09),('12664','2013-07-13','14:50:00',4.08),('12664','2013-07-13','14:55:00',4.07),('12664','2013-07-13','15:00:00',4.06),('12664','2013-07-13','15:05:00',4.05),('12664','2013-07-13','15:10:00',4),('12664','2013-07-13','15:15:00',3.78),('12664','2013-07-13','15:20:00',3.9),('12664','2013-07-13','15:25:00',3.87),('12664','2013-07-13','15:30:00',3.81),('12664','2013-07-13','15:35:00',3.79),('12664','2013-07-13','15:40:00',3.71),('12664','2013-07-13','15:45:00',3.65),('12664','2013-07-13','15:50:00',3.58),('12664','2013-07-13','15:55:00',3.53),('12664','2013-07-13','16:00:00',3.49),('12664','2013-07-13','16:05:00',3.45),('12664','2013-07-13','16:10:00',3.35),('12664','2013-07-13','16:15:00',3.26),('12664','2013-07-13','16:20:00',3.26),('12664','2013-07-13','16:25:00',3.16),('12664','2013-07-13','16:30:00',3.1),('12664','2013-07-13','16:35:00',3.05),('12664','2013-07-13','16:40:00',3.01),('12664','2013-07-13','16:45:00',2.92),('12664','2013-07-13','16:50:00',2.84),('12664','2013-07-13','16:55:00',2.76),('12664','2013-07-13','17:00:00',2.65),('12664','2013-07-13','17:05:00',2.51),('12664','2013-07-13','17:10:00',2.54),('12664','2013-07-13','17:15:00',2.46),('12664','2013-07-13','17:20:00',2.35),('12664','2013-07-13','17:25:00',2.33),('12664','2013-07-13','17:30:00',2.17),('12664','2013-07-13','17:35:00',2.13),('12664','2013-07-13','17:40:00',2.02),('12664','2013-07-13','17:45:00',1.94),('12664','2013-07-13','17:50:00',1.89),('12664','2013-07-13','17:55:00',1.81),('12664','2013-07-13','18:00:00',1.7),('12664','2013-07-13','18:05:00',1.6),('12664','2013-07-13','18:10:00',1.51),('12664','2013-07-13','18:15:00',1.39),('12664','2013-07-13','18:20:00',1.34),('12664','2013-07-13','18:25:00',1.25),('12664','2013-07-13','18:30:00',1.11),('12664','2013-07-12','08:05:00',1.35),('12664','2013-07-12','08:10:00',1.02),('12664','2013-07-12','08:20:00',1.3),('12664','2013-07-12','08:25:00',1.67),('12664','2013-07-12','08:30:00',1.11),('12664','2013-07-12','08:55:00',1.32),('12664','2013-07-12','09:00:00',1.5),('12664','2013-07-12','09:05:00',1.09),('12664','2013-07-12','09:15:00',1.37),('12664','2013-07-12','09:20:00',2.15),('12664','2013-07-12','09:25:00',1.59),('12664','2013-07-12','09:30:00',2.78),('12664','2013-07-12','09:35:00',2.8),('12664','2013-07-12','09:40:00',2.97),('12664','2013-07-12','09:45:00',2.9),('12664','2013-07-12','09:50:00',3.05),('12664','2013-07-12','09:55:00',2.55),('12664','2013-07-12','10:00:00',2.13),('12664','2013-07-12','10:05:00',2.26),('12664','2013-07-12','10:10:00',3.32),('12664','2013-07-12','10:15:00',3.27),('12664','2013-07-12','10:20:00',3.4),('12664','2013-07-12','10:25:00',3.54),('12664','2013-07-12','10:30:00',3.44),('12664','2013-07-12','10:35:00',2.23),('12664','2013-07-12','10:40:00',1.48),('12664','2013-07-12','10:45:00',3.76),('12664','2013-07-12','10:50:00',3.3),('12664','2013-07-12','10:55:00',2.89),('12664','2013-07-12','11:00:00',1.19),('12664','2013-07-12','11:05:00',1.8),('12664','2013-07-12','11:10:00',4.32),('12664','2013-07-12','11:15:00',2.48),('12664','2013-07-12','11:20:00',3.83),('12664','2013-07-12','11:25:00',2.49),('12664','2013-07-12','11:30:00',2.58),('12664','2013-07-12','11:35:00',4.13),('12664','2013-07-12','11:40:00',3.07),('12664','2013-07-12','11:45:00',4.23),('12664','2013-07-12','11:50:00',3.29),('12664','2013-07-12','11:55:00',2.35),('12664','2013-07-12','12:00:00',4.33),('12664','2013-07-12','12:05:00',4.38),('12664','2013-07-12','12:10:00',4.35),('12664','2013-07-12','12:15:00',4.35),('12664','2013-07-12','12:20:00',4.32),('12664','2013-07-12','12:25:00',3.87),('12664','2013-07-12','12:30:00',3.24),('12664','2013-07-12','12:35:00',2.59),('12664','2013-07-12','12:40:00',3.15),('12664','2013-07-12','12:45:00',4.63),('12664','2013-07-12','12:50:00',4.57),('12664','2013-07-12','12:55:00',4.39),('12664','2013-07-12','13:00:00',4.49),('12664','2013-07-12','13:05:00',4.46),('12664','2013-07-12','13:10:00',3.48),('12664','2013-07-12','13:15:00',3.01),('12664','2013-07-12','13:20:00',2.73),('12664','2013-07-12','13:25:00',4.54),('12664','2013-07-12','13:30:00',4.14),('12664','2013-07-12','13:35:00',4.51),('12664','2013-07-12','13:40:00',2.93),('12664','2013-07-12','13:45:00',4.23),('12664','2013-07-12','13:50:00',3.91),('12664','2013-07-12','13:55:00',2.1),('12664','2013-07-12','14:00:00',3.27),('12664','2013-07-12','14:05:00',4.09),('12664','2013-07-12','14:10:00',3.31),('12664','2013-07-12','14:15:00',4.51),('12664','2013-07-12','14:20:00',3.48),('12664','2013-07-12','14:25:00',4.49),('12664','2013-07-12','14:30:00',4.41),('12664','2013-07-12','14:35:00',2.68),('12664','2013-07-12','14:40:00',3.51),('12664','2013-07-12','14:45:00',4.16),('12664','2013-07-12','14:50:00',4.01),('12664','2013-07-12','14:55:00',3.96),('12664','2013-07-12','15:00:00',3.96),('12664','2013-07-12','15:05:00',3.88),('12664','2013-07-12','15:10:00',3.82),('12664','2013-07-12','15:15:00',3.8),('12664','2013-07-12','15:20:00',3.77);
INSERT INTO `solarlogmod` VALUES ('12664','2013-07-12','15:25:00',3.74),('12664','2013-07-12','15:30:00',3.7),('12664','2013-07-12','15:35:00',3.64),('12664','2013-07-12','15:40:00',3.47),('12664','2013-07-12','15:45:00',3.53),('12664','2013-07-12','15:50:00',3.45),('12664','2013-07-12','15:55:00',3.4),('12664','2013-07-12','16:00:00',3.38),('12664','2013-07-12','16:05:00',3.25),('12664','2013-07-12','16:10:00',3.21),('12664','2013-07-12','16:15:00',3.17),('12664','2013-07-12','16:20:00',3.16),('12664','2013-07-12','16:25:00',3.08),('12664','2013-07-12','16:30:00',3.03),('12664','2013-07-12','16:35:00',2.95),('12664','2013-07-12','16:40:00',2.88),('12664','2013-07-12','16:45:00',2.78),('12664','2013-07-12','16:50:00',2.7),('12664','2013-07-12','16:55:00',2.63),('12664','2013-07-12','17:00:00',2.54),('12664','2013-07-12','17:05:00',2.45),('12664','2013-07-12','17:10:00',2.41),('12664','2013-07-12','17:15:00',2.33),('12664','2013-07-12','17:20:00',2.2),('12664','2013-07-12','17:25:00',2.15),('12664','2013-07-12','17:30:00',2.09),('12664','2013-07-12','17:35:00',2.03),('12664','2013-07-12','17:40:00',1.96),('12664','2013-07-12','17:45:00',1.88),('12664','2013-07-12','17:50:00',1.07),('12664','2013-07-12','17:55:00',1.12),('12664','2013-07-12','18:05:00',1.01),('12664','2013-07-12','18:10:00',1.45),('12664','2013-07-12','18:15:00',1.33),('12664','2013-07-12','18:20:00',1.25),('12664','2013-07-12','18:25:00',1.18),('12664','2013-07-12','18:30:00',1.1),('12664','2013-07-11','07:50:00',1.08),('12664','2013-07-11','07:55:00',1.16),('12664','2013-07-11','08:00:00',1.25),('12664','2013-07-11','08:05:00',1.32),('12664','2013-07-11','08:10:00',1.4),('12664','2013-07-11','08:15:00',1.48),('12664','2013-07-11','08:20:00',1.54),('12664','2013-07-11','08:25:00',1.64),('12664','2013-07-11','08:30:00',1.74),('12664','2013-07-11','08:35:00',1.84),('12664','2013-07-11','08:40:00',1.88),('12664','2013-07-11','08:45:00',1.98),('12664','2013-07-11','08:50:00',2.05),('12664','2013-07-11','08:55:00',2.21),('12664','2013-07-11','09:00:00',2.23),('12664','2013-07-11','09:05:00',2.29),('12664','2013-07-11','09:10:00',2.39),('12664','2013-07-11','09:15:00',2.47),('12664','2013-07-11','09:20:00',2.59),('12664','2013-07-11','09:25:00',2.65),('12664','2013-07-11','09:30:00',2.7),('12664','2013-07-11','09:35:00',2.71),('12664','2013-07-11','09:40:00',1.88),('12664','2013-07-11','09:45:00',1.86),('12664','2013-07-11','09:50:00',2.2),('12664','2013-07-11','09:55:00',1.27),('12664','2013-07-11','10:00:00',1.38),('12664','2013-07-11','10:05:00',2.94),('12664','2013-07-11','10:10:00',3.48),('12664','2013-07-11','10:15:00',1.94),('12664','2013-07-11','10:20:00',1.08),('12664','2013-07-11','10:30:00',1.86),('12664','2013-07-11','10:35:00',2.58),('12664','2013-07-11','10:40:00',1.31),('12664','2013-07-11','10:45:00',2.75),('12664','2013-07-11','10:50:00',3.47),('12664','2013-07-11','10:55:00',4.14),('12664','2013-07-11','11:00:00',3.19),('12664','2013-07-11','11:05:00',2.15),('12664','2013-07-11','11:10:00',3.25),('12664','2013-07-11','11:15:00',1.72),('12664','2013-07-11','11:20:00',1.29),('12664','2013-07-11','11:25:00',3.16),('12664','2013-07-11','11:30:00',2.67),('12664','2013-07-11','11:35:00',2.78),('12664','2013-07-11','11:40:00',4.51),('12664','2013-07-11','11:45:00',3.45),('12664','2013-07-11','11:50:00',3.99),('12664','2013-07-11','11:55:00',3.67),('12664','2013-07-11','12:00:00',4.36),('12664','2013-07-11','12:05:00',4.39),('12664','2013-07-11','12:10:00',4.32),('12664','2013-07-11','12:15:00',4.34),('12664','2013-07-11','12:20:00',4.4),('12664','2013-07-11','12:25:00',4.42),('12664','2013-07-11','12:30:00',4.26),('12664','2013-07-11','12:35:00',4.38),('12664','2013-07-11','12:40:00',4.35),('12664','2013-07-11','12:45:00',4.36),('12664','2013-07-11','12:50:00',4.38),('12664','2013-07-11','12:55:00',4.28),('12664','2013-07-11','13:00:00',4.34),('12664','2013-07-11','13:05:00',4.33),('12664','2013-07-11','13:10:00',4.37),('12664','2013-07-11','13:15:00',4.34),('12664','2013-07-11','13:20:00',4.3),('12664','2013-07-11','13:25:00',4.31),('12664','2013-07-11','13:30:00',4.32),('12664','2013-07-11','13:35:00',4.35),('12664','2013-07-11','13:40:00',4.37),('12664','2013-07-11','13:45:00',4.36),('12664','2013-07-11','13:50:00',4.33),('12664','2013-07-11','13:55:00',4.27),('12664','2013-07-11','14:00:00',4.31),('12664','2013-07-11','14:05:00',3.53),('12664','2013-07-11','14:10:00',4.4),('12664','2013-07-11','14:15:00',4.3),('12664','2013-07-11','14:20:00',4.3),('12664','2013-07-11','14:25:00',4.29),('12664','2013-07-11','14:30:00',4.27),('12664','2013-07-11','14:35:00',3.39),('12664','2013-07-11','14:40:00',4.19),('12664','2013-07-11','14:45:00',4.11),('12664','2013-07-11','14:50:00',4.1),('12664','2013-07-11','14:55:00',3.84),('12664','2013-07-11','15:00:00',4.04),('12664','2013-07-11','15:05:00',4.01),('12664','2013-07-11','15:10:00',3.93),('12664','2013-07-11','15:15:00',3.91),('12664','2013-07-11','15:20:00',3.35),('12664','2013-07-11','15:25:00',3.86),('12664','2013-07-11','15:30:00',3.8),('12664','2013-07-11','15:35:00',3.77),('12664','2013-07-11','15:40:00',3.64),('12664','2013-07-11','15:45:00',3.69),('12664','2013-07-11','15:50:00',3.65),('12664','2013-07-11','15:55:00',3.42),('12664','2013-07-11','16:00:00',3.57),('12664','2013-07-11','16:05:00',3.44),('12664','2013-07-11','16:10:00',3.02),('12664','2013-07-11','16:15:00',3.32),('12664','2013-07-11','16:20:00',3.26),('12664','2013-07-11','16:25:00',3.19),('12664','2013-07-11','16:30:00',3.15),('12664','2013-07-11','16:35:00',2.93),('12664','2013-07-11','16:40:00',2.75),('12664','2013-07-11','16:45:00',2.95),('12664','2013-07-11','16:50:00',2.46),('12664','2013-07-11','16:55:00',2.23),('12664','2013-07-11','17:00:00',1.66),('12664','2013-07-11','17:05:00',2.7),('12664','2013-07-11','17:10:00',2.36),('12664','2013-07-11','17:15:00',1.59),('12664','2013-07-11','17:20:00',1.38),('12664','2013-07-11','17:25:00',1.94),('12664','2013-07-11','17:30:00',2.03),('12664','2013-07-11','17:40:00',2.11),('12664','2013-07-11','17:45:00',1.62),('12664','2013-07-11','17:50:00',1.75),('12664','2013-07-11','17:55:00',1.97),('12664','2013-07-11','18:00:00',1.69),('12664','2013-07-11','18:05:00',1.37),('12664','2013-07-11','18:10:00',1.08),('12664','2013-07-11','18:15:00',1.7),('12664','2013-07-11','18:20:00',1.13),('12664','2013-07-10','07:35:00',1.08),('12664','2013-07-10','07:40:00',1.19),('12664','2013-07-10','07:45:00',1.12),('12664','2013-07-10','08:20:00',1.27),('12664','2013-07-10','08:25:00',1.41),('12664','2013-07-10','08:30:00',1.68),('12664','2013-07-10','08:35:00',1.86),('12664','2013-07-10','08:40:00',2.08),('12664','2013-07-10','08:45:00',2.44),('12664','2013-07-10','08:50:00',2.36),('12664','2013-07-10','08:55:00',2.34),('12664','2013-07-10','09:00:00',2.38),('12664','2013-07-10','09:05:00',2.45),('12664','2013-07-10','09:10:00',2.52),('12664','2013-07-10','09:15:00',2.58),('12664','2013-07-10','09:20:00',2.67),('12664','2013-07-10','09:25:00',2.75),('12664','2013-07-10','09:30:00',2.79),('12664','2013-07-10','09:35:00',2.86),('12664','2013-07-10','09:40:00',2.93),('12664','2013-07-10','09:45:00',2.99),('12664','2013-07-10','09:50:00',3.01),('12664','2013-07-10','09:55:00',3.09),('12664','2013-07-10','10:00:00',3.1),('12664','2013-07-10','10:05:00',3.16),('12664','2013-07-10','10:10:00',3.23),('12664','2013-07-10','10:15:00',3.31),('12664','2013-07-10','10:20:00',3.37),('12664','2013-07-10','10:25:00',3.42),('12664','2013-07-10','10:30:00',3.47),('12664','2013-07-10','10:35:00',3.51),('12664','2013-07-10','10:40:00',3.55),('12664','2013-07-10','10:45:00',3.58),('12664','2013-07-10','10:50:00',3.6),('12664','2013-07-10','10:55:00',3.64),('12664','2013-07-10','11:00:00',3.69),('12664','2013-07-10','11:05:00',3.71),('12664','2013-07-10','11:10:00',3.74),('12664','2013-07-10','11:15:00',3.77),('12664','2013-07-10','11:20:00',3.8),('12664','2013-07-10','11:25:00',3.8),('12664','2013-07-10','11:30:00',3.82),('12664','2013-07-10','11:35:00',3.85),('12664','2013-07-10','11:40:00',3.9),('12664','2013-07-10','11:45:00',3.88),('12664','2013-07-10','11:50:00',3.96),('12664','2013-07-10','11:55:00',3.86),('12664','2013-07-10','12:00:00',3.99),('12664','2013-07-10','12:05:00',4.1),('12664','2013-07-10','12:10:00',4.1),('12664','2013-07-10','12:15:00',4.13),('12664','2013-07-10','12:20:00',4.15),('12664','2013-07-10','12:25:00',4.21),('12664','2013-07-10','12:30:00',4.17),('12664','2013-07-10','12:35:00',4.24),('12664','2013-07-10','12:40:00',4.22),('12664','2013-07-10','12:45:00',4.2),('12664','2013-07-10','12:50:00',4.22),('12664','2013-07-10','12:55:00',4.23),('12664','2013-07-10','13:00:00',4.25),('12664','2013-07-10','13:05:00',4.26),('12664','2013-07-10','13:10:00',4.24),('12664','2013-07-10','13:15:00',4.27),('12664','2013-07-10','13:20:00',4.31),('12664','2013-07-10','13:25:00',4.32),('12664','2013-07-10','13:30:00',4.32),('12664','2013-07-10','13:35:00',4.32),('12664','2013-07-10','13:40:00',4.33),('12664','2013-07-10','13:45:00',4.3),('12664','2013-07-10','13:50:00',4.32),('12664','2013-07-10','13:55:00',4.31),('12664','2013-07-10','14:00:00',4.3),('12664','2013-07-10','14:05:00',4.27),('12664','2013-07-10','14:10:00',4.25),('12664','2013-07-10','14:15:00',4.23),('12664','2013-07-10','14:20:00',4.22),('12664','2013-07-10','14:25:00',4.2),('12664','2013-07-10','14:30:00',4.16),('12664','2013-07-10','14:35:00',4.13),('12664','2013-07-10','14:40:00',4.1),('12664','2013-07-10','14:45:00',4.08),('12664','2013-07-10','14:50:00',4.08),('12664','2013-07-10','14:55:00',4.07),('12664','2013-07-10','15:00:00',4.04),('12664','2013-07-10','15:05:00',4),('12664','2013-07-10','15:10:00',3.94),('12664','2013-07-10','15:15:00',3.91),('12664','2013-07-10','15:20:00',3.88),('12664','2013-07-10','15:25:00',3.81),('12664','2013-07-10','15:30:00',3.77),('12664','2013-07-10','15:35:00',3.73),('12664','2013-07-10','15:40:00',3.69),('12664','2013-07-10','15:45:00',3.63),('12664','2013-07-10','15:50:00',3.57),('12664','2013-07-10','15:55:00',3.52),('12664','2013-07-10','16:00:00',3.45),('12664','2013-07-10','16:05:00',3.39),('12664','2013-07-10','16:10:00',3.33),('12664','2013-07-10','16:15:00',3.23),('12664','2013-07-10','16:20:00',3.18),('12664','2013-07-10','16:25:00',3.12),('12664','2013-07-10','16:30:00',3.06),('12664','2013-07-10','16:35:00',3.01),('12664','2013-07-10','16:40:00',2.93),('12664','2013-07-10','16:45:00',2.89),('12664','2013-07-10','16:50:00',2.88),('12664','2013-07-10','16:55:00',2.94),('12664','2013-07-10','17:00:00',3.08),('12664','2013-07-10','17:05:00',3.17),('12664','2013-07-10','17:10:00',3.15),('12664','2013-07-10','17:15:00',3),('12664','2013-07-10','17:20:00',2.69),('12664','2013-07-10','17:25:00',2.37),('12664','2013-07-10','17:30:00',2.28),('12664','2013-07-10','17:35:00',2.52),('12664','2013-07-10','17:40:00',2.03),('12664','2013-07-10','17:45:00',1.66),('12664','2013-07-10','17:50:00',2.06),('12664','2013-07-10','17:55:00',1.17),('12664','2014-05-02','07:35:00',1.19),('12664','2014-05-02','07:40:00',1.15),('12664','2014-05-02','07:45:00',1.26),('12664','2014-05-02','07:50:00',1.32),('12664','2014-05-02','08:25:00',1.29),('12664','2014-05-02','08:30:00',1.74),('12664','2014-05-02','08:35:00',1.14),('12664','2014-05-02','09:10:00',1.23),('12664','2014-05-02','09:15:00',1.8),('12664','2014-05-02','09:20:00',1.68),('12664','2014-05-02','09:25:00',1.43),('12664','2014-05-02','09:30:00',1.69),('12664','2014-05-02','09:35:00',1.69),('12664','2014-05-02','09:40:00',1.66),('12664','2014-05-02','09:45:00',1.28),('12664','2014-05-02','09:50:00',1.11),('12664','2014-05-02','12:35:00',1.18),('12664','2014-05-02','12:40:00',1.33),('12664','2014-05-02','12:45:00',1.79),('12664','2014-05-02','12:50:00',2.19),('12664','2014-05-02','12:55:00',2.3),('12664','2014-05-02','13:00:00',2.05),('12664','2014-05-02','13:05:00',1.95),('12664','2014-05-02','13:10:00',2.38),('12664','2014-05-02','13:15:00',2.54),('12664','2014-05-02','13:20:00',2.62),('12664','2014-05-02','13:25:00',1.79),('12664','2014-05-02','13:30:00',3.4),('12664','2014-05-02','13:35:00',2.9),('12664','2014-05-02','13:40:00',2.04),('12664','2014-05-02','13:45:00',1.96),('12664','2014-05-02','13:50:00',2.28),('12664','2014-05-02','13:55:00',1.75),('12664','2014-05-02','14:00:00',1.62),('12664','2014-05-02','14:05:00',2.19),('12664','2014-05-02','14:10:00',2.62),('12664','2014-05-02','14:15:00',2.17),('12664','2014-05-02','14:20:00',2.94),('12664','2014-05-02','14:25:00',2.67),('12664','2014-05-02','14:30:00',1.48),('12664','2014-05-02','14:35:00',1.29),('12664','2014-05-02','14:40:00',1.15),('12664','2014-05-02','15:10:00',1.01),('12664','2014-05-02','15:15:00',1.88),('12664','2014-05-02','15:20:00',1.63),('12664','2014-05-02','15:25:00',3),('12664','2014-05-02','15:30:00',1.59),('12664','2014-05-02','15:35:00',1.27),('12664','2014-05-02','15:45:00',1.15),('12664','2014-05-02','15:50:00',1.47),('12664','2014-05-02','16:05:00',1.03),('12664','2014-05-02','16:10:00',1.89),('12664','2014-05-02','16:15:00',1.5),('12664','2014-05-02','16:20:00',1.04),('12664','2014-05-02','16:25:00',1.44),('12664','2014-05-02','16:30:00',1.24),('12664','2014-05-02','16:35:00',1.18),('12664','2014-05-02','16:40:00',2.41),('12664','2014-05-02','16:45:00',2.26),('12664','2014-05-02','16:50:00',1.46),('12664','2014-05-02','16:55:00',1.1),('12664','2014-05-02','17:00:00',1.08),('12664','2014-05-02','17:10:00',1.08),('12664','2014-04-05','08:35:00',1.08),('12664','2014-04-05','08:40:00',1.06),('12664','2014-04-05','08:45:00',1.07),('12664','2014-04-05','08:50:00',1.08),('12664','2014-04-05','09:25:00',1.23),('12664','2014-04-05','09:30:00',1.56),('12664','2014-04-05','09:35:00',1.73),('12664','2014-04-05','09:40:00',1.43),('12664','2014-04-05','09:45:00',1.65),('12664','2014-04-05','09:50:00',1.86),('12664','2014-04-05','09:55:00',1.79),('12664','2014-04-05','10:00:00',2.58),('12664','2014-04-05','10:05:00',2.49),('12664','2014-04-05','10:10:00',2.25),('12664','2014-04-05','10:15:00',2.14),('12664','2014-04-05','10:20:00',2.03),('12664','2014-04-05','10:25:00',2.19),('12664','2014-04-05','10:30:00',3.91),('12664','2014-04-05','10:35:00',3.73),('12664','2014-04-05','10:40:00',3.48),('12664','2014-04-05','10:45:00',2.85),('12664','2014-04-05','10:50:00',2.35),('12664','2014-04-05','10:55:00',3.45),('12664','2014-04-05','11:00:00',3.84),('12664','2014-04-05','11:05:00',3.61),('12664','2014-04-05','11:10:00',3.57),('12664','2014-04-05','11:15:00',3.39),('12664','2014-04-05','11:20:00',3.09),('12664','2014-04-05','11:25:00',3.1),('12664','2014-04-05','11:30:00',3),('12664','2014-04-05','11:35:00',3.95),('12664','2014-04-05','11:40:00',4.3),('12664','2014-04-05','11:45:00',4.32),('12664','2014-04-05','11:50:00',4.1),('12664','2014-04-05','11:55:00',3.84),('12664','2014-04-05','12:00:00',3.37),('12664','2014-04-05','12:05:00',2.97),('12664','2014-04-05','12:10:00',2.48),('12664','2014-04-05','12:15:00',2.62),('12664','2014-04-05','12:20:00',2.5),('12664','2014-04-05','12:25:00',2.23),('12664','2014-04-05','12:30:00',2.36),('12664','2014-04-05','12:35:00',2.07),('12664','2014-04-05','12:40:00',2.09),('12664','2014-04-05','12:45:00',2.11),('12664','2014-04-05','12:50:00',2.41),('12664','2014-04-05','12:55:00',2.31),('12664','2014-04-05','13:00:00',2.5),('12664','2014-04-05','13:05:00',2.62),('12664','2014-04-05','13:10:00',2.83),('12664','2014-04-05','13:15:00',2.95),('12664','2014-04-05','13:20:00',3.28),('12664','2014-04-05','13:25:00',2.46),('12664','2014-04-05','13:30:00',3.7),('12664','2014-04-05','13:35:00',2.54),('12664','2014-04-05','13:40:00',1.44),('12664','2014-04-05','13:45:00',2.57),('12664','2014-04-05','13:50:00',4.15),('12664','2014-04-05','13:55:00',4.15),('12664','2014-04-05','14:00:00',4.56),('12664','2014-04-05','14:05:00',1.67),('12664','2014-04-05','14:10:00',1.46),('12664','2014-04-05','14:15:00',3.98),('12664','2014-04-05','15:00:00',2.3),('12664','2014-04-05','15:05:00',2.92),('12664','2014-04-05','15:10:00',1.84),('12664','2014-04-05','15:15:00',4.22),('12664','2014-04-05','15:20:00',2.94),('12664','2014-04-05','15:25:00',2.11),('12664','2014-04-05','15:30:00',3.85),('12664','2014-04-05','15:35:00',3.51),('12664','2014-04-05','15:40:00',2.85),('12664','2014-04-05','15:45:00',1.42),('12664','2014-04-05','15:50:00',1.07),('12664','2014-04-05','16:00:00',1.02),('12664','2014-04-05','16:05:00',1.2),('12664','2014-04-05','16:10:00',1.28),('12664','2014-04-05','16:15:00',1.26),('12664','2014-04-05','16:25:00',1.07),('12664','2014-04-05','16:30:00',2.31),('12664','2014-04-05','16:35:00',3.2),('12664','2014-04-05','16:40:00',1.37),('12664','2014-04-05','16:50:00',1.95),('12664','2014-04-05','16:55:00',2.55),('12664','2014-04-05','17:00:00',2.64),('12664','2014-04-05','17:05:00',2.41),('12664','2014-04-05','17:10:00',1.93),('12664','2014-04-05','17:15:00',2.08),('12664','2014-04-05','17:20:00',2.01),('12664','2014-04-05','17:25:00',1.88),('12664','2014-04-05','17:30:00',1.4),('12664','2014-04-05','17:35:00',1.1),('12664','2013-07-09','07:40:00',1.06),('12664','2013-07-09','07:45:00',1.21),('12664','2013-07-09','07:50:00',1.32),('12664','2013-07-09','07:55:00',1.41),('12664','2013-07-09','08:00:00',1.47),('12664','2013-07-09','08:05:00',1.4),('12664','2013-07-09','08:10:00',1.51),('12664','2013-07-09','08:15:00',1.57),('12664','2013-07-09','08:20:00',1.65),('12664','2013-07-09','08:25:00',1.74),('12664','2013-07-09','08:30:00',1.73),('12664','2013-07-09','08:35:00',1.9),('12664','2013-07-09','08:40:00',1.97),('12664','2013-07-09','08:45:00',2.06),('12664','2013-07-09','08:50:00',2.14),('12664','2013-07-09','08:55:00',2.23),('12664','2013-07-09','09:00:00',2.3),('12664','2013-07-09','09:05:00',2.36),('12664','2013-07-09','09:10:00',2.42),('12664','2013-07-09','09:15:00',2.51),('12664','2013-07-09','09:20:00',2.61),('12664','2013-07-09','09:25:00',2.68),('12664','2013-07-09','09:30:00',2.74),('12664','2013-07-09','09:35:00',2.81),('12664','2013-07-09','09:40:00',2.87),('12664','2013-07-09','09:45:00',2.93),('12664','2013-07-09','09:50:00',3),('12664','2013-07-09','09:55:00',3.06),('12664','2013-07-09','10:00:00',3.1),('12664','2013-07-09','10:05:00',3.19),('12664','2013-07-09','10:10:00',3.23),('12664','2013-07-09','10:15:00',3.26),('12664','2013-07-09','10:20:00',3.31),('12664','2013-07-09','10:25:00',3.36),('12664','2013-07-09','10:30:00',3.42),('12664','2013-07-09','10:35:00',3.48),('12664','2013-07-09','10:40:00',3.52),('12664','2013-07-09','10:45:00',3.56),('12664','2013-07-09','10:50:00',3.61),('12664','2013-07-09','10:55:00',3.65),('12664','2013-07-09','11:00:00',3.7),('12664','2013-07-09','11:05:00',3.71),('12664','2013-07-09','11:10:00',3.76),('12664','2013-07-09','11:15:00',3.77),('12664','2013-07-09','11:20:00',3.84),('12664','2013-07-09','11:25:00',3.93),('12664','2013-07-09','11:30:00',4.01),('12664','2013-07-09','11:35:00',3.97),('12664','2013-07-09','11:40:00',3.98),('12664','2013-07-09','11:45:00',3.74),('12664','2013-07-09','11:50:00',3.9),('12664','2013-07-09','11:55:00',4),('12664','2013-07-09','12:00:00',4.02),('12664','2013-07-09','12:05:00',4.04),('12664','2013-07-09','12:10:00',4.12),('12664','2013-07-09','12:15:00',3.98),('12664','2013-07-09','12:20:00',3.31),('12664','2013-07-09','12:25:00',3),('12664','2013-07-09','12:30:00',3.89),('12664','2013-07-09','12:35:00',4.07),('12664','2013-07-09','12:40:00',4.11),('12664','2013-07-09','12:45:00',4.24),('12664','2013-07-09','12:50:00',4.11),('12664','2013-07-09','12:55:00',3.04),('12664','2013-07-09','13:00:00',2.17),('12664','2013-07-09','13:05:00',4.54),('12664','2013-07-09','13:10:00',4.58),('12664','2013-07-09','13:15:00',4.44),('12664','2013-07-09','13:20:00',4.32),('12664','2013-07-09','13:25:00',4.33),('12664','2013-07-09','13:30:00',4.34),('12664','2013-07-09','13:35:00',4.45),('12664','2013-07-09','13:40:00',4.28),('12664','2013-07-09','13:45:00',4.19),('12664','2013-07-09','13:50:00',3.77),('12664','2013-07-09','13:55:00',4.3),('12664','2013-07-09','14:00:00',4.23),('12664','2013-07-09','14:05:00',3.77),('12664','2013-07-09','14:10:00',4.13),('12664','2013-07-09','14:15:00',4.52),('12664','2013-07-09','14:20:00',4.24),('12664','2013-07-09','14:25:00',2.57),('12664','2013-07-09','14:30:00',1.19),('12664','2013-07-08','07:50:00',1.25),('12664','2013-07-08','07:55:00',1.22),('12664','2013-07-08','08:00:00',1.37),('12664','2013-07-08','08:05:00',1.48),('12664','2013-07-08','08:10:00',1.56),('12664','2013-07-08','08:15:00',1.62),('12664','2013-07-08','08:20:00',1.68),('12664','2013-07-08','08:25:00',1.74),('12664','2013-07-08','08:30:00',1.81),('12664','2013-07-08','08:35:00',1.88),('12664','2013-07-08','08:40:00',1.94),('12664','2013-07-08','08:45:00',2.02),('12664','2013-07-08','08:50:00',2.09),('12664','2013-07-08','08:55:00',2.15),('12664','2013-07-08','09:00:00',2.23),('12664','2013-07-08','09:05:00',2.33),('12664','2013-07-08','09:10:00',2.4),('12664','2013-07-08','09:15:00',2.51),('12664','2013-07-08','09:20:00',2.59),('12664','2013-07-08','09:25:00',2.66),('12664','2013-07-08','09:30:00',2.71),('12664','2013-07-08','09:35:00',2.78),('12664','2013-07-08','09:40:00',2.84),('12664','2013-07-08','09:45:00',2.89),('12664','2013-07-08','09:50:00',2.95),('12664','2013-07-08','09:55:00',3.02),('12664','2013-07-08','10:00:00',3.1),('12664','2013-07-08','10:05:00',3.17),('12664','2013-07-08','10:10:00',3.23),('12664','2013-07-08','10:15:00',3.26),('12664','2013-07-08','10:20:00',3.32),('12664','2013-07-08','10:25:00',3.38),('12664','2013-07-08','10:30:00',3.44),('12664','2013-07-08','10:35:00',3.09),('12664','2013-07-08','10:40:00',3.53),('12664','2013-07-08','10:45:00',3.59),('12664','2013-07-08','10:50:00',3.61),('12664','2013-07-08','10:55:00',3.63),('12664','2013-07-08','11:00:00',3.67),('12664','2013-07-08','11:05:00',3.72),('12664','2013-07-08','11:10:00',3.78),('12664','2013-07-08','11:15:00',3.83),('12664','2013-07-08','11:20:00',3.85),('12664','2013-07-08','11:25:00',3.72),('12664','2013-07-08','11:30:00',3.77),('12664','2013-07-08','11:35:00',3.64),('12664','2013-07-08','11:40:00',3.54),('12664','2013-07-08','11:45:00',3.99),('12664','2013-07-08','11:50:00',4.11),('12664','2013-07-08','11:55:00',4.08),('12664','2013-07-08','12:00:00',3.97),('12664','2013-07-08','12:05:00',3.2),('12664','2013-07-08','12:10:00',4.01),('12664','2013-07-08','12:15:00',3.57),('12664','2013-07-08','12:20:00',4.34),('12664','2013-07-08','12:25:00',3.92),('12664','2013-07-08','12:30:00',3.91),('12664','2013-07-08','12:35:00',4.37),('12664','2013-07-08','12:40:00',4.3),('12664','2013-07-08','12:45:00',4.33),('12664','2013-07-08','12:50:00',4.14),('12664','2013-07-08','12:55:00',3.75),('12664','2013-07-08','13:00:00',2.62),('12664','2013-07-08','13:05:00',2.37),('12664','2013-07-08','13:10:00',1.2),('12664','2013-07-08','13:15:00',1.99),('12664','2013-07-08','13:20:00',1.6),('12664','2013-07-08','14:05:00',1.02),('12664','2013-07-08','14:10:00',1.3),('12664','2013-07-08','14:15:00',1.56),('12664','2013-07-08','14:20:00',1.42),('12664','2013-07-08','14:25:00',1.26),('12664','2013-07-08','14:30:00',1.07),('12664','2013-07-08','14:35:00',1.32),('12664','2013-07-08','14:40:00',1.85),('12664','2013-07-08','14:45:00',2.75),('12664','2013-07-08','14:50:00',2.23),('12664','2013-07-08','14:55:00',1.55),('12664','2013-07-08','15:00:00',1.48),('12664','2013-07-08','15:05:00',1.58),('12664','2013-07-08','15:10:00',1.53),('12664','2013-07-08','15:15:00',1.31),('12664','2013-07-08','15:20:00',1),('12664','2013-07-07','07:40:00',1.01),('12664','2013-07-07','07:45:00',1.1),('12664','2013-07-07','07:50:00',1.19),('12664','2013-07-07','07:55:00',1.28),('12664','2013-07-07','08:00:00',1.37),('12664','2013-07-07','08:05:00',1.47),('12664','2013-07-07','08:10:00',1.57),('12664','2013-07-07','08:15:00',1.66),('12664','2013-07-07','08:20:00',1.75),('12664','2013-07-07','08:25:00',1.83),('12664','2013-07-07','08:30:00',1.93),('12664','2013-07-07','08:35:00',1.55),('12664','2013-07-07','08:40:00',1.17),('12664','2013-07-07','08:45:00',2.18),('12664','2013-07-07','08:50:00',2.31),('12664','2013-07-07','08:55:00',2.44),('12664','2013-07-07','09:00:00',2.35),('12664','2013-07-07','09:05:00',1.81),('12664','2013-07-07','09:10:00',2.37),('12664','2013-07-07','09:15:00',1.94),('12664','2013-07-07','09:20:00',1.61),('12664','2013-07-07','09:25:00',1.32),('12664','2013-07-07','09:30:00',2.05),('12664','2013-07-07','09:35:00',2.86),('12664','2013-07-07','09:40:00',2.72),('12664','2013-07-07','09:45:00',2.85),('12664','2013-07-07','09:50:00',3.28),('12664','2013-07-07','09:55:00',3.3),('12664','2013-07-07','10:00:00',3.29),('12664','2013-07-07','10:05:00',3.27),('12664','2013-07-07','10:10:00',3.22),('12664','2013-07-07','10:15:00',2.96),('12664','2013-07-07','10:20:00',3.12),('12664','2013-07-07','10:25:00',3.65),('12664','2013-07-07','10:30:00',3.44),('12664','2013-07-07','10:35:00',3.04),('12664','2013-07-07','10:40:00',3.59),('12664','2013-07-07','10:45:00',3.51),('12664','2013-07-07','10:50:00',3.77),('12664','2013-07-07','10:55:00',3.75),('12664','2013-07-07','11:00:00',3.76),('12664','2013-07-07','11:05:00',3.79),('12664','2013-07-07','11:10:00',3.86),('12664','2013-07-07','11:15:00',3.94),('12664','2013-07-07','11:20:00',3.68),('12664','2013-07-07','11:25:00',3.2),('12664','2013-07-07','11:30:00',3.7),('12664','2013-07-07','11:35:00',3.75),('12664','2013-07-07','11:40:00',3.64),('12664','2013-07-07','11:45:00',3.73),('12664','2013-07-07','11:50:00',3.85),('12664','2013-07-07','11:55:00',3.93),('12664','2013-07-07','12:00:00',2.93),('12664','2013-07-07','12:05:00',3.71),('12664','2013-07-07','12:10:00',3.65),('12664','2013-07-07','12:15:00',3.29),('12664','2013-07-07','12:20:00',3.44),('12664','2013-07-07','12:25:00',3.98),('12664','2013-07-07','12:30:00',4.04),('12664','2013-07-07','12:35:00',4.21),('12664','2013-07-07','12:40:00',4.12),('12664','2013-07-07','12:45:00',4.09),('12664','2013-07-07','12:50:00',4.05),('12664','2013-07-07','12:55:00',4.24),('12664','2013-07-07','13:00:00',4.32),('12664','2013-07-07','13:05:00',4.22),('12664','2013-07-07','13:10:00',4.22),('12664','2013-07-07','13:15:00',4.28),('12664','2013-07-07','13:20:00',4.26),('12664','2013-07-07','13:25:00',4.15),('12664','2013-07-07','13:30:00',4.36),('12664','2013-07-07','13:35:00',4.53),('12664','2013-07-07','13:40:00',4.05),('12664','2013-07-07','13:45:00',1.4),('12664','2013-07-07','13:50:00',1.46),('12664','2013-07-07','13:55:00',1.28),('12664','2013-07-07','14:00:00',1.02),('12664','2013-07-07','14:15:00',1.17),('12664','2013-07-07','14:20:00',1.55),('12664','2013-07-07','14:25:00',2.34),('12664','2013-07-07','14:30:00',3.14),('12664','2013-07-07','14:35:00',1.65),('12664','2013-07-07','14:40:00',1.06),('12664','2013-07-07','14:45:00',1.05),('12664','2013-07-07','14:50:00',1.19),('12664','2013-07-07','14:55:00',1.23),('12664','2013-07-07','15:00:00',1.38),('12664','2013-07-07','15:05:00',1.87),('12664','2013-07-07','15:10:00',2.88),('12664','2013-07-07','15:15:00',1.62),('12664','2013-07-07','15:20:00',1.08),('12664','2013-07-07','17:05:00',1.05),('12664','2013-07-07','17:10:00',1.13),('12664','2013-07-07','17:15:00',1.21),('12664','2013-07-07','17:20:00',1.28),('12664','2013-07-07','17:25:00',1.29),('12664','2013-07-07','17:30:00',1.27),('12664','2013-07-07','17:35:00',1.32),('12664','2013-07-07','17:40:00',1.41),('12664','2013-07-07','17:45:00',1.58),('12664','2013-07-07','17:50:00',1.48),('12664','2013-07-07','17:55:00',1.44),('12664','2013-07-07','18:00:00',1.39),('12664','2013-07-07','18:05:00',1.23),('12664','2013-07-06','07:45:00',1.04),('12664','2013-07-06','07:50:00',1.13),('12664','2013-07-06','07:55:00',1.22),('12664','2013-07-06','08:00:00',1.31),('12664','2013-07-06','08:05:00',1.4),('12664','2013-07-06','08:10:00',1.48),('12664','2013-07-06','08:15:00',1.56),('12664','2013-07-06','08:20:00',1.64),('12664','2013-07-06','08:25:00',1.72),('12664','2013-07-06','08:30:00',1.8),('12664','2013-07-06','08:35:00',1.9),('12664','2013-07-06','08:40:00',1.98),('12664','2013-07-06','08:45:00',2.06),('12664','2013-07-06','08:50:00',2.15),('12664','2013-07-06','08:55:00',2.23),('12664','2013-07-06','09:00:00',2.32),('12664','2013-07-06','09:05:00',2.4),('12664','2013-07-06','09:10:00',2.47),('12664','2013-07-06','09:15:00',2.54),('12664','2013-07-06','09:20:00',2.6),('12664','2013-07-06','09:25:00',2.68),('12664','2013-07-06','09:30:00',2.75),('12664','2013-07-06','09:35:00',2.82),('12664','2013-07-06','09:40:00',2.88),('12664','2013-07-06','09:45:00',2.94),('12664','2013-07-06','09:50:00',3),('12664','2013-07-06','09:55:00',3.04),('12664','2013-07-06','10:00:00',3.09),('12664','2013-07-06','10:05:00',3.17),('12664','2013-07-06','10:10:00',3.23),('12664','2013-07-06','10:15:00',3.27),('12664','2013-07-06','10:20:00',3.33),('12664','2013-07-06','10:25:00',3.39),('12664','2013-07-06','10:30:00',3.44),('12664','2013-07-06','10:35:00',3.47),('12664','2013-07-06','10:40:00',3.55),('12664','2013-07-06','10:45:00',3.59),('12664','2013-07-06','10:50:00',3.63),('12664','2013-07-06','10:55:00',3.66),('12664','2013-07-06','11:00:00',3.71),('12664','2013-07-06','11:05:00',3.76),('12664','2013-07-06','11:10:00',3.8),('12664','2013-07-06','11:15:00',3.82),('12664','2013-07-06','11:20:00',3.87),('12664','2013-07-06','11:25:00',3.9),('12664','2013-07-06','11:30:00',3.89),('12664','2013-07-06','11:35:00',3.93),('12664','2013-07-06','11:40:00',3.97),('12664','2013-07-06','11:45:00',4.01),('12664','2013-07-06','11:50:00',3.99),('12664','2013-07-06','11:55:00',3.99),('12664','2013-07-06','12:00:00',4.02),('12664','2013-07-06','12:05:00',4.06),('12664','2013-07-06','12:10:00',4.08),('12664','2013-07-06','12:15:00',3.3),('12664','2013-07-06','12:20:00',4.12),('12664','2013-07-06','12:25:00',4.19),('12664','2013-07-06','12:30:00',4.22),('12664','2013-07-06','12:35:00',4.23),('12664','2013-07-06','12:40:00',4.22),('12664','2013-07-06','12:45:00',4.23),('12664','2013-07-06','12:50:00',4.22),('12664','2013-07-06','12:55:00',4.19),('12664','2013-07-06','13:00:00',4.23),('12664','2013-07-06','13:05:00',4.28),('12664','2013-07-06','13:10:00',4.2),('12664','2013-07-06','13:15:00',4.21),('12664','2013-07-06','13:20:00',3.19),('12664','2013-07-06','13:25:00',4.24),('12664','2013-07-06','13:30:00',4.14),('12664','2013-07-06','13:35:00',3.69),('12664','2013-07-06','13:40:00',4.07),('12664','2013-07-06','13:45:00',4.27),('12664','2013-07-06','13:50:00',4.21),('12664','2013-07-06','13:55:00',4.16),('12664','2013-07-06','14:00:00',4.16),('12664','2013-07-06','14:05:00',4.12),('12664','2013-07-06','14:10:00',4.08),('12664','2013-07-06','14:15:00',4.08),('12664','2013-07-06','14:20:00',4.08),('12664','2013-07-06','14:25:00',4.05),('12664','2013-07-06','14:30:00',4.06),('12664','2013-07-06','14:35:00',3.99),('12664','2013-07-06','14:40:00',3.96),('12664','2013-07-06','14:45:00',4.06),('12664','2013-07-06','14:50:00',2.68),('12664','2013-07-06','14:55:00',1.38),('12664','2013-07-06','15:00:00',1.51),('12664','2013-07-06','15:05:00',2.45),('12664','2013-07-06','15:10:00',1.01),('12664','2013-07-06','15:20:00',1.23),('12664','2013-07-06','15:25:00',1.03),('12664','2013-07-06','16:30:00',1.06),('12664','2013-07-06','16:35:00',1.22),('12664','2013-07-06','16:40:00',1.34),('12664','2013-07-06','16:45:00',2.06),('12664','2013-07-06','16:50:00',3.21),('12664','2013-07-06','16:55:00',1.95),('12664','2013-07-06','17:00:00',2.5),('12664','2013-07-06','17:05:00',2.64),('12664','2013-07-06','17:10:00',2.77),('12664','2013-07-06','17:15:00',2.11),('12664','2013-07-06','17:20:00',1.21),('12664','2013-07-05','07:45:00',1.07),('12664','2013-07-05','07:50:00',1.15),('12664','2013-07-05','07:55:00',1.24),('12664','2013-07-05','08:00:00',1.33),('12664','2013-07-05','08:05:00',1.41),('12664','2013-07-05','08:10:00',1.5),('12664','2013-07-05','08:15:00',1.6),('12664','2013-07-05','08:20:00',1.67),('12664','2013-07-05','08:25:00',1.76),('12664','2013-07-05','08:30:00',1.84),('12664','2013-07-05','08:35:00',1.91),('12664','2013-07-05','08:40:00',2),('12664','2013-07-05','08:45:00',2.08),('12664','2013-07-05','08:50:00',2.17),('12664','2013-07-05','08:55:00',2.25),('12664','2013-07-05','09:00:00',2.34),('12664','2013-07-05','09:05:00',2.41),('12664','2013-07-05','09:10:00',2.49),('12664','2013-07-05','09:15:00',2.55),('12664','2013-07-05','09:20:00',2.61),('12664','2013-07-05','09:25:00',2.68),('12664','2013-07-05','09:30:00',2.74),('12664','2013-07-05','09:35:00',2.8),('12664','2013-07-05','09:40:00',2.87),('12664','2013-07-05','09:45:00',2.93),('12664','2013-07-05','09:50:00',2.99),('12664','2013-07-05','09:55:00',3.03),('12664','2013-07-05','10:00:00',3.07),('12664','2013-07-05','10:05:00',3.13),('12664','2013-07-05','10:10:00',3.21),('12664','2013-07-05','10:15:00',3.26),('12664','2013-07-05','10:20:00',3.3),('12664','2013-07-05','10:25:00',3.36),('12664','2013-07-05','10:30:00',3.43),('12664','2013-07-05','10:35:00',3.48),('12664','2013-07-05','10:40:00',3.53),('12664','2013-07-05','10:45:00',3.57),('12664','2013-07-05','10:50:00',3.61),('12664','2013-07-05','10:55:00',3.66),('12664','2013-07-05','11:00:00',3.7),('12664','2013-07-05','11:05:00',3.73),('12664','2013-07-05','11:10:00',3.79),('12664','2013-07-05','11:15:00',3.82),('12664','2013-07-05','11:20:00',3.86),('12664','2013-07-05','11:25:00',3.89),('12664','2013-07-05','11:30:00',3.9),('12664','2013-07-05','11:35:00',3.9),('12664','2013-07-05','11:40:00',3.94),('12664','2013-07-05','11:45:00',4),('12664','2013-07-05','11:50:00',4.02),('12664','2013-07-05','11:55:00',4.05),('12664','2013-07-05','12:00:00',4.07),('12664','2013-07-05','12:05:00',4.11),('12664','2013-07-05','12:10:00',4.13),('12664','2013-07-05','12:15:00',4.17),('12664','2013-07-05','12:20:00',4.21),('12664','2013-07-05','12:25:00',3.58),('12664','2013-07-05','12:30:00',3.54),('12664','2013-07-05','12:35:00',3.54),('12664','2013-07-05','12:40:00',4.54),('12664','2013-07-05','12:45:00',3.38),('12664','2013-07-05','12:50:00',2.02),('12664','2013-07-05','12:55:00',2.27),('12664','2013-07-05','13:00:00',2.42),('12664','2013-07-05','13:05:00',4.3),('12664','2013-07-05','13:10:00',3.68),('12664','2013-07-05','13:15:00',4.43),('12664','2013-07-05','13:20:00',3.51),('12664','2013-07-05','13:25:00',4.46),('12664','2013-07-05','13:30:00',4.6),('12664','2013-07-05','13:35:00',3.89),('12664','2013-07-05','13:40:00',3.96),('12664','2013-07-05','13:45:00',4.29),('12664','2013-07-05','13:50:00',4.18),('12664','2013-07-05','13:55:00',4.18),('12664','2013-07-05','14:00:00',4.28),('12664','2013-07-05','14:05:00',4.3),('12664','2013-07-05','14:10:00',2.87),('12664','2013-07-05','14:15:00',3.19),('12664','2013-07-05','14:20:00',4.04),('12664','2013-07-05','14:25:00',4.24),('12664','2013-07-05','14:30:00',4.2),('12664','2013-07-05','14:35:00',4.1),('12664','2013-07-05','14:40:00',4.12),('12664','2013-07-05','14:45:00',3.97),('12664','2013-07-05','14:50:00',3.13),('12664','2013-07-05','14:55:00',4.07),('12664','2013-07-05','15:00:00',4.04),('12664','2013-07-05','15:05:00',4),('12664','2013-07-05','15:10:00',3.94),('12664','2013-07-05','15:15:00',2.67),('12664','2013-07-05','15:20:00',3.33),('12664','2013-07-05','15:25:00',1.98),('12664','2013-07-05','15:30:00',2.61),('12664','2013-07-05','15:40:00',3.22),('12664','2013-07-05','15:45:00',2.71),('12664','2013-07-05','15:50:00',3.59),('12664','2013-07-05','15:55:00',3.48),('12664','2013-07-05','16:00:00',3.42),('12664','2013-07-05','16:05:00',3.36),('12664','2013-07-05','16:10:00',2.99),('12664','2013-07-05','16:15:00',2.66),('12664','2013-07-05','16:20:00',3.17),('12664','2013-07-05','16:25:00',3.16),('12664','2013-07-05','16:30:00',3.09),('12664','2013-07-05','16:35:00',2.96),('12664','2013-07-05','16:40:00',2.87),('12664','2013-07-05','16:45:00',2.78),('12664','2013-07-05','16:50:00',2.75),('12664','2013-07-05','16:55:00',2.21),('12664','2013-07-05','17:00:00',2.2),('12664','2013-07-05','17:05:00',2.58),('12664','2013-07-05','17:10:00',2.45),('12664','2013-07-05','17:15:00',1.54),('12664','2013-07-05','17:20:00',2.03),('12664','2013-07-05','17:25:00',2.17),('12664','2013-07-05','17:30:00',2.06),('12664','2013-07-05','17:35:00',1.88),('12664','2013-07-05','17:40:00',1.97),('12664','2013-07-05','17:45:00',1.86),('12664','2013-07-05','17:50:00',1.72),('12664','2013-07-05','17:55:00',1.7),('12664','2013-07-05','18:00:00',1.7),('12664','2013-07-05','18:05:00',1.7),('12664','2013-07-05','18:10:00',1.63),('12664','2013-07-05','18:15:00',1.53),('12664','2013-07-05','18:20:00',1.44),('12664','2013-07-05','18:25:00',1.29),('12664','2013-07-05','18:30:00',1.14),('12664','2013-07-05','18:35:00',1.01),('12664','2013-07-04','11:00:00',1.03),('12664','2013-07-04','11:05:00',1.17),('12664','2013-07-04','11:10:00',1.16),('12664','2013-07-04','11:15:00',1.15),('12664','2013-07-04','11:20:00',1.2),('12664','2013-07-04','11:25:00',1.24),('12664','2013-07-04','11:30:00',1.32),('12664','2013-07-04','11:35:00',1.44),('12664','2013-07-04','11:40:00',1.61),('12664','2013-07-04','11:45:00',1.73),('12664','2013-07-04','11:50:00',1.51),('12664','2013-07-04','11:55:00',1.87),('12664','2013-07-04','12:00:00',2.21),('12664','2013-07-04','12:05:00',2.46),('12664','2013-07-04','12:10:00',2.35),('12664','2013-07-04','12:15:00',1.79),('12664','2013-07-04','12:20:00',1.86),('12664','2013-07-04','12:25:00',1.89),('12664','2013-07-04','12:30:00',1.48),('12664','2013-07-04','12:35:00',1.37),('12664','2013-07-04','12:40:00',1.44),('12664','2013-07-04','12:45:00',1.21),('12664','2013-07-04','12:50:00',1.2),('12664','2013-07-04','12:55:00',1.36),('12664','2013-07-04','13:00:00',1.32),('12664','2013-07-04','13:05:00',1.54),('12664','2013-07-04','13:10:00',1.85),('12664','2013-07-04','13:15:00',1.83),('12664','2013-07-04','13:20:00',2.14),('12664','2013-07-04','13:25:00',2.89),('12664','2013-07-04','13:30:00',2.72),('12664','2013-07-04','13:35:00',3.05),('12664','2013-07-04','13:40:00',2.04),('12664','2013-07-04','13:45:00',1.97),('12664','2013-07-04','13:50:00',1.96),('12664','2013-07-04','13:55:00',2.19),('12664','2013-07-04','14:00:00',1.97),('12664','2013-07-04','14:05:00',1.68),('12664','2013-07-04','14:10:00',1.67),('12664','2013-07-04','14:15:00',1.82),('12664','2013-07-04','14:20:00',1.73),('12664','2013-07-04','14:25:00',1.59),('12664','2013-07-04','14:30:00',1.48),('12664','2013-07-04','14:35:00',1.66),('12664','2013-07-04','14:40:00',1.29),('12664','2013-07-04','14:45:00',1.31),('12664','2013-07-04','14:50:00',1.42),('12664','2013-07-04','14:55:00',3.04),('12664','2013-07-04','15:00:00',2.46),('12664','2013-07-04','15:05:00',3.77),('12664','2013-07-04','15:10:00',4.29),('12664','2013-07-04','15:15:00',4.39),('12664','2013-07-04','15:20:00',2.32),('12664','2013-07-04','15:25:00',3.13),('12664','2013-07-04','15:30:00',3.87),('12664','2013-07-04','15:35:00',2.73),('12664','2013-07-04','15:40:00',2.76),('12664','2013-07-04','15:45:00',3.55),('12664','2013-07-04','15:50:00',3.49),('12664','2013-07-04','15:55:00',3.33),('12664','2013-07-04','16:00:00',2.55),('12664','2013-07-04','16:05:00',2.26),('12664','2013-07-04','16:10:00',2.58),('12664','2013-07-04','16:15:00',2.7),('12664','2013-07-04','16:20:00',2.93),('12664','2013-07-04','16:25:00',1.89),('12664','2013-07-04','16:30:00',1.96),('12664','2013-07-04','16:35:00',1.64),('12664','2013-07-04','16:40:00',1.47),('12664','2013-07-04','16:45:00',1.44),('12664','2013-07-04','16:50:00',1.38),('12664','2013-07-04','16:55:00',1.71),('12664','2013-07-04','17:00:00',1.99),('12664','2013-07-04','17:05:00',2.14),('12664','2013-07-04','17:10:00',2.61),('12664','2013-07-04','17:15:00',2.75),('12664','2013-07-04','17:20:00',2.39),('12664','2013-07-04','17:25:00',2.51),('12664','2013-07-04','17:30:00',2.01),('12664','2013-07-04','17:35:00',1.28),('12664','2013-07-04','17:40:00',1.41),('12664','2013-07-04','17:45:00',2.09),('12664','2013-07-04','17:50:00',1.99),('12664','2013-07-04','17:55:00',1.86),('12664','2013-07-04','18:00:00',1.78),('12664','2013-07-04','18:05:00',1.42),('12664','2013-07-04','18:10:00',1.58),('12664','2013-07-04','18:15:00',1.29),('12664','2013-07-04','18:20:00',1.2),('12664','2013-07-04','18:25:00',1.13),('12664','2013-07-04','18:30:00',1.1),('12664','2013-07-03','07:40:00',1.03),('12664','2013-07-03','07:45:00',1.12),('12664','2013-07-03','07:50:00',1.2),('12664','2013-07-03','07:55:00',1.29),('12664','2013-07-03','08:00:00',1.39),('12664','2013-07-03','08:05:00',1.49),('12664','2013-07-03','08:10:00',1.57),('12664','2013-07-03','08:15:00',1.67),('12664','2013-07-03','08:20:00',1.77),('12664','2013-07-03','08:25:00',1.85),('12664','2013-07-03','08:30:00',1.94),('12664','2013-07-03','08:35:00',2.01),('12664','2013-07-03','08:40:00',2.08),('12664','2013-07-03','08:45:00',2.17),('12664','2013-07-03','08:50:00',2.25),('12664','2013-07-03','08:55:00',2.33),('12664','2013-07-03','09:00:00',2.35),('12664','2013-07-03','09:05:00',2.47),('12664','2013-07-03','09:10:00',2.57),('12664','2013-07-03','09:15:00',2.63),('12664','2013-07-03','09:20:00',2.68),('12664','2013-07-03','09:25:00',2.78),('12664','2013-07-03','09:30:00',2.85),('12664','2013-07-03','09:35:00',2.91),('12664','2013-07-03','09:40:00',2.96),('12664','2013-07-03','09:45:00',3.01),('12664','2013-07-03','09:50:00',3.08),('12664','2013-07-03','09:55:00',3.11),('12664','2013-07-03','10:00:00',3.2),('12664','2013-07-03','10:05:00',3.26),('12664','2013-07-03','10:10:00',3.31),('12664','2013-07-03','10:15:00',3.35),('12664','2013-07-03','10:20:00',3.36),('12664','2013-07-03','10:25:00',3.46),('12664','2013-07-03','10:30:00',3.57),('12664','2013-07-03','10:35:00',3.61),('12664','2013-07-03','10:40:00',3.65),('12664','2013-07-03','10:45:00',3.72),('12664','2013-07-03','10:50:00',3.79),('12664','2013-07-03','10:55:00',3.8),('12664','2013-07-03','11:00:00',3.78),('12664','2013-07-03','11:05:00',3.89),('12664','2013-07-03','11:10:00',3.92),('12664','2013-07-03','11:15:00',3.95),('12664','2013-07-03','11:20:00',3.99),('12664','2013-07-03','11:25:00',4.05),('12664','2013-07-03','11:30:00',4.12),('12664','2013-07-03','11:35:00',4.15),('12664','2013-07-03','11:40:00',4.17),('12664','2013-07-03','11:45:00',4.2),('12664','2013-07-03','11:50:00',4.23),('12664','2013-07-03','11:55:00',4.27),('12664','2013-07-03','12:00:00',4.28),('12664','2013-07-03','12:05:00',4.3),('12664','2013-07-03','12:10:00',4.32),('12664','2013-07-03','12:15:00',4.31),('12664','2013-07-03','12:20:00',4.34),('12664','2013-07-03','12:25:00',4.36),('12664','2013-07-03','12:30:00',4.36),('12664','2013-07-03','12:35:00',4.37),('12664','2013-07-03','12:40:00',4.4),('12664','2013-07-03','12:45:00',4.39),('12664','2013-07-03','12:50:00',4.4),('12664','2013-07-03','12:55:00',4.39),('12664','2013-07-03','13:00:00',4.42),('12664','2013-07-03','13:05:00',4.44),('12664','2013-07-03','13:10:00',4.44),('12664','2013-07-03','13:15:00',4.44),('12664','2013-07-03','13:20:00',4.42),('12664','2013-07-03','13:25:00',4.43),('12664','2013-07-03','13:30:00',4.4),('12664','2013-07-03','13:35:00',4.4),('12664','2013-07-03','13:40:00',4.38),('12664','2013-07-03','13:45:00',4.37),('12664','2013-07-03','13:50:00',4.37),('12664','2013-07-03','13:55:00',4.36),('12664','2013-07-03','14:00:00',4.34),('12664','2013-07-03','14:05:00',4.33),('12664','2013-07-03','14:10:00',4.31),('12664','2013-07-03','14:15:00',4.3),('12664','2013-07-03','14:20:00',4.28),('12664','2013-07-03','14:25:00',4.26),('12664','2013-07-03','14:30:00',4.22),('12664','2013-07-03','14:35:00',4.22),('12664','2013-07-03','14:40:00',4.2),('12664','2013-07-03','14:45:00',4.18),('12664','2013-07-03','14:50:00',4.15),('12664','2013-07-03','14:55:00',4.11),('12664','2013-07-03','15:00:00',4.07),('12664','2013-07-03','15:05:00',4.04),('12664','2013-07-03','15:10:00',4),('12664','2013-07-03','15:15:00',3.96),('12664','2013-07-03','15:20:00',3.92),('12664','2013-07-03','15:25:00',3.87),('12664','2013-07-03','15:30:00',3.81),('12664','2013-07-03','15:35:00',3.77),('12664','2013-07-03','15:40:00',3.73),('12664','2013-07-03','15:45:00',3.69),('12664','2013-07-03','15:50:00',3.64),('12664','2013-07-03','15:55:00',3.58),('12664','2013-07-03','16:00:00',3.53),('12664','2013-07-03','16:05:00',3.46),('12664','2013-07-03','16:10:00',3.41),('12664','2013-07-03','16:15:00',3.35),('12664','2013-07-03','16:20:00',3.29),('12664','2013-07-03','16:25:00',3.24),('12664','2013-07-03','16:30:00',3.17),('12664','2013-07-03','16:35:00',3.1),('12664','2013-07-03','16:40:00',3.04),('12664','2013-07-03','16:45:00',2.97),('12664','2013-07-03','16:50:00',2.89),('12664','2013-07-03','16:55:00',2.83),('12664','2013-07-03','17:00:00',2.76),('12664','2013-07-03','17:05:00',2.68),('12664','2013-07-03','17:10:00',2.61),('12664','2013-07-03','17:15:00',2.53),('12664','2013-07-03','17:20:00',2.45),('12664','2013-07-03','17:25:00',2.35),('12664','2013-07-03','17:30:00',2.28),('12664','2013-07-03','17:35:00',2.19),('12664','2013-07-03','17:40:00',2.09),('12664','2013-07-03','17:45:00',2.01),('12664','2013-07-03','17:50:00',1.92),('12664','2013-07-03','17:55:00',1.84),('12664','2013-07-03','18:00:00',1.74),('12664','2013-07-03','18:05:00',1.65),('12664','2013-07-03','18:10:00',1.56),('12664','2013-07-03','18:15:00',1.47),('12664','2013-07-03','18:20:00',1.38),('12664','2013-07-03','18:25:00',1.28),('12664','2013-07-03','18:30:00',1.19),('12664','2013-07-03','18:35:00',1.1),('12664','2013-07-03','18:40:00',1),('12664','2013-07-02','07:40:00',1),('12664','2013-07-02','07:45:00',1.09),('12664','2013-07-02','07:50:00',1.18),('12664','2013-07-02','07:55:00',1.27),('12664','2013-07-02','08:00:00',1.36),('12664','2013-07-02','08:05:00',1.44),('12664','2013-07-02','08:10:00',1.53),('12664','2013-07-02','08:15:00',1.62),('12664','2013-07-02','08:20:00',1.71),('12664','2013-07-02','08:25:00',1.79),('12664','2013-07-02','08:30:00',1.87),('12664','2013-07-02','08:35:00',1.96),('12664','2013-07-02','08:40:00',2.05),('12664','2013-07-02','08:45:00',2.13),('12664','2013-07-02','08:50:00',2.21),('12664','2013-07-02','08:55:00',2.28),('12664','2013-07-02','09:00:00',2.36),('12664','2013-07-02','09:05:00',2.45),('12664','2013-07-02','09:10:00',2.52),('12664','2013-07-02','09:15:00',2.59),('12664','2013-07-02','09:20:00',2.66),('12664','2013-07-02','09:25:00',2.74),('12664','2013-07-02','09:30:00',2.81),('12664','2013-07-02','09:35:00',2.87),('12664','2013-07-02','09:40:00',2.93),('12664','2013-07-02','09:45:00',2.96),('12664','2013-07-02','09:50:00',3.02),('12664','2013-07-02','09:55:00',3.07),('12664','2013-07-02','10:00:00',3.14),('12664','2013-07-02','10:05:00',3.21),('12664','2013-07-02','10:10:00',3.26),('12664','2013-07-02','10:15:00',3.31),('12664','2013-07-02','10:20:00',3.35),('12664','2013-07-02','10:25:00',3.4),('12664','2013-07-02','10:30:00',3.45),('12664','2013-07-02','10:35:00',3.5),('12664','2013-07-02','10:40:00',3.53),('12664','2013-07-02','10:45:00',3.58),('12664','2013-07-02','10:50:00',3.62),('12664','2013-07-02','10:55:00',3.67),('12664','2013-07-02','11:00:00',3.71),('12664','2013-07-02','11:05:00',3.75),('12664','2013-07-02','11:10:00',3.78),('12664','2013-07-02','11:15:00',3.83),('12664','2013-07-02','11:20:00',3.89),('12664','2013-07-02','11:25:00',3.9),('12664','2013-07-02','11:30:00',3.92),('12664','2013-07-02','11:35:00',3.94),('12664','2013-07-02','11:40:00',3.91),('12664','2013-07-02','11:45:00',3.96),('12664','2013-07-02','11:50:00',4.07),('12664','2013-07-02','11:55:00',4.12),('12664','2013-07-02','12:00:00',4.13),('12664','2013-07-02','12:05:00',4.07),('12664','2013-07-02','12:10:00',4.03),('12664','2013-07-02','12:15:00',4.05),('12664','2013-07-02','12:20:00',4.14),('12664','2013-07-02','12:25:00',4.21),('12664','2013-07-02','12:30:00',4.18),('12664','2013-07-02','12:35:00',4.18),('12664','2013-07-02','12:40:00',4.2),('12664','2013-07-02','12:45:00',4.23),('12664','2013-07-02','12:50:00',4.33),('12664','2013-07-02','12:55:00',4.29),('12664','2013-07-02','13:00:00',4.27),('12664','2013-07-02','13:05:00',4.2),('12664','2013-07-02','13:10:00',4.26),('12664','2013-07-02','13:15:00',4.26),('12664','2013-07-02','13:20:00',4.28),('12664','2013-07-02','13:25:00',4.21),('12664','2013-07-02','13:30:00',4.26),('12664','2013-07-02','13:35:00',4.27),('12664','2013-07-02','13:40:00',4.24),('12664','2013-07-02','13:45:00',4.23),('12664','2013-07-02','13:50:00',4.17),('12664','2013-07-02','13:55:00',4.15),('12664','2013-07-02','14:00:00',4.2),('12664','2013-07-02','14:05:00',4.21),('12664','2013-07-02','14:10:00',4.18),('12664','2013-07-02','14:15:00',4.17),('12664','2013-07-02','14:20:00',4.14),('12664','2013-07-02','14:25:00',4.13),('12664','2013-07-02','14:30:00',4.11),('12664','2013-07-02','14:35:00',4.09),('12664','2013-07-02','14:40:00',4.07),('12664','2013-07-02','14:45:00',4.07),('12664','2013-07-02','14:50:00',4.04),('12664','2013-07-02','14:55:00',4.01),('12664','2013-07-02','15:00:00',3.98),('12664','2013-07-02','15:05:00',3.93),('12664','2013-07-02','15:10:00',3.91),('12664','2013-07-02','15:15:00',3.88),('12664','2013-07-02','15:20:00',3.84),('12664','2013-07-02','15:25:00',3.79),('12664','2013-07-02','15:30:00',3.74),('12664','2013-07-02','15:35:00',3.69),('12664','2013-07-02','15:40:00',3.67),('12664','2013-07-02','15:45:00',3.64),('12664','2013-07-02','15:50:00',3.58),('12664','2013-07-02','15:55:00',3.54),('12664','2013-07-02','16:00:00',3.46),('12664','2013-07-02','16:05:00',3.41),('12664','2013-07-02','16:10:00',3.34),('12664','2013-07-02','16:15:00',3.27),('12664','2013-07-02','16:20:00',3.22),('12664','2013-07-02','16:25:00',3.15),('12664','2013-07-02','16:30:00',3.09),('12664','2013-07-02','16:35:00',3.02),('12664','2013-07-02','16:40:00',2.96),('12664','2013-07-02','16:45:00',2.88),('12664','2013-07-02','16:50:00',2.82),('12664','2013-07-02','16:55:00',2.76),('12664','2013-07-02','17:00:00',2.66),('12664','2013-07-02','17:05:00',2.59),('12664','2013-07-02','17:10:00',2.53),('12664','2013-07-02','17:15:00',2.44),('12664','2013-07-02','17:20:00',2.36),('12664','2013-07-02','17:25:00',2.28),('12664','2013-07-02','17:30:00',2.19),('12664','2013-07-02','17:35:00',2.1),('12664','2013-07-02','17:40:00',2.02),('12664','2013-07-02','17:45:00',1.94),('12664','2013-07-02','17:50:00',1.85),('12664','2013-07-02','17:55:00',1.76),('12664','2013-07-02','18:00:00',1.67),('12664','2013-07-02','18:05:00',1.57),('12664','2013-07-02','18:10:00',1.48),('12664','2013-07-02','18:15:00',1.39),('12664','2013-07-02','18:20:00',1.3),('12664','2013-07-02','18:25:00',1.22),('12664','2013-07-02','18:30:00',1.13),('12664','2013-07-02','18:35:00',1.04),('12664','2013-07-01','07:40:00',1.05),('12664','2013-07-01','07:45:00',1.14),('12664','2013-07-01','07:50:00',1.23),('12664','2013-07-01','07:55:00',1.33),('12664','2013-07-01','08:00:00',1.42),('12664','2013-07-01','08:05:00',1.5),('12664','2013-07-01','08:10:00',1.58),('12664','2013-07-01','08:15:00',1.66),('12664','2013-07-01','08:20:00',1.75),('12664','2013-07-01','08:25:00',1.84),('12664','2013-07-01','08:30:00',1.92),('12664','2013-07-01','08:35:00',2),('12664','2013-07-01','08:40:00',2.09),('12664','2013-07-01','08:45:00',2.18),('12664','2013-07-01','08:50:00',2.27),('12664','2013-07-01','08:55:00',2.34),('12664','2013-07-01','09:00:00',2.43),('12664','2013-07-01','09:05:00',2.52),('12664','2013-07-01','09:10:00',2.59),('12664','2013-07-01','09:15:00',2.67),('12664','2013-07-01','09:20:00',2.75),('12664','2013-07-01','09:25:00',2.82),('12664','2013-07-01','09:30:00',2.92),('12664','2013-07-01','09:35:00',2.99),('12664','2013-07-01','09:40:00',3.04),('12664','2013-07-01','09:45:00',3.11),('12664','2013-07-01','09:50:00',3.16),('12664','2013-07-01','09:55:00',3.23),('12664','2013-07-01','10:00:00',3.28),('12664','2013-07-01','10:05:00',3.31),('12664','2013-07-01','10:10:00',3.36),('12664','2013-07-01','10:15:00',3.43),('12664','2013-07-01','10:20:00',3.49),('12664','2013-07-01','10:25:00',3.52),('12664','2013-07-01','10:30:00',3.58),('12664','2013-07-01','10:35:00',3.67),('12664','2013-07-01','10:40:00',3.67),('12664','2013-07-01','10:45:00',3.68),('12664','2013-07-01','10:50:00',3.71),('12664','2013-07-01','10:55:00',3.77),('12664','2013-07-01','11:00:00',3.79),('12664','2013-07-01','11:05:00',3.8),('12664','2013-07-01','11:10:00',3.83),('12664','2013-07-01','11:15:00',3.84),('12664','2013-07-01','11:20:00',3.93),('12664','2013-07-01','11:25:00',3.98),('12664','2013-07-01','11:30:00',3.99),('12664','2013-07-01','11:35:00',4.02),('12664','2013-07-01','11:40:00',4.01),('12664','2013-07-01','11:45:00',4.01),('12664','2013-07-01','11:50:00',4.06),('12664','2013-07-01','11:55:00',4.07),('12664','2013-07-01','12:00:00',4.1),('12664','2013-07-01','12:05:00',4.09),('12664','2013-07-01','12:10:00',4.1),('12664','2013-07-01','12:15:00',4.16),('12664','2013-07-01','12:20:00',4.13),('12664','2013-07-01','12:25:00',3.99),('12664','2013-07-01','12:30:00',3.67),('12664','2013-07-01','12:35:00',4.16),('12664','2013-07-01','12:40:00',4.35),('12664','2013-07-01','12:45:00',4.32),('12664','2013-07-01','12:50:00',4.17),('12664','2013-07-01','12:55:00',4.14),('12664','2013-07-01','13:00:00',4.2),('12664','2013-07-01','13:05:00',4.39),('12664','2013-07-01','13:10:00',4.31),('12664','2013-07-01','13:15:00',4.3),('12664','2013-07-01','13:20:00',4.33),('12664','2013-07-01','13:25:00',4.22),('12664','2013-07-01','13:30:00',4.25),('12664','2013-07-01','13:35:00',4.28),('12664','2013-07-01','13:40:00',4.32),('12664','2013-07-01','13:45:00',4.37),('12664','2013-07-01','13:50:00',4.32),('12664','2013-07-01','13:55:00',4.31),('12664','2013-07-01','14:00:00',4.33),('12664','2013-07-01','14:05:00',4.27),('12664','2013-07-01','14:10:00',4.29),('12664','2013-07-01','14:15:00',4.25),('12664','2013-07-01','14:20:00',4.2),('12664','2013-07-01','14:25:00',4.14),('12664','2013-07-01','14:30:00',4.14),('12664','2013-07-01','14:35:00',4.14),('12664','2013-07-01','14:40:00',4.09),('12664','2013-07-01','14:45:00',4.08),('12664','2013-07-01','14:50:00',4.02),('12664','2013-07-01','14:55:00',4.01),('12664','2013-07-01','15:00:00',3.97),('12664','2013-07-01','15:05:00',3.97),('12664','2013-07-01','15:10:00',3.93),('12664','2013-07-01','15:15:00',3.91),('12664','2013-07-01','15:20:00',3.83),('12664','2013-07-01','15:25:00',3.77),('12664','2013-07-01','15:30:00',3.73),('12664','2013-07-01','15:35:00',3.68),('12664','2013-07-01','15:40:00',3.63),('12664','2013-07-01','15:45:00',3.61),('12664','2013-07-01','15:50:00',3.53),('12664','2013-07-01','15:55:00',3.48),('12664','2013-07-01','16:00:00',3.44),('12664','2013-07-01','16:05:00',3.31),('12664','2013-07-01','16:10:00',3.28),('12664','2013-07-01','16:15:00',3.26),('12664','2013-07-01','16:20:00',3.19),('12664','2013-07-01','16:25:00',3.13),('12664','2013-07-01','16:30:00',3.06),('12664','2013-07-01','16:35:00',3),('12664','2013-07-01','16:40:00',2.92),('12664','2013-07-01','16:45:00',2.86),('12664','2013-07-01','16:50:00',2.79),('12664','2013-07-01','16:55:00',2.72),('12664','2013-07-01','17:00:00',2.65),('12664','2013-07-01','17:05:00',2.58),('12664','2013-07-01','17:10:00',2.49),('12664','2013-07-01','17:15:00',2.39),('12664','2013-07-01','17:20:00',2.33),('12664','2013-07-01','17:25:00',2.26),('12664','2013-07-01','17:30:00',2.17),('12664','2013-07-01','17:35:00',2.07),('12664','2013-07-01','17:40:00',2),('12664','2013-07-01','17:45:00',1.92),('12664','2013-07-01','17:50:00',1.83),('12664','2013-07-01','17:55:00',1.74),('12664','2013-07-01','18:00:00',1.67),('12664','2013-07-01','18:05:00',1.5),('12664','2013-07-01','18:10:00',1.4),('12664','2013-07-01','18:15:00',1.4),('12664','2013-07-01','18:20:00',1.36),('12664','2013-07-01','18:25:00',1.27),('12664','2013-07-01','18:30:00',1.09),('12664','2013-06-30','07:35:00',1.01),('12664','2013-06-30','07:40:00',1.11),('12664','2013-06-30','07:45:00',1.2),('12664','2013-06-30','07:50:00',1.29),('12664','2013-06-30','07:55:00',1.39),('12664','2013-06-30','08:00:00',1.48),('12664','2013-06-30','08:05:00',1.57),('12664','2013-06-30','08:10:00',1.67),('12664','2013-06-30','08:15:00',1.76),('12664','2013-06-30','08:20:00',1.84),('12664','2013-06-30','08:25:00',1.93),('12664','2013-06-30','08:30:00',2.01),('12664','2013-06-30','08:35:00',2.1),('12664','2013-06-30','08:40:00',2.19),('12664','2013-06-30','08:45:00',2.28),('12664','2013-06-30','08:50:00',2.36),('12664','2013-06-30','08:55:00',2.44),('12664','2013-06-30','09:00:00',2.52),('12664','2013-06-30','09:05:00',2.6),('12664','2013-06-30','09:10:00',2.68),('12664','2013-06-30','09:15:00',2.76),('12664','2013-06-30','09:20:00',2.85),('12664','2013-06-30','09:25:00',2.91),('12664','2013-06-30','09:30:00',2.97),('12664','2013-06-30','09:35:00',3.04),('12664','2013-06-30','09:40:00',3.11),('12664','2013-06-30','09:45:00',3.17),('12664','2013-06-30','09:50:00',3.22),('12664','2013-06-30','09:55:00',3.29),('12664','2013-06-30','10:00:00',3.35),('12664','2013-06-30','10:05:00',3.4),('12664','2013-06-30','10:10:00',3.45),('12664','2013-06-30','10:15:00',3.49),('12664','2013-06-30','10:20:00',3.56),('12664','2013-06-30','10:25:00',3.61),('12664','2013-06-30','10:30:00',3.66),('12664','2013-06-30','10:35:00',3.69),('12664','2013-06-30','10:40:00',3.72),('12664','2013-06-30','10:45:00',3.76),('12664','2013-06-30','10:50:00',3.81),('12664','2013-06-30','10:55:00',3.84),('12664','2013-06-30','11:00:00',3.89),('12664','2013-06-30','11:05:00',3.92),('12664','2013-06-30','11:10:00',3.93),('12664','2013-06-30','11:15:00',3.99),('12664','2013-06-30','11:20:00',4.05),('12664','2013-06-30','11:25:00',4.05),('12664','2013-06-30','11:30:00',4.06),('12664','2013-06-30','11:35:00',4.1),('12664','2013-06-30','11:40:00',4.1),('12664','2013-06-30','11:45:00',4.15),('12664','2013-06-30','11:50:00',4.18),('12664','2013-06-30','11:55:00',4.21),('12664','2013-06-30','12:00:00',4.21),('12664','2013-06-30','12:05:00',4.24),('12664','2013-06-30','12:10:00',4.26),('12664','2013-06-30','12:15:00',4.26),('12664','2013-06-30','12:20:00',4.29),('12664','2013-06-30','12:25:00',4.29),('12664','2013-06-30','12:30:00',4.29),('12664','2013-06-30','12:35:00',4.35),('12664','2013-06-30','12:40:00',4.44),('12664','2013-06-30','12:45:00',4.01),('12664','2013-06-30','12:50:00',4.64),('12664','2013-06-30','12:55:00',2.99),('12664','2013-06-30','13:00:00',3.34),('12664','2013-06-30','13:05:00',4.59),('12664','2013-06-30','13:10:00',2.08),('12664','2013-06-30','13:15:00',1.63),('12664','2013-06-30','13:20:00',4.25),('12664','2013-06-30','13:25:00',4.07),('12664','2013-06-30','13:30:00',2.3),('12664','2013-06-30','13:35:00',3.68),('12664','2013-06-30','13:40:00',3.33),('12664','2013-06-30','13:45:00',3.33),('12664','2013-06-30','13:50:00',3.62),('12664','2013-06-30','13:55:00',4.54),('12664','2013-06-30','14:00:00',4.5),('12664','2013-06-30','14:05:00',4.44),('12664','2013-06-30','14:10:00',4.38),('12664','2013-06-30','14:15:00',4.35),('12664','2013-06-30','14:20:00',4.31),('12664','2013-06-30','14:25:00',4.26),('12664','2013-06-30','14:30:00',4.26),('12664','2013-06-30','14:35:00',4.21),('12664','2013-06-30','14:40:00',4.2),('12664','2013-06-30','14:45:00',4.18),('12664','2013-06-30','14:50:00',4.14),('12664','2013-06-30','14:55:00',4.11),('12664','2013-06-30','15:00:00',4.07),('12664','2013-06-30','15:05:00',4.04),('12664','2013-06-30','15:10:00',4.01),('12664','2013-06-30','15:15:00',3.97),('12664','2013-06-30','15:20:00',3.92),('12664','2013-06-30','15:25:00',3.86),('12664','2013-06-30','15:30:00',3.93),('12664','2013-06-30','15:35:00',2.97),('12664','2013-06-30','15:40:00',3.93),('12664','2013-06-30','15:45:00',3.37),('12664','2013-06-30','15:50:00',3.62),('12664','2013-06-30','15:55:00',2.47),('12664','2013-06-30','16:00:00',3.64),('12664','2013-06-30','16:05:00',3.58),('12664','2013-06-30','16:10:00',2.96),('12664','2013-06-30','16:15:00',2.78),('12664','2013-06-30','16:20:00',3.37),('12664','2013-06-30','16:25:00',3.29),('12664','2013-06-30','16:30:00',3.2),('12664','2013-06-30','16:35:00',3.08),('12664','2013-06-30','16:40:00',2.97),('12664','2013-06-30','16:45:00',2.93),('12664','2013-06-30','16:50:00',2.82),('12664','2013-06-30','16:55:00',2.77),('12664','2013-06-30','17:00:00',2.67),('12664','2013-06-30','17:05:00',2.6),('12664','2013-06-30','17:10:00',2.52),('12664','2013-06-30','17:15:00',2.27),('12664','2013-06-30','17:20:00',2.28),('12664','2013-06-30','17:25:00',2.25),('12664','2013-06-30','17:30:00',2.19),('12664','2013-06-30','17:35:00',2.13),('12664','2013-06-30','17:40:00',2.04),('12664','2013-06-30','17:45:00',1.94),('12664','2013-06-30','17:50:00',1.87),('12664','2013-06-30','17:55:00',1.76),('12664','2013-06-30','18:00:00',1.62),('12664','2013-06-30','18:05:00',1.53),('12664','2013-06-30','18:10:00',1.45),('12664','2013-06-30','18:15:00',1.37),('12664','2013-06-30','18:20:00',1.29),('12664','2013-06-30','18:25:00',1.17),('12664','2013-06-30','18:30:00',1.1),('12664','2013-06-30','18:35:00',1.03),('12664','2014-04-04','12:35:00',1.15),('12664','2014-04-04','12:55:00',1.22),('12664','2014-04-04','13:00:00',1.81),('12664','2014-04-04','13:05:00',1.35),('12664','2014-04-04','13:10:00',3.02),('12664','2014-04-04','13:15:00',3.76),('12664','2014-04-04','13:20:00',1.43),('12664','2014-04-04','13:25:00',2.05),('12664','2014-04-04','13:30:00',3.86),('12664','2014-04-04','13:35:00',1.94),('12664','2014-04-04','13:40:00',1.8),('12664','2014-04-04','13:45:00',1.93),('12664','2014-04-04','13:50:00',2.58),('12664','2014-04-04','13:55:00',2.64),('12664','2014-04-04','14:00:00',2.43),('12664','2014-04-04','14:05:00',2.13),('12664','2014-04-04','14:10:00',1.33),('12664','2014-04-04','14:15:00',1.81),('12664','2014-04-04','14:20:00',1.34),('12664','2014-04-04','14:25:00',1.23),('12664','2014-04-04','14:30:00',1.28),('12664','2014-04-04','14:35:00',1.38),('12664','2014-04-04','14:40:00',2.07),('12664','2014-04-04','14:45:00',1.97),('12664','2014-04-04','14:50:00',2.1),('12664','2014-04-04','14:55:00',2.09),('12664','2014-04-04','15:00:00',2.38),('12664','2014-04-04','15:05:00',1.79),('12664','2014-04-04','15:10:00',1.48),('12664','2014-04-04','15:15:00',3.06),('12664','2014-04-04','15:20:00',2.3),('12664','2014-04-04','15:25:00',2.91),('12664','2014-04-04','15:30:00',2.27),('12664','2014-04-04','15:35:00',2.69),('12664','2014-04-04','15:40:00',1.34),('12664','2014-04-04','15:45:00',1.6),('12664','2014-04-04','15:50:00',2.97),('12664','2014-04-04','15:55:00',3.89),('12664','2014-04-04','16:00:00',2.01),('12664','2014-04-04','16:05:00',1.9),('12664','2014-04-04','16:10:00',1.53),('12664','2014-04-04','16:15:00',2.36),('12664','2014-04-04','16:20:00',1.34),('12664','2014-04-04','16:25:00',1.07),('12664','2014-04-04','16:30:00',2.77),('12664','2014-04-04','16:35:00',2.63),('12664','2014-04-04','16:40:00',3.4),('12664','2014-04-04','16:45:00',1.48),('12664','2014-04-04','16:50:00',1.48),('12664','2014-04-04','16:55:00',1.26),('12664','2014-04-04','17:00:00',1.48),('12664','2014-04-04','17:05:00',1.43),('12664','2014-04-04','17:15:00',1.55),('12664','2014-04-04','17:20:00',2.02),('12664','2014-04-04','17:25:00',1.79),('12664','2014-04-04','17:30:00',1.72),('12664','2014-04-04','17:35:00',1.24),('12664','2014-04-04','17:50:00',1.14),('12664','2013-06-29','07:20:00',1.09),('12664','2013-06-29','07:25:00',1.25),('12664','2013-06-29','07:30:00',1.36),('12664','2013-06-29','07:50:00',1.35),('12664','2013-06-29','08:15:00',1.82),('12664','2013-06-29','08:20:00',1.89),('12664','2013-06-29','08:25:00',1.93),('12664','2013-06-29','08:30:00',1.97),('12664','2013-06-29','08:35:00',2.04),('12664','2013-06-29','08:40:00',2.14),('12664','2013-06-29','08:45:00',2.22),('12664','2013-06-29','08:50:00',2.3),('12664','2013-06-29','08:55:00',2.38),('12664','2013-06-29','09:00:00',2.47),('12664','2013-06-29','09:05:00',2.54),('12664','2013-06-29','09:10:00',2.63),('12664','2013-06-29','09:15:00',2.71),('12664','2013-06-29','09:20:00',2.77),('12664','2013-06-29','09:25:00',2.82),('12664','2013-06-29','09:30:00',2.91),('12664','2013-06-29','09:35:00',2.96),('12664','2013-06-29','09:40:00',3.04),('12664','2013-06-29','09:45:00',3.12),('12664','2013-06-29','09:50:00',3.19),('12664','2013-06-29','09:55:00',3.25),('12664','2013-06-29','10:00:00',3.31),('12664','2013-06-29','10:05:00',3.37),('12664','2013-06-29','10:10:00',3.42),('12664','2013-06-29','10:15:00',3.46),('12664','2013-06-29','10:20:00',3.53),('12664','2013-06-29','10:25:00',3.59),('12664','2013-06-29','10:30:00',3.61),('12664','2013-06-29','10:35:00',3.66),('12664','2013-06-29','10:40:00',3.48),('12664','2013-06-29','10:45:00',2.94),('12664','2013-06-29','10:50:00',3.76),('12664','2013-06-29','10:55:00',3.92),('12664','2013-06-29','11:00:00',2.39),('12664','2013-06-29','11:10:00',4.37),('12664','2013-06-29','11:15:00',4.38),('12664','2013-06-29','11:20:00',4.4),('12664','2013-06-29','11:25:00',4.25),('12664','2013-06-29','11:30:00',4.28),('12664','2013-06-29','11:35:00',3.97),('12664','2013-06-29','11:40:00',1.74),('12664','2013-06-29','11:45:00',4.49),('12664','2013-06-29','11:50:00',4.45),('12664','2013-06-29','11:55:00',4.37),('12664','2013-06-29','12:00:00',4.34),('12664','2013-06-29','12:05:00',4.4),('12664','2013-06-29','12:10:00',3),('12664','2013-06-29','12:15:00',4.68),('12664','2013-06-29','12:20:00',4.72),('12664','2013-06-29','12:25:00',3.33),('12664','2013-06-29','12:30:00',1.49),('12664','2013-06-29','12:35:00',1.29),('12664','2013-06-29','12:40:00',3.98),('12664','2013-06-29','12:45:00',5.04),('12664','2013-06-29','12:50:00',4.92),('12664','2013-06-29','12:55:00',4.97),('12664','2013-06-29','13:00:00',4.78),('12664','2013-06-29','13:05:00',3.95),('12664','2013-06-29','13:10:00',2),('12664','2013-06-29','13:15:00',5.04),('12664','2013-06-29','13:20:00',4.09),('12664','2013-06-29','13:25:00',4.6),('12664','2013-06-29','13:30:00',4.14),('12664','2013-06-29','13:35:00',4.79),('12664','2013-06-29','13:40:00',4.62),('12664','2013-06-29','13:45:00',4.62),('12664','2013-06-29','13:50:00',4.56),('12664','2013-06-29','13:55:00',4.51),('12664','2013-06-29','14:00:00',3.84),('12664','2013-06-29','14:05:00',2.06),('12664','2013-06-29','14:10:00',4.06),('12664','2013-06-29','14:15:00',4.64),('12664','2013-06-29','14:20:00',4.56),('12664','2013-06-29','14:25:00',4.48),('12664','2013-06-29','14:30:00',4.5),('12664','2013-06-29','14:35:00',4.53),('12664','2013-06-29','14:40:00',4.48),('12664','2013-06-29','14:45:00',4.36),('12664','2013-06-29','14:50:00',4.46),('12664','2013-06-29','14:55:00',4.48),('12664','2013-06-29','15:00:00',4.51),('12664','2013-06-29','15:05:00',4.7),('12664','2013-06-29','15:10:00',4.63),('12664','2013-06-29','15:15:00',3.16),('12664','2013-06-29','15:20:00',1.91),('12664','2013-06-29','15:25:00',1.55),('12664','2013-06-29','15:30:00',2.04),('12664','2013-06-29','15:35:00',1.85),('12664','2013-06-29','16:20:00',1.22),('12664','2013-06-29','16:25:00',2.4),('12664','2013-06-29','16:30:00',3.16),('12664','2013-06-29','16:35:00',4.14),('12664','2013-06-29','16:40:00',2.95),('12664','2013-06-29','16:45:00',1.54),('12664','2013-06-29','16:50:00',1.82),('12664','2013-06-29','16:55:00',2.09),('12664','2013-06-29','17:00:00',2.16),('12664','2013-06-29','17:05:00',1.87),('12664','2013-06-29','17:10:00',1.91),('12664','2013-06-29','17:15:00',2.84),('12664','2013-06-29','17:20:00',1.97),('12664','2013-06-29','17:25:00',2.49),('12664','2013-06-29','17:30:00',2.38),('12664','2013-06-29','17:35:00',2.37),('12664','2013-06-29','17:40:00',1.73),('12664','2013-06-29','18:30:00',1.2),('12664','2013-06-29','18:55:00',1.02),('12664','2013-06-29','19:00:00',1.04),('12664','2013-06-28','07:45:00',1.18),('12664','2013-06-28','07:50:00',1.29),('12664','2013-06-28','07:55:00',1.17),('12664','2013-06-28','08:00:00',1.47),('12664','2013-06-28','08:05:00',1.55),('12664','2013-06-28','08:10:00',1.56),('12664','2013-06-28','08:15:00',1.51),('12664','2013-06-28','08:20:00',1.76),('12664','2013-06-28','08:25:00',1.9),('12664','2013-06-28','08:30:00',1.98),('12664','2013-06-28','08:35:00',2.07),('12664','2013-06-28','08:40:00',2.16),('12664','2013-06-28','08:45:00',2.32),('12664','2013-06-28','08:50:00',2.44),('12664','2013-06-28','08:55:00',2.44),('12664','2013-06-28','09:00:00',2.53),('12664','2013-06-28','09:05:00',2.3),('12664','2013-06-28','09:10:00',3.07),('12664','2013-06-28','09:15:00',2.89),('12664','2013-06-28','09:20:00',2.85),('12664','2013-06-28','09:25:00',2.68),('12664','2013-06-28','09:30:00',2.68),('12664','2013-06-28','09:35:00',2.56),('12664','2013-06-28','09:40:00',1.77),('12664','2013-06-28','09:45:00',1.03),('12664','2013-06-28','09:55:00',1.48),('12664','2013-06-28','10:00:00',3.8),('12664','2013-06-28','10:05:00',3.78),('12664','2013-06-28','10:10:00',2.55),('12664','2013-06-28','10:15:00',1.52),('12664','2013-06-28','10:20:00',1.22),('12664','2013-06-28','10:25:00',4.12),('12664','2013-06-28','10:30:00',4),('12664','2013-06-28','10:35:00',1.78),('12664','2013-06-28','10:40:00',1.51),('12664','2013-06-28','10:45:00',3.16),('12664','2013-06-28','10:50:00',4.33),('12664','2013-06-28','10:55:00',3.38),('12664','2013-06-28','11:00:00',3.59),('12664','2013-06-28','11:05:00',3.95),('12664','2013-06-28','11:10:00',4.18),('12664','2013-06-28','11:15:00',3.78),('12664','2013-06-28','11:20:00',4.1),('12664','2013-06-28','11:25:00',4.61),('12664','2013-06-28','11:30:00',4.16),('12664','2013-06-28','11:35:00',4.24),('12664','2013-06-28','11:40:00',3.37),('12664','2013-06-28','11:45:00',4.51),('12664','2013-06-28','11:50:00',4.08),('12664','2013-06-28','11:55:00',2.63),('12664','2013-06-28','12:00:00',3.23),('12664','2013-06-28','12:05:00',4.81),('12664','2013-06-28','12:10:00',3.29),('12664','2013-06-28','12:15:00',3.93),('12664','2013-06-28','12:20:00',4.5),('12664','2013-06-28','12:25:00',4.07),('12664','2013-06-28','12:30:00',4.62),('12664','2013-06-28','12:35:00',4.59),('12664','2013-06-28','12:40:00',4.67),('12664','2013-06-28','12:45:00',4.56),('12664','2013-06-28','12:50:00',4.47),('12664','2013-06-28','12:55:00',4.27),('12664','2013-06-28','13:00:00',2.07),('12664','2013-06-28','13:05:00',3.05),('12664','2013-06-28','13:10:00',3.56),('12664','2013-06-28','13:15:00',4.79),('12664','2013-06-28','13:20:00',4.64),('12664','2013-06-28','13:25:00',4.57),('12664','2013-06-28','13:30:00',2.2),('12664','2013-06-28','13:35:00',4.52),('12664','2013-06-28','13:40:00',4.36),('12664','2013-06-28','13:45:00',4.12),('12664','2013-06-28','13:50:00',4.06),('12664','2013-06-28','13:55:00',4.19),('12664','2013-06-28','14:00:00',4.63),('12664','2013-06-28','14:05:00',4.65),('12664','2013-06-28','14:10:00',4.56),('12664','2013-06-28','14:15:00',3.43),('12664','2013-06-28','14:20:00',4.74),('12664','2013-06-28','14:25:00',2.76),('12664','2013-06-28','14:30:00',2.43),('12664','2013-06-28','14:35:00',4.35),('12664','2013-06-28','14:40:00',4.33),('12664','2013-06-28','14:45:00',2.77),('12664','2013-06-28','14:50:00',1.67),('12664','2013-06-28','14:55:00',2.51),('12664','2013-06-28','15:00:00',3.11),('12664','2013-06-28','15:05:00',3.51),('12664','2013-06-28','15:10:00',3.29),('12664','2013-06-28','15:15:00',3.16),('12664','2013-06-28','15:20:00',2.64),('12664','2013-06-28','15:25:00',4.57),('12664','2013-06-28','15:30:00',4),('12664','2013-06-28','15:35:00',3.56),('12664','2013-06-28','15:40:00',2.49),('12664','2013-06-28','15:45:00',3.75),('12664','2013-06-28','15:50:00',2.92),('12664','2013-06-28','15:55:00',3.88),('12664','2013-06-28','16:00:00',3.9),('12664','2013-06-28','16:05:00',3.99),('12664','2013-06-28','16:10:00',2.59),('12664','2013-06-28','16:15:00',2.67),('12664','2013-06-28','16:20:00',3.66),('12664','2013-06-28','16:25:00',2.96),('12664','2013-06-28','16:30:00',2.57),('12664','2013-06-28','16:35:00',1.15),('12664','2013-06-28','16:40:00',1.99),('12664','2013-06-28','16:45:00',3.47),('12664','2013-06-28','16:50:00',1.84),('12664','2013-06-28','16:55:00',3.15),('12664','2013-06-28','17:00:00',2.61),('12664','2013-06-28','17:05:00',2.72),('12664','2013-06-28','17:10:00',2.74),('12664','2013-06-28','17:15:00',2.5),('12664','2013-06-28','17:20:00',2.4),('12664','2013-06-28','17:25:00',2.29),('12664','2013-06-28','17:30:00',2.19),('12664','2013-06-28','17:35:00',2.13),('12664','2013-06-28','17:40:00',2.06),('12664','2013-06-28','17:45:00',1.98),('12664','2013-06-28','17:50:00',1.88),('12664','2013-06-28','17:55:00',1.8),('12664','2013-06-28','18:00:00',1.72),('12664','2013-06-28','18:05:00',1.7),('12664','2013-06-28','18:10:00',1.64),('12664','2013-06-28','18:15:00',1.44),('12664','2013-06-28','18:20:00',1.35),('12664','2013-06-28','18:25:00',1.27),('12664','2013-06-28','18:30:00',1.23),('12664','2013-06-28','18:35:00',1.11),('12664','2013-06-28','18:40:00',1.01),('12664','2013-06-27','07:40:00',1.06),('12664','2013-06-27','07:45:00',1.17),('12664','2013-06-27','07:50:00',1.28),('12664','2013-06-27','07:55:00',1.37),('12664','2013-06-27','08:00:00',1.43),('12664','2013-06-27','08:05:00',1.57),('12664','2013-06-27','08:10:00',1.64),('12664','2013-06-27','08:15:00',1.72),('12664','2013-06-27','08:20:00',1.83),('12664','2013-06-27','08:25:00',1.9),('12664','2013-06-27','08:30:00',1.96),('12664','2013-06-27','08:35:00',2.04),('12664','2013-06-27','08:40:00',2.12),('12664','2013-06-27','08:45:00',2.21),('12664','2013-06-27','08:50:00',2.3),('12664','2013-06-27','08:55:00',2.41),('12664','2013-06-27','09:00:00',2.49),('12664','2013-06-27','09:05:00',2.58),('12664','2013-06-27','09:10:00',2.66),('12664','2013-06-27','09:15:00',2.73),('12664','2013-06-27','09:20:00',2.79),('12664','2013-06-27','09:25:00',2.88),('12664','2013-06-27','09:30:00',2.97),('12664','2013-06-27','09:35:00',3.03),('12664','2013-06-27','09:40:00',3.06),('12664','2013-06-27','09:45:00',3.13),('12664','2013-06-27','09:50:00',3.19),('12664','2013-06-27','09:55:00',3.23),('12664','2013-06-27','10:00:00',3.28),('12664','2013-06-27','10:05:00',3.35),('12664','2013-06-27','10:10:00',3.42),('12664','2013-06-27','10:15:00',3.45),('12664','2013-06-27','10:20:00',3.54),('12664','2013-06-27','10:25:00',3.62),('12664','2013-06-27','10:30:00',3.82),('12664','2013-06-27','10:35:00',3.98),('12664','2013-06-27','10:40:00',3.82),('12664','2013-06-27','10:45:00',3.98),('12664','2013-06-27','10:50:00',4.07),('12664','2013-06-27','10:55:00',4.11),('12664','2013-06-27','11:00:00',4.24),('12664','2013-06-27','11:05:00',4.26),('12664','2013-06-27','11:10:00',4.25),('12664','2013-06-27','11:15:00',4.25),('12664','2013-06-27','11:20:00',2.3),('12664','2013-06-27','11:25:00',1.05),('12664','2013-06-27','11:30:00',1.08),('12664','2013-06-27','11:35:00',1.08),('12664','2013-06-27','11:40:00',1.14),('12664','2013-06-27','11:45:00',1.02),('12664','2013-06-27','11:50:00',1.07),('12664','2013-06-27','11:55:00',1.12),('12664','2013-06-27','12:00:00',1.16),('12664','2013-06-27','12:05:00',1.07),('12664','2013-06-27','12:10:00',1.07),('12664','2013-06-27','12:15:00',1.14),('12664','2013-06-27','12:20:00',1.06),('12664','2013-06-27','12:25:00',1.02),('12664','2013-06-27','12:30:00',1.07),('12664','2013-06-27','12:35:00',1.18),('12664','2013-06-27','12:40:00',1.26),('12664','2013-06-27','12:45:00',1.4),('12664','2013-06-27','12:50:00',1.47),('12664','2013-06-27','12:55:00',1.61),('12664','2013-06-27','13:00:00',2.99),('12664','2013-06-27','13:05:00',5.03),('12664','2013-06-27','13:10:00',2.4),('12664','2013-06-27','13:15:00',2.64),('12664','2013-06-27','13:20:00',2.08),('12664','2013-06-27','13:25:00',3.95),('12664','2013-06-27','13:30:00',4.56),('12664','2013-06-27','13:35:00',3.61),('12664','2013-06-27','13:40:00',2.69),('12664','2013-06-27','13:45:00',3.36),('12664','2013-06-27','13:50:00',4.49),('12664','2013-06-27','13:55:00',4.46),('12664','2013-06-27','14:00:00',4.34),('12664','2013-06-27','14:05:00',4.31),('12664','2013-06-27','14:10:00',4.3),('12664','2013-06-27','14:15:00',4.3),('12664','2013-06-27','14:20:00',4.29),('12664','2013-06-27','14:25:00',3.68),('12664','2013-06-27','14:30:00',3.87),('12664','2013-06-27','14:35:00',4.27),('12664','2013-06-27','14:40:00',4.18),('12664','2013-06-27','14:45:00',4.08),('12664','2013-06-27','14:50:00',4.01),('12664','2013-06-27','14:55:00',3.97),('12664','2013-06-27','15:00:00',3.99),('12664','2013-06-27','15:05:00',3.93),('12664','2013-06-27','15:10:00',3.94),('12664','2013-06-27','15:15:00',3.91),('12664','2013-06-27','15:20:00',3.9),('12664','2013-06-27','15:25:00',3.87),('12664','2013-06-27','15:30:00',3.81),('12664','2013-06-27','15:35:00',3.73),('12664','2013-06-27','15:40:00',3.63),('12664','2013-06-27','15:45:00',3.59),('12664','2013-06-27','15:50:00',3.52),('12664','2013-06-27','15:55:00',3.45),('12664','2013-06-27','16:00:00',3.4),('12664','2013-06-27','16:05:00',3.36),('12664','2013-06-27','16:10:00',3.33),('12664','2013-06-27','16:15:00',3.24),('12664','2013-06-27','16:20:00',3.21),('12664','2013-06-27','16:25:00',3.14),('12664','2013-06-27','16:30:00',2.98),('12664','2013-06-27','16:35:00',2.95),('12664','2013-06-27','16:40:00',2.94),('12664','2013-06-27','16:45:00',2.83),('12664','2013-06-27','16:50:00',2.77),('12664','2013-06-27','16:55:00',2.71),('12664','2013-06-27','17:00:00',2.6),('12664','2013-06-27','17:05:00',2.49),('12664','2013-06-27','17:10:00',2.38),('12664','2013-06-27','17:15:00',2.43),('12664','2013-06-27','17:20:00',2.34),('12664','2013-06-27','17:25:00',2.32),('12664','2013-06-27','17:30:00',2.23),('12664','2013-06-27','17:35:00',2.14),('12664','2013-06-27','17:40:00',2.01),('12664','2013-06-27','17:45:00',1.95),('12664','2013-06-27','17:50:00',1.87),('12664','2013-06-27','17:55:00',1.79),('12664','2013-06-27','18:00:00',1.72),('12664','2013-06-27','18:05:00',1.64),('12664','2013-06-27','18:10:00',1.52),('12664','2013-06-27','18:15:00',1.37),('12664','2013-06-27','18:20:00',1.3),('12664','2013-06-27','18:25:00',1.16),('12664','2013-06-27','18:30:00',1.07),('12664','2013-06-26','07:40:00',1.09),('12664','2013-06-26','07:45:00',1.18),('12664','2013-06-26','07:50:00',1.25),('12664','2013-06-26','07:55:00',1.34),('12664','2013-06-26','08:00:00',1.44),('12664','2013-06-26','08:05:00',1.54),('12664','2013-06-26','08:10:00',1.63),('12664','2013-06-26','08:15:00',1.72),('12664','2013-06-26','08:20:00',1.82),('12664','2013-06-26','08:25:00',1.9),('12664','2013-06-26','08:30:00',1.98),('12664','2013-06-26','08:35:00',2.07),('12664','2013-06-26','08:40:00',2.16),('12664','2013-06-26','08:45:00',2.23),('12664','2013-06-26','08:50:00',2.33),('12664','2013-06-26','08:55:00',2.41),('12664','2013-06-26','09:00:00',2.48),('12664','2013-06-26','09:05:00',2.53),('12664','2013-06-26','09:10:00',2.6),('12664','2013-06-26','09:15:00',2.69),('12664','2013-06-26','09:20:00',2.77),('12664','2013-06-26','09:25:00',2.83),('12664','2013-06-26','09:30:00',2.9),('12664','2013-06-26','09:35:00',2.96),('12664','2013-06-26','09:40:00',3),('12664','2013-06-26','09:45:00',3.07),('12664','2013-06-26','09:50:00',3.13),('12664','2013-06-26','09:55:00',3.18),('12664','2013-06-26','10:00:00',3.25),('12664','2013-06-26','10:05:00',3.34),('12664','2013-06-26','10:10:00',3.39),('12664','2013-06-26','10:15:00',3.44),('12664','2013-06-26','10:20:00',3.48),('12664','2013-06-26','10:25:00',3.53),('12664','2013-06-26','10:30:00',3.55),('12664','2013-06-26','10:35:00',3.6),('12664','2013-06-26','10:40:00',3.68),('12664','2013-06-26','10:45:00',3.71),('12664','2013-06-26','10:50:00',3.77),('12664','2013-06-26','10:55:00',3.8),('12664','2013-06-26','11:00:00',3.84),('12664','2013-06-26','11:05:00',3.86),('12664','2013-06-26','11:10:00',3.9),('12664','2013-06-26','11:15:00',3.91),('12664','2013-06-26','11:20:00',3.97),('12664','2013-06-26','11:25:00',4),('12664','2013-06-26','11:30:00',4.01),('12664','2013-06-26','11:35:00',4.06),('12664','2013-06-26','11:40:00',4.09),('12664','2013-06-26','11:45:00',4.13),('12664','2013-06-26','11:50:00',4.14),('12664','2013-06-26','11:55:00',4.16),('12664','2013-06-26','12:00:00',4.16),('12664','2013-06-26','12:05:00',4.17),('12664','2013-06-26','12:10:00',4.2),('12664','2013-06-26','12:15:00',4.19),('12664','2013-06-26','12:20:00',2.28),('12664','2013-06-26','12:25:00',4.21),('12664','2013-06-26','12:30:00',4.4),('12664','2013-06-26','12:35:00',4.46),('12664','2013-06-26','12:40:00',4.03),('12664','2013-06-26','12:45:00',1.83),('12664','2013-06-26','12:50:00',3.71),('12664','2013-06-26','12:55:00',2.96),('12664','2013-06-26','13:00:00',1.84),('12664','2013-06-26','13:05:00',1.08),('12664','2013-06-26','13:10:00',1.41),('12664','2013-06-26','13:15:00',2.63),('12664','2013-06-26','13:20:00',1.16),('12664','2013-06-26','13:25:00',1.55),('12664','2013-06-26','13:30:00',4.81),('12664','2013-06-26','13:35:00',4.7),('12664','2013-06-26','13:40:00',4.61),('12664','2013-06-26','13:45:00',4.54),('12664','2013-06-26','13:50:00',4.39),('12664','2013-06-26','13:55:00',4.34),('12664','2013-06-26','14:00:00',4.3),('12664','2013-06-26','14:05:00',4.28),('12664','2013-06-26','14:10:00',4.31),('12664','2013-06-26','14:15:00',4.3),('12664','2013-06-26','14:20:00',4.24),('12664','2013-06-26','14:25:00',4.23),('12664','2013-06-26','14:30:00',4.2),('12664','2013-06-26','14:35:00',4.19),('12664','2013-06-26','14:40:00',4.17),('12664','2013-06-26','14:45:00',4.15),('12664','2013-06-26','14:50:00',4.12),('12664','2013-06-26','14:55:00',4.08),('12664','2013-06-26','15:00:00',4.06),('12664','2013-06-26','15:05:00',4.01),('12664','2013-06-26','15:10:00',3.97),('12664','2013-06-26','15:15:00',3.92),('12664','2013-06-26','15:20:00',3.88),('12664','2013-06-26','15:25:00',3.83),('12664','2013-06-26','15:30:00',3.78),('12664','2013-06-26','15:35:00',3.72),('12664','2013-06-26','15:40:00',3.68),('12664','2013-06-26','15:45:00',3.63),('12664','2013-06-26','15:50:00',3.61),('12664','2013-06-26','15:55:00',3.56),('12664','2013-06-26','16:00:00',3.49),('12664','2013-06-26','16:05:00',3.41),('12664','2013-06-26','16:10:00',3.36),('12664','2013-06-26','16:15:00',3.3),('12664','2013-06-26','16:20:00',3.24),('12664','2013-06-26','16:25:00',3.17),('12664','2013-06-26','16:30:00',3.1),('12664','2013-06-26','16:35:00',3.02),('12664','2013-06-26','16:40:00',2.95),('12664','2013-06-26','16:45:00',2.88),('12664','2013-06-26','16:50:00',2.82),('12664','2013-06-26','16:55:00',2.75),('12664','2013-06-26','17:00:00',2.66),('12664','2013-06-26','17:05:00',2.59),('12664','2013-06-26','17:10:00',2.51),('12664','2013-06-26','17:15:00',2.43),('12664','2013-06-26','17:20:00',2.35),('12664','2013-06-26','17:25:00',2.27),('12664','2013-06-26','17:30:00',2.2),('12664','2013-06-26','17:35:00',2.13),('12664','2013-06-26','17:40:00',2.02),('12664','2013-06-26','17:45:00',1.95),('12664','2013-06-26','17:50:00',1.86),('12664','2013-06-26','17:55:00',1.76),('12664','2013-06-26','18:00:00',1.64),('12664','2013-06-26','18:05:00',1.55),('12664','2013-06-26','18:10:00',1.44),('12664','2013-06-26','18:15:00',1.22),('12664','2013-06-26','18:25:00',1.22),('12664','2013-06-26','18:30:00',1.38),('12664','2013-06-26','18:35:00',1.04),('12664','2013-06-26','18:40:00',1.07),('12664','2013-06-25','07:50:00',1.22),('12664','2013-06-25','07:55:00',1.5),('12664','2013-06-25','08:00:00',1.52),('12664','2013-06-25','08:05:00',1.6),('12664','2013-06-25','08:10:00',1.71),('12664','2013-06-25','08:15:00',1.77),('12664','2013-06-25','08:20:00',1.83),('12664','2013-06-25','08:25:00',1.95),('12664','2013-06-25','08:30:00',2.02),('12664','2013-06-25','08:35:00',2.09),('12664','2013-06-25','08:40:00',2.19),('12664','2013-06-25','08:45:00',2.17),('12664','2013-06-25','08:50:00',1.87),('12664','2013-06-25','08:55:00',2.43),('12664','2013-06-25','09:00:00',2.56),('12664','2013-06-25','09:05:00',2.61),('12664','2013-06-25','09:10:00',2.65),('12664','2013-06-25','09:15:00',2.75),('12664','2013-06-25','09:20:00',2.83),('12664','2013-06-25','09:25:00',2.92),('12664','2013-06-25','09:30:00',2.99),('12664','2013-06-25','09:35:00',3.08),('12664','2013-06-25','09:40:00',3.16),('12664','2013-06-25','09:45:00',3.18),('12664','2013-06-25','09:50:00',3.29),('12664','2013-06-25','09:55:00',1.24),('12664','2013-06-25','10:05:00',2.3),('12664','2013-06-25','10:10:00',3.52),('12664','2013-06-25','10:15:00',1.02),('12664','2013-06-25','10:30:00',1.45),('12664','2013-06-25','10:35:00',4.14),('12664','2013-06-25','10:40:00',3.95),('12664','2013-06-25','10:45:00',4.01),('12664','2013-06-25','10:50:00',4.07),('12664','2013-06-25','10:55:00',4.03),('12664','2013-06-25','11:00:00',4.08),('12664','2013-06-25','11:05:00',4.17),('12664','2013-06-25','11:10:00',3.97),('12664','2013-06-25','11:15:00',4.47),('12664','2013-06-25','11:20:00',1.52),('12664','2013-06-25','11:25:00',1.36),('12664','2013-06-25','11:30:00',1.43),('12664','2013-06-25','11:35:00',1.62),('12664','2013-06-25','11:40:00',2.43),('12664','2013-06-25','11:45:00',4.67),('12664','2013-06-25','11:50:00',4.39),('12664','2013-06-25','11:55:00',2.69),('12664','2013-06-25','12:00:00',3.17),('12664','2013-06-25','12:05:00',3.88),('12664','2013-06-25','12:10:00',3.17),('12664','2013-06-25','12:15:00',4.71),('12664','2013-06-25','12:20:00',4.6),('12664','2013-06-25','12:25:00',4.49),('12664','2013-06-25','12:30:00',4.52),('12664','2013-06-25','12:35:00',4.5),('12664','2013-06-25','12:40:00',3.05),('12664','2013-06-25','12:45:00',4.61),('12664','2013-06-25','12:50:00',4.7),('12664','2013-06-25','12:55:00',4.62),('12664','2013-06-25','13:00:00',4.55),('12664','2013-06-25','13:05:00',4.45),('12664','2013-06-25','13:10:00',4.41),('12664','2013-06-25','13:15:00',4.44),('12664','2013-06-25','13:20:00',4.45),('12664','2013-06-25','13:25:00',4.43),('12664','2013-06-25','13:30:00',4.45),('12664','2013-06-25','13:35:00',4.44),('12664','2013-06-25','13:40:00',4.39),('12664','2013-06-25','13:45:00',4.39),('12664','2013-06-25','13:50:00',4.37),('12664','2013-06-25','13:55:00',4.34),('12664','2013-06-25','14:00:00',4.33),('12664','2013-06-25','14:05:00',4.28),('12664','2013-06-25','14:10:00',4.3),('12664','2013-06-25','14:15:00',4.27),('12664','2013-06-25','14:20:00',4.28),('12664','2013-06-25','14:25:00',4.25),('12664','2013-06-25','14:30:00',4.2),('12664','2013-06-25','14:35:00',4.18),('12664','2013-06-25','14:40:00',4.18),('12664','2013-06-25','14:45:00',4.1),('12664','2013-06-25','14:50:00',4.13),('12664','2013-06-25','14:55:00',4.04),('12664','2013-06-25','15:00:00',4.04),('12664','2013-06-25','15:05:00',4.01),('12664','2013-06-25','15:10:00',3.99),('12664','2013-06-25','15:15:00',3.94),('12664','2013-06-25','15:20:00',3.88),('12664','2013-06-25','15:25:00',3.83),('12664','2013-06-25','15:30:00',3.79),('12664','2013-06-25','15:35:00',3.72),('12664','2013-06-25','15:40:00',3.65),('12664','2013-06-25','15:45:00',3.6),('12664','2013-06-25','15:50:00',3.55),('12664','2013-06-25','15:55:00',3.49),('12664','2013-06-25','16:00:00',3.45),('12664','2013-06-25','16:05:00',3.39),('12664','2013-06-25','16:10:00',3.33),('12664','2013-06-25','16:15:00',3.27),('12664','2013-06-25','16:20:00',3.22),('12664','2013-06-25','16:25:00',3.15),('12664','2013-06-25','16:30:00',3.06),('12664','2013-06-25','16:35:00',3.01),('12664','2013-06-25','16:40:00',2.93),('12664','2013-06-25','16:45:00',2.87),('12664','2013-06-25','16:50:00',2.8),('12664','2013-06-25','16:55:00',2.73),('12664','2013-06-25','17:00:00',2.65),('12664','2013-06-25','17:05:00',2.58),('12664','2013-06-25','17:10:00',2.49),('12664','2013-06-25','17:15:00',2.42),('12664','2013-06-25','17:20:00',2.34),('12664','2013-06-25','17:25:00',2.25),('12664','2013-06-25','17:30:00',2.17),('12664','2013-06-25','17:35:00',2.08),('12664','2013-06-25','17:40:00',2),('12664','2013-06-25','17:45:00',1.93),('12664','2013-06-25','17:50:00',1.83),('12664','2013-06-25','17:55:00',1.73),('12664','2013-06-25','18:00:00',1.64),('12664','2013-06-25','18:05:00',1.56),('12664','2013-06-25','18:10:00',1.46),('12664','2013-06-25','18:15:00',1.38),('12664','2013-06-25','18:20:00',1.29),('12664','2013-06-25','18:25:00',1.22),('12664','2013-06-25','18:30:00',1.13),('12664','2013-06-25','18:35:00',1.04),('12664','2013-06-24','08:10:00',1.57),('12664','2013-06-24','08:15:00',2.03),('12664','2013-06-24','08:20:00',1.49),('12664','2013-06-24','08:25:00',1.72),('12664','2013-06-24','08:30:00',1.41),('12664','2013-06-24','08:40:00',2.24),('12664','2013-06-24','08:45:00',2.2),('12664','2013-06-24','08:50:00',2.63),('12664','2013-06-24','08:55:00',1.59),('12664','2013-06-24','09:00:00',2.82),('12664','2013-06-24','09:05:00',2.97),('12664','2013-06-24','09:10:00',2.64),('12664','2013-06-24','09:15:00',3.05),('12664','2013-06-24','09:20:00',2.57),('12664','2013-06-24','09:25:00',1.19),('12664','2013-06-24','09:30:00',2.98),('12664','2013-06-24','09:35:00',3.27),('12664','2013-06-24','09:40:00',3.53),('12664','2013-06-24','09:45:00',2.59),('12664','2013-06-24','09:50:00',2.61),('12664','2013-06-24','09:55:00',3.52),('12664','2013-06-24','10:00:00',3.68),('12664','2013-06-24','10:05:00',3.32),('12664','2013-06-24','10:10:00',3.77),('12664','2013-06-24','10:15:00',3.79),('12664','2013-06-24','10:20:00',3.93),('12664','2013-06-24','10:25:00',3.04),('12664','2013-06-24','10:30:00',4.09),('12664','2013-06-24','10:35:00',3.1),('12664','2013-06-24','10:40:00',4.32),('12664','2013-06-24','10:45:00',3.82),('12664','2013-06-24','10:50:00',2.25),('12664','2013-06-24','10:55:00',2.65),('12664','2013-06-24','11:00:00',2.28),('12664','2013-06-24','11:05:00',1.96),('12664','2013-06-24','11:10:00',4.98),('12664','2013-06-24','11:15:00',1.21),('12664','2013-06-24','11:20:00',2.5),('12664','2013-06-24','11:25:00',1.34),('12664','2013-06-24','11:30:00',1.36),('12664','2013-06-24','11:35:00',2.2),('12664','2013-06-24','11:40:00',2.57),('12664','2013-06-24','11:45:00',1.7),('12664','2013-06-24','11:50:00',2.32),('12664','2013-06-24','11:55:00',2.98),('12664','2013-06-24','12:00:00',2.16),('12664','2013-06-24','12:05:00',4.07),('12664','2013-06-24','12:10:00',4.71),('12664','2013-06-24','12:15:00',2.84),('12664','2013-06-24','12:20:00',4.08),('12664','2013-06-24','12:25:00',2.82),('12664','2013-06-24','12:30:00',3.05),('12664','2013-06-24','12:35:00',3.7),('12664','2013-06-24','12:40:00',4.37),('12664','2013-06-24','12:45:00',3.73),('12664','2013-06-24','12:50:00',4.06),('12664','2013-06-24','12:55:00',4.31),('12664','2013-06-24','13:00:00',4.1),('12664','2013-06-24','13:05:00',3.56),('12664','2013-06-24','13:10:00',4.2),('12664','2013-06-24','13:15:00',4.34),('12664','2013-06-24','13:20:00',3.73),('12664','2013-06-24','13:25:00',2.56),('12664','2013-06-24','13:30:00',3.48),('12664','2013-06-24','13:35:00',4.52),('12664','2013-06-24','13:40:00',4.56),('12664','2013-06-24','13:45:00',4.64),('12664','2013-06-24','13:50:00',4.82),('12664','2013-06-24','13:55:00',4.05),('12664','2013-06-24','14:00:00',4.49),('12664','2013-06-24','14:05:00',4.58),('12664','2013-06-24','14:10:00',4.28),('12664','2013-06-24','14:15:00',4.43),('12664','2013-06-24','14:20:00',4.61),('12664','2013-06-24','14:25:00',4.72),('12664','2013-06-24','14:30:00',4.49),('12664','2013-06-24','14:35:00',3.41),('12664','2013-06-24','14:40:00',3.14),('12664','2013-06-24','14:45:00',2.81),('12664','2013-06-24','14:50:00',2.54),('12664','2013-06-24','14:55:00',2.65),('12664','2013-06-24','15:00:00',2.49),('12664','2013-06-24','15:05:00',3.82),('12664','2013-06-24','15:10:00',4.45),('12664','2013-06-24','15:15:00',3.62),('12664','2013-06-24','15:20:00',3.8),('12664','2013-06-24','15:25:00',3.21),('12664','2013-06-24','15:30:00',3.46),('12664','2013-06-24','15:35:00',4.24),('12664','2013-06-24','15:40:00',3.02),('12664','2013-06-24','15:45:00',3.12),('12664','2013-06-24','15:50:00',4.07),('12664','2013-06-24','15:55:00',2.46),('12664','2013-06-24','16:00:00',2.4),('12664','2013-06-24','16:05:00',3.55),('12664','2013-06-24','16:10:00',3.13),('12664','2013-06-24','16:15:00',3.64),('12664','2013-06-24','16:20:00',2.45),('12664','2013-06-24','16:25:00',2.61),('12664','2013-06-24','16:30:00',2.53),('12664','2013-06-24','16:35:00',1.89),('12664','2013-06-24','16:40:00',1.79),('12664','2013-06-24','16:45:00',2.42),('12664','2013-06-24','16:50:00',1.35),('12664','2013-06-24','16:55:00',1.35),('12664','2013-06-24','17:00:00',1.7),('12664','2013-06-24','17:05:00',2.34),('12664','2013-06-24','17:10:00',2.12),('12664','2013-06-24','17:15:00',2.66),('12664','2013-06-24','17:20:00',1.35),('12664','2013-06-24','17:25:00',1.33),('12664','2013-06-24','17:30:00',1.73),('12664','2013-06-24','17:45:00',1.4),('12664','2013-06-24','17:50:00',1.23),('12664','2013-06-24','17:55:00',1.17),('12664','2013-06-24','18:05:00',1.71),('12664','2013-06-24','18:10:00',1.15),('12664','2013-06-24','18:20:00',1.36),('12664','2013-06-24','18:25:00',1.23),('12664','2013-06-24','18:30:00',1.3),('12664','2013-06-24','18:35:00',1.12),('12664','2013-06-23','08:50:00',1.28),('12664','2013-06-23','08:55:00',1.1),('12664','2013-06-23','09:00:00',1.07),('12664','2013-06-23','09:10:00',2.04),('12664','2013-06-23','09:15:00',2.78),('12664','2013-06-23','09:20:00',2.95),('12664','2013-06-23','09:25:00',2.97),('12664','2013-06-23','09:30:00',3.03),('12664','2013-06-23','09:35:00',3.26),('12664','2013-06-23','09:40:00',2.94),('12664','2013-06-23','09:45:00',3.3),('12664','2013-06-23','09:50:00',3.18),('12664','2013-06-23','09:55:00',2.94),('12664','2013-06-23','10:00:00',3.38),('12664','2013-06-23','10:05:00',3.3),('12664','2013-06-23','10:10:00',3.35),('12664','2013-06-23','10:15:00',3.39),('12664','2013-06-23','10:20:00',3.53),('12664','2013-06-23','10:25:00',3.61),('12664','2013-06-23','10:30:00',3.61),('12664','2013-06-23','10:35:00',3.58),('12664','2013-06-23','10:40:00',3.64),('12664','2013-06-23','10:45:00',3.72),('12664','2013-06-23','10:50:00',3.72),('12664','2013-06-23','10:55:00',3.77),('12664','2013-06-23','11:00:00',3.77),('12664','2013-06-23','11:05:00',3.77),('12664','2013-06-23','11:10:00',3.9),('12664','2013-06-23','11:15:00',3.9),('12664','2013-06-23','11:20:00',3.96),('12664','2013-06-23','11:25:00',3.89),('12664','2013-06-23','11:30:00',3.98),('12664','2013-06-23','11:35:00',4.07),('12664','2013-06-23','11:40:00',4.01),('12664','2013-06-23','11:45:00',4.12),('12664','2013-06-23','11:50:00',4.22),('12664','2013-06-23','11:55:00',4.15),('12664','2013-06-23','12:00:00',4.24),('12664','2013-06-23','12:05:00',4.26),('12664','2013-06-23','12:10:00',4.24),('12664','2013-06-23','12:15:00',4.27),('12664','2013-06-23','12:20:00',4.31),('12664','2013-06-23','12:25:00',4.35),('12664','2013-06-23','12:30:00',4.36),('12664','2013-06-23','12:35:00',4.38),('12664','2013-06-23','12:40:00',4.35),('12664','2013-06-23','12:45:00',4.34),('12664','2013-06-23','12:50:00',4.39),('12664','2013-06-23','12:55:00',4.41),('12664','2013-06-23','13:00:00',4.4),('12664','2013-06-23','13:05:00',4.41),('12664','2013-06-23','13:10:00',4.41),('12664','2013-06-23','13:15:00',4.41),('12664','2013-06-23','13:20:00',4.42),('12664','2013-06-23','13:25:00',4.43),('12664','2013-06-23','13:30:00',4.45),('12664','2013-06-23','13:35:00',4.44),('12664','2013-06-23','13:40:00',4.46),('12664','2013-06-23','13:45:00',4.46),('12664','2013-06-23','13:50:00',4.46),('12664','2013-06-23','13:55:00',4.46),('12664','2013-06-23','14:00:00',4.44),('12664','2013-06-23','14:05:00',4.42),('12664','2013-06-23','14:10:00',4.4),('12664','2013-06-23','14:15:00',4.38),('12664','2013-06-23','14:20:00',4.37),('12664','2013-06-23','14:25:00',4.33),('12664','2013-06-23','14:30:00',4.28),('12664','2013-06-23','14:35:00',4.28),('12664','2013-06-23','14:40:00',4.05),('12664','2013-06-23','14:45:00',4.23),('12664','2013-06-23','14:50:00',4.16),('12664','2013-06-23','14:55:00',4.14),('12664','2013-06-23','15:00:00',4.07),('12664','2013-06-23','15:05:00',4.09),('12664','2013-06-23','15:10:00',3.96),('12664','2013-06-23','15:15:00',4.01),('12664','2013-06-23','15:20:00',3.92),('12664','2013-06-23','15:25:00',3.87),('12664','2013-06-23','15:30:00',3.85),('12664','2013-06-23','15:35:00',3.8),('12664','2013-06-23','15:40:00',3.75),('12664','2013-06-23','15:45:00',3.71),('12664','2013-06-23','15:50:00',3.67),('12664','2013-06-23','15:55:00',3.59),('12664','2013-06-23','16:00:00',3.55),('12664','2013-06-23','16:05:00',3.48),('12664','2013-06-23','16:10:00',3.41),('12664','2013-06-23','16:15:00',3.36),('12664','2013-06-23','16:20:00',3.3),('12664','2013-06-23','16:25:00',3.24),('12664','2013-06-23','16:30:00',3.17),('12664','2013-06-23','16:35:00',3.08),('12664','2013-06-23','16:40:00',3.03),('12664','2013-06-23','16:45:00',2.95),('12664','2013-06-23','16:50:00',2.89),('12664','2013-06-23','16:55:00',2.82),('12664','2013-06-23','17:00:00',2.75),('12664','2013-06-23','17:05:00',2.72),('12664','2013-06-23','17:10:00',2.7),('12664','2013-06-23','17:15:00',2.48),('12664','2013-06-23','17:20:00',2.33),('12664','2013-06-23','17:25:00',2.32),('12664','2013-06-23','17:30:00',2.26),('12664','2013-06-23','17:35:00',2.13),('12664','2013-06-23','17:40:00',2.09),('12664','2013-06-23','17:45:00',1.27),('12664','2013-06-23','17:50:00',1.83),('12664','2013-06-23','17:55:00',1.9),('12664','2013-06-23','18:00:00',1.75),('12664','2013-06-23','18:05:00',1.64),('12664','2013-06-23','18:10:00',1.56),('12664','2013-06-23','18:15:00',1.44),('12664','2013-06-23','18:20:00',1.34),('12664','2013-06-23','18:25:00',1.24),('12664','2013-06-23','18:30:00',1.16),('12664','2013-06-23','18:35:00',1.07),('12664','2013-06-22','07:40:00',1.01),('12664','2013-06-22','07:45:00',1.09),('12664','2013-06-22','07:50:00',1.16),('12664','2013-06-22','07:55:00',1.28),('12664','2013-06-22','08:00:00',1.36),('12664','2013-06-22','08:05:00',1.43),('12664','2013-06-22','08:10:00',1.55),('12664','2013-06-22','08:15:00',1.63),('12664','2013-06-22','08:20:00',1.7),('12664','2013-06-22','08:25:00',1.81),('12664','2013-06-22','08:30:00',1.82),('12664','2013-06-22','08:35:00',1.94),('12664','2013-06-22','08:40:00',2.06),('12664','2013-06-22','08:45:00',2.16),('12664','2013-06-22','08:50:00',2.19),('12664','2013-06-22','08:55:00',2.27),('12664','2013-06-22','09:00:00',2.36),('12664','2013-06-22','09:05:00',2.43),('12664','2013-06-22','09:10:00',2.54),('12664','2013-06-22','09:15:00',2.59),('12664','2013-06-22','09:20:00',2.7),('12664','2013-06-22','09:25:00',2.78),('12664','2013-06-22','09:30:00',2.82),('12664','2013-06-22','09:35:00',2.91),('12664','2013-06-22','09:40:00',2.93),('12664','2013-06-22','09:45:00',3.03),('12664','2013-06-22','09:50:00',3.09),('12664','2013-06-22','09:55:00',3.17),('12664','2013-06-22','10:00:00',3.24),('12664','2013-06-22','10:05:00',3.29),('12664','2013-06-22','10:10:00',3.38),('12664','2013-06-22','10:15:00',3.44),('12664','2013-06-22','10:20:00',3.45),('12664','2013-06-22','10:25:00',3.5),('12664','2013-06-22','10:30:00',3.55),('12664','2013-06-22','10:35:00',3.63),('12664','2013-06-22','10:40:00',3.68),('12664','2013-06-22','10:45:00',3.71),('12664','2013-06-22','10:50:00',3.75),('12664','2013-06-22','10:55:00',3.79),('12664','2013-06-22','11:00:00',3.82),('12664','2013-06-22','11:05:00',3.84),('12664','2013-06-22','11:10:00',3.89),('12664','2013-06-22','11:15:00',3.92),('12664','2013-06-22','11:20:00',3.95),('12664','2013-06-22','11:25:00',3.97),('12664','2013-06-22','11:30:00',4),('12664','2013-06-22','11:35:00',4.05),('12664','2013-06-22','11:40:00',4.07),('12664','2013-06-22','11:45:00',4.1),('12664','2013-06-22','11:50:00',4.14),('12664','2013-06-22','11:55:00',4.11),('12664','2013-06-22','12:00:00',4.21),('12664','2013-06-22','12:05:00',4.22),('12664','2013-06-22','12:10:00',4.23),('12664','2013-06-22','12:15:00',4.24),('12664','2013-06-22','12:20:00',4.23),('12664','2013-06-22','12:25:00',4.23),('12664','2013-06-22','12:30:00',4.18),('12664','2013-06-22','12:35:00',4.22),('12664','2013-06-22','12:40:00',4.23),('12664','2013-06-22','12:45:00',4.17),('12664','2013-06-22','12:50:00',4.14),('12664','2013-06-22','12:55:00',4.12),('12664','2013-06-22','13:00:00',4.1),('12664','2013-06-22','13:05:00',4.21),('12664','2013-06-22','13:10:00',4.23),('12664','2013-06-22','13:15:00',4.25),('12664','2013-06-22','13:20:00',4.35),('12664','2013-06-22','13:25:00',4.44),('12664','2013-06-22','13:30:00',4.47),('12664','2013-06-22','13:35:00',4.36),('12664','2013-06-22','13:40:00',3.91),('12664','2013-06-22','13:45:00',4.03),('12664','2013-06-22','13:50:00',3.2),('12664','2013-06-22','13:55:00',4.5),('12664','2013-06-22','14:00:00',4.55),('12664','2013-06-22','14:05:00',4.58),('12664','2013-06-22','14:10:00',4.22),('12664','2013-06-22','14:15:00',2.53),('12664','2013-06-22','14:20:00',3.04),('12664','2013-06-22','14:25:00',3.42),('12664','2013-06-22','14:30:00',2.05),('12664','2013-06-22','14:35:00',2.28),('12664','2013-06-22','14:40:00',3.19),('12664','2013-06-22','14:45:00',3.74),('12664','2013-06-22','14:50:00',4.46),('12664','2013-06-22','14:55:00',4.01),('12664','2013-06-22','15:00:00',4.25),('12664','2013-06-22','15:05:00',3.89),('12664','2013-06-22','15:10:00',3.77),('12664','2013-06-22','15:15:00',4.02),('12664','2013-06-22','15:20:00',3.9),('12664','2013-06-22','15:25:00',3.6),('12664','2013-06-22','15:30:00',3.25),('12664','2013-06-22','15:35:00',1.92),('12664','2013-06-22','15:40:00',1.37),('12664','2013-06-22','15:45:00',1.35),('12664','2013-06-22','15:50:00',1.6),('12664','2013-06-22','15:55:00',1.69),('12664','2013-06-22','16:00:00',1.37),('12664','2013-06-22','16:05:00',1.45),('12664','2013-06-22','16:10:00',1.55),('12664','2013-06-22','16:15:00',1.55),('12664','2013-06-22','16:20:00',1.42),('12664','2013-06-22','16:25:00',1.37),('12664','2013-06-22','16:30:00',1.22),('12664','2013-06-22','16:35:00',1.15),('12664','2013-06-22','16:40:00',1.05),('12664','2013-06-22','16:45:00',1.07),('12664','2013-06-22','16:50:00',1.38),('12664','2013-06-22','16:55:00',2.56),('12664','2013-06-22','17:00:00',3.09),('12664','2013-06-22','17:05:00',2.97),('12664','2013-06-22','17:10:00',2.73),('12664','2013-06-22','17:15:00',2.11),('12664','2013-06-22','17:20:00',2.52),('12664','2013-06-22','17:25:00',2.52),('12664','2013-06-22','17:30:00',2.16),('12664','2013-06-22','17:35:00',2.04),('12664','2013-06-22','17:40:00',1.98),('12664','2013-06-22','17:45:00',1.96),('12664','2013-06-22','17:50:00',1.69),('12664','2013-06-22','17:55:00',1.53),('12664','2013-06-22','18:00:00',1.4),('12664','2013-06-22','18:05:00',1.1),('12664','2013-06-21','07:40:00',1.02),('12664','2013-06-21','07:45:00',1.1),('12664','2013-06-21','07:50:00',1.18),('12664','2013-06-21','07:55:00',1.27),('12664','2013-06-21','08:00:00',1.36),('12664','2013-06-21','08:05:00',1.43),('12664','2013-06-21','08:10:00',1.51),('12664','2013-06-21','08:15:00',1.6),('12664','2013-06-21','08:20:00',1.69),('12664','2013-06-21','08:25:00',1.76),('12664','2013-06-21','08:30:00',1.83),('12664','2013-06-21','08:35:00',1.91),('12664','2013-06-21','08:40:00',1.98),('12664','2013-06-21','08:45:00',2.03),('12664','2013-06-21','08:50:00',2.03),('12664','2013-06-21','08:55:00',2.22),('12664','2013-06-21','09:00:00',2.28),('12664','2013-06-21','09:05:00',2.38),('12664','2013-06-21','09:10:00',2.45),('12664','2013-06-21','09:15:00',2.53),('12664','2013-06-21','09:20:00',2.6),('12664','2013-06-21','09:25:00',2.67),('12664','2013-06-21','09:30:00',2.73),('12664','2013-06-21','09:35:00',2.8),('12664','2013-06-21','09:40:00',2.71),('12664','2013-06-21','09:45:00',2.94),('12664','2013-06-21','09:50:00',3.01),('12664','2013-06-21','09:55:00',3.09),('12664','2013-06-21','10:00:00',3.12),('12664','2013-06-21','10:05:00',3.16),('12664','2013-06-21','10:10:00',3.2),('12664','2013-06-21','10:15:00',3.26),('12664','2013-06-21','10:20:00',3.33),('12664','2013-06-21','10:25:00',3.38),('12664','2013-06-21','10:30:00',3.4),('12664','2013-06-21','10:35:00',3.45),('12664','2013-06-21','10:40:00',3.54),('12664','2013-06-21','10:45:00',3.59),('12664','2013-06-21','10:50:00',3.63),('12664','2013-06-21','10:55:00',3.65),('12664','2013-06-21','11:00:00',3.67),('12664','2013-06-21','11:05:00',3.68),('12664','2013-06-21','11:10:00',3.74),('12664','2013-06-21','11:15:00',3.66),('12664','2013-06-21','11:20:00',3.71),('12664','2013-06-21','11:25:00',3.84),('12664','2013-06-21','11:30:00',3.84),('12664','2013-06-21','11:35:00',3.8),('12664','2013-06-21','11:40:00',3.83),('12664','2013-06-21','11:45:00',3.92),('12664','2013-06-21','11:50:00',3.95),('12664','2013-06-21','11:55:00',3.95),('12664','2013-06-21','12:00:00',4.02),('12664','2013-06-21','12:05:00',4.06),('12664','2013-06-21','12:10:00',4.11),('12664','2013-06-21','12:15:00',4.11),('12664','2013-06-21','12:20:00',4.11),('12664','2013-06-21','12:25:00',4.14),('12664','2013-06-21','12:30:00',4.17),('12664','2013-06-21','12:35:00',4.17),('12664','2013-06-21','12:40:00',4.16),('12664','2013-06-21','12:45:00',4.14),('12664','2013-06-21','12:50:00',4.18),('12664','2013-06-21','12:55:00',4.2),('12664','2013-06-21','13:00:00',4.2),('12664','2013-06-21','13:05:00',4.19),('12664','2013-06-21','13:10:00',4.18),('12664','2013-06-21','13:15:00',4.22),('12664','2013-06-21','13:20:00',4.23),('12664','2013-06-21','13:25:00',4.27),('12664','2013-06-21','13:30:00',4.27),('12664','2013-06-21','13:35:00',4.27),('12664','2013-06-21','13:40:00',4.25),('12664','2013-06-21','13:45:00',4.24),('12664','2013-06-21','13:50:00',4.22),('12664','2013-06-21','13:55:00',4.21),('12664','2013-06-21','14:00:00',4.21),('12664','2013-06-21','14:05:00',4.19),('12664','2013-06-21','14:10:00',4.21),('12664','2013-06-21','14:15:00',4.19),('12664','2013-06-21','14:20:00',4.16),('12664','2013-06-21','14:25:00',4.13),('12664','2013-06-21','14:30:00',4.11),('12664','2013-06-21','14:35:00',4.09),('12664','2013-06-21','14:40:00',4.06),('12664','2013-06-21','14:45:00',4.04),('12664','2013-06-21','14:50:00',4.01),('12664','2013-06-21','14:55:00',3.97),('12664','2013-06-21','15:00:00',3.93),('12664','2013-06-21','15:05:00',3.89),('12664','2013-06-21','15:10:00',3.86),('12664','2013-06-21','15:15:00',3.83),('12664','2013-06-21','15:20:00',3.78),('12664','2013-06-21','15:25:00',3.75),('12664','2013-06-21','15:30:00',3.67),('12664','2013-06-21','15:35:00',3.63),('12664','2013-06-21','15:40:00',3.6),('12664','2013-06-21','15:45:00',3.53),('12664','2013-06-21','15:50:00',3.48),('12664','2013-06-21','15:55:00',3.43),('12664','2013-06-21','16:00:00',3.38),('12664','2013-06-21','16:05:00',3.32),('12664','2013-06-21','16:10:00',3.25),('12664','2013-06-21','16:15:00',3.19),('12664','2013-06-21','16:20:00',3.12),('12664','2013-06-21','16:25:00',3.06),('12664','2013-06-21','16:30:00',3),('12664','2013-06-21','16:35:00',2.94),('12664','2013-06-21','16:40:00',2.88),('12664','2013-06-21','16:45:00',2.81),('12664','2013-06-21','16:50:00',2.74),('12664','2013-06-21','16:55:00',2.68),('12664','2013-06-21','17:00:00',2.61),('12664','2013-06-21','17:05:00',2.52),('12664','2013-06-21','17:10:00',2.44),('12664','2013-06-21','17:15:00',2.36),('12664','2013-06-21','17:20:00',2.28),('12664','2013-06-21','17:25:00',2.2),('12664','2013-06-21','17:30:00',2.12),('12664','2013-06-21','17:35:00',2.03),('12664','2013-06-21','17:40:00',1.96),('12664','2013-06-21','17:45:00',1.86),('12664','2013-06-21','17:50:00',1.78),('12664','2013-06-21','17:55:00',1.7),('12664','2013-06-21','18:00:00',1.62),('12664','2013-06-21','18:05:00',1.52),('12664','2013-06-21','18:10:00',1.43),('12664','2013-06-21','18:15:00',1.35),('12664','2013-06-21','18:20:00',1.26),('12664','2013-06-21','18:25:00',1.16),('12664','2013-06-21','18:30:00',1.07),('12664','2013-06-20','07:40:00',1.03),('12664','2013-06-20','07:45:00',1.12),('12664','2013-06-20','07:50:00',1.19),('12664','2013-06-20','07:55:00',1.29),('12664','2013-06-20','08:00:00',1.38),('12664','2013-06-20','08:05:00',1.46),('12664','2013-06-20','08:10:00',1.54),('12664','2013-06-20','08:15:00',1.64),('12664','2013-06-20','08:20:00',1.72),('12664','2013-06-20','08:25:00',1.81),('12664','2013-06-20','08:30:00',1.88),('12664','2013-06-20','08:35:00',1.95),('12664','2013-06-20','08:40:00',2.02),('12664','2013-06-20','08:45:00',2.11),('12664','2013-06-20','08:50:00',2.2),('12664','2013-06-20','08:55:00',2.27),('12664','2013-06-20','09:00:00',2.35),('12664','2013-06-20','09:05:00',2.43),('12664','2013-06-20','09:10:00',2.51),('12664','2013-06-20','09:15:00',2.59),('12664','2013-06-20','09:20:00',2.65),('12664','2013-06-20','09:25:00',2.72),('12664','2013-06-20','09:30:00',2.78),('12664','2013-06-20','09:35:00',2.83),('12664','2013-06-20','09:40:00',2.92),('12664','2013-06-20','09:45:00',2.99),('12664','2013-06-20','09:50:00',3.05),('12664','2013-06-20','09:55:00',3.08),('12664','2013-06-20','10:00:00',3.14),('12664','2013-06-20','10:05:00',3.23),('12664','2013-06-20','10:10:00',3.27),('12664','2013-06-20','10:15:00',3.33),('12664','2013-06-20','10:20:00',3.38),('12664','2013-06-20','10:25:00',3.41),('12664','2013-06-20','10:30:00',3.46),('12664','2013-06-20','10:35:00',3.49),('12664','2013-06-20','10:40:00',3.52),('12664','2013-06-20','10:45:00',3.52),('12664','2013-06-20','10:50:00',3.58),('12664','2013-06-20','10:55:00',3.62),('12664','2013-06-20','11:00:00',3.64),('12664','2013-06-20','11:05:00',3.7),('12664','2013-06-20','11:10:00',3.74),('12664','2013-06-20','11:15:00',3.7),('12664','2013-06-20','11:20:00',3.75),('12664','2013-06-20','11:25:00',3.63),('12664','2013-06-20','11:30:00',3.86),('12664','2013-06-20','11:35:00',3.9),('12664','2013-06-20','11:40:00',3.86),('12664','2013-06-20','11:45:00',3.82),('12664','2013-06-20','11:50:00',3.98),('12664','2013-06-20','11:55:00',4.03),('12664','2013-06-20','12:00:00',4.05),('12664','2013-06-20','12:05:00',4.09),('12664','2013-06-20','12:10:00',4.11),('12664','2013-06-20','12:15:00',4.07),('12664','2013-06-20','12:20:00',4.11),('12664','2013-06-20','12:25:00',4.07),('12664','2013-06-20','12:30:00',3.99),('12664','2013-06-20','12:35:00',3.98),('12664','2013-06-20','12:40:00',4),('12664','2013-06-20','12:45:00',3.97),('12664','2013-06-20','12:50:00',3.98),('12664','2013-06-20','12:55:00',4.07),('12664','2013-06-20','13:00:00',4.13),('12664','2013-06-20','13:05:00',4.23),('12664','2013-06-20','13:10:00',4.29),('12664','2013-06-20','13:15:00',4.25),('12664','2013-06-20','13:20:00',4.23),('12664','2013-06-20','13:25:00',4.26),('12664','2013-06-20','13:30:00',4.29),('12664','2013-06-20','13:35:00',4.29),('12664','2013-06-20','13:40:00',4.3),('12664','2013-06-20','13:45:00',4.29),('12664','2013-06-20','13:50:00',4.27),('12664','2013-06-20','13:55:00',4.29),('12664','2013-06-20','14:00:00',4.32),('12664','2013-06-20','14:05:00',4.31),('12664','2013-06-20','14:10:00',4.26),('12664','2013-06-20','14:15:00',4.26),('12664','2013-06-20','14:20:00',4.25),('12664','2013-06-20','14:25:00',4.23),('12664','2013-06-20','14:30:00',4.22),('12664','2013-06-20','14:35:00',4.2),('12664','2013-06-20','14:40:00',4.16),('12664','2013-06-20','14:45:00',4.12),('12664','2013-06-20','14:50:00',4.09),('12664','2013-06-20','14:55:00',4.05),('12664','2013-06-20','15:00:00',4.01),('12664','2013-06-20','15:05:00',3.97),('12664','2013-06-20','15:10:00',3.93),('12664','2013-06-20','15:15:00',3.89),('12664','2013-06-20','15:20:00',3.83),('12664','2013-06-20','15:25:00',3.77),('12664','2013-06-20','15:30:00',3.72),('12664','2013-06-20','15:35:00',3.69),('12664','2013-06-20','15:40:00',3.65),('12664','2013-06-20','15:45:00',3.59),('12664','2013-06-20','15:50:00',3.53),('12664','2013-06-20','15:55:00',3.48),('12664','2013-06-20','16:00:00',3.43),('12664','2013-06-20','16:05:00',3.37),('12664','2013-06-20','16:10:00',3.32),('12664','2013-06-20','16:15:00',3.25),('12664','2013-06-20','16:20:00',3.19),('12664','2013-06-20','16:25:00',3.13),('12664','2013-06-20','16:30:00',3.06),('12664','2013-06-20','16:35:00',2.99),('12664','2013-06-20','16:40:00',2.91),('12664','2013-06-20','16:45:00',2.85),('12664','2013-06-20','16:50:00',2.77),('12664','2013-06-20','16:55:00',2.71),('12664','2013-06-20','17:00:00',2.64),('12664','2013-06-20','17:05:00',2.57),('12664','2013-06-20','17:10:00',2.49),('12664','2013-06-20','17:15:00',2.41),('12664','2013-06-20','17:20:00',2.34),('12664','2013-06-20','17:25:00',2.26),('12664','2013-06-20','17:30:00',2.17),('12664','2013-06-20','17:35:00',2.09),('12664','2013-06-20','17:40:00',2.01),('12664','2013-06-20','17:45:00',1.93),('12664','2013-06-20','17:50:00',1.85),('12664','2013-06-20','17:55:00',1.76),('12664','2013-06-20','18:00:00',1.66),('12664','2013-06-20','18:05:00',1.57),('12664','2013-06-20','18:10:00',1.49),('12664','2013-06-20','18:15:00',1.39),('12664','2013-06-20','18:20:00',1.29),('12664','2013-06-20','18:25:00',1.2),('12664','2013-06-20','18:30:00',1.1),('12664','2013-06-20','18:35:00',1.01),('12664','2014-04-03','08:55:00',1.02),('12664','2014-04-03','09:00:00',1.19),('12664','2014-04-03','09:05:00',1.26),('12664','2014-04-03','09:10:00',1.12),('12664','2014-04-03','09:15:00',1.06),('12664','2014-04-03','09:20:00',1.2),('12664','2014-04-03','09:25:00',1.28),('12664','2014-04-03','09:30:00',1.41),('12664','2014-04-03','09:35:00',1.54),('12664','2014-04-03','09:40:00',1.54),('12664','2014-04-03','09:45:00',1.55),('12664','2014-04-03','09:50:00',1.61),('12664','2014-04-03','09:55:00',1.85),('12664','2014-04-03','10:00:00',2.15),('12664','2014-04-03','10:05:00',2.17),('12664','2014-04-03','10:10:00',2.62),('12664','2014-04-03','10:15:00',2.9),('12664','2014-04-03','10:20:00',2.54),('12664','2014-04-03','10:25:00',2.31),('12664','2014-04-03','10:30:00',2.66),('12664','2014-04-03','10:35:00',2.28),('12664','2014-04-03','10:40:00',2.32),('12664','2014-04-03','10:45:00',2.46),('12664','2014-04-03','10:50:00',1.97),('12664','2014-04-03','10:55:00',1.65),('12664','2014-04-03','11:00:00',1.69),('12664','2014-04-03','11:05:00',1.77),('12664','2014-04-03','11:10:00',1.53),('12664','2014-04-03','11:15:00',1.42),('12664','2014-04-03','11:20:00',1.27),('12664','2014-04-03','11:25:00',1.18),('12664','2014-04-03','11:30:00',1.23),('12664','2014-04-03','11:35:00',1.39),('12664','2014-04-03','11:40:00',1.46),('12664','2014-04-03','11:45:00',1.55),('12664','2014-04-03','11:50:00',1.77),('12664','2014-04-03','11:55:00',2),('12664','2014-04-03','12:00:00',2.33),('12664','2014-04-03','12:05:00',2.2),('12664','2014-04-03','12:10:00',1.96),('12664','2014-04-03','12:15:00',2.13),('12664','2014-04-03','12:20:00',2.34),('12664','2014-04-03','12:25:00',3.18),('12664','2014-04-03','12:30:00',4.13),('12664','2014-04-03','12:35:00',3.55),('12664','2014-04-03','12:40:00',2.48),('12664','2014-04-03','12:45:00',2),('12664','2014-04-03','12:50:00',2.3),('12664','2014-04-03','12:55:00',2.44),('12664','2014-04-03','13:00:00',1.86),('12664','2014-04-03','13:05:00',2),('12664','2014-04-03','13:10:00',2.81),('12664','2014-04-03','13:15:00',3.55),('12664','2014-04-03','13:20:00',2.11),('12664','2014-04-03','13:25:00',3.12),('12664','2014-04-03','13:30:00',3.88),('12664','2014-04-03','13:35:00',3.1),('12664','2014-04-03','13:40:00',2.65),('12664','2014-04-03','13:45:00',1.69),('12664','2014-04-03','13:50:00',2.49),('12664','2014-04-03','13:55:00',2.58),('12664','2014-04-03','14:00:00',2.5),('12664','2014-04-03','14:05:00',3.6),('12664','2014-04-03','14:10:00',3.24),('12664','2014-04-03','14:15:00',3.56),('12664','2014-04-03','14:20:00',3.18),('12664','2014-04-03','14:25:00',2.72),('12664','2014-04-03','14:30:00',3.73),('12664','2014-04-03','14:35:00',3.78),('12664','2014-04-03','14:40:00',3.66),('12664','2014-04-03','14:45:00',3.59),('12664','2014-04-03','14:50:00',3.51),('12664','2014-04-03','14:55:00',3.44),('12664','2014-04-03','15:00:00',3.39),('12664','2014-04-03','15:05:00',3.3),('12664','2014-04-03','15:10:00',3.2),('12664','2014-04-03','15:15:00',3.24),('12664','2014-04-03','15:20:00',3.23),('12664','2014-04-03','15:25:00',3.22),('12664','2014-04-03','15:30:00',3.16),('12664','2014-04-03','15:35:00',3.1),('12664','2014-04-03','15:40:00',3.06),('12664','2014-04-03','15:45:00',3.01),('12664','2014-04-03','15:50:00',3.02),('12664','2014-04-03','15:55:00',2.9),('12664','2014-04-03','16:00:00',2.97),('12664','2014-04-03','16:05:00',2.89),('12664','2014-04-03','16:10:00',2.83),('12664','2014-04-03','16:15:00',2.76),('12664','2014-04-03','16:20:00',2.7),('12664','2014-04-03','16:25:00',2.59),('12664','2014-04-03','16:30:00',2.47),('12664','2014-04-03','16:35:00',2.42),('12664','2014-04-03','16:40:00',2.37),('12664','2014-04-03','16:45:00',2.31),('12664','2014-04-03','16:50:00',2.25),('12664','2014-04-03','16:55:00',1.78),('12664','2014-04-03','17:00:00',1.63),('12664','2014-04-03','17:05:00',1.3),('12664','2014-04-03','17:10:00',1.44),('12664','2014-04-03','17:15:00',1.62),('12664','2014-04-03','17:20:00',1.14),('12664','2014-04-03','17:25:00',1.21),('12664','2014-04-03','17:45:00',1.21),('12664','2014-04-03','17:50:00',1.24),('12664','2014-04-03','17:55:00',1.06),('12664','2013-06-19','07:40:00',1.02),('12664','2013-06-19','07:45:00',1.11),('12664','2013-06-19','07:50:00',1.19),('12664','2013-06-19','07:55:00',1.28),('12664','2013-06-19','08:00:00',1.36),('12664','2013-06-19','08:05:00',1.44),('12664','2013-06-19','08:10:00',1.51),('12664','2013-06-19','08:15:00',1.59),('12664','2013-06-19','08:20:00',1.69),('12664','2013-06-19','08:25:00',1.77),('12664','2013-06-19','08:30:00',1.85),('12664','2013-06-19','08:35:00',1.93),('12664','2013-06-19','08:40:00',2),('12664','2013-06-19','08:45:00',2.08),('12664','2013-06-19','08:50:00',2.16),('12664','2013-06-19','08:55:00',2.23),('12664','2013-06-19','09:00:00',2.3),('12664','2013-06-19','09:05:00',2.37),('12664','2013-06-19','09:10:00',2.43),('12664','2013-06-19','09:15:00',2.5),('12664','2013-06-19','09:20:00',2.56),('12664','2013-06-19','09:25:00',2.63),('12664','2013-06-19','09:30:00',2.7),('12664','2013-06-19','09:35:00',2.76),('12664','2013-06-19','09:40:00',2.82),('12664','2013-06-19','09:45:00',2.87),('12664','2013-06-19','09:50:00',2.93),('12664','2013-06-19','09:55:00',2.98),('12664','2013-06-19','10:00:00',3.02),('12664','2013-06-19','10:05:00',3.06),('12664','2013-06-19','10:10:00',3.1),('12664','2013-06-19','10:15:00',3.16),('12664','2013-06-19','10:20:00',3.21),('12664','2013-06-19','10:25:00',3.23),('12664','2013-06-19','10:30:00',3.26),('12664','2013-06-19','10:35:00',3.31),('12664','2013-06-19','10:40:00',3.28),('12664','2013-06-19','10:45:00',3.41),('12664','2013-06-19','10:50:00',3.45),('12664','2013-06-19','10:55:00',3.49),('12664','2013-06-19','11:00:00',3.56),('12664','2013-06-19','11:05:00',3.6),('12664','2013-06-19','11:10:00',3.66),('12664','2013-06-19','11:15:00',3.67),('12664','2013-06-19','11:20:00',3.73),('12664','2013-06-19','11:25:00',3.73),('12664','2013-06-19','11:30:00',3.74),('12664','2013-06-19','11:35:00',3.79),('12664','2013-06-19','11:40:00',3.86),('12664','2013-06-19','11:45:00',3.85),('12664','2013-06-19','11:50:00',3.88),('12664','2013-06-19','11:55:00',3.95),('12664','2013-06-19','12:00:00',4),('12664','2013-06-19','12:05:00',4.04),('12664','2013-06-19','12:10:00',4.12),('12664','2013-06-19','12:15:00',4.1),('12664','2013-06-19','12:20:00',4.13),('12664','2013-06-19','12:25:00',4.12),('12664','2013-06-19','12:30:00',4.15),('12664','2013-06-19','12:35:00',4.13),('12664','2013-06-19','12:40:00',4.14),('12664','2013-06-19','12:45:00',4.15),('12664','2013-06-19','12:50:00',4.15),('12664','2013-06-19','12:55:00',4.16),('12664','2013-06-19','13:00:00',4.19),('12664','2013-06-19','13:05:00',4.19),('12664','2013-06-19','13:10:00',4.2),('12664','2013-06-19','13:15:00',4.19),('12664','2013-06-19','13:20:00',4.22),('12664','2013-06-19','13:25:00',4.22),('12664','2013-06-19','13:30:00',4.21),('12664','2013-06-19','13:35:00',4.21),('12664','2013-06-19','13:40:00',4.22),('12664','2013-06-19','13:45:00',4.23),('12664','2013-06-19','13:50:00',4.23),('12664','2013-06-19','13:55:00',4.21),('12664','2013-06-19','14:00:00',4.21),('12664','2013-06-19','14:05:00',4.18),('12664','2013-06-19','14:10:00',4.16),('12664','2013-06-19','14:15:00',4.13),('12664','2013-06-19','14:20:00',4.1),('12664','2013-06-19','14:25:00',4.07),('12664','2013-06-19','14:30:00',4.05),('12664','2013-06-19','14:35:00',4.04),('12664','2013-06-19','14:40:00',4),('12664','2013-06-19','14:45:00',3.98),('12664','2013-06-19','14:50:00',3.94),('12664','2013-06-19','14:55:00',3.89),('12664','2013-06-19','15:00:00',3.84),('12664','2013-06-19','15:05:00',3.79),('12664','2013-06-19','15:10:00',3.76),('12664','2013-06-19','15:15:00',3.71),('12664','2013-06-19','15:20:00',3.67),('12664','2013-06-19','15:25:00',3.63),('12664','2013-06-19','15:30:00',3.61),('12664','2013-06-19','15:35:00',3.57),('12664','2013-06-19','15:40:00',3.52),('12664','2013-06-19','15:45:00',3.48),('12664','2013-06-19','15:50:00',3.43),('12664','2013-06-19','15:55:00',3.38),('12664','2013-06-19','16:00:00',3.32),('12664','2013-06-19','16:05:00',3.26),('12664','2013-06-19','16:10:00',3.21),('12664','2013-06-19','16:15:00',3.15),('12664','2013-06-19','16:20:00',3.1),('12664','2013-06-19','16:25:00',3.04),('12664','2013-06-19','16:30:00',2.96),('12664','2013-06-19','16:35:00',2.91),('12664','2013-06-19','16:40:00',2.85),('12664','2013-06-19','16:45:00',2.78),('12664','2013-06-19','16:50:00',2.72),('12664','2013-06-19','16:55:00',2.67),('12664','2013-06-19','17:00:00',2.6),('12664','2013-06-19','17:05:00',2.53),('12664','2013-06-19','17:10:00',2.44),('12664','2013-06-19','17:15:00',2.34),('12664','2013-06-19','17:20:00',2.26),('12664','2013-06-19','17:25:00',2.17),('12664','2013-06-19','17:30:00',2.09),('12664','2013-06-19','17:35:00',2.02),('12664','2013-06-19','17:40:00',1.93),('12664','2013-06-19','17:45:00',1.86),('12664','2013-06-19','17:50:00',1.77),('12664','2013-06-19','17:55:00',1.68),('12664','2013-06-19','18:00:00',1.59),('12664','2013-06-19','18:05:00',1.5),('12664','2013-06-19','18:10:00',1.41),('12664','2013-06-19','18:15:00',1.32),('12664','2013-06-19','18:20:00',1.23),('12664','2013-06-19','18:25:00',1.14),('12664','2013-06-19','18:30:00',1.06),('12664','2013-06-18','07:40:00',1.01),('12664','2013-06-18','07:45:00',1.08),('12664','2013-06-18','07:50:00',1.17),('12664','2013-06-18','07:55:00',1.25),('12664','2013-06-18','08:00:00',1.33),('12664','2013-06-18','08:05:00',1.41),('12664','2013-06-18','08:10:00',1.5),('12664','2013-06-18','08:15:00',1.58),('12664','2013-06-18','08:20:00',1.67),('12664','2013-06-18','08:25:00',1.75),('12664','2013-06-18','08:30:00',1.84),('12664','2013-06-18','08:35:00',1.91),('12664','2013-06-18','08:40:00',1.99),('12664','2013-06-18','08:45:00',2.05),('12664','2013-06-18','08:50:00',2.13),('12664','2013-06-18','08:55:00',2.19),('12664','2013-06-18','09:00:00',2.27),('12664','2013-06-18','09:05:00',2.35),('12664','2013-06-18','09:10:00',2.42),('12664','2013-06-18','09:15:00',2.5),('12664','2013-06-18','09:20:00',2.56),('12664','2013-06-18','09:25:00',2.62),('12664','2013-06-18','09:30:00',2.68),('12664','2013-06-18','09:35:00',2.75),('12664','2013-06-18','09:40:00',2.8),('12664','2013-06-18','09:45:00',2.86),('12664','2013-06-18','09:50:00',2.92),('12664','2013-06-18','09:55:00',2.98),('12664','2013-06-18','10:00:00',3.03),('12664','2013-06-18','10:05:00',3.07),('12664','2013-06-18','10:10:00',3.13),('12664','2013-06-18','10:15:00',3.18),('12664','2013-06-18','10:20:00',3.26),('12664','2013-06-18','10:25:00',3.3),('12664','2013-06-18','10:30:00',3.32),('12664','2013-06-18','10:35:00',3.38),('12664','2013-06-18','10:40:00',3.44),('12664','2013-06-18','10:45:00',3.5),('12664','2013-06-18','10:50:00',3.5),('12664','2013-06-18','10:55:00',3.54),('12664','2013-06-18','11:00:00',3.55),('12664','2013-06-18','11:05:00',3.59),('12664','2013-06-18','11:10:00',3.62),('12664','2013-06-18','11:15:00',3.65),('12664','2013-06-18','11:20:00',3.69),('12664','2013-06-18','11:25:00',3.76),('12664','2013-06-18','11:30:00',3.75),('12664','2013-06-18','11:35:00',3.75),('12664','2013-06-18','11:40:00',3.79),('12664','2013-06-18','11:45:00',3.81),('12664','2013-06-18','11:50:00',3.85),('12664','2013-06-18','11:55:00',3.89),('12664','2013-06-18','12:00:00',3.88),('12664','2013-06-18','12:05:00',3.72),('12664','2013-06-18','12:10:00',3.85),('12664','2013-06-18','12:15:00',3.84),('12664','2013-06-18','12:20:00',3.78),('12664','2013-06-18','12:25:00',3.87),('12664','2013-06-18','12:30:00',3.91),('12664','2013-06-18','12:35:00',3.89),('12664','2013-06-18','12:40:00',3.74),('12664','2013-06-18','12:45:00',3.81),('12664','2013-06-18','12:50:00',3.94),('12664','2013-06-18','12:55:00',4),('12664','2013-06-18','13:00:00',4.01),('12664','2013-06-18','13:05:00',4),('12664','2013-06-18','13:10:00',4.13),('12664','2013-06-18','13:15:00',4.18),('12664','2013-06-18','13:20:00',4.09),('12664','2013-06-18','13:25:00',4.04),('12664','2013-06-18','13:30:00',4.02),('12664','2013-06-18','13:35:00',4.02),('12664','2013-06-18','13:40:00',4.04),('12664','2013-06-18','13:45:00',4.03),('12664','2013-06-18','13:50:00',4.04),('12664','2013-06-18','13:55:00',4.04),('12664','2013-06-18','14:00:00',4.16),('12664','2013-06-18','14:05:00',4.24),('12664','2013-06-18','14:10:00',4.2),('12664','2013-06-18','14:15:00',4.25),('12664','2013-06-18','14:20:00',4.17),('12664','2013-06-18','14:25:00',4.13),('12664','2013-06-18','14:30:00',4.14),('12664','2013-06-18','14:35:00',4.25),('12664','2013-06-18','14:40:00',4.27),('12664','2013-06-18','14:45:00',3.76),('12664','2013-06-18','14:50:00',4.11),('12664','2013-06-18','14:55:00',4.06),('12664','2013-06-18','15:00:00',3.95),('12664','2013-06-18','15:05:00',3.86),('12664','2013-06-18','15:10:00',3.76),('12664','2013-06-18','15:15:00',3.72),('12664','2013-06-18','15:20:00',3.69),('12664','2013-06-18','15:25:00',3.64),('12664','2013-06-18','15:30:00',3.6),('12664','2013-06-18','15:35:00',3.57),('12664','2013-06-18','15:40:00',3.54),('12664','2013-06-18','15:45:00',3.48),('12664','2013-06-18','15:50:00',3.41),('12664','2013-06-18','15:55:00',3.38),('12664','2013-06-18','16:00:00',3.36),('12664','2013-06-18','16:05:00',3.31),('12664','2013-06-18','16:10:00',3.23),('12664','2013-06-18','16:15:00',3.21),('12664','2013-06-18','16:20:00',3.18),('12664','2013-06-18','16:25:00',3.16),('12664','2013-06-18','17:30:00',2.06),('12664','2013-06-18','17:35:00',1.99),('12664','2013-06-17','07:40:00',1.06),('12664','2013-06-17','07:45:00',1.15),('12664','2013-06-17','07:50:00',1.23),('12664','2013-06-17','07:55:00',1.31),('12664','2013-06-17','08:00:00',1.4),('12664','2013-06-17','08:05:00',1.48),('12664','2013-06-17','08:10:00',1.56),('12664','2013-06-17','08:15:00',1.64),('12664','2013-06-17','08:20:00',1.72),('12664','2013-06-17','08:25:00',1.82),('12664','2013-06-17','08:30:00',1.91),('12664','2013-06-17','08:35:00',1.99),('12664','2013-06-17','08:40:00',2.06),('12664','2013-06-17','08:45:00',2.14),('12664','2013-06-17','08:50:00',2.21),('12664','2013-06-17','08:55:00',2.29),('12664','2013-06-17','09:00:00',2.36),('12664','2013-06-17','09:05:00',2.44),('12664','2013-06-17','09:10:00',2.51),('12664','2013-06-17','09:15:00',2.61),('12664','2013-06-17','09:20:00',2.68),('12664','2013-06-17','09:25:00',2.75),('12664','2013-06-17','09:30:00',2.81),('12664','2013-06-17','09:35:00',2.88),('12664','2013-06-17','09:40:00',2.94),('12664','2013-06-17','09:45:00',3.02),('12664','2013-06-17','09:50:00',3.08),('12664','2013-06-17','09:55:00',3.14),('12664','2013-06-17','10:00:00',3.2),('12664','2013-06-17','10:05:00',3.25),('12664','2013-06-17','10:10:00',3.29),('12664','2013-06-17','10:15:00',3.35),('12664','2013-06-17','10:20:00',3.39),('12664','2013-06-17','10:25:00',3.42),('12664','2013-06-17','10:30:00',3.46),('12664','2013-06-17','10:35:00',3.52),('12664','2013-06-17','10:40:00',3.55),('12664','2013-06-17','10:45:00',3.59),('12664','2013-06-17','10:50:00',3.63),('12664','2013-06-17','10:55:00',3.66),('12664','2013-06-17','11:00:00',3.69),('12664','2013-06-17','11:05:00',3.72),('12664','2013-06-17','11:10:00',3.76),('12664','2013-06-17','11:15:00',3.81),('12664','2013-06-17','11:20:00',3.85),('12664','2013-06-17','11:25:00',3.85),('12664','2013-06-17','11:30:00',3.92),('12664','2013-06-17','11:35:00',3.97),('12664','2013-06-17','11:40:00',3.98),('12664','2013-06-17','11:45:00',4.02),('12664','2013-06-17','11:50:00',4.04),('12664','2013-06-17','11:55:00',4.06),('12664','2013-06-17','12:00:00',4.08),('12664','2013-06-17','12:05:00',4.16),('12664','2013-06-17','12:10:00',4.18),('12664','2013-06-17','12:15:00',4.19),('12664','2013-06-17','12:20:00',4.19),('12664','2013-06-17','12:25:00',4.22),('12664','2013-06-17','12:30:00',4.24),('12664','2013-06-17','12:35:00',4.23),('12664','2013-06-17','12:40:00',4.28),('12664','2013-06-17','12:45:00',4.28),('12664','2013-06-17','12:50:00',4.28),('12664','2013-06-17','12:55:00',4.3),('12664','2013-06-17','13:00:00',4.29),('12664','2013-06-17','13:05:00',4.28),('12664','2013-06-17','13:10:00',4.26),('12664','2013-06-17','13:15:00',4.25),('12664','2013-06-17','13:20:00',4.25),('12664','2013-06-17','13:25:00',4.24),('12664','2013-06-17','13:30:00',4.22),('12664','2013-06-17','13:35:00',4.22),('12664','2013-06-17','13:40:00',4.19),('12664','2013-06-17','13:45:00',4.14),('12664','2013-06-17','13:50:00',4.12),('12664','2013-06-17','13:55:00',4.14),('12664','2013-06-17','14:00:00',4.14),('12664','2013-06-17','14:05:00',4.12),('12664','2013-06-17','14:10:00',4.11),('12664','2013-06-17','14:15:00',4.08),('12664','2013-06-17','14:20:00',4.1),('12664','2013-06-17','14:25:00',4.07),('12664','2013-06-17','14:30:00',4.05),('12664','2013-06-17','14:35:00',4.03),('12664','2013-06-17','14:40:00',4),('12664','2013-06-17','14:45:00',3.97),('12664','2013-06-17','14:50:00',3.94),('12664','2013-06-17','14:55:00',3.89),('12664','2013-06-17','15:00:00',3.86),('12664','2013-06-17','15:05:00',3.83),('12664','2013-06-17','15:10:00',3.8),('12664','2013-06-17','15:15:00',3.76),('12664','2013-06-17','15:20:00',3.73),('12664','2013-06-17','15:25:00',3.71),('12664','2013-06-17','15:30:00',3.67),('12664','2013-06-17','15:35:00',3.62),('12664','2013-06-17','15:40:00',3.58),('12664','2013-06-17','15:45:00',3.53),('12664','2013-06-17','15:50:00',3.47),('12664','2013-06-17','15:55:00',3.41),('12664','2013-06-17','16:00:00',3.36),('12664','2013-06-17','16:05:00',3.3),('12664','2013-06-17','16:10:00',3.25),('12664','2013-06-17','16:15:00',3.18),('12664','2013-06-17','16:20:00',3.13),('12664','2013-06-17','16:25:00',3.09),('12664','2013-06-17','16:30:00',3.03),('12664','2013-06-17','16:35:00',2.96),('12664','2013-06-17','16:40:00',2.9),('12664','2013-06-17','16:45:00',2.85),('12664','2013-06-17','16:50:00',2.77),('12664','2013-06-17','16:55:00',2.69),('12664','2013-06-17','17:00:00',2.62),('12664','2013-06-17','17:05:00',2.55),('12664','2013-06-17','17:10:00',2.47),('12664','2013-06-17','17:15:00',2.38),('12664','2013-06-17','17:20:00',2.31),('12664','2013-06-17','17:25:00',2.24),('12664','2013-06-17','17:30:00',2.17),('12664','2013-06-17','17:35:00',2.1),('12664','2013-06-17','17:40:00',2.02),('12664','2013-06-17','17:45:00',1.94),('12664','2013-06-17','17:50:00',1.85),('12664','2013-06-17','17:55:00',1.77),('12664','2013-06-17','18:00:00',1.68),('12664','2013-06-17','18:05:00',1.6),('12664','2013-06-17','18:10:00',1.51),('12664','2013-06-17','18:15:00',1.43),('12664','2013-06-17','18:20:00',1.34),('12664','2013-06-17','18:25:00',1.25),('12664','2013-06-17','18:30:00',1.16),('12664','2013-06-17','18:35:00',1.08),('12664','2013-06-16','07:40:00',1.08),('12664','2013-06-16','07:45:00',1.18),('12664','2013-06-16','07:50:00',1.26),('12664','2013-06-16','07:55:00',1.34),('12664','2013-06-16','08:00:00',1.43),('12664','2013-06-16','08:05:00',1.52),('12664','2013-06-16','08:10:00',1.59),('12664','2013-06-16','08:15:00',1.69),('12664','2013-06-16','08:20:00',1.77),('12664','2013-06-16','08:25:00',1.85),('12664','2013-06-16','08:30:00',1.95),('12664','2013-06-16','08:35:00',2.04),('12664','2013-06-16','08:40:00',2.12),('12664','2013-06-16','08:45:00',2.19),('12664','2013-06-16','08:50:00',2.27),('12664','2013-06-16','08:55:00',2.34),('12664','2013-06-16','09:00:00',2.42),('12664','2013-06-16','09:05:00',2.48),('12664','2013-06-16','09:10:00',2.56),('12664','2013-06-16','09:15:00',2.67),('12664','2013-06-16','09:20:00',2.72),('12664','2013-06-16','09:25:00',2.79),('12664','2013-06-16','09:30:00',2.81),('12664','2013-06-16','09:35:00',2.93),('12664','2013-06-16','09:40:00',3),('12664','2013-06-16','09:45:00',3.05),('12664','2013-06-16','09:50:00',3.13),('12664','2013-06-16','09:55:00',3.19),('12664','2013-06-16','10:00:00',3.26),('12664','2013-06-16','10:05:00',3.33),('12664','2013-06-16','10:10:00',3.42),('12664','2013-06-16','10:15:00',3.45),('12664','2013-06-16','10:20:00',3.47),('12664','2013-06-16','10:25:00',3.53),('12664','2013-06-16','10:30:00',3.59),('12664','2013-06-16','10:35:00',3.63),('12664','2013-06-16','10:40:00',3.65),('12664','2013-06-16','10:45:00',3.69),('12664','2013-06-16','10:50:00',3.74),('12664','2013-06-16','10:55:00',3.78),('12664','2013-06-16','11:00:00',3.81),('12664','2013-06-16','11:05:00',3.86),('12664','2013-06-16','11:10:00',3.92),('12664','2013-06-16','11:15:00',3.93),('12664','2013-06-16','11:20:00',3.95),('12664','2013-06-16','11:25:00',3.96),('12664','2013-06-16','11:30:00',3.99),('12664','2013-06-16','11:35:00',4.01),('12664','2013-06-16','11:40:00',4.06),('12664','2013-06-16','11:45:00',4.1),('12664','2013-06-16','11:50:00',4.1),('12664','2013-06-16','11:55:00',4.16),('12664','2013-06-16','12:00:00',4.21),('12664','2013-06-16','12:05:00',4.22),('12664','2013-06-16','12:10:00',4.23),('12664','2013-06-16','12:15:00',4.27),('12664','2013-06-16','12:20:00',4.29),('12664','2013-06-16','12:25:00',4.3),('12664','2013-06-16','12:30:00',4.31),('12664','2013-06-16','12:35:00',4.33),('12664','2013-06-16','12:40:00',4.36),('12664','2013-06-16','12:45:00',4.36),('12664','2013-06-16','12:50:00',4.16),('12664','2013-06-16','12:55:00',4.39),('12664','2013-06-16','13:00:00',4.39),('12664','2013-06-16','13:05:00',4.37),('12664','2013-06-16','13:10:00',4.38),('12664','2013-06-16','13:15:00',4.38),('12664','2013-06-16','13:20:00',4.39),('12664','2013-06-16','13:25:00',4.36),('12664','2013-06-16','13:30:00',4.37),('12664','2013-06-16','13:35:00',4.38),('12664','2013-06-16','13:40:00',4.38),('12664','2013-06-16','13:45:00',4.36),('12664','2013-06-16','13:50:00',4.36),('12664','2013-06-16','13:55:00',4.34),('12664','2013-06-16','14:00:00',4.32),('12664','2013-06-16','14:05:00',4.3),('12664','2013-06-16','14:10:00',4.29),('12664','2013-06-16','14:15:00',4.24),('12664','2013-06-16','14:20:00',4.21),('12664','2013-06-16','14:25:00',4.17),('12664','2013-06-16','14:30:00',4.14),('12664','2013-06-16','14:35:00',4.12),('12664','2013-06-16','14:40:00',4.1),('12664','2013-06-16','14:45:00',4.05),('12664','2013-06-16','14:50:00',4.04),('12664','2013-06-16','14:55:00',3.5),('12664','2013-06-16','15:00:00',3.97),('12664','2013-06-16','15:05:00',3.95),('12664','2013-06-16','15:10:00',3.89),('12664','2013-06-16','15:15:00',3.86),('12664','2013-06-16','15:20:00',3.83),('12664','2013-06-16','15:25:00',3.77),('12664','2013-06-16','15:30:00',3.74),('12664','2013-06-16','15:35:00',3.7),('12664','2013-06-16','15:40:00',3.65),('12664','2013-06-16','15:45:00',3.59),('12664','2013-06-16','15:50:00',3.53),('12664','2013-06-16','15:55:00',3.48),('12664','2013-06-16','16:00:00',3.43),('12664','2013-06-16','16:05:00',3.37),('12664','2013-06-16','16:10:00',3.3),('12664','2013-06-16','16:15:00',3.24),('12664','2013-06-16','16:20:00',3.18),('12664','2013-06-16','16:25:00',3.12),('12664','2013-06-16','16:30:00',3.05),('12664','2013-06-16','16:35:00',2.99),('12664','2013-06-16','16:40:00',2.92),('12664','2013-06-16','16:45:00',2.85),('12664','2013-06-16','16:50:00',2.77),('12664','2013-06-16','16:55:00',2.7),('12664','2013-06-16','17:00:00',2.63),('12664','2013-06-16','17:05:00',2.56),('12664','2013-06-16','17:10:00',2.47),('12664','2013-06-16','17:15:00',2.38),('12664','2013-06-16','17:20:00',2.3),('12664','2013-06-16','17:25:00',2.22),('12664','2013-06-16','17:30:00',2.14),('12664','2013-06-16','17:35:00',2.05),('12664','2013-06-16','17:40:00',1.97),('12664','2013-06-16','17:45:00',1.88),('12664','2013-06-16','17:50:00',1.79),('12664','2013-06-16','17:55:00',1.71),('12664','2013-06-16','18:00:00',1.62),('12664','2013-06-16','18:05:00',1.53),('12664','2013-06-16','18:10:00',1.44),('12664','2013-06-16','18:15:00',1.35),('12664','2013-06-16','18:20:00',1.26),('12664','2013-06-16','18:25:00',1.17),('12664','2013-06-16','18:30:00',1.08),('12664','2013-06-15','07:40:00',1.05),('12664','2013-06-15','07:45:00',1.15),('12664','2013-06-15','07:50:00',1.24),('12664','2013-06-15','07:55:00',1.31),('12664','2013-06-15','08:00:00',1.39),('12664','2013-06-15','08:05:00',1.47),('12664','2013-06-15','08:10:00',1.58),('12664','2013-06-15','08:15:00',1.63),('12664','2013-06-15','08:20:00',1.74),('12664','2013-06-15','08:25:00',1.76),('12664','2013-06-15','08:30:00',1.79),('12664','2013-06-15','08:35:00',2.13),('12664','2013-06-15','08:40:00',2.26),('12664','2013-06-15','08:45:00',1.79),('12664','2013-06-15','08:50:00',1.46),('12664','2013-06-15','08:55:00',1.05),('12664','2013-06-15','09:00:00',1.02),('12664','2013-06-15','09:05:00',2.15),('12664','2013-06-15','09:10:00',2.75),('12664','2013-06-15','09:15:00',2.79),('12664','2013-06-15','09:20:00',2.85),('12664','2013-06-15','09:25:00',2.92),('12664','2013-06-15','09:30:00',2.94),('12664','2013-06-15','09:35:00',2.86),('12664','2013-06-15','09:40:00',3.03),('12664','2013-06-15','09:45:00',3.11),('12664','2013-06-15','09:50:00',3.13),('12664','2013-06-15','09:55:00',3.23),('12664','2013-06-15','10:00:00',3.23),('12664','2013-06-15','10:05:00',3.33),('12664','2013-06-15','10:10:00',3.41),('12664','2013-06-15','10:15:00',3.46),('12664','2013-06-15','10:20:00',3.51),('12664','2013-06-15','10:25:00',3.54),('12664','2013-06-15','10:30:00',3.6),('12664','2013-06-15','10:35:00',3.65),('12664','2013-06-15','10:40:00',3.65),('12664','2013-06-15','10:45:00',3.74),('12664','2013-06-15','10:50:00',3.78),('12664','2013-06-15','10:55:00',3.79),('12664','2013-06-15','11:00:00',3.8),('12664','2013-06-15','11:05:00',3.72),('12664','2013-06-15','11:10:00',4.01),('12664','2013-06-15','11:15:00',2.31),('12664','2013-06-15','11:20:00',2.92),('12664','2013-06-15','11:25:00',4.08),('12664','2013-06-15','11:30:00',4.15),('12664','2013-06-15','11:35:00',3.94),('12664','2013-06-15','11:40:00',4.26),('12664','2013-06-15','11:45:00',3.95),('12664','2013-06-15','11:50:00',4.15),('12664','2013-06-15','11:55:00',3.86),('12664','2013-06-15','12:00:00',4.25),('12664','2013-06-15','12:05:00',4.28),('12664','2013-06-15','12:10:00',4.3),('12664','2013-06-15','12:15:00',4.37),('12664','2013-06-15','12:20:00',4.39),('12664','2013-06-15','12:25:00',4.35),('12664','2013-06-15','12:30:00',4.37),('12664','2013-06-15','12:35:00',4.33),('12664','2013-06-15','12:40:00',4.34),('12664','2013-06-15','12:45:00',4.38),('12664','2013-06-15','12:50:00',4.38),('12664','2013-06-15','12:55:00',4.33),('12664','2013-06-15','13:00:00',4.34),('12664','2013-06-15','13:05:00',4.32),('12664','2013-06-15','13:10:00',4.34),('12664','2013-06-15','13:15:00',4.34),('12664','2013-06-15','13:20:00',4.36),('12664','2013-06-15','13:25:00',4.36),('12664','2013-06-15','13:30:00',4.38),('12664','2013-06-15','13:35:00',4.39),('12664','2013-06-15','13:40:00',4.37),('12664','2013-06-15','13:45:00',4.33),('12664','2013-06-15','13:50:00',4.14),('12664','2013-06-15','13:55:00',4.34),('12664','2013-06-15','14:00:00',4.32),('12664','2013-06-15','14:05:00',4.31),('12664','2013-06-15','14:10:00',4.29),('12664','2013-06-15','14:15:00',4.26),('12664','2013-06-15','14:20:00',4.18),('12664','2013-06-15','14:25:00',4.21),('12664','2013-06-15','14:30:00',4.15),('12664','2013-06-15','14:35:00',4.16),('12664','2013-06-15','14:40:00',4.12),('12664','2013-06-15','14:45:00',4.08),('12664','2013-06-15','14:50:00',4.06),('12664','2013-06-15','14:55:00',4.01),('12664','2013-06-15','15:00:00',4.01),('12664','2013-06-15','15:05:00',3.97),('12664','2013-06-15','15:10:00',3.91),('12664','2013-06-15','15:15:00',3.89),('12664','2013-06-15','15:20:00',3.85),('12664','2013-06-15','15:25:00',3.8),('12664','2013-06-15','15:30:00',3.74),('12664','2013-06-15','15:35:00',3.7),('12664','2013-06-15','15:40:00',3.65),('12664','2013-06-15','15:45:00',3.6),('12664','2013-06-15','15:50:00',3.55),('12664','2013-06-15','15:55:00',3.48),('12664','2013-06-15','16:00:00',3.42),('12664','2013-06-15','16:05:00',3.36),('12664','2013-06-15','16:10:00',3.31),('12664','2013-06-15','16:15:00',3.25),('12664','2013-06-15','16:20:00',3.17),('12664','2013-06-15','16:25:00',3.11),('12664','2013-06-15','16:30:00',3.02),('12664','2013-06-15','16:35:00',2.96),('12664','2013-06-15','16:40:00',2.89),('12664','2013-06-15','16:45:00',2.81),('12664','2013-06-15','16:50:00',2.74),('12664','2013-06-15','16:55:00',2.67),('12664','2013-06-15','17:00:00',2.61),('12664','2013-06-15','17:05:00',2.52),('12664','2013-06-15','17:10:00',2.44),('12664','2013-06-15','17:15:00',2.38),('12664','2013-06-15','17:20:00',2.28),('12664','2013-06-15','17:25:00',2.2),('12664','2013-06-15','17:30:00',2.11),('12664','2013-06-15','17:35:00',2.02),('12664','2013-06-15','17:40:00',1.95),('12664','2013-06-15','17:45:00',1.87),('12664','2013-06-15','17:50:00',1.78),('12664','2013-06-15','17:55:00',1.68),('12664','2013-06-15','18:00:00',1.6),('12664','2013-06-15','18:05:00',1.53),('12664','2013-06-15','18:10:00',1.43),('12664','2013-06-15','18:15:00',1.35),('12664','2013-06-15','18:20:00',1.26),('12664','2013-06-15','18:25:00',1.17),('12664','2013-06-15','18:30:00',1.08),('12664','2013-06-14','07:35:00',1.08),('12664','2013-06-14','07:40:00',1.17),('12664','2013-06-14','07:45:00',1.26),('12664','2013-06-14','07:50:00',1.36),('12664','2013-06-14','07:55:00',1.45),('12664','2013-06-14','08:00:00',1.54),('12664','2013-06-14','08:05:00',1.64),('12664','2013-06-14','08:10:00',1.74),('12664','2013-06-14','08:15:00',1.83),('12664','2013-06-14','08:20:00',1.93),('12664','2013-06-14','08:25:00',2.01),('12664','2013-06-14','08:30:00',2.1),('12664','2013-06-14','08:35:00',2.19),('12664','2013-06-14','08:40:00',2.28),('12664','2013-06-14','08:45:00',2.36),('12664','2013-06-14','08:50:00',2.44),('12664','2013-06-14','08:55:00',2.52),('12664','2013-06-14','09:00:00',2.59),('12664','2013-06-14','09:05:00',2.66),('12664','2013-06-14','09:10:00',2.72),('12664','2013-06-14','09:15:00',2.79),('12664','2013-06-14','09:20:00',2.86),('12664','2013-06-14','09:25:00',2.94),('12664','2013-06-14','09:30:00',3.01),('12664','2013-06-14','09:35:00',3.09),('12664','2013-06-14','09:40:00',3.15),('12664','2013-06-14','09:45:00',3.21),('12664','2013-06-14','09:50:00',3.27),('12664','2013-06-14','09:55:00',3.29),('12664','2013-06-14','10:00:00',3.33),('12664','2013-06-14','10:05:00',3.37),('12664','2013-06-14','10:10:00',3.4),('12664','2013-06-14','10:15:00',3.52),('12664','2013-06-14','10:20:00',3.57),('12664','2013-06-14','10:25:00',3.51),('12664','2013-06-14','10:30:00',3.6),('12664','2013-06-14','10:35:00',3.65),('12664','2013-06-14','10:40:00',3.75),('12664','2013-06-14','10:45:00',3.78),('12664','2013-06-14','10:50:00',3.8),('12664','2013-06-14','10:55:00',3.87),('12664','2013-06-14','11:00:00',3.87),('12664','2013-06-14','11:05:00',3.89),('12664','2013-06-14','11:10:00',3.97),('12664','2013-06-14','11:15:00',3.99),('12664','2013-06-14','11:20:00',4.07),('12664','2013-06-14','11:25:00',4.08),('12664','2013-06-14','11:30:00',4.1),('12664','2013-06-14','11:35:00',4.09),('12664','2013-06-14','11:40:00',4.14),('12664','2013-06-14','11:45:00',4.12),('12664','2013-06-14','11:50:00',4.08),('12664','2013-06-14','11:55:00',4.2),('12664','2013-06-14','12:00:00',4.26),('12664','2013-06-14','12:05:00',4.26),('12664','2013-06-14','12:10:00',4.28),('12664','2013-06-14','12:15:00',4.36),('12664','2013-06-14','12:20:00',4.38),('12664','2013-06-14','12:25:00',4.41),('12664','2013-06-14','12:30:00',4.4),('12664','2013-06-14','12:35:00',4.4),('12664','2013-06-14','12:40:00',4.38),('12664','2013-06-14','12:45:00',4.42),('12664','2013-06-14','12:50:00',4.41),('12664','2013-06-14','12:55:00',4.38),('12664','2013-06-14','13:00:00',4.36),('12664','2013-06-14','13:05:00',4.37),('12664','2013-06-14','13:10:00',4.42),('12664','2013-06-14','13:15:00',4.45),('12664','2013-06-14','13:20:00',4.41),('12664','2013-06-14','13:25:00',4.4),('12664','2013-06-14','13:30:00',4.39),('12664','2013-06-14','13:35:00',4.39),('12664','2013-06-14','13:40:00',4.39),('12664','2013-06-14','13:45:00',4.37),('12664','2013-06-14','13:50:00',4.33),('12664','2013-06-14','13:55:00',4.32),('12664','2013-06-14','14:00:00',4.32),('12664','2013-06-14','14:05:00',4.32),('12664','2013-06-14','14:10:00',4.28),('12664','2013-06-14','14:15:00',4.29),('12664','2013-06-14','14:20:00',4.29),('12664','2013-06-14','14:25:00',4.27),('12664','2013-06-14','14:30:00',4.26),('12664','2013-06-14','14:35:00',4.23),('12664','2013-06-14','14:40:00',4.2),('12664','2013-06-14','14:45:00',4.13),('12664','2013-06-14','14:50:00',4.09),('12664','2013-06-14','14:55:00',4.07),('12664','2013-06-14','15:00:00',4.03),('12664','2013-06-14','15:05:00',4.04),('12664','2013-06-14','15:10:00',3.99),('12664','2013-06-14','15:15:00',3.94),('12664','2013-06-14','15:20:00',3.91),('12664','2013-06-14','15:25:00',3.88),('12664','2013-06-14','15:30:00',3.86),('12664','2013-06-14','15:35:00',3.8),('12664','2013-06-14','15:40:00',3.75),('12664','2013-06-14','15:45:00',3.7),('12664','2013-06-14','15:50:00',3.64),('12664','2013-06-14','15:55:00',3.59),('12664','2013-06-14','16:00:00',3.52),('12664','2013-06-14','16:05:00',3.46),('12664','2013-06-14','16:10:00',3.41),('12664','2013-06-14','16:15:00',3.34),('12664','2013-06-14','16:20:00',3.28),('12664','2013-06-14','16:25:00',3.22),('12664','2013-06-14','16:30:00',3.15),('12664','2013-06-14','16:35:00',3.08),('12664','2013-06-14','16:40:00',3),('12664','2013-06-14','16:45:00',2.91),('12664','2013-06-14','16:50:00',2.83),('12664','2013-06-14','16:55:00',2.73),('12664','2013-06-14','17:00:00',2.7),('12664','2013-06-14','17:05:00',2.55),('12664','2013-06-14','17:10:00',2.51),('12664','2013-06-14','17:15:00',2.43),('12664','2013-06-14','17:20:00',2.37),('12664','2013-06-14','17:25:00',2.25),('12664','2013-06-14','17:30:00',2.22),('12664','2013-06-14','17:35:00',2.15),('12664','2013-06-14','17:40:00',2.06),('12664','2013-06-14','17:45:00',1.96),('12664','2013-06-14','17:50:00',1.86),('12664','2013-06-14','17:55:00',1.78),('12664','2013-06-14','18:00:00',1.69),('12664','2013-06-14','18:05:00',1.6),('12664','2013-06-14','18:10:00',1.5),('12664','2013-06-14','18:15:00',1.4),('12664','2013-06-14','18:20:00',1.31),('12664','2013-06-14','18:25:00',1.23),('12664','2013-06-14','18:30:00',1.14),('12664','2013-06-14','18:35:00',1.05),('12664','2013-06-13','07:30:00',1),('12664','2013-06-13','07:35:00',1.1),('12664','2013-06-13','07:40:00',1.19),('12664','2013-06-13','07:45:00',1.3),('12664','2013-06-13','07:50:00',1.4),('12664','2013-06-13','07:55:00',1.49),('12664','2013-06-13','08:00:00',1.59),('12664','2013-06-13','08:05:00',1.68),('12664','2013-06-13','08:10:00',1.77),('12664','2013-06-13','08:15:00',1.87),('12664','2013-06-13','08:20:00',1.95),('12664','2013-06-13','08:25:00',2.03),('12664','2013-06-13','08:30:00',2.12),('12664','2013-06-13','08:35:00',2.21),('12664','2013-06-13','08:40:00',2.3),('12664','2013-06-13','08:45:00',2.38),('12664','2013-06-13','08:50:00',2.46),('12664','2013-06-13','08:55:00',2.54),('12664','2013-06-13','09:00:00',2.63),('12664','2013-06-13','09:05:00',2.7),('12664','2013-06-13','09:10:00',2.78),('12664','2013-06-13','09:15:00',2.86),('12664','2013-06-13','09:20:00',2.93),('12664','2013-06-13','09:25:00',3.01),('12664','2013-06-13','09:30:00',3.07),('12664','2013-06-13','09:35:00',3.13),('12664','2013-06-13','09:40:00',3.2),('12664','2013-06-13','09:45:00',3.26),('12664','2013-06-13','09:50:00',3.33),('12664','2013-06-13','09:55:00',3.39),('12664','2013-06-13','10:00:00',3.45),('12664','2013-06-13','10:05:00',3.51),('12664','2013-06-13','10:10:00',3.56),('12664','2013-06-13','10:15:00',3.62),('12664','2013-06-13','10:20:00',3.67),('12664','2013-06-13','10:25:00',3.72),('12664','2013-06-13','10:30:00',3.78),('12664','2013-06-13','10:35:00',3.82),('12664','2013-06-13','10:40:00',3.87),('12664','2013-06-13','10:45:00',3.92),('12664','2013-06-13','10:50:00',3.95),('12664','2013-06-13','10:55:00',4.01),('12664','2013-06-13','11:00:00',4.06),('12664','2013-06-13','11:05:00',4.09),('12664','2013-06-13','11:10:00',4.12),('12664','2013-06-13','11:15:00',4.12),('12664','2013-06-13','11:20:00',4.16),('12664','2013-06-13','11:25:00',4.21),('12664','2013-06-13','11:30:00',4.23),('12664','2013-06-13','11:35:00',4.27),('12664','2013-06-13','11:40:00',4.29),('12664','2013-06-13','11:45:00',4.3),('12664','2013-06-13','11:50:00',4.34),('12664','2013-06-13','11:55:00',4.35),('12664','2013-06-13','12:00:00',4.38),('12664','2013-06-13','12:05:00',4.37),('12664','2013-06-13','12:10:00',4.39),('12664','2013-06-13','12:15:00',4.41),('12664','2013-06-13','12:20:00',4.42),('12664','2013-06-13','12:25:00',4.44),('12664','2013-06-13','12:30:00',4.4),('12664','2013-06-13','12:35:00',4.42),('12664','2013-06-13','12:40:00',4.47),('12664','2013-06-13','12:45:00',4.46),('12664','2013-06-13','12:50:00',4.45),('12664','2013-06-13','12:55:00',4.43),('12664','2013-06-13','13:00:00',4.41),('12664','2013-06-13','13:05:00',4.4),('12664','2013-06-13','13:10:00',4.4),('12664','2013-06-13','13:15:00',4.41),('12664','2013-06-13','13:20:00',4.42),('12664','2013-06-13','13:25:00',4.41),('12664','2013-06-13','13:30:00',4.39),('12664','2013-06-13','13:35:00',4.38),('12664','2013-06-13','13:40:00',4.35),('12664','2013-06-13','13:45:00',4.42),('12664','2013-06-13','13:50:00',4.38),('12664','2013-06-13','13:55:00',4.3),('12664','2013-06-13','14:00:00',4.24),('12664','2013-06-13','14:05:00',4.31),('12664','2013-06-13','14:10:00',4.2),('12664','2013-06-13','14:15:00',4.21),('12664','2013-06-13','14:20:00',4.21),('12664','2013-06-13','14:25:00',4.39),('12664','2013-06-13','14:30:00',2.29),('12664','2013-06-13','14:35:00',2.63),('12664','2013-06-13','14:40:00',4.56),('12664','2013-06-13','14:45:00',4.37),('12664','2013-06-13','14:50:00',4.29),('12664','2013-06-13','14:55:00',4.17),('12664','2013-06-13','15:00:00',4.02),('12664','2013-06-13','15:05:00',3.95),('12664','2013-06-13','15:10:00',4.01),('12664','2013-06-13','15:15:00',3.83),('12664','2013-06-13','15:20:00',3.8),('12664','2013-06-13','15:25:00',3.73),('12664','2013-06-13','15:30:00',3.68),('12664','2013-06-13','15:35:00',3.61),('12664','2013-06-13','15:40:00',3.47),('12664','2013-06-13','15:45:00',3.22),('12664','2013-06-13','15:50:00',2.84),('12664','2013-06-13','15:55:00',3.42),('12664','2013-06-13','16:00:00',3.41),('12664','2013-06-13','16:05:00',3.33),('12664','2013-06-13','16:10:00',3.26),('12664','2013-06-13','16:15:00',3.2),('12664','2013-06-13','16:20:00',3.2),('12664','2013-06-13','16:25:00',3.14),('12664','2013-06-13','16:30:00',3.09),('12664','2013-06-13','16:35:00',2.99),('12664','2013-06-13','16:40:00',2.93),('12664','2013-06-13','16:45:00',2.85),('12664','2013-06-13','16:50:00',2.74),('12664','2013-06-13','16:55:00',2.73),('12664','2013-06-13','17:00:00',2.68),('12664','2013-06-13','17:05:00',2.59),('12664','2013-06-13','17:10:00',2.5),('12664','2013-06-13','17:15:00',2.42),('12664','2013-06-13','17:20:00',2.32),('12664','2013-06-13','17:25:00',2.22),('12664','2013-06-13','17:30:00',2.15),('12664','2013-06-13','17:35:00',2.05),('12664','2013-06-13','17:40:00',1.97),('12664','2013-06-13','17:45:00',1.9),('12664','2013-06-13','17:50:00',1.83),('12664','2013-06-13','17:55:00',1.74),('12664','2013-06-13','18:00:00',1.64),('12664','2013-06-13','18:05:00',1.55),('12664','2013-06-13','18:10:00',1.47),('12664','2013-06-13','18:15:00',1.38),('12664','2013-06-13','18:20:00',1.28),('12664','2013-06-13','18:25:00',1.19),('12664','2013-06-13','18:30:00',1.1),('12664','2013-06-13','18:35:00',1),('12664','2013-06-12','07:30:00',1),('12664','2013-06-12','07:35:00',1.1),('12664','2013-06-12','07:40:00',1.19),('12664','2013-06-12','07:45:00',1.29),('12664','2013-06-12','07:50:00',1.39),('12664','2013-06-12','07:55:00',1.5),('12664','2013-06-12','08:00:00',1.6),('12664','2013-06-12','08:05:00',1.69),('12664','2013-06-12','08:10:00',1.78),('12664','2013-06-12','08:15:00',1.87),('12664','2013-06-12','08:20:00',1.96),('12664','2013-06-12','08:25:00',2.04),('12664','2013-06-12','08:30:00',2.13),('12664','2013-06-12','08:35:00',2.22),('12664','2013-06-12','08:40:00',2.3),('12664','2013-06-12','08:45:00',2.38),('12664','2013-06-12','08:50:00',2.46),('12664','2013-06-12','08:55:00',2.53),('12664','2013-06-12','09:00:00',2.6),('12664','2013-06-12','09:05:00',2.68),('12664','2013-06-12','09:10:00',2.74),('12664','2013-06-12','09:15:00',2.81),('12664','2013-06-12','09:20:00',2.92),('12664','2013-06-12','09:25:00',2.98),('12664','2013-06-12','09:30:00',3.05),('12664','2013-06-12','09:35:00',3.14),('12664','2013-06-12','09:40:00',3.2),('12664','2013-06-12','09:45:00',3.25),('12664','2013-06-12','09:50:00',3.32),('12664','2013-06-12','09:55:00',3.39),('12664','2013-06-12','10:00:00',3.46),('12664','2013-06-12','10:05:00',3.52),('12664','2013-06-12','10:10:00',3.57),('12664','2013-06-12','10:15:00',3.66),('12664','2013-06-12','10:20:00',3.67),('12664','2013-06-12','10:25:00',3.7),('12664','2013-06-12','10:30:00',3.76),('12664','2013-06-12','10:35:00',3.79),('12664','2013-06-12','10:40:00',3.81),('12664','2013-06-12','10:45:00',3.87),('12664','2013-06-12','10:50:00',3.91),('12664','2013-06-12','10:55:00',4),('12664','2013-06-12','11:00:00',4),('12664','2013-06-12','11:05:00',4.03),('12664','2013-06-12','11:10:00',4.06),('12664','2013-06-12','11:15:00',4.13),('12664','2013-06-12','11:20:00',4.13),('12664','2013-06-12','11:25:00',4.2),('12664','2013-06-12','11:30:00',4.23),('12664','2013-06-12','11:35:00',4.25),('12664','2013-06-12','11:40:00',4.29),('12664','2013-06-12','11:45:00',4.29),('12664','2013-06-12','11:50:00',4.29),('12664','2013-06-12','11:55:00',4.33),('12664','2013-06-12','12:00:00',4.35),('12664','2013-06-12','12:05:00',4.38),('12664','2013-06-12','12:10:00',4.34),('12664','2013-06-12','12:15:00',4.32),('12664','2013-06-12','12:20:00',4.4),('12664','2013-06-12','12:25:00',3.57),('12664','2013-06-12','12:30:00',4.05),('12664','2013-06-12','12:35:00',4.44),('12664','2013-06-12','12:40:00',4.55),('12664','2013-06-12','12:45:00',3.63),('12664','2013-06-12','12:50:00',4.56),('12664','2013-06-12','12:55:00',4.61),('12664','2013-06-12','13:00:00',4.53),('12664','2013-06-12','13:05:00',4.51),('12664','2013-06-12','13:10:00',4.5),('12664','2013-06-12','13:15:00',4.17),('12664','2013-06-12','13:20:00',4.43),('12664','2013-06-12','13:25:00',3.22),('12664','2013-06-12','13:30:00',2.85),('12664','2013-06-12','13:35:00',3.47),('12664','2013-06-12','13:40:00',3.3),('12664','2013-06-12','13:45:00',4.42),('12664','2013-06-12','13:50:00',4.31),('12664','2013-06-12','13:55:00',4.59),('12664','2013-06-12','14:00:00',4.6),('12664','2013-06-12','14:05:00',4.47),('12664','2013-06-12','14:10:00',4.45),('12664','2013-06-12','14:15:00',4.43),('12664','2013-06-12','14:20:00',4.39),('12664','2013-06-12','14:25:00',4.21),('12664','2013-06-12','14:30:00',4.31),('12664','2013-06-12','14:35:00',4.29),('12664','2013-06-12','14:40:00',4.28),('12664','2013-06-12','14:45:00',4.24),('12664','2013-06-12','14:50:00',4.19),('12664','2013-06-12','14:55:00',4.2),('12664','2013-06-12','15:00:00',4.17),('12664','2013-06-12','15:05:00',4.11),('12664','2013-06-12','15:10:00',4.03),('12664','2013-06-12','15:15:00',4.04),('12664','2013-06-12','15:20:00',4.01),('12664','2013-06-12','15:25:00',3.95),('12664','2013-06-12','15:30:00',3.9),('12664','2013-06-12','15:35:00',3.85),('12664','2013-06-12','15:40:00',3.82),('12664','2013-06-12','15:45:00',3.8),('12664','2013-06-12','15:50:00',3.76),('12664','2013-06-12','15:55:00',3.7),('12664','2013-06-12','16:00:00',3.62),('12664','2013-06-12','16:05:00',3.54),('12664','2013-06-12','16:10:00',3.48),('12664','2013-06-12','16:15:00',3.42),('12664','2013-06-12','16:20:00',3.36),('12664','2013-06-12','16:25:00',3.32),('12664','2013-06-12','16:30:00',3.26),('12664','2013-06-12','16:35:00',3.2),('12664','2013-06-12','16:40:00',3.22),('12664','2013-06-12','16:45:00',3.1),('12664','2013-06-12','16:50:00',2.89),('12664','2013-06-12','16:55:00',1.26),('12664','2013-06-12','17:00:00',2.73),('12664','2013-06-12','17:05:00',2.55),('12664','2013-06-12','17:10:00',2.66),('12664','2013-06-12','17:15:00',2.54),('12664','2013-06-12','17:20:00',2.45),('12664','2013-06-12','17:25:00',2.39),('12664','2013-06-12','17:30:00',2.39),('12664','2013-06-12','17:35:00',2.37),('12664','2013-06-12','17:40:00',2.26),('12664','2013-06-12','17:45:00',2.13),('12664','2013-06-12','17:50:00',2.01),('12664','2013-06-12','17:55:00',1.95),('12664','2013-06-12','18:00:00',1.84),('12664','2013-06-12','18:05:00',1.3),('12664','2013-06-12','18:10:00',1.57),('12664','2013-06-12','18:15:00',1.45),('12664','2013-06-12','18:25:00',1.03),('12664','2013-06-12','18:30:00',1.1),('12664','2013-06-12','18:35:00',1.06),('12664','2013-06-11','07:30:00',1.04),('12664','2013-06-11','07:35:00',1.09),('12664','2013-06-11','07:40:00',1.16),('12664','2013-06-11','07:45:00',1.25),('12664','2013-06-11','07:50:00',1.34),('12664','2013-06-11','07:55:00',1.43),('12664','2013-06-11','08:00:00',1.53),('12664','2013-06-11','08:05:00',1.63),('12664','2013-06-11','08:10:00',1.73),('12664','2013-06-11','08:15:00',1.82),('12664','2013-06-11','08:20:00',1.91),('12664','2013-06-11','08:25:00',1.99),('12664','2013-06-11','08:30:00',2.08),('12664','2013-06-11','08:35:00',2.18),('12664','2013-06-11','08:40:00',2.27),('12664','2013-06-11','08:45:00',2.35),('12664','2013-06-11','08:50:00',2.41),('12664','2013-06-11','08:55:00',2.54),('12664','2013-06-11','09:00:00',2.58),('12664','2013-06-11','09:05:00',2.69),('12664','2013-06-11','09:10:00',2.78),('12664','2013-06-11','09:15:00',2.86),('12664','2013-06-11','09:20:00',2.9),('12664','2013-06-11','09:25:00',2.97),('12664','2013-06-11','09:30:00',3.07),('12664','2013-06-11','09:35:00',3.11),('12664','2013-06-11','09:40:00',3.13),('12664','2013-06-11','09:45:00',3.14),('12664','2013-06-11','09:50:00',3.34),('12664','2013-06-11','09:55:00',3.38),('12664','2013-06-11','10:00:00',3.46),('12664','2013-06-11','10:05:00',3.61),('12664','2013-06-11','10:10:00',3.65),('12664','2013-06-11','10:15:00',3.78),('12664','2013-06-11','10:20:00',3.64),('12664','2013-06-11','10:25:00',4.04),('12664','2013-06-11','10:30:00',3.02),('12664','2013-06-11','10:35:00',4.12),('12664','2013-06-11','10:40:00',3.96),('12664','2013-06-11','10:45:00',2.64),('12664','2013-06-11','10:50:00',3.33),('12664','2013-06-11','10:55:00',4.2),('12664','2013-06-11','11:00:00',4.21),('12664','2013-06-11','11:05:00',4.19),('12664','2013-06-11','11:10:00',4.24),('12664','2013-06-11','11:15:00',4.25),('12664','2013-06-11','11:20:00',4.28),('12664','2013-06-11','11:25:00',4.33),('12664','2013-06-11','11:30:00',4.37),('12664','2013-06-11','11:35:00',4.42),('12664','2013-06-11','11:40:00',4.41),('12664','2013-06-11','11:45:00',4.39),('12664','2013-06-11','11:50:00',4.1),('12664','2013-06-11','11:55:00',4.53),('12664','2013-06-11','12:00:00',4.58),('12664','2013-06-11','12:05:00',4.55),('12664','2013-06-11','12:10:00',4.64),('12664','2013-06-11','12:15:00',4.57),('12664','2013-06-11','12:20:00',4.54),('12664','2013-06-11','12:25:00',4.56),('12664','2013-06-11','12:30:00',4.59),('12664','2013-06-11','12:35:00',4.59),('12664','2013-06-11','12:40:00',4.64),('12664','2013-06-11','12:45:00',4.67),('12664','2013-06-11','12:50:00',4.67),('12664','2013-06-11','12:55:00',4.64),('12664','2013-06-11','13:00:00',4.69),('12664','2013-06-11','13:05:00',4.76),('12664','2013-06-11','13:10:00',4.69),('12664','2013-06-11','13:15:00',4.7),('12664','2013-06-11','13:20:00',4.69),('12664','2013-06-11','13:25:00',4.69),('12664','2013-06-11','13:30:00',4.71),('12664','2013-06-11','13:35:00',4.7),('12664','2013-06-11','13:40:00',4.69),('12664','2013-06-11','13:45:00',4.65),('12664','2013-06-11','13:50:00',4.6),('12664','2013-06-11','13:55:00',4.6),('12664','2013-06-11','14:00:00',4.57),('12664','2013-06-11','14:05:00',4.56),('12664','2013-06-11','14:10:00',4.51),('12664','2013-06-11','14:15:00',4.49),('12664','2013-06-11','14:20:00',4.46),('12664','2013-06-11','14:25:00',4.44),('12664','2013-06-11','14:30:00',4.39),('12664','2013-06-11','14:35:00',4.34),('12664','2013-06-11','14:40:00',4.34),('12664','2013-06-11','14:45:00',3.45),('12664','2013-06-11','14:50:00',4.39),('12664','2013-06-11','14:55:00',4.3),('12664','2013-06-11','15:00:00',4.18),('12664','2013-06-11','15:05:00',4.13),('12664','2013-06-11','15:10:00',4.1),('12664','2013-06-11','15:15:00',3.81),('12664','2013-06-11','15:20:00',4.07),('12664','2013-06-11','15:25:00',3.96),('12664','2013-06-11','15:30:00',4.09),('12664','2013-06-11','15:35:00',3.98),('12664','2013-06-11','15:40:00',3.86),('12664','2013-06-11','15:45:00',3.88),('12664','2013-06-11','15:50:00',3.78),('12664','2013-06-11','15:55:00',3.62),('12664','2013-06-11','16:00:00',3.62),('12664','2013-06-11','16:05:00',3.56),('12664','2013-06-11','16:10:00',3.48),('12664','2013-06-11','16:15:00',3.42),('12664','2013-06-11','16:20:00',3.34),('12664','2013-06-11','16:25:00',3.29),('12664','2013-06-11','16:30:00',3.25),('12664','2013-06-11','16:35:00',3.22),('12664','2013-06-11','16:40:00',3.26),('12664','2013-06-11','16:45:00',3.28),('12664','2013-06-11','16:50:00',3.19),('12664','2013-06-11','16:55:00',1.88),('12664','2013-06-11','17:00:00',1.29),('12664','2013-06-11','17:05:00',1.04),('12664','2013-06-10','07:25:00',1.1),('12664','2013-06-10','07:30:00',1.15),('12664','2013-06-10','07:55:00',1.45),('12664','2013-06-10','08:00:00',1.09),('12664','2013-06-10','08:05:00',1.1),('12664','2013-06-10','08:10:00',1.43),('12664','2013-06-10','08:15:00',1.27),('12664','2013-06-10','08:20:00',1.94),('12664','2013-06-10','08:25:00',1.21),('12664','2013-06-10','08:45:00',1.78),('12664','2013-06-10','08:50:00',2.27),('12664','2013-06-10','08:55:00',1.76),('12664','2013-06-10','09:00:00',1.44),('12664','2013-06-10','09:05:00',1.43),('12664','2013-06-10','09:10:00',1.69),('12664','2013-06-10','09:15:00',3.23),('12664','2013-06-10','09:20:00',2.95),('12664','2013-06-10','09:25:00',2.14),('12664','2013-06-10','09:30:00',2.96),('12664','2013-06-10','09:35:00',2.13),('12664','2013-06-10','09:40:00',2.27),('12664','2013-06-10','09:45:00',3.23),('12664','2013-06-10','09:50:00',2.05),('12664','2013-06-10','09:55:00',2.06),('12664','2013-06-10','10:00:00',2.01),('12664','2013-06-10','10:05:00',1.76),('12664','2013-06-10','10:10:00',1.69),('12664','2013-06-10','10:15:00',1.64),('12664','2013-06-10','10:20:00',2.43),('12664','2013-06-10','10:25:00',2.73),('12664','2013-06-10','10:30:00',3.16),('12664','2013-06-10','10:35:00',3.7),('12664','2013-06-10','10:40:00',2.5),('12664','2013-06-10','10:45:00',1.73),('12664','2013-06-10','10:50:00',3.76),('12664','2013-06-10','10:55:00',3.01),('12664','2013-06-10','11:00:00',2.93),('12664','2013-06-10','11:05:00',3.96),('12664','2013-06-10','11:10:00',4.47),('12664','2013-06-10','11:15:00',3.82),('12664','2013-06-10','11:20:00',2.28),('12664','2013-06-10','11:25:00',1.57),('12664','2013-06-10','11:30:00',1.8),('12664','2013-06-10','11:35:00',2.56),('12664','2013-06-10','11:40:00',4.23),('12664','2013-06-10','11:45:00',2.35),('12664','2013-06-10','11:50:00',4.1),('12664','2013-06-10','11:55:00',3.22),('12664','2013-06-10','12:00:00',3.61),('12664','2013-06-10','12:05:00',4.97),('12664','2013-06-10','12:10:00',4.11),('12664','2013-06-10','12:15:00',4.36),('12664','2013-06-10','12:20:00',1.77),('12664','2013-06-10','12:25:00',4.3),('12664','2013-06-10','12:30:00',4.37),('12664','2013-06-10','12:35:00',1.85),('12664','2013-06-10','12:40:00',3.76),('12664','2013-06-10','12:45:00',3.39),('12664','2013-06-10','12:50:00',4.79),('12664','2013-06-10','12:55:00',2.27),('12664','2013-06-10','13:00:00',1.91),('12664','2013-06-10','13:05:00',2.54),('12664','2013-06-10','13:10:00',2.41),('12664','2013-06-10','13:15:00',2.9),('12664','2013-06-10','13:20:00',2.55),('12664','2013-06-10','13:25:00',1.89),('12664','2013-06-10','13:30:00',1.69),('12664','2013-06-10','13:35:00',2.05),('12664','2013-06-10','13:40:00',2.66),('12664','2013-06-10','13:45:00',3.04),('12664','2013-06-10','13:50:00',3.57),('12664','2013-06-10','13:55:00',4.8),('12664','2013-06-10','14:00:00',3.12),('12664','2013-06-10','14:05:00',4.51),('12664','2013-06-10','14:10:00',4.66),('12664','2013-06-10','14:15:00',4.61),('12664','2013-06-10','14:20:00',4.39),('12664','2013-06-10','14:25:00',4.5),('12664','2013-06-10','14:30:00',4.47),('12664','2013-06-10','14:35:00',4.43),('12664','2013-06-10','14:40:00',4.39),('12664','2013-06-10','14:45:00',4.36),('12664','2013-06-10','14:50:00',4.31),('12664','2013-06-10','14:55:00',4.24),('12664','2013-06-10','15:00:00',3.98),('12664','2013-06-10','15:05:00',4.18),('12664','2013-06-10','15:10:00',4.16),('12664','2013-06-10','15:15:00',4.13),('12664','2013-06-10','15:20:00',4.09),('12664','2013-06-10','15:25:00',4.04),('12664','2013-06-10','15:30:00',3.99),('12664','2013-06-10','15:35:00',3.98),('12664','2013-06-10','15:40:00',3.91),('12664','2013-06-10','15:45:00',3.84),('12664','2013-06-10','15:50:00',3.79),('12664','2013-06-10','15:55:00',3.72),('12664','2013-06-10','16:00:00',3.67),('12664','2013-06-10','16:05:00',3.6),('12664','2013-06-10','16:10:00',3.54),('12664','2013-06-10','16:15:00',3.48),('12664','2013-06-10','16:20:00',3.42),('12664','2013-06-10','16:25:00',3.35),('12664','2013-06-10','16:30:00',3.28),('12664','2013-06-10','16:35:00',3.19),('12664','2013-06-10','16:40:00',3.11),('12664','2013-06-10','16:45:00',3.04),('12664','2013-06-10','16:50:00',2.98),('12664','2013-06-10','16:55:00',2.89),('12664','2013-06-10','17:00:00',2.8),('12664','2013-06-10','17:05:00',2.74),('12664','2013-06-10','17:10:00',2.67),('12664','2013-06-10','17:15:00',2.59),('12664','2013-06-10','17:20:00',2.49),('12664','2013-06-10','17:25:00',2.41),('12664','2013-06-10','17:30:00',2.3),('12664','2013-06-10','17:35:00',2.21),('12664','2013-06-10','17:40:00',2.13),('12664','2013-06-10','17:45:00',2.04),('12664','2013-06-10','17:50:00',1.95),('12664','2013-06-10','17:55:00',1.84),('12664','2013-06-10','18:00:00',1.74),('12664','2013-06-10','18:05:00',1.65),('12664','2013-06-10','18:10:00',1.55),('12664','2013-06-10','18:15:00',1.46),('12664','2013-06-10','18:20:00',1.36),('12664','2013-06-10','18:25:00',1.26),('12664','2013-06-10','18:30:00',1.16),('12664','2013-06-10','18:35:00',1.06),('12664','2014-04-02','08:20:00',1.05),('12664','2014-04-02','09:00:00',1.48),('12664','2014-04-02','09:05:00',1.69),('12664','2014-04-02','09:10:00',1.72),('12664','2014-04-02','09:45:00',1.6),('12664','2014-04-02','09:50:00',2.65),('12664','2014-04-02','09:55:00',2.87),('12664','2014-04-02','10:00:00',2.51),('12664','2014-04-02','10:05:00',1.05),('12664','2014-04-02','10:25:00',1.11),('12664','2014-04-02','10:30:00',2.88),('12664','2014-04-02','10:35:00',1.85),('12664','2014-04-02','10:40:00',1.24),('12664','2014-04-02','11:00:00',1.31),('12664','2014-04-02','11:05:00',2),('12664','2014-04-02','11:10:00',1.31),('12664','2014-04-02','11:25:00',1.07),('12664','2014-04-02','11:30:00',1.49),('12664','2014-04-02','11:35:00',2.5),('12664','2014-04-02','11:40:00',2.97),('12664','2014-04-02','11:45:00',4.66),('12664','2014-04-02','11:50:00',4.01),('12664','2014-04-02','11:55:00',1.89),('12664','2014-04-02','12:00:00',1.45),('12664','2014-04-02','12:05:00',4.02),('12664','2014-04-02','12:10:00',4.42),('12664','2014-04-02','12:15:00',4.1),('12664','2014-04-02','12:20:00',3.97),('12664','2014-04-02','12:25:00',3.41),('12664','2014-04-02','12:30:00',2.91),('12664','2014-04-02','12:35:00',4.01),('12664','2014-04-02','12:40:00',4.45),('12664','2014-04-02','12:45:00',4.45),('12664','2014-04-02','12:50:00',4.59),('12664','2014-04-02','12:55:00',2.64),('12664','2014-04-02','13:00:00',3.75),('12664','2014-04-02','13:05:00',2.73),('12664','2014-04-02','13:10:00',3.81),('12664','2014-04-02','13:15:00',3.32),('12664','2014-04-02','13:20:00',3.11),('12664','2014-04-02','13:25:00',3.44),('12664','2014-04-02','13:30:00',4.3),('12664','2014-04-02','13:35:00',4.16),('12664','2014-04-02','13:40:00',2.7),('12664','2014-04-02','13:45:00',4.38),('12664','2014-04-02','13:50:00',3.17),('12664','2014-04-02','13:55:00',2.78),('12664','2014-04-02','14:00:00',3.92),('12664','2014-04-02','14:05:00',3.78),('12664','2014-04-02','14:10:00',3.5),('12664','2014-04-02','14:15:00',3.51),('12664','2014-04-02','14:20:00',4.29),('12664','2014-04-02','14:25:00',3.85),('12664','2014-04-02','14:30:00',3.98),('12664','2014-04-02','14:35:00',2.31),('12664','2014-04-02','14:40:00',3.96),('12664','2014-04-02','14:45:00',3.76),('12664','2014-04-02','14:50:00',3.43),('12664','2014-04-02','14:55:00',3.58),('12664','2014-04-02','15:00:00',3.62),('12664','2014-04-02','15:05:00',3.46),('12664','2014-04-02','15:10:00',3.41),('12664','2014-04-02','15:15:00',3.5),('12664','2014-04-02','15:20:00',3.35),('12664','2014-04-02','15:25:00',3.14),('12664','2014-04-02','15:30:00',3.01),('12664','2014-04-02','15:35:00',3.29),('12664','2014-04-02','15:40:00',3.3),('12664','2014-04-02','15:45:00',3.22),('12664','2014-04-02','15:50:00',2.86),('12664','2014-04-02','15:55:00',2.86),('12664','2014-04-02','16:00:00',2.88),('12664','2014-04-02','16:05:00',2.8),('12664','2014-04-02','16:10:00',2.75),('12664','2014-04-02','16:15:00',2.69),('12664','2014-04-02','16:20:00',2.58),('12664','2014-04-02','16:25:00',2.56),('12664','2014-04-02','16:30:00',2.47),('12664','2014-04-02','16:35:00',2.43),('12664','2014-04-02','16:40:00',2.38),('12664','2014-04-02','16:45:00',2.16),('12664','2014-04-02','16:50:00',2.02),('12664','2014-04-02','16:55:00',2.18),('12664','2014-04-02','17:00:00',2.03),('12664','2014-04-02','17:05:00',1.88),('12664','2014-04-02','17:10:00',1.79),('12664','2014-04-02','17:15:00',1.65),('12664','2014-04-02','17:20:00',1.58),('12664','2014-04-02','17:25:00',1.49),('12664','2014-04-02','17:30:00',1.34),('12664','2014-04-02','17:35:00',1.14),('12664','2014-04-02','17:40:00',1.03),('12664','2014-04-02','17:45:00',1.14),('12664','2014-04-02','17:50:00',1.1),('12664','2013-06-09','07:55:00',1.4),('12664','2013-06-09','08:00:00',1.05),('12664','2013-06-09','08:05:00',1.23),('12664','2013-06-09','08:10:00',1.51),('12664','2013-06-09','08:15:00',1.76),('12664','2013-06-09','08:20:00',1.86),('12664','2013-06-09','08:25:00',1.9),('12664','2013-06-09','08:30:00',1.94),('12664','2013-06-09','08:35:00',2.08),('12664','2013-06-09','08:40:00',2.13),('12664','2013-06-09','08:45:00',2.21),('12664','2013-06-09','08:50:00',2.37),('12664','2013-06-09','08:55:00',2.42),('12664','2013-06-09','09:00:00',2.5),('12664','2013-06-09','09:05:00',2.6),('12664','2013-06-09','09:10:00',2.65),('12664','2013-06-09','09:15:00',2.7),('12664','2013-06-09','09:20:00',2.77),('12664','2013-06-09','09:25:00',2.82),('12664','2013-06-09','09:30:00',2.91),('12664','2013-06-09','09:35:00',2.97),('12664','2013-06-09','09:40:00',3.07),('12664','2013-06-09','09:45:00',3.12),('12664','2013-06-09','09:50:00',3.15),('12664','2013-06-09','09:55:00',3.25),('12664','2013-06-09','10:00:00',3.25),('12664','2013-06-09','10:05:00',3.33),('12664','2013-06-09','10:10:00',3.42),('12664','2013-06-09','10:15:00',3.46),('12664','2013-06-09','10:20:00',3.51),('12664','2013-06-09','10:25:00',3.53),('12664','2013-06-09','10:30:00',3.56),('12664','2013-06-09','10:35:00',3.65),('12664','2013-06-09','10:40:00',3.73),('12664','2013-06-09','10:45:00',3.77),('12664','2013-06-09','10:50:00',3.78),('12664','2013-06-09','10:55:00',3.85),('12664','2013-06-09','11:00:00',3.84),('12664','2013-06-09','11:05:00',3.87),('12664','2013-06-09','11:10:00',3.88),('12664','2013-06-09','11:15:00',3.97),('12664','2013-06-09','11:20:00',4.03),('12664','2013-06-09','11:25:00',4.02),('12664','2013-06-09','11:30:00',4.05),('12664','2013-06-09','11:35:00',4.1),('12664','2013-06-09','11:40:00',4.08),('12664','2013-06-09','11:45:00',4.17),('12664','2013-06-09','11:50:00',4.16),('12664','2013-06-09','11:55:00',4.23),('12664','2013-06-09','12:00:00',4.24),('12664','2013-06-09','12:05:00',3.76),('12664','2013-06-09','12:10:00',4.02),('12664','2013-06-09','12:15:00',4.27),('12664','2013-06-09','12:20:00',3.89),('12664','2013-06-09','12:25:00',4.3),('12664','2013-06-09','12:30:00',4.26),('12664','2013-06-09','12:35:00',4.38),('12664','2013-06-09','12:40:00',4.45),('12664','2013-06-09','12:45:00',4.35),('12664','2013-06-09','12:50:00',4.29),('12664','2013-06-09','12:55:00',3.61),('12664','2013-06-09','13:00:00',4.46),('12664','2013-06-09','13:05:00',4.29),('12664','2013-06-09','13:10:00',4.41),('12664','2013-06-09','13:15:00',4.43),('12664','2013-06-09','13:20:00',4.5),('12664','2013-06-09','13:25:00',4.62),('12664','2013-06-09','13:30:00',3.95),('12664','2013-06-09','13:35:00',3.76),('12664','2013-06-09','13:40:00',3.92),('12664','2013-06-09','13:45:00',2.73),('12664','2013-06-09','13:50:00',4.87),('12664','2013-06-09','13:55:00',4.68),('12664','2013-06-09','14:00:00',4.3),('12664','2013-06-09','14:05:00',4.05),('12664','2013-06-09','14:10:00',4.72),('12664','2013-06-09','14:15:00',3.25),('12664','2013-06-09','14:20:00',1.57),('12664','2013-06-09','14:25:00',1.18),('12664','2013-06-09','14:30:00',1.61),('12664','2013-06-09','14:35:00',3.54),('12664','2013-06-09','14:40:00',4.42),('12664','2013-06-09','14:45:00',3.63),('12664','2013-06-09','14:50:00',3.91),('12664','2013-06-09','14:55:00',4.32),('12664','2013-06-09','15:00:00',4.12),('12664','2013-06-09','15:05:00',4.17),('12664','2013-06-09','15:10:00',4.13),('12664','2013-06-09','15:15:00',4),('12664','2013-06-09','15:20:00',3.99),('12664','2013-06-09','15:25:00',3.92),('12664','2013-06-09','15:30:00',3.86),('12664','2013-06-09','15:35:00',3.55),('12664','2013-06-09','15:40:00',3.05),('12664','2013-06-09','15:45:00',3.09),('12664','2013-06-09','15:50:00',3.61),('12664','2013-06-09','15:55:00',3.5),('12664','2013-06-09','16:00:00',3.5),('12664','2013-06-09','16:05:00',3.42),('12664','2013-06-09','16:10:00',3),('12664','2013-06-09','16:15:00',2.58),('12664','2013-06-09','16:20:00',2.52),('12664','2013-06-09','16:25:00',1.92),('12664','2013-06-09','16:30:00',1.06),('12664','2013-06-09','16:35:00',1.09),('12664','2013-06-09','16:45:00',1),('12664','2013-06-09','16:55:00',1.04),('12664','2013-06-09','17:00:00',1.08),('12664','2013-06-09','17:05:00',1.02),('12664','2013-06-09','18:00:00',1.15),('12664','2013-06-09','18:05:00',1.89),('12664','2013-06-09','18:10:00',1.2),('12664','2013-06-08','07:35:00',1.03),('12664','2013-06-08','07:40:00',1.12),('12664','2013-06-08','07:45:00',1.21),('12664','2013-06-08','07:50:00',1.31),('12664','2013-06-08','07:55:00',1.39),('12664','2013-06-08','08:00:00',1.5),('12664','2013-06-08','08:05:00',1.59),('12664','2013-06-08','08:10:00',1.69),('12664','2013-06-08','08:15:00',1.77),('12664','2013-06-08','08:20:00',1.85),('12664','2013-06-08','08:25:00',1.95),('12664','2013-06-08','08:30:00',2.04),('12664','2013-06-08','08:35:00',2.11),('12664','2013-06-08','08:40:00',2.19),('12664','2013-06-08','08:45:00',2.27),('12664','2013-06-08','08:50:00',2.33),('12664','2013-06-08','08:55:00',2.45),('12664','2013-06-08','09:00:00',2.55),('12664','2013-06-08','09:05:00',2.63),('12664','2013-06-08','09:10:00',2.69),('12664','2013-06-08','09:15:00',2.75),('12664','2013-06-08','09:20:00',2.8),('12664','2013-06-08','09:25:00',2.87),('12664','2013-06-08','09:30:00',2.97),('12664','2013-06-08','09:35:00',2.68),('12664','2013-06-08','09:40:00',2.56),('12664','2013-06-08','09:45:00',2.17),('12664','2013-06-08','09:50:00',3.23),('12664','2013-06-08','09:55:00',3.63),('12664','2013-06-08','10:00:00',3.55),('12664','2013-06-08','10:05:00',3.33),('12664','2013-06-08','10:10:00',3.57),('12664','2013-06-08','10:15:00',3.59),('12664','2013-06-08','10:20:00',3.7),('12664','2013-06-08','10:25:00',3.76),('12664','2013-06-08','10:30:00',3.78),('12664','2013-06-08','10:35:00',3.73),('12664','2013-06-08','10:40:00',3.94),('12664','2013-06-08','10:45:00',4.12),('12664','2013-06-08','10:50:00',4.17),('12664','2013-06-08','10:55:00',4.41),('12664','2013-06-08','11:00:00',4.51),('12664','2013-06-08','11:05:00',4.39),('12664','2013-06-08','11:10:00',3.62),('12664','2013-06-08','11:15:00',1.7),('12664','2013-06-08','11:20:00',3.74),('12664','2013-06-08','11:25:00',4.34),('12664','2013-06-08','11:30:00',4.3),('12664','2013-06-08','11:35:00',4.29),('12664','2013-06-08','11:40:00',4.38),('12664','2013-06-08','11:45:00',4.38),('12664','2013-06-08','11:50:00',3.41),('12664','2013-06-08','11:55:00',2.04),('12664','2013-06-08','12:00:00',4.19),('12664','2013-06-08','12:05:00',4.4),('12664','2013-06-08','12:10:00',4.52),('12664','2013-06-08','12:15:00',4.42),('12664','2013-06-08','12:20:00',4.38),('12664','2013-06-08','12:25:00',4.32),('12664','2013-06-08','12:30:00',4.4),('12664','2013-06-08','12:35:00',4.33),('12664','2013-06-08','12:40:00',4.37),('12664','2013-06-08','12:45:00',4.51),('12664','2013-06-08','12:50:00',4.53),('12664','2013-06-08','12:55:00',4.57),('12664','2013-06-08','13:00:00',4.49),('12664','2013-06-08','13:05:00',4.47),('12664','2013-06-08','13:10:00',4.46),('12664','2013-06-08','13:15:00',4.53),('12664','2013-06-08','13:20:00',4.45),('12664','2013-06-08','13:25:00',4.5),('12664','2013-06-08','13:30:00',4.33),('12664','2013-06-08','13:35:00',4.5),('12664','2013-06-08','13:40:00',4.43),('12664','2013-06-08','13:45:00',4.5),('12664','2013-06-08','13:50:00',4.59),('12664','2013-06-08','13:55:00',4.48),('12664','2013-06-08','14:00:00',4.49),('12664','2013-06-08','14:05:00',4.46),('12664','2013-06-08','14:10:00',4.44),('12664','2013-06-08','14:15:00',4.42),('12664','2013-06-08','14:20:00',4.39),('12664','2013-06-08','14:25:00',4.38),('12664','2013-06-08','14:30:00',4.35),('12664','2013-06-08','14:35:00',4.32),('12664','2013-06-08','14:40:00',4.26),('12664','2013-06-08','14:45:00',4.27),('12664','2013-06-08','14:50:00',4.19),('12664','2013-06-08','14:55:00',4.19),('12664','2013-06-08','15:00:00',4.14),('12664','2013-06-08','15:05:00',3.92),('12664','2013-06-08','15:10:00',4.13),('12664','2013-06-08','15:15:00',4.09),('12664','2013-06-08','15:20:00',3.99),('12664','2013-06-08','15:25:00',4.04),('12664','2013-06-08','15:30:00',4.04),('12664','2013-06-08','15:35:00',4.03),('12664','2013-06-08','15:40:00',4.06),('12664','2013-06-08','15:45:00',3.96),('12664','2013-06-08','15:50:00',3.77),('12664','2013-06-08','15:55:00',3.74),('12664','2013-06-08','16:00:00',3.58),('12664','2013-06-08','16:05:00',3.52),('12664','2013-06-08','16:10:00',3.73),('12664','2013-06-08','16:15:00',3.62),('12664','2013-06-08','16:20:00',3.44),('12664','2013-06-08','16:25:00',3.31),('12664','2013-06-08','16:30:00',3.2),('12664','2013-06-08','16:35:00',3.12),('12664','2013-06-08','16:40:00',3.07),('12664','2013-06-08','16:45:00',2.57),('12664','2013-06-08','16:50:00',2.65),('12664','2013-06-08','16:55:00',2.48),('12664','2013-06-08','17:00:00',1.75),('12664','2013-06-08','17:05:00',2.99),('12664','2013-06-08','17:10:00',2.96),('12664','2013-06-08','17:15:00',2.76),('12664','2013-06-08','17:20:00',2.34),('12664','2013-06-08','17:35:00',2.02),('12664','2013-06-08','17:40:00',2.09),('12664','2013-06-08','17:45:00',2.01),('12664','2013-06-08','17:50:00',2.08),('12664','2013-06-08','17:55:00',1.35),('12664','2013-06-08','18:00:00',1.4),('12664','2013-06-08','18:05:00',1.21),('12664','2013-06-08','18:10:00',1.09),('12664','2013-06-08','18:15:00',1.18),('12664','2013-06-07','07:30:00',1.02),('12664','2013-06-07','07:35:00',1.11),('12664','2013-06-07','07:40:00',1.21),('12664','2013-06-07','07:45:00',1.31),('12664','2013-06-07','07:50:00',1.41),('12664','2013-06-07','07:55:00',1.51),('12664','2013-06-07','08:00:00',1.61),('12664','2013-06-07','08:05:00',1.71),('12664','2013-06-07','08:10:00',1.8),('12664','2013-06-07','08:15:00',1.9),('12664','2013-06-07','08:20:00',1.99),('12664','2013-06-07','08:25:00',2.08),('12664','2013-06-07','08:30:00',2.18),('12664','2013-06-07','08:35:00',2.26),('12664','2013-06-07','08:40:00',2.35),('12664','2013-06-07','08:45:00',2.44),('12664','2013-06-07','08:50:00',2.53),('12664','2013-06-07','08:55:00',2.61),('12664','2013-06-07','09:00:00',2.69),('12664','2013-06-07','09:05:00',2.77),('12664','2013-06-07','09:10:00',2.84),('12664','2013-06-07','09:15:00',2.92),('12664','2013-06-07','09:20:00',2.99),('12664','2013-06-07','09:25:00',3.06),('12664','2013-06-07','09:30:00',3.14),('12664','2013-06-07','09:35:00',3.2),('12664','2013-06-07','09:40:00',3.27),('12664','2013-06-07','09:45:00',3.32),('12664','2013-06-07','09:50:00',3.4),('12664','2013-06-07','09:55:00',3.45),('12664','2013-06-07','10:00:00',3.51),('12664','2013-06-07','10:05:00',3.58),('12664','2013-06-07','10:10:00',3.63),('12664','2013-06-07','10:15:00',3.68),('12664','2013-06-07','10:20:00',3.74),('12664','2013-06-07','10:25:00',3.8),('12664','2013-06-07','10:30:00',3.85),('12664','2013-06-07','10:35:00',3.88),('12664','2013-06-07','10:40:00',3.93),('12664','2013-06-07','10:45:00',3.98),('12664','2013-06-07','10:50:00',4.02),('12664','2013-06-07','10:55:00',4.04),('12664','2013-06-07','11:00:00',4.09),('12664','2013-06-07','11:05:00',4.11),('12664','2013-06-07','11:10:00',4.13),('12664','2013-06-07','11:15:00',4.16),('12664','2013-06-07','11:20:00',4.21),('12664','2013-06-07','11:25:00',4.23),('12664','2013-06-07','11:30:00',4.26),('12664','2013-06-07','11:35:00',4.29),('12664','2013-06-07','11:40:00',4.3),('12664','2013-06-07','11:45:00',4.33),('12664','2013-06-07','11:50:00',4.36),('12664','2013-06-07','11:55:00',4.39),('12664','2013-06-07','12:00:00',4.39),('12664','2013-06-07','12:05:00',4.38),('12664','2013-06-07','12:10:00',4.42),('12664','2013-06-07','12:15:00',4.41),('12664','2013-06-07','12:20:00',4.44),('12664','2013-06-07','12:25:00',4.44),('12664','2013-06-07','12:30:00',4.46),('12664','2013-06-07','12:35:00',4.48),('12664','2013-06-07','12:40:00',4.45),('12664','2013-06-07','12:45:00',4.48),('12664','2013-06-07','12:50:00',4.48),('12664','2013-06-07','12:55:00',4.49),('12664','2013-06-07','13:00:00',4.43),('12664','2013-06-07','13:05:00',4.4),('12664','2013-06-07','13:10:00',4.44),('12664','2013-06-07','13:15:00',4.46),('12664','2013-06-07','13:20:00',4.45),('12664','2013-06-07','13:25:00',4.42),('12664','2013-06-07','13:30:00',4.39),('12664','2013-06-07','13:35:00',4.38),('12664','2013-06-07','13:40:00',4.37),('12664','2013-06-07','13:45:00',4.38),('12664','2013-06-07','13:50:00',4.33),('12664','2013-06-07','13:55:00',4.31),('12664','2013-06-07','14:00:00',4.27),('12664','2013-06-07','14:05:00',4.26),('12664','2013-06-07','14:10:00',4.26),('12664','2013-06-07','14:15:00',4.3),('12664','2013-06-07','14:20:00',4.21),('12664','2013-06-07','14:25:00',4.16),('12664','2013-06-07','14:30:00',4.15),('12664','2013-06-07','14:35:00',4.14),('12664','2013-06-07','14:40:00',4.07),('12664','2013-06-07','14:45:00',4.09),('12664','2013-06-07','14:50:00',4.11),('12664','2013-06-07','14:55:00',4.1),('12664','2013-06-07','15:00:00',4.08),('12664','2013-06-07','15:05:00',4.03),('12664','2013-06-07','15:10:00',4.03),('12664','2013-06-07','15:15:00',4),('12664','2013-06-07','15:20:00',3.97),('12664','2013-06-07','15:25:00',3.94),('12664','2013-06-07','15:30:00',3.89),('12664','2013-06-07','15:35:00',3.85),('12664','2013-06-07','15:40:00',3.8),('12664','2013-06-07','15:45:00',3.76),('12664','2013-06-07','15:50:00',3.72),('12664','2013-06-07','15:55:00',3.66),('12664','2013-06-07','16:00:00',3.59),('12664','2013-06-07','16:05:00',3.54),('12664','2013-06-07','16:10:00',3.49),('12664','2013-06-07','16:15:00',3.41),('12664','2013-06-07','16:20:00',3.35),('12664','2013-06-07','16:25:00',3.29),('12664','2013-06-07','16:30:00',3.23),('12664','2013-06-07','16:35:00',3.15),('12664','2013-06-07','16:40:00',3.06),('12664','2013-06-07','16:45:00',2.98),('12664','2013-06-07','16:50:00',2.9),('12664','2013-06-07','16:55:00',2.81),('12664','2013-06-07','17:00:00',2.73),('12664','2013-06-07','17:05:00',2.67),('12664','2013-06-07','17:10:00',2.58),('12664','2013-06-07','17:15:00',2.5),('12664','2013-06-07','17:20:00',2.42),('12664','2013-06-07','17:25:00',2.34),('12664','2013-06-07','17:30:00',2.28),('12664','2013-06-07','17:35:00',2.21),('12664','2013-06-07','17:40:00',2.19),('12664','2013-06-07','17:45:00',2.16),('12664','2013-06-07','17:50:00',2.04),('12664','2013-06-07','17:55:00',1.85),('12664','2013-06-07','18:00:00',1.76),('12664','2013-06-07','18:05:00',1.67),('12664','2013-06-07','18:10:00',1.33),('12664','2013-06-07','18:15:00',1.32),('12664','2013-06-07','18:20:00',1.28),('12664','2013-06-07','18:25:00',1.18),('12664','2013-06-07','18:30:00',1.08),('12664','2013-06-06','07:45:00',1.32),('12664','2013-06-06','07:50:00',1.42),('12664','2013-06-06','07:55:00',1.16),('12664','2013-06-06','08:00:00',1.63),('12664','2013-06-06','08:05:00',1.33),('12664','2013-06-06','08:10:00',1.44),('12664','2013-06-06','08:15:00',1.8),('12664','2013-06-06','08:20:00',1.95),('12664','2013-06-06','08:25:00',2.02),('12664','2013-06-06','08:30:00',2.1),('12664','2013-06-06','08:35:00',2.22),('12664','2013-06-06','08:40:00',2.31),('12664','2013-06-06','08:45:00',2.4),('12664','2013-06-06','08:50:00',2.38),('12664','2013-06-06','08:55:00',2.39),('12664','2013-06-06','09:00:00',2.55),('12664','2013-06-06','09:05:00',2.63),('12664','2013-06-06','09:10:00',2.68),('12664','2013-06-06','09:15:00',2.81),('12664','2013-06-06','09:20:00',2.93),('12664','2013-06-06','09:25:00',3.03),('12664','2013-06-06','09:30:00',3.11),('12664','2013-06-06','09:35:00',3.09),('12664','2013-06-06','09:40:00',3.2),('12664','2013-06-06','09:45:00',3.25),('12664','2013-06-06','09:50:00',3.34),('12664','2013-06-06','09:55:00',3.38),('12664','2013-06-06','10:00:00',3.45),('12664','2013-06-06','10:05:00',3.5),('12664','2013-06-06','10:10:00',3.48),('12664','2013-06-06','10:15:00',3.48),('12664','2013-06-06','10:20:00',3.63),('12664','2013-06-06','10:25:00',3.73),('12664','2013-06-06','10:30:00',3.8),('12664','2013-06-06','10:35:00',3.77),('12664','2013-06-06','10:40:00',3.88),('12664','2013-06-06','10:45:00',3.89),('12664','2013-06-06','10:50:00',3.91),('12664','2013-06-06','10:55:00',3.93),('12664','2013-06-06','11:00:00',4.08),('12664','2013-06-06','11:05:00',4.07),('12664','2013-06-06','11:10:00',4.1),('12664','2013-06-06','11:15:00',4.12),('12664','2013-06-06','11:20:00',4),('12664','2013-06-06','11:25:00',2.06),('12664','2013-06-06','11:30:00',3.42),('12664','2013-06-06','11:35:00',4.4),('12664','2013-06-06','11:40:00',4.31),('12664','2013-06-06','11:45:00',4.39),('12664','2013-06-06','11:50:00',4.39),('12664','2013-06-06','11:55:00',4.25),('12664','2013-06-06','12:00:00',4.35),('12664','2013-06-06','12:05:00',4.3),('12664','2013-06-06','12:10:00',4.37),('12664','2013-06-06','12:15:00',4.33),('12664','2013-06-06','12:20:00',4.4),('12664','2013-06-06','12:25:00',4.39),('12664','2013-06-06','12:30:00',4.41),('12664','2013-06-06','12:35:00',4.44),('12664','2013-06-06','12:40:00',4.45),('12664','2013-06-06','12:45:00',4.43),('12664','2013-06-06','12:50:00',4.55),('12664','2013-06-06','12:55:00',4.6),('12664','2013-06-06','13:00:00',4.63),('12664','2013-06-06','13:05:00',4.71),('12664','2013-06-06','13:10:00',4.59),('12664','2013-06-06','13:15:00',4),('12664','2013-06-06','13:20:00',1.38),('12664','2013-06-06','13:25:00',1.36),('12664','2013-06-06','13:30:00',4.59),('12664','2013-06-06','13:35:00',4.73),('12664','2013-06-06','13:40:00',4.55),('12664','2013-06-06','13:45:00',4.45),('12664','2013-06-06','13:50:00',4.4),('12664','2013-06-06','13:55:00',4.42),('12664','2013-06-06','14:00:00',4.35),('12664','2013-06-06','14:05:00',4.39),('12664','2013-06-06','14:10:00',4.37),('12664','2013-06-06','14:15:00',4.32),('12664','2013-06-06','14:20:00',4.29),('12664','2013-06-06','14:25:00',4.28),('12664','2013-06-06','14:30:00',4.28),('12664','2013-06-06','14:35:00',4.23),('12664','2013-06-06','14:40:00',4.17),('12664','2013-06-06','14:45:00',4.19),('12664','2013-06-06','14:50:00',4.15),('12664','2013-06-06','14:55:00',4.1),('12664','2013-06-06','15:00:00',4.08),('12664','2013-06-06','15:05:00',4),('12664','2013-06-06','15:10:00',3.96),('12664','2013-06-06','15:15:00',3.98),('12664','2013-06-06','15:20:00',3.88),('12664','2013-06-06','15:25:00',3.84),('12664','2013-06-06','15:30:00',3.8),('12664','2013-06-06','15:35:00',3.78),('12664','2013-06-06','15:40:00',3.7),('12664','2013-06-06','15:45:00',3.6),('12664','2013-06-06','15:50:00',3.56),('12664','2013-06-06','15:55:00',3.52),('12664','2013-06-06','16:00:00',3.44),('12664','2013-06-06','16:05:00',3.38),('12664','2013-06-06','16:10:00',3.34),('12664','2013-06-06','16:15:00',3.28),('12664','2013-06-06','16:20:00',3.26),('12664','2013-06-06','16:25:00',3.17),('12664','2013-06-06','16:30:00',3.13),('12664','2013-06-06','16:35:00',3.04),('12664','2013-06-06','16:40:00',2.96),('12664','2013-06-06','16:45:00',2.88),('12664','2013-06-06','16:50:00',2.8),('12664','2013-06-06','16:55:00',2.73),('12664','2013-06-06','17:00:00',2.64),('12664','2013-06-06','17:05:00',2.56),('12664','2013-06-06','17:10:00',2.48),('12664','2013-06-06','17:15:00',2.37),('12664','2013-06-06','17:20:00',2.34),('12664','2013-06-06','17:25:00',2.27),('12664','2013-06-06','17:30:00',2.17),('12664','2013-06-06','17:35:00',2.09),('12664','2013-06-06','17:40:00',2),('12664','2013-06-06','17:45:00',1.91),('12664','2013-06-06','17:50:00',1.83),('12664','2013-06-06','17:55:00',1.72),('12664','2013-06-06','18:00:00',1.63),('12664','2013-06-06','18:05:00',1.56),('12664','2013-06-06','18:10:00',1.46),('12664','2013-06-06','18:15:00',1.35),('12664','2013-06-06','18:20:00',1.25),('12664','2013-06-06','18:25:00',1.16),('12664','2013-06-06','18:30:00',1.06),('12664','2013-06-05','07:30:00',1.05),('12664','2013-06-05','07:35:00',1.14),('12664','2013-06-05','07:40:00',1.16),('12664','2013-06-05','07:45:00',1.27),('12664','2013-06-05','07:50:00',1.4),('12664','2013-06-05','07:55:00',1.46),('12664','2013-06-05','08:00:00',1.57),('12664','2013-06-05','08:05:00',1.66),('12664','2013-06-05','08:10:00',1.77),('12664','2013-06-05','08:15:00',1.84),('12664','2013-06-05','08:20:00',1.94),('12664','2013-06-05','08:25:00',2.02),('12664','2013-06-05','08:30:00',2.09),('12664','2013-06-05','08:35:00',2.22),('12664','2013-06-05','08:40:00',2.27),('12664','2013-06-05','08:45:00',2.38),('12664','2013-06-05','08:50:00',2.45),('12664','2013-06-05','08:55:00',2.54),('12664','2013-06-05','09:00:00',2.75),('12664','2013-06-05','09:05:00',3.05),('12664','2013-06-05','09:10:00',2.52),('12664','2013-06-05','09:15:00',1.4),('12664','2013-06-05','09:20:00',1.49),('12664','2013-06-05','09:25:00',1.56),('12664','2013-06-05','09:30:00',1.64),('12664','2013-06-05','09:35:00',1.26),('12664','2013-06-05','09:40:00',1.44),('12664','2013-06-05','09:45:00',3.6),('12664','2013-06-05','09:50:00',3.32),('12664','2013-06-05','09:55:00',1.59),('12664','2013-06-05','10:00:00',1.78),('12664','2013-06-05','10:05:00',2.89),('12664','2013-06-05','10:10:00',2.46),('12664','2013-06-05','10:15:00',2.62),('12664','2013-06-05','10:20:00',3.99),('12664','2013-06-05','10:25:00',3.89),('12664','2013-06-05','10:30:00',3.19),('12664','2013-06-05','10:35:00',3.85),('12664','2013-06-05','10:40:00',4.36),('12664','2013-06-05','10:45:00',4.59),('12664','2013-06-05','10:50:00',3.58),('12664','2013-06-05','10:55:00',2.69),('12664','2013-06-05','11:00:00',2.97),('12664','2013-06-05','11:05:00',2.29),('12664','2013-06-05','11:10:00',1.61),('12664','2013-06-05','11:15:00',1.72),('12664','2013-06-05','11:20:00',1.67),('12664','2013-06-05','11:25:00',2),('12664','2013-06-05','11:30:00',4.4),('12664','2013-06-05','11:35:00',2.75),('12664','2013-06-05','11:40:00',2.73),('12664','2013-06-05','11:45:00',1.35),('12664','2013-06-05','11:50:00',3.42),('12664','2013-06-05','11:55:00',3.79),('12664','2013-06-05','12:00:00',1.7),('12664','2013-06-05','12:05:00',3.04),('12664','2013-06-05','12:10:00',3.63),('12664','2013-06-05','12:15:00',4.47),('12664','2013-06-05','12:20:00',4.47),('12664','2013-06-05','12:25:00',3.82),('12664','2013-06-05','12:30:00',5.02),('12664','2013-06-05','12:35:00',5),('12664','2013-06-05','12:40:00',3.71),('12664','2013-06-05','12:45:00',4.54),('12664','2013-06-05','12:50:00',3.14),('12664','2013-06-05','12:55:00',4.79),('12664','2013-06-05','13:00:00',4.71),('12664','2013-06-05','13:05:00',4.87),('12664','2013-06-05','13:10:00',5.02),('12664','2013-06-05','13:15:00',3.79),('12664','2013-06-05','13:20:00',4.55),('12664','2013-06-05','13:25:00',4.5),('12664','2013-06-05','13:30:00',4.83),('12664','2013-06-05','13:35:00',4.99),('12664','2013-06-05','13:40:00',3.69),('12664','2013-06-05','13:45:00',4.76),('12664','2013-06-05','13:50:00',4.68),('12664','2013-06-05','13:55:00',4.65),('12664','2013-06-05','14:00:00',4.63),('12664','2013-06-05','14:05:00',4.62),('12664','2013-06-05','14:10:00',4.25),('12664','2013-06-05','14:15:00',3.89),('12664','2013-06-05','14:20:00',3.86),('12664','2013-06-05','14:25:00',4.59),('12664','2013-06-05','14:30:00',4.58),('12664','2013-06-05','14:35:00',4.62),('12664','2013-06-05','14:40:00',4.5),('12664','2013-06-05','14:45:00',4.4),('12664','2013-06-05','14:50:00',4.37),('12664','2013-06-05','14:55:00',4.42),('12664','2013-06-05','15:00:00',4.19),('12664','2013-06-05','15:05:00',3.86),('12664','2013-06-05','15:10:00',4.1),('12664','2013-06-05','15:15:00',3.04),('12664','2013-06-05','15:20:00',4.23),('12664','2013-06-05','15:25:00',3.93),('12664','2013-06-05','15:30:00',3.95),('12664','2013-06-05','15:35:00',4.07),('12664','2013-06-05','15:40:00',3.22),('12664','2013-06-05','15:45:00',3.92),('12664','2013-06-05','15:50:00',3.24),('12664','2013-06-05','15:55:00',3.94),('12664','2013-06-05','16:00:00',3.2),('12664','2013-06-05','16:05:00',3.16),('12664','2013-06-05','16:10:00',2.25),('12664','2013-06-05','16:15:00',2.99),('12664','2013-06-05','16:20:00',3.48),('12664','2013-06-05','16:25:00',1.57),('12664','2013-06-05','16:30:00',3.04),('12664','2013-06-05','16:35:00',3.59),('12664','2013-06-05','16:40:00',2.99),('12664','2013-06-05','16:45:00',2.68),('12664','2013-06-05','16:50:00',1.99),('12664','2013-06-05','16:55:00',1.61),('12664','2013-06-05','17:00:00',2.09),('12664','2013-06-05','17:05:00',1.7),('12664','2013-06-05','17:10:00',1.64),('12664','2013-06-05','17:15:00',1.22),('12664','2013-06-05','17:25:00',1.91),('12664','2013-06-05','17:30:00',1.47),('12664','2013-06-05','17:35:00',2.26),('12664','2013-06-05','17:40:00',2.09),('12664','2013-06-05','17:45:00',1.98),('12664','2013-06-05','17:50:00',1.27),('12664','2013-06-05','17:55:00',1.16),('12664','2013-06-05','18:00:00',1.76),('12664','2013-06-05','18:15:00',1.32),('12664','2013-06-05','18:30:00',1.23),('12664','2013-06-04','07:30:00',1.21),('12664','2013-06-04','07:35:00',1.42),('12664','2013-06-04','07:40:00',1.6),('12664','2013-06-04','07:45:00',1.87),('12664','2013-06-04','07:50:00',2.06),('12664','2013-06-04','07:55:00',2.14),('12664','2013-06-04','08:00:00',2.26),('12664','2013-06-04','08:05:00',2.31),('12664','2013-06-04','08:10:00',2.43),('12664','2013-06-04','08:15:00',2.47),('12664','2013-06-04','08:20:00',2.37),('12664','2013-06-04','08:25:00',2.75),('12664','2013-06-04','08:30:00',2.2),('12664','2013-06-04','08:35:00',1.9),('12664','2013-06-04','08:40:00',1.38),('12664','2013-06-04','08:45:00',1.29),('12664','2013-06-04','08:50:00',1.64),('12664','2013-06-04','08:55:00',1.62),('12664','2013-06-04','09:00:00',1.75),('12664','2013-06-04','09:05:00',1.96),('12664','2013-06-04','09:10:00',2.9),('12664','2013-06-04','09:15:00',2.12),('12664','2013-06-04','09:20:00',1.69),('12664','2013-06-04','09:25:00',1.6),('12664','2013-06-04','09:30:00',1.59),('12664','2013-06-04','09:35:00',1.71),('12664','2013-06-04','09:40:00',1.68),('12664','2013-06-04','09:45:00',1.74),('12664','2013-06-04','09:50:00',1.51),('12664','2013-06-04','09:55:00',1.31),('12664','2013-06-04','10:00:00',1.42),('12664','2013-06-04','10:05:00',1.78),('12664','2013-06-04','10:10:00',2.55),('12664','2013-06-04','10:15:00',2),('12664','2013-06-04','10:20:00',1.65),('12664','2013-06-04','10:25:00',1.63),('12664','2013-06-04','10:30:00',1.74),('12664','2013-06-04','10:35:00',2.14),('12664','2013-06-04','10:40:00',2.39),('12664','2013-06-04','10:45:00',2.65),('12664','2013-06-04','10:50:00',2.36),('12664','2013-06-04','10:55:00',2.39),('12664','2013-06-04','11:00:00',3.1),('12664','2013-06-04','11:05:00',2.99),('12664','2013-06-04','11:10:00',2.31),('12664','2013-06-04','11:15:00',2.69),('12664','2013-06-04','11:20:00',3.15),('12664','2013-06-04','11:25:00',3.1),('12664','2013-06-04','11:30:00',3.06),('12664','2013-06-04','11:35:00',3.49),('12664','2013-06-04','11:40:00',4.23),('12664','2013-06-04','11:45:00',4.52),('12664','2013-06-04','11:50:00',3.58),('12664','2013-06-04','11:55:00',4.1),('12664','2013-06-04','12:00:00',3.21),('12664','2013-06-04','12:05:00',2.49),('12664','2013-06-04','12:10:00',2.19),('12664','2013-06-04','12:15:00',3.11),('12664','2013-06-04','12:20:00',2.62),('12664','2013-06-04','12:25:00',2.8),('12664','2013-06-04','12:30:00',1.7),('12664','2013-06-04','12:35:00',1.2),('12664','2013-06-04','12:40:00',1.22),('12664','2013-06-04','12:45:00',1.3),('12664','2013-06-04','12:50:00',1.55),('12664','2013-06-04','12:55:00',1.32),('12664','2013-06-04','13:00:00',1.2),('12664','2013-06-04','13:05:00',1.35),('12664','2013-06-04','13:10:00',1.66),('12664','2013-06-04','13:15:00',1.9),('12664','2013-06-04','13:20:00',3.13),('12664','2013-06-04','13:25:00',2.65),('12664','2013-06-04','13:30:00',2.6),('12664','2013-06-04','13:35:00',2.68),('12664','2013-06-04','13:40:00',2.99),('12664','2013-06-04','13:45:00',3.68),('12664','2013-06-04','13:50:00',2.9),('12664','2013-06-04','13:55:00',2.57),('12664','2013-06-04','14:00:00',4.35),('12664','2013-06-04','14:05:00',4.31),('12664','2013-06-04','14:10:00',2.99),('12664','2013-06-04','14:15:00',1.04),('12664','2013-06-04','14:25:00',1.15),('12664','2013-06-04','14:30:00',1.81),('12664','2013-06-04','14:35:00',3.48),('12664','2013-06-04','14:40:00',4.75),('12664','2013-06-04','14:45:00',5.03),('12664','2013-06-04','14:50:00',2.73),('12664','2013-06-04','14:55:00',3.67),('12664','2013-06-04','15:00:00',2.4),('12664','2013-06-04','15:05:00',2.3),('12664','2013-06-04','15:10:00',4.74),('12664','2013-06-04','15:15:00',3.49),('12664','2013-06-04','15:20:00',2.08),('12664','2013-06-04','15:25:00',1.8),('12664','2013-06-04','15:30:00',1.39),('12664','2013-06-04','15:50:00',1.02),('12664','2013-06-04','16:10:00',1.2),('12664','2013-06-04','16:15:00',1),('12664','2013-06-04','16:40:00',1.22),('12664','2013-06-04','18:40:00',1.11),('12664','2013-06-04','18:45:00',1.01),('12664','2013-06-03','07:20:00',1.03),('12664','2013-06-03','07:25:00',1.27),('12664','2013-06-03','07:30:00',1.42),('12664','2013-06-03','07:35:00',1.46),('12664','2013-06-03','07:40:00',1.39),('12664','2013-06-03','07:45:00',1.27),('12664','2013-06-03','07:50:00',1.23),('12664','2013-06-03','07:55:00',1.47),('12664','2013-06-03','08:00:00',1.59),('12664','2013-06-03','08:05:00',1.67),('12664','2013-06-03','08:10:00',1.76),('12664','2013-06-03','08:15:00',1.87),('12664','2013-06-03','08:20:00',1.97),('12664','2013-06-03','08:25:00',2.05),('12664','2013-06-03','08:30:00',1.89),('12664','2013-06-03','08:35:00',1.9),('12664','2013-06-03','08:40:00',2.04),('12664','2013-06-03','08:45:00',1.62),('12664','2013-06-03','08:50:00',2.13),('12664','2013-06-03','08:55:00',2.54),('12664','2013-06-03','09:05:00',1.04),('12664','2013-06-03','09:10:00',2.37),('12664','2013-06-03','09:15:00',2.36),('12664','2013-06-03','09:20:00',1.74),('12664','2013-06-03','09:25:00',1.85),('12664','2013-06-03','09:30:00',2.47),('12664','2013-06-03','09:35:00',2.07),('12664','2013-06-03','09:40:00',1.47),('12664','2013-06-03','09:45:00',1.28),('12664','2013-06-03','09:50:00',1.5),('12664','2013-06-03','09:55:00',1.45),('12664','2013-06-03','10:00:00',1.05),('12664','2013-06-03','10:25:00',1.27),('12664','2013-06-03','10:30:00',1.49),('12664','2013-06-03','10:35:00',1.86),('12664','2013-06-03','10:40:00',2.98),('12664','2013-06-03','10:45:00',4.48),('12664','2013-06-03','10:50:00',2.62),('12664','2013-06-03','10:55:00',1.85),('12664','2013-06-03','11:00:00',2.98),('12664','2013-06-03','11:05:00',2.62),('12664','2013-06-03','11:10:00',4.72),('12664','2013-06-03','11:15:00',3.46),('12664','2013-06-03','11:20:00',2.35),('12664','2013-06-03','11:25:00',2.53),('12664','2013-06-03','11:30:00',3.12),('12664','2013-06-03','11:35:00',3.09),('12664','2013-06-03','11:40:00',3.28),('12664','2013-06-03','11:45:00',4.9),('12664','2013-06-03','11:50:00',4.28),('12664','2013-06-03','11:55:00',2.37),('12664','2013-06-03','12:00:00',2.09),('12664','2013-06-03','12:05:00',4.95),('12664','2013-06-03','12:10:00',2.89),('12664','2013-06-03','12:15:00',2.78),('12664','2013-06-03','12:20:00',2.12),('12664','2013-06-03','12:25:00',2.03),('12664','2013-06-03','12:30:00',1.71),('12664','2013-06-03','12:35:00',1.29),('12664','2013-06-03','12:40:00',1.14),('12664','2013-06-03','12:45:00',1.21),('12664','2013-06-03','12:50:00',1.29),('12664','2013-06-03','12:55:00',1.22),('12664','2013-06-03','13:00:00',1.32),('12664','2013-06-03','13:05:00',1.2),('12664','2013-06-03','13:10:00',1.45),('12664','2013-06-03','13:15:00',2.44),('12664','2013-06-03','13:20:00',4.8),('12664','2013-06-03','13:25:00',4.24),('12664','2013-06-03','13:30:00',1.81),('12664','2013-06-03','13:35:00',2.05),('12664','2013-06-03','13:40:00',1.8),('12664','2013-06-03','13:45:00',3.53),('12664','2013-06-03','13:50:00',2.57),('12664','2013-06-03','13:55:00',1.82),('12664','2013-06-03','14:00:00',1.09),('12664','2013-06-03','14:10:00',1.85),('12664','2013-06-03','14:15:00',3.76),('12664','2013-06-03','14:20:00',4.41),('12664','2013-06-03','14:25:00',5.01),('12664','2013-06-03','14:30:00',4.75),('12664','2013-06-03','14:35:00',4.56),('12664','2013-06-03','14:40:00',4.58),('12664','2013-06-03','14:45:00',4.5),('12664','2013-06-03','14:50:00',4.33),('12664','2013-06-03','14:55:00',4.35),('12664','2013-06-03','15:00:00',4.11),('12664','2013-06-03','15:05:00',4.05),('12664','2013-06-03','15:10:00',4.41),('12664','2013-06-03','15:15:00',4.38),('12664','2013-06-03','15:20:00',3.88),('12664','2013-06-03','15:25:00',4.31),('12664','2013-06-03','15:30:00',4.12),('12664','2013-06-03','15:35:00',2.64),('12664','2013-06-03','15:40:00',2.48),('12664','2013-06-03','15:45:00',3.95),('12664','2013-06-03','15:50:00',3.87),('12664','2013-06-03','15:55:00',3.87),('12664','2013-06-03','16:00:00',3.74),('12664','2013-06-03','16:05:00',3.65),('12664','2013-06-03','16:10:00',3.58),('12664','2013-06-03','16:15:00',3.29),('12664','2013-06-03','16:20:00',3.39),('12664','2013-06-03','16:25:00',3.26),('12664','2013-06-03','16:30:00',2.59),('12664','2013-06-03','16:35:00',2.59),('12664','2013-06-03','16:40:00',2.41),('12664','2013-06-03','16:45:00',2.21),('12664','2013-06-03','16:50:00',3.27),('12664','2013-06-03','16:55:00',3.12),('12664','2013-06-03','17:00:00',3.09),('12664','2013-06-03','17:05:00',2.49),('12664','2013-06-03','17:10:00',2.15),('12664','2013-06-03','17:15:00',1.92),('12664','2013-06-03','17:20:00',2.02),('12664','2013-06-03','17:25:00',1.55),('12664','2013-06-03','17:30:00',1.56),('12664','2013-06-03','17:45:00',1.01),('12664','2013-06-03','17:50:00',1.05),('12664','2013-06-02','08:40:00',2.28),('12664','2013-06-02','08:45:00',1.05),('12664','2013-06-02','08:50:00',1),('12664','2013-06-02','09:10:00',1.34),('12664','2013-06-02','09:15:00',1.47),('12664','2013-06-02','09:20:00',3.28),('12664','2013-06-02','09:25:00',3.27),('12664','2013-06-02','09:30:00',3.3),('12664','2013-06-02','09:35:00',3.37),('12664','2013-06-02','09:40:00',3.4),('12664','2013-06-02','09:45:00',3.44),('12664','2013-06-02','09:50:00',3.5),('12664','2013-06-02','09:55:00',3.55),('12664','2013-06-02','10:00:00',3.61),('12664','2013-06-02','10:05:00',3.64),('12664','2013-06-02','10:10:00',3.72),('12664','2013-06-02','10:15:00',3.77),('12664','2013-06-02','10:20:00',3.85),('12664','2013-06-02','10:25:00',3.84),('12664','2013-06-02','10:30:00',3.98),('12664','2013-06-02','10:35:00',3.97),('12664','2013-06-02','10:40:00',4.3),('12664','2013-06-02','10:45:00',4.05),('12664','2013-06-02','10:50:00',4.33),('12664','2013-06-02','10:55:00',3.71),('12664','2013-06-02','11:00:00',2.59),('12664','2013-06-02','11:05:00',2.39),('12664','2013-06-02','11:10:00',3.12),('12664','2013-06-02','11:15:00',4.08),('12664','2013-06-02','11:20:00',3.6),('12664','2013-06-02','11:25:00',4.52),('12664','2013-06-02','11:30:00',3.73),('12664','2013-06-02','11:35:00',5.01),('12664','2013-06-02','11:40:00',4.12),('12664','2013-06-02','11:45:00',3.85),('12664','2013-06-02','11:50:00',5.01),('12664','2013-06-02','11:55:00',3.94),('12664','2013-06-02','12:00:00',2.16),('12664','2013-06-02','12:05:00',5.03),('12664','2013-06-02','12:10:00',4.74),('12664','2013-06-02','12:15:00',4.57),('12664','2013-06-02','12:20:00',4.89),('12664','2013-06-02','12:25:00',4.78),('12664','2013-06-02','12:30:00',4.45),('12664','2013-06-02','12:35:00',4.73),('12664','2013-06-02','12:40:00',4.72),('12664','2013-06-02','12:45:00',4.73),('12664','2013-06-02','12:50:00',3.76),('12664','2013-06-02','12:55:00',4.78),('12664','2013-06-02','13:00:00',4.18),('12664','2013-06-02','13:05:00',4.86),('12664','2013-06-02','13:10:00',4.81),('12664','2013-06-02','13:15:00',4.72),('12664','2013-06-02','13:20:00',4.71),('12664','2013-06-02','13:25:00',4.48),('12664','2013-06-02','13:30:00',4.7),('12664','2013-06-02','13:35:00',4.65),('12664','2013-06-02','13:40:00',4.67),('12664','2013-06-02','13:45:00',4.66),('12664','2013-06-02','13:50:00',4.4),('12664','2013-06-02','13:55:00',4.67),('12664','2013-06-02','14:00:00',4.68),('12664','2013-06-02','14:05:00',4.66),('12664','2013-06-02','14:10:00',4.73),('12664','2013-06-02','14:15:00',4.73),('12664','2013-06-02','14:20:00',4.5),('12664','2013-06-02','14:25:00',4.67),('12664','2013-06-02','14:30:00',4.48),('12664','2013-06-02','14:35:00',4.34),('12664','2013-06-02','14:40:00',4.45),('12664','2013-06-02','14:45:00',4.41),('12664','2013-06-02','14:50:00',4.41),('12664','2013-06-02','14:55:00',4.33),('12664','2013-06-02','15:00:00',4.33),('12664','2013-06-02','15:05:00',4.16),('12664','2013-06-02','15:10:00',3.41),('12664','2013-06-02','15:15:00',4.39),('12664','2013-06-02','15:20:00',4),('12664','2013-06-02','15:25:00',2.68),('12664','2013-06-02','15:30:00',2.9),('12664','2013-06-02','15:35:00',4.39),('12664','2013-06-02','15:40:00',2.91),('12664','2013-06-02','15:45:00',4.46),('12664','2013-06-02','15:50:00',2.5),('12664','2013-06-02','15:55:00',2.92),('12664','2013-06-02','16:00:00',2.86),('12664','2013-06-02','16:05:00',4.23),('12664','2013-06-02','16:10:00',3.2),('12664','2013-06-02','16:15:00',2.96),('12664','2013-06-02','16:20:00',3.59),('12664','2013-06-02','16:25:00',3.6),('12664','2013-06-02','16:30:00',3.43),('12664','2013-06-02','16:35:00',3.17),('12664','2013-06-02','16:40:00',3.13),('12664','2013-06-02','16:45:00',1.79),('12664','2013-06-02','16:50:00',2.39),('12664','2013-06-02','16:55:00',2.97),('12664','2013-06-02','17:00:00',2.52),('12664','2013-06-02','17:05:00',2.76),('12664','2013-06-02','17:10:00',2.7),('12664','2013-06-02','17:15:00',2.58),('12664','2013-06-02','17:20:00',1.84),('12664','2013-06-02','17:25:00',1.99),('12664','2013-06-02','17:30:00',1.69),('12664','2013-06-02','17:35:00',2.04),('12664','2013-06-02','17:40:00',1.41),('12664','2013-06-02','17:45:00',1.19),('12664','2013-06-02','17:50:00',1.7),('12664','2013-06-02','17:55:00',1.95),('12664','2013-06-02','18:00:00',1.06),('12664','2013-06-02','18:35:00',1.16),('12664','2013-06-01','07:30:00',1.06),('12664','2013-06-01','07:35:00',1.19),('12664','2013-06-01','07:40:00',1.37),('12664','2013-06-01','07:45:00',1.77),('12664','2013-06-01','07:50:00',1.41),('12664','2013-06-01','08:10:00',2.14),('12664','2013-06-01','08:15:00',1.02),('12664','2013-06-01','08:25:00',1.57),('12664','2013-06-01','08:40:00',1.14),('12664','2013-06-01','08:45:00',1.59),('12664','2013-06-01','10:40:00',1.13),('12664','2013-06-01','10:45:00',1.54),('12664','2013-06-01','10:50:00',2.78),('12664','2013-06-01','10:55:00',2.66),('12664','2013-06-01','11:00:00',1.84),('12664','2013-06-01','11:05:00',1.81),('12664','2013-06-01','11:10:00',1.44),('12664','2013-06-01','11:15:00',1.54),('12664','2013-06-01','11:20:00',1.86),('12664','2013-06-01','11:25:00',1.91),('12664','2013-06-01','11:30:00',2.15),('12664','2013-06-01','11:35:00',3.81),('12664','2013-06-01','11:40:00',3.83),('12664','2013-06-01','11:45:00',3.43),('12664','2013-06-01','11:50:00',1.86),('12664','2013-06-01','11:55:00',1.06),('12664','2013-06-01','12:00:00',1.31),('12664','2013-06-01','12:05:00',1.41),('12664','2013-06-01','12:10:00',1.89),('12664','2013-06-01','12:15:00',1.58),('12664','2013-06-01','12:20:00',3.91),('12664','2013-06-01','12:25:00',3.2),('12664','2013-06-01','12:30:00',2.94),('12664','2013-06-01','12:35:00',2.37),('12664','2013-06-01','12:40:00',2.32),('12664','2013-06-01','12:45:00',2.19),('12664','2013-06-01','12:50:00',2.32),('12664','2013-06-01','12:55:00',2.39),('12664','2013-06-01','13:00:00',2.44),('12664','2013-06-01','13:05:00',2.46),('12664','2013-06-01','13:10:00',2.69),('12664','2013-06-01','13:15:00',2.76),('12664','2013-06-01','13:20:00',2.5),('12664','2013-06-01','13:25:00',2.37),('12664','2013-06-01','13:30:00',2.04),('12664','2013-06-01','13:35:00',2.07),('12664','2013-06-01','13:40:00',2.38),('12664','2013-06-01','13:45:00',1.88),('12664','2013-06-01','13:50:00',1.99),('12664','2013-06-01','13:55:00',2.18),('12664','2013-06-01','14:00:00',2.74),('12664','2013-06-01','14:05:00',2.7),('12664','2013-06-01','14:10:00',2.23),('12664','2013-06-01','14:15:00',2.72),('12664','2013-06-01','14:20:00',2.61),('12664','2013-06-01','14:25:00',1.78),('12664','2013-06-01','14:30:00',1.74),('12664','2013-06-01','14:35:00',1.72),('12664','2013-06-01','14:40:00',1.54),('12664','2013-06-01','14:45:00',1.44),('12664','2013-06-01','14:50:00',1.5),('12664','2013-06-01','14:55:00',1.01),('12664','2013-06-01','15:40:00',1.12),('12664','2013-06-01','15:45:00',1.56),('12664','2013-06-01','15:50:00',1.89),('12664','2013-06-01','15:55:00',1.63),('12664','2013-06-01','16:00:00',1.22),('12664','2013-06-01','16:15:00',1.29),('12664','2013-06-01','16:20:00',1.3),('12664','2013-06-01','16:25:00',1.24),('12664','2013-06-01','16:30:00',1.01),('12664','2013-06-01','16:35:00',1.08),('12664','2013-06-01','16:40:00',1.06),('12664','2013-06-01','18:20:00',1.34),('12664','2013-06-01','18:25:00',1.09),('12664','2013-06-01','18:30:00',1.19),('12664','2013-06-01','18:35:00',1.37),('12664','2013-06-01','18:40:00',1.31),('12664','2013-06-01','18:45:00',1.19),('12664','2013-06-01','18:50:00',1.33),('12664','2013-05-31','07:30:00',1.05),('12664','2013-05-31','07:35:00',1.16),('12664','2013-05-31','07:40:00',1.28),('12664','2013-05-31','07:45:00',1.36),('12664','2013-05-31','07:50:00',1.51),('12664','2013-05-31','07:55:00',1.68),('12664','2013-05-31','08:00:00',1.1),('12664','2013-05-31','08:10:00',1.7),('12664','2013-05-31','08:15:00',1.94),('12664','2013-05-31','08:20:00',2.05),('12664','2013-05-31','08:25:00',2.08),('12664','2013-05-31','08:30:00',2.25),('12664','2013-05-31','08:35:00',2.35),('12664','2013-05-31','08:40:00',2.7),('12664','2013-05-31','08:45:00',1.4),('12664','2013-05-31','08:50:00',1.29),('12664','2013-05-31','08:55:00',1.82),('12664','2013-05-31','09:00:00',1.85),('12664','2013-05-31','09:05:00',1.87),('12664','2013-05-31','09:10:00',1.43),('12664','2013-05-31','09:20:00',2.58),('12664','2013-05-31','09:25:00',3.47),('12664','2013-05-31','09:30:00',2.96),('12664','2013-05-31','09:35:00',2.68),('12664','2013-05-31','09:40:00',3.46),('12664','2013-05-31','09:45:00',3.37),('12664','2013-05-31','09:50:00',3.72),('12664','2013-05-31','09:55:00',4.09),('12664','2013-05-31','10:00:00',4.23),('12664','2013-05-31','10:05:00',4.06),('12664','2013-05-31','10:10:00',2.66),('12664','2013-05-31','10:15:00',1.38),('12664','2013-05-31','10:20:00',2.53),('12664','2013-05-31','10:25:00',3.46),('12664','2013-05-31','10:30:00',4.39),('12664','2013-05-31','10:35:00',4.31),('12664','2013-05-31','10:40:00',4.57),('12664','2013-05-31','10:45:00',4.81),('12664','2013-05-31','10:50:00',3.3),('12664','2013-05-31','10:55:00',3.04),('12664','2013-05-31','11:00:00',2.18),('12664','2013-05-31','11:05:00',1.94),('12664','2013-05-31','11:10:00',2.69),('12664','2013-05-31','11:15:00',2.2),('12664','2013-05-31','11:20:00',3.32),('12664','2013-05-31','11:25:00',3.57),('12664','2013-05-31','11:30:00',1.27),('12664','2013-05-31','11:35:00',2.9),('12664','2013-05-31','11:40:00',2.65),('12664','2013-05-31','11:45:00',2.05),('12664','2013-05-31','11:50:00',3.3),('12664','2013-05-31','11:55:00',2.81),('12664','2013-05-31','12:00:00',3.34),('12664','2013-05-31','12:05:00',3.63),('12664','2013-05-31','12:10:00',2.26),('12664','2013-05-31','12:15:00',3.19),('12664','2013-05-31','12:20:00',4.1),('12664','2013-05-31','12:25:00',2.1),('12664','2013-05-31','12:30:00',1.74),('12664','2013-05-31','12:35:00',1.18),('12664','2013-05-31','12:45:00',1.37),('12664','2013-05-31','12:50:00',4.63),('12664','2013-05-31','12:55:00',3.86),('12664','2013-05-31','13:00:00',1.69),('12664','2013-05-31','13:05:00',1.31),('12664','2013-05-31','13:10:00',1.97),('12664','2013-05-31','13:15:00',3.38),('12664','2013-05-31','13:20:00',3.19),('12664','2013-05-31','13:25:00',3.91),('12664','2013-05-31','13:30:00',1.33),('12664','2013-05-31','13:35:00',1.06),('12664','2013-05-31','13:40:00',2.31),('12664','2013-05-31','13:45:00',3.66),('12664','2013-05-31','13:50:00',2.76),('12664','2013-05-31','13:55:00',1.62),('12664','2013-05-31','14:25:00',2.16),('12664','2013-05-31','14:30:00',2.07),('12664','2013-05-31','14:35:00',1.18),('12664','2013-05-31','14:55:00',1.74),('12664','2013-05-31','15:00:00',1.18),('12664','2013-05-31','15:05:00',1.63),('12664','2013-05-31','15:10:00',3.09),('12664','2013-05-31','15:15:00',2.68),('12664','2013-05-31','15:20:00',1.96),('12664','2013-05-31','15:25:00',2.01),('12664','2013-05-31','15:30:00',1.91),('12664','2013-05-31','15:35:00',1.85),('12664','2013-05-31','15:40:00',1.69),('12664','2013-05-31','15:45:00',2.93),('12664','2013-05-31','15:50:00',2.27),('12664','2013-05-31','15:55:00',2.09),('12664','2013-05-31','16:00:00',1.3),('12664','2013-05-31','16:15:00',1.04),('12664','2013-05-31','16:20:00',1.43),('12664','2013-05-31','16:25:00',1.16),('12664','2013-05-31','16:40:00',1.12),('12664','2014-04-01','08:25:00',1.06),('12664','2014-04-01','08:30:00',1.15),('12664','2014-04-01','08:35:00',1.25),('12664','2014-04-01','08:40:00',1.34),('12664','2014-04-01','08:45:00',1.44),('12664','2014-04-01','08:50:00',1.54),('12664','2014-04-01','08:55:00',1.63),('12664','2014-04-01','09:00:00',1.73),('12664','2014-04-01','09:05:00',1.83),('12664','2014-04-01','09:10:00',1.91),('12664','2014-04-01','09:15:00',2.01),('12664','2014-04-01','09:20:00',2.08),('12664','2014-04-01','09:25:00',2.16),('12664','2014-04-01','09:30:00',2.21),('12664','2014-04-01','09:35:00',2.25),('12664','2014-04-01','09:40:00',2.36),('12664','2014-04-01','09:45:00',2.44),('12664','2014-04-01','09:50:00',2.59),('12664','2014-04-01','09:55:00',2.68),('12664','2014-04-01','10:00:00',2.77),('12664','2014-04-01','10:05:00',2.84),('12664','2014-04-01','10:10:00',2.91),('12664','2014-04-01','10:15:00',2.96),('12664','2014-04-01','10:20:00',3.02),('12664','2014-04-01','10:25:00',3.07),('12664','2014-04-01','10:30:00',3.14),('12664','2014-04-01','10:35:00',3.16),('12664','2014-04-01','10:40:00',3.27),('12664','2014-04-01','10:45:00',3.28),('12664','2014-04-01','10:50:00',3.34),('12664','2014-04-01','10:55:00',3.49),('12664','2014-04-01','11:00:00',3.48),('12664','2014-04-01','11:05:00',3.52),('12664','2014-04-01','11:10:00',3.62),('12664','2014-04-01','11:15:00',3.58),('12664','2014-04-01','11:20:00',3.63),('12664','2014-04-01','11:25:00',3.68),('12664','2014-04-01','11:30:00',3.63),('12664','2014-04-01','11:35:00',3.59),('12664','2014-04-01','11:40:00',3.73),('12664','2014-04-01','11:45:00',3.81),('12664','2014-04-01','11:50:00',3.58),('12664','2014-04-01','11:55:00',3.64),('12664','2014-04-01','12:00:00',3.94),('12664','2014-04-01','12:05:00',3.98),('12664','2014-04-01','12:10:00',4.01),('12664','2014-04-01','12:15:00',4.08),('12664','2014-04-01','12:20:00',4.1),('12664','2014-04-01','12:25:00',4.13),('12664','2014-04-01','12:30:00',4.16),('12664','2014-04-01','12:35:00',4.22),('12664','2014-04-01','12:40:00',4.35),('12664','2014-04-01','12:45:00',4.01),('12664','2014-04-01','12:50:00',4.21),('12664','2014-04-01','12:55:00',4.12),('12664','2014-04-01','13:00:00',4.25),('12664','2014-04-01','13:05:00',4.25),('12664','2014-04-01','13:10:00',4.24),('12664','2014-04-01','13:15:00',4.11),('12664','2014-04-01','13:20:00',4.26),('12664','2014-04-01','13:25:00',4.35),('12664','2014-04-01','13:30:00',3.89),('12664','2014-04-01','13:35:00',4.45),('12664','2014-04-01','13:40:00',4.42),('12664','2014-04-01','13:45:00',3.96),('12664','2014-04-01','13:50:00',4.28),('12664','2014-04-01','13:55:00',3.81),('12664','2014-04-01','14:00:00',3.98),('12664','2014-04-01','14:05:00',3.98),('12664','2014-04-01','14:10:00',4.21),('12664','2014-04-01','14:15:00',4.09),('12664','2014-04-01','14:20:00',4.05),('12664','2014-04-01','14:25:00',3.63),('12664','2014-04-01','14:30:00',4.17),('12664','2014-04-01','14:35:00',4.2),('12664','2014-04-01','14:40:00',4.08),('12664','2014-04-01','14:45:00',3.76),('12664','2014-04-01','14:50:00',3.55),('12664','2014-04-01','14:55:00',3.95),('12664','2014-04-01','15:00:00',3.75),('12664','2014-04-01','15:05:00',3.42),('12664','2014-04-01','15:10:00',3.16),('12664','2014-04-01','15:15:00',3.09),('12664','2014-04-01','15:20:00',3.71),('12664','2014-04-01','15:25:00',3.31),('12664','2014-04-01','15:30:00',3.69),('12664','2014-04-01','15:35:00',3.01),('12664','2014-04-01','15:40:00',2.89),('12664','2014-04-01','15:45:00',3.45),('12664','2014-04-01','15:50:00',3.45),('12664','2014-04-01','15:55:00',2.15),('12664','2014-04-01','16:00:00',1.93),('12664','2014-04-01','16:05:00',1.7),('12664','2014-04-01','16:10:00',2.86),('12664','2014-04-01','16:15:00',3.03),('12664','2014-04-01','16:20:00',2.13),('12664','2014-04-01','16:25:00',2.76),('12664','2014-04-01','16:30:00',2.69),('12664','2014-04-01','16:35:00',1.65),('12664','2014-04-01','16:40:00',2.06),('12664','2014-04-01','16:50:00',2.23),('12664','2014-04-01','16:55:00',2.08),('12664','2014-04-01','17:00:00',2.21),('12664','2014-04-01','17:05:00',2.11),('12664','2014-04-01','17:10:00',1.44),('12664','2014-04-01','17:15:00',1.4),('12664','2014-04-01','17:20:00',1.54),('12664','2014-04-01','17:25:00',1.58),('12664','2014-04-01','17:30:00',1.49),('12664','2014-04-01','17:35:00',1.39),('12664','2014-04-01','17:40:00',1.3),('12664','2014-04-01','17:45:00',1.15),('12664','2014-04-01','17:50:00',1.06),('12664','2014-04-01','17:55:00',1.02),('12664','2013-05-30','07:40:00',1.43),('12664','2013-05-30','07:45:00',1.62),('12664','2013-05-30','07:50:00',1.14),('12664','2013-05-30','08:25:00',1.79),('12664','2013-05-30','08:30:00',2.36),('12664','2013-05-30','08:35:00',2.43),('12664','2013-05-30','08:40:00',2.5),('12664','2013-05-30','08:45:00',2.57),('12664','2013-05-30','08:50:00',2.67),('12664','2013-05-30','08:55:00',2.78),('12664','2013-05-30','09:00:00',2.9),('12664','2013-05-30','09:05:00',2.99),('12664','2013-05-30','09:10:00',3.14),('12664','2013-05-30','09:15:00',3.1),('12664','2013-05-30','09:20:00',3.2),('12664','2013-05-30','09:25:00',2.77),('12664','2013-05-30','09:30:00',2.92),('12664','2013-05-30','09:35:00',3.61),('12664','2013-05-30','09:40:00',3.45),('12664','2013-05-30','09:45:00',3.5),('12664','2013-05-30','09:50:00',3.05),('12664','2013-05-30','09:55:00',3),('12664','2013-05-30','10:00:00',2.97),('12664','2013-05-30','10:05:00',3.36),('12664','2013-05-30','10:10:00',2.87),('12664','2013-05-30','10:15:00',3.88),('12664','2013-05-30','10:20:00',4.01),('12664','2013-05-30','10:30:00',1.44),('12664','2013-05-30','10:35:00',3.75),('12664','2013-05-30','10:40:00',4.52),('12664','2013-05-30','10:45:00',4.65),('12664','2013-05-30','10:50:00',4.74),('12664','2013-05-30','10:55:00',2.94),('12664','2013-05-30','11:00:00',2.8),('12664','2013-05-30','11:05:00',3.47),('12664','2013-05-30','11:10:00',5.02),('12664','2013-05-30','11:15:00',2.76),('12664','2013-05-30','11:20:00',4.85),('12664','2013-05-30','11:25:00',1.5),('12664','2013-05-30','11:30:00',3.5),('12664','2013-05-30','11:35:00',2.83),('12664','2013-05-30','11:40:00',2.96),('12664','2013-05-30','11:45:00',3.33),('12664','2013-05-30','11:50:00',3.28),('12664','2013-05-30','11:55:00',2.7),('12664','2013-05-30','12:00:00',1.06),('12664','2013-05-30','12:05:00',3.37),('12664','2013-05-30','12:10:00',3.67),('12664','2013-05-30','12:15:00',3.77),('12664','2013-05-30','12:20:00',3.81),('12664','2013-05-30','12:25:00',3.77),('12664','2013-05-30','12:30:00',4.76),('12664','2013-05-30','12:35:00',3.64),('12664','2013-05-30','12:40:00',2.67),('12664','2013-05-30','12:45:00',3.99),('12664','2013-05-30','12:50:00',2.43),('12664','2013-05-30','12:55:00',3.56),('12664','2013-05-30','13:00:00',3.2),('12664','2013-05-30','13:05:00',2.98),('12664','2013-05-30','13:10:00',1.46),('12664','2013-05-30','13:15:00',2.16),('12664','2013-05-30','13:20:00',4.03),('12664','2013-05-30','13:25:00',4.7),('12664','2013-05-30','13:30:00',3.75),('12664','2013-05-30','13:35:00',4.29),('12664','2013-05-30','13:40:00',3.05),('12664','2013-05-30','13:45:00',4.03),('12664','2013-05-30','13:50:00',4.62),('12664','2013-05-30','13:55:00',4.34),('12664','2013-05-30','14:00:00',3.47),('12664','2013-05-30','14:05:00',3.88),('12664','2013-05-30','14:10:00',1.25),('12664','2013-05-30','14:15:00',1.99),('12664','2013-05-30','14:20:00',1.36),('12664','2013-05-30','14:25:00',2.93),('12664','2013-05-30','14:30:00',1.42),('12664','2013-05-30','14:35:00',3.56),('12664','2013-05-30','14:40:00',2.45),('12664','2013-05-30','14:45:00',1.72),('12664','2013-05-30','14:50:00',1.76),('12664','2013-05-30','14:55:00',2.64),('12664','2013-05-30','15:00:00',1.84),('12664','2013-05-30','15:05:00',3.2),('12664','2013-05-30','15:10:00',1.82),('12664','2013-05-30','15:15:00',4.75),('12664','2013-05-30','15:20:00',1.4),('12664','2013-05-30','15:25:00',4.54),('12664','2013-05-30','15:30:00',2.74),('12664','2013-05-30','15:35:00',2.94),('12664','2013-05-30','15:40:00',4),('12664','2013-05-30','15:45:00',3.57),('12664','2013-05-30','15:50:00',2.38),('12664','2013-05-30','15:55:00',3.54),('12664','2013-05-30','16:00:00',4.45),('12664','2013-05-30','16:05:00',4.14),('12664','2013-05-30','16:10:00',2.38),('12664','2013-05-30','16:15:00',1.14),('12664','2013-05-30','16:20:00',1.11),('12664','2013-05-30','16:25:00',1.37),('12664','2013-05-30','16:30:00',1.18),('12664','2013-05-30','16:35:00',2.31),('12664','2013-05-30','16:40:00',2.01),('12664','2013-05-30','16:45:00',1.24),('12664','2013-05-30','16:50:00',2.03),('12664','2013-05-30','16:55:00',3.64),('12664','2013-05-30','17:00:00',2.33),('12664','2013-05-30','17:50:00',1.21),('12664','2013-05-30','17:55:00',1.32),('12664','2013-05-30','18:00:00',2),('12664','2013-05-30','18:05:00',1.56),('12664','2013-05-30','18:20:00',1.17),('12664','2013-05-30','18:25:00',1.75),('12664','2013-05-30','18:30:00',1.85),('12664','2013-05-30','18:35:00',1.59),('12664','2013-05-30','18:40:00',1.08),('12664','2013-05-29','07:30:00',1.03),('12664','2013-05-29','07:35:00',1.13),('12664','2013-05-29','07:40:00',1.22),('12664','2013-05-29','07:45:00',1.32),('12664','2013-05-29','07:50:00',1.42),('12664','2013-05-29','07:55:00',1.51),('12664','2013-05-29','08:00:00',1.6),('12664','2013-05-29','08:05:00',1.7),('12664','2013-05-29','08:10:00',1.79),('12664','2013-05-29','08:15:00',1.88),('12664','2013-05-29','08:20:00',1.98),('12664','2013-05-29','08:25:00',2.07),('12664','2013-05-29','08:30:00',2.18),('12664','2013-05-29','08:35:00',2.26),('12664','2013-05-29','08:40:00',2.35),('12664','2013-05-29','08:45:00',2.45),('12664','2013-05-29','08:50:00',2.55),('12664','2013-05-29','08:55:00',2.65),('12664','2013-05-29','09:00:00',2.73),('12664','2013-05-29','09:05:00',2.82),('12664','2013-05-29','09:10:00',2.9),('12664','2013-05-29','09:15:00',2.97),('12664','2013-05-29','09:20:00',3.05),('12664','2013-05-29','09:25:00',3.13),('12664','2013-05-29','09:30:00',3.2),('12664','2013-05-29','09:35:00',3.29),('12664','2013-05-29','09:40:00',3.36),('12664','2013-05-29','09:45:00',3.42),('12664','2013-05-29','09:50:00',3.51),('12664','2013-05-29','09:55:00',3.56),('12664','2013-05-29','10:00:00',3.66),('12664','2013-05-29','10:05:00',3.67),('12664','2013-05-29','10:10:00',3.75),('12664','2013-05-29','10:15:00',3.81),('12664','2013-05-29','10:20:00',3.94),('12664','2013-05-29','10:25:00',3.99),('12664','2013-05-29','10:30:00',4.01),('12664','2013-05-29','10:35:00',4.08),('12664','2013-05-29','10:40:00',4.08),('12664','2013-05-29','10:45:00',4.29),('12664','2013-05-29','10:50:00',3.81),('12664','2013-05-29','10:55:00',2.99),('12664','2013-05-29','11:00:00',4.86),('12664','2013-05-29','11:05:00',4.38),('12664','2013-05-29','11:10:00',2.19),('12664','2013-05-29','11:15:00',2.4),('12664','2013-05-29','11:20:00',2.81),('12664','2013-05-29','11:25:00',3.1),('12664','2013-05-29','11:30:00',2.92),('12664','2013-05-29','11:35:00',4.29),('12664','2013-05-29','11:40:00',4.51),('12664','2013-05-29','11:45:00',4.49),('12664','2013-05-29','11:50:00',3.93),('12664','2013-05-29','11:55:00',4.99),('12664','2013-05-29','12:00:00',4.93),('12664','2013-05-29','12:05:00',4.84),('12664','2013-05-29','12:10:00',4.4),('12664','2013-05-29','12:15:00',4.52),('12664','2013-05-29','12:20:00',4.88),('12664','2013-05-29','12:25:00',4.18),('12664','2013-05-29','12:30:00',4.34),('12664','2013-05-29','12:35:00',4.91),('12664','2013-05-29','12:40:00',4.29),('12664','2013-05-29','12:45:00',4.87),('12664','2013-05-29','12:50:00',4.84),('12664','2013-05-29','12:55:00',4.93),('12664','2013-05-29','13:00:00',4.79),('12664','2013-05-29','13:05:00',4.91),('12664','2013-05-29','13:10:00',4.9),('12664','2013-05-29','13:15:00',2.82),('12664','2013-05-29','13:20:00',3.6),('12664','2013-05-29','13:25:00',4.96),('12664','2013-05-29','13:30:00',3.64),('12664','2013-05-29','13:35:00',3.28),('12664','2013-05-29','13:40:00',4.26),('12664','2013-05-29','13:45:00',3.77),('12664','2013-05-29','13:50:00',3.45),('12664','2013-05-29','13:55:00',4.67),('12664','2013-05-29','14:00:00',4.84),('12664','2013-05-29','14:05:00',4.97),('12664','2013-05-29','14:10:00',4.98),('12664','2013-05-29','14:15:00',4.66),('12664','2013-05-29','14:20:00',4.66),('12664','2013-05-29','14:25:00',4.67),('12664','2013-05-29','14:30:00',3.74),('12664','2013-05-29','14:35:00',2.72),('12664','2013-05-29','14:40:00',3.88),('12664','2013-05-29','14:45:00',3.86),('12664','2013-05-29','14:50:00',4.28),('12664','2013-05-29','14:55:00',3.28),('12664','2013-05-29','15:00:00',3.8),('12664','2013-05-29','15:05:00',3.68),('12664','2013-05-29','15:10:00',2.78),('12664','2013-05-29','15:15:00',3.52),('12664','2013-05-29','15:20:00',4.09),('12664','2013-05-29','15:25:00',3.3),('12664','2013-05-29','15:30:00',3.19),('12664','2013-05-29','15:35:00',3.39),('12664','2013-05-29','15:40:00',3.02),('12664','2013-05-29','15:45:00',3.74),('12664','2013-05-29','15:50:00',3.71),('12664','2013-05-29','15:55:00',3.58),('12664','2013-05-29','16:00:00',2.75),('12664','2013-05-29','16:05:00',2.75),('12664','2013-05-29','16:10:00',2.66),('12664','2013-05-29','16:15:00',2.93),('12664','2013-05-29','16:20:00',4.27),('12664','2013-05-29','16:25:00',2.95),('12664','2013-05-29','16:30:00',2.17),('12664','2013-05-29','16:35:00',2.02),('12664','2013-05-29','16:40:00',1.9),('12664','2013-05-29','16:45:00',1.36),('12664','2013-05-29','16:50:00',1),('12664','2013-05-29','17:25:00',1.11),('12664','2013-05-29','17:30:00',1.87),('12664','2013-05-29','17:35:00',2.05),('12664','2013-05-29','17:40:00',1.5),('12664','2013-05-29','17:55:00',1.21),('12664','2013-05-29','18:00:00',1.15),('12664','2013-05-29','18:05:00',1.24),('12664','2013-05-29','18:10:00',1.72),('12664','2013-05-29','18:15:00',1.43),('12664','2013-05-28','07:25:00',1.03),('12664','2013-05-28','07:30:00',1.19),('12664','2013-05-28','07:35:00',1.12),('12664','2013-05-28','07:45:00',1.35),('12664','2013-05-28','07:50:00',1.22),('12664','2013-05-28','07:55:00',1.1),('12664','2013-05-28','08:00:00',1.16),('12664','2013-05-28','08:05:00',1.51),('12664','2013-05-28','08:10:00',1.49),('12664','2013-05-28','08:15:00',1.79),('12664','2013-05-28','08:20:00',1.87),('12664','2013-05-28','08:25:00',1.66),('12664','2013-05-28','08:30:00',1.82),('12664','2013-05-28','08:35:00',1.87),('12664','2013-05-28','08:40:00',1.74),('12664','2013-05-28','08:45:00',1.55),('12664','2013-05-28','08:50:00',1.6),('12664','2013-05-28','08:55:00',1.94),('12664','2013-05-28','09:00:00',1.66),('12664','2013-05-28','09:05:00',1.73),('12664','2013-05-28','09:10:00',1.94),('12664','2013-05-28','09:15:00',2.1),('12664','2013-05-28','09:20:00',2.13),('12664','2013-05-28','09:25:00',2.4),('12664','2013-05-28','09:30:00',2.67),('12664','2013-05-28','09:35:00',2.78),('12664','2013-05-28','09:40:00',2.5),('12664','2013-05-28','09:45:00',2.82),('12664','2013-05-28','09:50:00',2.68),('12664','2013-05-28','09:55:00',2.57),('12664','2013-05-28','10:00:00',2.14),('12664','2013-05-28','10:05:00',2.16),('12664','2013-05-28','10:10:00',2.42),('12664','2013-05-28','10:15:00',2.6),('12664','2013-05-28','10:20:00',2.4),('12664','2013-05-28','10:25:00',2.49),('12664','2013-05-28','10:30:00',2.78),('12664','2013-05-28','10:35:00',2.91),('12664','2013-05-28','10:40:00',3.22),('12664','2013-05-28','10:45:00',3.17),('12664','2013-05-28','10:50:00',2.61),('12664','2013-05-28','10:55:00',3.01),('12664','2013-05-28','11:00:00',3.17),('12664','2013-05-28','11:05:00',3.33),('12664','2013-05-28','11:10:00',3.41),('12664','2013-05-28','11:15:00',2.26),('12664','2013-05-28','11:20:00',2.47),('12664','2013-05-28','11:25:00',2.51),('12664','2013-05-28','11:30:00',3.69),('12664','2013-05-28','11:35:00',4.29),('12664','2013-05-28','11:40:00',4.39),('12664','2013-05-28','11:45:00',1.34),('12664','2013-05-28','11:50:00',1.15),('12664','2013-05-28','11:55:00',1.22),('12664','2013-05-28','12:00:00',1.98),('12664','2013-05-28','12:05:00',2.69),('12664','2013-05-28','12:10:00',3.33),('12664','2013-05-28','12:15:00',2.83),('12664','2013-05-28','12:20:00',2.76),('12664','2013-05-28','12:25:00',3.34),('12664','2013-05-28','12:30:00',2.67),('12664','2013-05-28','12:35:00',2.1),('12664','2013-05-28','12:40:00',2.31),('12664','2013-05-28','12:45:00',2.23),('12664','2013-05-28','12:50:00',2.25),('12664','2013-05-28','12:55:00',2.57),('12664','2013-05-28','13:00:00',2.77),('12664','2013-05-28','13:05:00',2.83),('12664','2013-05-28','13:10:00',2.22),('12664','2013-05-28','13:15:00',1.65),('12664','2013-05-28','13:20:00',2.19),('12664','2013-05-28','13:25:00',3.73),('12664','2013-05-28','13:30:00',4.21),('12664','2013-05-28','13:35:00',3.05),('12664','2013-05-28','13:40:00',2.32),('12664','2013-05-28','13:45:00',2.29),('12664','2013-05-28','13:50:00',2.07),('12664','2013-05-28','13:55:00',2.42),('12664','2013-05-28','14:00:00',1.93),('12664','2013-05-28','14:05:00',2.23),('12664','2013-05-28','14:10:00',2.31),('12664','2013-05-28','14:15:00',2.81),('12664','2013-05-28','14:20:00',3.58),('12664','2013-05-28','14:25:00',3.1),('12664','2013-05-28','14:30:00',3.23),('12664','2013-05-28','14:35:00',3.28),('12664','2013-05-28','14:40:00',2.9),('12664','2013-05-28','14:45:00',2.88),('12664','2013-05-28','14:50:00',3.58),('12664','2013-05-28','14:55:00',3.63),('12664','2013-05-28','15:00:00',3.87),('12664','2013-05-28','15:05:00',2.6),('12664','2013-05-28','15:10:00',1.99),('12664','2013-05-28','15:15:00',2.03),('12664','2013-05-28','15:20:00',2.07),('12664','2013-05-28','15:25:00',1.83),('12664','2013-05-28','15:30:00',2),('12664','2013-05-28','15:35:00',2.22),('12664','2013-05-28','15:40:00',1.96),('12664','2013-05-28','15:45:00',1.97),('12664','2013-05-28','15:50:00',2.44),('12664','2013-05-28','15:55:00',3.13),('12664','2013-05-28','16:00:00',2.85),('12664','2013-05-28','16:05:00',2.92),('12664','2013-05-28','16:10:00',1.79),('12664','2013-05-28','16:15:00',1.97),('12664','2013-05-28','16:20:00',2.04),('12664','2013-05-28','16:25:00',1.34),('12664','2013-05-28','16:30:00',1.29),('12664','2013-05-28','16:35:00',1.34),('12664','2013-05-28','16:40:00',1.88),('12664','2013-05-28','16:45:00',2.99),('12664','2013-05-28','16:50:00',2.79),('12664','2013-05-28','16:55:00',2.67),('12664','2013-05-28','17:00:00',2.61),('12664','2013-05-28','17:05:00',2.54),('12664','2013-05-28','17:10:00',2.46),('12664','2013-05-28','17:15:00',2.36),('12664','2013-05-28','17:20:00',2.27),('12664','2013-05-28','17:25:00',2.2),('12664','2013-05-28','17:30:00',2.13),('12664','2013-05-28','17:35:00',2.03),('12664','2013-05-28','17:40:00',1.94),('12664','2013-05-28','17:45:00',1.83),('12664','2013-05-28','17:50:00',1.69),('12664','2013-05-28','18:15:00',1.34),('12664','2013-05-28','18:20:00',1.43),('12664','2013-05-28','18:25:00',1.25),('12664','2013-05-28','18:30:00',1.07),('12664','2013-05-27','07:35:00',1.16),('12664','2013-05-27','07:40:00',1.29),('12664','2013-05-27','07:45:00',1.39),('12664','2013-05-27','08:00:00',1.83),('12664','2013-05-27','08:05:00',1.58),('12664','2013-05-27','08:10:00',1.47),('12664','2013-05-27','08:15:00',1.4),('12664','2013-05-27','08:20:00',1.94),('12664','2013-05-27','08:25:00',2.17),('12664','2013-05-27','08:30:00',2.37),('12664','2013-05-27','08:35:00',2.65),('12664','2013-05-27','08:40:00',2.19),('12664','2013-05-27','08:45:00',2.14),('12664','2013-05-27','08:50:00',2.11),('12664','2013-05-27','08:55:00',2.24),('12664','2013-05-27','09:00:00',3.21),('12664','2013-05-27','09:05:00',1.69),('12664','2013-05-27','09:10:00',2.33),('12664','2013-05-27','09:15:00',3.6),('12664','2013-05-27','09:20:00',2.08),('12664','2013-05-27','09:30:00',3.51),('12664','2013-05-27','09:35:00',3.5),('12664','2013-05-27','09:40:00',3.57),('12664','2013-05-27','09:45:00',3.7),('12664','2013-05-27','09:50:00',3.61),('12664','2013-05-27','09:55:00',3.63),('12664','2013-05-27','10:00:00',3.69),('12664','2013-05-27','10:05:00',2.82),('12664','2013-05-27','10:10:00',4.11),('12664','2013-05-27','10:15:00',3.98),('12664','2013-05-27','10:20:00',4.19),('12664','2013-05-27','10:25:00',4.38),('12664','2013-05-27','10:30:00',4.56),('12664','2013-05-27','10:35:00',4.01),('12664','2013-05-27','10:40:00',1.74),('12664','2013-05-27','10:45:00',3.92),('12664','2013-05-27','10:50:00',1.97),('12664','2013-05-27','10:55:00',3.19),('12664','2013-05-27','11:00:00',3.13),('12664','2013-05-27','11:05:00',3.27),('12664','2013-05-27','11:10:00',4.62),('12664','2013-05-27','11:15:00',3.76),('12664','2013-05-27','11:20:00',3.16),('12664','2013-05-27','11:25:00',2.35),('12664','2013-05-27','11:30:00',3.33),('12664','2013-05-27','11:35:00',3.23),('12664','2013-05-27','11:40:00',3.78),('12664','2013-05-27','11:45:00',1.47),('12664','2013-05-27','11:50:00',3.08),('12664','2013-05-27','11:55:00',4.65),('12664','2013-05-27','12:00:00',4.96),('12664','2013-05-27','12:05:00',5),('12664','2013-05-27','12:10:00',5.04),('12664','2013-05-27','12:15:00',5.05),('12664','2013-05-27','12:20:00',5.03),('12664','2013-05-27','12:25:00',4.93),('12664','2013-05-27','12:30:00',5),('12664','2013-05-27','12:35:00',4.96),('12664','2013-05-27','12:40:00',4.87),('12664','2013-05-27','12:45:00',4.89),('12664','2013-05-27','12:50:00',4.83),('12664','2013-05-27','12:55:00',4.96),('12664','2013-05-27','13:00:00',4.95),('12664','2013-05-27','13:05:00',4.77),('12664','2013-05-27','13:10:00',4.45),('12664','2013-05-27','13:15:00',3.38),('12664','2013-05-27','13:20:00',4.83),('12664','2013-05-27','13:25:00',4.83),('12664','2013-05-27','13:30:00',4.59),('12664','2013-05-27','13:35:00',4.12),('12664','2013-05-27','13:40:00',4.74),('12664','2013-05-27','13:45:00',4.83),('12664','2013-05-27','13:50:00',4.76),('12664','2013-05-27','13:55:00',4.73),('12664','2013-05-27','14:00:00',4.6),('12664','2013-05-27','14:05:00',4.76),('12664','2013-05-27','14:10:00',4.64),('12664','2013-05-27','14:15:00',4.61),('12664','2013-05-27','14:20:00',4.55),('12664','2013-05-27','14:25:00',4.54),('12664','2013-05-27','14:30:00',4.59),('12664','2013-05-27','14:35:00',4.54),('12664','2013-05-27','14:40:00',4.54),('12664','2013-05-27','14:45:00',4.52),('12664','2013-05-27','14:50:00',4.15),('12664','2013-05-27','14:55:00',3.58),('12664','2013-05-27','15:00:00',2.31),('12664','2013-05-27','15:05:00',4.7),('12664','2013-05-27','15:10:00',3.95),('12664','2013-05-27','15:15:00',3.08),('12664','2013-05-27','15:20:00',3.46),('12664','2013-05-27','15:25:00',3.57),('12664','2013-05-27','15:30:00',4.23),('12664','2013-05-27','15:35:00',3.79),('12664','2013-05-27','15:40:00',2.42),('12664','2013-05-27','15:45:00',4.02),('12664','2013-05-27','15:50:00',3.51),('12664','2013-05-27','15:55:00',3.41),('12664','2013-05-27','16:00:00',3.32),('12664','2013-05-27','16:05:00',3.01),('12664','2013-05-27','16:10:00',2.26),('12664','2013-05-27','16:15:00',3.04),('12664','2013-05-27','16:20:00',3.98),('12664','2013-05-27','16:25:00',3.36),('12664','2013-05-27','16:30:00',3.4),('12664','2013-05-27','16:35:00',2.89),('12664','2013-05-27','16:40:00',1.62),('12664','2013-05-27','16:45:00',1.28),('12664','2013-05-27','16:50:00',1.38),('12664','2013-05-27','16:55:00',1.45),('12664','2013-05-27','17:00:00',1.53),('12664','2013-05-27','17:05:00',1.75),('12664','2013-05-27','17:10:00',1.69),('12664','2013-05-27','17:15:00',1.35),('12664','2013-05-27','17:20:00',1.24),('12664','2013-05-27','17:25:00',1.22),('12664','2013-05-27','17:30:00',1.14),('12664','2013-05-27','17:35:00',1.05),('12664','2013-05-27','18:15:00',1.05),('12664','2013-05-27','18:20:00',1.66),('12664','2013-05-27','18:25:00',1.7),('12664','2013-05-27','18:30:00',1.46),('12664','2013-05-26','07:35:00',1.25),('12664','2013-05-26','07:40:00',1.53),('12664','2013-05-26','07:45:00',1.68),('12664','2013-05-26','08:00:00',1.59),('12664','2013-05-26','08:05:00',1.02),('12664','2013-05-26','08:10:00',1.71),('12664','2013-05-26','08:15:00',2.52),('12664','2013-05-26','08:20:00',1.15),('12664','2013-05-26','08:25:00',1.52),('12664','2013-05-26','08:35:00',2.4),('12664','2013-05-26','08:40:00',2.64),('12664','2013-05-26','08:45:00',1.31),('12664','2013-05-26','08:55:00',1.99),('12664','2013-05-26','09:00:00',1.59),('12664','2013-05-26','09:05:00',2.45),('12664','2013-05-26','09:10:00',1.59),('12664','2013-05-26','09:15:00',1.24),('12664','2013-05-26','09:20:00',1.33),('12664','2013-05-26','09:25:00',3.02),('12664','2013-05-26','09:30:00',1.12),('12664','2013-05-26','09:35:00',2.2),('12664','2013-05-26','09:40:00',1.75),('12664','2013-05-26','09:50:00',2.75),('12664','2013-05-26','09:55:00',4.1),('12664','2013-05-26','10:00:00',4.05),('12664','2013-05-26','10:05:00',4.2),('12664','2013-05-26','10:10:00',3.81),('12664','2013-05-26','10:15:00',4.08),('12664','2013-05-26','10:20:00',3.92),('12664','2013-05-26','10:25:00',4.27),('12664','2013-05-26','10:30:00',4.29),('12664','2013-05-26','10:35:00',4.3),('12664','2013-05-26','10:40:00',4.36),('12664','2013-05-26','10:45:00',4.4),('12664','2013-05-26','10:50:00',4.43),('12664','2013-05-26','10:55:00',4.48),('12664','2013-05-26','11:00:00',4.54),('12664','2013-05-26','11:05:00',4.64),('12664','2013-05-26','11:10:00',4.63),('12664','2013-05-26','11:15:00',4.74),('12664','2013-05-26','11:20:00',4.24),('12664','2013-05-26','11:25:00',4.75),('12664','2013-05-26','11:30:00',4.81),('12664','2013-05-26','11:35:00',4.8),('12664','2013-05-26','11:40:00',4.84),('12664','2013-05-26','11:45:00',4.84),('12664','2013-05-26','11:50:00',4.89),('12664','2013-05-26','11:55:00',4.99),('12664','2013-05-26','12:00:00',4.96),('12664','2013-05-26','12:05:00',5),('12664','2013-05-26','12:10:00',5.02),('12664','2013-05-26','12:15:00',5.03),('12664','2013-05-26','12:20:00',5.03),('12664','2013-05-26','12:25:00',5.02),('12664','2013-05-26','12:30:00',5),('12664','2013-05-26','12:35:00',4.59),('12664','2013-05-26','12:40:00',5.02),('12664','2013-05-26','12:45:00',5.03),('12664','2013-05-26','12:50:00',5.03),('12664','2013-05-26','12:55:00',5.04),('12664','2013-05-26','13:00:00',4.92),('12664','2013-05-26','13:05:00',4.43),('12664','2013-05-26','13:10:00',4.98),('12664','2013-05-26','13:15:00',5.03),('12664','2013-05-26','13:20:00',5.03),('12664','2013-05-26','13:25:00',5.01),('12664','2013-05-26','13:30:00',5.01),('12664','2013-05-26','13:35:00',4.76),('12664','2013-05-26','13:40:00',4.99),('12664','2013-05-26','13:45:00',4.99),('12664','2013-05-26','13:50:00',4.52),('12664','2013-05-26','13:55:00',4.95),('12664','2013-05-26','14:00:00',4.92),('12664','2013-05-26','14:05:00',4.89),('12664','2013-05-26','14:10:00',4.87),('12664','2013-05-26','14:15:00',4.84),('12664','2013-05-26','14:20:00',4.81),('12664','2013-05-26','14:25:00',4.77),('12664','2013-05-26','14:30:00',4.72),('12664','2013-05-26','14:35:00',4.68),('12664','2013-05-26','14:40:00',4.67),('12664','2013-05-26','14:45:00',4.64),('12664','2013-05-26','14:50:00',4.58),('12664','2013-05-26','14:55:00',3.18),('12664','2013-05-26','15:00:00',3.6),('12664','2013-05-26','15:05:00',4.44),('12664','2013-05-26','15:10:00',4.4),('12664','2013-05-26','15:15:00',4.35),('12664','2013-05-26','15:20:00',4.3),('12664','2013-05-26','15:25:00',4.25),('12664','2013-05-26','15:30:00',4.18),('12664','2013-05-26','15:35:00',4.13),('12664','2013-05-26','15:40:00',4.08),('12664','2013-05-26','15:45:00',4.03),('12664','2013-05-26','15:50:00',3.76),('12664','2013-05-26','15:55:00',3.92),('12664','2013-05-26','16:00:00',3.82),('12664','2013-05-26','16:05:00',3.76),('12664','2013-05-26','16:10:00',3.7),('12664','2013-05-26','16:15:00',3.62),('12664','2013-05-26','16:20:00',3.56),('12664','2013-05-26','16:25:00',3.49),('12664','2013-05-26','16:30:00',3.4),('12664','2013-05-26','16:35:00',3.32),('12664','2013-05-26','16:40:00',3.25),('12664','2013-05-26','16:45:00',3.16),('12664','2013-05-26','16:50:00',3.06),('12664','2013-05-26','16:55:00',2.99),('12664','2013-05-26','17:00:00',2.9),('12664','2013-05-26','17:05:00',2.8),('12664','2013-05-26','17:10:00',2.71),('12664','2013-05-26','17:15:00',2.62),('12664','2013-05-26','17:20:00',2.53),('12664','2013-05-26','17:25:00',2.45),('12664','2013-05-26','17:30:00',2.35),('12664','2013-05-26','17:35:00',2.25),('12664','2013-05-26','17:40:00',2.15),('12664','2013-05-26','17:45:00',2.05),('12664','2013-05-26','17:50:00',1.96),('12664','2013-05-26','17:55:00',1.85),('12664','2013-05-26','18:00:00',1.75),('12664','2013-05-26','18:05:00',1.64),('12664','2013-05-26','18:10:00',1.54),('12664','2013-05-26','18:15:00',1.43),('12664','2013-05-26','18:20:00',1.33),('12664','2013-05-26','18:25:00',1.22),('12664','2013-05-26','18:30:00',1.12),('12664','2013-05-26','18:35:00',1.01),('12664','2013-05-25','07:25:00',1.1),('12664','2013-05-25','07:30:00',1.15),('12664','2013-05-25','07:40:00',1.07),('12664','2013-05-25','07:45:00',1.11),('12664','2013-05-25','08:10:00',2.02),('12664','2013-05-25','08:15:00',2.82),('12664','2013-05-25','08:20:00',2.12),('12664','2013-05-25','08:30:00',1.47),('12664','2013-05-25','08:35:00',2.77),('12664','2013-05-25','08:40:00',1.99),('12664','2013-05-25','08:45:00',1.53),('12664','2013-05-25','08:50:00',1.91),('12664','2013-05-25','08:55:00',3.06),('12664','2013-05-25','09:00:00',3.46),('12664','2013-05-25','09:05:00',2.35),('12664','2013-05-25','09:20:00',2.6),('12664','2013-05-25','09:25:00',2.63),('12664','2013-05-25','09:30:00',1.11),('12664','2013-05-25','09:35:00',1.78),('12664','2013-05-25','09:40:00',3.68),('12664','2013-05-25','09:45:00',3.08),('12664','2013-05-25','09:50:00',1.44),('12664','2013-05-25','10:05:00',1.32),('12664','2013-05-25','10:10:00',1.3),('12664','2013-05-25','10:15:00',1.39),('12664','2013-05-25','10:25:00',1.13),('12664','2013-05-25','10:30:00',1.7),('12664','2013-05-25','10:35:00',1.19),('12664','2013-05-25','10:45:00',1.01),('12664','2013-05-25','10:50:00',1.1),('12664','2013-05-25','10:55:00',1.28),('12664','2013-05-25','11:00:00',3.75),('12664','2013-05-25','11:05:00',2.5),('12664','2013-05-25','11:10:00',1.13),('12664','2013-05-25','11:25:00',2.31),('12664','2013-05-25','11:30:00',1.97),('12664','2013-05-25','11:35:00',1.6),('12664','2013-05-25','11:40:00',2.53),('12664','2013-05-25','11:45:00',3.2),('12664','2013-05-25','11:50:00',1.59),('12664','2013-05-25','11:55:00',1.76),('12664','2013-05-25','12:00:00',2.63),('12664','2013-05-25','12:05:00',2.87),('12664','2013-05-25','12:10:00',2.34),('12664','2013-05-25','12:15:00',1.69),('12664','2013-05-25','12:20:00',1.08),('12664','2013-05-25','12:35:00',1.83),('12664','2013-05-25','12:40:00',2.84),('12664','2013-05-25','12:45:00',3.26),('12664','2013-05-25','12:50:00',4.05),('12664','2013-05-25','12:55:00',2.77),('12664','2013-05-25','13:00:00',2.57),('12664','2013-05-25','13:05:00',1.93),('12664','2013-05-25','13:10:00',2.15),('12664','2013-05-25','13:15:00',2.72),('12664','2013-05-25','13:20:00',2.94),('12664','2013-05-25','13:25:00',2.59),('12664','2013-05-25','13:30:00',3.24),('12664','2013-05-25','13:35:00',2.69),('12664','2013-05-25','13:40:00',3),('12664','2013-05-25','13:45:00',3.25),('12664','2013-05-25','13:50:00',3.04),('12664','2013-05-25','13:55:00',4.5),('12664','2013-05-25','14:00:00',3.37),('12664','2013-05-25','14:05:00',4.33),('12664','2013-05-25','14:10:00',3.24),('12664','2013-05-25','14:15:00',3.79),('12664','2013-05-25','14:20:00',3.36),('12664','2013-05-25','14:25:00',4.11),('12664','2013-05-25','14:30:00',3.63),('12664','2013-05-25','14:35:00',4.84),('12664','2013-05-25','14:40:00',4.71),('12664','2013-05-25','14:45:00',4.33),('12664','2013-05-25','14:50:00',3.78),('12664','2013-05-25','14:55:00',3.44),('12664','2013-05-25','15:00:00',1.98),('12664','2013-05-25','15:05:00',3.61),('12664','2013-05-25','15:10:00',4.49),('12664','2013-05-25','15:15:00',4.07),('12664','2013-05-25','15:20:00',1.62),('12664','2013-05-25','15:25:00',4.87),('12664','2013-05-25','15:30:00',3.17),('12664','2013-05-25','15:35:00',2.39),('12664','2013-05-25','15:40:00',3.34),('12664','2013-05-25','15:45:00',3.13),('12664','2013-05-25','15:50:00',4.57),('12664','2013-05-25','15:55:00',3.64),('12664','2013-05-25','16:00:00',2.31),('12664','2013-05-25','16:05:00',1.26),('12664','2013-05-25','16:10:00',2.17),('12664','2013-05-25','16:15:00',1.92),('12664','2013-05-25','16:20:00',3.19),('12664','2013-05-25','16:25:00',2.54),('12664','2013-05-25','16:30:00',2.52),('12664','2013-05-25','16:35:00',3.11),('12664','2013-05-25','16:40:00',1.77),('12664','2013-05-25','16:45:00',3.32),('12664','2013-05-25','16:50:00',2.31),('12664','2013-05-25','16:55:00',1.2),('12664','2013-05-25','17:00:00',3.36),('12664','2013-05-25','17:05:00',2.02),('12664','2013-05-25','17:10:00',2.68),('12664','2013-05-25','17:15:00',2.83),('12664','2013-05-25','17:20:00',2.36),('12664','2013-05-25','17:25:00',2.22),('12664','2013-05-25','17:30:00',2.18),('12664','2013-05-25','17:35:00',2.21),('12664','2013-05-25','17:40:00',1.7),('12664','2013-05-25','17:45:00',1.21),('12664','2013-05-25','17:50:00',1.94),('12664','2013-05-25','18:00:00',1.46),('12664','2013-05-24','08:10:00',1.03),('12664','2013-05-24','08:15:00',1.56),('12664','2013-05-24','08:20:00',1.35),('12664','2013-05-24','08:25:00',1.77),('12664','2013-05-24','08:30:00',1.25),('12664','2013-05-24','08:35:00',1.99),('12664','2013-05-24','08:40:00',2.41),('12664','2013-05-24','08:45:00',2.49),('12664','2013-05-24','08:50:00',2.61),('12664','2013-05-24','08:55:00',2.94),('12664','2013-05-24','09:00:00',2.53),('12664','2013-05-24','09:05:00',2.22),('12664','2013-05-24','09:10:00',3.12),('12664','2013-05-24','09:15:00',2.86),('12664','2013-05-24','09:25:00',1.34),('12664','2013-05-24','09:30:00',3.56),('12664','2013-05-24','09:35:00',2.56),('12664','2013-05-24','09:50:00',1.54),('12664','2013-05-24','09:55:00',4.13),('12664','2013-05-24','10:00:00',3.99),('12664','2013-05-24','10:15:00',1.37),('12664','2013-05-24','10:25:00',2.73),('12664','2013-05-24','10:30:00',4.11),('12664','2013-05-24','10:35:00',4.45),('12664','2013-05-24','10:40:00',4.57),('12664','2013-05-24','10:45:00',4.64),('12664','2013-05-24','10:50:00',4.64),('12664','2013-05-24','10:55:00',1.78),('12664','2013-05-24','11:00:00',3.1),('12664','2013-05-24','11:05:00',2.6),('12664','2013-05-24','11:10:00',2.96),('12664','2013-05-24','11:15:00',4.81),('12664','2013-05-24','11:20:00',3.88),('12664','2013-05-24','11:25:00',4.9),('12664','2013-05-24','11:30:00',4.29),('12664','2013-05-24','11:35:00',4.75),('12664','2013-05-24','11:40:00',2.19),('12664','2013-05-24','11:45:00',1.18),('12664','2013-05-24','11:50:00',3.3),('12664','2013-05-24','11:55:00',2.29),('12664','2013-05-24','12:00:00',3.07),('12664','2013-05-24','12:05:00',3.63),('12664','2013-05-24','12:10:00',3.41),('12664','2013-05-24','12:15:00',2.45),('12664','2013-05-24','12:20:00',2.07),('12664','2013-05-24','12:25:00',2.47),('12664','2013-05-24','12:30:00',2.35),('12664','2013-05-24','12:35:00',2.75),('12664','2013-05-24','12:40:00',2.75),('12664','2013-05-24','12:45:00',2.53),('12664','2013-05-24','12:50:00',3.34),('12664','2013-05-24','12:55:00',2.21),('12664','2013-05-24','13:00:00',3.02),('12664','2013-05-24','13:05:00',4.62),('12664','2013-05-24','13:10:00',4.93),('12664','2013-05-24','13:15:00',3.99),('12664','2013-05-24','13:20:00',3.45),('12664','2013-05-24','13:25:00',3.66),('12664','2013-05-24','13:30:00',4.95),('12664','2013-05-24','13:35:00',2.92),('12664','2013-05-24','13:40:00',1.6),('12664','2013-05-24','13:45:00',1.38),('12664','2013-05-24','13:50:00',3.86),('12664','2013-05-24','13:55:00',3.9),('12664','2013-05-24','14:00:00',4.59),('12664','2013-05-24','14:05:00',3.63),('12664','2013-05-24','14:10:00',1.8),('12664','2013-05-24','14:15:00',2.11),('12664','2013-05-24','14:20:00',3.42),('12664','2013-05-24','14:25:00',4.58),('12664','2013-05-24','14:30:00',4.92),('12664','2013-05-24','14:35:00',4.8),('12664','2013-05-24','14:40:00',2.84),('12664','2013-05-24','14:45:00',3.03),('12664','2013-05-24','14:50:00',1.71),('12664','2013-05-24','14:55:00',2.23),('12664','2013-05-24','15:00:00',2.37),('12664','2013-05-24','15:05:00',1.77),('12664','2013-05-24','15:10:00',3.53),('12664','2013-05-24','15:15:00',4.07),('12664','2013-05-24','15:20:00',2.65),('12664','2013-05-24','15:25:00',2.75),('12664','2013-05-24','15:30:00',2.75),('12664','2013-05-24','15:35:00',2.71),('12664','2013-05-24','15:40:00',3.59),('12664','2013-05-24','15:45:00',3.36),('12664','2013-05-24','15:50:00',2.21),('12664','2013-05-24','15:55:00',1.98),('12664','2013-05-24','16:00:00',1.89),('12664','2013-05-24','16:05:00',1.82),('12664','2013-05-24','16:10:00',1.63),('12664','2013-05-24','16:15:00',1.49),('12664','2013-05-24','16:20:00',1.68),('12664','2013-05-24','16:25:00',1.5),('12664','2013-05-24','16:30:00',1.3),('12664','2013-05-24','16:35:00',1.23),('12664','2013-05-24','16:40:00',1.21),('12664','2013-05-24','16:45:00',1.36),('12664','2013-05-24','16:50:00',1.18),('12664','2013-05-24','16:55:00',1.08),('12664','2013-05-24','17:00:00',1.15),('12664','2013-05-24','17:05:00',1.28),('12664','2013-05-24','17:10:00',1.32),('12664','2013-05-24','17:15:00',1.42),('12664','2013-05-24','17:25:00',1.26),('12664','2013-05-24','17:30:00',1.19),('12664','2013-05-24','17:35:00',1.09),('12664','2013-05-24','17:40:00',1.03),('12664','2013-05-23','07:00:00',1.11),('12664','2013-05-23','07:45:00',1.78),('12664','2013-05-23','07:50:00',1.02),('12664','2013-05-23','08:20:00',1.16),('12664','2013-05-23','08:25:00',1.67),('12664','2013-05-23','08:30:00',2.19),('12664','2013-05-23','08:35:00',1.92),('12664','2013-05-23','08:40:00',1.05),('12664','2013-05-23','08:45:00',1.79),('12664','2013-05-23','09:10:00',1.58),('12664','2013-05-23','09:15:00',1.75),('12664','2013-05-23','09:20:00',2.98),('12664','2013-05-23','09:25:00',3.55),('12664','2013-05-23','09:30:00',2.74),('12664','2013-05-23','09:35:00',2.51),('12664','2013-05-23','09:40:00',1.09),('12664','2013-05-23','09:45:00',2.34),('12664','2013-05-23','09:55:00',2.84),('12664','2013-05-23','10:00:00',2.32),('12664','2013-05-23','10:05:00',2.99),('12664','2013-05-23','10:10:00',3.62),('12664','2013-05-23','10:15:00',2.75),('12664','2013-05-23','10:20:00',3.73),('12664','2013-05-23','10:25:00',3.1),('12664','2013-05-23','10:30:00',1.77),('12664','2013-05-23','10:35:00',3.2),('12664','2013-05-23','10:40:00',2.27),('12664','2013-05-23','10:45:00',2.3),('12664','2013-05-23','10:50:00',2.94),('12664','2013-05-23','10:55:00',3.18),('12664','2013-05-23','11:00:00',1.74),('12664','2013-05-23','11:05:00',4.38),('12664','2013-05-23','11:10:00',2.56),('12664','2013-05-23','11:15:00',1.75),('12664','2013-05-23','11:20:00',1.36),('12664','2013-05-23','11:30:00',2.09),('12664','2013-05-23','11:35:00',2.95),('12664','2013-05-23','11:40:00',2.18),('12664','2013-05-23','11:45:00',1.41),('12664','2013-05-23','11:50:00',1.29),('12664','2013-05-23','11:55:00',1.97),('12664','2013-05-23','12:00:00',2.74),('12664','2013-05-23','12:05:00',2.01),('12664','2013-05-23','12:10:00',4.01),('12664','2013-05-23','12:15:00',4.58),('12664','2013-05-23','12:20:00',2.82),('12664','2013-05-23','12:25:00',2.64),('12664','2013-05-23','12:30:00',1.14),('12664','2013-05-23','12:35:00',3.25),('12664','2013-05-23','12:40:00',5),('12664','2013-05-23','12:45:00',5),('12664','2013-05-23','12:50:00',3.13),('12664','2013-05-23','12:55:00',4.12),('12664','2013-05-23','13:00:00',3.64),('12664','2013-05-23','13:05:00',4.82),('12664','2013-05-23','13:10:00',4.7),('12664','2013-05-23','13:15:00',4.61),('12664','2013-05-23','13:20:00',2.8),('12664','2013-05-23','13:25:00',4.59),('12664','2013-05-23','13:30:00',3.65),('12664','2013-05-23','13:35:00',4.9),('12664','2013-05-23','13:40:00',4.96),('12664','2013-05-23','13:45:00',4.82),('12664','2013-05-23','13:50:00',5.02),('12664','2013-05-23','13:55:00',3.8),('12664','2013-05-23','14:00:00',2.31),('12664','2013-05-23','14:05:00',3.35),('12664','2013-05-23','14:10:00',3.25),('12664','2013-05-23','14:15:00',3.82),('12664','2013-05-23','14:20:00',2.99),('12664','2013-05-23','14:25:00',3.05),('12664','2013-05-23','14:30:00',4.96),('12664','2013-05-23','14:35:00',5.02),('12664','2013-05-23','14:40:00',2.89),('12664','2013-05-23','14:45:00',3.92),('12664','2013-05-23','14:50:00',2.12),('12664','2013-05-23','14:55:00',4.69),('12664','2013-05-23','15:00:00',3.85),('12664','2013-05-23','15:05:00',3.49),('12664','2013-05-23','15:10:00',3.33),('12664','2013-05-23','15:15:00',2.46),('12664','2013-05-23','15:20:00',4.04),('12664','2013-05-23','15:25:00',2.16),('12664','2013-05-23','15:30:00',2.04),('12664','2013-05-23','15:35:00',2.59),('12664','2013-05-23','15:40:00',3.16),('12664','2013-05-23','15:45:00',4.28),('12664','2013-05-23','15:50:00',4.16),('12664','2013-05-23','15:55:00',3.44),('12664','2013-05-23','16:00:00',2.16),('12664','2013-05-23','16:05:00',3.25),('12664','2013-05-23','16:10:00',3.32),('12664','2013-05-23','16:15:00',2.88),('12664','2013-05-23','16:20:00',1.48),('12664','2013-05-23','16:25:00',1.23),('12664','2013-05-23','16:30:00',3.7),('12664','2013-05-23','16:35:00',1.07),('12664','2013-05-23','16:40:00',1.32),('12664','2013-05-23','16:45:00',1.81),('12664','2013-05-23','16:50:00',1.52),('12664','2013-05-23','16:55:00',2.23),('12664','2013-05-23','17:00:00',1.19),('12664','2013-05-23','17:15:00',1.25),('12664','2013-05-23','17:30:00',1.18),('12664','2013-05-23','17:35:00',1.56),('12664','2013-05-23','17:40:00',1.3),('12664','2013-05-23','17:45:00',1.83),('12664','2013-05-23','17:50:00',2.32),('12664','2013-05-23','17:55:00',1.47),('12664','2013-05-22','08:05:00',1.48),('12664','2013-05-22','08:10:00',1.42),('12664','2013-05-22','08:15:00',1.04),('12664','2013-05-22','08:20:00',1.32),('12664','2013-05-22','08:25:00',2.59),('12664','2013-05-22','08:30:00',2.29),('12664','2013-05-22','09:25:00',1.31),('12664','2013-05-22','09:30:00',2.74),('12664','2013-05-22','09:35:00',3.29),('12664','2013-05-22','09:40:00',3.22),('12664','2013-05-22','09:45:00',3.22),('12664','2013-05-22','09:50:00',3.25),('12664','2013-05-22','09:55:00',3.33),('12664','2013-05-22','10:00:00',3.42),('12664','2013-05-22','10:05:00',3.52),('12664','2013-05-22','10:10:00',3.57),('12664','2013-05-22','10:15:00',3.6),('12664','2013-05-22','10:20:00',3.67),('12664','2013-05-22','10:25:00',3.74),('12664','2013-05-22','10:30:00',3.71),('12664','2013-05-22','10:35:00',3.1),('12664','2013-05-22','10:40:00',2.16),('12664','2013-05-22','10:45:00',3.49),('12664','2013-05-22','10:50:00',4.06),('12664','2013-05-22','10:55:00',4.01),('12664','2013-05-22','11:00:00',4.06),('12664','2013-05-22','11:05:00',4.06),('12664','2013-05-22','11:10:00',4.08),('12664','2013-05-22','11:15:00',4.12),('12664','2013-05-22','11:20:00',4.16),('12664','2013-05-22','11:25:00',4.36),('12664','2013-05-22','11:30:00',4.32),('12664','2013-05-22','11:35:00',4.46),('12664','2013-05-22','11:40:00',3.68),('12664','2013-05-22','11:45:00',4.04),('12664','2013-05-22','11:50:00',3.86),('12664','2013-05-22','11:55:00',3.75),('12664','2013-05-22','12:00:00',2.34),('12664','2013-05-22','12:05:00',2.77),('12664','2013-05-22','12:10:00',2.06),('12664','2013-05-22','12:15:00',2.22),('12664','2013-05-22','12:20:00',4.7),('12664','2013-05-22','12:25:00',5.04),('12664','2013-05-22','12:30:00',2.97),('12664','2013-05-22','12:35:00',1.56),('12664','2013-05-22','12:40:00',1.37),('12664','2013-05-22','13:10:00',1.9),('12664','2013-05-22','13:15:00',2.29),('12664','2013-05-22','13:20:00',2.61),('12664','2013-05-22','13:25:00',1.35),('12664','2013-05-22','13:30:00',3.1),('12664','2013-05-22','13:35:00',2.91),('12664','2013-05-22','13:40:00',4.54),('12664','2013-05-22','13:45:00',3.77),('12664','2013-05-22','13:50:00',4.96),('12664','2013-05-22','13:55:00',3.94),('12664','2013-05-22','14:00:00',4.01),('12664','2013-05-22','14:05:00',4),('12664','2013-05-22','14:10:00',4.44),('12664','2013-05-22','14:15:00',4.33),('12664','2013-05-22','14:20:00',4.28),('12664','2013-05-22','14:25:00',4.26),('12664','2013-05-22','14:30:00',4.21),('12664','2013-05-22','14:35:00',4.17),('12664','2013-05-22','14:40:00',4.13),('12664','2013-05-22','14:45:00',4.11),('12664','2013-05-22','14:50:00',4.07),('12664','2013-05-22','14:55:00',4.01),('12664','2013-05-22','15:00:00',3.99),('12664','2013-05-22','15:05:00',3.97),('12664','2013-05-22','15:10:00',3.65),('12664','2013-05-22','15:15:00',3.85),('12664','2013-05-22','15:20:00',3.79),('12664','2013-05-22','15:25:00',3.84),('12664','2013-05-22','15:30:00',3.52),('12664','2013-05-22','15:35:00',3.97),('12664','2013-05-22','15:40:00',3.88),('12664','2013-05-22','15:45:00',3.66),('12664','2013-05-22','15:50:00',3.56),('12664','2013-05-22','15:55:00',3.44),('12664','2013-05-22','16:00:00',3.37),('12664','2013-05-22','16:05:00',3.31),('12664','2013-05-22','16:10:00',3.23),('12664','2013-05-22','16:15:00',3.19),('12664','2013-05-22','16:20:00',3.1),('12664','2013-05-22','16:25:00',3.09),('12664','2013-05-22','16:30:00',2.84),('12664','2013-05-22','16:35:00',3.11),('12664','2013-05-22','16:40:00',1.76),('12664','2013-05-22','16:45:00',2.7),('12664','2013-05-22','16:50:00',2.22),('12664','2013-05-22','17:25:00',1.23),('12664','2013-05-22','17:30:00',1.24),('12664','2013-05-22','17:35:00',1.47),('12664','2013-05-22','17:40:00',1.45),('12664','2013-05-22','17:45:00',1.38),('12664','2013-05-22','17:55:00',1.12),('12664','2013-05-22','18:00:00',1.12),('12664','2013-05-22','18:05:00',1.52),('12664','2013-05-22','18:10:00',1.43),('12664','2013-05-22','18:15:00',1.11),('12664','2013-05-22','18:35:00',1.16),('12664','2013-05-22','18:40:00',1.25),('12664','2013-05-22','18:45:00',1.26),('12664','2013-05-21','07:30:00',1.13),('12664','2013-05-21','07:35:00',1.47),('12664','2013-05-21','07:40:00',1.45),('12664','2013-05-21','07:50:00',1.07),('12664','2013-05-21','07:55:00',1.06),('12664','2013-05-21','08:00:00',1.05),('12664','2013-05-21','08:05:00',1.82),('12664','2013-05-21','08:10:00',1.75),('12664','2013-05-21','08:15:00',1.45),('12664','2013-05-21','08:20:00',1.5),('12664','2013-05-21','08:25:00',1.42),('12664','2013-05-21','08:30:00',1.24),('12664','2013-05-21','08:35:00',1.57),('12664','2013-05-21','08:40:00',1.45),('12664','2013-05-21','08:45:00',1.24),('12664','2013-05-21','08:50:00',1.27),('12664','2013-05-21','08:55:00',1.49),('12664','2013-05-21','09:00:00',1.42),('12664','2013-05-21','09:05:00',1.35),('12664','2013-05-21','09:10:00',1.73),('12664','2013-05-21','09:15:00',2),('12664','2013-05-21','09:20:00',2.45),('12664','2013-05-21','09:25:00',2.03),('12664','2013-05-21','09:30:00',1.93),('12664','2013-05-21','09:35:00',2.25),('12664','2013-05-21','09:40:00',1.82),('12664','2013-05-21','09:45:00',1.74),('12664','2013-05-21','09:50:00',1.79),('12664','2013-05-21','09:55:00',1.86),('12664','2013-05-21','10:00:00',2.16),('12664','2013-05-21','10:05:00',2.1),('12664','2013-05-21','10:10:00',1.88),('12664','2013-05-21','10:15:00',1.82),('12664','2013-05-21','10:20:00',1.9),('12664','2013-05-21','10:25:00',2.69),('12664','2013-05-21','10:30:00',1.82),('12664','2013-05-21','10:35:00',1.91),('12664','2013-05-21','10:40:00',2.79),('12664','2013-05-21','10:45:00',2.56),('12664','2013-05-21','10:50:00',2.38),('12664','2013-05-21','10:55:00',1.67),('12664','2013-05-21','11:00:00',1.39),('12664','2013-05-21','11:05:00',1.86),('12664','2013-05-21','11:10:00',2.48),('12664','2013-05-21','11:15:00',3.76),('12664','2013-05-21','11:20:00',3.25),('12664','2013-05-21','11:25:00',4.3),('12664','2013-05-21','11:30:00',2.73),('12664','2013-05-21','11:35:00',2.92),('12664','2013-05-21','11:40:00',3.06),('12664','2013-05-21','11:45:00',2.93),('12664','2013-05-21','11:50:00',3.18),('12664','2013-05-21','11:55:00',2.71),('12664','2013-05-21','12:00:00',2.35),('12664','2013-05-21','12:05:00',4.37),('12664','2013-05-21','12:10:00',3.15),('12664','2013-05-21','12:15:00',3.17),('12664','2013-05-21','12:20:00',2.33),('12664','2013-05-21','12:25:00',2.91),('12664','2013-05-21','12:30:00',2.71),('12664','2013-05-21','12:35:00',2.97),('12664','2013-05-21','12:40:00',3.2),('12664','2013-05-21','12:45:00',2.51),('12664','2013-05-21','12:50:00',3.76),('12664','2013-05-21','12:55:00',3.32),('12664','2013-05-21','13:00:00',3.25),('12664','2013-05-21','13:05:00',2.94),('12664','2013-05-21','13:10:00',3.7),('12664','2013-05-21','13:15:00',3.78),('12664','2013-05-21','13:20:00',3.23),('12664','2013-05-21','13:25:00',2.33),('12664','2013-05-21','13:30:00',1.56),('12664','2013-05-21','13:35:00',1.35),('12664','2013-05-21','13:40:00',1.19),('12664','2013-05-21','14:10:00',1.76),('12664','2013-05-21','14:15:00',2.16),('12664','2013-05-21','14:20:00',2.71),('12664','2013-05-21','14:25:00',4.72),('12664','2013-05-21','14:30:00',4.5),('12664','2013-05-21','14:35:00',2.85),('12664','2013-05-21','14:40:00',1.97),('12664','2013-05-21','14:45:00',1.18),('12664','2013-05-21','15:15:00',1.25),('12664','2013-05-21','15:20:00',1.7),('12664','2013-05-21','15:25:00',2.37),('12664','2013-05-21','15:30:00',4.08),('12664','2013-05-21','15:35:00',3.43),('12664','2013-05-21','15:40:00',2.24),('12664','2013-05-21','15:45:00',2.03),('12664','2013-05-21','15:50:00',1.22),('12664','2013-05-21','16:05:00',1.21),('12664','2013-05-21','16:10:00',1.05),('12664','2013-05-21','16:25:00',1.18),('12664','2013-05-21','16:30:00',1.53),('12664','2013-05-21','16:35:00',1.42),('12664','2013-05-21','16:40:00',1.32),('12664','2013-05-21','16:45:00',1.06),('12664','2014-03-31','08:25:00',1.04),('12664','2014-03-31','08:30:00',1.14),('12664','2014-03-31','08:35:00',1.22),('12664','2014-03-31','08:40:00',1.32),('12664','2014-03-31','08:45:00',1.44),('12664','2014-03-31','08:50:00',1.55),('12664','2014-03-31','08:55:00',1.65),('12664','2014-03-31','09:00:00',1.75),('12664','2014-03-31','09:05:00',1.83),('12664','2014-03-31','09:10:00',1.91),('12664','2014-03-31','09:15:00',1.99),('12664','2014-03-31','09:20:00',2.08),('12664','2014-03-31','09:25:00',2.16),('12664','2014-03-31','09:30:00',2.24),('12664','2014-03-31','09:35:00',2.32),('12664','2014-03-31','09:40:00',2.39),('12664','2014-03-31','09:45:00',2.48),('12664','2014-03-31','09:50:00',2.55),('12664','2014-03-31','09:55:00',2.6),('12664','2014-03-31','10:00:00',2.68),('12664','2014-03-31','10:05:00',2.73),('12664','2014-03-31','10:10:00',2.78),('12664','2014-03-31','10:15:00',2.84),('12664','2014-03-31','10:20:00',2.89),('12664','2014-03-31','10:25:00',2.97),('12664','2014-03-31','10:30:00',3.04),('12664','2014-03-31','10:35:00',3.1),('12664','2014-03-31','10:40:00',3.14),('12664','2014-03-31','10:45:00',3.2),('12664','2014-03-31','10:50:00',3.23),('12664','2014-03-31','10:55:00',3.31),('12664','2014-03-31','11:00:00',3.38),('12664','2014-03-31','11:05:00',3.41),('12664','2014-03-31','11:10:00',3.42),('12664','2014-03-31','11:15:00',3.46),('12664','2014-03-31','11:20:00',3.5),('12664','2014-03-31','11:25:00',3.53),('12664','2014-03-31','11:30:00',3.62),('12664','2014-03-31','11:35:00',3.63),('12664','2014-03-31','11:40:00',3.66),('12664','2014-03-31','11:45:00',3.69),('12664','2014-03-31','11:50:00',3.73),('12664','2014-03-31','11:55:00',3.76),('12664','2014-03-31','12:00:00',3.81),('12664','2014-03-31','12:05:00',3.81),('12664','2014-03-31','12:10:00',3.84),('12664','2014-03-31','12:15:00',3.84),('12664','2014-03-31','12:20:00',3.88),('12664','2014-03-31','12:25:00',3.95),('12664','2014-03-31','12:30:00',3.95),('12664','2014-03-31','12:35:00',3.94),('12664','2014-03-31','12:40:00',3.98),('12664','2014-03-31','12:45:00',3.99),('12664','2014-03-31','12:50:00',3.98),('12664','2014-03-31','12:55:00',3.96),('12664','2014-03-31','13:00:00',3.96),('12664','2014-03-31','13:05:00',4),('12664','2014-03-31','13:10:00',4),('12664','2014-03-31','13:15:00',3.98),('12664','2014-03-31','13:20:00',4.01),('12664','2014-03-31','13:25:00',4),('12664','2014-03-31','13:30:00',4),('12664','2014-03-31','13:35:00',4),('12664','2014-03-31','13:40:00',4),('12664','2014-03-31','13:45:00',4.01),('12664','2014-03-31','13:50:00',3.96),('12664','2014-03-31','13:55:00',3.94),('12664','2014-03-31','14:00:00',3.93),('12664','2014-03-31','14:05:00',3.91),('12664','2014-03-31','14:10:00',3.9),('12664','2014-03-31','14:15:00',3.88),('12664','2014-03-31','14:20:00',3.86),('12664','2014-03-31','14:25:00',3.84),('12664','2014-03-31','14:30:00',3.82),('12664','2014-03-31','14:35:00',3.79),('12664','2014-03-31','14:40:00',3.78),('12664','2014-03-31','14:45:00',3.74),('12664','2014-03-31','14:50:00',3.69),('12664','2014-03-31','14:55:00',3.66),('12664','2014-03-31','15:00:00',3.62),('12664','2014-03-31','15:05:00',3.59),('12664','2014-03-31','15:10:00',3.53),('12664','2014-03-31','15:15:00',3.46),('12664','2014-03-31','15:20:00',3.44),('12664','2014-03-31','15:25:00',3.37),('12664','2014-03-31','15:30:00',3.33),('12664','2014-03-31','15:35:00',3.28),('12664','2014-03-31','15:40:00',3.22),('12664','2014-03-31','15:45:00',3.11),('12664','2014-03-31','15:50:00',3.03),('12664','2014-03-31','15:55:00',3),('12664','2014-03-31','16:00:00',2.92),('12664','2014-03-31','16:05:00',2.85),('12664','2014-03-31','16:10:00',2.77),('12664','2014-03-31','16:15:00',2.75),('12664','2014-03-31','16:20:00',2.68),('12664','2014-03-31','16:25:00',2.61),('12664','2014-03-31','16:30:00',2.49),('12664','2014-03-31','16:35:00',2.41),('12664','2014-03-31','16:40:00',2.33),('12664','2014-03-31','16:45:00',2.23),('12664','2014-03-31','16:50:00',2.17),('12664','2014-03-31','16:55:00',2.09),('12664','2014-03-31','17:00:00',1.98),('12664','2014-03-31','17:05:00',1.9),('12664','2014-03-31','17:10:00',1.81),('12664','2014-03-31','17:15:00',1.74),('12664','2014-03-31','17:20:00',1.63),('12664','2014-03-31','17:25:00',1.53),('12664','2014-03-31','17:30:00',1.45),('12664','2014-03-31','17:35:00',1.35),('12664','2014-03-31','17:40:00',1.25),('12664','2014-03-31','17:45:00',1.14),('12664','2014-03-31','17:50:00',1.05),('12664','2013-05-20','07:15:00',1.06),('12664','2013-05-20','07:45:00',1.31),('12664','2013-05-20','07:50:00',1.18),('12664','2013-05-20','07:55:00',1),('12664','2013-05-20','08:05:00',1.54),('12664','2013-05-20','08:10:00',1.69),('12664','2013-05-20','08:15:00',1.97),('12664','2013-05-20','08:20:00',1.28),('12664','2013-05-20','08:30:00',1.86),('12664','2013-05-20','08:35:00',1.93),('12664','2013-05-20','08:55:00',2.98),('12664','2013-05-20','09:00:00',3.11),('12664','2013-05-20','09:05:00',3.24),('12664','2013-05-20','09:10:00',3.18),('12664','2013-05-20','09:15:00',3.2),('12664','2013-05-20','09:20:00',1.84),('12664','2013-05-20','09:25:00',1.61),('12664','2013-05-20','09:30:00',3.74),('12664','2013-05-20','09:35:00',3.51),('12664','2013-05-20','09:40:00',2.27),('12664','2013-05-20','09:45:00',1.6),('12664','2013-05-20','09:50:00',2.64),('12664','2013-05-20','09:55:00',2.73),('12664','2013-05-20','10:00:00',3.48),('12664','2013-05-20','10:05:00',2.67),('12664','2013-05-20','10:10:00',2.63),('12664','2013-05-20','10:15:00',4.12),('12664','2013-05-20','10:20:00',4.24),('12664','2013-05-20','10:25:00',4.36),('12664','2013-05-20','10:30:00',3.78),('12664','2013-05-20','10:35:00',3.75),('12664','2013-05-20','10:40:00',4.38),('12664','2013-05-20','10:45:00',3.99),('12664','2013-05-20','10:50:00',4.57),('12664','2013-05-20','10:55:00',4.1),('12664','2013-05-20','11:00:00',3.24),('12664','2013-05-20','11:05:00',3.69),('12664','2013-05-20','11:10:00',2.32),('12664','2013-05-20','11:15:00',4.17),('12664','2013-05-20','11:20:00',2.24),('12664','2013-05-20','11:25:00',1.33),('12664','2013-05-20','11:30:00',4.08),('12664','2013-05-20','11:35:00',2.2),('12664','2013-05-20','11:40:00',3.09),('12664','2013-05-20','11:45:00',4.89),('12664','2013-05-20','11:50:00',3.48),('12664','2013-05-20','11:55:00',4.81),('12664','2013-05-20','12:00:00',4.71),('12664','2013-05-20','12:05:00',4.79),('12664','2013-05-20','12:10:00',4.59),('12664','2013-05-20','12:15:00',4.64),('12664','2013-05-20','12:20:00',4.76),('12664','2013-05-20','12:25:00',4.86),('12664','2013-05-20','12:30:00',4.79),('12664','2013-05-20','12:35:00',4.81),('12664','2013-05-20','12:40:00',4.83),('12664','2013-05-20','12:45:00',4.84),('12664','2013-05-20','12:50:00',4.83),('12664','2013-05-20','12:55:00',4.81),('12664','2013-05-20','13:00:00',4.81),('12664','2013-05-20','13:05:00',4.84),('12664','2013-05-20','13:10:00',4.86),('12664','2013-05-20','13:15:00',4.8),('12664','2013-05-20','13:20:00',4.82),('12664','2013-05-20','13:25:00',4.8),('12664','2013-05-20','13:30:00',4.79),('12664','2013-05-20','13:35:00',4.79),('12664','2013-05-20','13:40:00',4.78),('12664','2013-05-20','13:45:00',4.78),('12664','2013-05-20','13:50:00',4.75),('12664','2013-05-20','13:55:00',4.47),('12664','2013-05-20','14:00:00',4.26),('12664','2013-05-20','14:05:00',4.67),('12664','2013-05-20','14:10:00',4.65),('12664','2013-05-20','14:15:00',4.59),('12664','2013-05-20','14:20:00',4.59),('12664','2013-05-20','14:25:00',4.57),('12664','2013-05-20','14:30:00',4.5),('12664','2013-05-20','14:35:00',4.44),('12664','2013-05-20','14:40:00',4.43),('12664','2013-05-20','14:45:00',4.38),('12664','2013-05-20','14:50:00',4.38),('12664','2013-05-20','14:55:00',4.36),('12664','2013-05-20','15:00:00',4.31),('12664','2013-05-20','15:05:00',4.27),('12664','2013-05-20','15:10:00',4.23),('12664','2013-05-20','15:15:00',4.15),('12664','2013-05-20','15:20:00',4.11),('12664','2013-05-20','15:25:00',4.05),('12664','2013-05-20','15:30:00',3.98),('12664','2013-05-20','15:35:00',3.91),('12664','2013-05-20','15:40:00',3.87),('12664','2013-05-20','15:45:00',3.82),('12664','2013-05-20','15:50:00',3.78),('12664','2013-05-20','15:55:00',3.73),('12664','2013-05-20','16:00:00',3.66),('12664','2013-05-20','16:05:00',3.59),('12664','2013-05-20','16:10:00',3.52),('12664','2013-05-20','16:15:00',3.44),('12664','2013-05-20','16:20:00',3.39),('12664','2013-05-20','16:25:00',3.34),('12664','2013-05-20','16:30:00',3.25),('12664','2013-05-20','16:35:00',3.09),('12664','2013-05-20','16:40:00',2.9),('12664','2013-05-20','16:45:00',2.87),('12664','2013-05-20','16:50:00',2.99),('12664','2013-05-20','16:55:00',2.21),('12664','2013-05-20','17:00:00',2.05),('12664','2013-05-20','17:05:00',2.39),('12664','2013-05-20','17:10:00',2.12),('12664','2013-05-20','17:15:00',1.75),('12664','2013-05-20','17:20:00',2.8),('12664','2013-05-20','17:25:00',2.43),('12664','2013-05-20','17:30:00',2.23),('12664','2013-05-20','17:35:00',1.96),('12664','2013-05-20','17:40:00',1.97),('12664','2013-05-20','17:45:00',1.87),('12664','2013-05-20','17:50:00',1.78),('12664','2013-05-20','17:55:00',1.71),('12664','2013-05-20','18:00:00',1.42),('12664','2013-05-20','18:05:00',1.39),('12664','2013-05-20','18:10:00',1.55),('12664','2013-05-20','18:15:00',1.33),('12664','2013-05-20','18:20:00',1.2),('12664','2013-05-20','18:25:00',1.09),('12664','2013-05-19','08:25:00',1.07),('12664','2013-05-19','08:30:00',1.32),('12664','2013-05-19','08:35:00',1.24),('12664','2013-05-19','08:40:00',1.15),('12664','2013-05-19','08:45:00',1),('12664','2013-05-19','08:50:00',1.14),('12664','2013-05-19','08:55:00',1.29),('12664','2013-05-19','09:05:00',1.12),('12664','2013-05-19','09:25:00',1.34),('12664','2013-05-19','09:30:00',1.48),('12664','2013-05-19','09:35:00',1.23),('12664','2013-05-19','09:40:00',1.33),('12664','2013-05-19','09:45:00',1.67),('12664','2013-05-19','09:50:00',1.49),('12664','2013-05-19','09:55:00',1.94),('12664','2013-05-19','10:00:00',2.16),('12664','2013-05-19','10:05:00',2.18),('12664','2013-05-19','10:10:00',2.37),('12664','2013-05-19','10:15:00',2.79),('12664','2013-05-19','10:20:00',4.12),('12664','2013-05-19','10:25:00',3.64),('12664','2013-05-19','10:30:00',3.12),('12664','2013-05-19','10:35:00',3.34),('12664','2013-05-19','10:40:00',2.02),('12664','2013-05-19','10:45:00',2.33),('12664','2013-05-19','10:50:00',4.09),('12664','2013-05-19','10:55:00',4.68),('12664','2013-05-19','11:00:00',3.03),('12664','2013-05-19','11:05:00',3.26),('12664','2013-05-19','11:10:00',3.89),('12664','2013-05-19','11:15:00',4.74),('12664','2013-05-19','11:20:00',4),('12664','2013-05-19','11:25:00',4.03),('12664','2013-05-19','11:30:00',4.69),('12664','2013-05-19','11:35:00',4.66),('12664','2013-05-19','11:40:00',4.69),('12664','2013-05-19','11:45:00',4.72),('12664','2013-05-19','11:50:00',4.77),('12664','2013-05-19','11:55:00',4.82),('12664','2013-05-19','12:00:00',4.8),('12664','2013-05-19','12:05:00',4.8),('12664','2013-05-19','12:10:00',4.82),('12664','2013-05-19','12:15:00',4.86),('12664','2013-05-19','12:20:00',4.89),('12664','2013-05-19','12:25:00',4.93),('12664','2013-05-19','12:30:00',4.9),('12664','2013-05-19','12:35:00',4.92),('12664','2013-05-19','12:40:00',4.98),('12664','2013-05-19','12:45:00',5.02),('12664','2013-05-19','12:50:00',4.99),('12664','2013-05-19','12:55:00',4.95),('12664','2013-05-19','13:00:00',4.93),('12664','2013-05-19','13:05:00',4.9),('12664','2013-05-19','13:10:00',4.85),('12664','2013-05-19','13:15:00',4.83),('12664','2013-05-19','13:20:00',4.87),('12664','2013-05-19','13:25:00',4.84),('12664','2013-05-19','13:30:00',4.83),('12664','2013-05-19','13:35:00',4.81),('12664','2013-05-19','13:40:00',4.81),('12664','2013-05-19','13:45:00',4.82),('12664','2013-05-19','13:50:00',4.81),('12664','2013-05-19','13:55:00',4.8),('12664','2013-05-19','14:00:00',4.78),('12664','2013-05-19','14:05:00',4.73),('12664','2013-05-19','14:10:00',4.74),('12664','2013-05-19','14:15:00',4.48),('12664','2013-05-19','14:20:00',3.97),('12664','2013-05-19','14:25:00',4.67),('12664','2013-05-19','14:30:00',4.06),('12664','2013-05-19','14:35:00',4.55),('12664','2013-05-19','14:40:00',4.52),('12664','2013-05-19','14:45:00',4.5),('12664','2013-05-19','14:50:00',3.8),('12664','2013-05-19','14:55:00',4.4),('12664','2013-05-19','15:00:00',4.27),('12664','2013-05-19','15:05:00',4.39),('12664','2013-05-19','15:10:00',4.32),('12664','2013-05-19','15:15:00',4.27),('12664','2013-05-19','15:20:00',4.19),('12664','2013-05-19','15:25:00',4.14),('12664','2013-05-19','15:30:00',4.09),('12664','2013-05-19','15:35:00',3.21),('12664','2013-05-19','15:40:00',3.96),('12664','2013-05-19','15:45:00',3.93),('12664','2013-05-19','15:50:00',3.87),('12664','2013-05-19','15:55:00',3.79),('12664','2013-05-19','16:00:00',3.75),('12664','2013-05-19','16:05:00',3.67),('12664','2013-05-19','16:10:00',3.59),('12664','2013-05-19','16:15:00',3.54),('12664','2013-05-19','16:20:00',3.46),('12664','2013-05-19','16:25:00',3.4),('12664','2013-05-19','16:30:00',3.32),('12664','2013-05-19','16:35:00',3.24),('12664','2013-05-19','16:40:00',3.17),('12664','2013-05-19','16:45:00',3.08),('12664','2013-05-19','16:50:00',2.98),('12664','2013-05-19','16:55:00',2.93),('12664','2013-05-19','17:00:00',2.83),('12664','2013-05-19','17:05:00',2.74),('12664','2013-05-19','17:10:00',2.64),('12664','2013-05-19','17:15:00',2.56),('12664','2013-05-19','17:20:00',2.48),('12664','2013-05-19','17:25:00',2.38),('12664','2013-05-19','17:30:00',2.3),('12664','2013-05-19','17:35:00',2.2),('12664','2013-05-19','17:40:00',2.09),('12664','2013-05-19','17:45:00',1.99),('12664','2013-05-19','17:50:00',1.89),('12664','2013-05-19','17:55:00',1.8),('12664','2013-05-19','18:00:00',1.7),('12664','2013-05-19','18:05:00',1.6),('12664','2013-05-19','18:10:00',1.46),('12664','2013-05-19','18:15:00',1.35),('12664','2013-05-19','18:20:00',1.26),('12664','2013-05-19','18:25:00',1.16),('12664','2013-05-19','18:30:00',1.06),('12664','2013-05-18','07:35:00',1.06),('12664','2013-05-18','07:40:00',1.18),('12664','2013-05-18','07:45:00',1.17),('12664','2013-05-18','07:50:00',1.55),('12664','2013-05-18','07:55:00',1.7),('12664','2013-05-18','08:00:00',1.99),('12664','2013-05-18','08:05:00',1.27),('12664','2013-05-18','08:15:00',1.08),('12664','2013-05-18','08:20:00',1.38),('12664','2013-05-18','08:25:00',1.6),('12664','2013-05-18','08:30:00',1.57),('12664','2013-05-18','08:35:00',1.55),('12664','2013-05-18','08:40:00',2.21),('12664','2013-05-18','08:45:00',2.48),('12664','2013-05-18','08:50:00',2.52),('12664','2013-05-18','08:55:00',2.28),('12664','2013-05-18','09:00:00',2.61),('12664','2013-05-18','09:05:00',2.79),('12664','2013-05-18','09:10:00',2.88),('12664','2013-05-18','09:15:00',2.92),('12664','2013-05-18','09:20:00',2.97),('12664','2013-05-18','09:25:00',3.04),('12664','2013-05-18','09:30:00',3.11),('12664','2013-05-18','09:35:00',3.19),('12664','2013-05-18','09:40:00',3.25),('12664','2013-05-18','09:45:00',3.31),('12664','2013-05-18','09:50:00',3.38),('12664','2013-05-18','09:55:00',3.45),('12664','2013-05-18','10:00:00',3.5),('12664','2013-05-18','10:05:00',3.54),('12664','2013-05-18','10:10:00',3.62),('12664','2013-05-18','10:15:00',3.66),('12664','2013-05-18','10:20:00',3.69),('12664','2013-05-18','10:25:00',3.74),('12664','2013-05-18','10:30:00',3.79),('12664','2013-05-18','10:35:00',3.84),('12664','2013-05-18','10:40:00',3.87),('12664','2013-05-18','10:45:00',3.95),('12664','2013-05-18','10:50:00',4.02),('12664','2013-05-18','10:55:00',4.13),('12664','2013-05-18','11:00:00',4.26),('12664','2013-05-18','11:05:00',4.57),('12664','2013-05-18','11:10:00',3.78),('12664','2013-05-18','11:15:00',3.7),('12664','2013-05-18','11:20:00',3.89),('12664','2013-05-18','11:25:00',3.29),('12664','2013-05-18','11:30:00',4.34),('12664','2013-05-18','11:35:00',4.2),('12664','2013-05-18','11:40:00',4.24),('12664','2013-05-18','11:45:00',4.29),('12664','2013-05-18','11:50:00',4.28),('12664','2013-05-18','11:55:00',4.3),('12664','2013-05-18','12:00:00',4.31),('12664','2013-05-18','12:05:00',4.31),('12664','2013-05-18','12:10:00',4.34),('12664','2013-05-18','12:15:00',4.31),('12664','2013-05-18','12:20:00',4.34),('12664','2013-05-18','12:25:00',4.42),('12664','2013-05-18','12:30:00',4.42),('12664','2013-05-18','12:35:00',4.4),('12664','2013-05-18','12:40:00',4.4),('12664','2013-05-18','12:45:00',4.4),('12664','2013-05-18','12:50:00',4.39),('12664','2013-05-18','12:55:00',4.36),('12664','2013-05-18','13:00:00',4.37),('12664','2013-05-18','13:05:00',4.37),('12664','2013-05-18','13:10:00',4.37),('12664','2013-05-18','13:15:00',4.36),('12664','2013-05-18','13:20:00',4.36),('12664','2013-05-18','13:25:00',4.34),('12664','2013-05-18','13:30:00',4.35),('12664','2013-05-18','13:35:00',4.37),('12664','2013-05-18','13:40:00',4.37),('12664','2013-05-18','13:45:00',4.37),('12664','2013-05-18','13:50:00',4.36),('12664','2013-05-18','13:55:00',4.35),('12664','2013-05-18','14:00:00',4.67),('12664','2013-05-18','14:05:00',3.82),('12664','2013-05-18','14:10:00',3.35),('12664','2013-05-18','14:15:00',3.54),('12664','2013-05-18','14:20:00',3.42),('12664','2013-05-18','14:25:00',3.54),('12664','2013-05-18','14:30:00',4.01),('12664','2013-05-18','14:35:00',4.15),('12664','2013-05-18','14:40:00',4.23),('12664','2013-05-18','14:45:00',3.01),('12664','2013-05-18','14:50:00',3.21),('12664','2013-05-18','14:55:00',3.24),('12664','2013-05-18','15:00:00',3.81),('12664','2013-05-18','15:05:00',3.82),('12664','2013-05-18','15:10:00',3.73),('12664','2013-05-18','15:15:00',3.67),('12664','2013-05-18','15:20:00',3.61),('12664','2013-05-18','15:25:00',3.55),('12664','2013-05-18','15:30:00',3.54),('12664','2013-05-18','15:35:00',3.38),('12664','2013-05-18','15:40:00',3.46),('12664','2013-05-18','15:45:00',3.35),('12664','2013-05-18','15:50:00',3.28),('12664','2013-05-18','15:55:00',3.2),('12664','2013-05-18','16:00:00',3.14),('12664','2013-05-18','16:05:00',3.1),('12664','2013-05-18','16:10:00',3.04),('12664','2013-05-18','16:15:00',2.94),('12664','2013-05-18','16:20:00',2.87),('12664','2013-05-18','16:25:00',2.8),('12664','2013-05-18','16:30:00',2.77),('12664','2013-05-18','16:35:00',2.67),('12664','2013-05-18','16:40:00',2.61),('12664','2013-05-18','16:45:00',2.53),('12664','2013-05-18','16:50:00',2.45),('12664','2013-05-18','16:55:00',2.39),('12664','2013-05-18','17:00:00',2.29),('12664','2013-05-18','17:05:00',2.24),('12664','2013-05-18','17:10:00',2.17),('12664','2013-05-18','17:15:00',2.08),('12664','2013-05-18','17:20:00',2),('12664','2013-05-18','17:25:00',1.92),('12664','2013-05-18','17:30:00',1.84),('12664','2013-05-18','17:35:00',1.75),('12664','2013-05-18','17:40:00',1.68),('12664','2013-05-18','17:45:00',1.6),('12664','2013-05-18','17:50:00',1.52),('12664','2013-05-18','17:55:00',1.44),('12664','2013-05-18','18:00:00',1.36),('12664','2013-05-18','18:05:00',1.27),('12664','2013-05-18','18:10:00',1.18),('12664','2013-05-18','18:15:00',1.09),('12664','2013-05-18','18:20:00',1.02),('12664','2013-05-17','07:40:00',1.19),('12664','2013-05-17','07:45:00',1.35),('12664','2013-05-17','07:50:00',1.68),('12664','2013-05-17','07:55:00',1.54),('12664','2013-05-17','08:00:00',1.1),('12664','2013-05-17','08:05:00',1.65),('12664','2013-05-17','08:10:00',2.13),('12664','2013-05-17','08:15:00',2.05),('12664','2013-05-17','08:20:00',1.65),('12664','2013-05-17','09:10:00',1.04),('12664','2013-05-17','09:15:00',1.43),('12664','2013-05-17','09:20:00',1.05),('12664','2013-05-17','10:15:00',1.01),('12664','2013-05-17','10:20:00',1.23),('12664','2013-05-17','10:25:00',1.21),('12664','2013-05-17','10:30:00',1.31),('12664','2013-05-17','10:35:00',1.28),('12664','2013-05-17','10:40:00',1.73),('12664','2013-05-17','10:45:00',3.02),('12664','2013-05-17','10:50:00',3.36),('12664','2013-05-17','10:55:00',3.18),('12664','2013-05-17','11:00:00',2.01),('12664','2013-05-17','11:05:00',1.84),('12664','2013-05-17','11:10:00',3.28),('12664','2013-05-17','11:15:00',3.64),('12664','2013-05-17','11:20:00',2.85),('12664','2013-05-17','11:25:00',3.99),('12664','2013-05-17','11:30:00',3.18),('12664','2013-05-17','11:35:00',2.65),('12664','2013-05-17','11:40:00',2.37),('12664','2013-05-17','11:45:00',3.33),('12664','2013-05-17','11:50:00',4.71),('12664','2013-05-17','11:55:00',4.45),('12664','2013-05-17','12:00:00',4.64),('12664','2013-05-17','12:05:00',4.73),('12664','2013-05-17','12:10:00',4.91),('12664','2013-05-17','12:15:00',4.11),('12664','2013-05-17','12:20:00',4.02),('12664','2013-05-17','12:25:00',2.93),('12664','2013-05-17','12:30:00',3.72),('12664','2013-05-17','12:35:00',3.86),('12664','2013-05-17','12:40:00',3.91),('12664','2013-05-17','12:45:00',4.28),('12664','2013-05-17','12:50:00',3.77),('12664','2013-05-17','12:55:00',3.69),('12664','2013-05-17','13:00:00',1.14),('12664','2013-05-17','13:05:00',1.25),('12664','2013-05-17','13:15:00',1.46),('12664','2013-05-17','13:20:00',3.09),('12664','2013-05-17','13:25:00',4.08),('12664','2013-05-17','13:30:00',3.08),('12664','2013-05-17','13:35:00',4.06),('12664','2013-05-17','13:40:00',3.86),('12664','2013-05-17','13:45:00',3.8),('12664','2013-05-17','13:50:00',4.15),('12664','2013-05-17','13:55:00',4.03),('12664','2013-05-17','14:00:00',4.18),('12664','2013-05-17','14:05:00',3.94),('12664','2013-05-17','14:10:00',4.18),('12664','2013-05-17','14:15:00',4.1),('12664','2013-05-17','14:20:00',4.27),('12664','2013-05-17','14:25:00',2.98),('12664','2013-05-17','14:30:00',4.34),('12664','2013-05-17','14:35:00',3.48),('12664','2013-05-17','14:40:00',3.86),('12664','2013-05-17','14:45:00',3.7),('12664','2013-05-17','14:50:00',3.33),('12664','2013-05-17','14:55:00',4.17),('12664','2013-05-17','15:00:00',4.27),('12664','2013-05-17','15:05:00',3.52),('12664','2013-05-17','15:10:00',4.2),('12664','2013-05-17','15:15:00',4.32),('12664','2013-05-17','15:20:00',4.22),('12664','2013-05-17','15:25:00',4.21),('12664','2013-05-17','15:30:00',4.11),('12664','2013-05-17','15:35:00',4.08),('12664','2013-05-17','15:40:00',3.77),('12664','2013-05-17','15:45:00',4.03),('12664','2013-05-17','15:50:00',3.77),('12664','2013-05-17','15:55:00',3.77),('12664','2013-05-17','16:00:00',3.73),('12664','2013-05-17','16:05:00',3.6),('12664','2013-05-17','16:10:00',3.55),('12664','2013-05-17','16:15:00',3.47),('12664','2013-05-17','16:20:00',3.44),('12664','2013-05-17','16:25:00',3.41),('12664','2013-05-17','16:30:00',3.08),('12664','2013-05-17','16:35:00',3.24),('12664','2013-05-17','16:40:00',3.13),('12664','2013-05-17','16:45:00',3.05),('12664','2013-05-17','16:50:00',2.97),('12664','2013-05-17','16:55:00',2.79),('12664','2013-05-17','17:00:00',2.83),('12664','2013-05-17','17:05:00',2.88),('12664','2013-05-17','17:10:00',2.72),('12664','2013-05-17','17:15:00',2.6),('12664','2013-05-17','17:20:00',2.44),('12664','2013-05-17','17:25:00',2.3),('12664','2013-05-17','17:30:00',2.22),('12664','2013-05-17','17:35:00',2.14),('12664','2013-05-17','17:40:00',2.06),('12664','2013-05-17','17:45:00',1.94),('12664','2013-05-17','17:50:00',1.82),('12664','2013-05-17','17:55:00',1.72),('12664','2013-05-17','18:00:00',1.62),('12664','2013-05-17','18:05:00',1.51),('12664','2013-05-17','18:10:00',1.42),('12664','2013-05-17','18:15:00',1.33),('12664','2013-05-17','18:20:00',1.22),('12664','2013-05-17','18:25:00',1.12),('12664','2013-05-17','18:30:00',1.02),('12664','2013-05-16','09:20:00',1.26),('12664','2013-05-16','09:25:00',1.9),('12664','2013-05-16','09:30:00',1.67),('12664','2013-05-16','09:35:00',1.89),('12664','2013-05-16','09:40:00',2.35),('12664','2013-05-16','09:45:00',3.5),('12664','2013-05-16','09:50:00',2.99),('12664','2013-05-16','09:55:00',1.11),('12664','2013-05-16','10:00:00',2.1),('12664','2013-05-16','10:05:00',1.44),('12664','2013-05-16','10:10:00',1.27),('12664','2013-05-16','10:15:00',1.58),('12664','2013-05-16','10:20:00',2.56),('12664','2013-05-16','10:25:00',1.41),('12664','2013-05-16','10:30:00',1.85),('12664','2013-05-16','10:35:00',1.75),('12664','2013-05-16','10:40:00',2.44),('12664','2013-05-16','10:45:00',3.3),('12664','2013-05-16','10:50:00',2.08),('12664','2013-05-16','10:55:00',1.79),('12664','2013-05-16','11:00:00',2.54),('12664','2013-05-16','11:05:00',3.37),('12664','2013-05-16','11:10:00',2.86),('12664','2013-05-16','11:15:00',3.79),('12664','2013-05-16','11:20:00',3.2),('12664','2013-05-16','11:25:00',2.14),('12664','2013-05-16','11:30:00',2.43),('12664','2013-05-16','11:35:00',2.23),('12664','2013-05-16','11:40:00',3.93),('12664','2013-05-16','11:45:00',4.46),('12664','2013-05-16','11:50:00',4.7),('12664','2013-05-16','11:55:00',3.64),('12664','2013-05-16','12:00:00',1.87),('12664','2013-05-16','12:05:00',1.34),('12664','2013-05-16','12:10:00',1.26),('12664','2013-05-16','12:15:00',1.25),('12664','2013-05-16','12:20:00',1.68),('12664','2013-05-16','12:25:00',2.03),('12664','2013-05-16','12:30:00',2.69),('12664','2013-05-16','12:35:00',4.89),('12664','2013-05-16','12:40:00',4.63),('12664','2013-05-16','12:45:00',3.39),('12664','2013-05-16','12:50:00',3.34),('12664','2013-05-16','12:55:00',4.62),('12664','2013-05-16','13:00:00',4.39),('12664','2013-05-16','13:05:00',4.34),('12664','2013-05-16','13:10:00',4.38),('12664','2013-05-16','13:15:00',4.36),('12664','2013-05-16','13:20:00',4.3),('12664','2013-05-16','13:25:00',4.34),('12664','2013-05-16','13:30:00',4.3),('12664','2013-05-16','13:35:00',4.29),('12664','2013-05-16','13:40:00',4.3),('12664','2013-05-16','13:45:00',4.27),('12664','2013-05-16','13:50:00',4.21),('12664','2013-05-16','13:55:00',4.23),('12664','2013-05-16','14:00:00',4.23),('12664','2013-05-16','14:05:00',4.15),('12664','2013-05-16','14:10:00',4.13),('12664','2013-05-16','14:15:00',4.08),('12664','2013-05-16','14:20:00',4.07),('12664','2013-05-16','14:25:00',4.07),('12664','2013-05-16','14:30:00',4),('12664','2013-05-16','14:35:00',3.91),('12664','2013-05-16','14:40:00',3.88),('12664','2013-05-16','14:45:00',3.88),('12664','2013-05-16','14:50:00',3.87),('12664','2013-05-16','14:55:00',3.82),('12664','2013-05-16','15:00:00',3.79),('12664','2013-05-16','15:05:00',3.74),('12664','2013-05-16','15:10:00',3.72),('12664','2013-05-16','15:15:00',3.05),('12664','2013-05-16','15:20:00',3.01),('12664','2013-05-16','15:25:00',3.44),('12664','2013-05-16','15:30:00',3.46),('12664','2013-05-16','15:35:00',3.35),('12664','2013-05-16','15:40:00',3.37),('12664','2013-05-16','15:45:00',3.32),('12664','2013-05-16','15:50:00',3.28),('12664','2013-05-16','15:55:00',3.16),('12664','2013-05-16','16:00:00',3.07),('12664','2013-05-16','16:05:00',2.9),('12664','2013-05-16','16:10:00',3.01),('12664','2013-05-16','16:15:00',2.58),('12664','2013-05-16','16:20:00',2.73),('12664','2013-05-16','16:25:00',2.76),('12664','2013-05-16','16:30:00',2.68),('12664','2013-05-16','16:35:00',2.65),('12664','2013-05-16','16:40:00',2.65),('12664','2013-05-16','16:45:00',2.23),('12664','2013-05-16','16:50:00',1.75),('12664','2013-05-16','16:55:00',1.84),('12664','2013-05-16','17:00:00',1.66),('12664','2013-05-16','17:05:00',1.3),('12664','2013-05-16','17:10:00',1.26),('12664','2013-05-16','17:15:00',1.3),('12664','2013-05-16','17:20:00',1.42),('12664','2013-05-16','17:25:00',1.92),('12664','2013-05-16','17:30:00',1.8),('12664','2013-05-16','17:35:00',1.08),('12664','2013-05-16','18:20:00',1.02),('12664','2013-05-16','18:25:00',1.09),('12664','2013-05-16','18:30:00',1.12),('12664','2013-05-16','18:35:00',1.12),('12664','2013-05-16','18:40:00',1.12),('12664','2013-05-16','18:45:00',1.12),('12664','2013-05-16','18:50:00',1.02),('12664','2013-05-15','07:35:00',1.1),('12664','2013-05-15','07:40:00',1.19),('12664','2013-05-15','07:45:00',1.24),('12664','2013-05-15','07:50:00',1.5),('12664','2013-05-15','07:55:00',1.48),('12664','2013-05-15','08:00:00',1.32),('12664','2013-05-15','08:05:00',1.34),('12664','2013-05-15','08:10:00',1.71),('12664','2013-05-15','08:15:00',1.78),('12664','2013-05-15','08:20:00',1.9),('12664','2013-05-15','08:25:00',1.85),('12664','2013-05-15','08:30:00',2.02),('12664','2013-05-15','08:35:00',2.19),('12664','2013-05-15','08:40:00',2.29),('12664','2013-05-15','08:45:00',2.36),('12664','2013-05-15','08:50:00',2.43),('12664','2013-05-15','08:55:00',2.42),('12664','2013-05-15','09:00:00',2.53),('12664','2013-05-15','09:05:00',2.52),('12664','2013-05-15','09:10:00',2.62),('12664','2013-05-15','09:15:00',2.67),('12664','2013-05-15','09:20:00',2.68),('12664','2013-05-15','09:25:00',2.88),('12664','2013-05-15','09:30:00',3.02),('12664','2013-05-15','09:35:00',2.97),('12664','2013-05-15','09:40:00',3.02),('12664','2013-05-15','09:45:00',3.18),('12664','2013-05-15','09:50:00',3.24),('12664','2013-05-15','09:55:00',3.35),('12664','2013-05-15','10:00:00',3.38),('12664','2013-05-15','10:05:00',3.47),('12664','2013-05-15','10:10:00',3.41),('12664','2013-05-15','10:15:00',3.56),('12664','2013-05-15','10:20:00',3.66),('12664','2013-05-15','10:25:00',3.75),('12664','2013-05-15','10:30:00',3.7),('12664','2013-05-15','10:35:00',3.65),('12664','2013-05-15','10:40:00',3.7),('12664','2013-05-15','10:45:00',3.8),('12664','2013-05-15','10:50:00',3.93),('12664','2013-05-15','10:55:00',3.88),('12664','2013-05-15','11:00:00',3.9),('12664','2013-05-15','11:05:00',4.01),('12664','2013-05-15','11:10:00',4.05),('12664','2013-05-15','11:15:00',3.89),('12664','2013-05-15','11:20:00',4),('12664','2013-05-15','11:25:00',4.32),('12664','2013-05-15','11:30:00',4.19),('12664','2013-05-15','11:35:00',4.46),('12664','2013-05-15','11:40:00',4.38),('12664','2013-05-15','11:45:00',4.17),('12664','2013-05-15','11:50:00',2.5),('12664','2013-05-15','11:55:00',3.25),('12664','2013-05-15','12:00:00',4.26),('12664','2013-05-15','12:05:00',4.29),('12664','2013-05-15','12:10:00',4.79),('12664','2013-05-15','12:15:00',3.6),('12664','2013-05-15','12:20:00',3.77),('12664','2013-05-15','12:25:00',4.39),('12664','2013-05-15','12:30:00',4.45),('12664','2013-05-15','12:35:00',3.98),('12664','2013-05-15','12:40:00',3.06),('12664','2013-05-15','12:45:00',2.58),('12664','2013-05-15','12:50:00',2.6),('12664','2013-05-15','12:55:00',2.54),('12664','2013-05-15','13:00:00',2.47),('12664','2013-05-15','13:05:00',2.7),('12664','2013-05-15','13:10:00',2.7),('12664','2013-05-15','13:15:00',2.6),('12664','2013-05-15','13:20:00',2.52),('12664','2013-05-15','13:25:00',2.52),('12664','2013-05-15','13:30:00',2.65),('12664','2013-05-15','13:35:00',2.55),('12664','2013-05-15','13:40:00',2.39),('12664','2013-05-15','13:45:00',2.13),('12664','2013-05-15','13:50:00',2.44),('12664','2013-05-15','13:55:00',2.2),('12664','2013-05-15','14:00:00',2.26),('12664','2013-05-15','14:05:00',2.77),('12664','2013-05-15','14:10:00',2.66),('12664','2013-05-15','14:15:00',2.7),('12664','2013-05-15','14:20:00',2.57),('12664','2013-05-15','14:25:00',2.12),('12664','2013-05-15','14:30:00',1.69),('12664','2013-05-15','14:35:00',1.46),('12664','2013-05-15','14:40:00',1.31),('12664','2013-05-15','14:45:00',1.26),('12664','2013-05-15','14:50:00',1.26),('12664','2013-05-15','14:55:00',1.38),('12664','2013-05-15','15:00:00',1.32),('12664','2013-05-15','15:05:00',1.09),('12664','2013-05-15','15:30:00',1),('12664','2013-05-15','15:35:00',1.06),('12664','2013-05-15','15:40:00',1.18),('12664','2013-05-15','15:45:00',1.42),('12664','2013-05-15','15:50:00',1.84),('12664','2013-05-15','15:55:00',1.9),('12664','2013-05-15','16:00:00',1.88),('12664','2013-05-15','16:05:00',1.8),('12664','2013-05-15','16:10:00',1.64),('12664','2013-05-15','16:15:00',1.65),('12664','2013-05-15','16:20:00',1.73),('12664','2013-05-15','16:25:00',1.74),('12664','2013-05-15','16:30:00',1.58),('12664','2013-05-15','16:35:00',1.6),('12664','2013-05-15','16:40:00',1.5),('12664','2013-05-15','16:45:00',1.33),('12664','2013-05-15','16:50:00',1.25),('12664','2013-05-15','16:55:00',1.37),('12664','2013-05-15','17:00:00',1.7),('12664','2013-05-15','17:05:00',2.02),('12664','2013-05-15','17:10:00',2.11),('12664','2013-05-15','17:15:00',1.67),('12664','2013-05-15','17:20:00',1.9),('12664','2013-05-15','17:25:00',1.57),('12664','2013-05-15','17:30:00',1.15),('12664','2013-05-14','07:35:00',1.07),('12664','2013-05-14','07:40:00',1.18),('12664','2013-05-14','07:45:00',1.28),('12664','2013-05-14','07:50:00',1.39),('12664','2013-05-14','07:55:00',1.49),('12664','2013-05-14','08:00:00',1.59),('12664','2013-05-14','08:05:00',1.7),('12664','2013-05-14','08:10:00',1.8),('12664','2013-05-14','08:15:00',1.9),('12664','2013-05-14','08:20:00',2),('12664','2013-05-14','08:25:00',2.1),('12664','2013-05-14','08:30:00',2.2),('12664','2013-05-14','08:35:00',2.29),('12664','2013-05-14','08:40:00',2.39),('12664','2013-05-14','08:45:00',2.48),('12664','2013-05-14','08:50:00',2.56),('12664','2013-05-14','08:55:00',2.65),('12664','2013-05-14','09:00:00',2.73),('12664','2013-05-14','09:05:00',2.82),('12664','2013-05-14','09:10:00',2.89),('12664','2013-05-14','09:15:00',2.97),('12664','2013-05-14','09:20:00',3.05),('12664','2013-05-14','09:25:00',3.13),('12664','2013-05-14','09:30:00',3.2),('12664','2013-05-14','09:35:00',3.27),('12664','2013-05-14','09:40:00',3.33),('12664','2013-05-14','09:45:00',3.41),('12664','2013-05-14','09:50:00',3.48),('12664','2013-05-14','09:55:00',3.53),('12664','2013-05-14','10:00:00',3.6),('12664','2013-05-14','10:05:00',3.65),('12664','2013-05-14','10:10:00',3.71),('12664','2013-05-14','10:15:00',3.77),('12664','2013-05-14','10:20:00',3.82),('12664','2013-05-14','10:25:00',3.88),('12664','2013-05-14','10:30:00',3.94),('12664','2013-05-14','10:35:00',4),('12664','2013-05-14','10:40:00',4.02),('12664','2013-05-14','10:45:00',4.05),('12664','2013-05-14','10:50:00',4.1),('12664','2013-05-14','10:55:00',4.14),('12664','2013-05-14','11:00:00',4.19),('12664','2013-05-14','11:05:00',4.22),('12664','2013-05-14','11:10:00',4.23),('12664','2013-05-14','11:15:00',4.27),('12664','2013-05-14','11:20:00',4.29),('12664','2013-05-14','11:25:00',3.86),('12664','2013-05-14','11:30:00',4.35),('12664','2013-05-14','11:35:00',4.14),('12664','2013-05-14','11:40:00',4.35),('12664','2013-05-14','11:45:00',4.37),('12664','2013-05-14','11:50:00',4.39),('12664','2013-05-14','11:55:00',4.4),('12664','2013-05-14','12:00:00',4.43),('12664','2013-05-14','12:05:00',3.98),('12664','2013-05-14','12:10:00',4.46),('12664','2013-05-14','12:15:00',4.5),('12664','2013-05-14','12:20:00',4.31),('12664','2013-05-14','12:25:00',1.78),('12664','2013-05-14','12:30:00',3.38),('12664','2013-05-14','12:35:00',2.66),('12664','2013-05-14','12:40:00',3.94),('12664','2013-05-14','12:45:00',2.49),('12664','2013-05-14','12:50:00',2.18),('12664','2013-05-14','12:55:00',2.26),('12664','2013-05-14','13:05:00',1.33),('12664','2013-05-14','13:10:00',1.73),('12664','2013-05-14','13:45:00',2.46),('12664','2013-05-14','13:50:00',4.4),('12664','2013-05-14','13:55:00',4.41),('12664','2013-05-14','14:00:00',4.38),('12664','2013-05-14','14:05:00',4.36),('12664','2013-05-14','14:10:00',4.41),('12664','2013-05-14','14:15:00',4.43),('12664','2013-05-14','14:20:00',4.4),('12664','2013-05-14','14:25:00',4.4),('12664','2013-05-14','14:30:00',4.38),('12664','2013-05-14','14:35:00',4.36),('12664','2013-05-14','14:40:00',4.34),('12664','2013-05-14','14:45:00',4.33),('12664','2013-05-14','14:50:00',4.32),('12664','2013-05-14','14:55:00',4.27),('12664','2013-05-14','15:00:00',4.22),('12664','2013-05-14','15:05:00',4.19),('12664','2013-05-14','15:10:00',4.14),('12664','2013-05-14','15:15:00',4.09),('12664','2013-05-14','15:20:00',4.06),('12664','2013-05-14','15:25:00',4.01),('12664','2013-05-14','15:30:00',3.98),('12664','2013-05-14','15:35:00',3.91),('12664','2013-05-14','15:40:00',3.85),('12664','2013-05-14','15:45:00',3.79),('12664','2013-05-14','15:50:00',3.74),('12664','2013-05-14','15:55:00',3.68),('12664','2013-05-14','16:00:00',3.6),('12664','2013-05-14','16:05:00',3.55),('12664','2013-05-14','16:10:00',3.49),('12664','2013-05-14','16:15:00',3.43),('12664','2013-05-14','16:20:00',3.35),('12664','2013-05-14','16:25:00',3.27),('12664','2013-05-14','16:30:00',3.18),('12664','2013-05-14','16:35:00',3.1),('12664','2013-05-14','16:40:00',3.02),('12664','2013-05-14','16:45:00',2.94),('12664','2013-05-14','16:50:00',2.86),('12664','2013-05-14','16:55:00',2.77),('12664','2013-05-14','17:00:00',2.68),('12664','2013-05-14','17:05:00',2.59),('12664','2013-05-14','17:10:00',2.51),('12664','2013-05-14','17:15:00',2.42),('12664','2013-05-14','17:20:00',2.32),('12664','2013-05-14','17:25:00',2.23),('12664','2013-05-14','17:30:00',2.14),('12664','2013-05-14','17:35:00',2.04),('12664','2013-05-14','17:40:00',1.94),('12664','2013-05-14','17:45:00',1.85),('12664','2013-05-14','17:50:00',1.75),('12664','2013-05-14','17:55:00',1.65),('12664','2013-05-14','18:00:00',1.54),('12664','2013-05-14','18:05:00',1.45),('12664','2013-05-14','18:10:00',1.35),('12664','2013-05-14','18:15:00',1.25),('12664','2013-05-14','18:20:00',1.14),('12664','2013-05-14','18:25:00',1.04),('12664','2013-05-13','07:30:00',1.22),('12664','2013-05-13','07:35:00',1.23),('12664','2013-05-13','07:40:00',1.2),('12664','2013-05-13','07:45:00',1.35),('12664','2013-05-13','07:50:00',1.35),('12664','2013-05-13','07:55:00',1.38),('12664','2013-05-13','08:00:00',1.47),('12664','2013-05-13','08:05:00',1.56),('12664','2013-05-13','08:10:00',1.65),('12664','2013-05-13','08:15:00',1.74),('12664','2013-05-13','08:20:00',1.83),('12664','2013-05-13','08:25:00',1.93),('12664','2013-05-13','08:30:00',2.03),('12664','2013-05-13','08:35:00',2.13),('12664','2013-05-13','08:40:00',2.23),('12664','2013-05-13','08:45:00',2.29),('12664','2013-05-13','08:50:00',2.39),('12664','2013-05-13','08:55:00',2.46),('12664','2013-05-13','09:00:00',2.54),('12664','2013-05-13','09:05:00',2.63),('12664','2013-05-13','09:10:00',2.73),('12664','2013-05-13','09:15:00',2.83),('12664','2013-05-13','09:20:00',2.87),('12664','2013-05-13','09:25:00',3.02),('12664','2013-05-13','09:30:00',1.9),('12664','2013-05-13','09:35:00',3.41),('12664','2013-05-13','09:40:00',2.34),('12664','2013-05-13','09:45:00',3.74),('12664','2013-05-13','09:50:00',4.03),('12664','2013-05-13','09:55:00',2.71),('12664','2013-05-13','10:00:00',2.72),('12664','2013-05-13','10:05:00',1.72),('12664','2013-05-13','10:10:00',2.83),('12664','2013-05-13','10:15:00',2.29),('12664','2013-05-13','10:20:00',1.92),('12664','2013-05-13','10:25:00',3.27),('12664','2013-05-13','10:30:00',4.34),('12664','2013-05-13','10:35:00',3.14),('12664','2013-05-13','10:40:00',3.56),('12664','2013-05-13','10:45:00',1.52),('12664','2013-05-13','10:50:00',2.29),('12664','2013-05-13','10:55:00',4.07),('12664','2013-05-13','11:00:00',4.34),('12664','2013-05-13','11:05:00',4.43),('12664','2013-05-13','11:10:00',4.69),('12664','2013-05-13','11:15:00',4.7),('12664','2013-05-13','11:20:00',1.58),('12664','2013-05-13','11:25:00',3),('12664','2013-05-13','11:30:00',4.88),('12664','2013-05-13','11:35:00',4.79),('12664','2013-05-13','11:40:00',4.75),('12664','2013-05-13','11:45:00',4.91),('12664','2013-05-13','11:50:00',5.01),('12664','2013-05-13','11:55:00',2.93),('12664','2013-05-13','12:00:00',2.81),('12664','2013-05-13','12:05:00',3.9),('12664','2013-05-13','12:10:00',1.38),('12664','2013-05-13','12:30:00',3.74),('12664','2013-05-13','12:35:00',5.03),('12664','2013-05-13','12:40:00',2.55),('12664','2013-05-13','12:45:00',4.42),('12664','2013-05-13','12:50:00',3.14),('12664','2013-05-13','12:55:00',3.23),('12664','2013-05-13','13:00:00',2.93),('12664','2013-05-13','13:05:00',2.43),('12664','2013-05-13','13:10:00',2),('12664','2013-05-13','13:15:00',1.12),('12664','2013-05-13','13:25:00',2.67),('12664','2013-05-13','13:30:00',1.35),('12664','2013-05-13','13:35:00',1.17),('12664','2013-05-13','13:55:00',1.11),('12664','2013-05-13','14:00:00',3.93),('12664','2013-05-13','14:05:00',4.47),('12664','2013-05-13','14:10:00',1.61),('12664','2013-05-13','14:20:00',1.1),('12664','2013-05-13','14:25:00',1.35),('12664','2013-05-13','14:35:00',1.08),('12664','2013-05-13','14:40:00',3.21),('12664','2013-05-13','14:45:00',1.82),('12664','2013-05-13','14:50:00',2.33),('12664','2013-05-13','15:30:00',1.48),('12664','2013-05-13','15:35:00',2.79),('12664','2013-05-13','15:40:00',3.24),('12664','2013-05-13','15:45:00',4.1),('12664','2013-05-13','15:50:00',1.98),('12664','2013-05-13','15:55:00',1.04),('12664','2013-05-13','16:00:00',1.15),('12664','2013-05-13','16:05:00',1.3),('12664','2013-05-13','16:10:00',1.36),('12664','2013-05-13','16:15:00',1.22),('12664','2013-05-13','16:20:00',1.03),('12664','2013-05-13','16:25:00',1.02),('12664','2013-05-13','16:55:00',2.08),('12664','2013-05-13','17:00:00',2.15),('12664','2013-05-13','17:05:00',2.2),('12664','2013-05-13','17:10:00',1.59),('12664','2013-05-13','17:15:00',2.58),('12664','2013-05-13','17:20:00',2.54),('12664','2013-05-13','17:25:00',2.01),('12664','2013-05-13','17:30:00',2.23),('12664','2013-05-13','17:35:00',2.07),('12664','2013-05-13','17:40:00',1.96),('12664','2013-05-13','17:45:00',1.85),('12664','2013-05-13','17:50:00',1.77),('12664','2013-05-13','17:55:00',1.36),('12664','2013-05-13','18:00:00',1.37),('12664','2013-05-13','18:05:00',1.65),('12664','2013-05-13','18:10:00',1.61),('12664','2013-05-13','18:15:00',1.47),('12664','2013-05-13','18:20:00',1.52),('12664','2013-05-13','18:25:00',1.62),('12664','2013-05-13','18:30:00',1.53),('12664','2013-05-13','18:35:00',1.37),('12664','2013-05-12','07:35:00',1.07),('12664','2013-05-12','07:45:00',1.33),('12664','2013-05-12','07:50:00',1.34),('12664','2013-05-12','08:05:00',1.07),('12664','2013-05-12','08:25:00',1.35),('12664','2013-05-12','08:30:00',2.01),('12664','2013-05-12','08:35:00',1.75),('12664','2013-05-12','08:40:00',1.67),('12664','2013-05-12','08:45:00',1.54),('12664','2013-05-12','08:50:00',1.48),('12664','2013-05-12','08:55:00',2.71),('12664','2013-05-12','09:00:00',3.1),('12664','2013-05-12','09:05:00',2.96),('12664','2013-05-12','09:10:00',2.47),('12664','2013-05-12','09:15:00',3.24),('12664','2013-05-12','09:20:00',3.6),('12664','2013-05-12','09:25:00',2.94),('12664','2013-05-12','09:30:00',2.17),('12664','2013-05-12','09:35:00',2.68),('12664','2013-05-12','09:40:00',1.44),('12664','2013-05-12','09:45:00',3),('12664','2013-05-12','09:50:00',2.08),('12664','2013-05-12','09:55:00',4.19),('12664','2013-05-12','10:00:00',4.08),('12664','2013-05-12','10:05:00',3.52),('12664','2013-05-12','10:10:00',2.7),('12664','2013-05-12','10:15:00',2.35),('12664','2013-05-12','10:20:00',4.52),('12664','2013-05-12','10:25:00',4.54),('12664','2013-05-12','10:30:00',4.49),('12664','2013-05-12','10:35:00',4.45),('12664','2013-05-12','10:40:00',2.45),('12664','2013-05-12','10:45:00',2.59),('12664','2013-05-12','10:50:00',1.03),('12664','2013-05-12','10:55:00',4.03),('12664','2013-05-12','11:00:00',4.55),('12664','2013-05-12','11:05:00',4.02),('12664','2013-05-12','11:10:00',4.66),('12664','2013-05-12','11:15:00',4.27),('12664','2013-05-12','11:20:00',2.61),('12664','2013-05-12','11:25:00',1.42),('12664','2013-05-12','11:30:00',1.49),('12664','2013-05-12','11:35:00',1.25),('12664','2013-05-12','11:40:00',2.39),('12664','2013-05-12','11:45:00',3.21),('12664','2013-05-12','11:50:00',4.78),('12664','2013-05-12','11:55:00',4.92),('12664','2013-05-12','12:00:00',1.42),('12664','2013-05-12','12:05:00',1.37),('12664','2013-05-12','12:10:00',2.81),('12664','2013-05-12','12:15:00',2.88),('12664','2013-05-12','12:20:00',4.5),('12664','2013-05-12','12:25:00',3.47),('12664','2013-05-12','12:30:00',3.55),('12664','2013-05-12','12:35:00',1.81),('12664','2013-05-12','12:40:00',2.44),('12664','2013-05-12','12:45:00',2.5),('12664','2013-05-12','12:50:00',5.03),('12664','2013-05-12','12:55:00',4.87),('12664','2013-05-12','13:00:00',4.72),('12664','2013-05-12','13:05:00',4.72),('12664','2013-05-12','13:10:00',4.73),('12664','2013-05-12','13:15:00',4.73),('12664','2013-05-12','13:20:00',4.7),('12664','2013-05-12','13:25:00',4.72),('12664','2013-05-12','13:30:00',4.75),('12664','2013-05-12','13:35:00',4.75),('12664','2013-05-12','13:40:00',4.77),('12664','2013-05-12','13:45:00',4.91),('12664','2013-05-12','13:50:00',4.38),('12664','2013-05-12','13:55:00',4.67),('12664','2013-05-12','14:00:00',4.76),('12664','2013-05-12','14:05:00',4.76),('12664','2013-05-12','14:10:00',4.75),('12664','2013-05-12','14:15:00',4.1),('12664','2013-05-12','14:20:00',4.35),('12664','2013-05-12','14:25:00',2.66),('12664','2013-05-12','14:30:00',2.94),('12664','2013-05-12','14:35:00',1.36),('12664','2013-05-12','14:40:00',2.5),('12664','2013-05-12','14:45:00',3.34),('12664','2013-05-12','14:50:00',2.1),('12664','2013-05-12','14:55:00',1.45),('12664','2013-05-12','15:00:00',3.49),('12664','2013-05-12','15:05:00',4.39),('12664','2013-05-12','15:10:00',3.55),('12664','2013-05-12','15:15:00',3.78),('12664','2013-05-12','15:20:00',4.12),('12664','2013-05-12','15:25:00',4.09),('12664','2013-05-12','15:30:00',3.96),('12664','2013-05-12','15:35:00',3.87),('12664','2013-05-12','15:40:00',3.81),('12664','2013-05-12','15:45:00',3.73),('12664','2013-05-12','15:50:00',3.67),('12664','2013-05-12','15:55:00',3.61),('12664','2013-05-12','16:00:00',3.55),('12664','2013-05-12','16:05:00',3.47),('12664','2013-05-12','16:10:00',3.2),('12664','2013-05-12','16:15:00',3.39),('12664','2013-05-12','16:20:00',2.47),('12664','2013-05-12','16:25:00',2.41),('12664','2013-05-12','16:30:00',3.31),('12664','2013-05-12','16:35:00',2.16),('12664','2013-05-12','16:40:00',2.51),('12664','2013-05-12','16:45:00',3.36),('12664','2013-05-12','16:50:00',2.5),('12664','2013-05-12','16:55:00',1.48),('12664','2013-05-12','17:00:00',2.36),('12664','2013-05-12','17:05:00',2.2),('12664','2013-05-12','17:10:00',2.56),('12664','2013-05-12','17:15:00',2.37),('12664','2013-05-12','17:20:00',2.12),('12664','2013-05-12','17:25:00',1.53),('12664','2013-05-12','17:30:00',2.04),('12664','2013-05-12','17:35:00',2.03),('12664','2013-05-12','17:40:00',1.49),('12664','2013-05-12','17:45:00',1.99),('12664','2013-05-12','17:50:00',2.73),('12664','2013-05-12','17:55:00',2.43),('12664','2013-05-12','18:00:00',1.85),('12664','2013-05-12','18:05:00',1.73),('12664','2013-05-12','18:10:00',1.68),('12664','2013-05-12','18:15:00',1.26),('12664','2013-05-12','18:20:00',1.13),('12664','2013-05-12','18:25:00',1.2),('12664','2013-05-12','18:30:00',1.19),('12664','2013-05-12','18:35:00',1.21),('12664','2013-05-11','07:35:00',1.08),('12664','2013-05-11','07:40:00',1.43),('12664','2013-05-11','07:45:00',1.45),('12664','2013-05-11','07:55:00',1.01),('12664','2013-05-11','08:10:00',1.27),('12664','2013-05-11','08:15:00',1.53),('12664','2013-05-11','08:25:00',1.66),('12664','2013-05-11','08:30:00',1.65),('12664','2013-05-11','08:35:00',1.68),('12664','2013-05-11','08:40:00',1.93),('12664','2013-05-11','08:45:00',1.76),('12664','2013-05-11','08:50:00',2.22),('12664','2013-05-11','08:55:00',1.71),('12664','2013-05-11','09:00:00',1.36),('12664','2013-05-11','09:05:00',1.85),('12664','2013-05-11','09:10:00',2.88),('12664','2013-05-11','09:15:00',2.23),('12664','2013-05-11','09:20:00',2.17),('12664','2013-05-11','09:25:00',2.67),('12664','2013-05-11','09:30:00',1.63),('12664','2013-05-11','09:35:00',3.53),('12664','2013-05-11','09:40:00',1.64),('12664','2013-05-11','09:45:00',2.83),('12664','2013-05-11','09:50:00',1.68),('12664','2013-05-11','09:55:00',1.79),('12664','2013-05-11','10:10:00',3.28),('12664','2013-05-11','10:15:00',4.1),('12664','2013-05-11','10:20:00',4.07),('12664','2013-05-11','10:25:00',3.23),('12664','2013-05-11','10:30:00',2.49),('12664','2013-05-11','10:35:00',3.99),('12664','2013-05-11','10:40:00',4.09),('12664','2013-05-11','10:45:00',4.02),('12664','2013-05-11','10:50:00',4.26),('12664','2013-05-11','10:55:00',4.09),('12664','2013-05-11','11:00:00',4.34),('12664','2013-05-11','11:05:00',1.55),('12664','2013-05-11','11:10:00',4.12),('12664','2013-05-11','11:15:00',4.21),('12664','2013-05-11','11:20:00',1.7),('12664','2013-05-11','11:25:00',4.87),('12664','2013-05-11','11:30:00',4.75),('12664','2013-05-11','11:35:00',2.93),('12664','2013-05-11','11:40:00',3.17),('12664','2013-05-11','11:45:00',2.68),('12664','2013-05-11','11:50:00',4.89),('12664','2013-05-11','11:55:00',2.35),('12664','2013-05-11','12:00:00',3.38),('12664','2013-05-11','12:05:00',2.9),('12664','2013-05-11','12:10:00',4.42),('12664','2013-05-11','12:15:00',2.32),('12664','2013-05-11','12:20:00',4.4),('12664','2013-05-11','12:25:00',4.21),('12664','2013-05-11','12:30:00',5.05),('12664','2013-05-11','12:35:00',2.97),('12664','2013-05-11','12:40:00',3.49),('12664','2013-05-11','12:45:00',3.21),('12664','2013-05-11','12:50:00',2.59),('12664','2013-05-11','12:55:00',4.14),('12664','2013-05-11','13:00:00',4.85),('12664','2013-05-11','13:05:00',3.06),('12664','2013-05-11','13:10:00',3.55),('12664','2013-05-11','13:15:00',3.18),('12664','2013-05-11','13:20:00',3.61),('12664','2013-05-11','13:25:00',2.33),('12664','2013-05-11','13:30:00',2.69),('12664','2013-05-11','13:35:00',3.07),('12664','2013-05-11','13:40:00',3.16),('12664','2013-05-11','13:45:00',2.91),('12664','2013-05-11','13:50:00',4.03),('12664','2013-05-11','13:55:00',4.27),('12664','2013-05-11','14:00:00',4.99),('12664','2013-05-11','14:05:00',3.75),('12664','2013-05-11','14:10:00',3.81),('12664','2013-05-11','14:15:00',3.26),('12664','2013-05-11','14:20:00',2.17),('12664','2013-05-11','14:25:00',3.17),('12664','2013-05-11','14:30:00',3.56),('12664','2013-05-11','14:35:00',3.51),('12664','2013-05-11','14:40:00',2.5),('12664','2013-05-11','14:45:00',2.91),('12664','2013-05-11','14:50:00',4.11),('12664','2013-05-11','14:55:00',3.63),('12664','2013-05-11','15:00:00',3.07),('12664','2013-05-11','15:05:00',3.34),('12664','2013-05-11','15:10:00',2.18),('12664','2013-05-11','15:15:00',2.86),('12664','2013-05-11','15:20:00',3.18),('12664','2013-05-11','15:25:00',3.64),('12664','2013-05-11','15:30:00',3.66),('12664','2013-05-11','15:35:00',4.01),('12664','2013-05-11','15:40:00',3.55),('12664','2013-05-11','15:45:00',1.93),('12664','2013-05-11','15:50:00',3.66),('12664','2013-05-11','15:55:00',4.03),('12664','2013-05-11','16:00:00',2.72),('12664','2013-05-11','16:05:00',3.85),('12664','2013-05-11','16:10:00',3.61),('12664','2013-05-11','16:15:00',3.64),('12664','2013-05-11','16:20:00',3.4),('12664','2013-05-11','16:25:00',3.39),('12664','2013-05-11','16:30:00',2.82),('12664','2013-05-11','16:35:00',2.94),('12664','2013-05-11','16:40:00',2.84),('12664','2013-05-11','16:45:00',3.05),('12664','2013-05-11','16:50:00',3.38),('12664','2013-05-11','16:55:00',2.59),('12664','2013-05-11','17:00:00',2.78),('12664','2013-05-11','17:05:00',2.39),('12664','2013-05-11','17:10:00',1.75),('12664','2013-05-11','17:15:00',1.67),('12664','2013-05-11','17:20:00',2.29),('12664','2013-05-11','17:25:00',1.86),('12664','2013-05-11','17:30:00',2.21),('12664','2013-05-11','17:35:00',1.47),('12664','2013-05-11','17:40:00',1.99),('12664','2013-05-11','17:45:00',1.21),('12664','2013-05-11','17:50:00',1.3),('12664','2013-05-11','17:55:00',1.84),('12664','2013-05-11','18:05:00',1.1),('12664','2013-05-11','18:15:00',1.3),('12664','2014-03-30','08:25:00',1.07),('12664','2014-03-30','08:30:00',1.2),('12664','2014-03-30','08:35:00',1.23),('12664','2014-03-30','08:40:00',1.23),('12664','2014-03-30','08:45:00',1.23),('12664','2014-03-30','08:50:00',1.22),('12664','2014-03-30','08:55:00',1.26),('12664','2014-03-30','09:00:00',1.32),('12664','2014-03-30','09:05:00',1.36),('12664','2014-03-30','09:10:00',1.47),('12664','2014-03-30','09:15:00',1.67),('12664','2014-03-30','09:20:00',1.8),('12664','2014-03-30','09:25:00',1.9),('12664','2014-03-30','09:30:00',1.97),('12664','2014-03-30','09:35:00',2.08),('12664','2014-03-30','09:40:00',2.2),('12664','2014-03-30','09:45:00',2.23),('12664','2014-03-30','09:50:00',2.23),('12664','2014-03-30','09:55:00',2.35),('12664','2014-03-30','10:00:00',2.54),('12664','2014-03-30','10:05:00',2.63),('12664','2014-03-30','10:10:00',2.78),('12664','2014-03-30','10:15:00',2.91),('12664','2014-03-30','10:20:00',2.88),('12664','2014-03-30','10:25:00',2.95),('12664','2014-03-30','10:30:00',2.99),('12664','2014-03-30','10:35:00',3.02),('12664','2014-03-30','10:40:00',3.03),('12664','2014-03-30','10:45:00',3.08),('12664','2014-03-30','10:50:00',3.07),('12664','2014-03-30','10:55:00',3.17),('12664','2014-03-30','11:00:00',3.11),('12664','2014-03-30','11:05:00',3.04),('12664','2014-03-30','11:10:00',3.21),('12664','2014-03-30','11:15:00',3.15),('12664','2014-03-30','11:20:00',3.16),('12664','2014-03-30','11:25:00',3.25),('12664','2014-03-30','11:30:00',3.48),('12664','2014-03-30','11:35:00',3.54),('12664','2014-03-30','11:40:00',3.64),('12664','2014-03-30','11:45:00',3.63),('12664','2014-03-30','11:50:00',3.71),('12664','2014-03-30','11:55:00',3.71),('12664','2014-03-30','12:00:00',3.7),('12664','2014-03-30','12:05:00',3.72),('12664','2014-03-30','12:10:00',3.74),('12664','2014-03-30','12:15:00',3.89),('12664','2014-03-30','12:20:00',3.97),('12664','2014-03-30','12:25:00',3.74),('12664','2014-03-30','12:30:00',3.79),('12664','2014-03-30','12:35:00',3.99),('12664','2014-03-30','12:40:00',4.09),('12664','2014-03-30','12:45:00',4.1),('12664','2014-03-30','12:50:00',4.09),('12664','2014-03-30','12:55:00',4.07),('12664','2014-03-30','13:00:00',4.08),('12664','2014-03-30','13:05:00',4.07),('12664','2014-03-30','13:10:00',4),('12664','2014-03-30','13:15:00',4),('12664','2014-03-30','13:20:00',4.07),('12664','2014-03-30','13:25:00',4.18),('12664','2014-03-30','13:30:00',4.19),('12664','2014-03-30','13:35:00',4.15),('12664','2014-03-30','13:40:00',4.15),('12664','2014-03-30','13:45:00',4.16),('12664','2014-03-30','13:50:00',4.14),('12664','2014-03-30','13:55:00',4.15),('12664','2014-03-30','14:00:00',4.07),('12664','2014-03-30','14:05:00',4.07),('12664','2014-03-30','14:10:00',3.92),('12664','2014-03-30','14:15:00',3.51),('12664','2014-03-30','14:20:00',2.99),('12664','2014-03-30','14:25:00',2.38),('12664','2014-03-30','14:30:00',2.82),('12664','2014-03-30','14:35:00',2.42),('12664','2014-03-30','14:40:00',2.44),('12664','2014-03-30','14:45:00',2.48),('12664','2014-03-30','14:50:00',2.13),('12664','2014-03-30','14:55:00',2.37),('12664','2014-03-30','15:00:00',2.87),('12664','2014-03-30','15:05:00',2.97),('12664','2014-03-30','15:10:00',3.06),('12664','2014-03-30','15:15:00',3.05),('12664','2014-03-30','15:20:00',2.52),('12664','2014-03-30','15:25:00',2.66),('12664','2014-03-30','15:30:00',2.99),('12664','2014-03-30','15:35:00',3.17),('12664','2014-03-30','15:40:00',3.14),('12664','2014-03-30','15:45:00',3.22),('12664','2014-03-30','15:50:00',3.28),('12664','2014-03-30','15:55:00',3.22),('12664','2014-03-30','16:00:00',3.23),('12664','2014-03-30','16:05:00',3.11),('12664','2014-03-30','16:10:00',2.94),('12664','2014-03-30','16:15:00',2.89),('12664','2014-03-30','16:20:00',2.85),('12664','2014-03-30','16:25:00',2.37),('12664','2014-03-30','16:30:00',2.04),('12664','2014-03-30','16:35:00',2.1),('12664','2014-03-30','16:40:00',2.46),('12664','2014-03-30','16:45:00',2.43),('12664','2014-03-30','16:50:00',2.28),('12664','2014-03-30','16:55:00',2.27),('12664','2014-03-30','17:00:00',2.15),('12664','2014-03-30','17:05:00',2.03),('12664','2014-03-30','17:10:00',1.89),('12664','2014-03-30','17:15:00',1.8),('12664','2014-03-30','17:20:00',1.76),('12664','2014-03-30','17:25:00',1.66),('12664','2014-03-30','17:30:00',1.55),('12664','2014-03-30','17:35:00',1.45),('12664','2014-03-30','17:40:00',1.38),('12664','2014-03-30','17:45:00',1.26),('12664','2014-03-30','17:50:00',1.15),('12664','2014-03-30','17:55:00',1.03),('12664','2013-05-10','07:45:00',1.12),('12664','2013-05-10','07:50:00',1.45),('12664','2013-05-10','07:55:00',1.27),('12664','2013-05-10','08:00:00',1.38),('12664','2013-05-10','08:05:00',1.37),('12664','2013-05-10','08:10:00',1.49),('12664','2013-05-10','08:15:00',1.74),('12664','2013-05-10','08:20:00',1.59),('12664','2013-05-10','08:25:00',1.07),('12664','2013-05-10','08:45:00',1.29),('12664','2013-05-10','08:50:00',2.34),('12664','2013-05-10','08:55:00',2.53),('12664','2013-05-10','09:00:00',2.52),('12664','2013-05-10','09:05:00',2.65),('12664','2013-05-10','09:10:00',2.75),('12664','2013-05-10','09:15:00',1.76),('12664','2013-05-10','09:20:00',2.81),('12664','2013-05-10','09:25:00',3.08),('12664','2013-05-10','09:30:00',2.49),('12664','2013-05-10','09:35:00',3.1),('12664','2013-05-10','09:40:00',2.09),('12664','2013-05-10','09:45:00',2.28),('12664','2013-05-10','09:50:00',2.15),('12664','2013-05-10','09:55:00',2.97),('12664','2013-05-10','10:00:00',1.39),('12664','2013-05-10','10:05:00',1.19),('12664','2013-05-10','10:10:00',2.48),('12664','2013-05-10','10:15:00',3.5),('12664','2013-05-10','10:20:00',3.85),('12664','2013-05-10','10:25:00',3.84),('12664','2013-05-10','10:30:00',3.87),('12664','2013-05-10','10:35:00',3.92),('12664','2013-05-10','10:40:00',3.97),('12664','2013-05-10','10:45:00',4.18),('12664','2013-05-10','10:50:00',2.73),('12664','2013-05-10','10:55:00',3.99),('12664','2013-05-10','11:00:00',2.89),('12664','2013-05-10','11:05:00',3.71),('12664','2013-05-10','11:10:00',4.36),('12664','2013-05-10','11:15:00',2.28),('12664','2013-05-10','11:20:00',2.36),('12664','2013-05-10','11:25:00',4.66),('12664','2013-05-10','11:30:00',3),('12664','2013-05-10','11:35:00',3.64),('12664','2013-05-10','11:40:00',4.54),('12664','2013-05-10','11:45:00',3.95),('12664','2013-05-10','11:50:00',3.2),('12664','2013-05-10','11:55:00',3.6),('12664','2013-05-10','12:00:00',3.27),('12664','2013-05-10','12:05:00',3.32),('12664','2013-05-10','12:10:00',3.11),('12664','2013-05-10','12:15:00',3.14),('12664','2013-05-10','12:20:00',3.67),('12664','2013-05-10','12:25:00',4.36),('12664','2013-05-10','12:30:00',4.16),('12664','2013-05-10','12:35:00',3.99),('12664','2013-05-10','12:40:00',3.88),('12664','2013-05-10','12:45:00',3.52),('12664','2013-05-10','12:50:00',4.92),('12664','2013-05-10','12:55:00',3.88),('12664','2013-05-10','13:00:00',3.84),('12664','2013-05-10','13:05:00',4.25),('12664','2013-05-10','13:10:00',4.93),('12664','2013-05-10','13:15:00',5.02),('12664','2013-05-10','13:20:00',4.76),('12664','2013-05-10','13:25:00',4.94),('12664','2013-05-10','13:30:00',4.44),('12664','2013-05-10','13:35:00',3.93),('12664','2013-05-10','13:40:00',2.51),('12664','2013-05-10','13:45:00',2.1),('12664','2013-05-10','13:50:00',2.16),('12664','2013-05-10','13:55:00',2.63),('12664','2013-05-10','14:00:00',2.98),('12664','2013-05-10','14:05:00',3.41),('12664','2013-05-10','14:10:00',3.31),('12664','2013-05-10','14:15:00',2.58),('12664','2013-05-10','14:20:00',2.51),('12664','2013-05-10','14:25:00',2.74),('12664','2013-05-10','14:30:00',2.33),('12664','2013-05-10','14:35:00',2.02),('12664','2013-05-10','14:40:00',1.58),('12664','2013-05-10','14:45:00',1.52),('12664','2013-05-10','14:50:00',1.89),('12664','2013-05-10','14:55:00',3.46),('12664','2013-05-10','15:00:00',3.63),('12664','2013-05-10','15:05:00',3.16),('12664','2013-05-10','15:10:00',2.14),('12664','2013-05-10','15:15:00',2.12),('12664','2013-05-10','15:20:00',2.41),('12664','2013-05-10','15:25:00',2.72),('12664','2013-05-10','15:30:00',2.46),('12664','2013-05-10','15:35:00',2.24),('12664','2013-05-10','15:40:00',2.11),('12664','2013-05-10','15:45:00',1.99),('12664','2013-05-10','15:50:00',1.92),('12664','2013-05-10','15:55:00',1.83),('12664','2013-05-10','16:00:00',1.68),('12664','2013-05-10','16:05:00',1.63),('12664','2013-05-10','16:10:00',1.73),('12664','2013-05-10','16:15:00',1.89),('12664','2013-05-10','16:20:00',1.91),('12664','2013-05-10','16:25:00',1.84),('12664','2013-05-10','16:30:00',1.76),('12664','2013-05-10','16:35:00',1.72),('12664','2013-05-10','16:40:00',1.44),('12664','2013-05-10','16:45:00',1.2),('12664','2013-05-10','16:50:00',1.34),('12664','2013-05-10','16:55:00',2.07),('12664','2013-05-10','17:00:00',1.93),('12664','2013-05-10','17:05:00',1.88),('12664','2013-05-10','17:10:00',2.19),('12664','2013-05-10','17:15:00',3.22),('12664','2013-05-10','17:20:00',2.72),('12664','2013-05-10','17:25:00',2.45),('12664','2013-05-10','17:30:00',1.22),('12664','2013-05-10','17:35:00',1.48),('12664','2013-05-10','17:40:00',1.15),('12664','2013-05-10','17:45:00',1.01),('12664','2013-05-09','07:40:00',1.05),('12664','2013-05-09','07:45:00',1.16),('12664','2013-05-09','07:50:00',1.27),('12664','2013-05-09','07:55:00',1.37),('12664','2013-05-09','08:00:00',1.47),('12664','2013-05-09','08:05:00',1.57),('12664','2013-05-09','08:10:00',1.67),('12664','2013-05-09','08:15:00',1.77),('12664','2013-05-09','08:20:00',1.86),('12664','2013-05-09','08:25:00',1.96),('12664','2013-05-09','08:30:00',2.05),('12664','2013-05-09','08:35:00',2.15),('12664','2013-05-09','08:40:00',2.24),('12664','2013-05-09','08:45:00',2.33),('12664','2013-05-09','08:50:00',2.43),('12664','2013-05-09','08:55:00',2.52),('12664','2013-05-09','09:00:00',2.6),('12664','2013-05-09','09:05:00',2.69),('12664','2013-05-09','09:10:00',2.76),('12664','2013-05-09','09:15:00',2.83),('12664','2013-05-09','09:20:00',2.9),('12664','2013-05-09','09:25:00',2.96),('12664','2013-05-09','09:30:00',3.06),('12664','2013-05-09','09:35:00',3.14),('12664','2013-05-09','09:40:00',3.21),('12664','2013-05-09','09:45:00',3.27),('12664','2013-05-09','09:50:00',3.35),('12664','2013-05-09','09:55:00',3.4),('12664','2013-05-09','10:00:00',3.49),('12664','2013-05-09','10:05:00',3.53),('12664','2013-05-09','10:10:00',3.61),('12664','2013-05-09','10:15:00',3.67),('12664','2013-05-09','10:20:00',3.72),('12664','2013-05-09','10:25:00',3.75),('12664','2013-05-09','10:30:00',3.77),('12664','2013-05-09','10:35:00',3.82),('12664','2013-05-09','10:40:00',3.87),('12664','2013-05-09','10:45:00',3.91),('12664','2013-05-09','10:50:00',3.96),('12664','2013-05-09','10:55:00',3.99),('12664','2013-05-09','11:00:00',4.03),('12664','2013-05-09','11:05:00',4.07),('12664','2013-05-09','11:10:00',4.11),('12664','2013-05-09','11:15:00',4.15),('12664','2013-05-09','11:20:00',4.14),('12664','2013-05-09','11:25:00',4.17),('12664','2013-05-09','11:30:00',4.24),('12664','2013-05-09','11:35:00',4.27),('12664','2013-05-09','11:40:00',4.29),('12664','2013-05-09','11:45:00',4.25),('12664','2013-05-09','11:50:00',4.34),('12664','2013-05-09','11:55:00',4.44),('12664','2013-05-09','12:00:00',4.47),('12664','2013-05-09','12:05:00',4.46),('12664','2013-05-09','12:10:00',4.47),('12664','2013-05-09','12:15:00',4.48),('12664','2013-05-09','12:20:00',3.99),('12664','2013-05-09','12:25:00',4.45),('12664','2013-05-09','12:30:00',4.56),('12664','2013-05-09','12:35:00',4.55),('12664','2013-05-09','12:40:00',4.63),('12664','2013-05-09','12:45:00',4.66),('12664','2013-05-09','12:50:00',4.33),('12664','2013-05-09','12:55:00',3.01),('12664','2013-05-09','13:00:00',4.58),('12664','2013-05-09','13:05:00',4.56),('12664','2013-05-09','13:10:00',3.55),('12664','2013-05-09','13:15:00',4.33),('12664','2013-05-09','13:20:00',4.74),('12664','2013-05-09','13:25:00',4.61),('12664','2013-05-09','13:30:00',4.58),('12664','2013-05-09','13:35:00',4.58),('12664','2013-05-09','13:40:00',4.71),('12664','2013-05-09','13:45:00',4.73),('12664','2013-05-09','13:50:00',2.79),('12664','2013-05-09','14:00:00',4.4),('12664','2013-05-09','14:05:00',3.29),('12664','2013-05-09','14:10:00',3.66),('12664','2013-05-09','14:15:00',4.8),('12664','2013-05-09','14:20:00',2.43),('12664','2013-05-09','14:25:00',3.57),('12664','2013-05-09','14:30:00',4.44),('12664','2013-05-09','14:35:00',4.43),('12664','2013-05-09','14:40:00',4.39),('12664','2013-05-09','14:45:00',4.29),('12664','2013-05-09','14:50:00',4.18),('12664','2013-05-09','14:55:00',4.15),('12664','2013-05-09','15:00:00',4.02),('12664','2013-05-09','15:05:00',4.02),('12664','2013-05-09','15:10:00',4.01),('12664','2013-05-09','15:15:00',3.42),('12664','2013-05-09','15:20:00',3.24),('12664','2013-05-09','15:25:00',3.92),('12664','2013-05-09','15:30:00',3.88),('12664','2013-05-09','15:35:00',3.81),('12664','2013-05-09','15:40:00',3.74),('12664','2013-05-09','15:45:00',3.65),('12664','2013-05-09','15:50:00',3.58),('12664','2013-05-09','15:55:00',3.54),('12664','2013-05-09','16:00:00',3.54),('12664','2013-05-09','16:05:00',3.47),('12664','2013-05-09','16:10:00',3.38),('12664','2013-05-09','16:15:00',3.32),('12664','2013-05-09','16:20:00',3.25),('12664','2013-05-09','16:25:00',3.17),('12664','2013-05-09','16:30:00',3.1),('12664','2013-05-09','16:35:00',3.01),('12664','2013-05-09','16:40:00',2.94),('12664','2013-05-09','16:45:00',2.86),('12664','2013-05-09','16:50:00',2.79),('12664','2013-05-09','16:55:00',2.7),('12664','2013-05-09','17:00:00',2.61),('12664','2013-05-09','17:05:00',2.51),('12664','2013-05-09','17:10:00',2.43),('12664','2013-05-09','17:15:00',2.34),('12664','2013-05-09','17:20:00',2.25),('12664','2013-05-09','17:25:00',2.15),('12664','2013-05-09','17:30:00',2.06),('12664','2013-05-09','17:35:00',1.97),('12664','2013-05-09','17:40:00',1.87),('12664','2013-05-09','17:45:00',1.77),('12664','2013-05-09','17:50:00',1.67),('12664','2013-05-09','17:55:00',1.58),('12664','2013-05-09','18:00:00',1.47),('12664','2013-05-09','18:05:00',1.36),('12664','2013-05-09','18:10:00',1.28),('12664','2013-05-09','18:15:00',1.18),('12664','2013-05-09','18:20:00',1.08),('12664','2013-05-08','07:40:00',1.04),('12664','2013-05-08','07:45:00',1.12),('12664','2013-05-08','07:50:00',1.23),('12664','2013-05-08','07:55:00',1.36),('12664','2013-05-08','08:00:00',1.45),('12664','2013-05-08','08:05:00',1.56),('12664','2013-05-08','08:10:00',1.64),('12664','2013-05-08','08:15:00',1.72),('12664','2013-05-08','08:20:00',1.85),('12664','2013-05-08','08:25:00',1.88),('12664','2013-05-08','08:30:00',2.06),('12664','2013-05-08','08:35:00',2.45),('12664','2013-05-08','08:40:00',2.82),('12664','2013-05-08','08:45:00',2.18),('12664','2013-05-08','08:50:00',1.2),('12664','2013-05-08','08:55:00',1.66),('12664','2013-05-08','09:25:00',1.4),('12664','2013-05-08','09:30:00',1.85),('12664','2013-05-08','09:35:00',3.63),('12664','2013-05-08','09:40:00',2.2),('12664','2013-05-08','09:45:00',2.73),('12664','2013-05-08','09:50:00',3.01),('12664','2013-05-08','09:55:00',2.95),('12664','2013-05-08','10:00:00',3.98),('12664','2013-05-08','10:05:00',3.74),('12664','2013-05-08','10:10:00',2.63),('12664','2013-05-08','10:15:00',1.6),('12664','2013-05-08','10:20:00',1.94),('12664','2013-05-08','10:25:00',4.26),('12664','2013-05-08','10:30:00',4.31),('12664','2013-05-08','10:35:00',4.6),('12664','2013-05-08','10:40:00',3.33),('12664','2013-05-08','10:45:00',2.12),('12664','2013-05-08','10:50:00',1.24),('12664','2013-05-08','10:55:00',1.29),('12664','2013-05-08','11:00:00',1.48),('12664','2013-05-08','11:05:00',1.19),('12664','2013-05-08','11:10:00',1.09),('12664','2013-05-08','11:15:00',1.19),('12664','2013-05-08','11:20:00',4.06),('12664','2013-05-08','11:25:00',4.73),('12664','2013-05-08','11:30:00',4.73),('12664','2013-05-08','11:35:00',4.88),('12664','2013-05-08','11:40:00',2.14),('12664','2013-05-08','11:45:00',1.31),('12664','2013-05-08','11:50:00',1.34),('12664','2013-05-08','11:55:00',4.7),('12664','2013-05-08','12:00:00',3.91),('12664','2013-05-08','12:05:00',2.9),('12664','2013-05-08','12:10:00',1.49),('12664','2013-05-08','12:15:00',2.64),('12664','2013-05-08','12:20:00',4.92),('12664','2013-05-08','12:25:00',4.92),('12664','2013-05-08','12:30:00',4.06),('12664','2013-05-08','12:35:00',1.46),('12664','2013-05-08','12:40:00',1.38),('12664','2013-05-08','12:45:00',1.36),('12664','2013-05-08','12:50:00',1.46),('12664','2013-05-08','12:55:00',2.6),('12664','2013-05-08','13:00:00',4.45),('12664','2013-05-08','13:05:00',4.46),('12664','2013-05-08','13:10:00',4.14),('12664','2013-05-08','13:15:00',3.66),('12664','2013-05-08','13:20:00',3.69),('12664','2013-05-08','13:25:00',2.82),('12664','2013-05-08','13:30:00',4.07),('12664','2013-05-08','13:35:00',4.65),('12664','2013-05-08','13:40:00',5.05),('12664','2013-05-08','13:45:00',5.03),('12664','2013-05-08','13:50:00',4.81),('12664','2013-05-08','13:55:00',4.96),('12664','2013-05-08','14:00:00',4.38),('12664','2013-05-08','14:05:00',1.53),('12664','2013-05-08','14:10:00',3.92),('12664','2013-05-08','14:15:00',4.74),('12664','2013-05-08','14:20:00',4.88),('12664','2013-05-08','14:25:00',3.11),('12664','2013-05-08','14:30:00',3.5),('12664','2013-05-08','14:35:00',5),('12664','2013-05-08','14:40:00',4.59),('12664','2013-05-08','14:45:00',1.68),('12664','2013-05-08','14:50:00',1.3),('12664','2013-05-08','14:55:00',3.35),('12664','2013-05-08','15:00:00',4.47),('12664','2013-05-08','15:05:00',4.45),('12664','2013-05-08','15:10:00',4.38),('12664','2013-05-08','15:15:00',4.22),('12664','2013-05-08','15:20:00',4.05),('12664','2013-05-08','15:25:00',3.97),('12664','2013-05-08','15:30:00',3.9),('12664','2013-05-08','15:35:00',3.85),('12664','2013-05-08','15:40:00',3.79),('12664','2013-05-08','15:45:00',3.72),('12664','2013-05-08','15:50:00',3.66),('12664','2013-05-08','15:55:00',3.61),('12664','2013-05-08','16:00:00',3.53),('12664','2013-05-08','16:05:00',3.47),('12664','2013-05-08','16:10:00',3.4),('12664','2013-05-08','16:15:00',2.91),('12664','2013-05-08','16:20:00',3.29),('12664','2013-05-08','16:25:00',3.23),('12664','2013-05-08','16:30:00',3.19),('12664','2013-05-08','16:35:00',2.86),('12664','2013-05-08','16:40:00',2.98),('12664','2013-05-08','16:45:00',3),('12664','2013-05-08','16:50:00',2.96),('12664','2013-05-08','16:55:00',2.19),('12664','2013-05-08','17:00:00',1.11),('12664','2013-05-08','17:05:00',1.13),('12664','2013-05-08','17:10:00',1.27),('12664','2013-05-08','17:15:00',1.49),('12664','2013-05-08','17:20:00',1.15),('12664','2013-05-08','17:25:00',1.48),('12664','2013-05-08','17:30:00',1.96),('12664','2013-05-08','17:35:00',2.12),('12664','2013-05-08','17:40:00',2.08),('12664','2013-05-08','17:45:00',2.12),('12664','2013-05-08','17:50:00',2.23),('12664','2013-05-08','17:55:00',2.21),('12664','2013-05-08','18:00:00',2.14),('12664','2013-05-08','18:05:00',1.95),('12664','2013-05-08','18:10:00',1.68),('12664','2013-05-08','18:15:00',1.44),('12664','2013-05-08','18:20:00',1.25),('12664','2013-05-07','07:40:00',1.06),('12664','2013-05-07','07:45:00',1.16),('12664','2013-05-07','07:50:00',1.25),('12664','2013-05-07','07:55:00',1.36),('12664','2013-05-07','08:00:00',1.47),('12664','2013-05-07','08:05:00',1.58),('12664','2013-05-07','08:10:00',1.66),('12664','2013-05-07','08:15:00',1.73),('12664','2013-05-07','08:20:00',1.84),('12664','2013-05-07','08:25:00',1.96),('12664','2013-05-07','08:30:00',2.07),('12664','2013-05-07','08:35:00',2.17),('12664','2013-05-07','08:40:00',2.3),('12664','2013-05-07','08:45:00',2.55),('12664','2013-05-07','08:50:00',1.71),('12664','2013-05-07','08:55:00',1.77),('12664','2013-05-07','09:05:00',1.57),('12664','2013-05-07','09:10:00',2.62),('12664','2013-05-07','09:15:00',3.18),('12664','2013-05-07','09:20:00',3.26),('12664','2013-05-07','09:25:00',2.56),('12664','2013-05-07','09:30:00',1.48),('12664','2013-05-07','09:55:00',1.14),('12664','2013-05-07','10:00:00',3.79),('12664','2013-05-07','10:05:00',3.89),('12664','2013-05-07','10:10:00',3.93),('12664','2013-05-07','10:15:00',4.14),('12664','2013-05-07','10:20:00',4.37),('12664','2013-05-07','10:25:00',3.96),('12664','2013-05-07','10:50:00',1.31),('12664','2013-05-07','10:55:00',2.34),('12664','2013-05-07','11:00:00',2.94),('12664','2013-05-07','11:05:00',1.4),('12664','2013-05-07','11:10:00',1.2),('12664','2013-05-07','11:15:00',1.06),('12664','2013-05-07','11:20:00',1.34),('12664','2013-05-07','11:25:00',1.44),('12664','2013-05-07','11:30:00',1.62),('12664','2013-05-07','11:35:00',2.07),('12664','2013-05-07','11:40:00',4.94),('12664','2013-05-07','11:45:00',4.85),('12664','2013-05-07','11:50:00',3.11),('12664','2013-05-07','11:55:00',1.62),('12664','2013-05-07','12:00:00',1.42),('12664','2013-05-07','12:05:00',1.55),('12664','2013-05-07','12:10:00',1.5),('12664','2013-05-07','12:15:00',1.31),('12664','2013-05-07','12:20:00',1.2),('12664','2013-05-07','12:25:00',1.1),('12664','2013-05-07','12:30:00',1.01),('12664','2013-05-07','12:35:00',1.38),('12664','2013-05-07','12:40:00',1.52),('12664','2013-05-07','12:45:00',2.75),('12664','2013-05-07','12:50:00',3.4),('12664','2013-05-07','12:55:00',3.49),('12664','2013-05-07','13:00:00',4.29),('12664','2013-05-07','13:05:00',2.02),('12664','2013-05-07','13:10:00',2.37),('12664','2013-05-07','13:15:00',3.15),('12664','2013-05-07','13:20:00',5.03),('12664','2013-05-07','13:25:00',4.58),('12664','2013-05-07','13:30:00',3.7),('12664','2013-05-07','13:35:00',4.99),('12664','2013-05-07','13:40:00',4.87),('12664','2013-05-07','13:45:00',2.16),('12664','2013-05-07','13:50:00',4.05),('12664','2013-05-07','13:55:00',3.52),('12664','2013-05-07','14:00:00',3.19),('12664','2013-05-07','14:05:00',2.12),('12664','2013-05-07','14:10:00',4.34),('12664','2013-05-07','14:15:00',2.24),('12664','2013-05-07','14:20:00',3.17),('12664','2013-05-07','14:25:00',4.62),('12664','2013-05-07','14:30:00',4.87),('12664','2013-05-07','14:35:00',4.97),('12664','2013-05-07','14:40:00',4.43),('12664','2013-05-07','14:45:00',4.34),('12664','2013-05-07','14:50:00',4.25),('12664','2013-05-07','14:55:00',4.4),('12664','2013-05-07','15:00:00',2.39),('12664','2013-05-07','15:05:00',2.96),('12664','2013-05-07','15:10:00',3.24),('12664','2013-05-07','15:15:00',3.85),('12664','2013-05-07','15:20:00',2.61),('12664','2013-05-07','15:25:00',2.91),('12664','2013-05-07','15:30:00',3.33),('12664','2013-05-07','15:35:00',4.33),('12664','2013-05-07','15:40:00',3.43),('12664','2013-05-07','15:45:00',3.1),('12664','2013-05-07','15:50:00',4),('12664','2013-05-07','15:55:00',4.34),('12664','2013-05-07','16:00:00',3.92),('12664','2013-05-07','16:05:00',3.57),('12664','2013-05-07','16:10:00',3.7),('12664','2013-05-07','16:15:00',3.52),('12664','2013-05-07','16:20:00',3.92),('12664','2013-05-07','16:25:00',3.86),('12664','2013-05-07','16:30:00',3.72),('12664','2013-05-07','16:35:00',3.61),('12664','2013-05-07','16:40:00',1.55),('12664','2013-05-07','16:45:00',1.72),('12664','2013-05-07','16:50:00',2.17),('12664','2013-05-07','16:55:00',1.71),('12664','2013-05-07','17:00:00',1.48),('12664','2013-05-07','17:05:00',1.32),('12664','2013-05-07','17:10:00',1.3),('12664','2013-05-07','17:15:00',1.38),('12664','2013-05-07','17:20:00',2.02),('12664','2013-05-07','17:25:00',1.5),('12664','2013-05-07','17:30:00',1.03),('12664','2013-05-06','08:25:00',1.15),('12664','2013-05-06','08:30:00',1.05),('12664','2013-05-06','08:35:00',1.11),('12664','2013-05-06','08:40:00',1.02),('12664','2013-05-06','08:45:00',1.39),('12664','2013-05-06','08:50:00',1.73),('12664','2013-05-06','08:55:00',1.4),('12664','2013-05-06','09:00:00',1.12),('12664','2013-05-06','09:05:00',1.22),('12664','2013-05-06','09:10:00',2.3),('12664','2013-05-06','09:40:00',1.02),('12664','2013-05-06','09:45:00',1.22),('12664','2013-05-06','09:55:00',1.17),('12664','2013-05-06','10:00:00',1.19),('12664','2013-05-06','10:05:00',2.11),('12664','2013-05-06','10:10:00',1.72),('12664','2013-05-06','10:15:00',1.9),('12664','2013-05-06','10:20:00',2.4),('12664','2013-05-06','10:25:00',2.02),('12664','2013-05-06','10:30:00',1.88),('12664','2013-05-06','10:35:00',1.87),('12664','2013-05-06','10:40:00',1.64),('12664','2013-05-06','10:45:00',1.86),('12664','2013-05-06','10:50:00',1.75),('12664','2013-05-06','10:55:00',1.45),('12664','2013-05-06','11:05:00',1.21),('12664','2013-05-06','11:10:00',1.99),('12664','2013-05-06','11:15:00',1.5),('12664','2013-05-06','11:25:00',2.37),('12664','2013-05-06','11:30:00',2.98),('12664','2013-05-06','11:35:00',1.71),('12664','2013-05-06','11:40:00',1.59),('12664','2013-05-06','11:45:00',2.14),('12664','2013-05-06','11:50:00',2.27),('12664','2013-05-06','11:55:00',2.95),('12664','2013-05-06','12:00:00',3.24),('12664','2013-05-06','12:05:00',2.26),('12664','2013-05-06','12:10:00',2.34),('12664','2013-05-06','12:15:00',4.07),('12664','2013-05-06','12:20:00',2.13),('12664','2013-05-06','12:25:00',3.02),('12664','2013-05-06','12:30:00',4.04),('12664','2013-05-06','12:35:00',3.18),('12664','2013-05-06','12:40:00',4.06),('12664','2013-05-06','12:45:00',2.93),('12664','2013-05-06','12:50:00',4.37),('12664','2013-05-06','12:55:00',3.12),('12664','2013-05-06','13:00:00',4.49),('12664','2013-05-06','13:05:00',4.36),('12664','2013-05-06','13:10:00',4.28),('12664','2013-05-06','13:15:00',5.06),('12664','2013-05-06','13:20:00',3.43),('12664','2013-05-06','13:25:00',4.3),('12664','2013-05-06','13:30:00',4.21),('12664','2013-05-06','13:35:00',4.12),('12664','2013-05-06','13:40:00',4.46),('12664','2013-05-06','13:45:00',3.56),('12664','2013-05-06','13:50:00',4.5),('12664','2013-05-06','13:55:00',2.6),('12664','2013-05-06','14:00:00',3.49),('12664','2013-05-06','14:05:00',4.54),('12664','2013-05-06','14:10:00',3.53),('12664','2013-05-06','14:15:00',3.1),('12664','2013-05-06','14:20:00',3.68),('12664','2013-05-06','14:25:00',4.99),('12664','2013-05-06','14:30:00',3.17),('12664','2013-05-06','14:35:00',3.62),('12664','2013-05-06','14:40:00',2.76),('12664','2013-05-06','14:45:00',3.09),('12664','2013-05-06','14:50:00',3.36),('12664','2013-05-06','14:55:00',2.56),('12664','2013-05-06','15:00:00',2.55),('12664','2013-05-06','15:05:00',4.59),('12664','2013-05-06','15:10:00',4.68),('12664','2013-05-06','15:15:00',2.72),('12664','2013-05-06','15:20:00',1.95),('12664','2013-05-06','15:25:00',3.12),('12664','2013-05-06','15:30:00',1.98),('12664','2013-05-06','15:35:00',2.38),('12664','2013-05-06','15:40:00',3.16),('12664','2013-05-06','15:45:00',4.3),('12664','2013-05-06','15:50:00',2.78),('12664','2013-05-06','15:55:00',1.69),('12664','2013-05-06','16:00:00',2.24),('12664','2013-05-06','16:05:00',3.56),('12664','2013-05-06','16:10:00',3.23),('12664','2013-05-06','16:15:00',2.31),('12664','2013-05-06','16:20:00',1.31),('12664','2013-05-06','16:25:00',1.85),('12664','2013-05-06','16:30:00',1.19),('12664','2013-05-06','16:35:00',1.83),('12664','2013-05-06','16:40:00',1.02),('12664','2013-05-06','16:45:00',1.01),('12664','2013-05-06','17:00:00',1.22),('12664','2013-05-06','17:05:00',3.31),('12664','2013-05-06','17:10:00',1.07),('12664','2013-05-06','17:15:00',1.64),('12664','2013-05-06','17:20:00',1.05),('12664','2013-05-06','17:25:00',1.98),('12664','2013-05-06','17:30:00',2.54),('12664','2013-05-06','17:35:00',2.5),('12664','2013-05-06','17:40:00',2.15),('12664','2013-05-06','17:45:00',1.25),('12664','2013-05-06','17:50:00',1.35),('12664','2013-05-06','17:55:00',1.49),('12664','2013-05-06','18:00:00',1.22),('12664','2013-05-06','18:05:00',1.36),('12664','2013-05-06','18:10:00',1.65),('12664','2013-05-06','18:15:00',1.35),('12664','2013-05-06','18:20:00',1.2),('12664','2013-05-05','07:45:00',1.05),('12664','2013-05-05','07:50:00',1.1),('12664','2013-05-05','07:55:00',1.14),('12664','2013-05-05','08:00:00',1.14),('12664','2013-05-05','08:05:00',1.35),('12664','2013-05-05','08:10:00',1.51),('12664','2013-05-05','08:15:00',1.61),('12664','2013-05-05','08:20:00',1.84),('12664','2013-05-05','08:25:00',1.16),('12664','2013-05-05','08:30:00',1.02),('12664','2013-05-05','08:35:00',1.23),('12664','2013-05-05','08:40:00',1.64),('12664','2013-05-05','08:45:00',1.42),('12664','2013-05-05','08:50:00',1.34),('12664','2013-05-05','08:55:00',1.37),('12664','2013-05-05','09:00:00',1.72),('12664','2013-05-05','09:05:00',2.02),('12664','2013-05-05','09:10:00',1.56),('12664','2013-05-05','09:15:00',1.51),('12664','2013-05-05','09:20:00',1.85),('12664','2013-05-05','09:25:00',3.14),('12664','2013-05-05','09:30:00',1.65),('12664','2013-05-05','09:35:00',3.37),('12664','2013-05-05','09:40:00',2.11),('12664','2013-05-05','09:45:00',2.08),('12664','2013-05-05','09:50:00',1.85),('12664','2013-05-05','09:55:00',1.56),('12664','2013-05-05','10:00:00',1.21),('12664','2013-05-05','10:05:00',1.33),('12664','2013-05-05','10:10:00',1.41),('12664','2013-05-05','10:15:00',1.51),('12664','2013-05-05','10:20:00',1.42),('12664','2013-05-05','10:25:00',1.59),('12664','2013-05-05','10:30:00',1.73),('12664','2013-05-05','10:35:00',1.52),('12664','2013-05-05','10:40:00',1.19),('12664','2013-05-05','10:45:00',1.06),('12664','2013-05-05','10:50:00',1.09),('12664','2013-05-05','10:55:00',1.25),('12664','2013-05-05','11:00:00',1.51),('12664','2013-05-05','11:05:00',1.61),('12664','2013-05-05','11:10:00',3.85),('12664','2013-05-05','11:15:00',4.34),('12664','2013-05-05','11:20:00',3.62),('12664','2013-05-05','11:25:00',4.67),('12664','2013-05-05','11:30:00',3.46),('12664','2013-05-05','11:35:00',2.99),('12664','2013-05-05','11:40:00',2.51),('12664','2013-05-05','11:45:00',2.55),('12664','2013-05-05','11:50:00',3.29),('12664','2013-05-05','11:55:00',4.56),('12664','2013-05-05','12:00:00',3.89),('12664','2013-05-05','12:05:00',4.23),('12664','2013-05-05','12:10:00',4.9),('12664','2013-05-05','12:15:00',5.03),('12664','2013-05-05','12:20:00',4.4),('12664','2013-05-05','12:25:00',4.47),('12664','2013-05-05','12:30:00',4.8),('12664','2013-05-05','12:35:00',4.6),('12664','2013-05-05','12:40:00',4.63),('12664','2013-05-05','12:45:00',4.59),('12664','2013-05-05','12:50:00',4.77),('12664','2013-05-05','12:55:00',1.65),('12664','2013-05-05','13:00:00',1.46),('12664','2013-05-05','13:05:00',4.42),('12664','2013-05-05','13:10:00',4.47),('12664','2013-05-05','13:15:00',4.36),('12664','2013-05-05','13:20:00',4.43),('12664','2013-05-05','13:25:00',4.3),('12664','2013-05-05','13:30:00',3.07),('12664','2013-05-05','13:35:00',2.92),('12664','2013-05-05','13:40:00',3.01),('12664','2013-05-05','13:45:00',3.56),('12664','2013-05-05','13:50:00',3.2),('12664','2013-05-05','13:55:00',3.53),('12664','2013-05-05','14:00:00',4.16),('12664','2013-05-05','14:05:00',4.94),('12664','2013-05-05','14:10:00',3.94),('12664','2013-05-05','14:15:00',4.36),('12664','2013-05-05','14:20:00',4.28),('12664','2013-05-05','14:25:00',4.11),('12664','2013-05-05','14:30:00',4.06),('12664','2013-05-05','14:35:00',4.06),('12664','2013-05-05','14:40:00',4.05),('12664','2013-05-05','14:45:00',3.99),('12664','2013-05-05','14:50:00',3.92),('12664','2013-05-05','14:55:00',3.89),('12664','2013-05-05','15:00:00',3.85),('12664','2013-05-05','15:05:00',3.83),('12664','2013-05-05','15:10:00',3.78),('12664','2013-05-05','15:15:00',3.71),('12664','2013-05-05','15:20:00',3.49),('12664','2013-05-05','15:25:00',3.65),('12664','2013-05-05','15:30:00',3.6),('12664','2013-05-05','15:35:00',3.53),('12664','2013-05-05','15:40:00',3.5),('12664','2013-05-05','15:45:00',3.44),('12664','2013-05-05','15:50:00',3.36),('12664','2013-05-05','15:55:00',3.3),('12664','2013-05-05','16:00:00',3.28),('12664','2013-05-05','16:05:00',3.19),('12664','2013-05-05','16:10:00',3.13),('12664','2013-05-05','16:15:00',3.09),('12664','2013-05-05','16:20:00',3.04),('12664','2013-05-05','16:25:00',2.95),('12664','2013-05-05','16:30:00',2.89),('12664','2013-05-05','16:35:00',2.83),('12664','2013-05-05','16:40:00',2.75),('12664','2013-05-05','16:45:00',2.68),('12664','2013-05-05','16:50:00',2.59),('12664','2013-05-05','16:55:00',2.5),('12664','2013-05-05','17:00:00',2.42),('12664','2013-05-05','17:05:00',2.33),('12664','2013-05-05','17:10:00',2.26),('12664','2013-05-05','17:15:00',2.18),('12664','2013-05-05','17:20:00',2.07),('12664','2013-05-05','17:25:00',1.97),('12664','2013-05-05','17:30:00',1.89),('12664','2013-05-05','17:35:00',1.81),('12664','2013-05-05','17:40:00',1.7),('12664','2013-05-05','17:45:00',1.6),('12664','2013-05-05','17:50:00',1.52),('12664','2013-05-05','17:55:00',1.43),('12664','2013-05-05','18:00:00',1.33),('12664','2013-05-05','18:05:00',1.24),('12664','2013-05-05','18:10:00',1.14),('12664','2013-05-05','18:15:00',1.06),('12664','2013-05-04','07:45:00',1.02),('12664','2013-05-04','07:50:00',1.09),('12664','2013-05-04','07:55:00',1.2),('12664','2013-05-04','08:00:00',1.26),('12664','2013-05-04','08:05:00',1.33),('12664','2013-05-04','08:10:00',1.43),('12664','2013-05-04','08:15:00',1.52),('12664','2013-05-04','08:20:00',1.59),('12664','2013-05-04','08:25:00',1.68),('12664','2013-05-04','08:30:00',1.77),('12664','2013-05-04','08:35:00',1.85),('12664','2013-05-04','08:40:00',1.94),('12664','2013-05-04','08:45:00',2.03),('12664','2013-05-04','08:50:00',2.11),('12664','2013-05-04','08:55:00',2.21),('12664','2013-05-04','09:00:00',2.3),('12664','2013-05-04','09:05:00',2.38),('12664','2013-05-04','09:10:00',2.4),('12664','2013-05-04','09:15:00',2.42),('12664','2013-05-04','09:20:00',2.51),('12664','2013-05-04','09:25:00',2.68),('12664','2013-05-04','09:30:00',2.73),('12664','2013-05-04','09:35:00',2.77),('12664','2013-05-04','09:40:00',2.88),('12664','2013-05-04','09:45:00',2.98),('12664','2013-05-04','09:50:00',3.06),('12664','2013-05-04','09:55:00',3.23),('12664','2013-05-04','10:00:00',3.05),('12664','2013-05-04','10:05:00',3.29),('12664','2013-05-04','10:10:00',3.36),('12664','2013-05-04','10:15:00',3.41),('12664','2013-05-04','10:20:00',3.49),('12664','2013-05-04','10:25:00',3.53),('12664','2013-05-04','10:30:00',3.55),('12664','2013-05-04','10:35:00',3.51),('12664','2013-05-04','10:40:00',3.49),('12664','2013-05-04','10:45:00',3.46),('12664','2013-05-04','10:50:00',3.57),('12664','2013-05-04','10:55:00',3.78),('12664','2013-05-04','11:00:00',3.86),('12664','2013-05-04','11:05:00',3.88),('12664','2013-05-04','11:10:00',3.84),('12664','2013-05-04','11:15:00',3.5),('12664','2013-05-04','11:20:00',3.46),('12664','2013-05-04','11:25:00',3.95),('12664','2013-05-04','11:30:00',3.73),('12664','2013-05-04','11:35:00',3.66),('12664','2013-05-04','11:40:00',3.73),('12664','2013-05-04','11:45:00',3.56),('12664','2013-05-04','11:50:00',3.47),('12664','2013-05-04','11:55:00',3.57),('12664','2013-05-04','12:00:00',3.68),('12664','2013-05-04','12:05:00',3.68),('12664','2013-05-04','12:10:00',3.7),('12664','2013-05-04','12:15:00',3.9),('12664','2013-05-04','12:20:00',4.06),('12664','2013-05-04','12:25:00',4.04),('12664','2013-05-04','12:30:00',4.16),('12664','2013-05-04','12:35:00',4.12),('12664','2013-05-04','12:40:00',4.18),('12664','2013-05-04','12:45:00',4.16),('12664','2013-05-04','12:50:00',4.1),('12664','2013-05-04','12:55:00',3.96),('12664','2013-05-04','13:00:00',4),('12664','2013-05-04','13:05:00',4.07),('12664','2013-05-04','13:10:00',4.11),('12664','2013-05-04','13:15:00',4.1),('12664','2013-05-04','13:20:00',4.13),('12664','2013-05-04','13:25:00',4.18),('12664','2013-05-04','13:30:00',4.12),('12664','2013-05-04','13:35:00',3.97),('12664','2013-05-04','13:40:00',4.19),('12664','2013-05-04','13:45:00',3.77),('12664','2013-05-04','13:50:00',3.28),('12664','2013-05-04','13:55:00',3.65),('12664','2013-05-04','14:00:00',3.99),('12664','2013-05-04','14:05:00',3.73),('12664','2013-05-04','14:10:00',3.8),('12664','2013-05-04','14:15:00',3.87),('12664','2013-05-04','14:20:00',3.62),('12664','2013-05-04','14:25:00',3.72),('12664','2013-05-04','14:30:00',3.63),('12664','2013-05-04','14:35:00',3.56),('12664','2013-05-04','14:40:00',3.5),('12664','2013-05-04','14:45:00',3.48),('12664','2013-05-04','14:50:00',3.3),('12664','2013-05-04','14:55:00',3.5),('12664','2013-05-04','15:00:00',3.55),('12664','2013-05-04','15:05:00',3.27),('12664','2013-05-04','15:10:00',3.45),('12664','2013-05-04','15:15:00',3.5),('12664','2013-05-04','15:20:00',3.52),('12664','2013-05-04','15:25:00',3.53),('12664','2013-05-04','15:30:00',3.49),('12664','2013-05-04','15:35:00',3.34),('12664','2013-05-04','15:40:00',3.47),('12664','2013-05-04','15:45:00',3.39),('12664','2013-05-04','15:50:00',3.29),('12664','2013-05-04','15:55:00',3.22),('12664','2013-05-04','16:00:00',3.15),('12664','2013-05-04','16:05:00',3.07),('12664','2013-05-04','16:10:00',3.02),('12664','2013-05-04','16:15:00',2.95),('12664','2013-05-04','16:20:00',2.88),('12664','2013-05-04','16:25:00',2.81),('12664','2013-05-04','16:30:00',2.73),('12664','2013-05-04','16:35:00',2.66),('12664','2013-05-04','16:40:00',2.59),('12664','2013-05-04','16:45:00',2.51),('12664','2013-05-04','16:50:00',2.43),('12664','2013-05-04','16:55:00',2.36),('12664','2013-05-04','17:00:00',2.28),('12664','2013-05-04','17:05:00',2.21),('12664','2013-05-04','17:10:00',2.05),('12664','2013-05-04','17:15:00',1.56),('12664','2013-05-04','17:20:00',1.97),('12664','2013-05-04','17:25:00',1.9),('12664','2013-05-04','17:30:00',1.78),('12664','2013-05-04','17:35:00',1.67),('12664','2013-05-04','17:40:00',1.53),('12664','2013-05-04','17:45:00',1.35),('12664','2013-05-04','17:50:00',1.46),('12664','2013-05-04','17:55:00',1.36),('12664','2013-05-04','18:00:00',1.26),('12664','2013-05-04','18:05:00',1.17),('12664','2013-05-04','18:10:00',1.02),('12664','2013-05-03','08:15:00',1.11),('12664','2013-05-03','08:20:00',1.39),('12664','2013-05-03','08:25:00',1.45),('12664','2013-05-03','08:30:00',1.35),('12664','2013-05-03','08:35:00',1.24),('12664','2013-05-03','08:40:00',1.21),('12664','2013-05-03','08:45:00',1.19),('12664','2013-05-03','08:50:00',1.77),('12664','2013-05-03','08:55:00',1.86),('12664','2013-05-03','09:00:00',2.09),('12664','2013-05-03','09:05:00',2.19),('12664','2013-05-03','09:10:00',2.44),('12664','2013-05-03','09:15:00',2.59),('12664','2013-05-03','09:20:00',2.77),('12664','2013-05-03','09:25:00',2.84),('12664','2013-05-03','09:30:00',2.88),('12664','2013-05-03','09:35:00',2.97),('12664','2013-05-03','09:40:00',3.05),('12664','2013-05-03','09:45:00',3.13),('12664','2013-05-03','09:50:00',3.2),('12664','2013-05-03','09:55:00',3.26),('12664','2013-05-03','10:00:00',3.32),('12664','2013-05-03','10:05:00',3.4),('12664','2013-05-03','10:10:00',3.48),('12664','2013-05-03','10:15:00',3.54),('12664','2013-05-03','10:20:00',3.59),('12664','2013-05-03','10:25:00',3.64),('12664','2013-05-03','10:30:00',3.7),('12664','2013-05-03','10:35:00',3.74),('12664','2013-05-03','10:40:00',3.79),('12664','2013-05-03','10:45:00',3.82),('12664','2013-05-03','10:50:00',3.86),('12664','2013-05-03','10:55:00',3.9),('12664','2013-05-03','11:00:00',3.92),('12664','2013-05-03','11:05:00',3.95),('12664','2013-05-03','11:10:00',3.98),('12664','2013-05-03','11:15:00',4.02),('12664','2013-05-03','11:20:00',4.05),('12664','2013-05-03','11:25:00',4.07),('12664','2013-05-03','11:30:00',4.12),('12664','2013-05-03','11:35:00',4.13),('12664','2013-05-03','11:40:00',4.14),('12664','2013-05-03','11:45:00',4.19),('12664','2013-05-03','11:50:00',4.2),('12664','2013-05-03','11:55:00',4.22),('12664','2013-05-03','12:00:00',4.23),('12664','2013-05-03','12:05:00',4.23),('12664','2013-05-03','12:10:00',4.21),('12664','2013-05-03','12:15:00',4.24),('12664','2013-05-03','12:20:00',4.24),('12664','2013-05-03','12:25:00',4.24),('12664','2013-05-03','12:30:00',4.27),('12664','2013-05-03','12:35:00',4.24),('12664','2013-05-03','12:40:00',4.34),('12664','2013-05-03','12:45:00',4.3),('12664','2013-05-03','12:50:00',4.37),('12664','2013-05-03','12:55:00',4.32),('12664','2013-05-03','13:00:00',4.35),('12664','2013-05-03','13:05:00',4.37),('12664','2013-05-03','13:10:00',4.36),('12664','2013-05-03','13:15:00',4.31),('12664','2013-05-03','13:20:00',4.29),('12664','2013-05-03','13:25:00',4.22),('12664','2013-05-03','13:30:00',4.09),('12664','2013-05-03','13:35:00',4.21),('12664','2013-05-03','13:40:00',4.13),('12664','2013-05-03','13:45:00',4.24),('12664','2013-05-03','13:50:00',4.16),('12664','2013-05-03','13:55:00',4.15),('12664','2013-05-03','14:00:00',4.16),('12664','2013-05-03','14:05:00',4.07),('12664','2013-05-03','14:10:00',4.21),('12664','2013-05-03','14:15:00',4.28),('12664','2013-05-03','14:20:00',4.24),('12664','2013-05-03','14:25:00',4.2),('12664','2013-05-03','14:30:00',4.19),('12664','2013-05-03','14:35:00',4.16),('12664','2013-05-03','14:40:00',4.12),('12664','2013-05-03','14:45:00',4.05),('12664','2013-05-03','14:50:00',4.01),('12664','2013-05-03','14:55:00',3.95),('12664','2013-05-03','15:00:00',3.91),('12664','2013-05-03','15:05:00',3.87),('12664','2013-05-03','15:10:00',3.84),('12664','2013-05-03','15:15:00',3.79),('12664','2013-05-03','15:20:00',3.71),('12664','2013-05-03','15:25:00',3.68),('12664','2013-05-03','15:30:00',3.59),('12664','2013-05-03','15:35:00',3.55),('12664','2013-05-03','15:40:00',3.47),('12664','2013-05-03','15:45:00',3.42),('12664','2013-05-03','15:50:00',3.37),('12664','2013-05-03','15:55:00',3.33),('12664','2013-05-03','16:00:00',3.28),('12664','2013-05-03','16:05:00',3.23),('12664','2013-05-03','16:10:00',3.16),('12664','2013-05-03','16:15:00',3.1),('12664','2013-05-03','16:20:00',3.02),('12664','2013-05-03','16:25:00',2.94),('12664','2013-05-03','16:30:00',2.85),('12664','2013-05-03','16:35:00',2.79),('12664','2013-05-03','16:40:00',2.69),('12664','2013-05-03','16:45:00',2.61),('12664','2013-05-03','16:50:00',2.54),('12664','2013-05-03','16:55:00',2.44),('12664','2013-05-03','17:00:00',2.36),('12664','2013-05-03','17:05:00',2.28),('12664','2013-05-03','17:10:00',2.18),('12664','2013-05-03','17:15:00',2.1),('12664','2013-05-03','17:20:00',2),('12664','2013-05-03','17:25:00',1.9),('12664','2013-05-03','17:30:00',1.84),('12664','2013-05-03','17:35:00',1.74),('12664','2013-05-03','17:40:00',1.63),('12664','2013-05-03','17:45:00',1.52),('12664','2013-05-03','17:50:00',1.43),('12664','2013-05-03','17:55:00',1.36),('12664','2013-05-03','18:00:00',1.26),('12664','2013-05-03','18:05:00',1.17),('12664','2013-05-03','18:10:00',1.08),('12664','2013-05-02','08:50:00',2.31),('12664','2013-05-02','08:55:00',1.11),('12664','2013-05-02','09:00:00',1.05),('12664','2013-05-02','09:30:00',2.12),('12664','2013-05-02','09:35:00',1.44),('12664','2013-05-02','09:45:00',1.07),('12664','2013-05-02','09:50:00',2.09),('12664','2013-05-02','09:55:00',1.18),('12664','2013-05-02','10:15:00',1.5),('12664','2013-05-02','10:20:00',2.77),('12664','2013-05-02','10:25:00',3.35),('12664','2013-05-02','10:30:00',2.51),('12664','2013-05-02','10:35:00',4.36),('12664','2013-05-02','10:40:00',3.76),('12664','2013-05-02','10:45:00',3.32),('12664','2013-05-02','10:50:00',2.8),('12664','2013-05-02','10:55:00',3.34),('12664','2013-05-02','11:00:00',3.94),('12664','2013-05-02','11:05:00',3.73),('12664','2013-05-02','11:10:00',2.92),('12664','2013-05-02','11:15:00',3.93),('12664','2013-05-02','11:20:00',4.08),('12664','2013-05-02','11:25:00',4.17),('12664','2013-05-02','11:30:00',4.11),('12664','2013-05-02','11:35:00',3.63),('12664','2013-05-02','11:40:00',4.27),('12664','2013-05-02','11:45:00',4.1),('12664','2013-05-02','11:50:00',4.11),('12664','2013-05-02','11:55:00',4.12),('12664','2013-05-02','12:00:00',3.93),('12664','2013-05-02','12:05:00',4.2),('12664','2013-05-02','12:10:00',4.17),('12664','2013-05-02','12:15:00',4.19),('12664','2013-05-02','12:20:00',4.17),('12664','2013-05-02','12:25:00',4.18),('12664','2013-05-02','12:30:00',4.16),('12664','2013-05-02','12:35:00',4.22),('12664','2013-05-02','12:40:00',4.25),('12664','2013-05-02','12:45:00',4.2),('12664','2013-05-02','12:50:00',4.24),('12664','2013-05-02','12:55:00',4.22),('12664','2013-05-02','13:00:00',4.29),('12664','2013-05-02','13:05:00',4.31),('12664','2013-05-02','13:10:00',4.25),('12664','2013-05-02','13:15:00',4.31),('12664','2013-05-02','13:20:00',4.4),('12664','2013-05-02','13:25:00',4.41),('12664','2013-05-02','13:30:00',4.38),('12664','2013-05-02','13:35:00',4.36),('12664','2013-05-02','13:40:00',4.36),('12664','2013-05-02','13:45:00',4.36),('12664','2013-05-02','13:50:00',4.33),('12664','2013-05-02','13:55:00',4.28),('12664','2013-05-02','14:00:00',4.27),('12664','2013-05-02','14:05:00',4.28),('12664','2013-05-02','14:10:00',4.25),('12664','2013-05-02','14:15:00',4.17),('12664','2013-05-02','14:20:00',4.17),('12664','2013-05-02','14:25:00',4.13),('12664','2013-05-02','14:30:00',4.1),('12664','2013-05-02','14:35:00',4.09),('12664','2013-05-02','14:40:00',4.05),('12664','2013-05-02','14:45:00',4.01),('12664','2013-05-02','14:50:00',3.97),('12664','2013-05-02','14:55:00',3.95),('12664','2013-05-02','15:00:00',3.94),('12664','2013-05-02','15:05:00',3.86),('12664','2013-05-02','15:10:00',3.8),('12664','2013-05-02','15:15:00',3.78),('12664','2013-05-02','15:20:00',3.73),('12664','2013-05-02','15:25:00',3.72),('12664','2013-05-02','15:30:00',3.67),('12664','2013-05-02','15:35:00',3.62),('12664','2013-05-02','15:40:00',3.56),('12664','2013-05-02','15:45:00',3.51),('12664','2013-05-02','15:50:00',3.44),('12664','2013-05-02','15:55:00',3.38),('12664','2013-05-02','16:00:00',3.33),('12664','2013-05-02','16:05:00',3.26),('12664','2013-05-02','16:10:00',3.19),('12664','2013-05-02','16:15:00',3.12),('12664','2013-05-02','16:20:00',3.05),('12664','2013-05-02','16:25:00',2.98),('12664','2013-05-02','16:30:00',2.9),('12664','2013-05-02','16:35:00',2.82),('12664','2013-05-02','16:40:00',2.75),('12664','2013-05-02','16:45:00',2.68),('12664','2013-05-02','16:50:00',2.59),('12664','2013-05-02','16:55:00',2.51),('12664','2013-05-02','17:00:00',2.42),('12664','2013-05-02','17:05:00',2.33),('12664','2013-05-02','17:10:00',2.23),('12664','2013-05-02','17:15:00',2.14),('12664','2013-05-02','17:20:00',2.05),('12664','2013-05-02','17:25:00',1.96),('12664','2013-05-02','17:30:00',1.88),('12664','2013-05-02','17:35:00',1.79),('12664','2013-05-02','17:40:00',1.7),('12664','2013-05-02','17:45:00',1.61),('12664','2013-05-02','17:50:00',1.51),('12664','2013-05-02','17:55:00',1.42),('12664','2013-05-02','18:00:00',1.33),('12664','2013-05-02','18:05:00',1.23),('12664','2013-05-02','18:10:00',1.14),('12664','2013-05-02','18:15:00',1.05),('12664','2013-05-01','07:55:00',1.05),('12664','2013-05-01','08:00:00',1.12),('12664','2013-05-01','08:05:00',1.17),('12664','2013-05-01','08:10:00',1.29),('12664','2013-05-01','08:15:00',1.39),('12664','2013-05-01','08:20:00',1.49),('12664','2013-05-01','08:25:00',1.6),('12664','2013-05-01','08:30:00',1.7),('12664','2013-05-01','08:35:00',1.8),('12664','2013-05-01','08:40:00',1.88),('12664','2013-05-01','08:45:00',1.99),('12664','2013-05-01','08:50:00',2.08),('12664','2013-05-01','08:55:00',2.19),('12664','2013-05-01','09:00:00',2.26),('12664','2013-05-01','09:05:00',2.32),('12664','2013-05-01','09:10:00',2.38),('12664','2013-05-01','09:15:00',2.44),('12664','2013-05-01','09:20:00',2.49),('12664','2013-05-01','09:25:00',2.5),('12664','2013-05-01','09:30:00',2.64),('12664','2013-05-01','09:35:00',2.71),('12664','2013-05-01','09:40:00',2.77),('12664','2013-05-01','09:45:00',2.83),('12664','2013-05-01','09:50:00',2.9),('12664','2013-05-01','09:55:00',2.95),('12664','2013-05-01','10:00:00',3.04),('12664','2013-05-01','10:05:00',3.12),('12664','2013-05-01','10:10:00',3.19),('12664','2013-05-01','10:15:00',3.23),('12664','2013-05-01','10:20:00',3.3),('12664','2013-05-01','10:25:00',3.41),('12664','2013-05-01','10:30:00',3.51),('12664','2013-05-01','10:35:00',3.62),('12664','2013-05-01','10:40:00',3.68),('12664','2013-05-01','10:45:00',3.71),('12664','2013-05-01','10:50:00',3.77),('12664','2013-05-01','10:55:00',3.83),('12664','2013-05-01','11:00:00',3.85),('12664','2013-05-01','11:05:00',3.85),('12664','2013-05-01','11:10:00',3.97),('12664','2013-05-01','11:15:00',3.93),('12664','2013-05-01','11:20:00',3.93),('12664','2013-05-01','11:25:00',4.08),('12664','2013-05-01','11:30:00',3.88),('12664','2013-05-01','11:35:00',3.97),('12664','2013-05-01','11:40:00',3.28),('12664','2013-05-01','11:45:00',4.08),('12664','2013-05-01','11:50:00',4.17),('12664','2013-05-01','11:55:00',4.12),('12664','2013-05-01','12:00:00',4.11),('12664','2013-05-01','12:05:00',4.14),('12664','2013-05-01','12:10:00',4.08),('12664','2013-05-01','12:15:00',4.09),('12664','2013-05-01','12:20:00',4.09),('12664','2013-05-01','12:25:00',4.12),('12664','2013-05-01','12:30:00',4.15),('12664','2013-05-01','12:35:00',4.27),('12664','2013-05-01','12:40:00',4.15),('12664','2013-05-01','12:45:00',2.35),('12664','2013-05-01','12:50:00',1.64),('12664','2013-05-01','12:55:00',1.54),('12664','2013-05-01','13:00:00',1.55),('12664','2013-05-01','13:05:00',1.74),('12664','2013-05-01','13:10:00',2.31),('12664','2013-05-01','13:15:00',3.9),('12664','2013-05-01','13:20:00',4.74),('12664','2013-05-01','13:25:00',3.58),('12664','2013-05-01','13:30:00',4.92),('12664','2013-05-01','13:35:00',4.38),('12664','2013-05-01','13:40:00',4.2),('12664','2013-05-01','13:45:00',4.47),('12664','2013-05-01','13:50:00',4.38),('12664','2013-05-01','13:55:00',4.22),('12664','2013-05-01','14:00:00',4.28),('12664','2013-05-01','14:05:00',4.34),('12664','2013-05-01','14:10:00',4.09),('12664','2013-05-01','14:15:00',4.18),('12664','2013-05-01','14:20:00',3.92),('12664','2013-05-01','14:25:00',4.3),('12664','2013-05-01','14:30:00',4.27),('12664','2013-05-01','14:35:00',4.21),('12664','2013-05-01','14:40:00',3.34),('12664','2013-05-01','14:45:00',3.21),('12664','2013-05-01','14:50:00',2.88),('12664','2013-05-01','14:55:00',3.08),('12664','2013-05-01','15:00:00',2.49),('12664','2013-05-01','15:05:00',3.07),('12664','2013-05-01','15:10:00',3.85),('12664','2013-05-01','15:15:00',2.96),('12664','2013-05-01','15:20:00',3.11),('12664','2013-05-01','15:25:00',2.67),('12664','2013-05-01','15:30:00',2.49),('12664','2013-05-01','15:35:00',2.33),('12664','2013-05-01','15:40:00',2.25),('12664','2013-05-01','15:45:00',2.02),('12664','2013-05-01','15:50:00',1.8),('12664','2013-05-01','15:55:00',1.84),('12664','2013-05-01','16:00:00',2.14),('12664','2013-05-01','16:05:00',2.14),('12664','2013-05-01','16:10:00',2.04),('12664','2013-05-01','16:15:00',1.9),('12664','2013-05-01','16:20:00',1.77),('12664','2013-05-01','16:25:00',1.38),('12664','2013-05-01','16:30:00',1.17),('12664','2013-05-01','16:35:00',1.18),('12664','2013-05-01','16:40:00',1.21),('12664','2013-05-01','16:45:00',1.12),('12664','2014-03-29','07:25:00',1.01),('12664','2014-03-29','07:30:00',1.09),('12664','2014-03-29','07:35:00',1.19),('12664','2014-03-29','07:40:00',1.29),('12664','2014-03-29','07:45:00',1.4),('12664','2014-03-29','07:50:00',1.49),('12664','2014-03-29','07:55:00',1.59),('12664','2014-03-29','08:00:00',1.69),('12664','2014-03-29','08:05:00',1.78),('12664','2014-03-29','08:10:00',1.89),('12664','2014-03-29','08:15:00',1.98),('12664','2014-03-29','08:20:00',2.07),('12664','2014-03-29','08:25:00',2.14),('12664','2014-03-29','08:30:00',2.24),('12664','2014-03-29','08:35:00',2.32),('12664','2014-03-29','08:40:00',2.4),('12664','2014-03-29','08:45:00',2.46),('12664','2014-03-29','08:50:00',2.52),('12664','2014-03-29','08:55:00',2.61),('12664','2014-03-29','09:00:00',2.67),('12664','2014-03-29','09:05:00',2.73),('12664','2014-03-29','09:10:00',2.82),('12664','2014-03-29','09:15:00',2.88),('12664','2014-03-29','09:20:00',2.93),('12664','2014-03-29','09:25:00',2.99),('12664','2014-03-29','09:30:00',3.06),('12664','2014-03-29','09:35:00',3.12),('12664','2014-03-29','09:40:00',3.19),('12664','2014-03-29','09:45:00',3.24),('12664','2014-03-29','09:50:00',3.28),('12664','2014-03-29','09:55:00',3.33),('12664','2014-03-29','10:00:00',3.39),('12664','2014-03-29','10:05:00',3.44),('12664','2014-03-29','10:10:00',3.46),('12664','2014-03-29','10:15:00',3.53),('12664','2014-03-29','10:20:00',3.58),('12664','2014-03-29','10:25:00',3.58),('12664','2014-03-29','10:30:00',3.6),('12664','2014-03-29','10:35:00',3.64),('12664','2014-03-29','10:40:00',3.68),('12664','2014-03-29','10:45:00',3.71),('12664','2014-03-29','10:50:00',3.74),('12664','2014-03-29','10:55:00',3.78),('12664','2014-03-29','11:00:00',3.81),('12664','2014-03-29','11:05:00',3.8),('12664','2014-03-29','11:10:00',3.79),('12664','2014-03-29','11:15:00',3.83),('12664','2014-03-29','11:20:00',3.87),('12664','2014-03-29','11:25:00',3.89),('12664','2014-03-29','11:30:00',3.88),('12664','2014-03-29','11:35:00',3.75),('12664','2014-03-29','11:40:00',3.89),('12664','2014-03-29','11:45:00',3.85),('12664','2014-03-29','11:50:00',3.91),('12664','2014-03-29','11:55:00',3.94),('12664','2014-03-29','12:00:00',3.96),('12664','2014-03-29','12:05:00',3.95),('12664','2014-03-29','12:10:00',3.96),('12664','2014-03-29','12:15:00',3.97),('12664','2014-03-29','12:20:00',3.93),('12664','2014-03-29','12:25:00',3.89),('12664','2014-03-29','12:30:00',3.54),('12664','2014-03-29','12:35:00',3.67),('12664','2014-03-29','12:40:00',3.83),('12664','2014-03-29','12:45:00',3.16),('12664','2014-03-29','12:50:00',3.88),('12664','2014-03-29','12:55:00',2.5),('12664','2014-03-29','13:00:00',3),('12664','2014-03-29','13:05:00',3.92),('12664','2014-03-29','13:10:00',3.89),('12664','2014-03-29','13:15:00',3.83),('12664','2014-03-29','13:20:00',4.07),('12664','2014-03-29','13:25:00',3.98),('12664','2014-03-29','13:30:00',3.67),('12664','2014-03-29','13:35:00',2.78),('12664','2014-03-29','13:40:00',2.62),('12664','2014-03-29','13:45:00',3.76),('12664','2014-03-29','13:50:00',3.11),('12664','2014-03-29','13:55:00',2.08),('12664','2014-03-29','14:00:00',3.41),('12664','2014-03-29','14:05:00',3.45),('12664','2014-03-29','14:10:00',3.47),('12664','2014-03-29','14:15:00',3.43),('12664','2014-03-29','14:20:00',3.34),('12664','2014-03-29','14:25:00',3.3),('12664','2014-03-29','14:30:00',3.22),('12664','2014-03-29','14:35:00',3.19),('12664','2014-03-29','14:40:00',3.15),('12664','2014-03-29','14:45:00',3.05),('12664','2014-03-29','14:50:00',3),('12664','2014-03-29','14:55:00',2.9),('12664','2014-03-29','15:00:00',2.84),('12664','2014-03-29','15:05:00',2.79),('12664','2014-03-29','15:10:00',2.68),('12664','2014-03-29','15:15:00',2.62),('12664','2014-03-29','15:20:00',2.55),('12664','2014-03-29','15:25:00',2.49),('12664','2014-03-29','15:30:00',2.39),('12664','2014-03-29','15:35:00',2.31),('12664','2014-03-29','15:40:00',2.22),('12664','2014-03-29','15:45:00',2.15),('12664','2014-03-29','15:50:00',2.06),('12664','2014-03-29','15:55:00',1.99),('12664','2014-03-29','16:00:00',1.92),('12664','2014-03-29','16:05:00',1.8),('12664','2014-03-29','16:10:00',1.71),('12664','2014-03-29','16:15:00',1.53),('12664','2014-03-29','16:20:00',1.5),('12664','2014-03-29','16:25:00',1.45),('12664','2014-03-29','16:30:00',1.35),('12664','2014-03-29','16:35:00',1.1),('12664','2014-03-29','16:50:00',1),('12664','2013-04-30','08:40:00',1.07),('12664','2013-04-30','08:45:00',1.12),('12664','2013-04-30','08:50:00',1.69),('12664','2013-04-30','08:55:00',2.41),('12664','2013-04-30','09:00:00',2.61),('12664','2013-04-30','09:05:00',1.91),('12664','2013-04-30','09:10:00',1.82),('12664','2013-04-30','09:15:00',2.83),('12664','2013-04-30','09:20:00',2.64),('12664','2013-04-30','09:25:00',1.99),('12664','2013-04-30','09:30:00',1.73),('12664','2013-04-30','09:35:00',2.81),('12664','2013-04-30','09:40:00',2.35),('12664','2013-04-30','09:45:00',2.52),('12664','2013-04-30','09:50:00',2.94),('12664','2013-04-30','09:55:00',2.87),('12664','2013-04-30','10:00:00',2.94),('12664','2013-04-30','10:05:00',1.91),('12664','2013-04-30','10:10:00',1.91),('12664','2013-04-30','10:15:00',2.2),('12664','2013-04-30','10:20:00',2.7),('12664','2013-04-30','10:25:00',2.41),('12664','2013-04-30','10:30:00',1.87),('12664','2013-04-30','10:35:00',1.54),('12664','2013-04-30','10:40:00',1.69),('12664','2013-04-30','10:45:00',2.16),('12664','2013-04-30','10:50:00',1.92),('12664','2013-04-30','10:55:00',2.04),('12664','2013-04-30','11:00:00',2.58),('12664','2013-04-30','11:05:00',2),('12664','2013-04-30','11:10:00',2.35),('12664','2013-04-30','11:15:00',2.16),('12664','2013-04-30','11:20:00',2.36),('12664','2013-04-30','11:25:00',2.24),('12664','2013-04-30','11:30:00',2.16),('12664','2013-04-30','11:35:00',2.46),('12664','2013-04-30','11:40:00',2.2),('12664','2013-04-30','11:45:00',1.6),('12664','2013-04-30','11:50:00',1.47),('12664','2013-04-30','11:55:00',1.65),('12664','2013-04-30','12:00:00',2.52),('12664','2013-04-30','12:05:00',1.98),('12664','2013-04-30','12:10:00',2.07),('12664','2013-04-30','12:15:00',2.87),('12664','2013-04-30','12:20:00',2.47),('12664','2013-04-30','12:25:00',1.64),('12664','2013-04-30','12:30:00',1.68),('12664','2013-04-30','12:35:00',3.31),('12664','2013-04-30','12:40:00',4.95),('12664','2013-04-30','12:45:00',4.51),('12664','2013-04-30','12:50:00',4.16),('12664','2013-04-30','12:55:00',3.94),('12664','2013-04-30','13:00:00',4.19),('12664','2013-04-30','13:05:00',4.37),('12664','2013-04-30','13:10:00',4.26),('12664','2013-04-30','13:15:00',4.22),('12664','2013-04-30','13:20:00',4.18),('12664','2013-04-30','13:25:00',4.07),('12664','2013-04-30','13:30:00',4.16),('12664','2013-04-30','13:35:00',4.12),('12664','2013-04-30','13:40:00',4.08),('12664','2013-04-30','13:45:00',4.04),('12664','2013-04-30','13:50:00',4.01),('12664','2013-04-30','13:55:00',3.99),('12664','2013-04-30','14:00:00',3.99),('12664','2013-04-30','14:05:00',3.96),('12664','2013-04-30','14:10:00',3.92),('12664','2013-04-30','14:15:00',3.9),('12664','2013-04-30','14:20:00',3.86),('12664','2013-04-30','14:25:00',3.81),('12664','2013-04-30','14:30:00',3.76),('12664','2013-04-30','14:35:00',3.76),('12664','2013-04-30','14:40:00',3.72),('12664','2013-04-30','14:45:00',3.69),('12664','2013-04-30','14:50:00',3.64),('12664','2013-04-30','14:55:00',3.61),('12664','2013-04-30','15:00:00',3.56),('12664','2013-04-30','15:05:00',3.59),('12664','2013-04-30','15:10:00',3.58),('12664','2013-04-30','15:15:00',3.54),('12664','2013-04-30','15:20:00',3.48),('12664','2013-04-30','15:25:00',3.43),('12664','2013-04-30','15:30:00',3.38),('12664','2013-04-30','15:35:00',3.32),('12664','2013-04-30','15:40:00',3.25),('12664','2013-04-30','15:45:00',3.21),('12664','2013-04-30','15:50:00',3.16),('12664','2013-04-30','15:55:00',3.1),('12664','2013-04-30','16:00:00',3.04),('12664','2013-04-30','16:05:00',2.98),('12664','2013-04-30','16:10:00',2.91),('12664','2013-04-30','16:15:00',2.82),('12664','2013-04-30','16:20:00',2.74),('12664','2013-04-30','16:25:00',2.69),('12664','2013-04-30','16:30:00',2.6),('12664','2013-04-30','16:35:00',2.45),('12664','2013-04-30','16:40:00',2.05),('12664','2013-04-30','16:45:00',1.26),('12664','2013-04-30','16:50:00',1.46),('12664','2013-04-30','16:55:00',1.67),('12664','2013-04-30','17:00:00',1.62),('12664','2013-04-30','17:05:00',1.15),('12664','2013-04-30','17:15:00',1.05),('12664','2013-04-30','17:20:00',1.27),('12664','2013-04-30','17:25:00',1.54),('12664','2013-04-30','17:30:00',1.58),('12664','2013-04-30','17:35:00',1.52),('12664','2013-04-30','17:40:00',1.44),('12664','2013-04-30','17:45:00',1.35),('12664','2013-04-30','17:50:00',1.26),('12664','2013-04-30','17:55:00',1.18),('12664','2013-04-30','18:00:00',1.09),('12664','2013-04-30','18:05:00',1.01),('12664','2013-04-29','07:50:00',1.05),('12664','2013-04-29','07:55:00',1.19),('12664','2013-04-29','08:00:00',1.24),('12664','2013-04-29','08:05:00',1.26),('12664','2013-04-29','08:10:00',1.17),('12664','2013-04-29','08:15:00',1.4),('12664','2013-04-29','08:20:00',1.64),('12664','2013-04-29','08:25:00',1.84),('12664','2013-04-29','08:30:00',2.1),('12664','2013-04-29','08:35:00',2.23),('12664','2013-04-29','08:40:00',1.92),('12664','2013-04-29','08:45:00',2.08),('12664','2013-04-29','08:50:00',2.07),('12664','2013-04-29','08:55:00',2.13),('12664','2013-04-29','09:00:00',2.28),('12664','2013-04-29','09:05:00',2.45),('12664','2013-04-29','09:10:00',1.99),('12664','2013-04-29','09:15:00',2.13),('12664','2013-04-29','09:20:00',2.48),('12664','2013-04-29','09:25:00',2.54),('12664','2013-04-29','09:30:00',2.53),('12664','2013-04-29','09:35:00',2.6),('12664','2013-04-29','09:40:00',2.6),('12664','2013-04-29','09:45:00',2.75),('12664','2013-04-29','09:50:00',2.55),('12664','2013-04-29','09:55:00',2.76),('12664','2013-04-29','10:00:00',2.9),('12664','2013-04-29','10:05:00',2.99),('12664','2013-04-29','10:10:00',2.59),('12664','2013-04-29','10:15:00',2.82),('12664','2013-04-29','10:20:00',3.49),('12664','2013-04-29','10:25:00',3.7),('12664','2013-04-29','10:30:00',3.59),('12664','2013-04-29','10:35:00',2.89),('12664','2013-04-29','10:40:00',3.02),('12664','2013-04-29','10:45:00',3.34),('12664','2013-04-29','10:50:00',3.46),('12664','2013-04-29','10:55:00',3.31),('12664','2013-04-29','11:00:00',3.2),('12664','2013-04-29','11:05:00',3.67),('12664','2013-04-29','11:10:00',3.68),('12664','2013-04-29','11:15:00',3.69),('12664','2013-04-29','11:20:00',4.1),('12664','2013-04-29','11:25:00',3.38),('12664','2013-04-29','11:30:00',3.77),('12664','2013-04-29','11:35:00',3.45),('12664','2013-04-29','11:40:00',3.91),('12664','2013-04-29','11:45:00',3.98),('12664','2013-04-29','11:50:00',3.94),('12664','2013-04-29','11:55:00',4.16),('12664','2013-04-29','12:00:00',4.12),('12664','2013-04-29','12:05:00',4.11),('12664','2013-04-29','12:10:00',4.13),('12664','2013-04-29','12:15:00',4.1),('12664','2013-04-29','12:20:00',4.16),('12664','2013-04-29','12:25:00',4.26),('12664','2013-04-29','12:30:00',4.26),('12664','2013-04-29','12:35:00',4.22),('12664','2013-04-29','12:40:00',4.17),('12664','2013-04-29','12:45:00',4.1),('12664','2013-04-29','12:50:00',3.87),('12664','2013-04-29','12:55:00',3.95),('12664','2013-04-29','13:00:00',4.02),('12664','2013-04-29','13:05:00',3.92),('12664','2013-04-29','13:10:00',3.93),('12664','2013-04-29','13:15:00',3.87),('12664','2013-04-29','13:20:00',4.26),('12664','2013-04-29','13:25:00',4.22),('12664','2013-04-29','13:30:00',4.2),('12664','2013-04-29','13:35:00',4.29),('12664','2013-04-29','13:40:00',4.26),('12664','2013-04-29','13:45:00',4.07),('12664','2013-04-29','13:50:00',4.05),('12664','2013-04-29','13:55:00',4.21),('12664','2013-04-29','14:00:00',4.16),('12664','2013-04-29','14:05:00',4.18),('12664','2013-04-29','14:10:00',4.12),('12664','2013-04-29','14:15:00',4.12),('12664','2013-04-29','14:20:00',4.05),('12664','2013-04-29','14:25:00',3.91),('12664','2013-04-29','14:30:00',3.66),('12664','2013-04-29','14:35:00',3.49),('12664','2013-04-29','14:40:00',3.52),('12664','2013-04-29','14:45:00',3.56),('12664','2013-04-29','14:50:00',3.43),('12664','2013-04-29','14:55:00',3.44),('12664','2013-04-29','15:00:00',3.06),('12664','2013-04-29','15:05:00',2.95),('12664','2013-04-29','15:10:00',3.54),('12664','2013-04-29','15:15:00',3.72),('12664','2013-04-29','15:20:00',3.7),('12664','2013-04-29','15:25:00',3.37),('12664','2013-04-29','15:30:00',3.03),('12664','2013-04-29','15:35:00',2.92),('12664','2013-04-29','15:40:00',2.8),('12664','2013-04-29','15:45:00',2.71),('12664','2013-04-29','15:50:00',2.87),('12664','2013-04-29','15:55:00',3.24),('12664','2013-04-29','16:00:00',3.13),('12664','2013-04-29','16:05:00',3.29),('12664','2013-04-29','16:10:00',3.32),('12664','2013-04-29','16:15:00',3.03),('12664','2013-04-29','16:20:00',2.56),('12664','2013-04-29','16:25:00',2.82),('12664','2013-04-29','16:30:00',2.75),('12664','2013-04-29','16:35:00',2.94),('12664','2013-04-29','16:40:00',2.79),('12664','2013-04-29','16:45:00',2.92),('12664','2013-04-29','16:50:00',2.91),('12664','2013-04-29','16:55:00',2.76),('12664','2013-04-29','17:00:00',2.63),('12664','2013-04-29','17:05:00',2.56),('12664','2013-04-29','17:10:00',2.22),('12664','2013-04-29','17:15:00',2.01),('12664','2013-04-29','17:20:00',2.07),('12664','2013-04-29','17:25:00',1.92),('12664','2013-04-29','17:30:00',1.91),('12664','2013-04-29','17:35:00',1.85),('12664','2013-04-29','17:40:00',1.4),('12664','2013-04-29','17:45:00',1.21),('12664','2013-04-29','17:50:00',1.53),('12664','2013-04-29','17:55:00',1.7),('12664','2013-04-29','18:00:00',1.56),('12664','2013-04-29','18:05:00',1.62),('12664','2013-04-29','18:10:00',1.43),('12664','2013-04-29','18:15:00',1.34),('12664','2013-04-29','18:20:00',1.21),('12664','2013-04-29','18:25:00',1.11),('12664','2013-04-28','07:50:00',1.06),('12664','2013-04-28','07:55:00',1.16),('12664','2013-04-28','08:00:00',1.26),('12664','2013-04-28','08:05:00',1.38),('12664','2013-04-28','08:10:00',1.49),('12664','2013-04-28','08:15:00',1.6),('12664','2013-04-28','08:20:00',1.72),('12664','2013-04-28','08:25:00',1.83),('12664','2013-04-28','08:30:00',1.92),('12664','2013-04-28','08:35:00',2.01),('12664','2013-04-28','08:40:00',2.07),('12664','2013-04-28','08:45:00',2.2),('12664','2013-04-28','08:50:00',2.29),('12664','2013-04-28','08:55:00',2.38),('12664','2013-04-28','09:00:00',2.48),('12664','2013-04-28','09:05:00',2.55),('12664','2013-04-28','09:10:00',2.63),('12664','2013-04-28','09:15:00',2.73),('12664','2013-04-28','09:20:00',2.81),('12664','2013-04-28','09:25:00',2.9),('12664','2013-04-28','09:30:00',2.98),('12664','2013-04-28','09:35:00',3.05),('12664','2013-04-28','09:40:00',3.13),('12664','2013-04-28','09:45:00',3.2),('12664','2013-04-28','09:50:00',3.27),('12664','2013-04-28','09:55:00',3.35),('12664','2013-04-28','10:00:00',3.41),('12664','2013-04-28','10:05:00',3.46),('12664','2013-04-28','10:10:00',3.52),('12664','2013-04-28','10:15:00',3.48),('12664','2013-04-28','10:20:00',3.64),('12664','2013-04-28','10:25:00',3.7),('12664','2013-04-28','10:30:00',3.47),('12664','2013-04-28','10:35:00',3.7),('12664','2013-04-28','10:40:00',3.44),('12664','2013-04-28','10:45:00',3.67),('12664','2013-04-28','10:50:00',3.72),('12664','2013-04-28','10:55:00',3.91),('12664','2013-04-28','11:00:00',3.97),('12664','2013-04-28','11:05:00',3.82),('12664','2013-04-28','11:10:00',3.98),('12664','2013-04-28','11:15:00',4.12),('12664','2013-04-28','11:20:00',4.1),('12664','2013-04-28','11:25:00',4.22),('12664','2013-04-28','11:30:00',4.26),('12664','2013-04-28','11:35:00',4.13),('12664','2013-04-28','11:40:00',4),('12664','2013-04-28','11:45:00',4.14),('12664','2013-04-28','11:50:00',3.94),('12664','2013-04-28','11:55:00',3.56),('12664','2013-04-28','12:00:00',3.41),('12664','2013-04-28','12:05:00',3.55),('12664','2013-04-28','12:10:00',3.97),('12664','2013-04-28','12:15:00',3.9),('12664','2013-04-28','12:20:00',4.15),('12664','2013-04-28','12:25:00',4.15),('12664','2013-04-28','12:30:00',4.01),('12664','2013-04-28','12:35:00',3.8),('12664','2013-04-28','12:40:00',2.99),('12664','2013-04-28','12:45:00',3.76),('12664','2013-04-28','12:50:00',4.33),('12664','2013-04-28','12:55:00',4.26),('12664','2013-04-28','13:00:00',4.4),('12664','2013-04-28','13:05:00',4.52),('12664','2013-04-28','13:10:00',4.11),('12664','2013-04-28','13:15:00',4.01),('12664','2013-04-28','13:20:00',4.24),('12664','2013-04-28','13:25:00',3.92),('12664','2013-04-28','13:30:00',4.08),('12664','2013-04-28','13:35:00',3.31),('12664','2013-04-28','13:40:00',4.35),('12664','2013-04-28','13:45:00',4.22),('12664','2013-04-28','13:50:00',4.38),('12664','2013-04-28','13:55:00',4.31),('12664','2013-04-28','14:00:00',4.26),('12664','2013-04-28','14:05:00',4.12),('12664','2013-04-28','14:10:00',3.96),('12664','2013-04-28','14:15:00',4.24),('12664','2013-04-28','14:20:00',4.15),('12664','2013-04-28','14:25:00',4.1),('12664','2013-04-28','14:30:00',4.12),('12664','2013-04-28','14:35:00',4.08),('12664','2013-04-28','14:40:00',4.02),('12664','2013-04-28','14:45:00',3.98),('12664','2013-04-28','14:50:00',3.93),('12664','2013-04-28','14:55:00',3.46),('12664','2013-04-28','15:00:00',3.8),('12664','2013-04-28','15:05:00',3.8),('12664','2013-04-28','15:10:00',3.79),('12664','2013-04-28','15:15:00',3.75),('12664','2013-04-28','15:20:00',3.5),('12664','2013-04-28','15:25:00',3.63),('12664','2013-04-28','15:30:00',3.59),('12664','2013-04-28','15:35:00',3.52),('12664','2013-04-28','15:40:00',3.44),('12664','2013-04-28','15:45:00',3.38),('12664','2013-04-28','15:50:00',3.34),('12664','2013-04-28','15:55:00',3.28),('12664','2013-04-28','16:00:00',3.23),('12664','2013-04-28','16:05:00',3.14),('12664','2013-04-28','16:10:00',3.08),('12664','2013-04-28','16:15:00',2.99),('12664','2013-04-28','16:20:00',2.91),('12664','2013-04-28','16:25:00',2.84),('12664','2013-04-28','16:30:00',2.81),('12664','2013-04-28','16:35:00',2.78),('12664','2013-04-28','16:40:00',2.71),('12664','2013-04-28','16:45:00',2.64),('12664','2013-04-28','16:50:00',2.58),('12664','2013-04-28','16:55:00',2.49),('12664','2013-04-28','17:00:00',2.27),('12664','2013-04-28','17:05:00',2.15),('12664','2013-04-28','17:10:00',2.18),('12664','2013-04-28','17:15:00',2.04),('12664','2013-04-28','17:20:00',2.03),('12664','2013-04-28','17:25:00',2),('12664','2013-04-28','17:30:00',1.62),('12664','2013-04-28','17:35:00',1.67),('12664','2013-04-28','17:40:00',1.62),('12664','2013-04-28','17:45:00',1.59),('12664','2013-04-28','17:50:00',1.48),('12664','2013-04-28','17:55:00',1.27),('12664','2013-04-28','18:00:00',1.23),('12664','2013-04-28','18:05:00',1.16),('12664','2013-04-28','18:15:00',1.08),('12664','2013-04-28','18:20:00',1.04),('12664','2013-04-27','12:40:00',1.03),('12664','2013-04-27','12:45:00',1.09),('12664','2013-04-27','12:50:00',1.25),('12664','2013-04-27','12:55:00',1.34),('12664','2013-04-27','13:00:00',1.25),('12664','2013-04-27','13:05:00',1.22),('12664','2013-04-27','13:10:00',1.26),('12664','2013-04-27','13:15:00',2.05),('12664','2013-04-27','13:20:00',1.92),('12664','2013-04-27','13:25:00',1.24),('12664','2013-04-27','14:35:00',1.01),('12664','2013-04-27','14:40:00',1.57),('12664','2013-04-27','16:55:00',1.28),('12664','2013-04-27','17:00:00',1.55),('12664','2013-04-27','17:05:00',1.2),('12664','2013-04-27','17:10:00',1.34),('12664','2013-04-27','17:40:00',1.84),('12664','2013-04-27','17:45:00',1.3),('12664','2013-04-26','08:05:00',1.09),('12664','2013-04-26','08:10:00',1.23),('12664','2013-04-26','08:15:00',1.36),('12664','2013-04-26','08:20:00',1.43),('12664','2013-04-26','08:25:00',1.48),('12664','2013-04-26','08:30:00',1.59),('12664','2013-04-26','08:35:00',1.57),('12664','2013-04-26','08:40:00',1.67),('12664','2013-04-26','08:45:00',1.96),('12664','2013-04-26','08:50:00',2.23),('12664','2013-04-26','08:55:00',2.4),('12664','2013-04-26','09:00:00',2.45),('12664','2013-04-26','09:05:00',1.85),('12664','2013-04-26','09:10:00',1.58),('12664','2013-04-26','09:15:00',1.6),('12664','2013-04-26','09:20:00',2),('12664','2013-04-26','09:25:00',2.12),('12664','2013-04-26','09:30:00',2.74),('12664','2013-04-26','09:35:00',2.84),('12664','2013-04-26','09:40:00',2.86),('12664','2013-04-26','09:45:00',2.52),('12664','2013-04-26','09:50:00',2.53),('12664','2013-04-26','09:55:00',2.31),('12664','2013-04-26','10:00:00',2.85),('12664','2013-04-26','10:05:00',3.32),('12664','2013-04-26','10:10:00',3.43),('12664','2013-04-26','10:15:00',3.43),('12664','2013-04-26','10:20:00',3.44),('12664','2013-04-26','10:25:00',3.59),('12664','2013-04-26','10:30:00',3.61),('12664','2013-04-26','10:35:00',3.74),('12664','2013-04-26','10:40:00',3.73),('12664','2013-04-26','10:45:00',3.87),('12664','2013-04-26','10:50:00',3.95),('12664','2013-04-26','10:55:00',3.95),('12664','2013-04-26','11:00:00',3.95),('12664','2013-04-26','11:05:00',3.98),('12664','2013-04-26','11:10:00',4.03),('12664','2013-04-26','11:15:00',4.02),('12664','2013-04-26','11:20:00',3.32),('12664','2013-04-26','11:25:00',3.34),('12664','2013-04-26','11:30:00',3.15),('12664','2013-04-26','11:35:00',2.79),('12664','2013-04-26','11:40:00',3.42),('12664','2013-04-26','11:45:00',3.63),('12664','2013-04-26','11:50:00',3.02),('12664','2013-04-26','11:55:00',2.9),('12664','2013-04-26','12:00:00',2.83),('12664','2013-04-26','12:05:00',3.13),('12664','2013-04-26','12:10:00',2.51),('12664','2013-04-26','12:15:00',3.38),('12664','2013-04-26','12:20:00',3.32),('12664','2013-04-26','12:25:00',2.23),('12664','2013-04-26','12:30:00',2.09),('12664','2013-04-26','12:35:00',2.53),('12664','2013-04-26','12:40:00',3.23),('12664','2013-04-26','12:45:00',2.61),('12664','2013-04-26','12:50:00',2.03),('12664','2013-04-26','12:55:00',1.51),('12664','2013-04-26','13:00:00',1.4),('12664','2013-04-26','13:05:00',1.55),('12664','2013-04-26','13:10:00',2.26),('12664','2013-04-26','13:15:00',4.94),('12664','2013-04-26','13:20:00',4.27),('12664','2013-04-26','13:25:00',4.34),('12664','2013-04-26','13:30:00',3.88),('12664','2013-04-26','13:35:00',2.84),('12664','2013-04-26','13:40:00',2.99),('12664','2013-04-26','13:45:00',3.18),('12664','2013-04-26','13:50:00',4.09),('12664','2013-04-26','13:55:00',3.78),('12664','2013-04-26','14:00:00',2.84),('12664','2013-04-26','14:05:00',3.63),('12664','2013-04-26','14:10:00',2.57),('12664','2013-04-26','14:15:00',3.31),('12664','2013-04-26','14:20:00',4.11),('12664','2013-04-26','14:25:00',3.88),('12664','2013-04-26','14:30:00',2.54),('12664','2013-04-26','14:35:00',2.14),('12664','2013-04-26','14:40:00',2.15),('12664','2013-04-26','14:45:00',2.07),('12664','2013-04-26','14:50:00',1.66),('12664','2013-04-26','14:55:00',1.48),('12664','2013-04-26','15:00:00',1.8),('12664','2013-04-26','15:05:00',1.71),('12664','2013-04-26','15:10:00',2.61),('12664','2013-04-26','15:15:00',3.71),('12664','2013-04-26','15:20:00',2),('12664','2013-04-26','15:25:00',2.64),('12664','2013-04-26','15:30:00',4.12),('12664','2013-04-26','15:35:00',3.37),('12664','2013-04-26','15:40:00',4.19),('12664','2013-04-26','15:45:00',2.14),('12664','2013-04-26','15:50:00',1.34),('12664','2013-04-25','08:10:00',1.2),('12664','2013-04-25','08:25:00',1.01),('12664','2013-04-25','08:30:00',1.08),('12664','2013-04-25','08:35:00',1.4),('12664','2013-04-25','08:40:00',1.73),('12664','2013-04-25','08:45:00',2.06),('12664','2013-04-25','08:50:00',1.42),('12664','2013-04-25','08:55:00',1.27),('12664','2013-04-25','09:00:00',1.36),('12664','2013-04-25','09:05:00',1.41),('12664','2013-04-25','09:10:00',1.44),('12664','2013-04-25','09:15:00',1.55),('12664','2013-04-25','09:20:00',1.64),('12664','2013-04-25','09:25:00',1.75),('12664','2013-04-25','09:30:00',2.34),('12664','2013-04-25','09:35:00',2.68),('12664','2013-04-25','09:40:00',2.95),('12664','2013-04-25','09:45:00',3.13),('12664','2013-04-25','09:50:00',3.06),('12664','2013-04-25','09:55:00',2.6),('12664','2013-04-25','10:00:00',2.72),('12664','2013-04-25','10:05:00',3.12),('12664','2013-04-25','10:10:00',3.42),('12664','2013-04-25','10:15:00',3.46),('12664','2013-04-25','10:20:00',3.57),('12664','2013-04-25','10:25:00',3.56),('12664','2013-04-25','10:30:00',3.58),('12664','2013-04-25','10:35:00',3.66),('12664','2013-04-25','10:40:00',3.68),('12664','2013-04-25','10:45:00',3.7),('12664','2013-04-25','10:50:00',3.74),('12664','2013-04-25','10:55:00',3.77),('12664','2013-04-25','11:00:00',3.77),('12664','2013-04-25','11:05:00',3.79),('12664','2013-04-25','11:10:00',3.78),('12664','2013-04-25','11:15:00',3.92),('12664','2013-04-25','11:20:00',3.94),('12664','2013-04-25','11:25:00',3.94),('12664','2013-04-25','11:30:00',4.07),('12664','2013-04-25','11:35:00',4.1),('12664','2013-04-25','11:40:00',4.14),('12664','2013-04-25','11:45:00',4.19),('12664','2013-04-25','11:50:00',4.24),('12664','2013-04-25','11:55:00',4.26),('12664','2013-04-25','12:00:00',4.24),('12664','2013-04-25','12:05:00',4.25),('12664','2013-04-25','12:10:00',4.35),('12664','2013-04-25','12:15:00',4.35),('12664','2013-04-25','12:20:00',4.19),('12664','2013-04-25','12:25:00',4.26),('12664','2013-04-25','12:30:00',4.3),('12664','2013-04-25','12:35:00',4.32),('12664','2013-04-25','12:40:00',4.31),('12664','2013-04-25','12:45:00',4.32),('12664','2013-04-25','12:50:00',4.34),('12664','2013-04-25','12:55:00',4.34),('12664','2013-04-25','13:00:00',3.74),('12664','2013-04-25','13:05:00',4.08),('12664','2013-04-25','13:10:00',4.37),('12664','2013-04-25','13:15:00',3.99),('12664','2013-04-25','13:20:00',3.83),('12664','2013-04-25','13:25:00',3.04),('12664','2013-04-25','13:30:00',2.58),('12664','2013-04-25','13:35:00',2.3),('12664','2013-04-25','13:40:00',2.23),('12664','2013-04-25','13:45:00',2.14),('12664','2013-04-25','13:50:00',2.03),('12664','2013-04-25','13:55:00',2.23),('12664','2013-04-25','14:00:00',2.25),('12664','2013-04-25','14:05:00',2.43),('12664','2013-04-25','14:10:00',2.36),('12664','2013-04-25','14:15:00',2.63),('12664','2013-04-25','14:20:00',3.16),('12664','2013-04-25','14:25:00',3.18),('12664','2013-04-25','14:30:00',3.73),('12664','2013-04-25','14:35:00',4.06),('12664','2013-04-25','14:40:00',3.84),('12664','2013-04-25','14:45:00',3.97),('12664','2013-04-25','14:50:00',3.55),('12664','2013-04-25','14:55:00',3.12),('12664','2013-04-25','15:00:00',3.68),('12664','2013-04-25','15:05:00',3.33),('12664','2013-04-25','15:10:00',3.28),('12664','2013-04-25','15:15:00',2.63),('12664','2013-04-25','15:20:00',3.42),('12664','2013-04-25','15:25:00',3.43),('12664','2013-04-25','15:30:00',3.18),('12664','2013-04-25','15:35:00',2.78),('12664','2013-04-25','15:40:00',2.64),('12664','2013-04-25','15:45:00',2.67),('12664','2013-04-25','15:50:00',2.19),('12664','2013-04-25','15:55:00',2.38),('12664','2013-04-25','16:00:00',2.44),('12664','2013-04-25','16:05:00',2.54),('12664','2013-04-25','16:10:00',2.81),('12664','2013-04-25','16:15:00',2.88),('12664','2013-04-25','16:20:00',2.72),('12664','2013-04-25','16:25:00',2.28),('12664','2013-04-25','16:30:00',2.25),('12664','2013-04-25','16:35:00',1.68),('12664','2013-04-25','16:40:00',1.88),('12664','2013-04-25','16:45:00',2.06),('12664','2013-04-25','16:50:00',2.07),('12664','2013-04-25','16:55:00',2.04),('12664','2013-04-25','17:00:00',1.96),('12664','2013-04-25','17:05:00',2.25),('12664','2013-04-25','17:10:00',1.95),('12664','2013-04-25','17:15:00',2.12),('12664','2013-04-25','17:20:00',1.98),('12664','2013-04-25','17:25:00',1.66),('12664','2013-04-25','17:30:00',1.57),('12664','2013-04-25','17:35:00',1.26),('12664','2013-04-25','17:40:00',1.3),('12664','2013-04-25','17:45:00',1.3),('12664','2013-04-25','17:50:00',1.2),('12664','2013-04-25','18:05:00',1.05),('12664','2013-04-24','07:55:00',1.05),('12664','2013-04-24','08:00:00',1.1),('12664','2013-04-24','08:05:00',1.15),('12664','2013-04-24','08:10:00',1.35),('12664','2013-04-24','08:15:00',1.52),('12664','2013-04-24','08:20:00',1.7),('12664','2013-04-24','08:25:00',1.75),('12664','2013-04-24','08:30:00',1.69),('12664','2013-04-24','08:35:00',1.68),('12664','2013-04-24','08:40:00',1.77),('12664','2013-04-24','08:45:00',1.94),('12664','2013-04-24','08:50:00',2.1),('12664','2013-04-24','08:55:00',2.29),('12664','2013-04-24','09:00:00',2.48),('12664','2013-04-24','09:05:00',2.69),('12664','2013-04-24','09:10:00',2.99),('12664','2013-04-24','09:15:00',2.29),('12664','2013-04-24','09:20:00',1.87),('12664','2013-04-24','09:25:00',1.77),('12664','2013-04-24','09:30:00',2.2),('12664','2013-04-24','09:35:00',2.15),('12664','2013-04-24','09:40:00',2.15),('12664','2013-04-24','09:45:00',2.54),('12664','2013-04-24','09:50:00',2.7),('12664','2013-04-24','09:55:00',2.88),('12664','2013-04-24','10:00:00',3.55),('12664','2013-04-24','10:05:00',3.69),('12664','2013-04-24','10:10:00',3.49),('12664','2013-04-24','10:15:00',3.33),('12664','2013-04-24','10:20:00',3.75),('12664','2013-04-24','10:25:00',3.72),('12664','2013-04-24','10:30:00',3.69),('12664','2013-04-24','10:35:00',3.56),('12664','2013-04-24','10:40:00',3.55),('12664','2013-04-24','10:45:00',3.43),('12664','2013-04-24','10:50:00',3.9),('12664','2013-04-24','10:55:00',3.95),('12664','2013-04-24','11:00:00',3.9),('12664','2013-04-24','11:05:00',4.04),('12664','2013-04-24','11:10:00',4.29),('12664','2013-04-24','11:15:00',4.35),('12664','2013-04-24','11:20:00',4.36),('12664','2013-04-24','11:25:00',4.2),('12664','2013-04-24','11:30:00',3.38),('12664','2013-04-24','11:35:00',3.56),('12664','2013-04-24','11:40:00',4.37),('12664','2013-04-24','11:45:00',4.28),('12664','2013-04-24','11:50:00',4.12),('12664','2013-04-24','11:55:00',3.25),('12664','2013-04-24','12:00:00',2.96),('12664','2013-04-24','12:05:00',3.5),('12664','2013-04-24','12:10:00',2.67),('12664','2013-04-24','12:15:00',3.88),('12664','2013-04-24','12:20:00',4.13),('12664','2013-04-24','12:25:00',3.22),('12664','2013-04-24','12:30:00',3.44),('12664','2013-04-24','12:35:00',3.22),('12664','2013-04-24','12:40:00',3.95),('12664','2013-04-24','12:45:00',3.67),('12664','2013-04-24','12:50:00',4.27),('12664','2013-04-24','12:55:00',4.34),('12664','2013-04-24','13:00:00',4.47),('12664','2013-04-24','13:05:00',4.89),('12664','2013-04-24','13:10:00',4.69),('12664','2013-04-24','13:15:00',3.91),('12664','2013-04-24','13:20:00',4),('12664','2013-04-24','13:25:00',3.92),('12664','2013-04-24','13:30:00',3.86),('12664','2013-04-24','13:35:00',4.01),('12664','2013-04-24','13:40:00',3.18),('12664','2013-04-24','13:45:00',2.93),('12664','2013-04-24','13:50:00',3.12),('12664','2013-04-24','13:55:00',3.5),('12664','2013-04-24','14:00:00',3.15),('12664','2013-04-24','14:05:00',3.08),('12664','2013-04-24','14:10:00',3.23),('12664','2013-04-24','14:15:00',2.73),('12664','2013-04-24','14:20:00',3.5),('12664','2013-04-24','14:25:00',3.74),('12664','2013-04-24','14:30:00',2.78),('12664','2013-04-24','14:35:00',3.07),('12664','2013-04-24','14:40:00',3.46),('12664','2013-04-24','14:45:00',2.59),('12664','2013-04-24','14:50:00',2.38),('12664','2013-04-24','14:55:00',2.55),('12664','2013-04-24','15:00:00',2.53),('12664','2013-04-24','15:05:00',2.3),('12664','2013-04-24','15:10:00',2.39),('12664','2013-04-24','15:15:00',2.18),('12664','2013-04-24','15:20:00',2.17),('12664','2013-04-24','15:25:00',2.12),('12664','2013-04-24','15:30:00',1.91),('12664','2013-04-24','15:35:00',2.05),('12664','2013-04-24','15:40:00',2.15),('12664','2013-04-24','15:45:00',1.93),('12664','2013-04-24','15:50:00',2),('12664','2013-04-24','15:55:00',2.26),('12664','2013-04-24','16:00:00',2.22),('12664','2013-04-24','16:05:00',2.21),('12664','2013-04-24','16:10:00',2.43),('12664','2013-04-24','16:15:00',3.2),('12664','2013-04-24','16:20:00',2.65),('12664','2013-04-24','16:25:00',2.04),('12664','2013-04-24','16:30:00',2.24),('12664','2013-04-24','16:35:00',2.07),('12664','2013-04-24','16:40:00',2.35),('12664','2013-04-24','16:45:00',2.49),('12664','2013-04-24','16:50:00',2.54),('12664','2013-04-24','16:55:00',2.67),('12664','2013-04-24','17:00:00',2.63),('12664','2013-04-24','17:05:00',2.55),('12664','2013-04-24','17:10:00',2.27),('12664','2013-04-24','17:15:00',2.17),('12664','2013-04-24','17:20:00',1.68),('12664','2013-04-24','17:35:00',1.1),('12664','2013-04-24','17:40:00',1.37),('12664','2013-04-24','17:45:00',1.47),('12664','2013-04-24','17:50:00',1.4),('12664','2013-04-24','17:55:00',1.17),('12664','2013-04-24','18:00:00',1.33),('12664','2013-04-23','07:50:00',1.07),('12664','2013-04-23','07:55:00',1.19),('12664','2013-04-23','08:00:00',1.3),('12664','2013-04-23','08:05:00',1.42),('12664','2013-04-23','08:10:00',1.53),('12664','2013-04-23','08:15:00',1.64),('12664','2013-04-23','08:20:00',1.75),('12664','2013-04-23','08:25:00',1.86),('12664','2013-04-23','08:30:00',1.96),('12664','2013-04-23','08:35:00',2.07),('12664','2013-04-23','08:40:00',2.16),('12664','2013-04-23','08:45:00',2.27),('12664','2013-04-23','08:50:00',2.36),('12664','2013-04-23','08:55:00',2.46),('12664','2013-04-23','09:00:00',2.54),('12664','2013-04-23','09:05:00',2.61),('12664','2013-04-23','09:10:00',2.7),('12664','2013-04-23','09:15:00',2.8),('12664','2013-04-23','09:20:00',2.87),('12664','2013-04-23','09:25:00',2.93),('12664','2013-04-23','09:30:00',3.04),('12664','2013-04-23','09:35:00',3.12),('12664','2013-04-23','09:40:00',3.17),('12664','2013-04-23','09:45:00',3.27),('12664','2013-04-23','09:50:00',3.37),('12664','2013-04-23','09:55:00',3.36),('12664','2013-04-23','10:00:00',3.48),('12664','2013-04-23','10:05:00',3.57),('12664','2013-04-23','10:10:00',3.65),('12664','2013-04-23','10:15:00',3.7),('12664','2013-04-23','10:20:00',3.75),('12664','2013-04-23','10:25:00',3.75),('12664','2013-04-23','10:30:00',3.83),('12664','2013-04-23','10:35:00',3.91),('12664','2013-04-23','10:40:00',3.98),('12664','2013-04-23','10:45:00',3.91),('12664','2013-04-23','10:50:00',4.1),('12664','2013-04-23','10:55:00',4.09),('12664','2013-04-23','11:00:00',4.14),('12664','2013-04-23','11:05:00',4.21),('12664','2013-04-23','11:10:00',4.26),('12664','2013-04-23','11:15:00',4.29),('12664','2013-04-23','11:20:00',4.29),('12664','2013-04-23','11:25:00',4.3),('12664','2013-04-23','11:30:00',4.35),('12664','2013-04-23','11:35:00',4.4),('12664','2013-04-23','11:40:00',4.42),('12664','2013-04-23','11:45:00',4.44),('12664','2013-04-23','11:50:00',4.44),('12664','2013-04-23','11:55:00',4.47),('12664','2013-04-23','12:00:00',4.46),('12664','2013-04-23','12:05:00',4.46),('12664','2013-04-23','12:10:00',4.49),('12664','2013-04-23','12:15:00',4.56),('12664','2013-04-23','12:20:00',4.48),('12664','2013-04-23','12:25:00',4.48),('12664','2013-04-23','12:30:00',4.53),('12664','2013-04-23','12:35:00',4.62),('12664','2013-04-23','12:40:00',4.74),('12664','2013-04-23','12:45:00',4.94),('12664','2013-04-23','12:50:00',4.36),('12664','2013-04-23','12:55:00',4.8),('12664','2013-04-23','13:00:00',4.77),('12664','2013-04-23','13:05:00',4.72),('12664','2013-04-23','13:10:00',4.81),('12664','2013-04-23','13:15:00',4.87),('12664','2013-04-23','13:20:00',4.85),('12664','2013-04-23','13:25:00',4.67),('12664','2013-04-23','13:30:00',4.26),('12664','2013-04-23','13:35:00',4.37),('12664','2013-04-23','13:40:00',4.48),('12664','2013-04-23','13:45:00',4.59),('12664','2013-04-23','13:50:00',3.81),('12664','2013-04-23','13:55:00',4.48),('12664','2013-04-23','14:00:00',4.94),('12664','2013-04-23','14:05:00',4.7),('12664','2013-04-23','14:10:00',4.26),('12664','2013-04-23','14:15:00',4.61),('12664','2013-04-23','14:20:00',4.5),('12664','2013-04-23','14:25:00',4.26),('12664','2013-04-23','14:30:00',3.12),('12664','2013-04-23','14:35:00',2.58),('12664','2013-04-23','14:40:00',2.77),('12664','2013-04-23','14:45:00',4.11),('12664','2013-04-23','14:50:00',3.41),('12664','2013-04-23','14:55:00',1.99),('12664','2013-04-23','15:00:00',1.81),('12664','2013-04-23','15:05:00',2.24),('12664','2013-04-23','15:10:00',3.2),('12664','2013-04-23','15:15:00',3.52),('12664','2013-04-23','15:20:00',3.24),('12664','2013-04-23','15:25:00',2.94),('12664','2013-04-23','15:30:00',2.65),('12664','2013-04-23','15:35:00',2.92),('12664','2013-04-23','15:40:00',3.12),('12664','2013-04-23','15:45:00',2.75),('12664','2013-04-23','15:50:00',2.81),('12664','2013-04-23','15:55:00',3.01),('12664','2013-04-23','16:00:00',2.87),('12664','2013-04-23','16:05:00',2.09),('12664','2013-04-23','16:10:00',2.46),('12664','2013-04-23','16:15:00',2.21),('12664','2013-04-23','16:20:00',1.75),('12664','2013-04-23','16:25:00',1.7),('12664','2013-04-23','16:30:00',1.64),('12664','2013-04-23','16:35:00',1.38),('12664','2013-04-23','16:40:00',1.33),('12664','2013-04-23','16:45:00',1.24),('12664','2013-04-23','16:50:00',2.01),('12664','2013-04-23','16:55:00',2.32),('12664','2013-04-23','17:00:00',2.41),('12664','2013-04-23','17:05:00',2.3),('12664','2013-04-23','17:10:00',2.37),('12664','2013-04-23','17:15:00',2.23),('12664','2013-04-23','17:20:00',1.95),('12664','2013-04-23','17:25:00',1.68),('12664','2013-04-23','17:30:00',2.1),('12664','2013-04-23','17:35:00',1.71),('12664','2013-04-23','17:40:00',1.92),('12664','2013-04-23','17:45:00',1.69),('12664','2013-04-23','17:50:00',1.47),('12664','2013-04-23','17:55:00',1.44),('12664','2013-04-23','18:00:00',1.33),('12664','2013-04-23','18:05:00',1.11),('12664','2013-04-22','08:45:00',1.31),('12664','2013-04-22','09:40:00',1.03),('12664','2013-04-22','10:35:00',2.08),('12664','2013-04-22','10:40:00',2.99),('12664','2013-04-22','10:45:00',3.26),('12664','2013-04-22','10:50:00',2.97),('12664','2013-04-22','11:20:00',1.27),('12664','2013-04-22','11:25:00',1.7),('12664','2013-04-22','11:30:00',1.53),('12664','2013-04-22','11:45:00',3.97),('12664','2013-04-22','11:50:00',4.94),('12664','2013-04-22','11:55:00',4.89),('12664','2013-04-22','12:00:00',4.85),('12664','2013-04-22','12:05:00',4.67),('12664','2013-04-22','12:10:00',4.79),('12664','2013-04-22','12:15:00',4.81),('12664','2013-04-22','12:20:00',4.85),('12664','2013-04-22','12:25:00',5),('12664','2013-04-22','12:30:00',5.05),('12664','2013-04-22','12:35:00',4.35),('12664','2013-04-22','12:40:00',4.64),('12664','2013-04-22','12:45:00',4.49),('12664','2013-04-22','12:50:00',5.04),('12664','2013-04-22','12:55:00',3.72),('12664','2013-04-22','13:00:00',3.55),('12664','2013-04-22','13:05:00',1.19),('12664','2013-04-22','13:10:00',1.31),('12664','2013-04-22','13:15:00',1.63),('12664','2013-04-22','13:20:00',2.4),('12664','2013-04-22','13:25:00',2.28),('12664','2013-04-22','13:30:00',1.27),('12664','2013-04-22','13:35:00',1.23),('12664','2013-04-22','13:40:00',1.04),('12664','2013-04-22','14:05:00',1.44),('12664','2013-04-22','14:10:00',4.1),('12664','2013-04-22','14:15:00',2.95),('12664','2013-04-22','14:20:00',2.91),('12664','2013-04-22','14:25:00',1.68),('12664','2013-04-22','14:30:00',1.27),('12664','2013-04-22','14:35:00',2.58),('12664','2013-04-22','14:40:00',4.78),('12664','2013-04-22','14:45:00',4.3),('12664','2013-04-22','14:50:00',4.21),('12664','2013-04-22','14:55:00',2.9),('12664','2013-04-22','15:00:00',1.11),('12664','2013-04-22','15:05:00',1.36),('12664','2013-04-22','15:10:00',1.17),('12664','2013-04-22','15:15:00',1.12),('12664','2013-04-22','15:20:00',1.19),('12664','2013-04-22','15:25:00',2.28),('12664','2013-04-22','15:30:00',1.42),('12664','2013-04-22','15:35:00',2.78),('12664','2013-04-22','15:40:00',1.34),('12664','2013-04-22','15:45:00',1.93),('12664','2013-04-22','15:50:00',3.16),('12664','2013-04-22','15:55:00',2.84),('12664','2013-04-22','16:00:00',1.78),('12664','2013-04-22','17:05:00',1.13),('12664','2013-04-22','17:10:00',1.93),('12664','2013-04-22','17:15:00',1.86),('12664','2013-04-22','17:20:00',1.79),('12664','2013-04-22','17:25:00',2.92),('12664','2013-04-22','17:30:00',2.93),('12664','2013-04-22','17:35:00',2.68),('12664','2013-04-22','17:40:00',2.48),('12664','2013-04-22','17:45:00',2.5),('12664','2013-04-22','17:50:00',2.52),('12664','2013-04-22','17:55:00',1.68),('12664','2013-04-22','18:00:00',2.02),('12664','2013-04-22','18:05:00',1.07),('12664','2013-04-22','18:10:00',1.19),('12664','2013-04-22','18:15:00',1.41),('12664','2013-04-22','18:20:00',1.28),('12664','2013-04-22','18:25:00',1.12),('12664','2013-04-21','08:45:00',1.36),('12664','2013-04-21','08:50:00',1.14),('12664','2013-04-21','09:15:00',1.16),('12664','2013-04-21','09:25:00',1.25),('12664','2013-04-21','09:30:00',2.69),('12664','2013-04-21','09:35:00',2.37),('12664','2013-04-21','09:40:00',2.4),('12664','2013-04-21','09:45:00',2.04),('12664','2013-04-21','09:50:00',2.27),('12664','2013-04-21','09:55:00',2.19),('12664','2013-04-21','10:00:00',2.07),('12664','2013-04-21','10:05:00',2.07),('12664','2013-04-21','10:10:00',3.2),('12664','2013-04-21','10:15:00',3.67),('12664','2013-04-21','10:20:00',3.73),('12664','2013-04-21','10:25:00',3.81),('12664','2013-04-21','10:30:00',3.96),('12664','2013-04-21','10:35:00',3.76),('12664','2013-04-21','10:40:00',3.49),('12664','2013-04-21','10:45:00',3.42),('12664','2013-04-21','10:50:00',4.03),('12664','2013-04-21','10:55:00',4.08),('12664','2013-04-21','11:00:00',4.14),('12664','2013-04-21','11:05:00',4.27),('12664','2013-04-21','11:10:00',4.3),('12664','2013-04-21','11:15:00',4.46),('12664','2013-04-21','11:20:00',4.54),('12664','2013-04-21','11:25:00',3.24),('12664','2013-04-21','11:30:00',2.95),('12664','2013-04-21','11:35:00',2.89),('12664','2013-04-21','11:40:00',2.86),('12664','2013-04-21','11:45:00',2.74),('12664','2013-04-21','11:50:00',2.62),('12664','2013-04-21','11:55:00',2.57),('12664','2013-04-21','12:00:00',2.87),('12664','2013-04-21','12:05:00',2.67),('12664','2013-04-21','12:10:00',2.43),('12664','2013-04-21','12:15:00',2.22),('12664','2013-04-21','12:20:00',2.14),('12664','2013-04-21','12:25:00',2.23),('12664','2013-04-21','12:30:00',2.33),('12664','2013-04-21','12:35:00',2.38),('12664','2013-04-21','12:40:00',2.54),('12664','2013-04-21','12:45:00',2.57),('12664','2013-04-21','12:50:00',2.49),('12664','2013-04-21','12:55:00',2.47),('12664','2013-04-21','13:00:00',2.63),('12664','2013-04-21','13:05:00',3.37),('12664','2013-04-21','13:10:00',2.98),('12664','2013-04-21','13:15:00',2.6),('12664','2013-04-21','13:20:00',2.65),('12664','2013-04-21','13:25:00',2.89),('12664','2013-04-21','13:30:00',3.12),('12664','2013-04-21','13:35:00',3.39),('12664','2013-04-21','13:40:00',4.15),('12664','2013-04-21','13:45:00',3.61),('12664','2013-04-21','13:50:00',4.41),('12664','2013-04-21','13:55:00',3.68),('12664','2013-04-21','14:00:00',2.9),('12664','2013-04-21','14:05:00',4.29),('12664','2013-04-21','14:10:00',4.65),('12664','2013-04-21','14:15:00',4.9),('12664','2013-04-21','14:20:00',4.27),('12664','2013-04-21','14:25:00',4.66),('12664','2013-04-21','14:30:00',4.51),('12664','2013-04-21','14:35:00',4.36),('12664','2013-04-21','14:40:00',4.24),('12664','2013-04-21','14:45:00',2.81),('12664','2013-04-21','14:50:00',3.4),('12664','2013-04-21','14:55:00',4.5),('12664','2013-04-21','15:00:00',4.19),('12664','2013-04-21','15:05:00',4.12),('12664','2013-04-21','15:10:00',4.2),('12664','2013-04-21','15:15:00',3.39),('12664','2013-04-21','15:20:00',3.1),('12664','2013-04-21','15:25:00',3.28),('12664','2013-04-21','15:30:00',3.87),('12664','2013-04-21','15:35:00',2.7),('12664','2013-04-21','15:40:00',2.56),('12664','2013-04-21','15:45:00',1.81),('12664','2013-04-21','15:50:00',1.2),('12664','2014-03-28','07:30:00',1.15),('12664','2014-03-28','07:35:00',1.28),('12664','2014-03-28','07:40:00',1.37),('12664','2014-03-28','07:45:00',1.45),('12664','2014-03-28','07:50:00',1.55),('12664','2014-03-28','07:55:00',1.66),('12664','2014-03-28','08:00:00',1.76),('12664','2014-03-28','08:05:00',1.85),('12664','2014-03-28','08:10:00',1.93),('12664','2014-03-28','08:15:00',2.01),('12664','2014-03-28','08:20:00',2.11),('12664','2014-03-28','08:25:00',2.2),('12664','2014-03-28','08:30:00',2.27),('12664','2014-03-28','08:35:00',2.37),('12664','2014-03-28','08:40:00',2.48),('12664','2014-03-28','08:45:00',2.58),('12664','2014-03-28','08:50:00',2.7),('12664','2014-03-28','08:55:00',2.83),('12664','2014-03-28','09:00:00',3),('12664','2014-03-28','09:05:00',3),('12664','2014-03-28','09:10:00',2.83),('12664','2014-03-28','09:15:00',3.16),('12664','2014-03-28','09:20:00',3.55),('12664','2014-03-28','09:25:00',2.28),('12664','2014-03-28','09:30:00',1.98),('12664','2014-03-28','09:35:00',1.93),('12664','2014-03-28','09:40:00',3.37),('12664','2014-03-28','09:45:00',3.19),('12664','2014-03-28','09:50:00',3.3),('12664','2014-03-28','09:55:00',3.78),('12664','2014-03-28','10:00:00',3.16),('12664','2014-03-28','10:05:00',2.86),('12664','2014-03-28','10:10:00',3.06),('12664','2014-03-28','10:15:00',2.92),('12664','2014-03-28','10:20:00',2.75),('12664','2014-03-28','10:25:00',3.37),('12664','2014-03-28','10:30:00',3.77),('12664','2014-03-28','10:35:00',3.84),('12664','2014-03-28','10:40:00',3.84),('12664','2014-03-28','10:45:00',3.89),('12664','2014-03-28','10:50:00',3.91),('12664','2014-03-28','10:55:00',3.92),('12664','2014-03-28','11:00:00',3.93),('12664','2014-03-28','11:05:00',3.95),('12664','2014-03-28','11:10:00',3.98),('12664','2014-03-28','11:15:00',3.99),('12664','2014-03-28','11:20:00',4.09),('12664','2014-03-28','11:25:00',4.1),('12664','2014-03-28','11:30:00',4.07),('12664','2014-03-28','11:35:00',4.06),('12664','2014-03-28','11:40:00',4.09),('12664','2014-03-28','11:45:00',4.11),('12664','2014-03-28','11:50:00',4.14),('12664','2014-03-28','11:55:00',4.18),('12664','2014-03-28','12:00:00',4.24),('12664','2014-03-28','12:05:00',4.26),('12664','2014-03-28','12:10:00',4.37),('12664','2014-03-28','12:15:00',4.33),('12664','2014-03-28','12:20:00',4.07),('12664','2014-03-28','12:25:00',4.29),('12664','2014-03-28','12:30:00',3.99),('12664','2014-03-28','12:35:00',4.36),('12664','2014-03-28','12:40:00',4.04),('12664','2014-03-28','12:45:00',3.76),('12664','2014-03-28','12:50:00',4.43),('12664','2014-03-28','12:55:00',3.01),('12664','2014-03-28','13:00:00',1.84),('12664','2014-03-28','13:05:00',1.92),('12664','2014-03-28','13:10:00',2.29),('12664','2014-03-28','13:15:00',1.72),('12664','2014-03-28','13:20:00',1.5),('12664','2014-03-28','13:25:00',1.65),('12664','2014-03-28','13:30:00',1.71),('12664','2014-03-28','13:35:00',4.27),('12664','2014-03-28','13:40:00',4.02),('12664','2014-03-28','13:45:00',3.95),('12664','2014-03-28','13:50:00',3.87),('12664','2014-03-28','13:55:00',3.83),('12664','2014-03-28','14:00:00',3.78),('12664','2014-03-28','14:05:00',3.71),('12664','2014-03-28','14:10:00',3.66),('12664','2014-03-28','14:15:00',3.62),('12664','2014-03-28','14:20:00',3.56),('12664','2014-03-28','14:25:00',3.52),('12664','2014-03-28','14:30:00',3.46),('12664','2014-03-28','14:35:00',3.39),('12664','2014-03-28','14:40:00',3.34),('12664','2014-03-28','14:45:00',3.29),('12664','2014-03-28','14:50:00',3.23),('12664','2014-03-28','14:55:00',3.16),('12664','2014-03-28','15:00:00',3.07),('12664','2014-03-28','15:05:00',3.01),('12664','2014-03-28','15:10:00',2.94),('12664','2014-03-28','15:15:00',2.86),('12664','2014-03-28','15:20:00',2.79),('12664','2014-03-28','15:25:00',2.71),('12664','2014-03-28','15:30:00',2.63),('12664','2014-03-28','15:35:00',2.6),('12664','2014-03-28','15:40:00',2.5),('12664','2014-03-28','15:45:00',2.43),('12664','2014-03-28','15:50:00',2.41),('12664','2014-03-28','15:55:00',2.44),('12664','2014-03-28','16:00:00',2.44),('12664','2014-03-28','16:05:00',2.26),('12664','2014-03-28','16:10:00',2.09),('12664','2014-03-28','16:15:00',1.98),('12664','2014-03-28','16:20:00',1.95),('12664','2014-03-28','16:25:00',1.33),('12664','2014-03-28','16:35:00',1.52),('12664','2014-03-28','16:50:00',1.25),('12664','2014-03-28','17:00:00',1.04),('12664','2013-04-20','08:05:00',1.13),('12664','2013-04-20','08:15:00',1.08),('12664','2013-04-20','08:25:00',1.28),('12664','2013-04-20','08:30:00',1.62),('12664','2013-04-20','08:35:00',1.88),('12664','2013-04-20','08:40:00',2.02),('12664','2013-04-20','08:45:00',2.11),('12664','2013-04-20','08:50:00',2.31),('12664','2013-04-20','08:55:00',2.38),('12664','2013-04-20','09:00:00',2.52),('12664','2013-04-20','09:05:00',2.61),('12664','2013-04-20','09:10:00',1.95),('12664','2013-04-20','09:15:00',2.08),('12664','2013-04-20','09:20:00',1.77),('12664','2013-04-20','09:25:00',1.56),('12664','2013-04-20','09:30:00',1.14),('12664','2013-04-20','10:25:00',1.02),('12664','2013-04-20','10:30:00',1.49),('12664','2013-04-20','10:35:00',1.81),('12664','2013-04-20','10:40:00',3.69),('12664','2013-04-20','10:45:00',3.53),('12664','2013-04-20','10:50:00',4.12),('12664','2013-04-20','10:55:00',4),('12664','2013-04-20','11:00:00',1.99),('12664','2013-04-20','11:05:00',2.23),('12664','2013-04-20','11:10:00',1.76),('12664','2013-04-20','11:15:00',3.11),('12664','2013-04-20','11:20:00',3.32),('12664','2013-04-20','11:25:00',3.44),('12664','2013-04-20','11:30:00',3.61),('12664','2013-04-20','11:35:00',3.8),('12664','2013-04-20','11:40:00',2.06),('12664','2013-04-20','11:45:00',1.97),('12664','2013-04-20','11:50:00',3.03),('12664','2013-04-20','11:55:00',2.75),('12664','2013-04-20','12:00:00',5.03),('12664','2013-04-20','12:05:00',3.6),('12664','2013-04-20','12:10:00',3.24),('12664','2013-04-20','12:15:00',4.88),('12664','2013-04-20','12:20:00',4.7),('12664','2013-04-20','12:25:00',4.54),('12664','2013-04-20','12:30:00',2.58),('12664','2013-04-20','12:35:00',1.26),('12664','2013-04-20','12:40:00',1.68),('12664','2013-04-20','12:45:00',3.07),('12664','2013-04-20','12:50:00',4.93),('12664','2013-04-20','12:55:00',4.76),('12664','2013-04-20','13:00:00',2.17),('12664','2013-04-20','13:05:00',2.75),('12664','2013-04-20','13:10:00',3.48),('12664','2013-04-20','13:15:00',4.73),('12664','2013-04-20','13:20:00',4.74),('12664','2013-04-20','13:25:00',4.72),('12664','2013-04-20','13:30:00',4.66),('12664','2013-04-20','13:35:00',4.78),('12664','2013-04-20','13:40:00',2),('12664','2013-04-20','13:45:00',2.72),('12664','2013-04-20','13:50:00',3.68),('12664','2013-04-20','13:55:00',3.76),('12664','2013-04-20','14:00:00',4.78),('12664','2013-04-20','14:05:00',4.48),('12664','2013-04-20','14:10:00',4.3),('12664','2013-04-20','14:15:00',3.92),('12664','2013-04-20','14:20:00',4.38),('12664','2013-04-20','14:25:00',3.4),('12664','2013-04-20','14:30:00',4.44),('12664','2013-04-20','14:35:00',4.29),('12664','2013-04-20','14:40:00',4.16),('12664','2013-04-20','14:45:00',4.1),('12664','2013-04-20','14:50:00',4.06),('12664','2013-04-20','14:55:00',4.04),('12664','2013-04-20','15:00:00',4.18),('12664','2013-04-20','15:05:00',1.98),('12664','2013-04-20','15:10:00',2.02),('12664','2013-04-20','15:15:00',3.2),('12664','2013-04-20','15:20:00',2.2),('12664','2013-04-20','15:25:00',1.49),('12664','2013-04-20','15:30:00',1.08),('12664','2013-04-20','15:55:00',1.08),('12664','2013-04-20','16:00:00',1.52),('12664','2013-04-20','16:05:00',2.76),('12664','2013-04-20','16:10:00',3.63),('12664','2013-04-20','16:15:00',3.2),('12664','2013-04-20','16:20:00',2.59),('12664','2013-04-20','16:25:00',3.34),('12664','2013-04-20','16:30:00',3.27),('12664','2013-04-20','16:35:00',3.1),('12664','2013-04-20','16:40:00',2.94),('12664','2013-04-20','16:45:00',2.73),('12664','2013-04-20','16:50:00',2.46),('12664','2013-04-20','16:55:00',2.38),('12664','2013-04-20','17:00:00',2.42),('12664','2013-04-20','17:05:00',2.32),('12664','2013-04-20','17:10:00',2.19),('12664','2013-04-20','17:15:00',2.11),('12664','2013-04-20','17:20:00',2.08),('12664','2013-04-20','17:25:00',2.05),('12664','2013-04-20','17:30:00',2.03),('12664','2013-04-20','17:35:00',1.71),('12664','2013-04-20','17:45:00',1.25),('12664','2013-04-20','17:50:00',1.44),('12664','2013-04-20','17:55:00',1.31),('12664','2013-04-20','18:00:00',1.3),('12664','2013-04-20','18:05:00',1.34),('12664','2013-04-20','18:10:00',1.06),('12664','2013-04-19','08:25:00',1.23),('12664','2013-04-19','08:30:00',1.12),('12664','2013-04-19','08:45:00',1.45),('12664','2013-04-19','08:50:00',1.26),('12664','2013-04-19','08:55:00',1.44),('12664','2013-04-19','09:00:00',1.34),('12664','2013-04-19','09:05:00',1.6),('12664','2013-04-19','09:10:00',2.23),('12664','2013-04-19','09:15:00',2.84),('12664','2013-04-19','09:20:00',2.64),('12664','2013-04-19','09:25:00',2.7),('12664','2013-04-19','09:30:00',2.73),('12664','2013-04-19','09:35:00',2.75),('12664','2013-04-19','09:40:00',2.8),('12664','2013-04-19','09:45:00',2.81),('12664','2013-04-19','09:50:00',2.91),('12664','2013-04-19','09:55:00',2.98),('12664','2013-04-19','10:00:00',3.07),('12664','2013-04-19','10:05:00',3.12),('12664','2013-04-19','10:10:00',3.18),('12664','2013-04-19','10:15:00',3.25),('12664','2013-04-19','10:20:00',3.33),('12664','2013-04-19','10:25:00',3.41),('12664','2013-04-19','10:30:00',3.48),('12664','2013-04-19','10:35:00',3.49),('12664','2013-04-19','10:40:00',3.51),('12664','2013-04-19','10:45:00',3.59),('12664','2013-04-19','10:50:00',3.65),('12664','2013-04-19','10:55:00',3.69),('12664','2013-04-19','11:00:00',3.74),('12664','2013-04-19','11:05:00',3.78),('12664','2013-04-19','11:10:00',3.81),('12664','2013-04-19','11:15:00',3.85),('12664','2013-04-19','11:20:00',3.93),('12664','2013-04-19','11:25:00',3.97),('12664','2013-04-19','11:30:00',4.01),('12664','2013-04-19','11:35:00',4.01),('12664','2013-04-19','11:40:00',4.06),('12664','2013-04-19','11:45:00',4.1),('12664','2013-04-19','11:50:00',4.07),('12664','2013-04-19','11:55:00',4.05),('12664','2013-04-19','12:00:00',4.08),('12664','2013-04-19','12:05:00',4.13),('12664','2013-04-19','12:10:00',4.16),('12664','2013-04-19','12:15:00',4.18),('12664','2013-04-19','12:20:00',4.15),('12664','2013-04-19','12:25:00',4.2),('12664','2013-04-19','12:30:00',4.2),('12664','2013-04-19','12:35:00',4.3),('12664','2013-04-19','12:40:00',4.28),('12664','2013-04-19','12:45:00',4.32),('12664','2013-04-19','12:50:00',4.32),('12664','2013-04-19','12:55:00',4.3),('12664','2013-04-19','13:00:00',4.37),('12664','2013-04-19','13:05:00',4.33),('12664','2013-04-19','13:10:00',4.34),('12664','2013-04-19','13:15:00',4.32),('12664','2013-04-19','13:20:00',4.35),('12664','2013-04-19','13:25:00',4.3),('12664','2013-04-19','13:30:00',4.32),('12664','2013-04-19','13:35:00',4.33),('12664','2013-04-19','13:40:00',4.28),('12664','2013-04-19','13:45:00',4.27),('12664','2013-04-19','13:50:00',4.22),('12664','2013-04-19','13:55:00',4.26),('12664','2013-04-19','14:00:00',4.23),('12664','2013-04-19','14:05:00',4.2),('12664','2013-04-19','14:10:00',4.2),('12664','2013-04-19','14:15:00',4.19),('12664','2013-04-19','14:20:00',4.14),('12664','2013-04-19','14:25:00',4.11),('12664','2013-04-19','14:30:00',4.1),('12664','2013-04-19','14:35:00',4.07),('12664','2013-04-19','14:40:00',4.02),('12664','2013-04-19','14:45:00',3.97),('12664','2013-04-19','14:50:00',3.92),('12664','2013-04-19','14:55:00',3.89),('12664','2013-04-19','15:00:00',3.87),('12664','2013-04-19','15:05:00',3.82),('12664','2013-04-19','15:10:00',3.75),('12664','2013-04-19','15:15:00',3.71),('12664','2013-04-19','15:20:00',3.67),('12664','2013-04-19','15:25:00',3.63),('12664','2013-04-19','15:30:00',3.57),('12664','2013-04-19','15:35:00',3.55),('12664','2013-04-19','15:40:00',3.5),('12664','2013-04-19','15:45:00',3.43),('12664','2013-04-19','15:50:00',3.37),('12664','2013-04-19','15:55:00',3.29),('12664','2013-04-19','16:00:00',3.22),('12664','2013-04-19','16:05:00',3.14),('12664','2013-04-19','16:10:00',3.06),('12664','2013-04-19','16:15:00',2.98),('12664','2013-04-19','16:20:00',2.92),('12664','2013-04-19','16:25:00',2.81),('12664','2013-04-19','16:30:00',2.7),('12664','2013-04-19','16:35:00',2.62),('12664','2013-04-19','16:40:00',2.55),('12664','2013-04-19','16:45:00',2.47),('12664','2013-04-19','16:50:00',2.38),('12664','2013-04-19','16:55:00',2.27),('12664','2013-04-19','17:00:00',2.16),('12664','2013-04-19','17:05:00',2.1),('12664','2013-04-19','17:10:00',2.01),('12664','2013-04-19','17:15:00',1.94),('12664','2013-04-19','17:20:00',1.85),('12664','2013-04-19','17:25:00',1.76),('12664','2013-04-19','17:30:00',1.65),('12664','2013-04-19','17:35:00',1.56),('12664','2013-04-19','17:40:00',1.48),('12664','2013-04-19','17:45:00',1.38),('12664','2013-04-19','17:50:00',1.28),('12664','2013-04-19','17:55:00',1.19),('12664','2013-04-19','18:00:00',1.1),('12664','2013-04-19','18:05:00',1.01),('12664','2013-04-18','08:05:00',1.02),('12664','2013-04-18','08:10:00',1.02),('12664','2013-04-18','08:15:00',1.15),('12664','2013-04-18','08:20:00',1.2),('12664','2013-04-18','08:25:00',1.15),('12664','2013-04-18','08:30:00',1.06),('12664','2013-04-18','08:35:00',1.04),('12664','2013-04-18','08:40:00',1.11),('12664','2013-04-18','08:45:00',1.2),('12664','2013-04-18','08:50:00',1.4),('12664','2013-04-18','08:55:00',1.39),('12664','2013-04-18','09:00:00',1.11),('12664','2013-04-18','09:05:00',1.41),('12664','2013-04-18','09:10:00',1.59),('12664','2013-04-18','09:15:00',1.61),('12664','2013-04-18','09:20:00',1.95),('12664','2013-04-18','09:25:00',2.1),('12664','2013-04-18','09:30:00',2.16),('12664','2013-04-18','09:35:00',1.84),('12664','2013-04-18','09:40:00',1.9),('12664','2013-04-18','09:45:00',1.99),('12664','2013-04-18','09:50:00',2.36),('12664','2013-04-18','09:55:00',2.86),('12664','2013-04-18','10:00:00',3.11),('12664','2013-04-18','10:05:00',3.08),('12664','2013-04-18','10:10:00',3.26),('12664','2013-04-18','10:15:00',3.27),('12664','2013-04-18','10:20:00',3.34),('12664','2013-04-18','10:25:00',3.45),('12664','2013-04-18','10:30:00',3.58),('12664','2013-04-18','10:35:00',3.68),('12664','2013-04-18','10:40:00',3.71),('12664','2013-04-18','10:45:00',3.73),('12664','2013-04-18','10:50:00',3.77),('12664','2013-04-18','10:55:00',3.79),('12664','2013-04-18','11:00:00',3.83),('12664','2013-04-18','11:05:00',3.86),('12664','2013-04-18','11:10:00',3.92),('12664','2013-04-18','11:15:00',3.95),('12664','2013-04-18','11:20:00',4.01),('12664','2013-04-18','11:25:00',4.08),('12664','2013-04-18','11:30:00',4.14),('12664','2013-04-18','11:35:00',4.18),('12664','2013-04-18','11:40:00',4.21),('12664','2013-04-18','11:55:00',4.33),('12664','2013-04-18','12:00:00',4.2),('12664','2013-04-18','12:05:00',4.41),('12664','2013-04-18','12:10:00',4.39),('12664','2013-04-18','12:15:00',4.35),('12664','2013-04-18','12:20:00',4.45),('12664','2013-04-18','12:25:00',4.47),('12664','2013-04-18','12:30:00',4.47),('12664','2013-04-18','12:35:00',4.47),('12664','2013-04-18','12:40:00',4.48),('12664','2013-04-18','12:45:00',4.47),('12664','2013-04-18','12:50:00',4.45),('12664','2013-04-18','12:55:00',4.42),('12664','2013-04-18','13:00:00',4.43),('12664','2013-04-18','13:05:00',4.41),('12664','2013-04-18','13:10:00',4.43),('12664','2013-04-18','13:15:00',4.43),('12664','2013-04-18','13:20:00',4.46),('12664','2013-04-18','13:25:00',4.47),('12664','2013-04-18','13:30:00',4.41),('12664','2013-04-18','13:35:00',4.39),('12664','2013-04-18','13:40:00',4.4),('12664','2013-04-18','13:45:00',4.41),('12664','2013-04-18','13:50:00',4.4),('12664','2013-04-18','13:55:00',4.37),('12664','2013-04-18','14:00:00',4.37),('12664','2013-04-18','14:05:00',4.36),('12664','2013-04-18','14:10:00',4.32),('12664','2013-04-18','14:15:00',4.29),('12664','2013-04-18','14:20:00',4.25),('12664','2013-04-18','14:25:00',4.22),('12664','2013-04-18','14:30:00',4.21),('12664','2013-04-18','14:35:00',4.17),('12664','2013-04-18','14:40:00',4.14),('12664','2013-04-18','14:45:00',4.1),('12664','2013-04-18','14:50:00',4.06),('12664','2013-04-18','14:55:00',4.02),('12664','2013-04-18','15:00:00',3.98),('12664','2013-04-18','15:05:00',3.9),('12664','2013-04-18','15:10:00',3.85),('12664','2013-04-18','15:15:00',3.83),('12664','2013-04-18','15:20:00',3.78),('12664','2013-04-18','15:25:00',3.71),('12664','2013-04-18','15:30:00',3.65),('12664','2013-04-18','15:35:00',3.58),('12664','2013-04-18','15:40:00',3.53),('12664','2013-04-18','15:45:00',3.47),('12664','2013-04-18','15:50:00',3.41),('12664','2013-04-18','15:55:00',3.31),('12664','2013-04-18','16:00:00',3.24),('12664','2013-04-18','16:05:00',3.17),('12664','2013-04-18','16:10:00',3.09),('12664','2013-04-18','16:15:00',3.01),('12664','2013-04-18','16:20:00',2.93),('12664','2013-04-18','16:25:00',2.86),('12664','2013-04-18','16:30:00',2.8),('12664','2013-04-18','16:35:00',2.75),('12664','2013-04-18','16:40:00',2.65),('12664','2013-04-18','16:45:00',2.57),('12664','2013-04-18','16:50:00',2.46),('12664','2013-04-18','16:55:00',2.35),('12664','2013-04-18','17:00:00',2.3),('12664','2013-04-18','17:05:00',2.21),('12664','2013-04-18','17:10:00',2.1),('12664','2013-04-18','17:15:00',2.01),('12664','2013-04-18','17:20:00',1.93),('12664','2013-04-18','17:25:00',1.84),('12664','2013-04-18','17:30:00',1.73),('12664','2013-04-18','17:35:00',1.63),('12664','2013-04-18','17:40:00',1.52),('12664','2013-04-18','17:45:00',1.39),('12664','2013-04-18','17:50:00',1.29),('12664','2013-04-18','17:55:00',1.22),('12664','2013-04-18','18:00:00',1.13),('12664','2013-04-18','18:05:00',1.04),('12664','2013-04-17','07:55:00',1.01),('12664','2013-04-17','08:00:00',1.11),('12664','2013-04-17','08:05:00',1.21),('12664','2013-04-17','08:10:00',1.31),('12664','2013-04-17','08:15:00',1.4),('12664','2013-04-17','08:20:00',1.5),('12664','2013-04-17','08:25:00',1.6),('12664','2013-04-17','08:30:00',1.7),('12664','2013-04-17','08:35:00',1.79),('12664','2013-04-17','08:40:00',1.88),('12664','2013-04-17','08:45:00',1.97),('12664','2013-04-17','08:50:00',2.07),('12664','2013-04-17','08:55:00',2.16),('12664','2013-04-17','09:00:00',2.23),('12664','2013-04-17','09:05:00',2.33),('12664','2013-04-17','09:10:00',2.43),('12664','2013-04-17','09:15:00',2.52),('12664','2013-04-17','09:20:00',2.6),('12664','2013-04-17','09:25:00',2.69),('12664','2013-04-17','09:30:00',2.75),('12664','2013-04-17','09:35:00',2.82),('12664','2013-04-17','09:40:00',2.89),('12664','2013-04-17','09:45:00',2.99),('12664','2013-04-17','09:50:00',3.07),('12664','2013-04-17','09:55:00',3.14),('12664','2013-04-17','10:00:00',3.23),('12664','2013-04-17','10:05:00',3.31),('12664','2013-04-17','10:10:00',3.37),('12664','2013-04-17','10:15:00',3.45),('12664','2013-04-17','10:20:00',3.51),('12664','2013-04-17','10:25:00',3.58),('12664','2013-04-17','10:30:00',3.62),('12664','2013-04-17','10:35:00',3.67),('12664','2013-04-17','10:40:00',3.72),('12664','2013-04-17','10:45:00',3.77),('12664','2013-04-17','10:50:00',3.82),('12664','2013-04-17','10:55:00',3.87),('12664','2013-04-17','11:00:00',3.92),('12664','2013-04-17','11:05:00',3.96),('12664','2013-04-17','11:10:00',4.02),('12664','2013-04-17','11:15:00',4.06),('12664','2013-04-17','11:20:00',4.09),('12664','2013-04-17','11:25:00',4.11),('12664','2013-04-17','11:30:00',4.15),('12664','2013-04-17','11:35:00',4.17),('12664','2013-04-17','11:40:00',4.19),('12664','2013-04-17','11:45:00',4.21),('12664','2013-04-17','11:50:00',4.23),('12664','2013-04-17','11:55:00',4.28),('12664','2013-04-17','12:00:00',4.27),('12664','2013-04-17','12:05:00',4.26),('12664','2013-04-17','12:10:00',4.31),('12664','2013-04-17','12:15:00',4.33),('12664','2013-04-17','12:20:00',4.36),('12664','2013-04-17','12:25:00',4.36),('12664','2013-04-17','12:30:00',4.37),('12664','2013-04-17','12:35:00',4.39),('12664','2013-04-17','12:40:00',4.4),('12664','2013-04-17','12:45:00',4.42),('12664','2013-04-17','12:50:00',4.44),('12664','2013-04-17','12:55:00',4.44),('12664','2013-04-17','13:00:00',4.07),('12664','2013-04-17','13:05:00',3.99),('12664','2013-04-17','13:10:00',4.4),('12664','2013-04-17','13:15:00',4.53),('12664','2013-04-17','13:20:00',4.41),('12664','2013-04-17','13:25:00',4.33),('12664','2013-04-17','13:30:00',4.55),('12664','2013-04-17','13:35:00',4.47),('12664','2013-04-17','13:40:00',4.58),('12664','2013-04-17','13:45:00',4.23),('12664','2013-04-17','13:50:00',4.16),('12664','2013-04-17','13:55:00',4.24),('12664','2013-04-17','14:00:00',3.39),('12664','2013-04-17','14:05:00',3.41),('12664','2013-04-17','14:10:00',4.41),('12664','2013-04-17','14:15:00',4.49),('12664','2013-04-17','14:20:00',4.71),('12664','2013-04-17','14:25:00',4.1),('12664','2013-04-17','14:30:00',4.39),('12664','2013-04-17','14:35:00',4.62),('12664','2013-04-17','14:40:00',4.39),('12664','2013-04-17','14:45:00',2.36),('12664','2013-04-17','14:50:00',2.65),('12664','2013-04-17','14:55:00',2),('12664','2013-04-17','15:00:00',2.48),('12664','2013-04-17','15:05:00',3.85),('12664','2013-04-17','15:10:00',3.57),('12664','2013-04-17','15:15:00',2.96),('12664','2013-04-17','15:20:00',2.75),('12664','2013-04-17','15:25:00',1.63),('12664','2013-04-17','15:30:00',2.69),('12664','2013-04-17','15:35:00',3.62),('12664','2013-04-17','15:40:00',3.84),('12664','2013-04-17','15:45:00',3.45),('12664','2013-04-17','15:50:00',3.66),('12664','2013-04-17','15:55:00',3.06),('12664','2013-04-17','16:00:00',3.38),('12664','2013-04-17','16:05:00',3.34),('12664','2013-04-17','16:10:00',3.17),('12664','2013-04-17','16:15:00',3.21),('12664','2013-04-17','16:20:00',3),('12664','2013-04-17','16:25:00',3.01),('12664','2013-04-17','16:30:00',2.91),('12664','2013-04-17','16:35:00',2.86),('12664','2013-04-17','16:40:00',2.29),('12664','2013-04-17','16:45:00',2.62),('12664','2013-04-17','16:50:00',2.54),('12664','2013-04-17','16:55:00',2.45),('12664','2013-04-17','17:00:00',2.35),('12664','2013-04-17','17:05:00',2.25),('12664','2013-04-17','17:10:00',2.15),('12664','2013-04-17','17:15:00',2.05),('12664','2013-04-17','17:20:00',1.96),('12664','2013-04-17','17:25:00',1.87),('12664','2013-04-17','17:30:00',1.76),('12664','2013-04-17','17:35:00',1.66),('12664','2013-04-17','17:40:00',1.57),('12664','2013-04-17','17:45:00',1.47),('12664','2013-04-17','17:50:00',1.37),('12664','2013-04-17','17:55:00',1.26),('12664','2013-04-17','18:00:00',1.17),('12664','2013-04-17','18:05:00',1.08),('12664','2013-04-16','08:05:00',1.16),('12664','2013-04-16','08:55:00',1.17),('12664','2013-04-16','09:00:00',2.05),('12664','2013-04-16','09:05:00',2.26),('12664','2013-04-16','09:10:00',2.33),('12664','2013-04-16','09:15:00',2.37),('12664','2013-04-16','09:20:00',1.84),('12664','2013-04-16','09:25:00',1.73),('12664','2013-04-16','09:30:00',1.84),('12664','2013-04-16','09:35:00',1.48),('12664','2013-04-16','09:40:00',1.64),('12664','2013-04-16','09:45:00',1.68),('12664','2013-04-16','09:50:00',1.66),('12664','2013-04-16','09:55:00',1.68),('12664','2013-04-16','10:00:00',1.74),('12664','2013-04-16','10:05:00',1.45),('12664','2013-04-16','10:10:00',1.37),('12664','2013-04-16','10:15:00',1.36),('12664','2013-04-16','10:20:00',1.33),('12664','2013-04-16','10:25:00',1.32),('12664','2013-04-16','10:30:00',1.36),('12664','2013-04-16','10:35:00',1.44),('12664','2013-04-16','10:40:00',1.5),('12664','2013-04-16','10:45:00',1.54),('12664','2013-04-16','10:50:00',1.58),('12664','2013-04-16','10:55:00',1.56),('12664','2013-04-16','11:00:00',1.57),('12664','2013-04-16','11:05:00',1.65),('12664','2013-04-16','11:10:00',1.74),('12664','2013-04-16','11:15:00',1.76),('12664','2013-04-16','11:20:00',1.78),('12664','2013-04-16','11:25:00',1.83),('12664','2013-04-16','11:30:00',1.71),('12664','2013-04-16','11:35:00',1.65),('12664','2013-04-16','11:40:00',1.94),('12664','2013-04-16','11:45:00',2.34),('12664','2013-04-16','11:50:00',2.53),('12664','2013-04-16','11:55:00',2.98),('12664','2013-04-16','12:00:00',3.28),('12664','2013-04-16','12:05:00',3.2),('12664','2013-04-16','12:10:00',3.66),('12664','2013-04-16','12:15:00',4.05),('12664','2013-04-16','12:20:00',3.7),('12664','2013-04-16','12:25:00',3.79),('12664','2013-04-16','12:30:00',3.94),('12664','2013-04-16','12:35:00',4.1),('12664','2013-04-16','12:40:00',3.45),('12664','2013-04-16','12:45:00',4.1),('12664','2013-04-16','12:50:00',3.58),('12664','2013-04-16','12:55:00',4.23),('12664','2013-04-16','13:00:00',4.27),('12664','2013-04-16','13:05:00',4.2),('12664','2013-04-16','13:10:00',4.18),('12664','2013-04-16','13:15:00',4.27),('12664','2013-04-16','13:20:00',4.32),('12664','2013-04-16','13:25:00',4.2),('12664','2013-04-16','13:30:00',4.36),('12664','2013-04-16','13:35:00',4.32),('12664','2013-04-16','13:40:00',4.33),('12664','2013-04-16','13:45:00',4.23),('12664','2013-04-16','13:50:00',4.33),('12664','2013-04-16','13:55:00',4.31),('12664','2013-04-16','14:00:00',4.29),('12664','2013-04-16','14:05:00',4.24),('12664','2013-04-16','14:10:00',4.3),('12664','2013-04-16','14:15:00',4.25),('12664','2013-04-16','14:30:00',3.32),('12664','2013-04-16','14:35:00',3.16),('12664','2013-04-16','14:40:00',4.06),('12664','2013-04-16','14:45:00',4.1),('12664','2013-04-16','14:50:00',4.05),('12664','2013-04-16','14:55:00',3.86),('12664','2013-04-16','15:00:00',4.02),('12664','2013-04-16','15:05:00',3.99),('12664','2013-04-16','15:10:00',3.82),('12664','2013-04-16','15:15:00',2.91),('12664','2013-04-16','15:20:00',3.11),('12664','2013-04-16','15:25:00',3.58),('12664','2013-04-16','15:30:00',3.42),('12664','2013-04-16','15:35:00',3.57),('12664','2013-04-16','15:40:00',3.45),('12664','2013-04-16','15:45:00',3.43),('12664','2013-04-16','15:50:00',3.37),('12664','2013-04-16','15:55:00',3.3),('12664','2013-04-16','16:00:00',3.23),('12664','2013-04-16','16:05:00',3.14),('12664','2013-04-16','16:10:00',3.09),('12664','2013-04-16','16:15:00',2.99),('12664','2013-04-16','16:20:00',2.89),('12664','2013-04-16','16:25:00',2.82),('12664','2013-04-16','16:30:00',2.77),('12664','2013-04-16','16:35:00',2.71),('12664','2013-04-16','16:40:00',2.67),('12664','2013-04-16','16:45:00',2.53),('12664','2013-04-16','16:50:00',2.46),('12664','2013-04-16','16:55:00',2.3),('12664','2013-04-16','17:00:00',2.28),('12664','2013-04-16','17:05:00',2.13),('12664','2013-04-16','17:10:00',2.1),('12664','2013-04-16','17:15:00',2),('12664','2013-04-16','17:20:00',1.9),('12664','2013-04-16','17:25:00',1.8),('12664','2013-04-16','17:30:00',1.73),('12664','2013-04-16','17:35:00',1.62),('12664','2013-04-16','17:40:00',1.52),('12664','2013-04-16','17:45:00',1.43),('12664','2013-04-16','17:50:00',1.39),('12664','2013-04-16','17:55:00',1.39),('12664','2013-04-16','18:00:00',1.38),('12664','2013-04-16','18:05:00',1.2),('12664','2013-04-15','08:00:00',1.08),('12664','2013-04-15','08:05:00',1.18),('12664','2013-04-15','08:10:00',1.29),('12664','2013-04-15','08:15:00',1.4),('12664','2013-04-15','08:20:00',1.5),('12664','2013-04-15','08:25:00',1.61),('12664','2013-04-15','08:30:00',1.71),('12664','2013-04-15','08:35:00',1.81),('12664','2013-04-15','08:40:00',1.91),('12664','2013-04-15','08:45:00',2.02),('12664','2013-04-15','08:50:00',2.12),('12664','2013-04-15','08:55:00',2.21),('12664','2013-04-15','09:00:00',2.31),('12664','2013-04-15','09:05:00',2.41),('12664','2013-04-15','09:10:00',2.51),('12664','2013-04-15','09:15:00',2.58),('12664','2013-04-15','09:20:00',2.67),('12664','2013-04-15','09:25:00',2.75),('12664','2013-04-15','09:30:00',2.82),('12664','2013-04-15','09:35:00',2.89),('12664','2013-04-15','09:40:00',2.97),('12664','2013-04-15','09:45:00',3.05),('12664','2013-04-15','09:50:00',3.12),('12664','2013-04-15','09:55:00',3.19),('12664','2013-04-15','10:00:00',3.27),('12664','2013-04-15','10:05:00',3.34),('12664','2013-04-15','10:10:00',3.39),('12664','2013-04-15','10:15:00',3.46),('12664','2013-04-15','10:20:00',3.52),('12664','2013-04-15','10:25:00',3.58),('12664','2013-04-15','10:30:00',3.63),('12664','2013-04-15','10:35:00',3.69),('12664','2013-04-15','10:40:00',3.75),('12664','2013-04-15','10:45:00',3.8),('12664','2013-04-15','10:50:00',3.85),('12664','2013-04-15','10:55:00',3.89),('12664','2013-04-15','11:00:00',3.93),('12664','2013-04-15','11:05:00',3.95),('12664','2013-04-15','11:10:00',3.99),('12664','2013-04-15','11:15:00',4.03),('12664','2013-04-15','11:20:00',4.08),('12664','2013-04-15','11:25:00',4.11),('12664','2013-04-15','11:30:00',4.13),('12664','2013-04-15','11:35:00',4.15),('12664','2013-04-15','11:40:00',4.16),('12664','2013-04-15','11:45:00',4.18),('12664','2013-04-15','11:50:00',4.22),('12664','2013-04-15','11:55:00',4.24),('12664','2013-04-15','12:00:00',4.24),('12664','2013-04-15','12:05:00',4.27),('12664','2013-04-15','12:10:00',4.32),('12664','2013-04-15','12:15:00',4.35),('12664','2013-04-15','12:20:00',4.36),('12664','2013-04-15','12:25:00',4.36),('12664','2013-04-15','12:30:00',4.36),('12664','2013-04-15','12:35:00',4.37),('12664','2013-04-15','12:40:00',4.38),('12664','2013-04-15','12:45:00',4.38),('12664','2013-04-15','12:50:00',4.39),('12664','2013-04-15','12:55:00',4.4),('12664','2013-04-15','13:00:00',4.43),('12664','2013-04-15','13:05:00',4.44),('12664','2013-04-15','13:10:00',4.4),('12664','2013-04-15','13:15:00',4.4),('12664','2013-04-15','13:20:00',4.4),('12664','2013-04-15','13:25:00',4.37),('12664','2013-04-15','13:30:00',4.42),('12664','2013-04-15','13:35:00',4.43),('12664','2013-04-15','13:40:00',4.44),('12664','2013-04-15','13:45:00',4.47),('12664','2013-04-15','13:50:00',4.47),('12664','2013-04-15','13:55:00',4.45),('12664','2013-04-15','14:00:00',4.43),('12664','2013-04-15','14:05:00',4.41),('12664','2013-04-15','14:10:00',4.38),('12664','2013-04-15','14:15:00',4.37),('12664','2013-04-15','14:20:00',4.34),('12664','2013-04-15','14:25:00',4.3),('12664','2013-04-15','14:30:00',4.26),('12664','2013-04-15','14:35:00',4.21),('12664','2013-04-15','14:40:00',4.17),('12664','2013-04-15','14:45:00',4.13),('12664','2013-04-15','14:50:00',4.1),('12664','2013-04-15','14:55:00',4.05),('12664','2013-04-15','15:00:00',4.01),('12664','2013-04-15','15:05:00',3.96),('12664','2013-04-15','15:10:00',3.91),('12664','2013-04-15','15:15:00',3.88),('12664','2013-04-15','15:20:00',3.82),('12664','2013-04-15','15:25:00',3.77),('12664','2013-04-15','15:30:00',3.71),('12664','2013-04-15','15:35:00',3.64),('12664','2013-04-15','15:40:00',3.57),('12664','2013-04-15','15:45:00',3.51),('12664','2013-04-15','15:50:00',3.43),('12664','2013-04-15','15:55:00',3.37),('12664','2013-04-15','16:00:00',3.3),('12664','2013-04-15','16:05:00',3.22),('12664','2013-04-15','16:10:00',3.15),('12664','2013-04-15','16:15:00',3.08),('12664','2013-04-15','16:20:00',3.01),('12664','2013-04-15','16:25:00',2.94),('12664','2013-04-15','16:30:00',2.86),('12664','2013-04-15','16:35:00',2.77),('12664','2013-04-15','16:40:00',2.68),('12664','2013-04-15','16:45:00',2.6),('12664','2013-04-15','16:50:00',2.51),('12664','2013-04-15','16:55:00',2.42),('12664','2013-04-15','17:00:00',2.33),('12664','2013-04-15','17:05:00',2.24),('12664','2013-04-15','17:10:00',2.15),('12664','2013-04-15','17:15:00',2.05),('12664','2013-04-15','17:20:00',1.96),('12664','2013-04-15','17:25:00',1.86),('12664','2013-04-15','17:30:00',1.76),('12664','2013-04-15','17:35:00',1.66),('12664','2013-04-15','17:40:00',1.56),('12664','2013-04-15','17:45:00',1.46),('12664','2013-04-15','17:50:00',1.36),('12664','2013-04-15','17:55:00',1.25),('12664','2013-04-15','18:00:00',1.15),('12664','2013-04-15','18:05:00',1.06),('12664','2013-04-14','08:00:00',1.01),('12664','2013-04-14','08:05:00',1.12),('12664','2013-04-14','08:10:00',1.23),('12664','2013-04-14','08:15:00',1.32),('12664','2013-04-14','08:20:00',1.41),('12664','2013-04-14','08:25:00',1.5),('12664','2013-04-14','08:30:00',1.6),('12664','2013-04-14','08:35:00',1.68),('12664','2013-04-14','08:40:00',1.77),('12664','2013-04-14','08:45:00',1.85),('12664','2013-04-14','08:50:00',1.95),('12664','2013-04-14','08:55:00',2.04),('12664','2013-04-14','09:00:00',2.13),('12664','2013-04-14','09:05:00',2.23),('12664','2013-04-14','09:10:00',2.33),('12664','2013-04-14','09:15:00',2.41),('12664','2013-04-14','09:20:00',2.51),('12664','2013-04-14','09:25:00',2.58),('12664','2013-04-14','09:30:00',2.67),('12664','2013-04-14','09:35:00',2.75),('12664','2013-04-14','09:40:00',2.82),('12664','2013-04-14','09:45:00',2.91),('12664','2013-04-14','09:50:00',2.99),('12664','2013-04-14','09:55:00',3.05),('12664','2013-04-14','10:00:00',3.12),('12664','2013-04-14','10:05:00',3.19),('12664','2013-04-14','10:10:00',3.26),('12664','2013-04-14','10:15:00',3.33),('12664','2013-04-14','10:20:00',3.38),('12664','2013-04-14','10:25:00',3.44),('12664','2013-04-14','10:30:00',3.5),('12664','2013-04-14','10:35:00',3.56),('12664','2013-04-14','10:40:00',3.6),('12664','2013-04-14','10:45:00',3.67),('12664','2013-04-14','10:50:00',3.7),('12664','2013-04-14','10:55:00',3.76),('12664','2013-04-14','11:00:00',3.81),('12664','2013-04-14','11:05:00',3.85),('12664','2013-04-14','11:10:00',3.88),('12664','2013-04-14','11:15:00',3.92),('12664','2013-04-14','11:20:00',3.96),('12664','2013-04-14','11:25:00',4),('12664','2013-04-14','11:30:00',4.03),('12664','2013-04-14','11:35:00',4.04),('12664','2013-04-14','11:40:00',4.08),('12664','2013-04-14','11:45:00',4.11),('12664','2013-04-14','11:50:00',4.15),('12664','2013-04-14','11:55:00',4.16),('12664','2013-04-14','12:00:00',4.18),('12664','2013-04-14','12:05:00',4.19),('12664','2013-04-14','12:10:00',4.16),('12664','2013-04-14','12:15:00',4.21),('12664','2013-04-14','12:20:00',4.24),('12664','2013-04-14','12:25:00',4.24),('12664','2013-04-14','12:30:00',4.22),('12664','2013-04-14','12:35:00',4.26),('12664','2013-04-14','12:40:00',4.26),('12664','2013-04-14','12:45:00',4.27),('12664','2013-04-14','12:50:00',4.21),('12664','2013-04-14','12:55:00',4.23),('12664','2013-04-14','13:00:00',4.29),('12664','2013-04-14','13:05:00',4.3),('12664','2013-04-14','13:10:00',4.19),('12664','2013-04-14','13:15:00',4.33),('12664','2013-04-14','13:20:00',4.31),('12664','2013-04-14','13:25:00',4.34),('12664','2013-04-14','13:30:00',4.34),('12664','2013-04-14','13:35:00',4.35),('12664','2013-04-14','13:40:00',4.42),('12664','2013-04-14','13:45:00',4.49),('12664','2013-04-14','13:50:00',4.44),('12664','2013-04-14','13:55:00',4.25),('12664','2013-04-14','14:00:00',4.25),('12664','2013-04-14','14:05:00',4.28),('12664','2013-04-14','14:10:00',4.13),('12664','2013-04-14','14:15:00',4.05),('12664','2013-04-14','14:20:00',4.19),('12664','2013-04-14','14:25:00',4.13),('12664','2013-04-14','14:30:00',4.09),('12664','2013-04-14','14:35:00',4.1),('12664','2013-04-14','14:40:00',4.06),('12664','2013-04-14','14:45:00',3.99),('12664','2013-04-14','14:50:00',3.93),('12664','2013-04-14','14:55:00',3.92),('12664','2013-04-14','15:00:00',3.89),('12664','2013-04-14','15:05:00',3.89),('12664','2013-04-14','15:10:00',3.8),('12664','2013-04-14','15:15:00',3.78),('12664','2013-04-14','15:20:00',3.7),('12664','2013-04-14','15:25:00',3.64),('12664','2013-04-14','15:30:00',3.57),('12664','2013-04-14','15:35:00',3.52),('12664','2013-04-14','15:40:00',3.48),('12664','2013-04-14','15:45:00',3.4),('12664','2013-04-14','15:50:00',3.36),('12664','2013-04-14','15:55:00',3.26),('12664','2013-04-14','16:00:00',3.18),('12664','2013-04-14','16:05:00',3.1),('12664','2013-04-14','16:10:00',3.04),('12664','2013-04-14','16:15:00',2.96),('12664','2013-04-14','16:20:00',2.89),('12664','2013-04-14','16:25:00',2.8),('12664','2013-04-14','16:30:00',2.74),('12664','2013-04-14','16:35:00',2.7),('12664','2013-04-14','16:40:00',2.58),('12664','2013-04-14','16:45:00',2.5),('12664','2013-04-14','16:50:00',2.4),('12664','2013-04-14','16:55:00',2.33),('12664','2013-04-14','17:00:00',2.23),('12664','2013-04-14','17:05:00',2.14),('12664','2013-04-14','17:10:00',2.06),('12664','2013-04-14','17:15:00',1.97),('12664','2013-04-14','17:20:00',1.87),('12664','2013-04-14','17:25:00',1.78),('12664','2013-04-14','17:30:00',1.69),('12664','2013-04-14','17:35:00',1.58),('12664','2013-04-14','17:40:00',1.5),('12664','2013-04-14','17:45:00',1.4),('12664','2013-04-14','17:50:00',1.3),('12664','2013-04-14','17:55:00',1.21),('12664','2013-04-14','18:00:00',1.11),('12664','2013-04-14','18:05:00',1.02),('12664','2013-04-13','08:40:00',1.74),('12664','2013-04-13','08:45:00',1.89),('12664','2013-04-13','08:50:00',1.98),('12664','2013-04-13','08:55:00',2.1),('12664','2013-04-13','09:00:00',2.14),('12664','2013-04-13','09:05:00',2.27),('12664','2013-04-13','09:10:00',2.36),('12664','2013-04-13','09:15:00',2.43),('12664','2013-04-13','09:20:00',2.61),('12664','2013-04-13','09:25:00',2.91),('12664','2013-04-13','09:30:00',2.06),('12664','2013-04-13','09:35:00',2.89),('12664','2013-04-13','09:40:00',3.1),('12664','2013-04-13','09:45:00',2.91),('12664','2013-04-13','09:50:00',3.44),('12664','2013-04-13','09:55:00',3),('12664','2013-04-13','10:00:00',1.82),('12664','2013-04-13','10:05:00',1.09),('12664','2013-04-13','10:10:00',2.18),('12664','2013-04-13','10:15:00',2.1),('12664','2013-04-13','10:20:00',3.98),('12664','2013-04-13','10:25:00',3.46),('12664','2013-04-13','10:30:00',2.14),('12664','2013-04-13','10:35:00',3.71),('12664','2013-04-13','10:40:00',3.76),('12664','2013-04-13','10:45:00',2.86),('12664','2013-04-13','10:50:00',1.88),('12664','2013-04-13','10:55:00',3.58),('12664','2013-04-13','11:00:00',2.58),('12664','2013-04-13','11:05:00',1.51),('12664','2013-04-13','11:10:00',3.92),('12664','2013-04-13','11:15:00',4.28),('12664','2013-04-13','11:20:00',4.18),('12664','2013-04-13','11:25:00',1.87),('12664','2013-04-13','11:30:00',2.72),('12664','2013-04-13','11:35:00',4.57),('12664','2013-04-13','11:40:00',3.88),('12664','2013-04-13','11:45:00',3.95),('12664','2013-04-13','11:50:00',2.61),('12664','2013-04-13','11:55:00',4.51),('12664','2013-04-13','12:00:00',4.77),('12664','2013-04-13','12:05:00',4.11),('12664','2013-04-13','12:10:00',4.59),('12664','2013-04-13','12:15:00',4.68),('12664','2013-04-13','12:20:00',4.09),('12664','2013-04-13','12:25:00',4.77),('12664','2013-04-13','12:30:00',4.12),('12664','2013-04-13','12:35:00',4.7),('12664','2013-04-13','12:40:00',4.59),('12664','2013-04-13','12:45:00',4.48),('12664','2013-04-13','12:50:00',4.51),('12664','2013-04-13','12:55:00',4.5),('12664','2013-04-13','13:00:00',4.43),('12664','2013-04-13','13:05:00',4.31),('12664','2013-04-13','13:10:00',4.35),('12664','2013-04-13','13:15:00',4.16),('12664','2013-04-13','13:20:00',4.28),('12664','2013-04-13','13:25:00',4.24),('12664','2013-04-13','13:30:00',3.95),('12664','2013-04-13','13:35:00',4.03),('12664','2013-04-13','13:40:00',3.8),('12664','2013-04-13','13:45:00',3.85),('12664','2013-04-13','13:50:00',3.64),('12664','2013-04-13','13:55:00',3.7),('12664','2013-04-13','14:00:00',3.71),('12664','2013-04-13','14:05:00',3.7),('12664','2013-04-13','14:10:00',3.63),('12664','2013-04-13','14:15:00',3.62),('12664','2013-04-13','14:20:00',3.65),('12664','2013-04-13','14:25:00',3.85),('12664','2013-04-13','14:30:00',4.06),('12664','2013-04-13','14:35:00',4),('12664','2013-04-13','14:40:00',3.91),('12664','2013-04-13','14:45:00',3.82),('12664','2013-04-13','14:50:00',3.68),('12664','2013-04-13','14:55:00',3.45),('12664','2013-04-13','15:00:00',3.43),('12664','2013-04-13','15:05:00',3.44),('12664','2013-04-13','15:10:00',3.25),('12664','2013-04-13','15:15:00',2.95),('12664','2013-04-13','15:20:00',2.95),('12664','2013-04-13','15:25:00',2.97),('12664','2013-04-13','15:30:00',2.87),('12664','2013-04-13','15:35:00',3.05),('12664','2013-04-13','15:40:00',3),('12664','2013-04-13','15:45:00',3.07),('12664','2013-04-13','15:50:00',3.11),('12664','2013-04-13','15:55:00',2.54),('12664','2013-04-13','16:00:00',2.61),('12664','2013-04-13','16:05:00',2.62),('12664','2013-04-13','16:10:00',2.64),('12664','2013-04-13','16:15:00',2.52),('12664','2013-04-13','16:20:00',2.26),('12664','2013-04-13','16:25:00',2.09),('12664','2013-04-13','16:30:00',2.07),('12664','2013-04-13','16:35:00',1.81),('12664','2013-04-13','16:40:00',1.82),('12664','2013-04-13','16:45:00',1.91),('12664','2013-04-13','16:50:00',1.63),('12664','2013-04-13','16:55:00',1.36),('12664','2013-04-13','17:00:00',1.84),('12664','2013-04-13','17:05:00',2.32),('12664','2013-04-13','17:10:00',2.13),('12664','2013-04-13','17:15:00',1.81),('12664','2013-04-13','17:20:00',1.92),('12664','2013-04-13','17:25:00',1.85),('12664','2013-04-13','17:30:00',1.64),('12664','2013-04-13','17:35:00',1.67),('12664','2013-04-13','17:40:00',1.57),('12664','2013-04-13','17:45:00',1.32),('12664','2013-04-13','17:50:00',1.25),('12664','2013-04-13','17:55:00',1.1),('12664','2013-04-13','18:05:00',1),('12664','2013-04-12','08:21:00',1.42),('12664','2013-04-12','08:25:00',1.05),('12664','2013-04-12','08:40:00',2.01),('12664','2013-04-12','08:50:00',1.03),('12664','2013-04-12','08:55:00',1.06),('12664','2013-04-12','09:00:00',1.17),('12664','2013-04-12','09:05:00',1.18),('12664','2013-04-12','09:10:00',1.16),('12664','2013-04-12','09:15:00',1.11),('12664','2013-04-12','09:25:00',1.36),('12664','2013-04-12','09:30:00',1.34),('12664','2013-04-12','09:35:00',1.11),('12664','2013-04-12','09:40:00',1.4),('12664','2013-04-12','09:45:00',1.45),('12664','2013-04-12','10:00:00',1.05),('12664','2013-04-12','10:05:00',1.19),('12664','2013-04-12','10:10:00',1.25),('12664','2013-04-12','10:15:00',1.15),('12664','2013-04-12','10:30:00',1.05),('12664','2013-04-12','10:35:00',1.13),('12664','2013-04-12','10:40:00',1.23),('12664','2013-04-12','10:45:00',1.32),('12664','2013-04-12','10:50:00',1.63),('12664','2013-04-12','10:55:00',1.85),('12664','2013-04-12','11:00:00',2.41),('12664','2013-04-12','11:05:00',3.67),('12664','2013-04-12','11:10:00',2.77),('12664','2013-04-12','11:15:00',2.46),('12664','2013-04-12','11:20:00',4.61),('12664','2013-04-12','11:25:00',4.53),('12664','2013-04-12','11:30:00',4.44),('12664','2013-04-12','11:35:00',4.38),('12664','2013-04-12','11:40:00',4.56),('12664','2013-04-12','11:45:00',4.54),('12664','2013-04-12','11:50:00',4.51),('12664','2013-04-12','11:55:00',4.19),('12664','2013-04-12','12:00:00',4.35),('12664','2013-04-12','12:05:00',4.11),('12664','2013-04-12','12:10:00',4.54),('12664','2013-04-12','12:15:00',4.08),('12664','2013-04-12','12:20:00',4.54),('12664','2013-04-12','12:25:00',4.63),('12664','2013-04-12','12:30:00',4.58),('12664','2013-04-12','12:35:00',4.66),('12664','2013-04-12','12:40:00',4.52),('12664','2013-04-12','12:45:00',4.26),('12664','2013-04-12','12:50:00',4.47),('12664','2013-04-12','12:55:00',4.87),('12664','2013-04-12','13:00:00',4.78),('12664','2013-04-12','13:05:00',4.63),('12664','2013-04-12','13:10:00',4.54),('12664','2013-04-12','13:15:00',4.23),('12664','2013-04-12','13:20:00',4.47),('12664','2013-04-12','13:25:00',4.49),('12664','2013-04-12','13:30:00',4.47),('12664','2013-04-12','13:35:00',4.44),('12664','2013-04-12','13:40:00',4.49),('12664','2013-04-12','13:45:00',4.47),('12664','2013-04-12','13:50:00',4.47),('12664','2013-04-12','13:55:00',4.43),('12664','2013-04-12','14:00:00',4.28),('12664','2013-04-12','14:05:00',4.36),('12664','2013-04-12','14:10:00',4.33),('12664','2013-04-12','14:15:00',4.31),('12664','2013-04-12','14:20:00',4.25),('12664','2013-04-12','14:25:00',4.24),('12664','2013-04-12','14:30:00',4.21),('12664','2013-04-12','14:35:00',3.73),('12664','2013-04-12','14:40:00',4.1),('12664','2013-04-12','14:45:00',4.09),('12664','2013-04-12','14:50:00',4.07),('12664','2013-04-12','14:55:00',4.02),('12664','2013-04-12','15:00:00',3.96),('12664','2013-04-12','15:05:00',3.91),('12664','2013-04-12','15:10:00',3.88),('12664','2013-04-12','15:15:00',3.83),('12664','2013-04-12','15:20:00',3.79),('12664','2013-04-12','15:25:00',3.71),('12664','2013-04-12','15:30:00',3.65),('12664','2013-04-12','15:35:00',3.57),('12664','2013-04-12','15:40:00',3.51),('12664','2013-04-12','15:45:00',3.44),('12664','2013-04-12','15:50:00',3.42),('12664','2013-04-12','15:55:00',3.32),('12664','2013-04-12','16:00:00',3.27),('12664','2013-04-12','16:05:00',3.22),('12664','2013-04-12','16:10:00',2.74),('12664','2013-04-12','16:15:00',3.13),('12664','2013-04-12','16:20:00',2.98),('12664','2013-04-12','16:25:00',2.48),('12664','2013-04-12','16:30:00',2.83),('12664','2013-04-12','16:35:00',2.3),('12664','2013-04-12','16:40:00',2.11),('12664','2013-04-12','16:45:00',2.63),('12664','2013-04-12','16:50:00',2.5),('12664','2013-04-12','16:55:00',2.52),('12664','2013-04-12','17:00:00',2.56),('12664','2013-04-12','17:05:00',2.32),('12664','2013-04-12','17:10:00',2.27),('12664','2013-04-12','17:15:00',2.05),('12664','2013-04-12','17:20:00',1.92),('12664','2013-04-12','17:25:00',1.82),('12664','2013-04-12','17:30:00',1.53),('12664','2013-04-12','17:35:00',1.34),('12664','2013-04-12','17:40:00',1.47),('12664','2013-04-12','17:45:00',1.4),('12664','2013-04-12','17:50:00',1.31),('12664','2013-04-12','17:55:00',1.22),('12664','2013-04-12','18:00:00',1.17),('12664','2013-04-12','18:05:00',1.26),('12664','2013-04-12','18:10:00',1.23),('12664','2013-04-11','08:05:00',1.09),('12664','2013-04-11','08:10:00',1.19),('12664','2013-04-11','08:15:00',1.28),('12664','2013-04-11','08:20:00',1.37),('12664','2013-04-11','08:25:00',1.46),('12664','2013-04-11','08:30:00',1.56),('12664','2013-04-11','08:35:00',1.66),('12664','2013-04-11','08:40:00',1.76),('12664','2013-04-11','08:45:00',1.86),('12664','2013-04-11','08:50:00',1.97),('12664','2013-04-11','08:55:00',2.07),('12664','2013-04-11','09:00:00',2.16),('12664','2013-04-11','09:05:00',2.24),('12664','2013-04-11','09:10:00',2.34),('12664','2013-04-11','09:15:00',2.43),('12664','2013-04-11','09:20:00',2.5),('12664','2013-04-11','09:25:00',2.52),('12664','2013-04-11','09:30:00',2.64),('12664','2013-04-11','09:35:00',2.67),('12664','2013-04-11','09:40:00',3.12),('12664','2013-04-11','09:45:00',3.22),('12664','2013-04-11','09:50:00',3.34),('12664','2013-04-11','09:55:00',3.59),('12664','2013-04-11','10:00:00',3.08),('12664','2013-04-11','10:05:00',1.49),('12664','2013-04-11','10:15:00',3.59),('12664','2013-04-11','10:20:00',3.55),('12664','2013-04-11','10:25:00',3.33),('12664','2013-04-11','10:30:00',1.17),('12664','2013-04-11','10:35:00',1.09),('12664','2013-04-11','10:40:00',1.64),('12664','2013-04-11','10:45:00',1.93),('12664','2013-04-11','10:50:00',4),('12664','2013-04-11','10:55:00',4.17),('12664','2013-04-11','11:00:00',4.26),('12664','2013-04-11','11:05:00',4.08),('12664','2013-04-11','11:10:00',1.43),('12664','2013-04-11','11:15:00',1.86),('12664','2013-04-11','11:20:00',1.56),('12664','2013-04-11','11:25:00',1.47),('12664','2013-04-11','11:30:00',1.56),('12664','2013-04-11','11:35:00',3.34),('12664','2013-04-11','11:40:00',4.31),('12664','2013-04-11','11:45:00',4.81),('12664','2013-04-11','11:50:00',4.71),('12664','2013-04-11','11:55:00',4.63),('12664','2013-04-11','12:00:00',4.66),('12664','2013-04-11','12:05:00',4.81),('12664','2013-04-11','12:10:00',4.08),('12664','2013-04-11','12:15:00',4.33),('12664','2013-04-11','12:20:00',4.81),('12664','2013-04-11','12:25:00',4.75),('12664','2013-04-11','12:30:00',3.98),('12664','2013-04-11','12:35:00',3.37),('12664','2013-04-11','12:40:00',4.8),('12664','2013-04-11','12:45:00',4.74),('12664','2013-04-11','12:50:00',2.53),('12664','2013-04-11','12:55:00',2.01),('12664','2013-04-11','13:00:00',3.18),('12664','2013-04-11','13:05:00',3.15),('12664','2013-04-11','13:10:00',4.6),('12664','2013-04-11','13:15:00',4.82),('12664','2013-04-11','13:20:00',2.96),('12664','2013-04-11','13:25:00',3.61),('12664','2013-04-11','13:30:00',4.74),('12664','2013-04-11','13:35:00',4.65),('12664','2013-04-11','13:40:00',3.88),('12664','2013-04-11','13:45:00',3.05),('12664','2013-04-11','13:50:00',2.01),('12664','2013-04-11','13:55:00',4.74),('12664','2013-04-11','14:00:00',3.21),('12664','2013-04-11','14:05:00',1.59),('12664','2013-04-11','14:10:00',4.43),('12664','2013-04-11','14:15:00',3.62),('12664','2013-04-11','14:20:00',3.6),('12664','2013-04-11','14:25:00',3.76),('12664','2013-04-11','14:30:00',3.76),('12664','2013-04-11','14:35:00',3.29),('12664','2013-04-11','14:40:00',3.74),('12664','2013-04-11','14:45:00',3.41),('12664','2013-04-11','14:50:00',3.4),('12664','2013-04-11','14:55:00',4.25),('12664','2013-04-11','15:00:00',4.06),('12664','2013-04-11','15:05:00',4.01),('12664','2013-04-11','15:10:00',3.99),('12664','2013-04-11','15:15:00',3.88),('12664','2013-04-11','15:20:00',3.82),('12664','2013-04-11','15:25:00',3.79),('12664','2013-04-11','15:30:00',3.71),('12664','2013-04-11','15:35:00',3.66),('12664','2013-04-11','15:40:00',3.6),('12664','2013-04-11','15:45:00',3.53),('12664','2013-04-11','15:50:00',3.47),('12664','2013-04-11','15:55:00',3.41),('12664','2013-04-11','16:00:00',3.33),('12664','2013-04-11','16:05:00',3.26),('12664','2013-04-11','16:10:00',3.21),('12664','2013-04-11','16:15:00',3.12),('12664','2013-04-11','16:20:00',3.03),('12664','2013-04-11','16:25:00',2.96),('12664','2013-04-11','16:30:00',2.88),('12664','2013-04-11','16:35:00',2.79),('12664','2013-04-11','16:40:00',2.72),('12664','2013-04-11','16:45:00',2.62),('12664','2013-04-11','16:50:00',2.52),('12664','2013-04-11','16:55:00',2.44),('12664','2013-04-11','17:00:00',2.34),('12664','2013-04-11','17:05:00',2.26),('12664','2013-04-11','17:10:00',2.16),('12664','2013-04-11','17:15:00',2.06),('12664','2013-04-11','17:20:00',1.97),('12664','2013-04-11','17:25:00',1.88),('12664','2013-04-11','17:30:00',1.77),('12664','2013-04-11','17:35:00',1.67),('12664','2013-04-11','17:40:00',1.57),('12664','2013-04-11','17:45:00',1.47),('12664','2013-04-11','17:50:00',1.36),('12664','2013-04-11','17:55:00',1.24),('12664','2013-04-11','18:00:00',1.07),('12664','2013-04-11','18:05:00',1),('12664','2014-03-27','09:25:00',1.08),('12664','2014-03-27','09:30:00',1.02),('12664','2014-03-27','10:05:00',1.19),('12664','2014-03-27','10:10:00',1.37),('12664','2014-03-27','10:15:00',1.31),('12664','2014-03-27','10:20:00',1.31),('12664','2014-03-27','10:25:00',1.49),('12664','2014-03-27','10:30:00',1.49),('12664','2014-03-27','10:35:00',1.63),('12664','2014-03-27','10:40:00',1.88),('12664','2014-03-27','10:45:00',2.01),('12664','2014-03-27','10:50:00',2.15),('12664','2014-03-27','10:55:00',2.07),('12664','2014-03-27','11:00:00',4.25),('12664','2014-03-27','11:05:00',2.4),('12664','2014-03-27','11:10:00',1.59),('12664','2014-03-27','11:15:00',1.43),('12664','2014-03-27','11:20:00',1.59),('12664','2014-03-27','11:25:00',1.12),('12664','2014-03-27','11:45:00',1.32),('12664','2014-03-27','11:50:00',1.49),('12664','2014-03-27','12:50:00',1.17),('12664','2014-03-27','12:55:00',1.35),('12664','2014-03-27','13:00:00',1.34),('12664','2014-03-27','13:05:00',1.7),('12664','2014-03-27','13:10:00',2.48),('12664','2014-03-27','13:15:00',2.89),('12664','2014-03-27','13:20:00',3.02),('12664','2014-03-27','13:25:00',3.42),('12664','2014-03-27','13:30:00',2.95),('12664','2014-03-27','13:35:00',2.5),('12664','2014-03-27','13:40:00',2.28),('12664','2014-03-27','13:45:00',2.07),('12664','2014-03-27','13:50:00',1.77),('12664','2014-03-27','13:55:00',1.08),('12664','2014-03-27','14:05:00',2.31),('12664','2014-03-27','14:10:00',1.91),('12664','2014-03-27','14:20:00',1.39),('12664','2014-03-27','14:25:00',1.67),('12664','2014-03-27','14:30:00',1.03),('12664','2014-03-27','15:40:00',2.38),('12664','2014-03-27','15:45:00',1.88),('12664','2014-03-27','15:50:00',1.53),('12664','2014-03-27','15:55:00',1.58),('12664','2014-03-27','16:20:00',1.16),('12664','2014-03-27','16:25:00',1.12),('12664','2013-04-10','08:45:00',1.46),('12664','2013-04-10','08:50:00',1.6),('12664','2013-04-10','08:55:00',1.85),('12664','2013-04-10','09:00:00',1.48),('12664','2013-04-10','09:05:00',2.15),('12664','2013-04-10','09:10:00',2.43),('12664','2013-04-10','09:15:00',2.54),('12664','2013-04-10','09:20:00',2.55),('12664','2013-04-10','09:25:00',2.56),('12664','2013-04-10','09:30:00',2.74),('12664','2013-04-10','09:35:00',2.86),('12664','2013-04-10','09:40:00',2.98),('12664','2013-04-10','09:45:00',2.68),('12664','2013-04-10','09:50:00',2.49),('12664','2013-04-10','09:55:00',3.27),('12664','2013-04-10','10:00:00',1.77),('12664','2013-04-10','10:10:00',1.48),('12664','2013-04-10','10:15:00',3.13),('12664','2013-04-10','10:20:00',2.26),('12664','2013-04-10','10:25:00',2.64),('12664','2013-04-10','10:30:00',2.1),('12664','2013-04-10','10:35:00',1.65),('12664','2013-04-10','10:40:00',1.51),('12664','2013-04-10','10:45:00',2.49),('12664','2013-04-10','10:50:00',1.01),('12664','2013-04-10','10:55:00',3.07),('12664','2013-04-10','11:00:00',4.22),('12664','2013-04-10','11:05:00',2.86),('12664','2013-04-10','11:10:00',3.17),('12664','2013-04-10','11:15:00',3.2),('12664','2013-04-10','11:20:00',4.06),('12664','2013-04-10','11:25:00',4.57),('12664','2013-04-10','11:30:00',4.19),('12664','2013-04-10','11:35:00',4.54),('12664','2013-04-10','11:40:00',4.57),('12664','2013-04-10','11:45:00',4.5),('12664','2013-04-10','11:50:00',4.53),('12664','2013-04-10','11:55:00',4.79),('12664','2013-04-10','12:00:00',4.08),('12664','2013-04-10','12:05:00',4.04),('12664','2013-04-10','12:10:00',3.57),('12664','2013-04-10','12:15:00',5.04),('12664','2013-04-10','12:20:00',3.74),('12664','2013-04-10','12:25:00',4.94),('12664','2013-04-10','12:30:00',4.78),('12664','2013-04-10','12:35:00',3.2),('12664','2013-04-10','12:40:00',4.85),('12664','2013-04-10','12:45:00',4.71),('12664','2013-04-10','12:50:00',3.29),('12664','2013-04-10','12:55:00',4.83),('12664','2013-04-10','13:00:00',3.75),('12664','2013-04-10','13:05:00',4.91),('12664','2013-04-10','13:10:00',4.75),('12664','2013-04-10','13:15:00',4.3),('12664','2013-04-10','13:20:00',4.19),('12664','2013-04-10','13:25:00',4.41),('12664','2013-04-10','13:30:00',4.55),('12664','2013-04-10','13:35:00',4.42),('12664','2013-04-10','13:40:00',4.45),('12664','2013-04-10','13:45:00',4.82),('12664','2013-04-10','13:50:00',4.95),('12664','2013-04-10','13:55:00',2.28),('12664','2013-04-10','14:00:00',3.62),('12664','2013-04-10','14:05:00',2.36),('12664','2013-04-10','14:10:00',4.23),('12664','2013-04-10','14:15:00',4.72),('12664','2013-04-10','14:20:00',4.64),('12664','2013-04-10','14:25:00',4.65),('12664','2013-04-10','14:30:00',4.28),('12664','2013-04-10','14:35:00',3.65),('12664','2013-04-10','14:40:00',2.42),('12664','2013-04-10','14:45:00',4.15),('12664','2013-04-10','14:50:00',4.53),('12664','2013-04-10','14:55:00',4.12),('12664','2013-04-10','15:00:00',4.15),('12664','2013-04-10','15:05:00',4.19),('12664','2013-04-10','15:10:00',3.73),('12664','2013-04-10','15:15:00',3.49),('12664','2013-04-10','15:20:00',4.03),('12664','2013-04-10','15:25:00',3.82),('12664','2013-04-10','15:30:00',3.8),('12664','2013-04-10','15:35:00',3.72),('12664','2013-04-10','15:40:00',3.36),('12664','2013-04-10','15:45:00',3.81),('12664','2013-04-10','15:50:00',3.63),('12664','2013-04-10','15:55:00',2.96),('12664','2013-04-10','16:00:00',2.48),('12664','2013-04-10','16:05:00',1.26),('12664','2013-04-10','16:10:00',2.94),('12664','2013-04-10','16:15:00',2.58),('12664','2013-04-10','16:20:00',2.5),('12664','2013-04-10','16:25:00',3.16),('12664','2013-04-10','16:30:00',1.16),('12664','2013-04-10','16:35:00',1.42),('12664','2013-04-10','16:40:00',1.17),('12664','2013-04-10','16:45:00',1.28),('12664','2013-04-10','16:50:00',1.24),('12664','2013-04-10','16:55:00',1.61),('12664','2013-04-10','17:00:00',2.4),('12664','2013-04-10','17:05:00',2.65),('12664','2013-04-10','17:10:00',2.72),('12664','2013-04-10','17:15:00',2.5),('12664','2013-04-10','17:20:00',2.29),('12664','2013-04-10','17:25:00',2.09),('12664','2013-04-10','17:30:00',1.8),('12664','2013-04-10','17:35:00',1.73),('12664','2013-04-10','17:40:00',1.25),('12664','2013-04-10','17:45:00',1.78),('12664','2013-04-10','17:50:00',1.8),('12664','2013-04-10','17:55:00',1.75),('12664','2013-04-10','18:00:00',1.67),('12664','2013-04-10','18:05:00',1.49),('12664','2013-04-10','18:10:00',1.43),('12664','2013-04-10','18:15:00',1.29),('12664','2013-04-10','18:20:00',1.4),('12664','2013-04-10','18:25:00',1.18),('12664','2013-04-09','08:05:00',1.04),('12664','2013-04-09','08:10:00',1.2),('12664','2013-04-09','08:15:00',1.56),('12664','2013-04-09','08:20:00',1.14),('12664','2013-04-09','08:25:00',1.04),('12664','2013-04-09','08:30:00',1.06),('12664','2013-04-09','08:35:00',1.09),('12664','2013-04-09','08:40:00',1.46),('12664','2013-04-09','08:45:00',1.65),('12664','2013-04-09','08:50:00',1.88),('12664','2013-04-09','08:55:00',1.68),('12664','2013-04-09','09:00:00',1.82),('12664','2013-04-09','09:05:00',1.17),('12664','2013-04-09','09:10:00',1.14),('12664','2013-04-09','09:15:00',1.55),('12664','2013-04-09','09:20:00',1.36),('12664','2013-04-09','09:25:00',1.7),('12664','2013-04-09','09:30:00',2.1),('12664','2013-04-09','09:35:00',1.63),('12664','2013-04-09','09:40:00',1.44),('12664','2013-04-09','09:45:00',1.88),('12664','2013-04-09','09:50:00',2.23),('12664','2013-04-09','09:55:00',3.84),('12664','2013-04-09','10:00:00',2),('12664','2013-04-09','10:05:00',2.55),('12664','2013-04-09','10:10:00',2.88),('12664','2013-04-09','10:15:00',3.48),('12664','2013-04-09','10:20:00',1.92),('12664','2013-04-09','10:25:00',3.74),('12664','2013-04-09','10:30:00',4.13),('12664','2013-04-09','10:35:00',3.73),('12664','2013-04-09','10:40:00',1.21),('12664','2013-04-09','10:45:00',4.31),('12664','2013-04-09','10:50:00',4.25),('12664','2013-04-09','10:55:00',2.73),('12664','2013-04-09','11:00:00',3.81),('12664','2013-04-09','11:05:00',2.86),('12664','2013-04-09','11:10:00',4.53),('12664','2013-04-09','11:15:00',4.44),('12664','2013-04-09','11:20:00',1.98),('12664','2013-04-09','11:25:00',4.32),('12664','2013-04-09','11:30:00',1.65),('12664','2013-04-09','11:35:00',1.43),('12664','2013-04-09','11:40:00',1.05),('12664','2013-04-09','11:45:00',1.24),('12664','2013-04-09','11:50:00',2.75),('12664','2013-04-09','11:55:00',5.02),('12664','2013-04-09','12:00:00',4.99),('12664','2013-04-09','12:05:00',4.92),('12664','2013-04-09','12:10:00',4.02),('12664','2013-04-09','12:15:00',2.82),('12664','2013-04-09','12:20:00',3.72),('12664','2013-04-09','12:25:00',2.37),('12664','2013-04-09','12:30:00',3.92),('12664','2013-04-09','12:35:00',1.32),('12664','2013-04-09','12:40:00',2.73),('12664','2013-04-09','12:45:00',3.16),('12664','2013-04-09','12:50:00',3.41),('12664','2013-04-09','12:55:00',3.64),('12664','2013-04-09','13:00:00',2.57),('12664','2013-04-09','13:05:00',2.16),('12664','2013-04-09','13:10:00',4.84),('12664','2013-04-09','13:15:00',3.98),('12664','2013-04-09','13:20:00',4.42),('12664','2013-04-09','13:25:00',2.62),('12664','2013-04-09','13:30:00',3),('12664','2013-04-09','13:35:00',2.88),('12664','2013-04-09','13:40:00',3.99),('12664','2013-04-09','13:45:00',4.8),('12664','2013-04-09','13:50:00',4.51),('12664','2013-04-09','13:55:00',4.24),('12664','2013-04-09','14:00:00',4.44),('12664','2013-04-09','14:05:00',4.39),('12664','2013-04-09','14:10:00',4.21),('12664','2013-04-09','14:15:00',1.98),('12664','2013-04-09','14:20:00',3.66),('12664','2013-04-09','14:25:00',3.87),('12664','2013-04-09','14:30:00',3.8),('12664','2013-04-09','14:35:00',4.25),('12664','2013-04-09','14:40:00',3.87),('12664','2013-04-09','14:45:00',3.57),('12664','2013-04-09','14:50:00',4.2),('12664','2013-04-09','14:55:00',4.12),('12664','2013-04-09','15:00:00',4.21),('12664','2013-04-09','15:05:00',4.03),('12664','2013-04-09','15:10:00',3.87),('12664','2013-04-09','15:15:00',3.92),('12664','2013-04-09','15:20:00',3.98),('12664','2013-04-09','15:25:00',3.95),('12664','2013-04-09','15:30:00',3.9),('12664','2013-04-09','15:35:00',3.65),('12664','2013-04-09','15:40:00',3.78),('12664','2013-04-09','15:45:00',3.63),('12664','2013-04-09','15:50:00',3.28),('12664','2013-04-09','15:55:00',2.95),('12664','2013-04-09','16:00:00',3.19),('12664','2013-04-09','16:05:00',3.45),('12664','2013-04-09','16:10:00',3.16),('12664','2013-04-09','16:15:00',3),('12664','2013-04-09','16:20:00',3.1),('12664','2013-04-09','16:25:00',2.92),('12664','2013-04-09','16:30:00',2.5),('12664','2013-04-09','16:35:00',2.62),('12664','2013-04-09','16:40:00',2.39),('12664','2013-04-09','16:45:00',2.74),('12664','2013-04-09','16:50:00',2.65),('12664','2013-04-09','16:55:00',2.21),('12664','2013-04-09','17:00:00',2.71),('12664','2013-04-09','17:05:00',2.44),('12664','2013-04-09','17:10:00',2.35),('12664','2013-04-09','17:15:00',2.23),('12664','2013-04-09','17:20:00',2.03),('12664','2013-04-09','17:25:00',1.63),('12664','2013-04-09','17:30:00',1.68),('12664','2013-04-09','17:35:00',1.29),('12664','2013-04-09','17:40:00',1.04),('12664','2013-04-08','08:25:00',1.1),('12664','2013-04-08','08:30:00',1.24),('12664','2013-04-08','08:35:00',1.73),('12664','2013-04-08','08:40:00',1.19),('12664','2013-04-08','08:50:00',1.02),('12664','2013-04-08','08:55:00',1.38),('12664','2013-04-08','09:00:00',2.06),('12664','2013-04-08','09:05:00',2.34),('12664','2013-04-08','09:10:00',2.51),('12664','2013-04-08','09:15:00',2.22),('12664','2013-04-08','09:20:00',2.49),('12664','2013-04-08','09:25:00',2.89),('12664','2013-04-08','09:30:00',2.88),('12664','2013-04-08','09:35:00',3.11),('12664','2013-04-08','09:40:00',3.1),('12664','2013-04-08','09:45:00',2.73),('12664','2013-04-08','09:50:00',1.46),('12664','2013-04-08','09:55:00',2.66),('12664','2013-04-08','10:00:00',3.08),('12664','2013-04-08','10:05:00',2.6),('12664','2013-04-08','10:10:00',3.36),('12664','2013-04-08','10:15:00',3.5),('12664','2013-04-08','10:20:00',3.53),('12664','2013-04-08','10:25:00',3.29),('12664','2013-04-08','10:30:00',3.49),('12664','2013-04-08','10:35:00',3.66),('12664','2013-04-08','10:40:00',3.82),('12664','2013-04-08','10:45:00',3.77),('12664','2013-04-08','10:50:00',3.79),('12664','2013-04-08','10:55:00',3.29),('12664','2013-04-08','11:00:00',3.28),('12664','2013-04-08','11:05:00',2.91),('12664','2013-04-08','11:10:00',2.93),('12664','2013-04-08','11:15:00',2.42),('12664','2013-04-08','11:20:00',2.13),('12664','2013-04-08','11:25:00',2.31),('12664','2013-04-08','11:30:00',2.94),('12664','2013-04-08','11:35:00',2.59),('12664','2013-04-08','11:40:00',2.74),('12664','2013-04-08','11:45:00',2.71),('12664','2013-04-08','11:50:00',2.69),('12664','2013-04-08','11:55:00',2.61),('12664','2013-04-08','12:00:00',2.34),('12664','2013-04-08','12:05:00',2.74),('12664','2013-04-08','12:10:00',3.32),('12664','2013-04-08','12:15:00',3.17),('12664','2013-04-08','12:20:00',3.23),('12664','2013-04-08','12:25:00',3.13),('12664','2013-04-08','12:30:00',3.33),('12664','2013-04-08','12:35:00',3.58),('12664','2013-04-08','12:40:00',3.35),('12664','2013-04-08','12:45:00',3.07),('12664','2013-04-08','12:50:00',3.85),('12664','2013-04-08','12:55:00',3.89),('12664','2013-04-08','13:00:00',3.49),('12664','2013-04-08','13:05:00',3.45),('12664','2013-04-08','13:10:00',3.82),('12664','2013-04-08','13:15:00',3.37),('12664','2013-04-08','13:20:00',3.89),('12664','2013-04-08','13:25:00',3.82),('12664','2013-04-08','13:30:00',2.99),('12664','2013-04-08','13:35:00',2.42),('12664','2013-04-08','13:40:00',4.14),('12664','2013-04-08','13:45:00',4.1),('12664','2013-04-08','13:50:00',3.68),('12664','2013-04-08','13:55:00',3.62),('12664','2013-04-08','14:00:00',3.72),('12664','2013-04-08','14:05:00',4.24),('12664','2013-04-08','14:10:00',3.97),('12664','2013-04-08','14:15:00',3.4),('12664','2013-04-08','14:20:00',3.86),('12664','2013-04-08','14:25:00',3.71),('12664','2013-04-08','14:30:00',3.72),('12664','2013-04-08','14:35:00',3.75),('12664','2013-04-08','14:40:00',4.09),('12664','2013-04-08','14:45:00',3.93),('12664','2013-04-08','14:50:00',4.2),('12664','2013-04-08','14:55:00',3.27),('12664','2013-04-08','15:00:00',3.6),('12664','2013-04-08','15:05:00',3.78),('12664','2013-04-08','15:10:00',3.26),('12664','2013-04-08','15:15:00',3.71),('12664','2013-04-08','15:20:00',3.93),('12664','2013-04-08','15:25:00',3.85),('12664','2013-04-08','15:30:00',3.72),('12664','2013-04-08','15:35:00',3.68),('12664','2013-04-08','15:40:00',3.59),('12664','2013-04-08','15:45:00',3.57),('12664','2013-04-08','15:50:00',3.51),('12664','2013-04-08','15:55:00',3.43),('12664','2013-04-08','16:00:00',3.33),('12664','2013-04-08','16:05:00',3.06),('12664','2013-04-08','16:10:00',3.17),('12664','2013-04-08','16:15:00',3.2),('12664','2013-04-08','16:20:00',3.04),('12664','2013-04-08','16:25:00',2.96),('12664','2013-04-08','16:30:00',2.92),('12664','2013-04-08','16:35:00',2.82),('12664','2013-04-08','16:40:00',2.75),('12664','2013-04-08','16:45:00',2.66),('12664','2013-04-08','16:50:00',2.56),('12664','2013-04-08','16:55:00',2.48),('12664','2013-04-08','17:00:00',2.41),('12664','2013-04-08','17:05:00',2.3),('12664','2013-04-08','17:10:00',2.2),('12664','2013-04-08','17:15:00',2.05),('12664','2013-04-08','17:20:00',2.01),('12664','2013-04-08','17:25:00',1.92),('12664','2013-04-08','17:30:00',1.75),('12664','2013-04-08','17:35:00',1.6),('12664','2013-04-08','17:40:00',1.34),('12664','2013-04-08','17:45:00',1.3),('12664','2013-04-08','17:55:00',1.04),('12664','2013-04-08','18:15:00',1.15),('12664','2013-04-08','18:20:00',1.17),('12664','2013-04-07','08:30:00',1.02),('12664','2013-04-07','08:35:00',1.09),('12664','2013-04-07','08:40:00',1.2),('12664','2013-04-07','08:45:00',1.31),('12664','2013-04-07','08:50:00',1.47),('12664','2013-04-07','08:55:00',1.67),('12664','2013-04-07','09:00:00',1.72),('12664','2013-04-07','09:05:00',1.85),('12664','2013-04-07','09:10:00',1.88),('12664','2013-04-07','09:15:00',1.82),('12664','2013-04-07','09:20:00',1.98),('12664','2013-04-07','09:25:00',1.9),('12664','2013-04-07','09:30:00',1.81),('12664','2013-04-07','09:35:00',1.94),('12664','2013-04-07','09:40:00',2.14),('12664','2013-04-07','09:45:00',2.35),('12664','2013-04-07','09:50:00',2.36),('12664','2013-04-07','09:55:00',2.31),('12664','2013-04-07','10:00:00',2.07),('12664','2013-04-07','10:05:00',1.91),('12664','2013-04-07','10:10:00',1.99),('12664','2013-04-07','10:15:00',2.41),('12664','2013-04-07','10:20:00',2.54),('12664','2013-04-07','10:25:00',3.05),('12664','2013-04-07','10:30:00',3.28),('12664','2013-04-07','10:35:00',3.31),('12664','2013-04-07','10:40:00',3.45),('12664','2013-04-07','10:45:00',3.51),('12664','2013-04-07','10:50:00',3.29),('12664','2013-04-07','10:55:00',2.86),('12664','2013-04-07','11:00:00',3.02),('12664','2013-04-07','11:05:00',2.77),('12664','2013-04-07','11:10:00',2.71),('12664','2013-04-07','11:15:00',2.6),('12664','2013-04-07','11:20:00',2.39),('12664','2013-04-07','11:25:00',2.27),('12664','2013-04-07','11:30:00',2.38),('12664','2013-04-07','11:35:00',2.81),('12664','2013-04-07','11:40:00',3.64),('12664','2013-04-07','11:45:00',4.26),('12664','2013-04-07','11:50:00',4.29),('12664','2013-04-07','11:55:00',4.31),('12664','2013-04-07','12:00:00',3.66),('12664','2013-04-07','12:05:00',3.38),('12664','2013-04-07','12:10:00',3.12),('12664','2013-04-07','12:15:00',3.22),('12664','2013-04-07','12:20:00',2.91),('12664','2013-04-07','12:25:00',3.11),('12664','2013-04-07','12:30:00',3.62),('12664','2013-04-07','12:35:00',3.68),('12664','2013-04-07','12:40:00',3.48),('12664','2013-04-07','12:45:00',3.35),('12664','2013-04-07','12:50:00',3.09),('12664','2013-04-07','12:55:00',3.29),('12664','2013-04-07','13:00:00',3.57),('12664','2013-04-07','13:05:00',3.33),('12664','2013-04-07','13:10:00',3.1),('12664','2013-04-07','13:15:00',3.41),('12664','2013-04-07','13:20:00',3.43),('12664','2013-04-07','13:25:00',3.2),('12664','2013-04-07','13:30:00',2.8),('12664','2013-04-07','13:35:00',3.04),('12664','2013-04-07','13:40:00',3.34),('12664','2013-04-07','13:45:00',3.3),('12664','2013-04-07','13:50:00',3.22),('12664','2013-04-07','13:55:00',3.09),('12664','2013-04-07','14:00:00',2.77),('12664','2013-04-07','14:05:00',2.76),('12664','2013-04-07','14:10:00',2.76),('12664','2013-04-07','14:15:00',2.7),('12664','2013-04-07','14:20:00',2.66),('12664','2013-04-07','14:25:00',2.66),('12664','2013-04-07','14:30:00',2.84),('12664','2013-04-07','14:35:00',2.92),('12664','2013-04-07','14:40:00',2.77),('12664','2013-04-07','14:45:00',2.72),('12664','2013-04-07','14:50:00',2.62),('12664','2013-04-07','14:55:00',2.57),('12664','2013-04-07','15:00:00',2.55),('12664','2013-04-07','15:05:00',2.55),('12664','2013-04-07','15:10:00',2.59),('12664','2013-04-07','15:15:00',2.57),('12664','2013-04-07','15:20:00',2.55),('12664','2013-04-07','15:25:00',2.55),('12664','2013-04-07','15:30:00',2.59),('12664','2013-04-07','15:35:00',1.91),('12664','2013-04-07','15:40:00',2.19),('12664','2013-04-07','15:45:00',2.42),('12664','2013-04-07','15:50:00',2.18),('12664','2013-04-07','15:55:00',1.74),('12664','2013-04-07','16:00:00',1.48),('12664','2013-04-07','16:05:00',1.52),('12664','2013-04-07','16:10:00',1.59),('12664','2013-04-07','16:15:00',1.37),('12664','2013-04-07','16:20:00',1.85),('12664','2013-04-07','16:25:00',2.11),('12664','2013-04-07','16:30:00',2.12),('12664','2013-04-07','16:35:00',2.58),('12664','2013-04-07','16:40:00',1.4),('12664','2013-04-07','16:45:00',1.15),('12664','2013-04-07','16:50:00',1.02),('12664','2013-04-07','17:05:00',1.83),('12664','2013-04-07','17:10:00',2.6),('12664','2013-04-07','17:15:00',2.57),('12664','2013-04-07','17:20:00',2),('12664','2013-04-07','17:25:00',1.06),('12664','2013-04-07','17:35:00',1.15),('12664','2013-04-07','17:40:00',1.36),('12664','2013-04-07','17:45:00',1.36),('12664','2013-04-06','08:10:00',1.1),('12664','2013-04-06','08:15:00',1.11),('12664','2013-04-06','08:20:00',1.31),('12664','2013-04-06','08:25:00',1.42),('12664','2013-04-06','08:30:00',1.52),('12664','2013-04-06','08:35:00',1.61),('12664','2013-04-06','08:40:00',1.71),('12664','2013-04-06','08:45:00',1.83),('12664','2013-04-06','08:50:00',1.93),('12664','2013-04-06','08:55:00',2.04),('12664','2013-04-06','09:00:00',2.14),('12664','2013-04-06','09:05:00',2.23),('12664','2013-04-06','09:10:00',2.32),('12664','2013-04-06','09:15:00',2.4),('12664','2013-04-06','09:20:00',2.5),('12664','2013-04-06','09:25:00',2.55),('12664','2013-04-06','09:30:00',2.64),('12664','2013-04-06','09:35:00',2.74),('12664','2013-04-06','09:40:00',2.79),('12664','2013-04-06','09:45:00',2.88),('12664','2013-04-06','09:50:00',2.95),('12664','2013-04-06','09:55:00',3.05),('12664','2013-04-06','10:00:00',3.09),('12664','2013-04-06','10:05:00',3.18),('12664','2013-04-06','10:10:00',3.39),('12664','2013-04-06','10:15:00',3.39),('12664','2013-04-06','10:20:00',3.54),('12664','2013-04-06','10:25:00',3.55),('12664','2013-04-06','10:30:00',3.56),('12664','2013-04-06','10:35:00',3.61),('12664','2013-04-06','10:40:00',3.74),('12664','2013-04-06','10:45:00',3.77),('12664','2013-04-06','10:50:00',3.82),('12664','2013-04-06','10:55:00',3.86),('12664','2013-04-06','11:00:00',3.91),('12664','2013-04-06','11:05:00',3.88),('12664','2013-04-06','11:10:00',3.95),('12664','2013-04-06','11:15:00',3.98),('12664','2013-04-06','11:20:00',4.04),('12664','2013-04-06','11:25:00',4.16),('12664','2013-04-06','11:30:00',4.23),('12664','2013-04-06','11:35:00',4.39),('12664','2013-04-06','11:40:00',4.27),('12664','2013-04-06','11:45:00',4.39),('12664','2013-04-06','11:50:00',4.33),('12664','2013-04-06','11:55:00',4.33),('12664','2013-04-06','12:00:00',4.33),('12664','2013-04-06','12:05:00',4.32),('12664','2013-04-06','12:10:00',4.36),('12664','2013-04-06','12:15:00',4.41),('12664','2013-04-06','12:20:00',3.73),('12664','2013-04-06','12:25:00',4.24),('12664','2013-04-06','12:30:00',4.5),('12664','2013-04-06','12:35:00',4.49),('12664','2013-04-06','12:40:00',4.5),('12664','2013-04-06','12:45:00',4.58),('12664','2013-04-06','12:50:00',4.66),('12664','2013-04-06','12:55:00',4.25),('12664','2013-04-06','13:00:00',1.73),('12664','2013-04-06','13:05:00',3.38),('12664','2013-04-06','13:10:00',3.98),('12664','2013-04-06','13:15:00',4.95),('12664','2013-04-06','13:20:00',4.83),('12664','2013-04-06','13:25:00',4.69),('12664','2013-04-06','13:30:00',4.73),('12664','2013-04-06','13:35:00',4.58),('12664','2013-04-06','13:40:00',4.54),('12664','2013-04-06','13:45:00',4.58),('12664','2013-04-06','13:50:00',4.56),('12664','2013-04-06','13:55:00',4.51),('12664','2013-04-06','14:00:00',4.56),('12664','2013-04-06','14:05:00',4.47),('12664','2013-04-06','14:10:00',4.42),('12664','2013-04-06','14:15:00',4.35),('12664','2013-04-06','14:20:00',4.33),('12664','2013-04-06','14:25:00',4.26),('12664','2013-04-06','14:30:00',4.23),('12664','2013-04-06','14:35:00',4.18),('12664','2013-04-06','14:40:00',4.14),('12664','2013-04-06','14:45:00',4.11),('12664','2013-04-06','14:50:00',4.07),('12664','2013-04-06','14:55:00',4.04),('12664','2013-04-06','15:00:00',3.94),('12664','2013-04-06','15:05:00',3.95),('12664','2013-04-06','15:10:00',3.85),('12664','2013-04-06','15:15:00',3.78),('12664','2013-04-06','15:20:00',3.78),('12664','2013-04-06','15:25:00',3.72),('12664','2013-04-06','15:30:00',3.62),('12664','2013-04-06','15:35:00',3.46),('12664','2013-04-06','15:40:00',3.51),('12664','2013-04-06','15:45:00',3.54),('12664','2013-04-06','15:50:00',3.4),('12664','2013-04-06','15:55:00',3.38),('12664','2013-04-06','16:00:00',3.19),('12664','2013-04-06','16:05:00',2.35),('12664','2013-04-06','16:10:00',2.25),('12664','2013-04-06','16:15:00',2.68),('12664','2013-04-06','16:20:00',2.95),('12664','2013-04-06','16:25:00',2.03),('12664','2013-04-06','16:30:00',1.94),('12664','2013-04-06','16:35:00',2.91),('12664','2013-04-06','16:40:00',1.88),('12664','2013-04-06','16:45:00',1.88),('12664','2013-04-06','16:50:00',2.27),('12664','2013-04-06','16:55:00',2.13),('12664','2013-04-06','17:00:00',1.76),('12664','2013-04-06','17:05:00',1.92),('12664','2013-04-06','17:10:00',1.69),('12664','2013-04-06','17:15:00',1.42),('12664','2013-04-06','17:20:00',1.15),('12664','2013-04-06','17:25:00',1.13),('12664','2013-04-05','08:40:00',1.63),('12664','2013-04-05','08:45:00',1.44),('12664','2013-04-05','08:50:00',1.12),('12664','2013-04-05','08:55:00',1.39),('12664','2013-04-05','09:15:00',1.1),('12664','2013-04-05','09:20:00',1.05),('12664','2013-04-05','09:25:00',1.3),('12664','2013-04-05','09:30:00',1.96),('12664','2013-04-05','09:35:00',1.99),('12664','2013-04-05','09:40:00',2.19),('12664','2013-04-05','09:45:00',1.61),('12664','2013-04-05','09:50:00',1.17),('12664','2013-04-05','09:55:00',1.42),('12664','2013-04-05','10:00:00',1.4),('12664','2013-04-05','10:05:00',1.71),('12664','2013-04-05','10:10:00',2.31),('12664','2013-04-05','10:15:00',2.86),('12664','2013-04-05','10:20:00',3.22),('12664','2013-04-05','10:25:00',2.8),('12664','2013-04-05','10:30:00',2.88),('12664','2013-04-05','10:35:00',3.89),('12664','2013-04-05','10:40:00',4.17),('12664','2013-04-05','10:45:00',3.66),('12664','2013-04-05','10:50:00',2.93),('12664','2013-04-05','10:55:00',2.08),('12664','2013-04-05','11:00:00',2.8),('12664','2013-04-05','11:05:00',4.26),('12664','2013-04-05','11:10:00',4.01),('12664','2013-04-05','11:15:00',3.57),('12664','2013-04-05','11:20:00',3.94),('12664','2013-04-05','11:25:00',4.34),('12664','2013-04-05','11:30:00',4.45),('12664','2013-04-05','11:35:00',4.38),('12664','2013-04-05','11:40:00',4.61),('12664','2013-04-05','11:45:00',2.18),('12664','2013-04-05','11:50:00',4.72),('12664','2013-04-05','11:55:00',4.81),('12664','2013-04-05','12:00:00',4.13),('12664','2013-04-05','12:05:00',2.34),('12664','2013-04-05','12:10:00',1.98),('12664','2013-04-05','12:15:00',1.76),('12664','2013-04-05','12:20:00',1.35),('12664','2013-04-05','12:25:00',3.05),('12664','2013-04-05','12:30:00',4.67),('12664','2013-04-05','12:35:00',1.44),('12664','2013-04-05','12:40:00',1.53),('12664','2013-04-05','12:45:00',2.05),('12664','2013-04-05','12:50:00',3.4),('12664','2013-04-05','12:55:00',4.49),('12664','2013-04-05','13:00:00',4.64),('12664','2013-04-05','13:05:00',4.69),('12664','2013-04-05','13:10:00',4),('12664','2013-04-05','13:15:00',4.74),('12664','2013-04-05','13:20:00',3.92),('12664','2013-04-05','13:25:00',4.79),('12664','2013-04-05','13:30:00',4.98),('12664','2013-04-05','13:35:00',4.1),('12664','2013-04-05','13:40:00',3.96),('12664','2013-04-05','13:45:00',4.7),('12664','2013-04-05','13:50:00',4.71),('12664','2013-04-05','13:55:00',4.19),('12664','2013-04-05','14:00:00',2.76),('12664','2013-04-05','14:05:00',2.46),('12664','2013-04-05','14:10:00',3.24),('12664','2013-04-05','14:15:00',4.78),('12664','2013-04-05','14:20:00',4.37),('12664','2013-04-05','14:25:00',3.86),('12664','2013-04-05','14:30:00',4.31),('12664','2013-04-05','14:35:00',2.95),('12664','2013-04-05','14:40:00',2.77),('12664','2013-04-05','14:45:00',2.34),('12664','2013-04-05','14:50:00',2.56),('12664','2013-04-05','14:55:00',2.96),('12664','2013-04-05','15:00:00',2.52),('12664','2013-04-05','15:05:00',1.72),('12664','2013-04-05','15:10:00',1.55),('12664','2013-04-05','15:15:00',1.66),('12664','2013-04-05','15:20:00',1.6),('12664','2013-04-05','15:25:00',1.25),('12664','2013-04-05','15:30:00',1.01),('12664','2013-04-05','15:35:00',1.24),('12664','2013-04-05','15:40:00',1.09),('12664','2013-04-05','15:55:00',1.2),('12664','2013-04-05','16:00:00',2.37),('12664','2013-04-05','16:05:00',2.23),('12664','2013-04-05','16:10:00',1.68),('12664','2013-04-05','16:15:00',2.34),('12664','2013-04-05','16:20:00',1.51),('12664','2013-04-05','16:25:00',1.78),('12664','2013-04-05','16:30:00',2.22),('12664','2013-04-05','16:35:00',1.92),('12664','2013-04-05','16:40:00',1.95),('12664','2013-04-05','16:45:00',2.93),('12664','2013-04-05','16:50:00',3.57),('12664','2013-04-05','16:55:00',1.84),('12664','2013-04-05','17:00:00',1.27),('12664','2013-04-05','17:05:00',1.82),('12664','2013-04-05','17:10:00',1.03),('12664','2013-04-05','17:15:00',2.11),('12664','2013-04-05','17:20:00',1.31),('12664','2013-04-05','17:35:00',1.59),('12664','2013-04-05','17:40:00',1.07),('12664','2013-04-05','17:55:00',1.19),('12664','2013-04-04','08:50:00',1.15),('12664','2013-04-04','08:55:00',2.1),('12664','2013-04-04','09:00:00',1.23),('12664','2013-04-04','09:05:00',1.03),('12664','2013-04-04','09:10:00',1.12),('12664','2013-04-04','09:15:00',1.13),('12664','2013-04-04','09:20:00',1.04),('12664','2013-04-04','09:25:00',1.28),('12664','2013-04-04','09:30:00',2.53),('12664','2013-04-04','09:35:00',2.66),('12664','2013-04-04','09:40:00',1.87),('12664','2013-04-04','09:45:00',1.2),('12664','2013-04-04','09:50:00',1.21),('12664','2013-04-04','09:55:00',1.66),('12664','2013-04-04','10:00:00',2.48),('12664','2013-04-04','10:05:00',2.66),('12664','2013-04-04','10:10:00',1.81),('12664','2013-04-04','10:15:00',1.52),('12664','2013-04-04','10:20:00',2.21),('12664','2013-04-04','10:25:00',3.33),('12664','2013-04-04','10:30:00',3.32),('12664','2013-04-04','10:35:00',3.88),('12664','2013-04-04','10:40:00',2.31),('12664','2013-04-04','10:45:00',2.17),('12664','2013-04-04','10:50:00',2.71),('12664','2013-04-04','10:55:00',2.05),('12664','2013-04-04','11:00:00',1.26),('12664','2013-04-04','11:05:00',1.18),('12664','2013-04-04','11:10:00',1.59),('12664','2013-04-04','11:15:00',1.45),('12664','2013-04-04','11:20:00',1.22),('12664','2013-04-04','11:25:00',1.2),('12664','2013-04-04','11:30:00',1.45),('12664','2013-04-04','11:35:00',2.18),('12664','2013-04-04','11:40:00',2.55),('12664','2013-04-04','11:45:00',3.31),('12664','2013-04-04','11:50:00',3.99),('12664','2013-04-04','11:55:00',4.11),('12664','2013-04-04','12:00:00',4.04),('12664','2013-04-04','12:05:00',3.96),('12664','2013-04-04','12:10:00',3.01),('12664','2013-04-04','12:15:00',2.03),('12664','2013-04-04','12:20:00',2.06),('12664','2013-04-04','12:25:00',3.77),('12664','2013-04-04','12:30:00',4.69),('12664','2013-04-04','12:35:00',4.65),('12664','2013-04-04','12:40:00',4.61),('12664','2013-04-04','12:45:00',4.43),('12664','2013-04-04','12:50:00',3.56),('12664','2013-04-04','12:55:00',2.98),('12664','2013-04-04','13:00:00',3.22),('12664','2013-04-04','13:05:00',1.95),('12664','2013-04-04','13:10:00',2.05),('12664','2013-04-04','13:15:00',2.89),('12664','2013-04-04','13:20:00',2.89),('12664','2013-04-04','13:25:00',2.95),('12664','2013-04-04','13:30:00',3.2),('12664','2013-04-04','13:35:00',4.32),('12664','2013-04-04','13:40:00',3.88),('12664','2013-04-04','13:45:00',3.58),('12664','2013-04-04','13:50:00',2.89),('12664','2013-04-04','13:55:00',2.62),('12664','2013-04-04','14:00:00',3.12),('12664','2013-04-04','14:05:00',3.93),('12664','2013-04-04','14:10:00',4.34),('12664','2013-04-04','14:15:00',4.19),('12664','2013-04-04','14:20:00',4.15),('12664','2013-04-04','14:25:00',4.05),('12664','2013-04-04','14:30:00',3.75),('12664','2013-04-04','14:35:00',3.57),('12664','2013-04-04','14:40:00',3.96),('12664','2013-04-04','14:45:00',3.9),('12664','2013-04-04','14:50:00',3.88),('12664','2013-04-04','14:55:00',3.91),('12664','2013-04-04','15:00:00',3.71),('12664','2013-04-04','15:05:00',3.59),('12664','2013-04-04','15:10:00',3.6),('12664','2013-04-04','15:15:00',3.66),('12664','2013-04-04','15:20:00',3.34),('12664','2013-04-04','15:25:00',3.46),('12664','2013-04-04','15:30:00',3.46),('12664','2013-04-04','15:35:00',3.35),('12664','2013-04-04','15:40:00',3.32),('12664','2013-04-04','15:45:00',3.23),('12664','2013-04-04','15:50:00',3.16),('12664','2013-04-04','15:55:00',3.14),('12664','2013-04-04','16:00:00',2.9),('12664','2013-04-04','16:05:00',2.9),('12664','2013-04-04','16:10:00',2.83),('12664','2013-04-04','16:15:00',2.48),('12664','2013-04-04','16:20:00',1.83),('12664','2013-04-04','16:25:00',2.98),('12664','2013-04-04','16:30:00',2.51),('12664','2013-04-04','16:35:00',2.08),('12664','2013-04-04','16:40:00',2.32),('12664','2013-04-04','16:45:00',1.91),('12664','2013-04-04','16:50:00',2),('12664','2013-04-04','16:55:00',1.91),('12664','2013-04-04','17:00:00',1.69),('12664','2013-04-04','17:05:00',1.82),('12664','2013-04-04','17:10:00',1.46),('12664','2013-04-04','17:15:00',1.48),('12664','2013-04-04','17:20:00',1.23),('12664','2013-04-04','17:25:00',1.04),('12664','2013-04-04','17:50:00',1.14),('12664','2013-04-04','17:55:00',1.32),('12664','2013-04-04','18:00:00',1.17),('12664','2013-04-03','08:05:00',1.02),('12664','2013-04-03','08:25:00',1.11),('12664','2013-04-03','08:30:00',1.46),('12664','2013-04-03','08:35:00',1.54),('12664','2013-04-03','08:40:00',1.79),('12664','2013-04-03','08:45:00',1.88),('12664','2013-04-03','08:50:00',1.77),('12664','2013-04-03','08:55:00',2.14),('12664','2013-04-03','09:00:00',2.27),('12664','2013-04-03','09:05:00',2.32),('12664','2013-04-03','09:10:00',2.5),('12664','2013-04-03','09:15:00',2.38),('12664','2013-04-03','09:20:00',2.06),('12664','2013-04-03','09:25:00',2.75),('12664','2013-04-03','09:30:00',2.9),('12664','2013-04-03','09:35:00',2.94),('12664','2013-04-03','09:40:00',3.04),('12664','2013-04-03','09:47:00',3.15),('12664','2013-04-03','09:50:00',3.6),('12664','2013-04-03','09:55:00',1.49),('12664','2013-04-03','10:00:00',1.49),('12664','2013-04-03','10:05:00',3.54),('12664','2013-04-03','10:10:00',3.51),('12664','2013-04-03','10:15:00',2.25),('12664','2013-04-03','10:20:00',2.25),('12664','2013-04-03','10:25:00',2.87),('12664','2013-04-03','10:30:00',3.54),('12664','2013-04-03','10:35:00',1.49),('12664','2013-04-03','10:40:00',1.79),('12664','2013-04-03','10:45:00',2.53),('12664','2013-04-03','10:50:00',3.15),('12664','2013-04-03','10:55:00',2.38),('12664','2013-04-03','11:00:00',2.07),('12664','2013-04-03','11:05:00',2.83),('12664','2013-04-03','11:10:00',2.61),('12664','2013-04-03','11:15:00',2.47),('12664','2013-04-03','11:20:00',1.83),('12664','2013-04-03','11:25:00',3.05),('12664','2013-04-03','11:30:00',1.76),('12664','2013-04-03','11:35:00',1.75),('12664','2013-04-03','11:40:00',3.85),('12664','2013-04-03','11:45:00',3.63),('12664','2013-04-03','11:50:00',2.53),('12664','2013-04-03','11:55:00',3.77),('12664','2013-04-03','12:00:00',3.23),('12664','2013-04-03','12:05:00',5.02),('12664','2013-04-03','12:10:00',2.96),('12664','2013-04-03','12:15:00',3.82),('12664','2013-04-03','12:20:00',4.1),('12664','2013-04-03','12:25:00',4.24),('12664','2013-04-03','12:30:00',4.4),('12664','2013-04-03','12:35:00',2.79),('12664','2013-04-03','12:40:00',4.33),('12664','2013-04-03','12:45:00',2.65),('12664','2013-04-03','12:50:00',4.29),('12664','2013-04-03','12:55:00',4.8),('12664','2013-04-03','13:00:00',4.21),('12664','2013-04-03','13:05:00',4.08),('12664','2013-04-03','13:10:00',2.8),('12664','2013-04-03','13:15:00',3.43),('12664','2013-04-03','13:20:00',4.19),('12664','2013-04-03','13:25:00',4.77),('12664','2013-04-03','13:30:00',3.92),('12664','2013-04-03','13:35:00',4.23),('12664','2013-04-03','13:40:00',3.51),('12664','2013-04-03','13:45:00',3.86),('12664','2013-04-03','13:50:00',4.59),('12664','2013-04-03','13:55:00',5.01),('12664','2013-04-03','14:00:00',4.06),('12664','2013-04-03','14:05:00',4.38),('12664','2013-04-03','14:10:00',4.78),('12664','2013-04-03','14:15:00',3.28),('12664','2013-04-03','14:20:00',3.28),('12664','2013-04-03','14:25:00',4.23),('12664','2013-04-03','14:30:00',4.23),('12664','2013-04-03','14:35:00',4.49),('12664','2013-04-03','14:40:00',4.77),('12664','2013-04-03','14:45:00',4.75),('12664','2013-04-03','14:50:00',3.65),('12664','2013-04-03','14:55:00',4.56),('12664','2013-04-03','15:00:00',3.9),('12664','2013-04-03','15:05:00',4.62),('12664','2013-04-03','15:10:00',3.62),('12664','2013-04-03','15:15:00',4.62),('12664','2013-04-03','15:20:00',4.6),('12664','2013-04-03','15:25:00',4.36),('12664','2013-04-03','15:30:00',3.94),('12664','2013-04-03','15:35:00',4.2),('12664','2013-04-03','15:40:00',3.71),('12664','2013-04-03','15:45:00',3.86),('12664','2013-04-03','15:50:00',3.65),('12664','2013-04-03','15:55:00',3.7),('12664','2013-04-03','16:00:00',3.65),('12664','2013-04-03','16:05:00',3.53),('12664','2013-04-03','16:10:00',3.49),('12664','2013-04-03','16:15:00',3.41),('12664','2013-04-03','16:20:00',3.3),('12664','2013-04-03','16:25:00',3.21),('12664','2013-04-03','16:30:00',3.13),('12664','2013-04-03','16:35:00',3.05),('12664','2013-04-03','16:40:00',2.95),('12664','2013-04-03','16:45:00',2.85),('12664','2013-04-03','16:50:00',2.75),('12664','2013-04-03','16:55:00',2.66),('12664','2013-04-03','17:00:00',2.55),('12664','2013-04-03','17:05:00',2.46),('12664','2013-04-03','17:10:00',2.34),('12664','2013-04-03','17:15:00',2.23),('12664','2013-04-03','17:20:00',2.12),('12664','2013-04-03','17:25:00',2.01),('12664','2013-04-03','17:30:00',1.91),('12664','2013-04-03','17:35:00',1.78),('12664','2013-04-03','17:40:00',1.66),('12664','2013-04-03','17:45:00',1.49),('12664','2013-04-03','17:50:00',1.45),('12664','2013-04-03','17:55:00',1.35),('12664','2013-04-03','18:00:00',1.23),('12664','2013-04-03','18:05:00',1.12),('12664','2013-04-02','08:55:00',2.04),('12664','2013-04-02','09:00:00',2.2),('12664','2013-04-02','09:05:00',2.27),('12664','2013-04-02','09:10:00',2.48),('12664','2013-04-02','09:15:00',2.63),('12664','2013-04-02','09:20:00',1.89),('12664','2013-04-02','09:25:00',2.38),('12664','2013-04-02','09:30:00',2.22),('12664','2013-04-02','09:35:00',1.76),('12664','2013-04-02','09:55:00',2.8),('12664','2013-04-02','10:00:00',4.12),('12664','2013-04-02','10:05:00',3.78),('12664','2013-04-02','10:10:00',1.48),('12664','2013-04-02','10:20:00',2.3),('12664','2013-04-02','10:30:00',1.21),('12664','2013-04-02','10:40:00',1.5),('12664','2013-04-02','10:45:00',3.95),('12664','2013-04-02','10:50:00',4.59),('12664','2013-04-02','10:55:00',4.09),('12664','2013-04-02','11:00:00',4.67),('12664','2013-04-02','11:05:00',3.97),('12664','2013-04-02','11:10:00',3.51),('12664','2013-04-02','11:15:00',3.73),('12664','2013-04-02','11:20:00',1.53),('12664','2013-04-02','11:25:00',1.61),('12664','2013-04-02','11:30:00',4),('12664','2013-04-02','11:35:00',3.85),('12664','2013-04-02','11:40:00',4.31),('12664','2013-04-02','11:45:00',3.82),('12664','2013-04-02','11:50:00',3.42),('12664','2013-04-02','11:55:00',1.12),('12664','2013-04-02','12:00:00',1.56),('12664','2013-04-02','12:05:00',3.25),('12664','2013-04-02','12:10:00',1.91),('12664','2013-04-02','12:15:00',1.38),('12664','2013-04-02','12:20:00',1.18),('12664','2013-04-02','12:35:00',1.73),('12664','2013-04-02','12:40:00',1.35),('12664','2013-04-02','12:45:00',2.08),('12664','2013-04-02','12:50:00',1.74),('12664','2013-04-02','12:55:00',1.38),('12664','2013-04-02','13:00:00',1.39),('12664','2013-04-02','13:05:00',1.25),('12664','2013-04-02','13:10:00',1.29),('12664','2013-04-02','13:15:00',1.35),('12664','2013-04-02','13:20:00',1.41),('12664','2013-04-02','13:25:00',1.63),('12664','2013-04-02','13:30:00',1.41),('12664','2013-04-02','13:35:00',1.4),('12664','2013-04-02','13:45:00',1.46),('12664','2013-04-02','13:50:00',4.05),('12664','2013-04-02','13:55:00',2.93),('12664','2013-04-02','14:00:00',4.21),('12664','2013-04-02','14:05:00',3.97),('12664','2013-04-02','14:10:00',3.8),('12664','2013-04-02','14:15:00',1.01),('12664','2013-04-02','14:20:00',3.28),('12664','2013-04-02','14:25:00',4.08),('12664','2013-04-02','14:30:00',2.94),('12664','2013-04-02','14:45:00',1.01),('12664','2013-04-02','14:50:00',1.2),('12664','2013-04-02','14:55:00',1.08),('12664','2013-04-02','15:00:00',1.14),('12664','2013-04-02','15:15:00',1.37),('12664','2013-04-02','15:40:00',1.03),('12664','2013-04-02','15:50:00',1.15),('12664','2013-04-02','15:55:00',1.37),('12664','2013-04-02','16:00:00',1.37),('12664','2013-04-02','16:05:00',1.32),('12664','2013-04-02','16:10:00',1.03),('12664','2013-04-02','16:30:00',1.1),('12664','2013-04-01','08:10:00',1.01),('12664','2013-04-01','08:15:00',1.14),('12664','2013-04-01','08:20:00',1.36),('12664','2013-04-01','08:25:00',1.67),('12664','2013-04-01','08:30:00',1.59),('12664','2013-04-01','08:40:00',1.61),('12664','2013-04-01','08:45:00',1.54),('12664','2013-04-01','08:50:00',1.55),('12664','2013-04-01','08:55:00',2.07),('12664','2013-04-01','09:00:00',2.2),('12664','2013-04-01','09:05:00',2.33),('12664','2013-04-01','09:10:00',2.46),('12664','2013-04-01','09:15:00',2.38),('12664','2013-04-01','09:20:00',2.3),('12664','2013-04-01','09:25:00',1.06),('12664','2013-04-01','09:30:00',1.24),('12664','2013-04-01','09:35:00',2.01),('12664','2013-04-01','09:40:00',2.78),('12664','2013-04-01','09:45:00',2.11),('12664','2013-04-01','09:50:00',1.44),('12664','2013-04-01','09:55:00',3.02),('12664','2013-04-01','10:00:00',3.13),('12664','2013-04-01','10:05:00',3.83),('12664','2013-04-01','10:10:00',1.98),('12664','2013-04-01','10:15:00',2.74),('12664','2013-04-01','10:20:00',3.4),('12664','2013-04-01','10:25:00',3.65),('12664','2013-04-01','10:30:00',1.93),('12664','2013-04-01','10:35:00',1.75),('12664','2013-04-01','10:40:00',2.72),('12664','2013-04-01','10:45:00',1.55),('12664','2013-04-01','10:50:00',1.79),('12664','2013-04-01','10:55:00',3.61),('12664','2013-04-01','11:00:00',3.17),('12664','2013-04-01','11:05:00',3.8),('12664','2013-04-01','11:10:00',3.06),('12664','2013-04-01','11:15:00',2.92),('12664','2013-04-01','11:20:00',3.12),('12664','2013-04-01','11:25:00',3.3),('12664','2013-04-01','11:30:00',2.29),('12664','2013-04-01','11:35:00',2.23),('12664','2013-04-01','11:40:00',2.34),('12664','2013-04-01','11:45:00',2.08),('12664','2013-04-01','11:50:00',2.31),('12664','2013-04-01','11:55:00',2.28),('12664','2013-04-01','12:00:00',1.9),('12664','2013-04-01','12:05:00',2.09),('12664','2013-04-01','12:10:00',2.66),('12664','2013-04-01','12:15:00',2.25),('12664','2013-04-01','12:20:00',2.26),('12664','2013-04-01','12:25:00',2.59),('12664','2013-04-01','12:30:00',2.57),('12664','2013-04-01','12:35:00',2.39),('12664','2013-04-01','12:40:00',2.72),('12664','2013-04-01','12:45:00',2.71),('12664','2013-04-01','12:50:00',3.09),('12664','2013-04-01','12:55:00',2.96),('12664','2013-04-01','13:00:00',2.77),('12664','2013-04-01','13:05:00',2.8),('12664','2013-04-01','13:10:00',3.16),('12664','2013-04-01','13:15:00',2.98),('12664','2013-04-01','13:20:00',2.89),('12664','2013-04-01','13:25:00',2.35),('12664','2013-04-01','13:30:00',2.25),('12664','2013-04-01','13:35:00',2.41),('12664','2013-04-01','13:40:00',2.83),('12664','2013-04-01','13:45:00',3.16),('12664','2013-04-01','13:50:00',3.54),('12664','2013-04-01','13:55:00',3.44),('12664','2013-04-01','14:00:00',2.15),('12664','2013-04-01','14:05:00',1.97),('12664','2013-04-01','14:10:00',2.1),('12664','2013-04-01','14:15:00',2.72),('12664','2013-04-01','14:20:00',3.58),('12664','2013-04-01','14:25:00',3.77),('12664','2013-04-01','14:30:00',4.31),('12664','2013-04-01','14:35:00',3.45),('12664','2013-04-01','14:40:00',2.99),('12664','2013-04-01','14:45:00',2.95),('12664','2013-04-01','14:50:00',2.67),('12664','2013-04-01','14:55:00',2.09),('12664','2013-04-01','15:00:00',1.93),('12664','2013-04-01','15:05:00',1.93),('12664','2013-04-01','15:10:00',2.24),('12664','2013-04-01','15:15:00',2.21),('12664','2013-04-01','15:20:00',2.45),('12664','2013-04-01','15:25:00',2.74),('12664','2013-04-01','15:30:00',2.45),('12664','2013-04-01','15:35:00',2.49),('12664','2013-04-01','15:40:00',1.98),('12664','2013-04-01','15:45:00',2.8),('12664','2013-04-01','15:50:00',3.13),('12664','2013-04-01','15:55:00',2.51),('12664','2013-04-01','16:00:00',2.09),('12664','2013-04-01','16:05:00',1.68),('12664','2013-04-01','16:10:00',1.28),('12664','2014-05-01','07:50:00',1.06),('12664','2014-05-01','07:55:00',1.04),('12664','2014-05-01','08:05:00',1.28),('12664','2014-05-01','08:10:00',1.38),('12664','2014-05-01','08:15:00',1.47),('12664','2014-05-01','08:20:00',1.57),('12664','2014-05-01','08:25:00',1.66),('12664','2014-05-01','08:30:00',1.75),('12664','2014-05-01','08:35:00',1.72),('12664','2014-05-01','08:45:00',1.09),('12664','2014-05-01','08:50:00',1.32),('12664','2014-05-01','08:55:00',1.57),('12664','2014-05-01','09:00:00',2.97),('12664','2014-05-01','09:05:00',1.55),('12664','2014-05-01','09:10:00',1.64),('12664','2014-05-01','09:15:00',2.13),('12664','2014-05-01','09:20:00',2.79),('12664','2014-05-01','09:25:00',3.23),('12664','2014-05-01','09:30:00',2.44),('12664','2014-05-01','09:35:00',1.37),('12664','2014-05-01','09:55:00',1.38),('12664','2014-05-01','10:00:00',1.95),('12664','2014-05-01','10:05:00',1.74),('12664','2014-05-01','10:10:00',3.2),('12664','2014-05-01','10:15:00',1.91),('12664','2014-05-01','10:20:00',1.98),('12664','2014-05-01','10:25:00',3.45),('12664','2014-05-01','10:30:00',2.61),('12664','2014-05-01','10:35:00',3.94),('12664','2014-05-01','10:40:00',3.96),('12664','2014-05-01','10:45:00',4.03),('12664','2014-05-01','10:50:00',4.08),('12664','2014-05-01','10:55:00',1.94),('12664','2014-05-01','11:00:00',4.24),('12664','2014-05-01','11:05:00',2.95),('12664','2014-05-01','11:10:00',4.13),('12664','2014-05-01','11:15:00',4.43),('12664','2014-05-01','11:20:00',2.43),('12664','2014-05-01','11:25:00',2.2),('12664','2014-05-01','11:30:00',2.1),('12664','2014-05-01','11:35:00',3.25),('12664','2014-05-01','11:40:00',4.38),('12664','2014-05-01','11:45:00',4.42),('12664','2014-05-01','11:50:00',4.33),('12664','2014-05-01','11:55:00',4.45),('12664','2014-05-01','12:00:00',1.61),('12664','2014-05-01','12:05:00',2.43),('12664','2014-05-01','12:10:00',4.51),('12664','2014-05-01','12:15:00',4.64),('12664','2014-05-01','12:20:00',3.6),('12664','2014-05-01','12:25:00',2.61),('12664','2014-05-01','12:30:00',4.86),('12664','2014-05-01','12:35:00',3.36),('12664','2014-05-01','12:40:00',2.73),('12664','2014-05-01','12:45:00',1.17),('12664','2014-05-01','12:50:00',1.3),('12664','2014-05-01','12:55:00',2.61),('12664','2014-05-01','13:00:00',3.59),('12664','2014-05-01','13:10:00',4.51),('12664','2014-05-01','13:15:00',4.31),('12664','2014-05-01','13:20:00',4.66),('12664','2014-05-01','13:25:00',4.75),('12664','2014-05-01','13:30:00',4.69),('12664','2014-05-01','13:35:00',4.71),('12664','2014-05-01','13:40:00',4.71),('12664','2014-05-01','13:45:00',4.51),('12664','2014-05-01','13:50:00',4.19),('12664','2014-05-01','13:55:00',3.87),('12664','2014-05-01','14:00:00',4.25),('12664','2014-05-01','14:05:00',4.2),('12664','2014-05-01','14:10:00',4.19),('12664','2014-05-01','14:15:00',4.14),('12664','2014-05-01','14:20:00',4.11),('12664','2014-05-01','14:25:00',4.09),('12664','2014-05-01','14:30:00',4.06),('12664','2014-05-01','14:35:00',4.09),('12664','2014-05-01','14:40:00',4.06),('12664','2014-05-01','14:45:00',4.09),('12664','2014-05-01','14:50:00',3.88),('12664','2014-05-01','14:55:00',3.89),('12664','2014-05-01','15:00:00',3.92),('12664','2014-05-01','15:05:00',3.9),('12664','2014-05-01','15:10:00',3.59),('12664','2014-05-01','15:15:00',3.73),('12664','2014-05-01','15:20:00',3.72),('12664','2014-05-01','15:25:00',3.69),('12664','2014-05-01','15:30:00',3.65),('12664','2014-05-01','15:35:00',3.57),('12664','2014-05-01','15:40:00',3.52),('12664','2014-05-01','15:45:00',3.45),('12664','2014-05-01','15:50:00',3.36),('12664','2014-05-01','15:55:00',3.18),('12664','2014-05-01','16:00:00',3.28),('12664','2014-05-01','16:05:00',3.24),('12664','2014-05-01','16:10:00',3.18),('12664','2014-05-01','16:15:00',3.01),('12664','2014-05-01','16:20:00',2.77),('12664','2014-05-01','16:25:00',2.84),('12664','2014-05-01','16:30:00',2.74),('12664','2014-05-01','16:35:00',2.63),('12664','2014-05-01','16:40:00',2.38),('12664','2014-05-01','16:45:00',2.39),('12664','2014-05-01','16:50:00',2.59),('12664','2014-05-01','16:55:00',2.36),('12664','2014-05-01','17:00:00',2.36),('12664','2014-05-01','17:05:00',2.32),('12664','2014-05-01','17:10:00',2.22),('12664','2014-05-01','17:15:00',1.71),('12664','2014-05-01','17:20:00',2.05),('12664','2014-05-01','17:25:00',1.99),('12664','2014-05-01','17:30:00',1.64),('12664','2014-05-01','17:35:00',1.31),('12664','2014-05-01','17:40:00',1.73),('12664','2014-05-01','17:45:00',1.31),('12664','2014-05-01','17:50:00',1.4),('12664','2014-05-01','17:55:00',1.14),('12664','2014-05-01','18:05:00',1.21),('12664','2014-03-26','07:25:00',1.3),('12664','2014-03-26','07:55:00',1.3),('12664','2014-03-26','08:00:00',1.88),('12664','2014-03-26','08:05:00',1.9),('12664','2014-03-26','08:10:00',1.94),('12664','2014-03-26','08:15:00',2.35),('12664','2014-03-26','08:20:00',1.66),('12664','2014-03-26','08:25:00',1.05),('12664','2014-03-26','08:45:00',1.05),('12664','2014-03-26','08:50:00',1.07),('12664','2014-03-26','08:55:00',1.14),('12664','2014-03-26','09:00:00',1.27),('12664','2014-03-26','09:05:00',1.53),('12664','2014-03-26','09:10:00',1.72),('12664','2014-03-26','09:15:00',1.16),('12664','2014-03-26','09:20:00',1.54),('12664','2014-03-26','09:25:00',3.39),('12664','2014-03-26','09:30:00',3.21),('12664','2014-03-26','09:35:00',3.22),('12664','2014-03-26','09:40:00',3.37),('12664','2014-03-26','09:45:00',3.44),('12664','2014-03-26','09:50:00',3.4),('12664','2014-03-26','09:55:00',3.44),('12664','2014-03-26','10:00:00',2.62),('12664','2014-03-26','10:05:00',3.69),('12664','2014-03-26','10:10:00',3.65),('12664','2014-03-26','10:15:00',3.69),('12664','2014-03-26','10:20:00',3.64),('12664','2014-03-26','10:25:00',3.8),('12664','2014-03-26','10:30:00',3.77),('12664','2014-03-26','10:40:00',1.67),('12664','2014-03-26','10:45:00',2.37),('12664','2014-03-26','10:50:00',1.18),('12664','2014-03-26','10:55:00',1.17),('12664','2014-03-26','11:00:00',1.63),('12664','2014-03-26','11:15:00',1.29),('12664','2014-03-26','11:20:00',2.2),('12664','2014-03-26','11:25:00',2.6),('12664','2014-03-26','11:30:00',1.34),('12664','2014-03-26','11:55:00',1.83),('12664','2014-03-26','12:00:00',2.16),('12664','2014-03-26','12:05:00',2.37),('12664','2014-03-26','12:10:00',1.54),('12664','2014-03-26','12:20:00',1.02),('12664','2014-03-26','12:25:00',1.26),('12664','2014-03-26','12:30:00',2.21),('12664','2014-03-26','12:35:00',2.27),('12664','2014-03-26','12:40:00',3.56),('12664','2014-03-26','12:45:00',3.77),('12664','2014-03-26','12:50:00',4.76),('12664','2014-03-26','12:55:00',3.8),('12664','2014-03-26','13:00:00',4.45),('12664','2014-03-26','13:05:00',3.91),('12664','2014-03-26','13:10:00',4.63),('12664','2014-03-26','13:15:00',4.53),('12664','2014-03-26','13:20:00',4.19),('12664','2014-03-26','13:25:00',1.91),('12664','2014-03-26','13:35:00',1.1),('12664','2014-03-26','13:40:00',2.53),('12664','2014-03-26','13:45:00',1.25),('12664','2014-03-26','13:50:00',3.01),('12664','2014-03-26','13:55:00',4.16),('12664','2014-03-26','14:00:00',3.52),('12664','2014-03-26','14:05:00',3.78),('12664','2014-03-26','14:10:00',4.1),('12664','2014-03-26','14:15:00',3.8),('12664','2014-03-26','14:20:00',2.66),('12664','2014-03-26','15:00:00',1.03),('12664','2014-03-26','15:05:00',2.58),('12664','2014-03-26','15:10:00',2.85),('12664','2014-03-26','15:15:00',2.69),('12664','2014-03-26','15:20:00',2.76),('12664','2014-03-26','15:25:00',2.57),('12664','2014-03-26','15:30:00',2.08),('12664','2014-03-26','15:35:00',1.5),('12664','2014-03-26','15:40:00',2.51),('12664','2014-03-26','15:45:00',2.03),('12664','2014-03-26','15:50:00',2.07),('12664','2014-03-26','16:20:00',1.8),('12664','2014-03-26','16:25:00',1.71),('12664','2014-03-26','16:30:00',1.35),('12664','2013-03-31','08:15:00',1.01),('12664','2013-03-31','08:50:00',1.02),('12664','2013-03-31','09:00:00',1.11),('12664','2013-03-31','09:05:00',1.09),('12664','2013-03-31','09:10:00',1.89),('12664','2013-03-31','09:20:00',1.15),('12664','2013-03-31','09:25:00',1.14),('12664','2013-03-31','09:45:00',2.99),('12664','2013-03-31','10:05:00',1.03),('12664','2013-03-31','10:10:00',1.9),('12664','2013-03-31','10:15:00',1.85),('12664','2013-03-31','10:20:00',1.79),('12664','2013-03-31','10:25:00',1.84),('12664','2013-03-31','10:30:00',1.59),('12664','2013-03-31','10:35:00',1.45),('12664','2013-03-31','10:40:00',1.26),('12664','2013-03-31','10:50:00',2.79),('12664','2013-03-31','10:55:00',2.02),('12664','2013-03-31','11:00:00',4.71),('12664','2013-03-31','11:05:00',2.13),('12664','2013-03-31','11:10:00',1.43),('12664','2013-03-31','11:15:00',1.26),('12664','2013-03-31','11:20:00',1.8),('12664','2013-03-31','11:25:00',2.41),('12664','2013-03-31','11:30:00',2.17),('12664','2013-03-31','11:35:00',3.16),('12664','2013-03-31','11:40:00',2.86),('12664','2013-03-31','11:45:00',1.72),('12664','2013-03-31','11:50:00',1.52),('12664','2013-03-31','11:55:00',1.8),('12664','2013-03-31','12:25:00',1.05),('12664','2013-03-31','12:30:00',1.33),('12664','2013-03-31','12:35:00',3.13),('12664','2013-03-31','12:40:00',2.75),('12664','2013-03-31','12:45:00',2.2),('12664','2013-03-31','12:50:00',1.41),('12664','2013-03-31','12:55:00',2.77),('12664','2013-03-31','13:00:00',2.46),('12664','2013-03-31','13:05:00',1.94),('12664','2013-03-31','13:10:00',2.38),('12664','2013-03-31','13:15:00',4.11),('12664','2013-03-31','13:20:00',3.22),('12664','2013-03-31','13:25:00',3.11),('12664','2013-03-31','13:30:00',2.37),('12664','2013-03-31','13:35:00',1.96),('12664','2013-03-31','13:40:00',3.09),('12664','2013-03-31','13:45:00',2.69),('12664','2013-03-31','13:50:00',2.99),('12664','2013-03-31','13:55:00',3.51),('12664','2013-03-31','14:00:00',3.2),('12664','2013-03-31','14:05:00',4.28),('12664','2013-03-31','14:10:00',4.48),('12664','2013-03-31','14:15:00',4.79),('12664','2013-03-31','14:20:00',3.26),('12664','2013-03-31','14:25:00',4.51),('12664','2013-03-31','14:30:00',3.34),('12664','2013-03-31','14:35:00',3.56),('12664','2013-03-31','14:40:00',4.1),('12664','2013-03-31','14:45:00',5.02),('12664','2013-03-31','14:50:00',4.63),('12664','2013-03-31','14:55:00',2.77),('12664','2013-03-31','15:00:00',4.53),('12664','2013-03-31','15:05:00',4.05),('12664','2013-03-31','15:10:00',3.83),('12664','2013-03-31','15:15:00',4.55),('12664','2013-03-31','15:20:00',4.45),('12664','2013-03-31','15:25:00',4.38),('12664','2013-03-31','15:30:00',3.83),('12664','2013-03-31','15:35:00',2.36),('12664','2013-03-31','15:40:00',2.74),('12664','2013-03-31','15:45:00',3.25),('12664','2013-03-31','16:20:00',1.14),('12664','2013-03-31','16:30:00',1.31),('12664','2013-03-31','16:35:00',1.18),('12664','2013-03-31','16:40:00',1.03),('12664','2013-03-31','16:50:00',1.07),('12664','2013-03-31','16:55:00',1.09),('12664','2013-03-31','17:00:00',1.56),('12664','2013-03-31','17:05:00',1.01),('12664','2013-03-31','17:30:00',1.12),('12664','2013-03-31','17:40:00',1.31),('12664','2013-03-31','17:45:00',1.82),('12664','2013-03-31','17:50:00',1.6),('12664','2013-03-31','18:10:00',1.31),('12664','2013-03-31','18:15:00',1.05),('12664','2013-03-30','09:20:00',1.09),('12664','2013-03-30','09:25:00',1.32),('12664','2013-03-30','09:30:00',1.38),('12664','2013-03-30','09:35:00',1.15),('12664','2013-03-30','09:40:00',1.3),('12664','2013-03-30','09:45:00',1.3),('12664','2013-03-30','09:50:00',1.54),('12664','2013-03-30','09:55:00',2.11),('12664','2013-03-30','10:00:00',2.5),('12664','2013-03-30','10:05:00',2.01),('12664','2013-03-30','10:10:00',1.61),('12664','2013-03-30','10:15:00',1.55),('12664','2013-03-30','10:20:00',1.6),('12664','2013-03-30','10:25:00',1.79),('12664','2013-03-30','10:30:00',2.11),('12664','2013-03-30','10:35:00',2.18),('12664','2013-03-30','10:40:00',1.94),('12664','2013-03-30','10:45:00',1.94),('12664','2013-03-30','10:50:00',2.2),('12664','2013-03-30','10:55:00',2.67),('12664','2013-03-30','11:00:00',2.7),('12664','2013-03-30','11:05:00',2.91),('12664','2013-03-30','11:10:00',2.66),('12664','2013-03-30','11:15:00',2.99),('12664','2013-03-30','11:20:00',2.41),('12664','2013-03-30','11:25:00',2.31),('12664','2013-03-30','11:30:00',3.97),('12664','2013-03-30','11:35:00',3.27),('12664','2013-03-30','11:40:00',3.42),('12664','2013-03-30','11:45:00',3.18),('12664','2013-03-30','11:50:00',2.35),('12664','2013-03-30','11:55:00',3.04),('12664','2013-03-30','12:00:00',2.59),('12664','2013-03-30','12:05:00',1.8),('12664','2013-03-30','12:10:00',1.13),('12664','2013-03-30','12:20:00',1.02),('12664','2013-03-30','12:30:00',1.06),('12664','2013-03-30','12:50:00',1.11),('12664','2013-03-30','12:55:00',1.58),('12664','2013-03-30','13:00:00',2.62),('12664','2013-03-30','13:05:00',2.16),('12664','2013-03-30','13:10:00',2.89),('12664','2013-03-30','13:15:00',1.3),('12664','2013-03-30','13:20:00',1.68),('12664','2013-03-30','13:40:00',1.04),('12664','2013-03-30','13:45:00',1.96),('12664','2013-03-30','13:50:00',2.51),('12664','2013-03-30','13:55:00',2.2),('12664','2013-03-30','14:00:00',2.76),('12664','2013-03-30','14:05:00',1.81),('12664','2013-03-30','14:10:00',1.61),('12664','2013-03-30','14:15:00',2.03),('12664','2013-03-30','14:20:00',3.08),('12664','2013-03-30','14:25:00',1.63),('12664','2013-03-30','14:30:00',1.15),('12664','2013-03-30','14:35:00',1.33),('12664','2013-03-30','14:40:00',1.05),('12664','2013-03-30','14:45:00',1.35),('12664','2013-03-29','07:10:00',1.09),('12664','2013-03-29','07:15:00',1.18),('12664','2013-03-29','07:30:00',1.16),('12664','2013-03-29','07:35:00',1.12),('12664','2013-03-29','07:40:00',1.1),('12664','2013-03-29','07:45:00',1.73),('12664','2013-03-29','07:50:00',1.86),('12664','2013-03-29','07:55:00',1.91),('12664','2013-03-29','08:00:00',2.09),('12664','2013-03-29','08:05:00',1.96),('12664','2013-03-29','08:10:00',1.87),('12664','2013-03-29','08:16:00',2.54),('12664','2013-03-29','08:20:00',2.33),('12664','2013-03-29','08:25:00',2.53),('12664','2013-03-29','08:30:00',2.64),('12664','2013-03-29','08:35:00',2.72),('12664','2013-03-29','08:40:00',2.62),('12664','2013-03-29','08:45:00',2.59),('12664','2013-03-29','08:50:00',2.39),('12664','2013-03-29','08:55:00',2.93),('12664','2013-03-29','09:00:00',2.79),('12664','2013-03-29','09:05:00',3.06),('12664','2013-03-29','09:10:00',3.34),('12664','2013-03-29','09:15:00',3.46),('12664','2013-03-29','09:20:00',3.19),('12664','2013-03-29','09:25:00',3.62),('12664','2013-03-29','09:30:00',3.61),('12664','2013-03-29','09:35:00',3.36),('12664','2013-03-29','09:40:00',3.32),('12664','2013-03-29','09:45:00',3.66),('12664','2013-03-29','09:50:00',3.62),('12664','2013-03-29','09:55:00',3.5),('12664','2013-03-29','10:00:00',3.32),('12664','2013-03-29','10:05:00',3.18),('12664','2013-03-29','10:10:00',3.47),('12664','2013-03-29','10:15:00',3.32),('12664','2013-03-29','10:20:00',3.07),('12664','2013-03-29','10:25:00',3.58),('12664','2013-03-29','10:30:00',3.11),('12664','2013-03-29','10:35:00',3.58),('12664','2013-03-29','10:40:00',3.5),('12664','2013-03-29','10:45:00',3.73),('12664','2013-03-29','10:50:00',4.18),('12664','2013-03-29','10:55:00',4.14),('12664','2013-03-29','11:00:00',4.23),('12664','2013-03-29','11:05:00',3.7),('12664','2013-03-29','11:10:00',1.12),('12664','2013-03-29','11:15:00',2.28),('12664','2013-03-29','11:20:00',4.96),('12664','2013-03-29','11:25:00',4.69),('12664','2013-03-29','11:30:00',4.55),('12664','2013-03-29','11:35:00',4.66),('12664','2013-03-29','11:40:00',4.68),('12664','2013-03-29','11:45:00',4.68),('12664','2013-03-29','11:50:00',4.66),('12664','2013-03-29','11:55:00',4.65),('12664','2013-03-29','12:00:00',4.72),('12664','2013-03-29','12:05:00',4.72),('12664','2013-03-29','12:10:00',4.49),('12664','2013-03-29','12:15:00',4.61),('12664','2013-03-29','12:20:00',4.44),('12664','2013-03-29','12:25:00',4.79),('12664','2013-03-29','12:30:00',4.66),('12664','2013-03-29','12:35:00',3.26),('12664','2013-03-29','12:40:00',4.98),('12664','2013-03-29','12:45:00',4.6),('12664','2013-03-29','12:50:00',3.27),('12664','2013-03-29','12:55:00',4.63),('12664','2013-03-29','13:00:00',4.6),('12664','2013-03-29','13:05:00',4.42),('12664','2013-03-29','13:10:00',3.57),('12664','2013-03-29','13:15:00',4.58),('12664','2013-03-29','13:20:00',4.72),('12664','2013-03-29','13:25:00',3.64),('12664','2013-03-29','13:30:00',3.89),('12664','2013-03-29','13:35:00',3.54),('12664','2013-03-29','13:40:00',4.01),('12664','2013-03-29','13:45:00',3.91),('12664','2013-03-29','13:50:00',3.95),('12664','2013-03-29','13:55:00',3.96),('12664','2013-03-29','14:00:00',3.24),('12664','2013-03-29','14:05:00',2.61),('12664','2013-03-29','14:10:00',2.54),('12664','2013-03-29','14:15:00',2.43),('12664','2013-03-29','14:20:00',2.56),('12664','2013-03-29','14:25:00',2.24),('12664','2013-03-29','14:30:00',2.03),('12664','2013-03-29','14:35:00',2.16),('12664','2013-03-29','14:40:00',1.92),('12664','2013-03-29','14:45:00',1.92),('12664','2013-03-29','14:50:00',1.84),('12664','2013-03-29','14:55:00',1.68),('12664','2013-03-29','15:00:00',1.65),('12664','2013-03-29','15:05:00',1.62),('12664','2013-03-29','15:10:00',1.55),('12664','2013-03-29','15:15:00',1.46),('12664','2013-03-29','15:20:00',1.31),('12664','2013-03-29','15:25:00',1.22),('12664','2013-03-29','15:30:00',1.16),('12664','2013-03-29','15:35:00',1.1),('12664','2013-03-29','15:40:00',1.1),('12664','2013-03-29','15:45:00',1.2),('12664','2013-03-29','15:50:00',1.39),('12664','2013-03-29','15:55:00',1.39),('12664','2013-03-29','16:00:00',1.36),('12664','2013-03-29','16:05:00',1.21),('12664','2013-03-29','16:10:00',1.07),('12664','2013-03-29','16:20:00',1.24),('12664','2013-03-29','16:25:00',1.35),('12664','2013-03-29','16:30:00',1.09),('12664','2013-03-29','16:35:00',2.2),('12664','2013-03-29','16:40:00',1.77),('12664','2013-03-29','16:45:00',1.39),('12664','2013-03-29','16:50:00',1.07),('12664','2013-03-29','16:55:00',1.28),('12664','2013-03-29','17:00:00',1.44),('12664','2013-03-29','17:20:00',1.05),('12664','2013-03-28','09:10:00',1.21),('12664','2013-03-28','09:15:00',1.4),('12664','2013-03-28','09:20:00',1.97),('12664','2013-03-28','09:25:00',1.86),('12664','2013-03-28','09:30:00',1.06),('12664','2013-03-28','12:45:00',1.65),('12664','2013-03-28','12:50:00',2.48),('12664','2013-03-28','12:55:00',1.57),('12664','2013-03-28','13:00:00',1.06),('12664','2013-03-28','13:10:00',1.04),('12664','2013-03-28','13:15:00',1.14),('12664','2013-03-28','13:20:00',1.18),('12664','2013-03-28','13:25:00',1.64),('12664','2013-03-28','13:30:00',1.58),('12664','2013-03-28','13:35:00',1.29),('12664','2013-03-28','13:40:00',1.38),('12664','2013-03-28','13:45:00',1.04),('12664','2013-03-28','14:00:00',1.87),('12664','2013-03-28','14:05:00',1.9),('12664','2013-03-28','14:10:00',1.83),('12664','2013-03-28','14:15:00',2.21),('12664','2013-03-28','14:20:00',1.5),('12664','2013-03-28','14:25:00',1.54),('12664','2013-03-28','14:30:00',1.99),('12664','2013-03-28','14:35:00',1.69),('12664','2013-03-28','14:40:00',1.24),('12664','2013-03-28','14:45:00',1),('12664','2013-03-28','15:05:00',1.05),('12664','2013-03-28','15:10:00',1.55),('12664','2013-03-28','15:15:00',2.14),('12664','2013-03-28','15:20:00',2.86),('12664','2013-03-28','15:25:00',1.42),('12664','2013-03-28','15:30:00',1.18),('12664','2013-03-28','15:40:00',1.41),('12664','2013-03-28','15:45:00',2.03),('12664','2013-03-28','15:50:00',1.84),('12664','2013-03-28','15:55:00',1.58),('12664','2013-03-28','16:00:00',1),('12664','2013-03-28','16:05:00',1.16),('12664','2013-03-28','16:10:00',1.37),('12664','2013-03-28','16:30:00',1.06),('12664','2013-03-28','16:35:00',1.57),('12664','2013-03-28','16:40:00',2),('12664','2013-03-28','16:45:00',1.32),('12664','2013-03-28','17:00:00',1.25),('12664','2013-03-28','17:05:00',1.39),('12664','2013-03-28','17:10:00',1.14),('12664','2013-03-27','07:10:00',1.01),('12664','2013-03-27','07:20:00',1.15),('12664','2013-03-27','07:25:00',1.35),('12664','2013-03-27','07:30:00',1.36),('12664','2013-03-27','07:35:00',1.46),('12664','2013-03-27','07:40:00',1.38),('12664','2013-03-27','08:05:00',1.08),('12664','2013-03-27','08:10:00',1.34),('12664','2013-03-27','08:15:00',1.25),('12664','2013-03-27','08:20:00',1.15),('12664','2013-03-27','08:25:00',1.9),('12664','2013-03-27','08:30:00',2.32),('12664','2013-03-27','08:35:00',2.89),('12664','2013-03-27','08:40:00',2.59),('12664','2013-03-27','08:45:00',2.79),('12664','2013-03-27','08:50:00',1.85),('12664','2013-03-27','08:55:00',3.26),('12664','2013-03-27','09:00:00',1.59),('12664','2013-03-27','09:05:00',1.85),('12664','2013-03-27','09:10:00',2.12),('12664','2013-03-27','09:15:00',1.22),('12664','2013-03-27','09:35:00',2.03),('12664','2013-03-27','09:40:00',2.86),('12664','2013-03-27','09:45:00',3.4),('12664','2013-03-27','09:50:00',2.74),('12664','2013-03-27','09:55:00',1.29),('12664','2013-03-27','10:00:00',1.69),('12664','2013-03-27','10:05:00',2.04),('12664','2013-03-27','10:10:00',3.35),('12664','2013-03-27','10:15:00',4.35),('12664','2013-03-27','10:20:00',4.83),('12664','2013-03-27','10:25:00',3.07),('12664','2013-03-27','10:30:00',3.43),('12664','2013-03-27','10:35:00',3.6),('12664','2013-03-27','10:40:00',3.18),('12664','2013-03-27','10:45:00',2.65),('12664','2013-03-27','10:50:00',2.32),('12664','2013-03-27','10:55:00',2.01),('12664','2013-03-27','11:00:00',1.92),('12664','2013-03-27','11:05:00',1.79),('12664','2013-03-27','11:10:00',1.97),('12664','2013-03-27','11:15:00',2.12),('12664','2013-03-27','11:20:00',1.52),('12664','2013-03-27','11:25:00',1.11),('12664','2013-03-27','11:30:00',1.48),('12664','2013-03-27','11:35:00',1.38),('12664','2013-03-27','11:40:00',1.19),('12664','2013-03-27','11:45:00',1.3),('12664','2013-03-27','11:50:00',2.52),('12664','2013-03-27','11:55:00',2.35),('12664','2013-03-27','12:00:00',2.02),('12664','2013-03-27','12:05:00',1.86),('12664','2013-03-27','12:10:00',1.91),('12664','2013-03-27','12:15:00',1.38),('12664','2013-03-27','12:20:00',1.26),('12664','2013-03-27','12:25:00',1.57),('12664','2013-03-27','12:30:00',1.67),('12664','2013-03-27','12:35:00',1.57),('12664','2013-03-27','12:40:00',2.41),('12664','2013-03-27','12:45:00',2.84),('12664','2013-03-27','12:50:00',2.15),('12664','2013-03-27','12:55:00',2.75),('12664','2013-03-27','13:00:00',3.01),('12664','2013-03-27','13:05:00',2.47),('12664','2013-03-27','13:10:00',2.49),('12664','2013-03-27','13:15:00',2.06),('12664','2013-03-27','13:20:00',1.96),('12664','2013-03-27','13:25:00',1.86),('12664','2013-03-27','13:30:00',2.05),('12664','2013-03-27','13:35:00',2.18),('12664','2013-03-27','13:40:00',2.33),('12664','2013-03-27','13:45:00',2.32),('12664','2013-03-27','13:50:00',1.85),('12664','2013-03-27','13:55:00',1.76),('12664','2013-03-27','14:00:00',1.74),('12664','2013-03-27','14:05:00',1.93),('12664','2013-03-27','14:10:00',2.02),('12664','2013-03-27','14:15:00',2),('12664','2013-03-27','14:20:00',1.97),('12664','2013-03-27','14:25:00',1.65),('12664','2013-03-27','14:30:00',1.58),('12664','2013-03-27','14:35:00',1.7),('12664','2013-03-27','14:40:00',1.88),('12664','2013-03-27','14:45:00',2.35),('12664','2013-03-27','14:50:00',2.16),('12664','2013-03-27','14:55:00',3.04),('12664','2013-03-27','15:00:00',2.1),('12664','2013-03-27','15:05:00',1.97),('12664','2013-03-27','15:10:00',1.33),('12664','2013-03-27','15:15:00',1.08),('12664','2013-03-27','15:20:00',1.55),('12664','2013-03-27','15:25:00',1.5),('12664','2013-03-27','15:30:00',1.02),('12664','2013-03-27','16:15:00',1.05),('12664','2013-03-27','16:20:00',1.51),('12664','2013-03-27','16:25:00',1.19),('12664','2013-03-27','16:30:00',1.27),('12664','2013-03-27','16:35:00',1.48),('12664','2013-03-27','16:40:00',1.44),('12664','2013-03-27','16:55:00',1.21),('12664','2013-03-27','17:00:00',1.43),('12664','2013-03-27','17:05:00',1.02),('12664','2013-03-26','08:30:00',1.39),('12664','2013-03-26','08:35:00',1.23),('12664','2013-03-26','08:40:00',1.04),('12664','2013-03-26','09:05:00',1.32),('12664','2013-03-26','09:10:00',1.55),('12664','2013-03-26','09:55:00',1.64),('12664','2013-03-26','10:00:00',1.77),('12664','2013-03-26','10:05:00',1.22),('12664','2013-03-26','10:25:00',1.01),('12664','2013-03-26','10:30:00',1.17),('12664','2013-03-26','10:35:00',1.12),('12664','2013-03-26','10:40:00',1.56),('12664','2013-03-26','10:45:00',1.6),('12664','2013-03-26','10:50:00',2.09),('12664','2013-03-26','10:55:00',2.72),('12664','2013-03-26','11:00:00',1.68),('12664','2013-03-26','11:35:00',2.48),('12664','2013-03-26','11:40:00',3.91),('12664','2013-03-26','11:45:00',3.8),('12664','2013-03-26','11:50:00',4.26),('12664','2013-03-26','11:55:00',3.36),('12664','2013-03-26','12:00:00',1.34),('12664','2013-03-26','12:05:00',1.15),('12664','2013-03-26','12:10:00',1.33),('12664','2013-03-26','12:15:00',1.66),('12664','2013-03-26','12:20:00',3.52),('12664','2013-03-26','12:25:00',4.08),('12664','2013-03-26','12:30:00',2.66),('12664','2013-03-26','12:35:00',1.99),('12664','2013-03-26','12:40:00',1.41),('12664','2013-03-26','12:45:00',3.15),('12664','2013-03-26','12:50:00',3.31),('12664','2013-03-26','12:55:00',2.15),('12664','2013-03-26','13:00:00',2.83),('12664','2013-03-26','13:05:00',2.52),('12664','2013-03-26','13:10:00',1.64),('12664','2013-03-26','13:15:00',2.03),('12664','2013-03-26','13:20:00',2.01),('12664','2013-03-26','13:25:00',1.93),('12664','2013-03-26','13:30:00',2.04),('12664','2013-03-26','13:35:00',2.55),('12664','2013-03-26','13:40:00',3.01),('12664','2013-03-26','13:45:00',2.46),('12664','2013-03-26','13:50:00',1.86),('12664','2013-03-26','13:55:00',1.19),('12664','2013-03-26','14:00:00',1.36),('12664','2013-03-26','14:05:00',2.15),('12664','2013-03-26','14:10:00',2.19),('12664','2013-03-26','14:15:00',1.58),('12664','2013-03-26','14:20:00',1.34),('12664','2013-03-26','14:25:00',1.05),('12664','2013-03-26','14:30:00',1.21),('12664','2013-03-26','14:35:00',1.23),('12664','2013-03-26','14:40:00',1.17),('12664','2013-03-26','15:05:00',1.01),('12664','2013-03-25','08:20:00',2.62),('12664','2013-03-25','08:25:00',2.74),('12664','2013-03-25','08:30:00',2.27),('12664','2013-03-25','08:35:00',1.5),('12664','2013-03-25','08:40:00',1.05),('12664','2013-03-25','08:45:00',1.27),('12664','2013-03-25','08:50:00',1.19),('12664','2013-03-25','08:55:00',1.1),('12664','2013-03-25','09:20:00',2.94),('12664','2013-03-25','09:25:00',3.03),('12664','2013-03-25','09:35:00',1.29),('12664','2013-03-25','09:50:00',1.09),('12664','2013-03-25','09:55:00',1.19),('12664','2013-03-25','10:00:00',1.21),('12664','2013-03-25','10:05:00',1.48),('12664','2013-03-25','10:10:00',3.55),('12664','2013-03-25','10:15:00',3.34),('12664','2013-03-25','10:20:00',2.04),('12664','2013-03-25','10:25:00',2.42),('12664','2013-03-25','10:30:00',1.9),('12664','2013-03-25','10:35:00',2.6),('12664','2013-03-25','10:40:00',3.03),('12664','2013-03-25','10:45:00',2.58),('12664','2013-03-25','10:50:00',1.41),('12664','2013-03-25','10:55:00',1.54),('12664','2013-03-25','11:00:00',2.07),('12664','2013-03-25','11:05:00',1.07),('12664','2013-03-25','11:10:00',1.09),('12664','2013-03-25','11:20:00',2.98),('12664','2013-03-25','11:25:00',1.66),('12664','2013-03-25','11:30:00',3.55),('12664','2013-03-25','11:35:00',3.76),('12664','2013-03-25','11:40:00',4.76),('12664','2013-03-25','11:45:00',3.21),('12664','2013-03-25','11:50:00',5.01),('12664','2013-03-25','11:55:00',2.1),('12664','2013-03-25','12:00:00',3.17),('12664','2013-03-25','12:05:00',1.35),('12664','2013-03-25','12:10:00',1.96),('12664','2013-03-25','12:15:00',3.91),('12664','2013-03-25','12:20:00',3.64),('12664','2013-03-25','12:25:00',4.78),('12664','2013-03-25','12:30:00',5.04),('12664','2013-03-25','12:35:00',4.95),('12664','2013-03-25','12:40:00',4.44),('12664','2013-03-25','12:45:00',2.34),('12664','2013-03-25','12:50:00',2.73),('12664','2013-03-25','12:55:00',1.89),('12664','2013-03-25','13:00:00',2.58),('12664','2013-03-25','13:05:00',4.68),('12664','2013-03-25','13:10:00',4.58),('12664','2013-03-25','13:15:00',3.42),('12664','2013-03-25','13:20:00',4.8),('12664','2013-03-25','13:25:00',3.97),('12664','2013-03-25','13:30:00',3.97),('12664','2013-03-25','13:35:00',3.31),('12664','2013-03-25','13:40:00',3.51),('12664','2013-03-25','13:45:00',3.22),('12664','2013-03-25','13:50:00',3.88),('12664','2013-03-25','13:55:00',3.42),('12664','2013-03-25','14:00:00',3.37),('12664','2013-03-25','14:05:00',4.59),('12664','2013-03-25','14:10:00',3.87),('12664','2013-03-25','14:15:00',3.33),('12664','2013-03-25','14:20:00',2.88),('12664','2013-03-25','14:25:00',4.11),('12664','2013-03-25','14:30:00',2.8),('12664','2013-03-25','14:35:00',2.45),('12664','2013-03-25','14:40:00',3.04),('12664','2013-03-25','14:45:00',2.29),('12664','2013-03-25','14:50:00',2.54),('12664','2013-03-25','14:55:00',2.55),('12664','2013-03-25','15:00:00',3.62),('12664','2013-03-25','15:05:00',3.88),('12664','2013-03-25','15:10:00',3.9),('12664','2013-03-25','15:15:00',2.81),('12664','2013-03-25','15:20:00',3.61),('12664','2013-03-25','15:25:00',3.3),('12664','2013-03-25','15:30:00',3.32),('12664','2013-03-25','15:35:00',3.03),('12664','2013-03-25','15:40:00',3.25),('12664','2013-03-25','15:45:00',2.75),('12664','2013-03-25','15:50:00',2.67),('12664','2013-03-25','15:55:00',1.95),('12664','2013-03-25','16:15:00',1.01),('12664','2013-03-25','16:20:00',1.39),('12664','2013-03-25','16:25:00',2.46),('12664','2013-03-25','16:30:00',2.29),('12664','2013-03-25','16:35:00',1.24),('12664','2013-03-25','16:40:00',1.49),('12664','2013-03-25','16:45:00',1.02),('12664','2013-03-24','07:25:00',1.02),('12664','2013-03-24','07:30:00',1.01),('12664','2013-03-24','07:40:00',1.05),('12664','2013-03-24','07:45:00',1.13),('12664','2013-03-24','07:50:00',1.28),('12664','2013-03-24','07:55:00',1.44),('12664','2013-03-24','08:00:00',1.68),('12664','2013-03-24','08:05:00',1.92),('12664','2013-03-24','08:10:00',1.98),('12664','2013-03-24','08:15:00',2.18),('12664','2013-03-24','08:20:00',2.27),('12664','2013-03-24','08:25:00',2.34),('12664','2013-03-24','08:30:00',2.45),('12664','2013-03-24','08:35:00',2.54),('12664','2013-03-24','08:40:00',2.63),('12664','2013-03-24','08:45:00',2.72),('12664','2013-03-24','08:50:00',2.79),('12664','2013-03-24','08:55:00',2.84),('12664','2013-03-24','09:00:00',2.92),('12664','2013-03-24','09:05:00',2.96),('12664','2013-03-24','09:10:00',3.07),('12664','2013-03-24','09:15:00',3.16),('12664','2013-03-24','09:20:00',3.23),('12664','2013-03-24','09:25:00',3.27),('12664','2013-03-24','09:30:00',3.34),('12664','2013-03-24','09:35:00',3.39),('12664','2013-03-24','09:40:00',3.44),('12664','2013-03-24','09:45:00',3.48),('12664','2013-03-24','09:50:00',3.55),('12664','2013-03-24','09:55:00',3.6),('12664','2013-03-24','10:00:00',3.66),('12664','2013-03-24','10:05:00',3.73),('12664','2013-03-24','10:10:00',3.74),('12664','2013-03-24','10:15:00',3.79),('12664','2013-03-24','10:20:00',3.83),('12664','2013-03-24','10:25:00',3.87),('12664','2013-03-24','10:30:00',3.91),('12664','2013-03-24','10:35:00',3.95),('12664','2013-03-24','10:40:00',3.98),('12664','2013-03-24','10:45:00',3.99),('12664','2013-03-24','10:50:00',4.02),('12664','2013-03-24','10:55:00',4.04),('12664','2013-03-24','11:00:00',4.07),('12664','2013-03-24','11:05:00',4.1),('12664','2013-03-24','11:10:00',4.12),('12664','2013-03-24','11:15:00',4.16),('12664','2013-03-24','11:20:00',4.18),('12664','2013-03-24','11:25:00',4.18),('12664','2013-03-24','11:30:00',4.22),('12664','2013-03-24','11:35:00',4.25),('12664','2013-03-24','11:40:00',4.22),('12664','2013-03-24','11:45:00',4.22),('12664','2013-03-24','11:50:00',4.24),('12664','2013-03-24','11:55:00',4.25),('12664','2013-03-24','12:00:00',4.2),('12664','2013-03-24','12:05:00',4.24),('12664','2013-03-24','12:10:00',4.26),('12664','2013-03-24','12:15:00',4.28),('12664','2013-03-24','12:20:00',4.36),('12664','2013-03-24','12:25:00',4.44),('12664','2013-03-24','12:30:00',4.46),('12664','2013-03-24','12:35:00',4.47),('12664','2013-03-24','12:40:00',4.48),('12664','2013-03-24','12:45:00',4.5),('12664','2013-03-24','12:50:00',4.45),('12664','2013-03-24','12:55:00',4.41),('12664','2013-03-24','13:00:00',4.44),('12664','2013-03-24','13:05:00',4.43),('12664','2013-03-24','13:10:00',4.38),('12664','2013-03-24','13:15:00',4.35),('12664','2013-03-24','13:20:00',4.31),('12664','2013-03-24','13:25:00',4.27),('12664','2013-03-24','13:30:00',4.27),('12664','2013-03-24','13:35:00',4.21),('12664','2013-03-24','13:40:00',4.19),('12664','2013-03-24','13:45:00',4.16),('12664','2013-03-24','13:50:00',4.11),('12664','2013-03-24','13:55:00',4.04),('12664','2013-03-24','14:00:00',3.98),('12664','2013-03-24','14:05:00',3.96),('12664','2013-03-24','14:10:00',3.9),('12664','2013-03-24','14:15:00',3.82),('12664','2013-03-24','14:20:00',3.74),('12664','2013-03-24','14:25:00',3.62),('12664','2013-03-24','14:30:00',3.55),('12664','2013-03-24','14:35:00',3.37),('12664','2013-03-24','14:40:00',3.48),('12664','2013-03-24','14:45:00',3.44),('12664','2013-03-24','14:50:00',3.31),('12664','2013-03-24','14:55:00',3.19),('12664','2013-03-24','15:00:00',3.13),('12664','2013-03-24','15:05:00',3.01),('12664','2013-03-24','15:10:00',2.96),('12664','2013-03-24','15:15:00',2.92),('12664','2013-03-24','15:20:00',2.9),('12664','2013-03-24','15:25:00',2.78),('12664','2013-03-24','15:30:00',2.69),('12664','2013-03-24','15:35:00',2.64),('12664','2013-03-24','15:40:00',2.54),('12664','2013-03-24','15:45:00',1.85),('12664','2013-03-24','15:50:00',1.36),('12664','2013-03-24','15:55:00',1.51),('12664','2013-03-24','16:00:00',1.42),('12664','2013-03-24','16:05:00',1.19),('12664','2013-03-24','16:10:00',1.11),('12664','2013-03-24','16:15:00',1.77),('12664','2013-03-24','16:20:00',1.26),('12664','2013-03-24','16:25:00',1.07),('12664','2013-03-24','16:30:00',1.21),('12664','2013-03-24','16:35:00',1.01),('12664','2013-03-23','07:30:00',1.1),('12664','2013-03-23','07:35:00',1.14),('12664','2013-03-23','07:40:00',1.3),('12664','2013-03-23','07:45:00',1.32),('12664','2013-03-23','07:50:00',1.54),('12664','2013-03-23','07:55:00',1.68),('12664','2013-03-23','08:00:00',1.87),('12664','2013-03-23','08:05:00',1.99),('12664','2013-03-23','08:10:00',2.09),('12664','2013-03-23','08:15:00',2.18),('12664','2013-03-23','08:20:00',2.29),('12664','2013-03-23','08:25:00',2.39),('12664','2013-03-23','08:30:00',2.47),('12664','2013-03-23','08:35:00',2.52),('12664','2013-03-23','08:40:00',2.67),('12664','2013-03-23','08:45:00',2.7),('12664','2013-03-23','08:50:00',2.92),('12664','2013-03-23','08:55:00',2.91),('12664','2013-03-23','09:00:00',3.02),('12664','2013-03-23','09:05:00',3.1),('12664','2013-03-23','09:10:00',3.19),('12664','2013-03-23','09:15:00',3.17),('12664','2013-03-23','09:20:00',3.34),('12664','2013-03-23','09:25:00',3.45),('12664','2013-03-23','09:30:00',3.52),('12664','2013-03-23','09:35:00',3.43),('12664','2013-03-23','09:40:00',3.54),('12664','2013-03-23','09:45:00',3.62),('12664','2013-03-23','09:50:00',3.67),('12664','2013-03-23','09:55:00',3.72),('12664','2013-03-23','10:00:00',3.71),('12664','2013-03-23','10:05:00',3.72),('12664','2013-03-23','10:10:00',3.89),('12664','2013-03-23','10:15:00',3.63),('12664','2013-03-23','10:20:00',2.91),('12664','2013-03-23','10:25:00',3.13),('12664','2013-03-23','10:30:00',3.21),('12664','2013-03-23','10:35:00',3.76),('12664','2013-03-23','10:40:00',4.03),('12664','2013-03-23','10:45:00',4.13),('12664','2013-03-23','10:50:00',3.86),('12664','2013-03-23','10:55:00',3.74),('12664','2013-03-23','11:00:00',3.42),('12664','2013-03-23','11:05:00',3.07),('12664','2013-03-23','11:10:00',3.88),('12664','2013-03-23','11:15:00',3.95),('12664','2013-03-23','11:20:00',3.68),('12664','2013-03-23','11:25:00',3.96),('12664','2013-03-23','11:30:00',4.19),('12664','2013-03-23','11:35:00',4.29),('12664','2013-03-23','11:40:00',3.99),('12664','2013-03-23','11:45:00',3.86),('12664','2013-03-23','11:50:00',4.19),('12664','2013-03-23','11:55:00',4.23),('12664','2013-03-23','12:00:00',4.22),('12664','2013-03-23','12:05:00',4.25),('12664','2013-03-23','12:10:00',4.28),('12664','2013-03-23','12:15:00',4.15),('12664','2013-03-23','12:20:00',4.32),('12664','2013-03-23','12:25:00',4.29),('12664','2013-03-23','12:30:00',4.26),('12664','2013-03-23','12:35:00',4.25),('12664','2013-03-23','12:40:00',4.37),('12664','2013-03-23','12:45:00',3.49),('12664','2013-03-23','12:50:00',3.77),('12664','2013-03-23','12:55:00',4.15),('12664','2013-03-23','13:00:00',3.81),('12664','2013-03-23','13:05:00',4.11),('12664','2013-03-23','13:10:00',4.17),('12664','2013-03-23','13:15:00',4.26),('12664','2013-03-23','13:20:00',4.24),('12664','2013-03-23','13:25:00',4.33),('12664','2013-03-23','13:30:00',4.21),('12664','2013-03-23','13:35:00',4.22),('12664','2013-03-23','13:40:00',4.09),('12664','2013-03-23','13:45:00',4.02),('12664','2013-03-23','13:50:00',4.03),('12664','2013-03-23','13:55:00',4.03),('12664','2013-03-23','14:00:00',4.07),('12664','2013-03-23','14:05:00',3.92),('12664','2013-03-23','14:10:00',3.75),('12664','2013-03-23','14:15:00',3.71),('12664','2013-03-23','14:20:00',3.77),('12664','2013-03-23','14:25:00',3.72),('12664','2013-03-23','14:30:00',3.63),('12664','2013-03-23','14:35:00',3.57),('12664','2013-03-23','14:40:00',3.3),('12664','2013-03-23','14:45:00',3.25),('12664','2013-03-23','14:50:00',3.27),('12664','2013-03-23','14:55:00',3.16),('12664','2013-03-23','15:00:00',3.11),('12664','2013-03-23','15:05:00',3.19),('12664','2013-03-23','15:10:00',2.72),('12664','2013-03-23','15:15:00',2.73),('12664','2013-03-23','15:20:00',2.84),('12664','2013-03-23','15:25:00',2.78),('12664','2013-03-23','15:30:00',2.43),('12664','2013-03-23','15:35:00',2.53),('12664','2013-03-23','15:40:00',2.39),('12664','2013-03-23','15:45:00',1.98),('12664','2013-03-23','15:50:00',1.72),('12664','2013-03-23','15:55:00',1.92),('12664','2013-03-23','16:00:00',1.81),('12664','2013-03-23','16:05:00',1.76),('12664','2013-03-23','16:10:00',2.11),('12664','2013-03-23','16:15:00',1.96),('12664','2013-03-23','16:20:00',1.79),('12664','2013-03-23','16:25:00',1.65),('12664','2013-03-23','16:30:00',1.46),('12664','2013-03-23','16:35:00',1.32),('12664','2013-03-23','16:40:00',1.12),('12664','2013-03-23','16:45:00',1.03),('12664','2013-03-23','16:50:00',1.07),('12664','2013-03-23','16:55:00',1.01),('12664','2013-03-23','17:00:00',1.24),('12664','2013-03-23','17:05:00',1.15),('12664','2013-03-22','07:25:00',1.04),('12664','2013-03-22','07:30:00',1.15),('12664','2013-03-22','07:35:00',1.26),('12664','2013-03-22','07:40:00',1.37),('12664','2013-03-22','07:45:00',1.48),('12664','2013-03-22','07:50:00',1.61),('12664','2013-03-22','07:55:00',1.72),('12664','2013-03-22','08:00:00',1.84),('12664','2013-03-22','08:05:00',1.95),('12664','2013-03-22','08:10:00',2.06),('12664','2013-03-22','08:15:00',2.17),('12664','2013-03-22','08:20:00',2.27),('12664','2013-03-22','08:25:00',2.37),('12664','2013-03-22','08:30:00',2.46),('12664','2013-03-22','08:35:00',2.58),('12664','2013-03-22','08:40:00',2.67),('12664','2013-03-22','08:45:00',2.76),('12664','2013-03-22','08:50:00',2.86),('12664','2013-03-22','08:55:00',2.94),('12664','2013-03-22','09:00:00',3.04),('12664','2013-03-22','09:05:00',3.11),('12664','2013-03-22','09:10:00',3.17),('12664','2013-03-22','09:15:00',3.22),('12664','2013-03-22','09:20:00',3.31),('12664','2013-03-22','09:25:00',3.37),('12664','2013-03-22','09:30:00',3.46),('12664','2013-03-22','09:35:00',3.51),('12664','2013-03-22','09:40:00',3.53),('12664','2013-03-22','09:45:00',3.56),('12664','2013-03-22','09:50:00',3.68),('12664','2013-03-22','09:55:00',3.73),('12664','2013-03-22','10:00:00',3.76),('12664','2013-03-22','10:05:00',3.84),('12664','2013-03-22','10:10:00',3.88),('12664','2013-03-22','10:15:00',3.92),('12664','2013-03-22','10:20:00',3.95),('12664','2013-03-22','10:25:00',4),('12664','2013-03-22','10:30:00',4.07),('12664','2013-03-22','10:35:00',4.08),('12664','2013-03-22','10:40:00',4.18),('12664','2013-03-22','10:45:00',4.23),('12664','2013-03-22','10:50:00',4.28),('12664','2013-03-22','10:55:00',4.33),('12664','2013-03-22','11:00:00',4.36),('12664','2013-03-22','11:05:00',4.4),('12664','2013-03-22','11:10:00',4.44),('12664','2013-03-22','11:15:00',4.43),('12664','2013-03-22','11:20:00',4.43),('12664','2013-03-22','11:25:00',4.49),('12664','2013-03-22','11:30:00',4.53),('12664','2013-03-22','11:35:00',4.58),('12664','2013-03-22','11:40:00',4.61),('12664','2013-03-22','11:45:00',4.61),('12664','2013-03-22','11:50:00',4.61),('12664','2013-03-22','11:55:00',4.65),('12664','2013-03-22','12:00:00',4.65),('12664','2013-03-22','12:05:00',4.65),('12664','2013-03-22','12:10:00',4.64),('12664','2013-03-22','12:15:00',4.64),('12664','2013-03-22','12:20:00',4.64),('12664','2013-03-22','12:25:00',4.65),('12664','2013-03-22','12:30:00',4.67),('12664','2013-03-22','12:35:00',4.64),('12664','2013-03-22','12:40:00',4.63),('12664','2013-03-22','12:45:00',4.59),('12664','2013-03-22','12:50:00',4.39),('12664','2013-03-22','12:55:00',4.58),('12664','2013-03-22','13:00:00',4.53),('12664','2013-03-22','13:05:00',4.59),('12664','2013-03-22','13:10:00',4.57),('12664','2013-03-22','13:15:00',4.53),('12664','2013-03-22','13:20:00',4.28),('12664','2013-03-22','13:25:00',4.17),('12664','2013-03-22','13:30:00',4.44),('12664','2013-03-22','13:35:00',3.93),('12664','2013-03-22','13:40:00',3.64),('12664','2013-03-22','13:45:00',4.39),('12664','2013-03-22','13:50:00',4.32),('12664','2013-03-22','13:55:00',4.23),('12664','2013-03-22','14:00:00',4.17),('12664','2013-03-22','14:05:00',4.12),('12664','2013-03-22','14:10:00',4.08),('12664','2013-03-22','14:15:00',4.03),('12664','2013-03-22','14:20:00',4),('12664','2013-03-22','14:25:00',3.92),('12664','2013-03-22','14:30:00',3.85),('12664','2013-03-22','14:35:00',3.81),('12664','2013-03-22','14:40:00',3.76),('12664','2013-03-22','14:45:00',3.64),('12664','2013-03-22','14:50:00',3.17),('12664','2013-03-22','14:55:00',3.63),('12664','2013-03-22','15:00:00',2.76),('12664','2013-03-22','15:05:00',3.32),('12664','2013-03-22','15:10:00',2.18),('12664','2013-03-22','15:15:00',2.18),('12664','2013-03-22','15:20:00',2.72),('12664','2013-03-22','15:25:00',2.47),('12664','2013-03-22','15:30:00',2.71),('12664','2013-03-22','15:35:00',2.72),('12664','2013-03-22','15:40:00',2.45),('12664','2013-03-22','15:45:00',2.55),('12664','2013-03-22','15:50:00',2.31),('12664','2013-03-22','15:55:00',1.69),('12664','2013-03-22','16:00:00',1.5),('12664','2013-03-22','16:05:00',1.81),('12664','2013-03-22','16:10:00',2.16),('12664','2013-03-22','16:15:00',1.85),('12664','2013-03-22','16:20:00',1.4),('12664','2013-03-22','16:25:00',1.85),('12664','2013-03-22','16:30:00',1.26),('12664','2013-03-22','16:35:00',1.46),('12664','2013-03-22','16:40:00',1.39),('12664','2013-03-22','16:45:00',1.69),('12664','2013-03-22','16:50:00',1.16),('12664','2013-03-22','16:55:00',1.28),('12664','2013-03-22','17:00:00',1.26),('12664','2013-03-22','17:05:00',1.08),('12664','2014-03-25','07:15:00',1.1),('12664','2014-03-25','07:20:00',1.24),('12664','2014-03-25','07:25:00',1.21),('12664','2014-03-25','07:30:00',1.21),('12664','2014-03-25','07:45:00',1.06),('12664','2014-03-25','07:50:00',1.09),('12664','2014-03-25','07:55:00',1),('12664','2014-03-25','08:00:00',1.02),('12664','2014-03-25','08:05:00',1.04),('12664','2014-03-25','08:10:00',1.11),('12664','2014-03-25','08:15:00',1.06),('12664','2014-03-25','08:35:00',1.1),('12664','2014-03-25','08:40:00',1.42),('12664','2014-03-25','08:45:00',1.6),('12664','2014-03-25','08:50:00',1.66),('12664','2014-03-25','08:55:00',1.65),('12664','2014-03-25','09:00:00',1.63),('12664','2014-03-25','09:05:00',1.76),('12664','2014-03-25','09:10:00',1.95),('12664','2014-03-25','09:15:00',2.23),('12664','2014-03-25','09:20:00',2.18),('12664','2014-03-25','09:25:00',1.88),('12664','2014-03-25','09:30:00',1.7),('12664','2014-03-25','09:35:00',1.72),('12664','2014-03-25','09:40:00',1.65),('12664','2014-03-25','09:45:00',1.72),('12664','2014-03-25','09:50:00',1.85),('12664','2014-03-25','09:55:00',2.21),('12664','2014-03-25','10:00:00',2.37),('12664','2014-03-25','10:05:00',2.48),('12664','2014-03-25','10:10:00',2.76),('12664','2014-03-25','10:15:00',3.05),('12664','2014-03-25','10:20:00',3.18),('12664','2014-03-25','10:25:00',2.64),('12664','2014-03-25','10:30:00',2.35),('12664','2014-03-25','10:35:00',2.14),('12664','2014-03-25','10:40:00',1.87),('12664','2014-03-25','10:45:00',1.73),('12664','2014-03-25','10:50:00',1.94),('12664','2014-03-25','10:55:00',2.21),('12664','2014-03-25','11:00:00',2.35),('12664','2014-03-25','11:05:00',2.5),('12664','2014-03-25','11:10:00',2.56),('12664','2014-03-25','11:15:00',2.67),('12664','2014-03-25','11:20:00',2.88),('12664','2014-03-25','11:25:00',3.03),('12664','2014-03-25','11:30:00',3.06),('12664','2014-03-25','11:35:00',2.96),('12664','2014-03-25','11:40:00',2.87),('12664','2014-03-25','11:45:00',2.61),('12664','2014-03-25','11:50:00',2.18),('12664','2014-03-25','11:55:00',1.67),('12664','2014-03-25','12:00:00',1.21),('12664','2014-03-25','12:05:00',1.17),('12664','2014-03-25','12:10:00',1.31),('12664','2014-03-25','12:15:00',1.31),('12664','2014-03-25','12:20:00',1.28),('12664','2014-03-25','12:25:00',1.09),('12664','2014-03-25','12:50:00',1.21),('12664','2014-03-25','12:55:00',1.03),('12664','2013-03-21','07:35:00',1.25),('12664','2013-03-21','07:55:00',1.76),('12664','2013-03-21','08:00:00',1.97),('12664','2013-03-21','08:05:00',2.06),('12664','2013-03-21','08:10:00',2.17),('12664','2013-03-21','08:15:00',2.34),('12664','2013-03-21','08:20:00',2.57),('12664','2013-03-21','08:25:00',2.58),('12664','2013-03-21','08:30:00',2.59),('12664','2013-03-21','08:35:00',2.3),('12664','2013-03-21','08:40:00',2.92),('12664','2013-03-21','08:45:00',3.09),('12664','2013-03-21','09:00:00',2.98),('12664','2013-03-21','09:05:00',3.41),('12664','2013-03-21','09:10:00',3.46),('12664','2013-03-21','09:15:00',3.54),('12664','2013-03-21','09:20:00',3.63),('12664','2013-03-21','09:25:00',3.79),('12664','2013-03-21','09:30:00',3.86),('12664','2013-03-21','09:35:00',3.67),('12664','2013-03-21','09:40:00',3.89),('12664','2013-03-21','09:45:00',3.87),('12664','2013-03-21','09:50:00',3.81),('12664','2013-03-21','09:55:00',3.99),('12664','2013-03-21','10:00:00',4.13),('12664','2013-03-21','10:05:00',3.67),('12664','2013-03-21','10:10:00',4.15),('12664','2013-03-21','10:15:00',4.29),('12664','2013-03-21','10:20:00',4.23),('12664','2013-03-21','10:25:00',4.26),('12664','2013-03-21','10:30:00',4.32),('12664','2013-03-21','10:35:00',4.4),('12664','2013-03-21','10:40:00',4.44),('12664','2013-03-21','10:45:00',4.48),('12664','2013-03-21','10:50:00',4.52),('12664','2013-03-21','10:55:00',4.55),('12664','2013-03-21','11:00:00',4.61),('12664','2013-03-21','11:05:00',4.66),('12664','2013-03-21','11:10:00',4.7),('12664','2013-03-21','11:15:00',4.76),('12664','2013-03-21','11:20:00',4.75),('12664','2013-03-21','11:25:00',4.74),('12664','2013-03-21','11:30:00',4.79),('12664','2013-03-21','11:35:00',4.8),('12664','2013-03-21','11:40:00',4.82),('12664','2013-03-21','11:45:00',4.84),('12664','2013-03-21','11:50:00',4.86),('12664','2013-03-21','11:55:00',4.85),('12664','2013-03-21','12:00:00',4.89),('12664','2013-03-21','12:05:00',4.9),('12664','2013-03-21','12:10:00',4.91),('12664','2013-03-21','12:15:00',4.89),('12664','2013-03-21','12:20:00',4.9),('12664','2013-03-21','12:25:00',4.9),('12664','2013-03-21','12:30:00',4.87),('12664','2013-03-21','12:35:00',4.85),('12664','2013-03-21','12:40:00',4.87),('12664','2013-03-21','12:45:00',4.85),('12664','2013-03-21','12:50:00',4.83),('12664','2013-03-21','12:55:00',4.8),('12664','2013-03-21','13:00:00',4.77),('12664','2013-03-21','13:05:00',4.74),('12664','2013-03-21','13:10:00',4.72),('12664','2013-03-21','13:15:00',4.69),('12664','2013-03-21','13:20:00',4.66),('12664','2013-03-21','13:25:00',4.63),('12664','2013-03-21','13:30:00',4.58),('12664','2013-03-21','13:35:00',4.55),('12664','2013-03-21','13:40:00',4.49),('12664','2013-03-21','13:45:00',4.45),('12664','2013-03-21','13:50:00',4.4),('12664','2013-03-21','13:55:00',4.34),('12664','2013-03-21','14:00:00',4.29),('12664','2013-03-21','14:05:00',4.24),('12664','2013-03-21','14:10:00',4.19),('12664','2013-03-21','14:15:00',4.13),('12664','2013-03-21','14:20:00',4.07),('12664','2013-03-21','14:25:00',4.02),('12664','2013-03-21','14:30:00',3.93),('12664','2013-03-21','14:35:00',3.87),('12664','2013-03-21','14:40:00',3.8),('12664','2013-03-21','14:45:00',3.74),('12664','2013-03-21','14:50:00',3.67),('12664','2013-03-21','14:55:00',3.62),('12664','2013-03-21','15:00:00',3.55),('12664','2013-03-21','15:05:00',3.45),('12664','2013-03-21','15:10:00',3.36),('12664','2013-03-21','15:15:00',3.27),('12664','2013-03-21','15:20:00',3.18),('12664','2013-03-21','15:25:00',3.11),('12664','2013-03-21','15:30:00',3.03),('12664','2013-03-21','15:35:00',2.93),('12664','2013-03-21','15:40:00',2.83),('12664','2013-03-21','15:45:00',2.73),('12664','2013-03-21','15:50:00',2.63),('12664','2013-03-21','15:55:00',2.51),('12664','2013-03-21','16:00:00',2.43),('12664','2013-03-21','16:05:00',2.33),('12664','2013-03-21','16:10:00',2.21),('12664','2013-03-21','16:15:00',2.12),('12664','2013-03-21','16:20:00',2.01),('12664','2013-03-21','16:25:00',1.89),('12664','2013-03-21','16:30:00',1.74),('12664','2013-03-21','16:35:00',1.67),('12664','2013-03-21','16:40:00',1.55),('12664','2013-03-21','16:45:00',1.43),('12664','2013-03-21','16:50:00',1.31),('12664','2013-03-21','16:55:00',1.19),('12664','2013-03-21','17:00:00',1.07),('12664','2013-03-20','07:25:00',1.05),('12664','2013-03-20','07:30:00',1.2),('12664','2013-03-20','07:35:00',1.32),('12664','2013-03-20','07:40:00',1.37),('12664','2013-03-20','07:45:00',1.51),('12664','2013-03-20','07:50:00',1.65),('12664','2013-03-20','08:05:00',1.9),('12664','2013-03-20','08:10:00',2.02),('12664','2013-03-20','08:15:00',2.12),('12664','2013-03-20','08:20:00',2.24),('12664','2013-03-20','08:25:00',2.31),('12664','2013-03-20','08:30:00',2.41),('12664','2013-03-20','08:35:00',2.41),('12664','2013-03-20','08:40:00',2.25),('12664','2013-03-20','08:45:00',2.59),('12664','2013-03-20','08:50:00',2.56),('12664','2013-03-20','08:55:00',2.65),('12664','2013-03-20','09:00:00',2.77),('12664','2013-03-20','09:05:00',1.87),('12664','2013-03-20','09:10:00',1.92),('12664','2013-03-20','09:15:00',3.05),('12664','2013-03-20','09:20:00',3.18),('12664','2013-03-20','09:25:00',2.17),('12664','2013-03-20','09:30:00',3.44),('12664','2013-03-20','09:35:00',3.15),('12664','2013-03-20','09:40:00',3.57),('12664','2013-03-20','09:45:00',3.68),('12664','2013-03-20','09:50:00',3.77),('12664','2013-03-20','09:55:00',3.54),('12664','2013-03-20','10:00:00',2.97),('12664','2013-03-20','10:05:00',3.77),('12664','2013-03-20','10:10:00',2.92),('12664','2013-03-20','10:15:00',2.99),('12664','2013-03-20','10:20:00',3.07),('12664','2013-03-20','10:25:00',3.52),('12664','2013-03-20','10:30:00',3.56),('12664','2013-03-20','10:35:00',2.58),('12664','2013-03-20','10:40:00',2.99),('12664','2013-03-20','10:45:00',2.74),('12664','2013-03-20','10:50:00',3.19),('12664','2013-03-20','10:55:00',3.05),('12664','2013-03-20','11:00:00',2.75),('12664','2013-03-20','11:05:00',2.89),('12664','2013-03-20','11:10:00',2.52),('12664','2013-03-20','11:15:00',2.6),('12664','2013-03-20','11:20:00',2.99),('12664','2013-03-20','11:25:00',2.45),('12664','2013-03-20','11:30:00',2.58),('12664','2013-03-20','11:35:00',3),('12664','2013-03-20','11:40:00',2.48),('12664','2013-03-20','11:45:00',2.12),('12664','2013-03-20','11:50:00',2.2),('12664','2013-03-20','11:55:00',2.13),('12664','2013-03-20','12:00:00',2.38),('12664','2013-03-20','12:05:00',2.21),('12664','2013-03-20','12:10:00',1.99),('12664','2013-03-20','12:15:00',1.55),('12664','2013-03-20','12:20:00',1.36),('12664','2013-03-20','12:25:00',1.22),('12664','2013-03-20','12:30:00',1.29),('12664','2013-03-20','12:35:00',1.28),('12664','2013-03-20','12:40:00',1.03),('12664','2013-03-20','12:50:00',1.51),('12664','2013-03-20','12:55:00',1.83),('12664','2013-03-20','13:00:00',1.27),('12664','2013-03-20','13:05:00',1.17),('12664','2013-03-20','13:10:00',1.25),('12664','2013-03-20','13:15:00',1.14),('12664','2013-03-20','13:20:00',1.24),('12664','2013-03-20','13:25:00',1.46),('12664','2013-03-20','13:30:00',1.58),('12664','2013-03-20','13:35:00',1.54),('12664','2013-03-20','13:40:00',2.03),('12664','2013-03-20','13:45:00',1.98),('12664','2013-03-20','13:50:00',1.71),('12664','2013-03-20','13:55:00',1.78),('12664','2013-03-20','14:00:00',1.55),('12664','2013-03-20','14:05:00',1.29),('12664','2013-03-20','14:10:00',1.34),('12664','2013-03-20','14:15:00',1.81),('12664','2013-03-20','14:20:00',2.05),('12664','2013-03-20','14:25:00',2.32),('12664','2013-03-20','14:30:00',2.01),('12664','2013-03-20','14:35:00',1.45),('12664','2013-03-20','14:40:00',1.17),('12664','2013-03-20','14:45:00',1.01),('12664','2013-03-19','07:30:00',1.12),('12664','2013-03-19','07:35:00',1.22),('12664','2013-03-19','07:40:00',1.33),('12664','2013-03-19','07:45:00',1.47),('12664','2013-03-19','07:50:00',1.62),('12664','2013-03-19','07:55:00',1.52),('12664','2013-03-19','08:00:00',1.47),('12664','2013-03-19','08:05:00',1.86),('12664','2013-03-19','08:10:00',1.77),('12664','2013-03-19','08:15:00',1.93),('12664','2013-03-19','08:20:00',2.05),('12664','2013-03-19','08:25:00',2.27),('12664','2013-03-19','08:30:00',2.43),('12664','2013-03-19','08:35:00',2.55),('12664','2013-03-19','08:40:00',2.63),('12664','2013-03-19','08:45:00',2.72),('12664','2013-03-19','08:50:00',2.64),('12664','2013-03-19','08:55:00',2.91),('12664','2013-03-19','09:00:00',3.01),('12664','2013-03-19','09:05:00',3.11),('12664','2013-03-19','09:10:00',3.2),('12664','2013-03-19','09:15:00',3.29),('12664','2013-03-19','09:20:00',3.35),('12664','2013-03-19','09:25:00',3.45),('12664','2013-03-19','09:30:00',3.52),('12664','2013-03-19','09:35:00',3.57),('12664','2013-03-19','09:40:00',3.66),('12664','2013-03-19','09:45:00',3.77),('12664','2013-03-19','09:50:00',3.89),('12664','2013-03-19','09:55:00',3.72),('12664','2013-03-19','10:00:00',3.99),('12664','2013-03-19','10:05:00',4.05),('12664','2013-03-19','10:10:00',4.1),('12664','2013-03-19','10:15:00',4.14),('12664','2013-03-19','10:20:00',4.22),('12664','2013-03-19','10:25:00',4.28),('12664','2013-03-19','10:30:00',4.31),('12664','2013-03-19','10:35:00',4.37),('12664','2013-03-19','10:40:00',4.4),('12664','2013-03-19','10:45:00',4.46),('12664','2013-03-19','10:50:00',4.53),('12664','2013-03-19','10:55:00',4.58),('12664','2013-03-19','11:00:00',4.6),('12664','2013-03-19','11:05:00',4.63),('12664','2013-03-19','11:10:00',4.66),('12664','2013-03-19','11:15:00',4.61),('12664','2013-03-19','11:20:00',4.67),('12664','2013-03-19','11:25:00',4.71),('12664','2013-03-19','11:30:00',4.33),('12664','2013-03-19','11:35:00',3.7),('12664','2013-03-19','11:40:00',3.94),('12664','2013-03-19','11:45:00',4.14),('12664','2013-03-19','11:50:00',4.59),('12664','2013-03-19','11:55:00',4.83),('12664','2013-03-19','12:00:00',4.84),('12664','2013-03-19','12:05:00',4.83),('12664','2013-03-19','12:10:00',4.81),('12664','2013-03-19','12:15:00',4.8),('12664','2013-03-19','12:20:00',4.75),('12664','2013-03-19','12:25:00',4.62),('12664','2013-03-19','12:30:00',4.76),('12664','2013-03-19','12:35:00',4.73),('12664','2013-03-19','12:40:00',4.73),('12664','2013-03-19','12:45:00',4.62),('12664','2013-03-19','12:50:00',4.63),('12664','2013-03-19','12:55:00',4.66),('12664','2013-03-19','13:00:00',4.66),('12664','2013-03-19','13:05:00',4.56),('12664','2013-03-19','13:10:00',4.59),('12664','2013-03-19','13:15:00',4.55),('12664','2013-03-19','13:20:00',4.53),('12664','2013-03-19','13:25:00',4.49),('12664','2013-03-19','13:30:00',4.47),('12664','2013-03-19','13:35:00',4.42),('12664','2013-03-19','13:40:00',4.33),('12664','2013-03-19','13:45:00',4.13),('12664','2013-03-19','13:50:00',4.28),('12664','2013-03-19','13:55:00',4.21),('12664','2013-03-19','14:00:00',4.16),('12664','2013-03-19','14:05:00',4.13),('12664','2013-03-19','14:10:00',4.08),('12664','2013-03-19','14:15:00',4.02),('12664','2013-03-19','14:20:00',3.94),('12664','2013-03-19','14:25:00',3.89),('12664','2013-03-19','14:30:00',3.82),('12664','2013-03-19','14:35:00',3.78),('12664','2013-03-19','14:40:00',3.72),('12664','2013-03-19','14:45:00',3.66),('12664','2013-03-19','14:50:00',3.59),('12664','2013-03-19','14:55:00',3.51),('12664','2013-03-19','15:00:00',3.43),('12664','2013-03-19','15:05:00',3.35),('12664','2013-03-19','15:10:00',3.28),('12664','2013-03-19','15:15:00',3.21),('12664','2013-03-19','15:20:00',3.11),('12664','2013-03-19','15:25:00',3.03),('12664','2013-03-19','15:30:00',2.94),('12664','2013-03-19','15:35:00',2.85),('12664','2013-03-19','15:40:00',2.75),('12664','2013-03-19','15:45:00',2.66),('12664','2013-03-19','15:50:00',2.56),('12664','2013-03-19','15:55:00',2.46),('12664','2013-03-19','16:00:00',2.36),('12664','2013-03-19','16:05:00',2.28),('12664','2013-03-19','16:10:00',2.16),('12664','2013-03-19','16:15:00',2.06),('12664','2013-03-19','16:20:00',1.94),('12664','2013-03-19','16:25:00',1.84),('12664','2013-03-19','16:30:00',1.76),('12664','2013-03-19','16:35:00',1.48),('12664','2013-03-19','16:40:00',1.52),('12664','2013-03-19','16:45:00',1.25),('12664','2013-03-19','16:55:00',1.13),('12664','2013-03-18','08:40:00',1.68),('12664','2013-03-18','08:45:00',1.11),('12664','2013-03-18','09:55:00',1.23),('12664','2013-03-18','10:00:00',1.48),('12664','2013-03-18','10:05:00',1.42),('12664','2013-03-18','10:10:00',1.51),('12664','2013-03-18','10:15:00',2.44),('12664','2013-03-18','10:20:00',2.43),('12664','2013-03-18','10:25:00',2.32),('12664','2013-03-18','10:30:00',1.82),('12664','2013-03-18','10:35:00',1.5),('12664','2013-03-18','10:40:00',1.65),('12664','2013-03-18','10:45:00',1.4),('12664','2013-03-18','11:00:00',1.18),('12664','2013-03-18','11:05:00',1.4),('12664','2013-03-18','11:10:00',1.71),('12664','2013-03-18','11:15:00',1.95),('12664','2013-03-18','11:20:00',2.08),('12664','2013-03-18','11:25:00',2.36),('12664','2013-03-18','11:30:00',2.14),('12664','2013-03-18','11:35:00',1.75),('12664','2013-03-18','11:40:00',1.34),('12664','2013-03-18','11:45:00',1.14),('12664','2013-03-18','11:50:00',1.08),('12664','2013-03-18','11:55:00',1.19),('12664','2013-03-18','12:00:00',1.41),('12664','2013-03-18','12:05:00',1.79),('12664','2013-03-18','12:10:00',2.1),('12664','2013-03-18','12:15:00',2.96),('12664','2013-03-18','12:20:00',3.96),('12664','2013-03-18','12:25:00',4.39),('12664','2013-03-18','12:30:00',3.51),('12664','2013-03-18','12:35:00',1.89),('12664','2013-03-18','12:40:00',2.24),('12664','2013-03-18','12:45:00',3.24),('12664','2013-03-18','12:50:00',3.66),('12664','2013-03-18','12:55:00',2.09),('12664','2013-03-18','13:00:00',1.27),('12664','2013-03-18','13:05:00',1.43),('12664','2013-03-18','13:10:00',1.14),('12664','2013-03-18','13:15:00',1.14),('12664','2013-03-18','13:20:00',2.33),('12664','2013-03-18','13:25:00',1.82),('12664','2013-03-18','13:30:00',1.04),('12664','2013-03-18','13:35:00',1.52),('12664','2013-03-18','13:40:00',1.49),('12664','2013-03-18','13:45:00',1.37),('12664','2013-03-18','13:55:00',1.29),('12664','2013-03-18','14:00:00',1.97),('12664','2013-03-18','14:05:00',1.72),('12664','2013-03-18','14:10:00',1.69),('12664','2013-03-18','14:20:00',1.02),('12664','2013-03-18','14:35:00',1.09),('12664','2013-03-18','14:40:00',1.02),('12664','2013-03-18','14:55:00',1),('12664','2013-03-17','08:15:00',1.02),('12664','2013-03-17','08:20:00',1.51),('12664','2013-03-17','08:25:00',1.48),('12664','2013-03-17','08:30:00',1.37),('12664','2013-03-17','08:35:00',1.24),('12664','2013-03-17','08:40:00',1.41),('12664','2013-03-17','08:45:00',1.48),('12664','2013-03-17','08:50:00',1.3),('12664','2013-03-17','08:55:00',1.22),('12664','2013-03-17','09:00:00',1.5),('12664','2013-03-17','09:05:00',1.8),('12664','2013-03-17','09:10:00',1.78),('12664','2013-03-17','09:15:00',1.65),('12664','2013-03-17','09:20:00',1.46),('12664','2013-03-17','09:25:00',1.33),('12664','2013-03-17','09:30:00',1.65),('12664','2013-03-17','09:35:00',1.58),('12664','2013-03-17','09:40:00',1.56),('12664','2013-03-17','09:45:00',1.71),('12664','2013-03-17','09:50:00',1.8),('12664','2013-03-17','09:55:00',1.96),('12664','2013-03-17','10:00:00',1.85),('12664','2013-03-17','10:05:00',1.69),('12664','2013-03-17','10:10:00',1.78),('12664','2013-03-17','10:15:00',1.85),('12664','2013-03-17','10:20:00',1.94),('12664','2013-03-17','10:25:00',2.02),('12664','2013-03-17','10:30:00',1.93),('12664','2013-03-17','10:35:00',1.93),('12664','2013-03-17','10:40:00',1.91),('12664','2013-03-17','10:45:00',1.79),('12664','2013-03-17','10:50:00',1.46),('12664','2013-03-17','10:55:00',1.36),('12664','2013-03-17','11:00:00',1.49),('12664','2013-03-17','11:05:00',1.62),('12664','2013-03-17','11:10:00',1.67),('12664','2013-03-17','11:15:00',2.12),('12664','2013-03-17','11:20:00',2.45),('12664','2013-03-17','11:25:00',1.98),('12664','2013-03-17','11:30:00',1.8),('12664','2013-03-17','11:35:00',1.73),('12664','2013-03-17','11:40:00',1.56),('12664','2013-03-17','11:45:00',1.37),('12664','2013-03-17','11:50:00',1.26),('12664','2013-03-17','11:55:00',1.16),('12664','2013-03-17','12:00:00',1.1),('12664','2013-03-17','12:05:00',1.38),('12664','2013-03-17','12:10:00',1.91),('12664','2013-03-17','12:15:00',2.52),('12664','2013-03-17','12:20:00',2.64),('12664','2013-03-17','12:25:00',2.7),('12664','2013-03-17','12:30:00',2.37),('12664','2013-03-17','12:35:00',2.42),('12664','2013-03-17','12:40:00',2.46),('12664','2013-03-17','12:45:00',2.25),('12664','2013-03-17','12:50:00',1.8),('12664','2013-03-17','12:55:00',1.92),('12664','2013-03-17','13:00:00',1.94),('12664','2013-03-17','13:05:00',1.87),('12664','2013-03-17','13:10:00',1.77),('12664','2013-03-17','13:15:00',1.59),('12664','2013-03-17','13:20:00',1.58),('12664','2013-03-17','13:25:00',2.59),('12664','2013-03-17','13:30:00',2.42),('12664','2013-03-17','13:35:00',2.14),('12664','2013-03-17','13:40:00',1.76),('12664','2013-03-17','13:45:00',1.4),('12664','2013-03-17','13:50:00',1.94),('12664','2013-03-17','13:55:00',2.14),('12664','2013-03-17','14:00:00',2.1),('12664','2013-03-17','14:05:00',2.66),('12664','2013-03-17','14:10:00',2.65),('12664','2013-03-17','14:15:00',2.92),('12664','2013-03-17','14:20:00',2.27),('12664','2013-03-17','14:25:00',2.34),('12664','2013-03-17','14:30:00',2.74),('12664','2013-03-17','14:35:00',2.59),('12664','2013-03-17','14:40:00',1.79),('12664','2013-03-17','14:45:00',1.46),('12664','2013-03-17','14:50:00',1.32),('12664','2013-03-17','14:55:00',1.99),('12664','2013-03-17','15:00:00',1.95),('12664','2013-03-17','15:05:00',3.88),('12664','2013-03-17','15:10:00',3.95),('12664','2013-03-17','15:15:00',3.68),('12664','2013-03-17','15:20:00',2.09),('12664','2013-03-17','15:25:00',2.36),('12664','2013-03-17','15:30:00',1.51),('12664','2013-03-17','15:35:00',1.13),('12664','2013-03-17','15:40:00',1.25),('12664','2013-03-17','15:45:00',1.02),('12664','2013-03-16','07:50:00',1.36),('12664','2013-03-16','07:55:00',1.18),('12664','2013-03-16','08:00:00',1.58),('12664','2013-03-16','08:05:00',1.46),('12664','2013-03-16','08:10:00',2.03),('12664','2013-03-16','08:15:00',1.95),('12664','2013-03-16','08:20:00',2.44),('12664','2013-03-16','08:25:00',2.37),('12664','2013-03-16','08:30:00',2.45),('12664','2013-03-16','08:35:00',2.72),('12664','2013-03-16','08:40:00',2.99),('12664','2013-03-16','08:45:00',3.22),('12664','2013-03-16','08:50:00',2.11),('12664','2013-03-16','08:55:00',2.27),('12664','2013-03-16','09:00:00',3.25),('12664','2013-03-16','09:05:00',3.34),('12664','2013-03-16','09:10:00',3.33),('12664','2013-03-16','09:15:00',3.31),('12664','2013-03-16','09:20:00',3.38),('12664','2013-03-16','09:25:00',3.51),('12664','2013-03-16','09:30:00',3.42),('12664','2013-03-16','09:35:00',3.56),('12664','2013-03-16','09:40:00',3.7),('12664','2013-03-16','09:45:00',3.88),('12664','2013-03-16','09:50:00',3.35),('12664','2013-03-16','09:55:00',2.72),('12664','2013-03-16','10:00:00',2.57),('12664','2013-03-16','10:05:00',2.14),('12664','2013-03-16','10:10:00',2.28),('12664','2013-03-16','10:15:00',2.51),('12664','2013-03-16','10:20:00',2.3),('12664','2013-03-16','10:25:00',4.07),('12664','2013-03-16','10:30:00',4.26),('12664','2013-03-16','10:35:00',4.43),('12664','2013-03-16','10:40:00',4.42),('12664','2013-03-16','10:45:00',4.45),('12664','2013-03-16','10:50:00',4.47),('12664','2013-03-16','10:55:00',4.45),('12664','2013-03-16','11:00:00',4.49),('12664','2013-03-16','11:05:00',4.48),('12664','2013-03-16','11:10:00',4.54),('12664','2013-03-16','11:15:00',4.56),('12664','2013-03-16','11:20:00',4.55),('12664','2013-03-16','11:25:00',4.56),('12664','2013-03-16','11:30:00',4.58),('12664','2013-03-16','11:35:00',4.59),('12664','2013-03-16','11:40:00',4.6),('12664','2013-03-16','11:45:00',4.58),('12664','2013-03-16','11:50:00',4.65),('12664','2013-03-16','11:55:00',4.74),('12664','2013-03-16','12:00:00',4.69),('12664','2013-03-16','12:05:00',4.69),('12664','2013-03-16','12:10:00',4.74),('12664','2013-03-16','12:15:00',4.75),('12664','2013-03-16','12:20:00',4.8),('12664','2013-03-16','12:25:00',4.9),('12664','2013-03-16','12:30:00',5.03),('12664','2013-03-16','12:35:00',4.12),('12664','2013-03-16','12:40:00',5.02),('12664','2013-03-16','12:45:00',4.89),('12664','2013-03-16','12:50:00',2.01),('12664','2013-03-16','13:10:00',1.52),('12664','2013-03-16','13:15:00',2.64),('12664','2013-03-16','13:20:00',3.12),('12664','2013-03-16','13:25:00',4.84),('12664','2013-03-16','13:30:00',4.73),('12664','2013-03-16','13:35:00',4.83),('12664','2013-03-16','13:40:00',4.72),('12664','2013-03-16','13:45:00',4.29),('12664','2013-03-16','13:50:00',2.21),('12664','2013-03-16','13:55:00',4.51),('12664','2013-03-16','14:00:00',3.58),('12664','2013-03-16','14:05:00',4.12),('12664','2013-03-16','14:10:00',4.13),('12664','2013-03-16','14:15:00',2.34),('12664','2013-03-16','14:25:00',1.02),('12664','2013-03-16','14:30:00',3.04),('12664','2013-03-16','14:35:00',3),('12664','2013-03-16','15:10:00',3.4),('12664','2013-03-16','15:15:00',3.4),('12664','2013-03-16','15:20:00',3.24),('12664','2013-03-16','15:25:00',3.07),('12664','2013-03-16','15:30:00',2.74),('12664','2013-03-16','15:35:00',1.82),('12664','2013-03-16','15:40:00',2.67),('12664','2013-03-16','15:45:00',2.13),('12664','2013-03-16','15:50:00',2.59),('12664','2013-03-16','15:55:00',2.23),('12664','2013-03-16','16:05:00',1.85),('12664','2013-03-16','16:10:00',1.31),('12664','2013-03-16','16:15:00',2.31),('12664','2013-03-16','16:20:00',2.32),('12664','2013-03-16','16:25:00',2.14),('12664','2013-03-16','16:30:00',1.91),('12664','2013-03-16','16:35:00',1.79),('12664','2013-03-16','16:40:00',1.34),('12664','2013-03-16','16:55:00',1.05),('12664','2013-03-16','17:00:00',1.09),('12664','2013-03-15','10:25:00',1.23),('12664','2013-03-15','10:30:00',1.42),('12664','2013-03-15','10:35:00',1.39),('12664','2013-03-15','10:40:00',1.38),('12664','2013-03-15','10:45:00',1.18),('12664','2013-03-15','10:50:00',1.18),('12664','2013-03-15','10:55:00',1.59),('12664','2013-03-15','11:00:00',1.53),('12664','2013-03-15','11:05:00',1.25),('12664','2013-03-15','11:10:00',1.08),('12664','2013-03-15','11:15:00',1.03),('12664','2013-03-15','11:20:00',1.09),('12664','2013-03-15','11:25:00',1.17),('12664','2013-03-15','11:30:00',1.4),('12664','2013-03-15','11:35:00',1.69),('12664','2013-03-15','11:40:00',1.94),('12664','2013-03-15','11:45:00',1.59),('12664','2013-03-15','11:50:00',1.45),('12664','2013-03-15','11:55:00',1.85),('12664','2013-03-15','12:00:00',2.14),('12664','2013-03-15','12:05:00',1.89),('12664','2013-03-15','12:10:00',2.06),('12664','2013-03-15','12:15:00',2.39),('12664','2013-03-15','12:20:00',2.33),('12664','2013-03-15','12:25:00',2.09),('12664','2013-03-15','12:30:00',1.72),('12664','2013-03-15','12:35:00',1.58),('12664','2013-03-15','12:40:00',1.63),('12664','2013-03-15','12:45:00',1.61),('12664','2013-03-15','12:50:00',1.48),('12664','2013-03-15','12:55:00',1.4),('12664','2013-03-15','13:00:00',1.52),('12664','2013-03-15','13:05:00',1.68),('12664','2013-03-15','13:10:00',1.97),('12664','2013-03-15','13:15:00',2.61),('12664','2013-03-15','13:20:00',2.46),('12664','2013-03-15','13:25:00',1.84),('12664','2013-03-15','13:30:00',1.58),('12664','2013-03-15','13:35:00',1.36),('12664','2013-03-15','13:40:00',1.13),('12664','2013-03-15','13:45:00',1.04),('12664','2013-03-15','13:50:00',1.16),('12664','2013-03-15','13:55:00',1.18),('12664','2013-03-15','14:00:00',1.01),('12664','2013-03-15','14:35:00',1.2),('12664','2013-03-15','14:40:00',1.31),('12664','2013-03-15','14:45:00',1.34),('12664','2013-03-15','14:50:00',1.35),('12664','2013-03-15','14:55:00',1.32),('12664','2013-03-15','15:00:00',1.34),('12664','2013-03-15','15:05:00',1.29),('12664','2013-03-15','15:10:00',1.32),('12664','2013-03-15','15:15:00',1.4),('12664','2013-03-15','15:20:00',1.34),('12664','2013-03-15','15:25:00',1.2),('12664','2013-03-15','15:30:00',1.19),('12664','2013-03-15','15:35:00',1.1),('12664','2013-03-15','17:00:00',1.06),('12664','2013-03-14','12:30:00',1.08),('12664','2013-03-14','12:35:00',1.15),('12664','2013-03-14','12:40:00',1.24),('12664','2013-03-14','12:45:00',1.29),('12664','2013-03-14','12:50:00',1.35),('12664','2013-03-14','12:55:00',1.43),('12664','2013-03-14','13:00:00',1.35),('12664','2013-03-14','13:05:00',1.29),('12664','2013-03-14','13:10:00',1.4),('12664','2013-03-14','13:15:00',1.7),('12664','2013-03-14','13:20:00',1.84),('12664','2013-03-14','13:25:00',1.8),('12664','2013-03-14','13:30:00',1.79),('12664','2013-03-14','13:35:00',1.38),('12664','2013-03-14','13:40:00',1.52),('12664','2013-03-14','13:45:00',1.6),('12664','2013-03-14','13:50:00',1.35),('12664','2013-03-14','13:55:00',1.43),('12664','2013-03-14','14:00:00',1.23),('12664','2013-03-14','14:05:00',1.55),('12664','2013-03-14','14:10:00',1.51),('12664','2013-03-14','14:15:00',1.58),('12664','2013-03-14','14:20:00',1.19),('12664','2013-03-14','15:15:00',1.05),('12664','2013-03-13','09:15:00',1.33),('12664','2013-03-13','09:20:00',1.55),('12664','2013-03-13','09:25:00',1.41),('12664','2013-03-13','09:30:00',1.25),('12664','2013-03-13','10:40:00',3.14),('12664','2013-03-13','10:45:00',3.15),('12664','2013-03-13','10:50:00',2.68),('12664','2013-03-13','10:55:00',1.81),('12664','2013-03-13','11:10:00',1.26),('12664','2013-03-13','11:15:00',1.34),('12664','2013-03-13','11:30:00',1.49),('12664','2013-03-13','11:35:00',1.87),('12664','2013-03-13','11:40:00',1.67),('12664','2013-03-13','11:45:00',1.64),('12664','2013-03-13','11:50:00',1.63),('12664','2013-03-13','11:55:00',1.43),('12664','2013-03-13','12:40:00',1.08),('12664','2013-03-13','12:45:00',1.12),('12664','2013-03-13','12:50:00',1.2),('12664','2013-03-13','12:55:00',1.23),('12664','2013-03-13','13:00:00',1.17),('12664','2013-03-13','13:05:00',1.12),('12664','2013-03-13','13:10:00',1.11),('12664','2013-03-13','13:30:00',1.08),('12664','2013-03-13','13:35:00',1.29),('12664','2013-03-13','13:40:00',1.77),('12664','2013-03-13','13:45:00',1.49),('12664','2013-03-13','13:50:00',1.25),('12664','2013-03-12','08:15:00',2.12),('12664','2013-03-12','08:25:00',2),('12664','2013-03-12','08:30:00',2.27),('12664','2013-03-12','08:35:00',2.15),('12664','2013-03-12','08:40:00',2.29),('12664','2013-03-12','08:45:00',2.52),('12664','2013-03-12','08:50:00',2.57),('12664','2013-03-12','08:55:00',2.74),('12664','2013-03-12','09:00:00',2.82),('12664','2013-03-12','09:05:00',2.89),('12664','2013-03-12','09:10:00',2.98),('12664','2013-03-12','09:15:00',3.08),('12664','2013-03-12','09:20:00',3.17),('12664','2013-03-12','09:25:00',3.25),('12664','2013-03-12','09:30:00',3.33),('12664','2013-03-12','09:35:00',3.42),('12664','2013-03-12','09:40:00',3.49),('12664','2013-03-12','09:45:00',3.48),('12664','2013-03-12','09:50:00',3.02),('12664','2013-03-12','09:55:00',3.09),('12664','2013-03-12','10:00:00',3.13),('12664','2013-03-12','10:05:00',3.01),('12664','2013-03-12','10:10:00',2.99),('12664','2013-03-12','10:15:00',3.41),('12664','2013-03-12','10:20:00',4.38),('12664','2013-03-12','10:25:00',3.39),('12664','2013-03-12','10:30:00',4.03),('12664','2013-03-12','10:35:00',3.66),('12664','2013-03-12','10:40:00',4.34),('12664','2013-03-12','10:45:00',4.09),('12664','2013-03-12','10:50:00',3.71),('12664','2013-03-12','10:55:00',4.48),('12664','2013-03-12','11:00:00',4.49),('12664','2013-03-12','11:05:00',2.63),('12664','2013-03-12','11:10:00',4.16),('12664','2013-03-12','11:15:00',4.3),('12664','2013-03-12','11:20:00',3.49),('12664','2013-03-12','11:25:00',1.47),('12664','2013-03-12','11:35:00',2.45),('12664','2013-03-12','11:40:00',1.79),('12664','2013-03-12','11:45:00',1.62),('12664','2013-03-12','11:50:00',4.71),('12664','2013-03-12','11:55:00',5),('12664','2013-03-12','12:00:00',3),('12664','2013-03-12','12:05:00',1.42),('12664','2013-03-12','12:15:00',1.4),('12664','2013-03-12','12:20:00',2.02),('12664','2013-03-12','12:25:00',2.55),('12664','2013-03-12','12:30:00',2.4),('12664','2013-03-12','12:35:00',2.77),('12664','2013-03-12','12:40:00',3.26),('12664','2013-03-12','12:45:00',4.31),('12664','2013-03-12','12:50:00',1.59),('12664','2013-03-12','12:55:00',2.77),('12664','2013-03-12','13:00:00',3.85),('12664','2013-03-12','13:05:00',3.36),('12664','2013-03-12','13:10:00',3.14),('12664','2013-03-12','13:15:00',2.05),('12664','2013-03-12','13:20:00',2.38),('12664','2013-03-12','13:25:00',1.75),('12664','2013-03-12','13:30:00',3.27),('12664','2013-03-12','13:35:00',2.45),('12664','2013-03-12','13:40:00',2.82),('12664','2013-03-12','13:45:00',3.74),('12664','2013-03-12','13:50:00',4),('12664','2013-03-12','13:55:00',2.91),('12664','2013-03-12','14:00:00',3.35),('12664','2013-03-12','14:05:00',2.8),('12664','2013-03-12','14:10:00',3.81),('12664','2013-03-12','14:15:00',2.45),('12664','2013-03-12','14:20:00',3.45),('12664','2013-03-12','14:25:00',2.82),('12664','2013-03-12','14:55:00',2.24),('12664','2013-03-12','15:00:00',2.23),('12664','2013-03-12','15:05:00',1.66),('12664','2013-03-12','15:10:00',2.13),('12664','2013-03-12','15:15:00',1.79),('12664','2013-03-12','15:20:00',2.03),('12664','2013-03-12','15:25:00',1.17),('12664','2014-03-24','08:45:00',1.57),('12664','2014-03-24','08:50:00',1.44),('12664','2014-03-24','09:15:00',3.24),('12664','2014-03-24','09:20:00',1.72),('12664','2014-03-24','09:25:00',1.95),('12664','2014-03-24','09:30:00',1.05),('12664','2014-03-24','09:35:00',3.16),('12664','2014-03-24','09:40:00',1.22),('12664','2014-03-24','09:45:00',1.17),('12664','2014-03-24','09:55:00',3.1),('12664','2014-03-24','10:00:00',3.9),('12664','2014-03-24','10:05:00',1.63),('12664','2014-03-24','10:10:00',1.49),('12664','2014-03-24','10:15:00',1.14),('12664','2014-03-24','10:20:00',2.51),('12664','2014-03-24','10:25:00',1.76),('12664','2014-03-24','10:30:00',2.04),('12664','2014-03-24','10:35:00',1.42),('12664','2014-03-24','10:40:00',1.65),('12664','2014-03-24','10:45:00',3.42),('12664','2014-03-24','10:50:00',4.34),('12664','2014-03-24','10:55:00',4.12),('12664','2014-03-24','11:00:00',3.3),('12664','2014-03-24','11:05:00',3.71),('12664','2014-03-24','11:10:00',3.19),('12664','2014-03-24','11:15:00',3.67),('12664','2014-03-24','11:20:00',3.68),('12664','2014-03-24','11:25:00',4),('12664','2014-03-24','11:30:00',1.37),('12664','2014-03-24','12:20:00',1.1),('12664','2014-03-24','12:25:00',1.6),('12664','2014-03-24','12:30:00',2),('12664','2014-03-24','12:35:00',1.82),('12664','2014-03-24','12:40:00',1.4),('12664','2014-03-24','12:45:00',1.41),('12664','2014-03-24','12:50:00',1.4),('12664','2014-03-24','12:55:00',1.4),('12664','2014-03-24','13:00:00',1.47),('12664','2014-03-24','13:05:00',1.5),('12664','2014-03-24','13:10:00',1.99),('12664','2014-03-24','13:15:00',2.3),('12664','2014-03-24','13:20:00',2.29),('12664','2014-03-24','13:25:00',2.21),('12664','2014-03-24','13:30:00',1.91),('12664','2014-03-24','13:35:00',1.29),('12664','2014-03-24','13:40:00',1.16),('12664','2014-03-24','13:45:00',1.13),('12664','2014-03-24','14:00:00',1.12),('12664','2014-03-24','14:05:00',1.21),('12664','2014-03-24','14:10:00',1.45),('12664','2014-03-24','14:15:00',2.04),('12664','2014-03-24','14:20:00',2.45),('12664','2014-03-24','14:25:00',2.14),('12664','2014-03-24','14:30:00',2.55),('12664','2014-03-24','14:35:00',2.71),('12664','2014-03-24','14:40:00',2.41),('12664','2014-03-24','14:45:00',1.96),('12664','2014-03-24','14:50:00',2.35),('12664','2014-03-24','14:55:00',1.58),('12664','2014-03-24','15:00:00',2.38),('12664','2014-03-24','15:05:00',2.33),('12664','2014-03-24','15:10:00',1.95),('12664','2014-03-24','15:15:00',1.94),('12664','2014-03-24','15:20:00',1.99),('12664','2014-03-24','15:25:00',1.65),('12664','2014-03-24','15:30:00',1.57),('12664','2014-03-24','15:35:00',1.15),('12664','2014-03-24','15:40:00',1.02),('12664','2014-03-24','15:45:00',1.19),('12664','2014-03-24','15:50:00',1.91),('12664','2014-03-24','15:55:00',1.01),('12664','2013-03-11','08:00:00',1.12),('12664','2013-03-11','08:05:00',1.65),('12664','2013-03-11','08:10:00',1.78),('12664','2013-03-11','08:15:00',1.98),('12664','2013-03-11','08:20:00',2.03),('12664','2013-03-11','08:25:00',2.07),('12664','2013-03-11','08:30:00',2.21),('12664','2013-03-11','08:35:00',2.15),('12664','2013-03-11','08:40:00',1.47),('12664','2013-03-11','08:45:00',1.8),('12664','2013-03-11','08:50:00',2.64),('12664','2013-03-11','08:55:00',2.65),('12664','2013-03-11','09:00:00',3),('12664','2013-03-11','09:05:00',3.11),('12664','2013-03-11','09:10:00',3),('12664','2013-03-11','09:15:00',3.07),('12664','2013-03-11','09:20:00',2.81),('12664','2013-03-11','09:25:00',3.61),('12664','2013-03-11','09:30:00',3.19),('12664','2013-03-11','09:35:00',3.77),('12664','2013-03-11','09:40:00',3.46),('12664','2013-03-11','09:45:00',2.87),('12664','2013-03-11','09:50:00',1.49),('12664','2013-03-11','09:55:00',1.25),('12664','2013-03-11','10:00:00',1.53),('12664','2013-03-11','10:05:00',2.13),('12664','2013-03-11','10:10:00',1.83),('12664','2013-03-11','10:15:00',1.62),('12664','2013-03-11','10:20:00',1.78),('12664','2013-03-11','10:25:00',1.91),('12664','2013-03-11','10:30:00',2.27),('12664','2013-03-11','10:35:00',2.98),('12664','2013-03-11','10:40:00',2.23),('12664','2013-03-11','10:45:00',3.86),('12664','2013-03-11','10:50:00',3.18),('12664','2013-03-11','10:55:00',2.11),('12664','2013-03-11','11:00:00',2.02),('12664','2013-03-11','11:05:00',1.71),('12664','2013-03-11','11:10:00',1.7),('12664','2013-03-11','11:15:00',1.77),('12664','2013-03-11','11:20:00',1.42),('12664','2013-03-11','11:25:00',1.34),('12664','2013-03-11','11:30:00',1.55),('12664','2013-03-11','11:35:00',1.69),('12664','2013-03-11','11:40:00',1.92),('12664','2013-03-11','11:45:00',2.57),('12664','2013-03-11','11:50:00',2.4),('12664','2013-03-11','11:55:00',2.81),('12664','2013-03-11','12:00:00',2.04),('12664','2013-03-11','12:05:00',2.69),('12664','2013-03-11','12:10:00',2.96),('12664','2013-03-11','12:15:00',3.99),('12664','2013-03-11','12:20:00',4.52),('12664','2013-03-11','12:25:00',3.54),('12664','2013-03-11','12:30:00',4.43),('12664','2013-03-11','12:35:00',4.61),('12664','2013-03-11','12:40:00',3.28),('12664','2013-03-11','12:45:00',4.36),('12664','2013-03-11','12:50:00',5.02),('12664','2013-03-11','12:55:00',4.75),('12664','2013-03-11','13:00:00',4.88),('12664','2013-03-11','13:05:00',3.88),('12664','2013-03-11','13:10:00',4.61),('12664','2013-03-11','13:15:00',4.21),('12664','2013-03-11','13:20:00',4.39),('12664','2013-03-11','13:25:00',4.51),('12664','2013-03-11','13:30:00',4.44),('12664','2013-03-11','13:35:00',4),('12664','2013-03-11','13:40:00',1.66),('12664','2013-03-11','13:45:00',4.69),('12664','2013-03-11','13:50:00',4.43),('12664','2013-03-11','13:55:00',4.32),('12664','2013-03-11','14:00:00',4.17),('12664','2013-03-11','14:05:00',4.25),('12664','2013-03-11','14:10:00',4.31),('12664','2013-03-11','14:15:00',4.19),('12664','2013-03-11','14:20:00',4.15),('12664','2013-03-11','14:25:00',3.75),('12664','2013-03-11','14:30:00',2.87),('12664','2013-03-11','14:35:00',4.05),('12664','2013-03-11','14:40:00',3.78),('12664','2013-03-11','14:45:00',3.67),('12664','2013-03-11','14:50:00',3.63),('12664','2013-03-11','14:55:00',2.72),('12664','2013-03-11','15:00:00',3.41),('12664','2013-03-11','15:05:00',3.4),('12664','2013-03-11','15:10:00',3.35),('12664','2013-03-11','15:15:00',3.19),('12664','2013-03-11','15:20:00',3.11),('12664','2013-03-11','15:25:00',2.91),('12664','2013-03-11','15:30:00',3.1),('12664','2013-03-11','15:35:00',2.91),('12664','2013-03-11','15:40:00',2.74),('12664','2013-03-11','15:45:00',2.71),('12664','2013-03-11','15:50:00',2.42),('12664','2013-03-11','15:55:00',2.24),('12664','2013-03-11','16:00:00',1.99),('12664','2013-03-11','16:05:00',1.85),('12664','2013-03-11','16:10:00',1.7),('12664','2013-03-11','16:15:00',1.84),('12664','2013-03-11','16:20:00',1.71),('12664','2013-03-11','16:25:00',1.57),('12664','2013-03-11','16:30:00',1.46),('12664','2013-03-10','07:40:00',1.07),('12664','2013-03-10','07:45:00',1.19),('12664','2013-03-10','07:50:00',1.31),('12664','2013-03-10','07:55:00',1.44),('12664','2013-03-10','08:00:00',1.57),('12664','2013-03-10','08:05:00',1.67),('12664','2013-03-10','08:10:00',1.67),('12664','2013-03-10','08:15:00',1.86),('12664','2013-03-10','08:20:00',2),('12664','2013-03-10','08:25:00',2.1),('12664','2013-03-10','08:30:00',2.21),('12664','2013-03-10','08:35:00',2.15),('12664','2013-03-10','08:40:00',2.4),('12664','2013-03-10','08:45:00',2.51),('12664','2013-03-10','08:50:00',2.61),('12664','2013-03-10','08:55:00',2.68),('12664','2013-03-10','09:00:00',2.78),('12664','2013-03-10','09:05:00',2.86),('12664','2013-03-10','09:10:00',2.93),('12664','2013-03-10','09:15:00',3.05),('12664','2013-03-10','09:20:00',3.14),('12664','2013-03-10','09:25:00',3.22),('12664','2013-03-10','09:30:00',3.33),('12664','2013-03-10','09:35:00',3.49),('12664','2013-03-10','09:40:00',3.68),('12664','2013-03-10','09:45:00',3.61),('12664','2013-03-10','09:50:00',3.62),('12664','2013-03-10','09:55:00',3.64),('12664','2013-03-10','10:00:00',3.63),('12664','2013-03-10','10:05:00',3.74),('12664','2013-03-10','10:10:00',3.81),('12664','2013-03-10','10:15:00',3.47),('12664','2013-03-10','10:20:00',3.89),('12664','2013-03-10','10:25:00',3.28),('12664','2013-03-10','10:30:00',1.56),('12664','2013-03-10','10:35:00',3.52),('12664','2013-03-10','10:40:00',1.3),('12664','2013-03-10','10:45:00',4.09),('12664','2013-03-10','10:50:00',3.97),('12664','2013-03-10','10:55:00',4.33),('12664','2013-03-10','11:00:00',4.29),('12664','2013-03-10','11:05:00',3.52),('12664','2013-03-10','11:10:00',3.72),('12664','2013-03-10','11:15:00',4.34),('12664','2013-03-10','11:20:00',4.38),('12664','2013-03-10','11:25:00',3.39),('12664','2013-03-10','11:30:00',3.97),('12664','2013-03-10','11:35:00',3.4),('12664','2013-03-10','11:40:00',2.17),('12664','2013-03-10','11:45:00',4.56),('12664','2013-03-10','11:50:00',4.53),('12664','2013-03-10','11:55:00',4.53),('12664','2013-03-10','12:00:00',3.81),('12664','2013-03-10','12:05:00',4.59),('12664','2013-03-10','12:10:00',4.29),('12664','2013-03-10','12:15:00',4.5),('12664','2013-03-10','12:20:00',3.56),('12664','2013-03-10','12:25:00',4.66),('12664','2013-03-10','12:30:00',4.52),('12664','2013-03-10','12:35:00',4.19),('12664','2013-03-10','12:40:00',4.36),('12664','2013-03-10','12:45:00',2.87),('12664','2013-03-10','12:50:00',4.55),('12664','2013-03-10','12:55:00',4.96),('12664','2013-03-10','13:00:00',4.7),('12664','2013-03-10','13:05:00',4.57),('12664','2013-03-10','13:10:00',3.89),('12664','2013-03-10','13:15:00',3.34),('12664','2013-03-10','13:20:00',4.69),('12664','2013-03-10','13:25:00',4.39),('12664','2013-03-10','13:30:00',3.44),('12664','2013-03-10','13:35:00',2.75),('12664','2013-03-10','13:40:00',2.71),('12664','2013-03-10','13:45:00',2.13),('12664','2013-03-10','13:50:00',1.83),('12664','2013-03-10','13:55:00',1.67),('12664','2013-03-10','14:00:00',1.52),('12664','2013-03-10','14:05:00',1.75),('12664','2013-03-10','14:10:00',1.79),('12664','2013-03-10','14:15:00',1.81),('12664','2013-03-10','14:20:00',1.88),('12664','2013-03-10','14:25:00',2.1),('12664','2013-03-10','14:30:00',1.68),('12664','2013-03-10','14:35:00',1.6),('12664','2013-03-10','14:40:00',1.75),('12664','2013-03-10','14:45:00',1.43),('12664','2013-03-10','14:50:00',1.54),('12664','2013-03-10','14:55:00',1.09),('12664','2013-03-10','15:15:00',1.11),('12664','2013-03-09','07:45:00',1.15),('12664','2013-03-09','08:05:00',1.59),('12664','2013-03-09','08:10:00',1.7),('12664','2013-03-09','08:15:00',1.84),('12664','2013-03-09','08:20:00',2.11),('12664','2013-03-09','08:25:00',2.1),('12664','2013-03-09','08:30:00',2.16),('12664','2013-03-09','08:35:00',2.25),('12664','2013-03-09','08:40:00',2.36),('12664','2013-03-09','08:45:00',2.46),('12664','2013-03-09','08:50:00',2.55),('12664','2013-03-09','08:55:00',2.65),('12664','2013-03-09','09:00:00',2.67),('12664','2013-03-09','09:05:00',1.7),('12664','2013-03-09','09:10:00',1.45),('12664','2013-03-09','09:15:00',1.68),('12664','2013-03-09','09:20:00',3.57),('12664','2013-03-09','09:25:00',1.84),('12664','2013-03-09','09:30:00',1.09),('12664','2013-03-09','09:35:00',1.73),('12664','2013-03-09','09:40:00',2.02),('12664','2013-03-09','09:45:00',3.16),('12664','2013-03-09','09:50:00',3.52),('12664','2013-03-09','09:55:00',1.16),('12664','2013-03-09','10:00:00',1.2),('12664','2013-03-09','10:05:00',1.04),('12664','2013-03-09','10:10:00',3.97),('12664','2013-03-09','10:15:00',1.98),('12664','2013-03-09','10:20:00',3.1),('12664','2013-03-09','10:25:00',1.91),('12664','2013-03-09','10:30:00',1.54),('12664','2013-03-09','10:35:00',2.56),('12664','2013-03-09','10:40:00',4.76),('12664','2013-03-09','10:45:00',4.59),('12664','2013-03-09','10:50:00',4.28),('12664','2013-03-09','10:55:00',4.23),('12664','2013-03-09','11:00:00',4.23),('12664','2013-03-09','11:05:00',4.35),('12664','2013-03-09','11:10:00',4.35),('12664','2013-03-09','11:15:00',4.43),('12664','2013-03-09','11:20:00',4.48),('12664','2013-03-09','11:25:00',4.44),('12664','2013-03-09','11:30:00',4.49),('12664','2013-03-09','11:35:00',4.26),('12664','2013-03-09','11:40:00',4.38),('12664','2013-03-09','11:45:00',4.43),('12664','2013-03-09','11:50:00',4.5),('12664','2013-03-09','11:55:00',4.45),('12664','2013-03-09','12:00:00',4.44),('12664','2013-03-09','12:05:00',4.52),('12664','2013-03-09','12:10:00',3.96),('12664','2013-03-09','12:15:00',3.56),('12664','2013-03-09','12:20:00',3.59),('12664','2013-03-09','12:25:00',3.71),('12664','2013-03-09','12:30:00',2.58),('12664','2013-03-09','12:35:00',2.58),('12664','2013-03-09','12:40:00',4.85),('12664','2013-03-09','12:45:00',4.3),('12664','2013-03-09','12:50:00',4.6),('12664','2013-03-09','12:55:00',4.27),('12664','2013-03-09','13:00:00',4.38),('12664','2013-03-09','13:05:00',4.35),('12664','2013-03-09','13:10:00',4.4),('12664','2013-03-09','13:15:00',3.74),('12664','2013-03-09','13:20:00',3.67),('12664','2013-03-09','13:25:00',4.44),('12664','2013-03-09','13:30:00',4.21),('12664','2013-03-09','13:35:00',4.15),('12664','2013-03-09','13:40:00',4.16),('12664','2013-03-09','13:45:00',4.12),('12664','2013-03-09','13:50:00',3.55),('12664','2013-03-09','13:55:00',4.11),('12664','2013-03-09','14:00:00',3.97),('12664','2013-03-09','14:05:00',3.88),('12664','2013-03-09','14:10:00',3.81),('12664','2013-03-09','14:15:00',3.28),('12664','2013-03-09','14:20:00',3.78),('12664','2013-03-09','14:25:00',2.09),('12664','2013-03-09','14:30:00',2.66),('12664','2013-03-09','14:35:00',1.72),('12664','2013-03-09','14:40:00',3.74),('12664','2013-03-09','14:45:00',3.07),('12664','2013-03-09','14:50:00',1.66),('12664','2013-03-09','14:55:00',3.39),('12664','2013-03-09','15:00:00',3.23),('12664','2013-03-09','15:05:00',3.16),('12664','2013-03-09','15:10:00',3.06),('12664','2013-03-09','15:15:00',2.99),('12664','2013-03-09','15:20:00',2.91),('12664','2013-03-09','15:25:00',2.81),('12664','2013-03-09','15:30:00',2.7),('12664','2013-03-09','15:35:00',2.63),('12664','2013-03-09','15:40:00',2.56),('12664','2013-03-09','15:45:00',2.46),('12664','2013-03-09','15:50:00',2.34),('12664','2013-03-09','15:55:00',2.16),('12664','2013-03-09','16:00:00',1.82),('12664','2013-03-09','16:05:00',1.64),('12664','2013-03-09','16:10:00',1.69),('12664','2013-03-09','16:15:00',1.14),('12664','2013-03-09','16:25:00',1.03),('12664','2013-03-09','16:40:00',1.17),('12664','2013-03-08','08:25:00',1.24),('12664','2013-03-08','08:30:00',1.63),('12664','2013-03-08','09:10:00',1.57),('12664','2013-03-08','09:15:00',2.88),('12664','2013-03-08','09:20:00',3.49),('12664','2013-03-08','09:25:00',3.13),('12664','2013-03-08','09:30:00',2.67),('12664','2013-03-08','09:35:00',3.75),('12664','2013-03-08','09:40:00',1.8),('12664','2013-03-08','09:45:00',1.96),('12664','2013-03-08','09:50:00',1.71),('12664','2013-03-08','09:55:00',2.65),('12664','2013-03-08','10:00:00',3.02),('12664','2013-03-08','10:05:00',1.24),('12664','2013-03-08','10:10:00',1.74),('12664','2013-03-08','10:15:00',1.41),('12664','2013-03-08','10:45:00',1.36),('12664','2013-03-08','10:50:00',1.07),('12664','2013-03-08','12:20:00',1.24),('12664','2013-03-08','12:25:00',1.2),('12664','2013-03-08','12:30:00',1.24),('12664','2013-03-08','12:35:00',1.81),('12664','2013-03-08','12:40:00',1.95),('12664','2013-03-08','12:45:00',1.88),('12664','2013-03-08','12:50:00',2.44),('12664','2013-03-08','12:55:00',2.79),('12664','2013-03-08','13:00:00',2.03),('12664','2013-03-08','13:05:00',1.67),('12664','2013-03-08','13:10:00',1.6),('12664','2013-03-08','13:15:00',1.51),('12664','2013-03-08','13:20:00',1.21),('12664','2013-03-08','13:25:00',1.33),('12664','2013-03-08','13:30:00',1.79),('12664','2013-03-08','13:35:00',1.51),('12664','2013-03-08','13:40:00',1.24),('12664','2013-03-08','13:45:00',1.31),('12664','2013-03-08','13:50:00',1.1),('12664','2013-03-07','10:40:00',1.92),('12664','2013-03-07','10:45:00',2.1),('12664','2013-03-07','10:50:00',1.68),('12664','2013-03-07','10:55:00',2.07),('12664','2013-03-07','11:00:00',1.41),('12664','2013-03-07','11:05:00',1.07),('12664','2013-03-07','11:35:00',1.8),('12664','2013-03-07','11:40:00',3.39),('12664','2013-03-07','11:45:00',2.37),('12664','2013-03-07','11:50:00',1.79),('12664','2013-03-07','11:55:00',1.46),('12664','2013-03-07','12:00:00',1.58),('12664','2013-03-07','12:05:00',1.26),('12664','2013-03-07','12:15:00',1.09),('12664','2013-03-07','12:20:00',1.26),('12664','2013-03-07','12:25:00',1.52),('12664','2013-03-07','12:30:00',1.45),('12664','2013-03-07','12:35:00',1.39),('12664','2013-03-07','12:50:00',1.22),('12664','2013-03-07','12:55:00',1.67),('12664','2013-03-07','13:00:00',2.51),('12664','2013-03-07','13:05:00',2.6),('12664','2013-03-07','13:10:00',2.83),('12664','2013-03-07','13:15:00',2.27),('12664','2013-03-07','13:20:00',1.3),('12664','2013-03-07','13:25:00',1.36),('12664','2013-03-07','13:30:00',1.58),('12664','2013-03-07','13:35:00',1.61),('12664','2013-03-07','13:40:00',1.33),('12664','2013-03-07','14:05:00',1.27),('12664','2013-03-07','14:10:00',1.05),('12664','2013-03-07','14:20:00',1.06),('12664','2013-03-07','15:20:00',1.17),('12664','2013-03-07','15:25:00',1),('12664','2013-03-07','16:30:00',1.29),('12664','2013-03-07','16:35:00',1),('12664','2013-03-05','08:05:00',1.06),('12664','2013-03-05','08:10:00',1.28),('12664','2013-03-05','08:15:00',1.55),('12664','2013-03-05','08:25:00',1.65),('12664','2013-03-05','08:30:00',1.45),('12664','2013-03-05','08:35:00',1.92),('12664','2013-03-05','08:40:00',2),('12664','2013-03-05','08:45:00',1.78),('12664','2013-03-05','08:50:00',2.09),('12664','2013-03-05','08:55:00',1.81),('12664','2013-03-05','09:00:00',1.59),('12664','2013-03-05','09:05:00',1.48),('12664','2013-03-05','09:10:00',1.43),('12664','2013-03-05','09:15:00',1.47),('12664','2013-03-05','09:20:00',1.51),('12664','2013-03-05','09:25:00',1.48),('12664','2013-03-05','09:30:00',1.62),('12664','2013-03-05','09:35:00',1.67),('12664','2013-03-05','09:40:00',1.76),('12664','2013-03-05','09:45:00',1.75),('12664','2013-03-05','09:50:00',1.76),('12664','2013-03-05','09:55:00',2.16),('12664','2013-03-05','10:00:00',2.18),('12664','2013-03-05','10:05:00',1.82),('12664','2013-03-05','10:10:00',1.7),('12664','2013-03-05','10:15:00',1.87),('12664','2013-03-05','10:20:00',2.16),('12664','2013-03-05','10:25:00',1.8),('12664','2013-03-05','10:30:00',1.76),('12664','2013-03-05','10:35:00',2.08),('12664','2013-03-05','10:40:00',2.62),('12664','2013-03-05','10:45:00',2.74),('12664','2013-03-05','10:50:00',3.07),('12664','2013-03-05','10:55:00',2.98),('12664','2013-03-05','11:00:00',2.97),('12664','2013-03-05','11:05:00',3.05),('12664','2013-03-05','11:10:00',3.08),('12664','2013-03-05','11:15:00',2.76),('12664','2013-03-05','11:20:00',2.75),('12664','2013-03-05','11:25:00',2.68),('12664','2013-03-05','11:30:00',2.82),('12664','2013-03-05','11:35:00',3.24),('12664','2013-03-05','11:40:00',3.26),('12664','2013-03-05','11:45:00',3.4),('12664','2013-03-05','11:50:00',3.53),('12664','2013-03-05','11:55:00',3.5),('12664','2013-03-05','12:00:00',3.65),('12664','2013-03-05','12:05:00',3.73),('12664','2013-03-05','12:10:00',3.51),('12664','2013-03-05','12:15:00',3.41),('12664','2013-03-05','12:20:00',3.62),('12664','2013-03-05','12:25:00',3.12),('12664','2013-03-05','12:30:00',3.1),('12664','2013-03-05','12:35:00',2.88),('12664','2013-03-05','12:40:00',2.81),('12664','2013-03-05','12:45:00',2.67),('12664','2013-03-05','12:50:00',2.45),('12664','2013-03-05','12:55:00',1.96),('12664','2013-03-05','13:00:00',1.74),('12664','2013-03-05','13:05:00',1.77),('12664','2013-03-05','13:10:00',1.93),('12664','2013-03-05','13:15:00',1.93),('12664','2013-03-05','13:20:00',1.77),('12664','2013-03-05','13:25:00',1.59),('12664','2013-03-05','13:30:00',1.42),('12664','2013-03-05','13:35:00',1.34),('12664','2013-03-05','13:40:00',1.23),('12664','2013-03-05','13:45:00',1.11),('12664','2013-03-05','13:50:00',1.09),('12664','2013-03-05','13:55:00',1.16),('12664','2013-03-05','14:00:00',1.19),('12664','2013-03-05','14:05:00',1.17),('12664','2013-03-05','14:10:00',1.09),('12664','2013-03-05','14:20:00',1.02),('12664','2013-03-05','14:25:00',1.05),('12664','2013-03-05','14:30:00',1.06),('12664','2013-03-05','14:35:00',1.05),('12664','2013-03-05','14:40:00',1.05),('12664','2013-03-05','14:45:00',1.06),('12664','2013-03-05','15:30:00',1),('12664','2013-03-05','15:35:00',1.08),('12664','2013-03-05','15:40:00',1.26),('12664','2013-03-05','15:45:00',1.29),('12664','2013-03-05','15:50:00',1.06),('12664','2013-03-04','07:50:00',1.08),('12664','2013-03-04','07:55:00',1.18),('12664','2013-03-04','08:00:00',1.3),('12664','2013-03-04','08:05:00',1.42),('12664','2013-03-04','08:10:00',1.53),('12664','2013-03-04','08:15:00',1.65),('12664','2013-03-04','08:20:00',1.75),('12664','2013-03-04','08:25:00',1.87),('12664','2013-03-04','08:30:00',1.95),('12664','2013-03-04','08:35:00',2.04),('12664','2013-03-04','08:40:00',2.15),('12664','2013-03-04','08:45:00',2.24),('12664','2013-03-04','08:50:00',2.34),('12664','2013-03-04','08:55:00',2.43),('12664','2013-03-04','09:00:00',2.5),('12664','2013-03-04','09:05:00',2.61),('12664','2013-03-04','09:10:00',2.7),('12664','2013-03-04','09:15:00',2.78),('12664','2013-03-04','09:20:00',2.83),('12664','2013-03-04','09:25:00',2.88),('12664','2013-03-04','09:30:00',2.96),('12664','2013-03-04','09:35:00',3.08),('12664','2013-03-04','09:40:00',3.18),('12664','2013-03-04','09:46:00',3.26),('12664','2013-03-04','09:50:00',3.32),('12664','2013-03-04','09:55:00',3.38),('12664','2013-03-04','10:00:00',3.43),('12664','2013-03-04','10:05:00',3.51),('12664','2013-03-04','10:10:00',3.56),('12664','2013-03-04','10:16:00',3.59),('12664','2013-03-04','10:20:00',3.62),('12664','2013-03-04','10:25:00',3.69),('12664','2013-03-04','10:30:00',3.6),('12664','2013-03-04','10:35:00',3.75),('12664','2013-03-04','10:40:00',3.73),('12664','2013-03-04','10:45:00',3.81),('12664','2013-03-04','10:50:00',3.85),('12664','2013-03-04','10:55:00',3.9),('12664','2013-03-04','11:00:00',3.98),('12664','2013-03-04','11:05:00',4.03),('12664','2013-03-04','11:10:00',4.05),('12664','2013-03-04','11:15:00',4.08),('12664','2013-03-04','11:20:00',4.11),('12664','2013-03-04','11:25:00',4.09),('12664','2013-03-04','11:30:00',4.07),('12664','2013-03-04','11:35:00',4.06),('12664','2013-03-04','11:40:00',4.11),('12664','2013-03-04','11:45:00',4.14),('12664','2013-03-04','11:50:00',4.15),('12664','2013-03-04','11:55:00',4.22),('12664','2013-03-04','12:00:00',4.21),('12664','2013-03-04','12:05:00',4.2),('12664','2013-03-04','12:10:00',4.17),('12664','2013-03-04','12:15:00',4.21),('12664','2013-03-04','12:20:00',4.2),('12664','2013-03-04','12:25:00',4.16),('12664','2013-03-04','12:30:00',4.11),('12664','2013-03-04','12:35:00',4.18),('12664','2013-03-04','12:40:00',4.19),('12664','2013-03-04','12:45:00',4.12),('12664','2013-03-04','12:50:00',4.13),('12664','2013-03-04','12:55:00',4.1),('12664','2013-03-04','13:00:00',4.06),('12664','2013-03-04','13:05:00',4.04),('12664','2013-03-04','13:10:00',4.03),('12664','2013-03-04','13:15:00',3.93),('12664','2013-03-04','13:20:00',4.04),('12664','2013-03-04','13:25:00',4.03),('12664','2013-03-04','13:30:00',4.13),('12664','2013-03-04','13:35:00',3.96),('12664','2013-03-04','13:40:00',3.83),('12664','2013-03-04','13:45:00',3.84),('12664','2013-03-04','13:50:00',3.76),('12664','2013-03-04','13:55:00',3.74),('12664','2013-03-04','14:00:00',3.68),('12664','2013-03-04','14:05:00',3.6),('12664','2013-03-04','14:10:00',3.58),('12664','2013-03-04','14:15:00',3.54),('12664','2013-03-04','14:20:00',3.45),('12664','2013-03-04','14:25:00',3.39),('12664','2013-03-04','14:30:00',3.31),('12664','2013-03-04','14:35:00',3.22),('12664','2013-03-04','14:40:00',3.19),('12664','2013-03-04','14:45:00',3.13),('12664','2013-03-04','14:50:00',3.06),('12664','2013-03-04','14:55:00',3.03),('12664','2013-03-04','15:00:00',2.97),('12664','2013-03-04','15:05:00',2.88),('12664','2013-03-04','15:10:00',2.82),('12664','2013-03-04','15:15:00',2.72),('12664','2013-03-04','15:20:00',2.63),('12664','2013-03-04','15:25:00',2.55),('12664','2013-03-04','15:30:00',2.47),('12664','2013-03-04','15:35:00',2.39),('12664','2013-03-04','15:40:00',2.3),('12664','2013-03-04','15:45:00',2.17),('12664','2013-03-04','15:50:00',2.1),('12664','2013-03-04','15:55:00',2.02),('12664','2013-03-04','16:00:00',1.92),('12664','2013-03-04','16:05:00',1.83),('12664','2013-03-04','16:10:00',1.74),('12664','2013-03-04','16:15:00',1.65),('12664','2013-03-04','16:20:00',1.57),('12664','2013-03-04','16:25:00',1.46),('12664','2013-03-04','16:30:00',1.34),('12664','2013-03-04','16:35:00',1.22),('12664','2013-03-04','16:40:00',1.11),('12664','2013-03-04','16:45:00',1.01),('12664','2013-03-03','07:45:00',1.1),('12664','2013-03-03','07:50:00',1.21),('12664','2013-03-03','07:55:00',1.33),('12664','2013-03-03','08:00:00',1.45),('12664','2013-03-03','08:05:00',1.57),('12664','2013-03-03','08:10:00',1.68),('12664','2013-03-03','08:15:00',1.8),('12664','2013-03-03','08:20:00',1.91),('12664','2013-03-03','08:25:00',2.02),('12664','2013-03-03','08:30:00',2.13),('12664','2013-03-03','08:35:00',2.24),('12664','2013-03-03','08:40:00',2.34),('12664','2013-03-03','08:45:00',2.45),('12664','2013-03-03','08:50:00',2.55),('12664','2013-03-03','08:55:00',2.64),('12664','2013-03-03','09:00:00',2.74),('12664','2013-03-03','09:05:00',2.83),('12664','2013-03-03','09:10:00',2.93),('12664','2013-03-03','09:15:00',3.02),('12664','2013-03-03','09:20:00',3.11),('12664','2013-03-03','09:25:00',3.18),('12664','2013-03-03','09:30:00',3.26),('12664','2013-03-03','09:35:00',3.32),('12664','2013-03-03','09:40:00',3.39),('12664','2013-03-03','09:45:00',3.45),('12664','2013-03-03','09:50:00',3.51),('12664','2013-03-03','09:55:00',3.57),('12664','2013-03-03','10:00:00',3.62),('12664','2013-03-03','10:05:00',3.72),('12664','2013-03-03','10:10:00',3.75),('12664','2013-03-03','10:15:00',3.79),('12664','2013-03-03','10:20:00',3.86),('12664','2013-03-03','10:25:00',3.92),('12664','2013-03-03','10:30:00',3.94),('12664','2013-03-03','10:35:00',3.98),('12664','2013-03-03','10:40:00',4.02),('12664','2013-03-03','10:45:00',4.08),('12664','2013-03-03','10:50:00',4.12),('12664','2013-03-03','10:55:00',4.14),('12664','2013-03-03','11:00:00',4.12),('12664','2013-03-03','11:05:00',4.13),('12664','2013-03-03','11:10:00',4.19),('12664','2013-03-03','11:15:00',4.23),('12664','2013-03-03','11:20:00',4.22),('12664','2013-03-03','11:25:00',4.26),('12664','2013-03-03','11:30:00',4.29),('12664','2013-03-03','11:35:00',4.29),('12664','2013-03-03','11:40:00',4.3),('12664','2013-03-03','11:45:00',4.3),('12664','2013-03-03','11:50:00',4.3),('12664','2013-03-03','11:55:00',4.28),('12664','2013-03-03','12:00:00',4.31),('12664','2013-03-03','12:05:00',4.31),('12664','2013-03-03','12:10:00',4.34),('12664','2013-03-03','12:15:00',4.35),('12664','2013-03-03','12:20:00',4.34),('12664','2013-03-03','12:25:00',4.32),('12664','2013-03-03','12:30:00',4.33),('12664','2013-03-03','12:35:00',4.31),('12664','2013-03-03','12:40:00',4.3),('12664','2013-03-03','12:45:00',4.3),('12664','2013-03-03','12:50:00',4.26),('12664','2013-03-03','12:55:00',4.24),('12664','2013-03-03','13:00:00',4.23),('12664','2013-03-03','13:05:00',4.21),('12664','2013-03-03','13:10:00',4.2),('12664','2013-03-03','13:15:00',4.16),('12664','2013-03-03','13:20:00',4.13),('12664','2013-03-03','13:25:00',4.13),('12664','2013-03-03','13:30:00',4.09),('12664','2013-03-03','13:35:00',4.07),('12664','2013-03-03','13:40:00',4.03),('12664','2013-03-03','13:45:00',3.99),('12664','2013-03-03','13:50:00',3.97),('12664','2013-03-03','13:55:00',3.92),('12664','2013-03-03','14:00:00',3.86),('12664','2013-03-03','14:05:00',3.82),('12664','2013-03-03','14:10:00',3.76),('12664','2013-03-03','14:15:00',3.7),('12664','2013-03-03','14:20:00',3.64),('12664','2013-03-03','14:25:00',3.61),('12664','2013-03-03','14:30:00',3.55),('12664','2013-03-03','14:35:00',3.48),('12664','2013-03-03','14:40:00',3.41),('12664','2013-03-03','14:45:00',3.35),('12664','2013-03-03','14:50:00',3.29),('12664','2013-03-03','14:55:00',3.21),('12664','2013-03-03','15:00:00',3.13),('12664','2013-03-03','15:05:00',3.06),('12664','2013-03-03','15:10:00',3.01),('12664','2013-03-03','15:15:00',2.9),('12664','2013-03-03','15:20:00',2.82),('12664','2013-03-03','15:25:00',2.74),('12664','2013-03-03','15:30:00',2.65),('12664','2013-03-03','15:35:00',2.57),('12664','2013-03-03','15:40:00',2.48),('12664','2013-03-03','15:45:00',2.4),('12664','2013-03-03','15:50:00',2.28),('12664','2013-03-03','15:55:00',2.18),('12664','2013-03-03','16:00:00',2.08),('12664','2013-03-03','16:05:00',1.98),('12664','2013-03-03','16:10:00',1.88),('12664','2013-03-03','16:15:00',1.78),('12664','2013-03-03','16:20:00',1.67),('12664','2013-03-03','16:25:00',1.55),('12664','2013-03-03','16:30:00',1.44),('12664','2013-03-03','16:35:00',1.32),('12664','2013-03-03','16:40:00',1.22),('12664','2013-03-03','16:45:00',1.11),('12664','2013-03-02','09:55:00',1.16),('12664','2013-03-02','10:00:00',1.1),('12664','2013-03-02','10:45:00',1.04),('12664','2013-03-02','10:50:00',1.18),('12664','2013-03-02','10:55:00',1.25),('12664','2013-03-02','11:00:00',1.34),('12664','2013-03-02','11:05:00',1.44),('12664','2013-03-02','11:10:00',1.53),('12664','2013-03-02','11:15:00',1.47),('12664','2013-03-02','11:20:00',1.73),('12664','2013-03-02','11:25:00',2.09),('12664','2013-03-02','11:30:00',2.15),('12664','2013-03-02','11:35:00',2.34),('12664','2013-03-02','11:40:00',2.76),('12664','2013-03-02','11:45:00',2.39),('12664','2013-03-02','11:50:00',3.12),('12664','2013-03-02','11:55:00',2.18),('12664','2013-03-02','12:00:00',3.52),('12664','2013-03-02','12:05:00',1.68),('12664','2013-03-02','12:10:00',1.45),('12664','2013-03-02','12:15:00',1.28),('12664','2013-03-02','12:20:00',1.31),('12664','2013-03-02','12:25:00',1.49),('12664','2013-03-02','12:30:00',1.45),('12664','2013-03-02','12:35:00',1.43),('12664','2013-03-02','12:40:00',1.44),('12664','2013-03-02','12:45:00',1.36),('12664','2013-03-02','12:50:00',1.29),('12664','2013-03-02','12:55:00',1.51),('12664','2013-03-02','13:00:00',1.11),('12664','2013-03-02','13:05:00',1.03),('12664','2013-03-02','13:20:00',1.01),('12664','2013-03-02','13:25:00',1.11),('12664','2013-03-02','13:30:00',1.2),('12664','2013-03-02','13:35:00',1.25),('12664','2013-03-02','13:40:00',1.26),('12664','2013-03-02','13:45:00',1.33),('12664','2013-03-02','13:50:00',1.33),('12664','2013-03-02','13:55:00',1.44),('12664','2013-03-02','14:00:00',1.63),('12664','2013-03-02','14:05:00',1.55),('12664','2013-03-02','14:10:00',1.23),('12664','2014-03-23','08:20:00',1.09),('12664','2014-03-23','08:25:00',1.14),('12664','2014-03-23','08:30:00',1.77),('12664','2014-03-23','08:50:00',1.49),('12664','2014-03-23','08:55:00',1.41),('12664','2014-03-23','09:00:00',2.17),('12664','2014-03-23','09:05:00',2.54),('12664','2014-03-23','09:10:00',2.35),('12664','2014-03-23','09:15:00',1.76),('12664','2014-03-23','09:25:00',1.04),('12664','2014-03-23','09:30:00',1.15),('12664','2014-03-23','10:20:00',1.23),('12664','2014-03-23','10:25:00',1.67),('12664','2014-03-23','10:35:00',1.57),('12664','2014-03-23','10:40:00',1.33),('12664','2014-03-23','10:45:00',1.4),('12664','2014-03-23','10:50:00',1.22),('12664','2014-03-23','11:05:00',1.2),('12664','2014-03-23','11:20:00',1.01),('12664','2014-03-23','11:25:00',1.11),('12664','2014-03-23','11:30:00',1.11),('12664','2014-03-23','11:35:00',1.07),('12664','2014-03-23','13:30:00',1.2),('12664','2014-03-23','13:35:00',2.2),('12664','2014-03-23','13:40:00',1.25),('12664','2014-03-23','13:45:00',1.14),('12664','2014-03-23','13:50:00',1.15),('12664','2014-03-23','14:50:00',1.04),('12664','2014-03-23','15:05:00',1.37),('12664','2014-03-23','15:10:00',1.56),('12664','2014-03-23','15:15:00',1.08),('12664','2013-03-01','07:55:00',1.02),('12664','2013-03-01','08:00:00',1.08),('12664','2013-03-01','08:05:00',1.08),('12664','2013-03-01','08:10:00',1.1),('12664','2013-03-01','08:15:00',1.11),('12664','2013-03-01','08:20:00',1.16),('12664','2013-03-01','08:25:00',1.23),('12664','2013-03-01','08:30:00',1.29),('12664','2013-03-01','08:35:00',1.45),('12664','2013-03-01','08:40:00',1.73),('12664','2013-03-01','08:45:00',1.82),('12664','2013-03-01','08:50:00',1.94),('12664','2013-03-01','08:55:00',2.07),('12664','2013-03-01','09:00:00',2.22),('12664','2013-03-01','09:05:00',2.35),('12664','2013-03-01','09:10:00',2.34),('12664','2013-03-01','09:15:00',2.36),('12664','2013-03-01','09:20:00',2.39),('12664','2013-03-01','09:25:00',2.39),('12664','2013-03-01','09:30:00',2.62),('12664','2013-03-01','09:35:00',2.7),('12664','2013-03-01','09:40:00',2.67),('12664','2013-03-01','09:45:00',2.77),('12664','2013-03-01','09:50:00',2.97),('12664','2013-03-01','09:55:00',2.94),('12664','2013-03-01','10:00:00',2.6),('12664','2013-03-01','10:05:00',2.29),('12664','2013-03-01','10:10:00',2.14),('12664','2013-03-01','10:15:00',2.17),('12664','2013-03-01','10:20:00',2.18),('12664','2013-03-01','10:25:00',2.26),('12664','2013-03-01','10:30:00',2.47),('12664','2013-03-01','10:35:00',2.76),('12664','2013-03-01','10:40:00',2.73),('12664','2013-03-01','10:45:00',2.39),('12664','2013-03-01','10:50:00',2.31),('12664','2013-03-01','10:55:00',2.22),('12664','2013-03-01','11:00:00',2.12),('12664','2013-03-01','11:05:00',2.03),('12664','2013-03-01','11:10:00',1.94),('12664','2013-03-01','11:15:00',2.04),('12664','2013-03-01','11:20:00',2.05),('12664','2013-03-01','11:25:00',1.96),('12664','2013-03-01','11:30:00',1.91),('12664','2013-03-01','11:35:00',1.82),('12664','2013-03-01','11:45:00',1.63),('12664','2013-03-01','11:50:00',1.58),('12664','2013-03-01','11:55:00',1.47),('12664','2013-03-01','12:00:00',1.37),('12664','2013-03-01','12:05:00',1.3),('12664','2013-03-01','12:10:00',1.22),('12664','2013-03-01','12:15:00',1.17),('12664','2013-03-01','12:20:00',1.15),('12664','2013-03-01','12:25:00',1.18),('12664','2013-03-01','12:30:00',1.21),('12664','2013-03-01','12:35:00',1.18),('12664','2013-03-01','12:40:00',1.19),('12664','2013-03-01','12:45:00',1.27),('12664','2013-03-01','12:50:00',1.37),('12664','2013-03-01','12:55:00',1.42),('12664','2013-03-01','13:00:00',1.45),('12664','2013-03-01','13:05:00',1.47),('12664','2013-03-01','13:10:00',1.52),('12664','2013-03-01','13:15:00',1.62),('12664','2013-03-01','13:20:00',1.82),('12664','2013-03-01','13:25:00',1.81),('12664','2013-03-01','13:30:00',1.67),('12664','2013-03-01','13:35:00',1.52),('12664','2013-03-01','13:40:00',1.45),('12664','2013-03-01','13:45:00',1.49),('12664','2013-03-01','13:50:00',1.49),('12664','2013-03-01','13:55:00',1.45),('12664','2013-03-01','14:00:00',1.37),('12664','2013-03-01','14:05:00',1.28),('12664','2013-03-01','14:10:00',1.22),('12664','2013-03-01','14:15:00',1.2),('12664','2013-03-01','14:20:00',1.19),('12664','2013-03-01','14:25:00',1.19),('12664','2013-03-01','14:30:00',1.18),('12664','2013-03-01','14:35:00',1.13),('12664','2013-03-01','14:40:00',1.08),('12664','2013-03-01','14:45:00',1.04),('12664','2013-03-01','14:50:00',1.01),('12664','2013-02-28','08:00:00',1.07),('12664','2013-02-28','08:05:00',1.19),('12664','2013-02-28','08:10:00',1.29),('12664','2013-02-28','08:15:00',1.41),('12664','2013-02-28','08:20:00',1.53),('12664','2013-02-28','08:25:00',1.65),('12664','2013-02-28','08:30:00',1.76),('12664','2013-02-28','08:35:00',1.87),('12664','2013-02-28','08:40:00',1.97),('12664','2013-02-28','08:45:00',2.06),('12664','2013-02-28','08:50:00',2.18),('12664','2013-02-28','08:55:00',2.27),('12664','2013-02-28','09:00:00',2.37),('12664','2013-02-28','09:05:00',2.46),('12664','2013-02-28','09:10:00',2.55),('12664','2013-02-28','09:15:00',2.65),('12664','2013-02-28','09:20:00',2.74),('12664','2013-02-28','09:25:00',2.81),('12664','2013-02-28','09:30:00',2.9),('12664','2013-02-28','09:35:00',2.96),('12664','2013-02-28','09:40:00',3.04),('12664','2013-02-28','09:45:00',2.91),('12664','2013-02-28','09:50:00',3.16),('12664','2013-02-28','09:55:00',3.23),('12664','2013-02-28','10:00:00',3.28),('12664','2013-02-28','10:05:00',3.32),('12664','2013-02-28','10:10:00',3.4),('12664','2013-02-28','10:15:00',3.45),('12664','2013-02-28','10:20:00',3.48),('12664','2013-02-28','10:25:00',3.52),('12664','2013-02-28','10:30:00',3.53),('12664','2013-02-28','10:35:00',3.62),('12664','2013-02-28','10:40:00',3.64),('12664','2013-02-28','10:45:00',3.66),('12664','2013-02-28','10:50:00',3.75),('12664','2013-02-28','10:55:00',3.78),('12664','2013-02-28','11:00:00',3.83),('12664','2013-02-28','11:05:00',3.82),('12664','2013-02-28','11:10:00',3.8),('12664','2013-02-28','11:15:00',3.89),('12664','2013-02-28','11:20:00',3.92),('12664','2013-02-28','11:25:00',3.97),('12664','2013-02-28','11:30:00',4.01),('12664','2013-02-28','11:35:00',3.96),('12664','2013-02-28','11:40:00',4.01),('12664','2013-02-28','11:45:00',3.95),('12664','2013-02-28','11:50:00',4.03),('12664','2013-02-28','11:55:00',4.02),('12664','2013-02-28','12:00:00',4.03),('12664','2013-02-28','12:05:00',3.98),('12664','2013-02-28','12:10:00',4.06),('12664','2013-02-28','12:15:00',4.08),('12664','2013-02-28','12:20:00',4.07),('12664','2013-02-28','12:25:00',4.08),('12664','2013-02-28','12:30:00',4.12),('12664','2013-02-28','12:35:00',4.1),('12664','2013-02-28','12:40:00',3.97),('12664','2013-02-28','12:45:00',4.01),('12664','2013-02-28','12:50:00',4.08),('12664','2013-02-28','12:55:00',3.86),('12664','2013-02-28','13:00:00',4.04),('12664','2013-02-28','13:05:00',4.01),('12664','2013-02-28','13:10:00',3.94),('12664','2013-02-28','13:15:00',3.81),('12664','2013-02-28','13:20:00',3.61),('12664','2013-02-28','13:25:00',3.44),('12664','2013-02-28','13:30:00',3.76),('12664','2013-02-28','13:35:00',4.1),('12664','2013-02-28','13:40:00',4),('12664','2013-02-28','13:45:00',4.02),('12664','2013-02-28','13:50:00',4.07),('12664','2013-02-28','13:55:00',4.03),('12664','2013-02-28','14:00:00',3.86),('12664','2013-02-28','14:05:00',3.71),('12664','2013-02-28','14:10:00',3.44),('12664','2013-02-28','14:15:00',3.49),('12664','2013-02-28','14:20:00',3.31),('12664','2013-02-28','14:25:00',3.23),('12664','2013-02-28','14:30:00',3.28),('12664','2013-02-28','14:35:00',1.7),('12664','2013-02-28','14:40:00',2.92),('12664','2013-02-28','14:45:00',3.02),('12664','2013-02-28','14:50:00',2.88),('12664','2013-02-28','14:55:00',2.81),('12664','2013-02-28','15:00:00',2.77),('12664','2013-02-28','15:05:00',2.69),('12664','2013-02-28','15:10:00',2.63),('12664','2013-02-28','15:15:00',2.59),('12664','2013-02-28','15:20:00',2.47),('12664','2013-02-28','15:25:00',2.41),('12664','2013-02-28','15:30:00',2.33),('12664','2013-02-28','15:35:00',2.25),('12664','2013-02-28','15:40:00',2.17),('12664','2013-02-28','15:45:00',2.07),('12664','2013-02-28','15:50:00',1.96),('12664','2013-02-28','15:55:00',1.88),('12664','2013-02-28','16:00:00',1.78),('12664','2013-02-28','16:05:00',1.67),('12664','2013-02-28','16:10:00',1.59),('12664','2013-02-28','16:15:00',1.48),('12664','2013-02-28','16:20:00',1.36),('12664','2013-02-28','16:25:00',1.24),('12664','2013-02-28','16:30:00',1.2),('12664','2013-02-28','16:35:00',1.09),('12664','2013-02-27','08:00:00',1.04),('12664','2013-02-27','08:05:00',1.15),('12664','2013-02-27','08:10:00',1.27),('12664','2013-02-27','08:15:00',1.38),('12664','2013-02-27','08:20:00',1.51),('12664','2013-02-27','08:25:00',1.63),('12664','2013-02-27','08:30:00',1.74),('12664','2013-02-27','08:35:00',1.84),('12664','2013-02-27','08:40:00',1.94),('12664','2013-02-27','08:45:00',2.04),('12664','2013-02-27','08:50:00',2.14),('12664','2013-02-27','08:55:00',2.23),('12664','2013-02-27','09:00:00',2.34),('12664','2013-02-27','09:05:00',2.44),('12664','2013-02-27','09:10:00',2.55),('12664','2013-02-27','09:15:00',2.66),('12664','2013-02-27','09:20:00',2.74),('12664','2013-02-27','09:25:00',2.82),('12664','2013-02-27','09:30:00',2.9),('12664','2013-02-27','09:35:00',2.97),('12664','2013-02-27','09:40:00',3.03),('12664','2013-02-27','09:45:00',3.1),('12664','2013-02-27','10:05:00',3.33),('12664','2013-02-27','10:10:00',3.38),('12664','2013-02-27','10:30:00',3.59),('12664','2013-02-27','10:35:00',3.64),('12664','2013-02-27','10:40:00',3.7),('12664','2013-02-27','11:15:00',3.83),('12664','2013-02-27','11:20:00',3.89),('12664','2013-02-27','11:25:00',3.91),('12664','2013-02-27','11:30:00',4.04),('12664','2013-02-27','11:35:00',4.02),('12664','2013-02-27','11:40:00',3.92),('12664','2013-02-27','11:45:00',4.03),('12664','2013-02-27','11:50:00',4.25),('12664','2013-02-27','11:55:00',3.86),('12664','2013-02-27','12:00:00',3.4),('12664','2013-02-27','12:05:00',4.23),('12664','2013-02-27','12:10:00',4.23),('12664','2013-02-27','12:15:00',4.29),('12664','2013-02-27','12:20:00',4.29),('12664','2013-02-27','12:25:00',4.22),('12664','2013-02-27','12:30:00',4.16),('12664','2013-02-27','12:35:00',4.12),('12664','2013-02-27','12:40:00',4.1),('12664','2013-02-27','12:45:00',4.12),('12664','2013-02-27','12:50:00',3.85),('12664','2013-02-27','12:55:00',3.94),('12664','2013-02-27','13:00:00',4.14),('12664','2013-02-27','13:05:00',4.1),('12664','2013-02-27','13:10:00',4.13),('12664','2013-02-27','13:15:00',4.05),('12664','2013-02-27','13:20:00',3.19),('12664','2013-02-27','13:25:00',3.24),('12664','2013-02-27','13:30:00',2.51),('12664','2013-02-27','13:35:00',3.55),('12664','2013-02-27','13:45:00',3.62),('12664','2013-02-27','13:50:00',3.89),('12664','2013-02-27','13:55:00',3.89),('12664','2013-02-27','14:00:00',2.78),('12664','2013-02-27','14:05:00',1.6),('12664','2013-02-27','14:10:00',1.67),('12664','2013-02-27','14:15:00',2.15),('12664','2013-02-27','14:20:00',2.15),('12664','2013-02-27','14:25:00',1.07),('12664','2013-02-27','14:35:00',2.36),('12664','2013-02-27','14:40:00',3.52),('12664','2013-02-27','14:45:00',3.46),('12664','2013-02-27','14:50:00',3.39),('12664','2013-02-27','14:55:00',3.16),('12664','2013-02-27','15:00:00',3.05),('12664','2013-02-27','15:05:00',2.89),('12664','2013-02-27','15:10:00',2.77),('12664','2013-02-27','15:15:00',2.7),('12664','2013-02-27','15:20:00',2.63),('12664','2013-02-27','15:25:00',2.54),('12664','2013-02-27','15:30:00',2.39),('12664','2013-02-27','15:35:00',2.33),('12664','2013-02-27','15:40:00',2.28),('12664','2013-02-27','15:45:00',2.18),('12664','2013-02-27','15:50:00',2.09),('12664','2013-02-27','15:55:00',2.03),('12664','2013-02-27','16:00:00',1.91),('12664','2013-02-27','16:05:00',1.8),('12664','2013-02-27','16:10:00',1.69),('12664','2013-02-27','16:15:00',1.59),('12664','2013-02-27','16:20:00',1.48),('12664','2013-02-27','16:25:00',1.38),('12664','2013-02-27','16:30:00',1.27),('12664','2013-02-27','16:35:00',1.16),('12664','2013-02-27','16:40:00',1.05),('12664','2013-02-26','09:15:00',1.01),('12664','2013-02-26','09:20:00',1.15),('12664','2013-02-26','09:25:00',1.34),('12664','2013-02-26','09:30:00',1.59),('12664','2013-02-26','09:35:00',1.86),('12664','2013-02-26','09:40:00',2.08),('12664','2013-02-26','09:45:00',2.25),('12664','2013-02-26','09:50:00',2.44),('12664','2013-02-26','09:55:00',2.61),('12664','2013-02-26','10:00:00',2.45),('12664','2013-02-26','10:05:00',2.86),('12664','2013-02-26','10:10:00',3.24),('12664','2013-02-26','10:15:00',2.98),('12664','2013-02-26','10:20:00',3.14),('12664','2013-02-26','10:25:00',1.77),('12664','2013-02-26','10:30:00',1.43),('12664','2013-02-26','10:35:00',1.61),('12664','2013-02-26','10:40:00',1.55),('12664','2013-02-26','10:45:00',1.53),('12664','2013-02-26','10:50:00',1.62),('12664','2013-02-26','10:55:00',1.65),('12664','2013-02-26','11:00:00',1.78),('12664','2013-02-26','11:05:00',1.71),('12664','2013-02-26','11:10:00',1.61),('12664','2013-02-26','11:15:00',1.67),('12664','2013-02-26','11:20:00',1.9),('12664','2013-02-26','11:25:00',2.21),('12664','2013-02-26','11:30:00',2.26),('12664','2013-02-26','11:35:00',2.48),('12664','2013-02-26','11:40:00',3.23),('12664','2013-02-26','11:45:00',3.29),('12664','2013-02-26','11:50:00',3.13),('12664','2013-02-26','11:55:00',3.89),('12664','2013-02-26','12:00:00',4.21),('12664','2013-02-26','12:05:00',2.85),('12664','2013-02-26','12:10:00',2.27),('12664','2013-02-26','12:15:00',1.79),('12664','2013-02-26','12:20:00',1.66),('12664','2013-02-26','12:25:00',1.56),('12664','2013-02-26','12:30:00',1.56),('12664','2013-02-26','12:35:00',1.42),('12664','2013-02-26','12:40:00',1.48),('12664','2013-02-26','12:45:00',1.41),('12664','2013-02-26','12:50:00',1.32),('12664','2013-02-26','12:55:00',1.29),('12664','2013-02-26','13:00:00',1.36),('12664','2013-02-26','13:05:00',1.17),('12664','2013-02-26','13:10:00',1.34),('12664','2013-02-26','13:15:00',1.58),('12664','2013-02-26','13:20:00',1.48),('12664','2013-02-26','13:25:00',1.43),('12664','2013-02-26','13:30:00',1.2),('12664','2013-02-25','10:35:00',1.03),('12664','2013-02-25','10:40:00',1.49),('12664','2013-02-25','10:45:00',1.8),('12664','2013-02-25','10:50:00',2.61),('12664','2013-02-25','10:55:00',3.79),('12664','2013-02-25','11:00:00',3.47),('12664','2013-02-25','11:05:00',3.77),('12664','2013-02-25','11:10:00',4.22),('12664','2013-02-25','11:15:00',4),('12664','2013-02-25','11:20:00',4.47),('12664','2013-02-25','11:25:00',1.71),('12664','2013-02-25','11:30:00',1.98),('12664','2013-02-25','11:35:00',1.38),('12664','2013-02-25','11:40:00',1.23),('12664','2013-02-25','11:45:00',1.09),('12664','2013-02-25','11:50:00',1.12),('12664','2013-02-25','11:55:00',1.28),('12664','2013-02-25','12:00:00',1.36),('12664','2013-02-25','12:05:00',1.62),('12664','2013-02-25','12:10:00',1.74),('12664','2013-02-25','12:15:00',1.92),('12664','2013-02-25','12:20:00',2.99),('12664','2013-02-25','12:25:00',3.55),('12664','2013-02-25','12:30:00',4.59),('12664','2013-02-25','12:35:00',3.06),('12664','2013-02-25','12:40:00',3.56),('12664','2013-02-25','12:45:00',4.61),('12664','2013-02-25','12:50:00',4.52),('12664','2013-02-25','12:55:00',4.49),('12664','2013-02-25','13:00:00',4.47),('12664','2013-02-25','13:05:00',4.05),('12664','2013-02-25','13:10:00',3.89),('12664','2013-02-25','13:15:00',2.46),('12664','2013-02-25','13:20:00',2.62),('12664','2013-02-25','13:25:00',1.5),('12664','2013-02-25','13:30:00',1.28),('12664','2013-02-25','13:35:00',1.17),('12664','2013-02-25','13:40:00',1.13),('12664','2013-02-25','13:45:00',1.95),('12664','2013-02-25','13:50:00',1.64),('12664','2013-02-25','13:55:00',1.2),('12664','2013-02-25','14:00:00',1.23),('12664','2013-02-25','14:05:00',1.19),('12664','2013-02-25','14:15:00',1.05),('12664','2013-02-25','16:35:00',1.15),('12664','2013-02-25','16:40:00',1.54),('12664','2013-02-24','10:15:00',1.05),('12664','2013-02-24','10:45:00',1.73),('12664','2013-02-24','10:50:00',2.21),('12664','2013-02-24','10:55:00',3.21),('12664','2013-02-24','11:00:00',2.42),('12664','2013-02-24','11:05:00',1.25),('12664','2013-02-24','11:35:00',1.03),('12664','2013-02-24','11:40:00',1.26),('12664','2013-02-24','11:45:00',1.29),('12664','2013-02-24','11:50:00',1.24),('12664','2013-02-24','11:55:00',1.17),('12664','2013-02-24','12:30:00',1.12),('12664','2013-02-24','12:35:00',1.46),('12664','2013-02-24','12:40:00',1.48),('12664','2013-02-24','12:45:00',1.86),('12664','2013-02-24','12:50:00',2.17),('12664','2013-02-24','12:55:00',2.47),('12664','2013-02-24','13:00:00',4.17),('12664','2013-02-24','13:05:00',3.79),('12664','2013-02-24','13:10:00',1.14),('12664','2013-02-24','13:20:00',1.51),('12664','2013-02-24','13:25:00',1.49),('12664','2013-02-24','13:30:00',2.28),('12664','2013-02-24','13:35:00',2.26),('12664','2013-02-24','13:40:00',1.96),('12664','2013-02-24','13:45:00',1.49),('12664','2013-02-24','13:50:00',1.27),('12664','2013-02-24','13:55:00',1.48),('12664','2013-02-24','14:00:00',1.59),('12664','2013-02-24','14:05:00',1.79),('12664','2013-02-24','14:10:00',1.79),('12664','2013-02-24','14:15:00',1.05),('12664','2013-02-24','14:20:00',1.29),('12664','2013-02-24','14:25:00',1.27),('12664','2013-02-24','14:50:00',2.34),('12664','2013-02-24','14:55:00',2.55),('12664','2013-02-24','15:00:00',2.71),('12664','2013-02-24','15:05:00',2.24),('12664','2013-02-24','15:10:00',1),('12664','2013-02-24','15:15:00',1.43),('12664','2013-02-24','15:20:00',2.05),('12664','2013-02-24','15:25:00',2.51),('12664','2013-02-24','15:30:00',1.72),('12664','2013-02-24','15:35:00',1.34),('12664','2013-02-24','15:40:00',1.66),('12664','2013-02-24','15:45:00',2.59),('12664','2013-02-24','15:50:00',1.2),('12664','2013-02-24','15:55:00',1.17),('12664','2013-02-24','16:00:00',1.49),('12664','2013-02-24','16:05:00',1.77),('12664','2013-02-24','16:10:00',1.59),('12664','2013-02-24','16:15:00',1.78),('12664','2013-02-23','07:50:00',1.06),('12664','2013-02-23','07:55:00',1.24),('12664','2013-02-23','08:00:00',1.31),('12664','2013-02-23','08:05:00',1.56),('12664','2013-02-23','08:10:00',1.93),('12664','2013-02-23','08:15:00',1.67),('12664','2013-02-23','08:55:00',1.09),('12664','2013-02-23','09:00:00',1.22),('12664','2013-02-23','09:05:00',1.2),('12664','2013-02-23','09:55:00',1),('12664','2013-02-23','10:30:00',1.03),('12664','2013-02-23','10:40:00',1.01),('12664','2013-02-23','10:45:00',1.19),('12664','2013-02-23','10:50:00',1.31),('12664','2013-02-23','10:55:00',1.24),('12664','2013-02-23','11:25:00',1.13),('12664','2013-02-23','11:30:00',1.31),('12664','2013-02-23','11:35:00',1.17),('12664','2013-02-23','11:45:00',1.01),('12664','2013-02-22','14:35:00',2.13),('12664','2013-02-22','14:40:00',1.76),('12664','2013-02-22','15:00:00',1.39),('12664','2013-02-22','15:30:00',1.23),('12664','2013-02-22','15:35:00',1.93),('12664','2013-02-21','11:45:00',1),('12664','2013-02-21','12:00:00',1.11),('12664','2013-02-21','12:05:00',1.2),('12664','2013-02-21','12:10:00',1.19),('12664','2013-02-21','12:15:00',1.19),('12664','2013-02-21','12:20:00',1.15),('12664','2013-02-21','12:25:00',1.12),('12664','2013-02-21','12:30:00',1.2),('12664','2013-02-21','12:35:00',1.3),('12664','2013-02-21','12:40:00',1.25),('12664','2013-02-21','12:45:00',1.14),('12664','2013-02-21','12:50:00',1.1),('12664','2013-02-21','12:55:00',1.18),('12664','2013-02-21','13:00:00',1.23),('12664','2013-02-21','13:05:00',1.15),('12664','2013-02-21','13:10:00',1.12),('12664','2013-02-21','13:15:00',1.28),('12664','2013-02-21','13:20:00',1.35),('12664','2013-02-21','13:25:00',1.23),('12664','2013-02-21','13:30:00',1.14),('12664','2013-02-21','13:35:00',1.11),('12664','2013-02-21','13:40:00',1.06),('12664','2013-02-21','13:45:00',1.05),('12664','2013-02-21','15:25:00',1.06),('12664','2013-02-21','15:30:00',1.07),('12664','2013-02-21','15:35:00',1.15),('12664','2013-02-21','15:40:00',1.22),('12664','2013-02-21','15:45:00',1.14),('12664','2013-02-21','15:50:00',1.28),('12664','2013-02-21','15:55:00',1.93),('12664','2013-02-21','16:00:00',1.56),('12664','2013-02-21','16:05:00',1.3),('12664','2013-02-21','16:10:00',1.93),('12664','2013-02-21','16:15:00',1.8),('12664','2013-02-21','16:20:00',1.59),('12664','2013-02-21','16:25:00',1.38),('12664','2013-02-21','16:30:00',1.2),('12664','2013-02-21','16:35:00',1.02),('12664','2013-02-20','08:10:00',1.44),('12664','2013-02-20','08:15:00',1.57),('12664','2013-02-20','08:20:00',1.55),('12664','2013-02-20','08:25:00',1.62),('12664','2013-02-20','08:30:00',1.72),('12664','2013-02-20','08:35:00',1.82),('12664','2013-02-20','08:40:00',1.92),('12664','2013-02-20','08:45:00',2.03),('12664','2013-02-20','08:50:00',2.13),('12664','2013-02-20','08:55:00',2.25),('12664','2013-02-20','09:00:00',2.37),('12664','2013-02-20','09:05:00',2.5),('12664','2013-02-20','09:15:00',1.3),('12664','2013-02-20','09:20:00',1.51),('12664','2013-02-20','09:25:00',1.86),('12664','2013-02-20','09:30:00',1.08),('12664','2013-02-20','09:35:00',2.9),('12664','2013-02-20','09:40:00',2.8),('12664','2013-02-20','09:45:00',1.47),('12664','2013-02-20','09:50:00',2.41),('12664','2013-02-20','09:55:00',2.24),('12664','2013-02-20','10:00:00',3.4),('12664','2013-02-20','10:05:00',3.39),('12664','2013-02-20','10:10:00',1.59),('12664','2013-02-20','10:15:00',2.39),('12664','2013-02-20','10:20:00',3.43),('12664','2013-02-20','10:25:00',3.57),('12664','2013-02-20','10:30:00',1.79),('12664','2013-02-20','10:35:00',2.64),('12664','2013-02-20','10:40:00',1.68),('12664','2013-02-20','10:55:00',2.89),('12664','2013-02-20','11:00:00',3.17),('12664','2013-02-20','11:05:00',4.06),('12664','2013-02-20','11:10:00',3.71),('12664','2013-02-20','11:15:00',3.64),('12664','2013-02-20','11:20:00',4.6),('12664','2013-02-20','11:25:00',3.19),('12664','2013-02-20','11:30:00',2.45),('12664','2013-02-20','11:35:00',2.86),('12664','2013-02-20','11:40:00',1.71),('12664','2013-02-20','11:45:00',1.34),('12664','2013-02-20','11:50:00',2.84),('12664','2013-02-20','11:55:00',2.92),('12664','2013-02-20','12:00:00',1.76),('12664','2013-02-20','12:05:00',1.5),('12664','2013-02-20','12:10:00',1.39),('12664','2013-02-20','12:15:00',2.83),('12664','2013-02-20','12:20:00',2.85),('12664','2013-02-20','12:25:00',4.56),('12664','2013-02-20','12:30:00',1.13),('12664','2013-02-20','12:35:00',1.12),('12664','2013-02-20','12:40:00',1.48),('12664','2013-02-20','12:45:00',2.03),('12664','2013-02-20','12:50:00',2.21),('12664','2013-02-20','12:55:00',3.49),('12664','2013-02-20','13:00:00',2.52),('12664','2013-02-20','13:05:00',2.38),('12664','2013-02-20','13:10:00',2.81),('12664','2013-02-20','13:15:00',1.26),('12664','2013-02-20','13:20:00',1.87),('12664','2013-02-20','13:25:00',2.13),('12664','2013-02-20','13:30:00',4.94),('12664','2013-02-20','13:35:00',4.47),('12664','2013-02-20','13:40:00',4.56),('12664','2013-02-20','13:45:00',4.16),('12664','2013-02-20','13:50:00',3.93),('12664','2013-02-20','13:55:00',3.16),('12664','2013-02-20','14:10:00',1.08),('12664','2013-02-20','14:15:00',2.21),('12664','2013-02-20','14:20:00',3.28),('12664','2013-02-20','14:25:00',1.42),('12664','2013-02-20','14:30:00',1.25),('12664','2013-02-20','14:35:00',2.91),('12664','2013-02-20','14:40:00',1.64),('12664','2013-02-20','14:45:00',1.22),('12664','2013-02-20','14:50:00',1.61),('12664','2013-02-20','14:55:00',1.84),('12664','2013-02-20','15:00:00',2.3),('12664','2013-02-20','15:05:00',2.42),('12664','2013-02-20','15:10:00',2.28),('12664','2013-02-20','15:15:00',2.44),('12664','2013-02-20','15:20:00',1.53),('12664','2013-02-20','15:25:00',1.3),('12664','2013-02-20','15:30:00',1.78),('12664','2013-02-20','15:35:00',1.06),('12664','2013-02-20','15:50:00',1.04),('12664','2013-02-20','16:05:00',1.3),('12664','2013-02-20','16:10:00',1.12),('12664','2013-02-20','16:15:00',1.16),('12664','2013-02-20','16:25:00',1.01),('12664','2013-02-20','16:30:00',1.22),('12664','2014-03-22','08:10:00',1.39),('12664','2014-03-22','08:15:00',1.47),('12664','2014-03-22','08:20:00',1.51),('12664','2014-03-22','08:25:00',1.4),('12664','2014-03-22','08:30:00',1.6),('12664','2014-03-22','08:40:00',1.36),('12664','2014-03-22','08:50:00',1.51),('12664','2014-03-22','08:55:00',1.16),('12664','2014-03-22','09:00:00',1.05),('12664','2014-03-22','09:05:00',1.12),('12664','2014-03-22','09:10:00',1.07),('12664','2014-03-22','09:15:00',1.19),('12664','2014-03-22','09:20:00',1.21),('12664','2014-03-22','09:25:00',2.04),('12664','2014-03-22','09:30:00',2.48),('12664','2014-03-22','09:35:00',1.09),('12664','2014-03-22','09:40:00',2.47),('12664','2014-03-22','09:45:00',2.15),('12664','2014-03-22','09:50:00',1.89),('12664','2014-03-22','09:55:00',2.75),('12664','2014-03-22','10:00:00',2.5),('12664','2014-03-22','10:05:00',3.43),('12664','2014-03-22','10:10:00',1.54),('12664','2014-03-22','10:15:00',1.41),('12664','2014-03-22','10:20:00',1.13),('12664','2014-03-22','10:25:00',1.03),('12664','2014-03-22','10:30:00',1.19),('12664','2014-03-22','10:35:00',1.1),('12664','2014-03-22','10:40:00',1.71),('12664','2014-03-22','10:45:00',2.15),('12664','2014-03-22','10:50:00',2.37),('12664','2014-03-22','10:55:00',1.69),('12664','2014-03-22','11:00:00',2.11),('12664','2014-03-22','11:05:00',2.08),('12664','2014-03-22','11:10:00',1.42),('12664','2014-03-22','11:15:00',1.84),('12664','2014-03-22','11:20:00',2.07),('12664','2014-03-22','11:25:00',3.06),('12664','2014-03-22','11:30:00',2.37),('12664','2014-03-22','11:35:00',3.87),('12664','2014-03-22','11:40:00',1.59),('12664','2014-03-22','11:45:00',3.37),('12664','2014-03-22','11:50:00',1.17),('12664','2014-03-22','11:55:00',2.31),('12664','2014-03-22','12:00:00',3.97),('12664','2014-03-22','12:05:00',4.39),('12664','2014-03-22','12:10:00',3.15),('12664','2014-03-22','12:15:00',1.73),('12664','2014-03-22','12:20:00',1.25),('12664','2014-03-22','12:25:00',2.12),('12664','2014-03-22','12:30:00',3.24),('12664','2014-03-22','12:35:00',4.04),('12664','2014-03-22','12:40:00',3.54),('12664','2014-03-22','12:45:00',2.97),('12664','2014-03-22','12:50:00',3.36),('12664','2014-03-22','12:55:00',3.78),('12664','2014-03-22','13:00:00',1.65),('12664','2014-03-22','13:05:00',2.9),('12664','2014-03-22','13:10:00',3.71),('12664','2014-03-22','13:15:00',3.98),('12664','2014-03-22','13:20:00',3.74),('12664','2014-03-22','13:25:00',3.5),('12664','2014-03-22','13:30:00',3.23),('12664','2014-03-22','13:35:00',3.51),('12664','2014-03-22','13:40:00',2.01),('12664','2014-03-22','13:45:00',3.54),('12664','2014-03-22','13:50:00',3.11),('12664','2014-03-22','13:55:00',3.11),('12664','2014-03-22','14:00:00',3.03),('12664','2014-03-22','14:05:00',3.28),('12664','2014-03-22','14:10:00',3.25),('12664','2014-03-22','14:15:00',3.23),('12664','2014-03-22','14:20:00',3.21),('12664','2014-03-22','14:25:00',2.49),('12664','2014-03-22','14:30:00',2.54),('12664','2014-03-22','14:35:00',2.45),('12664','2014-03-22','14:40:00',2.96),('12664','2014-03-22','14:45:00',2.85),('12664','2014-03-22','14:50:00',2.85),('12664','2014-03-22','14:55:00',1.07),('12664','2014-03-22','15:00:00',2.81),('12664','2014-03-22','15:05:00',2.65),('12664','2014-03-22','15:10:00',2.14),('12664','2014-03-22','15:15:00',2.48),('12664','2014-03-22','15:20:00',2.38),('12664','2014-03-22','15:25:00',2.31),('12664','2014-03-22','15:30:00',2.57),('12664','2014-03-22','15:35:00',1.28),('12664','2014-03-22','15:40:00',1.4),('12664','2014-03-22','15:45:00',2.22),('12664','2014-03-22','15:50:00',2.04),('12664','2014-03-22','15:55:00',1.94),('12664','2014-03-22','16:00:00',1.47),('12664','2014-03-22','16:10:00',1.49),('12664','2013-02-19','08:05:00',1.11),('12664','2013-02-19','08:10:00',1.22),('12664','2013-02-19','08:15:00',1.34),('12664','2013-02-19','08:20:00',1.46),('12664','2013-02-19','08:25:00',1.59),('12664','2013-02-19','08:30:00',1.7),('12664','2013-02-19','08:35:00',1.81),('12664','2013-02-19','08:40:00',1.92),('12664','2013-02-19','08:45:00',2.01),('12664','2013-02-19','08:50:00',2.11),('12664','2013-02-19','08:55:00',2.24),('12664','2013-02-19','09:00:00',2.33),('12664','2013-02-19','09:05:00',2.43),('12664','2013-02-19','09:10:00',2.52),('12664','2013-02-19','09:15:00',2.61),('12664','2013-02-19','09:20:00',2.69),('12664','2013-02-19','09:25:00',2.77),('12664','2013-02-19','09:30:00',2.85),('12664','2013-02-19','09:35:00',2.93),('12664','2013-02-19','09:40:00',2.98),('12664','2013-02-19','09:45:00',3.06),('12664','2013-02-19','09:50:00',3.15),('12664','2013-02-19','09:55:00',3.21),('12664','2013-02-19','10:00:00',3.26),('12664','2013-02-19','10:05:00',3.33),('12664','2013-02-19','10:10:00',3.39),('12664','2013-02-19','10:15:00',3.44),('12664','2013-02-19','10:20:00',3.49),('12664','2013-02-19','10:25:00',3.53),('12664','2013-02-19','10:30:00',3.58),('12664','2013-02-19','10:35:00',3.64),('12664','2013-02-19','10:40:00',3.68),('12664','2013-02-19','10:45:00',3.73),('12664','2013-02-19','10:50:00',3.75),('12664','2013-02-19','10:55:00',3.79),('12664','2013-02-19','11:00:00',3.84),('12664','2013-02-19','11:05:00',3.87),('12664','2013-02-19','11:10:00',3.89),('12664','2013-02-19','11:15:00',3.91),('12664','2013-02-19','11:20:00',3.94),('12664','2013-02-19','11:25:00',3.96),('12664','2013-02-19','11:30:00',3.98),('12664','2013-02-19','11:35:00',3.98),('12664','2013-02-19','11:40:00',4),('12664','2013-02-19','11:45:00',4.01),('12664','2013-02-19','11:50:00',4.02),('12664','2013-02-19','11:55:00',4.04),('12664','2013-02-19','12:00:00',4.02),('12664','2013-02-19','12:05:00',4.04),('12664','2013-02-19','12:10:00',4.02),('12664','2013-02-19','12:15:00',4.05),('12664','2013-02-19','12:20:00',4.04),('12664','2013-02-19','12:25:00',4),('12664','2013-02-19','12:30:00',3.97),('12664','2013-02-19','12:35:00',4),('12664','2013-02-19','12:40:00',4.03),('12664','2013-02-19','12:45:00',4.01),('12664','2013-02-19','12:50:00',3.99),('12664','2013-02-19','12:55:00',3.98),('12664','2013-02-19','13:00:00',3.98),('12664','2013-02-19','13:05:00',3.97),('12664','2013-02-19','13:10:00',3.93),('12664','2013-02-19','13:15:00',3.91),('12664','2013-02-19','13:20:00',3.91),('12664','2013-02-19','13:25:00',3.87),('12664','2013-02-19','13:30:00',3.83),('12664','2013-02-19','13:35:00',3.79),('12664','2013-02-19','13:40:00',3.77),('12664','2013-02-19','13:45:00',3.7),('12664','2013-02-19','13:50:00',3.68),('12664','2013-02-19','13:55:00',3.67),('12664','2013-02-19','14:00:00',3.58),('12664','2013-02-19','14:05:00',3.45),('12664','2013-02-19','14:10:00',3.4),('12664','2013-02-19','14:15:00',3.32),('12664','2013-02-19','14:20:00',3.3),('12664','2013-02-19','14:25:00',3.26),('12664','2013-02-19','14:30:00',3.11),('12664','2013-02-19','14:35:00',3.13),('12664','2013-02-19','14:40:00',3.07),('12664','2013-02-19','14:45:00',3.03),('12664','2013-02-19','14:50:00',3.02),('12664','2013-02-19','14:55:00',2.89),('12664','2013-02-19','15:00:00',2.82),('12664','2013-02-19','15:05:00',2.72),('12664','2013-02-19','15:10:00',2.66),('12664','2013-02-19','15:15:00',2.6),('12664','2013-02-19','15:20:00',2.49),('12664','2013-02-19','15:25:00',2.48),('12664','2013-02-19','15:30:00',2.37),('12664','2013-02-19','15:35:00',2.29),('12664','2013-02-19','15:40:00',2.21),('12664','2013-02-19','15:45:00',2.11),('12664','2013-02-19','15:50:00',2.02),('12664','2013-02-19','15:55:00',1.93),('12664','2013-02-19','16:00:00',1.83),('12664','2013-02-19','16:05:00',1.71),('12664','2013-02-19','16:10:00',1.61),('12664','2013-02-19','16:15:00',1.49),('12664','2013-02-19','16:20:00',1.38),('12664','2013-02-19','16:25:00',1.28),('12664','2013-02-19','16:30:00',1.16),('12664','2013-02-19','16:35:00',1.06),('12664','2013-02-18','08:00:00',1.07),('12664','2013-02-18','08:05:00',1.01),('12664','2013-02-18','08:10:00',1.04),('12664','2013-02-18','08:15:00',1.19),('12664','2013-02-18','08:20:00',1.34),('12664','2013-02-18','08:25:00',1.47),('12664','2013-02-18','08:30:00',1.56),('12664','2013-02-18','08:35:00',1.69),('12664','2013-02-18','08:40:00',1.8),('12664','2013-02-18','08:45:00',1.89),('12664','2013-02-18','08:50:00',1.97),('12664','2013-02-18','08:55:00',2.09),('12664','2013-02-18','09:00:00',2.19),('12664','2013-02-18','09:05:00',2.28),('12664','2013-02-18','09:10:00',2.32),('12664','2013-02-18','09:15:00',2.44),('12664','2013-02-18','09:20:00',2.55),('12664','2013-02-18','09:25:00',1.28),('12664','2013-02-18','09:35:00',2.41),('12664','2013-02-18','09:40:00',2.62),('12664','2013-02-18','09:45:00',1.07),('12664','2013-02-18','10:00:00',1.02),('12664','2013-02-18','10:05:00',3.57),('12664','2013-02-18','10:10:00',3.26),('12664','2013-02-18','10:15:00',3.3),('12664','2013-02-18','10:20:00',2.87),('12664','2013-02-18','10:25:00',3.21),('12664','2013-02-18','10:30:00',3.08),('12664','2013-02-18','10:35:00',3.52),('12664','2013-02-18','10:40:00',3.14),('12664','2013-02-18','10:45:00',1.89),('12664','2013-02-18','10:50:00',3.37),('12664','2013-02-18','10:55:00',1.44),('12664','2013-02-18','11:00:00',1.65),('12664','2013-02-18','11:05:00',1.46),('12664','2013-02-18','11:10:00',1.53),('12664','2013-02-18','11:15:00',1.79),('12664','2013-02-18','11:20:00',1.67),('12664','2013-02-18','11:25:00',1.87),('12664','2013-02-18','11:30:00',2.09),('12664','2013-02-18','11:35:00',2.33),('12664','2013-02-18','11:40:00',2.37),('12664','2013-02-18','11:45:00',2.57),('12664','2013-02-18','11:50:00',2.75),('12664','2013-02-18','11:55:00',2.14),('12664','2013-02-18','12:00:00',1.63),('12664','2013-02-18','12:05:00',1.48),('12664','2013-02-18','12:10:00',1.41),('12664','2013-02-18','12:15:00',1.27),('12664','2013-02-18','12:20:00',1.4),('12664','2013-02-18','12:25:00',1.73),('12664','2013-02-18','12:30:00',1.44),('12664','2013-02-18','12:35:00',1.43),('12664','2013-02-18','12:40:00',1.57),('12664','2013-02-18','12:45:00',1.73),('12664','2013-02-18','12:50:00',2.44),('12664','2013-02-18','12:55:00',2.79),('12664','2013-02-18','13:00:00',2.9),('12664','2013-02-18','13:05:00',2.5),('12664','2013-02-18','13:10:00',2.36),('12664','2013-02-18','13:15:00',3.07),('12664','2013-02-18','13:20:00',1.84),('12664','2013-02-18','13:25:00',1.53),('12664','2013-02-18','13:30:00',1.15),('12664','2013-02-18','13:35:00',1.05),('12664','2013-02-18','13:40:00',1.24),('12664','2013-02-18','13:45:00',1.32),('12664','2013-02-18','13:50:00',1.54),('12664','2013-02-18','13:55:00',2.18),('12664','2013-02-18','14:00:00',2.14),('12664','2013-02-18','14:05:00',1.92),('12664','2013-02-18','14:10:00',2.31),('12664','2013-02-18','14:15:00',2.82),('12664','2013-02-18','14:20:00',1.55),('12664','2013-02-18','14:35:00',1.17),('12664','2013-02-18','14:40:00',1.65),('12664','2013-02-18','14:45:00',1.24),('12664','2013-02-18','14:50:00',1.47),('12664','2013-02-18','14:55:00',1.58),('12664','2013-02-18','15:00:00',1.44),('12664','2013-02-18','15:05:00',1.07),('12664','2013-02-17','08:10:00',1.05),('12664','2013-02-17','08:15:00',1.17),('12664','2013-02-17','08:20:00',1.3),('12664','2013-02-17','08:25:00',1.45),('12664','2013-02-17','08:30:00',1.58),('12664','2013-02-17','08:35:00',1.71),('12664','2013-02-17','08:40:00',1.32),('12664','2013-02-17','08:45:00',1.18),('12664','2013-02-17','08:50:00',1.74),('12664','2013-02-17','08:55:00',1.89),('12664','2013-02-17','09:00:00',2.07),('12664','2013-02-17','09:05:00',2.04),('12664','2013-02-17','09:10:00',2.23),('12664','2013-02-17','09:15:00',2.27),('12664','2013-02-17','09:20:00',2.43),('12664','2013-02-17','09:25:00',2.52),('12664','2013-02-17','09:30:00',2.59),('12664','2013-02-17','09:35:00',2.71),('12664','2013-02-17','09:40:00',2.76),('12664','2013-02-17','09:45:00',2.83),('12664','2013-02-17','09:50:00',2.91),('12664','2013-02-17','09:55:00',2.96),('12664','2013-02-17','10:00:00',3.03),('12664','2013-02-17','10:05:00',3.09),('12664','2013-02-17','10:10:00',3.12),('12664','2013-02-17','10:15:00',3.19),('12664','2013-02-17','10:20:00',3.26),('12664','2013-02-17','10:25:00',3.32),('12664','2013-02-17','10:30:00',3.39),('12664','2013-02-17','10:35:00',3.42),('12664','2013-02-17','10:40:00',3.51),('12664','2013-02-17','10:45:00',3.54),('12664','2013-02-17','10:50:00',3.59),('12664','2013-02-17','10:55:00',3.63),('12664','2013-02-17','11:00:00',3.66),('12664','2013-02-17','11:05:00',3.7),('12664','2013-02-17','11:10:00',3.75),('12664','2013-02-17','11:15:00',3.76),('12664','2013-02-17','11:20:00',3.78),('12664','2013-02-17','11:25:00',3.74),('12664','2013-02-17','11:30:00',3.81),('12664','2013-02-17','11:35:00',3.86),('12664','2013-02-17','11:40:00',3.87),('12664','2013-02-17','11:45:00',3.86),('12664','2013-02-17','11:50:00',3.87),('12664','2013-02-17','11:55:00',3.83),('12664','2013-02-17','12:00:00',3.76),('12664','2013-02-17','12:05:00',3.86),('12664','2013-02-17','12:10:00',3.82),('12664','2013-02-17','12:15:00',3.8),('12664','2013-02-17','12:20:00',3.83),('12664','2013-02-17','12:25:00',3.79),('12664','2013-02-17','12:30:00',3.8),('12664','2013-02-17','12:35:00',3.79),('12664','2013-02-17','12:40:00',3.79),('12664','2013-02-17','12:45:00',3.78),('12664','2013-02-17','12:50:00',3.73),('12664','2013-02-17','12:55:00',3.74),('12664','2013-02-17','13:00:00',3.76),('12664','2013-02-17','13:05:00',3.74),('12664','2013-02-17','13:10:00',3.76),('12664','2013-02-17','13:15:00',3.74),('12664','2013-02-17','13:20:00',3.72),('12664','2013-02-17','13:25:00',3.69),('12664','2013-02-17','13:30:00',3.63),('12664','2013-02-17','13:35:00',3.18),('12664','2013-02-17','13:40:00',2.37),('12664','2013-02-17','13:45:00',3.62),('12664','2013-02-17','13:50:00',3.48),('12664','2013-02-17','13:55:00',3.46),('12664','2013-02-17','14:00:00',3.42),('12664','2013-02-17','14:05:00',3.08),('12664','2013-02-17','14:10:00',3.3),('12664','2013-02-17','14:15:00',3.28),('12664','2013-02-17','14:20:00',3.15),('12664','2013-02-17','14:25:00',3.03),('12664','2013-02-17','14:30:00',3.15),('12664','2013-02-17','14:35:00',3.05),('12664','2013-02-17','14:40:00',3.01),('12664','2013-02-17','14:45:00',2.94),('12664','2013-02-17','14:50:00',2.86),('12664','2013-02-17','14:55:00',2.82),('12664','2013-02-17','15:00:00',2.72),('12664','2013-02-17','15:05:00',2.62),('12664','2013-02-17','15:10:00',2.56),('12664','2013-02-17','15:15:00',2.46),('12664','2013-02-17','15:20:00',2.27),('12664','2013-02-17','15:25:00',2.08),('12664','2013-02-17','15:30:00',1.95),('12664','2013-02-17','15:35:00',2.1),('12664','2013-02-17','15:40:00',2.07),('12664','2013-02-17','15:45:00',1.87),('12664','2013-02-17','15:50:00',1.35),('12664','2013-02-17','15:55:00',1.75),('12664','2013-02-17','16:15:00',1),('12664','2013-02-17','16:20:00',1.07),('12664','2013-02-17','16:25:00',1.05),('12664','2013-02-16','08:10:00',1.06),('12664','2013-02-16','08:15:00',1.14),('12664','2013-02-16','08:20:00',1.23),('12664','2013-02-16','08:25:00',1.35),('12664','2013-02-16','08:30:00',1.41),('12664','2013-02-16','08:35:00',1.54),('12664','2013-02-16','08:40:00',1.67),('12664','2013-02-16','08:45:00',1.8),('12664','2013-02-16','08:50:00',1.9),('12664','2013-02-16','08:55:00',2.02),('12664','2013-02-16','09:00:00',2.13),('12664','2013-02-16','09:05:00',2.23),('12664','2013-02-16','09:10:00',2.29),('12664','2013-02-16','09:15:00',2.49),('12664','2013-02-16','09:20:00',2.68),('12664','2013-02-16','09:25:00',2.75),('12664','2013-02-16','09:30:00',2.81),('12664','2013-02-16','09:35:00',2.83),('12664','2013-02-16','09:40:00',2.9),('12664','2013-02-16','09:45:00',2.73),('12664','2013-02-16','09:50:00',2.87),('12664','2013-02-16','09:55:00',2.93),('12664','2013-02-16','10:00:00',3),('12664','2013-02-16','10:05:00',3.07),('12664','2013-02-16','10:10:00',3.2),('12664','2013-02-16','10:15:00',3.2),('12664','2013-02-16','10:20:00',3.31),('12664','2013-02-16','10:25:00',3.37),('12664','2013-02-16','10:30:00',3.43),('12664','2013-02-16','10:35:00',3.41),('12664','2013-02-16','10:40:00',3.46),('12664','2013-02-16','10:45:00',3.5),('12664','2013-02-16','10:50:00',3.55),('12664','2013-02-16','10:55:00',3.61),('12664','2013-02-16','11:00:00',3.65),('12664','2013-02-16','11:05:00',3.68),('12664','2013-02-16','11:10:00',3.7),('12664','2013-02-16','11:15:00',3.68),('12664','2013-02-16','11:20:00',3.72),('12664','2013-02-16','11:25:00',3.78),('12664','2013-02-16','11:30:00',3.73),('12664','2013-02-16','11:35:00',3.8),('12664','2013-02-16','11:40:00',3.89),('12664','2013-02-16','11:45:00',3.84),('12664','2013-02-16','11:50:00',3.92),('12664','2013-02-16','11:55:00',3.94),('12664','2013-02-16','12:00:00',3.94),('12664','2013-02-16','12:05:00',3.9),('12664','2013-02-16','12:10:00',3.91),('12664','2013-02-16','12:15:00',3.93),('12664','2013-02-16','12:20:00',3.95),('12664','2013-02-16','12:25:00',3.94),('12664','2013-02-16','12:30:00',3.98),('12664','2013-02-16','12:35:00',3.95),('12664','2013-02-16','12:40:00',3.95),('12664','2013-02-16','12:45:00',3.95),('12664','2013-02-16','12:50:00',3.96),('12664','2013-02-16','12:55:00',3.93),('12664','2013-02-16','13:00:00',3.92),('12664','2013-02-16','13:05:00',3.79),('12664','2013-02-16','13:10:00',3.85),('12664','2013-02-16','13:15:00',3.76),('12664','2013-02-16','13:20:00',3.58),('12664','2013-02-16','13:25:00',3.7),('12664','2013-02-16','13:30:00',3.7),('12664','2013-02-16','13:35:00',3.12),('12664','2013-02-16','13:40:00',3.64),('12664','2013-02-16','13:45:00',3.53),('12664','2013-02-16','13:50:00',3.58),('12664','2013-02-16','13:55:00',3.54),('12664','2013-02-16','14:00:00',3.46),('12664','2013-02-16','14:05:00',2.87),('12664','2013-02-16','14:10:00',3.38),('12664','2013-02-16','14:15:00',3.32),('12664','2013-02-16','14:20:00',3.27),('12664','2013-02-16','14:25:00',3.25),('12664','2013-02-16','14:30:00',2.71),('12664','2013-02-16','14:35:00',2.87),('12664','2013-02-16','14:40:00',3.19),('12664','2013-02-16','14:45:00',3.06),('12664','2013-02-16','14:50:00',2.95),('12664','2013-02-16','14:55:00',2.89),('12664','2013-02-16','15:00:00',2.67),('12664','2013-02-16','15:05:00',2.31),('12664','2013-02-16','15:10:00',3),('12664','2013-02-16','15:15:00',2.11),('12664','2013-02-16','15:20:00',1.23),('12664','2013-02-16','15:25:00',1.22),('12664','2013-02-16','15:30:00',1.49),('12664','2013-02-16','15:35:00',1.16),('12664','2013-02-16','15:40:00',1),('12664','2013-02-15','09:20:00',1.57),('12664','2013-02-15','09:25:00',1.35),('12664','2013-02-15','09:30:00',1.46),('12664','2013-02-15','09:35:00',1.8),('12664','2013-02-15','09:40:00',2.17),('12664','2013-02-15','09:45:00',1.8),('12664','2013-02-15','09:50:00',2.6),('12664','2013-02-15','09:55:00',2.54),('12664','2013-02-15','10:00:00',2.77),('12664','2013-02-15','10:05:00',2.67),('12664','2013-02-15','10:10:00',1.85),('12664','2013-02-15','10:15:00',2.21),('12664','2013-02-15','10:20:00',2.3),('12664','2013-02-15','10:25:00',3.26),('12664','2013-02-15','10:30:00',3.35),('12664','2013-02-15','10:35:00',3.26),('12664','2013-02-15','10:40:00',3.47),('12664','2013-02-15','10:45:00',1.98),('12664','2013-02-15','10:50:00',1.98),('12664','2013-02-15','10:55:00',2.25),('12664','2013-02-15','11:00:00',2.11),('12664','2013-02-15','11:05:00',2.75),('12664','2013-02-15','11:10:00',4.04),('12664','2013-02-15','11:15:00',3.99),('12664','2013-02-15','11:20:00',3.98),('12664','2013-02-15','11:25:00',4.02),('12664','2013-02-15','11:30:00',3.99),('12664','2013-02-15','11:35:00',4.07),('12664','2013-02-15','11:40:00',4.16),('12664','2013-02-15','11:45:00',3.22),('12664','2013-02-15','11:50:00',3.6),('12664','2013-02-15','11:55:00',3.06),('12664','2013-02-15','12:00:00',2.52),('12664','2013-02-15','12:05:00',2.67),('12664','2013-02-15','12:10:00',4.19),('12664','2013-02-15','12:15:00',3.5),('12664','2013-02-15','12:20:00',4.35),('12664','2013-02-15','12:25:00',4.12),('12664','2013-02-15','12:30:00',3.94),('12664','2013-02-15','12:35:00',3.94),('12664','2013-02-15','12:40:00',3.95),('12664','2013-02-15','12:45:00',3.93),('12664','2013-02-15','12:50:00',3.99),('12664','2013-02-15','12:55:00',3.97),('12664','2013-02-15','13:00:00',4.03),('12664','2013-02-15','13:05:00',4.01),('12664','2013-02-15','13:10:00',2.32),('12664','2013-02-15','13:15:00',2.37),('12664','2013-02-15','13:20:00',2.43),('12664','2013-02-15','13:25:00',1.95),('12664','2013-02-15','13:30:00',3.46),('12664','2013-02-15','13:35:00',2.6),('12664','2013-02-15','13:40:00',2.4),('12664','2013-02-15','13:45:00',3.67),('12664','2013-02-15','13:50:00',3.83),('12664','2013-02-15','13:55:00',4.11),('12664','2013-02-15','14:00:00',3.28),('12664','2013-02-15','14:05:00',2.79),('12664','2013-02-15','14:10:00',3.34),('12664','2013-02-15','14:15:00',3.01),('12664','2013-02-15','14:20:00',2.48),('12664','2013-02-15','14:25:00',2.75),('12664','2013-02-15','14:30:00',3.14),('12664','2013-02-15','14:35:00',2.84),('12664','2013-02-15','14:40:00',3.2),('12664','2013-02-15','14:45:00',2.14),('12664','2013-02-15','14:50:00',2.53),('12664','2013-02-15','14:55:00',1.5),('12664','2013-02-15','15:00:00',1.73),('12664','2013-02-15','15:05:00',2.69),('12664','2013-02-15','15:10:00',2.23),('12664','2013-02-15','15:15:00',2.52),('12664','2013-02-15','15:20:00',2.09),('12664','2013-02-15','15:25:00',1.31),('12664','2013-02-15','15:30:00',1.17),('12664','2013-02-15','15:35:00',1.44),('12664','2013-02-15','15:40:00',1.29),('12664','2013-02-14','08:05:00',1.03),('12664','2013-02-14','08:10:00',1.16),('12664','2013-02-14','08:15:00',1.24),('12664','2013-02-14','08:20:00',1.35),('12664','2013-02-14','08:25:00',1.56),('12664','2013-02-14','08:30:00',1.66),('12664','2013-02-14','08:35:00',1.76),('12664','2013-02-14','08:40:00',1.86),('12664','2013-02-14','08:45:00',1.97),('12664','2013-02-14','08:50:00',2.07),('12664','2013-02-14','08:55:00',2.17),('12664','2013-02-14','09:00:00',2.27),('12664','2013-02-14','09:05:00',2.38),('12664','2013-02-14','09:10:00',2.47),('12664','2013-02-14','09:15:00',2.56),('12664','2013-02-14','09:20:00',2.64),('12664','2013-02-14','09:25:00',2.73),('12664','2013-02-14','09:30:00',2.81),('12664','2013-02-14','09:35:00',2.89),('12664','2013-02-14','09:40:00',2.97),('12664','2013-02-14','09:45:00',3.05),('12664','2013-02-14','09:50:00',3.11),('12664','2013-02-14','09:55:00',3.2),('12664','2013-02-14','10:00:00',3.27),('12664','2013-02-14','10:05:00',3.34),('12664','2013-02-14','10:10:00',3.4),('12664','2013-02-14','10:15:00',3.45),('12664','2013-02-14','10:20:00',3.52),('12664','2013-02-14','10:25:00',3.57),('12664','2013-02-14','10:30:00',3.61),('12664','2013-02-14','10:35:00',3.66),('12664','2013-02-14','10:40:00',3.71),('12664','2013-02-14','10:45:00',3.76),('12664','2013-02-14','10:50:00',3.81),('12664','2013-02-14','10:55:00',3.83),('12664','2013-02-14','11:00:00',3.85),('12664','2013-02-14','11:05:00',3.91),('12664','2013-02-14','11:10:00',3.62),('12664','2013-02-14','11:15:00',3.73),('12664','2013-02-14','11:20:00',4),('12664','2013-02-14','11:25:00',4.01),('12664','2013-02-14','11:30:00',4.02),('12664','2013-02-14','11:35:00',4.05),('12664','2013-02-14','11:40:00',4.06),('12664','2013-02-14','11:45:00',4.07),('12664','2013-02-14','11:50:00',4.07),('12664','2013-02-14','11:55:00',4.09),('12664','2013-02-14','12:00:00',4.1),('12664','2013-02-14','12:05:00',4.12),('12664','2013-02-14','12:10:00',4.14),('12664','2013-02-14','12:15:00',4.14),('12664','2013-02-14','12:20:00',4.12),('12664','2013-02-14','12:25:00',4.09),('12664','2013-02-14','12:30:00',4.09),('12664','2013-02-14','12:35:00',4.07),('12664','2013-02-14','12:40:00',4.06),('12664','2013-02-14','12:45:00',4.05),('12664','2013-02-14','12:50:00',4.06),('12664','2013-02-14','12:55:00',4.05),('12664','2013-02-14','13:00:00',4.02),('12664','2013-02-14','13:05:00',4.01),('12664','2013-02-14','13:10:00',3.99),('12664','2013-02-14','13:15:00',3.97),('12664','2013-02-14','13:20:00',3.96),('12664','2013-02-14','13:25:00',3.92),('12664','2013-02-14','13:30:00',3.86),('12664','2013-02-14','13:35:00',3.83),('12664','2013-02-14','13:40:00',3.79),('12664','2013-02-14','13:45:00',3.7),('12664','2013-02-14','13:50:00',3.67),('12664','2013-02-14','13:55:00',3.64),('12664','2013-02-14','14:00:00',3.58),('12664','2013-02-14','14:05:00',3.55),('12664','2013-02-14','14:10:00',3.49),('12664','2013-02-14','14:15:00',3.42),('12664','2013-02-14','14:20:00',3.36),('12664','2013-02-14','14:25:00',3.27),('12664','2013-02-14','14:30:00',3.25),('12664','2013-02-14','14:35:00',3.18),('12664','2013-02-14','14:40:00',3.12),('12664','2013-02-14','14:45:00',3.04),('12664','2013-02-14','14:50:00',2.98),('12664','2013-02-14','14:55:00',2.9),('12664','2013-02-14','15:00:00',2.82),('12664','2013-02-14','15:05:00',2.73),('12664','2013-02-14','15:10:00',2.64),('12664','2013-02-14','15:15:00',2.55),('12664','2013-02-14','15:20:00',2.47),('12664','2013-02-14','15:25:00',2.39),('12664','2013-02-14','15:30:00',2.31),('12664','2013-02-14','15:35:00',2.21),('12664','2013-02-14','15:40:00',2.09),('12664','2013-02-14','15:45:00',2.01),('12664','2013-02-14','15:50:00',1.9),('12664','2013-02-14','15:55:00',1.8),('12664','2013-02-14','16:00:00',1.69),('12664','2013-02-14','16:05:00',1.56),('12664','2013-02-14','16:10:00',1.42),('12664','2013-02-14','16:15:00',1.34),('12664','2013-02-14','16:20:00',1.25),('12664','2013-02-14','16:25:00',1.15),('12664','2013-02-14','16:30:00',1.04),('12664','2013-02-13','09:00:00',1.04),('12664','2013-02-13','09:05:00',1.11),('12664','2013-02-13','09:10:00',1.12),('12664','2013-02-13','09:15:00',1.29),('12664','2013-02-13','09:20:00',1.85),('12664','2013-02-13','09:25:00',2.16),('12664','2013-02-13','09:30:00',2.26),('12664','2013-02-13','09:35:00',2.38),('12664','2013-02-13','09:40:00',2.52),('12664','2013-02-13','09:45:00',2.59),('12664','2013-02-13','09:50:00',2.48),('12664','2013-02-13','09:55:00',2.53),('12664','2013-02-13','10:00:00',2.88),('12664','2013-02-13','10:05:00',3.18),('12664','2013-02-13','10:10:00',3.25),('12664','2013-02-13','10:15:00',3.29),('12664','2013-02-13','10:20:00',3.27),('12664','2013-02-13','10:25:00',2.96),('12664','2013-02-13','10:30:00',3.14),('12664','2013-02-13','10:35:00',3.28),('12664','2013-02-13','10:40:00',3.53),('12664','2013-02-13','10:45:00',3.67),('12664','2013-02-13','10:50:00',3.6),('12664','2013-02-13','10:55:00',3.7),('12664','2013-02-13','11:00:00',3.83),('12664','2013-02-13','11:05:00',3.92),('12664','2013-02-13','11:10:00',3.86),('12664','2013-02-13','11:15:00',3.81),('12664','2013-02-13','11:20:00',3.29),('12664','2013-02-13','11:25:00',3.36),('12664','2013-02-13','11:30:00',3.27),('12664','2013-02-13','11:35:00',1.62),('12664','2013-02-13','11:40:00',2.35),('12664','2013-02-13','11:45:00',4.23),('12664','2013-02-13','11:50:00',3.63),('12664','2013-02-13','11:55:00',3.22),('12664','2013-02-13','12:00:00',2.32),('12664','2013-02-13','12:05:00',4.05),('12664','2013-02-13','12:10:00',4.08),('12664','2013-02-13','12:15:00',2.71),('12664','2013-02-13','12:20:00',2.78),('12664','2013-02-13','12:25:00',3.21),('12664','2013-02-13','12:30:00',1.57),('12664','2013-02-13','12:35:00',1.37),('12664','2013-02-13','12:40:00',1.5),('12664','2013-02-13','12:45:00',1.73),('12664','2013-02-13','12:50:00',1.23),('12664','2013-02-13','12:55:00',1.15),('12664','2013-02-13','13:00:00',1.88),('12664','2013-02-13','13:05:00',1.62),('12664','2013-02-13','13:10:00',1.23),('12664','2013-02-13','13:15:00',1.43),('12664','2013-02-13','13:20:00',1.23),('12664','2013-02-13','13:25:00',1),('12664','2013-02-13','13:30:00',1.17),('12664','2013-02-13','13:35:00',2.64),('12664','2013-02-13','13:40:00',3.79),('12664','2013-02-13','13:45:00',3.61),('12664','2013-02-13','13:50:00',3.81),('12664','2013-02-13','13:55:00',3.8),('12664','2013-02-13','14:00:00',3.56),('12664','2013-02-13','14:05:00',3.62),('12664','2013-02-13','14:10:00',3.58),('12664','2013-02-13','14:15:00',3.17),('12664','2013-02-13','14:20:00',2.83),('12664','2013-02-13','14:25:00',2.83),('12664','2013-02-13','14:30:00',2.72),('12664','2013-02-13','14:35:00',2.6),('12664','2013-02-13','14:40:00',2.92),('12664','2013-02-13','14:45:00',2.86),('12664','2013-02-13','14:50:00',2.88),('12664','2013-02-13','14:55:00',2.97),('12664','2013-02-13','15:00:00',2.87),('12664','2013-02-13','15:05:00',2.71),('12664','2013-02-13','15:10:00',2.68),('12664','2013-02-13','15:15:00',2.59),('12664','2013-02-13','15:20:00',2.52),('12664','2013-02-13','15:25:00',2.43),('12664','2013-02-13','15:30:00',2.31),('12664','2013-02-13','15:35:00',2.21),('12664','2013-02-13','15:40:00',2.13),('12664','2013-02-13','15:45:00',2.06),('12664','2013-02-13','15:50:00',1.93),('12664','2013-02-13','15:55:00',1.85),('12664','2013-02-13','16:00:00',1.76),('12664','2013-02-13','16:05:00',1.66),('12664','2013-02-13','16:10:00',1.53),('12664','2013-02-13','16:15:00',1.41),('12664','2013-02-13','16:20:00',1.29),('12664','2013-02-13','16:25:00',1.2),('12664','2013-02-13','16:30:00',1.09),('12664','2013-02-11','10:10:00',1.08),('12664','2013-02-11','10:15:00',1.14),('12664','2013-02-11','10:20:00',1.05),('12664','2013-02-11','11:15:00',1.22),('12664','2013-02-11','11:20:00',1.44),('12664','2013-02-11','11:40:00',1.01),('12664','2013-02-11','11:45:00',1.01),('12664','2013-02-11','14:10:00',1.04),('12664','2013-02-11','14:40:00',1.35),('12664','2013-02-11','14:45:00',1.16),('12664','2013-02-11','14:50:00',1.06),('12664','2013-02-10','09:15:00',1.31),('12664','2013-02-10','09:20:00',1.84),('12664','2013-02-10','09:25:00',2.84),('12664','2013-02-10','09:30:00',2.45),('12664','2013-02-10','09:35:00',1.67),('12664','2013-02-10','09:40:00',2.72),('12664','2013-02-10','09:45:00',3.02),('12664','2013-02-10','09:50:00',3.06),('12664','2013-02-10','09:55:00',3.06),('12664','2013-02-10','10:00:00',3.14),('12664','2013-02-10','10:05:00',3.18),('12664','2013-02-10','10:10:00',3.25),('12664','2013-02-10','10:15:00',3.31),('12664','2013-02-10','10:20:00',3.39),('12664','2013-02-10','10:25:00',3.46),('12664','2013-02-10','10:30:00',3.46),('12664','2013-02-10','10:35:00',3.5),('12664','2013-02-10','10:40:00',3.52),('12664','2013-02-10','10:45:00',3.56),('12664','2013-02-10','10:50:00',3.61),('12664','2013-02-10','10:55:00',3.66),('12664','2013-02-10','11:00:00',3.7),('12664','2013-02-10','11:05:00',3.72),('12664','2013-02-10','11:10:00',3.75),('12664','2013-02-10','11:15:00',3.77),('12664','2013-02-10','11:20:00',3.79),('12664','2013-02-10','11:25:00',3.83),('12664','2013-02-10','11:30:00',3.87),('12664','2013-02-10','11:35:00',3.88),('12664','2013-02-10','11:40:00',3.88),('12664','2013-02-10','11:45:00',3.94),('12664','2013-02-10','11:50:00',3.91),('12664','2013-02-10','11:55:00',3.8),('12664','2013-02-10','12:00:00',3.98),('12664','2013-02-10','12:05:00',3.97),('12664','2013-02-10','12:10:00',3.99),('12664','2013-02-10','12:15:00',4.03),('12664','2013-02-10','12:20:00',3.98),('12664','2013-02-10','12:25:00',3.94),('12664','2013-02-10','12:30:00',3.97),('12664','2013-02-10','12:35:00',3.94),('12664','2013-02-10','12:40:00',3.9),('12664','2013-02-10','12:45:00',3.93),('12664','2013-02-10','12:50:00',3.91),('12664','2013-02-10','12:55:00',3.92),('12664','2013-02-10','13:00:00',3.89),('12664','2013-02-10','13:05:00',3.86),('12664','2013-02-10','13:10:00',3.86),('12664','2013-02-10','13:15:00',3.84),('12664','2013-02-10','13:20:00',3.79),('12664','2013-02-10','13:25:00',3.77),('12664','2013-02-10','13:30:00',3.74),('12664','2013-02-10','13:35:00',3.69),('12664','2013-02-10','13:40:00',3.59),('12664','2013-02-10','13:45:00',3.55),('12664','2013-02-10','13:50:00',3.55),('12664','2013-02-10','13:55:00',3.5),('12664','2013-02-10','14:00:00',3.44),('12664','2013-02-10','14:05:00',3.41),('12664','2013-02-10','14:10:00',3.36),('12664','2013-02-10','14:15:00',3.31),('12664','2013-02-10','14:20:00',3.34),('12664','2013-02-10','14:25:00',3.22),('12664','2013-02-10','14:30:00',3.09),('12664','2013-02-10','14:35:00',3),('12664','2013-02-10','14:40:00',2.97),('12664','2013-02-10','14:45:00',2.87),('12664','2013-02-10','14:50:00',2.74),('12664','2013-02-10','14:55:00',2.69),('12664','2013-02-10','15:00:00',2.72),('12664','2013-02-10','15:05:00',2.11),('12664','2013-02-10','15:10:00',2),('12664','2013-02-10','15:15:00',1.06),('12664','2013-02-10','15:30:00',1),('12664','2013-02-10','15:45:00',1.24),('12664','2013-02-10','15:50:00',1.62),('12664','2013-02-10','15:55:00',1.32),('12664','2013-02-10','16:00:00',1.25),('12664','2013-02-10','16:05:00',1.12),('12664','2013-02-10','16:10:00',1.02),('12664','2013-02-10','16:15:00',1.67),('12664','2013-02-10','16:20:00',1.69),('12664','2013-02-10','16:25:00',1.33),('12664','2013-02-10','16:30:00',1.13),('12664','2014-03-21','07:45:00',1.03),('12664','2014-03-21','07:50:00',1.17),('12664','2014-03-21','07:55:00',1.28),('12664','2014-03-21','08:00:00',1.36),('12664','2014-03-21','08:05:00',1.43),('12664','2014-03-21','08:10:00',1.38),('12664','2014-03-21','08:15:00',1.6),('12664','2014-03-21','08:20:00',1.68),('12664','2014-03-21','08:25:00',1.79),('12664','2014-03-21','08:30:00',1.88),('12664','2014-03-21','08:35:00',1.96),('12664','2014-03-21','08:40:00',2.04),('12664','2014-03-21','08:45:00',2.1),('12664','2014-03-21','08:50:00',2.16),('12664','2014-03-21','08:55:00',2.27),('12664','2014-03-21','09:00:00',2.35),('12664','2014-03-21','09:05:00',2.41),('12664','2014-03-21','09:10:00',2.5),('12664','2014-03-21','09:15:00',2.58),('12664','2014-03-21','09:20:00',2.63),('12664','2014-03-21','09:25:00',2.63),('12664','2014-03-21','09:30:00',2.66),('12664','2014-03-21','09:35:00',2.8),('12664','2014-03-21','09:40:00',2.85),('12664','2014-03-21','09:45:00',2.89),('12664','2014-03-21','09:50:00',2.92),('12664','2014-03-21','09:55:00',2.71),('12664','2014-03-21','10:00:00',3.06),('12664','2014-03-21','10:05:00',3.03),('12664','2014-03-21','10:10:00',3.06),('12664','2014-03-21','10:15:00',3.06),('12664','2014-03-21','10:20:00',3.14),('12664','2014-03-21','10:25:00',3.15),('12664','2014-03-21','10:30:00',3.09),('12664','2014-03-21','10:35:00',3.16),('12664','2014-03-21','10:40:00',3.15),('12664','2014-03-21','10:45:00',3.19),('12664','2014-03-21','10:50:00',3.21),('12664','2014-03-21','10:55:00',3.32),('12664','2014-03-21','11:00:00',3.37),('12664','2014-03-21','11:05:00',3.33),('12664','2014-03-21','11:10:00',3.41),('12664','2014-03-21','11:15:00',3.51),('12664','2014-03-21','11:20:00',3.5),('12664','2014-03-21','11:25:00',3.57),('12664','2014-03-21','11:30:00',3.58),('12664','2014-03-21','11:35:00',3.58),('12664','2014-03-21','11:40:00',3.57),('12664','2014-03-21','11:45:00',3.66),('12664','2014-03-21','11:50:00',3.62),('12664','2014-03-21','11:55:00',3.66),('12664','2014-03-21','12:00:00',3.7),('12664','2014-03-21','12:05:00',3.74),('12664','2014-03-21','12:10:00',3.72),('12664','2014-03-21','12:15:00',3.72),('12664','2014-03-21','12:20:00',3.72),('12664','2014-03-21','12:25:00',3.77),('12664','2014-03-21','12:30:00',3.74),('12664','2014-03-21','12:35:00',3.72),('12664','2014-03-21','12:40:00',3.73),('12664','2014-03-21','12:45:00',3.75),('12664','2014-03-21','12:50:00',3.75),('12664','2014-03-21','12:55:00',3.7),('12664','2014-03-21','13:00:00',3.65),('12664','2014-03-21','13:05:00',3.69),('12664','2014-03-21','13:10:00',3.67),('12664','2014-03-21','13:15:00',3.68),('12664','2014-03-21','13:20:00',3.67),('12664','2014-03-21','13:25:00',3.63),('12664','2014-03-21','13:30:00',3.6),('12664','2014-03-21','13:35:00',3.57),('12664','2014-03-21','13:40:00',3.52),('12664','2014-03-21','13:45:00',3.49),('12664','2014-03-21','13:50:00',3.48),('12664','2014-03-21','13:55:00',3.47),('12664','2014-03-21','14:00:00',3.45),('12664','2014-03-21','14:05:00',3.4),('12664','2014-03-21','14:10:00',3.34),('12664','2014-03-21','14:15:00',3.31),('12664','2014-03-21','14:20:00',3.25),('12664','2014-03-21','14:25:00',3.19),('12664','2014-03-21','14:30:00',3.12),('12664','2014-03-21','14:35:00',2.97),('12664','2014-03-21','14:40:00',2.13),('12664','2014-03-21','14:45:00',2.14),('12664','2014-03-21','14:55:00',1.62),('12664','2014-03-21','15:00:00',2.62),('12664','2014-03-21','15:05:00',2.87),('12664','2014-03-21','15:10:00',3.04),('12664','2014-03-21','15:15:00',2.85),('12664','2014-03-21','15:20:00',1.97),('12664','2014-03-21','15:25:00',1.82),('12664','2014-03-21','15:30:00',2.62),('12664','2014-03-21','15:35:00',2.55),('12664','2014-03-21','15:40:00',2.48),('12664','2014-03-21','15:45:00',2.14),('12664','2014-03-21','15:50:00',2.33),('12664','2014-03-21','15:55:00',2.28),('12664','2014-03-21','16:00:00',2.13),('12664','2014-03-21','16:05:00',1.97),('12664','2014-03-21','16:10:00',1.79),('12664','2014-03-21','16:15:00',1.67),('12664','2014-03-21','16:20:00',1.5),('12664','2014-03-21','16:25:00',1.42),('12664','2014-03-21','16:30:00',1.3),('12664','2014-03-21','16:35:00',1.2),('12664','2014-03-21','16:40:00',1.11),('12664','2013-02-09','10:50:00',1.14),('12664','2013-02-09','10:55:00',1.21),('12664','2013-02-09','11:00:00',1.25),('12664','2013-02-09','11:05:00',1.33),('12664','2013-02-09','11:10:00',1.38),('12664','2013-02-09','11:15:00',1.43),('12664','2013-02-09','11:20:00',1.4),('12664','2013-02-09','11:25:00',1.32),('12664','2013-02-09','11:30:00',1.34),('12664','2013-02-09','11:35:00',1.36),('12664','2013-02-09','11:40:00',1.35),('12664','2013-02-09','11:45:00',1.33),('12664','2013-02-09','11:50:00',1.31),('12664','2013-02-09','11:55:00',1.32),('12664','2013-02-09','12:00:00',1.41),('12664','2013-02-09','12:05:00',1.43),('12664','2013-02-09','12:10:00',1.31),('12664','2013-02-09','12:15:00',1.26),('12664','2013-02-09','12:20:00',1.26),('12664','2013-02-09','12:25:00',1.27),('12664','2013-02-09','12:30:00',1.3),('12664','2013-02-09','12:35:00',1.3),('12664','2013-02-09','12:40:00',1.3),('12664','2013-02-09','12:45:00',1.43),('12664','2013-02-09','12:50:00',1.64),('12664','2013-02-09','12:55:00',1.81),('12664','2013-02-09','13:00:00',2.12),('12664','2013-02-09','13:05:00',2.45),('12664','2013-02-09','13:10:00',2.46),('12664','2013-02-09','13:15:00',2.62),('12664','2013-02-09','13:20:00',2.97),('12664','2013-02-09','13:25:00',3.21),('12664','2013-02-09','13:30:00',3.79),('12664','2013-02-09','13:35:00',3.9),('12664','2013-02-09','13:40:00',3.91),('12664','2013-02-09','13:45:00',3.75),('12664','2013-02-09','13:50:00',3.78),('12664','2013-02-09','13:55:00',3.58),('12664','2013-02-09','14:00:00',3.3),('12664','2013-02-09','14:05:00',1.19),('12664','2013-02-09','14:10:00',2.97),('12664','2013-02-09','14:15:00',3.94),('12664','2013-02-09','14:20:00',3.62),('12664','2013-02-09','14:25:00',3.3),('12664','2013-02-09','14:30:00',2.82),('12664','2013-02-09','14:35:00',2.2),('12664','2013-02-09','14:40:00',2.82),('12664','2013-02-09','14:45:00',2.97),('12664','2013-02-09','14:50:00',2.82),('12664','2013-02-09','14:55:00',2.71),('12664','2013-02-09','15:00:00',2.54),('12664','2013-02-09','15:05:00',2.16),('12664','2013-02-09','15:10:00',2.51),('12664','2013-02-09','15:15:00',2.33),('12664','2013-02-09','15:20:00',1.97),('12664','2013-02-09','15:25:00',1),('12664','2013-02-09','15:30:00',1.99),('12664','2013-02-09','15:35:00',2.15),('12664','2013-02-09','15:40:00',2.21),('12664','2013-02-09','15:45:00',1.28),('12664','2013-02-09','15:50:00',1.29),('12664','2013-02-09','15:55:00',1.58),('12664','2013-02-09','16:00:00',1.8),('12664','2013-02-09','16:05:00',1.75),('12664','2013-02-09','16:10:00',1.37),('12664','2013-02-09','16:15:00',1.53),('12664','2013-02-09','16:20:00',1.55),('12664','2013-02-09','16:25:00',1.38),('12664','2013-02-09','16:30:00',1.25),('12664','2013-02-09','16:40:00',1.13),('12664','2013-02-08','09:25:00',1.01),('12664','2013-02-08','09:55:00',1.71),('12664','2013-02-08','10:00:00',3.52),('12664','2013-02-08','10:05:00',3.43),('12664','2013-02-08','10:10:00',3.23),('12664','2013-02-08','10:15:00',3.52),('12664','2013-02-08','10:20:00',3.53),('12664','2013-02-08','10:25:00',3.58),('12664','2013-02-08','10:30:00',3.69),('12664','2013-02-08','10:35:00',3.92),('12664','2013-02-08','10:40:00',3.84),('12664','2013-02-08','10:45:00',2.54),('12664','2013-02-08','10:50:00',2.07),('12664','2013-02-08','10:55:00',1.76),('12664','2013-02-08','11:00:00',2.94),('12664','2013-02-08','11:05:00',2.32),('12664','2013-02-08','11:10:00',3.62),('12664','2013-02-08','11:15:00',3.85),('12664','2013-02-08','11:20:00',3.84),('12664','2013-02-08','11:25:00',3.86),('12664','2013-02-08','11:30:00',3.83),('12664','2013-02-08','11:35:00',3.84),('12664','2013-02-08','11:40:00',3.89),('12664','2013-02-08','11:45:00',3.91),('12664','2013-02-08','11:50:00',3.89),('12664','2013-02-08','11:55:00',3.91),('12664','2013-02-08','12:00:00',3.95),('12664','2013-02-08','12:05:00',3.95),('12664','2013-02-08','12:10:00',3.95),('12664','2013-02-08','12:15:00',4.14),('12664','2013-02-08','12:20:00',4.41),('12664','2013-02-08','12:25:00',3.7),('12664','2013-02-08','12:30:00',3.31),('12664','2013-02-08','12:35:00',3.39),('12664','2013-02-08','12:40:00',2.44),('12664','2013-02-08','12:45:00',2.51),('12664','2013-02-08','12:50:00',2.84),('12664','2013-02-08','12:55:00',2.82),('12664','2013-02-08','13:00:00',1.79),('12664','2013-02-08','13:05:00',1.7),('12664','2013-02-08','13:10:00',1.74),('12664','2013-02-08','13:15:00',1.94),('12664','2013-02-08','13:20:00',1.72),('12664','2013-02-08','13:25:00',1.6),('12664','2013-02-08','13:30:00',1.39),('12664','2013-02-08','13:35:00',1.42),('12664','2013-02-08','13:40:00',1.39),('12664','2013-02-08','13:45:00',1.49),('12664','2013-02-08','13:50:00',1.54),('12664','2013-02-08','13:55:00',1.7),('12664','2013-02-08','14:00:00',1.99),('12664','2013-02-08','14:05:00',2.4),('12664','2013-02-08','14:10:00',1.82),('12664','2013-02-08','14:15:00',1.76),('12664','2013-02-08','14:20:00',2.34),('12664','2013-02-08','14:25:00',3.25),('12664','2013-02-08','14:30:00',2.08),('12664','2013-02-08','14:35:00',2.13),('12664','2013-02-08','14:40:00',2.95),('12664','2013-02-08','14:45:00',3.02),('12664','2013-02-08','14:50:00',3.36),('12664','2013-02-08','14:55:00',3.38),('12664','2013-02-08','15:00:00',3.01),('12664','2013-02-08','15:05:00',2.97),('12664','2013-02-08','15:10:00',2.69),('12664','2013-02-08','15:15:00',2.6),('12664','2013-02-08','15:20:00',2.57),('12664','2013-02-08','15:25:00',2.46),('12664','2013-02-08','15:30:00',2.44),('12664','2013-02-08','15:35:00',2.38),('12664','2013-02-08','15:40:00',2.13),('12664','2013-02-08','15:45:00',2.11),('12664','2013-02-08','15:50:00',1.95),('12664','2013-02-08','16:00:00',1.74),('12664','2013-02-07','09:15:00',1.11),('12664','2013-02-07','10:15:00',1.32),('12664','2013-02-07','10:20:00',1.38),('12664','2013-02-07','10:25:00',2.02),('12664','2013-02-07','10:30:00',1.88),('12664','2013-02-07','10:35:00',2.39),('12664','2013-02-07','10:40:00',2.74),('12664','2013-02-07','10:45:00',2.41),('12664','2013-02-07','10:50:00',2.41),('12664','2013-02-07','10:55:00',3.08),('12664','2013-02-07','11:00:00',3.14),('12664','2013-02-07','11:05:00',1.88),('12664','2013-02-07','11:10:00',4.28),('12664','2013-02-07','11:15:00',1.2),('12664','2013-02-07','12:15:00',1.06),('12664','2013-02-07','12:20:00',2.71),('12664','2013-02-07','12:25:00',2.1),('12664','2013-02-07','12:30:00',2.18),('12664','2013-02-07','12:35:00',1.33),('12664','2013-02-07','12:40:00',1.09),('12664','2013-02-07','12:45:00',1.03),('12664','2013-02-07','13:05:00',1.19),('12664','2013-02-07','13:10:00',3.92),('12664','2013-02-07','13:15:00',4.69),('12664','2013-02-07','13:20:00',3.87),('12664','2013-02-07','13:25:00',1.75),('12664','2013-02-07','13:30:00',1.09),('12664','2013-02-07','13:45:00',1.02),('12664','2013-02-07','13:50:00',1.03),('12664','2013-02-07','13:55:00',1.74),('12664','2013-02-07','14:00:00',1.94),('12664','2013-02-07','14:05:00',3.35),('12664','2013-02-07','14:10:00',2.57),('12664','2013-02-07','14:15:00',2.78),('12664','2013-02-07','14:20:00',1.95),('12664','2013-02-07','14:25:00',1.43),('12664','2013-02-07','14:30:00',1.46),('12664','2013-02-07','14:40:00',1.62),('12664','2013-02-07','14:45:00',2.12),('12664','2013-02-07','14:50:00',1.42),('12664','2013-02-07','14:55:00',2.16),('12664','2013-02-07','15:00:00',2.35),('12664','2013-02-07','15:05:00',3.16),('12664','2013-02-07','15:10:00',2.72),('12664','2013-02-07','15:15:00',2.51),('12664','2013-02-07','15:20:00',1.16),('12664','2013-02-07','15:25:00',1.44),('12664','2013-02-07','15:30:00',2.45),('12664','2013-02-07','15:35:00',1.79),('12664','2013-02-06','08:45:00',1.05),('12664','2013-02-06','08:50:00',1.04),('12664','2013-02-06','08:55:00',1.08),('12664','2013-02-06','09:00:00',1.25),('12664','2013-02-06','09:05:00',1.23),('12664','2013-02-06','09:10:00',1.06),('12664','2013-02-06','09:15:00',1.04),('12664','2013-02-06','09:20:00',1.11),('12664','2013-02-06','09:25:00',1.27),('12664','2013-02-06','09:30:00',1.38),('12664','2013-02-06','09:35:00',1.24),('12664','2013-02-06','09:40:00',1.25),('12664','2013-02-06','09:45:00',1.51),('12664','2013-02-06','09:50:00',1.87),('12664','2013-02-06','09:55:00',1.54),('12664','2013-02-06','10:00:00',1.31),('12664','2013-02-06','10:05:00',1.49),('12664','2013-02-06','10:10:00',1.43),('12664','2013-02-06','10:15:00',1.84),('12664','2013-02-06','10:20:00',3.63),('12664','2013-02-06','10:25:00',2.28),('12664','2013-02-06','10:30:00',1.35),('12664','2013-02-06','10:35:00',1.29),('12664','2013-02-06','10:40:00',1.07),('12664','2013-02-06','10:45:00',1.19),('12664','2013-02-06','10:50:00',1.66),('12664','2013-02-06','10:55:00',1.63),('12664','2013-02-06','11:00:00',1.5),('12664','2013-02-06','11:05:00',1.85),('12664','2013-02-06','11:10:00',1.54),('12664','2013-02-06','11:15:00',2.4),('12664','2013-02-06','11:20:00',2.15),('12664','2013-02-06','11:25:00',1.49),('12664','2013-02-06','11:30:00',1.69),('12664','2013-02-06','11:35:00',1.63),('12664','2013-02-06','11:40:00',1.5),('12664','2013-02-06','11:45:00',1.54),('12664','2013-02-06','11:50:00',1.44),('12664','2013-02-06','11:55:00',1.04),('12664','2013-02-06','12:05:00',1.37),('12664','2013-02-06','12:10:00',1.38),('12664','2013-02-06','12:15:00',1.18),('12664','2013-02-06','12:20:00',1.03),('12664','2013-02-06','13:10:00',1.07),('12664','2013-02-06','13:15:00',1.31),('12664','2013-02-06','13:20:00',1.91),('12664','2013-02-06','13:25:00',2.25),('12664','2013-02-06','13:30:00',2.27),('12664','2013-02-06','13:35:00',1.65),('12664','2013-02-06','13:40:00',1.54),('12664','2013-02-06','13:45:00',2.28),('12664','2013-02-06','13:50:00',2.65),('12664','2013-02-06','13:55:00',1.52),('12664','2013-02-06','14:00:00',1.08),('12664','2013-02-06','14:05:00',1.01),('12664','2013-02-06','14:25:00',1.13),('12664','2013-02-06','14:30:00',2.15),('12664','2013-02-06','15:15:00',1.71),('12664','2013-02-06','15:20:00',2.19),('12664','2013-02-05','08:15:00',1),('12664','2013-02-05','08:20:00',1.11),('12664','2013-02-05','08:25:00',1.22),('12664','2013-02-05','08:30:00',1.33),('12664','2013-02-05','08:35:00',1.44),('12664','2013-02-05','08:40:00',1.55),('12664','2013-02-05','08:45:00',1.66),('12664','2013-02-05','08:50:00',1.78),('12664','2013-02-05','08:55:00',1.88),('12664','2013-02-05','09:00:00',1.98),('12664','2013-02-05','09:05:00',2.08),('12664','2013-02-05','09:10:00',2.18),('12664','2013-02-05','09:15:00',2.26),('12664','2013-02-05','09:20:00',2.34),('12664','2013-02-05','09:25:00',2.43),('12664','2013-02-05','09:30:00',2.5),('12664','2013-02-05','09:35:00',2.59),('12664','2013-02-05','09:40:00',2.65),('12664','2013-02-05','09:45:00',2.73),('12664','2013-02-05','09:50:00',2.78),('12664','2013-02-05','09:55:00',2.84),('12664','2013-02-05','10:00:00',2.87),('12664','2013-02-05','10:05:00',2.77),('12664','2013-02-05','10:10:00',2.93),('12664','2013-02-05','10:15:00',3.1),('12664','2013-02-05','10:20:00',3.15),('12664','2013-02-05','10:25:00',3.19),('12664','2013-02-05','10:30:00',3.23),('12664','2013-02-05','10:35:00',3.26),('12664','2013-02-05','10:40:00',3.31),('12664','2013-02-05','10:45:00',3.35),('12664','2013-02-05','10:50:00',3.41),('12664','2013-02-05','10:55:00',3.47),('12664','2013-02-05','11:00:00',3.41),('12664','2013-02-05','11:05:00',3.46),('12664','2013-02-05','11:10:00',3.49),('12664','2013-02-05','11:15:00',3.6),('12664','2013-02-05','11:20:00',3.62),('12664','2013-02-05','11:25:00',2.53),('12664','2013-02-05','11:30:00',3.68),('12664','2013-02-05','11:35:00',2.41),('12664','2013-02-05','11:40:00',3.02),('12664','2013-02-05','11:45:00',3.5),('12664','2013-02-05','11:50:00',3.97),('12664','2013-02-05','11:55:00',3.67),('12664','2013-02-05','12:00:00',3.85),('12664','2013-02-05','12:05:00',4.15),('12664','2013-02-05','12:10:00',1.92),('12664','2013-02-05','12:15:00',2.06),('12664','2013-02-05','12:20:00',2.96),('12664','2013-02-05','12:25:00',3.28),('12664','2013-02-05','12:30:00',3.63),('12664','2013-02-05','12:35:00',2.74),('12664','2013-02-05','12:40:00',1.87),('12664','2013-02-05','12:45:00',2.16),('12664','2013-02-05','12:50:00',1.41),('12664','2013-02-05','13:00:00',1.61),('12664','2013-02-05','13:05:00',2.28),('12664','2013-02-05','13:10:00',2.38),('12664','2013-02-05','13:15:00',1.77),('12664','2013-02-05','13:20:00',1.54),('12664','2013-02-05','13:25:00',1.2),('12664','2013-02-05','13:30:00',1.41),('12664','2013-02-05','13:35:00',1.33),('12664','2013-02-05','13:40:00',1.61),('12664','2013-02-05','13:45:00',1.57),('12664','2013-02-05','13:50:00',1.48),('12664','2013-02-05','13:55:00',1.59),('12664','2013-02-05','14:00:00',1.3),('12664','2013-02-05','14:05:00',1.09),('12664','2013-02-05','14:10:00',1.47),('12664','2013-02-05','14:15:00',1.62),('12664','2013-02-05','14:20:00',1.82),('12664','2013-02-05','14:25:00',1.67),('12664','2013-02-05','14:30:00',1.51),('12664','2013-02-05','14:35:00',1.8),('12664','2013-02-05','14:40:00',1.86),('12664','2013-02-05','14:45:00',1.57),('12664','2013-02-05','14:50:00',1.2),('12664','2013-02-04','08:15:00',1.09),('12664','2013-02-04','08:20:00',1.2),('12664','2013-02-04','08:25:00',1.32),('12664','2013-02-04','08:30:00',1.44),('12664','2013-02-04','08:35:00',1.57),('12664','2013-02-04','08:40:00',1.69),('12664','2013-02-04','08:45:00',1.79),('12664','2013-02-04','08:50:00',1.9),('12664','2013-02-04','08:55:00',2.02),('12664','2013-02-04','09:00:00',2.14),('12664','2013-02-04','09:05:00',2.29),('12664','2013-02-04','09:10:00',2.29),('12664','2013-02-04','09:15:00',1.85),('12664','2013-02-04','09:20:00',2.12),('12664','2013-02-04','09:25:00',2.52),('12664','2013-02-04','09:30:00',2.47),('12664','2013-02-04','09:35:00',2.91),('12664','2013-02-04','09:40:00',2.91),('12664','2013-02-04','09:45:00',3),('12664','2013-02-04','09:50:00',3.11),('12664','2013-02-04','09:55:00',3.22),('12664','2013-02-04','10:00:00',3.31),('12664','2013-02-04','10:05:00',3.36),('12664','2013-02-04','10:10:00',3.28),('12664','2013-02-04','10:15:00',2.86),('12664','2013-02-04','10:20:00',3.12),('12664','2013-02-04','10:25:00',3.37),('12664','2013-02-04','10:30:00',3.25),('12664','2013-02-04','10:35:00',3.52),('12664','2013-02-04','10:40:00',3.57),('12664','2013-02-04','10:45:00',3.61),('12664','2013-02-04','10:50:00',3.62),('12664','2013-02-04','10:55:00',3.62),('12664','2013-02-04','11:00:00',3.71),('12664','2013-02-04','11:05:00',3.72),('12664','2013-02-04','11:10:00',3.74),('12664','2013-02-04','11:15:00',3.77),('12664','2013-02-04','11:20:00',3.78),('12664','2013-02-04','11:25:00',3.81),('12664','2013-02-04','11:30:00',3.84),('12664','2013-02-04','11:35:00',3.85),('12664','2013-02-04','11:40:00',3.86),('12664','2013-02-04','11:45:00',3.85),('12664','2013-02-04','11:50:00',3.86),('12664','2013-02-04','11:55:00',3.88),('12664','2013-02-04','12:00:00',3.91),('12664','2013-02-04','12:05:00',3.9),('12664','2013-02-04','12:10:00',3.9),('12664','2013-02-04','12:15:00',3.9),('12664','2013-02-04','12:20:00',3.9),('12664','2013-02-04','12:25:00',3.9),('12664','2013-02-04','12:30:00',3.89),('12664','2013-02-04','12:35:00',3.88),('12664','2013-02-04','12:40:00',3.87),('12664','2013-02-04','12:45:00',3.85),('12664','2013-02-04','12:50:00',3.84),('12664','2013-02-04','12:55:00',3.83),('12664','2013-02-04','13:00:00',3.82),('12664','2013-02-04','13:05:00',3.78),('12664','2013-02-04','13:10:00',3.76),('12664','2013-02-04','13:15:00',3.76),('12664','2013-02-04','13:20:00',3.71),('12664','2013-02-04','13:25:00',3.7),('12664','2013-02-04','13:30:00',3.65),('12664','2013-02-04','13:35:00',3.61),('12664','2013-02-04','13:40:00',3.56),('12664','2013-02-04','13:45:00',3.54),('12664','2013-02-04','13:50:00',3.49),('12664','2013-02-04','13:55:00',3.43),('12664','2013-02-04','14:00:00',3.38),('12664','2013-02-04','14:05:00',3.35),('12664','2013-02-04','14:10:00',3.3),('12664','2013-02-04','14:15:00',3.25),('12664','2013-02-04','14:20:00',3.19),('12664','2013-02-04','14:25:00',3.14),('12664','2013-02-04','14:30:00',3.1),('12664','2013-02-04','14:35:00',3.03),('12664','2013-02-04','14:40:00',2.96),('12664','2013-02-04','14:45:00',2.89),('12664','2013-02-04','14:50:00',2.82),('12664','2013-02-04','14:55:00',2.75),('12664','2013-02-04','15:00:00',2.67),('12664','2013-02-04','15:05:00',2.57),('12664','2013-02-04','15:10:00',2.5),('12664','2013-02-04','15:15:00',2.41),('12664','2013-02-04','15:20:00',2.3),('12664','2013-02-04','15:25:00',2.21),('12664','2013-02-04','15:30:00',2.14),('12664','2013-02-04','15:35:00',2.02),('12664','2013-02-04','15:40:00',1.92),('12664','2013-02-04','15:45:00',1.83),('12664','2013-02-04','15:50:00',1.73),('12664','2013-02-04','15:55:00',1.63),('12664','2013-02-04','16:00:00',1.53),('12664','2013-02-04','16:05:00',1.42),('12664','2013-02-04','16:10:00',1.31),('12664','2013-02-04','16:15:00',1.19),('12664','2013-02-04','16:20:00',1.09),('12664','2013-02-03','09:10:00',1.6),('12664','2013-02-03','09:15:00',1.15),('12664','2013-02-03','09:20:00',1.03),('12664','2013-02-03','09:25:00',1.13),('12664','2013-02-03','09:30:00',1.46),('12664','2013-02-03','09:35:00',1.68),('12664','2013-02-03','09:40:00',2.28),('12664','2013-02-03','09:45:00',3.2),('12664','2013-02-03','09:50:00',1.15),('12664','2013-02-03','10:55:00',1.14),('12664','2013-02-03','11:00:00',1.14),('12664','2013-02-03','11:20:00',1.53),('12664','2013-02-03','11:25:00',3.55),('12664','2013-02-03','11:30:00',1.61),('12664','2013-02-03','11:50:00',1.12),('12664','2013-02-03','12:15:00',1.99),('12664','2013-02-03','12:20:00',1.08),('12664','2013-02-02','10:10:00',1.19),('12664','2013-02-02','10:15:00',2.02),('12664','2013-02-02','10:20:00',1.66),('12664','2013-02-02','10:25:00',1.28),('12664','2013-02-02','10:30:00',1.35),('12664','2013-02-02','10:35:00',1.69),('12664','2013-02-02','10:40:00',2.22),('12664','2013-02-02','10:45:00',2.44),('12664','2013-02-02','10:50:00',2.46),('12664','2013-02-02','10:55:00',2.21),('12664','2013-02-02','11:00:00',2.33),('12664','2013-02-02','11:05:00',2.36),('12664','2013-02-02','11:10:00',2.38),('12664','2013-02-02','11:15:00',2.09),('12664','2013-02-02','11:20:00',2.46),('12664','2013-02-02','11:25:00',2.44),('12664','2013-02-02','11:30:00',2.07),('12664','2013-02-02','11:35:00',1.93),('12664','2013-02-02','11:40:00',1.7),('12664','2013-02-02','11:45:00',1.05),('12664','2013-02-02','11:50:00',1.15),('12664','2013-02-02','12:35:00',1.02),('12664','2013-02-02','12:40:00',2.39),('12664','2013-02-02','12:45:00',2.52),('12664','2013-02-02','12:50:00',2.86),('12664','2013-02-02','12:55:00',2.32),('12664','2013-02-02','13:00:00',1.95),('12664','2013-02-02','13:05:00',1.96),('12664','2013-02-02','13:10:00',2.33),('12664','2013-02-02','13:15:00',2.93),('12664','2013-02-02','13:20:00',1.63),('12664','2013-02-02','13:25:00',1.3),('12664','2013-02-02','13:30:00',1.35),('12664','2013-02-02','13:35:00',1.34),('12664','2013-02-02','13:40:00',1.6),('12664','2013-02-02','13:45:00',1.27),('12664','2013-02-02','13:50:00',1.11),('12664','2013-02-01','08:35:00',1.24),('12664','2013-02-01','08:40:00',1.42),('12664','2013-02-01','08:45:00',1.4),('12664','2013-02-01','08:50:00',1.46),('12664','2013-02-01','08:55:00',1.35),('12664','2013-02-01','09:00:00',1.36),('12664','2013-02-01','09:05:00',1.91),('12664','2013-02-01','09:10:00',2.07),('12664','2013-02-01','09:15:00',2.16),('12664','2013-02-01','09:20:00',1.85),('12664','2013-02-01','09:25:00',2.09),('12664','2013-02-01','09:30:00',1.36),('12664','2013-02-01','09:40:00',1.3),('12664','2013-02-01','09:45:00',1.62),('12664','2013-02-01','09:50:00',1.95),('12664','2013-02-01','09:55:00',1.94),('12664','2013-02-01','10:00:00',2.56),('12664','2013-02-01','10:05:00',2.41),('12664','2013-02-01','10:10:00',2.07),('12664','2013-02-01','10:15:00',1.1),('12664','2013-02-01','10:20:00',2.3),('12664','2013-02-01','10:25:00',2.97),('12664','2013-02-01','10:30:00',2.15),('12664','2013-02-01','10:40:00',1.39),('12664','2013-02-01','10:45:00',1.68),('12664','2013-02-01','10:50:00',1.03),('12664','2013-02-01','11:20:00',2.86),('12664','2013-02-01','11:25:00',2.23),('12664','2013-02-01','11:30:00',2.9),('12664','2013-02-01','11:35:00',1.72),('12664','2013-02-01','11:40:00',1.6),('12664','2013-02-01','11:45:00',1.81),('12664','2013-02-01','11:50:00',1.52),('12664','2013-02-01','11:55:00',1.42),('12664','2013-02-01','12:00:00',1.24),('12664','2013-02-01','12:05:00',1.35),('12664','2013-02-01','12:10:00',2.11),('12664','2013-02-01','12:15:00',1.99),('12664','2013-02-01','12:20:00',4.09),('12664','2013-02-01','12:25:00',2.84),('12664','2013-02-01','12:30:00',4.49),('12664','2013-02-01','12:35:00',3.77),('12664','2013-02-01','12:40:00',3.83),('12664','2013-02-01','12:45:00',2.57),('12664','2013-02-01','12:50:00',2.61),('12664','2013-02-01','12:55:00',3.28),('12664','2013-02-01','13:00:00',2.55),('12664','2013-02-01','13:05:00',3.68),('12664','2013-02-01','13:10:00',3.57),('12664','2013-02-01','13:15:00',3.59),('12664','2013-02-01','13:20:00',3.02),('12664','2013-02-01','13:25:00',3.19),('12664','2013-02-01','13:30:00',1.95),('12664','2013-02-01','13:35:00',2.63),('12664','2013-02-01','13:40:00',2.58),('12664','2013-02-01','13:45:00',2.63),('12664','2013-02-01','13:50:00',3.02),('12664','2013-02-01','13:55:00',2.94),('12664','2013-02-01','14:00:00',2.74),('12664','2013-02-01','14:05:00',2.69),('12664','2013-02-01','14:10:00',3.16),('12664','2013-02-01','14:15:00',2.99),('12664','2013-02-01','14:20:00',2.53),('12664','2013-02-01','14:25:00',1.83),('12664','2013-02-01','14:30:00',1.07),('12664','2013-02-01','14:35:00',1.25),('12664','2013-02-01','14:40:00',1.08),('12664','2013-02-01','14:55:00',1.12),('12664','2013-02-01','15:15:00',1.63),('12664','2013-02-01','15:20:00',2.36),('12664','2013-02-01','15:25:00',2.03),('12664','2013-02-01','15:30:00',1.66),('12664','2013-01-31','09:25:00',1.09),('12664','2013-01-31','09:30:00',2.05),('12664','2013-01-31','09:35:00',2.37),('12664','2013-01-31','09:40:00',2.4),('12664','2013-01-31','09:45:00',2.48),('12664','2013-01-31','09:50:00',2.58),('12664','2013-01-31','09:55:00',2.63),('12664','2013-01-31','10:00:00',2.68),('12664','2013-01-31','10:05:00',2.74),('12664','2013-01-31','10:10:00',2.79),('12664','2013-01-31','10:15:00',2.9),('12664','2013-01-31','10:20:00',2.95),('12664','2013-01-31','10:25:00',3.01),('12664','2013-01-31','10:30:00',3.01),('12664','2013-01-31','10:35:00',3.16),('12664','2013-01-31','10:40:00',3.3),('12664','2013-01-31','10:45:00',3.07),('12664','2013-01-31','10:50:00',3.33),('12664','2013-01-31','10:55:00',1.25),('12664','2013-01-31','11:00:00',1.31),('12664','2013-01-31','11:10:00',1.35),('12664','2013-01-31','11:15:00',3.69),('12664','2013-01-31','11:20:00',3.57),('12664','2013-01-31','11:25:00',3.54),('12664','2013-01-31','11:30:00',3.6),('12664','2013-01-31','11:35:00',3.54),('12664','2013-01-31','11:40:00',2.95),('12664','2013-01-31','11:45:00',2.42),('12664','2013-01-31','11:50:00',3.59),('12664','2013-01-31','11:55:00',3.66),('12664','2013-01-31','12:00:00',3.6),('12664','2013-01-31','12:05:00',3.57),('12664','2013-01-31','12:10:00',3.54),('12664','2013-01-31','12:15:00',3.52),('12664','2013-01-31','12:20:00',3.47),('12664','2013-01-31','12:25:00',3.52),('12664','2013-01-31','12:30:00',3.5),('12664','2013-01-31','12:35:00',3.37),('12664','2013-01-31','12:40:00',3.43),('12664','2013-01-31','12:45:00',3.51),('12664','2013-01-31','12:50:00',3.5),('12664','2013-01-31','12:55:00',3.5),('12664','2013-01-31','13:00:00',3.47),('12664','2013-01-31','13:05:00',3.46),('12664','2013-01-31','13:10:00',3.42),('12664','2013-01-31','13:15:00',3.38),('12664','2013-01-31','13:20:00',3.34),('12664','2013-01-31','13:25:00',3.31),('12664','2013-01-31','13:30:00',3.22),('12664','2013-01-31','13:35:00',3.19),('12664','2013-01-31','13:40:00',3.16),('12664','2013-01-31','13:45:00',3.17),('12664','2013-01-31','13:50:00',3.05),('12664','2013-01-31','13:55:00',3.09),('12664','2013-01-31','14:00:00',3.03),('12664','2013-01-31','14:05:00',2.92),('12664','2013-01-31','14:10:00',2.93),('12664','2013-01-31','14:15:00',2.82),('12664','2013-01-31','14:20:00',2.75),('12664','2013-01-31','14:25:00',2.63),('12664','2013-01-31','14:30:00',2.53),('12664','2013-01-31','14:35:00',2.54),('12664','2013-01-31','14:40:00',2.55),('12664','2013-01-31','14:45:00',2.53),('12664','2013-01-31','14:50:00',2.43),('12664','2013-01-31','14:55:00',2.32),('12664','2013-01-31','15:00:00',2.25),('12664','2013-01-31','15:05:00',2.17),('12664','2013-01-31','15:10:00',2.14),('12664','2013-01-31','15:15:00',2.09),('12664','2013-01-31','15:20:00',1.97),('12664','2013-01-31','15:25:00',1.76),('12664','2013-01-31','15:30:00',1.86),('12664','2013-01-31','15:35:00',1.77),('12664','2013-01-31','15:40:00',1.66),('12664','2013-01-31','15:45:00',1.54),('12664','2013-01-31','15:50:00',1.47),('12664','2013-01-31','15:55:00',1.22),('12664','2013-01-31','16:00:00',1.01),('12664','2013-01-31','16:05:00',1.1),('12664','2013-01-31','16:10:00',1.09),('12664','2014-03-20','07:40:00',1.04),('12664','2014-03-20','07:45:00',1.16),('12664','2014-03-20','07:50:00',1.22),('12664','2014-03-20','07:55:00',1.21),('12664','2014-03-20','08:00:00',1.26),('12664','2014-03-20','08:05:00',1.25),('12664','2014-03-20','08:10:00',1.17),('12664','2014-03-20','08:15:00',1.33),('12664','2014-03-20','08:20:00',1.52),('12664','2014-03-20','08:25:00',1.66),('12664','2014-03-20','08:30:00',1.78),('12664','2014-03-20','08:35:00',1.88),('12664','2014-03-20','08:40:00',1.99),('12664','2014-03-20','08:45:00',2.08),('12664','2014-03-20','08:50:00',2.12),('12664','2014-03-20','08:55:00',2.2),('12664','2014-03-20','09:00:00',2.23),('12664','2014-03-20','09:05:00',2.32),('12664','2014-03-20','09:10:00',2.42),('12664','2014-03-20','09:15:00',2.47),('12664','2014-03-20','09:20:00',2.58),('12664','2014-03-20','09:25:00',2.72),('12664','2014-03-20','09:30:00',2.76),('12664','2014-03-20','09:35:00',2.77),('12664','2014-03-20','09:40:00',2.78),('12664','2014-03-20','09:45:00',2.9),('12664','2014-03-20','09:50:00',2.91),('12664','2014-03-20','09:55:00',3.01),('12664','2014-03-20','10:00:00',3.05),('12664','2014-03-20','10:05:00',3.1),('12664','2014-03-20','10:10:00',3.2),('12664','2014-03-20','10:15:00',3.25),('12664','2014-03-20','10:20:00',3.3),('12664','2014-03-20','10:25:00',3.3),('12664','2014-03-20','10:30:00',3.36),('12664','2014-03-20','10:35:00',3.33),('12664','2014-03-20','10:40:00',3.27),('12664','2014-03-20','10:45:00',3.39),('12664','2014-03-20','10:50:00',3.43),('12664','2014-03-20','10:55:00',3.47),('12664','2014-03-20','11:00:00',3.51),('12664','2014-03-20','11:05:00',3.46),('12664','2014-03-20','11:10:00',3.42),('12664','2014-03-20','11:15:00',3.34),('12664','2014-03-20','11:20:00',3.45),('12664','2014-03-20','11:25:00',3.32),('12664','2014-03-20','11:30:00',3.46),('12664','2014-03-20','11:35:00',3.59),('12664','2014-03-20','11:40:00',3.4),('12664','2014-03-20','11:45:00',3.41),('12664','2014-03-20','11:50:00',3.47),('12664','2014-03-20','11:55:00',3.49),('12664','2014-03-20','12:00:00',3.39),('12664','2014-03-20','12:05:00',3.15),('12664','2014-03-20','12:10:00',3.52),('12664','2014-03-20','12:15:00',3.72),('12664','2014-03-20','12:20:00',3.7),('12664','2014-03-20','12:25:00',3.52),('12664','2014-03-20','12:30:00',3.52),('12664','2014-03-20','12:35:00',3.71),('12664','2014-03-20','12:40:00',3.82),('12664','2014-03-20','12:45:00',3.82),('12664','2014-03-20','12:50:00',3.8),('12664','2014-03-20','12:55:00',3.81),('12664','2014-03-20','13:00:00',3.78),('12664','2014-03-20','13:05:00',3.65),('12664','2014-03-20','13:10:00',3.52),('12664','2014-03-20','13:15:00',3.5),('12664','2014-03-20','13:20:00',3.51),('12664','2014-03-20','13:25:00',3.5),('12664','2014-03-20','13:30:00',3.43),('12664','2014-03-20','13:35:00',3.33),('12664','2014-03-20','13:40:00',3.2),('12664','2014-03-20','13:45:00',3.15),('12664','2014-03-20','13:50:00',3.03),('12664','2014-03-20','13:55:00',2.96),('12664','2014-03-20','14:00:00',2.76),('12664','2014-03-20','14:05:00',2.83),('12664','2014-03-20','14:10:00',2.94),('12664','2014-03-20','14:15:00',2.51),('12664','2014-03-20','14:20:00',2.35),('12664','2014-03-20','14:25:00',2.2),('12664','2014-03-20','14:30:00',2.48),('12664','2014-03-20','14:35:00',2.51),('12664','2014-03-20','14:40:00',2.52),('12664','2014-03-20','14:45:00',2.54),('12664','2014-03-20','14:50:00',2.52),('12664','2014-03-20','14:55:00',2.49),('12664','2014-03-20','15:00:00',2.35),('12664','2014-03-20','15:05:00',2.19),('12664','2014-03-20','15:10:00',2.13),('12664','2014-03-20','15:15:00',2.1),('12664','2014-03-20','15:20:00',2.09),('12664','2014-03-20','15:25:00',2.04),('12664','2014-03-20','15:30:00',1.76),('12664','2014-03-20','15:35:00',1.56),('12664','2014-03-20','15:40:00',1.48),('12664','2014-03-20','15:45:00',1.31),('12664','2014-03-20','15:50:00',1.06),('12664','2014-03-20','15:55:00',1.05),('12664','2014-03-20','16:00:00',1.03),('12664','2014-03-20','16:05:00',1.05),('12664','2013-01-30','09:25:00',1.11),('12664','2013-01-30','09:30:00',1.52),('12664','2013-01-30','09:35:00',2.54),('12664','2013-01-30','09:40:00',2.55),('12664','2013-01-30','09:45:00',2.48),('12664','2013-01-30','09:50:00',1.38),('12664','2013-01-30','09:55:00',1.35),('12664','2013-01-30','10:00:00',1.44),('12664','2013-01-30','10:05:00',1.83),('12664','2013-01-30','10:10:00',1.45),('12664','2013-01-30','10:15:00',1.52),('12664','2013-01-30','10:20:00',1.49),('12664','2013-01-30','10:25:00',1.97),('12664','2013-01-30','10:30:00',2.02),('12664','2013-01-30','10:35:00',3.12),('12664','2013-01-30','10:40:00',2.17),('12664','2013-01-30','10:45:00',2.58),('12664','2013-01-30','10:50:00',3.02),('12664','2013-01-30','10:55:00',3.09),('12664','2013-01-30','11:00:00',3.08),('12664','2013-01-30','11:05:00',3.27),('12664','2013-01-30','11:10:00',3.29),('12664','2013-01-30','11:15:00',3.26),('12664','2013-01-30','11:20:00',3.31),('12664','2013-01-30','11:25:00',3.3),('12664','2013-01-30','11:30:00',2.95),('12664','2013-01-30','11:35:00',2.86),('12664','2013-01-30','11:40:00',3.11),('12664','2013-01-30','11:45:00',2.22),('12664','2013-01-30','11:50:00',1.57),('12664','2013-01-30','11:55:00',1.26),('12664','2013-01-30','12:00:00',1.94),('12664','2013-01-30','12:05:00',1.71),('12664','2013-01-30','12:10:00',3.09),('12664','2013-01-30','12:15:00',3.05),('12664','2013-01-30','12:20:00',4.19),('12664','2013-01-30','12:25:00',3.92),('12664','2013-01-30','12:30:00',3.12),('12664','2013-01-30','12:35:00',2.96),('12664','2013-01-30','12:40:00',1.93),('12664','2013-01-30','12:45:00',2.48),('12664','2013-01-30','12:50:00',2.55),('12664','2013-01-30','12:55:00',1.32),('12664','2013-01-30','13:00:00',2.65),('12664','2013-01-30','13:10:00',1.86),('12664','2013-01-30','13:15:00',3.63),('12664','2013-01-30','13:20:00',2.8),('12664','2013-01-30','13:25:00',2.01),('12664','2013-01-30','13:30:00',3.52),('12664','2013-01-30','13:45:00',1.3),('12664','2013-01-30','13:50:00',1.14),('12664','2013-01-30','13:55:00',1.13),('12664','2013-01-30','14:00:00',2.65),('12664','2013-01-30','14:05:00',3),('12664','2013-01-30','14:10:00',2.56),('12664','2013-01-30','14:15:00',2.25),('12664','2013-01-30','14:20:00',2.22),('12664','2013-01-30','14:25:00',2.49),('12664','2013-01-30','14:30:00',2.46),('12664','2013-01-30','14:35:00',2.59),('12664','2013-01-30','14:40:00',2.39),('12664','2013-01-30','14:45:00',2.09),('12664','2013-01-30','14:50:00',1.87),('12664','2013-01-30','14:55:00',2.08),('12664','2013-01-30','15:00:00',1.64),('12664','2013-01-30','15:05:00',1.35),('12664','2013-01-30','15:10:00',1.18),('12664','2013-01-30','15:15:00',1.04),('12664','2013-01-29','08:25:00',1.09),('12664','2013-01-29','08:30:00',1.19),('12664','2013-01-29','08:35:00',1.3),('12664','2013-01-29','08:40:00',1.41),('12664','2013-01-29','08:45:00',1.52),('12664','2013-01-29','08:50:00',1.62),('12664','2013-01-29','08:55:00',1.72),('12664','2013-01-29','09:00:00',1.82),('12664','2013-01-29','09:05:00',1.91),('12664','2013-01-29','09:10:00',2.01),('12664','2013-01-29','09:15:00',2.1),('12664','2013-01-29','09:20:00',2.18),('12664','2013-01-29','09:25:00',2.27),('12664','2013-01-29','09:30:00',2.35),('12664','2013-01-29','09:35:00',2.44),('12664','2013-01-29','09:40:00',2.53),('12664','2013-01-29','09:45:00',2.61),('12664','2013-01-29','09:50:00',2.66),('12664','2013-01-29','09:55:00',2.73),('12664','2013-01-29','10:00:00',2.78),('12664','2013-01-29','10:05:00',2.84),('12664','2013-01-29','10:10:00',2.9),('12664','2013-01-29','10:15:00',2.93),('12664','2013-01-29','10:20:00',3.02),('12664','2013-01-29','10:25:00',3.09),('12664','2013-01-29','10:30:00',3.14),('12664','2013-01-29','10:35:00',3.2),('12664','2013-01-29','10:40:00',3.23),('12664','2013-01-29','10:45:00',3.24),('12664','2013-01-29','10:50:00',3.26),('12664','2013-01-29','10:55:00',3.26),('12664','2013-01-29','11:00:00',3.31),('12664','2013-01-29','11:05:00',3.35),('12664','2013-01-29','11:10:00',3.35),('12664','2013-01-29','11:15:00',3.38),('12664','2013-01-29','11:20:00',3.46),('12664','2013-01-29','11:25:00',3.46),('12664','2013-01-29','11:30:00',3.42),('12664','2013-01-29','11:35:00',3.56),('12664','2013-01-29','11:40:00',3.56),('12664','2013-01-29','11:45:00',3.56),('12664','2013-01-29','11:50:00',3.6),('12664','2013-01-29','11:55:00',3.61),('12664','2013-01-29','12:00:00',3.65),('12664','2013-01-29','12:05:00',3.68),('12664','2013-01-29','12:10:00',3.68),('12664','2013-01-29','12:15:00',3.62),('12664','2013-01-29','12:20:00',3.67),('12664','2013-01-29','12:25:00',3.68),('12664','2013-01-29','12:30:00',3.68),('12664','2013-01-29','12:35:00',3.68),('12664','2013-01-29','12:40:00',3.59),('12664','2013-01-29','12:45:00',3.54),('12664','2013-01-29','12:50:00',3.62),('12664','2013-01-29','12:55:00',3.63),('12664','2013-01-29','13:00:00',3.59),('12664','2013-01-29','13:05:00',3.52),('12664','2013-01-29','13:10:00',3.55),('12664','2013-01-29','13:15:00',3.54),('12664','2013-01-29','13:20:00',3.49),('12664','2013-01-29','13:25:00',3.42),('12664','2013-01-29','13:30:00',3.39),('12664','2013-01-29','13:35:00',3.37),('12664','2013-01-29','13:40:00',3.27),('12664','2013-01-29','13:45:00',3.24),('12664','2013-01-29','13:50:00',3.22),('12664','2013-01-29','13:55:00',3.25),('12664','2013-01-29','14:00:00',3.23),('12664','2013-01-29','14:05:00',3.16),('12664','2013-01-29','14:10:00',3.07),('12664','2013-01-29','14:15:00',3),('12664','2013-01-29','14:20:00',2.94),('12664','2013-01-29','14:25:00',2.82),('12664','2013-01-29','14:30:00',2.81),('12664','2013-01-29','14:35:00',2.71),('12664','2013-01-29','14:40:00',2.63),('12664','2013-01-29','14:45:00',2.58),('12664','2013-01-29','14:50:00',2.48),('12664','2013-01-29','14:55:00',2.42),('12664','2013-01-29','15:00:00',2.34),('12664','2013-01-29','15:05:00',2.27),('12664','2013-01-29','15:10:00',2.18),('12664','2013-01-29','15:15:00',2.09),('12664','2013-01-29','15:20:00',2.06),('12664','2013-01-29','15:25:00',1.99),('12664','2013-01-29','15:30:00',1.95),('12664','2013-01-29','15:35:00',1.85),('12664','2013-01-29','15:40:00',1.75),('12664','2013-01-29','15:45:00',1.65),('12664','2013-01-29','15:50:00',1.52),('12664','2013-01-29','15:55:00',1.45),('12664','2013-01-29','16:00:00',1.35),('12664','2013-01-29','16:05:00',1.24),('12664','2013-01-29','16:10:00',1.14),('12664','2013-01-29','16:15:00',1.03),('12664','2013-01-28','12:35:00',1.06),('12664','2013-01-28','12:40:00',1.21),('12664','2013-01-28','12:45:00',1.3),('12664','2013-01-28','12:50:00',1.28),('12664','2013-01-28','12:55:00',1.22),('12664','2013-01-28','13:00:00',1.3),('12664','2013-01-28','13:05:00',1.27),('12664','2013-01-28','13:10:00',1.04),('12664','2013-01-27','08:25:00',1.1),('12664','2013-01-27','08:30:00',1.05),('12664','2013-01-27','08:45:00',1.7),('12664','2013-01-27','08:50:00',1.39),('12664','2013-01-27','08:55:00',1.3),('12664','2013-01-27','09:00:00',1.71),('12664','2013-01-27','09:05:00',1.9),('12664','2013-01-27','09:10:00',1.97),('12664','2013-01-27','09:15:00',2.07),('12664','2013-01-27','09:20:00',2.19),('12664','2013-01-27','09:25:00',2.27),('12664','2013-01-27','09:30:00',2.34),('12664','2013-01-27','09:35:00',2.39),('12664','2013-01-27','09:40:00',2.43),('12664','2013-01-27','09:45:00',2.52),('12664','2013-01-27','09:50:00',2.59),('12664','2013-01-27','09:55:00',2.66),('12664','2013-01-27','10:00:00',2.75),('12664','2013-01-27','10:05:00',2.83),('12664','2013-01-27','10:10:00',2.89),('12664','2013-01-27','10:15:00',2.94),('12664','2013-01-27','10:20:00',2.99),('12664','2013-01-27','10:25:00',3.05),('12664','2013-01-27','10:30:00',3.09),('12664','2013-01-27','10:35:00',3.14),('12664','2013-01-27','10:40:00',3.17),('12664','2013-01-27','10:45:00',3.22),('12664','2013-01-27','10:50:00',3.27),('12664','2013-01-27','10:55:00',3.32),('12664','2013-01-27','11:00:00',3.35),('12664','2013-01-27','11:05:00',3.38),('12664','2013-01-27','11:10:00',3.41),('12664','2013-01-27','11:15:00',3.43),('12664','2013-01-27','11:20:00',3.46),('12664','2013-01-27','11:25:00',3.5),('12664','2013-01-27','11:30:00',3.52),('12664','2013-01-27','11:35:00',3.54),('12664','2013-01-27','11:40:00',3.56),('12664','2013-01-27','11:45:00',3.54),('12664','2013-01-27','11:50:00',3.53),('12664','2013-01-27','11:55:00',3.55),('12664','2013-01-27','12:00:00',3.59),('12664','2013-01-27','12:05:00',3.58),('12664','2013-01-27','12:10:00',3.57),('12664','2013-01-27','12:15:00',3.6),('12664','2013-01-27','12:20:00',3.61),('12664','2013-01-27','12:25:00',3.6),('12664','2013-01-27','12:30:00',3.57),('12664','2013-01-27','12:35:00',3.56),('12664','2013-01-27','12:40:00',3.54),('12664','2013-01-27','12:45:00',3.52),('12664','2013-01-27','12:50:00',3.48),('12664','2013-01-27','12:55:00',3.47),('12664','2013-01-27','13:00:00',3.34),('12664','2013-01-27','13:05:00',3.35),('12664','2013-01-27','13:10:00',3.33),('12664','2013-01-27','13:15:00',3.34),('12664','2013-01-27','13:20:00',3.39),('12664','2013-01-27','13:25:00',3.38),('12664','2013-01-27','13:30:00',3.4),('12664','2013-01-27','13:35:00',3.35),('12664','2013-01-27','13:40:00',3.27),('12664','2013-01-27','13:45:00',3.18),('12664','2013-01-27','13:50:00',3.15),('12664','2013-01-27','13:55:00',3.05),('12664','2013-01-27','14:00:00',2.97),('12664','2013-01-27','14:05:00',2.95),('12664','2013-01-27','14:10:00',2.94),('12664','2013-01-27','14:15:00',2.88),('12664','2013-01-27','14:20:00',2.81),('12664','2013-01-27','14:25:00',2.77),('12664','2013-01-27','14:30:00',2.72),('12664','2013-01-27','14:35:00',2.64),('12664','2013-01-27','14:40:00',2.56),('12664','2013-01-27','14:45:00',2.48),('12664','2013-01-27','14:50:00',2.29),('12664','2013-01-27','14:55:00',2.28),('12664','2013-01-27','15:00:00',2.28),('12664','2013-01-27','15:05:00',2.09),('12664','2013-01-27','15:10:00',2.13),('12664','2013-01-27','15:15:00',2.06),('12664','2013-01-27','15:20:00',1.91),('12664','2013-01-27','15:25:00',1.83),('12664','2013-01-27','15:30:00',1.73),('12664','2013-01-27','15:35:00',1.62),('12664','2013-01-27','15:40:00',1.55),('12664','2013-01-27','15:45:00',1.23),('12664','2013-01-27','15:50:00',1.28),('12664','2013-01-27','15:55:00',1.27),('12664','2013-01-27','16:00:00',1.16),('12664','2013-01-27','16:05:00',1.04),('12664','2013-01-26','10:25:00',1.04),('12664','2013-01-26','10:30:00',1.22),('12664','2013-01-26','10:35:00',1.24),('12664','2013-01-26','10:45:00',1.01),('12664','2013-01-26','11:00:00',1.01),('12664','2013-01-26','11:05:00',1.1),('12664','2013-01-26','11:10:00',1.05),('12664','2013-01-26','11:15:00',1.01),('12664','2013-01-26','11:20:00',1.03),('12664','2013-01-26','11:30:00',1.02),('12664','2013-01-26','11:35:00',1.14),('12664','2013-01-26','11:40:00',1.11),('12664','2013-01-25','08:20:00',1.04),('12664','2013-01-25','08:25:00',1.2),('12664','2013-01-25','08:30:00',1.38),('12664','2013-01-25','08:35:00',1.5),('12664','2013-01-25','08:40:00',1.56),('12664','2013-01-25','08:45:00',1.58),('12664','2013-01-25','08:50:00',1.36),('12664','2013-01-25','08:55:00',1.33),('12664','2013-01-25','09:00:00',1.16),('12664','2013-01-25','09:05:00',1.23),('12664','2013-01-25','09:10:00',1.35),('12664','2013-01-25','09:15:00',1.4),('12664','2013-01-25','09:20:00',1.52),('12664','2013-01-25','09:25:00',1.49),('12664','2013-01-25','09:30:00',1.57),('12664','2013-01-25','09:35:00',1.83),('12664','2013-01-25','09:40:00',1.95),('12664','2013-01-25','09:45:00',1.85),('12664','2013-01-25','09:50:00',1.82),('12664','2013-01-25','09:55:00',2.16),('12664','2013-01-25','10:00:00',2.57),('12664','2013-01-25','10:05:00',3.09),('12664','2013-01-25','10:10:00',3.25),('12664','2013-01-25','10:15:00',3.29),('12664','2013-01-25','10:20:00',3.25),('12664','2013-01-25','10:25:00',3.27),('12664','2013-01-25','10:30:00',3.34),('12664','2013-01-25','10:35:00',3.43),('12664','2013-01-25','10:40:00',3.43),('12664','2013-01-25','10:45:00',3.52),('12664','2013-01-25','10:50:00',3.55),('12664','2013-01-25','10:55:00',3.58),('12664','2013-01-25','11:00:00',3.35),('12664','2013-01-25','11:05:00',3.38),('12664','2013-01-25','11:10:00',3.5),('12664','2013-01-25','11:15:00',3.52),('12664','2013-01-25','11:20:00',3.53),('12664','2013-01-25','11:25:00',3.38),('12664','2013-01-25','11:30:00',3.53),('12664','2013-01-25','11:35:00',3.67),('12664','2013-01-25','11:40:00',3.73),('12664','2013-01-25','11:45:00',3.76),('12664','2013-01-25','11:50:00',3.78),('12664','2013-01-25','11:55:00',3.79),('12664','2013-01-25','12:00:00',3.75),('12664','2013-01-25','12:05:00',3.72),('12664','2013-01-25','12:10:00',3.64),('12664','2013-01-25','12:15:00',3.68),('12664','2013-01-25','12:20:00',3.72),('12664','2013-01-25','12:25:00',3.77),('12664','2013-01-25','12:30:00',3.13),('12664','2013-01-25','12:35:00',3.35),('12664','2013-01-25','12:40:00',3.82),('12664','2013-01-25','12:45:00',3.78),('12664','2013-01-25','12:50:00',3.75),('12664','2013-01-25','12:55:00',3.69),('12664','2013-01-25','13:00:00',3.62),('12664','2013-01-25','13:05:00',3.58),('12664','2013-01-25','13:10:00',3.52),('12664','2013-01-25','13:15:00',3.47),('12664','2013-01-25','13:20:00',3.43),('12664','2013-01-25','13:25:00',3.47),('12664','2013-01-25','13:30:00',3.48),('12664','2013-01-25','13:35:00',3.4),('12664','2013-01-25','13:40:00',3.39),('12664','2013-01-25','13:45:00',3.35),('12664','2013-01-25','13:50:00',3.17),('12664','2013-01-25','13:55:00',2.86),('12664','2013-01-25','14:00:00',2.83),('12664','2013-01-25','14:05:00',2.82),('12664','2013-01-25','14:10:00',2.82),('12664','2013-01-25','14:15:00',2.79),('12664','2013-01-25','14:20:00',2.72),('12664','2013-01-25','14:25:00',2.68),('12664','2013-01-25','14:30:00',2.6),('12664','2013-01-25','14:35:00',2.52),('12664','2013-01-25','14:40:00',2.47),('12664','2013-01-25','14:45:00',2.44),('12664','2013-01-25','14:50:00',2.41),('12664','2013-01-25','14:55:00',2.27),('12664','2013-01-25','15:00:00',2.11),('12664','2013-01-25','15:05:00',1.96),('12664','2013-01-25','15:10:00',1.77),('12664','2013-01-25','15:15:00',1.81),('12664','2013-01-25','15:20:00',1.76),('12664','2013-01-25','15:25:00',1.83),('12664','2013-01-25','15:30:00',1.79),('12664','2013-01-25','15:35:00',1.7),('12664','2013-01-25','15:40:00',1.65),('12664','2013-01-25','15:45:00',1.53),('12664','2013-01-25','15:50:00',1.25),('12664','2013-01-24','08:50:00',1.22),('12664','2013-01-24','09:20:00',1.32),('12664','2013-01-24','09:30:00',1.54),('12664','2013-01-24','09:35:00',2.85),('12664','2013-01-24','09:40:00',2.7),('12664','2013-01-24','09:45:00',1.87),('12664','2013-01-24','09:50:00',2.06),('12664','2013-01-24','09:55:00',2.62),('12664','2013-01-24','10:00:00',1.78),('12664','2013-01-24','10:05:00',2.76),('12664','2013-01-24','10:10:00',3.25),('12664','2013-01-24','10:15:00',3.19),('12664','2013-01-24','10:20:00',2.85),('12664','2013-01-24','10:25:00',3.1),('12664','2013-01-24','10:30:00',3.27),('12664','2013-01-24','10:35:00',3.28),('12664','2013-01-24','10:40:00',3.31),('12664','2013-01-24','10:45:00',3.35),('12664','2013-01-24','10:50:00',3.31),('12664','2013-01-24','10:55:00',1.8),('12664','2013-01-24','12:35:00',1.11),('12664','2013-01-24','12:40:00',1.19),('12664','2013-01-24','12:45:00',1.15),('12664','2013-01-24','12:50:00',1.06),('12664','2013-01-24','12:55:00',1.01),('12664','2013-01-24','13:00:00',1),('12664','2013-01-24','13:50:00',1.08),('12664','2013-01-24','13:55:00',1.14),('12664','2013-01-24','14:00:00',1.19),('12664','2013-01-24','14:05:00',1.26),('12664','2013-01-24','14:10:00',1.33),('12664','2013-01-24','14:15:00',3.92),('12664','2013-01-24','14:20:00',3.76),('12664','2013-01-24','14:25:00',3.37),('12664','2013-01-24','14:30:00',2.52),('12664','2013-01-24','14:35:00',2.62),('12664','2013-01-24','14:40:00',2.76),('12664','2013-01-24','14:45:00',2.31),('12664','2013-01-24','14:50:00',1.98),('12664','2013-01-24','14:55:00',1.83),('12664','2013-01-24','15:00:00',2.3),('12664','2013-01-24','15:05:00',2.17),('12664','2013-01-24','15:10:00',1.59),('12664','2013-01-24','15:35:00',1.7),('12664','2013-01-24','15:40:00',1.8),('12664','2013-01-24','15:45:00',1.66),('12664','2013-01-24','15:50:00',1.45),('12664','2013-01-24','15:55:00',1.2),('12664','2013-01-24','16:10:00',1.02),('12664','2013-01-23','09:10:00',1.45),('12664','2013-01-23','09:15:00',2.71),('12664','2013-01-23','09:20:00',2.42),('12664','2013-01-23','09:35:00',1.03),('12664','2013-01-23','09:40:00',2.84),('12664','2013-01-23','09:45:00',2.89),('12664','2013-01-23','09:50:00',2.29),('12664','2013-01-23','09:55:00',1.68),('12664','2013-01-23','10:00:00',1.58),('12664','2013-01-23','10:05:00',2.95),('12664','2013-01-23','10:10:00',2.41),('12664','2013-01-23','10:15:00',2.6),('12664','2013-01-23','10:20:00',2.39),('12664','2013-01-23','10:25:00',1.53),('12664','2013-01-23','10:30:00',1.11),('12664','2013-01-22','08:40:00',1.23),('12664','2013-01-22','08:45:00',1.48),('12664','2013-01-22','08:50:00',1.52),('12664','2013-01-22','09:20:00',1.52),('12664','2013-01-22','09:25:00',2.38),('12664','2013-01-22','09:30:00',2.42),('12664','2013-01-22','09:35:00',2.39),('12664','2013-01-22','09:45:00',2.12),('12664','2013-01-22','09:50:00',2.62),('12664','2013-01-22','09:55:00',2.56),('12664','2013-01-22','10:00:00',2.7),('12664','2013-01-22','10:05:00',2.06),('12664','2013-01-22','10:10:00',2.81),('12664','2013-01-22','10:15:00',1.9),('12664','2013-01-22','10:20:00',1.82),('12664','2013-01-22','10:25:00',3.35),('12664','2013-01-22','10:30:00',1.05),('12664','2013-01-22','10:35:00',2.82),('12664','2013-01-22','10:45:00',1.34),('12664','2013-01-22','10:50:00',1.28),('12664','2013-01-22','10:55:00',1.2),('12664','2013-01-22','11:00:00',3.23),('12664','2013-01-22','11:10:00',3.09),('12664','2013-01-22','11:15:00',4.09),('12664','2013-01-22','11:20:00',2.74),('12664','2013-01-22','11:50:00',1.71),('12664','2013-01-22','11:55:00',2.33),('12664','2013-01-22','12:00:00',2.47),('12664','2013-01-22','12:05:00',1.24),('12664','2013-01-22','12:10:00',1.44),('12664','2013-01-22','12:15:00',3.99),('12664','2013-01-22','12:20:00',1.41),('12664','2013-01-22','12:25:00',1.53),('12664','2013-01-22','12:30:00',3.96),('12664','2013-01-22','12:35:00',2.44),('12664','2013-01-22','12:40:00',2),('12664','2013-01-22','12:45:00',1.21),('12664','2013-01-22','12:50:00',1.2),('12664','2013-01-22','13:00:00',2.69),('12664','2013-01-22','13:05:00',2.59),('12664','2013-01-22','13:10:00',2.21),('12664','2013-01-22','13:15:00',1.94),('12664','2013-01-22','13:20:00',1.85),('12664','2013-01-22','13:25:00',1.48),('12664','2013-01-22','13:30:00',1.23),('12664','2013-01-22','13:35:00',1.12),('12664','2013-01-22','13:45:00',1.09),('12664','2013-01-22','13:50:00',1.19),('12664','2013-01-22','13:55:00',2.9),('12664','2013-01-22','14:00:00',1.72),('12664','2013-01-22','14:05:00',3.37),('12664','2013-01-22','14:10:00',3.18),('12664','2013-01-22','14:15:00',1.69),('12664','2013-01-22','14:20:00',2.07),('12664','2013-01-22','14:25:00',2.99),('12664','2013-01-22','14:30:00',2.06),('12664','2013-01-22','14:35:00',2.78),('12664','2013-01-22','14:40:00',2.76),('12664','2013-01-22','14:45:00',1.8),('12664','2013-01-22','14:55:00',2.14),('12664','2013-01-21','10:45:00',1.02),('12664','2013-01-21','11:10:00',1.33),('12664','2013-01-21','11:15:00',1.1),('12664','2013-01-21','11:20:00',1.07),('12664','2013-01-21','11:35:00',1.09),('12664','2013-01-21','11:50:00',3.7),('12664','2013-01-21','11:55:00',3.57),('12664','2013-01-21','12:00:00',3.47),('12664','2013-01-21','12:05:00',3.16),('12664','2013-01-21','12:10:00',1.77),('12664','2013-01-21','12:15:00',2.69),('12664','2013-01-21','12:20:00',3.43),('12664','2013-01-21','12:25:00',1.96),('12664','2013-01-21','12:30:00',1.52),('12664','2013-01-21','12:35:00',2.11),('12664','2013-01-21','13:05:00',1.18),('12664','2013-01-21','13:10:00',1.09),('12664','2013-01-21','13:15:00',1.04),('12664','2013-01-21','13:20:00',2.6),('12664','2013-01-21','13:25:00',4.01),('12664','2013-01-21','13:30:00',3.69),('12664','2013-01-21','13:35:00',3.21),('12664','2013-01-21','13:40:00',2.92),('12664','2013-01-21','13:50:00',2.78),('12664','2013-01-21','13:55:00',3.76),('12664','2013-01-21','14:00:00',2.78),('12664','2013-01-21','14:05:00',2.75),('12664','2013-01-21','14:10:00',2.34),('12664','2013-01-21','14:15:00',2),('12664','2013-01-21','14:20:00',2.21),('12664','2013-01-21','15:25:00',1.19),('12664','2013-01-21','15:30:00',1.64),('12664','2014-03-19','09:00:00',1.06),('12664','2014-03-19','09:05:00',1.19),('12664','2014-03-19','09:10:00',1.19),('12664','2014-03-19','09:15:00',1.33),('12664','2014-03-19','09:20:00',1.55),('12664','2014-03-19','09:25:00',1.59),('12664','2014-03-19','09:30:00',1.73),('12664','2014-03-19','09:35:00',1.89),('12664','2014-03-19','09:40:00',2.19),('12664','2014-03-19','09:45:00',1.83),('12664','2014-03-19','09:50:00',1.64),('12664','2014-03-19','09:55:00',1.47),('12664','2014-03-19','10:00:00',1.17),('12664','2014-03-19','10:05:00',1.12),('12664','2014-03-19','10:10:00',1.24),('12664','2014-03-19','10:15:00',1.11),('12664','2014-03-19','10:20:00',1.33),('12664','2014-03-19','10:25:00',1.63),('12664','2014-03-19','10:30:00',2.14),('12664','2014-03-19','10:35:00',2.52),('12664','2014-03-19','10:40:00',1.74),('12664','2014-03-19','10:45:00',1.6),('12664','2014-03-19','10:50:00',1.48),('12664','2014-03-19','10:55:00',1.3),('12664','2014-03-19','11:00:00',1.32),('12664','2014-03-19','11:05:00',1.33),('12664','2014-03-19','11:10:00',1.41),('12664','2014-03-19','11:15:00',3.83),('12664','2014-03-19','11:20:00',2.24),('12664','2014-03-19','11:25:00',1.77),('12664','2014-03-19','11:30:00',1.81),('12664','2014-03-19','11:35:00',1.87),('12664','2014-03-19','11:40:00',3.19),('12664','2014-03-19','11:45:00',4.46),('12664','2014-03-19','11:50:00',2.96),('12664','2014-03-19','11:55:00',2.65),('12664','2014-03-19','12:00:00',3.79),('12664','2014-03-19','12:05:00',4.03),('12664','2014-03-19','12:10:00',4.17),('12664','2014-03-19','12:15:00',2.98),('12664','2014-03-19','12:20:00',3.51),('12664','2014-03-19','12:25:00',3.62),('12664','2014-03-19','12:30:00',4.14),('12664','2014-03-19','12:35:00',4.07),('12664','2014-03-19','12:40:00',3.7),('12664','2014-03-19','12:45:00',3.72),('12664','2014-03-19','12:50:00',3.71),('12664','2014-03-19','12:55:00',3.55),('12664','2014-03-19','13:00:00',3.7),('12664','2014-03-19','13:05:00',3.53),('12664','2014-03-19','13:10:00',3.22),('12664','2014-03-19','13:15:00',3.21),('12664','2014-03-19','13:20:00',3.5),('12664','2014-03-19','13:25:00',3.49),('12664','2014-03-19','13:30:00',3.56),('12664','2014-03-19','13:35:00',3.47),('12664','2014-03-19','13:40:00',3.48),('12664','2014-03-19','13:45:00',3.46),('12664','2014-03-19','13:50:00',3.4),('12664','2014-03-19','13:55:00',3.38),('12664','2014-03-19','14:00:00',3.34),('12664','2014-03-19','14:05:00',3.27),('12664','2014-03-19','14:10:00',3.22),('12664','2014-03-19','14:15:00',3.14),('12664','2014-03-19','14:20:00',3.03),('12664','2014-03-19','14:25:00',2.97),('12664','2014-03-19','14:30:00',3.02),('12664','2014-03-19','14:35:00',3.01),('12664','2014-03-19','14:40:00',2.94),('12664','2014-03-19','14:45:00',2.9),('12664','2014-03-19','14:50:00',2.83),('12664','2014-03-19','14:55:00',2.77),('12664','2014-03-19','15:00:00',2.7),('12664','2014-03-19','15:05:00',2.64),('12664','2014-03-19','15:10:00',2.59),('12664','2014-03-19','15:15:00',2.49),('12664','2014-03-19','15:20:00',2.44),('12664','2014-03-19','15:25:00',2.37),('12664','2014-03-19','15:30:00',2.22),('12664','2014-03-19','15:35:00',2.19),('12664','2014-03-19','15:40:00',2.12),('12664','2014-03-19','15:45:00',2.06),('12664','2014-03-19','15:50:00',1.97),('12664','2014-03-19','15:55:00',1.86),('12664','2014-03-19','16:00:00',1.8),('12664','2014-03-19','16:05:00',1.74),('12664','2014-03-19','16:10:00',1.63),('12664','2014-03-19','16:15:00',1.53),('12664','2014-03-19','16:20:00',1.42),('12664','2014-03-19','16:25:00',1.37),('12664','2014-03-19','16:30:00',1.16),('12664','2014-03-19','16:35:00',1.1),('12664','2014-03-19','16:40:00',1.01),('12664','2013-01-20','11:00:00',1.08),('12664','2013-01-20','11:05:00',1.13),('12664','2013-01-20','11:10:00',1.93),('12664','2013-01-20','11:15:00',2.09),('12664','2013-01-20','11:20:00',1.34),('12664','2013-01-20','11:25:00',1.67),('12664','2013-01-20','11:30:00',1.65),('12664','2013-01-20','11:35:00',1.15),('12664','2013-01-19','09:10:00',1.4),('12664','2013-01-19','09:15:00',1.44),('12664','2013-01-19','09:45:00',1.05),('12664','2013-01-19','09:50:00',1.51),('12664','2013-01-19','09:55:00',1.44),('12664','2013-01-19','10:00:00',1.12),('12664','2013-01-19','10:40:00',1.18),('12664','2013-01-19','10:45:00',1.31),('12664','2013-01-19','11:15:00',1.19),('12664','2013-01-19','11:20:00',1.19),('12664','2013-01-18','10:10:00',1.48),('12664','2013-01-18','10:15:00',2.66),('12664','2013-01-18','10:20:00',1.45),('12664','2013-01-18','10:25:00',1.43),('12664','2013-01-18','10:30:00',1.13),('12664','2013-01-18','11:20:00',1.09),('12664','2013-01-18','11:25:00',1.37),('12664','2013-01-18','11:30:00',1.49),('12664','2013-01-18','11:35:00',1.15),('12664','2013-01-18','11:50:00',1.07),('12664','2013-01-18','11:55:00',1.02),('12664','2013-01-18','12:00:00',1.08),('12664','2013-01-18','12:05:00',1.23),('12664','2013-01-18','12:10:00',1.33),('12664','2013-01-18','12:15:00',1.46),('12664','2013-01-18','12:20:00',1.33),('12664','2013-01-18','12:25:00',1.45),('12664','2013-01-18','12:30:00',1.48),('12664','2013-01-18','12:35:00',1.33),('12664','2013-01-18','12:40:00',1.34),('12664','2013-01-18','12:45:00',1.65),('12664','2013-01-18','12:50:00',2.08),('12664','2013-01-18','12:55:00',2.94),('12664','2013-01-18','13:00:00',2.69),('12664','2013-01-18','13:05:00',2.36),('12664','2013-01-18','13:10:00',2.78),('12664','2013-01-18','13:15:00',2.23),('12664','2013-01-18','13:20:00',2.15),('12664','2013-01-18','13:25:00',2.07),('12664','2013-01-18','13:30:00',1.97),('12664','2013-01-18','13:35:00',1.77),('12664','2013-01-18','13:40:00',3.32),('12664','2013-01-18','13:45:00',3.48),('12664','2013-01-18','13:50:00',3.3),('12664','2013-01-18','13:55:00',3.48),('12664','2013-01-18','14:00:00',2.47),('12664','2013-01-18','14:05:00',2.39),('12664','2013-01-18','14:10:00',3.54),('12664','2013-01-18','14:15:00',3.69),('12664','2013-01-18','14:20:00',2.99),('12664','2013-01-18','14:25:00',2.58),('12664','2013-01-18','14:30:00',1.26),('12664','2013-01-18','14:45:00',1.04),('12664','2013-01-18','14:50:00',1.12),('12664','2013-01-18','14:55:00',1.73),('12664','2013-01-18','15:00:00',2.12),('12664','2013-01-18','15:05:00',1.26),('12664','2013-01-18','15:25:00',1.08),('12664','2013-01-18','15:35:00',1.17),('12664','2013-01-18','15:40:00',1.43),('12664','2013-01-18','15:45:00',1.47),('12664','2013-01-18','15:50:00',1.42),('12664','2013-01-18','15:55:00',1.3),('12664','2013-01-18','16:00:00',1.19),('12664','2013-01-18','16:05:00',1.07),('12664','2013-01-18','16:10:00',1),('12664','2013-01-17','09:40:00',1.19),('12664','2013-01-17','09:45:00',1.8),('12664','2013-01-17','09:50:00',2.03),('12664','2013-01-17','09:55:00',1.57),('12664','2013-01-17','10:00:00',1.28),('12664','2013-01-17','10:05:00',1.3),('12664','2013-01-17','10:10:00',1.56),('12664','2013-01-17','10:15:00',1.73),('12664','2013-01-17','10:20:00',1.88),('12664','2013-01-17','10:25:00',1.95),('12664','2013-01-17','10:30:00',2.15),('12664','2013-01-17','10:35:00',1.93),('12664','2013-01-17','10:40:00',1.78),('12664','2013-01-17','10:45:00',1.46),('12664','2013-01-17','10:50:00',1.46),('12664','2013-01-17','10:55:00',1.45),('12664','2013-01-17','11:00:00',1.42),('12664','2013-01-17','11:05:00',1.8),('12664','2013-01-17','11:10:00',2.13),('12664','2013-01-17','11:15:00',2.01),('12664','2013-01-17','11:20:00',1.57),('12664','2013-01-17','11:25:00',1.5),('12664','2013-01-17','11:30:00',1.62),('12664','2013-01-17','11:35:00',2),('12664','2013-01-17','11:40:00',2.05),('12664','2013-01-17','11:45:00',2.04),('12664','2013-01-17','11:50:00',1.89),('12664','2013-01-17','11:55:00',1.77),('12664','2013-01-17','12:00:00',1.99),('12664','2013-01-17','12:05:00',2.04),('12664','2013-01-17','12:10:00',2),('12664','2013-01-17','12:15:00',2.12),('12664','2013-01-17','12:20:00',2.26),('12664','2013-01-17','12:25:00',2.05),('12664','2013-01-17','12:30:00',2.52),('12664','2013-01-17','12:35:00',2.37),('12664','2013-01-17','12:40:00',2.27),('12664','2013-01-17','12:45:00',2.24),('12664','2013-01-17','12:50:00',1.66),('12664','2013-01-17','12:55:00',2.12),('12664','2013-01-17','13:00:00',1.8),('12664','2013-01-17','13:05:00',2.03),('12664','2013-01-17','13:10:00',1.67),('12664','2013-01-17','13:15:00',1.71),('12664','2013-01-17','13:20:00',1.83),('12664','2013-01-17','13:25:00',2.02),('12664','2013-01-17','13:30:00',2.49),('12664','2013-01-17','13:35:00',2.76),('12664','2013-01-17','13:40:00',2.83),('12664','2013-01-17','13:45:00',2.95),('12664','2013-01-17','13:50:00',1.71),('12664','2013-01-17','13:55:00',1.05),('12664','2013-01-17','14:05:00',1.17),('12664','2013-01-17','14:45:00',1.37),('12664','2013-01-16','09:10:00',1.51),('12664','2013-01-16','09:15:00',1.73),('12664','2013-01-16','09:20:00',2.27),('12664','2013-01-16','09:25:00',2.4),('12664','2013-01-16','09:30:00',2.36),('12664','2013-01-16','09:35:00',2.36),('12664','2013-01-16','09:40:00',2.28),('12664','2013-01-16','09:45:00',1.97),('12664','2013-01-16','09:50:00',1.37),('12664','2013-01-16','10:20:00',1.21),('12664','2013-01-16','10:25:00',2.39),('12664','2013-01-16','10:30:00',2.14),('12664','2013-01-16','10:35:00',2.96),('12664','2013-01-16','10:40:00',3),('12664','2013-01-16','10:45:00',3.71),('12664','2013-01-16','10:50:00',1.1),('12664','2013-01-16','10:55:00',1.2),('12664','2013-01-16','12:00:00',1.94),('12664','2013-01-16','12:05:00',2.36),('12664','2013-01-16','12:10:00',3.88),('12664','2013-01-16','12:15:00',3.47),('12664','2013-01-16','13:10:00',2.54),('12664','2013-01-16','13:15:00',2.93),('12664','2013-01-16','15:55:00',1.38),('12664','2013-01-16','16:00:00',1.09),('12664','2013-01-15','10:00:00',1.15),('12664','2013-01-15','10:05:00',1.03),('12664','2013-01-15','10:10:00',1.13),('12664','2013-01-15','10:15:00',1.74),('12664','2013-01-15','10:20:00',1.21),('12664','2013-01-15','10:25:00',2.48),('12664','2013-01-15','10:30:00',1.48),('12664','2013-01-15','10:35:00',1.03),('12664','2013-01-15','10:45:00',1.07),('12664','2013-01-15','10:50:00',1.39),('12664','2013-01-15','10:55:00',1.59),('12664','2013-01-15','11:00:00',1.59),('12664','2013-01-15','11:05:00',1.71),('12664','2013-01-15','11:10:00',2.06),('12664','2013-01-15','11:15:00',2.14),('12664','2013-01-15','11:20:00',1.84),('12664','2013-01-15','11:25:00',1.73),('12664','2013-01-15','11:30:00',1.62),('12664','2013-01-15','11:35:00',1.57),('12664','2013-01-15','11:40:00',1.5),('12664','2013-01-15','11:45:00',1.34),('12664','2013-01-15','11:50:00',1.38),('12664','2013-01-15','11:55:00',1.49),('12664','2013-01-15','12:00:00',1.46),('12664','2013-01-15','12:05:00',1.41),('12664','2013-01-15','12:10:00',1.45),('12664','2013-01-15','12:15:00',1.4),('12664','2013-01-15','12:20:00',1.41),('12664','2013-01-15','12:25:00',1.4),('12664','2013-01-15','12:30:00',1.41),('12664','2013-01-15','12:35:00',1.43),('12664','2013-01-15','12:40:00',1.52),('12664','2013-01-15','12:45:00',1.5),('12664','2013-01-15','12:50:00',1.39),('12664','2013-01-15','12:55:00',1.2),('12664','2013-01-15','13:00:00',1.31),('12664','2013-01-15','13:05:00',1.41),('12664','2013-01-15','13:10:00',1.27),('12664','2013-01-15','13:15:00',1.3),('12664','2013-01-15','13:20:00',1.34),('12664','2013-01-15','13:25:00',1.2),('12664','2013-01-15','13:30:00',1.33),('12664','2013-01-15','13:35:00',1.26),('12664','2013-01-15','13:40:00',1.31),('12664','2013-01-15','13:45:00',1.37),('12664','2013-01-15','13:50:00',1.16),('12664','2013-01-15','13:55:00',1.4),('12664','2013-01-15','14:00:00',1.29),('12664','2013-01-15','14:05:00',1.21),('12664','2013-01-15','14:10:00',1.19),('12664','2013-01-15','14:15:00',1.57),('12664','2013-01-15','14:20:00',2.71),('12664','2013-01-15','14:25:00',2.85),('12664','2013-01-15','14:30:00',2.62),('12664','2013-01-15','14:35:00',2.51),('12664','2013-01-15','14:40:00',2.42),('12664','2013-01-15','14:45:00',2.29),('12664','2013-01-15','14:50:00',2.15),('12664','2013-01-15','14:55:00',2.17),('12664','2013-01-15','15:00:00',1.86),('12664','2013-01-15','15:05:00',2),('12664','2013-01-15','15:10:00',1.96),('12664','2013-01-15','15:15:00',1.91),('12664','2013-01-15','15:20:00',1.88),('12664','2013-01-15','15:25:00',1.79),('12664','2013-01-15','15:30:00',1.71),('12664','2013-01-15','15:35:00',1.5),('12664','2013-01-15','15:40:00',1.32),('12664','2013-01-15','15:45:00',1.14),('12664','2013-01-15','15:50:00',1.16),('12664','2013-01-15','15:55:00',1.34),('12664','2013-01-15','16:00:00',1.4),('12664','2013-01-15','16:05:00',1.23),('12664','2013-01-15','16:10:00',1.08),('12664','2013-01-14','15:10:00',1.4),('12664','2013-01-13','09:25:00',1.02),('12664','2013-01-13','09:30:00',1.52),('12664','2013-01-13','09:35:00',1.89),('12664','2013-01-13','09:50:00',1.3),('12664','2013-01-13','09:55:00',2.49),('12664','2013-01-13','10:00:00',2.45),('12664','2013-01-13','10:05:00',1.32),('12664','2013-01-13','10:10:00',1.22),('12664','2013-01-13','10:15:00',1.61),('12664','2013-01-13','10:20:00',3.19),('12664','2013-01-13','10:25:00',1.39),('12664','2013-01-13','10:35:00',1.08),('12664','2013-01-13','10:40:00',1.17),('12664','2013-01-12','08:35:00',1.03),('12664','2013-01-12','08:40:00',1.13),('12664','2013-01-12','08:45:00',1.24),('12664','2013-01-12','08:50:00',1.32),('12664','2013-01-12','08:55:00',1.44),('12664','2013-01-12','09:00:00',1.55),('12664','2013-01-12','09:05:00',1.65),('12664','2013-01-12','09:10:00',1.74),('12664','2013-01-12','09:15:00',1.81),('12664','2013-01-12','09:20:00',1.88),('12664','2013-01-12','09:25:00',1.94),('12664','2013-01-12','09:30:00',1.99),('12664','2013-01-12','09:35:00',2.05),('12664','2013-01-12','09:40:00',2.14),('12664','2013-01-12','09:45:00',2.22),('12664','2013-01-12','09:50:00',2.27),('12664','2013-01-12','09:55:00',2.33),('12664','2013-01-12','10:00:00',2.39),('12664','2013-01-12','10:05:00',2.48),('12664','2013-01-12','10:10:00',2.54),('12664','2013-01-12','10:15:00',2.62),('12664','2013-01-12','10:20:00',2.69),('12664','2013-01-12','10:25:00',2.61),('12664','2013-01-12','10:30:00',2.8),('12664','2013-01-12','10:35:00',2.84),('12664','2013-01-12','10:40:00',2.9),('12664','2013-01-12','10:45:00',2.94),('12664','2013-01-12','10:50:00',2.98),('12664','2013-01-12','10:55:00',3.03),('12664','2013-01-12','11:00:00',3.04),('12664','2013-01-12','11:05:00',3.06),('12664','2013-01-12','11:10:00',3.05),('12664','2013-01-12','11:15:00',3.06),('12664','2013-01-12','11:20:00',3.11),('12664','2013-01-12','11:25:00',3.16),('12664','2013-01-12','11:30:00',3.03),('12664','2013-01-12','11:35:00',3.07),('12664','2013-01-12','11:40:00',3.21),('12664','2013-01-12','11:45:00',3.19),('12664','2013-01-12','11:50:00',3.16),('12664','2013-01-12','11:55:00',3.22),('12664','2013-01-12','12:00:00',3.24),('12664','2013-01-12','12:05:00',3.23),('12664','2013-01-12','12:10:00',3.22),('12664','2013-01-12','12:15:00',3.2),('12664','2013-01-12','12:20:00',3.19),('12664','2013-01-12','12:25:00',3.23),('12664','2013-01-12','12:30:00',3.24),('12664','2013-01-12','12:35:00',3.18),('12664','2013-01-12','12:40:00',3.2),('12664','2013-01-12','12:45:00',3.14),('12664','2013-01-12','12:50:00',3.12),('12664','2013-01-12','12:55:00',3.1),('12664','2013-01-12','13:00:00',3.02),('12664','2013-01-12','13:05:00',2.87),('12664','2013-01-12','13:10:00',2.98),('12664','2013-01-12','13:15:00',2.86),('12664','2013-01-12','13:20:00',3.05),('12664','2013-01-12','13:25:00',3),('12664','2013-01-12','13:30:00',2.79),('12664','2013-01-12','13:35:00',2.76),('12664','2013-01-12','13:40:00',2.9),('12664','2013-01-12','13:45:00',2.9),('12664','2013-01-12','13:50:00',2.11),('12664','2013-01-12','13:55:00',2.47),('12664','2013-01-12','14:00:00',2.7),('12664','2013-01-12','14:05:00',2.65),('12664','2013-01-12','14:10:00',2.58),('12664','2013-01-12','14:15:00',2.51),('12664','2013-01-12','14:20:00',2.39),('12664','2013-01-12','14:25:00',2.37),('12664','2013-01-12','14:30:00',2.29),('12664','2013-01-12','14:35:00',2.24),('12664','2013-01-12','14:40:00',2.17),('12664','2013-01-12','14:45:00',2.12),('12664','2013-01-12','14:50:00',2.02),('12664','2013-01-12','14:55:00',1.98),('12664','2013-01-12','15:00:00',1.89),('12664','2013-01-12','15:05:00',1.79),('12664','2013-01-12','15:10:00',1.69),('12664','2013-01-12','15:15:00',1.6),('12664','2013-01-12','15:20:00',1.48),('12664','2013-01-12','15:25:00',1.43),('12664','2013-01-12','15:30:00',1.39),('12664','2013-01-12','15:35:00',1.29),('12664','2013-01-12','15:40:00',1.2),('12664','2013-01-12','15:45:00',1.12),('12664','2013-01-12','15:50:00',1.01),('12664','2013-01-11','09:40:00',1.72),('12664','2013-01-11','09:45:00',2.19),('12664','2013-01-11','09:50:00',2.66),('12664','2013-01-11','09:55:00',1.87),('12664','2013-01-11','10:00:00',2.25),('12664','2013-01-11','10:10:00',1.23),('12664','2013-01-11','10:15:00',2.54),('12664','2013-01-11','10:20:00',2.55),('12664','2013-01-11','10:25:00',2.57),('12664','2013-01-11','10:30:00',2.7),('12664','2013-01-11','10:35:00',2.73),('12664','2013-01-11','10:40:00',2.76),('12664','2013-01-11','10:45:00',2.82),('12664','2013-01-11','10:50:00',2.85),('12664','2013-01-11','10:55:00',2.84),('12664','2013-01-11','11:00:00',2.82),('12664','2013-01-11','11:05:00',2.9),('12664','2013-01-11','11:10:00',2.91),('12664','2013-01-11','11:15:00',2.88),('12664','2013-01-11','11:20:00',2.22),('12664','2013-01-11','11:25:00',1.66),('12664','2013-01-11','11:30:00',1.96),('12664','2013-01-11','11:35:00',1.85),('12664','2013-01-11','11:40:00',1.97),('12664','2013-01-11','11:45:00',1.31),('12664','2013-01-11','12:45:00',1.99),('12664','2013-01-11','12:50:00',2.33),('12664','2013-01-11','12:55:00',1.03),('12664','2013-01-11','13:30:00',1.63),('12664','2013-01-11','13:35:00',1.63),('12664','2013-01-11','13:40:00',1.44),('12664','2013-01-11','14:40:00',1.89),('12664','2013-01-11','14:45:00',2.44),('12664','2013-01-11','14:50:00',1.16),('12664','2013-01-11','14:55:00',1.63),('12664','2013-01-11','15:00:00',1.76),('12664','2014-03-18','08:15:00',1.35),('12664','2014-03-18','08:20:00',1.18),('12664','2014-03-18','08:25:00',1),('12664','2014-03-18','08:35:00',1.09),('12664','2014-03-18','08:40:00',1.33),('12664','2014-03-18','08:45:00',1.51),('12664','2014-03-18','08:50:00',2.75),('12664','2014-03-18','08:55:00',2.12),('12664','2014-03-18','09:00:00',1.62),('12664','2014-03-18','09:15:00',1.16),('12664','2014-03-18','09:20:00',1.06),('12664','2014-03-18','09:35:00',1.51),('12664','2014-03-18','09:40:00',1.05),('12664','2014-03-18','09:50:00',1.2),('12664','2014-03-18','09:55:00',1.09),('12664','2014-03-18','10:00:00',1.08),('12664','2014-03-18','10:05:00',1.12),('12664','2014-03-18','10:10:00',2.67),('12664','2014-03-18','10:15:00',2.11),('12664','2014-03-18','10:20:00',2.89),('12664','2014-03-18','10:25:00',1.39),('12664','2014-03-18','10:30:00',1.28),('12664','2014-03-18','10:35:00',1.15),('12664','2014-03-18','10:40:00',1.06),('12664','2014-03-18','10:45:00',1.08),('12664','2014-03-18','10:50:00',1.13),('12664','2014-03-18','10:55:00',1.45),('12664','2014-03-18','11:00:00',2.26),('12664','2014-03-18','11:05:00',2.71),('12664','2014-03-18','11:10:00',4.05),('12664','2014-03-18','11:15:00',3.91),('12664','2014-03-18','11:20:00',3.81),('12664','2014-03-18','11:25:00',3.82),('12664','2014-03-18','11:30:00',1.65),('12664','2014-03-18','11:35:00',2.1),('12664','2014-03-18','11:40:00',2.12),('12664','2014-03-18','11:45:00',4.15),('12664','2014-03-18','11:50:00',3.54),('12664','2014-03-18','11:55:00',1.51),('12664','2014-03-18','12:00:00',3.17),('12664','2014-03-18','12:05:00',3.85),('12664','2014-03-18','12:10:00',4.12),('12664','2014-03-18','12:15:00',2.95),('12664','2014-03-18','12:20:00',2.47),('12664','2014-03-18','12:25:00',4.04),('12664','2014-03-18','12:30:00',3.18),('12664','2014-03-18','12:35:00',3.78),('12664','2014-03-18','12:40:00',3.86),('12664','2014-03-18','12:45:00',3.36),('12664','2014-03-18','12:50:00',3.62),('12664','2014-03-18','12:55:00',3.45),('12664','2014-03-18','13:00:00',3.95),('12664','2014-03-18','13:05:00',3.72),('12664','2014-03-18','13:10:00',3.8),('12664','2014-03-18','13:15:00',3.8),('12664','2014-03-18','13:20:00',3.57),('12664','2014-03-18','13:25:00',3.62),('12664','2014-03-18','13:30:00',3.62),('12664','2014-03-18','13:35:00',3.56),('12664','2014-03-18','13:40:00',3.56),('12664','2014-03-18','13:45:00',3.51),('12664','2014-03-18','13:50:00',3.48),('12664','2014-03-18','13:55:00',3.39),('12664','2014-03-18','14:00:00',3.36),('12664','2014-03-18','14:05:00',3.29),('12664','2014-03-18','14:10:00',3.31),('12664','2014-03-18','14:15:00',3.28),('12664','2014-03-18','14:20:00',3.19),('12664','2014-03-18','14:25:00',3.17),('12664','2014-03-18','14:30:00',3.12),('12664','2014-03-18','14:35:00',2.99),('12664','2014-03-18','14:40:00',2.92),('12664','2014-03-18','14:45:00',2.87),('12664','2014-03-18','14:50:00',2.84),('12664','2014-03-18','14:55:00',2.79),('12664','2014-03-18','15:00:00',2.73),('12664','2014-03-18','15:05:00',2.67),('12664','2014-03-18','15:10:00',2.61),('12664','2014-03-18','15:15:00',2.51),('12664','2014-03-18','15:20:00',2.42),('12664','2014-03-18','15:25:00',2.29),('12664','2014-03-18','15:30:00',2.22),('12664','2014-03-18','15:35:00',2.04),('12664','2014-03-18','15:40:00',2.1),('12664','2014-03-18','15:45:00',2.01),('12664','2014-03-18','15:50:00',1.92),('12664','2014-03-18','15:55:00',1.88),('12664','2014-03-18','16:00:00',1.78),('12664','2014-03-18','16:05:00',1.68),('12664','2014-03-18','16:10:00',1.6),('12664','2014-03-18','16:15:00',1.51),('12664','2014-03-18','16:20:00',1.4),('12664','2014-03-18','16:25:00',1.04),('12664','2014-03-18','16:30:00',1.22),('12664','2014-03-18','16:35:00',1.15),('12664','2014-03-18','16:40:00',1.06),('12664','2013-01-10','11:25:00',1),('12664','2013-01-10','11:30:00',1.05),('12664','2013-01-10','12:00:00',1.17),('12664','2013-01-10','12:05:00',1.01),('12664','2013-01-10','13:55:00',1.37),('12664','2013-01-09','10:40:00',1.4),('12664','2013-01-09','10:45:00',1.97),('12664','2013-01-09','10:50:00',1.47),('12664','2013-01-09','10:55:00',1.25),('12664','2013-01-09','11:00:00',1.3),('12664','2013-01-09','11:05:00',2.41),('12664','2013-01-09','11:10:00',2.23),('12664','2013-01-09','11:15:00',1.58),('12664','2013-01-09','11:20:00',1.57),('12664','2013-01-09','11:25:00',2.09),('12664','2013-01-09','11:30:00',1.5),('12664','2013-01-09','11:35:00',1.59),('12664','2013-01-09','11:40:00',1.81),('12664','2013-01-09','11:45:00',1.57),('12664','2013-01-09','11:50:00',2.12),('12664','2013-01-09','11:55:00',2.42),('12664','2013-01-09','12:00:00',2.47),('12664','2013-01-09','12:05:00',2.12),('12664','2013-01-09','12:10:00',2.6),('12664','2013-01-09','12:15:00',2.6),('12664','2013-01-09','12:20:00',2.16),('12664','2013-01-09','12:25:00',2.13),('12664','2013-01-09','12:30:00',1.38),('12664','2013-01-09','12:35:00',1.51),('12664','2013-01-09','12:40:00',2.17),('12664','2013-01-09','12:45:00',3),('12664','2013-01-09','12:50:00',3.27),('12664','2013-01-09','12:55:00',2.86),('12664','2013-01-09','13:00:00',2.01),('12664','2013-01-09','13:05:00',1.95),('12664','2013-01-09','13:10:00',1.51),('12664','2013-01-09','13:15:00',1.36),('12664','2013-01-09','13:20:00',1.47),('12664','2013-01-09','13:25:00',1.72),('12664','2013-01-09','13:30:00',1.94),('12664','2013-01-09','13:35:00',1.7),('12664','2013-01-09','13:40:00',1.8),('12664','2013-01-09','13:45:00',1.4),('12664','2013-01-09','13:50:00',1.39),('12664','2013-01-09','13:55:00',1.48),('12664','2013-01-09','14:00:00',1.46),('12664','2013-01-09','14:05:00',1.74),('12664','2013-01-09','14:10:00',1.43),('12664','2013-01-09','14:15:00',1.8),('12664','2013-01-09','14:20:00',1.3),('12664','2013-01-09','14:25:00',1.37),('12664','2013-01-09','15:35:00',1.18),('12664','2013-01-09','15:40:00',1.12),('12664','2013-01-09','15:45:00',1.02),('12664','2013-01-08','08:30:00',1.18),('12664','2013-01-08','08:35:00',1.36),('12664','2013-01-08','08:40:00',1.47),('12664','2013-01-08','08:45:00',1.5),('12664','2013-01-08','08:50:00',1.71),('12664','2013-01-08','08:55:00',1.88),('12664','2013-01-08','09:00:00',1.89),('12664','2013-01-08','09:05:00',1.26),('12664','2013-01-08','09:10:00',1.37),('12664','2013-01-08','09:15:00',1.78),('12664','2013-01-08','09:20:00',2.26),('12664','2013-01-08','09:25:00',2.28),('12664','2013-01-08','09:30:00',2.16),('12664','2013-01-08','09:35:00',2.52),('12664','2013-01-08','09:40:00',2.72),('12664','2013-01-08','09:45:00',2.68),('12664','2013-01-08','09:50:00',2.61),('12664','2013-01-08','09:55:00',2.33),('12664','2013-01-08','10:00:00',2.2),('12664','2013-01-08','10:05:00',2.36),('12664','2013-01-08','10:10:00',2),('12664','2013-01-08','10:15:00',1.92),('12664','2013-01-08','10:20:00',2.25),('12664','2013-01-08','10:25:00',2.29),('12664','2013-01-08','10:30:00',2.27),('12664','2013-01-08','10:35:00',2.63),('12664','2013-01-08','10:40:00',2.34),('12664','2013-01-08','10:45:00',2.08),('12664','2013-01-08','10:50:00',2.88),('12664','2013-01-08','10:55:00',2.97),('12664','2013-01-08','11:00:00',3),('12664','2013-01-08','11:05:00',3.04),('12664','2013-01-08','11:10:00',3.08),('12664','2013-01-08','11:15:00',3.09),('12664','2013-01-08','11:20:00',3.08),('12664','2013-01-08','11:25:00',3.05),('12664','2013-01-08','11:30:00',3.15),('12664','2013-01-08','11:35:00',3.14),('12664','2013-01-08','11:40:00',3.19),('12664','2013-01-08','11:45:00',2.74),('12664','2013-01-08','11:50:00',2.76),('12664','2013-01-08','11:55:00',3.39),('12664','2013-01-08','12:00:00',2.13),('12664','2013-01-08','12:05:00',1.88),('12664','2013-01-08','12:10:00',2.07),('12664','2013-01-08','12:15:00',2.13),('12664','2013-01-08','12:20:00',1.66),('12664','2013-01-08','12:25:00',1.38),('12664','2013-01-08','12:30:00',1.38),('12664','2013-01-08','12:35:00',1.48),('12664','2013-01-08','12:40:00',1.42),('12664','2013-01-08','12:45:00',1.18),('12664','2013-01-08','12:50:00',1.15),('12664','2013-01-08','12:55:00',1.1),('12664','2013-01-08','13:05:00',1.16),('12664','2013-01-08','13:15:00',1.02),('12664','2013-01-08','13:20:00',1.2),('12664','2013-01-08','13:25:00',1.41),('12664','2013-01-08','13:30:00',1.2),('12664','2013-01-08','13:35:00',1.16),('12664','2013-01-08','13:40:00',1.16),('12664','2013-01-08','13:45:00',1.5),('12664','2013-01-08','13:50:00',2.49),('12664','2013-01-08','13:55:00',1.2),('12664','2013-01-08','14:10:00',1.37),('12664','2013-01-08','14:20:00',1.29),('12664','2013-01-08','14:25:00',1.95),('12664','2013-01-08','14:30:00',2.21),('12664','2013-01-08','14:35:00',1.09),('12664','2013-01-08','14:40:00',1.41),('12664','2013-01-08','14:45:00',1.72),('12664','2013-01-08','14:50:00',1.29),('12664','2013-01-07','08:45:00',1.1),('12664','2013-01-07','08:50:00',1.23),('12664','2013-01-07','08:55:00',1.31),('12664','2013-01-07','09:00:00',1.35),('12664','2013-01-07','09:05:00',1.07),('12664','2013-01-07','09:10:00',1.23),('12664','2013-01-07','09:15:00',1.67),('12664','2013-01-07','09:20:00',1.77),('12664','2013-01-07','09:25:00',1.86),('12664','2013-01-07','09:30:00',1.96),('12664','2013-01-07','09:35:00',2.05),('12664','2013-01-07','09:40:00',2.14),('12664','2013-01-07','09:45:00',2.15),('12664','2013-01-07','09:50:00',2.2),('12664','2013-01-07','09:55:00',2.29),('12664','2013-01-07','10:00:00',2.34),('12664','2013-01-07','10:05:00',2.49),('12664','2013-01-07','10:10:00',2.57),('12664','2013-01-07','10:15:00',2.64),('12664','2013-01-07','10:20:00',2.63),('12664','2013-01-07','10:25:00',2.67),('12664','2013-01-07','10:30:00',2.71),('12664','2013-01-07','10:35:00',2.75),('12664','2013-01-07','10:40:00',2.83),('12664','2013-01-07','10:45:00',2.92),('12664','2013-01-07','10:50:00',2.9),('12664','2013-01-07','10:55:00',2.87),('12664','2013-01-07','11:00:00',2.91),('12664','2013-01-07','11:05:00',2.94),('12664','2013-01-07','11:10:00',2.96),('12664','2013-01-07','11:15:00',3.05),('12664','2013-01-07','11:20:00',3.03),('12664','2013-01-07','11:25:00',3.05),('12664','2013-01-07','11:30:00',3.1),('12664','2013-01-07','11:35:00',3.11),('12664','2013-01-07','11:40:00',3.11),('12664','2013-01-07','11:45:00',3.1),('12664','2013-01-07','11:50:00',3.12),('12664','2013-01-07','11:55:00',3.12),('12664','2013-01-07','12:00:00',3.11),('12664','2013-01-07','12:05:00',3.08),('12664','2013-01-07','12:10:00',3.07),('12664','2013-01-07','12:15:00',3.07),('12664','2013-01-07','12:20:00',3.08),('12664','2013-01-07','12:25:00',3.09),('12664','2013-01-07','12:30:00',3.07),('12664','2013-01-07','12:35:00',3.04),('12664','2013-01-07','12:40:00',3.03),('12664','2013-01-07','12:45:00',3.05),('12664','2013-01-07','12:50:00',3.05),('12664','2013-01-07','12:55:00',3.01),('12664','2013-01-07','13:00:00',2.99),('12664','2013-01-07','13:05:00',2.96),('12664','2013-01-07','13:10:00',2.95),('12664','2013-01-07','13:15:00',2.92),('12664','2013-01-07','13:20:00',2.88),('12664','2013-01-07','13:25:00',2.85),('12664','2013-01-07','13:30:00',2.83),('12664','2013-01-07','13:35:00',2.8),('12664','2013-01-07','13:40:00',2.75),('12664','2013-01-07','13:45:00',2.71),('12664','2013-01-07','13:50:00',2.69),('12664','2013-01-07','13:55:00',2.66),('12664','2013-01-07','14:00:00',2.63),('12664','2013-01-07','14:05:00',2.59),('12664','2013-01-07','14:10:00',2.53),('12664','2013-01-07','14:15:00',2.46),('12664','2013-01-07','14:20:00',2.4),('12664','2013-01-07','14:25:00',2.34),('12664','2013-01-07','14:30:00',2.27),('12664','2013-01-07','14:35:00',2.18),('12664','2013-01-07','14:40:00',2.14),('12664','2013-01-07','14:45:00',2.08),('12664','2013-01-07','14:50:00',2.01),('12664','2013-01-07','14:55:00',1.93),('12664','2013-01-07','15:00:00',1.84),('12664','2013-01-07','15:05:00',1.77),('12664','2013-01-07','15:10:00',1.68),('12664','2013-01-07','15:15:00',1.6),('12664','2013-01-07','15:20:00',1.5),('12664','2013-01-07','15:25:00',1.4),('12664','2013-01-07','15:30:00',1.31),('12664','2013-01-07','15:35:00',1.22),('12664','2013-01-07','15:40:00',1.13),('12664','2013-01-07','15:45:00',1.03),('12664','2013-01-06','08:35:00',1.05),('12664','2013-01-06','08:40:00',1.14),('12664','2013-01-06','08:45:00',1.23),('12664','2013-01-06','08:50:00',1.33),('12664','2013-01-06','08:55:00',1.44),('12664','2013-01-06','09:00:00',1.54),('12664','2013-01-06','09:05:00',1.63),('12664','2013-01-06','09:10:00',1.73),('12664','2013-01-06','09:15:00',1.82),('12664','2013-01-06','09:20:00',1.91),('12664','2013-01-06','09:25:00',1.99),('12664','2013-01-06','09:30:00',2.08),('12664','2013-01-06','09:35:00',2.15),('12664','2013-01-06','09:40:00',2.22),('12664','2013-01-06','09:45:00',2.29),('12664','2013-01-06','09:50:00',2.35),('12664','2013-01-06','09:55:00',2.4),('12664','2013-01-06','10:00:00',2.43),('12664','2013-01-06','10:05:00',2.51),('12664','2013-01-06','10:10:00',2.51),('12664','2013-01-06','10:15:00',2.5),('12664','2013-01-06','10:20:00',2.59),('12664','2013-01-06','10:25:00',2.66),('12664','2013-01-06','10:30:00',2.72),('12664','2013-01-06','10:35:00',2.78),('12664','2013-01-06','10:40:00',2.8),('12664','2013-01-06','10:45:00',2.85),('12664','2013-01-06','10:50:00',2.88),('12664','2013-01-06','10:55:00',2.91),('12664','2013-01-06','11:00:00',2.96),('12664','2013-01-06','11:05:00',2.95),('12664','2013-01-06','11:10:00',2.97),('12664','2013-01-06','11:15:00',3.01),('12664','2013-01-06','11:20:00',3.01),('12664','2013-01-06','11:25:00',3.06),('12664','2013-01-06','11:30:00',3.09),('12664','2013-01-06','11:35:00',3.11),('12664','2013-01-06','11:40:00',3.1),('12664','2013-01-06','11:45:00',3.13),('12664','2013-01-06','11:50:00',3.12),('12664','2013-01-06','11:55:00',3.14),('12664','2013-01-06','12:00:00',3.2),('12664','2013-01-06','12:05:00',3.2),('12664','2013-01-06','12:10:00',3.14),('12664','2013-01-06','12:15:00',3.19),('12664','2013-01-06','12:20:00',3.23),('12664','2013-01-06','12:25:00',3.23),('12664','2013-01-06','12:30:00',3.23),('12664','2013-01-06','12:35:00',3.23),('12664','2013-01-06','12:40:00',3.21),('12664','2013-01-06','12:45:00',3.19),('12664','2013-01-06','12:50:00',3.16),('12664','2013-01-06','12:55:00',3.13),('12664','2013-01-06','13:00:00',3.09),('12664','2013-01-06','13:05:00',3.07),('12664','2013-01-06','13:10:00',3.04),('12664','2013-01-06','13:15:00',2.99),('12664','2013-01-06','13:20:00',2.93),('12664','2013-01-06','13:25:00',2.92),('12664','2013-01-06','13:30:00',2.88),('12664','2013-01-06','13:35:00',2.86),('12664','2013-01-06','13:40:00',2.78),('12664','2013-01-06','13:45:00',2.71),('12664','2013-01-06','13:50:00',2.64),('12664','2013-01-06','13:55:00',2.59),('12664','2013-01-06','14:00:00',2.58),('12664','2013-01-06','14:05:00',2.54),('12664','2013-01-06','14:10:00',2.46),('12664','2013-01-06','14:15:00',2.39),('12664','2013-01-06','14:20:00',2.34),('12664','2013-01-06','14:25:00',2.26),('12664','2013-01-06','14:30:00',2.18),('12664','2013-01-06','14:35:00',2.09),('12664','2013-01-06','14:40:00',2.03),('12664','2013-01-06','14:45:00',1.92),('12664','2013-01-06','14:50:00',1.85),('12664','2013-01-06','14:55:00',1.79),('12664','2013-01-06','15:00:00',1.7),('12664','2013-01-06','15:05:00',1.61),('12664','2013-01-06','15:10:00',1.55),('12664','2013-01-06','15:15:00',1.45),('12664','2013-01-06','15:20:00',1.36),('12664','2013-01-06','15:25:00',1.25),('12664','2013-01-06','15:30:00',1.18),('12664','2013-01-06','15:35:00',1.12),('12664','2013-01-06','15:40:00',1.03),('12664','2013-01-05','10:15:00',1.19),('12664','2013-01-05','10:20:00',1.21),('12664','2013-01-05','10:25:00',1.1),('12664','2013-01-05','10:30:00',1.16),('12664','2013-01-05','10:35:00',1.53),('12664','2013-01-05','10:40:00',1.66),('12664','2013-01-05','10:45:00',1.68),('12664','2013-01-05','10:50:00',1.77),('12664','2013-01-05','10:55:00',2.5),('12664','2013-01-05','11:00:00',2.58),('12664','2013-01-05','11:05:00',2.36),('12664','2013-01-05','11:10:00',2.53),('12664','2013-01-05','11:15:00',2.71),('12664','2013-01-05','11:20:00',2.96),('12664','2013-01-05','11:25:00',2.96),('12664','2013-01-05','11:30:00',2.76),('12664','2013-01-05','11:35:00',2.61),('12664','2013-01-05','11:40:00',2.5),('12664','2013-01-05','11:45:00',2.61),('12664','2013-01-05','11:50:00',2.34),('12664','2013-01-05','11:55:00',1.95),('12664','2013-01-05','12:00:00',1.87),('12664','2013-01-05','12:05:00',1.83),('12664','2013-01-05','12:10:00',2.03),('12664','2013-01-05','12:15:00',2.03),('12664','2013-01-05','12:20:00',1.8),('12664','2013-01-05','12:25:00',1.46),('12664','2013-01-05','12:30:00',1.54),('12664','2013-01-05','12:35:00',2.12),('12664','2013-01-05','12:40:00',2.67),('12664','2013-01-05','12:45:00',2.61),('12664','2013-01-05','12:50:00',1.95),('12664','2013-01-05','12:55:00',1.63),('12664','2013-01-05','13:00:00',1.46),('12664','2013-01-05','13:05:00',1.3),('12664','2013-01-05','13:10:00',1.55),('12664','2013-01-05','13:15:00',1.3),('12664','2013-01-05','13:30:00',2.28),('12664','2013-01-05','13:35:00',1.64),('12664','2013-01-05','13:50:00',1.2),('12664','2013-01-05','13:55:00',1.86),('12664','2013-01-05','14:00:00',1.77),('12664','2013-01-05','14:05:00',2.26),('12664','2013-01-05','14:10:00',2.08),('12664','2013-01-05','14:15:00',2.1),('12664','2013-01-05','14:20:00',1.51),('12664','2013-01-05','14:25:00',1.11),('12664','2013-01-05','14:30:00',1.6),('12664','2013-01-05','14:35:00',1.43),('12664','2013-01-05','14:40:00',1.22),('12664','2013-01-05','14:45:00',1.58),('12664','2013-01-05','14:50:00',1.47),('12664','2013-01-05','14:55:00',1.07),('12664','2013-01-04','08:40:00',1.03),('12664','2013-01-04','08:45:00',1.34),('12664','2013-01-04','08:50:00',1.47),('12664','2013-01-04','08:55:00',1.58),('12664','2013-01-04','09:00:00',1.52),('12664','2013-01-04','09:05:00',1.41),('12664','2013-01-04','09:10:00',1.37),('12664','2013-01-04','09:15:00',1.66),('12664','2013-01-04','09:20:00',1.53),('12664','2013-01-04','09:25:00',1.67),('12664','2013-01-04','09:30:00',1.87),('12664','2013-01-04','09:35:00',1.76),('12664','2013-01-04','09:40:00',1.84),('12664','2013-01-04','09:45:00',2.18),('12664','2013-01-04','09:50:00',1.94),('12664','2013-01-04','09:55:00',2.3),('12664','2013-01-04','10:00:00',2.47),('12664','2013-01-04','10:05:00',2.77),('12664','2013-01-04','10:10:00',2.52),('12664','2013-01-04','10:15:00',2.31),('12664','2013-01-04','10:20:00',2.59),('12664','2013-01-04','10:25:00',2.66),('12664','2013-01-04','10:30:00',2.7),('12664','2013-01-04','10:35:00',2.81),('12664','2013-01-04','10:40:00',2.76),('12664','2013-01-04','10:45:00',2.86),('12664','2013-01-04','10:50:00',3.02),('12664','2013-01-04','10:55:00',3.09),('12664','2013-01-04','11:00:00',3.5),('12664','2013-01-04','11:05:00',3.48),('12664','2013-01-04','11:10:00',2.27),('12664','2013-01-04','11:45:00',1.58),('12664','2013-01-04','11:50:00',2.84),('12664','2013-01-04','11:55:00',3.55),('12664','2013-01-04','12:00:00',3.81),('12664','2013-01-04','12:05:00',2.38),('12664','2013-01-04','12:10:00',1.46),('12664','2013-01-04','12:15:00',1.02),('12664','2013-01-04','12:25:00',1.39),('12664','2013-01-04','12:30:00',2.88),('12664','2013-01-04','12:35:00',3.35),('12664','2013-01-04','12:40:00',3.12),('12664','2013-01-04','12:45:00',2.87),('12664','2013-01-04','12:50:00',2.96),('12664','2013-01-04','12:55:00',3.3),('12664','2013-01-04','13:00:00',2.71),('12664','2013-01-04','13:05:00',1.95),('12664','2013-01-04','13:10:00',1.72),('12664','2013-01-04','13:15:00',2.8),('12664','2013-01-04','13:20:00',2.92),('12664','2013-01-04','13:25:00',2.85),('12664','2013-01-04','13:30:00',2.8),('12664','2013-01-04','13:35:00',2.76),('12664','2013-01-04','13:40:00',2.7),('12664','2013-01-04','13:45:00',2.64),('12664','2013-01-04','13:50:00',2.56),('12664','2013-01-04','13:55:00',2.5),('12664','2013-01-04','14:00:00',2.48),('12664','2013-01-04','14:05:00',2.43),('12664','2013-01-04','14:10:00',2.35),('12664','2013-01-04','14:15:00',2.31),('12664','2013-01-04','14:20:00',2.25),('12664','2013-01-04','14:25:00',2.21),('12664','2013-01-04','14:30:00',2.12),('12664','2013-01-04','14:35:00',2.05),('12664','2013-01-04','14:40:00',1.99),('12664','2013-01-04','14:45:00',1.91),('12664','2013-01-04','14:50:00',1.83),('12664','2013-01-04','14:55:00',1.77),('12664','2013-01-04','15:00:00',1.7),('12664','2013-01-04','15:05:00',1.61),('12664','2013-01-04','15:10:00',1.42),('12664','2013-01-04','15:15:00',1.43),('12664','2013-01-04','15:20:00',1.33),('12664','2013-01-04','15:25:00',1.26),('12664','2013-01-04','15:30:00',1.18),('12664','2013-01-04','15:35:00',1.07),('12664','2013-01-03','08:40:00',1.1),('12664','2013-01-03','08:45:00',1.17),('12664','2013-01-03','08:50:00',1.28),('12664','2013-01-03','08:55:00',1.4),('12664','2013-01-03','09:00:00',1.51),('12664','2013-01-03','09:05:00',1.63),('12664','2013-01-03','09:10:00',1.75),('12664','2013-01-03','09:15:00',1.84),('12664','2013-01-03','09:20:00',1.94),('12664','2013-01-03','09:25:00',2.04),('12664','2013-01-03','09:30:00',2.13),('12664','2013-01-03','09:35:00',2.25),('12664','2013-01-03','09:40:00',2.44),('12664','2013-01-03','09:45:00',2.64),('12664','2013-01-03','09:50:00',2.8),('12664','2013-01-03','09:55:00',2.78),('12664','2013-01-03','10:00:00',1.95),('12664','2013-01-03','10:05:00',1.58),('12664','2013-01-03','10:10:00',1.98),('12664','2013-01-03','10:15:00',1.66),('12664','2013-01-03','10:20:00',1.65),('12664','2013-01-03','10:25:00',1.65),('12664','2013-01-03','10:30:00',1.85),('12664','2013-01-03','10:35:00',1.93),('12664','2013-01-03','10:40:00',2.01),('12664','2013-01-03','10:45:00',1.9),('12664','2013-01-03','10:50:00',1.72),('12664','2013-01-03','10:55:00',1.74),('12664','2013-01-03','11:00:00',1.64),('12664','2013-01-03','11:05:00',1.81),('12664','2013-01-03','11:10:00',2.03),('12664','2013-01-03','11:15:00',1.82),('12664','2013-01-03','11:20:00',1.44),('12664','2013-01-03','11:25:00',1.95),('12664','2013-01-03','11:30:00',3.12),('12664','2013-01-03','11:35:00',3.29),('12664','2013-01-03','11:40:00',3.2),('12664','2013-01-03','11:45:00',3.18),('12664','2013-01-03','11:50:00',3.16),('12664','2013-01-03','11:55:00',3.14),('12664','2013-01-03','12:00:00',3.11),('12664','2013-01-03','12:05:00',3.13),('12664','2013-01-03','12:10:00',3.12),('12664','2013-01-03','12:15:00',3.11),('12664','2013-01-03','12:20:00',3.12),('12664','2013-01-03','12:25:00',3.1),('12664','2013-01-03','12:30:00',3.07),('12664','2013-01-03','12:35:00',3.08),('12664','2013-01-03','12:40:00',3.06),('12664','2013-01-03','12:45:00',3.03),('12664','2013-01-03','12:50:00',3.01),('12664','2013-01-03','12:55:00',2.97),('12664','2013-01-03','13:00:00',2.96),('12664','2013-01-03','13:05:00',2.95),('12664','2013-01-03','13:10:00',2.94),('12664','2013-01-03','13:15:00',2.88),('12664','2013-01-03','13:20:00',2.87),('12664','2013-01-03','13:25:00',2.82),('12664','2013-01-03','13:30:00',2.79),('12664','2013-01-03','13:35:00',2.76),('12664','2013-01-03','13:40:00',2.72),('12664','2013-01-03','13:45:00',2.68),('12664','2013-01-03','13:50:00',2.62),('12664','2013-01-03','13:55:00',2.57),('12664','2013-01-03','14:00:00',2.55),('12664','2013-01-03','14:05:00',2.47),('12664','2013-01-03','14:10:00',2.42),('12664','2013-01-03','14:15:00',2.32),('12664','2013-01-03','14:20:00',2.26),('12664','2013-01-03','14:25:00',2.19),('12664','2013-01-03','14:30:00',2.11),('12664','2013-01-03','14:35:00',2.05),('12664','2013-01-03','14:40:00',2),('12664','2013-01-03','14:45:00',1.84),('12664','2013-01-03','14:50:00',1.86),('12664','2013-01-03','14:55:00',1.81),('12664','2013-01-03','15:00:00',1.72),('12664','2013-01-03','15:05:00',1.63),('12664','2013-01-03','15:10:00',1.54),('12664','2013-01-03','15:15:00',1.46),('12664','2013-01-03','15:20:00',1.33),('12664','2013-01-03','15:25:00',1.15),('12664','2013-01-03','15:30:00',1.05),('12664','2013-01-03','15:35:00',1.1),('12664','2013-01-03','15:40:00',1.01),('12664','2013-01-02','11:40:00',2.34),('12664','2013-01-02','11:45:00',1.57),('12664','2013-01-02','11:50:00',1.15),('12664','2013-01-02','12:30:00',1.14),('12664','2013-01-02','12:35:00',1.15),('12664','2013-01-02','12:50:00',1.1),('12664','2013-01-02','12:55:00',1.26),('12664','2013-01-02','13:00:00',1.16),('12664','2013-01-02','13:10:00',1.38),('12664','2013-01-02','13:15:00',1.55),('12664','2013-01-02','13:30:00',1.01),('12664','2013-01-02','13:45:00',1.18),('12664','2013-01-02','13:50:00',1.02),('12664','2013-01-01','08:45:00',1.08),('12664','2013-01-01','08:50:00',1.19),('12664','2013-01-01','08:55:00',1.27),('12664','2013-01-01','09:00:00',1.35),('12664','2013-01-01','09:05:00',1.45),('12664','2013-01-01','09:10:00',1.56),('12664','2013-01-01','09:15:00',1.64),('12664','2013-01-01','09:20:00',1.71),('12664','2013-01-01','09:25:00',1.79),('12664','2013-01-01','09:30:00',1.89),('12664','2013-01-01','09:35:00',1.99),('12664','2013-01-01','09:40:00',2.07),('12664','2013-01-01','09:45:00',2.13),('12664','2013-01-01','09:50:00',2.19),('12664','2013-01-01','09:55:00',2.23),('12664','2013-01-01','10:00:00',2.28),('12664','2013-01-01','10:05:00',2.32),('12664','2013-01-01','10:10:00',2.41),('12664','2013-01-01','10:15:00',2.47),('12664','2013-01-01','10:20:00',2.53),('12664','2013-01-01','10:25:00',2.63),('12664','2013-01-01','10:30:00',2.52),('12664','2013-01-01','10:35:00',1.24),('12664','2013-01-01','10:45:00',1.99),('12664','2013-01-01','10:50:00',3.06),('12664','2013-01-01','10:55:00',2.85),('12664','2013-01-01','11:00:00',2.81),('12664','2013-01-01','11:05:00',2.8),('12664','2013-01-01','11:10:00',1.93),('12664','2013-01-01','11:15:00',2.5),('12664','2013-01-01','11:20:00',1.06),('12664','2013-01-01','11:25:00',1.49),('12664','2013-01-01','11:30:00',2.91),('12664','2013-01-01','11:35:00',2.75),('12664','2013-01-01','11:40:00',2.79),('12664','2013-01-01','11:45:00',3.17),('12664','2013-01-01','11:50:00',1.84),('12664','2013-01-01','11:55:00',1.56),('12664','2013-01-01','12:00:00',1.73),('12664','2013-01-01','12:05:00',1.9),('12664','2013-01-01','12:10:00',1.51),('12664','2013-01-01','12:15:00',1.5),('12664','2013-01-01','12:20:00',1.29),('12664','2013-01-01','12:25:00',1.11),('12664','2013-01-01','12:35:00',1.05),('12664','2013-01-01','12:40:00',1.02),('12664','2013-01-01','12:45:00',1.08),('12664','2014-03-17','09:20:00',1.06),('12664','2014-03-17','09:30:00',1.09),('12664','2014-03-17','09:35:00',1.07),('12664','2014-03-17','09:40:00',1.12),('12664','2014-03-17','09:45:00',1.03),('12664','2014-03-17','10:10:00',1.01),('12664','2014-03-17','10:30:00',1.09),('12664','2014-03-17','10:35:00',1.64),('12664','2014-03-17','10:40:00',1.53),('12664','2014-03-17','10:45:00',1.09),('12664','2014-03-17','10:50:00',1.38),('12664','2014-03-17','10:55:00',1.54),('12664','2014-03-17','11:00:00',1.44),('12664','2014-03-17','11:05:00',1.28),('12664','2014-03-17','11:10:00',2.07),('12664','2014-03-17','11:15:00',1.3),('12664','2014-03-17','11:20:00',1.21),('12664','2014-03-17','11:25:00',1.65),('12664','2014-03-17','11:30:00',1.11),('12664','2014-03-17','11:40:00',1.51),('12664','2014-03-17','11:45:00',1.65),('12664','2014-03-17','11:50:00',1.11),('12664','2014-03-17','11:55:00',1.66),('12664','2014-03-17','12:00:00',1.59),('12664','2014-03-17','12:05:00',1.94),('12664','2014-03-17','12:10:00',1.69),('12664','2014-03-17','12:15:00',2.32),('12664','2014-03-17','12:20:00',2.52),('12664','2014-03-17','12:25:00',3.65),('12664','2014-03-17','12:30:00',4.5),('12664','2014-03-17','12:35:00',4.07),('12664','2014-03-17','12:40:00',3.29),('12664','2014-03-17','12:45:00',2.38),('12664','2014-03-17','12:50:00',2.48),('12664','2014-03-17','12:55:00',2.95),('12664','2014-03-17','13:00:00',3.89),('12664','2014-03-17','13:05:00',1.84),('12664','2014-03-17','13:10:00',3.58),('12664','2014-03-17','13:15:00',3.5),('12664','2014-03-17','13:20:00',3.53),('12664','2014-03-17','13:25:00',3.58),('12664','2014-03-17','13:30:00',3.5),('12664','2014-03-17','13:35:00',3.6),('12664','2014-03-17','13:40:00',3.28),('12664','2014-03-17','13:45:00',2.75),('12664','2014-03-17','13:50:00',2.82),('12664','2014-03-17','13:55:00',3.57),('12664','2014-03-17','14:00:00',2.98),('12664','2014-03-17','14:05:00',3.27),('12664','2014-03-17','14:10:00',3.36),('12664','2014-03-17','14:15:00',3.4),('12664','2014-03-17','14:20:00',3.2),('12664','2014-03-17','14:25:00',2.5),('12664','2014-03-17','14:30:00',3.03),('12664','2014-03-17','14:35:00',1.74),('12664','2014-03-17','14:40:00',2.46),('12664','2014-03-17','14:45:00',2.99),('12664','2014-03-17','14:50:00',2.87),('12664','2014-03-17','14:55:00',2.75),('12664','2014-03-17','15:00:00',2.69),('12664','2014-03-17','15:05:00',2.58),('12664','2014-03-17','15:10:00',2.4),('12664','2014-03-17','15:15:00',1.59),('12664','2014-03-17','15:20:00',1.28),('12664','2014-03-17','15:35:00',1.82),('12664','2014-03-17','15:40:00',2.31),('12664','2014-03-17','15:45:00',2.1),('12664','2014-03-17','15:50:00',1.93),('12664','2014-03-17','15:55:00',1.8),('12664','2014-03-17','16:00:00',1.54),('12664','2014-03-17','16:05:00',1.59),('12664','2014-03-17','16:10:00',1.39),('12664','2014-03-17','16:15:00',1.31),('12664','2012-12-31','08:45:00',1.07),('12664','2012-12-31','08:55:00',1.11),('12664','2012-12-31','09:00:00',1.23),('12664','2012-12-31','09:05:00',1.51),('12664','2012-12-31','09:10:00',1.83),('12664','2012-12-31','09:15:00',1.94),('12664','2012-12-31','09:20:00',2.04),('12664','2012-12-31','09:25:00',2.15),('12664','2012-12-31','09:30:00',2.26),('12664','2012-12-31','09:35:00',2.33),('12664','2012-12-31','09:40:00',2.4),('12664','2012-12-31','09:45:00',2.47),('12664','2012-12-31','09:50:00',2.56),('12664','2012-12-31','09:55:00',2.62),('12664','2012-12-31','10:00:00',2.66),('12664','2012-12-31','10:05:00',2.7),('12664','2012-12-31','10:10:00',2.72),('12664','2012-12-31','10:15:00',2.76),('12664','2012-12-31','10:20:00',2.8),('12664','2012-12-31','10:25:00',2.78),('12664','2012-12-31','10:30:00',2.76),('12664','2012-12-31','10:35:00',2.86),('12664','2012-12-31','10:40:00',2.92),('12664','2012-12-31','10:45:00',2.95),('12664','2012-12-31','10:50:00',2.95),('12664','2012-12-31','10:55:00',2.96),('12664','2012-12-31','11:00:00',3.03),('12664','2012-12-31','11:05:00',3.07),('12664','2012-12-31','11:10:00',3.13),('12664','2012-12-31','11:15:00',3.15),('12664','2012-12-31','11:20:00',3.17),('12664','2012-12-31','11:25:00',3.18),('12664','2012-12-31','11:30:00',3.21),('12664','2012-12-31','11:35:00',3.22),('12664','2012-12-31','11:40:00',3.22),('12664','2012-12-31','11:45:00',3.24),('12664','2012-12-31','11:50:00',3.24),('12664','2012-12-31','11:55:00',3.23),('12664','2012-12-31','12:00:00',3.24),('12664','2012-12-31','12:05:00',3.24),('12664','2012-12-31','12:10:00',3.22),('12664','2012-12-31','12:15:00',3.24),('12664','2012-12-31','12:20:00',3.22),('12664','2012-12-31','12:25:00',3.22),('12664','2012-12-31','12:30:00',3.21),('12664','2012-12-31','12:35:00',3.2),('12664','2012-12-31','12:40:00',3.2),('12664','2012-12-31','12:45:00',3.18),('12664','2012-12-31','12:50:00',3.16),('12664','2012-12-31','12:55:00',3.14),('12664','2012-12-31','13:00:00',3.13),('12664','2012-12-31','13:05:00',3.12),('12664','2012-12-31','13:10:00',3.07),('12664','2012-12-31','13:15:00',3.01),('12664','2012-12-31','13:20:00',2.97),('12664','2012-12-31','13:25:00',2.94),('12664','2012-12-31','13:30:00',2.93),('12664','2012-12-31','13:35:00',2.88),('12664','2012-12-31','13:40:00',2.84),('12664','2012-12-31','13:45:00',2.8),('12664','2012-12-31','13:50:00',2.77),('12664','2012-12-31','13:55:00',2.7),('12664','2012-12-31','14:00:00',2.65),('12664','2012-12-31','14:05:00',2.58),('12664','2012-12-31','14:10:00',2.53),('12664','2012-12-31','14:15:00',2.46),('12664','2012-12-31','14:20:00',2.4),('12664','2012-12-31','14:25:00',2.33),('12664','2012-12-31','14:30:00',2.26),('12664','2012-12-31','14:35:00',2.18),('12664','2012-12-31','14:40:00',2.11),('12664','2012-12-31','14:45:00',2.02),('12664','2012-12-31','14:50:00',1.95),('12664','2012-12-31','14:55:00',1.87),('12664','2012-12-31','15:00:00',1.77),('12664','2012-12-31','15:05:00',1.68),('12664','2012-12-31','15:10:00',1.62),('12664','2012-12-31','15:15:00',1.55),('12664','2012-12-31','15:20:00',1.46),('12664','2012-12-31','15:25:00',1.36),('12664','2012-12-31','15:30:00',1.26),('12664','2012-12-31','15:35:00',1.15),('12664','2012-12-31','15:40:00',1.05),('12664','2012-12-30','08:35:00',1.07),('12664','2012-12-30','08:40:00',1.15),('12664','2012-12-30','08:45:00',1.26),('12664','2012-12-30','08:50:00',1.36),('12664','2012-12-30','08:55:00',1.47),('12664','2012-12-30','09:00:00',1.57),('12664','2012-12-30','09:05:00',1.65),('12664','2012-12-30','09:10:00',1.75),('12664','2012-12-30','09:15:00',1.81),('12664','2012-12-30','09:20:00',1.92),('12664','2012-12-30','09:25:00',2),('12664','2012-12-30','09:30:00',2.06),('12664','2012-12-30','09:35:00',2.09),('12664','2012-12-30','09:40:00',2.2),('12664','2012-12-30','09:45:00',2.26),('12664','2012-12-30','09:50:00',2.31),('12664','2012-12-30','09:55:00',2.4),('12664','2012-12-30','10:00:00',2.49),('12664','2012-12-30','10:05:00',2.56),('12664','2012-12-30','10:10:00',2.61),('12664','2012-12-30','10:15:00',2.67),('12664','2012-12-30','10:20:00',2.7),('12664','2012-12-30','10:25:00',2.77),('12664','2012-12-30','10:30:00',2.81),('12664','2012-12-30','10:35:00',2.85),('12664','2012-12-30','10:40:00',2.91),('12664','2012-12-30','10:45:00',2.95),('12664','2012-12-30','10:50:00',2.97),('12664','2012-12-30','10:55:00',3),('12664','2012-12-30','11:00:00',3.03),('12664','2012-12-30','11:05:00',3.04),('12664','2012-12-30','11:10:00',3.04),('12664','2012-12-30','11:15:00',3.07),('12664','2012-12-30','11:20:00',3.1),('12664','2012-12-30','11:25:00',3.13),('12664','2012-12-30','11:30:00',3.16),('12664','2012-12-30','11:35:00',3.18),('12664','2012-12-30','11:40:00',3.17),('12664','2012-12-30','11:45:00',3.18),('12664','2012-12-30','11:50:00',3.21),('12664','2012-12-30','11:55:00',3.23),('12664','2012-12-30','12:00:00',3.24),('12664','2012-12-30','12:05:00',3.23),('12664','2012-12-30','12:10:00',3.23),('12664','2012-12-30','12:15:00',3.25),('12664','2012-12-30','12:20:00',3.24),('12664','2012-12-30','12:25:00',3.23),('12664','2012-12-30','12:30:00',3.24),('12664','2012-12-30','12:35:00',3.23),('12664','2012-12-30','12:40:00',3.22),('12664','2012-12-30','12:45:00',3.22),('12664','2012-12-30','12:50:00',3.18),('12664','2012-12-30','12:55:00',3.15),('12664','2012-12-30','13:00:00',3.14),('12664','2012-12-30','13:05:00',3.1),('12664','2012-12-30','13:10:00',3.05),('12664','2012-12-30','13:15:00',3.03),('12664','2012-12-30','13:20:00',2.99),('12664','2012-12-30','13:25:00',2.96),('12664','2012-12-30','13:30:00',2.91),('12664','2012-12-30','13:35:00',2.87),('12664','2012-12-30','13:40:00',2.82),('12664','2012-12-30','13:45:00',2.76),('12664','2012-12-30','13:50:00',2.71),('12664','2012-12-30','13:55:00',2.68),('12664','2012-12-30','14:00:00',2.6),('12664','2012-12-30','14:05:00',2.58),('12664','2012-12-30','14:10:00',2.51),('12664','2012-12-30','14:15:00',2.44),('12664','2012-12-30','14:20:00',2.37),('12664','2012-12-30','14:25:00',2.31),('12664','2012-12-30','14:30:00',2.23),('12664','2012-12-30','14:35:00',2.13),('12664','2012-12-30','14:40:00',2.05),('12664','2012-12-30','14:45:00',1.98),('12664','2012-12-30','14:50:00',1.92),('12664','2012-12-30','14:55:00',1.83),('12664','2012-12-30','15:00:00',1.77),('12664','2012-12-30','15:05:00',1.66),('12664','2012-12-30','15:10:00',1.59),('12664','2012-12-30','15:15:00',1.5),('12664','2012-12-30','15:20:00',1.39),('12664','2012-12-30','15:25:00',1.31),('12664','2012-12-30','15:30:00',1.22),('12664','2012-12-30','15:35:00',1.13),('12664','2012-12-30','15:40:00',1.03),('12664','2012-12-29','08:35:00',1.04),('12664','2012-12-29','08:40:00',1.15),('12664','2012-12-29','08:45:00',1.25),('12664','2012-12-29','08:50:00',1.36),('12664','2012-12-29','08:55:00',1.45),('12664','2012-12-29','09:00:00',1.56),('12664','2012-12-29','09:05:00',1.66),('12664','2012-12-29','09:10:00',1.74),('12664','2012-12-29','09:15:00',1.82),('12664','2012-12-29','09:20:00',1.89),('12664','2012-12-29','09:25:00',1.97),('12664','2012-12-29','09:30:00',2.04),('12664','2012-12-29','09:35:00',2.12),('12664','2012-12-29','09:40:00',2.22),('12664','2012-12-29','09:45:00',2.3),('12664','2012-12-29','09:50:00',2.38),('12664','2012-12-29','09:55:00',2.44),('12664','2012-12-29','10:00:00',2.5),('12664','2012-12-29','10:05:00',2.56),('12664','2012-12-29','10:10:00',2.63),('12664','2012-12-29','10:15:00',2.68),('12664','2012-12-29','10:20:00',2.71),('12664','2012-12-29','10:25:00',2.77),('12664','2012-12-29','10:30:00',2.8),('12664','2012-12-29','10:35:00',2.71),('12664','2012-12-29','10:40:00',2.88),('12664','2012-12-29','10:45:00',2.81),('12664','2012-12-29','10:50:00',3.02),('12664','2012-12-29','10:55:00',3.07),('12664','2012-12-29','11:00:00',3.08),('12664','2012-12-29','11:05:00',3.1),('12664','2012-12-29','11:10:00',3.15),('12664','2012-12-29','11:15:00',3.19),('12664','2012-12-29','11:20:00',3.21),('12664','2012-12-29','11:25:00',3.23),('12664','2012-12-29','11:30:00',3.27),('12664','2012-12-29','11:35:00',3.31),('12664','2012-12-29','11:40:00',3.34),('12664','2012-12-29','11:45:00',3.35),('12664','2012-12-29','11:50:00',3.36),('12664','2012-12-29','11:55:00',3.37),('12664','2012-12-29','12:00:00',3.37),('12664','2012-12-29','12:05:00',3.36),('12664','2012-12-29','12:10:00',3.35),('12664','2012-12-29','12:15:00',3.33),('12664','2012-12-29','12:20:00',3.33),('12664','2012-12-29','12:25:00',3.33),('12664','2012-12-29','12:30:00',3.32),('12664','2012-12-29','12:35:00',3.31),('12664','2012-12-29','12:40:00',3.29),('12664','2012-12-29','12:45:00',3.27),('12664','2012-12-29','12:50:00',3.25),('12664','2012-12-29','12:55:00',3.2),('12664','2012-12-29','13:00:00',3.17),('12664','2012-12-29','13:05:00',3.16),('12664','2012-12-29','13:10:00',3.12),('12664','2012-12-29','13:15:00',3.08),('12664','2012-12-29','13:20:00',3),('12664','2012-12-29','13:25:00',2.97),('12664','2012-12-29','13:30:00',2.94),('12664','2012-12-29','13:35:00',2.9),('12664','2012-12-29','13:40:00',2.85),('12664','2012-12-29','13:45:00',2.81),('12664','2012-12-29','13:50:00',2.74),('12664','2012-12-29','13:55:00',2.68),('12664','2012-12-29','14:00:00',2.64),('12664','2012-12-29','14:05:00',2.59),('12664','2012-12-29','14:10:00',2.53),('12664','2012-12-29','14:15:00',2.46),('12664','2012-12-29','14:20:00',2.42),('12664','2012-12-29','14:25:00',2.35),('12664','2012-12-29','14:30:00',2.29),('12664','2012-12-29','14:35:00',2.23),('12664','2012-12-29','14:40:00',2.15),('12664','2012-12-29','14:45:00',2.06),('12664','2012-12-29','14:50:00',1.95),('12664','2012-12-29','14:55:00',1.9),('12664','2012-12-29','15:00:00',1.82),('12664','2012-12-29','15:05:00',1.74),('12664','2012-12-29','15:10:00',1.65),('12664','2012-12-29','15:15:00',1.56),('12664','2012-12-29','15:20:00',1.46),('12664','2012-12-29','15:25:00',1.37),('12664','2012-12-29','15:30:00',1.24),('12664','2012-12-29','15:35:00',1.15),('12664','2012-12-29','15:40:00',1.06),('12664','2012-12-28','08:40:00',1.03),('12664','2012-12-28','08:45:00',1.11),('12664','2012-12-28','08:50:00',1.19),('12664','2012-12-28','08:55:00',1.29),('12664','2012-12-28','09:00:00',1.37),('12664','2012-12-28','09:05:00',1.5),('12664','2012-12-28','09:10:00',1.6),('12664','2012-12-28','09:15:00',1.67),('12664','2012-12-28','09:20:00',1.73),('12664','2012-12-28','09:25:00',1.8),('12664','2012-12-28','09:30:00',1.84),('12664','2012-12-28','09:35:00',1.91),('12664','2012-12-28','09:40:00',2.04),('12664','2012-12-28','09:45:00',2.17),('12664','2012-12-28','09:50:00',2.24),('12664','2012-12-28','09:55:00',2.3),('12664','2012-12-28','10:00:00',2.38),('12664','2012-12-28','10:05:00',2.42),('12664','2012-12-28','10:10:00',2.48),('12664','2012-12-28','10:15:00',2.55),('12664','2012-12-28','10:20:00',2.59),('12664','2012-12-28','10:25:00',2.65),('12664','2012-12-28','10:30:00',2.65),('12664','2012-12-28','10:35:00',2.72),('12664','2012-12-28','10:40:00',2.79),('12664','2012-12-28','10:45:00',2.44),('12664','2012-12-28','10:50:00',2.89),('12664','2012-12-28','10:55:00',2.93),('12664','2012-12-28','11:00:00',2.97),('12664','2012-12-28','11:05:00',2.7),('12664','2012-12-28','11:10:00',2.81),('12664','2012-12-28','11:15:00',3.05),('12664','2012-12-28','11:20:00',3.15),('12664','2012-12-28','11:25:00',3.14),('12664','2012-12-28','11:30:00',3.05),('12664','2012-12-28','11:35:00',3.1),('12664','2012-12-28','11:40:00',2.6),('12664','2012-12-28','11:45:00',3.16),('12664','2012-12-28','11:50:00',3.1),('12664','2012-12-28','11:55:00',3.17),('12664','2012-12-28','12:00:00',3.12),('12664','2012-12-28','12:05:00',3.15),('12664','2012-12-28','12:10:00',3.21),('12664','2012-12-28','12:15:00',3.17),('12664','2012-12-28','12:20:00',3.2),('12664','2012-12-28','12:25:00',3.23),('12664','2012-12-28','12:30:00',3.24),('12664','2012-12-28','12:35:00',3.19),('12664','2012-12-28','12:40:00',3.15),('12664','2012-12-28','12:45:00',3.09),('12664','2012-12-28','12:50:00',3.07),('12664','2012-12-28','12:55:00',3.02),('12664','2012-12-28','13:00:00',2.96),('12664','2012-12-28','13:05:00',2.92),('12664','2012-12-28','13:10:00',2.93),('12664','2012-12-28','13:15:00',2.94),('12664','2012-12-28','13:20:00',2.92),('12664','2012-12-28','13:25:00',2.86),('12664','2012-12-28','13:30:00',2.78),('12664','2012-12-28','13:35:00',2.76),('12664','2012-12-28','13:40:00',2.72),('12664','2012-12-28','13:45:00',2.64),('12664','2012-12-28','13:50:00',2.54),('12664','2012-12-28','13:55:00',2.49),('12664','2012-12-28','14:00:00',2.45),('12664','2012-12-28','14:05:00',2.41),('12664','2012-12-28','14:10:00',2.33),('12664','2012-12-28','14:15:00',2.31),('12664','2012-12-28','14:20:00',2.26),('12664','2012-12-28','14:25:00',2.17),('12664','2012-12-28','14:30:00',2.09),('12664','2012-12-28','14:35:00',2.03),('12664','2012-12-28','14:40:00',1.96),('12664','2012-12-28','14:45:00',1.88),('12664','2012-12-28','14:50:00',1.81),('12664','2012-12-28','14:55:00',1.73),('12664','2012-12-28','15:00:00',1.64),('12664','2012-12-28','15:05:00',1.57),('12664','2012-12-28','15:10:00',1.49),('12664','2012-12-28','15:15:00',1.39),('12664','2012-12-28','15:20:00',1.3),('12664','2012-12-28','15:25:00',1.21),('12664','2012-12-28','15:30:00',1.11),('12664','2012-12-28','15:35:00',1.02),('12664','2012-12-27','08:50:00',1.09),('12664','2012-12-27','08:55:00',1.21),('12664','2012-12-27','09:00:00',1.34),('12664','2012-12-27','09:05:00',1.44),('12664','2012-12-27','09:10:00',1.53),('12664','2012-12-27','09:15:00',1.41),('12664','2012-12-27','09:25:00',1.77),('12664','2012-12-27','09:30:00',2.08),('12664','2012-12-27','09:35:00',2.46),('12664','2012-12-27','09:40:00',1.56),('12664','2012-12-27','10:10:00',1.29),('12664','2012-12-27','10:15:00',2.18),('12664','2012-12-27','10:20:00',2.38),('12664','2012-12-27','10:25:00',2.34),('12664','2012-12-27','10:30:00',2.51),('12664','2012-12-27','10:35:00',2.55),('12664','2012-12-27','10:40:00',2.59),('12664','2012-12-27','10:45:00',2.63),('12664','2012-12-27','10:50:00',2.69),('12664','2012-12-27','10:55:00',2.69),('12664','2012-12-27','11:00:00',2.76),('12664','2012-12-27','11:05:00',2.74),('12664','2012-12-27','11:10:00',2.78),('12664','2012-12-27','11:15:00',2.78),('12664','2012-12-27','11:20:00',2.83),('12664','2012-12-27','11:25:00',2.93),('12664','2012-12-27','11:30:00',2.89),('12664','2012-12-27','11:35:00',2.97),('12664','2012-12-27','11:40:00',2.97),('12664','2012-12-27','11:45:00',3.01),('12664','2012-12-27','11:50:00',2.96),('12664','2012-12-27','11:55:00',2.11),('12664','2012-12-27','12:00:00',1.36),('12664','2012-12-27','12:05:00',1.46),('12664','2012-12-27','12:10:00',1.75),('12664','2012-12-27','12:20:00',3.41),('12664','2012-12-27','12:25:00',2.82),('12664','2012-12-27','12:30:00',1.98),('12664','2012-12-27','12:35:00',1.88),('12664','2012-12-27','12:40:00',3.16),('12664','2012-12-27','12:45:00',3.07),('12664','2012-12-27','12:50:00',3.08),('12664','2012-12-27','12:55:00',2.7),('12664','2012-12-27','13:00:00',2.21),('12664','2012-12-27','13:05:00',2.22),('12664','2012-12-27','13:10:00',1.74),('12664','2012-12-27','13:15:00',1.67),('12664','2012-12-27','13:20:00',2.2),('12664','2012-12-27','13:25:00',2.45),('12664','2012-12-27','13:30:00',1.29),('12664','2012-12-27','13:50:00',1.72),('12664','2012-12-27','13:55:00',2.62),('12664','2012-12-27','14:00:00',2.54),('12664','2012-12-27','14:05:00',2.5),('12664','2012-12-27','14:10:00',2.42),('12664','2012-12-27','14:15:00',2.37),('12664','2012-12-27','14:20:00',2.13),('12664','2012-12-27','14:25:00',2.24),('12664','2012-12-27','14:30:00',2.27),('12664','2012-12-27','14:35:00',2.47),('12664','2012-12-27','14:40:00',2.33),('12664','2012-12-27','14:45:00',2.13),('12664','2012-12-27','14:50:00',1.87),('12664','2012-12-27','14:55:00',1.81),('12664','2012-12-27','15:00:00',1.7),('12664','2012-12-27','15:15:00',1.39),('12664','2012-12-27','15:20:00',1.34),('12664','2012-12-27','15:25:00',1.24),('12664','2012-12-27','15:30:00',1.13),('12664','2012-12-27','15:35:00',1.03),('12664','2012-12-26','09:05:00',1.43),('12664','2012-12-26','09:10:00',1.37),('12664','2012-12-26','09:15:00',1.66),('12664','2012-12-26','09:20:00',1.78),('12664','2012-12-26','09:25:00',1.86),('12664','2012-12-26','09:30:00',1.93),('12664','2012-12-26','09:35:00',2.01),('12664','2012-12-26','09:40:00',2.08),('12664','2012-12-26','09:45:00',2.14),('12664','2012-12-26','09:50:00',2.18),('12664','2012-12-26','09:55:00',2.25),('12664','2012-12-26','10:00:00',2.37),('12664','2012-12-26','10:05:00',2.66),('12664','2012-12-26','10:10:00',2.57),('12664','2012-12-26','10:15:00',2.51),('12664','2012-12-26','10:20:00',2.49),('12664','2012-12-26','10:25:00',2.56),('12664','2012-12-26','10:30:00',2.6),('12664','2012-12-26','10:35:00',2.62),('12664','2012-12-26','10:40:00',2.66),('12664','2012-12-26','10:45:00',2.69),('12664','2012-12-26','10:50:00',2.74),('12664','2012-12-26','10:55:00',2.74),('12664','2012-12-26','11:00:00',2.77),('12664','2012-12-26','11:05:00',2.78),('12664','2012-12-26','11:10:00',2.77),('12664','2012-12-26','11:15:00',2.8),('12664','2012-12-26','11:20:00',2.59),('12664','2012-12-26','11:25:00',2.58),('12664','2012-12-26','11:30:00',2.9),('12664','2012-12-26','11:35:00',2.96),('12664','2012-12-26','11:40:00',3.02),('12664','2012-12-26','11:45:00',3.3),('12664','2012-12-26','11:50:00',3.47),('12664','2012-12-26','11:55:00',3.55),('12664','2012-12-26','12:00:00',3.76),('12664','2012-12-26','12:05:00',3.88),('12664','2012-12-26','12:10:00',3.87),('12664','2012-12-26','12:15:00',3.92),('12664','2012-12-26','12:20:00',3.2),('12664','2012-12-26','12:25:00',2.62),('12664','2012-12-26','12:30:00',3.7),('12664','2012-12-26','12:35:00',2.53),('12664','2012-12-26','12:40:00',3.37),('12664','2012-12-26','12:45:00',3.24),('12664','2012-12-26','12:50:00',3.29),('12664','2012-12-26','12:55:00',3.21),('12664','2012-12-26','13:00:00',3.13),('12664','2012-12-26','13:05:00',2.32),('12664','2012-12-26','13:10:00',2.36),('12664','2012-12-26','13:15:00',3.18),('12664','2012-12-26','13:20:00',2.36),('12664','2012-12-26','13:25:00',2.19),('12664','2012-12-26','13:30:00',1.55),('12664','2012-12-26','13:35:00',1.58),('12664','2012-12-26','13:40:00',1.77),('12664','2012-12-26','13:45:00',1.07),('12664','2012-12-26','13:50:00',1.93),('12664','2012-12-26','13:55:00',1.47),('12664','2012-12-26','14:00:00',1.86),('12664','2012-12-26','14:05:00',1.46),('12664','2012-12-25','12:00:00',1.04),('12664','2012-12-23','08:35:00',1.05),('12664','2012-12-23','08:40:00',1.15),('12664','2012-12-23','08:45:00',1.24),('12664','2012-12-23','08:50:00',1.35),('12664','2012-12-23','08:55:00',1.47),('12664','2012-12-23','09:00:00',1.54),('12664','2012-12-23','09:05:00',1.6),('12664','2012-12-23','09:10:00',1.71),('12664','2012-12-23','09:15:00',1.75),('12664','2012-12-23','09:20:00',1.78),('12664','2012-12-23','09:25:00',1.87),('12664','2012-12-23','09:30:00',2),('12664','2012-12-23','09:35:00',2.12),('12664','2012-12-23','09:40:00',2.16),('12664','2012-12-23','09:45:00',2.25),('12664','2012-12-23','09:50:00',2.31),('12664','2012-12-23','09:55:00',2.32),('12664','2012-12-23','10:00:00',2.36),('12664','2012-12-23','10:05:00',2.4),('12664','2012-12-23','10:10:00',2.47),('12664','2012-12-23','10:15:00',2.46),('12664','2012-12-23','10:20:00',2.47),('12664','2012-12-23','10:25:00',2.61),('12664','2012-12-23','10:30:00',2.65),('12664','2012-12-23','10:35:00',2.69),('12664','2012-12-23','10:40:00',2.73),('12664','2012-12-23','10:45:00',2.79),('12664','2012-12-23','10:50:00',2.79),('12664','2012-12-23','10:55:00',2.78),('12664','2012-12-23','11:00:00',2.87),('12664','2012-12-23','11:05:00',2.95),('12664','2012-12-23','11:10:00',2.96),('12664','2012-12-23','11:15:00',3),('12664','2012-12-23','11:20:00',3.05),('12664','2012-12-23','11:25:00',3.06),('12664','2012-12-23','11:30:00',2.76),('12664','2012-12-23','11:35:00',3.04),('12664','2012-12-23','11:40:00',3.03),('12664','2012-12-23','11:45:00',3.02),('12664','2012-12-23','11:50:00',3.07),('12664','2012-12-23','11:55:00',2.73),('12664','2012-12-23','12:00:00',2.81),('12664','2012-12-23','12:05:00',2.95),('12664','2012-12-23','12:10:00',2.55),('12664','2012-12-23','12:15:00',2.3),('12664','2012-12-23','12:20:00',2.7),('12664','2012-12-23','12:25:00',2.69),('12664','2012-12-23','12:30:00',2.68),('12664','2012-12-23','12:35:00',2.73),('12664','2012-12-23','12:40:00',2.52),('12664','2012-12-23','12:45:00',2.02),('12664','2012-12-23','12:50:00',1.98),('12664','2012-12-23','12:55:00',2.92),('12664','2012-12-23','13:00:00',2.4),('12664','2012-12-23','13:05:00',2.33),('12664','2012-12-23','13:10:00',2.46),('12664','2012-12-23','13:15:00',2.13),('12664','2012-12-23','13:25:00',1.54),('12664','2012-12-23','13:30:00',1.76),('12664','2012-12-23','13:35:00',2.17),('12664','2012-12-23','13:40:00',1.58),('12664','2012-12-23','13:45:00',1.39),('12664','2012-12-23','13:50:00',1.39),('12664','2012-12-23','13:55:00',2.08),('12664','2012-12-23','14:00:00',2.63),('12664','2012-12-23','14:05:00',2.41),('12664','2012-12-23','14:10:00',2),('12664','2012-12-23','14:15:00',1.38),('12664','2012-12-23','14:25:00',1.23),('12664','2012-12-23','14:30:00',1.31),('12664','2012-12-23','14:35:00',1.26),('12664','2012-12-23','14:40:00',1.45),('12664','2012-12-23','14:45:00',1.12),('12664','2012-12-23','15:00:00',1.08),('12664','2012-12-23','15:10:00',1.2),('12664','2012-12-23','15:15:00',1.34),('12664','2012-12-23','15:20:00',1.28),('12664','2012-12-23','15:25:00',1.22),('12664','2012-12-23','15:30:00',1.15),('12664','2012-12-23','15:35:00',1.08),('12664','2012-12-22','10:35:00',1.44),('12664','2012-12-22','10:40:00',2.2),('12664','2012-12-22','10:45:00',2.04),('12664','2012-12-22','10:50:00',3.71),('12664','2012-12-22','10:55:00',3.74),('12664','2012-12-22','11:00:00',3.13),('12664','2012-12-22','11:05:00',3.94),('12664','2012-12-22','11:10:00',3.96),('12664','2012-12-22','11:15:00',4.01),('12664','2012-12-22','11:20:00',3.79),('12664','2012-12-22','11:25:00',3.69),('12664','2012-12-22','11:30:00',3.57),('12664','2012-12-22','11:35:00',3.64),('12664','2012-12-22','11:40:00',2.83),('12664','2012-12-22','11:45:00',3.44),('12664','2012-12-22','11:50:00',3.33),('12664','2012-12-22','11:55:00',3.45),('12664','2012-12-22','12:00:00',3.51),('12664','2012-12-22','12:05:00',3.81),('12664','2012-12-22','12:10:00',2.63),('12664','2012-12-22','12:15:00',1.13),('12664','2012-12-22','12:20:00',1.95),('12664','2012-12-22','12:25:00',3.38),('12664','2012-12-22','12:30:00',3.56),('12664','2012-12-22','12:35:00',2.28),('12664','2012-12-22','12:40:00',1.9),('12664','2012-12-22','12:45:00',1.06),('12664','2012-12-22','12:50:00',1.22),('12664','2012-12-22','12:55:00',1.21),('12664','2012-12-22','13:00:00',2.52),('12664','2012-12-22','13:05:00',3.57),('12664','2012-12-22','13:10:00',3.55),('12664','2012-12-22','13:15:00',3.47),('12664','2012-12-22','13:20:00',3.27),('12664','2012-12-22','13:25:00',3.6),('12664','2012-12-22','13:30:00',3.56),('12664','2012-12-22','13:35:00',2.81),('12664','2012-12-22','13:40:00',1.94),('12664','2012-12-22','13:50:00',1.29),('12664','2012-12-22','13:55:00',1.16),('12664','2012-12-22','14:05:00',2.27),('12664','2012-12-22','14:10:00',2.48),('12664','2012-12-22','15:00:00',1.61),('12664','2012-12-22','15:05:00',1.49),('12664','2012-12-22','15:10:00',1.47),('12664','2012-12-22','15:15:00',1.47),('12664','2012-12-22','15:25:00',1.06),('12664','2012-12-22','15:30:00',1.14),('12664','2012-12-22','15:35:00',1.17),('12664','2014-04-30','07:55:00',1.06),('12664','2014-04-30','08:00:00',1.11),('12664','2014-04-30','08:05:00',1.24),('12664','2014-04-30','08:10:00',1.32),('12664','2014-04-30','08:15:00',1.4),('12664','2014-04-30','08:20:00',1.49),('12664','2014-04-30','08:25:00',1.6),('12664','2014-04-30','08:30:00',1.7),('12664','2014-04-30','08:35:00',1.79),('12664','2014-04-30','08:40:00',1.87),('12664','2014-04-30','08:45:00',1.95),('12664','2014-04-30','08:50:00',2.02),('12664','2014-04-30','08:55:00',2.15),('12664','2014-04-30','09:00:00',2.2),('12664','2014-04-30','09:05:00',2.29),('12664','2014-04-30','09:10:00',2.37),('12664','2014-04-30','09:15:00',2.45),('12664','2014-04-30','09:20:00',2.54),('12664','2014-04-30','09:25:00',2.61),('12664','2014-04-30','09:30:00',2.7),('12664','2014-04-30','09:35:00',2.84),('12664','2014-04-30','09:40:00',2.85),('12664','2014-04-30','09:45:00',2.68),('12664','2014-04-30','09:50:00',3.16),('12664','2014-04-30','09:55:00',3.05),('12664','2014-04-30','10:00:00',3.37),('12664','2014-04-30','10:05:00',2.03),('12664','2014-04-30','10:10:00',3.19),('12664','2014-04-30','10:15:00',1.58),('12664','2014-04-30','10:20:00',3.19),('12664','2014-04-30','10:25:00',2.16),('12664','2014-04-30','10:30:00',1.01),('12664','2014-04-30','10:35:00',1.73),('12664','2014-04-30','10:40:00',2.94),('12664','2014-04-30','10:45:00',1.62),('12664','2014-04-30','10:50:00',2.48),('12664','2014-04-30','10:55:00',1.54),('12664','2014-04-30','11:00:00',1.66),('12664','2014-04-30','11:05:00',2.34),('12664','2014-04-30','11:10:00',2.84),('12664','2014-04-30','11:15:00',4.34),('12664','2014-04-30','11:20:00',4.42),('12664','2014-04-30','11:25:00',4.39),('12664','2014-04-30','11:30:00',3.21),('12664','2014-04-30','11:35:00',4.46),('12664','2014-04-30','11:40:00',3.75),('12664','2014-04-30','11:45:00',2.77),('12664','2014-04-30','11:50:00',2),('12664','2014-04-30','11:55:00',3.05),('12664','2014-04-30','12:00:00',2.68),('12664','2014-04-30','12:05:00',2.11),('12664','2014-04-30','12:10:00',2.26),('12664','2014-04-30','12:15:00',4.04),('12664','2014-04-30','12:20:00',2.7),('12664','2014-04-30','12:25:00',1.85),('12664','2014-04-30','12:30:00',2.84),('12664','2014-04-30','12:35:00',4.06),('12664','2014-04-30','12:40:00',4.12),('12664','2014-04-30','12:45:00',3.21),('12664','2014-04-30','12:50:00',2.43),('12664','2014-04-30','12:55:00',3.34),('12664','2014-04-30','13:05:00',2.96),('12664','2014-04-30','13:10:00',2.31),('12664','2014-04-30','13:15:00',1.77),('12664','2014-04-30','13:20:00',2.29),('12664','2014-04-30','13:25:00',2.29),('12664','2014-04-30','13:30:00',1.43),('12664','2014-04-30','13:35:00',3.61),('12664','2014-04-30','13:40:00',2.51),('12664','2014-04-30','13:45:00',1.51),('12664','2014-04-30','13:50:00',1.59),('12664','2014-04-30','13:55:00',2.38),('12664','2014-04-30','14:00:00',1.92),('12664','2014-04-30','14:05:00',1.09),('12664','2014-04-30','14:10:00',1.21),('12664','2014-04-30','14:15:00',1.41),('12664','2014-04-30','14:20:00',1.68),('12664','2014-04-30','14:25:00',1.26),('12664','2014-04-30','14:30:00',1.07),('12664','2014-04-30','14:35:00',1.16),('12664','2014-04-30','14:40:00',1.44),('12664','2014-04-30','14:45:00',1.9),('12664','2014-04-30','14:50:00',1.8),('12664','2014-04-30','14:55:00',1.39),('12664','2014-04-30','15:00:00',1.35),('12664','2014-04-30','15:05:00',2.3),('12664','2014-04-30','15:10:00',1.74),('12664','2014-04-30','15:15:00',1.43),('12664','2014-04-30','15:20:00',2.44),('12664','2014-04-30','15:25:00',2.05),('12664','2014-04-30','15:30:00',2.11),('12664','2014-04-30','15:35:00',3.04),('12664','2014-04-30','15:40:00',3.59),('12664','2014-04-30','15:45:00',3.47),('12664','2014-04-30','15:50:00',2.79),('12664','2014-04-30','15:55:00',1.81),('12664','2014-04-30','16:00:00',2.05),('12664','2014-04-30','16:05:00',1.12),('12664','2014-04-30','16:10:00',2.46),('12664','2014-04-30','16:15:00',2.27),('12664','2014-04-30','16:20:00',2.96),('12664','2014-04-30','16:25:00',2.3),('12664','2014-04-30','16:30:00',1.97),('12664','2014-04-30','16:35:00',3.21),('12664','2014-04-30','16:40:00',2.43),('12664','2014-04-30','16:45:00',1.57),('12664','2014-04-30','16:50:00',1.97),('12664','2014-04-30','16:55:00',1.78),('12664','2014-04-30','17:00:00',1.8),('12664','2014-04-30','17:05:00',1.24),('12664','2014-04-30','17:10:00',1.48),('12664','2014-04-30','17:25:00',1.42),('12664','2014-04-30','17:35:00',1.75),('12664','2014-03-16','08:00:00',1.07),('12664','2014-03-16','08:05:00',1.21),('12664','2014-03-16','08:10:00',1.28),('12664','2014-03-16','08:15:00',1.27),('12664','2014-03-16','08:20:00',1.34),('12664','2014-03-16','08:25:00',1.48),('12664','2014-03-16','08:30:00',1.59),('12664','2014-03-16','08:35:00',1.71),('12664','2014-03-16','08:40:00',1.76),('12664','2014-03-16','08:45:00',1.85),('12664','2014-03-16','08:50:00',1.92),('12664','2014-03-16','08:55:00',1.98),('12664','2014-03-16','09:00:00',1.89),('12664','2014-03-16','09:05:00',2.05),('12664','2014-03-16','09:10:00',2.18),('12664','2014-03-16','09:15:00',2.31),('12664','2014-03-16','09:20:00',2.3),('12664','2014-03-16','09:25:00',2.38),('12664','2014-03-16','09:30:00',2.38),('12664','2014-03-16','09:35:00',2.4),('12664','2014-03-16','09:40:00',2.48),('12664','2014-03-16','09:45:00',2.62),('12664','2014-03-16','09:50:00',2.78),('12664','2014-03-16','09:55:00',2.76),('12664','2014-03-16','10:00:00',2.82),('12664','2014-03-16','10:05:00',2.88),('12664','2014-03-16','10:10:00',2.92),('12664','2014-03-16','10:15:00',2.98),('12664','2014-03-16','10:20:00',2.99),('12664','2014-03-16','10:25:00',2.99),('12664','2014-03-16','10:30:00',3.1),('12664','2014-03-16','10:35:00',3.13),('12664','2014-03-16','10:40:00',3.16),('12664','2014-03-16','10:45:00',3.23),('12664','2014-03-16','10:50:00',3.23),('12664','2014-03-16','10:55:00',3.28),('12664','2014-03-16','11:00:00',3.29),('12664','2014-03-16','11:05:00',3.39),('12664','2014-03-16','11:10:00',3.44),('12664','2014-03-16','11:15:00',3.48),('12664','2014-03-16','11:20:00',3.4),('12664','2014-03-16','11:25:00',3.35),('12664','2014-03-16','11:30:00',3.39),('12664','2014-03-16','11:35:00',3.47),('12664','2014-03-16','11:40:00',3.5),('12664','2014-03-16','11:45:00',3.48),('12664','2014-03-16','11:50:00',3.49),('12664','2014-03-16','11:55:00',3.54),('12664','2014-03-16','12:00:00',3.61),('12664','2014-03-16','12:05:00',3.58),('12664','2014-03-16','12:10:00',3.53),('12664','2014-03-16','12:15:00',3.47),('12664','2014-03-16','12:20:00',3.46),('12664','2014-03-16','12:25:00',3.46),('12664','2014-03-16','12:30:00',3.47),('12664','2014-03-16','12:35:00',3.5),('12664','2014-03-16','12:40:00',3.52),('12664','2014-03-16','12:45:00',3.49),('12664','2014-03-16','12:50:00',3.54),('12664','2014-03-16','12:55:00',3.5),('12664','2014-03-16','13:00:00',3.41),('12664','2014-03-16','13:05:00',3.4),('12664','2014-03-16','13:10:00',3.52),('12664','2014-03-16','13:15:00',3.43),('12664','2014-03-16','13:20:00',3.32),('12664','2014-03-16','13:25:00',3.38),('12664','2014-03-16','13:30:00',3.36),('12664','2014-03-16','13:35:00',3.31),('12664','2014-03-16','13:40:00',3.19),('12664','2014-03-16','13:45:00',3.31),('12664','2014-03-16','13:50:00',3.21),('12664','2014-03-16','13:55:00',3.2),('12664','2014-03-16','14:00:00',3.16),('12664','2014-03-16','14:05:00',3.12),('12664','2014-03-16','14:10:00',3.08),('12664','2014-03-16','14:15:00',3.05),('12664','2014-03-16','14:20:00',2.99),('12664','2014-03-16','14:25:00',2.98),('12664','2014-03-16','14:30:00',2.89),('12664','2014-03-16','14:35:00',2.79),('12664','2014-03-16','14:40:00',2.65),('12664','2014-03-16','14:45:00',2.42),('12664','2014-03-16','14:50:00',2.47),('12664','2014-03-16','14:55:00',2.66),('12664','2014-03-16','15:00:00',2.21),('12664','2014-03-16','15:05:00',2.08),('12664','2014-03-16','15:10:00',1.92),('12664','2014-03-16','15:15:00',1.6),('12664','2014-03-16','15:20:00',1.71),('12664','2014-03-16','15:25:00',1.74),('12664','2014-03-16','15:30:00',1.55),('12664','2014-03-16','15:35:00',1.19),('12664','2014-03-16','15:40:00',1.35),('12664','2014-03-16','15:45:00',1.63),('12664','2014-03-16','15:50:00',1.38),('12664','2014-03-16','15:55:00',1.19),('12664','2014-03-16','16:00:00',1.32),('12664','2014-03-16','16:05:00',1.52),('12664','2014-03-16','16:10:00',1.49),('12664','2014-03-16','16:15:00',1.38),('12664','2014-03-16','16:20:00',1.29),('12664','2014-03-16','16:25:00',1.21),('12664','2014-03-16','16:30:00',1.07),('12664','2014-03-16','16:35:00',1.1),('12664','2014-03-15','08:05:00',1.07),('12664','2014-03-15','08:10:00',1.15),('12664','2014-03-15','08:15:00',1.24),('12664','2014-03-15','08:20:00',1.33),('12664','2014-03-15','08:25:00',1.41),('12664','2014-03-15','08:30:00',1.5),('12664','2014-03-15','08:35:00',1.57),('12664','2014-03-15','08:40:00',1.63),('12664','2014-03-15','08:45:00',1.7),('12664','2014-03-15','08:50:00',1.79),('12664','2014-03-15','08:55:00',1.86),('12664','2014-03-15','09:00:00',1.94),('12664','2014-03-15','09:05:00',2.02),('12664','2014-03-15','09:10:00',2.09),('12664','2014-03-15','09:15:00',2.14),('12664','2014-03-15','09:20:00',2.17),('12664','2014-03-15','09:25:00',2.23),('12664','2014-03-15','09:30:00',2.33),('12664','2014-03-15','09:35:00',2.4),('12664','2014-03-15','09:40:00',2.48),('12664','2014-03-15','09:45:00',2.54),('12664','2014-03-15','09:50:00',2.61),('12664','2014-03-15','09:55:00',2.66),('12664','2014-03-15','10:00:00',2.71),('12664','2014-03-15','10:05:00',2.77),('12664','2014-03-15','10:10:00',2.8),('12664','2014-03-15','10:15:00',2.84),('12664','2014-03-15','10:20:00',2.9),('12664','2014-03-15','10:25:00',2.95),('12664','2014-03-15','10:30:00',2.96),('12664','2014-03-15','10:35:00',2.97),('12664','2014-03-15','10:40:00',3.07),('12664','2014-03-15','10:45:00',3.06),('12664','2014-03-15','10:50:00',3.06),('12664','2014-03-15','10:55:00',3.14),('12664','2014-03-15','11:00:00',3.26),('12664','2014-03-15','11:05:00',3.31),('12664','2014-03-15','11:10:00',3.29),('12664','2014-03-15','11:15:00',3.3),('12664','2014-03-15','11:20:00',3.27),('12664','2014-03-15','11:25:00',3.33),('12664','2014-03-15','11:30:00',3.42),('12664','2014-03-15','11:35:00',3.41),('12664','2014-03-15','11:40:00',3.4),('12664','2014-03-15','11:45:00',3.43),('12664','2014-03-15','11:50:00',3.47),('12664','2014-03-15','11:55:00',3.44),('12664','2014-03-15','12:00:00',3.49),('12664','2014-03-15','12:05:00',3.42),('12664','2014-03-15','12:10:00',3.46),('12664','2014-03-15','12:15:00',3.51),('12664','2014-03-15','12:20:00',3.45),('12664','2014-03-15','12:25:00',3.51),('12664','2014-03-15','12:30:00',3.51),('12664','2014-03-15','12:35:00',3.56),('12664','2014-03-15','12:40:00',3.57),('12664','2014-03-15','12:45:00',3.52),('12664','2014-03-15','12:50:00',3.54),('12664','2014-03-15','12:55:00',3.49),('12664','2014-03-15','13:00:00',3.49),('12664','2014-03-15','13:05:00',3.49),('12664','2014-03-15','13:10:00',3.48),('12664','2014-03-15','13:15:00',3.49),('12664','2014-03-15','13:20:00',3.47),('12664','2014-03-15','13:25:00',3.45),('12664','2014-03-15','13:30:00',3.43),('12664','2014-03-15','13:35:00',3.42),('12664','2014-03-15','13:40:00',3.39),('12664','2014-03-15','13:45:00',3.36),('12664','2014-03-15','13:50:00',3.28),('12664','2014-03-15','13:55:00',3.23),('12664','2014-03-15','14:00:00',3.17),('12664','2014-03-15','14:05:00',3.16),('12664','2014-03-15','14:10:00',3.11),('12664','2014-03-15','14:15:00',3.07),('12664','2014-03-15','14:20:00',3),('12664','2014-03-15','14:25:00',2.93),('12664','2014-03-15','14:30:00',2.88),('12664','2014-03-15','14:35:00',2.81),('12664','2014-03-15','14:40:00',2.8),('12664','2014-03-15','14:45:00',2.76),('12664','2014-03-15','14:50:00',2.7),('12664','2014-03-15','14:55:00',2.59),('12664','2014-03-15','15:00:00',2.54),('12664','2014-03-15','15:05:00',2.48),('12664','2014-03-15','15:10:00',2.37),('12664','2014-03-15','15:15:00',2.35),('12664','2014-03-15','15:20:00',2.26),('12664','2014-03-15','15:25:00',2.18),('12664','2014-03-15','15:30:00',2.1),('12664','2014-03-15','15:35:00',2.02),('12664','2014-03-15','15:40:00',1.91),('12664','2014-03-15','15:45:00',1.77),('12664','2014-03-15','15:50:00',1.7),('12664','2014-03-15','15:55:00',1.6),('12664','2014-03-15','16:00:00',1.5),('12664','2014-03-15','16:05:00',1.41),('12664','2014-03-15','16:10:00',1.33),('12664','2014-03-15','16:15:00',1.28),('12664','2014-03-15','16:20:00',1.2),('12664','2014-03-15','16:25:00',1.11),('12664','2014-03-15','16:30:00',1.04),('12664','2014-03-14','08:35:00',1.06),('12664','2014-03-14','09:10:00',1.14),('12664','2014-03-14','09:15:00',1.41),('12664','2014-03-14','09:20:00',1.81),('12664','2014-03-14','09:25:00',1.92),('12664','2014-03-14','09:30:00',1.73),('12664','2014-03-14','09:35:00',1.78),('12664','2014-03-14','09:40:00',1.83),('12664','2014-03-14','09:45:00',1.93),('12664','2014-03-14','09:50:00',2.22),('12664','2014-03-14','09:55:00',2.57),('12664','2014-03-14','10:00:00',2.87),('12664','2014-03-14','10:05:00',3.02),('12664','2014-03-14','10:10:00',3.21),('12664','2014-03-14','10:15:00',3.3),('12664','2014-03-14','10:20:00',3.37),('12664','2014-03-14','10:25:00',3.39),('12664','2014-03-14','10:30:00',3.33),('12664','2014-03-14','10:35:00',3.22),('12664','2014-03-14','10:40:00',3.29),('12664','2014-03-14','10:45:00',3.34),('12664','2014-03-14','10:50:00',3.34),('12664','2014-03-14','10:55:00',3),('12664','2014-03-14','11:00:00',2.48),('12664','2014-03-14','11:05:00',3.32),('12664','2014-03-14','11:10:00',3.28),('12664','2014-03-14','11:15:00',3.4),('12664','2014-03-14','11:20:00',3.58),('12664','2014-03-14','11:25:00',3.58),('12664','2014-03-14','11:30:00',3.44),('12664','2014-03-14','11:35:00',3.31),('12664','2014-03-14','11:40:00',3.43),('12664','2014-03-14','11:45:00',3.33),('12664','2014-03-14','11:50:00',3.33),('12664','2014-03-14','11:55:00',3.56),('12664','2014-03-14','12:00:00',3.6),('12664','2014-03-14','12:05:00',3.51),('12664','2014-03-14','12:10:00',3.55),('12664','2014-03-14','12:15:00',3.5),('12664','2014-03-14','12:20:00',3.42),('12664','2014-03-14','12:25:00',3.36),('12664','2014-03-14','12:30:00',3.21),('12664','2014-03-14','12:35:00',3.13),('12664','2014-03-14','12:40:00',2.32),('12664','2014-03-14','12:45:00',2.04),('12664','2014-03-14','12:50:00',1.89),('12664','2014-03-14','12:55:00',1.95),('12664','2014-03-14','13:00:00',2.16),('12664','2014-03-14','13:05:00',1.98),('12664','2014-03-14','13:10:00',1.54),('12664','2014-03-14','13:15:00',1.82),('12664','2014-03-14','13:20:00',2.32),('12664','2014-03-14','13:25:00',2.47),('12664','2014-03-14','13:30:00',2.18),('12664','2014-03-14','13:35:00',2.53),('12664','2014-03-14','13:40:00',2.42),('12664','2014-03-14','13:45:00',1.91),('12664','2014-03-14','13:50:00',2.09),('12664','2014-03-14','13:55:00',2.14),('12664','2014-03-14','14:00:00',2.34),('12664','2014-03-14','14:05:00',2.23),('12664','2014-03-14','14:10:00',2.17),('12664','2014-03-14','14:15:00',2.04),('12664','2014-03-14','14:20:00',1.85),('12664','2014-03-14','14:25:00',2.38),('12664','2014-03-14','14:30:00',2.81),('12664','2014-03-14','14:35:00',2.51),('12664','2014-03-14','14:40:00',2.4),('12664','2014-03-14','14:45:00',2.11),('12664','2014-03-14','14:50:00',1.66),('12664','2014-03-14','14:55:00',1.48),('12664','2014-03-14','15:00:00',1.4),('12664','2014-03-14','15:05:00',1.27),('12664','2014-03-14','15:10:00',1.2),('12664','2014-03-14','15:15:00',1.12),('12664','2014-03-14','15:20:00',1.09),('12664','2014-03-14','15:25:00',1.08),('12664','2014-03-14','15:30:00',1.17),('12664','2014-03-14','15:35:00',1.19),('12664','2014-03-14','15:40:00',1.36),('12664','2014-03-14','15:45:00',1.53),('12664','2014-03-14','15:50:00',1.39),('12664','2014-03-14','15:55:00',1.09),('12664','2014-03-13','07:50:00',1.08),('12664','2014-03-13','07:55:00',1.17),('12664','2014-03-13','08:00:00',1.27),('12664','2014-03-13','08:05:00',1.37),('12664','2014-03-13','08:10:00',1.46),('12664','2014-03-13','08:15:00',1.56),('12664','2014-03-13','08:20:00',1.66),('12664','2014-03-13','08:25:00',1.75),('12664','2014-03-13','08:30:00',1.84),('12664','2014-03-13','08:35:00',1.92),('12664','2014-03-13','08:40:00',2),('12664','2014-03-13','08:45:00',2.09),('12664','2014-03-13','08:50:00',2.18),('12664','2014-03-13','08:55:00',2.27),('12664','2014-03-13','09:00:00',2.35),('12664','2014-03-13','09:05:00',2.42),('12664','2014-03-13','09:10:00',2.49),('12664','2014-03-13','09:15:00',2.57),('12664','2014-03-13','09:20:00',2.63),('12664','2014-03-13','09:25:00',2.7),('12664','2014-03-13','09:30:00',2.77),('12664','2014-03-13','09:35:00',2.84),('12664','2014-03-13','09:40:00',2.9),('12664','2014-03-13','09:45:00',2.94),('12664','2014-03-13','09:50:00',3.01),('12664','2014-03-13','09:55:00',3.05),('12664','2014-03-13','10:00:00',3.11),('12664','2014-03-13','10:05:00',3.15),('12664','2014-03-13','10:10:00',3.2),('12664','2014-03-13','10:15:00',3.24),('12664','2014-03-13','10:20:00',3.29),('12664','2014-03-13','10:25:00',3.31),('12664','2014-03-13','10:30:00',3.35),('12664','2014-03-13','10:35:00',3.38),('12664','2014-03-13','10:40:00',3.4),('12664','2014-03-13','10:45:00',3.45),('12664','2014-03-13','10:50:00',3.47),('12664','2014-03-13','10:55:00',3.52),('12664','2014-03-13','11:00:00',3.51),('12664','2014-03-13','11:05:00',3.52),('12664','2014-03-13','11:10:00',3.55),('12664','2014-03-13','11:15:00',3.56),('12664','2014-03-13','11:20:00',3.59),('12664','2014-03-13','11:25:00',3.6),('12664','2014-03-13','11:30:00',3.6),('12664','2014-03-13','11:35:00',3.61),('12664','2014-03-13','11:40:00',3.63),('12664','2014-03-13','11:45:00',3.64),('12664','2014-03-13','11:50:00',3.64),('12664','2014-03-13','11:55:00',3.65),('12664','2014-03-13','12:00:00',3.65),('12664','2014-03-13','12:05:00',3.68),('12664','2014-03-13','12:10:00',3.71),('12664','2014-03-13','12:15:00',3.7),('12664','2014-03-13','12:20:00',3.68),('12664','2014-03-13','12:25:00',3.65),('12664','2014-03-13','12:30:00',3.65),('12664','2014-03-13','12:35:00',3.64),('12664','2014-03-13','12:40:00',3.64),('12664','2014-03-13','12:45:00',3.66),('12664','2014-03-13','12:50:00',3.68),('12664','2014-03-13','12:55:00',3.66),('12664','2014-03-13','13:00:00',3.66),('12664','2014-03-13','13:05:00',3.65),('12664','2014-03-13','13:10:00',3.63),('12664','2014-03-13','13:15:00',3.61),('12664','2014-03-13','13:20:00',3.6),('12664','2014-03-13','13:25:00',3.58),('12664','2014-03-13','13:30:00',3.56),('12664','2014-03-13','13:35:00',3.52),('12664','2014-03-13','13:40:00',3.47),('12664','2014-03-13','13:45:00',3.43),('12664','2014-03-13','13:50:00',3.39),('12664','2014-03-13','13:55:00',3.36),('12664','2014-03-13','14:00:00',3.31),('12664','2014-03-13','14:05:00',3.25),('12664','2014-03-13','14:10:00',3.2),('12664','2014-03-13','14:15:00',3.16),('12664','2014-03-13','14:20:00',3.12),('12664','2014-03-13','14:25:00',3.08),('12664','2014-03-13','14:30:00',3.02),('12664','2014-03-13','14:35:00',2.94),('12664','2014-03-13','14:40:00',2.88),('12664','2014-03-13','14:45:00',2.81),('12664','2014-03-13','14:50:00',2.75),('12664','2014-03-13','14:55:00',2.67),('12664','2014-03-13','15:00:00',2.59),('12664','2014-03-13','15:05:00',2.49),('12664','2014-03-13','15:10:00',2.43),('12664','2014-03-13','15:15:00',2.34),('12664','2014-03-13','15:20:00',2.26),('12664','2014-03-13','15:25:00',2.18),('12664','2014-03-13','15:30:00',2.11),('12664','2014-03-13','15:35:00',2.03),('12664','2014-03-13','15:40:00',1.95),('12664','2014-03-13','15:45:00',1.87),('12664','2014-03-13','15:50:00',1.8),('12664','2014-03-13','15:55:00',1.71),('12664','2014-03-13','16:00:00',1.62),('12664','2014-03-13','16:05:00',1.53),('12664','2014-03-13','16:10:00',1.45),('12664','2014-03-13','16:15:00',1.36),('12664','2014-03-13','16:20:00',1.27),('12664','2014-03-13','16:25:00',1.21),('12664','2014-03-13','16:30:00',1.13),('12664','2014-03-13','16:35:00',1.03),('12664','2014-03-12','07:50:00',1.04),('12664','2014-03-12','07:55:00',1.13),('12664','2014-03-12','08:00:00',1.23),('12664','2014-03-12','08:05:00',1.32),('12664','2014-03-12','08:10:00',1.42),('12664','2014-03-12','08:15:00',1.52),('12664','2014-03-12','08:20:00',1.61),('12664','2014-03-12','08:25:00',1.71),('12664','2014-03-12','08:30:00',1.79),('12664','2014-03-12','08:35:00',1.89),('12664','2014-03-12','08:40:00',1.97),('12664','2014-03-12','08:45:00',2.06),('12664','2014-03-12','08:50:00',2.13),('12664','2014-03-12','08:55:00',2.21),('12664','2014-03-12','09:00:00',2.31),('12664','2014-03-12','09:05:00',2.38),('12664','2014-03-12','09:10:00',2.46),('12664','2014-03-12','09:15:00',2.54),('12664','2014-03-12','09:20:00',2.6),('12664','2014-03-12','09:25:00',2.67),('12664','2014-03-12','09:30:00',2.72),('12664','2014-03-12','09:35:00',2.77),('12664','2014-03-12','09:40:00',2.86),('12664','2014-03-12','09:45:00',2.92),('12664','2014-03-12','09:50:00',2.97),('12664','2014-03-12','09:55:00',3.02),('12664','2014-03-12','10:00:00',3.09),('12664','2014-03-12','10:05:00',3.11),('12664','2014-03-12','10:10:00',3.14),('12664','2014-03-12','10:15:00',3.21),('12664','2014-03-12','10:20:00',3.26),('12664','2014-03-12','10:25:00',3.3),('12664','2014-03-12','10:30:00',3.33),('12664','2014-03-12','10:35:00',3.36),('12664','2014-03-12','10:40:00',3.42),('12664','2014-03-12','10:45:00',3.46),('12664','2014-03-12','10:50:00',3.49),('12664','2014-03-12','10:55:00',3.51),('12664','2014-03-12','11:00:00',3.5),('12664','2014-03-12','11:05:00',3.53),('12664','2014-03-12','11:10:00',3.59),('12664','2014-03-12','11:15:00',3.62),('12664','2014-03-12','11:20:00',3.66),('12664','2014-03-12','11:25:00',3.67),('12664','2014-03-12','11:30:00',3.65),('12664','2014-03-12','11:35:00',3.65),('12664','2014-03-12','11:40:00',3.69),('12664','2014-03-12','11:45:00',3.71),('12664','2014-03-12','11:50:00',3.73),('12664','2014-03-12','11:55:00',3.7),('12664','2014-03-12','12:00:00',3.7),('12664','2014-03-12','12:05:00',3.69),('12664','2014-03-12','12:10:00',3.66),('12664','2014-03-12','12:15:00',3.7),('12664','2014-03-12','12:20:00',3.68),('12664','2014-03-12','12:25:00',3.67),('12664','2014-03-12','12:30:00',3.65),('12664','2014-03-12','12:35:00',3.66),('12664','2014-03-12','12:40:00',3.65),('12664','2014-03-12','12:45:00',3.64),('12664','2014-03-12','12:50:00',3.63),('12664','2014-03-12','12:55:00',3.63),('12664','2014-03-12','13:00:00',3.6),('12664','2014-03-12','13:05:00',3.57),('12664','2014-03-12','13:10:00',3.56),('12664','2014-03-12','13:15:00',3.54),('12664','2014-03-12','13:20:00',3.52),('12664','2014-03-12','13:25:00',3.52),('12664','2014-03-12','13:30:00',3.47),('12664','2014-03-12','13:35:00',3.45),('12664','2014-03-12','13:40:00',3.41),('12664','2014-03-12','13:45:00',3.4),('12664','2014-03-12','13:50:00',3.37),('12664','2014-03-12','13:55:00',3.31),('12664','2014-03-12','14:00:00',3.31),('12664','2014-03-12','14:05:00',3.27),('12664','2014-03-12','14:10:00',3.15),('12664','2014-03-12','14:15:00',3.11),('12664','2014-03-12','14:20:00',3.04),('12664','2014-03-12','14:25:00',3.02),('12664','2014-03-12','14:30:00',2.92),('12664','2014-03-12','14:35:00',2.88),('12664','2014-03-12','14:40:00',2.85),('12664','2014-03-12','14:45:00',2.81),('12664','2014-03-12','14:50:00',2.7),('12664','2014-03-12','14:55:00',2.7),('12664','2014-03-12','15:00:00',2.63),('12664','2014-03-12','15:05:00',2.53),('12664','2014-03-12','15:10:00',2.46),('12664','2014-03-12','15:15:00',2.38),('12664','2014-03-12','15:20:00',2.29),('12664','2014-03-12','15:25:00',2.21),('12664','2014-03-12','15:30:00',2.13),('12664','2014-03-12','15:35:00',2.06),('12664','2014-03-12','15:40:00',1.99),('12664','2014-03-12','15:45:00',1.92),('12664','2014-03-12','15:50:00',1.85),('12664','2014-03-12','15:55:00',1.76),('12664','2014-03-12','16:00:00',1.64),('12664','2014-03-12','16:05:00',1.56),('12664','2014-03-12','16:10:00',1.47),('12664','2014-03-12','16:15:00',1.37),('12664','2014-03-12','16:20:00',1.28),('12664','2014-03-12','16:25:00',1.19),('12664','2014-03-12','16:30:00',1.1),('12664','2014-03-12','16:35:00',1.02),('12664','2014-03-11','11:55:00',1.09),('12664','2014-03-11','12:00:00',1.26),('12664','2014-03-11','12:05:00',1.31),('12664','2014-03-11','12:10:00',1.4),('12664','2014-03-11','12:15:00',1.7),('12664','2014-03-11','12:20:00',1.87),('12664','2014-03-11','12:25:00',1.6),('12664','2014-03-11','12:30:00',1.47),('12664','2014-03-11','12:35:00',1.48),('12664','2014-03-11','12:40:00',1.33),('12664','2014-03-11','12:45:00',1.55),('12664','2014-03-11','12:50:00',1.58),('12664','2014-03-11','12:55:00',1.52),('12664','2014-03-11','13:00:00',1.96),('12664','2014-03-11','13:05:00',1.99),('12664','2014-03-11','13:10:00',2.49),('12664','2014-03-11','13:15:00',2.01),('12664','2014-03-11','13:20:00',1.45),('12664','2014-03-11','13:25:00',1.39),('12664','2014-03-11','13:30:00',1.2),('12664','2014-03-11','13:35:00',1.27),('12664','2014-03-11','13:40:00',1.31),('12664','2014-03-11','13:45:00',1.43),('12664','2014-03-11','13:50:00',1.73),('12664','2014-03-11','13:55:00',1.85),('12664','2014-03-11','14:00:00',2.03),('12664','2014-03-11','14:05:00',2.07),('12664','2014-03-11','14:10:00',1.88),('12664','2014-03-11','14:15:00',2.14),('12664','2014-03-11','14:20:00',1.94),('12664','2014-03-11','14:25:00',1.87),('12664','2014-03-11','14:30:00',1.92),('12664','2014-03-11','14:35:00',1.73),('12664','2014-03-11','14:40:00',1.61),('12664','2014-03-11','14:45:00',1.75),('12664','2014-03-11','14:50:00',1.46),('12664','2014-03-11','14:55:00',1.42),('12664','2014-03-11','15:00:00',1.61),('12664','2014-03-11','15:05:00',1.5),('12664','2014-03-11','15:10:00',1.45),('12664','2014-03-11','15:15:00',1.34),('12664','2014-03-11','15:20:00',1.09),('12664','2014-03-10','08:55:00',1.01),('12664','2014-03-10','09:00:00',1.06),('12664','2014-03-10','09:05:00',1.04),('12664','2014-03-10','09:35:00',1.05),('12664','2014-03-10','09:40:00',1.24),('12664','2014-03-10','09:45:00',1.47),('12664','2014-03-10','09:50:00',1.44),('12664','2014-03-10','09:55:00',1.2),('12664','2014-03-10','10:15:00',1.05),('12664','2014-03-10','10:20:00',1.14),('12664','2014-03-10','13:10:00',1.04),('12664','2014-03-10','13:15:00',1.08),('12664','2014-03-10','15:05:00',1.14),('12664','2014-03-10','15:10:00',2.93),('12664','2014-03-10','15:15:00',2.86),('12664','2014-03-10','15:20:00',2.64),('12664','2014-03-10','15:25:00',2.12),('12664','2014-03-10','15:30:00',2.1),('12664','2014-03-10','15:35:00',2.15),('12664','2014-03-10','15:40:00',1.48),('12664','2014-03-10','15:45:00',1.17),('12664','2014-03-09','07:55:00',1.07),('12664','2014-03-09','08:00:00',1.16),('12664','2014-03-09','08:05:00',1.25),('12664','2014-03-09','08:10:00',1.34),('12664','2014-03-09','08:15:00',1.43),('12664','2014-03-09','08:20:00',1.53),('12664','2014-03-09','08:25:00',1.61),('12664','2014-03-09','08:30:00',1.53),('12664','2014-03-09','08:35:00',1.82),('12664','2014-03-09','08:40:00',1.93),('12664','2014-03-09','08:45:00',2.03),('12664','2014-03-09','08:50:00',2.09),('12664','2014-03-09','08:55:00',2.15),('12664','2014-03-09','09:00:00',2.23),('12664','2014-03-09','09:05:00',2.33),('12664','2014-03-09','09:10:00',2.4),('12664','2014-03-09','09:15:00',2.48),('12664','2014-03-09','09:20:00',2.58),('12664','2014-03-09','09:25:00',2.67),('12664','2014-03-09','09:30:00',2.76),('12664','2014-03-09','09:35:00',2.88),('12664','2014-03-09','09:40:00',2.98),('12664','2014-03-09','09:45:00',3.11),('12664','2014-03-09','09:50:00',3.2),('12664','2014-03-09','09:55:00',3.25),('12664','2014-03-09','10:00:00',3.27),('12664','2014-03-09','10:05:00',3.31),('12664','2014-03-09','10:10:00',3.37),('12664','2014-03-09','10:15:00',3.41),('12664','2014-03-09','10:20:00',3.43),('12664','2014-03-09','10:25:00',3.51),('12664','2014-03-09','10:30:00',3.54),('12664','2014-03-09','10:35:00',3.59),('12664','2014-03-09','10:40:00',3.63),('12664','2014-03-09','10:45:00',3.69),('12664','2014-03-09','10:50:00',3.71),('12664','2014-03-09','10:55:00',3.72),('12664','2014-03-09','11:00:00',3.77),('12664','2014-03-09','11:05:00',2.98),('12664','2014-03-09','11:10:00',1.85),('12664','2014-03-09','11:15:00',1.29),('12664','2014-03-09','11:35:00',1.37),('12664','2014-03-09','11:40:00',4.35),('12664','2014-03-09','11:45:00',4.07),('12664','2014-03-09','11:50:00',1.26),('12664','2014-03-09','11:55:00',3.95),('12664','2014-03-09','12:00:00',1.56),('12664','2014-03-09','12:05:00',3.12),('12664','2014-03-09','12:10:00',2.56),('12664','2014-03-09','12:15:00',2.25),('12664','2014-03-09','12:20:00',3.81),('12664','2014-03-09','12:25:00',4.21),('12664','2014-03-09','12:30:00',4.11),('12664','2014-03-09','12:35:00',4.13),('12664','2014-03-09','12:40:00',4.05),('12664','2014-03-09','12:45:00',3.38),('12664','2014-03-09','12:50:00',1.46),('12664','2014-03-09','12:55:00',3.91),('12664','2014-03-09','13:00:00',3.92),('12664','2014-03-09','13:05:00',3.94),('12664','2014-03-09','13:10:00',3.99),('12664','2014-03-09','13:15:00',4.02),('12664','2014-03-09','13:20:00',4.2),('12664','2014-03-09','13:25:00',4.04),('12664','2014-03-09','13:30:00',3.89),('12664','2014-03-09','13:35:00',3.79),('12664','2014-03-09','13:40:00',3.54),('12664','2014-03-09','13:45:00',3.73),('12664','2014-03-09','13:50:00',1.94),('12664','2014-03-09','14:00:00',2.45),('12664','2014-03-09','14:05:00',3.55),('12664','2014-03-09','14:10:00',3.09),('12664','2014-03-09','14:15:00',2.98),('12664','2014-03-09','14:20:00',3.2),('12664','2014-03-09','14:25:00',3.07),('12664','2014-03-09','14:30:00',3.07),('12664','2014-03-09','14:35:00',2.88),('12664','2014-03-09','14:40:00',3.03),('12664','2014-03-09','14:45:00',2.29),('12664','2014-03-09','14:50:00',2.73),('12664','2014-03-09','14:55:00',2.77),('12664','2014-03-09','15:00:00',2.83),('12664','2014-03-09','15:05:00',2.59),('12664','2014-03-09','15:10:00',3),('12664','2014-03-09','15:15:00',2.95),('12664','2014-03-09','15:20:00',2.77),('12664','2014-03-09','15:25:00',1.59),('12664','2014-03-09','15:55:00',1.85),('12664','2014-03-09','16:00:00',1.01),('12664','2014-03-09','16:15:00',1.29),('12664','2014-03-09','16:20:00',1.43),('12664','2014-03-09','16:25:00',1.36),('12664','2014-03-09','16:30:00',1.24),('12664','2014-03-09','16:35:00',1.07),('12664','2014-03-08','07:55:00',1.06),('12664','2014-03-08','08:00:00',1.15),('12664','2014-03-08','08:05:00',1.25),('12664','2014-03-08','08:10:00',1.35),('12664','2014-03-08','08:15:00',1.44),('12664','2014-03-08','08:20:00',1.54),('12664','2014-03-08','08:25:00',1.64),('12664','2014-03-08','08:30:00',1.73),('12664','2014-03-08','08:35:00',1.81),('12664','2014-03-08','08:40:00',1.9),('12664','2014-03-08','08:45:00',1.98),('12664','2014-03-08','08:50:00',2.07),('12664','2014-03-08','08:55:00',2.15),('12664','2014-03-08','09:00:00',2.23),('12664','2014-03-08','09:05:00',2.31),('12664','2014-03-08','09:10:00',2.38),('12664','2014-03-08','09:15:00',2.44),('12664','2014-03-08','09:20:00',2.51),('12664','2014-03-08','09:25:00',2.57),('12664','2014-03-08','09:30:00',2.65),('12664','2014-03-08','09:35:00',2.71),('12664','2014-03-08','09:40:00',2.77),('12664','2014-03-08','09:45:00',2.84),('12664','2014-03-08','09:50:00',2.92),('12664','2014-03-08','09:55:00',2.99),('12664','2014-03-08','10:00:00',3.07),('12664','2014-03-08','10:05:00',3.12),('12664','2014-03-08','10:10:00',3.18),('12664','2014-03-08','10:15:00',3.22),('12664','2014-03-08','10:20:00',3.25),('12664','2014-03-08','10:25:00',3.3),('12664','2014-03-08','10:30:00',3.04),('12664','2014-03-08','10:35:00',3.11),('12664','2014-03-08','10:40:00',3.36),('12664','2014-03-08','10:45:00',3.56),('12664','2014-03-08','10:50:00',2.52),('12664','2014-03-08','10:55:00',3.62),('12664','2014-03-08','11:00:00',3.6),('12664','2014-03-08','11:05:00',3.62),('12664','2014-03-08','11:10:00',3.68),('12664','2014-03-08','11:15:00',3.8),('12664','2014-03-08','11:20:00',3.9),('12664','2014-03-08','11:25:00',3.27),('12664','2014-03-08','11:30:00',3.69),('12664','2014-03-08','11:35:00',4.47),('12664','2014-03-08','11:40:00',4.67),('12664','2014-03-08','11:45:00',3.36),('12664','2014-03-08','11:50:00',4.62),('12664','2014-03-08','11:55:00',4.85),('12664','2014-03-08','12:00:00',4.63),('12664','2014-03-08','12:05:00',4.73),('12664','2014-03-08','12:10:00',3.92),('12664','2014-03-08','12:15:00',4.07),('12664','2014-03-08','12:20:00',3.06),('12664','2014-03-08','12:25:00',2.46),('12664','2014-03-08','12:30:00',1.95),('12664','2014-03-08','12:35:00',1.76),('12664','2014-03-08','12:40:00',1.67),('12664','2014-03-08','12:45:00',1.67),('12664','2014-03-08','12:50:00',1.57),('12664','2014-03-08','12:55:00',1.44),('12664','2014-03-08','13:00:00',1.46),('12664','2014-03-08','13:05:00',1.94),('12664','2014-03-08','13:10:00',2.04),('12664','2014-03-08','13:15:00',1.51),('12664','2014-03-08','13:20:00',1.31),('12664','2014-03-08','13:25:00',1.06),('12664','2014-03-08','13:40:00',1.09),('12664','2014-03-08','13:45:00',1.47),('12664','2014-03-08','13:50:00',1.43),('12664','2014-03-08','13:55:00',1.7),('12664','2014-03-08','14:00:00',1.45),('12664','2014-03-08','14:05:00',1.24),('12664','2014-03-08','14:10:00',1.03),('12664','2014-03-08','15:25:00',1.28),('12664','2014-03-08','15:30:00',1.17),('12664','2014-03-07','10:05:00',1.96),('12664','2014-03-07','10:10:00',2.46),('12664','2014-03-07','10:15:00',2.93),('12664','2014-03-07','10:20:00',3.93),('12664','2014-03-07','10:25:00',3.53),('12664','2014-03-07','10:30:00',3.73),('12664','2014-03-07','10:35:00',3.99),('12664','2014-03-07','10:40:00',1.79),('12664','2014-03-07','10:45:00',3.6),('12664','2014-03-07','10:50:00',4.28),('12664','2014-03-07','10:55:00',4.25),('12664','2014-03-07','11:00:00',4.26),('12664','2014-03-07','11:05:00',2.67),('12664','2014-03-07','11:10:00',3.76),('12664','2014-03-07','11:15:00',4.07),('12664','2014-03-07','11:20:00',4.32),('12664','2014-03-07','11:25:00',4.21),('12664','2014-03-07','11:30:00',4.2),('12664','2014-03-07','11:35:00',4.34),('12664','2014-03-07','11:40:00',4.37),('12664','2014-03-07','11:45:00',3.03),('12664','2014-03-07','11:50:00',3.36),('12664','2014-03-07','11:55:00',3.9),('12664','2014-03-07','12:00:00',3.07),('12664','2014-03-07','12:05:00',2.41),('12664','2014-03-07','12:10:00',4.11),('12664','2014-03-07','12:15:00',3.95),('12664','2014-03-07','12:20:00',3.87),('12664','2014-03-07','12:25:00',3.95),('12664','2014-03-07','12:30:00',4.05),('12664','2014-03-07','12:35:00',4.04),('12664','2014-03-07','12:40:00',4.02),('12664','2014-03-07','12:45:00',3.97),('12664','2014-03-07','12:50:00',3.94),('12664','2014-03-07','12:55:00',3),('12664','2014-03-07','13:00:00',1.01),('12664','2014-03-07','13:05:00',1.29),('12664','2014-03-07','13:10:00',2.11),('12664','2014-03-07','13:15:00',2.52),('12664','2014-03-07','13:20:00',2.87),('12664','2014-03-07','13:25:00',1.61),('12664','2014-03-07','13:30:00',1.69),('12664','2014-03-07','13:35:00',1.94),('12664','2014-03-07','13:40:00',1.89),('12664','2014-03-07','13:45:00',1.91),('12664','2014-03-07','13:50:00',1.73),('12664','2014-03-07','13:55:00',1.46),('12664','2014-03-07','14:00:00',1.28),('12664','2014-03-07','14:05:00',1.21),('12664','2014-03-07','14:10:00',1.16),('12664','2014-03-07','14:15:00',1.12),('12664','2014-03-07','14:20:00',1.15),('12664','2014-03-07','14:25:00',1.24),('12664','2014-03-07','14:30:00',1.38),('12664','2014-03-07','14:35:00',1.5),('12664','2014-03-07','14:40:00',1.55),('12664','2014-03-07','14:45:00',1.69),('12664','2014-03-07','14:50:00',1.98),('12664','2014-03-07','14:55:00',2.02),('12664','2014-03-07','15:00:00',2.42),('12664','2014-03-07','15:05:00',2.76),('12664','2014-03-07','15:10:00',3.01),('12664','2014-03-07','15:15:00',2.76),('12664','2014-03-07','15:20:00',2.38),('12664','2014-03-07','15:25:00',2.02),('12664','2014-03-07','15:30:00',2.13),('12664','2014-03-07','15:35:00',1.37),('12664','2014-03-07','16:05:00',1.76),('12664','2014-03-07','16:10:00',1.08),('12664','2014-03-07','16:35:00',1.1),('12664','2014-03-07','16:40:00',1.04),('12664','2014-04-29','09:45:00',1.39),('12664','2014-04-29','09:50:00',2.62),('12664','2014-04-29','09:55:00',3.19),('12664','2014-04-29','10:00:00',3.62),('12664','2014-04-29','10:05:00',3.64),('12664','2014-04-29','10:10:00',3.63),('12664','2014-04-29','10:15:00',3.74),('12664','2014-04-29','10:20:00',3.71),('12664','2014-04-29','10:25:00',3.6),('12664','2014-04-29','10:30:00',3.61),('12664','2014-04-29','10:35:00',3.77),('12664','2014-04-29','10:40:00',3.56),('12664','2014-04-29','10:45:00',3.76),('12664','2014-04-29','10:50:00',3.91),('12664','2014-04-29','10:55:00',3.87),('12664','2014-04-29','11:00:00',3.95),('12664','2014-04-29','11:05:00',3.98),('12664','2014-04-29','11:10:00',4.02),('12664','2014-04-29','11:15:00',4.08),('12664','2014-04-29','11:20:00',4.13),('12664','2014-04-29','11:25:00',4.3),('12664','2014-04-29','11:30:00',3.93),('12664','2014-04-29','11:35:00',1.54),('12664','2014-04-29','11:40:00',1.27),('12664','2014-04-29','11:50:00',1.03),('12664','2014-04-29','11:55:00',1.07),('12664','2014-04-29','12:00:00',1.39),('12664','2014-04-29','12:05:00',2.36),('12664','2014-04-29','12:10:00',4.67),('12664','2014-04-29','12:15:00',4.56),('12664','2014-04-29','12:20:00',4.71),('12664','2014-04-29','12:25:00',4.64),('12664','2014-04-29','12:30:00',4.8),('12664','2014-04-29','12:35:00',4.79),('12664','2014-04-29','12:40:00',2.91),('12664','2014-04-29','12:45:00',2.89),('12664','2014-04-29','12:50:00',2.77),('12664','2014-04-29','12:55:00',1.37),('12664','2014-04-29','13:00:00',1.23),('12664','2014-04-29','13:05:00',1.38),('12664','2014-04-29','13:10:00',2.42),('12664','2014-04-29','13:15:00',3.88),('12664','2014-04-29','13:20:00',2.16),('12664','2014-04-29','13:25:00',4.42),('12664','2014-04-29','13:30:00',2.02),('12664','2014-04-29','13:35:00',1.46),('12664','2014-04-29','13:40:00',1.76),('12664','2014-04-29','13:45:00',4.66),('12664','2014-04-29','13:50:00',4.92),('12664','2014-04-29','13:55:00',3.22),('12664','2014-04-29','14:00:00',1.66),('12664','2014-04-29','14:05:00',1.51),('12664','2014-04-29','14:10:00',1.09),('12664','2014-04-29','14:15:00',1.01),('12664','2014-04-29','14:20:00',1.52),('12664','2014-04-29','14:25:00',1.81),('12664','2014-04-29','14:30:00',1.52),('12664','2014-04-29','14:35:00',1.19),('12664','2014-04-29','14:40:00',1.35),('12664','2014-04-29','14:45:00',1.66),('12664','2014-04-29','14:50:00',1.88),('12664','2014-04-29','14:55:00',2.85),('12664','2014-04-29','15:00:00',2.64),('12664','2014-04-29','15:05:00',3.27),('12664','2014-04-29','15:10:00',4.28),('12664','2014-04-29','15:15:00',3.34),('12664','2014-04-29','15:20:00',1.95),('12664','2014-04-29','15:25:00',1.42),('12664','2014-04-29','15:30:00',1.61),('12664','2014-04-29','15:35:00',1.76),('12664','2014-04-29','15:40:00',2.11),('12664','2014-04-29','15:45:00',2.45),('12664','2014-04-29','15:50:00',2.14),('12664','2014-04-29','15:55:00',1.16),('12664','2014-04-29','16:30:00',1.17),('12664','2014-04-29','16:35:00',1.01),('12664','2014-04-29','17:00:00',1.02),('12664','2014-04-29','17:05:00',1.76),('12664','2014-04-29','17:10:00',2.28),('12664','2014-04-29','17:15:00',2.32),('12664','2014-04-29','17:20:00',2.25),('12664','2014-04-29','17:25:00',1.75),('12664','2014-04-29','17:45:00',1.08),('12664','2014-03-06','08:45:00',1.01),('12664','2014-03-06','08:50:00',1.02),('12664','2014-03-06','09:05:00',1.21),('12664','2014-03-06','09:10:00',2.6),('12664','2014-03-06','09:15:00',2.12),('12664','2014-03-06','09:20:00',2.93),('12664','2014-03-06','09:25:00',2.44),('12664','2014-03-06','09:30:00',2.53),('12664','2014-03-06','09:35:00',2.14),('12664','2014-03-06','09:40:00',1.72),('12664','2014-03-06','09:45:00',1.77),('12664','2014-03-06','09:50:00',2.01),('12664','2014-03-06','09:55:00',2.3),('12664','2014-03-06','10:00:00',2.51),('12664','2014-03-06','10:05:00',2.62),('12664','2014-03-06','10:10:00',2.52),('12664','2014-03-06','10:15:00',2.62),('12664','2014-03-06','10:20:00',2.83),('12664','2014-03-06','10:25:00',3.37),('12664','2014-03-06','10:30:00',3.45),('12664','2014-03-06','10:35:00',2.22),('12664','2014-03-06','10:40:00',3.36),('12664','2014-03-06','10:45:00',2.31),('12664','2014-03-06','10:50:00',2.05),('12664','2014-03-06','10:55:00',3.79),('12664','2014-03-06','11:00:00',4.07),('12664','2014-03-06','11:05:00',4.29),('12664','2014-03-06','11:10:00',3.74),('12664','2014-03-06','11:15:00',4.04),('12664','2014-03-06','11:20:00',3.97),('12664','2014-03-06','11:25:00',3.99),('12664','2014-03-06','11:30:00',4.4),('12664','2014-03-06','11:35:00',4.22),('12664','2014-03-06','11:40:00',2.37),('12664','2014-03-06','11:45:00',2.86),('12664','2014-03-06','11:50:00',4.22),('12664','2014-03-06','11:55:00',2.96),('12664','2014-03-06','12:00:00',3.69),('12664','2014-03-06','12:05:00',2.15),('12664','2014-03-06','12:10:00',3.36),('12664','2014-03-06','12:15:00',3.6),('12664','2014-03-06','12:20:00',2.28),('12664','2014-03-06','12:30:00',1.13),('12664','2014-03-06','12:35:00',1.02),('12664','2014-03-06','12:40:00',3.51),('12664','2014-03-06','12:45:00',3.08),('12664','2014-03-06','12:50:00',2.14),('12664','2014-03-06','12:55:00',1.64),('12664','2014-03-06','13:00:00',1.52),('12664','2014-03-06','13:05:00',1.51),('12664','2014-03-06','13:10:00',1.39),('12664','2014-03-06','13:15:00',1.4),('12664','2014-03-06','13:20:00',1.51),('12664','2014-03-06','13:25:00',3.22),('12664','2014-03-06','13:30:00',2.44),('12664','2014-03-06','13:35:00',1.15),('12664','2014-03-06','13:45:00',1.03),('12664','2014-03-06','13:50:00',1.18),('12664','2014-03-06','13:55:00',1.12),('12664','2014-03-06','14:00:00',1.17),('12664','2014-03-06','14:05:00',1.29),('12664','2014-03-06','14:10:00',1.23),('12664','2014-03-06','14:15:00',1.25),('12664','2014-03-06','14:20:00',1.61),('12664','2014-03-06','14:25:00',1.33),('12664','2014-03-06','14:30:00',1.3),('12664','2014-03-06','14:35:00',1.17),('12664','2014-03-06','15:00:00',1.11),('12664','2014-03-06','15:05:00',1.17),('12664','2014-03-06','15:10:00',1.27),('12664','2014-03-06','15:15:00',1.47),('12664','2014-03-06','15:20:00',1.23),('12664','2014-03-06','15:25:00',1.17),('12664','2014-03-06','15:30:00',1.05),('12664','2014-03-06','16:45:00',1.04),('12664','2014-03-06','16:50:00',1.11),('12664','2014-03-05','07:55:00',1.29),('12664','2014-03-05','08:00:00',1.41),('12664','2014-03-05','08:05:00',1.51),('12664','2014-03-05','08:10:00',1.58),('12664','2014-03-05','08:15:00',1.7),('12664','2014-03-05','08:20:00',1.18),('12664','2014-03-05','08:25:00',1.85),('12664','2014-03-05','08:30:00',1.99),('12664','2014-03-05','08:35:00',1.11),('12664','2014-03-05','08:40:00',1.03),('12664','2014-03-05','08:45:00',1.93),('12664','2014-03-05','08:50:00',2.63),('12664','2014-03-05','08:55:00',2.53),('12664','2014-03-05','09:00:00',2.5),('12664','2014-03-05','09:05:00',2.43),('12664','2014-03-05','09:10:00',2.45),('12664','2014-03-05','09:15:00',2.51),('12664','2014-03-05','09:20:00',2.56),('12664','2014-03-05','09:25:00',2.62),('12664','2014-03-05','09:30:00',2.67),('12664','2014-03-05','09:35:00',2.74),('12664','2014-03-05','09:40:00',2.81),('12664','2014-03-05','09:45:00',2.89),('12664','2014-03-05','09:50:00',2.96),('12664','2014-03-05','09:55:00',2.98),('12664','2014-03-05','10:00:00',3.01),('12664','2014-03-05','10:05:00',3.08),('12664','2014-03-05','10:10:00',3.14),('12664','2014-03-05','10:15:00',3.23),('12664','2014-03-05','10:20:00',3.27),('12664','2014-03-05','10:25:00',3.29),('12664','2014-03-05','10:30:00',3.33),('12664','2014-03-05','10:35:00',3.42),('12664','2014-03-05','10:40:00',3.43),('12664','2014-03-05','10:45:00',3.48),('12664','2014-03-05','10:50:00',3.51),('12664','2014-03-05','10:55:00',3.54),('12664','2014-03-05','11:00:00',3.55),('12664','2014-03-05','11:05:00',3.6),('12664','2014-03-05','11:10:00',3.72),('12664','2014-03-05','11:15:00',3.79),('12664','2014-03-05','11:20:00',3.79),('12664','2014-03-05','11:25:00',3.82),('12664','2014-03-05','11:30:00',3.88),('12664','2014-03-05','11:35:00',3.93),('12664','2014-03-05','11:40:00',4.17),('12664','2014-03-05','11:45:00',3.78),('12664','2014-03-05','11:50:00',3.82),('12664','2014-03-05','11:55:00',3.93),('12664','2014-03-05','12:00:00',3.43),('12664','2014-03-05','12:05:00',3.32),('12664','2014-03-05','12:10:00',2.26),('12664','2014-03-05','12:15:00',3.53),('12664','2014-03-05','12:20:00',3.94),('12664','2014-03-05','12:25:00',4),('12664','2014-03-05','12:30:00',3.58),('12664','2014-03-05','12:35:00',3.91),('12664','2014-03-05','12:40:00',3.87),('12664','2014-03-05','12:45:00',3.72),('12664','2014-03-05','12:50:00',2.45),('12664','2014-03-05','12:55:00',2.17),('12664','2014-03-05','13:00:00',2.38),('12664','2014-03-05','13:05:00',2.22),('12664','2014-03-05','13:10:00',1.8),('12664','2014-03-05','13:15:00',3.69),('12664','2014-03-05','13:20:00',4),('12664','2014-03-05','13:25:00',3.96),('12664','2014-03-05','13:30:00',3.76),('12664','2014-03-05','13:35:00',4.25),('12664','2014-03-05','13:40:00',4.61),('12664','2014-03-05','13:45:00',4.63),('12664','2014-03-05','13:50:00',3.25),('12664','2014-03-05','13:55:00',2.19),('12664','2014-03-05','14:00:00',1.09),('12664','2014-03-05','14:10:00',2.51),('12664','2014-03-05','14:15:00',2.32),('12664','2014-03-05','14:20:00',1.46),('12664','2014-03-05','14:25:00',1.48),('12664','2014-03-05','14:30:00',1.45),('12664','2014-03-05','14:35:00',1.59),('12664','2014-03-05','14:40:00',1.52),('12664','2014-03-05','14:45:00',1.97),('12664','2014-03-05','14:50:00',2.23),('12664','2014-03-05','14:55:00',3.32),('12664','2014-03-05','15:00:00',2.72),('12664','2014-03-05','15:05:00',1.77),('12664','2014-03-05','15:30:00',1.01),('12664','2014-03-05','15:50:00',1.4),('12664','2014-03-05','15:55:00',2.75),('12664','2014-03-05','16:00:00',2.31),('12664','2014-03-05','16:05:00',1.37),('12664','2014-03-04','09:05:00',1.76),('12664','2014-03-04','09:55:00',1.64),('12664','2014-03-04','10:00:00',2.82),('12664','2014-03-04','10:05:00',2.05),('12664','2014-03-04','10:30:00',1.49),('12664','2014-03-04','10:35:00',1.3),('12664','2014-03-04','10:40:00',1.17),('12664','2014-03-04','10:45:00',2.72),('12664','2014-03-04','10:50:00',4.75),('12664','2014-03-04','10:55:00',2.57),('12664','2014-03-04','11:00:00',1.3),('12664','2014-03-04','11:20:00',1.18),('12664','2014-03-04','11:25:00',3.02),('12664','2014-03-04','11:30:00',2.47),('12664','2014-03-04','11:35:00',1.43),('12664','2014-03-04','11:40:00',3.75),('12664','2014-03-04','11:45:00',4.17),('12664','2014-03-04','11:50:00',4.15),('12664','2014-03-04','11:55:00',1.44),('12664','2014-03-04','12:00:00',4.09),('12664','2014-03-04','12:05:00',3.49),('12664','2014-03-04','12:10:00',4.08),('12664','2014-03-04','12:15:00',3.2),('12664','2014-03-04','12:20:00',2.67),('12664','2014-03-04','12:25:00',3.26),('12664','2014-03-04','12:30:00',3.9),('12664','2014-03-04','12:35:00',3.86),('12664','2014-03-04','12:40:00',3.71),('12664','2014-03-04','12:45:00',3.87),('12664','2014-03-04','12:50:00',3.85),('12664','2014-03-04','12:55:00',3.85),('12664','2014-03-04','13:00:00',3.72),('12664','2014-03-04','13:05:00',3.95),('12664','2014-03-04','13:10:00',3.56),('12664','2014-03-04','13:15:00',1.48),('12664','2014-03-04','13:20:00',1.24),('12664','2014-03-04','13:45:00',1.86),('12664','2014-03-04','13:50:00',3.62),('12664','2014-03-04','13:55:00',2.88),('12664','2014-03-04','14:00:00',3.5),('12664','2014-03-04','14:05:00',3.69),('12664','2014-03-04','14:10:00',3.75),('12664','2014-03-04','14:15:00',3.46),('12664','2014-03-04','14:20:00',2.53),('12664','2014-03-04','14:25:00',3.59),('12664','2014-03-04','14:30:00',3.23),('12664','2014-03-04','14:35:00',3.17),('12664','2014-03-04','14:40:00',3.06),('12664','2014-03-04','14:45:00',2.82),('12664','2014-03-04','14:50:00',2.75),('12664','2014-03-04','14:55:00',2.92),('12664','2014-03-04','15:00:00',2.78),('12664','2014-03-04','15:05:00',2.72),('12664','2014-03-04','15:10:00',2.6),('12664','2014-03-04','15:15:00',2.5),('12664','2014-03-04','15:20:00',2.47),('12664','2014-03-04','15:25:00',2.5),('12664','2014-03-04','15:30:00',2.06),('12664','2014-03-04','15:35:00',1.23),('12664','2014-03-04','15:40:00',1.65),('12664','2014-03-04','15:45:00',1.17),('12664','2014-03-04','16:00:00',1.37),('12664','2014-03-04','16:05:00',1.02),('12664','2014-03-04','16:25:00',1.61),('12664','2014-03-04','16:30:00',1.2),('12664','2014-03-04','16:40:00',1.01),('12664','2014-03-03','07:55:00',1.03),('12664','2014-03-03','08:00:00',1.16),('12664','2014-03-03','08:05:00',1.25),('12664','2014-03-03','08:10:00',1.37),('12664','2014-03-03','08:15:00',1.46),('12664','2014-03-03','08:20:00',1.54),('12664','2014-03-03','08:25:00',1.63),('12664','2014-03-03','08:30:00',1.72),('12664','2014-03-03','08:35:00',1.82),('12664','2014-03-03','08:40:00',1.92),('12664','2014-03-03','08:45:00',1.98),('12664','2014-03-03','08:50:00',1.9),('12664','2014-03-03','08:55:00',1.94),('12664','2014-03-03','09:00:00',1.63),('12664','2014-03-03','09:05:00',2.42),('12664','2014-03-03','09:10:00',2.49),('12664','2014-03-03','09:15:00',2.51),('12664','2014-03-03','09:20:00',2.47),('12664','2014-03-03','09:25:00',2.54),('12664','2014-03-03','09:30:00',2.67),('12664','2014-03-03','09:35:00',2.61),('12664','2014-03-03','09:40:00',2.51),('12664','2014-03-03','09:45:00',2.72),('12664','2014-03-03','09:50:00',2.86),('12664','2014-03-03','09:55:00',2.85),('12664','2014-03-03','10:00:00',2.99),('12664','2014-03-03','10:05:00',3.08),('12664','2014-03-03','10:10:00',3.11),('12664','2014-03-03','10:15:00',3.14),('12664','2014-03-03','10:20:00',3.19),('12664','2014-03-03','10:25:00',3.26),('12664','2014-03-03','10:30:00',3.29),('12664','2014-03-03','10:35:00',3.33),('12664','2014-03-03','10:40:00',3.38),('12664','2014-03-03','10:45:00',3.39),('12664','2014-03-03','10:50:00',3.41),('12664','2014-03-03','10:55:00',3.47),('12664','2014-03-03','11:00:00',3.48),('12664','2014-03-03','11:05:00',3.54),('12664','2014-03-03','11:10:00',3.55),('12664','2014-03-03','11:15:00',3.6),('12664','2014-03-03','11:20:00',3.66),('12664','2014-03-03','11:25:00',3.7),('12664','2014-03-03','11:30:00',3.76),('12664','2014-03-03','11:35:00',3.78),('12664','2014-03-03','11:40:00',3.8),('12664','2014-03-03','11:45:00',3.83),('12664','2014-03-03','11:50:00',3.84),('12664','2014-03-03','11:55:00',3.85),('12664','2014-03-03','12:00:00',3.85),('12664','2014-03-03','12:05:00',3.83),('12664','2014-03-03','12:10:00',3.85),('12664','2014-03-03','12:15:00',3.85),('12664','2014-03-03','12:20:00',3.86),('12664','2014-03-03','12:25:00',3.85),('12664','2014-03-03','12:30:00',3.85),('12664','2014-03-03','12:35:00',3.85),('12664','2014-03-03','12:40:00',3.84),('12664','2014-03-03','12:45:00',3.82),('12664','2014-03-03','12:50:00',3.79),('12664','2014-03-03','12:55:00',3.78),('12664','2014-03-03','13:00:00',3.77),('12664','2014-03-03','13:05:00',3.76),('12664','2014-03-03','13:10:00',3.74),('12664','2014-03-03','13:15:00',3.73),('12664','2014-03-03','13:20:00',3.72),('12664','2014-03-03','13:25:00',3.7),('12664','2014-03-03','13:30:00',3.69),('12664','2014-03-03','13:35:00',3.59),('12664','2014-03-03','13:40:00',3.22),('12664','2014-03-03','13:45:00',3.65),('12664','2014-03-03','13:50:00',3.59),('12664','2014-03-03','13:55:00',3.52),('12664','2014-03-03','14:00:00',3.17),('12664','2014-03-03','14:05:00',3.43),('12664','2014-03-03','14:10:00',3.39),('12664','2014-03-03','14:15:00',3.32),('12664','2014-03-03','14:20:00',3.03),('12664','2014-03-03','14:25:00',3.14),('12664','2014-03-03','14:30:00',3.14),('12664','2014-03-03','14:35:00',3.1),('12664','2014-03-03','14:40:00',3.02),('12664','2014-03-03','14:45:00',2.92),('12664','2014-03-03','14:50:00',2.88),('12664','2014-03-03','14:55:00',2.84),('12664','2014-03-03','15:00:00',2.63),('12664','2014-03-03','15:05:00',2.5),('12664','2014-03-03','15:10:00',2.57),('12664','2014-03-03','15:15:00',2.57),('12664','2014-03-03','15:20:00',2.53),('12664','2014-03-03','15:25:00',2.43),('12664','2014-03-03','15:30:00',2.08),('12664','2014-03-03','15:35:00',2.25),('12664','2014-03-03','15:40:00',1.66),('12664','2014-03-03','15:45:00',1.31),('12664','2014-03-03','15:50:00',1.82),('12664','2014-03-03','15:55:00',1.88),('12664','2014-03-03','16:00:00',1.75),('12664','2014-03-03','16:05:00',1.66),('12664','2014-03-03','16:10:00',1.58),('12664','2014-03-03','16:15:00',1.48),('12664','2014-03-03','16:20:00',1.38),('12664','2014-03-03','16:25:00',1.28),('12664','2014-03-03','16:30:00',1.19),('12664','2014-03-03','16:35:00',1.08),('12664','2014-03-02','08:15:00',1.06),('12664','2014-03-02','08:30:00',1.65),('12664','2014-03-02','08:35:00',1.85),('12664','2014-03-02','08:40:00',1.94),('12664','2014-03-02','08:45:00',2.04),('12664','2014-03-02','08:50:00',2.11),('12664','2014-03-02','08:55:00',2.22),('12664','2014-03-02','09:00:00',2.35),('12664','2014-03-02','09:05:00',2.48),('12664','2014-03-02','09:10:00',2.21),('12664','2014-03-02','09:15:00',2.75),('12664','2014-03-02','09:20:00',2.61),('12664','2014-03-02','09:25:00',2.34),('12664','2014-03-02','09:30:00',1.63),('12664','2014-03-02','09:35:00',2.74),('12664','2014-03-02','09:40:00',1.11),('12664','2014-03-02','10:15:00',1.34),('12664','2014-03-02','10:20:00',1.36),('12664','2014-03-02','10:25:00',2.23),('12664','2014-03-02','10:30:00',3.94),('12664','2014-03-02','10:35:00',3.85),('12664','2014-03-02','10:40:00',3.53),('12664','2014-03-02','10:45:00',3.37),('12664','2014-03-02','10:50:00',3.81),('12664','2014-03-02','10:55:00',1.58),('12664','2014-03-02','11:00:00',1.22),('12664','2014-03-02','11:05:00',1.54),('12664','2014-03-02','11:10:00',1.74),('12664','2014-03-02','11:15:00',1.84),('12664','2014-03-02','11:20:00',2.26),('12664','2014-03-02','11:25:00',1.88),('12664','2014-03-02','11:30:00',1.58),('12664','2014-03-02','11:35:00',1.64),('12664','2014-03-02','11:40:00',1.99),('12664','2014-03-02','11:45:00',3.03),('12664','2014-03-02','11:50:00',3.91),('12664','2014-03-02','11:55:00',3.62),('12664','2014-03-02','12:00:00',3.14),('12664','2014-03-02','12:05:00',2.54),('12664','2014-03-02','12:10:00',2.62),('12664','2014-03-02','12:15:00',1.23),('12664','2014-03-02','15:10:00',1),('12664','2014-03-02','15:15:00',1.02),('12664','2014-03-02','15:20:00',1.04),('12664','2014-03-02','15:25:00',1.09),('12664','2014-03-02','15:30:00',1.05),('12664','2014-03-02','15:35:00',1.03),('12664','2014-03-02','15:40:00',1.13),('12664','2014-03-02','15:45:00',1.18),('12664','2014-03-02','15:50:00',1.23),('12664','2014-03-02','15:55:00',1.23),('12664','2014-03-02','16:00:00',1),('12664','2014-02-28','07:50:00',1.18),('12664','2014-02-28','07:55:00',1.11),('12664','2014-02-28','09:05:00',1.71),('12664','2014-02-28','09:10:00',1.38),('12664','2014-02-28','09:15:00',2.17),('12664','2014-02-28','09:20:00',2.32),('12664','2014-02-28','09:25:00',2.44),('12664','2014-02-28','09:30:00',2.9),('12664','2014-02-28','09:35:00',3.23),('12664','2014-02-28','09:40:00',1.92),('12664','2014-02-28','09:45:00',1.24),('12664','2014-02-28','09:50:00',1.13),('12664','2014-02-28','09:55:00',1.26),('12664','2014-02-28','10:00:00',1.15),('12664','2014-02-28','10:05:00',1.06),('12664','2014-02-28','10:10:00',1.23),('12664','2014-02-28','10:15:00',2.81),('12664','2014-02-28','10:20:00',3.41),('12664','2014-02-28','10:25:00',3.38),('12664','2014-02-28','10:30:00',1.94),('12664','2014-02-28','10:35:00',1.43),('12664','2014-02-28','10:40:00',1.12),('12664','2014-02-28','10:45:00',1.06),('12664','2014-02-28','11:00:00',1.19),('12664','2014-02-28','11:05:00',1.1),('12664','2014-02-28','11:10:00',1.16),('12664','2014-02-28','11:15:00',1.2),('12664','2014-02-28','11:50:00',1.15),('12664','2014-02-28','11:55:00',1.03),('12664','2014-02-28','12:20:00',3.2),('12664','2014-02-28','12:25:00',4.24),('12664','2014-02-28','12:30:00',4.18),('12664','2014-02-28','12:35:00',3.47),('12664','2014-02-28','12:40:00',1.42),('12664','2014-02-28','12:45:00',1.03),('12664','2014-02-28','12:50:00',1.31),('12664','2014-02-28','12:55:00',1.36),('12664','2014-02-28','13:35:00',1.03),('12664','2014-02-28','13:40:00',1.05),('12664','2014-02-28','13:45:00',1.17),('12664','2014-02-28','13:50:00',1.19),('12664','2014-02-28','14:10:00',1.27),('12664','2014-02-28','14:15:00',2.48),('12664','2014-02-28','14:20:00',1.51),('12664','2014-02-28','15:30:00',2.74),('12664','2014-02-28','15:35:00',1.72),('12664','2014-02-27','10:35:00',1.09),('12664','2014-02-27','10:40:00',1.24),('12664','2014-02-27','10:45:00',1.14),('12664','2014-02-27','10:50:00',1.06),('12664','2014-02-27','10:55:00',1.19),('12664','2014-02-27','11:00:00',1.27),('12664','2014-02-27','11:05:00',1.3),('12664','2014-02-27','11:10:00',1.27),('12664','2014-02-27','11:15:00',1.26),('12664','2014-02-27','11:20:00',1.3),('12664','2014-02-27','11:25:00',1.37),('12664','2014-02-27','11:30:00',1.26),('12664','2014-02-27','11:35:00',1.12),('12664','2014-02-27','11:40:00',1.09),('12664','2014-02-27','11:45:00',1.1),('12664','2014-02-27','11:50:00',1.11),('12664','2014-02-27','11:55:00',1.03),('12664','2014-02-27','12:00:00',1.21),('12664','2014-02-27','12:05:00',1.23),('12664','2014-02-27','12:10:00',1.28),('12664','2014-02-27','12:15:00',1.28),('12664','2014-02-27','12:20:00',1.24),('12664','2014-02-27','12:25:00',1.23),('12664','2014-02-27','12:30:00',1.21),('12664','2014-02-27','12:35:00',1.2),('12664','2014-02-27','12:40:00',1.23),('12664','2014-02-27','12:45:00',1.24),('12664','2014-02-27','12:50:00',1.21),('12664','2014-02-27','12:55:00',1.21),('12664','2014-02-27','13:00:00',1.21),('12664','2014-02-27','13:05:00',1.08),('12664','2014-02-27','13:10:00',1.19),('12664','2014-02-27','13:15:00',1.39),('12664','2014-02-27','13:20:00',1.48),('12664','2014-02-27','13:25:00',1.54),('12664','2014-02-27','13:30:00',1.57),('12664','2014-02-27','13:35:00',1.52),('12664','2014-02-27','13:40:00',1.47),('12664','2014-02-27','13:45:00',1.49),('12664','2014-02-27','13:50:00',1.61),('12664','2014-02-27','13:55:00',1.34),('12664','2014-02-27','14:00:00',1.32),('12664','2014-02-27','14:05:00',1.79),('12664','2014-02-27','14:10:00',1.51),('12664','2014-02-27','14:15:00',1.52),('12664','2014-02-27','14:20:00',1.5),('12664','2014-02-27','14:25:00',1.28),('12664','2014-02-27','14:30:00',1.19),('12664','2014-02-27','14:35:00',1.19),('12664','2014-02-27','14:40:00',1.51),('12664','2014-02-27','14:45:00',1.52),('12664','2014-02-27','14:50:00',1.39),('12664','2014-02-27','14:55:00',1.3),('12664','2014-02-27','15:00:00',1.16),('12664','2014-02-27','15:05:00',1.53),('12664','2014-02-27','15:10:00',1.5),('12664','2014-02-27','15:15:00',1.25),('12664','2014-02-27','15:20:00',1.72),('12664','2014-02-27','15:25:00',1.76),('12664','2014-02-27','15:30:00',1.15),('12664','2014-02-27','16:40:00',1.12),('12664','2014-02-27','16:45:00',1.13),('12664','2014-02-26','08:05:00',1.08),('12664','2014-02-26','08:10:00',1.17),('12664','2014-02-26','08:15:00',1.21),('12664','2014-02-26','08:20:00',1.36),('12664','2014-02-26','08:25:00',1.45),('12664','2014-02-26','08:30:00',1.58),('12664','2014-02-26','08:35:00',1.75),('12664','2014-02-26','08:40:00',1.69),('12664','2014-02-26','08:45:00',1.51),('12664','2014-02-26','08:50:00',1.7),('12664','2014-02-26','08:55:00',1.94),('12664','2014-02-26','09:00:00',2.02),('12664','2014-02-26','09:05:00',1.9),('12664','2014-02-26','09:10:00',2.1),('12664','2014-02-26','09:15:00',2.22),('12664','2014-02-26','09:20:00',1.6),('12664','2014-02-26','09:25:00',1.65),('12664','2014-02-26','09:30:00',1.59),('12664','2014-02-26','09:35:00',1.81),('12664','2014-02-26','09:40:00',1.78),('12664','2014-02-26','09:45:00',1.64),('12664','2014-02-26','09:50:00',1.75),('12664','2014-02-26','09:55:00',1.13),('12664','2014-02-26','12:10:00',1.02),('12664','2014-02-26','12:15:00',1.15),('12664','2014-02-26','12:20:00',3.11),('12664','2014-02-26','12:25:00',2.1),('12664','2014-02-26','12:30:00',2.03),('12664','2014-02-26','12:35:00',1.34),('12664','2014-02-26','12:40:00',1.93),('12664','2014-02-26','12:45:00',2.06),('12664','2014-02-26','12:50:00',2.88),('12664','2014-02-26','12:55:00',1.82),('12664','2014-02-26','13:00:00',1.8),('12664','2014-02-26','13:05:00',1.96),('12664','2014-02-26','13:10:00',1.92),('12664','2014-02-26','13:15:00',3.37),('12664','2014-02-26','13:20:00',3.67),('12664','2014-02-26','13:25:00',3.64),('12664','2014-02-26','13:30:00',1.4),('12664','2014-02-26','13:35:00',1.16),('12664','2014-02-26','13:40:00',3.46),('12664','2014-02-26','13:45:00',4.04),('12664','2014-02-26','13:50:00',3.76),('12664','2014-02-26','13:55:00',2.36),('12664','2014-02-26','14:00:00',2.93),('12664','2014-02-26','14:05:00',1.56),('12664','2014-02-26','14:10:00',1.65),('12664','2014-02-26','14:20:00',1.04),('12664','2014-02-26','14:25:00',1.45),('12664','2014-02-26','14:30:00',1.68),('12664','2014-02-26','14:35:00',2.38),('12664','2014-02-26','14:40:00',3.12),('12664','2014-02-26','14:45:00',2.58),('12664','2014-02-26','14:50:00',2.95),('12664','2014-02-26','14:55:00',2.75),('12664','2014-02-26','15:00:00',2.69),('12664','2014-02-26','15:05:00',2.39),('12664','2014-02-26','15:10:00',2.21),('12664','2014-02-26','15:15:00',1.65),('12664','2014-02-26','15:20:00',1.24),('12664','2014-02-26','15:25:00',1.6),('12664','2014-02-26','15:30:00',1.93),('12664','2014-02-26','15:35:00',1.68),('12664','2014-02-26','15:40:00',1.52),('12664','2014-02-26','15:45:00',1.87),('12664','2014-02-26','15:50:00',1.82),('12664','2014-02-26','15:55:00',1.66),('12664','2014-02-26','16:00:00',1.44),('12664','2014-02-26','16:05:00',1.07),('12664','2014-02-26','16:10:00',1.32),('12664','2014-02-26','16:15:00',1.12),('12664','2014-02-25','08:05:00',1.03),('12664','2014-02-25','08:10:00',1.12),('12664','2014-02-25','08:15:00',1.2),('12664','2014-02-25','08:20:00',1.28),('12664','2014-02-25','08:25:00',1.37),('12664','2014-02-25','08:30:00',1.45),('12664','2014-02-25','08:35:00',1.54),('12664','2014-02-25','08:40:00',1.64),('12664','2014-02-25','08:45:00',1.74),('12664','2014-02-25','08:50:00',1.84),('12664','2014-02-25','08:55:00',1.89),('12664','2014-02-25','09:00:00',1.98),('12664','2014-02-25','09:05:00',2.07),('12664','2014-02-25','09:10:00',2.16),('12664','2014-02-25','09:15:00',2.23),('12664','2014-02-25','09:20:00',2.31),('12664','2014-02-25','09:25:00',2.36),('12664','2014-02-25','09:30:00',2.42),('12664','2014-02-25','09:35:00',2.49),('12664','2014-02-25','09:40:00',2.55),('12664','2014-02-25','09:45:00',2.62),('12664','2014-02-25','09:50:00',2.66),('12664','2014-02-25','09:55:00',2.7),('12664','2014-02-25','10:00:00',2.76),('12664','2014-02-25','10:05:00',2.82),('12664','2014-02-25','10:10:00',2.89),('12664','2014-02-25','10:15:00',2.95),('12664','2014-02-25','10:20:00',3.03),('12664','2014-02-25','10:25:00',3.04),('12664','2014-02-25','10:30:00',3.1),('12664','2014-02-25','10:35:00',3.13),('12664','2014-02-25','10:40:00',3.16),('12664','2014-02-25','10:45:00',3.17),('12664','2014-02-25','10:50:00',3.24),('12664','2014-02-25','10:55:00',3.28),('12664','2014-02-25','11:00:00',3.35),('12664','2014-02-25','11:05:00',3.36),('12664','2014-02-25','11:10:00',3.35),('12664','2014-02-25','11:15:00',3.37),('12664','2014-02-25','11:20:00',3.4),('12664','2014-02-25','11:25:00',3.42),('12664','2014-02-25','11:30:00',3.46),('12664','2014-02-25','11:35:00',3.49),('12664','2014-02-25','11:40:00',3.52),('12664','2014-02-25','11:45:00',3.53),('12664','2014-02-25','11:50:00',3.56),('12664','2014-02-25','11:55:00',3.56),('12664','2014-02-25','12:00:00',3.57),('12664','2014-02-25','12:05:00',3.56),('12664','2014-02-25','12:10:00',3.55),('12664','2014-02-25','12:15:00',3.57),('12664','2014-02-25','12:20:00',3.58),('12664','2014-02-25','12:25:00',3.58),('12664','2014-02-25','12:30:00',3.57),('12664','2014-02-25','12:35:00',3.59),('12664','2014-02-25','12:40:00',3.57),('12664','2014-02-25','12:45:00',3.53),('12664','2014-02-25','12:50:00',3.5),('12664','2014-02-25','12:55:00',3.49),('12664','2014-02-25','13:00:00',3.47),('12664','2014-02-25','13:05:00',3.45),('12664','2014-02-25','13:10:00',3.42),('12664','2014-02-25','13:15:00',3.38),('12664','2014-02-25','13:20:00',3.36),('12664','2014-02-25','13:25:00',3.4),('12664','2014-02-25','13:30:00',3.42),('12664','2014-02-25','13:35:00',3.4),('12664','2014-02-25','13:40:00',3.19),('12664','2014-02-25','13:45:00',3.22),('12664','2014-02-25','13:50:00',2.85),('12664','2014-02-25','14:00:00',2.66),('12664','2014-02-25','14:05:00',3.14),('12664','2014-02-25','14:10:00',2.94),('12664','2014-02-25','14:15:00',2.86),('12664','2014-02-25','14:20:00',2.74),('12664','2014-02-25','14:25:00',2.45),('12664','2014-02-25','14:30:00',2.35),('12664','2014-02-25','14:35:00',2.53),('12664','2014-02-25','14:40:00',2.6),('12664','2014-02-25','14:45:00',2.42),('12664','2014-02-25','14:50:00',2.51),('12664','2014-02-25','14:55:00',2.58),('12664','2014-02-25','15:00:00',2.42),('12664','2014-02-25','15:05:00',2.42),('12664','2014-02-25','15:10:00',2.31),('12664','2014-02-25','15:15:00',2.15),('12664','2014-02-25','15:20:00',2.11),('12664','2014-02-25','15:25:00',1.97),('12664','2014-02-25','15:30:00',1.92),('12664','2014-02-25','15:35:00',1.27),('12664','2014-02-25','15:45:00',1.08),('12664','2014-02-25','15:50:00',1.33),('12664','2014-02-25','15:55:00',1.2),('12664','2014-02-25','16:00:00',1.23),('12664','2014-02-25','16:05:00',1.03),('12664','2014-04-28','08:05:00',1.4),('12664','2014-04-28','08:10:00',1.7),('12664','2014-04-28','08:15:00',1.74),('12664','2014-04-28','08:20:00',1.17),('12664','2014-04-28','08:25:00',1.13),('12664','2014-04-28','08:40:00',1.04),('12664','2014-04-28','08:50:00',1.05),('12664','2014-04-28','08:55:00',2),('12664','2014-04-28','09:00:00',2.24),('12664','2014-04-28','09:05:00',2.58),('12664','2014-04-28','09:10:00',2.62),('12664','2014-04-28','09:15:00',2.53),('12664','2014-04-28','09:20:00',3.11),('12664','2014-04-28','09:25:00',2.49),('12664','2014-04-28','09:30:00',1.75),('12664','2014-04-28','09:35:00',1.25),('12664','2014-04-28','09:40:00',1.27),('12664','2014-04-28','09:45:00',1.37),('12664','2014-04-28','09:50:00',1.54),('12664','2014-04-28','09:55:00',1.42),('12664','2014-04-28','10:00:00',1.19),('12664','2014-04-28','10:25:00',1.01),('12664','2014-04-28','10:30:00',1.14),('12664','2014-04-28','10:35:00',1.13),('12664','2014-04-28','10:50:00',1.19),('12664','2014-04-28','10:55:00',1.41),('12664','2014-04-28','11:00:00',1.58),('12664','2014-04-28','11:05:00',1.62),('12664','2014-04-28','11:10:00',1.35),('12664','2014-04-28','11:15:00',1.47),('12664','2014-04-28','11:20:00',1.24),('12664','2014-04-28','11:25:00',1.36),('12664','2014-04-28','11:30:00',1.58),('12664','2014-04-28','11:35:00',1.59),('12664','2014-04-28','11:40:00',1.52),('12664','2014-04-28','11:45:00',1.46),('12664','2014-04-28','11:50:00',1.59),('12664','2014-04-28','11:55:00',1.81),('12664','2014-04-28','12:00:00',1.99),('12664','2014-04-28','12:05:00',1.77),('12664','2014-04-28','12:10:00',1.48),('12664','2014-04-28','12:15:00',1.69),('12664','2014-04-28','12:20:00',2.28),('12664','2014-04-28','12:25:00',2.74),('12664','2014-04-28','12:30:00',2.91),('12664','2014-04-28','12:35:00',2.14),('12664','2014-04-28','12:40:00',2.16),('12664','2014-04-28','12:45:00',2.11),('12664','2014-04-28','12:50:00',2.11),('12664','2014-04-28','12:55:00',2.7),('12664','2014-04-28','13:00:00',2.9),('12664','2014-04-28','13:05:00',3.43),('12664','2014-04-28','13:10:00',3.52),('12664','2014-04-28','13:15:00',4.21),('12664','2014-04-28','13:20:00',2.53),('12664','2014-04-28','13:25:00',3.2),('12664','2014-04-28','13:30:00',2.86),('12664','2014-04-28','13:35:00',2.61),('12664','2014-04-28','13:40:00',2.06),('12664','2014-04-28','13:45:00',1.88),('12664','2014-04-28','13:50:00',1.73),('12664','2014-04-28','13:55:00',1.97),('12664','2014-04-28','14:00:00',4.13),('12664','2014-04-28','14:05:00',4.9),('12664','2014-04-28','14:10:00',3.34),('12664','2014-04-28','14:15:00',4.41),('12664','2014-04-28','14:20:00',3.44),('12664','2014-04-28','14:25:00',2.53),('12664','2014-04-28','14:30:00',2.53),('12664','2014-04-28','14:35:00',1.98),('12664','2014-04-28','14:40:00',3.05),('12664','2014-04-28','14:45:00',1.92),('12664','2014-04-28','14:50:00',1.88),('12664','2014-04-28','14:55:00',2.35),('12664','2014-04-28','15:00:00',2.26),('12664','2014-04-28','15:05:00',4.2),('12664','2014-04-28','15:10:00',1.87),('12664','2014-04-28','15:15:00',2.24),('12664','2014-04-28','15:20:00',1.19),('12664','2014-04-28','15:25:00',1.45),('12664','2014-04-28','15:30:00',1.2),('12664','2014-04-28','15:35:00',2.54),('12664','2014-04-28','15:40:00',1.98),('12664','2014-04-28','15:45:00',1.13),('12664','2014-04-28','15:50:00',3.48),('12664','2014-04-28','15:55:00',1.22),('12664','2014-04-28','16:05:00',1.47),('12664','2014-04-28','16:10:00',1.9),('12664','2014-04-28','16:15:00',1.31),('12664','2014-04-28','16:20:00',2.4),('12664','2014-04-28','16:25:00',4.01),('12664','2014-04-28','16:30:00',1.58),('12664','2014-04-28','16:55:00',1.53),('12664','2014-04-28','17:00:00',2.04),('12664','2014-02-24','08:00:00',1.18),('12664','2014-02-24','08:05:00',1.33),('12664','2014-02-24','08:20:00',1.15),('12664','2014-02-24','08:45:00',1.01),('12664','2014-02-24','08:50:00',2.32),('12664','2014-02-24','08:55:00',2.16),('12664','2014-02-24','09:00:00',2.15),('12664','2014-02-24','09:05:00',2.16),('12664','2014-02-24','09:10:00',2.21),('12664','2014-02-24','09:15:00',2.29),('12664','2014-02-24','09:20:00',2.35),('12664','2014-02-24','09:25:00',2.44),('12664','2014-02-24','09:30:00',2.5),('12664','2014-02-24','09:35:00',2.56),('12664','2014-02-24','09:40:00',2.63),('12664','2014-02-24','09:45:00',2.7),('12664','2014-02-24','09:50:00',2.77),('12664','2014-02-24','09:55:00',2.81),('12664','2014-02-24','10:00:00',2.86),('12664','2014-02-24','10:05:00',2.91),('12664','2014-02-24','10:10:00',2.95),('12664','2014-02-24','10:15:00',3.01),('12664','2014-02-24','10:20:00',3.06),('12664','2014-02-24','10:25:00',3.09),('12664','2014-02-24','10:30:00',3.16),('12664','2014-02-24','10:35:00',3.19),('12664','2014-02-24','10:40:00',3.23),('12664','2014-02-24','10:45:00',3.27),('12664','2014-02-24','10:50:00',3.31),('12664','2014-02-24','10:55:00',3.33),('12664','2014-02-24','11:00:00',3.39),('12664','2014-02-24','11:05:00',3.44),('12664','2014-02-24','11:10:00',3.49),('12664','2014-02-24','11:15:00',3.51),('12664','2014-02-24','11:20:00',3.64),('12664','2014-02-24','11:25:00',3.93),('12664','2014-02-24','11:30:00',4.01),('12664','2014-02-24','11:35:00',1.8),('12664','2014-02-24','11:40:00',1.08),('12664','2014-02-24','11:45:00',4.03),('12664','2014-02-24','11:50:00',3.72),('12664','2014-02-24','11:55:00',3.61),('12664','2014-02-24','12:00:00',3.62),('12664','2014-02-24','12:05:00',3.63),('12664','2014-02-24','12:10:00',3.62),('12664','2014-02-24','12:15:00',3.62),('12664','2014-02-24','12:20:00',3.61),('12664','2014-02-24','12:25:00',3.61),('12664','2014-02-24','12:30:00',3.59),('12664','2014-02-24','12:35:00',3.57),('12664','2014-02-24','12:40:00',3.6),('12664','2014-02-24','12:45:00',3.67),('12664','2014-02-24','12:50:00',3.61),('12664','2014-02-24','12:55:00',3.6),('12664','2014-02-24','13:00:00',1.27),('12664','2014-02-24','13:05:00',2.89),('12664','2014-02-24','13:10:00',3.5),('12664','2014-02-24','13:15:00',3.19),('12664','2014-02-24','13:20:00',1.21),('12664','2014-02-24','13:25:00',1.06),('12664','2014-02-24','13:30:00',1.06),('12664','2014-02-24','13:35:00',1.14),('12664','2014-02-24','13:40:00',1.08),('12664','2014-02-24','13:45:00',1.02),('12664','2014-02-24','13:55:00',1.13),('12664','2014-02-24','14:00:00',1.23),('12664','2014-02-24','14:05:00',1.14),('12664','2014-02-24','14:10:00',1.05),('12664','2014-02-24','14:15:00',1.13),('12664','2014-02-24','14:20:00',1.2),('12664','2014-02-24','14:25:00',1.03),('12664','2014-02-24','14:55:00',1.04),('12664','2014-02-24','15:00:00',1.23),('12664','2014-02-24','15:05:00',1.91),('12664','2014-02-24','15:10:00',2.18),('12664','2014-02-24','15:15:00',2.18),('12664','2014-02-24','15:20:00',2.01),('12664','2014-02-24','15:25:00',2.32),('12664','2014-02-24','15:30:00',2.18),('12664','2014-02-24','15:35:00',1.95),('12664','2014-02-24','15:40:00',1.87),('12664','2014-02-24','15:45:00',1.87),('12664','2014-02-24','15:50:00',1.77),('12664','2014-02-24','15:55:00',1.67),('12664','2014-02-24','16:00:00',1.6),('12664','2014-02-24','16:05:00',1.57),('12664','2014-02-24','16:10:00',1.56),('12664','2014-02-24','16:30:00',1.04),('12664','2014-02-23','08:10:00',1.06),('12664','2014-02-23','08:15:00',1.14),('12664','2014-02-23','08:20:00',1.22),('12664','2014-02-23','08:25:00',1.32),('12664','2014-02-23','08:30:00',1.41),('12664','2014-02-23','08:35:00',1.51),('12664','2014-02-23','08:40:00',1.62),('12664','2014-02-23','08:45:00',1.71),('12664','2014-02-23','08:50:00',1.81),('12664','2014-02-23','08:55:00',1.92),('12664','2014-02-23','09:00:00',2.01),('12664','2014-02-23','09:05:00',2.1),('12664','2014-02-23','09:10:00',2.21),('12664','2014-02-23','09:15:00',2.26),('12664','2014-02-23','09:20:00',2.16),('12664','2014-02-23','09:25:00',2.23),('12664','2014-02-23','09:30:00',2.46),('12664','2014-02-23','09:35:00',2.53),('12664','2014-02-23','09:40:00',2.56),('12664','2014-02-23','09:45:00',2.63),('12664','2014-02-23','09:50:00',2.68),('12664','2014-02-23','09:55:00',2.71),('12664','2014-02-23','10:00:00',2.79),('12664','2014-02-23','10:05:00',2.85),('12664','2014-02-23','10:10:00',2.9),('12664','2014-02-23','10:15:00',2.96),('12664','2014-02-23','10:20:00',3.01),('12664','2014-02-23','10:25:00',3.07),('12664','2014-02-23','10:30:00',3.12),('12664','2014-02-23','10:35:00',3.17),('12664','2014-02-23','10:40:00',3.22),('12664','2014-02-23','10:45:00',3.25),('12664','2014-02-23','10:50:00',3.3),('12664','2014-02-23','10:55:00',3.33),('12664','2014-02-23','11:00:00',3.35),('12664','2014-02-23','11:05:00',3.38),('12664','2014-02-23','11:10:00',3.4),('12664','2014-02-23','11:15:00',3.46),('12664','2014-02-23','11:20:00',3.5),('12664','2014-02-23','11:25:00',3.55),('12664','2014-02-23','11:30:00',3.57),('12664','2014-02-23','11:35:00',3.59),('12664','2014-02-23','11:40:00',3.61),('12664','2014-02-23','11:45:00',3.67),('12664','2014-02-23','11:50:00',3.64),('12664','2014-02-23','11:55:00',2.75),('12664','2014-02-23','12:00:00',3.74),('12664','2014-02-23','12:05:00',3.93),('12664','2014-02-23','12:10:00',3.53),('12664','2014-02-23','12:15:00',2.33),('12664','2014-02-23','12:20:00',2.21),('12664','2014-02-23','12:25:00',3.81),('12664','2014-02-23','12:30:00',1.81),('12664','2014-02-23','12:35:00',2.62),('12664','2014-02-23','12:40:00',1.93),('12664','2014-02-23','12:45:00',2.91),('12664','2014-02-23','12:50:00',3.77),('12664','2014-02-23','12:55:00',3.68),('12664','2014-02-23','13:00:00',3.59),('12664','2014-02-23','13:05:00',3.62),('12664','2014-02-23','13:10:00',3.55),('12664','2014-02-23','13:15:00',3.54),('12664','2014-02-23','13:20:00',3.05),('12664','2014-02-23','13:25:00',3.44),('12664','2014-02-23','13:30:00',2.65),('12664','2014-02-23','13:35:00',3.17),('12664','2014-02-23','13:40:00',2.47),('12664','2014-02-23','13:45:00',2.42),('12664','2014-02-23','13:50:00',2.03),('12664','2014-02-23','13:55:00',2.47),('12664','2014-02-23','14:00:00',2.7),('12664','2014-02-23','14:05:00',1.4),('12664','2014-02-23','14:10:00',2.65),('12664','2014-02-23','14:15:00',3.23),('12664','2014-02-23','14:20:00',2.97),('12664','2014-02-23','14:25:00',2.16),('12664','2014-02-23','14:30:00',1.67),('12664','2014-02-23','14:35:00',3.62),('12664','2014-02-23','14:40:00',3.55),('12664','2014-02-23','14:45:00',2.48),('12664','2014-02-23','14:50:00',1.07),('12664','2014-02-23','15:00:00',1.04),('12664','2014-02-23','15:10:00',2.25),('12664','2014-02-23','15:15:00',2.1),('12664','2014-02-23','15:25:00',2.3),('12664','2014-02-23','15:30:00',2.29),('12664','2014-02-23','15:35:00',2.58),('12664','2014-02-23','15:40:00',2.42),('12664','2014-02-23','15:45:00',2.51),('12664','2014-02-23','15:50:00',2.49),('12664','2014-02-23','15:55:00',2.41),('12664','2014-02-23','16:00:00',2.56),('12664','2014-02-23','16:05:00',2.25),('12664','2014-02-23','16:10:00',1.82),('12664','2014-02-23','16:15:00',1.16),('12664','2014-02-22','09:15:00',1.14),('12664','2014-02-22','09:25:00',1.08),('12664','2014-02-22','09:30:00',1.03),('12664','2014-02-22','09:35:00',1.08),('12664','2014-02-22','09:40:00',1.64),('12664','2014-02-22','09:45:00',1.82),('12664','2014-02-22','09:50:00',2.29),('12664','2014-02-22','09:55:00',1.26),('12664','2014-02-22','10:00:00',1.83),('12664','2014-02-22','10:05:00',1.1),('12664','2014-02-22','10:20:00',2),('12664','2014-02-22','10:25:00',2.32),('12664','2014-02-22','10:30:00',1.44),('12664','2014-02-22','10:35:00',1.81),('12664','2014-02-22','10:40:00',1.34),('12664','2014-02-22','12:00:00',1.19),('12664','2014-02-22','12:05:00',1.2),('12664','2014-02-22','12:10:00',1.39),('12664','2014-02-22','12:15:00',1.15),('12664','2014-02-22','12:20:00',1.42),('12664','2014-02-22','12:25:00',1.34),('12664','2014-02-22','12:30:00',2.45),('12664','2014-02-22','12:35:00',3.45),('12664','2014-02-22','12:40:00',3.98),('12664','2014-02-22','12:45:00',4.03),('12664','2014-02-22','12:50:00',2.36),('12664','2014-02-22','12:55:00',3.95),('12664','2014-02-22','13:00:00',3.15),('12664','2014-02-22','13:15:00',1.2),('12664','2014-02-22','13:20:00',2.37),('12664','2014-02-22','13:25:00',2.73),('12664','2014-02-22','13:30:00',2.23),('12664','2014-02-22','13:35:00',3.93),('12664','2014-02-22','13:40:00',3.02),('12664','2014-02-22','13:45:00',2.05),('12664','2014-02-22','13:50:00',1.29),('12664','2014-02-22','13:55:00',1.13),('12664','2014-02-22','14:00:00',1.35),('12664','2014-02-22','14:05:00',2.29),('12664','2014-02-22','14:10:00',1.56),('12664','2014-02-22','14:15:00',3.17),('12664','2014-02-22','14:20:00',3.07),('12664','2014-02-22','14:25:00',1.75),('12664','2014-02-22','14:30:00',2.13),('12664','2014-02-22','14:35:00',2.54),('12664','2014-02-22','14:40:00',1.76),('12664','2014-02-22','14:45:00',1.51),('12664','2014-02-22','14:50:00',2.08),('12664','2014-02-22','14:55:00',2.48),('12664','2014-02-22','15:00:00',1.92),('12664','2014-02-22','15:05:00',1.93),('12664','2014-02-22','15:10:00',1.87),('12664','2014-02-22','15:15:00',2.37),('12664','2014-02-22','15:20:00',1.75),('12664','2014-02-22','15:25:00',1.41),('12664','2014-02-22','15:35:00',1.67),('12664','2014-02-22','15:40:00',2.36),('12664','2014-02-22','15:45:00',1.55),('12664','2014-02-22','15:50:00',1.71),('12664','2014-02-22','15:55:00',1.74),('12664','2014-02-22','16:00:00',1.65),('12664','2014-02-22','16:05:00',1.45),('12664','2014-02-22','16:10:00',1.07),('12664','2014-02-22','16:15:00',1.2),('12664','2014-02-22','16:20:00',1.19),('12664','2014-02-22','16:25:00',1.08),('12664','2014-02-21','09:10:00',1),('12664','2014-02-21','09:15:00',1.04),('12664','2014-02-21','09:20:00',1.08),('12664','2014-02-21','09:25:00',1.06),('12664','2014-02-21','09:35:00',1),('12664','2014-02-21','09:40:00',1),('12664','2014-02-21','09:45:00',1.02),('12664','2014-02-21','09:50:00',1.13),('12664','2014-02-21','09:55:00',1.29),('12664','2014-02-21','10:00:00',1.41),('12664','2014-02-21','10:05:00',1.74),('12664','2014-02-21','10:10:00',2.16),('12664','2014-02-21','10:15:00',1.83),('12664','2014-02-21','10:20:00',1.78),('12664','2014-02-21','10:25:00',1.79),('12664','2014-02-21','10:30:00',1.38),('12664','2014-02-21','10:35:00',1.27),('12664','2014-02-21','10:40:00',1.8),('12664','2014-02-21','10:45:00',2.38),('12664','2014-02-21','10:50:00',3.6),('12664','2014-02-21','10:55:00',3.57),('12664','2014-02-21','11:00:00',3.48),('12664','2014-02-21','11:05:00',3.76),('12664','2014-02-21','11:10:00',3.56),('12664','2014-02-21','11:15:00',4.09),('12664','2014-02-21','11:20:00',2.5),('12664','2014-02-21','11:25:00',2.04),('12664','2014-02-21','11:30:00',3.01),('12664','2014-02-21','11:35:00',3.87),('12664','2014-02-21','11:40:00',4.04),('12664','2014-02-21','11:45:00',1.36),('12664','2014-02-21','11:50:00',1.06),('12664','2014-02-21','11:55:00',3.14),('12664','2014-02-21','12:00:00',1.63),('12664','2014-02-21','12:05:00',1.47),('12664','2014-02-21','12:10:00',1.32),('12664','2014-02-21','12:15:00',1.36),('12664','2014-02-21','12:20:00',1.12),('12664','2014-02-21','14:05:00',1.26),('12664','2014-02-21','14:10:00',1.57),('12664','2014-02-21','14:15:00',1.3),('12664','2014-02-21','14:20:00',1.14),('12664','2014-02-21','14:25:00',2.14),('12664','2014-02-21','14:30:00',2.52),('12664','2014-02-21','14:35:00',2.92),('12664','2014-02-21','14:40:00',3.16),('12664','2014-02-21','14:45:00',1.95),('12664','2014-02-21','14:50:00',1.67),('12664','2014-02-21','14:55:00',2.65),('12664','2014-02-21','15:00:00',3.02),('12664','2014-02-21','15:05:00',2.75),('12664','2014-02-21','15:10:00',1.65),('12664','2014-02-21','15:15:00',2.19),('12664','2014-02-21','15:20:00',2.19),('12664','2014-02-21','15:25:00',2.05),('12664','2014-02-21','15:30:00',1.93),('12664','2014-02-21','15:35:00',1.82),('12664','2014-02-21','15:40:00',1.74),('12664','2014-02-21','15:45:00',1.65),('12664','2014-02-21','15:50:00',1.59),('12664','2014-02-21','15:55:00',1.32),('12664','2014-02-21','16:00:00',1.44),('12664','2014-02-21','16:05:00',1.34),('12664','2014-02-21','16:10:00',1.24),('12664','2014-02-21','16:15:00',1.16),('12664','2014-02-21','16:20:00',1.07),('12664','2014-02-20','10:15:00',1.02),('12664','2014-02-20','10:20:00',1.07),('12664','2014-02-20','10:25:00',1.05),('12664','2014-02-20','10:35:00',1.06),('12664','2014-02-20','10:40:00',1.18),('12664','2014-02-20','10:45:00',1.14),('12664','2014-02-20','10:50:00',1.08),('12664','2014-02-20','10:55:00',1.11),('12664','2014-02-20','11:00:00',1.08),('12664','2014-02-20','11:25:00',1.19),('12664','2014-02-20','11:30:00',1.37),('12664','2014-02-20','11:35:00',1.31),('12664','2014-02-20','11:40:00',1.16),('12664','2014-02-20','12:00:00',1.07),('12664','2014-02-20','13:00:00',1.12),('12664','2014-02-20','13:05:00',1.04),('12664','2014-02-20','13:10:00',1.32),('12664','2014-02-20','13:15:00',1.24),('12664','2014-02-20','13:25:00',1.17),('12664','2014-02-20','13:30:00',1.13),('12664','2014-02-20','13:35:00',1.15),('12664','2014-02-20','13:40:00',1.23),('12664','2014-02-20','13:45:00',1.12),('12664','2014-02-20','13:50:00',1.25),('12664','2014-02-20','13:55:00',1.05),('12664','2014-02-20','14:00:00',1.12),('12664','2014-02-20','14:05:00',1.04),('12664','2014-02-20','14:10:00',1.06),('12664','2014-02-19','09:40:00',1.05),('12664','2014-02-19','09:45:00',1.4),('12664','2014-02-19','09:50:00',1.3),('12664','2014-02-19','09:55:00',1.14),('12664','2014-02-19','10:00:00',1.22),('12664','2014-02-19','10:05:00',1.31),('12664','2014-02-19','10:10:00',1.28),('12664','2014-02-19','10:15:00',1.42),('12664','2014-02-19','10:20:00',1.35),('12664','2014-02-19','10:25:00',1.23),('12664','2014-02-19','10:30:00',1.1),('12664','2014-02-19','10:35:00',1.13),('12664','2014-02-19','10:40:00',1.22),('12664','2014-02-19','10:45:00',1.23),('12664','2014-02-19','10:50:00',1.27),('12664','2014-02-19','10:55:00',1.28),('12664','2014-02-19','11:00:00',1.17),('12664','2014-02-19','11:10:00',1.09),('12664','2014-02-19','11:15:00',1.32),('12664','2014-02-19','11:20:00',1.34),('12664','2014-02-19','11:25:00',1.25),('12664','2014-02-19','11:40:00',1.49),('12664','2014-02-19','11:45:00',1.62),('12664','2014-02-19','11:50:00',1.62),('12664','2014-02-19','11:55:00',1.36),('12664','2014-02-19','12:00:00',1.29),('12664','2014-02-19','12:05:00',1.29),('12664','2014-02-19','12:10:00',1.17),('12664','2014-02-19','13:00:00',1.11),('12664','2014-02-19','13:05:00',1.15),('12664','2014-02-19','13:10:00',1.24),('12664','2014-02-19','13:15:00',1.39),('12664','2014-02-19','13:20:00',1.37),('12664','2014-02-19','13:25:00',1.23),('12664','2014-02-19','13:30:00',1.55),('12664','2014-02-19','13:35:00',1.81),('12664','2014-02-19','13:40:00',1.63),('12664','2014-02-19','13:45:00',1.97),('12664','2014-02-19','13:50:00',1.92),('12664','2014-02-19','13:55:00',1.98),('12664','2014-02-19','14:00:00',1.49),('12664','2014-02-19','14:05:00',1.11),('12664','2014-02-19','14:15:00',1),('12664','2014-02-19','14:20:00',1.07),('12664','2014-02-19','14:25:00',1.34),('12664','2014-02-19','14:30:00',1.51),('12664','2014-02-18','08:15:00',1.05),('12664','2014-02-18','08:20:00',1.13),('12664','2014-02-18','08:25:00',1.23),('12664','2014-02-18','08:30:00',1.33),('12664','2014-02-18','08:35:00',1.42),('12664','2014-02-18','08:40:00',1.51),('12664','2014-02-18','08:45:00',1.61),('12664','2014-02-18','08:50:00',1.69),('12664','2014-02-18','08:55:00',1.78),('12664','2014-02-18','09:00:00',1.86),('12664','2014-02-18','09:05:00',1.94),('12664','2014-02-18','09:10:00',2.01),('12664','2014-02-18','09:15:00',2.09),('12664','2014-02-18','09:20:00',2.17),('12664','2014-02-18','09:25:00',2.21),('12664','2014-02-18','09:30:00',2.3),('12664','2014-02-18','09:35:00',2.37),('12664','2014-02-18','09:40:00',2.42),('12664','2014-02-18','09:45:00',2.5),('12664','2014-02-18','09:50:00',2.56),('12664','2014-02-18','09:55:00',2.62),('12664','2014-02-18','10:00:00',2.68),('12664','2014-02-18','10:05:00',2.73),('12664','2014-02-18','10:10:00',2.78),('12664','2014-02-18','10:15:00',2.84),('12664','2014-02-18','10:20:00',2.89),('12664','2014-02-18','10:25:00',2.93),('12664','2014-02-18','10:30:00',2.97),('12664','2014-02-18','10:35:00',3),('12664','2014-02-18','10:40:00',3.04),('12664','2014-02-18','10:45:00',3.08),('12664','2014-02-18','10:50:00',3.13),('12664','2014-02-18','10:55:00',3.19),('12664','2014-02-18','11:00:00',3.25),('12664','2014-02-18','11:05:00',3.13),('12664','2014-02-18','11:10:00',2.92),('12664','2014-02-18','11:15:00',2.94),('12664','2014-02-18','11:20:00',3.34),('12664','2014-02-18','11:25:00',3.24),('12664','2014-02-18','11:30:00',2.09),('12664','2014-02-18','11:35:00',1.56),('12664','2014-02-18','11:40:00',1.65),('12664','2014-02-18','11:45:00',1.4),('12664','2014-02-18','11:50:00',1.25),('12664','2014-02-18','11:55:00',1.35),('12664','2014-02-18','12:00:00',1.39),('12664','2014-02-18','12:05:00',1.36),('12664','2014-02-18','12:10:00',1.39),('12664','2014-02-18','12:15:00',1.53),('12664','2014-02-18','12:20:00',1.78),('12664','2014-02-18','12:25:00',1.93),('12664','2014-02-18','12:30:00',1.67),('12664','2014-02-18','12:35:00',1.48),('12664','2014-02-18','12:40:00',1.42),('12664','2014-02-18','12:45:00',1.37),('12664','2014-02-18','12:50:00',1.25),('12664','2014-02-18','12:55:00',1.32),('12664','2014-02-18','13:00:00',1.29),('12664','2014-02-18','13:05:00',1.2),('12664','2014-02-18','13:10:00',1.22),('12664','2014-02-18','13:15:00',1.5),('12664','2014-02-18','13:20:00',2.25),('12664','2014-02-18','13:25:00',2.81),('12664','2014-02-18','13:30:00',1.87),('12664','2014-02-18','13:35:00',1.63),('12664','2014-02-18','13:40:00',1.84),('12664','2014-02-18','13:45:00',2.01),('12664','2014-02-18','13:50:00',1.56),('12664','2014-02-18','13:55:00',1.46),('12664','2014-02-18','14:00:00',1.47),('12664','2014-02-18','14:05:00',1.82),('12664','2014-02-18','14:10:00',1.66),('12664','2014-02-18','14:15:00',1.39),('12664','2014-02-18','14:20:00',1.13),('12664','2014-02-18','14:25:00',1.05),('12664','2014-02-18','14:30:00',1.19),('12664','2014-02-18','14:35:00',1.18),('12664','2014-02-18','14:40:00',1.04),('12664','2014-02-18','15:35:00',1.18),('12664','2014-02-18','15:40:00',1.08),('12664','2014-02-18','16:00:00',1.04),('12664','2014-02-18','16:05:00',1),('12664','2014-02-17','08:25:00',1.07),('12664','2014-02-17','08:30:00',1.18),('12664','2014-02-17','08:35:00',1.26),('12664','2014-02-17','08:40:00',1.32),('12664','2014-02-17','08:45:00',1.39),('12664','2014-02-17','08:50:00',1.46),('12664','2014-02-17','08:55:00',1.56),('12664','2014-02-17','09:00:00',1.63),('12664','2014-02-17','09:05:00',1.72),('12664','2014-02-17','09:10:00',1.8),('12664','2014-02-17','09:15:00',1.88),('12664','2014-02-17','09:20:00',1.96),('12664','2014-02-17','09:25:00',2.04),('12664','2014-02-17','09:30:00',2.12),('12664','2014-02-17','09:35:00',2.2),('12664','2014-02-17','09:40:00',2.24),('12664','2014-02-17','09:45:00',2.3),('12664','2014-02-17','09:50:00',2.34),('12664','2014-02-17','09:55:00',2.4),('12664','2014-02-17','10:00:00',2.44),('12664','2014-02-17','10:05:00',2.48),('12664','2014-02-17','10:10:00',2.53),('12664','2014-02-17','10:15:00',2.59),('12664','2014-02-17','10:20:00',2.64),('12664','2014-02-17','10:25:00',2.68),('12664','2014-02-17','10:30:00',2.71),('12664','2014-02-17','10:35:00',2.75),('12664','2014-02-17','10:40:00',2.79),('12664','2014-02-17','10:45:00',2.79),('12664','2014-02-17','10:50:00',2.8),('12664','2014-02-17','10:55:00',2.84),('12664','2014-02-17','11:00:00',2.85),('12664','2014-02-17','11:05:00',2.86),('12664','2014-02-17','11:10:00',2.88),('12664','2014-02-17','11:15:00',2.91),('12664','2014-02-17','11:20:00',2.92),('12664','2014-02-17','11:25:00',2.92),('12664','2014-02-17','11:30:00',2.93),('12664','2014-02-17','11:35:00',2.95),('12664','2014-02-17','11:40:00',2.95),('12664','2014-02-17','11:45:00',2.98),('12664','2014-02-17','11:50:00',3.04),('12664','2014-02-17','11:55:00',3.09),('12664','2014-02-17','12:00:00',3.15),('12664','2014-02-17','12:05:00',3.19),('12664','2014-02-17','12:10:00',3.2),('12664','2014-02-17','12:15:00',3.2),('12664','2014-02-17','12:20:00',3.23),('12664','2014-02-17','12:25:00',3.22),('12664','2014-02-17','12:30:00',3.2),('12664','2014-02-17','12:35:00',3.18),('12664','2014-02-17','12:40:00',3.17),('12664','2014-02-17','12:45:00',3.18),('12664','2014-02-17','12:50:00',3.17),('12664','2014-02-17','12:55:00',3.13),('12664','2014-02-17','13:00:00',3.11),('12664','2014-02-17','13:05:00',3.11),('12664','2014-02-17','13:10:00',3.1),('12664','2014-02-17','13:15:00',3.08),('12664','2014-02-17','13:20:00',3.06),('12664','2014-02-17','13:25:00',3.03),('12664','2014-02-17','13:30:00',2.98),('12664','2014-02-17','13:35:00',2.91),('12664','2014-02-17','13:40:00',2.93),('12664','2014-02-17','13:45:00',2.89),('12664','2014-02-17','13:50:00',2.86),('12664','2014-02-17','13:55:00',2.84),('12664','2014-02-17','14:00:00',2.77),('12664','2014-02-17','14:05:00',2.76),('12664','2014-02-17','14:10:00',2.6),('12664','2014-02-17','14:15:00',2.69),('12664','2014-02-17','14:20:00',2.63),('12664','2014-02-17','14:25:00',2.54),('12664','2014-02-17','14:30:00',2.44),('12664','2014-02-17','14:35:00',2.36),('12664','2014-02-17','14:40:00',2.34),('12664','2014-02-17','14:45:00',2.3),('12664','2014-02-17','14:50:00',2.26),('12664','2014-02-17','14:55:00',2.21),('12664','2014-02-17','15:00:00',2.14),('12664','2014-02-17','15:05:00',1.97),('12664','2014-02-17','15:10:00',1.86),('12664','2014-02-17','15:15:00',1.95),('12664','2014-02-17','15:20:00',1.82),('12664','2014-02-17','15:25:00',1.79),('12664','2014-02-17','15:30:00',1.76),('12664','2014-02-17','15:35:00',1.62),('12664','2014-02-17','15:40:00',1.6),('12664','2014-02-17','15:45:00',1.51),('12664','2014-02-17','15:50:00',1.43),('12664','2014-02-17','15:55:00',1.36),('12664','2014-02-17','16:00:00',1.22),('12664','2014-02-17','16:05:00',1.18),('12664','2014-02-17','16:10:00',1.08),('12664','2014-02-16','08:15:00',1.03),('12664','2014-02-16','08:20:00',1.13),('12664','2014-02-16','08:25:00',1.22),('12664','2014-02-16','08:30:00',1.32),('12664','2014-02-16','08:35:00',1.32),('12664','2014-02-16','08:40:00',1.47),('12664','2014-02-16','08:45:00',1.57),('12664','2014-02-16','08:50:00',1.72),('12664','2014-02-16','08:55:00',1.84),('12664','2014-02-16','09:00:00',1.84),('12664','2014-02-16','09:05:00',1.81),('12664','2014-02-16','09:10:00',1.85),('12664','2014-02-16','09:15:00',2.09),('12664','2014-02-16','09:20:00',2.06),('12664','2014-02-16','09:25:00',2.02),('12664','2014-02-16','09:30:00',1.86),('12664','2014-02-16','09:35:00',2.34),('12664','2014-02-16','09:40:00',2.31),('12664','2014-02-16','09:45:00',2.46),('12664','2014-02-16','09:50:00',2.41),('12664','2014-02-16','09:55:00',2.51),('12664','2014-02-16','10:00:00',2.52),('12664','2014-02-16','10:05:00',2.7),('12664','2014-02-16','10:10:00',2.73),('12664','2014-02-16','10:15:00',2.66),('12664','2014-02-16','10:20:00',2.8),('12664','2014-02-16','10:25:00',2.92),('12664','2014-02-16','10:30:00',3.02),('12664','2014-02-16','10:35:00',3.06),('12664','2014-02-16','10:40:00',3.03),('12664','2014-02-16','10:45:00',2.93),('12664','2014-02-16','10:50:00',2.83),('12664','2014-02-16','10:55:00',3.14),('12664','2014-02-16','11:00:00',3.05),('12664','2014-02-16','11:05:00',2.85),('12664','2014-02-16','11:10:00',3.07),('12664','2014-02-16','11:15:00',2.93),('12664','2014-02-16','11:20:00',2.73),('12664','2014-02-16','11:25:00',3.07),('12664','2014-02-16','11:30:00',3.31),('12664','2014-02-16','11:35:00',3.21),('12664','2014-02-16','11:40:00',2.92),('12664','2014-02-16','11:45:00',3.09),('12664','2014-02-16','11:50:00',3.17),('12664','2014-02-16','11:55:00',3.36),('12664','2014-02-16','12:00:00',3.3),('12664','2014-02-16','12:05:00',3.35),('12664','2014-02-16','12:10:00',3.37),('12664','2014-02-16','12:15:00',3.35),('12664','2014-02-16','12:20:00',3.33),('12664','2014-02-16','12:25:00',3.31),('12664','2014-02-16','12:30:00',3.31),('12664','2014-02-16','12:35:00',3.27),('12664','2014-02-16','12:40:00',3.26),('12664','2014-02-16','12:45:00',3.24),('12664','2014-02-16','12:50:00',3.24),('12664','2014-02-16','12:55:00',3.25),('12664','2014-02-16','13:00:00',3.28),('12664','2014-02-16','13:05:00',3.08),('12664','2014-02-16','13:10:00',3.26),('12664','2014-02-16','13:15:00',3.23),('12664','2014-02-16','13:20:00',3.16),('12664','2014-02-16','13:25:00',3.11),('12664','2014-02-16','13:30:00',3.11),('12664','2014-02-16','13:35:00',3.07),('12664','2014-02-16','13:40:00',3.12),('12664','2014-02-16','13:45:00',2.94),('12664','2014-02-16','13:50:00',3.01),('12664','2014-02-16','13:55:00',3.03),('12664','2014-02-16','14:00:00',3),('12664','2014-02-16','14:05:00',2.96),('12664','2014-02-16','14:10:00',2.91),('12664','2014-02-16','14:15:00',2.88),('12664','2014-02-16','14:20:00',2.77),('12664','2014-02-16','14:25:00',2.82),('12664','2014-02-16','14:30:00',2.73),('12664','2014-02-16','14:35:00',2.58),('12664','2014-02-16','14:40:00',2.63),('12664','2014-02-16','14:45:00',2.58),('12664','2014-02-16','14:50:00',2.14),('12664','2014-02-16','14:55:00',2.02),('12664','2014-02-16','15:00:00',2.36),('12664','2014-02-16','15:05:00',2.32),('12664','2014-02-16','15:10:00',2.24),('12664','2014-02-16','15:15:00',2.15),('12664','2014-02-16','15:20:00',2.08),('12664','2014-02-16','15:25:00',2),('12664','2014-02-16','15:30:00',1.82),('12664','2014-02-16','15:35:00',1.66),('12664','2014-02-16','16:10:00',1.32),('12664','2014-02-16','16:15:00',1.24),('12664','2014-02-16','16:20:00',1.39),('12664','2014-02-16','16:25:00',1.24),('12664','2014-02-15','08:20:00',1.04),('12664','2014-02-15','08:25:00',1.13),('12664','2014-02-15','08:30:00',1.22),('12664','2014-02-15','08:35:00',1.32),('12664','2014-02-15','08:40:00',1.42),('12664','2014-02-15','08:45:00',1.5),('12664','2014-02-15','08:50:00',1.6),('12664','2014-02-15','08:55:00',1.69),('12664','2014-02-15','09:00:00',1.78),('12664','2014-02-15','09:05:00',1.85),('12664','2014-02-15','09:10:00',1.93),('12664','2014-02-15','09:15:00',2.01),('12664','2014-02-15','09:20:00',2.09),('12664','2014-02-15','09:25:00',2.16),('12664','2014-02-15','09:30:00',2.23),('12664','2014-02-15','09:35:00',2.29),('12664','2014-02-15','09:40:00',2.35),('12664','2014-02-15','09:45:00',2.41),('12664','2014-02-15','09:50:00',2.46),('12664','2014-02-15','09:55:00',2.5),('12664','2014-02-15','10:00:00',2.55),('12664','2014-02-15','10:05:00',2.6),('12664','2014-02-15','10:10:00',2.63),('12664','2014-02-15','10:15:00',2.65),('12664','2014-02-15','10:20:00',2.65),('12664','2014-02-15','10:25:00',2.72),('12664','2014-02-15','10:30:00',2.77),('12664','2014-02-15','10:35:00',2.81),('12664','2014-02-15','10:40:00',2.8),('12664','2014-02-15','10:45:00',2.77),('12664','2014-02-15','10:50:00',2.92),('12664','2014-02-15','10:55:00',2.92),('12664','2014-02-15','11:00:00',2.97),('12664','2014-02-15','11:05:00',3.01),('12664','2014-02-15','11:10:00',3.04),('12664','2014-02-15','11:15:00',3.06),('12664','2014-02-15','11:20:00',3.09),('12664','2014-02-15','11:25:00',3.11),('12664','2014-02-15','11:30:00',3.05),('12664','2014-02-15','11:35:00',3.13),('12664','2014-02-15','11:40:00',2.71),('12664','2014-02-15','11:45:00',2.55),('12664','2014-02-15','11:50:00',1.63),('12664','2014-02-15','11:55:00',3.41),('12664','2014-02-15','12:00:00',3.5),('12664','2014-02-15','12:05:00',2.63),('12664','2014-02-15','12:10:00',3.14),('12664','2014-02-15','12:15:00',3.54),('12664','2014-02-15','12:20:00',3.64),('12664','2014-02-15','12:25:00',3.68),('12664','2014-02-15','12:30:00',3.5),('12664','2014-02-15','12:35:00',2.61),('12664','2014-02-15','12:40:00',3.46),('12664','2014-02-15','12:45:00',2.86),('12664','2014-02-15','12:50:00',3.36),('12664','2014-02-15','12:55:00',3.29),('12664','2014-02-15','13:00:00',3.49),('12664','2014-02-15','13:05:00',3.34),('12664','2014-02-15','13:10:00',3.33),('12664','2014-02-15','13:15:00',3.34),('12664','2014-02-15','13:20:00',3.28),('12664','2014-02-15','13:25:00',3.28),('12664','2014-02-15','13:30:00',2.73),('12664','2014-02-15','13:35:00',2.28),('12664','2014-02-15','13:40:00',3.02),('12664','2014-02-15','13:45:00',3.13),('12664','2014-02-15','13:50:00',3.06),('12664','2014-02-15','13:55:00',2.99),('12664','2014-02-15','14:00:00',2.94),('12664','2014-02-15','14:05:00',2.9),('12664','2014-02-15','14:10:00',2.86),('12664','2014-02-15','14:15:00',2.83),('12664','2014-02-15','14:20:00',2.78),('12664','2014-02-15','14:25:00',2.71),('12664','2014-02-15','14:30:00',2.63),('12664','2014-02-15','14:35:00',2.6),('12664','2014-02-15','14:40:00',2.53),('12664','2014-02-15','14:45:00',2.47),('12664','2014-02-15','14:50:00',2.43),('12664','2014-02-15','14:55:00',2.36),('12664','2014-02-15','15:00:00',2.27),('12664','2014-02-15','15:05:00',2.22),('12664','2014-02-15','15:10:00',2.16),('12664','2014-02-15','15:15:00',2.1),('12664','2014-02-15','15:20:00',2.01),('12664','2014-02-15','15:25:00',1.93),('12664','2014-02-15','15:30:00',1.85),('12664','2014-02-15','15:35:00',1.78),('12664','2014-02-15','15:40:00',1.7),('12664','2014-02-15','15:45:00',1.62),('12664','2014-02-15','15:50:00',1.53),('12664','2014-02-15','15:55:00',1.44),('12664','2014-02-15','16:00:00',1.35),('12664','2014-02-15','16:05:00',1.28),('12664','2014-02-15','16:10:00',1.18),('12664','2014-02-15','16:15:00',1.1),('12664','2014-04-27','08:45:00',1.11),('12664','2014-04-27','08:50:00',1.09),('12664','2014-04-27','10:05:00',1.2),('12664','2014-04-27','10:10:00',1.14),('12664','2014-04-27','10:15:00',1.2),('12664','2014-04-27','10:20:00',1.22),('12664','2014-04-27','10:35:00',1.23),('12664','2014-04-27','10:40:00',1.03),('12664','2014-04-27','11:00:00',1.13),('12664','2014-04-27','11:05:00',1.22),('12664','2014-04-27','11:20:00',1.1),('12664','2014-04-27','11:25:00',2.77),('12664','2014-04-27','11:30:00',2.85),('12664','2014-04-27','11:35:00',2.7),('12664','2014-04-27','11:40:00',2.43),('12664','2014-04-27','11:45:00',1.8),('12664','2014-04-27','11:50:00',1.26),('12664','2014-04-27','11:55:00',1.65),('12664','2014-04-27','12:00:00',1.38),('12664','2014-04-27','12:05:00',1.8),('12664','2014-04-27','12:10:00',1.63),('12664','2014-04-27','12:15:00',1.12),('12664','2014-04-27','12:20:00',1.18),('12664','2014-04-27','12:25:00',1.71),('12664','2014-04-27','12:30:00',2.98),('12664','2014-04-27','12:35:00',2.83),('12664','2014-04-27','12:40:00',2.12),('12664','2014-04-27','12:45:00',2.27),('12664','2014-04-27','12:50:00',1.42),('12664','2014-04-27','12:55:00',1.05),('12664','2014-04-27','13:00:00',1.39),('12664','2014-04-27','13:05:00',1.59),('12664','2014-04-27','13:10:00',1.38),('12664','2014-04-27','13:15:00',1.68),('12664','2014-04-27','13:20:00',1.84),('12664','2014-04-27','13:25:00',2.54),('12664','2014-04-27','13:30:00',1.91),('12664','2014-04-27','13:35:00',1.15),('12664','2014-04-27','13:40:00',1.17),('12664','2014-04-27','13:45:00',1.31),('12664','2014-04-27','13:50:00',2.34),('12664','2014-04-27','13:55:00',1.61),('12664','2014-04-27','14:00:00',1.91),('12664','2014-04-27','14:05:00',1.52),('12664','2014-04-27','14:10:00',1.45),('12664','2014-04-27','14:15:00',1.77),('12664','2014-04-27','14:20:00',1.99),('12664','2014-04-27','14:25:00',2.26),('12664','2014-04-27','14:30:00',2.13),('12664','2014-04-27','14:35:00',2.42),('12664','2014-04-27','14:40:00',2.61),('12664','2014-04-27','14:45:00',1.93),('12664','2014-04-27','14:50:00',1.65),('12664','2014-04-27','14:55:00',1.88),('12664','2014-04-27','15:00:00',2.35),('12664','2014-04-27','15:05:00',2.44),('12664','2014-04-27','15:10:00',2.53),('12664','2014-04-27','15:15:00',2.31),('12664','2014-04-27','15:20:00',1.26),('12664','2014-04-27','15:35:00',1.19),('12664','2014-04-27','15:40:00',1.03),('12664','2014-02-14','08:30:00',1.18),('12664','2014-02-14','08:35:00',1.31),('12664','2014-02-14','08:40:00',1.39),('12664','2014-02-14','08:45:00',1.49),('12664','2014-02-14','08:50:00',1.59),('12664','2014-02-14','08:55:00',1.67),('12664','2014-02-14','09:00:00',1.75),('12664','2014-02-14','09:05:00',1.83),('12664','2014-02-14','09:10:00',1.9),('12664','2014-02-14','09:15:00',1.98),('12664','2014-02-14','09:20:00',2.02),('12664','2014-02-14','09:25:00',2.09),('12664','2014-02-14','09:30:00',2.02),('12664','2014-02-14','09:35:00',2.26),('12664','2014-02-14','09:40:00',2.36),('12664','2014-02-14','09:45:00',2.39),('12664','2014-02-14','09:50:00',2.5),('12664','2014-02-14','09:55:00',2.5),('12664','2014-02-14','10:00:00',2.36),('12664','2014-02-14','10:05:00',2.73),('12664','2014-02-14','10:10:00',2.64),('12664','2014-02-14','10:15:00',2.9),('12664','2014-02-14','10:20:00',2.68),('12664','2014-02-14','10:25:00',2.73),('12664','2014-02-14','10:30:00',2.72),('12664','2014-02-14','10:35:00',2.61),('12664','2014-02-14','10:40:00',2.88),('12664','2014-02-14','10:45:00',3.2),('12664','2014-02-14','10:50:00',3.14),('12664','2014-02-14','10:55:00',3.26),('12664','2014-02-14','11:00:00',3.29),('12664','2014-02-14','11:05:00',3.29),('12664','2014-02-14','11:10:00',3.31),('12664','2014-02-14','11:15:00',3.21),('12664','2014-02-14','11:20:00',3.4),('12664','2014-02-14','11:25:00',3.43),('12664','2014-02-14','11:30:00',3.47),('12664','2014-02-14','11:35:00',3.41),('12664','2014-02-14','11:40:00',2.92),('12664','2014-02-14','11:45:00',3.44),('12664','2014-02-14','11:50:00',3.5),('12664','2014-02-14','11:55:00',3.52),('12664','2014-02-14','12:00:00',3.51),('12664','2014-02-14','12:05:00',3.53),('12664','2014-02-14','12:10:00',3.51),('12664','2014-02-14','12:15:00',3.54),('12664','2014-02-14','12:20:00',3.51),('12664','2014-02-14','12:25:00',3.52),('12664','2014-02-14','12:30:00',3.53),('12664','2014-02-14','12:35:00',3.52),('12664','2014-02-14','12:40:00',3.51),('12664','2014-02-14','12:45:00',3.5),('12664','2014-02-14','12:50:00',3.46),('12664','2014-02-14','12:55:00',3.46),('12664','2014-02-14','13:00:00',3.46),('12664','2014-02-14','13:05:00',3.45),('12664','2014-02-14','13:10:00',3.41),('12664','2014-02-14','13:15:00',3.4),('12664','2014-02-14','13:20:00',3.37),('12664','2014-02-14','13:25:00',3.34),('12664','2014-02-14','13:30:00',3.3),('12664','2014-02-14','13:35:00',3.29),('12664','2014-02-14','13:40:00',3.24),('12664','2014-02-14','13:45:00',3.23),('12664','2014-02-14','13:50:00',3.18),('12664','2014-02-14','13:55:00',3.14),('12664','2014-02-14','14:00:00',3.12),('12664','2014-02-14','14:05:00',3.07),('12664','2014-02-14','14:10:00',3),('12664','2014-02-14','14:15:00',2.96),('12664','2014-02-14','14:20:00',2.88),('12664','2014-02-14','14:25:00',2.83),('12664','2014-02-14','14:30:00',2.78),('12664','2014-02-14','14:35:00',2.73),('12664','2014-02-14','14:40:00',2.67),('12664','2014-02-14','14:45:00',2.61),('12664','2014-02-14','14:50:00',2.53),('12664','2014-02-14','14:55:00',2.45),('12664','2014-02-14','15:00:00',2.36),('12664','2014-02-14','15:05:00',2.29),('12664','2014-02-14','15:10:00',2.22),('12664','2014-02-14','15:15:00',2.15),('12664','2014-02-14','15:20:00',2.06),('12664','2014-02-14','15:25:00',1.98),('12664','2014-02-14','15:30:00',1.9),('12664','2014-02-14','15:35:00',1.81),('12664','2014-02-14','15:40:00',1.73),('12664','2014-02-14','15:45:00',1.64),('12664','2014-02-14','15:50:00',1.55),('12664','2014-02-14','15:55:00',1.46),('12664','2014-02-14','16:00:00',1.37),('12664','2014-02-14','16:05:00',1.29),('12664','2014-02-14','16:10:00',1.18),('12664','2014-02-14','16:15:00',1.08),('12664','2014-02-13','08:20:00',1.05),('12664','2014-02-13','08:25:00',1.12),('12664','2014-02-13','08:30:00',1.2),('12664','2014-02-13','08:35:00',1.3),('12664','2014-02-13','08:40:00',1.41),('12664','2014-02-13','08:45:00',1.5),('12664','2014-02-13','08:50:00',1.6),('12664','2014-02-13','08:55:00',1.68),('12664','2014-02-13','09:00:00',1.77),('12664','2014-02-13','09:05:00',1.85),('12664','2014-02-13','09:10:00',1.92),('12664','2014-02-13','09:15:00',2.01),('12664','2014-02-13','09:20:00',2.11),('12664','2014-02-13','09:25:00',2.18),('12664','2014-02-13','09:30:00',2.25),('12664','2014-02-13','09:35:00',2.31),('12664','2014-02-13','09:40:00',2.38),('12664','2014-02-13','09:45:00',2.45),('12664','2014-02-13','09:50:00',2.52),('12664','2014-02-13','09:55:00',2.57),('12664','2014-02-13','10:00:00',2.63),('12664','2014-02-13','10:05:00',2.66),('12664','2014-02-13','10:10:00',2.7),('12664','2014-02-13','10:15:00',2.76),('12664','2014-02-13','10:20:00',2.81),('12664','2014-02-13','10:25:00',2.86),('12664','2014-02-13','10:30:00',2.89),('12664','2014-02-13','10:35:00',2.93),('12664','2014-02-13','10:40:00',2.99),('12664','2014-02-13','10:45:00',3.03),('12664','2014-02-13','10:50:00',3.07),('12664','2014-02-13','10:55:00',3.08),('12664','2014-02-13','11:00:00',3.12),('12664','2014-02-13','11:05:00',3.06),('12664','2014-02-13','11:10:00',2.53),('12664','2014-02-13','11:15:00',2.93),('12664','2014-02-13','11:20:00',3.2),('12664','2014-02-13','11:25:00',2.14),('12664','2014-02-13','11:30:00',2.85),('12664','2014-02-13','11:35:00',2.13),('12664','2014-02-13','11:40:00',2.85),('12664','2014-02-13','11:45:00',1.46),('12664','2014-02-13','11:50:00',1.83),('12664','2014-02-13','11:55:00',3.53),('12664','2014-02-13','12:00:00',3.53),('12664','2014-02-13','12:05:00',3.55),('12664','2014-02-13','12:10:00',3.14),('12664','2014-02-13','12:15:00',1.13),('12664','2014-02-13','12:20:00',2.36),('12664','2014-02-13','12:25:00',3.87),('12664','2014-02-13','12:30:00',3.43),('12664','2014-02-13','12:35:00',3.74),('12664','2014-02-13','12:40:00',3.71),('12664','2014-02-13','12:45:00',3.74),('12664','2014-02-13','12:50:00',3.78),('12664','2014-02-13','12:55:00',3.71),('12664','2014-02-13','13:00:00',3.67),('12664','2014-02-13','13:05:00',3.54),('12664','2014-02-13','13:10:00',3.38),('12664','2014-02-13','13:15:00',3.36),('12664','2014-02-13','13:20:00',3.36),('12664','2014-02-13','13:25:00',3.34),('12664','2014-02-13','13:30:00',3.31),('12664','2014-02-13','13:35:00',3.3),('12664','2014-02-13','13:40:00',3.26),('12664','2014-02-13','13:45:00',3.23),('12664','2014-02-13','13:50:00',2.93),('12664','2014-02-13','13:55:00',3.15),('12664','2014-02-13','14:00:00',3.15),('12664','2014-02-13','14:05:00',3.07),('12664','2014-02-13','14:10:00',3.02),('12664','2014-02-13','14:15:00',2.96),('12664','2014-02-13','14:20:00',2.92),('12664','2014-02-13','14:25:00',2.95),('12664','2014-02-13','14:30:00',2.93),('12664','2014-02-13','14:35:00',2.93),('12664','2014-02-13','14:40:00',1.1),('12664','2014-02-13','14:45:00',2.34),('12664','2014-02-13','14:50:00',1.73),('12664','2014-02-13','14:55:00',2.15),('12664','2014-02-13','15:00:00',2.46),('12664','2014-02-13','15:05:00',1.53),('12664','2014-02-13','15:10:00',1.91),('12664','2014-02-13','15:15:00',1.57),('12664','2014-02-13','15:20:00',1.52),('12664','2014-02-13','15:25:00',1.26),('12664','2014-02-13','15:30:00',1.08),('12664','2014-02-13','15:35:00',1.4),('12664','2014-02-13','15:40:00',1.34),('12664','2014-02-13','15:45:00',1.7),('12664','2014-02-13','15:50:00',1.64),('12664','2014-02-13','15:55:00',1.32),('12664','2014-02-13','16:00:00',1.43),('12664','2014-02-13','16:05:00',1.32),('12664','2014-02-12','08:25:00',1.08),('12664','2014-02-12','08:30:00',1.18),('12664','2014-02-12','08:35:00',1.29),('12664','2014-02-12','08:40:00',1.39),('12664','2014-02-12','08:45:00',1.49),('12664','2014-02-12','08:50:00',1.58),('12664','2014-02-12','08:55:00',1.24),('12664','2014-02-12','09:00:00',1.6),('12664','2014-02-12','09:05:00',1.4),('12664','2014-02-12','09:10:00',1.95),('12664','2014-02-12','09:15:00',2.05),('12664','2014-02-12','09:20:00',2.16),('12664','2014-02-12','09:25:00',1.78),('12664','2014-02-12','09:40:00',1.02),('12664','2014-02-12','09:45:00',1.37),('12664','2014-02-12','09:50:00',1.83),('12664','2014-02-12','09:55:00',1.93),('12664','2014-02-12','10:00:00',1.4),('12664','2014-02-12','10:05:00',1.17),('12664','2014-02-12','10:10:00',1.06),('12664','2014-02-12','10:20:00',1.11),('12664','2014-02-12','10:25:00',1.12),('12664','2014-02-12','10:30:00',1.34),('12664','2014-02-12','10:35:00',1.03),('12664','2014-02-12','10:40:00',1.01),('12664','2014-02-12','10:45:00',1.13),('12664','2014-02-12','11:00:00',1.01),('12664','2014-02-12','11:05:00',1.09),('12664','2014-02-12','11:10:00',1.55),('12664','2014-02-12','11:15:00',1.92),('12664','2014-02-12','11:20:00',1.09),('12664','2014-02-12','11:25:00',1.94),('12664','2014-02-12','11:30:00',3.09),('12664','2014-02-12','11:35:00',3.79),('12664','2014-02-12','11:40:00',3.75),('12664','2014-02-12','11:45:00',3.57),('12664','2014-02-12','11:50:00',2.23),('12664','2014-02-12','11:55:00',1.05),('12664','2014-02-12','12:00:00',1.06),('12664','2014-02-12','12:05:00',1.09),('12664','2014-02-12','12:10:00',1.22),('12664','2014-02-12','12:15:00',1.09),('12664','2014-02-12','12:20:00',1.06),('12664','2014-02-12','12:25:00',1.14),('12664','2014-02-12','12:30:00',1.22),('12664','2014-02-12','12:35:00',1.29),('12664','2014-02-12','12:40:00',1.34),('12664','2014-02-12','12:45:00',1.57),('12664','2014-02-12','12:50:00',1.88),('12664','2014-02-12','12:55:00',1.73),('12664','2014-02-12','13:00:00',2),('12664','2014-02-12','13:05:00',1.7),('12664','2014-02-12','13:10:00',1.79),('12664','2014-02-12','13:15:00',2.7),('12664','2014-02-12','13:20:00',2.21),('12664','2014-02-12','13:25:00',2.08),('12664','2014-02-12','13:30:00',2.76),('12664','2014-02-12','13:35:00',1.5),('12664','2014-02-12','13:40:00',1.52),('12664','2014-02-12','13:45:00',1.31),('12664','2014-02-12','13:50:00',1.28),('12664','2014-02-12','13:55:00',1.37),('12664','2014-02-12','14:00:00',1.57),('12664','2014-02-12','14:05:00',3.23),('12664','2014-02-12','14:10:00',3.09),('12664','2014-02-12','14:15:00',2.28),('12664','2014-02-12','14:20:00',3.05),('12664','2014-02-12','14:25:00',3.23),('12664','2014-02-12','14:30:00',2.84),('12664','2014-02-12','14:35:00',3.14),('12664','2014-02-12','14:40:00',1.94),('12664','2014-02-12','14:45:00',2.66),('12664','2014-02-12','14:50:00',2.72),('12664','2014-02-12','14:55:00',2.33),('12664','2014-02-12','15:00:00',1.13),('12664','2014-02-12','15:05:00',1.84),('12664','2014-02-12','15:10:00',1.58),('12664','2014-02-12','15:15:00',1.66),('12664','2014-02-12','15:20:00',1.66),('12664','2014-02-12','15:30:00',1.11),('12664','2014-02-12','15:35:00',2.04),('12664','2014-02-12','15:40:00',1.59),('12664','2014-02-12','15:45:00',1.02),('12664','2014-02-12','15:50:00',1.15),('12664','2014-02-11','09:25:00',1.06),('12664','2014-02-11','09:30:00',1.16),('12664','2014-02-11','09:45:00',1.22),('12664','2014-02-11','09:50:00',1.26),('12664','2014-02-11','09:55:00',1.09),('12664','2014-02-11','10:00:00',1.08),('12664','2014-02-11','10:05:00',1.09),('12664','2014-02-11','10:10:00',1.25),('12664','2014-02-11','10:15:00',1.53),('12664','2014-02-11','10:20:00',1.6),('12664','2014-02-11','10:25:00',1.91),('12664','2014-02-11','10:30:00',1.83),('12664','2014-02-11','10:35:00',1.86),('12664','2014-02-11','10:40:00',1.85),('12664','2014-02-11','10:45:00',1.6),('12664','2014-02-11','10:50:00',1.78),('12664','2014-02-11','10:55:00',1.64),('12664','2014-02-11','11:00:00',2.24),('12664','2014-02-11','11:05:00',2.44),('12664','2014-02-11','11:10:00',1.84),('12664','2014-02-11','11:15:00',2.25),('12664','2014-02-11','11:20:00',2.04),('12664','2014-02-11','11:25:00',2.39),('12664','2014-02-11','11:30:00',2.74),('12664','2014-02-11','11:35:00',2.4),('12664','2014-02-11','11:40:00',2.16),('12664','2014-02-11','11:45:00',1.91),('12664','2014-02-11','11:50:00',2.36),('12664','2014-02-11','11:55:00',2.04),('12664','2014-02-11','12:00:00',1.77),('12664','2014-02-11','12:05:00',1.39),('12664','2014-02-11','12:10:00',2.03),('12664','2014-02-11','12:15:00',1.93),('12664','2014-02-11','12:20:00',1.26),('12664','2014-02-11','12:25:00',1.59),('12664','2014-02-11','12:30:00',2.05),('12664','2014-02-11','12:35:00',2.22),('12664','2014-02-11','12:40:00',1.84),('12664','2014-02-11','12:45:00',1.45),('12664','2014-02-11','12:50:00',2.51),('12664','2014-02-11','12:55:00',1.71),('12664','2014-02-11','13:00:00',2.64),('12664','2014-02-11','13:05:00',1.95),('12664','2014-02-11','13:10:00',2.88),('12664','2014-02-11','13:15:00',3.39),('12664','2014-02-11','13:20:00',3.04),('12664','2014-02-11','13:25:00',2.74),('12664','2014-02-11','13:30:00',2.58),('12664','2014-02-11','13:35:00',2.52),('12664','2014-02-11','13:40:00',2.73),('12664','2014-02-11','13:45:00',1.93),('12664','2014-02-11','13:50:00',2.08),('12664','2014-02-11','13:55:00',2.03),('12664','2014-02-11','14:00:00',1.38),('12664','2014-02-11','14:05:00',1.15),('12664','2014-02-11','14:10:00',1.55),('12664','2014-02-11','14:15:00',1.58),('12664','2014-02-11','14:20:00',1.4),('12664','2014-02-11','14:25:00',1.44),('12664','2014-02-11','14:30:00',1.15),('12664','2014-02-11','14:35:00',1.27),('12664','2014-02-11','15:05:00',1.12),('12664','2014-02-11','15:10:00',1.2),('12664','2014-02-11','15:15:00',1.34),('12664','2014-02-11','15:20:00',1.48),('12664','2014-02-11','16:15:00',1.02),('12664','2014-02-09','12:05:00',2.7),('12664','2014-02-09','12:15:00',2.04),('12664','2014-02-09','12:35:00',1.05),('12664','2014-02-09','12:40:00',1.33),('12664','2014-02-09','12:50:00',1.05),('12664','2014-02-09','12:55:00',3.73),('12664','2014-02-09','13:00:00',3.07),('12664','2014-02-09','13:05:00',1.08),('12664','2014-02-09','13:10:00',1.97),('12664','2014-02-09','13:15:00',1.17),('12664','2014-02-09','13:20:00',1.73),('12664','2014-02-09','13:25:00',1.46),('12664','2014-02-09','13:30:00',1.66),('12664','2014-02-09','13:35:00',2.98),('12664','2014-02-09','13:40:00',1.46),('12664','2014-02-09','13:45:00',2.42),('12664','2014-02-09','13:50:00',2.71),('12664','2014-02-09','13:55:00',3.17),('12664','2014-02-09','14:00:00',3.05),('12664','2014-02-09','14:05:00',1.68),('12664','2014-02-09','14:15:00',1.52),('12664','2014-02-09','14:20:00',2.75),('12664','2014-02-09','14:25:00',2.64),('12664','2014-02-09','14:30:00',2.1),('12664','2014-02-09','14:35:00',1.44),('12664','2014-02-09','14:40:00',1.8),('12664','2014-02-09','14:45:00',1.48),('12664','2014-02-09','14:50:00',2.11),('12664','2014-02-09','14:55:00',1.9),('12664','2014-02-09','15:00:00',1.24),('12664','2014-02-09','15:05:00',2.15),('12664','2014-02-09','15:10:00',1.74),('12664','2014-02-09','15:15:00',1.45),('12664','2014-02-09','15:20:00',1.9),('12664','2014-02-09','15:25:00',1.82),('12664','2014-02-09','15:30:00',1.76),('12664','2014-02-09','15:35:00',1.7),('12664','2014-02-09','15:40:00',1.46),('12664','2014-02-09','15:45:00',1.38),('12664','2014-02-09','15:50:00',1.25),('12664','2014-02-09','15:55:00',1.29),('12664','2014-02-09','16:00:00',1.14),('12664','2014-02-09','16:05:00',1.11),('12664','2014-02-08','09:50:00',1.9),('12664','2014-02-08','09:55:00',2.42),('12664','2014-02-08','10:00:00',2.6),('12664','2014-02-08','10:05:00',2.65),('12664','2014-02-08','10:10:00',2.78),('12664','2014-02-08','10:15:00',2.53),('12664','2014-02-08','10:20:00',1.99),('12664','2014-02-08','10:25:00',3.16),('12664','2014-02-08','10:30:00',1.18),('12664','2014-02-08','10:40:00',1.93),('12664','2014-02-08','10:45:00',1.79),('12664','2014-02-08','10:50:00',3.17),('12664','2014-02-08','10:55:00',2.02),('12664','2014-02-08','11:00:00',3.51),('12664','2014-02-08','11:05:00',2.63),('12664','2014-02-08','11:15:00',1.3),('12664','2014-02-08','11:20:00',1.85),('12664','2014-02-08','11:25:00',1.83),('12664','2014-02-08','11:30:00',2.37),('12664','2014-02-08','11:35:00',1),('12664','2014-02-08','11:50:00',3.68),('12664','2014-02-08','11:55:00',3.74),('12664','2014-02-08','12:00:00',2.7),('12664','2014-02-08','12:05:00',2.32),('12664','2014-02-08','12:10:00',2.06),('12664','2014-02-08','12:15:00',1.63),('12664','2014-02-08','12:20:00',3.95),('12664','2014-02-08','12:25:00',2.69),('12664','2014-02-08','12:30:00',2.49),('12664','2014-02-08','12:35:00',3.55),('12664','2014-02-08','12:40:00',2.6),('12664','2014-02-08','12:45:00',1.91),('12664','2014-02-08','12:50:00',3.97),('12664','2014-02-08','12:55:00',4.01),('12664','2014-02-08','13:00:00',2.52),('12664','2014-02-08','13:05:00',2.62),('12664','2014-02-08','13:10:00',2.15),('12664','2014-02-08','13:15:00',2.56),('12664','2014-02-08','13:20:00',2.96),('12664','2014-02-08','13:25:00',2.45),('12664','2014-02-08','13:30:00',2.68),('12664','2014-02-08','13:35:00',1.57),('12664','2014-02-08','13:40:00',1.78),('12664','2014-02-08','13:45:00',1.96),('12664','2014-02-08','13:50:00',1.13),('12664','2014-02-08','13:55:00',3.43),('12664','2014-02-08','14:00:00',3.29),('12664','2014-02-08','14:05:00',3.27),('12664','2014-02-08','14:10:00',2.73),('12664','2014-02-08','14:15:00',2.13),('12664','2014-02-08','14:20:00',2.54),('12664','2014-02-08','14:25:00',2.1),('12664','2014-02-08','14:35:00',2.77),('12664','2014-02-08','14:40:00',2.37),('12664','2014-02-08','14:45:00',1.05),('12664','2014-02-08','14:50:00',1.45),('12664','2014-02-08','14:55:00',1.41),('12664','2014-02-08','15:00:00',2.47),('12664','2014-02-08','15:15:00',1.25),('12664','2014-02-08','15:20:00',1.36),('12664','2014-02-08','15:25:00',1.55),('12664','2014-02-08','15:40:00',1.25),('12664','2014-02-08','15:55:00',1.18),('12664','2014-02-07','08:20:00',1.14),('12664','2014-02-07','08:25:00',1.28),('12664','2014-02-07','08:30:00',1.25),('12664','2014-02-07','08:35:00',1.15),('12664','2014-02-07','08:40:00',1.24),('12664','2014-02-07','08:45:00',1.35),('12664','2014-02-07','08:50:00',1.46),('12664','2014-02-07','08:55:00',1.54),('12664','2014-02-07','09:00:00',1.62),('12664','2014-02-07','09:05:00',1.71),('12664','2014-02-07','09:10:00',1.77),('12664','2014-02-07','09:15:00',1.83),('12664','2014-02-07','09:20:00',1.92),('12664','2014-02-07','09:25:00',1.99),('12664','2014-02-07','09:30:00',2.05),('12664','2014-02-07','09:35:00',2.11),('12664','2014-02-07','09:40:00',2.18),('12664','2014-02-07','09:45:00',2.25),('12664','2014-02-07','09:50:00',2.32),('12664','2014-02-07','09:55:00',2.35),('12664','2014-02-07','10:00:00',2.41),('12664','2014-02-07','10:05:00',2.49),('12664','2014-02-07','10:10:00',2.49),('12664','2014-02-07','10:15:00',2.66),('12664','2014-02-07','10:20:00',2.76),('12664','2014-02-07','10:25:00',2.89),('12664','2014-02-07','10:30:00',2.87),('12664','2014-02-07','10:35:00',1.87),('12664','2014-02-07','10:40:00',2.93),('12664','2014-02-07','10:45:00',3.1),('12664','2014-02-07','10:50:00',2.59),('12664','2014-02-07','10:55:00',1.47),('12664','2014-02-07','11:00:00',1.84),('12664','2014-02-07','11:05:00',3.6),('12664','2014-02-07','11:10:00',2.73),('12664','2014-02-07','11:15:00',1.07),('12664','2014-02-07','11:20:00',1.07),('12664','2014-02-07','11:35:00',2.44),('12664','2014-02-07','11:40:00',1.34),('12664','2014-02-07','11:45:00',3.05),('12664','2014-02-07','11:50:00',3.55),('12664','2014-02-07','11:55:00',3.86),('12664','2014-02-07','12:00:00',3.78),('12664','2014-02-07','12:05:00',3.29),('12664','2014-02-07','12:10:00',3.02),('12664','2014-02-07','12:15:00',2.8),('12664','2014-02-07','12:20:00',2.86),('12664','2014-02-07','12:25:00',3.62),('12664','2014-02-07','12:30:00',3.64),('12664','2014-02-07','12:35:00',3.66),('12664','2014-02-07','12:40:00',3.57),('12664','2014-02-07','12:45:00',2.23),('12664','2014-02-07','12:50:00',1.82),('12664','2014-02-07','12:55:00',3.31),('12664','2014-02-07','13:00:00',2.31),('12664','2014-02-07','13:10:00',3.29),('12664','2014-02-07','13:15:00',3.71),('12664','2014-02-07','13:20:00',2.26),('12664','2014-02-07','13:25:00',3.58),('12664','2014-02-07','13:30:00',3.46),('12664','2014-02-07','13:35:00',3.25),('12664','2014-02-07','13:40:00',3.21),('12664','2014-02-07','13:45:00',2.64),('12664','2014-02-07','13:50:00',3.15),('12664','2014-02-07','13:55:00',3.06),('12664','2014-02-07','14:00:00',2.91),('12664','2014-02-07','14:05:00',2.24),('12664','2014-02-07','14:10:00',3.04),('12664','2014-02-07','14:15:00',2.94),('12664','2014-02-07','14:20:00',2.77),('12664','2014-02-07','14:25:00',2.74),('12664','2014-02-07','14:30:00',2.68),('12664','2014-02-07','14:35:00',2.63),('12664','2014-02-07','14:40:00',2.18),('12664','2014-02-07','14:45:00',2.01),('12664','2014-02-07','14:50:00',2.05),('12664','2014-02-07','14:55:00',2.44),('12664','2014-02-07','15:00:00',1.67),('12664','2014-02-07','15:05:00',2.24),('12664','2014-02-07','15:10:00',2.21),('12664','2014-02-07','15:15:00',2.1),('12664','2014-02-07','15:20:00',1.99),('12664','2014-02-07','15:25:00',1.89),('12664','2014-02-07','15:30:00',1.79),('12664','2014-02-07','15:35:00',1.71),('12664','2014-02-07','15:40:00',1.63),('12664','2014-02-07','15:45:00',1.54),('12664','2014-02-07','15:50:00',1.46),('12664','2014-02-07','15:55:00',1.36),('12664','2014-02-07','16:00:00',1.27),('12664','2014-02-07','16:05:00',1.17),('12664','2014-02-07','16:10:00',1.09),('12664','2014-02-07','16:15:00',1.01),('12664','2014-02-06','08:30:00',1.09),('12664','2014-02-06','08:35:00',1.2),('12664','2014-02-06','08:40:00',1.27),('12664','2014-02-06','08:45:00',1.44),('12664','2014-02-06','08:50:00',1.73),('12664','2014-02-06','08:55:00',1.92),('12664','2014-02-06','09:00:00',1.71),('12664','2014-02-06','09:05:00',1.02),('12664','2014-02-06','09:15:00',1.6),('12664','2014-02-06','09:20:00',2.12),('12664','2014-02-06','09:30:00',2.18),('12664','2014-02-06','09:35:00',2.22),('12664','2014-02-06','09:40:00',2.29),('12664','2014-02-06','09:45:00',2.32),('12664','2014-02-06','09:50:00',2.38),('12664','2014-02-06','09:55:00',2.46),('12664','2014-02-06','10:00:00',2.54),('12664','2014-02-06','10:05:00',2.59),('12664','2014-02-06','10:10:00',2.63),('12664','2014-02-06','10:15:00',2.7),('12664','2014-02-06','10:20:00',2.76),('12664','2014-02-06','10:25:00',2.68),('12664','2014-02-06','10:35:00',1.42),('12664','2014-02-06','10:40:00',2.89),('12664','2014-02-06','10:45:00',2.5),('12664','2014-02-06','10:50:00',1.67),('12664','2014-02-06','10:55:00',2.89),('12664','2014-02-06','11:00:00',1.87),('12664','2014-02-06','11:05:00',3.31),('12664','2014-02-06','11:10:00',3.21),('12664','2014-02-06','11:15:00',3.36),('12664','2014-02-06','11:20:00',3.51),('12664','2014-02-06','11:25:00',3.2),('12664','2014-02-06','11:30:00',3.47),('12664','2014-02-06','11:35:00',3.37),('12664','2014-02-06','11:40:00',3.38),('12664','2014-02-06','11:45:00',3.39),('12664','2014-02-06','11:50:00',3.41),('12664','2014-02-06','11:55:00',3.43),('12664','2014-02-06','12:00:00',3.44),('12664','2014-02-06','12:05:00',3.52),('12664','2014-02-06','12:10:00',3.47),('12664','2014-02-06','12:15:00',3.46),('12664','2014-02-06','12:20:00',3.44),('12664','2014-02-06','12:25:00',3.43),('12664','2014-02-06','12:30:00',3.4),('12664','2014-02-06','12:35:00',3.44),('12664','2014-02-06','12:40:00',3.45),('12664','2014-02-06','12:45:00',3.42),('12664','2014-02-06','12:50:00',3.4),('12664','2014-02-06','12:55:00',3.4),('12664','2014-02-06','13:00:00',3.39),('12664','2014-02-06','13:05:00',3.36),('12664','2014-02-06','13:10:00',3.33),('12664','2014-02-06','13:15:00',3.32),('12664','2014-02-06','13:20:00',3.32),('12664','2014-02-06','13:25:00',3.28),('12664','2014-02-06','13:30:00',3.14),('12664','2014-02-06','13:35:00',3.19),('12664','2014-02-06','13:40:00',3.15),('12664','2014-02-06','13:45:00',3.12),('12664','2014-02-06','13:50:00',3.06),('12664','2014-02-06','13:55:00',3.04),('12664','2014-02-06','14:00:00',2.98),('12664','2014-02-06','14:05:00',2.93),('12664','2014-02-06','14:10:00',2.88),('12664','2014-02-06','14:15:00',2.81),('12664','2014-02-06','14:20:00',2.76),('12664','2014-02-06','14:25:00',2.73),('12664','2014-02-06','14:30:00',2.67),('12664','2014-02-06','14:35:00',2.6),('12664','2014-02-06','14:40:00',2.53),('12664','2014-02-06','14:45:00',2.45),('12664','2014-02-06','14:50:00',2.41),('12664','2014-02-06','14:55:00',2.32),('12664','2014-02-06','15:00:00',2.24),('12664','2014-02-06','15:05:00',2.17),('12664','2014-02-06','15:10:00',2.07),('12664','2014-02-06','15:15:00',1.99),('12664','2014-02-06','15:20:00',1.93),('12664','2014-02-06','15:25:00',1.86),('12664','2014-02-06','15:30:00',1.79),('12664','2014-02-06','15:35:00',1.7),('12664','2014-02-06','15:40:00',1.62),('12664','2014-02-06','15:45:00',1.52),('12664','2014-02-06','15:50:00',1.43),('12664','2014-02-06','15:55:00',1.34),('12664','2014-02-06','16:00:00',1.24),('12664','2014-02-06','16:05:00',1.15),('12664','2014-02-06','16:10:00',1.06),('12664','2014-02-05','09:25:00',1.19),('12664','2014-02-05','10:10:00',1.17),('12664','2014-02-05','10:15:00',1.71),('12664','2014-02-05','10:20:00',1.45),('12664','2014-02-05','10:25:00',1.42),('12664','2014-02-05','10:30:00',3.02),('12664','2014-02-05','10:35:00',2.98),('12664','2014-02-05','10:40:00',2.96),('12664','2014-02-05','10:45:00',2.98),('12664','2014-02-05','10:50:00',2.87),('12664','2014-02-05','10:55:00',1.98),('12664','2014-02-05','11:00:00',2.01),('12664','2014-02-05','11:05:00',2.1),('12664','2014-02-05','11:10:00',1.15),('12664','2014-02-05','11:15:00',1.5),('12664','2014-02-05','11:20:00',1.05),('12664','2014-02-05','12:30:00',1.5),('12664','2014-02-05','12:35:00',1.19),('12664','2014-02-05','12:40:00',1.28),('12664','2014-02-05','12:45:00',1.7),('12664','2014-02-05','12:50:00',1.08),('12664','2014-02-05','12:55:00',1.04),('12664','2014-02-05','13:00:00',1.2),('12664','2014-02-05','13:30:00',1.2),('12664','2014-02-05','13:35:00',1.43),('12664','2014-02-05','13:40:00',1.44),('12664','2014-02-05','13:45:00',1.39),('12664','2014-02-05','14:05:00',1.04),('12664','2014-02-05','14:10:00',1.28),('12664','2014-02-05','14:15:00',1.51),('12664','2014-02-05','14:20:00',2.52),('12664','2014-02-05','14:25:00',2.38),('12664','2014-02-05','14:45:00',1.13),('12664','2014-02-05','14:50:00',1.47),('12664','2014-02-05','14:55:00',1),('12664','2014-02-05','15:20:00',1.09),('12664','2014-04-26','09:45:00',1.05),('12664','2014-04-26','09:50:00',1.1),('12664','2014-04-26','09:55:00',1.25),('12664','2014-04-26','10:00:00',1.61),('12664','2014-04-26','10:05:00',2.29),('12664','2014-04-26','10:10:00',1.72),('12664','2014-04-26','10:15:00',2.06),('12664','2014-04-26','10:20:00',2.35),('12664','2014-04-26','10:25:00',2.17),('12664','2014-04-26','10:30:00',2.42),('12664','2014-04-26','10:35:00',1.9),('12664','2014-04-26','10:40:00',1.57),('12664','2014-04-26','10:45:00',1.48),('12664','2014-04-26','10:50:00',1.73),('12664','2014-04-26','10:55:00',1.96),('12664','2014-04-26','11:00:00',2.31),('12664','2014-04-26','11:05:00',2.76),('12664','2014-04-26','11:10:00',3.58),('12664','2014-04-26','11:15:00',3.84),('12664','2014-04-26','11:20:00',3.83),('12664','2014-04-26','11:25:00',3.56),('12664','2014-04-26','11:30:00',3.81),('12664','2014-04-26','11:35:00',3.72),('12664','2014-04-26','11:40:00',3.8),('12664','2014-04-26','11:45:00',3.7),('12664','2014-04-26','11:50:00',3.49),('12664','2014-04-26','11:55:00',3.22),('12664','2014-04-26','12:00:00',2.04),('12664','2014-04-26','12:05:00',3.5),('12664','2014-04-26','12:10:00',3.7),('12664','2014-04-26','12:15:00',2.18),('12664','2014-04-26','12:20:00',2.5),('12664','2014-04-26','12:25:00',2.72),('12664','2014-04-26','12:30:00',2.59),('12664','2014-04-26','12:35:00',2.73),('12664','2014-04-26','12:40:00',3.78),('12664','2014-04-26','12:45:00',3.4),('12664','2014-04-26','12:50:00',3.52),('12664','2014-04-26','12:55:00',3.37),('12664','2014-04-26','13:00:00',3.46),('12664','2014-04-26','13:05:00',2.84),('12664','2014-04-26','13:10:00',2.95),('12664','2014-04-26','13:15:00',3.27),('12664','2014-04-26','13:20:00',3.65),('12664','2014-04-26','13:25:00',3.18),('12664','2014-04-26','13:30:00',3.41),('12664','2014-04-26','13:35:00',3.19),('12664','2014-04-26','13:40:00',1.63),('12664','2014-04-26','13:45:00',1.13),('12664','2014-04-26','13:50:00',1.97),('12664','2014-04-26','13:55:00',1.6),('12664','2014-04-26','14:00:00',1.68),('12664','2014-04-26','14:05:00',1.81),('12664','2014-04-26','14:10:00',1.49),('12664','2014-04-26','14:15:00',1.09),('12664','2014-04-26','14:20:00',1.17),('12664','2014-04-26','14:25:00',1.63),('12664','2014-04-26','14:30:00',1.36),('12664','2014-04-26','14:35:00',2.07),('12664','2014-04-26','14:45:00',2.19),('12664','2014-04-26','14:50:00',2.78),('12664','2014-04-26','14:55:00',1.1),('12664','2014-02-04','09:25:00',1.16),('12664','2014-02-04','09:30:00',1.09),('12664','2014-02-04','09:35:00',1.42),('12664','2014-02-04','09:40:00',2.37),('12664','2014-02-04','09:45:00',2.48),('12664','2014-02-04','09:50:00',2.38),('12664','2014-02-04','09:55:00',2.46),('12664','2014-02-04','10:00:00',2.55),('12664','2014-02-04','10:05:00',2.61),('12664','2014-02-04','10:10:00',2.66),('12664','2014-02-04','10:15:00',2.7),('12664','2014-02-04','10:20:00',2.51),('12664','2014-02-04','10:25:00',3),('12664','2014-02-04','10:30:00',2.84),('12664','2014-02-04','10:35:00',2.52),('12664','2014-02-04','10:40:00',2.69),('12664','2014-02-04','10:45:00',3.18),('12664','2014-02-04','10:50:00',2.03),('12664','2014-02-04','10:55:00',2.53),('12664','2014-02-04','11:00:00',2.45),('12664','2014-02-04','11:05:00',1.51),('12664','2014-02-04','11:15:00',2.18),('12664','2014-02-04','11:20:00',1.47),('12664','2014-02-04','11:25:00',1),('12664','2014-02-04','11:30:00',1.13),('12664','2014-02-04','11:50:00',1.02),('12664','2014-02-04','11:55:00',1.41),('12664','2014-02-04','12:00:00',1.1),('12664','2014-02-04','12:50:00',1.26),('12664','2014-02-04','12:55:00',1.05),('12664','2014-02-04','13:00:00',1.28),('12664','2014-02-04','13:05:00',1.51),('12664','2014-02-04','13:10:00',1.62),('12664','2014-02-04','13:15:00',1.37),('12664','2014-02-04','13:20:00',1.02),('12664','2014-02-03','10:25:00',1.09),('12664','2014-02-03','10:30:00',1.1),('12664','2014-02-03','11:40:00',1.04),('12664','2014-02-03','11:45:00',1.1),('12664','2014-02-03','11:50:00',1.13),('12664','2014-02-03','11:55:00',1.14),('12664','2014-02-03','12:00:00',1.03),('12664','2014-02-01','11:00:00',1.18),('12664','2014-02-01','11:05:00',1.24),('12664','2014-02-01','11:10:00',1.4),('12664','2014-02-01','11:15:00',1.82),('12664','2014-02-01','11:20:00',2.04),('12664','2014-02-01','11:25:00',2.33),('12664','2014-02-01','11:30:00',2.15),('12664','2014-02-01','11:35:00',2.46),('12664','2014-02-01','11:40:00',2.47),('12664','2014-02-01','11:45:00',1.76),('12664','2014-02-01','11:50:00',2),('12664','2014-02-01','11:55:00',1.94),('12664','2014-02-01','12:00:00',1.39),('12664','2014-02-01','12:05:00',2.44),('12664','2014-02-01','12:10:00',2.35),('12664','2014-02-01','12:15:00',2),('12664','2014-02-01','12:30:00',1.56),('12664','2014-02-01','12:35:00',2.17),('12664','2014-02-01','12:40:00',2.44),('12664','2014-02-01','12:45:00',1.9),('12664','2014-02-01','12:50:00',2.14),('12664','2014-02-01','12:55:00',1.76),('12664','2014-02-01','13:00:00',1.1),('12664','2014-01-30','09:50:00',1.08),('12664','2014-01-30','09:55:00',1.39),('12664','2014-01-30','10:00:00',1.98),('12664','2014-01-30','10:05:00',2.61),('12664','2014-01-30','10:10:00',2.1),('12664','2014-01-30','10:15:00',1.55),('12664','2014-01-30','10:20:00',1.33),('12664','2014-01-30','10:25:00',1.32),('12664','2014-01-30','10:30:00',1.43),('12664','2014-01-30','10:35:00',1.57),('12664','2014-01-30','10:40:00',1.22),('12664','2014-01-30','10:45:00',1.51),('12664','2014-01-30','10:50:00',1.46),('12664','2014-01-30','10:55:00',1.37),('12664','2014-01-30','11:00:00',1.62),('12664','2014-01-30','11:05:00',1.78),('12664','2014-01-30','11:10:00',2.04),('12664','2014-01-30','11:15:00',2.49),('12664','2014-01-30','11:20:00',2.85),('12664','2014-01-30','11:25:00',2.95),('12664','2014-01-30','11:30:00',2.75),('12664','2014-01-30','11:35:00',2.45),('12664','2014-01-30','11:40:00',3.04),('12664','2014-01-30','11:45:00',3.31),('12664','2014-01-30','11:50:00',3.3),('12664','2014-01-30','11:55:00',2.61),('12664','2014-01-30','12:00:00',3.27),('12664','2014-01-30','12:05:00',3.05),('12664','2014-01-30','12:10:00',1.66),('12664','2014-01-30','12:15:00',1.7),('12664','2014-01-30','12:20:00',2.46),('12664','2014-01-30','12:25:00',2.73),('12664','2014-01-30','12:30:00',2.73),('12664','2014-01-30','12:35:00',3.15),('12664','2014-01-30','12:40:00',3.13),('12664','2014-01-30','12:45:00',3.06),('12664','2014-01-30','12:50:00',3.07),('12664','2014-01-30','12:55:00',3.13),('12664','2014-01-30','13:00:00',3.1),('12664','2014-01-30','13:05:00',3.18),('12664','2014-01-30','13:10:00',3.19),('12664','2014-01-30','13:15:00',3.07),('12664','2014-01-30','13:20:00',3.02),('12664','2014-01-30','13:25:00',2.24),('12664','2014-01-30','13:30:00',2.23),('12664','2014-01-30','13:35:00',2.19),('12664','2014-01-30','13:40:00',2.47),('12664','2014-01-30','13:45:00',3.02),('12664','2014-01-30','13:50:00',3.02),('12664','2014-01-30','13:55:00',2.6),('12664','2014-01-30','14:00:00',2.2),('12664','2014-01-30','14:05:00',2.06),('12664','2014-01-30','14:10:00',2.07),('12664','2014-01-30','14:15:00',1.92),('12664','2014-01-30','14:20:00',1.48),('12664','2014-01-30','14:25:00',1.82),('12664','2014-01-30','14:30:00',1.87),('12664','2014-01-30','14:35:00',1.48),('12664','2014-01-30','14:40:00',2.24),('12664','2014-01-30','14:45:00',2.46),('12664','2014-01-30','14:50:00',2.25),('12664','2014-01-30','14:55:00',2.21),('12664','2014-01-30','15:00:00',1.71),('12664','2014-01-30','15:05:00',1.86),('12664','2014-01-30','15:10:00',1.57),('12664','2014-01-30','15:20:00',1.85),('12664','2014-01-30','15:25:00',1.72),('12664','2014-01-30','15:30:00',1.6),('12664','2014-01-30','15:35:00',1.48),('12664','2014-01-29','09:15:00',1.32),('12664','2014-01-29','09:20:00',1.52),('12664','2014-01-29','09:25:00',1.47),('12664','2014-01-29','09:30:00',1.45),('12664','2014-01-29','09:35:00',1.41),('12664','2014-01-29','09:40:00',1.29),('12664','2014-01-29','09:45:00',1.08),('12664','2014-01-29','10:05:00',1.05),('12664','2014-01-29','10:10:00',1.36),('12664','2014-01-29','10:15:00',1.38),('12664','2014-01-29','10:20:00',3.2),('12664','2014-01-29','10:25:00',2.88),('12664','2014-01-29','10:30:00',2.23),('12664','2014-01-29','10:35:00',2),('12664','2014-01-29','10:40:00',1.59),('12664','2014-01-29','10:45:00',1.42),('12664','2014-01-29','10:50:00',1.46),('12664','2014-01-29','10:55:00',1.58),('12664','2014-01-29','11:00:00',1.82),('12664','2014-01-29','11:05:00',2),('12664','2014-01-29','11:10:00',1.85),('12664','2014-01-29','11:15:00',1.81),('12664','2014-01-29','11:20:00',2.07),('12664','2014-01-29','11:25:00',2),('12664','2014-01-29','11:30:00',2.23),('12664','2014-01-29','11:35:00',2.53),('12664','2014-01-29','11:40:00',3.23),('12664','2014-01-29','11:45:00',2.78),('12664','2014-01-29','11:50:00',1.32),('12664','2014-01-29','12:15:00',1.3),('12664','2014-01-29','12:20:00',1.77),('12664','2014-01-29','12:25:00',1.06),('12664','2014-01-29','12:35:00',1.31),('12664','2014-01-29','12:40:00',2.46),('12664','2014-01-29','12:45:00',2.77),('12664','2014-01-29','12:50:00',3.36),('12664','2014-01-29','12:55:00',3.05),('12664','2014-01-29','13:00:00',2.58),('12664','2014-01-29','13:05:00',2.75),('12664','2014-01-29','13:35:00',1.78),('12664','2014-01-29','13:40:00',2.97),('12664','2014-01-29','13:45:00',2.54),('12664','2014-01-29','13:50:00',2.99),('12664','2014-01-29','13:55:00',3.32),('12664','2014-01-29','14:00:00',2.34),('12664','2014-01-29','14:05:00',1.41),('12664','2014-01-28','09:15:00',1.15),('12664','2014-01-28','09:20:00',1.2),('12664','2014-01-28','09:25:00',1.44),('12664','2014-01-28','09:30:00',1.39),('12664','2014-01-28','09:35:00',1.25),('12664','2014-01-28','09:40:00',1.35),('12664','2014-01-28','09:45:00',1.62),('12664','2014-01-28','09:50:00',2.01),('12664','2014-01-28','09:55:00',2.09),('12664','2014-01-28','10:00:00',2.28),('12664','2014-01-28','10:05:00',2.43),('12664','2014-01-28','10:10:00',2.6),('12664','2014-01-28','10:15:00',2.72),('12664','2014-01-28','10:20:00',2.73),('12664','2014-01-28','10:25:00',2.78),('12664','2014-01-28','10:30:00',2.68),('12664','2014-01-28','10:35:00',2.67),('12664','2014-01-28','10:40:00',3.04),('12664','2014-01-28','10:45:00',3.14),('12664','2014-01-28','10:50:00',2.91),('12664','2014-01-28','10:55:00',2.43),('12664','2014-01-28','11:00:00',2.56),('12664','2014-01-28','11:10:00',2.63),('12664','2014-01-28','11:15:00',2.41),('12664','2014-01-28','11:20:00',2.23),('12664','2014-01-28','11:25:00',1.3),('12664','2014-01-28','11:30:00',2.61),('12664','2014-01-28','11:35:00',1.96),('12664','2014-01-28','11:40:00',1.82),('12664','2014-01-28','11:45:00',1.49),('12664','2014-01-28','11:50:00',3.38),('12664','2014-01-28','11:55:00',3.56),('12664','2014-01-28','12:00:00',1.69),('12664','2014-01-28','12:05:00',2.82),('12664','2014-01-28','12:10:00',1.46),('12664','2014-01-28','12:15:00',1.27),('12664','2014-01-28','12:20:00',1.23),('12664','2014-01-28','12:25:00',1.21),('12664','2014-01-28','12:30:00',1.25),('12664','2014-01-28','12:35:00',1.31),('12664','2014-01-28','12:40:00',1.5),('12664','2014-01-28','12:45:00',3.58),('12664','2014-01-28','12:50:00',3.63),('12664','2014-01-28','12:55:00',3.3),('12664','2014-01-28','13:00:00',2.7),('12664','2014-01-28','13:05:00',2.1),('12664','2014-01-28','13:10:00',3.17),('12664','2014-01-28','13:15:00',3.13),('12664','2014-01-28','13:20:00',3.12),('12664','2014-01-28','13:25:00',2.84),('12664','2014-01-28','13:30:00',3.05),('12664','2014-01-28','13:35:00',3.23),('12664','2014-01-28','13:40:00',3.16),('12664','2014-01-28','13:45:00',3.07),('12664','2014-01-28','13:50:00',2.97),('12664','2014-01-28','13:55:00',2.92),('12664','2014-01-28','14:00:00',2.87),('12664','2014-01-28','14:05:00',2.84),('12664','2014-01-28','14:10:00',2.79),('12664','2014-01-28','14:15:00',2.68),('12664','2014-01-28','14:20:00',2.66),('12664','2014-01-28','14:25:00',2.6),('12664','2014-01-28','14:30:00',2.55),('12664','2014-01-28','14:35:00',2.48),('12664','2014-01-28','14:40:00',2.4),('12664','2014-01-28','14:45:00',2.34),('12664','2014-01-28','14:50:00',2.28),('12664','2014-01-28','14:55:00',2.2),('12664','2014-01-28','15:00:00',2.13),('12664','2014-01-28','15:05:00',2.05),('12664','2014-01-28','15:10:00',1.96),('12664','2014-01-28','15:15:00',1.88),('12664','2014-01-28','15:20:00',1.8),('12664','2014-01-28','15:25:00',1.71),('12664','2014-01-28','15:30:00',1.63),('12664','2014-01-28','15:35:00',1.54),('12664','2014-01-28','15:40:00',1.44),('12664','2014-01-28','15:45:00',1.36),('12664','2014-01-28','15:50:00',1.27),('12664','2014-01-28','15:55:00',1.16),('12664','2014-01-28','16:00:00',1.07),('12664','2014-01-26','09:00:00',1.32),('12664','2014-01-26','09:05:00',1.02),('12664','2014-01-26','09:25:00',1.64),('12664','2014-01-26','09:30:00',1.55),('12664','2014-01-26','09:45:00',1.33),('12664','2014-01-26','09:50:00',1.03),('12664','2014-01-26','10:05:00',1.3),('12664','2014-01-26','10:10:00',1.49),('12664','2014-01-26','10:15:00',1.29),('12664','2014-01-26','11:00:00',1.07),('12664','2014-01-26','11:05:00',1.01),('12664','2014-01-26','11:20:00',1.51),('12664','2014-01-26','11:25:00',2),('12664','2014-01-26','12:10:00',1.21),('12664','2014-01-26','12:15:00',1.27),('12664','2014-01-26','12:20:00',1.69),('12664','2014-01-26','12:25:00',2.55),('12664','2014-01-26','12:30:00',1.47),('12664','2014-01-26','12:35:00',1.12),('12664','2014-01-26','13:00:00',1.18),('12664','2014-01-26','13:05:00',1.18),('12664','2014-01-26','13:10:00',1.21),('12664','2014-01-26','13:15:00',1.33),('12664','2014-01-26','13:20:00',1.26),('12664','2014-01-26','13:25:00',1.12),('12664','2014-01-26','13:45:00',1.17),('12664','2014-01-26','15:40:00',1.66),('1444','2014-05-05','07:50:00',1),('1444','2014-05-05','07:55:00',1.07),('1444','2014-05-05','08:00:00',1.14),('1444','2014-05-05','08:05:00',1.2),('1444','2014-05-05','08:10:00',1.27),('1444','2014-05-05','08:15:00',1.35),('1444','2014-05-05','08:20:00',1.42),('1444','2014-05-05','08:25:00',1.5),('1444','2014-05-05','08:30:00',1.57),('1444','2014-05-05','08:35:00',1.65),('1444','2014-05-05','08:40:00',1.72),('1444','2014-05-05','08:45:00',1.78),('1444','2014-05-05','08:50:00',1.84),('1444','2014-05-05','08:55:00',1.9),('1444','2014-05-05','09:00:00',1.95),('1444','2014-05-05','09:05:00',2),('1444','2014-05-05','09:10:00',2.07),('1444','2014-05-05','09:15:00',2.14),('1444','2014-05-05','09:20:00',2.2),('1444','2014-05-05','09:25:00',2.24),('1444','2014-05-05','09:30:00',2.31),('1444','2014-05-05','09:35:00',2.37),('1444','2014-05-05','09:40:00',2.41),('1444','2014-05-05','09:45:00',2.47),('1444','2014-05-05','09:50:00',2.54),('1444','2014-05-05','09:55:00',2.6),('1444','2014-05-05','10:00:00',2.64),('1444','2014-05-05','10:05:00',2.72),('1444','2014-05-05','10:10:00',2.76),('1444','2014-05-05','10:15:00',2.79),('1444','2014-05-05','10:20:00',2.81),('1444','2014-05-05','10:25:00',2.85),('1444','2014-05-05','10:30:00',2.88),('1444','2014-05-05','10:35:00',2.92),('1444','2014-05-05','10:40:00',2.96),('1444','2014-05-05','10:45:00',2.97),('1444','2014-05-05','10:50:00',2.99),('1444','2014-05-05','10:55:00',3.02),('1444','2014-05-05','11:00:00',3.07),('1444','2014-05-05','11:05:00',3.09),('1444','2014-05-05','11:10:00',3.1),('1444','2014-05-05','11:15:00',3.17),('1444','2014-05-05','11:20:00',3.15),('1444','2014-05-05','11:25:00',3.21),('1444','2014-05-05','11:30:00',3.2),('1444','2014-05-05','11:35:00',3.22),('1444','2014-05-05','11:40:00',3.24),('1444','2014-05-05','11:45:00',3.31),('1444','2014-05-05','11:50:00',3.35),('1444','2014-05-05','11:55:00',3.36),('1444','2014-05-05','12:00:00',3.47),('1444','2014-05-05','12:05:00',2.37),('1444','2014-05-05','12:10:00',1.27),('1444','2014-05-05','12:15:00',1.58),('1444','2014-05-05','12:20:00',1.81),('1444','2014-05-05','12:25:00',1.4),('1444','2014-05-05','12:30:00',2.51),('1444','2014-05-05','12:35:00',2.83),('1444','2014-05-05','12:40:00',1.22),('1444','2014-05-05','12:45:00',2.98),('1444','2014-05-05','12:50:00',3.14),('1444','2014-05-05','12:55:00',1.7),('1444','2014-05-05','13:00:00',1.03),('1444','2014-05-05','13:05:00',1.04),('1444','2014-05-05','13:10:00',3.8),('1444','2014-05-05','13:15:00',3.66),('1444','2014-05-05','13:20:00',3.5),('1444','2014-05-05','13:25:00',3.45),('1444','2014-05-05','13:30:00',3.47),('1444','2014-05-05','13:35:00',3.53),('1444','2014-05-05','13:40:00',3.52),('1444','2014-05-05','13:45:00',3.22),('1444','2014-05-05','13:50:00',3.54),('1444','2014-05-05','13:55:00',3.53),('1444','2014-05-05','14:00:00',3.5),('1444','2014-05-05','14:05:00',2.75),('1444','2014-05-05','14:10:00',1.26),('1444','2014-05-05','14:15:00',3.74),('1444','2014-05-05','14:20:00',3.3),('1444','2014-05-05','14:25:00',3.32),('1444','2014-05-05','14:30:00',3.52),('1444','2014-05-05','14:35:00',2.15),('1444','2014-05-05','14:40:00',2.26),('1444','2014-05-05','14:45:00',1.78),('1444','2014-05-05','14:50:00',1.13),('1444','2014-05-05','14:55:00',1.32),('1444','2014-05-05','15:00:00',2.67),('1444','2014-05-05','15:05:00',3.32),('1444','2014-05-05','15:10:00',3.21),('1444','2014-05-05','15:15:00',1.08),('1444','2014-05-05','15:20:00',1.09),('1444','2014-05-05','15:25:00',1.55),('1444','2014-05-05','15:30:00',1.49),('1444','2014-05-05','15:40:00',3.11),('1444','2014-05-05','15:45:00',2.61),('1444','2014-05-05','15:50:00',1.11),('1444','2014-05-05','16:00:00',1.03),('1444','2014-05-05','16:05:00',1.78),('1444','2014-05-05','16:10:00',2.68),('1444','2014-05-05','16:15:00',1.04),('1444','2014-05-05','16:20:00',1.75),('1444','2014-05-05','16:25:00',1.5),('1444','2014-05-05','16:30:00',1.04),('1444','2014-05-05','16:35:00',2.55),('1444','2014-05-05','16:40:00',2.49),('1444','2014-05-05','16:45:00',2.27),('1444','2014-05-05','16:50:00',2.27),('1444','2014-05-05','16:55:00',2.14),('1444','2014-05-05','17:00:00',2),('1444','2014-05-05','17:05:00',1.91),('1444','2014-05-05','17:10:00',1.93),('1444','2014-05-05','17:15:00',1.86),('1444','2014-05-05','17:20:00',1.77),('1444','2014-05-05','17:25:00',1.68),('1444','2014-05-05','17:30:00',1.59),('1444','2014-05-05','17:35:00',1.49),('1444','2014-05-05','17:40:00',1.43),('1444','2014-05-05','17:45:00',1.37),('1444','2014-05-05','17:50:00',1.3),('1444','2014-05-05','17:55:00',1.23),('1444','2014-05-05','18:00:00',1.15),('1444','2014-05-05','18:05:00',1.09),('1444','2014-05-05','18:10:00',1.03),('1444','2014-04-26','09:55:00',1.08),('1444','2014-04-26','10:00:00',1.15),('1444','2014-04-26','10:05:00',1.01),('1444','2014-04-26','10:15:00',1.04),('1444','2014-04-26','10:20:00',1.21),('1444','2014-04-26','10:25:00',1.42),('1444','2014-04-26','10:30:00',1.59),('1444','2014-04-26','10:35:00',1.65),('1444','2014-04-26','10:40:00',1.48),('1444','2014-04-26','10:45:00',1.69),('1444','2014-04-26','10:50:00',2.27),('1444','2014-04-26','10:55:00',2.74),('1444','2014-04-26','11:00:00',2.8),('1444','2014-04-26','11:05:00',2.76),('1444','2014-04-26','11:10:00',2.46),('1444','2014-04-26','11:15:00',2.44),('1444','2014-04-26','11:20:00',2.39),('1444','2014-04-26','11:25:00',2.28),('1444','2014-04-26','11:30:00',2.37),('1444','2014-04-26','11:35:00',2.43),('1444','2014-04-26','11:40:00',2.34),('1444','2014-04-26','11:45:00',2.42),('1444','2014-04-26','11:50:00',2.36),('1444','2014-04-26','11:55:00',2.29),('1444','2014-04-26','12:00:00',2.4),('1444','2014-04-26','12:05:00',2.66),('1444','2014-04-26','12:10:00',2.76),('1444','2014-04-26','12:15:00',1.8),('1444','2014-04-26','12:20:00',2.18),('1444','2014-04-26','12:25:00',2.55),('1444','2014-04-26','12:30:00',1.67),('1444','2014-04-26','12:35:00',2.97),('1444','2014-04-26','12:40:00',2.75),('1444','2014-04-26','12:45:00',3.15),('1444','2014-04-26','12:50:00',3.32),('1444','2014-04-26','12:55:00',3.33),('1444','2014-04-26','13:00:00',3),('1444','2014-04-26','13:05:00',2.76),('1444','2014-04-26','13:10:00',2.4),('1444','2014-04-26','13:15:00',3.24),('1444','2014-04-26','13:20:00',3.55),('1444','2014-04-26','13:25:00',3.56),('1444','2014-04-26','13:30:00',1.19),('1444','2014-04-26','13:35:00',1.38),('1444','2014-04-26','13:40:00',3.46),('1444','2014-04-26','13:45:00',3.4),('1444','2014-04-26','13:50:00',3.25),('1444','2014-04-26','13:55:00',3.36),('1444','2014-04-26','14:00:00',2.8),('1444','2014-04-26','14:10:00',1.09),('1444','2014-04-26','14:15:00',2.01),('1444','2014-04-26','14:35:00',1.2),('1444','2014-04-26','14:40:00',1.83),('1444','2014-01-26','10:10:00',1.19),('1444','2014-01-26','10:15:00',1.34),('1444','2014-01-26','12:30:00',1.76),('1444','2014-01-26','12:35:00',1.25),('1444','2014-01-26','13:20:00',1.05),('1444','2014-01-25','09:55:00',1.26),('1444','2014-01-25','10:05:00',1.47),('1444','2014-01-25','10:10:00',1.56),('1444','2014-01-25','10:15:00',1.7),('1444','2014-01-25','10:20:00',1.7),('1444','2014-01-25','10:25:00',1.19),('1444','2014-01-25','10:30:00',1.15),('1444','2014-01-25','10:40:00',1.27),('1444','2014-01-25','10:50:00',1.21),('1444','2014-01-25','10:55:00',1.28),('1444','2014-01-25','11:15:00',1.07),('1444','2014-01-25','11:30:00',2.23),('1444','2014-01-25','11:35:00',2.44),('1444','2014-01-25','11:40:00',1.27),('1444','2014-01-25','11:50:00',1.14),('1444','2014-01-25','11:55:00',1.18),('1444','2014-01-25','12:00:00',1.14),('1444','2014-01-25','12:05:00',1.22),('1444','2014-01-25','12:10:00',1.3),('1444','2014-01-25','12:15:00',1.25),('1444','2014-01-25','12:20:00',1.3),('1444','2014-01-25','12:25:00',1.39),('1444','2014-01-25','12:30:00',1.36),('1444','2014-01-25','12:35:00',1.22),('1444','2014-01-25','12:40:00',1.28),('1444','2014-01-25','12:45:00',1.5),('1444','2014-01-25','12:50:00',1.52),('1444','2014-01-25','12:55:00',1.71),('1444','2014-01-25','13:00:00',1.71),('1444','2014-01-25','13:05:00',1.57),('1444','2014-01-25','13:10:00',1.82),('1444','2014-01-25','13:15:00',1.58),('1444','2014-01-25','13:25:00',1.13),('1444','2014-01-25','13:35:00',1.06),('1444','2014-01-25','14:10:00',1.37),('1444','2014-01-25','14:20:00',1.17),('1444','2014-01-25','14:25:00',1.37),('1444','2014-01-25','14:30:00',1.52),('1444','2014-01-25','14:35:00',1.66),('1444','2014-01-25','14:40:00',1.58),('1444','2014-01-25','14:45:00',1.55),('1444','2014-01-25','14:50:00',1.41),('1444','2014-01-25','14:55:00',1.28),('1444','2014-01-25','15:00:00',1.11),('1444','2014-01-25','15:05:00',1.01),('1444','2014-01-24','10:35:00',1.06),('1444','2014-01-24','10:40:00',1.37),('1444','2014-01-24','10:45:00',1.04),('1444','2014-01-24','11:45:00',1.33),('1444','2014-01-24','11:50:00',1.97),('1444','2014-01-24','11:55:00',2.14),('1444','2014-01-24','12:00:00',1.37),('1444','2014-01-24','12:25:00',1.1),('1444','2014-01-24','12:35:00',1.95),('1444','2014-01-24','12:40:00',1.59),('1444','2014-01-24','12:45:00',1.12),('1444','2014-01-24','12:55:00',1.07),('1444','2014-01-24','13:00:00',1.27),('1444','2014-01-24','13:05:00',1.4),('1444','2014-01-24','13:35:00',1.27),('1444','2014-01-24','13:40:00',1.03),('1444','2014-01-24','13:45:00',1.33),('1444','2014-01-24','13:50:00',1.52),('1444','2014-01-24','13:55:00',1.37),('1444','2014-01-24','14:10:00',1.93),('1444','2014-01-24','14:15:00',1.53),('1444','2014-01-24','14:20:00',1.36),('1444','2014-01-24','14:25:00',1.19),('1444','2014-01-22','13:15:00',1.23),('1444','2014-01-21','10:55:00',1.01),('1444','2014-01-21','11:00:00',1.46),('1444','2014-01-21','12:10:00',1.21),('1444','2014-01-21','12:30:00',1.13),('1444','2014-01-21','12:35:00',1.01),('1444','2014-01-21','12:50:00',1),('1444','2014-01-20','11:20:00',1.14),('1444','2014-01-20','11:25:00',1.31),('1444','2014-01-20','11:30:00',1.32),('1444','2014-01-20','11:35:00',1.38),('1444','2014-01-20','11:40:00',1.96),('1444','2014-01-20','11:45:00',1.95),('1444','2014-01-20','11:50:00',1.23),('1444','2014-01-20','13:20:00',2.43),('1444','2014-01-20','13:25:00',2),('1444','2014-01-20','13:30:00',1.74),('1444','2014-01-20','13:35:00',1.71),('1444','2014-01-20','13:40:00',1.37),('1444','2014-01-20','13:45:00',1.3),('1444','2014-01-20','13:55:00',1.06),('1444','2014-01-20','14:00:00',1.78),('1444','2014-01-20','14:05:00',1.19),('1444','2014-01-19','14:25:00',1.08),('1444','2014-01-19','14:30:00',1.23),('1444','2014-01-18','10:05:00',1.07),('1444','2014-01-18','10:10:00',1.37),('1444','2014-01-18','10:15:00',1.46),('1444','2014-01-18','10:20:00',1.24),('1444','2014-01-18','10:25:00',1.01),('1444','2014-01-18','10:30:00',1.06),('1444','2014-01-18','11:10:00',1.21),('1444','2014-01-18','11:15:00',1.69),('1444','2014-01-18','11:20:00',1.6),('1444','2014-01-18','11:25:00',1.53),('1444','2014-01-18','11:30:00',1.57),('1444','2014-01-18','11:35:00',1.62),('1444','2014-01-18','11:40:00',1.69),('1444','2014-01-18','11:45:00',1.86),('1444','2014-01-18','11:50:00',1.84),('1444','2014-01-18','11:55:00',1.91),('1444','2014-01-18','12:00:00',1.84),('1444','2014-01-18','12:05:00',1.34),('1444','2014-01-18','12:10:00',1.75),('1444','2014-01-18','12:15:00',1.64),('1444','2014-01-18','12:20:00',1.64),('1444','2014-01-18','12:25:00',1.62),('1444','2014-01-18','12:30:00',1.64),('1444','2014-01-18','12:35:00',1.63),('1444','2014-01-18','12:40:00',1.64),('1444','2014-01-18','12:45:00',1.56),('1444','2014-01-18','12:50:00',1.48),('1444','2014-01-18','12:55:00',1.7),('1444','2014-01-18','13:00:00',1.12),('1444','2014-01-18','13:05:00',1.07),('1444','2014-01-18','13:10:00',1.38),('1444','2014-01-18','13:15:00',1.65),('1444','2014-01-18','13:20:00',1.07),('1444','2014-01-18','13:30:00',1.41),('1444','2014-01-18','13:40:00',1.29),('1444','2014-01-18','13:45:00',1.42),('1444','2014-01-18','13:50:00',1.06),('1444','2014-01-18','13:55:00',1.36),('1444','2014-01-18','14:00:00',1.34),('1444','2014-01-18','14:05:00',1.26),('1444','2014-01-18','14:10:00',1.17),('1444','2014-01-18','14:15:00',1.11),('1444','2014-01-18','14:20:00',1.14),('1444','2014-01-18','14:25:00',1.08),('1444','2014-01-18','14:30:00',1.04),('1444','2014-01-18','14:35:00',1.02),('1444','2014-01-17','09:40:00',1.01),('1444','2014-01-17','09:45:00',1.12),('1444','2014-01-17','11:30:00',1.25),('1444','2014-01-17','11:35:00',1.32),('1444','2014-01-17','11:40:00',1.19),('1444','2014-01-17','12:05:00',1.01),('1444','2014-04-25','08:10:00',1.04),('1444','2014-04-25','08:15:00',1.08),('1444','2014-04-25','08:20:00',1.14),('1444','2014-04-25','08:25:00',1.2),('1444','2014-04-25','08:30:00',1.24),('1444','2014-04-25','08:35:00',1.31),('1444','2014-04-25','08:40:00',1.36),('1444','2014-04-25','08:45:00',1.44),('1444','2014-04-25','08:50:00',1.53),('1444','2014-04-25','08:55:00',1.64),('1444','2014-04-25','09:00:00',1.28),('1444','2014-04-25','09:25:00',1.21),('1444','2014-04-25','10:00:00',1.04),('1444','2014-04-25','10:05:00',1),('1444','2014-04-25','10:10:00',1.06),('1444','2014-04-25','10:20:00',1.04),('1444','2014-04-25','10:25:00',1.06),('1444','2014-04-25','10:37:00',1.28),('1444','2014-04-25','10:40:00',1.68),('1444','2014-04-25','10:45:00',2.22),('1444','2014-04-25','10:50:00',2.21),('1444','2014-04-25','10:55:00',2.63),('1444','2014-04-25','11:00:00',2.09),('1444','2014-04-25','11:05:00',1.49),('1444','2014-04-25','11:10:00',1.68),('1444','2014-04-25','11:15:00',2.88),('1444','2014-04-25','11:20:00',1.65),('1444','2014-04-25','11:25:00',3.25),('1444','2014-04-25','11:30:00',2.26),('1444','2014-04-25','11:35:00',1.83),('1444','2014-04-25','11:40:00',2.58),('1444','2014-04-25','11:45:00',2.29),('1444','2014-04-25','11:50:00',2.63),('1444','2014-04-25','11:55:00',3.39),('1444','2014-04-25','12:00:00',3),('1444','2014-04-25','12:05:00',2.92),('1444','2014-04-25','12:10:00',2.93),('1444','2014-04-25','12:15:00',1.06),('1444','2014-04-25','12:20:00',2.1),('1444','2014-04-25','12:25:00',3.17),('1444','2014-04-25','12:30:00',3.34),('1444','2014-04-25','12:35:00',3.43),('1444','2014-04-25','12:40:00',3.48),('1444','2014-04-25','12:45:00',3.49),('1444','2014-04-25','12:50:00',3.64),('1444','2014-04-25','12:55:00',3.09),('1444','2014-04-25','13:00:00',3.43),('1444','2014-04-25','13:05:00',3.43),('1444','2014-04-25','13:10:00',3.46),('1444','2014-04-25','13:15:00',3.47),('1444','2014-04-25','13:20:00',2.02),('1444','2014-04-25','13:25:00',2.37),('1444','2014-04-25','13:30:00',1.08),('1444','2014-04-25','13:40:00',1.43),('1444','2014-04-25','13:45:00',1.12),('1444','2014-04-25','13:55:00',1.21),('1444','2014-04-25','14:00:00',1.1),('1444','2014-04-25','14:05:00',1.25),('1444','2014-04-25','14:15:00',1.22),('1444','2014-04-25','14:20:00',1.69),('1444','2014-04-25','14:25:00',1.23),('1444','2014-04-25','14:30:00',3.32),('1444','2014-04-25','14:35:00',2.93),('1444','2014-04-25','14:40:00',2.15),('1444','2014-04-25','14:45:00',2.96),('1444','2014-04-25','14:50:00',2.93),('1444','2014-04-25','14:55:00',2.89),('1444','2014-04-25','15:00:00',2.84),('1444','2014-04-25','15:05:00',2.79),('1444','2014-04-25','15:10:00',2.79),('1444','2014-04-25','15:15:00',2.74),('1444','2014-04-25','15:20:00',2.62),('1444','2014-04-25','15:25:00',2.59),('1444','2014-04-25','15:30:00',2.53),('1444','2014-04-25','15:35:00',2.61),('1444','2014-04-25','15:40:00',2.55),('1444','2014-04-25','15:45:00',2.49),('1444','2014-04-25','15:50:00',2.46),('1444','2014-04-25','15:55:00',2.41),('1444','2014-04-25','16:00:00',2.37),('1444','2014-04-25','16:05:00',2.29),('1444','2014-04-25','16:10:00',2.14),('1444','2014-04-25','16:15:00',2.1),('1444','2014-04-25','16:20:00',1.95),('1444','2014-04-25','16:25:00',2.01),('1444','2014-04-25','16:30:00',2.06),('1444','2014-04-25','16:35:00',2.07),('1444','2014-04-25','16:40:00',2.03),('1444','2014-04-25','16:45:00',1.98),('1444','2014-04-25','16:50:00',1.76),('1444','2014-04-25','16:55:00',1.49),('1444','2014-04-25','17:00:00',1.54),('1444','2014-04-25','17:05:00',1.62),('1444','2014-04-25','17:10:00',1.38),('1444','2014-04-25','17:15:00',1.47),('1444','2014-01-16','09:35:00',1.04),('1444','2014-01-16','09:40:00',1.15),('1444','2014-01-16','09:45:00',1.05),('1444','2014-01-16','10:30:00',1.34),('1444','2014-01-16','10:35:00',1.64),('1444','2014-01-16','10:40:00',1.46),('1444','2014-01-16','10:45:00',1.11),('1444','2014-01-16','10:50:00',1.19),('1444','2014-01-16','10:55:00',1.29),('1444','2014-01-16','11:00:00',1.3),('1444','2014-01-16','11:05:00',1.3),('1444','2014-01-16','11:10:00',1.36),('1444','2014-01-16','11:15:00',1.3),('1444','2014-01-16','11:20:00',1.21),('1444','2014-01-16','11:25:00',1.25),('1444','2014-01-16','11:30:00',1.16),('1444','2014-01-16','11:35:00',1.07),('1444','2014-01-16','11:40:00',1.09),('1444','2014-01-16','11:45:00',1.12),('1444','2014-01-16','11:55:00',1.09),('1444','2014-01-16','12:05:00',1.07),('1444','2014-01-16','12:10:00',1.07),('1444','2014-01-16','12:30:00',1.03),('1444','2014-01-16','12:35:00',1.25),('1444','2014-01-16','12:40:00',1.27),('1444','2014-01-16','12:45:00',1.28),('1444','2014-01-16','12:50:00',1.35),('1444','2014-01-16','12:55:00',1.35),('1444','2014-01-16','13:00:00',1.43),('1444','2014-01-16','13:05:00',1.37),('1444','2014-01-16','13:10:00',1.24),('1444','2014-01-16','13:15:00',1.09),('1444','2014-01-16','13:20:00',1.04),('1444','2014-01-16','13:25:00',1.11),('1444','2014-01-16','13:45:00',1.44),('1444','2014-01-16','13:50:00',1.18),('1444','2014-01-16','13:55:00',1.43),('1444','2014-01-15','10:20:00',1.16),('1444','2014-01-15','10:25:00',1.15),('1444','2014-01-15','10:30:00',1.13),('1444','2014-01-15','10:40:00',1.14),('1444','2014-01-15','11:05:00',1.12),('1444','2014-01-15','11:10:00',1.64),('1444','2014-01-15','11:15:00',1.58),('1444','2014-01-15','11:20:00',1.51),('1444','2014-01-15','11:25:00',1.43),('1444','2014-01-15','11:30:00',1.06),('1444','2014-01-15','11:40:00',1.06),('1444','2014-01-15','11:45:00',1.46),('1444','2014-01-15','11:50:00',1.49),('1444','2014-01-15','11:55:00',1.24),('1444','2014-01-15','12:00:00',1.22),('1444','2014-01-15','12:05:00',1.11),('1444','2014-01-15','12:10:00',1.07),('1444','2014-01-15','12:15:00',1.26),('1444','2014-01-15','12:20:00',1.6),('1444','2014-01-15','12:25:00',1.25),('1444','2014-01-15','12:35:00',1.07),('1444','2014-01-15','13:10:00',1.18),('1444','2014-01-15','13:15:00',1.68),('1444','2014-01-15','13:20:00',1.56),('1444','2014-01-15','13:25:00',1.62),('1444','2014-01-15','13:30:00',1.55),('1444','2014-01-15','13:35:00',1.42),('1444','2014-01-15','13:40:00',1.39),('1444','2014-01-15','13:45:00',1.33),('1444','2014-01-15','14:00:00',1.2),('1444','2014-01-15','14:05:00',1.18),('1444','2014-01-15','14:10:00',1.12),('1444','2014-01-15','14:15:00',1.07),('1444','2014-01-15','14:20:00',1.08),('1444','2014-01-15','14:25:00',1.07),('1444','2014-01-15','14:30:00',1.06),('1444','2014-01-15','14:35:00',1.03),('1444','2014-01-15','14:40:00',1.03),('1444','2014-01-15','14:45:00',1.03),('1444','2014-01-14','10:25:00',1.13),('1444','2014-01-14','10:30:00',1.73),('1444','2014-01-14','10:35:00',1.74),('1444','2014-01-14','10:40:00',1.54),('1444','2014-01-14','10:45:00',1.44),('1444','2014-01-14','11:00:00',1.01),('1444','2014-01-13','10:10:00',1.02),('1444','2014-01-13','10:15:00',1.05),('1444','2014-01-13','10:20:00',1.1),('1444','2014-01-13','10:25:00',1.12),('1444','2014-01-13','10:30:00',1.15),('1444','2014-01-13','10:35:00',1.18),('1444','2014-01-13','10:40:00',1.21),('1444','2014-01-13','10:45:00',1.25),('1444','2014-01-13','10:50:00',1.28),('1444','2014-01-13','10:55:00',1.33),('1444','2014-01-13','11:00:00',1.35),('1444','2014-01-13','11:05:00',1.37),('1444','2014-01-13','11:10:00',1.38),('1444','2014-01-13','11:15:00',1.41),('1444','2014-01-13','11:20:00',1.43),('1444','2014-01-13','11:25:00',1.42),('1444','2014-01-13','11:30:00',1.43),('1444','2014-01-13','11:35:00',1.46),('1444','2014-01-13','11:40:00',1.46),('1444','2014-01-13','11:45:00',1.45),('1444','2014-01-13','11:50:00',1.46),('1444','2014-01-13','11:55:00',1.45),('1444','2014-01-13','12:00:00',1.45),('1444','2014-01-13','12:05:00',1.44),('1444','2014-01-13','12:10:00',1.44),('1444','2014-01-13','12:15:00',1.46),('1444','2014-01-13','12:20:00',1.47),('1444','2014-01-13','12:25:00',1.46),('1444','2014-01-13','12:30:00',1.41),('1444','2014-01-13','12:35:00',1.38),('1444','2014-01-13','12:40:00',1.4),('1444','2014-01-13','12:45:00',1.37),('1444','2014-01-13','12:50:00',1.33),('1444','2014-01-13','12:55:00',1.27),('1444','2014-01-13','13:00:00',1.3),('1444','2014-01-13','13:05:00',1.29),('1444','2014-01-13','13:10:00',1.29),('1444','2014-01-13','13:15:00',1.29),('1444','2014-01-13','13:20:00',1.28),('1444','2014-01-13','13:25:00',1.23),('1444','2014-01-13','13:30:00',1.23),('1444','2014-01-13','13:35:00',1.19),('1444','2014-01-13','13:40:00',1.13),('1444','2014-01-13','13:45:00',1.09),('1444','2014-01-13','13:50:00',1.13),('1444','2014-01-13','13:55:00',1.09),('1444','2014-01-13','14:00:00',1.09),('1444','2014-01-13','14:05:00',1.04),('1444','2014-01-13','14:10:00',1.01),('1444','2014-01-12','10:50:00',1.06),('1444','2014-01-12','10:55:00',1.11),('1444','2014-01-12','11:00:00',1.07),('1444','2014-01-12','11:05:00',1.12),('1444','2014-01-12','11:10:00',1.3),('1444','2014-01-12','11:15:00',1.11),('1444','2014-01-12','11:20:00',1.01),('1444','2014-01-12','11:25:00',1.08),('1444','2014-01-12','11:30:00',1.01),('1444','2014-01-12','11:40:00',1.22),('1444','2014-01-12','11:45:00',1.22),('1444','2014-01-12','11:50:00',1.37),('1444','2014-01-12','11:55:00',1.2),('1444','2014-01-12','12:00:00',1),('1444','2014-01-12','12:05:00',1.01),('1444','2014-01-11','10:35:00',1.02),('1444','2014-01-11','10:40:00',1.29),('1444','2014-01-11','10:45:00',1.36),('1444','2014-01-11','10:50:00',1.38),('1444','2014-01-11','10:55:00',1.39),('1444','2014-01-11','11:00:00',1.36),('1444','2014-01-11','11:05:00',1.29),('1444','2014-01-11','11:10:00',1.43),('1444','2014-01-11','11:15:00',1.24),('1444','2014-01-11','11:20:00',1.2),('1444','2014-01-11','11:25:00',1.21),('1444','2014-01-11','11:30:00',1.21),('1444','2014-01-11','11:35:00',1.06),('1444','2014-01-11','11:45:00',1.03),('1444','2014-01-11','11:50:00',1.14),('1444','2014-01-11','11:55:00',1.16),('1444','2014-01-11','12:00:00',1.23),('1444','2014-01-11','12:05:00',1.36),('1444','2014-01-11','12:10:00',1.23),('1444','2014-01-11','12:15:00',1.2),('1444','2014-01-11','12:20:00',1.21),('1444','2014-01-11','12:25:00',1.1),('1444','2014-01-11','12:30:00',1.02),('1444','2014-01-11','12:50:00',1.16),('1444','2014-01-11','12:55:00',1.21),('1444','2014-01-11','13:00:00',1.2),('1444','2014-01-11','13:05:00',1.05),('1444','2014-01-11','13:15:00',1.28),('1444','2014-01-11','13:20:00',1.06),('1444','2014-01-09','09:40:00',1.04),('1444','2014-01-09','09:45:00',1.12),('1444','2014-01-09','09:50:00',1.15),('1444','2014-01-09','09:55:00',1.12),('1444','2014-01-09','10:00:00',1.16),('1444','2014-01-09','10:05:00',1.11),('1444','2014-01-09','10:10:00',1.01),('1444','2014-01-09','10:15:00',1.02),('1444','2014-01-09','10:20:00',1.06),('1444','2014-01-09','10:25:00',1.14),('1444','2014-01-09','10:30:00',1.16),('1444','2014-01-09','10:35:00',1.25),('1444','2014-01-09','10:40:00',1.39),('1444','2014-01-09','10:45:00',1.1),('1444','2014-01-09','11:20:00',1.07),('1444','2014-01-09','11:35:00',1.1),('1444','2014-01-09','11:40:00',1.29),('1444','2014-01-08','10:15:00',1.01),('1444','2014-01-08','10:20:00',1.13),('1444','2014-01-08','10:25:00',1.16),('1444','2014-01-08','10:30:00',1.19),('1444','2014-01-08','10:35:00',1.17),('1444','2014-01-08','10:40:00',1.15),('1444','2014-01-08','10:45:00',1.26),('1444','2014-01-08','10:50:00',1.31),('1444','2014-01-08','10:55:00',1.35),('1444','2014-01-08','11:00:00',1.37),('1444','2014-01-08','11:05:00',1.4),('1444','2014-01-08','11:10:00',1.42),('1444','2014-01-08','11:15:00',1.44),('1444','2014-01-08','11:20:00',1.45),('1444','2014-01-08','11:25:00',1.45),('1444','2014-01-08','11:30:00',1.44),('1444','2014-01-08','11:35:00',1.52),('1444','2014-01-08','11:40:00',1.53),('1444','2014-01-08','11:45:00',1.54),('1444','2014-01-08','11:50:00',1.49),('1444','2014-01-08','11:55:00',1.48),('1444','2014-01-08','12:00:00',1.48),('1444','2014-01-08','12:05:00',1.47),('1444','2014-01-08','12:10:00',1.45),('1444','2014-01-08','12:15:00',1.48),('1444','2014-01-08','12:20:00',1.45),('1444','2014-01-08','12:25:00',1.43),('1444','2014-01-08','12:30:00',1.43),('1444','2014-01-08','12:35:00',1.41),('1444','2014-01-08','12:40:00',1.37),('1444','2014-01-08','12:45:00',1.33),('1444','2014-01-08','12:50:00',1.35),('1444','2014-01-08','12:55:00',1.35),('1444','2014-01-08','13:00:00',1.31),('1444','2014-01-08','13:05:00',1.34),('1444','2014-01-08','13:10:00',1.28),('1444','2014-01-08','13:15:00',1.27),('1444','2014-01-08','13:20:00',1.24),('1444','2014-01-08','13:25:00',1.24),('1444','2014-01-08','13:30:00',1.2),('1444','2014-01-08','13:35:00',1.18),('1444','2014-01-08','13:40:00',1.14),('1444','2014-01-08','13:45:00',1.12),('1444','2014-01-08','13:50:00',1.12),('1444','2014-01-08','13:55:00',1.08),('1444','2014-01-08','14:00:00',1.05),('1444','2014-01-08','14:05:00',1.04),('1444','2014-01-08','14:10:00',1.02),('1444','2014-01-08','14:15:00',1.02),('1444','2014-01-08','14:20:00',1.02),('1444','2014-01-07','10:05:00',1.04),('1444','2014-01-07','10:10:00',1.06),('1444','2014-01-07','10:15:00',1.1),('1444','2014-01-07','10:20:00',1.13),('1444','2014-01-07','10:25:00',1.16),('1444','2014-01-07','10:30:00',1.21),('1444','2014-01-07','10:35:00',1.24),('1444','2014-01-07','10:40:00',1.28),('1444','2014-01-07','10:45:00',1.31),('1444','2014-01-07','10:50:00',1.34),('1444','2014-01-07','10:55:00',1.38),('1444','2014-01-07','11:00:00',1.4),('1444','2014-01-07','11:05:00',1.42),('1444','2014-01-07','11:10:00',1.43),('1444','2014-01-07','11:15:00',1.46),('1444','2014-01-07','11:20:00',1.48),('1444','2014-01-07','11:25:00',1.48),('1444','2014-01-07','11:30:00',1.51),('1444','2014-01-07','11:35:00',1.52),('1444','2014-01-07','11:40:00',1.52),('1444','2014-01-07','11:45:00',1.54),('1444','2014-01-07','11:50:00',1.54),('1444','2014-01-07','11:55:00',1.54),('1444','2014-01-07','12:00:00',1.55),('1444','2014-01-07','12:05:00',1.53),('1444','2014-01-07','12:10:00',1.52),('1444','2014-01-07','12:15:00',1.5),('1444','2014-01-07','12:20:00',1.46),('1444','2014-01-07','12:25:00',1.48),('1444','2014-01-07','12:30:00',1.49),('1444','2014-01-07','12:35:00',1.46),('1444','2014-01-07','12:40:00',1.39),('1444','2014-01-07','12:45:00',1.44),('1444','2014-01-07','12:50:00',1.41),('1444','2014-01-07','12:55:00',1.37),('1444','2014-01-07','13:00:00',1.29),('1444','2014-01-07','13:05:00',1.26),('1444','2014-01-07','13:10:00',1.3),('1444','2014-01-07','13:15:00',1.31),('1444','2014-01-07','13:20:00',1.28),('1444','2014-01-07','13:25:00',1.17),('1444','2014-01-07','13:30:00',1.15),('1444','2014-01-07','13:35:00',1.18),('1444','2014-01-07','13:40:00',1.18),('1444','2014-01-07','13:45:00',1.19),('1444','2014-01-07','13:50:00',1.18),('1444','2014-01-07','13:55:00',1.13),('1444','2014-01-07','14:00:00',1.09),('1444','2014-01-07','14:05:00',1.05),('1444','2014-01-07','14:10:00',1),('1444','2014-01-07','14:22:00',1),('1444','2014-04-24','08:10:00',1.06),('1444','2014-04-24','08:15:00',1.11),('1444','2014-04-24','08:20:00',1.17),('1444','2014-04-24','08:25:00',1.24),('1444','2014-04-24','08:30:00',1.29),('1444','2014-04-24','08:35:00',1.36),('1444','2014-04-24','08:40:00',1.42),('1444','2014-04-24','08:45:00',1.49),('1444','2014-04-24','08:50:00',1.55),('1444','2014-04-24','08:55:00',1.61),('1444','2014-04-24','09:00:00',1.68),('1444','2014-04-24','09:05:00',1.72),('1444','2014-04-24','09:10:00',1.79),('1444','2014-04-24','09:15:00',1.85),('1444','2014-04-24','09:20:00',1.89),('1444','2014-04-24','09:25:00',1.94),('1444','2014-04-24','09:30:00',2),('1444','2014-04-24','09:35:00',2.07),('1444','2014-04-24','09:40:00',2.11),('1444','2014-04-24','09:45:00',2.17),('1444','2014-04-24','09:50:00',2.2),('1444','2014-04-24','09:55:00',2.26),('1444','2014-04-24','10:00:00',2.29),('1444','2014-04-24','10:05:00',2.35),('1444','2014-04-24','10:10:00',2.4),('1444','2014-04-24','10:15:00',2.44),('1444','2014-04-24','10:20:00',2.48),('1444','2014-04-24','10:25:00',2.51),('1444','2014-04-24','10:30:00',2.55),('1444','2014-04-24','10:35:00',2.58),('1444','2014-04-24','10:40:00',2.59),('1444','2014-04-24','10:45:00',2.64),('1444','2014-04-24','10:50:00',2.69),('1444','2014-04-24','10:55:00',2.74),('1444','2014-04-24','11:00:00',2.74),('1444','2014-04-24','11:05:00',2.79),('1444','2014-04-24','11:10:00',2.78),('1444','2014-04-24','11:15:00',2.8),('1444','2014-04-24','11:20:00',2.83),('1444','2014-04-24','11:25:00',2.83),('1444','2014-04-24','11:30:00',2.84),('1444','2014-04-24','11:35:00',2.87),('1444','2014-04-24','11:40:00',2.95),('1444','2014-04-24','11:45:00',2.95),('1444','2014-04-24','11:50:00',2.98),('1444','2014-04-24','11:55:00',2.98),('1444','2014-04-24','12:00:00',2.96),('1444','2014-04-24','12:05:00',3.04),('1444','2014-04-24','12:10:00',1.83),('1444','2014-04-24','12:15:00',2.25),('1444','2014-04-24','12:20:00',3.26),('1444','2014-04-24','12:25:00',3.17),('1444','2014-04-24','12:30:00',3.02),('1444','2014-04-24','12:35:00',3.25),('1444','2014-04-24','12:40:00',3.22),('1444','2014-04-24','12:45:00',3.15),('1444','2014-04-24','12:50:00',3.22),('1444','2014-04-24','12:55:00',3.05),('1444','2014-04-24','13:00:00',3.19),('1444','2014-04-24','13:05:00',3.2),('1444','2014-04-24','13:10:00',3.25),('1444','2014-04-24','13:15:00',3.31),('1444','2014-04-24','13:20:00',3.27),('1444','2014-04-24','13:25:00',2.94),('1444','2014-04-24','13:30:00',1.52),('1444','2014-04-24','13:35:00',2.7),('1444','2014-04-24','13:40:00',1.62),('1444','2014-04-24','13:45:00',1.73),('1444','2014-04-24','13:50:00',3.63),('1444','2014-04-24','13:55:00',3.58),('1444','2014-04-24','14:00:00',3.59),('1444','2014-04-24','14:05:00',3.51),('1444','2014-04-24','14:10:00',3.21),('1444','2014-04-24','14:15:00',3.55),('1444','2014-04-24','14:20:00',3.38),('1444','2014-04-24','14:25:00',3.34),('1444','2014-04-24','14:30:00',2.61),('1444','2014-04-24','14:35:00',2.89),('1444','2014-04-24','14:40:00',2.47),('1444','2014-04-24','14:45:00',1.65),('1444','2014-04-24','14:50:00',2.02),('1444','2014-04-24','14:55:00',3.53),('1444','2014-04-24','15:00:00',3.33),('1444','2014-04-24','15:05:00',3.28),('1444','2014-04-24','15:10:00',3.43),('1444','2014-04-24','15:15:00',3.17),('1444','2014-04-24','15:20:00',2.46),('1444','2014-04-24','15:25:00',1.73),('1444','2014-04-24','15:30:00',2.19),('1444','2014-04-24','15:35:00',2.13),('1444','2014-04-24','15:40:00',1.93),('1444','2014-04-24','15:45:00',1.69),('1444','2014-04-24','15:50:00',1.99),('1444','2014-04-24','15:55:00',2.13),('1444','2014-04-24','16:00:00',2.96),('1444','2014-04-24','16:05:00',2.62),('1444','2014-04-24','16:10:00',2.29),('1444','2014-04-24','16:15:00',2.87),('1444','2014-04-24','16:20:00',2.66),('1444','2014-04-24','16:25:00',2.05),('1444','2014-04-24','16:30:00',1.9),('1444','2014-04-24','16:35:00',1.57),('1444','2014-04-24','16:40:00',1.55),('1444','2014-04-24','16:45:00',1.21),('1444','2014-04-24','16:55:00',1.02),('1444','2014-04-24','17:00:00',1.07),('1444','2014-01-06','11:40:00',1.56),('1444','2014-01-06','11:45:00',1.65),('1444','2014-01-06','11:50:00',1.32),('1444','2014-01-06','12:00:00',1.5),('1444','2014-01-06','12:05:00',1.44),('1444','2014-01-06','12:10:00',1.54),('1444','2014-01-06','12:15:00',1.51),('1444','2014-01-06','12:20:00',1.44),('1444','2014-01-06','12:25:00',1.42),('1444','2014-01-06','12:30:00',1.45),('1444','2014-01-06','12:35:00',1.45),('1444','2014-01-06','12:40:00',1.44),('1444','2014-01-06','12:45:00',1.44),('1444','2014-01-06','12:50:00',1.44),('1444','2014-01-06','12:55:00',1.36),('1444','2014-01-06','13:00:00',1.36),('1444','2014-01-06','13:05:00',1.34),('1444','2014-01-06','13:10:00',1.35),('1444','2014-01-06','13:15:00',1.43),('1444','2014-01-06','13:20:00',1.36),('1444','2014-01-06','13:25:00',1.3),('1444','2014-01-06','13:30:00',1.24),('1444','2014-01-06','13:35:00',1.19),('1444','2014-01-06','13:40:00',1.16),('1444','2014-01-06','13:45:00',1.14),('1444','2014-01-06','13:50:00',1.12),('1444','2014-01-06','13:55:00',1.09),('1444','2014-01-06','14:15:00',1.13),('1444','2014-01-06','14:45:00',1.1),('1444','2014-01-03','09:40:00',1.07),('1444','2014-01-03','09:45:00',1.09),('1444','2014-01-03','10:00:00',1.03),('1444','2014-01-03','12:00:00',1.22),('1444','2014-01-03','12:05:00',1.34),('1444','2014-01-03','12:10:00',1.74),('1444','2014-01-03','12:15:00',1.44),('1444','2014-01-03','12:20:00',1.65),('1444','2014-01-03','12:25:00',1.5),('1444','2014-01-03','12:30:00',1.37),('1444','2014-01-03','12:35:00',1.12),('1444','2014-01-03','12:40:00',1.1),('1444','2014-01-03','12:45:00',1.11),('1444','2014-01-03','12:50:00',1.04),('1444','2014-01-03','13:05:00',1.14),('1444','2014-01-03','13:10:00',1.09),('1444','2014-01-03','13:35:00',1.06),('1444','2014-01-02','10:05:00',1.01),('1444','2014-01-02','10:10:00',1.04),('1444','2014-01-02','10:15:00',1.08),('1444','2014-01-02','10:20:00',1.1),('1444','2014-01-02','10:25:00',1.13),('1444','2014-01-02','10:30:00',1.16),('1444','2014-01-02','10:35:00',1.18),('1444','2014-01-02','10:40:00',1.22),('1444','2014-01-02','10:45:00',1.25),('1444','2014-01-02','10:50:00',1.31),('1444','2014-01-02','10:55:00',1.41),('1444','2014-01-02','11:00:00',1.45),('1444','2014-01-02','11:05:00',1.4),('1444','2014-01-02','11:25:00',1.09),('1444','2014-01-02','11:30:00',1.16),('1444','2014-01-02','11:35:00',1.47),('1444','2014-01-02','11:40:00',1.3),('1444','2014-01-02','11:45:00',1.13),('1444','2014-01-02','12:50:00',1.08),('1444','2014-01-02','12:55:00',1.06),('1444','2014-01-02','13:30:00',1.01),('1444','2014-01-02','13:35:00',1.27),('1444','2014-01-02','13:40:00',1.25),('1444','2014-01-01','09:35:00',1.06),('1444','2014-01-01','09:45:00',1.08),('1444','2014-01-01','09:50:00',1.27),('1444','2014-01-01','09:55:00',1.14),('1444','2014-01-01','13:50:00',1.53),('1444','2014-01-01','13:55:00',1.04),('1444','2013-12-31','11:30:00',1.64),('1444','2013-12-31','11:35:00',1.29),('1444','2013-12-31','11:40:00',1.47),('1444','2013-12-31','12:00:00',1.48),('1444','2013-12-31','12:05:00',1.59),('1444','2013-12-31','12:10:00',1.55),('1444','2013-12-31','12:15:00',1.54),('1444','2013-12-31','12:20:00',1.52),('1444','2013-12-31','12:25:00',1.49),('1444','2013-12-31','12:30:00',1.47),('1444','2013-12-31','12:35:00',1.44),('1444','2013-12-31','12:40:00',1.43),('1444','2013-12-31','12:45:00',1.44),('1444','2013-12-31','12:50:00',1.4),('1444','2013-12-31','12:55:00',1.38),('1444','2013-12-31','13:00:00',1.38),('1444','2013-12-31','13:05:00',1.36),('1444','2013-12-31','13:10:00',1.33),('1444','2013-12-31','13:15:00',1.33),('1444','2013-12-31','13:20:00',1.29),('1444','2013-12-31','13:25:00',1.26),('1444','2013-12-31','13:30:00',1.23),('1444','2013-12-31','13:35:00',1.22),('1444','2013-12-31','13:40:00',1.17),('1444','2013-12-31','13:45:00',1.14),('1444','2013-12-31','13:50:00',1.11),('1444','2013-12-31','13:55:00',1.08),('1444','2013-12-31','14:00:00',1.08),('1444','2013-12-31','14:05:00',1.05),('1444','2013-12-31','14:10:00',1.01),('1444','2013-12-29','10:10:00',1.01),('1444','2013-12-29','10:15:00',1.05),('1444','2013-12-29','10:20:00',1.15),('1444','2013-12-29','10:25:00',1.1),('1444','2013-12-29','10:30:00',1.3),('1444','2013-12-29','10:35:00',1.58),('1444','2013-12-29','10:40:00',1.04),('1444','2013-12-29','10:55:00',1.08),('1444','2013-12-28','10:05:00',1.02),('1444','2013-12-28','10:10:00',1.06),('1444','2013-12-28','10:15:00',1.08),('1444','2013-12-28','10:20:00',1.12),('1444','2013-12-28','10:25:00',1.15),('1444','2013-12-28','10:30:00',1.2),('1444','2013-12-28','10:35:00',1.23),('1444','2013-12-28','10:40:00',1.26),('1444','2013-12-28','10:45:00',1.3),('1444','2013-12-28','10:50:00',1.35),('1444','2013-12-28','10:55:00',1.37),('1444','2013-12-28','11:00:00',1.39),('1444','2013-12-28','11:05:00',1.41),('1444','2013-12-28','11:10:00',1.43),('1444','2013-12-28','11:15:00',1.45),('1444','2013-12-28','11:20:00',1.46),('1444','2013-12-28','11:25:00',1.48),('1444','2013-12-28','11:30:00',1.49),('1444','2013-12-28','11:35:00',1.5),('1444','2013-12-28','11:40:00',1.5),('1444','2013-12-28','11:45:00',1.5),('1444','2013-12-28','11:50:00',1.48),('1444','2013-12-28','11:55:00',1.46),('1444','2013-12-28','12:00:00',1.5),('1444','2013-12-28','12:05:00',1.48),('1444','2013-12-28','12:10:00',1.49),('1444','2013-12-28','12:15:00',1.47),('1444','2013-12-28','12:20:00',1.44),('1444','2013-12-28','12:25:00',1.42),('1444','2013-12-28','12:30:00',1.41),('1444','2013-12-28','12:35:00',1.4),('1444','2013-12-28','12:40:00',1.4),('1444','2013-12-28','12:45:00',1.36),('1444','2013-12-28','12:50:00',1.31),('1444','2013-12-28','12:55:00',1.32),('1444','2013-12-28','13:00:00',1.3),('1444','2013-12-28','13:05:00',1.28),('1444','2013-12-28','13:10:00',1.27),('1444','2013-12-28','13:15:00',1.22),('1444','2013-12-28','13:20:00',1.18),('1444','2013-12-28','13:25:00',1.15),('1444','2013-12-28','13:30:00',1.12),('1444','2013-12-28','13:35:00',1.11),('1444','2013-12-28','13:40:00',1.08),('1444','2013-12-28','13:45:00',1.04),('1444','2013-12-28','13:50:00',1.03),('1444','2013-12-28','13:55:00',1.02),('1444','2014-04-23','13:20:00',1.04),('1444','2014-04-23','13:25:00',1.08),('1444','2014-04-23','13:30:00',1.16),('1444','2014-04-23','13:35:00',1.2),('1444','2014-04-23','13:40:00',1.27),('1444','2014-04-23','13:45:00',1.29),('1444','2014-04-23','13:50:00',1.27),('1444','2014-04-23','13:55:00',1.28),('1444','2014-04-23','14:00:00',1.21),('1444','2014-04-23','14:05:00',1.22),('1444','2014-04-23','14:10:00',1.17),('1444','2014-04-23','14:55:00',1.16),('1444','2014-04-23','15:00:00',1.29),('1444','2014-04-23','15:05:00',1.35),('1444','2014-04-23','15:10:00',1.33),('1444','2014-04-23','15:15:00',1.45),('1444','2014-04-23','15:20:00',1.23),('1444','2014-04-23','15:25:00',1.09),('1444','2014-04-23','15:30:00',1.02),('1444','2013-12-27','12:10:00',1.09),('1444','2013-12-27','12:15:00',1.1),('1444','2013-12-27','12:20:00',1.29),('1444','2013-12-27','12:45:00',1.1),('1444','2013-12-27','12:50:00',1.28),('1444','2013-12-27','12:55:00',1.29),('1444','2013-12-27','13:00:00',1.32),('1444','2013-12-27','13:05:00',1.15),('1444','2013-12-27','13:20:00',1.08),('1444','2013-12-27','13:25:00',1.01),('1444','2013-12-27','13:30:00',1.44),('1444','2013-12-27','13:35:00',1.34),('1444','2013-12-25','11:20:00',1.3),('1444','2013-12-25','11:30:00',1.1),('1444','2013-12-25','11:40:00',1.15),('1444','2013-12-25','11:45:00',1.27),('1444','2013-12-25','11:55:00',1.46),('1444','2013-12-25','12:00:00',1.03),('1444','2013-12-25','12:25:00',1.06),('1444','2013-12-24','10:20:00',1.03),('1444','2013-12-24','10:25:00',1.06),('1444','2013-12-24','10:30:00',1.09),('1444','2013-12-24','10:35:00',1.11),('1444','2013-12-24','10:40:00',1.14),('1444','2013-12-24','10:45:00',1.16),('1444','2013-12-24','10:50:00',1.2),('1444','2013-12-24','10:55:00',1.21),('1444','2013-12-24','11:00:00',1.22),('1444','2013-12-24','11:05:00',1.23),('1444','2013-12-24','11:10:00',1.24),('1444','2013-12-24','11:15:00',1.25),('1444','2013-12-24','11:20:00',1.27),('1444','2013-12-24','11:25:00',1.3),('1444','2013-12-24','11:30:00',1.31),('1444','2013-12-24','11:35:00',1.33),('1444','2013-12-24','11:40:00',1.33),('1444','2013-12-24','11:45:00',1.34),('1444','2013-12-24','11:50:00',1.28),('1444','2013-12-24','11:55:00',1.33),('1444','2013-12-24','12:00:00',1.33),('1444','2013-12-24','12:05:00',1.29),('1444','2013-12-24','12:10:00',1.3),('1444','2013-12-24','12:15:00',1.29),('1444','2013-12-24','12:20:00',1.25),('1444','2013-12-24','12:25:00',1.25),('1444','2013-12-24','12:30:00',1.23),('1444','2013-12-24','12:35:00',1.2),('1444','2013-12-24','12:40:00',1.2),('1444','2013-12-24','12:45:00',1.17),('1444','2013-12-24','12:50:00',1.16),('1444','2013-12-24','12:55:00',1.14),('1444','2013-12-24','13:00:00',1.12),('1444','2013-12-24','13:05:00',1.12),('1444','2013-12-24','13:10:00',1.12),('1444','2013-12-24','13:15:00',1.06),('1444','2013-12-24','13:20:00',1.03),('1444','2013-12-24','13:25:00',1.02),('1444','2013-12-23','10:00:00',1.07),('1444','2013-12-23','10:05:00',1.14),('1444','2013-12-23','10:10:00',1.09),('1444','2013-12-23','10:15:00',1.14),('1444','2013-12-23','10:20:00',1.16),('1444','2013-12-23','10:25:00',1.13),('1444','2013-12-23','10:30:00',1.09),('1444','2013-12-23','10:35:00',1.12),('1444','2013-12-23','10:40:00',1.17),('1444','2013-12-23','10:45:00',1.19),('1444','2013-12-23','10:50:00',1.22),('1444','2013-12-23','10:55:00',1.37),('1444','2013-12-23','11:00:00',1.46),('1444','2013-12-23','11:05:00',1.48),('1444','2013-12-23','11:10:00',1.48),('1444','2013-12-23','11:15:00',1.42),('1444','2013-12-23','11:20:00',1.46),('1444','2013-12-23','11:25:00',1.4),('1444','2013-12-23','11:30:00',1.46),('1444','2013-12-23','11:35:00',1.51),('1444','2013-12-23','11:40:00',1.35),('1444','2013-12-23','11:45:00',1.29),('1444','2013-12-23','11:50:00',1.34),('1444','2013-12-23','11:55:00',1.39),('1444','2013-12-23','12:00:00',1.42),('1444','2013-12-23','12:05:00',1.4),('1444','2013-12-23','12:10:00',1.39),('1444','2013-12-23','12:15:00',1.37),('1444','2013-12-23','12:20:00',1.34),('1444','2013-12-23','12:25:00',1.29),('1444','2013-12-23','12:30:00',1.25),('1444','2013-12-23','12:35:00',1.23),('1444','2013-12-23','12:40:00',1.32),('1444','2013-12-23','12:45:00',1.29),('1444','2013-12-23','12:50:00',1.27),('1444','2013-12-23','12:55:00',1.28),('1444','2013-12-23','13:00:00',1.27),('1444','2013-12-23','13:05:00',1.24),('1444','2013-12-23','13:10:00',1.22),('1444','2013-12-23','13:15:00',1.13),('1444','2013-12-23','13:25:00',1.08),('1444','2013-12-22','09:35:00',1.04),('1444','2013-12-22','09:40:00',1.16),('1444','2013-12-22','09:45:00',1.21),('1444','2013-12-22','09:50:00',1.27),('1444','2013-12-22','09:55:00',1.24),('1444','2013-12-22','10:00:00',1.23),('1444','2013-12-22','10:05:00',1.23),('1444','2013-12-22','10:10:00',1.26),('1444','2013-12-22','10:15:00',1.24),('1444','2013-12-22','10:20:00',1.2),('1444','2013-12-22','10:25:00',1.23),('1444','2013-12-22','10:30:00',1.3),('1444','2013-12-22','10:35:00',1.21),('1444','2013-12-22','10:40:00',1.15),('1444','2013-12-22','10:45:00',1.27),('1444','2013-12-22','10:50:00',1.25),('1444','2013-12-22','10:55:00',1.19),('1444','2013-12-22','11:00:00',1.07),('1444','2013-12-22','11:05:00',1.25),('1444','2013-12-22','11:10:00',1.5),('1444','2013-12-22','11:15:00',1.42),('1444','2013-12-22','11:20:00',1.31),('1444','2013-12-22','11:25:00',1.33),('1444','2013-12-22','11:30:00',1.24),('1444','2013-12-22','11:35:00',1.28),('1444','2013-12-22','11:40:00',1.34),('1444','2013-12-22','11:45:00',1.21),('1444','2013-12-22','12:30:00',1.04),('1444','2013-12-22','12:35:00',1.14),('1444','2013-12-22','12:40:00',1.09),('1444','2013-12-22','12:45:00',1.1),('1444','2013-12-22','12:50:00',1.27),('1444','2013-12-22','12:55:00',1.47),('1444','2013-12-22','13:00:00',1.42),('1444','2013-12-22','13:05:00',1.63),('1444','2013-12-22','13:10:00',1.55),('1444','2013-12-22','13:15:00',1.25),('1444','2013-12-22','13:20:00',1.19),('1444','2013-12-22','13:25:00',1.17),('1444','2013-12-22','13:30:00',1.08),('1444','2013-12-21','10:10:00',1.01),('1444','2013-12-21','10:15:00',1.04),('1444','2013-12-21','10:20:00',1.07),('1444','2013-12-21','10:25:00',1.1),('1444','2013-12-21','10:30:00',1.14),('1444','2013-12-21','10:35:00',1.17),('1444','2013-12-21','10:40:00',1.21),('1444','2013-12-21','10:45:00',1.24),('1444','2013-12-21','10:50:00',1.26),('1444','2013-12-21','10:55:00',1.29),('1444','2013-12-21','11:00:00',1.31),('1444','2013-12-21','11:05:00',1.34),('1444','2013-12-21','11:10:00',1.35),('1444','2013-12-21','11:15:00',1.37),('1444','2013-12-21','11:20:00',1.38),('1444','2013-12-21','11:25:00',1.39),('1444','2013-12-21','11:30:00',1.41),('1444','2013-12-21','11:35:00',1.42),('1444','2013-12-21','11:40:00',1.44),('1444','2013-12-21','11:45:00',1.44),('1444','2013-12-21','11:50:00',1.45),('1444','2013-12-21','11:55:00',1.45),('1444','2013-12-21','12:00:00',1.44),('1444','2013-12-21','12:05:00',1.43),('1444','2013-12-21','12:10:00',1.43),('1444','2013-12-21','12:15:00',1.42),('1444','2013-12-21','12:20:00',1.4),('1444','2013-12-21','12:25:00',1.39),('1444','2013-12-21','12:30:00',1.37),('1444','2013-12-21','12:35:00',1.36),('1444','2013-12-21','12:40:00',1.37),('1444','2013-12-21','12:45:00',1.29),('1444','2013-12-21','12:50:00',1.31),('1444','2013-12-21','12:55:00',1.31),('1444','2013-12-21','13:00:00',1.28),('1444','2013-12-21','13:05:00',1.25),('1444','2013-12-21','13:10:00',1.24),('1444','2013-12-21','13:15:00',1.19),('1444','2013-12-21','13:20:00',1.19),('1444','2013-12-21','13:25:00',1.14),('1444','2013-12-21','13:30:00',1.14),('1444','2013-12-21','13:35:00',1.1),('1444','2013-12-21','13:40:00',1.07),('1444','2013-12-21','13:45:00',1.04),('1444','2013-12-21','13:50:00',1.01),('1444','2013-12-21','13:55:00',1.01),('1444','2013-12-20','10:25:00',1.03),('1444','2013-12-20','10:30:00',1.07),('1444','2013-12-20','10:35:00',1.14),('1444','2013-12-20','10:40:00',1.17),('1444','2013-12-20','10:45:00',1.2),('1444','2013-12-20','10:50:00',1.23),('1444','2013-12-20','10:55:00',1.26),('1444','2013-12-20','11:00:00',1.28),('1444','2013-12-20','11:05:00',1.3),('1444','2013-12-20','11:10:00',1.31),('1444','2013-12-20','11:15:00',1.32),('1444','2013-12-20','11:20:00',1.33),('1444','2013-12-20','11:25:00',1.34),('1444','2013-12-20','11:30:00',1.36),('1444','2013-12-20','11:35:00',1.37),('1444','2013-12-20','11:40:00',1.36),('1444','2013-12-20','11:45:00',1.37),('1444','2013-12-20','11:50:00',1.4),('1444','2013-12-20','11:55:00',1.37),('1444','2013-12-20','12:00:00',1.37),('1444','2013-12-20','12:05:00',1.37),('1444','2013-12-20','12:10:00',1.36),('1444','2013-12-20','12:15:00',1.34),('1444','2013-12-20','12:20:00',1.34),('1444','2013-12-20','12:25:00',1.32),('1444','2013-12-20','12:30:00',1.3),('1444','2013-12-20','12:35:00',1.3),('1444','2013-12-20','12:40:00',1.29),('1444','2013-12-20','12:45:00',1.25),('1444','2013-12-20','12:50:00',1.24),('1444','2013-12-20','12:55:00',1.22),('1444','2013-12-20','13:00:00',1.19),('1444','2013-12-20','13:05:00',1.18),('1444','2013-12-20','13:10:00',1.15),('1444','2013-12-20','13:15:00',1.11),('1444','2013-12-20','13:20:00',1.07),('1444','2013-12-20','13:25:00',1.02),('1444','2013-12-19','09:50:00',1.04),('1444','2013-12-19','09:55:00',1.12),('1444','2013-12-19','10:00:00',1.03),('1444','2013-12-19','10:05:00',1.18),('1444','2013-12-19','10:10:00',1.26),('1444','2013-12-19','10:15:00',1.13),('1444','2013-12-19','10:40:00',1.16),('1444','2013-12-19','10:45:00',1.46),('1444','2013-12-19','14:30:00',1.02),('1444','2013-12-18','10:05:00',1.01),('1444','2013-12-18','10:10:00',1.05),('1444','2013-12-18','10:15:00',1.08),('1444','2013-12-18','10:20:00',1.11),('1444','2013-12-18','10:25:00',1.15),('1444','2013-12-18','10:30:00',1.18),('1444','2013-12-18','10:35:00',1.24),('1444','2013-12-18','10:40:00',1.26),('1444','2013-12-18','10:45:00',1.29),('1444','2013-12-18','10:50:00',1.32),('1444','2013-12-18','10:55:00',1.33),('1444','2013-12-18','11:00:00',1.35),('1444','2013-12-18','11:05:00',1.38),('1444','2013-12-18','11:10:00',1.39),('1444','2013-12-18','11:15:00',1.4),('1444','2013-12-18','11:20:00',1.4),('1444','2013-12-18','11:25:00',1.41),('1444','2013-12-18','11:30:00',1.43),('1444','2013-12-18','11:35:00',1.44),('1444','2013-12-18','11:40:00',1.44),('1444','2013-12-18','11:45:00',1.43),('1444','2013-12-18','11:50:00',1.44),('1444','2013-12-18','11:55:00',1.44),('1444','2013-12-18','12:00:00',1.41),('1444','2013-12-18','12:05:00',1.41),('1444','2013-12-18','12:10:00',1.4),('1444','2013-12-18','12:15:00',1.38),('1444','2013-12-18','12:20:00',1.39),('1444','2013-12-18','12:25:00',1.38),('1444','2013-12-18','12:30:00',1.36),('1444','2013-12-18','12:35:00',1.34),('1444','2013-12-18','12:40:00',1.36),('1444','2013-12-18','12:45:00',1.28),('1444','2013-12-18','12:50:00',1.28),('1444','2013-12-18','12:55:00',1.31),('1444','2013-12-18','13:00:00',1.28),('1444','2013-12-18','13:05:00',1.22),('1444','2013-12-18','13:10:00',1.22),('1444','2013-12-18','13:15:00',1.15),('1444','2013-12-18','13:20:00',1.14),('1444','2013-12-18','13:25:00',1.12),('1444','2013-12-18','13:30:00',1.1),('1444','2013-12-18','13:35:00',1.07),('1444','2013-12-18','13:40:00',1.03),('1444','2013-12-18','13:45:00',1),('1444','2014-04-22','08:10:00',1.01),('1444','2014-04-22','08:15:00',1.07),('1444','2014-04-22','08:20:00',1.15),('1444','2014-04-22','08:25:00',1.2),('1444','2014-04-22','08:30:00',1.27),('1444','2014-04-22','08:35:00',1.31),('1444','2014-04-22','08:40:00',1.4),('1444','2014-04-22','08:45:00',1.45),('1444','2014-04-22','08:50:00',1.48),('1444','2014-04-22','08:55:00',1.49),('1444','2014-04-22','09:00:00',1.14),('1444','2014-04-22','09:05:00',1.79),('1444','2014-04-22','09:10:00',1.67),('1444','2014-04-22','09:15:00',1.65),('1444','2014-04-22','09:20:00',1.88),('1444','2014-04-22','09:25:00',1.69),('1444','2014-04-22','09:30:00',1.77),('1444','2014-04-22','09:35:00',2.13),('1444','2014-04-22','09:40:00',2.1),('1444','2014-04-22','09:45:00',2.31),('1444','2014-04-22','09:50:00',1.75),('1444','2014-04-22','09:55:00',1.11),('1444','2014-04-22','10:00:00',1.06),('1444','2014-04-22','10:05:00',1.14),('1444','2014-04-22','10:10:00',1.52),('1444','2014-04-22','10:15:00',1.74),('1444','2014-04-22','10:20:00',2.46),('1444','2014-04-22','10:25:00',1.7),('1444','2014-04-22','10:30:00',2.84),('1444','2014-04-22','10:35:00',2.8),('1444','2014-04-22','10:40:00',2.73),('1444','2014-04-22','10:45:00',2.94),('1444','2014-04-22','10:50:00',2.92),('1444','2014-04-22','10:55:00',2.16),('1444','2014-04-22','11:00:00',1.58),('1444','2014-04-22','11:05:00',1.94),('1444','2014-04-22','11:10:00',1.34),('1444','2014-04-22','11:15:00',1.16),('1444','2014-04-22','11:20:00',1),('1444','2014-04-22','12:20:00',1.01),('1444','2014-04-22','12:25:00',1.09),('1444','2014-04-22','12:30:00',1.26),('1444','2014-04-22','12:35:00',1.07),('1444','2014-04-22','13:15:00',1.2),('1444','2014-04-22','13:20:00',1.79),('1444','2014-04-22','13:25:00',2.08),('1444','2014-04-22','13:30:00',2.17),('1444','2014-04-22','13:35:00',2.09),('1444','2014-04-22','13:40:00',2.47),('1444','2014-04-22','13:45:00',2.55),('1444','2014-04-22','13:50:00',2.05),('1444','2014-04-22','13:55:00',1.23),('1444','2014-04-22','14:00:00',1.1),('1444','2014-04-22','14:05:00',1.56),('1444','2014-04-22','14:10:00',2.74),('1444','2014-04-22','14:15:00',2.5),('1444','2014-04-22','14:20:00',3.13),('1444','2014-04-22','14:25:00',1.76),('1444','2014-04-22','14:30:00',1.71),('1444','2014-04-22','14:35:00',2.06),('1444','2014-04-22','14:40:00',2.66),('1444','2014-04-22','14:45:00',3.26),('1444','2014-04-22','14:50:00',2.98),('1444','2014-04-22','14:55:00',2.21),('1444','2014-04-22','15:00:00',1.04),('1444','2014-04-22','15:05:00',1.02),('1444','2014-04-22','15:20:00',1.04),('1444','2014-04-22','15:25:00',1.17),('1444','2014-04-22','15:30:00',1.48),('1444','2014-04-22','15:35:00',2.02),('1444','2014-04-22','15:40:00',1.62),('1444','2014-04-22','15:45:00',1.47),('1444','2014-04-22','15:50:00',1.73),('1444','2014-04-22','15:55:00',1.43),('1444','2014-04-22','16:00:00',1.66),('1444','2014-04-22','16:05:00',1.19),('1444','2014-04-22','16:10:00',1.15),('1444','2014-04-22','16:15:00',1.11),('1444','2014-04-22','16:20:00',1.28),('1444','2014-04-22','16:25:00',1.2),('1444','2014-04-22','16:30:00',1.02),('1444','2014-04-22','16:35:00',1.13),('1444','2014-04-22','16:40:00',1.39),('1444','2014-04-22','16:45:00',1.3),('1444','2014-04-22','16:50:00',1.02),('1444','2014-04-22','17:00:00',1.03),('1444','2014-04-22','17:05:00',1.12),('1444','2013-12-17','10:00:00',1.01),('1444','2013-12-17','10:05:00',1.03),('1444','2013-12-17','10:10:00',1.04),('1444','2013-12-17','10:15:00',1.11),('1444','2013-12-17','10:20:00',1.14),('1444','2013-12-17','10:25:00',1.19),('1444','2013-12-17','10:30:00',1.22),('1444','2013-12-17','10:35:00',1.27),('1444','2013-12-17','10:40:00',1.29),('1444','2013-12-17','10:45:00',1.33),('1444','2013-12-17','10:50:00',1.35),('1444','2013-12-17','10:55:00',1.37),('1444','2013-12-17','11:00:00',1.39),('1444','2013-12-17','11:05:00',1.4),('1444','2013-12-17','11:10:00',1.43),('1444','2013-12-17','11:15:00',1.45),('1444','2013-12-17','11:20:00',1.46),('1444','2013-12-17','11:25:00',1.46),('1444','2013-12-17','11:30:00',1.46),('1444','2013-12-17','11:35:00',1.48),('1444','2013-12-17','11:40:00',1.48),('1444','2013-12-17','11:45:00',1.49),('1444','2013-12-17','11:50:00',1.5),('1444','2013-12-17','11:55:00',1.51),('1444','2013-12-17','12:00:00',1.49),('1444','2013-12-17','12:05:00',1.49),('1444','2013-12-17','12:10:00',1.48),('1444','2013-12-17','12:15:00',1.46),('1444','2013-12-17','12:20:00',1.46),('1444','2013-12-17','12:25:00',1.45),('1444','2013-12-17','12:30:00',1.43),('1444','2013-12-17','12:35:00',1.44),('1444','2013-12-17','12:40:00',1.42),('1444','2013-12-17','12:45:00',1.33),('1444','2013-12-17','12:50:00',1.36),('1444','2013-12-17','12:55:00',1.36),('1444','2013-12-17','13:00:00',1.33),('1444','2013-12-17','13:05:00',1.31),('1444','2013-12-17','13:10:00',1.27),('1444','2013-12-17','13:15:00',1.22),('1444','2013-12-17','13:20:00',1.2),('1444','2013-12-17','13:25:00',1.17),('1444','2013-12-17','13:30:00',1.17),('1444','2013-12-17','13:35:00',1.14),('1444','2013-12-17','13:40:00',1.1),('1444','2013-12-17','13:45:00',1.07),('1444','2013-12-17','13:50:00',1.07),('1444','2013-12-17','13:55:00',1.05),('1444','2013-12-17','14:00:00',1.02),('1444','2013-12-16','10:05:00',1.03),('1444','2013-12-16','10:10:00',1.06),('1444','2013-12-16','10:15:00',1.09),('1444','2013-12-16','10:20:00',1.11),('1444','2013-12-16','10:25:00',1.15),('1444','2013-12-16','10:30:00',1.17),('1444','2013-12-16','10:35:00',1.22),('1444','2013-12-16','10:40:00',1.25),('1444','2013-12-16','10:45:00',1.29),('1444','2013-12-16','10:50:00',1.32),('1444','2013-12-16','10:55:00',1.34),('1444','2013-12-16','11:00:00',1.35),('1444','2013-12-16','11:05:00',1.37),('1444','2013-12-16','11:10:00',1.38),('1444','2013-12-16','11:15:00',1.38),('1444','2013-12-16','11:20:00',1.42),('1444','2013-12-16','11:25:00',1.44),('1444','2013-12-16','11:30:00',1.44),('1444','2013-12-16','11:35:00',1.44),('1444','2013-12-16','11:40:00',1.45),('1444','2013-12-16','11:45:00',1.46),('1444','2013-12-16','11:50:00',1.48),('1444','2013-12-16','11:55:00',1.49),('1444','2013-12-16','12:00:00',1.47),('1444','2013-12-16','12:05:00',1.47),('1444','2013-12-16','12:10:00',1.47),('1444','2013-12-16','12:15:00',1.45),('1444','2013-12-16','12:20:00',1.45),('1444','2013-12-16','12:25:00',1.44),('1444','2013-12-16','12:30:00',1.42),('1444','2013-12-16','12:35:00',1.42),('1444','2013-12-16','12:40:00',1.39),('1444','2013-12-16','12:45:00',1.32),('1444','2013-12-16','12:50:00',1.34),('1444','2013-12-16','12:55:00',1.35),('1444','2013-12-16','13:00:00',1.32),('1444','2013-12-16','13:05:00',1.3),('1444','2013-12-16','13:10:00',1.28),('1444','2013-12-16','13:15:00',1.22),('1444','2013-12-16','13:20:00',1.2),('1444','2013-12-16','13:25:00',1.18),('1444','2013-12-16','13:30:00',1.16),('1444','2013-12-16','13:35:00',1.12),('1444','2013-12-16','13:40:00',1.08),('1444','2013-12-16','13:45:00',1.05),('1444','2013-12-16','13:50:00',1.03),('1444','2013-12-16','13:55:00',1.03),('1444','2013-12-14','10:00:00',1.02),('1444','2013-12-14','10:05:00',1.06),('1444','2013-12-14','10:10:00',1.08),('1444','2013-12-14','10:15:00',1.11),('1444','2013-12-14','10:20:00',1.14),('1444','2013-12-14','10:25:00',1.17),('1444','2013-12-14','10:30:00',1.2),('1444','2013-12-14','10:35:00',1.24),('1444','2013-12-14','10:40:00',1.26),('1444','2013-12-14','10:45:00',1.3),('1444','2013-12-14','10:50:00',1.32),('1444','2013-12-14','10:55:00',1.33),('1444','2013-12-14','11:00:00',1.34),('1444','2013-12-14','11:05:00',1.37),('1444','2013-12-14','11:10:00',1.38),('1444','2013-12-14','11:15:00',1.4),('1444','2013-12-14','11:20:00',1.41),('1444','2013-12-14','11:25:00',1.43),('1444','2013-12-14','11:30:00',1.43),('1444','2013-12-14','11:35:00',1.44),('1444','2013-12-14','11:40:00',1.44),('1444','2013-12-14','11:45:00',1.41),('1444','2013-12-14','11:50:00',1.41),('1444','2013-12-14','11:55:00',1.4),('1444','2013-12-14','12:00:00',1.36),('1444','2013-12-14','12:05:00',1.38),('1444','2013-12-14','12:10:00',1.39),('1444','2013-12-14','12:15:00',1.33),('1444','2013-12-14','12:20:00',1.36),('1444','2013-12-14','12:25:00',1.35),('1444','2013-12-14','12:30:00',1.14),('1444','2013-12-14','12:35:00',1.33),('1444','2013-12-14','12:40:00',1.2),('1444','2013-12-14','12:45:00',1.16),('1444','2013-12-14','12:50:00',1.29),('1444','2013-12-14','12:55:00',1.26),('1444','2013-12-14','13:00:00',1.23),('1444','2013-12-14','13:05:00',1.23),('1444','2013-12-14','13:10:00',1.2),('1444','2013-12-14','13:15:00',1.17),('1444','2013-12-14','13:20:00',1.17),('1444','2013-12-14','13:25:00',1.15),('1444','2013-12-14','13:30:00',1.15),('1444','2013-12-14','13:35:00',1.11),('1444','2013-12-14','13:40:00',1.07),('1444','2013-12-14','13:45:00',1.02),('1444','2013-12-14','13:50:00',1.03),('1444','2013-12-14','13:55:00',1.02),('1444','2013-12-13','10:10:00',1.02),('1444','2013-12-13','10:15:00',1.03),('1444','2013-12-13','10:20:00',1.06),('1444','2013-12-13','10:25:00',1.1),('1444','2013-12-13','10:30:00',1.14),('1444','2013-12-13','10:35:00',1.18),('1444','2013-12-13','10:40:00',1.21),('1444','2013-12-13','10:45:00',1.25),('1444','2013-12-13','10:50:00',1.26),('1444','2013-12-13','10:55:00',1.27),('1444','2013-12-13','11:00:00',1.31),('1444','2013-12-13','11:05:00',1.33),('1444','2013-12-13','11:10:00',1.35),('1444','2013-12-13','11:15:00',1.36),('1444','2013-12-13','11:20:00',1.35),('1444','2013-12-13','11:25:00',1.35),('1444','2013-12-13','11:30:00',1.35),('1444','2013-12-13','11:35:00',1.38),('1444','2013-12-13','11:40:00',1.39),('1444','2013-12-13','11:45:00',1.41),('1444','2013-12-13','11:50:00',1.42),('1444','2013-12-13','11:55:00',1.43),('1444','2013-12-13','12:00:00',1.4),('1444','2013-12-13','12:05:00',1.38),('1444','2013-12-13','12:10:00',1.41),('1444','2013-12-13','12:15:00',1.37),('1444','2013-12-13','12:20:00',1.36),('1444','2013-12-13','12:25:00',1.34),('1444','2013-12-13','12:30:00',1.31),('1444','2013-12-13','12:35:00',1.32),('1444','2013-12-13','12:40:00',1.29),('1444','2013-12-13','12:45:00',1.25),('1444','2013-12-13','12:50:00',1.26),('1444','2013-12-13','12:55:00',1.25),('1444','2013-12-13','13:00:00',1.26),('1444','2013-12-13','13:05:00',1.27),('1444','2013-12-13','13:10:00',1.24),('1444','2013-12-13','13:15:00',1.19),('1444','2013-12-13','13:20:00',1.19),('1444','2013-12-13','13:25:00',1.16),('1444','2013-12-13','13:30:00',1.15),('1444','2013-12-13','13:35:00',1.13),('1444','2013-12-13','13:40:00',1.1),('1444','2013-12-13','13:45:00',1.05),('1444','2013-12-13','13:50:00',1.04),('1444','2013-12-13','13:55:00',1.02),('1444','2013-12-13','14:00:00',1.01),('1444','2013-12-12','10:05:00',1.04),('1444','2013-12-12','10:10:00',1.08),('1444','2013-12-12','10:15:00',1.11),('1444','2013-12-12','10:20:00',1.14),('1444','2013-12-12','10:25:00',1.18),('1444','2013-12-12','10:30:00',1.22),('1444','2013-12-12','10:35:00',1.25),('1444','2013-12-12','10:40:00',1.28),('1444','2013-12-12','10:45:00',1.32),('1444','2013-12-12','10:50:00',1.34),('1444','2013-12-12','10:55:00',1.34),('1444','2013-12-12','11:00:00',1.36),('1444','2013-12-12','11:05:00',1.37),('1444','2013-12-12','11:10:00',1.39),('1444','2013-12-12','11:15:00',1.4),('1444','2013-12-12','11:20:00',1.4),('1444','2013-12-12','11:25:00',1.4),('1444','2013-12-12','11:30:00',1.41),('1444','2013-12-12','11:35:00',1.42),('1444','2013-12-12','11:40:00',1.43),('1444','2013-12-12','11:45:00',1.43),('1444','2013-12-12','11:50:00',1.44),('1444','2013-12-12','11:55:00',1.44),('1444','2013-12-12','12:00:00',1.41),('1444','2013-12-12','12:05:00',1.42),('1444','2013-12-12','12:10:00',1.42),('1444','2013-12-12','12:15:00',1.39),('1444','2013-12-12','12:20:00',1.39),('1444','2013-12-12','12:25:00',1.4),('1444','2013-12-12','12:30:00',1.38),('1444','2013-12-12','12:35:00',1.39),('1444','2013-12-12','12:40:00',1.35),('1444','2013-12-12','12:45:00',1.26),('1444','2013-12-12','12:50:00',1.3),('1444','2013-12-12','12:55:00',1.28),('1444','2013-12-12','13:00:00',1.25),('1444','2013-12-12','13:05:00',1.24),('1444','2013-12-12','13:10:00',1.2),('1444','2013-12-12','13:15:00',1.14),('1444','2013-12-12','13:20:00',1.14),('1444','2013-12-12','13:25:00',1.14),('1444','2013-12-12','13:30:00',1.11),('1444','2013-12-12','13:35:00',1.09),('1444','2013-12-12','13:40:00',1.05),('1444','2013-12-12','13:45:00',1.05),('1444','2013-12-12','13:50:00',1.04),('1444','2013-12-12','13:55:00',1.01),('1444','2013-12-11','10:00:00',1.02),('1444','2013-12-11','10:05:00',1.06),('1444','2013-12-11','10:10:00',1.1),('1444','2013-12-11','10:15:00',1.13),('1444','2013-12-11','10:20:00',1.17),('1444','2013-12-11','10:25:00',1.21),('1444','2013-12-11','10:30:00',1.24),('1444','2013-12-11','10:35:00',1.29),('1444','2013-12-11','10:40:00',1.32),('1444','2013-12-11','10:45:00',1.35),('1444','2013-12-11','10:50:00',1.36),('1444','2013-12-11','10:55:00',1.39),('1444','2013-12-11','11:00:00',1.41),('1444','2013-12-11','11:05:00',1.44),('1444','2013-12-11','11:10:00',1.46),('1444','2013-12-11','11:15:00',1.47),('1444','2013-12-11','11:20:00',1.48),('1444','2013-12-11','11:25:00',1.5),('1444','2013-12-11','11:30:00',1.47),('1444','2013-12-11','11:35:00',1.47),('1444','2013-12-11','11:40:00',1.48),('1444','2013-12-11','11:45:00',1.5),('1444','2013-12-11','11:50:00',1.51),('1444','2013-12-11','11:55:00',1.5),('1444','2013-12-11','12:00:00',1.48),('1444','2013-12-11','12:05:00',1.49),('1444','2013-12-11','12:10:00',1.48),('1444','2013-12-11','12:15:00',1.43),('1444','2013-12-11','12:20:00',1.42),('1444','2013-12-11','12:25:00',1.41),('1444','2013-12-11','12:30:00',1.39),('1444','2013-12-11','12:35:00',1.41),('1444','2013-12-11','12:40:00',1.38),('1444','2013-12-11','12:45:00',1.35),('1444','2013-12-11','12:50:00',1.38),('1444','2013-12-11','12:55:00',1.36),('1444','2013-12-11','13:00:00',1.34),('1444','2013-12-11','13:05:00',1.32),('1444','2013-12-11','13:10:00',1.26),('1444','2013-12-11','13:15:00',1.22),('1444','2013-12-11','13:20:00',1.21),('1444','2013-12-11','13:25:00',1.18),('1444','2013-12-11','13:30:00',1.15),('1444','2013-12-11','13:35:00',1.15),('1444','2013-12-11','13:40:00',1.11),('1444','2013-12-11','13:45:00',1.07),('1444','2013-12-11','13:50:00',1.06),('1444','2013-12-11','13:55:00',1.02),('1444','2013-12-10','09:55:00',1.04),('1444','2013-12-10','10:00:00',1.07),('1444','2013-12-10','10:05:00',1.11),('1444','2013-12-10','10:10:00',1.13),('1444','2013-12-10','10:15:00',1.17),('1444','2013-12-10','10:20:00',1.2),('1444','2013-12-10','10:25:00',1.24),('1444','2013-12-10','10:30:00',1.29),('1444','2013-12-10','10:35:00',1.31),('1444','2013-12-10','10:40:00',1.36),('1444','2013-12-10','10:45:00',1.37),('1444','2013-12-10','10:50:00',1.38),('1444','2013-12-10','10:55:00',1.4),('1444','2013-12-10','11:00:00',1.42),('1444','2013-12-10','11:05:00',1.45),('1444','2013-12-10','11:10:00',1.47),('1444','2013-12-10','11:15:00',1.48),('1444','2013-12-10','11:20:00',1.49),('1444','2013-12-10','11:25:00',1.51),('1444','2013-12-10','11:30:00',1.52),('1444','2013-12-10','11:35:00',1.53),('1444','2013-12-10','11:40:00',1.54),('1444','2013-12-10','11:45:00',1.54),('1444','2013-12-10','11:50:00',1.54),('1444','2013-12-10','11:55:00',1.52),('1444','2013-12-10','12:00:00',1.5),('1444','2013-12-10','12:05:00',1.5),('1444','2013-12-10','12:10:00',1.48),('1444','2013-12-10','12:15:00',1.46),('1444','2013-12-10','12:20:00',1.45),('1444','2013-12-10','12:25:00',1.44),('1444','2013-12-10','12:30:00',1.4),('1444','2013-12-10','12:35:00',1.4),('1444','2013-12-10','12:40:00',1.37),('1444','2013-12-10','12:45:00',1.32),('1444','2013-12-10','12:50:00',1.35),('1444','2013-12-10','12:55:00',1.32),('1444','2013-12-10','13:00:00',1.29),('1444','2013-12-10','13:05:00',1.27),('1444','2013-12-10','13:10:00',1.24),('1444','2013-12-10','13:15:00',1.17),('1444','2013-12-10','13:20:00',1.15),('1444','2013-12-10','13:25:00',1.13),('1444','2013-12-10','13:30:00',1.12),('1444','2013-12-10','13:35:00',1.12),('1444','2013-12-10','13:40:00',1.11),('1444','2013-12-10','13:45:00',1.08),('1444','2013-12-10','13:50:00',1.07),('1444','2013-12-10','13:55:00',1.05),('1444','2013-12-10','14:00:00',1.02),('1444','2013-12-09','09:55:00',1.02),('1444','2013-12-09','10:00:00',1.07),('1444','2013-12-09','10:05:00',1.21),('1444','2013-12-09','10:10:00',1.39),('1444','2013-12-09','10:15:00',1.62),('1444','2013-12-09','10:20:00',1.71),('1444','2013-12-09','10:25:00',1.12),('1444','2013-12-09','12:30:00',1.21),('1444','2013-12-09','12:45:00',1.22),('1444','2013-12-09','12:50:00',1.09),('1444','2013-12-09','12:55:00',1.34),('1444','2013-12-09','13:00:00',1.14),('1444','2013-12-09','13:15:00',1.2),('1444','2013-12-09','13:20:00',1.16),('1444','2013-12-08','11:10:00',1.08),('1444','2013-12-08','11:15:00',1.13),('1444','2013-12-08','12:55:00',1.14),('1444','2013-12-08','13:10:00',1.18),('1444','2013-12-08','13:15:00',1.07),('1444','2014-04-21','09:20:00',1.33),('1444','2014-04-21','10:00:00',1.12),('1444','2014-04-21','10:05:00',2.35),('1444','2014-04-21','10:10:00',2.53),('1444','2014-04-21','10:15:00',2.54),('1444','2014-04-21','10:20:00',2.5),('1444','2014-04-21','10:25:00',2.52),('1444','2014-04-21','10:30:00',2.52),('1444','2014-04-21','10:35:00',2.53),('1444','2014-04-21','10:40:00',2.57),('1444','2014-04-21','10:45:00',2.61),('1444','2014-04-21','10:50:00',2.63),('1444','2014-04-21','10:55:00',2.66),('1444','2014-04-21','11:00:00',2.68),('1444','2014-04-21','11:05:00',2.71),('1444','2014-04-21','11:10:00',2.74),('1444','2014-04-21','11:15:00',2.77),('1444','2014-04-21','11:20:00',2.79),('1444','2014-04-21','11:25:00',2.82),('1444','2014-04-21','11:30:00',2.85),('1444','2014-04-21','11:35:00',2.88),('1444','2014-04-21','11:40:00',2.94),('1444','2014-04-21','11:45:00',2.93),('1444','2014-04-21','11:50:00',2.97),('1444','2014-04-21','11:55:00',3),('1444','2014-04-21','12:00:00',3.01),('1444','2014-04-21','12:05:00',3.05),('1444','2014-04-21','12:10:00',3.06),('1444','2014-04-21','12:15:00',3.08),('1444','2014-04-21','12:20:00',3.11),('1444','2014-04-21','12:25:00',3.11),('1444','2014-04-21','12:30:00',3.12),('1444','2014-04-21','12:35:00',3.15),('1444','2014-04-21','12:40:00',3.15),('1444','2014-04-21','12:45:00',3.17),('1444','2014-04-21','12:50:00',3.19),('1444','2014-04-21','12:55:00',3.18),('1444','2014-04-21','13:00:00',3.19),('1444','2014-04-21','13:05:00',3.21),('1444','2014-04-21','13:10:00',3.19),('1444','2014-04-21','13:15:00',3.18),('1444','2014-04-21','13:20:00',3.16),('1444','2014-04-21','13:25:00',3.15),('1444','2014-04-21','13:30:00',3.16),('1444','2014-04-21','13:35:00',3.14),('1444','2014-04-21','13:40:00',3.14),('1444','2014-04-21','13:45:00',3.16),('1444','2014-04-21','13:50:00',3.17),('1444','2014-04-21','13:55:00',3.16),('1444','2014-04-21','14:00:00',3.15),('1444','2014-04-21','14:05:00',3.14),('1444','2014-04-21','14:10:00',3.12),('1444','2014-04-21','14:15:00',3.12),('1444','2014-04-21','14:20:00',3.1),('1444','2014-04-21','14:25:00',3.06),('1444','2014-04-21','14:30:00',3.04),('1444','2014-04-21','14:35:00',3.02),('1444','2014-04-21','14:40:00',2.99),('1444','2014-04-21','14:45:00',2.96),('1444','2014-04-21','14:50:00',2.93),('1444','2014-04-21','14:55:00',2.91),('1444','2014-04-21','15:00:00',2.88),('1444','2014-04-21','15:05:00',2.85),('1444','2014-04-21','15:10:00',2.81),('1444','2014-04-21','15:15:00',2.77),('1444','2014-04-21','15:20:00',2.74),('1444','2014-04-21','15:25:00',2.69),('1444','2014-04-21','15:30:00',2.65),('1444','2014-04-21','15:35:00',2.62),('1444','2014-04-21','15:40:00',2.58),('1444','2014-04-21','15:45:00',2.53),('1444','2014-04-21','15:50:00',2.49),('1444','2014-04-21','15:55:00',2.45),('1444','2014-04-21','16:00:00',2.41),('1444','2014-04-21','16:05:00',2.37),('1444','2014-04-21','16:10:00',2.33),('1444','2014-04-21','16:15:00',2.44),('1444','2014-04-21','16:20:00',2.24),('1444','2014-04-21','16:25:00',2.13),('1444','2014-04-21','16:30:00',2.13),('1444','2014-04-21','16:35:00',2.06),('1444','2014-04-21','16:40:00',2.02),('1444','2014-04-21','16:45:00',1.97),('1444','2014-04-21','16:50:00',1.91),('1444','2014-04-21','16:55:00',1.84),('1444','2014-04-21','17:00:00',1.78),('1444','2014-04-21','17:05:00',1.72),('1444','2014-04-21','17:10:00',1.67),('1444','2014-04-21','17:15:00',1.6),('1444','2014-04-21','17:20:00',1.54),('1444','2014-04-21','17:25:00',1.48),('1444','2014-04-21','17:30:00',1.43),('1444','2014-04-21','17:35:00',1.37),('1444','2014-04-21','17:40:00',1.25),('1444','2014-04-21','17:45:00',1.24),('1444','2014-04-21','17:50:00',1.18),('1444','2014-04-21','17:55:00',1.1),('1444','2014-04-21','18:00:00',1.03),('1444','2013-12-07','09:50:00',1.01),('1444','2013-12-07','09:55:00',1.05),('1444','2013-12-07','10:00:00',1.09),('1444','2013-12-07','10:05:00',1.1),('1444','2013-12-07','10:10:00',1.1),('1444','2013-12-07','10:15:00',1.11),('1444','2013-12-07','10:20:00',1.18),('1444','2013-12-07','10:25:00',1.2),('1444','2013-12-07','10:30:00',1.25),('1444','2013-12-07','10:35:00',1.29),('1444','2013-12-07','10:40:00',1.33),('1444','2013-12-07','10:45:00',1.39),('1444','2013-12-07','10:50:00',1.4),('1444','2013-12-07','10:55:00',1.39),('1444','2013-12-07','11:00:00',1.41),('1444','2013-12-07','11:05:00',1.43),('1444','2013-12-07','11:10:00',1.44),('1444','2013-12-07','11:15:00',1.45),('1444','2013-12-07','11:20:00',1.46),('1444','2013-12-07','11:25:00',1.47),('1444','2013-12-07','11:30:00',1.47),('1444','2013-12-07','11:35:00',1.47),('1444','2013-12-07','11:40:00',1.47),('1444','2013-12-07','11:45:00',1.46),('1444','2013-12-07','11:50:00',1.47),('1444','2013-12-07','11:55:00',1.46),('1444','2013-12-07','12:00:00',1.42),('1444','2013-12-07','12:05:00',1.44),('1444','2013-12-07','12:10:00',1.43),('1444','2013-12-07','12:15:00',1.42),('1444','2013-12-07','12:20:00',1.42),('1444','2013-12-07','12:25:00',1.4),('1444','2013-12-07','12:30:00',1.39),('1444','2013-12-07','12:35:00',1.38),('1444','2013-12-07','12:40:00',1.36),('1444','2013-12-07','12:45:00',1.32),('1444','2013-12-07','12:50:00',1.33),('1444','2013-12-07','12:55:00',1.24),('1444','2013-12-07','13:00:00',1.1),('1444','2013-12-07','13:05:00',1.29),('1444','2013-12-07','13:10:00',1.25),('1444','2013-12-07','13:15:00',1.23),('1444','2013-12-07','13:20:00',1.21),('1444','2013-12-07','13:25:00',1.17),('1444','2013-12-07','13:30:00',1.15),('1444','2013-12-07','13:35:00',1.16),('1444','2013-12-07','13:40:00',1.14),('1444','2013-12-07','13:45:00',1.09),('1444','2013-12-07','13:50:00',1.05),('1444','2013-12-07','13:55:00',1.04),('1444','2013-12-07','14:00:00',1.01),('1444','2013-12-06','11:40:00',1.19),('1444','2013-12-06','11:45:00',1.07),('1444','2013-12-06','11:50:00',1.4),('1444','2013-12-06','11:55:00',1.36),('1444','2013-12-06','12:00:00',1.62),('1444','2013-12-06','12:05:00',1.04),('1444','2013-12-06','12:10:00',1.31),('1444','2013-12-06','12:15:00',1.05),('1444','2013-12-06','12:20:00',1.2),('1444','2013-12-06','12:40:00',1.41),('1444','2013-12-05','09:45:00',1.02),('1444','2013-12-05','09:50:00',1.05),('1444','2013-12-05','09:55:00',1.08),('1444','2013-12-05','10:00:00',1.13),('1444','2013-12-05','10:05:00',1.15),('1444','2013-12-05','10:10:00',1.18),('1444','2013-12-05','10:15:00',1.22),('1444','2013-12-05','10:20:00',1.25),('1444','2013-12-05','10:25:00',1.29),('1444','2013-12-05','10:30:00',1.32),('1444','2013-12-05','10:35:00',1.37),('1444','2013-12-05','10:40:00',1.4),('1444','2013-12-05','10:45:00',1.42),('1444','2013-12-05','10:50:00',1.44),('1444','2013-12-05','10:55:00',1.45),('1444','2013-12-05','11:00:00',1.47),('1444','2013-12-05','11:05:00',1.47),('1444','2013-12-05','11:10:00',1.51),('1444','2013-12-05','11:15:00',1.52),('1444','2013-12-05','11:20:00',1.53),('1444','2013-12-05','11:25:00',1.52),('1444','2013-12-05','11:30:00',1.52),('1444','2013-12-05','11:35:00',1.54),('1444','2013-12-05','11:40:00',1.54),('1444','2013-12-05','11:45:00',1.55),('1444','2013-12-05','11:50:00',1.57),('1444','2013-12-05','11:55:00',1.53),('1444','2013-12-05','12:00:00',1.52),('1444','2013-12-05','12:05:00',1.5),('1444','2013-12-05','12:10:00',1.5),('1444','2013-12-05','12:15:00',1.46),('1444','2013-12-05','12:20:00',1.48),('1444','2013-12-05','12:25:00',1.43),('1444','2013-12-05','12:30:00',1.42),('1444','2013-12-05','12:35:00',1.43),('1444','2013-12-05','12:40:00',1.38),('1444','2013-12-05','12:45:00',1.38),('1444','2013-12-05','12:50:00',1.46),('1444','2013-12-05','12:55:00',1.41),('1444','2013-12-05','13:00:00',1.45),('1444','2013-12-05','13:05:00',1.43),('1444','2013-12-05','13:10:00',1.36),('1444','2013-12-05','13:15:00',1.31),('1444','2013-12-05','13:20:00',1.31),('1444','2013-12-05','13:25:00',1.29),('1444','2013-12-05','13:30:00',1.23),('1444','2013-12-05','13:35:00',1.21),('1444','2013-12-05','13:40:00',1.1),('1444','2013-12-05','13:45:00',1.03),('1444','2013-12-05','13:50:00',1.07),('1444','2013-12-05','13:55:00',1.03),('1444','2013-12-05','14:00:00',1.02),('1444','2013-12-05','14:05:00',1.01),('1444','2013-12-04','09:35:00',1),('1444','2013-12-04','09:40:00',1.03),('1444','2013-12-04','09:45:00',1.07),('1444','2013-12-04','09:50:00',1.12),('1444','2013-12-04','09:55:00',1.15),('1444','2013-12-04','10:00:00',1.2),('1444','2013-12-04','10:05:00',1.23),('1444','2013-12-04','10:10:00',1.26),('1444','2013-12-04','10:15:00',1.3),('1444','2013-12-04','10:20:00',1.34),('1444','2013-12-04','10:25:00',1.38),('1444','2013-12-04','10:30:00',1.42),('1444','2013-12-04','10:35:00',1.45),('1444','2013-12-04','10:40:00',1.49),('1444','2013-12-04','10:45:00',1.52),('1444','2013-12-04','10:50:00',1.53),('1444','2013-12-04','10:55:00',1.55),('1444','2013-12-04','11:00:00',1.57),('1444','2013-12-04','11:05:00',1.59),('1444','2013-12-04','11:10:00',1.61),('1444','2013-12-04','11:15:00',1.61),('1444','2013-12-04','11:20:00',1.62),('1444','2013-12-04','11:25:00',1.63),('1444','2013-12-04','11:30:00',1.64),('1444','2013-12-04','11:35:00',1.65),('1444','2013-12-04','11:40:00',1.65),('1444','2013-12-04','11:45:00',1.66),('1444','2013-12-04','11:50:00',1.65),('1444','2013-12-04','11:55:00',1.65),('1444','2013-12-04','12:00:00',1.64),('1444','2013-12-04','12:05:00',1.61),('1444','2013-12-04','12:10:00',1.59),('1444','2013-12-04','12:15:00',1.59),('1444','2013-12-04','12:20:00',1.58),('1444','2013-12-04','12:25:00',1.57),('1444','2013-12-04','12:30:00',1.56),('1444','2013-12-04','12:35:00',1.55),('1444','2013-12-04','12:40:00',1.53),('1444','2013-12-04','12:45:00',1.43),('1444','2013-12-04','12:50:00',1.49),('1444','2013-12-04','12:55:00',1.46),('1444','2013-12-04','13:00:00',1.44),('1444','2013-12-04','13:05:00',1.43),('1444','2013-12-04','13:10:00',1.38),('1444','2013-12-04','13:15:00',1.32),('1444','2013-12-04','13:20:00',1.29),('1444','2013-12-04','13:25:00',1.27),('1444','2013-12-04','13:30:00',1.24),('1444','2013-12-04','13:35:00',1.24),('1444','2013-12-04','13:40:00',1.19),('1444','2013-12-04','13:45:00',1.17),('1444','2013-12-04','13:50:00',1.14),('1444','2013-12-04','13:55:00',1.12),('1444','2013-12-04','14:00:00',1.11),('1444','2013-12-04','14:05:00',1.07),('1444','2013-12-04','14:10:00',1.03),('1444','2013-12-03','10:00:00',1.16),('1444','2013-12-03','10:05:00',1.22),('1444','2013-12-03','10:10:00',1.24),('1444','2013-12-03','10:15:00',1.29),('1444','2013-12-03','10:20:00',1.31),('1444','2013-12-03','10:25:00',1.37),('1444','2013-12-03','10:30:00',1.4),('1444','2013-12-03','10:35:00',1.43),('1444','2013-12-03','10:40:00',1.47),('1444','2013-12-03','10:45:00',1.5),('1444','2013-12-03','10:50:00',1.53),('1444','2013-12-03','10:55:00',1.57),('1444','2013-12-03','11:00:00',1.59),('1444','2013-12-03','11:05:00',1.62),('1444','2013-12-03','11:10:00',1.64),('1444','2013-12-03','11:15:00',1.65),('1444','2013-12-03','11:20:00',1.66),('1444','2013-12-03','11:25:00',1.66),('1444','2013-12-03','11:30:00',1.66),('1444','2013-12-03','11:35:00',1.67),('1444','2013-12-03','11:40:00',1.67),('1444','2013-12-03','11:45:00',1.69),('1444','2013-12-03','11:50:00',1.7),('1444','2013-12-03','11:55:00',1.69),('1444','2013-12-03','12:00:00',1.69),('1444','2013-12-03','12:05:00',1.69),('1444','2013-12-03','12:10:00',1.68),('1444','2013-12-03','12:15:00',1.68),('1444','2013-12-03','12:20:00',1.69),('1444','2013-12-03','12:25:00',1.71),('1444','2013-12-03','12:30:00',1.73),('1444','2013-12-03','12:35:00',1.75),('1444','2013-12-03','12:40:00',1.77),('1444','2013-12-03','12:45:00',1.78),('1444','2013-12-03','12:50:00',1.86),('1444','2013-12-03','12:55:00',1.86),('1444','2013-12-03','13:00:00',1.9),('1444','2013-12-03','13:05:00',1.95),('1444','2013-12-03','13:10:00',1.93),('1444','2013-12-03','13:15:00',1.87),('1444','2013-12-03','13:20:00',1.82),('1444','2013-12-03','13:25:00',1.74),('1444','2013-12-03','13:30:00',1.62),('1444','2013-12-03','13:35:00',1.58),('1444','2013-12-03','13:40:00',1.48),('1444','2013-12-03','13:45:00',1.41),('1444','2013-12-03','13:50:00',1.31),('1444','2013-12-03','13:55:00',1.25),('1444','2013-12-03','14:00:00',1.21),('1444','2013-12-03','14:05:00',1.12),('1444','2013-12-03','14:10:00',1.05),('1444','2013-12-01','12:10:00',1.15),('1444','2013-11-30','09:20:00',1.05),('1444','2013-11-30','09:25:00',1.05),('1444','2013-11-30','09:30:00',1.2),('1444','2013-11-30','09:35:00',1.35),('1444','2013-11-30','09:40:00',1.28),('1444','2013-11-30','09:45:00',1.02),('1444','2013-11-30','10:40:00',1.06),('1444','2013-11-30','10:45:00',1.01),('1444','2013-11-30','11:10:00',1.01),('1444','2013-11-29','09:35:00',1.04),('1444','2013-11-29','09:40:00',1.08),('1444','2013-11-29','09:45:00',1.12),('1444','2013-11-29','09:50:00',1.16),('1444','2013-11-29','09:55:00',1.2),('1444','2013-11-29','10:00:00',1.24),('1444','2013-11-29','10:05:00',1.28),('1444','2013-11-29','10:10:00',1.31),('1444','2013-11-29','10:15:00',1.35),('1444','2013-11-29','10:20:00',1.39),('1444','2013-11-29','10:25:00',1.44),('1444','2013-11-29','10:30:00',1.47),('1444','2013-11-29','10:35:00',1.52),('1444','2013-11-29','10:40:00',1.54),('1444','2013-11-29','10:45:00',1.57),('1444','2013-11-29','10:50:00',1.59),('1444','2013-11-29','10:55:00',1.61),('1444','2013-11-29','11:00:00',1.62),('1444','2013-11-29','11:05:00',1.64),('1444','2013-11-29','11:10:00',1.66),('1444','2013-11-29','11:15:00',1.67),('1444','2013-11-29','11:20:00',1.68),('1444','2013-11-29','11:25:00',1.69),('1444','2013-11-29','11:30:00',1.7),('1444','2013-11-29','11:35:00',1.71),('1444','2013-11-29','11:40:00',1.72),('1444','2013-11-29','11:45:00',1.71),('1444','2013-11-29','11:50:00',1.7),('1444','2013-11-29','11:55:00',1.7),('1444','2013-11-29','12:00:00',1.7),('1444','2013-11-29','12:05:00',1.69),('1444','2013-11-29','12:10:00',1.66),('1444','2013-11-29','12:15:00',1.64),('1444','2013-11-29','12:20:00',1.65),('1444','2013-11-29','12:25:00',1.63),('1444','2013-11-29','12:30:00',1.61),('1444','2013-11-29','12:35:00',1.59),('1444','2013-11-29','12:40:00',1.58),('1444','2013-11-29','12:45:00',1.57),('1444','2013-11-29','12:50:00',1.56),('1444','2013-11-29','12:55:00',1.52),('1444','2013-11-29','13:00:00',1.51),('1444','2013-11-29','13:05:00',1.47),('1444','2013-11-29','13:10:00',1.44),('1444','2013-11-29','13:15:00',1.41),('1444','2013-11-29','13:20:00',1.38),('1444','2013-11-29','13:25:00',1.33),('1444','2013-11-29','13:30:00',1.3),('1444','2013-11-29','13:35:00',1.27),('1444','2013-11-29','13:40:00',1.24),('1444','2013-11-29','13:45:00',1.21),('1444','2013-11-29','13:50:00',1.16),('1444','2013-11-29','13:55:00',1.11),('1444','2013-11-29','14:00:00',1.12),('1444','2013-11-29','14:05:00',1.09),('1444','2013-11-29','14:10:00',1.06),('1444','2013-11-29','14:15:00',1.02),('1444','2014-04-20','08:15:00',1.09),('1444','2014-04-20','08:20:00',1.45),('1444','2014-04-20','08:25:00',1.67),('1444','2014-04-20','08:30:00',1.8),('1444','2014-04-20','08:35:00',1.44),('1444','2014-04-20','08:45:00',1.62),('1444','2014-04-20','09:00:00',1.32),('1444','2014-04-20','09:10:00',1.7),('1444','2014-04-20','09:15:00',1.99),('1444','2014-04-20','09:20:00',2.11),('1444','2014-04-20','09:25:00',2.36),('1444','2014-04-20','09:30:00',2.56),('1444','2014-04-20','09:35:00',2.28),('1444','2014-04-20','09:40:00',1.49),('1444','2014-04-20','09:45:00',1.14),('1444','2014-04-20','09:50:00',1.28),('1444','2014-04-20','09:55:00',1.51),('1444','2014-04-20','10:00:00',1.8),('1444','2014-04-20','10:05:00',2.2),('1444','2014-04-20','10:10:00',2.07),('1444','2014-04-20','10:15:00',2.36),('1444','2014-04-20','10:20:00',2.4),('1444','2014-04-20','10:25:00',2.28),('1444','2014-04-20','10:30:00',2.09),('1444','2014-04-20','10:35:00',2.22),('1444','2014-04-20','10:40:00',2.06),('1444','2014-04-20','10:45:00',2.12),('1444','2014-04-20','10:50:00',2.22),('1444','2014-04-20','10:55:00',2.32),('1444','2014-04-20','11:00:00',2.71),('1444','2014-04-20','11:05:00',2.52),('1444','2014-04-20','11:10:00',2.7),('1444','2014-04-20','11:15:00',1.65),('1444','2014-04-20','11:20:00',3.04),('1444','2014-04-20','11:25:00',3.02),('1444','2014-04-20','11:30:00',3),('1444','2014-04-20','11:35:00',3.12),('1444','2014-04-20','11:40:00',1.87),('1444','2014-04-20','11:45:00',3.4),('1444','2014-04-20','11:50:00',2.44),('1444','2014-04-20','11:55:00',3.44),('1444','2014-04-20','12:00:00',3.32),('1444','2014-04-20','12:05:00',3.3),('1444','2014-04-20','12:10:00',2.57),('1444','2014-04-20','12:15:00',1.11),('1444','2014-04-20','12:20:00',2.36),('1444','2014-04-20','12:25:00',2.14),('1444','2014-04-20','12:30:00',3.55),('1444','2014-04-20','12:35:00',3.37),('1444','2014-04-20','12:40:00',3.39),('1444','2014-04-20','12:45:00',3.36),('1444','2014-04-20','12:50:00',3.37),('1444','2014-04-20','12:55:00',3.36),('1444','2014-04-20','13:00:00',3.37),('1444','2014-04-20','13:05:00',3.39),('1444','2014-04-20','13:10:00',3.2),('1444','2014-04-20','13:15:00',3.09),('1444','2014-04-20','13:20:00',3.33),('1444','2014-04-20','13:25:00',3.34),('1444','2014-04-20','13:30:00',3.32),('1444','2014-04-20','13:35:00',3.33),('1444','2014-04-20','13:40:00',3.32),('1444','2014-04-20','13:45:00',3.29),('1444','2014-04-20','13:50:00',3.3),('1444','2014-04-20','13:55:00',3.28),('1444','2014-04-20','14:00:00',3.24),('1444','2014-04-20','14:05:00',3.23),('1444','2014-04-20','14:10:00',3.25),('1444','2014-04-20','14:15:00',3.4),('1444','2014-04-20','14:20:00',2.5),('1444','2014-04-20','14:25:00',2.45),('1444','2014-04-20','14:30:00',2.32),('1444','2014-04-20','14:35:00',1.98),('1444','2014-04-20','14:40:00',1.99),('1444','2014-04-20','14:45:00',2.15),('1444','2014-04-20','14:50:00',2.1),('1444','2014-04-20','14:55:00',2.34),('1444','2014-04-20','15:00:00',3.13),('1444','2014-04-20','15:05:00',2.7),('1444','2014-04-20','15:10:00',3.02),('1444','2014-04-20','15:15:00',2.88),('1444','2014-04-20','15:20:00',2.84),('1444','2014-04-20','15:25:00',2.79),('1444','2014-04-20','15:30:00',2.75),('1444','2014-04-20','15:35:00',2.64),('1444','2014-04-20','15:40:00',2.77),('1444','2014-04-20','15:45:00',1.79),('1444','2014-04-20','15:50:00',2.32),('1444','2014-04-20','15:55:00',2.6),('1444','2014-04-20','16:00:00',2.5),('1444','2014-04-20','16:05:00',2.43),('1444','2014-04-20','16:10:00',2.41),('1444','2014-04-20','16:15:00',2.39),('1444','2014-04-20','16:20:00',2.34),('1444','2014-04-20','16:25:00',2.28),('1444','2014-04-20','16:30:00',2.07),('1444','2014-04-20','16:35:00',2.14),('1444','2014-04-20','16:40:00',1.92),('1444','2014-04-20','16:45:00',1.67),('1444','2014-04-20','16:50:00',1.82),('1444','2014-04-20','16:55:00',1.98),('1444','2014-04-20','17:00:00',1.87),('1444','2014-04-20','17:05:00',1.78),('1444','2014-04-20','17:10:00',1.69),('1444','2014-04-20','17:15:00',1.62),('1444','2014-04-20','17:20:00',1.56),('1444','2014-04-20','17:25:00',1.49),('1444','2014-04-20','17:30:00',1.43),('1444','2014-04-20','17:35:00',1.36),('1444','2014-04-20','17:40:00',1.3),('1444','2014-04-20','17:45:00',1.23),('1444','2014-04-20','17:50:00',1.16),('1444','2014-04-20','17:55:00',1.1),('1444','2014-04-20','18:00:00',1.03),('1444','2013-11-27','10:45:00',1.02),('1444','2013-11-27','11:05:00',1.13),('1444','2013-11-27','11:10:00',1.27),('1444','2013-11-27','11:15:00',1.01),('1444','2013-11-27','11:20:00',1.03),('1444','2013-11-27','11:25:00',1.1),('1444','2013-11-27','11:30:00',1.67),('1444','2013-11-27','11:35:00',1.39),('1444','2013-11-27','11:40:00',1.16),('1444','2013-11-27','11:45:00',1.14),('1444','2013-11-27','11:50:00',1.75),('1444','2013-11-27','11:55:00',1.98),('1444','2013-11-27','12:00:00',1.97),('1444','2013-11-27','12:05:00',1.53),('1444','2013-11-27','12:10:00',1.07),('1444','2013-11-27','12:15:00',1.24),('1444','2013-11-27','12:20:00',1.91),('1444','2013-11-27','12:25:00',1.18),('1444','2013-11-27','12:35:00',1.62),('1444','2013-11-26','09:40:00',1.07),('1444','2013-11-26','09:55:00',1.16),('1444','2013-11-26','10:05:00',1.04),('1444','2013-11-26','10:20:00',1.06),('1444','2013-11-26','10:25:00',1.17),('1444','2013-11-26','10:30:00',1.23),('1444','2013-11-26','10:35:00',1.69),('1444','2013-11-26','10:40:00',1.68),('1444','2013-11-26','10:45:00',1.73),('1444','2013-11-26','10:50:00',1.71),('1444','2013-11-26','10:55:00',1.78),('1444','2013-11-26','11:00:00',1.81),('1444','2013-11-26','11:05:00',1.83),('1444','2013-11-26','11:10:00',2.1),('1444','2013-11-26','11:15:00',2.23),('1444','2013-11-26','11:20:00',1.56),('1444','2013-11-26','11:25:00',2.07),('1444','2013-11-26','11:30:00',2.11),('1444','2013-11-26','11:35:00',1.62),('1444','2013-11-26','11:40:00',1.55),('1444','2013-11-26','11:45:00',2.23),('1444','2013-11-26','11:50:00',1.88),('1444','2013-11-26','11:55:00',1.62),('1444','2013-11-26','12:05:00',1.17),('1444','2013-11-26','12:20:00',1.84),('1444','2013-11-26','12:25:00',1.74),('1444','2013-11-26','12:30:00',1.64),('1444','2013-11-26','12:35:00',1.73),('1444','2013-11-26','12:40:00',1.72),('1444','2013-11-26','12:45:00',1.72),('1444','2013-11-26','12:50:00',1.7),('1444','2013-11-26','12:55:00',1.66),('1444','2013-11-26','13:00:00',1.66),('1444','2013-11-26','13:05:00',1.62),('1444','2013-11-26','13:10:00',1.6),('1444','2013-11-26','13:15:00',1.56),('1444','2013-11-26','13:20:00',1.52),('1444','2013-11-26','13:25:00',1.49),('1444','2013-11-26','13:30:00',1.45),('1444','2013-11-26','13:35:00',1.42),('1444','2013-11-26','13:40:00',1.4),('1444','2013-11-26','13:45:00',1.36),('1444','2013-11-26','13:50:00',1.36),('1444','2013-11-26','13:55:00',1.3),('1444','2013-11-26','14:00:00',1.46),('1444','2013-11-26','14:05:00',1.54),('1444','2013-11-26','14:10:00',1.58),('1444','2013-11-26','14:15:00',1.82),('1444','2013-11-26','14:20:00',1.64),('1444','2013-11-26','14:25:00',1.09),('1444','2013-11-26','14:35:00',1.02),('1444','2013-11-26','14:45:00',1.08),('1444','2013-11-26','14:50:00',1.07),('1444','2013-11-26','14:55:00',1.21),('1444','2013-11-26','15:00:00',1.09),('1444','2013-11-25','08:55:00',1.12),('1444','2013-11-25','09:00:00',1.24),('1444','2013-11-25','09:05:00',1.3),('1444','2013-11-25','09:10:00',1.3),('1444','2013-11-25','09:15:00',1.36),('1444','2013-11-25','09:20:00',1.52),('1444','2013-11-25','09:25:00',1.22),('1444','2013-11-25','09:35:00',1.12),('1444','2013-11-25','09:40:00',1.23),('1444','2013-11-25','09:50:00',1.38),('1444','2013-11-25','09:55:00',1.27),('1444','2013-11-25','10:00:00',1.27),('1444','2013-11-25','10:05:00',1.42),('1444','2013-11-25','10:15:00',1.36),('1444','2013-11-25','10:25:00',1.06),('1444','2013-11-25','10:30:00',1.32),('1444','2013-11-25','10:35:00',1.48),('1444','2013-11-25','10:40:00',1.94),('1444','2013-11-25','10:45:00',1.87),('1444','2013-11-25','10:50:00',1.57),('1444','2013-11-25','10:55:00',1.54),('1444','2013-11-25','11:00:00',1.76),('1444','2013-11-25','11:05:00',1.88),('1444','2013-11-25','11:10:00',2.2),('1444','2013-11-25','11:15:00',1.96),('1444','2013-11-25','11:30:00',1.24),('1444','2013-11-25','11:50:00',1.15),('1444','2013-11-25','12:00:00',1.15),('1444','2013-11-25','12:05:00',1.14),('1444','2013-11-25','12:10:00',1.37),('1444','2013-11-25','12:15:00',1.19),('1444','2013-11-25','12:25:00',1.05),('1444','2013-11-25','12:40:00',1.85),('1444','2013-11-25','12:45:00',1.84),('1444','2013-11-25','12:50:00',1.48),('1444','2013-11-25','12:55:00',1.55),('1444','2013-11-25','13:00:00',1.96),('1444','2013-11-25','13:05:00',1.88),('1444','2013-11-25','13:10:00',1.55),('1444','2013-11-25','13:15:00',1.25),('1444','2013-11-25','13:20:00',2.11),('1444','2013-11-25','13:25:00',1.97),('1444','2013-11-25','13:30:00',1.43),('1444','2013-11-24','10:00:00',1.07),('1444','2013-11-24','10:05:00',1.11),('1444','2013-11-24','10:10:00',1.13),('1444','2013-11-24','10:15:00',1.05),('1444','2013-11-24','10:25:00',1.2),('1444','2013-11-24','10:30:00',1.13),('1444','2013-11-24','11:20:00',1.03),('1444','2013-11-24','11:25:00',1.06),('1444','2013-11-24','11:30:00',1.07),('1444','2013-11-24','13:05:00',1.1),('1444','2013-11-24','13:10:00',1.08),('1444','2013-11-24','13:15:00',1.04),('1444','2013-11-23','10:25:00',1.1),('1444','2013-11-23','10:30:00',1.18),('1444','2013-11-23','10:40:00',1.58),('1444','2013-11-23','13:35:00',1.1),('1444','2013-11-21','09:45:00',1.15),('1444','2013-11-21','09:55:00',1.12),('1444','2013-11-21','10:00:00',1.33),('1444','2013-11-21','10:05:00',1.33),('1444','2013-11-21','10:15:00',1.41),('1444','2013-11-21','10:20:00',1.28),('1444','2013-11-21','10:25:00',1.01),('1444','2013-11-21','10:30:00',1.42),('1444','2013-11-21','10:35:00',1.47),('1444','2013-11-21','10:40:00',1.67),('1444','2013-11-21','10:45:00',1.19),('1444','2013-11-21','11:20:00',1.05),('1444','2013-11-21','11:30:00',1.12),('1444','2013-11-21','11:35:00',1.53),('1444','2013-11-21','11:40:00',1.28),('1444','2013-11-21','11:50:00',1.38),('1444','2013-11-21','11:55:00',1.6),('1444','2013-11-21','12:05:00',1.69),('1444','2013-11-21','12:10:00',1.65),('1444','2013-11-21','12:15:00',1.64),('1444','2013-11-21','12:20:00',1.66),('1444','2013-11-21','12:25:00',1.73),('1444','2013-11-21','12:30:00',1.85),('1444','2013-11-21','12:35:00',1.82),('1444','2013-11-21','12:40:00',1.91),('1444','2013-11-21','12:45:00',1.84),('1444','2013-11-21','12:50:00',1.55),('1444','2013-11-21','12:55:00',1.85),('1444','2013-11-21','13:00:00',1.84),('1444','2013-11-21','13:05:00',1.76),('1444','2013-11-21','13:10:00',1.71),('1444','2013-11-21','13:15:00',1.74),('1444','2013-11-21','13:20:00',1.54),('1444','2013-11-21','13:25:00',1.34),('1444','2013-11-21','13:40:00',1.36),('1444','2013-11-21','13:45:00',1.31),('1444','2013-11-21','13:55:00',1.13),('1444','2013-11-21','14:00:00',1.29),('1444','2013-11-20','09:25:00',1),('1444','2013-11-20','09:30:00',1.14),('1444','2013-11-20','10:15:00',1.27),('1444','2013-11-20','11:45:00',2.51),('1444','2013-11-20','11:50:00',2.05),('1444','2013-11-20','11:55:00',1.21),('1444','2013-11-20','12:50:00',1.82),('1444','2013-11-20','12:55:00',1.84),('1444','2013-11-20','13:00:00',1.27),('1444','2013-11-20','13:05:00',1.21),('1444','2013-11-20','13:20:00',1.14),('1444','2013-11-19','09:40:00',1.17),('1444','2013-11-19','09:45:00',1.11),('1444','2013-11-19','11:20:00',1.13),('1444','2013-11-19','11:25:00',1.34),('1444','2013-11-19','11:30:00',1.57),('1444','2013-11-19','11:35:00',1.76),('1444','2013-11-19','11:40:00',1.34),('1444','2013-11-19','11:45:00',1.58),('1444','2013-11-19','11:50:00',1.47),('1444','2013-11-19','11:55:00',1.32),('1444','2013-11-19','12:00:00',1.32),('1444','2013-11-19','12:05:00',1.43),('1444','2013-11-19','12:10:00',1.14),('1444','2013-11-19','12:15:00',1.55),('1444','2013-11-19','12:30:00',1.1),('1444','2013-11-19','12:40:00',1.1),('1444','2013-11-19','12:45:00',1.3),('1444','2013-11-19','12:50:00',1.32),('1444','2013-11-19','12:55:00',1.81),('1444','2013-11-19','13:15:00',1.38),('1444','2013-11-19','13:20:00',1.11),('1444','2013-11-18','09:35:00',1.14),('1444','2013-11-18','10:10:00',1.09),('1444','2013-11-18','10:15:00',1.14),('1444','2013-11-18','12:05:00',1.03),('1444','2013-11-18','12:10:00',1.02),('1444','2013-11-18','12:15:00',1.06),('1444','2013-11-18','12:20:00',1.12),('1444','2013-11-18','12:25:00',1.14),('1444','2013-11-18','12:30:00',1.01),('1444','2014-04-19','07:55:00',1.46),('1444','2014-04-19','08:00:00',1.15),('1444','2014-04-19','08:25:00',1.34),('1444','2014-04-19','08:30:00',1.8),('1444','2014-04-19','08:35:00',1.63),('1444','2014-04-19','08:40:00',1.54),('1444','2014-04-19','08:45:00',1.42),('1444','2014-04-19','08:50:00',1.12),('1444','2014-04-19','09:25:00',1.23),('1444','2014-04-19','09:30:00',1.66),('1444','2014-04-19','09:35:00',1.47),('1444','2014-04-19','10:55:00',1.29),('1444','2014-04-19','11:00:00',1.28),('1444','2014-04-19','11:05:00',1.02),('1444','2014-04-19','11:10:00',1.03),('1444','2014-04-19','11:15:00',1.59),('1444','2014-04-19','11:20:00',2.31),('1444','2014-04-19','11:25:00',1.8),('1444','2014-04-19','11:30:00',2.06),('1444','2014-04-19','11:35:00',1.97),('1444','2014-04-19','11:40:00',1.71),('1444','2014-04-19','11:45:00',1.65),('1444','2014-04-19','11:50:00',1.29),('1444','2014-04-19','13:15:00',1.28),('1444','2014-04-19','14:30:00',1.12),('1444','2014-04-19','14:35:00',1.25),('1444','2014-04-19','14:40:00',1.52),('1444','2014-04-19','14:45:00',1.56),('1444','2014-04-19','15:00:00',1.2),('1444','2014-04-19','15:50:00',2.91),('1444','2014-04-19','15:55:00',1.94),('1444','2014-04-19','16:00:00',1.91),('1444','2014-04-19','16:05:00',1.64),('1444','2014-04-19','16:10:00',1.44),('1444','2014-04-19','16:15:00',1.46),('1444','2014-04-19','16:20:00',1.67),('1444','2014-04-19','16:25:00',1.57),('1444','2014-04-19','16:30:00',1.81),('1444','2014-04-19','16:35:00',1.23),('1444','2014-04-19','17:20:00',1.35),('1444','2014-04-19','17:25:00',1.05),('1444','2013-11-17','08:50:00',1.07),('1444','2013-11-17','08:55:00',1.07),('1444','2013-11-17','09:25:00',1.09),('1444','2013-11-17','09:30:00',1.13),('1444','2013-11-17','09:35:00',1.07),('1444','2013-11-17','09:40:00',1.1),('1444','2013-11-17','09:45:00',1.13),('1444','2013-11-17','09:50:00',1.15),('1444','2013-11-17','09:55:00',1.19),('1444','2013-11-17','10:00:00',1.23),('1444','2013-11-17','10:05:00',1.27),('1444','2013-11-17','10:10:00',1.29),('1444','2013-11-17','10:15:00',1.35),('1444','2013-11-17','10:20:00',1.38),('1444','2013-11-17','10:25:00',1.4),('1444','2013-11-17','10:30:00',1.43),('1444','2013-11-17','10:35:00',1.45),('1444','2013-11-17','10:40:00',1.46),('1444','2013-11-17','10:45:00',1.48),('1444','2013-11-17','10:50:00',1.49),('1444','2013-11-17','10:55:00',1.51),('1444','2013-11-17','11:00:00',1.53),('1444','2013-11-17','11:05:00',1.55),('1444','2013-11-17','11:10:00',1.56),('1444','2013-11-17','11:15:00',1.57),('1444','2013-11-17','11:20:00',1.58),('1444','2013-11-17','11:25:00',1.58),('1444','2013-11-17','11:30:00',1.58),('1444','2013-11-17','11:35:00',1.58),('1444','2013-11-17','11:40:00',1.58),('1444','2013-11-17','11:45:00',1.59),('1444','2013-11-17','11:50:00',1.6),('1444','2013-11-17','11:55:00',1.59),('1444','2013-11-17','12:00:00',1.57),('1444','2013-11-17','12:05:00',1.58),('1444','2013-11-17','12:10:00',1.57),('1444','2013-11-17','12:15:00',1.57),('1444','2013-11-17','12:20:00',1.55),('1444','2013-11-17','12:25:00',1.53),('1444','2013-11-17','12:30:00',1.53),('1444','2013-11-17','12:35:00',1.51),('1444','2013-11-17','12:40:00',1.51),('1444','2013-11-17','12:45:00',1.48),('1444','2013-11-17','12:50:00',1.45),('1444','2013-11-17','12:55:00',1.42),('1444','2013-11-17','13:00:00',1.39),('1444','2013-11-17','13:05:00',1.37),('1444','2013-11-17','13:10:00',1.34),('1444','2013-11-17','13:15:00',1.33),('1444','2013-11-17','13:20:00',1.28),('1444','2013-11-17','13:25:00',1.17),('1444','2013-11-17','13:30:00',1.3),('1444','2013-11-17','13:35:00',1.33),('1444','2013-11-17','13:40:00',1),('1444','2013-11-15','11:20:00',1.13),('1444','2013-11-15','11:25:00',1.15),('1444','2013-11-15','11:30:00',1.22),('1444','2013-11-15','11:35:00',1.15),('1444','2013-11-15','11:40:00',1.22),('1444','2013-11-15','11:45:00',1.04),('1444','2013-11-15','12:20:00',1.01),('1444','2013-11-15','13:45:00',1.1),('1444','2013-11-15','13:50:00',1.09),('1444','2013-11-14','09:05:00',1.01),('1444','2013-11-14','09:20:00',1.02),('1444','2013-11-14','09:25:00',1.03),('1444','2013-11-14','09:30:00',1.06),('1444','2013-11-14','09:35:00',1.11),('1444','2013-11-14','09:40:00',1.13),('1444','2013-11-14','09:45:00',1.15),('1444','2013-11-14','10:15:00',1.36),('1444','2013-11-14','10:20:00',1.44),('1444','2013-11-14','10:25:00',1.43),('1444','2013-11-14','10:30:00',1.46),('1444','2013-11-14','10:35:00',1.47),('1444','2013-11-14','10:40:00',1.46),('1444','2013-11-14','10:45:00',1.45),('1444','2013-11-14','10:50:00',1.5),('1444','2013-11-14','10:55:00',1.54),('1444','2013-11-14','11:00:00',1.55),('1444','2013-11-14','11:05:00',1.6),('1444','2013-11-14','11:10:00',1.65),('1444','2013-11-14','11:15:00',1.67),('1444','2013-11-14','11:20:00',1.72),('1444','2013-11-14','11:25:00',1.73),('1444','2013-11-14','11:30:00',1.74),('1444','2013-11-14','11:35:00',1.56),('1444','2013-11-14','11:40:00',1.39),('1444','2013-11-14','11:45:00',1.02),('1444','2013-11-14','11:55:00',1.65),('1444','2013-11-14','12:00:00',1.82),('1444','2013-11-14','12:05:00',1.72),('1444','2013-11-13','10:20:00',1.76),('1444','2013-11-13','10:25:00',1.96),('1444','2013-11-13','10:30:00',1.93),('1444','2013-11-13','10:35:00',2.18),('1444','2013-11-13','10:40:00',2.01),('1444','2013-11-13','10:45:00',1.97),('1444','2013-11-13','10:50:00',2.17),('1444','2013-11-13','10:55:00',1.51),('1444','2013-11-13','14:00:00',1.11),('1444','2013-11-13','14:05:00',1.05),('1444','2013-11-13','14:10:00',1.01),('1444','2013-11-13','14:15:00',1.03),('1444','2013-11-13','14:25:00',1.01),('1444','2013-11-12','11:50:00',1.14),('1444','2013-11-12','12:00:00',1.65),('1444','2013-11-12','12:30:00',2.46),('1444','2013-11-12','12:35:00',2.3),('1444','2013-11-12','12:40:00',1.43),('1444','2013-11-12','12:45:00',1.36),('1444','2013-11-12','12:50:00',1.28),('1444','2013-11-12','12:55:00',1.48),('1444','2013-11-12','13:00:00',1.33),('1444','2013-11-12','13:05:00',1.29),('1444','2013-11-12','13:10:00',1.43),('1444','2013-11-12','13:15:00',1.37),('1444','2013-11-12','13:20:00',1.17),('1444','2013-11-12','13:25:00',1.22),('1444','2013-11-12','13:30:00',1.27),('1444','2013-11-12','13:35:00',1.33),('1444','2013-11-12','13:40:00',1.31),('1444','2013-11-12','13:45:00',1.09),('1444','2013-11-12','14:10:00',1.54),('1444','2013-11-12','14:15:00',1.63),('1444','2013-11-12','14:20:00',1.31),('1444','2013-11-12','14:30:00',1),('1444','2013-11-11','10:15:00',1.48),('1444','2013-11-11','10:20:00',1.38),('1444','2013-11-11','11:05:00',1.21);
INSERT INTO `solarlogmod` VALUES ('1444','2013-11-11','11:10:00',2.45),('1444','2013-11-11','11:15:00',2.32),('1444','2013-11-11','11:20:00',1.22),('1444','2013-11-11','11:25:00',1.33),('1444','2013-11-11','11:30:00',2.38),('1444','2013-11-11','11:35:00',2.04),('1444','2013-11-11','11:40:00',2.03),('1444','2013-11-11','11:45:00',1.74),('1444','2013-11-11','11:50:00',2.13),('1444','2013-11-11','11:55:00',2.15),('1444','2013-11-11','12:00:00',1.84),('1444','2013-11-11','12:05:00',1.88),('1444','2013-11-11','12:10:00',1.5),('1444','2013-11-11','12:15:00',1.68),('1444','2013-11-11','12:20:00',1.79),('1444','2013-11-11','12:25:00',1.9),('1444','2013-11-11','12:40:00',1.06),('1444','2013-11-11','12:45:00',1.03),('1444','2013-11-11','13:40:00',1.04),('1444','2013-11-11','14:00:00',1.42),('1444','2013-11-11','14:25:00',1.24),('1444','2013-11-11','14:30:00',1.1),('1444','2013-11-11','14:35:00',1.06),('1444','2013-11-10','08:50:00',1.02),('1444','2013-11-10','09:20:00',1.07),('1444','2013-11-10','09:25:00',1.16),('1444','2013-11-10','09:35:00',1.01),('1444','2013-11-10','09:40:00',1.11),('1444','2013-11-10','09:45:00',1.25),('1444','2013-11-10','09:50:00',1.29),('1444','2013-11-10','09:55:00',1.3),('1444','2013-11-10','10:00:00',1.22),('1444','2013-11-10','10:05:00',1.36),('1444','2013-11-10','10:10:00',1.58),('1444','2013-11-10','10:15:00',1.57),('1444','2013-11-10','10:20:00',1.46),('1444','2013-11-10','10:25:00',1.78),('1444','2013-11-10','10:30:00',1.64),('1444','2013-11-10','10:35:00',1.21),('1444','2013-11-10','10:40:00',1.62),('1444','2013-11-10','10:45:00',1.71),('1444','2013-11-10','10:50:00',2.04),('1444','2013-11-10','10:55:00',2.03),('1444','2013-11-10','11:25:00',1.03),('1444','2013-11-10','11:40:00',1.56),('1444','2013-11-10','11:45:00',1.63),('1444','2013-11-10','11:55:00',1.12),('1444','2013-11-10','12:10:00',1.04),('1444','2013-11-10','12:15:00',1.78),('1444','2013-11-10','12:20:00',1.55),('1444','2013-11-10','12:25:00',1.68),('1444','2013-11-10','12:35:00',1.61),('1444','2013-11-10','12:40:00',1.87),('1444','2013-11-10','12:45:00',1.99),('1444','2013-11-10','12:50:00',1.92),('1444','2013-11-10','12:55:00',1.28),('1444','2013-11-10','13:50:00',1.4),('1444','2013-11-09','09:45:00',1.17),('1444','2013-11-09','09:50:00',1.76),('1444','2013-11-09','09:55:00',1.61),('1444','2013-11-09','10:00:00',1.56),('1444','2013-11-09','10:05:00',1.46),('1444','2013-11-09','10:10:00',1.39),('1444','2013-11-09','10:15:00',1.41),('1444','2013-11-09','10:20:00',1.14),('1444','2013-11-09','10:50:00',1.26),('1444','2013-11-09','10:55:00',1.22),('1444','2013-11-09','11:00:00',1.33),('1444','2013-11-09','11:05:00',1.35),('1444','2013-11-09','11:10:00',1.68),('1444','2013-11-09','11:15:00',1.41),('1444','2013-11-09','11:20:00',1.24),('1444','2013-11-09','11:25:00',1.65),('1444','2013-11-09','11:30:00',1.45),('1444','2013-11-09','11:35:00',1.18),('1444','2013-11-09','11:40:00',1.68),('1444','2013-11-09','11:45:00',1.98),('1444','2013-11-09','11:50:00',1.57),('1444','2013-11-09','11:55:00',2.09),('1444','2013-11-09','12:00:00',2.3),('1444','2013-11-09','12:05:00',2.13),('1444','2013-11-09','12:10:00',1.11),('1444','2013-11-09','12:15:00',1.38),('1444','2013-11-09','12:25:00',1.17),('1444','2013-11-09','12:30:00',1.5),('1444','2013-11-09','12:35:00',2.33),('1444','2013-11-09','12:40:00',2.21),('1444','2013-11-09','12:45:00',1.03),('1444','2013-11-09','12:55:00',1.68),('1444','2013-11-09','13:00:00',1.51),('1444','2013-11-09','13:05:00',1.53),('1444','2013-11-09','13:10:00',1.8),('1444','2013-11-09','13:15:00',1.47),('1444','2013-11-09','13:25:00',1.69),('1444','2013-11-09','13:30:00',1.47),('1444','2013-11-09','13:35:00',1.44),('1444','2013-11-09','13:40:00',1.37),('1444','2013-11-09','13:45:00',1.34),('1444','2013-11-09','13:50:00',1.36),('1444','2013-11-09','13:55:00',1.31),('1444','2013-11-09','14:00:00',1.1),('1444','2013-11-09','14:05:00',1.13),('1444','2013-11-09','14:20:00',1.17),('1444','2013-11-08','09:30:00',1.06),('1444','2013-11-08','09:50:00',1.32),('1444','2013-11-08','09:55:00',1.66),('1444','2013-11-08','10:00:00',1.44),('1444','2013-11-08','10:05:00',1.33),('1444','2013-11-08','10:10:00',1.28),('1444','2013-11-08','10:50:00',1.55),('1444','2013-11-08','11:40:00',1.09),('1444','2013-11-08','11:45:00',1.09),('1444','2013-11-08','11:50:00',1.99),('1444','2013-11-08','11:55:00',1.99),('1444','2013-11-08','12:00:00',1.83),('1444','2013-11-08','12:05:00',1.72),('1444','2013-11-08','12:10:00',1.33),('1444','2013-11-08','12:20:00',1.21),('1444','2013-11-08','12:30:00',1.83),('1444','2013-11-08','12:35:00',1.89),('1444','2013-11-08','12:40:00',1.9),('1444','2013-11-08','12:45:00',1.9),('1444','2013-11-08','12:50:00',1.86),('1444','2013-11-08','12:55:00',1.78),('1444','2013-11-08','13:00:00',1.69),('1444','2013-11-08','13:05:00',1.72),('1444','2013-11-08','13:10:00',1.33),('1444','2013-11-08','13:20:00',1.07),('1444','2013-11-08','13:35:00',1.46),('1444','2013-11-08','13:40:00',1.39),('1444','2013-11-08','13:45:00',1.33),('1444','2013-11-08','13:50:00',1.32),('1444','2013-11-08','13:55:00',1.27),('1444','2013-11-08','14:00:00',1.23),('1444','2013-11-08','14:05:00',1.09),('1444','2013-11-08','14:10:00',1.16),('1444','2013-11-08','14:15:00',1.1),('1444','2013-11-08','14:25:00',1.06),('1444','2013-11-08','14:30:00',1.07),('1444','2013-11-08','14:35:00',1.08),('1444','2014-04-18','08:05:00',1.25),('1444','2014-04-18','08:10:00',1.24),('1444','2014-04-18','08:40:00',1.09),('1444','2014-04-18','08:45:00',1.25),('1444','2014-04-18','09:05:00',1.8),('1444','2014-04-18','09:10:00',2.45),('1444','2014-04-18','09:15:00',2.28),('1444','2014-04-18','09:20:00',2.14),('1444','2014-04-18','09:25:00',1.3),('1444','2014-04-18','09:30:00',2.36),('1444','2014-04-18','09:35:00',1.5),('1444','2014-04-18','09:45:00',1.36),('1444','2014-04-18','09:50:00',2.18),('1444','2014-04-18','09:55:00',2.47),('1444','2014-04-18','10:00:00',2.05),('1444','2014-04-18','10:05:00',1.38),('1444','2014-04-18','10:10:00',1.21),('1444','2014-04-18','10:15:00',1.2),('1444','2014-04-18','10:20:00',1.21),('1444','2014-04-18','10:25:00',1.23),('1444','2014-04-18','10:30:00',1.04),('1444','2014-04-18','10:40:00',1.09),('1444','2014-04-18','10:45:00',1.8),('1444','2014-04-18','10:50:00',2.04),('1444','2014-04-18','10:55:00',2.28),('1444','2014-04-18','11:00:00',1.52),('1444','2014-04-18','11:05:00',1.36),('1444','2014-04-18','11:10:00',1.46),('1444','2014-04-18','11:15:00',2.61),('1444','2014-04-18','11:20:00',1.6),('1444','2014-04-18','11:25:00',1.15),('1444','2014-04-18','11:30:00',1.34),('1444','2014-04-18','11:35:00',1.35),('1444','2014-04-18','11:40:00',1.38),('1444','2014-04-18','11:45:00',1.31),('1444','2014-04-18','11:50:00',1.6),('1444','2014-04-18','11:55:00',1.42),('1444','2014-04-18','12:00:00',1.48),('1444','2014-04-18','12:05:00',2.6),('1444','2014-04-18','12:10:00',2.88),('1444','2014-04-18','12:15:00',2.95),('1444','2014-04-18','12:20:00',2.88),('1444','2014-04-18','12:25:00',2.29),('1444','2014-04-18','12:30:00',3.42),('1444','2014-04-18','12:35:00',3.26),('1444','2014-04-18','12:40:00',3.53),('1444','2014-04-18','12:45:00',2.73),('1444','2014-04-18','12:50:00',2.85),('1444','2014-04-18','12:55:00',2.15),('1444','2014-04-18','13:00:00',3.35),('1444','2014-04-18','13:05:00',1.89),('1444','2014-04-18','13:10:00',1.91),('1444','2014-04-18','13:15:00',1.87),('1444','2014-04-18','13:20:00',1.77),('1444','2014-04-18','13:25:00',1.36),('1444','2014-04-18','13:30:00',1.09),('1444','2014-04-18','13:35:00',1.12),('1444','2014-04-18','13:40:00',1.09),('1444','2014-04-18','13:50:00',1.08),('1444','2014-04-18','13:55:00',1.83),('1444','2014-04-18','14:00:00',1.63),('1444','2014-04-18','14:05:00',1.46),('1444','2014-04-18','14:10:00',1.24),('1444','2014-04-18','14:15:00',1.1),('1444','2014-04-18','14:20:00',1.27),('1444','2014-04-18','14:25:00',1.62),('1444','2014-04-18','14:30:00',1.84),('1444','2014-04-18','14:35:00',2.05),('1444','2014-04-18','14:40:00',1.79),('1444','2014-04-18','14:45:00',2.09),('1444','2014-04-18','14:50:00',2.15),('1444','2014-04-18','14:55:00',1.83),('1444','2014-04-18','15:00:00',3.29),('1444','2014-04-18','15:05:00',2.11),('1444','2014-04-18','15:10:00',1.45),('1444','2014-04-18','15:15:00',1.66),('1444','2014-04-18','15:20:00',1.44),('1444','2014-04-18','15:25:00',1.81),('1444','2014-04-18','15:30:00',2.52),('1444','2014-04-18','15:35:00',2.84),('1444','2014-04-18','15:40:00',2.59),('1444','2014-04-18','15:45:00',1.9),('1444','2014-04-18','15:50:00',2.13),('1444','2014-04-18','15:55:00',2.17),('1444','2014-04-18','16:00:00',1.88),('1444','2014-04-18','16:05:00',1.46),('1444','2014-04-18','16:10:00',1.19),('1444','2014-04-18','16:15:00',1.04),('1444','2014-04-18','16:20:00',1.07),('1444','2014-04-18','16:25:00',2.03),('1444','2014-04-18','16:30:00',1.86),('1444','2014-04-18','16:35:00',2.42),('1444','2014-04-18','16:40:00',2.27),('1444','2014-04-18','16:45:00',2.09),('1444','2014-04-18','16:50:00',2.09),('1444','2014-04-18','16:55:00',2.05),('1444','2014-04-18','17:00:00',2.04),('1444','2014-04-18','17:05:00',2.1),('1444','2014-04-18','17:10:00',1.69),('1444','2014-04-18','17:15:00',1.6),('1444','2014-04-18','17:20:00',1.58),('1444','2014-04-18','17:25:00',1.57),('1444','2014-04-18','17:30:00',1.42),('1444','2014-04-18','17:35:00',1.34),('1444','2014-04-18','17:40:00',1.3),('1444','2014-04-18','17:45:00',1.22),('1444','2014-04-18','17:50:00',1.16),('1444','2014-04-18','17:55:00',1.1),('1444','2014-04-18','18:00:00',1.06),('1444','2013-11-07','09:15:00',1.02),('1444','2013-11-07','09:20:00',1.06),('1444','2013-11-07','09:25:00',1.09),('1444','2013-11-07','09:30:00',1.14),('1444','2013-11-07','09:35:00',1.19),('1444','2013-11-07','09:40:00',1.23),('1444','2013-11-07','09:45:00',1.27),('1444','2013-11-07','09:50:00',1.31),('1444','2013-11-07','09:55:00',1.34),('1444','2013-11-07','10:00:00',1.37),('1444','2013-11-07','10:05:00',1.39),('1444','2013-11-07','10:10:00',1.41),('1444','2013-11-07','10:15:00',1.42),('1444','2013-11-07','10:20:00',1.43),('1444','2013-11-07','10:25:00',1.47),('1444','2013-11-07','10:30:00',1.49),('1444','2013-11-07','10:35:00',1.51),('1444','2013-11-07','10:40:00',1.53),('1444','2013-11-07','10:45:00',1.55),('1444','2013-11-07','10:50:00',1.55),('1444','2013-11-07','10:55:00',1.55),('1444','2013-11-07','11:00:00',1.56),('1444','2013-11-07','11:05:00',1.57),('1444','2013-11-07','11:10:00',1.57),('1444','2013-11-07','11:15:00',1.59),('1444','2013-11-07','11:20:00',1.61),('1444','2013-11-07','11:25:00',1.6),('1444','2013-11-07','11:30:00',1.62),('1444','2013-11-07','11:35:00',1.65),('1444','2013-11-07','11:40:00',1.63),('1444','2013-11-07','11:45:00',1.62),('1444','2013-11-07','11:50:00',1.65),('1444','2013-11-07','11:55:00',1.62),('1444','2013-11-07','12:00:00',1.62),('1444','2013-11-07','12:05:00',1.62),('1444','2013-11-07','12:10:00',1.6),('1444','2013-11-07','12:15:00',1.56),('1444','2013-11-07','12:20:00',1.55),('1444','2013-11-07','12:25:00',1.51),('1444','2013-11-07','12:30:00',1.51),('1444','2013-11-07','12:35:00',1.56),('1444','2013-11-07','12:40:00',1.59),('1444','2013-11-07','12:45:00',1.57),('1444','2013-11-07','12:50:00',1.54),('1444','2013-11-07','12:55:00',1.66),('1444','2013-11-07','13:00:00',1.59),('1444','2013-11-07','13:20:00',1.19),('1444','2013-11-07','13:25:00',1.59),('1444','2013-11-07','13:30:00',1.74),('1444','2013-11-07','13:35:00',1.14),('1444','2013-11-07','13:45:00',1.34),('1444','2013-11-07','13:50:00',1.03),('1444','2013-11-07','14:05:00',1.08),('1444','2013-11-07','14:10:00',1.07),('1444','2013-11-07','14:30:00',1.12),('1444','2013-11-07','14:35:00',1.01),('1444','2013-11-06','09:25:00',1.14),('1444','2013-11-06','09:30:00',1.2),('1444','2013-11-06','09:35:00',1.25),('1444','2013-11-06','09:40:00',1.3),('1444','2013-11-06','09:45:00',1.33),('1444','2013-11-06','09:50:00',1.37),('1444','2013-11-06','09:55:00',1.4),('1444','2013-11-06','10:00:00',1.43),('1444','2013-11-06','10:05:00',1.46),('1444','2013-11-06','10:10:00',1.49),('1444','2013-11-06','10:15:00',1.52),('1444','2013-11-06','10:20:00',1.55),('1444','2013-11-06','10:25:00',1.57),('1444','2013-11-06','10:30:00',1.59),('1444','2013-11-06','10:35:00',1.61),('1444','2013-11-06','10:40:00',1.63),('1444','2013-11-06','10:45:00',1.65),('1444','2013-11-06','10:50:00',1.67),('1444','2013-11-06','10:55:00',1.69),('1444','2013-11-06','11:00:00',1.7),('1444','2013-11-06','11:05:00',1.71),('1444','2013-11-06','11:10:00',1.72),('1444','2013-11-06','11:15:00',1.74),('1444','2013-11-06','11:20:00',1.75),('1444','2013-11-06','11:25:00',1.75),('1444','2013-11-06','11:30:00',1.75),('1444','2013-11-06','11:35:00',1.76),('1444','2013-11-06','11:40:00',1.75),('1444','2013-11-06','11:45:00',1.77),('1444','2013-11-06','11:50:00',1.77),('1444','2013-11-06','11:55:00',1.78),('1444','2013-11-06','12:00:00',1.77),('1444','2013-11-06','12:05:00',1.76),('1444','2013-11-06','12:10:00',1.75),('1444','2013-11-06','12:15:00',1.74),('1444','2013-11-06','12:20:00',1.74),('1444','2013-11-06','12:25:00',1.73),('1444','2013-11-06','12:30:00',1.73),('1444','2013-11-06','12:35:00',1.72),('1444','2013-11-06','12:40:00',1.69),('1444','2013-11-06','12:45:00',1.68),('1444','2013-11-06','12:50:00',1.67),('1444','2013-11-06','12:55:00',1.65),('1444','2013-11-06','13:00:00',1.62),('1444','2013-11-06','13:05:00',1.6),('1444','2013-11-06','13:10:00',1.57),('1444','2013-11-06','13:15:00',1.55),('1444','2013-11-06','13:20:00',1.53),('1444','2013-11-06','13:25:00',1.51),('1444','2013-11-06','13:30:00',1.46),('1444','2013-11-06','13:35:00',1.43),('1444','2013-11-06','13:40:00',1.39),('1444','2013-11-06','13:45:00',1.34),('1444','2013-11-06','13:50:00',1.31),('1444','2013-11-06','13:55:00',1.27),('1444','2013-11-06','14:00:00',1.23),('1444','2013-11-06','14:05:00',1.19),('1444','2013-11-06','14:10:00',1.09),('1444','2013-11-06','14:15:00',1.1),('1444','2013-11-06','14:20:00',1.11),('1444','2013-11-06','14:25:00',1.08),('1444','2013-11-06','14:30:00',1.04),('1444','2013-11-06','14:35:00',1.01),('1444','2013-11-05','08:35:00',1.02),('1444','2013-11-05','08:40:00',1.01),('1444','2013-11-05','10:20:00',1.21),('1444','2013-11-05','10:25:00',1.52),('1444','2013-11-05','10:30:00',1.05),('1444','2013-11-05','10:35:00',1.46),('1444','2013-11-05','10:40:00',1.03),('1444','2013-11-05','10:45:00',1.07),('1444','2013-11-05','11:40:00',1.05),('1444','2013-11-05','12:10:00',1.09),('1444','2013-11-05','12:15:00',1.05),('1444','2013-11-05','12:20:00',1.04),('1444','2013-11-05','12:30:00',1.01),('1444','2013-11-05','13:35:00',1.46),('1444','2013-11-05','13:40:00',1.55),('1444','2013-11-05','13:45:00',1.39),('1444','2013-11-05','13:50:00',1.01),('1444','2013-11-05','13:55:00',1.71),('1444','2013-11-05','14:00:00',1.14),('1444','2013-11-05','14:05:00',1.49),('1444','2013-11-05','14:10:00',1.14),('1444','2013-11-05','14:25:00',1.07),('1444','2013-11-05','14:30:00',1.29),('1444','2013-11-05','14:35:00',1.31),('1444','2013-11-05','14:40:00',1.17),('1444','2013-11-05','14:45:00',1.07),('1444','2013-11-04','09:10:00',1.08),('1444','2013-11-04','09:15:00',1.14),('1444','2013-11-04','09:20:00',1.35),('1444','2013-11-04','09:25:00',1.66),('1444','2013-11-04','10:00:00',1.29),('1444','2013-11-04','10:05:00',1.53),('1444','2013-11-04','10:10:00',1.57),('1444','2013-11-04','10:15:00',1.61),('1444','2013-11-04','10:20:00',1.62),('1444','2013-11-04','10:25:00',1.83),('1444','2013-11-04','10:30:00',1.73),('1444','2013-11-04','10:35:00',1.94),('1444','2013-11-04','10:40:00',1.9),('1444','2013-11-04','10:45:00',1.27),('1444','2013-11-04','10:50:00',1.24),('1444','2013-11-04','10:55:00',1.92),('1444','2013-11-04','11:00:00',1.92),('1444','2013-11-04','11:05:00',1.58),('1444','2013-11-04','11:10:00',1.13),('1444','2013-11-04','11:15:00',1.39),('1444','2013-11-04','11:20:00',1.17),('1444','2013-11-04','11:25:00',1.13),('1444','2013-11-04','11:30:00',1.66),('1444','2013-11-04','11:35:00',1.35),('1444','2013-11-04','11:40:00',1.46),('1444','2013-11-04','11:45:00',1.87),('1444','2013-11-04','11:50:00',2.36),('1444','2013-11-04','11:55:00',2.05),('1444','2013-11-04','12:00:00',2.07),('1444','2013-11-04','12:05:00',1.9),('1444','2013-11-04','12:10:00',1.88),('1444','2013-11-04','12:15:00',1.85),('1444','2013-11-04','12:20:00',1.85),('1444','2013-11-04','12:25:00',1.82),('1444','2013-11-04','12:30:00',1.81),('1444','2013-11-04','12:35:00',1.81),('1444','2013-11-04','12:40:00',1.79),('1444','2013-11-04','12:45:00',1.77),('1444','2013-11-04','12:50:00',1.72),('1444','2013-11-04','12:55:00',1.69),('1444','2013-11-04','13:00:00',1.69),('1444','2013-11-04','13:05:00',1.55),('1444','2013-11-04','13:10:00',1.57),('1444','2013-11-04','13:15:00',1.56),('1444','2013-11-04','13:20:00',1.44),('1444','2013-11-04','13:25:00',1.61),('1444','2013-11-04','13:30:00',1.57),('1444','2013-11-04','13:35:00',1.48),('1444','2013-11-04','13:40:00',1.24),('1444','2013-11-04','13:45:00',1.6),('1444','2013-11-04','13:50:00',1.43),('1444','2013-11-04','14:05:00',1.33),('1444','2013-11-04','14:10:00',1.36),('1444','2013-11-04','14:15:00',1.39),('1444','2013-11-04','14:20:00',1.38),('1444','2013-11-04','14:30:00',1.01),('1444','2013-11-04','14:35:00',1.26),('1444','2013-11-04','14:40:00',1.1),('1444','2013-11-04','14:45:00',1.03),('1444','2013-11-04','14:50:00',1.01),('1444','2013-11-03','09:40:00',1.61),('1444','2013-11-03','10:20:00',1.41),('1444','2013-11-03','10:30:00',1.58),('1444','2013-11-03','11:20:00',1.04),('1444','2013-11-03','11:30:00',1.48),('1444','2013-11-03','11:35:00',1.29),('1444','2013-11-03','11:40:00',1.95),('1444','2013-11-03','11:45:00',1.99),('1444','2013-11-03','11:50:00',2.03),('1444','2013-11-03','11:55:00',1.69),('1444','2013-11-03','12:00:00',2.31),('1444','2013-11-03','12:05:00',2.05),('1444','2013-11-03','12:10:00',1.75),('1444','2013-11-03','12:15:00',1.06),('1444','2013-11-03','12:25:00',1.24),('1444','2013-11-03','13:45:00',1.73),('1444','2013-11-03','14:00:00',1.18),('1444','2013-11-03','14:05:00',1.33),('1444','2013-11-03','14:10:00',1.13),('1444','2013-11-03','14:15:00',1.24),('1444','2013-11-03','14:25:00',1.22),('1444','2013-11-03','14:40:00',1.06),('1444','2013-11-02','09:05:00',1.08),('1444','2013-11-02','09:10:00',1.06),('1444','2013-11-02','09:15:00',1.06),('1444','2013-11-02','09:25:00',1.16),('1444','2013-11-02','09:30:00',1.23),('1444','2013-11-02','09:35:00',1.16),('1444','2013-11-02','09:40:00',1.28),('1444','2013-11-02','09:45:00',1.36),('1444','2013-11-02','09:50:00',1.43),('1444','2013-11-02','10:00:00',1.27),('1444','2013-11-02','10:05:00',1.55),('1444','2013-11-02','11:55:00',1.53),('1444','2013-11-02','12:00:00',2.01),('1444','2013-11-02','12:05:00',2.05),('1444','2013-11-02','12:10:00',1.75),('1444','2013-11-02','12:15:00',1.65),('1444','2013-11-02','12:20:00',2.08),('1444','2013-11-02','12:25:00',1.96),('1444','2013-11-02','12:30:00',2.32),('1444','2013-11-02','12:35:00',1.87),('1444','2013-11-02','12:40:00',1.86),('1444','2013-11-02','12:45:00',1.31),('1444','2013-11-02','12:50:00',1.88),('1444','2013-11-02','12:55:00',1.98),('1444','2013-11-02','13:00:00',1.51),('1444','2013-11-02','13:05:00',2.03),('1444','2013-11-02','13:10:00',2.02),('1444','2013-11-02','13:15:00',1.37),('1444','2013-11-02','13:30:00',1.77),('1444','2013-11-02','13:35:00',1.73),('1444','2013-11-02','13:40:00',1.62),('1444','2013-11-02','13:45:00',1.89),('1444','2013-11-02','13:50:00',1.93),('1444','2013-11-02','13:55:00',1.84),('1444','2013-11-02','14:00:00',1.57),('1444','2013-11-02','14:05:00',1.37),('1444','2013-11-02','14:10:00',1.25),('1444','2013-11-02','14:15:00',1.19),('1444','2013-11-02','14:20:00',1.15),('1444','2013-11-02','14:25:00',1.11),('1444','2013-11-02','14:30:00',1.08),('1444','2013-11-02','14:35:00',1.04),('1444','2013-11-02','14:40:00',1.01),('1444','2013-11-01','09:10:00',1.02),('1444','2013-11-01','09:15:00',1.07),('1444','2013-11-01','09:20:00',1.1),('1444','2013-11-01','09:25:00',1.16),('1444','2013-11-01','09:30:00',1.21),('1444','2013-11-01','09:35:00',1.24),('1444','2013-11-01','09:40:00',1.27),('1444','2013-11-01','09:45:00',1.31),('1444','2013-11-01','09:50:00',1.35),('1444','2013-11-01','09:55:00',1.38),('1444','2013-11-01','10:00:00',1.42),('1444','2013-11-01','10:05:00',1.45),('1444','2013-11-01','10:10:00',1.48),('1444','2013-11-01','10:15:00',1.5),('1444','2013-11-01','10:20:00',1.54),('1444','2013-11-01','10:25:00',1.56),('1444','2013-11-01','10:30:00',1.53),('1444','2013-11-01','10:35:00',1.56),('1444','2013-11-01','10:40:00',1.58),('1444','2013-11-01','10:45:00',1.54),('1444','2013-11-01','10:50:00',1.56),('1444','2013-11-01','10:55:00',1.59),('1444','2013-11-01','11:00:00',1.62),('1444','2013-11-01','11:05:00',1.47),('1444','2013-11-01','11:10:00',1.31),('1444','2013-11-01','11:15:00',1.52),('1444','2013-11-01','11:20:00',1.74),('1444','2013-11-01','11:25:00',1.81),('1444','2013-11-01','11:30:00',1.82),('1444','2013-11-01','11:35:00',1.77),('1444','2013-11-01','11:40:00',1.53),('1444','2013-11-01','11:45:00',1.67),('1444','2013-11-01','11:50:00',1.83),('1444','2013-11-01','11:55:00',1.82),('1444','2013-11-01','12:00:00',1.79),('1444','2013-11-01','12:05:00',1.76),('1444','2013-11-01','12:10:00',1.6),('1444','2013-11-01','12:15:00',1.48),('1444','2013-11-01','12:20:00',1.49),('1444','2013-11-01','12:25:00',1.49),('1444','2013-10-31','09:30:00',1.05),('1444','2013-10-31','09:35:00',1.07),('1444','2013-10-31','09:45:00',1.02),('1444','2013-10-31','09:50:00',1.01),('1444','2013-10-31','09:55:00',1.08),('1444','2013-10-31','10:00:00',1.12),('1444','2013-10-31','10:05:00',1.03),('1444','2013-10-31','10:10:00',1),('1444','2013-10-31','10:30:00',1.04),('1444','2013-10-31','10:35:00',1.18),('1444','2013-10-31','10:40:00',1.16),('1444','2013-10-31','10:45:00',1.08),('1444','2013-10-31','10:50:00',1.12),('1444','2013-10-31','10:55:00',1.22),('1444','2013-10-31','11:00:00',1.48),('1444','2013-10-31','11:05:00',1.68),('1444','2013-10-31','11:10:00',1.65),('1444','2013-10-31','11:15:00',1.71),('1444','2013-10-31','11:20:00',1.59),('1444','2013-10-31','11:25:00',1.47),('1444','2013-10-31','11:30:00',1.61),('1444','2013-10-31','11:35:00',1.56),('1444','2013-10-31','11:40:00',1.74),('1444','2013-10-31','11:45:00',1.8),('1444','2013-10-31','11:50:00',1.77),('1444','2013-10-31','11:55:00',1.74),('1444','2013-10-31','12:00:00',1.71),('1444','2013-10-31','12:05:00',1.66),('1444','2013-10-31','12:10:00',1.73),('1444','2013-10-31','12:15:00',1.69),('1444','2013-10-31','12:20:00',1.69),('1444','2013-10-31','12:25:00',1.7),('1444','2013-10-31','12:30:00',1.64),('1444','2013-10-31','12:35:00',1.59),('1444','2013-10-31','12:40:00',1.63),('1444','2013-10-31','12:45:00',1.69),('1444','2013-10-31','12:50:00',1.72),('1444','2013-10-31','12:55:00',1.72),('1444','2013-10-31','13:00:00',1.69),('1444','2013-10-31','13:05:00',1.66),('1444','2013-10-31','13:10:00',1.59),('1444','2013-10-31','13:15:00',1.56),('1444','2013-10-31','13:20:00',1.54),('1444','2013-10-31','13:25:00',1.51),('1444','2013-10-31','13:30:00',1.46),('1444','2013-10-31','13:35:00',1.38),('1444','2013-10-31','13:40:00',1.29),('1444','2013-10-31','13:45:00',1.26),('1444','2013-10-31','13:55:00',1),('1444','2013-10-31','14:00:00',1.26),('1444','2013-10-31','14:05:00',1.23),('1444','2013-10-31','14:10:00',1.01),('1444','2013-10-30','09:10:00',1.04),('1444','2013-10-30','09:15:00',1.09),('1444','2013-10-30','09:20:00',1.13),('1444','2013-10-30','09:25:00',1.19),('1444','2013-10-30','09:30:00',1.22),('1444','2013-10-30','09:35:00',1.26),('1444','2013-10-30','09:40:00',1.28),('1444','2013-10-30','09:45:00',1.32),('1444','2013-10-30','09:50:00',1.34),('1444','2013-10-30','09:55:00',1.24),('1444','2013-10-30','10:00:00',1.15),('1444','2013-10-30','10:05:00',1.27),('1444','2013-10-30','10:10:00',1.51),('1444','2013-10-30','10:15:00',1.49),('1444','2013-10-30','10:20:00',1.45),('1444','2013-10-30','10:25:00',1.5),('1444','2013-10-30','10:30:00',1.5),('1444','2013-10-30','10:35:00',1.45),('1444','2013-10-30','10:40:00',1.44),('1444','2013-10-30','10:45:00',1.41),('1444','2013-10-30','10:55:00',1.46),('1444','2013-10-30','11:00:00',1.35),('1444','2013-10-30','11:05:00',1.75),('1444','2013-10-30','11:10:00',1.7),('1444','2013-10-30','11:15:00',1.4),('1444','2013-10-30','11:20:00',1.38),('1444','2013-10-30','12:15:00',1.54),('1444','2013-10-30','12:20:00',2.05),('1444','2013-10-30','12:25:00',1.3),('1444','2013-10-30','12:30:00',1.23),('1444','2013-10-30','12:50:00',1.04),('1444','2013-10-30','12:55:00',1.78),('1444','2013-10-30','13:00:00',1.76),('1444','2013-10-30','13:05:00',1.94),('1444','2013-10-30','13:10:00',1.84),('1444','2013-10-30','13:15:00',1.96),('1444','2013-10-30','13:20:00',1.89),('1444','2013-10-30','13:25:00',1.88),('1444','2013-10-30','13:35:00',1.69),('1444','2013-10-30','13:40:00',1.67),('1444','2013-10-30','13:45:00',1.41),('1444','2013-10-30','13:50:00',1.49),('1444','2013-10-30','13:55:00',1.63),('1444','2013-10-30','14:00:00',1.45),('1444','2013-10-30','14:40:00',1.02),('1444','2013-10-29','09:05:00',1.03),('1444','2013-10-29','09:10:00',1.07),('1444','2013-10-29','09:15:00',1.11),('1444','2013-10-29','09:20:00',1.18),('1444','2013-10-29','09:25:00',1.18),('1444','2013-10-29','09:30:00',1.25),('1444','2013-10-29','09:35:00',1.29),('1444','2013-10-29','09:45:00',1.06),('1444','2013-10-29','09:50:00',1.39),('1444','2013-10-29','09:55:00',1.48),('1444','2013-10-29','10:00:00',1.35),('1444','2013-10-29','10:05:00',1.59),('1444','2013-10-29','10:10:00',1.6),('1444','2013-10-29','10:15:00',1.69),('1444','2013-10-29','10:20:00',1.56),('1444','2013-10-29','10:25:00',1.24),('1444','2013-10-29','10:35:00',1.04),('1444','2013-10-29','10:55:00',1.94),('1444','2013-10-29','11:00:00',1.92),('1444','2013-10-29','11:05:00',1.98),('1444','2013-10-29','11:10:00',1.94),('1444','2013-10-29','11:15:00',1.83),('1444','2013-10-29','11:20:00',1.82),('1444','2013-10-29','11:25:00',1.82),('1444','2013-10-29','11:30:00',1.82),('1444','2013-10-29','11:35:00',1.82),('1444','2013-10-29','11:40:00',1.8),('1444','2013-10-29','11:45:00',1.78),('1444','2013-10-29','11:50:00',1.79),('1444','2013-10-29','11:55:00',1.76),('1444','2013-10-29','12:00:00',1.74),('1444','2013-10-29','12:05:00',1.76),('1444','2013-10-29','12:10:00',1.74),('1444','2013-10-29','12:15:00',1.76),('1444','2013-10-29','12:20:00',1.72),('1444','2013-10-29','12:25:00',1.69),('1444','2013-10-29','12:30:00',1.68),('1444','2013-10-29','12:35:00',1.71),('1444','2013-10-29','12:40:00',1.66),('1444','2013-10-29','12:45:00',1.62),('1444','2013-10-29','12:50:00',1.64),('1444','2013-10-29','12:55:00',1.64),('1444','2013-10-29','13:00:00',1.62),('1444','2013-10-29','13:05:00',1.6),('1444','2013-10-29','13:10:00',1.58),('1444','2013-10-29','13:15:00',1.5),('1444','2013-10-29','13:20:00',1.52),('1444','2013-10-29','13:25:00',1.53),('1444','2013-10-29','13:30:00',1.49),('1444','2013-10-29','13:35:00',1.39),('1444','2013-10-29','13:40:00',1.37),('1444','2013-10-29','13:45:00',1.34),('1444','2013-10-29','13:50:00',1.33),('1444','2013-10-29','13:55:00',1.31),('1444','2013-10-29','14:00:00',1.28),('1444','2013-10-29','14:05:00',1.23),('1444','2013-10-29','14:10:00',1.18),('1444','2013-10-29','14:15:00',1.13),('1444','2013-10-29','14:20:00',1.06),('1444','2013-10-29','14:25:00',1.05),('1444','2013-10-29','14:30:00',1.02),('1444','2014-04-17','08:10:00',1.05),('1444','2014-04-17','08:15:00',1.13),('1444','2014-04-17','08:20:00',1.16),('1444','2014-04-17','08:25:00',1.24),('1444','2014-04-17','08:30:00',1.31),('1444','2014-04-17','08:35:00',1.37),('1444','2014-04-17','08:40:00',1.45),('1444','2014-04-17','08:45:00',1.52),('1444','2014-04-17','08:50:00',1.6),('1444','2014-04-17','08:55:00',1.55),('1444','2014-04-17','09:00:00',1.4),('1444','2014-04-17','09:05:00',1.72),('1444','2014-04-17','09:10:00',1.85),('1444','2014-04-17','09:15:00',1.93),('1444','2014-04-17','09:20:00',2),('1444','2014-04-17','09:25:00',2.06),('1444','2014-04-17','09:30:00',2.13),('1444','2014-04-17','09:35:00',2.2),('1444','2014-04-17','09:40:00',2.27),('1444','2014-04-17','09:45:00',2.32),('1444','2014-04-17','09:50:00',2.37),('1444','2014-04-17','09:55:00',2.46),('1444','2014-04-17','10:00:00',2.57),('1444','2014-04-17','10:05:00',2.79),('1444','2014-04-17','10:10:00',2.7),('1444','2014-04-17','10:15:00',2.01),('1444','2014-04-17','10:20:00',2.82),('1444','2014-04-17','10:25:00',2.95),('1444','2014-04-17','10:30:00',3.15),('1444','2014-04-17','10:35:00',3.34),('1444','2014-04-17','10:40:00',3.12),('1444','2014-04-17','10:45:00',2.93),('1444','2014-04-17','10:50:00',2.15),('1444','2014-04-17','10:55:00',1.92),('1444','2014-04-17','11:00:00',2.17),('1444','2014-04-17','11:05:00',2.39),('1444','2014-04-17','11:10:00',2.44),('1444','2014-04-17','11:15:00',1.78),('1444','2014-04-17','11:20:00',2.19),('1444','2014-04-17','11:25:00',3.2),('1444','2014-04-17','11:30:00',2.03),('1444','2014-04-17','11:35:00',1.78),('1444','2014-04-17','11:40:00',1.8),('1444','2014-04-17','11:45:00',3.2),('1444','2014-04-17','11:50:00',2.59),('1444','2014-04-17','11:55:00',1.88),('1444','2014-04-17','12:00:00',2.32),('1444','2014-04-17','12:05:00',2.45),('1444','2014-04-17','12:10:00',2.04),('1444','2014-04-17','12:15:00',1.83),('1444','2014-04-17','12:20:00',1.96),('1444','2014-04-17','12:25:00',2.24),('1444','2014-04-17','12:30:00',2.6),('1444','2014-04-17','12:35:00',2.76),('1444','2014-04-17','12:40:00',3.35),('1444','2014-04-17','12:45:00',3.22),('1444','2014-04-17','12:50:00',2.54),('1444','2014-04-17','13:00:00',3.37),('1444','2014-04-17','13:05:00',3.63),('1444','2014-04-17','13:10:00',3.6),('1444','2014-04-17','13:15:00',3.68),('1444','2014-04-17','13:20:00',1.22),('1444','2014-04-17','13:25:00',3),('1444','2014-04-17','13:30:00',3.94),('1444','2014-04-17','13:35:00',2.22),('1444','2014-04-17','13:50:00',1.21),('1444','2014-04-17','13:55:00',1.87),('1444','2014-04-17','14:10:00',1.28),('1444','2014-04-17','14:15:00',3.06),('1444','2014-04-17','14:20:00',1.17),('1444','2014-04-17','14:25:00',1.36),('1444','2014-04-17','14:30:00',1.9),('1444','2014-04-17','14:35:00',1.74),('1444','2014-04-17','14:40:00',1.91),('1444','2014-04-17','14:45:00',1.46),('1444','2014-04-17','15:30:00',1.47),('1444','2014-04-17','15:35:00',2.02),('1444','2014-04-17','15:40:00',1.66),('1444','2014-04-17','15:45:00',1.15),('1444','2014-04-17','15:55:00',1.08),('1444','2014-04-17','16:45:00',1.52),('1444','2014-04-17','16:50:00',1.37),('1444','2013-10-28','09:00:00',1.04),('1444','2013-10-28','09:05:00',1.18),('1444','2013-10-28','09:10:00',1.28),('1444','2013-10-28','09:15:00',1.28),('1444','2013-10-28','09:20:00',1.32),('1444','2013-10-28','09:25:00',1.31),('1444','2013-10-28','09:30:00',1.33),('1444','2013-10-28','09:35:00',1.42),('1444','2013-10-28','09:40:00',1.57),('1444','2013-10-28','09:45:00',1.48),('1444','2013-10-28','09:50:00',1.78),('1444','2013-10-28','10:50:00',1.76),('1444','2013-10-28','10:55:00',1.74),('1444','2013-10-28','11:00:00',1.75),('1444','2013-10-28','11:05:00',1.76),('1444','2013-10-28','11:10:00',1.78),('1444','2013-10-28','11:15:00',1.79),('1444','2013-10-28','11:20:00',1.78),('1444','2013-10-28','11:25:00',1.78),('1444','2013-10-28','11:30:00',1.79),('1444','2013-10-28','11:35:00',1.8),('1444','2013-10-28','11:40:00',1.8),('1444','2013-10-28','11:45:00',1.8),('1444','2013-10-28','11:50:00',1.78),('1444','2013-10-28','11:55:00',1.55),('1444','2013-10-28','12:00:00',1.37),('1444','2013-10-28','12:05:00',1.5),('1444','2013-10-28','12:10:00',1.93),('1444','2013-10-28','12:15:00',1.89),('1444','2013-10-28','12:20:00',1.59),('1444','2013-10-28','12:25:00',1.04),('1444','2013-10-28','12:30:00',1.97),('1444','2013-10-28','12:35:00',2.1),('1444','2013-10-28','12:40:00',1.63),('1444','2013-10-28','12:45:00',1.92),('1444','2013-10-28','12:50:00',1.88),('1444','2013-10-28','12:55:00',1.76),('1444','2013-10-28','13:00:00',1.72),('1444','2013-10-28','13:05:00',1.69),('1444','2013-10-28','13:10:00',1.65),('1444','2013-10-28','13:15:00',1.65),('1444','2013-10-28','13:20:00',1.52),('1444','2013-10-28','13:25:00',1.56),('1444','2013-10-28','13:30:00',1.56),('1444','2013-10-28','13:35:00',1.54),('1444','2013-10-28','13:40:00',1.54),('1444','2013-10-28','13:45:00',1.5),('1444','2013-10-28','13:50:00',1.48),('1444','2013-10-28','13:55:00',1.47),('1444','2013-10-28','14:00:00',1.33),('1444','2013-10-28','14:05:00',1.51),('1444','2013-10-28','14:10:00',1.41),('1444','2013-10-28','14:15:00',1.31),('1444','2013-10-28','14:20:00',1.26),('1444','2013-10-28','14:25:00',1.06),('1444','2013-10-28','14:45:00',1.07),('1444','2013-10-27','11:35:00',1.07),('1444','2013-10-27','11:40:00',1.13),('1444','2013-10-27','11:45:00',1.23),('1444','2013-10-27','12:15:00',1.29),('1444','2013-10-27','12:20:00',1.72),('1444','2013-10-27','12:25:00',1.56),('1444','2013-10-27','12:30:00',1.64),('1444','2013-10-27','12:35:00',2.21),('1444','2013-10-27','12:40:00',1.14),('1444','2013-10-27','12:45:00',1.79),('1444','2013-10-27','12:50:00',2.07),('1444','2013-10-27','12:55:00',1.39),('1444','2013-10-27','13:00:00',1.06),('1444','2013-10-27','13:30:00',1.05),('1444','2013-10-27','14:30:00',1.26),('1444','2013-10-27','14:35:00',1.02),('1444','2013-10-26','10:00:00',1.04),('1444','2013-10-26','10:05:00',1.09),('1444','2013-10-26','10:10:00',1.13),('1444','2013-10-26','10:15:00',1.17),('1444','2013-10-26','10:20:00',1.19),('1444','2013-10-26','10:25:00',1.23),('1444','2013-10-26','10:30:00',1.28),('1444','2013-10-26','10:35:00',1.31),('1444','2013-10-26','10:40:00',1.35),('1444','2013-10-26','10:45:00',1.39),('1444','2013-10-26','10:50:00',1.44),('1444','2013-10-26','10:55:00',1.46),('1444','2013-10-26','11:00:00',1.5),('1444','2013-10-26','11:05:00',1.52),('1444','2013-10-26','11:10:00',1.53),('1444','2013-10-26','11:15:00',1.57),('1444','2013-10-26','11:20:00',1.59),('1444','2013-10-26','11:25:00',1.61),('1444','2013-10-26','11:30:00',1.64),('1444','2013-10-26','11:35:00',1.66),('1444','2013-10-26','11:40:00',1.67),('1444','2013-10-26','11:45:00',1.68),('1444','2013-10-26','11:50:00',1.7),('1444','2013-10-26','11:55:00',1.69),('1444','2013-10-26','12:00:00',1.68),('1444','2013-10-26','12:05:00',1.7),('1444','2013-10-26','12:10:00',1.74),('1444','2013-10-26','12:15:00',1.74),('1444','2013-10-26','12:20:00',1.77),('1444','2013-10-26','12:25:00',1.77),('1444','2013-10-26','12:30:00',1.79),('1444','2013-10-26','12:35:00',1.73),('1444','2013-10-26','12:40:00',1.75),('1444','2013-10-26','12:45:00',1.61),('1444','2013-10-26','12:50:00',1.75),('1444','2013-10-26','12:55:00',1.41),('1444','2013-10-26','13:00:00',1.73),('1444','2013-10-26','13:05:00',1.75),('1444','2013-10-26','13:10:00',1.79),('1444','2013-10-26','13:15:00',1.72),('1444','2013-10-26','13:20:00',1.74),('1444','2013-10-26','13:25:00',1.7),('1444','2013-10-26','13:30:00',1.72),('1444','2013-10-26','13:40:00',1.72),('1444','2013-10-26','13:45:00',1.59),('1444','2013-10-26','13:50:00',1.62),('1444','2013-10-26','13:55:00',1.59),('1444','2013-10-26','14:00:00',1.32),('1444','2013-10-26','14:05:00',1.24),('1444','2013-10-26','14:10:00',1.05),('1444','2013-10-26','14:20:00',1.44),('1444','2013-10-26','14:25:00',1.35),('1444','2013-10-26','14:30:00',1.19),('1444','2013-10-26','14:35:00',1.23),('1444','2013-10-26','14:40:00',1.05),('1444','2013-10-26','14:50:00',1),('1444','2013-10-26','14:55:00',1.33),('1444','2013-10-26','15:00:00',1.29),('1444','2013-10-26','15:05:00',1.23),('1444','2013-10-26','15:10:00',1.22),('1444','2013-10-26','15:15:00',1.16),('1444','2013-10-26','15:20:00',1.17),('1444','2013-10-26','15:25:00',1.2),('1444','2013-10-26','15:30:00',1.14),('1444','2013-10-26','15:35:00',1.1),('1444','2013-10-26','15:40:00',1),('1444','2013-10-25','10:00:00',1.06),('1444','2013-10-25','10:05:00',1.12),('1444','2013-10-25','10:10:00',1.16),('1444','2013-10-25','10:15:00',1.2),('1444','2013-10-25','10:20:00',1.24),('1444','2013-10-25','10:25:00',1.29),('1444','2013-10-25','10:30:00',1.33),('1444','2013-10-25','10:35:00',1.37),('1444','2013-10-25','10:40:00',1.4),('1444','2013-10-25','10:45:00',1.43),('1444','2013-10-25','10:50:00',1.44),('1444','2013-10-25','10:55:00',1.48),('1444','2013-10-25','11:00:00',1.51),('1444','2013-10-25','11:05:00',1.53),('1444','2013-10-25','11:10:00',1.56),('1444','2013-10-25','11:15:00',1.59),('1444','2013-10-25','11:20:00',1.59),('1444','2013-10-25','11:25:00',1.63),('1444','2013-10-25','11:30:00',1.67),('1444','2013-10-25','11:35:00',1.71),('1444','2013-10-25','11:40:00',1.73),('1444','2013-10-25','11:45:00',1.74),('1444','2013-10-25','11:50:00',1.76),('1444','2013-10-25','11:55:00',1.76),('1444','2013-10-25','12:00:00',1.79),('1444','2013-10-25','12:05:00',1.82),('1444','2013-10-25','12:10:00',1.83),('1444','2013-10-25','12:15:00',1.83),('1444','2013-10-25','12:20:00',1.83),('1444','2013-10-25','12:25:00',1.85),('1444','2013-10-25','12:30:00',1.84),('1444','2013-10-25','12:35:00',1.83),('1444','2013-10-25','12:40:00',1.85),('1444','2013-10-25','12:45:00',1.85),('1444','2013-10-25','12:50:00',1.84),('1444','2013-10-25','12:55:00',1.84),('1444','2013-10-25','13:00:00',1.84),('1444','2013-10-25','13:05:00',1.83),('1444','2013-10-25','13:10:00',1.83),('1444','2013-10-25','13:15:00',1.82),('1444','2013-10-25','13:20:00',1.82),('1444','2013-10-25','13:25:00',1.81),('1444','2013-10-25','13:30:00',1.79),('1444','2013-10-25','13:35:00',1.76),('1444','2013-10-25','13:40:00',1.73),('1444','2013-10-25','13:45:00',1.73),('1444','2013-10-25','13:50:00',1.72),('1444','2013-10-25','13:55:00',1.71),('1444','2013-10-25','14:00:00',1.68),('1444','2013-10-25','14:05:00',1.67),('1444','2013-10-25','14:10:00',1.64),('1444','2013-10-25','14:15:00',1.63),('1444','2013-10-25','14:20:00',1.62),('1444','2013-10-25','14:25:00',1.58),('1444','2013-10-25','14:30:00',1.56),('1444','2013-10-25','14:35:00',1.52),('1444','2013-10-25','14:40:00',1.49),('1444','2013-10-25','14:45:00',1.48),('1444','2013-10-25','14:50:00',1.44),('1444','2013-10-25','14:55:00',1.4),('1444','2013-10-25','15:00:00',1.35),('1444','2013-10-25','15:05:00',1.34),('1444','2013-10-25','15:10:00',1.3),('1444','2013-10-25','15:15:00',1.24),('1444','2013-10-25','15:20:00',1.2),('1444','2013-10-25','15:25:00',1.17),('1444','2013-10-25','15:30:00',1.12),('1444','2013-10-25','15:35:00',1.07),('1444','2013-10-25','15:40:00',1.07),('1444','2013-10-25','15:45:00',1.02),('1444','2013-10-24','10:35:00',1.07),('1444','2013-10-24','10:45:00',1.22),('1444','2013-10-24','10:50:00',1.01),('1444','2013-10-24','10:55:00',1.27),('1444','2013-10-24','11:00:00',1.83),('1444','2013-10-24','11:05:00',1.87),('1444','2013-10-24','11:10:00',1.39),('1444','2013-10-24','11:15:00',1.23),('1444','2013-10-24','11:20:00',1.22),('1444','2013-10-24','11:50:00',1.07),('1444','2013-10-24','11:55:00',1.46),('1444','2013-10-24','12:00:00',1.18),('1444','2013-10-24','12:25:00',1.03),('1444','2013-10-24','12:30:00',1.09),('1444','2013-10-24','12:35:00',1.19),('1444','2013-10-24','12:40:00',1.41),('1444','2013-10-24','12:45:00',1.58),('1444','2013-10-24','12:50:00',1.35),('1444','2013-10-24','12:55:00',2.13),('1444','2013-10-24','13:00:00',2.31),('1444','2013-10-24','13:05:00',1.93),('1444','2013-10-24','13:10:00',1.59),('1444','2013-10-24','13:15:00',1.61),('1444','2013-10-24','13:20:00',1.43),('1444','2013-10-24','13:25:00',1.09),('1444','2013-10-24','13:45:00',1.06),('1444','2013-10-24','13:50:00',1.27),('1444','2013-10-24','13:55:00',1.61),('1444','2013-10-24','14:00:00',1.54),('1444','2013-10-24','14:25:00',1),('1444','2013-10-24','14:30:00',1.04),('1444','2013-10-24','14:35:00',1.12),('1444','2013-10-24','14:40:00',1.29),('1444','2013-10-24','14:45:00',1.5),('1444','2013-10-24','15:10:00',1.14),('1444','2013-10-24','15:35:00',1.42),('1444','2013-10-24','15:40:00',1.1),('1444','2013-10-24','15:45:00',1.25),('1444','2013-10-23','10:50:00',1.04),('1444','2013-10-23','10:55:00',1.05),('1444','2013-10-23','11:00:00',1.3),('1444','2013-10-23','11:05:00',1.66),('1444','2013-10-23','11:10:00',1.76),('1444','2013-10-23','11:15:00',1.25),('1444','2013-10-23','11:20:00',1.53),('1444','2013-10-23','11:25:00',1.49),('1444','2013-10-23','11:30:00',1.56),('1444','2013-10-23','11:35:00',1.68),('1444','2013-10-23','11:40:00',1.72),('1444','2013-10-23','11:45:00',1.68),('1444','2013-10-23','11:50:00',1.62),('1444','2013-10-23','11:55:00',1.55),('1444','2013-10-23','12:00:00',1.73),('1444','2013-10-23','12:05:00',1.59),('1444','2013-10-23','12:10:00',1.64),('1444','2013-10-23','12:15:00',1.67),('1444','2013-10-23','12:20:00',1.75),('1444','2013-10-23','12:25:00',1.72),('1444','2013-10-23','12:30:00',1.69),('1444','2013-10-23','12:35:00',1.81),('1444','2013-10-23','12:40:00',1.76),('1444','2013-10-23','12:45:00',1.61),('1444','2013-10-23','12:50:00',1.57),('1444','2013-10-23','12:55:00',1.61),('1444','2013-10-23','13:00:00',1.67),('1444','2013-10-23','13:05:00',1.69),('1444','2013-10-23','13:10:00',1.67),('1444','2013-10-23','13:15:00',1.6),('1444','2013-10-23','13:20:00',1.69),('1444','2013-10-23','13:25:00',1.69),('1444','2013-10-23','13:30:00',1.62),('1444','2013-10-23','13:35:00',1.65),('1444','2013-10-23','13:40:00',1.66),('1444','2013-10-23','13:45:00',1.69),('1444','2013-10-23','13:50:00',1.58),('1444','2013-10-23','13:55:00',1.42),('1444','2013-10-23','14:00:00',1.62),('1444','2013-10-23','14:05:00',1.68),('1444','2013-10-23','14:10:00',1.58),('1444','2013-10-23','14:15:00',1.41),('1444','2013-10-23','14:20:00',1.47),('1444','2013-10-23','14:25:00',1.43),('1444','2013-10-23','14:30:00',1.44),('1444','2013-10-23','14:35:00',1.39),('1444','2013-10-23','14:40:00',1.41),('1444','2013-10-23','14:45:00',1.43),('1444','2013-10-23','14:50:00',1.42),('1444','2013-10-23','14:55:00',1.46),('1444','2013-10-23','15:00:00',1.43),('1444','2013-10-23','15:05:00',1.38),('1444','2013-10-23','15:10:00',1.3),('1444','2013-10-23','15:15:00',1.25),('1444','2013-10-23','15:20:00',1.25),('1444','2013-10-23','15:25:00',1.23),('1444','2013-10-23','15:30:00',1.08),('1444','2013-10-23','15:35:00',1.01),('1444','2013-10-23','15:40:00',1.14),('1444','2013-10-23','15:45:00',1.14),('1444','2013-10-23','15:50:00',1.04),('1444','2013-10-22','09:50:00',1.01),('1444','2013-10-22','09:55:00',1.06),('1444','2013-10-22','10:00:00',1.1),('1444','2013-10-22','10:05:00',1.13),('1444','2013-10-22','10:10:00',1.18),('1444','2013-10-22','10:15:00',1.22),('1444','2013-10-22','10:20:00',1.27),('1444','2013-10-22','10:25:00',1.29),('1444','2013-10-22','10:30:00',1.33),('1444','2013-10-22','10:35:00',1.37),('1444','2013-10-22','10:40:00',1.4),('1444','2013-10-22','10:45:00',1.42),('1444','2013-10-22','10:50:00',1.45),('1444','2013-10-22','10:55:00',1.5),('1444','2013-10-22','11:00:00',1.54),('1444','2013-10-22','11:05:00',1.56),('1444','2013-10-22','11:10:00',1.56),('1444','2013-10-22','11:15:00',1.58),('1444','2013-10-22','11:20:00',1.61),('1444','2013-10-22','11:25:00',1.62),('1444','2013-10-22','11:30:00',1.61),('1444','2013-10-22','11:35:00',1.62),('1444','2013-10-22','11:40:00',1.66),('1444','2013-10-22','11:45:00',1.67),('1444','2013-10-22','11:50:00',1.68),('1444','2013-10-22','11:55:00',1.7),('1444','2013-10-22','12:00:00',1.73),('1444','2013-10-22','12:05:00',1.75),('1444','2013-10-22','12:10:00',1.74),('1444','2013-10-22','12:15:00',1.77),('1444','2013-10-22','12:20:00',1.78),('1444','2013-10-22','12:25:00',1.78),('1444','2013-10-22','12:30:00',1.79),('1444','2013-10-22','12:35:00',1.8),('1444','2013-10-22','12:40:00',1.81),('1444','2013-10-22','12:45:00',1.8),('1444','2013-10-22','12:50:00',1.79),('1444','2013-10-22','12:55:00',1.78),('1444','2013-10-22','13:00:00',1.75),('1444','2013-10-22','13:05:00',1.73),('1444','2013-10-22','13:10:00',1.78),('1444','2013-10-22','13:15:00',1.78),('1444','2013-10-22','13:20:00',1.76),('1444','2013-10-22','13:25:00',1.77),('1444','2013-10-22','13:30:00',1.72),('1444','2013-10-22','13:35:00',1.71),('1444','2013-10-22','13:40:00',1.67),('1444','2013-10-22','13:45:00',1.55),('1444','2013-10-22','13:50:00',1.7),('1444','2013-10-22','13:55:00',1.74),('1444','2013-10-22','14:00:00',1.56),('1444','2013-10-22','14:05:00',1.59),('1444','2013-10-22','14:10:00',1.67),('1444','2013-10-22','14:15:00',1.79),('1444','2013-10-22','14:20:00',1.84),('1444','2013-10-22','14:25:00',1.87),('1444','2013-10-22','14:30:00',1.73),('1444','2013-10-22','14:35:00',1.76),('1444','2013-10-22','14:40:00',1.65),('1444','2013-10-22','14:45:00',1.58),('1444','2013-10-22','14:50:00',1.45),('1444','2013-10-22','14:55:00',1.43),('1444','2013-10-22','15:00:00',1.38),('1444','2013-10-22','15:05:00',1.3),('1444','2013-10-22','15:10:00',1.29),('1444','2013-10-22','15:15:00',1.26),('1444','2013-10-22','15:20:00',1.22),('1444','2013-10-22','15:25:00',1.12),('1444','2013-10-22','15:30:00',1.15),('1444','2013-10-22','15:35:00',1.15),('1444','2013-10-22','15:40:00',1.15),('1444','2013-10-22','15:45:00',1.03),('1444','2013-10-21','09:55:00',1.08),('1444','2013-10-21','10:00:00',1.05),('1444','2013-10-21','10:05:00',1.23),('1444','2013-10-21','10:10:00',1.23),('1444','2013-10-21','10:15:00',1.29),('1444','2013-10-21','10:20:00',1.3),('1444','2013-10-21','10:25:00',1.38),('1444','2013-10-21','10:30:00',1.36),('1444','2013-10-21','10:35:00',1.37),('1444','2013-10-21','10:40:00',1.35),('1444','2013-10-21','10:45:00',1.39),('1444','2013-10-21','10:50:00',1.49),('1444','2013-10-21','10:55:00',1.47),('1444','2013-10-21','11:00:00',1.62),('1444','2013-10-21','11:05:00',1.39),('1444','2013-10-21','11:10:00',1.52),('1444','2013-10-21','11:15:00',1.69),('1444','2013-10-21','11:20:00',1.67),('1444','2013-10-21','11:25:00',1.65),('1444','2013-10-21','11:30:00',1.73),('1444','2013-10-21','11:35:00',1.68),('1444','2013-10-21','11:40:00',1.71),('1444','2013-10-21','11:45:00',1.78),('1444','2013-10-21','11:50:00',1.81),('1444','2013-10-21','11:55:00',1.81),('1444','2013-10-21','12:00:00',1.85),('1444','2013-10-21','12:05:00',1.89),('1444','2013-10-21','12:10:00',1.9),('1444','2013-10-21','12:15:00',1.88),('1444','2013-10-21','12:20:00',1.89),('1444','2013-10-21','12:25:00',1.86),('1444','2013-10-21','12:30:00',1.85),('1444','2013-10-21','12:35:00',1.91),('1444','2013-10-21','12:40:00',1.92),('1444','2013-10-21','12:45:00',1.91),('1444','2013-10-21','12:50:00',1.91),('1444','2013-10-21','12:55:00',1.9),('1444','2013-10-21','13:00:00',1.88),('1444','2013-10-21','13:05:00',1.83),('1444','2013-10-21','13:10:00',1.83),('1444','2013-10-21','13:15:00',1.85),('1444','2013-10-21','13:20:00',1.82),('1444','2013-10-21','13:25:00',1.88),('1444','2013-10-21','13:30:00',1.86),('1444','2013-10-21','13:35:00',1.85),('1444','2013-10-21','13:40:00',1.83),('1444','2013-10-21','13:45:00',1.81),('1444','2013-10-21','13:50:00',1.74),('1444','2013-10-21','13:55:00',1.71),('1444','2013-10-21','14:00:00',1.72),('1444','2013-10-21','14:05:00',1.73),('1444','2013-10-21','14:10:00',1.69),('1444','2013-10-21','14:15:00',1.69),('1444','2013-10-21','14:20:00',1.69),('1444','2013-10-21','14:25:00',1.61),('1444','2013-10-21','14:30:00',1.58),('1444','2013-10-21','14:35:00',1.51),('1444','2013-10-21','14:40:00',1.46),('1444','2013-10-21','14:45:00',1.44),('1444','2013-10-21','14:50:00',1.39),('1444','2013-10-21','14:55:00',1.4),('1444','2013-10-21','15:00:00',1.4),('1444','2013-10-21','15:05:00',1.38),('1444','2013-10-21','15:10:00',1.35),('1444','2013-10-21','15:15:00',1.32),('1444','2013-10-21','15:20:00',1.28),('1444','2013-10-21','15:25:00',1.24),('1444','2013-10-21','15:30:00',1.19),('1444','2013-10-21','15:35:00',1.14),('1444','2013-10-21','15:40:00',1.11),('1444','2013-10-21','15:45:00',1.07),('1444','2013-10-21','15:50:00',1.04),('1444','2013-10-20','09:45:00',1.05),('1444','2013-10-20','09:50:00',1.09),('1444','2013-10-20','09:55:00',1.14),('1444','2013-10-20','10:00:00',1.19),('1444','2013-10-20','10:05:00',1.24),('1444','2013-10-20','10:10:00',1.27),('1444','2013-10-20','10:15:00',1.31),('1444','2013-10-20','10:20:00',1.35),('1444','2013-10-20','10:25:00',1.4),('1444','2013-10-20','10:30:00',1.44),('1444','2013-10-20','10:35:00',1.47),('1444','2013-10-20','10:40:00',1.5),('1444','2013-10-20','10:45:00',1.54),('1444','2013-10-20','10:50:00',1.57),('1444','2013-10-20','10:55:00',1.61),('1444','2013-10-20','11:00:00',1.63),('1444','2013-10-20','11:05:00',1.67),('1444','2013-10-20','11:10:00',1.69),('1444','2013-10-20','11:15:00',1.72),('1444','2013-10-20','11:20:00',1.76),('1444','2013-10-20','11:25:00',1.78),('1444','2013-10-20','11:30:00',1.79),('1444','2013-10-20','11:35:00',1.82),('1444','2013-10-20','11:40:00',1.83),('1444','2013-10-20','11:45:00',1.84),('1444','2013-10-20','11:50:00',1.86),('1444','2013-10-20','11:55:00',1.8),('1444','2013-10-20','12:00:00',1.86),('1444','2013-10-20','12:05:00',1.91),('1444','2013-10-20','12:10:00',1.66),('1444','2013-10-20','12:15:00',1.82),('1444','2013-10-20','12:20:00',1.23),('1444','2013-10-20','12:25:00',2.18),('1444','2013-10-20','12:30:00',1.78),('1444','2013-10-20','12:35:00',1.34),('1444','2013-10-20','12:40:00',1.86),('1444','2013-10-20','12:45:00',1.82),('1444','2013-10-20','12:50:00',1.39),('1444','2013-10-20','12:55:00',1.54),('1444','2013-10-20','13:00:00',1.45),('1444','2013-10-20','13:05:00',1.09),('1444','2013-10-20','13:10:00',1.25),('1444','2013-10-20','13:20:00',1.8),('1444','2013-10-20','13:25:00',1.07),('1444','2013-10-20','13:55:00',1.19),('1444','2013-10-19','09:30:00',1.04),('1444','2013-10-19','09:35:00',1.1),('1444','2013-10-19','09:40:00',1.18),('1444','2013-10-19','09:45:00',1.23),('1444','2013-10-19','09:50:00',1.29),('1444','2013-10-19','09:55:00',1.36),('1444','2013-10-19','10:00:00',1.31),('1444','2013-10-19','10:05:00',1.26),('1444','2013-10-19','10:10:00',1.4),('1444','2013-10-19','10:15:00',1.34),('1444','2013-10-19','10:20:00',1.43),('1444','2013-10-19','10:25:00',1.62),('1444','2013-10-19','10:30:00',1.67),('1444','2013-10-19','10:35:00',1.67),('1444','2013-10-19','10:40:00',1.69),('1444','2013-10-19','10:45:00',1.68),('1444','2013-10-19','10:50:00',1.74),('1444','2013-10-19','10:55:00',1.59),('1444','2013-10-19','11:00:00',1.68),('1444','2013-10-19','11:05:00',1.75),('1444','2013-10-19','11:20:00',1.91),('1444','2013-10-19','11:25:00',1.8),('1444','2013-10-19','11:30:00',2.06),('1444','2013-10-19','11:35:00',2),('1444','2013-10-19','11:40:00',1.96),('1444','2013-10-19','11:45:00',2.04),('1444','2013-10-19','11:50:00',1.84),('1444','2013-10-19','11:55:00',2.09),('1444','2013-10-19','12:00:00',2.1),('1444','2013-10-19','12:05:00',2.11),('1444','2013-10-19','12:10:00',2.07),('1444','2013-10-19','12:15:00',2.1),('1444','2013-10-19','12:20:00',2.03),('1444','2013-10-19','12:25:00',2),('1444','2013-10-19','12:30:00',2.12),('1444','2013-10-19','12:35:00',2.14),('1444','2013-10-19','12:40:00',2.21),('1444','2013-10-19','12:45:00',2.27),('1444','2013-10-19','12:50:00',2.27),('1444','2013-10-19','12:55:00',2.37),('1444','2013-10-19','13:00:00',2.57),('1444','2013-10-19','13:05:00',2.07),('1444','2013-10-19','13:10:00',2.17),('1444','2013-10-19','13:15:00',2.05),('1444','2013-10-19','13:20:00',1.97),('1444','2013-10-19','13:25:00',2.2),('1444','2013-10-19','13:30:00',2.32),('1444','2013-10-19','13:35:00',1.55),('1444','2013-10-19','13:40:00',1.54),('1444','2013-10-19','13:45:00',1.27),('1444','2013-10-19','13:50:00',1.79),('1444','2013-10-19','13:55:00',2.15),('1444','2013-10-19','14:00:00',1.8),('1444','2013-10-19','14:05:00',1.55),('1444','2013-10-19','14:10:00',1.17),('1444','2013-10-19','14:15:00',1.67),('1444','2013-10-19','14:20:00',1.35),('1444','2013-10-19','14:25:00',1.07),('1444','2013-10-19','14:30:00',1.42),('1444','2013-10-19','14:35:00',1.8),('1444','2013-10-19','14:40:00',1.52),('1444','2013-10-19','14:45:00',1.36),('1444','2013-10-19','14:50:00',1.86),('1444','2013-10-19','14:55:00',1.77),('1444','2013-10-19','15:00:00',1.71),('1444','2013-10-19','15:05:00',1.65),('1444','2013-10-19','15:10:00',1.61),('1444','2013-10-19','15:15:00',1.57),('1444','2013-10-19','15:20:00',1.43),('1444','2013-10-19','15:25:00',1.38),('1444','2013-10-19','15:30:00',1.31),('1444','2013-10-19','15:35:00',1.32),('1444','2013-10-19','15:40:00',1.21),('1444','2013-10-19','15:45:00',1.05),('1444','2013-10-19','15:50:00',1.13),('1444','2013-10-19','15:55:00',1.21),('1444','2013-10-19','16:05:00',1.06),('1444','2013-10-19','16:15:00',1.04),('1444','2014-05-04','07:45:00',1),('1444','2014-05-04','07:50:00',1.06),('1444','2014-05-04','07:55:00',1.11),('1444','2014-05-04','08:00:00',1.18),('1444','2014-05-04','08:05:00',1.27),('1444','2014-05-04','08:10:00',1.31),('1444','2014-05-04','08:15:00',1.39),('1444','2014-05-04','08:20:00',1.47),('1444','2014-05-04','08:25:00',1.56),('1444','2014-05-04','08:30:00',1.59),('1444','2014-05-04','08:35:00',1.8),('1444','2014-05-04','08:40:00',1.12),('1444','2014-05-04','08:45:00',1.28),('1444','2014-05-04','08:50:00',1.32),('1444','2014-05-04','09:00:00',1.04),('1444','2014-05-04','09:05:00',1.54),('1444','2014-05-04','09:10:00',1.82),('1444','2014-05-04','09:15:00',1.47),('1444','2014-05-04','09:20:00',2.59),('1444','2014-05-04','09:25:00',2.87),('1444','2014-05-04','09:30:00',1.81),('1444','2014-05-04','09:35:00',1.05),('1444','2014-05-04','09:40:00',1.11),('1444','2014-05-04','09:45:00',1.41),('1444','2014-05-04','09:50:00',1.75),('1444','2014-05-04','09:55:00',1.57),('1444','2014-05-04','10:00:00',2.58),('1444','2014-05-04','10:05:00',3.11),('1444','2014-05-04','10:10:00',2.97),('1444','2014-05-04','10:15:00',2.23),('1444','2014-05-04','10:20:00',1.61),('1444','2014-05-04','10:25:00',1.63),('1444','2014-05-04','10:30:00',1.79),('1444','2014-05-04','10:35:00',1.83),('1444','2014-05-04','10:40:00',1.8),('1444','2014-05-04','10:45:00',2.02),('1444','2014-05-04','10:50:00',2.01),('1444','2014-05-04','10:55:00',1.98),('1444','2014-05-04','11:00:00',1.9),('1444','2014-05-04','11:05:00',1.95),('1444','2014-05-04','11:10:00',3.37),('1444','2014-05-04','11:15:00',3.11),('1444','2014-05-04','11:20:00',3.58),('1444','2014-05-04','11:25:00',3.49),('1444','2014-05-04','11:30:00',3.1),('1444','2014-05-04','11:35:00',3.37),('1444','2014-05-04','11:40:00',2.63),('1444','2014-05-04','11:45:00',2.96),('1444','2014-05-04','11:50:00',2.37),('1444','2014-05-04','11:55:00',3.35),('1444','2014-05-04','12:00:00',2.42),('1444','2014-05-04','12:05:00',2.16),('1444','2014-05-04','12:10:00',1.5),('1444','2014-05-04','12:15:00',1.36),('1444','2014-05-04','12:20:00',1.28),('1444','2014-05-04','12:25:00',1.34),('1444','2014-05-04','12:30:00',1.74),('1444','2014-05-04','12:35:00',4.18),('1444','2014-05-04','12:40:00',1.82),('1444','2014-05-04','12:45:00',1.36),('1444','2014-05-04','12:50:00',1.27),('1444','2014-05-04','12:55:00',1.45),('1444','2014-05-04','13:00:00',1.51),('1444','2014-05-04','13:05:00',1.29),('1444','2014-05-04','13:10:00',1.29),('1444','2014-05-04','13:15:00',1.32),('1444','2014-05-04','13:20:00',1.26),('1444','2014-05-04','13:25:00',1.23),('1444','2014-05-04','13:30:00',1.17),('1444','2014-05-04','13:35:00',1.32),('1444','2014-05-04','13:40:00',1.31),('1444','2014-05-04','13:45:00',1.15),('1444','2014-05-04','13:50:00',1.06),('1444','2014-05-04','13:55:00',1.11),('1444','2014-05-04','14:00:00',1.11),('1444','2014-05-04','14:05:00',1.12),('1444','2014-05-04','14:10:00',1.11),('1444','2014-05-04','14:15:00',1.05),('1444','2014-05-04','14:55:00',1.33),('1444','2014-05-04','15:00:00',1.54),('1444','2014-05-04','15:05:00',1.75),('1444','2014-05-04','15:10:00',2.75),('1444','2014-05-04','15:15:00',2.22),('1444','2014-05-04','15:20:00',1.84),('1444','2014-05-04','15:25:00',1.34),('1444','2014-05-04','15:30:00',1.13),('1444','2014-05-04','16:10:00',1.06),('1444','2014-05-04','16:15:00',1.01),('1444','2014-04-16','08:10:00',1.01),('1444','2014-04-16','08:15:00',1.1),('1444','2014-04-16','08:20:00',1.17),('1444','2014-04-16','08:25:00',1.22),('1444','2014-04-16','08:45:00',1.34),('1444','2014-04-16','08:50:00',1.45),('1444','2014-04-16','08:55:00',1.67),('1444','2014-04-16','09:00:00',1.73),('1444','2014-04-16','09:05:00',1.79),('1444','2014-04-16','09:10:00',1.85),('1444','2014-04-16','09:15:00',1.9),('1444','2014-04-16','09:20:00',1.97),('1444','2014-04-16','09:25:00',2.08),('1444','2014-04-16','09:30:00',1.36),('1444','2014-04-16','09:35:00',1.02),('1444','2014-04-16','09:55:00',2.32),('1444','2014-04-16','10:00:00',2.55),('1444','2014-04-16','10:05:00',2.58),('1444','2014-04-16','10:10:00',2.64),('1444','2014-04-16','10:15:00',2.7),('1444','2014-04-16','10:20:00',2.76),('1444','2014-04-16','10:25:00',2.8),('1444','2014-04-16','10:30:00',2.85),('1444','2014-04-16','10:35:00',2.89),('1444','2014-04-16','10:40:00',2.94),('1444','2014-04-16','10:45:00',3),('1444','2014-04-16','10:50:00',3.11),('1444','2014-04-16','10:55:00',2.8),('1444','2014-04-16','11:00:00',2.88),('1444','2014-04-16','11:05:00',1.63),('1444','2014-04-16','11:10:00',1.3),('1444','2014-04-16','11:15:00',1.46),('1444','2014-04-16','11:20:00',2.68),('1444','2014-04-16','11:25:00',3.07),('1444','2014-04-16','11:30:00',3.21),('1444','2014-04-16','11:35:00',2.34),('1444','2014-04-16','11:40:00',2.57),('1444','2014-04-16','11:45:00',3.4),('1444','2014-04-16','11:50:00',3.83),('1444','2014-04-16','11:55:00',3.8),('1444','2014-04-16','12:00:00',3.75),('1444','2014-04-16','12:05:00',3.03),('1444','2014-04-16','12:10:00',3.09),('1444','2014-04-16','12:15:00',3.42),('1444','2014-04-16','12:20:00',2.26),('1444','2014-04-16','12:35:00',3.66),('1444','2014-04-16','12:40:00',3.65),('1444','2014-04-16','12:45:00',3.64),('1444','2014-04-16','12:50:00',3.39),('1444','2014-04-16','13:00:00',1.88),('1444','2014-04-16','13:05:00',1.1),('1444','2014-04-16','13:20:00',1.14),('1444','2014-04-16','13:35:00',1.22),('1444','2014-04-16','13:40:00',2.18),('1444','2014-04-16','13:45:00',3.89),('1444','2014-04-16','13:50:00',3.41),('1444','2014-04-16','13:55:00',3.73),('1444','2014-04-16','14:00:00',1.42),('1444','2014-04-16','14:05:00',2.65),('1444','2014-04-16','14:10:00',3.4),('1444','2014-04-16','14:15:00',3.96),('1444','2014-04-16','14:20:00',2.94),('1444','2014-04-16','14:25:00',3.32),('1444','2014-04-16','14:30:00',3.59),('1444','2014-04-16','14:35:00',3.37),('1444','2014-04-16','14:40:00',3.33),('1444','2014-04-16','14:45:00',3.51),('1444','2014-04-16','14:50:00',3.58),('1444','2014-04-16','14:55:00',1.72),('1444','2014-04-16','15:05:00',2.11),('1444','2014-04-16','15:10:00',3.65),('1444','2014-04-16','15:15:00',2.67),('1444','2014-04-16','15:30:00',1.79),('1444','2014-04-16','15:35:00',3.18),('1444','2014-04-16','15:40:00',3.07),('1444','2014-04-16','15:45:00',2.93),('1444','2014-04-16','15:50:00',2.84),('1444','2014-04-16','15:55:00',2.74),('1444','2014-04-16','16:00:00',2.67),('1444','2014-04-16','16:05:00',2.59),('1444','2014-04-16','16:10:00',2.52),('1444','2014-04-16','16:15:00',2.47),('1444','2014-04-16','16:20:00',2.47),('1444','2014-04-16','16:25:00',2.36),('1444','2014-04-16','16:30:00',2.31),('1444','2014-04-16','16:35:00',2.24),('1444','2014-04-16','16:40:00',2.19),('1444','2014-04-16','16:45:00',2.12),('1444','2014-04-16','16:50:00',2.05),('1444','2014-04-16','16:55:00',1.99),('1444','2014-04-16','17:00:00',1.92),('1444','2014-04-16','17:05:00',1.85),('1444','2014-04-16','17:10:00',1.78),('1444','2014-04-16','17:15:00',1.73),('1444','2014-04-16','17:20:00',1.64),('1444','2014-04-16','17:25:00',1.56),('1444','2014-04-16','17:30:00',1.5),('1444','2014-04-16','17:35:00',1.45),('1444','2014-04-16','17:40:00',1.37),('1444','2014-04-16','17:45:00',1.32),('1444','2014-04-16','17:50:00',1.32),('1444','2014-04-16','17:55:00',1.33),('1444','2014-04-16','18:00:00',1.19),('1444','2014-04-16','18:05:00',1.13),('1444','2014-04-16','18:10:00',1.03),('1444','2013-10-18','09:35:00',1.07),('1444','2013-10-18','09:40:00',1.15),('1444','2013-10-18','09:45:00',1.2),('1444','2013-10-18','09:50:00',1.25),('1444','2013-10-18','09:55:00',1.3),('1444','2013-10-18','10:00:00',1.34),('1444','2013-10-18','10:05:00',1.4),('1444','2013-10-18','10:10:00',1.44),('1444','2013-10-18','10:15:00',1.47),('1444','2013-10-18','10:20:00',1.49),('1444','2013-10-18','10:25:00',1.55),('1444','2013-10-18','10:30:00',1.6),('1444','2013-10-18','10:35:00',1.65),('1444','2013-10-18','10:40:00',1.67),('1444','2013-10-18','10:45:00',1.69),('1444','2013-10-18','10:50:00',1.72),('1444','2013-10-18','10:55:00',1.74),('1444','2013-10-18','11:00:00',1.76),('1444','2013-10-18','11:05:00',1.68),('1444','2013-10-18','11:10:00',1.78),('1444','2013-10-18','11:15:00',1.79),('1444','2013-10-18','11:20:00',1.92),('1444','2013-10-18','11:25:00',1.91),('1444','2013-10-18','11:30:00',1.9),('1444','2013-10-18','11:35:00',1.95),('1444','2013-10-18','11:40:00',2.02),('1444','2013-10-18','11:45:00',1.93),('1444','2013-10-18','11:50:00',1.95),('1444','2013-10-18','11:55:00',2.06),('1444','2013-10-18','12:00:00',2.03),('1444','2013-10-18','12:05:00',2.02),('1444','2013-10-18','12:10:00',2.04),('1444','2013-10-18','12:15:00',2.02),('1444','2013-10-18','12:20:00',1.99),('1444','2013-10-18','12:25:00',2.02),('1444','2013-10-18','12:30:00',2.04),('1444','2013-10-18','12:35:00',2.01),('1444','2013-10-18','12:40:00',2.02),('1444','2013-10-18','12:45:00',2),('1444','2013-10-18','12:50:00',1.97),('1444','2013-10-18','12:55:00',2.04),('1444','2013-10-18','13:00:00',2.01),('1444','2013-10-18','13:05:00',1.99),('1444','2013-10-18','13:10:00',1.89),('1444','2013-10-18','13:15:00',1.91),('1444','2013-10-18','13:20:00',2.02),('1444','2013-10-18','13:25:00',2.02),('1444','2013-10-18','13:30:00',2.04),('1444','2013-10-18','13:35:00',2.01),('1444','2013-10-18','13:40:00',1.97),('1444','2013-10-18','13:45:00',1.94),('1444','2013-10-18','13:50:00',1.94),('1444','2013-10-18','13:55:00',1.94),('1444','2013-10-18','14:00:00',1.8),('1444','2013-10-18','14:05:00',1.78),('1444','2013-10-18','14:10:00',1.77),('1444','2013-10-18','14:15:00',1.79),('1444','2013-10-18','14:20:00',1.78),('1444','2013-10-18','14:25:00',1.76),('1444','2013-10-18','14:30:00',1.74),('1444','2013-10-18','14:35:00',1.67),('1444','2013-10-18','14:40:00',1.67),('1444','2013-10-18','14:45:00',1.58),('1444','2013-10-18','14:50:00',1.57),('1444','2013-10-18','14:55:00',1.59),('1444','2013-10-18','15:00:00',1.33),('1444','2013-10-18','15:05:00',1.26),('1444','2013-10-18','15:10:00',1.39),('1444','2013-10-18','15:15:00',1.37),('1444','2013-10-18','15:20:00',1.43),('1444','2013-10-18','15:25:00',1.33),('1444','2013-10-18','15:30:00',1.25),('1444','2013-10-18','15:35:00',1.25),('1444','2013-10-18','15:40:00',1.17),('1444','2013-10-18','15:45:00',1.08),('1444','2013-10-18','15:50:00',1.01),('1444','2013-10-18','16:00:00',1.01),('1444','2013-10-17','09:30:00',1.03),('1444','2013-10-17','09:35:00',1.09),('1444','2013-10-17','09:40:00',1.15),('1444','2013-10-17','09:45:00',1.21),('1444','2013-10-17','09:50:00',1.26),('1444','2013-10-17','09:55:00',1.3),('1444','2013-10-17','10:00:00',1.34),('1444','2013-10-17','10:05:00',1.38),('1444','2013-10-17','10:10:00',1.43),('1444','2013-10-17','10:15:00',1.47),('1444','2013-10-17','10:20:00',1.52),('1444','2013-10-17','10:25:00',1.56),('1444','2013-10-17','10:30:00',1.59),('1444','2013-10-17','10:35:00',1.64),('1444','2013-10-17','10:40:00',1.68),('1444','2013-10-17','10:45:00',1.73),('1444','2013-10-17','10:50:00',1.76),('1444','2013-10-17','10:55:00',1.8),('1444','2013-10-17','11:00:00',1.84),('1444','2013-10-17','11:05:00',1.87),('1444','2013-10-17','11:10:00',1.9),('1444','2013-10-17','11:15:00',1.92),('1444','2013-10-17','11:20:00',1.95),('1444','2013-10-17','11:25:00',1.97),('1444','2013-10-17','11:30:00',2),('1444','2013-10-17','11:35:00',2.03),('1444','2013-10-17','11:40:00',2.05),('1444','2013-10-17','11:45:00',2.07),('1444','2013-10-17','11:50:00',2.08),('1444','2013-10-17','11:55:00',2.08),('1444','2013-10-17','12:00:00',2.09),('1444','2013-10-17','12:05:00',2.12),('1444','2013-10-17','12:10:00',2.12),('1444','2013-10-17','12:15:00',2.13),('1444','2013-10-17','12:20:00',2.12),('1444','2013-10-17','12:25:00',2.13),('1444','2013-10-17','12:30:00',2.14),('1444','2013-10-17','12:35:00',2.15),('1444','2013-10-17','12:40:00',2.17),('1444','2013-10-17','12:45:00',2.18),('1444','2013-10-17','12:50:00',2.18),('1444','2013-10-17','12:55:00',2.17),('1444','2013-10-17','13:00:00',2.15),('1444','2013-10-17','13:05:00',2.15),('1444','2013-10-17','13:10:00',2.15),('1444','2013-10-17','13:15:00',2.15),('1444','2013-10-17','13:20:00',2.14),('1444','2013-10-17','13:25:00',2.12),('1444','2013-10-17','13:30:00',2.09),('1444','2013-10-17','13:35:00',2.11),('1444','2013-10-17','13:40:00',2.09),('1444','2013-10-17','13:45:00',2.08),('1444','2013-10-17','13:50:00',2.06),('1444','2013-10-17','13:55:00',2.03),('1444','2013-10-17','14:00:00',2.02),('1444','2013-10-17','14:05:00',2),('1444','2013-10-17','14:10:00',1.98),('1444','2013-10-17','14:15:00',1.96),('1444','2013-10-17','14:20:00',1.95),('1444','2013-10-17','14:25:00',1.92),('1444','2013-10-17','14:30:00',1.88),('1444','2013-10-17','14:35:00',1.84),('1444','2013-10-17','14:40:00',1.82),('1444','2013-10-17','14:45:00',1.78),('1444','2013-10-17','14:50:00',1.76),('1444','2013-10-17','14:55:00',1.71),('1444','2013-10-17','15:00:00',1.67),('1444','2013-10-17','15:05:00',1.64),('1444','2013-10-17','15:10:00',1.6),('1444','2013-10-17','15:15:00',1.57),('1444','2013-10-17','15:20:00',1.53),('1444','2013-10-17','15:25:00',1.49),('1444','2013-10-17','15:30:00',1.45),('1444','2013-10-17','15:35:00',1.39),('1444','2013-10-17','15:40:00',1.35),('1444','2013-10-17','15:45:00',1.3),('1444','2013-10-17','15:50:00',1.25),('1444','2013-10-17','15:55:00',1.2),('1444','2013-10-17','16:00:00',1.15),('1444','2013-10-17','16:05:00',1.1),('1444','2013-10-17','16:10:00',1.05),('1444','2013-10-17','16:15:00',1),('1444','2013-10-16','09:45:00',1.2),('1444','2013-10-16','09:50:00',1.03),('1444','2013-10-16','12:15:00',1.64),('1444','2013-10-16','12:20:00',1.01),('1444','2013-10-16','12:30:00',1.14),('1444','2013-10-16','12:35:00',1.03),('1444','2013-10-16','12:40:00',2.5),('1444','2013-10-16','12:45:00',1.53),('1444','2013-10-16','12:50:00',1.95),('1444','2013-10-16','12:55:00',1.63),('1444','2013-10-16','13:00:00',1.39),('1444','2013-10-16','13:05:00',1.97),('1444','2013-10-16','13:10:00',1.27),('1444','2013-10-16','13:15:00',2.47),('1444','2013-10-16','13:20:00',2.32),('1444','2013-10-16','13:25:00',2.22),('1444','2013-10-16','13:30:00',2.16),('1444','2013-10-16','13:35:00',2.09),('1444','2013-10-16','13:40:00',2.11),('1444','2013-10-16','13:45:00',2.1),('1444','2013-10-16','13:50:00',1.73),('1444','2013-10-16','13:55:00',2.17),('1444','2013-10-16','14:00:00',1.83),('1444','2013-10-16','14:05:00',1.29),('1444','2013-10-16','14:10:00',2.18),('1444','2013-10-16','14:15:00',2.02),('1444','2013-10-16','14:20:00',1.95),('1444','2013-10-16','14:25:00',2.03),('1444','2013-10-16','14:30:00',1.98),('1444','2013-10-16','14:35:00',2.07),('1444','2013-10-16','14:40:00',1.91),('1444','2013-10-16','14:45:00',1.73),('1444','2013-10-16','14:50:00',1.68),('1444','2013-10-16','14:55:00',1.72),('1444','2013-10-16','15:00:00',1.64),('1444','2013-10-16','15:10:00',1.71),('1444','2013-10-16','15:15:00',1.58),('1444','2013-10-16','15:20:00',1.5),('1444','2013-10-16','15:25:00',1.25),('1444','2013-10-16','15:40:00',1.42),('1444','2013-10-16','15:45:00',1.33),('1444','2013-10-16','15:50:00',1.27),('1444','2013-10-16','15:55:00',1.21),('1444','2013-10-16','16:00:00',1.17),('1444','2013-10-16','16:05:00',1.12),('1444','2013-10-16','16:10:00',1.08),('1444','2013-10-16','16:15:00',1.01),('1444','2013-10-15','09:45:00',1.14),('1444','2013-10-15','09:50:00',1.25),('1444','2013-10-15','09:55:00',1.34),('1444','2013-10-15','10:00:00',1.35),('1444','2013-10-15','10:05:00',1.54),('1444','2013-10-15','10:10:00',1.18),('1444','2013-10-15','10:25:00',1.02),('1444','2013-10-15','10:30:00',1.3),('1444','2013-10-15','10:35:00',1.03),('1444','2013-10-15','10:40:00',1.24),('1444','2013-10-15','10:45:00',1.49),('1444','2013-10-15','10:50:00',1.43),('1444','2013-10-15','10:55:00',1.26),('1444','2013-10-15','11:00:00',1.24),('1444','2013-10-15','11:05:00',1.34),('1444','2013-10-15','11:10:00',1.7),('1444','2013-10-15','11:15:00',1.88),('1444','2013-10-15','11:20:00',1.9),('1444','2013-10-15','11:25:00',1.74),('1444','2013-10-15','11:30:00',1.84),('1444','2013-10-15','11:35:00',1.55),('1444','2013-10-15','11:40:00',1.27),('1444','2013-10-15','11:45:00',1.05),('1444','2013-10-15','11:50:00',1.01),('1444','2013-10-15','11:55:00',1.01),('1444','2013-10-15','12:00:00',1.06),('1444','2013-10-15','12:05:00',1.06),('1444','2013-10-15','12:10:00',1.08),('1444','2013-10-15','12:15:00',1.06),('1444','2013-10-15','12:20:00',1.12),('1444','2013-10-15','12:25:00',1.01),('1444','2013-10-15','12:45:00',1.02),('1444','2013-10-15','13:05:00',1.13),('1444','2013-10-15','13:10:00',1.25),('1444','2013-10-15','13:15:00',1.25),('1444','2013-10-15','13:20:00',1.76),('1444','2013-10-15','13:25:00',1.97),('1444','2013-10-15','13:30:00',1.27),('1444','2013-10-15','13:35:00',1.09),('1444','2013-10-15','13:40:00',1.06),('1444','2013-10-15','13:45:00',1.08),('1444','2013-10-15','13:50:00',1.02),('1444','2013-10-15','14:15:00',1.26),('1444','2013-10-15','14:20:00',1.33),('1444','2013-10-15','14:25:00',1.46),('1444','2013-10-15','14:30:00',1.36),('1444','2013-10-15','14:40:00',1.23),('1444','2013-10-15','14:45:00',1.3),('1444','2013-10-15','14:50:00',1.74),('1444','2013-10-15','14:55:00',1.27),('1444','2013-10-14','09:30:00',1.07),('1444','2013-10-14','09:35:00',1.05),('1444','2013-10-14','09:55:00',1.16),('1444','2013-10-14','10:00:00',1.16),('1444','2013-10-14','10:05:00',1.26),('1444','2013-10-14','10:10:00',1.35),('1444','2013-10-14','10:15:00',1.45),('1444','2013-10-14','10:20:00',1.48),('1444','2013-10-14','10:25:00',1.52),('1444','2013-10-14','10:30:00',1.55),('1444','2013-10-14','10:35:00',1.56),('1444','2013-10-14','10:40:00',1.56),('1444','2013-10-14','10:45:00',1.61),('1444','2013-10-14','10:50:00',1.66),('1444','2013-10-14','10:55:00',1.71),('1444','2013-10-14','11:00:00',1.74),('1444','2013-10-14','11:05:00',1.75),('1444','2013-10-14','11:10:00',1.84),('1444','2013-10-14','11:15:00',1.82),('1444','2013-10-14','11:20:00',1.85),('1444','2013-10-14','11:25:00',1.9),('1444','2013-10-14','11:30:00',1.94),('1444','2013-10-14','11:35:00',1.9),('1444','2013-10-14','11:40:00',1.93),('1444','2013-10-14','11:45:00',1.92),('1444','2013-10-14','11:50:00',1.94),('1444','2013-10-14','11:55:00',1.95),('1444','2013-10-14','12:00:00',1.97),('1444','2013-10-14','12:05:00',1.99),('1444','2013-10-14','12:10:00',2.04),('1444','2013-10-14','12:15:00',1.99),('1444','2013-10-14','12:20:00',1.86),('1444','2013-10-14','12:25:00',2),('1444','2013-10-14','12:30:00',2.08),('1444','2013-10-14','12:35:00',2.05),('1444','2013-10-14','12:40:00',2.04),('1444','2013-10-14','12:45:00',2.05),('1444','2013-10-14','12:50:00',2.05),('1444','2013-10-14','12:55:00',2.05),('1444','2013-10-14','13:00:00',2.05),('1444','2013-10-14','13:05:00',2.02),('1444','2013-10-14','13:10:00',2.02),('1444','2013-10-14','13:15:00',2.01),('1444','2013-10-14','13:20:00',2.02),('1444','2013-10-14','13:25:00',2),('1444','2013-10-14','13:30:00',1.98),('1444','2013-10-14','13:35:00',1.98),('1444','2013-10-14','13:40:00',1.98),('1444','2013-10-14','13:45:00',1.96),('1444','2013-10-14','13:50:00',1.94),('1444','2013-10-14','13:55:00',1.94),('1444','2013-10-14','14:00:00',1.91),('1444','2013-10-14','14:05:00',1.91),('1444','2013-10-14','14:10:00',1.88),('1444','2013-10-14','14:15:00',1.86),('1444','2013-10-14','14:20:00',1.84),('1444','2013-10-14','14:25:00',1.81),('1444','2013-10-14','14:30:00',1.79),('1444','2013-10-14','14:35:00',1.76),('1444','2013-10-14','14:40:00',1.74),('1444','2013-10-14','14:45:00',1.71),('1444','2013-10-14','14:50:00',1.68),('1444','2013-10-14','14:55:00',1.63),('1444','2013-10-14','15:00:00',1.6),('1444','2013-10-14','15:05:00',1.56),('1444','2013-10-14','15:10:00',1.51),('1444','2013-10-14','15:15:00',1.46),('1444','2013-10-14','15:20:00',1.43),('1444','2013-10-14','15:25:00',1.39),('1444','2013-10-14','15:30:00',1.34),('1444','2013-10-14','15:35:00',1.28),('1444','2013-10-14','15:40:00',1.16),('1444','2013-10-13','09:15:00',1.02),('1444','2013-10-13','09:20:00',1.09),('1444','2013-10-13','09:40:00',1.37),('1444','2013-10-13','09:45:00',1.67),('1444','2013-10-13','09:50:00',1.66),('1444','2013-10-13','09:55:00',1.7),('1444','2013-10-13','10:00:00',1.16),('1444','2013-10-13','10:10:00',1.41),('1444','2013-10-13','10:15:00',1.4),('1444','2013-10-13','10:20:00',1.25),('1444','2013-10-13','10:25:00',1.47),('1444','2013-10-13','10:30:00',1.79),('1444','2013-10-13','10:35:00',2),('1444','2013-10-13','10:40:00',2.07),('1444','2013-10-13','10:45:00',2.14),('1444','2013-10-13','10:50:00',1.67),('1444','2013-10-13','10:55:00',1.58),('1444','2013-10-13','11:00:00',1.88),('1444','2013-10-13','11:05:00',1.92),('1444','2013-10-13','11:10:00',1.98),('1444','2013-10-13','11:15:00',2.03),('1444','2013-10-13','11:20:00',1.96),('1444','2013-10-13','11:25:00',1.92),('1444','2013-10-13','11:30:00',1.98),('1444','2013-10-13','11:35:00',1.97),('1444','2013-10-13','11:40:00',1.98),('1444','2013-10-13','11:45:00',1.99),('1444','2013-10-13','11:50:00',2.01),('1444','2013-10-13','11:55:00',2.04),('1444','2013-10-13','12:00:00',2.04),('1444','2013-10-13','12:05:00',2.05),('1444','2013-10-13','12:10:00',2.04),('1444','2013-10-13','12:15:00',2.07),('1444','2013-10-13','12:20:00',1.99),('1444','2013-10-13','12:25:00',1.99),('1444','2013-10-13','12:30:00',2.08),('1444','2013-10-13','12:35:00',2.1),('1444','2013-10-13','12:40:00',2.11),('1444','2013-10-13','12:45:00',2.07),('1444','2013-10-13','12:50:00',2.05),('1444','2013-10-13','12:55:00',2.05),('1444','2013-10-13','13:00:00',2.06),('1444','2013-10-13','13:05:00',2.05),('1444','2013-10-13','13:10:00',2.07),('1444','2013-10-13','13:15:00',2.09),('1444','2013-10-13','13:20:00',2.1),('1444','2013-10-13','13:25:00',1.8),('1444','2013-10-13','13:30:00',1.56),('1444','2013-10-13','13:35:00',1.59),('1444','2013-10-13','13:40:00',1.25),('1444','2013-10-13','13:45:00',1.34),('1444','2013-10-13','13:50:00',1.49),('1444','2013-10-13','13:55:00',1.71),('1444','2013-10-13','14:00:00',2.06),('1444','2013-10-13','14:05:00',2),('1444','2013-10-13','14:10:00',1.93),('1444','2013-10-13','14:15:00',1.84),('1444','2013-10-13','14:20:00',2.02),('1444','2013-10-13','14:25:00',2.01),('1444','2013-10-13','14:30:00',1.59),('1444','2013-10-13','14:35:00',1.65),('1444','2013-10-13','14:40:00',1.74),('1444','2013-10-13','14:45:00',1.27),('1444','2013-10-13','14:50:00',1.17),('1444','2013-10-13','14:55:00',1.39),('1444','2013-10-13','15:00:00',1.72),('1444','2013-10-13','15:05:00',1.34),('1444','2013-10-13','15:10:00',1.02),('1444','2013-10-13','15:15:00',1.28),('1444','2013-10-13','15:20:00',1.43),('1444','2013-10-13','15:25:00',1.5),('1444','2013-10-13','15:30:00',1.15),('1444','2013-10-13','15:35:00',1.01),('1444','2013-10-13','16:05:00',1.11),('1444','2013-10-13','16:25:00',1.13),('1444','2013-10-13','16:30:00',1.08),('1444','2013-10-12','11:35:00',1.32),('1444','2013-10-12','11:40:00',2),('1444','2013-10-12','11:45:00',1.07),('1444','2013-10-12','11:50:00',1.02),('1444','2013-10-12','12:20:00',1.51),('1444','2013-10-12','12:25:00',2.35),('1444','2013-10-12','12:30:00',1.79),('1444','2013-10-12','12:35:00',2.12),('1444','2013-10-12','12:40:00',2.05),('1444','2013-10-12','12:45:00',1.91),('1444','2013-10-12','12:50:00',1.95),('1444','2013-10-12','12:55:00',1.34),('1444','2013-10-12','13:00:00',1.17),('1444','2013-10-12','13:25:00',1.18),('1444','2013-10-12','13:30:00',2.77),('1444','2013-10-12','13:35:00',1.03),('1444','2013-10-12','16:15:00',1.17),('1444','2013-10-12','16:20:00',1.23),('1444','2013-10-11','09:45:00',1.29),('1444','2013-10-11','09:50:00',1.33),('1444','2013-10-11','09:55:00',1.38),('1444','2013-10-11','10:00:00',1.43),('1444','2013-10-11','10:05:00',1.5),('1444','2013-10-11','10:10:00',1.54),('1444','2013-10-11','10:15:00',1.23),('1444','2013-10-11','10:20:00',1.41),('1444','2013-10-11','10:25:00',1.49),('1444','2013-10-11','10:30:00',1.7),('1444','2013-10-11','10:35:00',1.75),('1444','2013-10-11','11:05:00',1.93),('1444','2013-10-11','11:10:00',1.42),('1444','2013-10-11','11:40:00',1.11),('1444','2013-10-11','11:45:00',1.32),('1444','2013-10-11','11:50:00',1.49),('1444','2013-10-11','11:55:00',1.26),('1444','2013-10-11','12:00:00',2.14),('1444','2013-10-11','12:05:00',1.92),('1444','2013-10-11','13:05:00',1.7),('1444','2013-10-11','13:10:00',1.49),('1444','2013-10-11','13:15:00',1.22),('1444','2013-10-11','13:20:00',1.92),('1444','2013-10-11','13:25:00',2.55),('1444','2013-10-11','13:30:00',1.01),('1444','2013-10-11','13:40:00',2.45),('1444','2013-10-11','13:45:00',1.85),('1444','2013-10-11','15:40:00',1.14),('1444','2013-10-11','16:00:00',1.43),('1444','2013-10-10','09:15:00',1.01),('1444','2013-10-10','09:20:00',1.03),('1444','2013-10-10','09:25:00',1.05),('1444','2013-10-10','09:30:00',1.07),('1444','2013-10-10','09:40:00',1.06),('1444','2013-10-10','09:50:00',1.29),('1444','2013-10-10','10:10:00',1.25),('1444','2013-10-10','10:15:00',1.57),('1444','2013-10-10','10:20:00',1.59),('1444','2013-10-10','10:40:00',1.71),('1444','2013-10-10','10:45:00',1.84),('1444','2013-10-10','10:50:00',1.48),('1444','2013-10-10','11:20:00',1.85),('1444','2013-10-10','11:25:00',1.58),('1444','2013-10-10','11:35:00',1.8),('1444','2013-10-10','11:40:00',1.27),('1444','2013-10-10','11:50:00',1.88),('1444','2013-10-10','11:55:00',2.48),('1444','2013-10-10','12:00:00',2.35),('1444','2013-10-10','12:05:00',2.37),('1444','2013-10-10','12:20:00',2.09),('1444','2013-10-10','12:25:00',2.02),('1444','2013-10-10','12:35:00',2.72),('1444','2013-10-10','12:40:00',2.52),('1444','2013-10-10','12:45:00',1.71),('1444','2013-10-10','12:50:00',1.57),('1444','2013-10-10','12:55:00',2.72),('1444','2013-10-10','13:00:00',2.54),('1444','2013-10-10','13:05:00',2.64),('1444','2013-10-10','13:10:00',2.58),('1444','2013-10-10','13:15:00',1.74),('1444','2013-10-10','13:20:00',1),('1444','2013-10-10','13:25:00',2.88),('1444','2013-10-10','13:30:00',2.26),('1444','2013-10-10','13:35:00',1.73),('1444','2013-10-10','13:40:00',1.62),('1444','2013-10-10','13:45:00',2.28),('1444','2013-10-10','13:50:00',2.25),('1444','2013-10-10','13:55:00',2.33),('1444','2013-10-10','14:00:00',2.27),('1444','2013-10-10','14:05:00',2.33),('1444','2013-10-10','14:10:00',2.08),('1444','2013-10-10','14:15:00',1.2),('1444','2013-10-10','14:20:00',2.09),('1444','2013-10-10','14:25:00',2.43),('1444','2013-10-10','14:30:00',2.34),('1444','2013-10-10','14:35:00',2.37),('1444','2013-10-10','14:40:00',2.17),('1444','2013-10-10','14:45:00',2.09),('1444','2013-10-10','14:50:00',2),('1444','2013-10-10','14:55:00',1.94),('1444','2013-10-10','15:00:00',1.95),('1444','2013-10-10','15:05:00',1.6),('1444','2013-10-10','15:10:00',1.73),('1444','2013-10-10','15:15:00',1.33),('1444','2013-10-10','15:20:00',1.84),('1444','2013-10-10','15:30:00',1.22),('1444','2013-10-10','15:40:00',1.46),('1444','2013-10-10','15:50:00',1.18),('1444','2013-10-10','15:55:00',1.62),('1444','2013-10-10','16:25:00',1.22),('1444','2014-04-15','09:00:00',1.55),('1444','2014-04-15','09:05:00',1.09),('1444','2014-04-15','09:10:00',1.53),('1444','2014-04-15','09:15:00',1.81),('1444','2014-04-15','09:20:00',1.86),('1444','2014-04-15','09:25:00',1.89),('1444','2014-04-15','09:30:00',1.02),('1444','2014-04-15','09:50:00',1.26),('1444','2014-04-15','10:00:00',1.77),('1444','2014-04-15','10:05:00',1.79),('1444','2014-04-15','10:10:00',2.19),('1444','2014-04-15','10:15:00',1.34),('1444','2014-04-15','10:20:00',1.77),('1444','2014-04-15','10:25:00',1.91),('1444','2014-04-15','10:30:00',3.03),('1444','2014-04-15','10:35:00',1.56),('1444','2014-04-15','10:40:00',2.26),('1444','2014-04-15','10:45:00',2.15),('1444','2014-04-15','10:50:00',1.87),('1444','2014-04-15','10:55:00',1.07),('1444','2014-04-15','11:00:00',2.22),('1444','2014-04-15','11:05:00',2.47),('1444','2014-04-15','11:10:00',1.44),('1444','2014-04-15','11:15:00',1.43),('1444','2014-04-15','11:25:00',1.2),('1444','2014-04-15','11:45:00',1),('1444','2014-04-15','11:50:00',1.09),('1444','2014-04-15','12:15:00',1.26),('1444','2014-04-15','12:20:00',1.12),('1444','2014-04-15','13:10:00',1.08),('1444','2014-04-15','13:15:00',1.91),('1444','2014-04-15','13:20:00',2.11),('1444','2014-04-15','13:25:00',1.78),('1444','2014-04-15','13:30:00',1.76),('1444','2014-04-15','13:35:00',2.68),('1444','2014-04-15','13:40:00',1.36),('1444','2014-04-15','14:00:00',2.65),('1444','2014-04-15','14:05:00',1.33),('1444','2014-04-15','14:10:00',3.1),('1444','2014-04-15','14:15:00',1.88),('1444','2014-04-15','14:20:00',2.07),('1444','2014-04-15','14:25:00',2.84),('1444','2014-04-15','14:30:00',1.84),('1444','2014-04-15','14:35:00',1.15),('1444','2014-04-15','14:40:00',1.53),('1444','2014-04-15','14:45:00',1.52),('1444','2014-04-15','14:50:00',1.11),('1444','2014-04-15','15:10:00',1.03),('1444','2014-04-15','15:15:00',1.29),('1444','2014-04-15','15:20:00',1.44),('1444','2014-04-15','15:25:00',1.5),('1444','2014-04-15','15:30:00',1.25),('1444','2014-04-15','15:35:00',1.16),('1444','2014-04-15','15:40:00',1.17),('1444','2014-04-15','15:45:00',1.07),('1444','2014-04-15','15:50:00',1.09),('1444','2014-04-15','15:55:00',1.25),('1444','2014-04-15','16:00:00',1.31),('1444','2014-04-15','16:05:00',1.19),('1444','2013-10-08','10:55:00',1),('1444','2013-10-08','11:07:00',1.26),('1444','2013-10-08','11:10:00',1.22),('1444','2013-10-08','11:15:00',2.14),('1444','2013-10-08','11:20:00',2.28),('1444','2013-10-08','11:25:00',1.37),('1444','2013-10-08','11:30:00',1.72),('1444','2013-10-08','11:37:00',1.35),('1444','2013-10-08','11:40:00',1.07),('1444','2013-10-08','12:25:00',1.11),('1444','2013-10-08','12:30:00',1.46),('1444','2013-10-08','12:35:00',1.68),('1444','2013-10-08','12:40:00',2.56),('1444','2013-10-08','12:45:00',2.32),('1444','2013-10-08','12:50:00',2.43),('1444','2013-10-08','12:55:00',2.5),('1444','2013-10-08','13:00:00',2.3),('1444','2013-10-08','13:05:00',1.69),('1444','2013-10-08','13:10:00',1.18),('1444','2013-10-08','13:15:00',1.89),('1444','2013-10-08','13:20:00',1.03),('1444','2013-10-08','13:25:00',2.32),('1444','2013-10-08','13:30:00',1.37),('1444','2013-10-08','14:05:00',1.06),('1444','2013-10-08','14:10:00',1.29),('1444','2013-10-08','14:15:00',1.61),('1444','2013-10-08','14:20:00',1.7),('1444','2013-10-08','14:25:00',1.95),('1444','2013-10-08','14:30:00',1.59),('1444','2013-10-08','14:45:00',1.99),('1444','2013-10-08','14:50:00',2.05),('1444','2013-10-08','14:55:00',1.89),('1444','2013-10-08','15:00:00',1.89),('1444','2013-10-08','15:05:00',1.88),('1444','2013-10-08','15:10:00',1.85),('1444','2013-10-08','15:15:00',1.48),('1444','2013-10-08','15:20:00',1.9),('1444','2013-10-08','15:25:00',2.08),('1444','2013-10-08','15:30:00',2.04),('1444','2013-10-08','15:35:00',1.78),('1444','2013-10-08','15:50:00',1.3),('1444','2013-10-07','09:00:00',1.01),('1444','2013-10-07','09:15:00',1.03),('1444','2013-10-07','09:20:00',1.07),('1444','2013-10-07','09:25:00',1.13),('1444','2013-10-07','09:30:00',1.18),('1444','2013-10-07','09:35:00',1.23),('1444','2013-10-07','09:40:00',1.28),('1444','2013-10-07','09:45:00',1.33),('1444','2013-10-07','09:50:00',1.38),('1444','2013-10-07','09:55:00',1.43),('1444','2013-10-07','10:00:00',1.47),('1444','2013-10-07','10:05:00',1.52),('1444','2013-10-07','10:10:00',1.55),('1444','2013-10-07','10:15:00',1.6),('1444','2013-10-07','10:20:00',1.65),('1444','2013-10-07','10:25:00',1.65),('1444','2013-10-07','10:30:00',1.77),('1444','2013-10-07','10:35:00',1.91),('1444','2013-10-07','10:40:00',1.83),('1444','2013-10-07','10:45:00',1.86),('1444','2013-10-07','10:50:00',1.91),('1444','2013-10-07','10:55:00',1.68),('1444','2013-10-07','11:00:00',1.76),('1444','2013-10-07','11:05:00',1.94),('1444','2013-10-07','11:10:00',1.74),('1444','2013-10-07','11:15:00',2.01),('1444','2013-10-07','11:20:00',1.96),('1444','2013-10-07','11:25:00',2.09),('1444','2013-10-07','11:30:00',2.09),('1444','2013-10-07','11:35:00',2.13),('1444','2013-10-07','11:40:00',2.16),('1444','2013-10-07','11:45:00',2.18),('1444','2013-10-07','11:50:00',2.21),('1444','2013-10-07','11:55:00',2.23),('1444','2013-10-07','12:00:00',2.24),('1444','2013-10-07','12:05:00',2.32),('1444','2013-10-07','12:10:00',2.2),('1444','2013-10-07','12:20:00',1.92),('1444','2013-10-07','12:25:00',2.68),('1444','2013-10-07','12:30:00',2.6),('1444','2013-10-07','12:35:00',2.4),('1444','2013-10-07','12:40:00',1.57),('1444','2013-10-07','12:45:00',2.34),('1444','2013-10-07','12:50:00',1.75),('1444','2013-10-07','12:55:00',2.56),('1444','2013-10-07','13:00:00',2.51),('1444','2013-10-07','13:05:00',2.51),('1444','2013-10-07','13:10:00',2.62),('1444','2013-10-07','13:15:00',2.5),('1444','2013-10-07','13:20:00',1.93),('1444','2013-10-07','13:25:00',1.07),('1444','2013-10-07','13:35:00',2.03),('1444','2013-10-07','13:40:00',2.29),('1444','2013-10-07','13:50:00',2.15),('1444','2013-10-07','13:55:00',2.57),('1444','2013-10-07','14:00:00',1.13),('1444','2013-10-07','14:30:00',2.39),('1444','2013-10-07','14:35:00',2.54),('1444','2013-10-07','14:40:00',1.89),('1444','2013-10-07','14:45:00',2.19),('1444','2013-10-07','14:50:00',2.34),('1444','2013-10-07','14:55:00',2.24),('1444','2013-10-07','15:00:00',1.44),('1444','2013-10-07','15:05:00',2.08),('1444','2013-10-07','15:10:00',1.01),('1444','2013-10-07','15:15:00',1.92),('1444','2013-10-07','15:25:00',1.8),('1444','2013-10-07','15:30:00',1.01),('1444','2013-10-07','15:40:00',1.25),('1444','2013-10-07','15:45:00',2.02),('1444','2013-10-07','16:05:00',1.66),('1444','2013-10-07','16:10:00',1.53),('1444','2013-10-07','16:15:00',1.39),('1444','2013-10-07','16:20:00',1.27),('1444','2013-10-07','16:25:00',1.27),('1444','2013-10-07','16:30:00',1.22),('1444','2013-10-07','16:35:00',1.13),('1444','2013-10-07','16:45:00',1.06),('1444','2013-10-06','09:35:00',1),('1444','2013-10-06','09:50:00',1.39),('1444','2013-10-06','09:55:00',1.62),('1444','2013-10-06','10:00:00',1.86),('1444','2013-10-06','10:05:00',1.9),('1444','2013-10-06','10:10:00',1.86),('1444','2013-10-06','10:15:00',1.74),('1444','2013-10-06','10:20:00',1.75),('1444','2013-10-06','10:25:00',1.97),('1444','2013-10-06','10:30:00',1.93),('1444','2013-10-06','10:35:00',1.9),('1444','2013-10-06','10:40:00',1.62),('1444','2013-10-06','10:45:00',1.29),('1444','2013-10-06','10:50:00',1.55),('1444','2013-10-06','10:55:00',1.57),('1444','2013-10-06','11:00:00',1.67),('1444','2013-10-06','11:05:00',1.81),('1444','2013-10-06','11:10:00',1.87),('1444','2013-10-06','11:15:00',1.78),('1444','2013-10-06','11:20:00',1.9),('1444','2013-10-06','11:25:00',1.92),('1444','2013-10-06','11:30:00',1.89),('1444','2013-10-06','11:35:00',1.85),('1444','2013-10-06','11:40:00',1.23),('1444','2013-10-06','11:45:00',1.16),('1444','2013-10-06','11:50:00',1.13),('1444','2013-10-06','11:55:00',1.69),('1444','2013-10-06','12:00:00',1.71),('1444','2013-10-06','12:05:00',1.81),('1444','2013-10-06','12:10:00',2.23),('1444','2013-10-06','12:15:00',2.02),('1444','2013-10-06','12:20:00',1.73),('1444','2013-10-06','12:25:00',1.61),('1444','2013-10-06','12:30:00',1.35),('1444','2013-10-06','12:35:00',1.75),('1444','2013-10-06','12:40:00',1.69),('1444','2013-10-06','12:45:00',1.54),('1444','2013-10-06','12:50:00',1.8),('1444','2013-10-06','12:55:00',2.03),('1444','2013-10-06','13:00:00',1.89),('1444','2013-10-06','13:05:00',2.14),('1444','2013-10-06','13:10:00',2.07),('1444','2013-10-06','13:15:00',2.28),('1444','2013-10-06','13:20:00',1.03),('1444','2013-10-06','13:45:00',1.56),('1444','2013-10-06','13:50:00',2.55),('1444','2013-10-06','13:55:00',2.36),('1444','2013-10-06','14:00:00',1.95),('1444','2013-10-06','14:05:00',1.38),('1444','2013-10-06','14:10:00',1.05),('1444','2013-10-06','14:25:00',1.03),('1444','2013-10-06','14:30:00',1.57),('1444','2013-10-06','14:35:00',1.55),('1444','2013-10-06','14:40:00',1.45),('1444','2013-10-06','14:45:00',1.18),('1444','2013-10-06','14:50:00',1.38),('1444','2013-10-06','14:55:00',1.7),('1444','2013-10-06','15:00:00',1.27),('1444','2013-10-04','09:55:00',1.61),('1444','2013-10-04','10:00:00',1.45),('1444','2013-10-04','10:05:00',1.01),('1444','2013-10-04','10:10:00',1.04),('1444','2013-10-04','10:15:00',1.14),('1444','2013-10-04','10:20:00',1.11),('1444','2013-10-04','10:25:00',1.39),('1444','2013-10-04','10:30:00',1.6),('1444','2013-10-04','10:35:00',1.51),('1444','2013-10-04','10:40:00',1.56),('1444','2013-10-04','10:45:00',1.79),('1444','2013-10-04','10:50:00',1.3),('1444','2013-10-04','10:55:00',1.46),('1444','2013-10-04','11:00:00',1.47),('1444','2013-10-04','11:05:00',1.17),('1444','2013-10-04','11:10:00',1.09),('1444','2013-10-04','11:15:00',1.9),('1444','2013-10-04','11:20:00',1.88),('1444','2013-10-04','11:25:00',1.84),('1444','2013-10-04','11:30:00',2.42),('1444','2013-10-04','11:35:00',2.2),('1444','2013-10-04','11:40:00',2.21),('1444','2013-10-04','11:45:00',2.31),('1444','2013-10-04','11:50:00',2.31),('1444','2013-10-04','11:55:00',2.31),('1444','2013-10-04','12:00:00',2.34),('1444','2013-10-04','12:05:00',2.36),('1444','2013-10-04','12:10:00',2.37),('1444','2013-10-04','12:15:00',2.29),('1444','2013-10-04','12:20:00',2.22),('1444','2013-10-04','12:25:00',2.42),('1444','2013-10-04','12:30:00',2.51),('1444','2013-10-04','12:35:00',2.39),('1444','2013-10-04','12:40:00',2.34),('1444','2013-10-04','12:45:00',2.38),('1444','2013-10-04','12:50:00',2.33),('1444','2013-10-04','12:55:00',2.29),('1444','2013-10-04','13:00:00',2.32),('1444','2013-10-04','13:05:00',2.36),('1444','2013-10-04','13:10:00',2.39),('1444','2013-10-04','13:15:00',2.48),('1444','2013-10-04','13:20:00',2.41),('1444','2013-10-04','13:25:00',2.23),('1444','2013-10-04','13:30:00',2.4),('1444','2013-10-04','13:35:00',2.42),('1444','2013-10-04','13:40:00',2.27),('1444','2013-10-04','13:45:00',2.22),('1444','2013-10-04','13:50:00',2.23),('1444','2013-10-04','13:55:00',2.19),('1444','2013-10-04','14:00:00',2.2),('1444','2013-10-04','14:05:00',2.19),('1444','2013-10-04','14:10:00',1.98),('1444','2013-10-04','14:15:00',1.65),('1444','2013-10-04','14:20:00',2.04),('1444','2013-10-04','14:25:00',2.07),('1444','2013-10-04','14:30:00',1.81),('1444','2013-10-04','14:35:00',1.28),('1444','2013-10-04','14:40:00',1.08),('1444','2013-10-04','14:45:00',1.33),('1444','2013-10-04','14:50:00',1.67),('1444','2013-10-04','14:55:00',1.64),('1444','2013-10-04','15:00:00',1.41),('1444','2013-10-04','15:05:00',1.57),('1444','2013-10-04','15:10:00',1.28),('1444','2013-10-04','15:15:00',1.05),('1444','2013-10-04','15:25:00',1.71),('1444','2013-10-04','15:30:00',1.39),('1444','2013-10-03','09:05:00',1.01),('1444','2013-10-03','09:10:00',1.07),('1444','2013-10-03','09:15:00',1.14),('1444','2013-10-03','09:20:00',1.19),('1444','2013-10-03','09:25:00',1.25),('1444','2013-10-03','09:30:00',1.31),('1444','2013-10-03','09:35:00',1.37),('1444','2013-10-03','09:40:00',1.42),('1444','2013-10-03','09:45:00',1.47),('1444','2013-10-03','09:50:00',1.53),('1444','2013-10-03','09:55:00',1.58),('1444','2013-10-03','10:00:00',1.64),('1444','2013-10-03','10:05:00',1.69),('1444','2013-10-03','10:10:00',1.73),('1444','2013-10-03','10:15:00',1.78),('1444','2013-10-03','10:20:00',1.83),('1444','2013-10-03','10:25:00',1.88),('1444','2013-10-03','10:30:00',1.92),('1444','2013-10-03','10:35:00',1.96),('1444','2013-10-03','10:40:00',2),('1444','2013-10-03','10:45:00',2.04),('1444','2013-10-03','10:50:00',2.07),('1444','2013-10-03','10:55:00',2.12),('1444','2013-10-03','11:00:00',2.15),('1444','2013-10-03','11:05:00',2.17),('1444','2013-10-03','11:10:00',2.22),('1444','2013-10-03','11:15:00',2.24),('1444','2013-10-03','11:20:00',2.27),('1444','2013-10-03','11:25:00',2.3),('1444','2013-10-03','11:30:00',2.32),('1444','2013-10-03','11:35:00',2.35),('1444','2013-10-03','11:40:00',2.37),('1444','2013-10-03','11:45:00',2.38),('1444','2013-10-03','11:50:00',2.41),('1444','2013-10-03','11:55:00',2.43),('1444','2013-10-03','12:00:00',2.44),('1444','2013-10-03','12:05:00',2.47),('1444','2013-10-03','12:10:00',2.48),('1444','2013-10-03','12:15:00',2.48),('1444','2013-10-03','12:20:00',2.48),('1444','2013-10-03','12:25:00',2.49),('1444','2013-10-03','12:30:00',2.49),('1444','2013-10-03','12:35:00',2.5),('1444','2013-10-03','12:40:00',2.5),('1444','2013-10-03','12:45:00',2.5),('1444','2013-10-03','12:50:00',2.5),('1444','2013-10-03','12:55:00',2.49),('1444','2013-10-03','13:00:00',2.49),('1444','2013-10-03','13:05:00',2.44),('1444','2013-10-03','13:10:00',2.46),('1444','2013-10-03','13:15:00',2.46),('1444','2013-10-03','13:20:00',2.46),('1444','2013-10-03','13:25:00',2.46),('1444','2013-10-03','13:30:00',2.46),('1444','2013-10-03','13:35:00',2.46),('1444','2013-10-03','13:40:00',2.44),('1444','2013-10-03','13:45:00',2.4),('1444','2013-10-03','13:50:00',2.39),('1444','2013-10-03','13:55:00',2.39),('1444','2013-10-03','14:00:00',2.38),('1444','2013-10-03','14:05:00',2.36),('1444','2013-10-03','14:10:00',2.34),('1444','2013-10-03','14:15:00',2.31),('1444','2013-10-03','14:20:00',2.28),('1444','2013-10-03','14:25:00',2.26),('1444','2013-10-03','14:30:00',2.24),('1444','2013-10-03','14:35:00',2.21),('1444','2013-10-03','14:40:00',2.18),('1444','2013-10-03','14:45:00',2.15),('1444','2013-10-03','14:50:00',2.11),('1444','2013-10-03','14:55:00',2.07),('1444','2013-10-03','15:00:00',2.04),('1444','2013-10-03','15:05:00',1.99),('1444','2013-10-03','15:10:00',1.95),('1444','2013-10-03','15:15:00',1.91),('1444','2013-10-03','15:20:00',1.88),('1444','2013-10-03','15:25:00',1.83),('1444','2013-10-03','15:30:00',1.79),('1444','2013-10-03','15:35:00',1.74),('1444','2013-10-03','15:40:00',1.69),('1444','2013-10-03','15:45:00',1.64),('1444','2013-10-03','15:50:00',1.59),('1444','2013-10-03','15:55:00',1.55),('1444','2013-10-03','16:00:00',1.49),('1444','2013-10-03','16:05:00',1.44),('1444','2013-10-03','16:10:00',1.39),('1444','2013-10-03','16:15:00',1.33),('1444','2013-10-03','16:20:00',1.27),('1444','2013-10-03','16:25:00',1.22),('1444','2013-10-03','16:30:00',1.17),('1444','2013-10-03','16:35:00',1.11),('1444','2013-10-03','16:40:00',1.05),('1444','2013-10-02','09:10:00',1.02),('1444','2013-10-02','09:15:00',1.08),('1444','2013-10-02','09:20:00',1.13),('1444','2013-10-02','09:25:00',1.19),('1444','2013-10-02','09:30:00',1.24),('1444','2013-10-02','09:35:00',1.29),('1444','2013-10-02','09:40:00',1.34),('1444','2013-10-02','09:45:00',1.39),('1444','2013-10-02','09:50:00',1.45),('1444','2013-10-02','09:55:00',1.49),('1444','2013-10-02','10:00:00',1.23),('1444','2013-10-02','10:05:00',1.58),('1444','2013-10-02','10:10:00',1.62),('1444','2013-10-02','10:15:00',1.66),('1444','2013-10-02','10:20:00',1.72),('1444','2013-10-02','10:25:00',1.77),('1444','2013-10-02','10:30:00',1.81),('1444','2013-10-02','10:35:00',1.86),('1444','2013-10-02','10:40:00',1.9),('1444','2013-10-02','10:45:00',1.95),('1444','2013-10-02','10:50:00',2),('1444','2013-10-02','10:55:00',2.03),('1444','2013-10-02','11:00:00',2.06),('1444','2013-10-02','11:05:00',2.1),('1444','2013-10-02','11:10:00',2.13),('1444','2013-10-02','11:15:00',2.15),('1444','2013-10-02','11:20:00',2.18),('1444','2013-10-02','11:25:00',2.2),('1444','2013-10-02','11:30:00',2.23),('1444','2013-10-02','11:35:00',2.25),('1444','2013-10-02','11:40:00',2.27),('1444','2013-10-02','11:45:00',2.29),('1444','2013-10-02','11:50:00',2.3),('1444','2013-10-02','11:55:00',2.32),('1444','2013-10-02','12:00:00',2.34),('1444','2013-10-02','12:05:00',2.36),('1444','2013-10-02','12:10:00',2.38),('1444','2013-10-02','12:15:00',2.38),('1444','2013-10-02','12:20:00',2.4),('1444','2013-10-02','12:25:00',2.39),('1444','2013-10-02','12:30:00',2.39),('1444','2013-10-02','12:35:00',2.41),('1444','2013-10-02','12:40:00',2.41),('1444','2013-10-02','12:45:00',2.41),('1444','2013-10-02','12:50:00',2.42),('1444','2013-10-02','12:55:00',2.42),('1444','2013-10-02','13:00:00',2.42),('1444','2013-10-02','13:05:00',2.44),('1444','2013-10-02','13:10:00',2.42),('1444','2013-10-02','13:15:00',2.41),('1444','2013-10-02','13:20:00',2.41),('1444','2013-10-02','13:25:00',2.41),('1444','2013-10-02','13:30:00',2.4),('1444','2013-10-02','13:35:00',2.39),('1444','2013-10-02','13:40:00',2.37),('1444','2013-10-02','13:45:00',2.35),('1444','2013-10-02','13:50:00',2.33),('1444','2013-10-02','13:55:00',2.32),('1444','2013-10-02','14:00:00',2.3),('1444','2013-10-02','14:05:00',2.29),('1444','2013-10-02','14:10:00',2.27),('1444','2013-10-02','14:15:00',2.24),('1444','2013-10-02','14:20:00',2.22),('1444','2013-10-02','14:25:00',2.19),('1444','2013-10-02','14:30:00',2.17),('1444','2013-10-02','14:35:00',2.15),('1444','2013-10-02','14:40:00',2.12),('1444','2013-10-02','14:45:00',2.09),('1444','2013-10-02','14:50:00',2.06),('1444','2013-10-02','14:55:00',2.03),('1444','2013-10-02','15:00:00',1.99),('1444','2013-10-02','15:05:00',1.95),('1444','2013-10-02','15:10:00',1.92),('1444','2013-10-02','15:15:00',1.88),('1444','2013-10-02','15:20:00',1.83),('1444','2013-10-02','15:25:00',1.79),('1444','2013-10-02','15:30:00',1.74),('1444','2013-10-02','15:35:00',1.7),('1444','2013-10-02','15:40:00',1.65),('1444','2013-10-02','15:45:00',1.6),('1444','2013-10-02','15:50:00',1.57),('1444','2013-10-02','15:55:00',1.52),('1444','2013-10-02','16:00:00',1.47),('1444','2013-10-02','16:05:00',1.42),('1444','2013-10-02','16:10:00',1.36),('1444','2013-10-02','16:15:00',1.3),('1444','2013-10-02','16:20:00',1.25),('1444','2013-10-02','16:25:00',1.2),('1444','2013-10-02','16:30:00',1.14),('1444','2013-10-02','16:35:00',1.09),('1444','2013-10-02','16:40:00',1.04),('1444','2013-10-01','09:10:00',1.02),('1444','2013-10-01','09:15:00',1.07),('1444','2013-10-01','09:20:00',1.12),('1444','2013-10-01','09:25:00',1.18),('1444','2013-10-01','09:30:00',1.22),('1444','2013-10-01','09:35:00',1.28),('1444','2013-10-01','09:40:00',1.33),('1444','2013-10-01','09:45:00',1.37),('1444','2013-10-01','09:50:00',1.42),('1444','2013-10-01','09:55:00',1.46),('1444','2013-10-01','10:00:00',1.51),('1444','2013-10-01','10:05:00',1.56),('1444','2013-10-01','10:10:00',1.6),('1444','2013-10-01','10:15:00',1.65),('1444','2013-10-01','10:20:00',1.7),('1444','2013-10-01','10:25:00',1.64),('1444','2013-10-01','10:30:00',1.8),('1444','2013-10-01','10:35:00',1.85),('1444','2013-10-01','10:40:00',1.85),('1444','2013-10-01','10:45:00',1.91),('1444','2013-10-01','10:50:00',1.8),('1444','2013-10-01','10:55:00',1.83),('1444','2013-10-01','11:00:00',1.91),('1444','2013-10-01','11:10:00',1.2),('1444','2013-10-01','11:15:00',2.17),('1444','2013-10-01','11:20:00',1.05),('1444','2013-10-01','11:35:00',2.37),('1444','2013-10-01','11:40:00',2.39),('1444','2013-10-01','11:45:00',2.39),('1444','2013-10-01','11:50:00',1.41),('1444','2013-10-01','12:10:00',1.94),('1444','2013-10-01','12:15:00',2.1),('1444','2013-10-01','12:20:00',2.22),('1444','2013-10-01','12:25:00',2.6),('1444','2013-10-01','12:30:00',2.39),('1444','2013-10-01','12:55:00',1.4),('1444','2013-10-01','13:00:00',2.62),('1444','2013-10-01','13:05:00',1.34),('1444','2013-10-01','13:10:00',1.03),('1444','2013-10-01','13:15:00',1.32),('1444','2013-10-01','13:20:00',2.66),('1444','2013-10-01','13:25:00',2.66),('1444','2013-10-01','13:30:00',2.63),('1444','2013-10-01','13:35:00',2.59),('1444','2013-10-01','13:40:00',2.53),('1444','2013-10-01','13:45:00',2.02),('1444','2013-10-01','13:50:00',2.28),('1444','2013-10-01','13:55:00',2.33),('1444','2013-10-01','14:00:00',2.24),('1444','2013-10-01','14:05:00',2.25),('1444','2013-10-01','14:10:00',2.19),('1444','2013-10-01','14:15:00',2.19),('1444','2013-10-01','14:20:00',2.18),('1444','2013-10-01','14:25:00',2.12),('1444','2013-10-01','14:30:00',2.14),('1444','2013-10-01','14:35:00',2.13),('1444','2013-10-01','14:40:00',2.11),('1444','2013-10-01','14:45:00',2.14),('1444','2013-10-01','14:50:00',2.13),('1444','2013-10-01','14:55:00',2.07),('1444','2013-10-01','15:00:00',2),('1444','2013-10-01','15:05:00',1.95),('1444','2013-10-01','15:10:00',1.9),('1444','2013-10-01','15:15:00',1.87),('1444','2013-10-01','15:20:00',1.83),('1444','2013-10-01','15:25:00',1.79),('1444','2013-10-01','15:30:00',1.76),('1444','2013-10-01','15:35:00',1.72),('1444','2013-10-01','15:40:00',1.67),('1444','2013-10-01','15:45:00',1.61),('1444','2013-10-01','15:50:00',1.56),('1444','2013-10-01','15:55:00',1.51),('1444','2013-10-01','16:00:00',1.46),('1444','2013-10-01','16:05:00',1.41),('1444','2013-10-01','16:10:00',1.37),('1444','2013-10-01','16:15:00',1.32),('1444','2013-10-01','16:20:00',1.26),('1444','2013-10-01','16:25:00',1.21),('1444','2013-10-01','16:30:00',1.16),('1444','2013-10-01','16:35:00',1.1),('1444','2013-10-01','16:40:00',1.04),('1444','2013-09-30','10:35:00',1.08),('1444','2013-09-30','10:40:00',1.44),('1444','2013-09-30','10:45:00',2.11),('1444','2013-09-30','10:50:00',2.11),('1444','2013-09-30','10:55:00',1.91),('1444','2013-09-30','11:00:00',1.55),('1444','2013-09-30','11:10:00',1.75),('1444','2013-09-30','11:15:00',2.09),('1444','2013-09-30','11:20:00',2.26),('1444','2013-09-30','11:25:00',1.52),('1444','2013-09-30','11:30:00',1.91),('1444','2013-09-30','11:35:00',1.51),('1444','2013-09-30','11:40:00',2.65),('1444','2013-09-30','11:45:00',1.15),('1444','2013-09-30','11:50:00',1.07),('1444','2013-09-30','12:00:00',1.31),('1444','2013-09-30','12:15:00',2.55),('1444','2013-09-30','12:20:00',2.55),('1444','2013-09-30','12:25:00',2.54),('1444','2013-09-30','12:30:00',2.5),('1444','2013-09-30','12:35:00',2.36),('1444','2013-09-30','12:40:00',2.07),('1444','2013-09-30','12:45:00',1.69),('1444','2013-09-30','12:50:00',2.61),('1444','2013-09-30','12:55:00',2.55),('1444','2013-09-30','13:00:00',2.58),('1444','2013-09-30','13:05:00',2.62),('1444','2013-09-30','13:10:00',2.59),('1444','2013-09-30','13:15:00',2.76),('1444','2013-09-30','13:20:00',2.78),('1444','2013-09-30','13:25:00',2.87),('1444','2013-09-30','13:30:00',2.72),('1444','2013-09-30','13:35:00',2.38),('1444','2013-09-30','13:40:00',2.6),('1444','2013-09-30','13:45:00',1.26),('1444','2013-09-30','13:50:00',1.72),('1444','2013-09-30','13:55:00',1.81),('1444','2013-09-30','14:00:00',1.54),('1444','2013-09-30','14:30:00',2.01),('1444','2013-09-30','14:35:00',1.69),('1444','2013-09-30','14:40:00',2.35),('1444','2013-09-30','14:45:00',2.66),('1444','2013-09-30','14:50:00',1.43),('1444','2013-09-30','14:55:00',1.81),('1444','2013-09-30','15:00:00',1.46),('1444','2013-09-30','15:05:00',1.65),('1444','2013-09-30','15:10:00',2.48),('1444','2013-09-30','15:15:00',2.28),('1444','2013-09-30','15:20:00',1.67),('1444','2013-09-30','15:25:00',1.87),('1444','2013-09-30','15:30:00',1.92),('1444','2013-09-30','15:35:00',2.24),('1444','2013-09-30','15:40:00',2.05),('1444','2013-09-30','15:45:00',1.19),('1444','2013-09-30','16:15:00',1.01),('1444','2013-09-30','16:20:00',1.27),('1444','2013-09-30','16:45:00',1.07),('1444','2013-09-29','10:05:00',1.1),('1444','2013-09-29','10:10:00',1.29),('1444','2013-09-29','10:15:00',1.62),('1444','2013-09-29','10:20:00',1.39),('1444','2013-09-29','10:25:00',1.29),('1444','2013-09-29','10:30:00',1.45),('1444','2013-09-29','10:35:00',1.5),('1444','2013-09-29','10:40:00',1.35),('1444','2013-09-29','10:45:00',1.64),('1444','2013-09-29','10:50:00',1.8),('1444','2013-09-29','10:55:00',1.79),('1444','2013-09-29','11:00:00',1.81),('1444','2013-09-29','11:05:00',1.75),('1444','2013-09-29','11:10:00',1.75),('1444','2013-09-29','11:15:00',1.9),('1444','2013-09-29','11:20:00',1.86),('1444','2013-09-29','11:25:00',1.76),('1444','2013-09-29','11:30:00',1.92),('1444','2013-09-29','11:35:00',1.9),('1444','2013-09-29','11:40:00',1.99),('1444','2013-09-29','11:45:00',2.04),('1444','2013-09-29','11:50:00',2.13),('1444','2013-09-29','11:55:00',2.12),('1444','2013-09-29','12:00:00',1.88),('1444','2013-09-29','12:05:00',1.23),('1444','2013-09-29','12:10:00',2.23),('1444','2013-09-29','12:15:00',2.4),('1444','2013-09-29','12:20:00',1.22),('1444','2013-09-29','12:25:00',1.16),('1444','2013-09-29','12:30:00',1.28),('1444','2013-09-29','12:35:00',1.24),('1444','2013-09-29','12:40:00',1.1),('1444','2013-09-29','13:25:00',1),('1444','2013-09-29','13:30:00',1.14),('1444','2013-09-29','13:35:00',1.32),('1444','2013-09-29','13:40:00',1.15),('1444','2013-09-29','13:45:00',1.05),('1444','2013-09-29','13:50:00',1.2),('1444','2013-09-29','13:55:00',1.36),('1444','2013-09-29','14:00:00',1.25),('1444','2013-09-29','14:05:00',1.42),('1444','2013-09-29','14:15:00',1.14),('1444','2013-09-29','14:20:00',2.01),('1444','2013-09-29','14:25:00',1.04),('1444','2013-09-29','14:30:00',1.23),('1444','2014-04-14','08:20:00',1.06),('1444','2014-04-14','08:25:00',1.13),('1444','2014-04-14','08:30:00',1.19),('1444','2014-04-14','08:35:00',1.26),('1444','2014-04-14','08:40:00',1.33),('1444','2014-04-14','08:45:00',1.39),('1444','2014-04-14','08:50:00',1.46),('1444','2014-04-14','08:55:00',1.52),('1444','2014-04-14','09:00:00',1.6),('1444','2014-04-14','09:05:00',1.66),('1444','2014-04-14','09:10:00',1.72),('1444','2014-04-14','09:15:00',1.77),('1444','2014-04-14','09:20:00',1.83),('1444','2014-04-14','09:25:00',1.89),('1444','2014-04-14','09:30:00',1.96),('1444','2014-04-14','09:35:00',2.01),('1444','2014-04-14','09:40:00',2.06),('1444','2014-04-14','09:45:00',2.12),('1444','2014-04-14','09:50:00',2.19),('1444','2014-04-14','09:55:00',2.25),('1444','2014-04-14','10:00:00',2.29),('1444','2014-04-14','10:05:00',2.34),('1444','2014-04-14','10:10:00',2.4),('1444','2014-04-14','10:15:00',2.45),('1444','2014-04-14','10:20:00',2.5),('1444','2014-04-14','10:25:00',2.55),('1444','2014-04-14','10:30:00',2.59),('1444','2014-04-14','10:35:00',2.63),('1444','2014-04-14','10:40:00',2.67),('1444','2014-04-14','10:45:00',2.71),('1444','2014-04-14','10:50:00',2.73),('1444','2014-04-14','10:55:00',2.77),('1444','2014-04-14','11:00:00',2.8),('1444','2014-04-14','11:05:00',2.83),('1444','2014-04-14','11:10:00',2.86),('1444','2014-04-14','11:15:00',2.88),('1444','2014-04-14','11:20:00',2.91),('1444','2014-04-14','11:25:00',2.96),('1444','2014-04-14','11:30:00',2.97),('1444','2014-04-14','11:35:00',3),('1444','2014-04-14','11:40:00',3.01),('1444','2014-04-14','11:45:00',3.02),('1444','2014-04-14','11:50:00',3.04),('1444','2014-04-14','11:55:00',3.07),('1444','2014-04-14','12:00:00',3.1),('1444','2014-04-14','12:05:00',3.12),('1444','2014-04-14','12:10:00',3.12),('1444','2014-04-14','12:15:00',3.14),('1444','2014-04-14','12:20:00',3.15),('1444','2014-04-14','12:25:00',3.18),('1444','2014-04-14','12:30:00',3.19),('1444','2014-04-14','12:35:00',3.21),('1444','2014-04-14','12:40:00',3.2),('1444','2014-04-14','12:45:00',3.2),('1444','2014-04-14','12:50:00',3.22),('1444','2014-04-14','12:55:00',3.24),('1444','2014-04-14','13:00:00',3.24),('1444','2014-04-14','13:05:00',3.2),('1444','2014-04-14','13:10:00',3.21),('1444','2014-04-14','13:15:00',3.24),('1444','2014-04-14','13:20:00',3.23),('1444','2014-04-14','13:25:00',3.23),('1444','2014-04-14','13:30:00',3.23),('1444','2014-04-14','13:35:00',3.22),('1444','2014-04-14','13:40:00',3.23),('1444','2014-04-14','13:45:00',3.21),('1444','2014-04-14','13:50:00',3.2),('1444','2014-04-14','13:55:00',3.19),('1444','2014-04-14','14:00:00',3.17),('1444','2014-04-14','14:05:00',3.18),('1444','2014-04-14','14:10:00',3.17),('1444','2014-04-14','14:15:00',3.14),('1444','2014-04-14','14:20:00',3.14),('1444','2014-04-14','14:25:00',3.11),('1444','2014-04-14','14:30:00',3.08),('1444','2014-04-14','14:35:00',3.05),('1444','2014-04-14','14:40:00',3.04),('1444','2014-04-14','14:45:00',3.02),('1444','2014-04-14','14:50:00',3),('1444','2014-04-14','14:55:00',2.96),('1444','2014-04-14','15:00:00',2.93),('1444','2014-04-14','15:05:00',2.89),('1444','2014-04-14','15:10:00',2.86),('1444','2014-04-14','15:15:00',2.83),('1444','2014-04-14','15:20:00',2.8),('1444','2014-04-14','15:25:00',2.77),('1444','2014-04-14','15:30:00',2.72),('1444','2014-04-14','15:35:00',2.67),('1444','2014-04-14','15:40:00',2.63),('1444','2014-04-14','15:45:00',2.59),('1444','2014-04-14','15:50:00',2.55),('1444','2014-04-14','15:55:00',2.5),('1444','2014-04-14','16:00:00',2.45),('1444','2014-04-14','16:05:00',2.39),('1444','2014-04-14','16:10:00',2.34),('1444','2014-04-14','16:15:00',2.29),('1444','2014-04-14','16:20:00',2.24),('1444','2014-04-14','16:25:00',2.18),('1444','2014-04-14','16:30:00',2.12),('1444','2014-04-14','16:35:00',2.06),('1444','2014-04-14','16:40:00',2),('1444','2014-04-14','16:45:00',1.94),('1444','2014-04-14','16:50:00',1.88),('1444','2014-04-14','16:55:00',1.82),('1444','2014-04-14','17:00:00',1.76),('1444','2014-04-14','17:05:00',1.69),('1444','2014-04-14','17:10:00',1.62),('1444','2014-04-14','17:15:00',1.56),('1444','2014-04-14','17:20:00',1.5),('1444','2014-04-14','17:25:00',1.43),('1444','2014-04-14','17:30:00',1.36),('1444','2014-04-14','17:35:00',1.29),('1444','2014-04-14','17:40:00',1.22),('1444','2014-04-14','17:45:00',1.15),('1444','2014-04-14','17:50:00',1.08),('1444','2014-04-14','17:55:00',1.02),('1444','2013-09-28','09:15:00',1.02),('1444','2013-09-28','09:20:00',1.07),('1444','2013-09-28','09:25:00',1.13),('1444','2013-09-28','09:30:00',1.17),('1444','2013-09-28','09:35:00',1.23),('1444','2013-09-28','09:40:00',1.26),('1444','2013-09-28','09:45:00',1.31),('1444','2013-09-28','09:50:00',1.49),('1444','2013-09-28','09:55:00',1.6),('1444','2013-09-28','10:00:00',1.06),('1444','2013-09-28','10:10:00',1.35),('1444','2013-09-28','10:15:00',1.41),('1444','2013-09-28','10:20:00',1.27),('1444','2013-09-28','10:35:00',1.12),('1444','2013-09-28','10:40:00',1.89),('1444','2013-09-28','10:45:00',2.24),('1444','2013-09-28','10:50:00',2.36),('1444','2013-09-28','10:55:00',2.26),('1444','2013-09-28','11:00:00',1.8),('1444','2013-09-28','11:05:00',1.53),('1444','2013-09-28','11:10:00',2.09),('1444','2013-09-28','11:15:00',2.3),('1444','2013-09-28','11:20:00',2.38),('1444','2013-09-28','11:25:00',2.44),('1444','2013-09-28','11:30:00',2.41),('1444','2013-09-28','11:35:00',1.97),('1444','2013-09-28','11:50:00',1.87),('1444','2013-09-28','11:55:00',2.43),('1444','2013-09-28','12:00:00',2.55),('1444','2013-09-28','12:05:00',1.8),('1444','2013-09-28','12:10:00',2.27),('1444','2013-09-28','12:15:00',1.99),('1444','2013-09-28','12:20:00',1.78),('1444','2013-09-28','12:25:00',1.77),('1444','2013-09-28','12:30:00',1.55),('1444','2013-09-28','12:35:00',2.24),('1444','2013-09-28','12:40:00',2.52),('1444','2013-09-28','12:45:00',2.61),('1444','2013-09-28','12:50:00',2.68),('1444','2013-09-28','12:55:00',2.6),('1444','2013-09-28','13:00:00',1.52),('1444','2013-09-28','13:05:00',1.42),('1444','2013-09-28','13:10:00',2.73),('1444','2013-09-28','13:15:00',2.45),('1444','2013-09-28','13:20:00',2.39),('1444','2013-09-28','13:25:00',2.4),('1444','2013-09-28','13:30:00',1.52),('1444','2013-09-28','13:35:00',1.37),('1444','2013-09-28','13:40:00',1.99),('1444','2013-09-28','13:45:00',2.09),('1444','2013-09-28','13:50:00',2.61),('1444','2013-09-28','13:55:00',2.77),('1444','2013-09-28','14:00:00',2.53),('1444','2013-09-28','14:05:00',2.63),('1444','2013-09-28','14:10:00',2.6),('1444','2013-09-28','14:15:00',2.52),('1444','2013-09-28','14:20:00',2.42),('1444','2013-09-28','14:25:00',2.33),('1444','2013-09-28','14:30:00',2.29),('1444','2013-09-28','14:35:00',2.29),('1444','2013-09-28','14:40:00',2.24),('1444','2013-09-28','14:45:00',2.2),('1444','2013-09-28','14:50:00',2.09),('1444','2013-09-28','14:55:00',2.06),('1444','2013-09-28','15:00:00',2.1),('1444','2013-09-28','15:05:00',1.67),('1444','2013-09-28','15:10:00',1.99),('1444','2013-09-28','15:15:00',1.93),('1444','2013-09-28','15:20:00',1.91),('1444','2013-09-28','15:25:00',1.86),('1444','2013-09-28','15:30:00',1.78),('1444','2013-09-28','15:35:00',1.68),('1444','2013-09-28','15:40:00',1.7),('1444','2013-09-28','15:45:00',1.68),('1444','2013-09-28','15:50:00',1.6),('1444','2013-09-28','15:55:00',1.62),('1444','2013-09-28','16:00:00',1.61),('1444','2013-09-28','16:05:00',1.55),('1444','2013-09-28','16:10:00',1.47),('1444','2013-09-28','16:15:00',1.04),('1444','2013-09-28','16:20:00',1.27),('1444','2013-09-28','16:25:00',1.16),('1444','2013-09-28','16:30:00',1.09),('1444','2013-09-28','16:35:00',1.11),('1444','2013-09-28','16:40:00',1.05),('1444','2013-09-27','09:00:00',1.06),('1444','2013-09-27','09:50:00',1.07),('1444','2013-09-27','09:55:00',1.58),('1444','2013-09-27','10:00:00',1.12),('1444','2013-09-27','10:05:00',1.41),('1444','2013-09-27','10:10:00',1.2),('1444','2013-09-27','10:15:00',1.09),('1444','2013-09-27','10:20:00',1.1),('1444','2013-09-27','10:25:00',1.07),('1444','2013-09-27','10:30:00',1.03),('1444','2013-09-27','10:55:00',1.04),('1444','2013-09-27','11:00:00',1.12),('1444','2013-09-27','11:10:00',1.76),('1444','2013-09-27','11:15:00',1.52),('1444','2013-09-27','11:20:00',2.08),('1444','2013-09-27','11:25:00',2.21),('1444','2013-09-27','11:30:00',1.06),('1444','2013-09-27','11:55:00',1.38),('1444','2013-09-27','12:00:00',2.58),('1444','2013-09-27','12:05:00',1.78),('1444','2013-09-27','12:10:00',2.27),('1444','2013-09-27','12:50:00',1.68),('1444','2013-09-27','12:55:00',2.05),('1444','2013-09-27','13:00:00',2.35),('1444','2013-09-27','13:05:00',2.55),('1444','2013-09-27','13:10:00',2.16),('1444','2013-09-27','13:15:00',1.21),('1444','2013-09-27','13:20:00',1.06),('1444','2013-09-27','13:50:00',1.47),('1444','2013-09-27','13:55:00',1.59),('1444','2013-09-27','14:00:00',2.4),('1444','2013-09-27','14:05:00',1.97),('1444','2013-09-27','14:10:00',2.33),('1444','2013-09-27','14:15:00',2.35),('1444','2013-09-27','14:20:00',2.29),('1444','2013-09-27','14:25:00',1.79),('1444','2013-09-27','14:30:00',2.17),('1444','2013-09-27','14:35:00',1.98),('1444','2013-09-27','14:40:00',2.04),('1444','2013-09-27','14:45:00',2.1),('1444','2013-09-27','14:50:00',1.86),('1444','2013-09-27','14:55:00',2.1),('1444','2013-09-27','15:00:00',2.05),('1444','2013-09-27','15:05:00',1.55),('1444','2013-09-27','15:10:00',1.92),('1444','2013-09-27','15:15:00',1.88),('1444','2013-09-27','15:20:00',1.9),('1444','2013-09-27','15:25:00',1.87),('1444','2013-09-27','15:30:00',1.31),('1444','2013-09-27','15:35:00',1.77),('1444','2013-09-27','15:40:00',1.54),('1444','2013-09-27','15:45:00',1.76),('1444','2013-09-27','15:50:00',1.72),('1444','2013-09-27','15:55:00',1.55),('1444','2013-09-27','16:00:00',1.5),('1444','2013-09-27','16:05:00',1.02),('1444','2013-09-27','16:10:00',1.17),('1444','2013-09-27','16:15:00',1.25),('1444','2013-09-27','16:20:00',1.26),('1444','2013-09-27','16:25:00',1.26),('1444','2013-09-27','16:35:00',1.15),('1444','2013-09-27','16:40:00',1.1),('1444','2013-09-27','16:45:00',1.06),('1444','2013-09-26','09:05:00',1.02),('1444','2013-09-26','09:10:00',1.07),('1444','2013-09-26','09:15:00',1.11),('1444','2013-09-26','09:20:00',1.17),('1444','2013-09-26','09:25:00',1.21),('1444','2013-09-26','09:30:00',1.26),('1444','2013-09-26','09:35:00',1.32),('1444','2013-09-26','09:40:00',1.38),('1444','2013-09-26','09:45:00',1.42),('1444','2013-09-26','09:50:00',1.47),('1444','2013-09-26','09:55:00',1.49),('1444','2013-09-26','10:00:00',1.56),('1444','2013-09-26','10:05:00',1.6),('1444','2013-09-26','10:10:00',1.64),('1444','2013-09-26','10:15:00',1.67),('1444','2013-09-26','10:20:00',1.71),('1444','2013-09-26','10:25:00',1.73),('1444','2013-09-26','10:30:00',1.78),('1444','2013-09-26','10:35:00',1.83),('1444','2013-09-26','10:40:00',1.63),('1444','2013-09-26','10:45:00',1.85),('1444','2013-09-26','10:50:00',1.91),('1444','2013-09-26','10:55:00',1.9),('1444','2013-09-26','11:00:00',1.95),('1444','2013-09-26','11:05:00',1.57),('1444','2013-09-26','11:10:00',2.06),('1444','2013-09-26','11:15:00',2.05),('1444','2013-09-26','11:20:00',2.03),('1444','2013-09-26','11:25:00',2.01),('1444','2013-09-26','11:30:00',2.1),('1444','2013-09-26','11:35:00',2.17),('1444','2013-09-26','11:40:00',2.12),('1444','2013-09-26','11:45:00',2.19),('1444','2013-09-26','11:50:00',1.97),('1444','2013-09-26','11:55:00',2.22),('1444','2013-09-26','12:00:00',2.34),('1444','2013-09-26','12:05:00',2.66),('1444','2013-09-26','12:10:00',1.36),('1444','2013-09-26','12:15:00',1.21),('1444','2013-09-26','12:20:00',1.43),('1444','2013-09-26','12:35:00',1.09),('1444','2013-09-26','12:40:00',1.08),('1444','2013-09-26','12:45:00',1.08),('1444','2013-09-26','12:50:00',1.1),('1444','2013-09-26','12:55:00',2.43),('1444','2013-09-26','13:00:00',1.21),('1444','2013-09-26','13:05:00',1.24),('1444','2013-09-26','13:10:00',1.95),('1444','2013-09-26','13:15:00',2.23),('1444','2013-09-26','13:20:00',1.53),('1444','2013-09-26','13:25:00',1.57),('1444','2013-09-26','13:30:00',1.8),('1444','2013-09-26','13:35:00',1.6),('1444','2013-09-26','13:40:00',1.03),('1444','2013-09-26','13:45:00',1.4),('1444','2013-09-26','13:50:00',2.35),('1444','2013-09-26','13:55:00',1.21),('1444','2013-09-26','14:00:00',2.18),('1444','2013-09-26','14:05:00',2.62),('1444','2013-09-26','14:10:00',1.39),('1444','2013-09-26','14:30:00',1.29),('1444','2013-09-26','14:40:00',1.38),('1444','2013-09-26','14:45:00',2.55),('1444','2013-09-26','14:50:00',2.52),('1444','2013-09-26','14:55:00',2.2),('1444','2013-09-26','15:00:00',1.13),('1444','2013-09-26','15:05:00',2.16),('1444','2013-09-26','15:20:00',1.87),('1444','2013-09-26','15:35:00',1.91),('1444','2013-09-26','15:50:00',1.12),('1444','2013-09-26','15:55:00',1.58),('1444','2013-09-26','16:00:00',1.05),('1444','2013-09-26','16:10:00',1.16),('1444','2013-09-26','16:15:00',1.3),('1444','2013-09-26','16:20:00',1.33),('1444','2013-09-26','16:25:00',1.31),('1444','2013-09-26','16:30:00',1.23),('1444','2013-09-26','16:35:00',1.17),('1444','2013-09-26','16:40:00',1.11),('1444','2013-09-26','16:45:00',1.05),('1444','2013-09-25','09:35:00',1.51),('1444','2013-09-25','09:50:00',1.61),('1444','2013-09-25','09:55:00',1.11),('1444','2013-09-25','10:20:00',1.11),('1444','2013-09-25','10:40:00',1.07),('1444','2013-09-25','10:45:00',2.4),('1444','2013-09-25','10:50:00',2.07),('1444','2013-09-25','10:55:00',2.19),('1444','2013-09-25','11:00:00',1.66),('1444','2013-09-25','11:05:00',1.17),('1444','2013-09-25','11:10:00',1.59),('1444','2013-09-25','11:15:00',1.4),('1444','2013-09-25','11:20:00',2.23),('1444','2013-09-25','11:25:00',2.24),('1444','2013-09-25','11:30:00',2.31),('1444','2013-09-25','11:35:00',2.38),('1444','2013-09-25','11:40:00',2.47),('1444','2013-09-25','11:45:00',1.75),('1444','2013-09-25','12:10:00',2.23),('1444','2013-09-25','12:15:00',2.03),('1444','2013-09-25','12:30:00',2.45),('1444','2013-09-25','12:35:00',2.27),('1444','2013-09-25','13:10:00',1.04),('1444','2013-09-25','13:15:00',2.8),('1444','2013-09-25','13:20:00',2.82),('1444','2013-09-25','13:25:00',2.96),('1444','2013-09-25','13:30:00',2.91),('1444','2013-09-25','13:35:00',2.88),('1444','2013-09-25','13:40:00',2.83),('1444','2013-09-25','13:45:00',2.8),('1444','2013-09-25','13:50:00',1.64),('1444','2013-09-25','14:20:00',1.53),('1444','2013-09-25','14:25:00',1.95),('1444','2013-09-25','14:30:00',2.64),('1444','2013-09-25','14:35:00',2.6),('1444','2013-09-25','14:40:00',2.17),('1444','2013-09-25','14:45:00',1.76),('1444','2013-09-25','14:50:00',2.29),('1444','2013-09-25','14:55:00',1.74),('1444','2013-09-25','15:00:00',1.79),('1444','2013-09-25','15:05:00',2.24),('1444','2013-09-25','15:10:00',2.11),('1444','2013-09-25','15:15:00',2.06),('1444','2013-09-25','15:20:00',1.59),('1444','2013-09-25','15:25:00',1.93),('1444','2013-09-25','15:30:00',1.91),('1444','2013-09-25','15:35:00',2.06),('1444','2013-09-25','15:40:00',1.92),('1444','2013-09-25','15:45:00',1.76),('1444','2013-09-25','15:50:00',1.79),('1444','2013-09-25','15:55:00',1.74),('1444','2013-09-25','16:00:00',1.69),('1444','2013-09-25','16:05:00',1.59),('1444','2013-09-25','16:10:00',1.56),('1444','2013-09-25','16:15:00',1.5),('1444','2013-09-25','16:20:00',1.43),('1444','2013-09-25','16:25:00',1.39),('1444','2013-09-25','16:30:00',1.34),('1444','2013-09-25','16:35:00',1.15),('1444','2013-09-25','16:40:00',1.19),('1444','2013-09-25','16:45:00',1.14),('1444','2013-09-25','16:50:00',1.08),('1444','2013-09-25','16:55:00',1.03),('1444','2013-09-24','09:00:00',1.03),('1444','2013-09-24','09:05:00',1.09),('1444','2013-09-24','09:10:00',1.14),('1444','2013-09-24','09:15:00',1.2),('1444','2013-09-24','09:20:00',1.25),('1444','2013-09-24','09:25:00',1.32),('1444','2013-09-24','09:30:00',1.37),('1444','2013-09-24','09:35:00',1.43),('1444','2013-09-24','09:40:00',1.46),('1444','2013-09-24','09:45:00',1.52),('1444','2013-09-24','09:50:00',1.57),('1444','2013-09-24','09:55:00',1.61),('1444','2013-09-24','10:00:00',1.66),('1444','2013-09-24','10:05:00',1.72),('1444','2013-09-24','10:10:00',1.77),('1444','2013-09-24','10:15:00',1.81),('1444','2013-09-24','10:20:00',1.86),('1444','2013-09-24','10:25:00',1.9),('1444','2013-09-24','10:30:00',1.94),('1444','2013-09-24','10:35:00',1.97),('1444','2013-09-24','10:40:00',2.01),('1444','2013-09-24','10:45:00',2.04),('1444','2013-09-24','10:50:00',2.08),('1444','2013-09-24','10:55:00',2.1),('1444','2013-09-24','11:00:00',2.14),('1444','2013-09-24','11:05:00',2.15),('1444','2013-09-24','11:10:00',2.16),('1444','2013-09-24','11:15:00',2.19),('1444','2013-09-24','11:20:00',2.23),('1444','2013-09-24','11:25:00',2.25),('1444','2013-09-24','11:30:00',2.28),('1444','2013-09-24','11:35:00',2.28),('1444','2013-09-24','11:40:00',2.29),('1444','2013-09-24','11:45:00',2.31),('1444','2013-09-24','11:50:00',2.33),('1444','2013-09-24','11:55:00',2.34),('1444','2013-09-24','12:00:00',2.37),('1444','2013-09-24','12:05:00',2.39),('1444','2013-09-24','12:10:00',2.38),('1444','2013-09-24','12:15:00',2.35),('1444','2013-09-24','12:20:00',2.36),('1444','2013-09-24','12:25:00',2.39),('1444','2013-09-24','12:30:00',2.42),('1444','2013-09-24','12:35:00',2.45),('1444','2013-09-24','12:40:00',2.46),('1444','2013-09-24','12:45:00',2.43),('1444','2013-09-24','12:50:00',2.42),('1444','2013-09-24','12:55:00',2.43),('1444','2013-09-24','13:00:00',2.47),('1444','2013-09-24','13:05:00',2.46),('1444','2013-09-24','13:10:00',2.47),('1444','2013-09-24','13:15:00',2.45),('1444','2013-09-24','13:20:00',2.45),('1444','2013-09-24','13:25:00',2.42),('1444','2013-09-24','13:30:00',2.44),('1444','2013-09-24','13:35:00',2.45),('1444','2013-09-24','13:40:00',2.46),('1444','2013-09-24','13:45:00',2.42),('1444','2013-09-24','13:50:00',2.4),('1444','2013-09-24','13:55:00',2.39),('1444','2013-09-24','14:00:00',2.37),('1444','2013-09-24','14:05:00',2.35),('1444','2013-09-24','14:10:00',2.35),('1444','2013-09-24','14:15:00',2.33),('1444','2013-09-24','14:20:00',2.3),('1444','2013-09-24','14:25:00',2.3),('1444','2013-09-24','14:30:00',2.25),('1444','2013-09-24','14:35:00',2.23),('1444','2013-09-24','14:40:00',2.21),('1444','2013-09-24','14:45:00',2.18),('1444','2013-09-24','14:50:00',2.15),('1444','2013-09-24','14:55:00',2.12),('1444','2013-09-24','15:00:00',2.09),('1444','2013-09-24','15:05:00',2.06),('1444','2013-09-24','15:10:00',2),('1444','2013-09-24','15:15:00',2.01),('1444','2013-09-24','15:20:00',1.98),('1444','2013-09-24','15:25:00',1.94),('1444','2013-09-24','15:30:00',1.9),('1444','2013-09-24','15:35:00',1.86),('1444','2013-09-24','15:40:00',1.81),('1444','2013-09-24','15:45:00',1.78),('1444','2013-09-24','15:50:00',1.73),('1444','2013-09-24','15:55:00',1.69),('1444','2013-09-24','16:00:00',1.64),('1444','2013-09-24','16:05:00',1.58),('1444','2013-09-24','16:10:00',1.54),('1444','2013-09-24','16:15:00',1.49),('1444','2013-09-24','16:20:00',1.46),('1444','2013-09-24','16:25:00',1.39),('1444','2013-09-24','16:30:00',1.32),('1444','2013-09-24','16:35:00',1.28),('1444','2013-09-24','16:40:00',1.22),('1444','2013-09-24','16:45:00',1.18),('1444','2013-09-24','16:50:00',1.12),('1444','2013-09-24','16:55:00',1.07),('1444','2013-09-24','17:00:00',1),('1444','2013-09-23','08:55:00',1.01),('1444','2013-09-23','09:00:00',1.07),('1444','2013-09-23','09:05:00',1.12),('1444','2013-09-23','09:10:00',1.18),('1444','2013-09-23','09:15:00',1.24),('1444','2013-09-23','09:20:00',1.3),('1444','2013-09-23','09:25:00',1.35),('1444','2013-09-23','09:30:00',1.4),('1444','2013-09-23','09:35:00',1.46),('1444','2013-09-23','09:40:00',1.52),('1444','2013-09-23','09:45:00',1.56),('1444','2013-09-23','09:50:00',1.61),('1444','2013-09-23','09:55:00',1.66),('1444','2013-09-23','10:00:00',1.71),('1444','2013-09-23','10:05:00',1.76),('1444','2013-09-23','10:10:00',1.8),('1444','2013-09-23','10:15:00',1.85),('1444','2013-09-23','10:20:00',1.89),('1444','2013-09-23','10:25:00',1.94),('1444','2013-09-23','10:30:00',1.98),('1444','2013-09-23','10:35:00',2.01),('1444','2013-09-23','10:40:00',2.06),('1444','2013-09-23','10:45:00',2.09),('1444','2013-09-23','10:50:00',2.12),('1444','2013-09-23','10:55:00',2.12),('1444','2013-09-23','11:00:00',2.19),('1444','2013-09-23','11:05:00',2.21),('1444','2013-09-23','11:10:00',2.25),('1444','2013-09-23','11:15:00',2.28),('1444','2013-09-23','11:20:00',2.33),('1444','2013-09-23','11:25:00',2.35),('1444','2013-09-23','11:30:00',2.38),('1444','2013-09-23','11:35:00',2.39),('1444','2013-09-23','11:40:00',2.43),('1444','2013-09-23','11:45:00',2.45),('1444','2013-09-23','11:50:00',2.46),('1444','2013-09-23','11:55:00',2.5),('1444','2013-09-23','12:00:00',2.5),('1444','2013-09-23','12:05:00',2.51),('1444','2013-09-23','12:10:00',2.53),('1444','2013-09-23','12:15:00',2.54),('1444','2013-09-23','12:20:00',2.54),('1444','2013-09-23','12:25:00',2.57),('1444','2013-09-23','12:30:00',2.59),('1444','2013-09-23','12:35:00',2.58),('1444','2013-09-23','12:40:00',2.56),('1444','2013-09-23','12:45:00',2.56),('1444','2013-09-23','12:50:00',2.57),('1444','2013-09-23','12:55:00',2.56),('1444','2013-09-23','13:00:00',2.57),('1444','2013-09-23','13:05:00',2.55),('1444','2013-09-23','13:10:00',2.54),('1444','2013-09-23','13:15:00',2.51),('1444','2013-09-23','13:20:00',2.49),('1444','2013-09-23','13:25:00',2.46),('1444','2013-09-23','13:30:00',2.46),('1444','2013-09-23','13:35:00',2.5),('1444','2013-09-23','13:40:00',2.49),('1444','2013-09-23','13:45:00',2.49),('1444','2013-09-23','13:50:00',2.46),('1444','2013-09-23','13:55:00',2.46),('1444','2013-09-23','14:00:00',2.41),('1444','2013-09-23','14:05:00',2.37),('1444','2013-09-23','14:10:00',2.33),('1444','2013-09-23','14:15:00',2.38),('1444','2013-09-23','14:20:00',2.35),('1444','2013-09-23','14:25:00',2.33),('1444','2013-09-23','14:30:00',2.33),('1444','2013-09-23','14:35:00',2.28),('1444','2013-09-23','14:40:00',1.99),('1444','2013-09-23','14:45:00',2.2),('1444','2013-09-23','14:50:00',2.18),('1444','2013-09-23','14:55:00',1.92),('1444','2013-09-23','15:00:00',2.15),('1444','2013-09-23','15:05:00',2.17),('1444','2013-09-23','15:10:00',1.37),('1444','2013-09-23','15:15:00',1.12),('1444','2013-09-23','15:20:00',1.75),('1444','2013-09-23','15:25:00',1.08),('1444','2013-09-23','15:30:00',1.93),('1444','2013-09-23','15:35:00',1.78),('1444','2013-09-23','15:40:00',1.86),('1444','2013-09-23','15:45:00',1.82),('1444','2013-09-23','15:50:00',1.76),('1444','2013-09-23','15:55:00',1.7),('1444','2013-09-23','16:00:00',1.64),('1444','2013-09-23','16:05:00',1.59),('1444','2013-09-23','16:10:00',1.56),('1444','2013-09-23','16:15:00',1.32),('1444','2013-09-23','16:20:00',1.42),('1444','2013-09-23','16:25:00',1.37),('1444','2013-09-23','16:30:00',1.33),('1444','2013-09-23','16:35:00',1.25),('1444','2013-09-23','16:40:00',1.19),('1444','2013-09-23','16:45:00',1.14),('1444','2013-09-23','16:50:00',1.09),('1444','2013-09-23','16:55:00',1.03),('1444','2013-09-22','09:00:00',1.05),('1444','2013-09-22','09:05:00',1.11),('1444','2013-09-22','09:10:00',1.17),('1444','2013-09-22','09:15:00',1.23),('1444','2013-09-22','09:20:00',1.29),('1444','2013-09-22','09:25:00',1.35),('1444','2013-09-22','09:30:00',1.41),('1444','2013-09-22','09:35:00',1.47),('1444','2013-09-22','09:40:00',1.51),('1444','2013-09-22','09:45:00',1.56),('1444','2013-09-22','09:50:00',1.61),('1444','2013-09-22','09:55:00',1.66),('1444','2013-09-22','10:00:00',1.72),('1444','2013-09-22','10:05:00',1.76),('1444','2013-09-22','10:10:00',1.82),('1444','2013-09-22','10:15:00',1.87),('1444','2013-09-22','10:20:00',1.92),('1444','2013-09-22','10:25:00',1.96),('1444','2013-09-22','10:30:00',2),('1444','2013-09-22','10:35:00',2.05),('1444','2013-09-22','10:40:00',2.08),('1444','2013-09-22','10:45:00',2.12),('1444','2013-09-22','10:50:00',2.15),('1444','2013-09-22','10:55:00',2.18),('1444','2013-09-22','11:00:00',2.21),('1444','2013-09-22','11:05:00',2.23),('1444','2013-09-22','11:10:00',2.25),('1444','2013-09-22','11:15:00',2.3),('1444','2013-09-22','11:20:00',2.33),('1444','2013-09-22','11:25:00',2.35),('1444','2013-09-22','11:30:00',2.38),('1444','2013-09-22','11:35:00',2.42),('1444','2013-09-22','11:40:00',2.45),('1444','2013-09-22','11:45:00',2.49),('1444','2013-09-22','11:50:00',2.51),('1444','2013-09-22','11:55:00',2.53),('1444','2013-09-22','12:00:00',2.55),('1444','2013-09-22','12:05:00',2.57),('1444','2013-09-22','12:10:00',2.58),('1444','2013-09-22','12:15:00',2.58),('1444','2013-09-22','12:20:00',2.6),('1444','2013-09-22','12:25:00',2.63),('1444','2013-09-22','12:30:00',2.63),('1444','2013-09-22','12:35:00',2.62),('1444','2013-09-22','12:40:00',2.63),('1444','2013-09-22','12:45:00',2.64),('1444','2013-09-22','12:50:00',2.67),('1444','2013-09-22','12:55:00',2.69),('1444','2013-09-22','13:00:00',2.66),('1444','2013-09-22','13:05:00',2.64),('1444','2013-09-22','13:10:00',2.65),('1444','2013-09-22','13:15:00',2.63),('1444','2013-09-22','13:20:00',2.61),('1444','2013-09-22','13:25:00',2.59),('1444','2013-09-22','13:30:00',2.36),('1444','2013-09-22','13:35:00',2.59),('1444','2013-09-22','13:40:00',2.56),('1444','2013-09-22','13:45:00',2.56),('1444','2013-09-22','13:50:00',2.57),('1444','2013-09-22','13:55:00',2.55),('1444','2013-09-22','14:00:00',2.52),('1444','2013-09-22','14:05:00',2.52),('1444','2013-09-22','14:10:00',2.44),('1444','2013-09-22','14:15:00',2.51),('1444','2013-09-22','14:20:00',2.56),('1444','2013-09-22','14:25:00',2.68),('1444','2013-09-22','14:35:00',1.85),('1444','2013-09-22','14:40:00',2.47),('1444','2013-09-22','14:45:00',2.19),('1444','2013-09-22','14:50:00',2.3),('1444','2013-09-22','14:55:00',2.27),('1444','2013-09-22','15:00:00',2.3),('1444','2013-09-22','15:05:00',2.34),('1444','2013-09-22','15:10:00',2.28),('1444','2013-09-22','15:15:00',2.36),('1444','2013-09-22','15:20:00',2.53),('1444','2013-09-22','15:25:00',1.77),('1444','2013-09-22','15:30:00',1.13),('1444','2013-09-22','15:40:00',1.89),('1444','2013-09-22','15:45:00',1.97),('1444','2013-09-22','15:50:00',1.85),('1444','2013-09-22','15:55:00',1.84),('1444','2013-09-22','16:00:00',1.95),('1444','2013-09-22','16:05:00',2.08),('1444','2013-09-22','16:10:00',2.11),('1444','2013-09-22','16:15:00',1.97),('1444','2013-09-22','16:20:00',1.39),('1444','2013-09-22','16:25:00',1.08),('1444','2013-09-22','16:30:00',1.06),('1444','2013-09-22','16:35:00',1.02),('1444','2013-09-22','16:45:00',1.02),('1444','2013-09-22','16:50:00',1.68),('1444','2013-09-22','17:00:00',1.24),('1444','2013-09-22','17:05:00',1.2),('1444','2013-09-22','17:10:00',1.14),('1444','2013-09-21','09:00:00',1.04),('1444','2013-09-21','09:05:00',1.1),('1444','2013-09-21','09:10:00',1.16),('1444','2013-09-21','09:15:00',1.21),('1444','2013-09-21','09:20:00',1.26),('1444','2013-09-21','09:25:00',1.32),('1444','2013-09-21','09:30:00',1.37),('1444','2013-09-21','09:35:00',1.43),('1444','2013-09-21','09:40:00',1.46),('1444','2013-09-21','09:45:00',1.53),('1444','2013-09-21','09:50:00',1.58),('1444','2013-09-21','09:55:00',1.62),('1444','2013-09-21','10:00:00',1.65),('1444','2013-09-21','10:05:00',1.72),('1444','2013-09-21','10:10:00',1.77),('1444','2013-09-21','10:15:00',1.81),('1444','2013-09-21','10:20:00',1.85),('1444','2013-09-21','10:25:00',1.9),('1444','2013-09-21','10:30:00',1.95),('1444','2013-09-21','10:35:00',2),('1444','2013-09-21','10:40:00',2.03),('1444','2013-09-21','10:45:00',2.07),('1444','2013-09-21','10:50:00',2.1),('1444','2013-09-21','10:55:00',2.14),('1444','2013-09-21','11:00:00',2.18),('1444','2013-09-21','11:05:00',2.18),('1444','2013-09-21','11:10:00',2.21),('1444','2013-09-21','11:15:00',2.24),('1444','2013-09-21','11:20:00',2.28),('1444','2013-09-21','11:25:00',2.3),('1444','2013-09-21','11:30:00',2.33),('1444','2013-09-21','11:35:00',2.36),('1444','2013-09-21','11:40:00',2.41),('1444','2013-09-21','11:45:00',2.42),('1444','2013-09-21','11:50:00',2.45),('1444','2013-09-21','11:55:00',2.43),('1444','2013-09-21','12:00:00',2.46),('1444','2013-09-21','12:05:00',2.5),('1444','2013-09-21','12:10:00',2.5),('1444','2013-09-21','12:15:00',2.53),('1444','2013-09-21','12:20:00',2.41),('1444','2013-09-21','12:25:00',2.4),('1444','2013-09-21','12:30:00',2.59),('1444','2013-09-21','12:35:00',2.52),('1444','2013-09-21','12:40:00',2.45),('1444','2013-09-21','12:45:00',2.5),('1444','2013-09-21','12:50:00',2.52),('1444','2013-09-21','12:55:00',2.59),('1444','2013-09-21','13:00:00',2.59),('1444','2013-09-21','13:05:00',2.52),('1444','2013-09-21','13:10:00',2.55),('1444','2013-09-21','13:15:00',2.63),('1444','2013-09-21','13:20:00',2.25),('1444','2013-09-21','13:25:00',2.5),('1444','2013-09-21','13:30:00',2.49),('1444','2013-09-21','13:35:00',2.39),('1444','2013-09-21','13:40:00',2.27),('1444','2013-09-21','13:45:00',2.23),('1444','2013-09-21','13:50:00',2.12),('1444','2013-09-21','13:55:00',2.1),('1444','2013-09-21','14:00:00',2.32),('1444','2013-09-21','14:05:00',2.4),('1444','2013-09-21','14:10:00',2.36),('1444','2013-09-21','14:15:00',2.42),('1444','2013-09-21','14:20:00',2.39),('1444','2013-09-21','14:25:00',2.37),('1444','2013-09-21','14:30:00',2.33),('1444','2013-09-21','14:35:00',2.3),('1444','2013-09-21','14:40:00',2.27),('1444','2013-09-21','14:45:00',2.24),('1444','2013-09-21','14:50:00',2.21),('1444','2013-09-21','14:55:00',2.17),('1444','2013-09-21','15:00:00',2.15),('1444','2013-09-21','15:05:00',2.12),('1444','2013-09-21','15:10:00',2.07),('1444','2013-09-21','15:15:00',2.01),('1444','2013-09-21','15:20:00',2.01),('1444','2013-09-21','15:25:00',1.97),('1444','2013-09-21','15:30:00',1.92),('1444','2013-09-21','15:35:00',1.89),('1444','2013-09-21','15:40:00',1.76),('1444','2013-09-21','15:45:00',1.35),('1444','2013-09-21','15:50:00',1.77),('1444','2013-09-21','15:55:00',1.63),('1444','2013-09-21','16:00:00',1.21),('1444','2013-09-21','16:20:00',1.05),('1444','2013-09-20','09:55:00',1.2),('1444','2013-09-20','10:00:00',1.35),('1444','2013-09-20','10:05:00',1.26),('1444','2013-09-20','10:10:00',1.79),('1444','2013-09-20','10:15:00',2.14),('1444','2013-09-20','10:20:00',2.37),('1444','2013-09-20','10:25:00',2.27),('1444','2013-09-20','10:30:00',2.68),('1444','2013-09-20','10:35:00',2.41),('1444','2013-09-20','10:40:00',2.68),('1444','2013-09-20','10:45:00',1.98),('1444','2013-09-20','10:50:00',1.8),('1444','2013-09-20','10:55:00',1.4),('1444','2013-09-20','11:00:00',1.32),('1444','2013-09-20','11:05:00',1.46),('1444','2013-09-20','11:10:00',1.78),('1444','2013-09-20','11:15:00',1.77),('1444','2013-09-20','11:20:00',1.51),('1444','2013-09-20','11:25:00',1.45),('1444','2013-09-20','11:30:00',2.42),('1444','2013-09-20','11:35:00',1.76),('1444','2013-09-20','11:40:00',2.77),('1444','2013-09-20','11:45:00',2.71),('1444','2013-09-20','11:50:00',2.59),('1444','2013-09-20','11:55:00',2.52),('1444','2013-09-20','12:00:00',2.5),('1444','2013-09-20','12:05:00',2.53),('1444','2013-09-20','12:10:00',2.56),('1444','2013-09-20','12:15:00',2.63),('1444','2013-09-20','12:20:00',2.71),('1444','2013-09-20','12:25:00',2.36),('1444','2013-09-20','12:30:00',1.9),('1444','2013-09-20','12:35:00',2.09),('1444','2013-09-20','12:40:00',1.59),('1444','2013-09-20','12:45:00',1.39),('1444','2013-09-20','12:50:00',2.76),('1444','2013-09-20','12:55:00',2.67),('1444','2013-09-20','13:00:00',2.63),('1444','2013-09-20','13:05:00',2.58),('1444','2013-09-20','13:10:00',2.15),('1444','2013-09-20','13:15:00',1.9),('1444','2013-09-20','13:20:00',1.74),('1444','2013-09-20','13:25:00',1.84),('1444','2013-09-20','13:30:00',2.7),('1444','2013-09-20','13:35:00',2.65),('1444','2013-09-20','13:40:00',2.56),('1444','2013-09-20','13:45:00',2.57),('1444','2013-09-20','13:50:00',2.37),('1444','2013-09-20','13:55:00',1.9),('1444','2013-09-20','14:10:00',1.22),('1444','2013-09-20','14:15:00',2.62),('1444','2013-09-20','14:20:00',1.71),('1444','2013-09-20','14:25:00',1.67),('1444','2013-09-20','14:30:00',2.35),('1444','2013-09-20','14:35:00',2.18),('1444','2013-09-20','14:40:00',2.23),('1444','2013-09-20','14:45:00',2.43),('1444','2013-09-20','14:50:00',2.36),('1444','2013-09-20','14:55:00',2.33),('1444','2013-09-20','15:00:00',1.6),('1444','2013-09-20','15:05:00',2.46),('1444','2013-09-20','15:10:00',1.74),('1444','2013-09-20','15:15:00',1.59),('1444','2013-09-20','15:20:00',1.64),('1444','2013-09-20','15:25:00',1.25),('1444','2013-09-20','15:30:00',1.3),('1444','2013-09-20','15:35:00',1.97),('1444','2013-09-20','15:40:00',2.08),('1444','2013-09-20','15:45:00',1.97),('1444','2013-09-20','15:50:00',1.94),('1444','2013-09-20','15:55:00',1.96),('1444','2013-09-20','16:00:00',2.1),('1444','2013-09-20','16:05:00',1.39),('1444','2013-09-20','16:10:00',1.08),('1444','2013-09-20','16:15:00',1.35),('1444','2013-09-20','16:20:00',1.34),('1444','2013-09-20','16:25:00',1.66),('1444','2013-09-20','16:45:00',1.27),('1444','2013-09-20','16:50:00',1.61),('1444','2013-09-20','16:55:00',1.2),('1444','2013-09-20','17:00:00',1.13),('1444','2013-09-20','17:05:00',1.41),('1444','2013-09-20','17:10:00',1.47),('1444','2013-09-20','17:15:00',1.39),('1444','2013-09-20','17:20:00',1.38),('1444','2013-09-20','17:25:00',1.18),('1444','2013-09-19','09:10:00',1.14),('1444','2013-09-19','09:15:00',1.26),('1444','2013-09-19','10:05:00',1.93),('1444','2013-09-19','10:30:00',1.05),('1444','2013-09-19','10:35:00',2.62),('1444','2013-09-19','10:40:00',2.02),('1444','2013-09-19','10:45:00',1.76),('1444','2013-09-19','10:55:00',2.53),('1444','2013-09-19','11:00:00',2.65),('1444','2013-09-19','11:05:00',2.26),('1444','2013-09-19','11:10:00',1.98),('1444','2013-09-19','11:15:00',1.19),('1444','2013-09-19','11:20:00',1.45),('1444','2013-09-19','11:25:00',1.56),('1444','2013-09-19','11:30:00',2),('1444','2013-09-19','11:35:00',1.91),('1444','2013-09-19','11:40:00',1.39),('1444','2013-09-19','11:45:00',2.24),('1444','2013-09-19','11:50:00',2.74),('1444','2013-09-19','11:55:00',1.28),('1444','2013-09-19','12:00:00',1.12),('1444','2013-09-19','12:05:00',1.16),('1444','2013-09-19','12:10:00',2.23),('1444','2013-09-19','12:15:00',1.5),('1444','2013-09-19','12:20:00',2.4),('1444','2013-09-19','12:25:00',2.42),('1444','2013-09-19','12:30:00',2.79),('1444','2013-09-19','12:35:00',2.72),('1444','2013-09-19','12:40:00',2.86),('1444','2013-09-19','12:45:00',2.41),('1444','2013-09-19','12:50:00',2.82),('1444','2013-09-19','12:55:00',2.79),('1444','2013-09-19','13:00:00',2.78),('1444','2013-09-19','13:05:00',2.83),('1444','2013-09-19','13:10:00',2.95),('1444','2013-09-19','13:15:00',2.93),('1444','2013-09-19','13:20:00',2.94),('1444','2013-09-19','13:25:00',2.86),('1444','2013-09-19','13:30:00',2.71),('1444','2013-09-19','13:35:00',2.77),('1444','2013-09-19','13:40:00',2.92),('1444','2013-09-19','13:45:00',2.99),('1444','2013-09-19','13:50:00',2.52),('1444','2013-09-19','14:00:00',1.72),('1444','2013-09-19','14:05:00',2.81),('1444','2013-09-19','14:10:00',2.43),('1444','2013-09-19','14:15:00',2.34),('1444','2013-09-19','14:20:00',2.51),('1444','2013-09-19','14:25:00',2.47),('1444','2013-09-19','14:30:00',2.44),('1444','2013-09-19','14:35:00',2.43),('1444','2013-09-19','14:40:00',2.21),('1444','2013-09-19','14:45:00',2.33),('1444','2013-09-19','14:50:00',2.31),('1444','2013-09-19','14:55:00',2.35),('1444','2013-09-19','15:00:00',2.33),('1444','2013-09-19','15:05:00',2.23),('1444','2013-09-19','15:10:00',2.22),('1444','2013-09-19','15:15:00',1.74),('1444','2013-09-19','15:20:00',2.22),('1444','2013-09-19','15:25:00',2.2),('1444','2013-09-19','15:30:00',2.12),('1444','2013-09-19','15:35:00',2.07),('1444','2013-09-19','15:40:00',2.16),('1444','2013-09-19','15:45:00',2.04),('1444','2013-09-19','15:50:00',1.61),('1444','2013-09-19','15:55:00',1.72),('1444','2013-09-19','16:00:00',1.77),('1444','2013-09-19','16:05:00',1.73),('1444','2013-09-19','16:10:00',1.69),('1444','2013-09-19','16:15:00',1.57),('1444','2013-09-19','16:20:00',1.67),('1444','2013-09-19','16:25:00',1.54),('1444','2013-09-19','16:30:00',1.35),('1444','2013-09-19','16:35:00',1.3),('1444','2013-09-19','16:40:00',1.21),('1444','2013-09-19','16:45:00',1.27),('1444','2013-09-19','16:50:00',1.35),('1444','2013-09-19','16:55:00',1.26),('1444','2013-09-19','17:00:00',1.01),('1444','2013-09-19','17:05:00',1.03),('1444','2014-04-13','09:10:00',1.2),('1444','2014-04-13','09:15:00',1.01),('1444','2014-04-13','09:20:00',1.05),('1444','2014-04-13','09:25:00',1.17),('1444','2014-04-13','09:30:00',1.51),('1444','2014-04-13','09:35:00',1.32),('1444','2014-04-13','09:40:00',1.63),('1444','2014-04-13','09:45:00',1.57),('1444','2014-04-13','09:50:00',1.1),('1444','2014-04-13','09:55:00',1.14),('1444','2014-04-13','10:00:00',1.86),('1444','2014-04-13','10:05:00',2.66),('1444','2014-04-13','10:10:00',2.1),('1444','2014-04-13','10:15:00',1.88),('1444','2014-04-13','10:20:00',2),('1444','2014-04-13','10:25:00',1.44),('1444','2014-04-13','10:30:00',2.37),('1444','2014-04-13','10:35:00',2.63),('1444','2014-04-13','10:40:00',2.51),('1444','2014-04-13','10:45:00',2.75),('1444','2014-04-13','10:50:00',2.54),('1444','2014-04-13','10:55:00',2.78),('1444','2014-04-13','11:00:00',2.8),('1444','2014-04-13','11:05:00',2.89),('1444','2014-04-13','11:10:00',2.83),('1444','2014-04-13','11:15:00',2.96),('1444','2014-04-13','11:20:00',3.51),('1444','2014-04-13','11:25:00',2.36),('1444','2014-04-13','11:30:00',1.69),('1444','2014-04-13','11:35:00',2.62),('1444','2014-04-13','11:40:00',3.19),('1444','2014-04-13','11:45:00',2.73),('1444','2014-04-13','11:50:00',3.06),('1444','2014-04-13','11:55:00',2.41),('1444','2014-04-13','12:00:00',1.62),('1444','2014-04-13','12:05:00',1.36),('1444','2014-04-13','12:10:00',1.2),('1444','2014-04-13','12:15:00',1.15),('1444','2014-04-13','12:20:00',1.07),('1444','2014-04-13','13:05:00',1.02),('1444','2014-04-13','13:10:00',1.55),('1444','2014-04-13','13:15:00',1.59),('1444','2014-04-13','13:20:00',1.99),('1444','2014-04-13','13:25:00',2.33),('1444','2014-04-13','13:30:00',3.43),('1444','2014-04-13','13:35:00',3.11),('1444','2014-04-13','13:40:00',2.86),('1444','2014-04-13','13:45:00',1.63),('1444','2014-04-13','13:50:00',2.34),('1444','2014-04-13','13:55:00',2.04),('1444','2014-04-13','14:00:00',3.21),('1444','2014-04-13','14:05:00',3.01),('1444','2014-04-13','14:10:00',2.94),('1444','2014-04-13','14:15:00',3.41),('1444','2014-04-13','14:20:00',1.58),('1444','2014-04-13','14:25:00',1.34),('1444','2014-04-13','14:30:00',1.42),('1444','2014-04-13','14:35:00',1.28),('1444','2014-04-13','14:40:00',1.09),('1444','2014-04-13','14:45:00',1.82),('1444','2014-04-13','14:50:00',2.7),('1444','2014-04-13','14:55:00',2.72),('1444','2014-04-13','15:00:00',2.28),('1444','2014-04-13','15:05:00',2.85),('1444','2014-04-13','15:10:00',2.93),('1444','2014-04-13','15:15:00',2.49),('1444','2014-04-13','15:20:00',2.43),('1444','2014-04-13','15:25:00',2.68),('1444','2014-04-13','15:30:00',2.54),('1444','2014-04-13','15:35:00',1.7),('1444','2014-04-13','15:40:00',1.12),('1444','2014-04-13','15:45:00',1.07),('1444','2014-04-13','15:50:00',1.44),('1444','2014-04-13','15:55:00',1.37),('1444','2014-04-13','16:00:00',2.51),('1444','2014-04-13','16:05:00',2.25),('1444','2014-04-13','16:10:00',1.01),('1444','2014-04-13','16:20:00',1.02),('1444','2014-04-13','16:25:00',1.47),('1444','2014-04-13','16:30:00',1.22),('1444','2014-04-13','16:35:00',1.13),('1444','2014-04-13','16:40:00',1.6),('1444','2014-04-13','16:45:00',2.21),('1444','2014-04-13','16:50:00',1.89),('1444','2014-04-13','16:55:00',1.9),('1444','2014-04-13','17:00:00',1.33),('1444','2014-04-13','17:05:00',1.2),('1444','2014-04-13','17:20:00',1.19),('1444','2014-04-13','17:25:00',1.08),('1444','2013-09-18','09:00:00',1.17),('1444','2013-09-18','09:15:00',1.23),('1444','2013-09-18','09:20:00',1.56),('1444','2013-09-18','09:30:00',1.18),('1444','2013-09-18','09:35:00',1.14),('1444','2013-09-18','09:55:00',1.49),('1444','2013-09-18','10:00:00',1.83),('1444','2013-09-18','10:05:00',2.04),('1444','2013-09-18','10:10:00',1.9),('1444','2013-09-18','10:15:00',1.85),('1444','2013-09-18','10:20:00',1.89),('1444','2013-09-18','10:25:00',1.92),('1444','2013-09-18','10:30:00',1.96),('1444','2013-09-18','10:35:00',1.99),('1444','2013-09-18','10:40:00',2.02),('1444','2013-09-18','10:45:00',2.07),('1444','2013-09-18','10:50:00',2.13),('1444','2013-09-18','10:55:00',2.25),('1444','2013-09-18','11:00:00',2.28),('1444','2013-09-18','11:05:00',2.32),('1444','2013-09-18','11:10:00',1.7),('1444','2013-09-18','11:15:00',1.14),('1444','2013-09-18','11:20:00',2.34),('1444','2013-09-18','11:25:00',2.63),('1444','2013-09-18','11:30:00',2.37),('1444','2013-09-18','11:35:00',1.54),('1444','2013-09-18','11:40:00',2.07),('1444','2013-09-18','11:45:00',2.56),('1444','2013-09-18','11:50:00',2.54),('1444','2013-09-18','11:55:00',2.48),('1444','2013-09-18','12:00:00',2.59),('1444','2013-09-18','12:05:00',2.66),('1444','2013-09-18','12:10:00',2.67),('1444','2013-09-18','12:15:00',2.73),('1444','2013-09-18','12:20:00',2.77),('1444','2013-09-18','12:25:00',1.3),('1444','2013-09-18','12:30:00',2.02),('1444','2013-09-18','12:35:00',3.03),('1444','2013-09-18','12:40:00',2.34),('1444','2013-09-18','12:45:00',2.75),('1444','2013-09-18','12:50:00',1.75),('1444','2013-09-18','12:55:00',1.24),('1444','2013-09-18','13:00:00',1.02),('1444','2013-09-18','13:05:00',2.9),('1444','2013-09-18','13:10:00',2.81),('1444','2013-09-18','13:15:00',2.74),('1444','2013-09-18','13:20:00',2.71),('1444','2013-09-18','13:25:00',2.74),('1444','2013-09-18','13:30:00',2.7),('1444','2013-09-18','13:35:00',2.7),('1444','2013-09-18','13:40:00',2.74),('1444','2013-09-18','13:45:00',2.78),('1444','2013-09-18','13:50:00',2.83),('1444','2013-09-18','13:55:00',2.74),('1444','2013-09-18','14:00:00',2.08),('1444','2013-09-18','14:05:00',1.74),('1444','2013-09-18','14:10:00',2.61),('1444','2013-09-18','14:15:00',2.58),('1444','2013-09-18','14:20:00',2.54),('1444','2013-09-18','14:25:00',2.5),('1444','2013-09-18','14:30:00',2.37),('1444','2013-09-18','14:35:00',2.39),('1444','2013-09-18','14:40:00',2.43),('1444','2013-09-18','14:45:00',2.27),('1444','2013-09-18','14:50:00',2.36),('1444','2013-09-18','14:55:00',1.82),('1444','2013-09-18','15:00:00',1.82),('1444','2013-09-18','15:05:00',1.4),('1444','2013-09-18','15:10:00',1.05),('1444','2013-09-18','15:15:00',1.88),('1444','2013-09-18','15:20:00',1.59),('1444','2013-09-18','15:25:00',2.16),('1444','2013-09-18','15:30:00',1.94),('1444','2013-09-18','15:35:00',1.74),('1444','2013-09-18','15:40:00',2.05),('1444','2013-09-18','15:45:00',1.96),('1444','2013-09-18','15:50:00',1.42),('1444','2013-09-18','15:55:00',1.86),('1444','2013-09-18','16:00:00',1.95),('1444','2013-09-18','16:05:00',1.95),('1444','2013-09-18','16:10:00',1.77),('1444','2013-09-18','16:15:00',1.69),('1444','2013-09-18','16:20:00',1.6),('1444','2013-09-18','16:25:00',1.4),('1444','2013-09-18','16:30:00',1.35),('1444','2013-09-18','16:35:00',1.24),('1444','2013-09-18','16:40:00',1.29),('1444','2013-09-18','16:45:00',1.28),('1444','2013-09-18','16:50:00',1.13),('1444','2013-09-18','16:55:00',1.1),('1444','2013-09-18','17:00:00',1.15),('1444','2013-09-18','17:05:00',1.04),('1444','2013-09-18','17:10:00',1.04),('1444','2013-09-17','09:20:00',1.05),('1444','2013-09-17','09:45:00',1.37),('1444','2013-09-17','09:55:00',1.42),('1444','2013-09-17','10:00:00',1.56),('1444','2013-09-17','10:05:00',1.13),('1444','2013-09-17','10:10:00',1.17),('1444','2013-09-17','10:20:00',1.16),('1444','2013-09-17','10:25:00',1.73),('1444','2013-09-17','10:30:00',2.1),('1444','2013-09-17','10:35:00',1.13),('1444','2013-09-17','10:40:00',1.13),('1444','2013-09-17','10:45:00',1.69),('1444','2013-09-17','10:50:00',2.47),('1444','2013-09-17','10:55:00',2.01),('1444','2013-09-17','11:00:00',1.67),('1444','2013-09-17','11:05:00',1.71),('1444','2013-09-17','11:10:00',2.44),('1444','2013-09-17','11:15:00',2),('1444','2013-09-17','11:20:00',1.7),('1444','2013-09-17','11:25:00',1.17),('1444','2013-09-17','11:30:00',1.36),('1444','2013-09-17','11:35:00',2.18),('1444','2013-09-17','11:40:00',2.13),('1444','2013-09-17','11:45:00',1.97),('1444','2013-09-17','11:50:00',2.54),('1444','2013-09-17','11:55:00',2.36),('1444','2013-09-17','12:00:00',2.29),('1444','2013-09-17','12:05:00',2.18),('1444','2013-09-17','12:10:00',1.3),('1444','2013-09-17','12:15:00',1.29),('1444','2013-09-17','12:20:00',1.5),('1444','2013-09-17','12:25:00',2.83),('1444','2013-09-17','12:30:00',1.73),('1444','2013-09-17','12:35:00',1.84),('1444','2013-09-17','12:40:00',2.3),('1444','2013-09-17','12:45:00',3.16),('1444','2013-09-17','12:50:00',2.13),('1444','2013-09-17','12:55:00',2.17),('1444','2013-09-17','13:00:00',1.39),('1444','2013-09-17','13:10:00',2.08),('1444','2013-09-17','13:15:00',1.81),('1444','2013-09-17','13:20:00',1.67),('1444','2013-09-17','13:25:00',1.46),('1444','2013-09-17','13:30:00',1.07),('1444','2013-09-17','13:35:00',1.74),('1444','2013-09-17','13:40:00',1.63),('1444','2013-09-17','13:55:00',1.17),('1444','2013-09-17','14:00:00',1.3),('1444','2013-09-17','14:25:00',1.34),('1444','2013-09-17','14:50:00',1.39),('1444','2013-09-17','14:55:00',2.47),('1444','2013-09-17','15:00:00',2.09),('1444','2013-09-17','15:05:00',1.89),('1444','2013-09-17','15:10:00',1.62),('1444','2013-09-17','15:15:00',2.11),('1444','2013-09-17','15:20:00',2.06),('1444','2013-09-17','15:25:00',1.82),('1444','2013-09-17','15:30:00',1.85),('1444','2013-09-17','15:50:00',1.18),('1444','2013-09-17','15:55:00',1.36),('1444','2013-09-17','16:05:00',1.4),('1444','2013-09-17','16:10:00',1.2),('1444','2013-09-17','16:15:00',1.08),('1444','2013-09-17','16:45:00',1.09),('1444','2013-09-17','17:00:00',1.07),('1444','2013-09-17','17:05:00',1.19),('1444','2013-09-17','17:10:00',1.1),('1444','2013-09-17','17:15:00',1.08),('1444','2013-09-16','09:05:00',1.35),('1444','2013-09-16','09:10:00',1.01),('1444','2013-09-16','09:15:00',1.35),('1444','2013-09-16','09:20:00',1.38),('1444','2013-09-16','09:25:00',1.43),('1444','2013-09-16','09:35:00',1.52),('1444','2013-09-16','09:40:00',1.56),('1444','2013-09-16','09:45:00',1.64),('1444','2013-09-16','09:50:00',1.34),('1444','2013-09-16','09:55:00',1.78),('1444','2013-09-16','10:00:00',1.82),('1444','2013-09-16','10:05:00',1.96),('1444','2013-09-16','10:10:00',1.09),('1444','2013-09-16','10:15:00',1.21),('1444','2013-09-16','10:20:00',1.51),('1444','2013-09-16','10:25:00',1.92),('1444','2013-09-16','10:30:00',1.98),('1444','2013-09-16','10:35:00',2.33),('1444','2013-09-16','10:40:00',2.47),('1444','2013-09-16','10:45:00',2.69),('1444','2013-09-16','10:50:00',1.76),('1444','2013-09-16','10:55:00',1.32),('1444','2013-09-16','11:00:00',1.52),('1444','2013-09-16','11:05:00',1.45),('1444','2013-09-16','11:25:00',2.2),('1444','2013-09-16','11:30:00',1.04),('1444','2013-09-16','11:35:00',2.66),('1444','2013-09-16','11:40:00',2.67),('1444','2013-09-16','11:45:00',2.52),('1444','2013-09-16','11:50:00',2.69),('1444','2013-09-16','11:55:00',2.67),('1444','2013-09-16','12:00:00',2.75),('1444','2013-09-16','12:05:00',1.91),('1444','2013-09-16','12:10:00',2.59),('1444','2013-09-16','12:15:00',1.58),('1444','2013-09-16','12:20:00',2.78),('1444','2013-09-16','12:25:00',2.73),('1444','2013-09-16','12:30:00',2.7),('1444','2013-09-16','12:35:00',2.73),('1444','2013-09-16','12:40:00',2.85),('1444','2013-09-16','12:45:00',3.03),('1444','2013-09-16','12:50:00',3.28),('1444','2013-09-16','12:55:00',3.38),('1444','2013-09-16','13:00:00',3.35),('1444','2013-09-16','13:05:00',1.87),('1444','2013-09-16','13:10:00',3.01),('1444','2013-09-16','13:15:00',2.78),('1444','2013-09-16','13:20:00',2.72),('1444','2013-09-16','13:25:00',2.71),('1444','2013-09-16','13:30:00',2.68),('1444','2013-09-16','13:35:00',2.69),('1444','2013-09-16','13:40:00',2.68),('1444','2013-09-16','13:45:00',2.68),('1444','2013-09-16','13:50:00',2.7),('1444','2013-09-16','13:55:00',2.72),('1444','2013-09-16','14:00:00',2.69),('1444','2013-09-16','14:05:00',2.59),('1444','2013-09-16','14:10:00',2.56),('1444','2013-09-16','14:15:00',2.54),('1444','2013-09-16','14:20:00',2.5),('1444','2013-09-16','14:25:00',2.5),('1444','2013-09-16','14:30:00',2.47),('1444','2013-09-16','14:35:00',2.45),('1444','2013-09-16','14:40:00',2.42),('1444','2013-09-16','14:45:00',2.39),('1444','2013-09-16','14:50:00',2.38),('1444','2013-09-16','14:55:00',2.28),('1444','2013-09-16','15:00:00',2.32),('1444','2013-09-16','15:05:00',2.28),('1444','2013-09-16','15:10:00',2.25),('1444','2013-09-16','15:15:00',2.22),('1444','2013-09-16','15:20:00',2.17),('1444','2013-09-16','15:25:00',2.14),('1444','2013-09-16','15:30:00',2.09),('1444','2013-09-16','15:35:00',2.07),('1444','2013-09-16','15:40:00',2.04),('1444','2013-09-16','15:45:00',1.99),('1444','2013-09-16','15:50:00',1.95),('1444','2013-09-16','15:55:00',1.91),('1444','2013-09-16','16:00:00',1.84),('1444','2013-09-16','16:05:00',1.91),('1444','2013-09-16','16:10:00',1.8),('1444','2013-09-16','16:15:00',1.71),('1444','2013-09-16','16:20:00',1.65),('1444','2013-09-16','16:25:00',1.6),('1444','2013-09-16','16:30:00',1.55),('1444','2013-09-16','16:35:00',1.49),('1444','2013-09-16','16:40:00',1.45),('1444','2013-09-16','16:45:00',1.38),('1444','2013-09-16','16:50:00',1.33),('1444','2013-09-16','16:55:00',1.28),('1444','2013-09-16','17:00:00',1.22),('1444','2013-09-16','17:05:00',1.16),('1444','2013-09-16','17:10:00',1.09),('1444','2013-09-16','17:15:00',1.03),('1444','2013-09-15','08:45:00',1.02),('1444','2013-09-15','08:50:00',1.04),('1444','2013-09-15','08:55:00',1.01),('1444','2013-09-15','09:00:00',1.1),('1444','2013-09-15','09:05:00',1.12),('1444','2013-09-15','09:10:00',1.25),('1444','2013-09-15','09:15:00',1.36),('1444','2013-09-15','09:20:00',1.32),('1444','2013-09-15','09:25:00',1.41),('1444','2013-09-15','09:30:00',1.43),('1444','2013-09-15','09:35:00',1.54),('1444','2013-09-15','09:40:00',1.59),('1444','2013-09-15','09:45:00',1.62),('1444','2013-09-15','09:50:00',1.65),('1444','2013-09-15','09:55:00',1.73),('1444','2013-09-15','10:00:00',1.8),('1444','2013-09-15','10:05:00',1.86),('1444','2013-09-15','10:10:00',1.89),('1444','2013-09-15','10:15:00',1.88),('1444','2013-09-15','10:20:00',1.91),('1444','2013-09-15','10:25:00',1.94),('1444','2013-09-15','10:30:00',1.88),('1444','2013-09-15','10:55:00',2.28),('1444','2013-09-15','11:00:00',2.55),('1444','2013-09-15','11:05:00',2.22),('1444','2013-09-15','11:10:00',1.08),('1444','2013-09-15','11:20:00',1.15),('1444','2013-09-15','11:30:00',1.79),('1444','2013-09-15','11:35:00',1.35),('1444','2013-09-15','11:40:00',1.08),('1444','2013-09-15','11:45:00',1.67),('1444','2013-09-15','11:50:00',1.18),('1444','2013-09-15','11:55:00',1.18),('1444','2013-09-15','12:20:00',1.19),('1444','2013-09-15','12:25:00',1.25),('1444','2013-09-15','12:30:00',1.16),('1444','2013-09-15','12:35:00',1.07),('1444','2013-09-15','12:40:00',1.09),('1444','2013-09-15','12:50:00',1.11),('1444','2013-09-15','13:45:00',1.31),('1444','2013-09-15','13:50:00',1.16),('1444','2013-09-15','14:00:00',1.4),('1444','2013-09-15','14:05:00',1.27),('1444','2013-09-15','14:10:00',1.09),('1444','2013-09-15','14:15:00',1.08),('1444','2013-09-15','14:20:00',1.05),('1444','2013-09-15','14:25:00',1.02),('1444','2013-09-15','15:10:00',1.01),('1444','2013-09-15','15:15:00',2.09),('1444','2013-09-15','15:20:00',1.45),('1444','2013-09-15','15:25:00',1.08),('1444','2013-09-14','08:50:00',1.03),('1444','2013-09-14','08:55:00',1.09),('1444','2013-09-14','09:00:00',1.14),('1444','2013-09-14','09:05:00',1.2),('1444','2013-09-14','09:10:00',1.26),('1444','2013-09-14','09:15:00',1.32),('1444','2013-09-14','09:20:00',1.37),('1444','2013-09-14','09:25:00',1.43),('1444','2013-09-14','09:30:00',1.49),('1444','2013-09-14','09:35:00',1.52),('1444','2013-09-14','09:40:00',1.58),('1444','2013-09-14','09:45:00',1.61),('1444','2013-09-14','09:50:00',1.67),('1444','2013-09-14','10:00:00',1.78),('1444','2013-09-14','10:05:00',1.79),('1444','2013-09-14','10:10:00',1.68),('1444','2013-09-14','10:15:00',1.7),('1444','2013-09-14','10:20:00',1.85),('1444','2013-09-14','10:25:00',1.97),('1444','2013-09-14','10:30:00',2.02),('1444','2013-09-14','10:35:00',2.18),('1444','2013-09-14','10:40:00',2.18),('1444','2013-09-14','10:45:00',1.94),('1444','2013-09-14','10:50:00',2.13),('1444','2013-09-14','10:55:00',1.88),('1444','2013-09-14','11:00:00',2.1),('1444','2013-09-14','11:05:00',1.35),('1444','2013-09-14','11:10:00',1.64),('1444','2013-09-14','11:20:00',1.31),('1444','2013-09-14','11:25:00',2.48),('1444','2013-09-14','11:30:00',2.19),('1444','2013-09-14','11:35:00',1.63),('1444','2013-09-14','11:40:00',2.51),('1444','2013-09-14','11:45:00',2.66),('1444','2013-09-14','12:10:00',1.16),('1444','2013-09-14','12:35:00',1.77),('1444','2013-09-14','13:10:00',1.4),('1444','2013-09-14','13:15:00',2.96),('1444','2013-09-14','13:20:00',2.14),('1444','2013-09-14','13:25:00',2.97),('1444','2013-09-14','13:30:00',1.76),('1444','2013-09-14','13:35:00',1.11),('1444','2013-09-14','13:40:00',2.84),('1444','2013-09-14','13:45:00',1.52),('1444','2013-09-14','13:50:00',2.42),('1444','2013-09-14','13:55:00',2.91),('1444','2013-09-14','14:00:00',2.84),('1444','2013-09-14','14:05:00',2.66),('1444','2013-09-14','14:10:00',2.6),('1444','2013-09-14','14:15:00',2.6),('1444','2013-09-14','14:20:00',2.51),('1444','2013-09-14','14:25:00',2.57),('1444','2013-09-14','14:30:00',2.53),('1444','2013-09-14','14:35:00',2.47),('1444','2013-09-14','14:40:00',2.49),('1444','2013-09-14','14:45:00',2.43),('1444','2013-09-14','14:50:00',2.41),('1444','2013-09-14','14:55:00',2.38),('1444','2013-09-14','15:00:00',2.31),('1444','2013-09-14','15:05:00',2.28),('1444','2013-09-14','15:10:00',2.25),('1444','2013-09-14','15:15:00',2.22),('1444','2013-09-14','15:20:00',2.19),('1444','2013-09-14','15:25:00',1.4),('1444','2013-09-14','15:30:00',2.17),('1444','2013-09-14','15:35:00',2.08),('1444','2013-09-14','15:40:00',2.04),('1444','2013-09-14','15:45:00',1.98),('1444','2013-09-14','15:50:00',1.94),('1444','2013-09-14','15:55:00',1.89),('1444','2013-09-14','16:00:00',1.84),('1444','2013-09-14','16:05:00',1.79),('1444','2013-09-14','16:10:00',1.73),('1444','2013-09-14','16:15:00',1.7),('1444','2013-09-14','16:20:00',1.64),('1444','2013-09-14','16:25:00',1.61),('1444','2013-09-14','16:30:00',1.56),('1444','2013-09-14','16:35:00',1.49),('1444','2013-09-14','16:40:00',1.43),('1444','2013-09-14','16:45:00',1.39),('1444','2013-09-14','16:50:00',1.34),('1444','2013-09-14','16:55:00',1.29),('1444','2013-09-14','17:00:00',1.25),('1444','2013-09-14','17:05:00',1.18),('1444','2013-09-14','17:10:00',1.03),('1444','2013-09-14','17:20:00',1.01),('1444','2013-09-13','09:40:00',1),('1444','2013-09-13','09:50:00',1.34),('1444','2013-09-13','09:55:00',2.1),('1444','2013-09-13','10:00:00',1.24),('1444','2013-09-13','10:05:00',1.05),('1444','2013-09-13','10:10:00',1.61),('1444','2013-09-13','10:15:00',2.55),('1444','2013-09-13','10:20:00',2.18),('1444','2013-09-13','10:25:00',1.21),('1444','2013-09-13','10:30:00',1.92),('1444','2013-09-13','10:35:00',2.04),('1444','2013-09-13','10:40:00',2.12),('1444','2013-09-13','10:45:00',2.2),('1444','2013-09-13','10:50:00',2.22),('1444','2013-09-13','10:55:00',2.25),('1444','2013-09-13','11:00:00',2.29),('1444','2013-09-13','11:05:00',2.32),('1444','2013-09-13','11:10:00',2.34),('1444','2013-09-13','11:15:00',2.37),('1444','2013-09-13','11:20:00',2.42),('1444','2013-09-13','11:25:00',2.44),('1444','2013-09-13','11:30:00',2.46),('1444','2013-09-13','11:35:00',2.5),('1444','2013-09-13','11:40:00',2.51),('1444','2013-09-13','11:45:00',2.52),('1444','2013-09-13','11:50:00',2.56),('1444','2013-09-13','11:55:00',2.54),('1444','2013-09-13','12:00:00',2.58),('1444','2013-09-13','12:05:00',2.66),('1444','2013-09-13','12:10:00',2.63),('1444','2013-09-13','12:15:00',2.66),('1444','2013-09-13','12:20:00',2.69),('1444','2013-09-13','12:25:00',2.71),('1444','2013-09-13','12:30:00',2.74),('1444','2013-09-13','12:35:00',2.74),('1444','2013-09-13','12:40:00',2.78),('1444','2013-09-13','12:45:00',2.79),('1444','2013-09-13','12:50:00',2.81),('1444','2013-09-13','12:55:00',2.76),('1444','2013-09-13','13:00:00',2.74),('1444','2013-09-13','13:05:00',2.73),('1444','2013-09-13','13:10:00',2.69),('1444','2013-09-13','13:15:00',2.7),('1444','2013-09-13','13:20:00',2.69),('1444','2013-09-13','13:25:00',2.67),('1444','2013-09-13','13:30:00',2.66),('1444','2013-09-13','13:36:00',2.66),('1444','2013-09-13','13:40:00',2.64),('1444','2013-09-13','13:45:00',2.62),('1444','2013-09-13','13:50:00',2.59),('1444','2013-09-13','13:56:00',2.57),('1444','2013-09-13','14:00:00',2.55),('1444','2013-09-13','14:12:00',2.55),('1444','2013-09-13','14:15:00',2.56),('1444','2013-09-13','14:20:00',2.57),('1444','2013-09-13','14:26:00',2.2),('1444','2013-09-13','14:35:00',1.7),('1444','2013-09-13','14:47:00',2.52),('1444','2013-09-13','14:50:00',2.44),('1444','2013-09-13','14:56:00',2.4),('1444','2013-09-13','15:00:00',2.35),('1444','2013-09-13','15:05:00',2.33),('1444','2013-09-13','15:10:00',2.3),('1444','2013-09-13','15:15:00',2.25),('1444','2013-09-13','15:20:00',2.24),('1444','2013-09-13','15:25:00',2.17),('1444','2013-09-13','15:30:00',2.15),('1444','2013-09-13','15:35:00',2.11),('1444','2013-09-13','15:40:00',2.08),('1444','2013-09-13','15:45:00',2.03),('1444','2013-09-13','15:50:00',1.99),('1444','2013-09-13','15:55:00',1.94),('1444','2013-09-13','16:00:00',1.86),('1444','2013-09-13','16:05:00',1.84),('1444','2013-09-13','16:10:00',1.79),('1444','2013-09-13','16:15:00',1.74),('1444','2013-09-13','16:20:00',1.7),('1444','2013-09-13','16:25:00',1.66),('1444','2013-09-13','16:30:00',1.58),('1444','2013-09-13','16:35:00',1.52),('1444','2013-09-13','16:40:00',1.48),('1444','2013-09-13','16:45:00',1.43),('1444','2013-09-13','16:50:00',1.36),('1444','2013-09-13','16:55:00',1.31),('1444','2013-09-13','17:00:00',1.24),('1444','2013-09-13','17:05:00',1.18),('1444','2013-09-13','17:10:00',1.13),('1444','2013-09-13','17:15:00',1.07),('1444','2013-09-13','17:20:00',1.01),('1444','2013-09-12','08:30:00',1.07),('1444','2013-09-12','08:35:00',1.04),('1444','2013-09-12','09:00:00',1.12),('1444','2013-09-12','09:05:00',1.05),('1444','2013-09-12','09:15:00',1.34),('1444','2013-09-12','09:20:00',1.37),('1444','2013-09-12','09:25:00',1.46),('1444','2013-09-12','09:30:00',1.47),('1444','2013-09-12','09:35:00',1.36),('1444','2013-09-12','09:40:00',1.16),('1444','2013-09-12','09:45:00',1.57),('1444','2013-09-12','09:50:00',1.55),('1444','2013-09-12','10:05:00',1.05),('1444','2013-09-12','10:10:00',1.24),('1444','2013-09-12','10:15:00',1.3),('1444','2013-09-12','10:30:00',1.5),('1444','2013-09-12','10:35:00',1.3),('1444','2013-09-12','10:55:00',1.43),('1444','2013-09-12','11:00:00',1.68),('1444','2013-09-12','11:05:00',2.43),('1444','2013-09-12','11:10:00',1.83),('1444','2013-09-12','11:15:00',1.59),('1444','2013-09-12','11:20:00',1.33),('1444','2013-09-12','11:45:00',1.74),('1444','2013-09-12','11:50:00',1.15),('1444','2013-09-12','11:55:00',1),('1444','2013-09-12','12:00:00',2),('1444','2013-09-12','12:05:00',2.29),('1444','2013-09-12','12:10:00',1.66),('1444','2013-09-12','12:15:00',1.37),('1444','2013-09-12','12:25:00',1.15),('1444','2013-09-12','12:35:00',2.09),('1444','2013-09-12','12:40:00',1.59),('1444','2013-09-12','12:55:00',1.67),('1444','2013-09-12','13:00:00',2.48),('1444','2013-09-12','13:05:00',1.38),('1444','2013-09-12','13:10:00',2.24),('1444','2013-09-12','13:15:00',2.7),('1444','2013-09-12','13:20:00',3.1),('1444','2013-09-12','13:25:00',2.73),('1444','2013-09-12','13:30:00',2.34),('1444','2013-09-12','13:35:00',1.38),('1444','2013-09-12','13:40:00',1.8),('1444','2013-09-12','13:45:00',1.6),('1444','2013-09-12','13:50:00',2.46),('1444','2013-09-12','13:55:00',2.77),('1444','2013-09-12','14:00:00',2.19),('1444','2013-09-12','14:05:00',2.61),('1444','2013-09-12','14:10:00',2.67),('1444','2013-09-12','14:15:00',2.29),('1444','2013-09-12','14:20:00',2.66),('1444','2013-09-12','14:25:00',2.44),('1444','2013-09-12','14:30:00',2.72),('1444','2013-09-12','14:35:00',1.18),('1444','2013-09-12','14:40:00',2.33),('1444','2013-09-12','14:45:00',2.5),('1444','2013-09-12','14:50:00',2.5),('1444','2013-09-12','14:55:00',2.45),('1444','2013-09-12','15:00:00',1.85),('1444','2013-09-12','15:05:00',1.7),('1444','2013-09-12','15:10:00',2.43),('1444','2013-09-12','15:15:00',2.35),('1444','2013-09-12','15:20:00',2.25),('1444','2013-09-12','15:25:00',2.23),('1444','2013-09-12','15:30:00',2.2),('1444','2013-09-12','15:35:00',2.14),('1444','2013-09-12','15:40:00',2.12),('1444','2013-09-12','15:45:00',2.09),('1444','2013-09-12','15:50:00',2.05),('1444','2013-09-12','15:55:00',2.02),('1444','2013-09-12','16:00:00',1.95),('1444','2013-09-12','16:05:00',1.53),('1444','2013-09-12','16:10:00',1.98),('1444','2013-09-12','16:15:00',1.19),('1444','2013-09-12','16:20:00',1.63),('1444','2013-09-12','16:25:00',1.33),('1444','2013-09-12','16:30:00',1.83),('1444','2013-09-12','16:35:00',1.09),('1444','2013-09-12','16:40:00',1.81),('1444','2013-09-12','16:45:00',1.1),('1444','2013-09-12','17:00:00',1.44),('1444','2013-09-12','17:05:00',1.46),('1444','2013-09-12','17:10:00',1.28),('1444','2013-09-12','17:30:00',1.06),('1444','2013-09-11','09:00:00',1.1),('1444','2013-09-11','09:05:00',1.22),('1444','2013-09-11','09:10:00',1.16),('1444','2013-09-11','09:15:00',1.57),('1444','2013-09-11','09:20:00',1.67),('1444','2013-09-11','09:25:00',1.05),('1444','2013-09-11','09:35:00',1.6),('1444','2013-09-11','10:00:00',1.22),('1444','2013-09-11','10:05:00',1.24),('1444','2013-09-11','10:15:00',1.91),('1444','2013-09-11','10:20:00',1.09),('1444','2013-09-11','10:25:00',1.83),('1444','2013-09-11','10:30:00',2.15),('1444','2013-09-11','10:35:00',2.29),('1444','2013-09-11','10:40:00',2.01),('1444','2013-09-11','10:45:00',2.45),('1444','2013-09-11','10:50:00',1.41),('1444','2013-09-11','10:55:00',1.68),('1444','2013-09-11','11:00:00',1.02),('1444','2013-09-11','11:05:00',2.87),('1444','2013-09-11','11:10:00',2.25),('1444','2013-09-11','11:15:00',2.46),('1444','2013-09-11','11:20:00',2.34),('1444','2013-09-11','11:25:00',1.33),('1444','2013-09-11','11:40:00',2.68),('1444','2013-09-11','11:45:00',2.66),('1444','2013-09-11','11:50:00',2.67),('1444','2013-09-11','11:55:00',2.5),('1444','2013-09-11','12:00:00',2.48),('1444','2013-09-11','12:05:00',1.86),('1444','2013-09-11','12:10:00',2.31),('1444','2013-09-11','12:15:00',1.75),('1444','2013-09-11','12:20:00',2.28),('1444','2013-09-11','12:25:00',2.21),('1444','2013-09-11','12:30:00',1.32),('1444','2013-09-11','12:35:00',2.38),('1444','2013-09-11','12:40:00',2.6),('1444','2013-09-11','12:45:00',2.78),('1444','2013-09-11','12:50:00',3.01),('1444','2013-09-11','13:00:00',2.83),('1444','2013-09-11','13:05:00',2.83),('1444','2013-09-11','13:10:00',2.87),('1444','2013-09-11','13:15:00',2.94),('1444','2013-09-11','13:20:00',2.41),('1444','2013-09-11','13:25:00',2.34),('1444','2013-09-11','13:30:00',1.82),('1444','2013-09-11','13:35:00',3.12),('1444','2013-09-11','13:40:00',1.7),('1444','2013-09-11','13:45:00',2.84),('1444','2013-09-11','13:50:00',2.56),('1444','2013-09-11','13:55:00',1.9),('1444','2013-09-11','14:00:00',2.6),('1444','2013-09-11','14:05:00',2.53),('1444','2013-09-11','14:10:00',2.22),('1444','2013-09-11','14:15:00',2.54),('1444','2013-09-11','14:20:00',1.97),('1444','2013-09-11','14:25:00',1.94),('1444','2013-09-11','14:30:00',1.7),('1444','2013-09-11','14:35:00',1.55),('1444','2013-09-11','14:40:00',1.26),('1444','2013-09-11','14:45:00',2.36),('1444','2013-09-11','14:50:00',1.63),('1444','2013-09-11','14:55:00',1.75),('1444','2013-09-11','15:00:00',2.71),('1444','2013-09-11','15:05:00',1.6),('1444','2013-09-11','15:10:00',1.84),('1444','2013-09-11','15:15:00',2.56),('1444','2013-09-11','15:20:00',1.64),('1444','2013-09-11','15:25:00',1.05),('1444','2013-09-11','15:30:00',1.57),('1444','2013-09-11','15:45:00',1.97),('1444','2013-09-11','15:50:00',1.76),('1444','2013-09-11','15:55:00',2.16),('1444','2013-09-11','16:00:00',1.76),('1444','2013-09-11','16:05:00',2.1),('1444','2013-09-11','16:10:00',1.94),('1444','2013-09-11','16:15:00',1.82),('1444','2013-09-11','16:20:00',1.45),('1444','2013-09-11','16:25:00',1),('1444','2013-09-11','16:30:00',1.24),('1444','2013-09-11','16:35:00',1.32),('1444','2013-09-11','16:40:00',1.38),('1444','2013-09-11','16:45:00',1.39),('1444','2013-09-11','16:50:00',1.44),('1444','2013-09-11','16:55:00',1.04),('1444','2013-09-11','17:00:00',1.36),('1444','2013-09-11','17:05:00',1.25),('1444','2013-09-11','17:10:00',1.18),('1444','2013-09-11','17:15:00',1.1),('1444','2013-09-10','08:55:00',1.07),('1444','2013-09-10','09:00:00',1.11),('1444','2013-09-10','09:05:00',1.31),('1444','2013-09-10','09:10:00',1.53),('1444','2013-09-10','09:15:00',1.27),('1444','2013-09-10','09:20:00',1.02),('1444','2013-09-10','09:25:00',1.06),('1444','2013-09-10','09:30:00',1.79),('1444','2013-09-10','09:35:00',1.88),('1444','2013-09-10','09:40:00',1.16),('1444','2013-09-10','10:40:00',1.09),('1444','2013-09-10','10:45:00',1.4),('1444','2013-09-10','11:00:00',1.13),('1444','2013-09-10','11:55:00',1.05),('1444','2013-09-10','13:40:00',1.31),('1444','2013-09-10','13:45:00',1.9),('1444','2013-09-10','13:50:00',1.24),('1444','2013-09-10','13:55:00',1.05),('1444','2013-09-10','14:15:00',1.11),('1444','2013-09-10','14:20:00',1.1),('1444','2013-09-10','14:25:00',1.52),('1444','2013-09-10','14:30:00',1.3),('1444','2013-09-10','14:35:00',1.02),('1444','2013-09-10','14:40:00',1.24),('1444','2013-09-10','14:45:00',1.3),('1444','2013-09-10','14:50:00',1.47),('1444','2013-09-10','14:55:00',1.28),('1444','2013-09-10','15:00:00',1.77),('1444','2013-09-10','15:05:00',1.5),('1444','2013-09-10','15:10:00',1.13),('1444','2013-09-10','15:15:00',1.13),('1444','2013-09-10','15:20:00',1.33),('1444','2013-09-10','15:25:00',1.2),('1444','2013-09-10','15:30:00',1.41),('1444','2013-09-10','15:35:00',1.14),('1444','2013-09-09','10:00:00',1.09),('1444','2013-09-09','10:05:00',1.25),('1444','2013-09-09','10:10:00',1.22),('1444','2013-09-09','10:15:00',1.17),('1444','2013-09-09','10:20:00',1.15),('1444','2013-09-09','10:25:00',1.17),('1444','2013-09-09','10:30:00',1.1),('1444','2013-09-09','10:35:00',1.17),('1444','2013-09-09','10:40:00',1.22),('1444','2013-09-09','10:45:00',1.38),('1444','2013-09-09','10:50:00',1.72),('1444','2013-09-09','10:55:00',1.69),('1444','2013-09-09','11:00:00',1.86),('1444','2013-09-09','11:05:00',1.61),('1444','2013-09-09','11:10:00',1.48),('1444','2013-09-09','11:15:00',1.47),('1444','2013-09-09','11:20:00',1.55),('1444','2013-09-09','11:25:00',1.73),('1444','2013-09-09','11:30:00',1.48),('1444','2013-09-09','11:35:00',1.6),('1444','2013-09-09','11:40:00',2.13),('1444','2013-09-09','11:45:00',2.32),('1444','2013-09-09','11:50:00',2.49),('1444','2013-09-09','11:55:00',2.27),('1444','2013-09-09','12:00:00',2.05),('1444','2013-09-09','12:05:00',2.05),('1444','2013-09-09','12:10:00',1.68),('1444','2013-09-09','12:15:00',1.41),('1444','2013-09-09','12:20:00',1.01),('1444','2013-09-09','12:40:00',1.19),('1444','2013-09-09','12:45:00',1.06),('1444','2013-09-09','12:55:00',1.38),('1444','2013-09-09','13:00:00',1.32),('1444','2013-09-09','13:05:00',1.63),('1444','2013-09-09','13:10:00',1.82),('1444','2013-09-09','13:15:00',1.92),('1444','2013-09-09','13:20:00',1.85),('1444','2013-09-09','13:25:00',2.11),('1444','2013-09-09','13:30:00',2.39),('1444','2013-09-09','13:35:00',2.54),('1444','2013-09-09','13:40:00',2.14),('1444','2013-09-09','13:45:00',2.69),('1444','2013-09-09','13:50:00',2.52),('1444','2013-09-09','13:55:00',2.53),('1444','2013-09-09','14:00:00',2.4),('1444','2013-09-09','14:05:00',2.06),('1444','2013-09-09','14:10:00',2.13),('1444','2013-09-09','14:15:00',1.32),('1444','2013-09-09','14:20:00',1.24),('1444','2013-09-09','14:25:00',1.06),('1444','2013-09-09','14:30:00',2.04),('1444','2013-09-09','14:35:00',2.5),('1444','2013-09-09','14:40:00',2.21),('1444','2013-09-09','14:45:00',1.98),('1444','2013-09-09','14:50:00',2.2),('1444','2013-09-09','14:55:00',1.71),('1444','2013-09-09','15:00:00',1.55),('1444','2013-09-09','15:05:00',1.73),('1444','2013-09-09','15:10:00',1.58),('1444','2013-09-09','15:20:00',1.6),('1444','2013-09-09','15:25:00',1.02),('1444','2013-09-09','15:30:00',2.02),('1444','2013-09-09','15:35:00',1.68),('1444','2013-09-09','15:40:00',1.35),('1444','2013-09-09','15:50:00',1.03),('1444','2013-09-09','15:55:00',1.21),('1444','2013-09-09','16:00:00',1.42),('1444','2013-09-09','16:10:00',1.3),('1444','2013-09-09','16:15:00',1.54),('1444','2013-09-09','16:20:00',1.25),('1444','2013-09-09','16:45:00',1.4),('1444','2014-04-12','09:15:00',1.26),('1444','2014-04-12','09:20:00',1.81),('1444','2014-04-12','09:25:00',1.77),('1444','2014-04-12','09:30:00',1.28),('1444','2014-04-12','09:35:00',1.09),('1444','2014-04-12','09:50:00',1.07),('1444','2014-04-12','09:55:00',1.02),('1444','2014-04-12','10:00:00',1.04),('1444','2014-04-12','10:05:00',1.09),('1444','2014-04-12','10:10:00',1.2),('1444','2014-04-12','10:15:00',1.34),('1444','2014-04-12','10:20:00',1.41),('1444','2014-04-12','10:25:00',1.48),('1444','2014-04-12','10:30:00',1.67),('1444','2014-04-12','10:35:00',1.76),('1444','2014-04-12','10:40:00',1.78),('1444','2014-04-12','10:45:00',2.03),('1444','2014-04-12','10:50:00',2.11),('1444','2014-04-12','10:55:00',2.05),('1444','2014-04-12','11:00:00',2.15),('1444','2014-04-12','11:05:00',1.71),('1444','2014-04-12','11:10:00',2.7),('1444','2014-04-12','11:15:00',2.3),('1444','2014-04-12','11:20:00',2.48),('1444','2014-04-12','11:25:00',2.7),('1444','2014-04-12','11:30:00',2.75),('1444','2014-04-12','11:35:00',2.97),('1444','2014-04-12','11:40:00',2.79),('1444','2014-04-12','11:45:00',2.56),('1444','2014-04-12','11:50:00',2.11),('1444','2014-04-12','11:55:00',1.65),('1444','2014-04-12','12:00:00',1.45),('1444','2014-04-12','12:05:00',1.22),('1444','2014-04-12','12:10:00',1.24),('1444','2014-04-12','12:15:00',1.8),('1444','2014-04-12','12:20:00',2.16),('1444','2014-04-12','12:25:00',1.44),('1444','2014-04-12','12:30:00',1.71),('1444','2014-04-12','12:35:00',2.02),('1444','2014-04-12','12:40:00',2.23),('1444','2014-04-12','12:45:00',1.87),('1444','2014-04-12','12:50:00',1.47),('1444','2014-04-12','12:55:00',1.75),('1444','2014-04-12','13:00:00',1.66),('1444','2014-04-12','13:05:00',1.34),('1444','2014-04-12','13:10:00',1.73),('1444','2014-04-12','13:15:00',1.91),('1444','2014-04-12','13:20:00',2.48),('1444','2014-04-12','13:25:00',3.06),('1444','2014-04-12','13:30:00',1.15),('1444','2014-04-12','13:35:00',1.6),('1444','2014-04-12','13:40:00',1.54),('1444','2014-04-12','13:45:00',2.39),('1444','2014-04-12','13:50:00',1.46),('1444','2014-04-12','13:55:00',2.96),('1444','2014-04-12','14:00:00',2.98),('1444','2014-04-12','14:05:00',2.02),('1444','2014-04-12','14:10:00',1.05),('1444','2014-04-12','14:15:00',1.82),('1444','2014-04-12','14:20:00',2.99),('1444','2014-04-12','14:25:00',1.39),('1444','2014-04-12','14:30:00',2.01),('1444','2014-04-12','14:35:00',2.02),('1444','2014-04-12','14:40:00',2.01),('1444','2014-04-12','14:45:00',1.92),('1444','2014-04-12','14:50:00',2.44),('1444','2014-04-12','14:55:00',2.16),('1444','2014-04-12','15:00:00',2.4),('1444','2014-04-12','15:05:00',2.61),('1444','2014-04-12','15:10:00',2.75),('1444','2014-04-12','15:15:00',2.66),('1444','2014-04-12','15:20:00',2.07),('1444','2014-04-12','15:25:00',2.07),('1444','2014-04-12','15:30:00',1.85),('1444','2014-04-12','15:35:00',1.53),('1444','2014-04-12','15:40:00',1.71),('1444','2014-04-12','15:45:00',2.21),('1444','2014-04-12','15:50:00',2.5),('1444','2014-04-12','15:55:00',2.51),('1444','2014-04-12','16:00:00',2.47),('1444','2014-04-12','16:05:00',2.42),('1444','2014-04-12','16:10:00',2.29),('1444','2014-04-12','16:15:00',2.38),('1444','2014-04-12','16:20:00',2.4),('1444','2014-04-12','16:25:00',2.15),('1444','2014-04-12','16:30:00',2.03),('1444','2014-04-12','16:35:00',1.59),('1444','2014-04-12','16:40:00',1.62),('1444','2014-04-12','16:45:00',1.52),('1444','2014-04-12','16:50:00',1.17),('1444','2014-04-12','16:55:00',1.84),('1444','2014-04-12','17:00:00',1.68),('1444','2014-04-12','17:05:00',1.56),('1444','2014-04-12','17:10:00',1.54),('1444','2014-04-12','17:15:00',1.5),('1444','2014-04-12','17:20:00',1.22),('1444','2014-04-12','17:25:00',1.37),('1444','2014-04-12','17:30:00',1.29),('1444','2014-04-12','17:35:00',1.13),('1444','2014-04-12','17:40:00',1.42),('1444','2014-04-12','17:45:00',1.39),('1444','2014-04-12','17:50:00',1.27),('1444','2014-04-12','17:55:00',1.04),('1444','2013-09-08','09:20:00',1.21),('1444','2013-09-08','09:25:00',1.28),('1444','2013-09-08','09:30:00',1.09),('1444','2013-09-08','09:35:00',1.15),('1444','2013-09-08','09:40:00',1.07),('1444','2013-09-08','09:45:00',1.25),('1444','2013-09-08','09:50:00',1.6),('1444','2013-09-08','09:55:00',1.62),('1444','2013-09-08','10:00:00',1.66),('1444','2013-09-08','10:05:00',1.71),('1444','2013-09-08','10:10:00',1.64),('1444','2013-09-08','10:15:00',1.76),('1444','2013-09-08','10:20:00',1.82),('1444','2013-09-08','10:25:00',1.88),('1444','2013-09-08','10:30:00',1.91),('1444','2013-09-08','10:35:00',1.96),('1444','2013-09-08','10:40:00',1.88),('1444','2013-09-08','10:45:00',1.98),('1444','2013-09-08','10:50:00',1.99),('1444','2013-09-08','10:55:00',1.97),('1444','2013-09-08','11:00:00',2.09),('1444','2013-09-08','11:05:00',2.12),('1444','2013-09-08','11:10:00',2.15),('1444','2013-09-08','11:15:00',2.2),('1444','2013-09-08','11:20:00',2.14),('1444','2013-09-08','11:25:00',2.13),('1444','2013-09-08','11:30:00',2.13),('1444','2013-09-08','11:35:00',2.16),('1444','2013-09-08','11:40:00',2.2),('1444','2013-09-08','11:45:00',2.29),('1444','2013-09-08','11:50:00',2.22),('1444','2013-09-08','11:55:00',2.24),('1444','2013-09-08','12:00:00',2.16),('1444','2013-09-08','12:05:00',2.12),('1444','2013-09-08','12:10:00',2.28),('1444','2013-09-08','12:15:00',2.44),('1444','2013-09-08','12:20:00',2.36),('1444','2013-09-08','12:25:00',2.4),('1444','2013-09-08','12:30:00',2.25),('1444','2013-09-08','12:35:00',2.36),('1444','2013-09-08','12:40:00',2.36),('1444','2013-09-08','12:45:00',2.32),('1444','2013-09-08','12:50:00',2.35),('1444','2013-09-08','12:55:00',2.43),('1444','2013-09-08','13:00:00',2.39),('1444','2013-09-08','13:05:00',2.44),('1444','2013-09-08','13:10:00',2.41),('1444','2013-09-08','13:15:00',2.37),('1444','2013-09-08','13:20:00',2.37),('1444','2013-09-08','13:25:00',2.17),('1444','2013-09-08','13:30:00',2.18),('1444','2013-09-08','13:35:00',2.03),('1444','2013-09-08','13:40:00',1.49),('1444','2013-09-08','13:45:00',1.43),('1444','2013-09-08','13:50:00',2.01),('1444','2013-09-08','13:55:00',2.04),('1444','2013-09-08','14:00:00',2.31),('1444','2013-09-08','14:05:00',2.16),('1444','2013-09-08','14:10:00',2.49),('1444','2013-09-08','14:15:00',2.27),('1444','2013-09-08','14:20:00',2.64),('1444','2013-09-08','14:25:00',2.66),('1444','2013-09-08','14:30:00',2.34),('1444','2013-09-08','14:35:00',2.43),('1444','2013-09-08','14:40:00',2.35),('1444','2013-09-08','14:45:00',2.28),('1444','2013-09-08','14:50:00',2.29),('1444','2013-09-08','14:55:00',2.29),('1444','2013-09-08','15:00:00',2.26),('1444','2013-09-08','15:05:00',1.78),('1444','2013-09-08','15:10:00',1.2),('1444','2013-09-08','15:15:00',1.68),('1444','2013-09-08','15:20:00',2.17),('1444','2013-09-08','15:25:00',2.17),('1444','2013-09-08','15:30:00',2.16),('1444','2013-09-08','15:35:00',2.08),('1444','2013-09-08','15:40:00',1.93),('1444','2013-09-08','15:45:00',1.97),('1444','2013-09-08','15:50:00',1.89),('1444','2013-09-08','15:55:00',1.61),('1444','2013-09-08','16:00:00',1.62),('1444','2013-09-08','16:05:00',1.61),('1444','2013-09-08','16:10:00',1.49),('1444','2013-09-08','16:15:00',1.66),('1444','2013-09-08','16:20:00',1.46),('1444','2013-09-08','16:25:00',1.42),('1444','2013-09-08','16:30:00',1.51),('1444','2013-09-08','16:35:00',1.37),('1444','2013-09-08','16:40:00',1.15),('1444','2013-09-08','17:00:00',1.19),('1444','2013-09-08','17:05:00',1.3),('1444','2013-09-08','17:10:00',1.21),('1444','2013-09-08','17:15:00',1.11),('1444','2013-09-07','08:50:00',1.02),('1444','2013-09-07','08:55:00',1.07),('1444','2013-09-07','09:00:00',1.11),('1444','2013-09-07','09:05:00',1.18),('1444','2013-09-07','09:10:00',1.25),('1444','2013-09-07','09:15:00',1.29),('1444','2013-09-07','09:20:00',1.34),('1444','2013-09-07','09:25:00',1.4),('1444','2013-09-07','09:30:00',1.45),('1444','2013-09-07','09:35:00',1.5),('1444','2013-09-07','09:40:00',1.54),('1444','2013-09-07','09:45:00',1.59),('1444','2013-09-07','09:50:00',1.64),('1444','2013-09-07','09:55:00',1.66),('1444','2013-09-07','10:00:00',1.72),('1444','2013-09-07','10:05:00',1.75),('1444','2013-09-07','10:10:00',1.8),('1444','2013-09-07','10:15:00',1.83),('1444','2013-09-07','10:20:00',1.87),('1444','2013-09-07','10:25:00',1.91),('1444','2013-09-07','10:30:00',1.93),('1444','2013-09-07','10:35:00',1.97),('1444','2013-09-07','10:40:00',2.02),('1444','2013-09-07','10:45:00',2.04),('1444','2013-09-07','10:50:00',2.08),('1444','2013-09-07','10:55:00',2.12),('1444','2013-09-07','11:00:00',2.15),('1444','2013-09-07','11:05:00',2.18),('1444','2013-09-07','11:10:00',2.22),('1444','2013-09-07','11:15:00',2.23),('1444','2013-09-07','11:20:00',2.25),('1444','2013-09-07','11:25:00',2.28),('1444','2013-09-07','11:30:00',2.32),('1444','2013-09-07','11:35:00',2.34),('1444','2013-09-07','11:40:00',2.38),('1444','2013-09-07','11:45:00',2.4),('1444','2013-09-07','11:50:00',2.4),('1444','2013-09-07','11:55:00',2.42),('1444','2013-09-07','12:00:00',2.41),('1444','2013-09-07','12:05:00',2.48),('1444','2013-09-07','12:10:00',2.49),('1444','2013-09-07','12:15:00',2.5),('1444','2013-09-07','12:20:00',2.52),('1444','2013-09-07','12:25:00',2.51),('1444','2013-09-07','12:30:00',2.49),('1444','2013-09-07','12:35:00',2.48),('1444','2013-09-07','12:40:00',2.49),('1444','2013-09-07','12:45:00',2.51),('1444','2013-09-07','12:50:00',2.54),('1444','2013-09-07','12:57:00',2.5),('1444','2013-09-07','13:00:00',2.54),('1444','2013-09-07','13:05:00',2.54),('1444','2013-09-07','13:10:00',2.54),('1444','2013-09-07','13:15:00',2.52),('1444','2013-09-07','13:20:00',2.54),('1444','2013-09-07','13:25:00',2.57),('1444','2013-09-07','13:30:00',2.55),('1444','2013-09-07','13:35:00',1.65),('1444','2013-09-07','13:40:00',1.62),('1444','2013-09-07','13:50:00',2.51),('1444','2013-09-07','13:55:00',2.56),('1444','2013-09-07','14:00:00',2.57),('1444','2013-09-07','14:05:00',2.54),('1444','2013-09-07','14:10:00',2.5),('1444','2013-09-07','14:15:00',2.44),('1444','2013-09-07','14:20:00',2.4),('1444','2013-09-07','14:25:00',2.4),('1444','2013-09-07','14:30:00',2.42),('1444','2013-09-07','14:35:00',2.42),('1444','2013-09-07','14:40:00',2.39),('1444','2013-09-07','14:45:00',2.35),('1444','2013-09-07','14:50:00',2.32),('1444','2013-09-07','14:55:00',2.29),('1444','2013-09-07','15:00:00',2.27),('1444','2013-09-07','15:05:00',2.24),('1444','2013-09-07','15:10:00',2.21),('1444','2013-09-07','15:15:00',2.19),('1444','2013-09-07','15:20:00',2.18),('1444','2013-09-07','15:25:00',2.15),('1444','2013-09-07','15:30:00',2.1),('1444','2013-09-07','15:35:00',2.06),('1444','2013-09-07','15:40:00',1.98),('1444','2013-09-07','15:45:00',1.96),('1444','2013-09-07','15:50:00',1.92),('1444','2013-09-07','15:55:00',1.87),('1444','2013-09-07','16:00:00',1.83),('1444','2013-09-07','16:05:00',1.78),('1444','2013-09-07','16:10:00',1.73),('1444','2013-09-07','16:15:00',1.69),('1444','2013-09-07','16:20:00',1.63),('1444','2013-09-07','16:25:00',1.57),('1444','2013-09-07','16:30:00',1.5),('1444','2013-09-07','16:35:00',1.46),('1444','2013-09-07','16:40:00',1.42),('1444','2013-09-07','16:45:00',1.38),('1444','2013-09-07','16:50:00',1.33),('1444','2013-09-07','16:55:00',1.29),('1444','2013-09-07','17:00:00',1.22),('1444','2013-09-07','17:05:00',1.17),('1444','2013-09-07','17:10:00',1.12),('1444','2013-09-07','17:15:00',1.07),('1444','2013-09-07','17:20:00',1.02),('1444','2013-09-06','08:50:00',1.06),('1444','2013-09-06','08:55:00',1.12),('1444','2013-09-06','09:00:00',1.17),('1444','2013-09-06','09:05:00',1.22),('1444','2013-09-06','09:10:00',1.28),('1444','2013-09-06','09:15:00',1.33),('1444','2013-09-06','09:20:00',1.38),('1444','2013-09-06','09:25:00',1.43),('1444','2013-09-06','09:30:00',1.48),('1444','2013-09-06','09:35:00',1.54),('1444','2013-09-06','09:40:00',1.59),('1444','2013-09-06','09:45:00',1.63),('1444','2013-09-06','09:50:00',1.68),('1444','2013-09-06','09:55:00',1.73),('1444','2013-09-06','10:00:00',1.76),('1444','2013-09-06','10:05:00',1.81),('1444','2013-09-06','10:10:00',1.84),('1444','2013-09-06','10:15:00',1.87),('1444','2013-09-06','10:20:00',1.92),('1444','2013-09-06','10:25:00',1.96),('1444','2013-09-06','10:30:00',2),('1444','2013-09-06','10:35:00',2.06),('1444','2013-09-06','10:40:00',2.1),('1444','2013-09-06','10:45:00',2.16),('1444','2013-09-06','10:50:00',2.19),('1444','2013-09-06','10:55:00',2.21),('1444','2013-09-06','11:00:00',2.22),('1444','2013-09-06','11:05:00',2.24),('1444','2013-09-06','11:10:00',2.28),('1444','2013-09-06','11:15:00',2.31),('1444','2013-09-06','11:20:00',2.33),('1444','2013-09-06','11:25:00',2.35),('1444','2013-09-06','11:30:00',2.37),('1444','2013-09-06','11:35:00',2.38),('1444','2013-09-06','11:40:00',2.42),('1444','2013-09-06','11:45:00',2.45),('1444','2013-09-06','11:50:00',2.47),('1444','2013-09-06','11:55:00',2.47),('1444','2013-09-06','12:00:00',2.47),('1444','2013-09-06','12:05:00',2.48),('1444','2013-09-06','12:10:00',2.5),('1444','2013-09-06','12:15:00',2.55),('1444','2013-09-06','12:20:00',2.56),('1444','2013-09-06','12:25:00',2.56),('1444','2013-09-06','12:30:00',2.59),('1444','2013-09-06','12:35:00',2.6),('1444','2013-09-06','12:40:00',2.6),('1444','2013-09-06','12:45:00',2.6),('1444','2013-09-06','12:50:00',2.59),('1444','2013-09-06','12:55:00',2.6),('1444','2013-09-06','13:00:00',2.6),('1444','2013-09-06','13:05:00',2.6),('1444','2013-09-06','13:10:00',2.6),('1444','2013-09-06','13:15:00',2.58),('1444','2013-09-06','13:20:00',2.57),('1444','2013-09-06','13:25:00',2.55),('1444','2013-09-06','13:30:00',2.56),('1444','2013-09-06','13:35:00',2.57),('1444','2013-09-06','13:40:00',2.56),('1444','2013-09-06','13:45:00',2.53),('1444','2013-09-06','13:50:00',2.51),('1444','2013-09-06','13:55:00',2.48),('1444','2013-09-06','14:00:00',2.46),('1444','2013-09-06','14:05:00',2.45),('1444','2013-09-06','14:10:00',2.44),('1444','2013-09-06','14:15:00',2.43),('1444','2013-09-06','14:20:00',2.4),('1444','2013-09-06','14:25:00',2.39),('1444','2013-09-06','14:30:00',2.35),('1444','2013-09-06','14:35:00',2.27),('1444','2013-09-06','14:40:00',2.28),('1444','2013-09-06','14:45:00',2.27),('1444','2013-09-06','14:50:00',2.31),('1444','2013-09-06','14:55:00',2.3),('1444','2013-09-06','15:00:00',2.27),('1444','2013-09-06','15:05:00',2.23),('1444','2013-09-06','15:10:00',2.2),('1444','2013-09-06','15:15:00',2.17),('1444','2013-09-06','15:20:00',2.14),('1444','2013-09-06','15:25:00',2.09),('1444','2013-09-06','15:30:00',2.03),('1444','2013-09-06','15:35:00',1.98),('1444','2013-09-06','15:40:00',1.96),('1444','2013-09-06','15:45:00',1.94),('1444','2013-09-06','15:50:00',1.9),('1444','2013-09-06','15:55:00',1.87),('1444','2013-09-06','16:00:00',1.81),('1444','2013-09-06','16:05:00',1.78),('1444','2013-09-06','16:10:00',1.74),('1444','2013-09-06','16:15:00',1.7),('1444','2013-09-06','16:20:00',1.65),('1444','2013-09-06','16:25:00',1.63),('1444','2013-09-06','16:30:00',1.6),('1444','2013-09-06','16:35:00',1.54),('1444','2013-09-06','16:40:00',1.49),('1444','2013-09-06','16:45:00',1.42),('1444','2013-09-06','16:50:00',1.38),('1444','2013-09-06','16:55:00',1.3),('1444','2013-09-06','17:00:00',1.27),('1444','2013-09-06','17:05:00',1.2),('1444','2013-09-06','17:10:00',1.15),('1444','2013-09-06','17:15:00',1.1),('1444','2013-09-06','17:20:00',1.05),('1444','2013-09-05','08:40:00',1.03),('1444','2013-09-05','08:45:00',1.08),('1444','2013-09-05','08:50:00',1.14),('1444','2013-09-05','08:55:00',1.2),('1444','2013-09-05','09:00:00',1.26),('1444','2013-09-05','09:05:00',1.31),('1444','2013-09-05','09:10:00',1.37),('1444','2013-09-05','09:15:00',1.42),('1444','2013-09-05','09:20:00',1.48),('1444','2013-09-05','09:25:00',1.53),('1444','2013-09-05','09:30:00',1.58),('1444','2013-09-05','09:35:00',1.63),('1444','2013-09-05','09:40:00',1.67),('1444','2013-09-05','09:45:00',1.72),('1444','2013-09-05','09:50:00',1.76),('1444','2013-09-05','09:55:00',1.82),('1444','2013-09-05','10:00:00',1.86),('1444','2013-09-05','10:05:00',1.9),('1444','2013-09-05','10:10:00',1.95),('1444','2013-09-05','10:15:00',1.99),('1444','2013-09-05','10:20:00',2.03),('1444','2013-09-05','10:25:00',2.07),('1444','2013-09-05','10:30:00',2.1),('1444','2013-09-05','10:35:00',2.14),('1444','2013-09-05','10:40:00',2.17),('1444','2013-09-05','10:45:00',2.2),('1444','2013-09-05','10:50:00',2.23),('1444','2013-09-05','10:55:00',2.25),('1444','2013-09-05','11:00:00',2.3),('1444','2013-09-05','11:05:00',2.33),('1444','2013-09-05','11:10:00',2.35),('1444','2013-09-05','11:15:00',2.37),('1444','2013-09-05','11:20:00',2.39),('1444','2013-09-05','11:25:00',2.44),('1444','2013-09-05','11:30:00',2.46),('1444','2013-09-05','11:35:00',2.44),('1444','2013-09-05','11:40:00',2.46),('1444','2013-09-05','11:45:00',2.46),('1444','2013-09-05','11:50:00',2.52),('1444','2013-09-05','11:55:00',2.57),('1444','2013-09-05','12:00:00',2.56),('1444','2013-09-05','12:05:00',2.57),('1444','2013-09-05','12:10:00',2.57),('1444','2013-09-05','12:15:00',2.58),('1444','2013-09-05','12:20:00',2.61),('1444','2013-09-05','12:25:00',2.64),('1444','2013-09-05','12:30:00',2.62),('1444','2013-09-05','12:35:00',2.61),('1444','2013-09-05','12:40:00',2.63),('1444','2013-09-05','12:45:00',2.64),('1444','2013-09-05','12:50:00',2.67),('1444','2013-09-05','12:55:00',2.68),('1444','2013-09-05','13:00:00',2.66),('1444','2013-09-05','13:05:00',2.65),('1444','2013-09-05','13:10:00',2.63),('1444','2013-09-05','13:15:00',2.66),('1444','2013-09-05','13:20:00',2.63),('1444','2013-09-05','13:25:00',2.63),('1444','2013-09-05','13:30:00',2.66),('1444','2013-09-05','13:35:00',2.66),('1444','2013-09-05','13:40:00',2.62),('1444','2013-09-05','13:45:00',2.58),('1444','2013-09-05','13:50:00',2.56),('1444','2013-09-05','13:55:00',2.54),('1444','2013-09-05','14:00:00',2.54),('1444','2013-09-05','14:05:00',2.55),('1444','2013-09-05','14:10:00',2.52),('1444','2013-09-05','14:15:00',2.49),('1444','2013-09-05','14:20:00',2.46),('1444','2013-09-05','14:25:00',2.45),('1444','2013-09-05','14:30:00',2.44),('1444','2013-09-05','14:35:00',2.4),('1444','2013-09-05','14:40:00',2.4),('1444','2013-09-05','14:45:00',2.36),('1444','2013-09-05','14:50:00',2.35),('1444','2013-09-05','14:55:00',2.35),('1444','2013-09-05','15:00:00',2.34),('1444','2013-09-05','15:05:00',2.31),('1444','2013-09-05','15:10:00',2.26),('1444','2013-09-05','15:15:00',2.24),('1444','2013-09-05','15:20:00',2.2),('1444','2013-09-05','15:25:00',2.15),('1444','2013-09-05','15:30:00',2.12),('1444','2013-09-05','15:35:00',2.1),('1444','2013-09-05','15:40:00',2.07),('1444','2013-09-05','15:45:00',2.03),('1444','2013-09-05','15:50:00',1.99),('1444','2013-09-05','15:55:00',1.95),('1444','2013-09-05','16:00:00',1.9),('1444','2013-09-05','16:05:00',1.88),('1444','2013-09-05','16:10:00',1.84),('1444','2013-09-05','16:15:00',1.79),('1444','2013-09-05','16:20:00',1.73),('1444','2013-09-05','16:25:00',1.69),('1444','2013-09-05','16:30:00',1.66),('1444','2013-09-05','16:35:00',1.64),('1444','2013-09-05','16:40:00',1.6),('1444','2013-09-05','16:45:00',1.57),('1444','2013-09-05','16:50:00',1.23),('1444','2013-09-05','16:55:00',1),('1444','2013-09-05','17:40:00',1.02),('1444','2013-09-04','08:40:00',1.03),('1444','2013-09-04','08:45:00',1.09),('1444','2013-09-04','08:50:00',1.15),('1444','2013-09-04','08:55:00',1.21),('1444','2013-09-04','09:00:00',1.27),('1444','2013-09-04','09:05:00',1.33),('1444','2013-09-04','09:10:00',1.39),('1444','2013-09-04','09:15:00',1.46),('1444','2013-09-04','09:20:00',1.52),('1444','2013-09-04','09:25:00',1.58),('1444','2013-09-04','09:30:00',1.61),('1444','2013-09-04','09:35:00',1.69),('1444','2013-09-04','09:40:00',1.74),('1444','2013-09-04','09:45:00',1.8),('1444','2013-09-04','09:50:00',1.85),('1444','2013-09-04','09:55:00',1.89),('1444','2013-09-04','10:00:00',1.94),('1444','2013-09-04','10:05:00',1.98),('1444','2013-09-04','10:10:00',2.04),('1444','2013-09-04','10:15:00',2.07),('1444','2013-09-04','10:20:00',2.11),('1444','2013-09-04','10:25:00',2.15),('1444','2013-09-04','10:30:00',2.18),('1444','2013-09-04','10:35:00',2.23),('1444','2013-09-04','10:40:00',2.27),('1444','2013-09-04','10:45:00',2.3),('1444','2013-09-04','10:50:00',2.34),('1444','2013-09-04','10:55:00',2.37),('1444','2013-09-04','11:00:00',2.41),('1444','2013-09-04','11:05:00',2.44),('1444','2013-09-04','11:10:00',2.46),('1444','2013-09-04','11:15:00',2.49),('1444','2013-09-04','11:20:00',2.52),('1444','2013-09-04','11:25:00',2.54),('1444','2013-09-04','11:30:00',2.56),('1444','2013-09-04','11:35:00',2.59),('1444','2013-09-04','11:40:00',2.61),('1444','2013-09-04','11:45:00',2.63),('1444','2013-09-04','11:50:00',2.66),('1444','2013-09-04','11:55:00',2.69),('1444','2013-09-04','12:00:00',2.7),('1444','2013-09-04','12:05:00',2.71),('1444','2013-09-04','12:10:00',2.72),('1444','2013-09-04','12:15:00',2.71),('1444','2013-09-04','12:20:00',2.73),('1444','2013-09-04','12:25:00',2.76),('1444','2013-09-04','12:30:00',2.77),('1444','2013-09-04','12:35:00',2.78),('1444','2013-09-04','12:40:00',2.79),('1444','2013-09-04','12:45:00',2.79),('1444','2013-09-04','12:50:00',2.77),('1444','2013-09-04','12:55:00',2.78),('1444','2013-09-04','13:00:00',2.78),('1444','2013-09-04','13:05:00',2.77),('1444','2013-09-04','13:10:00',2.77),('1444','2013-09-04','13:15:00',2.77),('1444','2013-09-04','13:20:00',2.76),('1444','2013-09-04','13:25:00',2.75),('1444','2013-09-04','13:30:00',2.75),('1444','2013-09-04','13:35:00',2.74),('1444','2013-09-04','13:40:00',2.73),('1444','2013-09-04','13:45:00',2.72),('1444','2013-09-04','13:50:00',2.7),('1444','2013-09-04','13:55:00',2.71),('1444','2013-09-04','14:00:00',2.68),('1444','2013-09-04','14:05:00',2.68),('1444','2013-09-04','14:10:00',2.67),('1444','2013-09-04','14:15:00',2.65),('1444','2013-09-04','14:20:00',2.61),('1444','2013-09-04','14:25:00',2.6),('1444','2013-09-04','14:30:00',2.58),('1444','2013-09-04','14:35:00',2.57),('1444','2013-09-04','14:40:00',2.53),('1444','2013-09-04','14:45:00',2.52),('1444','2013-09-04','14:50:00',2.49),('1444','2013-09-04','14:55:00',2.45),('1444','2013-09-04','15:00:00',2.41),('1444','2013-09-04','15:05:00',2.38),('1444','2013-09-04','15:10:00',2.37),('1444','2013-09-04','15:15:00',2.33),('1444','2013-09-04','15:20:00',2.3),('1444','2013-09-04','15:25:00',2.25),('1444','2013-09-04','15:30:00',2.22),('1444','2013-09-04','15:35:00',2.18),('1444','2013-09-04','15:40:00',2.15),('1444','2013-09-04','15:45:00',2.11),('1444','2013-09-04','15:50:00',2.06),('1444','2013-09-04','15:55:00',2.01),('1444','2013-09-04','16:00:00',1.97),('1444','2013-09-04','16:05:00',1.92),('1444','2013-09-04','16:10:00',1.87),('1444','2013-09-04','16:15:00',1.83),('1444','2013-09-04','16:20:00',1.79),('1444','2013-09-04','16:25:00',1.73),('1444','2013-09-04','16:30:00',1.68),('1444','2013-09-04','16:35:00',1.63),('1444','2013-09-04','16:40:00',1.57),('1444','2013-09-04','16:45:00',1.52),('1444','2013-09-04','16:50:00',1.47),('1444','2013-09-04','16:55:00',1.41),('1444','2013-09-04','17:00:00',1.36),('1444','2013-09-04','17:05:00',1.31),('1444','2013-09-04','17:10:00',1.25),('1444','2013-09-04','17:15:00',1.19),('1444','2013-09-04','17:20:00',1.13),('1444','2013-09-04','17:25:00',1.08),('1444','2013-09-04','17:30:00',1.02),('1444','2013-09-03','08:45:00',1.01),('1444','2013-09-03','08:50:00',1.07),('1444','2013-09-03','08:55:00',1.13),('1444','2013-09-03','09:00:00',1.18),('1444','2013-09-03','09:05:00',1.23),('1444','2013-09-03','09:10:00',1.3),('1444','2013-09-03','09:15:00',1.36),('1444','2013-09-03','09:20:00',1.42),('1444','2013-09-03','09:25:00',1.48),('1444','2013-09-03','09:30:00',1.54),('1444','2013-09-03','09:35:00',1.59),('1444','2013-09-03','09:40:00',1.64),('1444','2013-09-03','09:45:00',1.69),('1444','2013-09-03','09:50:00',1.72),('1444','2013-09-03','09:55:00',1.75),('1444','2013-09-03','10:00:00',1.79),('1444','2013-09-03','10:05:00',1.84),('1444','2013-09-03','10:10:00',1.87),('1444','2013-09-03','10:15:00',1.93),('1444','2013-09-03','10:20:00',1.98),('1444','2013-09-03','10:25:00',2.03),('1444','2013-09-03','10:30:00',2.08),('1444','2013-09-03','10:35:00',2.12),('1444','2013-09-03','10:40:00',2.17),('1444','2013-09-03','10:45:00',2.23),('1444','2013-09-03','10:50:00',2.27),('1444','2013-09-03','10:55:00',2.29),('1444','2013-09-03','11:00:00',2.3),('1444','2013-09-03','11:05:00',2.34),('1444','2013-09-03','11:10:00',2.35),('1444','2013-09-03','11:15:00',2.39),('1444','2013-09-03','11:20:00',2.42),('1444','2013-09-03','11:25:00',2.43),('1444','2013-09-03','11:30:00',2.45),('1444','2013-09-03','11:35:00',2.47),('1444','2013-09-03','11:40:00',2.51),('1444','2013-09-03','11:45:00',2.53),('1444','2013-09-03','11:50:00',2.57),('1444','2013-09-03','11:55:00',2.6),('1444','2013-09-03','12:00:00',2.61),('1444','2013-09-03','12:05:00',2.62),('1444','2013-09-03','12:10:00',2.62),('1444','2013-09-03','12:15:00',2.64),('1444','2013-09-03','12:20:00',2.66),('1444','2013-09-03','12:25:00',2.67),('1444','2013-09-03','12:30:00',2.7),('1444','2013-09-03','12:35:00',2.71),('1444','2013-09-03','12:40:00',2.72),('1444','2013-09-03','12:45:00',2.73),('1444','2013-09-03','12:50:00',2.72),('1444','2013-09-03','12:55:00',2.71),('1444','2013-09-03','13:00:00',2.72),('1444','2013-09-03','13:05:00',2.73),('1444','2013-09-03','13:10:00',2.72),('1444','2013-09-03','13:15:00',2.7),('1444','2013-09-03','13:20:00',2.72),('1444','2013-09-03','13:25:00',2.7),('1444','2013-09-03','13:30:00',2.69),('1444','2013-09-03','13:35:00',2.68),('1444','2013-09-03','13:40:00',2.67),('1444','2013-09-03','13:45:00',2.66),('1444','2013-09-03','13:50:00',2.67),('1444','2013-09-03','13:55:00',2.68),('1444','2013-09-03','14:00:00',2.65),('1444','2013-09-03','14:05:00',2.58),('1444','2013-09-03','14:10:00',2.54),('1444','2013-09-03','14:15:00',2.55),('1444','2013-09-03','14:20:00',2.54),('1444','2013-09-03','14:25:00',2.53),('1444','2013-09-03','14:30:00',2.53),('1444','2013-09-03','14:35:00',2.52),('1444','2013-09-03','14:40:00',2.52),('1444','2013-09-03','14:45:00',2.48),('1444','2013-09-03','14:50:00',2.48),('1444','2013-09-03','14:55:00',2.46),('1444','2013-09-03','15:00:00',2.42),('1444','2013-09-03','15:05:00',2.36),('1444','2013-09-03','15:10:00',2.3),('1444','2013-09-03','15:15:00',2.29),('1444','2013-09-03','15:20:00',2.27),('1444','2013-09-03','15:25:00',2.23),('1444','2013-09-03','15:30:00',2.21),('1444','2013-09-03','15:35:00',2.15),('1444','2013-09-03','15:40:00',2.1),('1444','2013-09-03','15:45:00',2.06),('1444','2013-09-03','15:50:00',2.03),('1444','2013-09-03','15:55:00',1.99),('1444','2013-09-03','16:00:00',1.94),('1444','2013-09-03','16:05:00',1.92),('1444','2013-09-03','16:10:00',1.88),('1444','2013-09-03','16:15:00',1.83),('1444','2013-09-03','16:20:00',1.78),('1444','2013-09-03','16:25:00',1.73),('1444','2013-09-03','16:30:00',1.68),('1444','2013-09-03','16:35:00',1.63),('1444','2013-09-03','16:40:00',1.58),('1444','2013-09-03','16:45:00',1.52),('1444','2013-09-03','16:50:00',1.46),('1444','2013-09-03','16:55:00',1.42),('1444','2013-09-03','17:00:00',1.37),('1444','2013-09-03','17:05:00',1.31),('1444','2013-09-03','17:10:00',1.26),('1444','2013-09-03','17:15:00',1.2),('1444','2013-09-03','17:20:00',1.15),('1444','2013-09-03','17:25:00',1.09),('1444','2013-09-03','17:30:00',1.03),('1444','2013-09-02','08:45:00',1.06),('1444','2013-09-02','08:50:00',1.12),('1444','2013-09-02','08:55:00',1.17),('1444','2013-09-02','09:00:00',1.23),('1444','2013-09-02','09:05:00',1.29),('1444','2013-09-02','09:10:00',1.34),('1444','2013-09-02','09:15:00',1.38),('1444','2013-09-02','09:20:00',1.43),('1444','2013-09-02','09:25:00',1.5),('1444','2013-09-02','09:30:00',1.57),('1444','2013-09-02','09:35:00',1.62),('1444','2013-09-02','09:40:00',1.67),('1444','2013-09-02','09:45:00',1.73),('1444','2013-09-02','09:50:00',1.78),('1444','2013-09-02','09:55:00',1.82),('1444','2013-09-02','10:00:00',1.87),('1444','2013-09-02','10:05:00',1.92),('1444','2013-09-02','10:10:00',1.96),('1444','2013-09-02','10:15:00',2.01),('1444','2013-09-02','10:20:00',2.06),('1444','2013-09-02','10:25:00',2.09),('1444','2013-09-02','10:30:00',2.13),('1444','2013-09-02','10:35:00',2.17),('1444','2013-09-02','10:40:00',2.2),('1444','2013-09-02','10:45:00',2.23),('1444','2013-09-02','10:50:00',2.26),('1444','2013-09-02','10:55:00',2.29),('1444','2013-09-02','11:00:00',2.31),('1444','2013-09-02','11:05:00',2.33),('1444','2013-09-02','11:10:00',2.37),('1444','2013-09-02','11:15:00',2.41),('1444','2013-09-02','11:20:00',2.42),('1444','2013-09-02','11:25:00',2.45),('1444','2013-09-02','11:30:00',2.47),('1444','2013-09-02','11:35:00',2.5),('1444','2013-09-02','11:40:00',2.53),('1444','2013-09-02','11:45:00',2.56),('1444','2013-09-02','11:50:00',2.54),('1444','2013-09-02','11:55:00',2.55),('1444','2013-09-02','12:00:00',2.58),('1444','2013-09-02','12:05:00',2.59),('1444','2013-09-02','12:10:00',2.61),('1444','2013-09-02','12:15:00',2.66),('1444','2013-09-02','12:20:00',2.67),('1444','2013-09-02','12:25:00',2.67),('1444','2013-09-02','12:30:00',2.68),('1444','2013-09-02','12:35:00',2.62),('1444','2013-09-02','12:40:00',2.66),('1444','2013-09-02','12:45:00',2.66),('1444','2013-09-02','12:50:00',2.68),('1444','2013-09-02','12:55:00',2.7),('1444','2013-09-02','13:00:00',2.71),('1444','2013-09-02','13:05:00',2.71),('1444','2013-09-02','13:10:00',2.68),('1444','2013-09-02','13:15:00',2.68),('1444','2013-09-02','13:20:00',2.65),('1444','2013-09-02','13:25:00',2.66),('1444','2013-09-02','13:30:00',2.64),('1444','2013-09-02','13:35:00',2.6),('1444','2013-09-02','13:40:00',2.56),('1444','2013-09-02','13:45:00',2.69),('1444','2013-09-02','13:50:00',2.67),('1444','2013-09-02','13:55:00',1.18),('1444','2013-09-02','14:00:00',2.26),('1444','2013-09-02','14:05:00',1.76),('1444','2013-09-02','14:10:00',2.68),('1444','2013-09-02','14:15:00',2.62),('1444','2013-09-02','14:20:00',2.45),('1444','2013-09-02','14:25:00',2.56),('1444','2013-09-02','14:30:00',2.59),('1444','2013-09-02','14:35:00',2.54),('1444','2013-09-02','14:40:00',2.53),('1444','2013-09-02','14:45:00',2.56),('1444','2013-09-02','14:50:00',2.56),('1444','2013-09-02','14:55:00',1.7),('1444','2013-09-02','15:00:00',1.98),('1444','2013-09-02','15:05:00',2.27),('1444','2013-09-02','15:10:00',1.01),('1444','2013-09-02','15:15:00',1.41),('1444','2013-09-02','15:25:00',1.43),('1444','2013-09-02','15:30:00',2.19),('1444','2013-09-02','15:35:00',1.91),('1444','2013-09-02','15:40:00',1.89),('1444','2013-09-02','15:45:00',2.04),('1444','2013-09-02','15:50:00',2.06),('1444','2013-09-02','15:55:00',2.03),('1444','2013-09-02','16:00:00',2.01),('1444','2013-09-02','16:05:00',1.95),('1444','2013-09-02','16:10:00',1.9),('1444','2013-09-02','16:15:00',1.87),('1444','2013-09-02','16:20:00',1.83),('1444','2013-09-02','16:25:00',1.75),('1444','2013-09-02','16:30:00',1.68),('1444','2013-09-02','16:35:00',1.65),('1444','2013-09-02','16:40:00',1.58),('1444','2013-09-02','16:45:00',1.51),('1444','2013-09-02','16:50:00',1.44),('1444','2013-09-02','16:55:00',1.35),('1444','2013-09-02','17:00:00',1.32),('1444','2013-09-02','17:05:00',1.26),('1444','2013-09-02','17:10:00',1.21),('1444','2013-09-02','17:15:00',1.16),('1444','2013-09-02','17:20:00',1.11),('1444','2013-09-02','17:25:00',1.07),('1444','2013-09-02','17:30:00',1.02),('1444','2013-09-01','08:40:00',1.05),('1444','2013-09-01','08:45:00',1.1),('1444','2013-09-01','08:50:00',1.16),('1444','2013-09-01','08:55:00',1.21),('1444','2013-09-01','09:00:00',1.26),('1444','2013-09-01','09:05:00',1.32),('1444','2013-09-01','09:10:00',1.39),('1444','2013-09-01','09:15:00',1.45),('1444','2013-09-01','09:20:00',1.5),('1444','2013-09-01','09:25:00',1.55),('1444','2013-09-01','09:30:00',1.61),('1444','2013-09-01','09:35:00',1.66),('1444','2013-09-01','09:40:00',1.72),('1444','2013-09-01','09:45:00',1.77),('1444','2013-09-01','09:50:00',1.81),('1444','2013-09-01','09:55:00',1.86),('1444','2013-09-01','10:00:00',1.9),('1444','2013-09-01','10:05:00',1.94),('1444','2013-09-01','10:10:00',1.99),('1444','2013-09-01','10:15:00',2.03),('1444','2013-09-01','10:20:00',2.06),('1444','2013-09-01','10:25:00',2.1),('1444','2013-09-01','10:30:00',2.14),('1444','2013-09-01','10:35:00',2.16),('1444','2013-09-01','10:40:00',2.22),('1444','2013-09-01','10:45:00',2.25),('1444','2013-09-01','10:50:00',2.27),('1444','2013-09-01','10:55:00',2.32),('1444','2013-09-01','11:00:00',2.33),('1444','2013-09-01','11:05:00',2.37),('1444','2013-09-01','11:10:00',2.4),('1444','2013-09-01','11:15:00',2.43),('1444','2013-09-01','11:20:00',2.42),('1444','2013-09-01','11:25:00',2.48),('1444','2013-09-01','11:30:00',2.49),('1444','2013-09-01','11:35:00',2.51),('1444','2013-09-01','11:40:00',2.53),('1444','2013-09-01','11:45:00',2.56),('1444','2013-09-01','11:50:00',2.6),('1444','2013-09-01','11:55:00',2.61),('1444','2013-09-01','12:00:00',2.57),('1444','2013-09-01','12:05:00',2.53),('1444','2013-09-01','12:10:00',2.62),('1444','2013-09-01','12:15:00',2.65),('1444','2013-09-01','12:20:00',2.68),('1444','2013-09-01','12:25:00',2.61),('1444','2013-09-01','12:30:00',2.7),('1444','2013-09-01','12:35:00',2.69),('1444','2013-09-01','12:40:00',2.73),('1444','2013-09-01','12:45:00',2.64),('1444','2013-09-01','12:50:00',2.68),('1444','2013-09-01','12:55:00',2.68),('1444','2013-09-01','13:00:00',2.73),('1444','2013-09-01','13:05:00',2.74),('1444','2013-09-01','13:10:00',2.75),('1444','2013-09-01','13:15:00',2.34),('1444','2013-09-01','13:20:00',2.78),('1444','2013-09-01','13:25:00',2.77),('1444','2013-09-01','13:30:00',2.78),('1444','2013-09-01','13:35:00',2.7),('1444','2013-09-01','13:40:00',2.72),('1444','2013-09-01','13:45:00',2.55),('1444','2013-09-01','13:50:00',2.3),('1444','2013-09-01','13:55:00',2.36),('1444','2013-09-01','14:00:00',2.04),('1444','2013-09-01','14:05:00',2.05),('1444','2013-09-01','14:10:00',2.37),('1444','2013-09-01','14:15:00',2.43),('1444','2013-09-01','14:20:00',2.24),('1444','2013-09-01','14:25:00',2.2),('1444','2013-09-01','14:30:00',2.24),('1444','2013-09-01','14:35:00',2.24),('1444','2013-09-01','14:40:00',2.29),('1444','2013-09-01','14:45:00',2.32),('1444','2013-09-01','14:50:00',2.29),('1444','2013-09-01','14:55:00',2.22),('1444','2013-09-01','15:00:00',2.21),('1444','2013-09-01','15:05:00',2.17),('1444','2013-09-01','15:10:00',2.16),('1444','2013-09-01','15:15:00',2.15),('1444','2013-09-01','15:20:00',1.98),('1444','2013-09-01','15:25:00',1.7),('1444','2013-09-01','15:30:00',1.42),('1444','2013-09-01','15:35:00',1.65),('1444','2013-09-01','15:40:00',1.93),('1444','2013-09-01','15:45:00',1.73),('1444','2013-09-01','15:50:00',1.3),('1444','2013-09-01','15:55:00',1.55),('1444','2013-09-01','16:00:00',1.88),('1444','2013-09-01','16:05:00',1.94),('1444','2013-09-01','16:10:00',1.86),('1444','2013-09-01','16:15:00',1.85),('1444','2013-09-01','16:20:00',1.65),('1444','2013-09-01','16:25:00',1.72),('1444','2013-09-01','16:30:00',1.77),('1444','2013-09-01','16:35:00',1.69),('1444','2013-09-01','16:40:00',1.68),('1444','2013-09-01','16:45:00',1.53),('1444','2013-09-01','16:50:00',1.46),('1444','2013-09-01','16:55:00',1.28),('1444','2013-09-01','17:00:00',1.11),('1444','2013-09-01','17:05:00',1.16),('1444','2013-09-01','17:20:00',1.05),('1444','2013-08-31','08:40:00',1.07),('1444','2013-08-31','08:45:00',1.16),('1444','2013-08-31','08:50:00',1.27),('1444','2013-08-31','08:55:00',1.39),('1444','2013-08-31','09:00:00',1.43),('1444','2013-08-31','09:05:00',1.24),('1444','2013-08-31','09:10:00',1.03),('1444','2013-08-31','09:15:00',1.34),('1444','2013-08-31','09:20:00',1.42),('1444','2013-08-31','09:25:00',1.62),('1444','2013-08-31','09:30:00',1.69),('1444','2013-08-31','09:35:00',1.77),('1444','2013-08-31','09:40:00',1.8),('1444','2013-08-31','09:45:00',1.74),('1444','2013-08-31','09:50:00',1.74),('1444','2013-08-31','09:55:00',1.89),('1444','2013-08-31','10:00:00',1.99),('1444','2013-08-31','10:05:00',1.96),('1444','2013-08-31','10:10:00',2.05),('1444','2013-08-31','10:15:00',2.08),('1444','2013-08-31','10:20:00',2.12),('1444','2013-08-31','10:25:00',2.16),('1444','2013-08-31','10:30:00',2.2),('1444','2013-08-31','10:35:00',2.27),('1444','2013-08-31','10:40:00',2.29),('1444','2013-08-31','10:45:00',2.32),('1444','2013-08-31','10:50:00',2.4),('1444','2013-08-31','10:55:00',2.41),('1444','2013-08-31','11:00:00',2.47),('1444','2013-08-31','11:05:00',2.5),('1444','2013-08-31','11:10:00',2.53),('1444','2013-08-31','11:15:00',2.56),('1444','2013-08-31','11:20:00',2.58),('1444','2013-08-31','11:25:00',2.6),('1444','2013-08-31','11:30:00',2.63),('1444','2013-08-31','11:35:00',2.66),('1444','2013-08-31','11:40:00',2.7),('1444','2013-08-31','11:45:00',2.72),('1444','2013-08-31','11:50:00',2.74),('1444','2013-08-31','11:55:00',2.75),('1444','2013-08-31','12:00:00',2.71),('1444','2013-08-31','12:05:00',2.14),('1444','2013-08-31','12:10:00',2.26),('1444','2013-08-31','12:15:00',2.57),('1444','2013-08-31','12:20:00',2.75),('1444','2013-08-31','12:25:00',2.73),('1444','2013-08-31','12:30:00',2.72),('1444','2013-08-31','12:35:00',2.76),('1444','2013-08-31','12:40:00',2.73),('1444','2013-08-31','12:45:00',2.78),('1444','2013-08-31','12:50:00',2.77),('1444','2013-08-31','12:55:00',2.78),('1444','2013-08-31','13:00:00',2.78),('1444','2013-08-31','13:05:00',2.79),('1444','2013-08-31','13:10:00',2.77),('1444','2013-08-31','13:15:00',2.72),('1444','2013-08-31','13:20:00',2.67),('1444','2013-08-31','13:25:00',2.76),('1444','2013-08-31','13:30:00',2.77),('1444','2013-08-31','13:35:00',2.74),('1444','2013-08-31','13:40:00',2.69),('1444','2013-08-31','13:45:00',2.62),('1444','2013-08-31','13:50:00',2.7),('1444','2013-08-31','13:55:00',2.7),('1444','2013-08-31','14:00:00',2.7),('1444','2013-08-31','14:05:00',2.69),('1444','2013-08-31','14:10:00',2.67),('1444','2013-08-31','14:15:00',2.63),('1444','2013-08-31','14:20:00',2.6),('1444','2013-08-31','14:25:00',2.55),('1444','2013-08-31','14:30:00',2.52),('1444','2013-08-31','14:35:00',2.42),('1444','2013-08-31','14:40:00',2.47),('1444','2013-08-31','14:45:00',2.46),('1444','2013-08-31','14:50:00',2.48),('1444','2013-08-31','14:55:00',2.4),('1444','2013-08-31','15:00:00',2.38),('1444','2013-08-31','15:05:00',2.36),('1444','2013-08-31','15:10:00',2.35),('1444','2013-08-31','15:15:00',2.3),('1444','2013-08-31','15:20:00',2.26),('1444','2013-08-31','15:25:00',2.24),('1444','2013-08-31','15:30:00',2.22),('1444','2013-08-31','15:35:00',2.14),('1444','2013-08-31','15:40:00',2.13),('1444','2013-08-31','15:45:00',2.08),('1444','2013-08-31','15:50:00',2.05),('1444','2013-08-31','15:55:00',1.99),('1444','2013-08-31','16:00:00',1.96),('1444','2013-08-31','16:05:00',1.92),('1444','2013-08-31','16:10:00',1.87),('1444','2013-08-31','16:15:00',1.83),('1444','2013-08-31','16:20:00',1.81),('1444','2013-08-31','16:25:00',1.74),('1444','2013-08-31','16:30:00',1.68),('1444','2013-08-31','16:35:00',1.68),('1444','2013-08-31','16:40:00',1.63),('1444','2013-08-31','16:45:00',1.53),('1444','2013-08-31','16:50:00',1.46),('1444','2013-08-31','16:55:00',1.42),('1444','2013-08-31','17:00:00',1.35),('1444','2013-08-31','17:05:00',1.33),('1444','2013-08-31','17:10:00',1.28),('1444','2013-08-31','17:15:00',1.21),('1444','2013-08-31','17:20:00',1.17),('1444','2013-08-31','17:25:00',1.11),('1444','2013-08-31','17:30:00',1.06),('1444','2013-08-30','08:35:00',1.03),('1444','2013-08-30','08:40:00',1.06),('1444','2013-08-30','09:00:00',1.02),('1444','2013-08-30','09:05:00',1.12),('1444','2013-08-30','09:30:00',1.12),('1444','2013-08-30','09:35:00',1.25),('1444','2013-08-30','09:40:00',1.19),('1444','2013-08-30','09:45:00',1.22),('1444','2013-08-30','09:50:00',1.23),('1444','2013-08-30','09:55:00',1.34),('1444','2013-08-30','10:00:00',1.36),('1444','2013-08-30','10:05:00',1.37),('1444','2013-08-30','10:10:00',1.36),('1444','2013-08-30','10:15:00',1.45),('1444','2013-08-30','10:20:00',1.53),('1444','2013-08-30','10:25:00',1.41),('1444','2013-08-30','10:30:00',1.55),('1444','2013-08-30','10:35:00',1.5),('1444','2013-08-30','10:40:00',1.41),('1444','2013-08-30','10:45:00',1.39),('1444','2013-08-30','10:50:00',1.47),('1444','2013-08-30','10:55:00',1.39),('1444','2013-08-30','11:00:00',1.48),('1444','2013-08-30','11:05:00',1.55),('1444','2013-08-30','11:10:00',1.63),('1444','2013-08-30','11:15:00',1.64),('1444','2013-08-30','11:20:00',1.66),('1444','2013-08-30','11:25:00',1.7),('1444','2013-08-30','11:30:00',1.8),('1444','2013-08-30','11:35:00',1.72),('1444','2013-08-30','11:40:00',1.86),('1444','2013-08-30','11:45:00',1.86),('1444','2013-08-30','11:50:00',2.08),('1444','2013-08-30','11:55:00',1.84),('1444','2013-08-30','12:00:00',1.67),('1444','2013-08-30','12:05:00',1.45),('1444','2013-08-30','12:10:00',1.56),('1444','2013-08-30','12:15:00',1.71),('1444','2013-08-30','12:20:00',1.85),('1444','2013-08-30','12:25:00',1.98),('1444','2013-08-30','12:30:00',2.22),('1444','2013-08-30','12:35:00',2.15),('1444','2013-08-30','12:40:00',2.11),('1444','2013-08-30','12:45:00',2.21),('1444','2013-08-30','12:50:00',2.17),('1444','2013-08-30','12:55:00',2.02),('1444','2013-08-30','13:00:00',2),('1444','2013-08-30','13:05:00',2),('1444','2013-08-30','13:10:00',1.97),('1444','2013-08-30','13:15:00',1.83),('1444','2013-08-30','13:20:00',2.37),('1444','2013-08-30','13:25:00',2.68),('1444','2013-08-30','13:30:00',2.77),('1444','2013-08-30','13:35:00',2.57),('1444','2013-08-30','13:40:00',2.7),('1444','2013-08-30','13:45:00',2.4),('1444','2013-08-30','13:50:00',2.42),('1444','2013-08-30','13:55:00',2.67),('1444','2013-08-30','14:00:00',2.75),('1444','2013-08-30','14:05:00',2.61),('1444','2013-08-30','14:10:00',2.66),('1444','2013-08-30','14:15:00',2.62),('1444','2013-08-30','14:20:00',2.69),('1444','2013-08-30','14:25:00',2.65),('1444','2013-08-30','14:30:00',2.59),('1444','2013-08-30','14:35:00',2.67),('1444','2013-08-30','14:40:00',2.53),('1444','2013-08-30','14:45:00',1.95),('1444','2013-08-30','14:50:00',1.75),('1444','2013-08-30','14:55:00',1.97),('1444','2013-08-30','15:00:00',1.73),('1444','2013-08-30','15:05:00',1.58),('1444','2013-08-30','15:10:00',1.62),('1444','2013-08-30','15:15:00',1.99),('1444','2013-08-30','15:20:00',1.65),('1444','2013-08-30','15:25:00',1.53),('1444','2013-08-30','15:30:00',1.48),('1444','2013-08-30','15:35:00',1.2),('1444','2013-08-30','15:40:00',1.32),('1444','2013-08-30','15:45:00',1.54),('1444','2013-08-30','15:50:00',1.66),('1444','2013-08-30','15:55:00',1.62),('1444','2013-08-30','16:00:00',1.53),('1444','2013-08-30','16:05:00',1.33),('1444','2013-08-30','16:10:00',1.12),('1444','2013-08-30','16:15:00',1.02),('1444','2013-08-30','16:20:00',1.14),('1444','2013-08-30','16:25:00',1.04),('1444','2013-08-30','16:30:00',1.27),('1444','2013-08-30','16:35:00',1.23),('1444','2013-08-30','16:40:00',1.57),('1444','2013-08-30','16:45:00',1.68),('1444','2013-08-30','16:50:00',1.59),('1444','2013-08-30','16:55:00',1.37),('1444','2013-08-30','17:00:00',1.34),('1444','2013-08-30','17:10:00',1.09),('1444','2013-08-30','17:35:00',1.09),('1444','2014-04-11','08:35:00',1.31),('1444','2014-04-11','08:40:00',1.39),('1444','2014-04-11','08:45:00',1.46),('1444','2014-04-11','08:50:00',1.46),('1444','2014-04-11','08:55:00',1.47),('1444','2014-04-11','09:00:00',1.24),('1444','2014-04-11','09:05:00',1.54),('1444','2014-04-11','09:10:00',1.64),('1444','2014-04-11','09:15:00',1.71),('1444','2014-04-11','09:20:00',1.74),('1444','2014-04-11','09:25:00',1.79),('1444','2014-04-11','09:30:00',1.85),('1444','2014-04-11','09:35:00',1.92),('1444','2014-04-11','09:40:00',1.97),('1444','2014-04-11','09:45:00',2.04),('1444','2014-04-11','09:50:00',2.1),('1444','2014-04-11','09:55:00',2.15),('1444','2014-04-11','10:00:00',2.21),('1444','2014-04-11','10:05:00',2.29),('1444','2014-04-11','10:10:00',2.33),('1444','2014-04-11','10:15:00',2.37),('1444','2014-04-11','10:20:00',2.42),('1444','2014-04-11','10:25:00',2.47),('1444','2014-04-11','10:30:00',2.5),('1444','2014-04-11','10:35:00',2.54),('1444','2014-04-11','10:40:00',2.59),('1444','2014-04-11','10:45:00',2.63),('1444','2014-04-11','10:50:00',2.69),('1444','2014-04-11','10:55:00',2.72),('1444','2014-04-11','11:00:00',2.77),('1444','2014-04-11','11:05:00',2.8),('1444','2014-04-11','11:10:00',2.82),('1444','2014-04-11','11:15:00',2.84),('1444','2014-04-11','11:20:00',2.89),('1444','2014-04-11','11:25:00',2.93),('1444','2014-04-11','11:30:00',2.96),('1444','2014-04-11','11:35:00',2.99),('1444','2014-04-11','11:40:00',3.01),('1444','2014-04-11','11:45:00',3.06),('1444','2014-04-11','11:50:00',3),('1444','2014-04-11','11:55:00',2.99),('1444','2014-04-11','12:00:00',2.98),('1444','2014-04-11','12:05:00',3.17),('1444','2014-04-11','12:10:00',3.12),('1444','2014-04-11','12:15:00',2.77),('1444','2014-04-11','12:20:00',3.21),('1444','2014-04-11','12:25:00',3.21),('1444','2014-04-11','12:30:00',3.27),('1444','2014-04-11','12:35:00',3.36),('1444','2014-04-11','12:40:00',3.35),('1444','2014-04-11','12:45:00',2.35),('1444','2014-04-11','12:50:00',3.52),('1444','2014-04-11','12:55:00',3.33),('1444','2014-04-11','13:00:00',3.55),('1444','2014-04-11','13:05:00',3.47),('1444','2014-04-11','13:10:00',3.5),('1444','2014-04-11','13:15:00',2.19),('1444','2014-04-11','13:20:00',2.73),('1444','2014-04-11','13:25:00',3.41),('1444','2014-04-11','13:30:00',2.75),('1444','2014-04-11','13:35:00',1.87),('1444','2014-04-11','13:40:00',2.39),('1444','2014-04-11','13:45:00',3.37),('1444','2014-04-11','13:50:00',3.24),('1444','2014-04-11','13:55:00',2.86),('1444','2014-04-11','14:00:00',3.01),('1444','2014-04-11','14:05:00',2.88),('1444','2014-04-11','14:10:00',1.62),('1444','2014-04-11','14:15:00',1.47),('1444','2014-04-11','14:20:00',2.22),('1444','2014-04-11','14:25:00',2.03),('1444','2014-04-11','14:30:00',2.72),('1444','2014-04-11','14:35:00',3.19),('1444','2014-04-11','14:40:00',1.82),('1444','2014-04-11','14:45:00',2.29),('1444','2014-04-11','14:50:00',2.94),('1444','2014-04-11','14:55:00',1.74),('1444','2014-04-11','15:00:00',2.75),('1444','2014-04-11','15:05:00',2.11),('1444','2014-04-11','15:10:00',2.72),('1444','2014-04-11','15:15:00',2.88),('1444','2014-04-11','15:20:00',2.34),('1444','2014-04-11','15:25:00',2.78),('1444','2014-04-11','15:30:00',2.65),('1444','2014-04-11','15:35:00',2.31),('1444','2014-04-11','15:40:00',2.59),('1444','2014-04-11','15:45:00',2.52),('1444','2014-04-11','15:50:00',2.49),('1444','2014-04-11','15:55:00',2.48),('1444','2014-04-11','16:00:00',2.39),('1444','2014-04-11','16:05:00',2.3),('1444','2014-04-11','16:10:00',1.94),('1444','2014-04-11','16:15:00',2.15),('1444','2014-04-11','16:20:00',2.14),('1444','2014-04-11','16:25:00',2.1),('1444','2014-04-11','16:30:00',2.06),('1444','2014-04-11','16:35:00',1.74),('1444','2014-04-11','16:40:00',1.91),('1444','2014-04-11','16:45:00',1.9),('1444','2014-04-11','16:50:00',1.22),('1444','2014-04-11','16:55:00',1.9),('1444','2014-04-11','17:00:00',1.75),('1444','2014-04-11','17:05:00',1.55),('1444','2014-04-11','17:10:00',1.39),('1444','2014-04-11','17:15:00',1.33),('1444','2014-04-11','17:20:00',1.49),('1444','2014-04-11','17:25:00',1.41),('1444','2014-04-11','17:30:00',1.42),('1444','2014-04-11','17:35:00',1.38),('1444','2014-04-11','17:40:00',1.3),('1444','2014-04-11','17:45:00',1.17),('1444','2014-04-11','17:50:00',1.06),('1444','2013-08-29','08:25:00',1.1),('1444','2013-08-29','08:30:00',1.26),('1444','2013-08-29','08:35:00',1.2),('1444','2013-08-29','08:55:00',1.18),('1444','2013-08-29','09:00:00',1.15),('1444','2013-08-29','09:05:00',1.14),('1444','2013-08-29','09:10:00',1.1),('1444','2013-08-29','09:15:00',1.17),('1444','2013-08-29','09:20:00',1.15),('1444','2013-08-29','09:25:00',1.06),('1444','2013-08-29','09:30:00',1.11),('1444','2013-08-29','09:35:00',1.22),('1444','2013-08-29','09:40:00',1.2),('1444','2013-08-29','09:45:00',1.1),('1444','2013-08-29','09:50:00',1.06),('1444','2013-08-29','09:55:00',1.11),('1444','2013-08-29','10:00:00',1.17),('1444','2013-08-29','10:05:00',1.11),('1444','2013-08-29','10:10:00',1.09),('1444','2013-08-29','10:15:00',1.09),('1444','2013-08-29','10:20:00',1.11),('1444','2013-08-29','10:25:00',1.12),('1444','2013-08-29','10:30:00',1.15),('1444','2013-08-29','10:35:00',1.08),('1444','2013-08-29','10:55:00',1.04),('1444','2013-08-29','11:00:00',1.1),('1444','2013-08-29','11:05:00',1.12),('1444','2013-08-29','11:10:00',1.66),('1444','2013-08-29','11:15:00',1.86),('1444','2013-08-29','11:20:00',1.7),('1444','2013-08-29','11:25:00',1.27),('1444','2013-08-29','11:30:00',1.11),('1444','2013-08-29','11:35:00',1.01),('1444','2013-08-29','11:40:00',1.15),('1444','2013-08-29','11:45:00',1.35),('1444','2013-08-29','11:50:00',1.39),('1444','2013-08-29','11:55:00',1.34),('1444','2013-08-29','12:00:00',1.32),('1444','2013-08-29','12:05:00',1.58),('1444','2013-08-29','12:10:00',1.81),('1444','2013-08-29','12:15:00',2.08),('1444','2013-08-29','12:20:00',1.85),('1444','2013-08-29','12:25:00',1.89),('1444','2013-08-29','12:30:00',1.92),('1444','2013-08-29','12:35:00',2.5),('1444','2013-08-29','12:40:00',3.31),('1444','2013-08-29','12:45:00',2.93),('1444','2013-08-29','12:50:00',1.87),('1444','2013-08-29','12:55:00',2.92),('1444','2013-08-29','13:00:00',1.91),('1444','2013-08-29','13:05:00',1.83),('1444','2013-08-29','13:10:00',1.77),('1444','2013-08-29','13:15:00',1.72),('1444','2013-08-29','13:20:00',1.64),('1444','2013-08-29','13:25:00',1.44),('1444','2013-08-29','13:30:00',1.33),('1444','2013-08-29','13:35:00',1.26),('1444','2013-08-29','13:40:00',1.21),('1444','2013-08-29','13:45:00',1.14),('1444','2013-08-29','13:50:00',1.12),('1444','2013-08-29','13:55:00',1.31),('1444','2013-08-29','14:00:00',1.61),('1444','2013-08-29','14:05:00',1.23),('1444','2013-08-29','14:10:00',1.11),('1444','2013-08-29','14:55:00',1.02),('1444','2013-08-29','15:00:00',1.12),('1444','2013-08-29','15:05:00',1.24),('1444','2013-08-29','15:25:00',1.08),('1444','2013-08-29','15:30:00',1.76),('1444','2013-08-29','15:35:00',1.57),('1444','2013-08-29','15:40:00',1.54),('1444','2013-08-29','15:45:00',1.75),('1444','2013-08-29','15:50:00',2.05),('1444','2013-08-29','15:55:00',2.09),('1444','2013-08-29','16:00:00',2.08),('1444','2013-08-29','16:05:00',2.27),('1444','2013-08-29','16:10:00',2.16),('1444','2013-08-29','16:15:00',1.98),('1444','2013-08-29','16:20:00',1.93),('1444','2013-08-29','16:25:00',1.84),('1444','2013-08-29','16:30:00',1.82),('1444','2013-08-29','16:35:00',1.76),('1444','2013-08-29','16:40:00',1.71),('1444','2013-08-29','16:45:00',1.66),('1444','2013-08-29','16:50:00',1.6),('1444','2013-08-29','16:55:00',1.55),('1444','2013-08-29','17:00:00',1.5),('1444','2013-08-29','17:05:00',1.44),('1444','2013-08-29','17:10:00',1.38),('1444','2013-08-29','17:15:00',1.33),('1444','2013-08-29','17:20:00',1.27),('1444','2013-08-29','17:25:00',1.19),('1444','2013-08-29','17:30:00',1.14),('1444','2013-08-29','17:35:00',1.08),('1444','2013-08-29','17:40:00',1.02),('1444','2013-08-28','08:35:00',1.07),('1444','2013-08-28','09:15:00',1.15),('1444','2013-08-28','09:35:00',1.4),('1444','2013-08-28','09:40:00',1.69),('1444','2013-08-28','09:45:00',1.8),('1444','2013-08-28','09:50:00',1.87),('1444','2013-08-28','09:55:00',1.88),('1444','2013-08-28','10:00:00',1.85),('1444','2013-08-28','10:05:00',1.95),('1444','2013-08-28','10:10:00',2.04),('1444','2013-08-28','10:15:00',2.14),('1444','2013-08-28','10:20:00',2.3),('1444','2013-08-28','10:30:00',1.14),('1444','2013-08-28','10:35:00',1.51),('1444','2013-08-28','10:40:00',2.15),('1444','2013-08-28','10:45:00',2.56),('1444','2013-08-28','10:50:00',2.48),('1444','2013-08-28','10:55:00',2.46),('1444','2013-08-28','11:00:00',1.14),('1444','2013-08-28','11:05:00',2.75),('1444','2013-08-28','11:10:00',1.66),('1444','2013-08-28','11:15:00',2.92),('1444','2013-08-28','11:20:00',2.7),('1444','2013-08-28','11:25:00',2.77),('1444','2013-08-28','11:30:00',2.83),('1444','2013-08-28','11:35:00',2.87),('1444','2013-08-28','11:40:00',2.89),('1444','2013-08-28','11:45:00',2.77),('1444','2013-08-28','11:50:00',2.62),('1444','2013-08-28','12:00:00',2.61),('1444','2013-08-28','12:05:00',2.88),('1444','2013-08-28','12:10:00',1.6),('1444','2013-08-28','12:15:00',2.96),('1444','2013-08-28','12:20:00',2.75),('1444','2013-08-28','12:25:00',2.9),('1444','2013-08-28','12:30:00',2.88),('1444','2013-08-28','12:35:00',2.89),('1444','2013-08-28','12:40:00',2.92),('1444','2013-08-28','12:45:00',3),('1444','2013-08-28','12:50:00',2.93),('1444','2013-08-28','12:55:00',2.92),('1444','2013-08-28','13:00:00',2.98),('1444','2013-08-28','13:05:00',3.04),('1444','2013-08-28','13:10:00',2.95),('1444','2013-08-28','13:15:00',2.97),('1444','2013-08-28','13:20:00',2.91),('1444','2013-08-28','13:25:00',2.49),('1444','2013-08-28','13:30:00',2.82),('1444','2013-08-28','13:35:00',2.96),('1444','2013-08-28','13:40:00',1.67),('1444','2013-08-28','13:45:00',3.04),('1444','2013-08-28','13:50:00',2.95),('1444','2013-08-28','13:55:00',1.98),('1444','2013-08-28','14:00:00',2.83),('1444','2013-08-28','14:05:00',2.86),('1444','2013-08-28','14:10:00',2.85),('1444','2013-08-28','14:15:00',2.82),('1444','2013-08-28','14:20:00',2.8),('1444','2013-08-28','14:25:00',2.79),('1444','2013-08-28','14:30:00',2.7),('1444','2013-08-28','14:35:00',2.85),('1444','2013-08-28','14:40:00',2.76),('1444','2013-08-28','14:45:00',2.69),('1444','2013-08-28','14:50:00',2.66),('1444','2013-08-28','14:55:00',2.63),('1444','2013-08-28','15:00:00',2.59),('1444','2013-08-28','15:05:00',2.5),('1444','2013-08-28','15:10:00',2.42),('1444','2013-08-28','15:15:00',2.58),('1444','2013-08-28','15:20:00',2.34),('1444','2013-08-28','15:25:00',1.91),('1444','2013-08-28','15:30:00',2.27),('1444','2013-08-28','15:35:00',2.61),('1444','2013-08-28','15:50:00',1.74),('1444','2013-08-28','15:55:00',2.46),('1444','2013-08-28','16:00:00',2.3),('1444','2013-08-28','16:05:00',1.32),('1444','2013-08-28','16:10:00',1.69),('1444','2013-08-28','16:15:00',1.62),('1444','2013-08-28','16:20:00',1.97),('1444','2013-08-28','16:25:00',2.05),('1444','2013-08-28','16:30:00',1.93),('1444','2013-08-28','16:35:00',1.88),('1444','2013-08-28','16:40:00',1.82),('1444','2013-08-28','16:45:00',1.72),('1444','2013-08-28','16:50:00',1.66),('1444','2013-08-28','16:55:00',1.63),('1444','2013-08-28','17:00:00',1.58),('1444','2013-08-28','17:05:00',1.49),('1444','2013-08-28','17:10:00',1.45),('1444','2013-08-28','17:15:00',1.14),('1444','2013-08-28','17:25:00',1.48),('1444','2013-08-28','17:30:00',1.13),('1444','2013-08-28','17:35:00',1.1),('1444','2013-08-28','17:40:00',1.14),('1444','2013-08-27','08:25:00',1.04),('1444','2013-08-27','08:30:00',1.02),('1444','2013-08-27','09:20:00',1.07),('1444','2013-08-27','09:25:00',1.38),('1444','2013-08-27','09:30:00',1.47),('1444','2013-08-27','09:55:00',1.01),('1444','2013-08-27','10:00:00',1.32),('1444','2013-08-27','10:05:00',1.56),('1444','2013-08-27','10:10:00',1.96),('1444','2013-08-27','10:15:00',1.98),('1444','2013-08-27','10:20:00',2.08),('1444','2013-08-27','10:25:00',2.13),('1444','2013-08-27','10:30:00',2.13),('1444','2013-08-27','10:35:00',2.15),('1444','2013-08-27','10:40:00',2.16),('1444','2013-08-27','10:45:00',2.21),('1444','2013-08-27','10:50:00',2.25),('1444','2013-08-27','10:55:00',2.2),('1444','2013-08-27','11:00:00',2.26),('1444','2013-08-27','11:05:00',2.36),('1444','2013-08-27','11:10:00',2.37),('1444','2013-08-27','11:15:00',2.35),('1444','2013-08-27','11:20:00',2.42),('1444','2013-08-27','11:25:00',2.43),('1444','2013-08-27','11:30:00',2.46),('1444','2013-08-27','11:35:00',2.4),('1444','2013-08-27','11:40:00',2.19),('1444','2013-08-27','11:45:00',2.82),('1444','2013-08-27','11:50:00',1.9),('1444','2013-08-27','11:55:00',2.73),('1444','2013-08-27','12:00:00',2.99),('1444','2013-08-27','12:05:00',2.67),('1444','2013-08-27','12:10:00',2.13),('1444','2013-08-27','12:15:00',2.33),('1444','2013-08-27','12:20:00',2.63),('1444','2013-08-27','12:25:00',2.51),('1444','2013-08-27','12:30:00',2.81),('1444','2013-08-27','12:35:00',2.97),('1444','2013-08-27','12:40:00',2.94),('1444','2013-08-27','12:45:00',2.09),('1444','2013-08-27','12:50:00',1.56),('1444','2013-08-27','12:55:00',1.17),('1444','2013-08-27','13:05:00',1.2),('1444','2013-08-27','13:10:00',1.18),('1444','2013-08-27','13:15:00',1.34),('1444','2013-08-27','13:20:00',1.48),('1444','2013-08-27','13:25:00',1.62),('1444','2013-08-27','13:30:00',1.74),('1444','2013-08-27','13:35:00',1.55),('1444','2013-08-27','13:40:00',1.46),('1444','2013-08-27','13:45:00',2.23),('1444','2013-08-27','13:50:00',2.47),('1444','2013-08-27','13:55:00',2.36),('1444','2013-08-27','14:00:00',2.89),('1444','2013-08-27','14:05:00',1.44),('1444','2013-08-27','14:10:00',1.66),('1444','2013-08-27','14:15:00',2.07),('1444','2013-08-27','14:20:00',1.37),('1444','2013-08-27','15:55:00',1),('1444','2013-08-27','16:00:00',1.03),('1444','2013-08-27','16:05:00',1.58),('1444','2013-08-27','16:10:00',2.49),('1444','2013-08-27','16:15:00',2.24),('1444','2013-08-27','16:20:00',1.63),('1444','2013-08-27','16:25:00',1.56),('1444','2013-08-27','16:40:00',1.47),('1444','2013-08-27','16:45:00',1.03),('1444','2013-08-27','16:50:00',1.94),('1444','2013-08-27','16:55:00',1.48),('1444','2013-08-27','17:10:00',1.83),('1444','2013-08-27','17:50:00',1.03),('1444','2013-08-27','17:55:00',1.05),('1444','2014-04-10','08:20:00',1.03),('1444','2014-04-10','08:25:00',1.1),('1444','2014-04-10','08:30:00',1.17),('1444','2014-04-10','08:35:00',1.24),('1444','2014-04-10','08:40:00',1.32),('1444','2014-04-10','08:45:00',1.39),('1444','2014-04-10','08:50:00',1.46),('1444','2014-04-10','08:55:00',1.52),('1444','2014-04-10','09:00:00',1.58),('1444','2014-04-10','09:05:00',1.67),('1444','2014-04-10','09:10:00',1.72),('1444','2014-04-10','09:15:00',1.76),('1444','2014-04-10','09:20:00',1.77),('1444','2014-04-10','09:25:00',1.9),('1444','2014-04-10','09:30:00',1.98),('1444','2014-04-10','09:35:00',2.04),('1444','2014-04-10','09:40:00',2.08),('1444','2014-04-10','09:45:00',2.13),('1444','2014-04-10','09:50:00',2.21),('1444','2014-04-10','09:55:00',2.26),('1444','2014-04-10','10:00:00',2.31),('1444','2014-04-10','10:05:00',2.37),('1444','2014-04-10','10:10:00',2.44),('1444','2014-04-10','10:15:00',2.43),('1444','2014-04-10','10:20:00',2.49),('1444','2014-04-10','10:25:00',2.53),('1444','2014-04-10','10:30:00',2.56),('1444','2014-04-10','10:35:00',2.64),('1444','2014-04-10','10:40:00',2.69),('1444','2014-04-10','10:45:00',2.69),('1444','2014-04-10','10:50:00',2.67),('1444','2014-04-10','10:55:00',2.75),('1444','2014-04-10','11:00:00',2.75),('1444','2014-04-10','11:05:00',2.87),('1444','2014-04-10','11:10:00',2.78),('1444','2014-04-10','11:15:00',2.9),('1444','2014-04-10','11:20:00',2.98),('1444','2014-04-10','11:25:00',3.04),('1444','2014-04-10','11:30:00',3.05),('1444','2014-04-10','11:35:00',3.1),('1444','2014-04-10','11:40:00',2.97),('1444','2014-04-10','11:45:00',3.09),('1444','2014-04-10','11:50:00',2.99),('1444','2014-04-10','11:55:00',3.14),('1444','2014-04-10','12:00:00',3.1),('1444','2014-04-10','12:05:00',2.94),('1444','2014-04-10','12:10:00',3.04),('1444','2014-04-10','12:15:00',3.11),('1444','2014-04-10','12:20:00',3.14),('1444','2014-04-10','12:25:00',2.99),('1444','2014-04-10','12:30:00',3.05),('1444','2014-04-10','12:35:00',3.24),('1444','2014-04-10','12:40:00',3.05),('1444','2014-04-10','12:45:00',3.14),('1444','2014-04-10','12:50:00',3.15),('1444','2014-04-10','12:55:00',3.12),('1444','2014-04-10','13:00:00',3.03),('1444','2014-04-10','13:05:00',2.94),('1444','2014-04-10','13:10:00',3.03),('1444','2014-04-10','13:15:00',3.06),('1444','2014-04-10','13:20:00',2.94),('1444','2014-04-10','13:25:00',3.2),('1444','2014-04-10','13:30:00',3.12),('1444','2014-04-10','13:35:00',3.2),('1444','2014-04-10','13:40:00',3.03),('1444','2014-04-10','13:45:00',3.16),('1444','2014-04-10','13:50:00',3.18),('1444','2014-04-10','13:55:00',3.18),('1444','2014-04-10','14:00:00',3.14),('1444','2014-04-10','14:05:00',3.07),('1444','2014-04-10','14:10:00',3.02),('1444','2014-04-10','14:15:00',3.03),('1444','2014-04-10','14:20:00',3.09),('1444','2014-04-10','14:25:00',3.07),('1444','2014-04-10','14:30:00',3.01),('1444','2014-04-10','14:35:00',2.99),('1444','2014-04-10','14:40:00',2.95),('1444','2014-04-10','14:45:00',2.64),('1444','2014-04-10','14:50:00',2.96),('1444','2014-04-10','14:55:00',2.9),('1444','2014-04-10','15:00:00',2.86),('1444','2014-04-10','15:05:00',2.83),('1444','2014-04-10','15:10:00',2.75),('1444','2014-04-10','15:15:00',2.73),('1444','2014-04-10','15:20:00',2.71),('1444','2014-04-10','15:25:00',2.65),('1444','2014-04-10','15:30:00',2.43),('1444','2014-04-10','15:35:00',2.35),('1444','2014-04-10','15:40:00',2.35),('1444','2014-04-10','15:45:00',2.42),('1444','2014-04-10','15:50:00',2.41),('1444','2014-04-10','15:55:00',2.36),('1444','2014-04-10','16:00:00',2.33),('1444','2014-04-10','16:05:00',2.34),('1444','2014-04-10','16:10:00',2.31),('1444','2014-04-10','16:15:00',2.36),('1444','2014-04-10','16:20:00',2.25),('1444','2014-04-10','16:25:00',2.21),('1444','2014-04-10','16:30:00',2.19),('1444','2014-04-10','16:35:00',2.08),('1444','2014-04-10','16:40:00',2.05),('1444','2014-04-10','16:45:00',2.06),('1444','2014-04-10','16:50:00',1.89),('1444','2014-04-10','16:55:00',1.86),('1444','2014-04-10','17:00:00',1.78),('1444','2014-04-10','17:05:00',1.72),('1444','2014-04-10','17:10:00',1.64),('1444','2014-04-10','17:15:00',1.54),('1444','2014-04-10','17:20:00',1.51),('1444','2014-04-10','17:25:00',1.42),('1444','2014-04-10','17:30:00',1.34),('1444','2014-04-10','17:35:00',1.26),('1444','2014-04-10','17:40:00',1.19),('1444','2014-04-10','17:45:00',1.12),('1444','2014-04-10','17:50:00',1.05),('1444','2014-04-09','09:50:00',1.75),('1444','2014-04-09','09:55:00',2.16),('1444','2014-04-09','10:00:00',2.19),('1444','2014-04-09','10:05:00',2.17),('1444','2014-04-09','10:10:00',2.24),('1444','2014-04-09','10:15:00',2.25),('1444','2014-04-09','10:20:00',2.43),('1444','2014-04-09','10:25:00',2.64),('1444','2014-04-09','10:30:00',2.81),('1444','2014-04-09','10:35:00',1.49),('1444','2014-04-09','10:45:00',1.56),('1444','2014-04-09','10:55:00',2.94),('1444','2014-04-09','11:00:00',3.04),('1444','2014-04-09','11:05:00',3.05),('1444','2014-04-09','11:10:00',3.12),('1444','2014-04-09','11:15:00',3.25),('1444','2014-04-09','11:20:00',3.27),('1444','2014-04-09','11:25:00',3.16),('1444','2014-04-09','11:30:00',2.09),('1444','2014-04-09','11:35:00',3.23),('1444','2014-04-09','11:40:00',3.32),('1444','2014-04-09','11:45:00',2.99),('1444','2014-04-09','11:50:00',3.35),('1444','2014-04-09','11:55:00',3.22),('1444','2014-04-09','12:00:00',3.43),('1444','2014-04-09','12:05:00',3.02),('1444','2014-04-09','12:10:00',3.17),('1444','2014-04-09','12:15:00',1.38),('1444','2014-04-09','12:20:00',2.06),('1444','2014-04-09','13:20:00',1),('1444','2014-04-09','14:05:00',1.08),('1444','2014-04-09','14:10:00',1.12),('1444','2014-04-09','14:15:00',1.06),('1444','2014-04-09','14:30:00',1.08),('1444','2014-04-09','14:35:00',1.05),('1444','2014-04-09','14:40:00',1.49),('1444','2014-04-09','14:45:00',1.64),('1444','2014-04-09','14:50:00',1.76),('1444','2014-04-09','14:55:00',1.5),('1444','2014-04-09','15:00:00',1.33),('1444','2014-04-09','15:05:00',1.3),('1444','2014-04-09','15:10:00',2.77),('1444','2014-04-09','15:15:00',3.07),('1444','2014-04-09','15:20:00',2.38),('1444','2014-04-09','15:25:00',2.02),('1444','2014-04-09','15:30:00',2.23),('1444','2014-04-09','15:35:00',1.43),('1444','2014-04-09','15:40:00',1.34),('1444','2014-04-09','15:45:00',1.2),('1444','2014-04-09','15:50:00',1.02),('1444','2014-04-09','16:00:00',1.18),('1444','2014-04-09','16:05:00',1.46),('1444','2014-04-09','16:10:00',1.65),('1444','2014-04-09','16:15:00',2.08),('1444','2014-04-09','16:20:00',2.19),('1444','2014-04-09','16:25:00',2.14),('1444','2014-04-09','16:30:00',2.34),('1444','2014-04-09','16:35:00',2.42),('1444','2014-04-09','16:40:00',1.97),('1444','2014-04-09','16:45:00',2.32),('1444','2014-04-09','16:50:00',2.12),('1444','2014-04-09','16:55:00',1.86),('1444','2014-04-09','17:00:00',1.83),('1444','2014-04-09','17:05:00',1.86),('1444','2014-04-09','17:10:00',1.6),('1444','2014-04-09','17:15:00',1.46),('1444','2014-04-09','17:20:00',1.41),('1444','2014-04-09','17:25:00',1.36),('1444','2014-04-09','17:30:00',1.22),('1444','2013-08-03','08:20:00',1.04),('1444','2013-08-03','08:25:00',1.09),('1444','2013-08-03','08:30:00',1.15),('1444','2013-08-03','08:35:00',1.2),('1444','2013-08-03','08:40:00',1.25),('1444','2013-08-03','08:45:00',1.3),('1444','2013-08-03','08:50:00',1.36),('1444','2013-08-03','08:55:00',1.41),('1444','2013-08-03','09:00:00',1.46),('1444','2013-08-03','09:05:00',1.52),('1444','2013-08-03','09:10:00',1.57),('1444','2013-08-03','09:15:00',1.63),('1444','2013-08-03','09:20:00',1.67),('1444','2013-08-03','09:25:00',1.72),('1444','2013-08-03','09:30:00',1.76),('1444','2013-08-03','09:35:00',1.8),('1444','2013-08-03','09:40:00',1.85),('1444','2013-08-03','09:45:00',1.9),('1444','2013-08-03','09:50:00',1.95),('1444','2013-08-03','09:55:00',2),('1444','2013-08-03','10:00:00',2.03),('1444','2013-08-03','10:05:00',2.06),('1444','2013-08-03','10:10:00',2.11),('1444','2013-08-03','10:15:00',2.15),('1444','2013-08-03','10:20:00',2.2),('1444','2013-08-03','10:25:00',2.25),('1444','2013-08-03','10:30:00',2.28),('1444','2013-08-03','10:35:00',2.3),('1444','2013-08-03','10:40:00',2.34),('1444','2013-08-03','10:45:00',2.38),('1444','2013-08-03','10:50:00',2.39),('1444','2013-08-03','10:55:00',2.41),('1444','2013-08-03','11:00:00',2.46),('1444','2013-08-03','11:05:00',2.47),('1444','2013-08-03','11:10:00',2.5),('1444','2013-08-03','11:15:00',2.54),('1444','2013-08-03','11:20:00',2.57),('1444','2013-08-03','11:25:00',2.59),('1444','2013-08-03','11:30:00',2.59),('1444','2013-08-03','11:35:00',2.6),('1444','2013-08-03','11:40:00',2.63),('1444','2013-08-03','11:45:00',2.64),('1444','2013-08-03','11:50:00',2.67),('1444','2013-08-03','11:55:00',2.69),('1444','2013-08-03','12:00:00',2.68),('1444','2013-08-03','12:05:00',2.69),('1444','2013-08-03','12:10:00',2.67),('1444','2013-08-03','12:15:00',2.67),('1444','2013-08-03','12:20:00',2.71),('1444','2013-08-03','12:25:00',2.7),('1444','2013-08-03','12:30:00',2.71),('1444','2013-08-03','12:35:00',2.7),('1444','2013-08-03','12:40:00',2.7),('1444','2013-08-03','12:45:00',2.73),('1444','2013-08-03','12:50:00',2.7),('1444','2013-08-03','12:55:00',2.71),('1444','2013-08-03','13:00:00',2.72),('1444','2013-08-03','13:05:00',2.73),('1444','2013-08-03','13:10:00',2.74),('1444','2013-08-03','13:15:00',2.73),('1444','2013-08-03','13:20:00',2.72),('1444','2013-08-03','13:25:00',2.71),('1444','2013-08-03','13:30:00',2.71),('1444','2013-08-03','13:35:00',2.76),('1444','2013-08-03','13:40:00',2.75),('1444','2013-08-03','13:45:00',2.72),('1444','2013-08-03','13:50:00',2.71),('1444','2013-08-03','13:55:00',2.68),('1444','2013-08-03','14:00:00',2.67),('1444','2013-08-03','14:05:00',2.66),('1444','2013-08-03','14:10:00',2.62),('1444','2013-08-03','14:15:00',2.62),('1444','2013-08-03','14:20:00',2.67),('1444','2013-08-03','14:25:00',2.66),('1444','2013-08-03','14:30:00',2.64),('1444','2013-08-03','14:35:00',2.68),('1444','2013-08-03','14:40:00',2.67),('1444','2013-08-03','14:45:00',2.66),('1444','2013-08-03','14:50:00',2.64),('1444','2013-08-03','14:55:00',2.61),('1444','2013-08-03','15:00:00',2.59),('1444','2013-08-03','15:05:00',2.56),('1444','2013-08-03','15:10:00',2.54),('1444','2013-08-03','15:15:00',2.53),('1444','2013-08-03','15:20:00',2.49),('1444','2013-08-03','15:25:00',2.48),('1444','2013-08-03','15:30:00',2.45),('1444','2013-08-03','15:35:00',2.42),('1444','2013-08-03','15:40:00',2.38),('1444','2013-08-03','15:45:00',2.35),('1444','2013-08-03','15:50:00',2.33),('1444','2013-08-03','15:55:00',2.28),('1444','2013-08-03','16:00:00',2.23),('1444','2013-08-03','16:05:00',2.17),('1444','2013-08-03','16:10:00',2.12),('1444','2013-08-03','16:15:00',2.08),('1444','2013-08-03','16:20:00',2.04),('1444','2013-08-03','16:25:00',1.99),('1444','2013-08-03','16:30:00',1.97),('1444','2013-08-03','16:35:00',1.92),('1444','2013-08-03','16:40:00',1.87),('1444','2013-08-03','16:45:00',1.8),('1444','2013-08-03','16:50:00',1.68),('1444','2013-08-03','16:55:00',1.45),('1444','2013-08-03','17:00:00',1.57),('1444','2013-08-03','17:05:00',1.63),('1444','2013-08-03','17:10:00',1.6),('1444','2013-08-03','17:15:00',1.55),('1444','2013-08-03','17:20:00',1.5),('1444','2013-08-03','17:25:00',1.44),('1444','2013-08-03','17:30:00',1.39),('1444','2013-08-03','17:35:00',1.35),('1444','2013-08-03','17:40:00',1.28),('1444','2013-08-03','17:45:00',1.23),('1444','2013-08-03','17:50:00',1.18),('1444','2013-08-03','17:55:00',1.12),('1444','2013-08-03','18:00:00',1.07),('1444','2013-08-03','18:05:00',1.01),('1444','2013-08-02','08:15:00',1.04),('1444','2013-08-02','08:20:00',1.1),('1444','2013-08-02','08:25:00',1.16),('1444','2013-08-02','08:30:00',1.21),('1444','2013-08-02','08:35:00',1.27),('1444','2013-08-02','08:40:00',1.33),('1444','2013-08-02','08:45:00',1.38),('1444','2013-08-02','08:50:00',1.43),('1444','2013-08-02','08:55:00',1.48),('1444','2013-08-02','09:00:00',1.54),('1444','2013-08-02','09:05:00',1.6),('1444','2013-08-02','09:10:00',1.65),('1444','2013-08-02','09:15:00',1.7),('1444','2013-08-02','09:20:00',1.75),('1444','2013-08-02','09:25:00',1.79),('1444','2013-08-02','09:30:00',1.85),('1444','2013-08-02','09:35:00',1.88),('1444','2013-08-02','09:40:00',1.93),('1444','2013-08-02','09:45:00',1.97),('1444','2013-08-02','09:50:00',2.02),('1444','2013-08-02','09:55:00',2.06),('1444','2013-08-02','10:00:00',2.09),('1444','2013-08-02','10:05:00',2.13),('1444','2013-08-02','10:10:00',2.17),('1444','2013-08-02','10:15:00',2.22),('1444','2013-08-02','10:20:00',2.26),('1444','2013-08-02','10:25:00',2.28),('1444','2013-08-02','10:30:00',2.34),('1444','2013-08-02','10:35:00',2.37),('1444','2013-08-02','10:40:00',2.41),('1444','2013-08-02','10:45:00',2.46),('1444','2013-08-02','10:50:00',2.49),('1444','2013-08-02','10:55:00',2.5),('1444','2013-08-02','11:00:00',2.51),('1444','2013-08-02','11:05:00',2.53),('1444','2013-08-02','11:10:00',2.55),('1444','2013-08-02','11:15:00',2.59),('1444','2013-08-02','11:20:00',2.61),('1444','2013-08-02','11:25:00',2.66),('1444','2013-08-02','11:30:00',2.67),('1444','2013-08-02','11:35:00',2.69),('1444','2013-08-02','11:40:00',2.71),('1444','2013-08-02','11:45:00',2.73),('1444','2013-08-02','11:50:00',2.73),('1444','2013-08-02','11:55:00',2.75),('1444','2013-08-02','12:00:00',2.78),('1444','2013-08-02','12:05:00',2.8),('1444','2013-08-02','12:10:00',2.8),('1444','2013-08-02','12:15:00',2.83),('1444','2013-08-02','12:20:00',2.84),('1444','2013-08-02','12:25:00',2.83),('1444','2013-08-02','12:30:00',2.83),('1444','2013-08-02','12:35:00',2.83),('1444','2013-08-02','12:40:00',2.86),('1444','2013-08-02','12:45:00',2.87),('1444','2013-08-02','12:50:00',2.88),('1444','2013-08-02','12:55:00',2.85),('1444','2013-08-02','13:00:00',2.84),('1444','2013-08-02','13:05:00',2.85),('1444','2013-08-02','13:10:00',2.84),('1444','2013-08-02','13:15:00',2.85),('1444','2013-08-02','13:20:00',2.85),('1444','2013-08-02','13:25:00',2.87),('1444','2013-08-02','13:30:00',2.84),('1444','2013-08-02','13:35:00',2.82),('1444','2013-08-02','13:40:00',2.85),('1444','2013-08-02','13:45:00',2.84),('1444','2013-08-02','13:50:00',2.84),('1444','2013-08-02','13:55:00',2.84),('1444','2013-08-02','14:00:00',2.84),('1444','2013-08-02','14:05:00',2.82),('1444','2013-08-02','14:10:00',2.8),('1444','2013-08-02','14:15:00',2.77),('1444','2013-08-02','14:20:00',2.73),('1444','2013-08-02','14:25:00',2.72),('1444','2013-08-02','14:30:00',2.74),('1444','2013-08-02','14:35:00',2.76),('1444','2013-08-02','14:40:00',2.74),('1444','2013-08-02','14:45:00',2.72),('1444','2013-08-02','14:50:00',2.7),('1444','2013-08-02','14:55:00',2.68),('1444','2013-08-02','15:00:00',2.64),('1444','2013-08-02','15:05:00',2.61),('1444','2013-08-02','15:10:00',2.58),('1444','2013-08-02','15:15:00',2.55),('1444','2013-08-02','15:20:00',2.54),('1444','2013-08-02','15:25:00',2.52),('1444','2013-08-02','15:30:00',2.49),('1444','2013-08-02','15:35:00',2.46),('1444','2013-08-02','15:40:00',2.42),('1444','2013-08-02','15:45:00',2.4),('1444','2013-08-02','15:50:00',2.36),('1444','2013-08-02','15:55:00',2.33),('1444','2013-08-02','16:00:00',2.3),('1444','2013-08-02','16:05:00',2.25),('1444','2013-08-02','16:10:00',2.19),('1444','2013-08-02','16:15:00',2.16),('1444','2013-08-02','16:20:00',2.13),('1444','2013-08-02','16:25:00',2.09),('1444','2013-08-02','16:30:00',2.05),('1444','2013-08-02','16:35:00',2.01),('1444','2013-08-02','16:40:00',1.97),('1444','2013-08-02','16:45:00',1.92),('1444','2013-08-02','16:50:00',1.87),('1444','2013-08-02','16:55:00',1.81),('1444','2013-08-02','17:00:00',1.76),('1444','2013-08-02','17:05:00',1.71),('1444','2013-08-02','17:10:00',1.67),('1444','2013-08-02','17:15:00',1.62),('1444','2013-08-02','17:20:00',1.56),('1444','2013-08-02','17:25:00',1.5),('1444','2013-08-02','17:30:00',1.44),('1444','2013-08-02','17:35:00',1.39),('1444','2013-08-02','17:40:00',1.34),('1444','2013-08-02','17:45:00',1.27),('1444','2013-08-02','17:50:00',1.21),('1444','2013-08-02','17:55:00',1.16),('1444','2013-08-02','18:00:00',1.11),('1444','2013-08-02','18:05:00',1.06),('1444','2013-08-02','18:10:00',1),('1444','2013-08-01','08:15:00',1.05),('1444','2013-08-01','08:20:00',1.11),('1444','2013-08-01','08:25:00',1.17),('1444','2013-08-01','08:30:00',1.23),('1444','2013-08-01','08:35:00',1.3),('1444','2013-08-01','08:40:00',1.35),('1444','2013-08-01','08:45:00',1.42),('1444','2013-08-01','08:50:00',1.47),('1444','2013-08-01','08:55:00',1.52),('1444','2013-08-01','09:00:00',1.58),('1444','2013-08-01','09:05:00',1.63),('1444','2013-08-01','09:10:00',1.69),('1444','2013-08-01','09:15:00',1.75),('1444','2013-08-01','09:20:00',1.81),('1444','2013-08-01','09:25:00',1.86),('1444','2013-08-01','09:30:00',1.91),('1444','2013-08-01','09:35:00',1.96),('1444','2013-08-01','09:40:00',2.01),('1444','2013-08-01','09:45:00',2.06),('1444','2013-08-01','09:50:00',2.1),('1444','2013-08-01','09:55:00',2.15),('1444','2013-08-01','10:00:00',2.19),('1444','2013-08-01','10:05:00',2.23),('1444','2013-08-01','10:10:00',2.29),('1444','2013-08-01','10:15:00',2.33),('1444','2013-08-01','10:20:00',2.35),('1444','2013-08-01','10:25:00',2.39),('1444','2013-08-01','10:30:00',2.44),('1444','2013-08-01','10:35:00',2.46),('1444','2013-08-01','10:40:00',2.49),('1444','2013-08-01','10:45:00',2.53),('1444','2013-08-01','10:50:00',2.58),('1444','2013-08-01','10:55:00',2.61),('1444','2013-08-01','11:00:00',2.63),('1444','2013-08-01','11:05:00',2.68),('1444','2013-08-01','11:10:00',2.71),('1444','2013-08-01','11:15:00',2.76),('1444','2013-08-01','11:20:00',2.78),('1444','2013-08-01','11:25:00',2.8),('1444','2013-08-01','11:30:00',2.82),('1444','2013-08-01','11:35:00',2.86),('1444','2013-08-01','11:40:00',2.89),('1444','2013-08-01','11:45:00',2.9),('1444','2013-08-01','11:50:00',2.92),('1444','2013-08-01','11:55:00',2.91),('1444','2013-08-01','12:00:00',2.92),('1444','2013-08-01','12:05:00',2.92),('1444','2013-08-01','12:10:00',2.95),('1444','2013-08-01','12:15:00',2.96),('1444','2013-08-01','12:20:00',2.99),('1444','2013-08-01','12:25:00',2.99),('1444','2013-08-01','12:30:00',3.03),('1444','2013-08-01','12:35:00',3.03),('1444','2013-08-01','12:40:00',3.05),('1444','2013-08-01','12:45:00',3.03),('1444','2013-08-01','12:50:00',3.05),('1444','2013-08-01','12:55:00',3.01),('1444','2013-08-01','13:00:00',3.04),('1444','2013-08-01','13:05:00',3.02),('1444','2013-08-01','13:10:00',3.03),('1444','2013-08-01','13:15:00',2.94),('1444','2013-08-01','13:20:00',3.09),('1444','2013-08-01','13:25:00',3.05),('1444','2013-08-01','13:30:00',2.92),('1444','2013-08-01','13:35:00',3.08),('1444','2013-08-01','13:40:00',3.07),('1444','2013-08-01','13:45:00',2.03),('1444','2013-08-01','13:50:00',2.55),('1444','2013-08-01','13:55:00',2.73),('1444','2013-08-01','14:00:00',2.67),('1444','2013-08-01','14:05:00',3.01),('1444','2013-08-01','14:10:00',2.89),('1444','2013-08-01','14:15:00',2.81),('1444','2013-08-01','14:20:00',2.78),('1444','2013-08-01','14:25:00',2.87),('1444','2013-08-01','14:30:00',2.85),('1444','2013-08-01','14:35:00',2.61),('1444','2013-08-01','14:40:00',2.85),('1444','2013-08-01','14:45:00',2.84),('1444','2013-08-01','14:50:00',2.28),('1444','2013-08-01','14:55:00',2.78),('1444','2013-08-01','15:00:00',2.7),('1444','2013-08-01','15:05:00',2.72),('1444','2013-08-01','15:10:00',2.71),('1444','2013-08-01','15:15:00',2.73),('1444','2013-08-01','15:20:00',2.66),('1444','2013-08-01','15:25:00',2.56),('1444','2013-08-01','15:30:00',2.57),('1444','2013-08-01','15:35:00',2.57),('1444','2013-08-01','15:40:00',2.34),('1444','2013-08-01','15:45:00',2.48),('1444','2013-08-01','15:50:00',2.43),('1444','2013-08-01','15:55:00',2.42),('1444','2013-08-01','16:00:00',2.42),('1444','2013-08-01','16:05:00',2.38),('1444','2013-08-01','16:10:00',2.3),('1444','2013-08-01','16:15:00',2.24),('1444','2013-08-01','16:20:00',2.21),('1444','2013-08-01','16:25:00',2.16),('1444','2013-08-01','16:30:00',2.1),('1444','2013-08-01','16:35:00',2.06),('1444','2013-08-01','16:40:00',2.02),('1444','2013-08-01','16:45:00',1.97),('1444','2013-08-01','16:50:00',1.92),('1444','2013-08-01','16:55:00',1.87),('1444','2013-08-01','17:00:00',1.81),('1444','2013-08-01','17:05:00',1.76),('1444','2013-08-01','17:10:00',1.71),('1444','2013-08-01','17:15:00',1.65),('1444','2013-08-01','17:20:00',1.6),('1444','2013-08-01','17:25:00',1.54),('1444','2013-08-01','17:30:00',1.5),('1444','2013-08-01','17:35:00',1.45),('1444','2013-08-01','17:40:00',1.38),('1444','2013-08-01','17:45:00',1.32),('1444','2013-08-01','17:50:00',1.26),('1444','2013-08-01','17:55:00',1.21),('1444','2013-08-01','18:00:00',1.16),('1444','2013-08-01','18:05:00',1.1),('1444','2013-08-01','18:10:00',1.04),('1444','2013-07-31','08:10:00',1.02),('1444','2013-07-31','08:15:00',1.08),('1444','2013-07-31','08:20:00',1.14),('1444','2013-07-31','08:25:00',1.2),('1444','2013-07-31','08:30:00',1.26),('1444','2013-07-31','08:35:00',1.32),('1444','2013-07-31','08:40:00',1.38),('1444','2013-07-31','08:45:00',1.44),('1444','2013-07-31','08:50:00',1.49),('1444','2013-07-31','08:55:00',1.56),('1444','2013-07-31','09:00:00',1.61),('1444','2013-07-31','09:05:00',1.66),('1444','2013-07-31','09:10:00',1.71),('1444','2013-07-31','09:15:00',1.77),('1444','2013-07-31','09:20:00',1.82),('1444','2013-07-31','09:25:00',1.87),('1444','2013-07-31','09:30:00',1.92),('1444','2013-07-31','09:35:00',1.98),('1444','2013-07-31','09:40:00',2.02),('1444','2013-07-31','09:45:00',2.07),('1444','2013-07-31','09:50:00',2.12),('1444','2013-07-31','09:55:00',2.16),('1444','2013-07-31','10:00:00',2.2),('1444','2013-07-31','10:05:00',2.26),('1444','2013-07-31','10:10:00',2.28),('1444','2013-07-31','10:15:00',2.33),('1444','2013-07-31','10:20:00',2.36),('1444','2013-07-31','10:25:00',2.4),('1444','2013-07-31','10:30:00',2.45),('1444','2013-07-31','10:35:00',2.5),('1444','2013-07-31','10:40:00',2.54),('1444','2013-07-31','10:45:00',2.58),('1444','2013-07-31','10:52:00',2.62),('1444','2013-07-31','10:55:00',2.65),('1444','2013-07-31','11:00:00',2.68),('1444','2013-07-31','11:05:00',2.71),('1444','2013-07-31','11:10:00',2.74),('1444','2013-07-31','11:15:00',2.77),('1444','2013-07-31','11:20:00',2.77),('1444','2013-07-31','11:25:00',2.81),('1444','2013-07-31','11:30:00',2.82),('1444','2013-07-31','11:35:00',2.85),('1444','2013-07-31','11:40:00',2.88),('1444','2013-07-31','11:45:00',2.91),('1444','2013-07-31','11:52:00',2.94),('1444','2013-07-31','11:55:00',2.96),('1444','2013-07-31','12:00:00',2.94),('1444','2013-07-31','12:05:00',2.95),('1444','2013-07-31','12:10:00',2.98),('1444','2013-07-31','12:15:00',3.03),('1444','2013-07-31','12:20:00',3.02),('1444','2013-07-31','12:25:00',3.06),('1444','2013-07-31','12:30:00',3.05),('1444','2013-07-31','12:35:00',3.03),('1444','2013-07-31','12:40:00',3.07),('1444','2013-07-31','12:45:00',2.95),('1444','2013-07-31','12:50:00',1.65),('1444','2013-07-31','12:55:00',3.25),('1444','2013-07-31','13:05:00',2.09),('1444','2013-07-31','13:10:00',3.24),('1444','2013-07-31','13:15:00',3.14),('1444','2013-07-31','13:20:00',3.04),('1444','2013-07-31','13:25:00',2.97),('1444','2013-07-31','13:30:00',2.76),('1444','2013-07-31','13:35:00',3),('1444','2013-07-31','13:40:00',3.05),('1444','2013-07-31','13:45:00',3.05),('1444','2013-07-31','13:50:00',3.21),('1444','2013-07-31','13:55:00',2.27),('1444','2013-07-31','14:00:00',2.19),('1444','2013-07-31','14:05:00',3),('1444','2013-07-31','14:10:00',2.83),('1444','2013-07-31','14:15:00',2.64),('1444','2013-07-31','14:20:00',3.03),('1444','2013-07-31','14:25:00',2.89),('1444','2013-07-31','14:30:00',2.95),('1444','2013-07-31','14:35:00',2.91),('1444','2013-07-31','14:40:00',2.94),('1444','2013-07-31','14:45:00',2.87),('1444','2013-07-31','14:50:00',3.03),('1444','2013-07-31','14:55:00',2.43),('1444','2013-07-31','15:05:00',2.11),('1444','2013-07-31','15:10:00',2.84),('1444','2013-07-31','15:15:00',2.37),('1444','2013-07-31','15:20:00',2.54),('1444','2013-07-31','15:25:00',2.69),('1444','2013-07-31','15:30:00',2.02),('1444','2013-07-31','15:35:00',2.54),('1444','2013-07-31','15:40:00',2.67),('1444','2013-07-31','15:45:00',2.21),('1444','2013-07-31','15:50:00',2.48),('1444','2013-07-31','15:55:00',2.44),('1444','2013-07-31','16:00:00',2.39),('1444','2013-07-31','16:05:00',2.4),('1444','2013-07-31','16:10:00',2.38),('1444','2013-07-31','16:15:00',2.31),('1444','2013-07-31','16:20:00',2.32),('1444','2013-07-31','16:25:00',2.31),('1444','2013-07-31','16:30:00',2.26),('1444','2013-07-31','16:35:00',2.12),('1444','2013-07-31','16:40:00',2.03),('1444','2013-07-31','16:45:00',1.95),('1444','2013-07-31','16:50:00',1.95),('1444','2013-07-31','16:55:00',1.89),('1444','2013-07-31','17:00:00',1.85),('1444','2013-07-31','17:05:00',1.79),('1444','2013-07-31','17:10:00',1.63),('1444','2013-07-31','17:15:00',1.65),('1444','2013-07-31','17:20:00',1.24),('1444','2013-07-31','17:25:00',1.51),('1444','2013-07-31','17:30:00',1.49),('1444','2013-07-31','17:35:00',1.42),('1444','2013-07-31','17:40:00',1.37),('1444','2013-07-31','17:45:00',1.32),('1444','2013-07-31','17:50:00',1.28),('1444','2013-07-31','17:55:00',1.2),('1444','2013-07-31','18:00:00',1.16),('1444','2013-07-31','18:05:00',1.1),('1444','2013-07-31','18:10:00',1.03),('1444','2014-04-08','08:20:00',1.06),('1444','2014-04-08','08:25:00',1),('1444','2014-04-08','08:30:00',1.07),('1444','2014-04-08','08:35:00',1.08),('1444','2014-04-08','08:40:00',1.09),('1444','2014-04-08','08:45:00',1.19),('1444','2014-04-08','08:50:00',1.21),('1444','2014-04-08','08:55:00',1.32),('1444','2014-04-08','09:00:00',1.38),('1444','2014-04-08','09:05:00',1.44),('1444','2014-04-08','09:10:00',1.49),('1444','2014-04-08','09:15:00',1.55),('1444','2014-04-08','09:20:00',1.62),('1444','2014-04-08','09:25:00',1.68),('1444','2014-04-08','09:30:00',1.75),('1444','2014-04-08','09:35:00',1.79),('1444','2014-04-08','09:40:00',1.81),('1444','2014-04-08','09:45:00',1.86),('1444','2014-04-08','09:50:00',1.92),('1444','2014-04-08','09:55:00',1.95),('1444','2014-04-08','10:00:00',1.99),('1444','2014-04-08','10:05:00',2),('1444','2014-04-08','10:10:00',2.11),('1444','2014-04-08','10:15:00',2.2),('1444','2014-04-08','10:20:00',2.26),('1444','2014-04-08','10:25:00',2.29),('1444','2014-04-08','10:30:00',2.36),('1444','2014-04-08','10:35:00',2.38),('1444','2014-04-08','10:40:00',2.4),('1444','2014-04-08','10:45:00',2.43),('1444','2014-04-08','10:50:00',2.52),('1444','2014-04-08','10:55:00',2.55),('1444','2014-04-08','11:00:00',2.57),('1444','2014-04-08','11:05:00',2.61),('1444','2014-04-08','11:10:00',2.6),('1444','2014-04-08','11:15:00',2.58),('1444','2014-04-08','11:20:00',2.64),('1444','2014-04-08','11:25:00',2.75),('1444','2014-04-08','11:30:00',2.68),('1444','2014-04-08','11:35:00',2.63),('1444','2014-04-08','11:40:00',2.73),('1444','2014-04-08','11:45:00',2.74),('1444','2014-04-08','11:50:00',2.77),('1444','2014-04-08','11:55:00',2.83),('1444','2014-04-08','12:00:00',2.83),('1444','2014-04-08','12:05:00',2.83),('1444','2014-04-08','12:10:00',2.75),('1444','2014-04-08','12:15:00',2.58),('1444','2014-04-08','12:20:00',2.56),('1444','2014-04-08','12:25:00',2.57),('1444','2014-04-08','12:30:00',3.03),('1444','2014-04-08','12:35:00',3),('1444','2014-04-08','12:40:00',2.53),('1444','2014-04-08','12:45:00',1.95),('1444','2014-04-08','12:50:00',2.63),('1444','2014-04-08','12:55:00',2.98),('1444','2014-04-08','13:00:00',2.87),('1444','2014-04-08','13:05:00',2.96),('1444','2014-04-08','13:10:00',3.03),('1444','2014-04-08','13:15:00',3.08),('1444','2014-04-08','13:20:00',3.08),('1444','2014-04-08','13:25:00',3.09),('1444','2014-04-08','13:30:00',3.05),('1444','2014-04-08','13:35:00',3.08),('1444','2014-04-08','13:40:00',3.08),('1444','2014-04-08','13:45:00',3.04),('1444','2014-04-08','13:50:00',3.03),('1444','2014-04-08','13:55:00',3.06),('1444','2014-04-08','14:00:00',3.03),('1444','2014-04-08','14:05:00',3.02),('1444','2014-04-08','14:10:00',2.99),('1444','2014-04-08','14:15:00',2.96),('1444','2014-04-08','14:20:00',2.76),('1444','2014-04-08','14:25:00',2.79),('1444','2014-04-08','14:30:00',2.97),('1444','2014-04-08','14:35:00',2.88),('1444','2014-04-08','14:40:00',2.45),('1444','2014-04-08','14:45:00',2.56),('1444','2014-04-08','14:50:00',2.76),('1444','2014-04-08','14:55:00',2.82),('1444','2014-04-08','15:00:00',2.74),('1444','2014-04-08','15:05:00',2.68),('1444','2014-04-08','15:10:00',2.69),('1444','2014-04-08','15:15:00',2.62),('1444','2014-04-08','15:20:00',2.56),('1444','2014-04-08','15:25:00',2.5),('1444','2014-04-08','15:30:00',2.33),('1444','2014-04-08','15:35:00',2.49),('1444','2014-04-08','15:40:00',2.43),('1444','2014-04-08','15:45:00',2.29),('1444','2014-04-08','15:50:00',2.33),('1444','2014-04-08','15:55:00',2.32),('1444','2014-04-08','16:00:00',2.2),('1444','2014-04-08','16:05:00',2.18),('1444','2014-04-08','16:10:00',2.09),('1444','2014-04-08','16:15:00',1.96),('1444','2014-04-08','16:20:00',1.81),('1444','2014-04-08','16:25:00',1.87),('1444','2014-04-08','16:30:00',2),('1444','2014-04-08','16:35:00',1.91),('1444','2014-04-08','16:40:00',1.82),('1444','2014-04-08','16:45:00',1.73),('1444','2014-04-08','16:50:00',1.73),('1444','2014-04-08','16:55:00',1.62),('1444','2014-04-08','17:00:00',1.5),('1444','2014-04-08','17:05:00',1.56),('1444','2014-04-08','17:10:00',1.45),('1444','2014-04-08','17:15:00',1.4),('1444','2014-04-08','17:20:00',1.33),('1444','2014-04-08','17:25:00',1.18),('1444','2014-04-08','17:30:00',1.12),('1444','2014-04-08','17:35:00',1.03),('1444','2014-04-08','17:40:00',1.02),('1444','2013-07-30','08:10:00',1.09),('1444','2013-07-30','08:15:00',1.17),('1444','2013-07-30','08:20:00',1.3),('1444','2013-07-30','08:25:00',1.25),('1444','2013-07-30','08:30:00',1.13),('1444','2013-07-30','08:35:00',1.27),('1444','2013-07-30','08:40:00',1.34),('1444','2013-07-30','08:45:00',1.4),('1444','2013-07-30','08:50:00',1.49),('1444','2013-07-30','08:55:00',1.58),('1444','2013-07-30','09:00:00',1.64),('1444','2013-07-30','09:05:00',1.66),('1444','2013-07-30','09:10:00',1.72),('1444','2013-07-30','09:15:00',1.78),('1444','2013-07-30','09:20:00',1.85),('1444','2013-07-30','09:25:00',1.93),('1444','2013-07-30','09:30:00',1.96),('1444','2013-07-30','09:35:00',1.91),('1444','2013-07-30','09:40:00',1.88),('1444','2013-07-30','09:45:00',1.75),('1444','2013-07-30','09:50:00',1.62),('1444','2013-07-30','10:10:00',1.1),('1444','2013-07-30','10:15:00',2.52),('1444','2013-07-30','10:20:00',2.55),('1444','2013-07-30','10:25:00',2.58),('1444','2013-07-30','10:30:00',2.58),('1444','2013-07-30','10:35:00',2.53),('1444','2013-07-30','10:40:00',2.52),('1444','2013-07-30','10:45:00',2.56),('1444','2013-07-30','10:50:00',2.52),('1444','2013-07-30','10:55:00',2.57),('1444','2013-07-30','11:00:00',2.67),('1444','2013-07-30','11:05:00',2.68),('1444','2013-07-30','11:10:00',2.7),('1444','2013-07-30','11:15:00',2.63),('1444','2013-07-30','11:20:00',2.7),('1444','2013-07-30','11:25:00',2.79),('1444','2013-07-30','11:30:00',2.79),('1444','2013-07-30','11:35:00',2.87),('1444','2013-07-30','11:40:00',2.82),('1444','2013-07-30','11:45:00',2.8),('1444','2013-07-30','11:50:00',2.54),('1444','2013-07-30','11:55:00',2.58),('1444','2013-07-30','12:00:00',2.82),('1444','2013-07-30','12:05:00',2.88),('1444','2013-07-30','12:10:00',2.79),('1444','2013-07-30','12:15:00',2.77),('1444','2013-07-30','12:20:00',2.9),('1444','2013-07-30','12:25:00',2.92),('1444','2013-07-30','12:30:00',2.89),('1444','2013-07-30','12:35:00',2.77),('1444','2013-07-30','12:40:00',1.99),('1444','2013-07-30','12:45:00',2.99),('1444','2013-07-30','12:50:00',3.11),('1444','2013-07-30','12:55:00',2.85),('1444','2013-07-30','13:00:00',2.66),('1444','2013-07-30','13:05:00',1.6),('1444','2013-07-30','13:10:00',2.24),('1444','2013-07-30','13:15:00',2.26),('1444','2013-07-30','13:20:00',3.18),('1444','2013-07-30','13:25:00',3.07),('1444','2013-07-30','13:30:00',3.07),('1444','2013-07-30','13:35:00',3.01),('1444','2013-07-30','13:40:00',3.09),('1444','2013-07-30','13:45:00',2.97),('1444','2013-07-30','13:50:00',2.99),('1444','2013-07-30','13:55:00',3.01),('1444','2013-07-30','14:00:00',2.13),('1444','2013-07-30','14:05:00',1.88),('1444','2013-07-30','14:10:00',3.16),('1444','2013-07-30','14:15:00',3.02),('1444','2013-07-30','14:20:00',2.58),('1444','2013-07-30','14:25:00',2.85),('1444','2013-07-30','14:30:00',2.87),('1444','2013-07-30','14:35:00',2.86),('1444','2013-07-30','14:40:00',2.78),('1444','2013-07-30','14:45:00',2.76),('1444','2013-07-30','14:50:00',2.68),('1444','2013-07-30','14:55:00',2.7),('1444','2013-07-30','15:00:00',2.68),('1444','2013-07-30','15:05:00',2.64),('1444','2013-07-30','15:10:00',2.59),('1444','2013-07-30','15:15:00',2.56),('1444','2013-07-30','15:20:00',2.54),('1444','2013-07-30','15:25:00',2.52),('1444','2013-07-30','15:30:00',2.49),('1444','2013-07-30','15:35:00',2.45),('1444','2013-07-30','15:40:00',2.44),('1444','2013-07-30','15:45:00',2.4),('1444','2013-07-30','15:50:00',2.37),('1444','2013-07-30','15:55:00',2.32),('1444','2013-07-30','16:00:00',2.3),('1444','2013-07-30','16:05:00',2.26),('1444','2013-07-30','16:10:00',2.22),('1444','2013-07-30','16:15:00',2.17),('1444','2013-07-30','16:20:00',2.14),('1444','2013-07-30','16:25:00',2.1),('1444','2013-07-30','16:30:00',2.04),('1444','2013-07-30','16:35:00',2),('1444','2013-07-30','16:40:00',1.98),('1444','2013-07-30','16:45:00',1.92),('1444','2013-07-30','16:50:00',1.87),('1444','2013-07-30','16:55:00',1.82),('1444','2013-07-30','17:00:00',1.77),('1444','2013-07-30','17:05:00',1.73),('1444','2013-07-30','17:10:00',1.67),('1444','2013-07-30','17:15:00',1.61),('1444','2013-07-30','17:20:00',1.58),('1444','2013-07-30','17:25:00',1.53),('1444','2013-07-30','17:30:00',1.47),('1444','2013-07-30','17:35:00',1.41),('1444','2013-07-30','17:40:00',1.37),('1444','2013-07-30','17:45:00',1.31),('1444','2013-07-30','17:50:00',1.25),('1444','2013-07-30','17:55:00',1.18),('1444','2013-07-30','18:00:00',1.12),('1444','2013-07-30','18:05:00',1.06),('1444','2013-07-30','18:10:00',1.01),('1444','2013-07-29','08:20:00',1.03),('1444','2013-07-29','08:25:00',1.08),('1444','2013-07-29','08:30:00',1.13),('1444','2013-07-29','08:35:00',1.19),('1444','2013-07-29','08:40:00',1.22),('1444','2013-07-29','08:45:00',1.26),('1444','2013-07-29','08:50:00',1.33),('1444','2013-07-29','08:55:00',1.39),('1444','2013-07-29','09:00:00',1.41),('1444','2013-07-29','09:05:00',1.48),('1444','2013-07-29','09:10:00',1.54),('1444','2013-07-29','09:15:00',1.58),('1444','2013-07-29','09:20:00',1.62),('1444','2013-07-29','09:25:00',1.66),('1444','2013-07-29','09:30:00',1.71),('1444','2013-07-29','09:35:00',1.78),('1444','2013-07-29','09:40:00',1.84),('1444','2013-07-29','09:45:00',1.9),('1444','2013-07-29','09:50:00',1.95),('1444','2013-07-29','09:55:00',2),('1444','2013-07-29','10:00:00',2.03),('1444','2013-07-29','10:05:00',2.07),('1444','2013-07-29','10:10:00',2.11),('1444','2013-07-29','10:15:00',2.13),('1444','2013-07-29','10:20:00',2.2),('1444','2013-07-29','10:25:00',2.23),('1444','2013-07-29','10:30:00',2.27),('1444','2013-07-29','10:35:00',2.3),('1444','2013-07-29','10:40:00',2.35),('1444','2013-07-29','10:45:00',2.35),('1444','2013-07-29','10:50:00',2.38),('1444','2013-07-29','10:55:00',2.41),('1444','2013-07-29','11:00:00',2.43),('1444','2013-07-29','11:05:00',2.46),('1444','2013-07-29','11:10:00',2.47),('1444','2013-07-29','11:15:00',2.52),('1444','2013-07-29','11:20:00',2.56),('1444','2013-07-29','11:25:00',2.56),('1444','2013-07-29','11:30:00',2.56),('1444','2013-07-29','11:35:00',2.6),('1444','2013-07-29','11:40:00',2.63),('1444','2013-07-29','11:45:00',2.61),('1444','2013-07-29','11:50:00',2.62),('1444','2013-07-29','11:55:00',2.64),('1444','2013-07-29','12:00:00',2.67),('1444','2013-07-29','12:05:00',2.71),('1444','2013-07-29','12:10:00',2.69),('1444','2013-07-29','12:15:00',2.68),('1444','2013-07-29','12:20:00',2.71),('1444','2013-07-29','12:25:00',2.72),('1444','2013-07-29','12:30:00',2.71),('1444','2013-07-29','12:35:00',2.74),('1444','2013-07-29','12:40:00',2.76),('1444','2013-07-29','12:45:00',2.77),('1444','2013-07-29','12:50:00',2.71),('1444','2013-07-29','12:55:00',2.7),('1444','2013-07-29','13:00:00',2.8),('1444','2013-07-29','13:05:00',2.77),('1444','2013-07-29','13:10:00',2.81),('1444','2013-07-29','13:15:00',2.82),('1444','2013-07-29','13:20:00',2.86),('1444','2013-07-29','13:25:00',2.87),('1444','2013-07-29','13:30:00',2.89),('1444','2013-07-29','13:35:00',2.87),('1444','2013-07-29','13:40:00',2.86),('1444','2013-07-29','13:45:00',2.9),('1444','2013-07-29','13:50:00',2.9),('1444','2013-07-29','13:55:00',2.88),('1444','2013-07-29','14:00:00',2.86),('1444','2013-07-29','14:05:00',2.85),('1444','2013-07-29','14:10:00',2.83),('1444','2013-07-29','14:15:00',2.82),('1444','2013-07-29','14:20:00',2.82),('1444','2013-07-29','14:25:00',2.78),('1444','2013-07-29','14:30:00',2.77),('1444','2013-07-29','14:35:00',2.75),('1444','2013-07-29','14:40:00',2.72),('1444','2013-07-29','14:45:00',2.7),('1444','2013-07-29','14:50:00',2.69),('1444','2013-07-29','14:55:00',2.68),('1444','2013-07-29','15:00:00',2.65),('1444','2013-07-29','15:05:00',2.63),('1444','2013-07-29','15:10:00',2.61),('1444','2013-07-29','15:15:00',2.58),('1444','2013-07-29','15:20:00',2.54),('1444','2013-07-29','15:25:00',2.52),('1444','2013-07-29','15:30:00',2.49),('1444','2013-07-29','15:35:00',2.47),('1444','2013-07-29','15:40:00',2.5),('1444','2013-07-29','15:45:00',2.56),('1444','2013-07-29','15:50:00',1.95),('1444','2013-07-29','15:55:00',1.43),('1444','2013-07-29','16:00:00',1.32),('1444','2013-07-29','16:05:00',2.04),('1444','2013-07-29','16:10:00',2.06),('1444','2013-07-29','16:15:00',1.72),('1444','2013-07-29','16:20:00',1.75),('1444','2013-07-29','16:25:00',1.99),('1444','2013-07-29','16:30:00',2.11),('1444','2013-07-29','16:35:00',1.67),('1444','2013-07-29','16:40:00',1.82),('1444','2013-07-29','16:45:00',2.13),('1444','2013-07-29','16:50:00',1.86),('1444','2013-07-29','16:55:00',1.29),('1444','2013-07-29','17:05:00',1.46),('1444','2013-07-29','17:20:00',1.66),('1444','2013-07-29','17:25:00',1.43),('1444','2013-07-29','17:45:00',1.41),('1444','2013-07-29','17:50:00',1.26),('1444','2013-07-29','17:55:00',1.13),('1444','2013-07-29','18:10:00',1),('1444','2013-07-28','08:20:00',1.02),('1444','2013-07-28','08:25:00',1.09),('1444','2013-07-28','08:30:00',1.15),('1444','2013-07-28','08:35:00',1.21),('1444','2013-07-28','08:40:00',1.26),('1444','2013-07-28','08:45:00',1.31),('1444','2013-07-28','08:50:00',1.37),('1444','2013-07-28','08:55:00',1.41),('1444','2013-07-28','09:00:00',1.47),('1444','2013-07-28','09:05:00',1.53),('1444','2013-07-28','09:10:00',1.58),('1444','2013-07-28','09:15:00',1.63),('1444','2013-07-28','09:20:00',1.67),('1444','2013-07-28','09:25:00',1.7),('1444','2013-07-28','09:30:00',1.79),('1444','2013-07-28','09:35:00',1.85),('1444','2013-07-28','09:40:00',1.88),('1444','2013-07-28','09:45:00',1.94),('1444','2013-07-28','09:50:00',1.97),('1444','2013-07-28','09:55:00',2.01),('1444','2013-07-28','10:00:00',2.05),('1444','2013-07-28','10:05:00',2.08),('1444','2013-07-28','10:10:00',2.13),('1444','2013-07-28','10:15:00',2.17),('1444','2013-07-28','10:20:00',2.22),('1444','2013-07-28','10:25:00',2.25),('1444','2013-07-28','10:30:00',2.27),('1444','2013-07-28','10:35:00',2.3),('1444','2013-07-28','10:40:00',2.32),('1444','2013-07-28','10:45:00',2.35),('1444','2013-07-28','10:50:00',2.36),('1444','2013-07-28','10:55:00',2.4),('1444','2013-07-28','11:00:00',2.45),('1444','2013-07-28','11:05:00',2.46),('1444','2013-07-28','11:10:00',2.48),('1444','2013-07-28','11:15:00',2.5),('1444','2013-07-28','11:20:00',2.52),('1444','2013-07-28','11:25:00',2.56),('1444','2013-07-28','11:30:00',2.59),('1444','2013-07-28','11:35:00',2.64),('1444','2013-07-28','11:40:00',2.63),('1444','2013-07-28','11:45:00',2.66),('1444','2013-07-28','11:50:00',2.64),('1444','2013-07-28','11:55:00',2.66),('1444','2013-07-28','12:00:00',2.68),('1444','2013-07-28','12:05:00',2.69),('1444','2013-07-28','12:10:00',2.72),('1444','2013-07-28','12:15:00',2.68),('1444','2013-07-28','12:20:00',2.69),('1444','2013-07-28','12:25:00',2.69),('1444','2013-07-28','12:30:00',2.67),('1444','2013-07-28','12:35:00',2.74),('1444','2013-07-28','12:40:00',2.74),('1444','2013-07-28','12:45:00',2.81),('1444','2013-07-28','12:50:00',2.75),('1444','2013-07-28','12:55:00',2.8),('1444','2013-07-28','13:00:00',2.84),('1444','2013-07-28','13:05:00',2.8),('1444','2013-07-28','13:10:00',2.82),('1444','2013-07-28','13:15:00',2.7),('1444','2013-07-28','13:20:00',2.86),('1444','2013-07-28','13:25:00',2.86),('1444','2013-07-28','13:30:00',2.84),('1444','2013-07-28','13:35:00',2.82),('1444','2013-07-28','13:40:00',2.83),('1444','2013-07-28','13:45:00',2.84),('1444','2013-07-28','13:50:00',2.77),('1444','2013-07-28','13:55:00',2.83),('1444','2013-07-28','14:00:00',2.82),('1444','2013-07-28','14:05:00',2.8),('1444','2013-07-28','14:10:00',2.81),('1444','2013-07-28','14:15:00',2.8),('1444','2013-07-28','14:20:00',2.78),('1444','2013-07-28','14:25:00',2.75),('1444','2013-07-28','14:30:00',2.73),('1444','2013-07-28','14:35:00',2.71),('1444','2013-07-28','14:40:00',2.71),('1444','2013-07-28','14:45:00',2.67),('1444','2013-07-28','14:50:00',2.68),('1444','2013-07-28','14:55:00',2.64),('1444','2013-07-28','15:00:00',2.62),('1444','2013-07-28','15:05:00',2.61),('1444','2013-07-28','15:10:00',2.58),('1444','2013-07-28','15:15:00',2.52),('1444','2013-07-28','15:20:00',2.51),('1444','2013-07-28','15:25:00',2.48),('1444','2013-07-28','15:30:00',2.44),('1444','2013-07-28','15:35:00',2.41),('1444','2013-07-28','15:40:00',2.39),('1444','2013-07-28','15:45:00',2.36),('1444','2013-07-28','15:50:00',2.34),('1444','2013-07-28','15:55:00',2.3),('1444','2013-07-28','16:00:00',2.28),('1444','2013-07-28','16:05:00',2.26),('1444','2013-07-28','16:10:00',2.21),('1444','2013-07-28','16:15:00',2.18),('1444','2013-07-28','16:20:00',2.17),('1444','2013-07-28','16:25:00',2.12),('1444','2013-07-28','16:30:00',2.08),('1444','2013-07-28','16:35:00',2.04),('1444','2013-07-28','16:40:00',2),('1444','2013-07-28','16:45:00',1.95),('1444','2013-07-28','16:50:00',1.9),('1444','2013-07-28','16:55:00',1.85),('1444','2013-07-28','17:00:00',1.8),('1444','2013-07-28','17:05:00',1.75),('1444','2013-07-28','17:10:00',1.7),('1444','2013-07-28','17:15:00',1.65),('1444','2013-07-28','17:20:00',1.6),('1444','2013-07-28','17:25:00',1.55),('1444','2013-07-28','17:30:00',1.5),('1444','2013-07-28','17:35:00',1.45),('1444','2013-07-28','17:40:00',1.39),('1444','2013-07-28','17:45:00',1.34),('1444','2013-07-28','17:50:00',1.28),('1444','2013-07-28','17:55:00',1.22),('1444','2013-07-28','18:00:00',1.15),('1444','2013-07-28','18:05:00',1.1),('1444','2013-07-28','18:10:00',1.04),('1444','2013-07-27','08:20:00',1.06),('1444','2013-07-27','08:25:00',1.12),('1444','2013-07-27','08:30:00',1.16),('1444','2013-07-27','08:35:00',1.22),('1444','2013-07-27','08:40:00',1.28),('1444','2013-07-27','08:45:00',1.33),('1444','2013-07-27','08:50:00',1.38),('1444','2013-07-27','08:55:00',1.45),('1444','2013-07-27','09:00:00',1.48),('1444','2013-07-27','09:05:00',1.53),('1444','2013-07-27','09:10:00',1.59),('1444','2013-07-27','09:15:00',1.66),('1444','2013-07-27','09:20:00',1.7),('1444','2013-07-27','09:25:00',1.75),('1444','2013-07-27','09:30:00',1.81),('1444','2013-07-27','09:35:00',1.86),('1444','2013-07-27','09:40:00',1.88),('1444','2013-07-27','09:45:00',1.92),('1444','2013-07-27','09:50:00',1.97),('1444','2013-07-27','09:55:00',2.04),('1444','2013-07-27','10:00:00',2.08),('1444','2013-07-27','10:05:00',2.11),('1444','2013-07-27','10:10:00',2.15),('1444','2013-07-27','10:15:00',2.19),('1444','2013-07-27','10:20:00',2.25),('1444','2013-07-27','10:25:00',2.26),('1444','2013-07-27','10:30:00',2.3),('1444','2013-07-27','10:35:00',2.34),('1444','2013-07-27','10:40:00',2.35),('1444','2013-07-27','10:45:00',2.35),('1444','2013-07-27','10:50:00',2.39),('1444','2013-07-27','10:55:00',2.42),('1444','2013-07-27','11:00:00',2.48),('1444','2013-07-27','11:05:00',2.53),('1444','2013-07-27','11:10:00',2.53),('1444','2013-07-27','11:15:00',2.52),('1444','2013-07-27','11:20:00',2.57),('1444','2013-07-27','11:25:00',2.6),('1444','2013-07-27','11:30:00',2.64),('1444','2013-07-27','11:35:00',2.67),('1444','2013-07-27','11:40:00',2.7),('1444','2013-07-27','11:45:00',2.7),('1444','2013-07-27','11:50:00',2.71),('1444','2013-07-27','11:55:00',2.69),('1444','2013-07-27','12:00:00',2.71),('1444','2013-07-27','12:05:00',2.72),('1444','2013-07-27','12:10:00',2.74),('1444','2013-07-27','12:15:00',2.71),('1444','2013-07-27','12:20:00',2.67),('1444','2013-07-27','12:25:00',2.76),('1444','2013-07-27','12:30:00',2.81),('1444','2013-07-27','12:35:00',2.77),('1444','2013-07-27','12:40:00',2.74),('1444','2013-07-27','12:45:00',2.79),('1444','2013-07-27','12:50:00',2.82),('1444','2013-07-27','12:55:00',2.81),('1444','2013-07-27','13:00:00',2.88),('1444','2013-07-27','13:05:00',1.33),('1444','2013-07-27','13:10:00',2.01),('1444','2013-07-27','13:15:00',2.81),('1444','2013-07-27','13:20:00',2.9),('1444','2013-07-27','13:25:00',2.89),('1444','2013-07-27','13:30:00',2.86),('1444','2013-07-27','13:35:00',2.83),('1444','2013-07-27','13:40:00',2.49),('1444','2013-07-27','13:45:00',2.87),('1444','2013-07-27','13:50:00',2.85),('1444','2013-07-27','13:55:00',2.86),('1444','2013-07-27','14:00:00',2.8),('1444','2013-07-27','14:05:00',2.87),('1444','2013-07-27','14:10:00',2.88),('1444','2013-07-27','14:15:00',2.71),('1444','2013-07-27','14:20:00',2.76),('1444','2013-07-27','14:25:00',2.75),('1444','2013-07-27','14:30:00',2.74),('1444','2013-07-27','14:35:00',2.73),('1444','2013-07-27','14:40:00',2.69),('1444','2013-07-27','14:45:00',2.69),('1444','2013-07-27','14:50:00',2.67),('1444','2013-07-27','14:55:00',2.65),('1444','2013-07-27','15:00:00',2.63),('1444','2013-07-27','15:05:00',2.64),('1444','2013-07-27','15:10:00',2.59),('1444','2013-07-27','15:15:00',2.59),('1444','2013-07-27','15:20:00',2.57),('1444','2013-07-27','15:25:00',2.53),('1444','2013-07-27','15:30:00',2.5),('1444','2013-07-27','15:35:00',2.47),('1444','2013-07-27','15:40:00',2.43),('1444','2013-07-27','15:45:00',2.4),('1444','2013-07-27','15:50:00',2.37),('1444','2013-07-27','15:55:00',2.34),('1444','2013-07-27','16:00:00',2.31),('1444','2013-07-27','16:05:00',2.28),('1444','2013-07-27','16:10:00',2.23),('1444','2013-07-27','16:15:00',2.19),('1444','2013-07-27','16:20:00',2.16),('1444','2013-07-27','16:25:00',2.13),('1444','2013-07-27','16:30:00',2.1),('1444','2013-07-27','16:35:00',2.06),('1444','2013-07-27','16:40:00',2.01),('1444','2013-07-27','16:45:00',1.96),('1444','2013-07-27','16:50:00',1.91),('1444','2013-07-27','16:55:00',1.84),('1444','2013-07-27','17:00:00',1.8),('1444','2013-07-27','17:05:00',1.75),('1444','2013-07-27','17:10:00',1.71),('1444','2013-07-27','17:15:00',1.65),('1444','2013-07-27','17:20:00',1.6),('1444','2013-07-27','17:25:00',1.53),('1444','2013-07-27','17:30:00',1.5),('1444','2013-07-27','17:35:00',1.44),('1444','2013-07-27','17:40:00',1.38),('1444','2013-07-27','17:45:00',1.32),('1444','2013-07-27','17:50:00',1.27),('1444','2013-07-27','17:55:00',1.23),('1444','2013-07-27','18:00:00',1.17),('1444','2013-07-27','18:05:00',1.12),('1444','2013-07-27','18:10:00',1.07),('1444','2013-07-27','18:15:00',1.02),('1444','2013-07-26','08:20:00',1.05),('1444','2013-07-26','08:25:00',1.1),('1444','2013-07-26','08:30:00',1.16),('1444','2013-07-26','08:35:00',1.2),('1444','2013-07-26','08:40:00',1.25),('1444','2013-07-26','08:45:00',1.31),('1444','2013-07-26','08:50:00',1.38),('1444','2013-07-26','08:55:00',1.45),('1444','2013-07-26','09:00:00',1.48),('1444','2013-07-26','09:05:00',1.53),('1444','2013-07-26','09:10:00',1.57),('1444','2013-07-26','09:15:00',1.64),('1444','2013-07-26','09:20:00',1.67),('1444','2013-07-26','09:25:00',1.64),('1444','2013-07-26','09:30:00',1.85),('1444','2013-07-26','09:35:00',1.76),('1444','2013-07-26','09:40:00',1.87),('1444','2013-07-26','09:45:00',1.92),('1444','2013-07-26','09:50:00',1.97),('1444','2013-07-26','09:55:00',1.74),('1444','2013-07-26','10:00:00',2),('1444','2013-07-26','10:05:00',2.07),('1444','2013-07-26','10:10:00',2.13),('1444','2013-07-26','10:15:00',2.19),('1444','2013-07-26','10:20:00',2.16),('1444','2013-07-26','10:25:00',2.17),('1444','2013-07-26','10:30:00',2.27),('1444','2013-07-26','10:35:00',2.32),('1444','2013-07-26','10:40:00',2.36),('1444','2013-07-26','10:45:00',2.36),('1444','2013-07-26','10:50:00',2.4),('1444','2013-07-26','10:55:00',2.49),('1444','2013-07-26','11:00:00',2.4),('1444','2013-07-26','11:05:00',2.39),('1444','2013-07-26','11:10:00',2.56),('1444','2013-07-26','11:15:00',2.48),('1444','2013-07-26','11:20:00',2.52),('1444','2013-07-26','11:25:00',2.62),('1444','2013-07-26','11:30:00',2.66),('1444','2013-07-26','11:35:00',2.6),('1444','2013-07-26','11:40:00',2.66),('1444','2013-07-26','11:45:00',2.75),('1444','2013-07-26','11:50:00',2.83),('1444','2013-07-26','11:55:00',2.14),('1444','2013-07-26','12:00:00',2.78),('1444','2013-07-26','12:05:00',2.64),('1444','2013-07-26','12:10:00',2.81),('1444','2013-07-26','12:15:00',2.79),('1444','2013-07-26','12:20:00',2.8),('1444','2013-07-26','12:25:00',2.86),('1444','2013-07-26','12:30:00',2.34),('1444','2013-07-26','12:35:00',2.87),('1444','2013-07-26','12:40:00',3.04),('1444','2013-07-26','12:45:00',3.07),('1444','2013-07-26','12:50:00',3.11),('1444','2013-07-26','12:55:00',3.03),('1444','2013-07-26','13:00:00',2.64),('1444','2013-07-26','13:10:00',1.29),('1444','2013-07-26','13:15:00',1.37),('1444','2013-07-26','13:20:00',1.22),('1444','2013-07-26','13:25:00',1.56),('1444','2013-07-26','13:30:00',2.64),('1444','2013-07-26','13:35:00',3.13),('1444','2013-07-26','13:40:00',3.04),('1444','2013-07-26','13:45:00',2.22),('1444','2013-07-26','13:50:00',1.75),('1444','2013-07-26','13:55:00',3.06),('1444','2013-07-26','14:00:00',2.94),('1444','2013-07-26','14:05:00',3.08),('1444','2013-07-26','14:10:00',3.01),('1444','2013-07-26','14:15:00',2.52),('1444','2013-07-26','14:20:00',2.89),('1444','2013-07-26','14:25:00',2.86),('1444','2013-07-26','14:30:00',2.85),('1444','2013-07-26','14:35:00',2.85),('1444','2013-07-26','14:40:00',2.79),('1444','2013-07-26','14:45:00',2.78),('1444','2013-07-26','14:50:00',2.74),('1444','2013-07-26','14:55:00',2.71),('1444','2013-07-26','15:00:00',2.69),('1444','2013-07-26','15:05:00',2.65),('1444','2013-07-26','15:10:00',2.63),('1444','2013-07-26','15:15:00',2.63),('1444','2013-07-26','15:20:00',2.57),('1444','2013-07-26','15:25:00',2.54),('1444','2013-07-26','15:30:00',2.51),('1444','2013-07-26','15:35:00',2.49),('1444','2013-07-26','15:40:00',2.48),('1444','2013-07-26','15:45:00',2.44),('1444','2013-07-26','15:50:00',2.42),('1444','2013-07-26','15:55:00',2.38),('1444','2013-07-26','16:00:00',2.34),('1444','2013-07-26','16:05:00',2.31),('1444','2013-07-26','16:10:00',2.26),('1444','2013-07-26','16:15:00',2.23),('1444','2013-07-26','16:20:00',2.18),('1444','2013-07-26','16:25:00',2.16),('1444','2013-07-26','16:30:00',2.11),('1444','2013-07-26','16:35:00',2.06),('1444','2013-07-26','16:40:00',2),('1444','2013-07-26','16:45:00',1.97),('1444','2013-07-26','16:50:00',1.93),('1444','2013-07-26','16:55:00',1.85),('1444','2013-07-26','17:00:00',1.81),('1444','2013-07-26','17:05:00',1.77),('1444','2013-07-26','17:10:00',1.72),('1444','2013-07-26','17:15:00',1.65),('1444','2013-07-26','17:20:00',1.6),('1444','2013-07-26','17:25:00',1.56),('1444','2013-07-26','17:30:00',1.5),('1444','2013-07-26','17:35:00',1.43),('1444','2013-07-26','17:40:00',1.38),('1444','2013-07-26','17:45:00',1.33),('1444','2013-07-26','17:50:00',1.23),('1444','2013-07-26','17:55:00',1.17),('1444','2013-07-26','18:00:00',1.11),('1444','2013-07-26','18:05:00',1.08),('1444','2013-07-26','18:10:00',1.01),('1444','2013-07-25','08:15:00',1),('1444','2013-07-25','08:20:00',1.06),('1444','2013-07-25','08:25:00',1.11),('1444','2013-07-25','08:30:00',1.14),('1444','2013-07-25','08:35:00',1.2),('1444','2013-07-25','08:40:00',1.17),('1444','2013-07-25','08:45:00',1.33),('1444','2013-07-25','08:50:00',1.41),('1444','2013-07-25','08:55:00',1.48),('1444','2013-07-25','09:00:00',1.49),('1444','2013-07-25','09:05:00',1.6),('1444','2013-07-25','09:10:00',1.7),('1444','2013-07-25','09:15:00',1.6),('1444','2013-07-25','09:25:00',1.85),('1444','2013-07-25','09:30:00',2.04),('1444','2013-07-25','09:35:00',1.25),('1444','2013-07-25','09:40:00',1.72),('1444','2013-07-25','09:45:00',1.6),('1444','2013-07-25','09:50:00',1.97),('1444','2013-07-25','09:55:00',1.25),('1444','2013-07-25','10:00:00',1.58),('1444','2013-07-25','10:05:00',2.11),('1444','2013-07-25','10:10:00',2.21),('1444','2013-07-25','10:15:00',2.11),('1444','2013-07-25','10:20:00',1.17),('1444','2013-07-25','10:25:00',2.35),('1444','2013-07-25','10:30:00',1.91),('1444','2013-07-25','10:35:00',1.68),('1444','2013-07-25','10:40:00',2.59),('1444','2013-07-25','10:45:00',2.57),('1444','2013-07-25','10:50:00',2.54),('1444','2013-07-25','10:55:00',2.57),('1444','2013-07-25','11:00:00',2.63),('1444','2013-07-25','11:05:00',2.68),('1444','2013-07-25','11:10:00',2.69),('1444','2013-07-25','11:15:00',2.77),('1444','2013-07-25','11:20:00',2.79),('1444','2013-07-25','11:25:00',2.77),('1444','2013-07-25','11:30:00',2.68),('1444','2013-07-25','11:35:00',2.78),('1444','2013-07-25','11:40:00',1.45),('1444','2013-07-25','11:45:00',1.1),('1444','2013-07-25','11:50:00',3.18),('1444','2013-07-25','11:55:00',3.07),('1444','2013-07-25','12:00:00',2.01),('1444','2013-07-25','12:10:00',1.72),('1444','2013-07-25','12:15:00',2.63),('1444','2013-07-25','12:20:00',2.47),('1444','2013-07-25','12:25:00',3.24),('1444','2013-07-25','12:30:00',3.18),('1444','2013-07-25','12:35:00',2.92),('1444','2013-07-25','12:40:00',3.08),('1444','2013-07-25','12:45:00',1.86),('1444','2013-07-25','12:50:00',3.12),('1444','2013-07-25','12:55:00',3.08),('1444','2013-07-25','13:00:00',3.07),('1444','2013-07-25','13:05:00',3.02),('1444','2013-07-25','13:10:00',3.09),('1444','2013-07-25','13:15:00',3.08),('1444','2013-07-25','13:20:00',3.05),('1444','2013-07-25','13:25:00',3),('1444','2013-07-25','13:30:00',3.06),('1444','2013-07-25','13:35:00',3.03),('1444','2013-07-25','13:40:00',3.02),('1444','2013-07-25','13:45:00',3.03),('1444','2013-07-25','13:50:00',3.08),('1444','2013-07-25','13:55:00',3.03),('1444','2013-07-25','14:00:00',3.02),('1444','2013-07-25','14:05:00',3.01),('1444','2013-07-25','14:10:00',2.98),('1444','2013-07-25','14:15:00',2.94),('1444','2013-07-25','14:20:00',2.94),('1444','2013-07-25','14:25:00',2.95),('1444','2013-07-25','14:30:00',2.93),('1444','2013-07-25','14:35:00',2.93),('1444','2013-07-25','14:40:00',2.92),('1444','2013-07-25','14:45:00',2.89),('1444','2013-07-25','14:50:00',2.86),('1444','2013-07-25','14:55:00',2.84),('1444','2013-07-25','15:00:00',2.81),('1444','2013-07-25','15:05:00',2.77),('1444','2013-07-25','15:10:00',2.73),('1444','2013-07-25','15:15:00',2.72),('1444','2013-07-25','15:20:00',2.7),('1444','2013-07-25','15:25:00',2.66),('1444','2013-07-25','15:30:00',2.64),('1444','2013-07-25','15:35:00',2.61),('1444','2013-07-25','15:40:00',2.57),('1444','2013-07-25','15:45:00',2.55),('1444','2013-07-25','15:50:00',2.52),('1444','2013-07-25','15:55:00',2.48),('1444','2013-07-25','16:00:00',2.44),('1444','2013-07-25','16:05:00',2.4),('1444','2013-07-25','16:10:00',2.36),('1444','2013-07-25','16:15:00',2.31),('1444','2013-07-25','16:20:00',2.26),('1444','2013-07-25','16:25:00',2.22),('1444','2013-07-25','16:30:00',2.15),('1444','2013-07-25','16:35:00',2.12),('1444','2013-07-25','16:40:00',2.08),('1444','2013-07-25','16:45:00',2.07),('1444','2013-07-25','16:50:00',1.99),('1444','2013-07-25','16:55:00',1.94),('1444','2013-07-25','17:00:00',1.9),('1444','2013-07-25','17:05:00',1.87),('1444','2013-07-25','17:10:00',1.81),('1444','2013-07-25','17:15:00',1.76),('1444','2013-07-25','17:20:00',1.69),('1444','2013-07-25','17:25:00',1.65),('1444','2013-07-25','17:30:00',1.59),('1444','2013-07-25','17:35:00',1.54),('1444','2013-07-25','17:40:00',1.49),('1444','2013-07-25','17:45:00',1.42),('1444','2013-07-25','17:50:00',1.35),('1444','2013-07-25','17:55:00',1.31),('1444','2013-07-25','18:00:00',1.24),('1444','2013-07-25','18:05:00',1.18),('1444','2013-07-25','18:10:00',1.12),('1444','2013-07-25','18:15:00',1.05),('1444','2013-07-24','08:40:00',1.01),('1444','2013-07-24','08:45:00',1.43),('1444','2013-07-24','08:50:00',1.45),('1444','2013-07-24','08:55:00',1.48),('1444','2013-07-24','09:00:00',1.48),('1444','2013-07-24','09:05:00',1.63),('1444','2013-07-24','09:10:00',1.04),('1444','2013-07-24','09:15:00',1.1),('1444','2013-07-24','09:20:00',1.72),('1444','2013-07-24','09:25:00',1.36),('1444','2013-07-24','09:30:00',1.76),('1444','2013-07-24','09:35:00',1.57),('1444','2013-07-24','09:40:00',1.15),('1444','2013-07-24','09:45:00',1.23),('1444','2013-07-24','10:20:00',1.95),('1444','2013-07-24','10:25:00',2.58),('1444','2013-07-24','10:30:00',2.5),('1444','2013-07-24','10:35:00',2.59),('1444','2013-07-24','10:40:00',1.3),('1444','2013-07-24','10:45:00',1.65),('1444','2013-07-24','10:50:00',1.63),('1444','2013-07-24','10:55:00',1.32),('1444','2013-07-24','11:05:00',2.36),('1444','2013-07-24','11:10:00',2.85),('1444','2013-07-24','11:15:00',2.84),('1444','2013-07-24','11:20:00',2.72),('1444','2013-07-24','11:25:00',2.47),('1444','2013-07-24','11:30:00',1.27),('1444','2013-07-24','11:35:00',2.13),('1444','2013-07-24','11:40:00',2.91),('1444','2013-07-24','11:45:00',2.88),('1444','2013-07-24','11:50:00',2.7),('1444','2013-07-24','11:55:00',2.82),('1444','2013-07-24','12:00:00',2.93),('1444','2013-07-24','12:05:00',2.73),('1444','2013-07-24','12:10:00',3.22),('1444','2013-07-24','12:15:00',3.19),('1444','2013-07-24','12:20:00',1.91),('1444','2013-07-24','12:25:00',1.66),('1444','2013-07-24','12:30:00',1.24),('1444','2013-07-24','12:35:00',2.19),('1444','2013-07-24','12:40:00',3.37),('1444','2013-07-24','12:45:00',2.44),('1444','2013-07-24','12:50:00',2.94),('1444','2013-07-24','12:55:00',3.12),('1444','2013-07-24','13:00:00',3.14),('1444','2013-07-24','13:05:00',3.08),('1444','2013-07-24','13:10:00',3.08),('1444','2013-07-24','13:15:00',2.45),('1444','2013-07-24','13:20:00',2.17),('1444','2013-07-24','13:25:00',2.43),('1444','2013-07-24','13:30:00',3.03),('1444','2013-07-24','13:35:00',1.04),('1444','2013-07-24','13:45:00',1.9),('1444','2013-07-24','13:50:00',3.14),('1444','2013-07-24','13:55:00',1.6),('1444','2013-07-24','14:00:00',3.27),('1444','2013-07-24','14:05:00',3.03),('1444','2013-07-24','14:10:00',3.02),('1444','2013-07-24','14:15:00',2.17),('1444','2013-07-24','14:20:00',2.99),('1444','2013-07-24','14:25:00',2.95),('1444','2013-07-24','14:30:00',3.15),('1444','2013-07-24','14:35:00',3.11),('1444','2013-07-24','14:40:00',2.86),('1444','2013-07-24','14:45:00',3.02),('1444','2013-07-24','14:50:00',2.99),('1444','2013-07-24','14:55:00',2.96),('1444','2013-07-24','15:00:00',2.9),('1444','2013-07-24','15:05:00',2.85),('1444','2013-07-24','15:10:00',2.82),('1444','2013-07-24','15:15:00',2.8),('1444','2013-07-24','15:20:00',2.77),('1444','2013-07-24','15:25:00',2.75),('1444','2013-07-24','15:30:00',2.63),('1444','2013-07-24','15:35:00',2.56),('1444','2013-07-24','15:40:00',2.64),('1444','2013-07-24','15:45:00',2.58),('1444','2013-07-24','15:50:00',2.5),('1444','2013-07-24','15:55:00',2.5),('1444','2013-07-24','16:00:00',2.46),('1444','2013-07-24','16:05:00',2.39),('1444','2013-07-24','16:10:00',2.39),('1444','2013-07-24','16:15:00',2.32),('1444','2013-07-24','16:20:00',2.35),('1444','2013-07-24','16:25:00',2.31),('1444','2013-07-24','16:30:00',2.29),('1444','2013-07-24','16:35:00',2.24),('1444','2013-07-24','16:40:00',2.2),('1444','2013-07-24','16:45:00',2.11),('1444','2013-07-24','16:50:00',2.11),('1444','2013-07-24','16:55:00',2.14),('1444','2013-07-24','17:00:00',2.08),('1444','2013-07-24','17:05:00',2.01),('1444','2013-07-24','17:10:00',1.87),('1444','2013-07-24','17:15:00',1.82),('1444','2013-07-24','17:20:00',1.76),('1444','2013-07-24','17:25:00',1.69),('1444','2013-07-24','17:30:00',1.63),('1444','2013-07-24','17:35:00',1.58),('1444','2013-07-24','17:40:00',1.49),('1444','2013-07-24','17:45:00',1.42),('1444','2013-07-24','17:50:00',1.34),('1444','2013-07-24','17:55:00',1.29),('1444','2013-07-24','18:00:00',1.22),('1444','2013-07-24','18:05:00',1.15),('1444','2013-07-24','18:10:00',1.12),('1444','2013-07-24','18:15:00',1.03),('1444','2013-07-23','08:10:00',1.05),('1444','2013-07-23','08:15:00',1.12),('1444','2013-07-23','08:20:00',1.19),('1444','2013-07-23','08:25:00',1.25),('1444','2013-07-23','08:30:00',1.3),('1444','2013-07-23','08:35:00',1.35),('1444','2013-07-23','08:40:00',1.41),('1444','2013-07-23','08:45:00',1.47),('1444','2013-07-23','08:50:00',1.53),('1444','2013-07-23','08:55:00',1.59),('1444','2013-07-23','09:00:00',1.64),('1444','2013-07-23','09:05:00',1.69),('1444','2013-07-23','09:10:00',1.73),('1444','2013-07-23','09:15:00',1.76),('1444','2013-07-23','09:20:00',1.82),('1444','2013-07-23','09:25:00',1.85),('1444','2013-07-23','09:30:00',1.88),('1444','2013-07-23','09:35:00',1.94),('1444','2013-07-23','09:40:00',1.97),('1444','2013-07-23','09:45:00',2.01),('1444','2013-07-23','09:50:00',2.06),('1444','2013-07-23','09:55:00',2.09),('1444','2013-07-23','10:00:00',2.11),('1444','2013-07-23','10:05:00',2.18),('1444','2013-07-23','10:10:00',2.19),('1444','2013-07-23','10:15:00',2.2),('1444','2013-07-23','10:20:00',2.31),('1444','2013-07-23','10:25:00',2.37),('1444','2013-07-23','10:30:00',2.42),('1444','2013-07-23','10:35:00',2.47),('1444','2013-07-23','10:40:00',2.49),('1444','2013-07-23','10:45:00',2.51),('1444','2013-07-23','10:50:00',2.56),('1444','2013-07-23','10:55:00',2.58),('1444','2013-07-23','11:00:00',2.61),('1444','2013-07-23','11:05:00',2.64),('1444','2013-07-23','11:10:00',2.68),('1444','2013-07-23','11:15:00',2.73),('1444','2013-07-23','11:20:00',2.72),('1444','2013-07-23','11:25:00',2.75),('1444','2013-07-23','11:30:00',2.75),('1444','2013-07-23','11:35:00',2.8),('1444','2013-07-23','11:40:00',2.85),('1444','2013-07-23','11:45:00',2.88),('1444','2013-07-23','11:50:00',2.91),('1444','2013-07-23','11:55:00',2.9),('1444','2013-07-23','12:00:00',2.97),('1444','2013-07-23','12:05:00',2.95),('1444','2013-07-23','12:10:00',3),('1444','2013-07-23','12:15:00',3.05),('1444','2013-07-23','12:20:00',3.04),('1444','2013-07-23','12:25:00',2.93),('1444','2013-07-23','12:30:00',2.56),('1444','2013-07-23','12:45:00',1.29),('1444','2013-07-23','12:50:00',1.02),('1444','2013-07-23','12:55:00',2.27),('1444','2013-07-23','13:00:00',1.56),('1444','2013-07-23','13:35:00',2.65),('1444','2013-07-23','13:40:00',1.23),('1444','2013-07-23','13:55:00',1.23),('1444','2013-07-23','14:00:00',2.78),('1444','2013-07-23','14:05:00',3.08),('1444','2013-07-23','14:25:00',1.17),('1444','2013-07-23','14:30:00',2.14),('1444','2013-07-23','14:35:00',1.16),('1444','2013-07-23','14:45:00',2.31),('1444','2013-07-23','14:50:00',2.37),('1444','2013-07-23','14:55:00',2.94),('1444','2013-07-23','15:00:00',3.2),('1444','2013-07-23','15:05:00',2.79),('1444','2013-07-23','15:10:00',2.88),('1444','2013-07-23','15:15:00',2.82),('1444','2013-07-23','15:20:00',2.74),('1444','2013-07-23','15:25:00',2.71),('1444','2013-07-23','15:30:00',2.68),('1444','2013-07-23','15:35:00',2.65),('1444','2013-07-23','15:40:00',2.51),('1444','2013-07-23','15:45:00',2.49),('1444','2013-07-23','15:50:00',2.51),('1444','2013-07-23','15:55:00',2.48),('1444','2013-07-23','16:00:00',2.41),('1444','2013-07-23','16:05:00',2.38),('1444','2013-07-23','16:10:00',2.33),('1444','2013-07-23','16:15:00',2.29),('1444','2013-07-23','16:20:00',2.26),('1444','2013-07-23','16:25:00',2.21),('1444','2013-07-23','16:30:00',2.17),('1444','2013-07-23','16:35:00',2.11),('1444','2013-07-23','16:40:00',2.07),('1444','2013-07-23','16:45:00',2.04),('1444','2013-07-23','16:50:00',2.01),('1444','2013-07-23','16:55:00',1.95),('1444','2013-07-23','17:00:00',1.9),('1444','2013-07-23','17:05:00',1.84),('1444','2013-07-23','17:10:00',1.81),('1444','2013-07-23','17:15:00',1.76),('1444','2013-07-23','17:20:00',1.71),('1444','2013-07-23','17:25:00',1.68),('1444','2013-07-23','17:30:00',1.61),('1444','2013-07-23','17:35:00',1.57),('1444','2013-07-23','17:40:00',1.52),('1444','2013-07-23','17:45:00',1.46),('1444','2013-07-23','17:50:00',1.39),('1444','2013-07-23','17:55:00',1.34),('1444','2013-07-23','18:00:00',1.29),('1444','2013-07-23','18:05:00',1.22),('1444','2013-07-23','18:10:00',1.16),('1444','2013-07-23','18:15:00',1.11),('1444','2013-07-23','18:20:00',1.05),('1444','2013-07-22','08:10:00',1.05),('1444','2013-07-22','08:15:00',1.11),('1444','2013-07-22','08:20:00',1.17),('1444','2013-07-22','08:25:00',1.22),('1444','2013-07-22','08:30:00',1.29),('1444','2013-07-22','08:35:00',1.34),('1444','2013-07-22','08:40:00',1.4),('1444','2013-07-22','08:45:00',1.47),('1444','2013-07-22','08:50:00',1.52),('1444','2013-07-22','08:55:00',1.58),('1444','2013-07-22','09:00:00',1.63),('1444','2013-07-22','09:05:00',1.68),('1444','2013-07-22','09:10:00',1.73),('1444','2013-07-22','09:15:00',1.78),('1444','2013-07-22','09:20:00',1.84),('1444','2013-07-22','09:25:00',1.88),('1444','2013-07-22','09:30:00',1.93),('1444','2013-07-22','09:35:00',1.98),('1444','2013-07-22','09:40:00',2.02),('1444','2013-07-22','09:45:00',2.07),('1444','2013-07-22','09:50:00',2.11),('1444','2013-07-22','09:55:00',2.15),('1444','2013-07-22','10:00:00',2.19),('1444','2013-07-22','10:05:00',2.24),('1444','2013-07-22','10:10:00',2.29),('1444','2013-07-22','10:15:00',2.33),('1444','2013-07-22','10:20:00',2.39),('1444','2013-07-22','10:25:00',2.43),('1444','2013-07-22','10:30:00',2.46),('1444','2013-07-22','10:35:00',2.49),('1444','2013-07-22','10:40:00',2.52),('1444','2013-07-22','10:45:00',2.55),('1444','2013-07-22','10:50:00',2.58),('1444','2013-07-22','10:55:00',2.59),('1444','2013-07-22','11:00:00',2.62),('1444','2013-07-22','11:05:00',2.65),('1444','2013-07-22','11:10:00',2.68),('1444','2013-07-22','11:15:00',2.68),('1444','2013-07-22','11:20:00',2.73),('1444','2013-07-22','11:25:00',2.77),('1444','2013-07-22','11:30:00',2.76),('1444','2013-07-22','11:35:00',2.77),('1444','2013-07-22','11:40:00',2.78),('1444','2013-07-22','11:45:00',2.81),('1444','2013-07-22','11:50:00',2.83),('1444','2013-07-22','11:55:00',2.84),('1444','2013-07-22','12:00:00',2.85),('1444','2013-07-22','12:05:00',2.88),('1444','2013-07-22','12:10:00',2.92),('1444','2013-07-22','12:15:00',2.93),('1444','2013-07-22','12:20:00',2.94),('1444','2013-07-22','12:25:00',2.93),('1444','2013-07-22','12:30:00',2.95),('1444','2013-07-22','12:35:00',2.97),('1444','2013-07-22','12:40:00',3.01),('1444','2013-07-22','12:45:00',3.01),('1444','2013-07-22','12:50:00',2.98),('1444','2013-07-22','12:55:00',2.97),('1444','2013-07-22','13:00:00',2.97),('1444','2013-07-22','13:05:00',3),('1444','2013-07-22','13:10:00',3.03),('1444','2013-07-22','13:15:00',3.01),('1444','2013-07-22','13:20:00',3.01),('1444','2013-07-22','13:25:00',3.03),('1444','2013-07-22','13:30:00',3.01),('1444','2013-07-22','13:35:00',3),('1444','2013-07-22','13:40:00',2.99),('1444','2013-07-22','13:45:00',3.05),('1444','2013-07-22','13:50:00',3.01),('1444','2013-07-22','13:55:00',2.98),('1444','2013-07-22','14:00:00',2.95),('1444','2013-07-22','14:05:00',2.93),('1444','2013-07-22','14:10:00',2.91),('1444','2013-07-22','14:15:00',2.91),('1444','2013-07-22','14:20:00',2.89),('1444','2013-07-22','14:25:00',2.87),('1444','2013-07-22','14:30:00',2.85),('1444','2013-07-22','14:35:00',2.84),('1444','2013-07-22','14:40:00',2.82),('1444','2013-07-22','14:45:00',2.81),('1444','2013-07-22','14:50:00',2.83),('1444','2013-07-22','14:55:00',2.8),('1444','2013-07-22','15:00:00',2.74),('1444','2013-07-22','15:05:00',2.72),('1444','2013-07-22','15:10:00',2.77),('1444','2013-07-22','15:15:00',2.69),('1444','2013-07-22','15:20:00',2.65),('1444','2013-07-22','15:25:00',2.65),('1444','2013-07-22','15:30:00',1.63),('1444','2013-07-22','15:45:00',1.31),('1444','2013-07-22','15:50:00',2.74),('1444','2013-07-22','15:55:00',2.77),('1444','2013-07-22','16:00:00',2.79),('1444','2013-07-22','16:05:00',2.66),('1444','2013-07-22','16:10:00',2.45),('1444','2013-07-22','16:15:00',2.55),('1444','2013-07-22','16:20:00',2.48),('1444','2013-07-22','16:25:00',2.38),('1444','2013-07-22','16:30:00',2.25),('1444','2013-07-22','16:35:00',2.2),('1444','2013-07-22','16:40:00',2.05),('1444','2013-07-22','16:45:00',1.98),('1444','2013-07-22','16:50:00',1.97),('1444','2013-07-22','16:55:00',1.94),('1444','2013-07-22','17:00:00',1.88),('1444','2013-07-22','17:05:00',1.84),('1444','2013-07-22','17:10:00',1.78),('1444','2013-07-22','17:15:00',1.73),('1444','2013-07-22','17:20:00',1.69),('1444','2013-07-22','17:25:00',1.58),('1444','2013-07-22','17:30:00',1.51),('1444','2013-07-22','17:35:00',1.54),('1444','2013-07-22','17:40:00',1.49),('1444','2013-07-22','17:45:00',1.34),('1444','2013-07-22','17:50:00',1.25),('1444','2013-07-22','17:55:00',1.27),('1444','2013-07-22','18:00:00',1.27),('1444','2013-07-22','18:05:00',1.19),('1444','2013-07-22','18:10:00',1.09),('1444','2013-07-22','18:15:00',1.01),('1444','2013-07-21','08:15:00',1.05),('1444','2013-07-21','08:20:00',1.09),('1444','2013-07-21','08:25:00',1.16),('1444','2013-07-21','08:30:00',1.23),('1444','2013-07-21','08:35:00',1.29),('1444','2013-07-21','08:40:00',1.34),('1444','2013-07-21','08:45:00',1.38),('1444','2013-07-21','08:50:00',1.44),('1444','2013-07-21','08:55:00',1.5),('1444','2013-07-21','09:00:00',1.56),('1444','2013-07-21','09:05:00',1.61),('1444','2013-07-21','09:10:00',1.66),('1444','2013-07-21','09:15:00',1.72),('1444','2013-07-21','09:20:00',1.76),('1444','2013-07-21','09:25:00',1.81),('1444','2013-07-21','09:30:00',1.86),('1444','2013-07-21','09:35:00',1.91),('1444','2013-07-21','09:40:00',1.95),('1444','2013-07-21','09:45:00',2),('1444','2013-07-21','09:50:00',2.04),('1444','2013-07-21','09:55:00',2.09),('1444','2013-07-21','10:00:00',2.12),('1444','2013-07-21','10:05:00',2.2),('1444','2013-07-21','10:10:00',2.22),('1444','2013-07-21','10:15:00',2.26),('1444','2013-07-21','10:20:00',2.31),('1444','2013-07-21','10:25:00',2.35),('1444','2013-07-21','10:30:00',2.38),('1444','2013-07-21','10:35:00',2.41),('1444','2013-07-21','10:40:00',2.45),('1444','2013-07-21','10:45:00',2.45),('1444','2013-07-21','10:50:00',2.5),('1444','2013-07-21','10:55:00',2.53),('1444','2013-07-21','11:00:00',2.57),('1444','2013-07-21','11:05:00',2.61),('1444','2013-07-21','11:10:00',2.63),('1444','2013-07-21','11:15:00',2.67),('1444','2013-07-21','11:20:00',2.67),('1444','2013-07-21','11:25:00',2.7),('1444','2013-07-21','11:30:00',2.77),('1444','2013-07-21','11:35:00',2.77),('1444','2013-07-21','11:40:00',2.83),('1444','2013-07-21','11:45:00',2.86),('1444','2013-07-21','11:50:00',2.83),('1444','2013-07-21','11:55:00',2.84),('1444','2013-07-21','12:00:00',2.87),('1444','2013-07-21','12:05:00',2.91),('1444','2013-07-21','12:17:00',2.85),('1444','2013-07-21','12:25:00',3.36),('1444','2013-07-21','12:30:00',2.89),('1444','2013-07-21','12:35:00',3.12),('1444','2013-07-21','12:40:00',3.57),('1444','2013-07-21','12:45:00',3.6),('1444','2013-07-21','12:57:00',3.52),('1444','2013-07-21','13:05:00',3.54),('1444','2013-07-21','13:10:00',2.98),('1444','2013-07-21','13:15:00',1.96),('1444','2013-07-21','13:20:00',3.02),('1444','2013-07-21','13:25:00',3.34),('1444','2013-07-21','13:37:00',3.4),('1444','2013-07-21','13:45:00',3.02),('1444','2013-07-21','13:50:00',2.24),('1444','2013-07-21','14:21:00',1.09),('1444','2013-07-21','14:25:00',1.06),('1444','2013-07-21','14:55:00',1.2),('1444','2013-07-21','15:01:00',1.25),('1444','2013-07-21','15:05:00',1.35),('1444','2013-07-21','15:10:00',1.33),('1444','2013-07-21','15:15:00',2.69),('1444','2013-07-21','15:27:00',3.06),('1444','2013-07-21','15:30:00',1.08),('1444','2013-07-21','15:35:00',1.24),('1444','2013-07-21','15:40:00',2.4),('1444','2013-07-21','15:45:00',2.63),('1444','2013-07-21','15:50:00',2.23),('1444','2013-07-21','15:55:00',1.73),('1444','2013-07-21','17:10:00',1.02),('1444','2014-04-07','08:35:00',1.2),('1444','2014-04-07','08:40:00',1.27),('1444','2014-04-07','08:45:00',1.14),('1444','2014-04-07','08:50:00',1.09),('1444','2014-04-07','09:10:00',1.09),('1444','2014-04-07','09:15:00',1.27),('1444','2014-04-07','09:50:00',1.04),('1444','2014-04-07','09:55:00',1.08),('1444','2014-04-07','10:00:00',1.09),('1444','2014-04-07','10:05:00',1.09),('1444','2014-04-07','10:10:00',1.11),('1444','2014-04-07','10:15:00',1.03),('1444','2014-04-07','10:20:00',1.03),('1444','2014-04-07','10:25:00',1.06),('1444','2014-04-07','10:30:00',1.08),('1444','2014-04-07','10:35:00',1.15),('1444','2014-04-07','10:40:00',1.17),('1444','2014-04-07','10:45:00',1.21),('1444','2014-04-07','10:50:00',1.27),('1444','2014-04-07','10:55:00',1.36),('1444','2014-04-07','11:00:00',1.51),('1444','2014-04-07','11:05:00',1.49),('1444','2014-04-07','11:10:00',1.67),('1444','2014-04-07','11:15:00',1.77),('1444','2014-04-07','11:20:00',1.76),('1444','2014-04-07','11:25:00',1.58),('1444','2014-04-07','11:30:00',1.56),('1444','2014-04-07','11:35:00',1.55),('1444','2014-04-07','11:40:00',1.55),('1444','2014-04-07','11:45:00',1.45),('1444','2014-04-07','11:50:00',1.37),('1444','2014-04-07','11:55:00',1.32),('1444','2014-04-07','12:00:00',1.41),('1444','2014-04-07','12:05:00',1.75),('1444','2014-04-07','12:10:00',1.85),('1444','2014-04-07','12:15:00',2.45),('1444','2014-04-07','12:20:00',2.98),('1444','2014-04-07','12:25:00',2.81),('1444','2014-04-07','12:30:00',1.8),('1444','2014-04-07','12:35:00',1.61),('1444','2014-04-07','12:40:00',1.82),('1444','2014-04-07','12:45:00',3),('1444','2014-04-07','12:50:00',3.03),('1444','2014-04-07','12:55:00',2.98),('1444','2014-04-07','13:00:00',2.99),('1444','2014-04-07','13:05:00',2.99),('1444','2014-04-07','13:10:00',2.98),('1444','2014-04-07','13:15:00',2.95),('1444','2014-04-07','13:20:00',2.94),('1444','2014-04-07','13:25:00',2.94),('1444','2014-04-07','13:30:00',2.96),('1444','2014-04-07','13:35:00',2.97),('1444','2014-04-07','13:40:00',2.93),('1444','2014-04-07','13:45:00',2.93),('1444','2014-04-07','13:50:00',2.95),('1444','2014-04-07','13:55:00',2.97),('1444','2014-04-07','14:00:00',2.95),('1444','2014-04-07','14:05:00',2.93),('1444','2014-04-07','14:10:00',2.9),('1444','2014-04-07','14:15:00',2.85),('1444','2014-04-07','14:20:00',2.84),('1444','2014-04-07','14:25:00',2.89),('1444','2014-04-07','14:30:00',2.89),('1444','2014-04-07','14:35:00',2.81),('1444','2014-04-07','14:40:00',2.77),('1444','2014-04-07','14:45:00',2.77),('1444','2014-04-07','14:50:00',2.75),('1444','2014-04-07','14:55:00',2.71),('1444','2014-04-07','15:00:00',2.35),('1444','2014-04-07','15:05:00',2.73),('1444','2014-04-07','15:10:00',2.68),('1444','2014-04-07','15:15:00',2.76),('1444','2014-04-07','15:20:00',2.83),('1444','2014-04-07','15:25:00',2.82),('1444','2014-04-07','15:30:00',2.62),('1444','2014-04-07','15:35:00',2.58),('1444','2014-04-07','15:40:00',2.55),('1444','2014-04-07','15:45:00',2.57),('1444','2014-04-07','15:50:00',2.7),('1444','2014-04-07','15:55:00',2.68),('1444','2014-04-07','16:00:00',2.1),('1444','2014-04-07','16:05:00',1.45),('1444','2014-04-07','16:10:00',2.28),('1444','2014-04-07','16:15:00',2.17),('1444','2014-04-07','16:20:00',2.02),('1444','2014-04-07','16:25:00',1.96),('1444','2014-04-07','16:30:00',1.85),('1444','2014-04-07','16:35:00',1.05),('1444','2014-04-07','16:40:00',1.28),('1444','2014-04-07','16:45:00',1.29),('1444','2014-04-07','16:50:00',1.77),('1444','2014-04-07','16:55:00',1.84),('1444','2014-04-07','17:00:00',1.89),('1444','2014-04-07','17:05:00',1.79),('1444','2014-04-07','17:10:00',1.43),('1444','2014-04-07','17:15:00',1.45),('1444','2014-04-07','17:20:00',1.26),('1444','2013-07-20','08:10:00',1.06),('1444','2013-07-20','08:15:00',1.11),('1444','2013-07-20','08:20:00',1.17),('1444','2013-07-20','08:25:00',1.23),('1444','2013-07-20','08:30:00',1.29),('1444','2013-07-20','08:35:00',1.34),('1444','2013-07-20','08:40:00',1.41),('1444','2013-07-20','08:45:00',1.48),('1444','2013-07-20','08:50:00',1.51),('1444','2013-07-20','08:55:00',1.59),('1444','2013-07-20','09:00:00',1.63),('1444','2013-07-20','09:05:00',1.72),('1444','2013-07-20','09:10:00',1.81),('1444','2013-07-20','09:15:00',1.88),('1444','2013-07-20','09:20:00',1.9),('1444','2013-07-20','09:25:00',1.86),('1444','2013-07-20','09:30:00',1.83),('1444','2013-07-20','09:35:00',1.82),('1444','2013-07-20','09:40:00',1.8),('1444','2013-07-20','09:45:00',2.09),('1444','2013-07-20','09:50:00',2.01),('1444','2013-07-20','09:55:00',1.95),('1444','2013-07-20','10:00:00',2.07),('1444','2013-07-20','10:05:00',2.2),('1444','2013-07-20','10:10:00',2.27),('1444','2013-07-20','10:15:00',2.32),('1444','2013-07-20','10:20:00',2.36),('1444','2013-07-20','10:25:00',2.38),('1444','2013-07-20','10:30:00',2.43),('1444','2013-07-20','10:35:00',2.44),('1444','2013-07-20','10:40:00',2.49),('1444','2013-07-20','10:45:00',2.49),('1444','2013-07-20','10:50:00',2.55),('1444','2013-07-20','10:55:00',2.6),('1444','2013-07-20','11:00:00',2.64),('1444','2013-07-20','11:05:00',2.64),('1444','2013-07-20','11:10:00',2.66),('1444','2013-07-20','11:15:00',2.66),('1444','2013-07-20','11:20:00',2.65),('1444','2013-07-20','11:25:00',2.69),('1444','2013-07-20','11:30:00',2.64),('1444','2013-07-20','11:35:00',2.75),('1444','2013-07-20','11:40:00',2.78),('1444','2013-07-20','11:45:00',2.77),('1444','2013-07-20','11:50:00',2.66),('1444','2013-07-20','11:55:00',2.87),('1444','2013-07-20','12:00:00',2.87),('1444','2013-07-20','12:05:00',2.93),('1444','2013-07-20','12:10:00',2.89),('1444','2013-07-20','12:15:00',2.89),('1444','2013-07-20','12:20:00',2.97),('1444','2013-07-20','12:25:00',2.92),('1444','2013-07-20','12:30:00',2.93),('1444','2013-07-20','12:35:00',2.99),('1444','2013-07-20','12:40:00',3.03),('1444','2013-07-20','12:45:00',3.04),('1444','2013-07-20','12:50:00',3.02),('1444','2013-07-20','12:55:00',3),('1444','2013-07-20','13:00:00',3.14),('1444','2013-07-20','13:05:00',2.16),('1444','2013-07-20','13:20:00',1.02),('1444','2013-07-20','13:25:00',1.7),('1444','2013-07-20','13:30:00',2.15),('1444','2013-07-20','13:35:00',3.33),('1444','2013-07-20','13:40:00',3.19),('1444','2013-07-20','13:45:00',2.86),('1444','2013-07-20','13:50:00',1.48),('1444','2013-07-20','13:55:00',1.43),('1444','2013-07-20','14:00:00',2.8),('1444','2013-07-20','14:05:00',3.09),('1444','2013-07-20','14:10:00',3.13),('1444','2013-07-20','14:15:00',3.14),('1444','2013-07-20','14:20:00',3.09),('1444','2013-07-20','14:25:00',2.95),('1444','2013-07-20','14:30:00',2.95),('1444','2013-07-20','14:35:00',3),('1444','2013-07-20','14:40:00',2.97),('1444','2013-07-20','14:45:00',2.96),('1444','2013-07-20','14:50:00',3.02),('1444','2013-07-20','14:55:00',3.01),('1444','2013-07-20','15:00:00',2.93),('1444','2013-07-20','15:05:00',2.88),('1444','2013-07-20','15:10:00',2.82),('1444','2013-07-20','15:15:00',2.77),('1444','2013-07-20','15:20:00',2.69),('1444','2013-07-20','15:25:00',2.66),('1444','2013-07-20','15:30:00',2.65),('1444','2013-07-20','15:35:00',2.63),('1444','2013-07-20','15:40:00',2.61),('1444','2013-07-20','15:45:00',2.57),('1444','2013-07-20','15:50:00',2.53),('1444','2013-07-20','15:55:00',2.48),('1444','2013-07-20','16:00:00',2.46),('1444','2013-07-20','16:05:00',2.42),('1444','2013-07-20','16:10:00',2.37),('1444','2013-07-20','16:15:00',2.36),('1444','2013-07-20','16:20:00',2.32),('1444','2013-07-20','16:25:00',2.27),('1444','2013-07-20','16:30:00',2.23),('1444','2013-07-20','16:35:00',2.16),('1444','2013-07-20','16:40:00',2.11),('1444','2013-07-20','16:45:00',2.05),('1444','2013-07-20','16:50:00',2.02),('1444','2013-07-20','16:55:00',1.95),('1444','2013-07-20','17:00:00',1.9),('1444','2013-07-20','17:05:00',1.86),('1444','2013-07-20','17:10:00',1.81),('1444','2013-07-20','17:15:00',1.76),('1444','2013-07-20','17:20:00',1.7),('1444','2013-07-20','17:25:00',1.65),('1444','2013-07-20','17:30:00',1.59),('1444','2013-07-20','17:35:00',1.55),('1444','2013-07-20','17:40:00',1.49),('1444','2013-07-20','17:45:00',1.44),('1444','2013-07-20','17:50:00',1.39),('1444','2013-07-20','17:55:00',1.33),('1444','2013-07-20','18:00:00',1.27),('1444','2013-07-20','18:05:00',1.21),('1444','2013-07-20','18:10:00',1.15),('1444','2013-07-20','18:15:00',1.1),('1444','2013-07-20','18:20:00',1.04),('1444','2013-07-19','08:10:00',1.02),('1444','2013-07-19','08:15:00',1.08),('1444','2013-07-19','08:20:00',1.14),('1444','2013-07-19','08:30:00',1.23),('1444','2013-07-19','08:35:00',1.3),('1444','2013-07-19','08:40:00',1.37),('1444','2013-07-19','08:45:00',1.42),('1444','2013-07-19','08:50:00',1.48),('1444','2013-07-19','08:55:00',1.54),('1444','2013-07-19','09:00:00',1.57),('1444','2013-07-19','09:05:00',1.63),('1444','2013-07-19','09:10:00',1.68),('1444','2013-07-19','09:15:00',1.73),('1444','2013-07-19','09:20:00',1.78),('1444','2013-07-19','09:25:00',1.83),('1444','2013-07-19','09:30:00',1.88),('1444','2013-07-19','09:40:00',1.83),('1444','2013-07-19','09:45:00',2),('1444','2013-07-19','09:50:00',2.02),('1444','2013-07-19','09:55:00',2.05),('1444','2013-07-19','10:00:00',2.08),('1444','2013-07-19','10:05:00',2.12),('1444','2013-07-19','10:10:00',2.18),('1444','2013-07-19','10:15:00',2.23),('1444','2013-07-19','10:20:00',2.26),('1444','2013-07-19','10:25:00',2.27),('1444','2013-07-19','10:30:00',2.31),('1444','2013-07-19','10:35:00',2.37),('1444','2013-07-19','10:40:00',2.4),('1444','2013-07-19','10:45:00',2.42),('1444','2013-07-19','10:50:00',2.43),('1444','2013-07-19','10:55:00',2.46),('1444','2013-07-19','11:00:00',2.47),('1444','2013-07-19','11:05:00',2.53),('1444','2013-07-19','11:10:00',2.58),('1444','2013-07-19','11:15:00',2.6),('1444','2013-07-19','11:20:00',2.6),('1444','2013-07-19','11:25:00',2.63),('1444','2013-07-19','11:30:00',2.67),('1444','2013-07-19','11:35:00',2.67),('1444','2013-07-19','11:40:00',2.73),('1444','2013-07-19','11:45:00',2.78),('1444','2013-07-19','11:50:00',2.79),('1444','2013-07-19','11:55:00',2.75),('1444','2013-07-19','12:00:00',2.89),('1444','2013-07-19','12:05:00',3),('1444','2013-07-19','12:10:00',2.98),('1444','2013-07-19','12:15:00',3.04),('1444','2013-07-19','12:20:00',2.98),('1444','2013-07-19','12:25:00',2.97),('1444','2013-07-19','12:30:00',2.97),('1444','2013-07-19','12:35:00',2.94),('1444','2013-07-19','12:40:00',2.91),('1444','2013-07-19','12:45:00',2.91),('1444','2013-07-19','12:50:00',3.02),('1444','2013-07-19','12:55:00',2.99),('1444','2013-07-19','13:00:00',2.89),('1444','2013-07-19','13:05:00',3.01),('1444','2013-07-19','13:10:00',2.47),('1444','2013-07-19','13:15:00',1.87),('1444','2013-07-19','13:20:00',3.14),('1444','2013-07-19','13:25:00',3.14),('1444','2013-07-19','13:30:00',3.16),('1444','2013-07-19','13:35:00',3.08),('1444','2013-07-19','13:40:00',3.11),('1444','2013-07-19','13:45:00',3.09),('1444','2013-07-19','13:50:00',3.1),('1444','2013-07-19','13:55:00',3.11),('1444','2013-07-19','14:00:00',3.08),('1444','2013-07-19','14:05:00',3),('1444','2013-07-19','14:10:00',2.6),('1444','2013-07-19','14:15:00',3.04),('1444','2013-07-19','14:20:00',3.07),('1444','2013-07-19','14:25:00',3.06),('1444','2013-07-19','14:30:00',3.07),('1444','2013-07-19','14:35:00',2.69),('1444','2013-07-19','14:40:00',2.96),('1444','2013-07-19','14:45:00',2.77),('1444','2013-07-19','14:50:00',2.84),('1444','2013-07-19','14:55:00',2.97),('1444','2013-07-19','15:00:00',2.88),('1444','2013-07-19','15:05:00',2.91),('1444','2013-07-19','15:10:00',2.7),('1444','2013-07-19','15:15:00',1.61),('1444','2013-07-19','15:20:00',2.42),('1444','2013-07-19','15:25:00',2.57),('1444','2013-07-19','15:30:00',2.82),('1444','2013-07-19','15:35:00',2.81),('1444','2013-07-19','15:40:00',2.22),('1444','2013-07-19','15:45:00',2.71),('1444','2013-07-19','15:50:00',2.62),('1444','2013-07-19','15:55:00',2.58),('1444','2013-07-19','16:00:00',2.51),('1444','2013-07-19','16:05:00',2.49),('1444','2013-07-19','16:10:00',2.46),('1444','2013-07-19','16:15:00',2.43),('1444','2013-07-19','16:20:00',2.41),('1444','2013-07-19','16:25:00',2.35),('1444','2013-07-19','16:30:00',2.33),('1444','2013-07-19','16:35:00',2.3),('1444','2013-07-19','16:40:00',2.24),('1444','2013-07-19','16:45:00',2.22),('1444','2013-07-19','16:50:00',2.21),('1444','2013-07-19','16:55:00',2.16),('1444','2013-07-19','17:00:00',2.2),('1444','2013-07-19','17:05:00',1.83),('1444','2013-07-19','17:10:00',1.95),('1444','2013-07-19','17:15:00',1.74),('1444','2013-07-19','17:20:00',1.74),('1444','2013-07-19','17:25:00',1.32),('1444','2013-07-19','17:30:00',1.66),('1444','2013-07-19','17:35:00',1.82),('1444','2013-07-19','17:40:00',1.48),('1444','2013-07-19','17:45:00',1.14),('1444','2013-07-18','08:05:00',1.04),('1444','2013-07-18','08:10:00',1.1),('1444','2013-07-18','08:15:00',1.15),('1444','2013-07-18','08:20:00',1.21),('1444','2013-07-18','08:25:00',1.27),('1444','2013-07-18','08:30:00',1.33),('1444','2013-07-18','08:35:00',1.38),('1444','2013-07-18','08:40:00',1.44),('1444','2013-07-18','08:45:00',1.5),('1444','2013-07-18','08:50:00',1.56),('1444','2013-07-18','08:55:00',1.61),('1444','2013-07-18','09:00:00',1.66),('1444','2013-07-18','09:05:00',1.71),('1444','2013-07-18','09:10:00',1.76),('1444','2013-07-18','09:15:00',1.81),('1444','2013-07-18','09:20:00',1.85),('1444','2013-07-18','09:25:00',1.89),('1444','2013-07-18','09:30:00',1.94),('1444','2013-07-18','09:35:00',2),('1444','2013-07-18','09:40:00',2.05),('1444','2013-07-18','09:45:00',2.09),('1444','2013-07-18','09:50:00',2.14),('1444','2013-07-18','09:55:00',2.17),('1444','2013-07-18','10:00:00',2.23),('1444','2013-07-18','10:05:00',2.26),('1444','2013-07-18','10:10:00',2.28),('1444','2013-07-18','10:15:00',2.34),('1444','2013-07-18','10:20:00',2.37),('1444','2013-07-18','10:25:00',2.41),('1444','2013-07-18','10:30:00',2.44),('1444','2013-07-18','10:35:00',2.46),('1444','2013-07-18','10:40:00',2.51),('1444','2013-07-18','10:45:00',2.55),('1444','2013-07-18','10:50:00',2.57),('1444','2013-07-18','10:55:00',2.6),('1444','2013-07-18','11:00:00',2.62),('1444','2013-07-18','11:05:00',2.65),('1444','2013-07-18','11:10:00',2.67),('1444','2013-07-18','11:15:00',2.7),('1444','2013-07-18','11:20:00',2.71),('1444','2013-07-18','11:25:00',2.74),('1444','2013-07-18','11:30:00',2.75),('1444','2013-07-18','11:35:00',2.78),('1444','2013-07-18','11:40:00',2.78),('1444','2013-07-18','11:45:00',2.78),('1444','2013-07-18','11:50:00',2.8),('1444','2013-07-18','11:55:00',2.84),('1444','2013-07-18','12:00:00',2.86),('1444','2013-07-18','12:05:00',2.81),('1444','2013-07-18','12:10:00',2.85),('1444','2013-07-18','12:15:00',2.87),('1444','2013-07-18','12:20:00',2.93),('1444','2013-07-18','12:25:00',2.95),('1444','2013-07-18','12:30:00',3.03),('1444','2013-07-18','12:35:00',3.01),('1444','2013-07-18','12:40:00',3.05),('1444','2013-07-18','12:45:00',3.19),('1444','2013-07-18','12:50:00',3.12),('1444','2013-07-18','12:55:00',3.08),('1444','2013-07-18','13:00:00',3.11),('1444','2013-07-18','13:05:00',3.04),('1444','2013-07-18','13:10:00',3.08),('1444','2013-07-18','13:15:00',3.06),('1444','2013-07-18','13:20:00',3.02),('1444','2013-07-18','13:25:00',3.09),('1444','2013-07-18','13:30:00',2.71),('1444','2013-07-18','13:35:00',3.09),('1444','2013-07-18','13:40:00',3.03),('1444','2013-07-18','13:45:00',3.07),('1444','2013-07-18','13:50:00',3.09),('1444','2013-07-18','13:55:00',3.03),('1444','2013-07-18','14:00:00',2.98),('1444','2013-07-18','14:05:00',2.98),('1444','2013-07-18','14:10:00',2.99),('1444','2013-07-18','14:15:00',2.98),('1444','2013-07-18','14:20:00',2.87),('1444','2013-07-18','14:25:00',2.89),('1444','2013-07-18','14:30:00',2.92),('1444','2013-07-18','14:35:00',2.92),('1444','2013-07-18','14:40:00',2.87),('1444','2013-07-18','14:45:00',2.84),('1444','2013-07-18','14:50:00',2.8),('1444','2013-07-18','14:55:00',2.81),('1444','2013-07-18','15:00:00',2.81),('1444','2013-07-18','15:05:00',2.78),('1444','2013-07-18','15:10:00',2.74),('1444','2013-07-18','15:15:00',2.72),('1444','2013-07-18','15:20:00',2.72),('1444','2013-07-18','15:25:00',2.69),('1444','2013-07-18','15:30:00',2.66),('1444','2013-07-18','15:35:00',2.63),('1444','2013-07-18','15:40:00',2.59),('1444','2013-07-18','15:45:00',2.55),('1444','2013-07-18','15:50:00',2.52),('1444','2013-07-18','15:55:00',2.48),('1444','2013-07-18','16:00:00',2.44),('1444','2013-07-18','16:05:00',2.4),('1444','2013-07-18','16:10:00',2.36),('1444','2013-07-18','16:15:00',2.32),('1444','2013-07-18','16:20:00',2.27),('1444','2013-07-18','16:25:00',2.24),('1444','2013-07-18','16:30:00',2.19),('1444','2013-07-18','16:35:00',2.13),('1444','2013-07-18','16:40:00',2.08),('1444','2013-07-18','16:45:00',2.05),('1444','2013-07-18','16:50:00',2),('1444','2013-07-18','16:55:00',1.92),('1444','2013-07-18','17:00:00',1.88),('1444','2013-07-18','17:05:00',1.83),('1444','2013-07-18','17:10:00',1.79),('1444','2013-07-18','17:15:00',1.73),('1444','2013-07-18','17:20:00',1.7),('1444','2013-07-18','17:25:00',1.64),('1444','2013-07-18','17:30:00',1.57),('1444','2013-07-18','17:35:00',1.48),('1444','2013-07-18','17:40:00',1.38),('1444','2013-07-18','17:45:00',1.38),('1444','2013-07-18','17:50:00',1.31),('1444','2013-07-18','17:55:00',1.18),('1444','2013-07-18','18:00:00',1.13),('1444','2013-07-18','18:10:00',1.04),('1444','2013-07-17','08:00:00',1.01),('1444','2013-07-17','08:05:00',1.08),('1444','2013-07-17','08:10:00',1.14),('1444','2013-07-17','08:15:00',1.21),('1444','2013-07-17','08:20:00',1.28),('1444','2013-07-17','08:25:00',1.33),('1444','2013-07-17','08:30:00',1.39),('1444','2013-07-17','08:35:00',1.46),('1444','2013-07-17','08:40:00',1.52),('1444','2013-07-17','08:45:00',1.58),('1444','2013-07-17','08:50:00',1.63),('1444','2013-07-17','08:55:00',1.69),('1444','2013-07-17','09:00:00',1.74),('1444','2013-07-17','09:05:00',1.79),('1444','2013-07-17','09:10:00',1.86),('1444','2013-07-17','09:15:00',1.91),('1444','2013-07-17','09:20:00',1.97),('1444','2013-07-17','09:25:00',2.03),('1444','2013-07-17','09:30:00',2.07),('1444','2013-07-17','09:35:00',2.11),('1444','2013-07-17','09:40:00',2.15),('1444','2013-07-17','09:45:00',2.21),('1444','2013-07-17','09:50:00',2.24),('1444','2013-07-17','09:55:00',2.28),('1444','2013-07-17','10:00:00',2.33),('1444','2013-07-17','10:05:00',2.36),('1444','2013-07-17','10:10:00',2.4),('1444','2013-07-17','10:15:00',2.44),('1444','2013-07-17','10:20:00',2.48),('1444','2013-07-17','10:25:00',2.5),('1444','2013-07-17','10:30:00',2.54),('1444','2013-07-17','10:35:00',2.6),('1444','2013-07-17','10:40:00',2.61),('1444','2013-07-17','10:45:00',2.62),('1444','2013-07-17','10:50:00',2.67),('1444','2013-07-17','10:55:00',2.7),('1444','2013-07-17','11:00:00',2.73),('1444','2013-07-17','11:05:00',2.78),('1444','2013-07-17','11:10:00',2.82),('1444','2013-07-17','11:15:00',2.84),('1444','2013-07-17','11:20:00',2.87),('1444','2013-07-17','11:25:00',2.89),('1444','2013-07-17','11:30:00',2.9),('1444','2013-07-17','11:35:00',2.9),('1444','2013-07-17','11:40:00',2.93),('1444','2013-07-17','11:45:00',2.95),('1444','2013-07-17','11:50:00',2.97),('1444','2013-07-17','11:55:00',2.98),('1444','2013-07-17','12:00:00',3.02),('1444','2013-07-17','12:05:00',3.05),('1444','2013-07-17','12:10:00',3.04),('1444','2013-07-17','12:15:00',3.06),('1444','2013-07-17','12:20:00',3.06),('1444','2013-07-17','12:25:00',3.04),('1444','2013-07-17','12:30:00',3.08),('1444','2013-07-17','12:35:00',3.09),('1444','2013-07-17','12:40:00',3.07),('1444','2013-07-17','12:45:00',3.07),('1444','2013-07-17','12:50:00',3.06),('1444','2013-07-17','12:55:00',3.06),('1444','2013-07-17','13:00:00',3.06),('1444','2013-07-17','13:05:00',3.11),('1444','2013-07-17','13:10:00',3.08),('1444','2013-07-17','13:15:00',3.07),('1444','2013-07-17','13:20:00',3.09),('1444','2013-07-17','13:25:00',3.05),('1444','2013-07-17','13:30:00',3.02),('1444','2013-07-17','13:35:00',3.05),('1444','2013-07-17','13:40:00',3.01),('1444','2013-07-17','13:45:00',3.02),('1444','2013-07-17','13:50:00',3),('1444','2013-07-17','13:55:00',2.9),('1444','2013-07-17','14:00:00',3.03),('1444','2013-07-17','14:05:00',3.03),('1444','2013-07-17','14:10:00',3.04),('1444','2013-07-17','14:15:00',3.02),('1444','2013-07-17','14:20:00',2.97),('1444','2013-07-17','14:25:00',2.95),('1444','2013-07-17','14:30:00',2.94),('1444','2013-07-17','14:35:00',2.92),('1444','2013-07-17','14:40:00',2.95),('1444','2013-07-17','14:45:00',2.91),('1444','2013-07-17','14:50:00',2.86),('1444','2013-07-17','14:55:00',2.11),('1444','2013-07-17','15:00:00',2.46),('1444','2013-07-17','15:05:00',2.86),('1444','2013-07-17','15:10:00',2.78),('1444','2013-07-17','15:15:00',2.76),('1444','2013-07-17','15:20:00',2.75),('1444','2013-07-17','15:25:00',2.74),('1444','2013-07-17','15:30:00',2.73),('1444','2013-07-17','15:35:00',2.7),('1444','2013-07-17','15:40:00',2.69),('1444','2013-07-17','15:45:00',2.58),('1444','2013-07-17','15:50:00',2.48),('1444','2013-07-17','15:55:00',2.38),('1444','2013-07-17','16:00:00',2.49),('1444','2013-07-17','16:05:00',2.46),('1444','2013-07-17','16:10:00',2.46),('1444','2013-07-17','16:15:00',2.42),('1444','2013-07-17','16:20:00',2.33),('1444','2013-07-17','16:25:00',2.21),('1444','2013-07-17','16:30:00',2.18),('1444','2013-07-17','16:35:00',2.2),('1444','2013-07-17','16:40:00',1.8),('1444','2013-07-17','16:45:00',2.06),('1444','2013-07-17','16:50:00',2.03),('1444','2013-07-17','16:55:00',1.96),('1444','2013-07-17','17:00:00',1.97),('1444','2013-07-17','17:05:00',1.91),('1444','2013-07-17','17:10:00',1.88),('1444','2013-07-17','17:15:00',1.82),('1444','2013-07-17','17:20:00',1.75),('1444','2013-07-17','17:25:00',1.67),('1444','2013-07-17','17:30:00',1.61),('1444','2013-07-17','17:35:00',1.58),('1444','2013-07-17','17:40:00',1.5),('1444','2013-07-17','17:45:00',1.45),('1444','2013-07-17','17:50:00',1.4),('1444','2013-07-17','17:55:00',1.33),('1444','2013-07-17','18:00:00',1.27),('1444','2013-07-17','18:05:00',1.23),('1444','2013-07-17','18:10:00',1.16),('1444','2013-07-17','18:15:00',1.11),('1444','2013-07-17','18:20:00',1.05),('1444','2013-07-16','08:05:00',1.04),('1444','2013-07-16','08:10:00',1.1),('1444','2013-07-16','08:15:00',1.15),('1444','2013-07-16','08:20:00',1.21),('1444','2013-07-16','08:25:00',1.28),('1444','2013-07-16','08:30:00',1.34),('1444','2013-07-16','08:35:00',1.4),('1444','2013-07-16','08:40:00',1.45),('1444','2013-07-16','08:45:00',1.5),('1444','2013-07-16','08:50:00',1.56),('1444','2013-07-16','08:55:00',1.63),('1444','2013-07-16','09:00:00',1.69),('1444','2013-07-16','09:05:00',1.74),('1444','2013-07-16','09:10:00',1.79),('1444','2013-07-16','09:15:00',1.83),('1444','2013-07-16','09:20:00',1.87),('1444','2013-07-16','09:25:00',1.91),('1444','2013-07-16','09:30:00',1.96),('1444','2013-07-16','09:35:00',2.02),('1444','2013-07-16','09:40:00',2.08),('1444','2013-07-16','09:45:00',2.12),('1444','2013-07-16','09:50:00',2.15),('1444','2013-07-16','09:55:00',2.22),('1444','2013-07-16','10:00:00',2.26),('1444','2013-07-16','10:05:00',2.3),('1444','2013-07-16','10:10:00',2.34),('1444','2013-07-16','10:15:00',2.38),('1444','2013-07-16','10:20:00',2.45),('1444','2013-07-16','10:25:00',2.48),('1444','2013-07-16','10:30:00',2.55),('1444','2013-07-16','10:35:00',2.57),('1444','2013-07-16','10:40:00',2.6),('1444','2013-07-16','10:45:00',2.63),('1444','2013-07-16','10:50:00',2.66),('1444','2013-07-16','10:55:00',2.7),('1444','2013-07-16','11:00:00',2.73),('1444','2013-07-16','11:05:00',2.75),('1444','2013-07-16','11:10:00',2.79),('1444','2013-07-16','11:15:00',2.81),('1444','2013-07-16','11:20:00',2.83),('1444','2013-07-16','11:25:00',2.85),('1444','2013-07-16','11:30:00',2.86),('1444','2013-07-16','11:35:00',2.87),('1444','2013-07-16','11:40:00',2.87),('1444','2013-07-16','11:45:00',2.9),('1444','2013-07-16','11:50:00',2.95),('1444','2013-07-16','11:55:00',3),('1444','2013-07-16','12:00:00',3.01),('1444','2013-07-16','12:05:00',3.04),('1444','2013-07-16','12:10:00',3.07),('1444','2013-07-16','12:15:00',3.08),('1444','2013-07-16','12:20:00',3.09),('1444','2013-07-16','12:25:00',3.09),('1444','2013-07-16','12:30:00',3.05),('1444','2013-07-16','12:35:00',3.05),('1444','2013-07-16','12:40:00',3.05),('1444','2013-07-16','12:45:00',3.07),('1444','2013-07-16','12:50:00',3.02),('1444','2013-07-16','12:55:00',3.01),('1444','2013-07-16','13:00:00',3),('1444','2013-07-16','13:05:00',3.04),('1444','2013-07-16','13:10:00',3.05),('1444','2013-07-16','13:15:00',3.06),('1444','2013-07-16','13:20:00',3.11),('1444','2013-07-16','13:25:00',3.08),('1444','2013-07-16','13:30:00',3.1),('1444','2013-07-16','13:35:00',3.06),('1444','2013-07-16','13:40:00',3.11),('1444','2013-07-16','13:45:00',3.16),('1444','2013-07-16','13:50:00',3.22),('1444','2013-07-16','13:55:00',3.13),('1444','2013-07-16','14:00:00',3),('1444','2013-07-16','14:05:00',3.07),('1444','2013-07-16','14:10:00',1.72),('1444','2013-07-16','14:15:00',3.02),('1444','2013-07-16','14:20:00',1.34),('1444','2013-07-16','14:25:00',2.16),('1444','2013-07-16','14:30:00',3.05),('1444','2013-07-16','14:35:00',2.98),('1444','2013-07-16','14:40:00',2.98),('1444','2013-07-16','14:45:00',2.92),('1444','2013-07-16','14:50:00',2.91),('1444','2013-07-16','14:55:00',2.93),('1444','2013-07-16','15:00:00',2.9),('1444','2013-07-16','15:05:00',2.84),('1444','2013-07-16','15:10:00',2.8),('1444','2013-07-16','15:15:00',2.77),('1444','2013-07-16','15:20:00',2.75),('1444','2013-07-16','15:25:00',2.75),('1444','2013-07-16','15:30:00',2.75),('1444','2013-07-16','15:35:00',2.38),('1444','2013-07-16','15:40:00',2.64),('1444','2013-07-16','15:45:00',2.08),('1444','2013-07-16','15:50:00',2.46),('1444','2013-07-16','15:55:00',2.52),('1444','2013-07-16','16:00:00',2.44),('1444','2013-07-16','16:05:00',1.84),('1444','2013-07-16','16:10:00',1.76),('1444','2013-07-16','16:15:00',1.54),('1444','2013-07-16','16:20:00',1.21),('1444','2013-07-16','16:25:00',1.5),('1444','2013-07-16','16:50:00',1.1),('1444','2013-07-16','16:55:00',1.37),('1444','2013-07-16','17:00:00',1.93),('1444','2013-07-16','17:05:00',2.23),('1444','2013-07-16','17:10:00',2.12),('1444','2013-07-16','17:15:00',1.86),('1444','2013-07-16','17:20:00',1),('1444','2013-07-16','17:25:00',1.61),('1444','2013-07-16','17:30:00',1.46),('1444','2013-07-16','17:35:00',1.33),('1444','2013-07-16','17:40:00',1.63),('1444','2013-07-16','17:45:00',1.66),('1444','2013-07-16','17:50:00',1.47),('1444','2013-07-16','18:05:00',1.06),('1444','2013-07-16','18:15:00',1.1),('1444','2013-07-15','08:00:00',1.04),('1444','2013-07-15','08:05:00',1.1),('1444','2013-07-15','08:10:00',1.16),('1444','2013-07-15','08:15:00',1.23),('1444','2013-07-15','08:20:00',1.29),('1444','2013-07-15','08:25:00',1.35),('1444','2013-07-15','08:30:00',1.4),('1444','2013-07-15','08:35:00',1.46),('1444','2013-07-15','08:40:00',1.53),('1444','2013-07-15','08:45:00',1.58),('1444','2013-07-15','08:50:00',1.64),('1444','2013-07-15','08:55:00',1.69),('1444','2013-07-15','09:00:00',1.75),('1444','2013-07-15','09:05:00',1.8),('1444','2013-07-15','09:10:00',1.86),('1444','2013-07-15','09:15:00',1.91),('1444','2013-07-15','09:20:00',1.96),('1444','2013-07-15','09:25:00',2.01),('1444','2013-07-15','09:30:00',2.06),('1444','2013-07-15','09:35:00',2.11),('1444','2013-07-15','09:40:00',2.14),('1444','2013-07-15','09:45:00',2.18),('1444','2013-07-15','09:50:00',2.23),('1444','2013-07-15','09:55:00',2.27),('1444','2013-07-15','10:00:00',2.32),('1444','2013-07-15','10:05:00',2.36),('1444','2013-07-15','10:10:00',2.4),('1444','2013-07-15','10:15:00',2.43),('1444','2013-07-15','10:20:00',2.47),('1444','2013-07-15','10:25:00',2.5),('1444','2013-07-15','10:30:00',2.52),('1444','2013-07-15','10:35:00',2.56),('1444','2013-07-15','10:40:00',2.59),('1444','2013-07-15','10:45:00',2.61),('1444','2013-07-15','10:50:00',2.63),('1444','2013-07-15','10:55:00',2.68),('1444','2013-07-15','11:00:00',2.72),('1444','2013-07-15','11:05:00',2.73),('1444','2013-07-15','11:10:00',2.77),('1444','2013-07-15','11:15:00',2.78),('1444','2013-07-15','11:20:00',2.79),('1444','2013-07-15','11:25:00',2.82),('1444','2013-07-15','11:30:00',2.83),('1444','2013-07-15','11:35:00',2.85),('1444','2013-07-15','11:40:00',2.88),('1444','2013-07-15','11:45:00',2.89),('1444','2013-07-15','11:50:00',2.9),('1444','2013-07-15','11:55:00',2.91),('1444','2013-07-15','12:00:00',2.96),('1444','2013-07-15','12:05:00',3),('1444','2013-07-15','12:10:00',3.02),('1444','2013-07-15','12:15:00',3),('1444','2013-07-15','12:20:00',3.06),('1444','2013-07-15','12:25:00',3.08),('1444','2013-07-15','12:30:00',3.08),('1444','2013-07-15','12:35:00',3.08),('1444','2013-07-15','12:40:00',3.07),('1444','2013-07-15','12:45:00',3.04),('1444','2013-07-15','12:50:00',2.99),('1444','2013-07-15','12:55:00',2.93),('1444','2013-07-15','13:00:00',3.07),('1444','2013-07-15','13:05:00',3.1),('1444','2013-07-15','13:10:00',2.5),('1444','2013-07-15','13:15:00',3.1),('1444','2013-07-15','13:20:00',3.1),('1444','2013-07-15','13:25:00',3.01),('1444','2013-07-15','13:30:00',3.24),('1444','2013-07-15','13:35:00',3.34),('1444','2013-07-15','13:40:00',2.11),('1444','2013-07-15','13:45:00',1.78),('1444','2013-07-15','13:55:00',1.61),('1444','2013-07-15','14:00:00',2.81),('1444','2013-07-15','14:05:00',3.06),('1444','2013-07-15','14:10:00',2.85),('1444','2013-07-15','14:25:00',2.61),('1444','2013-07-15','14:30:00',3.22),('1444','2013-07-15','14:35:00',3.14),('1444','2013-07-15','14:40:00',3),('1444','2013-07-15','14:45:00',1.93),('1444','2013-07-15','14:50:00',3.08),('1444','2013-07-15','14:55:00',3.06),('1444','2013-07-15','15:00:00',3.01),('1444','2013-07-15','15:05:00',2.94),('1444','2013-07-15','15:10:00',2.87),('1444','2013-07-15','15:15:00',2.83),('1444','2013-07-15','15:20:00',2.55),('1444','2013-07-15','15:30:00',2.58),('1444','2013-07-15','15:35:00',2.85),('1444','2013-07-15','15:40:00',2.78),('1444','2013-07-15','15:45:00',2.68),('1444','2013-07-15','15:50:00',2.61),('1444','2013-07-15','15:55:00',2.58),('1444','2013-07-15','16:00:00',2.49),('1444','2013-07-15','16:05:00',2.45),('1444','2013-07-15','16:10:00',2.41),('1444','2013-07-15','16:15:00',2.36),('1444','2013-07-15','16:20:00',2.28),('1444','2013-07-15','16:25:00',2.24),('1444','2013-07-15','16:30:00',2.23),('1444','2013-07-15','16:35:00',2.18),('1444','2013-07-15','16:40:00',2.14),('1444','2013-07-15','16:45:00',2.09),('1444','2013-07-15','16:50:00',2.04),('1444','2013-07-15','16:55:00',2),('1444','2013-07-15','17:00:00',1.93),('1444','2013-07-15','17:05:00',1.89),('1444','2013-07-15','17:10:00',1.84),('1444','2013-07-15','17:15:00',1.78),('1444','2013-07-15','17:20:00',1.73),('1444','2013-07-15','17:25:00',1.69),('1444','2013-07-15','17:30:00',1.63),('1444','2013-07-15','17:35:00',1.55),('1444','2013-07-15','17:40:00',1.5),('1444','2013-07-15','17:45:00',1.44),('1444','2013-07-15','17:50:00',1.38),('1444','2013-07-15','17:55:00',1.32),('1444','2013-07-15','18:00:00',1.26),('1444','2013-07-15','18:05:00',1.2),('1444','2013-07-15','18:10:00',1.15),('1444','2013-07-15','18:15:00',1.08),('1444','2013-07-15','18:20:00',1.02),('1444','2013-07-14','07:50:00',1.11),('1444','2013-07-14','07:55:00',1.24),('1444','2013-07-14','08:00:00',1.22),('1444','2013-07-14','08:05:00',1.34),('1444','2013-07-14','08:10:00',1.31),('1444','2013-07-14','08:20:00',1.18),('1444','2013-07-14','09:10:00',1.18),('1444','2013-07-14','09:15:00',1.16),('1444','2013-07-14','09:20:00',1.52),('1444','2013-07-14','09:25:00',1.63),('1444','2013-07-14','09:30:00',1.6),('1444','2013-07-14','09:35:00',1.66),('1444','2013-07-14','09:40:00',1.28),('1444','2013-07-14','09:45:00',1.23),('1444','2013-07-14','09:50:00',1.21),('1444','2013-07-14','09:55:00',1.18),('1444','2013-07-14','10:00:00',1.15),('1444','2013-07-14','10:05:00',1.31),('1444','2013-07-14','10:10:00',1.24),('1444','2013-07-14','10:15:00',1.18),('1444','2013-07-14','10:20:00',1.48),('1444','2013-07-14','10:25:00',2.27),('1444','2013-07-14','10:30:00',1.97),('1444','2013-07-14','10:35:00',2.46),('1444','2013-07-14','10:40:00',2.39),('1444','2013-07-14','10:45:00',1.99),('1444','2013-07-14','10:50:00',2.81),('1444','2013-07-14','10:55:00',2.47),('1444','2013-07-14','11:00:00',1.66),('1444','2013-07-14','11:05:00',1.24),('1444','2013-07-14','11:10:00',1.14),('1444','2013-07-14','11:15:00',2.72),('1444','2013-07-14','11:20:00',3.03),('1444','2013-07-14','11:25:00',2.19),('1444','2013-07-14','11:30:00',1.74),('1444','2013-07-14','11:35:00',1.99),('1444','2013-07-14','11:40:00',1.49),('1444','2013-07-14','11:45:00',1.01),('1444','2013-07-14','11:50:00',1.24),('1444','2013-07-14','11:55:00',3.06),('1444','2013-07-14','12:00:00',2.69),('1444','2013-07-14','12:05:00',3.3),('1444','2013-07-14','12:10:00',3.38),('1444','2013-07-14','12:15:00',3),('1444','2013-07-14','12:20:00',2.86),('1444','2013-07-14','12:25:00',3.28),('1444','2013-07-14','12:30:00',3.31),('1444','2013-07-14','12:35:00',2.28),('1444','2013-07-14','12:40:00',3.42),('1444','2013-07-14','12:45:00',2.96),('1444','2013-07-14','12:50:00',3.26),('1444','2013-07-14','12:55:00',2.88),('1444','2013-07-14','13:00:00',1.22),('1444','2013-07-14','13:05:00',2.65),('1444','2013-07-14','13:10:00',3.39),('1444','2013-07-14','13:15:00',3.26),('1444','2013-07-14','13:20:00',3.21),('1444','2013-07-14','13:25:00',3.14),('1444','2013-07-14','13:30:00',3.08),('1444','2013-07-14','13:35:00',3.09),('1444','2013-07-14','13:40:00',3.15),('1444','2013-07-14','13:45:00',3.16),('1444','2013-07-14','13:50:00',3.18),('1444','2013-07-14','13:55:00',3.14),('1444','2013-07-14','14:00:00',3.14),('1444','2013-07-14','14:05:00',3.15),('1444','2013-07-14','14:10:00',3.14),('1444','2013-07-14','14:15:00',3.13),('1444','2013-07-14','14:20:00',3.12),('1444','2013-07-14','14:25:00',3.07),('1444','2013-07-14','14:30:00',3.03),('1444','2013-07-14','14:35:00',3.01),('1444','2013-07-14','14:40:00',2.96),('1444','2013-07-14','14:45:00',2.92),('1444','2013-07-14','14:50:00',2.89),('1444','2013-07-14','14:55:00',2.84),('1444','2013-07-14','15:00:00',2.84),('1444','2013-07-14','15:05:00',2.82),('1444','2013-07-14','15:10:00',2.79),('1444','2013-07-14','15:15:00',2.77),('1444','2013-07-14','15:20:00',2.75),('1444','2013-07-14','15:25:00',2.71),('1444','2013-07-14','15:30:00',2.67),('1444','2013-07-14','15:35:00',2.65),('1444','2013-07-14','15:40:00',2.62),('1444','2013-07-14','15:45:00',2.56),('1444','2013-07-14','15:50:00',2.52),('1444','2013-07-14','15:55:00',2.5),('1444','2013-07-14','16:00:00',2.51),('1444','2013-07-14','16:05:00',2.46),('1444','2013-07-14','16:10:00',2.42),('1444','2013-07-14','16:15:00',2.31),('1444','2013-07-14','16:20:00',2.17),('1444','2013-07-14','16:25:00',1.82),('1444','2013-07-14','16:30:00',1.99),('1444','2013-07-14','16:35:00',2.36),('1444','2013-07-14','16:40:00',2.29),('1444','2013-07-14','16:45:00',1.94),('1444','2013-07-14','16:55:00',1.74),('1444','2013-07-14','17:00:00',1.77),('1444','2013-07-14','17:05:00',1.46),('1444','2013-07-14','17:10:00',1.62),('1444','2013-07-14','17:15:00',1.88),('1444','2013-07-14','17:25:00',1.83),('1444','2013-07-14','17:30:00',1.7),('1444','2013-07-14','17:35:00',1.55),('1444','2013-07-14','17:40:00',1.48),('1444','2013-07-14','17:45:00',1.32),('1444','2013-07-14','17:55:00',1.02),('1444','2013-07-14','18:00:00',1.38),('1444','2013-07-14','18:05:00',1.07),('1444','2013-07-13','08:05:00',1.03),('1444','2013-07-13','08:10:00',1.08),('1444','2013-07-13','08:15:00',1.14),('1444','2013-07-13','08:20:00',1.21),('1444','2013-07-13','08:25:00',1.25),('1444','2013-07-13','08:30:00',1.31),('1444','2013-07-13','08:35:00',1.36),('1444','2013-07-13','08:40:00',1.41),('1444','2013-07-13','08:45:00',1.45),('1444','2013-07-13','08:50:00',1.52),('1444','2013-07-13','08:55:00',1.58),('1444','2013-07-13','09:00:00',1.65),('1444','2013-07-13','09:05:00',1.7),('1444','2013-07-13','09:10:00',1.76),('1444','2013-07-13','09:15:00',1.81),('1444','2013-07-13','09:20:00',1.86),('1444','2013-07-13','09:25:00',1.92),('1444','2013-07-13','09:30:00',1.96),('1444','2013-07-13','09:35:00',1.99),('1444','2013-07-13','09:40:00',2.03),('1444','2013-07-13','09:45:00',2.08),('1444','2013-07-13','09:50:00',2.13),('1444','2013-07-13','09:55:00',2.17),('1444','2013-07-13','10:00:00',2.21),('1444','2013-07-13','10:05:00',2.26),('1444','2013-07-13','10:10:00',2.29),('1444','2013-07-13','10:15:00',2.23),('1444','2013-07-13','10:20:00',1.89),('1444','2013-07-13','10:25:00',1.8),('1444','2013-07-13','10:30:00',2.38),('1444','2013-07-13','10:35:00',2.51),('1444','2013-07-13','10:40:00',2.56),('1444','2013-07-13','10:45:00',2.64),('1444','2013-07-13','10:50:00',2.7),('1444','2013-07-13','10:55:00',2.74),('1444','2013-07-13','11:00:00',2.91),('1444','2013-07-13','11:05:00',1.91),('1444','2013-07-13','11:10:00',2.29),('1444','2013-07-13','11:15:00',2.23),('1444','2013-07-13','11:30:00',2.81),('1444','2013-07-13','11:35:00',3.13),('1444','2013-07-13','11:40:00',1.07),('1444','2013-07-13','11:50:00',2.94),('1444','2013-07-13','11:55:00',2.65),('1444','2013-07-13','12:00:00',1.78),('1444','2013-07-13','12:05:00',2.16),('1444','2013-07-13','12:10:00',2.56),('1444','2013-07-13','12:15:00',3.21),('1444','2013-07-13','12:25:00',2.71),('1444','2013-07-13','12:30:00',3),('1444','2013-07-13','12:35:00',2.32),('1444','2013-07-13','12:40:00',3.29),('1444','2013-07-13','12:45:00',2.85),('1444','2013-07-13','12:55:00',1.34),('1444','2013-07-13','13:00:00',3.4),('1444','2013-07-13','13:05:00',3.32),('1444','2013-07-13','13:10:00',3.21),('1444','2013-07-13','13:15:00',2.97),('1444','2013-07-13','13:20:00',3.14),('1444','2013-07-13','13:25:00',3.1),('1444','2013-07-13','13:30:00',3.12),('1444','2013-07-13','13:35:00',3.15),('1444','2013-07-13','13:40:00',3.12),('1444','2013-07-13','13:45:00',3.12),('1444','2013-07-13','13:50:00',3.1),('1444','2013-07-13','13:55:00',3.09),('1444','2013-07-13','14:00:00',3.1),('1444','2013-07-13','14:05:00',3.1),('1444','2013-07-13','14:10:00',3.08),('1444','2013-07-13','14:15:00',3.04),('1444','2013-07-13','14:20:00',3.03),('1444','2013-07-13','14:25:00',3.03),('1444','2013-07-13','14:30:00',3.02),('1444','2013-07-13','14:35:00',2.98),('1444','2013-07-13','14:40:00',2.96),('1444','2013-07-13','14:45:00',2.97),('1444','2013-07-13','14:50:00',2.94),('1444','2013-07-13','14:55:00',2.93),('1444','2013-07-13','15:00:00',2.9),('1444','2013-07-13','15:05:00',2.91),('1444','2013-07-13','15:10:00',2.9),('1444','2013-07-13','15:15:00',2.86),('1444','2013-07-13','15:20:00',2.69),('1444','2013-07-13','15:25:00',2.84),('1444','2013-07-13','15:30:00',2.73),('1444','2013-07-13','15:35:00',2.77),('1444','2013-07-13','15:40:00',2.72),('1444','2013-07-13','15:45:00',2.68),('1444','2013-07-13','15:50:00',2.64),('1444','2013-07-13','15:55:00',2.61),('1444','2013-07-13','16:00:00',2.58),('1444','2013-07-13','16:05:00',2.53),('1444','2013-07-13','16:10:00',2.5),('1444','2013-07-13','16:15:00',2.43),('1444','2013-07-13','16:20:00',2.4),('1444','2013-07-13','16:25:00',2.38),('1444','2013-07-13','16:30:00',2.33),('1444','2013-07-13','16:35:00',2.28),('1444','2013-07-13','16:40:00',2.23),('1444','2013-07-13','16:45:00',2.19),('1444','2013-07-13','16:50:00',2.11),('1444','2013-07-13','16:55:00',2.06),('1444','2013-07-13','17:00:00',1.99),('1444','2013-07-13','17:05:00',1.9),('1444','2013-07-13','17:10:00',1.9),('1444','2013-07-13','17:15:00',1.85),('1444','2013-07-13','17:20:00',1.74),('1444','2013-07-13','17:25:00',1.77),('1444','2013-07-13','17:30:00',1.65),('1444','2013-07-13','17:35:00',1.6),('1444','2013-07-13','17:40:00',1.57),('1444','2013-07-13','17:45:00',1.51),('1444','2013-07-13','17:50:00',1.42),('1444','2013-07-13','17:55:00',1.44),('1444','2013-07-13','18:00:00',1.32),('1444','2013-07-13','18:05:00',1.21),('1444','2013-07-13','18:10:00',1.21),('1444','2013-07-13','18:15:00',1.16),('1444','2013-07-13','18:20:00',1.11),('1444','2013-07-13','18:25:00',1.08),('1444','2013-07-12','09:15:00',1.08),('1444','2013-07-12','09:20:00',1.62),('1444','2013-07-12','09:25:00',1.8),('1444','2013-07-12','09:30:00',1.27),('1444','2013-07-12','09:35:00',1.85),('1444','2013-07-12','09:40:00',2.03),('1444','2013-07-12','09:45:00',2.1),('1444','2013-07-12','09:50:00',2.17),('1444','2013-07-12','09:55:00',2.18),('1444','2013-07-12','10:00:00',2.17),('1444','2013-07-12','10:05:00',1.98),('1444','2013-07-12','10:10:00',2.25),('1444','2013-07-12','10:15:00',2.48),('1444','2013-07-12','10:20:00',2.09),('1444','2013-07-12','10:25:00',1.46),('1444','2013-07-12','10:45:00',1.84),('1444','2013-07-12','10:50:00',3.01),('1444','2013-07-12','10:55:00',2.95),('1444','2013-07-12','11:00:00',1.83),('1444','2013-07-12','11:05:00',1.45),('1444','2013-07-12','11:10:00',2.6),('1444','2013-07-12','11:15:00',2.13),('1444','2013-07-12','11:20:00',3.12),('1444','2013-07-12','11:25:00',2.31),('1444','2013-07-12','11:30:00',2.4),('1444','2013-07-12','11:35:00',2.94),('1444','2013-07-12','11:40:00',3.18),('1444','2013-07-12','11:45:00',1.12),('1444','2013-07-12','11:50:00',2.79),('1444','2013-07-12','11:55:00',3),('1444','2013-07-12','12:00:00',3.2),('1444','2013-07-12','12:05:00',1.21),('1444','2013-07-12','12:10:00',1.57),('1444','2013-07-12','12:15:00',3.56),('1444','2013-07-12','12:20:00',2.32),('1444','2013-07-12','12:25:00',2.18),('1444','2013-07-12','12:30:00',3.43),('1444','2013-07-12','12:35:00',3.38),('1444','2013-07-12','12:40:00',2.74),('1444','2013-07-12','12:45:00',3.33),('1444','2013-07-12','12:50:00',3.3),('1444','2013-07-12','12:55:00',3.2),('1444','2013-07-12','13:00:00',3.19),('1444','2013-07-12','13:05:00',2.66),('1444','2013-07-12','13:10:00',3.26),('1444','2013-07-12','13:15:00',3.23),('1444','2013-07-12','13:20:00',3.18),('1444','2013-07-12','13:25:00',3.13),('1444','2013-07-12','13:30:00',3.16),('1444','2013-07-12','13:35:00',3.12),('1444','2013-07-12','13:40:00',3.08),('1444','2013-07-12','13:45:00',2.87),('1444','2013-07-12','13:50:00',3.21),('1444','2013-07-12','13:55:00',2.79),('1444','2013-07-12','14:00:00',2.5),('1444','2013-07-12','14:05:00',2.13),('1444','2013-07-12','14:10:00',1.82),('1444','2013-07-12','14:15:00',3.39),('1444','2013-07-12','14:20:00',1.95),('1444','2013-07-12','14:25:00',2.74),('1444','2013-07-12','14:30:00',2.99),('1444','2013-07-12','14:35:00',3.03),('1444','2013-07-12','14:40:00',2.96),('1444','2013-07-12','14:45:00',2.82),('1444','2013-07-12','14:50:00',2.93),('1444','2013-07-12','14:55:00',2.89),('1444','2013-07-12','15:00:00',2.82),('1444','2013-07-12','15:05:00',2.86),('1444','2013-07-12','15:10:00',2.83),('1444','2013-07-12','15:15:00',2.81),('1444','2013-07-12','15:20:00',2.79),('1444','2013-07-12','15:25:00',2.72),('1444','2013-07-12','15:30:00',2.63),('1444','2013-07-12','15:35:00',2.66),('1444','2013-07-12','15:40:00',2.65),('1444','2013-07-12','15:45:00',2.61),('1444','2013-07-12','15:50:00',2.53),('1444','2013-07-12','15:55:00',2.5),('1444','2013-07-12','16:00:00',2.5),('1444','2013-07-12','16:05:00',2.43),('1444','2013-07-12','16:10:00',2.38),('1444','2013-07-12','16:15:00',2.36),('1444','2013-07-12','16:20:00',2.34),('1444','2013-07-12','16:25:00',2.28),('1444','2013-07-12','16:30:00',2.24),('1444','2013-07-12','16:35:00',2.2),('1444','2013-07-12','16:40:00',2.15),('1444','2013-07-12','16:45:00',2.11),('1444','2013-07-12','16:50:00',2.06),('1444','2013-07-12','16:55:00',2.02),('1444','2013-07-12','17:00:00',1.96),('1444','2013-07-12','17:05:00',1.92),('1444','2013-07-12','17:10:00',1.87),('1444','2013-07-12','17:15:00',1.81),('1444','2013-07-12','17:20:00',1.73),('1444','2013-07-12','17:25:00',1.68),('1444','2013-07-12','17:30:00',1.63),('1444','2013-07-12','17:35:00',1.58),('1444','2013-07-12','17:40:00',1.52),('1444','2013-07-12','17:45:00',1.46),('1444','2013-07-12','17:50:00',1.42),('1444','2013-07-12','17:55:00',1.34),('1444','2013-07-12','18:00:00',1.29),('1444','2013-07-12','18:05:00',1.24),('1444','2013-07-12','18:10:00',1.19),('1444','2013-07-12','18:15:00',1.12),('1444','2013-07-12','18:20:00',1.06),('1444','2013-07-11','08:05:00',1.04),('1444','2013-07-11','08:10:00',1.1),('1444','2013-07-11','08:15:00',1.15),('1444','2013-07-11','08:20:00',1.22),('1444','2013-07-11','08:25:00',1.28),('1444','2013-07-11','08:30:00',1.33),('1444','2013-07-11','08:35:00',1.38),('1444','2013-07-11','08:40:00',1.43),('1444','2013-07-11','08:45:00',1.48),('1444','2013-07-11','08:50:00',1.54),('1444','2013-07-11','08:55:00',1.62),('1444','2013-07-11','09:00:00',1.67),('1444','2013-07-11','09:05:00',1.71),('1444','2013-07-11','09:10:00',1.82),('1444','2013-07-11','09:15:00',1.8),('1444','2013-07-11','09:20:00',1.45),('1444','2013-07-11','09:25:00',1.9),('1444','2013-07-11','09:30:00',2.1),('1444','2013-07-11','09:35:00',2.15),('1444','2013-07-11','09:40:00',2.28),('1444','2013-07-11','09:45:00',2.26),('1444','2013-07-11','09:50:00',2.12),('1444','2013-07-11','09:55:00',1.35),('1444','2013-07-11','10:05:00',2.27),('1444','2013-07-11','10:10:00',2.52),('1444','2013-07-11','10:15:00',2.29),('1444','2013-07-11','10:20:00',2.49),('1444','2013-07-11','10:25:00',1.72),('1444','2013-07-11','10:30:00',1.5),('1444','2013-07-11','10:35:00',1.64),('1444','2013-07-11','10:40:00',2.03),('1444','2013-07-11','10:45:00',2.8),('1444','2013-07-11','10:50:00',1.58),('1444','2013-07-11','10:55:00',1.71),('1444','2013-07-11','11:00:00',2.98),('1444','2013-07-11','11:05:00',2.96),('1444','2013-07-11','11:10:00',2.77),('1444','2013-07-11','11:15:00',2.64),('1444','2013-07-11','11:20:00',2.86),('1444','2013-07-11','11:25:00',2.99),('1444','2013-07-11','11:30:00',1.74),('1444','2013-07-11','11:35:00',1.14),('1444','2013-07-11','11:40:00',3.29),('1444','2013-07-11','11:45:00',1.78),('1444','2013-07-11','11:50:00',3.07),('1444','2013-07-11','11:55:00',3.4),('1444','2013-07-11','12:00:00',2.58),('1444','2013-07-11','12:10:00',1.87),('1444','2013-07-11','12:15:00',3.13),('1444','2013-07-11','12:20:00',3.3),('1444','2013-07-11','12:25:00',3.27),('1444','2013-07-11','12:30:00',3.26),('1444','2013-07-11','12:35:00',3.24),('1444','2013-07-11','12:40:00',3.33),('1444','2013-07-11','12:45:00',3.23),('1444','2013-07-11','12:50:00',2.31),('1444','2013-07-11','12:55:00',3.16),('1444','2013-07-11','13:00:00',3.27),('1444','2013-07-11','13:05:00',3.29),('1444','2013-07-11','13:10:00',2.39),('1444','2013-07-11','13:15:00',3.28),('1444','2013-07-11','13:20:00',2.82),('1444','2013-07-11','13:25:00',2.34),('1444','2013-07-11','13:30:00',3.37),('1444','2013-07-11','13:35:00',3.39),('1444','2013-07-11','13:40:00',2.29),('1444','2013-07-11','13:45:00',2.5),('1444','2013-07-11','13:50:00',1.61),('1444','2013-07-11','13:55:00',2.79),('1444','2013-07-11','14:00:00',3.14),('1444','2013-07-11','14:05:00',3.17),('1444','2013-07-11','14:10:00',2.95),('1444','2013-07-11','14:15:00',3.17),('1444','2013-07-11','14:20:00',3.13),('1444','2013-07-11','14:25:00',3.11),('1444','2013-07-11','14:30:00',3.12),('1444','2013-07-11','14:35:00',3.06),('1444','2013-07-11','14:40:00',2.71),('1444','2013-07-11','14:45:00',3.09),('1444','2013-07-11','14:50:00',2.72),('1444','2013-07-11','14:55:00',2.94),('1444','2013-07-11','15:00:00',1.87),('1444','2013-07-11','15:05:00',1.33),('1444','2013-07-11','15:10:00',2.23),('1444','2013-07-11','15:20:00',1.8),('1444','2013-07-11','15:25:00',2.23),('1444','2013-07-11','15:30:00',2.84),('1444','2013-07-11','15:35:00',1.47),('1444','2013-07-11','15:40:00',2.35),('1444','2013-07-11','15:45:00',2.11),('1444','2013-07-11','15:50:00',1.41),('1444','2013-07-11','15:55:00',1.06),('1444','2013-07-11','16:00:00',2.33),('1444','2013-07-11','16:05:00',2.3),('1444','2013-07-11','16:10:00',1.85),('1444','2013-07-11','16:15:00',1.95),('1444','2013-07-11','16:20:00',1.81),('1444','2013-07-11','16:25:00',1.07),('1444','2013-07-11','16:30:00',2.18),('1444','2013-07-11','16:35:00',1.67),('1444','2013-07-11','16:40:00',2.39),('1444','2013-07-11','16:45:00',2.35),('1444','2013-07-11','16:50:00',2.19),('1444','2013-07-11','16:55:00',2.09),('1444','2013-07-11','17:00:00',1.84),('1444','2013-07-11','17:05:00',2.03),('1444','2013-07-11','17:10:00',1.71),('1444','2013-07-11','17:15:00',1.74),('1444','2013-07-11','17:20:00',1.97),('1444','2013-07-11','17:25:00',1.95),('1444','2013-07-11','17:30:00',1.75),('1444','2013-07-11','17:35:00',1.61),('1444','2013-07-11','17:40:00',1.29),('1444','2013-07-11','17:45:00',1.63),('1444','2013-07-11','17:50:00',1.31),('1444','2013-07-11','17:55:00',1.47),('1444','2013-07-11','18:00:00',1.28),('1444','2013-07-11','18:05:00',1.07),('1444','2013-07-11','18:10:00',1.43),('1444','2013-07-11','18:15:00',1.32),('1444','2013-07-11','18:20:00',1.06),('1444','2014-05-03','07:55:00',1.07),('1444','2014-05-03','08:00:00',1.21),('1444','2014-05-03','08:05:00',1.21),('1444','2014-05-03','08:10:00',1.56),('1444','2014-05-03','08:45:00',1.53),('1444','2014-05-03','08:50:00',2.01),('1444','2014-05-03','08:55:00',2.11),('1444','2014-05-03','09:00:00',1.76),('1444','2014-05-03','09:05:00',1.58),('1444','2014-05-03','09:10:00',1.44),('1444','2014-05-03','09:15:00',1.62),('1444','2014-05-03','09:20:00',2.31),('1444','2014-05-03','09:25:00',1.21),('1444','2014-05-03','09:30:00',2.54),('1444','2014-05-03','09:35:00',2.36),('1444','2014-05-03','09:40:00',1.8),('1444','2014-05-03','09:45:00',2.01),('1444','2014-05-03','09:50:00',1.43),('1444','2014-05-03','09:55:00',2.87),('1444','2014-05-03','10:00:00',2.82),('1444','2014-05-03','10:05:00',2.84),('1444','2014-05-03','10:10:00',2.66),('1444','2014-05-03','10:15:00',2.66),('1444','2014-05-03','10:20:00',1.03),('1444','2014-05-03','10:25:00',1.13),('1444','2014-05-03','10:30:00',2.3),('1444','2014-05-03','10:40:00',1.36),('1444','2014-05-03','10:55:00',2.48),('1444','2014-05-03','11:00:00',1.8),('1444','2014-05-03','11:05:00',3.13),('1444','2014-05-03','11:10:00',3.26),('1444','2014-05-03','11:15:00',3.93),('1444','2014-05-03','11:20:00',3.61),('1444','2014-05-03','11:25:00',3.37),('1444','2014-05-03','11:30:00',3.39),('1444','2014-05-03','11:35:00',2.17),('1444','2014-05-03','11:40:00',2.5),('1444','2014-05-03','11:45:00',2.01),('1444','2014-05-03','11:50:00',1.85),('1444','2014-05-03','11:55:00',1.78),('1444','2014-05-03','12:00:00',1.32),('1444','2014-05-03','12:05:00',1.09),('1444','2014-05-03','12:30:00',1.34),('1444','2014-05-03','12:35:00',1.77),('1444','2014-05-03','12:40:00',1.75),('1444','2014-05-03','12:45:00',1.65),('1444','2014-05-03','12:50:00',1.39),('1444','2014-05-03','12:55:00',1.37),('1444','2014-05-03','13:00:00',1.57),('1444','2014-05-03','13:05:00',1.94),('1444','2014-05-03','13:10:00',2.39),('1444','2014-05-03','13:15:00',2.19),('1444','2014-05-03','13:20:00',2.35),('1444','2014-05-03','13:25:00',2.49),('1444','2014-05-03','13:30:00',2.62),('1444','2014-05-03','13:35:00',2.32),('1444','2014-05-03','13:40:00',1.55),('1444','2014-05-03','13:45:00',1.48),('1444','2014-05-03','13:50:00',1.47),('1444','2014-05-03','13:55:00',1.49),('1444','2014-05-03','14:00:00',1.48),('1444','2014-05-03','14:05:00',1.55),('1444','2014-05-03','14:10:00',1.73),('1444','2014-05-03','14:15:00',2.07),('1444','2014-05-03','14:20:00',2.37),('1444','2014-05-03','14:25:00',2.57),('1444','2014-05-03','14:30:00',1.52),('1444','2014-05-03','14:35:00',1.17),('1444','2014-05-03','14:50:00',1.25),('1444','2014-05-03','14:55:00',3.46),('1444','2014-05-03','15:00:00',2.49),('1444','2014-05-03','15:05:00',1.24),('1444','2014-04-06','08:30:00',1.04),('1444','2014-04-06','08:35:00',1.13),('1444','2014-04-06','08:40:00',1.21),('1444','2014-04-06','08:45:00',1.26),('1444','2014-04-06','08:50:00',1.34),('1444','2014-04-06','09:15:00',1.82),('1444','2014-04-06','09:20:00',1.51),('1444','2014-04-06','09:25:00',1.13),('1444','2014-04-06','09:30:00',1.39),('1444','2014-04-06','09:35:00',1.72),('1444','2014-04-06','09:40:00',1.89),('1444','2014-04-06','09:45:00',2.29),('1444','2014-04-06','09:50:00',2.74),('1444','2014-04-06','09:55:00',2.78),('1444','2014-04-06','10:00:00',2.79),('1444','2014-04-06','10:05:00',1.37),('1444','2014-04-06','10:10:00',1.12),('1444','2014-04-06','10:15:00',1.27),('1444','2014-04-06','10:20:00',1.09),('1444','2014-04-06','10:30:00',1.08),('1444','2014-04-06','10:35:00',1.19),('1444','2014-04-06','10:40:00',1.35),('1444','2014-04-06','10:45:00',2.15),('1444','2014-04-06','10:50:00',2.82),('1444','2014-04-06','10:55:00',1.17),('1444','2014-04-06','11:00:00',2.48),('1444','2014-04-06','11:05:00',3.1),('1444','2014-04-06','11:10:00',2.83),('1444','2014-04-06','11:15:00',1.97),('1444','2014-04-06','11:20:00',2.3),('1444','2014-04-06','11:25:00',3.09),('1444','2014-04-06','11:30:00',3.19),('1444','2014-04-06','11:35:00',3.47),('1444','2014-04-06','11:40:00',3.5),('1444','2014-04-06','11:45:00',3.35),('1444','2014-04-06','11:50:00',3.2),('1444','2014-04-06','11:55:00',3.02),('1444','2014-04-06','12:00:00',3.39),('1444','2014-04-06','12:05:00',3.15),('1444','2014-04-06','12:10:00',3.26),('1444','2014-04-06','12:15:00',3.35),('1444','2014-04-06','12:20:00',2.83),('1444','2014-04-06','12:25:00',2.02),('1444','2014-04-06','12:30:00',1.41),('1444','2014-04-06','12:35:00',1.94),('1444','2014-04-06','12:40:00',1.02),('1444','2014-04-06','13:00:00',2.12),('1444','2014-04-06','13:05:00',2.62),('1444','2014-04-06','13:10:00',2.87),('1444','2014-04-06','13:15:00',1.9),('1444','2014-04-06','13:20:00',2.61),('1444','2014-04-06','13:25:00',1.12),('1444','2014-04-06','13:30:00',1.87),('1444','2014-04-06','13:35:00',2.85),('1444','2014-04-06','13:40:00',1.05),('1444','2014-04-06','13:45:00',2.58),('1444','2014-04-06','13:50:00',3.14),('1444','2014-04-06','13:55:00',3.38),('1444','2014-04-06','14:00:00',3.24),('1444','2014-04-06','14:05:00',3.16),('1444','2014-04-06','14:10:00',2.79),('1444','2014-04-06','14:15:00',3.34),('1444','2014-04-06','14:20:00',1.77),('1444','2014-04-06','14:25:00',1.16),('1444','2014-04-06','14:35:00',1.04),('1444','2014-04-06','14:40:00',1.01),('1444','2014-04-06','14:45:00',2.59),('1444','2014-04-06','14:50:00',2.72),('1444','2014-04-06','14:55:00',1.75),('1444','2014-04-06','15:00:00',2.67),('1444','2014-04-06','15:10:00',1.54),('1444','2014-04-06','15:15:00',2.71),('1444','2014-04-06','15:20:00',2.36),('1444','2014-04-06','15:25:00',1.17),('1444','2014-04-06','15:30:00',1.05),('1444','2014-04-06','15:55:00',2.78),('1444','2014-04-06','16:00:00',2.73),('1444','2014-04-06','16:05:00',1.61),('1444','2014-04-06','16:10:00',1.62),('1444','2014-04-06','16:15:00',1.17),('1444','2014-04-06','16:35:00',1.23),('1444','2014-04-06','16:40:00',1.53),('1444','2014-04-06','16:45:00',2.28),('1444','2014-04-06','16:50:00',2.3),('1444','2014-04-06','16:55:00',1.93),('1444','2014-04-06','17:25:00',1.21),('1444','2014-04-06','17:30:00',1.38),('1444','2014-04-06','17:35:00',1.03),('1444','2014-04-06','17:50:00',1.12),('1444','2013-07-10','07:35:00',1.11),('1444','2013-07-10','07:40:00',1.21),('1444','2013-07-10','07:45:00',1.29),('1444','2013-07-10','07:50:00',1.39),('1444','2013-07-10','07:55:00',1.41),('1444','2013-07-10','08:00:00',1.06),('1444','2013-07-10','08:05:00',1.25),('1444','2013-07-10','08:10:00',1.31),('1444','2013-07-10','08:15:00',1.38),('1444','2013-07-10','08:20:00',1.48),('1444','2013-07-10','08:25:00',1.42),('1444','2013-07-10','08:30:00',1.34),('1444','2013-07-10','08:35:00',1.39),('1444','2013-07-10','08:40:00',1.9),('1444','2013-07-10','08:45:00',1.78),('1444','2013-07-10','08:50:00',1.77),('1444','2013-07-10','08:55:00',1.74),('1444','2013-07-10','09:00:00',1.71),('1444','2013-07-10','09:05:00',1.76),('1444','2013-07-10','09:10:00',1.95),('1444','2013-07-10','09:15:00',2.03),('1444','2013-07-10','09:20:00',1.63),('1444','2013-07-10','09:25:00',1.29),('1444','2013-07-10','09:30:00',1.83),('1444','2013-07-10','09:35:00',2.04),('1444','2013-07-10','09:40:00',2.11),('1444','2013-07-10','09:45:00',2.15),('1444','2013-07-10','09:50:00',2.1),('1444','2013-07-10','09:55:00',1.72),('1444','2013-07-10','10:00:00',2.28),('1444','2013-07-10','10:05:00',2.31),('1444','2013-07-10','10:10:00',2.34),('1444','2013-07-10','10:15:00',2.38),('1444','2013-07-10','10:20:00',2.44),('1444','2013-07-10','10:25:00',2.48),('1444','2013-07-10','10:30:00',2.51),('1444','2013-07-10','10:35:00',2.55),('1444','2013-07-10','10:40:00',2.58),('1444','2013-07-10','10:45:00',2.6),('1444','2013-07-10','10:50:00',2.62),('1444','2013-07-10','10:55:00',2.65),('1444','2013-07-10','11:00:00',2.67),('1444','2013-07-10','11:05:00',2.7),('1444','2013-07-10','11:10:00',2.72),('1444','2013-07-10','11:15:00',2.74),('1444','2013-07-10','11:20:00',2.76),('1444','2013-07-10','11:25:00',2.74),('1444','2013-07-10','11:30:00',2.8),('1444','2013-07-10','11:35:00',2.83),('1444','2013-07-10','11:40:00',2.87),('1444','2013-07-10','11:45:00',2.89),('1444','2013-07-10','11:50:00',2.91),('1444','2013-07-10','11:55:00',2.93),('1444','2013-07-10','12:00:00',2.94),('1444','2013-07-10','12:05:00',2.94),('1444','2013-07-10','12:10:00',2.95),('1444','2013-07-10','12:15:00',2.98),('1444','2013-07-10','12:20:00',3.02),('1444','2013-07-10','12:25:00',3.02),('1444','2013-07-10','12:30:00',3.01),('1444','2013-07-10','12:35:00',3.08),('1444','2013-07-10','12:40:00',3.09),('1444','2013-07-10','12:45:00',3.07),('1444','2013-07-10','12:50:00',3.1),('1444','2013-07-10','12:55:00',3.1),('1444','2013-07-10','13:00:00',3.13),('1444','2013-07-10','13:05:00',3.1),('1444','2013-07-10','13:10:00',3.09),('1444','2013-07-10','13:15:00',3.09),('1444','2013-07-10','13:20:00',3.08),('1444','2013-07-10','13:25:00',3.09),('1444','2013-07-10','13:30:00',3.07),('1444','2013-07-10','13:35:00',3.1),('1444','2013-07-10','13:40:00',3.1),('1444','2013-07-10','13:45:00',3.1),('1444','2013-07-10','13:50:00',3.1),('1444','2013-07-10','13:55:00',3.1),('1444','2013-07-10','14:00:00',3.1),('1444','2013-07-10','14:05:00',3.11),('1444','2013-07-10','14:10:00',3.1),('1444','2013-07-10','14:15:00',3.09),('1444','2013-07-10','14:20:00',3.08),('1444','2013-07-10','14:25:00',3.07),('1444','2013-07-10','14:30:00',3.05),('1444','2013-07-10','14:35:00',3.01),('1444','2013-07-10','14:40:00',3),('1444','2013-07-10','14:45:00',2.97),('1444','2013-07-10','14:50:00',2.96),('1444','2013-07-10','14:55:00',2.94),('1444','2013-07-10','15:00:00',2.92),('1444','2013-07-10','15:05:00',2.91),('1444','2013-07-10','15:10:00',2.88),('1444','2013-07-10','15:15:00',2.84),('1444','2013-07-10','15:20:00',2.81),('1444','2013-07-10','15:25:00',2.79),('1444','2013-07-10','15:30:00',2.77),('1444','2013-07-10','15:35:00',2.73),('1444','2013-07-10','15:40:00',2.15),('1444','2013-07-10','15:45:00',2.66),('1444','2013-07-10','15:50:00',2.63),('1444','2013-07-10','15:55:00',2.58),('1444','2013-07-10','16:00:00',2.54),('1444','2013-07-10','16:05:00',2.5),('1444','2013-07-10','16:10:00',2.48),('1444','2013-07-10','16:15:00',2.43),('1444','2013-07-10','16:20:00',2.39),('1444','2013-07-10','16:25:00',2.34),('1444','2013-07-10','16:30:00',2.3),('1444','2013-07-10','16:35:00',2.26),('1444','2013-07-10','16:40:00',2.19),('1444','2013-07-10','16:45:00',2.16),('1444','2013-07-10','16:50:00',2.14),('1444','2013-07-10','16:55:00',2.11),('1444','2013-07-10','17:00:00',2.12),('1444','2013-07-10','17:05:00',1.87),('1444','2013-07-10','17:10:00',1.5),('1444','2013-07-10','17:15:00',1.24),('1444','2013-07-10','17:20:00',1.45),('1444','2013-07-10','17:35:00',1.13),('1444','2013-07-10','17:40:00',1.33),('1444','2013-07-10','17:45:00',1.28),('1444','2013-07-10','17:50:00',1.52),('1444','2013-07-10','17:55:00',1.25),('1444','2013-07-10','18:00:00',1.33),('1444','2013-07-10','18:05:00',1.2),('1444','2013-07-10','18:10:00',1.16),('1444','2013-07-09','07:55:00',1.01),('1444','2013-07-09','08:00:00',1.05),('1444','2013-07-09','08:05:00',1.11),('1444','2013-07-09','08:10:00',1.16),('1444','2013-07-09','08:15:00',1.22),('1444','2013-07-09','08:20:00',1.27),('1444','2013-07-09','08:25:00',1.33),('1444','2013-07-09','08:30:00',1.39),('1444','2013-07-09','08:35:00',1.45),('1444','2013-07-09','08:40:00',1.5),('1444','2013-07-09','08:45:00',1.55),('1444','2013-07-09','08:50:00',1.61),('1444','2013-07-09','08:55:00',1.66),('1444','2013-07-09','09:00:00',1.71),('1444','2013-07-09','09:05:00',1.77),('1444','2013-07-09','09:10:00',1.81),('1444','2013-07-09','09:15:00',1.87),('1444','2013-07-09','09:20:00',1.91),('1444','2013-07-09','09:25:00',1.97),('1444','2013-07-09','09:30:00',2.02),('1444','2013-07-09','09:35:00',2.05),('1444','2013-07-09','09:40:00',2.09),('1444','2013-07-09','09:45:00',2.15),('1444','2013-07-09','09:50:00',2.18),('1444','2013-07-09','09:55:00',2.23),('1444','2013-07-09','10:00:00',2.25),('1444','2013-07-09','10:05:00',2.24),('1444','2013-07-09','10:10:00',2.32),('1444','2013-07-09','10:15:00',2.37),('1444','2013-07-09','10:20:00',2.4),('1444','2013-07-09','10:25:00',2.44),('1444','2013-07-09','10:30:00',2.48),('1444','2013-07-09','10:35:00',2.53),('1444','2013-07-09','10:40:00',2.54),('1444','2013-07-09','10:45:00',2.6),('1444','2013-07-09','10:50:00',2.64),('1444','2013-07-09','10:55:00',2.66),('1444','2013-07-09','11:00:00',2.71),('1444','2013-07-09','11:05:00',2.74),('1444','2013-07-09','11:10:00',2.78),('1444','2013-07-09','11:15:00',2.82),('1444','2013-07-09','11:20:00',2.71),('1444','2013-07-09','11:25:00',1.72),('1444','2013-07-09','11:30:00',2.31),('1444','2013-07-09','11:35:00',1.72),('1444','2013-07-09','11:40:00',1.73),('1444','2013-07-09','11:45:00',2.02),('1444','2013-07-09','11:50:00',3.2),('1444','2013-07-09','11:55:00',3.26),('1444','2013-07-09','12:00:00',3.2),('1444','2013-07-09','12:05:00',3.17),('1444','2013-07-09','12:10:00',3.08),('1444','2013-07-09','12:15:00',3.05),('1444','2013-07-09','12:20:00',2.96),('1444','2013-07-09','12:25:00',2.99),('1444','2013-07-09','12:30:00',2.98),('1444','2013-07-09','12:35:00',3.03),('1444','2013-07-09','12:40:00',3.04),('1444','2013-07-09','12:45:00',3.05),('1444','2013-07-09','12:50:00',3.02),('1444','2013-07-09','12:55:00',3),('1444','2013-07-09','13:00:00',3.05),('1444','2013-07-09','13:05:00',3.16),('1444','2013-07-09','13:10:00',3.17),('1444','2013-07-09','13:15:00',3.11),('1444','2013-07-09','13:20:00',3.13),('1444','2013-07-09','13:25:00',3.18),('1444','2013-07-09','13:30:00',3.3),('1444','2013-07-09','13:35:00',3.08),('1444','2013-07-09','13:40:00',3),('1444','2013-07-09','13:45:00',2.81),('1444','2013-07-09','13:50:00',2.32),('1444','2013-07-09','13:55:00',2.4),('1444','2013-07-09','14:00:00',2.5),('1444','2013-07-09','14:05:00',2.31),('1444','2013-07-09','14:10:00',2.58),('1444','2013-07-09','14:15:00',2.72),('1444','2013-07-09','14:20:00',2.18),('1444','2013-07-09','14:25:00',2.61),('1444','2013-07-09','14:30:00',1.43),('1444','2013-07-08','07:45:00',1.03),('1444','2013-07-08','08:10:00',1.08),('1444','2013-07-08','08:15:00',1.2),('1444','2013-07-08','08:20:00',1.27),('1444','2013-07-08','08:25:00',1.33),('1444','2013-07-08','08:30:00',1.38),('1444','2013-07-08','08:35:00',1.45),('1444','2013-07-08','08:40:00',1.51),('1444','2013-07-08','08:45:00',1.57),('1444','2013-07-08','08:50:00',1.61),('1444','2013-07-08','08:55:00',1.67),('1444','2013-07-08','09:00:00',1.7),('1444','2013-07-08','09:05:00',1.75),('1444','2013-07-08','09:10:00',1.79),('1444','2013-07-08','09:15:00',1.83),('1444','2013-07-08','09:20:00',1.89),('1444','2013-07-08','09:25:00',1.86),('1444','2013-07-08','09:30:00',1.97),('1444','2013-07-08','09:35:00',2.06),('1444','2013-07-08','09:40:00',2.14),('1444','2013-07-08','09:45:00',2.2),('1444','2013-07-08','09:50:00',2.23),('1444','2013-07-08','09:55:00',2.28),('1444','2013-07-08','10:00:00',2.33),('1444','2013-07-08','10:05:00',2.36),('1444','2013-07-08','10:10:00',2.38),('1444','2013-07-08','10:15:00',2.43),('1444','2013-07-08','10:20:00',2.45),('1444','2013-07-08','10:25:00',2.5),('1444','2013-07-08','10:30:00',2.55),('1444','2013-07-08','10:35:00',2.57),('1444','2013-07-08','10:40:00',2.56),('1444','2013-07-08','10:45:00',2.61),('1444','2013-07-08','10:50:00',2.64),('1444','2013-07-08','10:55:00',2.66),('1444','2013-07-08','11:00:00',2.68),('1444','2013-07-08','11:05:00',2.73),('1444','2013-07-08','11:10:00',2.76),('1444','2013-07-08','11:15:00',2.81),('1444','2013-07-08','11:20:00',2.84),('1444','2013-07-08','11:25:00',2.89),('1444','2013-07-08','11:30:00',2.9),('1444','2013-07-08','11:35:00',2.93),('1444','2013-07-08','11:40:00',2.84),('1444','2013-07-08','11:45:00',2.86),('1444','2013-07-08','11:50:00',2.99),('1444','2013-07-08','11:55:00',2.97),('1444','2013-07-08','12:00:00',2.99),('1444','2013-07-08','12:05:00',3.09),('1444','2013-07-08','12:10:00',3.19),('1444','2013-07-08','12:15:00',3.26),('1444','2013-07-08','12:20:00',2.79),('1444','2013-07-08','12:25:00',3.13),('1444','2013-07-08','12:30:00',2.51),('1444','2013-07-08','12:35:00',3.08),('1444','2013-07-08','12:40:00',3.14),('1444','2013-07-08','12:45:00',3.14),('1444','2013-07-08','12:50:00',3.11),('1444','2013-07-08','12:55:00',3.17),('1444','2013-07-08','13:00:00',3.25),('1444','2013-07-08','13:05:00',2.97),('1444','2013-07-08','13:10:00',3.37),('1444','2013-07-08','13:15:00',3.48),('1444','2013-07-08','13:20:00',2.81),('1444','2013-07-07','07:55:00',1.05),('1444','2013-07-07','08:00:00',1.11),('1444','2013-07-07','08:05:00',1.17),('1444','2013-07-07','08:10:00',1.24),('1444','2013-07-07','08:15:00',1.29),('1444','2013-07-07','08:25:00',1.1),('1444','2013-07-07','08:30:00',1.27),('1444','2013-07-07','08:35:00',1.57),('1444','2013-07-07','08:40:00',1.55),('1444','2013-07-07','08:50:00',1.23),('1444','2013-07-07','08:55:00',1.75),('1444','2013-07-07','09:00:00',1.78),('1444','2013-07-07','09:05:00',1.67),('1444','2013-07-07','09:10:00',1.79),('1444','2013-07-07','09:15:00',1.91),('1444','2013-07-07','09:20:00',1.14),('1444','2013-07-07','09:25:00',1.4),('1444','2013-07-07','09:30:00',2.07),('1444','2013-07-07','09:35:00',2.18),('1444','2013-07-07','09:40:00',2.16),('1444','2013-07-07','09:45:00',2.12),('1444','2013-07-07','09:50:00',2.33),('1444','2013-07-07','09:55:00',2.43),('1444','2013-07-07','10:00:00',2.49),('1444','2013-07-07','10:05:00',2.33),('1444','2013-07-07','10:10:00',2.37),('1444','2013-07-07','10:15:00',2.41),('1444','2013-07-07','10:20:00',2.24),('1444','2013-07-07','10:25:00',2.47),('1444','2013-07-07','10:30:00',2.16),('1444','2013-07-07','10:35:00',2.67),('1444','2013-07-07','10:40:00',2.58),('1444','2013-07-07','10:45:00',2.59),('1444','2013-07-07','10:50:00',2.76),('1444','2013-07-07','10:55:00',2.77),('1444','2013-07-07','11:00:00',2.79),('1444','2013-07-07','11:05:00',2.81),('1444','2013-07-07','11:10:00',2.9),('1444','2013-07-07','11:15:00',2.9),('1444','2013-07-07','11:20:00',2.73),('1444','2013-07-07','11:25:00',2.53),('1444','2013-07-07','11:30:00',2.52),('1444','2013-07-07','11:35:00',2.52),('1444','2013-07-07','11:40:00',2.54),('1444','2013-07-07','11:45:00',2.29),('1444','2013-07-07','11:50:00',2.13),('1444','2013-07-07','11:55:00',1.71),('1444','2013-07-07','12:00:00',1.41),('1444','2013-07-07','12:05:00',2.79),('1444','2013-07-07','12:10:00',2.96),('1444','2013-07-07','12:15:00',2.99),('1444','2013-07-07','12:20:00',3.15),('1444','2013-07-07','12:25:00',2.93),('1444','2013-07-07','12:30:00',2.86),('1444','2013-07-07','12:35:00',3.01),('1444','2013-07-07','12:40:00',3.13),('1444','2013-07-07','12:45:00',3.19),('1444','2013-07-07','12:50:00',3.07),('1444','2013-07-07','12:55:00',3.23),('1444','2013-07-07','13:00:00',3.18),('1444','2013-07-07','13:05:00',2.73),('1444','2013-07-07','13:10:00',3.18),('1444','2013-07-07','13:15:00',3.19),('1444','2013-07-07','13:20:00',3.1),('1444','2013-07-07','13:25:00',2.83),('1444','2013-07-07','13:30:00',2.28),('1444','2013-07-07','13:35:00',3.25),('1444','2013-07-07','13:40:00',3.19),('1444','2013-07-07','13:45:00',3.12),('1444','2013-07-07','13:50:00',3.52),('1444','2013-07-07','13:55:00',3.18),('1444','2013-07-07','14:00:00',1.83),('1444','2013-07-07','14:05:00',2.37),('1444','2013-07-07','14:10:00',1.54),('1444','2013-07-07','14:15:00',1.09),('1444','2013-07-06','07:55:00',1.01),('1444','2013-07-06','08:00:00',1.07),('1444','2013-07-06','08:05:00',1.13),('1444','2013-07-06','08:10:00',1.19),('1444','2013-07-06','08:15:00',1.24),('1444','2013-07-06','08:20:00',1.29),('1444','2013-07-06','08:25:00',1.36),('1444','2013-07-06','08:30:00',1.42),('1444','2013-07-06','08:35:00',1.47),('1444','2013-07-06','08:40:00',1.54),('1444','2013-07-06','08:45:00',1.59),('1444','2013-07-06','08:50:00',1.65),('1444','2013-07-06','08:55:00',1.69),('1444','2013-07-06','09:00:00',1.74),('1444','2013-07-06','09:05:00',1.8),('1444','2013-07-06','09:10:00',1.86),('1444','2013-07-06','09:15:00',1.9),('1444','2013-07-06','09:20:00',1.96),('1444','2013-07-06','09:25:00',2.01),('1444','2013-07-06','09:30:00',2.04),('1444','2013-07-06','09:35:00',2.08),('1444','2013-07-06','09:40:00',2.13),('1444','2013-07-06','09:45:00',2.16),('1444','2013-07-06','09:50:00',2.22),('1444','2013-07-06','09:55:00',2.29),('1444','2013-07-06','10:00:00',2.34),('1444','2013-07-06','10:05:00',2.39),('1444','2013-07-06','10:10:00',2.44),('1444','2013-07-06','10:15:00',2.48),('1444','2013-07-06','10:20:00',2.5),('1444','2013-07-06','10:25:00',2.53),('1444','2013-07-06','10:30:00',2.57),('1444','2013-07-06','10:35:00',2.59),('1444','2013-07-06','10:40:00',2.6),('1444','2013-07-06','10:45:00',2.66),('1444','2013-07-06','10:50:00',2.71),('1444','2013-07-06','10:55:00',2.75),('1444','2013-07-06','11:00:00',2.77),('1444','2013-07-06','11:05:00',2.8),('1444','2013-07-06','11:10:00',2.81),('1444','2013-07-06','11:15:00',2.86),('1444','2013-07-06','11:20:00',2.84),('1444','2013-07-06','11:25:00',2.86),('1444','2013-07-06','11:30:00',2.91),('1444','2013-07-06','11:35:00',2.94),('1444','2013-07-06','11:40:00',2.95),('1444','2013-07-06','11:45:00',2.99),('1444','2013-07-06','11:50:00',3.01),('1444','2013-07-06','11:55:00',2.99),('1444','2013-07-06','12:00:00',3.01),('1444','2013-07-06','12:05:00',3.03),('1444','2013-07-06','12:10:00',3.12),('1444','2013-07-06','12:15:00',3.14),('1444','2013-07-06','12:20:00',3.17),('1444','2013-07-06','12:25:00',3.2),('1444','2013-07-06','12:30:00',3.19),('1444','2013-07-06','12:35:00',3.19),('1444','2013-07-06','12:40:00',3.14),('1444','2013-07-06','12:45:00',3.15),('1444','2013-07-06','12:50:00',3.16),('1444','2013-07-06','12:55:00',3.16),('1444','2013-07-06','13:00:00',3.19),('1444','2013-07-06','13:05:00',3.17),('1444','2013-07-06','13:10:00',3.14),('1444','2013-07-06','13:15:00',3.14),('1444','2013-07-06','13:20:00',3.16),('1444','2013-07-06','13:25:00',3.16),('1444','2013-07-06','13:30:00',3.2),('1444','2013-07-06','13:35:00',3.17),('1444','2013-07-06','13:40:00',3.19),('1444','2013-07-06','13:45:00',3.19),('1444','2013-07-06','13:50:00',3.15),('1444','2013-07-06','13:55:00',3.13),('1444','2013-07-06','14:00:00',3.14),('1444','2013-07-06','14:05:00',3.16),('1444','2013-07-06','14:10:00',3.14),('1444','2013-07-06','14:15:00',3.14),('1444','2013-07-06','14:20:00',1.75),('1444','2013-07-06','14:25:00',3.21),('1444','2013-07-06','14:30:00',3.08),('1444','2013-07-06','14:35:00',3.04),('1444','2013-07-06','14:40:00',3.04),('1444','2013-07-06','14:45:00',3.02),('1444','2013-07-06','14:50:00',2.63),('1444','2013-07-06','14:55:00',2.26),('1444','2013-07-06','15:00:00',1.88),('1444','2013-07-06','15:05:00',3),('1444','2013-07-06','15:10:00',3.01),('1444','2013-07-06','15:15:00',2.91),('1444','2013-07-06','15:20:00',2.72),('1444','2013-07-06','15:25:00',2.86),('1444','2013-07-06','15:30:00',2.59),('1444','2013-07-06','15:35:00',1.14),('1444','2013-07-06','16:50:00',1.24),('1444','2013-07-06','16:55:00',1.09),('1444','2013-07-06','17:15:00',1.16),('1444','2013-07-05','07:55:00',1.03),('1444','2013-07-05','08:00:00',1.1),('1444','2013-07-05','08:05:00',1.15),('1444','2013-07-05','08:10:00',1.21),('1444','2013-07-05','08:15:00',1.26),('1444','2013-07-05','08:20:00',1.3),('1444','2013-07-05','08:25:00',1.35),('1444','2013-07-05','08:30:00',1.41),('1444','2013-07-05','08:35:00',1.47),('1444','2013-07-05','08:40:00',1.52),('1444','2013-07-05','08:45:00',1.57),('1444','2013-07-05','08:50:00',1.62),('1444','2013-07-05','08:55:00',1.67),('1444','2013-07-05','09:00:00',1.73),('1444','2013-07-05','09:05:00',1.8),('1444','2013-07-05','09:10:00',1.86),('1444','2013-07-05','09:15:00',1.91),('1444','2013-07-05','09:20:00',1.97),('1444','2013-07-05','09:25:00',2.02),('1444','2013-07-05','09:30:00',2.05),('1444','2013-07-05','09:35:00',2.08),('1444','2013-07-05','09:40:00',2.14),('1444','2013-07-05','09:45:00',2.19),('1444','2013-07-05','09:50:00',2.23),('1444','2013-07-05','09:55:00',2.27),('1444','2013-07-05','10:00:00',2.32),('1444','2013-07-05','10:05:00',2.37),('1444','2013-07-05','10:10:00',2.41),('1444','2013-07-05','10:15:00',2.44),('1444','2013-07-05','10:20:00',2.48),('1444','2013-07-05','10:25:00',2.5),('1444','2013-07-05','10:30:00',2.54),('1444','2013-07-05','10:35:00',2.57),('1444','2013-07-05','10:40:00',2.59),('1444','2013-07-05','10:45:00',2.62),('1444','2013-07-05','10:50:00',2.65),('1444','2013-07-05','10:55:00',2.68),('1444','2013-07-05','11:00:00',2.68),('1444','2013-07-05','11:05:00',2.7),('1444','2013-07-05','11:10:00',2.74),('1444','2013-07-05','11:15:00',2.76),('1444','2013-07-05','11:20:00',2.8),('1444','2013-07-05','11:25:00',2.84),('1444','2013-07-05','11:30:00',2.91),('1444','2013-07-05','11:35:00',2.91),('1444','2013-07-05','11:40:00',2.92),('1444','2013-07-05','11:45:00',2.94),('1444','2013-07-05','11:50:00',2.93),('1444','2013-07-05','11:55:00',2.98),('1444','2013-07-05','12:00:00',2.99),('1444','2013-07-05','12:05:00',3.01),('1444','2013-07-05','12:10:00',3),('1444','2013-07-05','12:15:00',3.02),('1444','2013-07-05','12:20:00',3.09),('1444','2013-07-05','12:25:00',2.37),('1444','2013-07-05','12:30:00',2.55),('1444','2013-07-05','12:35:00',3.15),('1444','2013-07-05','12:40:00',3.08),('1444','2013-07-05','12:45:00',3.05),('1444','2013-07-05','12:50:00',3.12),('1444','2013-07-05','12:55:00',3.14),('1444','2013-07-05','13:00:00',2.48),('1444','2013-07-05','13:05:00',1.98),('1444','2013-07-05','13:10:00',2.79),('1444','2013-07-05','13:15:00',3.01),('1444','2013-07-05','13:20:00',2.44),('1444','2013-07-05','13:25:00',2.77),('1444','2013-07-05','13:30:00',2.89),('1444','2013-07-05','13:35:00',3.25),('1444','2013-07-05','13:40:00',3.23),('1444','2013-07-05','13:45:00',3.18),('1444','2013-07-05','13:50:00',3.16),('1444','2013-07-05','13:55:00',3.16),('1444','2013-07-05','14:00:00',3.2),('1444','2013-07-05','14:05:00',3.18),('1444','2013-07-05','14:10:00',2.71),('1444','2013-07-05','14:15:00',3.11),('1444','2013-07-05','14:20:00',3.06),('1444','2013-07-05','14:25:00',3.06),('1444','2013-07-05','14:30:00',3.03),('1444','2013-07-05','14:35:00',2.7),('1444','2013-07-05','14:40:00',2.77),('1444','2013-07-05','14:45:00',2.52),('1444','2013-07-05','14:50:00',2.35),('1444','2013-07-05','14:55:00',2.88),('1444','2013-07-05','15:00:00',2.97),('1444','2013-07-05','15:05:00',2.09),('1444','2013-07-05','15:10:00',2.99),('1444','2013-07-05','15:15:00',2.92),('1444','2013-07-05','15:20:00',2.3),('1444','2013-07-05','15:25:00',2.32),('1444','2013-07-05','15:30:00',1.96),('1444','2013-07-05','15:35:00',2.84),('1444','2013-07-05','15:40:00',2.74),('1444','2013-07-05','15:45:00',2.74),('1444','2013-07-05','15:50:00',2.69),('1444','2013-07-05','15:55:00',2.45),('1444','2013-07-05','16:00:00',2.55),('1444','2013-07-05','16:05:00',2.54),('1444','2013-07-05','16:10:00',2.48),('1444','2013-07-05','16:15:00',2.42),('1444','2013-07-05','16:20:00',2.41),('1444','2013-07-05','16:25:00',2.38),('1444','2013-07-05','16:30:00',2.33),('1444','2013-07-05','16:35:00',2.29),('1444','2013-07-05','16:40:00',2.22),('1444','2013-07-05','16:45:00',2.2),('1444','2013-07-05','16:50:00',2.11),('1444','2013-07-05','16:55:00',2.03),('1444','2013-07-05','17:00:00',1.99),('1444','2013-07-05','17:05:00',1.94),('1444','2013-07-05','17:10:00',1.92),('1444','2013-07-05','17:15:00',1.91),('1444','2013-07-05','17:20:00',1.87),('1444','2013-07-05','17:25:00',1.77),('1444','2013-07-05','17:30:00',1.73),('1444','2013-07-05','17:35:00',1.66),('1444','2013-07-05','17:40:00',1.56),('1444','2013-07-05','17:45:00',1.49),('1444','2013-07-05','17:50:00',1.41),('1444','2013-07-05','17:55:00',1.37),('1444','2013-07-05','18:00:00',1.36),('1444','2013-07-05','18:05:00',1.32),('1444','2013-07-05','18:10:00',1.18),('1444','2013-07-05','18:15:00',1.04),('1444','2013-07-04','11:35:00',1.09),('1444','2013-07-04','11:40:00',1.22),('1444','2013-07-04','11:45:00',1.29),('1444','2013-07-04','11:50:00',1.27),('1444','2013-07-04','11:55:00',1.11),('1444','2013-07-04','12:00:00',1.1),('1444','2013-07-04','12:05:00',1.51),('1444','2013-07-04','12:10:00',1.83),('1444','2013-07-04','12:15:00',1.73),('1444','2013-07-04','12:20:00',2.11),('1444','2013-07-04','12:25:00',2.42),('1444','2013-07-04','12:30:00',2.06),('1444','2013-07-04','12:35:00',1.62),('1444','2013-07-04','12:40:00',1.28),('1444','2013-07-04','13:05:00',1.05),('1444','2013-07-04','13:10:00',1.4),('1444','2013-07-04','13:15:00',2.14),('1444','2013-07-04','13:20:00',1.61),('1444','2013-07-04','13:25:00',2.68),('1444','2013-07-04','13:30:00',1.77),('1444','2013-07-04','13:35:00',2),('1444','2013-07-04','13:40:00',2.9),('1444','2013-07-04','13:45:00',3.92),('1444','2013-07-04','13:50:00',3.86),('1444','2013-07-04','13:55:00',2.88),('1444','2013-07-04','14:00:00',2.02),('1444','2013-07-04','14:05:00',1.78),('1444','2013-07-04','14:10:00',1.74),('1444','2013-07-04','14:15:00',1.76),('1444','2013-07-04','14:20:00',1.75),('1444','2013-07-04','14:25:00',1.67),('1444','2013-07-04','14:30:00',1.58),('1444','2013-07-04','14:35:00',1.61),('1444','2013-07-04','14:40:00',1.73),('1444','2013-07-04','14:45:00',2.1),('1444','2013-07-04','14:50:00',2.39),('1444','2013-07-04','14:55:00',1.55),('1444','2013-07-04','15:00:00',1.4),('1444','2013-07-04','15:05:00',1.42),('1444','2013-07-04','15:10:00',2.38),('1444','2013-07-04','15:15:00',1.84),('1444','2013-07-04','15:20:00',2.13),('1444','2013-07-04','15:25:00',3.03),('1444','2013-07-04','15:30:00',1.96),('1444','2013-07-04','15:35:00',1.62),('1444','2013-07-04','15:40:00',1.96),('1444','2013-07-04','15:45:00',2.75),('1444','2013-07-04','15:50:00',1.52),('1444','2013-07-04','15:55:00',1.53),('1444','2013-07-04','16:00:00',1.58),('1444','2013-07-04','16:05:00',1.72),('1444','2013-07-04','16:10:00',1.39),('1444','2013-07-04','16:15:00',1.38),('1444','2013-07-04','16:20:00',1.48),('1444','2013-07-04','16:25:00',1.83),('1444','2013-07-04','16:30:00',1.62),('1444','2013-07-04','16:35:00',2.11),('1444','2013-07-04','16:40:00',1.28),('1444','2013-07-04','16:45:00',1.27),('1444','2013-07-04','16:50:00',1.16),('1444','2013-07-04','16:55:00',1.1),('1444','2013-07-04','17:10:00',1.24),('1444','2013-07-04','17:15:00',2.04),('1444','2013-07-04','17:20:00',1.47),('1444','2013-07-04','17:25:00',2.03),('1444','2013-07-04','17:30:00',1.64),('1444','2013-07-04','17:35:00',1.89),('1444','2013-07-04','17:40:00',1.75),('1444','2013-07-04','17:45:00',1.72),('1444','2013-07-04','17:50:00',1.7),('1444','2013-07-04','17:55:00',1.42),('1444','2013-07-04','18:00:00',1.59),('1444','2013-07-04','18:05:00',1.5),('1444','2013-07-04','18:10:00',1.44),('1444','2013-07-04','18:15:00',1.41),('1444','2013-07-04','18:20:00',1.3),('1444','2013-07-04','18:25:00',1.07),('1444','2013-07-03','07:50:00',1.01),('1444','2013-07-03','07:55:00',1.07),('1444','2013-07-03','08:00:00',1.13),('1444','2013-07-03','08:05:00',1.19),('1444','2013-07-03','08:10:00',1.24),('1444','2013-07-03','08:15:00',1.32),('1444','2013-07-03','08:20:00',1.37),('1444','2013-07-03','08:25:00',1.44),('1444','2013-07-03','08:30:00',1.49),('1444','2013-07-03','08:35:00',1.54),('1444','2013-07-03','08:40:00',1.6),('1444','2013-07-03','08:45:00',1.65),('1444','2013-07-03','08:50:00',1.7),('1444','2013-07-03','08:55:00',1.76),('1444','2013-07-03','09:00:00',1.81),('1444','2013-07-03','09:05:00',1.87),('1444','2013-07-03','09:10:00',1.92),('1444','2013-07-03','09:15:00',1.97),('1444','2013-07-03','09:20:00',2.02),('1444','2013-07-03','09:25:00',2.05),('1444','2013-07-03','09:30:00',2.09),('1444','2013-07-03','09:35:00',2.13),('1444','2013-07-03','09:40:00',2.15),('1444','2013-07-03','09:45:00',2.21),('1444','2013-07-03','09:50:00',2.26),('1444','2013-07-03','09:55:00',2.28),('1444','2013-07-03','10:00:00',2.33),('1444','2013-07-03','10:05:00',2.39),('1444','2013-07-03','10:10:00',2.41),('1444','2013-07-03','10:15:00',2.43),('1444','2013-07-03','10:20:00',2.45),('1444','2013-07-03','10:25:00',2.47),('1444','2013-07-03','10:30:00',2.54),('1444','2013-07-03','10:35:00',2.58),('1444','2013-07-03','10:40:00',2.6),('1444','2013-07-03','10:45:00',2.61),('1444','2013-07-03','10:50:00',2.64),('1444','2013-07-03','10:55:00',2.68),('1444','2013-07-03','11:00:00',2.74),('1444','2013-07-03','11:05:00',2.75),('1444','2013-07-03','11:10:00',2.81),('1444','2013-07-03','11:15:00',2.86),('1444','2013-07-03','11:20:00',2.85),('1444','2013-07-03','11:25:00',2.85),('1444','2013-07-03','11:30:00',2.89),('1444','2013-07-03','11:35:00',2.91),('1444','2013-07-03','11:40:00',2.98),('1444','2013-07-03','11:45:00',3.01),('1444','2013-07-03','11:50:00',2.99),('1444','2013-07-03','11:55:00',3),('1444','2013-07-03','12:00:00',3.03),('1444','2013-07-03','12:05:00',3.05),('1444','2013-07-03','12:10:00',3.06),('1444','2013-07-03','12:15:00',3.08),('1444','2013-07-03','12:20:00',3.08),('1444','2013-07-03','12:25:00',3.1),('1444','2013-07-03','12:30:00',3.12),('1444','2013-07-03','12:35:00',3.14),('1444','2013-07-03','12:40:00',3.16),('1444','2013-07-03','12:45:00',3.16),('1444','2013-07-03','12:50:00',3.18),('1444','2013-07-03','12:55:00',3.18),('1444','2013-07-03','13:00:00',3.18),('1444','2013-07-03','13:05:00',3.19),('1444','2013-07-03','13:10:00',3.19),('1444','2013-07-03','13:15:00',3.19),('1444','2013-07-03','13:20:00',3.18),('1444','2013-07-03','13:25:00',3.19),('1444','2013-07-03','13:30:00',3.18),('1444','2013-07-03','13:35:00',3.18),('1444','2013-07-03','13:40:00',3.18),('1444','2013-07-03','13:45:00',3.18),('1444','2013-07-03','13:50:00',3.18),('1444','2013-07-03','13:55:00',3.17),('1444','2013-07-03','14:00:00',3.16),('1444','2013-07-03','14:05:00',3.16),('1444','2013-07-03','14:10:00',3.13),('1444','2013-07-03','14:15:00',3.13),('1444','2013-07-03','14:20:00',3.13),('1444','2013-07-03','14:25:00',3.13),('1444','2013-07-03','14:30:00',3.1),('1444','2013-07-03','14:35:00',3.08),('1444','2013-07-03','14:40:00',3.06),('1444','2013-07-03','14:45:00',3.03),('1444','2013-07-03','14:50:00',3.02),('1444','2013-07-03','14:55:00',3),('1444','2013-07-03','15:00:00',2.99),('1444','2013-07-03','15:05:00',2.96),('1444','2013-07-03','15:10:00',2.93),('1444','2013-07-03','15:15:00',2.91),('1444','2013-07-03','15:20:00',2.87),('1444','2013-07-03','15:25:00',2.85),('1444','2013-07-03','15:30:00',2.83),('1444','2013-07-03','15:35:00',2.78),('1444','2013-07-03','15:40:00',2.75),('1444','2013-07-03','15:45:00',2.72),('1444','2013-07-03','15:50:00',2.68),('1444','2013-07-03','15:55:00',2.65),('1444','2013-07-03','16:00:00',2.62),('1444','2013-07-03','16:05:00',2.58),('1444','2013-07-03','16:10:00',2.53),('1444','2013-07-03','16:15:00',2.5),('1444','2013-07-03','16:20:00',2.45),('1444','2013-07-03','16:25:00',2.4),('1444','2013-07-03','16:30:00',2.37),('1444','2013-07-03','16:35:00',2.32),('1444','2013-07-03','16:40:00',2.28),('1444','2013-07-03','16:45:00',2.22),('1444','2013-07-03','16:50:00',2.17),('1444','2013-07-03','16:55:00',2.14),('1444','2013-07-03','17:00:00',2.09),('1444','2013-07-03','17:05:00',2.04),('1444','2013-07-03','17:10:00',1.99),('1444','2013-07-03','17:15:00',1.93),('1444','2013-07-03','17:20:00',1.89),('1444','2013-07-03','17:25:00',1.83),('1444','2013-07-03','17:30:00',1.78),('1444','2013-07-03','17:35:00',1.72),('1444','2013-07-03','17:40:00',1.67),('1444','2013-07-03','17:45:00',1.62),('1444','2013-07-03','17:50:00',1.55),('1444','2013-07-03','17:55:00',1.49),('1444','2013-07-03','18:00:00',1.43),('1444','2013-07-03','18:05:00',1.35),('1444','2013-07-03','18:10:00',1.3),('1444','2013-07-03','18:15:00',1.25),('1444','2013-07-03','18:20:00',1.2),('1444','2013-07-03','18:25:00',1.14),('1444','2013-07-03','18:30:00',1.08),('1444','2013-07-03','18:35:00',1.02),('1444','2013-07-02','07:55:00',1.06),('1444','2013-07-02','08:00:00',1.11),('1444','2013-07-02','08:05:00',1.17),('1444','2013-07-02','08:10:00',1.24),('1444','2013-07-02','08:15:00',1.28),('1444','2013-07-02','08:20:00',1.36),('1444','2013-07-02','08:25:00',1.41),('1444','2013-07-02','08:30:00',1.47),('1444','2013-07-02','08:35:00',1.54),('1444','2013-07-02','08:40:00',1.59),('1444','2013-07-02','08:45:00',1.63),('1444','2013-07-02','08:50:00',1.68),('1444','2013-07-02','08:55:00',1.74),('1444','2013-07-02','09:00:00',1.81),('1444','2013-07-02','09:05:00',1.86),('1444','2013-07-02','09:10:00',1.91),('1444','2013-07-02','09:15:00',1.95),('1444','2013-07-02','09:20:00',1.99),('1444','2013-07-02','09:25:00',2.03),('1444','2013-07-02','09:30:00',2.07),('1444','2013-07-02','09:35:00',2.12),('1444','2013-07-02','09:40:00',2.16),('1444','2013-07-02','09:45:00',2.2),('1444','2013-07-02','09:50:00',2.24),('1444','2013-07-02','09:55:00',2.3),('1444','2013-07-02','10:00:00',2.35),('1444','2013-07-02','10:05:00',2.36),('1444','2013-07-02','10:10:00',2.39),('1444','2013-07-02','10:15:00',2.42),('1444','2013-07-02','10:20:00',2.44),('1444','2013-07-02','10:25:00',2.49),('1444','2013-07-02','10:30:00',2.51),('1444','2013-07-02','10:35:00',2.53),('1444','2013-07-02','10:40:00',2.58),('1444','2013-07-02','10:45:00',2.62),('1444','2013-07-02','10:50:00',2.64),('1444','2013-07-02','10:55:00',2.69),('1444','2013-07-02','11:00:00',2.71),('1444','2013-07-02','11:05:00',2.69),('1444','2013-07-02','11:10:00',2.7),('1444','2013-07-02','11:15:00',2.74),('1444','2013-07-02','11:20:00',2.78),('1444','2013-07-02','11:25:00',2.79),('1444','2013-07-02','11:30:00',2.79),('1444','2013-07-02','11:35:00',2.83),('1444','2013-07-02','11:40:00',2.88),('1444','2013-07-02','11:45:00',2.87),('1444','2013-07-02','11:50:00',2.89),('1444','2013-07-02','11:55:00',2.92),('1444','2013-07-02','12:00:00',2.94),('1444','2013-07-02','12:05:00',2.94),('1444','2013-07-02','12:10:00',2.94),('1444','2013-07-02','12:15:00',2.92),('1444','2013-07-02','12:20:00',2.99),('1444','2013-07-02','12:25:00',2.99),('1444','2013-07-02','12:30:00',2.53),('1444','2013-07-02','12:40:00',2.93),('1444','2013-07-02','12:45:00',3.05),('1444','2013-07-02','12:50:00',2.88),('1444','2013-07-02','12:55:00',2.7),('1444','2013-07-02','13:00:00',2.1),('1444','2013-07-02','13:05:00',2.2),('1444','2013-07-02','13:10:00',3),('1444','2013-07-02','13:15:00',2.82),('1444','2013-07-02','13:20:00',3.13),('1444','2013-07-02','13:25:00',3.17),('1444','2013-07-02','13:30:00',3.09),('1444','2013-07-02','13:35:00',3.12),('1444','2013-07-02','13:40:00',3.07),('1444','2013-07-02','13:45:00',3.09),('1444','2013-07-02','13:50:00',3.05),('1444','2013-07-02','13:55:00',3.05),('1444','2013-07-02','14:00:00',3.04),('1444','2013-07-02','14:05:00',3.02),('1444','2013-07-02','14:10:00',3.05),('1444','2013-07-02','14:15:00',3.06),('1444','2013-07-02','14:20:00',3.05),('1444','2013-07-02','14:25:00',3.03),('1444','2013-07-02','14:30:00',2.99),('1444','2013-07-02','14:35:00',2.99),('1444','2013-07-02','14:40:00',2.99),('1444','2013-07-02','14:45:00',2.96),('1444','2013-07-02','14:50:00',2.93),('1444','2013-07-02','14:55:00',2.93),('1444','2013-07-02','15:00:00',2.92),('1444','2013-07-02','15:05:00',2.9),('1444','2013-07-02','15:10:00',2.87),('1444','2013-07-02','15:15:00',2.83),('1444','2013-07-02','15:20:00',2.81),('1444','2013-07-02','15:25:00',2.79),('1444','2013-07-02','15:30:00',2.77),('1444','2013-07-02','15:35:00',2.74),('1444','2013-07-02','15:40:00',2.72),('1444','2013-07-02','15:45:00',2.68),('1444','2013-07-02','15:50:00',2.63),('1444','2013-07-02','15:55:00',2.59),('1444','2013-07-02','16:00:00',2.56),('1444','2013-07-02','16:05:00',2.53),('1444','2013-07-02','16:10:00',2.49),('1444','2013-07-02','16:15:00',2.44),('1444','2013-07-02','16:20:00',2.4),('1444','2013-07-02','16:25:00',2.35),('1444','2013-07-02','16:30:00',2.31),('1444','2013-07-02','16:35:00',2.27),('1444','2013-07-02','16:40:00',2.23),('1444','2013-07-02','16:45:00',2.17),('1444','2013-07-02','16:50:00',2.12),('1444','2013-07-02','16:55:00',2.1),('1444','2013-07-02','17:00:00',2.03),('1444','2013-07-02','17:05:00',1.97),('1444','2013-07-02','17:10:00',1.93),('1444','2013-07-02','17:15:00',1.87),('1444','2013-07-02','17:20:00',1.82),('1444','2013-07-02','17:25:00',1.78),('1444','2013-07-02','17:30:00',1.71),('1444','2013-07-02','17:35:00',1.65),('1444','2013-07-02','17:40:00',1.59),('1444','2013-07-02','17:45:00',1.53),('1444','2013-07-02','17:50:00',1.48),('1444','2013-07-02','17:55:00',1.43),('1444','2013-07-02','18:00:00',1.37),('1444','2013-07-02','18:05:00',1.31),('1444','2013-07-02','18:10:00',1.25),('1444','2013-07-02','18:15:00',1.21),('1444','2013-07-02','18:20:00',1.15),('1444','2013-07-02','18:25:00',1.08),('1444','2013-07-02','18:30:00',1.02),('1444','2013-07-01','07:50:00',1.01),('1444','2013-07-01','07:55:00',1.08),('1444','2013-07-01','08:00:00',1.15),('1444','2013-07-01','08:05:00',1.2),('1444','2013-07-01','08:10:00',1.24),('1444','2013-07-01','08:15:00',1.32),('1444','2013-07-01','08:20:00',1.39),('1444','2013-07-01','08:25:00',1.44),('1444','2013-07-01','08:30:00',1.51),('1444','2013-07-01','08:35:00',1.57),('1444','2013-07-01','08:40:00',1.63),('1444','2013-07-01','08:45:00',1.7),('1444','2013-07-01','08:50:00',1.75),('1444','2013-07-01','08:55:00',1.8),('1444','2013-07-01','09:00:00',1.85),('1444','2013-07-01','09:05:00',1.9),('1444','2013-07-01','09:10:00',1.96),('1444','2013-07-01','09:15:00',2.01),('1444','2013-07-01','09:20:00',2.06),('1444','2013-07-01','09:25:00',2.11),('1444','2013-07-01','09:30:00',2.16),('1444','2013-07-01','09:35:00',2.2),('1444','2013-07-01','09:40:00',2.23),('1444','2013-07-01','09:45:00',2.28),('1444','2013-07-01','09:50:00',2.32),('1444','2013-07-01','09:55:00',2.35),('1444','2013-07-01','10:00:00',2.4),('1444','2013-07-01','10:05:00',2.43),('1444','2013-07-01','10:10:00',2.46),('1444','2013-07-01','10:15:00',2.5),('1444','2013-07-01','10:20:00',2.56),('1444','2013-07-01','10:25:00',2.58),('1444','2013-07-01','10:30:00',2.63),('1444','2013-07-01','10:35:00',2.65),('1444','2013-07-01','10:40:00',2.69),('1444','2013-07-01','10:45:00',2.73),('1444','2013-07-01','10:50:00',2.78),('1444','2013-07-01','10:55:00',2.82),('1444','2013-07-01','11:00:00',2.85),('1444','2013-07-01','11:05:00',2.89),('1444','2013-07-01','11:10:00',2.87),('1444','2013-07-01','11:15:00',2.91),('1444','2013-07-01','11:20:00',2.97),('1444','2013-07-01','11:25:00',3.02),('1444','2013-07-01','11:30:00',3.04),('1444','2013-07-01','11:35:00',3.02),('1444','2013-07-01','11:40:00',3.02),('1444','2013-07-01','11:45:00',3.06),('1444','2013-07-01','11:50:00',3.08),('1444','2013-07-01','11:55:00',3.11),('1444','2013-07-01','12:00:00',3.09),('1444','2013-07-01','12:05:00',3.09),('1444','2013-07-01','12:10:00',3.1),('1444','2013-07-01','12:15:00',3.11),('1444','2013-07-01','12:20:00',3.11),('1444','2013-07-01','12:25:00',3.1),('1444','2013-07-01','12:30:00',3.1),('1444','2013-07-01','12:35:00',3.16),('1444','2013-07-01','12:40:00',3.16),('1444','2013-07-01','12:45:00',3.18),('1444','2013-07-01','12:50:00',3.18),('1444','2013-07-01','12:55:00',3.17),('1444','2013-07-01','13:00:00',3.17),('1444','2013-07-01','13:05:00',3.16),('1444','2013-07-01','13:10:00',3.2),('1444','2013-07-01','13:15:00',3.18),('1444','2013-07-01','13:20:00',3.16),('1444','2013-07-01','13:25:00',3.2),('1444','2013-07-01','13:30:00',3.21),('1444','2013-07-01','13:35:00',3.21),('1444','2013-07-01','13:40:00',3.16),('1444','2013-07-01','13:45:00',3.15),('1444','2013-07-01','13:50:00',3.12),('1444','2013-07-01','13:55:00',3.14),('1444','2013-07-01','14:00:00',3.15),('1444','2013-07-01','14:05:00',3.17),('1444','2013-07-01','14:10:00',3.17),('1444','2013-07-01','14:15:00',3.13),('1444','2013-07-01','14:20:00',3.1),('1444','2013-07-01','14:25:00',3.07),('1444','2013-07-01','14:30:00',3.06),('1444','2013-07-01','14:35:00',3.03),('1444','2013-07-01','14:40:00',3),('1444','2013-07-01','14:45:00',3),('1444','2013-07-01','14:50:00',2.96),('1444','2013-07-01','14:55:00',2.9),('1444','2013-07-01','15:00:00',2.91),('1444','2013-07-01','15:05:00',2.87),('1444','2013-07-01','15:10:00',2.87),('1444','2013-07-01','15:15:00',2.85),('1444','2013-07-01','15:20:00',2.81),('1444','2013-07-01','15:25:00',2.78),('1444','2013-07-01','15:30:00',2.74),('1444','2013-07-01','15:35:00',2.7),('1444','2013-07-01','15:40:00',2.67),('1444','2013-07-01','15:45:00',2.66),('1444','2013-07-01','15:50:00',2.62),('1444','2013-07-01','15:55:00',2.57),('1444','2013-07-01','16:00:00',2.54),('1444','2013-07-01','16:05:00',2.52),('1444','2013-07-01','16:10:00',2.46),('1444','2013-07-01','16:15:00',2.43),('1444','2013-07-01','16:20:00',2.36),('1444','2013-07-01','16:25:00',2.32),('1444','2013-07-01','16:30:00',2.28),('1444','2013-07-01','16:35:00',2.24),('1444','2013-07-01','16:40:00',2.18),('1444','2013-07-01','16:45:00',2.15),('1444','2013-07-01','16:50:00',2.12),('1444','2013-07-01','16:55:00',2.08),('1444','2013-07-01','17:00:00',2.03),('1444','2013-07-01','17:05:00',1.98),('1444','2013-07-01','17:10:00',1.92),('1444','2013-07-01','17:15:00',1.87),('1444','2013-07-01','17:20:00',1.83),('1444','2013-07-01','17:25:00',1.76),('1444','2013-07-01','17:30:00',1.7),('1444','2013-07-01','17:35:00',1.64),('1444','2013-07-01','17:40:00',1.59),('1444','2013-07-01','17:45:00',1.54),('1444','2013-07-01','17:50:00',1.49),('1444','2013-07-01','17:55:00',1.43),('1444','2013-07-01','18:00:00',1.26),('1444','2013-07-01','18:05:00',1.3),('1444','2013-07-01','18:10:00',1.23),('1444','2013-07-01','18:20:00',1.05),('1444','2013-07-01','18:25:00',1.12),('1444','2013-07-01','18:30:00',1.06),('1444','2014-04-05','09:20:00',1.24),('1444','2014-04-05','09:25:00',1.38),('1444','2014-04-05','09:30:00',2.77),('1444','2014-04-05','09:35:00',2.78),('1444','2014-04-05','09:40:00',2.65),('1444','2014-04-05','09:45:00',2.51),('1444','2014-04-05','09:50:00',1.45),('1444','2014-04-05','09:55:00',1.26),('1444','2014-04-05','10:00:00',1.56),('1444','2014-04-05','10:05:00',1.47),('1444','2014-04-05','10:10:00',1.59),('1444','2014-04-05','10:15:00',1.65),('1444','2014-04-05','10:20:00',1.58),('1444','2014-04-05','10:25:00',2.1),('1444','2014-04-05','10:30:00',1.96),('1444','2014-04-05','10:35:00',2.08),('1444','2014-04-05','10:40:00',2.39),('1444','2014-04-05','10:45:00',2.53),('1444','2014-04-05','10:50:00',2.17),('1444','2014-04-05','10:55:00',2.12),('1444','2014-04-05','11:00:00',2.39),('1444','2014-04-05','11:05:00',2.68),('1444','2014-04-05','11:10:00',2.92),('1444','2014-04-05','11:15:00',3.03),('1444','2014-04-05','11:20:00',3.24),('1444','2014-04-05','11:25:00',3.05),('1444','2014-04-05','11:30:00',2.13),('1444','2014-04-05','11:35:00',1.66),('1444','2014-04-05','11:40:00',2.1),('1444','2014-04-05','11:45:00',2.86),('1444','2014-04-05','11:50:00',3.16),('1444','2014-04-05','11:55:00',3.03),('1444','2014-04-05','12:00:00',3.1),('1444','2014-04-05','12:05:00',2.41),('1444','2014-04-05','12:10:00',2.31),('1444','2014-04-05','12:15:00',2.62),('1444','2014-04-05','12:20:00',2.68),('1444','2014-04-05','12:25:00',2.89),('1444','2014-04-05','12:30:00',2.26),('1444','2014-04-05','12:35:00',2.1),('1444','2014-04-05','12:40:00',2.19),('1444','2014-04-05','12:45:00',3.47),('1444','2014-04-05','12:50:00',3.41),('1444','2014-04-05','12:55:00',3.23),('1444','2014-04-05','13:00:00',2.96),('1444','2014-04-05','13:05:00',2.55),('1444','2014-04-05','13:10:00',1.79),('1444','2014-04-05','13:15:00',1.6),('1444','2014-04-05','13:20:00',1.54),('1444','2014-04-05','13:25:00',3.71),('1444','2014-04-05','13:30:00',3.23),('1444','2014-04-05','13:35:00',2.28),('1444','2014-04-05','13:40:00',1.54),('1444','2014-04-05','13:45:00',2.97),('1444','2014-04-05','13:50:00',3.12),('1444','2014-04-05','13:55:00',3.19),('1444','2014-04-05','14:00:00',2.37),('1444','2014-04-05','14:05:00',3.83),('1444','2014-04-05','14:10:00',2.99),('1444','2014-04-05','14:25:00',1.01),('1444','2014-04-05','14:30:00',3.03),('1444','2014-04-05','14:55:00',1.65),('1444','2014-04-05','15:00:00',3.02),('1444','2014-04-05','15:05:00',2.43),('1444','2014-04-05','15:10:00',2.81),('1444','2014-04-05','15:15:00',1.54),('1444','2014-04-05','15:20:00',3.14),('1444','2014-04-05','15:25:00',1.6),('1444','2014-04-05','15:30:00',1.34),('1444','2014-04-05','15:35:00',1.15),('1444','2014-04-05','15:40:00',1.58),('1444','2014-04-05','15:45:00',1.52),('1444','2014-04-05','15:50:00',1.73),('1444','2014-04-05','15:55:00',1.09),('1444','2014-04-05','16:00:00',1),('1444','2014-04-05','16:05:00',1.01),('1444','2014-04-05','16:15:00',1.77),('1444','2014-04-05','16:20:00',2.69),('1444','2014-04-05','16:25:00',2.54),('1444','2014-04-05','16:30:00',1.44),('1444','2014-04-05','16:35:00',2.45),('1444','2014-04-05','16:40:00',1.26),('1444','2014-04-05','16:45:00',1.74),('1444','2014-04-05','16:50:00',1.25),('1444','2014-04-05','16:55:00',1.97),('1444','2014-04-05','17:00:00',1.12),('1444','2014-04-05','17:05:00',1.54),('1444','2014-04-05','17:10:00',1.33),('1444','2013-06-30','07:45:00',1),('1444','2013-06-30','07:50:00',1.08),('1444','2013-06-30','07:55:00',1.14),('1444','2013-06-30','08:00:00',1.2),('1444','2013-06-30','08:05:00',1.26),('1444','2013-06-30','08:10:00',1.32),('1444','2013-06-30','08:15:00',1.39),('1444','2013-06-30','08:20:00',1.45),('1444','2013-06-30','08:25:00',1.51),('1444','2013-06-30','08:30:00',1.57),('1444','2013-06-30','08:35:00',1.59),('1444','2013-06-30','08:40:00',1.68),('1444','2013-06-30','08:45:00',1.74),('1444','2013-06-30','08:50:00',1.8),('1444','2013-06-30','08:55:00',1.85),('1444','2013-06-30','09:00:00',1.9),('1444','2013-06-30','09:05:00',1.95),('1444','2013-06-30','09:10:00',2),('1444','2013-06-30','09:15:00',2.06),('1444','2013-06-30','09:20:00',2.11),('1444','2013-06-30','09:25:00',2.16),('1444','2013-06-30','09:30:00',2.22),('1444','2013-06-30','09:35:00',2.26),('1444','2013-06-30','09:40:00',2.32),('1444','2013-06-30','09:45:00',2.36),('1444','2013-06-30','09:50:00',2.4),('1444','2013-06-30','09:55:00',2.45),('1444','2013-06-30','10:00:00',2.49),('1444','2013-06-30','10:05:00',2.52),('1444','2013-06-30','10:10:00',2.56),('1444','2013-06-30','10:15:00',2.62),('1444','2013-06-30','10:20:00',2.67),('1444','2013-06-30','10:25:00',2.71),('1444','2013-06-30','10:30:00',2.73),('1444','2013-06-30','10:35:00',2.75),('1444','2013-06-30','10:40:00',2.79),('1444','2013-06-30','10:45:00',2.82),('1444','2013-06-30','10:50:00',2.86),('1444','2013-06-30','10:55:00',2.87),('1444','2013-06-30','11:00:00',2.87),('1444','2013-06-30','11:05:00',2.88),('1444','2013-06-30','11:10:00',2.91),('1444','2013-06-30','11:15:00',2.93),('1444','2013-06-30','11:20:00',2.96),('1444','2013-06-30','11:25:00',2.99),('1444','2013-06-30','11:30:00',3.01),('1444','2013-06-30','11:35:00',3.03),('1444','2013-06-30','11:40:00',3.05),('1444','2013-06-30','11:45:00',3.05),('1444','2013-06-30','11:50:00',3.06),('1444','2013-06-30','11:55:00',3.1),('1444','2013-06-30','12:00:00',3.13),('1444','2013-06-30','12:05:00',3.15),('1444','2013-06-30','12:10:00',3.18),('1444','2013-06-30','12:15:00',3.18),('1444','2013-06-30','12:20:00',3.19),('1444','2013-06-30','12:25:00',3.17),('1444','2013-06-30','12:30:00',3.17),('1444','2013-06-30','12:35:00',3.18),('1444','2013-06-30','12:40:00',3.21),('1444','2013-06-30','12:45:00',3.17),('1444','2013-06-30','12:50:00',3.21),('1444','2013-06-30','12:55:00',3.28),('1444','2013-06-30','13:00:00',3.31),('1444','2013-06-30','13:05:00',3.28),('1444','2013-06-30','13:10:00',3.24),('1444','2013-06-30','13:15:00',3.26),('1444','2013-06-30','13:20:00',3.28),('1444','2013-06-30','13:25:00',3.31),('1444','2013-06-30','13:30:00',3.29),('1444','2013-06-30','13:35:00',3.26),('1444','2013-06-30','13:40:00',3.02),('1444','2013-06-30','13:45:00',2.4),('1444','2013-06-30','13:50:00',3.27),('1444','2013-06-30','13:55:00',3.22),('1444','2013-06-30','14:00:00',3.13),('1444','2013-06-30','14:05:00',3.23),('1444','2013-06-30','14:10:00',3.22),('1444','2013-06-30','14:15:00',3.18),('1444','2013-06-30','14:20:00',3.16),('1444','2013-06-30','14:25:00',3.14),('1444','2013-06-30','14:30:00',3.07),('1444','2013-06-30','14:35:00',3.06),('1444','2013-06-30','14:40:00',3.08),('1444','2013-06-30','14:45:00',3.1),('1444','2013-06-30','14:50:00',3.06),('1444','2013-06-30','14:55:00',3.02),('1444','2013-06-30','15:00:00',2.99),('1444','2013-06-30','15:05:00',2.93),('1444','2013-06-30','15:10:00',2.93),('1444','2013-06-30','15:15:00',2.93),('1444','2013-06-30','15:20:00',2.93),('1444','2013-06-30','15:25:00',2.9),('1444','2013-06-30','15:30:00',2.85),('1444','2013-06-30','15:35:00',2.84),('1444','2013-06-30','15:40:00',2.81),('1444','2013-06-30','15:45:00',2.78),('1444','2013-06-30','15:50:00',2.77),('1444','2013-06-30','15:55:00',2.71),('1444','2013-06-30','16:00:00',2.67),('1444','2013-06-30','16:05:00',2.62),('1444','2013-06-30','16:10:00',2.61),('1444','2013-06-30','16:15:00',2.55),('1444','2013-06-30','16:20:00',2.5),('1444','2013-06-30','16:25:00',2.56),('1444','2013-06-30','16:30:00',2.58),('1444','2013-06-30','16:35:00',2.4),('1444','2013-06-30','16:40:00',2.29),('1444','2013-06-30','16:45:00',2.24),('1444','2013-06-30','16:50:00',2.2),('1444','2013-06-30','16:55:00',2.13),('1444','2013-06-30','17:00:00',2.05),('1444','2013-06-30','17:05:00',1.99),('1444','2013-06-30','17:10:00',1.96),('1444','2013-06-30','17:15:00',1.89),('1444','2013-06-30','17:20:00',1.84),('1444','2013-06-30','17:25:00',1.79),('1444','2013-06-30','17:30:00',1.71),('1444','2013-06-30','17:35:00',1.65),('1444','2013-06-30','17:40:00',1.62),('1444','2013-06-30','17:45:00',1.56),('1444','2013-06-30','17:50:00',1.51),('1444','2013-06-30','17:55:00',1.44),('1444','2013-06-30','18:00:00',1.34),('1444','2013-06-30','18:05:00',1.17),('1444','2013-06-30','18:10:00',1.24),('1444','2013-06-30','18:15:00',1.2),('1444','2013-06-30','18:20:00',1.14),('1444','2013-06-30','18:25:00',1.09),('1444','2013-06-30','18:30:00',1.02),('1444','2013-06-29','07:30:00',1.01),('1444','2013-06-29','07:35:00',1.19),('1444','2013-06-29','07:40:00',1.24),('1444','2013-06-29','07:45:00',1.24),('1444','2013-06-29','07:50:00',1.31),('1444','2013-06-29','07:55:00',1.46),('1444','2013-06-29','08:00:00',1.61),('1444','2013-06-29','08:05:00',1.72),('1444','2013-06-29','08:10:00',1.76),('1444','2013-06-29','08:15:00',1.39),('1444','2013-06-29','08:20:00',1.09),('1444','2013-06-29','08:25:00',1.55),('1444','2013-06-29','08:30:00',1.67),('1444','2013-06-29','08:35:00',1.65),('1444','2013-06-29','08:40:00',1.03),('1444','2013-06-29','08:45:00',1.72),('1444','2013-06-29','08:50:00',1.81),('1444','2013-06-29','08:55:00',1.86),('1444','2013-06-29','09:00:00',1.9),('1444','2013-06-29','09:05:00',1.94),('1444','2013-06-29','09:10:00',1.98),('1444','2013-06-29','09:15:00',2.03),('1444','2013-06-29','09:20:00',2.09),('1444','2013-06-29','09:25:00',2.14),('1444','2013-06-29','09:30:00',2.17),('1444','2013-06-29','09:35:00',2.21),('1444','2013-06-29','09:40:00',2.27),('1444','2013-06-29','09:45:00',2.34),('1444','2013-06-29','09:50:00',2.39),('1444','2013-06-29','09:55:00',2.41),('1444','2013-06-29','10:00:00',2.44),('1444','2013-06-29','10:05:00',2.49),('1444','2013-06-29','10:10:00',2.54),('1444','2013-06-29','10:15:00',2.58),('1444','2013-06-29','10:20:00',2.61),('1444','2013-06-29','10:25:00',2.59),('1444','2013-06-29','10:30:00',2.69),('1444','2013-06-29','10:35:00',2.72),('1444','2013-06-29','10:40:00',2.78),('1444','2013-06-29','10:45:00',2.79),('1444','2013-06-29','10:50:00',2.49),('1444','2013-06-29','10:55:00',1.5),('1444','2013-06-29','11:00:00',2.99),('1444','2013-06-29','11:05:00',2.99),('1444','2013-06-29','11:10:00',2.99),('1444','2013-06-29','11:15:00',3.07),('1444','2013-06-29','11:20:00',3.23),('1444','2013-06-29','11:25:00',3.33),('1444','2013-06-29','11:30:00',3.33),('1444','2013-06-29','11:35:00',2.39),('1444','2013-06-29','11:40:00',1.01),('1444','2013-06-29','11:45:00',3.62),('1444','2013-06-29','11:50:00',3.65),('1444','2013-06-29','11:55:00',3.18),('1444','2013-06-29','12:00:00',3.23),('1444','2013-06-29','12:05:00',3.13),('1444','2013-06-29','12:10:00',3.39),('1444','2013-06-29','12:15:00',3.49),('1444','2013-06-29','12:20:00',2.27),('1444','2013-06-29','12:25:00',3.43),('1444','2013-06-29','12:30:00',3.5),('1444','2013-06-29','12:35:00',1.22),('1444','2013-06-29','12:40:00',1.25),('1444','2013-06-29','12:45:00',3.27),('1444','2013-06-29','12:50:00',3.29),('1444','2013-06-29','12:55:00',3.45),('1444','2013-06-29','13:00:00',1.97),('1444','2013-06-29','13:05:00',2.22),('1444','2013-06-29','13:10:00',3.78),('1444','2013-06-29','13:15:00',3.08),('1444','2013-06-29','13:20:00',1.18),('1444','2013-06-29','13:25:00',2.78),('1444','2013-06-29','13:45:00',1.06),('1444','2013-06-29','13:50:00',1.27),('1444','2013-06-29','13:55:00',2.11),('1444','2013-06-29','14:00:00',3.72),('1444','2013-06-29','14:05:00',3.64),('1444','2013-06-29','14:10:00',3.59),('1444','2013-06-29','14:15:00',3.55),('1444','2013-06-29','14:20:00',3.7),('1444','2013-06-29','14:25:00',3.66),('1444','2013-06-29','14:30:00',3.5),('1444','2013-06-29','14:35:00',3.45),('1444','2013-06-29','14:40:00',3.44),('1444','2013-06-29','14:45:00',3.46),('1444','2013-06-29','14:50:00',3.65),('1444','2013-06-29','14:55:00',2.67),('1444','2013-06-29','15:00:00',3.06),('1444','2013-06-29','15:05:00',3.86),('1444','2013-06-29','15:10:00',2.21),('1444','2013-06-29','15:15:00',2.21),('1444','2013-06-29','15:20:00',1.16),('1444','2013-06-29','15:25:00',1.05),('1444','2013-06-29','16:45:00',1.19),('1444','2013-06-29','16:50:00',1.87),('1444','2013-06-29','16:55:00',1.03),('1444','2013-06-29','17:00:00',1.01),('1444','2013-06-29','17:05:00',1.48),('1444','2013-06-29','17:20:00',1.15),('1444','2013-06-29','17:25:00',1.46),('1444','2013-06-29','17:30:00',2.06),('1444','2013-06-29','17:35:00',1.56),('1444','2013-06-29','17:45:00',1.63),('1444','2013-06-29','17:50:00',1.46),('1444','2013-06-29','17:55:00',1.49),('1444','2013-06-29','18:00:00',1.4),('1444','2013-06-29','18:05:00',1.32),('1444','2013-06-29','18:20:00',1.11),('1444','2013-06-28','07:45:00',1.03),('1444','2013-06-28','07:50:00',1.07),('1444','2013-06-28','07:55:00',1.12),('1444','2013-06-28','08:00:00',1.14),('1444','2013-06-28','08:05:00',1.05),('1444','2013-06-28','08:10:00',1.15),('1444','2013-06-28','08:15:00',1.3),('1444','2013-06-28','08:20:00',1.31),('1444','2013-06-28','08:25:00',1.33),('1444','2013-06-28','08:30:00',1.48),('1444','2013-06-28','08:35:00',1.53),('1444','2013-06-28','08:40:00',1.59),('1444','2013-06-28','08:45:00',1.64),('1444','2013-06-28','08:50:00',1.69),('1444','2013-06-28','08:55:00',1.79),('1444','2013-06-28','09:00:00',1.86),('1444','2013-06-28','09:05:00',1.9),('1444','2013-06-28','09:10:00',2.06),('1444','2013-06-28','09:15:00',1.39),('1444','2013-06-28','09:25:00',1.68),('1444','2013-06-28','09:30:00',2.28),('1444','2013-06-28','09:35:00',2.3),('1444','2013-06-28','09:40:00',2.46),('1444','2013-06-28','09:45:00',2.53),('1444','2013-06-28','09:50:00',2.27),('1444','2013-06-28','09:55:00',1.49),('1444','2013-06-28','10:00:00',1.41),('1444','2013-06-28','10:05:00',2.66),('1444','2013-06-28','10:10:00',2.74),('1444','2013-06-28','10:15:00',2.08),('1444','2013-06-28','10:25:00',1.03),('1444','2013-06-28','10:30:00',3.2),('1444','2013-06-28','10:35:00',2.73),('1444','2013-06-28','10:40:00',2.04),('1444','2013-06-28','10:45:00',2.14),('1444','2013-06-28','10:50:00',1.78),('1444','2013-06-28','10:55:00',1.69),('1444','2013-06-28','11:00:00',2.48),('1444','2013-06-28','11:05:00',1.32),('1444','2013-06-28','11:10:00',1.34),('1444','2013-06-28','11:15:00',1.2),('1444','2013-06-28','11:20:00',1.29),('1444','2013-06-28','11:25:00',2.19),('1444','2013-06-28','11:30:00',3.06),('1444','2013-06-28','11:35:00',2.76),('1444','2013-06-28','11:40:00',3.35),('1444','2013-06-28','11:45:00',2.89),('1444','2013-06-28','11:50:00',2.51),('1444','2013-06-28','11:55:00',3.09),('1444','2013-06-28','12:00:00',1.59),('1444','2013-06-28','12:05:00',2.96),('1444','2013-06-28','12:10:00',3.64),('1444','2013-06-28','12:15:00',3.34),('1444','2013-06-28','12:20:00',3.24),('1444','2013-06-28','12:25:00',3.44),('1444','2013-06-28','12:30:00',3.4),('1444','2013-06-28','12:35:00',2.24),('1444','2013-06-28','12:40:00',2.47),('1444','2013-06-28','12:45:00',3.41),('1444','2013-06-28','12:50:00',3.39),('1444','2013-06-28','12:55:00',3.31),('1444','2013-06-28','13:00:00',3.37),('1444','2013-06-28','13:05:00',3.44),('1444','2013-06-28','13:10:00',3.44),('1444','2013-06-28','13:15:00',2.87),('1444','2013-06-28','13:20:00',3.26),('1444','2013-06-28','13:25:00',3.31),('1444','2013-06-28','13:30:00',3.32),('1444','2013-06-28','13:35:00',3.03),('1444','2013-06-28','13:40:00',3.02),('1444','2013-06-28','13:45:00',2.92),('1444','2013-06-28','13:50:00',2.64),('1444','2013-06-28','13:55:00',3.13),('1444','2013-06-28','14:00:00',2.81),('1444','2013-06-28','14:05:00',3.22),('1444','2013-06-28','14:10:00',2.78),('1444','2013-06-28','14:15:00',3.16),('1444','2013-06-28','14:20:00',2.88),('1444','2013-06-28','14:25:00',1.74),('1444','2013-06-28','14:30:00',3.05),('1444','2013-06-28','14:35:00',2.68),('1444','2013-06-28','14:40:00',2.76),('1444','2013-06-28','14:45:00',3.4),('1444','2013-06-28','14:50:00',3.24),('1444','2013-06-28','14:55:00',3.14),('1444','2013-06-28','15:00:00',2.91),('1444','2013-06-28','15:05:00',3.05),('1444','2013-06-28','15:10:00',3.02),('1444','2013-06-28','15:15:00',3.07),('1444','2013-06-28','15:20:00',3.16),('1444','2013-06-28','15:25:00',2.98),('1444','2013-06-28','15:30:00',2.75),('1444','2013-06-28','15:35:00',2.56),('1444','2013-06-28','15:40:00',1.31),('1444','2013-06-28','15:45:00',2.94),('1444','2013-06-28','15:50:00',2.33),('1444','2013-06-28','15:55:00',2.89),('1444','2013-06-28','16:00:00',2.6),('1444','2013-06-28','16:05:00',2.17),('1444','2013-06-28','16:10:00',1.35),('1444','2013-06-28','16:15:00',2.09),('1444','2013-06-28','16:20:00',2.41),('1444','2013-06-28','16:25:00',2.2),('1444','2013-06-28','16:30:00',2.02),('1444','2013-06-28','16:40:00',1.58),('1444','2013-06-28','16:45:00',1.73),('1444','2013-06-28','16:50:00',2.48),('1444','2013-06-28','16:55:00',2.33),('1444','2013-06-28','17:00:00',2.1),('1444','2013-06-28','17:05:00',2.01),('1444','2013-06-28','17:10:00',1.96),('1444','2013-06-28','17:15:00',1.91),('1444','2013-06-28','17:20:00',1.83),('1444','2013-06-28','17:25:00',1.85),('1444','2013-06-28','17:30:00',1.76),('1444','2013-06-28','17:35:00',1.69),('1444','2013-06-28','17:40:00',1.6),('1444','2013-06-28','17:45:00',1.58),('1444','2013-06-28','17:50:00',1.53),('1444','2013-06-28','17:55:00',1.48),('1444','2013-06-28','18:00:00',1.42),('1444','2013-06-28','18:05:00',1.34),('1444','2013-06-28','18:10:00',1.28),('1444','2013-06-28','18:15:00',1.26),('1444','2013-06-28','18:20:00',1.2),('1444','2013-06-28','18:25:00',1.14),('1444','2013-06-27','07:50:00',1.06),('1444','2013-06-27','07:55:00',1.11),('1444','2013-06-27','08:00:00',1.17),('1444','2013-06-27','08:05:00',1.23),('1444','2013-06-27','08:10:00',1.25),('1444','2013-06-27','08:15:00',1.33),('1444','2013-06-27','08:20:00',1.41),('1444','2013-06-27','08:25:00',1.46),('1444','2013-06-27','08:30:00',1.51),('1444','2013-06-27','08:35:00',1.56),('1444','2013-06-27','08:40:00',1.61),('1444','2013-06-27','08:45:00',1.67),('1444','2013-06-27','08:50:00',1.73),('1444','2013-06-27','08:55:00',1.83),('1444','2013-06-27','09:00:00',1.87),('1444','2013-06-27','09:05:00',1.91),('1444','2013-06-27','09:10:00',1.98),('1444','2013-06-27','09:15:00',2.03),('1444','2013-06-27','09:20:00',2.1),('1444','2013-06-27','09:25:00',2.14),('1444','2013-06-27','09:30:00',2.17),('1444','2013-06-27','09:35:00',2.22),('1444','2013-06-27','09:40:00',2.28),('1444','2013-06-27','09:45:00',2.28),('1444','2013-06-27','09:50:00',2.4),('1444','2013-06-27','09:55:00',2.48),('1444','2013-06-27','10:00:00',2.2),('1444','2013-06-27','10:05:00',1.54),('1444','2013-06-27','10:10:00',2.29),('1444','2013-06-27','10:15:00',1.57),('1444','2013-06-27','10:20:00',2.67),('1444','2013-06-27','10:25:00',2.68),('1444','2013-06-27','10:30:00',2.75),('1444','2013-06-27','10:35:00',2.63),('1444','2013-06-27','10:40:00',3.04),('1444','2013-06-27','10:45:00',3.06),('1444','2013-06-27','10:50:00',2.7),('1444','2013-06-27','10:55:00',3.07),('1444','2013-06-27','11:00:00',3.04),('1444','2013-06-27','11:05:00',3.1),('1444','2013-06-27','11:10:00',3.1),('1444','2013-06-27','11:15:00',3.11),('1444','2013-06-27','11:20:00',2.1),('1444','2013-06-27','11:25:00',2.98),('1444','2013-06-27','11:30:00',3.2),('1444','2013-06-27','11:35:00',3.18),('1444','2013-06-27','11:40:00',3.27),('1444','2013-06-27','11:45:00',3.36),('1444','2013-06-27','11:50:00',1.59),('1444','2013-06-27','12:25:00',1.1),('1444','2013-06-27','12:30:00',1.75),('1444','2013-06-27','12:35:00',2.15),('1444','2013-06-27','12:40:00',1.25),('1444','2013-06-27','12:45:00',1.48),('1444','2013-06-27','12:50:00',1.49),('1444','2013-06-27','13:15:00',1.03),('1444','2013-06-27','13:20:00',1.04),('1444','2013-06-27','13:25:00',1.1),('1444','2013-06-27','13:30:00',1.01),('1444','2013-06-27','13:45:00',1.01),('1444','2013-06-27','13:50:00',1.1),('1444','2013-06-27','14:00:00',1.01),('1444','2013-06-27','14:05:00',1.03),('1444','2013-06-27','14:10:00',1.31),('1444','2013-06-27','14:15:00',2.23),('1444','2013-06-27','14:20:00',2.98),('1444','2013-06-27','14:25:00',1.42),('1444','2013-06-27','14:30:00',1.2),('1444','2013-06-27','14:35:00',1.18),('1444','2013-06-27','14:40:00',2.5),('1444','2013-06-27','14:45:00',2.92),('1444','2013-06-27','14:50:00',2.98),('1444','2013-06-27','14:55:00',2.98),('1444','2013-06-27','15:00:00',2.9),('1444','2013-06-27','15:05:00',2.86),('1444','2013-06-27','15:10:00',2.84),('1444','2013-06-27','15:15:00',2.81),('1444','2013-06-27','15:20:00',2.8),('1444','2013-06-27','15:25:00',2.79),('1444','2013-06-27','15:30:00',2.77),('1444','2013-06-27','15:35:00',2.73),('1444','2013-06-27','15:40:00',2.69),('1444','2013-06-27','15:45:00',2.66),('1444','2013-06-27','15:50:00',2.57),('1444','2013-06-27','15:55:00',2.6),('1444','2013-06-27','16:00:00',2.5),('1444','2013-06-27','16:05:00',2.46),('1444','2013-06-27','16:10:00',2.44),('1444','2013-06-27','16:15:00',2.41),('1444','2013-06-27','16:20:00',2.39),('1444','2013-06-27','16:25:00',2.35),('1444','2013-06-27','16:30:00',2.31),('1444','2013-06-27','16:35:00',2.15),('1444','2013-06-27','16:40:00',2.19),('1444','2013-06-27','16:45:00',2.19),('1444','2013-06-27','16:50:00',2.11),('1444','2013-06-27','16:55:00',2.06),('1444','2013-06-27','17:00:00',2.01),('1444','2013-06-27','17:05:00',1.95),('1444','2013-06-27','17:10:00',1.85),('1444','2013-06-27','17:15:00',1.8),('1444','2013-06-27','17:20:00',1.86),('1444','2013-06-27','17:25:00',1.79),('1444','2013-06-27','17:30:00',1.75),('1444','2013-06-27','17:35:00',1.67),('1444','2013-06-27','17:40:00',1.39),('1444','2013-06-27','17:50:00',1.43),('1444','2013-06-27','17:55:00',1.39),('1444','2013-06-27','18:00:00',1.33),('1444','2013-06-27','18:05:00',1.28),('1444','2013-06-27','18:10:00',1.21),('1444','2013-06-27','18:15:00',1.13),('1444','2013-06-27','18:20:00',1.08),('1444','2013-06-27','18:25:00',1.08),('1444','2013-06-27','18:30:00',1.03),('1444','2013-06-26','07:45:00',1),('1444','2013-06-26','07:50:00',1.07),('1444','2013-06-26','07:55:00',1.11),('1444','2013-06-26','08:00:00',1.16),('1444','2013-06-26','08:05:00',1.23),('1444','2013-06-26','08:10:00',1.3),('1444','2013-06-26','08:15:00',1.35),('1444','2013-06-26','08:20:00',1.4),('1444','2013-06-26','08:25:00',1.46),('1444','2013-06-26','08:30:00',1.51),('1444','2013-06-26','08:35:00',1.56),('1444','2013-06-26','08:40:00',1.62),('1444','2013-06-26','08:45:00',1.68),('1444','2013-06-26','08:50:00',1.72),('1444','2013-06-26','08:55:00',1.78),('1444','2013-06-26','09:00:00',1.84),('1444','2013-06-26','09:05:00',1.9),('1444','2013-06-26','09:10:00',1.93),('1444','2013-06-26','09:15:00',1.97),('1444','2013-06-26','09:20:00',2.02),('1444','2013-06-26','09:25:00',2.08),('1444','2013-06-26','09:30:00',2.13),('1444','2013-06-26','09:35:00',2.16),('1444','2013-06-26','09:40:00',2.2),('1444','2013-06-26','09:45:00',2.24),('1444','2013-06-26','09:50:00',2.28),('1444','2013-06-26','09:55:00',2.32),('1444','2013-06-26','10:00:00',2.38),('1444','2013-06-26','10:05:00',2.42),('1444','2013-06-26','10:10:00',2.48),('1444','2013-06-26','10:15:00',2.53),('1444','2013-06-26','10:20:00',2.56),('1444','2013-06-26','10:25:00',2.56),('1444','2013-06-26','10:30:00',2.58),('1444','2013-06-26','10:35:00',2.62),('1444','2013-06-26','10:40:00',2.68),('1444','2013-06-26','10:45:00',2.72),('1444','2013-06-26','10:50:00',2.76),('1444','2013-06-26','10:55:00',2.78),('1444','2013-06-26','11:00:00',2.8),('1444','2013-06-26','11:05:00',2.82),('1444','2013-06-26','11:10:00',2.86),('1444','2013-06-26','11:15:00',2.89),('1444','2013-06-26','11:20:00',2.93),('1444','2013-06-26','11:25:00',2.93),('1444','2013-06-26','11:30:00',2.92),('1444','2013-06-26','11:35:00',2.98),('1444','2013-06-26','11:40:00',2.99),('1444','2013-06-26','11:45:00',3),('1444','2013-06-26','11:50:00',3),('1444','2013-06-26','11:55:00',3.05),('1444','2013-06-26','12:00:00',3.1),('1444','2013-06-26','12:05:00',3.12),('1444','2013-06-26','12:10:00',3.07),('1444','2013-06-26','12:15:00',3.1),('1444','2013-06-26','12:20:00',3.1),('1444','2013-06-26','12:25:00',3.09),('1444','2013-06-26','12:30:00',3.14),('1444','2013-06-26','12:35:00',3.14),('1444','2013-06-26','12:40:00',3.08),('1444','2013-06-26','12:45:00',1.42),('1444','2013-06-26','12:50:00',2.26),('1444','2013-06-26','12:55:00',1.23),('1444','2013-06-26','13:00:00',3.31),('1444','2013-06-26','13:05:00',1.8),('1444','2013-06-26','13:10:00',3.43),('1444','2013-06-26','13:15:00',3.34),('1444','2013-06-26','13:20:00',1.99),('1444','2013-06-26','13:25:00',2.84),('1444','2013-06-26','13:30:00',1.41),('1444','2013-06-26','13:35:00',1.11),('1444','2013-06-26','13:40:00',2.25),('1444','2013-06-26','13:45:00',1.31),('1444','2013-06-26','13:50:00',2.41),('1444','2013-06-26','13:55:00',2.15),('1444','2013-06-26','14:00:00',3.02),('1444','2013-06-26','14:05:00',3.41),('1444','2013-06-26','14:10:00',2.64),('1444','2013-06-26','14:15:00',1.56),('1444','2013-06-26','14:20:00',3.31),('1444','2013-06-26','14:25:00',3),('1444','2013-06-26','14:30:00',1.96),('1444','2013-06-26','14:35:00',2.72),('1444','2013-06-26','14:40:00',2.95),('1444','2013-06-26','14:45:00',2.31),('1444','2013-06-26','14:50:00',3.23),('1444','2013-06-26','14:55:00',3.14),('1444','2013-06-26','15:00:00',2.96),('1444','2013-06-26','15:05:00',2.91),('1444','2013-06-26','15:10:00',2.87),('1444','2013-06-26','15:15:00',2.83),('1444','2013-06-26','15:20:00',2.84),('1444','2013-06-26','15:25:00',2.8),('1444','2013-06-26','15:30:00',2.76),('1444','2013-06-26','15:35:00',2.77),('1444','2013-06-26','15:40:00',2.43),('1444','2013-06-26','15:45:00',2.68),('1444','2013-06-26','15:50:00',2.7),('1444','2013-06-26','15:55:00',2.62),('1444','2013-06-26','16:00:00',2.6),('1444','2013-06-26','16:05:00',2.54),('1444','2013-06-26','16:10:00',2.49),('1444','2013-06-26','16:15:00',2.44),('1444','2013-06-26','16:20:00',2.41),('1444','2013-06-26','16:25:00',2.37),('1444','2013-06-26','16:30:00',2.32),('1444','2013-06-26','16:35:00',2.24),('1444','2013-06-26','16:40:00',2.2),('1444','2013-06-26','16:45:00',2.17),('1444','2013-06-26','16:50:00',2.13),('1444','2013-06-26','16:55:00',2.07),('1444','2013-06-26','17:00:00',2.04),('1444','2013-06-26','17:05:00',1.99),('1444','2013-06-26','17:10:00',1.94),('1444','2013-06-26','17:15:00',1.87),('1444','2013-06-26','17:20:00',1.82),('1444','2013-06-26','17:25:00',1.76),('1444','2013-06-26','17:30:00',1.71),('1444','2013-06-26','17:35:00',1.66),('1444','2013-06-26','17:40:00',1.59),('1444','2013-06-26','17:45:00',1.53),('1444','2013-06-26','17:50:00',1.47),('1444','2013-06-26','17:55:00',1.41),('1444','2013-06-26','18:00:00',1.36),('1444','2013-06-26','18:05:00',1.37),('1444','2013-06-26','18:10:00',1.51),('1444','2013-06-26','18:15:00',1.2),('1444','2013-06-25','07:45:00',1.04),('1444','2013-06-25','07:50:00',1.06),('1444','2013-06-25','08:00:00',1.22),('1444','2013-06-25','08:20:00',1.03),('1444','2013-06-25','08:25:00',1.49),('1444','2013-06-25','08:30:00',1.54),('1444','2013-06-25','08:35:00',1.6),('1444','2013-06-25','08:40:00',1.65),('1444','2013-06-25','08:45:00',1.7),('1444','2013-06-25','08:50:00',1.75),('1444','2013-06-25','08:55:00',1.82),('1444','2013-06-25','09:00:00',1.88),('1444','2013-06-25','09:05:00',1.93),('1444','2013-06-25','09:10:00',1.96),('1444','2013-06-25','09:15:00',1.99),('1444','2013-06-25','09:20:00',2.06),('1444','2013-06-25','09:25:00',2.08),('1444','2013-06-25','09:30:00',2.17),('1444','2013-06-25','09:35:00',2.33),('1444','2013-06-25','09:40:00',2.38),('1444','2013-06-25','09:45:00',2.51),('1444','2013-06-25','09:50:00',2.6),('1444','2013-06-25','09:55:00',2.66),('1444','2013-06-25','10:00:00',2.72),('1444','2013-06-25','10:05:00',2.78),('1444','2013-06-25','10:10:00',2.9),('1444','2013-06-25','10:15:00',2.12),('1444','2013-06-25','10:25:00',1.66),('1444','2013-06-25','10:30:00',3.07),('1444','2013-06-25','10:35:00',2.79),('1444','2013-06-25','10:40:00',2.5),('1444','2013-06-25','10:55:00',1.77),('1444','2013-06-25','11:00:00',2.29),('1444','2013-06-25','11:10:00',1.97),('1444','2013-06-25','11:15:00',3.35),('1444','2013-06-25','11:35:00',1.7),('1444','2013-06-25','11:40:00',3.59),('1444','2013-06-25','11:45:00',3.19),('1444','2013-06-25','11:50:00',3.54),('1444','2013-06-25','11:55:00',1.08),('1444','2013-06-25','12:30:00',1.07),('1444','2013-06-25','12:35:00',3.08),('1444','2013-06-25','12:40:00',2.59),('1444','2013-06-25','12:45:00',2.74),('1444','2013-06-25','12:50:00',2.07),('1444','2013-06-25','12:55:00',1.73),('1444','2013-06-25','13:00:00',3.65),('1444','2013-06-25','13:05:00',3.19),('1444','2013-06-25','13:10:00',1.19),('1444','2013-06-25','13:15:00',3.42),('1444','2013-06-25','13:20:00',2.38),('1444','2013-06-25','13:25:00',3.45),('1444','2013-06-25','13:30:00',2.06),('1444','2013-06-25','13:35:00',3.17),('1444','2013-06-25','13:40:00',3.5),('1444','2013-06-25','13:45:00',3.33),('1444','2013-06-25','13:50:00',2.31),('1444','2013-06-25','13:55:00',1.71),('1444','2013-06-25','14:00:00',2.49),('1444','2013-06-25','14:05:00',3.37),('1444','2013-06-25','14:10:00',3.15),('1444','2013-06-25','14:15:00',2.87),('1444','2013-06-25','14:20:00',3.14),('1444','2013-06-25','14:25:00',3.17),('1444','2013-06-25','14:30:00',3.1),('1444','2013-06-25','14:35:00',3.09),('1444','2013-06-25','14:40:00',3.12),('1444','2013-06-25','14:45:00',3.09),('1444','2013-06-25','14:50:00',3.05),('1444','2013-06-25','14:55:00',3.02),('1444','2013-06-25','15:00:00',2.97),('1444','2013-06-25','15:05:00',2.96),('1444','2013-06-25','15:10:00',2.93),('1444','2013-06-25','15:15:00',2.89),('1444','2013-06-25','15:20:00',2.86),('1444','2013-06-25','15:25:00',2.81),('1444','2013-06-25','15:30:00',2.79),('1444','2013-06-25','15:35:00',2.73),('1444','2013-06-25','15:40:00',2.71),('1444','2013-06-25','15:45:00',2.65),('1444','2013-06-25','15:50:00',2.63),('1444','2013-06-25','15:55:00',2.59),('1444','2013-06-25','16:00:00',2.56),('1444','2013-06-25','16:05:00',2.51),('1444','2013-06-25','16:10:00',2.47),('1444','2013-06-25','16:15:00',2.44),('1444','2013-06-25','16:20:00',2.39),('1444','2013-06-25','16:25:00',2.34),('1444','2013-06-25','16:30:00',2.3),('1444','2013-06-25','16:35:00',2.25),('1444','2013-06-25','16:40:00',2.21),('1444','2013-06-25','16:45:00',2.17),('1444','2013-06-25','16:50:00',2.11),('1444','2013-06-25','16:55:00',2.06),('1444','2013-06-25','17:00:00',2.01),('1444','2013-06-25','17:05:00',1.96),('1444','2013-06-25','17:10:00',1.9),('1444','2013-06-25','17:15:00',1.86),('1444','2013-06-25','17:20:00',1.81),('1444','2013-06-25','17:25:00',1.75),('1444','2013-06-25','17:30:00',1.7),('1444','2013-06-25','17:35:00',1.65),('1444','2013-06-25','17:40:00',1.58),('1444','2013-06-25','17:45:00',1.52),('1444','2013-06-25','17:50:00',1.45),('1444','2013-06-25','17:55:00',1.42),('1444','2013-06-25','18:00:00',1.37),('1444','2013-06-25','18:05:00',1.29),('1444','2013-06-25','18:10:00',1.22),('1444','2013-06-25','18:15:00',1.16),('1444','2013-06-25','18:20:00',1.12),('1444','2013-06-25','18:25:00',1.05),('1444','2013-06-25','18:30:00',1),('1444','2013-06-24','08:40:00',1.68),('1444','2013-06-24','08:45:00',1.83),('1444','2013-06-24','08:50:00',1.86),('1444','2013-06-24','08:55:00',1.99),('1444','2013-06-24','09:00:00',1.92),('1444','2013-06-24','09:05:00',1.24),('1444','2013-06-24','09:10:00',1.54),('1444','2013-06-24','09:15:00',1.92),('1444','2013-06-24','09:20:00',2.01),('1444','2013-06-24','09:25:00',2.71),('1444','2013-06-24','09:30:00',2.34),('1444','2013-06-24','09:35:00',2.06),('1444','2013-06-24','09:40:00',2.49),('1444','2013-06-24','09:45:00',2.73),('1444','2013-06-24','09:50:00',2.57),('1444','2013-06-24','09:55:00',2.35),('1444','2013-06-24','10:00:00',2.54),('1444','2013-06-24','10:05:00',2.61),('1444','2013-06-24','10:10:00',2.41),('1444','2013-06-24','10:15:00',2.2),('1444','2013-06-24','10:20:00',1.98),('1444','2013-06-24','10:25:00',2.87),('1444','2013-06-24','10:30:00',1.82),('1444','2013-06-24','10:35:00',2.78),('1444','2013-06-24','10:40:00',1.44),('1444','2013-06-24','10:45:00',2.64),('1444','2013-06-24','10:50:00',2.59),('1444','2013-06-24','10:55:00',2.17),('1444','2013-06-24','11:00:00',2.85),('1444','2013-06-24','11:05:00',1.99),('1444','2013-06-24','11:15:00',2.82),('1444','2013-06-24','11:20:00',2.56),('1444','2013-06-24','11:25:00',2.15),('1444','2013-06-24','11:30:00',2.32),('1444','2013-06-24','11:35:00',1.05),('1444','2013-06-24','11:45:00',1.72),('1444','2013-06-24','11:50:00',1.59),('1444','2013-06-24','11:55:00',2.58),('1444','2013-06-24','12:00:00',2.88),('1444','2013-06-24','12:05:00',2.74),('1444','2013-06-24','12:10:00',3.44),('1444','2013-06-24','12:15:00',1.41),('1444','2013-06-24','12:20:00',3.75),('1444','2013-06-24','12:25:00',2.9),('1444','2013-06-24','12:30:00',1.95),('1444','2013-06-24','12:35:00',3),('1444','2013-06-24','12:40:00',2.19),('1444','2013-06-24','12:45:00',3.02),('1444','2013-06-24','12:50:00',3.01),('1444','2013-06-24','12:55:00',2.6),('1444','2013-06-24','13:00:00',2.73),('1444','2013-06-24','13:05:00',3.49),('1444','2013-06-24','13:10:00',3.61),('1444','2013-06-24','13:15:00',2.48),('1444','2013-06-24','13:20:00',1.76),('1444','2013-06-24','13:25:00',2.78),('1444','2013-06-24','13:30:00',3.36),('1444','2013-06-24','13:35:00',3.29),('1444','2013-06-24','13:40:00',3.06),('1444','2013-06-24','13:45:00',3.04),('1444','2013-06-24','13:50:00',3.39),('1444','2013-06-24','13:55:00',3.28),('1444','2013-06-24','14:00:00',3.24),('1444','2013-06-24','14:05:00',3.25),('1444','2013-06-24','14:10:00',3.28),('1444','2013-06-24','14:15:00',3.27),('1444','2013-06-24','14:20:00',3.24),('1444','2013-06-24','14:25:00',3.25),('1444','2013-06-24','14:30:00',3.17),('1444','2013-06-24','14:35:00',3.28),('1444','2013-06-24','14:40:00',3.17),('1444','2013-06-24','14:45:00',3.02),('1444','2013-06-24','14:50:00',2.92),('1444','2013-06-24','14:55:00',1.73),('1444','2013-06-24','15:00:00',2.95),('1444','2013-06-24','15:05:00',1.32),('1444','2013-06-24','15:10:00',2.44),('1444','2013-06-24','15:15:00',2.34),('1444','2013-06-24','15:20:00',2.86),('1444','2013-06-24','15:25:00',2.31),('1444','2013-06-24','15:30:00',2.66),('1444','2013-06-24','15:35:00',1.13),('1444','2013-06-24','15:40:00',1.98),('1444','2013-06-24','15:45:00',2.03),('1444','2013-06-24','15:50:00',3.11),('1444','2013-06-24','15:55:00',2.92),('1444','2013-06-24','16:00:00',2.77),('1444','2013-06-24','16:05:00',3),('1444','2013-06-24','16:10:00',2.57),('1444','2013-06-24','16:15:00',2.62),('1444','2013-06-24','16:20:00',1.77),('1444','2013-06-24','16:25:00',1.58),('1444','2013-06-24','16:30:00',2.41),('1444','2013-06-24','16:35:00',2.7),('1444','2013-06-24','16:40:00',1.62),('1444','2013-06-24','16:45:00',1.08),('1444','2013-06-24','16:50:00',1.38),('1444','2013-06-24','17:00:00',1.01),('1444','2013-06-24','17:05:00',1.79),('1444','2013-06-24','17:10:00',1.31),('1444','2013-06-24','17:15:00',2.03),('1444','2013-06-24','17:20:00',1.65),('1444','2013-06-24','17:25:00',1.35),('1444','2013-06-24','17:55:00',1.22),('1444','2013-06-24','18:00:00',1.65),('1444','2013-06-24','18:05:00',1.49),('1444','2013-06-24','18:10:00',1.16),('1444','2013-06-24','18:15:00',1.27),('1444','2013-06-24','18:20:00',1.02),('1444','2013-06-23','08:50:00',1.04),('1444','2013-06-23','09:00:00',1.34),('1444','2013-06-23','09:05:00',1.07),('1444','2013-06-23','09:20:00',1.3),('1444','2013-06-23','09:25:00',2.03),('1444','2013-06-23','09:30:00',2.08),('1444','2013-06-23','09:35:00',2.23),('1444','2013-06-23','09:40:00',2.63),('1444','2013-06-23','09:45:00',1.27),('1444','2013-06-23','09:55:00',1.5),('1444','2013-06-23','10:00:00',1.31),('1444','2013-06-23','10:05:00',1.41),('1444','2013-06-23','10:10:00',2.07),('1444','2013-06-23','10:15:00',1.42),('1444','2013-06-23','10:20:00',1.71),('1444','2013-06-23','10:25:00',1.27),('1444','2013-06-23','10:30:00',1.19),('1444','2013-06-23','10:35:00',1.61),('1444','2013-06-23','10:40:00',2.56),('1444','2013-06-23','10:45:00',2.71),('1444','2013-06-23','10:50:00',2.69),('1444','2013-06-23','10:55:00',2.69),('1444','2013-06-23','11:00:00',2.73),('1444','2013-06-23','11:05:00',2.8),('1444','2013-06-23','11:10:00',2.79),('1444','2013-06-23','11:15:00',2.75),('1444','2013-06-23','11:20:00',2.89),('1444','2013-06-23','11:25:00',2.66),('1444','2013-06-23','11:30:00',2.35),('1444','2013-06-23','11:35:00',2.85),('1444','2013-06-23','11:40:00',2.89),('1444','2013-06-23','11:45:00',2.92),('1444','2013-06-23','11:50:00',2.89),('1444','2013-06-23','11:55:00',2.54),('1444','2013-06-23','12:00:00',3.08),('1444','2013-06-23','12:05:00',3.07),('1444','2013-06-23','12:10:00',3.12),('1444','2013-06-23','12:15:00',3.08),('1444','2013-06-23','12:20:00',3.08),('1444','2013-06-23','12:25:00',3.15),('1444','2013-06-23','12:30:00',3.13),('1444','2013-06-23','12:35:00',3.1),('1444','2013-06-23','12:40:00',3.15),('1444','2013-06-23','12:45:00',3.16),('1444','2013-06-23','12:50:00',3.16),('1444','2013-06-23','12:55:00',3.15),('1444','2013-06-23','13:00:00',3.14),('1444','2013-06-23','13:05:00',3.16),('1444','2013-06-23','13:10:00',3.17),('1444','2013-06-23','13:15:00',3.16),('1444','2013-06-23','13:20:00',3.14),('1444','2013-06-23','13:25:00',3.15),('1444','2013-06-23','13:30:00',3.16),('1444','2013-06-23','13:35:00',3.19),('1444','2013-06-23','13:40:00',3.18),('1444','2013-06-23','13:45:00',3.18),('1444','2013-06-23','13:50:00',3.17),('1444','2013-06-23','13:55:00',3.18),('1444','2013-06-23','14:00:00',3.14),('1444','2013-06-23','14:05:00',3.13),('1444','2013-06-23','14:10:00',3.11),('1444','2013-06-23','14:15:00',3.1),('1444','2013-06-23','14:20:00',3.08),('1444','2013-06-23','14:25:00',3.09),('1444','2013-06-23','14:30:00',3.08),('1444','2013-06-23','14:35:00',3.06),('1444','2013-06-23','14:40:00',3.03),('1444','2013-06-23','14:45:00',3.03),('1444','2013-06-23','14:50:00',3.01),('1444','2013-06-23','14:55:00',2.99),('1444','2013-06-23','15:00:00',2.96),('1444','2013-06-23','15:05:00',2.93),('1444','2013-06-23','15:10:00',2.91),('1444','2013-06-23','15:15:00',2.87),('1444','2013-06-23','15:20:00',2.85),('1444','2013-06-23','15:25:00',2.81),('1444','2013-06-23','15:30:00',2.78),('1444','2013-06-23','15:35:00',2.74),('1444','2013-06-23','15:40:00',2.71),('1444','2013-06-23','15:45:00',2.67),('1444','2013-06-23','15:50:00',2.64),('1444','2013-06-23','15:55:00',2.6),('1444','2013-06-23','16:00:00',2.56),('1444','2013-06-23','16:05:00',2.52),('1444','2013-06-23','16:10:00',2.47),('1444','2013-06-23','16:15:00',2.42),('1444','2013-06-23','16:20:00',2.36),('1444','2013-06-23','16:25:00',2.34),('1444','2013-06-23','16:30:00',2.28),('1444','2013-06-23','16:35:00',2.26),('1444','2013-06-23','16:40:00',2.21),('1444','2013-06-23','16:45:00',2.18),('1444','2013-06-23','16:50:00',2.11),('1444','2013-06-23','16:55:00',2.06),('1444','2013-06-23','17:00:00',2.02),('1444','2013-06-23','17:05:00',1.97),('1444','2013-06-23','17:10:00',1.92),('1444','2013-06-23','17:15:00',1.88),('1444','2013-06-23','17:20:00',1.82),('1444','2013-06-23','17:25:00',1.77),('1444','2013-06-23','17:30:00',1.71),('1444','2013-06-23','17:35:00',1.63),('1444','2013-06-23','17:40:00',1.61),('1444','2013-06-23','17:45:00',1.56),('1444','2013-06-23','17:50:00',1.5),('1444','2013-06-23','17:55:00',1.44),('1444','2013-06-23','18:00:00',1.4),('1444','2013-06-23','18:05:00',1.32),('1444','2013-06-23','18:10:00',1.25),('1444','2013-06-23','18:15:00',1.18),('1444','2013-06-23','18:20:00',1.15),('1444','2013-06-23','18:25:00',1.08),('1444','2013-06-23','18:30:00',1.02),('1444','2013-06-22','07:55:00',1.01),('1444','2013-06-22','08:00:00',1.06),('1444','2013-06-22','08:05:00',1.09),('1444','2013-06-22','08:10:00',1.16),('1444','2013-06-22','08:15:00',1.21),('1444','2013-06-22','08:20:00',1.27),('1444','2013-06-22','08:25:00',1.34),('1444','2013-06-22','08:30:00',1.4),('1444','2013-06-22','08:35:00',1.47),('1444','2013-06-22','08:40:00',1.53),('1444','2013-06-22','08:45:00',1.58),('1444','2013-06-22','08:50:00',1.63),('1444','2013-06-22','08:55:00',1.67),('1444','2013-06-22','09:00:00',1.72),('1444','2013-06-22','09:05:00',1.76),('1444','2013-06-22','09:10:00',1.81),('1444','2013-06-22','09:15:00',1.85),('1444','2013-06-22','09:20:00',1.9),('1444','2013-06-22','09:25:00',1.93),('1444','2013-06-22','09:30:00',1.98),('1444','2013-06-22','09:35:00',2.03),('1444','2013-06-22','09:40:00',2.07),('1444','2013-06-22','09:45:00',2.13),('1444','2013-06-22','09:50:00',2.18),('1444','2013-06-22','09:55:00',2.22),('1444','2013-06-22','10:00:00',2.26),('1444','2013-06-22','10:05:00',2.3),('1444','2013-06-22','10:10:00',2.34),('1444','2013-06-22','10:15:00',2.4),('1444','2013-06-22','10:20:00',2.45),('1444','2013-06-22','10:25:00',2.47),('1444','2013-06-22','10:30:00',2.47),('1444','2013-06-22','10:35:00',2.51),('1444','2013-06-22','10:40:00',2.56),('1444','2013-06-22','10:45:00',2.61),('1444','2013-06-22','10:50:00',2.65),('1444','2013-06-22','10:55:00',2.67),('1444','2013-06-22','11:00:00',2.71),('1444','2013-06-22','11:05:00',2.73),('1444','2013-06-22','11:10:00',2.76),('1444','2013-06-22','11:15:00',2.78),('1444','2013-06-22','11:20:00',2.79),('1444','2013-06-22','11:25:00',2.81),('1444','2013-06-22','11:30:00',2.84),('1444','2013-06-22','11:35:00',2.85),('1444','2013-06-22','11:40:00',2.88),('1444','2013-06-22','11:45:00',2.9),('1444','2013-06-22','11:50:00',2.89),('1444','2013-06-22','11:55:00',2.9),('1444','2013-06-22','12:00:00',2.94),('1444','2013-06-22','12:05:00',2.89),('1444','2013-06-22','12:10:00',2.87),('1444','2013-06-22','12:15:00',2.98),('1444','2013-06-22','12:20:00',2.92),('1444','2013-06-22','12:25:00',2.97),('1444','2013-06-22','12:30:00',3),('1444','2013-06-22','12:35:00',3.02),('1444','2013-06-22','12:40:00',3.04),('1444','2013-06-22','12:45:00',2.99),('1444','2013-06-22','12:50:00',2.96),('1444','2013-06-22','12:55:00',2.94),('1444','2013-06-22','13:00:00',2.9),('1444','2013-06-22','13:05:00',2.92),('1444','2013-06-22','13:10:00',2.91),('1444','2013-06-22','13:15:00',2.85),('1444','2013-06-22','13:20:00',2.78),('1444','2013-06-22','13:25:00',3.04),('1444','2013-06-22','13:30:00',3.16),('1444','2013-06-22','13:35:00',3.21),('1444','2013-06-22','13:40:00',2.84),('1444','2013-06-22','13:45:00',3.07),('1444','2013-06-22','13:50:00',3.09),('1444','2013-06-22','13:55:00',2.2),('1444','2013-06-22','14:00:00',2.17),('1444','2013-06-22','14:05:00',3.38),('1444','2013-06-22','14:10:00',3.21),('1444','2013-06-22','14:15:00',3.15),('1444','2013-06-22','14:20:00',2.7),('1444','2013-06-22','14:25:00',3.08),('1444','2013-06-22','14:30:00',2.18),('1444','2013-06-22','14:35:00',1.66),('1444','2013-06-22','14:40:00',1.27),('1444','2013-06-22','14:45:00',1.7),('1444','2013-06-22','14:50:00',2.93),('1444','2013-06-22','14:55:00',2.95),('1444','2013-06-22','15:00:00',2.95),('1444','2013-06-22','15:05:00',2.19),('1444','2013-06-22','15:10:00',3),('1444','2013-06-22','15:15:00',3.01),('1444','2013-06-22','15:20:00',2.67),('1444','2013-06-22','15:25:00',2.33),('1444','2013-06-22','15:30:00',1.73),('1444','2013-06-22','15:35:00',1.29),('1444','2013-06-22','15:40:00',1.55),('1444','2013-06-22','15:45:00',2.06),('1444','2013-06-22','15:50:00',1.84),('1444','2013-06-22','15:55:00',1.84),('1444','2013-06-22','16:00:00',1.34),('1444','2013-06-22','16:15:00',1.24),('1444','2013-06-22','16:20:00',1.35),('1444','2013-06-22','17:00:00',1.15),('1444','2013-06-22','17:05:00',1.11),('1444','2013-06-22','17:10:00',1.65),('1444','2013-06-22','17:15:00',2.21),('1444','2013-06-22','17:20:00',2.05),('1444','2013-06-22','17:25:00',2.03),('1444','2013-06-22','17:30:00',1.53),('1444','2013-06-22','17:35:00',1.52),('1444','2013-06-22','17:40:00',1.65),('1444','2013-06-22','17:45:00',1.62),('1444','2013-06-22','17:50:00',1.47),('1444','2013-06-22','17:55:00',1.45),('1444','2013-06-22','18:00:00',1.31),('1444','2013-06-22','18:05:00',1.07),('1444','2013-06-21','07:55:00',1.02),('1444','2013-06-21','08:00:00',1.08),('1444','2013-06-21','08:05:00',1.13),('1444','2013-06-21','08:10:00',1.18),('1444','2013-06-21','08:15:00',1.23),('1444','2013-06-21','08:20:00',1.28),('1444','2013-06-21','08:25:00',1.33),('1444','2013-06-21','08:30:00',1.38),('1444','2013-06-21','08:35:00',1.45),('1444','2013-06-21','08:40:00',1.49),('1444','2013-06-21','08:45:00',1.53),('1444','2013-06-21','08:50:00',1.57),('1444','2013-06-21','08:55:00',1.62),('1444','2013-06-21','09:00:00',1.67),('1444','2013-06-21','09:05:00',1.71),('1444','2013-06-21','09:10:00',1.76),('1444','2013-06-21','09:15:00',1.8),('1444','2013-06-21','09:20:00',1.83),('1444','2013-06-21','09:25:00',1.87),('1444','2013-06-21','09:30:00',1.91),('1444','2013-06-21','09:35:00',1.95),('1444','2013-06-21','09:40:00',1.99),('1444','2013-06-21','09:45:00',2.04),('1444','2013-06-21','09:50:00',2.1),('1444','2013-06-21','09:55:00',2.13),('1444','2013-06-21','10:00:00',2.16),('1444','2013-06-21','10:05:00',2.18),('1444','2013-06-21','10:10:00',2.23),('1444','2013-06-21','10:15:00',2.25),('1444','2013-06-21','10:20:00',2.28),('1444','2013-06-21','10:25:00',2.32),('1444','2013-06-21','10:30:00',2.36),('1444','2013-06-21','10:35:00',2.38),('1444','2013-06-21','10:40:00',2.41),('1444','2013-06-21','10:45:00',2.43),('1444','2013-06-21','10:50:00',2.43),('1444','2013-06-21','10:55:00',2.43),('1444','2013-06-21','11:00:00',2.48),('1444','2013-06-21','11:05:00',2.52),('1444','2013-06-21','11:10:00',2.55),('1444','2013-06-21','11:15:00',2.61),('1444','2013-06-21','11:20:00',2.65),('1444','2013-06-21','11:25:00',2.67),('1444','2013-06-21','11:30:00',2.7),('1444','2013-06-21','11:35:00',2.69),('1444','2013-06-21','11:40:00',2.68),('1444','2013-06-21','11:45:00',2.75),('1444','2013-06-21','11:50:00',2.79),('1444','2013-06-21','11:55:00',2.77),('1444','2013-06-21','12:00:00',2.79),('1444','2013-06-21','12:05:00',2.78),('1444','2013-06-21','12:10:00',2.77),('1444','2013-06-21','12:15:00',2.78),('1444','2013-06-21','12:20:00',2.77),('1444','2013-06-21','12:25:00',2.79),('1444','2013-06-21','12:30:00',2.8),('1444','2013-06-21','12:35:00',2.8),('1444','2013-06-21','12:40:00',2.83),('1444','2013-06-21','12:45:00',2.87),('1444','2013-06-21','12:50:00',2.8),('1444','2013-06-21','12:55:00',2.79),('1444','2013-06-21','13:00:00',2.81),('1444','2013-06-21','13:05:00',2.8),('1444','2013-06-21','13:10:00',2.86),('1444','2013-06-21','13:15:00',2.9),('1444','2013-06-21','13:20:00',2.88),('1444','2013-06-21','13:25:00',2.89),('1444','2013-06-21','13:30:00',2.91),('1444','2013-06-21','13:35:00',2.9),('1444','2013-06-21','13:40:00',2.9),('1444','2013-06-21','13:45:00',2.9),('1444','2013-06-21','13:50:00',2.89),('1444','2013-06-21','13:55:00',2.9),('1444','2013-06-21','14:00:00',2.91),('1444','2013-06-21','14:05:00',2.9),('1444','2013-06-21','14:10:00',2.91),('1444','2013-06-21','14:15:00',2.89),('1444','2013-06-21','14:20:00',2.89),('1444','2013-06-21','14:25:00',2.9),('1444','2013-06-21','14:30:00',2.89),('1444','2013-06-21','14:35:00',2.86),('1444','2013-06-21','14:40:00',2.86),('1444','2013-06-21','14:45:00',2.84),('1444','2013-06-21','14:50:00',2.84),('1444','2013-06-21','14:55:00',2.82),('1444','2013-06-21','15:00:00',2.79),('1444','2013-06-21','15:05:00',2.78),('1444','2013-06-21','15:10:00',2.72),('1444','2013-06-21','15:15:00',2.71),('1444','2013-06-21','15:20:00',2.7),('1444','2013-06-21','15:25:00',2.67),('1444','2013-06-21','15:30:00',2.65),('1444','2013-06-21','15:35:00',2.63),('1444','2013-06-21','15:40:00',2.58),('1444','2013-06-21','15:45:00',2.56),('1444','2013-06-21','15:50:00',2.52),('1444','2013-06-21','15:55:00',2.48),('1444','2013-06-21','16:00:00',2.44),('1444','2013-06-21','16:05:00',2.41),('1444','2013-06-21','16:10:00',2.37),('1444','2013-06-21','16:15:00',2.33),('1444','2013-06-21','16:20:00',2.29),('1444','2013-06-21','16:25:00',2.25),('1444','2013-06-21','16:30:00',2.21),('1444','2013-06-21','16:35:00',2.17),('1444','2013-06-21','16:40:00',2.12),('1444','2013-06-21','16:45:00',2.07),('1444','2013-06-21','16:50:00',2.02),('1444','2013-06-21','16:55:00',1.99),('1444','2013-06-21','17:00:00',1.95),('1444','2013-06-21','17:05:00',1.9),('1444','2013-06-21','17:10:00',1.85),('1444','2013-06-21','17:15:00',1.79),('1444','2013-06-21','17:20:00',1.74),('1444','2013-06-21','17:25:00',1.69),('1444','2013-06-21','17:30:00',1.63),('1444','2013-06-21','17:35:00',1.58),('1444','2013-06-21','17:40:00',1.53),('1444','2013-06-21','17:45:00',1.47),('1444','2013-06-21','17:50:00',1.42),('1444','2013-06-21','17:55:00',1.36),('1444','2013-06-21','18:00:00',1.31),('1444','2013-06-21','18:05:00',1.25),('1444','2013-06-21','18:10:00',1.19),('1444','2013-06-21','18:15:00',1.13),('1444','2013-06-21','18:20:00',1.07),('1444','2013-06-21','18:25:00',1.01),('1444','2014-04-04','09:05:00',1.34),('1444','2014-04-04','09:10:00',1.61),('1444','2014-04-04','09:15:00',1.59),('1444','2014-04-04','09:20:00',1.14),('1444','2014-04-04','13:20:00',1.48),('1444','2014-04-04','13:25:00',1.6),('1444','2014-04-04','13:30:00',1.73),('1444','2014-04-04','13:35:00',2.28),('1444','2014-04-04','13:40:00',3.33),('1444','2014-04-04','13:45:00',2.57),('1444','2014-04-04','13:50:00',3.36),('1444','2014-04-04','13:55:00',1.53),('1444','2014-04-04','14:00:00',2.6),('1444','2014-04-04','14:05:00',3.25),('1444','2014-04-04','14:10:00',3.81),('1444','2014-04-04','14:15:00',2.42),('1444','2014-04-04','14:20:00',2.48),('1444','2014-04-04','14:25:00',2.54),('1444','2014-04-04','14:30:00',1),('1444','2014-04-04','14:35:00',1.58),('1444','2014-04-04','14:40:00',1.07),('1444','2014-04-04','14:45:00',1.26),('1444','2014-04-04','14:50:00',2.82),('1444','2014-04-04','14:55:00',3.17),('1444','2014-04-04','15:00:00',2.76),('1444','2014-04-04','15:05:00',2.47),('1444','2014-04-04','15:10:00',2.93),('1444','2014-04-04','15:15:00',2.62),('1444','2014-04-04','15:20:00',1.61),('1444','2014-04-04','15:25:00',1.51),('1444','2014-04-04','15:30:00',1.18),('1444','2014-04-04','15:35:00',1.29),('1444','2014-04-04','15:40:00',1.61),('1444','2014-04-04','15:45:00',1.26),('1444','2014-04-04','15:50:00',1.7),('1444','2014-04-04','15:55:00',2.5),('1444','2014-04-04','16:00:00',1.65),('1444','2014-04-04','16:05:00',1.66),('1444','2014-04-04','16:10:00',2.19),('1444','2014-04-04','16:15:00',1.39),('1444','2014-04-04','16:25:00',1.03),('1444','2014-04-04','16:30:00',1.74),('1444','2014-04-04','16:35:00',1.5),('1444','2014-04-04','16:40:00',1.14),('1444','2014-04-04','16:45:00',1.96),('1444','2014-04-04','16:50:00',2.41),('1444','2014-04-04','16:55:00',2),('1444','2014-04-04','17:00:00',1.59),('1444','2014-04-04','17:05:00',1.43),('1444','2014-04-04','17:10:00',1.65),('1444','2014-04-04','17:15:00',1.58),('1444','2014-04-04','17:20:00',1.17),('1444','2014-04-04','17:25:00',1.31),('1444','2014-04-04','17:30:00',1.5),('1444','2014-04-04','17:35:00',1.01),('1444','2014-04-04','17:40:00',1.34),('1444','2014-04-04','17:45:00',1.21),('1444','2014-04-04','17:50:00',1.13),('1444','2013-06-20','08:00:00',1.06),('1444','2013-06-20','08:05:00',1.12),('1444','2013-06-20','08:10:00',1.18),('1444','2013-06-20','08:15:00',1.24),('1444','2013-06-20','08:20:00',1.29),('1444','2013-06-20','08:25:00',1.34),('1444','2013-06-20','08:30:00',1.4),('1444','2013-06-20','08:35:00',1.46),('1444','2013-06-20','08:40:00',1.51),('1444','2013-06-20','08:45:00',1.57),('1444','2013-06-20','08:50:00',1.62),('1444','2013-06-20','08:55:00',1.65),('1444','2013-06-20','09:00:00',1.71),('1444','2013-06-20','09:05:00',1.76),('1444','2013-06-20','09:10:00',1.81),('1444','2013-06-20','09:15:00',1.86),('1444','2013-06-20','09:20:00',1.92),('1444','2013-06-20','09:25:00',1.95),('1444','2013-06-20','09:30:00',1.98),('1444','2013-06-20','09:35:00',2.04),('1444','2013-06-20','09:40:00',2.1),('1444','2013-06-20','09:45:00',2.12),('1444','2013-06-20','09:50:00',2.17),('1444','2013-06-20','09:55:00',2.22),('1444','2013-06-20','10:00:00',2.26),('1444','2013-06-20','10:05:00',2.29),('1444','2013-06-20','10:10:00',2.32),('1444','2013-06-20','10:15:00',2.34),('1444','2013-06-20','10:20:00',2.39),('1444','2013-06-20','10:25:00',2.43),('1444','2013-06-20','10:30:00',2.44),('1444','2013-06-20','10:35:00',2.48),('1444','2013-06-20','10:40:00',2.5),('1444','2013-06-20','10:45:00',2.52),('1444','2013-06-20','10:50:00',2.56),('1444','2013-06-20','10:55:00',2.59),('1444','2013-06-20','11:00:00',2.57),('1444','2013-06-20','11:05:00',2.61),('1444','2013-06-20','11:10:00',2.61),('1444','2013-06-20','11:15:00',2.63),('1444','2013-06-20','11:20:00',2.63),('1444','2013-06-20','11:25:00',2.68),('1444','2013-06-20','11:30:00',2.74),('1444','2013-06-20','11:35:00',2.73),('1444','2013-06-20','11:40:00',2.73),('1444','2013-06-20','11:45:00',2.68),('1444','2013-06-20','11:50:00',2.66),('1444','2013-06-20','11:55:00',2.69),('1444','2013-06-20','12:00:00',2.69),('1444','2013-06-20','12:05:00',2.72),('1444','2013-06-20','12:10:00',1.96),('1444','2013-06-20','12:15:00',2.77),('1444','2013-06-20','12:20:00',1.77),('1444','2013-06-20','12:25:00',1.93),('1444','2013-06-20','12:30:00',2.92),('1444','2013-06-20','12:35:00',2.73),('1444','2013-06-20','12:40:00',2.77),('1444','2013-06-20','12:45:00',1.66),('1444','2013-06-20','12:50:00',2.97),('1444','2013-06-20','12:55:00',2.95),('1444','2013-06-20','13:00:00',2.99),('1444','2013-06-20','13:05:00',2.95),('1444','2013-06-20','13:10:00',2.04),('1444','2013-06-20','13:15:00',2.12),('1444','2013-06-20','13:20:00',2.93),('1444','2013-06-20','13:25:00',2.96),('1444','2013-06-20','13:30:00',2.72),('1444','2013-06-20','13:35:00',2.99),('1444','2013-06-20','13:40:00',2.99),('1444','2013-06-20','13:45:00',3),('1444','2013-06-20','13:50:00',3),('1444','2013-06-20','13:55:00',2.99),('1444','2013-06-20','14:00:00',3.04),('1444','2013-06-20','14:05:00',2.99),('1444','2013-06-20','14:10:00',3),('1444','2013-06-20','14:15:00',3),('1444','2013-06-20','14:20:00',3.01),('1444','2013-06-20','14:25:00',2.96),('1444','2013-06-20','14:30:00',2.98),('1444','2013-06-20','14:35:00',2.97),('1444','2013-06-20','14:40:00',2.95),('1444','2013-06-20','14:45:00',2.92),('1444','2013-06-20','14:50:00',2.91),('1444','2013-06-20','14:55:00',2.9),('1444','2013-06-20','15:00:00',2.86),('1444','2013-06-20','15:05:00',2.85),('1444','2013-06-20','15:10:00',2.84),('1444','2013-06-20','15:15:00',2.8),('1444','2013-06-20','15:20:00',2.76),('1444','2013-06-20','15:25:00',2.72),('1444','2013-06-20','15:30:00',2.69),('1444','2013-06-20','15:35:00',2.65),('1444','2013-06-20','15:40:00',2.63),('1444','2013-06-20','15:45:00',2.59),('1444','2013-06-20','15:50:00',2.54),('1444','2013-06-20','15:55:00',2.51),('1444','2013-06-20','16:00:00',2.48),('1444','2013-06-20','16:05:00',2.43),('1444','2013-06-20','16:10:00',2.4),('1444','2013-06-20','16:15:00',2.38),('1444','2013-06-20','16:20:00',2.33),('1444','2013-06-20','16:25:00',2.3),('1444','2013-06-20','16:30:00',2.25),('1444','2013-06-20','16:35:00',2.2),('1444','2013-06-20','16:40:00',2.15),('1444','2013-06-20','16:45:00',2.11),('1444','2013-06-20','16:50:00',2.06),('1444','2013-06-20','16:55:00',1.99),('1444','2013-06-20','17:00:00',1.95),('1444','2013-06-20','17:05:00',1.91),('1444','2013-06-20','17:10:00',1.86),('1444','2013-06-20','17:15:00',1.82),('1444','2013-06-20','17:20:00',1.76),('1444','2013-06-20','17:25:00',1.71),('1444','2013-06-20','17:30:00',1.65),('1444','2013-06-20','17:35:00',1.58),('1444','2013-06-20','17:40:00',1.54),('1444','2013-06-20','17:45:00',1.49),('1444','2013-06-20','17:50:00',1.43),('1444','2013-06-20','17:55:00',1.38),('1444','2013-06-20','18:00:00',1.33),('1444','2013-06-20','18:05:00',1.28),('1444','2013-06-20','18:10:00',1.22),('1444','2013-06-20','18:15:00',1.16),('1444','2013-06-20','18:20:00',1.1),('1444','2013-06-20','18:25:00',1.04),('1444','2013-06-19','08:00:00',1.05),('1444','2013-06-19','08:05:00',1.09),('1444','2013-06-19','08:10:00',1.15),('1444','2013-06-19','08:15:00',1.21),('1444','2013-06-19','08:20:00',1.27),('1444','2013-06-19','08:25:00',1.32),('1444','2013-06-19','08:30:00',1.37),('1444','2013-06-19','08:35:00',1.42),('1444','2013-06-19','08:40:00',1.48),('1444','2013-06-19','08:45:00',1.52),('1444','2013-06-19','08:50:00',1.57),('1444','2013-06-19','08:55:00',1.62),('1444','2013-06-19','09:00:00',1.67),('1444','2013-06-19','09:05:00',1.73),('1444','2013-06-19','09:10:00',1.78),('1444','2013-06-19','09:15:00',1.82),('1444','2013-06-19','09:20:00',1.87),('1444','2013-06-19','09:25:00',1.91),('1444','2013-06-19','09:30:00',1.94),('1444','2013-06-19','09:35:00',1.99),('1444','2013-06-19','09:40:00',2.03),('1444','2013-06-19','09:45:00',2.07),('1444','2013-06-19','09:50:00',2.12),('1444','2013-06-19','09:55:00',2.16),('1444','2013-06-19','10:00:00',2.18),('1444','2013-06-19','10:05:00',2.21),('1444','2013-06-19','10:10:00',2.24),('1444','2013-06-19','10:15:00',2.3),('1444','2013-06-19','10:20:00',2.34),('1444','2013-06-19','10:25:00',2.37),('1444','2013-06-19','10:30:00',2.41),('1444','2013-06-19','10:35:00',2.44),('1444','2013-06-19','10:40:00',2.45),('1444','2013-06-19','10:45:00',2.48),('1444','2013-06-19','10:50:00',2.48),('1444','2013-06-19','10:55:00',2.49),('1444','2013-06-19','11:00:00',2.52),('1444','2013-06-19','11:05:00',2.54),('1444','2013-06-19','11:10:00',2.57),('1444','2013-06-19','11:15:00',2.59),('1444','2013-06-19','11:20:00',2.62),('1444','2013-06-19','11:25:00',2.61),('1444','2013-06-19','11:30:00',2.66),('1444','2013-06-19','11:35:00',2.66),('1444','2013-06-19','11:40:00',2.69),('1444','2013-06-19','11:45:00',2.7),('1444','2013-06-19','11:50:00',2.72),('1444','2013-06-19','11:55:00',2.74),('1444','2013-06-19','12:00:00',2.76),('1444','2013-06-19','12:05:00',2.75),('1444','2013-06-19','12:10:00',2.75),('1444','2013-06-19','12:15:00',2.79),('1444','2013-06-19','12:20:00',2.79),('1444','2013-06-19','12:25:00',2.8),('1444','2013-06-19','12:30:00',2.86),('1444','2013-06-19','12:35:00',2.9),('1444','2013-06-19','12:40:00',2.91),('1444','2013-06-19','12:45:00',2.87),('1444','2013-06-19','12:50:00',2.92),('1444','2013-06-19','12:55:00',2.9),('1444','2013-06-19','13:00:00',2.87),('1444','2013-06-19','13:05:00',2.93),('1444','2013-06-19','13:10:00',2.91),('1444','2013-06-19','13:15:00',2.87),('1444','2013-06-19','13:20:00',2.91),('1444','2013-06-19','13:25:00',2.95),('1444','2013-06-19','13:30:00',2.93),('1444','2013-06-19','13:35:00',2.94),('1444','2013-06-19','13:40:00',2.93),('1444','2013-06-19','13:45:00',2.93),('1444','2013-06-19','13:50:00',2.94),('1444','2013-06-19','13:55:00',2.93),('1444','2013-06-19','14:00:00',2.95),('1444','2013-06-19','14:05:00',2.92),('1444','2013-06-19','14:10:00',2.9),('1444','2013-06-19','14:15:00',2.88),('1444','2013-06-19','14:20:00',2.88),('1444','2013-06-19','14:25:00',2.89),('1444','2013-06-19','14:30:00',2.85),('1444','2013-06-19','14:35:00',2.83),('1444','2013-06-19','14:40:00',2.79),('1444','2013-06-19','14:45:00',2.78),('1444','2013-06-19','14:50:00',2.77),('1444','2013-06-19','14:55:00',2.76),('1444','2013-06-19','15:00:00',2.74),('1444','2013-06-19','15:05:00',2.71),('1444','2013-06-19','15:10:00',2.68),('1444','2013-06-19','15:15:00',2.66),('1444','2013-06-19','15:20:00',2.64),('1444','2013-06-19','15:25:00',2.62),('1444','2013-06-19','15:30:00',2.57),('1444','2013-06-19','15:35:00',2.53),('1444','2013-06-19','15:40:00',2.49),('1444','2013-06-19','15:45:00',2.47),('1444','2013-06-19','15:50:00',2.43),('1444','2013-06-19','15:55:00',2.39),('1444','2013-06-19','16:00:00',2.36),('1444','2013-06-19','16:05:00',2.3),('1444','2013-06-19','16:10:00',2.25),('1444','2013-06-19','16:15:00',2.23),('1444','2013-06-19','16:20:00',2.2),('1444','2013-06-19','16:25:00',2.16),('1444','2013-06-19','16:30:00',2.13),('1444','2013-06-19','16:35:00',2.08),('1444','2013-06-19','16:40:00',2.05),('1444','2013-06-19','16:45:00',2.01),('1444','2013-06-19','16:50:00',1.97),('1444','2013-06-19','16:55:00',1.92),('1444','2013-06-19','17:00:00',1.88),('1444','2013-06-19','17:05:00',1.84),('1444','2013-06-19','17:10:00',1.79),('1444','2013-06-19','17:15:00',1.75),('1444','2013-06-19','17:20:00',1.72),('1444','2013-06-19','17:25:00',1.68),('1444','2013-06-19','17:30:00',1.63),('1444','2013-06-19','17:35:00',1.57),('1444','2013-06-19','17:40:00',1.52),('1444','2013-06-19','17:45:00',1.46),('1444','2013-06-19','17:50:00',1.4),('1444','2013-06-19','17:55:00',1.35),('1444','2013-06-19','18:00:00',1.29),('1444','2013-06-19','18:05:00',1.23),('1444','2013-06-19','18:10:00',1.16),('1444','2013-06-19','18:15:00',1.1),('1444','2013-06-19','18:20:00',1.04),('1444','2013-06-18','08:00:00',1.03),('1444','2013-06-18','08:05:00',1.09),('1444','2013-06-18','08:10:00',1.15),('1444','2013-06-18','08:15:00',1.2),('1444','2013-06-18','08:20:00',1.25),('1444','2013-06-18','08:25:00',1.3),('1444','2013-06-18','08:30:00',1.36),('1444','2013-06-18','08:35:00',1.41),('1444','2013-06-18','08:40:00',1.45),('1444','2013-06-18','08:45:00',1.51),('1444','2013-06-18','08:50:00',1.56),('1444','2013-06-18','08:55:00',1.61),('1444','2013-06-18','09:00:00',1.65),('1444','2013-06-18','09:05:00',1.7),('1444','2013-06-18','09:10:00',1.75),('1444','2013-06-18','09:15:00',1.79),('1444','2013-06-18','09:20:00',1.82),('1444','2013-06-18','09:25:00',1.88),('1444','2013-06-18','09:30:00',1.91),('1444','2013-06-18','09:35:00',1.96),('1444','2013-06-18','09:40:00',2),('1444','2013-06-18','09:45:00',2.03),('1444','2013-06-18','09:50:00',1.65),('1444','2013-06-18','09:55:00',2.11),('1444','2013-06-18','10:00:00',2.14),('1444','2013-06-18','10:05:00',2.17),('1444','2013-06-18','10:10:00',2.21),('1444','2013-06-18','10:15:00',2.26),('1444','2013-06-18','10:20:00',2.3),('1444','2013-06-18','10:25:00',2.33),('1444','2013-06-18','10:30:00',2.36),('1444','2013-06-18','10:35:00',2.42),('1444','2013-06-18','10:40:00',2.45),('1444','2013-06-18','10:45:00',2.48),('1444','2013-06-18','10:50:00',2.46),('1444','2013-06-18','10:55:00',2.45),('1444','2013-06-18','11:00:00',2.51),('1444','2013-06-18','11:05:00',2.55),('1444','2013-06-18','11:10:00',2.54),('1444','2013-06-18','11:15:00',2.56),('1444','2013-06-18','11:20:00',2.64),('1444','2013-06-18','11:25:00',2.63),('1444','2013-06-18','11:30:00',2.64),('1444','2013-06-18','11:35:00',2.65),('1444','2013-06-18','11:40:00',2.66),('1444','2013-06-18','11:45:00',2.67),('1444','2013-06-18','11:50:00',2.69),('1444','2013-06-18','11:55:00',2.7),('1444','2013-06-18','12:00:00',2.71),('1444','2013-06-18','12:05:00',2.69),('1444','2013-06-18','12:10:00',2.63),('1444','2013-06-18','12:15:00',2.42),('1444','2013-06-18','12:20:00',2.65),('1444','2013-06-18','12:25:00',2.78),('1444','2013-06-18','12:30:00',2.7),('1444','2013-06-18','12:35:00',2.7),('1444','2013-06-18','12:40:00',2.12),('1444','2013-06-18','12:45:00',2.06),('1444','2013-06-18','12:50:00',2.2),('1444','2013-06-18','12:55:00',2.14),('1444','2013-06-18','13:00:00',1.33),('1444','2013-06-18','13:05:00',2.56),('1444','2013-06-18','13:10:00',2.38),('1444','2013-06-18','13:15:00',2.27),('1444','2013-06-18','13:20:00',2.92),('1444','2013-06-18','13:25:00',2.05),('1444','2013-06-18','13:30:00',2.21),('1444','2013-06-18','13:35:00',3.02),('1444','2013-06-18','13:40:00',2.32),('1444','2013-06-18','13:45:00',1.93),('1444','2013-06-18','13:50:00',2.94),('1444','2013-06-18','13:55:00',2.27),('1444','2013-06-18','14:00:00',2.93),('1444','2013-06-18','14:05:00',2.97),('1444','2013-06-18','14:10:00',2.87),('1444','2013-06-18','14:15:00',2.92),('1444','2013-06-18','14:20:00',2.9),('1444','2013-06-18','14:25:00',2.87),('1444','2013-06-18','14:30:00',2.84),('1444','2013-06-18','14:35:00',2.93),('1444','2013-06-18','14:40:00',2.94),('1444','2013-06-18','14:45:00',2.89),('1444','2013-06-18','14:50:00',2.85),('1444','2013-06-18','14:55:00',2.84),('1444','2013-06-18','15:00:00',2.82),('1444','2013-06-18','15:05:00',2.76),('1444','2013-06-18','15:10:00',2.73),('1444','2013-06-18','15:15:00',2.69),('1444','2013-06-18','15:20:00',2.65),('1444','2013-06-18','15:25:00',2.64),('1444','2013-06-18','15:30:00',2.6),('1444','2013-06-18','15:35:00',2.59),('1444','2013-06-18','15:40:00',2.58),('1444','2013-06-18','15:45:00',2.54),('1444','2013-06-18','15:50:00',2.52),('1444','2013-06-18','15:55:00',2.52),('1444','2013-06-18','16:00:00',2.49),('1444','2013-06-18','16:05:00',2.46),('1444','2013-06-18','16:10:00',2.42),('1444','2013-06-18','16:15:00',2.4),('1444','2013-06-18','16:20:00',2.37),('1444','2013-06-18','16:25:00',2.31),('1444','2013-06-18','16:30:00',2.24),('1444','2013-06-18','16:35:00',2.16),('1444','2013-06-18','16:40:00',2.11),('1444','2013-06-18','16:45:00',2.04),('1444','2013-06-18','16:50:00',1.97),('1444','2013-06-18','16:55:00',1.96),('1444','2013-06-18','17:00:00',1.91),('1444','2013-06-18','17:05:00',1.87),('1444','2013-06-18','17:10:00',1.82),('1444','2013-06-18','17:15:00',1.77),('1444','2013-06-18','17:20:00',1.72),('1444','2013-06-18','17:25:00',1.68),('1444','2013-06-18','17:30:00',1.62),('1444','2013-06-18','17:35:00',1.56),('1444','2013-06-18','17:40:00',1.51),('1444','2013-06-18','17:45:00',1.46),('1444','2013-06-18','17:50:00',1.39),('1444','2013-06-18','17:55:00',1.35),('1444','2013-06-18','18:00:00',1.3),('1444','2013-06-18','18:05:00',1.24),('1444','2013-06-18','18:10:00',1.17),('1444','2013-06-18','18:15:00',1.12),('1444','2013-06-18','18:20:00',1.09),('1444','2013-06-18','18:25:00',1.03),('1444','2014-04-03','09:05:00',1.03),('1444','2014-04-03','09:30:00',1.18),('1444','2014-04-03','09:35:00',1.4),('1444','2014-04-03','09:40:00',1.46),('1444','2014-04-03','09:45:00',1.44),('1444','2014-04-03','09:50:00',1.37),('1444','2014-04-03','09:55:00',1.45),('1444','2014-04-03','10:00:00',1.7),('1444','2014-04-03','10:05:00',1.97),('1444','2014-04-03','10:10:00',2.09),('1444','2014-04-03','10:15:00',2.36),('1444','2014-04-03','10:20:00',2.41),('1444','2014-04-03','10:25:00',2.03),('1444','2014-04-03','10:30:00',2.05),('1444','2014-04-03','10:35:00',2.15),('1444','2014-04-03','10:40:00',1.74),('1444','2014-04-03','10:45:00',1.84),('1444','2014-04-03','10:50:00',1.59),('1444','2014-04-03','10:55:00',1.69),('1444','2014-04-03','11:00:00',1.56),('1444','2014-04-03','11:05:00',1.35),('1444','2014-04-03','11:10:00',1.28),('1444','2014-04-03','11:15:00',1.21),('1444','2014-04-03','11:20:00',1.15),('1444','2014-04-03','11:25:00',1.07),('1444','2014-04-03','11:30:00',1.06),('1444','2014-04-03','11:35:00',1.14),('1444','2014-04-03','11:40:00',1.25),('1444','2014-04-03','11:45:00',1.43),('1444','2014-04-03','11:50:00',1.75),('1444','2014-04-03','11:55:00',1.88),('1444','2014-04-03','12:00:00',1.8),('1444','2014-04-03','12:05:00',1.8),('1444','2014-04-03','12:10:00',1.74),('1444','2014-04-03','12:15:00',1.71),('1444','2014-04-03','12:20:00',1.94),('1444','2014-04-03','12:25:00',2.33),('1444','2014-04-03','12:30:00',2.95),('1444','2014-04-03','12:35:00',2.86),('1444','2014-04-03','12:40:00',3.17),('1444','2014-04-03','12:45:00',1.74),('1444','2014-04-03','12:50:00',2.19),('1444','2014-04-03','12:55:00',2.06),('1444','2014-04-03','13:00:00',2.07),('1444','2014-04-03','13:05:00',2.59),('1444','2014-04-03','13:10:00',2.07),('1444','2014-04-03','13:15:00',3.53),('1444','2014-04-03','13:20:00',2.01),('1444','2014-04-03','13:25:00',2.19),('1444','2014-04-03','13:30:00',2.29),('1444','2014-04-03','13:35:00',3.48),('1444','2014-04-03','13:40:00',2.87),('1444','2014-04-03','13:45:00',1.64),('1444','2014-04-03','13:50:00',1.64),('1444','2014-04-03','13:55:00',2.18),('1444','2014-04-03','14:00:00',2.85),('1444','2014-04-03','14:05:00',2.57),('1444','2014-04-03','14:10:00',2.03),('1444','2014-04-03','14:15:00',2.83),('1444','2014-04-03','14:20:00',2.78),('1444','2014-04-03','14:25:00',2.9),('1444','2014-04-03','14:30:00',2.94),('1444','2014-04-03','14:35:00',2.94),('1444','2014-04-03','14:40:00',2.83),('1444','2014-04-03','14:45:00',2.75),('1444','2014-04-03','14:50:00',2.71),('1444','2014-04-03','14:55:00',2.66),('1444','2014-04-03','15:00:00',2.61),('1444','2014-04-03','15:05:00',2.59),('1444','2014-04-03','15:10:00',2.57),('1444','2014-04-03','15:15:00',2.56),('1444','2014-04-03','15:20:00',2.54),('1444','2014-04-03','15:25:00',2.51),('1444','2014-04-03','15:30:00',2.47),('1444','2014-04-03','15:35:00',2.44),('1444','2014-04-03','15:40:00',2.4),('1444','2014-04-03','15:45:00',2.39),('1444','2014-04-03','15:50:00',2.33),('1444','2014-04-03','15:55:00',2.31),('1444','2014-04-03','16:00:00',2.3),('1444','2014-04-03','16:05:00',2.23),('1444','2014-04-03','16:10:00',2.2),('1444','2014-04-03','16:15:00',2.13),('1444','2014-04-03','16:20:00',2.09),('1444','2014-04-03','16:25:00',2.03),('1444','2014-04-03','16:30:00',1.95),('1444','2014-04-03','16:35:00',1.9),('1444','2014-04-03','16:40:00',1.86),('1444','2014-04-03','16:45:00',1.74),('1444','2014-04-03','16:50:00',1.3),('1444','2014-04-03','16:55:00',1.05),('1444','2014-04-03','17:50:00',1.01),('1444','2014-04-02','08:55:00',1.04),('1444','2014-04-02','09:55:00',2.27),('1444','2014-04-02','10:00:00',1.68),('1444','2014-04-02','10:05:00',1.5),('1444','2014-04-02','10:10:00',2.38),('1444','2014-04-02','10:15:00',2.55),('1444','2014-04-02','10:20:00',2.41),('1444','2014-04-02','10:25:00',1.62),('1444','2014-04-02','10:45:00',2.1),('1444','2014-04-02','10:50:00',2.85),('1444','2014-04-02','10:55:00',2.86),('1444','2014-04-02','11:00:00',1.05),('1444','2014-04-02','11:15:00',2.61),('1444','2014-04-02','11:20:00',2.84),('1444','2014-04-02','11:25:00',3.03),('1444','2014-04-02','11:30:00',2.61),('1444','2014-04-02','11:45:00',2.02),('1444','2014-04-02','11:50:00',3.22),('1444','2014-04-02','11:55:00',2.55),('1444','2014-04-02','12:00:00',1.76),('1444','2014-04-02','12:05:00',2),('1444','2014-04-02','12:10:00',1.23),('1444','2014-04-02','12:15:00',1.05),('1444','2014-04-02','12:20:00',1.92),('1444','2014-04-02','12:25:00',1.31),('1444','2014-04-02','12:30:00',3.05),('1444','2014-04-02','12:35:00',1.39),('1444','2014-04-02','12:40:00',2.84),('1444','2014-04-02','12:45:00',2.42),('1444','2014-04-02','12:50:00',2.62),('1444','2014-04-02','12:55:00',1.02),('1444','2014-04-02','13:00:00',2.64),('1444','2014-04-02','13:05:00',3.61),('1444','2014-04-02','13:10:00',3.58),('1444','2014-04-02','13:15:00',3.47),('1444','2014-04-02','13:20:00',3.3),('1444','2014-04-02','13:25:00',3.11),('1444','2014-04-02','13:30:00',3.25),('1444','2014-04-02','13:35:00',3.24),('1444','2014-04-02','13:40:00',3.22),('1444','2014-04-02','13:45:00',3.11),('1444','2014-04-02','13:50:00',3.11),('1444','2014-04-02','13:55:00',3.11),('1444','2014-04-02','14:00:00',3.09),('1444','2014-04-02','14:05:00',3.04),('1444','2014-04-02','14:10:00',2.87),('1444','2014-04-02','14:15:00',2.98),('1444','2014-04-02','14:20:00',2.99),('1444','2014-04-02','14:25:00',2.99),('1444','2014-04-02','14:30:00',2.98),('1444','2014-04-02','14:35:00',2.95),('1444','2014-04-02','14:40:00',2.91),('1444','2014-04-02','14:45:00',1.76),('1444','2014-04-02','14:50:00',2.66),('1444','2014-04-02','14:55:00',2.52),('1444','2014-04-02','15:00:00',2.54),('1444','2014-04-02','15:05:00',2.72),('1444','2014-04-02','15:10:00',2.52),('1444','2014-04-02','15:15:00',2.58),('1444','2014-04-02','15:20:00',2.58),('1444','2014-04-02','15:25:00',2.55),('1444','2014-04-02','15:30:00',2.39),('1444','2014-04-02','15:35:00',2.34),('1444','2014-04-02','15:40:00',2.34),('1444','2014-04-02','15:45:00',2.43),('1444','2014-04-02','15:50:00',2.39),('1444','2014-04-02','15:55:00',2.1),('1444','2014-04-02','16:00:00',2.18),('1444','2014-04-02','16:05:00',2.15),('1444','2014-04-02','16:10:00',2.1),('1444','2014-04-02','16:15:00',2.02),('1444','2014-04-02','16:20:00',1.97),('1444','2014-04-02','16:25:00',1.82),('1444','2014-04-02','16:30:00',1.96),('1444','2014-04-02','16:35:00',1.88),('1444','2014-04-02','16:40:00',1.81),('1444','2014-04-02','16:45:00',1.74),('1444','2014-04-02','16:50:00',1.62),('1444','2014-04-02','16:55:00',1.6),('1444','2014-04-02','17:00:00',1.6),('1444','2014-04-02','17:05:00',1.44),('1444','2014-04-02','17:10:00',1.37),('1444','2014-04-02','17:15:00',1.22),('1444','2014-04-02','17:20:00',1.22),('1444','2014-04-02','17:25:00',1.16),('1444','2014-04-02','17:30:00',1.04),('1444','2014-04-02','17:35:00',1.02),('1444','2014-04-01','08:40:00',1.04),('1444','2014-04-01','08:45:00',1.11),('1444','2014-04-01','08:50:00',1.18),('1444','2014-04-01','08:55:00',1.25),('1444','2014-04-01','09:00:00',1.32),('1444','2014-04-01','09:05:00',1.38),('1444','2014-04-01','09:10:00',1.44),('1444','2014-04-01','09:15:00',1.5),('1444','2014-04-01','09:20:00',1.56),('1444','2014-04-01','09:25:00',1.6),('1444','2014-04-01','09:30:00',1.66),('1444','2014-04-01','09:35:00',1.78),('1444','2014-04-01','09:40:00',1.84),('1444','2014-04-01','09:45:00',1.87),('1444','2014-04-01','09:50:00',1.96),('1444','2014-04-01','09:55:00',2.02),('1444','2014-04-01','10:00:00',2.06),('1444','2014-04-01','10:05:00',2.07),('1444','2014-04-01','10:10:00',2.15),('1444','2014-04-01','10:15:00',2.26),('1444','2014-04-01','10:20:00',2.41),('1444','2014-04-01','10:25:00',2.29),('1444','2014-04-01','10:30:00',2.27),('1444','2014-04-01','10:35:00',2.73),('1444','2014-04-01','10:40:00',2.57),('1444','2014-04-01','10:45:00',2.59),('1444','2014-04-01','10:50:00',2.55),('1444','2014-04-01','10:55:00',2.57),('1444','2014-04-01','11:00:00',2.63),('1444','2014-04-01','11:05:00',2.65),('1444','2014-04-01','11:10:00',2.67),('1444','2014-04-01','11:15:00',2.71),('1444','2014-04-01','11:20:00',2.79),('1444','2014-04-01','11:25:00',2.82),('1444','2014-04-01','11:30:00',2.87),('1444','2014-04-01','11:35:00',2.84),('1444','2014-04-01','11:40:00',2.88),('1444','2014-04-01','11:45:00',2.9),('1444','2014-04-01','11:50:00',2.91),('1444','2014-04-01','11:55:00',2.87),('1444','2014-04-01','12:00:00',2.98),('1444','2014-04-01','12:05:00',3.01),('1444','2014-04-01','12:10:00',3.02),('1444','2014-04-01','12:15:00',3.04),('1444','2014-04-01','12:20:00',3.07),('1444','2014-04-01','12:25:00',3.09),('1444','2014-04-01','12:30:00',3.13),('1444','2014-04-01','12:35:00',3.15),('1444','2014-04-01','12:40:00',3.16),('1444','2014-04-01','12:45:00',3.16),('1444','2014-04-01','12:50:00',2.98),('1444','2014-04-01','12:55:00',3.17),('1444','2014-04-01','13:00:00',3.18),('1444','2014-04-01','13:05:00',3.11),('1444','2014-04-01','13:10:00',3.17),('1444','2014-04-01','13:15:00',3.21),('1444','2014-04-01','13:20:00',3.08),('1444','2014-04-01','13:25:00',3.14),('1444','2014-04-01','13:30:00',2.95),('1444','2014-04-01','13:35:00',2.94),('1444','2014-04-01','13:40:00',2.51),('1444','2014-04-01','13:45:00',3.2),('1444','2014-04-01','13:50:00',3.15),('1444','2014-04-01','13:55:00',3.15),('1444','2014-04-01','14:00:00',3.1),('1444','2014-04-01','14:05:00',2.85),('1444','2014-04-01','14:10:00',2.71),('1444','2014-04-01','14:15:00',2.76),('1444','2014-04-01','14:20:00',2.78),('1444','2014-04-01','14:25:00',2.81),('1444','2014-04-01','14:30:00',3.11),('1444','2014-04-01','14:35:00',2.85),('1444','2014-04-01','14:40:00',2.5),('1444','2014-04-01','14:45:00',3.13),('1444','2014-04-01','14:50:00',2.61),('1444','2014-04-01','14:55:00',2.46),('1444','2014-04-01','15:00:00',2.55),('1444','2014-04-01','15:05:00',2.39),('1444','2014-04-01','15:10:00',2.86),('1444','2014-04-01','15:15:00',2.86),('1444','2014-04-01','15:20:00',1.87),('1444','2014-04-01','15:25:00',2.81),('1444','2014-04-01','15:30:00',2.24),('1444','2014-04-01','15:35:00',2.69),('1444','2014-04-01','15:40:00',2.58),('1444','2014-04-01','15:45:00',2.13),('1444','2014-04-01','15:50:00',2.56),('1444','2014-04-01','15:55:00',2.43),('1444','2014-04-01','16:00:00',2.31),('1444','2014-04-01','16:05:00',2.4),('1444','2014-04-01','16:10:00',2.19),('1444','2014-04-01','16:15:00',2.38),('1444','2014-04-01','16:20:00',1.1),('1444','2014-04-01','16:25:00',1.74),('1444','2014-04-01','16:30:00',2.2),('1444','2014-04-01','16:35:00',2.06),('1444','2014-04-01','16:40:00',1.75),('1444','2014-04-01','16:45:00',1.08),('1444','2014-04-01','16:50:00',1.6),('1444','2014-04-01','16:55:00',1.05),('1444','2014-04-01','17:00:00',1.5),('1444','2014-04-01','17:05:00',1.59),('1444','2014-04-01','17:10:00',1.46),('1444','2014-04-01','17:15:00',1.35),('1444','2014-04-01','17:20:00',1.37),('1444','2014-04-01','17:25:00',1.31),('1444','2014-04-01','17:30:00',1.21),('1444','2014-04-01','17:35:00',1.12),('1444','2014-04-01','17:40:00',1.08),('1444','2014-04-01','17:45:00',1.01),('1444','2014-03-31','08:40:00',1.03),('1444','2014-03-31','08:45:00',1.09),('1444','2014-03-31','08:50:00',1.16),('1444','2014-03-31','08:55:00',1.22),('1444','2014-03-31','09:00:00',1.28),('1444','2014-03-31','09:05:00',1.36),('1444','2014-03-31','09:10:00',1.43),('1444','2014-03-31','09:15:00',1.49),('1444','2014-03-31','09:20:00',1.56),('1444','2014-03-31','09:25:00',1.62),('1444','2014-03-31','09:30:00',1.67),('1444','2014-03-31','09:35:00',1.75),('1444','2014-03-31','09:40:00',1.81),('1444','2014-03-31','09:45:00',1.87),('1444','2014-03-31','09:50:00',1.92),('1444','2014-03-31','09:55:00',1.95),('1444','2014-03-31','10:00:00',2.01),('1444','2014-03-31','10:05:00',2.05),('1444','2014-03-31','10:10:00',2.11),('1444','2014-03-31','10:15:00',2.17),('1444','2014-03-31','10:20:00',2.22),('1444','2014-03-31','10:25:00',2.25),('1444','2014-03-31','10:30:00',2.29),('1444','2014-03-31','10:35:00',2.34),('1444','2014-03-31','10:40:00',2.38),('1444','2014-03-31','10:45:00',2.42),('1444','2014-03-31','10:50:00',2.48),('1444','2014-03-31','10:55:00',2.51),('1444','2014-03-31','11:00:00',2.54),('1444','2014-03-31','11:05:00',2.58),('1444','2014-03-31','11:10:00',2.61),('1444','2014-03-31','11:15:00',2.64),('1444','2014-03-31','11:20:00',2.67),('1444','2014-03-31','11:25:00',2.71),('1444','2014-03-31','11:30:00',2.73),('1444','2014-03-31','11:35:00',2.73),('1444','2014-03-31','11:40:00',2.78),('1444','2014-03-31','11:45:00',2.8),('1444','2014-03-31','11:50:00',2.85),('1444','2014-03-31','11:55:00',2.84),('1444','2014-03-31','12:00:00',2.85),('1444','2014-03-31','12:05:00',2.87),('1444','2014-03-31','12:10:00',2.9),('1444','2014-03-31','12:15:00',2.93),('1444','2014-03-31','12:20:00',2.93),('1444','2014-03-31','12:25:00',2.95),('1444','2014-03-31','12:30:00',2.96),('1444','2014-03-31','12:35:00',2.97),('1444','2014-03-31','12:40:00',2.98),('1444','2014-03-31','12:45:00',2.96),('1444','2014-03-31','12:50:00',2.96),('1444','2014-03-31','12:55:00',2.97),('1444','2014-03-31','13:00:00',2.99),('1444','2014-03-31','13:05:00',3.02),('1444','2014-03-31','13:10:00',3.02),('1444','2014-03-31','13:15:00',3.01),('1444','2014-03-31','13:20:00',3),('1444','2014-03-31','13:25:00',2.99),('1444','2014-03-31','13:30:00',2.98),('1444','2014-03-31','13:35:00',2.99),('1444','2014-03-31','13:40:00',3.01),('1444','2014-03-31','13:45:00',3),('1444','2014-03-31','13:50:00',2.98),('1444','2014-03-31','13:55:00',2.98),('1444','2014-03-31','14:00:00',2.97),('1444','2014-03-31','14:05:00',2.97),('1444','2014-03-31','14:10:00',2.95),('1444','2014-03-31','14:15:00',2.94),('1444','2014-03-31','14:20:00',2.9),('1444','2014-03-31','14:25:00',2.88),('1444','2014-03-31','14:30:00',2.86),('1444','2014-03-31','14:35:00',2.86),('1444','2014-03-31','14:40:00',2.84),('1444','2014-03-31','14:45:00',2.82),('1444','2014-03-31','14:50:00',2.78),('1444','2014-03-31','14:55:00',2.73),('1444','2014-03-31','15:00:00',2.73),('1444','2014-03-31','15:05:00',2.7),('1444','2014-03-31','15:10:00',2.65),('1444','2014-03-31','15:15:00',2.62),('1444','2014-03-31','15:20:00',2.59),('1444','2014-03-31','15:25:00',2.54),('1444','2014-03-31','15:30:00',2.5),('1444','2014-03-31','15:35:00',2.45),('1444','2014-03-31','15:40:00',2.41),('1444','2014-03-31','15:45:00',2.37),('1444','2014-03-31','15:50:00',2.32),('1444','2014-03-31','15:55:00',2.25),('1444','2014-03-31','16:00:00',2.21),('1444','2014-03-31','16:05:00',2.15),('1444','2014-03-31','16:10:00',2.09),('1444','2014-03-31','16:15:00',2.04),('1444','2014-03-31','16:20:00',1.99),('1444','2014-03-31','16:25:00',1.93),('1444','2014-03-31','16:30:00',1.88),('1444','2014-03-31','16:35:00',1.82),('1444','2014-03-31','16:40:00',1.77),('1444','2014-03-31','16:45:00',1.71),('1444','2014-03-31','16:50:00',1.65),('1444','2014-03-31','16:55:00',1.58),('1444','2014-03-31','17:00:00',1.51),('1444','2014-03-31','17:05:00',1.46),('1444','2014-03-31','17:10:00',1.4),('1444','2014-03-31','17:15:00',1.33),('1444','2014-03-31','17:20:00',1.25),('1444','2014-03-31','17:25:00',1.19),('1444','2014-03-31','17:30:00',1.14),('1444','2014-03-31','17:35:00',1.06),('1444','2014-03-31','17:40:00',1.02),('1444','2014-03-30','08:40:00',1),('1444','2014-03-30','08:50:00',1.02),('1444','2014-03-30','08:55:00',1.06),('1444','2014-03-30','09:00:00',1.09),('1444','2014-03-30','09:05:00',1.09),('1444','2014-03-30','09:10:00',1.04),('1444','2014-03-30','09:15:00',1.15),('1444','2014-03-30','09:20:00',1.23),('1444','2014-03-30','09:25:00',1.42),('1444','2014-03-30','09:30:00',1.57),('1444','2014-03-30','09:35:00',1.66),('1444','2014-03-30','09:40:00',1.68),('1444','2014-03-30','09:45:00',1.76),('1444','2014-03-30','09:50:00',1.78),('1444','2014-03-30','09:55:00',1.72),('1444','2014-03-30','10:00:00',1.86),('1444','2014-03-30','10:05:00',1.96),('1444','2014-03-30','10:10:00',2.02),('1444','2014-03-30','10:15:00',2),('1444','2014-03-30','10:20:00',2.13),('1444','2014-03-30','10:25:00',2.19),('1444','2014-03-30','10:30:00',2.24),('1444','2014-03-30','10:35:00',2.31),('1444','2014-03-30','10:40:00',2.35),('1444','2014-03-30','10:45:00',2.37),('1444','2014-03-30','10:50:00',2.35),('1444','2014-03-30','10:55:00',2.35),('1444','2014-03-30','11:00:00',2.3),('1444','2014-03-30','11:05:00',2.31),('1444','2014-03-30','11:10:00',2.34),('1444','2014-03-30','11:15:00',2.28),('1444','2014-03-30','11:20:00',2.34),('1444','2014-03-30','11:25:00',2.52),('1444','2014-03-30','11:30:00',2.56),('1444','2014-03-30','11:35:00',2.59),('1444','2014-03-30','11:40:00',2.69),('1444','2014-03-30','11:45:00',2.75),('1444','2014-03-30','11:50:00',2.81),('1444','2014-03-30','11:55:00',2.88),('1444','2014-03-30','12:00:00',2.95),('1444','2014-03-30','12:05:00',3),('1444','2014-03-30','12:10:00',3.07),('1444','2014-03-30','12:15:00',3.09),('1444','2014-03-30','12:20:00',2.94),('1444','2014-03-30','12:25:00',2.91),('1444','2014-03-30','12:30:00',2.69),('1444','2014-03-30','12:35:00',2.91),('1444','2014-03-30','12:40:00',2.89),('1444','2014-03-30','12:45:00',2.9),('1444','2014-03-30','12:50:00',2.93),('1444','2014-03-30','12:55:00',2.98),('1444','2014-03-30','13:00:00',3.08),('1444','2014-03-30','13:05:00',3.11),('1444','2014-03-30','13:10:00',3.06),('1444','2014-03-30','13:15:00',3.08),('1444','2014-03-30','13:20:00',3.07),('1444','2014-03-30','13:25:00',3.06),('1444','2014-03-30','13:30:00',3.09),('1444','2014-03-30','13:35:00',3.08),('1444','2014-03-30','13:40:00',3.09),('1444','2014-03-30','13:45:00',3.07),('1444','2014-03-30','13:50:00',3),('1444','2014-03-30','13:55:00',2.93),('1444','2014-03-30','14:00:00',2.89),('1444','2014-03-30','14:05:00',2.86),('1444','2014-03-30','14:10:00',2.8),('1444','2014-03-30','14:15:00',2.82),('1444','2014-03-30','14:20:00',2.91),('1444','2014-03-30','14:25:00',2.92),('1444','2014-03-30','14:30:00',2.81),('1444','2014-03-30','14:35:00',2.54),('1444','2014-03-30','14:40:00',2.51),('1444','2014-03-30','14:45:00',2.18),('1444','2014-03-30','14:50:00',1.75),('1444','2014-03-30','14:55:00',1.12),('1444','2014-03-30','15:00:00',1.16),('1444','2014-03-30','15:05:00',1.37),('1444','2014-03-30','15:10:00',2.02),('1444','2014-03-30','15:15:00',2.24),('1444','2014-03-30','15:20:00',2.31),('1444','2014-03-30','15:25:00',2.37),('1444','2014-03-30','15:30:00',2.39),('1444','2014-03-30','15:35:00',2.37),('1444','2014-03-30','15:40:00',2.39),('1444','2014-03-30','15:45:00',2.36),('1444','2014-03-30','15:50:00',2.31),('1444','2014-03-30','15:55:00',2.25),('1444','2014-03-30','16:00:00',2.03),('1444','2014-03-30','16:05:00',2),('1444','2014-03-30','16:10:00',1.95),('1444','2014-03-30','16:15:00',2.13),('1444','2014-03-30','16:20:00',2.11),('1444','2014-03-30','16:25:00',2.04),('1444','2014-03-30','16:30:00',2.04),('1444','2014-03-30','16:35:00',1.98),('1444','2014-03-30','16:40:00',1.82),('1444','2014-03-30','16:45:00',1.62),('1444','2014-03-30','16:50:00',1.37),('1444','2014-03-30','16:55:00',1.34),('1444','2014-03-30','17:00:00',1.44),('1444','2014-03-30','17:05:00',1.53),('1444','2014-03-30','17:10:00',1.56),('1444','2014-03-30','17:15:00',1.5),('1444','2014-03-30','17:20:00',1.41),('1444','2014-03-30','17:25:00',1.26),('1444','2014-03-30','17:30:00',1.25),('1444','2014-03-30','17:35:00',1.17),('1444','2014-03-30','17:40:00',1.05),('1444','2014-03-30','17:45:00',1.01),('1444','2014-03-29','07:45:00',1.05),('1444','2014-03-29','07:50:00',1.12),('1444','2014-03-29','07:55:00',1.18),('1444','2014-03-29','08:00:00',1.25),('1444','2014-03-29','08:05:00',1.32),('1444','2014-03-29','08:10:00',1.39),('1444','2014-03-29','08:15:00',1.46),('1444','2014-03-29','08:20:00',1.51),('1444','2014-03-29','08:25:00',1.6),('1444','2014-03-29','08:30:00',1.64),('1444','2014-03-29','08:35:00',1.69),('1444','2014-03-29','08:40:00',1.75),('1444','2014-03-29','08:45:00',1.79),('1444','2014-03-29','08:50:00',1.85),('1444','2014-03-29','08:55:00',1.92),('1444','2014-03-29','09:00:00',1.95),('1444','2014-03-29','09:05:00',2.02),('1444','2014-03-29','09:10:00',2.09),('1444','2014-03-29','09:15:00',2.14),('1444','2014-03-29','09:20:00',2.19),('1444','2014-03-29','09:25:00',2.25),('1444','2014-03-29','09:30:00',2.28),('1444','2014-03-29','09:35:00',2.34),('1444','2014-03-29','09:40:00',2.4),('1444','2014-03-29','09:45:00',2.44),('1444','2014-03-29','09:50:00',2.49),('1444','2014-03-29','09:55:00',2.53),('1444','2014-03-29','10:00:00',2.55),('1444','2014-03-29','10:05:00',2.57),('1444','2014-03-29','10:10:00',2.63),('1444','2014-03-29','10:15:00',2.7),('1444','2014-03-29','10:20:00',2.72),('1444','2014-03-29','10:25:00',2.75),('1444','2014-03-29','10:30:00',2.79),('1444','2014-03-29','10:35:00',2.8),('1444','2014-03-29','10:40:00',2.84),('1444','2014-03-29','10:45:00',2.84),('1444','2014-03-29','10:50:00',2.9),('1444','2014-03-29','10:55:00',2.92),('1444','2014-03-29','11:00:00',2.94),('1444','2014-03-29','11:05:00',2.96),('1444','2014-03-29','11:10:00',2.96),('1444','2014-03-29','11:15:00',2.98),('1444','2014-03-29','11:20:00',2.99),('1444','2014-03-29','11:25:00',2.99),('1444','2014-03-29','11:30:00',2.99),('1444','2014-03-29','11:35:00',3),('1444','2014-03-29','11:40:00',2.91),('1444','2014-03-29','11:45:00',3.04),('1444','2014-03-29','11:50:00',3.05),('1444','2014-03-29','11:55:00',3.06),('1444','2014-03-29','12:00:00',3.05),('1444','2014-03-29','12:05:00',3.07),('1444','2014-03-29','12:10:00',3.06),('1444','2014-03-29','12:15:00',3.06),('1444','2014-03-29','12:20:00',3.05),('1444','2014-03-29','12:25:00',3.06),('1444','2014-03-29','12:30:00',3.08),('1444','2014-03-29','12:35:00',3.06),('1444','2014-03-29','12:40:00',3.02),('1444','2014-03-29','12:45:00',3.02),('1444','2014-03-29','12:50:00',3.01),('1444','2014-03-29','12:55:00',2.97),('1444','2014-03-29','13:00:00',2.92),('1444','2014-03-29','13:05:00',2.97),('1444','2014-03-29','13:10:00',2.93),('1444','2014-03-29','13:15:00',2.91),('1444','2014-03-29','13:20:00',2.91),('1444','2014-03-29','13:25:00',2.86),('1444','2014-03-29','13:30:00',2.81),('1444','2014-03-29','13:35:00',2.77),('1444','2014-03-29','13:40:00',2.75),('1444','2014-03-29','13:45:00',2.73),('1444','2014-03-29','13:50:00',2.68),('1444','2014-03-29','13:55:00',2.66),('1444','2014-03-29','14:00:00',2.65),('1444','2014-03-29','14:05:00',2.6),('1444','2014-03-29','14:10:00',2.57),('1444','2014-03-29','14:15:00',2.54),('1444','2014-03-29','14:20:00',2.48),('1444','2014-03-29','14:25:00',2.23),('1444','2014-03-29','14:30:00',2.39),('1444','2014-03-29','14:35:00',2.2),('1444','2014-03-29','14:40:00',2.01),('1444','2014-03-29','14:45:00',2.31),('1444','2014-03-29','14:50:00',2.26),('1444','2014-03-29','14:55:00',2.22),('1444','2014-03-29','15:00:00',2.19),('1444','2014-03-29','15:05:00',2.1),('1444','2014-03-29','15:10:00',2.04),('1444','2014-03-29','15:15:00',2.01),('1444','2014-03-29','15:20:00',1.96),('1444','2014-03-29','15:25:00',1.86),('1444','2014-03-29','15:30:00',1.75),('1444','2014-03-29','15:35:00',1.69),('1444','2014-03-29','15:40:00',1.66),('1444','2014-03-29','15:45:00',1.63),('1444','2014-03-29','15:50:00',1.57),('1444','2014-03-29','15:55:00',1.51),('1444','2014-03-29','16:00:00',1.47),('1444','2014-03-29','16:05:00',1.39),('1444','2014-03-29','16:10:00',1.31),('1444','2014-03-29','16:15:00',1.26),('1444','2014-03-29','16:20:00',1.14),('1444','2014-03-29','16:25:00',1.14),('1444','2014-03-29','16:30:00',1.08),('1444','2014-03-28','07:45:00',1.08),('1444','2014-03-28','07:50:00',1.16),('1444','2014-03-28','07:55:00',1.21),('1444','2014-03-28','08:00:00',1.27),('1444','2014-03-28','08:05:00',1.35),('1444','2014-03-28','08:10:00',1.43),('1444','2014-03-28','08:15:00',1.5),('1444','2014-03-28','08:20:00',1.57),('1444','2014-03-28','08:25:00',1.63),('1444','2014-03-28','08:30:00',1.69),('1444','2014-03-28','08:35:00',1.76),('1444','2014-03-28','08:40:00',1.83),('1444','2014-03-28','08:45:00',1.88),('1444','2014-03-28','08:50:00',1.95),('1444','2014-03-28','08:55:00',2.04),('1444','2014-03-28','09:00:00',2.1),('1444','2014-03-28','09:05:00',2.18),('1444','2014-03-28','09:10:00',2.28),('1444','2014-03-28','09:15:00',2.36),('1444','2014-03-28','09:20:00',2.22),('1444','2014-03-28','09:25:00',2.65),('1444','2014-03-28','09:30:00',2.65),('1444','2014-03-28','09:35:00',2.47),('1444','2014-03-28','09:40:00',1.53),('1444','2014-03-28','09:45:00',1.48),('1444','2014-03-28','09:50:00',1.88),('1444','2014-03-28','09:55:00',2.75),('1444','2014-03-28','10:00:00',2.66),('1444','2014-03-28','10:05:00',2.73),('1444','2014-03-28','10:10:00',2.76),('1444','2014-03-28','10:15:00',2.14),('1444','2014-03-28','10:20:00',1.78),('1444','2014-03-28','10:25:00',2.6),('1444','2014-03-28','10:30:00',2.81),('1444','2014-03-28','10:35:00',2.78),('1444','2014-03-28','10:40:00',2.68),('1444','2014-03-28','10:45:00',2.31),('1444','2014-03-28','10:50:00',2.97),('1444','2014-03-28','10:55:00',3.02),('1444','2014-03-28','11:00:00',3.02),('1444','2014-03-28','11:05:00',2.98),('1444','2014-03-28','11:10:00',2.4),('1444','2014-03-28','11:15:00',1.49),('1444','2014-03-28','11:25:00',1.93),('1444','2014-03-28','11:30:00',1.84),('1444','2014-03-28','11:35:00',1.27),('1444','2014-03-28','11:40:00',1.18),('1444','2014-03-28','11:45:00',2.03),('1444','2014-03-28','11:50:00',2.6),('1444','2014-03-28','11:55:00',1.09),('1444','2014-03-28','12:05:00',2.92),('1444','2014-03-28','12:10:00',3.41),('1444','2014-03-28','12:15:00',3.52),('1444','2014-03-28','12:20:00',3.62),('1444','2014-03-28','12:25:00',1.85),('1444','2014-03-28','12:35:00',1.4),('1444','2014-03-28','12:40:00',1.75),('1444','2014-03-28','12:45:00',3.36),('1444','2014-03-28','12:50:00',2.86),('1444','2014-03-28','12:55:00',3.16),('1444','2014-03-28','13:00:00',3.04),('1444','2014-03-28','13:05:00',2.89),('1444','2014-03-28','13:10:00',2.52),('1444','2014-03-28','13:15:00',1.54),('1444','2014-03-28','13:20:00',2.03),('1444','2014-03-28','13:25:00',1.51),('1444','2014-03-28','13:30:00',1.33),('1444','2014-03-28','13:35:00',2.68),('1444','2014-03-28','13:40:00',3.06),('1444','2014-03-28','13:45:00',3.02),('1444','2014-03-28','13:50:00',2.9),('1444','2014-03-28','13:55:00',2.83),('1444','2014-03-28','14:00:00',2.81),('1444','2014-03-28','14:05:00',2.76),('1444','2014-03-28','14:10:00',2.73),('1444','2014-03-28','14:15:00',2.68),('1444','2014-03-28','14:20:00',2.63),('1444','2014-03-28','14:25:00',2.6),('1444','2014-03-28','14:30:00',2.56),('1444','2014-03-28','14:35:00',2.52),('1444','2014-03-28','14:40:00',2.5),('1444','2014-03-28','14:45:00',2.45),('1444','2014-03-28','14:50:00',2.41),('1444','2014-03-28','14:55:00',2.37),('1444','2014-03-28','15:00:00',2.33),('1444','2014-03-28','15:05:00',2.28),('1444','2014-03-28','15:10:00',2.2),('1444','2014-03-28','15:15:00',2.15),('1444','2014-03-28','15:20:00',2.09),('1444','2014-03-28','15:25:00',2.03),('1444','2014-03-28','15:30:00',1.97),('1444','2014-03-28','15:35:00',1.92),('1444','2014-03-28','15:40:00',1.86),('1444','2014-03-28','15:45:00',1.84),('1444','2014-03-28','15:50:00',1.82),('1444','2014-03-28','15:55:00',1.65),('1444','2014-03-28','16:00:00',1.76),('1444','2014-03-28','16:05:00',1.83),('1444','2014-03-28','16:10:00',1.76),('1444','2014-03-28','16:15:00',1.68),('1444','2014-03-28','16:20:00',1.44),('1444','2014-03-28','16:25:00',1.27),('1444','2014-03-28','16:30:00',1.21),('1444','2014-05-02','08:00:00',1.08),('1444','2014-05-02','08:05:00',1.01),('1444','2014-05-02','08:15:00',1.56),('1444','2014-05-02','08:20:00',1.17),('1444','2014-05-02','08:45:00',1.42),('1444','2014-05-02','08:50:00',1.11),('1444','2014-05-02','09:20:00',1.21),('1444','2014-05-02','09:25:00',1.55),('1444','2014-05-02','09:30:00',1.65),('1444','2014-05-02','09:35:00',1.52),('1444','2014-05-02','09:40:00',1.47),('1444','2014-05-02','09:45:00',1.26),('1444','2014-05-02','09:50:00',1.33),('1444','2014-05-02','09:55:00',1.24),('1444','2014-05-02','10:00:00',1.43),('1444','2014-05-02','10:05:00',1.67),('1444','2014-05-02','10:10:00',1.47),('1444','2014-05-02','10:15:00',1.35),('1444','2014-05-02','10:20:00',1.13),('1444','2014-05-02','12:45:00',1.26),('1444','2014-05-02','12:50:00',1.52),('1444','2014-05-02','12:55:00',1.19),('1444','2014-05-02','13:00:00',1.34),('1444','2014-05-02','13:05:00',1.59),('1444','2014-05-02','13:10:00',1.5),('1444','2014-05-02','13:15:00',2.14),('1444','2014-05-02','13:20:00',2.52),('1444','2014-05-02','13:25:00',2.83),('1444','2014-05-02','13:30:00',1.92),('1444','2014-05-02','13:35:00',1.88),('1444','2014-05-02','13:40:00',1.93),('1444','2014-05-02','13:45:00',1.59),('1444','2014-05-02','13:50:00',1.31),('1444','2014-05-02','13:55:00',1.03),('1444','2014-05-02','14:00:00',1.27),('1444','2014-05-02','14:05:00',2.09),('1444','2014-05-02','14:30:00',1.01),('1444','2014-05-02','14:35:00',1.48),('1444','2014-05-02','14:40:00',2.25),('1444','2014-05-02','14:45:00',1.18),('1444','2014-05-02','14:50:00',1.15),('1444','2014-05-02','14:55:00',1.62),('1444','2014-05-02','15:00:00',1.95),('1444','2014-05-02','15:05:00',1.52),('1444','2014-05-02','15:10:00',2.7),('1444','2014-05-02','15:15:00',1.81),('1444','2014-05-02','15:20:00',2.03),('1444','2014-05-02','15:25:00',1.09),('1444','2014-05-02','15:30:00',1.11),('1444','2014-05-02','15:35:00',2.57),('1444','2014-05-02','15:40:00',2.52),('1444','2014-05-02','15:45:00',1.01),('1444','2014-05-02','16:00:00',1.18),('1444','2014-05-02','16:05:00',1.28),('1444','2014-05-02','16:15:00',1.2),('1444','2014-05-02','16:20:00',1.64),('1444','2014-03-27','08:00:00',1.18),('1444','2014-03-27','08:05:00',1.13),('1444','2014-03-27','10:20:00',1.33),('1444','2014-03-27','10:25:00',1.6),('1444','2014-03-27','10:30:00',1.63),('1444','2014-03-27','10:35:00',1.55),('1444','2014-03-27','10:40:00',1.63),('1444','2014-03-27','11:10:00',2.68),('1444','2014-03-27','11:15:00',1.56),('1444','2014-03-27','11:55:00',1.12),('1444','2014-03-27','13:10:00',1.34),('1444','2014-03-27','13:15:00',1.75),('1444','2014-03-27','13:20:00',1.86),('1444','2014-03-27','13:25:00',1.86),('1444','2014-03-27','13:30:00',1.58),('1444','2014-03-27','13:35:00',1.49),('1444','2014-03-27','13:40:00',1.4),('1444','2014-03-27','13:45:00',1.33),('1444','2014-03-27','13:50:00',1.79),('1444','2014-03-27','13:55:00',2.07),('1444','2014-03-27','14:00:00',1.54),('1444','2014-03-27','14:15:00',2.23),('1444','2014-03-27','14:20:00',2.77),('1444','2014-03-27','14:25:00',2.96),('1444','2014-03-27','14:30:00',2.6),('1444','2014-03-27','14:35:00',1.69),('1444','2014-03-27','14:40:00',1.44),('1444','2014-03-27','14:45:00',1.38),('1444','2014-03-27','14:50:00',1.73),('1444','2014-03-27','14:55:00',1.48),('1444','2014-03-27','15:00:00',2.62),('1444','2014-03-27','15:05:00',1.01),('1444','2014-03-27','15:25:00',2.39),('1444','2014-03-27','15:30:00',1.85),('1444','2014-03-27','15:35:00',2.15),('1444','2014-03-26','07:45:00',1.03),('1444','2014-03-26','07:50:00',1.1),('1444','2014-03-26','07:55:00',1.17),('1444','2014-03-26','08:00:00',1.23),('1444','2014-03-26','08:05:00',1.32),('1444','2014-03-26','08:10:00',1.41),('1444','2014-03-26','08:15:00',1.61),('1444','2014-03-26','08:20:00',1.18),('1444','2014-03-26','08:50:00',1.08),('1444','2014-03-26','09:00:00',1.1),('1444','2014-03-26','09:05:00',1.01),('1444','2014-03-26','09:10:00',1.2),('1444','2014-03-26','09:15:00',1),('1444','2014-03-26','09:25:00',1.96),('1444','2014-03-26','09:30:00',2.4),('1444','2014-03-26','09:35:00',2.4),('1444','2014-03-26','09:40:00',2.42),('1444','2014-03-26','09:45:00',2.48),('1444','2014-03-26','09:50:00',2.51),('1444','2014-03-26','09:55:00',2.54),('1444','2014-03-26','10:00:00',2.62),('1444','2014-03-26','10:05:00',1.76),('1444','2014-03-26','10:10:00',3.03),('1444','2014-03-26','10:15:00',2.39),('1444','2014-03-26','10:20:00',1.78),('1444','2014-03-26','10:25:00',3.07),('1444','2014-03-26','10:30:00',1.69),('1444','2014-03-26','10:45:00',1.4),('1444','2014-03-26','10:50:00',2.23),('1444','2014-03-26','10:55:00',3.59),('1444','2014-03-26','11:00:00',2.43),('1444','2014-03-26','11:05:00',1.39),('1444','2014-03-26','11:10:00',3.48),('1444','2014-03-26','11:15:00',3.86),('1444','2014-03-26','11:20:00',1.26),('1444','2014-03-26','11:30:00',1.34),('1444','2014-03-26','11:35:00',1.35),('1444','2014-03-26','11:40:00',1.47),('1444','2014-03-26','11:45:00',3.12),('1444','2014-03-26','11:50:00',2.66),('1444','2014-03-26','11:55:00',3.7),('1444','2014-03-26','12:00:00',3.09),('1444','2014-03-26','12:05:00',2.73),('1444','2014-03-26','12:10:00',2.63),('1444','2014-03-26','12:15:00',1.34),('1444','2014-03-26','12:20:00',1.5),('1444','2014-03-26','12:25:00',1.37),('1444','2014-03-26','12:30:00',1.36),('1444','2014-03-26','12:35:00',1.3),('1444','2014-03-26','12:40:00',1.69),('1444','2014-03-26','12:45:00',1.56),('1444','2014-03-26','12:50:00',1.2),('1444','2014-03-26','13:00:00',1.05),('1444','2014-03-26','13:20:00',2.97),('1444','2014-03-26','13:25:00',3.38),('1444','2014-03-26','13:30:00',2.44),('1444','2014-03-26','13:35:00',1.68),('1444','2014-03-26','13:55:00',1.61),('1444','2014-03-26','14:00:00',3.63),('1444','2014-03-26','14:05:00',3.55),('1444','2014-03-26','14:10:00',1.19),('1444','2014-03-26','14:45:00',2.07),('1444','2014-03-26','14:50:00',2.32),('1444','2014-03-26','14:55:00',2.58),('1444','2014-03-26','15:00:00',2.18),('1444','2014-03-26','15:05:00',2.27),('1444','2014-03-26','15:10:00',2.35),('1444','2014-03-26','15:15:00',2.47),('1444','2014-03-26','15:20:00',2.2),('1444','2014-03-26','15:25:00',2.3),('1444','2014-03-26','15:30:00',2.29),('1444','2014-03-26','15:35:00',2.13),('1444','2014-03-26','15:40:00',1.78),('1444','2014-03-26','15:45:00',1.63),('1444','2014-03-26','15:50:00',1.22),('1444','2014-03-26','15:55:00',1.11),('1444','2014-03-26','16:10:00',1.02),('1444','2014-03-26','16:15:00',1.08),('1444','2014-03-25','07:25:00',1.03),('1444','2014-03-25','07:30:00',1.06),('1444','2014-03-25','08:10:00',1.06),('1444','2014-03-25','08:15:00',1.11),('1444','2014-03-25','08:20:00',1.02),('1444','2014-03-25','08:40:00',1.04),('1444','2014-03-25','08:45:00',1.38),('1444','2014-03-25','08:50:00',1.49),('1444','2014-03-25','08:55:00',1.57),('1444','2014-03-25','09:00:00',1.43),('1444','2014-03-25','09:05:00',1.41),('1444','2014-03-25','09:10:00',1.39),('1444','2014-03-25','09:15:00',1.78),('1444','2014-03-25','09:20:00',1.95),('1444','2014-03-25','09:25:00',1.68),('1444','2014-03-25','09:30:00',1.52),('1444','2014-03-25','09:35:00',1.44),('1444','2014-03-25','09:40:00',1.44),('1444','2014-03-25','09:45:00',1.35),('1444','2014-03-25','09:50:00',1.41),('1444','2014-03-25','09:55:00',1.59),('1444','2014-03-25','10:00:00',1.78),('1444','2014-03-25','10:05:00',1.93),('1444','2014-03-25','10:10:00',2),('1444','2014-03-25','10:15:00',2.18),('1444','2014-03-25','10:20:00',2.14),('1444','2014-03-25','10:25:00',2.08),('1444','2014-03-25','10:30:00',2.27),('1444','2014-03-25','10:35:00',1.91),('1444','2014-03-25','10:40:00',1.63),('1444','2014-03-25','10:45:00',1.52),('1444','2014-03-25','10:50:00',1.49),('1444','2014-03-25','10:55:00',1.49),('1444','2014-03-25','11:00:00',1.6),('1444','2014-03-25','11:05:00',1.78),('1444','2014-03-25','11:10:00',1.95),('1444','2014-03-25','11:15:00',2.17),('1444','2014-03-25','11:20:00',2.17),('1444','2014-03-25','11:25:00',1.84),('1444','2014-03-25','11:30:00',2.24),('1444','2014-03-25','11:35:00',1.95),('1444','2014-03-25','11:40:00',2.17),('1444','2014-03-25','11:45:00',1.44),('1444','2014-03-25','11:50:00',1.73),('1444','2014-03-25','11:55:00',1.28),('1444','2014-03-24','08:55:00',1.27),('1444','2014-03-24','09:00:00',1.39),('1444','2014-03-24','09:20:00',1.06),('1444','2014-03-24','09:40:00',1.21),('1444','2014-03-24','10:00:00',1.69),('1444','2014-03-24','10:05:00',1.89),('1444','2014-03-24','10:10:00',2.65),('1444','2014-03-24','10:15:00',1.55),('1444','2014-03-24','10:35:00',1.18),('1444','2014-03-24','10:45:00',1.71),('1444','2014-03-24','10:50:00',3.39),('1444','2014-03-24','10:55:00',2.41),('1444','2014-03-24','11:00:00',1.4),('1444','2014-03-24','11:05:00',1.77),('1444','2014-03-24','11:10:00',2.1),('1444','2014-03-24','11:15:00',2.57),('1444','2014-03-24','11:20:00',1.96),('1444','2014-03-24','11:25:00',2.5),('1444','2014-03-24','11:30:00',2.56),('1444','2014-03-24','11:35:00',1.15),('1444','2014-03-24','12:35:00',1.56),('1444','2014-03-24','12:40:00',1.54),('1444','2014-03-24','12:45:00',1.39),('1444','2014-03-24','12:50:00',1.17),('1444','2014-03-24','12:55:00',1.12),('1444','2014-03-24','13:00:00',1.14),('1444','2014-03-24','13:05:00',1.12),('1444','2014-03-24','13:30:00',1.1),('1444','2014-03-24','13:50:00',1.08),('1444','2014-03-24','13:55:00',1.05),('1444','2014-03-24','14:10:00',1.03),('1444','2014-03-24','14:15:00',1.36),('1444','2014-03-24','14:20:00',1.71),('1444','2014-03-24','14:25:00',1.62),('1444','2014-03-24','14:30:00',1.57),('1444','2014-03-24','14:35:00',1.88),('1444','2014-03-24','14:40:00',2.26),('1444','2014-03-24','14:45:00',2.49),('1444','2014-03-24','14:50:00',2.44),('1444','2014-03-24','14:55:00',2.16),('1444','2014-03-24','15:00:00',1.99),('1444','2014-03-24','15:05:00',1.77),('1444','2014-03-24','15:10:00',1.58),('1444','2014-03-24','15:15:00',1.34),('1444','2014-03-24','15:20:00',1.3),('1444','2014-03-24','15:25:00',1.26),('1444','2014-03-24','15:30:00',1.22),('1444','2014-03-24','15:35:00',1.16),('1444','2014-03-24','15:50:00',1.03),('1444','2014-03-24','15:55:00',1.38),('1444','2014-03-24','16:00:00',1.84),('1444','2014-03-24','16:05:00',1.07),('1444','2014-03-23','08:55:00',1.12),('1444','2014-03-23','09:05:00',1.32),('1444','2014-03-23','09:10:00',2.01),('1444','2014-03-23','09:15:00',1.86),('1444','2014-03-23','09:20:00',1.3),('1444','2014-03-23','09:30:00',1.11),('1444','2014-03-23','09:35:00',1.15),('1444','2014-03-23','10:40:00',1.01),('1444','2014-03-23','10:50:00',1.11),('1444','2014-03-23','10:55:00',1.34),('1444','2014-03-23','11:10:00',1.12),('1444','2014-03-23','11:35:00',1.3),('1444','2014-03-23','11:40:00',2.43),('1444','2014-03-23','13:45:00',1.66),('1444','2014-03-23','13:50:00',1.25),('1444','2014-03-23','15:10:00',1.16),('1444','2014-03-23','15:15:00',1.17),('1444','2014-03-23','15:20:00',1.24),('1444','2014-03-23','15:25:00',1.2),('1444','2014-03-22','08:15:00',1.02),('1444','2014-03-22','08:20:00',1.19),('1444','2014-03-22','08:25:00',1.22),('1444','2014-03-22','08:30:00',1.13),('1444','2014-03-22','08:40:00',1.5),('1444','2014-03-22','08:45:00',1.59),('1444','2014-03-22','08:50:00',1.28),('1444','2014-03-22','08:55:00',1.77),('1444','2014-03-22','09:00:00',1.46),('1444','2014-03-22','09:05:00',1.01),('1444','2014-03-22','09:10:00',1.19),('1444','2014-03-22','09:20:00',1.06),('1444','2014-03-22','09:25:00',1.58),('1444','2014-03-22','09:30:00',1.44),('1444','2014-03-22','09:40:00',1.76),('1444','2014-03-22','09:45:00',2.17),('1444','2014-03-22','09:50:00',2.22),('1444','2014-03-22','09:55:00',2.19),('1444','2014-03-22','10:00:00',1.97),('1444','2014-03-22','10:05:00',1.46),('1444','2014-03-22','10:10:00',1.86),('1444','2014-03-22','10:15:00',1.42),('1444','2014-03-22','10:35:00',1.25),('1444','2014-03-22','10:40:00',1.48),('1444','2014-03-22','10:45:00',1.82),('1444','2014-03-22','10:50:00',1.34),('1444','2014-03-22','11:10:00',1.14),('1444','2014-03-22','11:15:00',1.46),('1444','2014-03-22','11:20:00',2.88),('1444','2014-03-22','11:25:00',3.26),('1444','2014-03-22','11:30:00',2),('1444','2014-03-22','11:35:00',2.05),('1444','2014-03-22','11:40:00',1.37),('1444','2014-03-22','11:45:00',1.14),('1444','2014-03-22','11:50:00',2.55),('1444','2014-03-22','11:55:00',2.92),('1444','2014-03-22','12:00:00',1.3),('1444','2014-03-22','12:05:00',1.03),('1444','2014-03-22','12:10:00',1.12),('1444','2014-03-22','12:15:00',2.54),('1444','2014-03-22','12:20:00',2.6),('1444','2014-03-22','12:25:00',1.13),('1444','2014-03-22','12:30:00',1.46),('1444','2014-03-22','12:35:00',1.57),('1444','2014-03-22','12:40:00',3.12),('1444','2014-03-22','12:45:00',2.3),('1444','2014-03-22','12:50:00',2),('1444','2014-03-22','12:55:00',1.76),('1444','2014-03-22','13:00:00',1.22),('1444','2014-03-22','13:05:00',2.74),('1444','2014-03-22','13:10:00',2.76),('1444','2014-03-22','13:15:00',2.95),('1444','2014-03-22','13:20:00',2.49),('1444','2014-03-22','13:25:00',2.07),('1444','2014-03-22','13:30:00',2.33),('1444','2014-03-22','13:35:00',2.23),('1444','2014-03-22','13:40:00',2.96),('1444','2014-03-22','13:45:00',2.43),('1444','2014-03-22','13:50:00',1.54),('1444','2014-03-22','13:55:00',2.36),('1444','2014-03-22','14:00:00',1.9),('1444','2014-03-22','14:05:00',2.04),('1444','2014-03-22','14:10:00',2.12),('1444','2014-03-22','14:15:00',1.68),('1444','2014-03-22','14:20:00',2.44),('1444','2014-03-22','14:25:00',2.33),('1444','2014-03-22','14:30:00',2.28),('1444','2014-03-22','14:35:00',2.23),('1444','2014-03-22','14:40:00',2.17),('1444','2014-03-22','14:45:00',2.12),('1444','2014-03-22','14:50:00',2.08),('1444','2014-03-22','14:55:00',2.02),('1444','2014-03-22','15:00:00',1.95),('1444','2014-03-22','15:05:00',1.8),('1444','2014-03-22','15:10:00',1.77),('1444','2014-03-22','15:15:00',1.82),('1444','2014-03-22','15:20:00',1.77),('1444','2014-03-22','15:25:00',1.36),('1444','2014-03-22','15:35:00',1.64),('1444','2014-03-22','15:40:00',1.79),('1444','2014-03-22','15:45:00',1.88),('1444','2014-03-22','15:50:00',1.92),('1444','2014-03-22','15:55:00',1.68),('1444','2014-03-22','16:00:00',1.55),('1444','2014-03-22','16:05:00',1.35),('1444','2014-03-22','16:10:00',1.21),('1444','2014-03-22','16:15:00',1.08),('1444','2014-03-22','16:20:00',1.16),('1444','2014-03-21','08:05:00',1.04),('1444','2014-03-21','08:10:00',1.1),('1444','2014-03-21','08:15:00',1.15),('1444','2014-03-21','08:20:00',1.19),('1444','2014-03-21','08:25:00',1.25),('1444','2014-03-21','08:30:00',1.34),('1444','2014-03-21','08:35:00',1.41),('1444','2014-03-21','08:40:00',1.47),('1444','2014-03-21','08:45:00',1.5),('1444','2014-03-21','08:50:00',1.55),('1444','2014-03-21','08:55:00',1.62),('1444','2014-03-21','09:00:00',1.68),('1444','2014-03-21','09:05:00',1.72),('1444','2014-03-21','09:10:00',1.8),('1444','2014-03-21','09:15:00',1.85),('1444','2014-03-21','09:20:00',1.93),('1444','2014-03-21','09:25:00',1.88),('1444','2014-03-21','09:30:00',1.99),('1444','2014-03-21','09:35:00',2.03),('1444','2014-03-21','09:40:00',2.1),('1444','2014-03-21','09:45:00',2.13),('1444','2014-03-21','09:50:00',2.17),('1444','2014-03-21','09:55:00',2.18),('1444','2014-03-21','10:00:00',2.25),('1444','2014-03-21','10:05:00',2.29),('1444','2014-03-21','10:10:00',2.31),('1444','2014-03-21','10:15:00',2.34),('1444','2014-03-21','10:20:00',2.33),('1444','2014-03-21','10:25:00',2.41),('1444','2014-03-21','10:30:00',2.44),('1444','2014-03-21','10:35:00',2.45),('1444','2014-03-21','10:40:00',2.42),('1444','2014-03-21','10:45:00',2.44),('1444','2014-03-21','10:50:00',2.47),('1444','2014-03-21','10:55:00',2.48),('1444','2014-03-21','11:00:00',2.52),('1444','2014-03-21','11:05:00',2.51),('1444','2014-03-21','11:10:00',2.55),('1444','2014-03-21','11:15:00',2.58),('1444','2014-03-21','11:20:00',2.61),('1444','2014-03-21','11:25:00',2.62),('1444','2014-03-21','11:30:00',2.67),('1444','2014-03-21','11:35:00',2.03),('1444','2014-03-21','11:40:00',2.51),('1444','2014-03-21','11:45:00',2.84),('1444','2014-03-21','11:50:00',2.76),('1444','2014-03-21','11:55:00',2.47),('1444','2014-03-21','12:00:00',2.56),('1444','2014-03-21','12:05:00',2.8),('1444','2014-03-21','12:10:00',2.82),('1444','2014-03-21','12:15:00',2.81),('1444','2014-03-21','12:20:00',2.77),('1444','2014-03-21','12:25:00',2.73),('1444','2014-03-21','12:30:00',2.74),('1444','2014-03-21','12:35:00',2.74),('1444','2014-03-21','12:40:00',2.76),('1444','2014-03-21','12:45:00',2.78),('1444','2014-03-21','12:50:00',2.73),('1444','2014-03-21','12:55:00',2.67),('1444','2014-03-21','13:00:00',2.71),('1444','2014-03-21','13:05:00',2.67),('1444','2014-03-21','13:10:00',2.69),('1444','2014-03-21','13:15:00',2.67),('1444','2014-03-21','13:20:00',2.64),('1444','2014-03-21','13:25:00',2.62),('1444','2014-03-21','13:30:00',2.61),('1444','2014-03-21','13:35:00',2.58),('1444','2014-03-21','13:40:00',2.52),('1444','2014-03-21','13:45:00',2.46),('1444','2014-03-21','13:50:00',2.43),('1444','2014-03-21','13:55:00',2.39),('1444','2014-03-21','14:00:00',2.45),('1444','2014-03-21','14:05:00',2.43),('1444','2014-03-21','14:10:00',2.41),('1444','2014-03-21','14:15:00',2.37),('1444','2014-03-21','14:20:00',2.31),('1444','2014-03-21','14:25:00',2.27),('1444','2014-03-21','14:30:00',2.2),('1444','2014-03-21','14:35:00',2.11),('1444','2014-03-21','14:40:00',2.11),('1444','2014-03-21','14:45:00',1.99),('1444','2014-03-21','14:50:00',1.64),('1444','2014-03-21','15:05:00',1.48),('1444','2014-03-21','15:10:00',2.22),('1444','2014-03-21','15:15:00',2.17),('1444','2014-03-21','15:20:00',1.81),('1444','2014-03-21','15:25:00',2.19),('1444','2014-03-21','15:30:00',2.03),('1444','2014-03-21','15:35:00',1.91),('1444','2014-03-21','15:40:00',1.92),('1444','2014-03-21','15:45:00',1.9),('1444','2014-03-21','15:50:00',1.81),('1444','2014-03-21','15:55:00',1.77),('1444','2014-03-21','16:00:00',1.63),('1444','2014-03-21','16:05:00',1.53),('1444','2014-03-21','16:10:00',1.4),('1444','2014-03-21','16:15:00',1.28),('1444','2014-03-21','16:20:00',1.16),('1444','2014-03-21','16:25:00',1.06),('1444','2014-03-20','08:00:00',1.04),('1444','2014-03-20','08:05:00',1.09),('1444','2014-03-20','08:10:00',1.13),('1444','2014-03-20','08:15:00',1.17),('1444','2014-03-20','08:20:00',1.2),('1444','2014-03-20','08:25:00',1.26),('1444','2014-03-20','08:30:00',1.34),('1444','2014-03-20','08:35:00',1.42),('1444','2014-03-20','08:40:00',1.5),('1444','2014-03-20','08:45:00',1.57),('1444','2014-03-20','08:50:00',1.61),('1444','2014-03-20','08:55:00',1.66),('1444','2014-03-20','09:00:00',1.69),('1444','2014-03-20','09:05:00',1.76),('1444','2014-03-20','09:10:00',1.83),('1444','2014-03-20','09:15:00',1.86),('1444','2014-03-20','09:20:00',1.92),('1444','2014-03-20','09:25:00',1.94),('1444','2014-03-20','09:30:00',1.98),('1444','2014-03-20','09:35:00',2.05),('1444','2014-03-20','09:40:00',2.06),('1444','2014-03-20','09:45:00',2.08),('1444','2014-03-20','09:50:00',2.09),('1444','2014-03-20','09:55:00',2.13),('1444','2014-03-20','10:00:00',2.24),('1444','2014-03-20','10:05:00',2.33),('1444','2014-03-20','10:10:00',2.33),('1444','2014-03-20','10:15:00',2.33),('1444','2014-03-20','10:20:00',2.37),('1444','2014-03-20','10:25:00',2.39),('1444','2014-03-20','10:30:00',2.42),('1444','2014-03-20','10:35:00',2.34),('1444','2014-03-20','10:40:00',2.3),('1444','2014-03-20','10:45:00',2.33),('1444','2014-03-20','10:50:00',2.5),('1444','2014-03-20','10:55:00',2.62),('1444','2014-03-20','11:00:00',2.66),('1444','2014-03-20','11:05:00',2.64),('1444','2014-03-20','11:10:00',2.61),('1444','2014-03-20','11:15:00',2.49),('1444','2014-03-20','11:20:00',2.6),('1444','2014-03-20','11:25:00',2.61),('1444','2014-03-20','11:30:00',2.71),('1444','2014-03-20','11:35:00',2.77),('1444','2014-03-20','11:40:00',2.74),('1444','2014-03-20','11:45:00',2.72),('1444','2014-03-20','11:50:00',2.77),('1444','2014-03-20','11:55:00',2.5),('1444','2014-03-20','12:00:00',2.43),('1444','2014-03-20','12:05:00',2.64),('1444','2014-03-20','12:10:00',2.74),('1444','2014-03-20','12:15:00',2.71),('1444','2014-03-20','12:20:00',2.66),('1444','2014-03-20','12:25:00',2.59),('1444','2014-03-20','12:30:00',2.65),('1444','2014-03-20','12:35:00',2.71),('1444','2014-03-20','12:40:00',2.72),('1444','2014-03-20','12:45:00',2.77),('1444','2014-03-20','12:50:00',2.72),('1444','2014-03-20','12:55:00',2.7),('1444','2014-03-20','13:00:00',2.68),('1444','2014-03-20','13:05:00',2.65),('1444','2014-03-20','13:10:00',2.63),('1444','2014-03-20','13:15:00',2.58),('1444','2014-03-20','13:20:00',2.58),('1444','2014-03-20','13:25:00',2.49),('1444','2014-03-20','13:30:00',2.56),('1444','2014-03-20','13:35:00',2.44),('1444','2014-03-20','13:40:00',2.34),('1444','2014-03-20','13:45:00',2.26),('1444','2014-03-20','13:50:00',2.16),('1444','2014-03-20','13:55:00',1.97),('1444','2014-03-20','14:00:00',2.14),('1444','2014-03-20','14:05:00',2.35),('1444','2014-03-20','14:10:00',2.22),('1444','2014-03-20','14:15:00',2.1),('1444','2014-03-20','14:20:00',2.04),('1444','2014-03-20','14:25:00',2.01),('1444','2014-03-20','14:30:00',1.69),('1444','2014-03-20','14:35:00',1.64),('1444','2014-03-20','14:40:00',1.8),('1444','2014-03-20','14:45:00',1.73),('1444','2014-03-20','14:50:00',1.65),('1444','2014-03-20','14:55:00',1.58),('1444','2014-03-20','15:00:00',1.47),('1444','2014-03-20','15:05:00',1.48),('1444','2014-03-20','15:10:00',1.49),('1444','2014-03-20','15:15:00',1.44),('1444','2014-03-20','15:20:00',1.52),('1444','2014-03-20','15:25:00',1.39),('1444','2014-03-20','15:30:00',1.33),('1444','2014-03-20','15:35:00',1.24),('1444','2014-03-20','15:40:00',1.16),('1444','2014-03-20','15:45:00',1.17),('1444','2014-03-20','15:50:00',1.01),('1444','2014-03-19','09:10:00',1.12),('1444','2014-03-19','09:15:00',1.19),('1444','2014-03-19','09:20:00',1.22),('1444','2014-03-19','09:25:00',2.32),('1444','2014-03-19','09:30:00',2.18),('1444','2014-03-19','09:35:00',2.53),('1444','2014-03-19','09:40:00',2.24),('1444','2014-03-19','09:45:00',1.84),('1444','2014-03-19','09:50:00',1.79),('1444','2014-03-19','09:55:00',1.19),('1444','2014-03-19','10:30:00',1.34),('1444','2014-03-19','10:35:00',1.79),('1444','2014-03-19','10:40:00',1.2),('1444','2014-03-19','10:45:00',1.13),('1444','2014-03-19','10:50:00',1.08),('1444','2014-03-19','10:55:00',1.26),('1444','2014-03-19','11:00:00',3.07),('1444','2014-03-19','11:05:00',3),('1444','2014-03-19','11:10:00',1.49),('1444','2014-03-19','11:15:00',1.5),('1444','2014-03-19','11:20:00',1.3),('1444','2014-03-19','11:25:00',1.46),('1444','2014-03-19','11:30:00',1.85),('1444','2014-03-19','11:35:00',2.5),('1444','2014-03-19','11:40:00',1.54),('1444','2014-03-19','11:45:00',1.44),('1444','2014-03-19','11:50:00',1.32),('1444','2014-03-19','11:55:00',1.27),('1444','2014-03-19','12:00:00',1.79),('1444','2014-03-19','12:05:00',1.51),('1444','2014-03-19','12:10:00',2.2),('1444','2014-03-19','12:15:00',1.24),('1444','2014-03-19','12:20:00',2.17),('1444','2014-03-19','12:25:00',2.93),('1444','2014-03-19','12:30:00',2.65),('1444','2014-03-19','12:35:00',1.97),('1444','2014-03-19','12:40:00',2.93),('1444','2014-03-19','12:45:00',1.61),('1444','2014-03-19','12:50:00',1.83),('1444','2014-03-19','12:55:00',2.93),('1444','2014-03-19','13:00:00',2.69),('1444','2014-03-19','13:05:00',2.65),('1444','2014-03-19','13:10:00',2.62),('1444','2014-03-19','13:15:00',2.12),('1444','2014-03-19','13:20:00',2.47),('1444','2014-03-19','13:25:00',2.28),('1444','2014-03-19','13:30:00',2.54),('1444','2014-03-19','13:35:00',2.53),('1444','2014-03-19','13:40:00',2.5),('1444','2014-03-19','13:45:00',2.49),('1444','2014-03-19','13:50:00',2.38),('1444','2014-03-19','13:55:00',2.47),('1444','2014-03-19','14:00:00',2.27),('1444','2014-03-19','14:05:00',2.43),('1444','2014-03-19','14:10:00',2.38),('1444','2014-03-19','14:15:00',2.31),('1444','2014-03-19','14:20:00',2.29),('1444','2014-03-19','14:25:00',2.25),('1444','2014-03-19','14:30:00',2.16),('1444','2014-03-19','14:35:00',2.2),('1444','2014-03-19','14:40:00',2.14),('1444','2014-03-19','14:45:00',2.08),('1444','2014-03-19','14:50:00',1.98),('1444','2014-03-19','14:55:00',1.92),('1444','2014-03-19','15:00:00',1.87),('1444','2014-03-19','15:05:00',1.83),('1444','2014-03-19','15:10:00',1.79),('1444','2014-03-19','15:15:00',1.73),('1444','2014-03-19','15:20:00',1.69),('1444','2014-03-19','15:25:00',1.7),('1444','2014-03-19','15:30:00',1.63),('1444','2014-03-19','15:35:00',1.53),('1444','2014-03-19','15:40:00',1.52),('1444','2014-03-19','15:45:00',1.46),('1444','2014-03-19','15:50:00',1.4),('1444','2014-03-19','15:55:00',1.37),('1444','2014-03-19','16:00:00',1.3),('1444','2014-03-19','16:05:00',1.24),('1444','2014-03-19','16:10:00',1.18),('1444','2014-03-19','16:15:00',1.13),('1444','2014-03-19','16:20:00',1.04),('1444','2014-03-18','08:15:00',1.03),('1444','2014-03-18','08:50:00',1.89),('1444','2014-03-18','08:55:00',1.86),('1444','2014-03-18','09:00:00',1.52),('1444','2014-03-18','09:05:00',1.31),('1444','2014-03-18','09:10:00',1.92),('1444','2014-03-18','09:15:00',1.35),('1444','2014-03-18','09:20:00',1.49),('1444','2014-03-18','09:25:00',1.05),('1444','2014-03-18','09:30:00',1.66),('1444','2014-03-18','09:40:00',1.06),('1444','2014-03-18','09:45:00',1.48),('1444','2014-03-18','09:50:00',1.03),('1444','2014-03-18','10:00:00',2.35),('1444','2014-03-18','10:05:00',2.35),('1444','2014-03-18','10:10:00',1.87),('1444','2014-03-18','10:15:00',2.27),('1444','2014-03-18','10:20:00',2.65),('1444','2014-03-18','10:25:00',2.94),('1444','2014-03-18','10:30:00',2.52),('1444','2014-03-18','10:35:00',1.86),('1444','2014-03-18','10:40:00',1.61),('1444','2014-03-18','10:45:00',2),('1444','2014-03-18','10:50:00',2.75),('1444','2014-03-18','10:55:00',1.7),('1444','2014-03-18','11:00:00',1.47),('1444','2014-03-18','11:05:00',2.48),('1444','2014-03-18','11:10:00',1.68),('1444','2014-03-18','11:15:00',1.83),('1444','2014-03-18','11:20:00',2.05),('1444','2014-03-18','11:25:00',1.59),('1444','2014-03-18','11:30:00',2.16),('1444','2014-03-18','11:35:00',2.62),('1444','2014-03-18','11:40:00',1.29),('1444','2014-03-18','11:45:00',2.97),('1444','2014-03-18','11:50:00',2.08),('1444','2014-03-18','11:55:00',2.09),('1444','2014-03-18','12:00:00',2.6),('1444','2014-03-18','12:05:00',2.34),('1444','2014-03-18','12:10:00',1.24),('1444','2014-03-18','12:15:00',1.35),('1444','2014-03-18','12:20:00',1.1),('1444','2014-03-18','12:25:00',1.08),('1444','2014-03-18','12:30:00',1.97),('1444','2014-03-18','12:35:00',1.25),('1444','2014-03-18','12:40:00',2.17),('1444','2014-03-18','12:45:00',2.91),('1444','2014-03-18','12:50:00',2.81),('1444','2014-03-18','12:55:00',2.85),('1444','2014-03-18','13:00:00',2.81),('1444','2014-03-18','13:05:00',2.75),('1444','2014-03-18','13:10:00',2.76),('1444','2014-03-18','13:15:00',2.78),('1444','2014-03-18','13:20:00',2.58),('1444','2014-03-18','13:25:00',2.45),('1444','2014-03-18','13:30:00',2.61),('1444','2014-03-18','13:35:00',2.57),('1444','2014-03-18','13:40:00',2.57),('1444','2014-03-18','13:45:00',2.48),('1444','2014-03-18','13:50:00',2.48),('1444','2014-03-18','13:55:00',2.4),('1444','2014-03-18','14:00:00',2.34),('1444','2014-03-18','14:05:00',2.35),('1444','2014-03-18','14:10:00',2.32),('1444','2014-03-18','14:15:00',2.28),('1444','2014-03-18','14:20:00',2.25),('1444','2014-03-18','14:25:00',2.24),('1444','2014-03-18','14:30:00',2.2),('1444','2014-03-18','14:35:00',2.15),('1444','2014-03-18','14:40:00',2.09),('1444','2014-03-18','14:45:00',2.12),('1444','2014-03-18','14:50:00',2.09),('1444','2014-03-18','14:55:00',2.03),('1444','2014-03-18','15:00:00',1.97),('1444','2014-03-18','15:05:00',1.92),('1444','2014-03-18','15:10:00',1.87),('1444','2014-03-18','15:15:00',1.83),('1444','2014-03-18','15:20:00',1.78),('1444','2014-03-18','15:25:00',1.69),('1444','2014-03-18','15:30:00',1.66),('1444','2014-03-18','15:35:00',1.59),('1444','2014-03-18','15:40:00',1.52),('1444','2014-03-18','15:45:00',1.48),('1444','2014-03-18','15:50:00',1.42),('1444','2014-03-18','15:55:00',1.35),('1444','2014-03-18','16:00:00',1.31),('1444','2014-03-18','16:05:00',1.24),('1444','2014-03-18','16:10:00',1.18),('1444','2014-03-18','16:15:00',1.1),('1444','2014-03-18','16:20:00',1.05),('1444','2014-03-18','16:25:00',1),('1444','2012-12-31','10:10:00',1.03),('1444','2012-12-31','10:15:00',1.2),('1444','2012-12-31','10:20:00',1.21),('1444','2012-12-31','10:25:00',1.23),('1444','2012-12-31','10:30:00',1.25),('1444','2012-12-31','10:35:00',1.28),('1444','2012-12-31','10:40:00',1.31),('1444','2012-12-31','10:45:00',1.31),('1444','2012-12-31','10:50:00',1.35),('1444','2012-12-31','10:55:00',1.39),('1444','2012-12-31','11:00:00',1.41),('1444','2012-12-31','11:05:00',1.38),('1444','2012-12-31','11:10:00',1.39),('1444','2012-12-31','11:15:00',1.46),('1444','2012-12-31','11:20:00',1.48),('1444','2012-12-31','11:25:00',1.5),('1444','2012-12-31','11:30:00',1.51),('1444','2012-12-31','11:35:00',1.52),('1444','2012-12-31','11:40:00',1.54),('1444','2012-12-31','11:45:00',1.55),('1444','2012-12-31','11:50:00',1.55),('1444','2012-12-31','11:55:00',1.56),('1444','2012-12-31','12:00:00',1.56),('1444','2012-12-31','12:05:00',1.56),('1444','2012-12-31','12:10:00',1.55),('1444','2012-12-31','12:15:00',1.55),('1444','2012-12-31','12:20:00',1.55),('1444','2012-12-31','12:25:00',1.52),('1444','2012-12-31','12:30:00',1.52),('1444','2012-12-31','12:35:00',1.5),('1444','2012-12-31','12:40:00',1.47),('1444','2012-12-31','12:45:00',1.49),('1444','2012-12-31','12:50:00',1.45),('1444','2012-12-31','12:55:00',1.41),('1444','2012-12-31','13:00:00',1.41),('1444','2012-12-31','13:05:00',1.4),('1444','2012-12-31','13:10:00',1.36),('1444','2012-12-31','13:15:00',1.36),('1444','2012-12-31','13:20:00',1.31),('1444','2012-12-31','13:25:00',1.26),('1444','2012-12-31','13:30:00',1.24),('1444','2012-12-31','13:35:00',1.21),('1444','2012-12-31','13:40:00',1.18),('1444','2012-12-31','13:45:00',1.17),('1444','2012-12-31','13:50:00',1.15),('1444','2012-12-31','13:55:00',1.11),('1444','2012-12-31','14:00:00',1.09),('1444','2012-12-31','14:05:00',1.04),('1444','2012-12-31','14:10:00',1.03),('1444','2012-12-31','14:15:00',1.02),('1444','2012-12-30','10:05:00',1.01),('1444','2012-12-30','10:10:00',1.04),('1444','2012-12-30','10:15:00',1.09),('1444','2012-12-30','10:20:00',1.12),('1444','2012-12-30','10:25:00',1.16),('1444','2012-12-30','10:30:00',1.2),('1444','2012-12-30','10:35:00',1.24),('1444','2012-12-30','10:40:00',1.28),('1444','2012-12-30','10:45:00',1.32),('1444','2012-12-30','10:50:00',1.35),('1444','2012-12-30','10:55:00',1.38),('1444','2012-12-30','11:00:00',1.41),('1444','2012-12-30','11:05:00',1.43),('1444','2012-12-30','11:10:00',1.44),('1444','2012-12-30','11:15:00',1.46),('1444','2012-12-30','11:20:00',1.48),('1444','2012-12-30','11:25:00',1.48),('1444','2012-12-30','11:30:00',1.5),('1444','2012-12-30','11:35:00',1.52),('1444','2012-12-30','11:40:00',1.52),('1444','2012-12-30','11:45:00',1.54),('1444','2012-12-30','11:50:00',1.55),('1444','2012-12-30','11:55:00',1.55),('1444','2012-12-30','12:00:00',1.56),('1444','2012-12-30','12:05:00',1.53),('1444','2012-12-30','12:10:00',1.51),('1444','2012-12-30','12:15:00',1.51),('1444','2012-12-30','12:20:00',1.5),('1444','2012-12-30','12:25:00',1.47),('1444','2012-12-30','12:30:00',1.46),('1444','2012-12-30','12:35:00',1.45),('1444','2012-12-30','12:40:00',1.44),('1444','2012-12-30','12:45:00',1.43),('1444','2012-12-30','12:50:00',1.37),('1444','2012-12-30','12:55:00',1.37),('1444','2012-12-30','13:00:00',1.39),('1444','2012-12-30','13:05:00',1.39),('1444','2012-12-30','13:10:00',1.35),('1444','2012-12-30','13:15:00',1.34),('1444','2012-12-30','13:20:00',1.29),('1444','2012-12-30','13:25:00',1.28),('1444','2012-12-30','13:30:00',1.23),('1444','2012-12-30','13:35:00',1.2),('1444','2012-12-30','13:40:00',1.17),('1444','2012-12-30','13:45:00',1.19),('1444','2012-12-30','13:50:00',1.16),('1444','2012-12-30','13:55:00',1.11),('1444','2012-12-30','14:00:00',1.1),('1444','2012-12-30','14:05:00',1.07),('1444','2012-12-30','14:10:00',1.05),('1444','2012-12-30','14:15:00',1.02),('1444','2012-12-29','10:00:00',1),('1444','2012-12-29','10:05:00',1.04),('1444','2012-12-29','10:10:00',1.08),('1444','2012-12-29','10:15:00',1.12),('1444','2012-12-29','10:20:00',1.15),('1444','2012-12-29','10:25:00',1.18),('1444','2012-12-29','10:30:00',1.22),('1444','2012-12-29','10:35:00',1.25),('1444','2012-12-29','10:40:00',1.29),('1444','2012-12-29','10:45:00',1.33),('1444','2012-12-29','10:50:00',1.37),('1444','2012-12-29','10:55:00',1.41),('1444','2012-12-29','11:00:00',1.42),('1444','2012-12-29','11:05:00',1.43),('1444','2012-12-29','11:10:00',1.46),('1444','2012-12-29','11:15:00',1.48),('1444','2012-12-29','11:20:00',1.5),('1444','2012-12-29','11:25:00',1.51),('1444','2012-12-29','11:30:00',1.52),('1444','2012-12-29','11:35:00',1.54),('1444','2012-12-29','11:40:00',1.55),('1444','2012-12-29','11:45:00',1.55),('1444','2012-12-29','11:50:00',1.56),('1444','2012-12-29','11:55:00',1.56),('1444','2012-12-29','12:00:00',1.57),('1444','2012-12-29','12:05:00',1.56),('1444','2012-12-29','12:10:00',1.56),('1444','2012-12-29','12:15:00',1.56),('1444','2012-12-29','12:20:00',1.51),('1444','2012-12-29','12:25:00',1.5),('1444','2012-12-29','12:30:00',1.49),('1444','2012-12-29','12:35:00',1.47),('1444','2012-12-29','12:40:00',1.48),('1444','2012-12-29','12:45:00',1.47),('1444','2012-12-29','12:50:00',1.4),('1444','2012-12-29','12:55:00',1.41),('1444','2012-12-29','13:00:00',1.42),('1444','2012-12-29','13:05:00',1.4),('1444','2012-12-29','13:10:00',1.37),('1444','2012-12-29','13:15:00',1.36),('1444','2012-12-29','13:20:00',1.29),('1444','2012-12-29','13:25:00',1.27),('1444','2012-12-29','13:30:00',1.25),('1444','2012-12-29','13:35:00',1.25),('1444','2012-12-29','13:40:00',1.22),('1444','2012-12-29','13:45:00',1.19),('1444','2012-12-29','13:50:00',1.16),('1444','2012-12-29','13:55:00',1.11),('1444','2012-12-29','14:00:00',1.1),('1444','2012-12-29','14:05:00',1.08),('1444','2012-12-29','14:10:00',1.05),('1444','2012-12-29','14:15:00',1.03),('1444','2012-12-28','10:15:00',1.03),('1444','2012-12-28','10:20:00',1.07),('1444','2012-12-28','10:25:00',1.11),('1444','2012-12-28','10:30:00',1.14),('1444','2012-12-28','10:35:00',1.19),('1444','2012-12-28','10:40:00',1.23),('1444','2012-12-28','10:45:00',1.25),('1444','2012-12-28','10:50:00',1.29),('1444','2012-12-28','10:55:00',1.34),('1444','2012-12-28','11:00:00',1.35),('1444','2012-12-28','11:05:00',1.37),('1444','2012-12-28','11:10:00',1.4),('1444','2012-12-28','11:15:00',1.26),('1444','2012-12-28','11:20:00',1.43),('1444','2012-12-28','11:25:00',1.46),('1444','2012-12-28','11:30:00',1.43),('1444','2012-12-28','11:35:00',1.39),('1444','2012-12-28','11:40:00',1.49),('1444','2012-12-28','11:45:00',1.49),('1444','2012-12-28','11:50:00',1.5),('1444','2012-12-28','11:55:00',1.52),('1444','2012-12-28','12:00:00',1.57),('1444','2012-12-28','12:05:00',1.48),('1444','2012-12-28','12:10:00',1.47),('1444','2012-12-28','12:15:00',1.48),('1444','2012-12-28','12:20:00',1.46),('1444','2012-12-28','12:25:00',1.46),('1444','2012-12-28','12:30:00',1.44),('1444','2012-12-28','12:35:00',1.4),('1444','2012-12-28','12:40:00',1.43),('1444','2012-12-28','12:45:00',1.41),('1444','2012-12-28','12:50:00',1.35),('1444','2012-12-28','12:55:00',1.31),('1444','2012-12-28','13:00:00',1.3),('1444','2012-12-28','13:05:00',1.3),('1444','2012-12-28','13:10:00',1.3),('1444','2012-12-28','13:15:00',1.28),('1444','2012-12-28','13:20:00',1.23),('1444','2012-12-28','13:25:00',1.23),('1444','2012-12-28','13:30:00',1.17),('1444','2012-12-28','13:40:00',1.13),('1444','2012-12-28','13:45:00',1.11),('1444','2012-12-28','13:50:00',1.08),('1444','2012-12-28','13:55:00',1.05),('1444','2012-12-28','14:00:00',1.02),('1444','2012-12-27','09:50:00',1.08),('1444','2012-12-27','09:55:00',1.07),('1444','2012-12-27','10:00:00',1.02),('1444','2012-12-27','10:05:00',1.02),('1444','2012-12-27','10:10:00',1.01),('1444','2012-12-27','10:15:00',1.02),('1444','2012-12-27','10:25:00',1.05),('1444','2012-12-27','10:30:00',1.09),('1444','2012-12-27','10:35:00',1.08),('1444','2012-12-27','10:40:00',1.18),('1444','2012-12-27','10:45:00',1.22),('1444','2012-12-27','10:50:00',1.21),('1444','2012-12-27','11:00:00',1.33),('1444','2012-12-27','11:05:00',1.09),('1444','2012-12-27','11:50:00',1.27),('1444','2012-12-27','11:55:00',1.34),('1444','2012-12-27','12:00:00',1.47),('1444','2012-12-27','12:05:00',1.52),('1444','2012-12-27','12:10:00',1.43),('1444','2012-12-27','12:25:00',1.32),('1444','2012-12-27','12:30:00',1.4),('1444','2012-12-27','12:35:00',1.38),('1444','2012-12-27','12:40:00',1.46),('1444','2012-12-27','12:45:00',1.67),('1444','2012-12-27','12:50:00',1.38),('1444','2012-12-27','12:55:00',1.26),('1444','2012-12-27','13:00:00',1.4),('1444','2012-12-27','13:05:00',1.48),('1444','2012-12-27','13:10:00',1.47),('1444','2012-12-27','13:15:00',1.56),('1444','2012-12-27','13:20:00',1.56),('1444','2012-12-27','13:25:00',1.47),('1444','2012-12-27','13:30:00',1.29),('1444','2012-12-27','14:00:00',1.28),('1444','2012-12-27','14:05:00',1.15),('1444','2012-12-27','14:10:00',1.27),('1444','2012-12-27','14:15:00',1),('1444','2012-12-26','10:10:00',1.01),('1444','2012-12-26','10:15:00',1.04),('1444','2012-12-26','10:20:00',1.07),('1444','2012-12-26','10:25:00',1.08),('1444','2012-12-26','10:30:00',1.12),('1444','2012-12-26','10:35:00',1.15),('1444','2012-12-26','10:40:00',1.19),('1444','2012-12-26','10:45:00',1.21),('1444','2012-12-26','10:50:00',1.24),('1444','2012-12-26','10:55:00',1.27),('1444','2012-12-26','11:00:00',1.28),('1444','2012-12-26','11:05:00',1.31),('1444','2012-12-26','11:10:00',1.31),('1444','2012-12-26','11:15:00',1.33),('1444','2012-12-26','11:20:00',1.34),('1444','2012-12-26','11:25:00',1.37),('1444','2012-12-26','11:30:00',1.38),('1444','2012-12-26','11:35:00',1.38),('1444','2012-12-26','11:40:00',1.41),('1444','2012-12-26','11:45:00',1.42),('1444','2012-12-26','11:50:00',1.45),('1444','2012-12-26','11:55:00',1.48),('1444','2012-12-26','12:00:00',1.49),('1444','2012-12-26','12:05:00',1.47),('1444','2012-12-26','12:10:00',1.46),('1444','2012-12-26','12:15:00',1.44),('1444','2012-12-26','12:20:00',1.43),('1444','2012-12-26','12:25:00',1.43),('1444','2012-12-26','12:30:00',1.42),('1444','2012-12-26','12:35:00',1.39),('1444','2012-12-26','12:40:00',1.42),('1444','2012-12-26','12:45:00',1.39),('1444','2012-12-26','12:50:00',1.33),('1444','2012-12-26','12:55:00',1.13),('1444','2012-12-26','13:00:00',1.37),('1444','2012-12-26','13:10:00',1.32),('1444','2012-12-26','13:15:00',1.2),('1444','2012-12-26','13:20:00',1.37),('1444','2012-12-26','13:25:00',1.29),('1444','2012-12-26','13:30:00',1.44),('1444','2012-12-26','13:35:00',1.44),('1444','2012-12-26','13:40:00',1.45),('1444','2012-12-26','13:45:00',1.46),('1444','2012-12-26','13:50:00',1.42),('1444','2012-12-26','13:55:00',1.33),('1444','2012-12-26','14:00:00',1.42),('1444','2012-12-26','14:05:00',1.34),('1444','2012-12-23','10:05:00',1),('1444','2012-12-23','10:10:00',1.05),('1444','2012-12-23','10:15:00',1.07),('1444','2012-12-23','10:20:00',1.1),('1444','2012-12-23','10:25:00',1.1),('1444','2012-12-23','10:30:00',1.11),('1444','2012-12-23','10:35:00',1.14),('1444','2012-12-23','10:40:00',1.22),('1444','2012-12-23','10:45:00',1.25),('1444','2012-12-23','10:50:00',1.28),('1444','2012-12-23','10:55:00',1.24),('1444','2012-12-23','11:00:00',1.32),('1444','2012-12-23','11:05:00',1.35),('1444','2012-12-23','11:10:00',1.36),('1444','2012-12-23','11:15:00',1.41),('1444','2012-12-23','11:20:00',1.44),('1444','2012-12-23','11:25:00',1.31),('1444','2012-12-23','11:30:00',1.39),('1444','2012-12-23','11:35:00',1.48),('1444','2012-12-23','11:40:00',1.5),('1444','2012-12-23','11:45:00',1.47),('1444','2012-12-23','11:50:00',1.53),('1444','2012-12-23','11:55:00',1.43),('1444','2012-12-23','12:00:00',1.36),('1444','2012-12-23','12:05:00',1.34),('1444','2012-12-23','12:10:00',1.35),('1444','2012-12-23','12:20:00',1.16),('1444','2012-12-23','12:55:00',1.34),('1444','2012-12-23','13:00:00',1.41),('1444','2012-12-23','13:05:00',1.22),('1444','2012-12-23','13:10:00',1.24),('1444','2012-12-23','13:15:00',1.12),('1444','2012-12-23','14:00:00',1.17),('1444','2012-12-23','14:05:00',1.04),('1444','2014-05-01','08:00:00',1.15),('1444','2014-05-01','08:05:00',1.21),('1444','2014-05-01','08:10:00',1.19),('1444','2014-05-01','08:15:00',1.29),('1444','2014-05-01','08:20:00',1.36),('1444','2014-05-01','08:25:00',1.43),('1444','2014-05-01','08:30:00',1.5),('1444','2014-05-01','08:35:00',1.56),('1444','2014-05-01','08:40:00',1.63),('1444','2014-05-01','08:45:00',1.69),('1444','2014-05-01','08:50:00',1.88),('1444','2014-05-01','08:55:00',1.81),('1444','2014-05-01','09:00:00',1.09),('1444','2014-05-01','09:05:00',1.12),('1444','2014-05-01','09:10:00',1.42),('1444','2014-05-01','09:15:00',1.14),('1444','2014-05-01','09:25:00',1.12),('1444','2014-05-01','09:30:00',2.12),('1444','2014-05-01','09:35:00',2.32),('1444','2014-05-01','09:40:00',2.67),('1444','2014-05-01','09:45:00',1.84),('1444','2014-05-01','09:50:00',2.17),('1444','2014-05-01','09:55:00',2.16),('1444','2014-05-01','10:00:00',1.37),('1444','2014-05-01','10:05:00',1.02),('1444','2014-05-01','10:10:00',1.23),('1444','2014-05-01','10:15:00',2.19),('1444','2014-05-01','10:20:00',2.18),('1444','2014-05-01','10:25:00',1.28),('1444','2014-05-01','10:30:00',1.69),('1444','2014-05-01','10:35:00',2.46),('1444','2014-05-01','10:40:00',2.27),('1444','2014-05-01','10:45:00',2.7),('1444','2014-05-01','10:50:00',3.25),('1444','2014-05-01','10:55:00',3.37),('1444','2014-05-01','11:00:00',2.15),('1444','2014-05-01','11:05:00',1.66),('1444','2014-05-01','11:10:00',2.95),('1444','2014-05-01','11:20:00',1.31),('1444','2014-05-01','11:25:00',3.58),('1444','2014-05-01','11:30:00',2.56),('1444','2014-05-01','11:35:00',2.15),('1444','2014-05-01','11:45:00',2.54),('1444','2014-05-01','11:50:00',3.79),('1444','2014-05-01','11:55:00',1.88),('1444','2014-05-01','12:05:00',3.17),('1444','2014-05-01','12:10:00',2.92),('1444','2014-05-01','12:15:00',3.69),('1444','2014-05-01','12:20:00',3.59),('1444','2014-05-01','12:25:00',3.2),('1444','2014-05-01','12:30:00',1.23),('1444','2014-05-01','12:35:00',2.23),('1444','2014-05-01','12:40:00',3.89),('1444','2014-05-01','12:45:00',2.7),('1444','2014-05-01','12:50:00',3.17),('1444','2014-05-01','12:55:00',3.83),('1444','2014-05-01','13:00:00',3.72),('1444','2014-05-01','13:05:00',3.64),('1444','2014-05-01','13:10:00',3.73),('1444','2014-05-01','13:15:00',3.62),('1444','2014-05-01','13:20:00',3.37),('1444','2014-05-01','13:25:00',1.61),('1444','2014-05-01','13:30:00',1.94),('1444','2014-05-01','13:35:00',3.15),('1444','2014-05-01','13:40:00',3.62),('1444','2014-05-01','13:45:00',3.74),('1444','2014-05-01','13:50:00',3.53),('1444','2014-05-01','13:55:00',2.98),('1444','2014-05-01','14:00:00',3.78),('1444','2014-05-01','14:05:00',3.51),('1444','2014-05-01','14:10:00',3.43),('1444','2014-05-01','14:15:00',3.37),('1444','2014-05-01','14:20:00',3.32),('1444','2014-05-01','14:25:00',3.33),('1444','2014-05-01','14:30:00',3.21),('1444','2014-05-01','14:35:00',3.15),('1444','2014-05-01','14:40:00',3.37),('1444','2014-05-01','14:45:00',3.37),('1444','2014-05-01','14:50:00',3.33),('1444','2014-05-01','14:55:00',2.82),('1444','2014-05-01','15:00:00',2.83),('1444','2014-05-01','15:05:00',3.3),('1444','2014-05-01','15:10:00',3.18),('1444','2014-05-01','15:15:00',2.27),('1444','2014-05-01','15:20:00',3.04),('1444','2014-05-01','15:25:00',2.96),('1444','2014-05-01','15:30:00',2.91),('1444','2014-05-01','15:35:00',2.86),('1444','2014-05-01','15:40:00',2.82),('1444','2014-05-01','15:45:00',2.71),('1444','2014-05-01','15:50:00',2.77),('1444','2014-05-01','15:55:00',2.62),('1444','2014-05-01','16:00:00',2.64),('1444','2014-05-01','16:05:00',2.62),('1444','2014-05-01','16:10:00',2.49),('1444','2014-05-01','16:15:00',2.46),('1444','2014-05-01','16:20:00',2.35),('1444','2014-05-01','16:25:00',2.15),('1444','2014-05-01','16:30:00',2.26),('1444','2014-05-01','16:35:00',2.3),('1444','2014-05-01','16:40:00',2.15),('1444','2014-05-01','16:45:00',1.82),('1444','2014-05-01','16:50:00',1.49),('1444','2014-05-01','16:55:00',1.92),('1444','2014-05-01','17:00:00',1.86),('1444','2014-05-01','17:05:00',1.75),('1444','2014-05-01','17:10:00',1.89),('1444','2014-05-01','17:15:00',1.8),('1444','2014-05-01','17:20:00',1.72),('1444','2014-05-01','17:25:00',1.66),('1444','2014-05-01','17:30:00',1.59),('1444','2014-05-01','17:35:00',1.52),('1444','2014-05-01','17:40:00',1.44),('1444','2014-05-01','17:45:00',1.37),('1444','2014-05-01','17:50:00',1.31),('1444','2014-05-01','17:55:00',1.25),('1444','2014-05-01','18:00:00',1.19),('1444','2014-05-01','18:05:00',1.14),('1444','2014-05-01','18:10:00',1.03),('1444','2014-03-17','09:25:00',1.1),('1444','2014-03-17','09:30:00',1.15),('1444','2014-03-17','09:35:00',1.02),('1444','2014-03-17','09:45:00',1.05),('1444','2014-03-17','09:50:00',1.64),('1444','2014-03-17','09:55:00',1.4),('1444','2014-03-17','10:00:00',1.42),('1444','2014-03-17','10:05:00',1.35),('1444','2014-03-17','10:10:00',1.22),('1444','2014-03-17','10:15:00',1.34),('1444','2014-03-17','10:20:00',1.43),('1444','2014-03-17','10:25:00',1.22),('1444','2014-03-17','10:30:00',1.06),('1444','2014-03-17','10:40:00',1.13),('1444','2014-03-17','10:45:00',1.33),('1444','2014-03-17','10:50:00',1.13),('1444','2014-03-17','10:55:00',1.23),('1444','2014-03-17','11:00:00',1.3),('1444','2014-03-17','11:05:00',1.12),('1444','2014-03-17','11:10:00',1.55),('1444','2014-03-17','11:15:00',1.02),('1444','2014-03-17','11:25:00',1.29),('1444','2014-03-17','11:30:00',1.28),('1444','2014-03-17','11:35:00',1.07),('1444','2014-03-17','11:45:00',1.33),('1444','2014-03-17','11:50:00',1.86),('1444','2014-03-17','11:55:00',1.35),('1444','2014-03-17','12:00:00',1.32),('1444','2014-03-17','12:05:00',1.22),('1444','2014-03-17','12:10:00',1.06),('1444','2014-03-17','12:15:00',1.34),('1444','2014-03-17','12:20:00',3.03),('1444','2014-03-17','12:25:00',1.33),('1444','2014-03-17','12:30:00',1.44),('1444','2014-03-17','12:35:00',1.32),('1444','2014-03-17','12:40:00',2.03),('1444','2014-03-17','12:45:00',1.97),('1444','2014-03-17','12:50:00',2.31),('1444','2014-03-17','12:55:00',2.75),('1444','2014-03-17','13:00:00',1.46),('1444','2014-03-17','13:05:00',1.56),('1444','2014-03-17','13:10:00',2.56),('1444','2014-03-17','13:15:00',2.71),('1444','2014-03-17','13:20:00',2.29),('1444','2014-03-17','13:25:00',2.74),('1444','2014-03-17','13:30:00',2.72),('1444','2014-03-17','13:35:00',2.65),('1444','2014-03-17','13:40:00',2.62),('1444','2014-03-17','13:45:00',2.53),('1444','2014-03-17','13:50:00',2.53),('1444','2014-03-17','13:55:00',1.87),('1444','2014-03-17','14:00:00',2.41),('1444','2014-03-17','14:05:00',1.41),('1444','2014-03-17','14:15:00',1.97),('1444','2014-03-17','14:20:00',1.45),('1444','2014-03-17','14:25:00',2.29),('1444','2014-03-17','14:30:00',1.09),('1444','2014-03-17','14:35:00',1.68),('1444','2014-03-17','14:40:00',2.11),('1444','2014-03-17','14:45:00',2.11),('1444','2014-03-17','14:50:00',2.12),('1444','2014-03-17','14:55:00',2.04),('1444','2014-03-17','15:00:00',1.99),('1444','2014-03-17','15:05:00',1.95),('1444','2014-03-17','15:10:00',1.89),('1444','2014-03-17','15:20:00',1.78),('1444','2014-03-17','15:25:00',1.69),('1444','2014-03-17','15:30:00',1.56),('1444','2014-03-17','15:35:00',1.49),('1444','2014-03-17','15:40:00',1.45),('1444','2014-03-17','15:50:00',1.24),('1444','2014-03-17','15:55:00',1),('1444','2014-03-17','16:00:00',1.09),('1444','2014-03-17','16:05:00',1.15),('1444','2014-03-17','16:20:00',1.08),('1444','2012-12-22','10:35:00',1.65),('1444','2012-12-22','10:40:00',1.61),('1444','2012-12-22','10:45:00',1.57),('1444','2012-12-22','10:50:00',1.5),('1444','2012-12-22','11:40:00',1.81),('1444','2012-12-22','11:45:00',1.86),('1444','2012-12-22','11:50:00',1.39),('1444','2012-12-22','11:55:00',1.2),('1444','2012-12-22','12:00:00',1.4),('1444','2012-12-22','12:30:00',1.42),('1444','2012-12-22','12:35:00',1.08),('1444','2012-12-22','12:40:00',1.7),('1444','2012-12-22','12:45:00',1.9),('1444','2012-12-22','12:50:00',1.7),('1444','2012-12-22','12:55:00',1.64),('1444','2012-12-22','13:00:00',1.71),('1444','2012-12-22','13:05:00',1.46),('1444','2012-12-22','13:10:00',1.72),('1444','2012-12-22','13:15:00',1.81),('1444','2012-12-22','13:20:00',1.81),('1444','2012-12-22','13:25:00',1.77),('1444','2012-12-22','13:30:00',1.6),('1444','2012-12-22','13:35:00',1.51),('1444','2014-03-16','08:20:00',1.05),('1444','2014-03-16','08:25:00',1.11),('1444','2014-03-16','08:30:00',1.17),('1444','2014-03-16','08:35:00',1.19),('1444','2014-03-16','08:40:00',1.26),('1444','2014-03-16','08:45:00',1.32),('1444','2014-03-16','08:50:00',1.38),('1444','2014-03-16','08:55:00',1.41),('1444','2014-03-16','09:00:00',1.4),('1444','2014-03-16','09:05:00',1.45),('1444','2014-03-16','09:10:00',1.56),('1444','2014-03-16','09:15:00',1.68),('1444','2014-03-16','09:20:00',1.72),('1444','2014-03-16','09:25:00',1.72),('1444','2014-03-16','09:30:00',1.78),('1444','2014-03-16','09:35:00',1.78),('1444','2014-03-16','09:40:00',1.8),('1444','2014-03-16','09:45:00',1.89),('1444','2014-03-16','09:50:00',2.03),('1444','2014-03-16','09:55:00',2.03),('1444','2014-03-16','10:00:00',2.05),('1444','2014-03-16','10:05:00',2.06),('1444','2014-03-16','10:10:00',2.13),('1444','2014-03-16','10:15:00',2.17),('1444','2014-03-16','10:20:00',2.19),('1444','2014-03-16','10:25:00',2.21),('1444','2014-03-16','10:30:00',2.24),('1444','2014-03-16','10:35:00',2.29),('1444','2014-03-16','10:40:00',2.32),('1444','2014-03-16','10:45:00',2.35),('1444','2014-03-16','10:50:00',2.34),('1444','2014-03-16','10:55:00',2.45),('1444','2014-03-16','11:00:00',2.45),('1444','2014-03-16','11:05:00',2.49),('1444','2014-03-16','11:10:00',2.48),('1444','2014-03-16','11:15:00',2.52),('1444','2014-03-16','11:20:00',2.53),('1444','2014-03-16','11:25:00',2.55),('1444','2014-03-16','11:30:00',2.54),('1444','2014-03-16','11:35:00',2.52),('1444','2014-03-16','11:40:00',2.51),('1444','2014-03-16','11:45:00',2.5),('1444','2014-03-16','11:50:00',2.51),('1444','2014-03-16','11:55:00',2.5),('1444','2014-03-16','12:00:00',2.52),('1444','2014-03-16','12:05:00',2.58),('1444','2014-03-16','12:10:00',2.56),('1444','2014-03-16','12:15:00',2.51),('1444','2014-03-16','12:20:00',2.54),('1444','2014-03-16','12:25:00',2.54),('1444','2014-03-16','12:30:00',2.54),('1444','2014-03-16','12:35:00',2.6),('1444','2014-03-16','12:40:00',2.55),('1444','2014-03-16','12:45:00',2.53),('1444','2014-03-16','12:50:00',2.51),('1444','2014-03-16','12:55:00',2.5),('1444','2014-03-16','13:00:00',2.43),('1444','2014-03-16','13:05:00',2.45),('1444','2014-03-16','13:10:00',2.42),('1444','2014-03-16','13:15:00',2.43),('1444','2014-03-16','13:20:00',2.37),('1444','2014-03-16','13:25:00',2.41),('1444','2014-03-16','13:30:00',2.43),('1444','2014-03-16','13:35:00',2.39),('1444','2014-03-16','13:40:00',2.46),('1444','2014-03-16','13:45:00',2.38),('1444','2014-03-16','13:50:00',2.39),('1444','2014-03-16','13:55:00',2.36),('1444','2014-03-16','14:00:00',2.28),('1444','2014-03-16','14:05:00',2.26),('1444','2014-03-16','14:10:00',2.15),('1444','2014-03-16','14:15:00',2.14),('1444','2014-03-16','14:20:00',2.12),('1444','2014-03-16','14:25:00',2.1),('1444','2014-03-16','14:30:00',2.03),('1444','2014-03-16','14:35:00',1.97),('1444','2014-03-16','14:40:00',1.92),('1444','2014-03-16','14:45:00',1.91),('1444','2014-03-16','14:50:00',1.78),('1444','2014-03-16','14:55:00',1.73),('1444','2014-03-16','15:00:00',1.82),('1444','2014-03-16','15:05:00',1.75),('1444','2014-03-16','15:10:00',1.62),('1444','2014-03-16','15:15:00',1.56),('1444','2014-03-16','15:20:00',1.33),('1444','2014-03-16','15:25:00',1.5),('1444','2014-03-16','15:30:00',1.37),('1444','2014-03-16','15:35:00',1.27),('1444','2014-03-16','15:40:00',1),('1444','2014-03-16','15:50:00',1.07),('1444','2014-03-16','16:10:00',1.05),('1444','2014-03-16','16:15:00',1.03),('1444','2014-03-15','08:20:00',1.03),('1444','2014-03-15','08:25:00',1.08),('1444','2014-03-15','08:30:00',1.13),('1444','2014-03-15','08:35:00',1.18),('1444','2014-03-15','08:40:00',1.24),('1444','2014-03-15','08:45:00',1.28),('1444','2014-03-15','08:50:00',1.34),('1444','2014-03-15','08:55:00',1.39),('1444','2014-03-15','09:00:00',1.45),('1444','2014-03-15','09:05:00',1.49),('1444','2014-03-15','09:10:00',1.56),('1444','2014-03-15','09:15:00',1.61),('1444','2014-03-15','09:20:00',1.67),('1444','2014-03-15','09:25:00',1.71),('1444','2014-03-15','09:30:00',1.74),('1444','2014-03-15','09:35:00',1.8),('1444','2014-03-15','09:40:00',1.84),('1444','2014-03-15','09:45:00',1.87),('1444','2014-03-15','09:50:00',1.9),('1444','2014-03-15','09:55:00',1.93),('1444','2014-03-15','10:00:00',1.99),('1444','2014-03-15','10:05:00',2.04),('1444','2014-03-15','10:10:00',2.07),('1444','2014-03-15','10:15:00',2.11),('1444','2014-03-15','10:20:00',2.14),('1444','2014-03-15','10:25:00',2.14),('1444','2014-03-15','10:30:00',2.2),('1444','2014-03-15','10:35:00',2.22),('1444','2014-03-15','10:40:00',2.23),('1444','2014-03-15','10:45:00',2.3),('1444','2014-03-15','10:50:00',2.3),('1444','2014-03-15','10:55:00',2.32),('1444','2014-03-15','11:00:00',2.38),('1444','2014-03-15','11:05:00',2.4),('1444','2014-03-15','11:10:00',2.38),('1444','2014-03-15','11:15:00',2.48),('1444','2014-03-15','11:20:00',2.47),('1444','2014-03-15','11:25:00',2.5),('1444','2014-03-15','11:30:00',2.46),('1444','2014-03-15','11:35:00',2.51),('1444','2014-03-15','11:40:00',2.52),('1444','2014-03-15','11:45:00',2.54),('1444','2014-03-15','11:50:00',2.5),('1444','2014-03-15','11:55:00',2.5),('1444','2014-03-15','12:00:00',2.53),('1444','2014-03-15','12:05:00',2.47),('1444','2014-03-15','12:10:00',2.48),('1444','2014-03-15','12:15:00',2.5),('1444','2014-03-15','12:20:00',2.49),('1444','2014-03-15','12:25:00',2.54),('1444','2014-03-15','12:30:00',2.55),('1444','2014-03-15','12:35:00',2.54),('1444','2014-03-15','12:40:00',2.55),('1444','2014-03-15','12:45:00',2.54),('1444','2014-03-15','12:50:00',2.54),('1444','2014-03-15','12:55:00',2.53),('1444','2014-03-15','13:00:00',2.53),('1444','2014-03-15','13:05:00',2.53),('1444','2014-03-15','13:10:00',2.56),('1444','2014-03-15','13:15:00',2.54),('1444','2014-03-15','13:20:00',2.51),('1444','2014-03-15','13:25:00',2.48),('1444','2014-03-15','13:30:00',2.49),('1444','2014-03-15','13:35:00',2.46),('1444','2014-03-15','13:40:00',2.45),('1444','2014-03-15','13:45:00',2.42),('1444','2014-03-15','13:50:00',2.39),('1444','2014-03-15','13:55:00',2.38),('1444','2014-03-15','14:00:00',2.36),('1444','2014-03-15','14:05:00',2.33),('1444','2014-03-15','14:10:00',2.3),('1444','2014-03-15','14:15:00',2.23),('1444','2014-03-15','14:20:00',2.17),('1444','2014-03-15','14:25:00',2.12),('1444','2014-03-15','14:30:00',2.06),('1444','2014-03-15','14:35:00',2.04),('1444','2014-03-15','14:40:00',1.99),('1444','2014-03-15','14:45:00',1.91),('1444','2014-03-15','14:50:00',1.84),('1444','2014-03-15','14:55:00',1.85),('1444','2014-03-15','15:00:00',1.81),('1444','2014-03-15','15:05:00',1.78),('1444','2014-03-15','15:10:00',1.71),('1444','2014-03-15','15:15:00',1.64),('1444','2014-03-15','15:20:00',1.6),('1444','2014-03-15','15:25:00',1.54),('1444','2014-03-15','15:30:00',1.5),('1444','2014-03-15','15:35:00',1.44),('1444','2014-03-15','15:40:00',1.39),('1444','2014-03-15','15:45:00',1.34),('1444','2014-03-15','15:50:00',1.27),('1444','2014-03-15','15:55:00',1.2),('1444','2014-03-15','16:00:00',1.15),('1444','2014-03-15','16:05:00',1.04),('1444','2014-03-15','16:10:00',1.01),('1444','2014-03-14','09:05:00',1.01),('1444','2014-03-14','09:10:00',1.11),('1444','2014-03-14','09:15:00',1.16),('1444','2014-03-14','09:20:00',1.13),('1444','2014-03-14','09:25:00',1.15),('1444','2014-03-14','09:30:00',1.15),('1444','2014-03-14','09:35:00',1.33),('1444','2014-03-14','09:40:00',1.64),('1444','2014-03-14','09:45:00',1.93),('1444','2014-03-14','09:50:00',2.25),('1444','2014-03-14','09:55:00',2.35),('1444','2014-03-14','10:00:00',2.52),('1444','2014-03-14','10:05:00',2.52),('1444','2014-03-14','10:10:00',2.46),('1444','2014-03-14','10:15:00',2.39),('1444','2014-03-14','10:20:00',2.34),('1444','2014-03-14','10:25:00',2.22),('1444','2014-03-14','10:30:00',2.24),('1444','2014-03-14','10:35:00',2.35),('1444','2014-03-14','10:40:00',2.44),('1444','2014-03-14','10:45:00',2.02),('1444','2014-03-14','10:50:00',1.41),('1444','2014-03-14','10:55:00',2.03),('1444','2014-03-14','11:00:00',2.31),('1444','2014-03-14','11:05:00',2.47),('1444','2014-03-14','11:10:00',2.71),('1444','2014-03-14','11:15:00',2.67),('1444','2014-03-14','11:20:00',2.59),('1444','2014-03-14','11:25:00',2.5),('1444','2014-03-14','11:30:00',2.54),('1444','2014-03-14','11:35:00',2.58),('1444','2014-03-14','11:40:00',2.66),('1444','2014-03-14','11:45:00',2.72),('1444','2014-03-14','11:50:00',2.78),('1444','2014-03-14','11:55:00',2.74),('1444','2014-03-14','12:00:00',2.74),('1444','2014-03-14','12:05:00',2.71),('1444','2014-03-14','12:10:00',2.55),('1444','2014-03-14','12:15:00',2.44),('1444','2014-03-14','12:20:00',1.91),('1444','2014-03-14','12:25:00',1.68),('1444','2014-03-14','12:30:00',1.52),('1444','2014-03-14','12:35:00',1.32),('1444','2014-03-14','12:40:00',1.62),('1444','2014-03-14','12:45:00',1.95),('1444','2014-03-14','12:50:00',2.21),('1444','2014-03-14','12:55:00',2.31),('1444','2014-03-14','13:00:00',1.53),('1444','2014-03-14','13:05:00',1.48),('1444','2014-03-14','13:10:00',1.71),('1444','2014-03-14','13:15:00',1.87),('1444','2014-03-14','13:20:00',2.1),('1444','2014-03-14','13:25:00',1.86),('1444','2014-03-14','13:30:00',1.75),('1444','2014-03-14','13:35:00',1.51),('1444','2014-03-14','13:40:00',1.55),('1444','2014-03-14','13:45:00',1.65),('1444','2014-03-14','13:50:00',1.67),('1444','2014-03-14','13:55:00',1.54),('1444','2014-03-14','14:00:00',1.91),('1444','2014-03-14','14:05:00',2.12),('1444','2014-03-14','14:10:00',2.01),('1444','2014-03-14','14:15:00',2.09),('1444','2014-03-14','14:20:00',2.13),('1444','2014-03-14','14:25:00',1.9),('1444','2014-03-14','14:30:00',1.82),('1444','2014-03-14','14:35:00',1.75),('1444','2014-03-14','14:40:00',1.4),('1444','2014-03-14','14:45:00',1.19),('1444','2014-03-14','14:50:00',1.13),('1444','2014-03-14','14:55:00',1.03),('1444','2014-03-14','15:30:00',1.03),('1444','2014-03-14','15:35:00',1.21),('1444','2014-03-14','15:40:00',1.12),('1444','2014-03-13','08:15:00',1.05),('1444','2014-03-13','08:20:00',1.16),('1444','2014-03-13','08:25:00',1.21),('1444','2014-03-13','08:30:00',1.28),('1444','2014-03-13','08:35:00',1.34),('1444','2014-03-13','08:40:00',1.4),('1444','2014-03-13','08:45:00',1.45),('1444','2014-03-13','08:50:00',1.51),('1444','2014-03-13','08:55:00',1.57),('1444','2014-03-13','09:00:00',1.65),('1444','2014-03-13','09:05:00',1.71),('1444','2014-03-13','09:10:00',1.76),('1444','2014-03-13','09:15:00',1.81),('1444','2014-03-13','09:20:00',1.86),('1444','2014-03-13','09:25:00',1.9),('1444','2014-03-13','09:30:00',1.95),('1444','2014-03-13','09:35:00',2),('1444','2014-03-13','09:40:00',2.06),('1444','2014-03-13','09:45:00',2.11),('1444','2014-03-13','09:50:00',2.17),('1444','2014-03-13','09:55:00',2.21),('1444','2014-03-13','10:00:00',2.25),('1444','2014-03-13','10:05:00',2.3),('1444','2014-03-13','10:10:00',2.34),('1444','2014-03-13','10:15:00',2.32),('1444','2014-03-13','10:20:00',2.4),('1444','2014-03-13','10:25:00',2.42),('1444','2014-03-13','10:30:00',2.44),('1444','2014-03-13','10:35:00',2.47),('1444','2014-03-13','10:40:00',2.49),('1444','2014-03-13','10:45:00',2.52),('1444','2014-03-13','10:50:00',2.54),('1444','2014-03-13','10:55:00',2.56),('1444','2014-03-13','11:00:00',2.59),('1444','2014-03-13','11:05:00',2.62),('1444','2014-03-13','11:10:00',2.63),('1444','2014-03-13','11:15:00',2.63),('1444','2014-03-13','11:20:00',2.68),('1444','2014-03-13','11:25:00',2.69),('1444','2014-03-13','11:30:00',2.69),('1444','2014-03-13','11:35:00',2.7),('1444','2014-03-13','11:40:00',2.74),('1444','2014-03-13','11:45:00',2.73),('1444','2014-03-13','11:50:00',2.73),('1444','2014-03-13','11:55:00',2.75),('1444','2014-03-13','12:00:00',2.74),('1444','2014-03-13','12:05:00',2.76),('1444','2014-03-13','12:10:00',2.75),('1444','2014-03-13','12:15:00',2.75),('1444','2014-03-13','12:20:00',2.71),('1444','2014-03-13','12:25:00',2.7),('1444','2014-03-13','12:30:00',2.7),('1444','2014-03-13','12:35:00',2.7),('1444','2014-03-13','12:40:00',2.69),('1444','2014-03-13','12:45:00',2.67),('1444','2014-03-13','12:50:00',2.67),('1444','2014-03-13','12:55:00',2.64),('1444','2014-03-13','13:00:00',2.61),('1444','2014-03-13','13:05:00',2.58),('1444','2014-03-13','13:10:00',2.54),('1444','2014-03-13','13:15:00',2.54),('1444','2014-03-13','13:20:00',2.56),('1444','2014-03-13','13:25:00',2.54),('1444','2014-03-13','13:30:00',2.52),('1444','2014-03-13','13:35:00',2.49),('1444','2014-03-13','13:40:00',2.47),('1444','2014-03-13','13:45:00',2.44),('1444','2014-03-13','13:50:00',2.4),('1444','2014-03-13','13:55:00',2.36),('1444','2014-03-13','14:00:00',2.33),('1444','2014-03-13','14:05:00',2.29),('1444','2014-03-13','14:10:00',2.27),('1444','2014-03-13','14:15:00',2.24),('1444','2014-03-13','14:20:00',2.19),('1444','2014-03-13','14:25:00',2.16),('1444','2014-03-13','14:30:00',2.12),('1444','2014-03-13','14:35:00',2.09),('1444','2014-03-13','14:40:00',2.01),('1444','2014-03-13','14:45:00',1.94),('1444','2014-03-13','14:50:00',1.94),('1444','2014-03-13','14:55:00',1.9),('1444','2014-03-13','15:00:00',1.85),('1444','2014-03-13','15:05:00',1.8),('1444','2014-03-13','15:10:00',1.74),('1444','2014-03-13','15:15:00',1.7),('1444','2014-03-13','15:20:00',1.64),('1444','2014-03-13','15:25:00',1.59),('1444','2014-03-13','15:30:00',1.54),('1444','2014-03-13','15:35:00',1.47),('1444','2014-03-13','15:40:00',1.42),('1444','2014-03-13','15:45:00',1.36),('1444','2014-03-13','15:50:00',1.3),('1444','2014-03-13','15:55:00',1.24),('1444','2014-03-13','16:00:00',1.17),('1444','2014-03-13','16:05:00',1.11),('1444','2014-03-13','16:10:00',1.05),('1444','2014-03-12','08:15:00',1.05),('1444','2014-03-12','08:20:00',1.12),('1444','2014-03-12','08:25:00',1.17),('1444','2014-03-12','08:30:00',1.25),('1444','2014-03-12','08:35:00',1.32),('1444','2014-03-12','08:40:00',1.38),('1444','2014-03-12','08:45:00',1.45),('1444','2014-03-12','08:50:00',1.51),('1444','2014-03-12','08:55:00',1.57),('1444','2014-03-12','09:00:00',1.64),('1444','2014-03-12','09:05:00',1.69),('1444','2014-03-12','09:10:00',1.74),('1444','2014-03-12','09:15:00',1.79),('1444','2014-03-12','09:20:00',1.85),('1444','2014-03-12','09:25:00',1.91),('1444','2014-03-12','09:30:00',1.96),('1444','2014-03-12','09:35:00',2),('1444','2014-03-12','09:40:00',2.05),('1444','2014-03-12','09:45:00',2.09),('1444','2014-03-12','09:50:00',2.13),('1444','2014-03-12','09:55:00',2.18),('1444','2014-03-12','10:00:00',2.23),('1444','2014-03-12','10:05:00',2.28),('1444','2014-03-12','10:10:00',2.32),('1444','2014-03-12','10:15:00',2.35),('1444','2014-03-12','10:20:00',2.37),('1444','2014-03-12','10:25:00',2.41),('1444','2014-03-12','10:30:00',2.45),('1444','2014-03-12','10:35:00',2.49),('1444','2014-03-12','10:40:00',2.52),('1444','2014-03-12','10:45:00',2.56),('1444','2014-03-12','10:50:00',2.6),('1444','2014-03-12','10:55:00',2.62),('1444','2014-03-12','11:00:00',2.62),('1444','2014-03-12','11:05:00',2.66),('1444','2014-03-12','11:10:00',2.7),('1444','2014-03-12','11:15:00',2.73),('1444','2014-03-12','11:20:00',2.75),('1444','2014-03-12','11:25:00',2.76),('1444','2014-03-12','11:30:00',2.78),('1444','2014-03-12','11:35:00',2.79),('1444','2014-03-12','11:40:00',2.79),('1444','2014-03-12','11:45:00',2.79),('1444','2014-03-12','11:50:00',2.8),('1444','2014-03-12','11:55:00',2.81),('1444','2014-03-12','12:00:00',2.81),('1444','2014-03-12','12:05:00',2.81),('1444','2014-03-12','12:10:00',2.82),('1444','2014-03-12','12:15:00',2.8),('1444','2014-03-12','12:20:00',2.79),('1444','2014-03-12','12:25:00',2.8),('1444','2014-03-12','12:30:00',2.79),('1444','2014-03-12','12:35:00',2.78),('1444','2014-03-12','12:40:00',2.78),('1444','2014-03-12','12:45:00',2.76),('1444','2014-03-12','12:50:00',2.75),('1444','2014-03-12','12:55:00',2.72),('1444','2014-03-12','13:00:00',2.73),('1444','2014-03-12','13:05:00',2.71),('1444','2014-03-12','13:10:00',2.68),('1444','2014-03-12','13:15:00',2.65),('1444','2014-03-12','13:20:00',2.64),('1444','2014-03-12','13:25:00',2.63),('1444','2014-03-12','13:30:00',2.6),('1444','2014-03-12','13:35:00',2.55),('1444','2014-03-12','13:40:00',2.51),('1444','2014-03-12','13:45:00',2.51),('1444','2014-03-12','13:50:00',2.48),('1444','2014-03-12','13:55:00',2.45),('1444','2014-03-12','14:00:00',2.43),('1444','2014-03-12','14:05:00',2.4),('1444','2014-03-12','14:10:00',2.37),('1444','2014-03-12','14:15:00',2.31),('1444','2014-03-12','14:20:00',2.29),('1444','2014-03-12','14:25:00',2.26),('1444','2014-03-12','14:30:00',2.22),('1444','2014-03-12','14:35:00',2.13),('1444','2014-03-12','14:40:00',2.04),('1444','2014-03-12','14:45:00',2.01),('1444','2014-03-12','14:50:00',1.95),('1444','2014-03-12','14:55:00',1.93),('1444','2014-03-12','15:00:00',1.74),('1444','2014-03-12','15:05:00',1.77),('1444','2014-03-12','15:10:00',1.74),('1444','2014-03-12','15:15:00',1.69),('1444','2014-03-12','15:20:00',1.62),('1444','2014-03-12','15:25:00',1.56),('1444','2014-03-12','15:30:00',1.51),('1444','2014-03-12','15:35:00',1.45),('1444','2014-03-12','15:40:00',1.42),('1444','2014-03-12','15:45:00',1.37),('1444','2014-03-12','15:50:00',1.31),('1444','2014-03-12','15:55:00',1.25),('1444','2014-03-12','16:00:00',1.21),('1444','2014-03-12','16:05:00',1.15),('1444','2014-03-12','16:10:00',1.07),('1444','2014-03-12','16:15:00',1.01),('1444','2014-03-11','12:20:00',1.06),('1444','2014-03-11','12:35:00',1.01),('1444','2014-03-11','12:40:00',1.09),('1444','2014-03-11','12:45:00',1.08),('1444','2014-03-11','12:50:00',1.03),('1444','2014-03-11','13:05:00',1.06),('1444','2014-03-11','13:10:00',1.06),('1444','2014-03-11','13:20:00',1.04),('1444','2014-03-11','13:45:00',1.09),('1444','2014-03-11','13:50:00',1.29),('1444','2014-03-11','13:55:00',1.48),('1444','2014-03-11','14:00:00',1.53),('1444','2014-03-11','14:05:00',1.5),('1444','2014-03-11','14:10:00',1.8),('1444','2014-03-11','14:15:00',2.09),('1444','2014-03-11','14:20:00',1.97),('1444','2014-03-11','14:25:00',1.49),('1444','2014-03-11','14:30:00',1.09),('1444','2014-03-11','14:35:00',1.15),('1444','2014-03-11','14:40:00',1.08),('1444','2014-03-11','14:45:00',1.13),('1444','2014-03-11','14:50:00',1.04),('1444','2014-03-11','14:55:00',1.03),('1444','2014-03-11','15:00:00',1.19),('1444','2014-03-11','15:05:00',1.26),('1444','2014-03-11','15:10:00',1.39),('1444','2014-03-11','15:15:00',1.28),('1444','2014-03-11','15:20:00',1.21),('1444','2014-03-11','15:25:00',1.04),('1444','2014-03-10','13:05:00',1.01),('1444','2014-03-10','13:10:00',1.07),('1444','2014-03-10','13:15:00',1.17),('1444','2014-03-10','13:20:00',1.18),('1444','2014-03-10','13:25:00',1.08),('1444','2014-03-10','13:55:00',1.01),('1444','2014-03-10','14:05:00',1.34),('1444','2014-03-10','14:10:00',1.54),('1444','2014-03-10','14:15:00',2.18),('1444','2014-03-10','14:20:00',1.48),('1444','2014-03-10','14:25:00',1.24),('1444','2014-03-10','14:30:00',1.11),('1444','2014-03-10','14:35:00',1.49),('1444','2014-03-10','14:40:00',2.14),('1444','2014-03-10','14:45:00',2.19),('1444','2014-03-10','14:50:00',1.99),('1444','2014-03-10','15:00:00',1.39),('1444','2014-03-10','15:05:00',1.14),('1444','2014-03-10','15:15:00',1.03),('1444','2014-03-10','15:20:00',1.38),('1444','2014-03-10','15:25:00',1.7),('1444','2014-03-10','15:30:00',1.39),('1444','2014-03-10','15:35:00',1.04),('1444','2014-03-09','08:20:00',1.01),('1444','2014-03-09','08:25:00',1),('1444','2014-03-09','08:55:00',1.18),('1444','2014-03-09','09:00:00',1.45),('1444','2014-03-09','09:05:00',1.42),('1444','2014-03-09','09:15:00',1.71),('1444','2014-03-09','09:20:00',1.84),('1444','2014-03-09','09:25:00',1.94),('1444','2014-03-09','09:30:00',2),('1444','2014-03-09','09:35:00',2.14),('1444','2014-03-09','09:40:00',2.19),('1444','2014-03-09','09:45:00',2.23),('1444','2014-03-09','09:50:00',2.25),('1444','2014-03-09','09:55:00',2.26),('1444','2014-03-09','10:00:00',2.28),('1444','2014-03-09','10:05:00',2.3),('1444','2014-03-09','10:10:00',2.37),('1444','2014-03-09','10:15:00',2.39),('1444','2014-03-09','10:20:00',2.4),('1444','2014-03-09','10:25:00',2.46),('1444','2014-03-09','10:30:00',2.51),('1444','2014-03-09','10:35:00',2.54),('1444','2014-03-09','10:40:00',2.54),('1444','2014-03-09','10:45:00',2.58),('1444','2014-03-09','10:50:00',2.61),('1444','2014-03-09','10:55:00',2.74),('1444','2014-03-09','11:00:00',2.89),('1444','2014-03-09','11:05:00',2.89),('1444','2014-03-09','11:10:00',3),('1444','2014-03-09','11:15:00',3.12),('1444','2014-03-09','11:20:00',2.36),('1444','2014-03-09','11:25:00',1.47),('1444','2014-03-09','11:30:00',1),('1444','2014-03-09','11:35:00',1.85),('1444','2014-03-09','11:40:00',1.71),('1444','2014-03-09','11:45:00',1.19),('1444','2014-03-09','11:50:00',2.44),('1444','2014-03-09','11:55:00',2.47),('1444','2014-03-09','12:00:00',2.63),('1444','2014-03-09','12:05:00',2.58),('1444','2014-03-09','12:10:00',3.11),('1444','2014-03-09','12:15:00',3.14),('1444','2014-03-09','12:20:00',3.21),('1444','2014-03-09','12:25:00',3.14),('1444','2014-03-09','12:30:00',3.13),('1444','2014-03-09','12:35:00',3.27),('1444','2014-03-09','12:40:00',3.09),('1444','2014-03-09','12:45:00',3.01),('1444','2014-03-09','12:50:00',3.02),('1444','2014-03-09','12:55:00',3.05),('1444','2014-03-09','13:00:00',3.14),('1444','2014-03-09','13:05:00',3.15),('1444','2014-03-09','13:10:00',3.08),('1444','2014-03-09','13:15:00',2.92),('1444','2014-03-09','13:20:00',2.89),('1444','2014-03-09','13:25:00',2.78),('1444','2014-03-09','13:30:00',2.8),('1444','2014-03-09','13:35:00',2.59),('1444','2014-03-09','13:40:00',1.08),('1444','2014-03-09','13:50:00',2.28),('1444','2014-03-09','14:05:00',2.59),('1444','2014-03-09','14:10:00',2.48),('1444','2014-03-09','14:15:00',2.42),('1444','2014-03-09','14:20:00',1.3),('1444','2014-03-09','14:25:00',2.54),('1444','2014-03-09','14:30:00',1.55),('1444','2014-03-09','14:45:00',1.25),('1444','2014-03-09','14:50:00',1.36),('1444','2014-03-09','14:55:00',2.09),('1444','2014-03-09','15:00:00',2.02),('1444','2014-03-09','15:05:00',1.95),('1444','2014-03-09','15:10:00',1.86),('1444','2014-03-09','15:15:00',1.81),('1444','2014-03-09','15:20:00',1.77),('1444','2014-03-09','15:25:00',1.76),('1444','2014-03-09','15:30:00',1.71),('1444','2014-03-09','15:35:00',1.62),('1444','2014-03-09','15:40:00',1.53),('1444','2014-03-09','15:45:00',1.37),('1444','2014-03-09','15:55:00',1.29),('1444','2014-03-09','16:00:00',1.34),('1444','2014-03-09','16:05:00',1.2),('1444','2014-03-08','08:20:00',1.04),('1444','2014-03-08','08:25:00',1.1),('1444','2014-03-08','08:30:00',1.17),('1444','2014-03-08','08:35:00',1.23),('1444','2014-03-08','08:40:00',1.3),('1444','2014-03-08','08:45:00',1.36),('1444','2014-03-08','08:50:00',1.43),('1444','2014-03-08','08:55:00',1.49),('1444','2014-03-08','09:00:00',1.56),('1444','2014-03-08','09:05:00',1.62),('1444','2014-03-08','09:10:00',1.67),('1444','2014-03-08','09:15:00',1.72),('1444','2014-03-08','09:20:00',1.79),('1444','2014-03-08','09:25:00',1.85),('1444','2014-03-08','09:30:00',1.9),('1444','2014-03-08','09:35:00',1.95),('1444','2014-03-08','09:40:00',1.99),('1444','2014-03-08','09:45:00',2.04),('1444','2014-03-08','09:50:00',2.09),('1444','2014-03-08','09:55:00',2.14),('1444','2014-03-08','10:00:00',2.17),('1444','2014-03-08','10:05:00',2.22),('1444','2014-03-08','10:10:00',2.27),('1444','2014-03-08','10:15:00',2.3),('1444','2014-03-08','10:20:00',2.33),('1444','2014-03-08','10:25:00',2.39),('1444','2014-03-08','10:30:00',2.44),('1444','2014-03-08','10:35:00',2.46),('1444','2014-03-08','10:40:00',2.51),('1444','2014-03-08','10:45:00',2.55),('1444','2014-03-08','10:50:00',2.55),('1444','2014-03-08','10:55:00',2.58),('1444','2014-03-08','11:00:00',2.61),('1444','2014-03-08','11:05:00',2.63),('1444','2014-03-08','11:10:00',2.66),('1444','2014-03-08','11:15:00',2.71),('1444','2014-03-08','11:20:00',2.75),('1444','2014-03-08','11:25:00',2.82),('1444','2014-03-08','11:30:00',2.97),('1444','2014-03-08','11:35:00',2.81),('1444','2014-03-08','11:40:00',2.14),('1444','2014-03-08','11:45:00',1.51),('1444','2014-03-08','11:50:00',1.11),('1444','2014-03-08','11:55:00',2.08),('1444','2014-03-08','12:00:00',1.54),('1444','2014-03-08','12:20:00',1.01),('1444','2014-03-08','12:25:00',1.14),('1444','2014-03-08','12:30:00',1.23),('1444','2014-03-08','12:35:00',2.43),('1444','2014-03-08','12:40:00',1.58),('1444','2014-03-08','12:45:00',1.66),('1444','2014-03-08','12:50:00',2.11),('1444','2014-03-08','12:55:00',2.45),('1444','2014-03-08','13:00:00',1.71),('1444','2014-03-08','13:05:00',1.31),('1444','2014-03-08','13:10:00',1.16),('1444','2014-03-08','13:30:00',1.23),('1444','2014-03-08','13:35:00',1.28),('1444','2014-03-08','13:40:00',1.85),('1444','2014-03-08','13:45:00',2.11),('1444','2014-03-08','13:50:00',1.9),('1444','2014-03-08','13:55:00',1.1),('1444','2014-03-08','15:20:00',1.12),('1444','2014-03-08','15:25:00',1.04),('1444','2014-03-08','15:30:00',1.5),('1444','2014-04-30','08:00:00',1.05),('1444','2014-04-30','08:05:00',1.1),('1444','2014-04-30','08:10:00',1.19),('1444','2014-04-30','08:15:00',1.24),('1444','2014-04-30','08:20:00',1.3),('1444','2014-04-30','08:25:00',1.36),('1444','2014-04-30','08:30:00',1.43),('1444','2014-04-30','08:35:00',1.49),('1444','2014-04-30','08:40:00',1.55),('1444','2014-04-30','08:45:00',1.59),('1444','2014-04-30','08:50:00',1.45),('1444','2014-04-30','08:55:00',1.35),('1444','2014-04-30','09:00:00',1.97),('1444','2014-04-30','09:05:00',2),('1444','2014-04-30','09:10:00',1.76),('1444','2014-04-30','09:15:00',1.39),('1444','2014-04-30','09:20:00',1.78),('1444','2014-04-30','09:25:00',1.42),('1444','2014-04-30','09:35:00',2.22),('1444','2014-04-30','09:40:00',2.41),('1444','2014-04-30','09:45:00',2.12),('1444','2014-04-30','09:50:00',1.81),('1444','2014-04-30','09:55:00',2.7),('1444','2014-04-30','10:00:00',2.91),('1444','2014-04-30','10:05:00',1.97),('1444','2014-04-30','10:10:00',2.16),('1444','2014-04-30','10:15:00',2.21),('1444','2014-04-30','10:20:00',1.31),('1444','2014-04-30','10:25:00',1.5),('1444','2014-04-30','10:30:00',1.73),('1444','2014-04-30','10:35:00',1.56),('1444','2014-04-30','10:40:00',1.82),('1444','2014-04-30','10:45:00',1.29),('1444','2014-04-30','10:50:00',1.59),('1444','2014-04-30','10:55:00',3.52),('1444','2014-04-30','11:00:00',3.06),('1444','2014-04-30','11:05:00',2.26),('1444','2014-04-30','11:10:00',2.57),('1444','2014-04-30','11:15:00',1.58),('1444','2014-04-30','11:20:00',1.51),('1444','2014-04-30','11:25:00',1.78),('1444','2014-04-30','11:30:00',1.83),('1444','2014-04-30','11:35:00',2.33),('1444','2014-04-30','11:40:00',1.78),('1444','2014-04-30','11:45:00',1.89),('1444','2014-04-30','11:50:00',3.31),('1444','2014-04-30','11:55:00',3.16),('1444','2014-04-30','12:00:00',2.08),('1444','2014-04-30','12:05:00',1.23),('1444','2014-04-30','12:10:00',1.53),('1444','2014-04-30','12:15:00',1.56),('1444','2014-04-30','12:20:00',1.34),('1444','2014-04-30','12:25:00',1.65),('1444','2014-04-30','12:30:00',2.36),('1444','2014-04-30','12:35:00',1.43),('1444','2014-04-30','12:40:00',1.19),('1444','2014-04-30','12:45:00',1.09),('1444','2014-04-30','12:50:00',1.49),('1444','2014-04-30','12:55:00',3.06),('1444','2014-04-30','13:00:00',3.38),('1444','2014-04-30','13:05:00',1.42),('1444','2014-04-30','13:10:00',2.54),('1444','2014-04-30','13:15:00',1.82),('1444','2014-04-30','13:20:00',1.99),('1444','2014-04-30','13:25:00',2.55),('1444','2014-04-30','13:30:00',2.05),('1444','2014-04-30','13:35:00',1.96),('1444','2014-04-30','13:40:00',2.78),('1444','2014-04-30','13:45:00',2.74),('1444','2014-04-30','13:50:00',1.99),('1444','2014-04-30','13:55:00',3.11),('1444','2014-04-30','14:00:00',1.61),('1444','2014-04-30','14:05:00',1.47),('1444','2014-04-30','14:10:00',1.3),('1444','2014-04-30','14:15:00',1.57),('1444','2014-04-30','14:20:00',2.81),('1444','2014-04-30','14:25:00',3.33),('1444','2014-04-30','14:30:00',3.99),('1444','2014-04-30','14:35:00',2.73),('1444','2014-04-30','14:40:00',1.58),('1444','2014-04-30','14:45:00',1.2),('1444','2014-04-30','14:50:00',1.38),('1444','2014-04-30','14:55:00',1.47),('1444','2014-04-30','15:00:00',1.27),('1444','2014-04-30','15:05:00',1.23),('1444','2014-04-30','15:10:00',1.27),('1444','2014-04-30','15:15:00',1.12),('1444','2014-04-30','15:25:00',1.05),('1444','2014-04-30','15:30:00',1.4),('1444','2014-04-30','15:35:00',2.2),('1444','2014-04-30','15:40:00',3.37),('1444','2014-04-30','15:45:00',2.58),('1444','2014-04-30','15:50:00',3.2),('1444','2014-04-30','15:55:00',1.63),('1444','2014-04-30','16:00:00',1.55),('1444','2014-04-30','16:05:00',1.52),('1444','2014-04-30','16:10:00',1.54),('1444','2014-04-30','16:15:00',2.81),('1444','2014-04-30','16:20:00',1.2),('1444','2014-04-30','16:25:00',2.02),('1444','2014-04-30','16:30:00',2.32),('1444','2014-04-30','16:35:00',1.5),('1444','2014-04-30','16:40:00',2.41),('1444','2014-04-30','16:45:00',1.13),('1444','2014-04-30','16:50:00',1.48),('1444','2014-04-30','16:55:00',1.29),('1444','2014-04-30','17:00:00',2.11),('1444','2014-04-30','17:05:00',1.37),('1444','2014-04-30','17:10:00',1.48),('1444','2014-04-30','17:15:00',1.06),('1444','2014-04-30','17:35:00',1.07),('1444','2014-03-07','11:45:00',1.46),('1444','2014-03-07','11:50:00',2.85),('1444','2014-03-07','11:55:00',3.01),('1444','2014-03-07','12:00:00',3.41),('1444','2014-03-07','12:05:00',3.22),('1444','2014-03-07','12:10:00',3.12),('1444','2014-03-07','12:15:00',3.02),('1444','2014-03-07','12:20:00',3.05),('1444','2014-03-07','12:25:00',2.76),('1444','2014-03-07','12:30:00',1.16),('1444','2014-03-07','12:35:00',1.95),('1444','2014-03-07','12:40:00',1.57),('1444','2014-03-07','12:50:00',1.24),('1444','2014-03-07','12:55:00',1.8),('1444','2014-03-07','13:00:00',2.99),('1444','2014-03-07','13:05:00',2.87),('1444','2014-03-07','13:10:00',1.61),('1444','2014-03-07','13:15:00',1.37),('1444','2014-03-07','13:20:00',2.05),('1444','2014-03-07','13:25:00',2.76),('1444','2014-03-07','13:30:00',2.74),('1444','2014-03-07','13:35:00',2.11),('1444','2014-03-07','13:40:00',2.11),('1444','2014-03-07','13:45:00',1.91),('1444','2014-03-07','13:50:00',1.24),('1444','2014-03-07','14:40:00',1.01),('1444','2014-03-07','14:45:00',1.03),('1444','2014-03-07','14:50:00',1.32),('1444','2014-03-07','14:55:00',1.84),('1444','2014-03-07','15:00:00',2.2),('1444','2014-03-07','15:05:00',2.36),('1444','2014-03-07','15:10:00',2.38),('1444','2014-03-07','15:15:00',2.39),('1444','2014-03-07','15:20:00',2.35),('1444','2014-03-07','15:25:00',2.22),('1444','2014-03-07','15:30:00',2.09),('1444','2014-03-07','15:35:00',1.95),('1444','2014-03-07','15:40:00',1.43),('1444','2014-03-07','15:45:00',1.36),('1444','2014-03-07','15:50:00',1.26),('1444','2014-03-07','15:55:00',1.22),('1444','2014-03-07','16:00:00',1.38),('1444','2014-03-07','16:05:00',1.3),('1444','2014-03-07','16:10:00',1.24),('1444','2014-03-07','16:15:00',1.24),('1444','2014-03-07','16:20:00',1.12),('1444','2014-03-07','16:25:00',1.05),('1444','2014-03-06','08:10:00',1.1),('1444','2014-03-06','08:15:00',1.37),('1444','2014-03-06','08:20:00',1.28),('1444','2014-03-06','09:40:00',1.05),('1444','2014-03-06','09:45:00',1.16),('1444','2014-03-06','09:50:00',1.32),('1444','2014-03-06','09:55:00',1.64),('1444','2014-03-06','10:00:00',1.75),('1444','2014-03-06','10:05:00',1.8),('1444','2014-03-06','10:10:00',1.91),('1444','2014-03-06','10:15:00',2.28),('1444','2014-03-06','10:20:00',2.37),('1444','2014-03-06','10:25:00',1.31),('1444','2014-03-06','10:40:00',1.73),('1444','2014-03-06','10:50:00',1.34),('1444','2014-03-06','10:55:00',1.07),('1444','2014-03-06','11:00:00',2.07),('1444','2014-03-06','11:05:00',2.42),('1444','2014-03-06','11:10:00',2.34),('1444','2014-03-06','11:15:00',1.77),('1444','2014-03-06','11:20:00',2.05),('1444','2014-03-06','11:25:00',2.06),('1444','2014-03-06','11:30:00',1.46),('1444','2014-03-06','11:35:00',1.11),('1444','2014-03-06','11:40:00',1.45),('1444','2014-03-06','11:45:00',2.37),('1444','2014-03-06','11:50:00',2.99),('1444','2014-03-06','11:55:00',2.75),('1444','2014-03-06','12:00:00',1.32),('1444','2014-03-06','12:05:00',1.42),('1444','2014-03-06','12:10:00',3.21),('1444','2014-03-06','12:15:00',2.08),('1444','2014-03-06','12:20:00',1.04),('1444','2014-03-06','12:25:00',1.5),('1444','2014-03-06','12:30:00',2.82),('1444','2014-03-06','12:35:00',1.72),('1444','2014-03-06','12:40:00',1.15),('1444','2014-03-06','12:55:00',1.03),('1444','2014-03-06','13:00:00',1.62),('1444','2014-03-06','13:05:00',1.2),('1444','2014-03-06','13:10:00',1.01),('1444','2014-03-06','13:15:00',1.04),('1444','2014-03-06','14:35:00',1.41),('1444','2014-03-06','14:40:00',1.03),('1444','2014-03-06','15:05:00',1),('1444','2014-03-05','08:10:00',1.01),('1444','2014-03-05','08:15:00',1.16),('1444','2014-03-05','08:35:00',1.51),('1444','2014-03-05','08:40:00',1.19),('1444','2014-03-05','08:45:00',1.58),('1444','2014-03-05','08:50:00',1.21),('1444','2014-03-05','09:00:00',1.26),('1444','2014-03-05','09:05:00',1.75),('1444','2014-03-05','09:15:00',1.47),('1444','2014-03-05','09:20:00',1.84),('1444','2014-03-05','09:25:00',1.86),('1444','2014-03-05','09:30:00',1.91),('1444','2014-03-05','09:35:00',1.97),('1444','2014-03-05','09:40:00',2.01),('1444','2014-03-05','09:45:00',2.06),('1444','2014-03-05','09:50:00',2.1),('1444','2014-03-05','09:55:00',2.14),('1444','2014-03-05','10:00:00',2.19),('1444','2014-03-05','10:05:00',2.23),('1444','2014-03-05','10:10:00',1.79),('1444','2014-03-05','10:15:00',2.35),('1444','2014-03-05','10:20:00',2.29),('1444','2014-03-05','10:25:00',2.38),('1444','2014-03-05','10:30:00',2.41),('1444','2014-03-05','10:35:00',2.45),('1444','2014-03-05','10:40:00',2.47),('1444','2014-03-05','10:45:00',2.49),('1444','2014-03-05','10:50:00',2.51),('1444','2014-03-05','10:55:00',2.55),('1444','2014-03-05','11:00:00',2.59),('1444','2014-03-05','11:05:00',2.64),('1444','2014-03-05','11:10:00',2.66),('1444','2014-03-05','11:15:00',2.59),('1444','2014-03-05','11:20:00',2.74),('1444','2014-03-05','11:25:00',2.76),('1444','2014-03-05','11:30:00',2.8),('1444','2014-03-05','11:35:00',2.87),('1444','2014-03-05','11:40:00',2.85),('1444','2014-03-05','11:45:00',2.88),('1444','2014-03-05','11:50:00',2.82),('1444','2014-03-05','11:55:00',2.46),('1444','2014-03-05','12:00:00',2.54),('1444','2014-03-05','12:05:00',2.29),('1444','2014-03-05','12:10:00',1.71),('1444','2014-03-05','12:15:00',1.14),('1444','2014-03-05','12:35:00',1.34),('1444','2014-03-05','12:40:00',1.49),('1444','2014-03-05','12:50:00',1.21),('1444','2014-03-05','12:55:00',1.01),('1444','2014-03-05','13:00:00',1.23),('1444','2014-03-05','13:05:00',1.59),('1444','2014-03-05','13:10:00',2.44),('1444','2014-03-05','13:15:00',2.17),('1444','2014-03-05','13:20:00',1.68),('1444','2014-03-05','13:30:00',1.01),('1444','2014-03-05','13:40:00',1.22),('1444','2014-03-05','13:45:00',1.23),('1444','2014-03-05','13:50:00',1.01),('1444','2014-03-05','14:25:00',1.25),('1444','2014-03-05','14:30:00',1.13),('1444','2014-03-05','14:40:00',1.18),('1444','2014-03-05','14:45:00',1.75),('1444','2014-03-05','14:50:00',2.45),('1444','2014-03-05','14:55:00',1.89),('1444','2014-03-05','15:45:00',1.35),('1444','2014-03-05','15:50:00',1.05),('1444','2014-03-05','15:55:00',1.55),('1444','2014-03-05','16:00:00',1.99),('1444','2014-03-05','16:05:00',1.83),('1444','2014-03-05','16:10:00',1.54),('1444','2014-03-05','16:15:00',1.17),('1444','2014-03-04','09:05:00',1.03),('1444','2014-03-04','09:15:00',1.77),('1444','2014-03-04','09:20:00',1.46),('1444','2014-03-04','09:40:00',1.48),('1444','2014-03-04','09:55:00',1.53),('1444','2014-03-04','10:00:00',1.02),('1444','2014-03-04','10:25:00',2.88),('1444','2014-03-04','10:30:00',1.27),('1444','2014-03-04','10:35:00',2.71),('1444','2014-03-04','10:40:00',3.02),('1444','2014-03-04','10:45:00',2.59),('1444','2014-03-04','10:55:00',2.73),('1444','2014-03-04','11:00:00',1.12),('1444','2014-03-04','11:05:00',1.38),('1444','2014-03-04','11:10:00',2.95),('1444','2014-03-04','11:15:00',3.38),('1444','2014-03-04','11:20:00',1.91),('1444','2014-03-04','11:45:00',1.61),('1444','2014-03-04','11:50:00',3.55),('1444','2014-03-04','11:55:00',2.97),('1444','2014-03-04','12:00:00',2.9),('1444','2014-03-04','12:05:00',2.86),('1444','2014-03-04','12:10:00',2.84),('1444','2014-03-04','12:15:00',2.82),('1444','2014-03-04','12:20:00',2.79),('1444','2014-03-04','12:25:00',2.88),('1444','2014-03-04','12:30:00',2.79),('1444','2014-03-04','12:35:00',2.77),('1444','2014-03-04','12:40:00',2.82),('1444','2014-03-04','12:45:00',1.97),('1444','2014-03-04','12:50:00',2.38),('1444','2014-03-04','12:55:00',2.09),('1444','2014-03-04','13:00:00',2.6),('1444','2014-03-04','13:05:00',2.36),('1444','2014-03-04','13:10:00',2.94),('1444','2014-03-04','13:15:00',1.6),('1444','2014-03-04','13:20:00',1.19),('1444','2014-03-04','14:05:00',1.33),('1444','2014-03-04','14:10:00',1.63),('1444','2014-03-04','14:15:00',2.2),('1444','2014-03-04','14:20:00',1.51),('1444','2014-03-04','14:25:00',2.44),('1444','2014-03-04','14:30:00',2.29),('1444','2014-03-04','14:35:00',2.2),('1444','2014-03-04','14:40:00',2),('1444','2014-03-04','14:45:00',2.03),('1444','2014-03-04','14:50:00',1.81),('1444','2014-03-04','14:55:00',1.37),('1444','2014-03-04','15:00:00',1.98),('1444','2014-03-04','15:05:00',1.96),('1444','2014-03-04','15:10:00',1.74),('1444','2014-03-04','15:15:00',1.45),('1444','2014-03-04','15:20:00',1.04),('1444','2014-03-04','15:25:00',1.49),('1444','2014-03-04','15:35:00',1.91),('1444','2014-03-04','15:40:00',1.6),('1444','2014-03-04','15:45:00',1.07),('1444','2014-03-04','15:50:00',1.18),('1444','2014-03-03','08:20:00',1.01),('1444','2014-03-03','08:25:00',1.07),('1444','2014-03-03','08:30:00',1.14),('1444','2014-03-03','08:35:00',1.2),('1444','2014-03-03','08:40:00',1.28),('1444','2014-03-03','08:45:00',1.35),('1444','2014-03-03','08:50:00',1.34),('1444','2014-03-03','08:55:00',1.49),('1444','2014-03-03','09:00:00',1.5),('1444','2014-03-03','09:05:00',1.46),('1444','2014-03-03','09:10:00',1.36),('1444','2014-03-03','09:15:00',1.5),('1444','2014-03-03','09:20:00',1.69),('1444','2014-03-03','09:25:00',1.79),('1444','2014-03-03','09:30:00',1.86),('1444','2014-03-03','09:35:00',1.75),('1444','2014-03-03','09:40:00',1.5),('1444','2014-03-03','09:45:00',1.68),('1444','2014-03-03','09:50:00',1.75),('1444','2014-03-03','09:55:00',1.87),('1444','2014-03-03','10:00:00',2.01),('1444','2014-03-03','10:05:00',2.15),('1444','2014-03-03','10:10:00',2.18),('1444','2014-03-03','10:15:00',2.23),('1444','2014-03-03','10:20:00',2.22),('1444','2014-03-03','10:25:00',2.24),('1444','2014-03-03','10:30:00',2.29),('1444','2014-03-03','10:35:00',2.36),('1444','2014-03-03','10:40:00',2.39),('1444','2014-03-03','10:45:00',2.4),('1444','2014-03-03','10:50:00',2.42),('1444','2014-03-03','10:55:00',2.46),('1444','2014-03-03','11:00:00',2.5),('1444','2014-03-03','11:05:00',2.51),('1444','2014-03-03','11:10:00',2.53),('1444','2014-03-03','11:15:00',2.55),('1444','2014-03-03','11:20:00',2.56),('1444','2014-03-03','11:25:00',2.61),('1444','2014-03-03','11:30:00',2.66),('1444','2014-03-03','11:35:00',1.38),('1444','2014-03-03','11:40:00',2.36),('1444','2014-03-03','11:45:00',2.72),('1444','2014-03-03','11:50:00',2.7),('1444','2014-03-03','11:55:00',2.75),('1444','2014-03-03','12:00:00',2.73),('1444','2014-03-03','12:05:00',2.75),('1444','2014-03-03','12:10:00',2.76),('1444','2014-03-03','12:15:00',2.75),('1444','2014-03-03','12:20:00',2.76),('1444','2014-03-03','12:25:00',2.76),('1444','2014-03-03','12:30:00',2.76),('1444','2014-03-03','12:35:00',2.75),('1444','2014-03-03','12:40:00',2.74),('1444','2014-03-03','12:45:00',2.73),('1444','2014-03-03','12:50:00',2.72),('1444','2014-03-03','12:55:00',2.7),('1444','2014-03-03','13:00:00',2.69),('1444','2014-03-03','13:05:00',2.67),('1444','2014-03-03','13:10:00',2.65),('1444','2014-03-03','13:15:00',2.62),('1444','2014-03-03','13:20:00',2.63),('1444','2014-03-03','13:25:00',2.6),('1444','2014-03-03','13:30:00',2.59),('1444','2014-03-03','13:35:00',2.57),('1444','2014-03-03','13:40:00',2.55),('1444','2014-03-03','13:45:00',2.52),('1444','2014-03-03','13:50:00',2.51),('1444','2014-03-03','13:55:00',2.45),('1444','2014-03-03','14:00:00',2.43),('1444','2014-03-03','14:05:00',2.38),('1444','2014-03-03','14:10:00',2.39),('1444','2014-03-03','14:15:00',2.38),('1444','2014-03-03','14:20:00',2.29),('1444','2014-03-03','14:25:00',2.28),('1444','2014-03-03','14:30:00',2.22),('1444','2014-03-03','14:35:00',2.17),('1444','2014-03-03','14:40:00',2.12),('1444','2014-03-03','14:45:00',2.04),('1444','2014-03-03','14:50:00',1.98),('1444','2014-03-03','14:55:00',1.94),('1444','2014-03-03','15:00:00',1.88),('1444','2014-03-03','15:05:00',1.85),('1444','2014-03-03','15:10:00',1.78),('1444','2014-03-03','15:15:00',1.74),('1444','2014-03-03','15:20:00',1.69),('1444','2014-03-03','15:25:00',1.63),('1444','2014-03-03','15:30:00',1.56),('1444','2014-03-03','15:35:00',1.5),('1444','2014-03-03','15:40:00',1.44),('1444','2014-03-03','15:45:00',1.36),('1444','2014-03-03','15:50:00',1.31),('1444','2014-03-03','15:55:00',1.23),('1444','2014-03-03','16:00:00',1.17),('1444','2014-03-03','16:05:00',1.11),('1444','2014-03-03','16:10:00',1.06),('1444','2014-03-02','08:10:00',1.26),('1444','2014-03-02','08:15:00',1.18),('1444','2014-03-02','08:20:00',1.15),('1444','2014-03-02','08:25:00',1.09),('1444','2014-03-02','08:30:00',1.11),('1444','2014-03-02','08:35:00',1.15),('1444','2014-03-02','08:40:00',1.23),('1444','2014-03-02','08:45:00',1.3),('1444','2014-03-02','08:50:00',1.38),('1444','2014-03-02','08:55:00',1.44),('1444','2014-03-02','09:00:00',1.52),('1444','2014-03-02','09:05:00',1.6),('1444','2014-03-02','09:10:00',1.71),('1444','2014-03-02','09:15:00',1.75),('1444','2014-03-02','09:20:00',1.51),('1444','2014-03-02','09:25:00',1.97),('1444','2014-03-02','09:30:00',2.05),('1444','2014-03-02','09:35:00',2.05),('1444','2014-03-02','09:40:00',1.54),('1444','2014-03-02','09:55:00',1.05),('1444','2014-03-02','10:00:00',1.19),('1444','2014-03-02','10:05:00',1.24),('1444','2014-03-02','10:10:00',1.06),('1444','2014-03-02','10:25:00',1.15),('1444','2014-03-02','10:30:00',1.22),('1444','2014-03-02','10:35:00',2.09),('1444','2014-03-02','10:40:00',1.16),('1444','2014-03-02','10:50:00',1.3),('1444','2014-03-02','10:55:00',1.14),('1444','2014-03-02','11:00:00',2.83),('1444','2014-03-02','11:05:00',1.8),('1444','2014-03-02','11:10:00',1.17),('1444','2014-03-02','11:15:00',1.05),('1444','2014-03-02','11:20:00',1.42),('1444','2014-03-02','11:25:00',1.51),('1444','2014-03-02','11:30:00',1.79),('1444','2014-03-02','11:35:00',1.99),('1444','2014-03-02','11:40:00',2.26),('1444','2014-03-02','11:45:00',3.47),('1444','2014-03-02','11:50:00',3.18),('1444','2014-03-02','11:55:00',3.02),('1444','2014-03-02','12:00:00',1.9),('1444','2014-03-02','12:05:00',1.38),('1444','2014-03-02','12:10:00',1.6),('1444','2014-03-02','12:15:00',1.84),('1444','2014-03-02','12:20:00',1.71),('1444','2014-03-02','12:25:00',1.73),('1444','2014-03-02','12:30:00',1.11),('1444','2014-03-02','12:55:00',1.05),('1444','2014-03-02','13:00:00',1.16),('1444','2014-03-02','13:05:00',1.2),('1444','2014-03-02','13:10:00',1.14),('1444','2014-03-02','14:05:00',1.06),('1444','2014-03-02','14:10:00',1.03),('1444','2014-03-02','15:05:00',1.03),('1444','2014-03-02','15:10:00',1.05),('1444','2014-03-02','15:15:00',1.03),('1444','2014-03-02','15:20:00',1.06),('1444','2014-03-02','15:25:00',1.06),('1444','2014-03-02','15:30:00',1.04),('1444','2014-03-02','15:35:00',1.03),('1444','2014-03-02','15:40:00',1),('1444','2014-02-28','08:20:00',1.11),('1444','2014-02-28','08:35:00',1.59),('1444','2014-02-28','09:25:00',1.19),('1444','2014-02-28','09:30:00',1.27),('1444','2014-02-28','09:40:00',1.88),('1444','2014-02-28','09:45:00',2.14),('1444','2014-02-28','09:50:00',2.53),('1444','2014-02-28','09:55:00',1.56),('1444','2014-02-28','10:10:00',1.08),('1444','2014-02-28','10:20:00',1.38),('1444','2014-02-28','10:25:00',2.4),('1444','2014-02-28','10:30:00',2.76),('1444','2014-02-28','10:35:00',1.94),('1444','2014-02-28','11:20:00',1.06),('1444','2014-02-28','12:00:00',1.2),('1444','2014-02-28','12:05:00',1.68),('1444','2014-02-28','12:10:00',1.47),('1444','2014-02-28','12:25:00',1.76),('1444','2014-02-28','12:30:00',1.43),('1444','2014-02-28','12:35:00',2.68),('1444','2014-02-28','12:40:00',1.48),('1444','2014-02-28','12:45:00',1.04),('1444','2014-02-28','12:50:00',1.84),('1444','2014-02-28','12:55:00',1.25),('1444','2014-02-28','13:00:00',2.17),('1444','2014-02-28','13:05:00',1.43),('1444','2014-02-28','13:10:00',1.26),('1444','2014-02-28','13:45:00',1.02),('1444','2014-02-28','13:50:00',2.78),('1444','2014-02-28','13:55:00',1.82),('1444','2014-02-28','14:00:00',1.1),('1444','2014-02-28','14:15:00',1.05),('1444','2014-02-28','14:20:00',1.22),('1444','2014-02-28','14:25:00',2.35),('1444','2014-02-28','14:30:00',1.48),('1444','2014-02-28','14:35:00',1.14),('1444','2014-02-28','14:40:00',1.08),('1444','2014-02-28','14:45:00',1.03),('1444','2014-02-28','14:50:00',1.11),('1444','2014-02-28','14:55:00',1.22),('1444','2014-02-28','15:00:00',1.74),('1444','2014-02-28','15:05:00',1),('1444','2014-02-28','15:25:00',1.69),('1444','2014-02-28','15:30:00',1.32),('1444','2014-02-28','15:35:00',1.39),('1444','2014-02-28','15:40:00',1.33),('1444','2014-02-28','16:15:00',1.45),('1444','2014-02-28','16:20:00',1.1),('1444','2014-02-28','16:45:00',1.02),('1444','2014-02-27','10:45:00',1),('1444','2014-02-27','10:50:00',1.05),('1444','2014-02-27','10:55:00',1.08),('1444','2014-02-27','11:00:00',1.25),('1444','2014-02-27','11:05:00',1.36),('1444','2014-02-27','11:10:00',1.29),('1444','2014-02-27','11:15:00',1.27),('1444','2014-02-27','11:20:00',1.15),('1444','2014-02-27','11:25:00',1.33),('1444','2014-02-27','11:30:00',1.55),('1444','2014-02-27','11:35:00',1.39),('1444','2014-02-27','11:40:00',1.2),('1444','2014-02-27','11:45:00',1.03),('1444','2014-02-27','11:50:00',1.02),('1444','2014-02-27','11:55:00',1.06),('1444','2014-02-27','12:00:00',1.02),('1444','2014-02-27','12:20:00',1.02),('1444','2014-02-27','12:25:00',1.04),('1444','2014-02-27','13:00:00',1),('1444','2014-02-27','13:15:00',1.05),('1444','2014-02-27','13:20:00',1.05),('1444','2014-02-27','13:25:00',1.1),('1444','2014-02-27','13:30:00',1.25),('1444','2014-02-27','13:35:00',1.34),('1444','2014-02-27','13:40:00',1.37),('1444','2014-02-27','13:45:00',1.37),('1444','2014-02-27','13:50:00',1.46),('1444','2014-02-27','13:55:00',1.6),('1444','2014-02-27','14:00:00',1.54),('1444','2014-02-27','14:05:00',1.36),('1444','2014-02-27','14:10:00',1.23),('1444','2014-02-27','14:15:00',1.15),('1444','2014-02-27','14:20:00',1.15),('1444','2014-02-27','14:25:00',1.15),('1444','2014-02-27','14:30:00',1.16),('1444','2014-02-27','14:35:00',1.1),('1444','2014-02-27','14:40:00',1.01),('1444','2014-02-27','14:45:00',1.05),('1444','2014-02-27','15:15:00',1.12),('1444','2014-02-27','15:20:00',1.19),('1444','2014-02-27','15:25:00',1.04),('1444','2014-02-27','15:30:00',1.02),('1444','2014-02-27','15:35:00',1),('1444','2014-02-26','08:30:00',1.02),('1444','2014-02-26','08:35:00',1.1),('1444','2014-02-26','08:40:00',1.18),('1444','2014-02-26','08:45:00',1.31),('1444','2014-02-26','08:50:00',1.27),('1444','2014-02-26','08:55:00',1.34),('1444','2014-02-26','09:00:00',1.36),('1444','2014-02-26','09:05:00',1.37),('1444','2014-02-26','09:10:00',1.41),('1444','2014-02-26','09:15:00',1.5),('1444','2014-02-26','09:20:00',1.6),('1444','2014-02-26','09:25:00',1.83),('1444','2014-02-26','09:30:00',1.46),('1444','2014-02-26','09:35:00',1.34),('1444','2014-02-26','09:40:00',1.41),('1444','2014-02-26','09:45:00',1.37),('1444','2014-02-26','09:50:00',1.22),('1444','2014-02-26','12:00:00',1.12),('1444','2014-02-26','12:05:00',1.37),('1444','2014-02-26','12:10:00',1.07),('1444','2014-02-26','12:20:00',1.12),('1444','2014-02-26','12:25:00',1.61),('1444','2014-02-26','12:30:00',2.33),('1444','2014-02-26','12:35:00',2.15),('1444','2014-02-26','12:40:00',2.13),('1444','2014-02-26','12:45:00',1.72),('1444','2014-02-26','12:50:00',2.23),('1444','2014-02-26','12:55:00',2.67),('1444','2014-02-26','13:00:00',2.05),('1444','2014-02-26','13:05:00',2.15),('1444','2014-02-26','13:10:00',2.22),('1444','2014-02-26','13:15:00',2.2),('1444','2014-02-26','13:20:00',2.04),('1444','2014-02-26','13:25:00',2.56),('1444','2014-02-26','13:30:00',2.55),('1444','2014-02-26','13:35:00',2.48),('1444','2014-02-26','13:40:00',2.53),('1444','2014-02-26','13:45:00',1.11),('1444','2014-02-26','13:50:00',1.14),('1444','2014-02-26','13:55:00',2.28),('1444','2014-02-26','14:00:00',2.57),('1444','2014-02-26','14:05:00',1.17),('1444','2014-02-26','14:10:00',1.46),('1444','2014-02-26','14:15:00',2.52),('1444','2014-02-26','14:20:00',2.54),('1444','2014-02-26','14:25:00',2.33),('1444','2014-02-26','14:30:00',1.13),('1444','2014-02-26','14:35:00',2.34),('1444','2014-02-26','14:40:00',1.73),('1444','2014-02-26','14:45:00',2.03),('1444','2014-02-26','14:50:00',2.1),('1444','2014-02-26','14:55:00',2.05),('1444','2014-02-26','15:00:00',1.02),('1444','2014-02-26','15:05:00',1.68),('1444','2014-02-26','15:10:00',1.75),('1444','2014-02-26','15:15:00',1.5),('1444','2014-02-26','15:20:00',1.25),('1444','2014-02-26','15:35:00',1.15),('1444','2014-02-26','15:40:00',1.12),('1444','2014-02-26','15:55:00',1.1),('1444','2014-02-26','16:00:00',1.27),('1444','2014-02-26','16:05:00',1.11),('1444','2014-04-29','10:05:00',1.42),('1444','2014-04-29','10:10:00',2.86),('1444','2014-04-29','10:15:00',2.2),('1444','2014-04-29','10:20:00',2.35),('1444','2014-04-29','10:25:00',3.17),('1444','2014-04-29','10:30:00',2.99),('1444','2014-04-29','10:35:00',2.99),('1444','2014-04-29','10:40:00',3.03),('1444','2014-04-29','10:45:00',3.04),('1444','2014-04-29','10:50:00',3.1),('1444','2014-04-29','10:55:00',2.94),('1444','2014-04-29','11:00:00',3.07),('1444','2014-04-29','11:05:00',3.1),('1444','2014-04-29','11:10:00',2.69),('1444','2014-04-29','11:15:00',3.42),('1444','2014-04-29','11:20:00',1.72),('1444','2014-04-29','11:25:00',2.62),('1444','2014-04-29','11:30:00',1.3),('1444','2014-04-29','11:35:00',1.75),('1444','2014-04-29','11:40:00',2.12),('1444','2014-04-29','11:45:00',1.2),('1444','2014-04-29','12:00:00',1.33),('1444','2014-04-29','12:05:00',1.49),('1444','2014-04-29','12:10:00',1.46),('1444','2014-04-29','12:15:00',1.47),('1444','2014-04-29','12:20:00',2.71),('1444','2014-04-29','12:25:00',1.4),('1444','2014-04-29','12:30:00',1.32),('1444','2014-04-29','12:35:00',1.5),('1444','2014-04-29','12:40:00',1.41),('1444','2014-04-29','12:45:00',2.72),('1444','2014-04-29','12:50:00',1.47),('1444','2014-04-29','12:55:00',1.56),('1444','2014-04-29','13:00:00',2.51),('1444','2014-04-29','13:05:00',1.89),('1444','2014-04-29','13:10:00',2.29),('1444','2014-04-29','13:15:00',2.67),('1444','2014-04-29','13:20:00',3.12),('1444','2014-04-29','13:25:00',2.64),('1444','2014-04-29','13:30:00',1.61),('1444','2014-04-29','13:35:00',1.14),('1444','2014-04-29','13:40:00',1.34),('1444','2014-04-29','13:45:00',2.41),('1444','2014-04-29','13:50:00',1.86),('1444','2014-04-29','17:25:00',1.47),('1444','2014-04-29','17:30:00',1.11),('1444','2014-04-29','17:40:00',1.65),('1444','2014-04-29','17:45:00',1.52),('1444','2014-02-25','08:35:00',1.01),('1444','2014-02-25','08:40:00',1.06),('1444','2014-02-25','08:45:00',1.1),('1444','2014-02-25','08:50:00',1.16),('1444','2014-02-25','08:55:00',1.22),('1444','2014-02-25','09:00:00',1.3),('1444','2014-02-25','09:05:00',1.36),('1444','2014-02-25','09:10:00',1.43),('1444','2014-02-25','09:15:00',1.48),('1444','2014-02-25','09:20:00',1.53),('1444','2014-02-25','09:25:00',1.58),('1444','2014-02-25','09:30:00',1.62),('1444','2014-02-25','09:35:00',1.67),('1444','2014-02-25','09:40:00',1.72),('1444','2014-02-25','09:45:00',1.78),('1444','2014-02-25','09:50:00',1.82),('1444','2014-02-25','09:55:00',1.86),('1444','2014-02-25','10:00:00',1.91),('1444','2014-02-25','10:05:00',1.96),('1444','2014-02-25','10:10:00',2),('1444','2014-02-25','10:15:00',2.02),('1444','2014-02-25','10:20:00',2.06),('1444','2014-02-25','10:25:00',2.11),('1444','2014-02-25','10:30:00',2.14),('1444','2014-02-25','10:35:00',2.16),('1444','2014-02-25','10:40:00',2.2),('1444','2014-02-25','10:45:00',2.22),('1444','2014-02-25','10:50:00',2.23),('1444','2014-02-25','10:55:00',2.27),('1444','2014-02-25','11:00:00',2.26),('1444','2014-02-25','11:05:00',2.3),('1444','2014-02-25','11:10:00',2.32),('1444','2014-02-25','11:15:00',2.35),('1444','2014-02-25','11:20:00',2.34),('1444','2014-02-25','11:25:00',2.36),('1444','2014-02-25','11:30:00',2.39),('1444','2014-02-25','11:35:00',2.41),('1444','2014-02-25','11:40:00',2.41),('1444','2014-02-25','11:45:00',2.4),('1444','2014-02-25','11:50:00',2.44),('1444','2014-02-25','11:55:00',2.42),('1444','2014-02-25','12:00:00',2.45),('1444','2014-02-25','12:05:00',2.46),('1444','2014-02-25','12:10:00',2.48),('1444','2014-02-25','12:15:00',2.52),('1444','2014-02-25','12:20:00',2.55),('1444','2014-02-25','12:25:00',2.53),('1444','2014-02-25','12:30:00',2.48),('1444','2014-02-25','12:35:00',2.46),('1444','2014-02-25','12:40:00',2.41),('1444','2014-02-25','12:45:00',2.46),('1444','2014-02-25','12:50:00',2.46),('1444','2014-02-25','12:55:00',2.42),('1444','2014-02-25','13:00:00',2.38),('1444','2014-02-25','13:05:00',2.3),('1444','2014-02-25','13:40:00',1.02),('1444','2014-02-25','14:25:00',1.42),('1444','2014-02-25','14:30:00',1.58),('1444','2014-02-25','14:35:00',1.92),('1444','2014-02-25','14:40:00',2.04),('1444','2014-02-25','14:45:00',2.04),('1444','2014-02-25','14:50:00',1.1),('1444','2014-02-25','15:00:00',1.66),('1444','2014-02-25','15:05:00',1.72),('1444','2014-02-25','15:10:00',1.65),('1444','2014-02-25','15:15:00',1.54),('1444','2014-02-25','15:20:00',1.47),('1444','2014-02-25','15:25:00',1.27),('1444','2014-02-25','15:30:00',1.17),('1444','2014-02-25','15:35:00',1.05),('1444','2014-02-25','15:40:00',1.12),('1444','2014-02-24','08:15:00',1.02),('1444','2014-02-24','08:20:00',1.08),('1444','2014-02-24','08:25:00',1.13),('1444','2014-02-24','08:35:00',1.17),('1444','2014-02-24','08:50:00',1.02),('1444','2014-02-24','08:55:00',1.27),('1444','2014-02-24','09:00:00',1.3),('1444','2014-02-24','09:05:00',1.35),('1444','2014-02-24','09:10:00',1.41),('1444','2014-02-24','09:15:00',1.46),('1444','2014-02-24','09:20:00',1.51),('1444','2014-02-24','09:25:00',1.58),('1444','2014-02-24','09:30:00',1.64),('1444','2014-02-24','09:35:00',1.68),('1444','2014-02-24','09:40:00',1.73),('1444','2014-02-24','09:45:00',1.79),('1444','2014-02-24','09:50:00',1.84),('1444','2014-02-24','09:55:00',1.87),('1444','2014-02-24','10:00:00',1.93),('1444','2014-02-24','10:05:00',1.97),('1444','2014-02-24','10:10:00',2.02),('1444','2014-02-24','10:15:00',2.07),('1444','2014-02-24','10:20:00',2.11),('1444','2014-02-24','10:25:00',2.15),('1444','2014-02-24','10:30:00',2.18),('1444','2014-02-24','10:35:00',2.22),('1444','2014-02-24','10:40:00',2.25),('1444','2014-02-24','10:45:00',2.27),('1444','2014-02-24','10:50:00',2.3),('1444','2014-02-24','10:55:00',2.34),('1444','2014-02-24','11:00:00',2.35),('1444','2014-02-24','11:05:00',2.37),('1444','2014-02-24','11:10:00',2.42),('1444','2014-02-24','11:15:00',2.46),('1444','2014-02-24','11:20:00',2.46),('1444','2014-02-24','11:25:00',2.48),('1444','2014-02-24','11:30:00',2.74),('1444','2014-02-24','11:35:00',2.07),('1444','2014-02-24','11:40:00',1.8),('1444','2014-02-24','11:45:00',2.43),('1444','2014-02-24','11:50:00',2.48),('1444','2014-02-24','11:55:00',2.21),('1444','2014-02-24','12:00:00',2.58),('1444','2014-02-24','12:05:00',2.59),('1444','2014-02-24','12:10:00',2.5),('1444','2014-02-24','12:15:00',2.59),('1444','2014-02-24','12:20:00',2.63),('1444','2014-02-24','12:25:00',2.59),('1444','2014-02-24','12:30:00',1.74),('1444','2014-02-24','12:35:00',2.76),('1444','2014-02-24','12:40:00',2.86),('1444','2014-02-24','12:45:00',2.14),('1444','2014-02-24','12:50:00',1.58),('1444','2014-02-24','12:55:00',2.22),('1444','2014-02-24','13:00:00',2.06),('1444','2014-02-24','13:05:00',2.32),('1444','2014-02-24','13:10:00',2.79),('1444','2014-02-24','13:15:00',2.39),('1444','2014-02-24','15:35:00',1.54),('1444','2014-02-24','15:40:00',1.69),('1444','2014-02-24','15:45:00',1.6),('1444','2014-02-24','15:50:00',1.56),('1444','2014-02-24','15:55:00',1.5),('1444','2014-02-24','16:00:00',1.39),('1444','2014-02-24','16:05:00',1.45),('1444','2014-02-24','16:10:00',1.35),('1444','2014-02-24','16:15:00',1.22),('1444','2014-02-24','16:20:00',1.02),('1444','2014-02-23','08:40:00',1.04),('1444','2014-02-23','08:45:00',1.07),('1444','2014-02-23','08:50:00',1.1),('1444','2014-02-23','08:55:00',1.18),('1444','2014-02-23','09:00:00',1.24),('1444','2014-02-23','09:05:00',1.33),('1444','2014-02-23','09:10:00',1.4),('1444','2014-02-23','09:15:00',1.48),('1444','2014-02-23','09:20:00',1.54),('1444','2014-02-23','09:25:00',1.41),('1444','2014-02-23','09:30:00',1.43),('1444','2014-02-23','09:35:00',1.63),('1444','2014-02-23','09:40:00',1.72),('1444','2014-02-23','09:45:00',1.77),('1444','2014-02-23','09:50:00',1.78),('1444','2014-02-23','09:55:00',1.82),('1444','2014-02-23','10:00:00',1.87),('1444','2014-02-23','10:05:00',1.91),('1444','2014-02-23','10:10:00',1.94),('1444','2014-02-23','10:15:00',1.97),('1444','2014-02-23','10:20:00',2.03),('1444','2014-02-23','10:25:00',2.09),('1444','2014-02-23','10:30:00',2.11),('1444','2014-02-23','10:35:00',2.16),('1444','2014-02-23','10:40:00',2.18),('1444','2014-02-23','10:45:00',2.22),('1444','2014-02-23','10:50:00',2.26),('1444','2014-02-23','10:55:00',2.27),('1444','2014-02-23','11:00:00',2.32),('1444','2014-02-23','11:05:00',2.34),('1444','2014-02-23','11:10:00',2.39),('1444','2014-02-23','11:15:00',2.46),('1444','2014-02-23','11:20:00',2.47),('1444','2014-02-23','11:25:00',2.45),('1444','2014-02-23','11:30:00',2.5),('1444','2014-02-23','11:35:00',2.42),('1444','2014-02-23','11:40:00',2.05),('1444','2014-02-23','11:45:00',2.43),('1444','2014-02-23','11:50:00',2.7),('1444','2014-02-23','11:55:00',2.63),('1444','2014-02-23','12:00:00',2.66),('1444','2014-02-23','12:05:00',1.15),('1444','2014-02-23','12:10:00',1.63),('1444','2014-02-23','12:15:00',2.39),('1444','2014-02-23','12:20:00',2.53),('1444','2014-02-23','12:25:00',1.62),('1444','2014-02-23','12:30:00',1.98),('1444','2014-02-23','12:35:00',2.72),('1444','2014-02-23','12:40:00',1.54),('1444','2014-02-23','12:45:00',1.9),('1444','2014-02-23','12:50:00',1.45),('1444','2014-02-23','12:55:00',1.46),('1444','2014-02-23','13:00:00',2.03),('1444','2014-02-23','13:05:00',2.54),('1444','2014-02-23','13:10:00',2.53),('1444','2014-02-23','13:15:00',2.5),('1444','2014-02-23','13:20:00',2.48),('1444','2014-02-23','13:25:00',2.48),('1444','2014-02-23','13:30:00',2.39),('1444','2014-02-23','13:35:00',2.32),('1444','2014-02-23','13:40:00',2.06),('1444','2014-02-23','13:45:00',1.8),('1444','2014-02-23','13:50:00',2.15),('1444','2014-02-23','13:55:00',1.11),('1444','2014-02-23','14:05:00',2.02),('1444','2014-02-23','14:10:00',2.28),('1444','2014-02-23','14:15:00',1.79),('1444','2014-02-23','14:20:00',1.17),('1444','2014-02-23','14:25:00',1.47),('1444','2014-02-23','14:30:00',2.57),('1444','2014-02-23','14:35:00',2.1),('1444','2014-02-23','14:40:00',1.62),('1444','2014-02-23','14:45:00',1.36),('1444','2014-02-23','14:50:00',1.58),('1444','2014-02-23','14:55:00',1.03),('1444','2014-02-22','10:00:00',1.35),('1444','2014-02-22','10:05:00',1.37),('1444','2014-02-22','10:10:00',2.05),('1444','2014-02-22','10:15:00',1.44),('1444','2014-02-22','10:20:00',1.09),('1444','2014-02-22','10:25:00',1.72),('1444','2014-02-22','10:30:00',1.7),('1444','2014-02-22','10:35:00',1.37),('1444','2014-02-22','10:40:00',1.21),('1444','2014-02-22','10:45:00',2.71),('1444','2014-02-22','10:50:00',2.24),('1444','2014-02-22','12:05:00',1.1),('1444','2014-02-22','12:10:00',1.27),('1444','2014-02-22','12:15:00',1.38),('1444','2014-02-22','12:20:00',1.39),('1444','2014-02-22','12:25:00',1.24),('1444','2014-02-22','12:40:00',1.21),('1444','2014-02-22','12:45:00',2.52),('1444','2014-02-22','12:50:00',2.42),('1444','2014-02-22','12:55:00',1.18),('1444','2014-02-22','13:00:00',1.12),('1444','2014-02-22','13:05:00',2.07),('1444','2014-02-22','13:10:00',3.42),('1444','2014-02-22','13:15:00',1.94),('1444','2014-02-22','13:20:00',1.17),('1444','2014-02-22','13:35:00',1.34),('1444','2014-02-22','13:50:00',1.51),('1444','2014-02-22','13:55:00',2.45),('1444','2014-02-22','14:00:00',2.3),('1444','2014-02-22','14:10:00',1.28),('1444','2014-02-22','14:15:00',2.05),('1444','2014-02-22','14:20:00',2.19),('1444','2014-02-22','14:25:00',1.6),('1444','2014-02-22','14:30:00',1.28),('1444','2014-02-22','14:35:00',1.66),('1444','2014-02-22','14:40:00',1.91),('1444','2014-02-22','14:45:00',2.06),('1444','2014-02-22','14:50:00',1.68),('1444','2014-02-22','15:05:00',1.52),('1444','2014-02-22','15:30:00',1.47),('1444','2014-02-22','15:45:00',1.3),('1444','2014-02-21','10:05:00',1.11),('1444','2014-02-21','10:15:00',1.22),('1444','2014-02-21','10:20:00',1.59),('1444','2014-02-21','10:25:00',1.77),('1444','2014-02-21','10:30:00',1.87),('1444','2014-02-21','10:35:00',1.34),('1444','2014-02-21','10:40:00',1.32),('1444','2014-02-21','10:45:00',1.2),('1444','2014-02-21','10:50:00',1.41),('1444','2014-02-21','10:55:00',1.73),('1444','2014-02-21','11:00:00',1.28),('1444','2014-02-21','11:05:00',1.26),('1444','2014-02-21','11:10:00',1.2),('1444','2014-02-21','11:15:00',1.3),('1444','2014-02-21','11:20:00',1.2),('1444','2014-02-21','11:25:00',1.25),('1444','2014-02-21','11:30:00',1.29),('1444','2014-02-21','11:35:00',1.33),('1444','2014-02-21','11:40:00',1.4),('1444','2014-02-21','11:45:00',1.21),('1444','2014-02-21','11:50:00',1.17),('1444','2014-02-21','11:55:00',1.25),('1444','2014-02-21','12:00:00',1.12),('1444','2014-02-21','12:05:00',1.81),('1444','2014-02-21','12:10:00',2.84),('1444','2014-02-21','12:15:00',2.34),('1444','2014-02-21','12:20:00',2.42),('1444','2014-02-21','12:25:00',1.6),('1444','2014-02-21','12:30:00',1.06),('1444','2014-02-21','15:05:00',1.08),('1444','2014-02-21','15:35:00',1.09),('1444','2014-02-21','15:40:00',1.19),('1444','2014-02-21','15:45:00',1.14),('1444','2014-02-21','15:50:00',1.06),('1444','2014-02-20','13:00:00',1.15),('1444','2014-02-19','09:40:00',1.01),('1444','2014-02-19','09:45:00',1.19),('1444','2014-02-19','09:50:00',1.11),('1444','2014-02-19','09:55:00',1.04),('1444','2014-02-19','10:00:00',1),('1444','2014-02-19','10:05:00',1.01),('1444','2014-02-19','10:10:00',1.1),('1444','2014-02-19','10:15:00',1.14),('1444','2014-02-19','10:20:00',1.05),('1444','2014-02-19','10:25:00',1.08),('1444','2014-02-19','10:30:00',1.14),('1444','2014-02-19','10:35:00',1.2),('1444','2014-02-19','10:40:00',1.38),('1444','2014-02-19','10:45:00',1.49),('1444','2014-02-19','10:50:00',1.39),('1444','2014-02-19','10:55:00',1.25),('1444','2014-02-19','11:00:00',1.15),('1444','2014-02-19','11:05:00',1.18),('1444','2014-02-19','11:10:00',1.34),('1444','2014-02-19','11:15:00',1.31),('1444','2014-02-19','11:20:00',1.41),('1444','2014-02-19','11:25:00',1.31),('1444','2014-02-19','11:30:00',1.24),('1444','2014-02-19','11:35:00',1.31),('1444','2014-02-19','11:40:00',1.19),('1444','2014-02-19','11:45:00',1.18),('1444','2014-02-19','11:50:00',1.2),('1444','2014-02-19','11:55:00',1.03),('1444','2014-02-19','12:00:00',1.04),('1444','2014-02-19','12:05:00',1.12),('1444','2014-02-19','12:10:00',1.07),('1444','2014-02-19','12:15:00',1.02),('1444','2014-02-19','12:25:00',1.09),('1444','2014-02-19','12:30:00',1.19),('1444','2014-02-19','13:25:00',1.19),('1444','2014-02-19','13:30:00',1.17),('1444','2014-02-19','13:35:00',1.28),('1444','2014-02-19','13:40:00',1.19),('1444','2014-02-19','13:45:00',1.56),('1444','2014-02-19','13:50:00',1.58),('1444','2014-02-19','13:55:00',1.41),('1444','2014-02-19','14:00:00',1.31),('1444','2014-02-19','14:05:00',1.38),('1444','2014-02-19','14:10:00',1.11),('1444','2014-02-19','14:15:00',1.05),('1444','2014-02-19','14:20:00',1.58),('1444','2014-02-19','14:25:00',1.24),('1444','2014-02-19','14:30:00',1.17),('1444','2014-02-19','14:35:00',1.26),('1444','2014-02-19','14:50:00',1.19),('1444','2014-02-19','14:55:00',1.01),('1444','2014-02-18','09:10:00',1.04),('1444','2014-02-18','09:15:00',1.1),('1444','2014-02-18','09:20:00',1.16),('1444','2014-02-18','09:25:00',1.22),('1444','2014-02-18','09:30:00',1.28),('1444','2014-02-18','09:35:00',1.33),('1444','2014-02-18','09:40:00',1.37),('1444','2014-02-18','09:45:00',1.4),('1444','2014-02-18','09:50:00',1.46),('1444','2014-02-18','09:55:00',1.51),('1444','2014-02-18','10:00:00',1.55),('1444','2014-02-18','10:05:00',1.59),('1444','2014-02-18','10:10:00',1.61),('1444','2014-02-18','10:15:00',1.65),('1444','2014-02-18','10:20:00',1.68),('1444','2014-02-18','10:25:00',1.72),('1444','2014-02-18','10:30:00',1.74),('1444','2014-02-18','10:35:00',1.77),('1444','2014-02-18','10:40:00',1.8),('1444','2014-02-18','10:45:00',1.83),('1444','2014-02-18','10:50:00',1.86),('1444','2014-02-18','10:55:00',1.89),('1444','2014-02-18','11:00:00',1.9),('1444','2014-02-18','11:05:00',1.61),('1444','2014-02-18','11:10:00',1.57),('1444','2014-02-18','11:15:00',1.52),('1444','2014-02-18','11:20:00',1.79),('1444','2014-02-18','11:25:00',1.96),('1444','2014-02-18','11:30:00',1.75),('1444','2014-02-18','11:35:00',1.67),('1444','2014-02-18','11:40:00',1.39),('1444','2014-02-18','11:45:00',1.42),('1444','2014-02-18','11:50:00',1.2),('1444','2014-02-18','11:55:00',1.06),('1444','2014-02-18','12:00:00',1.06),('1444','2014-02-18','12:05:00',1.08),('1444','2014-02-18','12:10:00',1.24),('1444','2014-02-18','12:15:00',1.29),('1444','2014-02-18','12:20:00',1.3),('1444','2014-02-18','12:25:00',1.5),('1444','2014-02-18','12:30:00',1.61),('1444','2014-02-18','12:35:00',1.22),('1444','2014-02-18','12:40:00',1.14),('1444','2014-02-18','12:45:00',1.1),('1444','2014-02-18','12:50:00',1.19),('1444','2014-02-18','12:55:00',1.24),('1444','2014-02-18','13:10:00',1.02),('1444','2014-02-18','13:15:00',1.32),('1444','2014-02-18','13:20:00',1.42),('1444','2014-02-18','13:25:00',1.67),('1444','2014-02-18','13:30:00',1.18),('1444','2014-02-18','13:35:00',1.01),('1444','2014-02-18','13:40:00',1.31),('1444','2014-02-18','13:45:00',1.46),('1444','2014-02-18','13:50:00',1.14),('1444','2014-02-18','13:55:00',1.14),('1444','2014-02-18','14:00:00',1.26),('1444','2014-02-18','14:05:00',1.78),('1444','2014-02-18','14:10:00',1.05),('1444','2014-02-17','09:15:00',1.02),('1444','2014-02-17','09:20:00',1.09),('1444','2014-02-17','09:25:00',1.14),('1444','2014-02-17','09:30:00',1.22),('1444','2014-02-17','09:35:00',1.25),('1444','2014-02-17','09:40:00',1.3),('1444','2014-02-17','09:45:00',1.33),('1444','2014-02-17','09:50:00',1.36),('1444','2014-02-17','09:55:00',1.39),('1444','2014-02-17','10:00:00',1.43),('1444','2014-02-17','10:05:00',1.48),('1444','2014-02-17','10:10:00',1.51),('1444','2014-02-17','10:15:00',1.53),('1444','2014-02-17','10:20:00',1.51),('1444','2014-02-17','10:25:00',1.57),('1444','2014-02-17','10:30:00',1.61),('1444','2014-02-17','10:35:00',1.62),('1444','2014-02-17','10:40:00',1.63),('1444','2014-02-17','10:45:00',1.65),('1444','2014-02-17','10:50:00',1.67),('1444','2014-02-17','10:55:00',1.7),('1444','2014-02-17','11:00:00',1.72),('1444','2014-02-17','11:05:00',1.75),('1444','2014-02-17','11:10:00',1.77),('1444','2014-02-17','11:15:00',1.78),('1444','2014-02-17','11:20:00',1.82),('1444','2014-02-17','11:25:00',1.86),('1444','2014-02-17','11:30:00',1.92),('1444','2014-02-17','11:35:00',1.95),('1444','2014-02-17','11:40:00',1.96),('1444','2014-02-17','11:45:00',1.98),('1444','2014-02-17','11:50:00',1.99),('1444','2014-02-17','11:55:00',2),('1444','2014-02-17','12:00:00',2),('1444','2014-02-17','12:05:00',2),('1444','2014-02-17','12:10:00',2),('1444','2014-02-17','12:15:00',1.99),('1444','2014-02-17','12:20:00',1.99),('1444','2014-02-17','12:25:00',1.99),('1444','2014-02-17','12:30:00',1.98),('1444','2014-02-17','12:35:00',1.98),('1444','2014-02-17','12:40:00',1.96),('1444','2014-02-17','12:45:00',1.95),('1444','2014-02-17','12:50:00',1.93),('1444','2014-02-17','12:55:00',1.92),('1444','2014-02-17','13:00:00',1.92),('1444','2014-02-17','13:05:00',1.9),('1444','2014-02-17','13:10:00',1.89),('1444','2014-02-17','13:15:00',1.87),('1444','2014-02-17','13:20:00',1.86),('1444','2014-02-17','13:25:00',1.86),('1444','2014-02-17','13:30:00',1.85),('1444','2014-02-17','13:35:00',1.83),('1444','2014-02-17','13:40:00',1.81),('1444','2014-02-17','13:45:00',1.73),('1444','2014-02-17','13:50:00',1.74),('1444','2014-02-17','13:55:00',1.73),('1444','2014-02-17','14:00:00',1.69),('1444','2014-02-17','14:05:00',1.68),('1444','2014-02-17','14:10:00',1.6),('1444','2014-02-17','14:15:00',1.55),('1444','2014-02-17','14:20:00',1.6),('1444','2014-02-17','14:25:00',1.53),('1444','2014-02-17','14:30:00',1.47),('1444','2014-02-17','14:35:00',1.41),('1444','2014-02-17','14:40:00',1.3),('1444','2014-02-17','14:45:00',1.42),('1444','2014-02-17','14:50:00',1.33),('1444','2014-02-17','14:55:00',1.31),('1444','2014-02-17','15:00:00',1.23),('1444','2014-02-17','15:05:00',1.21),('1444','2014-02-17','15:10:00',1.17),('1444','2014-02-17','15:15:00',1.17),('1444','2014-02-17','15:20:00',1.13),('1444','2014-02-17','15:25:00',1.05),('1444','2014-02-17','15:30:00',1.02),('1444','2014-02-16','09:05:00',1.03),('1444','2014-02-16','09:10:00',1.02),('1444','2014-02-16','09:20:00',1.12),('1444','2014-02-16','09:25:00',1.09),('1444','2014-02-16','09:30:00',1.14),('1444','2014-02-16','09:40:00',1.31),('1444','2014-02-16','09:45:00',1.37),('1444','2014-02-16','09:50:00',1.45),('1444','2014-02-16','09:55:00',1.4),('1444','2014-02-16','10:00:00',1.42),('1444','2014-02-16','10:05:00',1.54),('1444','2014-02-16','10:10:00',1.6),('1444','2014-02-16','10:15:00',1.64),('1444','2014-02-16','10:20:00',1.69),('1444','2014-02-16','10:25:00',1.75),('1444','2014-02-16','10:30:00',1.78),('1444','2014-02-16','10:35:00',1.85),('1444','2014-02-16','10:40:00',1.86),('1444','2014-02-16','10:45:00',1.86),('1444','2014-02-16','10:50:00',1.58),('1444','2014-02-16','10:55:00',1.69),('1444','2014-02-16','11:00:00',1.92),('1444','2014-02-16','11:05:00',1.96),('1444','2014-02-16','11:10:00',1.88),('1444','2014-02-16','11:15:00',1.94),('1444','2014-02-16','11:20:00',1.84),('1444','2014-02-16','11:25:00',1.91),('1444','2014-02-16','11:30:00',1.93),('1444','2014-02-16','11:35:00',2),('1444','2014-02-16','11:40:00',2),('1444','2014-02-16','11:45:00',1.83),('1444','2014-02-16','11:50:00',2.03),('1444','2014-02-16','11:55:00',1.71),('1444','2014-02-16','12:00:00',2.03),('1444','2014-02-16','12:05:00',1.99),('1444','2014-02-16','12:10:00',1.98),('1444','2014-02-16','12:15:00',2.04),('1444','2014-02-16','12:20:00',2.05),('1444','2014-02-16','12:25:00',2.01),('1444','2014-02-16','12:30:00',2.01),('1444','2014-02-16','12:35:00',2.01),('1444','2014-02-16','12:40:00',2.02),('1444','2014-02-16','12:45:00',2.02),('1444','2014-02-16','12:50:00',2.01),('1444','2014-02-16','12:55:00',2),('1444','2014-02-16','13:00:00',1.99),('1444','2014-02-16','13:05:00',2),('1444','2014-02-16','13:10:00',1.91),('1444','2014-02-16','13:15:00',1.93),('1444','2014-02-16','13:20:00',1.91),('1444','2014-02-16','13:25:00',1.89),('1444','2014-02-16','13:30:00',1.9),('1444','2014-02-16','13:35:00',1.86),('1444','2014-02-16','13:40:00',1.89),('1444','2014-02-16','13:45:00',1.88),('1444','2014-02-16','13:50:00',1.85),('1444','2014-02-16','13:55:00',1.83),('1444','2014-02-16','14:00:00',1.81),('1444','2014-02-16','14:05:00',1.78),('1444','2014-02-16','14:10:00',1.75),('1444','2014-02-16','14:15:00',1.7),('1444','2014-02-16','14:20:00',1.68),('1444','2014-02-16','14:25:00',1.67),('1444','2014-02-16','14:30:00',1.63),('1444','2014-02-16','14:35:00',1.58),('1444','2014-02-16','14:40:00',1.51),('1444','2014-02-16','14:45:00',1.48),('1444','2014-02-16','14:50:00',1.44),('1444','2014-02-16','14:55:00',1.41),('1444','2014-02-16','15:00:00',1.35),('1444','2014-02-16','15:05:00',1.33),('1444','2014-02-16','15:10:00',1.26),('1444','2014-02-16','15:15:00',1.21),('1444','2014-02-16','15:20:00',1.14),('1444','2014-02-16','15:25:00',1.09),('1444','2014-02-16','15:30:00',1.04),('1444','2014-04-28','08:15:00',1.36),('1444','2014-04-28','08:20:00',1.33),('1444','2014-04-28','08:25:00',1.3),('1444','2014-04-28','08:40:00',1.01),('1444','2014-04-28','08:45:00',1.04),('1444','2014-04-28','08:50:00',1.13),('1444','2014-04-28','09:05:00',1.39),('1444','2014-04-28','09:10:00',2.19),('1444','2014-04-28','09:15:00',2.49),('1444','2014-04-28','09:20:00',1.46),('1444','2014-04-28','09:25:00',1.47),('1444','2014-04-28','09:30:00',2.26),('1444','2014-04-28','09:35:00',1.95),('1444','2014-04-28','09:40:00',1.27),('1444','2014-04-28','09:45:00',1.52),('1444','2014-04-28','09:50:00',1.35),('1444','2014-04-28','09:55:00',1.25),('1444','2014-04-28','10:00:00',1.94),('1444','2014-04-28','10:05:00',1.85),('1444','2014-04-28','10:10:00',1.87),('1444','2014-04-28','10:15:00',1.51),('1444','2014-04-28','10:20:00',1.2),('1444','2014-04-28','10:45:00',1.38),('1444','2014-04-28','10:50:00',1.55),('1444','2014-04-28','10:55:00',1.35),('1444','2014-04-28','11:00:00',1.65),('1444','2014-04-28','11:05:00',1.98),('1444','2014-04-28','11:10:00',2.19),('1444','2014-04-28','11:15:00',2.09),('1444','2014-04-28','11:20:00',1.75),('1444','2014-04-28','11:25:00',1.58),('1444','2014-04-28','11:30:00',1.54),('1444','2014-04-28','11:35:00',1.31),('1444','2014-04-28','11:40:00',1.2),('1444','2014-04-28','11:45:00',1.37),('1444','2014-04-28','11:50:00',1.58),('1444','2014-04-28','11:55:00',1.65),('1444','2014-04-28','12:00:00',1.41),('1444','2014-04-28','12:05:00',1.22),('1444','2014-04-28','12:10:00',1.76),('1444','2014-04-28','12:15:00',2.21),('1444','2014-04-28','12:20:00',2.25),('1444','2014-04-28','12:25:00',2.21),('1444','2014-04-28','12:30:00',2.27),('1444','2014-04-28','12:35:00',2.02),('1444','2014-04-28','12:40:00',1.71),('1444','2014-04-28','12:45:00',1.61),('1444','2014-04-28','12:50:00',1.82),('1444','2014-04-28','12:55:00',1.8),('1444','2014-04-28','13:00:00',1.86),('1444','2014-04-28','13:05:00',2.81),('1444','2014-04-28','13:10:00',2.05),('1444','2014-04-28','13:15:00',1.83),('1444','2014-04-28','13:20:00',2.11),('1444','2014-04-28','13:25:00',2.68),('1444','2014-04-28','13:30:00',3.94),('1444','2014-04-28','13:35:00',2.35),('1444','2014-04-28','13:40:00',1.47),('1444','2014-04-28','13:45:00',3.65),('1444','2014-04-28','13:50:00',2.9),('1444','2014-04-28','13:55:00',1.88),('1444','2014-04-28','14:00:00',1.39),('1444','2014-04-28','14:05:00',2.82),('1444','2014-04-28','14:10:00',3.1),('1444','2014-04-28','14:15:00',2.26),('1444','2014-04-28','14:20:00',3.18),('1444','2014-04-28','14:25:00',2.21),('1444','2014-04-28','14:30:00',2.62),('1444','2014-04-28','14:35:00',1.84),('1444','2014-04-28','14:40:00',2.4),('1444','2014-04-28','14:45:00',1.98),('1444','2014-04-28','14:50:00',2.95),('1444','2014-04-28','14:55:00',1.83),('1444','2014-04-28','15:00:00',3.05),('1444','2014-04-28','15:05:00',3.65),('1444','2014-04-28','15:10:00',1.11),('1444','2014-04-28','15:20:00',1.04),('1444','2014-04-28','15:25:00',1.76),('1444','2014-04-28','15:30:00',1.39),('1444','2014-04-28','15:35:00',3.83),('1444','2014-04-28','15:40:00',3.05),('1444','2014-04-28','15:45:00',2.16),('1444','2014-04-28','15:50:00',1.25),('1444','2014-04-28','15:55:00',1.08),('1444','2014-04-28','16:00:00',2.36),('1444','2014-04-28','16:05:00',1.83),('1444','2014-04-28','16:10:00',2.95),('1444','2014-04-28','16:15:00',2.11),('1444','2014-04-28','16:20:00',1.76),('1444','2014-04-28','16:25:00',2.09),('1444','2014-04-28','16:30:00',2.39),('1444','2014-04-28','16:35:00',1.67),('1444','2014-04-28','16:55:00',1.07),('1444','2014-04-28','17:35:00',1.13),('1444','2014-04-28','17:40:00',1.05),('1444','2014-02-15','09:15:00',1.03),('1444','2014-02-15','09:20:00',1.08),('1444','2014-02-15','09:25:00',1.13),('1444','2014-02-15','09:30:00',1.16),('1444','2014-02-15','09:35:00',1.24),('1444','2014-02-15','09:40:00',1.29),('1444','2014-02-15','09:45:00',1.35),('1444','2014-02-15','09:50:00',1.38),('1444','2014-02-15','09:55:00',1.42),('1444','2014-02-15','10:00:00',1.46),('1444','2014-02-15','10:05:00',1.49),('1444','2014-02-15','10:10:00',1.53),('1444','2014-02-15','10:15:00',1.57),('1444','2014-02-15','10:20:00',1.59),('1444','2014-02-15','10:25:00',1.62),('1444','2014-02-15','10:30:00',1.65),('1444','2014-02-15','10:35:00',1.66),('1444','2014-02-15','10:40:00',1.7),('1444','2014-02-15','10:45:00',1.76),('1444','2014-02-15','10:50:00',1.77),('1444','2014-02-15','10:55:00',1.77),('1444','2014-02-15','11:00:00',1.78),('1444','2014-02-15','11:05:00',1.93),('1444','2014-02-15','11:10:00',1.94),('1444','2014-02-15','11:15:00',1.71),('1444','2014-02-15','11:20:00',1.29),('1444','2014-02-15','11:25:00',2.27),('1444','2014-02-15','11:30:00',1.17),('1444','2014-02-15','11:35:00',2.34),('1444','2014-02-15','11:40:00',1.9),('1444','2014-02-15','11:45:00',2.25),('1444','2014-02-15','11:50:00',1.69),('1444','2014-02-15','11:55:00',1.27),('1444','2014-02-15','12:05:00',1.12),('1444','2014-02-15','12:10:00',2.21),('1444','2014-02-15','12:15:00',2.17),('1444','2014-02-15','12:20:00',2.02),('1444','2014-02-15','12:30:00',2.42),('1444','2014-02-15','12:35:00',2.02),('1444','2014-02-15','12:40:00',2.43),('1444','2014-02-15','12:45:00',2.29),('1444','2014-02-15','12:50:00',1.13),('1444','2014-02-15','12:55:00',1.56),('1444','2014-02-15','13:00:00',2.17),('1444','2014-02-15','13:05:00',2.27),('1444','2014-02-15','13:10:00',2.21),('1444','2014-02-15','13:15:00',2.09),('1444','2014-02-15','13:20:00',2.06),('1444','2014-02-15','13:25:00',1.99),('1444','2014-02-15','13:30:00',1.95),('1444','2014-02-15','13:35:00',1.91),('1444','2014-02-15','13:40:00',1.88),('1444','2014-02-15','13:45:00',1.85),('1444','2014-02-15','13:50:00',1.86),('1444','2014-02-15','13:55:00',1.78),('1444','2014-02-15','14:00:00',1.75),('1444','2014-02-15','14:05:00',1.74),('1444','2014-02-15','14:10:00',1.69),('1444','2014-02-15','14:15:00',1.67),('1444','2014-02-15','14:20:00',1.61),('1444','2014-02-15','14:25:00',1.59),('1444','2014-02-15','14:30:00',1.55),('1444','2014-02-15','14:35:00',1.51),('1444','2014-02-15','14:40:00',1.44),('1444','2014-02-15','14:45:00',1.42),('1444','2014-02-15','14:50:00',1.3),('1444','2014-02-15','14:55:00',1.22),('1444','2014-02-15','15:00:00',1.3),('1444','2014-02-15','15:05:00',1.26),('1444','2014-02-15','15:10:00',1.22),('1444','2014-02-15','15:15:00',1.17),('1444','2014-02-15','15:20:00',1.13),('1444','2014-02-15','15:25:00',1.08),('1444','2014-02-15','15:30:00',1.03),('1444','2014-02-14','09:15:00',1.09),('1444','2014-02-14','09:30:00',1.4),('1444','2014-02-14','09:45:00',1.02),('1444','2014-02-14','09:50:00',1.62),('1444','2014-02-14','09:55:00',1.51),('1444','2014-02-14','10:00:00',1.51),('1444','2014-02-14','10:05:00',1.53),('1444','2014-02-14','10:10:00',1.27),('1444','2014-02-14','10:15:00',1.29),('1444','2014-02-14','10:20:00',1.78),('1444','2014-02-14','10:25:00',1.75),('1444','2014-02-14','10:30:00',1.77),('1444','2014-02-14','10:35:00',1.75),('1444','2014-02-14','10:40:00',1.78),('1444','2014-02-14','10:45:00',1.84),('1444','2014-02-14','10:50:00',1.8),('1444','2014-02-14','10:55:00',1.89),('1444','2014-02-14','11:00:00',1.81),('1444','2014-02-14','11:05:00',1.95),('1444','2014-02-14','11:10:00',1.96),('1444','2014-02-14','11:15:00',1.98),('1444','2014-02-14','11:20:00',2),('1444','2014-02-14','11:25:00',2.04),('1444','2014-02-14','11:30:00',2.06),('1444','2014-02-14','11:35:00',2.06),('1444','2014-02-14','11:40:00',2.1),('1444','2014-02-14','11:45:00',2.1),('1444','2014-02-14','11:50:00',2.13),('1444','2014-02-14','11:55:00',2.13),('1444','2014-02-14','12:00:00',1.81),('1444','2014-02-14','12:05:00',2.08),('1444','2014-02-14','12:10:00',2.15),('1444','2014-02-14','12:15:00',2.14),('1444','2014-02-14','12:20:00',2.14),('1444','2014-02-14','12:25:00',2.13),('1444','2014-02-14','12:30:00',2.13),('1444','2014-02-14','12:35:00',2.13),('1444','2014-02-14','12:40:00',2.12),('1444','2014-02-14','12:45:00',2.1),('1444','2014-02-14','12:50:00',2.08),('1444','2014-02-14','12:55:00',2.08),('1444','2014-02-14','13:00:00',2.07),('1444','2014-02-14','13:05:00',2.05),('1444','2014-02-14','13:10:00',2.05),('1444','2014-02-14','13:15:00',2.02),('1444','2014-02-14','13:20:00',2),('1444','2014-02-14','13:25:00',2),('1444','2014-02-14','13:30:00',1.96),('1444','2014-02-14','13:35:00',1.94),('1444','2014-02-14','13:40:00',1.91),('1444','2014-02-14','13:45:00',1.89),('1444','2014-02-14','13:50:00',1.86),('1444','2014-02-14','13:55:00',1.85),('1444','2014-02-14','14:00:00',1.82),('1444','2014-02-14','14:05:00',1.78),('1444','2014-02-14','14:10:00',1.74),('1444','2014-02-14','14:15:00',1.7),('1444','2014-02-14','14:20:00',1.67),('1444','2014-02-14','14:25:00',1.63),('1444','2014-02-14','14:30:00',1.6),('1444','2014-02-14','14:35:00',1.56),('1444','2014-02-14','14:40:00',1.5),('1444','2014-02-14','14:45:00',1.45),('1444','2014-02-14','14:50:00',1.41),('1444','2014-02-14','14:55:00',1.33),('1444','2014-02-14','15:00:00',1.3),('1444','2014-02-14','15:05:00',1.28),('1444','2014-02-14','15:10:00',1.23),('1444','2014-02-14','15:15:00',1.18),('1444','2014-02-14','15:20:00',1.14),('1444','2014-02-14','15:25:00',1.08),('1444','2014-02-14','15:30:00',1.04),('1444','2014-02-13','09:15:00',1.04),('1444','2014-02-13','09:20:00',1.09),('1444','2014-02-13','09:25:00',1.14),('1444','2014-02-13','09:30:00',1.17),('1444','2014-02-13','09:35:00',1.19),('1444','2014-02-13','09:40:00',1.23),('1444','2014-02-13','09:45:00',1.27),('1444','2014-02-13','09:50:00',1.38),('1444','2014-02-13','09:55:00',1.45),('1444','2014-02-13','10:00:00',1.49),('1444','2014-02-13','10:05:00',1.53),('1444','2014-02-13','10:10:00',1.57),('1444','2014-02-13','10:15:00',1.57),('1444','2014-02-13','10:20:00',1.62),('1444','2014-02-13','10:25:00',1.66),('1444','2014-02-13','10:30:00',1.69),('1444','2014-02-13','10:35:00',1.72),('1444','2014-02-13','10:40:00',1.7),('1444','2014-02-13','10:45:00',1.73),('1444','2014-02-13','10:50:00',1.76),('1444','2014-02-13','10:55:00',1.83),('1444','2014-02-13','11:00:00',1.85),('1444','2014-02-13','11:05:00',1.89),('1444','2014-02-13','11:10:00',1.92),('1444','2014-02-13','11:15:00',1.95),('1444','2014-02-13','11:20:00',1.94),('1444','2014-02-13','11:25:00',2),('1444','2014-02-13','11:30:00',1.25),('1444','2014-02-13','11:35:00',1.02),('1444','2014-02-13','11:40:00',1.95),('1444','2014-02-13','11:45:00',2.11),('1444','2014-02-13','11:50:00',2.3),('1444','2014-02-13','11:55:00',1.73),('1444','2014-02-13','12:00:00',1.08),('1444','2014-02-13','12:05:00',1.69),('1444','2014-02-13','12:10:00',1.68),('1444','2014-02-13','12:15:00',1.72),('1444','2014-02-13','12:20:00',1.93),('1444','2014-02-13','12:25:00',2.58),('1444','2014-02-13','12:30:00',2.54),('1444','2014-02-13','12:35:00',2.44),('1444','2014-02-13','12:50:00',1.43),('1444','2014-02-13','12:55:00',2.07),('1444','2014-02-13','13:00:00',2.18),('1444','2014-02-13','13:05:00',2.13),('1444','2014-02-13','13:10:00',2.08),('1444','2014-02-13','13:15:00',2.06),('1444','2014-02-13','13:20:00',2.04),('1444','2014-02-13','13:25:00',2.03),('1444','2014-02-13','13:30:00',2),('1444','2014-02-13','13:35:00',1.97),('1444','2014-02-13','13:40:00',1.93),('1444','2014-02-13','13:45:00',1.92),('1444','2014-02-13','13:50:00',1.9),('1444','2014-02-13','13:55:00',1.87),('1444','2014-02-13','14:00:00',1.84),('1444','2014-02-13','14:05:00',1.81),('1444','2014-02-13','14:10:00',1.76),('1444','2014-02-13','14:15:00',1.72),('1444','2014-02-13','14:20:00',1.71),('1444','2014-02-13','14:25:00',1.66),('1444','2014-02-13','14:30:00',1.63),('1444','2014-02-13','14:35:00',1.61),('1444','2014-02-13','14:40:00',1.05),('1444','2014-02-13','14:50:00',1.3),('1444','2014-02-13','14:55:00',1.51),('1444','2014-02-13','15:00:00',1.07),('1444','2014-02-13','15:05:00',1.44),('1444','2014-02-13','15:10:00',1.06),('1444','2014-02-13','15:15:00',1.29),('1444','2014-02-13','15:20:00',1.24),('1444','2014-02-13','15:40:00',1.06),('1444','2014-02-12','09:15:00',1.04),('1444','2014-02-12','09:45:00',1.27),('1444','2014-02-12','09:50:00',1.57),('1444','2014-02-12','10:05:00',1.12),('1444','2014-02-12','10:30:00',1.01),('1444','2014-02-12','10:35:00',1.12),('1444','2014-02-12','10:40:00',1.03),('1444','2014-02-12','10:45:00',1.2),('1444','2014-02-12','11:00:00',1.09),('1444','2014-02-12','11:05:00',1.38),('1444','2014-02-12','11:10:00',1.06),('1444','2014-02-12','11:15:00',1),('1444','2014-02-12','11:25:00',1.11),('1444','2014-02-12','11:30:00',1.07),('1444','2014-02-12','11:35:00',1.13),('1444','2014-02-12','12:30:00',1.05),('1444','2014-02-12','12:35:00',1.01),('1444','2014-02-12','12:45:00',1.11),('1444','2014-02-12','12:50:00',1.22),('1444','2014-02-12','12:55:00',1.24),('1444','2014-02-12','13:00:00',1.31),('1444','2014-02-12','13:05:00',1.26),('1444','2014-02-12','13:10:00',1.08),('1444','2014-02-12','13:25:00',1.04),('1444','2014-02-12','13:30:00',1.85),('1444','2014-02-12','13:35:00',2.31),('1444','2014-02-12','13:40:00',1.67),('1444','2014-02-12','13:45:00',1.62),('1444','2014-02-12','13:50:00',1.48),('1444','2014-02-12','13:55:00',1.16),('1444','2014-02-12','14:00:00',1.86),('1444','2014-02-12','14:05:00',2),('1444','2014-02-12','14:10:00',1.92),('1444','2014-02-12','14:15:00',1.78),('1444','2014-02-12','14:20:00',1.79),('1444','2014-02-12','14:25:00',1.19),('1444','2014-02-12','14:30:00',1.33),('1444','2014-02-12','14:35:00',1.27),('1444','2014-02-12','14:40:00',1.31),('1444','2014-02-12','14:45:00',1.67),('1444','2014-02-12','14:50:00',1.51),('1444','2014-02-12','14:55:00',1.28),('1444','2014-02-12','15:15:00',1.11),('1444','2014-02-12','15:20:00',1.05),('1444','2014-02-12','15:30:00',1.2),('1444','2014-02-12','15:35:00',1.36),('1444','2014-02-12','15:40:00',1.23),('1444','2014-02-11','10:15:00',1.07),('1444','2014-02-11','10:20:00',1.27),('1444','2014-02-11','10:25:00',1.29),('1444','2014-02-11','10:30:00',1.41),('1444','2014-02-11','10:35:00',1.54),('1444','2014-02-11','10:40:00',1.5),('1444','2014-02-11','10:45:00',1.46),('1444','2014-02-11','10:50:00',1.57),('1444','2014-02-11','10:55:00',1.41),('1444','2014-02-11','11:00:00',1.52),('1444','2014-02-11','11:05:00',1.45),('1444','2014-02-11','11:10:00',1.47),('1444','2014-02-11','11:15:00',1.35),('1444','2014-02-11','11:20:00',1.09),('1444','2014-02-11','11:25:00',1.04),('1444','2014-02-11','11:30:00',1.28),('1444','2014-02-11','11:35:00',1.24),('1444','2014-02-11','11:40:00',1.33),('1444','2014-02-11','11:45:00',1.46),('1444','2014-02-11','11:50:00',1.22),('1444','2014-02-11','12:05:00',1.27),('1444','2014-02-11','12:10:00',1.34),('1444','2014-02-11','12:15:00',1.14),('1444','2014-02-11','12:20:00',1.22),('1444','2014-02-11','12:25:00',1.59),('1444','2014-02-11','12:30:00',1.51),('1444','2014-02-11','12:35:00',1.35),('1444','2014-02-11','12:40:00',1.03),('1444','2014-02-11','12:45:00',1.2),('1444','2014-02-11','12:55:00',1.2),('1444','2014-02-11','13:00:00',1.23),('1444','2014-02-11','13:05:00',1.52),('1444','2014-02-11','13:10:00',1.82),('1444','2014-02-11','13:15:00',1.79),('1444','2014-02-11','13:20:00',1.98),('1444','2014-02-11','13:25:00',1.78),('1444','2014-02-11','13:30:00',1.65),('1444','2014-02-11','13:35:00',1.53),('1444','2014-02-11','13:40:00',1.84),('1444','2014-02-11','13:45:00',1.32),('1444','2014-02-11','13:50:00',1.12),('1444','2014-02-11','14:00:00',1.26),('1444','2014-02-11','14:05:00',1.45),('1444','2014-02-11','14:10:00',1.07),('1444','2014-02-11','14:15:00',1.39),('1444','2014-02-11','14:20:00',1),('1444','2014-02-09','12:25:00',1.06),('1444','2014-02-09','12:30:00',1.01),('1444','2014-02-09','12:45:00',1.69),('1444','2014-02-09','12:55:00',1.35),('1444','2014-02-09','13:00:00',1.43),('1444','2014-02-09','13:05:00',2.21),('1444','2014-02-09','13:10:00',1.28),('1444','2014-02-09','13:45:00',1.56),('1444','2014-02-09','13:55:00',1.29),('1444','2014-02-09','14:00:00',1.15),('1444','2014-02-09','14:05:00',1.8),('1444','2014-02-09','14:10:00',1.54),('1444','2014-02-09','14:25:00',1.06),('1444','2014-02-09','14:30:00',1.27),('1444','2014-02-09','14:35:00',1.27),('1444','2014-02-09','14:50:00',1.24),('1444','2014-02-08','09:50:00',1.49),('1444','2014-02-08','10:30:00',1.48),('1444','2014-02-08','10:35:00',1.51),('1444','2014-02-08','10:50:00',1.3),('1444','2014-02-08','10:55:00',1.3),('1444','2014-02-08','11:00:00',1.32),('1444','2014-02-08','11:05:00',1.7),('1444','2014-02-08','11:10:00',1.24),('1444','2014-02-08','11:15:00',1.41),('1444','2014-02-08','11:30:00',1.48),('1444','2014-02-08','11:35:00',2.47),('1444','2014-02-08','11:40:00',1.04),('1444','2014-02-08','11:50:00',1.33),('1444','2014-02-08','11:55:00',2.08),('1444','2014-02-08','12:10:00',1.72),('1444','2014-02-08','12:15:00',1.9),('1444','2014-02-08','12:25:00',1.71),('1444','2014-02-08','12:30:00',1.9),('1444','2014-02-08','12:35:00',1.51),('1444','2014-02-08','12:40:00',1.72),('1444','2014-02-08','12:45:00',2.27),('1444','2014-02-08','12:50:00',1.27),('1444','2014-02-08','12:55:00',1.13),('1444','2014-02-08','13:00:00',1.46),('1444','2014-02-08','13:10:00',1.73),('1444','2014-02-08','13:15:00',2.49),('1444','2014-02-08','13:20:00',2.33),('1444','2014-02-08','13:25:00',2.07),('1444','2014-02-08','13:30:00',1.48),('1444','2014-02-08','13:35:00',1.11),('1444','2014-02-08','13:40:00',1.61),('1444','2014-02-08','13:45:00',2.02),('1444','2014-02-08','13:50:00',1.54),('1444','2014-02-08','13:55:00',1.83),('1444','2014-02-08','14:00:00',1.7),('1444','2014-02-08','14:05:00',1.24),('1444','2014-02-08','14:10:00',1.62),('1444','2014-02-08','14:20:00',1.51),('1444','2014-02-08','14:25:00',1.14),('1444','2014-02-08','14:30:00',1.76),('1444','2014-02-08','14:35:00',1.13),('1444','2014-02-08','14:40:00',1.06),('1444','2014-02-08','14:50:00',1.58),('1444','2014-02-08','15:15:00',1.04),('1444','2014-02-08','15:20:00',1.21),('1444','2014-02-08','15:40:00',1.2),('1444','2014-02-07','09:25:00',1),('1444','2014-02-07','09:30:00',1.05),('1444','2014-02-07','09:35:00',1.1),('1444','2014-02-07','09:40:00',1.14),('1444','2014-02-07','09:45:00',1.18),('1444','2014-02-07','09:50:00',1.23),('1444','2014-02-07','09:55:00',1.27),('1444','2014-02-07','10:00:00',1.33),('1444','2014-02-07','10:05:00',1.39),('1444','2014-02-07','10:10:00',1.42),('1444','2014-02-07','10:15:00',1.53),('1444','2014-02-07','10:20:00',1.59),('1444','2014-02-07','10:25:00',1.2),('1444','2014-02-07','10:30:00',1.68),('1444','2014-02-07','10:35:00',1.77),('1444','2014-02-07','10:40:00',1.37),('1444','2014-02-07','10:45:00',1.84),('1444','2014-02-07','10:50:00',1.74),('1444','2014-02-07','10:55:00',1.81),('1444','2014-02-07','11:00:00',1.74),('1444','2014-02-07','11:05:00',2.04),('1444','2014-02-07','11:10:00',2.07),('1444','2014-02-07','11:15:00',2.1),('1444','2014-02-07','11:20:00',1.64),('1444','2014-02-07','11:25:00',1.85),('1444','2014-02-07','11:30:00',1.6),('1444','2014-02-07','11:35:00',1.98),('1444','2014-02-07','11:40:00',2.07),('1444','2014-02-07','11:45:00',1.37),('1444','2014-02-07','11:50:00',2.23),('1444','2014-02-07','11:55:00',1.52),('1444','2014-02-07','12:00:00',1.44),('1444','2014-02-07','12:05:00',1.35),('1444','2014-02-07','12:10:00',1.79),('1444','2014-02-07','12:15:00',2.36),('1444','2014-02-07','12:20:00',2.17),('1444','2014-02-07','12:25:00',1.11),('1444','2014-02-07','12:40:00',1.15),('1444','2014-02-07','12:45:00',1.42),('1444','2014-02-07','12:50:00',2.52),('1444','2014-02-07','12:55:00',1.3),('1444','2014-02-07','13:05:00',1.63),('1444','2014-02-07','13:10:00',1.99),('1444','2014-02-07','13:15:00',1.33),('1444','2014-02-07','13:20:00',1.41),('1444','2014-02-07','13:35:00',1.12),('1444','2014-02-07','13:45:00',2.19),('1444','2014-02-07','13:50:00',1.85),('1444','2014-02-07','13:55:00',1.77),('1444','2014-02-07','14:00:00',1.29),('1444','2014-02-07','14:05:00',1.7),('1444','2014-02-07','14:10:00',1.77),('1444','2014-02-07','14:15:00',1.77),('1444','2014-02-07','14:20:00',1.23),('1444','2014-02-07','14:25:00',1.16),('1444','2014-02-07','14:30:00',1.7),('1444','2014-02-07','14:35:00',1.75),('1444','2014-02-07','14:40:00',1.56),('1444','2014-02-07','14:45:00',1.39),('1444','2014-02-07','14:50:00',1.36),('1444','2014-02-07','14:55:00',1.29),('1444','2014-02-07','15:00:00',1.24),('1444','2014-02-07','15:05:00',1.19),('1444','2014-02-07','15:10:00',1.14),('1444','2014-02-07','15:15:00',1.09),('1444','2014-02-07','15:20:00',1.09),('1444','2014-02-06','09:00:00',1.07),('1444','2014-02-06','09:05:00',1.22),('1444','2014-02-06','09:10:00',1.11),('1444','2014-02-06','09:15:00',1.03),('1444','2014-02-06','09:35:00',1.14),('1444','2014-02-06','09:40:00',1.17),('1444','2014-02-06','09:45:00',1.2),('1444','2014-02-06','09:50:00',1.26),('1444','2014-02-06','09:55:00',1.29),('1444','2014-02-06','10:00:00',1.33),('1444','2014-02-06','10:05:00',1.4),('1444','2014-02-06','10:10:00',1.45),('1444','2014-02-06','10:15:00',1.5),('1444','2014-02-06','10:20:00',1.54),('1444','2014-02-06','10:25:00',1.52),('1444','2014-02-06','10:30:00',1.64),('1444','2014-02-06','10:35:00',1.37),('1444','2014-02-06','10:40:00',1.71),('1444','2014-02-06','10:45:00',1.22),('1444','2014-02-06','10:50:00',1.41),('1444','2014-02-06','10:55:00',1.29),('1444','2014-02-06','11:05:00',1.49),('1444','2014-02-06','11:20:00',2.03),('1444','2014-02-06','11:25:00',1.24),('1444','2014-02-06','11:30:00',2.16),('1444','2014-02-06','11:35:00',1.99),('1444','2014-02-06','11:40:00',1.97),('1444','2014-02-06','11:45:00',1.99),('1444','2014-02-06','11:50:00',2),('1444','2014-02-06','11:55:00',2.02),('1444','2014-02-06','12:00:00',2.04),('1444','2014-02-06','12:05:00',2.08),('1444','2014-02-06','12:10:00',2.06),('1444','2014-02-06','12:15:00',2.06),('1444','2014-02-06','12:20:00',1.99),('1444','2014-02-06','12:25:00',2.04),('1444','2014-02-06','12:30:00',2.03),('1444','2014-02-06','12:35:00',1.94),('1444','2014-02-06','12:40:00',1.98),('1444','2014-02-06','12:45:00',2.04),('1444','2014-02-06','12:50:00',2),('1444','2014-02-06','12:55:00',1.99),('1444','2014-02-06','13:00:00',1.99),('1444','2014-02-06','13:05:00',1.79),('1444','2014-02-06','13:10:00',2.05),('1444','2014-02-06','13:15:00',1.99),('1444','2014-02-06','13:20:00',1.98),('1444','2014-02-06','13:25:00',1.54),('1444','2014-02-06','13:30:00',1.66),('1444','2014-02-06','13:35:00',1.95),('1444','2014-02-06','13:40:00',1.87),('1444','2014-02-06','13:45:00',1.83),('1444','2014-02-06','13:50:00',1.85),('1444','2014-02-06','13:55:00',1.82),('1444','2014-02-06','14:00:00',1.72),('1444','2014-02-06','14:05:00',1.75),('1444','2014-02-06','14:10:00',1.7),('1444','2014-02-06','14:15:00',1.6),('1444','2014-02-06','14:20:00',1.52),('1444','2014-02-06','14:25:00',1.54),('1444','2014-02-06','14:30:00',1.54),('1444','2014-02-06','14:35:00',1.27),('1444','2014-02-06','14:40:00',1.23),('1444','2014-02-06','14:50:00',1.42),('1444','2014-02-06','14:55:00',1.29),('1444','2014-02-06','15:00:00',1.25),('1444','2014-02-06','15:05:00',1.21),('1444','2014-02-06','15:10:00',1.15),('1444','2014-02-06','15:15:00',1.11),('1444','2014-02-06','15:20:00',1.08),('1444','2014-04-27','11:15:00',1.02),('1444','2014-04-27','11:35:00',1.19),('1444','2014-04-27','11:40:00',1.44),('1444','2014-04-27','11:45:00',3.05),('1444','2014-04-27','11:50:00',2.53),('1444','2014-04-27','11:55:00',2.25),('1444','2014-04-27','12:00:00',2.04),('1444','2014-04-27','12:05:00',2.36),('1444','2014-04-27','12:10:00',2.51),('1444','2014-04-27','12:15:00',2.58),('1444','2014-04-27','12:20:00',2.21),('1444','2014-04-27','12:25:00',2.15),('1444','2014-04-27','12:30:00',2.08),('1444','2014-04-27','12:35:00',2.05),('1444','2014-04-27','12:40:00',1.92),('1444','2014-04-27','12:45:00',2.27),('1444','2014-04-27','12:50:00',1.8),('1444','2014-04-27','12:55:00',1.97),('1444','2014-04-27','13:00:00',2.15),('1444','2014-04-27','13:05:00',1.71),('1444','2014-04-27','13:10:00',1.49),('1444','2014-04-27','13:15:00',1.58),('1444','2014-04-27','13:20:00',1.97),('1444','2014-04-27','13:25:00',1.76),('1444','2014-04-27','13:30:00',1.63),('1444','2014-04-27','13:35:00',1.43),('1444','2014-04-27','13:40:00',1.4),('1444','2014-04-27','13:45:00',1.4),('1444','2014-04-27','13:50:00',1.37),('1444','2014-04-27','13:55:00',1.26),('1444','2014-04-27','14:00:00',1.57),('1444','2014-04-27','14:05:00',1.77),('1444','2014-04-27','14:10:00',1.22),('1444','2014-04-27','14:15:00',1.25),('1444','2014-04-27','14:20:00',1.52),('1444','2014-04-27','14:25:00',1.83),('1444','2014-04-27','14:30:00',1.86),('1444','2014-04-27','14:35:00',1.91),('1444','2014-04-27','14:40:00',1.96),('1444','2014-04-27','14:45:00',1.62),('1444','2014-04-27','14:50:00',1.56),('1444','2014-04-27','14:55:00',1.66),('1444','2014-04-27','15:00:00',1.83),('1444','2014-04-27','15:05:00',2.69),('1444','2014-04-27','15:10:00',3.19),('1444','2014-04-27','15:15:00',2.09),('1444','2014-04-27','15:20:00',1.47),('1444','2014-02-05','10:15:00',1.39),('1444','2014-02-05','10:20:00',1.93),('1444','2014-02-05','10:25:00',1.41),('1444','2014-02-05','11:10:00',1.21),('1444','2014-02-05','11:15:00',1.77),('1444','2014-02-05','11:20:00',2.15),('1444','2014-02-05','11:25:00',1.08),('1444','2014-02-05','13:10:00',1.08),('1444','2014-02-05','13:20:00',1.03),('1444','2014-02-05','13:25:00',1.12),('1444','2014-02-05','13:37:00',1.13),('1444','2014-02-05','13:40:00',1.39),('1444','2014-02-05','13:45:00',1.33),('1444','2014-02-05','13:50:00',1.19),('1444','2014-02-05','14:30:00',1.8),('1444','2014-02-05','14:35:00',1.04),('1444','2014-02-04','09:35:00',1.08),('1444','2014-02-04','09:40:00',1.24),('1444','2014-02-04','09:45:00',1.13),('1444','2014-02-04','09:50:00',1.19),('1444','2014-02-04','10:00:00',1.3),('1444','2014-02-04','10:05:00',1.52),('1444','2014-02-04','10:10:00',1.21),('1444','2014-02-04','10:15:00',1.16),('1444','2014-02-04','10:45:00',1.29),('1444','2014-02-04','10:50:00',1.37),('1444','2014-02-04','10:55:00',1.82),('1444','2014-02-04','11:00:00',2.13),('1444','2014-02-04','11:05:00',1.03),('1444','2014-02-04','11:50:00',1.48),('1444','2014-02-04','11:55:00',2.36),('1444','2014-02-04','12:00:00',1.16),('1444','2014-02-04','12:05:00',1.28),('1444','2014-02-04','12:10:00',1.42),('1444','2014-02-04','12:15:00',1.13),('1444','2014-02-04','12:20:00',1.13),('1444','2014-02-04','13:20:00',1.14),('1444','2014-02-01','11:20:00',1.13),('1444','2014-02-01','11:35:00',1.02),('1444','2014-02-01','11:55:00',1.12),('1444','2014-02-01','12:10:00',1.35),('1444','2014-02-01','12:20:00',1.56),('1444','2014-02-01','12:25:00',1.13),('1444','2014-02-01','12:45:00',1.46),('1444','2014-02-01','12:50:00',1.41),('1444','2014-02-01','12:55:00',1.14),('1444','2014-02-01','13:00:00',1.14),('1444','2014-01-30','09:55:00',1.19),('1444','2014-01-30','10:00:00',1.01),('1444','2014-01-30','10:10:00',1.11),('1444','2014-01-30','10:15:00',1.38),('1444','2014-01-30','10:20:00',1.19),('1444','2014-01-30','10:25:00',1.54),('1444','2014-01-30','10:30:00',1.6),('1444','2014-01-30','10:35:00',1.59),('1444','2014-01-30','10:40:00',1.62),('1444','2014-01-30','10:45:00',1.42),('1444','2014-01-30','10:50:00',1.75),('1444','2014-01-30','10:55:00',2.09),('1444','2014-01-30','11:00:00',2.06),('1444','2014-01-30','11:05:00',1.78),('1444','2014-01-30','11:10:00',1.58),('1444','2014-01-30','11:15:00',1.54),('1444','2014-01-30','11:20:00',1.06),('1444','2014-01-30','11:25:00',1.74),('1444','2014-01-30','11:30:00',1.47),('1444','2014-01-30','11:35:00',1.62),('1444','2014-01-30','11:40:00',1.59),('1444','2014-01-30','11:45:00',1.8),('1444','2014-01-30','11:50:00',1.91),('1444','2014-01-30','11:55:00',1.84),('1444','2014-01-30','12:00:00',1.65),('1444','2014-01-30','12:05:00',1.98),('1444','2014-01-30','12:10:00',2.11),('1444','2014-01-30','12:15:00',1.9),('1444','2014-01-30','12:20:00',2.09),('1444','2014-01-30','12:25:00',1.64),('1444','2014-01-30','12:30:00',1.51),('1444','2014-01-30','12:35:00',1.56),('1444','2014-01-30','12:40:00',1.53),('1444','2014-01-30','12:45:00',1.85),('1444','2014-01-30','12:50:00',1.86),('1444','2014-01-30','12:55:00',1.87),('1444','2014-01-30','13:00:00',1.91),('1444','2014-01-30','13:05:00',2.03),('1444','2014-01-30','13:10:00',1.82),('1444','2014-01-30','13:15:00',1.88),('1444','2014-01-30','13:20:00',1.57),('1444','2014-01-30','13:25:00',1.66),('1444','2014-01-30','13:30:00',1.35),('1444','2014-01-30','13:35:00',1.24),('1444','2014-01-30','13:40:00',1.62),('1444','2014-01-30','13:45:00',1.75),('1444','2014-01-30','13:50:00',1.57),('1444','2014-01-30','13:55:00',1.35),('1444','2014-01-30','14:00:00',1.35),('1444','2014-01-30','14:05:00',1.27),('1444','2014-01-30','14:10:00',1.26),('1444','2014-01-30','14:15:00',1.08),('1444','2014-01-30','14:25:00',1.07),('1444','2014-01-30','14:30:00',1.11),('1444','2014-01-30','14:35:00',1.09),('1444','2014-01-30','14:40:00',1.22),('1444','2014-01-30','14:45:00',1.14),('1444','2014-01-30','14:50:00',1.2),('1444','2014-01-30','14:55:00',1.13),('1444','2014-01-30','15:00:00',1.07),('1444','2014-01-30','15:05:00',1.05),('1444','2014-01-30','15:10:00',1),('1444','2014-01-29','09:35:00',1.25),('1444','2014-01-29','09:40:00',1.06),('1444','2014-01-29','09:45:00',1.15),('1444','2014-01-29','09:50:00',1.06),('1444','2014-01-29','09:55:00',1.07),('1444','2014-01-29','10:10:00',1.16),('1444','2014-01-29','10:15:00',1.35),('1444','2014-01-29','10:25:00',1.87),('1444','2014-01-29','10:30:00',1.88),('1444','2014-01-29','10:35:00',1.55),('1444','2014-01-29','10:40:00',1.52),('1444','2014-01-29','10:45:00',1.4),('1444','2014-01-29','10:50:00',1.4),('1444','2014-01-29','10:55:00',1.24),('1444','2014-01-29','11:00:00',1.3),('1444','2014-01-29','11:05:00',1.41),('1444','2014-01-29','11:10:00',1.21),('1444','2014-01-29','11:15:00',1.24),('1444','2014-01-29','11:20:00',1.32),('1444','2014-01-29','11:25:00',1.32),('1444','2014-01-29','11:30:00',1.74),('1444','2014-01-29','11:35:00',1.49),('1444','2014-01-29','12:50:00',1.9),('1444','2014-01-29','12:55:00',1.97),('1444','2014-01-29','13:00:00',1.23),('1444','2014-01-29','13:35:00',1.24),('1444','2014-01-29','13:40:00',1.73),('1444','2014-01-29','13:45:00',1.23),('1444','2014-01-29','13:50:00',1.35),('1444','2014-01-29','13:55:00',1.51),('1444','2014-01-29','15:15:00',1.12),('1444','2014-01-28','09:50:00',1.08),('1444','2014-01-28','09:55:00',1.11),('1444','2014-01-28','10:00:00',1.18),('1444','2014-01-28','10:05:00',1.16),('1444','2014-01-28','10:10:00',1.12),('1444','2014-01-28','10:15:00',1.24),('1444','2014-01-28','10:20:00',1.37),('1444','2014-01-28','10:25:00',1.4),('1444','2014-01-28','10:30:00',1.43),('1444','2014-01-28','10:35:00',1.51),('1444','2014-01-28','10:40:00',1.57),('1444','2014-01-28','10:45:00',1.49),('1444','2014-01-28','10:50:00',1.67),('1444','2014-01-28','10:55:00',1.07),('1444','2014-01-28','11:00:00',1.02),('1444','2014-01-28','11:05:00',1.17),('1444','2014-01-28','11:10:00',1.9),('1444','2014-01-28','11:15:00',1.06),('1444','2014-01-28','11:25:00',1.14),('1444','2014-01-28','11:30:00',1.21),('1444','2014-01-28','11:35:00',1.27),('1444','2014-01-28','11:40:00',2.16),('1444','2014-01-28','11:45:00',2.09),('1444','2014-01-28','11:50:00',1.72),('1444','2014-01-28','12:00:00',1.6),('1444','2014-01-28','12:05:00',1.35),('1444','2014-01-28','12:10:00',1.12),('1444','2014-01-28','12:35:00',1.11),('1444','2014-01-28','12:40:00',1.1),('1444','2014-01-28','12:45:00',1.71),('1444','2014-01-28','12:50:00',1.68),('1444','2014-01-28','12:55:00',2.19),('1444','2014-01-28','13:00:00',2.07),('1444','2014-01-28','13:05:00',2.1),('1444','2014-01-28','13:10:00',1.42),('1444','2014-01-28','13:15:00',1.81),('1444','2014-01-28','13:20:00',1.72),('1444','2014-01-28','13:25:00',1.74),('1444','2014-01-28','13:30:00',1.87),('1444','2014-01-28','13:35:00',1.87),('1444','2014-01-28','13:40:00',1.74),('1444','2014-01-28','13:45:00',1.66),('1444','2014-01-28','13:50:00',1.59),('1444','2014-01-28','13:55:00',1.56),('1444','2014-01-28','14:00:00',1.51),('1444','2014-01-28','14:05:00',1.39),('1444','2014-01-28','14:10:00',1.38),('1444','2014-01-28','14:15:00',1.38),('1444','2014-01-28','14:20:00',1.38),('1444','2014-01-28','14:25:00',1.39),('1444','2014-01-28','14:30:00',1.33),('1444','2014-01-28','14:35:00',1.27),('1444','2014-01-28','14:40:00',1.24),('1444','2014-01-28','14:45:00',1.21),('1444','2014-01-28','14:50:00',1.16),('1444','2014-01-28','14:55:00',1.1),('1444','2014-01-28','15:00:00',1.05),('1444','2014-01-28','15:05:00',1.02),('14598','2014-05-05','08:05:00',1.07),('14598','2014-05-05','08:10:00',1.16),('14598','2014-05-05','08:15:00',1.26),('14598','2014-05-05','08:20:00',1.36),('14598','2014-05-05','08:25:00',1.48),('14598','2014-05-05','08:30:00',1.61),('14598','2014-05-05','08:35:00',1.73),('14598','2014-05-05','08:40:00',1.84),('14598','2014-05-05','08:45:00',1.95),('14598','2014-05-05','08:50:00',2.04),('14598','2014-05-05','08:55:00',2.17),('14598','2014-05-05','09:00:00',2.29),('14598','2014-05-05','09:05:00',2.41),('14598','2014-05-05','09:10:00',2.5),('14598','2014-05-05','09:15:00',2.59),('14598','2014-05-05','09:20:00',2.68),('14598','2014-05-05','09:25:00',2.78),('14598','2014-05-05','09:30:00',2.87),('14598','2014-05-05','09:35:00',2.97),('14598','2014-05-05','09:40:00',3.05),('14598','2014-05-05','09:45:00',3.12),('14598','2014-05-05','09:50:00',3.23),('14598','2014-05-05','09:55:00',3.31),('14598','2014-05-05','10:00:00',3.39),('14598','2014-05-05','10:05:00',3.47),('14598','2014-05-05','10:10:00',3.54),('14598','2014-05-05','10:15:00',3.62),('14598','2014-05-05','10:20:00',3.7),('14598','2014-05-05','10:25:00',3.77),('14598','2014-05-05','10:30:00',3.84),('14598','2014-05-05','10:35:00',3.92),('14598','2014-05-05','10:40:00',3.98),('14598','2014-05-05','10:45:00',4.03),('14598','2014-05-05','10:50:00',4.07),('14598','2014-05-05','10:55:00',4.13),('14598','2014-05-05','11:00:00',4.12),('14598','2014-05-05','11:05:00',4.22),('14598','2014-05-05','11:10:00',4.27),('14598','2014-05-05','11:15:00',4.32),('14598','2014-05-05','11:20:00',4.35),('14598','2014-05-05','11:25:00',4.39),('14598','2014-05-05','11:30:00',4.47),('14598','2014-05-05','11:35:00',4.49),('14598','2014-05-05','11:40:00',4.51),('14598','2014-05-05','11:45:00',4.56),('14598','2014-05-05','11:50:00',4.58),('14598','2014-05-05','11:55:00',4.63),('14598','2014-05-05','12:00:00',4.64),('14598','2014-05-05','12:05:00',4.68),('14598','2014-05-05','12:10:00',4.72),('14598','2014-05-05','12:15:00',4.76),('14598','2014-05-05','12:20:00',4.56),('14598','2014-05-05','12:25:00',4.27),('14598','2014-05-05','12:30:00',4.78),('14598','2014-05-05','12:35:00',5.12),('14598','2014-05-05','12:40:00',5.19),('14598','2014-05-05','12:45:00',5.2),('14598','2014-05-05','12:50:00',5.21),('14598','2014-05-05','12:55:00',5.23),('14598','2014-05-05','13:00:00',5.24),('14598','2014-05-05','13:05:00',5.25),('14598','2014-05-05','13:10:00',5.27),('14598','2014-05-05','13:15:00',5.3),('14598','2014-05-05','13:20:00',5.31),('14598','2014-05-05','13:25:00',5.3),('14598','2014-05-05','13:30:00',5.33),('14598','2014-05-05','13:35:00',5.32),('14598','2014-05-05','13:40:00',5.31),('14598','2014-05-05','13:45:00',5.28),('14598','2014-05-05','13:50:00',5.3),('14598','2014-05-05','13:55:00',5.31),('14598','2014-05-05','14:00:00',5.3),('14598','2014-05-05','14:05:00',5.2),('14598','2014-05-05','14:10:00',5.27),('14598','2014-05-05','14:15:00',5.27),('14598','2014-05-05','14:20:00',5.25),('14598','2014-05-05','14:25:00',5.22),('14598','2014-05-05','14:30:00',5.19),('14598','2014-05-05','14:35:00',5.18),('14598','2014-05-05','14:40:00',5.17),('14598','2014-05-05','14:45:00',5.16),('14598','2014-05-05','14:50:00',5.13),('14598','2014-05-05','14:55:00',5.11),('14598','2014-05-05','15:00:00',5.06),('14598','2014-05-05','15:05:00',5.02),('14598','2014-05-05','15:10:00',4.98),('14598','2014-05-05','15:15:00',4.94),('14598','2014-05-05','15:20:00',4.88),('14598','2014-05-05','15:25:00',4.83),('14598','2014-05-05','15:30:00',4.8),('14598','2014-05-05','15:35:00',4.75),('14598','2014-05-05','15:40:00',4.71),('14598','2014-05-05','15:45:00',4.64),('14598','2014-05-05','15:50:00',4.58),('14598','2014-05-05','15:55:00',4.54),('14598','2014-05-05','16:00:00',4.5),('14598','2014-05-05','16:05:00',4.42),('14598','2014-05-05','16:10:00',4.34),('14598','2014-05-05','16:15:00',4.29),('14598','2014-05-05','16:20:00',4.23),('14598','2014-05-05','16:25:00',4.15),('14598','2014-05-05','16:30:00',4.08),('14598','2014-05-05','16:35:00',4.02),('14598','2014-05-05','16:40:00',3.92),('14598','2014-05-05','16:45:00',3.84),('14598','2014-05-05','16:50:00',3.75),('14598','2014-05-05','16:55:00',3.7),('14598','2014-05-05','17:00:00',3.6),('14598','2014-05-05','17:05:00',3.5),('14598','2014-05-05','17:10:00',3.43),('14598','2014-05-05','17:15:00',3.34),('14598','2014-05-05','17:20:00',3.25),('14598','2014-05-05','17:25:00',3.14),('14598','2014-05-05','17:30:00',3.04),('14598','2014-05-05','17:35:00',2.94),('14598','2014-05-05','17:40:00',2.84),('14598','2014-05-05','17:45:00',2.72),('14598','2014-05-05','17:50:00',2.63),('14598','2014-05-05','17:55:00',2.51),('14598','2014-05-05','18:00:00',2.41),('14598','2014-05-05','18:05:00',2.29),('14598','2014-05-05','18:10:00',2.19),('14598','2014-05-05','18:15:00',2.08),('14598','2014-05-05','18:20:00',1.98),('14598','2014-05-05','18:25:00',1.86),('14598','2014-05-05','18:30:00',1.76),('14598','2014-05-05','18:35:00',1.64),('14598','2014-05-05','18:40:00',1.53),('14598','2014-05-05','18:45:00',1.41),('14598','2014-05-05','18:50:00',1.28),('14598','2014-05-05','18:55:00',1.17),('14598','2014-05-05','19:00:00',1.06),('14598','2014-04-26','08:40:00',1.13),('14598','2014-04-26','08:45:00',1.19),('14598','2014-04-26','08:50:00',1.22),('14598','2014-04-26','08:55:00',1.24),('14598','2014-04-26','09:00:00',1.4),('14598','2014-04-26','09:05:00',1.64),('14598','2014-04-26','09:10:00',1.42),('14598','2014-04-26','09:15:00',1.4),('14598','2014-04-26','09:20:00',1.19),('14598','2014-04-26','09:25:00',1.27),('14598','2014-04-26','09:30:00',1.37),('14598','2014-04-26','09:35:00',1.23),('14598','2014-04-26','09:40:00',1.48),('14598','2014-04-26','09:45:00',1.59),('14598','2014-04-26','09:50:00',1.52),('14598','2014-04-26','10:05:00',1.13),('14598','2014-04-26','10:10:00',1.94),('14598','2014-04-26','10:15:00',2.23),('14598','2014-04-26','10:20:00',2.75),('14598','2014-04-26','10:25:00',2.22),('14598','2014-04-26','10:30:00',1.92),('14598','2014-04-26','10:35:00',2.29),('14598','2014-04-26','10:40:00',3.42),('14598','2014-04-26','10:45:00',3.49),('14598','2014-04-26','10:50:00',4.11),('14598','2014-04-26','10:55:00',4.14),('14598','2014-04-26','11:00:00',3.89),('14598','2014-04-26','11:05:00',3.81),('14598','2014-04-26','11:10:00',3.62),('14598','2014-04-26','11:15:00',2.84),('14598','2014-04-26','11:20:00',4.21),('14598','2014-04-26','11:25:00',4.55),('14598','2014-04-26','11:30:00',4.55),('14598','2014-04-26','11:35:00',3.79),('14598','2014-04-26','11:40:00',2.5),('14598','2014-04-26','11:45:00',3.81),('14598','2014-04-26','11:50:00',4.6),('14598','2014-04-26','11:55:00',3.17),('14598','2014-04-26','12:00:00',2.54),('14598','2014-04-26','12:05:00',3.8),('14598','2014-04-26','12:10:00',4.02),('14598','2014-04-26','12:15:00',4.83),('14598','2014-04-26','12:20:00',4.19),('14598','2014-04-26','12:25:00',2.6),('14598','2014-04-26','12:30:00',2.45),('14598','2014-04-26','12:35:00',4.04),('14598','2014-04-26','12:40:00',3.68),('14598','2014-04-26','12:45:00',2.96),('14598','2014-04-26','12:50:00',5.33),('14598','2014-04-26','12:55:00',5.3),('14598','2014-04-26','13:00:00',5.26),('14598','2014-04-26','13:05:00',5.41),('14598','2014-04-26','13:10:00',5.49),('14598','2014-04-26','13:15:00',4.58),('14598','2014-04-26','13:20:00',4.4),('14598','2014-04-26','13:25:00',5.16),('14598','2014-04-26','13:30:00',4.93),('14598','2014-04-26','13:35:00',4.96),('14598','2014-04-26','13:40:00',4.86),('14598','2014-04-26','13:45:00',5.03),('14598','2014-04-26','13:50:00',5.13),('14598','2014-04-26','13:55:00',5.12),('14598','2014-04-26','14:00:00',5.08),('14598','2014-04-26','14:05:00',5.33),('14598','2014-04-26','14:10:00',5.01),('14598','2014-04-26','14:15:00',5.35),('14598','2014-04-26','14:20:00',5.32),('14598','2014-04-26','14:25:00',5.24),('14598','2014-04-26','14:30:00',5.24),('14598','2014-04-26','14:35:00',5.23),('14598','2014-04-26','14:40:00',4.74),('14598','2014-04-26','14:45:00',3.79),('14598','2014-04-26','14:50:00',5.4),('14598','2014-04-26','14:55:00',5.04),('14598','2014-04-26','15:00:00',4.15),('14598','2014-04-26','15:05:00',2.49),('14598','2014-04-26','15:10:00',2.07),('14598','2014-04-26','15:15:00',1.98),('14598','2014-04-26','15:20:00',1.73),('14598','2014-04-26','15:25:00',1.31),('14598','2014-04-26','15:30:00',1.02),('14598','2014-04-26','15:50:00',1.3),('14598','2014-01-26','08:55:00',1.09),('14598','2014-01-26','09:15:00',1.01),('14598','2014-01-26','09:20:00',1.13),('14598','2014-01-26','09:45:00',1.03),('14598','2014-01-26','09:50:00',1.11),('14598','2014-01-26','10:00:00',2.5),('14598','2014-01-26','10:05:00',2.88),('14598','2014-01-26','10:10:00',1.54),('14598','2014-01-26','10:20:00',1.14),('14598','2014-01-26','10:25:00',1),('14598','2014-01-26','10:30:00',1.11),('14598','2014-01-26','10:35:00',2.04),('14598','2014-01-26','10:40:00',1.65),('14598','2014-01-26','10:45:00',1.38),('14598','2014-01-26','10:50:00',1.5),('14598','2014-01-26','10:55:00',1.18),('14598','2014-01-26','11:00:00',1.14),('14598','2014-01-26','11:05:00',1.53),('14598','2014-01-26','11:10:00',2.6),('14598','2014-01-26','11:15:00',1.73),('14598','2014-01-26','11:20:00',1.28),('14598','2014-01-26','11:25:00',1.39),('14598','2014-01-26','11:30:00',2.31),('14598','2014-01-26','11:35:00',2.3),('14598','2014-01-26','11:40:00',1.71),('14598','2014-01-26','11:45:00',1.38),('14598','2014-01-26','11:50:00',1.56),('14598','2014-01-26','11:55:00',1.71),('14598','2014-01-26','12:00:00',1.44),('14598','2014-01-26','12:05:00',1.6),('14598','2014-01-26','12:10:00',1.91),('14598','2014-01-26','12:15:00',1.95),('14598','2014-01-26','12:20:00',1.33),('14598','2014-01-26','12:25:00',1.19),('14598','2014-01-26','12:30:00',1.17),('14598','2014-01-26','12:35:00',1.18),('14598','2014-01-26','12:40:00',1.17),('14598','2014-01-26','12:45:00',1.22),('14598','2014-01-26','12:50:00',1.28),('14598','2014-01-26','12:55:00',1.36),('14598','2014-01-26','13:00:00',1.52),('14598','2014-01-26','13:05:00',1.79),('14598','2014-01-26','13:10:00',1.98),('14598','2014-01-26','13:15:00',2.92),('14598','2014-01-26','13:20:00',1.94),('14598','2014-01-26','13:25:00',1.55),('14598','2014-01-26','13:30:00',1.33),('14598','2014-01-26','13:35:00',1.05),('14598','2014-01-26','13:45:00',1.02),('14598','2014-01-26','13:50:00',1.28),('14598','2014-01-26','13:55:00',1.14),('14598','2014-01-25','09:50:00',1.09),('14598','2014-01-25','09:55:00',1.21),('14598','2014-01-25','10:00:00',1.19),('14598','2014-01-25','10:05:00',1.1),('14598','2014-01-25','10:10:00',1.06),('14598','2014-01-25','10:15:00',1.24),('14598','2014-01-25','10:20:00',1.41),('14598','2014-01-25','10:25:00',1.61),('14598','2014-01-25','10:30:00',1.91),('14598','2014-01-25','10:35:00',2.41),('14598','2014-01-25','10:40:00',2.9),('14598','2014-01-25','10:45:00',2.62),('14598','2014-01-25','10:50:00',3.5),('14598','2014-01-25','10:55:00',3.49),('14598','2014-01-25','11:00:00',1.74),('14598','2014-01-25','11:05:00',1.94),('14598','2014-01-25','11:10:00',1.96),('14598','2014-01-25','11:15:00',2.64),('14598','2014-01-25','11:20:00',3.82),('14598','2014-01-25','11:25:00',3.84),('14598','2014-01-25','11:30:00',3.69),('14598','2014-01-25','11:35:00',2.48),('14598','2014-01-25','11:40:00',2.5),('14598','2014-01-25','11:45:00',2.3),('14598','2014-01-25','11:50:00',2.47),('14598','2014-01-25','11:55:00',2.43),('14598','2014-01-25','12:00:00',1.42),('14598','2014-01-25','12:05:00',1.51),('14598','2014-01-25','12:10:00',1.74),('14598','2014-01-25','12:15:00',1.83),('14598','2014-01-25','12:20:00',1.96),('14598','2014-01-25','12:25:00',2.35),('14598','2014-01-25','12:30:00',2.6),('14598','2014-01-25','12:35:00',3.57),('14598','2014-01-25','12:40:00',3.62),('14598','2014-01-25','12:45:00',3.72),('14598','2014-01-25','12:50:00',3.56),('14598','2014-01-25','12:55:00',3.49),('14598','2014-01-25','13:00:00',3.59),('14598','2014-01-25','13:05:00',3.49),('14598','2014-01-25','13:10:00',3.32),('14598','2014-01-25','13:15:00',3.51),('14598','2014-01-25','13:20:00',3.55),('14598','2014-01-25','13:25:00',3.47),('14598','2014-01-25','13:30:00',3.45),('14598','2014-01-25','13:35:00',3.34),('14598','2014-01-25','13:40:00',3.34),('14598','2014-01-25','13:45:00',3.34),('14598','2014-01-25','13:50:00',3.36),('14598','2014-01-25','13:55:00',3.36),('14598','2014-01-25','14:00:00',2.49),('14598','2014-01-25','14:05:00',2.54),('14598','2014-01-25','14:10:00',2.51),('14598','2014-01-25','14:15:00',2.63),('14598','2014-01-25','14:20:00',2.84),('14598','2014-01-25','14:25:00',2.87),('14598','2014-01-25','14:30:00',2.42),('14598','2014-01-25','14:35:00',2.53),('14598','2014-01-25','14:40:00',2.61),('14598','2014-01-25','14:45:00',2.87),('14598','2014-01-25','14:50:00',2.81),('14598','2014-01-25','14:55:00',2.69),('14598','2014-01-25','15:00:00',2.62),('14598','2014-01-25','15:05:00',2.48),('14598','2014-01-25','15:10:00',2.37),('14598','2014-01-25','15:15:00',2.27),('14598','2014-01-25','15:20:00',2.19),('14598','2014-01-25','15:25:00',2.08),('14598','2014-01-25','15:30:00',1.99),('14598','2014-01-25','15:35:00',1.9),('14598','2014-01-25','15:40:00',1.78),('14598','2014-01-25','15:45:00',1.71),('14598','2014-01-25','15:50:00',1.6),('14598','2014-01-25','15:55:00',1.52),('14598','2014-01-25','16:00:00',1.43),('14598','2014-01-25','16:05:00',1.31),('14598','2014-01-25','16:10:00',1.2),('14598','2014-01-25','16:15:00',1.1),('14598','2014-01-24','09:55:00',1.21),('14598','2014-01-24','10:00:00',1.43),('14598','2014-01-24','10:05:00',2.21),('14598','2014-01-24','10:10:00',1.95),('14598','2014-01-24','10:15:00',2.19),('14598','2014-01-24','10:20:00',1.01),('14598','2014-01-24','10:30:00',1.07),('14598','2014-01-24','10:40:00',1.84),('14598','2014-01-24','10:45:00',1.19),('14598','2014-01-24','11:00:00',1.1),('14598','2014-01-24','11:05:00',1.79),('14598','2014-01-24','11:10:00',1.5),('14598','2014-01-24','11:15:00',1.07),('14598','2014-01-24','11:20:00',1.97),('14598','2014-01-24','11:25:00',2.87),('14598','2014-01-24','11:30:00',2.44),('14598','2014-01-24','11:35:00',1.53),('14598','2014-01-24','11:40:00',1.21),('14598','2014-01-24','11:45:00',1.05),('14598','2014-01-24','11:50:00',1.18),('14598','2014-01-24','11:55:00',2.97),('14598','2014-01-24','12:00:00',2.4),('14598','2014-01-24','12:10:00',1.01),('14598','2014-01-24','12:15:00',1.42),('14598','2014-01-24','12:20:00',1.86),('14598','2014-01-24','12:25:00',1.86),('14598','2014-01-24','12:30:00',1.76),('14598','2014-01-24','12:40:00',3.31),('14598','2014-01-24','12:45:00',1.23),('14598','2014-01-24','12:50:00',2.54),('14598','2014-01-24','12:55:00',3.5),('14598','2014-01-24','13:00:00',2.56),('14598','2014-01-24','13:05:00',3.2),('14598','2014-01-24','13:10:00',2.43),('14598','2014-01-24','13:15:00',2.41),('14598','2014-01-24','13:20:00',3.09),('14598','2014-01-24','13:25:00',2.62),('14598','2014-01-24','13:30:00',2.25),('14598','2014-01-24','13:35:00',1.39),('14598','2014-01-24','13:55:00',2.47),('14598','2014-01-24','14:00:00',3.62),('14598','2014-01-24','14:05:00',3.12),('14598','2014-01-24','14:10:00',3.04),('14598','2014-01-24','14:15:00',3.01),('14598','2014-01-24','14:20:00',2.97),('14598','2014-01-24','14:25:00',2.87),('14598','2014-01-24','14:30:00',2.32),('14598','2014-01-24','14:35:00',2.13),('14598','2014-01-24','14:40:00',1.41),('14598','2014-01-23','10:35:00',1.16),('14598','2014-01-23','10:40:00',1.71),('14598','2014-01-23','10:45:00',3.12),('14598','2014-01-23','10:50:00',2.7),('14598','2014-01-23','10:55:00',2.01),('14598','2014-01-23','11:00:00',1.41),('14598','2014-01-23','11:05:00',1.3),('14598','2014-01-23','11:10:00',1.15),('14598','2014-01-23','11:15:00',1.07),('14598','2014-01-23','11:20:00',1.39),('14598','2014-01-23','11:25:00',1.59),('14598','2014-01-23','11:30:00',1.68),('14598','2014-01-23','11:35:00',2.24),('14598','2014-01-23','11:40:00',1.99),('14598','2014-01-23','11:45:00',1.71),('14598','2014-01-23','11:50:00',1.31),('14598','2014-01-23','11:55:00',1.23),('14598','2014-01-23','12:00:00',1.36),('14598','2014-01-23','12:05:00',1.23),('14598','2014-01-22','11:55:00',1.01),('14598','2014-01-22','12:00:00',1.36),('14598','2014-01-22','12:05:00',1.37),('14598','2014-01-22','12:10:00',1.63),('14598','2014-01-22','12:15:00',1.22),('14598','2014-01-22','12:20:00',1),('14598','2014-01-22','12:25:00',1.01),('14598','2014-01-22','12:30:00',1.02),('14598','2014-01-22','12:50:00',1.26),('14598','2014-01-22','14:25:00',1.01),('14598','2014-01-22','14:30:00',1.48),('14598','2014-01-22','14:35:00',1.34),('14598','2014-01-22','14:40:00',1.21),('14598','2014-01-22','14:45:00',1.02),('14598','2014-01-22','14:50:00',1.05),('14598','2014-01-22','14:55:00',1.18),('14598','2014-01-22','15:25:00',1.28),('14598','2014-01-22','15:30:00',1.88),('14598','2014-01-22','15:35:00',1.66),('14598','2014-01-22','15:40:00',2.11),('14598','2014-01-22','15:45:00',2.08),('14598','2014-01-22','15:50:00',1.87),('14598','2014-01-22','15:55:00',1.56),('14598','2014-01-22','16:00:00',1.41),('14598','2014-01-22','16:05:00',1.27),('14598','2014-01-22','16:10:00',1.14),('14598','2014-01-22','16:15:00',1.03),('14598','2014-01-21','10:10:00',1.36),('14598','2014-01-21','10:15:00',1.43),('14598','2014-01-21','10:25:00',1.45),('14598','2014-01-21','10:30:00',1.49),('14598','2014-01-21','10:40:00',1.03),('14598','2014-01-21','10:45:00',1.62),('14598','2014-01-21','11:05:00',1.59),('14598','2014-01-21','11:10:00',2.13),('14598','2014-01-21','11:25:00',1.24),('14598','2014-01-21','11:30:00',2.43),('14598','2014-01-21','11:35:00',2.03),('14598','2014-01-21','11:40:00',1.81),('14598','2014-01-21','11:45:00',2.11),('14598','2014-01-21','11:50:00',2.17),('14598','2014-01-21','11:55:00',1.69),('14598','2014-01-21','12:00:00',1.41),('14598','2014-01-21','12:05:00',1.07),('14598','2014-01-21','12:10:00',1.06),('14598','2014-01-21','12:15:00',1.17),('14598','2014-01-21','12:35:00',1.29),('14598','2014-01-21','12:40:00',1.64),('14598','2014-01-21','12:45:00',1.69),('14598','2014-01-21','12:50:00',1.4),('14598','2014-01-21','12:55:00',1.13),('14598','2014-01-21','13:15:00',1.18),('14598','2014-01-21','13:20:00',1.59),('14598','2014-01-21','13:25:00',1.59),('14598','2014-01-21','13:30:00',1.23),('14598','2014-01-21','14:25:00',1.01),('14598','2014-01-21','14:30:00',1.59),('14598','2014-01-21','14:35:00',1.45),('14598','2014-01-21','14:40:00',1.22),('14598','2014-01-21','14:45:00',1.19),('14598','2014-01-21','14:55:00',1.06),('14598','2014-01-21','15:00:00',2.3),('14598','2014-01-21','15:05:00',2.16),('14598','2014-01-21','15:10:00',1.54),('14598','2014-01-21','15:15:00',1.9),('14598','2014-01-21','15:20:00',1.65),('14598','2014-01-20','09:55:00',1.4),('14598','2014-01-20','10:00:00',1.77),('14598','2014-01-20','10:05:00',1.21),('14598','2014-01-20','11:45:00',1.08),('14598','2014-01-20','11:50:00',1.49),('14598','2014-01-20','11:55:00',2.12),('14598','2014-01-20','12:00:00',1.04),('14598','2014-01-20','12:10:00',1.54),('14598','2014-01-20','12:15:00',3.74),('14598','2014-01-20','12:20:00',3.68),('14598','2014-01-20','12:25:00',3.47),('14598','2014-01-20','12:30:00',2.24),('14598','2014-01-20','12:35:00',3.31),('14598','2014-01-20','12:40:00',3.32),('14598','2014-01-20','12:45:00',3.41),('14598','2014-01-20','12:50:00',3.48),('14598','2014-01-20','12:55:00',2.45),('14598','2014-01-20','13:20:00',2.76),('14598','2014-01-20','13:25:00',1.93),('14598','2014-01-20','13:30:00',1.15),('14598','2014-01-20','13:45:00',1.47),('14598','2014-01-20','13:50:00',1.01),('14598','2014-01-20','13:55:00',1.22),('14598','2014-01-20','14:00:00',1.64),('14598','2014-01-19','11:35:00',1.11),('14598','2014-01-19','11:40:00',1.34),('14598','2014-01-19','11:45:00',1.41),('14598','2014-01-19','11:50:00',1.43),('14598','2014-01-19','11:55:00',1.47),('14598','2014-01-19','12:00:00',1.29),('14598','2014-01-19','12:05:00',1.02),('14598','2014-01-19','12:15:00',1.01),('14598','2014-01-19','12:20:00',1.23),('14598','2014-01-19','12:25:00',1.41),('14598','2014-01-19','12:30:00',1.34),('14598','2014-01-19','12:35:00',1.21),('14598','2014-01-19','12:40:00',1.21),('14598','2014-01-19','12:45:00',1.2),('14598','2014-01-19','12:50:00',1.33),('14598','2014-01-19','12:55:00',1.41),('14598','2014-01-19','13:00:00',1.44),('14598','2014-01-19','13:05:00',1.41),('14598','2014-01-19','13:10:00',1.28),('14598','2014-01-19','13:15:00',1.14),('14598','2014-01-19','13:20:00',1.13),('14598','2014-01-19','13:25:00',1.07),('14598','2014-01-19','13:30:00',1.02),('14598','2014-01-19','13:35:00',1.24),('14598','2014-01-19','13:40:00',1.33),('14598','2014-01-19','13:45:00',1.22),('14598','2014-01-19','13:50:00',1.22),('14598','2014-01-19','13:55:00',1.21),('14598','2014-01-19','14:00:00',1.03),('14598','2014-01-19','14:05:00',1.01),('14598','2014-01-19','14:10:00',1.41),('14598','2014-01-19','14:15:00',1.92),('14598','2014-01-19','14:20:00',2.03),('14598','2014-01-19','14:25:00',1.56),('14598','2014-01-19','14:30:00',1.31),('14598','2014-01-18','09:35:00',1.52),('14598','2014-01-18','09:40:00',1.55),('14598','2014-01-18','09:45:00',1.06),('14598','2014-01-18','09:50:00',1.4),('14598','2014-01-18','09:55:00',1.63),('14598','2014-01-18','10:00:00',1.87),('14598','2014-01-18','10:05:00',1.54),('14598','2014-01-18','10:10:00',1.37),('14598','2014-01-18','10:15:00',1.32),('14598','2014-01-18','10:20:00',1.19),('14598','2014-01-18','10:25:00',1.34),('14598','2014-01-18','10:30:00',2.15),('14598','2014-01-18','10:35:00',1.21),('14598','2014-01-18','10:40:00',1.04),('14598','2014-01-18','10:45:00',1.59),('14598','2014-01-18','10:50:00',2.06),('14598','2014-01-18','10:55:00',2.51),('14598','2014-01-18','11:00:00',2.52),('14598','2014-01-18','11:05:00',2.55),('14598','2014-01-18','11:10:00',2.58),('14598','2014-01-18','11:15:00',2.63),('14598','2014-01-18','11:20:00',2.69),('14598','2014-01-18','11:25:00',2.82),('14598','2014-01-18','11:30:00',2.57),('14598','2014-01-18','11:35:00',1.56),('14598','2014-01-18','11:40:00',1.46),('14598','2014-01-18','11:45:00',2.74),('14598','2014-01-18','11:50:00',3.14),('14598','2014-01-18','11:55:00',2.97),('14598','2014-01-18','12:00:00',2.92),('14598','2014-01-18','12:05:00',2.93),('14598','2014-01-18','12:10:00',2.94),('14598','2014-01-18','12:15:00',2.8),('14598','2014-01-18','12:20:00',2.88),('14598','2014-01-18','12:25:00',2.99),('14598','2014-01-18','12:30:00',2.86),('14598','2014-01-18','12:35:00',3.11),('14598','2014-01-18','12:40:00',2.73),('14598','2014-01-18','12:45:00',3.24),('14598','2014-01-18','12:50:00',3),('14598','2014-01-18','12:55:00',1.81),('14598','2014-01-18','13:00:00',2.03),('14598','2014-01-18','13:05:00',2.83),('14598','2014-01-18','13:10:00',2.92),('14598','2014-01-18','13:15:00',2.72),('14598','2014-01-18','13:20:00',2.2),('14598','2014-01-18','13:25:00',3.26),('14598','2014-01-18','13:30:00',2.94),('14598','2014-01-18','13:35:00',2.71),('14598','2014-01-18','13:40:00',2.71),('14598','2014-01-18','13:45:00',2.96),('14598','2014-01-18','13:50:00',3.09),('14598','2014-01-18','13:55:00',2.68),('14598','2014-01-18','14:00:00',2.7),('14598','2014-01-18','14:05:00',2.68),('14598','2014-01-18','14:10:00',2.35),('14598','2014-01-18','14:15:00',2.01),('14598','2014-01-18','14:20:00',2.58),('14598','2014-01-18','14:25:00',2.58),('14598','2014-01-18','14:30:00',2.26),('14598','2014-01-18','14:35:00',2.06),('14598','2014-01-18','14:40:00',2.31),('14598','2014-01-18','15:10:00',1.29),('14598','2014-01-18','15:15:00',2.26),('14598','2014-01-18','15:20:00',1.59),('14598','2014-01-18','15:40:00',1.64),('14598','2014-01-18','15:45:00',1.45),('14598','2014-01-18','15:50:00',1.03),('14598','2014-01-18','15:55:00',1.16),('14598','2014-01-17','09:15:00',1.17),('14598','2014-01-17','09:20:00',1.4),('14598','2014-01-17','09:25:00',1.56),('14598','2014-04-25','08:10:00',1),('14598','2014-04-25','08:15:00',1.03),('14598','2014-04-25','08:20:00',1.12),('14598','2014-04-25','08:25:00',1.19),('14598','2014-04-25','08:30:00',1.31),('14598','2014-04-25','08:35:00',1.41),('14598','2014-04-25','08:40:00',1.49),('14598','2014-04-25','08:45:00',1.59),('14598','2014-04-25','08:50:00',1.6),('14598','2014-04-25','08:55:00',1.78),('14598','2014-04-25','09:00:00',1.92),('14598','2014-04-25','09:05:00',2.02),('14598','2014-04-25','09:10:00',2.14),('14598','2014-04-25','09:15:00',2.4),('14598','2014-04-25','09:20:00',1.93),('14598','2014-04-25','09:25:00',2.36),('14598','2014-04-25','09:30:00',1.13),('14598','2014-04-25','09:40:00',1.05),('14598','2014-04-25','09:45:00',1.17),('14598','2014-04-25','09:50:00',1.13),('14598','2014-04-25','09:55:00',1.28),('14598','2014-04-25','10:00:00',1.94),('14598','2014-04-25','10:05:00',2.63),('14598','2014-04-25','10:10:00',3.59),('14598','2014-04-25','10:15:00',3.47),('14598','2014-04-25','10:20:00',3.48),('14598','2014-04-25','10:25:00',3.57),('14598','2014-04-25','10:30:00',3.65),('14598','2014-04-25','10:35:00',3.74),('14598','2014-04-25','10:40:00',3.83),('14598','2014-04-25','10:45:00',3.81),('14598','2014-04-25','10:50:00',3.91),('14598','2014-04-25','10:55:00',3.98),('14598','2014-04-25','11:00:00',4.03),('14598','2014-04-25','11:05:00',4.1),('14598','2014-04-25','11:10:00',4.13),('14598','2014-04-25','11:15:00',4.21),('14598','2014-04-25','11:20:00',4.3),('14598','2014-04-25','11:25:00',4.33),('14598','2014-04-25','11:30:00',4.37),('14598','2014-04-25','11:35:00',4.41),('14598','2014-04-25','11:40:00',4.45),('14598','2014-04-25','11:45:00',4.5),('14598','2014-04-25','11:50:00',4.54),('14598','2014-04-25','11:55:00',4.59),('14598','2014-04-25','12:00:00',4.62),('14598','2014-04-25','12:05:00',4.67),('14598','2014-04-25','12:10:00',4.72),('14598','2014-04-25','12:15:00',4.74),('14598','2014-04-25','12:20:00',4.8),('14598','2014-04-25','12:25:00',4.8),('14598','2014-04-25','12:30:00',4.84),('14598','2014-04-25','12:35:00',4.87),('14598','2014-04-25','12:40:00',4.88),('14598','2014-04-25','12:45:00',4.9),('14598','2014-04-25','12:50:00',4.91),('14598','2014-04-25','12:55:00',4.93),('14598','2014-04-25','13:00:00',4.95),('14598','2014-04-25','13:05:00',4.97),('14598','2014-04-25','13:10:00',5),('14598','2014-04-25','13:15:00',5.03),('14598','2014-04-25','13:20:00',5.04),('14598','2014-04-25','13:25:00',5.05),('14598','2014-04-25','13:30:00',4.78),('14598','2014-04-25','13:35:00',5.03),('14598','2014-04-25','13:40:00',5.03),('14598','2014-04-25','13:45:00',5.07),('14598','2014-04-25','13:50:00',5.08),('14598','2014-04-25','13:55:00',5.04),('14598','2014-04-25','14:00:00',4.99),('14598','2014-04-25','14:05:00',4.97),('14598','2014-04-25','14:10:00',5),('14598','2014-04-25','14:15:00',5),('14598','2014-04-25','14:20:00',5),('14598','2014-04-25','14:25:00',4.99),('14598','2014-04-25','14:30:00',4.95),('14598','2014-04-25','14:35:00',4.95),('14598','2014-04-25','14:40:00',4.95),('14598','2014-04-25','14:45:00',4.93),('14598','2014-04-25','14:50:00',4.88),('14598','2014-04-25','14:55:00',4.79),('14598','2014-04-25','15:00:00',4.75),('14598','2014-04-25','15:05:00',4.68),('14598','2014-04-25','15:10:00',4.73),('14598','2014-04-25','15:15:00',4.64),('14598','2014-04-25','15:20:00',4.56),('14598','2014-04-25','15:25:00',4.49),('14598','2014-04-25','15:30:00',4.45),('14598','2014-04-25','15:35:00',4.39),('14598','2014-04-25','15:40:00',4.48),('14598','2014-04-25','15:45:00',4.43),('14598','2014-04-25','15:50:00',4.22),('14598','2014-04-25','15:55:00',3.86),('14598','2014-04-25','16:00:00',3.73),('14598','2014-04-25','16:05:00',3.59),('14598','2014-04-25','16:10:00',3.46),('14598','2014-04-25','16:15:00',3.56),('14598','2014-04-25','16:20:00',3.66),('14598','2014-04-25','16:25:00',3.73),('14598','2014-04-25','16:30:00',3.31),('14598','2014-04-25','16:35:00',3),('14598','2014-04-25','16:40:00',3.1),('14598','2014-04-25','16:45:00',2.79),('14598','2014-04-25','16:50:00',3.01),('14598','2014-04-25','16:55:00',2.96),('14598','2014-04-25','17:00:00',2.65),('14598','2014-04-25','17:05:00',2.73),('14598','2014-04-25','17:10:00',2.88),('14598','2014-04-25','17:15:00',2.58),('14598','2014-04-25','17:20:00',2.11),('14598','2014-04-25','17:25:00',1.98),('14598','2014-04-25','17:30:00',1.59),('14598','2014-04-25','17:35:00',1.35),('14598','2014-04-25','17:40:00',1.42),('14598','2014-04-25','17:45:00',1.31),('14598','2014-04-25','17:50:00',1.22),('14598','2014-04-25','17:55:00',1.18),('14598','2014-04-25','18:00:00',1.2),('14598','2014-04-25','18:05:00',1.19),('14598','2014-04-25','18:10:00',1.2),('14598','2014-04-25','18:15:00',1.13),('14598','2014-04-25','18:20:00',1.02),('14598','2014-04-25','18:50:00',1.18),('14598','2014-04-25','18:55:00',1.34),('14598','2014-04-25','19:00:00',1.19),('14598','2014-04-25','19:05:00',1.06),('14598','2014-01-16','09:05:00',1.03),('14598','2014-01-16','09:10:00',1.12),('14598','2014-01-16','09:15:00',1.19),('14598','2014-01-16','09:20:00',1.25),('14598','2014-01-16','09:25:00',1.29),('14598','2014-01-16','09:30:00',1.22),('14598','2014-01-16','09:35:00',1.16),('14598','2014-01-16','09:40:00',1.15),('14598','2014-01-16','09:45:00',1.03),('14598','2014-01-16','09:50:00',1.06),('14598','2014-01-16','09:55:00',1.16),('14598','2014-01-16','10:00:00',1.21),('14598','2014-01-16','10:05:00',1.59),('14598','2014-01-16','10:10:00',1.83),('14598','2014-01-16','10:15:00',2.09),('14598','2014-01-16','10:20:00',2.06),('14598','2014-01-16','10:25:00',1.86),('14598','2014-01-16','10:30:00',1.93),('14598','2014-01-16','10:35:00',2.01),('14598','2014-01-16','10:40:00',2.08),('14598','2014-01-16','10:45:00',2.32),('14598','2014-01-16','10:50:00',2.35),('14598','2014-01-16','10:55:00',2.25),('14598','2014-01-16','11:00:00',1.89),('14598','2014-01-16','11:05:00',1.88),('14598','2014-01-16','11:10:00',1.92),('14598','2014-01-16','11:15:00',1.98),('14598','2014-01-16','11:20:00',2.03),('14598','2014-01-16','11:25:00',2.17),('14598','2014-01-16','11:30:00',2.19),('14598','2014-01-16','11:35:00',2.25),('14598','2014-01-16','11:40:00',2.09),('14598','2014-01-16','11:45:00',2.18),('14598','2014-01-16','11:50:00',2.08),('14598','2014-01-16','11:55:00',2.09),('14598','2014-01-16','12:00:00',1.93),('14598','2014-01-16','12:05:00',1.92),('14598','2014-01-16','12:10:00',1.99),('14598','2014-01-16','12:15:00',2.13),('14598','2014-01-16','12:20:00',2.17),('14598','2014-01-16','12:25:00',2.09),('14598','2014-01-16','12:30:00',2.32),('14598','2014-01-16','12:35:00',2.55),('14598','2014-01-16','12:40:00',2.81),('14598','2014-01-16','12:45:00',2.8),('14598','2014-01-16','12:50:00',2.71),('14598','2014-01-16','12:55:00',2.77),('14598','2014-01-16','13:00:00',2.82),('14598','2014-01-16','13:05:00',2.83),('14598','2014-01-16','13:10:00',2.86),('14598','2014-01-16','13:15:00',2.82),('14598','2014-01-16','13:20:00',3.04),('14598','2014-01-16','13:25:00',3.33),('14598','2014-01-16','13:30:00',3.07),('14598','2014-01-16','13:35:00',1.75),('14598','2014-01-16','13:40:00',1.78),('14598','2014-01-16','13:45:00',1.63),('14598','2014-01-16','13:50:00',1.48),('14598','2014-01-16','13:55:00',1.41),('14598','2014-01-16','14:00:00',1.35),('14598','2014-01-16','14:05:00',1.32),('14598','2014-01-16','14:10:00',1.29),('14598','2014-01-16','14:15:00',1.22),('14598','2014-01-16','14:20:00',1.17),('14598','2014-01-16','14:25:00',1.1),('14598','2014-01-16','14:30:00',1.14),('14598','2014-01-16','14:35:00',1.36),('14598','2014-01-16','14:40:00',1.25),('14598','2014-01-16','14:45:00',1.12),('14598','2014-01-15','09:40:00',1.04),('14598','2014-01-15','09:45:00',1.14),('14598','2014-01-15','09:50:00',1.34),('14598','2014-01-15','09:55:00',1.55),('14598','2014-01-15','10:00:00',1.47),('14598','2014-01-15','10:05:00',1.57),('14598','2014-01-15','10:10:00',1.62),('14598','2014-01-15','10:15:00',1.74),('14598','2014-01-15','10:20:00',2.04),('14598','2014-01-15','10:25:00',2.13),('14598','2014-01-15','10:30:00',2),('14598','2014-01-15','10:35:00',2.03),('14598','2014-01-15','10:40:00',2),('14598','2014-01-15','10:45:00',2.35),('14598','2014-01-15','10:50:00',2.32),('14598','2014-01-15','10:55:00',2.01),('14598','2014-01-15','11:00:00',2.4),('14598','2014-01-15','11:05:00',2.46),('14598','2014-01-15','11:10:00',2.64),('14598','2014-01-15','11:15:00',2.68),('14598','2014-01-15','11:20:00',2.54),('14598','2014-01-15','11:25:00',2.67),('14598','2014-01-15','11:30:00',2.74),('14598','2014-01-15','11:35:00',2.76),('14598','2014-01-15','11:40:00',2.8),('14598','2014-01-15','11:45:00',2.8),('14598','2014-01-15','11:50:00',2.89),('14598','2014-01-15','11:55:00',2.97),('14598','2014-01-15','12:00:00',2.9),('14598','2014-01-15','12:05:00',2.9),('14598','2014-01-15','12:10:00',2.94),('14598','2014-01-15','12:15:00',2.45),('14598','2014-01-15','12:20:00',3.11),('14598','2014-01-15','12:25:00',3.19),('14598','2014-01-15','12:30:00',3.35),('14598','2014-01-15','12:35:00',3.47),('14598','2014-01-15','12:40:00',3.52),('14598','2014-01-15','12:45:00',3.61),('14598','2014-01-15','12:50:00',3.51),('14598','2014-01-15','12:55:00',3.51),('14598','2014-01-15','13:00:00',3.45),('14598','2014-01-15','13:05:00',3.34),('14598','2014-01-15','13:10:00',3.29),('14598','2014-01-15','13:15:00',3.24),('14598','2014-01-15','13:20:00',3.13),('14598','2014-01-15','13:25:00',3.05),('14598','2014-01-15','13:30:00',3),('14598','2014-01-15','13:35:00',2.96),('14598','2014-01-15','13:40:00',2.93),('14598','2014-01-15','13:45:00',2.88),('14598','2014-01-15','13:50:00',2.84),('14598','2014-01-15','13:55:00',2.8),('14598','2014-01-15','14:00:00',2.78),('14598','2014-01-15','14:05:00',2.73),('14598','2014-01-15','14:10:00',2.68),('14598','2014-01-15','14:15:00',2.62),('14598','2014-01-15','14:20:00',2.58),('14598','2014-01-15','14:25:00',2.49),('14598','2014-01-15','14:30:00',2.47),('14598','2014-01-15','14:35:00',2.41),('14598','2014-01-15','14:40:00',2.35),('14598','2014-01-15','14:45:00',2.29),('14598','2014-01-15','14:50:00',2.24),('14598','2014-01-15','14:55:00',2.18),('14598','2014-01-15','15:00:00',2.11),('14598','2014-01-15','15:05:00',2.04),('14598','2014-01-15','15:10:00',1.97),('14598','2014-01-15','15:15:00',1.89),('14598','2014-01-15','15:20:00',1.82),('14598','2014-01-15','15:25:00',1.74),('14598','2014-01-15','15:30:00',1.66),('14598','2014-01-15','15:35:00',1.57),('14598','2014-01-15','15:40:00',1.48),('14598','2014-01-15','15:45:00',1.38),('14598','2014-01-15','15:50:00',1.28),('14598','2014-01-15','15:55:00',1.19),('14598','2014-01-15','16:00:00',1.09),('14598','2014-01-14','09:50:00',1.12),('14598','2014-01-14','09:55:00',1.84),('14598','2014-01-14','10:00:00',1.69),('14598','2014-01-14','10:05:00',1.58),('14598','2014-01-14','10:10:00',1.57),('14598','2014-01-14','10:15:00',1.54),('14598','2014-01-14','10:20:00',1.27),('14598','2014-01-14','10:40:00',1.15),('14598','2014-01-14','10:45:00',1.52),('14598','2014-01-14','10:50:00',1.66),('14598','2014-01-14','10:55:00',1.41),('14598','2014-01-13','09:30:00',1.03),('14598','2014-01-13','09:35:00',1.2),('14598','2014-01-13','09:40:00',1.3),('14598','2014-01-13','09:45:00',1.38),('14598','2014-01-13','09:50:00',1.44),('14598','2014-01-13','09:55:00',1.51),('14598','2014-01-13','10:00:00',1.59),('14598','2014-01-13','10:05:00',1.66),('14598','2014-01-13','10:10:00',1.74),('14598','2014-01-13','10:15:00',1.8),('14598','2014-01-13','10:20:00',1.87),('14598','2014-01-13','10:25:00',1.94),('14598','2014-01-13','10:30:00',2),('14598','2014-01-13','10:35:00',2.01),('14598','2014-01-13','10:40:00',2.1),('14598','2014-01-13','10:45:00',2.17),('14598','2014-01-13','10:50:00',2.22),('14598','2014-01-13','10:55:00',2.27),('14598','2014-01-13','11:00:00',2.33),('14598','2014-01-13','11:05:00',2.38),('14598','2014-01-13','11:10:00',2.39),('14598','2014-01-13','11:15:00',2.42),('14598','2014-01-13','11:20:00',2.47),('14598','2014-01-13','11:25:00',2.51),('14598','2014-01-13','11:30:00',2.54),('14598','2014-01-13','11:35:00',2.55),('14598','2014-01-13','11:40:00',2.59),('14598','2014-01-13','11:45:00',2.63),('14598','2014-01-13','11:50:00',2.63),('14598','2014-01-13','11:55:00',2.69),('14598','2014-01-13','12:00:00',2.69),('14598','2014-01-13','12:05:00',2.74),('14598','2014-01-13','12:10:00',2.72),('14598','2014-01-13','12:15:00',2.71),('14598','2014-01-13','12:20:00',2.73),('14598','2014-01-13','12:25:00',2.73),('14598','2014-01-13','12:30:00',2.74),('14598','2014-01-13','12:35:00',2.72),('14598','2014-01-13','12:40:00',2.73),('14598','2014-01-13','12:45:00',2.73),('14598','2014-01-13','12:50:00',2.74),('14598','2014-01-13','12:55:00',2.72),('14598','2014-01-13','13:00:00',2.73),('14598','2014-01-13','13:05:00',2.71),('14598','2014-01-13','13:10:00',2.68),('14598','2014-01-13','13:15:00',2.67),('14598','2014-01-13','13:20:00',2.68),('14598','2014-01-13','13:25:00',2.69),('14598','2014-01-13','13:30:00',2.68),('14598','2014-01-13','13:35:00',2.63),('14598','2014-01-13','13:40:00',2.63),('14598','2014-01-13','13:45:00',2.58),('14598','2014-01-13','13:50:00',2.53),('14598','2014-01-13','13:55:00',2.49),('14598','2014-01-13','14:00:00',2.47),('14598','2014-01-13','14:05:00',2.43),('14598','2014-01-13','14:10:00',2.39),('14598','2014-01-13','14:15:00',2.37),('14598','2014-01-13','14:20:00',2.32),('14598','2014-01-13','14:25:00',2.28),('14598','2014-01-13','14:30:00',2.22),('14598','2014-01-13','14:35:00',2.17),('14598','2014-01-13','14:40:00',2.13),('14598','2014-01-13','14:45:00',2.06),('14598','2014-01-13','14:50:00',2),('14598','2014-01-13','14:55:00',1.95),('14598','2014-01-13','15:00:00',1.87),('14598','2014-01-13','15:05:00',1.78),('14598','2014-01-13','15:10:00',1.68),('14598','2014-01-13','15:15:00',1.63),('14598','2014-01-13','15:20:00',1.55),('14598','2014-01-13','15:25:00',1.47),('14598','2014-01-13','15:30:00',1.39),('14598','2014-01-13','15:35:00',1.31),('14598','2014-01-13','15:40:00',1.21),('14598','2014-01-13','15:45:00',1.12),('14598','2014-01-13','15:50:00',1.04),('14598','2014-01-12','10:05:00',1.11),('14598','2014-01-12','10:10:00',1.29),('14598','2014-01-12','10:15:00',1.17),('14598','2014-01-12','10:20:00',1.23),('14598','2014-01-12','10:25:00',1.29),('14598','2014-01-12','10:30:00',1.51),('14598','2014-01-12','10:35:00',1.46),('14598','2014-01-12','10:40:00',1.36),('14598','2014-01-12','10:45:00',1.69),('14598','2014-01-12','10:50:00',2.19),('14598','2014-01-12','10:55:00',2.08),('14598','2014-01-12','11:00:00',2.33),('14598','2014-01-12','11:05:00',2.46),('14598','2014-01-12','11:10:00',2.19),('14598','2014-01-12','11:15:00',2.22),('14598','2014-01-12','11:20:00',2.41),('14598','2014-01-12','11:25:00',2.55),('14598','2014-01-12','11:30:00',1.74),('14598','2014-01-12','11:35:00',1.81),('14598','2014-01-12','11:40:00',1.5),('14598','2014-01-12','11:45:00',1.4),('14598','2014-01-12','11:50:00',1.64),('14598','2014-01-12','11:55:00',1.57),('14598','2014-01-12','12:00:00',1.49),('14598','2014-01-12','12:05:00',1.31),('14598','2014-01-12','12:10:00',1.16),('14598','2014-01-12','12:15:00',1.17),('14598','2014-01-12','12:20:00',1.22),('14598','2014-01-12','12:25:00',1.19),('14598','2014-01-12','12:30:00',1.15),('14598','2014-01-12','12:35:00',1.18),('14598','2014-01-12','12:40:00',1.14),('14598','2014-01-12','12:45:00',1.06),('14598','2014-01-12','12:50:00',1.02),('14598','2014-01-12','13:00:00',1.01),('14598','2014-01-12','13:05:00',1.1),('14598','2014-01-12','13:10:00',1.17),('14598','2014-01-12','13:15:00',1.19),('14598','2014-01-12','13:20:00',1.22),('14598','2014-01-12','13:25:00',1.28),('14598','2014-01-12','13:30:00',1.29),('14598','2014-01-12','13:35:00',1.24),('14598','2014-01-12','13:40:00',1.23),('14598','2014-01-12','13:45:00',1.16),('14598','2014-01-12','13:50:00',1.08),('14598','2014-01-12','13:55:00',1.01),('14598','2014-01-11','09:55:00',1.03),('14598','2014-01-11','10:00:00',1.18),('14598','2014-01-11','10:05:00',1.22),('14598','2014-01-11','10:10:00',1.42),('14598','2014-01-11','10:15:00',1.36),('14598','2014-01-11','10:20:00',1.71),('14598','2014-01-11','10:25:00',1.84),('14598','2014-01-11','10:30:00',2.02),('14598','2014-01-11','10:35:00',1.97),('14598','2014-01-11','10:40:00',2.19),('14598','2014-01-11','10:45:00',2.28),('14598','2014-01-11','10:50:00',2.21),('14598','2014-01-11','10:55:00',1.84),('14598','2014-01-11','11:00:00',1.6),('14598','2014-01-11','11:05:00',1.63),('14598','2014-01-11','11:10:00',1.73),('14598','2014-01-11','11:15:00',1.71),('14598','2014-01-11','11:20:00',2.06),('14598','2014-01-11','11:25:00',2.03),('14598','2014-01-11','11:30:00',1.89),('14598','2014-01-11','11:35:00',1.93),('14598','2014-01-11','11:40:00',2.18),('14598','2014-01-11','11:45:00',1.93),('14598','2014-01-11','11:50:00',1.96),('14598','2014-01-11','11:55:00',2.6),('14598','2014-01-11','12:00:00',2.89),('14598','2014-01-11','12:05:00',1.8),('14598','2014-01-11','12:10:00',1.77),('14598','2014-01-11','12:15:00',2.35),('14598','2014-01-11','12:20:00',2.31),('14598','2014-01-11','12:25:00',2.45),('14598','2014-01-11','12:30:00',2.68),('14598','2014-01-11','12:35:00',2.7),('14598','2014-01-11','12:40:00',3.06),('14598','2014-01-11','12:45:00',2.99),('14598','2014-01-11','12:50:00',2.88),('14598','2014-01-11','12:55:00',2.5),('14598','2014-01-11','13:00:00',2.12),('14598','2014-01-11','13:05:00',2.52),('14598','2014-01-11','13:10:00',2.2),('14598','2014-01-11','13:15:00',2),('14598','2014-01-11','13:20:00',1.83),('14598','2014-01-11','13:25:00',1.69),('14598','2014-01-11','13:30:00',1.64),('14598','2014-01-11','13:35:00',1.61),('14598','2014-01-11','13:40:00',1.88),('14598','2014-01-11','13:45:00',2.01),('14598','2014-01-11','13:50:00',1.41),('14598','2014-01-11','13:55:00',1.1),('14598','2014-01-11','14:00:00',1.02),('14598','2014-01-11','14:05:00',1.06),('14598','2014-01-11','14:10:00',1.11),('14598','2014-01-11','14:15:00',1.15),('14598','2014-01-11','14:20:00',1.13),('14598','2014-01-11','14:25:00',1.12),('14598','2014-01-11','14:30:00',1.08),('14598','2014-01-11','14:35:00',1.03),('14598','2014-01-11','14:50:00',1.01),('14598','2014-01-11','15:15:00',1.22),('14598','2014-01-09','09:15:00',1.04),('14598','2014-01-09','09:20:00',1.16),('14598','2014-01-09','09:25:00',1.27),('14598','2014-01-09','09:30:00',1.35),('14598','2014-01-09','09:35:00',1.43),('14598','2014-01-09','09:40:00',1.42),('14598','2014-01-09','09:45:00',1.45),('14598','2014-01-09','09:50:00',1.46),('14598','2014-01-09','09:55:00',1.48),('14598','2014-01-09','10:00:00',1.56),('14598','2014-01-09','10:05:00',1.64),('14598','2014-01-09','10:10:00',1.72),('14598','2014-01-09','10:15:00',1.73),('14598','2014-01-09','10:20:00',1.71),('14598','2014-01-09','10:25:00',1.59),('14598','2014-01-09','10:30:00',1.54),('14598','2014-01-09','10:35:00',1.51),('14598','2014-01-09','10:40:00',1.53),('14598','2014-01-09','10:45:00',1.34),('14598','2014-01-09','10:50:00',1.21),('14598','2014-01-09','10:55:00',1.17),('14598','2014-01-09','11:00:00',1.23),('14598','2014-01-09','11:05:00',1.23),('14598','2014-01-09','11:10:00',1.16),('14598','2014-01-09','11:15:00',1.17),('14598','2014-01-09','11:20:00',1.16),('14598','2014-01-09','11:25:00',1.17),('14598','2014-01-09','11:30:00',1.22),('14598','2014-01-09','11:35:00',1.35),('14598','2014-01-09','11:40:00',1.46),('14598','2014-01-09','11:45:00',1.62),('14598','2014-01-09','11:50:00',1.5),('14598','2014-01-09','11:55:00',1.5),('14598','2014-01-09','12:00:00',1.81),('14598','2014-01-09','12:05:00',1.92),('14598','2014-01-09','12:10:00',1.64),('14598','2014-01-09','12:15:00',1.5),('14598','2014-01-09','12:20:00',1.62),('14598','2014-01-09','12:25:00',1.82),('14598','2014-01-09','12:30:00',1.6),('14598','2014-01-09','12:35:00',1.13),('14598','2014-01-09','12:40:00',1.34),('14598','2014-01-09','12:45:00',1.28),('14598','2014-01-09','12:50:00',1.18),('14598','2014-01-09','12:55:00',1.15),('14598','2014-01-09','13:00:00',1.23),('14598','2014-01-09','13:05:00',1.23),('14598','2014-01-09','13:10:00',1.13),('14598','2014-01-09','13:15:00',1.06),('14598','2014-01-09','13:20:00',1.05),('14598','2014-01-09','13:25:00',1.22),('14598','2014-01-09','13:30:00',1.12),('14598','2014-01-09','13:35:00',1.07),('14598','2014-01-09','13:40:00',1.01),('14598','2014-01-08','09:25:00',1.01),('14598','2014-01-08','09:30:00',1.09),('14598','2014-01-08','09:35:00',1.09),('14598','2014-01-08','09:40:00',1.17),('14598','2014-01-08','09:45:00',1.25),('14598','2014-01-08','09:50:00',1.3),('14598','2014-01-08','09:55:00',1.44),('14598','2014-01-08','10:00:00',1.53),('14598','2014-01-08','10:05:00',1.63),('14598','2014-01-08','10:10:00',1.72),('14598','2014-01-08','10:15:00',1.73),('14598','2014-01-08','10:20:00',1.65),('14598','2014-01-08','10:25:00',1.85),('14598','2014-01-08','10:30:00',1.92),('14598','2014-01-08','10:35:00',2.02),('14598','2014-01-08','10:40:00',2.13),('14598','2014-01-08','10:45:00',2.2),('14598','2014-01-08','10:50:00',2.26),('14598','2014-01-08','10:55:00',2.31),('14598','2014-01-08','11:00:00',2.35),('14598','2014-01-08','11:05:00',2.38),('14598','2014-01-08','11:10:00',2.29),('14598','2014-01-08','11:15:00',2.47),('14598','2014-01-08','11:20:00',2.52),('14598','2014-01-08','11:25:00',2.55),('14598','2014-01-08','11:30:00',2.58),('14598','2014-01-08','11:35:00',2.61),('14598','2014-01-08','11:40:00',2.65),('14598','2014-01-08','11:45:00',2.59),('14598','2014-01-08','11:50:00',2.48),('14598','2014-01-08','11:55:00',2.39),('14598','2014-01-08','12:00:00',2.65),('14598','2014-01-08','12:05:00',2.58),('14598','2014-01-08','12:10:00',2.67),('14598','2014-01-08','12:15:00',2.72),('14598','2014-01-08','12:20:00',2.63),('14598','2014-01-08','12:25:00',2.55),('14598','2014-01-08','12:30:00',2.51),('14598','2014-01-08','12:35:00',2.41),('14598','2014-01-08','12:40:00',2.55),('14598','2014-01-08','12:45:00',2.67),('14598','2014-01-08','12:50:00',2.68),('14598','2014-01-08','12:55:00',2.7),('14598','2014-01-08','13:00:00',2.77),('14598','2014-01-08','13:05:00',2.78),('14598','2014-01-08','13:10:00',2.76),('14598','2014-01-08','13:15:00',2.69),('14598','2014-01-08','13:20:00',2.68),('14598','2014-01-08','13:25:00',2.71),('14598','2014-01-08','13:30:00',2.69),('14598','2014-01-08','13:35:00',2.6),('14598','2014-01-08','13:40:00',2.64),('14598','2014-01-08','13:45:00',2.6),('14598','2014-01-08','13:50:00',2.58),('14598','2014-01-08','13:55:00',2.52),('14598','2014-01-08','14:00:00',2.45),('14598','2014-01-08','14:05:00',2.46),('14598','2014-01-08','14:10:00',2.32),('14598','2014-01-08','14:15:00',2.17),('14598','2014-01-08','14:20:00',2.01),('14598','2014-01-08','14:25:00',1.89),('14598','2014-01-08','14:30:00',1.77),('14598','2014-01-08','14:35:00',1.79),('14598','2014-01-08','14:40:00',2.15),('14598','2014-01-08','14:45:00',2.15),('14598','2014-01-08','14:50:00',2.01),('14598','2014-01-08','14:55:00',1.78),('14598','2014-01-08','15:00:00',1.86),('14598','2014-01-08','15:05:00',1.77),('14598','2014-01-08','15:10:00',1.54),('14598','2014-01-08','15:15:00',1.58),('14598','2014-01-08','15:20:00',1.59),('14598','2014-01-08','15:25:00',1.49),('14598','2014-01-08','15:30:00',1.29),('14598','2014-01-08','15:35:00',1.22),('14598','2014-01-08','15:40:00',1.05),('14598','2014-01-07','09:35:00',1.04),('14598','2014-01-07','09:55:00',1.1),('14598','2014-01-07','10:00:00',1.23),('14598','2014-01-07','10:05:00',1.07),('14598','2014-01-07','10:10:00',1.23),('14598','2014-01-07','10:15:00',1.47),('14598','2014-01-07','10:20:00',1.33),('14598','2014-01-07','10:25:00',1.62),('14598','2014-01-07','10:30:00',1.77),('14598','2014-01-07','10:35:00',2.05),('14598','2014-01-07','10:40:00',2.26),('14598','2014-01-07','10:45:00',2.25),('14598','2014-01-07','10:50:00',2.33),('14598','2014-01-07','10:55:00',2.31),('14598','2014-01-07','11:00:00',2.4),('14598','2014-01-07','11:05:00',2.45),('14598','2014-01-07','11:10:00',2.49),('14598','2014-01-07','11:15:00',2.51),('14598','2014-01-07','11:20:00',2.56),('14598','2014-01-07','11:25:00',2.61),('14598','2014-01-07','11:30:00',2.59),('14598','2014-01-07','11:35:00',2.67),('14598','2014-01-07','11:40:00',2.71),('14598','2014-01-07','11:45:00',2.73),('14598','2014-01-07','11:50:00',2.76),('14598','2014-01-07','11:55:00',2.78),('14598','2014-01-07','12:00:00',2.8),('14598','2014-01-07','12:05:00',2.8),('14598','2014-01-07','12:10:00',2.83),('14598','2014-01-07','12:15:00',2.85),('14598','2014-01-07','12:20:00',2.86),('14598','2014-01-07','12:25:00',2.88),('14598','2014-01-07','12:30:00',2.89),('14598','2014-01-07','12:35:00',2.91),('14598','2014-01-07','12:40:00',2.91),('14598','2014-01-07','12:45:00',2.86),('14598','2014-01-07','12:50:00',2.77),('14598','2014-01-07','12:55:00',2.69),('14598','2014-01-07','13:00:00',2.8),('14598','2014-01-07','13:05:00',2.53),('14598','2014-01-07','13:10:00',2.72),('14598','2014-01-07','13:15:00',2.69),('14598','2014-01-07','13:20:00',2.68),('14598','2014-01-07','13:25:00',2.7),('14598','2014-01-07','13:30:00',2.62),('14598','2014-01-07','13:35:00',2.71),('14598','2014-01-07','13:40:00',2.71),('14598','2014-01-07','13:45:00',2.31),('14598','2014-01-07','13:50:00',2.4),('14598','2014-01-07','13:55:00',2.5),('14598','2014-01-07','14:00:00',2.51),('14598','2014-01-07','14:05:00',2.37),('14598','2014-01-07','14:10:00',2.37),('14598','2014-01-07','14:15:00',2.4),('14598','2014-01-07','14:20:00',2.32),('14598','2014-01-07','14:25:00',2.31),('14598','2014-01-07','14:30:00',2.25),('14598','2014-01-07','14:35:00',2.2),('14598','2014-01-07','14:40:00',2.15),('14598','2014-01-07','14:45:00',2.13),('14598','2014-01-07','14:50:00',2.12),('14598','2014-01-07','14:55:00',2.06),('14598','2014-01-07','15:00:00',1.98),('14598','2014-01-07','15:05:00',1.91),('14598','2014-01-07','15:10:00',1.74),('14598','2014-01-07','15:15:00',1.6),('14598','2014-01-07','15:20:00',1.34),('14598','2014-01-07','15:25:00',1.3),('14598','2014-01-07','15:30:00',1.29),('14598','2014-01-07','15:35:00',1.08),('14598','2014-01-07','15:40:00',1.07),('14598','2014-01-07','15:45:00',1.05),('14598','2014-01-07','15:50:00',1.06),('14598','2014-01-07','15:55:00',1.09),('14598','2014-01-07','16:00:00',1.03),('14598','2014-04-24','08:15:00',1.04),('14598','2014-04-24','08:20:00',1.12),('14598','2014-04-24','08:25:00',1.22),('14598','2014-04-24','08:30:00',1.32),('14598','2014-04-24','08:35:00',1.43),('14598','2014-04-24','08:40:00',1.53),('14598','2014-04-24','08:45:00',1.62),('14598','2014-04-24','08:50:00',1.71),('14598','2014-04-24','08:55:00',1.82),('14598','2014-04-24','09:00:00',1.95),('14598','2014-04-24','09:05:00',2.1),('14598','2014-04-24','09:10:00',2.2),('14598','2014-04-24','09:15:00',2.27),('14598','2014-04-24','09:20:00',2.36),('14598','2014-04-24','09:25:00',2.48),('14598','2014-04-24','09:30:00',2.54),('14598','2014-04-24','09:35:00',2.63),('14598','2014-04-24','09:40:00',2.69),('14598','2014-04-24','09:45:00',2.78),('14598','2014-04-24','09:50:00',2.84),('14598','2014-04-24','09:55:00',2.93),('14598','2014-04-24','10:00:00',3.07),('14598','2014-04-24','10:05:00',3.16),('14598','2014-04-24','10:10:00',3.25),('14598','2014-04-24','10:15:00',3.37),('14598','2014-04-24','10:20:00',3.39),('14598','2014-04-24','10:25:00',3.49),('14598','2014-04-24','10:30:00',3.57),('14598','2014-04-24','10:35:00',3.63),('14598','2014-04-24','10:40:00',3.71),('14598','2014-04-24','10:45:00',3.75),('14598','2014-04-24','10:50:00',3.85),('14598','2014-04-24','10:55:00',3.91),('14598','2014-04-24','11:00:00',3.97),('14598','2014-04-24','11:05:00',4.01),('14598','2014-04-24','11:10:00',4.06),('14598','2014-04-24','11:15:00',4.09),('14598','2014-04-24','11:20:00',4.12),('14598','2014-04-24','11:25:00',4.21),('14598','2014-04-24','11:30:00',4.26),('14598','2014-04-24','11:35:00',4.31),('14598','2014-04-24','11:40:00',4.36),('14598','2014-04-24','11:45:00',4.41),('14598','2014-04-24','11:50:00',4.47),('14598','2014-04-24','11:55:00',4.51),('14598','2014-04-24','12:00:00',4.54),('14598','2014-04-24','12:05:00',4.52),('14598','2014-04-24','12:10:00',4.61),('14598','2014-04-24','12:15:00',4.64),('14598','2014-04-24','12:20:00',4.7),('14598','2014-04-24','12:25:00',4.74),('14598','2014-04-24','12:30:00',4.78),('14598','2014-04-24','12:35:00',4.83),('14598','2014-04-24','12:40:00',4.86),('14598','2014-04-24','12:45:00',4.87),('14598','2014-04-24','12:50:00',4.9),('14598','2014-04-24','12:55:00',4.92),('14598','2014-04-24','13:00:00',4.95),('14598','2014-04-24','13:05:00',4.97),('14598','2014-04-24','13:10:00',4.99),('14598','2014-04-24','13:15:00',5.01),('14598','2014-04-24','13:20:00',5.02),('14598','2014-04-24','13:25:00',5.04),('14598','2014-04-24','13:30:00',5.04),('14598','2014-04-24','13:35:00',5.03),('14598','2014-04-24','13:40:00',5.01),('14598','2014-04-24','13:45:00',5.03),('14598','2014-04-24','13:50:00',5.01),('14598','2014-04-24','13:55:00',5.02),('14598','2014-04-24','14:00:00',5.03),('14598','2014-04-24','14:05:00',5.03),('14598','2014-04-24','14:10:00',5.01),('14598','2014-04-24','14:15:00',4.99),('14598','2014-04-24','14:20:00',5),('14598','2014-04-24','14:25:00',4.98),('14598','2014-04-24','14:30:00',4.95),('14598','2014-04-24','14:35:00',4.94),('14598','2014-04-24','14:40:00',4.91),('14598','2014-04-24','14:45:00',4.9),('14598','2014-04-24','14:50:00',4.88),('14598','2014-04-24','14:55:00',4.85),('14598','2014-04-24','15:00:00',4.79),('14598','2014-04-24','15:05:00',4.72),('14598','2014-04-24','15:10:00',4.73),('14598','2014-04-24','15:15:00',4.68),('14598','2014-04-24','15:20:00',4.6),('14598','2014-04-24','15:25:00',4.57),('14598','2014-04-24','15:30:00',4.57),('14598','2014-04-24','15:35:00',4.87),('14598','2014-04-24','15:40:00',2.27),('14598','2014-04-24','15:45:00',2.18),('14598','2014-04-24','15:50:00',3.85),('14598','2014-04-24','15:55:00',3.74),('14598','2014-04-24','16:00:00',2.07),('14598','2014-04-24','16:05:00',3.18),('14598','2014-04-24','16:10:00',4.41),('14598','2014-04-24','16:15:00',4.39),('14598','2014-04-24','16:20:00',4.05),('14598','2014-04-24','16:25:00',4.17),('14598','2014-04-24','16:30:00',4.35),('14598','2014-04-24','16:35:00',3.48),('14598','2014-04-24','16:40:00',2.63),('14598','2014-04-24','16:45:00',1.75),('14598','2014-04-24','16:50:00',1.79),('14598','2014-04-24','16:55:00',2.18),('14598','2014-04-24','17:00:00',1.68),('14598','2014-04-24','17:05:00',1.6),('14598','2014-04-24','17:10:00',1.54),('14598','2014-04-24','17:15:00',1.45),('14598','2014-04-24','17:20:00',1.45),('14598','2014-04-24','17:25:00',2.13),('14598','2014-04-24','17:30:00',2.37),('14598','2014-04-24','17:35:00',1.83),('14598','2014-04-24','17:40:00',2.41),('14598','2014-04-24','17:45:00',1.63),('14598','2014-04-24','17:50:00',1.25),('14598','2014-01-06','10:15:00',1.07),('14598','2014-01-06','10:20:00',1.17),('14598','2014-01-06','10:25:00',1.61),('14598','2014-01-06','10:30:00',1.25),('14598','2014-01-06','10:45:00',1.47),('14598','2014-01-06','10:50:00',2.31),('14598','2014-01-06','10:55:00',2.35),('14598','2014-01-06','11:00:00',2.39),('14598','2014-01-06','11:05:00',2.44),('14598','2014-01-06','11:10:00',2.49),('14598','2014-01-06','11:15:00',2.55),('14598','2014-01-06','11:20:00',2.59),('14598','2014-01-06','11:25:00',1.13),('14598','2014-01-06','11:35:00',1.27),('14598','2014-01-06','11:40:00',1.83),('14598','2014-01-06','11:45:00',2.82),('14598','2014-01-06','11:50:00',2.8),('14598','2014-01-06','11:55:00',2.78),('14598','2014-01-06','12:00:00',2.79),('14598','2014-01-06','12:05:00',2.79),('14598','2014-01-06','12:10:00',2.81),('14598','2014-01-06','12:15:00',2.81),('14598','2014-01-06','12:20:00',2.81),('14598','2014-01-06','12:25:00',2.81),('14598','2014-01-06','12:30:00',2.81),('14598','2014-01-06','12:35:00',2.83),('14598','2014-01-06','12:40:00',2.83),('14598','2014-01-06','12:45:00',2.82),('14598','2014-01-06','12:50:00',2.82),('14598','2014-01-06','12:55:00',2.81),('14598','2014-01-06','13:00:00',2.81),('14598','2014-01-06','13:05:00',2.79),('14598','2014-01-06','13:10:00',2.78),('14598','2014-01-06','13:15:00',2.77),('14598','2014-01-06','13:20:00',2.74),('14598','2014-01-06','13:25:00',2.74),('14598','2014-01-06','13:30:00',2.73),('14598','2014-01-06','13:35:00',2.71),('14598','2014-01-06','13:40:00',2.67),('14598','2014-01-06','13:45:00',2.62),('14598','2014-01-06','13:50:00',2.58),('14598','2014-01-06','13:55:00',2.55),('14598','2014-01-06','14:00:00',2.54),('14598','2014-01-06','14:05:00',2.51),('14598','2014-01-06','14:10:00',2.59),('14598','2014-01-06','14:15:00',2.23),('14598','2014-01-06','14:20:00',1.03),('14598','2014-01-06','14:30:00',1.35),('14598','2014-01-06','14:35:00',2.41),('14598','2014-01-06','14:40:00',2.8),('14598','2014-01-06','14:45:00',2.75),('14598','2014-01-06','14:50:00',2.64),('14598','2014-01-06','14:55:00',2.52),('14598','2014-01-06','15:00:00',2.51),('14598','2014-01-06','15:05:00',2.31),('14598','2014-01-06','15:10:00',2.24),('14598','2014-01-06','15:15:00',2.08),('14598','2014-01-06','15:20:00',1.83),('14598','2014-01-06','15:25:00',1.62),('14598','2014-01-06','15:30:00',1.74),('14598','2014-01-06','15:35:00',1.72),('14598','2014-01-06','15:40:00',1.4),('14598','2014-01-06','15:45:00',1.07),('14598','2014-01-04','12:05:00',1.27),('14598','2014-01-04','12:10:00',1.33),('14598','2014-01-04','12:15:00',1.11),('14598','2014-01-04','14:30:00',1.02),('14598','2014-01-03','09:45:00',1.23),('14598','2014-01-03','09:50:00',1.17),('14598','2014-01-03','10:10:00',1.04),('14598','2014-01-03','10:20:00',1.78),('14598','2014-01-03','10:25:00',1.43),('14598','2014-01-03','10:30:00',1.56),('14598','2014-01-03','10:35:00',1.66),('14598','2014-01-03','10:40:00',1.06),('14598','2014-01-03','10:45:00',1.12),('14598','2014-01-03','11:10:00',1.22),('14598','2014-01-03','11:15:00',1.27),('14598','2014-01-03','11:20:00',1.22),('14598','2014-01-03','11:30:00',1.36),('14598','2014-01-03','11:35:00',1.29),('14598','2014-01-03','11:40:00',1.14),('14598','2014-01-03','11:45:00',1.13),('14598','2014-01-03','12:05:00',2.44),('14598','2014-01-03','12:10:00',2.8),('14598','2014-01-03','12:15:00',3.09),('14598','2014-01-03','12:20:00',2.82),('14598','2014-01-03','12:25:00',3.27),('14598','2014-01-03','12:30:00',3.61),('14598','2014-01-03','12:35:00',2.83),('14598','2014-01-03','12:40:00',2.43),('14598','2014-01-03','12:45:00',3.22),('14598','2014-01-03','12:50:00',2.5),('14598','2014-01-03','12:55:00',1.83),('14598','2014-01-03','13:00:00',2.12),('14598','2014-01-03','13:05:00',1.8),('14598','2014-01-03','13:10:00',1.46),('14598','2014-01-03','13:15:00',1.56),('14598','2014-01-03','13:20:00',1.72),('14598','2014-01-03','13:25:00',1.77),('14598','2014-01-03','13:30:00',1.61),('14598','2014-01-03','13:35:00',1.8),('14598','2014-01-03','13:40:00',2.1),('14598','2014-01-03','13:45:00',1.59),('14598','2014-01-03','13:50:00',1.3),('14598','2014-01-03','13:55:00',1.16),('14598','2014-01-03','14:40:00',1.34),('14598','2014-01-02','09:25:00',1),('14598','2014-01-02','09:30:00',1.08),('14598','2014-01-02','09:35:00',1.17),('14598','2014-01-02','09:40:00',1.25),('14598','2014-01-02','09:45:00',1.33),('14598','2014-01-02','09:50:00',1.41),('14598','2014-01-02','09:55:00',1.49),('14598','2014-01-02','10:00:00',1.6),('14598','2014-01-02','10:05:00',1.71),('14598','2014-01-02','10:10:00',1.37),('14598','2014-01-02','10:15:00',1.66),('14598','2014-01-02','10:20:00',1.33),('14598','2014-01-02','10:25:00',1.38),('14598','2014-01-02','10:30:00',1.35),('14598','2014-01-02','10:35:00',1.21),('14598','2014-01-02','10:40:00',1.17),('14598','2014-01-02','10:45:00',1.14),('14598','2014-01-02','10:50:00',1.16),('14598','2014-01-02','10:55:00',1.28),('14598','2014-01-02','11:00:00',1.5),('14598','2014-01-02','11:05:00',1.9),('14598','2014-01-02','11:10:00',1.84),('14598','2014-01-02','11:15:00',1.77),('14598','2014-01-02','11:20:00',1.74),('14598','2014-01-02','11:25:00',1.75),('14598','2014-01-02','11:30:00',1.42),('14598','2014-01-02','11:35:00',1.25),('14598','2014-01-02','11:40:00',1.24),('14598','2014-01-02','11:45:00',1.23),('14598','2014-01-02','11:50:00',1.12),('14598','2014-01-02','11:55:00',1.05),('14598','2014-01-02','12:00:00',1.08),('14598','2014-01-02','12:05:00',1.14),('14598','2014-01-02','12:10:00',1.16),('14598','2014-01-02','12:15:00',1.35),('14598','2014-01-02','12:20:00',1.48),('14598','2014-01-02','12:25:00',2.28),('14598','2014-01-02','12:30:00',3.42),('14598','2014-01-02','12:35:00',3),('14598','2014-01-02','12:40:00',2.82),('14598','2014-01-02','12:45:00',2.98),('14598','2014-01-02','12:50:00',2.35),('14598','2014-01-02','12:55:00',1.71),('14598','2014-01-02','13:00:00',2.68),('14598','2014-01-02','13:05:00',1.61),('14598','2014-01-02','13:10:00',1.63),('14598','2014-01-02','13:15:00',1.14),('14598','2014-01-02','13:20:00',1),('14598','2014-01-02','13:45:00',1.14),('14598','2014-01-01','09:25:00',1.08),('14598','2014-01-01','09:30:00',1.18),('14598','2014-01-01','09:35:00',1.29),('14598','2014-01-01','09:40:00',1.39),('14598','2014-01-01','09:45:00',1.55),('14598','2014-01-01','09:50:00',1.84),('14598','2014-01-01','09:55:00',1.35),('14598','2014-01-01','10:10:00',1.81),('14598','2014-01-01','10:15:00',1.82),('14598','2014-01-01','10:20:00',1.87),('14598','2014-01-01','10:25:00',1.93),('14598','2014-01-01','10:30:00',2),('14598','2014-01-01','10:35:00',2.06),('14598','2014-01-01','10:40:00',2.11),('14598','2014-01-01','10:45:00',2.14),('14598','2014-01-01','10:50:00',2.22),('14598','2014-01-01','10:55:00',2.26),('14598','2014-01-01','11:00:00',2.3),('14598','2014-01-01','11:05:00',2.33),('14598','2014-01-01','11:10:00',2.39),('14598','2014-01-01','11:15:00',2.43),('14598','2014-01-01','11:20:00',2.45),('14598','2014-01-01','11:25:00',2.48),('14598','2014-01-01','11:30:00',2.51),('14598','2014-01-01','11:35:00',2.56),('14598','2014-01-01','11:40:00',2.58),('14598','2014-01-01','11:45:00',2.61),('14598','2014-01-01','11:50:00',2.64),('14598','2014-01-01','11:55:00',2.66),('14598','2014-01-01','12:00:00',2.67),('14598','2014-01-01','12:05:00',2.72),('14598','2014-01-01','12:10:00',2.77),('14598','2014-01-01','12:15:00',2.79),('14598','2014-01-01','12:20:00',2.82),('14598','2014-01-01','12:25:00',2.79),('14598','2014-01-01','12:30:00',2.86),('14598','2014-01-01','12:35:00',2.4),('14598','2014-01-01','12:40:00',1.69),('14598','2014-01-01','12:45:00',2.11),('14598','2014-01-01','12:50:00',1.96),('14598','2014-01-01','12:55:00',2.05),('14598','2014-01-01','13:00:00',2.86),('14598','2014-01-01','13:05:00',3.04),('14598','2014-01-01','13:10:00',3.22),('14598','2014-01-01','13:15:00',2.82),('14598','2014-01-01','13:20:00',2.69),('14598','2014-01-01','13:25:00',2.26),('14598','2014-01-01','13:30:00',2.57),('14598','2014-01-01','13:35:00',2.54),('14598','2014-01-01','13:40:00',2.58),('14598','2014-01-01','13:45:00',2.67),('14598','2014-01-01','13:50:00',2.77),('14598','2014-01-01','13:55:00',2.73),('14598','2014-01-01','14:00:00',1.73),('14598','2014-01-01','14:05:00',1.76),('14598','2014-01-01','14:10:00',2.04),('14598','2014-01-01','14:15:00',1.39),('14598','2014-01-01','14:20:00',1.71),('14598','2014-01-01','14:25:00',2.3),('14598','2014-01-01','14:30:00',1.66),('14598','2014-01-01','14:35:00',1.43),('14598','2014-01-01','14:40:00',1.84),('14598','2014-01-01','14:45:00',1.99),('14598','2014-01-01','14:50:00',1.88),('14598','2014-01-01','14:55:00',1.8),('14598','2014-01-01','15:00:00',1.71),('14598','2014-01-01','15:05:00',1.64),('14598','2014-01-01','15:10:00',1.57),('14598','2014-01-01','15:15:00',1.49),('14598','2014-01-01','15:20:00',1.4),('14598','2014-01-01','15:25:00',1.3),('14598','2014-01-01','15:30:00',1.22),('14598','2014-01-01','15:35:00',1.17),('14598','2014-01-01','15:40:00',1.08),('14598','2013-12-31','09:05:00',1.16),('14598','2013-12-31','09:10:00',1.16),('14598','2013-12-31','09:15:00',1.14),('14598','2013-12-31','09:35:00',1.04),('14598','2013-12-31','09:45:00',1.15),('14598','2013-12-31','10:10:00',1.07),('14598','2013-12-31','10:15:00',1.31),('14598','2013-12-31','10:35:00',1.1),('14598','2013-12-31','10:40:00',1.2),('14598','2013-12-31','10:45:00',1.28),('14598','2013-12-31','10:50:00',1.3),('14598','2013-12-31','10:55:00',1.32),('14598','2013-12-31','11:00:00',1.42),('14598','2013-12-31','11:05:00',1.18),('14598','2013-12-31','11:10:00',1.2),('14598','2013-12-31','11:15:00',1.23),('14598','2013-12-31','11:20:00',1.26),('14598','2013-12-31','11:25:00',1.28),('14598','2013-12-31','11:30:00',1.26),('14598','2013-12-31','11:35:00',1.38),('14598','2013-12-31','11:40:00',1.35),('14598','2013-12-31','11:45:00',1.33),('14598','2013-12-31','11:50:00',1.27),('14598','2013-12-31','12:25:00',1.17),('14598','2013-12-31','12:35:00',2.87),('14598','2013-12-31','12:40:00',3.06),('14598','2013-12-31','12:45:00',2.9),('14598','2013-12-31','12:50:00',2.83),('14598','2013-12-31','12:55:00',2.81),('14598','2013-12-31','13:00:00',2.78),('14598','2013-12-31','13:05:00',2.76),('14598','2013-12-31','13:10:00',2.74),('14598','2013-12-31','13:15:00',2.72),('14598','2013-12-31','13:20:00',2.72),('14598','2013-12-31','13:25:00',2.7),('14598','2013-12-31','13:30:00',2.66),('14598','2013-12-31','13:35:00',2.62),('14598','2013-12-31','13:40:00',2.61),('14598','2013-12-31','13:45:00',2.56),('14598','2013-12-31','13:50:00',2.54),('14598','2013-12-31','13:55:00',2.51),('14598','2013-12-31','14:00:00',2.47),('14598','2013-12-31','14:05:00',2.41),('14598','2013-12-31','14:10:00',2.36),('14598','2013-12-31','14:15:00',2.32),('14598','2013-12-31','14:20:00',2.22),('14598','2013-12-31','14:25:00',2.21),('14598','2013-12-31','14:30:00',2.15),('14598','2013-12-31','14:35:00',2.09),('14598','2013-12-31','14:40:00',2.02),('14598','2013-12-31','14:45:00',1.96),('14598','2013-12-31','14:50:00',1.9),('14598','2013-12-31','14:55:00',1.82),('14598','2013-12-31','15:00:00',1.73),('14598','2013-12-31','15:05:00',1.65),('14598','2013-12-31','15:10:00',1.58),('14598','2013-12-31','15:15:00',1.51),('14598','2013-12-31','15:20:00',1.42),('14598','2013-12-31','15:25:00',1.34),('14598','2013-12-31','15:30:00',1.26),('14598','2013-12-31','15:35:00',1.17),('14598','2013-12-31','15:40:00',1.09),('14598','2013-12-29','09:40:00',1.25),('14598','2013-12-29','09:45:00',1.33),('14598','2013-12-29','09:50:00',1.35),('14598','2013-12-29','09:55:00',1.54),('14598','2013-12-29','10:00:00',1.8),('14598','2013-12-29','10:05:00',1.65),('14598','2013-12-29','10:10:00',1.84),('14598','2013-12-29','10:15:00',1.95),('14598','2013-12-29','10:20:00',1.56),('14598','2013-12-29','10:25:00',2.07),('14598','2013-12-29','10:30:00',2.52),('14598','2013-12-29','10:35:00',2.67),('14598','2013-12-29','10:40:00',2.2),('14598','2013-12-29','10:45:00',2.2),('14598','2013-12-29','10:50:00',2.72),('14598','2013-12-29','10:55:00',2.89),('14598','2013-12-29','11:00:00',1.66),('14598','2013-12-29','11:05:00',1.36),('14598','2013-12-29','11:10:00',1.36),('14598','2013-12-29','11:15:00',1.06),('14598','2013-12-28','09:25:00',1.05),('14598','2013-12-28','09:30:00',1.13),('14598','2013-12-28','09:35:00',1.23),('14598','2013-12-28','09:40:00',1.31),('14598','2013-12-28','09:45:00',1.4),('14598','2013-12-28','09:50:00',1.48),('14598','2013-12-28','09:55:00',1.56),('14598','2013-12-28','10:00:00',1.63),('14598','2013-12-28','10:05:00',1.71),('14598','2013-12-28','10:10:00',1.78),('14598','2013-12-28','10:15:00',1.85),('14598','2013-12-28','10:20:00',1.92),('14598','2013-12-28','10:25:00',1.98),('14598','2013-12-28','10:30:00',2.04),('14598','2013-12-28','10:35:00',2.1),('14598','2013-12-28','10:40:00',2.16),('14598','2013-12-28','10:45:00',2.22),('14598','2013-12-28','10:50:00',2.27),('14598','2013-12-28','10:55:00',2.32),('14598','2013-12-28','11:00:00',2.37),('14598','2013-12-28','11:05:00',2.41),('14598','2013-12-28','11:10:00',2.45),('14598','2013-12-28','11:15:00',2.49),('14598','2013-12-28','11:20:00',2.54),('14598','2013-12-28','11:25:00',2.57),('14598','2013-12-28','11:30:00',2.61),('14598','2013-12-28','11:35:00',2.64),('14598','2013-12-28','11:40:00',2.67),('14598','2013-12-28','11:45:00',2.7),('14598','2013-12-28','11:50:00',2.73),('14598','2013-12-28','11:55:00',2.75),('14598','2013-12-28','12:00:00',2.75),('14598','2013-12-28','12:05:00',2.78),('14598','2013-12-28','12:10:00',2.79),('14598','2013-12-28','12:15:00',2.77),('14598','2013-12-28','12:20:00',2.81),('14598','2013-12-28','12:25:00',2.82),('14598','2013-12-28','12:30:00',2.82),('14598','2013-12-28','12:35:00',2.82),('14598','2013-12-28','12:40:00',2.81),('14598','2013-12-28','12:45:00',2.78),('14598','2013-12-28','12:50:00',2.77),('14598','2013-12-28','12:55:00',2.75),('14598','2013-12-28','13:00:00',2.75),('14598','2013-12-28','13:05:00',2.74),('14598','2013-12-28','13:10:00',2.71),('14598','2013-12-28','13:15:00',2.69),('14598','2013-12-28','13:20:00',2.68),('14598','2013-12-28','13:25:00',2.67),('14598','2013-12-28','13:30:00',2.63),('14598','2013-12-28','13:35:00',2.61),('14598','2013-12-28','13:40:00',2.58),('14598','2013-12-28','13:45:00',2.56),('14598','2013-12-28','13:50:00',2.54),('14598','2013-12-28','13:55:00',2.5),('14598','2013-12-28','14:00:00',2.43),('14598','2013-12-28','14:05:00',2.42),('14598','2013-12-28','14:10:00',2.38),('14598','2013-12-28','14:15:00',2.31),('14598','2013-12-28','14:20:00',2.2),('14598','2013-12-28','14:25:00',2.23),('14598','2013-12-28','14:30:00',2.25),('14598','2013-12-28','14:35:00',2.29),('14598','2013-12-28','14:40:00',2.22),('14598','2013-12-28','14:45:00',2.18),('14598','2013-12-28','14:50:00',2.04),('14598','2013-12-28','14:55:00',1.9),('14598','2013-12-28','15:00:00',1.77),('14598','2013-12-28','15:05:00',1.69),('14598','2013-12-28','15:10:00',1.61),('14598','2013-12-28','15:15:00',1.47),('14598','2013-12-28','15:20:00',1.48),('14598','2013-12-28','15:25:00',1.4),('14598','2013-12-28','15:30:00',1.32),('14598','2013-12-28','15:35:00',1.23),('14598','2013-12-28','15:40:00',1.14),('14598','2013-12-28','15:45:00',1),('14598','2014-04-23','10:55:00',1.27),('14598','2014-04-23','11:00:00',1.47),('14598','2014-04-23','11:05:00',1.52),('14598','2014-04-23','11:10:00',1.47),('14598','2014-04-23','11:15:00',1.35),('14598','2014-04-23','11:20:00',1.33),('14598','2014-04-23','11:25:00',1.21),('14598','2014-04-23','11:30:00',1.21),('14598','2014-04-23','11:35:00',1.16),('14598','2014-04-23','11:40:00',1.09),('14598','2014-04-23','11:45:00',1.25),('14598','2014-04-23','11:50:00',1.47),('14598','2014-04-23','11:55:00',1.45),('14598','2014-04-23','12:00:00',1.33),('14598','2014-04-23','12:05:00',1.17),('14598','2014-04-23','12:10:00',1.04),('14598','2014-04-23','12:20:00',1.04),('14598','2014-04-23','12:25:00',1.21),('14598','2014-04-23','12:30:00',1.36),('14598','2014-04-23','12:35:00',1.51),('14598','2014-04-23','12:40:00',1.57),('14598','2014-04-23','12:45:00',1.54),('14598','2014-04-23','12:50:00',1.47),('14598','2014-04-23','12:55:00',1.51),('14598','2014-04-23','13:00:00',1.6),('14598','2014-04-23','13:05:00',1.72),('14598','2014-04-23','13:10:00',1.82),('14598','2014-04-23','13:15:00',2.01),('14598','2014-04-23','13:20:00',2.13),('14598','2014-04-23','13:25:00',2.16),('14598','2014-04-23','13:30:00',2.24),('14598','2014-04-23','13:35:00',2.55),('14598','2014-04-23','13:40:00',2.87),('14598','2014-04-23','13:45:00',3.29),('14598','2014-04-23','13:50:00',3.35),('14598','2014-04-23','13:55:00',3.3),('14598','2014-04-23','14:00:00',3.08),('14598','2014-04-23','14:05:00',3.19),('14598','2014-04-23','14:10:00',3.22),('14598','2014-04-23','14:15:00',3.1),('14598','2014-04-23','14:20:00',2.54),('14598','2014-04-23','14:25:00',2.15),('14598','2014-04-23','14:30:00',1.99),('14598','2014-04-23','14:35:00',1.94),('14598','2014-04-23','14:40:00',1.73),('14598','2014-04-23','14:45:00',1.54),('14598','2014-04-23','14:50:00',1.46),('14598','2014-04-23','14:55:00',1.37),('14598','2014-04-23','15:00:00',1.26),('14598','2014-04-23','15:05:00',1.26),('14598','2014-04-23','15:10:00',1.25),('14598','2014-04-23','15:15:00',1.26),('14598','2014-04-23','15:20:00',1.28),('14598','2014-04-23','15:25:00',1.28),('14598','2014-04-23','15:30:00',1.28),('14598','2014-04-23','15:35:00',1.28),('14598','2014-04-23','15:40:00',1.3),('14598','2014-04-23','15:45:00',1.32),('14598','2014-04-23','15:50:00',1.39),('14598','2014-04-23','15:55:00',1.34),('14598','2014-04-23','16:00:00',1.26),('14598','2014-04-23','16:05:00',1.24),('14598','2014-04-23','16:10:00',1.24),('14598','2014-04-23','16:15:00',1.24),('14598','2014-04-23','16:20:00',1.27),('14598','2014-04-23','16:25:00',1.33),('14598','2014-04-23','16:30:00',1.28),('14598','2014-04-23','16:35:00',1.15),('14598','2014-04-23','16:40:00',1.02),('14598','2013-12-27','11:10:00',1.15),('14598','2013-12-27','11:15:00',1.76),('14598','2013-12-27','11:20:00',1.83),('14598','2013-12-27','11:25:00',1.38),('14598','2013-12-27','11:30:00',1.19),('14598','2013-12-27','11:35:00',1.23),('14598','2013-12-27','11:40:00',1.34),('14598','2013-12-27','11:45:00',1.34),('14598','2013-12-27','11:50:00',1.28),('14598','2013-12-27','11:55:00',1.29),('14598','2013-12-27','12:00:00',1.39),('14598','2013-12-27','12:05:00',1.45),('14598','2013-12-27','12:10:00',1.42),('14598','2013-12-27','12:15:00',1.4),('14598','2013-12-27','12:20:00',1.38),('14598','2013-12-27','12:25:00',1.27),('14598','2013-12-27','12:30:00',1.22),('14598','2013-12-27','12:35:00',1.18),('14598','2013-12-27','12:40:00',1.63),('14598','2013-12-27','12:45:00',1.78),('14598','2013-12-27','12:50:00',1.97),('14598','2013-12-27','12:55:00',2.15),('14598','2013-12-27','13:00:00',2.12),('14598','2013-12-27','13:05:00',2.32),('14598','2013-12-27','13:10:00',2.63),('14598','2013-12-27','13:15:00',2.31),('14598','2013-12-27','13:20:00',2.03),('14598','2013-12-27','13:25:00',1.53),('14598','2013-12-27','13:30:00',1.73),('14598','2013-12-27','13:35:00',1.56),('14598','2013-12-27','13:40:00',1.33),('14598','2013-12-27','13:45:00',1.35),('14598','2013-12-27','13:50:00',1.46),('14598','2013-12-27','13:55:00',1.28),('14598','2013-12-27','14:00:00',1.19),('14598','2013-12-27','14:05:00',1.13),('14598','2013-12-27','14:10:00',1.13),('14598','2013-12-27','14:15:00',1.14),('14598','2013-12-27','14:20:00',1.16),('14598','2013-12-27','14:25:00',1.08),('14598','2013-12-27','14:30:00',1.02),('14598','2013-12-25','10:25:00',1.17),('14598','2013-12-25','10:30:00',1.11),('14598','2013-12-25','10:40:00',1.19),('14598','2013-12-25','10:45:00',1.79),('14598','2013-12-25','10:50:00',1.61),('14598','2013-12-25','10:55:00',1.35),('14598','2013-12-25','11:00:00',1.17),('14598','2013-12-25','11:05:00',1.53),('14598','2013-12-25','11:10:00',1.18),('14598','2013-12-25','11:15:00',2.35),('14598','2013-12-25','11:20:00',2.6),('14598','2013-12-25','11:25:00',2.01),('14598','2013-12-25','11:30:00',1.42),('14598','2013-12-25','11:50:00',1.06),('14598','2013-12-25','11:55:00',1.57),('14598','2013-12-25','12:00:00',2.69),('14598','2013-12-25','12:05:00',1.32),('14598','2013-12-25','12:10:00',1.62),('14598','2013-12-25','12:15:00',2.31),('14598','2013-12-25','12:20:00',1.07),('14598','2013-12-25','12:45:00',1.23),('14598','2013-12-25','12:50:00',1.32),('14598','2013-12-25','12:55:00',1.38),('14598','2013-12-25','13:00:00',1.82),('14598','2013-12-25','13:05:00',1.68),('14598','2013-12-25','13:10:00',1.71),('14598','2013-12-25','13:15:00',1.25),('14598','2013-12-25','13:20:00',1.22),('14598','2013-12-25','13:25:00',1.2),('14598','2013-12-25','13:30:00',1.11),('14598','2013-12-25','13:35:00',1.12),('14598','2013-12-25','13:40:00',1.21),('14598','2013-12-25','13:45:00',1.01),('14598','2013-12-25','13:50:00',1.08),('14598','2013-12-25','13:55:00',1.11),('14598','2013-12-25','15:00:00',1.39),('14598','2013-12-25','15:05:00',1.51),('14598','2013-12-25','15:10:00',1.03),('14598','2013-12-24','09:25:00',1.03),('14598','2013-12-24','09:30:00',1.11),('14598','2013-12-24','09:35:00',1.2),('14598','2013-12-24','09:40:00',1.28),('14598','2013-12-24','09:45:00',1.36),('14598','2013-12-24','09:50:00',1.44),('14598','2013-12-24','09:55:00',1.51),('14598','2013-12-24','10:00:00',1.58),('14598','2013-12-24','10:05:00',1.65),('14598','2013-12-24','10:10:00',1.71),('14598','2013-12-24','10:15:00',1.78),('14598','2013-12-24','10:20:00',1.85),('14598','2013-12-24','10:25:00',1.92),('14598','2013-12-24','10:30:00',1.98),('14598','2013-12-24','10:35:00',2.05),('14598','2013-12-24','10:40:00',2.11),('14598','2013-12-24','10:45:00',2.17),('14598','2013-12-24','10:50:00',2.22),('14598','2013-12-24','10:55:00',2.26),('14598','2013-12-24','11:00:00',2.31),('14598','2013-12-24','11:05:00',2.34),('14598','2013-12-24','11:10:00',2.39),('14598','2013-12-24','11:15:00',2.4),('14598','2013-12-24','11:20:00',2.47),('14598','2013-12-24','11:25:00',2.5),('14598','2013-12-24','11:30:00',2.54),('14598','2013-12-24','11:35:00',2.57),('14598','2013-12-24','11:40:00',2.58),('14598','2013-12-24','11:45:00',2.6),('14598','2013-12-24','11:50:00',2.62),('14598','2013-12-24','11:55:00',2.63),('14598','2013-12-24','12:00:00',2.65),('14598','2013-12-24','12:05:00',2.67),('14598','2013-12-24','12:10:00',2.67),('14598','2013-12-24','12:15:00',2.68),('14598','2013-12-24','12:20:00',2.69),('14598','2013-12-24','12:25:00',2.7),('14598','2013-12-24','12:30:00',2.67),('14598','2013-12-24','12:35:00',2.69),('14598','2013-12-24','12:40:00',2.67),('14598','2013-12-24','12:45:00',2.64),('14598','2013-12-24','12:50:00',2.63),('14598','2013-12-24','12:55:00',2.61),('14598','2013-12-24','13:00:00',2.58),('14598','2013-12-24','13:05:00',2.58),('14598','2013-12-24','13:10:00',2.56),('14598','2013-12-24','13:15:00',2.56),('14598','2013-12-24','13:20:00',2.51),('14598','2013-12-24','13:25:00',2.47),('14598','2013-12-24','13:30:00',2.46),('14598','2013-12-24','13:35:00',2.45),('14598','2013-12-24','13:40:00',2.42),('14598','2013-12-24','13:45:00',2.36),('14598','2013-12-24','13:50:00',2.32),('14598','2013-12-24','13:55:00',2.28),('14598','2013-12-24','14:00:00',2.21),('14598','2013-12-24','14:05:00',2.16),('14598','2013-12-24','14:10:00',2.13),('14598','2013-12-24','14:15:00',2.06),('14598','2013-12-24','14:20:00',2),('14598','2013-12-24','14:25:00',1.98),('14598','2013-12-24','14:30:00',1.92),('14598','2013-12-24','14:35:00',1.86),('14598','2013-12-24','14:40:00',1.8),('14598','2013-12-24','14:45:00',1.74),('14598','2013-12-24','14:50:00',1.67),('14598','2013-12-24','14:55:00',1.61),('14598','2013-12-24','15:00:00',1.55),('14598','2013-12-24','15:05:00',1.48),('14598','2013-12-24','15:10:00',1.41),('14598','2013-12-24','15:15:00',1.33),('14598','2013-12-24','15:20:00',1.26),('14598','2013-12-24','15:25:00',1.18),('14598','2013-12-24','15:30:00',1.09),('14598','2013-12-23','09:30:00',1.11),('14598','2013-12-23','09:35:00',1.19),('14598','2013-12-23','09:40:00',1.14),('14598','2013-12-23','10:00:00',1.09),('14598','2013-12-23','10:10:00',1.02),('14598','2013-12-23','10:15:00',1.03),('14598','2013-12-23','10:25:00',1.05),('14598','2013-12-23','10:30:00',1.39),('14598','2013-12-23','10:35:00',1.54),('14598','2013-12-23','10:40:00',2.21),('14598','2013-12-23','10:45:00',2.31),('14598','2013-12-23','10:50:00',2.22),('14598','2013-12-23','10:55:00',2.49),('14598','2013-12-23','11:00:00',2.44),('14598','2013-12-23','11:05:00',2.59),('14598','2013-12-23','11:10:00',2.57),('14598','2013-12-23','11:15:00',2.57),('14598','2013-12-23','11:20:00',2.55),('14598','2013-12-23','11:25:00',2.52),('14598','2013-12-23','11:30:00',2.5),('14598','2013-12-23','11:35:00',2.54),('14598','2013-12-23','11:40:00',2.45),('14598','2013-12-23','11:45:00',2.54),('14598','2013-12-23','11:50:00',2.66),('14598','2013-12-23','11:55:00',2.68),('14598','2013-12-23','12:00:00',2.73),('14598','2013-12-23','12:05:00',2.75),('14598','2013-12-23','12:10:00',2.74),('14598','2013-12-23','12:15:00',2.74),('14598','2013-12-23','12:20:00',2.75),('14598','2013-12-23','12:25:00',2.77),('14598','2013-12-23','12:30:00',2.77),('14598','2013-12-23','12:35:00',2.76),('14598','2013-12-23','12:40:00',2.77),('14598','2013-12-23','12:45:00',2.77),('14598','2013-12-23','12:50:00',2.77),('14598','2013-12-23','12:55:00',2.74),('14598','2013-12-23','13:00:00',2.6),('14598','2013-12-23','13:05:00',2.26),('14598','2013-12-23','13:10:00',2.58),('14598','2013-12-23','13:15:00',2.68),('14598','2013-12-23','13:20:00',2.66),('14598','2013-12-23','13:25:00',2.63),('14598','2013-12-23','13:30:00',2.6),('14598','2013-12-23','13:35:00',2.57),('14598','2013-12-23','13:40:00',2.54),('14598','2013-12-23','13:45:00',2.53),('14598','2013-12-23','13:50:00',2.26),('14598','2013-12-23','13:55:00',1.63),('14598','2013-12-23','14:00:00',1.85),('14598','2013-12-23','14:05:00',2.02),('14598','2013-12-23','14:10:00',2.28),('14598','2013-12-23','14:15:00',2.23),('14598','2013-12-23','14:20:00',2.14),('14598','2013-12-23','14:25:00',2.09),('14598','2013-12-23','14:30:00',1.8),('14598','2013-12-23','14:35:00',1.91),('14598','2013-12-23','14:40:00',1.9),('14598','2013-12-23','14:45:00',1.8),('14598','2013-12-23','14:50:00',1.72),('14598','2013-12-23','14:55:00',1.65),('14598','2013-12-23','15:00:00',1.55),('14598','2013-12-23','15:05:00',1.51),('14598','2013-12-23','15:10:00',1.43),('14598','2013-12-23','15:15:00',1.36),('14598','2013-12-23','15:20:00',1.28),('14598','2013-12-23','15:25:00',1.21),('14598','2013-12-23','15:30:00',1.11),('14598','2013-12-23','15:35:00',1.03),('14598','2013-12-22','09:20:00',1.01),('14598','2013-12-22','09:25:00',1.26),('14598','2013-12-22','09:30:00',1.57),('14598','2013-12-22','09:35:00',1.67),('14598','2013-12-22','09:40:00',1.82),('14598','2013-12-22','09:45:00',1.9),('14598','2013-12-22','09:50:00',1.88),('14598','2013-12-22','09:55:00',1.86),('14598','2013-12-22','10:00:00',1.91),('14598','2013-12-22','10:05:00',2.03),('14598','2013-12-22','10:10:00',2.09),('14598','2013-12-22','10:15:00',1.86),('14598','2013-12-22','10:20:00',1.98),('14598','2013-12-22','10:25:00',2.08),('14598','2013-12-22','10:30:00',1.94),('14598','2013-12-22','10:35:00',2.01),('14598','2013-12-22','10:40:00',1.88),('14598','2013-12-22','10:45:00',2.09),('14598','2013-12-22','10:50:00',2.25),('14598','2013-12-22','10:55:00',2.4),('14598','2013-12-22','11:00:00',2.54),('14598','2013-12-22','11:05:00',2.45),('14598','2013-12-22','11:10:00',2.55),('14598','2013-12-22','11:15:00',2.52),('14598','2013-12-22','11:20:00',2.32),('14598','2013-12-22','11:25:00',2.38),('14598','2013-12-22','11:30:00',2.45),('14598','2013-12-22','11:35:00',2.47),('14598','2013-12-22','11:40:00',2.64),('14598','2013-12-22','11:45:00',2.45),('14598','2013-12-22','11:50:00',1.94),('14598','2013-12-22','11:55:00',1.24),('14598','2013-12-22','12:05:00',1.03),('14598','2013-12-22','12:10:00',1.05),('14598','2013-12-22','12:15:00',1.11),('14598','2013-12-22','12:20:00',1.32),('14598','2013-12-22','12:25:00',1.42),('14598','2013-12-22','12:30:00',1.6),('14598','2013-12-22','12:35:00',2.03),('14598','2013-12-22','12:40:00',1.89),('14598','2013-12-22','12:45:00',1.74),('14598','2013-12-22','12:50:00',2.24),('14598','2013-12-22','12:55:00',2.86),('14598','2013-12-22','13:00:00',2.81),('14598','2013-12-22','13:05:00',2.91),('14598','2013-12-22','13:10:00',2.97),('14598','2013-12-22','13:15:00',2.89),('14598','2013-12-22','13:20:00',3.08),('14598','2013-12-22','13:25:00',2.94),('14598','2013-12-22','13:30:00',2.53),('14598','2013-12-22','13:35:00',2.53),('14598','2013-12-22','13:40:00',2.21),('14598','2013-12-22','13:45:00',1.66),('14598','2013-12-22','13:50:00',1.51),('14598','2013-12-22','13:55:00',1.61),('14598','2013-12-22','14:00:00',1.64),('14598','2013-12-22','14:05:00',1.39),('14598','2013-12-22','14:10:00',1.37),('14598','2013-12-22','14:15:00',1.19),('14598','2013-12-22','14:20:00',1.55),('14598','2013-12-22','14:25:00',1.35),('14598','2013-12-22','14:30:00',1.57),('14598','2013-12-22','14:35:00',1.84),('14598','2013-12-22','14:40:00',2.07),('14598','2013-12-22','14:45:00',1.7),('14598','2013-12-22','14:50:00',1.75),('14598','2013-12-22','14:55:00',1.41),('14598','2013-12-22','15:00:00',1.1),('14598','2013-12-22','15:05:00',1.23),('14598','2013-12-22','15:10:00',1.09),('14598','2013-12-21','09:25:00',1.05),('14598','2013-12-21','09:30:00',1.13),('14598','2013-12-21','09:35:00',1.21),('14598','2013-12-21','09:40:00',1.28),('14598','2013-12-21','09:45:00',1.37),('14598','2013-12-21','09:50:00',1.45),('14598','2013-12-21','09:55:00',1.53),('14598','2013-12-21','10:00:00',1.6),('14598','2013-12-21','10:05:00',1.68),('14598','2013-12-21','10:10:00',1.75),('14598','2013-12-21','10:15:00',1.82),('14598','2013-12-21','10:20:00',1.88),('14598','2013-12-21','10:25:00',1.94),('14598','2013-12-21','10:30:00',1.99),('14598','2013-12-21','10:35:00',2.04),('14598','2013-12-21','10:40:00',2.08),('14598','2013-12-21','10:45:00',2.12),('14598','2013-12-21','10:50:00',2.17),('14598','2013-12-21','10:55:00',2.21),('14598','2013-12-21','11:00:00',2.27),('14598','2013-12-21','11:05:00',2.31),('14598','2013-12-21','11:10:00',2.35),('14598','2013-12-21','11:15:00',2.39),('14598','2013-12-21','11:20:00',2.43),('14598','2013-12-21','11:25:00',2.45),('14598','2013-12-21','11:30:00',2.51),('14598','2013-12-21','11:35:00',2.54),('14598','2013-12-21','11:40:00',2.57),('14598','2013-12-21','11:45:00',2.59),('14598','2013-12-21','11:50:00',2.61),('14598','2013-12-21','11:55:00',2.63),('14598','2013-12-21','12:00:00',2.64),('14598','2013-12-21','12:05:00',2.66),('14598','2013-12-21','12:10:00',2.66),('14598','2013-12-21','12:15:00',2.65),('14598','2013-12-21','12:20:00',2.66),('14598','2013-12-21','12:25:00',2.66),('14598','2013-12-21','12:30:00',2.66),('14598','2013-12-21','12:35:00',2.68),('14598','2013-12-21','12:40:00',2.65),('14598','2013-12-21','12:45:00',2.64),('14598','2013-12-21','12:50:00',2.64),('14598','2013-12-21','12:55:00',2.62),('14598','2013-12-21','13:00:00',2.6),('14598','2013-12-21','13:05:00',2.6),('14598','2013-12-21','13:10:00',2.55),('14598','2013-12-21','13:15:00',2.55),('14598','2013-12-21','13:20:00',2.52),('14598','2013-12-21','13:25:00',2.5),('14598','2013-12-21','13:30:00',2.48),('14598','2013-12-21','13:35:00',2.45),('14598','2013-12-21','13:40:00',2.42),('14598','2013-12-21','13:45:00',2.37),('14598','2013-12-21','13:50:00',2.35),('14598','2013-12-21','13:55:00',2.34),('14598','2013-12-21','14:00:00',2.31),('14598','2013-12-21','14:05:00',2.29),('14598','2013-12-21','14:10:00',2.25),('14598','2013-12-21','14:15:00',2.19),('14598','2013-12-21','14:20:00',2.14),('14598','2013-12-21','14:25:00',2.08),('14598','2013-12-21','14:30:00',2.02),('14598','2013-12-21','14:35:00',1.96),('14598','2013-12-21','14:40:00',1.89),('14598','2013-12-21','14:45:00',1.82),('14598','2013-12-21','14:50:00',1.75),('14598','2013-12-21','14:55:00',1.68),('14598','2013-12-21','15:00:00',1.6),('14598','2013-12-21','15:05:00',1.53),('14598','2013-12-21','15:10:00',1.46),('14598','2013-12-21','15:15:00',1.38),('14598','2013-12-21','15:20:00',1.3),('14598','2013-12-21','15:25:00',1.23),('14598','2013-12-21','15:30:00',1.14),('14598','2013-12-21','15:35:00',1.03),('14598','2013-12-20','09:25:00',1.17),('14598','2013-12-20','09:30:00',1.21),('14598','2013-12-20','09:35:00',1.27),('14598','2013-12-20','09:40:00',1.34),('14598','2013-12-20','09:45:00',1.41),('14598','2013-12-20','09:50:00',1.47),('14598','2013-12-20','09:55:00',1.49),('14598','2013-12-20','10:00:00',1.54),('14598','2013-12-20','10:05:00',1.62),('14598','2013-12-20','10:10:00',1.69),('14598','2013-12-20','10:15:00',1.73),('14598','2013-12-20','10:20:00',1.78),('14598','2013-12-20','10:25:00',1.86),('14598','2013-12-20','10:30:00',1.87),('14598','2013-12-20','10:35:00',1.95),('14598','2013-12-20','10:40:00',2.01),('14598','2013-12-20','10:45:00',2.06),('14598','2013-12-20','10:50:00',2.09),('14598','2013-12-20','10:55:00',2.13),('14598','2013-12-20','11:00:00',2.19),('14598','2013-12-20','11:05:00',2.24),('14598','2013-12-20','11:10:00',2.24),('14598','2013-12-20','11:15:00',2.27),('14598','2013-12-20','11:20:00',2.34),('14598','2013-12-20','11:25:00',2.39),('14598','2013-12-20','11:30:00',2.41),('14598','2013-12-20','11:35:00',1.89),('14598','2013-12-20','11:40:00',2.59),('14598','2013-12-20','11:45:00',1.8),('14598','2013-12-20','11:50:00',1.24),('14598','2013-12-20','11:55:00',2.3),('14598','2013-12-20','12:00:00',2.59),('14598','2013-12-20','12:05:00',2.54),('14598','2013-12-20','12:10:00',2.51),('14598','2013-12-20','12:15:00',2.57),('14598','2013-12-20','12:20:00',2.58),('14598','2013-12-20','12:25:00',2.58),('14598','2013-12-20','12:30:00',2.51),('14598','2013-12-20','12:35:00',2.14),('14598','2013-12-20','12:40:00',2.34),('14598','2013-12-20','12:45:00',2.45),('14598','2013-12-20','12:50:00',2.31),('14598','2013-12-20','12:55:00',2.46),('14598','2013-12-20','13:00:00',2.14),('14598','2013-12-20','13:05:00',1.48),('14598','2013-12-20','13:10:00',1.01),('14598','2013-12-20','13:15:00',1.58),('14598','2013-12-20','13:20:00',1.62),('14598','2013-12-20','13:25:00',1.68),('14598','2013-12-20','13:30:00',1.88),('14598','2013-12-20','13:35:00',1.36),('14598','2013-12-20','14:40:00',1.3),('14598','2013-12-20','14:45:00',1.82),('14598','2013-12-20','14:50:00',1.91),('14598','2013-12-20','14:55:00',1.79),('14598','2013-12-20','15:00:00',1.88),('14598','2013-12-20','15:05:00',1.62),('14598','2013-12-20','15:10:00',1.07),('14598','2013-12-20','15:15:00',1.18),('14598','2013-12-20','15:20:00',1.19),('14598','2013-12-19','09:10:00',1.03),('14598','2013-12-19','09:15:00',1.11),('14598','2013-12-19','09:20:00',1.01),('14598','2013-12-19','09:30:00',1.17),('14598','2013-12-19','09:35:00',1.43),('14598','2013-12-19','09:45:00',1.11),('14598','2013-12-19','09:50:00',1.58),('14598','2013-12-19','09:55:00',1.44),('14598','2013-12-19','10:00:00',1.24),('14598','2013-12-19','10:05:00',1.16),('14598','2013-12-19','10:15:00',1.11),('14598','2013-12-19','10:20:00',2.03),('14598','2013-12-19','10:25:00',2.32),('14598','2013-12-19','10:30:00',2.44),('14598','2013-12-19','10:35:00',2.57),('14598','2013-12-19','10:40:00',2.84),('14598','2013-12-19','10:45:00',2.85),('14598','2013-12-19','10:50:00',2.38),('14598','2013-12-19','10:55:00',1.85),('14598','2013-12-19','11:00:00',1.4),('14598','2013-12-19','11:05:00',2.14),('14598','2013-12-19','11:10:00',1.67),('14598','2013-12-19','11:15:00',1.57),('14598','2013-12-19','11:20:00',1.39),('14598','2013-12-19','11:25:00',2.01),('14598','2013-12-19','11:30:00',1.18),('14598','2013-12-19','11:35:00',1.32),('14598','2013-12-19','11:40:00',1.18),('14598','2013-12-19','11:45:00',2.47),('14598','2013-12-19','11:50:00',2.79),('14598','2013-12-19','11:55:00',2.21),('14598','2013-12-19','12:00:00',1.82),('14598','2013-12-19','12:05:00',1.19),('14598','2013-12-19','12:10:00',1.73),('14598','2013-12-19','12:15:00',1.93),('14598','2013-12-19','12:20:00',2),('14598','2013-12-19','12:25:00',1.9),('14598','2013-12-19','12:30:00',2.04),('14598','2013-12-19','12:35:00',2.79),('14598','2013-12-19','12:40:00',2.49),('14598','2013-12-19','12:45:00',1.43),('14598','2013-12-19','12:50:00',1.74),('14598','2013-12-19','12:55:00',2.72),('14598','2013-12-19','13:00:00',2.96),('14598','2013-12-19','13:05:00',2.77),('14598','2013-12-19','13:10:00',2.62),('14598','2013-12-19','13:15:00',1.28),('14598','2013-12-19','13:20:00',1.12),('14598','2013-12-19','13:25:00',2.67),('14598','2013-12-19','13:30:00',1.58),('14598','2013-12-19','13:35:00',1.35),('14598','2013-12-19','13:40:00',1.13),('14598','2013-12-19','13:45:00',2.44),('14598','2013-12-19','13:50:00',1.67),('14598','2013-12-19','13:55:00',1.57),('14598','2013-12-19','14:00:00',2.24),('14598','2013-12-19','14:05:00',2.43),('14598','2013-12-19','14:10:00',2.22),('14598','2013-12-19','14:15:00',2.03),('14598','2013-12-19','14:20:00',2.05),('14598','2013-12-19','14:25:00',1.98),('14598','2013-12-19','14:30:00',1.91),('14598','2013-12-19','14:35:00',1.86),('14598','2013-12-19','14:40:00',1.8),('14598','2013-12-19','14:45:00',1.75),('14598','2013-12-19','14:50:00',1.67),('14598','2013-12-19','14:55:00',1.63),('14598','2013-12-19','15:00:00',1.53),('14598','2013-12-19','15:05:00',1.45),('14598','2013-12-19','15:10:00',1.39),('14598','2013-12-19','15:15:00',1.36),('14598','2013-12-19','15:20:00',1.28),('14598','2013-12-19','15:25:00',1.2),('14598','2013-12-19','15:30:00',1.18),('14598','2013-12-19','15:35:00',1.06),('14598','2013-12-18','09:20:00',1.04),('14598','2013-12-18','09:25:00',1.12),('14598','2013-12-18','09:30:00',1.2),('14598','2013-12-18','09:35:00',1.28),('14598','2013-12-18','09:40:00',1.37),('14598','2013-12-18','09:45:00',1.46),('14598','2013-12-18','09:50:00',1.54),('14598','2013-12-18','09:55:00',1.62),('14598','2013-12-18','10:00:00',1.68),('14598','2013-12-18','10:05:00',1.75),('14598','2013-12-18','10:10:00',1.82),('14598','2013-12-18','10:15:00',1.89),('14598','2013-12-18','10:20:00',1.93),('14598','2013-12-18','10:25:00',2),('14598','2013-12-18','10:30:00',2.08),('14598','2013-12-18','10:35:00',2.13),('14598','2013-12-18','10:40:00',2.19),('14598','2013-12-18','10:45:00',2.25),('14598','2013-12-18','10:50:00',2.29),('14598','2013-12-18','10:55:00',2.36),('14598','2013-12-18','11:00:00',2.42),('14598','2013-12-18','11:05:00',2.47),('14598','2013-12-18','11:10:00',2.5),('14598','2013-12-18','11:15:00',2.54),('14598','2013-12-18','11:20:00',2.58),('14598','2013-12-18','11:25:00',2.6),('14598','2013-12-18','11:30:00',2.63),('14598','2013-12-18','11:35:00',2.65),('14598','2013-12-18','11:40:00',2.62),('14598','2013-12-18','11:45:00',2.67),('14598','2013-12-18','11:50:00',2.68),('14598','2013-12-18','11:55:00',2.7),('14598','2013-12-18','12:00:00',2.74),('14598','2013-12-18','12:05:00',2.75),('14598','2013-12-18','12:10:00',2.73),('14598','2013-12-18','12:15:00',2.73),('14598','2013-12-18','12:20:00',2.74),('14598','2013-12-18','12:25:00',2.75),('14598','2013-12-18','12:30:00',2.72),('14598','2013-12-18','12:35:00',2.74),('14598','2013-12-18','12:40:00',2.74),('14598','2013-12-18','12:45:00',2.72),('14598','2013-12-18','12:50:00',2.72),('14598','2013-12-18','12:55:00',2.7),('14598','2013-12-18','13:00:00',2.68),('14598','2013-12-18','13:05:00',2.66),('14598','2013-12-18','13:10:00',2.62),('14598','2013-12-18','13:15:00',2.61),('14598','2013-12-18','13:20:00',2.57),('14598','2013-12-18','13:25:00',2.54),('14598','2013-12-18','13:30:00',2.52),('14598','2013-12-18','13:35:00',2.49),('14598','2013-12-18','13:40:00',2.47),('14598','2013-12-18','13:45:00',2.43),('14598','2013-12-18','13:50:00',2.41),('14598','2013-12-18','13:55:00',2.35),('14598','2013-12-18','14:00:00',2.31),('14598','2013-12-18','14:05:00',2.26),('14598','2013-12-18','14:10:00',2.22),('14598','2013-12-18','14:15:00',2.15),('14598','2013-12-18','14:20:00',2.1),('14598','2013-12-18','14:25:00',2.03),('14598','2013-12-18','14:30:00',1.96),('14598','2013-12-18','14:35:00',1.9),('14598','2013-12-18','14:40:00',1.79),('14598','2013-12-18','14:45:00',1.75),('14598','2013-12-18','14:50:00',1.67),('14598','2013-12-18','14:55:00',1.59),('14598','2013-12-18','15:00:00',1.55),('14598','2013-12-18','15:05:00',1.46),('14598','2013-12-18','15:10:00',1.41),('14598','2013-12-18','15:15:00',1.32),('14598','2013-12-18','15:20:00',1.26),('14598','2013-12-18','15:25:00',1.16),('14598','2013-12-18','15:30:00',1.07),('14598','2014-04-22','08:20:00',1.07),('14598','2014-04-22','08:25:00',1.12),('14598','2014-04-22','08:30:00',1.21),('14598','2014-04-22','08:35:00',1.36),('14598','2014-04-22','08:40:00',1.55),('14598','2014-04-22','08:45:00',1.39),('14598','2014-04-22','08:50:00',1.37),('14598','2014-04-22','08:55:00',1.76),('14598','2014-04-22','09:00:00',1.66),('14598','2014-04-22','09:05:00',1.85),('14598','2014-04-22','09:10:00',2.01),('14598','2014-04-22','09:15:00',2.27),('14598','2014-04-22','09:20:00',2.29),('14598','2014-04-22','09:25:00',2.22),('14598','2014-04-22','09:30:00',2.6),('14598','2014-04-22','09:35:00',2.02),('14598','2014-04-22','09:40:00',2.98),('14598','2014-04-22','09:45:00',2),('14598','2014-04-22','09:50:00',2.42),('14598','2014-04-22','09:55:00',2.05),('14598','2014-04-22','10:00:00',1.67),('14598','2014-04-22','10:05:00',1.8),('14598','2014-04-22','10:10:00',1.75),('14598','2014-04-22','10:15:00',1.47),('14598','2014-04-22','10:20:00',1.75),('14598','2014-04-22','10:25:00',2),('14598','2014-04-22','10:30:00',2.37),('14598','2014-04-22','10:35:00',2.69),('14598','2014-04-22','10:40:00',2.35),('14598','2014-04-22','10:45:00',3.06),('14598','2014-04-22','10:50:00',3.47),('14598','2014-04-22','10:55:00',3.58),('14598','2014-04-22','11:00:00',3.06),('14598','2014-04-22','11:05:00',2.31),('14598','2014-04-22','11:10:00',2.27),('14598','2014-04-22','11:15:00',2.01),('14598','2014-04-22','11:20:00',1.97),('14598','2014-04-22','11:25:00',1.83),('14598','2014-04-22','11:30:00',1.48),('14598','2014-04-22','11:35:00',1.42),('14598','2014-04-22','11:40:00',1.68),('14598','2014-04-22','11:45:00',2.16),('14598','2014-04-22','11:50:00',1.71),('14598','2014-04-22','11:55:00',1.7),('14598','2014-04-22','12:00:00',1.96),('14598','2014-04-22','12:05:00',2.28),('14598','2014-04-22','12:10:00',1.99),('14598','2014-04-22','12:15:00',1.82),('14598','2014-04-22','12:20:00',1.44),('14598','2014-04-22','12:25:00',1.46),('14598','2014-04-22','12:30:00',1.69),('14598','2014-04-22','12:35:00',1.56),('14598','2014-04-22','12:40:00',1.36),('14598','2014-04-22','12:45:00',1.43),('14598','2014-04-22','12:50:00',1.29),('14598','2014-04-22','12:55:00',1.27),('14598','2014-04-22','13:00:00',1.21),('14598','2014-04-22','13:05:00',1.31),('14598','2014-04-22','13:10:00',1.34),('14598','2014-04-22','13:15:00',1.5),('14598','2014-04-22','13:20:00',1.54),('14598','2014-04-22','13:25:00',1.54),('14598','2014-04-22','13:30:00',2.16),('14598','2014-04-22','13:35:00',3.47),('14598','2014-04-22','13:40:00',3.77),('14598','2014-04-22','13:45:00',2.65),('14598','2014-04-22','13:50:00',3.06),('14598','2014-04-22','13:55:00',3.41),('14598','2014-04-22','14:00:00',2.55),('14598','2014-04-22','14:05:00',1.75),('14598','2014-04-22','14:10:00',2.13),('14598','2014-04-22','14:15:00',2.06),('14598','2014-04-22','14:20:00',1.82),('14598','2014-04-22','14:25:00',1.92),('14598','2014-04-22','14:30:00',2.05),('14598','2014-04-22','14:35:00',3.33),('14598','2014-04-22','14:40:00',3.1),('14598','2014-04-22','14:45:00',2.47),('14598','2014-04-22','14:50:00',2.81),('14598','2014-04-22','14:55:00',2.25),('14598','2014-04-22','15:00:00',3.59),('14598','2014-04-22','15:05:00',3.06),('14598','2014-04-22','15:10:00',2.28),('14598','2014-04-22','15:15:00',2.85),('14598','2014-04-22','15:20:00',4.41),('14598','2014-04-22','15:25:00',2.91),('14598','2014-04-22','15:30:00',3.67),('14598','2014-04-22','15:35:00',3.89),('14598','2014-04-22','15:40:00',3.22),('14598','2014-04-22','15:45:00',3.26),('14598','2014-04-22','15:50:00',2.48),('14598','2014-04-22','15:55:00',1.61),('14598','2014-04-22','16:00:00',1.54),('14598','2014-04-22','16:05:00',1.56),('14598','2014-04-22','16:10:00',1.57),('14598','2014-04-22','16:15:00',1.52),('14598','2014-04-22','16:20:00',1.44),('14598','2014-04-22','16:25:00',2.11),('14598','2014-04-22','16:30:00',2.45),('14598','2014-04-22','16:35:00',2.05),('14598','2014-04-22','16:40:00',1.67),('14598','2014-04-22','16:45:00',1.51),('14598','2014-04-22','16:50:00',1.3),('14598','2014-04-22','16:55:00',1.21),('14598','2014-04-22','17:05:00',1.05),('14598','2014-04-22','17:10:00',1.83),('14598','2014-04-22','17:15:00',1.99),('14598','2014-04-22','17:20:00',1.41),('14598','2014-04-22','17:25:00',1.07),('14598','2013-12-17','09:15:00',1.02),('14598','2013-12-17','09:20:00',1.11),('14598','2013-12-17','09:25:00',1.2),('14598','2013-12-17','09:30:00',1.29),('14598','2013-12-17','09:35:00',1.37),('14598','2013-12-17','09:40:00',1.46),('14598','2013-12-17','09:45:00',1.53),('14598','2013-12-17','09:50:00',1.61),('14598','2013-12-17','09:55:00',1.69),('14598','2013-12-17','10:00:00',1.76),('14598','2013-12-17','10:05:00',1.83),('14598','2013-12-17','10:10:00',1.91),('14598','2013-12-17','10:15:00',1.98),('14598','2013-12-17','10:20:00',2.05),('14598','2013-12-17','10:25:00',2.11),('14598','2013-12-17','10:30:00',2.17),('14598','2013-12-17','10:35:00',2.23),('14598','2013-12-17','10:40:00',2.29),('14598','2013-12-17','10:45:00',2.34),('14598','2013-12-17','10:50:00',2.38),('14598','2013-12-17','10:55:00',2.43),('14598','2013-12-17','11:00:00',2.48),('14598','2013-12-17','11:05:00',2.53),('14598','2013-12-17','11:10:00',2.56),('14598','2013-12-17','11:15:00',2.6),('14598','2013-12-17','11:20:00',2.63),('14598','2013-12-17','11:25:00',2.67),('14598','2013-12-17','11:30:00',2.69),('14598','2013-12-17','11:35:00',2.74),('14598','2013-12-17','11:40:00',2.77),('14598','2013-12-17','11:45:00',2.8),('14598','2013-12-17','11:50:00',2.83),('14598','2013-12-17','11:55:00',2.86),('14598','2013-12-17','12:00:00',2.87),('14598','2013-12-17','12:05:00',2.88),('14598','2013-12-17','12:10:00',2.88),('14598','2013-12-17','12:15:00',2.9),('14598','2013-12-17','12:20:00',2.9),('14598','2013-12-17','12:25:00',2.89),('14598','2013-12-17','12:30:00',2.89),('14598','2013-12-17','12:35:00',2.89),('14598','2013-12-17','12:40:00',2.86),('14598','2013-12-17','12:45:00',2.88),('14598','2013-12-17','12:50:00',2.87),('14598','2013-12-17','12:55:00',2.86),('14598','2013-12-17','13:00:00',2.84),('14598','2013-12-17','13:05:00',2.83),('14598','2013-12-17','13:10:00',2.81),('14598','2013-12-17','13:15:00',2.78),('14598','2013-12-17','13:20:00',2.75),('14598','2013-12-17','13:25:00',2.72),('14598','2013-12-17','13:30:00',2.69),('14598','2013-12-17','13:35:00',2.65),('14598','2013-12-17','13:40:00',2.63),('14598','2013-12-17','13:45:00',2.6),('14598','2013-12-17','13:50:00',2.56),('14598','2013-12-17','13:55:00',2.49),('14598','2013-12-17','14:00:00',2.49),('14598','2013-12-17','14:05:00',2.44),('14598','2013-12-17','14:10:00',2.39),('14598','2013-12-17','14:15:00',2.35),('14598','2013-12-17','14:20:00',2.29),('14598','2013-12-17','14:25:00',2.21),('14598','2013-12-17','14:30:00',2.14),('14598','2013-12-17','14:35:00',2.09),('14598','2013-12-17','14:40:00',2.03),('14598','2013-12-17','14:45:00',1.97),('14598','2013-12-17','14:50:00',1.9),('14598','2013-12-17','14:55:00',1.83),('14598','2013-12-17','15:00:00',1.75),('14598','2013-12-17','15:05:00',1.66),('14598','2013-12-17','15:10:00',1.57),('14598','2013-12-17','15:15:00',1.5),('14598','2013-12-17','15:20:00',1.42),('14598','2013-12-17','15:25:00',1.33),('14598','2013-12-17','15:30:00',1.24),('14598','2013-12-17','15:35:00',1.13),('14598','2013-12-17','15:40:00',1.04),('14598','2013-12-16','09:20:00',1.06),('14598','2013-12-16','09:25:00',1.15),('14598','2013-12-16','09:30:00',1.23),('14598','2013-12-16','09:35:00',1.31),('14598','2013-12-16','09:40:00',1.41),('14598','2013-12-16','09:45:00',1.5),('14598','2013-12-16','09:50:00',1.58),('14598','2013-12-16','09:55:00',1.66),('14598','2013-12-16','10:00:00',1.73),('14598','2013-12-16','10:05:00',1.78),('14598','2013-12-16','10:10:00',1.87),('14598','2013-12-16','10:15:00',1.94),('14598','2013-12-16','10:20:00',2),('14598','2013-12-16','10:25:00',2.07),('14598','2013-12-16','10:30:00',2.13),('14598','2013-12-16','10:35:00',2.19),('14598','2013-12-16','10:40:00',2.24),('14598','2013-12-16','10:45:00',2.3),('14598','2013-12-16','10:50:00',2.34),('14598','2013-12-16','10:55:00',2.37),('14598','2013-12-16','11:00:00',1.92),('14598','2013-12-16','11:05:00',2.45),('14598','2013-12-16','11:10:00',2.48),('14598','2013-12-16','11:15:00',2.54),('14598','2013-12-16','11:20:00',2.56),('14598','2013-12-16','11:25:00',2.6),('14598','2013-12-16','11:30:00',2.65),('14598','2013-12-16','11:35:00',2.67),('14598','2013-12-16','11:40:00',2.72),('14598','2013-12-16','11:45:00',2.74),('14598','2013-12-16','11:50:00',2.75),('14598','2013-12-16','11:55:00',2.79),('14598','2013-12-16','12:00:00',2.8),('14598','2013-12-16','12:05:00',2.81),('14598','2013-12-16','12:10:00',2.82),('14598','2013-12-16','12:15:00',2.83),('14598','2013-12-16','12:20:00',2.83),('14598','2013-12-16','12:25:00',2.83),('14598','2013-12-16','12:30:00',2.84),('14598','2013-12-16','12:35:00',2.83),('14598','2013-12-16','12:40:00',2.76),('14598','2013-12-16','12:45:00',2.77),('14598','2013-12-16','12:50:00',2.8),('14598','2013-12-16','12:55:00',2.78),('14598','2013-12-16','13:00:00',2.76),('14598','2013-12-16','13:05:00',2.76),('14598','2013-12-16','13:10:00',2.73),('14598','2013-12-16','13:15:00',2.73),('14598','2013-12-16','13:20:00',2.72),('14598','2013-12-16','13:25:00',2.7),('14598','2013-12-16','13:30:00',2.68),('14598','2013-12-16','13:35:00',2.64),('14598','2013-12-16','13:40:00',2.62),('14598','2013-12-16','13:45:00',2.58),('14598','2013-12-16','13:50:00',2.55),('14598','2013-12-16','13:55:00',2.52),('14598','2013-12-16','14:00:00',2.47),('14598','2013-12-16','14:05:00',2.43),('14598','2013-12-16','14:10:00',2.37),('14598','2013-12-16','14:15:00',2.3),('14598','2013-12-16','14:20:00',2.26),('14598','2013-12-16','14:25:00',2.2),('14598','2013-12-16','14:30:00',2.15),('14598','2013-12-16','14:35:00',2.08),('14598','2013-12-16','14:40:00',2),('14598','2013-12-16','14:45:00',1.94),('14598','2013-12-16','14:50:00',1.87),('14598','2013-12-16','14:55:00',1.79),('14598','2013-12-16','15:00:00',1.72),('14598','2013-12-16','15:05:00',1.63),('14598','2013-12-16','15:10:00',1.55),('14598','2013-12-16','15:15:00',1.47),('14598','2013-12-16','15:20:00',1.39),('14598','2013-12-16','15:25:00',1.3),('14598','2013-12-16','15:30:00',1.2),('14598','2013-12-16','15:35:00',1.1),('14598','2013-12-16','15:40:00',1),('14598','2013-12-15','09:50:00',1.19),('14598','2013-12-15','09:55:00',1.12),('14598','2013-12-15','10:00:00',1.06),('14598','2013-12-15','10:05:00',1.08),('14598','2013-12-15','10:10:00',1.07),('14598','2013-12-15','10:50:00',1.24),('14598','2013-12-15','10:55:00',1.74),('14598','2013-12-15','11:00:00',1.35),('14598','2013-12-15','11:05:00',1.48),('14598','2013-12-15','11:10:00',1.44),('14598','2013-12-15','11:15:00',1.71),('14598','2013-12-15','11:20:00',1.49),('14598','2013-12-15','11:25:00',1.32),('14598','2013-12-15','11:30:00',1.13),('14598','2013-12-15','11:35:00',1.15),('14598','2013-12-15','11:40:00',1.14),('14598','2013-12-14','09:20:00',1.03),('14598','2013-12-14','09:25:00',1.12),('14598','2013-12-14','09:30:00',1.19),('14598','2013-12-14','09:35:00',1.29),('14598','2013-12-14','09:40:00',1.37),('14598','2013-12-14','09:45:00',1.44),('14598','2013-12-14','09:50:00',1.49),('14598','2013-12-14','09:55:00',1.59),('14598','2013-12-14','10:00:00',1.66),('14598','2013-12-14','10:05:00',1.74),('14598','2013-12-14','10:10:00',1.8),('14598','2013-12-14','10:15:00',1.87),('14598','2013-12-14','10:20:00',1.94),('14598','2013-12-14','10:25:00',1.8),('14598','2013-12-14','10:30:00',1.78),('14598','2013-12-14','10:35:00',2.1),('14598','2013-12-14','10:40:00',2.16),('14598','2013-12-14','10:45:00',2.22),('14598','2013-12-14','10:50:00',2.28),('14598','2013-12-14','10:55:00',1.5),('14598','2013-12-14','11:00:00',1.89),('14598','2013-12-14','11:05:00',2.41),('14598','2013-12-14','11:10:00',2.45),('14598','2013-12-14','11:15:00',2.48),('14598','2013-12-14','11:20:00',2.52),('14598','2013-12-14','11:25:00',2.56),('14598','2013-12-14','11:30:00',2.58),('14598','2013-12-14','11:35:00',2.6),('14598','2013-12-14','11:40:00',2.63),('14598','2013-12-14','11:45:00',2.65),('14598','2013-12-14','11:50:00',2.68),('14598','2013-12-14','11:55:00',2.68),('14598','2013-12-14','12:00:00',2.7),('14598','2013-12-14','12:05:00',2.7),('14598','2013-12-14','12:10:00',2.72),('14598','2013-12-14','12:15:00',2.71),('14598','2013-12-14','12:20:00',2.7),('14598','2013-12-14','12:25:00',2.72),('14598','2013-12-14','12:30:00',2.73),('14598','2013-12-14','12:35:00',2.7),('14598','2013-12-14','12:40:00',2.71),('14598','2013-12-14','12:45:00',2.68),('14598','2013-12-14','12:50:00',2.61),('14598','2013-12-14','12:55:00',2.61),('14598','2013-12-14','13:00:00',2.6),('14598','2013-12-14','13:05:00',2.59),('14598','2013-12-14','13:10:00',2.6),('14598','2013-12-14','13:15:00',2.6),('14598','2013-12-14','13:20:00',2.59),('14598','2013-12-14','13:25:00',2.58),('14598','2013-12-14','13:30:00',2.58),('14598','2013-12-14','13:35:00',2.54),('14598','2013-12-14','13:40:00',2.5),('14598','2013-12-14','13:45:00',2.47),('14598','2013-12-14','13:50:00',2.4),('14598','2013-12-14','13:55:00',2.36),('14598','2013-12-14','14:00:00',2.32),('14598','2013-12-14','14:05:00',2.27),('14598','2013-12-14','14:10:00',2.22),('14598','2013-12-14','14:15:00',2.18),('14598','2013-12-14','14:20:00',2.12),('14598','2013-12-14','14:25:00',2.07),('14598','2013-12-14','14:30:00',1.99),('14598','2013-12-14','14:35:00',1.93),('14598','2013-12-14','14:40:00',1.87),('14598','2013-12-14','14:45:00',1.8),('14598','2013-12-14','14:50:00',1.73),('14598','2013-12-14','14:55:00',1.66),('14598','2013-12-14','15:00:00',1.59),('14598','2013-12-14','15:05:00',1.53),('14598','2013-12-14','15:10:00',1.46),('14598','2013-12-14','15:15:00',1.38),('14598','2013-12-14','15:20:00',1.29),('14598','2013-12-14','15:25:00',1.19),('14598','2013-12-14','15:30:00',1.09),('14598','2013-12-13','09:20:00',1.02),('14598','2013-12-13','09:25:00',1.11),('14598','2013-12-13','09:30:00',1.21),('14598','2013-12-13','09:35:00',1.21),('14598','2013-12-13','09:40:00',1.29),('14598','2013-12-13','09:45:00',1.38),('14598','2013-12-13','09:50:00',1.47),('14598','2013-12-13','09:55:00',1.54),('14598','2013-12-13','10:00:00',1.62),('14598','2013-12-13','10:05:00',1.65),('14598','2013-12-13','10:10:00',1.67),('14598','2013-12-13','10:15:00',1.79),('14598','2013-12-13','10:20:00',1.85),('14598','2013-12-13','10:25:00',1.91),('14598','2013-12-13','10:30:00',1.96),('14598','2013-12-13','10:35:00',2.04),('14598','2013-12-13','10:40:00',2.09),('14598','2013-12-13','10:45:00',2.14),('14598','2013-12-13','10:50:00',2.19),('14598','2013-12-13','10:55:00',2.24),('14598','2013-12-13','11:00:00',2.28),('14598','2013-12-13','11:05:00',2.33),('14598','2013-12-13','11:10:00',2.37),('14598','2013-12-13','11:15:00',2.41),('14598','2013-12-13','11:20:00',2.37),('14598','2013-12-13','11:25:00',2.45),('14598','2013-12-13','11:30:00',2.47),('14598','2013-12-13','11:35:00',2.53),('14598','2013-12-13','11:40:00',2.51),('14598','2013-12-13','11:45:00',2.55),('14598','2013-12-13','11:50:00',2.38),('14598','2013-12-13','11:55:00',2.58),('14598','2013-12-13','12:00:00',2.59),('14598','2013-12-13','12:05:00',2.62),('14598','2013-12-13','12:10:00',2.6),('14598','2013-12-13','12:15:00',2.59),('14598','2013-12-13','12:20:00',2.56),('14598','2013-12-13','12:25:00',2.62),('14598','2013-12-13','12:30:00',2.61),('14598','2013-12-13','12:35:00',2.56),('14598','2013-12-13','12:40:00',2.53),('14598','2013-12-13','12:45:00',2.55),('14598','2013-12-13','12:50:00',2.59),('14598','2013-12-13','12:55:00',2.52),('14598','2013-12-13','13:00:00',2.6),('14598','2013-12-13','13:05:00',2.66),('14598','2013-12-13','13:10:00',2.66),('14598','2013-12-13','13:15:00',2.57),('14598','2013-12-13','13:20:00',2.59),('14598','2013-12-13','13:25:00',2.58),('14598','2013-12-13','13:30:00',2.58),('14598','2013-12-13','13:35:00',2.54),('14598','2013-12-13','13:40:00',2.51),('14598','2013-12-13','13:45:00',2.49),('14598','2013-12-13','13:50:00',2.43),('14598','2013-12-13','13:55:00',2.39),('14598','2013-12-13','14:00:00',2.32),('14598','2013-12-13','14:05:00',2.29),('14598','2013-12-13','14:10:00',2.21),('14598','2013-12-13','14:15:00',2.15),('14598','2013-12-13','14:20:00',2.1),('14598','2013-12-13','14:25:00',2.06),('14598','2013-12-13','14:30:00',1.97),('14598','2013-12-13','14:35:00',1.93),('14598','2013-12-13','14:40:00',1.86),('14598','2013-12-13','14:45:00',1.78),('14598','2013-12-13','14:50:00',1.7),('14598','2013-12-13','14:55:00',1.63),('14598','2013-12-13','15:00:00',1.57),('14598','2013-12-13','15:05:00',1.5),('14598','2013-12-13','15:10:00',1.41),('14598','2013-12-13','15:15:00',1.3),('14598','2013-12-13','15:20:00',1.22),('14598','2013-12-13','15:25:00',1.12),('14598','2013-12-13','15:30:00',1.08),('14598','2013-12-13','15:35:00',1),('14598','2013-12-12','09:20:00',1.08),('14598','2013-12-12','09:25:00',1.16),('14598','2013-12-12','09:30:00',1.25),('14598','2013-12-12','09:35:00',1.05),('14598','2013-12-12','09:40:00',1.39),('14598','2013-12-12','09:45:00',1.47),('14598','2013-12-12','09:50:00',1.54),('14598','2013-12-12','09:55:00',1.61),('14598','2013-12-12','10:00:00',1.69),('14598','2013-12-12','10:05:00',1.76),('14598','2013-12-12','10:10:00',1.83),('14598','2013-12-12','10:15:00',1.9),('14598','2013-12-12','10:20:00',1.96),('14598','2013-12-12','10:25:00',2.01),('14598','2013-12-12','10:30:00',2.07),('14598','2013-12-12','10:35:00',2.12),('14598','2013-12-12','10:40:00',2.16),('14598','2013-12-12','10:45:00',2.21),('14598','2013-12-12','10:50:00',2.27),('14598','2013-12-12','10:55:00',2.32),('14598','2013-12-12','11:00:00',2.36),('14598','2013-12-12','11:05:00',2.39),('14598','2013-12-12','11:10:00',2.44),('14598','2013-12-12','11:15:00',2.47),('14598','2013-12-12','11:20:00',2.51),('14598','2013-12-12','11:25:00',2.55),('14598','2013-12-12','11:30:00',2.58),('14598','2013-12-12','11:35:00',2.61),('14598','2013-12-12','11:40:00',2.62),('14598','2013-12-12','11:45:00',2.64),('14598','2013-12-12','11:50:00',2.66),('14598','2013-12-12','11:55:00',2.68),('14598','2013-12-12','12:00:00',2.69),('14598','2013-12-12','12:05:00',2.71),('14598','2013-12-12','12:10:00',2.72),('14598','2013-12-12','12:15:00',2.72),('14598','2013-12-12','12:20:00',2.72),('14598','2013-12-12','12:25:00',2.72),('14598','2013-12-12','12:30:00',2.72),('14598','2013-12-12','12:35:00',2.7),('14598','2013-12-12','12:40:00',2.71),('14598','2013-12-12','12:45:00',2.7),('14598','2013-12-12','12:50:00',2.69),('14598','2013-12-12','12:55:00',2.65),('14598','2013-12-12','13:00:00',2.66),('14598','2013-12-12','13:05:00',2.63),('14598','2013-12-12','13:10:00',2.61),('14598','2013-12-12','13:15:00',2.58),('14598','2013-12-12','13:20:00',2.54),('14598','2013-12-12','13:25:00',2.49),('14598','2013-12-12','13:30:00',2.47),('14598','2013-12-12','13:35:00',2.42),('14598','2013-12-12','13:40:00',2.41),('14598','2013-12-12','13:45:00',2.37),('14598','2013-12-12','13:50:00',2.31),('14598','2013-12-12','13:55:00',2.29),('14598','2013-12-12','14:00:00',2.24),('14598','2013-12-12','14:05:00',2.2),('14598','2013-12-12','14:10:00',2.15),('14598','2013-12-12','14:15:00',2.11),('14598','2013-12-12','14:20:00',2.05),('14598','2013-12-12','14:25:00',1.98),('14598','2013-12-12','14:30:00',1.94),('14598','2013-12-12','14:35:00',1.87),('14598','2013-12-12','14:40:00',1.81),('14598','2013-12-12','14:45:00',1.73),('14598','2013-12-12','14:50:00',1.67),('14598','2013-12-12','14:55:00',1.59),('14598','2013-12-12','15:00:00',1.52),('14598','2013-12-12','15:05:00',1.47),('14598','2013-12-12','15:10:00',1.4),('14598','2013-12-12','15:15:00',1.31),('14598','2013-12-12','15:20:00',1.23),('14598','2013-12-12','15:25:00',1.16),('14598','2013-12-12','15:30:00',1.08),('14598','2013-12-11','09:15:00',1.02),('14598','2013-12-11','09:20:00',1.09),('14598','2013-12-11','09:25:00',1.19),('14598','2013-12-11','09:30:00',1.26),('14598','2013-12-11','09:35:00',1.34),('14598','2013-12-11','09:40:00',1.43),('14598','2013-12-11','09:45:00',1.51),('14598','2013-12-11','09:50:00',1.58),('14598','2013-12-11','09:55:00',1.66),('14598','2013-12-11','10:00:00',1.73),('14598','2013-12-11','10:05:00',1.8),('14598','2013-12-11','10:10:00',1.86),('14598','2013-12-11','10:15:00',1.92),('14598','2013-12-11','10:20:00',1.98),('14598','2013-12-11','10:25:00',2.04),('14598','2013-12-11','10:30:00',2.11),('14598','2013-12-11','10:35:00',2.17),('14598','2013-12-11','10:40:00',2.22),('14598','2013-12-11','10:45:00',2.27),('14598','2013-12-11','10:50:00',2.31),('14598','2013-12-11','10:55:00',2.36),('14598','2013-12-11','11:00:00',2.42),('14598','2013-12-11','11:05:00',2.43),('14598','2013-12-11','11:10:00',2.5),('14598','2013-12-11','11:15:00',2.53),('14598','2013-12-11','11:20:00',2.54),('14598','2013-12-11','11:25:00',2.55),('14598','2013-12-11','11:30:00',2.57),('14598','2013-12-11','11:35:00',2.58),('14598','2013-12-11','11:40:00',2.62),('14598','2013-12-11','11:45:00',2.64),('14598','2013-12-11','11:50:00',2.68),('14598','2013-12-11','11:55:00',2.69),('14598','2013-12-11','12:00:00',2.72),('14598','2013-12-11','12:05:00',2.74),('14598','2013-12-11','12:10:00',2.77),('14598','2013-12-11','12:15:00',2.75),('14598','2013-12-11','12:20:00',2.71),('14598','2013-12-11','12:25:00',2.69),('14598','2013-12-11','12:30:00',2.74),('14598','2013-12-11','12:35:00',2.72),('14598','2013-12-11','12:40:00',2.71),('14598','2013-12-11','12:45:00',2.7),('14598','2013-12-11','12:50:00',2.66),('14598','2013-12-11','12:55:00',2.69),('14598','2013-12-11','13:00:00',2.65),('14598','2013-12-11','13:05:00',2.61),('14598','2013-12-11','13:10:00',2.59),('14598','2013-12-11','13:15:00',2.57),('14598','2013-12-11','13:20:00',2.54),('14598','2013-12-11','13:25:00',2.49),('14598','2013-12-11','13:30:00',2.42),('14598','2013-12-11','13:35:00',2.39),('14598','2013-12-11','13:40:00',2.38),('14598','2013-12-11','13:45:00',2.35),('14598','2013-12-11','13:50:00',2.34),('14598','2013-12-11','13:55:00',2.3),('14598','2013-12-11','14:00:00',2.32),('14598','2013-12-11','14:05:00',2.29),('14598','2013-12-11','14:10:00',2.23),('14598','2013-12-11','14:15:00',2.19),('14598','2013-12-11','14:20:00',2.14),('14598','2013-12-11','14:25:00',2.08),('14598','2013-12-11','14:30:00',1.99),('14598','2013-12-11','14:35:00',1.93),('14598','2013-12-11','14:40:00',1.86),('14598','2013-12-11','14:45:00',1.78),('14598','2013-12-11','14:50:00',1.71),('14598','2013-12-11','14:55:00',1.63),('14598','2013-12-11','15:00:00',1.54),('14598','2013-12-11','15:05:00',1.46),('14598','2013-12-11','15:10:00',1.4),('14598','2013-12-11','15:15:00',1.32),('14598','2013-12-11','15:20:00',1.23),('14598','2013-12-11','15:25:00',1.16),('14598','2013-12-11','15:30:00',1.06),('14598','2013-12-10','09:15:00',1.04),('14598','2013-12-10','09:20:00',1.13),('14598','2013-12-10','09:25:00',1.21),('14598','2013-12-10','09:30:00',1.3),('14598','2013-12-10','09:35:00',1.38),('14598','2013-12-10','09:40:00',1.46),('14598','2013-12-10','09:45:00',1.54),('14598','2013-12-10','09:50:00',1.61),('14598','2013-12-10','09:55:00',1.68),('14598','2013-12-10','10:00:00',1.76),('14598','2013-12-10','10:05:00',1.84),('14598','2013-12-10','10:10:00',1.91),('14598','2013-12-10','10:15:00',1.97),('14598','2013-12-10','10:20:00',2.04),('14598','2013-12-10','10:25:00',2.1),('14598','2013-12-10','10:30:00',2.16),('14598','2013-12-10','10:35:00',2.21),('14598','2013-12-10','10:40:00',2.26),('14598','2013-12-10','10:45:00',2.3),('14598','2013-12-10','10:50:00',2.34),('14598','2013-12-10','10:55:00',2.39),('14598','2013-12-10','11:00:00',2.44),('14598','2013-12-10','11:05:00',2.48),('14598','2013-12-10','11:10:00',2.52),('14598','2013-12-10','11:15:00',2.57),('14598','2013-12-10','11:20:00',1.95),('14598','2013-12-10','11:25:00',2.64),('14598','2013-12-10','11:30:00',2.67),('14598','2013-12-10','11:35:00',2.71),('14598','2013-12-10','11:40:00',2.73),('14598','2013-12-10','11:45:00',2.75),('14598','2013-12-10','11:50:00',2.77),('14598','2013-12-10','11:55:00',2.78),('14598','2013-12-10','12:00:00',2.8),('14598','2013-12-10','12:05:00',2.79),('14598','2013-12-10','12:10:00',2.8),('14598','2013-12-10','12:15:00',2.8),('14598','2013-12-10','12:20:00',2.81),('14598','2013-12-10','12:25:00',2.81),('14598','2013-12-10','12:30:00',2.82),('14598','2013-12-10','12:35:00',2.83),('14598','2013-12-10','12:40:00',2.82),('14598','2013-12-10','12:45:00',2.82),('14598','2013-12-10','12:50:00',2.81),('14598','2013-12-10','12:55:00',2.8),('14598','2013-12-10','13:00:00',2.77),('14598','2013-12-10','13:05:00',2.74),('14598','2013-12-10','13:10:00',2.72),('14598','2013-12-10','13:15:00',2.69),('14598','2013-12-10','13:20:00',2.66),('14598','2013-12-10','13:25:00',2.63),('14598','2013-12-10','13:30:00',2.6),('14598','2013-12-10','13:35:00',2.56),('14598','2013-12-10','13:40:00',2.51),('14598','2013-12-10','13:45:00',2.48),('14598','2013-12-10','13:50:00',2.44),('14598','2013-12-10','13:55:00',2.41),('14598','2013-12-10','14:00:00',2.33),('14598','2013-12-10','14:05:00',2.26),('14598','2013-12-10','14:10:00',2.22),('14598','2013-12-10','14:15:00',2.18),('14598','2013-12-10','14:20:00',2.13),('14598','2013-12-10','14:25:00',2.07),('14598','2013-12-10','14:30:00',2.01),('14598','2013-12-10','14:35:00',1.97),('14598','2013-12-10','14:40:00',1.92),('14598','2013-12-10','14:45:00',1.83),('14598','2013-12-10','14:50:00',1.7),('14598','2013-12-10','14:55:00',1.58),('14598','2013-12-10','15:00:00',1.6),('14598','2013-12-10','15:05:00',1.48),('14598','2013-12-10','15:10:00',1.42),('14598','2013-12-10','15:15:00',1.33),('14598','2013-12-10','15:20:00',1.25),('14598','2013-12-10','15:25:00',1.15),('14598','2013-12-10','15:30:00',1.04),('14598','2013-12-09','09:00:00',1.23),('14598','2013-12-09','09:05:00',1.26),('14598','2013-12-09','09:25:00',1.2),('14598','2013-12-09','11:40:00',1.05),('14598','2013-12-09','11:50:00',2.28),('14598','2013-12-09','12:10:00',1.23),('14598','2013-12-09','12:15:00',1.69),('14598','2013-12-09','12:20:00',1.97),('14598','2013-12-09','12:25:00',2.33),('14598','2013-12-09','12:30:00',1.86),('14598','2013-12-09','12:35:00',2.91),('14598','2013-12-09','12:40:00',2.95),('14598','2013-12-09','12:45:00',2.92),('14598','2013-12-09','12:50:00',2.75),('14598','2013-12-09','12:55:00',2.97),('14598','2013-12-09','13:00:00',3.03),('14598','2013-12-09','13:05:00',3.2),('14598','2013-12-09','13:10:00',3.08),('14598','2013-12-09','13:15:00',2.99),('14598','2013-12-09','13:20:00',1.85),('14598','2013-12-09','13:25:00',1.38),('14598','2013-12-09','13:30:00',1.14),('14598','2013-12-09','13:55:00',1.01),('14598','2013-12-08','12:40:00',1.05),('14598','2013-12-08','12:45:00',1.5),('14598','2013-12-08','12:50:00',1.1),('14598','2013-12-08','13:00:00',1.11),('14598','2013-12-08','13:05:00',1.45),('14598','2013-12-08','13:10:00',2.63),('14598','2013-12-08','13:15:00',3.33),('14598','2013-12-08','13:20:00',3.3),('14598','2013-12-08','13:25:00',2.53),('14598','2013-12-08','13:30:00',1.33),('14598','2013-12-08','13:40:00',1.05),('14598','2013-12-08','13:45:00',1.11),('14598','2013-12-08','13:50:00',1.75),('14598','2013-12-08','13:55:00',1.66),('14598','2013-12-08','14:00:00',2.35),('14598','2013-12-08','14:05:00',2.34),('14598','2013-12-08','14:10:00',2.42),('14598','2013-12-08','14:15:00',2.28),('14598','2013-12-08','14:20:00',1.47),('14598','2013-12-08','14:25:00',1.95),('14598','2013-12-08','14:30:00',1.95),('14598','2013-12-08','14:35:00',1.88),('14598','2013-12-08','14:40:00',1.82),('14598','2013-12-08','14:45:00',1.73),('14598','2013-12-08','14:50:00',1.67),('14598','2013-12-08','14:55:00',1.61),('14598','2013-12-08','15:00:00',1.56),('14598','2013-12-08','15:05:00',1.49),('14598','2013-12-08','15:10:00',1.38),('14598','2013-12-08','15:15:00',1.28),('14598','2013-12-08','15:20:00',1.18),('14598','2013-12-08','15:25:00',1.07),('14598','2014-04-21','08:55:00',1.12),('14598','2014-04-21','09:00:00',1.53),('14598','2014-04-21','09:05:00',1.27),('14598','2014-04-21','09:10:00',1.79),('14598','2014-04-21','09:15:00',2.59),('14598','2014-04-21','09:20:00',2.66),('14598','2014-04-21','09:25:00',2.67),('14598','2014-04-21','09:30:00',2.45),('14598','2014-04-21','09:35:00',3.22),('14598','2014-04-21','09:40:00',3.25),('14598','2014-04-21','09:45:00',1.35),('14598','2014-04-21','09:50:00',1.26),('14598','2014-04-21','09:55:00',1.3),('14598','2014-04-21','10:00:00',1.81),('14598','2014-04-21','10:05:00',2.66),('14598','2014-04-21','10:10:00',2.78),('14598','2014-04-21','10:15:00',2.99),('14598','2014-04-21','10:20:00',2.26),('14598','2014-04-21','10:25:00',4.01),('14598','2014-04-21','10:30:00',3.38),('14598','2014-04-21','10:35:00',3.58),('14598','2014-04-21','10:40:00',3.61),('14598','2014-04-21','10:45:00',3.67),('14598','2014-04-21','10:50:00',3.72),('14598','2014-04-21','10:55:00',3.77),('14598','2014-04-21','11:00:00',3.83),('14598','2014-04-21','11:05:00',3.87),('14598','2014-04-21','11:10:00',3.92),('14598','2014-04-21','11:15:00',3.98),('14598','2014-04-21','11:20:00',4.02),('14598','2014-04-21','11:25:00',4.08),('14598','2014-04-21','11:30:00',4.2),('14598','2014-04-21','11:35:00',4.28),('14598','2014-04-21','11:40:00',4.31),('14598','2014-04-21','11:45:00',4.3),('14598','2014-04-21','11:50:00',4.37),('14598','2014-04-21','11:55:00',4.41),('14598','2014-04-21','12:00:00',4.46),('14598','2014-04-21','12:05:00',4.54),('14598','2014-04-21','12:10:00',4.58),('14598','2014-04-21','12:15:00',4.62),('14598','2014-04-21','12:20:00',4.69),('14598','2014-04-21','12:25:00',4.73),('14598','2014-04-21','12:30:00',4.76),('14598','2014-04-21','12:35:00',4.76),('14598','2014-04-21','12:40:00',4.76),('14598','2014-04-21','12:45:00',4.82),('14598','2014-04-21','12:50:00',4.86),('14598','2014-04-21','12:55:00',4.9),('14598','2014-04-21','13:00:00',4.92),('14598','2014-04-21','13:05:00',4.95),('14598','2014-04-21','13:10:00',4.96),('14598','2014-04-21','13:15:00',4.97),('14598','2014-04-21','13:20:00',4.98),('14598','2014-04-21','13:25:00',5),('14598','2014-04-21','13:30:00',4.98),('14598','2014-04-21','13:35:00',5.01),('14598','2014-04-21','13:40:00',5.01),('14598','2014-04-21','13:45:00',5.01),('14598','2014-04-21','13:50:00',5.01),('14598','2014-04-21','13:55:00',5),('14598','2014-04-21','14:00:00',5),('14598','2014-04-21','14:05:00',5.01),('14598','2014-04-21','14:10:00',5),('14598','2014-04-21','14:15:00',4.99),('14598','2014-04-21','14:20:00',4.97),('14598','2014-04-21','14:25:00',4.95),('14598','2014-04-21','14:30:00',4.9),('14598','2014-04-21','14:35:00',4.9),('14598','2014-04-21','14:40:00',4.88),('14598','2014-04-21','14:45:00',4.81),('14598','2014-04-21','14:50:00',4.79),('14598','2014-04-21','14:55:00',4.76),('14598','2014-04-21','15:00:00',4.73),('14598','2014-04-21','15:05:00',4.71),('14598','2014-04-21','15:10:00',4.65),('14598','2014-04-21','15:15:00',4.62),('14598','2014-04-21','15:20:00',4.57),('14598','2014-04-21','15:25:00',4.51),('14598','2014-04-21','15:30:00',4.46),('14598','2014-04-21','15:35:00',4.42),('14598','2014-04-21','15:40:00',4.38),('14598','2014-04-21','15:45:00',4.35),('14598','2014-04-21','15:50:00',4.29),('14598','2014-04-21','15:55:00',4.26),('14598','2014-04-21','16:00:00',4.2),('14598','2014-04-21','16:05:00',4.15),('14598','2014-04-21','16:10:00',4.11),('14598','2014-04-21','16:15:00',4.05),('14598','2014-04-21','16:20:00',3.98),('14598','2014-04-21','16:25:00',3.91),('14598','2014-04-21','16:30:00',3.83),('14598','2014-04-21','16:35:00',3.78),('14598','2014-04-21','16:40:00',3.71),('14598','2014-04-21','16:45:00',3.65),('14598','2014-04-21','16:50:00',3.58),('14598','2014-04-21','16:55:00',3.49),('14598','2014-04-21','17:00:00',3.41),('14598','2014-04-21','17:05:00',3.32),('14598','2014-04-21','17:10:00',3.23),('14598','2014-04-21','17:15:00',3.12),('14598','2014-04-21','17:20:00',3.03),('14598','2014-04-21','17:25:00',2.95),('14598','2014-04-21','17:30:00',2.84),('14598','2014-04-21','17:35:00',2.74),('14598','2014-04-21','17:40:00',2.63),('14598','2014-04-21','17:45:00',2.51),('14598','2014-04-21','17:50:00',2.41),('14598','2014-04-21','17:55:00',2.3),('14598','2014-04-21','18:00:00',2.19),('14598','2014-04-21','18:05:00',2.07),('14598','2014-04-21','18:10:00',1.97),('14598','2014-04-21','18:15:00',1.85),('14598','2014-04-21','18:20:00',1.75),('14598','2014-04-21','18:25:00',1.64),('14598','2014-04-21','18:30:00',1.52),('14598','2014-04-21','18:35:00',1.42),('14598','2014-04-21','18:40:00',1.31),('14598','2014-04-21','18:45:00',1.19),('14598','2014-04-21','18:50:00',1.08),('14598','2013-12-07','09:10:00',1.03),('14598','2013-12-07','09:15:00',1.11),('14598','2013-12-07','09:20:00',1.19),('14598','2013-12-07','09:25:00',1.27),('14598','2013-12-07','09:30:00',1.36),('14598','2013-12-07','09:35:00',1.44),('14598','2013-12-07','09:40:00',1.52),('14598','2013-12-07','09:45:00',1.6),('14598','2013-12-07','09:50:00',1.67),('14598','2013-12-07','09:55:00',1.75),('14598','2013-12-07','10:00:00',1.82),('14598','2013-12-07','10:05:00',1.87),('14598','2013-12-07','10:10:00',1.93),('14598','2013-12-07','10:15:00',2.01),('14598','2013-12-07','10:20:00',2.06),('14598','2013-12-07','10:25:00',2.12),('14598','2013-12-07','10:30:00',2.17),('14598','2013-12-07','10:35:00',2.23),('14598','2013-12-07','10:40:00',2.28),('14598','2013-12-07','10:45:00',2.33),('14598','2013-12-07','10:50:00',2.38),('14598','2013-12-07','10:55:00',2.43),('14598','2013-12-07','11:00:00',2.46),('14598','2013-12-07','11:05:00',2.49),('14598','2013-12-07','11:10:00',2.56),('14598','2013-12-07','11:15:00',2.61),('14598','2013-12-07','11:20:00',2.62),('14598','2013-12-07','11:25:00',2.64),('14598','2013-12-07','11:30:00',2.68),('14598','2013-12-07','11:35:00',2.69),('14598','2013-12-07','11:40:00',2.7),('14598','2013-12-07','11:45:00',2.69),('14598','2013-12-07','11:50:00',2.77),('14598','2013-12-07','11:55:00',2.76),('14598','2013-12-07','12:00:00',2.76),('14598','2013-12-07','12:05:00',2.77),('14598','2013-12-07','12:10:00',2.76),('14598','2013-12-07','12:15:00',2.76),('14598','2013-12-07','12:20:00',2.76),('14598','2013-12-07','12:25:00',2.76),('14598','2013-12-07','12:30:00',2.78),('14598','2013-12-07','12:35:00',2.79),('14598','2013-12-07','12:40:00',2.76),('14598','2013-12-07','12:45:00',2.73),('14598','2013-12-07','12:50:00',2.71),('14598','2013-12-07','12:55:00',2.7),('14598','2013-12-07','13:00:00',2.68),('14598','2013-12-07','13:05:00',2.64),('14598','2013-12-07','13:10:00',2.62),('14598','2013-12-07','13:15:00',2.6),('14598','2013-12-07','13:20:00',2.56),('14598','2013-12-07','13:25:00',2.53),('14598','2013-12-07','13:30:00',2.5),('14598','2013-12-07','13:35:00',2.47),('14598','2013-12-07','13:40:00',2.44),('14598','2013-12-07','13:45:00',2.4),('14598','2013-12-07','13:50:00',2.35),('14598','2013-12-07','13:55:00',2.3),('14598','2013-12-07','14:00:00',2.25),('14598','2013-12-07','14:05:00',2.2),('14598','2013-12-07','14:10:00',2.15),('14598','2013-12-07','14:15:00',2.1),('14598','2013-12-07','14:20:00',2.04),('14598','2013-12-07','14:25:00',1.98),('14598','2013-12-07','14:30:00',1.91),('14598','2013-12-07','14:35:00',1.85),('14598','2013-12-07','14:40:00',1.78),('14598','2013-12-07','14:45:00',1.68),('14598','2013-12-07','14:50:00',1.61),('14598','2013-12-07','14:55:00',1.55),('14598','2013-12-07','15:00:00',1.49),('14598','2013-12-07','15:05:00',1.42),('14598','2013-12-07','15:10:00',1.35),('14598','2013-12-07','15:15:00',1.27),('14598','2013-12-07','15:20:00',1.2),('14598','2013-12-07','15:25:00',1.11),('14598','2013-12-07','15:30:00',1.03),('14598','2013-12-06','10:55:00',1.04),('14598','2013-12-06','11:00:00',1.13),('14598','2013-12-06','11:05:00',1.17),('14598','2013-12-06','11:10:00',1.1),('14598','2013-12-06','11:15:00',1.16),('14598','2013-12-06','11:20:00',1.31),('14598','2013-12-06','11:25:00',1.59),('14598','2013-12-06','11:30:00',1.7),('14598','2013-12-06','11:35:00',1.68),('14598','2013-12-06','11:40:00',1.87),('14598','2013-12-06','11:45:00',1.42),('14598','2013-12-06','11:50:00',1.33),('14598','2013-12-06','11:55:00',1.32),('14598','2013-12-06','12:00:00',1.33),('14598','2013-12-06','12:05:00',1.25),('14598','2013-12-06','12:10:00',1.29),('14598','2013-12-06','12:15:00',1.29),('14598','2013-12-06','12:20:00',1.38),('14598','2013-12-06','12:25:00',1.28),('14598','2013-12-06','12:30:00',1.25),('14598','2013-12-06','12:35:00',1.14),('14598','2013-12-06','12:40:00',1.31),('14598','2013-12-06','12:45:00',1.59),('14598','2013-12-06','12:50:00',1.51),('14598','2013-12-06','12:55:00',1.67),('14598','2013-12-06','13:00:00',2.16),('14598','2013-12-06','13:05:00',1.51),('14598','2013-12-06','13:10:00',1.11),('14598','2013-12-06','13:15:00',1.24),('14598','2013-12-06','13:20:00',1.15),('14598','2013-12-06','13:25:00',1.04),('14598','2013-12-06','13:35:00',1.02),('14598','2013-12-06','14:10:00',1.03),('14598','2013-12-06','14:15:00',1.96),('14598','2013-12-06','14:20:00',1.26),('14598','2013-12-06','14:40:00',1.11),('14598','2013-12-06','14:45:00',1.62),('14598','2013-12-06','14:50:00',1.97),('14598','2013-12-06','14:55:00',1.89),('14598','2013-12-06','15:00:00',1.71),('14598','2013-12-06','15:05:00',1.54),('14598','2013-12-06','15:10:00',1.64),('14598','2013-12-06','15:15:00',1.88),('14598','2013-12-06','15:20:00',1.4),('14598','2013-12-06','15:25:00',1.18),('14598','2013-12-05','09:10:00',1.04),('14598','2013-12-05','09:15:00',1.13),('14598','2013-12-05','09:20:00',1.23),('14598','2013-12-05','09:25:00',1.31),('14598','2013-12-05','09:30:00',1.39),('14598','2013-12-05','09:35:00',1.47),('14598','2013-12-05','09:40:00',1.54),('14598','2013-12-05','09:45:00',1.63),('14598','2013-12-05','09:50:00',1.71),('14598','2013-12-05','09:55:00',1.78),('14598','2013-12-05','10:00:00',1.86),('14598','2013-12-05','10:05:00',1.93),('14598','2013-12-05','10:10:00',1.98),('14598','2013-12-05','10:15:00',2.05),('14598','2013-12-05','10:20:00',2.1),('14598','2013-12-05','10:25:00',2.17),('14598','2013-12-05','10:30:00',2.23),('14598','2013-12-05','10:35:00',2.28),('14598','2013-12-05','10:40:00',2.33),('14598','2013-12-05','10:45:00',2.39),('14598','2013-12-05','10:50:00',2.44),('14598','2013-12-05','10:55:00',2.48),('14598','2013-12-05','11:00:00',2.5),('14598','2013-12-05','11:05:00',2.55),('14598','2013-12-05','11:10:00',2.57),('14598','2013-12-05','11:15:00',2.62),('14598','2013-12-05','11:20:00',2.65),('14598','2013-12-05','11:25:00',2.68),('14598','2013-12-05','11:30:00',2.72),('14598','2013-12-05','11:35:00',2.73),('14598','2013-12-05','11:40:00',2.76),('14598','2013-12-05','11:45:00',2.77),('14598','2013-12-05','11:50:00',2.78),('14598','2013-12-05','11:55:00',2.81),('14598','2013-12-05','12:00:00',2.82),('14598','2013-12-05','12:05:00',2.82),('14598','2013-12-05','12:10:00',2.83),('14598','2013-12-05','12:15:00',2.82),('14598','2013-12-05','12:20:00',2.82),('14598','2013-12-05','12:25:00',2.83),('14598','2013-12-05','12:30:00',2.81),('14598','2013-12-05','12:35:00',2.8),('14598','2013-12-05','12:40:00',2.77),('14598','2013-12-05','12:45:00',2.77),('14598','2013-12-05','12:50:00',2.76),('14598','2013-12-05','12:55:00',2.75),('14598','2013-12-05','13:00:00',2.71),('14598','2013-12-05','13:05:00',2.7),('14598','2013-12-05','13:10:00',2.66),('14598','2013-12-05','13:15:00',2.65),('14598','2013-12-05','13:20:00',2.62),('14598','2013-12-05','13:25:00',2.07),('14598','2013-12-05','13:30:00',2.54),('14598','2013-12-05','13:35:00',2.54),('14598','2013-12-05','13:40:00',2.52),('14598','2013-12-05','13:45:00',2.53),('14598','2013-12-05','13:50:00',2.5),('14598','2013-12-05','13:55:00',2.47),('14598','2013-12-05','14:00:00',2.39),('14598','2013-12-05','14:05:00',2.36),('14598','2013-12-05','14:10:00',2.3),('14598','2013-12-05','14:15:00',2.25),('14598','2013-12-05','14:20:00',2.2),('14598','2013-12-05','14:25:00',2.13),('14598','2013-12-05','14:30:00',2.07),('14598','2013-12-05','14:35:00',2),('14598','2013-12-05','14:40:00',1.93),('14598','2013-12-05','14:45:00',1.85),('14598','2013-12-05','14:50:00',1.78),('14598','2013-12-05','14:55:00',1.71),('14598','2013-12-05','15:00:00',1.62),('14598','2013-12-05','15:05:00',1.54),('14598','2013-12-05','15:10:00',1.45),('14598','2013-12-05','15:15:00',1.35),('14598','2013-12-05','15:20:00',1.28),('14598','2013-12-05','15:25:00',1.17),('14598','2013-12-05','15:30:00',1.07),('14598','2013-12-04','09:05:00',1.06),('14598','2013-12-04','09:10:00',1.15),('14598','2013-12-04','09:15:00',1.24),('14598','2013-12-04','09:20:00',1.32),('14598','2013-12-04','09:25:00',1.41),('14598','2013-12-04','09:30:00',1.49),('14598','2013-12-04','09:35:00',1.57),('14598','2013-12-04','09:40:00',1.64),('14598','2013-12-04','09:45:00',1.73),('14598','2013-12-04','09:50:00',1.8),('14598','2013-12-04','09:55:00',1.88),('14598','2013-12-04','10:00:00',1.96),('14598','2013-12-04','10:05:00',2.03),('14598','2013-12-04','10:10:00',2.09),('14598','2013-12-04','10:15:00',2.17),('14598','2013-12-04','10:20:00',2.23),('14598','2013-12-04','10:25:00',2.29),('14598','2013-12-04','10:30:00',2.35),('14598','2013-12-04','10:35:00',2.41),('14598','2013-12-04','10:40:00',2.47),('14598','2013-12-04','10:45:00',2.52),('14598','2013-12-04','10:50:00',2.57),('14598','2013-12-04','10:55:00',2.61),('14598','2013-12-04','11:00:00',2.66),('14598','2013-12-04','11:05:00',2.7),('14598','2013-12-04','11:10:00',2.74),('14598','2013-12-04','11:15:00',2.78),('14598','2013-12-04','11:20:00',2.8),('14598','2013-12-04','11:25:00',2.83),('14598','2013-12-04','11:30:00',2.87),('14598','2013-12-04','11:35:00',2.89),('14598','2013-12-04','11:40:00',2.91),('14598','2013-12-04','11:45:00',2.92),('14598','2013-12-04','11:50:00',2.94),('14598','2013-12-04','11:55:00',2.96),('14598','2013-12-04','12:00:00',2.98),('14598','2013-12-04','12:05:00',2.99),('14598','2013-12-04','12:10:00',3),('14598','2013-12-04','12:15:00',3.01),('14598','2013-12-04','12:20:00',3.01),('14598','2013-12-04','12:25:00',3),('14598','2013-12-04','12:30:00',3),('14598','2013-12-04','12:35:00',2.99),('14598','2013-12-04','12:40:00',2.98),('14598','2013-12-04','12:45:00',2.9),('14598','2013-12-04','12:50:00',2.95),('14598','2013-12-04','12:55:00',2.93),('14598','2013-12-04','13:00:00',2.92),('14598','2013-12-04','13:05:00',2.91),('14598','2013-12-04','13:10:00',2.87),('14598','2013-12-04','13:15:00',2.85),('14598','2013-12-04','13:20:00',2.82),('14598','2013-12-04','13:25:00',2.8),('14598','2013-12-04','13:30:00',2.76),('14598','2013-12-04','13:35:00',2.74),('14598','2013-12-04','13:40:00',2.7),('14598','2013-12-04','13:45:00',2.66),('14598','2013-12-04','13:50:00',2.61),('14598','2013-12-04','13:55:00',2.58),('14598','2013-12-04','14:00:00',2.53),('14598','2013-12-04','14:05:00',2.49),('14598','2013-12-04','14:10:00',2.44),('14598','2013-12-04','14:15:00',2.38),('14598','2013-12-04','14:20:00',2.32),('14598','2013-12-04','14:25:00',2.27),('14598','2013-12-04','14:30:00',2.2),('14598','2013-12-04','14:35:00',2.14),('14598','2013-12-04','14:40:00',2.07),('14598','2013-12-04','14:45:00',1.99),('14598','2013-12-04','14:50:00',1.93),('14598','2013-12-04','14:55:00',1.85),('14598','2013-12-04','15:00:00',1.76),('14598','2013-12-04','15:05:00',1.67),('14598','2013-12-04','15:10:00',1.59),('14598','2013-12-04','15:15:00',1.51),('14598','2013-12-04','15:20:00',1.42),('14598','2013-12-04','15:25:00',1.31),('14598','2013-12-04','15:30:00',1.21),('14598','2013-12-04','15:35:00',1.11),('14598','2013-12-04','15:40:00',1.01),('14598','2013-12-03','09:10:00',1.06),('14598','2013-12-03','09:15:00',1.13),('14598','2013-12-03','09:20:00',1.21),('14598','2013-12-03','09:25:00',1.34),('14598','2013-12-03','09:30:00',1.44),('14598','2013-12-03','09:35:00',1.53),('14598','2013-12-03','09:40:00',1.6),('14598','2013-12-03','09:45:00',1.67),('14598','2013-12-03','09:50:00',1.75),('14598','2013-12-03','09:55:00',1.82),('14598','2013-12-03','10:00:00',1.89),('14598','2013-12-03','10:05:00',1.95),('14598','2013-12-03','10:10:00',2.02),('14598','2013-12-03','10:15:00',2.08),('14598','2013-12-03','10:20:00',2.15),('14598','2013-12-03','10:25:00',2.17),('14598','2013-12-03','10:30:00',2.29),('14598','2013-12-03','10:35:00',2.34),('14598','2013-12-03','10:40:00',2.4),('14598','2013-12-03','10:45:00',2.45),('14598','2013-12-03','10:50:00',2.5),('14598','2013-12-03','10:55:00',2.55),('14598','2013-12-03','11:00:00',2.6),('14598','2013-12-03','11:05:00',2.65),('14598','2013-12-03','11:10:00',2.7),('14598','2013-12-03','11:15:00',2.75),('14598','2013-12-03','11:20:00',2.81),('14598','2013-12-03','11:25:00',2.85),('14598','2013-12-03','11:30:00',2.88),('14598','2013-12-03','11:35:00',2.92),('14598','2013-12-03','11:40:00',2.92),('14598','2013-12-03','11:45:00',2.99),('14598','2013-12-03','11:50:00',3.09),('14598','2013-12-03','11:55:00',3.08),('14598','2013-12-03','12:00:00',3.09),('14598','2013-12-03','12:05:00',3.1),('14598','2013-12-03','12:10:00',3.12),('14598','2013-12-03','12:15:00',3.17),('14598','2013-12-03','12:20:00',3.2),('14598','2013-12-03','12:25:00',3.23),('14598','2013-12-03','12:30:00',3.25),('14598','2013-12-03','12:35:00',3.29),('14598','2013-12-03','12:40:00',3.3),('14598','2013-12-03','12:45:00',3.31),('14598','2013-12-03','12:50:00',3.34),('14598','2013-12-03','12:55:00',3.36),('14598','2013-12-03','13:00:00',3.06),('14598','2013-12-03','13:05:00',3.02),('14598','2013-12-03','13:10:00',3.24),('14598','2013-12-03','13:15:00',3.4),('14598','2013-12-03','13:20:00',3.36),('14598','2013-12-03','13:25:00',2.92),('14598','2013-12-03','13:30:00',2.89),('14598','2013-12-03','13:35:00',2.81),('14598','2013-12-03','13:40:00',2.36),('14598','2013-12-03','13:45:00',2.09),('14598','2013-12-03','13:50:00',2.41),('14598','2013-12-03','13:55:00',2.25),('14598','2013-12-03','14:00:00',1.69),('14598','2013-12-03','14:05:00',1.72),('14598','2013-12-03','14:10:00',2.24),('14598','2013-12-03','14:15:00',2.37),('14598','2013-12-03','14:20:00',2.31),('14598','2013-12-03','14:25:00',2.25),('14598','2013-12-03','14:30:00',2.18),('14598','2013-12-03','14:35:00',2.1),('14598','2013-12-03','14:40:00',2.01),('14598','2013-12-03','14:45:00',1.95),('14598','2013-12-03','14:50:00',1.87),('14598','2013-12-03','14:55:00',1.79),('14598','2013-12-03','15:00:00',1.7),('14598','2013-12-03','15:05:00',1.61),('14598','2013-12-03','15:10:00',1.53),('14598','2013-12-03','15:15:00',1.44),('14598','2013-12-03','15:20:00',1.34),('14598','2013-12-03','15:25:00',1.26),('14598','2013-12-03','15:30:00',1.16),('14598','2013-12-03','15:35:00',1.07),('14598','2013-12-01','11:45:00',1.29),('14598','2013-12-01','12:00:00',1.31),('14598','2013-12-01','12:05:00',1.51),('14598','2013-12-01','12:10:00',1.23),('14598','2013-12-01','12:15:00',1.41),('14598','2013-12-01','12:20:00',1.16),('14598','2013-12-01','12:55:00',1.15),('14598','2013-11-30','10:15:00',1.01),('14598','2013-11-30','10:20:00',1.22),('14598','2013-11-30','10:25:00',1.38),('14598','2013-11-30','10:30:00',1.36),('14598','2013-11-30','10:35:00',1.36),('14598','2013-11-30','10:40:00',1.17),('14598','2013-11-30','10:45:00',1.26),('14598','2013-11-30','10:50:00',1.3),('14598','2013-11-30','10:55:00',1.17),('14598','2013-11-30','11:00:00',1.08),('14598','2013-11-30','11:05:00',1.05),('14598','2013-11-30','11:10:00',1.11),('14598','2013-11-30','11:15:00',1.2),('14598','2013-11-30','11:20:00',1.27),('14598','2013-11-30','11:25:00',1.3),('14598','2013-11-30','11:30:00',1.25),('14598','2013-11-30','11:35:00',1.32),('14598','2013-11-30','11:40:00',1.25),('14598','2013-11-30','11:45:00',1.11),('14598','2013-11-30','11:50:00',1.07),('14598','2013-11-30','11:55:00',1.02),('14598','2013-11-29','09:00:00',1.02),('14598','2013-11-29','09:05:00',1.11),('14598','2013-11-29','09:10:00',1.2),('14598','2013-11-29','09:15:00',1.28),('14598','2013-11-29','09:20:00',1.36),('14598','2013-11-29','09:25:00',1.44),('14598','2013-11-29','09:30:00',1.52),('14598','2013-11-29','09:35:00',1.6),('14598','2013-11-29','09:40:00',1.68),('14598','2013-11-29','09:45:00',1.75),('14598','2013-11-29','09:50:00',1.83),('14598','2013-11-29','09:55:00',1.89),('14598','2013-11-29','10:00:00',1.97),('14598','2013-11-29','10:05:00',2.04),('14598','2013-11-29','10:10:00',2.11),('14598','2013-11-29','10:15:00',2.17),('14598','2013-11-29','10:20:00',2.23),('14598','2013-11-29','10:25:00',2.3),('14598','2013-11-29','10:30:00',2.35),('14598','2013-11-29','10:35:00',2.41),('14598','2013-11-29','10:40:00',2.46),('14598','2013-11-29','10:45:00',2.52),('14598','2013-11-29','10:50:00',2.57),('14598','2013-11-29','10:55:00',2.6),('14598','2013-11-29','11:00:00',2.65),('14598','2013-11-29','11:05:00',2.7),('14598','2013-11-29','11:10:00',2.69),('14598','2013-11-29','11:15:00',2.78),('14598','2013-11-29','11:20:00',2.81),('14598','2013-11-29','11:25:00',2.85),('14598','2013-11-29','11:30:00',2.88),('14598','2013-11-29','11:35:00',2.91),('14598','2013-11-29','11:40:00',2.92),('14598','2013-11-29','11:45:00',2.94),('14598','2013-11-29','11:50:00',2.96),('14598','2013-11-29','11:55:00',2.98),('14598','2013-11-29','12:00:00',2.99),('14598','2013-11-29','12:05:00',3),('14598','2013-11-29','12:10:00',3),('14598','2013-11-29','12:15:00',3.03),('14598','2013-11-29','12:20:00',3.02),('14598','2013-11-29','12:25:00',2.98),('14598','2013-11-29','12:30:00',3.01),('14598','2013-11-29','12:35:00',3.01),('14598','2013-11-29','12:40:00',3),('14598','2013-11-29','12:45:00',2.98),('14598','2013-11-29','12:50:00',2.97),('14598','2013-11-29','12:55:00',2.95),('14598','2013-11-29','13:00:00',2.94),('14598','2013-11-29','13:05:00',2.93),('14598','2013-11-29','13:10:00',2.9),('14598','2013-11-29','13:15:00',2.86),('14598','2013-11-29','13:20:00',2.84),('14598','2013-11-29','13:25:00',2.82),('14598','2013-11-29','13:30:00',2.77),('14598','2013-11-29','13:35:00',2.74),('14598','2013-11-29','13:40:00',2.71),('14598','2013-11-29','13:45:00',2.68),('14598','2013-11-29','13:50:00',2.63),('14598','2013-11-29','13:55:00',2.58),('14598','2013-11-29','14:00:00',2.56),('14598','2013-11-29','14:05:00',2.48),('14598','2013-11-29','14:10:00',2.38),('14598','2013-11-29','14:15:00',2.39),('14598','2013-11-29','14:20:00',2.33),('14598','2013-11-29','14:25:00',2.25),('14598','2013-11-29','14:30:00',2.19),('14598','2013-11-29','14:35:00',2.14),('14598','2013-11-29','14:40:00',2.05),('14598','2013-11-29','14:45:00',1.97),('14598','2013-11-29','14:50:00',1.9),('14598','2013-11-29','14:55:00',1.81),('14598','2013-11-29','15:00:00',1.72),('14598','2013-11-29','15:05:00',1.64),('14598','2013-11-29','15:10:00',1.55),('14598','2013-11-29','15:15:00',1.47),('14598','2013-11-29','15:20:00',1.39),('14598','2013-11-29','15:25:00',1.31),('14598','2013-11-29','15:30:00',1.23),('14598','2013-11-29','15:35:00',1.14),('14598','2013-11-29','15:40:00',1.03),('14598','2013-11-28','11:30:00',1.23),('14598','2013-11-28','11:35:00',1.37),('14598','2013-11-28','12:50:00',1.13),('14598','2013-11-28','13:35:00',1.06),('14598','2014-04-20','07:35:00',1.1),('14598','2014-04-20','08:20:00',1.08),('14598','2014-04-20','08:30:00',1.75),('14598','2014-04-20','08:35:00',1.55),('14598','2014-04-20','08:40:00',1.43),('14598','2014-04-20','08:45:00',1.48),('14598','2014-04-20','08:50:00',1.68),('14598','2014-04-20','08:55:00',1.81),('14598','2014-04-20','09:00:00',1.99),('14598','2014-04-20','09:05:00',2.17),('14598','2014-04-20','09:10:00',2.33),('14598','2014-04-20','09:15:00',2.5),('14598','2014-04-20','09:20:00',2.61),('14598','2014-04-20','09:25:00',2.69),('14598','2014-04-20','09:30:00',3.08),('14598','2014-04-20','09:35:00',2.56),('14598','2014-04-20','09:40:00',2.11),('14598','2014-04-20','09:45:00',2.24),('14598','2014-04-20','09:50:00',2.61),('14598','2014-04-20','09:55:00',2.2),('14598','2014-04-20','10:00:00',2.3),('14598','2014-04-20','10:05:00',2.24),('14598','2014-04-20','10:10:00',2.08),('14598','2014-04-20','10:15:00',2.05),('14598','2014-04-20','10:20:00',2.07),('14598','2014-04-20','10:25:00',2.36),('14598','2014-04-20','10:30:00',2.81),('14598','2014-04-20','10:35:00',3.04),('14598','2014-04-20','10:40:00',3.65),('14598','2014-04-20','10:45:00',4.38),('14598','2014-04-20','10:50:00',3.59),('14598','2014-04-20','10:55:00',3.33),('14598','2014-04-20','11:00:00',3.3),('14598','2014-04-20','11:05:00',3.28),('14598','2014-04-20','11:10:00',4.16),('14598','2014-04-20','11:15:00',4.42),('14598','2014-04-20','11:20:00',4.5),('14598','2014-04-20','11:25:00',4.39),('14598','2014-04-20','11:30:00',4.42),('14598','2014-04-20','11:35:00',4.49),('14598','2014-04-20','11:40:00',4.55),('14598','2014-04-20','11:45:00',4.61),('14598','2014-04-20','11:50:00',4.61),('14598','2014-04-20','11:55:00',4.68),('14598','2014-04-20','12:00:00',4.75),('14598','2014-04-20','12:05:00',4.76),('14598','2014-04-20','12:10:00',4.82),('14598','2014-04-20','12:15:00',4.87),('14598','2014-04-20','12:20:00',4.89),('14598','2014-04-20','12:25:00',4.88),('14598','2014-04-20','12:30:00',4.96),('14598','2014-04-20','12:35:00',4.98),('14598','2014-04-20','12:40:00',5.02),('14598','2014-04-20','12:45:00',5.06),('14598','2014-04-20','12:50:00',5.04),('14598','2014-04-20','12:55:00',5.07),('14598','2014-04-20','13:00:00',5.11),('14598','2014-04-20','13:05:00',5.11),('14598','2014-04-20','13:10:00',5.13),('14598','2014-04-20','13:15:00',5.12),('14598','2014-04-20','13:20:00',5.14),('14598','2014-04-20','13:25:00',5.18),('14598','2014-04-20','13:30:00',5.21),('14598','2014-04-20','13:35:00',5.18),('14598','2014-04-20','13:40:00',5.09),('14598','2014-04-20','13:45:00',5.08),('14598','2014-04-20','13:50:00',5.17),('14598','2014-04-20','13:55:00',5.24),('14598','2014-04-20','14:00:00',5.31),('14598','2014-04-20','14:05:00',5.49),('14598','2014-04-20','14:10:00',4.06),('14598','2014-04-20','14:15:00',3.6),('14598','2014-04-20','14:20:00',3.33),('14598','2014-04-20','14:25:00',3.19),('14598','2014-04-20','14:30:00',2.88),('14598','2014-04-20','14:35:00',3.02),('14598','2014-04-20','14:40:00',3.55),('14598','2014-04-20','14:45:00',5.27),('14598','2014-04-20','14:50:00',4.86),('14598','2014-04-20','14:55:00',5.12),('14598','2014-04-20','15:00:00',4.95),('14598','2014-04-20','15:05:00',4.88),('14598','2014-04-20','15:10:00',4.78),('14598','2014-04-20','15:15:00',4.72),('14598','2014-04-20','15:20:00',4.79),('14598','2014-04-20','15:25:00',3.51),('14598','2014-04-20','15:30:00',4.54),('14598','2014-04-20','15:35:00',4.74),('14598','2014-04-20','15:40:00',4.53),('14598','2014-04-20','15:45:00',4.47),('14598','2014-04-20','15:50:00',4.45),('14598','2014-04-20','15:55:00',4.39),('14598','2014-04-20','16:00:00',4.35),('14598','2014-04-20','16:05:00',4.2),('14598','2014-04-20','16:10:00',4.26),('14598','2014-04-20','16:15:00',3.58),('14598','2014-04-20','16:20:00',4.16),('14598','2014-04-20','16:25:00',3.88),('14598','2014-04-20','16:30:00',3.43),('14598','2014-04-20','16:35:00',4.13),('14598','2014-04-20','16:40:00',3.75),('14598','2014-04-20','16:45:00',3.74),('14598','2014-04-20','16:50:00',3.58),('14598','2014-04-20','16:55:00',3.49),('14598','2014-04-20','17:00:00',3.35),('14598','2014-04-20','17:05:00',3.27),('14598','2014-04-20','17:10:00',3.19),('14598','2014-04-20','17:15:00',3.14),('14598','2014-04-20','17:20:00',3.05),('14598','2014-04-20','17:25:00',2.92),('14598','2014-04-20','17:30:00',2.83),('14598','2014-04-20','17:35:00',2.72),('14598','2014-04-20','17:40:00',2.63),('14598','2014-04-20','17:45:00',2.53),('14598','2014-04-20','17:50:00',2.42),('14598','2014-04-20','17:55:00',2.33),('14598','2014-04-20','18:00:00',2.22),('14598','2014-04-20','18:05:00',1.9),('14598','2014-04-20','18:10:00',1.67),('14598','2014-04-20','18:15:00',1.2),('14598','2014-04-20','18:20:00',1.84),('14598','2014-04-20','18:25:00',1.66),('14598','2014-04-20','18:30:00',1.26),('14598','2013-11-27','08:55:00',1.01),('14598','2013-11-27','09:20:00',1.03),('14598','2013-11-27','09:25:00',1.06),('14598','2013-11-27','09:30:00',1.3),('14598','2013-11-27','09:45:00',1.11),('14598','2013-11-27','09:50:00',1.21),('14598','2013-11-27','09:55:00',1.58),('14598','2013-11-27','10:00:00',1.57),('14598','2013-11-27','10:05:00',1.49),('14598','2013-11-27','10:10:00',1.33),('14598','2013-11-27','10:15:00',1.23),('14598','2013-11-27','10:20:00',1.62),('14598','2013-11-27','10:25:00',1.61),('14598','2013-11-27','10:30:00',1.46),('14598','2013-11-27','10:35:00',1.37),('14598','2013-11-27','10:40:00',1.51),('14598','2013-11-27','10:45:00',1.32),('14598','2013-11-27','10:50:00',1.4),('14598','2013-11-27','10:55:00',1.46),('14598','2013-11-27','11:00:00',1.36),('14598','2013-11-27','11:05:00',1.4),('14598','2013-11-27','11:10:00',1.91),('14598','2013-11-27','11:15:00',2.24),('14598','2013-11-27','11:20:00',1.6),('14598','2013-11-27','11:25:00',1.42),('14598','2013-11-27','11:30:00',1.37),('14598','2013-11-27','11:35:00',1.22),('14598','2013-11-27','11:40:00',1.18),('14598','2013-11-27','11:45:00',1),('14598','2013-11-27','11:50:00',1.19),('14598','2013-11-27','11:55:00',1.35),('14598','2013-11-27','12:00:00',1.83),('14598','2013-11-27','12:05:00',2.67),('14598','2013-11-27','12:10:00',3.4),('14598','2013-11-27','12:15:00',3.79),('14598','2013-11-27','12:20:00',2.26),('14598','2013-11-27','12:25:00',4.48),('14598','2013-11-27','12:30:00',2.57),('14598','2013-11-27','12:35:00',1.41),('14598','2013-11-27','12:40:00',1.43),('14598','2013-11-27','12:45:00',1.09),('14598','2013-11-27','12:50:00',1.14),('14598','2013-11-27','12:55:00',1.05),('14598','2013-11-27','13:00:00',1.06),('14598','2013-11-27','13:05:00',1.17),('14598','2013-11-27','13:10:00',1.28),('14598','2013-11-27','13:15:00',1.37),('14598','2013-11-27','13:20:00',1.49),('14598','2013-11-27','13:25:00',1.2),('14598','2013-11-26','08:50:00',1.35),('14598','2013-11-26','08:55:00',1.35),('14598','2013-11-26','09:00:00',1.43),('14598','2013-11-26','09:05:00',1.51),('14598','2013-11-26','09:10:00',1.36),('14598','2013-11-26','10:15:00',1.85),('14598','2013-11-26','10:20:00',2.4),('14598','2013-11-26','10:25:00',2.48),('14598','2013-11-26','10:30:00',2.2),('14598','2013-11-26','10:35:00',2.3),('14598','2013-11-26','10:40:00',2.49),('14598','2013-11-26','10:45:00',2.97),('14598','2013-11-26','10:50:00',2.19),('14598','2013-11-26','10:55:00',2.97),('14598','2013-11-26','11:00:00',3.13),('14598','2013-11-26','11:05:00',3.41),('14598','2013-11-26','11:10:00',3.19),('14598','2013-11-26','11:15:00',3.84),('14598','2013-11-26','11:20:00',3.26),('14598','2013-11-26','11:25:00',2.47),('14598','2013-11-26','11:30:00',1.97),('14598','2013-11-26','11:40:00',1.09),('14598','2013-11-26','11:45:00',1.34),('14598','2013-11-26','11:50:00',1.55),('14598','2013-11-26','11:55:00',2.1),('14598','2013-11-26','12:00:00',3.66),('14598','2013-11-26','12:05:00',3.94),('14598','2013-11-26','12:10:00',3.59),('14598','2013-11-26','12:15:00',3.54),('14598','2013-11-26','12:20:00',3.41),('14598','2013-11-26','12:25:00',3.42),('14598','2013-11-26','12:30:00',3.26),('14598','2013-11-26','12:35:00',3.43),('14598','2013-11-26','12:40:00',3.44),('14598','2013-11-26','12:45:00',3.44),('14598','2013-11-26','12:50:00',2.77),('14598','2013-11-26','12:55:00',3.34),('14598','2013-11-26','13:00:00',3.22),('14598','2013-11-26','13:05:00',2.45),('14598','2013-11-26','13:10:00',2.18),('14598','2013-11-26','13:15:00',2.63),('14598','2013-11-26','13:20:00',3.05),('14598','2013-11-26','13:25:00',3.12),('14598','2013-11-26','13:30:00',3.09),('14598','2013-11-26','13:35:00',3.05),('14598','2013-11-26','13:40:00',2.72),('14598','2013-11-26','13:45:00',2.79),('14598','2013-11-26','13:50:00',2.73),('14598','2013-11-26','13:55:00',2.62),('14598','2013-11-26','14:00:00',2.63),('14598','2013-11-26','14:05:00',2.56),('14598','2013-11-26','14:10:00',2.55),('14598','2013-11-26','14:15:00',2.38),('14598','2013-11-26','14:20:00',2.34),('14598','2013-11-26','14:25:00',2.22),('14598','2013-11-26','14:30:00',1.98),('14598','2013-11-26','14:35:00',2.1),('14598','2013-11-26','14:40:00',2.07),('14598','2013-11-26','14:45:00',1.74),('14598','2013-11-26','14:50:00',1.68),('14598','2013-11-26','14:55:00',2.21),('14598','2013-11-26','15:00:00',1.64),('14598','2013-11-26','15:05:00',1.35),('14598','2013-11-26','15:10:00',2.04),('14598','2013-11-26','15:15:00',1.75),('14598','2013-11-26','15:20:00',1.45),('14598','2013-11-26','15:25:00',1.45),('14598','2013-11-26','15:30:00',1.41),('14598','2013-11-26','15:35:00',1.18),('14598','2013-11-25','08:55:00',1.06),('14598','2013-11-25','09:00:00',1.14),('14598','2013-11-25','09:05:00',1.7),('14598','2013-11-25','09:10:00',1.37),('14598','2013-11-25','09:15:00',1.31),('14598','2013-11-25','09:20:00',1.59),('14598','2013-11-25','09:25:00',1.9),('14598','2013-11-25','09:45:00',2),('14598','2013-11-25','09:50:00',1.16),('14598','2013-11-25','09:55:00',1.06),('14598','2013-11-25','10:00:00',1.82),('14598','2013-11-25','10:05:00',2.5),('14598','2013-11-25','10:10:00',2.84),('14598','2013-11-25','10:15:00',2.92),('14598','2013-11-25','10:20:00',2.37),('14598','2013-11-25','10:25:00',1.31),('14598','2013-11-25','10:30:00',2.33),('14598','2013-11-25','10:35:00',3.03),('14598','2013-11-25','10:40:00',3.03),('14598','2013-11-25','10:45:00',1.96),('14598','2013-11-25','10:50:00',1.69),('14598','2013-11-25','10:55:00',1.99),('14598','2013-11-25','11:00:00',2.06),('14598','2013-11-25','11:05:00',3.04),('14598','2013-11-25','11:10:00',3.24),('14598','2013-11-25','11:15:00',2.5),('14598','2013-11-25','11:20:00',1.03),('14598','2013-11-25','11:25:00',1.08),('14598','2013-11-25','11:30:00',1.22),('14598','2013-11-25','11:35:00',1.09),('14598','2013-11-25','11:40:00',1.03),('14598','2013-11-25','11:45:00',1.23),('14598','2013-11-25','11:50:00',1.63),('14598','2013-11-25','11:55:00',1.46),('14598','2013-11-25','12:00:00',2.13),('14598','2013-11-25','12:05:00',3.13),('14598','2013-11-25','12:10:00',1.91),('14598','2013-11-25','12:15:00',1.48),('14598','2013-11-25','12:20:00',1.77),('14598','2013-11-25','12:25:00',2.61),('14598','2013-11-25','12:30:00',2.31),('14598','2013-11-25','12:35:00',2.11),('14598','2013-11-25','12:40:00',1.77),('14598','2013-11-25','12:45:00',1.93),('14598','2013-11-25','12:50:00',2.26),('14598','2013-11-25','12:55:00',3.1),('14598','2013-11-25','13:00:00',2.05),('14598','2013-11-25','13:05:00',1.24),('14598','2013-11-25','13:10:00',1.21),('14598','2013-11-25','13:15:00',1.25),('14598','2013-11-25','13:20:00',1.56),('14598','2013-11-25','13:25:00',1.45),('14598','2013-11-25','13:30:00',2.03),('14598','2013-11-25','13:35:00',1.71),('14598','2013-11-25','13:40:00',1.59),('14598','2013-11-25','13:45:00',1.2),('14598','2013-11-24','10:00:00',1.3),('14598','2013-11-24','10:05:00',1.66),('14598','2013-11-24','10:10:00',1.67),('14598','2013-11-24','10:15:00',1.41),('14598','2013-11-24','10:20:00',1.99),('14598','2013-11-24','10:25:00',2.04),('14598','2013-11-24','10:30:00',2.42),('14598','2013-11-24','10:35:00',2.31),('14598','2013-11-24','10:40:00',2.7),('14598','2013-11-24','10:45:00',2.8),('14598','2013-11-24','10:50:00',2.88),('14598','2013-11-24','10:55:00',2.63),('14598','2013-11-24','11:00:00',1.82),('14598','2013-11-24','11:05:00',1.81),('14598','2013-11-24','11:10:00',1.34),('14598','2013-11-24','11:15:00',1.45),('14598','2013-11-24','11:20:00',1.68),('14598','2013-11-24','11:25:00',1.76),('14598','2013-11-24','11:30:00',1.49),('14598','2013-11-24','11:35:00',1.13),('14598','2013-11-24','12:45:00',1.04),('14598','2013-11-24','12:50:00',1.08),('14598','2013-11-24','12:55:00',1.06),('14598','2013-11-24','13:00:00',1.14),('14598','2013-11-24','13:05:00',1.24),('14598','2013-11-24','13:10:00',1.24),('14598','2013-11-24','13:15:00',1.2),('14598','2013-11-24','13:20:00',1.15),('14598','2013-11-24','13:25:00',1.12),('14598','2013-11-24','13:30:00',1.11),('14598','2013-11-24','13:35:00',1.08),('14598','2013-11-24','13:40:00',1.03),('14598','2013-11-23','10:10:00',1.11),('14598','2013-11-23','10:15:00',2.41),('14598','2013-11-23','11:35:00',1.04),('14598','2013-11-23','11:40:00',1.98),('14598','2013-11-23','11:45:00',1.37),('14598','2013-11-23','13:05:00',1.04),('14598','2013-11-22','09:00:00',1.08),('14598','2013-11-22','09:20:00',1.01),('14598','2013-11-22','12:00:00',1.3),('14598','2013-11-22','12:05:00',1.58),('14598','2013-11-22','12:10:00',1.83),('14598','2013-11-22','12:15:00',1.71),('14598','2013-11-22','12:20:00',1.76),('14598','2013-11-22','12:25:00',1.88),('14598','2013-11-22','12:30:00',1.05),('14598','2013-11-22','12:40:00',1.05),('14598','2013-11-21','09:15:00',1.09),('14598','2013-11-21','09:20:00',1.28),('14598','2013-11-21','09:30:00',1.39),('14598','2013-11-21','09:35:00',1.16),('14598','2013-11-21','09:50:00',1.12),('14598','2013-11-21','09:55:00',1.64),('14598','2013-11-21','10:00:00',1.51),('14598','2013-11-21','10:05:00',1.04),('14598','2013-11-21','10:10:00',1.76),('14598','2013-11-21','10:15:00',2.13),('14598','2013-11-21','10:20:00',1.25),('14598','2013-11-21','10:25:00',1.17),('14598','2013-11-21','10:30:00',1.2),('14598','2013-11-21','10:35:00',2.34),('14598','2013-11-21','10:40:00',3.32),('14598','2013-11-21','10:45:00',1.84),('14598','2013-11-21','10:50:00',2.57),('14598','2013-11-21','10:55:00',1.35),('14598','2013-11-21','11:00:00',2.57),('14598','2013-11-21','11:05:00',2.87),('14598','2013-11-21','11:10:00',3.07),('14598','2013-11-21','11:15:00',3.12),('14598','2013-11-21','11:20:00',3.36),('14598','2013-11-21','11:25:00',3.05),('14598','2013-11-21','11:30:00',1.8),('14598','2013-11-21','11:35:00',2.7),('14598','2013-11-21','11:40:00',3.38),('14598','2013-11-21','11:45:00',2.55),('14598','2013-11-21','11:50:00',3),('14598','2013-11-21','11:55:00',2.74),('14598','2013-11-21','12:00:00',1.65),('14598','2013-11-21','12:05:00',1.46),('14598','2013-11-21','12:10:00',2.02),('14598','2013-11-21','12:15:00',1.35),('14598','2013-11-21','12:20:00',1.6),('14598','2013-11-21','12:25:00',1.18),('14598','2013-11-21','12:30:00',1.42),('14598','2013-11-21','12:35:00',2.07),('14598','2013-11-21','12:40:00',2.34),('14598','2013-11-21','12:45:00',3.22),('14598','2013-11-21','12:50:00',3.14),('14598','2013-11-21','12:55:00',3.26),('14598','2013-11-21','13:00:00',3.74),('14598','2013-11-21','13:05:00',3.66),('14598','2013-11-21','13:10:00',2.78),('14598','2013-11-21','13:15:00',1.97),('14598','2013-11-21','13:20:00',2.86),('14598','2013-11-21','13:25:00',1.36),('14598','2013-11-21','13:30:00',3.39),('14598','2013-11-21','13:35:00',3.15),('14598','2013-11-21','13:40:00',3.02),('14598','2013-11-21','13:45:00',2.6),('14598','2013-11-21','13:50:00',1.15),('14598','2013-11-21','13:55:00',1.27),('14598','2013-11-21','14:00:00',1.46),('14598','2013-11-21','14:05:00',2.51),('14598','2013-11-21','14:10:00',1.55),('14598','2013-11-21','14:15:00',2.18),('14598','2013-11-21','14:20:00',1.9),('14598','2013-11-21','14:25:00',1.61),('14598','2013-11-21','14:30:00',2.43),('14598','2013-11-21','14:35:00',1.74),('14598','2013-11-21','14:40:00',1.25),('14598','2013-11-21','14:45:00',2.13),('14598','2013-11-21','14:50:00',2.07),('14598','2013-11-21','15:10:00',1.98),('14598','2013-11-21','15:15:00',1.72),('14598','2013-11-21','15:20:00',1.67),('14598','2013-11-21','15:25:00',1.69),('14598','2013-11-21','15:30:00',1.29),('14598','2013-11-20','08:45:00',1.2),('14598','2013-11-20','08:50:00',1.12),('14598','2013-11-20','09:50:00',1.2),('14598','2013-11-20','11:15:00',1.02),('14598','2013-11-20','11:20:00',1.88),('14598','2013-11-20','11:25:00',2.25),('14598','2013-11-20','11:30:00',1.14),('14598','2013-11-20','11:35:00',1.04),('14598','2013-11-20','11:40:00',1.14),('14598','2013-11-20','11:45:00',1.7),('14598','2013-11-20','11:50:00',2.14),('14598','2013-11-20','11:55:00',1.68),('14598','2013-11-20','12:00:00',1.34),('14598','2013-11-20','12:05:00',1.19),('14598','2013-11-20','12:10:00',1.23),('14598','2013-11-20','12:15:00',1.22),('14598','2013-11-20','12:20:00',1.35),('14598','2013-11-20','12:25:00',1.41),('14598','2013-11-20','12:30:00',1.77),('14598','2013-11-20','12:35:00',1.72),('14598','2013-11-20','12:40:00',1.96),('14598','2013-11-20','12:45:00',1.42),('14598','2013-11-20','12:50:00',2.12),('14598','2013-11-20','12:55:00',2.28),('14598','2013-11-20','13:00:00',3.01),('14598','2013-11-20','13:05:00',3.06),('14598','2013-11-20','13:10:00',1.95),('14598','2013-11-20','13:15:00',2.31),('14598','2013-11-20','13:20:00',2.3),('14598','2013-11-20','13:25:00',1.97),('14598','2013-11-20','13:30:00',2.47),('14598','2013-11-20','13:35:00',1.79),('14598','2013-11-20','13:40:00',1.14),('14598','2013-11-20','13:50:00',1.09),('14598','2013-11-20','13:55:00',1.41),('14598','2013-11-20','14:00:00',1.03),('14598','2013-11-20','14:10:00',2.03),('14598','2013-11-20','14:15:00',1.14),('14598','2013-11-20','14:25:00',1.6),('14598','2013-11-20','14:35:00',1.52),('14598','2013-11-20','14:40:00',2.61),('14598','2013-11-20','14:45:00',1.24),('14598','2013-11-19','09:15:00',1.14),('14598','2013-11-19','09:20:00',1.05),('14598','2013-11-19','09:25:00',1.34),('14598','2013-11-19','09:30:00',1.12),('14598','2013-11-19','10:15:00',1.82),('14598','2013-11-19','10:20:00',1.94),('14598','2013-11-19','10:25:00',1.63),('14598','2013-11-19','10:30:00',2.85),('14598','2013-11-19','10:35:00',1.85),('14598','2013-11-19','10:40:00',1.52),('14598','2013-11-19','10:45:00',1.93),('14598','2013-11-19','10:50:00',1.27),('14598','2013-11-19','10:55:00',1.14),('14598','2013-11-19','11:00:00',2.16),('14598','2013-11-19','11:05:00',1.46),('14598','2013-11-19','11:10:00',2.38),('14598','2013-11-19','11:15:00',1.23),('14598','2013-11-19','11:25:00',1.48),('14598','2013-11-19','11:30:00',1.49),('14598','2013-11-19','11:35:00',2.53),('14598','2013-11-19','11:40:00',2.39),('14598','2013-11-19','11:45:00',1.58),('14598','2013-11-19','11:50:00',1.09),('14598','2013-11-19','11:55:00',1.29),('14598','2013-11-19','12:00:00',1.11),('14598','2013-11-19','12:05:00',1.03),('14598','2013-11-19','12:10:00',1.5),('14598','2013-11-19','12:15:00',1.92),('14598','2013-11-19','12:20:00',3.03),('14598','2013-11-19','12:25:00',2.32),('14598','2013-11-19','12:30:00',2.17),('14598','2013-11-19','12:35:00',2.74),('14598','2013-11-19','12:40:00',2.48),('14598','2013-11-19','12:50:00',1.19),('14598','2013-11-19','12:55:00',1.87),('14598','2013-11-19','13:00:00',1.57),('14598','2013-11-19','13:05:00',1.92),('14598','2013-11-19','14:55:00',1.22),('14598','2013-11-19','15:00:00',2.26),('14598','2013-11-19','15:05:00',2.78),('14598','2013-11-19','15:10:00',2.23),('14598','2013-11-19','15:15:00',1.8),('14598','2013-11-19','15:20:00',1.66),('14598','2013-11-19','15:25:00',1.45),('14598','2013-11-19','15:30:00',1.33),('14598','2013-11-19','15:35:00',1.22),('14598','2013-11-19','15:40:00',1.1),('14598','2013-11-19','15:45:00',1.02),('14598','2013-11-18','09:05:00',1.04),('14598','2013-11-18','09:10:00',1.09),('14598','2013-11-18','09:15:00',1.25),('14598','2013-11-18','09:20:00',1.58),('14598','2013-11-18','09:25:00',1.3),('14598','2013-11-18','09:30:00',1.03),('14598','2013-11-18','09:40:00',1.03),('14598','2013-11-18','09:45:00',1.17),('14598','2013-11-18','09:50:00',1.2),('14598','2013-11-18','09:55:00',1.54),('14598','2013-11-18','10:00:00',1.44),('14598','2013-11-18','10:05:00',1.37),('14598','2013-11-18','10:10:00',1.29),('14598','2013-11-18','10:15:00',1.26),('14598','2013-11-18','10:20:00',1.16),('14598','2013-11-18','10:25:00',1.12),('14598','2013-11-18','10:30:00',1.14),('14598','2013-11-18','10:35:00',1.09),('14598','2013-11-18','10:40:00',1),('14598','2013-11-18','11:00:00',1.1),('14598','2013-11-18','11:05:00',1.27),('14598','2013-11-18','11:10:00',1.37),('14598','2013-11-18','11:15:00',1.39),('14598','2013-11-18','11:20:00',1.4),('14598','2013-11-18','11:25:00',1.39),('14598','2013-11-18','11:30:00',1.42),('14598','2013-11-18','11:35:00',1.52),('14598','2013-11-18','11:40:00',1.52),('14598','2013-11-18','11:45:00',1.55),('14598','2013-11-18','11:50:00',1.59),('14598','2013-11-18','11:55:00',1.63),('14598','2013-11-18','12:00:00',1.6),('14598','2013-11-18','12:05:00',1.64),('14598','2013-11-18','12:10:00',1.55),('14598','2013-11-18','12:15:00',1.96),('14598','2013-11-18','12:20:00',1.86),('14598','2013-11-18','12:25:00',1.77),('14598','2013-11-18','12:30:00',1.57),('14598','2013-11-18','12:35:00',1.35),('14598','2013-11-18','12:40:00',1.2),('14598','2013-11-18','12:45:00',1.12),('14598','2013-11-18','12:50:00',1.09),('14598','2013-11-18','12:55:00',1.08),('14598','2013-11-18','13:00:00',1.13),('14598','2013-11-18','13:05:00',1.47),('14598','2013-11-18','13:10:00',1.54),('14598','2013-11-18','13:15:00',1.53),('14598','2013-11-18','13:20:00',1.38),('14598','2013-11-18','13:25:00',1.23),('14598','2013-11-18','13:30:00',1.05),('14598','2013-11-18','13:35:00',1.02),('14598','2013-11-18','13:40:00',1.27),('14598','2013-11-18','13:45:00',1.21),('14598','2013-11-18','13:50:00',1.09),('14598','2013-11-18','13:55:00',1.01),('14598','2014-04-19','09:00:00',1.01),('14598','2014-04-19','09:05:00',1.08),('14598','2014-04-19','09:10:00',1.07),('14598','2014-04-19','10:10:00',1.64),('14598','2014-04-19','10:15:00',1.88),('14598','2014-04-19','10:20:00',2.05),('14598','2014-04-19','10:25:00',2.54),('14598','2014-04-19','10:30:00',1.42),('14598','2014-04-19','10:35:00',1.22),('14598','2014-04-19','10:40:00',1.03),('14598','2014-04-19','10:45:00',1.16),('14598','2014-04-19','10:50:00',1.51),('14598','2014-04-19','10:55:00',1.43),('14598','2014-04-19','11:00:00',1.57),('14598','2014-04-19','11:05:00',1.94),('14598','2014-04-19','11:10:00',2.33),('14598','2014-04-19','11:15:00',2.67),('14598','2014-04-19','11:20:00',1.31),('14598','2014-04-19','11:25:00',1.9),('14598','2014-04-19','11:30:00',1.4),('14598','2014-04-19','12:50:00',1.61),('14598','2014-04-19','13:00:00',1.51),('14598','2014-04-19','13:05:00',2.26),('14598','2014-04-19','13:10:00',1.8),('14598','2014-04-19','13:15:00',1.97),('14598','2014-04-19','13:20:00',2.21),('14598','2014-04-19','13:25:00',2.46),('14598','2014-04-19','13:30:00',2.66),('14598','2014-04-19','13:35:00',1.13),('14598','2014-04-19','13:45:00',1.04),('14598','2014-04-19','13:50:00',1.21),('14598','2014-04-19','13:55:00',1.22),('14598','2014-04-19','14:10:00',1.27),('14598','2014-04-19','14:15:00',1.81),('14598','2014-04-19','14:20:00',2.23),('14598','2014-04-19','14:25:00',1.88),('14598','2014-04-19','14:30:00',1.18),('14598','2014-04-19','14:35:00',1.07),('14598','2014-04-19','14:40:00',1.32),('14598','2014-04-19','14:45:00',1.11),('14598','2014-04-19','14:50:00',1.54),('14598','2014-04-19','14:55:00',1.35),('14598','2014-04-19','15:10:00',1.95),('14598','2014-04-19','15:15:00',1.12),('14598','2014-04-19','15:20:00',1.12),('14598','2014-04-19','15:25:00',4.79),('14598','2014-04-19','15:30:00',3.13),('14598','2014-04-19','15:35:00',2.28),('14598','2014-04-19','15:40:00',2.49),('14598','2014-04-19','15:45:00',2.18),('14598','2014-04-19','15:50:00',1.51),('14598','2014-04-19','15:55:00',2.52),('14598','2014-04-19','16:00:00',2.95),('14598','2014-04-19','16:05:00',2.42),('14598','2014-04-19','16:10:00',1.77),('14598','2014-04-19','16:15:00',1.39),('14598','2014-04-19','16:20:00',1.39),('14598','2014-04-19','16:25:00',1.1),('14598','2014-04-19','16:30:00',1.14),('14598','2014-04-19','16:35:00',1.07),('14598','2014-04-19','16:40:00',1.01),('14598','2014-04-19','16:45:00',1.21),('14598','2014-04-19','16:50:00',1.36),('14598','2014-04-19','16:55:00',1.48),('14598','2014-04-19','17:00:00',1.86),('14598','2014-04-19','17:05:00',1.39),('14598','2014-04-19','17:10:00',1.75),('14598','2013-11-17','08:40:00',1.23),('14598','2013-11-17','08:45:00',1.07),('14598','2013-11-17','08:50:00',1.11),('14598','2013-11-17','08:55:00',1.19),('14598','2013-11-17','09:00:00',1.27),('14598','2013-11-17','09:05:00',1.39),('14598','2013-11-17','09:10:00',1.52),('14598','2013-11-17','09:15:00',1.48),('14598','2013-11-17','09:20:00',1.58),('14598','2013-11-17','09:25:00',1.65),('14598','2013-11-17','09:30:00',1.56),('14598','2013-11-17','09:35:00',1.26),('14598','2013-11-17','09:40:00',2.26),('14598','2013-11-17','09:45:00',2.16),('14598','2013-11-17','09:50:00',2.51),('14598','2013-11-17','09:55:00',2.36),('14598','2013-11-17','10:00:00',1.48),('14598','2013-11-17','10:05:00',1.77),('14598','2013-11-17','10:10:00',2.02),('14598','2013-11-17','10:15:00',1.19),('14598','2013-11-17','10:20:00',1.19),('14598','2013-11-17','10:25:00',2.5),('14598','2013-11-17','10:30:00',3.15),('14598','2013-11-17','10:35:00',2.74),('14598','2013-11-17','10:40:00',2.6),('14598','2013-11-17','10:45:00',2.65),('14598','2013-11-17','10:50:00',2.68),('14598','2013-11-17','10:55:00',2.73),('14598','2013-11-17','11:00:00',2.77),('14598','2013-11-17','11:05:00',2.8),('14598','2013-11-17','11:10:00',2.86),('14598','2013-11-17','11:15:00',2.88),('14598','2013-11-17','11:20:00',2.91),('14598','2013-11-17','11:25:00',2.93),('14598','2013-11-17','11:30:00',2.95),('14598','2013-11-17','11:35:00',2.96),('14598','2013-11-17','11:40:00',2.99),('14598','2013-11-17','11:45:00',3),('14598','2013-11-17','11:50:00',3.02),('14598','2013-11-17','11:55:00',3.05),('14598','2013-11-17','12:00:00',3.05),('14598','2013-11-17','12:05:00',3.05),('14598','2013-11-17','12:10:00',3.06),('14598','2013-11-17','12:15:00',3.06),('14598','2013-11-17','12:20:00',3.08),('14598','2013-11-17','12:25:00',3.1),('14598','2013-11-17','12:30:00',3.08),('14598','2013-11-17','12:35:00',3.08),('14598','2013-11-17','12:40:00',3.05),('14598','2013-11-17','12:45:00',3.03),('14598','2013-11-17','12:50:00',3.06),('14598','2013-11-17','12:55:00',3.03),('14598','2013-11-17','13:00:00',2.98),('14598','2013-11-17','13:05:00',2.98),('14598','2013-11-17','13:10:00',2.93),('14598','2013-11-17','13:15:00',2.9),('14598','2013-11-17','13:20:00',2.88),('14598','2013-11-17','13:25:00',2.87),('14598','2013-11-17','13:30:00',2.85),('14598','2013-11-17','13:35:00',2.84),('14598','2013-11-17','13:40:00',2.82),('14598','2013-11-17','13:45:00',2.79),('14598','2013-11-17','13:50:00',2.73),('14598','2013-11-17','13:55:00',2.66),('14598','2013-11-17','14:00:00',2.57),('14598','2013-11-17','14:05:00',2.57),('14598','2013-11-17','14:10:00',2.44),('14598','2013-11-17','14:15:00',1.98),('14598','2013-11-17','14:20:00',2.25),('14598','2013-11-17','14:25:00',2.37),('14598','2013-11-17','14:30:00',2.38),('14598','2013-11-17','14:35:00',2.3),('14598','2013-11-17','14:40:00',2.2),('14598','2013-11-17','14:45:00',2.12),('14598','2013-11-17','14:50:00',2.02),('14598','2013-11-17','14:55:00',1.94),('14598','2013-11-17','15:00:00',1.86),('14598','2013-11-17','15:05:00',1.76),('14598','2013-11-17','15:10:00',1.68),('14598','2013-11-17','15:15:00',1.6),('14598','2013-11-17','15:20:00',1.46),('14598','2013-11-17','15:25:00',1.41),('14598','2013-11-17','15:30:00',1.29),('14598','2013-11-17','15:35:00',1.24),('14598','2013-11-17','15:40:00',1.15),('14598','2013-11-17','15:45:00',1.05),('14598','2013-11-15','10:25:00',1.01),('14598','2013-11-15','10:30:00',1),('14598','2013-11-15','11:45:00',1.13),('14598','2013-11-15','11:50:00',1.73),('14598','2013-11-15','11:55:00',1.91),('14598','2013-11-15','12:00:00',1.72),('14598','2013-11-15','12:05:00',1.64),('14598','2013-11-15','12:10:00',1.58),('14598','2013-11-15','12:15:00',1.3),('14598','2013-11-15','12:20:00',1.13),('14598','2013-11-15','12:25:00',1.03),('14598','2013-11-14','08:40:00',1.13),('14598','2013-11-14','08:45:00',1.16),('14598','2013-11-14','08:50:00',1.27),('14598','2013-11-14','08:55:00',1.36),('14598','2013-11-14','09:00:00',1.45),('14598','2013-11-14','09:05:00',1.52),('14598','2013-11-14','09:10:00',1.47),('14598','2013-11-14','09:20:00',1.02),('14598','2013-11-14','09:25:00',1.38),('14598','2013-11-14','09:30:00',1.3),('14598','2013-11-14','09:35:00',1.61),('14598','2013-11-14','09:40:00',1.9),('14598','2013-11-14','09:45:00',1.05),('14598','2013-11-14','09:50:00',1.66),('14598','2013-11-14','09:55:00',1.99),('14598','2013-11-14','10:00:00',2.06),('14598','2013-11-14','10:05:00',2.14),('14598','2013-11-14','10:10:00',2.28),('14598','2013-11-14','10:15:00',2.52),('14598','2013-11-14','10:20:00',2.58),('14598','2013-11-14','10:25:00',2.6),('14598','2013-11-14','10:30:00',2.63),('14598','2013-11-14','10:35:00',2.64),('14598','2013-11-14','10:40:00',2.58),('14598','2013-11-14','10:45:00',2.5),('14598','2013-11-14','10:50:00',2.56),('14598','2013-11-14','10:55:00',2.91),('14598','2013-11-14','11:00:00',3.02),('14598','2013-11-14','11:05:00',3.2),('14598','2013-11-14','11:10:00',3.41),('14598','2013-11-14','11:15:00',2.89),('14598','2013-11-14','11:20:00',2.27),('14598','2013-11-14','11:25:00',2.14),('14598','2013-11-14','11:30:00',3.41),('14598','2013-11-14','11:35:00',3.53),('14598','2013-11-14','11:40:00',2.57),('14598','2013-11-14','11:45:00',2.51),('14598','2013-11-14','11:50:00',1.69),('14598','2013-11-14','11:55:00',1.53),('14598','2013-11-14','12:00:00',1.68),('14598','2013-11-14','12:05:00',1.48),('14598','2013-11-14','12:10:00',1.81),('14598','2013-11-14','12:15:00',2.19),('14598','2013-11-14','12:20:00',1.96),('14598','2013-11-14','12:25:00',3.24),('14598','2013-11-14','12:30:00',3.64),('14598','2013-11-14','12:35:00',3.27),('14598','2013-11-14','12:40:00',2.71),('14598','2013-11-14','12:45:00',1.79),('14598','2013-11-14','12:50:00',2.48),('14598','2013-11-14','12:55:00',2.05),('14598','2013-11-14','13:00:00',1.84),('14598','2013-11-14','13:05:00',1.13),('14598','2013-11-14','13:25:00',1.36),('14598','2013-11-14','13:40:00',1.41),('14598','2013-11-14','13:45:00',2.86),('14598','2013-11-14','13:50:00',2.58),('14598','2013-11-14','13:55:00',1.41),('14598','2013-11-14','14:00:00',1.93),('14598','2013-11-14','14:05:00',1.08),('14598','2013-11-14','14:10:00',1.02),('14598','2013-11-14','14:15:00',1.7),('14598','2013-11-14','14:20:00',1.28),('14598','2013-11-13','10:10:00',1.12),('14598','2013-11-13','10:15:00',1.06),('14598','2013-11-13','10:20:00',1.37),('14598','2013-11-13','10:25:00',1.23),('14598','2013-11-13','10:30:00',1.61),('14598','2013-11-13','10:35:00',3.54),('14598','2013-11-13','10:40:00',3),('14598','2013-11-13','10:45:00',2.81),('14598','2013-11-13','10:50:00',2.66),('14598','2013-11-13','10:55:00',3.19),('14598','2013-11-13','11:00:00',1.28),('14598','2013-11-13','11:05:00',1.37),('14598','2013-11-13','11:10:00',2.44),('14598','2013-11-13','11:15:00',1.64),('14598','2013-11-13','11:20:00',1.37),('14598','2013-11-13','11:25:00',2.18),('14598','2013-11-13','11:30:00',3.05),('14598','2013-11-13','11:35:00',3.66),('14598','2013-11-13','11:40:00',2.92),('14598','2013-11-13','11:45:00',2.36),('14598','2013-11-13','11:50:00',1.37),('14598','2013-11-13','12:00:00',1.14),('14598','2013-11-13','12:05:00',1.8),('14598','2013-11-13','12:10:00',1.28),('14598','2013-11-13','12:15:00',1.39),('14598','2013-11-13','12:20:00',1.37),('14598','2013-11-13','12:25:00',1.18),('14598','2013-11-13','12:30:00',1.08),('14598','2013-11-13','12:35:00',1.02),('14598','2013-11-13','13:05:00',1.09),('14598','2013-11-13','13:10:00',1.22),('14598','2013-11-13','13:15:00',1.33),('14598','2013-11-13','13:20:00',1.41),('14598','2013-11-13','13:25:00',1.45),('14598','2013-11-13','13:30:00',1.76),('14598','2013-11-13','13:35:00',1.5),('14598','2013-11-13','13:50:00',1.09),('14598','2013-11-13','13:55:00',1.33),('14598','2013-11-13','14:00:00',1.97),('14598','2013-11-13','14:05:00',1.65),('14598','2013-11-13','14:10:00',2.24),('14598','2013-11-13','14:15:00',2.03),('14598','2013-11-13','14:20:00',2.19),('14598','2013-11-13','14:25:00',1.62),('14598','2013-11-13','14:30:00',1.78),('14598','2013-11-13','14:35:00',1.69),('14598','2013-11-13','14:40:00',1.7),('14598','2013-11-13','14:45:00',1.66),('14598','2013-11-13','14:50:00',1.14),('14598','2013-11-13','14:55:00',1.04),('14598','2013-11-13','15:05:00',1.11),('14598','2013-11-12','11:05:00',1.11),('14598','2013-11-12','11:10:00',1.04),('14598','2013-11-12','11:15:00',1.28),('14598','2013-11-12','11:20:00',1.34),('14598','2013-11-12','11:25:00',1.28),('14598','2013-11-12','11:30:00',1.41),('14598','2013-11-12','11:35:00',2.02),('14598','2013-11-12','11:40:00',1.1),('14598','2013-11-12','11:45:00',1.79),('14598','2013-11-12','11:50:00',3.66),('14598','2013-11-12','11:55:00',2.08),('14598','2013-11-12','12:00:00',1.61),('14598','2013-11-12','12:05:00',1.27),('14598','2013-11-12','12:10:00',3.47),('14598','2013-11-12','12:15:00',1.64),('14598','2013-11-12','12:20:00',1.01),('14598','2013-11-12','12:25:00',1.16),('14598','2013-11-12','12:30:00',1.02),('14598','2013-11-12','12:35:00',1.12),('14598','2013-11-12','12:40:00',2.37),('14598','2013-11-12','12:45:00',2.86),('14598','2013-11-12','12:50:00',2.59),('14598','2013-11-12','12:55:00',2.48),('14598','2013-11-12','13:00:00',2.04),('14598','2013-11-12','13:05:00',2.12),('14598','2013-11-12','13:10:00',2.89),('14598','2013-11-12','13:15:00',2.45),('14598','2013-11-12','13:20:00',1.93),('14598','2013-11-12','13:25:00',1.74),('14598','2013-11-12','13:30:00',1.82),('14598','2013-11-12','13:35:00',1.93),('14598','2013-11-12','13:40:00',2.43),('14598','2013-11-12','13:45:00',2.24),('14598','2013-11-12','13:50:00',1.82),('14598','2013-11-12','13:55:00',1.49),('14598','2013-11-12','14:00:00',1.13),('14598','2013-11-12','14:05:00',1.29),('14598','2013-11-12','14:10:00',1.65),('14598','2013-11-12','14:15:00',1.37),('14598','2013-11-12','14:20:00',2.38),('14598','2013-11-12','14:25:00',2.73),('14598','2013-11-12','14:30:00',2.62),('14598','2013-11-12','14:35:00',2.63),('14598','2013-11-12','14:40:00',2.5),('14598','2013-11-12','14:45:00',2.34),('14598','2013-11-12','14:50:00',2.3),('14598','2013-11-12','14:55:00',1.33),('14598','2013-11-11','09:05:00',1.29),('14598','2013-11-11','09:10:00',2.67),('14598','2013-11-11','09:15:00',2.58),('14598','2013-11-11','09:20:00',2.45),('14598','2013-11-11','09:25:00',2.33),('14598','2013-11-11','09:30:00',2.6),('14598','2013-11-11','09:35:00',3.14),('14598','2013-11-11','09:40:00',3.13),('14598','2013-11-11','09:45:00',3.27),('14598','2013-11-11','09:50:00',1.52),('14598','2013-11-11','09:55:00',1.92),('14598','2013-11-11','10:00:00',2.48),('14598','2013-11-11','10:05:00',2.37),('14598','2013-11-11','10:10:00',2.72),('14598','2013-11-11','10:15:00',1.84),('14598','2013-11-11','11:25:00',1.42),('14598','2013-11-11','11:30:00',3.1),('14598','2013-11-11','11:35:00',1.59),('14598','2013-11-11','11:40:00',4.29),('14598','2013-11-11','11:45:00',4),('14598','2013-11-11','11:50:00',2.96),('14598','2013-11-11','11:55:00',1.22),('14598','2013-11-11','12:00:00',1.94),('14598','2013-11-11','12:05:00',4.27),('14598','2013-11-11','12:10:00',4.15),('14598','2013-11-11','12:15:00',3.86),('14598','2013-11-11','12:20:00',3.13),('14598','2013-11-11','12:25:00',2.18),('14598','2013-11-11','13:45:00',1.01),('14598','2013-11-11','13:50:00',1.28),('14598','2013-11-11','14:05:00',2.95),('14598','2013-11-11','14:10:00',1.87),('14598','2013-11-11','15:30:00',1.2),('14598','2013-11-10','08:40:00',1.12),('14598','2013-11-10','08:45:00',1.17),('14598','2013-11-10','08:50:00',1.22),('14598','2013-11-10','09:00:00',1.2),('14598','2013-11-10','09:05:00',1.42),('14598','2013-11-10','09:10:00',1.78),('14598','2013-11-10','09:15:00',1.36),('14598','2013-11-10','09:20:00',1.39),('14598','2013-11-10','09:25:00',1.88),('14598','2013-11-10','09:30:00',2.09),('14598','2013-11-10','09:35:00',2.21),('14598','2013-11-10','09:40:00',2.08),('14598','2013-11-10','09:45:00',1.79),('14598','2013-11-10','09:50:00',2.04),('14598','2013-11-10','09:55:00',2.57),('14598','2013-11-10','10:00:00',2.22),('14598','2013-11-10','10:05:00',2.21),('14598','2013-11-10','10:10:00',2.41),('14598','2013-11-10','10:15:00',2.36),('14598','2013-11-10','10:20:00',2.67),('14598','2013-11-10','10:25:00',2.11),('14598','2013-11-10','10:30:00',1.51),('14598','2013-11-10','10:35:00',2.24),('14598','2013-11-10','10:40:00',1.79),('14598','2013-11-10','10:45:00',1.7),('14598','2013-11-10','10:50:00',1.51),('14598','2013-11-10','10:55:00',3.24),('14598','2013-11-10','11:00:00',1.23),('14598','2013-11-10','11:05:00',1.12),('14598','2013-11-10','11:10:00',1.54),('14598','2013-11-10','11:15:00',1.28),('14598','2013-11-10','11:20:00',1.07),('14598','2013-11-10','11:25:00',2.81),('14598','2013-11-10','11:30:00',3.17),('14598','2013-11-10','11:35:00',1.31),('14598','2013-11-10','11:45:00',3.3),('14598','2013-11-10','11:50:00',3.36),('14598','2013-11-10','11:55:00',3.28),('14598','2013-11-10','12:00:00',3.47),('14598','2013-11-10','12:05:00',3.32),('14598','2013-11-10','12:10:00',3.23),('14598','2013-11-10','12:15:00',3.33),('14598','2013-11-10','12:20:00',3.1),('14598','2013-11-10','12:25:00',1.09),('14598','2013-11-10','12:35:00',1.03),('14598','2013-11-10','12:40:00',1.17),('14598','2013-11-10','12:45:00',1.1),('14598','2013-11-10','12:55:00',1.2),('14598','2013-11-10','13:00:00',3.36),('14598','2013-11-10','13:05:00',1.71),('14598','2013-11-10','13:10:00',2.85),('14598','2013-11-10','13:15:00',2.12),('14598','2013-11-10','14:25:00',1.06),('14598','2013-11-10','14:30:00',1.29),('14598','2013-11-10','14:35:00',1.54),('14598','2013-11-09','08:30:00',1.06),('14598','2013-11-09','08:40:00',1.43),('14598','2013-11-09','08:45:00',1.64),('14598','2013-11-09','08:50:00',1.83),('14598','2013-11-09','08:55:00',1.36),('14598','2013-11-09','09:00:00',2.06),('14598','2013-11-09','09:05:00',2.24),('14598','2013-11-09','09:10:00',1.98),('14598','2013-11-09','09:15:00',1.89),('14598','2013-11-09','09:20:00',1.48),('14598','2013-11-09','09:25:00',2.23),('14598','2013-11-09','09:30:00',2.35),('14598','2013-11-09','09:50:00',1.1),('14598','2013-11-09','10:10:00',2.62),('14598','2013-11-09','10:15:00',2.2),('14598','2013-11-09','10:20:00',1.03),('14598','2013-11-09','10:25:00',1.14),('14598','2013-11-09','10:30:00',2.35),('14598','2013-11-09','10:35:00',1.35),('14598','2013-11-09','10:40:00',1.52),('14598','2013-11-09','10:45:00',1.09),('14598','2013-11-09','10:50:00',2.01),('14598','2013-11-09','10:55:00',1.32),('14598','2013-11-09','11:00:00',1.19),('14598','2013-11-09','11:05:00',1.08),('14598','2013-11-09','11:10:00',3.2),('14598','2013-11-09','11:15:00',3.81),('14598','2013-11-09','11:20:00',3.69),('14598','2013-11-09','11:25:00',3.07),('14598','2013-11-09','11:30:00',1.74),('14598','2013-11-09','11:35:00',1.28),('14598','2013-11-09','11:40:00',2.87),('14598','2013-11-09','11:45:00',1.61),('14598','2013-11-09','11:50:00',1.22),('14598','2013-11-09','11:55:00',2.06),('14598','2013-11-09','12:00:00',1.54),('14598','2013-11-09','12:05:00',1.1),('14598','2013-11-09','12:15:00',1.22),('14598','2013-11-09','12:20:00',1.79),('14598','2013-11-09','12:25:00',2.25),('14598','2013-11-09','12:30:00',2.52),('14598','2013-11-09','12:35:00',3.3),('14598','2013-11-09','12:40:00',1.93),('14598','2013-11-09','12:45:00',4.55),('14598','2013-11-09','12:50:00',4.17),('14598','2013-11-09','12:55:00',3.63),('14598','2013-11-09','13:00:00',3.92),('14598','2013-11-09','13:05:00',3.93),('14598','2013-11-09','13:10:00',3.91),('14598','2013-11-09','13:15:00',3.79),('14598','2013-11-09','13:20:00',3.47),('14598','2013-11-09','13:25:00',3.77),('14598','2013-11-09','13:30:00',2.57),('14598','2013-11-09','13:35:00',1.2),('14598','2013-11-09','13:40:00',1.77),('14598','2013-11-09','13:45:00',2.34),('14598','2013-11-09','13:50:00',1.94),('14598','2013-11-09','13:55:00',2.05),('14598','2013-11-09','14:00:00',1.51),('14598','2013-11-09','14:05:00',3.09),('14598','2013-11-09','14:10:00',2.84),('14598','2013-11-09','14:15:00',1.35),('14598','2013-11-09','14:55:00',2.48),('14598','2013-11-09','15:00:00',2.91),('14598','2013-11-09','15:05:00',2.29),('14598','2013-11-09','15:10:00',1.98),('14598','2013-11-09','15:15:00',1.92),('14598','2013-11-09','15:20:00',1.53),('14598','2013-11-09','15:25:00',1.57),('14598','2013-11-09','15:30:00',1.22),('14598','2013-11-09','15:35:00',1.02),('14598','2013-11-09','15:55:00',1.11),('14598','2013-11-08','08:40:00',1.1),('14598','2013-11-08','08:45:00',1.14),('14598','2013-11-08','08:50:00',1.23),('14598','2013-11-08','08:55:00',1.35),('14598','2013-11-08','09:00:00',1.41),('14598','2013-11-08','09:05:00',1.49),('14598','2013-11-08','09:10:00',1.59),('14598','2013-11-08','09:15:00',1.65),('14598','2013-11-08','09:20:00',1.77),('14598','2013-11-08','09:25:00',1.35),('14598','2013-11-08','09:30:00',1.92),('14598','2013-11-08','09:35:00',1.99),('14598','2013-11-08','09:40:00',2.03),('14598','2013-11-08','09:45:00',2.09),('14598','2013-11-08','09:50:00',2.18),('14598','2013-11-08','09:55:00',2.24),('14598','2013-11-08','10:00:00',2.32),('14598','2013-11-08','10:05:00',2.38),('14598','2013-11-08','10:10:00',2.44),('14598','2013-11-08','10:15:00',2.49),('14598','2013-11-08','10:20:00',2.57),('14598','2013-11-08','10:25:00',2.65),('14598','2013-11-08','10:30:00',2.75),('14598','2013-11-08','10:35:00',2.94),('14598','2013-11-08','10:40:00',2.76),('14598','2013-11-08','10:45:00',1.97),('14598','2013-11-08','10:50:00',2.74),('14598','2013-11-08','10:55:00',1.52),('14598','2013-11-08','11:00:00',1.95),('14598','2013-11-08','11:05:00',1.14),('14598','2013-11-08','11:10:00',3.03),('14598','2013-11-08','11:15:00',3.5),('14598','2013-11-08','11:20:00',2.67),('14598','2013-11-08','11:25:00',3.23),('14598','2013-11-08','11:30:00',3.32),('14598','2013-11-08','11:35:00',3.24),('14598','2013-11-08','11:40:00',3.22),('14598','2013-11-08','11:45:00',3.23),('14598','2013-11-08','11:50:00',3.25),('14598','2013-11-08','11:55:00',3.26),('14598','2013-11-08','12:00:00',3.26),('14598','2013-11-08','12:05:00',3.29),('14598','2013-11-08','12:10:00',3.31),('14598','2013-11-08','12:15:00',3.29),('14598','2013-11-08','12:20:00',3.3),('14598','2013-11-08','12:25:00',3.31),('14598','2013-11-08','12:30:00',3.32),('14598','2013-11-08','12:35:00',3.29),('14598','2013-11-08','12:40:00',3.29),('14598','2013-11-08','12:45:00',3.28),('14598','2013-11-08','12:50:00',3.26),('14598','2013-11-08','12:55:00',3.24),('14598','2013-11-08','13:00:00',3.21),('14598','2013-11-08','13:05:00',3.2),('14598','2013-11-08','13:10:00',3.18),('14598','2013-11-08','13:15:00',3.11),('14598','2013-11-08','13:20:00',3.12),('14598','2013-11-08','13:25:00',3.1),('14598','2013-11-08','13:30:00',3.07),('14598','2013-11-08','13:35:00',3.04),('14598','2013-11-08','13:40:00',2.99),('14598','2013-11-08','13:45:00',2.95),('14598','2013-11-08','13:50:00',2.91),('14598','2013-11-08','13:55:00',2.86),('14598','2013-11-08','14:00:00',2.81),('14598','2013-11-08','14:05:00',2.77),('14598','2013-11-08','14:10:00',2.72),('14598','2013-11-08','14:15:00',2.66),('14598','2013-11-08','14:20:00',2.62),('14598','2013-11-08','14:25:00',2.56),('14598','2013-11-08','14:30:00',2.47),('14598','2013-11-08','14:35:00',2.42),('14598','2013-11-08','14:40:00',2.35),('14598','2013-11-08','14:45:00',2.28),('14598','2013-11-08','14:50:00',2.21),('14598','2013-11-08','14:55:00',2.13),('14598','2013-11-08','15:00:00',2.04),('14598','2013-11-08','15:05:00',1.97),('14598','2013-11-08','15:10:00',1.89),('14598','2013-11-08','15:15:00',1.81),('14598','2013-11-08','15:20:00',1.73),('14598','2013-11-08','15:25:00',1.64),('14598','2013-11-08','15:30:00',1.55),('14598','2013-11-08','15:35:00',1.45),('14598','2013-11-08','15:40:00',1.37),('14598','2013-11-08','15:45:00',1.28),('14598','2013-11-08','15:50:00',1.18),('14598','2013-11-08','15:55:00',1.07),('14598','2014-04-18','08:15:00',1.21),('14598','2014-04-18','08:20:00',1.47),('14598','2014-04-18','08:25:00',1.34),('14598','2014-04-18','08:30:00',1.2),('14598','2014-04-18','08:35:00',1.1),('14598','2014-04-18','09:20:00',2.16),('14598','2014-04-18','09:25:00',2.28),('14598','2014-04-18','09:30:00',1.42),('14598','2014-04-18','09:35:00',1.29),('14598','2014-04-18','09:40:00',2.78),('14598','2014-04-18','09:45:00',2.82),('14598','2014-04-18','09:50:00',3.62),('14598','2014-04-18','09:55:00',1.82),('14598','2014-04-18','10:00:00',1.98),('14598','2014-04-18','10:05:00',2),('14598','2014-04-18','10:10:00',2.97),('14598','2014-04-18','10:15:00',2.32),('14598','2014-04-18','10:20:00',3.38),('14598','2014-04-18','10:25:00',3.85),('14598','2014-04-18','10:30:00',3.47),('14598','2014-04-18','10:35:00',2.36),('14598','2014-04-18','10:40:00',3.09),('14598','2014-04-18','10:45:00',4.16),('14598','2014-04-18','10:50:00',4.27),('14598','2014-04-18','10:55:00',3.28),('14598','2014-04-18','11:00:00',2.72),('14598','2014-04-18','11:05:00',2.13),('14598','2014-04-18','11:10:00',1.79),('14598','2014-04-18','11:15:00',2.23),('14598','2014-04-18','11:20:00',3.56),('14598','2014-04-18','11:25:00',4.94),('14598','2014-04-18','11:30:00',5.35),('14598','2014-04-18','11:35:00',5.32),('14598','2014-04-18','11:40:00',3.88),('14598','2014-04-18','11:45:00',2.75),('14598','2014-04-18','11:50:00',2.95),('14598','2014-04-18','11:55:00',2.65),('14598','2014-04-18','12:00:00',2.59),('14598','2014-04-18','12:05:00',2.8),('14598','2014-04-18','12:10:00',3.62),('14598','2014-04-18','12:15:00',4.19),('14598','2014-04-18','12:20:00',3),('14598','2014-04-18','12:25:00',2.34),('14598','2014-04-18','12:30:00',5.02),('14598','2014-04-18','12:35:00',3.6),('14598','2014-04-18','12:40:00',3.01),('14598','2014-04-18','12:45:00',5.61),('14598','2014-04-18','12:50:00',4.29),('14598','2014-04-18','12:55:00',2.84),('14598','2014-04-18','13:00:00',3.79),('14598','2014-04-18','13:05:00',3),('14598','2014-04-18','13:10:00',2.78),('14598','2014-04-18','13:15:00',3.11),('14598','2014-04-18','13:20:00',3.68),('14598','2014-04-18','13:25:00',4),('14598','2014-04-18','13:30:00',3.87),('14598','2014-04-18','13:35:00',5),('14598','2014-04-18','13:40:00',2.89),('14598','2014-04-18','13:45:00',2.59),('14598','2014-04-18','13:50:00',2.85),('14598','2014-04-18','13:55:00',3.29),('14598','2014-04-18','14:00:00',2.5),('14598','2014-04-18','14:05:00',4.8),('14598','2014-04-18','14:10:00',5.39),('14598','2014-04-18','14:15:00',3.37),('14598','2014-04-18','14:20:00',2.44),('14598','2014-04-18','14:25:00',3.7),('14598','2014-04-18','14:30:00',3.99),('14598','2014-04-18','14:35:00',2.88),('14598','2014-04-18','14:40:00',3.15),('14598','2014-04-18','14:45:00',5.01),('14598','2014-04-18','14:50:00',4.01),('14598','2014-04-18','14:55:00',4.78),('14598','2014-04-18','15:00:00',4.94),('14598','2014-04-18','15:05:00',4.67),('14598','2014-04-18','15:10:00',4.97),('14598','2014-04-18','15:15:00',4.93),('14598','2014-04-18','15:20:00',4.63),('14598','2014-04-18','15:25:00',4.83),('14598','2014-04-18','15:30:00',4.92),('14598','2014-04-18','15:35:00',2.45),('14598','2014-04-18','15:40:00',3.07),('14598','2014-04-18','15:45:00',4.5),('14598','2014-04-18','15:50:00',3.44),('14598','2014-04-18','15:55:00',4.57),('14598','2014-04-18','16:00:00',4.4),('14598','2014-04-18','16:05:00',4.3),('14598','2014-04-18','16:10:00',4.24),('14598','2014-04-18','16:15:00',4.16),('14598','2014-04-18','16:20:00',4.08),('14598','2014-04-18','16:25:00',4.01),('14598','2014-04-18','16:30:00',3.93),('14598','2014-04-18','16:35:00',3.83),('14598','2014-04-18','16:40:00',3.74),('14598','2014-04-18','16:45:00',3.67),('14598','2014-04-18','16:50:00',3.6),('14598','2014-04-18','16:55:00',3.49),('14598','2014-04-18','17:00:00',3.32),('14598','2014-04-18','17:05:00',3.32),('14598','2014-04-18','17:10:00',3.23),('14598','2014-04-18','17:15:00',3.11),('14598','2014-04-18','17:20:00',3.01),('14598','2014-04-18','17:25:00',2.92),('14598','2014-04-18','17:30:00',2.8),('14598','2014-04-18','17:35:00',2.7),('14598','2014-04-18','17:40:00',2.6),('14598','2014-04-18','17:45:00',2.5),('14598','2014-04-18','17:50:00',2.39),('14598','2014-04-18','17:55:00',2.29),('14598','2014-04-18','18:00:00',2.19),('14598','2014-04-18','18:05:00',2.08),('14598','2014-04-18','18:10:00',1.98),('14598','2014-04-18','18:15:00',1.87),('14598','2014-04-18','18:20:00',1.76),('14598','2014-04-18','18:25:00',1.65),('14598','2014-04-18','18:30:00',1.56),('14598','2014-04-18','18:35:00',1.44),('14598','2014-04-18','18:40:00',1.32),('14598','2014-04-18','18:45:00',1.12),('14598','2013-11-07','08:35:00',1.03),('14598','2013-11-07','08:40:00',1.12),('14598','2013-11-07','08:45:00',1.22),('14598','2013-11-07','08:50:00',1.31),('14598','2013-11-07','08:55:00',1.39),('14598','2013-11-07','09:00:00',1.49),('14598','2013-11-07','09:05:00',1.58),('14598','2013-11-07','09:10:00',1.66),('14598','2013-11-07','09:15:00',1.74),('14598','2013-11-07','09:20:00',1.82),('14598','2013-11-07','09:25:00',1.9),('14598','2013-11-07','09:30:00',1.97),('14598','2013-11-07','09:35:00',2.04),('14598','2013-11-07','09:40:00',2.04),('14598','2013-11-07','09:45:00',2.16),('14598','2013-11-07','09:50:00',2.24),('14598','2013-11-07','09:55:00',2.3),('14598','2013-11-07','10:00:00',2.37),('14598','2013-11-07','10:05:00',2.45),('14598','2013-11-07','10:10:00',2.51),('14598','2013-11-07','10:15:00',2.55),('14598','2013-11-07','10:20:00',2.59),('14598','2013-11-07','10:25:00',2.66),('14598','2013-11-07','10:30:00',2.7),('14598','2013-11-07','10:35:00',2.74),('14598','2013-11-07','10:40:00',2.79),('14598','2013-11-07','10:45:00',2.83),('14598','2013-11-07','10:50:00',2.87),('14598','2013-11-07','10:55:00',2.87),('14598','2013-11-07','11:00:00',2.94),('14598','2013-11-07','11:05:00',2.97),('14598','2013-11-07','11:10:00',2.99),('14598','2013-11-07','11:15:00',3.03),('14598','2013-11-07','11:20:00',3.04),('14598','2013-11-07','11:25:00',3.07),('14598','2013-11-07','11:30:00',3.12),('14598','2013-11-07','11:35:00',3.17),('14598','2013-11-07','11:40:00',3.21),('14598','2013-11-07','11:45:00',3.23),('14598','2013-11-07','11:50:00',3.24),('14598','2013-11-07','11:55:00',3.24),('14598','2013-11-07','12:00:00',3.27),('14598','2013-11-07','12:05:00',3.28),('14598','2013-11-07','12:10:00',3.29),('14598','2013-11-07','12:15:00',3.3),('14598','2013-11-07','12:20:00',3.28),('14598','2013-11-07','12:25:00',1.77),('14598','2013-11-07','12:30:00',1.62),('14598','2013-11-07','12:35:00',1.99),('14598','2013-11-07','12:40:00',3.29),('14598','2013-11-07','12:45:00',3.27),('14598','2013-11-07','12:50:00',3.28),('14598','2013-11-07','12:55:00',3.24),('14598','2013-11-07','13:00:00',3.2),('14598','2013-11-07','13:05:00',3.2),('14598','2013-11-07','13:10:00',3.19),('14598','2013-11-07','13:15:00',3.15),('14598','2013-11-07','13:20:00',3.12),('14598','2013-11-07','13:25:00',3.09),('14598','2013-11-07','13:30:00',3.08),('14598','2013-11-07','13:35:00',3.01),('14598','2013-11-07','13:40:00',2.97),('14598','2013-11-07','13:45:00',2.94),('14598','2013-11-07','13:50:00',2.89),('14598','2013-11-07','13:55:00',2.86),('14598','2013-11-07','14:00:00',2.77),('14598','2013-11-07','14:05:00',2.73),('14598','2013-11-07','14:10:00',2.65),('14598','2013-11-07','14:15:00',2.6),('14598','2013-11-07','14:20:00',2.56),('14598','2013-11-07','14:25:00',2.49),('14598','2013-11-07','14:30:00',2.45),('14598','2013-11-07','14:35:00',2.39),('14598','2013-11-07','14:40:00',2.34),('14598','2013-11-07','14:45:00',2.26),('14598','2013-11-07','14:50:00',2.19),('14598','2013-11-07','14:55:00',2.12),('14598','2013-11-07','15:00:00',2.05),('14598','2013-11-07','15:05:00',1.96),('14598','2013-11-07','15:10:00',1.88),('14598','2013-11-07','15:15:00',1.79),('14598','2013-11-07','15:20:00',1.73),('14598','2013-11-07','15:25:00',1.64),('14598','2013-11-07','15:30:00',1.55),('14598','2013-11-07','15:35:00',1.45),('14598','2013-11-07','15:40:00',1.36),('14598','2013-11-07','15:45:00',1.25),('14598','2013-11-07','15:50:00',1.15),('14598','2013-11-07','15:55:00',1.03),('14598','2013-11-06','08:40:00',1.17),('14598','2013-11-06','08:45:00',1.26),('14598','2013-11-06','08:50:00',1.37),('14598','2013-11-06','08:55:00',1.42),('14598','2013-11-06','09:00:00',1.52),('14598','2013-11-06','09:05:00',1.66),('14598','2013-11-06','09:10:00',1.75),('14598','2013-11-06','09:15:00',1.83),('14598','2013-11-06','09:20:00',1.92),('14598','2013-11-06','09:25:00',1.99),('14598','2013-11-06','09:30:00',2.08),('14598','2013-11-06','09:35:00',2.15),('14598','2013-11-06','09:40:00',2.23),('14598','2013-11-06','09:45:00',2.3),('14598','2013-11-06','09:50:00',2.36),('14598','2013-11-06','09:55:00',2.43),('14598','2013-11-06','10:00:00',2.49),('14598','2013-11-06','10:05:00',2.55),('14598','2013-11-06','10:10:00',2.61),('14598','2013-11-06','10:15:00',2.66),('14598','2013-11-06','10:20:00',2.71),('14598','2013-11-06','10:25:00',2.76),('14598','2013-11-06','10:30:00',2.82),('14598','2013-11-06','10:35:00',2.86),('14598','2013-11-06','10:40:00',2.85),('14598','2013-11-06','10:45:00',2.95),('14598','2013-11-06','10:50:00',2.99),('14598','2013-11-06','10:55:00',3.03),('14598','2013-11-06','11:00:00',3.08),('14598','2013-11-06','11:05:00',3.11),('14598','2013-11-06','11:10:00',3.15),('14598','2013-11-06','11:15:00',3.18),('14598','2013-11-06','11:20:00',3.2),('14598','2013-11-06','11:25:00',3.22),('14598','2013-11-06','11:30:00',3.26),('14598','2013-11-06','11:35:00',3.29),('14598','2013-11-06','11:40:00',3.32),('14598','2013-11-06','11:45:00',3.35),('14598','2013-11-06','11:50:00',3.36),('14598','2013-11-06','11:55:00',3.35),('14598','2013-11-06','12:00:00',3.35),('14598','2013-11-06','12:05:00',3.37),('14598','2013-11-06','12:10:00',3.37),('14598','2013-11-06','12:15:00',3.37),('14598','2013-11-06','12:20:00',3.38),('14598','2013-11-06','12:25:00',3.37),('14598','2013-11-06','12:30:00',3.35),('14598','2013-11-06','12:35:00',3.35),('14598','2013-11-06','12:40:00',3.34),('14598','2013-11-06','12:45:00',3.32),('14598','2013-11-06','12:50:00',3.31),('14598','2013-11-06','12:55:00',3.29),('14598','2013-11-06','13:00:00',3.29),('14598','2013-11-06','13:05:00',3.26),('14598','2013-11-06','13:10:00',3.23),('14598','2013-11-06','13:15:00',3.22),('14598','2013-11-06','13:20:00',3.19),('14598','2013-11-06','13:25:00',3.16),('14598','2013-11-06','13:30:00',3.13),('14598','2013-11-06','13:35:00',3.09),('14598','2013-11-06','13:40:00',3.02),('14598','2013-11-06','13:45:00',2.93),('14598','2013-11-06','13:50:00',2.93),('14598','2013-11-06','13:55:00',2.94),('14598','2013-11-06','14:00:00',2.9),('14598','2013-11-06','14:05:00',2.85),('14598','2013-11-06','14:10:00',2.81),('14598','2013-11-06','14:15:00',2.77),('14598','2013-11-06','14:20:00',2.72),('14598','2013-11-06','14:25:00',2.66),('14598','2013-11-06','14:30:00',2.6),('14598','2013-11-06','14:35:00',2.55),('14598','2013-11-06','14:40:00',2.48),('14598','2013-11-06','14:45:00',2.4),('14598','2013-11-06','14:50:00',2.32),('14598','2013-11-06','14:55:00',2.24),('14598','2013-11-06','15:00:00',2.14),('14598','2013-11-06','15:05:00',2.08),('14598','2013-11-06','15:10:00',2),('14598','2013-11-06','15:15:00',1.93),('14598','2013-11-06','15:20:00',1.85),('14598','2013-11-06','15:25:00',1.75),('14598','2013-11-06','15:30:00',1.66),('14598','2013-11-06','15:35:00',1.57),('14598','2013-11-06','15:40:00',1.46),('14598','2013-11-06','15:45:00',1.37),('14598','2013-11-06','15:50:00',1.27),('14598','2013-11-06','15:55:00',1.17),('14598','2013-11-06','16:00:00',1.07),('14598','2013-11-05','10:00:00',1.04),('14598','2013-11-05','10:05:00',1.44),('14598','2013-11-05','10:10:00',1.64),('14598','2013-11-05','10:15:00',1.6),('14598','2013-11-05','10:20:00',1.11),('14598','2013-11-05','10:40:00',1.01),('14598','2013-11-05','10:45:00',1.07),('14598','2013-11-05','10:50:00',1.13),('14598','2013-11-05','10:55:00',1.15),('14598','2013-11-05','11:00:00',1.22),('14598','2013-11-05','11:05:00',1.19),('14598','2013-11-05','11:10:00',1.26),('14598','2013-11-05','11:15:00',1.29),('14598','2013-11-05','11:20:00',1.14),('14598','2013-11-05','11:25:00',1.35),('14598','2013-11-05','11:30:00',1.56),('14598','2013-11-05','11:35:00',1.67),('14598','2013-11-05','11:40:00',1.72),('14598','2013-11-05','11:45:00',1.65),('14598','2013-11-05','11:50:00',1.78),('14598','2013-11-05','11:55:00',2.22),('14598','2013-11-05','12:00:00',1.87),('14598','2013-11-05','12:05:00',1.42),('14598','2013-11-05','12:10:00',1.47),('14598','2013-11-05','12:15:00',1.5),('14598','2013-11-05','12:20:00',1.71),('14598','2013-11-05','12:25:00',1.25),('14598','2013-11-05','12:30:00',1.13),('14598','2013-11-05','12:35:00',1.18),('14598','2013-11-05','12:40:00',1.33),('14598','2013-11-05','12:45:00',1.76),('14598','2013-11-05','12:50:00',1.99),('14598','2013-11-05','12:55:00',1.96),('14598','2013-11-05','13:00:00',1.62),('14598','2013-11-05','13:05:00',1.48),('14598','2013-11-05','13:10:00',1.67),('14598','2013-11-05','13:15:00',1.83),('14598','2013-11-05','13:20:00',1.99),('14598','2013-11-05','13:25:00',1.73),('14598','2013-11-05','13:30:00',2.73),('14598','2013-11-05','13:35:00',3.44),('14598','2013-11-05','13:40:00',2.43),('14598','2013-11-05','13:45:00',1.83),('14598','2013-11-05','13:50:00',1.5),('14598','2013-11-05','13:55:00',1.43),('14598','2013-11-05','14:00:00',1.98),('14598','2013-11-05','14:05:00',1.74),('14598','2013-11-05','14:10:00',2.32),('14598','2013-11-05','14:15:00',2.86),('14598','2013-11-05','14:20:00',2.93),('14598','2013-11-05','14:25:00',3.03),('14598','2013-11-05','14:30:00',2.08),('14598','2013-11-05','14:35:00',1.53),('14598','2013-11-05','14:40:00',1.2),('14598','2013-11-05','14:45:00',1.64),('14598','2013-11-05','14:50:00',1.19),('14598','2013-11-05','14:55:00',2.24),('14598','2013-11-05','15:00:00',2.67),('14598','2013-11-05','15:05:00',2.32),('14598','2013-11-05','15:10:00',2.03),('14598','2013-11-05','15:15:00',1.98),('14598','2013-11-05','15:20:00',1.83),('14598','2013-11-05','15:25:00',1.72),('14598','2013-11-05','15:30:00',1.34),('14598','2013-11-05','15:55:00',1.12),('14598','2013-11-05','16:00:00',1.12),('14598','2013-11-04','08:30:00',1.02),('14598','2013-11-04','09:25:00',1.42),('14598','2013-11-04','09:30:00',2.15),('14598','2013-11-04','09:35:00',2.18),('14598','2013-11-04','09:40:00',1.51),('14598','2013-11-04','09:45:00',1.71),('14598','2013-11-04','09:50:00',2.22),('14598','2013-11-04','09:55:00',1.8),('14598','2013-11-04','10:05:00',2.71),('14598','2013-11-04','10:10:00',2.76),('14598','2013-11-04','10:15:00',2.11),('14598','2013-11-04','10:20:00',2.1),('14598','2013-11-04','10:25:00',1.15),('14598','2013-11-04','10:40:00',1.62),('14598','2013-11-04','10:45:00',2.22),('14598','2013-11-04','10:50:00',2.58),('14598','2013-11-04','10:55:00',3.36),('14598','2013-11-04','11:00:00',3.31),('14598','2013-11-04','11:05:00',1.54),('14598','2013-11-04','11:15:00',1.26),('14598','2013-11-04','11:20:00',2.83),('14598','2013-11-04','11:25:00',2.77),('14598','2013-11-04','11:30:00',1.01),('14598','2013-11-04','11:35:00',1.24),('14598','2013-11-04','12:05:00',3.82),('14598','2013-11-04','12:10:00',3.72),('14598','2013-11-04','12:15:00',3.62),('14598','2013-11-04','12:20:00',3.56),('14598','2013-11-04','12:25:00',3.59),('14598','2013-11-04','12:30:00',3.28),('14598','2013-11-04','12:35:00',2.6),('14598','2013-11-04','12:40:00',3.23),('14598','2013-11-04','12:45:00',3.9),('14598','2013-11-04','12:50:00',3.94),('14598','2013-11-04','12:55:00',3.38),('14598','2013-11-04','13:00:00',3.8),('14598','2013-11-04','13:05:00',3.17),('14598','2013-11-04','13:10:00',2.19),('14598','2013-11-04','13:15:00',2.53),('14598','2013-11-04','13:20:00',2),('14598','2013-11-04','13:25:00',2.91),('14598','2013-11-04','13:30:00',2.55),('14598','2013-11-04','13:40:00',2.41),('14598','2013-11-04','13:45:00',2.54),('14598','2013-11-04','13:50:00',1.55),('14598','2013-11-04','13:55:00',1.82),('14598','2013-11-04','14:20:00',1.26),('14598','2013-11-04','14:25:00',1.45),('14598','2013-11-04','14:30:00',1.82),('14598','2013-11-04','14:35:00',1.1),('14598','2013-11-04','14:40:00',1.32),('14598','2013-11-04','14:50:00',1.14),('14598','2013-11-04','14:55:00',1.67),('14598','2013-11-04','15:00:00',1.3),('14598','2013-11-04','15:05:00',1.16),('14598','2013-11-04','15:10:00',1.3),('14598','2013-11-04','15:15:00',2.19),('14598','2013-11-04','15:20:00',1.88),('14598','2013-11-04','15:25:00',1.76),('14598','2013-11-04','15:30:00',1.74),('14598','2013-11-04','15:35:00',1.54),('14598','2013-11-04','15:40:00',1.44),('14598','2013-11-04','15:45:00',1.36),('14598','2013-11-04','15:50:00',1.18),('14598','2013-11-04','15:55:00',1.01),('14598','2013-11-03','08:30:00',1.09),('14598','2013-11-03','08:35:00',1.06),('14598','2013-11-03','08:45:00',1.03),('14598','2013-11-03','09:05:00',1.69),('14598','2013-11-03','09:25:00',1.1),('14598','2013-11-03','09:30:00',1.85),('14598','2013-11-03','09:35:00',1.75),('14598','2013-11-03','09:40:00',1.91),('14598','2013-11-03','09:45:00',2.14),('14598','2013-11-03','09:50:00',2.26),('14598','2013-11-03','09:55:00',2.33),('14598','2013-11-03','10:00:00',2.4),('14598','2013-11-03','10:05:00',1.8),('14598','2013-11-03','10:10:00',2.92),('14598','2013-11-03','10:15:00',2.69),('14598','2013-11-03','10:20:00',1.37),('14598','2013-11-03','10:30:00',1.66),('14598','2013-11-03','10:35:00',1.23),('14598','2013-11-03','10:40:00',1.35),('14598','2013-11-03','10:45:00',1.86),('14598','2013-11-03','10:50:00',1.87),('14598','2013-11-03','10:55:00',2.33),('14598','2013-11-03','11:05:00',1.75),('14598','2013-11-03','11:10:00',2.77),('14598','2013-11-03','11:25:00',1.82),('14598','2013-11-03','11:30:00',3.79),('14598','2013-11-03','11:35:00',1.69),('14598','2013-11-03','11:40:00',2.07),('14598','2013-11-03','11:45:00',4.19),('14598','2013-11-03','11:50:00',3.04),('14598','2013-11-03','11:55:00',2.58),('14598','2013-11-03','12:00:00',1.22),('14598','2013-11-03','12:05:00',2.64),('14598','2013-11-03','12:10:00',1.77),('14598','2013-11-03','12:25:00',1.65),('14598','2013-11-03','12:30:00',1.63),('14598','2013-11-03','12:35:00',1.32),('14598','2013-11-03','12:40:00',1.21),('14598','2013-11-03','12:45:00',1.38),('14598','2013-11-03','12:50:00',1.37),('14598','2013-11-03','12:55:00',1.67),('14598','2013-11-03','13:00:00',2.48),('14598','2013-11-03','13:05:00',1.16),('14598','2013-11-03','13:15:00',1.13),('14598','2013-11-03','13:20:00',2.08),('14598','2013-11-03','13:25:00',1.92),('14598','2013-11-03','13:30:00',2.77),('14598','2013-11-03','13:35:00',3.77),('14598','2013-11-03','13:40:00',3.2),('14598','2013-11-03','14:10:00',1.26),('14598','2013-11-03','14:15:00',2.66),('14598','2013-11-03','14:20:00',2.53),('14598','2013-11-03','14:25:00',2.63),('14598','2013-11-03','14:30:00',1.56),('14598','2013-11-03','14:35:00',1.08),('14598','2013-11-03','14:40:00',1.56),('14598','2013-11-03','14:50:00',1.12),('14598','2013-11-03','15:00:00',1.25),('14598','2013-11-03','15:05:00',1.8),('14598','2013-11-03','15:10:00',1.73),('14598','2013-11-03','15:15:00',1.32),('14598','2013-11-03','15:20:00',1.19),('14598','2013-11-03','15:25:00',1.69),('14598','2013-11-02','08:15:00',1.09),('14598','2013-11-02','08:20:00',1.23),('14598','2013-11-02','08:25:00',1.32),('14598','2013-11-02','08:30:00',1.37),('14598','2013-11-02','09:05:00',1.07),('14598','2013-11-02','09:20:00',1.77),('14598','2013-11-02','09:25:00',1.69),('14598','2013-11-02','09:30:00',1.63),('14598','2013-11-02','09:35:00',1.17),('14598','2013-11-02','09:40:00',1.16),('14598','2013-11-02','10:15:00',3.4),('14598','2013-11-02','10:20:00',2.56),('14598','2013-11-02','10:25:00',3.36),('14598','2013-11-02','10:30:00',3.13),('14598','2013-11-02','10:35:00',2.95),('14598','2013-11-02','10:40:00',3.13),('14598','2013-11-02','10:45:00',1.54),('14598','2013-11-02','10:55:00',2.74),('14598','2013-11-02','11:00:00',2.17),('14598','2013-11-02','11:05:00',2.94),('14598','2013-11-02','11:10:00',3.22),('14598','2013-11-02','11:15:00',3.17),('14598','2013-11-02','11:20:00',2.56),('14598','2013-11-02','11:25:00',1.28),('14598','2013-11-02','11:50:00',1.58),('14598','2013-11-02','11:55:00',2.38),('14598','2013-11-02','12:00:00',3.58),('14598','2013-11-02','12:05:00',2.78),('14598','2013-11-02','12:10:00',1.02),('14598','2013-11-02','12:15:00',1.81),('14598','2013-11-02','12:20:00',3.72),('14598','2013-11-02','12:25:00',3.81),('14598','2013-11-02','12:30:00',2.96),('14598','2013-11-02','12:35:00',1.16),('14598','2013-11-02','12:55:00',1.12),('14598','2013-11-02','13:00:00',2.49),('14598','2013-11-02','13:05:00',4.09),('14598','2013-11-02','13:10:00',3.56),('14598','2013-11-02','13:15:00',3.29),('14598','2013-11-02','13:20:00',3.45),('14598','2013-11-02','13:25:00',3.22),('14598','2013-11-02','13:30:00',3.15),('14598','2013-11-02','13:35:00',3.1),('14598','2013-11-02','13:40:00',3.07),('14598','2013-11-02','13:45:00',3.06),('14598','2013-11-02','13:50:00',3.01),('14598','2013-11-02','13:55:00',2.94),('14598','2013-11-02','14:00:00',2.92),('14598','2013-11-02','14:05:00',2.86),('14598','2013-11-02','14:10:00',2.76),('14598','2013-11-02','14:15:00',2.75),('14598','2013-11-02','14:20:00',2.71),('14598','2013-11-02','14:25:00',2.66),('14598','2013-11-02','14:30:00',2.59),('14598','2013-11-02','14:35:00',2.53),('14598','2013-11-02','14:40:00',2.42),('14598','2013-11-02','14:45:00',2.37),('14598','2013-11-02','14:50:00',2.21),('14598','2013-11-02','14:55:00',2.13),('14598','2013-11-02','15:05:00',1.56),('14598','2013-11-02','15:10:00',1.97),('14598','2013-11-02','15:15:00',1.87),('14598','2013-11-02','15:20:00',1.48),('14598','2013-11-02','15:25:00',1.52),('14598','2013-11-02','15:30:00',1.49),('14598','2013-11-02','15:35:00',1.4),('14598','2013-11-01','08:35:00',1.06),('14598','2013-11-01','08:40:00',1.23),('14598','2013-11-01','08:45:00',1.32),('14598','2013-11-01','08:50:00',1.41),('14598','2013-11-01','08:55:00',1.49),('14598','2013-11-01','09:00:00',1.58),('14598','2013-11-01','09:05:00',1.65),('14598','2013-11-01','09:10:00',1.76),('14598','2013-11-01','09:15:00',1.83),('14598','2013-11-01','09:20:00',1.91),('14598','2013-11-01','09:25:00',1.99),('14598','2013-11-01','09:30:00',2.07),('14598','2013-11-01','09:35:00',2.15),('14598','2013-11-01','09:40:00',2.23),('14598','2013-11-01','09:45:00',2.33),('14598','2013-11-01','09:50:00',2.4),('14598','2013-11-01','09:55:00',2.48),('14598','2013-11-01','10:00:00',2.57),('14598','2013-11-01','10:05:00',2.66),('14598','2013-11-01','10:10:00',2.72),('14598','2013-11-01','10:15:00',2.77),('14598','2013-11-01','10:20:00',2.83),('14598','2013-11-01','10:25:00',2.83),('14598','2013-11-01','10:30:00',2.78),('14598','2013-11-01','10:35:00',2.69),('14598','2013-11-01','10:40:00',2.77),('14598','2013-11-01','10:45:00',2.95),('14598','2013-11-01','10:50:00',3.11),('14598','2013-11-01','10:55:00',3.14),('14598','2013-11-01','11:00:00',2.85),('14598','2013-11-01','11:05:00',2.58),('14598','2013-11-01','11:10:00',2.01),('14598','2013-11-01','11:15:00',2.56),('14598','2013-11-01','11:20:00',2.48),('14598','2013-11-01','11:25:00',2.17),('14598','2013-11-01','11:30:00',2.91),('14598','2013-11-01','11:35:00',3.13),('14598','2013-11-01','11:40:00',3.08),('14598','2013-11-01','11:45:00',2.85),('14598','2013-11-01','11:50:00',3.27),('14598','2013-11-01','11:55:00',3.54),('14598','2013-11-01','12:00:00',3.53),('14598','2013-11-01','12:05:00',3.45),('14598','2013-11-01','12:10:00',3.46),('14598','2013-11-01','12:15:00',1.87),('14598','2013-11-01','12:20:00',1.59),('14598','2013-11-01','12:25:00',2.99),('14598','2013-11-01','12:30:00',2.83),('14598','2013-11-01','12:35:00',2.69),('14598','2013-11-01','12:40:00',2.44),('14598','2013-11-01','12:45:00',2.18),('14598','2013-11-01','12:50:00',1.78),('14598','2013-11-01','12:55:00',1.77),('14598','2013-11-01','13:00:00',2.09),('14598','2013-11-01','13:05:00',1.5),('14598','2013-11-01','13:10:00',1.01),('14598','2013-11-01','13:55:00',1.17),('14598','2013-11-01','14:00:00',1.64),('14598','2013-11-01','14:05:00',2.68),('14598','2013-11-01','14:10:00',2.62),('14598','2013-11-01','14:15:00',2.31),('14598','2013-11-01','14:20:00',1.66),('14598','2013-11-01','14:25:00',1.02),('14598','2013-11-01','14:55:00',1.15),('14598','2013-11-01','15:00:00',1.7),('14598','2013-11-01','15:05:00',1.56),('14598','2013-11-01','15:10:00',1.54),('14598','2013-11-01','15:15:00',1.52),('14598','2013-11-01','15:20:00',1.31),('14598','2013-11-01','15:25:00',1.09),('14598','2013-11-01','15:45:00',1.04),('14598','2013-11-01','15:50:00',1),('14598','2013-10-31','08:40:00',1.15),('14598','2013-10-31','08:45:00',1.35),('14598','2013-10-31','08:50:00',1.44),('14598','2013-10-31','08:55:00',1.5),('14598','2013-10-31','09:00:00',1.6),('14598','2013-10-31','09:05:00',1.68),('14598','2013-10-31','09:10:00',1.68),('14598','2013-10-31','09:15:00',1.75),('14598','2013-10-31','09:20:00',1.86),('14598','2013-10-31','09:25:00',1.92),('14598','2013-10-31','09:30:00',1.48),('14598','2013-10-31','09:35:00',1.8),('14598','2013-10-31','09:40:00',1.93),('14598','2013-10-31','09:45:00',2.12),('14598','2013-10-31','09:50:00',2.33),('14598','2013-10-31','09:55:00',2.46),('14598','2013-10-31','10:00:00',2.52),('14598','2013-10-31','10:05:00',2.55),('14598','2013-10-31','10:10:00',2.6),('14598','2013-10-31','10:15:00',2.66),('14598','2013-10-31','10:20:00',2.73),('14598','2013-10-31','10:25:00',2.8),('14598','2013-10-31','10:30:00',2.87),('14598','2013-10-31','10:35:00',2.89),('14598','2013-10-31','10:40:00',2.92),('14598','2013-10-31','10:45:00',2.96),('14598','2013-10-31','10:50:00',3),('14598','2013-10-31','10:55:00',3.02),('14598','2013-10-31','11:00:00',3),('14598','2013-10-31','11:05:00',3),('14598','2013-10-31','11:10:00',2.95),('14598','2013-10-31','11:15:00',3),('14598','2013-10-31','11:20:00',2.94),('14598','2013-10-31','11:25:00',2.88),('14598','2013-10-31','11:30:00',2.96),('14598','2013-10-31','11:35:00',3.08),('14598','2013-10-31','11:40:00',3.21),('14598','2013-10-31','11:45:00',3.22),('14598','2013-10-31','11:50:00',3.29),('14598','2013-10-31','11:55:00',3.38),('14598','2013-10-31','12:00:00',3.4),('14598','2013-10-31','12:05:00',3.39),('14598','2013-10-31','12:10:00',3.41),('14598','2013-10-31','12:15:00',3.45),('14598','2013-10-31','12:20:00',3.36),('14598','2013-10-31','12:25:00',3.39),('14598','2013-10-31','12:30:00',3.36),('14598','2013-10-31','12:35:00',3.3),('14598','2013-10-31','12:40:00',3.3),('14598','2013-10-31','12:45:00',3.27),('14598','2013-10-31','12:50:00',3.24),('14598','2013-10-31','12:55:00',3.2),('14598','2013-10-31','13:00:00',3.18),('14598','2013-10-31','13:05:00',3.18),('14598','2013-10-31','13:10:00',3.03),('14598','2013-10-31','13:15:00',3.07),('14598','2013-10-31','13:20:00',2.97),('14598','2013-10-31','13:25:00',2.43),('14598','2013-10-31','13:30:00',2.5),('14598','2013-10-31','13:35:00',2.89),('14598','2013-10-31','13:40:00',2.99),('14598','2013-10-31','13:45:00',2.83),('14598','2013-10-31','13:50:00',2.84),('14598','2013-10-31','13:55:00',2.84),('14598','2013-10-31','14:00:00',2.72),('14598','2013-10-31','14:05:00',2.73),('14598','2013-10-31','14:10:00',2.68),('14598','2013-10-31','14:15:00',2.63),('14598','2013-10-31','14:20:00',2.54),('14598','2013-10-31','14:25:00',2.4),('14598','2013-10-31','14:30:00',2.32),('14598','2013-10-31','14:35:00',2.22),('14598','2013-10-31','14:40:00',2.06),('14598','2013-10-31','14:45:00',1.78),('14598','2013-10-31','14:50:00',1.69),('14598','2013-10-31','14:55:00',1.67),('14598','2013-10-31','15:00:00',1.62),('14598','2013-10-31','15:05:00',1.56),('14598','2013-10-31','15:10:00',1.54),('14598','2013-10-31','15:15:00',1.58),('14598','2013-10-31','15:20:00',1.33),('14598','2013-10-31','15:25:00',1.23),('14598','2013-10-31','15:30:00',1.12),('14598','2013-10-31','15:35:00',1.11),('14598','2013-10-31','15:40:00',1.08),('14598','2013-10-30','08:50:00',1.04),('14598','2013-10-30','08:55:00',1.33),('14598','2013-10-30','09:10:00',1.02),('14598','2013-10-30','09:15:00',1.04),('14598','2013-10-30','09:20:00',1.27),('14598','2013-10-30','09:25:00',1.28),('14598','2013-10-30','09:30:00',1.27),('14598','2013-10-30','09:35:00',1.13),('14598','2013-10-30','09:40:00',1.44),('14598','2013-10-30','09:45:00',1.5),('14598','2013-10-30','09:50:00',1.51),('14598','2013-10-30','09:55:00',1.55),('14598','2013-10-30','10:00:00',1.96),('14598','2013-10-30','10:05:00',1.47),('14598','2013-10-30','10:10:00',2.45),('14598','2013-10-30','10:15:00',2.77),('14598','2013-10-30','10:20:00',2.84),('14598','2013-10-30','10:25:00',2.73),('14598','2013-10-30','10:30:00',2.69),('14598','2013-10-30','10:35:00',2.91),('14598','2013-10-30','10:40:00',2.81),('14598','2013-10-30','10:45:00',2.81),('14598','2013-10-30','10:50:00',2.64),('14598','2013-10-30','10:55:00',2.82),('14598','2013-10-30','11:00:00',3.02),('14598','2013-10-30','11:05:00',3.05),('14598','2013-10-30','11:10:00',3.08),('14598','2013-10-30','11:15:00',3.06),('14598','2013-10-30','11:20:00',3.17),('14598','2013-10-30','11:25:00',3.2),('14598','2013-10-30','11:30:00',1.65),('14598','2013-10-30','11:35:00',1.82),('14598','2013-10-30','11:40:00',2.72),('14598','2013-10-30','11:45:00',3.2),('14598','2013-10-30','11:50:00',3.43),('14598','2013-10-30','11:55:00',3.48),('14598','2013-10-30','12:00:00',3.56),('14598','2013-10-30','12:05:00',3.39),('14598','2013-10-30','12:10:00',3.37),('14598','2013-10-30','12:15:00',3.21),('14598','2013-10-30','12:20:00',2.95),('14598','2013-10-30','12:25:00',3.13),('14598','2013-10-30','12:30:00',3.09),('14598','2013-10-30','12:35:00',3.41),('14598','2013-10-30','12:40:00',3.46),('14598','2013-10-30','12:45:00',3.12),('14598','2013-10-30','12:50:00',3.06),('14598','2013-10-30','12:55:00',3.3),('14598','2013-10-30','13:00:00',3.43),('14598','2013-10-30','13:05:00',3.28),('14598','2013-10-30','13:10:00',3.3),('14598','2013-10-30','13:15:00',3.24),('14598','2013-10-30','13:20:00',3.25),('14598','2013-10-30','13:25:00',3.18),('14598','2013-10-30','13:30:00',3.17),('14598','2013-10-30','13:35:00',3.14),('14598','2013-10-30','13:40:00',3.12),('14598','2013-10-30','13:45:00',3.07),('14598','2013-10-30','13:50:00',2.92),('14598','2013-10-30','13:55:00',3),('14598','2013-10-30','14:00:00',2.94),('14598','2013-10-30','14:05:00',2.87),('14598','2013-10-30','14:10:00',2.58),('14598','2013-10-30','14:15:00',2.44),('14598','2013-10-30','14:20:00',2.6),('14598','2013-10-30','14:25:00',2.65),('14598','2013-10-30','14:30:00',2.59),('14598','2013-10-30','14:35:00',2.51),('14598','2013-10-30','14:40:00',2.47),('14598','2013-10-30','14:45:00',2.19),('14598','2013-10-30','14:50:00',2.12),('14598','2013-10-30','14:55:00',2.14),('14598','2013-10-30','15:00:00',1.87),('14598','2013-10-30','15:05:00',2.02),('14598','2013-10-30','15:10:00',2.05),('14598','2013-10-30','15:15:00',2.02),('14598','2013-10-30','15:20:00',1.92),('14598','2013-10-30','15:25:00',1.72),('14598','2013-10-30','15:30:00',1.29),('14598','2013-10-30','15:35:00',1.5),('14598','2013-10-30','15:40:00',1.29),('14598','2013-10-29','08:30:00',1.08),('14598','2013-10-29','08:35:00',1.17),('14598','2013-10-29','08:40:00',1.28),('14598','2013-10-29','08:45:00',1.36),('14598','2013-10-29','08:50:00',1.43),('14598','2013-10-29','08:55:00',1.48),('14598','2013-10-29','09:00:00',1.54),('14598','2013-10-29','09:05:00',1.61),('14598','2013-10-29','09:10:00',1.68),('14598','2013-10-29','09:15:00',1.76),('14598','2013-10-29','09:20:00',1.87),('14598','2013-10-29','09:25:00',1.89),('14598','2013-10-29','09:30:00',1.96),('14598','2013-10-29','09:35:00',1.93),('14598','2013-10-29','09:40:00',1.91),('14598','2013-10-29','09:45:00',2.25),('14598','2013-10-29','09:50:00',2.32),('14598','2013-10-29','09:55:00',2.39),('14598','2013-10-29','10:00:00',2.42),('14598','2013-10-29','10:05:00',2.51),('14598','2013-10-29','10:10:00',2.58),('14598','2013-10-29','10:15:00',2.67),('14598','2013-10-29','10:20:00',2.69),('14598','2013-10-29','10:25:00',2.64),('14598','2013-10-29','10:30:00',2.78),('14598','2013-10-29','10:35:00',2.84),('14598','2013-10-29','10:40:00',2.18),('14598','2013-10-29','10:45:00',1.19),('14598','2013-10-29','10:50:00',1.01),('14598','2013-10-29','10:55:00',1.22),('14598','2013-10-29','11:00:00',1.31),('14598','2013-10-29','11:05:00',1.43),('14598','2013-10-29','11:10:00',1.03),('14598','2013-10-29','11:20:00',2.27),('14598','2013-10-29','11:25:00',3.03),('14598','2013-10-29','11:30:00',3.86),('14598','2013-10-29','11:35:00',3.77),('14598','2013-10-29','11:40:00',3.69),('14598','2013-10-29','11:45:00',3.52),('14598','2013-10-29','11:50:00',3.45),('14598','2013-10-29','11:55:00',3.42),('14598','2013-10-29','12:00:00',3.4),('14598','2013-10-29','12:05:00',3.42),('14598','2013-10-29','12:10:00',3.43),('14598','2013-10-29','12:15:00',3.42),('14598','2013-10-29','12:20:00',3.42),('14598','2013-10-29','12:25:00',3.42),('14598','2013-10-29','12:30:00',3.4),('14598','2013-10-29','12:35:00',3.4),('14598','2013-10-29','12:40:00',3.4),('14598','2013-10-29','12:45:00',3.38),('14598','2013-10-29','12:50:00',3.36),('14598','2013-10-29','12:55:00',3.35),('14598','2013-10-29','13:00:00',3.33),('14598','2013-10-29','13:05:00',3.31),('14598','2013-10-29','13:10:00',3.28),('14598','2013-10-29','13:15:00',3.27),('14598','2013-10-29','13:20:00',3.23),('14598','2013-10-29','13:25:00',3.21),('14598','2013-10-29','13:30:00',3.17),('14598','2013-10-29','13:35:00',3.15),('14598','2013-10-29','13:40:00',3.12),('14598','2013-10-29','13:45:00',3.08),('14598','2013-10-29','13:50:00',2.97),('14598','2013-10-29','13:55:00',2.98),('14598','2013-10-29','14:00:00',2.93),('14598','2013-10-29','14:05:00',2.87),('14598','2013-10-29','14:10:00',2.83),('14598','2013-10-29','14:15:00',2.78),('14598','2013-10-29','14:20:00',2.72),('14598','2013-10-29','14:25:00',2.67),('14598','2013-10-29','14:30:00',2.59),('14598','2013-10-29','14:35:00',2.53),('14598','2013-10-29','14:40:00',2.46),('14598','2013-10-29','14:45:00',2.39),('14598','2013-10-29','14:50:00',2.32),('14598','2013-10-29','14:55:00',2.25),('14598','2013-10-29','15:00:00',2.15),('14598','2013-10-29','15:05:00',2.05),('14598','2013-10-29','15:10:00',1.99),('14598','2013-10-29','15:15:00',1.89),('14598','2013-10-29','15:20:00',1.82),('14598','2013-10-29','15:25:00',1.74),('14598','2013-10-29','15:30:00',1.64),('14598','2013-10-29','15:35:00',1.55),('14598','2013-10-29','15:40:00',1.46),('14598','2013-10-29','15:45:00',1.37),('14598','2013-10-29','15:50:00',1.27),('14598','2013-10-29','15:55:00',1.17),('14598','2013-10-29','16:00:00',1.07),('14598','2014-04-17','08:25:00',1.12),('14598','2014-04-17','08:30:00',1.25),('14598','2014-04-17','08:35:00',1.35),('14598','2014-04-17','08:40:00',1.46),('14598','2014-04-17','08:45:00',1.57),('14598','2014-04-17','08:50:00',1.68),('14598','2014-04-17','08:55:00',1.78),('14598','2014-04-17','09:00:00',1.91),('14598','2014-04-17','09:05:00',2.08),('14598','2014-04-17','09:10:00',2.15),('14598','2014-04-17','09:15:00',2.33),('14598','2014-04-17','09:20:00',2.44),('14598','2014-04-17','09:25:00',2.55),('14598','2014-04-17','09:30:00',2.63),('14598','2014-04-17','09:35:00',2.76),('14598','2014-04-17','09:40:00',2.84),('14598','2014-04-17','09:45:00',2.96),('14598','2014-04-17','09:50:00',3.05),('14598','2014-04-17','09:55:00',3.15),('14598','2014-04-17','10:00:00',3.24),('14598','2014-04-17','10:05:00',3.35),('14598','2014-04-17','10:10:00',3.46),('14598','2014-04-17','10:15:00',3.16),('14598','2014-04-17','10:20:00',3.19),('14598','2014-04-17','10:25:00',3.13),('14598','2014-04-17','10:30:00',3.48),('14598','2014-04-17','10:35:00',3.11),('14598','2014-04-17','10:40:00',2.66),('14598','2014-04-17','10:45:00',3.18),('14598','2014-04-17','10:50:00',4.37),('14598','2014-04-17','10:55:00',3.87),('14598','2014-04-17','11:00:00',2.74),('14598','2014-04-17','11:05:00',3.47),('14598','2014-04-17','11:10:00',4.42),('14598','2014-04-17','11:15:00',4.41),('14598','2014-04-17','11:20:00',4.23),('14598','2014-04-17','11:25:00',5.11),('14598','2014-04-17','11:30:00',4.48),('14598','2014-04-17','11:35:00',3.07),('14598','2014-04-17','11:40:00',2.55),('14598','2014-04-17','11:45:00',5.18),('14598','2014-04-17','11:50:00',4.36),('14598','2014-04-17','11:55:00',4.92),('14598','2014-04-17','12:00:00',5.09),('14598','2014-04-17','12:05:00',5.1),('14598','2014-04-17','12:10:00',5.18),('14598','2014-04-17','12:15:00',4.75),('14598','2014-04-17','12:20:00',4.81),('14598','2014-04-17','12:25:00',4.86),('14598','2014-04-17','12:30:00',5.11),('14598','2014-04-17','12:35:00',4.51),('14598','2014-04-17','12:40:00',5.03),('14598','2014-04-17','12:45:00',5.04),('14598','2014-04-17','12:50:00',5.08),('14598','2014-04-17','12:55:00',5.1),('14598','2014-04-17','13:00:00',5.1),('14598','2014-04-17','13:05:00',5.07),('14598','2014-04-17','13:10:00',5.06),('14598','2014-04-17','13:15:00',5.14),('14598','2014-04-17','13:20:00',5.2),('14598','2014-04-17','13:25:00',5.24),('14598','2014-04-17','13:30:00',5.14),('14598','2014-04-17','13:35:00',5.29),('14598','2014-04-17','13:40:00',5.49),('14598','2014-04-17','13:45:00',5.87),('14598','2014-04-17','13:50:00',3.59),('14598','2014-04-17','13:55:00',1.32),('14598','2014-04-17','14:15:00',1.16),('14598','2014-04-17','14:20:00',1.46),('14598','2014-04-17','14:25:00',1.69),('14598','2014-04-17','14:30:00',1.91),('14598','2014-04-17','14:35:00',4.23),('14598','2014-04-17','14:40:00',3.3),('14598','2014-04-17','14:45:00',2.18),('14598','2014-04-17','14:50:00',1.87),('14598','2014-04-17','14:55:00',1.71),('14598','2014-04-17','15:00:00',4.8),('14598','2014-04-17','15:05:00',5.32),('14598','2014-04-17','15:10:00',5.24),('14598','2014-04-17','15:15:00',4.47),('14598','2014-04-17','15:20:00',2.7),('14598','2014-04-17','15:25:00',3.88),('14598','2014-04-17','15:30:00',3.75),('14598','2014-04-17','15:35:00',3.07),('14598','2014-04-17','15:40:00',4.84),('14598','2014-04-17','15:45:00',3.14),('14598','2014-04-17','15:50:00',2.75),('14598','2014-04-17','15:55:00',2.81),('14598','2014-04-17','16:00:00',1.77),('14598','2014-04-17','16:05:00',2.1),('14598','2014-04-17','16:10:00',5.42),('14598','2014-04-17','16:15:00',2.72),('14598','2014-04-17','16:20:00',3.12),('14598','2014-04-17','16:25:00',2.67),('14598','2014-04-17','16:30:00',2.56),('14598','2014-04-17','16:35:00',1.54),('14598','2014-04-17','16:40:00',1.61),('14598','2014-04-17','16:45:00',1.74),('14598','2014-04-17','16:50:00',2.52),('14598','2014-04-17','16:55:00',2.63),('14598','2014-04-17','17:00:00',1.47),('14598','2014-04-17','17:05:00',1.02),('14598','2013-10-28','08:25:00',1.04),('14598','2013-10-28','08:30:00',1.12),('14598','2013-10-28','08:35:00',1.22),('14598','2013-10-28','08:40:00',1.34),('14598','2013-10-28','08:45:00',1.44),('14598','2013-10-28','08:50:00',1.06),('14598','2013-10-28','08:55:00',1.25),('14598','2013-10-28','09:00:00',1.37),('14598','2013-10-28','09:05:00',1.27),('14598','2013-10-28','09:10:00',1.1),('14598','2013-10-28','09:55:00',1.02),('14598','2013-10-28','10:00:00',1.1),('14598','2013-10-28','10:05:00',1.16),('14598','2013-10-28','10:10:00',1.87),('14598','2013-10-28','10:15:00',1.55),('14598','2013-10-28','10:20:00',1.52),('14598','2013-10-28','10:25:00',1.61),('14598','2013-10-28','10:30:00',1.7),('14598','2013-10-28','10:35:00',2.65),('14598','2013-10-28','10:40:00',3.03),('14598','2013-10-28','10:45:00',3.03),('14598','2013-10-28','10:50:00',3.06),('14598','2013-10-28','10:55:00',3.07),('14598','2013-10-28','11:00:00',3.08),('14598','2013-10-28','11:05:00',3.13),('14598','2013-10-28','11:10:00',3.24),('14598','2013-10-28','11:15:00',3.29),('14598','2013-10-28','11:20:00',3.41),('14598','2013-10-28','11:25:00',3.68),('14598','2013-10-28','11:30:00',2.45),('14598','2013-10-28','11:35:00',2.15),('14598','2013-10-28','11:40:00',2.04),('14598','2013-10-28','11:45:00',2.44),('14598','2013-10-28','11:50:00',2.41),('14598','2013-10-28','11:55:00',2.41),('14598','2013-10-28','12:00:00',2.23),('14598','2013-10-28','12:05:00',3.36),('14598','2013-10-28','12:10:00',3.59),('14598','2013-10-28','12:15:00',3.49),('14598','2013-10-28','12:20:00',3.42),('14598','2013-10-28','12:25:00',3.46),('14598','2013-10-28','12:30:00',3.47),('14598','2013-10-28','12:35:00',3.43),('14598','2013-10-28','12:40:00',3.46),('14598','2013-10-28','12:45:00',3.47),('14598','2013-10-28','12:50:00',3.24),('14598','2013-10-28','12:55:00',2.95),('14598','2013-10-28','13:00:00',3.16),('14598','2013-10-28','13:05:00',3.42),('14598','2013-10-28','13:10:00',3.36),('14598','2013-10-28','13:15:00',3.36),('14598','2013-10-28','13:20:00',3.31),('14598','2013-10-28','13:25:00',3.07),('14598','2013-10-28','13:30:00',3.32),('14598','2013-10-28','13:35:00',3.32),('14598','2013-10-28','13:40:00',3.39),('14598','2013-10-28','13:45:00',3.46),('14598','2013-10-28','13:50:00',3.1),('14598','2013-10-28','13:55:00',3.11),('14598','2013-10-28','14:00:00',3.29),('14598','2013-10-28','14:05:00',3.43),('14598','2013-10-28','14:10:00',3.72),('14598','2013-10-28','14:15:00',3.39),('14598','2013-10-28','14:20:00',2),('14598','2013-10-28','14:25:00',3.16),('14598','2013-10-28','14:30:00',2.55),('14598','2013-10-28','14:35:00',2.25),('14598','2013-10-28','14:40:00',2.08),('14598','2013-10-28','14:45:00',1.39),('14598','2013-10-28','14:50:00',1.5),('14598','2013-10-28','14:55:00',1.36),('14598','2013-10-28','15:00:00',1.74),('14598','2013-10-28','15:05:00',2.11),('14598','2013-10-28','15:10:00',2.03),('14598','2013-10-28','15:15:00',1.88),('14598','2013-10-28','15:20:00',1.79),('14598','2013-10-28','15:25:00',1.76),('14598','2013-10-28','15:30:00',1.68),('14598','2013-10-28','15:35:00',1.6),('14598','2013-10-28','15:40:00',1.49),('14598','2013-10-28','15:45:00',1.4),('14598','2013-10-28','15:50:00',1.29),('14598','2013-10-28','15:55:00',1.19),('14598','2013-10-28','16:00:00',1.09),('14598','2013-10-27','09:15:00',1.02),('14598','2013-10-27','09:20:00',1.13),('14598','2013-10-27','09:25:00',1.09),('14598','2013-10-27','09:30:00',1.07),('14598','2013-10-27','09:35:00',1.16),('14598','2013-10-27','09:40:00',1.11),('14598','2013-10-27','09:45:00',1.07),('14598','2013-10-27','09:55:00',1.09),('14598','2013-10-27','10:00:00',1.38),('14598','2013-10-27','10:05:00',1.77),('14598','2013-10-27','10:10:00',1.7),('14598','2013-10-27','10:15:00',1.66),('14598','2013-10-27','10:20:00',1.68),('14598','2013-10-27','10:25:00',1.74),('14598','2013-10-27','10:30:00',1.5),('14598','2013-10-27','10:35:00',1.39),('14598','2013-10-27','10:40:00',1.51),('14598','2013-10-27','10:45:00',1.82),('14598','2013-10-27','10:50:00',2.11),('14598','2013-10-27','10:55:00',2.23),('14598','2013-10-27','11:00:00',1.75),('14598','2013-10-27','11:05:00',1.81),('14598','2013-10-27','11:10:00',2.18),('14598','2013-10-27','11:15:00',1.82),('14598','2013-10-27','11:20:00',1.6),('14598','2013-10-27','11:25:00',1.45),('14598','2013-10-27','11:30:00',1.47),('14598','2013-10-27','11:35:00',1.63),('14598','2013-10-27','11:40:00',1.89),('14598','2013-10-27','11:45:00',1.95),('14598','2013-10-27','11:50:00',1.99),('14598','2013-10-27','11:55:00',2.72),('14598','2013-10-27','12:00:00',3.72),('14598','2013-10-27','12:05:00',2.97),('14598','2013-10-27','12:10:00',2.81),('14598','2013-10-27','12:15:00',3.38),('14598','2013-10-27','12:20:00',3.38),('14598','2013-10-27','12:25:00',3.38),('14598','2013-10-27','12:30:00',3.33),('14598','2013-10-27','12:35:00',3.27),('14598','2013-10-27','12:40:00',3.12),('14598','2013-10-27','12:45:00',2.59),('14598','2013-10-27','12:50:00',2.15),('14598','2013-10-27','12:55:00',1.87),('14598','2013-10-27','13:00:00',2.98),('14598','2013-10-27','13:05:00',2.86),('14598','2013-10-27','13:10:00',3.59),('14598','2013-10-27','13:15:00',3.48),('14598','2013-10-27','13:20:00',3.15),('14598','2013-10-27','13:25:00',3.16),('14598','2013-10-27','13:30:00',3.2),('14598','2013-10-27','13:35:00',3.06),('14598','2013-10-27','13:40:00',1.9),('14598','2013-10-27','13:45:00',2.36),('14598','2013-10-27','13:50:00',1.18),('14598','2013-10-27','13:55:00',1.13),('14598','2013-10-27','14:20:00',2.81),('14598','2013-10-27','14:25:00',2.81),('14598','2013-10-27','14:30:00',2.67),('14598','2013-10-27','14:35:00',2.61),('14598','2013-10-27','14:40:00',2.47),('14598','2013-10-27','14:45:00',2.38),('14598','2013-10-27','14:50:00',2.17),('14598','2013-10-27','14:55:00',1.92),('14598','2013-10-27','15:00:00',1.64),('14598','2013-10-27','15:05:00',2.1),('14598','2013-10-27','15:10:00',2.13),('14598','2013-10-27','15:15:00',1.98),('14598','2013-10-27','15:20:00',1.84),('14598','2013-10-27','15:25:00',1.74),('14598','2013-10-27','15:30:00',1.55),('14598','2013-10-27','15:35:00',1.56),('14598','2013-10-27','15:40:00',1.44),('14598','2013-10-27','15:45:00',1.33),('14598','2013-10-27','15:50:00',1.24),('14598','2013-10-27','15:55:00',1.12),('14598','2013-10-27','16:00:00',1.06),('14598','2013-10-26','09:25:00',1.06),('14598','2013-10-26','09:30:00',1.18),('14598','2013-10-26','09:35:00',1.28),('14598','2013-10-26','09:40:00',1.38),('14598','2013-10-26','09:45:00',1.44),('14598','2013-10-26','09:50:00',1.5),('14598','2013-10-26','09:55:00',1.59),('14598','2013-10-26','10:00:00',1.69),('14598','2013-10-26','10:05:00',1.77),('14598','2013-10-26','10:10:00',1.87),('14598','2013-10-26','10:15:00',1.94),('14598','2013-10-26','10:20:00',1.97),('14598','2013-10-26','10:25:00',2),('14598','2013-10-26','10:30:00',1.99),('14598','2013-10-26','10:35:00',1.98),('14598','2013-10-26','10:40:00',2.1),('14598','2013-10-26','10:45:00',2.46),('14598','2013-10-26','10:50:00',2.27),('14598','2013-10-26','10:55:00',1.92),('14598','2013-10-26','11:00:00',1.79),('14598','2013-10-26','11:05:00',1.84),('14598','2013-10-26','11:10:00',2.91),('14598','2013-10-26','11:15:00',2.59),('14598','2013-10-26','11:20:00',2.73),('14598','2013-10-26','11:25:00',2.84),('14598','2013-10-26','11:30:00',2.86),('14598','2013-10-26','11:35:00',2.89),('14598','2013-10-26','11:40:00',2.96),('14598','2013-10-26','11:45:00',2.99),('14598','2013-10-26','11:50:00',3.04),('14598','2013-10-26','11:55:00',3.01),('14598','2013-10-26','12:00:00',3),('14598','2013-10-26','12:05:00',3.07),('14598','2013-10-26','12:10:00',2.95),('14598','2013-10-26','12:15:00',3.02),('14598','2013-10-26','12:20:00',3.1),('14598','2013-10-26','12:25:00',3.16),('14598','2013-10-26','12:30:00',3.31),('14598','2013-10-26','12:35:00',3.32),('14598','2013-10-26','12:40:00',3.32),('14598','2013-10-26','12:45:00',3.31),('14598','2013-10-26','12:50:00',3.31),('14598','2013-10-26','12:55:00',3.31),('14598','2013-10-26','13:00:00',3.33),('14598','2013-10-26','13:05:00',3.38),('14598','2013-10-26','13:10:00',3.41),('14598','2013-10-26','13:15:00',3.41),('14598','2013-10-26','13:20:00',3.41),('14598','2013-10-26','13:25:00',3.44),('14598','2013-10-26','13:30:00',3.4),('14598','2013-10-26','13:35:00',3.41),('14598','2013-10-26','13:40:00',3.42),('14598','2013-10-26','13:45:00',3.43),('14598','2013-10-26','13:50:00',3.41),('14598','2013-10-26','13:55:00',3.41),('14598','2013-10-26','14:00:00',3.38),('14598','2013-10-26','14:05:00',3.34),('14598','2013-10-26','14:10:00',3.35),('14598','2013-10-26','14:15:00',3.32),('14598','2013-10-26','14:20:00',3.32),('14598','2013-10-26','14:25:00',3.29),('14598','2013-10-26','14:30:00',3.26),('14598','2013-10-26','14:35:00',3.22),('14598','2013-10-26','14:40:00',3.16),('14598','2013-10-26','14:45:00',3.13),('14598','2013-10-26','14:50:00',3.09),('14598','2013-10-26','14:55:00',3.03),('14598','2013-10-26','15:00:00',2.99),('14598','2013-10-26','15:05:00',2.93),('14598','2013-10-26','15:10:00',2.9),('14598','2013-10-26','15:15:00',2.82),('14598','2013-10-26','15:20:00',2.78),('14598','2013-10-26','15:25:00',2.71),('14598','2013-10-26','15:30:00',2.63),('14598','2013-10-26','15:35:00',2.6),('14598','2013-10-26','15:40:00',2.51),('14598','2013-10-26','15:45:00',2.45),('14598','2013-10-26','15:50:00',2.38),('14598','2013-10-26','15:55:00',2.28),('14598','2013-10-26','16:00:00',2.22),('14598','2013-10-26','16:05:00',2.12),('14598','2013-10-26','16:10:00',2.03),('14598','2013-10-26','16:15:00',1.97),('14598','2013-10-26','16:20:00',1.89),('14598','2013-10-26','16:25:00',1.8),('14598','2013-10-26','16:30:00',1.73),('14598','2013-10-26','16:35:00',1.64),('14598','2013-10-26','16:40:00',1.52),('14598','2013-10-26','16:45:00',1.43),('14598','2013-10-26','16:50:00',1.35),('14598','2013-10-26','16:55:00',1.26),('14598','2013-10-26','17:00:00',1.14),('14598','2013-10-26','17:05:00',1.04),('14598','2013-10-25','09:25:00',1.09),('14598','2013-10-25','09:30:00',1.2),('14598','2013-10-25','09:35:00',1.28),('14598','2013-10-25','09:40:00',1.37),('14598','2013-10-25','09:45:00',1.46),('14598','2013-10-25','09:50:00',1.55),('14598','2013-10-25','09:55:00',1.64),('14598','2013-10-25','10:00:00',1.55),('14598','2013-10-25','10:05:00',1.35),('14598','2013-10-25','10:10:00',1.87),('14598','2013-10-25','10:15:00',1.94),('14598','2013-10-25','10:20:00',2.03),('14598','2013-10-25','10:25:00',2.1),('14598','2013-10-25','10:30:00',2.17),('14598','2013-10-25','10:35:00',2.23),('14598','2013-10-25','10:40:00',2.31),('14598','2013-10-25','10:45:00',2.39),('14598','2013-10-25','10:50:00',2.45),('14598','2013-10-25','10:55:00',2.52),('14598','2013-10-25','11:00:00',2.59),('14598','2013-10-25','11:05:00',2.65),('14598','2013-10-25','11:10:00',2.7),('14598','2013-10-25','11:15:00',2.75),('14598','2013-10-25','11:20:00',2.82),('14598','2013-10-25','11:25:00',2.86),('14598','2013-10-25','11:30:00',2.88),('14598','2013-10-25','11:35:00',2.97),('14598','2013-10-25','11:40:00',2.98),('14598','2013-10-25','11:45:00',3.04),('14598','2013-10-25','11:50:00',3.09),('14598','2013-10-25','11:55:00',3.13),('14598','2013-10-25','12:00:00',3.12),('14598','2013-10-25','12:05:00',3.18),('14598','2013-10-25','12:10:00',3.17),('14598','2013-10-25','12:15:00',3.26),('14598','2013-10-25','12:20:00',3.26),('14598','2013-10-25','12:25:00',3.31),('14598','2013-10-25','12:30:00',3.33),('14598','2013-10-25','12:35:00',3.34),('14598','2013-10-25','12:40:00',3.3),('14598','2013-10-25','12:45:00',3.36),('14598','2013-10-25','12:50:00',3.39),('14598','2013-10-25','12:55:00',3.39),('14598','2013-10-25','13:00:00',3.37),('14598','2013-10-25','13:05:00',3.41),('14598','2013-10-25','13:10:00',3.42),('14598','2013-10-25','13:15:00',3.45),('14598','2013-10-25','13:20:00',3.48),('14598','2013-10-25','13:25:00',3.48),('14598','2013-10-25','13:30:00',3.51),('14598','2013-10-25','13:35:00',3.49),('14598','2013-10-25','13:40:00',3.5),('14598','2013-10-25','13:45:00',3.49),('14598','2013-10-25','13:50:00',3.49),('14598','2013-10-25','13:55:00',3.47),('14598','2013-10-25','14:00:00',3.47),('14598','2013-10-25','14:05:00',3.44),('14598','2013-10-25','14:10:00',3.44),('14598','2013-10-25','14:15:00',3.4),('14598','2013-10-25','14:20:00',3.38),('14598','2013-10-25','14:25:00',3.36),('14598','2013-10-25','14:30:00',3.3),('14598','2013-10-25','14:35:00',3.28),('14598','2013-10-25','14:40:00',3.25),('14598','2013-10-25','14:45:00',3.22),('14598','2013-10-25','14:50:00',3.18),('14598','2013-10-25','14:55:00',3.13),('14598','2013-10-25','15:00:00',3.1),('14598','2013-10-25','15:05:00',3.06),('14598','2013-10-25','15:10:00',3.02),('14598','2013-10-25','15:15:00',2.96),('14598','2013-10-25','15:20:00',2.89),('14598','2013-10-25','15:25:00',2.84),('14598','2013-10-25','15:30:00',2.78),('14598','2013-10-25','15:35:00',2.72),('14598','2013-10-25','15:40:00',2.65),('14598','2013-10-25','15:45:00',2.56),('14598','2013-10-25','15:50:00',2.5),('14598','2013-10-25','15:55:00',2.42),('14598','2013-10-25','16:00:00',2.34),('14598','2013-10-25','16:05:00',2.26),('14598','2013-10-25','16:10:00',2.18),('14598','2013-10-25','16:15:00',2.09),('14598','2013-10-25','16:20:00',2.01),('14598','2013-10-25','16:25:00',1.92),('14598','2013-10-25','16:30:00',1.82),('14598','2013-10-25','16:35:00',1.72),('14598','2013-10-25','16:40:00',1.63),('14598','2013-10-25','16:45:00',1.54),('14598','2013-10-25','16:50:00',1.44),('14598','2013-10-25','16:55:00',1.34),('14598','2013-10-25','17:00:00',1.24),('14598','2013-10-25','17:05:00',1.13),('14598','2013-10-25','17:10:00',1.02),('14598','2013-10-24','08:50:00',1.02),('14598','2013-10-24','09:05:00',1.29),('14598','2013-10-24','10:00:00',1.1),('14598','2013-10-24','10:05:00',1.36),('14598','2013-10-24','10:10:00',1.52),('14598','2013-10-24','10:15:00',2.16),('14598','2013-10-24','10:20:00',2.71),('14598','2013-10-24','10:25:00',1.7),('14598','2013-10-24','10:30:00',1.25),('14598','2013-10-24','10:35:00',1.21),('14598','2013-10-24','10:40:00',1.21),('14598','2013-10-24','10:45:00',1.2),('14598','2013-10-24','10:50:00',1.16),('14598','2013-10-24','10:55:00',1.15),('14598','2013-10-24','11:00:00',1.27),('14598','2013-10-24','11:05:00',2.56),('14598','2013-10-24','11:10:00',2.42),('14598','2013-10-24','11:15:00',1.91),('14598','2013-10-24','11:20:00',1.42),('14598','2013-10-24','11:25:00',1.36),('14598','2013-10-24','11:30:00',1.44),('14598','2013-10-24','11:35:00',1.5),('14598','2013-10-24','11:40:00',1.6),('14598','2013-10-24','11:45:00',1.66),('14598','2013-10-24','11:50:00',1.82),('14598','2013-10-24','11:55:00',1.71),('14598','2013-10-24','12:00:00',1.3),('14598','2013-10-24','12:05:00',2.03),('14598','2013-10-24','12:10:00',1.7),('14598','2013-10-24','12:15:00',1.79),('14598','2013-10-24','12:20:00',1.9),('14598','2013-10-24','12:25:00',2.02),('14598','2013-10-24','12:30:00',1.59),('14598','2013-10-24','12:35:00',1.52),('14598','2013-10-24','12:40:00',1.5),('14598','2013-10-24','12:45:00',1.48),('14598','2013-10-24','12:50:00',1.48),('14598','2013-10-24','12:55:00',1.53),('14598','2013-10-24','13:00:00',1.62),('14598','2013-10-24','13:05:00',1.73),('14598','2013-10-24','13:10:00',1.67),('14598','2013-10-24','13:15:00',1.6),('14598','2013-10-24','13:20:00',1.54),('14598','2013-10-24','13:25:00',1.51),('14598','2013-10-24','13:30:00',1.51),('14598','2013-10-24','13:35:00',1.46),('14598','2013-10-24','13:40:00',1.42),('14598','2013-10-24','13:45:00',1.43),('14598','2013-10-24','13:50:00',1.54),('14598','2013-10-24','13:55:00',1.65),('14598','2013-10-24','14:00:00',2.04),('14598','2013-10-24','14:05:00',1.58),('14598','2013-10-24','14:10:00',1.42),('14598','2013-10-24','14:15:00',1.34),('14598','2013-10-24','14:20:00',1.26),('14598','2013-10-24','14:25:00',1.22),('14598','2013-10-24','14:30:00',1.24),('14598','2013-10-24','14:35:00',1.24),('14598','2013-10-24','14:40:00',1.33),('14598','2013-10-24','14:45:00',1.43),('14598','2013-10-24','14:50:00',1.37),('14598','2013-10-24','14:55:00',1.22),('14598','2013-10-24','15:00:00',1.27),('14598','2013-10-24','15:05:00',2.43),('14598','2013-10-24','15:10:00',3.44),('14598','2013-10-24','15:15:00',3.09),('14598','2013-10-24','15:20:00',3.06),('14598','2013-10-23','10:30:00',1.02),('14598','2013-10-23','10:35:00',1.11),('14598','2013-10-23','10:40:00',1.23),('14598','2013-10-23','10:45:00',1.29),('14598','2013-10-23','10:50:00',1.16),('14598','2013-10-23','10:55:00',1.57),('14598','2013-10-23','11:00:00',1.93),('14598','2013-10-23','11:05:00',1.91),('14598','2013-10-23','11:10:00',2.33),('14598','2013-10-23','11:15:00',1.77),('14598','2013-10-23','11:20:00',2.1),('14598','2013-10-23','11:25:00',1.68),('14598','2013-10-23','11:30:00',2.84),('14598','2013-10-23','11:35:00',2.77),('14598','2013-10-23','11:40:00',3.09),('14598','2013-10-23','11:45:00',3.08),('14598','2013-10-23','11:50:00',3.12),('14598','2013-10-23','11:55:00',3.15),('14598','2013-10-23','12:00:00',3.15),('14598','2013-10-23','12:05:00',3.18),('14598','2013-10-23','12:10:00',3.16),('14598','2013-10-23','12:15:00',3.24),('14598','2013-10-23','12:20:00',3.26),('14598','2013-10-23','12:25:00',3.23),('14598','2013-10-23','12:30:00',3.22),('14598','2013-10-23','12:35:00',3.33),('14598','2013-10-23','12:40:00',3.29),('14598','2013-10-23','12:45:00',3.18),('14598','2013-10-23','12:50:00',3.24),('14598','2013-10-23','12:55:00',3.16),('14598','2013-10-23','13:00:00',3.36),('14598','2013-10-23','13:05:00',3.48),('14598','2013-10-23','13:10:00',3.48),('14598','2013-10-23','13:15:00',3.46),('14598','2013-10-23','13:20:00',3.45),('14598','2013-10-23','13:25:00',3.43),('14598','2013-10-23','13:30:00',3.43),('14598','2013-10-23','13:35:00',3.36),('14598','2013-10-23','13:40:00',3.33),('14598','2013-10-23','13:45:00',3.34),('14598','2013-10-23','13:50:00',3.38),('14598','2013-10-23','13:55:00',3.32),('14598','2013-10-23','14:00:00',3.31),('14598','2013-10-23','14:05:00',3.26),('14598','2013-10-23','14:10:00',3.26),('14598','2013-10-23','14:15:00',3.24),('14598','2013-10-23','14:20:00',3.2),('14598','2013-10-23','14:25:00',3.2),('14598','2013-10-23','14:30:00',3.15),('14598','2013-10-23','14:35:00',3.15),('14598','2013-10-23','14:40:00',3.14),('14598','2013-10-23','14:45:00',3.11),('14598','2013-10-23','14:50:00',3.08),('14598','2013-10-23','14:55:00',3.06),('14598','2013-10-23','15:00:00',3),('14598','2013-10-23','15:05:00',2.94),('14598','2013-10-23','15:10:00',2.55),('14598','2013-10-23','15:15:00',2.52),('14598','2013-10-23','15:20:00',2.65),('14598','2013-10-23','15:25:00',2.49),('14598','2013-10-23','15:30:00',2.36),('14598','2013-10-23','15:35:00',2.5),('14598','2013-10-23','15:40:00',2.22),('14598','2013-10-23','15:45:00',1.81),('14598','2013-10-23','15:50:00',1.19),('14598','2013-10-23','15:55:00',1.36),('14598','2013-10-23','16:00:00',1.53),('14598','2013-10-23','16:05:00',1.98),('14598','2013-10-23','16:10:00',2.02),('14598','2013-10-23','16:15:00',2.05),('14598','2013-10-23','16:20:00',2.17),('14598','2013-10-23','16:25:00',1.96),('14598','2013-10-23','16:30:00',1.76),('14598','2013-10-23','16:35:00',1.72),('14598','2013-10-23','16:40:00',1.52),('14598','2013-10-23','16:45:00',1.47),('14598','2013-10-23','16:50:00',1.25),('14598','2013-10-23','16:55:00',1.01),('14598','2013-10-22','09:20:00',1.04),('14598','2013-10-22','09:25:00',1.15),('14598','2013-10-22','09:30:00',1.25),('14598','2013-10-22','09:35:00',1.34),('14598','2013-10-22','09:40:00',1.4),('14598','2013-10-22','09:45:00',1.47),('14598','2013-10-22','09:50:00',1.54),('14598','2013-10-22','09:55:00',1.62),('14598','2013-10-22','10:00:00',1.71),('14598','2013-10-22','10:05:00',1.78),('14598','2013-10-22','10:10:00',1.86),('14598','2013-10-22','10:15:00',1.86),('14598','2013-10-22','10:20:00',1.97),('14598','2013-10-22','10:25:00',2.07),('14598','2013-10-22','10:30:00',2.11),('14598','2013-10-22','10:35:00',2.16),('14598','2013-10-22','10:40:00',2.28),('14598','2013-10-22','10:45:00',2.35),('14598','2013-10-22','10:50:00',2.43),('14598','2013-10-22','10:55:00',2.48),('14598','2013-10-22','11:00:00',2.46),('14598','2013-10-22','11:05:00',2.53),('14598','2013-10-22','11:10:00',2.58),('14598','2013-10-22','11:15:00',2.67),('14598','2013-10-22','11:20:00',2.68),('14598','2013-10-22','11:25:00',2.79),('14598','2013-10-22','11:30:00',2.91),('14598','2013-10-22','11:35:00',2.19),('14598','2013-10-22','11:40:00',2.63),('14598','2013-10-22','11:45:00',3.11),('14598','2013-10-22','11:50:00',1.68),('14598','2013-10-22','11:55:00',1.17),('14598','2013-10-22','12:00:00',2.35),('14598','2013-10-22','12:05:00',2.75),('14598','2013-10-22','12:10:00',3.17),('14598','2013-10-22','12:15:00',3.25),('14598','2013-10-22','12:20:00',3.24),('14598','2013-10-22','12:25:00',3.19),('14598','2013-10-22','12:30:00',3.28),('14598','2013-10-22','12:35:00',1.24),('14598','2013-10-22','12:40:00',3.08),('14598','2013-10-22','12:45:00',3.36),('14598','2013-10-22','12:50:00',3.42),('14598','2013-10-22','12:55:00',3.41),('14598','2013-10-22','13:00:00',3.48),('14598','2013-10-22','13:05:00',3.36),('14598','2013-10-22','13:10:00',3.37),('14598','2013-10-22','13:15:00',3.32),('14598','2013-10-22','13:20:00',3.4),('14598','2013-10-22','13:25:00',3.39),('14598','2013-10-22','13:30:00',2.7),('14598','2013-10-22','13:35:00',3.38),('14598','2013-10-22','13:40:00',3.43),('14598','2013-10-22','13:45:00',3.42),('14598','2013-10-22','13:50:00',3.39),('14598','2013-10-22','13:55:00',3.27),('14598','2013-10-22','14:00:00',3.32),('14598','2013-10-22','14:05:00',3.33),('14598','2013-10-22','14:10:00',3.29),('14598','2013-10-22','14:15:00',3.26),('14598','2013-10-22','14:20:00',3.24),('14598','2013-10-22','14:25:00',3.15),('14598','2013-10-22','14:30:00',3.19),('14598','2013-10-22','14:35:00',3.19),('14598','2013-10-22','14:40:00',3.18),('14598','2013-10-22','14:45:00',3.15),('14598','2013-10-22','14:50:00',3.1),('14598','2013-10-22','14:55:00',3.05),('14598','2013-10-22','15:00:00',3.02),('14598','2013-10-22','15:05:00',2.96),('14598','2013-10-22','15:10:00',2.9),('14598','2013-10-22','15:15:00',2.85),('14598','2013-10-22','15:20:00',2.82),('14598','2013-10-22','15:25:00',2.74),('14598','2013-10-22','15:30:00',2.68),('14598','2013-10-22','15:35:00',2.64),('14598','2013-10-22','15:40:00',2.58),('14598','2013-10-22','15:45:00',2.53),('14598','2013-10-22','15:50:00',2.46),('14598','2013-10-22','15:55:00',2.37),('14598','2013-10-22','16:00:00',2.3),('14598','2013-10-22','16:05:00',2.23),('14598','2013-10-22','16:10:00',2.14),('14598','2013-10-22','16:15:00',2.06),('14598','2013-10-22','16:20:00',1.97),('14598','2013-10-22','16:25:00',1.88),('14598','2013-10-22','16:30:00',1.79),('14598','2013-10-22','16:35:00',1.69),('14598','2013-10-22','16:40:00',1.6),('14598','2013-10-22','16:45:00',1.5),('14598','2013-10-22','16:50:00',1.4),('14598','2013-10-22','16:55:00',1.3),('14598','2013-10-22','17:00:00',1.2),('14598','2013-10-22','17:05:00',1.09),('14598','2013-10-21','09:25:00',1.04),('14598','2013-10-21','09:30:00',1.32),('14598','2013-10-21','09:35:00',1.38),('14598','2013-10-21','09:40:00',1.45),('14598','2013-10-21','09:45:00',1.54),('14598','2013-10-21','09:50:00',1.65),('14598','2013-10-21','09:55:00',1.75),('14598','2013-10-21','10:00:00',1.68),('14598','2013-10-21','10:05:00',1.66),('14598','2013-10-21','10:10:00',2.07),('14598','2013-10-21','10:15:00',2.14),('14598','2013-10-21','10:20:00',2.19),('14598','2013-10-21','10:25:00',2.04),('14598','2013-10-21','10:30:00',2.27),('14598','2013-10-21','10:35:00',1.98),('14598','2013-10-21','10:40:00',2.44),('14598','2013-10-21','10:45:00',2.5),('14598','2013-10-21','10:50:00',2.64),('14598','2013-10-21','10:55:00',2.65),('14598','2013-10-21','11:00:00',2.65),('14598','2013-10-21','11:05:00',2.79),('14598','2013-10-21','11:10:00',2.73),('14598','2013-10-21','11:15:00',2.78),('14598','2013-10-21','11:20:00',2.86),('14598','2013-10-21','11:25:00',2.89),('14598','2013-10-21','11:30:00',2.92),('14598','2013-10-21','11:35:00',2.82),('14598','2013-10-21','11:40:00',2.84),('14598','2013-10-21','11:45:00',2.9),('14598','2013-10-21','11:50:00',2.79),('14598','2013-10-21','11:55:00',2.76),('14598','2013-10-21','12:00:00',2.87),('14598','2013-10-21','12:05:00',2.97),('14598','2013-10-21','12:10:00',3.21),('14598','2013-10-21','12:15:00',3.08),('14598','2013-10-21','12:20:00',3.26),('14598','2013-10-21','12:25:00',3.32),('14598','2013-10-21','12:30:00',3.3),('14598','2013-10-21','12:35:00',3.42),('14598','2013-10-21','12:40:00',3.4),('14598','2013-10-21','12:45:00',3.29),('14598','2013-10-21','12:50:00',3.36),('14598','2013-10-21','12:55:00',3.07),('14598','2013-10-21','13:00:00',3.2),('14598','2013-10-21','13:05:00',3.4),('14598','2013-10-21','13:10:00',3.39),('14598','2013-10-21','13:15:00',3.41),('14598','2013-10-21','13:20:00',3.46),('14598','2013-10-21','13:25:00',3.57),('14598','2013-10-21','13:30:00',3.18),('14598','2013-10-21','13:35:00',3.4),('14598','2013-10-21','13:40:00',3.52),('14598','2013-10-21','13:45:00',3.5),('14598','2013-10-21','13:50:00',3.48),('14598','2013-10-21','13:55:00',3.51),('14598','2013-10-21','14:00:00',3.48),('14598','2013-10-21','14:05:00',3.44),('14598','2013-10-21','14:10:00',3.35),('14598','2013-10-21','14:15:00',3.38),('14598','2013-10-21','14:20:00',3.35),('14598','2013-10-21','14:25:00',3.31),('14598','2013-10-21','14:30:00',3.27),('14598','2013-10-21','14:35:00',3.2),('14598','2013-10-21','14:40:00',3.05),('14598','2013-10-21','14:45:00',3.07),('14598','2013-10-21','14:50:00',3.14),('14598','2013-10-21','14:55:00',3.11),('14598','2013-10-21','15:00:00',3.07),('14598','2013-10-21','15:05:00',3.02),('14598','2013-10-21','15:10:00',2.97),('14598','2013-10-21','15:15:00',2.91),('14598','2013-10-21','15:20:00',2.81),('14598','2013-10-21','15:25:00',2.75),('14598','2013-10-21','15:30:00',2.68),('14598','2013-10-21','15:35:00',2.56),('14598','2013-10-21','15:40:00',2.56),('14598','2013-10-21','15:45:00',2.53),('14598','2013-10-21','15:50:00',2.47),('14598','2013-10-21','15:55:00',2.41),('14598','2013-10-21','16:00:00',2.31),('14598','2013-10-21','16:05:00',2.25),('14598','2013-10-21','16:10:00',2.14),('14598','2013-10-21','16:15:00',2.02),('14598','2013-10-21','16:20:00',2),('14598','2013-10-21','16:25:00',1.94),('14598','2013-10-21','16:30:00',1.78),('14598','2013-10-21','16:35:00',1.45),('14598','2013-10-21','16:40:00',1.48),('14598','2013-10-21','16:45:00',1.48),('14598','2013-10-21','16:50:00',1.4),('14598','2013-10-21','16:55:00',1.43),('14598','2013-10-21','17:00:00',1.35),('14598','2013-10-21','17:05:00',1.23),('14598','2013-10-21','17:10:00',1.12),('14598','2013-10-21','17:15:00',1.04),('14598','2013-10-20','09:20:00',1.1),('14598','2013-10-20','09:25:00',1.23),('14598','2013-10-20','09:30:00',1.19),('14598','2013-10-20','09:35:00',1.33),('14598','2013-10-20','09:40:00',1.8),('14598','2013-10-20','09:45:00',2.2),('14598','2013-10-20','09:50:00',1.74),('14598','2013-10-20','09:55:00',1.87),('14598','2013-10-20','10:00:00',2),('14598','2013-10-20','10:05:00',2.12),('14598','2013-10-20','10:10:00',2.08),('14598','2013-10-20','10:15:00',1.74),('14598','2013-10-20','10:20:00',1.73),('14598','2013-10-20','10:25:00',1.67),('14598','2013-10-20','10:30:00',1.47),('14598','2013-10-20','10:35:00',1.39),('14598','2013-10-20','10:40:00',1.38),('14598','2013-10-20','10:45:00',1.27),('14598','2013-10-20','10:50:00',2.36),('14598','2013-10-20','10:55:00',2.17),('14598','2013-10-20','11:00:00',2.79),('14598','2013-10-20','11:05:00',2.63),('14598','2013-10-20','11:10:00',2.78),('14598','2013-10-20','11:15:00',2.94),('14598','2013-10-20','11:20:00',2.95),('14598','2013-10-20','11:25:00',2.99),('14598','2013-10-20','11:30:00',3.03),('14598','2013-10-20','11:35:00',3.06),('14598','2013-10-20','11:40:00',3.05),('14598','2013-10-20','11:45:00',3.13),('14598','2013-10-20','11:50:00',3.08),('14598','2013-10-20','11:55:00',3.2),('14598','2013-10-20','12:00:00',3.24),('14598','2013-10-20','12:05:00',3.23),('14598','2013-10-20','12:10:00',3.32),('14598','2013-10-20','12:15:00',3.25),('14598','2013-10-20','12:20:00',3.16),('14598','2013-10-20','12:25:00',3.09),('14598','2013-10-20','12:30:00',3.33),('14598','2013-10-20','12:35:00',3.3),('14598','2013-10-20','12:40:00',3.91),('14598','2013-10-20','12:45:00',3.75),('14598','2013-10-20','12:50:00',3.79),('14598','2013-10-20','12:55:00',3.6),('14598','2013-10-20','13:00:00',3.68),('14598','2013-10-20','13:05:00',3.68),('14598','2013-10-20','13:10:00',3.65),('14598','2013-10-20','13:15:00',3.67),('14598','2013-10-20','13:20:00',3.67),('14598','2013-10-20','13:25:00',3.66),('14598','2013-10-20','13:30:00',3.67),('14598','2013-10-20','13:35:00',3.67),('14598','2013-10-20','13:40:00',3.64),('14598','2013-10-20','13:45:00',3.63),('14598','2013-10-20','13:50:00',3.61),('14598','2013-10-20','13:55:00',3.61),('14598','2013-10-20','14:00:00',3.59),('14598','2013-10-20','14:05:00',3.59),('14598','2013-10-20','14:10:00',3.55),('14598','2013-10-20','14:15:00',3.52),('14598','2013-10-20','14:20:00',3.5),('14598','2013-10-20','14:25:00',3.47),('14598','2013-10-20','14:30:00',3.43),('14598','2013-10-20','14:35:00',3.41),('14598','2013-10-20','14:40:00',3.35),('14598','2013-10-20','14:45:00',3.34),('14598','2013-10-20','14:50:00',3.29),('14598','2013-10-20','14:55:00',3.26),('14598','2013-10-20','15:00:00',3.21),('14598','2013-10-20','15:05:00',3.16),('14598','2013-10-20','15:10:00',3.11),('14598','2013-10-20','15:15:00',3.06),('14598','2013-10-20','15:20:00',3),('14598','2013-10-20','15:25:00',2.94),('14598','2013-10-20','15:30:00',2.87),('14598','2013-10-20','15:35:00',2.82),('14598','2013-10-20','15:40:00',2.76),('14598','2013-10-20','15:45:00',2.68),('14598','2013-10-20','15:50:00',2.6),('14598','2013-10-20','15:55:00',2.49),('14598','2013-10-20','16:00:00',2.41),('14598','2013-10-20','16:05:00',2.35),('14598','2013-10-20','16:10:00',2.27),('14598','2013-10-20','16:15:00',2.19),('14598','2013-10-20','16:20:00',2.12),('14598','2013-10-20','16:25:00',2.04),('14598','2013-10-20','16:30:00',1.94),('14598','2013-10-20','16:35:00',1.86),('14598','2013-10-20','16:40:00',1.76),('14598','2013-10-20','16:45:00',1.66),('14598','2013-10-20','16:50:00',1.57),('14598','2013-10-20','16:55:00',1.48),('14598','2013-10-20','17:00:00',1.37),('14598','2013-10-20','17:05:00',1.26),('14598','2013-10-20','17:10:00',1.16),('14598','2013-10-20','17:15:00',1.06),('14598','2013-10-19','09:05:00',1.02),('14598','2013-10-19','09:10:00',1.15),('14598','2013-10-19','09:15:00',1.19),('14598','2013-10-19','09:20:00',1.28),('14598','2013-10-19','09:25:00',1.37),('14598','2013-10-19','09:30:00',1.5),('14598','2013-10-19','09:35:00',1.56),('14598','2013-10-19','09:40:00',1.64),('14598','2013-10-19','09:45:00',1.72),('14598','2013-10-19','09:50:00',1.87),('14598','2013-10-19','09:55:00',1.96),('14598','2013-10-19','10:00:00',2.05),('14598','2013-10-19','10:05:00',2.14),('14598','2013-10-19','10:10:00',2.23),('14598','2013-10-19','10:15:00',2.31),('14598','2013-10-19','10:20:00',2.37),('14598','2013-10-19','10:25:00',2.11),('14598','2013-10-19','10:30:00',2.57),('14598','2013-10-19','10:35:00',2.56),('14598','2013-10-19','10:40:00',2.53),('14598','2013-10-19','10:45:00',2.55),('14598','2013-10-19','10:50:00',2.83),('14598','2013-10-19','10:55:00',2.92),('14598','2013-10-19','11:00:00',2.99),('14598','2013-10-19','11:05:00',3.03),('14598','2013-10-19','11:10:00',3.1),('14598','2013-10-19','11:15:00',3.04),('14598','2013-10-19','11:20:00',3.03),('14598','2013-10-19','11:25:00',3.17),('14598','2013-10-19','11:30:00',3.34),('14598','2013-10-19','11:35:00',3.37),('14598','2013-10-19','11:40:00',3.32),('14598','2013-10-19','11:45:00',3.42),('14598','2013-10-19','11:50:00',3.44),('14598','2013-10-19','11:55:00',3.59),('14598','2013-10-19','12:00:00',3.63),('14598','2013-10-19','12:05:00',3.67),('14598','2013-10-19','12:10:00',3.7),('14598','2013-10-19','12:15:00',3.8),('14598','2013-10-19','12:20:00',4.03),('14598','2013-10-19','12:25:00',4.23),('14598','2013-10-19','12:30:00',3.17),('14598','2013-10-19','12:35:00',2.49),('14598','2013-10-19','12:40:00',3.01),('14598','2013-10-19','12:45:00',3.73),('14598','2013-10-19','12:50:00',4),('14598','2013-10-19','12:55:00',4.54),('14598','2013-10-19','13:00:00',3.59),('14598','2013-10-19','13:05:00',3.69),('14598','2013-10-19','13:10:00',3.25),('14598','2013-10-19','13:15:00',4.02),('14598','2013-10-19','13:20:00',4.26),('14598','2013-10-19','13:25:00',4.22),('14598','2013-10-19','13:30:00',4.14),('14598','2013-10-19','13:35:00',3.81),('14598','2013-10-19','13:40:00',3.83),('14598','2013-10-19','13:45:00',3.81),('14598','2013-10-19','13:50:00',3.87),('14598','2013-10-19','13:55:00',3.39),('14598','2013-10-19','14:00:00',3.15),('14598','2013-10-19','14:05:00',2.42),('14598','2013-10-19','14:10:00',3.75),('14598','2013-10-19','14:15:00',3.58),('14598','2013-10-19','14:20:00',3.6),('14598','2013-10-19','14:25:00',3.49),('14598','2013-10-19','14:30:00',3.5),('14598','2013-10-19','14:35:00',3.45),('14598','2013-10-19','14:40:00',3.35),('14598','2013-10-19','14:45:00',3.35),('14598','2013-10-19','14:50:00',3.3),('14598','2013-10-19','14:55:00',3.38),('14598','2013-10-19','15:00:00',3.21),('14598','2013-10-19','15:05:00',3.08),('14598','2013-10-19','15:10:00',3.14),('14598','2013-10-19','15:15:00',3.33),('14598','2013-10-19','15:20:00',3.3),('14598','2013-10-19','15:25:00',3.2),('14598','2013-10-19','15:30:00',3),('14598','2013-10-19','15:35:00',2.44),('14598','2013-10-19','15:40:00',3),('14598','2013-10-19','15:45:00',1.24),('14598','2013-10-19','15:50:00',1.65),('14598','2013-10-19','15:55:00',2.37),('14598','2013-10-19','16:00:00',2.75),('14598','2013-10-19','16:05:00',2.71),('14598','2013-10-19','16:10:00',2.55),('14598','2013-10-19','16:15:00',2.58),('14598','2013-10-19','16:20:00',2.47),('14598','2013-10-19','16:25:00',1.85),('14598','2013-10-19','16:30:00',2.39),('14598','2013-10-19','16:35:00',1.46),('14598','2013-10-19','16:40:00',1.63),('14598','2013-10-19','16:45:00',1.91),('14598','2013-10-19','16:50:00',1.59),('14598','2013-10-19','16:55:00',1.74),('14598','2013-10-19','17:00:00',1.81),('14598','2013-10-19','17:05:00',1.76),('14598','2013-10-19','17:10:00',1.55),('14598','2013-10-19','17:15:00',1.1),('14598','2013-10-19','17:20:00',1.07),('14598','2014-05-04','07:45:00',1.2),('14598','2014-05-04','07:50:00',1.29),('14598','2014-05-04','07:55:00',1.26),('14598','2014-05-04','08:00:00',1.21),('14598','2014-05-04','08:05:00',1.51),('14598','2014-05-04','08:10:00',1.18),('14598','2014-05-04','08:15:00',1.78),('14598','2014-05-04','08:20:00',1.7),('14598','2014-05-04','08:25:00',2.09),('14598','2014-05-04','08:30:00',1.88),('14598','2014-05-04','08:35:00',2.19),('14598','2014-05-04','08:40:00',1.86),('14598','2014-05-04','08:45:00',2.06),('14598','2014-05-04','08:50:00',2.14),('14598','2014-05-04','08:55:00',2.27),('14598','2014-05-04','09:00:00',2.25),('14598','2014-05-04','09:05:00',2.69),('14598','2014-05-04','09:10:00',3.04),('14598','2014-05-04','09:15:00',2.1),('14598','2014-05-04','09:20:00',1.45),('14598','2014-05-04','09:25:00',1.53),('14598','2014-05-04','09:30:00',1.45),('14598','2014-05-04','09:35:00',2.21),('14598','2014-05-04','09:40:00',3.49),('14598','2014-05-04','09:45:00',4.29),('14598','2014-05-04','09:50:00',3.62),('14598','2014-05-04','09:55:00',1.99),('14598','2014-05-04','10:00:00',1.76),('14598','2014-05-04','10:05:00',2.42),('14598','2014-05-04','10:10:00',2.11),('14598','2014-05-04','10:15:00',2.31),('14598','2014-05-04','10:20:00',1.7),('14598','2014-05-04','10:25:00',2),('14598','2014-05-04','10:30:00',3.25),('14598','2014-05-04','10:35:00',3.26),('14598','2014-05-04','10:40:00',2.7),('14598','2014-05-04','10:45:00',3.34),('14598','2014-05-04','10:50:00',3.11),('14598','2014-05-04','10:55:00',4.06),('14598','2014-05-04','11:00:00',3.79),('14598','2014-05-04','11:05:00',3.55),('14598','2014-05-04','11:10:00',3.46),('14598','2014-05-04','11:15:00',3.19),('14598','2014-05-04','11:20:00',4.82),('14598','2014-05-04','11:25:00',4.68),('14598','2014-05-04','11:30:00',4.47),('14598','2014-05-04','11:35:00',4.08),('14598','2014-05-04','11:40:00',5.08),('14598','2014-05-04','11:45:00',4.2),('14598','2014-05-04','11:50:00',4.67),('14598','2014-05-04','11:55:00',4.57),('14598','2014-05-04','12:00:00',4.91),('14598','2014-05-04','12:05:00',4.97),('14598','2014-05-04','12:10:00',4.92),('14598','2014-05-04','12:15:00',5.08),('14598','2014-05-04','12:20:00',5.05),('14598','2014-05-04','12:25:00',5.06),('14598','2014-05-04','12:30:00',5.21),('14598','2014-05-04','12:35:00',5.44),('14598','2014-05-04','12:40:00',3.38),('14598','2014-05-04','12:45:00',2.52),('14598','2014-05-04','12:50:00',3.47),('14598','2014-05-04','12:55:00',5.08),('14598','2014-05-04','13:00:00',4.64),('14598','2014-05-04','13:05:00',4.83),('14598','2014-05-04','13:10:00',3.92),('14598','2014-05-04','13:15:00',3.97),('14598','2014-05-04','13:20:00',4.05),('14598','2014-05-04','13:25:00',4.37),('14598','2014-05-04','13:30:00',1.86),('14598','2014-05-04','13:35:00',1.74),('14598','2014-05-04','13:40:00',1.17),('14598','2014-05-04','14:15:00',1.07),('14598','2014-05-04','15:25:00',1.21),('14598','2014-05-04','15:30:00',1.51),('14598','2014-05-04','15:35:00',1.74),('14598','2014-05-04','15:40:00',2.55),('14598','2014-05-04','15:45:00',3.25),('14598','2014-05-04','15:50:00',4.04),('14598','2014-05-04','15:55:00',5.48),('14598','2014-05-04','16:00:00',4.87),('14598','2014-05-04','16:05:00',3.49),('14598','2014-05-04','16:10:00',3.5),('14598','2014-05-04','16:15:00',2.56),('14598','2014-05-04','16:20:00',2.4),('14598','2014-05-04','16:25:00',1.74),('14598','2014-05-04','16:30:00',2.25),('14598','2014-04-16','08:20:00',1.01),('14598','2014-04-16','08:25:00',1.1),('14598','2014-04-16','08:30:00',1.22),('14598','2014-04-16','08:35:00',1.33),('14598','2014-04-16','08:40:00',1.45),('14598','2014-04-16','08:45:00',1.56),('14598','2014-04-16','08:50:00',1.67),('14598','2014-04-16','08:55:00',1.78),('14598','2014-04-16','09:00:00',1.91),('14598','2014-04-16','09:05:00',2.07),('14598','2014-04-16','09:10:00',2.2),('14598','2014-04-16','09:15:00',2.32),('14598','2014-04-16','09:20:00',2.43),('14598','2014-04-16','09:25:00',2.54),('14598','2014-04-16','09:30:00',2.65),('14598','2014-04-16','09:35:00',2.75),('14598','2014-04-16','09:40:00',2.83),('14598','2014-04-16','09:45:00',2.96),('14598','2014-04-16','09:50:00',3.07),('14598','2014-04-16','09:55:00',3.28),('14598','2014-04-16','10:00:00',3.51),('14598','2014-04-16','10:05:00',3.41),('14598','2014-04-16','10:10:00',3.47),('14598','2014-04-16','10:15:00',3.58),('14598','2014-04-16','10:20:00',3.69),('14598','2014-04-16','10:25:00',3.76),('14598','2014-04-16','10:30:00',3.89),('14598','2014-04-16','10:35:00',3.69),('14598','2014-04-16','10:40:00',4.06),('14598','2014-04-16','10:45:00',4.1),('14598','2014-04-16','10:50:00',4.15),('14598','2014-04-16','10:55:00',4.21),('14598','2014-04-16','11:00:00',4.4),('14598','2014-04-16','11:05:00',4.09),('14598','2014-04-16','11:10:00',3.8),('14598','2014-04-16','11:15:00',2.72),('14598','2014-04-16','11:20:00',3.15),('14598','2014-04-16','11:25:00',4.02),('14598','2014-04-16','11:30:00',3.77),('14598','2014-04-16','11:35:00',4.86),('14598','2014-04-16','11:40:00',4.33),('14598','2014-04-16','11:45:00',3.11),('14598','2014-04-16','11:50:00',3.16),('14598','2014-04-16','11:55:00',2.81),('14598','2014-04-16','12:00:00',5.23),('14598','2014-04-16','12:05:00',2.99),('14598','2014-04-16','12:10:00',4.06),('14598','2014-04-16','12:15:00',5.11),('14598','2014-04-16','12:20:00',4.77),('14598','2014-04-16','12:25:00',5.57),('14598','2014-04-16','12:30:00',4.51),('14598','2014-04-16','12:35:00',3.62),('14598','2014-04-16','12:40:00',4.64),('14598','2014-04-16','12:45:00',4.53),('14598','2014-04-16','12:50:00',2.53),('14598','2014-04-16','12:55:00',4.49),('14598','2014-04-16','13:00:00',4.79),('14598','2014-04-16','13:05:00',5.54),('14598','2014-04-16','13:10:00',5.79),('14598','2014-04-16','13:15:00',5.25),('14598','2014-04-16','13:20:00',4.52),('14598','2014-04-16','13:25:00',3.68),('14598','2014-04-16','13:30:00',2.47),('14598','2014-04-16','13:35:00',5.49),('14598','2014-04-16','13:40:00',4.07),('14598','2014-04-16','13:45:00',4.99),('14598','2014-04-16','13:50:00',5.57),('14598','2014-04-16','13:55:00',5.5),('14598','2014-04-16','14:00:00',5.47),('14598','2014-04-16','14:05:00',5.46),('14598','2014-04-16','14:10:00',5.46),('14598','2014-04-16','14:15:00',5.58),('14598','2014-04-16','14:20:00',5.79),('14598','2014-04-16','14:25:00',5.54),('14598','2014-04-16','14:30:00',5.39),('14598','2014-04-16','14:35:00',5.38),('14598','2014-04-16','14:40:00',4.16),('14598','2014-04-16','14:45:00',5.49),('14598','2014-04-16','14:50:00',5.02),('14598','2014-04-16','14:55:00',5.26),('14598','2014-04-16','15:00:00',5.13),('14598','2014-04-16','15:05:00',4.85),('14598','2014-04-16','15:10:00',5.09),('14598','2014-04-16','15:15:00',5.29),('14598','2014-04-16','15:20:00',4.06),('14598','2014-04-16','15:25:00',4.64),('14598','2014-04-16','15:30:00',5.17),('14598','2014-04-16','15:35:00',5.25),('14598','2014-04-16','15:40:00',5.22),('14598','2014-04-16','15:45:00',4.93),('14598','2014-04-16','15:50:00',4.73),('14598','2014-04-16','15:55:00',4.58),('14598','2014-04-16','16:00:00',4.29),('14598','2014-04-16','16:05:00',4.43),('14598','2014-04-16','16:10:00',4.5),('14598','2014-04-16','16:15:00',4.43),('14598','2014-04-16','16:20:00',1.82),('14598','2014-04-16','16:25:00',4.49),('14598','2014-04-16','16:30:00',4.17),('14598','2014-04-16','16:35:00',4.14),('14598','2014-04-16','16:40:00',4.33),('14598','2014-04-16','16:45:00',2.72),('14598','2014-04-16','17:05:00',2.6),('14598','2014-04-16','17:10:00',2.72),('14598','2014-04-16','17:15:00',3.17),('14598','2014-04-16','17:20:00',2.92),('14598','2014-04-16','17:25:00',3.09),('14598','2014-04-16','17:30:00',2.95),('14598','2014-04-16','17:35:00',2.87),('14598','2014-04-16','17:40:00',2.75),('14598','2014-04-16','17:45:00',2.63),('14598','2014-04-16','17:50:00',2.52),('14598','2014-04-16','17:55:00',2.5),('14598','2014-04-16','18:00:00',2.46),('14598','2014-04-16','18:05:00',2.39),('14598','2014-04-16','18:10:00',2.15),('14598','2014-04-16','18:15:00',2.05),('14598','2014-04-16','18:20:00',1.73),('14598','2014-04-16','18:25:00',1.39),('14598','2014-04-16','18:55:00',1.05),('14598','2013-10-18','09:10:00',1.03),('14598','2013-10-18','09:15:00',1.16),('14598','2013-10-18','09:20:00',1.28),('14598','2013-10-18','09:25:00',1.38),('14598','2013-10-18','09:30:00',1.5),('14598','2013-10-18','09:35:00',1.6),('14598','2013-10-18','09:40:00',1.7),('14598','2013-10-18','09:45:00',1.78),('14598','2013-10-18','09:50:00',1.89),('14598','2013-10-18','09:55:00',2),('14598','2013-10-18','10:00:00',2.08),('14598','2013-10-18','10:05:00',2.11),('14598','2013-10-18','10:10:00',2.18),('14598','2013-10-18','10:15:00',1.98),('14598','2013-10-18','10:20:00',2.1),('14598','2013-10-18','10:25:00',2.27),('14598','2013-10-18','10:30:00',2.4),('14598','2013-10-18','10:35:00',2.67),('14598','2013-10-18','10:40:00',2.7),('14598','2013-10-18','10:45:00',2.6),('14598','2013-10-18','10:50:00',2.68),('14598','2013-10-18','10:55:00',2.72),('14598','2013-10-18','11:00:00',2.82),('14598','2013-10-18','11:05:00',2.64),('14598','2013-10-18','11:10:00',2.83),('14598','2013-10-18','11:15:00',3.09),('14598','2013-10-18','11:20:00',3.13),('14598','2013-10-18','11:25:00',3.23),('14598','2013-10-18','11:30:00',3.3),('14598','2013-10-18','11:35:00',3.06),('14598','2013-10-18','11:40:00',2.77),('14598','2013-10-18','11:45:00',3.32),('14598','2013-10-18','11:50:00',3.37),('14598','2013-10-18','11:55:00',3.36),('14598','2013-10-18','12:00:00',3.44),('14598','2013-10-18','12:05:00',3.52),('14598','2013-10-18','12:10:00',3.54),('14598','2013-10-18','12:15:00',3.56),('14598','2013-10-18','12:20:00',3.55),('14598','2013-10-18','12:25:00',3.58),('14598','2013-10-18','12:30:00',3.46),('14598','2013-10-18','12:35:00',3.51),('14598','2013-10-18','12:40:00',3.59),('14598','2013-10-18','12:45:00',3.64),('14598','2013-10-18','12:50:00',3.7),('14598','2013-10-18','12:55:00',3.55),('14598','2013-10-18','13:00:00',3.61),('14598','2013-10-18','13:05:00',3.61),('14598','2013-10-18','13:10:00',3.63),('14598','2013-10-18','13:15:00',3.76),('14598','2013-10-18','13:20:00',3.27),('14598','2013-10-18','13:25:00',3.77),('14598','2013-10-18','13:30:00',3.68),('14598','2013-10-18','13:35:00',3.71),('14598','2013-10-18','13:40:00',3.82),('14598','2013-10-18','13:45:00',3.76),('14598','2013-10-18','13:50:00',3.73),('14598','2013-10-18','13:55:00',3.61),('14598','2013-10-18','14:00:00',3.65),('14598','2013-10-18','14:05:00',3.75),('14598','2013-10-18','14:10:00',3.75),('14598','2013-10-18','14:15:00',3.61),('14598','2013-10-18','14:20:00',3.73),('14598','2013-10-18','14:25:00',3.39),('14598','2013-10-18','14:30:00',3.49),('14598','2013-10-18','14:35:00',3.65),('14598','2013-10-18','14:40:00',3.5),('14598','2013-10-18','14:45:00',3.61),('14598','2013-10-18','14:50:00',3.57),('14598','2013-10-18','14:55:00',3.33),('14598','2013-10-18','15:00:00',3.12),('14598','2013-10-18','15:05:00',3.27),('14598','2013-10-18','15:10:00',3.12),('14598','2013-10-18','15:15:00',2.74),('14598','2013-10-18','15:20:00',2.66),('14598','2013-10-18','15:25:00',2.77),('14598','2013-10-18','15:30:00',2.53),('14598','2013-10-18','15:35:00',2.37),('14598','2013-10-18','15:40:00',2.55),('14598','2013-10-18','15:45:00',2.57),('14598','2013-10-18','15:50:00',2.68),('14598','2013-10-18','15:55:00',2.6),('14598','2013-10-18','16:00:00',2.28),('14598','2013-10-18','16:05:00',2.17),('14598','2013-10-18','16:10:00',2.04),('14598','2013-10-18','16:15:00',2.01),('14598','2013-10-18','16:20:00',1.93),('14598','2013-10-18','16:25:00',1.8),('14598','2013-10-18','16:30:00',1.46),('14598','2013-10-18','16:35:00',1.3),('14598','2013-10-18','16:40:00',1.39),('14598','2013-10-18','16:45:00',1.47),('14598','2013-10-18','16:50:00',1.3),('14598','2013-10-18','16:55:00',1.17),('14598','2013-10-18','17:00:00',1.15),('14598','2013-10-17','09:10:00',1.02),('14598','2013-10-17','09:15:00',1.14),('14598','2013-10-17','09:20:00',1.25),('14598','2013-10-17','09:25:00',1.38),('14598','2013-10-17','09:30:00',1.48),('14598','2013-10-17','09:35:00',1.58),('14598','2013-10-17','09:40:00',1.68),('14598','2013-10-17','09:45:00',1.78),('14598','2013-10-17','09:50:00',1.88),('14598','2013-10-17','09:55:00',1.96),('14598','2013-10-17','10:00:00',2.04),('14598','2013-10-17','10:05:00',2.15),('14598','2013-10-17','10:10:00',2.22),('14598','2013-10-17','10:15:00',2.31),('14598','2013-10-17','10:20:00',2.4),('14598','2013-10-17','10:25:00',2.47),('14598','2013-10-17','10:30:00',2.54),('14598','2013-10-17','10:35:00',2.62),('14598','2013-10-17','10:40:00',2.7),('14598','2013-10-17','10:45:00',2.78),('14598','2013-10-17','10:50:00',2.84),('14598','2013-10-17','10:55:00',2.91),('14598','2013-10-17','11:00:00',2.98),('14598','2013-10-17','11:05:00',3.04),('14598','2013-10-17','11:10:00',3.11),('14598','2013-10-17','11:15:00',3.17),('14598','2013-10-17','11:20:00',3.2),('14598','2013-10-17','11:25:00',3.27),('14598','2013-10-17','11:30:00',3.32),('14598','2013-10-17','11:35:00',3.38),('14598','2013-10-17','11:40:00',3.41),('14598','2013-10-17','11:45:00',3.45),('14598','2013-10-17','11:50:00',3.48),('14598','2013-10-17','11:55:00',3.52),('14598','2013-10-17','12:00:00',3.57),('14598','2013-10-17','12:05:00',3.62),('14598','2013-10-17','12:10:00',3.65),('14598','2013-10-17','12:15:00',3.66),('14598','2013-10-17','12:20:00',3.68),('14598','2013-10-17','12:25:00',3.7),('14598','2013-10-17','12:30:00',3.71),('14598','2013-10-17','12:35:00',3.74),('14598','2013-10-17','12:40:00',3.76),('14598','2013-10-17','12:45:00',3.75),('14598','2013-10-17','12:50:00',3.77),('14598','2013-10-17','12:55:00',3.81),('14598','2013-10-17','13:00:00',3.81),('14598','2013-10-17','13:05:00',3.8),('14598','2013-10-17','13:10:00',3.83),('14598','2013-10-17','13:15:00',3.84),('14598','2013-10-17','13:20:00',3.82),('14598','2013-10-17','13:25:00',3.83),('14598','2013-10-17','13:30:00',3.85),('14598','2013-10-17','13:35:00',3.86),('14598','2013-10-17','13:40:00',3.85),('14598','2013-10-17','13:45:00',3.88),('14598','2013-10-17','13:50:00',3.87),('14598','2013-10-17','13:55:00',3.86),('14598','2013-10-17','14:00:00',3.86),('14598','2013-10-17','14:05:00',3.83),('14598','2013-10-17','14:10:00',3.81),('14598','2013-10-17','14:15:00',3.78),('14598','2013-10-17','14:20:00',3.76),('14598','2013-10-17','14:25:00',3.75),('14598','2013-10-17','14:30:00',3.73),('14598','2013-10-17','14:35:00',3.68),('14598','2013-10-17','14:40:00',3.64),('14598','2013-10-17','14:45:00',3.61),('14598','2013-10-17','14:50:00',3.58),('14598','2013-10-17','14:55:00',3.54),('14598','2013-10-17','15:00:00',3.49),('14598','2013-10-17','15:05:00',3.47),('14598','2013-10-17','15:10:00',3.41),('14598','2013-10-17','15:15:00',3.36),('14598','2013-10-17','15:20:00',3.31),('14598','2013-10-17','15:25:00',3.25),('14598','2013-10-17','15:30:00',3.2),('14598','2013-10-17','15:35:00',3.14),('14598','2013-10-17','15:40:00',3.07),('14598','2013-10-17','15:45:00',3.01),('14598','2013-10-17','15:50:00',2.95),('14598','2013-10-17','15:55:00',2.88),('14598','2013-10-17','16:00:00',1.88),('14598','2013-10-17','16:05:00',2.4),('14598','2013-10-17','16:10:00',2.64),('14598','2013-10-17','16:15:00',2.55),('14598','2013-10-17','16:25:00',2.22),('14598','2013-10-17','16:30:00',2.28),('14598','2013-10-17','16:35:00',2.18),('14598','2013-10-17','16:40:00',2.09),('14598','2013-10-17','16:45:00',1.98),('14598','2013-10-17','16:50:00',1.89),('14598','2013-10-17','16:55:00',1.79),('14598','2013-10-17','17:00:00',1.68),('14598','2013-10-17','17:05:00',1.57),('14598','2013-10-17','17:10:00',1.46),('14598','2013-10-17','17:15:00',1.36),('14598','2013-10-17','17:20:00',1.25),('14598','2013-10-17','17:25:00',1.15),('14598','2013-10-17','17:30:00',1.03),('14598','2013-10-16','09:05:00',1),('14598','2013-10-16','09:20:00',1.08),('14598','2013-10-16','09:25:00',1.02),('14598','2013-10-16','09:35:00',1.65),('14598','2013-10-16','09:40:00',1.89),('14598','2013-10-16','09:45:00',1.9),('14598','2013-10-16','10:20:00',1.02),('14598','2013-10-16','10:25:00',1.15),('14598','2013-10-16','10:30:00',1.49),('14598','2013-10-16','10:40:00',1.96),('14598','2013-10-16','10:45:00',2.51),('14598','2013-10-16','10:50:00',1.85),('14598','2013-10-16','10:55:00',1.28),('14598','2013-10-16','11:00:00',1.71),('14598','2013-10-16','11:05:00',1.86),('14598','2013-10-16','11:10:00',2.29),('14598','2013-10-16','11:15:00',3.67),('14598','2013-10-16','11:20:00',3.5),('14598','2013-10-16','11:25:00',3.43),('14598','2013-10-16','11:30:00',3.83),('14598','2013-10-16','11:35:00',4.11),('14598','2013-10-16','11:40:00',2.1),('14598','2013-10-16','11:50:00',1.36),('14598','2013-10-16','11:55:00',1.68),('14598','2013-10-16','12:00:00',1.29),('14598','2013-10-16','12:05:00',1.23),('14598','2013-10-16','12:10:00',3.3),('14598','2013-10-16','12:15:00',3.93),('14598','2013-10-16','12:20:00',4.01),('14598','2013-10-16','12:25:00',4.02),('14598','2013-10-16','12:30:00',3.77),('14598','2013-10-16','12:35:00',3.97),('14598','2013-10-16','12:40:00',3.28),('14598','2013-10-16','12:45:00',3.32),('14598','2013-10-16','12:50:00',3.48),('14598','2013-10-16','12:55:00',2.77),('14598','2013-10-16','13:00:00',2.9),('14598','2013-10-16','13:05:00',4.02),('14598','2013-10-16','13:10:00',3.88),('14598','2013-10-16','13:15:00',3.93),('14598','2013-10-16','13:20:00',3.98),('14598','2013-10-16','13:25:00',3.85),('14598','2013-10-16','13:30:00',3.88),('14598','2013-10-16','13:35:00',3.71),('14598','2013-10-16','13:40:00',2.58),('14598','2013-10-16','13:45:00',3.59),('14598','2013-10-16','13:50:00',4.18),('14598','2013-10-16','13:55:00',4.1),('14598','2013-10-16','14:00:00',3.85),('14598','2013-10-16','14:05:00',3.66),('14598','2013-10-16','14:10:00',2.66),('14598','2013-10-16','14:15:00',3.75),('14598','2013-10-16','14:20:00',3.75),('14598','2013-10-16','14:25:00',3.72),('14598','2013-10-16','14:30:00',3.68),('14598','2013-10-16','14:35:00',3.65),('14598','2013-10-16','14:40:00',3.59),('14598','2013-10-16','14:45:00',3.59),('14598','2013-10-16','14:50:00',2.81),('14598','2013-10-16','14:55:00',3.08),('14598','2013-10-16','15:00:00',3.4),('14598','2013-10-16','15:05:00',3.36),('14598','2013-10-16','15:10:00',3.34),('14598','2013-10-16','15:15:00',3.24),('14598','2013-10-16','15:20:00',3.2),('14598','2013-10-16','15:25:00',3.14),('14598','2013-10-16','15:30:00',3.09),('14598','2013-10-16','15:35:00',3.02),('14598','2013-10-16','15:40:00',2.98),('14598','2013-10-16','15:45:00',2.91),('14598','2013-10-16','15:50:00',2.84),('14598','2013-10-16','15:55:00',2.76),('14598','2013-10-16','16:00:00',2.69),('14598','2013-10-16','16:05:00',2.62),('14598','2013-10-16','16:10:00',2.54),('14598','2013-10-16','16:15:00',2.46),('14598','2013-10-16','16:20:00',2.37),('14598','2013-10-16','16:25:00',2.28),('14598','2013-10-16','16:30:00',2.2),('14598','2013-10-16','16:35:00',2.11),('14598','2013-10-16','16:40:00',2.02),('14598','2013-10-16','16:45:00',1.93),('14598','2013-10-16','16:50:00',1.86),('14598','2013-10-16','16:55:00',1.76),('14598','2013-10-16','17:00:00',1.66),('14598','2013-10-16','17:05:00',1.56),('14598','2013-10-16','17:10:00',1.45),('14598','2013-10-16','17:15:00',1.34),('14598','2013-10-16','17:20:00',1.22),('14598','2013-10-16','17:25:00',1.09),('14598','2013-10-15','09:25:00',1.11),('14598','2013-10-15','09:30:00',1.47),('14598','2013-10-15','09:35:00',1.86),('14598','2013-10-15','09:40:00',2.01),('14598','2013-10-15','09:45:00',2.04),('14598','2013-10-15','09:50:00',2.28),('14598','2013-10-15','09:55:00',1.92),('14598','2013-10-15','10:00:00',1.33),('14598','2013-10-15','10:05:00',1.4),('14598','2013-10-15','10:10:00',1.76),('14598','2013-10-15','10:22:00',2.18),('14598','2013-10-15','10:25:00',2.53),('14598','2013-10-15','10:30:00',2.66),('14598','2013-10-15','10:35:00',2.04),('14598','2013-10-15','10:40:00',1.83),('14598','2013-10-15','10:45:00',1.89),('14598','2013-10-15','10:50:00',2.49),('14598','2013-10-15','10:55:00',2.94),('14598','2013-10-15','11:00:00',2.96),('14598','2013-10-15','11:05:00',2.77),('14598','2013-10-15','11:10:00',2.54),('14598','2013-10-15','11:15:00',2.78),('14598','2013-10-15','11:20:00',2.24),('14598','2013-10-15','11:25:00',1.91),('14598','2013-10-15','11:30:00',1.82),('14598','2013-10-15','11:35:00',1.84),('14598','2013-10-15','11:40:00',1.8),('14598','2013-10-15','11:45:00',1.71),('14598','2013-10-15','11:50:00',1.65),('14598','2013-10-15','11:55:00',1.68),('14598','2013-10-15','12:00:00',1.75),('14598','2013-10-15','12:05:00',1.82),('14598','2013-10-15','12:10:00',1.59),('14598','2013-10-15','12:15:00',1.57),('14598','2013-10-15','12:20:00',1.6),('14598','2013-10-15','12:25:00',1.73),('14598','2013-10-15','12:30:00',1.84),('14598','2013-10-15','12:35:00',1.69),('14598','2013-10-15','12:40:00',1.63),('14598','2013-10-15','12:45:00',1.75),('14598','2013-10-15','12:50:00',2.24),('14598','2013-10-15','12:55:00',1.98),('14598','2013-10-15','13:00:00',2.46),('14598','2013-10-15','13:05:00',3.46),('14598','2013-10-15','13:10:00',3),('14598','2013-10-15','13:15:00',2.5),('14598','2013-10-15','13:20:00',1.96),('14598','2013-10-15','13:25:00',2.06),('14598','2013-10-15','13:30:00',2),('14598','2013-10-15','13:40:00',1.53),('14598','2013-10-15','13:45:00',1.37),('14598','2013-10-15','13:50:00',1.53),('14598','2013-10-15','13:55:00',1.77),('14598','2013-10-15','14:00:00',2.19),('14598','2013-10-15','14:05:00',2.51),('14598','2013-10-15','14:10:00',2.71),('14598','2013-10-15','14:15:00',2.12),('14598','2013-10-15','14:20:00',1.91),('14598','2013-10-15','14:25:00',2.52),('14598','2013-10-15','14:30:00',3.3),('14598','2013-10-15','14:35:00',2.74),('14598','2013-10-15','14:40:00',1.81),('14598','2013-10-15','14:45:00',1.6),('14598','2013-10-15','14:50:00',1.95),('14598','2013-10-15','14:55:00',1.87),('14598','2013-10-15','15:00:00',1.57),('14598','2013-10-15','15:05:00',1.51),('14598','2013-10-15','15:10:00',1.31),('14598','2013-10-15','15:15:00',1.22),('14598','2013-10-15','15:20:00',1.27),('14598','2013-10-15','15:25:00',1.27),('14598','2013-10-15','15:30:00',1.17),('14598','2013-10-15','15:35:00',1.03),('14598','2013-10-15','16:05:00',1.19),('14598','2013-10-15','16:10:00',1.41),('14598','2013-10-15','16:15:00',1.42),('14598','2013-10-15','16:20:00',1.25),('14598','2013-10-15','16:25:00',1.01),('14598','2013-10-15','16:35:00',1.45),('14598','2013-10-15','16:40:00',1.62),('14598','2013-10-15','16:45:00',1.08),('14598','2013-10-14','09:10:00',1.14),('14598','2013-10-14','09:15:00',1.26),('14598','2013-10-14','09:20:00',1.15),('14598','2013-10-14','09:30:00',1.33),('14598','2013-10-14','09:35:00',1.41),('14598','2013-10-14','09:40:00',1.68),('14598','2013-10-14','09:45:00',1.7),('14598','2013-10-14','09:50:00',1.88),('14598','2013-10-14','09:55:00',1.94),('14598','2013-10-14','10:00:00',2.02),('14598','2013-10-14','10:05:00',2.06),('14598','2013-10-14','10:10:00',2.18),('14598','2013-10-14','10:15:00',2.23),('14598','2013-10-14','10:20:00',2.28),('14598','2013-10-14','10:25:00',2.33),('14598','2013-10-14','10:30:00',2.4),('14598','2013-10-14','10:35:00',2.43),('14598','2013-10-14','10:40:00',2.57),('14598','2013-10-14','10:45:00',2.69),('14598','2013-10-14','10:50:00',2.72),('14598','2013-10-14','10:55:00',2.73),('14598','2013-10-14','11:00:00',2.9),('14598','2013-10-14','11:05:00',2.85),('14598','2013-10-14','11:10:00',2.98),('14598','2013-10-14','11:15:00',3.09),('14598','2013-10-14','11:20:00',3.11),('14598','2013-10-14','11:25:00',3.02),('14598','2013-10-14','11:30:00',3.06),('14598','2013-10-14','11:35:00',2.99),('14598','2013-10-14','11:40:00',3.18),('14598','2013-10-14','11:45:00',3.27),('14598','2013-10-14','11:50:00',3.3),('14598','2013-10-14','11:55:00',3.4),('14598','2013-10-14','12:00:00',3.29),('14598','2013-10-14','12:05:00',3.12),('14598','2013-10-14','12:10:00',3.37),('14598','2013-10-14','12:15:00',3.43),('14598','2013-10-14','12:20:00',3.54),('14598','2013-10-14','12:25:00',3.52),('14598','2013-10-14','12:30:00',3.52),('14598','2013-10-14','12:35:00',3.56),('14598','2013-10-14','12:40:00',3.56),('14598','2013-10-14','12:45:00',3.59),('14598','2013-10-14','12:50:00',3.56),('14598','2013-10-14','12:55:00',3.64),('14598','2013-10-14','13:00:00',3.65),('14598','2013-10-14','13:05:00',3.65),('14598','2013-10-14','13:10:00',3.65),('14598','2013-10-14','13:15:00',3.68),('14598','2013-10-14','13:20:00',3.64),('14598','2013-10-14','13:25:00',3.65),('14598','2013-10-14','13:30:00',3.65),('14598','2013-10-14','13:35:00',3.65),('14598','2013-10-14','13:40:00',3.61),('14598','2013-10-14','13:45:00',3.62),('14598','2013-10-14','13:50:00',3.6),('14598','2013-10-14','13:55:00',3.59),('14598','2013-10-14','14:00:00',3.55),('14598','2013-10-14','14:05:00',3.53),('14598','2013-10-14','14:10:00',3.52),('14598','2013-10-14','14:15:00',3.5),('14598','2013-10-14','14:20:00',3.46),('14598','2013-10-14','14:25:00',3.44),('14598','2013-10-14','14:30:00',3.43),('14598','2013-10-14','14:35:00',3.37),('14598','2013-10-14','14:40:00',3.35),('14598','2013-10-14','14:45:00',3.32),('14598','2013-10-14','14:50:00',3.27),('14598','2013-10-14','14:55:00',3.21),('14598','2013-10-14','15:00:00',3.19),('14598','2013-10-14','15:05:00',3.14),('14598','2013-10-14','15:10:00',3.09),('14598','2013-10-14','15:15:00',3.08),('14598','2013-10-14','15:20:00',3.04),('14598','2013-10-14','15:25:00',3.01),('14598','2013-10-14','15:30:00',2.89),('14598','2013-10-14','15:35:00',2.76),('14598','2013-10-14','15:40:00',2.83),('14598','2013-10-14','15:45:00',2.37),('14598','2013-10-14','15:50:00',1.7),('14598','2013-10-14','15:55:00',2.09),('14598','2013-10-14','16:00:00',2.27),('14598','2013-10-14','16:05:00',1.82),('14598','2013-10-14','16:10:00',1.87),('14598','2013-10-14','16:25:00',1.33),('14598','2013-10-14','16:30:00',2.44),('14598','2013-10-14','16:35:00',1.35),('14598','2013-10-14','16:40:00',1.18),('14598','2013-10-14','16:55:00',1.01),('14598','2013-10-14','17:00:00',1.22),('14598','2013-10-14','17:05:00',1.43),('14598','2013-10-14','17:10:00',1.37),('14598','2013-10-14','17:15:00',1.32),('14598','2013-10-14','17:20:00',1.15),('14598','2013-10-14','17:25:00',1.02),('14598','2013-10-13','09:20:00',1.05),('14598','2013-10-13','09:25:00',1.24),('14598','2013-10-13','09:30:00',1.26),('14598','2013-10-13','09:35:00',1.4),('14598','2013-10-13','09:40:00',1.17),('14598','2013-10-13','09:45:00',1.02),('14598','2013-10-13','09:50:00',1.64),('14598','2013-10-13','09:55:00',1.39),('14598','2013-10-13','10:00:00',1.03),('14598','2013-10-13','10:05:00',1.01),('14598','2013-10-13','10:10:00',1.34),('14598','2013-10-13','10:15:00',2.48),('14598','2013-10-13','10:20:00',2.21),('14598','2013-10-13','10:25:00',2.36),('14598','2013-10-13','10:30:00',2.04),('14598','2013-10-13','10:35:00',2.86),('14598','2013-10-13','10:40:00',2.02),('14598','2013-10-13','10:45:00',1.88),('14598','2013-10-13','10:50:00',2.82),('14598','2013-10-13','10:55:00',2.19),('14598','2013-10-13','11:00:00',2.2),('14598','2013-10-13','11:05:00',2.22),('14598','2013-10-13','11:10:00',2.22),('14598','2013-10-13','11:15:00',2.41),('14598','2013-10-13','11:20:00',3.25),('14598','2013-10-13','11:25:00',3.33),('14598','2013-10-13','11:30:00',3.32),('14598','2013-10-13','11:35:00',3.15),('14598','2013-10-13','11:40:00',3.27),('14598','2013-10-13','11:45:00',3.37),('14598','2013-10-13','11:50:00',3.43),('14598','2013-10-13','11:55:00',3.49),('14598','2013-10-13','12:00:00',3.49),('14598','2013-10-13','12:05:00',3.55),('14598','2013-10-13','12:10:00',3.62),('14598','2013-10-13','12:15:00',3.57),('14598','2013-10-13','12:20:00',3.46),('14598','2013-10-13','12:25:00',3.69),('14598','2013-10-13','12:30:00',3.64),('14598','2013-10-13','12:35:00',3.65),('14598','2013-10-13','12:40:00',3.65),('14598','2013-10-13','12:45:00',3.66),('14598','2013-10-13','12:50:00',3.72),('14598','2013-10-13','12:55:00',3.77),('14598','2013-10-13','13:00:00',3.82),('14598','2013-10-13','13:05:00',3.88),('14598','2013-10-13','13:10:00',3.8),('14598','2013-10-13','13:15:00',3.79),('14598','2013-10-13','13:20:00',3.83),('14598','2013-10-13','13:25:00',3.89),('14598','2013-10-13','13:30:00',3.89),('14598','2013-10-13','13:35:00',3.37),('14598','2013-10-13','13:40:00',3.5),('14598','2013-10-13','13:45:00',3.89),('14598','2013-10-13','13:50:00',3.06),('14598','2013-10-13','13:55:00',3.77),('14598','2013-10-13','14:00:00',3.31),('14598','2013-10-13','14:05:00',4.13),('14598','2013-10-13','14:10:00',4.17),('14598','2013-10-13','14:15:00',3.35),('14598','2013-10-13','14:20:00',3.43),('14598','2013-10-13','14:25:00',2.81),('14598','2013-10-13','14:30:00',3.29),('14598','2013-10-13','14:35:00',3.4),('14598','2013-10-13','14:40:00',3),('14598','2013-10-13','14:45:00',2.85),('14598','2013-10-13','14:50:00',3.01),('14598','2013-10-13','14:55:00',2.8),('14598','2013-10-13','15:00:00',3.03),('14598','2013-10-13','15:05:00',3.07),('14598','2013-10-13','15:10:00',2.26),('14598','2013-10-13','15:15:00',2.53),('14598','2013-10-13','15:20:00',2.08),('14598','2013-10-13','15:25:00',1.61),('14598','2013-10-13','15:30:00',1.92),('14598','2013-10-13','15:35:00',2.33),('14598','2013-10-13','15:40:00',2.67),('14598','2013-10-13','15:45:00',2.34),('14598','2013-10-13','15:50:00',2.87),('14598','2013-10-13','15:55:00',2.72),('14598','2013-10-13','16:00:00',2.33),('14598','2013-10-13','16:05:00',2.54),('14598','2013-10-13','16:10:00',2.39),('14598','2013-10-13','16:15:00',2.23),('14598','2013-10-13','16:20:00',2.05),('14598','2013-10-13','16:25:00',2.26),('14598','2013-10-13','16:30:00',1.77),('14598','2013-10-13','16:35:00',1.38),('14598','2013-10-13','16:55:00',1.1),('14598','2013-10-13','17:00:00',1.02),('14598','2013-10-13','17:05:00',1.12),('14598','2013-10-13','17:10:00',1.51),('14598','2013-10-13','17:15:00',1.15),('14598','2013-10-13','17:20:00',1.25),('14598','2013-10-13','17:25:00',1.35),('14598','2013-10-13','17:30:00',1.03),('14598','2013-10-12','11:15:00',1.25),('14598','2013-10-12','11:20:00',1.87),('14598','2013-10-12','11:25:00',1.94),('14598','2013-10-12','11:30:00',1.66),('14598','2013-10-12','11:35:00',1.21),('14598','2013-10-12','11:50:00',1.1),('14598','2013-10-12','11:55:00',1.3),('14598','2013-10-12','12:00:00',1.43),('14598','2013-10-12','12:05:00',2.26),('14598','2013-10-12','12:10:00',3.69),('14598','2013-10-12','12:15:00',1.88),('14598','2013-10-12','12:20:00',1.75),('14598','2013-10-12','12:25:00',3.07),('14598','2013-10-12','12:30:00',3.9),('14598','2013-10-12','12:35:00',3.89),('14598','2013-10-12','12:40:00',2.78),('14598','2013-10-12','12:45:00',2.13),('14598','2013-10-12','12:50:00',1.88),('14598','2013-10-12','12:55:00',1.84),('14598','2013-10-12','13:00:00',1.49),('14598','2013-10-12','13:05:00',1.31),('14598','2013-10-12','13:10:00',1.23),('14598','2013-10-12','14:50:00',1.06),('14598','2013-10-12','14:55:00',1.04),('14598','2013-10-12','15:00:00',1.14),('14598','2013-10-12','15:05:00',1.22),('14598','2013-10-12','15:10:00',1.08),('14598','2013-10-12','15:15:00',1.02),('14598','2013-10-12','15:20:00',1.09),('14598','2013-10-12','15:25:00',1.08),('14598','2013-10-12','15:30:00',1.03),('14598','2013-10-12','15:40:00',1.03),('14598','2013-10-12','16:10:00',1.65),('14598','2013-10-12','16:15:00',1.5),('14598','2013-10-12','16:20:00',1.86),('14598','2013-10-12','16:25:00',2.48),('14598','2013-10-12','16:30:00',1.6),('14598','2013-10-12','16:35:00',1.46),('14598','2013-10-12','16:40:00',1.15),('14598','2013-10-12','17:00:00',1.09),('14598','2013-10-12','17:05:00',1.25),('14598','2013-10-11','08:50:00',1),('14598','2013-10-11','08:55:00',1.19),('14598','2013-10-11','09:30:00',1.43),('14598','2013-10-11','09:35:00',1.53),('14598','2013-10-11','09:40:00',2.12),('14598','2013-10-11','09:45:00',2.12),('14598','2013-10-11','09:50:00',2.16),('14598','2013-10-11','09:55:00',2.22),('14598','2013-10-11','10:00:00',2.03),('14598','2013-10-11','10:05:00',2.47),('14598','2013-10-11','10:10:00',2.51),('14598','2013-10-11','10:15:00',2.59),('14598','2013-10-11','10:20:00',1.93),('14598','2013-10-11','10:25:00',2.11),('14598','2013-10-11','10:30:00',2.16),('14598','2013-10-11','10:35:00',2.91),('14598','2013-10-11','10:40:00',1.63),('14598','2013-10-11','10:45:00',1.5),('14598','2013-10-11','10:50:00',1.95),('14598','2013-10-11','10:55:00',1.91),('14598','2013-10-11','11:00:00',1.85),('14598','2013-10-11','11:05:00',1.52),('14598','2013-10-11','11:10:00',1.42),('14598','2013-10-11','11:15:00',1.47),('14598','2013-10-11','11:20:00',1.54),('14598','2013-10-11','11:25:00',1.68),('14598','2013-10-11','11:30:00',2.64),('14598','2013-10-11','11:35:00',2.08),('14598','2013-10-11','11:40:00',2.62),('14598','2013-10-11','11:45:00',1.55),('14598','2013-10-11','11:50:00',2.81),('14598','2013-10-11','11:55:00',3.65),('14598','2013-10-11','12:00:00',1.63),('14598','2013-10-11','12:10:00',2.03),('14598','2013-10-11','12:15:00',4.71),('14598','2013-10-11','12:20:00',5.2),('14598','2013-10-11','12:25:00',5.19),('14598','2013-10-11','12:30:00',4.9),('14598','2013-10-11','12:35:00',4.9),('14598','2013-10-11','12:40:00',4.81),('14598','2013-10-11','12:45:00',2.4),('14598','2013-10-11','12:50:00',3.41),('14598','2013-10-11','12:55:00',3.95),('14598','2013-10-11','13:00:00',1.45),('14598','2013-10-11','13:05:00',2.09),('14598','2013-10-11','13:10:00',4.2),('14598','2013-10-11','13:15:00',4.16),('14598','2013-10-11','13:20:00',4.17),('14598','2013-10-11','13:25:00',4.45),('14598','2013-10-11','13:30:00',4.4),('14598','2013-10-11','13:35:00',3.2),('14598','2013-10-11','13:40:00',1.31),('14598','2013-10-11','13:45:00',1.2),('14598','2013-10-11','13:50:00',1.64),('14598','2013-10-11','13:55:00',1.7),('14598','2013-10-11','14:00:00',1.87),('14598','2013-10-11','14:05:00',1.59),('14598','2013-10-11','14:10:00',1.79),('14598','2013-10-11','14:15:00',2.15),('14598','2013-10-11','14:20:00',1.67),('14598','2013-10-11','14:25:00',4.07),('14598','2013-10-11','14:30:00',3.84),('14598','2013-10-11','14:35:00',4.4),('14598','2013-10-11','14:40:00',3.5),('14598','2013-10-11','14:45:00',1.1),('14598','2013-10-11','14:50:00',1.02),('14598','2013-10-11','14:55:00',4.13),('14598','2013-10-11','15:00:00',3.7),('14598','2013-10-11','15:05:00',3.41),('14598','2013-10-11','15:10:00',3.56),('14598','2013-10-11','15:15:00',3.52),('14598','2013-10-11','15:20:00',3.56),('14598','2013-10-11','15:25:00',3.32),('14598','2013-10-11','15:30:00',3.23),('14598','2013-10-11','15:35:00',3.12),('14598','2013-10-11','15:40:00',3.13),('14598','2013-10-11','15:45:00',3.06),('14598','2013-10-11','15:50:00',3),('14598','2013-10-11','15:55:00',2.9),('14598','2013-10-11','16:00:00',2.82),('14598','2013-10-11','16:05:00',2.72),('14598','2013-10-11','16:10:00',2.66),('14598','2013-10-11','16:15:00',2.58),('14598','2013-10-11','16:20:00',2.51),('14598','2013-10-11','16:25:00',2.43),('14598','2013-10-11','16:30:00',2.32),('14598','2013-10-11','16:35:00',2.23),('14598','2013-10-11','16:40:00',2.14),('14598','2013-10-11','16:45:00',2.06),('14598','2013-10-11','16:50:00',1.96),('14598','2013-10-11','16:55:00',1.86),('14598','2013-10-11','17:00:00',1.77),('14598','2013-10-11','17:05:00',1.67),('14598','2013-10-11','17:10:00',1.63),('14598','2013-10-11','17:15:00',1.69),('14598','2013-10-11','17:20:00',1.66),('14598','2013-10-11','17:25:00',1.28),('14598','2013-10-11','17:30:00',1.11),('14598','2013-10-11','17:35:00',1),('14598','2013-10-10','09:05:00',1.04),('14598','2013-10-10','09:10:00',1.13),('14598','2013-10-10','09:15:00',1.23),('14598','2013-10-10','09:20:00',1.4),('14598','2013-10-10','09:25:00',1.52),('14598','2013-10-10','09:30:00',1.61),('14598','2013-10-10','09:35:00',1.7),('14598','2013-10-10','09:40:00',1.72),('14598','2013-10-10','09:45:00',1.87),('14598','2013-10-10','09:50:00',1.98),('14598','2013-10-10','09:55:00',2.07),('14598','2013-10-10','10:00:00',2.15),('14598','2013-10-10','10:05:00',2.21),('14598','2013-10-10','10:10:00',2.31),('14598','2013-10-10','10:15:00',2.4),('14598','2013-10-10','10:20:00',2.45),('14598','2013-10-10','10:25:00',2.48),('14598','2013-10-10','10:30:00',2.61),('14598','2013-10-10','10:35:00',2.74),('14598','2013-10-10','10:40:00',2.82),('14598','2013-10-10','10:45:00',1.11),('14598','2013-10-10','10:55:00',1.32),('14598','2013-10-10','11:00:00',3.15),('14598','2013-10-10','11:05:00',3.41),('14598','2013-10-10','11:10:00',3.37),('14598','2013-10-10','11:15:00',3.36),('14598','2013-10-10','11:20:00',3.38),('14598','2013-10-10','11:25:00',3.47),('14598','2013-10-10','11:30:00',3.2),('14598','2013-10-10','11:35:00',3.6),('14598','2013-10-10','11:40:00',2.96),('14598','2013-10-10','11:45:00',3.7),('14598','2013-10-10','11:50:00',3.82),('14598','2013-10-10','11:55:00',3.68),('14598','2013-10-10','12:00:00',2.98),('14598','2013-10-10','12:05:00',4.59),('14598','2013-10-10','12:10:00',4.31),('14598','2013-10-10','12:15:00',3.93),('14598','2013-10-10','12:20:00',3.91),('14598','2013-10-10','12:25:00',3.92),('14598','2013-10-10','12:30:00',3.94),('14598','2013-10-10','12:35:00',3.98),('14598','2013-10-10','12:40:00',4.09),('14598','2013-10-10','12:45:00',4.11),('14598','2013-10-10','12:50:00',4.1),('14598','2013-10-10','12:55:00',4.1),('14598','2013-10-10','13:00:00',3.96),('14598','2013-10-10','13:05:00',4.04),('14598','2013-10-10','13:10:00',4.06),('14598','2013-10-10','13:15:00',4.06),('14598','2013-10-10','13:20:00',4.08),('14598','2013-10-10','13:25:00',4.09),('14598','2013-10-10','13:30:00',4),('14598','2013-10-10','13:35:00',4.1),('14598','2013-10-10','13:40:00',4.15),('14598','2013-10-10','13:45:00',4.22),('14598','2013-10-10','13:50:00',4.08),('14598','2013-10-10','13:55:00',4.12),('14598','2013-10-10','14:00:00',4.16),('14598','2013-10-10','14:05:00',4.19),('14598','2013-10-10','14:10:00',4.09),('14598','2013-10-10','14:15:00',4.08),('14598','2013-10-10','14:20:00',4),('14598','2013-10-10','14:25:00',4),('14598','2013-10-10','14:30:00',4.12),('14598','2013-10-10','14:35:00',3.97),('14598','2013-10-10','14:40:00',3.92),('14598','2013-10-10','14:45:00',3.78),('14598','2013-10-10','14:50:00',3.82),('14598','2013-10-10','14:55:00',3.74),('14598','2013-10-10','15:00:00',3.72),('14598','2013-10-10','15:05:00',2.94),('14598','2013-10-10','15:10:00',3.06),('14598','2013-10-10','15:15:00',3.33),('14598','2013-10-10','15:20:00',3.53),('14598','2013-10-10','15:25:00',1.24),('14598','2013-10-10','15:30:00',3.27),('14598','2013-10-10','15:35:00',2.93),('14598','2013-10-10','15:40:00',2.21),('14598','2013-10-10','15:45:00',2.01),('14598','2013-10-10','15:50:00',2.98),('14598','2013-10-10','15:55:00',1.7),('14598','2013-10-10','16:00:00',1.75),('14598','2013-10-10','16:10:00',3.45),('14598','2013-10-10','16:15:00',2.31),('14598','2013-10-10','16:30:00',1.42),('14598','2013-10-10','16:35:00',1.1),('14598','2013-10-10','16:40:00',2.22),('14598','2013-10-10','16:45:00',1.99),('14598','2013-10-10','16:50:00',2.14),('14598','2013-10-10','16:55:00',2.05),('14598','2013-10-10','17:00:00',1.95),('14598','2013-10-10','17:05:00',1.83),('14598','2013-10-10','17:10:00',1.72),('14598','2013-10-10','17:15:00',1.48),('14598','2013-10-10','17:20:00',1.29),('14598','2013-10-09','08:50:00',1.02),('14598','2013-10-09','08:55:00',1.25),('14598','2013-10-09','09:00:00',1.03),('14598','2013-10-09','09:10:00',1.41),('14598','2013-10-09','09:30:00',1.21),('14598','2013-10-09','09:55:00',1.64),('14598','2013-10-09','10:00:00',2.25),('14598','2013-10-09','10:05:00',2.44),('14598','2013-10-09','10:10:00',2.54),('14598','2013-10-09','10:15:00',2.64),('14598','2013-10-09','10:20:00',2.6),('14598','2013-10-09','10:25:00',2.63),('14598','2013-10-09','10:30:00',2.92),('14598','2013-10-09','10:35:00',2.97),('14598','2013-10-09','10:40:00',2.53),('14598','2013-10-09','10:45:00',3.06),('14598','2013-10-09','10:50:00',2.96),('14598','2013-10-09','10:55:00',3.35),('14598','2013-10-09','11:00:00',3.35),('14598','2013-10-09','11:05:00',1.4),('14598','2013-10-09','11:10:00',2.14),('14598','2013-10-09','11:15:00',3.56),('14598','2013-10-09','11:20:00',3.58),('14598','2013-10-09','11:25:00',3),('14598','2013-10-09','11:30:00',1.53),('14598','2013-10-09','11:35:00',1.75),('14598','2013-10-09','11:40:00',2.21),('14598','2013-10-09','11:45:00',2.72),('14598','2013-10-09','11:50:00',3.7),('14598','2013-10-09','11:55:00',2.34),('14598','2013-10-09','12:00:00',3.01),('14598','2013-10-09','12:05:00',2.12),('14598','2013-10-09','12:10:00',1.07),('14598','2013-10-09','12:15:00',3.3),('14598','2013-10-09','12:20:00',4.08),('14598','2013-10-09','12:25:00',4.43),('14598','2013-10-09','12:30:00',3.68),('14598','2013-10-09','12:35:00',2.08),('14598','2013-10-09','12:40:00',2.91),('14598','2013-10-09','12:45:00',3.25),('14598','2013-10-09','12:50:00',3.69),('14598','2013-10-09','12:55:00',4.6),('14598','2013-10-09','13:00:00',4.2),('14598','2013-10-09','13:05:00',4.33),('14598','2013-10-09','13:10:00',4.3),('14598','2013-10-09','13:15:00',4.31),('14598','2013-10-09','13:20:00',4.32),('14598','2013-10-09','13:25:00',4.34),('14598','2013-10-09','13:30:00',4.23),('14598','2013-10-09','13:35:00',2.16),('14598','2013-10-09','13:40:00',2.29),('14598','2013-10-09','13:45:00',4.47),('14598','2013-10-09','13:50:00',4.32),('14598','2013-10-09','13:55:00',4.24),('14598','2013-10-09','14:00:00',4.37),('14598','2013-10-09','14:05:00',4.36),('14598','2013-10-09','14:10:00',2.88),('14598','2013-10-09','14:15:00',1.42),('14598','2013-10-09','14:20:00',3.11),('14598','2013-10-09','14:25:00',1.32),('14598','2013-10-09','14:30:00',1.23),('14598','2013-10-09','14:35:00',1.34),('14598','2013-10-09','14:40:00',1.31),('14598','2013-10-09','14:45:00',1.54),('14598','2013-10-09','14:50:00',1.55),('14598','2013-10-09','14:55:00',1.49),('14598','2013-10-09','15:00:00',1.35),('14598','2013-10-09','15:05:00',1.29),('14598','2013-10-09','15:10:00',1.22),('14598','2013-10-09','15:15:00',1.56),('14598','2013-10-09','15:20:00',1.6),('14598','2013-10-09','15:25:00',1.46),('14598','2013-10-09','15:30:00',1.11),('14598','2013-10-09','15:35:00',1.65),('14598','2013-10-09','15:40:00',2.28),('14598','2013-10-09','15:45:00',1.37),('14598','2013-10-09','15:50:00',1.45),('14598','2013-10-09','15:55:00',1.27),('14598','2013-10-09','16:00:00',1.67),('14598','2013-10-09','16:05:00',1.87),('14598','2013-10-09','16:10:00',3.55),('14598','2013-10-09','16:15:00',2.89),('14598','2013-10-09','16:20:00',2.71),('14598','2013-10-09','16:25:00',2.63),('14598','2013-10-09','16:30:00',2.56),('14598','2013-10-09','16:35:00',2.49),('14598','2013-10-09','16:40:00',1.92),('14598','2013-10-09','16:45:00',2.34),('14598','2013-10-09','16:50:00',2.67),('14598','2013-10-09','16:55:00',1.85),('14598','2013-10-09','17:00:00',1.92),('14598','2013-10-09','17:05:00',1.77),('14598','2013-10-09','17:10:00',2.25),('14598','2013-10-09','17:15:00',1.94),('14598','2013-10-09','17:20:00',1.59),('14598','2013-10-09','17:25:00',1.48),('14598','2013-10-09','17:30:00',1.38),('14598','2013-10-09','17:35:00',1.23),('14598','2014-04-15','08:05:00',1.05),('14598','2014-04-15','08:45:00',1.1),('14598','2014-04-15','08:55:00',1.58),('14598','2014-04-15','09:05:00',1.11),('14598','2014-04-15','09:10:00',2.46),('14598','2014-04-15','09:15:00',2.57),('14598','2014-04-15','09:20:00',2.36),('14598','2014-04-15','09:25:00',2.07),('14598','2014-04-15','09:30:00',2.7),('14598','2014-04-15','09:35:00',1.54),('14598','2014-04-15','09:40:00',2.12),('14598','2014-04-15','09:45:00',2.05),('14598','2014-04-15','09:50:00',2.03),('14598','2014-04-15','09:55:00',1.79),('14598','2014-04-15','10:00:00',1.47),('14598','2014-04-15','10:05:00',1.29),('14598','2014-04-15','10:10:00',1.98),('14598','2014-04-15','10:15:00',2.49),('14598','2014-04-15','10:20:00',4),('14598','2014-04-15','10:25:00',3.99),('14598','2014-04-15','10:30:00',2.64),('14598','2014-04-15','10:35:00',3.66),('14598','2014-04-15','10:40:00',4.01),('14598','2014-04-15','10:45:00',1.92),('14598','2014-04-15','10:50:00',1.94),('14598','2014-04-15','10:55:00',2.09),('14598','2014-04-15','11:00:00',1.65),('14598','2014-04-15','11:05:00',2.26),('14598','2014-04-15','11:10:00',1.63),('14598','2014-04-15','11:15:00',1.72),('14598','2014-04-15','11:20:00',1.26),('14598','2014-04-15','11:25:00',1.13),('14598','2014-04-15','11:30:00',2.06),('14598','2014-04-15','11:35:00',4.47),('14598','2014-04-15','11:40:00',2.46),('14598','2014-04-15','11:45:00',3.12),('14598','2014-04-15','11:50:00',4.26),('14598','2014-04-15','11:55:00',2.14),('14598','2014-04-15','12:00:00',2.13),('14598','2014-04-15','12:05:00',1.85),('14598','2014-04-15','12:10:00',1.85),('14598','2014-04-15','12:15:00',1.5),('14598','2014-04-15','12:20:00',1.61),('14598','2014-04-15','12:25:00',1.08),('14598','2014-04-15','12:30:00',3.99),('14598','2014-04-15','12:35:00',2.4),('14598','2014-04-15','12:40:00',2.67),('14598','2014-04-15','12:45:00',2.45),('14598','2014-04-15','12:50:00',3.15),('14598','2014-04-15','12:55:00',2.76),('14598','2014-04-15','13:00:00',4.1),('14598','2014-04-15','13:05:00',2.51),('14598','2014-04-15','13:10:00',3.62),('14598','2014-04-15','13:15:00',5.28),('14598','2014-04-15','13:20:00',4.42),('14598','2014-04-15','13:25:00',2.95),('14598','2014-04-15','13:30:00',3.57),('14598','2014-04-15','13:35:00',3.81),('14598','2014-04-15','13:40:00',4.49),('14598','2014-04-15','13:45:00',4.07),('14598','2014-04-15','13:50:00',4.29),('14598','2014-04-15','13:55:00',4.97),('14598','2014-04-15','14:00:00',5.25),('14598','2014-04-15','14:05:00',5.06),('14598','2014-04-15','14:10:00',4.82),('14598','2014-04-15','14:15:00',3.99),('14598','2014-04-15','14:20:00',3.86),('14598','2014-04-15','14:25:00',4.15),('14598','2014-04-15','14:30:00',4.99),('14598','2014-04-15','14:35:00',4.66),('14598','2014-04-15','14:40:00',4.81),('14598','2014-04-15','14:45:00',4.39),('14598','2014-04-15','14:50:00',4.77),('14598','2014-04-15','14:55:00',4.77),('14598','2014-04-15','15:00:00',4.73),('14598','2014-04-15','15:05:00',4.06),('14598','2014-04-15','15:10:00',4.88),('14598','2014-04-15','15:15:00',4.73),('14598','2014-04-15','15:20:00',3.87),('14598','2014-04-15','15:25:00',4.5),('14598','2014-04-15','15:30:00',4.16),('14598','2014-04-15','15:35:00',4.68),('14598','2014-04-15','15:40:00',4.3),('14598','2014-04-15','15:45:00',4.55),('14598','2014-04-15','15:50:00',4.4),('14598','2014-04-15','15:55:00',4.21),('14598','2014-04-15','16:00:00',2.19),('14598','2014-04-15','16:05:00',1.46),('14598','2013-10-08','09:00:00',1),('14598','2013-10-08','09:05:00',1.08),('14598','2013-10-08','09:10:00',1.18),('14598','2013-10-08','09:15:00',1.32),('14598','2013-10-08','09:20:00',1.45),('14598','2013-10-08','09:25:00',1.57),('14598','2013-10-08','09:30:00',1.56),('14598','2013-10-08','09:50:00',2.18),('14598','2013-10-08','09:55:00',1.93),('14598','2013-10-08','10:00:00',1.5),('14598','2013-10-08','10:05:00',1.8),('14598','2013-10-08','10:10:00',1.25),('14598','2013-10-08','10:15:00',1.41),('14598','2013-10-08','10:20:00',1.35),('14598','2013-10-08','10:25:00',1.1),('14598','2013-10-08','10:35:00',1.13),('14598','2013-10-08','10:40:00',1.01),('14598','2013-10-08','11:10:00',1.05),('14598','2013-10-08','11:15:00',1.18),('14598','2013-10-08','11:20:00',1.12),('14598','2013-10-08','12:05:00',1.6),('14598','2013-10-08','12:10:00',2.73),('14598','2013-10-08','12:15:00',2.23),('14598','2013-10-08','12:20:00',3.55),('14598','2013-10-08','12:25:00',1.43),('14598','2013-10-08','12:30:00',1.12),('14598','2013-10-08','12:35:00',2.46),('14598','2013-10-08','12:40:00',2.66),('14598','2013-10-08','12:45:00',2.08),('14598','2013-10-08','12:50:00',1.6),('14598','2013-10-08','12:55:00',1.45),('14598','2013-10-08','13:00:00',1.07),('14598','2013-10-08','13:05:00',1.03),('14598','2013-10-08','13:10:00',1.2),('14598','2013-10-08','13:15:00',1.11),('14598','2013-10-08','13:30:00',1.04),('14598','2013-10-08','13:35:00',1.02),('14598','2013-10-08','13:50:00',1.21),('14598','2013-10-08','13:55:00',1.22),('14598','2013-10-08','14:00:00',1.08),('14598','2013-10-08','14:05:00',1.08),('14598','2013-10-08','14:10:00',1.06),('14598','2013-10-08','14:15:00',1.23),('14598','2013-10-08','14:20:00',1.53),('14598','2013-10-08','14:25:00',1.73),('14598','2013-10-08','14:30:00',2.3),('14598','2013-10-08','14:35:00',4.02),('14598','2013-10-08','14:40:00',4.04),('14598','2013-10-08','14:45:00',3.62),('14598','2013-10-08','14:50:00',4.34),('14598','2013-10-08','14:55:00',2.22),('14598','2013-10-08','15:00:00',2.12),('14598','2013-10-08','15:05:00',3.49),('14598','2013-10-08','15:10:00',3.03),('14598','2013-10-08','15:15:00',3.97),('14598','2013-10-08','15:20:00',3.74),('14598','2013-10-08','15:25:00',2.6),('14598','2013-10-08','16:15:00',1.44),('14598','2013-10-08','16:20:00',1.27),('14598','2013-10-08','16:40:00',1.12),('14598','2013-10-08','16:45:00',1.78),('14598','2013-10-08','16:50:00',1.23),('14598','2013-10-08','17:55:00',1.24),('14598','2013-10-08','18:00:00',1.17),('14598','2013-10-07','08:55:00',1.13),('14598','2013-10-07','09:00:00',1.2),('14598','2013-10-07','09:05:00',1.4),('14598','2013-10-07','09:10:00',1.15),('14598','2013-10-07','09:25:00',1.41),('14598','2013-10-07','09:30:00',1.73),('14598','2013-10-07','09:35:00',1.76),('14598','2013-10-07','09:40:00',1.88),('14598','2013-10-07','09:45:00',1.95),('14598','2013-10-07','09:50:00',2.02),('14598','2013-10-07','09:55:00',2.13),('14598','2013-10-07','10:00:00',2.21),('14598','2013-10-07','10:05:00',2.29),('14598','2013-10-07','10:10:00',2.35),('14598','2013-10-07','10:15:00',2.45),('14598','2013-10-07','10:20:00',2.53),('14598','2013-10-07','10:25:00',2.61),('14598','2013-10-07','10:30:00',2.69),('14598','2013-10-07','10:35:00',2.77),('14598','2013-10-07','10:40:00',2.85),('14598','2013-10-07','10:45:00',2.92),('14598','2013-10-07','10:50:00',2.98),('14598','2013-10-07','10:55:00',3.05),('14598','2013-10-07','11:00:00',3.11),('14598','2013-10-07','11:05:00',3.14),('14598','2013-10-07','11:10:00',3.21),('14598','2013-10-07','11:15:00',3.21),('14598','2013-10-07','11:20:00',3.29),('14598','2013-10-07','11:25:00',3.36),('14598','2013-10-07','11:30:00',3.12),('14598','2013-10-07','11:35:00',1.07),('14598','2013-10-07','11:40:00',1.16),('14598','2013-10-07','11:55:00',1.03),('14598','2013-10-07','12:00:00',1.78),('14598','2013-10-07','12:05:00',1.85),('14598','2013-10-07','12:10:00',1.9),('14598','2013-10-07','12:15:00',2.77),('14598','2013-10-07','12:20:00',4.67),('14598','2013-10-07','12:25:00',3.18),('14598','2013-10-07','12:30:00',3.87),('14598','2013-10-07','12:35:00',4.06),('14598','2013-10-07','12:40:00',3.99),('14598','2013-10-07','12:45:00',4),('14598','2013-10-07','12:50:00',4.03),('14598','2013-10-07','12:55:00',4.01),('14598','2013-10-07','13:00:00',4.05),('14598','2013-10-07','13:05:00',4.06),('14598','2013-10-07','13:10:00',4.07),('14598','2013-10-07','13:15:00',4.08),('14598','2013-10-07','13:20:00',4.1),('14598','2013-10-07','13:25:00',4.07),('14598','2013-10-07','13:30:00',4.07),('14598','2013-10-07','13:35:00',4.07),('14598','2013-10-07','13:40:00',4.06),('14598','2013-10-07','13:45:00',4.08),('14598','2013-10-07','13:50:00',4.09),('14598','2013-10-07','13:55:00',4.07),('14598','2013-10-07','14:00:00',4.05),('14598','2013-10-07','14:05:00',4.03),('14598','2013-10-07','14:10:00',4.01),('14598','2013-10-07','14:15:00',3.99),('14598','2013-10-07','14:20:00',3.98),('14598','2013-10-07','14:25:00',3.95),('14598','2013-10-07','14:30:00',3.93),('14598','2013-10-07','14:35:00',3.91),('14598','2013-10-07','14:40:00',3.89),('14598','2013-10-07','14:45:00',3.8),('14598','2013-10-07','14:50:00',3.87),('14598','2013-10-07','14:55:00',3.88),('14598','2013-10-07','15:00:00',3.88),('14598','2013-10-07','15:05:00',3.78),('14598','2013-10-07','15:10:00',3.66),('14598','2013-10-07','15:15:00',3.9),('14598','2013-10-07','15:20:00',3.71),('14598','2013-10-07','15:25:00',3.74),('14598','2013-10-07','15:30:00',3.49),('14598','2013-10-07','15:35:00',2.64),('14598','2013-10-07','15:40:00',3.03),('14598','2013-10-07','15:45:00',2.81),('14598','2013-10-07','15:50:00',3.31),('14598','2013-10-07','15:55:00',3.28),('14598','2013-10-07','16:00:00',3.18),('14598','2013-10-07','16:05:00',2.51),('14598','2013-10-07','16:10:00',2.74),('14598','2013-10-07','16:15:00',2.99),('14598','2013-10-07','16:20:00',2.79),('14598','2013-10-07','16:25:00',2.64),('14598','2013-10-07','16:30:00',2.53),('14598','2013-10-07','16:35:00',2.43),('14598','2013-10-07','16:40:00',2.38),('14598','2013-10-07','16:45:00',2.35),('14598','2013-10-07','16:50:00',2.2),('14598','2013-10-07','16:55:00',2.07),('14598','2013-10-07','17:00:00',1.97),('14598','2013-10-07','17:05:00',1.85),('14598','2013-10-07','17:10:00',1.76),('14598','2013-10-07','17:15:00',1.66),('14598','2013-10-07','17:20:00',1.55),('14598','2013-10-07','17:25:00',1.45),('14598','2013-10-07','17:30:00',1.34),('14598','2013-10-07','17:35:00',1.23),('14598','2013-10-07','17:40:00',1.12),('14598','2013-10-07','17:45:00',1),('14598','2013-10-06','08:50:00',1.09),('14598','2013-10-06','08:55:00',1.26),('14598','2013-10-06','09:05:00',1.33),('14598','2013-10-06','09:10:00',1.39),('14598','2013-10-06','09:15:00',1.29),('14598','2013-10-06','09:20:00',1.91),('14598','2013-10-06','09:25:00',2.03),('14598','2013-10-06','09:30:00',1.98),('14598','2013-10-06','09:35:00',2.05),('14598','2013-10-06','09:40:00',2.14),('14598','2013-10-06','09:45:00',1.85),('14598','2013-10-06','09:50:00',1.72),('14598','2013-10-06','10:00:00',1.31),('14598','2013-10-06','10:05:00',1.51),('14598','2013-10-06','10:10:00',1.44),('14598','2013-10-06','10:15:00',1.8),('14598','2013-10-06','10:20:00',1.76),('14598','2013-10-06','10:25:00',1.96),('14598','2013-10-06','10:30:00',1.84),('14598','2013-10-06','10:35:00',1.85),('14598','2013-10-06','10:40:00',1.74),('14598','2013-10-06','10:45:00',1.99),('14598','2013-10-06','10:50:00',1.95),('14598','2013-10-06','10:55:00',2.17),('14598','2013-10-06','11:00:00',2.57),('14598','2013-10-06','11:05:00',2.45),('14598','2013-10-06','11:10:00',2.41),('14598','2013-10-06','11:15:00',2.6),('14598','2013-10-06','11:20:00',2.02),('14598','2013-10-06','11:25:00',2.5),('14598','2013-10-06','11:30:00',2.21),('14598','2013-10-06','11:35:00',2.85),('14598','2013-10-06','11:40:00',2.72),('14598','2013-10-06','11:45:00',3.21),('14598','2013-10-06','11:50:00',3.13),('14598','2013-10-06','11:55:00',3.47),('14598','2013-10-06','12:00:00',3.07),('14598','2013-10-06','12:05:00',3.92),('14598','2013-10-06','12:10:00',4.05),('14598','2013-10-06','12:15:00',3.83),('14598','2013-10-06','12:20:00',3.6),('14598','2013-10-06','12:25:00',3.66),('14598','2013-10-06','12:30:00',3.12),('14598','2013-10-06','12:35:00',4.51),('14598','2013-10-06','12:40:00',4.16),('14598','2013-10-06','12:45:00',4.13),('14598','2013-10-06','12:50:00',4.37),('14598','2013-10-06','12:55:00',4.33),('14598','2013-10-06','13:00:00',4.59),('14598','2013-10-06','13:05:00',3.95),('14598','2013-10-06','13:10:00',3.28),('14598','2013-10-06','13:15:00',4.1),('14598','2013-10-06','13:20:00',4.56),('14598','2013-10-06','13:25:00',3.36),('14598','2013-10-06','13:30:00',3.47),('14598','2013-10-06','13:35:00',2.06),('14598','2013-10-06','13:40:00',2.04),('14598','2013-10-06','13:45:00',1.83),('14598','2013-10-06','13:50:00',2.46),('14598','2013-10-06','13:55:00',2.41),('14598','2013-10-06','14:00:00',2.17),('14598','2013-10-06','14:05:00',2.01),('14598','2013-10-06','14:10:00',2.63),('14598','2013-10-06','14:15:00',2.77),('14598','2013-10-06','14:20:00',3.24),('14598','2013-10-06','14:25:00',2.84),('14598','2013-10-06','14:30:00',2.98),('14598','2013-10-06','14:35:00',2.37),('14598','2013-10-06','14:40:00',1.9),('14598','2013-10-06','14:45:00',1.6),('14598','2013-10-06','14:50:00',2.17),('14598','2013-10-06','14:55:00',2.21),('14598','2013-10-06','15:00:00',1.51),('14598','2013-10-06','15:05:00',1.49),('14598','2013-10-06','15:10:00',1.46),('14598','2013-10-06','15:15:00',1.79),('14598','2013-10-06','15:20:00',1.57),('14598','2013-10-06','15:25:00',1.35),('14598','2013-10-06','15:30:00',1.14),('14598','2013-10-06','15:35:00',1.11),('14598','2013-10-06','15:40:00',1.16),('14598','2013-10-06','15:45:00',1.57),('14598','2013-10-06','15:50:00',1.75),('14598','2013-10-06','15:55:00',1.23),('14598','2013-10-06','16:15:00',1.05),('14598','2013-10-05','15:30:00',1.01),('14598','2013-10-05','15:35:00',1.22),('14598','2013-10-05','15:40:00',1.48),('14598','2013-10-05','15:45:00',1.64),('14598','2013-10-05','15:50:00',1.55),('14598','2013-10-05','15:55:00',1.21),('14598','2013-10-05','16:00:00',1.01),('14598','2013-10-05','16:15:00',1.03),('14598','2013-10-05','16:20:00',1.16),('14598','2013-10-05','16:25:00',1.4),('14598','2013-10-05','16:30:00',1.58),('14598','2013-10-05','16:35:00',1.5),('14598','2013-10-05','16:40:00',1.17),('14598','2013-10-05','16:45:00',1.51),('14598','2013-10-05','16:50:00',1.18),('14598','2013-10-05','16:55:00',1.04),('14598','2013-10-05','17:00:00',1.02),('14598','2013-10-04','08:45:00',1.44),('14598','2013-10-04','09:15:00',1.8),('14598','2013-10-04','09:20:00',1.56),('14598','2013-10-04','09:25:00',1.04),('14598','2013-10-04','09:30:00',1.1),('14598','2013-10-04','09:35:00',1.19),('14598','2013-10-04','09:50:00',1.26),('14598','2013-10-04','09:55:00',1.97),('14598','2013-10-04','10:00:00',2.62),('14598','2013-10-04','10:05:00',2.73),('14598','2013-10-04','10:10:00',2.3),('14598','2013-10-04','10:15:00',1.62),('14598','2013-10-04','10:20:00',1.75),('14598','2013-10-04','10:25:00',2.2),('14598','2013-10-04','10:30:00',1.83),('14598','2013-10-04','10:35:00',3.2),('14598','2013-10-04','10:40:00',2.42),('14598','2013-10-04','10:45:00',2.18),('14598','2013-10-04','10:50:00',3.19),('14598','2013-10-04','10:55:00',3.55),('14598','2013-10-04','11:00:00',3.4),('14598','2013-10-04','11:05:00',1.79),('14598','2013-10-04','11:10:00',1.52),('14598','2013-10-04','11:15:00',2.31),('14598','2013-10-04','11:20:00',1.82),('14598','2013-10-04','11:25:00',1.27),('14598','2013-10-04','11:30:00',1.78),('14598','2013-10-04','11:35:00',3.34),('14598','2013-10-04','11:40:00',3.69),('14598','2013-10-04','11:45:00',3.81),('14598','2013-10-04','11:50:00',3.58),('14598','2013-10-04','11:55:00',2.19),('14598','2013-10-04','12:00:00',3.06),('14598','2013-10-04','12:05:00',4.04),('14598','2013-10-04','12:10:00',3.92),('14598','2013-10-04','12:15:00',3.91),('14598','2013-10-04','12:20:00',3.88),('14598','2013-10-04','12:25:00',3.94),('14598','2013-10-04','12:30:00',3.95),('14598','2013-10-04','12:35:00',4.01),('14598','2013-10-04','12:40:00',4.01),('14598','2013-10-04','12:45:00',3.99),('14598','2013-10-04','12:50:00',3.98),('14598','2013-10-04','12:55:00',3.99),('14598','2013-10-04','13:00:00',3.98),('14598','2013-10-04','13:05:00',4.04),('14598','2013-10-04','13:10:00',4),('14598','2013-10-04','13:15:00',4.06),('14598','2013-10-04','13:20:00',4.07),('14598','2013-10-04','13:25:00',4),('14598','2013-10-04','13:30:00',3.97),('14598','2013-10-04','13:35:00',4.06),('14598','2013-10-04','13:40:00',4.08),('14598','2013-10-04','13:45:00',4.05),('14598','2013-10-04','13:50:00',4.1),('14598','2013-10-04','13:55:00',4.07),('14598','2013-10-04','14:00:00',3.43),('14598','2013-10-04','14:05:00',3.37),('14598','2013-10-04','14:10:00',2.98),('14598','2013-10-04','14:15:00',3.11),('14598','2013-10-04','14:20:00',2.8),('14598','2013-10-04','14:25:00',2.7),('14598','2013-10-04','14:30:00',2.29),('14598','2013-10-04','14:35:00',3.4),('14598','2013-10-04','14:40:00',2.82),('14598','2013-10-04','14:45:00',2.6),('14598','2013-10-04','14:50:00',3.41),('14598','2013-10-04','14:55:00',2.09),('14598','2013-10-04','15:00:00',1.95),('14598','2013-10-04','15:05:00',2.49),('14598','2013-10-04','15:10:00',2.75),('14598','2013-10-04','15:15:00',2.05),('14598','2013-10-04','15:20:00',1.83),('14598','2013-10-04','15:25:00',1.49),('14598','2013-10-04','15:30:00',1.38),('14598','2013-10-04','15:35:00',1.22),('14598','2013-10-04','15:40:00',1.24),('14598','2013-10-04','15:45:00',1.25),('14598','2013-10-04','15:50:00',1.2),('14598','2013-10-04','15:55:00',1.21),('14598','2013-10-04','16:00:00',1.14),('14598','2013-10-04','16:05:00',1.16),('14598','2013-10-04','16:10:00',1.03),('14598','2013-10-04','16:15:00',1.08),('14598','2013-10-04','16:20:00',1.17),('14598','2013-10-04','16:25:00',1.07),('14598','2013-10-04','16:30:00',1.03),('14598','2013-10-04','16:35:00',1.12),('14598','2013-10-03','08:55:00',1.01),('14598','2013-10-03','09:00:00',1.11),('14598','2013-10-03','09:05:00',1.22),('14598','2013-10-03','09:10:00',1.35),('14598','2013-10-03','09:15:00',1.45),('14598','2013-10-03','09:20:00',1.59),('14598','2013-10-03','09:25:00',1.71),('14598','2013-10-03','09:30:00',1.81),('14598','2013-10-03','09:35:00',1.92),('14598','2013-10-03','09:40:00',2.01),('14598','2013-10-03','09:45:00',2.1),('14598','2013-10-03','09:50:00',2.21),('14598','2013-10-03','09:55:00',2.3),('14598','2013-10-03','10:00:00',2.39),('14598','2013-10-03','10:05:00',2.48),('14598','2013-10-03','10:10:00',2.59),('14598','2013-10-03','10:15:00',2.68),('14598','2013-10-03','10:20:00',2.76),('14598','2013-10-03','10:25:00',2.85),('14598','2013-10-03','10:30:00',2.94),('14598','2013-10-03','10:35:00',3),('14598','2013-10-03','10:40:00',3.09),('14598','2013-10-03','10:45:00',3.15),('14598','2013-10-03','10:50:00',3.22),('14598','2013-10-03','10:55:00',3.3),('14598','2013-10-03','11:00:00',3.36),('14598','2013-10-03','11:05:00',3.42),('14598','2013-10-03','11:10:00',3.5),('14598','2013-10-03','11:15:00',3.56),('14598','2013-10-03','11:20:00',3.61),('14598','2013-10-03','11:25:00',3.67),('14598','2013-10-03','11:30:00',3.7),('14598','2013-10-03','11:35:00',3.76),('14598','2013-10-03','11:40:00',3.78),('14598','2013-10-03','11:45:00',3.86),('14598','2013-10-03','11:50:00',3.9),('14598','2013-10-03','11:55:00',3.95),('14598','2013-10-03','12:00:00',3.98),('14598','2013-10-03','12:05:00',4.02),('14598','2013-10-03','12:10:00',4.01),('14598','2013-10-03','12:15:00',4.03),('14598','2013-10-03','12:20:00',4.05),('14598','2013-10-03','12:25:00',4.11),('14598','2013-10-03','12:30:00',4.13),('14598','2013-10-03','12:35:00',4.11),('14598','2013-10-03','12:40:00',4.15),('14598','2013-10-03','12:45:00',4.21),('14598','2013-10-03','12:50:00',4.22),('14598','2013-10-03','12:55:00',4.19),('14598','2013-10-03','13:00:00',4.23),('14598','2013-10-03','13:05:00',4.23),('14598','2013-10-03','13:10:00',4.24),('14598','2013-10-03','13:15:00',4.23),('14598','2013-10-03','13:20:00',4.23),('14598','2013-10-03','13:25:00',4.24),('14598','2013-10-03','13:30:00',4.25),('14598','2013-10-03','13:35:00',4.23),('14598','2013-10-03','13:40:00',4.25),('14598','2013-10-03','13:45:00',4.26),('14598','2013-10-03','13:50:00',4.24),('14598','2013-10-03','13:55:00',4.2),('14598','2013-10-03','14:00:00',4.19),('14598','2013-10-03','14:05:00',4.15),('14598','2013-10-03','14:10:00',4.15),('14598','2013-10-03','14:15:00',4.12),('14598','2013-10-03','14:20:00',4.12),('14598','2013-10-03','14:25:00',4.1),('14598','2013-10-03','14:30:00',4.06),('14598','2013-10-03','14:35:00',4.02),('14598','2013-10-03','14:40:00',3.96),('14598','2013-10-03','14:45:00',3.96),('14598','2013-10-03','14:50:00',3.91),('14598','2013-10-03','14:55:00',3.86),('14598','2013-10-03','15:00:00',3.82),('14598','2013-10-03','15:05:00',3.77),('14598','2013-10-03','15:10:00',3.72),('14598','2013-10-03','15:15:00',3.65),('14598','2013-10-03','15:20:00',3.57),('14598','2013-10-03','15:25:00',3.57),('14598','2013-10-03','15:30:00',3.53),('14598','2013-10-03','15:35:00',3.46),('14598','2013-10-03','15:40:00',3.41),('14598','2013-10-03','15:45:00',3.34),('14598','2013-10-03','15:50:00',3.28),('14598','2013-10-03','15:55:00',3.19),('14598','2013-10-03','16:00:00',3.14),('14598','2013-10-03','16:05:00',3.06),('14598','2013-10-03','16:10:00',2.91),('14598','2013-10-03','16:15:00',2.88),('14598','2013-10-03','16:20:00',2.8),('14598','2013-10-03','16:25:00',2.7),('14598','2013-10-03','16:30:00',2.61),('14598','2013-10-03','16:35:00',2.54),('14598','2013-10-03','16:40:00',2.46),('14598','2013-10-03','16:45:00',2.37),('14598','2013-10-03','16:50:00',2.27),('14598','2013-10-03','16:55:00',2.17),('14598','2013-10-03','17:00:00',2.07),('14598','2013-10-03','17:05:00',1.98),('14598','2013-10-03','17:10:00',1.9),('14598','2013-10-03','17:15:00',1.8),('14598','2013-10-03','17:20:00',1.71),('14598','2013-10-03','17:25:00',1.6),('14598','2013-10-03','17:30:00',1.48),('14598','2013-10-03','17:35:00',1.37),('14598','2013-10-03','17:40:00',1.25),('14598','2013-10-03','17:45:00',1.13),('14598','2013-10-03','17:50:00',1.02),('14598','2013-10-02','09:00:00',1.08),('14598','2013-10-02','09:05:00',1.18),('14598','2013-10-02','09:10:00',1.31),('14598','2013-10-02','09:15:00',1.41),('14598','2013-10-02','09:20:00',1.52),('14598','2013-10-02','09:25:00',1.62),('14598','2013-10-02','09:30:00',1.72),('14598','2013-10-02','09:35:00',1.82),('14598','2013-10-02','09:40:00',1.9),('14598','2013-10-02','09:45:00',2),('14598','2013-10-02','09:50:00',2.1),('14598','2013-10-02','09:55:00',2.19),('14598','2013-10-02','10:00:00',2.27),('14598','2013-10-02','10:05:00',2.36),('14598','2013-10-02','10:10:00',2.45),('14598','2013-10-02','10:15:00',2.53),('14598','2013-10-02','10:20:00',2.6),('14598','2013-10-02','10:25:00',2.67),('14598','2013-10-02','10:30:00',2.75),('14598','2013-10-02','10:35:00',2.84),('14598','2013-10-02','10:40:00',2.91),('14598','2013-10-02','10:45:00',2.97),('14598','2013-10-02','10:50:00',3.04),('14598','2013-10-02','10:55:00',3.11),('14598','2013-10-02','11:00:00',3.16),('14598','2013-10-02','11:05:00',3.24),('14598','2013-10-02','11:10:00',3.32),('14598','2013-10-02','11:15:00',3.37),('14598','2013-10-02','11:20:00',3.4),('14598','2013-10-02','11:25:00',3.46),('14598','2013-10-02','11:30:00',3.52),('14598','2013-10-02','11:35:00',3.56),('14598','2013-10-02','11:40:00',3.6),('14598','2013-10-02','11:45:00',3.64),('14598','2013-10-02','11:50:00',3.69),('14598','2013-10-02','11:55:00',3.73),('14598','2013-10-02','12:00:00',3.76),('14598','2013-10-02','12:05:00',3.79),('14598','2013-10-02','12:10:00',3.82),('14598','2013-10-02','12:15:00',3.85),('14598','2013-10-02','12:20:00',3.87),('14598','2013-10-02','12:25:00',3.9),('14598','2013-10-02','12:30:00',3.94),('14598','2013-10-02','12:35:00',3.94),('14598','2013-10-02','12:40:00',3.99),('14598','2013-10-02','12:45:00',4),('14598','2013-10-02','12:50:00',4.01),('14598','2013-10-02','12:55:00',4.02),('14598','2013-10-02','13:00:00',4.03),('14598','2013-10-02','13:05:00',4.05),('14598','2013-10-02','13:10:00',4.04),('14598','2013-10-02','13:15:00',4.02),('14598','2013-10-02','13:20:00',4.02),('14598','2013-10-02','13:25:00',4.02),('14598','2013-10-02','13:30:00',4.1),('14598','2013-10-02','13:35:00',4.15),('14598','2013-10-02','13:40:00',4.12),('14598','2013-10-02','13:45:00',4.11),('14598','2013-10-02','13:50:00',4.08),('14598','2013-10-02','13:55:00',4.05),('14598','2013-10-02','14:00:00',4.1),('14598','2013-10-02','14:05:00',4.09),('14598','2013-10-02','14:10:00',4.11),('14598','2013-10-02','14:15:00',4.06),('14598','2013-10-02','14:20:00',3.66),('14598','2013-10-02','14:25:00',3.98),('14598','2013-10-02','14:30:00',3.8),('14598','2013-10-02','14:35:00',3.77),('14598','2013-10-02','14:40:00',3.67),('14598','2013-10-02','14:45:00',3.85),('14598','2013-10-02','14:50:00',3.78),('14598','2013-10-02','14:55:00',3.72),('14598','2013-10-02','15:00:00',3.72),('14598','2013-10-02','15:05:00',3.67),('14598','2013-10-02','15:10:00',3.72),('14598','2013-10-02','15:15:00',1.9),('14598','2013-10-02','15:20:00',3.45),('14598','2013-10-02','15:25:00',3.56),('14598','2013-10-02','15:30:00',3.41),('14598','2013-10-02','15:35:00',3.37),('14598','2013-10-02','15:40:00',3.28),('14598','2013-10-02','15:45:00',3.27),('14598','2013-10-02','15:50:00',3.21),('14598','2013-10-02','15:55:00',3.11),('14598','2013-10-02','16:00:00',3.06),('14598','2013-10-02','16:05:00',2.97),('14598','2013-10-02','16:10:00',2.86),('14598','2013-10-02','16:15:00',2.82),('14598','2013-10-02','16:20:00',2.75),('14598','2013-10-02','16:25:00',2.7),('14598','2013-10-02','16:30:00',2.6),('14598','2013-10-02','16:35:00',2.53),('14598','2013-10-02','16:40:00',2.41),('14598','2013-10-02','16:45:00',2.34),('14598','2013-10-02','16:50:00',2.22),('14598','2013-10-02','16:55:00',2.08),('14598','2013-10-02','17:00:00',1.99),('14598','2013-10-02','17:05:00',1.93),('14598','2013-10-02','17:10:00',1.81),('14598','2013-10-02','17:15:00',1.7),('14598','2013-10-02','17:20:00',1.6),('14598','2013-10-02','17:25:00',1.52),('14598','2013-10-02','17:30:00',1.42),('14598','2013-10-02','17:35:00',1.32),('14598','2013-10-02','17:40:00',1.21),('14598','2013-10-02','17:45:00',1.09),('14598','2013-10-01','09:00:00',1.09),('14598','2013-10-01','09:05:00',1.2),('14598','2013-10-01','09:10:00',1.33),('14598','2013-10-01','09:15:00',1.43),('14598','2013-10-01','09:20:00',1.55),('14598','2013-10-01','09:25:00',1.64),('14598','2013-10-01','09:30:00',1.74),('14598','2013-10-01','09:35:00',1.84),('14598','2013-10-01','09:40:00',1.93),('14598','2013-10-01','09:45:00',2.02),('14598','2013-10-01','09:50:00',2.1),('14598','2013-10-01','09:55:00',2.2),('14598','2013-10-01','10:00:00',2.27),('14598','2013-10-01','10:05:00',2.37),('14598','2013-10-01','10:10:00',2.47),('14598','2013-10-01','10:15:00',2.5),('14598','2013-10-01','10:20:00',2.56),('14598','2013-10-01','10:25:00',2.81),('14598','2013-10-01','10:30:00',2.95),('14598','2013-10-01','10:35:00',3.12),('14598','2013-10-01','10:40:00',3.24),('14598','2013-10-01','10:45:00',2.74),('14598','2013-10-01','10:50:00',2.32),('14598','2013-10-01','10:55:00',3.15),('14598','2013-10-01','11:00:00',3.22),('14598','2013-10-01','11:05:00',3.28),('14598','2013-10-01','11:10:00',3.35),('14598','2013-10-01','11:15:00',3.4),('14598','2013-10-01','11:20:00',3.45),('14598','2013-10-01','11:25:00',3.5),('14598','2013-10-01','11:30:00',3.57),('14598','2013-10-01','11:35:00',3.62),('14598','2013-10-01','11:40:00',3.66),('14598','2013-10-01','11:45:00',3.71),('14598','2013-10-01','11:50:00',3.73),('14598','2013-10-01','11:55:00',3.82),('14598','2013-10-01','12:00:00',3.86),('14598','2013-10-01','12:05:00',3.9),('14598','2013-10-01','12:10:00',3.92),('14598','2013-10-01','12:15:00',3.95),('14598','2013-10-01','12:20:00',3.98),('14598','2013-10-01','12:25:00',4.02),('14598','2013-10-01','12:30:00',4.06),('14598','2013-10-01','12:35:00',4.09),('14598','2013-10-01','12:40:00',4.12),('14598','2013-10-01','12:45:00',4.14),('14598','2013-10-01','12:50:00',4.15),('14598','2013-10-01','12:55:00',4.15),('14598','2013-10-01','13:00:00',4.16),('14598','2013-10-01','13:05:00',4.17),('14598','2013-10-01','13:10:00',4.18),('14598','2013-10-01','13:15:00',4.17),('14598','2013-10-01','13:20:00',4.19),('14598','2013-10-01','13:25:00',4.19),('14598','2013-10-01','13:30:00',4.2),('14598','2013-10-01','13:35:00',4.19),('14598','2013-10-01','13:40:00',4.2),('14598','2013-10-01','13:45:00',4.19),('14598','2013-10-01','13:50:00',4.17),('14598','2013-10-01','13:55:00',4.17),('14598','2013-10-01','14:00:00',4.17),('14598','2013-10-01','14:05:00',4.13),('14598','2013-10-01','14:10:00',4.11),('14598','2013-10-01','14:15:00',4.09),('14598','2013-10-01','14:20:00',4.07),('14598','2013-10-01','14:25:00',4.06),('14598','2013-10-01','14:30:00',4.03),('14598','2013-10-01','14:35:00',4),('14598','2013-10-01','14:40:00',3.96),('14598','2013-10-01','14:45:00',3.93),('14598','2013-10-01','14:50:00',3.91),('14598','2013-10-01','14:55:00',3.88),('14598','2013-10-01','15:00:00',3.86),('14598','2013-10-01','15:05:00',3.82),('14598','2013-10-01','15:10:00',3.78),('14598','2013-10-01','15:15:00',3.72),('14598','2013-10-01','15:20:00',3.67),('14598','2013-10-01','15:25:00',3.62),('14598','2013-10-01','15:30:00',3.56),('14598','2013-10-01','15:35:00',3.5),('14598','2013-10-01','15:40:00',3.43),('14598','2013-10-01','15:45:00',3.35),('14598','2013-10-01','15:50:00',3.3),('14598','2013-10-01','15:55:00',3.23),('14598','2013-10-01','16:00:00',3.16),('14598','2013-10-01','16:05:00',3.08),('14598','2013-10-01','16:10:00',3.01),('14598','2013-10-01','16:15:00',2.93),('14598','2013-10-01','16:20:00',2.86),('14598','2013-10-01','16:25:00',2.77),('14598','2013-10-01','16:30:00',2.68),('14598','2013-10-01','16:35:00',2.6),('14598','2013-10-01','16:40:00',2.52),('14598','2013-10-01','16:45:00',2.42),('14598','2013-10-01','16:50:00',2.34),('14598','2013-10-01','16:55:00',2.23),('14598','2013-10-01','17:00:00',2.13),('14598','2013-10-01','17:05:00',2.02),('14598','2013-10-01','17:10:00',1.91),('14598','2013-10-01','17:15:00',1.8),('14598','2013-10-01','17:20:00',1.68),('14598','2013-10-01','17:25:00',1.59),('14598','2013-10-01','17:30:00',1.48),('14598','2013-10-01','17:35:00',1.37),('14598','2013-10-01','17:40:00',1.26),('14598','2013-10-01','17:45:00',1.16),('14598','2013-10-01','17:50:00',1.01),('14598','2013-09-30','09:00:00',1.23),('14598','2013-09-30','09:05:00',1.28),('14598','2013-09-30','09:10:00',1.46),('14598','2013-09-30','09:15:00',1.27),('14598','2013-09-30','09:20:00',1.33),('14598','2013-09-30','09:25:00',1.22),('14598','2013-09-30','09:30:00',1.03),('14598','2013-09-30','09:35:00',1.04),('14598','2013-09-30','09:50:00',1.01),('14598','2013-09-30','09:55:00',1.16),('14598','2013-09-30','10:00:00',1.01),('14598','2013-09-30','10:05:00',1.09),('14598','2013-09-30','10:10:00',1.28),('14598','2013-09-30','10:15:00',1.6),('14598','2013-09-30','10:20:00',1.99),('14598','2013-09-30','10:25:00',2.51),('14598','2013-09-30','10:30:00',2.45),('14598','2013-09-30','10:35:00',2.3),('14598','2013-09-30','10:40:00',2.97),('14598','2013-09-30','10:45:00',3.35),('14598','2013-09-30','10:50:00',3.31),('14598','2013-09-30','10:55:00',3.11),('14598','2013-09-30','11:00:00',3.18),('14598','2013-09-30','11:05:00',3.51),('14598','2013-09-30','11:10:00',3.8),('14598','2013-09-30','11:15:00',3.73),('14598','2013-09-30','11:20:00',1.09),('14598','2013-09-30','11:35:00',2.05),('14598','2013-09-30','11:40:00',3.59),('14598','2013-09-30','11:45:00',4.02),('14598','2013-09-30','11:50:00',3.89),('14598','2013-09-30','11:55:00',3.9),('14598','2013-09-30','12:00:00',3.92),('14598','2013-09-30','12:05:00',4),('14598','2013-09-30','12:10:00',3.46),('14598','2013-09-30','12:15:00',4.1),('14598','2013-09-30','12:20:00',4.1),('14598','2013-09-30','12:25:00',4.16),('14598','2013-09-30','12:30:00',3.63),('14598','2013-09-30','12:35:00',4.39),('14598','2013-09-30','12:40:00',4.1),('14598','2013-09-30','12:45:00',4.16),('14598','2013-09-30','12:50:00',4.16),('14598','2013-09-30','12:55:00',4.12),('14598','2013-09-30','13:00:00',3.19),('14598','2013-09-30','13:05:00',3.71),('14598','2013-09-30','13:10:00',3.29),('14598','2013-09-30','13:15:00',4.52),('14598','2013-09-30','13:20:00',4.61),('14598','2013-09-30','13:25:00',3.76),('14598','2013-09-30','13:30:00',1.01),('14598','2013-09-30','13:35:00',1.08),('14598','2013-09-30','13:40:00',1.18),('14598','2013-09-30','13:45:00',1.51),('14598','2013-09-30','13:50:00',1.81),('14598','2013-09-30','14:10:00',2.27),('14598','2013-09-30','14:15:00',4.98),('14598','2013-09-30','14:20:00',5.26),('14598','2013-09-30','14:25:00',4.84),('14598','2013-09-30','14:30:00',4.18),('14598','2013-09-30','14:35:00',4.46),('14598','2013-09-30','14:40:00',4.5),('14598','2013-09-30','14:45:00',3.37),('14598','2013-09-30','14:50:00',4.63),('14598','2013-09-30','14:55:00',4.43),('14598','2013-09-30','15:00:00',4.53),('14598','2013-09-30','15:05:00',4.44),('14598','2013-09-30','15:10:00',4.65),('14598','2013-09-30','15:15:00',2.13),('14598','2013-09-30','15:35:00',1.65),('14598','2013-09-30','15:40:00',3.49),('14598','2013-09-30','15:45:00',3.38),('14598','2013-09-30','15:50:00',3.02),('14598','2013-09-30','15:55:00',3.18),('14598','2013-09-30','16:00:00',3.45),('14598','2013-09-30','16:05:00',3.25),('14598','2013-09-30','16:10:00',2.3),('14598','2013-09-30','16:15:00',2.96),('14598','2013-09-30','16:20:00',1.97),('14598','2013-09-30','16:25:00',2.71),('14598','2013-09-30','16:30:00',2.33),('14598','2013-09-30','16:35:00',2.54),('14598','2013-09-30','16:40:00',2.44),('14598','2013-09-30','16:45:00',2.52),('14598','2013-09-30','16:50:00',2.4),('14598','2013-09-30','16:55:00',2.31),('14598','2013-09-30','17:00:00',2.2),('14598','2013-09-30','17:05:00',2.11),('14598','2013-09-30','17:10:00',1.99),('14598','2013-09-30','17:15:00',1.87),('14598','2013-09-30','17:20:00',1.76),('14598','2013-09-30','17:25:00',1.69),('14598','2013-09-30','17:30:00',1.39),('14598','2013-09-30','17:55:00',1.04),('14598','2013-09-29','09:35:00',1.24),('14598','2013-09-29','09:40:00',1.65),('14598','2013-09-29','09:45:00',1.7),('14598','2013-09-29','09:50:00',1.97),('14598','2013-09-29','09:55:00',2),('14598','2013-09-29','10:00:00',1.46),('14598','2013-09-29','10:05:00',1.36),('14598','2013-09-29','10:10:00',1.71),('14598','2013-09-29','10:15:00',2.29),('14598','2013-09-29','10:20:00',2.34),('14598','2013-09-29','10:25:00',2.41),('14598','2013-09-29','10:30:00',2.56),('14598','2013-09-29','10:35:00',1.79),('14598','2013-09-29','10:40:00',2.83),('14598','2013-09-29','10:45:00',2.98),('14598','2013-09-29','10:50:00',1.88),('14598','2013-09-29','10:55:00',2.09),('14598','2013-09-29','11:00:00',2.73),('14598','2013-09-29','11:05:00',2.95),('14598','2013-09-29','11:10:00',2.97),('14598','2013-09-29','11:15:00',2.96),('14598','2013-09-29','11:20:00',3.13),('14598','2013-09-29','11:25:00',3.15),('14598','2013-09-29','11:30:00',3.38),('14598','2013-09-29','11:35:00',3.48),('14598','2013-09-29','11:40:00',3.35),('14598','2013-09-29','11:45:00',3.09),('14598','2013-09-29','11:50:00',2.19),('14598','2013-09-29','11:55:00',1.38),('14598','2013-09-29','12:00:00',1.18),('14598','2013-09-29','12:05:00',1.03),('14598','2013-09-29','12:10:00',1.28),('14598','2013-09-29','12:15:00',1.05),('14598','2013-09-29','12:20:00',1.3),('14598','2013-09-29','12:25:00',1.35),('14598','2013-09-29','12:35:00',1.35),('14598','2013-09-29','12:40:00',1.69),('14598','2013-09-29','12:45:00',1.58),('14598','2013-09-29','12:50:00',1.63),('14598','2013-09-29','12:55:00',1.64),('14598','2013-09-29','13:00:00',2),('14598','2013-09-29','13:05:00',1.93),('14598','2013-09-29','13:10:00',2.44),('14598','2013-09-29','13:15:00',3.69),('14598','2013-09-29','13:20:00',2.52),('14598','2013-09-29','13:25:00',3.14),('14598','2013-09-29','13:30:00',2.87),('14598','2013-09-29','13:35:00',2.8),('14598','2013-09-29','13:40:00',3.56),('14598','2013-09-29','13:45:00',4),('14598','2013-09-29','13:50:00',2.09),('14598','2013-09-29','13:55:00',1.82),('14598','2013-09-29','14:00:00',1.34),('14598','2013-09-29','14:05:00',1.11),('14598','2013-09-29','14:10:00',1.1),('14598','2013-09-29','14:15:00',1.2),('14598','2013-09-29','14:20:00',1.17),('14598','2013-09-29','14:25:00',1.11),('14598','2013-09-29','14:55:00',1.04),('14598','2013-09-29','15:00:00',1.05),('14598','2013-09-29','15:10:00',1),('14598','2013-09-29','15:15:00',1.21),('14598','2013-09-29','15:20:00',1.32),('14598','2013-09-29','15:50:00',1.32),('14598','2013-09-29','15:55:00',1.53),('14598','2013-09-29','16:00:00',1.19),('14598','2013-09-29','16:05:00',1.02),('14598','2013-09-29','16:10:00',1.13),('14598','2013-09-29','16:15:00',1.37),('14598','2013-09-29','16:20:00',1.38),('14598','2013-09-29','16:25:00',1.28),('14598','2013-09-29','16:30:00',1.31),('14598','2013-09-29','16:35:00',1.1),('14598','2013-09-29','16:45:00',1.42),('14598','2013-09-29','16:50:00',2.34),('14598','2013-09-29','16:55:00',1.95),('14598','2013-09-29','17:00:00',1.4),('14598','2013-09-29','17:05:00',1.02),('14598','2013-09-29','17:10:00',1.03),('14598','2014-04-14','08:25:00',1.02),('14598','2014-04-14','08:30:00',1.13),('14598','2014-04-14','08:35:00',1.26),('14598','2014-04-14','08:40:00',1.37),('14598','2014-04-14','08:45:00',1.47),('14598','2014-04-14','08:50:00',1.58),('14598','2014-04-14','08:55:00',1.7),('14598','2014-04-14','09:00:00',1.81),('14598','2014-04-14','09:05:00',1.94),('14598','2014-04-14','09:10:00',2.06),('14598','2014-04-14','09:15:00',2.2),('14598','2014-04-14','09:20:00',2.3),('14598','2014-04-14','09:25:00',2.4),('14598','2014-04-14','09:30:00',2.47),('14598','2014-04-14','09:35:00',2.59),('14598','2014-04-14','09:40:00',2.69),('14598','2014-04-14','09:45:00',2.79),('14598','2014-04-14','09:50:00',2.88),('14598','2014-04-14','09:55:00',2.97),('14598','2014-04-14','10:00:00',3.05),('14598','2014-04-14','10:05:00',3.13),('14598','2014-04-14','10:10:00',3.2),('14598','2014-04-14','10:15:00',3.28),('14598','2014-04-14','10:20:00',3.36),('14598','2014-04-14','10:25:00',3.44),('14598','2014-04-14','10:30:00',3.51),('14598','2014-04-14','10:35:00',3.59),('14598','2014-04-14','10:40:00',3.66),('14598','2014-04-14','10:45:00',3.72),('14598','2014-04-14','10:50:00',3.8),('14598','2014-04-14','10:55:00',3.85),('14598','2014-04-14','11:00:00',3.92),('14598','2014-04-14','11:05:00',3.99),('14598','2014-04-14','11:10:00',4.04),('14598','2014-04-14','11:15:00',4.08),('14598','2014-04-14','11:20:00',4.14),('14598','2014-04-14','11:25:00',4.2),('14598','2014-04-14','11:30:00',4.29),('14598','2014-04-14','11:35:00',4.36),('14598','2014-04-14','11:40:00',4.44),('14598','2014-04-14','11:45:00',4.51),('14598','2014-04-14','11:50:00',4.54),('14598','2014-04-14','11:55:00',4.59),('14598','2014-04-14','12:00:00',4.63),('14598','2014-04-14','12:05:00',4.66),('14598','2014-04-14','12:10:00',4.72),('14598','2014-04-14','12:15:00',4.76),('14598','2014-04-14','12:20:00',4.81),('14598','2014-04-14','12:25:00',4.82),('14598','2014-04-14','12:30:00',4.8),('14598','2014-04-14','12:35:00',4.88),('14598','2014-04-14','12:40:00',4.91),('14598','2014-04-14','12:45:00',4.91),('14598','2014-04-14','12:50:00',4.92),('14598','2014-04-14','12:55:00',4.95),('14598','2014-04-14','13:00:00',4.98),('14598','2014-04-14','13:05:00',5),('14598','2014-04-14','13:10:00',5.02),('14598','2014-04-14','13:15:00',5.03),('14598','2014-04-14','13:20:00',5.04),('14598','2014-04-14','13:25:00',5.05),('14598','2014-04-14','13:30:00',5.06),('14598','2014-04-14','13:35:00',5.09),('14598','2014-04-14','13:40:00',5.07),('14598','2014-04-14','13:45:00',5.05),('14598','2014-04-14','13:50:00',5.06),('14598','2014-04-14','13:55:00',5.06),('14598','2014-04-14','14:00:00',5.05),('14598','2014-04-14','14:05:00',5.04),('14598','2014-04-14','14:10:00',5.03),('14598','2014-04-14','14:15:00',5.03),('14598','2014-04-14','14:20:00',5.02),('14598','2014-04-14','14:25:00',4.99),('14598','2014-04-14','14:30:00',4.98),('14598','2014-04-14','14:35:00',4.97),('14598','2014-04-14','14:40:00',4.94),('14598','2014-04-14','14:45:00',4.9),('14598','2014-04-14','14:50:00',4.88),('14598','2014-04-14','14:55:00',4.85),('14598','2014-04-14','15:00:00',4.83),('14598','2014-04-14','15:05:00',4.79),('14598','2014-04-14','15:10:00',4.75),('14598','2014-04-14','15:15:00',4.67),('14598','2014-04-14','15:20:00',4.66),('14598','2014-04-14','15:25:00',4.61),('14598','2014-04-14','15:30:00',4.54),('14598','2014-04-14','15:35:00',4.52),('14598','2014-04-14','15:40:00',4.48),('14598','2014-04-14','15:45:00',4.41),('14598','2014-04-14','15:50:00',4.33),('14598','2014-04-14','15:55:00',4.27),('14598','2014-04-14','16:00:00',4.22),('14598','2014-04-14','16:05:00',4.16),('14598','2014-04-14','16:10:00',4.12),('14598','2014-04-14','16:15:00',4.03),('14598','2014-04-14','16:20:00',3.98),('14598','2014-04-14','16:25:00',3.92),('14598','2014-04-14','16:30:00',3.85),('14598','2014-04-14','16:35:00',3.77),('14598','2014-04-14','16:40:00',3.68),('14598','2014-04-14','16:45:00',3.6),('14598','2014-04-14','16:50:00',3.51),('14598','2014-04-14','16:55:00',3.43),('14598','2014-04-14','17:00:00',3.34),('14598','2014-04-14','17:05:00',3.25),('14598','2014-04-14','17:10:00',3.16),('14598','2014-04-14','17:15:00',3.06),('14598','2014-04-14','17:20:00',2.97),('14598','2014-04-14','17:25:00',2.87),('14598','2014-04-14','17:30:00',2.77),('14598','2014-04-14','17:35:00',2.63),('14598','2014-04-14','17:40:00',2.53),('14598','2014-04-14','17:45:00',2.43),('14598','2014-04-14','17:50:00',2.31),('14598','2014-04-14','17:55:00',2.2),('14598','2014-04-14','18:00:00',2.08),('14598','2014-04-14','18:05:00',1.99),('14598','2014-04-14','18:10:00',1.86),('14598','2014-04-14','18:15:00',1.76),('14598','2014-04-14','18:20:00',1.64),('14598','2014-04-14','18:25:00',1.52),('14598','2014-04-14','18:30:00',1.41),('14598','2014-04-14','18:35:00',1.25),('14598','2014-04-14','18:40:00',1.16),('14598','2014-04-14','18:45:00',1.03),('14598','2013-09-28','08:55:00',1.01),('14598','2013-09-28','09:00:00',1.1),('14598','2013-09-28','09:05:00',1.21),('14598','2013-09-28','09:10:00',1.34),('14598','2013-09-28','09:15:00',1.44),('14598','2013-09-28','09:20:00',1.55),('14598','2013-09-28','09:25:00',1.64),('14598','2013-09-28','09:30:00',1.75),('14598','2013-09-28','09:35:00',1.85),('14598','2013-09-28','09:40:00',1.94),('14598','2013-09-28','09:45:00',2.03),('14598','2013-09-28','09:50:00',2.07),('14598','2013-09-28','09:55:00',2.18),('14598','2013-09-28','10:00:00',2.28),('14598','2013-09-28','10:05:00',2.44),('14598','2013-09-28','10:10:00',2.54),('14598','2013-09-28','10:15:00',2.33),('14598','2013-09-28','10:20:00',1.73),('14598','2013-09-28','10:25:00',1.3),('14598','2013-09-28','10:30:00',3.12),('14598','2013-09-28','10:35:00',3.15),('14598','2013-09-28','10:40:00',3.19),('14598','2013-09-28','10:45:00',3.38),('14598','2013-09-28','10:50:00',2.33),('14598','2013-09-28','10:55:00',2.65),('14598','2013-09-28','11:00:00',3.31),('14598','2013-09-28','11:05:00',2.11),('14598','2013-09-28','11:10:00',3.57),('14598','2013-09-28','11:15:00',3.54),('14598','2013-09-28','11:20:00',3.52),('14598','2013-09-28','11:25:00',3.54),('14598','2013-09-28','11:30:00',3.56),('14598','2013-09-28','11:35:00',3.63),('14598','2013-09-28','11:40:00',3.66),('14598','2013-09-28','11:45:00',3.71),('14598','2013-09-28','11:50:00',3.76),('14598','2013-09-28','11:55:00',3.8),('14598','2013-09-28','12:00:00',3.84),('14598','2013-09-28','12:05:00',3.88),('14598','2013-09-28','12:10:00',3.91),('14598','2013-09-28','12:15:00',3.95),('14598','2013-09-28','12:20:00',3.97),('14598','2013-09-28','12:25:00',3.98),('14598','2013-09-28','12:30:00',4.03),('14598','2013-09-28','12:35:00',4.05),('14598','2013-09-28','12:40:00',4.07),('14598','2013-09-28','12:45:00',4.05),('14598','2013-09-28','12:50:00',4.1),('14598','2013-09-28','12:55:00',4.13),('14598','2013-09-28','13:00:00',4.14),('14598','2013-09-28','13:05:00',4.14),('14598','2013-09-28','13:10:00',4.12),('14598','2013-09-28','13:15:00',4.12),('14598','2013-09-28','13:20:00',4.12),('14598','2013-09-28','13:25:00',4.14),('14598','2013-09-28','13:30:00',4.13),('14598','2013-09-28','13:35:00',4.14),('14598','2013-09-28','13:40:00',4.14),('14598','2013-09-28','13:45:00',4.11),('14598','2013-09-28','13:50:00',4.12),('14598','2013-09-28','13:55:00',4.13),('14598','2013-09-28','14:00:00',4.12),('14598','2013-09-28','14:05:00',4.09),('14598','2013-09-28','14:10:00',4.08),('14598','2013-09-28','14:15:00',4.06),('14598','2013-09-28','14:20:00',4.04),('14598','2013-09-28','14:25:00',4.04),('14598','2013-09-28','14:30:00',3.95),('14598','2013-09-28','14:35:00',3.99),('14598','2013-09-28','14:40:00',3.96),('14598','2013-09-28','14:45:00',3.95),('14598','2013-09-28','14:50:00',3.9),('14598','2013-09-28','14:55:00',3.85),('14598','2013-09-28','15:00:00',3.8),('14598','2013-09-28','15:05:00',3.74),('14598','2013-09-28','15:10:00',3.71),('14598','2013-09-28','15:15:00',3.7),('14598','2013-09-28','15:20:00',3.65),('14598','2013-09-28','15:25:00',3.62),('14598','2013-09-28','15:30:00',3.39),('14598','2013-09-28','15:35:00',3.39),('14598','2013-09-28','15:40:00',3.41),('14598','2013-09-28','15:45:00',3.29),('14598','2013-09-28','15:50:00',3.08),('14598','2013-09-28','15:55:00',3.05),('14598','2013-09-28','16:00:00',2.74),('14598','2013-09-28','16:05:00',2.68),('14598','2013-09-28','16:10:00',1.56),('14598','2013-09-28','16:15:00',2.15),('14598','2013-09-28','16:20:00',2.65),('14598','2013-09-28','16:25:00',2.77),('14598','2013-09-28','16:30:00',2.57),('14598','2013-09-28','16:35:00',2.52),('14598','2013-09-28','16:40:00',2.45),('14598','2013-09-28','16:45:00',2.33),('14598','2013-09-28','16:50:00',2.25),('14598','2013-09-28','16:55:00',2.16),('14598','2013-09-28','17:00:00',2.07),('14598','2013-09-28','17:05:00',1.99),('14598','2013-09-28','17:10:00',1.91),('14598','2013-09-28','17:15:00',1.83),('14598','2013-09-28','17:20:00',1.75),('14598','2013-09-28','17:25:00',1.59),('14598','2013-09-28','17:30:00',1.31),('14598','2013-09-27','08:50:00',1),('14598','2013-09-27','08:55:00',1.19),('14598','2013-09-27','09:00:00',1.1),('14598','2013-09-27','09:45:00',1.29),('14598','2013-09-27','09:50:00',1.11),('14598','2013-09-27','09:55:00',1.24),('14598','2013-09-27','10:00:00',2.23),('14598','2013-09-27','10:05:00',2.15),('14598','2013-09-27','10:10:00',2.39),('14598','2013-09-27','10:15:00',2.28),('14598','2013-09-27','10:20:00',1.41),('14598','2013-09-27','10:25:00',1.22),('14598','2013-09-27','10:30:00',1.55),('14598','2013-09-27','10:35:00',3.02),('14598','2013-09-27','10:40:00',2.92),('14598','2013-09-27','10:45:00',2.94),('14598','2013-09-27','10:50:00',3.09),('14598','2013-09-27','10:55:00',3.27),('14598','2013-09-27','11:00:00',1.61),('14598','2013-09-27','11:05:00',3.06),('14598','2013-09-27','11:10:00',3.1),('14598','2013-09-27','11:15:00',3.95),('14598','2013-09-27','11:20:00',2.99),('14598','2013-09-27','11:25:00',2.31),('14598','2013-09-27','11:30:00',2.47),('14598','2013-09-27','11:35:00',1.61),('14598','2013-09-27','11:40:00',1.67),('14598','2013-09-27','11:45:00',1.63),('14598','2013-09-27','11:50:00',2.58),('14598','2013-09-27','11:55:00',4.26),('14598','2013-09-27','12:00:00',3.94),('14598','2013-09-27','12:05:00',3.96),('14598','2013-09-27','12:10:00',3.98),('14598','2013-09-27','12:15:00',3.94),('14598','2013-09-27','12:20:00',3.95),('14598','2013-09-27','12:25:00',3.94),('14598','2013-09-27','12:30:00',3.95),('14598','2013-09-27','12:35:00',3.98),('14598','2013-09-27','12:40:00',4),('14598','2013-09-27','12:45:00',4.07),('14598','2013-09-27','12:50:00',4.07),('14598','2013-09-27','12:55:00',4.13),('14598','2013-09-27','13:00:00',3.89),('14598','2013-09-27','13:05:00',4.09),('14598','2013-09-27','13:10:00',4.07),('14598','2013-09-27','13:15:00',4.03),('14598','2013-09-27','13:20:00',4.11),('14598','2013-09-27','13:25:00',4.09),('14598','2013-09-27','13:30:00',4.06),('14598','2013-09-27','13:35:00',4.06),('14598','2013-09-27','13:40:00',4.02),('14598','2013-09-27','13:45:00',4.01),('14598','2013-09-27','13:50:00',4.08),('14598','2013-09-27','13:55:00',4.05),('14598','2013-09-27','14:00:00',4.13),('14598','2013-09-27','14:05:00',3.63),('14598','2013-09-27','14:10:00',3),('14598','2013-09-27','14:15:00',1.88),('14598','2013-09-27','14:20:00',3.38),('14598','2013-09-27','14:25:00',2.69),('14598','2013-09-27','14:30:00',3.47),('14598','2013-09-27','14:35:00',4.13),('14598','2013-09-27','14:40:00',3.92),('14598','2013-09-27','14:45:00',3.86),('14598','2013-09-27','14:50:00',3.91),('14598','2013-09-27','14:55:00',3.91),('14598','2013-09-27','15:00:00',3.49),('14598','2013-09-27','15:05:00',3.65),('14598','2013-09-27','15:10:00',3.36),('14598','2013-09-27','15:15:00',3.56),('14598','2013-09-27','15:20:00',3.56),('14598','2013-09-27','15:25:00',3.61),('14598','2013-09-27','15:30:00',3.54),('14598','2013-09-27','15:35:00',3.48),('14598','2013-09-27','15:40:00',3.41),('14598','2013-09-27','15:45:00',3.31),('14598','2013-09-27','15:50:00',3.27),('14598','2013-09-27','15:55:00',3.21),('14598','2013-09-27','16:00:00',3.14),('14598','2013-09-27','16:05:00',3.07),('14598','2013-09-27','16:10:00',2.98),('14598','2013-09-27','16:15:00',2.95),('14598','2013-09-27','16:20:00',2.87),('14598','2013-09-27','16:25:00',2.79),('14598','2013-09-27','16:30:00',2.7),('14598','2013-09-27','16:35:00',2.58),('14598','2013-09-27','16:40:00',2.51),('14598','2013-09-27','16:45:00',2.4),('14598','2013-09-27','16:50:00',2.31),('14598','2013-09-27','16:55:00',2.21),('14598','2013-09-27','17:00:00',2.18),('14598','2013-09-27','17:05:00',2.09),('14598','2013-09-27','17:10:00',1.99),('14598','2013-09-27','17:15:00',1.87),('14598','2013-09-27','17:20:00',1.76),('14598','2013-09-27','17:25:00',1.66),('14598','2013-09-27','17:30:00',1.53),('14598','2013-09-27','17:35:00',1.41),('14598','2013-09-27','17:40:00',1.35),('14598','2013-09-27','17:45:00',1.19),('14598','2013-09-27','17:50:00',1.08),('14598','2013-09-27','17:55:00',1.02),('14598','2013-09-26','08:55:00',1.09),('14598','2013-09-26','09:00:00',1.22),('14598','2013-09-26','09:05:00',1.33),('14598','2013-09-26','09:10:00',1.45),('14598','2013-09-26','09:15:00',1.56),('14598','2013-09-26','09:20:00',1.69),('14598','2013-09-26','09:25:00',1.8),('14598','2013-09-26','09:30:00',1.86),('14598','2013-09-26','09:35:00',1.9),('14598','2013-09-26','09:40:00',2.03),('14598','2013-09-26','09:45:00',2.11),('14598','2013-09-26','09:50:00',2.21),('14598','2013-09-26','09:55:00',2.35),('14598','2013-09-26','10:00:00',2.15),('14598','2013-09-26','10:05:00',1.96),('14598','2013-09-26','10:10:00',1.8),('14598','2013-09-26','10:15:00',2),('14598','2013-09-26','10:20:00',2.48),('14598','2013-09-26','10:25:00',2.72),('14598','2013-09-26','10:30:00',2.7),('14598','2013-09-26','10:35:00',2.89),('14598','2013-09-26','10:40:00',2.85),('14598','2013-09-26','10:45:00',2.99),('14598','2013-09-26','10:50:00',3.09),('14598','2013-09-26','10:55:00',3.18),('14598','2013-09-26','11:00:00',3.23),('14598','2013-09-26','11:05:00',2.77),('14598','2013-09-26','11:10:00',1.91),('14598','2013-09-26','11:15:00',2.37),('14598','2013-09-26','11:20:00',2.13),('14598','2013-09-26','11:25:00',1.33),('14598','2013-09-26','11:30:00',2.38),('14598','2013-09-26','11:35:00',3.79),('14598','2013-09-26','11:40:00',3.68),('14598','2013-09-26','11:45:00',3.8),('14598','2013-09-26','11:50:00',3.85),('14598','2013-09-26','11:55:00',3.9),('14598','2013-09-26','12:00:00',4.02),('14598','2013-09-26','12:05:00',4.26),('14598','2013-09-26','12:10:00',3.62),('14598','2013-09-26','12:15:00',2.96),('14598','2013-09-26','12:20:00',3.8),('14598','2013-09-26','12:25:00',2.99),('14598','2013-09-26','12:30:00',3.56),('14598','2013-09-26','12:35:00',3.92),('14598','2013-09-26','12:40:00',4.28),('14598','2013-09-26','12:45:00',3.88),('14598','2013-09-26','12:50:00',4.2),('14598','2013-09-26','12:55:00',3.47),('14598','2013-09-26','13:00:00',3.38),('14598','2013-09-26','13:05:00',2.5),('14598','2013-09-26','13:10:00',4),('14598','2013-09-26','13:15:00',4.26),('14598','2013-09-26','13:20:00',4.27),('14598','2013-09-26','13:25:00',4.33),('14598','2013-09-26','13:30:00',3.06),('14598','2013-09-26','13:35:00',3.41),('14598','2013-09-26','13:40:00',3.3),('14598','2013-09-26','13:45:00',3.61),('14598','2013-09-26','13:50:00',3.65),('14598','2013-09-26','13:55:00',4.13),('14598','2013-09-26','14:00:00',4.36),('14598','2013-09-26','14:05:00',4.26),('14598','2013-09-26','14:10:00',4.2),('14598','2013-09-26','14:15:00',4.15),('14598','2013-09-26','14:20:00',4.17),('14598','2013-09-26','14:25:00',4.11),('14598','2013-09-26','14:30:00',1.44),('14598','2013-09-26','14:35:00',1.27),('14598','2013-09-26','14:40:00',3.14),('14598','2013-09-26','14:45:00',4),('14598','2013-09-26','14:50:00',4),('14598','2013-09-26','14:55:00',2.96),('14598','2013-09-26','15:00:00',2.99),('14598','2013-09-26','15:05:00',3.76),('14598','2013-09-26','15:10:00',2.96),('14598','2013-09-26','15:20:00',3.62),('14598','2013-09-26','15:25:00',3.88),('14598','2013-09-26','15:30:00',3.58),('14598','2013-09-26','15:35:00',3.64),('14598','2013-09-26','15:40:00',3.25),('14598','2013-09-26','15:45:00',2.92),('14598','2013-09-26','15:50:00',1.67),('14598','2013-09-26','15:55:00',1.14),('14598','2013-09-26','16:00:00',1.32),('14598','2013-09-26','16:05:00',2.13),('14598','2013-09-26','16:10:00',2.32),('14598','2013-09-26','16:15:00',2.05),('14598','2013-09-26','16:20:00',2.65),('14598','2013-09-26','16:25:00',2.73),('14598','2013-09-26','16:30:00',2.73),('14598','2013-09-26','16:35:00',2.64),('14598','2013-09-26','16:40:00',2.53),('14598','2013-09-26','16:45:00',2.44),('14598','2013-09-26','16:50:00',2.36),('14598','2013-09-26','16:55:00',1.92),('14598','2013-09-26','17:05:00',1.57),('14598','2013-09-26','17:10:00',1.75),('14598','2013-09-26','17:15:00',1.7),('14598','2013-09-26','17:20:00',1.61),('14598','2013-09-26','17:25:00',1.53),('14598','2013-09-26','17:30:00',1.3),('14598','2013-09-26','17:35:00',1.38),('14598','2013-09-26','17:40:00',1.33),('14598','2013-09-26','17:45:00',1.21),('14598','2013-09-26','17:50:00',1.06),('14598','2013-09-25','08:45:00',1.21),('14598','2013-09-25','08:50:00',1.25),('14598','2013-09-25','08:55:00',1.55),('14598','2013-09-25','09:00:00',1.69),('14598','2013-09-25','09:05:00',1.08),('14598','2013-09-25','09:10:00',1.7),('14598','2013-09-25','09:15:00',1.73),('14598','2013-09-25','09:20:00',1.16),('14598','2013-09-25','09:25:00',1.48),('14598','2013-09-25','09:30:00',1.75),('14598','2013-09-25','09:35:00',2.04),('14598','2013-09-25','09:40:00',2.33),('14598','2013-09-25','09:45:00',2.52),('14598','2013-09-25','09:50:00',1.63),('14598','2013-09-25','09:55:00',1.83),('14598','2013-09-25','10:00:00',2.22),('14598','2013-09-25','10:05:00',1.29),('14598','2013-09-25','10:10:00',1.21),('14598','2013-09-25','10:35:00',1.31),('14598','2013-09-25','10:40:00',3.11),('14598','2013-09-25','10:45:00',3.16),('14598','2013-09-25','10:50:00',3.21),('14598','2013-09-25','10:55:00',3.34),('14598','2013-09-25','11:00:00',3.22),('14598','2013-09-25','11:05:00',3.47),('14598','2013-09-25','11:10:00',3.52),('14598','2013-09-25','11:15:00',3.54),('14598','2013-09-25','11:20:00',3.63),('14598','2013-09-25','11:25:00',3.66),('14598','2013-09-25','11:30:00',3.72),('14598','2013-09-25','11:35:00',3.73),('14598','2013-09-25','11:40:00',3.78),('14598','2013-09-25','11:45:00',3.83),('14598','2013-09-25','11:50:00',3.89),('14598','2013-09-25','11:55:00',3.87),('14598','2013-09-25','12:00:00',3.96),('14598','2013-09-25','12:05:00',4.02),('14598','2013-09-25','12:10:00',4.04),('14598','2013-09-25','12:15:00',4.08),('14598','2013-09-25','12:20:00',4.12),('14598','2013-09-25','12:25:00',4.15),('14598','2013-09-25','12:30:00',4.16),('14598','2013-09-25','12:35:00',4.16),('14598','2013-09-25','12:40:00',4.2),('14598','2013-09-25','12:45:00',4.23),('14598','2013-09-25','12:50:00',4.26),('14598','2013-09-25','12:55:00',4.27),('14598','2013-09-25','13:00:00',4.29),('14598','2013-09-25','13:05:00',4.32),('14598','2013-09-25','13:10:00',4.31),('14598','2013-09-25','13:15:00',4.33),('14598','2013-09-25','13:20:00',4.33),('14598','2013-09-25','13:25:00',4.36),('14598','2013-09-25','13:30:00',4.36),('14598','2013-09-25','13:35:00',4.22),('14598','2013-09-25','13:40:00',4.21),('14598','2013-09-25','13:45:00',4.26),('14598','2013-09-25','13:50:00',4.24),('14598','2013-09-25','13:55:00',4.3),('14598','2013-09-25','14:00:00',4.27),('14598','2013-09-25','14:05:00',4.24),('14598','2013-09-25','14:10:00',4.23),('14598','2013-09-25','14:15:00',3.93),('14598','2013-09-25','14:20:00',4.28),('14598','2013-09-25','14:25:00',4.19),('14598','2013-09-25','14:30:00',4.17),('14598','2013-09-25','14:35:00',4.14),('14598','2013-09-25','14:40:00',4.1),('14598','2013-09-25','14:45:00',3.92),('14598','2013-09-25','14:50:00',3.94),('14598','2013-09-25','14:55:00',4.09),('14598','2013-09-25','15:00:00',3.53),('14598','2013-09-25','15:05:00',3.89),('14598','2013-09-25','15:10:00',4.01),('14598','2013-09-25','15:15:00',3.6),('14598','2013-09-25','15:20:00',3.65),('14598','2013-09-25','15:25:00',3.82),('14598','2013-09-25','15:30:00',3.74),('14598','2013-09-25','15:35:00',3.65),('14598','2013-09-25','15:40:00',3.63),('14598','2013-09-25','15:45:00',3.59),('14598','2013-09-25','15:50:00',3.52),('14598','2013-09-25','15:55:00',3.46),('14598','2013-09-25','16:00:00',3.37),('14598','2013-09-25','16:05:00',3.28),('14598','2013-09-25','16:10:00',3.23),('14598','2013-09-25','16:15:00',3.15),('14598','2013-09-25','16:20:00',3.08),('14598','2013-09-25','16:25:00',3.01),('14598','2013-09-25','16:30:00',2.94),('14598','2013-09-25','16:35:00',2.86),('14598','2013-09-25','16:40:00',2.77),('14598','2013-09-25','16:45:00',2.67),('14598','2013-09-25','16:50:00',2.59),('14598','2013-09-25','16:55:00',2.5),('14598','2013-09-25','17:00:00',2.41),('14598','2013-09-25','17:05:00',2.31),('14598','2013-09-25','17:10:00',2.21),('14598','2013-09-25','17:15:00',2.11),('14598','2013-09-25','17:20:00',2.01),('14598','2013-09-25','17:25:00',1.9),('14598','2013-09-25','17:30:00',1.8),('14598','2013-09-25','17:35:00',1.69),('14598','2013-09-25','17:40:00',1.58),('14598','2013-09-25','17:45:00',1.47),('14598','2013-09-25','17:50:00',1.36),('14598','2013-09-25','17:55:00',1.25),('14598','2013-09-25','18:00:00',1.11),('14598','2013-09-25','18:05:00',1.01),('14598','2013-09-24','08:50:00',1.06),('14598','2013-09-24','08:55:00',1.17),('14598','2013-09-24','09:00:00',1.28),('14598','2013-09-24','09:05:00',1.39),('14598','2013-09-24','09:10:00',1.48),('14598','2013-09-24','09:15:00',1.62),('14598','2013-09-24','09:20:00',1.74),('14598','2013-09-24','09:25:00',1.85),('14598','2013-09-24','09:30:00',1.95),('14598','2013-09-24','09:35:00',2.05),('14598','2013-09-24','09:40:00',2.14),('14598','2013-09-24','09:45:00',2.24),('14598','2013-09-24','09:50:00',2.33),('14598','2013-09-24','09:55:00',2.42),('14598','2013-09-24','10:00:00',2.52),('14598','2013-09-24','10:05:00',2.61),('14598','2013-09-24','10:10:00',2.7),('14598','2013-09-24','10:15:00',2.78),('14598','2013-09-24','10:20:00',2.86),('14598','2013-09-24','10:25:00',2.94),('14598','2013-09-24','10:30:00',3.01),('14598','2013-09-24','10:35:00',3.07),('14598','2013-09-24','10:40:00',3.13),('14598','2013-09-24','10:45:00',3.19),('14598','2013-09-24','10:50:00',3.25),('14598','2013-09-24','10:55:00',3.3),('14598','2013-09-24','11:00:00',3.38),('14598','2013-09-24','11:05:00',3.43),('14598','2013-09-24','11:10:00',3.49),('14598','2013-09-24','11:15:00',3.55),('14598','2013-09-24','11:20:00',3.59),('14598','2013-09-24','11:25:00',3.64),('14598','2013-09-24','11:30:00',3.67),('14598','2013-09-24','11:35:00',3.76),('14598','2013-09-24','11:40:00',3.85),('14598','2013-09-24','11:45:00',3.93),('14598','2013-09-24','11:50:00',3.96),('14598','2013-09-24','11:55:00',3.99),('14598','2013-09-24','12:00:00',4.03),('14598','2013-09-24','12:05:00',4.07),('14598','2013-09-24','12:10:00',4.09),('14598','2013-09-24','12:15:00',4.15),('14598','2013-09-24','12:20:00',4.19),('14598','2013-09-24','12:25:00',4.22),('14598','2013-09-24','12:30:00',4.25),('14598','2013-09-24','12:35:00',4.28),('14598','2013-09-24','12:40:00',4.31),('14598','2013-09-24','12:45:00',4.33),('14598','2013-09-24','12:50:00',4.34),('14598','2013-09-24','12:55:00',4.37),('14598','2013-09-24','13:00:00',4.39),('14598','2013-09-24','13:05:00',4.42),('14598','2013-09-24','13:10:00',4.45),('14598','2013-09-24','13:15:00',4.44),('14598','2013-09-24','13:20:00',4.46),('14598','2013-09-24','13:25:00',4.42),('14598','2013-09-24','13:30:00',4.41),('14598','2013-09-24','13:35:00',4.44),('14598','2013-09-24','13:40:00',4.43),('14598','2013-09-24','13:45:00',4.42),('14598','2013-09-24','13:50:00',4.42),('14598','2013-09-24','13:55:00',4.4),('14598','2013-09-24','14:00:00',4.4),('14598','2013-09-24','14:05:00',4.38),('14598','2013-09-24','14:10:00',4.36),('14598','2013-09-24','14:15:00',4.33),('14598','2013-09-24','14:20:00',4.31),('14598','2013-09-24','14:25:00',4.29),('14598','2013-09-24','14:30:00',4.28),('14598','2013-09-24','14:35:00',4.26),('14598','2013-09-24','14:40:00',4.24),('14598','2013-09-24','14:45:00',4.21),('14598','2013-09-24','14:50:00',4.17),('14598','2013-09-24','14:55:00',4.12),('14598','2013-09-24','15:00:00',4.07),('14598','2013-09-24','15:05:00',4.06),('14598','2013-09-24','15:10:00',3.94),('14598','2013-09-24','15:15:00',3.97),('14598','2013-09-24','15:20:00',3.92),('14598','2013-09-24','15:25:00',3.88),('14598','2013-09-24','15:30:00',3.82),('14598','2013-09-24','15:35:00',3.77),('14598','2013-09-24','15:40:00',3.71),('14598','2013-09-24','15:45:00',3.64),('14598','2013-09-24','15:50:00',3.58),('14598','2013-09-24','15:55:00',3.53),('14598','2013-09-24','16:00:00',3.46),('14598','2013-09-24','16:05:00',3.37),('14598','2013-09-24','16:10:00',3.33),('14598','2013-09-24','16:15:00',3.24),('14598','2013-09-24','16:20:00',3.17),('14598','2013-09-24','16:25:00',3.08),('14598','2013-09-24','16:30:00',2.98),('14598','2013-09-24','16:35:00',2.91),('14598','2013-09-24','16:40:00',2.82),('14598','2013-09-24','16:45:00',2.76),('14598','2013-09-24','16:50:00',2.67),('14598','2013-09-24','16:55:00',2.56),('14598','2013-09-24','17:00:00',2.47),('14598','2013-09-24','17:05:00',2.38),('14598','2013-09-24','17:10:00',2.27),('14598','2013-09-24','17:15:00',2.19),('14598','2013-09-24','17:20:00',2.08),('14598','2013-09-24','17:25:00',1.95),('14598','2013-09-24','17:30:00',1.85),('14598','2013-09-24','17:35:00',1.76),('14598','2013-09-24','17:40:00',1.62),('14598','2013-09-24','17:45:00',1.41),('14598','2013-09-24','17:50:00',1.01),('14598','2013-09-24','17:55:00',1.34),('14598','2013-09-24','18:00:00',1.19),('14598','2013-09-24','18:05:00',1.07),('14598','2013-09-23','08:50:00',1.1),('14598','2013-09-23','08:55:00',1.21),('14598','2013-09-23','09:00:00',1.31),('14598','2013-09-23','09:05:00',1.42),('14598','2013-09-23','09:10:00',1.53),('14598','2013-09-23','09:15:00',1.67),('14598','2013-09-23','09:20:00',1.8),('14598','2013-09-23','09:25:00',1.9),('14598','2013-09-23','09:30:00',1.99),('14598','2013-09-23','09:35:00',2.1),('14598','2013-09-23','09:40:00',2.19),('14598','2013-09-23','09:45:00',2.28),('14598','2013-09-23','09:50:00',2.38),('14598','2013-09-23','09:55:00',2.47),('14598','2013-09-23','10:00:00',2.55),('14598','2013-09-23','10:05:00',2.65),('14598','2013-09-23','10:10:00',2.74),('14598','2013-09-23','10:15:00',2.82),('14598','2013-09-23','10:20:00',2.9),('14598','2013-09-23','10:25:00',2.98),('14598','2013-09-23','10:30:00',3.07),('14598','2013-09-23','10:35:00',3.14),('14598','2013-09-23','10:40:00',3.22),('14598','2013-09-23','10:45:00',3.28),('14598','2013-09-23','10:50:00',3.34),('14598','2013-09-23','10:55:00',3.41),('14598','2013-09-23','11:00:00',3.47),('14598','2013-09-23','11:05:00',3.52),('14598','2013-09-23','11:10:00',3.59),('14598','2013-09-23','11:15:00',3.62),('14598','2013-09-23','11:20:00',3.68),('14598','2013-09-23','11:25:00',3.72),('14598','2013-09-23','11:30:00',3.77),('14598','2013-09-23','11:35:00',3.84),('14598','2013-09-23','11:40:00',3.79),('14598','2013-09-23','11:45:00',3.92),('14598','2013-09-23','11:50:00',3.9),('14598','2013-09-23','11:55:00',3.96),('14598','2013-09-23','12:00:00',3.99),('14598','2013-09-23','12:05:00',3.99),('14598','2013-09-23','12:10:00',4.07),('14598','2013-09-23','12:15:00',4.07),('14598','2013-09-23','12:20:00',4.09),('14598','2013-09-23','12:25:00',4.11),('14598','2013-09-23','12:30:00',4.12),('14598','2013-09-23','12:35:00',4.17),('14598','2013-09-23','12:40:00',4.21),('14598','2013-09-23','12:45:00',4.21),('14598','2013-09-23','12:50:00',4.24),('14598','2013-09-23','12:55:00',4.28),('14598','2013-09-23','13:00:00',4.28),('14598','2013-09-23','13:05:00',4.25),('14598','2013-09-23','13:10:00',4.28),('14598','2013-09-23','13:15:00',4.28),('14598','2013-09-23','13:20:00',4.28),('14598','2013-09-23','13:25:00',4.23),('14598','2013-09-23','13:30:00',4.28),('14598','2013-09-23','13:35:00',4.26),('14598','2013-09-23','13:40:00',4.24),('14598','2013-09-23','13:45:00',4.16),('14598','2013-09-23','13:50:00',4.22),('14598','2013-09-23','13:55:00',4.26),('14598','2013-09-23','14:00:00',4.25),('14598','2013-09-23','14:05:00',4.25),('14598','2013-09-23','14:10:00',4.32),('14598','2013-09-23','14:15:00',4.28),('14598','2013-09-23','14:20:00',4.26),('14598','2013-09-23','14:25:00',4.23),('14598','2013-09-23','14:30:00',4.19),('14598','2013-09-23','14:35:00',4.18),('14598','2013-09-23','14:40:00',4.16),('14598','2013-09-23','14:45:00',4.13),('14598','2013-09-23','14:50:00',4.09),('14598','2013-09-23','14:55:00',4.06),('14598','2013-09-23','15:00:00',4.04),('14598','2013-09-23','15:05:00',4),('14598','2013-09-23','15:10:00',3.97),('14598','2013-09-23','15:15:00',3.92),('14598','2013-09-23','15:20:00',3.89),('14598','2013-09-23','15:25:00',3.85),('14598','2013-09-23','15:30:00',3.79),('14598','2013-09-23','15:35:00',3.73),('14598','2013-09-23','15:40:00',3.68),('14598','2013-09-23','15:45:00',3.64),('14598','2013-09-23','15:50:00',3.59),('14598','2013-09-23','15:55:00',3.51),('14598','2013-09-23','16:00:00',3.42),('14598','2013-09-23','16:05:00',3.35),('14598','2013-09-23','16:10:00',3.28),('14598','2013-09-23','16:15:00',3.21),('14598','2013-09-23','16:20:00',3.13),('14598','2013-09-23','16:25:00',3.06),('14598','2013-09-23','16:30:00',2.98),('14598','2013-09-23','16:35:00',2.9),('14598','2013-09-23','16:40:00',2.83),('14598','2013-09-23','16:45:00',2.75),('14598','2013-09-23','16:50:00',2.65),('14598','2013-09-23','16:55:00',2.57),('14598','2013-09-23','17:00:00',2.48),('14598','2013-09-23','17:05:00',2.37),('14598','2013-09-23','17:10:00',2.26),('14598','2013-09-23','17:15:00',2.15),('14598','2013-09-23','17:20:00',2.06),('14598','2013-09-23','17:25:00',1.96),('14598','2013-09-23','17:30:00',1.85),('14598','2013-09-23','17:35:00',1.74),('14598','2013-09-23','17:40:00',1.61),('14598','2013-09-23','17:45:00',1.5),('14598','2013-09-23','17:50:00',1.39),('14598','2013-09-23','17:55:00',1.27),('14598','2013-09-23','18:00:00',1.14),('14598','2013-09-23','18:05:00',1.03),('14598','2013-09-22','08:50:00',1.09),('14598','2013-09-22','08:55:00',1.2),('14598','2013-09-22','09:00:00',1.29),('14598','2013-09-22','09:05:00',1.37),('14598','2013-09-22','09:10:00',1.49),('14598','2013-09-22','09:15:00',1.64),('14598','2013-09-22','09:20:00',1.77),('14598','2013-09-22','09:25:00',1.86),('14598','2013-09-22','09:30:00',1.96),('14598','2013-09-22','09:35:00',2.06),('14598','2013-09-22','09:40:00',2.15),('14598','2013-09-22','09:45:00',2.25),('14598','2013-09-22','09:50:00',2.34),('14598','2013-09-22','09:55:00',2.43),('14598','2013-09-22','10:00:00',2.52),('14598','2013-09-22','10:05:00',2.61),('14598','2013-09-22','10:10:00',2.7),('14598','2013-09-22','10:15:00',2.78),('14598','2013-09-22','10:20:00',2.87),('14598','2013-09-22','10:25:00',2.95),('14598','2013-09-22','10:30:00',3.03),('14598','2013-09-22','10:35:00',3.11),('14598','2013-09-22','10:40:00',3.17),('14598','2013-09-22','10:45:00',3.26),('14598','2013-09-22','10:50:00',3.32),('14598','2013-09-22','10:55:00',3.39),('14598','2013-09-22','11:00:00',3.46),('14598','2013-09-22','11:05:00',3.53),('14598','2013-09-22','11:10:00',3.61),('14598','2013-09-22','11:15:00',3.66),('14598','2013-09-22','11:20:00',3.72),('14598','2013-09-22','11:25:00',3.77),('14598','2013-09-22','11:30:00',3.82),('14598','2013-09-22','11:35:00',3.88),('14598','2013-09-22','11:40:00',3.92),('14598','2013-09-22','11:45:00',3.97),('14598','2013-09-22','11:50:00',4.03),('14598','2013-09-22','11:55:00',4.11),('14598','2013-09-22','12:00:00',4.03),('14598','2013-09-22','12:05:00',4.11),('14598','2013-09-22','12:10:00',4.11),('14598','2013-09-22','12:15:00',4.13),('14598','2013-09-22','12:20:00',4.2),('14598','2013-09-22','12:25:00',4.21),('14598','2013-09-22','12:30:00',4.29),('14598','2013-09-22','12:35:00',4.33),('14598','2013-09-22','12:40:00',4.35),('14598','2013-09-22','12:45:00',4.35),('14598','2013-09-22','12:50:00',4.34),('14598','2013-09-22','12:55:00',4.36),('14598','2013-09-22','13:00:00',4.36),('14598','2013-09-22','13:05:00',4.36),('14598','2013-09-22','13:10:00',4.35),('14598','2013-09-22','13:15:00',4.35),('14598','2013-09-22','13:20:00',4.4),('14598','2013-09-22','13:25:00',3.47),('14598','2013-09-22','13:30:00',4.13),('14598','2013-09-22','13:35:00',4.39),('14598','2013-09-22','13:40:00',3.95),('14598','2013-09-22','13:45:00',3.09),('14598','2013-09-22','13:50:00',4.59),('14598','2013-09-22','13:55:00',4.35),('14598','2013-09-22','14:00:00',3.79),('14598','2013-09-22','14:05:00',4.43),('14598','2013-09-22','14:10:00',4.6),('14598','2013-09-22','14:15:00',4.54),('14598','2013-09-22','14:20:00',4.58),('14598','2013-09-22','14:25:00',3.78),('14598','2013-09-22','14:30:00',2.58),('14598','2013-09-22','14:35:00',1.73),('14598','2013-09-22','14:40:00',2.29),('14598','2013-09-22','14:45:00',4.08),('14598','2013-09-22','14:50:00',3.27),('14598','2013-09-22','14:55:00',2.14),('14598','2013-09-22','15:00:00',1.62),('14598','2013-09-22','15:05:00',4.03),('14598','2013-09-22','15:10:00',1.66),('14598','2013-09-22','15:15:00',4.41),('14598','2013-09-22','15:20:00',3.04),('14598','2013-09-22','15:25:00',2.35),('14598','2013-09-22','15:30:00',2.53),('14598','2013-09-22','15:35:00',2.17),('14598','2013-09-22','15:40:00',2.07),('14598','2013-09-22','15:45:00',1.51),('14598','2013-09-22','15:50:00',1.58),('14598','2013-09-22','15:55:00',2.09),('14598','2013-09-22','16:00:00',1.9),('14598','2013-09-22','16:05:00',2.05),('14598','2013-09-22','16:10:00',1.81),('14598','2013-09-22','16:15:00',1.43),('14598','2013-09-22','16:20:00',1.46),('14598','2013-09-22','16:25:00',1.35),('14598','2013-09-22','16:30:00',1.1),('14598','2013-09-22','16:35:00',1.1),('14598','2013-09-22','16:40:00',1.06),('14598','2013-09-22','16:50:00',1),('14598','2013-09-22','17:15:00',1.63),('14598','2013-09-22','17:20:00',2.18),('14598','2013-09-22','17:25:00',2.04),('14598','2013-09-22','17:30:00',1.67),('14598','2013-09-22','17:35:00',1.05),('14598','2013-09-22','17:55:00',1.27),('14598','2013-09-22','18:00:00',1.15),('14598','2013-09-21','08:50:00',1.1),('14598','2013-09-21','08:55:00',1.2),('14598','2013-09-21','09:00:00',1.3),('14598','2013-09-21','09:05:00',1.39),('14598','2013-09-21','09:10:00',1.51),('14598','2013-09-21','09:15:00',1.66),('14598','2013-09-21','09:20:00',1.77),('14598','2013-09-21','09:25:00',1.86),('14598','2013-09-21','09:30:00',1.97),('14598','2013-09-21','09:35:00',2.06),('14598','2013-09-21','09:40:00',2.16),('14598','2013-09-21','09:45:00',2.24),('14598','2013-09-21','09:50:00',2.33),('14598','2013-09-21','09:55:00',2.44),('14598','2013-09-21','10:00:00',2.53),('14598','2013-09-21','10:05:00',2.62),('14598','2013-09-21','10:10:00',2.69),('14598','2013-09-21','10:15:00',2.78),('14598','2013-09-21','10:20:00',2.87),('14598','2013-09-21','10:25:00',2.94),('14598','2013-09-21','10:30:00',3.02),('14598','2013-09-21','10:35:00',3.09),('14598','2013-09-21','10:40:00',3.14),('14598','2013-09-21','10:45:00',3.21),('14598','2013-09-21','10:50:00',3.29),('14598','2013-09-21','10:55:00',3.36),('14598','2013-09-21','11:00:00',3.42),('14598','2013-09-21','11:05:00',3.41),('14598','2013-09-21','11:10:00',3.52),('14598','2013-09-21','11:15:00',3.58),('14598','2013-09-21','11:20:00',3.64),('14598','2013-09-21','11:25:00',3.69),('14598','2013-09-21','11:30:00',3.76),('14598','2013-09-21','11:35:00',3.81),('14598','2013-09-21','11:40:00',3.88),('14598','2013-09-21','11:45:00',3.93),('14598','2013-09-21','11:50:00',3.99),('14598','2013-09-21','11:55:00',4.02),('14598','2013-09-21','12:00:00',4.09),('14598','2013-09-21','12:05:00',3.73),('14598','2013-09-21','12:10:00',4.14),('14598','2013-09-21','12:15:00',4.25),('14598','2013-09-21','12:20:00',3.97),('14598','2013-09-21','12:25:00',4.23),('14598','2013-09-21','12:30:00',4.09),('14598','2013-09-21','12:35:00',4.23),('14598','2013-09-21','12:40:00',4.38),('14598','2013-09-21','12:45:00',4.37),('14598','2013-09-21','12:50:00',4.34),('14598','2013-09-21','12:55:00',4.35),('14598','2013-09-21','13:00:00',4.52),('14598','2013-09-21','13:05:00',4.11),('14598','2013-09-21','13:10:00',3.86),('14598','2013-09-21','13:15:00',4.12),('14598','2013-09-21','13:20:00',4.18),('14598','2013-09-21','13:25:00',3.96),('14598','2013-09-21','13:30:00',3.95),('14598','2013-09-21','13:35:00',4.04),('14598','2013-09-21','13:40:00',4.32),('14598','2013-09-21','13:45:00',4.4),('14598','2013-09-21','13:50:00',4.33),('14598','2013-09-21','13:55:00',4.41),('14598','2013-09-21','14:00:00',4.38),('14598','2013-09-21','14:05:00',4.37),('14598','2013-09-21','14:10:00',4.28),('14598','2013-09-21','14:15:00',4.34),('14598','2013-09-21','14:20:00',4.32),('14598','2013-09-21','14:25:00',4.25),('14598','2013-09-21','14:30:00',4.27),('14598','2013-09-21','14:35:00',4.24),('14598','2013-09-21','14:40:00',4.23),('14598','2013-09-21','14:45:00',4.19),('14598','2013-09-21','14:50:00',4.16),('14598','2013-09-21','14:55:00',4.02),('14598','2013-09-21','15:00:00',4.04),('14598','2013-09-21','15:05:00',4.04),('14598','2013-09-21','15:10:00',4.01),('14598','2013-09-21','15:15:00',3.97),('14598','2013-09-21','15:20:00',3.94),('14598','2013-09-21','15:25:00',3.88),('14598','2013-09-21','15:30:00',3.87),('14598','2013-09-21','15:35:00',3.85),('14598','2013-09-21','15:40:00',3.8),('14598','2013-09-21','15:45:00',1.6),('14598','2013-09-21','15:50:00',1.83),('14598','2013-09-21','15:55:00',1.84),('14598','2013-09-21','16:00:00',1.65),('14598','2013-09-21','16:05:00',1.69),('14598','2013-09-21','16:10:00',1.2),('14598','2013-09-21','16:15:00',1.92),('14598','2013-09-21','16:20:00',1.91),('14598','2013-09-21','16:25:00',1.87),('14598','2013-09-21','16:30:00',1.77),('14598','2013-09-21','16:35:00',1.85),('14598','2013-09-21','16:40:00',1.87),('14598','2013-09-21','16:45:00',1.08),('14598','2013-09-21','16:50:00',1.47),('14598','2013-09-21','16:55:00',1.87),('14598','2013-09-21','17:00:00',1.5),('14598','2013-09-21','17:15:00',1.09),('14598','2013-09-21','17:20:00',1.17),('14598','2013-09-21','17:25:00',1.45),('14598','2013-09-21','17:30:00',1.88),('14598','2013-09-21','17:35:00',1.68),('14598','2013-09-21','17:40:00',1.59),('14598','2013-09-21','17:45:00',1.59),('14598','2013-09-21','17:50:00',1.42),('14598','2013-09-21','17:55:00',1.2),('14598','2013-09-21','18:00:00',1.18),('14598','2013-09-21','18:05:00',1.04),('14598','2013-09-20','09:45:00',1.02),('14598','2013-09-20','09:50:00',1.08),('14598','2013-09-20','09:55:00',1.23),('14598','2013-09-20','10:00:00',1.4),('14598','2013-09-20','10:05:00',1.55),('14598','2013-09-20','10:10:00',1.63),('14598','2013-09-20','10:15:00',1.7),('14598','2013-09-20','10:20:00',1.8),('14598','2013-09-20','10:25:00',1.9),('14598','2013-09-20','10:30:00',2.4),('14598','2013-09-20','10:35:00',3.49),('14598','2013-09-20','10:40:00',2.79),('14598','2013-09-20','10:45:00',2.91),('14598','2013-09-20','10:50:00',2.26),('14598','2013-09-20','10:55:00',2.39),('14598','2013-09-20','11:00:00',2.7),('14598','2013-09-20','11:05:00',3.39),('14598','2013-09-20','11:10:00',2.56),('14598','2013-09-20','11:15:00',3.09),('14598','2013-09-20','11:20:00',3.76),('14598','2013-09-20','11:25:00',4.22),('14598','2013-09-20','11:30:00',4.55),('14598','2013-09-20','11:35:00',4.48),('14598','2013-09-20','11:40:00',4.18),('14598','2013-09-20','11:45:00',3.74),('14598','2013-09-20','11:50:00',3.36),('14598','2013-09-20','11:55:00',3.51),('14598','2013-09-20','12:00:00',2.44),('14598','2013-09-20','12:05:00',2.02),('14598','2013-09-20','12:10:00',3.2),('14598','2013-09-20','12:15:00',3.35),('14598','2013-09-20','12:20:00',3.14),('14598','2013-09-20','12:25:00',3.77),('14598','2013-09-20','12:30:00',3.5),('14598','2013-09-20','12:35:00',4.26),('14598','2013-09-20','12:40:00',4.2),('14598','2013-09-20','12:45:00',4.2),('14598','2013-09-20','12:50:00',4.09),('14598','2013-09-20','12:55:00',3.86),('14598','2013-09-20','13:00:00',4.21),('14598','2013-09-20','13:05:00',4.24),('14598','2013-09-20','13:10:00',4.24),('14598','2013-09-20','13:15:00',4.31),('14598','2013-09-20','13:20:00',4.27),('14598','2013-09-20','13:25:00',4.21),('14598','2013-09-20','13:30:00',4.23),('14598','2013-09-20','13:35:00',4.3),('14598','2013-09-20','13:40:00',4.31),('14598','2013-09-20','13:45:00',4.33),('14598','2013-09-20','13:50:00',4.33),('14598','2013-09-20','13:55:00',4.36),('14598','2013-09-20','14:00:00',4.36),('14598','2013-09-20','14:05:00',4.33),('14598','2013-09-20','14:10:00',4.33),('14598','2013-09-20','14:15:00',4.31),('14598','2013-09-20','14:20:00',4.32),('14598','2013-09-20','14:25:00',4.25),('14598','2013-09-20','14:30:00',4.23),('14598','2013-09-20','14:35:00',4.23),('14598','2013-09-20','14:40:00',4.28),('14598','2013-09-20','14:45:00',3.39),('14598','2013-09-20','14:50:00',4.29),('14598','2013-09-20','14:55:00',3.79),('14598','2013-09-20','15:00:00',4.34),('14598','2013-09-20','15:05:00',4.32),('14598','2013-09-20','15:10:00',4.18),('14598','2013-09-20','15:15:00',4.17),('14598','2013-09-20','15:20:00',4.26),('14598','2013-09-20','15:25:00',4.18),('14598','2013-09-20','15:30:00',4.15),('14598','2013-09-20','15:35:00',4.21),('14598','2013-09-20','15:40:00',4.44),('14598','2013-09-20','15:45:00',4.55);
INSERT INTO `solarlogmod` VALUES ('14598','2013-09-20','15:50:00',3.78),('14598','2013-09-20','15:55:00',2.13),('14598','2013-09-20','16:00:00',1.67),('14598','2013-09-20','16:05:00',1.87),('14598','2013-09-20','16:10:00',2.32),('14598','2013-09-20','16:15:00',2.31),('14598','2013-09-20','16:20:00',2.39),('14598','2013-09-20','16:25:00',2.91),('14598','2013-09-20','16:30:00',3.41),('14598','2013-09-20','16:35:00',3.2),('14598','2013-09-20','16:40:00',3.09),('14598','2013-09-20','16:45:00',2.9),('14598','2013-09-20','16:50:00',2.8),('14598','2013-09-20','16:55:00',2.71),('14598','2013-09-20','17:00:00',2.6),('14598','2013-09-20','17:05:00',2.47),('14598','2013-09-20','17:10:00',2.34),('14598','2013-09-20','17:15:00',2.24),('14598','2013-09-20','17:20:00',2.17),('14598','2013-09-20','17:25:00',2.03),('14598','2013-09-20','17:30:00',1.71),('14598','2013-09-20','17:45:00',1.54),('14598','2013-09-20','17:50:00',1.46),('14598','2013-09-20','17:55:00',1.37),('14598','2013-09-20','18:00:00',1.26),('14598','2013-09-20','18:05:00',1.14),('14598','2013-09-20','18:10:00',1.01),('14598','2013-09-19','08:50:00',1.12),('14598','2013-09-19','08:55:00',1.23),('14598','2013-09-19','09:00:00',1.36),('14598','2013-09-19','09:05:00',1.65),('14598','2013-09-19','09:10:00',1.52),('14598','2013-09-19','09:15:00',1.52),('14598','2013-09-19','09:20:00',1.2),('14598','2013-09-19','09:25:00',1.36),('14598','2013-09-19','09:40:00',1.95),('14598','2013-09-19','09:45:00',2.37),('14598','2013-09-19','09:50:00',1.98),('14598','2013-09-19','09:55:00',1.81),('14598','2013-09-19','10:00:00',2.71),('14598','2013-09-19','10:05:00',2.01),('14598','2013-09-19','10:10:00',1.14),('14598','2013-09-19','10:15:00',1.69),('14598','2013-09-19','10:20:00',2.13),('14598','2013-09-19','10:25:00',2.47),('14598','2013-09-19','10:30:00',2.45),('14598','2013-09-19','10:35:00',3.12),('14598','2013-09-19','10:40:00',3.19),('14598','2013-09-19','10:45:00',3.25),('14598','2013-09-19','10:50:00',3.32),('14598','2013-09-19','10:55:00',3.38),('14598','2013-09-19','11:00:00',3.44),('14598','2013-09-19','11:05:00',3.51),('14598','2013-09-19','11:10:00',3.58),('14598','2013-09-19','11:15:00',3.82),('14598','2013-09-19','11:20:00',3.28),('14598','2013-09-19','11:25:00',3.55),('14598','2013-09-19','11:30:00',3.9),('14598','2013-09-19','11:35:00',3.76),('14598','2013-09-19','11:40:00',3.93),('14598','2013-09-19','11:45:00',3.94),('14598','2013-09-19','11:50:00',3.97),('14598','2013-09-19','11:55:00',4.01),('14598','2013-09-19','12:00:00',4.09),('14598','2013-09-19','12:05:00',3.82),('14598','2013-09-19','12:10:00',4.17),('14598','2013-09-19','12:15:00',4.25),('14598','2013-09-19','12:20:00',4.27),('14598','2013-09-19','12:25:00',4.43),('14598','2013-09-19','12:30:00',4.34),('14598','2013-09-19','12:35:00',3.85),('14598','2013-09-19','12:40:00',4.72),('14598','2013-09-19','12:45:00',4.61),('14598','2013-09-19','12:50:00',4.42),('14598','2013-09-19','12:55:00',4.43),('14598','2013-09-19','13:00:00',4.57),('14598','2013-09-19','13:05:00',4.5),('14598','2013-09-19','13:10:00',4.15),('14598','2013-09-19','13:15:00',4.49),('14598','2013-09-19','13:20:00',4.49),('14598','2013-09-19','13:25:00',4.51),('14598','2013-09-19','13:30:00',4.49),('14598','2013-09-19','13:35:00',4.46),('14598','2013-09-19','13:40:00',4.48),('14598','2013-09-19','13:45:00',4.47),('14598','2013-09-19','13:50:00',4.46),('14598','2013-09-19','13:55:00',4.44),('14598','2013-09-19','14:00:00',4.41),('14598','2013-09-19','14:05:00',4.41),('14598','2013-09-19','14:10:00',4.41),('14598','2013-09-19','14:15:00',4.41),('14598','2013-09-19','14:20:00',4.27),('14598','2013-09-19','14:25:00',4.28),('14598','2013-09-19','14:30:00',4.36),('14598','2013-09-19','14:35:00',4.23),('14598','2013-09-19','14:40:00',4.03),('14598','2013-09-19','14:45:00',4.32),('14598','2013-09-19','14:50:00',4.27),('14598','2013-09-19','14:55:00',4.21),('14598','2013-09-19','15:00:00',4.13),('14598','2013-09-19','15:05:00',4.11),('14598','2013-09-19','15:10:00',4.16),('14598','2013-09-19','15:15:00',4.21),('14598','2013-09-19','15:20:00',3.78),('14598','2013-09-19','15:25:00',4.04),('14598','2013-09-19','15:30:00',3.68),('14598','2013-09-19','15:35:00',3.85),('14598','2013-09-19','15:40:00',3.8),('14598','2013-09-19','15:45:00',3.47),('14598','2013-09-19','15:50:00',2.87),('14598','2013-09-19','15:55:00',3.12),('14598','2013-09-19','16:00:00',4.14),('14598','2013-09-19','16:05:00',3.57),('14598','2013-09-19','16:10:00',2.96),('14598','2013-09-19','16:15:00',3.35),('14598','2013-09-19','16:20:00',3.29),('14598','2013-09-19','16:25:00',3.07),('14598','2013-09-19','16:30:00',3.12),('14598','2013-09-19','16:35:00',2.75),('14598','2013-09-19','16:40:00',2.76),('14598','2013-09-19','16:45:00',2.76),('14598','2013-09-19','16:50:00',2.74),('14598','2013-09-19','16:55:00',2.72),('14598','2013-09-19','17:00:00',2.57),('14598','2013-09-19','17:05:00',2.32),('14598','2013-09-19','17:10:00',2.26),('14598','2013-09-19','17:15:00',2),('14598','2013-09-19','17:20:00',1.69),('14598','2013-09-19','17:25:00',1.78),('14598','2013-09-19','17:30:00',2.13),('14598','2013-09-19','17:35:00',1.84),('14598','2013-09-19','17:40:00',1.57),('14598','2013-09-19','17:45:00',1.58),('14598','2013-09-19','17:50:00',1.37),('14598','2013-09-19','17:55:00',1.06),('14598','2013-09-19','18:00:00',1.35),('14598','2013-09-19','18:05:00',1.37),('14598','2013-09-19','18:10:00',1.31),('14598','2013-09-19','18:15:00',1.2),('14598','2013-09-19','18:20:00',1.06),('14598','2014-04-13','09:45:00',1.03),('14598','2014-04-13','09:50:00',1.37),('14598','2014-04-13','09:55:00',1.78),('14598','2014-04-13','10:00:00',1.9),('14598','2014-04-13','10:05:00',1.85),('14598','2014-04-13','10:10:00',2.33),('14598','2014-04-13','10:15:00',2.38),('14598','2014-04-13','10:20:00',3.66),('14598','2014-04-13','10:25:00',2.59),('14598','2014-04-13','10:30:00',1.87),('14598','2014-04-13','10:35:00',1.35),('14598','2014-04-13','10:40:00',1.21),('14598','2014-04-13','10:45:00',1.14),('14598','2014-04-13','10:50:00',1.07),('14598','2014-04-13','10:55:00',1.09),('14598','2014-04-13','11:00:00',1.18),('14598','2014-04-13','11:05:00',1.39),('14598','2014-04-13','11:10:00',1.57),('14598','2014-04-13','11:15:00',1.78),('14598','2014-04-13','11:20:00',3.97),('14598','2014-04-13','11:25:00',3.49),('14598','2014-04-13','11:30:00',4.15),('14598','2014-04-13','11:35:00',4.14),('14598','2014-04-13','11:40:00',4.42),('14598','2014-04-13','11:45:00',4.6),('14598','2014-04-13','11:50:00',3.24),('14598','2014-04-13','11:55:00',2.78),('14598','2014-04-13','12:00:00',2.65),('14598','2014-04-13','12:05:00',3.41),('14598','2014-04-13','12:10:00',1.87),('14598','2014-04-13','12:15:00',3.33),('14598','2014-04-13','12:20:00',3.45),('14598','2014-04-13','12:25:00',3.08),('14598','2014-04-13','12:30:00',3.76),('14598','2014-04-13','12:35:00',4.52),('14598','2014-04-13','12:40:00',4.3),('14598','2014-04-13','12:45:00',4.42),('14598','2014-04-13','12:50:00',5.38),('14598','2014-04-13','12:55:00',5.3),('14598','2014-04-13','13:00:00',2.61),('14598','2014-04-13','13:05:00',1.71),('14598','2014-04-13','13:10:00',1.43),('14598','2014-04-13','13:15:00',1.3),('14598','2014-04-13','13:20:00',1.28),('14598','2014-04-13','14:05:00',1.08),('14598','2014-04-13','14:10:00',1.29),('14598','2014-04-13','14:15:00',1.54),('14598','2014-04-13','14:20:00',1.95),('14598','2014-04-13','14:25:00',2.73),('14598','2014-04-13','14:30:00',4.95),('14598','2014-04-13','14:35:00',2.47),('14598','2014-04-13','14:40:00',1.98),('14598','2014-04-13','14:45:00',3.32),('14598','2014-04-13','14:50:00',3.45),('14598','2014-04-13','14:55:00',4.08),('14598','2014-04-13','15:00:00',2.92),('14598','2014-04-13','15:05:00',3.43),('14598','2014-04-13','15:10:00',4.16),('14598','2014-04-13','15:15:00',4.96),('14598','2014-04-13','15:20:00',4.57),('14598','2014-04-13','15:25:00',4.23),('14598','2014-04-13','15:30:00',2.54),('14598','2014-04-13','15:35:00',2.01),('14598','2014-04-13','15:40:00',2.53),('14598','2014-04-13','15:45:00',4.03),('14598','2014-04-13','15:50:00',3.44),('14598','2014-04-13','15:55:00',3.68),('14598','2014-04-13','16:00:00',3.19),('14598','2014-04-13','16:05:00',2.39),('14598','2014-04-13','16:10:00',1.68),('14598','2014-04-13','16:15:00',1.51),('14598','2014-04-13','16:20:00',1.85),('14598','2014-04-13','16:25:00',3.21),('14598','2014-04-13','16:30:00',3.33),('14598','2014-04-13','16:35:00',3.43),('14598','2014-04-13','16:40:00',2.44),('14598','2014-04-13','16:45:00',1.3),('14598','2014-04-13','16:50:00',1.85),('14598','2014-04-13','16:55:00',1.43),('14598','2014-04-13','17:00:00',2.05),('14598','2014-04-13','17:05:00',1.84),('14598','2014-04-13','17:10:00',1.62),('14598','2014-04-13','17:15:00',2.1),('14598','2014-04-13','17:20:00',2.46),('14598','2014-04-13','17:25:00',2.05),('14598','2014-04-13','17:30:00',1.58),('14598','2014-04-13','17:35:00',1.57),('14598','2014-04-13','17:40:00',1.68),('14598','2014-04-13','17:45:00',1.95),('14598','2014-04-13','17:50:00',1.25),('14598','2013-09-18','08:45:00',1.06),('14598','2013-09-18','08:50:00',1.22),('14598','2013-09-18','08:55:00',1.28),('14598','2013-09-18','09:00:00',1.35),('14598','2013-09-18','09:05:00',1.44),('14598','2013-09-18','09:10:00',1.82),('14598','2013-09-18','09:15:00',2.08),('14598','2013-09-18','09:20:00',1.73),('14598','2013-09-18','09:25:00',1.53),('14598','2013-09-18','09:30:00',1.64),('14598','2013-09-18','09:35:00',2.06),('14598','2013-09-18','09:40:00',2.21),('14598','2013-09-18','09:45:00',2.28),('14598','2013-09-18','09:50:00',2.35),('14598','2013-09-18','09:55:00',2.46),('14598','2013-09-18','10:00:00',2.56),('14598','2013-09-18','10:05:00',2.65),('14598','2013-09-18','10:10:00',2.72),('14598','2013-09-18','10:15:00',2.81),('14598','2013-09-18','10:20:00',2.88),('14598','2013-09-18','10:25:00',2.95),('14598','2013-09-18','10:30:00',3),('14598','2013-09-18','10:35:00',3.09),('14598','2013-09-18','10:40:00',3.17),('14598','2013-09-18','10:45:00',3.25),('14598','2013-09-18','10:50:00',3.34),('14598','2013-09-18','10:55:00',3.45),('14598','2013-09-18','11:00:00',3.1),('14598','2013-09-18','11:05:00',3.13),('14598','2013-09-18','11:10:00',3.63),('14598','2013-09-18','11:15:00',3.66),('14598','2013-09-18','11:20:00',3.65),('14598','2013-09-18','11:25:00',3.74),('14598','2013-09-18','11:30:00',3.8),('14598','2013-09-18','11:35:00',3.83),('14598','2013-09-18','11:40:00',3.9),('14598','2013-09-18','11:45:00',3.94),('14598','2013-09-18','11:50:00',4),('14598','2013-09-18','11:55:00',4.06),('14598','2013-09-18','12:00:00',4.17),('14598','2013-09-18','12:05:00',4.22),('14598','2013-09-18','12:10:00',4.22),('14598','2013-09-18','12:15:00',4.24),('14598','2013-09-18','12:20:00',4.29),('14598','2013-09-18','12:25:00',4.27),('14598','2013-09-18','12:30:00',4.3),('14598','2013-09-18','12:35:00',4.28),('14598','2013-09-18','12:40:00',4.38),('14598','2013-09-18','12:45:00',4.41),('14598','2013-09-18','12:50:00',4.49),('14598','2013-09-18','12:55:00',4.64),('14598','2013-09-18','13:00:00',4.54),('14598','2013-09-18','13:05:00',4.65),('14598','2013-09-18','13:10:00',4.38),('14598','2013-09-18','13:15:00',4.42),('14598','2013-09-18','13:20:00',4.44),('14598','2013-09-18','13:25:00',4.44),('14598','2013-09-18','13:30:00',4.43),('14598','2013-09-18','13:35:00',4.37),('14598','2013-09-18','13:40:00',4.48),('14598','2013-09-18','13:45:00',4.52),('14598','2013-09-18','13:50:00',4.49),('14598','2013-09-18','13:55:00',4.28),('14598','2013-09-18','14:00:00',4.45),('14598','2013-09-18','14:05:00',4.2),('14598','2013-09-18','14:10:00',4.52),('14598','2013-09-18','14:15:00',4.56),('14598','2013-09-18','14:20:00',2.92),('14598','2013-09-18','14:25:00',2.78),('14598','2013-09-18','14:30:00',3.49),('14598','2013-09-18','14:35:00',4.38),('14598','2013-09-18','14:40:00',3.57),('14598','2013-09-18','14:45:00',3.92),('14598','2013-09-18','14:50:00',2.88),('14598','2013-09-18','14:55:00',4.51),('14598','2013-09-18','15:00:00',4.23),('14598','2013-09-18','15:05:00',4.31),('14598','2013-09-18','15:10:00',3.54),('14598','2013-09-18','15:15:00',4.13),('14598','2013-09-18','15:20:00',4),('14598','2013-09-18','15:25:00',4.02),('14598','2013-09-18','15:30:00',3.89),('14598','2013-09-18','15:35:00',3.59),('14598','2013-09-18','15:40:00',3.86),('14598','2013-09-18','15:45:00',3.78),('14598','2013-09-18','15:50:00',3.67),('14598','2013-09-18','15:55:00',3.7),('14598','2013-09-18','16:00:00',3.54),('14598','2013-09-18','16:05:00',3.23),('14598','2013-09-18','16:10:00',3.27),('14598','2013-09-18','16:15:00',3.13),('14598','2013-09-18','16:20:00',3.19),('14598','2013-09-18','16:25:00',3.21),('14598','2013-09-18','16:30:00',2.99),('14598','2013-09-18','16:35:00',2.06),('14598','2013-09-18','16:40:00',2.96),('14598','2013-09-18','16:45:00',2.65),('14598','2013-09-18','16:50:00',2.91),('14598','2013-09-18','16:55:00',2.82),('14598','2013-09-18','17:00:00',2.69),('14598','2013-09-18','17:05:00',2.54),('14598','2013-09-18','17:10:00',2.45),('14598','2013-09-18','17:15:00',2.34),('14598','2013-09-18','17:20:00',2.29),('14598','2013-09-18','17:25:00',1.12),('14598','2013-09-18','17:30:00',1.32),('14598','2013-09-18','17:35:00',1.65),('14598','2013-09-18','17:45:00',1.33),('14598','2013-09-18','17:50:00',1.75),('14598','2013-09-18','18:00:00',1.29),('14598','2013-09-18','18:05:00',1.17),('14598','2013-09-18','18:10:00',1.14),('14598','2013-09-18','18:15:00',1.06),('14598','2013-09-17','09:05:00',1.04),('14598','2013-09-17','09:10:00',1.12),('14598','2013-09-17','09:15:00',1.15),('14598','2013-09-17','09:20:00',1.11),('14598','2013-09-17','09:30:00',1.08),('14598','2013-09-17','09:35:00',1.39),('14598','2013-09-17','09:40:00',1.73),('14598','2013-09-17','09:45:00',2.52),('14598','2013-09-17','09:50:00',2.64),('14598','2013-09-17','09:55:00',2.4),('14598','2013-09-17','10:00:00',1.44),('14598','2013-09-17','10:05:00',1.5),('14598','2013-09-17','10:10:00',1.46),('14598','2013-09-17','10:15:00',3.83),('14598','2013-09-17','10:20:00',3.14),('14598','2013-09-17','10:25:00',1.7),('14598','2013-09-17','10:30:00',2.9),('14598','2013-09-17','10:35:00',4.27),('14598','2013-09-17','10:40:00',3.81),('14598','2013-09-17','10:45:00',4.43),('14598','2013-09-17','10:50:00',2.37),('14598','2013-09-17','10:55:00',1.87),('14598','2013-09-17','11:00:00',1.83),('14598','2013-09-17','11:05:00',2.31),('14598','2013-09-17','11:10:00',2.79),('14598','2013-09-17','11:15:00',2.17),('14598','2013-09-17','11:20:00',1.91),('14598','2013-09-17','11:25:00',2.1),('14598','2013-09-17','11:30:00',1.84),('14598','2013-09-17','11:35:00',1.58),('14598','2013-09-17','11:40:00',4.41),('14598','2013-09-17','11:45:00',4.34),('14598','2013-09-17','11:50:00',2.55),('14598','2013-09-17','11:55:00',1.6),('14598','2013-09-17','12:00:00',2.54),('14598','2013-09-17','12:05:00',2.72),('14598','2013-09-17','12:10:00',3.21),('14598','2013-09-17','12:15:00',3.27),('14598','2013-09-17','12:20:00',3.09),('14598','2013-09-17','12:25:00',1.93),('14598','2013-09-17','12:30:00',1.87),('14598','2013-09-17','12:35:00',4.56),('14598','2013-09-17','12:40:00',3.76),('14598','2013-09-17','12:45:00',3.97),('14598','2013-09-17','12:50:00',4.39),('14598','2013-09-17','12:55:00',4.64),('14598','2013-09-17','13:00:00',3.46),('14598','2013-09-17','13:05:00',3.49),('14598','2013-09-17','13:10:00',2.1),('14598','2013-09-17','13:15:00',1.56),('14598','2013-09-17','13:20:00',1.63),('14598','2013-09-17','13:25:00',1.47),('14598','2013-09-17','13:30:00',1.55),('14598','2013-09-17','13:35:00',1.71),('14598','2013-09-17','13:40:00',1.73),('14598','2013-09-17','13:45:00',1.64),('14598','2013-09-17','13:50:00',2.34),('14598','2013-09-17','13:55:00',1.87),('14598','2013-09-17','14:00:00',1.26),('14598','2013-09-17','14:05:00',1.35),('14598','2013-09-17','14:10:00',1.25),('14598','2013-09-17','14:15:00',2.44),('14598','2013-09-17','14:20:00',2.83),('14598','2013-09-17','14:25:00',1.17),('14598','2013-09-17','14:30:00',1.04),('14598','2013-09-17','14:35:00',1.6),('14598','2013-09-17','14:40:00',3.63),('14598','2013-09-17','14:45:00',3.18),('14598','2013-09-17','14:50:00',5.01),('14598','2013-09-17','14:55:00',3.56),('14598','2013-09-17','15:00:00',3.54),('14598','2013-09-17','15:05:00',2.81),('14598','2013-09-17','15:20:00',1.36),('14598','2013-09-17','15:25:00',1.08),('14598','2013-09-17','15:30:00',1.23),('14598','2013-09-17','15:35:00',2.16),('14598','2013-09-17','15:40:00',2.31),('14598','2013-09-17','15:45:00',2.18),('14598','2013-09-17','15:50:00',2.66),('14598','2013-09-17','15:55:00',1.85),('14598','2013-09-17','16:00:00',1.57),('14598','2013-09-17','16:05:00',1.52),('14598','2013-09-17','16:10:00',1.5),('14598','2013-09-17','16:15:00',1.6),('14598','2013-09-17','16:20:00',1.88),('14598','2013-09-17','16:25:00',1.71),('14598','2013-09-17','16:30:00',1.68),('14598','2013-09-17','16:35:00',1.82),('14598','2013-09-17','16:40:00',2.18),('14598','2013-09-17','16:45:00',2.27),('14598','2013-09-17','16:50:00',2.5),('14598','2013-09-17','16:55:00',2.51),('14598','2013-09-17','17:00:00',2.24),('14598','2013-09-17','17:05:00',2.12),('14598','2013-09-17','17:10:00',2.44),('14598','2013-09-17','17:15:00',2.75),('14598','2013-09-17','17:20:00',2.22),('14598','2013-09-17','17:25:00',2.05),('14598','2013-09-17','17:30:00',2.01),('14598','2013-09-17','17:35:00',1.38),('14598','2013-09-16','08:55:00',1.4),('14598','2013-09-16','09:00:00',1.56),('14598','2013-09-16','09:05:00',1.66),('14598','2013-09-16','09:10:00',1.71),('14598','2013-09-16','09:15:00',1.68),('14598','2013-09-16','09:20:00',2.08),('14598','2013-09-16','09:25:00',1.32),('14598','2013-09-16','09:30:00',1.41),('14598','2013-09-16','09:35:00',2.04),('14598','2013-09-16','09:40:00',2.24),('14598','2013-09-16','09:45:00',2.33),('14598','2013-09-16','09:50:00',2.43),('14598','2013-09-16','09:55:00',2.51),('14598','2013-09-16','10:00:00',2.59),('14598','2013-09-16','10:05:00',2.67),('14598','2013-09-16','10:10:00',2.75),('14598','2013-09-16','10:15:00',2.87),('14598','2013-09-16','10:20:00',3),('14598','2013-09-16','10:25:00',2.38),('14598','2013-09-16','10:30:00',1.16),('14598','2013-09-16','10:35:00',2.85),('14598','2013-09-16','10:40:00',3.36),('14598','2013-09-16','10:45:00',3.22),('14598','2013-09-16','10:50:00',3.44),('14598','2013-09-16','10:55:00',3.49),('14598','2013-09-16','11:00:00',3.55),('14598','2013-09-16','11:05:00',3.6),('14598','2013-09-16','11:10:00',3.65),('14598','2013-09-16','11:15:00',3.73),('14598','2013-09-16','11:20:00',3.78),('14598','2013-09-16','11:25:00',3.83),('14598','2013-09-16','11:30:00',3.9),('14598','2013-09-16','11:35:00',3.92),('14598','2013-09-16','11:40:00',3.97),('14598','2013-09-16','11:45:00',4),('14598','2013-09-16','11:50:00',4.01),('14598','2013-09-16','11:55:00',4.08),('14598','2013-09-16','12:00:00',4.1),('14598','2013-09-16','12:05:00',4.17),('14598','2013-09-16','12:10:00',4.22),('14598','2013-09-16','12:15:00',4.23),('14598','2013-09-16','12:20:00',4.12),('14598','2013-09-16','12:25:00',4.38),('14598','2013-09-16','12:30:00',4.37),('14598','2013-09-16','12:35:00',4.41),('14598','2013-09-16','12:40:00',4.46),('14598','2013-09-16','12:45:00',4.45),('14598','2013-09-16','12:50:00',4.5),('14598','2013-09-16','12:55:00',4.51),('14598','2013-09-16','13:00:00',4.52),('14598','2013-09-16','13:05:00',4.55),('14598','2013-09-16','13:10:00',4.52),('14598','2013-09-16','13:15:00',4.58),('14598','2013-09-16','13:20:00',4.56),('14598','2013-09-16','13:25:00',4.55),('14598','2013-09-16','13:30:00',4.58),('14598','2013-09-16','13:35:00',4.56),('14598','2013-09-16','13:40:00',4.52),('14598','2013-09-16','13:45:00',4.57),('14598','2013-09-16','13:50:00',4.56),('14598','2013-09-16','13:55:00',4.53),('14598','2013-09-16','14:00:00',4.55),('14598','2013-09-16','14:05:00',4.53),('14598','2013-09-16','14:10:00',4.54),('14598','2013-09-16','14:15:00',4.52),('14598','2013-09-16','14:20:00',4.5),('14598','2013-09-16','14:25:00',4.48),('14598','2013-09-16','14:30:00',4.48),('14598','2013-09-16','14:35:00',4.45),('14598','2013-09-16','14:40:00',4.39),('14598','2013-09-16','14:45:00',4.36),('14598','2013-09-16','14:50:00',4.33),('14598','2013-09-16','14:55:00',4.29),('14598','2013-09-16','15:00:00',4.28),('14598','2013-09-16','15:05:00',4.23),('14598','2013-09-16','15:10:00',4.2),('14598','2013-09-16','15:15:00',4.17),('14598','2013-09-16','15:20:00',4.12),('14598','2013-09-16','15:25:00',4.04),('14598','2013-09-16','15:30:00',4.06),('14598','2013-09-16','15:35:00',4.02),('14598','2013-09-16','15:40:00',3.96),('14598','2013-09-16','15:45:00',3.9),('14598','2013-09-16','15:50:00',3.85),('14598','2013-09-16','15:55:00',3.77),('14598','2013-09-16','16:00:00',3.7),('14598','2013-09-16','16:05:00',3.63),('14598','2013-09-16','16:10:00',3.57),('14598','2013-09-16','16:15:00',3.52),('14598','2013-09-16','16:20:00',3.45),('14598','2013-09-16','16:25:00',3.36),('14598','2013-09-16','16:30:00',3.28),('14598','2013-09-16','16:35:00',3.22),('14598','2013-09-16','16:40:00',3.09),('14598','2013-09-16','16:45:00',3.02),('14598','2013-09-16','16:50:00',2.93),('14598','2013-09-16','16:55:00',2.85),('14598','2013-09-16','17:00:00',2.56),('14598','2013-09-16','17:05:00',2.68),('14598','2013-09-16','17:10:00',2.56),('14598','2013-09-16','17:15:00',2.46),('14598','2013-09-16','17:20:00',2.37),('14598','2013-09-16','17:25:00',2.26),('14598','2013-09-16','17:30:00',2.14),('14598','2013-09-16','17:35:00',2.03),('14598','2013-09-16','17:40:00',1.93),('14598','2013-09-16','17:45:00',1.81),('14598','2013-09-16','17:50:00',1.69),('14598','2013-09-16','17:55:00',1.57),('14598','2013-09-16','18:00:00',1.45),('14598','2013-09-16','18:05:00',1.35),('14598','2013-09-16','18:10:00',1.22),('14598','2013-09-16','18:15:00',1.09),('14598','2013-09-15','08:40:00',1.07),('14598','2013-09-15','08:45:00',1.05),('14598','2013-09-15','08:50:00',1.15),('14598','2013-09-15','08:55:00',1.2),('14598','2013-09-15','09:00:00',1.38),('14598','2013-09-15','09:05:00',1.56),('14598','2013-09-15','09:10:00',1.58),('14598','2013-09-15','09:15:00',1.73),('14598','2013-09-15','09:20:00',1.82),('14598','2013-09-15','09:25:00',1.98),('14598','2013-09-15','09:30:00',2.09),('14598','2013-09-15','09:35:00',2.15),('14598','2013-09-15','09:40:00',2.21),('14598','2013-09-15','09:45:00',2.38),('14598','2013-09-15','09:50:00',2.47),('14598','2013-09-15','09:55:00',2.53),('14598','2013-09-15','10:00:00',2.59),('14598','2013-09-15','10:05:00',2.75),('14598','2013-09-15','10:10:00',2.66),('14598','2013-09-15','10:15:00',2.75),('14598','2013-09-15','10:20:00',2.71),('14598','2013-09-15','10:25:00',2.75),('14598','2013-09-15','10:30:00',3.04),('14598','2013-09-15','10:35:00',3.01),('14598','2013-09-15','10:40:00',3.06),('14598','2013-09-15','10:45:00',3.25),('14598','2013-09-15','10:50:00',3.31),('14598','2013-09-15','10:55:00',3.46),('14598','2013-09-15','11:00:00',3.41),('14598','2013-09-15','11:05:00',3.49),('14598','2013-09-15','11:10:00',3.64),('14598','2013-09-15','11:15:00',3.67),('14598','2013-09-15','11:20:00',3.72),('14598','2013-09-15','11:25:00',3.78),('14598','2013-09-15','11:30:00',3.83),('14598','2013-09-15','11:35:00',3.91),('14598','2013-09-15','11:40:00',3.97),('14598','2013-09-15','11:45:00',4.01),('14598','2013-09-15','11:50:00',4.07),('14598','2013-09-15','11:55:00',4.08),('14598','2013-09-15','12:00:00',4.17),('14598','2013-09-15','12:05:00',4.27),('14598','2013-09-15','12:10:00',4.4),('14598','2013-09-15','12:15:00',4.54),('14598','2013-09-15','12:20:00',4.61),('14598','2013-09-15','12:25:00',4.58),('14598','2013-09-15','12:30:00',4.47),('14598','2013-09-15','12:35:00',3.07),('14598','2013-09-15','12:40:00',4.03),('14598','2013-09-15','12:45:00',3.4),('14598','2013-09-15','12:50:00',3.02),('14598','2013-09-15','12:55:00',3.2),('14598','2013-09-15','13:00:00',3.54),('14598','2013-09-15','13:05:00',3.4),('14598','2013-09-15','13:10:00',3.05),('14598','2013-09-15','13:15:00',2.99),('14598','2013-09-15','13:20:00',3.74),('14598','2013-09-15','13:25:00',4.99),('14598','2013-09-15','13:30:00',5.01),('14598','2013-09-15','13:35:00',3.31),('14598','2013-09-15','13:40:00',2.47),('14598','2013-09-15','13:45:00',1.86),('14598','2013-09-15','13:50:00',2.18),('14598','2013-09-15','13:55:00',2.09),('14598','2013-09-15','14:00:00',2.13),('14598','2013-09-15','14:05:00',1.79),('14598','2013-09-15','14:10:00',1.57),('14598','2013-09-15','14:15:00',1.44),('14598','2013-09-15','14:20:00',1.38),('14598','2013-09-15','14:25:00',1.37),('14598','2013-09-15','14:30:00',1.43),('14598','2013-09-15','14:35:00',1.4),('14598','2013-09-15','14:40:00',1.22),('14598','2013-09-15','14:45:00',1.14),('14598','2013-09-15','14:50:00',1.16),('14598','2013-09-15','14:55:00',1.31),('14598','2013-09-15','15:00:00',1.73),('14598','2013-09-15','15:05:00',1.95),('14598','2013-09-15','15:10:00',1.64),('14598','2013-09-15','15:15:00',1.35),('14598','2013-09-15','15:25:00',1.07),('14598','2013-09-15','15:30:00',1.25),('14598','2013-09-15','15:40:00',1.08),('14598','2013-09-15','15:45:00',1.04),('14598','2013-09-15','15:50:00',1.1),('14598','2013-09-15','15:55:00',1.18),('14598','2013-09-15','16:00:00',1.01),('14598','2013-09-15','16:05:00',1.2),('14598','2013-09-15','16:10:00',1.47),('14598','2013-09-15','16:15:00',1.23),('14598','2013-09-15','16:20:00',2.62),('14598','2013-09-15','16:25:00',1.89),('14598','2013-09-15','16:30:00',2.24),('14598','2013-09-15','16:35:00',1.74),('14598','2013-09-15','16:40:00',2.04),('14598','2013-09-15','16:45:00',1.38),('14598','2013-09-15','16:50:00',1.18),('14598','2013-09-15','16:55:00',1),('14598','2013-09-15','17:05:00',1.1),('14598','2013-09-15','17:50:00',1.52),('14598','2013-09-14','08:40:00',1.02),('14598','2013-09-14','08:45:00',1.12),('14598','2013-09-14','08:50:00',1.21),('14598','2013-09-14','08:55:00',1.31),('14598','2013-09-14','09:00:00',1.41),('14598','2013-09-14','09:05:00',1.53),('14598','2013-09-14','09:10:00',1.64),('14598','2013-09-14','09:15:00',1.77),('14598','2013-09-14','09:20:00',1.89),('14598','2013-09-14','09:25:00',2),('14598','2013-09-14','09:30:00',2.08),('14598','2013-09-14','09:35:00',2.16),('14598','2013-09-14','09:40:00',2.28),('14598','2013-09-14','09:45:00',2.38),('14598','2013-09-14','09:50:00',2.49),('14598','2013-09-14','09:55:00',2.51),('14598','2013-09-14','10:00:00',2.59),('14598','2013-09-14','10:05:00',1.8),('14598','2013-09-14','10:10:00',2.49),('14598','2013-09-14','10:15:00',2.58),('14598','2013-09-14','10:20:00',2.81),('14598','2013-09-14','10:25:00',3.07),('14598','2013-09-14','10:30:00',3.12),('14598','2013-09-14','10:35:00',3.18),('14598','2013-09-14','10:40:00',3.24),('14598','2013-09-14','10:45:00',3.32),('14598','2013-09-14','10:50:00',3.38),('14598','2013-09-14','10:55:00',3.42),('14598','2013-09-14','11:00:00',3.44),('14598','2013-09-14','11:05:00',3.49),('14598','2013-09-14','11:10:00',3.57),('14598','2013-09-14','11:15:00',3.54),('14598','2013-09-14','11:20:00',3.58),('14598','2013-09-14','11:25:00',3.68),('14598','2013-09-14','11:30:00',3.72),('14598','2013-09-14','11:35:00',3.77),('14598','2013-09-14','11:40:00',3.85),('14598','2013-09-14','11:45:00',3.93),('14598','2013-09-14','11:50:00',4.04),('14598','2013-09-14','11:55:00',4.08),('14598','2013-09-14','12:00:00',4.08),('14598','2013-09-14','12:05:00',4.14),('14598','2013-09-14','12:10:00',4.2),('14598','2013-09-14','12:15:00',4.23),('14598','2013-09-14','12:20:00',4.27),('14598','2013-09-14','12:25:00',4.3),('14598','2013-09-14','12:30:00',4.34),('14598','2013-09-14','12:35:00',4.38),('14598','2013-09-14','12:40:00',4.43),('14598','2013-09-14','12:45:00',4.45),('14598','2013-09-14','12:50:00',4.47),('14598','2013-09-14','12:55:00',4.48),('14598','2013-09-14','13:00:00',4.45),('14598','2013-09-14','13:05:00',4.57),('14598','2013-09-14','13:10:00',4.62),('14598','2013-09-14','13:15:00',4.61),('14598','2013-09-14','13:20:00',4.59),('14598','2013-09-14','13:25:00',4.57),('14598','2013-09-14','13:30:00',4.57),('14598','2013-09-14','13:35:00',4.6),('14598','2013-09-14','13:40:00',4.55),('14598','2013-09-14','13:45:00',4.59),('14598','2013-09-14','13:50:00',4.53),('14598','2013-09-14','13:55:00',4.52),('14598','2013-09-14','14:00:00',4.51),('14598','2013-09-14','14:05:00',4.51),('14598','2013-09-14','14:10:00',4.49),('14598','2013-09-14','14:15:00',4.47),('14598','2013-09-14','14:20:00',4.45),('14598','2013-09-14','14:25:00',4.41),('14598','2013-09-14','14:30:00',4.39),('14598','2013-09-14','14:35:00',4.38),('14598','2013-09-14','14:40:00',4.34),('14598','2013-09-14','14:45:00',4.26),('14598','2013-09-14','14:50:00',4.29),('14598','2013-09-14','14:55:00',4.25),('14598','2013-09-14','15:00:00',4.2),('14598','2013-09-14','15:05:00',4.18),('14598','2013-09-14','15:10:00',4.13),('14598','2013-09-14','15:15:00',4.08),('14598','2013-09-14','15:20:00',4.04),('14598','2013-09-14','15:25:00',3.99),('14598','2013-09-14','15:30:00',3.95),('14598','2013-09-14','15:35:00',3.89),('14598','2013-09-14','15:40:00',3.84),('14598','2013-09-14','15:45:00',3.78),('14598','2013-09-14','15:50:00',3.72),('14598','2013-09-14','15:55:00',3.67),('14598','2013-09-14','16:00:00',3.59),('14598','2013-09-14','16:05:00',3.56),('14598','2013-09-14','16:10:00',3.46),('14598','2013-09-14','16:15:00',3.42),('14598','2013-09-14','16:20:00',3.36),('14598','2013-09-14','16:25:00',3.28),('14598','2013-09-14','16:30:00',3.21),('14598','2013-09-14','16:35:00',3.13),('14598','2013-09-14','16:40:00',3.05),('14598','2013-09-14','16:45:00',2.97),('14598','2013-09-14','16:50:00',2.9),('14598','2013-09-14','16:55:00',2.8),('14598','2013-09-14','17:00:00',2.72),('14598','2013-09-14','17:05:00',2.61),('14598','2013-09-14','17:10:00',2.53),('14598','2013-09-14','17:15:00',2.47),('14598','2013-09-14','17:20:00',2.39),('14598','2013-09-14','17:25:00',2.28),('14598','2013-09-14','17:30:00',2.02),('14598','2013-09-14','17:35:00',1.63),('14598','2013-09-14','17:40:00',2.03),('14598','2013-09-14','17:45:00',1.85),('14598','2013-09-14','17:50:00',1.75),('14598','2013-09-14','17:55:00',1.57),('14598','2013-09-14','18:00:00',1.5),('14598','2013-09-14','18:05:00',1.43),('14598','2013-09-14','18:10:00',1.32),('14598','2013-09-14','18:15:00',1.21),('14598','2013-09-14','18:20:00',1.09),('14598','2013-09-13','09:10:00',1.07),('14598','2013-09-13','09:15:00',1.09),('14598','2013-09-13','09:20:00',1.16),('14598','2013-09-13','09:25:00',1.24),('14598','2013-09-13','09:30:00',1.34),('14598','2013-09-13','09:35:00',1.31),('14598','2013-09-13','09:40:00',1.58),('14598','2013-09-13','09:45:00',1.59),('14598','2013-09-13','09:50:00',1.47),('14598','2013-09-13','09:55:00',1.99),('14598','2013-09-13','10:00:00',2.67),('14598','2013-09-13','10:05:00',2.98),('14598','2013-09-13','10:10:00',2.98),('14598','2013-09-13','10:15:00',2.96),('14598','2013-09-13','10:20:00',3),('14598','2013-09-13','10:25:00',3.09),('14598','2013-09-13','10:30:00',3.16),('14598','2013-09-13','10:35:00',3.24),('14598','2013-09-13','10:40:00',3.31),('14598','2013-09-13','10:45:00',3.37),('14598','2013-09-13','10:50:00',3.44),('14598','2013-09-13','10:55:00',3.49),('14598','2013-09-13','11:00:00',3.55),('14598','2013-09-13','11:05:00',3.63),('14598','2013-09-13','11:10:00',3.67),('14598','2013-09-13','11:15:00',3.71),('14598','2013-09-13','11:20:00',3.76),('14598','2013-09-13','11:25:00',3.81),('14598','2013-09-13','11:30:00',3.84),('14598','2013-09-13','11:35:00',3.86),('14598','2013-09-13','11:40:00',3.94),('14598','2013-09-13','11:45:00',3.99),('14598','2013-09-13','11:50:00',4.05),('14598','2013-09-13','11:55:00',4.08),('14598','2013-09-13','12:00:00',4.08),('14598','2013-09-13','12:05:00',4.1),('14598','2013-09-13','12:10:00',4.15),('14598','2013-09-13','12:15:00',4.16),('14598','2013-09-13','12:20:00',4.18),('14598','2013-09-13','12:25:00',4.28),('14598','2013-09-13','12:30:00',4.33),('14598','2013-09-13','12:35:00',4.4),('14598','2013-09-13','12:40:00',4.37),('14598','2013-09-13','12:45:00',4.47),('14598','2013-09-13','12:50:00',4.49),('14598','2013-09-13','12:55:00',4.51),('14598','2013-09-13','13:00:00',4.54),('14598','2013-09-13','13:05:00',4.58),('14598','2013-09-13','13:10:00',4.58),('14598','2013-09-13','13:15:00',4.58),('14598','2013-09-13','13:20:00',4.6),('14598','2013-09-13','13:25:00',4.61),('14598','2013-09-13','13:30:00',4.61),('14598','2013-09-13','13:35:00',4.62),('14598','2013-09-13','13:40:00',4.61),('14598','2013-09-13','13:45:00',4.6),('14598','2013-09-13','13:50:00',4.62),('14598','2013-09-13','13:55:00',4.61),('14598','2013-09-13','14:00:00',4.63),('14598','2013-09-13','14:05:00',4.61),('14598','2013-09-13','14:10:00',4.59),('14598','2013-09-13','14:15:00',4.57),('14598','2013-09-13','14:20:00',4.57),('14598','2013-09-13','14:25:00',4.54),('14598','2013-09-13','14:30:00',4.52),('14598','2013-09-13','14:35:00',4.5),('14598','2013-09-13','14:40:00',4.46),('14598','2013-09-13','14:45:00',4.46),('14598','2013-09-13','14:50:00',4.41),('14598','2013-09-13','14:55:00',4.38),('14598','2013-09-13','15:00:00',4.35),('14598','2013-09-13','15:05:00',4.31),('14598','2013-09-13','15:10:00',4.25),('14598','2013-09-13','15:15:00',4.22),('14598','2013-09-13','15:20:00',4.16),('14598','2013-09-13','15:25:00',4.12),('14598','2013-09-13','15:30:00',4.07),('14598','2013-09-13','15:35:00',4.02),('14598','2013-09-13','15:40:00',3.97),('14598','2013-09-13','15:45:00',3.91),('14598','2013-09-13','15:50:00',3.86),('14598','2013-09-13','15:55:00',3.8),('14598','2013-09-13','16:00:00',3.72),('14598','2013-09-13','16:05:00',3.65),('14598','2013-09-13','16:10:00',3.59),('14598','2013-09-13','16:15:00',3.52),('14598','2013-09-13','16:20:00',3.46),('14598','2013-09-13','16:25:00',3.39),('14598','2013-09-13','16:30:00',3.3),('14598','2013-09-13','16:35:00',3.22),('14598','2013-09-13','16:40:00',3.13),('14598','2013-09-13','16:45:00',3.05),('14598','2013-09-13','16:50:00',2.97),('14598','2013-09-13','16:55:00',2.88),('14598','2013-09-13','17:00:00',2.79),('14598','2013-09-13','17:05:00',2.69),('14598','2013-09-13','17:10:00',2.59),('14598','2013-09-13','17:15:00',2.5),('14598','2013-09-13','17:20:00',2.4),('14598','2013-09-13','17:25:00',2.25),('14598','2013-09-13','17:30:00',2.19),('14598','2013-09-13','17:35:00',2.08),('14598','2013-09-13','17:40:00',1.97),('14598','2013-09-13','17:45:00',1.86),('14598','2013-09-13','17:50:00',1.74),('14598','2013-09-13','17:55:00',1.63),('14598','2013-09-13','18:00:00',1.52),('14598','2013-09-13','18:05:00',1.41),('14598','2013-09-13','18:10:00',1.29),('14598','2013-09-13','18:15:00',1.18),('14598','2013-09-13','18:20:00',1.06),('14598','2013-09-12','08:35:00',1.26),('14598','2013-09-12','08:40:00',1.21),('14598','2013-09-12','08:45:00',1.12),('14598','2013-09-12','08:50:00',1.22),('14598','2013-09-12','08:55:00',1.49),('14598','2013-09-12','09:00:00',1.5),('14598','2013-09-12','09:05:00',1.4),('14598','2013-09-12','09:10:00',1.33),('14598','2013-09-12','09:15:00',1.56),('14598','2013-09-12','09:20:00',2.17),('14598','2013-09-12','09:25:00',1.49),('14598','2013-09-12','09:30:00',2.01),('14598','2013-09-12','09:35:00',1.85),('14598','2013-09-12','09:40:00',1.57),('14598','2013-09-12','09:45:00',1.91),('14598','2013-09-12','09:50:00',2.27),('14598','2013-09-12','09:55:00',2.51),('14598','2013-09-12','10:00:00',2.18),('14598','2013-09-12','10:05:00',1.44),('14598','2013-09-12','10:15:00',1.65),('14598','2013-09-12','10:20:00',2.96),('14598','2013-09-12','10:25:00',3.29),('14598','2013-09-12','10:30:00',3.47),('14598','2013-09-12','10:35:00',3.89),('14598','2013-09-12','10:40:00',4.3),('14598','2013-09-12','10:45:00',3.54),('14598','2013-09-12','10:50:00',1.63),('14598','2013-09-12','11:15:00',1.41),('14598','2013-09-12','11:20:00',1.51),('14598','2013-09-12','11:25:00',3.54),('14598','2013-09-12','11:30:00',4.21),('14598','2013-09-12','11:35:00',4.11),('14598','2013-09-12','11:40:00',4.04),('14598','2013-09-12','11:45:00',4.24),('14598','2013-09-12','11:50:00',4.31),('14598','2013-09-12','11:55:00',4.37),('14598','2013-09-12','12:00:00',4.33),('14598','2013-09-12','12:05:00',4.51),('14598','2013-09-12','12:10:00',4.24),('14598','2013-09-12','12:15:00',4.47),('14598','2013-09-12','12:20:00',4.27),('14598','2013-09-12','12:25:00',3.98),('14598','2013-09-12','12:30:00',3.71),('14598','2013-09-12','12:35:00',3.9),('14598','2013-09-12','12:40:00',4.54),('14598','2013-09-12','12:45:00',4.58),('14598','2013-09-12','12:50:00',4.33),('14598','2013-09-12','12:55:00',4.57),('14598','2013-09-12','13:00:00',5.27),('14598','2013-09-12','13:05:00',3.43),('14598','2013-09-12','13:10:00',4.85),('14598','2013-09-12','13:15:00',4.69),('14598','2013-09-12','13:20:00',4.63),('14598','2013-09-12','13:25:00',4.59),('14598','2013-09-12','13:30:00',4.58),('14598','2013-09-12','13:35:00',3.71),('14598','2013-09-12','13:40:00',4.65),('14598','2013-09-12','13:45:00',3.65),('14598','2013-09-12','13:50:00',3.12),('14598','2013-09-12','13:55:00',4.53),('14598','2013-09-12','14:00:00',4.98),('14598','2013-09-12','14:05:00',4.72),('14598','2013-09-12','14:10:00',4.56),('14598','2013-09-12','14:15:00',4.26),('14598','2013-09-12','14:20:00',3.36),('14598','2013-09-12','14:25:00',4.91),('14598','2013-09-12','14:30:00',4.59),('14598','2013-09-12','14:35:00',4.72),('14598','2013-09-12','14:40:00',4.55),('14598','2013-09-12','14:45:00',4.51),('14598','2013-09-12','14:50:00',4.5),('14598','2013-09-12','14:55:00',4.48),('14598','2013-09-12','15:00:00',4.37),('14598','2013-09-12','15:05:00',4.42),('14598','2013-09-12','15:10:00',4.38),('14598','2013-09-12','15:15:00',3.59),('14598','2013-09-12','15:20:00',3.56),('14598','2013-09-12','15:25:00',4.16),('14598','2013-09-12','15:30:00',3.87),('14598','2013-09-12','15:35:00',3.87),('14598','2013-09-12','15:40:00',2.4),('14598','2013-09-12','15:45:00',3.24),('14598','2013-09-12','15:50:00',4.15),('14598','2013-09-12','15:55:00',4.11),('14598','2013-09-12','16:00:00',2.88),('14598','2013-09-12','16:05:00',3.83),('14598','2013-09-12','16:10:00',2.35),('14598','2013-09-12','16:15:00',3.91),('14598','2013-09-12','16:20:00',3.82),('14598','2013-09-12','16:25:00',3.67),('14598','2013-09-12','16:30:00',3.69),('14598','2013-09-12','16:35:00',3.05),('14598','2013-09-12','16:40:00',2.53),('14598','2013-09-12','16:45:00',1.15),('14598','2013-09-12','16:50:00',2),('14598','2013-09-12','16:55:00',3.34),('14598','2013-09-12','17:00:00',3.09),('14598','2013-09-12','17:05:00',2.4),('14598','2013-09-12','17:10:00',2.99),('14598','2013-09-12','17:15:00',2.27),('14598','2013-09-12','17:20:00',2.56),('14598','2013-09-12','17:25:00',2.3),('14598','2013-09-12','17:45:00',1.31),('14598','2013-09-12','17:50:00',1.29),('14598','2013-09-12','17:55:00',1.19),('14598','2013-09-12','18:00:00',1.72),('14598','2013-09-12','18:05:00',1.58),('14598','2013-09-12','18:10:00',1.42),('14598','2013-09-12','18:15:00',1.1),('14598','2013-09-12','18:25:00',1.07),('14598','2013-09-11','08:45:00',1.08),('14598','2013-09-11','09:35:00',1.13),('14598','2013-09-11','09:40:00',1.34),('14598','2013-09-11','09:45:00',2.25),('14598','2013-09-11','09:50:00',2.51),('14598','2013-09-11','09:55:00',2.58),('14598','2013-09-11','10:00:00',2.64),('14598','2013-09-11','10:05:00',2.71),('14598','2013-09-11','10:10:00',2.76),('14598','2013-09-11','10:15:00',2.86),('14598','2013-09-11','10:20:00',2.94),('14598','2013-09-11','10:25:00',3),('14598','2013-09-11','10:30:00',2.76),('14598','2013-09-11','10:35:00',3.13),('14598','2013-09-11','10:40:00',3.24),('14598','2013-09-11','10:45:00',3.29),('14598','2013-09-11','10:50:00',3.4),('14598','2013-09-11','10:55:00',3.47),('14598','2013-09-11','11:00:00',3.55),('14598','2013-09-11','11:05:00',3.64),('14598','2013-09-11','11:10:00',3.65),('14598','2013-09-11','11:15:00',3.76),('14598','2013-09-11','11:20:00',3.81),('14598','2013-09-11','11:25:00',3.86),('14598','2013-09-11','11:30:00',3.9),('14598','2013-09-11','11:35:00',3.96),('14598','2013-09-11','11:40:00',3.99),('14598','2013-09-11','11:45:00',4.04),('14598','2013-09-11','11:50:00',4.08),('14598','2013-09-11','11:55:00',4.1),('14598','2013-09-11','12:00:00',4.12),('14598','2013-09-11','12:05:00',4.18),('14598','2013-09-11','12:10:00',4.19),('14598','2013-09-11','12:15:00',4.25),('14598','2013-09-11','12:20:00',4.27),('14598','2013-09-11','12:25:00',4.32),('14598','2013-09-11','12:30:00',4.36),('14598','2013-09-11','12:35:00',4.44),('14598','2013-09-11','12:40:00',4.44),('14598','2013-09-11','12:45:00',4.48),('14598','2013-09-11','12:50:00',4.58),('14598','2013-09-11','12:55:00',2.63),('14598','2013-09-11','13:00:00',4.4),('14598','2013-09-11','13:05:00',3.44),('14598','2013-09-11','13:10:00',4.33),('14598','2013-09-11','13:15:00',4.58),('14598','2013-09-11','13:20:00',4.62),('14598','2013-09-11','13:25:00',4.56),('14598','2013-09-11','13:30:00',4.55),('14598','2013-09-11','13:35:00',4.57),('14598','2013-09-11','13:40:00',4.61),('14598','2013-09-11','13:45:00',4.61),('14598','2013-09-11','13:50:00',4.69),('14598','2013-09-11','13:55:00',4.77),('14598','2013-09-11','14:00:00',4.79),('14598','2013-09-11','14:05:00',4.98),('14598','2013-09-11','14:10:00',4.92),('14598','2013-09-11','14:15:00',1.83),('14598','2013-09-11','14:20:00',1.9),('14598','2013-09-11','14:25:00',2.41),('14598','2013-09-11','14:30:00',3.06),('14598','2013-09-11','14:35:00',2.93),('14598','2013-09-11','14:40:00',1.86),('14598','2013-09-11','14:45:00',2.28),('14598','2013-09-11','14:50:00',3.31),('14598','2013-09-11','14:55:00',1.92),('14598','2013-09-11','15:00:00',2.54),('14598','2013-09-11','15:05:00',4.08),('14598','2013-09-11','15:10:00',4.43),('14598','2013-09-11','15:15:00',4.26),('14598','2013-09-11','15:20:00',4.27),('14598','2013-09-11','15:25:00',4.21),('14598','2013-09-11','15:30:00',3.94),('14598','2013-09-11','15:35:00',1.68),('14598','2013-09-11','15:40:00',1.24),('14598','2013-09-11','15:45:00',1.54),('14598','2013-09-11','15:50:00',4.59),('14598','2013-09-11','15:55:00',3.95),('14598','2013-09-11','16:00:00',3.81),('14598','2013-09-11','16:05:00',3.75),('14598','2013-09-11','16:10:00',3.68),('14598','2013-09-11','16:15:00',3.58),('14598','2013-09-11','16:20:00',3.53),('14598','2013-09-11','16:25:00',3.47),('14598','2013-09-11','16:30:00',3.37),('14598','2013-09-11','16:35:00',2.58),('14598','2013-09-11','16:40:00',2.04),('14598','2013-09-11','16:45:00',3.15),('14598','2013-09-11','16:50:00',3.02),('14598','2013-09-11','16:55:00',2.93),('14598','2013-09-11','17:00:00',2.84),('14598','2013-09-11','17:05:00',2.75),('14598','2013-09-11','17:10:00',2.66),('14598','2013-09-11','17:15:00',2.33),('14598','2013-09-11','17:20:00',2.52),('14598','2013-09-11','17:25:00',2.37),('14598','2013-09-11','17:30:00',2.26),('14598','2013-09-11','17:35:00',2.16),('14598','2013-09-11','17:40:00',2.04),('14598','2013-09-11','17:45:00',1.96),('14598','2013-09-11','17:50:00',1.79),('14598','2013-09-11','17:55:00',1.7),('14598','2013-09-11','18:00:00',1.57),('14598','2013-09-11','18:05:00',1.15),('14598','2013-09-10','08:55:00',1.37),('14598','2013-09-10','09:00:00',2.15),('14598','2013-09-10','09:05:00',1.86),('14598','2013-09-10','09:10:00',1.64),('14598','2013-09-10','09:15:00',1.91),('14598','2013-09-10','09:20:00',1.76),('14598','2013-09-10','09:25:00',1.21),('14598','2013-09-10','10:20:00',1.04),('14598','2013-09-10','10:25:00',1.14),('14598','2013-09-10','10:30:00',1.29),('14598','2013-09-10','10:35:00',1.23),('14598','2013-09-10','10:40:00',1.33),('14598','2013-09-10','10:45:00',1.54),('14598','2013-09-10','10:50:00',1.75),('14598','2013-09-10','10:55:00',1.38),('14598','2013-09-10','11:00:00',1.13),('14598','2013-09-10','11:10:00',1.38),('14598','2013-09-10','11:15:00',1.52),('14598','2013-09-10','11:20:00',1.03),('14598','2013-09-10','11:30:00',1.26),('14598','2013-09-10','11:35:00',1.83),('14598','2013-09-10','11:40:00',1.39),('14598','2013-09-10','11:45:00',2.06),('14598','2013-09-10','11:50:00',2.39),('14598','2013-09-10','11:55:00',2.06),('14598','2013-09-10','12:00:00',1.48),('14598','2013-09-10','12:05:00',2.26),('14598','2013-09-10','12:10:00',2.34),('14598','2013-09-10','12:15:00',2.6),('14598','2013-09-10','12:20:00',2.06),('14598','2013-09-10','12:25:00',1.43),('14598','2013-09-10','13:10:00',1.09),('14598','2013-09-10','13:15:00',1.26),('14598','2013-09-10','13:20:00',1.14),('14598','2013-09-10','13:25:00',1.46),('14598','2013-09-10','13:30:00',1.77),('14598','2013-09-10','13:35:00',1.95),('14598','2013-09-10','13:40:00',2.35),('14598','2013-09-10','13:45:00',2.66),('14598','2013-09-10','13:50:00',1.82),('14598','2013-09-10','13:55:00',1.68),('14598','2013-09-10','14:00:00',1.81),('14598','2013-09-10','14:05:00',1.88),('14598','2013-09-10','14:10:00',1.93),('14598','2013-09-10','14:15:00',2.07),('14598','2013-09-10','14:20:00',2.41),('14598','2013-09-10','14:25:00',2.46),('14598','2013-09-10','14:30:00',2.25),('14598','2013-09-10','14:35:00',2.6),('14598','2013-09-10','14:40:00',2.4),('14598','2013-09-10','14:45:00',2.39),('14598','2013-09-10','14:50:00',2.66),('14598','2013-09-10','14:55:00',2.68),('14598','2013-09-10','15:00:00',2.66),('14598','2013-09-10','15:05:00',2.52),('14598','2013-09-10','15:10:00',2.7),('14598','2013-09-10','15:15:00',2.26),('14598','2013-09-10','15:20:00',1.64),('14598','2013-09-10','15:25:00',1.62),('14598','2013-09-10','15:30:00',1.49),('14598','2013-09-10','15:35:00',1.64),('14598','2013-09-10','15:40:00',1.56),('14598','2013-09-10','15:45:00',1.42),('14598','2013-09-10','15:50:00',1.16),('14598','2013-09-10','15:55:00',1.07),('14598','2013-09-10','16:15:00',1.21),('14598','2013-09-10','16:20:00',1.33),('14598','2013-09-10','16:25:00',1.18),('14598','2013-09-10','16:30:00',1.17),('14598','2013-09-10','16:35:00',1.93),('14598','2013-09-10','16:40:00',1.02),('14598','2013-09-09','09:25:00',1.14),('14598','2013-09-09','09:30:00',1.37),('14598','2013-09-09','09:35:00',1.29),('14598','2013-09-09','09:45:00',1.17),('14598','2013-09-09','10:00:00',1.11),('14598','2013-09-09','10:05:00',1.27),('14598','2013-09-09','10:10:00',1.32),('14598','2013-09-09','10:15:00',1.59),('14598','2013-09-09','10:20:00',1.74),('14598','2013-09-09','10:25:00',1.74),('14598','2013-09-09','10:30:00',2.08),('14598','2013-09-09','10:35:00',2.6),('14598','2013-09-09','10:40:00',2.62),('14598','2013-09-09','10:45:00',2.3),('14598','2013-09-09','10:50:00',1.88),('14598','2013-09-09','10:55:00',1.85),('14598','2013-09-09','11:00:00',2.03),('14598','2013-09-09','11:05:00',2.4),('14598','2013-09-09','11:10:00',2.44),('14598','2013-09-09','11:15:00',2.49),('14598','2013-09-09','11:20:00',3.03),('14598','2013-09-09','11:25:00',3.18),('14598','2013-09-09','11:30:00',2.9),('14598','2013-09-09','11:35:00',3.48),('14598','2013-09-09','11:40:00',3.66),('14598','2013-09-09','11:45:00',3.76),('14598','2013-09-09','11:50:00',3.89),('14598','2013-09-09','11:55:00',3.49),('14598','2013-09-09','12:00:00',3.36),('14598','2013-09-09','12:05:00',2.87),('14598','2013-09-09','12:10:00',3),('14598','2013-09-09','12:15:00',3.18),('14598','2013-09-09','12:20:00',2.89),('14598','2013-09-09','12:25:00',2.69),('14598','2013-09-09','12:30:00',2.59),('14598','2013-09-09','12:35:00',2.66),('14598','2013-09-09','12:40:00',2.65),('14598','2013-09-09','12:45:00',2.44),('14598','2013-09-09','12:50:00',3.14),('14598','2013-09-09','12:55:00',3.9),('14598','2013-09-09','13:00:00',4.21),('14598','2013-09-09','13:05:00',3.6),('14598','2013-09-09','13:10:00',3.33),('14598','2013-09-09','13:15:00',4.07),('14598','2013-09-09','13:20:00',4.28),('14598','2013-09-09','13:25:00',4.49),('14598','2013-09-09','13:30:00',4),('14598','2013-09-09','13:35:00',4.54),('14598','2013-09-09','13:40:00',4.58),('14598','2013-09-09','13:45:00',4.3),('14598','2013-09-09','13:50:00',4.26),('14598','2013-09-09','13:55:00',4.56),('14598','2013-09-09','14:00:00',4.43),('14598','2013-09-09','14:05:00',4.68),('14598','2013-09-09','14:10:00',4.66),('14598','2013-09-09','14:15:00',3.49),('14598','2013-09-09','14:20:00',3.47),('14598','2013-09-09','14:25:00',3.82),('14598','2013-09-09','14:30:00',3.96),('14598','2013-09-09','14:35:00',4.25),('14598','2013-09-09','14:40:00',3.56),('14598','2013-09-09','14:45:00',3.02),('14598','2013-09-09','14:50:00',2.95),('14598','2013-09-09','14:55:00',3.58),('14598','2013-09-09','15:00:00',4.11),('14598','2013-09-09','15:05:00',4.11),('14598','2013-09-09','15:10:00',3.88),('14598','2013-09-09','15:15:00',3.1),('14598','2013-09-09','15:20:00',4.13),('14598','2013-09-09','15:25:00',3.01),('14598','2013-09-09','15:30:00',2.53),('14598','2013-09-09','15:35:00',2.14),('14598','2013-09-09','15:40:00',3.1),('14598','2013-09-09','15:45:00',1.41),('14598','2013-09-09','15:50:00',1.61),('14598','2013-09-09','15:55:00',1.57),('14598','2013-09-09','16:00:00',1.79),('14598','2013-09-09','16:05:00',1.87),('14598','2013-09-09','16:10:00',1.83),('14598','2013-09-09','16:15:00',1.35),('14598','2013-09-09','16:20:00',1.48),('14598','2013-09-09','16:25:00',1.02),('14598','2013-09-09','16:40:00',1.05),('14598','2013-09-09','18:00:00',1.56),('14598','2013-09-09','18:05:00',1.59),('14598','2013-09-09','18:10:00',1.44),('14598','2013-09-09','18:15:00',1.23),('14598','2013-09-09','18:20:00',1.08),('14598','2014-04-12','08:10:00',1.05),('14598','2014-04-12','08:15:00',1.25),('14598','2014-04-12','08:20:00',1.49),('14598','2014-04-12','08:25:00',1.33),('14598','2014-04-12','08:30:00',1.49),('14598','2014-04-12','08:35:00',1.59),('14598','2014-04-12','08:40:00',1.89),('14598','2014-04-12','08:45:00',2.08),('14598','2014-04-12','08:50:00',1.62),('14598','2014-04-12','08:55:00',1.73),('14598','2014-04-12','09:00:00',1.9),('14598','2014-04-12','09:05:00',1.6),('14598','2014-04-12','09:10:00',1.37),('14598','2014-04-12','09:35:00',1.33),('14598','2014-04-12','09:40:00',1.59),('14598','2014-04-12','09:45:00',1.74),('14598','2014-04-12','09:50:00',1.7),('14598','2014-04-12','09:55:00',1.68),('14598','2014-04-12','10:00:00',1.75),('14598','2014-04-12','10:05:00',1.74),('14598','2014-04-12','10:10:00',1.86),('14598','2014-04-12','10:15:00',2.09),('14598','2014-04-12','10:20:00',2.67),('14598','2014-04-12','10:25:00',2.68),('14598','2014-04-12','10:30:00',2.44),('14598','2014-04-12','10:35:00',2.77),('14598','2014-04-12','10:40:00',2.62),('14598','2014-04-12','10:45:00',3.3),('14598','2014-04-12','10:50:00',2.71),('14598','2014-04-12','10:55:00',2.43),('14598','2014-04-12','11:00:00',2.66),('14598','2014-04-12','11:05:00',2.81),('14598','2014-04-12','11:10:00',3.24),('14598','2014-04-12','11:15:00',3.16),('14598','2014-04-12','11:20:00',3),('14598','2014-04-12','11:25:00',3.39),('14598','2014-04-12','11:30:00',3.86),('14598','2014-04-12','11:35:00',3),('14598','2014-04-12','11:40:00',3.45),('14598','2014-04-12','11:45:00',3.51),('14598','2014-04-12','11:50:00',3.3),('14598','2014-04-12','11:55:00',3.04),('14598','2014-04-12','12:00:00',3.3),('14598','2014-04-12','12:05:00',3.16),('14598','2014-04-12','12:10:00',3.88),('14598','2014-04-12','12:15:00',3.96),('14598','2014-04-12','12:20:00',3.71),('14598','2014-04-12','12:25:00',4.45),('14598','2014-04-12','12:30:00',4.82),('14598','2014-04-12','12:35:00',4.94),('14598','2014-04-12','12:40:00',4.75),('14598','2014-04-12','12:45:00',4.86),('14598','2014-04-12','12:50:00',4.86),('14598','2014-04-12','12:55:00',4.75),('14598','2014-04-12','13:00:00',4.91),('14598','2014-04-12','13:05:00',4.93),('14598','2014-04-12','13:10:00',4.98),('14598','2014-04-12','13:15:00',5.01),('14598','2014-04-12','13:20:00',4.85),('14598','2014-04-12','13:25:00',4.78),('14598','2014-04-12','13:30:00',3.96),('14598','2014-04-12','13:35:00',4.1),('14598','2014-04-12','13:40:00',4.91),('14598','2014-04-12','13:45:00',4.83),('14598','2014-04-12','13:50:00',4.6),('14598','2014-04-12','13:55:00',4.5),('14598','2014-04-12','14:00:00',4.15),('14598','2014-04-12','14:05:00',3.41),('14598','2014-04-12','14:10:00',3.98),('14598','2014-04-12','14:15:00',3.9),('14598','2014-04-12','14:20:00',4.05),('14598','2014-04-12','14:25:00',4.16),('14598','2014-04-12','14:30:00',4.24),('14598','2014-04-12','14:35:00',3.78),('14598','2014-04-12','14:40:00',3.6),('14598','2014-04-12','14:45:00',4.1),('14598','2014-04-12','14:50:00',4.25),('14598','2014-04-12','14:55:00',4.35),('14598','2014-04-12','15:00:00',4.26),('14598','2014-04-12','15:05:00',3.98),('14598','2014-04-12','15:10:00',4.45),('14598','2014-04-12','15:15:00',4.69),('14598','2014-04-12','15:20:00',4.65),('14598','2014-04-12','15:25:00',4.33),('14598','2014-04-12','15:30:00',4.11),('14598','2014-04-12','15:35:00',4.45),('14598','2014-04-12','15:40:00',4.51),('14598','2014-04-12','15:45:00',4.45),('14598','2014-04-12','15:50:00',4.36),('14598','2014-04-12','15:55:00',4.2),('14598','2014-04-12','16:00:00',4.25),('14598','2014-04-12','16:05:00',4.36),('14598','2014-04-12','16:10:00',3.56),('14598','2014-04-12','16:15:00',4.19),('14598','2014-04-12','16:20:00',3.97),('14598','2014-04-12','16:25:00',3.75),('14598','2014-04-12','16:30:00',3.55),('14598','2014-04-12','16:35:00',3.36),('14598','2014-04-12','16:40:00',3.18),('14598','2014-04-12','16:45:00',3.35),('14598','2014-04-12','16:50:00',3.12),('14598','2014-04-12','16:55:00',3.35),('14598','2014-04-12','17:00:00',3.2),('14598','2014-04-12','17:05:00',3.16),('14598','2014-04-12','17:10:00',3.08),('14598','2014-04-12','17:15:00',2.93),('14598','2014-04-12','17:20:00',2.8),('14598','2014-04-12','17:25:00',2.77),('14598','2014-04-12','17:30:00',2.7),('14598','2014-04-12','17:35:00',2.58),('14598','2014-04-12','17:40:00',2.49),('14598','2014-04-12','17:45:00',2.43),('14598','2014-04-12','17:50:00',2.3),('14598','2014-04-12','17:55:00',2.16),('14598','2014-04-12','18:00:00',2.19),('14598','2014-04-12','18:05:00',2.21),('14598','2014-04-12','18:10:00',1.56),('14598','2014-04-12','18:15:00',1.53),('14598','2014-04-12','18:20:00',1.26),('14598','2014-04-12','18:25:00',1.37),('14598','2013-09-08','08:40:00',1.03),('14598','2013-09-08','08:45:00',1.14),('14598','2013-09-08','08:50:00',1.21),('14598','2013-09-08','08:55:00',1.33),('14598','2013-09-08','09:00:00',1.4),('14598','2013-09-08','09:05:00',1.48),('14598','2013-09-08','09:10:00',1.57),('14598','2013-09-08','09:15:00',1.7),('14598','2013-09-08','09:20:00',1.81),('14598','2013-09-08','09:25:00',1.9),('14598','2013-09-08','09:30:00',2),('14598','2013-09-08','09:35:00',2.09),('14598','2013-09-08','09:40:00',2.17),('14598','2013-09-08','09:45:00',2.25),('14598','2013-09-08','09:50:00',2.31),('14598','2013-09-08','09:55:00',2.38),('14598','2013-09-08','10:00:00',2.49),('14598','2013-09-08','10:05:00',2.58),('14598','2013-09-08','10:10:00',2.65),('14598','2013-09-08','10:15:00',2.72),('14598','2013-09-08','10:20:00',2.78),('14598','2013-09-08','10:25:00',2.86),('14598','2013-09-08','10:30:00',2.87),('14598','2013-09-08','10:35:00',2.98),('14598','2013-09-08','10:40:00',3.1),('14598','2013-09-08','10:45:00',3.05),('14598','2013-09-08','10:50:00',3.04),('14598','2013-09-08','10:55:00',3.09),('14598','2013-09-08','11:00:00',2.87),('14598','2013-09-08','11:05:00',2.85),('14598','2013-09-08','11:10:00',3.42),('14598','2013-09-08','11:15:00',3.48),('14598','2013-09-08','11:20:00',3.47),('14598','2013-09-08','11:25:00',3.58),('14598','2013-09-08','11:30:00',3.66),('14598','2013-09-08','11:35:00',3.74),('14598','2013-09-08','11:40:00',3.68),('14598','2013-09-08','11:45:00',3.68),('14598','2013-09-08','11:50:00',3.88),('14598','2013-09-08','11:55:00',3.96),('14598','2013-09-08','12:00:00',3.98),('14598','2013-09-08','12:05:00',4.07),('14598','2013-09-08','12:10:00',3.91),('14598','2013-09-08','12:15:00',4.11),('14598','2013-09-08','12:20:00',4.14),('14598','2013-09-08','12:25:00',4.18),('14598','2013-09-08','12:30:00',4.24),('14598','2013-09-08','12:35:00',4.23),('14598','2013-09-08','12:40:00',4.15),('14598','2013-09-08','12:45:00',4.12),('14598','2013-09-08','12:50:00',4.27),('14598','2013-09-08','12:55:00',4.32),('14598','2013-09-08','13:00:00',4.09),('14598','2013-09-08','13:05:00',3.98),('14598','2013-09-08','13:10:00',3.88),('14598','2013-09-08','13:15:00',4.09),('14598','2013-09-08','13:20:00',3.02),('14598','2013-09-08','13:25:00',2.37),('14598','2013-09-08','13:30:00',3.61),('14598','2013-09-08','13:35:00',4.07),('14598','2013-09-08','13:40:00',4.71),('14598','2013-09-08','13:45:00',4.59),('14598','2013-09-08','13:50:00',4.24),('14598','2013-09-08','13:55:00',4.54),('14598','2013-09-08','14:00:00',4.94),('14598','2013-09-08','14:05:00',4.82),('14598','2013-09-08','14:10:00',4.36),('14598','2013-09-08','14:15:00',4.52),('14598','2013-09-08','14:20:00',4.51),('14598','2013-09-08','14:25:00',4.43),('14598','2013-09-08','14:30:00',4.2),('14598','2013-09-08','14:35:00',4.41),('14598','2013-09-08','14:40:00',4.49),('14598','2013-09-08','14:45:00',4.39),('14598','2013-09-08','14:50:00',2.38),('14598','2013-09-08','14:55:00',2.89),('14598','2013-09-08','15:00:00',4.12),('14598','2013-09-08','15:05:00',4.36),('14598','2013-09-08','15:10:00',4.3),('14598','2013-09-08','15:15:00',4.21),('14598','2013-09-08','15:20:00',3.85),('14598','2013-09-08','15:25:00',4.07),('14598','2013-09-08','15:30:00',4.04),('14598','2013-09-08','15:35:00',3.94),('14598','2013-09-08','15:40:00',3.78),('14598','2013-09-08','15:45:00',3.76),('14598','2013-09-08','15:50:00',3.44),('14598','2013-09-08','15:55:00',3.75),('14598','2013-09-08','16:00:00',3.5),('14598','2013-09-08','16:05:00',3.42),('14598','2013-09-08','16:10:00',3.21),('14598','2013-09-08','16:15:00',3.06),('14598','2013-09-08','16:20:00',2.61),('14598','2013-09-08','16:25:00',3.22),('14598','2013-09-08','16:30:00',3.25),('14598','2013-09-08','16:35:00',2.39),('14598','2013-09-08','16:40:00',1.51),('14598','2013-09-08','16:45:00',2.91),('14598','2013-09-08','16:50:00',3.16),('14598','2013-09-08','16:55:00',2.9),('14598','2013-09-08','17:00:00',2.72),('14598','2013-09-08','17:05:00',2.16),('14598','2013-09-08','17:10:00',2.51),('14598','2013-09-08','17:15:00',1.65),('14598','2013-09-08','17:20:00',1.58),('14598','2013-09-08','17:25:00',2.22),('14598','2013-09-08','17:30:00',2.16),('14598','2013-09-08','17:35:00',2.02),('14598','2013-09-08','17:40:00',1.9),('14598','2013-09-08','17:45:00',1.77),('14598','2013-09-08','17:50:00',1.56),('14598','2013-09-08','17:55:00',1.43),('14598','2013-09-08','18:00:00',1.31),('14598','2013-09-08','18:05:00',1.2),('14598','2013-09-08','18:10:00',1.16),('14598','2013-09-08','18:15:00',1.11),('14598','2013-09-07','08:40:00',1.05),('14598','2013-09-07','08:45:00',1.14),('14598','2013-09-07','08:50:00',1.23),('14598','2013-09-07','08:55:00',1.35),('14598','2013-09-07','09:00:00',1.44),('14598','2013-09-07','09:05:00',1.55),('14598','2013-09-07','09:10:00',1.66),('14598','2013-09-07','09:15:00',1.77),('14598','2013-09-07','09:20:00',1.87),('14598','2013-09-07','09:25:00',1.97),('14598','2013-09-07','09:30:00',2.06),('14598','2013-09-07','09:35:00',2.14),('14598','2013-09-07','09:40:00',2.22),('14598','2013-09-07','09:45:00',2.32),('14598','2013-09-07','09:50:00',2.39),('14598','2013-09-07','09:55:00',2.47),('14598','2013-09-07','10:00:00',2.56),('14598','2013-09-07','10:05:00',2.58),('14598','2013-09-07','10:10:00',2.7),('14598','2013-09-07','10:15:00',2.78),('14598','2013-09-07','10:20:00',2.87),('14598','2013-09-07','10:25:00',2.93),('14598','2013-09-07','10:30:00',2.99),('14598','2013-09-07','10:35:00',3.07),('14598','2013-09-07','10:40:00',3.13),('14598','2013-09-07','10:45:00',3.18),('14598','2013-09-07','10:50:00',3.24),('14598','2013-09-07','10:55:00',3.26),('14598','2013-09-07','11:00:00',3.38),('14598','2013-09-07','11:05:00',3.45),('14598','2013-09-07','11:10:00',3.52),('14598','2013-09-07','11:15:00',3.55),('14598','2013-09-07','11:20:00',3.61),('14598','2013-09-07','11:25:00',3.61),('14598','2013-09-07','11:30:00',3.67),('14598','2013-09-07','11:35:00',3.7),('14598','2013-09-07','11:40:00',3.78),('14598','2013-09-07','11:45:00',3.86),('14598','2013-09-07','11:50:00',3.9),('14598','2013-09-07','11:55:00',3.96),('14598','2013-09-07','12:00:00',4.04),('14598','2013-09-07','12:05:00',4.07),('14598','2013-09-07','12:10:00',4.12),('14598','2013-09-07','12:15:00',4.16),('14598','2013-09-07','12:20:00',4.18),('14598','2013-09-07','12:25:00',4.21),('14598','2013-09-07','12:30:00',4.25),('14598','2013-09-07','12:35:00',4.3),('14598','2013-09-07','12:40:00',4.33),('14598','2013-09-07','12:45:00',4.35),('14598','2013-09-07','12:50:00',4.38),('14598','2013-09-07','12:55:00',4.39),('14598','2013-09-07','13:00:00',4.39),('14598','2013-09-07','13:05:00',4.43),('14598','2013-09-07','13:10:00',4.4),('14598','2013-09-07','13:15:00',4.46),('14598','2013-09-07','13:20:00',4.46),('14598','2013-09-07','13:25:00',4.49),('14598','2013-09-07','13:30:00',4.49),('14598','2013-09-07','13:35:00',4.52),('14598','2013-09-07','13:40:00',4.53),('14598','2013-09-07','13:45:00',4.53),('14598','2013-09-07','13:50:00',4.53),('14598','2013-09-07','13:55:00',4.53),('14598','2013-09-07','14:00:00',4.52),('14598','2013-09-07','14:05:00',4.49),('14598','2013-09-07','14:10:00',4.47),('14598','2013-09-07','14:15:00',4.45),('14598','2013-09-07','14:20:00',4.45),('14598','2013-09-07','14:25:00',4.39),('14598','2013-09-07','14:30:00',4.41),('14598','2013-09-07','14:35:00',4.38),('14598','2013-09-07','14:40:00',3.43),('14598','2013-09-07','14:45:00',4.33),('14598','2013-09-07','14:50:00',4.31),('14598','2013-09-07','14:55:00',4.28),('14598','2013-09-07','15:00:00',4.26),('14598','2013-09-07','15:05:00',4.24),('14598','2013-09-07','15:10:00',4.22),('14598','2013-09-07','15:15:00',4.17),('14598','2013-09-07','15:20:00',4.13),('14598','2013-09-07','15:25:00',2.65),('14598','2013-09-07','15:30:00',4.02),('14598','2013-09-07','15:35:00',3.98),('14598','2013-09-07','15:40:00',3.92),('14598','2013-09-07','15:45:00',3.88),('14598','2013-09-07','15:50:00',3.8),('14598','2013-09-07','15:55:00',3.76),('14598','2013-09-07','16:00:00',3.71),('14598','2013-09-07','16:05:00',3.65),('14598','2013-09-07','16:10:00',3.61),('14598','2013-09-07','16:15:00',3.54),('14598','2013-09-07','16:20:00',3.45),('14598','2013-09-07','16:25:00',3.37),('14598','2013-09-07','16:30:00',3.29),('14598','2013-09-07','16:35:00',3.22),('14598','2013-09-07','16:40:00',3.13),('14598','2013-09-07','16:45:00',3.06),('14598','2013-09-07','16:50:00',2.98),('14598','2013-09-07','16:55:00',2.88),('14598','2013-09-07','17:00:00',2.79),('14598','2013-09-07','17:05:00',2.7),('14598','2013-09-07','17:10:00',2.6),('14598','2013-09-07','17:15:00',2.51),('14598','2013-09-07','17:20:00',2.41),('14598','2013-09-07','17:25:00',2.3),('14598','2013-09-07','17:30:00',2.2),('14598','2013-09-07','17:35:00',2.12),('14598','2013-09-07','17:40:00',2),('14598','2013-09-07','17:45:00',1.9),('14598','2013-09-07','17:50:00',1.8),('14598','2013-09-07','17:55:00',1.73),('14598','2013-09-07','18:00:00',1.61),('14598','2013-09-07','18:05:00',1.5),('14598','2013-09-07','18:10:00',1.39),('14598','2013-09-07','18:15:00',1.29),('14598','2013-09-07','18:20:00',1.19),('14598','2013-09-07','18:25:00',1.1),('14598','2013-09-06','08:40:00',1.08),('14598','2013-09-06','08:45:00',1.19),('14598','2013-09-06','08:50:00',1.28),('14598','2013-09-06','08:55:00',1.42),('14598','2013-09-06','09:00:00',1.52),('14598','2013-09-06','09:05:00',1.61),('14598','2013-09-06','09:10:00',1.72),('14598','2013-09-06','09:15:00',1.85),('14598','2013-09-06','09:20:00',1.95),('14598','2013-09-06','09:25:00',2.05),('14598','2013-09-06','09:30:00',2.14),('14598','2013-09-06','09:35:00',2.23),('14598','2013-09-06','09:40:00',2.31),('14598','2013-09-06','09:45:00',2.4),('14598','2013-09-06','09:50:00',2.49),('14598','2013-09-06','09:55:00',2.58),('14598','2013-09-06','10:00:00',2.66),('14598','2013-09-06','10:05:00',2.7),('14598','2013-09-06','10:10:00',2.83),('14598','2013-09-06','10:15:00',2.91),('14598','2013-09-06','10:20:00',2.98),('14598','2013-09-06','10:25:00',3.04),('14598','2013-09-06','10:30:00',3.1),('14598','2013-09-06','10:35:00',3.2),('14598','2013-09-06','10:40:00',3.1),('14598','2013-09-06','10:45:00',2.84),('14598','2013-09-06','10:50:00',3.4),('14598','2013-09-06','10:55:00',3.46),('14598','2013-09-06','11:00:00',3.52),('14598','2013-09-06','11:05:00',3.56),('14598','2013-09-06','11:10:00',3.58),('14598','2013-09-06','11:15:00',3.64),('14598','2013-09-06','11:20:00',3.67),('14598','2013-09-06','11:25:00',3.75),('14598','2013-09-06','11:30:00',3.78),('14598','2013-09-06','11:35:00',3.86),('14598','2013-09-06','11:40:00',3.87),('14598','2013-09-06','11:45:00',3.94),('14598','2013-09-06','11:50:00',3.94),('14598','2013-09-06','11:55:00',4.02),('14598','2013-09-06','12:00:00',4.02),('14598','2013-09-06','12:05:00',3.99),('14598','2013-09-06','12:10:00',4.03),('14598','2013-09-06','12:15:00',4.06),('14598','2013-09-06','12:20:00',4.09),('14598','2013-09-06','12:25:00',4.13),('14598','2013-09-06','12:30:00',4.13),('14598','2013-09-06','12:35:00',4.13),('14598','2013-09-06','12:40:00',4.1),('14598','2013-09-06','12:45:00',4.14),('14598','2013-09-06','12:50:00',4.24),('14598','2013-09-06','12:55:00',4.28),('14598','2013-09-06','13:00:00',4.32),('14598','2013-09-06','13:05:00',4.34),('14598','2013-09-06','13:10:00',4.34),('14598','2013-09-06','13:15:00',4.41),('14598','2013-09-06','13:20:00',4.45),('14598','2013-09-06','13:25:00',4.49),('14598','2013-09-06','13:30:00',4.49),('14598','2013-09-06','13:35:00',4.53),('14598','2013-09-06','13:40:00',4.51),('14598','2013-09-06','13:45:00',4.51),('14598','2013-09-06','13:50:00',4.48),('14598','2013-09-06','13:55:00',4.47),('14598','2013-09-06','14:00:00',4.46),('14598','2013-09-06','14:05:00',4.48),('14598','2013-09-06','14:10:00',4.48),('14598','2013-09-06','14:15:00',4.48),('14598','2013-09-06','14:20:00',4.45),('14598','2013-09-06','14:25:00',4.42),('14598','2013-09-06','14:30:00',4.43),('14598','2013-09-06','14:35:00',4.4),('14598','2013-09-06','14:40:00',4.38),('14598','2013-09-06','14:45:00',4.39),('14598','2013-09-06','14:50:00',4.37),('14598','2013-09-06','14:55:00',4.34),('14598','2013-09-06','15:00:00',4.3),('14598','2013-09-06','15:05:00',4.28),('14598','2013-09-06','15:10:00',4.24),('14598','2013-09-06','15:15:00',4.21),('14598','2013-09-06','15:20:00',4.16),('14598','2013-09-06','15:25:00',4.13),('14598','2013-09-06','15:30:00',4.08),('14598','2013-09-06','15:35:00',4.04),('14598','2013-09-06','15:40:00',3.99),('14598','2013-09-06','15:45:00',3.92),('14598','2013-09-06','15:50:00',3.85),('14598','2013-09-06','15:55:00',3.78),('14598','2013-09-06','16:00:00',3.74),('14598','2013-09-06','16:05:00',3.7),('14598','2013-09-06','16:10:00',3.6),('14598','2013-09-06','16:15:00',3.56),('14598','2013-09-06','16:20:00',3.49),('14598','2013-09-06','16:25:00',3.41),('14598','2013-09-06','16:30:00',3.34),('14598','2013-09-06','16:35:00',3.28),('14598','2013-09-06','16:40:00',3.2),('14598','2013-09-06','16:45:00',3.11),('14598','2013-09-06','16:50:00',3.02),('14598','2013-09-06','16:55:00',2.95),('14598','2013-09-06','17:00:00',2.88),('14598','2013-09-06','17:05:00',2.79),('14598','2013-09-06','17:10:00',2.7),('14598','2013-09-06','17:15:00',2.61),('14598','2013-09-06','17:20:00',2.52),('14598','2013-09-06','17:25:00',2.41),('14598','2013-09-06','17:30:00',2.32),('14598','2013-09-06','17:35:00',2.25),('14598','2013-09-06','17:40:00',2.13),('14598','2013-09-06','17:45:00',2.04),('14598','2013-09-06','17:50:00',1.91),('14598','2013-09-06','17:55:00',1.81),('14598','2013-09-06','18:00:00',1.69),('14598','2013-09-06','18:05:00',1.58),('14598','2013-09-06','18:10:00',1.45),('14598','2013-09-06','18:15:00',1.35),('14598','2013-09-06','18:20:00',1.26),('14598','2013-09-06','18:25:00',1.15),('14598','2013-09-06','18:30:00',1.03),('14598','2013-09-05','08:35:00',1.04),('14598','2013-09-05','08:40:00',1.15),('14598','2013-09-05','08:45:00',1.25),('14598','2013-09-05','08:50:00',1.36),('14598','2013-09-05','08:55:00',1.48),('14598','2013-09-05','09:00:00',1.59),('14598','2013-09-05','09:05:00',1.69),('14598','2013-09-05','09:10:00',1.79),('14598','2013-09-05','09:15:00',1.89),('14598','2013-09-05','09:20:00',2),('14598','2013-09-05','09:25:00',2.12),('14598','2013-09-05','09:30:00',2.22),('14598','2013-09-05','09:35:00',2.31),('14598','2013-09-05','09:40:00',2.4),('14598','2013-09-05','09:45:00',2.5),('14598','2013-09-05','09:50:00',2.57),('14598','2013-09-05','09:55:00',2.67),('14598','2013-09-05','10:00:00',2.75),('14598','2013-09-05','10:05:00',2.83),('14598','2013-09-05','10:10:00',2.91),('14598','2013-09-05','10:15:00',2.99),('14598','2013-09-05','10:20:00',3.06),('14598','2013-09-05','10:25:00',3.13),('14598','2013-09-05','10:30:00',3.2),('14598','2013-09-05','10:35:00',3.26),('14598','2013-09-05','10:40:00',3.31),('14598','2013-09-05','10:45:00',3.38),('14598','2013-09-05','10:50:00',3.43),('14598','2013-09-05','10:55:00',3.47),('14598','2013-09-05','11:00:00',3.5),('14598','2013-09-05','11:05:00',3.58),('14598','2013-09-05','11:10:00',3.64),('14598','2013-09-05','11:15:00',3.69),('14598','2013-09-05','11:20:00',3.74),('14598','2013-09-05','11:25:00',3.82),('14598','2013-09-05','11:30:00',3.9),('14598','2013-09-05','11:35:00',3.97),('14598','2013-09-05','11:40:00',4.02),('14598','2013-09-05','11:45:00',4.05),('14598','2013-09-05','11:50:00',4.07),('14598','2013-09-05','11:55:00',4.1),('14598','2013-09-05','12:00:00',4.13),('14598','2013-09-05','12:05:00',4.14),('14598','2013-09-05','12:10:00',4.23),('14598','2013-09-05','12:15:00',4.29),('14598','2013-09-05','12:20:00',4.3),('14598','2013-09-05','12:25:00',4.33),('14598','2013-09-05','12:30:00',4.35),('14598','2013-09-05','12:35:00',4.37),('14598','2013-09-05','12:40:00',4.38),('14598','2013-09-05','12:45:00',4.42),('14598','2013-09-05','12:50:00',4.47),('14598','2013-09-05','12:55:00',4.52),('14598','2013-09-05','13:00:00',4.55),('14598','2013-09-05','13:05:00',4.56),('14598','2013-09-05','13:10:00',4.55),('14598','2013-09-05','13:15:00',4.54),('14598','2013-09-05','13:20:00',4.51),('14598','2013-09-05','13:25:00',4.5),('14598','2013-09-05','13:30:00',4.54),('14598','2013-09-05','13:35:00',4.58),('14598','2013-09-05','13:40:00',4.6),('14598','2013-09-05','13:45:00',4.6),('14598','2013-09-05','13:50:00',4.62),('14598','2013-09-05','13:55:00',4.61),('14598','2013-09-05','14:00:00',4.6),('14598','2013-09-05','14:05:00',4.56),('14598','2013-09-05','14:10:00',4.58),('14598','2013-09-05','14:15:00',4.57),('14598','2013-09-05','14:20:00',4.57),('14598','2013-09-05','14:25:00',4.52),('14598','2013-09-05','14:30:00',4.51),('14598','2013-09-05','14:35:00',4.5),('14598','2013-09-05','14:40:00',4.46),('14598','2013-09-05','14:45:00',4.44),('14598','2013-09-05','14:50:00',4.41),('14598','2013-09-05','14:55:00',4.39),('14598','2013-09-05','15:00:00',4.37),('14598','2013-09-05','15:05:00',4.32),('14598','2013-09-05','15:10:00',4.29),('14598','2013-09-05','15:15:00',4.27),('14598','2013-09-05','15:20:00',4.23),('14598','2013-09-05','15:25:00',4.18),('14598','2013-09-05','15:30:00',4.15),('14598','2013-09-05','15:35:00',4.1),('14598','2013-09-05','15:40:00',4.05),('14598','2013-09-05','15:45:00',4.02),('14598','2013-09-05','15:50:00',3.97),('14598','2013-09-05','15:55:00',3.91),('14598','2013-09-05','16:00:00',3.86),('14598','2013-09-05','16:05:00',3.8),('14598','2013-09-05','16:10:00',3.76),('14598','2013-09-05','16:15:00',3.69),('14598','2013-09-05','16:20:00',3.65),('14598','2013-09-05','16:25:00',3.61),('14598','2013-09-05','16:30:00',3.54),('14598','2013-09-05','16:35:00',3.5),('14598','2013-09-05','16:40:00',3.44),('14598','2013-09-05','16:45:00',2.49),('14598','2013-09-05','16:50:00',2.47),('14598','2013-09-05','16:55:00',2.33),('14598','2013-09-05','17:00:00',2.48),('14598','2013-09-05','17:05:00',2.27),('14598','2013-09-05','17:10:00',2.09),('14598','2013-09-05','17:15:00',2.11),('14598','2013-09-05','17:20:00',2.2),('14598','2013-09-05','17:25:00',2.43),('14598','2013-09-05','17:30:00',2.34),('14598','2013-09-05','17:35:00',1.8),('14598','2013-09-05','17:40:00',2.1),('14598','2013-09-05','17:45:00',2.03),('14598','2013-09-05','17:50:00',1.86),('14598','2013-09-05','17:55:00',1.81),('14598','2013-09-05','18:00:00',1.63),('14598','2013-09-05','18:05:00',1.31),('14598','2013-09-05','18:10:00',1.43),('14598','2013-09-05','18:15:00',1.06),('14598','2013-09-05','18:25:00',1.08),('14598','2013-09-05','18:30:00',1.07),('14598','2013-09-05','18:35:00',1.02),('14598','2013-09-05','18:40:00',1.05),('14598','2013-09-04','08:35:00',1.05),('14598','2013-09-04','08:40:00',1.17),('14598','2013-09-04','08:45:00',1.28),('14598','2013-09-04','08:50:00',1.39),('14598','2013-09-04','08:55:00',1.49),('14598','2013-09-04','09:00:00',1.61),('14598','2013-09-04','09:05:00',1.71),('14598','2013-09-04','09:10:00',1.83),('14598','2013-09-04','09:15:00',1.95),('14598','2013-09-04','09:20:00',2.06),('14598','2013-09-04','09:25:00',2.16),('14598','2013-09-04','09:30:00',2.26),('14598','2013-09-04','09:35:00',2.36),('14598','2013-09-04','09:40:00',2.45),('14598','2013-09-04','09:45:00',2.54),('14598','2013-09-04','09:50:00',2.61),('14598','2013-09-04','09:55:00',2.72),('14598','2013-09-04','10:00:00',2.81),('14598','2013-09-04','10:05:00',2.88),('14598','2013-09-04','10:10:00',2.97),('14598','2013-09-04','10:15:00',3.04),('14598','2013-09-04','10:20:00',3.11),('14598','2013-09-04','10:25:00',3.16),('14598','2013-09-04','10:30:00',3.22),('14598','2013-09-04','10:35:00',3.29),('14598','2013-09-04','10:40:00',3.38),('14598','2013-09-04','10:45:00',3.46),('14598','2013-09-04','10:50:00',3.53),('14598','2013-09-04','10:55:00',3.57),('14598','2013-09-04','11:00:00',3.61),('14598','2013-09-04','11:05:00',3.61),('14598','2013-09-04','11:10:00',3.73),('14598','2013-09-04','11:15:00',3.78),('14598','2013-09-04','11:20:00',3.85),('14598','2013-09-04','11:25:00',3.91),('14598','2013-09-04','11:30:00',3.96),('14598','2013-09-04','11:35:00',4),('14598','2013-09-04','11:40:00',4.06),('14598','2013-09-04','11:45:00',4.08),('14598','2013-09-04','11:50:00',4.12),('14598','2013-09-04','11:55:00',4.16),('14598','2013-09-04','12:00:00',4.17),('14598','2013-09-04','12:05:00',4.17),('14598','2013-09-04','12:10:00',4.19),('14598','2013-09-04','12:15:00',4.23),('14598','2013-09-04','12:20:00',4.29),('14598','2013-09-04','12:25:00',4.35),('14598','2013-09-04','12:30:00',4.37),('14598','2013-09-04','12:35:00',4.42),('14598','2013-09-04','12:40:00',4.43),('14598','2013-09-04','12:45:00',4.48),('14598','2013-09-04','12:50:00',4.5),('14598','2013-09-04','12:55:00',4.52),('14598','2013-09-04','13:00:00',4.54),('14598','2013-09-04','13:05:00',4.55),('14598','2013-09-04','13:10:00',4.52),('14598','2013-09-04','13:15:00',4.51),('14598','2013-09-04','13:20:00',4.55),('14598','2013-09-04','13:25:00',4.56),('14598','2013-09-04','13:30:00',4.56),('14598','2013-09-04','13:35:00',4.57),('14598','2013-09-04','13:40:00',4.56),('14598','2013-09-04','13:45:00',4.55),('14598','2013-09-04','13:50:00',4.54),('14598','2013-09-04','13:55:00',4.54),('14598','2013-09-04','14:00:00',4.5),('14598','2013-09-04','14:05:00',4.51),('14598','2013-09-04','14:10:00',4.5),('14598','2013-09-04','14:15:00',4.45),('14598','2013-09-04','14:20:00',4.44),('14598','2013-09-04','14:25:00',4.45),('14598','2013-09-04','14:30:00',4.42),('14598','2013-09-04','14:35:00',4.38),('14598','2013-09-04','14:40:00',4.31),('14598','2013-09-04','14:45:00',4.3),('14598','2013-09-04','14:50:00',4.23),('14598','2013-09-04','14:55:00',4.23),('14598','2013-09-04','15:00:00',4.26),('14598','2013-09-04','15:05:00',4.22),('14598','2013-09-04','15:10:00',4.16),('14598','2013-09-04','15:15:00',4.15),('14598','2013-09-04','15:20:00',4.12),('14598','2013-09-04','15:25:00',4.14),('14598','2013-09-04','15:30:00',4.12),('14598','2013-09-04','15:35:00',4.09),('14598','2013-09-04','15:40:00',4.03),('14598','2013-09-04','15:45:00',4),('14598','2013-09-04','15:50:00',3.88),('14598','2013-09-04','15:55:00',3.88),('14598','2013-09-04','16:00:00',3.83),('14598','2013-09-04','16:05:00',3.76),('14598','2013-09-04','16:10:00',3.7),('14598','2013-09-04','16:15:00',3.63),('14598','2013-09-04','16:20:00',3.55),('14598','2013-09-04','16:25:00',3.51),('14598','2013-09-04','16:30:00',3.44),('14598','2013-09-04','16:35:00',3.36),('14598','2013-09-04','16:40:00',3.28),('14598','2013-09-04','16:45:00',3.2),('14598','2013-09-04','16:50:00',3.12),('14598','2013-09-04','16:55:00',3.04),('14598','2013-09-04','17:00:00',2.96),('14598','2013-09-04','17:05:00',2.86),('14598','2013-09-04','17:10:00',2.77),('14598','2013-09-04','17:15:00',2.7),('14598','2013-09-04','17:20:00',2.59),('14598','2013-09-04','17:25:00',2.49),('14598','2013-09-04','17:30:00',2.4),('14598','2013-09-04','17:35:00',2.3),('14598','2013-09-04','17:40:00',2.19),('14598','2013-09-04','17:45:00',2.1),('14598','2013-09-04','17:50:00',2),('14598','2013-09-04','17:55:00',1.9),('14598','2013-09-04','18:00:00',1.79),('14598','2013-09-04','18:05:00',1.68),('14598','2013-09-04','18:10:00',1.57),('14598','2013-09-04','18:15:00',1.46),('14598','2013-09-04','18:20:00',1.35),('14598','2013-09-04','18:25:00',1.24),('14598','2013-09-04','18:30:00',1.13),('14598','2013-09-04','18:35:00',1.01),('14598','2013-09-03','08:35:00',1.01),('14598','2013-09-03','08:40:00',1.13),('14598','2013-09-03','08:45:00',1.23),('14598','2013-09-03','08:50:00',1.33),('14598','2013-09-03','08:55:00',1.43),('14598','2013-09-03','09:00:00',1.53),('14598','2013-09-03','09:05:00',1.63),('14598','2013-09-03','09:10:00',1.74),('14598','2013-09-03','09:15:00',1.86),('14598','2013-09-03','09:20:00',1.95),('14598','2013-09-03','09:25:00',2.03),('14598','2013-09-03','09:30:00',2.12),('14598','2013-09-03','09:35:00',2.22),('14598','2013-09-03','09:40:00',2.33),('14598','2013-09-03','09:45:00',2.4),('14598','2013-09-03','09:50:00',2.46),('14598','2013-09-03','09:55:00',2.58),('14598','2013-09-03','10:00:00',2.66),('14598','2013-09-03','10:05:00',2.75),('14598','2013-09-03','10:10:00',2.83),('14598','2013-09-03','10:15:00',2.9),('14598','2013-09-03','10:20:00',2.98),('14598','2013-09-03','10:25:00',3.04),('14598','2013-09-03','10:30:00',3.1),('14598','2013-09-03','10:35:00',3.18),('14598','2013-09-03','10:40:00',3.24),('14598','2013-09-03','10:45:00',3.29),('14598','2013-09-03','10:50:00',3.34),('14598','2013-09-03','10:55:00',3.43),('14598','2013-09-03','11:00:00',3.48),('14598','2013-09-03','11:05:00',3.55),('14598','2013-09-03','11:10:00',3.61),('14598','2013-09-03','11:15:00',3.66),('14598','2013-09-03','11:20:00',3.68),('14598','2013-09-03','11:25:00',3.72),('14598','2013-09-03','11:30:00',3.77),('14598','2013-09-03','11:35:00',3.78),('14598','2013-09-03','11:40:00',3.84),('14598','2013-09-03','11:45:00',3.85),('14598','2013-09-03','11:50:00',3.91),('14598','2013-09-03','11:55:00',3.95),('14598','2013-09-03','12:00:00',4),('14598','2013-09-03','12:05:00',4.04),('14598','2013-09-03','12:10:00',4.12),('14598','2013-09-03','12:15:00',4.15),('14598','2013-09-03','12:20:00',4.15),('14598','2013-09-03','12:25:00',4.19),('14598','2013-09-03','12:30:00',4.24),('14598','2013-09-03','12:35:00',4.26),('14598','2013-09-03','12:40:00',4.3),('14598','2013-09-03','12:45:00',4.29),('14598','2013-09-03','12:50:00',4.24),('14598','2013-09-03','12:55:00',4.32),('14598','2013-09-03','13:00:00',4.31),('14598','2013-09-03','13:05:00',4.41),('14598','2013-09-03','13:10:00',4.49),('14598','2013-09-03','13:15:00',4.45),('14598','2013-09-03','13:20:00',4.35),('14598','2013-09-03','13:25:00',4.44),('14598','2013-09-03','13:30:00',4.46),('14598','2013-09-03','13:35:00',4.47),('14598','2013-09-03','13:40:00',4.49),('14598','2013-09-03','13:45:00',4.49),('14598','2013-09-03','13:50:00',4.42),('14598','2013-09-03','13:55:00',4.43),('14598','2013-09-03','14:00:00',4.42),('14598','2013-09-03','14:05:00',4.44),('14598','2013-09-03','14:10:00',4.42),('14598','2013-09-03','14:15:00',4.37),('14598','2013-09-03','14:20:00',4.34),('14598','2013-09-03','14:25:00',4.3),('14598','2013-09-03','14:30:00',4.32),('14598','2013-09-03','14:35:00',4.43),('14598','2013-09-03','14:40:00',4.42),('14598','2013-09-03','14:45:00',4.38),('14598','2013-09-03','14:50:00',4.33),('14598','2013-09-03','14:55:00',4.32),('14598','2013-09-03','15:00:00',4.3),('14598','2013-09-03','15:05:00',4.29),('14598','2013-09-03','15:10:00',4.24),('14598','2013-09-03','15:15:00',4.19),('14598','2013-09-03','15:20:00',4.15),('14598','2013-09-03','15:25:00',4.11),('14598','2013-09-03','15:30:00',4.08),('14598','2013-09-03','15:35:00',4.03),('14598','2013-09-03','15:40:00',3.99),('14598','2013-09-03','15:45:00',3.97),('14598','2013-09-03','15:50:00',3.95),('14598','2013-09-03','15:55:00',3.84),('14598','2013-09-03','16:00:00',3.8),('14598','2013-09-03','16:05:00',3.72),('14598','2013-09-03','16:10:00',3.62),('14598','2013-09-03','16:15:00',3.59),('14598','2013-09-03','16:20:00',3.52),('14598','2013-09-03','16:25:00',3.47),('14598','2013-09-03','16:30:00',3.4),('14598','2013-09-03','16:35:00',3.33),('14598','2013-09-03','16:40:00',3.21),('14598','2013-09-03','16:45:00',3.14),('14598','2013-09-03','16:50:00',3.08),('14598','2013-09-03','16:55:00',3),('14598','2013-09-03','17:00:00',2.92),('14598','2013-09-03','17:05:00',2.83),('14598','2013-09-03','17:10:00',2.75),('14598','2013-09-03','17:15:00',2.63),('14598','2013-09-03','17:20:00',2.54),('14598','2013-09-03','17:25:00',2.45),('14598','2013-09-03','17:30:00',2.36),('14598','2013-09-03','17:35:00',2.28),('14598','2013-09-03','17:40:00',2.16),('14598','2013-09-03','17:45:00',2.07),('14598','2013-09-03','17:50:00',1.97),('14598','2013-09-03','17:55:00',1.86),('14598','2013-09-03','18:00:00',1.75),('14598','2013-09-03','18:05:00',1.62),('14598','2013-09-03','18:10:00',1.52),('14598','2013-09-03','18:15:00',1.42),('14598','2013-09-03','18:20:00',1.31),('14598','2013-09-03','18:25:00',1.19),('14598','2013-09-03','18:30:00',1.08),('14598','2013-09-02','08:35:00',1.06),('14598','2013-09-02','08:40:00',1.17),('14598','2013-09-02','08:45:00',1.28),('14598','2013-09-02','08:50:00',1.38),('14598','2013-09-02','08:55:00',1.47),('14598','2013-09-02','09:00:00',1.58),('14598','2013-09-02','09:05:00',1.67),('14598','2013-09-02','09:10:00',1.78),('14598','2013-09-02','09:15:00',1.89),('14598','2013-09-02','09:20:00',2.01),('14598','2013-09-02','09:25:00',2.11),('14598','2013-09-02','09:30:00',2.2),('14598','2013-09-02','09:35:00',2.3),('14598','2013-09-02','09:40:00',2.39),('14598','2013-09-02','09:45:00',2.48),('14598','2013-09-02','09:50:00',2.57),('14598','2013-09-02','09:55:00',2.66),('14598','2013-09-02','10:00:00',2.75),('14598','2013-09-02','10:05:00',2.83),('14598','2013-09-02','10:10:00',2.92),('14598','2013-09-02','10:15:00',2.99),('14598','2013-09-02','10:20:00',3.06),('14598','2013-09-02','10:25:00',3.14),('14598','2013-09-02','10:30:00',3.21),('14598','2013-09-02','10:35:00',3.24),('14598','2013-09-02','10:40:00',3.34),('14598','2013-09-02','10:45:00',3.41),('14598','2013-09-02','10:50:00',3.47),('14598','2013-09-02','10:55:00',3.54),('14598','2013-09-02','11:00:00',3.59),('14598','2013-09-02','11:05:00',3.65),('14598','2013-09-02','11:10:00',3.7),('14598','2013-09-02','11:15:00',3.76),('14598','2013-09-02','11:20:00',3.8),('14598','2013-09-02','11:25:00',3.86),('14598','2013-09-02','11:30:00',3.9),('14598','2013-09-02','11:35:00',3.95),('14598','2013-09-02','11:40:00',3.99),('14598','2013-09-02','11:45:00',4.03),('14598','2013-09-02','11:50:00',4.04),('14598','2013-09-02','11:55:00',4.09),('14598','2013-09-02','12:00:00',4.14),('14598','2013-09-02','12:05:00',4.17),('14598','2013-09-02','12:10:00',4.22),('14598','2013-09-02','12:15:00',4.26),('14598','2013-09-02','12:20:00',4.24),('14598','2013-09-02','12:25:00',4.27),('14598','2013-09-02','12:30:00',4.27),('14598','2013-09-02','12:35:00',4.28),('14598','2013-09-02','12:40:00',4.31),('14598','2013-09-02','12:45:00',4.29),('14598','2013-09-02','12:50:00',4.3),('14598','2013-09-02','12:55:00',4.32),('14598','2013-09-02','13:00:00',4.36),('14598','2013-09-02','13:05:00',4.41),('14598','2013-09-02','13:10:00',4.46),('14598','2013-09-02','13:15:00',4.46),('14598','2013-09-02','13:20:00',4.51),('14598','2013-09-02','13:25:00',4.52),('14598','2013-09-02','13:30:00',4.56),('14598','2013-09-02','13:35:00',4.53),('14598','2013-09-02','13:40:00',4.63),('14598','2013-09-02','13:45:00',4.64),('14598','2013-09-02','13:50:00',4.62),('14598','2013-09-02','13:55:00',4.64),('14598','2013-09-02','14:00:00',4.63),('14598','2013-09-02','14:05:00',4.62),('14598','2013-09-02','14:10:00',4.6),('14598','2013-09-02','14:15:00',4.6),('14598','2013-09-02','14:20:00',4.59),('14598','2013-09-02','14:25:00',4.57),('14598','2013-09-02','14:30:00',4.56),('14598','2013-09-02','14:35:00',4.53),('14598','2013-09-02','14:40:00',4.51),('14598','2013-09-02','14:45:00',4.47),('14598','2013-09-02','14:50:00',4.44),('14598','2013-09-02','14:55:00',4.4),('14598','2013-09-02','15:00:00',4.37),('14598','2013-09-02','15:05:00',4.33),('14598','2013-09-02','15:10:00',4.31),('14598','2013-09-02','15:15:00',4.29),('14598','2013-09-02','15:20:00',4.25),('14598','2013-09-02','15:25:00',4.24),('14598','2013-09-02','15:30:00',4.2),('14598','2013-09-02','15:35:00',4.13),('14598','2013-09-02','15:40:00',4.08),('14598','2013-09-02','15:45:00',3.99),('14598','2013-09-02','15:50:00',3.93),('14598','2013-09-02','15:55:00',3.91),('14598','2013-09-02','16:00:00',3.83),('14598','2013-09-02','16:05:00',3.78),('14598','2013-09-02','16:10:00',3.71),('14598','2013-09-02','16:15:00',3.64),('14598','2013-09-02','16:20:00',3.55),('14598','2013-09-02','16:25:00',3.49),('14598','2013-09-02','16:30:00',3.43),('14598','2013-09-02','16:35:00',3.35),('14598','2013-09-02','16:40:00',3.32),('14598','2013-09-02','16:45:00',3.27),('14598','2013-09-02','16:50:00',3.14),('14598','2013-09-02','16:55:00',3.03),('14598','2013-09-02','17:00:00',2.95),('14598','2013-09-02','17:05:00',2.86),('14598','2013-09-02','17:10:00',2.77),('14598','2013-09-02','17:15:00',2.69),('14598','2013-09-02','17:20:00',2.59),('14598','2013-09-02','17:25:00',2.5),('14598','2013-09-02','17:30:00',2.39),('14598','2013-09-02','17:35:00',2.29),('14598','2013-09-02','17:40:00',2.18),('14598','2013-09-02','17:45:00',2.08),('14598','2013-09-02','17:50:00',1.96),('14598','2013-09-02','17:55:00',1.85),('14598','2013-09-02','18:00:00',1.75),('14598','2013-09-02','18:05:00',1.63),('14598','2013-09-02','18:10:00',1.5),('14598','2013-09-02','18:15:00',1.38),('14598','2013-09-02','18:20:00',1.24),('14598','2013-09-02','18:25:00',1.17),('14598','2013-09-02','18:30:00',1.06),('14598','2013-09-01','08:35:00',1.09),('14598','2013-09-01','08:40:00',1.2),('14598','2013-09-01','08:45:00',1.29),('14598','2013-09-01','08:50:00',1.39),('14598','2013-09-01','08:55:00',1.5),('14598','2013-09-01','09:00:00',1.59),('14598','2013-09-01','09:05:00',1.71),('14598','2013-09-01','09:10:00',1.82),('14598','2013-09-01','09:15:00',1.94),('14598','2013-09-01','09:20:00',2.05),('14598','2013-09-01','09:25:00',2.14),('14598','2013-09-01','09:30:00',2.24),('14598','2013-09-01','09:35:00',2.33),('14598','2013-09-01','09:40:00',2.41),('14598','2013-09-01','09:45:00',2.51),('14598','2013-09-01','09:50:00',2.59),('14598','2013-09-01','09:55:00',2.67),('14598','2013-09-01','10:00:00',2.75),('14598','2013-09-01','10:05:00',2.85),('14598','2013-09-01','10:10:00',2.95),('14598','2013-09-01','10:15:00',3.03),('14598','2013-09-01','10:20:00',3.11),('14598','2013-09-01','10:25:00',3.17),('14598','2013-09-01','10:30:00',3.24),('14598','2013-09-01','10:35:00',3.31),('14598','2013-09-01','10:40:00',3.39),('14598','2013-09-01','10:45:00',3.44),('14598','2013-09-01','10:50:00',3.49),('14598','2013-09-01','10:55:00',3.57),('14598','2013-09-01','11:00:00',3.64),('14598','2013-09-01','11:05:00',3.69),('14598','2013-09-01','11:10:00',3.71),('14598','2013-09-01','11:15:00',3.78),('14598','2013-09-01','11:20:00',3.83),('14598','2013-09-01','11:25:00',3.87),('14598','2013-09-01','11:30:00',3.94),('14598','2013-09-01','11:35:00',3.96),('14598','2013-09-01','11:40:00',4.02),('14598','2013-09-01','11:45:00',3.98),('14598','2013-09-01','11:50:00',4.11),('14598','2013-09-01','11:55:00',4.06),('14598','2013-09-01','12:00:00',4.13),('14598','2013-09-01','12:05:00',4.11),('14598','2013-09-01','12:10:00',4.09),('14598','2013-09-01','12:15:00',4.29),('14598','2013-09-01','12:20:00',4.33),('14598','2013-09-01','12:25:00',4.33),('14598','2013-09-01','12:30:00',4.34),('14598','2013-09-01','12:35:00',4.33),('14598','2013-09-01','12:40:00',4.42),('14598','2013-09-01','12:45:00',4.46),('14598','2013-09-01','12:50:00',4.41),('14598','2013-09-01','12:55:00',4.17),('14598','2013-09-01','13:00:00',4.62),('14598','2013-09-01','13:05:00',4.61),('14598','2013-09-01','13:10:00',4.69),('14598','2013-09-01','13:15:00',4.64),('14598','2013-09-01','13:20:00',4.24),('14598','2013-09-01','13:25:00',3.58),('14598','2013-09-01','13:30:00',4.66),('14598','2013-09-01','13:35:00',4.6),('14598','2013-09-01','13:40:00',4.59),('14598','2013-09-01','13:45:00',4.36),('14598','2013-09-01','13:50:00',4.41),('14598','2013-09-01','13:55:00',4.39),('14598','2013-09-01','14:00:00',4.43),('14598','2013-09-01','14:05:00',4.44),('14598','2013-09-01','14:10:00',4.3),('14598','2013-09-01','14:15:00',4.02),('14598','2013-09-01','14:20:00',3.55),('14598','2013-09-01','14:25:00',4.06),('14598','2013-09-01','14:30:00',3.69),('14598','2013-09-01','14:35:00',4.17),('14598','2013-09-01','14:40:00',4.01),('14598','2013-09-01','14:45:00',4.26),('14598','2013-09-01','14:50:00',4.33),('14598','2013-09-01','14:55:00',4.29),('14598','2013-09-01','15:00:00',4.28),('14598','2013-09-01','15:05:00',4.27),('14598','2013-09-01','15:10:00',4.2),('14598','2013-09-01','15:15:00',4.2),('14598','2013-09-01','15:20:00',4.21),('14598','2013-09-01','15:25:00',4.24),('14598','2013-09-01','15:30:00',4.11),('14598','2013-09-01','15:35:00',3.92),('14598','2013-09-01','15:40:00',3.82),('14598','2013-09-01','15:45:00',3.61),('14598','2013-09-01','15:50:00',3.55),('14598','2013-09-01','15:55:00',3.37),('14598','2013-09-01','16:00:00',3.5),('14598','2013-09-01','16:05:00',3.54),('14598','2013-09-01','16:10:00',3.26),('14598','2013-09-01','16:15:00',3.02),('14598','2013-09-01','16:20:00',2.66),('14598','2013-09-01','16:25:00',3.1),('14598','2013-09-01','16:30:00',3.19),('14598','2013-09-01','16:35:00',2.99),('14598','2013-09-01','16:40:00',3.06),('14598','2013-09-01','16:45:00',3.12),('14598','2013-09-01','16:50:00',3.08),('14598','2013-09-01','16:55:00',2.95),('14598','2013-09-01','17:00:00',2.86),('14598','2013-09-01','17:05:00',2.72),('14598','2013-09-01','17:10:00',2.41),('14598','2013-09-01','17:15:00',2.4),('14598','2013-09-01','17:20:00',2.45),('14598','2013-09-01','17:25:00',2.51),('14598','2013-09-01','17:30:00',2.39),('14598','2013-09-01','17:35:00',2.35),('14598','2013-09-01','17:40:00',2.38),('14598','2013-09-01','17:45:00',2.18),('14598','2013-09-01','17:50:00',2.14),('14598','2013-09-01','17:55:00',1.94),('14598','2013-09-01','18:00:00',1.76),('14598','2013-09-01','18:05:00',1.9),('14598','2013-09-01','18:10:00',1.74),('14598','2013-09-01','18:15:00',1.5),('14598','2013-09-01','18:20:00',1.37),('14598','2013-09-01','18:25:00',1.52),('14598','2013-09-01','18:30:00',1.4),('14598','2013-09-01','18:35:00',1.26),('14598','2013-09-01','18:40:00',1.13),('14598','2013-08-31','08:30:00',1.02),('14598','2013-08-31','08:35:00',1.17),('14598','2013-08-31','08:40:00',1.34),('14598','2013-08-31','08:45:00',1.55),('14598','2013-08-31','08:50:00',1.65),('14598','2013-08-31','08:55:00',1.41),('14598','2013-08-31','09:05:00',1.65),('14598','2013-08-31','09:10:00',1.84),('14598','2013-08-31','09:15:00',2.14),('14598','2013-08-31','09:20:00',2.21),('14598','2013-08-31','09:25:00',2.35),('14598','2013-08-31','09:30:00',2.33),('14598','2013-08-31','09:35:00',2.22),('14598','2013-08-31','09:40:00',2.42),('14598','2013-08-31','09:45:00',2.62),('14598','2013-08-31','09:50:00',2.71),('14598','2013-08-31','09:55:00',2.71),('14598','2013-08-31','10:00:00',2.84),('14598','2013-08-31','10:05:00',2.88),('14598','2013-08-31','10:10:00',2.92),('14598','2013-08-31','10:15:00',3),('14598','2013-08-31','10:20:00',3.09),('14598','2013-08-31','10:25:00',3.23),('14598','2013-08-31','10:30:00',3.26),('14598','2013-08-31','10:35:00',3.3),('14598','2013-08-31','10:40:00',3.4),('14598','2013-08-31','10:45:00',3.52),('14598','2013-08-31','10:50:00',3.6),('14598','2013-08-31','10:55:00',3.66),('14598','2013-08-31','11:00:00',3.72),('14598','2013-08-31','11:05:00',3.77),('14598','2013-08-31','11:10:00',3.81),('14598','2013-08-31','11:15:00',3.88),('14598','2013-08-31','11:20:00',3.92),('14598','2013-08-31','11:25:00',3.99),('14598','2013-08-31','11:30:00',4.06),('14598','2013-08-31','11:35:00',4.07),('14598','2013-08-31','11:40:00',4.11),('14598','2013-08-31','11:45:00',4.2),('14598','2013-08-31','11:50:00',4.21),('14598','2013-08-31','11:55:00',4.26),('14598','2013-08-31','12:00:00',4.29),('14598','2013-08-31','12:05:00',4.33),('14598','2013-08-31','12:10:00',4.34),('14598','2013-08-31','12:15:00',4.34),('14598','2013-08-31','12:20:00',4.38),('14598','2013-08-31','12:25:00',4.41),('14598','2013-08-31','12:30:00',4.45),('14598','2013-08-31','12:35:00',4.47),('14598','2013-08-31','12:40:00',4.48),('14598','2013-08-31','12:45:00',4.5),('14598','2013-08-31','12:50:00',4.52),('14598','2013-08-31','12:55:00',4.51),('14598','2013-08-31','13:00:00',4.55),('14598','2013-08-31','13:05:00',4.55),('14598','2013-08-31','13:10:00',4.56),('14598','2013-08-31','13:15:00',4.55),('14598','2013-08-31','13:20:00',4.56),('14598','2013-08-31','13:25:00',4.5),('14598','2013-08-31','13:30:00',4.5),('14598','2013-08-31','13:35:00',4.48),('14598','2013-08-31','13:40:00',4.48),('14598','2013-08-31','13:45:00',4.53),('14598','2013-08-31','13:50:00',4.51),('14598','2013-08-31','13:55:00',4.46),('14598','2013-08-31','14:00:00',4.44),('14598','2013-08-31','14:05:00',4.48),('14598','2013-08-31','14:10:00',4.43),('14598','2013-08-31','14:15:00',4.37),('14598','2013-08-31','14:20:00',4.34),('14598','2013-08-31','14:25:00',4.32),('14598','2013-08-31','14:30:00',4.26),('14598','2013-08-31','14:35:00',4.22),('14598','2013-08-31','14:40:00',4.2),('14598','2013-08-31','14:45:00',4.22),('14598','2013-08-31','14:50:00',4.21),('14598','2013-08-31','14:55:00',4.16),('14598','2013-08-31','15:00:00',4.18),('14598','2013-08-31','15:05:00',4.15),('14598','2013-08-31','15:10:00',4.1),('14598','2013-08-31','15:15:00',4.1),('14598','2013-08-31','15:20:00',4.12),('14598','2013-08-31','15:25:00',4.12),('14598','2013-08-31','15:30:00',4.13),('14598','2013-08-31','15:35:00',4.07),('14598','2013-08-31','15:40:00',4.02),('14598','2013-08-31','15:45:00',3.98),('14598','2013-08-31','15:50:00',3.94),('14598','2013-08-31','15:55:00',3.79),('14598','2013-08-31','16:00:00',3.71),('14598','2013-08-31','16:05:00',3.69),('14598','2013-08-31','16:10:00',3.66),('14598','2013-08-31','16:15:00',3.65),('14598','2013-08-31','16:20:00',3.58),('14598','2013-08-31','16:25:00',3.53),('14598','2013-08-31','16:30:00',3.4),('14598','2013-08-31','16:35:00',3.36),('14598','2013-08-31','16:40:00',3.23),('14598','2013-08-31','16:45:00',3.2),('14598','2013-08-31','16:50:00',3.11),('14598','2013-08-31','16:55:00',3.04),('14598','2013-08-31','17:00:00',3.01),('14598','2013-08-31','17:05:00',2.92),('14598','2013-08-31','17:10:00',2.88),('14598','2013-08-31','17:15:00',2.72),('14598','2013-08-31','17:20:00',2.55),('14598','2013-08-31','17:25:00',2.52),('14598','2013-08-31','17:30:00',2.44),('14598','2013-08-31','17:35:00',2.28),('14598','2013-08-31','17:40:00',1.72),('14598','2013-08-31','17:45:00',1.72),('14598','2013-08-31','17:50:00',1.53),('14598','2013-08-31','17:55:00',1.74),('14598','2013-08-31','18:00:00',1.51),('14598','2013-08-31','18:05:00',1.38),('14598','2013-08-30','08:15:00',1),('14598','2013-08-30','08:20:00',1.05),('14598','2013-08-30','08:25:00',1.12),('14598','2013-08-30','08:30:00',1.23),('14598','2013-08-30','08:35:00',1.2),('14598','2013-08-30','08:40:00',1.13),('14598','2013-08-30','08:45:00',1.18),('14598','2013-08-30','08:50:00',1.35),('14598','2013-08-30','08:55:00',1.46),('14598','2013-08-30','09:00:00',1.37),('14598','2013-08-30','09:05:00',1.24),('14598','2013-08-30','09:10:00',1.13),('14598','2013-08-30','09:15:00',1.17),('14598','2013-08-30','09:20:00',1.43),('14598','2013-08-30','09:25:00',1.67),('14598','2013-08-30','09:30:00',1.74),('14598','2013-08-30','09:35:00',1.66),('14598','2013-08-30','09:40:00',1.81),('14598','2013-08-30','09:45:00',1.87),('14598','2013-08-30','09:50:00',1.83),('14598','2013-08-30','09:55:00',1.8),('14598','2013-08-30','10:00:00',1.89),('14598','2013-08-30','10:05:00',1.97),('14598','2013-08-30','10:10:00',1.96),('14598','2013-08-30','10:15:00',2.02),('14598','2013-08-30','10:20:00',2.26),('14598','2013-08-30','10:25:00',2.18),('14598','2013-08-30','10:30:00',2.13),('14598','2013-08-30','10:35:00',2.15),('14598','2013-08-30','10:40:00',2.23),('14598','2013-08-30','10:45:00',2.14),('14598','2013-08-30','10:50:00',2.18),('14598','2013-08-30','10:55:00',2.33),('14598','2013-08-30','11:00:00',2.55),('14598','2013-08-30','11:05:00',2.54),('14598','2013-08-30','11:10:00',2.52),('14598','2013-08-30','11:15:00',2.67),('14598','2013-08-30','11:20:00',2.86),('14598','2013-08-30','11:25:00',2.76),('14598','2013-08-30','11:30:00',2.84),('14598','2013-08-30','11:35:00',2.87),('14598','2013-08-30','11:40:00',3.03),('14598','2013-08-30','11:45:00',2.98),('14598','2013-08-30','11:50:00',2.71),('14598','2013-08-30','11:55:00',2.67),('14598','2013-08-30','12:00:00',3.15),('14598','2013-08-30','12:05:00',2.72),('14598','2013-08-30','12:10:00',3.14),('14598','2013-08-30','12:15:00',3.38),('14598','2013-08-30','12:20:00',3.44),('14598','2013-08-30','12:25:00',3.46),('14598','2013-08-30','12:30:00',3.44),('14598','2013-08-30','12:35:00',3.41),('14598','2013-08-30','12:40:00',3.24),('14598','2013-08-30','12:45:00',3.19),('14598','2013-08-30','12:50:00',3.1),('14598','2013-08-30','12:55:00',2.83),('14598','2013-08-30','13:00:00',2.9),('14598','2013-08-30','13:05:00',3.11),('14598','2013-08-30','13:10:00',3.2),('14598','2013-08-30','13:15:00',4.21),('14598','2013-08-30','13:20:00',4.46),('14598','2013-08-30','13:25:00',4.09),('14598','2013-08-30','13:30:00',3.96),('14598','2013-08-30','13:35:00',3.04),('14598','2013-08-30','13:40:00',2.94),('14598','2013-08-30','13:45:00',4.57),('14598','2013-08-30','13:50:00',4.44),('14598','2013-08-30','13:55:00',4.79),('14598','2013-08-30','14:00:00',4.74),('14598','2013-08-30','14:05:00',4.16),('14598','2013-08-30','14:10:00',4.46),('14598','2013-08-30','14:15:00',4.08),('14598','2013-08-30','14:20:00',4.04),('14598','2013-08-30','14:25:00',4.32),('14598','2013-08-30','14:30:00',4.11),('14598','2013-08-30','14:35:00',3.76),('14598','2013-08-30','14:40:00',3.45),('14598','2013-08-30','14:45:00',3.44),('14598','2013-08-30','14:50:00',4.14),('14598','2013-08-30','14:55:00',4.01),('14598','2013-08-30','15:00:00',3.47),('14598','2013-08-30','15:05:00',3.45),('14598','2013-08-30','15:10:00',3.46),('14598','2013-08-30','15:15:00',3.51),('14598','2013-08-30','15:20:00',3.43),('14598','2013-08-30','15:25:00',3.62),('14598','2013-08-30','15:30:00',3.59),('14598','2013-08-30','15:35:00',3.08),('14598','2013-08-30','15:40:00',2.79),('14598','2013-08-30','15:45:00',2.58),('14598','2013-08-30','15:50:00',2.54),('14598','2013-08-30','15:55:00',2.74),('14598','2013-08-30','16:00:00',2.88),('14598','2013-08-30','16:05:00',2.81),('14598','2013-08-30','16:10:00',2.56),('14598','2013-08-30','16:15:00',2.12),('14598','2013-08-30','16:20:00',2.4),('14598','2013-08-30','16:25:00',2.88),('14598','2013-08-30','16:30:00',2.95),('14598','2013-08-30','16:35:00',2.83),('14598','2013-08-30','16:40:00',2.94),('14598','2013-08-30','16:45:00',2.57),('14598','2013-08-30','16:50:00',2.16),('14598','2013-08-30','16:55:00',2.37),('14598','2013-08-30','17:00:00',2.7),('14598','2013-08-30','17:05:00',2.43),('14598','2013-08-30','17:10:00',2.29),('14598','2013-08-30','17:15:00',2.2),('14598','2013-08-30','17:20:00',2.03),('14598','2013-08-30','17:25:00',2.25),('14598','2013-08-30','17:30:00',2.53),('14598','2013-08-30','17:35:00',2.48),('14598','2013-08-30','17:40:00',2.01),('14598','2013-08-30','17:45:00',1.79),('14598','2013-08-30','17:50:00',1.72),('14598','2013-08-30','17:55:00',1.77),('14598','2013-08-30','18:00:00',1.21),('14598','2014-04-11','08:30:00',1.07),('14598','2014-04-11','08:45:00',1.4),('14598','2014-04-11','08:50:00',1.54),('14598','2014-04-11','08:55:00',1.66),('14598','2014-04-11','09:00:00',1.73),('14598','2014-04-11','09:05:00',1.73),('14598','2014-04-11','09:10:00',1.92),('14598','2014-04-11','09:15:00',2.04),('14598','2014-04-11','09:20:00',2.15),('14598','2014-04-11','09:25:00',2.12),('14598','2014-04-11','09:30:00',2.39),('14598','2014-04-11','09:35:00',2.5),('14598','2014-04-11','09:40:00',2.6),('14598','2014-04-11','09:45:00',2.71),('14598','2014-04-11','09:50:00',2.75),('14598','2014-04-11','09:55:00',2.78),('14598','2014-04-11','10:00:00',2.88),('14598','2014-04-11','10:05:00',3.03),('14598','2014-04-11','10:10:00',3.13),('14598','2014-04-11','10:15:00',3.19),('14598','2014-04-11','10:20:00',3.28),('14598','2014-04-11','10:25:00',3.38),('14598','2014-04-11','10:30:00',3.51),('14598','2014-04-11','10:35:00',3.23),('14598','2014-04-11','10:40:00',2.77),('14598','2014-04-11','10:45:00',2.13),('14598','2014-04-11','10:50:00',2.55),('14598','2014-04-11','10:55:00',3.85),('14598','2014-04-11','11:00:00',3.1),('14598','2014-04-11','11:05:00',2.74),('14598','2014-04-11','11:10:00',4.09),('14598','2014-04-11','11:15:00',3.52),('14598','2014-04-11','11:20:00',3.1),('14598','2014-04-11','11:25:00',3.01),('14598','2014-04-11','11:30:00',3.1),('14598','2014-04-11','11:35:00',4.66),('14598','2014-04-11','11:40:00',4.22),('14598','2014-04-11','11:45:00',4.38),('14598','2014-04-11','11:50:00',4.1),('14598','2014-04-11','11:55:00',3.46),('14598','2014-04-11','12:00:00',3.03),('14598','2014-04-11','12:05:00',5.09),('14598','2014-04-11','12:10:00',5.23),('14598','2014-04-11','12:15:00',3.52),('14598','2014-04-11','12:20:00',4.5),('14598','2014-04-11','12:25:00',4.58),('14598','2014-04-11','12:30:00',3.71),('14598','2014-04-11','12:35:00',4.47),('14598','2014-04-11','12:40:00',5.08),('14598','2014-04-11','12:45:00',5.47),('14598','2014-04-11','12:50:00',3.23),('14598','2014-04-11','12:55:00',2.41),('14598','2014-04-11','13:00:00',4),('14598','2014-04-11','13:05:00',4.74),('14598','2014-04-11','13:10:00',5.4),('14598','2014-04-11','13:15:00',5.17),('14598','2014-04-11','13:20:00',4.05),('14598','2014-04-11','13:25:00',2.46),('14598','2014-04-11','13:30:00',5.11),('14598','2014-04-11','13:35:00',5.78),('14598','2014-04-11','13:40:00',3.49),('14598','2014-04-11','13:45:00',2.97),('14598','2014-04-11','13:50:00',4.49),('14598','2014-04-11','13:55:00',3.3),('14598','2014-04-11','14:00:00',3.74),('14598','2014-04-11','14:05:00',2.21),('14598','2014-04-11','14:10:00',4.63),('14598','2014-04-11','14:15:00',3.92),('14598','2014-04-11','14:20:00',3.72),('14598','2014-04-11','14:25:00',1.85),('14598','2014-04-11','14:30:00',3.83),('14598','2014-04-11','14:35:00',2.2),('14598','2014-04-11','14:40:00',4.06),('14598','2014-04-11','14:45:00',5.8),('14598','2014-04-11','14:50:00',5.4),('14598','2014-04-11','14:55:00',5.36),('14598','2014-04-11','15:00:00',3.98),('14598','2014-04-11','15:05:00',4.51),('14598','2014-04-11','15:10:00',3.58),('14598','2014-04-11','15:15:00',2.53),('14598','2014-04-11','15:20:00',3.64),('14598','2014-04-11','15:25:00',2.32),('14598','2014-04-11','15:30:00',3.64),('14598','2014-04-11','15:35:00',1.94),('14598','2014-04-11','15:40:00',2.66),('14598','2014-04-11','15:45:00',3.75),('14598','2014-04-11','15:50:00',3.15),('14598','2014-04-11','15:55:00',3.48),('14598','2014-04-11','16:00:00',1.68),('14598','2014-04-11','16:05:00',1.65),('14598','2014-04-11','16:10:00',2.95),('14598','2014-04-11','16:15:00',3.15),('14598','2014-04-11','16:20:00',1.82),('14598','2014-04-11','16:25:00',2.3),('14598','2014-04-11','16:30:00',2.5),('14598','2014-04-11','16:35:00',1.33),('14598','2014-04-11','16:40:00',2.13),('14598','2014-04-11','16:45:00',1.22),('14598','2014-04-11','16:50:00',1.28),('14598','2014-04-11','16:55:00',2.47),('14598','2014-04-11','17:00:00',2.53),('14598','2014-04-11','17:05:00',2.54),('14598','2014-04-11','17:10:00',3.06),('14598','2014-04-11','17:15:00',1.87),('14598','2014-04-11','17:20:00',3.1),('14598','2014-04-11','17:25:00',1.54),('14598','2014-04-11','17:30:00',1.26),('14598','2014-04-11','17:35:00',1.11),('14598','2014-04-11','17:40:00',1.21),('14598','2014-04-11','17:45:00',1.25),('14598','2014-04-11','17:50:00',1.43),('14598','2014-04-11','17:55:00',1.05),('14598','2014-04-11','18:45:00',1.11),('14598','2013-08-29','08:20:00',1.17),('14598','2013-08-29','08:25:00',1.31),('14598','2013-08-29','08:30:00',1.15),('14598','2013-08-29','08:35:00',1.11),('14598','2013-08-29','08:40:00',1.17),('14598','2013-08-29','08:45:00',1.27),('14598','2013-08-29','08:50:00',1.36),('14598','2013-08-29','08:55:00',1.3),('14598','2013-08-29','09:00:00',1.32),('14598','2013-08-29','09:05:00',1.32),('14598','2013-08-29','09:10:00',1.39),('14598','2013-08-29','09:15:00',1.48),('14598','2013-08-29','09:20:00',1.53),('14598','2013-08-29','09:25:00',1.61),('14598','2013-08-29','09:30:00',1.58),('14598','2013-08-29','09:35:00',1.44),('14598','2013-08-29','09:40:00',1.36),('14598','2013-08-29','09:45:00',1.33),('14598','2013-08-29','09:50:00',1.34),('14598','2013-08-29','09:55:00',1.36),('14598','2013-08-29','10:00:00',1.35),('14598','2013-08-29','10:05:00',1.39),('14598','2013-08-29','10:10:00',1.48),('14598','2013-08-29','10:15:00',1.51),('14598','2013-08-29','10:20:00',1.46),('14598','2013-08-29','10:25:00',1.36),('14598','2013-08-29','10:30:00',1.27),('14598','2013-08-29','10:35:00',1.32),('14598','2013-08-29','10:40:00',1.5),('14598','2013-08-29','10:45:00',1.72),('14598','2013-08-29','10:50:00',1.67),('14598','2013-08-29','10:55:00',1.78),('14598','2013-08-29','11:00:00',1.85),('14598','2013-08-29','11:05:00',1.57),('14598','2013-08-29','11:10:00',1.38),('14598','2013-08-29','11:15:00',1.3),('14598','2013-08-29','11:20:00',1.33),('14598','2013-08-29','11:25:00',1.5),('14598','2013-08-29','11:30:00',1.73),('14598','2013-08-29','11:35:00',1.93),('14598','2013-08-29','11:40:00',2.12),('14598','2013-08-29','11:45:00',2.46),('14598','2013-08-29','11:50:00',2.75),('14598','2013-08-29','11:55:00',3.09),('14598','2013-08-29','12:00:00',2.72),('14598','2013-08-29','12:05:00',2.44),('14598','2013-08-29','12:10:00',2.32),('14598','2013-08-29','12:15:00',2.64),('14598','2013-08-29','12:20:00',4.73),('14598','2013-08-29','12:25:00',5.2),('14598','2013-08-29','12:30:00',5.53),('14598','2013-08-29','12:35:00',4.2),('14598','2013-08-29','12:40:00',3.51),('14598','2013-08-29','12:45:00',2.67),('14598','2013-08-29','12:50:00',2.37),('14598','2013-08-29','12:55:00',2.19),('14598','2013-08-29','13:00:00',2.19),('14598','2013-08-29','13:05:00',2.17),('14598','2013-08-29','13:10:00',1.95),('14598','2013-08-29','13:15:00',1.72),('14598','2013-08-29','13:20:00',1.69),('14598','2013-08-29','13:25:00',1.73),('14598','2013-08-29','13:30:00',1.83),('14598','2013-08-29','13:35:00',1.86),('14598','2013-08-29','13:40:00',2.19),('14598','2013-08-29','13:45:00',2.75),('14598','2013-08-29','13:50:00',2.49),('14598','2013-08-29','13:55:00',2.01),('14598','2013-08-29','14:00:00',1.41),('14598','2013-08-29','14:05:00',1.44),('14598','2013-08-29','14:10:00',1.38),('14598','2013-08-29','14:15:00',1.32),('14598','2013-08-29','14:20:00',1.39),('14598','2013-08-29','14:25:00',1.55),('14598','2013-08-29','14:30:00',1.59),('14598','2013-08-29','14:35:00',1.8),('14598','2013-08-29','14:40:00',3.08),('14598','2013-08-29','14:45:00',3.41),('14598','2013-08-29','14:50:00',3.36),('14598','2013-08-29','14:55:00',1.81),('14598','2013-08-29','15:00:00',1.85),('14598','2013-08-29','15:05:00',1.85),('14598','2013-08-29','15:10:00',2.18),('14598','2013-08-29','15:15:00',2.16),('14598','2013-08-29','15:20:00',2.15),('14598','2013-08-29','15:25:00',2.6),('14598','2013-08-29','15:30:00',2.86),('14598','2013-08-29','15:35:00',2.56),('14598','2013-08-29','15:40:00',3.2),('14598','2013-08-29','15:45:00',4.22),('14598','2013-08-29','15:50:00',4.49),('14598','2013-08-29','15:55:00',4.07),('14598','2013-08-29','16:00:00',3.93),('14598','2013-08-29','16:05:00',3.96),('14598','2013-08-29','16:10:00',3.86),('14598','2013-08-29','16:15:00',3.83),('14598','2013-08-29','16:20:00',3.77),('14598','2013-08-29','16:25:00',3.68),('14598','2013-08-29','16:30:00',3.6),('14598','2013-08-29','16:35:00',3.53),('14598','2013-08-29','16:40:00',3.46),('14598','2013-08-29','16:45:00',3.37),('14598','2013-08-29','16:50:00',3.28),('14598','2013-08-29','16:55:00',3.18),('14598','2013-08-29','17:00:00',3.07),('14598','2013-08-29','17:05:00',3.02),('14598','2013-08-29','17:10:00',2.92),('14598','2013-08-29','17:15:00',2.82),('14598','2013-08-29','17:20:00',2.72),('14598','2013-08-29','17:25:00',2.63),('14598','2013-08-29','17:30:00',2.53),('14598','2013-08-29','17:35:00',2.43),('14598','2013-08-29','17:40:00',2.33),('14598','2013-08-29','17:45:00',2.24),('14598','2013-08-29','17:50:00',2.14),('14598','2013-08-29','17:55:00',2.02),('14598','2013-08-29','18:00:00',1.92),('14598','2013-08-29','18:05:00',1.82),('14598','2013-08-29','18:10:00',1.71),('14598','2013-08-29','18:15:00',1.59),('14598','2013-08-29','18:20:00',1.49),('14598','2013-08-29','18:25:00',1.38),('14598','2013-08-29','18:30:00',1.28),('14598','2013-08-29','18:35:00',1.17),('14598','2013-08-29','18:40:00',1.05),('14598','2013-08-28','08:30:00',1.02),('14598','2013-08-28','08:35:00',1.16),('14598','2013-08-28','08:40:00',1.26),('14598','2013-08-28','08:45:00',1.37),('14598','2013-08-28','08:50:00',1.43),('14598','2013-08-28','08:55:00',1.54),('14598','2013-08-28','09:00:00',1.62),('14598','2013-08-28','09:05:00',1.78),('14598','2013-08-28','09:10:00',1.88),('14598','2013-08-28','09:15:00',2),('14598','2013-08-28','09:20:00',2.12),('14598','2013-08-28','09:25:00',2.23),('14598','2013-08-28','09:30:00',2.31),('14598','2013-08-28','09:35:00',2.4),('14598','2013-08-28','09:40:00',2.5),('14598','2013-08-28','09:45:00',2.58),('14598','2013-08-28','09:50:00',2.67),('14598','2013-08-28','09:55:00',2.75),('14598','2013-08-28','10:00:00',2.85),('14598','2013-08-28','10:05:00',2.93),('14598','2013-08-28','10:10:00',2.99),('14598','2013-08-28','10:15:00',3.08),('14598','2013-08-28','10:20:00',3.1),('14598','2013-08-28','10:25:00',3.18),('14598','2013-08-28','10:30:00',3.27),('14598','2013-08-28','10:35:00',3.33),('14598','2013-08-28','10:40:00',3.42),('14598','2013-08-28','10:45:00',2.81),('14598','2013-08-28','10:50:00',3.64),('14598','2013-08-28','10:55:00',3.71),('14598','2013-08-28','11:00:00',3.75),('14598','2013-08-28','11:05:00',3.81),('14598','2013-08-28','11:10:00',3.87),('14598','2013-08-28','11:15:00',3.94),('14598','2013-08-28','11:20:00',4),('14598','2013-08-28','11:25:00',4.05),('14598','2013-08-28','11:30:00',4.1),('14598','2013-08-28','11:35:00',4.18),('14598','2013-08-28','11:40:00',4.22),('14598','2013-08-28','11:45:00',4.27),('14598','2013-08-28','11:50:00',4.31),('14598','2013-08-28','11:55:00',4.37),('14598','2013-08-28','12:00:00',4.4),('14598','2013-08-28','12:05:00',4.42),('14598','2013-08-28','12:10:00',4.47),('14598','2013-08-28','12:15:00',4.51),('14598','2013-08-28','12:20:00',4.53),('14598','2013-08-28','12:25:00',4.56),('14598','2013-08-28','12:30:00',4.59),('14598','2013-08-28','12:35:00',4.6),('14598','2013-08-28','12:40:00',4.64),('14598','2013-08-28','12:45:00',4.11),('14598','2013-08-28','12:50:00',4.72),('14598','2013-08-28','12:55:00',4.62),('14598','2013-08-28','13:00:00',4.48),('14598','2013-08-28','13:05:00',4.81),('14598','2013-08-28','13:10:00',4.83),('14598','2013-08-28','13:15:00',4.88),('14598','2013-08-28','13:20:00',4.84),('14598','2013-08-28','13:25:00',4.58),('14598','2013-08-28','13:30:00',4.9),('14598','2013-08-28','13:35:00',4.87),('14598','2013-08-28','13:40:00',4.88),('14598','2013-08-28','13:45:00',4.87),('14598','2013-08-28','13:50:00',4.88),('14598','2013-08-28','13:55:00',4.88),('14598','2013-08-28','14:00:00',4.87),('14598','2013-08-28','14:05:00',4.87),('14598','2013-08-28','14:10:00',4.79),('14598','2013-08-28','14:15:00',4.85),('14598','2013-08-28','14:20:00',4.78),('14598','2013-08-28','14:25:00',4.81),('14598','2013-08-28','14:30:00',4.78),('14598','2013-08-28','14:35:00',4.78),('14598','2013-08-28','14:40:00',4.75),('14598','2013-08-28','14:45:00',4.73),('14598','2013-08-28','14:50:00',4.69),('14598','2013-08-28','14:55:00',4.65),('14598','2013-08-28','15:00:00',4.63),('14598','2013-08-28','15:05:00',4.61),('14598','2013-08-28','15:10:00',4.58),('14598','2013-08-28','15:15:00',4.52),('14598','2013-08-28','15:20:00',4.46),('14598','2013-08-28','15:25:00',4.42),('14598','2013-08-28','15:30:00',4.39),('14598','2013-08-28','15:35:00',4.35),('14598','2013-08-28','15:40:00',4.3),('14598','2013-08-28','15:45:00',4.26),('14598','2013-08-28','15:50:00',4.21),('14598','2013-08-28','15:55:00',4.18),('14598','2013-08-28','16:00:00',4.12),('14598','2013-08-28','16:05:00',4.04),('14598','2013-08-28','16:10:00',3.97),('14598','2013-08-28','16:15:00',3.88),('14598','2013-08-28','16:20:00',3.8),('14598','2013-08-28','16:25:00',3.48),('14598','2013-08-28','16:30:00',3.59),('14598','2013-08-28','16:35:00',3.75),('14598','2013-08-28','16:40:00',3.52),('14598','2013-08-28','16:45:00',3.45),('14598','2013-08-28','16:50:00',3.36),('14598','2013-08-28','16:55:00',3.3),('14598','2013-08-28','17:00:00',3.19),('14598','2013-08-28','17:05:00',3.1),('14598','2013-08-28','17:10:00',3.03),('14598','2013-08-28','17:15:00',2.97),('14598','2013-08-28','17:20:00',2.29),('14598','2013-08-28','17:25:00',3.01),('14598','2013-08-28','17:30:00',2.42),('14598','2013-08-28','17:35:00',1.84),('14598','2013-08-28','17:40:00',2.14),('14598','2013-08-28','17:45:00',2.71),('14598','2013-08-28','17:55:00',1.34),('14598','2013-08-28','18:00:00',2.32),('14598','2013-08-28','18:05:00',1.21),('14598','2013-08-28','18:10:00',1.38),('14598','2013-08-28','18:15:00',1.9),('14598','2013-08-28','18:20:00',1.63),('14598','2013-08-28','18:30:00',1.26),('14598','2013-08-28','18:35:00',1.32),('14598','2013-08-28','18:45:00',1.03),('14598','2013-08-27','08:45:00',1.06),('14598','2013-08-27','08:50:00',1.32),('14598','2013-08-27','08:55:00',1.35),('14598','2013-08-27','09:00:00',1.48),('14598','2013-08-27','09:05:00',1.58),('14598','2013-08-27','09:10:00',1.87),('14598','2013-08-27','09:15:00',1.98),('14598','2013-08-27','09:20:00',2.09),('14598','2013-08-27','09:25:00',2.1),('14598','2013-08-27','09:30:00',1.81),('14598','2013-08-27','09:35:00',1.56),('14598','2013-08-27','09:40:00',1.73),('14598','2013-08-27','09:45:00',2.29),('14598','2013-08-27','09:50:00',2.64),('14598','2013-08-27','09:55:00',2.73),('14598','2013-08-27','10:00:00',2.75),('14598','2013-08-27','10:05:00',2.01),('14598','2013-08-27','10:10:00',2.84),('14598','2013-08-27','10:15:00',2.97),('14598','2013-08-27','10:20:00',3.03),('14598','2013-08-27','10:25:00',3.13),('14598','2013-08-27','10:30:00',3.17),('14598','2013-08-27','10:35:00',3.24),('14598','2013-08-27','10:40:00',3.26),('14598','2013-08-27','10:45:00',3.35),('14598','2013-08-27','10:50:00',3.4),('14598','2013-08-27','10:55:00',3.49),('14598','2013-08-27','11:00:00',3.55),('14598','2013-08-27','11:05:00',3.53),('14598','2013-08-27','11:10:00',3.66),('14598','2013-08-27','11:15:00',3.73),('14598','2013-08-27','11:20:00',3.76),('14598','2013-08-27','11:25:00',3.93),('14598','2013-08-27','11:30:00',3.99),('14598','2013-08-27','11:35:00',2.91),('14598','2013-08-27','11:40:00',4.18),('14598','2013-08-27','11:45:00',4.27),('14598','2013-08-27','11:50:00',4.52),('14598','2013-08-27','11:55:00',3.38),('14598','2013-08-27','12:00:00',4.66),('14598','2013-08-27','12:05:00',4.33),('14598','2013-08-27','12:10:00',3.44),('14598','2013-08-27','12:15:00',2.43),('14598','2013-08-27','12:20:00',3.5),('14598','2013-08-27','12:25:00',4.4),('14598','2013-08-27','12:30:00',4.02),('14598','2013-08-27','12:35:00',3.15),('14598','2013-08-27','12:40:00',2.32),('14598','2013-08-27','12:45:00',1.89),('14598','2013-08-27','12:50:00',1.91),('14598','2013-08-27','12:55:00',2.03),('14598','2013-08-27','13:00:00',2.62),('14598','2013-08-27','13:05:00',2.64),('14598','2013-08-27','13:10:00',2.98),('14598','2013-08-27','13:15:00',3.09),('14598','2013-08-27','13:20:00',2.17),('14598','2013-08-27','13:25:00',1.74),('14598','2013-08-27','13:30:00',2.19),('14598','2013-08-27','13:35:00',2.25),('14598','2013-08-27','13:40:00',2.37),('14598','2013-08-27','13:45:00',2.53),('14598','2013-08-27','13:50:00',3.7),('14598','2013-08-27','13:55:00',4.67),('14598','2013-08-27','14:00:00',3.45),('14598','2013-08-27','14:05:00',2.74),('14598','2013-08-27','14:10:00',2.18),('14598','2013-08-27','14:15:00',1.76),('14598','2013-08-27','14:20:00',1.51),('14598','2013-08-27','14:25:00',1.27),('14598','2013-08-27','15:40:00',2.18),('14598','2013-08-27','15:45:00',2.54),('14598','2013-08-27','15:50:00',2.16),('14598','2013-08-27','15:55:00',3.11),('14598','2013-08-27','16:00:00',4.4),('14598','2013-08-27','16:05:00',4.35),('14598','2013-08-27','16:10:00',4.19),('14598','2013-08-27','16:15:00',3.81),('14598','2013-08-27','16:20:00',3.7),('14598','2013-08-27','16:25:00',3.57),('14598','2013-08-27','16:30:00',1.77),('14598','2013-08-27','16:35:00',3),('14598','2013-08-27','16:40:00',2.06),('14598','2013-08-27','16:45:00',1.36),('14598','2013-08-27','16:50:00',1.24),('14598','2013-08-27','17:00:00',1.02),('14598','2013-08-27','17:30:00',1.13),('14598','2013-08-27','17:35:00',2.69),('14598','2013-08-27','17:40:00',2.21),('14598','2013-08-27','17:45:00',1.08),('14598','2013-08-26','08:30:00',1.06),('14598','2013-08-26','08:35:00',1.16),('14598','2013-08-26','08:40:00',1.27),('14598','2013-08-26','08:45:00',1.37),('14598','2013-08-26','08:50:00',1.45),('14598','2013-08-26','08:55:00',1.54),('14598','2013-08-26','09:00:00',1.65),('14598','2013-08-26','09:05:00',1.77),('14598','2013-08-26','09:10:00',1.88),('14598','2013-08-26','09:15:00',1.99),('14598','2013-08-26','09:20:00',2.09),('14598','2013-08-26','09:25:00',2.18),('14598','2013-08-26','09:30:00',2.26),('14598','2013-08-26','09:35:00',2.35),('14598','2013-08-26','09:40:00',2.45),('14598','2013-08-26','09:45:00',2.53),('14598','2013-08-26','09:50:00',2.62),('14598','2013-08-26','09:55:00',2.7),('14598','2013-08-26','10:00:00',2.78),('14598','2013-08-26','10:05:00',2.86),('14598','2013-08-26','10:10:00',2.95),('14598','2013-08-26','10:15:00',3.01),('14598','2013-08-26','10:20:00',3.07),('14598','2013-08-26','10:25:00',3.06),('14598','2013-08-26','10:30:00',3.21),('14598','2013-08-26','10:35:00',3.3),('14598','2013-08-26','10:40:00',3.35),('14598','2013-08-26','10:45:00',3.44),('14598','2013-08-26','10:50:00',3.53),('14598','2013-08-26','10:55:00',3.6),('14598','2013-08-26','11:00:00',3.65),('14598','2013-08-26','11:05:00',3.74),('14598','2013-08-26','11:10:00',3.8),('14598','2013-08-26','11:15:00',3.85),('14598','2013-08-26','11:20:00',3.91),('14598','2013-08-26','11:25:00',3.93),('14598','2013-08-26','11:30:00',3.96),('14598','2013-08-26','11:35:00',3.99),('14598','2013-08-26','11:40:00',4.03),('14598','2013-08-26','11:45:00',4.06),('14598','2013-08-26','11:50:00',4.12),('14598','2013-08-26','11:55:00',4.13),('14598','2013-08-26','12:00:00',4.15),('14598','2013-08-26','12:05:00',4.16),('14598','2013-08-26','12:10:00',4.14),('14598','2013-08-26','12:15:00',3.17),('14598','2013-08-26','12:20:00',3.38),('14598','2013-08-26','12:25:00',3.19),('14598','2013-08-26','12:30:00',2.89),('14598','2013-08-26','12:35:00',4.35),('14598','2013-08-26','12:40:00',4.17),('14598','2013-08-26','12:45:00',3.84),('14598','2013-08-26','12:50:00',2.55),('14598','2013-08-26','12:55:00',2.2),('14598','2013-08-26','13:00:00',2.41),('14598','2013-08-26','13:05:00',2.8),('14598','2013-08-26','13:10:00',2.73),('14598','2013-08-26','13:15:00',2.77),('14598','2013-08-26','13:20:00',3.11),('14598','2013-08-26','13:25:00',3.43),('14598','2013-08-26','13:30:00',4.19),('14598','2013-08-26','13:35:00',4.02),('14598','2013-08-26','13:40:00',3.92),('14598','2013-08-26','13:45:00',3.37),('14598','2013-08-26','13:50:00',4.91),('14598','2013-08-26','13:55:00',4.18),('14598','2013-08-26','14:00:00',4.63),('14598','2013-08-26','14:05:00',4.12),('14598','2013-08-26','14:10:00',4.36),('14598','2013-08-26','14:15:00',4.72),('14598','2013-08-26','14:20:00',4.57),('14598','2013-08-26','14:25:00',4.53),('14598','2013-08-26','14:30:00',4.11),('14598','2013-08-26','14:35:00',2.95),('14598','2013-08-26','14:40:00',3.91),('14598','2013-08-26','14:45:00',2.33),('14598','2013-08-26','14:50:00',2.56),('14598','2013-08-26','14:55:00',1.58),('14598','2013-08-26','15:00:00',1.2),('14598','2013-08-26','15:15:00',1.07),('14598','2013-08-26','15:20:00',1.1),('14598','2013-08-26','15:25:00',1.13),('14598','2013-08-26','15:30:00',1.84),('14598','2013-08-26','15:35:00',1.37),('14598','2013-08-26','15:40:00',1.66),('14598','2013-08-26','15:45:00',1.78),('14598','2013-08-26','15:50:00',2.31),('14598','2013-08-26','15:55:00',4.42),('14598','2013-08-26','16:00:00',3.95),('14598','2013-08-26','16:05:00',3.74),('14598','2013-08-26','16:10:00',3.3),('14598','2013-08-26','16:15:00',3.41),('14598','2013-08-26','16:20:00',3.51),('14598','2013-08-26','16:25:00',3.22),('14598','2013-08-26','16:30:00',2.49),('14598','2013-08-26','16:35:00',3.26),('14598','2013-08-26','16:40:00',3.2),('14598','2013-08-26','16:45:00',3.11),('14598','2013-08-26','16:50:00',2.91),('14598','2013-08-26','16:55:00',2.6),('14598','2013-08-26','17:00:00',2.91),('14598','2013-08-26','17:05:00',2.79),('14598','2013-08-26','17:10:00',2.43),('14598','2013-08-26','17:15:00',1.33),('14598','2013-08-26','17:20:00',2.04),('14598','2013-08-26','17:25:00',1.58),('14598','2013-08-26','17:30:00',1.28),('14598','2013-08-26','17:35:00',2.35),('14598','2013-08-26','17:40:00',2.5),('14598','2013-08-26','17:45:00',2.14),('14598','2013-08-26','17:50:00',1.99),('14598','2013-08-26','17:55:00',1.83),('14598','2013-08-26','18:00:00',1.7),('14598','2013-08-26','18:05:00',1.61),('14598','2013-08-26','18:10:00',1.51),('14598','2013-08-26','18:15:00',1.42),('14598','2013-08-26','18:20:00',1.3),('14598','2013-08-26','18:25:00',1.2),('14598','2013-08-26','18:30:00',1.1),('14598','2013-08-25','08:50:00',1.3),('14598','2013-08-25','08:55:00',1.92),('14598','2013-08-25','09:00:00',1.93),('14598','2013-08-25','09:05:00',2.19),('14598','2013-08-25','09:10:00',1.41),('14598','2013-08-25','09:15:00',1.18),('14598','2013-08-25','09:20:00',1.21),('14598','2013-08-25','09:25:00',1.2),('14598','2013-08-25','09:30:00',1.04),('14598','2013-08-25','09:35:00',1.63),('14598','2013-08-25','09:40:00',2.08),('14598','2013-08-25','09:45:00',1.55),('14598','2013-08-25','14:50:00',1.13),('14598','2013-08-25','14:55:00',1.36),('14598','2013-08-25','15:00:00',1.46),('14598','2013-08-25','15:05:00',1.62),('14598','2013-08-25','15:10:00',1.99),('14598','2013-08-25','15:15:00',2.92),('14598','2013-08-25','15:20:00',4.67),('14598','2013-08-25','15:25:00',4.73),('14598','2013-08-25','15:30:00',4.28),('14598','2013-08-25','15:35:00',2.37),('14598','2013-08-25','15:40:00',3.65),('14598','2013-08-25','15:45:00',2.68),('14598','2013-08-25','15:50:00',3.39),('14598','2013-08-25','15:55:00',4.41),('14598','2013-08-25','16:00:00',4.06),('14598','2013-08-25','16:05:00',3.89),('14598','2013-08-25','16:10:00',3.78),('14598','2013-08-25','16:15:00',3.68),('14598','2013-08-25','16:20:00',3.66),('14598','2013-08-25','16:25:00',3.52),('14598','2013-08-25','16:30:00',2.34),('14598','2013-08-25','16:35:00',1.91),('14598','2013-08-25','16:40:00',2.98),('14598','2013-08-25','16:45:00',3.71),('14598','2013-08-25','16:50:00',3.47),('14598','2013-08-25','16:55:00',3.33),('14598','2013-08-25','17:00:00',3.21),('14598','2013-08-25','17:05:00',2.98),('14598','2013-08-25','17:10:00',2.9),('14598','2013-08-25','17:15:00',2.77),('14598','2013-08-25','17:20:00',2.68),('14598','2013-08-25','17:25:00',2.25),('14598','2013-08-25','17:30:00',2.16),('14598','2013-08-25','17:35:00',2.24),('14598','2013-08-25','17:40:00',1.48),('14598','2013-08-25','17:50:00',1.34),('14598','2013-08-25','17:55:00',1.28),('14598','2013-08-25','18:00:00',1.51),('14598','2013-08-25','18:05:00',1.71),('14598','2013-08-25','18:10:00',1.73),('14598','2013-08-25','18:15:00',1.29),('14598','2013-08-25','18:20:00',1.17),('14598','2013-08-24','08:30:00',1.01),('14598','2013-08-24','08:35:00',1.09),('14598','2013-08-24','08:40:00',1.19),('14598','2013-08-24','08:45:00',1.28),('14598','2013-08-24','08:50:00',1.36),('14598','2013-08-24','08:55:00',1.41),('14598','2013-08-24','09:00:00',1.53),('14598','2013-08-24','09:05:00',1.65),('14598','2013-08-24','09:10:00',1.74),('14598','2013-08-24','09:15:00',1.87),('14598','2013-08-24','09:20:00',1.97),('14598','2013-08-24','09:25:00',2.04),('14598','2013-08-24','09:30:00',2.13),('14598','2013-08-24','09:35:00',2.21),('14598','2013-08-24','09:40:00',2.29),('14598','2013-08-24','09:45:00',2.34),('14598','2013-08-24','09:50:00',2.39),('14598','2013-08-24','09:55:00',2.49),('14598','2013-08-24','10:00:00',2.65),('14598','2013-08-24','10:05:00',2.73),('14598','2013-08-24','10:10:00',2.78),('14598','2013-08-24','10:15:00',2.89),('14598','2013-08-24','10:20:00',2.93),('14598','2013-08-24','10:25:00',3.03),('14598','2013-08-24','10:30:00',3.11),('14598','2013-08-24','10:35:00',3.2),('14598','2013-08-24','10:40:00',3.27),('14598','2013-08-24','10:45:00',3.33),('14598','2013-08-24','10:50:00',3.4),('14598','2013-08-24','10:55:00',3.48),('14598','2013-08-24','11:00:00',3.54),('14598','2013-08-24','11:05:00',3.59),('14598','2013-08-24','11:10:00',3.64),('14598','2013-08-24','11:15:00',3.72),('14598','2013-08-24','11:20:00',3.77),('14598','2013-08-24','11:25:00',3.8),('14598','2013-08-24','11:30:00',1.29),('14598','2013-08-24','11:35:00',3.89),('14598','2013-08-24','11:40:00',3.95),('14598','2013-08-24','11:45:00',4.04),('14598','2013-08-24','11:50:00',4.08),('14598','2013-08-24','11:55:00',4.13),('14598','2013-08-24','12:00:00',4.16),('14598','2013-08-24','12:05:00',4.18),('14598','2013-08-24','12:10:00',4.21),('14598','2013-08-24','12:15:00',4.27),('14598','2013-08-24','12:20:00',4.29),('14598','2013-08-24','12:25:00',4.3),('14598','2013-08-24','12:30:00',4.36),('14598','2013-08-24','12:35:00',4.38),('14598','2013-08-24','12:40:00',4.4),('14598','2013-08-24','12:45:00',4.42),('14598','2013-08-24','12:50:00',4.42),('14598','2013-08-24','12:55:00',4.45),('14598','2013-08-24','13:00:00',4.45),('14598','2013-08-24','13:05:00',4.48),('14598','2013-08-24','13:10:00',4.5),('14598','2013-08-24','13:15:00',4.53),('14598','2013-08-24','13:20:00',4.54),('14598','2013-08-24','13:25:00',4.53),('14598','2013-08-24','13:30:00',4.53),('14598','2013-08-24','13:35:00',4.53),('14598','2013-08-24','13:40:00',4.54),('14598','2013-08-24','13:45:00',4.52),('14598','2013-08-24','13:50:00',4.55),('14598','2013-08-24','13:55:00',4.54),('14598','2013-08-24','14:00:00',4.54),('14598','2013-08-24','14:05:00',4.51),('14598','2013-08-24','14:10:00',4.5),('14598','2013-08-24','14:15:00',4.48),('14598','2013-08-24','14:20:00',4.5),('14598','2013-08-24','14:25:00',4.49),('14598','2013-08-24','14:30:00',4.47),('14598','2013-08-24','14:35:00',4.45),('14598','2013-08-24','14:40:00',4.44),('14598','2013-08-24','14:45:00',4.42),('14598','2013-08-24','14:50:00',4.39),('14598','2013-08-24','14:55:00',4.33),('14598','2013-08-24','15:00:00',4.3),('14598','2013-08-24','15:05:00',4.3),('14598','2013-08-24','15:10:00',4.29),('14598','2013-08-24','15:15:00',4.25),('14598','2013-08-24','15:20:00',4.21),('14598','2013-08-24','15:25:00',4.15),('14598','2013-08-24','15:30:00',4.09),('14598','2013-08-24','15:35:00',4.08),('14598','2013-08-24','15:40:00',4.05),('14598','2013-08-24','15:45:00',4.01),('14598','2013-08-24','15:50:00',3.97),('14598','2013-08-24','15:55:00',3.9),('14598','2013-08-24','16:00:00',3.83),('14598','2013-08-24','16:05:00',3.79),('14598','2013-08-24','16:10:00',3.73),('14598','2013-08-24','16:15:00',3.67),('14598','2013-08-24','16:20:00',3.61),('14598','2013-08-24','16:25:00',3.55),('14598','2013-08-24','16:30:00',3.48),('14598','2013-08-24','16:35:00',3.4),('14598','2013-08-24','16:40:00',3.33),('14598','2013-08-24','16:45:00',3.22),('14598','2013-08-24','16:50:00',3.12),('14598','2013-08-24','16:55:00',3.1),('14598','2013-08-24','17:00:00',3.02),('14598','2013-08-24','17:05:00',2.96),('14598','2013-08-24','17:10:00',2.87),('14598','2013-08-24','17:15:00',2.77),('14598','2013-08-24','17:20:00',2.7),('14598','2013-08-24','17:25:00',2.6),('14598','2013-08-24','17:30:00',2.51),('14598','2013-08-24','17:35:00',2.42),('14598','2013-08-24','17:40:00',2.32),('14598','2013-08-24','17:45:00',2.22),('14598','2013-08-24','17:50:00',2.12),('14598','2013-08-24','17:55:00',2.03),('14598','2013-08-24','18:00:00',1.93),('14598','2013-08-24','18:05:00',1.82),('14598','2013-08-24','18:10:00',1.72),('14598','2013-08-24','18:15:00',1.62),('14598','2013-08-24','18:20:00',1.52),('14598','2013-08-24','18:25:00',1.41),('14598','2013-08-24','18:30:00',1.31),('14598','2013-08-24','18:35:00',1.2),('14598','2013-08-24','18:40:00',1.09),('14598','2013-08-23','08:20:00',1.03),('14598','2013-08-23','08:30:00',1.04),('14598','2013-08-23','08:35:00',1.07),('14598','2013-08-23','08:40:00',1.16),('14598','2013-08-23','08:45:00',1.22),('14598','2013-08-23','08:50:00',1.32),('14598','2013-08-23','08:55:00',1.39),('14598','2013-08-23','09:00:00',1.48),('14598','2013-08-23','09:05:00',1.59),('14598','2013-08-23','09:10:00',1.71),('14598','2013-08-23','09:15:00',1.81),('14598','2013-08-23','09:20:00',1.89),('14598','2013-08-23','09:25:00',1.97),('14598','2013-08-23','09:30:00',2.04),('14598','2013-08-23','09:35:00',2.13),('14598','2013-08-23','09:40:00',2.22),('14598','2013-08-23','09:45:00',2.27),('14598','2013-08-23','09:50:00',2.35),('14598','2013-08-23','09:55:00',2.4),('14598','2013-08-23','10:00:00',2.52),('14598','2013-08-23','10:05:00',2.53),('14598','2013-08-23','10:10:00',2.63),('14598','2013-08-23','10:15:00',2.69),('14598','2013-08-23','10:20:00',2.79),('14598','2013-08-23','10:25:00',2.97),('14598','2013-08-23','10:30:00',3.04),('14598','2013-08-23','10:35:00',3.13),('14598','2013-08-23','10:40:00',3.21),('14598','2013-08-23','10:45:00',3.27),('14598','2013-08-23','10:50:00',3.34),('14598','2013-08-23','10:55:00',3.41),('14598','2013-08-23','11:00:00',3.47),('14598','2013-08-23','11:05:00',3.54),('14598','2013-08-23','11:10:00',3.54),('14598','2013-08-23','11:15:00',3.64),('14598','2013-08-23','11:20:00',3.69),('14598','2013-08-23','11:25:00',3.76),('14598','2013-08-23','11:30:00',3.82),('14598','2013-08-23','11:35:00',3.87),('14598','2013-08-23','11:40:00',3.91),('14598','2013-08-23','11:45:00',3.95),('14598','2013-08-23','11:50:00',4.01),('14598','2013-08-23','11:55:00',4.06),('14598','2013-08-23','12:00:00',4.11),('14598','2013-08-23','12:05:00',4.15),('14598','2013-08-23','12:10:00',4.19),('14598','2013-08-23','12:15:00',4.24),('14598','2013-08-23','12:20:00',4.27),('14598','2013-08-23','12:25:00',4.3),('14598','2013-08-23','12:30:00',4.3),('14598','2013-08-23','12:35:00',4.34),('14598','2013-08-23','12:40:00',4.38),('14598','2013-08-23','12:45:00',4.41),('14598','2013-08-23','12:50:00',4.43),('14598','2013-08-23','12:55:00',4.45),('14598','2013-08-23','13:00:00',4.44),('14598','2013-08-23','13:05:00',4.49),('14598','2013-08-23','13:10:00',4.51),('14598','2013-08-23','13:15:00',4.53),('14598','2013-08-23','13:20:00',4.53),('14598','2013-08-23','13:25:00',4.54),('14598','2013-08-23','13:30:00',4.53),('14598','2013-08-23','13:35:00',4.55),('14598','2013-08-23','13:40:00',4.57),('14598','2013-08-23','13:45:00',4.57),('14598','2013-08-23','13:50:00',4.57),('14598','2013-08-23','13:55:00',4.58),('14598','2013-08-23','14:00:00',4.56),('14598','2013-08-23','14:05:00',4.53),('14598','2013-08-23','14:10:00',4.47),('14598','2013-08-23','14:15:00',4.52),('14598','2013-08-23','14:20:00',4.47),('14598','2013-08-23','14:25:00',4.39),('14598','2013-08-23','14:30:00',4.52),('14598','2013-08-23','14:35:00',4.36),('14598','2013-08-23','14:40:00',4.36),('14598','2013-08-23','14:45:00',4.21),('14598','2013-08-23','14:50:00',4.32),('14598','2013-08-23','14:55:00',4.19),('14598','2013-08-23','15:00:00',4.22),('14598','2013-08-23','15:05:00',4.13),('14598','2013-08-23','15:10:00',4.34),('14598','2013-08-23','15:15:00',4.12),('14598','2013-08-23','15:20:00',3.96),('14598','2013-08-23','15:25:00',3.93),('14598','2013-08-23','15:30:00',3.69),('14598','2013-08-23','15:35:00',4.03),('14598','2013-08-23','15:40:00',3.81),('14598','2013-08-23','15:45:00',3.6),('14598','2013-08-23','15:50:00',3.46),('14598','2013-08-23','15:55:00',3.97),('14598','2013-08-23','16:00:00',3.91),('14598','2013-08-23','16:05:00',3.89),('14598','2013-08-23','16:10:00',3.82),('14598','2013-08-23','16:15:00',3.77),('14598','2013-08-23','16:20:00',3.65),('14598','2013-08-23','16:25:00',3.54),('14598','2013-08-23','16:30:00',3.48),('14598','2013-08-23','16:35:00',3.4),('14598','2013-08-23','16:40:00',3.33),('14598','2013-08-23','16:45:00',3.2),('14598','2013-08-23','16:50:00',3.12),('14598','2013-08-23','16:55:00',3.02),('14598','2013-08-23','17:00:00',2.98),('14598','2013-08-23','17:05:00',2.93),('14598','2013-08-23','17:10:00',2.86),('14598','2013-08-23','17:15:00',2.79),('14598','2013-08-23','17:20:00',2.7),('14598','2013-08-23','17:25:00',2.61),('14598','2013-08-23','17:30:00',2.52),('14598','2013-08-23','17:35:00',2.44),('14598','2013-08-23','17:40:00',2.37),('14598','2013-08-23','17:45:00',2.23),('14598','2013-08-23','17:50:00',2),('14598','2013-08-23','17:55:00',1.49),('14598','2013-08-23','18:00:00',1.91),('14598','2013-08-23','18:05:00',1.88),('14598','2013-08-23','18:10:00',1.74),('14598','2013-08-23','18:15:00',1.63),('14598','2013-08-23','18:20:00',1.5),('14598','2013-08-23','18:25:00',1.4),('14598','2013-08-23','18:30:00',1.26),('14598','2013-08-23','18:35:00',1.2),('14598','2013-08-23','18:40:00',1.1),('14598','2013-08-22','08:25:00',1.04),('14598','2013-08-22','08:30:00',1.14),('14598','2013-08-22','08:35:00',1.23),('14598','2013-08-22','08:40:00',1.28),('14598','2013-08-22','08:45:00',1.3),('14598','2013-08-22','08:50:00',1.36),('14598','2013-08-22','08:55:00',1.45),('14598','2013-08-22','09:00:00',1.55),('14598','2013-08-22','09:05:00',1.68),('14598','2013-08-22','09:10:00',1.81),('14598','2013-08-22','09:15:00',1.91),('14598','2013-08-22','09:20:00',1.99),('14598','2013-08-22','09:25:00',2.1),('14598','2013-08-22','09:30:00',2.16),('14598','2013-08-22','09:35:00',2.24),('14598','2013-08-22','09:40:00',2.31),('14598','2013-08-22','09:45:00',2.43),('14598','2013-08-22','09:50:00',2.52),('14598','2013-08-22','09:55:00',2.59),('14598','2013-08-22','10:00:00',2.66),('14598','2013-08-22','10:05:00',2.7),('14598','2013-08-22','10:10:00',2.36),('14598','2013-08-22','10:15:00',2.89),('14598','2013-08-22','10:20:00',2.93),('14598','2013-08-22','10:25:00',3),('14598','2013-08-22','10:30:00',3.09),('14598','2013-08-22','10:35:00',3.18),('14598','2013-08-22','10:40:00',3.24),('14598','2013-08-22','10:45:00',3.28),('14598','2013-08-22','10:50:00',3.36),('14598','2013-08-22','10:55:00',3.36),('14598','2013-08-22','11:00:00',3.49),('14598','2013-08-22','11:05:00',3.54),('14598','2013-08-22','11:10:00',3.58),('14598','2013-08-22','11:15:00',3.64),('14598','2013-08-22','11:20:00',3.69),('14598','2013-08-22','11:25:00',3.73),('14598','2013-08-22','11:30:00',3.76),('14598','2013-08-22','11:35:00',3.8),('14598','2013-08-22','11:40:00',3.84),('14598','2013-08-22','11:45:00',3.86),('14598','2013-08-22','11:50:00',3.88),('14598','2013-08-22','11:55:00',3.94),('14598','2013-08-22','12:00:00',3.95),('14598','2013-08-22','12:05:00',4),('14598','2013-08-22','12:10:00',3.94),('14598','2013-08-22','12:15:00',4.02),('14598','2013-08-22','12:20:00',4.06),('14598','2013-08-22','12:25:00',4.11),('14598','2013-08-22','12:30:00',4.07),('14598','2013-08-22','12:35:00',4.09),('14598','2013-08-22','12:40:00',4.14),('14598','2013-08-22','12:45:00',4.2),('14598','2013-08-22','12:50:00',4.22),('14598','2013-08-22','12:55:00',4.24),('14598','2013-08-22','13:00:00',4.14),('14598','2013-08-22','13:05:00',4.15),('14598','2013-08-22','13:10:00',4.15),('14598','2013-08-22','13:15:00',4.18),('14598','2013-08-22','13:20:00',4.22),('14598','2013-08-22','13:25:00',4.23),('14598','2013-08-22','13:30:00',4.22),('14598','2013-08-22','13:35:00',4.25),('14598','2013-08-22','13:40:00',4.28),('14598','2013-08-22','13:45:00',4.31),('14598','2013-08-22','13:50:00',4.38),('14598','2013-08-22','13:55:00',4.36),('14598','2013-08-22','14:00:00',4.39),('14598','2013-08-22','14:05:00',4.41),('14598','2013-08-22','14:10:00',4.42),('14598','2013-08-22','14:15:00',4.42),('14598','2013-08-22','14:20:00',4.39),('14598','2013-08-22','14:25:00',4.41),('14598','2013-08-22','14:30:00',4.41),('14598','2013-08-22','14:35:00',4.37),('14598','2013-08-22','14:40:00',4.33),('14598','2013-08-22','14:45:00',4.32),('14598','2013-08-22','14:50:00',4.27),('14598','2013-08-22','14:55:00',4.24),('14598','2013-08-22','15:00:00',4.21),('14598','2013-08-22','15:05:00',4.19),('14598','2013-08-22','15:10:00',4.15),('14598','2013-08-22','15:15:00',4.14),('14598','2013-08-22','15:20:00',4.1),('14598','2013-08-22','15:25:00',4.07),('14598','2013-08-22','15:30:00',4.01),('14598','2013-08-22','15:35:00',3.97),('14598','2013-08-22','15:40:00',3.86),('14598','2013-08-22','15:45:00',3.87),('14598','2013-08-22','15:50:00',3.83),('14598','2013-08-22','15:55:00',3.76),('14598','2013-08-22','16:00:00',3.68),('14598','2013-08-22','16:05:00',3.61),('14598','2013-08-22','16:10:00',3.56),('14598','2013-08-22','16:15:00',3.51),('14598','2013-08-22','16:20:00',3.46),('14598','2013-08-22','16:25:00',3.38),('14598','2013-08-22','16:30:00',3.32),('14598','2013-08-22','16:35:00',3.24),('14598','2013-08-22','16:40:00',3.16),('14598','2013-08-22','16:45:00',3.07),('14598','2013-08-22','16:50:00',3),('14598','2013-08-22','16:55:00',2.92),('14598','2013-08-22','17:00:00',2.81),('14598','2013-08-22','17:05:00',2.77),('14598','2013-08-22','17:10:00',2.69),('14598','2013-08-22','17:15:00',2.58),('14598','2013-08-22','17:20:00',2.51),('14598','2013-08-22','17:25:00',2.43),('14598','2013-08-22','17:30:00',2.33),('14598','2013-08-22','17:35:00',2.24),('14598','2013-08-22','17:40:00',2.15),('14598','2013-08-22','17:45:00',2.06),('14598','2013-08-22','17:50:00',1.97),('14598','2013-08-22','17:55:00',1.87),('14598','2013-08-22','18:00:00',1.78),('14598','2013-08-22','18:05:00',1.67),('14598','2013-08-22','18:10:00',1.57),('14598','2013-08-22','18:15:00',1.47),('14598','2013-08-22','18:20:00',1.4),('14598','2013-08-22','18:25:00',1.25),('14598','2013-08-22','18:30:00',1.11),('14598','2013-08-22','18:35:00',1.06),('14598','2013-08-22','18:40:00',1),('14598','2013-08-21','08:50:00',1.19),('14598','2013-08-21','08:55:00',1.36),('14598','2013-08-21','09:00:00',1.22),('14598','2013-08-21','09:05:00',1.12),('14598','2013-08-21','09:25:00',1.12),('14598','2013-08-21','09:30:00',2.13),('14598','2013-08-21','09:35:00',2.21),('14598','2013-08-21','09:40:00',2.19),('14598','2013-08-21','09:45:00',1.65),('14598','2013-08-21','09:50:00',1.01),('14598','2013-08-21','09:55:00',2.16),('14598','2013-08-21','10:00:00',2.23),('14598','2013-08-21','10:05:00',2.46),('14598','2013-08-21','10:10:00',2.3),('14598','2013-08-21','10:15:00',2.79),('14598','2013-08-21','10:20:00',2.71),('14598','2013-08-21','10:25:00',3.14),('14598','2013-08-21','10:30:00',3.54),('14598','2013-08-21','10:35:00',3.75),('14598','2013-08-21','10:40:00',3.01),('14598','2013-08-21','10:45:00',2.36),('14598','2013-08-21','10:50:00',3.15),('14598','2013-08-21','10:55:00',3.45),('14598','2013-08-21','11:00:00',2.6),('14598','2013-08-21','11:05:00',2.23),('14598','2013-08-21','11:10:00',2.55),('14598','2013-08-21','11:15:00',2.34),('14598','2013-08-21','11:20:00',3.12),('14598','2013-08-21','11:25:00',2.6),('14598','2013-08-21','11:30:00',2.77),('14598','2013-08-21','11:35:00',3.01),('14598','2013-08-21','11:40:00',2.93),('14598','2013-08-21','11:45:00',3.23),('14598','2013-08-21','11:50:00',4.21),('14598','2013-08-21','11:55:00',4.12),('14598','2013-08-21','12:00:00',4.16),('14598','2013-08-21','12:05:00',3.68),('14598','2013-08-21','12:10:00',4.03),('14598','2013-08-21','12:15:00',4.11),('14598','2013-08-21','12:20:00',4.12),('14598','2013-08-21','12:25:00',3.96),('14598','2013-08-21','12:30:00',3.74),('14598','2013-08-21','12:35:00',3.82),('14598','2013-08-21','12:40:00',3.53),('14598','2013-08-21','12:45:00',3.82),('14598','2013-08-21','12:50:00',3.8),('14598','2013-08-21','12:55:00',3.54),('14598','2013-08-21','13:00:00',3.72),('14598','2013-08-21','13:05:00',3.83),('14598','2013-08-21','13:10:00',4.2),('14598','2013-08-21','13:15:00',4.27),('14598','2013-08-21','13:20:00',4.31),('14598','2013-08-21','13:25:00',4.13),('14598','2013-08-21','13:30:00',4.13),('14598','2013-08-21','13:35:00',4.13),('14598','2013-08-21','13:40:00',4.08),('14598','2013-08-21','13:45:00',4.08),('14598','2013-08-21','13:50:00',4.2),('14598','2013-08-21','13:55:00',4.21),('14598','2013-08-21','14:00:00',4.26),('14598','2013-08-21','14:05:00',4.22),('14598','2013-08-21','14:10:00',4.35),('14598','2013-08-21','14:15:00',4.29),('14598','2013-08-21','14:20:00',4.15),('14598','2013-08-21','14:25:00',3.47),('14598','2013-08-21','14:30:00',4.11),('14598','2013-08-21','14:35:00',3.09),('14598','2013-08-21','14:40:00',2.35),('14598','2013-08-21','14:45:00',3.77),('14598','2013-08-21','14:50:00',2.82),('14598','2013-08-21','14:55:00',3.26),('14598','2013-08-21','15:00:00',3.63),('14598','2013-08-21','15:05:00',3.17),('14598','2013-08-21','15:10:00',4.17),('14598','2013-08-21','15:15:00',3.84),('14598','2013-08-21','15:20:00',3.59),('14598','2013-08-21','15:25:00',3.43),('14598','2013-08-21','15:30:00',3.39),('14598','2013-08-21','15:35:00',3.16),('14598','2013-08-21','15:40:00',3),('14598','2013-08-21','15:45:00',3.07),('14598','2013-08-21','15:50:00',3.18),('14598','2013-08-21','15:55:00',3.19),('14598','2013-08-21','16:00:00',3.05),('14598','2013-08-21','16:05:00',3.12),('14598','2013-08-21','16:10:00',3.26),('14598','2013-08-21','16:15:00',3.33),('14598','2013-08-21','16:20:00',3.46),('14598','2013-08-21','16:25:00',3.45),('14598','2013-08-21','16:30:00',3.29),('14598','2013-08-21','16:35:00',3.3),('14598','2013-08-21','16:40:00',3.25),('14598','2013-08-21','16:45:00',3.19),('14598','2013-08-21','16:50:00',3.13),('14598','2013-08-21','16:55:00',3.02),('14598','2013-08-21','17:00:00',2.96),('14598','2013-08-21','17:05:00',2.9),('14598','2013-08-21','17:10:00',2.77),('14598','2013-08-21','17:15:00',2.71),('14598','2013-08-21','17:20:00',2.61),('14598','2013-08-21','17:25:00',2.54),('14598','2013-08-21','17:30:00',2.42),('14598','2013-08-21','17:35:00',2.27),('14598','2013-08-21','17:40:00',2.22),('14598','2013-08-21','17:45:00',2.13),('14598','2013-08-21','17:50:00',2.04),('14598','2013-08-21','17:55:00',1.86),('14598','2013-08-21','18:00:00',1.22),('14598','2013-08-21','18:05:00',1.16),('14598','2013-08-21','18:10:00',1.22),('14598','2013-08-21','18:15:00',1.27),('14598','2013-08-21','18:20:00',1.28),('14598','2013-08-21','18:25:00',1.29),('14598','2013-08-21','18:30:00',1.29),('14598','2013-08-21','18:35:00',1.24),('14598','2013-08-21','18:40:00',1.18),('14598','2013-08-21','18:45:00',1.06),('14598','2013-08-20','08:55:00',1.33),('14598','2013-08-20','09:00:00',1.86),('14598','2013-08-20','09:05:00',2.12),('14598','2013-08-20','09:10:00',2.42),('14598','2013-08-20','09:15:00',2.57),('14598','2013-08-20','09:20:00',1.56),('14598','2013-08-20','09:25:00',1.62),('14598','2013-08-20','09:30:00',1.43),('14598','2013-08-20','09:35:00',1.5),('14598','2013-08-20','09:40:00',1.49),('14598','2013-08-20','09:45:00',1.38),('14598','2013-08-20','09:50:00',1.4),('14598','2013-08-20','09:55:00',1.77),('14598','2013-08-20','10:00:00',2.28),('14598','2013-08-20','10:05:00',2.54),('14598','2013-08-20','10:10:00',1.74),('14598','2013-08-20','10:15:00',3.44),('14598','2013-08-20','10:20:00',3.56),('14598','2013-08-20','10:25:00',3.09),('14598','2013-08-20','10:30:00',4.38),('14598','2013-08-20','10:35:00',4.28),('14598','2013-08-20','10:40:00',4.3),('14598','2013-08-20','10:45:00',3.39),('14598','2013-08-20','10:50:00',4.22),('14598','2013-08-20','10:55:00',3.34),('14598','2013-08-20','11:00:00',3.59),('14598','2013-08-20','11:05:00',2.36),('14598','2013-08-20','11:10:00',1.95),('14598','2013-08-20','11:15:00',2.26),('14598','2013-08-20','11:20:00',2.05),('14598','2013-08-20','11:25:00',2.17),('14598','2013-08-20','11:30:00',2.06),('14598','2013-08-20','11:35:00',1.75),('14598','2013-08-20','11:40:00',1.48),('14598','2013-08-20','11:45:00',1.34),('14598','2013-08-20','11:50:00',1.18),('14598','2013-08-20','11:55:00',1.2),('14598','2013-08-20','12:00:00',1.25),('14598','2013-08-20','12:05:00',1.36),('14598','2013-08-20','12:10:00',1.48),('14598','2013-08-20','12:15:00',1.74),('14598','2013-08-20','12:20:00',2.06),('14598','2013-08-20','12:25:00',2.34),('14598','2013-08-20','12:30:00',2.9),('14598','2013-08-20','12:35:00',3.62),('14598','2013-08-20','12:40:00',3.86),('14598','2013-08-20','12:45:00',3.87),('14598','2013-08-20','12:50:00',3.48),('14598','2013-08-20','12:55:00',3.7),('14598','2013-08-20','13:00:00',3.28),('14598','2013-08-20','13:05:00',3.05),('14598','2013-08-20','13:10:00',3),('14598','2013-08-20','13:15:00',3.04),('14598','2013-08-20','13:20:00',2.81),('14598','2013-08-20','13:25:00',3.1),('14598','2013-08-20','13:30:00',3.35),('14598','2013-08-20','13:35:00',2.96),('14598','2013-08-20','13:40:00',3.21),('14598','2013-08-20','13:45:00',3.78),('14598','2013-08-20','13:50:00',2.14),('14598','2013-08-20','13:55:00',2.44),('14598','2013-08-20','14:00:00',2.09),('14598','2013-08-20','14:05:00',2.52),('14598','2013-08-20','14:10:00',3.84),('14598','2013-08-20','14:15:00',5.08),('14598','2013-08-20','14:20:00',4.95),('14598','2013-08-20','14:25:00',4.87),('14598','2013-08-20','14:30:00',4.87),('14598','2013-08-20','14:35:00',4.86),('14598','2013-08-20','14:40:00',4.9),('14598','2013-08-20','14:45:00',5.1),('14598','2013-08-20','14:50:00',4.32),('14598','2013-08-20','14:55:00',3.96),('14598','2013-08-20','15:00:00',1.89),('14598','2013-08-20','15:05:00',4.88),('14598','2013-08-20','15:10:00',5.07),('14598','2013-08-20','15:15:00',4.67),('14598','2013-08-20','15:20:00',4.57),('14598','2013-08-20','15:25:00',4.46),('14598','2013-08-20','15:30:00',4.44),('14598','2013-08-20','15:35:00',4.41),('14598','2013-08-20','15:40:00',4.3),('14598','2013-08-20','15:45:00',2.31),('14598','2013-08-20','15:50:00',4.32),('14598','2013-08-20','15:55:00',4.15),('14598','2013-08-20','16:00:00',4.09),('14598','2013-08-20','16:05:00',4.03),('14598','2013-08-20','16:10:00',3.97),('14598','2013-08-20','16:15:00',3.9),('14598','2013-08-20','16:20:00',3.82),('14598','2013-08-20','16:25:00',3.21),('14598','2013-08-20','16:30:00',3.75),('14598','2013-08-20','16:35:00',3.74),('14598','2013-08-20','16:40:00',3.5),('14598','2013-08-20','16:45:00',2.86),('14598','2013-08-20','16:50:00',4.07),('14598','2013-08-20','16:55:00',3.22),('14598','2013-08-20','17:00:00',2.02),('14598','2013-08-20','17:05:00',3.41),('14598','2013-08-20','17:10:00',2.59),('14598','2013-08-20','17:15:00',2.71),('14598','2013-08-20','17:20:00',2.86),('14598','2013-08-20','17:25:00',2.85),('14598','2013-08-20','17:30:00',2.78),('14598','2013-08-20','17:35:00',2.55),('14598','2013-08-20','17:40:00',1.77),('14598','2013-08-20','17:45:00',1.41),('14598','2013-08-20','17:50:00',2.3),('14598','2013-08-20','17:55:00',2.21),('14598','2013-08-20','18:00:00',2.04),('14598','2013-08-20','18:10:00',1.31),('14598','2013-08-20','18:15:00',1.67),('14598','2013-08-20','18:20:00',1.09),('14598','2013-08-20','18:40:00',1),('14598','2013-08-20','18:45:00',1.17),('14598','2013-08-20','18:50:00',1.08),('14598','2014-04-10','08:30:00',1.05),('14598','2014-04-10','08:35:00',1.15),('14598','2014-04-10','08:40:00',1.27),('14598','2014-04-10','08:45:00',1.39),('14598','2014-04-10','08:50:00',1.49),('14598','2014-04-10','08:55:00',1.61),('14598','2014-04-10','09:00:00',1.72),('14598','2014-04-10','09:05:00',1.85),('14598','2014-04-10','09:10:00',1.97),('14598','2014-04-10','09:15:00',2.09),('14598','2014-04-10','09:20:00',2.22),('14598','2014-04-10','09:25:00',2.33),('14598','2014-04-10','09:30:00',2.43),('14598','2014-04-10','09:35:00',2.52),('14598','2014-04-10','09:40:00',2.62),('14598','2014-04-10','09:45:00',2.73),('14598','2014-04-10','09:50:00',2.82),('14598','2014-04-10','09:55:00',2.91),('14598','2014-04-10','10:00:00',2.99),('14598','2014-04-10','10:05:00',3.07),('14598','2014-04-10','10:10:00',3.14),('14598','2014-04-10','10:15:00',3.23),('14598','2014-04-10','10:20:00',3.28),('14598','2014-04-10','10:25:00',3.32),('14598','2014-04-10','10:30:00',3.4),('14598','2014-04-10','10:35:00',3.55),('14598','2014-04-10','10:40:00',3.64),('14598','2014-04-10','10:45:00',3.63),('14598','2014-04-10','10:50:00',3.66),('14598','2014-04-10','10:55:00',3.74),('14598','2014-04-10','11:00:00',3.87),('14598','2014-04-10','11:05:00',3.99),('14598','2014-04-10','11:10:00',4.06),('14598','2014-04-10','11:15:00',4.13),('14598','2014-04-10','11:20:00',4.15),('14598','2014-04-10','11:25:00',4.21),('14598','2014-04-10','11:30:00',4.28),('14598','2014-04-10','11:35:00',4.38),('14598','2014-04-10','11:40:00',4.33),('14598','2014-04-10','11:45:00',4.36),('14598','2014-04-10','11:50:00',4.41),('14598','2014-04-10','11:55:00',4.35),('14598','2014-04-10','12:00:00',4.42),('14598','2014-04-10','12:05:00',4.5),('14598','2014-04-10','12:10:00',4.65),('14598','2014-04-10','12:15:00',4.7),('14598','2014-04-10','12:20:00',4.2),('14598','2014-04-10','12:25:00',4.58),('14598','2014-04-10','12:30:00',4.82),('14598','2014-04-10','12:35:00',4.7),('14598','2014-04-10','12:40:00',4.41),('14598','2014-04-10','12:45:00',4.85),('14598','2014-04-10','12:50:00',4.8),('14598','2014-04-10','12:55:00',4.75),('14598','2014-04-10','13:00:00',4.79),('14598','2014-04-10','13:05:00',4.76),('14598','2014-04-10','13:10:00',4.79),('14598','2014-04-10','13:15:00',4.95),('14598','2014-04-10','13:20:00',4.42),('14598','2014-04-10','13:25:00',4.83),('14598','2014-04-10','13:30:00',4.77),('14598','2014-04-10','13:35:00',4.86),('14598','2014-04-10','13:40:00',4.76),('14598','2014-04-10','13:45:00',4.79),('14598','2014-04-10','13:50:00',4.79),('14598','2014-04-10','13:55:00',4.8),('14598','2014-04-10','14:00:00',4.8),('14598','2014-04-10','14:05:00',4.84),('14598','2014-04-10','14:10:00',4.57),('14598','2014-04-10','14:15:00',4.78),('14598','2014-04-10','14:20:00',4.76),('14598','2014-04-10','14:25:00',4.63),('14598','2014-04-10','14:30:00',4.77),('14598','2014-04-10','14:35:00',4.79),('14598','2014-04-10','14:40:00',4.88),('14598','2014-04-10','14:45:00',4.6),('14598','2014-04-10','14:50:00',4.61),('14598','2014-04-10','14:55:00',4.34),('14598','2014-04-10','15:00:00',4.29),('14598','2014-04-10','15:05:00',4.4),('14598','2014-04-10','15:10:00',4.25),('14598','2014-04-10','15:15:00',4.31),('14598','2014-04-10','15:20:00',4.27),('14598','2014-04-10','15:25:00',4.35),('14598','2014-04-10','15:30:00',4.17),('14598','2014-04-10','15:35:00',4.01),('14598','2014-04-10','15:40:00',4.04),('14598','2014-04-10','15:45:00',4.03),('14598','2014-04-10','15:50:00',4.02),('14598','2014-04-10','15:55:00',4.02),('14598','2014-04-10','16:00:00',4.24),('14598','2014-04-10','16:05:00',4.2),('14598','2014-04-10','16:10:00',4.11),('14598','2014-04-10','16:15:00',4.02),('14598','2014-04-10','16:20:00',3.95),('14598','2014-04-10','16:25:00',3.86),('14598','2014-04-10','16:30:00',3.75),('14598','2014-04-10','16:35:00',3.71),('14598','2014-04-10','16:40:00',3.66),('14598','2014-04-10','16:45:00',3.63),('14598','2014-04-10','16:50:00',3.55),('14598','2014-04-10','16:55:00',3.44),('14598','2014-04-10','17:00:00',3.36),('14598','2014-04-10','17:05:00',3.27),('14598','2014-04-10','17:10:00',3.17),('14598','2014-04-10','17:15:00',3.05),('14598','2014-04-10','17:20:00',2.96),('14598','2014-04-10','17:25:00',2.81),('14598','2014-04-10','17:30:00',2.75),('14598','2014-04-10','17:35:00',2.64),('14598','2014-04-10','17:40:00',2.53),('14598','2014-04-10','17:45:00',2.4),('14598','2014-04-10','17:50:00',2.3),('14598','2014-04-10','17:55:00',2.15),('14598','2014-04-10','18:00:00',2.05),('14598','2014-04-10','18:05:00',1.92),('14598','2014-04-10','18:10:00',1.8),('14598','2014-04-10','18:15:00',1.64),('14598','2014-04-10','18:20:00',1.5),('14598','2014-04-10','18:25:00',1.22),('14598','2014-04-10','18:30:00',1.12),('14598','2014-04-10','18:35:00',1.02),('14598','2013-08-19','08:30:00',1.07),('14598','2013-08-19','08:35:00',1.16),('14598','2013-08-19','08:40:00',1.25),('14598','2013-08-19','08:45:00',1.35),('14598','2013-08-19','08:50:00',1.42),('14598','2013-08-19','08:55:00',1.51),('14598','2013-08-19','09:00:00',1.63),('14598','2013-08-19','09:05:00',1.78),('14598','2013-08-19','09:10:00',1.87),('14598','2013-08-19','09:15:00',1.98),('14598','2013-08-19','09:20:00',2.03),('14598','2013-08-19','09:25:00',2.17),('14598','2013-08-19','09:30:00',2.24),('14598','2013-08-19','09:35:00',2.33),('14598','2013-08-19','09:40:00',2.41),('14598','2013-08-19','09:45:00',2.48),('14598','2013-08-19','09:50:00',2.54),('14598','2013-08-19','09:55:00',2.62),('14598','2013-08-19','10:00:00',2.7),('14598','2013-08-19','10:05:00',2.81),('14598','2013-08-19','10:10:00',2.87),('14598','2013-08-19','10:15:00',2.95),('14598','2013-08-19','10:20:00',3.01),('14598','2013-08-19','10:25:00',3.08),('14598','2013-08-19','10:30:00',3.12),('14598','2013-08-19','10:35:00',3.17),('14598','2013-08-19','10:40:00',3.26),('14598','2013-08-19','10:45:00',3.31),('14598','2013-08-19','10:50:00',3.37),('14598','2013-08-19','10:55:00',3.48),('14598','2013-08-19','11:00:00',3.58),('14598','2013-08-19','11:05:00',3.61),('14598','2013-08-19','11:10:00',3.68),('14598','2013-08-19','11:15:00',3.74),('14598','2013-08-19','11:20:00',3.8),('14598','2013-08-19','11:25:00',3.85),('14598','2013-08-19','11:30:00',3.89),('14598','2013-08-19','11:35:00',3.97),('14598','2013-08-19','11:40:00',4.03),('14598','2013-08-19','11:45:00',4.05),('14598','2013-08-19','11:50:00',4.1),('14598','2013-08-19','11:55:00',4.2),('14598','2013-08-19','12:00:00',4.24),('14598','2013-08-19','12:05:00',4.31),('14598','2013-08-19','12:10:00',4.35),('14598','2013-08-19','12:15:00',4.41),('14598','2013-08-19','12:20:00',4.33),('14598','2013-08-19','12:25:00',4.44),('14598','2013-08-19','12:30:00',4.49),('14598','2013-08-19','12:35:00',4.49),('14598','2013-08-19','12:40:00',4.53),('14598','2013-08-19','12:45:00',4.53),('14598','2013-08-19','12:50:00',4.57),('14598','2013-08-19','12:55:00',4.56),('14598','2013-08-19','13:00:00',4.56),('14598','2013-08-19','13:05:00',4.6),('14598','2013-08-19','13:10:00',4.64),('14598','2013-08-19','13:15:00',4.65),('14598','2013-08-19','13:20:00',4.66),('14598','2013-08-19','13:25:00',4.66),('14598','2013-08-19','13:30:00',4.66),('14598','2013-08-19','13:35:00',4.64),('14598','2013-08-19','13:40:00',4.7),('14598','2013-08-19','13:45:00',4.7),('14598','2013-08-19','13:50:00',4.73),('14598','2013-08-19','13:55:00',4.71),('14598','2013-08-19','14:00:00',4.7),('14598','2013-08-19','14:05:00',4.69),('14598','2013-08-19','14:10:00',4.7),('14598','2013-08-19','14:15:00',4.69),('14598','2013-08-19','14:20:00',4.7),('14598','2013-08-19','14:25:00',4.68),('14598','2013-08-19','14:30:00',4.66),('14598','2013-08-19','14:35:00',4.65),('14598','2013-08-19','14:40:00',4.64),('14598','2013-08-19','14:45:00',4.62),('14598','2013-08-19','14:50:00',4.58),('14598','2013-08-19','14:55:00',4.56),('14598','2013-08-19','15:00:00',4.51),('14598','2013-08-19','15:05:00',4.48),('14598','2013-08-19','15:10:00',4.46),('14598','2013-08-19','15:15:00',4.43),('14598','2013-08-19','15:20:00',4.33),('14598','2013-08-19','15:25:00',4.37),('14598','2013-08-19','15:30:00',4.32),('14598','2013-08-19','15:35:00',4.27),('14598','2013-08-19','15:40:00',4.23),('14598','2013-08-19','15:45:00',4.17),('14598','2013-08-19','15:50:00',4.12),('14598','2013-08-19','15:55:00',4.06),('14598','2013-08-19','16:00:00',4.01),('14598','2013-08-19','16:05:00',3.87),('14598','2013-08-19','16:10:00',3.9),('14598','2013-08-19','16:15:00',3.84),('14598','2013-08-19','16:20:00',3.79),('14598','2013-08-19','16:25:00',3.71),('14598','2013-08-19','16:30:00',3.65),('14598','2013-08-19','16:35:00',3.57),('14598','2013-08-19','16:40:00',3.47),('14598','2013-08-19','16:45:00',3.43),('14598','2013-08-19','16:50:00',3.35),('14598','2013-08-19','16:55:00',3.29),('14598','2013-08-19','17:00:00',3.2),('14598','2013-08-19','17:05:00',3.11),('14598','2013-08-19','17:10:00',3.02),('14598','2013-08-19','17:15:00',2.94),('14598','2013-08-19','17:20:00',2.86),('14598','2013-08-19','17:25:00',2.77),('14598','2013-08-19','17:30:00',2.65),('14598','2013-08-19','17:35:00',2.56),('14598','2013-08-19','17:40:00',2.48),('14598','2013-08-19','17:45:00',2.36),('14598','2013-08-19','17:50:00',2.26),('14598','2013-08-19','17:55:00',2.18),('14598','2013-08-19','18:00:00',2.07),('14598','2013-08-19','18:05:00',1.98),('14598','2013-08-19','18:10:00',1.88),('14598','2013-08-19','18:15:00',1.78),('14598','2013-08-19','18:20:00',1.68),('14598','2013-08-19','18:25:00',1.54),('14598','2013-08-19','18:30:00',1.47),('14598','2013-08-19','18:35:00',1.36),('14598','2013-08-19','18:40:00',1.26),('14598','2013-08-19','18:45:00',1.16),('14598','2013-08-19','18:50:00',1.05),('14598','2013-08-18','08:25:00',1.02),('14598','2013-08-18','08:30:00',1.1),('14598','2013-08-18','08:35:00',1.18),('14598','2013-08-18','08:40:00',1.28),('14598','2013-08-18','08:45:00',1.38),('14598','2013-08-18','08:50:00',1.47),('14598','2013-08-18','08:55:00',1.55),('14598','2013-08-18','09:00:00',1.67),('14598','2013-08-18','09:05:00',1.79),('14598','2013-08-18','09:10:00',1.91),('14598','2013-08-18','09:15:00',2),('14598','2013-08-18','09:20:00',2.09),('14598','2013-08-18','09:25:00',2.18),('14598','2013-08-18','09:30:00',2.26),('14598','2013-08-18','09:35:00',2.35),('14598','2013-08-18','09:40:00',2.44),('14598','2013-08-18','09:45:00',2.52),('14598','2013-08-18','09:50:00',2.58),('14598','2013-08-18','09:55:00',2.67),('14598','2013-08-18','10:00:00',2.76),('14598','2013-08-18','10:05:00',2.83),('14598','2013-08-18','10:10:00',2.9),('14598','2013-08-18','10:15:00',2.98),('14598','2013-08-18','10:20:00',3.03),('14598','2013-08-18','10:25:00',3.1),('14598','2013-08-18','10:30:00',3.12),('14598','2013-08-18','10:35:00',3.17),('14598','2013-08-18','10:40:00',3.23),('14598','2013-08-18','10:45:00',3.35),('14598','2013-08-18','10:50:00',3.43),('14598','2013-08-18','10:55:00',3.52),('14598','2013-08-18','11:00:00',3.58),('14598','2013-08-18','11:05:00',3.61),('14598','2013-08-18','11:10:00',3.69),('14598','2013-08-18','11:15:00',3.77),('14598','2013-08-18','11:20:00',3.84),('14598','2013-08-18','11:25:00',3.91),('14598','2013-08-18','11:30:00',3.99),('14598','2013-08-18','11:35:00',4.02),('14598','2013-08-18','11:40:00',4.08),('14598','2013-08-18','11:45:00',4.12),('14598','2013-08-18','11:50:00',4.16),('14598','2013-08-18','11:55:00',4.21),('14598','2013-08-18','12:00:00',4.26),('14598','2013-08-18','12:05:00',4.25),('14598','2013-08-18','12:10:00',4.31),('14598','2013-08-18','12:15:00',4.32),('14598','2013-08-18','12:20:00',4.4),('14598','2013-08-18','12:25:00',4.44),('14598','2013-08-18','12:30:00',4.47),('14598','2013-08-18','12:35:00',4.5),('14598','2013-08-18','12:40:00',4.53),('14598','2013-08-18','12:45:00',4.56),('14598','2013-08-18','12:50:00',4.58),('14598','2013-08-18','12:55:00',4.6),('14598','2013-08-18','13:00:00',4.62),('14598','2013-08-18','13:05:00',4.64),('14598','2013-08-18','13:10:00',4.64),('14598','2013-08-18','13:15:00',4.67),('14598','2013-08-18','13:20:00',4.68),('14598','2013-08-18','13:25:00',4.69),('14598','2013-08-18','13:30:00',4.7),('14598','2013-08-18','13:35:00',4.71),('14598','2013-08-18','13:40:00',4.7),('14598','2013-08-18','13:45:00',4.69),('14598','2013-08-18','13:50:00',4.61),('14598','2013-08-18','13:55:00',4.72),('14598','2013-08-18','14:00:00',4.73),('14598','2013-08-18','14:05:00',4.71),('14598','2013-08-18','14:10:00',4.69),('14598','2013-08-18','14:15:00',4.68),('14598','2013-08-18','14:20:00',4.66),('14598','2013-08-18','14:25:00',4.66),('14598','2013-08-18','14:30:00',4.65),('14598','2013-08-18','14:35:00',4.62),('14598','2013-08-18','14:40:00',4.58),('14598','2013-08-18','14:45:00',4.55),('14598','2013-08-18','14:50:00',4.52),('14598','2013-08-18','14:55:00',4.51),('14598','2013-08-18','15:00:00',4.46),('14598','2013-08-18','15:05:00',4.43),('14598','2013-08-18','15:10:00',4.4),('14598','2013-08-18','15:15:00',4.36),('14598','2013-08-18','15:20:00',4.32),('14598','2013-08-18','15:25:00',4.29),('14598','2013-08-18','15:30:00',4.25),('14598','2013-08-18','15:35:00',4.22),('14598','2013-08-18','15:40:00',4.2),('14598','2013-08-18','15:45:00',4.14),('14598','2013-08-18','15:50:00',4.1),('14598','2013-08-18','15:55:00',4.05),('14598','2013-08-18','16:00:00',3.99),('14598','2013-08-18','16:05:00',3.94),('14598','2013-08-18','16:10:00',3.89),('14598','2013-08-18','16:15:00',3.86),('14598','2013-08-18','16:20:00',3.79),('14598','2013-08-18','16:25:00',3.71),('14598','2013-08-18','16:30:00',3.65),('14598','2013-08-18','16:35:00',3.57),('14598','2013-08-18','16:40:00',3.51),('14598','2013-08-18','16:45:00',3.44),('14598','2013-08-18','16:50:00',3.31),('14598','2013-08-18','16:55:00',3.29),('14598','2013-08-18','17:00:00',3.2),('14598','2013-08-18','17:05:00',3.12),('14598','2013-08-18','17:10:00',3.04),('14598','2013-08-18','17:15:00',2.96),('14598','2013-08-18','17:20:00',2.88),('14598','2013-08-18','17:25:00',2.79),('14598','2013-08-18','17:30:00',2.7),('14598','2013-08-18','17:35:00',2.61),('14598','2013-08-18','17:40:00',2.51),('14598','2013-08-18','17:45:00',2.41),('14598','2013-08-18','17:50:00',2.31),('14598','2013-08-18','17:55:00',2.22),('14598','2013-08-18','18:00:00',2.12),('14598','2013-08-18','18:05:00',2.01),('14598','2013-08-18','18:10:00',1.9),('14598','2013-08-18','18:15:00',1.81),('14598','2013-08-18','18:20:00',1.71),('14598','2013-08-18','18:25:00',1.6),('14598','2013-08-18','18:30:00',1.49),('14598','2013-08-18','18:35:00',1.38),('14598','2013-08-18','18:40:00',1.26),('14598','2013-08-18','18:45:00',1.17),('14598','2013-08-18','18:50:00',1.06),('14598','2013-08-17','08:25:00',1.01),('14598','2013-08-17','08:30:00',1.09),('14598','2013-08-17','08:35:00',1.18),('14598','2013-08-17','08:40:00',1.27),('14598','2013-08-17','08:45:00',1.37),('14598','2013-08-17','08:50:00',1.44),('14598','2013-08-17','08:55:00',1.53),('14598','2013-08-17','09:00:00',1.56),('14598','2013-08-17','09:05:00',1.81),('14598','2013-08-17','09:10:00',1.63),('14598','2013-08-17','09:15:00',1.97),('14598','2013-08-17','09:20:00',2.07),('14598','2013-08-17','09:25:00',2.15),('14598','2013-08-17','09:30:00',2.25),('14598','2013-08-17','09:35:00',2.33),('14598','2013-08-17','09:40:00',2.43),('14598','2013-08-17','09:45:00',2.5),('14598','2013-08-17','09:50:00',2.59),('14598','2013-08-17','09:55:00',2.65),('14598','2013-08-17','10:00:00',2.73),('14598','2013-08-17','10:05:00',2.81),('14598','2013-08-17','10:10:00',2.88),('14598','2013-08-17','10:15:00',2.94),('14598','2013-08-17','10:20:00',3.03),('14598','2013-08-17','10:25:00',3.08),('14598','2013-08-17','10:30:00',3.14),('14598','2013-08-17','10:35:00',3.19),('14598','2013-08-17','10:40:00',3.26),('14598','2013-08-17','10:45:00',3.35),('14598','2013-08-17','10:50:00',3.46),('14598','2013-08-17','10:55:00',3.53),('14598','2013-08-17','11:00:00',3.58),('14598','2013-08-17','11:05:00',3.66),('14598','2013-08-17','11:10:00',3.73),('14598','2013-08-17','11:15:00',3.8),('14598','2013-08-17','11:20:00',3.85),('14598','2013-08-17','11:25:00',3.9),('14598','2013-08-17','11:30:00',3.93),('14598','2013-08-17','11:35:00',4.01),('14598','2013-08-17','11:40:00',4.06),('14598','2013-08-17','11:45:00',4.1),('14598','2013-08-17','11:50:00',4.14),('14598','2013-08-17','11:55:00',4.18),('14598','2013-08-17','12:00:00',4.21),('14598','2013-08-17','12:05:00',4.25),('14598','2013-08-17','12:10:00',4.29),('14598','2013-08-17','12:15:00',4.32),('14598','2013-08-17','12:20:00',4.37),('14598','2013-08-17','12:25:00',4.38),('14598','2013-08-17','12:30:00',4.41),('14598','2013-08-17','12:35:00',4.43),('14598','2013-08-17','12:40:00',4.48),('14598','2013-08-17','12:45:00',4.51),('14598','2013-08-17','12:50:00',4.52),('14598','2013-08-17','12:55:00',4.08),('14598','2013-08-17','13:00:00',4.55),('14598','2013-08-17','13:05:00',4.58),('14598','2013-08-17','13:10:00',4.58),('14598','2013-08-17','13:15:00',4.62),('14598','2013-08-17','13:20:00',4.61),('14598','2013-08-17','13:25:00',4.62),('14598','2013-08-17','13:30:00',4.65),('14598','2013-08-17','13:35:00',4.67),('14598','2013-08-17','13:40:00',4.67),('14598','2013-08-17','13:45:00',4.66),('14598','2013-08-17','13:50:00',4.66),('14598','2013-08-17','13:55:00',4.67),('14598','2013-08-17','14:00:00',4.65),('14598','2013-08-17','14:05:00',4.64),('14598','2013-08-17','14:10:00',4.62),('14598','2013-08-17','14:15:00',4.61),('14598','2013-08-17','14:20:00',4.59),('14598','2013-08-17','14:25:00',4.62),('14598','2013-08-17','14:30:00',4.6),('14598','2013-08-17','14:35:00',4.58),('14598','2013-08-17','14:40:00',4.56),('14598','2013-08-17','14:45:00',4.55),('14598','2013-08-17','14:50:00',4.54),('14598','2013-08-17','14:55:00',4.5),('14598','2013-08-17','15:00:00',4.46),('14598','2013-08-17','15:05:00',4.44),('14598','2013-08-17','15:10:00',4.41),('14598','2013-08-17','15:15:00',4.38),('14598','2013-08-17','15:20:00',4.35),('14598','2013-08-17','15:25:00',4.32),('14598','2013-08-17','15:30:00',4.3),('14598','2013-08-17','15:35:00',4.22),('14598','2013-08-17','15:40:00',3.36),('14598','2013-08-17','15:45:00',4.17),('14598','2013-08-17','15:50:00',4.14),('14598','2013-08-17','15:55:00',4.07),('14598','2013-08-17','16:00:00',4.02),('14598','2013-08-17','16:05:00',3.97),('14598','2013-08-17','16:10:00',3.93),('14598','2013-08-17','16:15:00',3.87),('14598','2013-08-17','16:20:00',3.75),('14598','2013-08-17','16:25:00',3.57),('14598','2013-08-17','16:30:00',3.6),('14598','2013-08-17','16:35:00',3.43),('14598','2013-08-17','16:40:00',3.37),('14598','2013-08-17','16:45:00',3.5),('14598','2013-08-17','16:50:00',3.4),('14598','2013-08-17','16:55:00',3.34),('14598','2013-08-17','17:00:00',3.28),('14598','2013-08-17','17:05:00',3.17),('14598','2013-08-17','17:10:00',3.07),('14598','2013-08-17','17:15:00',2.96),('14598','2013-08-17','17:20:00',2.79),('14598','2013-08-17','17:25:00',2.71),('14598','2013-08-17','17:30:00',2.62),('14598','2013-08-17','17:35:00',2.5),('14598','2013-08-17','17:40:00',2.44),('14598','2013-08-17','17:45:00',2.47),('14598','2013-08-17','17:50:00',2.38),('14598','2013-08-17','17:55:00',2.27),('14598','2013-08-17','18:00:00',2.18),('14598','2013-08-17','18:05:00',2.08),('14598','2013-08-17','18:10:00',1.91),('14598','2013-08-17','18:15:00',1.85),('14598','2013-08-17','18:20:00',1.73),('14598','2013-08-17','18:25:00',1.66),('14598','2013-08-17','18:30:00',1.56),('14598','2013-08-17','18:35:00',1.46),('14598','2013-08-17','18:40:00',1.36),('14598','2013-08-17','18:45:00',1.26),('14598','2013-08-17','18:50:00',1.15),('14598','2013-08-17','18:55:00',1.04),('14598','2013-08-16','08:25:00',1.04),('14598','2013-08-16','08:30:00',1.13),('14598','2013-08-16','08:35:00',1.22),('14598','2013-08-16','08:40:00',1.31),('14598','2013-08-16','08:45:00',1.41),('14598','2013-08-16','08:50:00',1.49),('14598','2013-08-16','08:55:00',1.59),('14598','2013-08-16','09:00:00',1.71),('14598','2013-08-16','09:05:00',1.83),('14598','2013-08-16','09:10:00',1.95),('14598','2013-08-16','09:15:00',2.05),('14598','2013-08-16','09:20:00',2.15),('14598','2013-08-16','09:25:00',2.24),('14598','2013-08-16','09:30:00',2.32),('14598','2013-08-16','09:35:00',2.43),('14598','2013-08-16','09:40:00',2.52),('14598','2013-08-16','09:45:00',2.6),('14598','2013-08-16','09:50:00',2.69),('14598','2013-08-16','09:55:00',2.77),('14598','2013-08-16','10:00:00',2.84),('14598','2013-08-16','10:05:00',2.91),('14598','2013-08-16','10:10:00',2.99),('14598','2013-08-16','10:15:00',3.06),('14598','2013-08-16','10:20:00',3.12),('14598','2013-08-16','10:25:00',3.21),('14598','2013-08-16','10:30:00',3.27),('14598','2013-08-16','10:35:00',3.35),('14598','2013-08-16','10:40:00',3.41),('14598','2013-08-16','10:45:00',3.45),('14598','2013-08-16','10:50:00',3.53),('14598','2013-08-16','10:55:00',3.59),('14598','2013-08-16','11:00:00',3.62),('14598','2013-08-16','11:05:00',3.64),('14598','2013-08-16','11:10:00',3.73),('14598','2013-08-16','11:15:00',3.81),('14598','2013-08-16','11:20:00',3.86),('14598','2013-08-16','11:25:00',3.9),('14598','2013-08-16','11:30:00',3.95),('14598','2013-08-16','11:35:00',4),('14598','2013-08-16','11:40:00',4.03),('14598','2013-08-16','11:45:00',4.06),('14598','2013-08-16','11:50:00',4.1),('14598','2013-08-16','11:55:00',4.14),('14598','2013-08-16','12:00:00',4.15),('14598','2013-08-16','12:05:00',4.16),('14598','2013-08-16','12:10:00',4.19),('14598','2013-08-16','12:15:00',4.23),('14598','2013-08-16','12:20:00',4.28),('14598','2013-08-16','12:25:00',4.32),('14598','2013-08-16','12:30:00',4.28),('14598','2013-08-16','12:35:00',4.37),('14598','2013-08-16','12:40:00',4.4),('14598','2013-08-16','12:45:00',4.4),('14598','2013-08-16','12:50:00',4.44),('14598','2013-08-16','12:55:00',4.48),('14598','2013-08-16','13:00:00',4.48),('14598','2013-08-16','13:05:00',4.49),('14598','2013-08-16','13:10:00',4.5),('14598','2013-08-16','13:15:00',4.48),('14598','2013-08-16','13:20:00',4.47),('14598','2013-08-16','13:25:00',4.47),('14598','2013-08-16','13:30:00',4.52),('14598','2013-08-16','13:35:00',4.52),('14598','2013-08-16','13:40:00',4.51),('14598','2013-08-16','13:45:00',4.44),('14598','2013-08-16','13:50:00',4.46),('14598','2013-08-16','13:55:00',4.44),('14598','2013-08-16','14:00:00',4.53),('14598','2013-08-16','14:05:00',4.62),('14598','2013-08-16','14:10:00',4.63),('14598','2013-08-16','14:15:00',4.65),('14598','2013-08-16','14:20:00',4.65),('14598','2013-08-16','14:25:00',4.61),('14598','2013-08-16','14:30:00',4.62),('14598','2013-08-16','14:35:00',4.63),('14598','2013-08-16','14:40:00',4.61),('14598','2013-08-16','14:45:00',4.58),('14598','2013-08-16','14:50:00',4.55),('14598','2013-08-16','14:55:00',4.53),('14598','2013-08-16','15:00:00',4.49),('14598','2013-08-16','15:05:00',4.46),('14598','2013-08-16','15:10:00',4.42),('14598','2013-08-16','15:15:00',4.39),('14598','2013-08-16','15:20:00',4.36),('14598','2013-08-16','15:25:00',4.32),('14598','2013-08-16','15:30:00',4.29),('14598','2013-08-16','15:35:00',4.18),('14598','2013-08-16','15:40:00',4.21),('14598','2013-08-16','15:45:00',4.17),('14598','2013-08-16','15:50:00',4.14),('14598','2013-08-16','15:55:00',4.06),('14598','2013-08-16','16:00:00',3.99),('14598','2013-08-16','16:05:00',3.94),('14598','2013-08-16','16:10:00',3.87),('14598','2013-08-16','16:15:00',3.85),('14598','2013-08-16','16:20:00',3.78),('14598','2013-08-16','16:25:00',3.72),('14598','2013-08-16','16:30:00',3.66),('14598','2013-08-16','16:35:00',3.6),('14598','2013-08-16','16:40:00',3.52),('14598','2013-08-16','16:45:00',3.45),('14598','2013-08-16','16:50:00',3.37),('14598','2013-08-16','16:55:00',3.29),('14598','2013-08-16','17:00:00',3.22),('14598','2013-08-16','17:05:00',3.12),('14598','2013-08-16','17:10:00',3.04),('14598','2013-08-16','17:15:00',2.96),('14598','2013-08-16','17:20:00',2.85),('14598','2013-08-16','17:25:00',2.78),('14598','2013-08-16','17:30:00',2.69),('14598','2013-08-16','17:35:00',2.6),('14598','2013-08-16','17:40:00',2.5),('14598','2013-08-16','17:45:00',2.41),('14598','2013-08-16','17:50:00',2.33),('14598','2013-08-16','17:55:00',2.24),('14598','2013-08-16','18:00:00',2.12),('14598','2013-08-16','18:05:00',1.98),('14598','2013-08-16','18:10:00',1.96),('14598','2013-08-16','18:15:00',1.84),('14598','2013-08-16','18:20:00',1.04),('14598','2013-08-16','18:25:00',1.36),('14598','2013-08-16','18:30:00',1.63),('14598','2013-08-16','18:35:00',1.53),('14598','2013-08-16','18:40:00',1.42),('14598','2013-08-16','18:45:00',1.31),('14598','2013-08-16','18:50:00',1.16),('14598','2013-08-16','18:55:00',1.09),('14598','2013-08-15','08:40:00',1.11),('14598','2013-08-15','08:45:00',1.45),('14598','2013-08-15','08:50:00',1.52),('14598','2013-08-15','08:55:00',1.65),('14598','2013-08-15','09:00:00',1.74),('14598','2013-08-15','09:05:00',1.86),('14598','2013-08-15','09:10:00',1.96),('14598','2013-08-15','09:15:00',2.07),('14598','2013-08-15','09:20:00',2.15),('14598','2013-08-15','09:25:00',2.24),('14598','2013-08-15','09:30:00',2.34),('14598','2013-08-15','09:35:00',2.42),('14598','2013-08-15','09:40:00',2.5),('14598','2013-08-15','09:45:00',2.59),('14598','2013-08-15','09:50:00',2.67),('14598','2013-08-15','09:55:00',2.76),('14598','2013-08-15','10:00:00',2.85),('14598','2013-08-15','10:05:00',2.95),('14598','2013-08-15','10:10:00',3.01),('14598','2013-08-15','10:15:00',3.08),('14598','2013-08-15','10:20:00',3.16),('14598','2013-08-15','10:25:00',3.23),('14598','2013-08-15','10:30:00',3.29),('14598','2013-08-15','10:35:00',3.35),('14598','2013-08-15','10:40:00',3.42),('14598','2013-08-15','10:45:00',3.47),('14598','2013-08-15','10:50:00',3.55),('14598','2013-08-15','10:55:00',3.61),('14598','2013-08-15','11:00:00',3.67),('14598','2013-08-15','11:05:00',3.72),('14598','2013-08-15','11:10:00',3.79),('14598','2013-08-15','11:15:00',3.84),('14598','2013-08-15','11:20:00',3.89),('14598','2013-08-15','11:25:00',3.94),('14598','2013-08-15','11:30:00',3.99),('14598','2013-08-15','11:35:00',4.04),('14598','2013-08-15','11:40:00',4.08),('14598','2013-08-15','11:45:00',4.14),('14598','2013-08-15','11:50:00',4.19),('14598','2013-08-15','11:55:00',4.23),('14598','2013-08-15','12:00:00',4.22),('14598','2013-08-15','12:05:00',4.28),('14598','2013-08-15','12:10:00',4.33),('14598','2013-08-15','12:15:00',4.36),('14598','2013-08-15','12:20:00',4.41),('14598','2013-08-15','12:25:00',4.44),('14598','2013-08-15','12:30:00',4.45),('14598','2013-08-15','12:35:00',4.5),('14598','2013-08-15','12:40:00',4.5),('14598','2013-08-15','12:45:00',4.51),('14598','2013-08-15','12:50:00',4.5),('14598','2013-08-15','12:55:00',4.51),('14598','2013-08-15','13:00:00',4.48),('14598','2013-08-15','13:05:00',4.49),('14598','2013-08-15','13:10:00',4.51),('14598','2013-08-15','13:15:00',4.54),('14598','2013-08-15','13:20:00',4.53),('14598','2013-08-15','13:25:00',4.55),('14598','2013-08-15','13:30:00',4.53),('14598','2013-08-15','13:35:00',4.52),('14598','2013-08-15','13:40:00',4.55),('14598','2013-08-15','13:45:00',4.56),('14598','2013-08-15','13:50:00',4.52),('14598','2013-08-15','13:55:00',4.52),('14598','2013-08-15','14:00:00',4.5),('14598','2013-08-15','14:05:00',4.46),('14598','2013-08-15','14:10:00',4.44),('14598','2013-08-15','14:15:00',4.48),('14598','2013-08-15','14:20:00',4.45),('14598','2013-08-15','14:25:00',4.44),('14598','2013-08-15','14:30:00',4.38),('14598','2013-08-15','14:35:00',4.38),('14598','2013-08-15','14:40:00',4.36),('14598','2013-08-15','14:45:00',4.33),('14598','2013-08-15','14:50:00',4.3),('14598','2013-08-15','14:55:00',4.27),('14598','2013-08-15','15:00:00',4.28),('14598','2013-08-15','15:05:00',4.25),('14598','2013-08-15','15:10:00',4.3),('14598','2013-08-15','15:15:00',4.27),('14598','2013-08-15','15:20:00',4.26),('14598','2013-08-15','15:25:00',4.22),('14598','2013-08-15','15:30:00',4.18),('14598','2013-08-15','15:35:00',4.12),('14598','2013-08-15','15:40:00',4.08),('14598','2013-08-15','15:45:00',4.05),('14598','2013-08-15','15:50:00',4.03),('14598','2013-08-15','15:55:00',3.98),('14598','2013-08-15','16:00:00',3.9),('14598','2013-08-15','16:05:00',3.83),('14598','2013-08-15','16:10:00',3.8),('14598','2013-08-15','16:15:00',3.79),('14598','2013-08-15','16:20:00',3.74),('14598','2013-08-15','16:25:00',3.7),('14598','2013-08-15','16:30:00',3.65),('14598','2013-08-15','16:35:00',3.59),('14598','2013-08-15','16:40:00',3.28),('14598','2013-08-15','16:45:00',3.32),('14598','2013-08-15','16:50:00',3.36),('14598','2013-08-15','16:55:00',3.08),('14598','2013-08-15','17:00:00',2.74),('14598','2013-08-15','17:05:00',3.07),('14598','2013-08-15','17:10:00',2.95),('14598','2013-08-15','17:15:00',2.87),('14598','2013-08-15','17:20:00',2.78),('14598','2013-08-15','17:25:00',2.74),('14598','2013-08-15','17:30:00',2.54),('14598','2013-08-15','17:35:00',2.54),('14598','2013-08-15','17:40:00',2.46),('14598','2013-08-15','17:45:00',2.37),('14598','2013-08-15','17:50:00',2.23),('14598','2013-08-15','17:55:00',2.12),('14598','2013-08-15','18:00:00',2.01),('14598','2013-08-15','18:05:00',1.79),('14598','2013-08-15','18:10:00',1.65),('14598','2013-08-15','18:15:00',1.6),('14598','2013-08-15','18:20:00',1.56),('14598','2013-08-15','18:25:00',1.44),('14598','2013-08-15','18:30:00',1.35),('14598','2013-08-15','18:35:00',1.28),('14598','2013-08-15','18:40:00',1.14),('14598','2013-08-14','08:25:00',1.04),('14598','2013-08-14','08:30:00',1.12),('14598','2013-08-14','08:35:00',1.18),('14598','2013-08-14','08:40:00',1.27),('14598','2013-08-14','08:45:00',1.36),('14598','2013-08-14','08:50:00',1.48),('14598','2013-08-14','08:55:00',1.62),('14598','2013-08-14','09:00:00',1.73),('14598','2013-08-14','09:05:00',1.79),('14598','2013-08-14','09:10:00',1.94),('14598','2013-08-14','09:15:00',1.56),('14598','2013-08-14','09:20:00',2.08),('14598','2013-08-14','09:25:00',2.39),('14598','2013-08-14','09:30:00',2.24),('14598','2013-08-14','09:35:00',2.41),('14598','2013-08-14','09:40:00',1.74),('14598','2013-08-14','09:45:00',2.32),('14598','2013-08-14','09:50:00',2.48),('14598','2013-08-14','09:55:00',2.79),('14598','2013-08-14','10:00:00',2.61),('14598','2013-08-14','10:05:00',2.87),('14598','2013-08-14','10:10:00',3.02),('14598','2013-08-14','10:15:00',3.06),('14598','2013-08-14','10:20:00',3.15),('14598','2013-08-14','10:25:00',3.17),('14598','2013-08-14','10:30:00',3.25),('14598','2013-08-14','10:35:00',3.25),('14598','2013-08-14','10:40:00',3.23),('14598','2013-08-14','10:45:00',3.18),('14598','2013-08-14','10:50:00',3.22),('14598','2013-08-14','10:55:00',3.53),('14598','2013-08-14','11:00:00',3.68),('14598','2013-08-14','11:05:00',3.71),('14598','2013-08-14','11:10:00',3.84),('14598','2013-08-14','11:15:00',3.87),('14598','2013-08-14','11:20:00',3.92),('14598','2013-08-14','11:25:00',3.92),('14598','2013-08-14','11:30:00',3.96),('14598','2013-08-14','11:35:00',3.81),('14598','2013-08-14','11:40:00',3.91),('14598','2013-08-14','11:45:00',4.17),('14598','2013-08-14','11:50:00',4.21),('14598','2013-08-14','11:55:00',4.22),('14598','2013-08-14','12:00:00',4.38),('14598','2013-08-14','12:05:00',4.39),('14598','2013-08-14','12:10:00',4.48),('14598','2013-08-14','12:15:00',4.35),('14598','2013-08-14','12:20:00',4.38),('14598','2013-08-14','12:25:00',4.19),('14598','2013-08-14','12:30:00',4),('14598','2013-08-14','12:35:00',3.8),('14598','2013-08-14','12:40:00',4.02),('14598','2013-08-14','12:45:00',4.08),('14598','2013-08-14','12:50:00',3.55),('14598','2013-08-14','12:55:00',3.93),('14598','2013-08-14','13:00:00',4.41),('14598','2013-08-14','13:05:00',4.55),('14598','2013-08-14','13:10:00',4.49),('14598','2013-08-14','13:15:00',4.55),('14598','2013-08-14','13:20:00',4.6),('14598','2013-08-14','13:25:00',4.53),('14598','2013-08-14','13:30:00',4.76),('14598','2013-08-14','13:35:00',4.73),('14598','2013-08-14','13:40:00',4.68),('14598','2013-08-14','13:45:00',4.78),('14598','2013-08-14','13:50:00',4.76),('14598','2013-08-14','13:55:00',4.76),('14598','2013-08-14','14:00:00',4.66),('14598','2013-08-14','14:05:00',4.72),('14598','2013-08-14','14:10:00',4.72),('14598','2013-08-14','14:15:00',4.74),('14598','2013-08-14','14:20:00',4.73),('14598','2013-08-14','14:25:00',4.68),('14598','2013-08-14','14:30:00',4.68),('14598','2013-08-14','14:35:00',4.68),('14598','2013-08-14','14:40:00',4.63),('14598','2013-08-14','14:45:00',4.61),('14598','2013-08-14','14:50:00',4.58),('14598','2013-08-14','14:55:00',4.58),('14598','2013-08-14','15:00:00',4.54),('14598','2013-08-14','15:05:00',4.52),('14598','2013-08-14','15:10:00',4.48),('14598','2013-08-14','15:15:00',4.42),('14598','2013-08-14','15:20:00',4.42),('14598','2013-08-14','15:25:00',4.39),('14598','2013-08-14','15:30:00',4.35),('14598','2013-08-14','15:35:00',4.32),('14598','2013-08-14','15:40:00',4.3),('14598','2013-08-14','15:45:00',4.24),('14598','2013-08-14','15:50:00',4.19),('14598','2013-08-14','15:55:00',4.14),('14598','2013-08-14','16:00:00',4.08),('14598','2013-08-14','16:05:00',3.99),('14598','2013-08-14','16:10:00',3.9),('14598','2013-08-14','16:15:00',3.87),('14598','2013-08-14','16:20:00',3.82),('14598','2013-08-14','16:25:00',3.7),('14598','2013-08-14','16:30:00',3.67),('14598','2013-08-14','16:35:00',3.59),('14598','2013-08-14','16:40:00',3.55),('14598','2013-08-14','16:45:00',3.33),('14598','2013-08-14','16:50:00',3.43),('14598','2013-08-14','16:55:00',3.35),('14598','2013-08-14','17:00:00',3.27),('14598','2013-08-14','17:05:00',3.15),('14598','2013-08-14','17:10:00',3.09),('14598','2013-08-14','17:15:00',3.01),('14598','2013-08-14','17:20:00',2.93),('14598','2013-08-14','17:25:00',2.84),('14598','2013-08-14','17:30:00',2.75),('14598','2013-08-14','17:35:00',2.67),('14598','2013-08-14','17:40:00',2.58),('14598','2013-08-14','17:45:00',2.49),('14598','2013-08-14','17:50:00',2.4),('14598','2013-08-14','17:55:00',2.3),('14598','2013-08-14','18:00:00',2.22),('14598','2013-08-14','18:05:00',2.12),('14598','2013-08-14','18:10:00',2.01),('14598','2013-08-14','18:15:00',1.89),('14598','2013-08-14','18:20:00',1.79),('14598','2013-08-14','18:25:00',1.65),('14598','2013-08-14','18:30:00',1.52),('14598','2013-08-14','18:35:00',1.45),('14598','2013-08-14','18:40:00',1.36),('14598','2013-08-14','18:45:00',1.27),('14598','2013-08-14','18:50:00',1.17),('14598','2013-08-14','18:55:00',1.07),('14598','2013-08-13','08:25:00',1.08),('14598','2013-08-13','08:30:00',1.17),('14598','2013-08-13','08:35:00',1.24),('14598','2013-08-13','08:40:00',1.34),('14598','2013-08-13','08:45:00',1.43),('14598','2013-08-13','08:50:00',1.51),('14598','2013-08-13','08:55:00',1.63),('14598','2013-08-13','09:00:00',1.72),('14598','2013-08-13','09:05:00',1.84),('14598','2013-08-13','09:10:00',1.96),('14598','2013-08-13','09:15:00',1.99),('14598','2013-08-13','09:20:00',1.98),('14598','2013-08-13','09:30:00',1.3),('14598','2013-08-13','09:35:00',1.97),('14598','2013-08-13','09:40:00',2.57),('14598','2013-08-13','09:45:00',1.34),('14598','2013-08-13','09:55:00',1.22),('14598','2013-08-13','10:05:00',1.68),('14598','2013-08-13','10:10:00',1.01),('14598','2013-08-13','10:15:00',2.93),('14598','2013-08-13','10:20:00',3.23),('14598','2013-08-13','10:25:00',3.24),('14598','2013-08-13','10:30:00',3.27),('14598','2013-08-13','10:35:00',2.67),('14598','2013-08-13','10:40:00',3.44),('14598','2013-08-13','10:45:00',3.52),('14598','2013-08-13','10:50:00',3.57),('14598','2013-08-13','10:55:00',3.62),('14598','2013-08-13','11:00:00',3.65),('14598','2013-08-13','11:05:00',3.76),('14598','2013-08-13','11:10:00',3.8),('14598','2013-08-13','11:15:00',3.87),('14598','2013-08-13','11:20:00',3.93),('14598','2013-08-13','11:25:00',3.98),('14598','2013-08-13','11:30:00',4.03),('14598','2013-08-13','11:35:00',4.08),('14598','2013-08-13','11:40:00',4.13),('14598','2013-08-13','11:45:00',4.19),('14598','2013-08-13','11:50:00',4.22),('14598','2013-08-13','11:55:00',4.26),('14598','2013-08-13','12:00:00',4.31),('14598','2013-08-13','12:05:00',4.35),('14598','2013-08-13','12:10:00',4.38),('14598','2013-08-13','12:15:00',4.41),('14598','2013-08-13','12:20:00',4.45),('14598','2013-08-13','12:25:00',4.51),('14598','2013-08-13','12:30:00',4.55),('14598','2013-08-13','12:35:00',4.59),('14598','2013-08-13','12:40:00',4.61),('14598','2013-08-13','12:45:00',4.63),('14598','2013-08-13','12:50:00',4.66),('14598','2013-08-13','12:55:00',4.69),('14598','2013-08-13','13:00:00',4.7),('14598','2013-08-13','13:05:00',4.7),('14598','2013-08-13','13:10:00',4.72),('14598','2013-08-13','13:15:00',4.73),('14598','2013-08-13','13:20:00',4.74),('14598','2013-08-13','13:25:00',4.75),('14598','2013-08-13','13:30:00',4.77),('14598','2013-08-13','13:35:00',4.79),('14598','2013-08-13','13:40:00',4.79),('14598','2013-08-13','13:45:00',4.78),('14598','2013-08-13','13:50:00',4.79),('14598','2013-08-13','13:55:00',4.79),('14598','2013-08-13','14:00:00',4.7),('14598','2013-08-13','14:05:00',4.77),('14598','2013-08-13','14:10:00',4.75),('14598','2013-08-13','14:15:00',4.73),('14598','2013-08-13','14:20:00',4.74),('14598','2013-08-13','14:25:00',4.74),('14598','2013-08-13','14:30:00',4.72),('14598','2013-08-13','14:35:00',4.71),('14598','2013-08-13','14:40:00',4.67),('14598','2013-08-13','14:45:00',4.66),('14598','2013-08-13','14:50:00',4.65),('14598','2013-08-13','14:55:00',4.62),('14598','2013-08-13','15:00:00',4.58),('14598','2013-08-13','15:05:00',4.55),('14598','2013-08-13','15:10:00',4.51),('14598','2013-08-13','15:15:00',4.47),('14598','2013-08-13','15:20:00',4.46),('14598','2013-08-13','15:25:00',4.43),('14598','2013-08-13','15:30:00',4.39),('14598','2013-08-13','15:35:00',4.35),('14598','2013-08-13','15:40:00',4.3),('14598','2013-08-13','15:45:00',4.24),('14598','2013-08-13','15:50:00',4.18),('14598','2013-08-13','15:55:00',4.14),('14598','2013-08-13','16:00:00',4.09),('14598','2013-08-13','16:05:00',4.05),('14598','2013-08-13','16:10:00',3.98),('14598','2013-08-13','16:15:00',3.91),('14598','2013-08-13','16:20:00',3.86),('14598','2013-08-13','16:25:00',3.81),('14598','2013-08-13','16:30:00',3.74),('14598','2013-08-13','16:35:00',3.68),('14598','2013-08-13','16:40:00',3.6),('14598','2013-08-13','16:45:00',3.53),('14598','2013-08-13','16:50:00',3.45),('14598','2013-08-13','16:55:00',3.36),('14598','2013-08-13','17:00:00',3.3),('14598','2013-08-13','17:05:00',3.23),('14598','2013-08-13','17:10:00',3.15),('14598','2013-08-13','17:15:00',3.06),('14598','2013-08-13','17:20:00',2.98),('14598','2013-08-13','17:25:00',2.89),('14598','2013-08-13','17:30:00',2.8),('14598','2013-08-13','17:35:00',2.72),('14598','2013-08-13','17:40:00',2.62),('14598','2013-08-13','17:45:00',2.53),('14598','2013-08-13','17:50:00',2.45),('14598','2013-08-13','17:55:00',2.36),('14598','2013-08-13','18:00:00',2.28),('14598','2013-08-13','18:05:00',2.17),('14598','2013-08-13','18:10:00',2.06),('14598','2013-08-13','18:15:00',1.95),('14598','2013-08-13','18:20:00',1.86),('14598','2013-08-13','18:25:00',1.75),('14598','2013-08-13','18:30:00',1.63),('14598','2013-08-13','18:35:00',1.53),('14598','2013-08-13','18:40:00',1.4),('14598','2013-08-13','18:45:00',1.29),('14598','2013-08-13','18:50:00',1.17),('14598','2013-08-13','18:55:00',1.11),('14598','2013-08-12','08:25:00',1.08),('14598','2013-08-12','08:30:00',1.16),('14598','2013-08-12','08:35:00',1.24),('14598','2013-08-12','08:40:00',1.33),('14598','2013-08-12','08:45:00',1.44),('14598','2013-08-12','08:50:00',1.55),('14598','2013-08-12','08:55:00',1.64),('14598','2013-08-12','09:00:00',1.73),('14598','2013-08-12','09:05:00',1.84),('14598','2013-08-12','09:10:00',1.94),('14598','2013-08-12','09:15:00',2.04),('14598','2013-08-12','09:20:00',2.13),('14598','2013-08-12','09:25:00',2.21),('14598','2013-08-12','09:30:00',2.3),('14598','2013-08-12','09:35:00',2.38),('14598','2013-08-12','09:40:00',2.46),('14598','2013-08-12','09:45:00',2.53),('14598','2013-08-12','09:50:00',2.6),('14598','2013-08-12','09:55:00',2.67),('14598','2013-08-12','10:00:00',2.73),('14598','2013-08-12','10:05:00',2.8),('14598','2013-08-12','10:10:00',2.86),('14598','2013-08-12','10:15:00',2.9),('14598','2013-08-12','10:20:00',3),('14598','2013-08-12','10:25:00',3.11),('14598','2013-08-12','10:30:00',3.18),('14598','2013-08-12','10:35:00',3.27),('14598','2013-08-12','10:40:00',3.35),('14598','2013-08-12','10:45:00',3.38),('14598','2013-08-12','10:50:00',3.48),('14598','2013-08-12','10:55:00',3.55),('14598','2013-08-12','11:00:00',3.6),('14598','2013-08-12','11:05:00',3.65),('14598','2013-08-12','11:10:00',3.75),('14598','2013-08-12','11:15:00',3.78),('14598','2013-08-12','11:20:00',3.85),('14598','2013-08-12','11:25:00',3.89),('14598','2013-08-12','11:30:00',3.94),('14598','2013-08-12','11:35:00',3.96),('14598','2013-08-12','11:40:00',4.03),('14598','2013-08-12','11:45:00',4.06),('14598','2013-08-12','11:50:00',4.12),('14598','2013-08-12','11:55:00',4.14),('14598','2013-08-12','12:00:00',4.16),('14598','2013-08-12','12:05:00',4.24),('14598','2013-08-12','12:10:00',4.27),('14598','2013-08-12','12:15:00',4.33),('14598','2013-08-12','12:20:00',4.34),('14598','2013-08-12','12:25:00',4.36),('14598','2013-08-12','12:30:00',4.39),('14598','2013-08-12','12:35:00',4.44),('14598','2013-08-12','12:40:00',4.46),('14598','2013-08-12','12:45:00',4.47),('14598','2013-08-12','12:50:00',4.5),('14598','2013-08-12','12:55:00',4.52),('14598','2013-08-12','13:00:00',4.58),('14598','2013-08-12','13:05:00',4.59),('14598','2013-08-12','13:10:00',4.6),('14598','2013-08-12','13:15:00',4.61),('14598','2013-08-12','13:20:00',4.65),('14598','2013-08-12','13:25:00',4.68),('14598','2013-08-12','13:30:00',4.7),('14598','2013-08-12','13:35:00',4.7),('14598','2013-08-12','13:40:00',4.71),('14598','2013-08-12','13:45:00',4.7),('14598','2013-08-12','13:50:00',4.69),('14598','2013-08-12','13:55:00',4.68),('14598','2013-08-12','14:00:00',4.69),('14598','2013-08-12','14:05:00',4.69),('14598','2013-08-12','14:10:00',4.69),('14598','2013-08-12','14:15:00',4.69),('14598','2013-08-12','14:20:00',4.67),('14598','2013-08-12','14:25:00',4.66),('14598','2013-08-12','14:30:00',4.66),('14598','2013-08-12','14:35:00',4.63),('14598','2013-08-12','14:40:00',4.61),('14598','2013-08-12','14:45:00',4.59),('14598','2013-08-12','14:50:00',4.54),('14598','2013-08-12','14:55:00',4.51),('14598','2013-08-12','15:00:00',4.48),('14598','2013-08-12','15:05:00',4.46),('14598','2013-08-12','15:10:00',4.45),('14598','2013-08-12','15:15:00',4.4),('14598','2013-08-12','15:20:00',4.34),('14598','2013-08-12','15:25:00',4.3),('14598','2013-08-12','15:30:00',4.27),('14598','2013-08-12','15:35:00',4.26),('14598','2013-08-12','15:40:00',4.22),('14598','2013-08-12','15:45:00',4.17),('14598','2013-08-12','15:50:00',4.12),('14598','2013-08-12','15:55:00',4.09),('14598','2013-08-12','16:00:00',4.05),('14598','2013-08-12','16:05:00',3.97),('14598','2013-08-12','16:10:00',3.91),('14598','2013-08-12','16:15:00',3.85),('14598','2013-08-12','16:20:00',3.79),('14598','2013-08-12','16:25:00',3.73),('14598','2013-08-12','16:30:00',3.67),('14598','2013-08-12','16:35:00',3.6),('14598','2013-08-12','16:40:00',3.53),('14598','2013-08-12','16:45:00',3.41),('14598','2013-08-12','16:50:00',3.4),('14598','2013-08-12','16:55:00',3.32),('14598','2013-08-12','17:00:00',3.24),('14598','2013-08-12','17:05:00',3.17),('14598','2013-08-12','17:10:00',3.1),('14598','2013-08-12','17:15:00',3.03),('14598','2013-08-12','17:20:00',2.93),('14598','2013-08-12','17:25:00',2.85),('14598','2013-08-12','17:30:00',2.78),('14598','2013-08-12','17:35:00',2.69),('14598','2013-08-12','17:40:00',2.6),('14598','2013-08-12','17:45:00',2.5),('14598','2013-08-12','17:50:00',2.42),('14598','2013-08-12','17:55:00',2.32),('14598','2013-08-12','18:00:00',2.23),('14598','2013-08-12','18:05:00',2.14),('14598','2013-08-12','18:10:00',2.05),('14598','2013-08-12','18:15:00',1.95),('14598','2013-08-12','18:20:00',1.86),('14598','2013-08-12','18:25:00',1.77),('14598','2013-08-12','18:30:00',1.66),('14598','2013-08-12','18:35:00',1.56),('14598','2013-08-12','18:40:00',1.45),('14598','2013-08-12','18:45:00',1.35),('14598','2013-08-12','18:50:00',1.24),('14598','2013-08-12','18:55:00',1.13),('14598','2013-08-12','19:00:00',1.02),('14598','2013-08-11','08:20:00',1.02),('14598','2013-08-11','08:25:00',1.11),('14598','2013-08-11','08:30:00',1.19),('14598','2013-08-11','08:35:00',1.26),('14598','2013-08-11','08:40:00',1.37),('14598','2013-08-11','08:45:00',1.49),('14598','2013-08-11','08:50:00',1.6),('14598','2013-08-11','08:55:00',1.69),('14598','2013-08-11','09:00:00',1.79),('14598','2013-08-11','09:05:00',1.9),('14598','2013-08-11','09:10:00',2),('14598','2013-08-11','09:15:00',2.11),('14598','2013-08-11','09:20:00',2.2),('14598','2013-08-11','09:25:00',2.29),('14598','2013-08-11','09:30:00',2.38),('14598','2013-08-11','09:35:00',2.46),('14598','2013-08-11','09:40:00',2.54),('14598','2013-08-11','09:45:00',2.62),('14598','2013-08-11','09:50:00',2.7),('14598','2013-08-11','09:55:00',2.78),('14598','2013-08-11','10:00:00',2.86),('14598','2013-08-11','10:05:00',2.94),('14598','2013-08-11','10:10:00',3.01),('14598','2013-08-11','10:15:00',3.1),('14598','2013-08-11','10:20:00',3.16),('14598','2013-08-11','10:25:00',3.24),('14598','2013-08-11','10:30:00',3.3),('14598','2013-08-11','10:35:00',3.36),('14598','2013-08-11','10:40:00',3.39),('14598','2013-08-11','10:45:00',3.5),('14598','2013-08-11','10:50:00',3.55),('14598','2013-08-11','10:55:00',3.61),('14598','2013-08-11','11:00:00',3.69),('14598','2013-08-11','11:05:00',3.73),('14598','2013-08-11','11:10:00',3.79),('14598','2013-08-11','11:15:00',3.85),('14598','2013-08-11','11:20:00',3.9),('14598','2013-08-11','11:25:00',3.93),('14598','2013-08-11','11:30:00',3.99),('14598','2013-08-11','11:35:00',4.03),('14598','2013-08-11','11:40:00',4.06),('14598','2013-08-11','11:45:00',4.08),('14598','2013-08-11','11:50:00',4.11),('14598','2013-08-11','11:55:00',4.11),('14598','2013-08-11','12:00:00',4.18),('14598','2013-08-11','12:05:00',4.24),('14598','2013-08-11','12:10:00',4.29),('14598','2013-08-11','12:15:00',4.3),('14598','2013-08-11','12:20:00',4.32),('14598','2013-08-11','12:25:00',4.32),('14598','2013-08-11','12:30:00',4.32),('14598','2013-08-11','12:35:00',4.39),('14598','2013-08-11','12:40:00',4.5),('14598','2013-08-11','12:45:00',4.59),('14598','2013-08-11','12:50:00',4.63),('14598','2013-08-11','12:55:00',4.66),('14598','2013-08-11','13:00:00',4.66),('14598','2013-08-11','13:05:00',4.68),('14598','2013-08-11','13:10:00',4.7),('14598','2013-08-11','13:15:00',4.71),('14598','2013-08-11','13:20:00',4.74),('14598','2013-08-11','13:25:00',4.75),('14598','2013-08-11','13:30:00',4.74),('14598','2013-08-11','13:35:00',4.76),('14598','2013-08-11','13:40:00',4.77),('14598','2013-08-11','13:45:00',4.7),('14598','2013-08-11','13:50:00',4.77),('14598','2013-08-11','13:55:00',4.77),('14598','2013-08-11','14:00:00',4.76),('14598','2013-08-11','14:05:00',4.76),('14598','2013-08-11','14:10:00',4.75),('14598','2013-08-11','14:15:00',4.75),('14598','2013-08-11','14:20:00',4.76),('14598','2013-08-11','14:25:00',4.72),('14598','2013-08-11','14:30:00',4.73),('14598','2013-08-11','14:35:00',4.71),('14598','2013-08-11','14:40:00',4.69),('14598','2013-08-11','14:45:00',4.68),('14598','2013-08-11','14:50:00',4.64),('14598','2013-08-11','14:55:00',4.63),('14598','2013-08-11','15:00:00',4.57),('14598','2013-08-11','15:05:00',4.55),('14598','2013-08-11','15:10:00',4.53),('14598','2013-08-11','15:15:00',4.48),('14598','2013-08-11','15:20:00',4.46),('14598','2013-08-11','15:25:00',4.42),('14598','2013-08-11','15:30:00',4.29),('14598','2013-08-11','15:35:00',4.34),('14598','2013-08-11','15:40:00',4.28),('14598','2013-08-11','15:45:00',4.23),('14598','2013-08-11','15:50:00',4.18),('14598','2013-08-11','15:55:00',4.14),('14598','2013-08-11','16:00:00',4.1),('14598','2013-08-11','16:05:00',4.03),('14598','2013-08-11','16:10:00',3.97),('14598','2013-08-11','16:15:00',3.92),('14598','2013-08-11','16:20:00',3.87),('14598','2013-08-11','16:25:00',3.81),('14598','2013-08-11','16:30:00',3.74),('14598','2013-08-11','16:35:00',3.67),('14598','2013-08-11','16:40:00',3.6),('14598','2013-08-11','16:45:00',3.5),('14598','2013-08-11','16:50:00',3.47),('14598','2013-08-11','16:55:00',3.39),('14598','2013-08-11','17:00:00',3.31),('14598','2013-08-11','17:05:00',3.21),('14598','2013-08-11','17:10:00',3.14),('14598','2013-08-11','17:15:00',3.06),('14598','2013-08-11','17:20:00',2.98),('14598','2013-08-11','17:25:00',2.89),('14598','2013-08-11','17:30:00',2.8),('14598','2013-08-11','17:35:00',2.7),('14598','2013-08-11','17:40:00',2.61),('14598','2013-08-11','17:45:00',2.53),('14598','2013-08-11','17:50:00',2.43),('14598','2013-08-11','17:55:00',2.33),('14598','2013-08-11','18:00:00',2.23),('14598','2013-08-11','18:05:00',2.13),('14598','2013-08-11','18:10:00',2.02),('14598','2013-08-11','18:15:00',1.93),('14598','2013-08-11','18:20:00',1.83),('14598','2013-08-11','18:25:00',1.72),('14598','2013-08-11','18:30:00',1.58),('14598','2013-08-11','18:35:00',1.51),('14598','2013-08-11','18:40:00',1.4),('14598','2013-08-11','18:45:00',1.3),('14598','2013-08-11','18:50:00',1.19),('14598','2013-08-11','18:55:00',1.08),('14598','2013-08-10','08:20:00',1.04),('14598','2013-08-10','08:25:00',1.12),('14598','2013-08-10','08:30:00',1.22),('14598','2013-08-10','08:35:00',1.3),('14598','2013-08-10','08:40:00',1.39),('14598','2013-08-10','08:45:00',1.52),('14598','2013-08-10','08:50:00',1.62),('14598','2013-08-10','08:55:00',1.72),('14598','2013-08-10','09:00:00',1.81),('14598','2013-08-10','09:05:00',1.9),('14598','2013-08-10','09:10:00',1.99),('14598','2013-08-10','09:15:00',2.11),('14598','2013-08-10','09:20:00',2.22),('14598','2013-08-10','09:25:00',2.31),('14598','2013-08-10','09:30:00',2.39),('14598','2013-08-10','09:35:00',2.48),('14598','2013-08-10','09:40:00',2.57),('14598','2013-08-10','09:45:00',2.64),('14598','2013-08-10','09:50:00',2.75),('14598','2013-08-10','09:55:00',2.82),('14598','2013-08-10','10:00:00',2.91),('14598','2013-08-10','10:05:00',2.98),('14598','2013-08-10','10:10:00',3.04),('14598','2013-08-10','10:15:00',3.14),('14598','2013-08-10','10:20:00',3.18),('14598','2013-08-10','10:25:00',3.23),('14598','2013-08-10','10:30:00',3.3),('14598','2013-08-10','10:35:00',3.37),('14598','2013-08-10','10:40:00',3.45),('14598','2013-08-10','10:45:00',3.5),('14598','2013-08-10','10:50:00',3.55),('14598','2013-08-10','10:55:00',3.6),('14598','2013-08-10','11:00:00',3.68),('14598','2013-08-10','11:05:00',3.69),('14598','2013-08-10','11:10:00',3.77),('14598','2013-08-10','11:15:00',3.81),('14598','2013-08-10','11:20:00',3.88),('14598','2013-08-10','11:25:00',3.97),('14598','2013-08-10','11:30:00',4),('14598','2013-08-10','11:35:00',4.13),('14598','2013-08-10','11:40:00',4.37),('14598','2013-08-10','11:45:00',3.42),('14598','2013-08-10','11:50:00',2.15),('14598','2013-08-10','11:55:00',1.75),('14598','2013-08-10','12:00:00',1.96),('14598','2013-08-10','12:05:00',1.37),('14598','2013-08-10','12:10:00',3.53),('14598','2013-08-10','12:15:00',4.19),('14598','2013-08-10','12:20:00',4.41),('14598','2013-08-10','12:25:00',4.38),('14598','2013-08-10','12:30:00',4.33),('14598','2013-08-10','12:35:00',2.15),('14598','2013-08-10','12:40:00',4.09),('14598','2013-08-10','12:45:00',4.5),('14598','2013-08-10','12:50:00',4.47),('14598','2013-08-10','12:55:00',4.43),('14598','2013-08-10','13:00:00',4.42),('14598','2013-08-10','13:05:00',4.6),('14598','2013-08-10','13:10:00',4.71),('14598','2013-08-10','13:15:00',4.65),('14598','2013-08-10','13:20:00',4.77),('14598','2013-08-10','13:25:00',4.78),('14598','2013-08-10','13:30:00',4.79),('14598','2013-08-10','13:35:00',4.81),('14598','2013-08-10','13:40:00',4.89),('14598','2013-08-10','13:45:00',4.89),('14598','2013-08-10','13:50:00',4.79),('14598','2013-08-10','13:55:00',4.84),('14598','2013-08-10','14:00:00',4.86),('14598','2013-08-10','14:05:00',5),('14598','2013-08-10','14:10:00',4.39),('14598','2013-08-10','14:15:00',4.92),('14598','2013-08-10','14:20:00',4.4),('14598','2013-08-10','14:25:00',3.81),('14598','2013-08-10','14:30:00',4.94),('14598','2013-08-10','14:35:00',4.27),('14598','2013-08-10','14:40:00',4.84),('14598','2013-08-10','14:45:00',4.88),('14598','2013-08-10','14:50:00',5.11),('14598','2013-08-10','14:55:00',5.25),('14598','2013-08-10','15:00:00',2.41),('14598','2013-08-10','15:05:00',1.31),('14598','2013-08-10','15:10:00',1.27),('14598','2013-08-10','16:10:00',1.16),('14598','2013-08-10','16:15:00',1.41),('14598','2013-08-10','16:20:00',2.15),('14598','2013-08-10','16:25:00',2.84),('14598','2013-08-10','16:30:00',4.7),('14598','2013-08-10','16:35:00',2.63),('14598','2013-08-10','16:40:00',2.23),('14598','2013-08-10','16:45:00',4.35),('14598','2013-08-10','16:50:00',4.25),('14598','2013-08-10','16:55:00',2.97),('14598','2013-08-10','17:00:00',1.51),('14598','2013-08-10','17:05:00',1.09),('14598','2013-08-10','17:10:00',1.14),('14598','2013-08-10','17:15:00',1.4),('14598','2013-08-10','17:20:00',1.01),('14598','2013-08-10','17:35:00',1.45),('14598','2014-04-09','08:55:00',1.37),('14598','2014-04-09','09:00:00',2.1),('14598','2014-04-09','09:05:00',1.42),('14598','2014-04-09','09:25:00',2.2),('14598','2014-04-09','09:30:00',1.55),('14598','2014-04-09','09:35:00',1.63),('14598','2014-04-09','09:40:00',1.72),('14598','2014-04-09','09:45:00',2.62),('14598','2014-04-09','09:50:00',2.64),('14598','2014-04-09','09:55:00',2.74),('14598','2014-04-09','10:00:00',2.84),('14598','2014-04-09','10:05:00',2.92),('14598','2014-04-09','10:10:00',3.03),('14598','2014-04-09','10:15:00',3.1),('14598','2014-04-09','10:20:00',3.18),('14598','2014-04-09','10:25:00',3.27),('14598','2014-04-09','10:30:00',3.37),('14598','2014-04-09','10:35:00',3.47),('14598','2014-04-09','10:40:00',3.54),('14598','2014-04-09','10:45:00',3.6),('14598','2014-04-09','10:50:00',3.69),('14598','2014-04-09','10:55:00',3.78),('14598','2014-04-09','11:00:00',3.88),('14598','2014-04-09','11:05:00',3.96),('14598','2014-04-09','11:10:00',4.02),('14598','2014-04-09','11:15:00',4.06),('14598','2014-04-09','11:20:00',4.13),('14598','2014-04-09','11:25:00',4.15),('14598','2014-04-09','11:30:00',4.18),('14598','2014-04-09','11:35:00',4.28),('14598','2014-04-09','11:40:00',4.35),('14598','2014-04-09','11:45:00',4.41),('14598','2014-04-09','11:50:00',4.43),('14598','2014-04-09','11:55:00',4.46),('14598','2014-04-09','12:00:00',4.5),('14598','2014-04-09','12:05:00',4.52),('14598','2014-04-09','12:10:00',4.54),('14598','2014-04-09','12:15:00',4.58),('14598','2014-04-09','12:20:00',4.58),('14598','2014-04-09','12:25:00',4.63),('14598','2014-04-09','12:30:00',4.68),('14598','2014-04-09','12:35:00',4.7),('14598','2014-04-09','12:40:00',4.72),('14598','2014-04-09','12:45:00',4.74),('14598','2014-04-09','12:50:00',4.75),('14598','2014-04-09','12:55:00',4.78),('14598','2014-04-09','13:00:00',4.84),('14598','2014-04-09','13:05:00',4.87),('14598','2014-04-09','13:10:00',4.89),('14598','2014-04-09','13:15:00',4.85),('14598','2014-04-09','13:20:00',4.92),('14598','2014-04-09','13:25:00',4.92),('14598','2014-04-09','13:30:00',4.93),('14598','2014-04-09','13:35:00',4.91),('14598','2014-04-09','13:40:00',4.93),('14598','2014-04-09','13:45:00',4.94),('14598','2014-04-09','13:50:00',4.93),('14598','2014-04-09','13:55:00',4.91),('14598','2014-04-09','14:00:00',4.91),('14598','2014-04-09','14:05:00',4.91),('14598','2014-04-09','14:10:00',4.9),('14598','2014-04-09','14:15:00',4.88),('14598','2014-04-09','14:20:00',4.87),('14598','2014-04-09','14:25:00',4.84),('14598','2014-04-09','14:30:00',4.78),('14598','2014-04-09','14:35:00',4.81),('14598','2014-04-09','14:40:00',4.76),('14598','2014-04-09','14:45:00',4.74),('14598','2014-04-09','14:50:00',4.71),('14598','2014-04-09','14:55:00',4.66),('14598','2014-04-09','15:00:00',4.62),('14598','2014-04-09','15:05:00',4.58),('14598','2014-04-09','15:10:00',4.55),('14598','2014-04-09','15:15:00',4.51),('14598','2014-04-09','15:20:00',4.46),('14598','2014-04-09','15:25:00',4.43),('14598','2014-04-09','15:30:00',4.38),('14598','2014-04-09','15:35:00',4.32),('14598','2014-04-09','15:40:00',4.27),('14598','2014-04-09','15:45:00',4.21),('14598','2014-04-09','15:50:00',4.16),('14598','2014-04-09','15:55:00',4.06),('14598','2014-04-09','16:00:00',4.01),('14598','2014-04-09','16:05:00',3.95),('14598','2014-04-09','16:10:00',3.85),('14598','2014-04-09','16:15:00',3.77),('14598','2014-04-09','16:20:00',3.7),('14598','2014-04-09','16:25:00',3.67),('14598','2014-04-09','16:30:00',3.62),('14598','2014-04-09','16:35:00',3.3),('14598','2014-04-09','16:40:00',3.4),('14598','2014-04-09','16:45:00',3.34),('14598','2014-04-09','16:50:00',3.25),('14598','2014-04-09','16:55:00',3.19),('14598','2014-04-09','17:00:00',3.12),('14598','2014-04-09','17:05:00',2.94),('14598','2014-04-09','17:10:00',2.91),('14598','2014-04-09','17:15:00',2.38),('14598','2014-04-09','17:20:00',2.64),('14598','2014-04-09','17:25:00',2.57),('14598','2014-04-09','17:30:00',2.19),('14598','2014-04-09','17:35:00',2.3),('14598','2014-04-09','17:40:00',2.21),('14598','2014-04-09','17:45:00',2.28),('14598','2014-04-09','17:50:00',2.31),('14598','2014-04-09','17:55:00',2.31),('14598','2014-04-09','18:00:00',1.06),('14598','2013-08-09','08:20:00',1.09),('14598','2013-08-09','08:25:00',1.31),('14598','2013-08-09','08:30:00',1.42),('14598','2013-08-09','08:35:00',1.54),('14598','2013-08-09','08:40:00',1.6),('14598','2013-08-09','08:45:00',1.68),('14598','2013-08-09','08:50:00',1.92),('14598','2013-08-09','08:55:00',1.85),('14598','2013-08-09','09:00:00',1.43),('14598','2013-08-09','09:05:00',1.09),('14598','2013-08-09','09:20:00',1.16),('14598','2013-08-09','09:25:00',1.39),('14598','2013-08-09','09:30:00',1.56),('14598','2013-08-09','09:35:00',1.71),('14598','2013-08-09','09:40:00',1.5),('14598','2013-08-09','09:45:00',1.04),('14598','2013-08-09','09:50:00',2.13),('14598','2013-08-09','09:55:00',2.73),('14598','2013-08-09','10:00:00',2.74),('14598','2013-08-09','10:05:00',2.77),('14598','2013-08-09','10:10:00',2.89),('14598','2013-08-09','10:15:00',2.95),('14598','2013-08-09','10:20:00',3.04),('14598','2013-08-09','10:25:00',3.1),('14598','2013-08-09','10:30:00',3.22),('14598','2013-08-09','10:35:00',3.26),('14598','2013-08-09','10:40:00',3.28),('14598','2013-08-09','10:45:00',3.33),('14598','2013-08-09','10:50:00',3.42),('14598','2013-08-09','10:55:00',3.47),('14598','2013-08-09','11:00:00',3.53),('14598','2013-08-09','11:05:00',3.57),('14598','2013-08-09','11:10:00',3.69),('14598','2013-08-09','11:15:00',3.71),('14598','2013-08-09','11:20:00',3.79),('14598','2013-08-09','11:25:00',3.89),('14598','2013-08-09','11:30:00',3.96),('14598','2013-08-09','11:35:00',4.13),('14598','2013-08-09','11:40:00',4.56),('14598','2013-08-09','11:45:00',4.77),('14598','2013-08-09','11:50:00',3.7),('14598','2013-08-09','11:55:00',2.55),('14598','2013-08-09','12:00:00',1.91),('14598','2013-08-09','12:05:00',1.96),('14598','2013-08-09','12:10:00',1.88),('14598','2013-08-09','12:15:00',2.16),('14598','2013-08-09','12:20:00',2.36),('14598','2013-08-09','12:25:00',2.21),('14598','2013-08-09','12:30:00',1.35),('14598','2013-08-09','12:35:00',1.29),('14598','2013-08-09','12:40:00',1.2),('14598','2013-08-09','12:45:00',1.25),('14598','2013-08-09','12:50:00',1.95),('14598','2013-08-09','12:55:00',2.42),('14598','2013-08-09','13:00:00',2.59),('14598','2013-08-09','13:05:00',2.19),('14598','2013-08-09','13:10:00',2.28),('14598','2013-08-09','13:15:00',2.41),('14598','2013-08-09','13:20:00',1.92),('14598','2013-08-09','13:25:00',1.27),('14598','2013-08-09','13:30:00',1.14),('14598','2013-08-09','13:35:00',1.4),('14598','2013-08-09','13:40:00',1.54),('14598','2013-08-09','13:45:00',1.39),('14598','2013-08-09','13:50:00',1.38),('14598','2013-08-09','13:55:00',1.25),('14598','2013-08-09','14:00:00',1.21),('14598','2013-08-09','14:05:00',1.07),('14598','2013-08-09','14:10:00',1.18),('14598','2013-08-09','14:15:00',1.13),('14598','2013-08-09','14:20:00',1.04),('14598','2013-08-09','15:05:00',1.38),('14598','2013-08-09','15:45:00',1.15),('14598','2013-08-09','15:50:00',1.17),('14598','2013-08-09','15:55:00',1.85),('14598','2013-08-09','16:00:00',3.26),('14598','2013-08-09','16:05:00',2.43),('14598','2013-08-09','17:15:00',1.18),('14598','2013-08-09','17:20:00',1.2),('14598','2013-08-09','17:25:00',1.36),('14598','2013-08-09','17:30:00',2.11),('14598','2013-08-09','17:35:00',1.21),('14598','2013-08-09','18:10:00',1.02),('14598','2013-08-09','18:35:00',1.29),('14598','2013-08-09','18:40:00',1.21),('14598','2013-08-09','18:50:00',1.34),('14598','2013-08-09','18:55:00',1.12),('14598','2013-08-09','19:00:00',1.03),('14598','2013-08-08','08:20:00',1.01),('14598','2013-08-08','08:25:00',1.11),('14598','2013-08-08','08:30:00',1.19),('14598','2013-08-08','08:35:00',1.29),('14598','2013-08-08','08:40:00',1.4),('14598','2013-08-08','08:45:00',1.49),('14598','2013-08-08','08:50:00',1.58),('14598','2013-08-08','08:55:00',1.66),('14598','2013-08-08','09:00:00',1.76),('14598','2013-08-08','09:05:00',1.87),('14598','2013-08-08','09:10:00',1.97),('14598','2013-08-08','09:15:00',2.04),('14598','2013-08-08','09:20:00',2.1),('14598','2013-08-08','09:25:00',2.2),('14598','2013-08-08','09:30:00',2.29),('14598','2013-08-08','09:35:00',2.35),('14598','2013-08-08','09:40:00',2.43),('14598','2013-08-08','09:45:00',2.5),('14598','2013-08-08','09:50:00',2.58),('14598','2013-08-08','09:55:00',2.71),('14598','2013-08-08','10:00:00',2.81),('14598','2013-08-08','10:05:00',2.88),('14598','2013-08-08','10:10:00',2.97),('14598','2013-08-08','10:15:00',3.06),('14598','2013-08-08','10:20:00',3.15),('14598','2013-08-08','10:25:00',3.24),('14598','2013-08-08','10:30:00',3.31),('14598','2013-08-08','10:35:00',3.38),('14598','2013-08-08','10:40:00',3.44),('14598','2013-08-08','10:45:00',3.52),('14598','2013-08-08','10:50:00',3.57),('14598','2013-08-08','10:55:00',3.63),('14598','2013-08-08','11:00:00',3.68),('14598','2013-08-08','11:05:00',3.75),('14598','2013-08-08','11:10:00',3.82),('14598','2013-08-08','11:15:00',3.89),('14598','2013-08-08','11:20:00',3.94),('14598','2013-08-08','11:25:00',3.97),('14598','2013-08-08','11:30:00',4.04),('14598','2013-08-08','11:35:00',4.1),('14598','2013-08-08','11:40:00',4.15),('14598','2013-08-08','11:45:00',4.18),('14598','2013-08-08','11:50:00',4.21),('14598','2013-08-08','11:55:00',4.25),('14598','2013-08-08','12:00:00',4.3),('14598','2013-08-08','12:05:00',4.36),('14598','2013-08-08','12:10:00',4.38),('14598','2013-08-08','12:15:00',4.41),('14598','2013-08-08','12:20:00',4.44),('14598','2013-08-08','12:25:00',4.45),('14598','2013-08-08','12:30:00',4.46),('14598','2013-08-08','12:35:00',4.48),('14598','2013-08-08','12:40:00',4.51),('14598','2013-08-08','12:45:00',4.54),('14598','2013-08-08','12:50:00',4.54),('14598','2013-08-08','12:55:00',4.55),('14598','2013-08-08','13:00:00',4.56),('14598','2013-08-08','13:05:00',4.59),('14598','2013-08-08','13:10:00',4.59),('14598','2013-08-08','13:15:00',4.62),('14598','2013-08-08','13:20:00',4.63),('14598','2013-08-08','13:25:00',4.64),('14598','2013-08-08','13:30:00',4.66),('14598','2013-08-08','13:35:00',4.68),('14598','2013-08-08','13:40:00',4.66),('14598','2013-08-08','13:45:00',4.64),('14598','2013-08-08','13:50:00',4.66),('14598','2013-08-08','13:55:00',4.65),('14598','2013-08-08','14:00:00',4.64),('14598','2013-08-08','14:05:00',4.63),('14598','2013-08-08','14:10:00',4.63),('14598','2013-08-08','14:15:00',4.63),('14598','2013-08-08','14:20:00',4.61),('14598','2013-08-08','14:25:00',4.54),('14598','2013-08-08','14:30:00',4.57),('14598','2013-08-08','14:35:00',4.55),('14598','2013-08-08','14:40:00',4.53),('14598','2013-08-08','14:45:00',4.51),('14598','2013-08-08','14:50:00',4.48),('14598','2013-08-08','14:55:00',4.44),('14598','2013-08-08','15:00:00',4.42),('14598','2013-08-08','15:05:00',4.39),('14598','2013-08-08','15:10:00',4.36),('14598','2013-08-08','15:15:00',4.34),('14598','2013-08-08','15:20:00',4.31),('14598','2013-08-08','15:25:00',4.26),('14598','2013-08-08','15:30:00',4.22),('14598','2013-08-08','15:35:00',4.17),('14598','2013-08-08','15:40:00',4.13),('14598','2013-08-08','15:45:00',4.09),('14598','2013-08-08','15:50:00',4.05),('14598','2013-08-08','15:55:00',4.01),('14598','2013-08-08','16:00:00',3.95),('14598','2013-08-08','16:05:00',3.92),('14598','2013-08-08','16:10:00',3.82),('14598','2013-08-08','16:15:00',3.82),('14598','2013-08-08','16:20:00',3.77),('14598','2013-08-08','16:25:00',3.71),('14598','2013-08-08','16:30:00',3.64),('14598','2013-08-08','16:35:00',3.57),('14598','2013-08-08','16:40:00',3.5),('14598','2013-08-08','16:45:00',3.43),('14598','2013-08-08','16:50:00',3.38),('14598','2013-08-08','16:55:00',3.32),('14598','2013-08-08','17:00:00',3.24),('14598','2013-08-08','17:05:00',3.16),('14598','2013-08-08','17:10:00',3.07),('14598','2013-08-08','17:15:00',3),('14598','2013-08-08','17:20:00',2.93),('14598','2013-08-08','17:25:00',2.85),('14598','2013-08-08','17:30:00',2.77),('14598','2013-08-08','17:35:00',2.69),('14598','2013-08-08','17:40:00',2.59),('14598','2013-08-08','17:45:00',2.5),('14598','2013-08-08','17:50:00',2.41),('14598','2013-08-08','17:55:00',2.31),('14598','2013-08-08','18:00:00',2.21),('14598','2013-08-08','18:05:00',2.11),('14598','2013-08-08','18:10:00',2.03),('14598','2013-08-08','18:15:00',1.93),('14598','2013-08-08','18:20:00',1.82),('14598','2013-08-08','18:25:00',1.71),('14598','2013-08-08','18:30:00',1.6),('14598','2013-08-08','18:35:00',1.51),('14598','2013-08-08','18:40:00',1.4),('14598','2013-08-08','18:45:00',1.29),('14598','2013-08-08','18:50:00',1.19),('14598','2013-08-08','18:55:00',1.1),('14598','2013-08-07','08:20:00',1.06),('14598','2013-08-07','08:25:00',1.14),('14598','2013-08-07','08:30:00',1.23),('14598','2013-08-07','08:35:00',1.33),('14598','2013-08-07','08:40:00',1.43),('14598','2013-08-07','08:45:00',1.52),('14598','2013-08-07','08:50:00',1.61),('14598','2013-08-07','08:55:00',1.69),('14598','2013-08-07','09:00:00',1.79),('14598','2013-08-07','09:05:00',1.86),('14598','2013-08-07','09:10:00',1.98),('14598','2013-08-07','09:15:00',2.1),('14598','2013-08-07','09:20:00',2.11),('14598','2013-08-07','09:25:00',2.21),('14598','2013-08-07','09:30:00',2.34),('14598','2013-08-07','09:35:00',2.41),('14598','2013-08-07','09:40:00',2.47),('14598','2013-08-07','09:45:00',2.52),('14598','2013-08-07','09:50:00',2.61),('14598','2013-08-07','09:55:00',2.77),('14598','2013-08-07','10:00:00',2.84),('14598','2013-08-07','10:05:00',2.96),('14598','2013-08-07','10:10:00',3.02),('14598','2013-08-07','10:15:00',3.12),('14598','2013-08-07','10:20:00',3.2),('14598','2013-08-07','10:25:00',3.27),('14598','2013-08-07','10:30:00',3.34),('14598','2013-08-07','10:35:00',3.42),('14598','2013-08-07','10:40:00',3.47),('14598','2013-08-07','10:45:00',3.55),('14598','2013-08-07','10:50:00',3.62),('14598','2013-08-07','10:55:00',3.68),('14598','2013-08-07','11:00:00',3.73),('14598','2013-08-07','11:05:00',3.81),('14598','2013-08-07','11:10:00',3.86),('14598','2013-08-07','11:15:00',3.93),('14598','2013-08-07','11:20:00',3.97),('14598','2013-08-07','11:25:00',4.03),('14598','2013-08-07','11:30:00',4.05),('14598','2013-08-07','11:35:00',4.11),('14598','2013-08-07','11:40:00',4.16),('14598','2013-08-07','11:45:00',4.21),('14598','2013-08-07','11:50:00',4.26),('14598','2013-08-07','11:55:00',4.31),('14598','2013-08-07','12:00:00',4.35),('14598','2013-08-07','12:05:00',4.38),('14598','2013-08-07','12:10:00',4.39),('14598','2013-08-07','12:15:00',4.43),('14598','2013-08-07','12:20:00',4.46),('14598','2013-08-07','12:25:00',4.42),('14598','2013-08-07','12:30:00',4.54),('14598','2013-08-07','12:35:00',4.58),('14598','2013-08-07','12:40:00',4.59),('14598','2013-08-07','12:45:00',4.61),('14598','2013-08-07','12:50:00',4.64),('14598','2013-08-07','12:55:00',4.67),('14598','2013-08-07','13:00:00',4.71),('14598','2013-08-07','13:05:00',4.74),('14598','2013-08-07','13:10:00',4.74),('14598','2013-08-07','13:15:00',4.73),('14598','2013-08-07','13:20:00',4.74),('14598','2013-08-07','13:25:00',4.7),('14598','2013-08-07','13:30:00',4.72),('14598','2013-08-07','13:35:00',4.72),('14598','2013-08-07','13:40:00',4.73),('14598','2013-08-07','13:45:00',4.75),('14598','2013-08-07','13:50:00',4.75),('14598','2013-08-07','13:55:00',4.77),('14598','2013-08-07','14:00:00',4.77),('14598','2013-08-07','14:05:00',4.73),('14598','2013-08-07','14:10:00',4.74),('14598','2013-08-07','14:15:00',4.74),('14598','2013-08-07','14:20:00',4.69),('14598','2013-08-07','14:25:00',4.67),('14598','2013-08-07','14:30:00',4.65),('14598','2013-08-07','14:35:00',4.66),('14598','2013-08-07','14:40:00',4.64),('14598','2013-08-07','14:45:00',4.64),('14598','2013-08-07','14:50:00',4.62),('14598','2013-08-07','14:55:00',4.58),('14598','2013-08-07','15:00:00',4.55),('14598','2013-08-07','15:05:00',4.52),('14598','2013-08-07','15:10:00',4.49),('14598','2013-08-07','15:15:00',4.48),('14598','2013-08-07','15:20:00',4.45),('14598','2013-08-07','15:25:00',4.33),('14598','2013-08-07','15:30:00',4.38),('14598','2013-08-07','15:35:00',4.33),('14598','2013-08-07','15:40:00',4.27),('14598','2013-08-07','15:45:00',4.24),('14598','2013-08-07','15:50:00',4.2),('14598','2013-08-07','15:55:00',4.15),('14598','2013-08-07','16:00:00',4.1),('14598','2013-08-07','16:05:00',4.04),('14598','2013-08-07','16:10:00',3.98),('14598','2013-08-07','16:15:00',3.91),('14598','2013-08-07','16:20:00',3.85),('14598','2013-08-07','16:25:00',3.78),('14598','2013-08-07','16:30:00',3.71),('14598','2013-08-07','16:35:00',3.64),('14598','2013-08-07','16:40:00',3.57),('14598','2013-08-07','16:45:00',3.52),('14598','2013-08-07','16:50:00',3.44),('14598','2013-08-07','16:55:00',3.37),('14598','2013-08-07','17:00:00',3.31),('14598','2013-08-07','17:05:00',3.23),('14598','2013-08-07','17:10:00',3.14),('14598','2013-08-07','17:15:00',3.07),('14598','2013-08-07','17:20:00',2.99),('14598','2013-08-07','17:25:00',2.9),('14598','2013-08-07','17:30:00',2.81),('14598','2013-08-07','17:35:00',2.72),('14598','2013-08-07','17:40:00',2.63),('14598','2013-08-07','17:45:00',2.53),('14598','2013-08-07','17:50:00',2.41),('14598','2013-08-07','17:55:00',2.3),('14598','2013-08-07','18:00:00',2.23),('14598','2013-08-07','18:05:00',2.15),('14598','2013-08-07','18:10:00',2.04),('14598','2013-08-07','18:15:00',1.91),('14598','2013-08-07','18:20:00',1.81),('14598','2013-08-07','18:25:00',1.71),('14598','2013-08-07','18:30:00',1.51),('14598','2013-08-07','18:35:00',1.51),('14598','2013-08-07','18:40:00',1.29),('14598','2013-08-07','18:45:00',1.29),('14598','2013-08-07','18:50:00',1.2),('14598','2013-08-07','18:55:00',1.13),('14598','2013-08-07','19:00:00',1.02),('14598','2013-08-06','08:20:00',1.03),('14598','2013-08-06','08:25:00',1.13),('14598','2013-08-06','08:30:00',1.22),('14598','2013-08-06','08:35:00',1.3),('14598','2013-08-06','08:40:00',1.4),('14598','2013-08-06','08:45:00',1.48),('14598','2013-08-06','08:50:00',1.57),('14598','2013-08-06','08:55:00',1.67),('14598','2013-08-06','09:00:00',1.75),('14598','2013-08-06','09:05:00',1.84),('14598','2013-08-06','09:10:00',1.93),('14598','2013-08-06','09:15:00',2.02),('14598','2013-08-06','09:20:00',1.92),('14598','2013-08-06','09:25:00',2.3),('14598','2013-08-06','09:30:00',2.34),('14598','2013-08-06','09:35:00',2.23),('14598','2013-08-06','09:40:00',2.56),('14598','2013-08-06','09:45:00',2.64),('14598','2013-08-06','09:50:00',2.75),('14598','2013-08-06','09:55:00',2.74),('14598','2013-08-06','10:00:00',2.82),('14598','2013-08-06','10:05:00',2.91),('14598','2013-08-06','10:10:00',3.01),('14598','2013-08-06','10:15:00',3.09),('14598','2013-08-06','10:20:00',3.16),('14598','2013-08-06','10:25:00',3.24),('14598','2013-08-06','10:30:00',3.3),('14598','2013-08-06','10:35:00',3.37),('14598','2013-08-06','10:40:00',3.42),('14598','2013-08-06','10:45:00',3.49),('14598','2013-08-06','10:50:00',3.57),('14598','2013-08-06','10:55:00',3.64),('14598','2013-08-06','11:00:00',3.7),('14598','2013-08-06','11:05:00',3.76),('14598','2013-08-06','11:10:00',3.82),('14598','2013-08-06','11:15:00',3.89),('14598','2013-08-06','11:20:00',3.94),('14598','2013-08-06','11:25:00',3.99),('14598','2013-08-06','11:30:00',4.04),('14598','2013-08-06','11:35:00',4.1),('14598','2013-08-06','11:40:00',4.12),('14598','2013-08-06','11:45:00',4.18),('14598','2013-08-06','11:50:00',4.23),('14598','2013-08-06','11:55:00',4.28),('14598','2013-08-06','12:00:00',4.32),('14598','2013-08-06','12:05:00',4.36),('14598','2013-08-06','12:10:00',4.4),('14598','2013-08-06','12:15:00',4.44),('14598','2013-08-06','12:20:00',4.49),('14598','2013-08-06','12:25:00',4.53),('14598','2013-08-06','12:30:00',4.55),('14598','2013-08-06','12:35:00',4.58),('14598','2013-08-06','12:40:00',4.61),('14598','2013-08-06','12:45:00',4.62),('14598','2013-08-06','12:50:00',4.64),('14598','2013-08-06','12:55:00',4.61),('14598','2013-08-06','13:00:00',4.65),('14598','2013-08-06','13:05:00',4.66),('14598','2013-08-06','13:10:00',4.67),('14598','2013-08-06','13:15:00',4.71),('14598','2013-08-06','13:20:00',4.75),('14598','2013-08-06','13:25:00',4.76),('14598','2013-08-06','13:30:00',4.76),('14598','2013-08-06','13:35:00',4.79),('14598','2013-08-06','13:40:00',4.76),('14598','2013-08-06','13:45:00',4.77),('14598','2013-08-06','13:50:00',4.77),('14598','2013-08-06','13:55:00',4.78),('14598','2013-08-06','14:00:00',4.77),('14598','2013-08-06','14:05:00',4.75),('14598','2013-08-06','14:10:00',4.74),('14598','2013-08-06','14:15:00',4.75),('14598','2013-08-06','14:20:00',4.74),('14598','2013-08-06','14:25:00',4.73),('14598','2013-08-06','14:30:00',4.73),('14598','2013-08-06','14:35:00',4.71),('14598','2013-08-06','14:40:00',4.64),('14598','2013-08-06','14:45:00',4.7),('14598','2013-08-06','14:50:00',4.68),('14598','2013-08-06','14:55:00',4.65),('14598','2013-08-06','15:00:00',4.62),('14598','2013-08-06','15:05:00',4.59),('14598','2013-08-06','15:10:00',4.52),('14598','2013-08-06','15:15:00',4.48),('14598','2013-08-06','15:20:00',4.45),('14598','2013-08-06','15:25:00',4.42),('14598','2013-08-06','15:30:00',4.38),('14598','2013-08-06','15:35:00',4.34),('14598','2013-08-06','15:40:00',4.31),('14598','2013-08-06','15:45:00',4.28),('14598','2013-08-06','15:50:00',4.25),('14598','2013-08-06','15:55:00',4.19),('14598','2013-08-06','16:00:00',4.13),('14598','2013-08-06','16:05:00',4.06),('14598','2013-08-06','16:10:00',4.03),('14598','2013-08-06','16:15:00',3.96),('14598','2013-08-06','16:20:00',3.92),('14598','2013-08-06','16:25:00',3.85),('14598','2013-08-06','16:30:00',3.79),('14598','2013-08-06','16:35:00',3.73),('14598','2013-08-06','16:40:00',3.66),('14598','2013-08-06','16:45:00',3.59),('14598','2013-08-06','16:50:00',3.52),('14598','2013-08-06','16:55:00',3.44),('14598','2013-08-06','17:00:00',3.37),('14598','2013-08-06','17:05:00',3.29),('14598','2013-08-06','17:10:00',3.22),('14598','2013-08-06','17:15:00',3.13),('14598','2013-08-06','17:20:00',3.04),('14598','2013-08-06','17:25:00',2.97),('14598','2013-08-06','17:30:00',2.84),('14598','2013-08-06','17:35:00',2.86),('14598','2013-08-06','17:40:00',2.66),('14598','2013-08-06','17:45:00',2.63),('14598','2013-08-06','17:50:00',2.51),('14598','2013-08-06','17:55:00',2.4),('14598','2013-08-06','18:00:00',2.3),('14598','2013-08-06','18:05:00',2.2),('14598','2013-08-06','18:10:00',2.09),('14598','2013-08-06','18:15:00',1.97),('14598','2013-08-06','18:20:00',1.89),('14598','2013-08-06','18:25:00',1.79),('14598','2013-08-06','18:30:00',1.7),('14598','2013-08-06','18:35:00',1.6),('14598','2013-08-06','18:40:00',1.48),('14598','2013-08-06','18:45:00',1.37),('14598','2013-08-06','18:50:00',1.25),('14598','2013-08-06','18:55:00',1.12),('14598','2013-08-06','19:00:00',1.03),('14598','2013-08-05','08:20:00',1.04),('14598','2013-08-05','08:25:00',1.14),('14598','2013-08-05','08:30:00',1.23),('14598','2013-08-05','08:35:00',1.33),('14598','2013-08-05','08:40:00',1.45),('14598','2013-08-05','08:45:00',1.55),('14598','2013-08-05','08:50:00',1.64),('14598','2013-08-05','08:55:00',1.73),('14598','2013-08-05','09:00:00',1.83),('14598','2013-08-05','09:05:00',1.93),('14598','2013-08-05','09:10:00',2.04),('14598','2013-08-05','09:15:00',2.12),('14598','2013-08-05','09:20:00',2.2),('14598','2013-08-05','09:25:00',2.28),('14598','2013-08-05','09:30:00',2.37),('14598','2013-08-05','09:35:00',2.47),('14598','2013-08-05','09:40:00',2.56),('14598','2013-08-05','09:45:00',2.67),('14598','2013-08-05','09:50:00',2.75),('14598','2013-08-05','09:55:00',2.82),('14598','2013-08-05','10:00:00',2.91),('14598','2013-08-05','10:05:00',2.99),('14598','2013-08-05','10:10:00',3.08),('14598','2013-08-05','10:15:00',3.16),('14598','2013-08-05','10:20:00',3.25),('14598','2013-08-05','10:25:00',3.31),('14598','2013-08-05','10:30:00',3.35),('14598','2013-08-05','10:35:00',3.4),('14598','2013-08-05','10:40:00',3.49),('14598','2013-08-05','10:45:00',3.54),('14598','2013-08-05','10:50:00',3.62),('14598','2013-08-05','10:55:00',3.69),('14598','2013-08-05','11:00:00',3.77),('14598','2013-08-05','11:05:00',3.82),('14598','2013-08-05','11:10:00',3.89),('14598','2013-08-05','11:15:00',3.95),('14598','2013-08-05','11:20:00',3.97),('14598','2013-08-05','11:25:00',4.03),('14598','2013-08-05','11:30:00',4.09),('14598','2013-08-05','11:35:00',4.13),('14598','2013-08-05','11:40:00',4.21),('14598','2013-08-05','11:45:00',4.24),('14598','2013-08-05','11:50:00',4.28),('14598','2013-08-05','11:55:00',4.33),('14598','2013-08-05','12:00:00',4.36),('14598','2013-08-05','12:05:00',4.4),('14598','2013-08-05','12:10:00',4.43),('14598','2013-08-05','12:15:00',4.47),('14598','2013-08-05','12:20:00',4.5),('14598','2013-08-05','12:25:00',4.52),('14598','2013-08-05','12:30:00',4.55),('14598','2013-08-05','12:35:00',4.54),('14598','2013-08-05','12:40:00',4.6),('14598','2013-08-05','12:45:00',4.63),('14598','2013-08-05','12:50:00',4.66),('14598','2013-08-05','12:55:00',4.69),('14598','2013-08-05','13:00:00',4.69),('14598','2013-08-05','13:05:00',4.71),('14598','2013-08-05','13:10:00',4.73),('14598','2013-08-05','13:15:00',4.72),('14598','2013-08-05','13:20:00',4.73),('14598','2013-08-05','13:25:00',4.75),('14598','2013-08-05','13:30:00',4.77),('14598','2013-08-05','13:35:00',4.78),('14598','2013-08-05','13:40:00',4.78),('14598','2013-08-05','13:45:00',4.78),('14598','2013-08-05','13:50:00',4.77),('14598','2013-08-05','13:55:00',4.76),('14598','2013-08-05','14:00:00',4.76),('14598','2013-08-05','14:05:00',4.76),('14598','2013-08-05','14:10:00',4.74),('14598','2013-08-05','14:15:00',4.73),('14598','2013-08-05','14:20:00',4.71),('14598','2013-08-05','14:25:00',4.65),('14598','2013-08-05','14:30:00',4.7),('14598','2013-08-05','14:35:00',4.68),('14598','2013-08-05','14:40:00',4.66),('14598','2013-08-05','14:45:00',4.62),('14598','2013-08-05','14:50:00',4.62),('14598','2013-08-05','14:55:00',4.61),('14598','2013-08-05','15:00:00',4.6),('14598','2013-08-05','15:05:00',4.57),('14598','2013-08-05','15:10:00',4.53),('14598','2013-08-05','15:15:00',4.51),('14598','2013-08-05','15:20:00',4.46),('14598','2013-08-05','15:25:00',4.45),('14598','2013-08-05','15:30:00',4.4),('14598','2013-08-05','15:35:00',4.37),('14598','2013-08-05','15:40:00',4.33),('14598','2013-08-05','15:45:00',4.31),('14598','2013-08-05','15:50:00',4.25),('14598','2013-08-05','15:55:00',4.2),('14598','2013-08-05','16:00:00',4.13),('14598','2013-08-05','16:05:00',4.07),('14598','2013-08-05','16:10:00',4.02),('14598','2013-08-05','16:15:00',3.96),('14598','2013-08-05','16:20:00',3.9),('14598','2013-08-05','16:25:00',3.84),('14598','2013-08-05','16:30:00',3.78),('14598','2013-08-05','16:35:00',3.71),('14598','2013-08-05','16:40:00',3.64),('14598','2013-08-05','16:45:00',3.54),('14598','2013-08-05','16:50:00',3.47),('14598','2013-08-05','16:55:00',3.42),('14598','2013-08-05','17:00:00',3.33),('14598','2013-08-05','17:05:00',3.25),('14598','2013-08-05','17:10:00',3.17),('14598','2013-08-05','17:15:00',3.09),('14598','2013-08-05','17:20:00',3),('14598','2013-08-05','17:25:00',2.85),('14598','2013-08-05','17:30:00',2.82),('14598','2013-08-05','17:35:00',2.74),('14598','2013-08-05','17:40:00',2.65),('14598','2013-08-05','17:45:00',2.55),('14598','2013-08-05','17:50:00',2.46),('14598','2013-08-05','17:55:00',2.38),('14598','2013-08-05','18:00:00',2.28),('14598','2013-08-05','18:05:00',2.17),('14598','2013-08-05','18:10:00',2.07),('14598','2013-08-05','18:15:00',1.96),('14598','2013-08-05','18:20:00',1.86),('14598','2013-08-05','18:25:00',1.75),('14598','2013-08-05','18:30:00',1.65),('14598','2013-08-05','18:35:00',1.54),('14598','2013-08-05','18:40:00',1.44),('14598','2013-08-05','18:45:00',1.34),('14598','2013-08-05','18:50:00',1.23),('14598','2013-08-05','18:55:00',1.11),('14598','2013-08-04','08:15:00',1.02),('14598','2013-08-04','08:20:00',1.09),('14598','2013-08-04','08:25:00',1.2),('14598','2013-08-04','08:30:00',1.31),('14598','2013-08-04','08:35:00',1.4),('14598','2013-08-04','08:40:00',1.51),('14598','2013-08-04','08:45:00',1.62),('14598','2013-08-04','08:50:00',1.71),('14598','2013-08-04','08:55:00',1.81),('14598','2013-08-04','09:00:00',1.91),('14598','2013-08-04','09:05:00',2.01),('14598','2013-08-04','09:10:00',2.13),('14598','2013-08-04','09:15:00',2.22),('14598','2013-08-04','09:20:00',2.3),('14598','2013-08-04','09:25:00',2.39),('14598','2013-08-04','09:30:00',2.48),('14598','2013-08-04','09:35:00',2.57),('14598','2013-08-04','09:40:00',2.65),('14598','2013-08-04','09:45:00',2.73),('14598','2013-08-04','09:50:00',2.8),('14598','2013-08-04','09:55:00',2.88),('14598','2013-08-04','10:00:00',2.98),('14598','2013-08-04','10:05:00',2.99),('14598','2013-08-04','10:10:00',3.14),('14598','2013-08-04','10:15:00',3.22),('14598','2013-08-04','10:20:00',3.3),('14598','2013-08-04','10:25:00',3.39),('14598','2013-08-04','10:30:00',3.46),('14598','2013-08-04','10:35:00',3.53),('14598','2013-08-04','10:40:00',3.62),('14598','2013-08-04','10:45:00',3.68),('14598','2013-08-04','10:50:00',3.75),('14598','2013-08-04','10:55:00',3.81),('14598','2013-08-04','11:00:00',3.87),('14598','2013-08-04','11:05:00',3.93),('14598','2013-08-04','11:10:00',4),('14598','2013-08-04','11:15:00',4.06),('14598','2013-08-04','11:20:00',4.09),('14598','2013-08-04','11:25:00',4.18),('14598','2013-08-04','11:30:00',4.24),('14598','2013-08-04','11:35:00',4.3),('14598','2013-08-04','11:40:00',4.35),('14598','2013-08-04','11:45:00',4.37),('14598','2013-08-04','11:50:00',4.43),('14598','2013-08-04','11:55:00',4.47),('14598','2013-08-04','12:00:00',4.5),('14598','2013-08-04','12:05:00',4.54),('14598','2013-08-04','12:10:00',4.59),('14598','2013-08-04','12:15:00',4.61),('14598','2013-08-04','12:20:00',4.64),('14598','2013-08-04','12:25:00',4.69),('14598','2013-08-04','12:30:00',4.74),('14598','2013-08-04','12:35:00',4.75),('14598','2013-08-04','12:40:00',4.75),('14598','2013-08-04','12:45:00',4.74),('14598','2013-08-04','12:50:00',4.79),('14598','2013-08-04','12:55:00',4.8),('14598','2013-08-04','13:00:00',4.84),('14598','2013-08-04','13:05:00',4.76),('14598','2013-08-04','13:10:00',4.84),('14598','2013-08-04','13:15:00',4.86),('14598','2013-08-04','13:20:00',4.87),('14598','2013-08-04','13:25:00',4.87),('14598','2013-08-04','13:30:00',4.89),('14598','2013-08-04','13:35:00',4.89),('14598','2013-08-04','13:40:00',4.9),('14598','2013-08-04','13:45:00',4.89),('14598','2013-08-04','13:50:00',4.89),('14598','2013-08-04','13:55:00',4.89),('14598','2013-08-04','14:00:00',4.87),('14598','2013-08-04','14:05:00',4.86),('14598','2013-08-04','14:10:00',4.89),('14598','2013-08-04','14:15:00',4.88),('14598','2013-08-04','14:20:00',4.8),('14598','2013-08-04','14:25:00',4.85),('14598','2013-08-04','14:30:00',4.84),('14598','2013-08-04','14:35:00',4.79),('14598','2013-08-04','14:40:00',4.77),('14598','2013-08-04','14:45:00',4.72),('14598','2013-08-04','14:50:00',4.69),('14598','2013-08-04','14:55:00',4.67),('14598','2013-08-04','15:00:00',4.68),('14598','2013-08-04','15:05:00',4.69),('14598','2013-08-04','15:10:00',4.65),('14598','2013-08-04','15:15:00',4.6),('14598','2013-08-04','15:20:00',4.59),('14598','2013-08-04','15:25:00',4.54),('14598','2013-08-04','15:30:00',4.48),('14598','2013-08-04','15:35:00',4.45),('14598','2013-08-04','15:40:00',4.42),('14598','2013-08-04','15:45:00',4.41),('14598','2013-08-04','15:50:00',4.36),('14598','2013-08-04','15:55:00',4.3),('14598','2013-08-04','16:00:00',4.24),('14598','2013-08-04','16:05:00',4.13),('14598','2013-08-04','16:10:00',4.12),('14598','2013-08-04','16:15:00',4.05),('14598','2013-08-04','16:20:00',3.97),('14598','2013-08-04','16:25:00',3.91),('14598','2013-08-04','16:30:00',3.85),('14598','2013-08-04','16:35:00',3.76),('14598','2013-08-04','16:40:00',3.69),('14598','2013-08-04','16:45:00',3.59),('14598','2013-08-04','16:50:00',3.51),('14598','2013-08-04','16:55:00',3.44),('14598','2013-08-04','17:00:00',3.36),('14598','2013-08-04','17:05:00',3.28),('14598','2013-08-04','17:10:00',3.19),('14598','2013-08-04','17:15:00',3.1),('14598','2013-08-04','17:20:00',3.03),('14598','2013-08-04','17:25:00',2.95),('14598','2013-08-04','17:30:00',2.87),('14598','2013-08-04','17:35:00',2.8),('14598','2013-08-04','17:40:00',2.7),('14598','2013-08-04','17:45:00',2.59),('14598','2013-08-04','17:50:00',2.5),('14598','2013-08-04','17:55:00',2.43),('14598','2013-08-04','18:00:00',2.32),('14598','2013-08-04','18:05:00',2.23),('14598','2013-08-04','18:10:00',2.13),('14598','2013-08-04','18:15:00',2.03),('14598','2013-08-04','18:20:00',1.95),('14598','2013-08-04','18:25:00',1.84),('14598','2013-08-04','18:30:00',1.72),('14598','2013-08-04','18:35:00',1.59),('14598','2013-08-04','18:40:00',1.47),('14598','2013-08-04','18:45:00',1.35),('14598','2013-08-04','18:50:00',1.26),('14598','2013-08-04','18:55:00',1.15),('14598','2013-08-04','19:00:00',1.04),('14598','2013-08-03','08:15:00',1.02),('14598','2013-08-03','08:20:00',1.12),('14598','2013-08-03','08:25:00',1.23),('14598','2013-08-03','08:30:00',1.33),('14598','2013-08-03','08:35:00',1.42),('14598','2013-08-03','08:40:00',1.52),('14598','2013-08-03','08:45:00',1.64),('14598','2013-08-03','08:50:00',1.73),('14598','2013-08-03','08:55:00',1.83),('14598','2013-08-03','09:00:00',1.91),('14598','2013-08-03','09:05:00',2.04),('14598','2013-08-03','09:10:00',2.15),('14598','2013-08-03','09:15:00',2.25),('14598','2013-08-03','09:20:00',2.34),('14598','2013-08-03','09:25:00',2.44),('14598','2013-08-03','09:30:00',2.52),('14598','2013-08-03','09:35:00',2.6),('14598','2013-08-03','09:40:00',2.68),('14598','2013-08-03','09:45:00',2.77),('14598','2013-08-03','09:50:00',2.84),('14598','2013-08-03','09:55:00',2.92),('14598','2013-08-03','10:00:00',3),('14598','2013-08-03','10:05:00',3.06),('14598','2013-08-03','10:10:00',3.11),('14598','2013-08-03','10:15:00',3.19),('14598','2013-08-03','10:20:00',3.29),('14598','2013-08-03','10:25:00',3.36),('14598','2013-08-03','10:30:00',3.43),('14598','2013-08-03','10:35:00',3.47),('14598','2013-08-03','10:40:00',3.5),('14598','2013-08-03','10:45:00',3.59),('14598','2013-08-03','10:50:00',3.66),('14598','2013-08-03','10:55:00',3.7),('14598','2013-08-03','11:00:00',3.78),('14598','2013-08-03','11:05:00',3.87),('14598','2013-08-03','11:10:00',3.96),('14598','2013-08-03','11:15:00',4.03),('14598','2013-08-03','11:20:00',4.07),('14598','2013-08-03','11:25:00',4.14),('14598','2013-08-03','11:30:00',4.19),('14598','2013-08-03','11:35:00',4.24),('14598','2013-08-03','11:40:00',4.3),('14598','2013-08-03','11:45:00',4.35),('14598','2013-08-03','11:50:00',4.4),('14598','2013-08-03','11:55:00',4.43),('14598','2013-08-03','12:00:00',4.46),('14598','2013-08-03','12:05:00',4.51),('14598','2013-08-03','12:10:00',4.58),('14598','2013-08-03','12:15:00',4.63),('14598','2013-08-03','12:20:00',4.66),('14598','2013-08-03','12:25:00',4.67),('14598','2013-08-03','12:30:00',4.72),('14598','2013-08-03','12:35:00',4.75),('14598','2013-08-03','12:40:00',4.78),('14598','2013-08-03','12:45:00',4.78),('14598','2013-08-03','12:50:00',4.79),('14598','2013-08-03','12:55:00',4.82),('14598','2013-08-03','13:00:00',4.85),('14598','2013-08-03','13:05:00',4.86),('14598','2013-08-03','13:10:00',4.87),('14598','2013-08-03','13:15:00',4.86),('14598','2013-08-03','13:20:00',4.84),('14598','2013-08-03','13:25:00',4.9),('14598','2013-08-03','13:30:00',4.91),('14598','2013-08-03','13:35:00',4.91),('14598','2013-08-03','13:40:00',4.92),('14598','2013-08-03','13:45:00',4.94),('14598','2013-08-03','13:50:00',4.96),('14598','2013-08-03','13:55:00',4.92),('14598','2013-08-03','14:00:00',4.93),('14598','2013-08-03','14:05:00',4.94),('14598','2013-08-03','14:10:00',4.94),('14598','2013-08-03','14:15:00',4.93),('14598','2013-08-03','14:20:00',4.91),('14598','2013-08-03','14:25:00',4.9),('14598','2013-08-03','14:30:00',4.88),('14598','2013-08-03','14:35:00',4.85),('14598','2013-08-03','14:40:00',4.84),('14598','2013-08-03','14:45:00',4.82),('14598','2013-08-03','14:50:00',4.78),('14598','2013-08-03','14:55:00',4.75),('14598','2013-08-03','15:00:00',4.72),('14598','2013-08-03','15:05:00',4.62),('14598','2013-08-03','15:10:00',4.64),('14598','2013-08-03','15:15:00',4.62),('14598','2013-08-03','15:20:00',4.57),('14598','2013-08-03','15:25:00',4.54),('14598','2013-08-03','15:30:00',4.51),('14598','2013-08-03','15:35:00',4.48),('14598','2013-08-03','15:40:00',4.43),('14598','2013-08-03','15:45:00',4.37),('14598','2013-08-03','15:50:00',4.31),('14598','2013-08-03','15:55:00',4.26),('14598','2013-08-03','16:00:00',4.22),('14598','2013-08-03','16:05:00',4.16),('14598','2013-08-03','16:10:00',4.11),('14598','2013-08-03','16:15:00',4.06),('14598','2013-08-03','16:20:00',3.97),('14598','2013-08-03','16:25:00',3.97),('14598','2013-08-03','16:30:00',3.89),('14598','2013-08-03','16:35:00',3.82),('14598','2013-08-03','16:40:00',3.78),('14598','2013-08-03','16:45:00',3.71),('14598','2013-08-03','16:50:00',3.62),('14598','2013-08-03','16:55:00',3.57),('14598','2013-08-03','17:00:00',3.49),('14598','2013-08-03','17:05:00',3.4),('14598','2013-08-03','17:10:00',3.31),('14598','2013-08-03','17:15:00',3.22),('14598','2013-08-03','17:20:00',3.18),('14598','2013-08-03','17:25:00',3.13),('14598','2013-08-03','17:30:00',3.04),('14598','2013-08-03','17:35:00',2.96),('14598','2013-08-03','17:40:00',2.86),('14598','2013-08-03','17:45:00',2.77),('14598','2013-08-03','17:50:00',2.67),('14598','2013-08-03','17:55:00',2.57),('14598','2013-08-03','18:00:00',2.47),('14598','2013-08-03','18:05:00',2.34),('14598','2013-08-03','18:10:00',2.27),('14598','2013-08-03','18:15:00',2.17),('14598','2013-08-03','18:20:00',2.07),('14598','2013-08-03','18:25:00',1.97),('14598','2013-08-03','18:30:00',1.86),('14598','2013-08-03','18:35:00',1.75),('14598','2013-08-03','18:40:00',1.64),('14598','2013-08-03','18:45:00',1.55),('14598','2013-08-03','18:50:00',1.44),('14598','2013-08-03','18:55:00',1.33),('14598','2013-08-03','19:00:00',1.22),('14598','2013-08-03','19:05:00',1.11),('14598','2013-08-03','19:10:00',1),('14598','2013-08-02','08:15:00',1.09),('14598','2013-08-02','08:20:00',1.19),('14598','2013-08-02','08:25:00',1.3),('14598','2013-08-02','08:30:00',1.4),('14598','2013-08-02','08:35:00',1.49),('14598','2013-08-02','08:40:00',1.6),('14598','2013-08-02','08:45:00',1.73),('14598','2013-08-02','08:50:00',1.83),('14598','2013-08-02','08:55:00',1.93),('14598','2013-08-02','09:00:00',2.03),('14598','2013-08-02','09:05:00',2.14),('14598','2013-08-02','09:10:00',2.26),('14598','2013-08-02','09:15:00',2.35),('14598','2013-08-02','09:20:00',2.45),('14598','2013-08-02','09:25:00',2.53),('14598','2013-08-02','09:30:00',2.61),('14598','2013-08-02','09:35:00',2.7),('14598','2013-08-02','09:40:00',2.78),('14598','2013-08-02','09:45:00',2.86),('14598','2013-08-02','09:50:00',2.94),('14598','2013-08-02','09:55:00',3.01),('14598','2013-08-02','10:00:00',3.08),('14598','2013-08-02','10:05:00',3.15),('14598','2013-08-02','10:10:00',3.22),('14598','2013-08-02','10:15:00',3.29),('14598','2013-08-02','10:20:00',3.34),('14598','2013-08-02','10:25:00',3.42),('14598','2013-08-02','10:30:00',3.48),('14598','2013-08-02','10:35:00',3.56),('14598','2013-08-02','10:40:00',3.62),('14598','2013-08-02','10:45:00',3.67),('14598','2013-08-02','10:50:00',3.72),('14598','2013-08-02','10:55:00',3.77),('14598','2013-08-02','11:00:00',3.83),('14598','2013-08-02','11:05:00',3.88),('14598','2013-08-02','11:10:00',3.93),('14598','2013-08-02','11:15:00',3.98),('14598','2013-08-02','11:20:00',4.02),('14598','2013-08-02','11:25:00',4.05),('14598','2013-08-02','11:30:00',4.14),('14598','2013-08-02','11:35:00',4.23),('14598','2013-08-02','11:40:00',4.29),('14598','2013-08-02','11:45:00',4.32),('14598','2013-08-02','11:50:00',4.32),('14598','2013-08-02','11:55:00',4.4),('14598','2013-08-02','12:00:00',4.43),('14598','2013-08-02','12:05:00',4.46),('14598','2013-08-02','12:10:00',4.52),('14598','2013-08-02','12:15:00',4.54),('14598','2013-08-02','12:20:00',4.57),('14598','2013-08-02','12:25:00',4.62),('14598','2013-08-02','12:30:00',4.65),('14598','2013-08-02','12:35:00',4.67),('14598','2013-08-02','12:40:00',4.71),('14598','2013-08-02','12:45:00',4.73),('14598','2013-08-02','12:50:00',4.75),('14598','2013-08-02','12:55:00',4.79),('14598','2013-08-02','13:00:00',4.8),('14598','2013-08-02','13:05:00',4.81),('14598','2013-08-02','13:10:00',4.83),('14598','2013-08-02','13:15:00',4.86),('14598','2013-08-02','13:20:00',4.85),('14598','2013-08-02','13:25:00',4.84),('14598','2013-08-02','13:30:00',4.85),('14598','2013-08-02','13:35:00',4.84),('14598','2013-08-02','13:40:00',4.88),('14598','2013-08-02','13:45:00',4.87),('14598','2013-08-02','13:50:00',4.85),('14598','2013-08-02','13:55:00',4.86),('14598','2013-08-02','14:00:00',4.88),('14598','2013-08-02','14:05:00',4.88),('14598','2013-08-02','14:10:00',4.86),('14598','2013-08-02','14:15:00',4.86),('14598','2013-08-02','14:20:00',4.85),('14598','2013-08-02','14:25:00',4.85),('14598','2013-08-02','14:30:00',4.84),('14598','2013-08-02','14:35:00',4.84),('14598','2013-08-02','14:40:00',4.81),('14598','2013-08-02','14:45:00',4.81),('14598','2013-08-02','14:50:00',4.77),('14598','2013-08-02','14:55:00',4.76),('14598','2013-08-02','15:00:00',4.73),('14598','2013-08-02','15:05:00',4.71),('14598','2013-08-02','15:10:00',4.69),('14598','2013-08-02','15:15:00',4.67),('14598','2013-08-02','15:20:00',4.64),('14598','2013-08-02','15:25:00',4.6),('14598','2013-08-02','15:30:00',4.57),('14598','2013-08-02','15:35:00',4.53),('14598','2013-08-02','15:40:00',4.48),('14598','2013-08-02','15:45:00',4.45),('14598','2013-08-02','15:50:00',4.4),('14598','2013-08-02','15:55:00',4.35),('14598','2013-08-02','16:00:00',4.28),('14598','2013-08-02','16:05:00',4.21),('14598','2013-08-02','16:10:00',4.17),('14598','2013-08-02','16:15:00',4.15),('14598','2013-08-02','16:20:00',4.1),('14598','2013-08-02','16:25:00',4.03),('14598','2013-08-02','16:30:00',3.98),('14598','2013-08-02','16:35:00',3.89),('14598','2013-08-02','16:40:00',3.84),('14598','2013-08-02','16:45:00',3.77),('14598','2013-08-02','16:50:00',3.72),('14598','2013-08-02','16:55:00',3.62),('14598','2013-08-02','17:00:00',3.51),('14598','2013-08-02','17:05:00',3.42),('14598','2013-08-02','17:10:00',3.36),('14598','2013-08-02','17:15:00',3.3),('14598','2013-08-02','17:20:00',3.22),('14598','2013-08-02','17:25:00',3.13),('14598','2013-08-02','17:30:00',3.07),('14598','2013-08-02','17:35:00',2.98),('14598','2013-08-02','17:40:00',2.87),('14598','2013-08-02','17:45:00',2.76),('14598','2013-08-02','17:50:00',2.69),('14598','2013-08-02','17:55:00',2.59),('14598','2013-08-02','18:00:00',2.49),('14598','2013-08-02','18:05:00',2.4),('14598','2013-08-02','18:10:00',2.3),('14598','2013-08-02','18:15:00',2.22),('14598','2013-08-02','18:20:00',2.12),('14598','2013-08-02','18:25:00',2.02),('14598','2013-08-02','18:30:00',1.91),('14598','2013-08-02','18:35:00',1.81),('14598','2013-08-02','18:40:00',1.7),('14598','2013-08-02','18:45:00',1.59),('14598','2013-08-02','18:50:00',1.49),('14598','2013-08-02','18:55:00',1.38),('14598','2013-08-02','19:00:00',1.27),('14598','2013-08-02','19:05:00',1.16),('14598','2013-08-02','19:10:00',1.06),('14598','2013-08-01','08:10:00',1.01),('14598','2013-08-01','08:15:00',1.09),('14598','2013-08-01','08:20:00',1.22),('14598','2013-08-01','08:25:00',1.32),('14598','2013-08-01','08:30:00',1.42),('14598','2013-08-01','08:35:00',1.52),('14598','2013-08-01','08:40:00',1.62),('14598','2013-08-01','08:45:00',1.75),('14598','2013-08-01','08:50:00',1.86),('14598','2013-08-01','08:55:00',1.96),('14598','2013-08-01','09:00:00',2.07),('14598','2013-08-01','09:05:00',2.18),('14598','2013-08-01','09:10:00',2.3),('14598','2013-08-01','09:15:00',2.39),('14598','2013-08-01','09:20:00',2.49),('14598','2013-08-01','09:25:00',2.58),('14598','2013-08-01','09:30:00',2.66),('14598','2013-08-01','09:35:00',2.75),('14598','2013-08-01','09:40:00',2.84),('14598','2013-08-01','09:45:00',2.92),('14598','2013-08-01','09:50:00',3.01),('14598','2013-08-01','09:55:00',3.06),('14598','2013-08-01','10:00:00',3.12),('14598','2013-08-01','10:05:00',3.24),('14598','2013-08-01','10:10:00',3.3),('14598','2013-08-01','10:15:00',3.39),('14598','2013-08-01','10:20:00',3.45),('14598','2013-08-01','10:25:00',3.51),('14598','2013-08-01','10:30:00',3.6),('14598','2013-08-01','10:35:00',3.68),('14598','2013-08-01','10:40:00',3.75),('14598','2013-08-01','10:45:00',3.8),('14598','2013-08-01','10:50:00',3.87),('14598','2013-08-01','10:55:00',3.93),('14598','2013-08-01','11:00:00',3.95),('14598','2013-08-01','11:05:00',4.01),('14598','2013-08-01','11:10:00',4.08),('14598','2013-08-01','11:15:00',4.08),('14598','2013-08-01','11:20:00',4.16),('14598','2013-08-01','11:25:00',4.2),('14598','2013-08-01','11:30:00',4.27),('14598','2013-08-01','11:35:00',4.32),('14598','2013-08-01','11:40:00',4.39),('14598','2013-08-01','11:45:00',4.45),('14598','2013-08-01','11:50:00',4.43),('14598','2013-08-01','11:55:00',4.5),('14598','2013-08-01','12:00:00',4.52),('14598','2013-08-01','12:05:00',4.59),('14598','2013-08-01','12:10:00',4.61),('14598','2013-08-01','12:15:00',4.61),('14598','2013-08-01','12:20:00',4.67),('14598','2013-08-01','12:25:00',4.71),('14598','2013-08-01','12:30:00',4.68),('14598','2013-08-01','12:35:00',4.73),('14598','2013-08-01','12:40:00',4.76),('14598','2013-08-01','12:45:00',4.77),('14598','2013-08-01','12:50:00',4.82),('14598','2013-08-01','12:55:00',4.8),('14598','2013-08-01','13:00:00',4.8),('14598','2013-08-01','13:05:00',4.86),('14598','2013-08-01','13:10:00',4.85),('14598','2013-08-01','13:15:00',4.88),('14598','2013-08-01','13:20:00',4.9),('14598','2013-08-01','13:25:00',4.89),('14598','2013-08-01','13:30:00',4.93),('14598','2013-08-01','13:35:00',4.94),('14598','2013-08-01','13:40:00',4.91),('14598','2013-08-01','13:45:00',4.89),('14598','2013-08-01','13:50:00',4.9),('14598','2013-08-01','13:55:00',4.88),('14598','2013-08-01','14:00:00',4.9),('14598','2013-08-01','14:05:00',4.87),('14598','2013-08-01','14:10:00',4.8),('14598','2013-08-01','14:15:00',4.83),('14598','2013-08-01','14:20:00',4.74),('14598','2013-08-01','14:25:00',4.8),('14598','2013-08-01','14:30:00',4.81),('14598','2013-08-01','14:35:00',4.75),('14598','2013-08-01','14:40:00',4.77),('14598','2013-08-01','14:45:00',4.77),('14598','2013-08-01','14:50:00',4.73),('14598','2013-08-01','14:55:00',4.71),('14598','2013-08-01','15:00:00',4.64),('14598','2013-08-01','15:05:00',4.61),('14598','2013-08-01','15:10:00',4.57),('14598','2013-08-01','15:15:00',4.53),('14598','2013-08-01','15:20:00',4.53),('14598','2013-08-01','15:25:00',4.5),('14598','2013-08-01','15:30:00',4.41),('14598','2013-08-01','15:35:00',4.37),('14598','2013-08-01','15:40:00',4.37),('14598','2013-08-01','15:45:00',4.34),('14598','2013-08-01','15:50:00',4.3),('14598','2013-08-01','15:55:00',4.27),('14598','2013-08-01','16:00:00',4.18),('14598','2013-08-01','16:05:00',4.1),('14598','2013-08-01','16:10:00',4.09),('14598','2013-08-01','16:25:00',3.81),('14598','2013-08-01','16:30:00',3.96),('14598','2013-08-01','16:35:00',3.9),('14598','2013-08-01','16:40:00',3.84),('14598','2013-08-01','16:45:00',3.78),('14598','2013-08-01','16:50:00',3.68),('14598','2013-08-01','16:55:00',3.61),('14598','2013-08-01','17:00:00',3.29),('14598','2013-08-01','17:05:00',3.48),('14598','2013-08-01','17:10:00',3.39),('14598','2013-08-01','17:15:00',3.32),('14598','2013-08-01','17:20:00',3.27),('14598','2013-08-01','17:25:00',3.14),('14598','2013-08-01','17:30:00',3.08),('14598','2013-08-01','17:35:00',2.97),('14598','2013-08-01','17:40:00',2.88),('14598','2013-08-01','17:45:00',2.79),('14598','2013-08-01','17:50:00',2.7),('14598','2013-08-01','17:55:00',2.63),('14598','2013-08-01','18:00:00',2.55),('14598','2013-08-01','18:05:00',2.42),('14598','2013-08-01','18:10:00',2.36),('14598','2013-08-01','18:15:00',2.25),('14598','2013-08-01','18:20:00',2.15),('14598','2013-08-01','18:25:00',2.06),('14598','2013-08-01','18:30:00',1.95),('14598','2013-08-01','18:35:00',1.84),('14598','2013-08-01','18:40:00',1.74),('14598','2013-08-01','18:45:00',1.63),('14598','2013-08-01','18:50:00',1.52),('14598','2013-08-01','18:55:00',1.41),('14598','2013-08-01','19:00:00',1.3),('14598','2013-08-01','19:05:00',1.18),('14598','2013-08-01','19:10:00',1.08),('14598','2013-07-31','08:10:00',1.02),('14598','2013-07-31','08:15:00',1.11),('14598','2013-07-31','08:20:00',1.23),('14598','2013-07-31','08:25:00',1.33),('14598','2013-07-31','08:30:00',1.42),('14598','2013-07-31','08:35:00',1.52),('14598','2013-07-31','08:40:00',1.62),('14598','2013-07-31','08:45:00',1.75),('14598','2013-07-31','08:50:00',1.84),('14598','2013-07-31','08:55:00',1.95),('14598','2013-07-31','09:00:00',2.06),('14598','2013-07-31','09:05:00',2.19),('14598','2013-07-31','09:10:00',2.3),('14598','2013-07-31','09:15:00',2.39),('14598','2013-07-31','09:20:00',2.49),('14598','2013-07-31','09:25:00',2.57),('14598','2013-07-31','09:30:00',2.66),('14598','2013-07-31','09:35:00',2.75),('14598','2013-07-31','09:40:00',2.83),('14598','2013-07-31','09:45:00',2.91),('14598','2013-07-31','09:50:00',3),('14598','2013-07-31','09:55:00',3.07),('14598','2013-07-31','10:00:00',3.15),('14598','2013-07-31','10:05:00',3.24),('14598','2013-07-31','10:10:00',3.32),('14598','2013-07-31','10:15:00',3.39),('14598','2013-07-31','10:20:00',3.45),('14598','2013-07-31','10:25:00',3.52),('14598','2013-07-31','10:30:00',3.58),('14598','2013-07-31','10:35:00',3.64),('14598','2013-07-31','10:40:00',3.7),('14598','2013-07-31','10:45:00',3.75),('14598','2013-07-31','10:50:00',3.84),('14598','2013-07-31','10:55:00',3.9),('14598','2013-07-31','11:00:00',3.97),('14598','2013-07-31','11:05:00',4.03),('14598','2013-07-31','11:10:00',4.06),('14598','2013-07-31','11:15:00',4.13),('14598','2013-07-31','11:20:00',4.2),('14598','2013-07-31','11:25:00',4.22),('14598','2013-07-31','11:30:00',4.28),('14598','2013-07-31','11:35:00',4.31),('14598','2013-07-31','11:40:00',4.36),('14598','2013-07-31','11:45:00',4.41),('14598','2013-07-31','11:50:00',4.44),('14598','2013-07-31','11:55:00',4.48),('14598','2013-07-31','12:00:00',4.55),('14598','2013-07-31','12:05:00',4.57),('14598','2013-07-31','12:10:00',4.62),('14598','2013-07-31','12:15:00',4.63),('14598','2013-07-31','12:20:00',4.64),('14598','2013-07-31','12:25:00',4.63),('14598','2013-07-31','12:30:00',4.66),('14598','2013-07-31','12:35:00',4.69),('14598','2013-07-31','12:40:00',4.71),('14598','2013-07-31','12:45:00',4.7),('14598','2013-07-31','12:50:00',4.74),('14598','2013-07-31','12:55:00',4.76),('14598','2013-07-31','13:00:00',4.06),('14598','2013-07-31','13:05:00',4.87),('14598','2013-07-31','13:10:00',4.15),('14598','2013-07-31','13:15:00',4.81),('14598','2013-07-31','13:20:00',4.89),('14598','2013-07-31','13:25:00',4.83),('14598','2013-07-31','13:30:00',4.81),('14598','2013-07-31','13:35:00',4.83),('14598','2013-07-31','13:40:00',4.84),('14598','2013-07-31','13:45:00',4.86),('14598','2013-07-31','13:50:00',4.83),('14598','2013-07-31','13:55:00',4.87),('14598','2013-07-31','14:00:00',4.34),('14598','2013-07-31','14:05:00',4.27),('14598','2013-07-31','14:10:00',4.88),('14598','2013-07-31','14:15:00',4.83),('14598','2013-07-31','14:20:00',4.82),('14598','2013-07-31','14:25:00',4.73),('14598','2013-07-31','14:30:00',4.73),('14598','2013-07-31','14:35:00',4.85),('14598','2013-07-31','14:40:00',4.91),('14598','2013-07-31','14:45:00',4.85),('14598','2013-07-31','14:50:00',4.82),('14598','2013-07-31','14:55:00',4.73),('14598','2013-07-31','15:00:00',4.77),('14598','2013-07-31','15:05:00',4.79),('14598','2013-07-31','15:10:00',4.79),('14598','2013-07-31','15:15:00',4.61),('14598','2013-07-31','15:20:00',4.58),('14598','2013-07-31','15:25:00',4.64),('14598','2013-07-31','15:30:00',4.83),('14598','2013-07-31','15:35:00',4.91),('14598','2013-07-31','15:40:00',4.27),('14598','2013-07-31','15:45:00',4.71),('14598','2013-07-31','15:50:00',4.71),('14598','2013-07-31','15:55:00',4.68),('14598','2013-07-31','16:00:00',4.55),('14598','2013-07-31','16:05:00',3.53),('14598','2013-07-31','16:10:00',3.56),('14598','2013-07-31','16:15:00',4.19),('14598','2013-07-31','16:20:00',4.11),('14598','2013-07-31','16:25:00',4.05),('14598','2013-07-31','16:30:00',4.07),('14598','2013-07-31','16:35:00',4.08),('14598','2013-07-31','16:40:00',3.96),('14598','2013-07-31','16:45:00',3.81),('14598','2013-07-31','16:50:00',3.73),('14598','2013-07-31','16:55:00',3.69),('14598','2013-07-31','17:00:00',3.62),('14598','2013-07-31','17:05:00',3.5),('14598','2013-07-31','17:10:00',3.44),('14598','2013-07-31','17:15:00',3.22),('14598','2013-07-31','17:20:00',3.27),('14598','2013-07-31','17:25:00',3.18),('14598','2013-07-31','17:30:00',3.11),('14598','2013-07-31','17:35:00',2.98),('14598','2013-07-31','17:40:00',2.88),('14598','2013-07-31','17:45:00',2.79),('14598','2013-07-31','17:50:00',2.69),('14598','2013-07-31','17:55:00',2.59),('14598','2013-07-31','18:00:00',2.48),('14598','2013-07-31','18:05:00',2.34),('14598','2013-07-31','18:10:00',2.23),('14598','2013-07-31','18:15:00',2.15),('14598','2013-07-31','18:20:00',2.09),('14598','2013-07-31','18:25:00',1.97),('14598','2013-07-31','18:30:00',1.88),('14598','2013-07-31','18:35:00',1.71),('14598','2013-07-31','18:40:00',1.57),('14598','2013-07-31','18:45:00',1.52),('14598','2013-07-31','18:50:00',1.45),('14598','2013-07-31','18:55:00',1.34),('14598','2013-07-31','19:00:00',1.24),('14598','2013-07-31','19:05:00',1.15),('14598','2013-07-31','19:10:00',1.04),('14598','2014-04-08','08:35:00',1.02),('14598','2014-04-08','08:40:00',1.12),('14598','2014-04-08','08:45:00',1.23),('14598','2014-04-08','08:50:00',1.32),('14598','2014-04-08','08:55:00',1.44),('14598','2014-04-08','09:00:00',1.53),('14598','2014-04-08','09:05:00',1.55),('14598','2014-04-08','09:10:00',1.63),('14598','2014-04-08','09:20:00',1.93),('14598','2014-04-08','09:25:00',1.7),('14598','2014-04-08','09:30:00',1.79),('14598','2014-04-08','09:35:00',1.13),('14598','2014-04-08','09:40:00',1.98),('14598','2014-04-08','09:45:00',1.42),('14598','2014-04-08','09:50:00',2.7),('14598','2014-04-08','09:55:00',2.45),('14598','2014-04-08','10:00:00',2.43),('14598','2014-04-08','10:05:00',2.21),('14598','2014-04-08','10:10:00',2.95),('14598','2014-04-08','10:15:00',3.18),('14598','2014-04-08','10:20:00',3.18),('14598','2014-04-08','10:25:00',3.31),('14598','2014-04-08','10:30:00',3.4),('14598','2014-04-08','10:35:00',3.5),('14598','2014-04-08','10:40:00',3.38),('14598','2014-04-08','10:45:00',3.14),('14598','2014-04-08','10:50:00',3.45),('14598','2014-04-08','10:55:00',3.55),('14598','2014-04-08','11:00:00',3.54),('14598','2014-04-08','11:05:00',3.59),('14598','2014-04-08','11:10:00',3.74),('14598','2014-04-08','11:15:00',3.89),('14598','2014-04-08','11:20:00',3.96),('14598','2014-04-08','11:25:00',3.98),('14598','2014-04-08','11:30:00',4.01),('14598','2014-04-08','11:35:00',4.01),('14598','2014-04-08','11:40:00',4.23),('14598','2014-04-08','11:45:00',4.36),('14598','2014-04-08','11:50:00',4.51),('14598','2014-04-08','11:55:00',4.31),('14598','2014-04-08','12:00:00',3.96),('14598','2014-04-08','12:05:00',4.47),('14598','2014-04-08','12:10:00',4.67),('14598','2014-04-08','12:15:00',4.81),('14598','2014-04-08','12:20:00',4.87),('14598','2014-04-08','12:25:00',4.52),('14598','2014-04-08','12:30:00',4.28),('14598','2014-04-08','12:35:00',4.24),('14598','2014-04-08','12:40:00',4.18),('14598','2014-04-08','12:45:00',4.05),('14598','2014-04-08','12:50:00',4.25),('14598','2014-04-08','12:55:00',4.79),('14598','2014-04-08','13:00:00',4.87),('14598','2014-04-08','13:05:00',4.88),('14598','2014-04-08','13:10:00',4.82),('14598','2014-04-08','13:15:00',4.59),('14598','2014-04-08','13:20:00',4.64),('14598','2014-04-08','13:25:00',4.96),('14598','2014-04-08','13:30:00',4.96),('14598','2014-04-08','13:35:00',5),('14598','2014-04-08','13:40:00',4.86),('14598','2014-04-08','13:45:00',4.85),('14598','2014-04-08','13:50:00',4.94),('14598','2014-04-08','13:55:00',4.99),('14598','2014-04-08','14:00:00',4.94),('14598','2014-04-08','14:05:00',4.93),('14598','2014-04-08','14:10:00',4.9),('14598','2014-04-08','14:15:00',4.66),('14598','2014-04-08','14:20:00',4.16),('14598','2014-04-08','14:25:00',4.69),('14598','2014-04-08','14:30:00',4.82),('14598','2014-04-08','14:35:00',4.25),('14598','2014-04-08','14:40:00',4.82),('14598','2014-04-08','14:45:00',4.77),('14598','2014-04-08','14:50:00',4.72),('14598','2014-04-08','14:55:00',4.64),('14598','2014-04-08','15:00:00',4.63),('14598','2014-04-08','15:05:00',4.61),('14598','2014-04-08','15:10:00',4.57),('14598','2014-04-08','15:15:00',4.48),('14598','2014-04-08','15:20:00',4.42),('14598','2014-04-08','15:25:00',4.33),('14598','2014-04-08','15:30:00',4.27),('14598','2014-04-08','15:35:00',4.34),('14598','2014-04-08','15:40:00',4.22),('14598','2014-04-08','15:45:00',4.21),('14598','2014-04-08','15:50:00',4.14),('14598','2014-04-08','15:55:00',4.11),('14598','2014-04-08','16:00:00',3.99),('14598','2014-04-08','16:05:00',3.96),('14598','2014-04-08','16:10:00',3.93),('14598','2014-04-08','16:15:00',3.79),('14598','2014-04-08','16:20:00',3.66),('14598','2014-04-08','16:25:00',3.54),('14598','2014-04-08','16:30:00',3.53),('14598','2014-04-08','16:35:00',3.52),('14598','2014-04-08','16:40:00',3.38),('14598','2014-04-08','16:45:00',3.19),('14598','2014-04-08','16:50:00',3.26),('14598','2014-04-08','16:55:00',3.05),('14598','2014-04-08','17:00:00',2.92),('14598','2014-04-08','17:05:00',2.88),('14598','2014-04-08','17:10:00',2.95),('14598','2014-04-08','17:15:00',2.66),('14598','2014-04-08','17:20:00',2.69),('14598','2014-04-08','17:25:00',2.52),('14598','2014-04-08','17:30:00',2.29),('14598','2014-04-08','17:35:00',1.81),('14598','2014-04-08','17:40:00',1.9),('14598','2014-04-08','17:45:00',2.21),('14598','2014-04-08','17:50:00',2.03),('14598','2014-04-08','17:55:00',1.76),('14598','2014-04-08','18:00:00',1.62),('14598','2014-04-08','18:05:00',1.61),('14598','2014-04-08','18:10:00',1.51),('14598','2014-04-08','18:15:00',1.34),('14598','2014-04-08','18:20:00',1.17),('14598','2013-07-30','08:15:00',1.28),('14598','2013-07-30','08:20:00',1.24),('14598','2013-07-30','08:25:00',1.33),('14598','2013-07-30','08:30:00',1.37),('14598','2013-07-30','08:35:00',1.47),('14598','2013-07-30','08:40:00',1.61),('14598','2013-07-30','08:45:00',1.7),('14598','2013-07-30','08:50:00',1.87),('14598','2013-07-30','08:55:00',1.98),('14598','2013-07-30','09:00:00',2.2),('14598','2013-07-30','09:05:00',2.38),('14598','2013-07-30','09:10:00',2.51),('14598','2013-07-30','09:15:00',2.51),('14598','2013-07-30','09:20:00',2.59),('14598','2013-07-30','09:25:00',2.27),('14598','2013-07-30','09:30:00',2.08),('14598','2013-07-30','09:35:00',2.94),('14598','2013-07-30','09:40:00',3.02),('14598','2013-07-30','09:45:00',3.09),('14598','2013-07-30','09:50:00',3.15),('14598','2013-07-30','09:55:00',3.26),('14598','2013-07-30','10:00:00',3.04),('14598','2013-07-30','10:05:00',3.37),('14598','2013-07-30','10:10:00',3.54),('14598','2013-07-30','10:15:00',3.63),('14598','2013-07-30','10:20:00',3.32),('14598','2013-07-30','10:25:00',3.47),('14598','2013-07-30','10:30:00',3.03),('14598','2013-07-30','10:35:00',4.06),('14598','2013-07-30','10:40:00',4.01),('14598','2013-07-30','10:45:00',4.14),('14598','2013-07-30','10:50:00',4.1),('14598','2013-07-30','10:55:00',4.36),('14598','2013-07-30','11:00:00',3.63),('14598','2013-07-30','11:05:00',4.14),('14598','2013-07-30','11:10:00',4.22),('14598','2013-07-30','11:15:00',4.15),('14598','2013-07-30','11:20:00',4.15),('14598','2013-07-30','11:25:00',4.23),('14598','2013-07-30','11:30:00',4.33),('14598','2013-07-30','11:35:00',4.35),('14598','2013-07-30','11:40:00',4.37),('14598','2013-07-30','11:45:00',4.43),('14598','2013-07-30','11:50:00',4.51),('14598','2013-07-30','11:55:00',4.55),('14598','2013-07-30','12:00:00',4.48),('14598','2013-07-30','12:05:00',4.58),('14598','2013-07-30','12:10:00',4.59),('14598','2013-07-30','12:15:00',4.57),('14598','2013-07-30','12:20:00',4.7),('14598','2013-07-30','12:25:00',4.74),('14598','2013-07-30','12:30:00',4.8),('14598','2013-07-30','12:35:00',4.81),('14598','2013-07-30','12:40:00',4.85),('14598','2013-07-30','12:45:00',4.87),('14598','2013-07-30','12:50:00',4.86),('14598','2013-07-30','12:55:00',4.88),('14598','2013-07-30','13:00:00',4.94),('14598','2013-07-30','13:05:00',4.95),('14598','2013-07-30','13:10:00',4.96),('14598','2013-07-30','13:15:00',4.99),('14598','2013-07-30','13:20:00',5.02),('14598','2013-07-30','13:25:00',4.99),('14598','2013-07-30','13:30:00',4.99),('14598','2013-07-30','13:35:00',4.98),('14598','2013-07-30','13:40:00',4.98),('14598','2013-07-30','13:45:00',4.96),('14598','2013-07-30','13:50:00',4.98),('14598','2013-07-30','13:55:00',4.96),('14598','2013-07-30','14:00:00',4.97),('14598','2013-07-30','14:05:00',4.97),('14598','2013-07-30','14:10:00',4.98),('14598','2013-07-30','14:15:00',4.94),('14598','2013-07-30','14:20:00',4.93),('14598','2013-07-30','14:25:00',4.9),('14598','2013-07-30','14:30:00',4.89),('14598','2013-07-30','14:35:00',4.88),('14598','2013-07-30','14:40:00',4.87),('14598','2013-07-30','14:45:00',4.88),('14598','2013-07-30','14:50:00',4.84),('14598','2013-07-30','14:55:00',4.81),('14598','2013-07-30','15:00:00',4.78),('14598','2013-07-30','15:05:00',4.79),('14598','2013-07-30','15:10:00',4.77),('14598','2013-07-30','15:15:00',4.67),('14598','2013-07-30','15:20:00',4.68),('14598','2013-07-30','15:25:00',4.65),('14598','2013-07-30','15:30:00',4.61),('14598','2013-07-30','15:35:00',4.56),('14598','2013-07-30','15:40:00',4.51),('14598','2013-07-30','15:45:00',4.47),('14598','2013-07-30','15:50:00',4.41),('14598','2013-07-30','15:55:00',4.37),('14598','2013-07-30','16:00:00',4.32),('14598','2013-07-30','16:05:00',4.26),('14598','2013-07-30','16:10:00',4.2),('14598','2013-07-30','16:15:00',4.14),('14598','2013-07-30','16:20:00',4.08),('14598','2013-07-30','16:25:00',4.03),('14598','2013-07-30','16:30:00',3.96),('14598','2013-07-30','16:35:00',3.91),('14598','2013-07-30','16:40:00',3.87),('14598','2013-07-30','16:45:00',3.8),('14598','2013-07-30','16:50:00',3.7),('14598','2013-07-30','16:55:00',3.64),('14598','2013-07-30','17:00:00',3.59),('14598','2013-07-30','17:05:00',3.42),('14598','2013-07-30','17:10:00',3.41),('14598','2013-07-30','17:15:00',3.34),('14598','2013-07-30','17:20:00',3.25),('14598','2013-07-30','17:25:00',3.18),('14598','2013-07-30','17:30:00',3.09),('14598','2013-07-30','17:35:00',3.01),('14598','2013-07-30','17:40:00',2.93),('14598','2013-07-30','17:45:00',2.83),('14598','2013-07-30','17:50:00',2.74),('14598','2013-07-30','17:55:00',2.68),('14598','2013-07-30','18:00:00',2.59),('14598','2013-07-30','18:05:00',2.48),('14598','2013-07-30','18:10:00',2.36),('14598','2013-07-30','18:15:00',2.26),('14598','2013-07-30','18:20:00',2.16),('14598','2013-07-30','18:25:00',2.06),('14598','2013-07-30','18:30:00',1.96),('14598','2013-07-30','18:35:00',1.86),('14598','2013-07-30','18:40:00',1.75),('14598','2013-07-30','18:45:00',1.64),('14598','2013-07-30','18:50:00',1.53),('14598','2013-07-30','18:55:00',1.43),('14598','2013-07-30','19:00:00',1.33),('14598','2013-07-30','19:05:00',1.22),('14598','2013-07-30','19:10:00',1.1),('14598','2013-07-29','08:10:00',1.04),('14598','2013-07-29','08:15:00',1.1),('14598','2013-07-29','08:20:00',1.2),('14598','2013-07-29','08:25:00',1.29),('14598','2013-07-29','08:30:00',1.37),('14598','2013-07-29','08:35:00',1.45),('14598','2013-07-29','08:40:00',1.54),('14598','2013-07-29','08:45:00',1.64),('14598','2013-07-29','08:50:00',1.75),('14598','2013-07-29','08:55:00',1.82),('14598','2013-07-29','09:00:00',1.93),('14598','2013-07-29','09:05:00',2.01),('14598','2013-07-29','09:10:00',2.09),('14598','2013-07-29','09:15:00',2.21),('14598','2013-07-29','09:20:00',2.31),('14598','2013-07-29','09:25:00',2.43),('14598','2013-07-29','09:30:00',2.5),('14598','2013-07-29','09:35:00',2.59),('14598','2013-07-29','09:40:00',2.66),('14598','2013-07-29','09:45:00',2.75),('14598','2013-07-29','09:50:00',2.85),('14598','2013-07-29','09:55:00',2.92),('14598','2013-07-29','10:00:00',3),('14598','2013-07-29','10:05:00',3.09),('14598','2013-07-29','10:10:00',3.16),('14598','2013-07-29','10:15:00',3.24),('14598','2013-07-29','10:20:00',3.32),('14598','2013-07-29','10:25:00',3.39),('14598','2013-07-29','10:30:00',3.47),('14598','2013-07-29','10:35:00',3.53),('14598','2013-07-29','10:40:00',3.6),('14598','2013-07-29','10:45:00',3.66),('14598','2013-07-29','10:50:00',3.72),('14598','2013-07-29','10:55:00',3.77),('14598','2013-07-29','11:00:00',3.83),('14598','2013-07-29','11:05:00',3.9),('14598','2013-07-29','11:10:00',3.95),('14598','2013-07-29','11:15:00',3.96),('14598','2013-07-29','11:20:00',4.06),('14598','2013-07-29','11:25:00',4.11),('14598','2013-07-29','11:30:00',4.18),('14598','2013-07-29','11:35:00',4.24),('14598','2013-07-29','11:40:00',4.27),('14598','2013-07-29','11:45:00',4.31),('14598','2013-07-29','11:50:00',4.36),('14598','2013-07-29','11:55:00',4.4),('14598','2013-07-29','12:00:00',4.42),('14598','2013-07-29','12:05:00',4.48),('14598','2013-07-29','12:10:00',4.48),('14598','2013-07-29','12:15:00',4.54),('14598','2013-07-29','12:20:00',4.6),('14598','2013-07-29','12:25:00',4.61),('14598','2013-07-29','12:30:00',4.62),('14598','2013-07-29','12:35:00',4.67),('14598','2013-07-29','12:40:00',4.73),('14598','2013-07-29','12:45:00',4.77),('14598','2013-07-29','12:50:00',4.75),('14598','2013-07-29','12:55:00',4.74),('14598','2013-07-29','13:00:00',4.78),('14598','2013-07-29','13:05:00',4.81),('14598','2013-07-29','13:10:00',4.8),('14598','2013-07-29','13:15:00',4.81),('14598','2013-07-29','13:20:00',4.84),('14598','2013-07-29','13:25:00',4.84),('14598','2013-07-29','13:30:00',4.84),('14598','2013-07-29','13:35:00',4.86),('14598','2013-07-29','13:40:00',4.86),('14598','2013-07-29','13:45:00',4.85),('14598','2013-07-29','13:50:00',4.85),('14598','2013-07-29','13:55:00',4.85),('14598','2013-07-29','14:00:00',4.86),('14598','2013-07-29','14:05:00',4.86),('14598','2013-07-29','14:10:00',4.86),('14598','2013-07-29','14:15:00',4.79),('14598','2013-07-29','14:20:00',4.84),('14598','2013-07-29','14:25:00',4.84),('14598','2013-07-29','14:30:00',4.82),('14598','2013-07-29','14:35:00',4.83),('14598','2013-07-29','14:40:00',4.79),('14598','2013-07-29','14:45:00',4.76),('14598','2013-07-29','14:50:00',4.79),('14598','2013-07-29','14:55:00',4.75),('14598','2013-07-29','15:00:00',4.74),('14598','2013-07-29','15:05:00',4.7),('14598','2013-07-29','15:10:00',4.66),('14598','2013-07-29','15:15:00',4.77),('14598','2013-07-29','15:20:00',4.67),('14598','2013-07-29','15:25:00',3.58),('14598','2013-07-29','15:30:00',4.07),('14598','2013-07-29','15:35:00',3.55),('14598','2013-07-29','15:40:00',3.83),('14598','2013-07-29','15:45:00',3.71),('14598','2013-07-29','15:50:00',3.07),('14598','2013-07-29','15:55:00',2.78),('14598','2013-07-29','16:00:00',2.66),('14598','2013-07-29','16:05:00',3.04),('14598','2013-07-29','16:10:00',4.61),('14598','2013-07-29','16:15:00',4.08),('14598','2013-07-29','16:20:00',4.03),('14598','2013-07-29','16:25:00',2.31),('14598','2013-07-29','16:30:00',3.09),('14598','2013-07-29','16:35:00',2.02),('14598','2013-07-29','16:40:00',1.68),('14598','2013-07-29','16:45:00',3.86),('14598','2013-07-29','16:50:00',4.28),('14598','2013-07-29','16:55:00',3.46),('14598','2013-07-29','17:00:00',3.1),('14598','2013-07-29','17:05:00',3.52),('14598','2013-07-29','17:10:00',2.62),('14598','2013-07-29','17:15:00',2.34),('14598','2013-07-29','17:20:00',2.53),('14598','2013-07-29','17:25:00',3.71),('14598','2013-07-29','17:30:00',3.35),('14598','2013-07-29','17:35:00',2.2),('14598','2013-07-29','17:40:00',1.37),('14598','2013-07-29','17:45:00',2.82),('14598','2013-07-29','17:50:00',2.82),('14598','2013-07-29','17:55:00',2.56),('14598','2013-07-29','18:00:00',2.41),('14598','2013-07-29','18:05:00',2.21),('14598','2013-07-29','18:10:00',2.2),('14598','2013-07-29','18:15:00',2.11),('14598','2013-07-29','18:20:00',1.89),('14598','2013-07-29','18:25:00',1.35),('14598','2013-07-29','18:30:00',1.12),('14598','2013-07-29','18:35:00',1.52),('14598','2013-07-29','18:40:00',1.67),('14598','2013-07-29','18:45:00',1.75),('14598','2013-07-29','18:50:00',1.23),('14598','2013-07-28','08:10:00',1.03),('14598','2013-07-28','08:15:00',1.11),('14598','2013-07-28','08:20:00',1.2),('14598','2013-07-28','08:25:00',1.29),('14598','2013-07-28','08:30:00',1.37),('14598','2013-07-28','08:35:00',1.45),('14598','2013-07-28','08:40:00',1.54),('14598','2013-07-28','08:45:00',1.64),('14598','2013-07-28','08:50:00',1.74),('14598','2013-07-28','08:55:00',1.82),('14598','2013-07-28','09:00:00',1.99),('14598','2013-07-28','09:05:00',2.03),('14598','2013-07-28','09:10:00',2.1),('14598','2013-07-28','09:15:00',2.15),('14598','2013-07-28','09:20:00',2.28),('14598','2013-07-28','09:25:00',2.14),('14598','2013-07-28','09:30:00',2.36),('14598','2013-07-28','09:35:00',2.6),('14598','2013-07-28','09:40:00',2.67),('14598','2013-07-28','09:45:00',2.8),('14598','2013-07-28','09:50:00',2.89),('14598','2013-07-28','09:55:00',2.94),('14598','2013-07-28','10:00:00',3.04),('14598','2013-07-28','10:05:00',3.12),('14598','2013-07-28','10:10:00',3.21),('14598','2013-07-28','10:15:00',3.28),('14598','2013-07-28','10:20:00',3.35),('14598','2013-07-28','10:25:00',3.41),('14598','2013-07-28','10:30:00',3.48),('14598','2013-07-28','10:35:00',3.57),('14598','2013-07-28','10:40:00',3.64),('14598','2013-07-28','10:45:00',3.7),('14598','2013-07-28','10:50:00',3.76),('14598','2013-07-28','10:55:00',3.83),('14598','2013-07-28','11:00:00',3.89),('14598','2013-07-28','11:05:00',3.95),('14598','2013-07-28','11:10:00',4),('14598','2013-07-28','11:15:00',4.05),('14598','2013-07-28','11:20:00',4.09),('14598','2013-07-28','11:25:00',4.14),('14598','2013-07-28','11:30:00',4.19),('14598','2013-07-28','11:35:00',4.24),('14598','2013-07-28','11:40:00',4.3),('14598','2013-07-28','11:45:00',4.33),('14598','2013-07-28','11:50:00',4.38),('14598','2013-07-28','11:55:00',4.43),('14598','2013-07-28','12:00:00',4.46),('14598','2013-07-28','12:05:00',4.51),('14598','2013-07-28','12:10:00',4.54),('14598','2013-07-28','12:15:00',4.53),('14598','2013-07-28','12:20:00',4.6),('14598','2013-07-28','12:25:00',4.63),('14598','2013-07-28','12:30:00',4.66),('14598','2013-07-28','12:35:00',4.7),('14598','2013-07-28','12:40:00',4.74),('14598','2013-07-28','12:45:00',4.76),('14598','2013-07-28','12:50:00',4.8),('14598','2013-07-28','12:55:00',4.83),('14598','2013-07-28','13:00:00',4.85),('14598','2013-07-28','13:05:00',4.86),('14598','2013-07-28','13:10:00',4.89),('14598','2013-07-28','13:15:00',4.9),('14598','2013-07-28','13:20:00',4.91),('14598','2013-07-28','13:25:00',4.92),('14598','2013-07-28','13:30:00',4.92),('14598','2013-07-28','13:35:00',4.92),('14598','2013-07-28','13:40:00',4.94),('14598','2013-07-28','13:45:00',4.95),('14598','2013-07-28','13:50:00',4.93),('14598','2013-07-28','13:55:00',4.92),('14598','2013-07-28','14:00:00',4.9),('14598','2013-07-28','14:05:00',4.92),('14598','2013-07-28','14:10:00',4.91),('14598','2013-07-28','14:15:00',4.91),('14598','2013-07-28','14:20:00',4.88),('14598','2013-07-28','14:25:00',4.87),('14598','2013-07-28','14:30:00',4.85),('14598','2013-07-28','14:35:00',4.82),('14598','2013-07-28','14:40:00',4.82),('14598','2013-07-28','14:45:00',4.81),('14598','2013-07-28','14:50:00',4.78),('14598','2013-07-28','14:55:00',4.76),('14598','2013-07-28','15:00:00',4.74),('14598','2013-07-28','15:05:00',4.73),('14598','2013-07-28','15:10:00',4.71),('14598','2013-07-28','15:15:00',4.64),('14598','2013-07-28','15:20:00',4.6),('14598','2013-07-28','15:25:00',4.58),('14598','2013-07-28','15:30:00',4.53),('14598','2013-07-28','15:35:00',4.49),('14598','2013-07-28','15:40:00',4.47),('14598','2013-07-28','15:45:00',4.42),('14598','2013-07-28','15:50:00',4.38),('14598','2013-07-28','15:55:00',4.34),('14598','2013-07-28','16:00:00',4.29),('14598','2013-07-28','16:05:00',4.23),('14598','2013-07-28','16:10:00',4.17),('14598','2013-07-28','16:15:00',4.12),('14598','2013-07-28','16:20:00',4.07),('14598','2013-07-28','16:25:00',4),('14598','2013-07-28','16:30:00',3.94),('14598','2013-07-28','16:35:00',3.87),('14598','2013-07-28','16:40:00',3.81),('14598','2013-07-28','16:45:00',3.56),('14598','2013-07-28','16:50:00',2.82),('14598','2013-07-28','16:55:00',3.58),('14598','2013-07-28','17:00:00',3.51),('14598','2013-07-28','17:05:00',3.43),('14598','2013-07-28','17:10:00',3.39),('14598','2013-07-28','17:15:00',3.31),('14598','2013-07-28','17:20:00',3.24),('14598','2013-07-28','17:25:00',3.16),('14598','2013-07-28','17:30:00',3.08),('14598','2013-07-28','17:35:00',2.95),('14598','2013-07-28','17:40:00',2.88),('14598','2013-07-28','17:45:00',2.81),('14598','2013-07-28','17:50:00',2.69),('14598','2013-07-28','17:55:00',2.59),('14598','2013-07-28','18:00:00',2.48),('14598','2013-07-28','18:05:00',2.4),('14598','2013-07-28','18:10:00',2.31),('14598','2013-07-28','18:15:00',2.2),('14598','2013-07-28','18:20:00',2.09),('14598','2013-07-28','18:25:00',2),('14598','2013-07-28','18:30:00',1.89),('14598','2013-07-28','18:35:00',1.81),('14598','2013-07-28','18:40:00',1.7),('14598','2013-07-28','18:45:00',1.59),('14598','2013-07-28','18:50:00',1.47),('14598','2013-07-28','18:55:00',1.35),('14598','2013-07-28','19:00:00',1.25),('14598','2013-07-28','19:05:00',1.15),('14598','2013-07-28','19:10:00',1.05),('14598','2013-07-27','08:10:00',1.04),('14598','2013-07-27','08:15:00',1.14),('14598','2013-07-27','08:20:00',1.22),('14598','2013-07-27','08:25:00',1.32),('14598','2013-07-27','08:30:00',1.42),('14598','2013-07-27','08:35:00',1.49),('14598','2013-07-27','08:40:00',1.54),('14598','2013-07-27','08:45:00',1.68),('14598','2013-07-27','08:50:00',1.77),('14598','2013-07-27','08:55:00',1.86),('14598','2013-07-27','09:00:00',1.99),('14598','2013-07-27','09:05:00',2.08),('14598','2013-07-27','09:10:00',2.18),('14598','2013-07-27','09:15:00',2.26),('14598','2013-07-27','09:20:00',2.34),('14598','2013-07-27','09:25:00',2.42),('14598','2013-07-27','09:30:00',2.52),('14598','2013-07-27','09:35:00',2.57),('14598','2013-07-27','09:40:00',2.69),('14598','2013-07-27','09:45:00',2.77),('14598','2013-07-27','09:50:00',2.82),('14598','2013-07-27','09:55:00',2.9),('14598','2013-07-27','10:00:00',2.99),('14598','2013-07-27','10:05:00',3.05),('14598','2013-07-27','10:10:00',3.14),('14598','2013-07-27','10:15:00',3.23),('14598','2013-07-27','10:20:00',3.29),('14598','2013-07-27','10:25:00',3.31),('14598','2013-07-27','10:30:00',3.4),('14598','2013-07-27','10:35:00',3.49),('14598','2013-07-27','10:40:00',3.62),('14598','2013-07-27','10:45:00',3.68),('14598','2013-07-27','10:50:00',3.75),('14598','2013-07-27','10:55:00',3.82),('14598','2013-07-27','11:00:00',3.88),('14598','2013-07-27','11:05:00',3.94),('14598','2013-07-27','11:10:00',3.92),('14598','2013-07-27','11:15:00',4.02),('14598','2013-07-27','11:20:00',4.09),('14598','2013-07-27','11:25:00',3.68),('14598','2013-07-27','11:30:00',2.94),('14598','2013-07-27','11:35:00',4.24),('14598','2013-07-27','11:40:00',3.24),('14598','2013-07-27','11:45:00',4.36),('14598','2013-07-27','11:50:00',4.42),('14598','2013-07-27','11:55:00',4.48),('14598','2013-07-27','12:00:00',4.51),('14598','2013-07-27','12:05:00',4.55),('14598','2013-07-27','12:10:00',3.67),('14598','2013-07-27','12:15:00',4.61),('14598','2013-07-27','12:20:00',4.67),('14598','2013-07-27','12:25:00',4.69),('14598','2013-07-27','12:30:00',4.71),('14598','2013-07-27','12:35:00',4.74),('14598','2013-07-27','12:40:00',4.78),('14598','2013-07-27','12:45:00',4.79),('14598','2013-07-27','12:50:00',4.85),('14598','2013-07-27','12:55:00',4.86),('14598','2013-07-27','13:00:00',4.87),('14598','2013-07-27','13:05:00',4.87),('14598','2013-07-27','13:10:00',4.89),('14598','2013-07-27','13:15:00',4.9),('14598','2013-07-27','13:20:00',4.91),('14598','2013-07-27','13:25:00',4.92),('14598','2013-07-27','13:30:00',4.9),('14598','2013-07-27','13:35:00',4.91),('14598','2013-07-27','13:40:00',4.91),('14598','2013-07-27','13:45:00',4.91),('14598','2013-07-27','13:50:00',4.92),('14598','2013-07-27','13:55:00',4.92),('14598','2013-07-27','14:00:00',4.92),('14598','2013-07-27','14:05:00',4.92),('14598','2013-07-27','14:10:00',4.93),('14598','2013-07-27','14:15:00',4.86),('14598','2013-07-27','14:20:00',4.89),('14598','2013-07-27','14:25:00',4.89),('14598','2013-07-27','14:30:00',4.87),('14598','2013-07-27','14:35:00',4.85),('14598','2013-07-27','14:40:00',4.84),('14598','2013-07-27','14:45:00',4.79),('14598','2013-07-27','14:50:00',4.78),('14598','2013-07-27','14:55:00',4.78),('14598','2013-07-27','15:00:00',4.76),('14598','2013-07-27','15:05:00',4.72),('14598','2013-07-27','15:10:00',4.7),('14598','2013-07-27','15:15:00',4.66),('14598','2013-07-27','15:20:00',4.62),('14598','2013-07-27','15:25:00',4.57),('14598','2013-07-27','15:30:00',4.51),('14598','2013-07-27','15:35:00',4.48),('14598','2013-07-27','15:40:00',4.46),('14598','2013-07-27','15:45:00',4.41),('14598','2013-07-27','15:50:00',4.39),('14598','2013-07-27','15:55:00',4.35),('14598','2013-07-27','16:00:00',4.28),('14598','2013-07-27','16:05:00',4.24),('14598','2013-07-27','16:10:00',4.17),('14598','2013-07-27','16:15:00',4.14),('14598','2013-07-27','16:20:00',4.1),('14598','2013-07-27','16:25:00',4.02),('14598','2013-07-27','16:30:00',3.97),('14598','2013-07-27','16:35:00',3.94),('14598','2013-07-27','16:40:00',3.85),('14598','2013-07-27','16:45:00',3.8),('14598','2013-07-27','16:50:00',3.74),('14598','2013-07-27','16:55:00',3.64),('14598','2013-07-27','17:00:00',3.59),('14598','2013-07-27','17:05:00',3.52),('14598','2013-07-27','17:10:00',3.45),('14598','2013-07-27','17:15:00',3.36),('14598','2013-07-27','17:20:00',3.28),('14598','2013-07-27','17:25:00',3.23),('14598','2013-07-27','17:30:00',3.11),('14598','2013-07-27','17:35:00',3.05),('14598','2013-07-27','17:40:00',2.97),('14598','2013-07-27','17:45:00',2.89),('14598','2013-07-27','17:50:00',2.78),('14598','2013-07-27','17:55:00',2.68),('14598','2013-07-27','18:00:00',2.56),('14598','2013-07-27','18:05:00',2.44),('14598','2013-07-27','18:10:00',2.35),('14598','2013-07-27','18:15:00',2.27),('14598','2013-07-27','18:20:00',2.17),('14598','2013-07-27','18:25:00',2.06),('14598','2013-07-27','18:30:00',1.95),('14598','2013-07-27','18:35:00',1.84),('14598','2013-07-27','18:40:00',1.74),('14598','2013-07-27','18:45:00',1.64),('14598','2013-07-27','18:50:00',1.52),('14598','2013-07-27','18:55:00',1.42),('14598','2013-07-27','19:00:00',1.27),('14598','2013-07-27','19:05:00',1.2),('14598','2013-07-27','19:10:00',1.08),('14598','2013-07-27','19:15:00',1),('14598','2013-07-26','07:55:00',1.12),('14598','2013-07-26','08:00:00',1.06),('14598','2013-07-26','08:05:00',1.16),('14598','2013-07-26','08:10:00',1.28),('14598','2013-07-26','08:15:00',1.37),('14598','2013-07-26','08:20:00',1.4),('14598','2013-07-26','08:25:00',1.5),('14598','2013-07-26','08:30:00',1.6),('14598','2013-07-26','08:35:00',1.62),('14598','2013-07-26','08:40:00',1.84),('14598','2013-07-26','08:45:00',2.04),('14598','2013-07-26','08:50:00',1.78),('14598','2013-07-26','08:55:00',1.64),('14598','2013-07-26','09:00:00',1.55),('14598','2013-07-26','09:05:00',1.98),('14598','2013-07-26','09:10:00',2.1),('14598','2013-07-26','09:15:00',2.17),('14598','2013-07-26','09:20:00',2.27),('14598','2013-07-26','09:25:00',2.38),('14598','2013-07-26','09:30:00',2.43),('14598','2013-07-26','09:35:00',2.52),('14598','2013-07-26','09:40:00',2.32),('14598','2013-07-26','09:45:00',2.13),('14598','2013-07-26','09:50:00',2.84),('14598','2013-07-26','09:55:00',2.84),('14598','2013-07-26','10:00:00',2.11),('14598','2013-07-26','10:05:00',1.21),('14598','2013-07-26','10:10:00',1.17),('14598','2013-07-26','10:15:00',2.73),('14598','2013-07-26','10:20:00',2.88),('14598','2013-07-26','10:25:00',3.25),('14598','2013-07-26','10:30:00',3.41),('14598','2013-07-26','10:35:00',3.42),('14598','2013-07-26','10:40:00',3.51),('14598','2013-07-26','10:45:00',3.6),('14598','2013-07-26','10:50:00',3.62),('14598','2013-07-26','10:55:00',3.65),('14598','2013-07-26','11:00:00',3.74),('14598','2013-07-26','11:05:00',3.88),('14598','2013-07-26','11:10:00',3.86),('14598','2013-07-26','11:15:00',3.92),('14598','2013-07-26','11:20:00',3.99),('14598','2013-07-26','11:25:00',4.02),('14598','2013-07-26','11:30:00',4.12),('14598','2013-07-26','11:35:00',4.17),('14598','2013-07-26','11:40:00',4.22),('14598','2013-07-26','11:45:00',4.23),('14598','2013-07-26','11:50:00',4.27),('14598','2013-07-26','11:55:00',4.32),('14598','2013-07-26','12:00:00',4.38),('14598','2013-07-26','12:05:00',4.4),('14598','2013-07-26','12:10:00',4.45),('14598','2013-07-26','12:15:00',4.47),('14598','2013-07-26','12:20:00',4.51),('14598','2013-07-26','12:25:00',4.54),('14598','2013-07-26','12:30:00',4.54),('14598','2013-07-26','12:35:00',4.58),('14598','2013-07-26','12:40:00',4.61),('14598','2013-07-26','12:45:00',4.64),('14598','2013-07-26','12:50:00',4.66),('14598','2013-07-26','12:55:00',4.69),('14598','2013-07-26','13:00:00',4.73),('14598','2013-07-26','13:05:00',4.76),('14598','2013-07-26','13:10:00',4.75),('14598','2013-07-26','13:15:00',4.73),('14598','2013-07-26','13:20:00',4.79),('14598','2013-07-26','13:25:00',4.79),('14598','2013-07-26','13:30:00',4.81),('14598','2013-07-26','13:35:00',4.8),('14598','2013-07-26','13:40:00',4.81),('14598','2013-07-26','13:45:00',4.83),('14598','2013-07-26','13:50:00',4.83),('14598','2013-07-26','13:55:00',4.84),('14598','2013-07-26','14:00:00',4.85),('14598','2013-07-26','14:05:00',4.84),('14598','2013-07-26','14:10:00',4.84),('14598','2013-07-26','14:15:00',4.83),('14598','2013-07-26','14:20:00',4.83),('14598','2013-07-26','14:25:00',4.83),('14598','2013-07-26','14:30:00',4.81),('14598','2013-07-26','14:35:00',4.78),('14598','2013-07-26','14:40:00',4.75),('14598','2013-07-26','14:45:00',4.72),('14598','2013-07-26','14:50:00',4.7),('14598','2013-07-26','14:55:00',4.7),('14598','2013-07-26','15:00:00',4.64),('14598','2013-07-26','15:05:00',4.63),('14598','2013-07-26','15:10:00',4.62),('14598','2013-07-26','15:15:00',4.59),('14598','2013-07-26','15:20:00',4.56),('14598','2013-07-26','15:25:00',4.54),('14598','2013-07-26','15:30:00',4.51),('14598','2013-07-26','15:35:00',4.45),('14598','2013-07-26','15:40:00',4.42),('14598','2013-07-26','15:45:00',4.35),('14598','2013-07-26','15:50:00',4.28),('14598','2013-07-26','15:55:00',4.24),('14598','2013-07-26','16:00:00',4.2),('14598','2013-07-26','16:05:00',4.14),('14598','2013-07-26','16:10:00',4.09),('14598','2013-07-26','16:15:00',3.98),('14598','2013-07-26','16:20:00',3.98),('14598','2013-07-26','16:25:00',3.91),('14598','2013-07-26','16:30:00',3.85),('14598','2013-07-26','16:35:00',3.78),('14598','2013-07-26','16:40:00',3.72),('14598','2013-07-26','16:45:00',3.64),('14598','2013-07-26','16:50:00',3.59),('14598','2013-07-26','16:55:00',3.51),('14598','2013-07-26','17:00:00',3.41),('14598','2013-07-26','17:05:00',3.35),('14598','2013-07-26','17:10:00',3.28),('14598','2013-07-26','17:15:00',3.2),('14598','2013-07-26','17:20:00',3.1),('14598','2013-07-26','17:25:00',3.04),('14598','2013-07-26','17:30:00',2.95),('14598','2013-07-26','17:35:00',2.86),('14598','2013-07-26','17:40:00',2.79),('14598','2013-07-26','17:45:00',2.7),('14598','2013-07-26','17:50:00',2.6),('14598','2013-07-26','17:55:00',2.49),('14598','2013-07-26','18:00:00',2.37),('14598','2013-07-26','18:05:00',2.34),('14598','2013-07-26','18:10:00',2.23),('14598','2013-07-26','18:15:00',2.14),('14598','2013-07-26','18:20:00',2.03),('14598','2013-07-26','18:25:00',1.91),('14598','2013-07-26','18:30:00',1.81),('14598','2013-07-26','18:35:00',1.68),('14598','2013-07-26','18:40:00',1.5),('14598','2013-07-26','18:45:00',1.49),('14598','2013-07-26','18:50:00',1.4),('14598','2013-07-26','18:55:00',1.29),('14598','2013-07-26','19:00:00',1.19),('14598','2013-07-26','19:05:00',1.08),('14598','2013-07-25','08:10:00',1.01),('14598','2013-07-25','08:15:00',1.04),('14598','2013-07-25','08:20:00',1.07),('14598','2013-07-25','08:25:00',1.22),('14598','2013-07-25','08:30:00',1.17),('14598','2013-07-25','08:35:00',1.03),('14598','2013-07-25','08:40:00',1.12),('14598','2013-07-25','08:45:00',1.5),('14598','2013-07-25','08:50:00',1.44),('14598','2013-07-25','08:55:00',1.88),('14598','2013-07-25','09:00:00',1.7),('14598','2013-07-25','09:05:00',2.02),('14598','2013-07-25','09:10:00',2.3),('14598','2013-07-25','09:15:00',2.46),('14598','2013-07-25','09:20:00',2.39),('14598','2013-07-25','09:25:00',2.41),('14598','2013-07-25','09:30:00',1.87),('14598','2013-07-25','09:35:00',2.05),('14598','2013-07-25','09:40:00',2.39),('14598','2013-07-25','09:45:00',1.08),('14598','2013-07-25','09:50:00',2.22),('14598','2013-07-25','09:55:00',3.02),('14598','2013-07-25','10:00:00',2.25),('14598','2013-07-25','10:05:00',2.16),('14598','2013-07-25','10:10:00',3.13),('14598','2013-07-25','10:15:00',3.29),('14598','2013-07-25','10:20:00',3.46),('14598','2013-07-25','10:25:00',3.44),('14598','2013-07-25','10:30:00',3.42),('14598','2013-07-25','10:35:00',3.48),('14598','2013-07-25','10:40:00',3.49),('14598','2013-07-25','10:45:00',3.6),('14598','2013-07-25','10:50:00',3.67),('14598','2013-07-25','10:55:00',3.75),('14598','2013-07-25','11:00:00',3.79),('14598','2013-07-25','11:05:00',3.89),('14598','2013-07-25','11:10:00',3.97),('14598','2013-07-25','11:15:00',3.99),('14598','2013-07-25','11:20:00',4.09),('14598','2013-07-25','11:25:00',4.17),('14598','2013-07-25','11:30:00',4.24),('14598','2013-07-25','11:35:00',4.24),('14598','2013-07-25','11:40:00',4.33),('14598','2013-07-25','11:45:00',4.34),('14598','2013-07-25','11:50:00',4.4),('14598','2013-07-25','11:55:00',4.43),('14598','2013-07-25','12:00:00',4.48),('14598','2013-07-25','12:05:00',4.53),('14598','2013-07-25','12:10:00',4.55),('14598','2013-07-25','12:15:00',4.58),('14598','2013-07-25','12:20:00',4.63),('14598','2013-07-25','12:25:00',4.66),('14598','2013-07-25','12:30:00',4.74),('14598','2013-07-25','12:35:00',4.75),('14598','2013-07-25','12:40:00',4.8),('14598','2013-07-25','12:45:00',4.85),('14598','2013-07-25','12:50:00',4.88),('14598','2013-07-25','12:55:00',4.89),('14598','2013-07-25','13:00:00',4.93),('14598','2013-07-25','13:05:00',4.94),('14598','2013-07-25','13:10:00',4.96),('14598','2013-07-25','13:15:00',5),('14598','2013-07-25','13:20:00',4.98),('14598','2013-07-25','13:25:00',4.99),('14598','2013-07-25','13:30:00',4.99),('14598','2013-07-25','13:35:00',4.96),('14598','2013-07-25','13:40:00',4.94),('14598','2013-07-25','13:45:00',4.97),('14598','2013-07-25','13:50:00',4.96),('14598','2013-07-25','13:55:00',4.97),('14598','2013-07-25','14:00:00',4.98),('14598','2013-07-25','14:05:00',4.98),('14598','2013-07-25','14:10:00',4.97),('14598','2013-07-25','14:15:00',4.93),('14598','2013-07-25','14:20:00',4.93),('14598','2013-07-25','14:25:00',4.82),('14598','2013-07-25','14:30:00',4.89),('14598','2013-07-25','14:35:00',4.87),('14598','2013-07-25','14:40:00',4.85),('14598','2013-07-25','14:45:00',4.83),('14598','2013-07-25','14:50:00',4.81),('14598','2013-07-25','14:55:00',4.78),('14598','2013-07-25','15:00:00',4.76),('14598','2013-07-25','15:05:00',4.72),('14598','2013-07-25','15:10:00',4.67),('14598','2013-07-25','15:15:00',4.64),('14598','2013-07-25','15:20:00',4.61),('14598','2013-07-25','15:25:00',4.6),('14598','2013-07-25','15:30:00',4.51),('14598','2013-07-25','15:35:00',4.53),('14598','2013-07-25','15:40:00',4.49),('14598','2013-07-25','15:45:00',4.47),('14598','2013-07-25','15:50:00',4.41),('14598','2013-07-25','15:55:00',4.35),('14598','2013-07-25','16:00:00',4.28),('14598','2013-07-25','16:05:00',4.25),('14598','2013-07-25','16:10:00',4.24),('14598','2013-07-25','16:15:00',4.02),('14598','2013-07-25','16:20:00',3.96),('14598','2013-07-25','16:25:00',4.02),('14598','2013-07-25','16:30:00',3.91),('14598','2013-07-25','16:35:00',3.92),('14598','2013-07-25','16:40:00',3.85),('14598','2013-07-25','16:45:00',3.8),('14598','2013-07-25','16:50:00',3.75),('14598','2013-07-25','16:55:00',3.32),('14598','2013-07-25','17:00:00',3.44),('14598','2013-07-25','17:05:00',3.49),('14598','2013-07-25','17:10:00',2.98),('14598','2013-07-25','17:15:00',3.27),('14598','2013-07-25','17:20:00',3.08),('14598','2013-07-25','17:25:00',3.09),('14598','2013-07-25','17:30:00',3.06),('14598','2013-07-25','17:35:00',3),('14598','2013-07-25','17:40:00',2.89),('14598','2013-07-25','17:45:00',2.81),('14598','2013-07-25','17:50:00',2.69),('14598','2013-07-25','17:55:00',2.62),('14598','2013-07-25','18:00:00',2.52),('14598','2013-07-25','18:05:00',2.4),('14598','2013-07-25','18:10:00',2.31),('14598','2013-07-25','18:15:00',2.22),('14598','2013-07-25','18:20:00',2.12),('14598','2013-07-25','18:25:00',2.03),('14598','2013-07-25','18:30:00',1.91),('14598','2013-07-25','18:35:00',1.83),('14598','2013-07-25','18:40:00',1.72),('14598','2013-07-25','18:45:00',1.61),('14598','2013-07-25','18:50:00',1.5),('14598','2013-07-25','18:55:00',1.41),('14598','2013-07-25','19:00:00',1.32),('14598','2013-07-25','19:05:00',1.21),('14598','2013-07-25','19:10:00',1.09),('14598','2013-07-24','08:10:00',1.04),('14598','2013-07-24','08:15:00',1.17),('14598','2013-07-24','08:20:00',1.3),('14598','2013-07-24','08:25:00',1.18),('14598','2013-07-24','08:45:00',1.6),('14598','2013-07-24','08:50:00',2),('14598','2013-07-24','08:55:00',1.77),('14598','2013-07-24','09:00:00',1.31),('14598','2013-07-24','09:05:00',1.96),('14598','2013-07-24','09:10:00',2.22),('14598','2013-07-24','09:15:00',2.38),('14598','2013-07-24','09:20:00',2.1),('14598','2013-07-24','09:25:00',2.44),('14598','2013-07-24','09:30:00',2.54),('14598','2013-07-24','09:35:00',2.62),('14598','2013-07-24','09:40:00',2.73),('14598','2013-07-24','09:45:00',2.8),('14598','2013-07-24','09:50:00',2.86),('14598','2013-07-24','09:55:00',2.98),('14598','2013-07-24','10:00:00',2.09),('14598','2013-07-24','10:05:00',3.18),('14598','2013-07-24','10:10:00',3.11),('14598','2013-07-24','10:15:00',3.3),('14598','2013-07-24','10:20:00',3.39),('14598','2013-07-24','10:25:00',3.4),('14598','2013-07-24','10:30:00',2.71),('14598','2013-07-24','10:35:00',3.72),('14598','2013-07-24','10:40:00',3.83),('14598','2013-07-24','10:45:00',3.78),('14598','2013-07-24','10:50:00',3.82),('14598','2013-07-24','10:55:00',3.83),('14598','2013-07-24','11:00:00',3.9),('14598','2013-07-24','11:05:00',3.94),('14598','2013-07-24','11:10:00',4.03),('14598','2013-07-24','11:15:00',4.05),('14598','2013-07-24','11:20:00',4.12),('14598','2013-07-24','11:25:00',4.16),('14598','2013-07-24','11:30:00',4.2),('14598','2013-07-24','11:35:00',4.25),('14598','2013-07-24','11:40:00',4.26),('14598','2013-07-24','11:45:00',4.32),('14598','2013-07-24','11:50:00',4.39),('14598','2013-07-24','11:55:00',4.43),('14598','2013-07-24','12:00:00',4.48),('14598','2013-07-24','12:05:00',4.51),('14598','2013-07-24','12:10:00',4.52),('14598','2013-07-24','12:15:00',4.56),('14598','2013-07-24','12:20:00',4.58),('14598','2013-07-24','12:25:00',4.64),('14598','2013-07-24','12:30:00',4.66),('14598','2013-07-24','12:35:00',4.67),('14598','2013-07-24','12:40:00',4.7),('14598','2013-07-24','12:45:00',4.72),('14598','2013-07-24','12:50:00',4.72),('14598','2013-07-24','12:55:00',4.77),('14598','2013-07-24','13:00:00',4.8),('14598','2013-07-24','13:05:00',4.83),('14598','2013-07-24','13:10:00',4.86),('14598','2013-07-24','13:15:00',4.88),('14598','2013-07-24','13:20:00',4.79),('14598','2013-07-24','13:25:00',4.84),('14598','2013-07-24','13:30:00',4.9),('14598','2013-07-24','13:35:00',4.93),('14598','2013-07-24','13:40:00',4.92),('14598','2013-07-24','13:45:00',4.91),('14598','2013-07-24','13:50:00',4.91),('14598','2013-07-24','13:55:00',4.91),('14598','2013-07-24','14:00:00',4.89),('14598','2013-07-24','14:05:00',4.89),('14598','2013-07-24','14:10:00',4.87),('14598','2013-07-24','14:15:00',4.86),('14598','2013-07-24','14:20:00',4.86),('14598','2013-07-24','14:25:00',4.85),('14598','2013-07-24','14:30:00',4.85),('14598','2013-07-24','14:35:00',4.83),('14598','2013-07-24','14:40:00',4.81),('14598','2013-07-24','14:45:00',4.84),('14598','2013-07-24','14:50:00',4.83),('14598','2013-07-24','14:55:00',4.8),('14598','2013-07-24','15:00:00',4.78),('14598','2013-07-24','15:05:00',4.77),('14598','2013-07-24','15:10:00',4.73),('14598','2013-07-24','15:15:00',4.72),('14598','2013-07-24','15:20:00',4.67),('14598','2013-07-24','15:25:00',4.62),('14598','2013-07-24','15:30:00',4.59),('14598','2013-07-24','15:35:00',4.56),('14598','2013-07-24','15:40:00',4.6),('14598','2013-07-24','15:45:00',4.52),('14598','2013-07-24','15:50:00',4.33),('14598','2013-07-24','15:55:00',4.25),('14598','2013-07-24','16:00:00',4.32),('14598','2013-07-24','16:05:00',4.31),('14598','2013-07-24','16:10:00',4.29),('14598','2013-07-24','16:15:00',4.24),('14598','2013-07-24','16:20:00',4.2),('14598','2013-07-24','16:25:00',4.14),('14598','2013-07-24','16:30:00',4.04),('14598','2013-07-24','16:35:00',4.01),('14598','2013-07-24','16:40:00',3.93),('14598','2013-07-24','16:45:00',3.84),('14598','2013-07-24','16:50:00',3.74),('14598','2013-07-24','16:55:00',3.66),('14598','2013-07-24','17:00:00',3.58),('14598','2013-07-24','17:05:00',3.49),('14598','2013-07-24','17:10:00',3.39),('14598','2013-07-24','17:15:00',3.28),('14598','2013-07-24','17:20:00',3.17),('14598','2013-07-24','17:25:00',3.04),('14598','2013-07-24','17:30:00',2.99),('14598','2013-07-24','17:35:00',2.88),('14598','2013-07-24','17:40:00',2.8),('14598','2013-07-24','17:45:00',2.65),('14598','2013-07-24','17:50:00',2.66),('14598','2013-07-24','17:55:00',2.61),('14598','2013-07-24','18:00:00',2.41),('14598','2013-07-24','18:05:00',1.95),('14598','2013-07-24','18:10:00',2.17),('14598','2013-07-24','18:15:00',1.85),('14598','2013-07-24','18:20:00',1.96),('14598','2013-07-24','18:25:00',1.82),('14598','2013-07-24','18:30:00',1.71),('14598','2013-07-24','18:35:00',1.79),('14598','2013-07-24','18:40:00',1.67),('14598','2013-07-24','18:45:00',1.4),('14598','2013-07-24','18:50:00',1.45),('14598','2013-07-24','18:55:00',1.36),('14598','2013-07-24','19:00:00',1.23),('14598','2013-07-23','08:10:00',1.07),('14598','2013-07-23','08:15:00',1.16),('14598','2013-07-23','08:20:00',1.24),('14598','2013-07-23','08:25:00',1.33),('14598','2013-07-23','08:30:00',1.41),('14598','2013-07-23','08:35:00',1.49),('14598','2013-07-23','08:40:00',1.59),('14598','2013-07-23','08:45:00',1.7),('14598','2013-07-23','08:50:00',1.79),('14598','2013-07-23','08:55:00',1.9),('14598','2013-07-23','09:00:00',2),('14598','2013-07-23','09:05:00',2.11),('14598','2013-07-23','09:10:00',2.2),('14598','2013-07-23','09:15:00',2.3),('14598','2013-07-23','09:20:00',2.39),('14598','2013-07-23','09:25:00',2.48),('14598','2013-07-23','09:30:00',2.55),('14598','2013-07-23','09:35:00',2.63),('14598','2013-07-23','09:40:00',2.7),('14598','2013-07-23','09:45:00',2.77),('14598','2013-07-23','09:50:00',2.84),('14598','2013-07-23','09:55:00',2.92),('14598','2013-07-23','10:00:00',2.99),('14598','2013-07-23','10:05:00',3.06),('14598','2013-07-23','10:10:00',3.12),('14598','2013-07-23','10:15:00',3.19),('14598','2013-07-23','10:20:00',3.23),('14598','2013-07-23','10:25:00',3.32),('14598','2013-07-23','10:30:00',3.44),('14598','2013-07-23','10:35:00',3.44),('14598','2013-07-23','10:40:00',3.57),('14598','2013-07-23','10:45:00',3.66),('14598','2013-07-23','10:50:00',3.7),('14598','2013-07-23','10:55:00',3.75),('14598','2013-07-23','11:00:00',3.82),('14598','2013-07-23','11:05:00',3.9),('14598','2013-07-23','11:10:00',3.94),('14598','2013-07-23','11:15:00',4),('14598','2013-07-23','11:20:00',4.06),('14598','2013-07-23','11:25:00',4.1),('14598','2013-07-23','11:30:00',4.15),('14598','2013-07-23','11:35:00',4.19),('14598','2013-07-23','11:40:00',3.38),('14598','2013-07-23','11:45:00',4.26),('14598','2013-07-23','11:50:00',4.33),('14598','2013-07-23','11:55:00',4.36),('14598','2013-07-23','12:00:00',4.42),('14598','2013-07-23','12:05:00',4.44),('14598','2013-07-23','12:10:00',4.48),('14598','2013-07-23','12:15:00',4.53),('14598','2013-07-23','12:20:00',4.55),('14598','2013-07-23','12:25:00',4.57),('14598','2013-07-23','12:30:00',4.61),('14598','2013-07-23','12:35:00',4.65),('14598','2013-07-23','12:40:00',4.68),('14598','2013-07-23','12:45:00',4.71),('14598','2013-07-23','12:50:00',4.74),('14598','2013-07-23','12:55:00',4.75),('14598','2013-07-23','13:00:00',4.78),('14598','2013-07-23','13:05:00',4.81),('14598','2013-07-23','13:10:00',4.82),('14598','2013-07-23','13:15:00',4.84),('14598','2013-07-23','13:20:00',4.85),('14598','2013-07-23','13:25:00',4.87),('14598','2013-07-23','13:30:00',4.89),('14598','2013-07-23','13:35:00',4.91),('14598','2013-07-23','13:40:00',4.83),('14598','2013-07-23','13:45:00',4.92),('14598','2013-07-23','13:50:00',4.91),('14598','2013-07-23','13:55:00',4.91),('14598','2013-07-23','14:00:00',4.91),('14598','2013-07-23','14:05:00',4.88),('14598','2013-07-23','14:10:00',4.9),('14598','2013-07-23','14:15:00',4.92),('14598','2013-07-23','14:20:00',4.89),('14598','2013-07-23','14:25:00',4.86),('14598','2013-07-23','14:30:00',4.87),('14598','2013-07-23','14:35:00',4.87),('14598','2013-07-23','14:40:00',4.85),('14598','2013-07-23','14:45:00',4.83),('14598','2013-07-23','14:50:00',4.77),('14598','2013-07-23','14:55:00',4.76),('14598','2013-07-23','15:00:00',4.76),('14598','2013-07-23','15:05:00',4.73),('14598','2013-07-23','15:10:00',4.69),('14598','2013-07-23','15:15:00',4.63),('14598','2013-07-23','15:20:00',4.57),('14598','2013-07-23','15:25:00',4.53),('14598','2013-07-23','15:30:00',4.48),('14598','2013-07-23','15:35:00',4.41),('14598','2013-07-23','15:40:00',4.39),('14598','2013-07-23','15:45:00',4.38),('14598','2013-07-23','15:50:00',4.32),('14598','2013-07-23','15:55:00',4.27),('14598','2013-07-23','16:00:00',4.22),('14598','2013-07-23','16:05:00',4.18),('14598','2013-07-23','16:10:00',4.14),('14598','2013-07-23','16:15:00',4.08),('14598','2013-07-23','16:20:00',4.02),('14598','2013-07-23','16:25:00',3.99),('14598','2013-07-23','16:30:00',3.94),('14598','2013-07-23','16:35:00',3.88),('14598','2013-07-23','16:40:00',3.79),('14598','2013-07-23','16:45:00',3.79),('14598','2013-07-23','16:50:00',3.73),('14598','2013-07-23','16:55:00',3.65),('14598','2013-07-23','17:00:00',3.58),('14598','2013-07-23','17:05:00',3.51),('14598','2013-07-23','17:10:00',3.46),('14598','2013-07-23','17:15:00',3.38),('14598','2013-07-23','17:20:00',3.31),('14598','2013-07-23','17:25:00',3.22),('14598','2013-07-23','17:30:00',3.13),('14598','2013-07-23','17:35:00',3.03),('14598','2013-07-23','17:40:00',2.93),('14598','2013-07-23','17:45:00',2.84),('14598','2013-07-23','17:50:00',2.76),('14598','2013-07-23','17:55:00',2.68),('14598','2013-07-23','18:00:00',2.61),('14598','2013-07-23','18:05:00',2.53),('14598','2013-07-23','18:10:00',2.42),('14598','2013-07-23','18:15:00',2.3),('14598','2013-07-23','18:20:00',1.25),('14598','2013-07-23','18:40:00',1.93),('14598','2013-07-23','18:45:00',1.86),('14598','2013-07-23','18:50:00',1.71),('14598','2013-07-23','18:55:00',1.56),('14598','2013-07-23','19:00:00',1.43),('14598','2013-07-23','19:05:00',1.3),('14598','2013-07-23','19:10:00',1.16),('14598','2013-07-23','19:15:00',1.06),('14598','2013-07-22','08:05:00',1.01),('14598','2013-07-22','08:10:00',1.1),('14598','2013-07-22','08:15:00',1.19),('14598','2013-07-22','08:20:00',1.27),('14598','2013-07-22','08:25:00',1.37),('14598','2013-07-22','08:30:00',1.45),('14598','2013-07-22','08:35:00',1.52),('14598','2013-07-22','08:40:00',1.64),('14598','2013-07-22','08:45:00',1.74),('14598','2013-07-22','08:50:00',1.85),('14598','2013-07-22','08:55:00',1.95),('14598','2013-07-22','09:00:00',2.06),('14598','2013-07-22','09:05:00',2.16),('14598','2013-07-22','09:10:00',2.25),('14598','2013-07-22','09:15:00',2.34),('14598','2013-07-22','09:20:00',2.42),('14598','2013-07-22','09:25:00',2.49),('14598','2013-07-22','09:30:00',2.57),('14598','2013-07-22','09:35:00',2.66),('14598','2013-07-22','09:40:00',2.75),('14598','2013-07-22','09:45:00',2.84),('14598','2013-07-22','09:50:00',2.89),('14598','2013-07-22','09:55:00',2.99),('14598','2013-07-22','10:00:00',3.07),('14598','2013-07-22','10:05:00',3.15),('14598','2013-07-22','10:10:00',3.22),('14598','2013-07-22','10:15:00',3.29),('14598','2013-07-22','10:20:00',3.36),('14598','2013-07-22','10:25:00',3.42),('14598','2013-07-22','10:30:00',3.49),('14598','2013-07-22','10:35:00',3.56),('14598','2013-07-22','10:40:00',3.61),('14598','2013-07-22','10:45:00',3.65),('14598','2013-07-22','10:50:00',3.72),('14598','2013-07-22','10:55:00',3.78),('14598','2013-07-22','11:00:00',3.83),('14598','2013-07-22','11:05:00',3.89),('14598','2013-07-22','11:10:00',3.94),('14598','2013-07-22','11:15:00',3.99),('14598','2013-07-22','11:20:00',4.03),('14598','2013-07-22','11:25:00',4.09),('14598','2013-07-22','11:30:00',4.12),('14598','2013-07-22','11:35:00',4.17),('14598','2013-07-22','11:40:00',4.21),('14598','2013-07-22','11:45:00',4.23),('14598','2013-07-22','11:50:00',4.3),('14598','2013-07-22','11:55:00',4.35),('14598','2013-07-22','12:00:00',4.39),('14598','2013-07-22','12:05:00',4.42),('14598','2013-07-22','12:10:00',4.44),('14598','2013-07-22','12:15:00',4.44),('14598','2013-07-22','12:20:00',4.46),('14598','2013-07-22','12:25:00',4.49),('14598','2013-07-22','12:30:00',4.5),('14598','2013-07-22','12:35:00',4.5),('14598','2013-07-22','12:40:00',4.53),('14598','2013-07-22','12:45:00',4.53),('14598','2013-07-22','12:50:00',4.54),('14598','2013-07-22','12:55:00',4.54),('14598','2013-07-22','13:00:00',4.64),('14598','2013-07-22','13:05:00',4.68),('14598','2013-07-22','13:10:00',4.67),('14598','2013-07-22','13:15:00',4.7),('14598','2013-07-22','13:20:00',4.75),('14598','2013-07-22','13:25:00',4.83),('14598','2013-07-22','13:30:00',4.87),('14598','2013-07-22','13:35:00',4.86),('14598','2013-07-22','13:40:00',4.85),('14598','2013-07-22','13:45:00',4.86),('14598','2013-07-22','13:50:00',4.84),('14598','2013-07-22','13:55:00',4.87),('14598','2013-07-22','14:00:00',4.87),('14598','2013-07-22','14:05:00',4.87),('14598','2013-07-22','14:10:00',4.86),('14598','2013-07-22','14:15:00',4.87),('14598','2013-07-22','14:20:00',4.87),('14598','2013-07-22','14:25:00',4.87),('14598','2013-07-22','14:30:00',4.85),('14598','2013-07-22','14:35:00',4.8),('14598','2013-07-22','14:40:00',4.76),('14598','2013-07-22','14:45:00',4.76),('14598','2013-07-22','14:50:00',4.75),('14598','2013-07-22','14:55:00',4.72),('14598','2013-07-22','15:00:00',4.7),('14598','2013-07-22','15:05:00',4.68),('14598','2013-07-22','15:10:00',4.66),('14598','2013-07-22','15:15:00',4.63),('14598','2013-07-22','15:20:00',4.62),('14598','2013-07-22','15:25:00',4.6),('14598','2013-07-22','15:30:00',4.54),('14598','2013-07-22','15:35:00',4.51),('14598','2013-07-22','15:40:00',4.5),('14598','2013-07-22','15:45:00',4.46),('14598','2013-07-22','15:50:00',4.39),('14598','2013-07-22','15:55:00',4.32),('14598','2013-07-22','16:00:00',4.31),('14598','2013-07-22','16:05:00',4.23),('14598','2013-07-22','16:10:00',4.16),('14598','2013-07-22','16:15:00',3.93),('14598','2013-07-22','16:20:00',3.81),('14598','2013-07-22','16:25:00',3.94),('14598','2013-07-22','16:30:00',3.91),('14598','2013-07-22','16:35:00',3.88),('14598','2013-07-22','16:40:00',3.8),('14598','2013-07-22','16:45:00',3.67),('14598','2013-07-22','16:50:00',3.59),('14598','2013-07-22','16:55:00',3.54),('14598','2013-07-22','17:00:00',3.51),('14598','2013-07-22','17:05:00',3.43),('14598','2013-07-22','17:10:00',3.28),('14598','2013-07-22','17:15:00',3.2),('14598','2013-07-22','17:20:00',3.19),('14598','2013-07-22','17:25:00',3.06),('14598','2013-07-22','17:30:00',2.98),('14598','2013-07-22','17:35:00',2.9),('14598','2013-07-22','17:40:00',2.8),('14598','2013-07-22','17:45:00',2.72),('14598','2013-07-22','17:50:00',2.56),('14598','2013-07-22','17:55:00',2.52),('14598','2013-07-22','18:00:00',2.46),('14598','2013-07-22','18:05:00',2.37),('14598','2013-07-22','18:10:00',2.26),('14598','2013-07-22','18:15:00',2.14),('14598','2013-07-22','18:20:00',2.04),('14598','2013-07-22','18:25:00',1.95),('14598','2013-07-22','18:30:00',1.86),('14598','2013-07-22','18:35:00',1.75),('14598','2013-07-22','18:40:00',1.67),('14598','2013-07-22','18:45:00',1.56),('14598','2013-07-22','18:50:00',1.44),('14598','2013-07-22','18:55:00',1.33),('14598','2013-07-22','19:00:00',1.26),('14598','2013-07-22','19:05:00',1.15),('14598','2013-07-22','19:10:00',1.07),('14598','2013-07-21','08:10:00',1.05),('14598','2013-07-21','08:15:00',1.14),('14598','2013-07-21','08:20:00',1.22),('14598','2013-07-21','08:25:00',1.31),('14598','2013-07-21','08:30:00',1.41),('14598','2013-07-21','08:35:00',1.51),('14598','2013-07-21','08:40:00',1.6),('14598','2013-07-21','08:45:00',1.65),('14598','2013-07-21','08:50:00',1.77),('14598','2013-07-21','08:55:00',1.83),('14598','2013-07-21','09:00:00',1.97),('14598','2013-07-21','09:05:00',2.09),('14598','2013-07-21','09:10:00',2.16),('14598','2013-07-21','09:15:00',2.25),('14598','2013-07-21','09:20:00',2.32),('14598','2013-07-21','09:25:00',2.38),('14598','2013-07-21','09:30:00',2.46),('14598','2013-07-21','09:35:00',2.02),('14598','2013-07-21','09:40:00',2.61),('14598','2013-07-21','09:45:00',2.7),('14598','2013-07-21','09:50:00',2.8),('14598','2013-07-21','09:55:00',2.85),('14598','2013-07-21','10:00:00',2.93),('14598','2013-07-21','10:05:00',2.99),('14598','2013-07-21','10:10:00',3.12),('14598','2013-07-21','10:15:00',3.17),('14598','2013-07-21','10:20:00',3.25),('14598','2013-07-21','10:25:00',3.32),('14598','2013-07-21','10:30:00',3.39),('14598','2013-07-21','10:35:00',3.47),('14598','2013-07-21','10:40:00',3.5),('14598','2013-07-21','10:45:00',3.56),('14598','2013-07-21','10:50:00',3.6),('14598','2013-07-21','10:55:00',3.67),('14598','2013-07-21','11:00:00',3.72),('14598','2013-07-21','11:05:00',3.75),('14598','2013-07-21','11:10:00',3.79),('14598','2013-07-21','11:15:00',3.86),('14598','2013-07-21','11:20:00',3.95),('14598','2013-07-21','11:25:00',3.96),('14598','2013-07-21','11:30:00',4.06),('14598','2013-07-21','11:35:00',4.16),('14598','2013-07-21','11:40:00',4.26),('14598','2013-07-21','11:45:00',4.04),('14598','2013-07-21','11:50:00',4.46),('14598','2013-07-21','11:55:00',4.48),('14598','2013-07-21','12:00:00',4.62),('14598','2013-07-21','12:05:00',4.64),('14598','2013-07-21','12:10:00',4.72),('14598','2013-07-21','12:15:00',4.28),('14598','2013-07-21','12:20:00',2.78),('14598','2013-07-21','12:25:00',1.61),('14598','2013-07-21','12:30:00',1.61),('14598','2013-07-21','12:35:00',1.72),('14598','2013-07-21','12:40:00',3.38),('14598','2013-07-21','12:45:00',5.64),('14598','2013-07-21','12:50:00',5.46),('14598','2013-07-21','12:55:00',5.54),('14598','2013-07-21','13:00:00',5.14),('14598','2013-07-21','13:05:00',1.87),('14598','2013-07-21','13:10:00',2.03),('14598','2013-07-21','13:15:00',2.32),('14598','2013-07-21','13:20:00',2.32),('14598','2013-07-21','13:25:00',2.32),('14598','2013-07-21','13:30:00',2.81),('14598','2013-07-21','13:35:00',2.86),('14598','2013-07-21','13:40:00',4.74),('14598','2013-07-21','13:45:00',3.43),('14598','2013-07-21','13:50:00',2.55),('14598','2013-07-21','13:55:00',2.59),('14598','2013-07-21','14:00:00',4.77),('14598','2013-07-21','14:05:00',4.68),('14598','2013-07-21','14:10:00',5.97),('14598','2013-07-21','14:15:00',5.75),('14598','2013-07-21','14:20:00',5.74),('14598','2013-07-21','14:25:00',5.78),('14598','2013-07-21','14:30:00',4.78),('14598','2013-07-21','14:35:00',4.56),('14598','2013-07-21','14:40:00',4.38),('14598','2013-07-21','14:45:00',2.7),('14598','2013-07-21','14:50:00',2.99),('14598','2013-07-21','14:55:00',2.83),('14598','2013-07-21','15:00:00',2.89),('14598','2013-07-21','15:05:00',2.64),('14598','2013-07-21','15:10:00',2.38),('14598','2013-07-21','15:15:00',3.03),('14598','2013-07-21','15:20:00',4.25),('14598','2013-07-21','15:25:00',3.93),('14598','2013-07-21','15:30:00',3.71),('14598','2013-07-21','15:35:00',2.6),('14598','2013-07-21','15:40:00',2.05),('14598','2013-07-21','15:45:00',1.74),('14598','2013-07-21','15:50:00',1.71),('14598','2013-07-21','15:55:00',1.66),('14598','2013-07-21','16:00:00',1.53),('14598','2013-07-21','16:05:00',1.4),('14598','2013-07-21','16:10:00',1.32),('14598','2013-07-21','16:15:00',1.33),('14598','2013-07-21','16:20:00',1.52),('14598','2013-07-21','16:25:00',1.68),('14598','2013-07-21','16:30:00',2.01),('14598','2013-07-21','16:35:00',2.32),('14598','2013-07-21','16:40:00',1.85),('14598','2013-07-21','16:45:00',1.86),('14598','2013-07-21','16:50:00',1.89),('14598','2013-07-21','16:55:00',1.78),('14598','2013-07-21','17:00:00',1.85),('14598','2013-07-21','17:05:00',1.87),('14598','2013-07-21','17:10:00',1.86),('14598','2013-07-21','17:15:00',2.32),('14598','2013-07-21','17:20:00',2.34),('14598','2013-07-21','17:25:00',2.76),('14598','2013-07-21','17:30:00',2.81),('14598','2013-07-21','17:35:00',3.05),('14598','2013-07-21','17:40:00',3.15),('14598','2013-07-21','17:45:00',3.28),('14598','2013-07-21','17:50:00',3.07),('14598','2013-07-21','17:55:00',2.66),('14598','2013-07-21','18:00:00',2.23),('14598','2013-07-21','18:05:00',1.8),('14598','2013-07-21','18:10:00',1.59),('14598','2013-07-21','18:15:00',1.66),('14598','2013-07-21','18:20:00',1.63),('14598','2013-07-21','18:25:00',1.81),('14598','2013-07-21','18:30:00',1.75),('14598','2013-07-21','18:35:00',1.4),('14598','2013-07-21','18:40:00',1.33),('14598','2013-07-21','18:45:00',1.09),('14598','2013-07-21','18:50:00',1.05),('14598','2013-07-21','18:55:00',1.41),('14598','2013-07-21','19:00:00',1.63),('14598','2013-07-21','19:05:00',1.35),('14598','2014-04-07','09:00:00',1.02),('14598','2014-04-07','09:05:00',1.15),('14598','2014-04-07','09:10:00',1.24),('14598','2014-04-07','09:15:00',1.3),('14598','2014-04-07','09:20:00',1.27),('14598','2014-04-07','09:25:00',1.21),('14598','2014-04-07','09:30:00',1.17),('14598','2014-04-07','09:35:00',1.21),('14598','2014-04-07','09:40:00',1.16),('14598','2014-04-07','09:45:00',1.14),('14598','2014-04-07','09:50:00',1.16),('14598','2014-04-07','09:55:00',1.19),('14598','2014-04-07','10:00:00',1.23),('14598','2014-04-07','10:05:00',1.3),('14598','2014-04-07','10:10:00',1.45),('14598','2014-04-07','10:15:00',1.62),('14598','2014-04-07','10:20:00',1.54),('14598','2014-04-07','10:25:00',1.55),('14598','2014-04-07','10:30:00',1.67),('14598','2014-04-07','10:35:00',1.75),('14598','2014-04-07','10:40:00',1.72),('14598','2014-04-07','10:45:00',1.79),('14598','2014-04-07','10:50:00',1.89),('14598','2014-04-07','10:55:00',1.94),('14598','2014-04-07','11:00:00',2.06),('14598','2014-04-07','11:05:00',2.1),('14598','2014-04-07','11:10:00',2.18),('14598','2014-04-07','11:15:00',2.26),('14598','2014-04-07','11:20:00',1.79),('14598','2014-04-07','11:25:00',1.64),('14598','2014-04-07','11:30:00',1.69),('14598','2014-04-07','11:35:00',1.94),('14598','2014-04-07','11:40:00',2.35),('14598','2014-04-07','11:45:00',2.38),('14598','2014-04-07','11:50:00',3.25),('14598','2014-04-07','11:55:00',4.39),('14598','2014-04-07','12:00:00',3.54),('14598','2014-04-07','12:05:00',4.28),('14598','2014-04-07','12:10:00',4.18),('14598','2014-04-07','12:15:00',3.24),('14598','2014-04-07','12:20:00',2.07),('14598','2014-04-07','12:25:00',2.55),('14598','2014-04-07','12:30:00',4.71),('14598','2014-04-07','12:35:00',4.68),('14598','2014-04-07','12:40:00',4.59),('14598','2014-04-07','12:45:00',4.58),('14598','2014-04-07','12:50:00',4.59),('14598','2014-04-07','12:55:00',4.59),('14598','2014-04-07','13:00:00',4.6),('14598','2014-04-07','13:05:00',4.61),('14598','2014-04-07','13:10:00',4.59),('14598','2014-04-07','13:15:00',4.59),('14598','2014-04-07','13:20:00',4.62),('14598','2014-04-07','13:25:00',4.64),('14598','2014-04-07','13:30:00',4.67),('14598','2014-04-07','13:35:00',4.71),('14598','2014-04-07','13:40:00',4.69),('14598','2014-04-07','13:45:00',4.72),('14598','2014-04-07','13:50:00',4.73),('14598','2014-04-07','13:55:00',4.71),('14598','2014-04-07','14:00:00',4.73),('14598','2014-04-07','14:05:00',4.74),('14598','2014-04-07','14:10:00',4.73),('14598','2014-04-07','14:15:00',4.7),('14598','2014-04-07','14:20:00',4.69),('14598','2014-04-07','14:25:00',4.67),('14598','2014-04-07','14:30:00',4.68),('14598','2014-04-07','14:35:00',4.64),('14598','2014-04-07','14:40:00',4.6),('14598','2014-04-07','14:45:00',4.58),('14598','2014-04-07','14:50:00',4.55),('14598','2014-04-07','14:55:00',4.53),('14598','2014-04-07','15:00:00',4.45),('14598','2014-04-07','15:05:00',4.46),('14598','2014-04-07','15:10:00',4.41),('14598','2014-04-07','15:15:00',4.34),('14598','2014-04-07','15:20:00',4.31),('14598','2014-04-07','15:25:00',4.28),('14598','2014-04-07','15:30:00',4.25),('14598','2014-04-07','15:35:00',4.16),('14598','2014-04-07','15:40:00',4.1),('14598','2014-04-07','15:45:00',4.03),('14598','2014-04-07','15:50:00',4.01),('14598','2014-04-07','15:55:00',3.95),('14598','2014-04-07','16:00:00',3.8),('14598','2014-04-07','16:05:00',3.78),('14598','2014-04-07','16:10:00',3.75),('14598','2014-04-07','16:15:00',3.68),('14598','2014-04-07','16:20:00',3.7),('14598','2014-04-07','16:25:00',3.74),('14598','2014-04-07','16:30:00',3.59),('14598','2014-04-07','16:35:00',3.37),('14598','2014-04-07','16:40:00',2.33),('14598','2014-04-07','16:45:00',2.69),('14598','2014-04-07','16:50:00',3.25),('14598','2014-04-07','16:55:00',3.03),('14598','2014-04-07','17:00:00',2.96),('14598','2014-04-07','17:05:00',2.86),('14598','2014-04-07','17:10:00',2.76),('14598','2014-04-07','17:15:00',2.72),('14598','2014-04-07','17:20:00',2.58),('14598','2014-04-07','17:25:00',2.34),('14598','2014-04-07','17:30:00',2.35),('14598','2014-04-07','17:35:00',2.23),('14598','2014-04-07','17:40:00',2.14),('14598','2014-04-07','17:45:00',2.01),('14598','2014-04-07','17:50:00',1.95),('14598','2014-04-07','17:55:00',1.63),('14598','2014-04-07','18:00:00',1.56),('14598','2014-04-07','18:10:00',1.36),('14598','2014-04-07','18:15:00',1.06),('14598','2013-07-20','08:05:00',1.03),('14598','2013-07-20','08:10:00',1.11),('14598','2013-07-20','08:15:00',1.22),('14598','2013-07-20','08:20:00',1.33),('14598','2013-07-20','08:25:00',1.45),('14598','2013-07-20','08:30:00',1.52),('14598','2013-07-20','08:35:00',1.69),('14598','2013-07-20','08:40:00',1.73),('14598','2013-07-20','08:45:00',1.98),('14598','2013-07-20','08:50:00',2.11),('14598','2013-07-20','08:55:00',2.18),('14598','2013-07-20','09:00:00',2.12),('14598','2013-07-20','09:05:00',2.03),('14598','2013-07-20','09:10:00',1.94),('14598','2013-07-20','09:15:00',2.21),('14598','2013-07-20','09:20:00',2.56),('14598','2013-07-20','09:25:00',2.45),('14598','2013-07-20','09:30:00',1.9),('14598','2013-07-20','09:35:00',2.1),('14598','2013-07-20','09:40:00',2.78),('14598','2013-07-20','09:45:00',2.86),('14598','2013-07-20','09:50:00',2.9),('14598','2013-07-20','09:55:00',2.99),('14598','2013-07-20','10:00:00',3.06),('14598','2013-07-20','10:05:00',3.11),('14598','2013-07-20','10:10:00',3.17),('14598','2013-07-20','10:15:00',3.26),('14598','2013-07-20','10:20:00',3.34),('14598','2013-07-20','10:25:00',3.4),('14598','2013-07-20','10:30:00',3.44),('14598','2013-07-20','10:35:00',3.53),('14598','2013-07-20','10:40:00',3.59),('14598','2013-07-20','10:45:00',3.62),('14598','2013-07-20','10:50:00',3.68),('14598','2013-07-20','10:55:00',3.75),('14598','2013-07-20','11:00:00',3.81),('14598','2013-07-20','11:05:00',3.91),('14598','2013-07-20','11:10:00',3.99),('14598','2013-07-20','11:15:00',4.05),('14598','2013-07-20','11:20:00',4.12),('14598','2013-07-20','11:25:00',4.17),('14598','2013-07-20','11:30:00',4.24),('14598','2013-07-20','11:35:00',4.25),('14598','2013-07-20','11:40:00',4.3),('14598','2013-07-20','11:45:00',4.37),('14598','2013-07-20','11:50:00',4.43),('14598','2013-07-20','11:55:00',4.46),('14598','2013-07-20','12:00:00',4.51),('14598','2013-07-20','12:05:00',4.56),('14598','2013-07-20','12:10:00',4.57),('14598','2013-07-20','12:15:00',4.59),('14598','2013-07-20','12:20:00',4.63),('14598','2013-07-20','12:25:00',4.66),('14598','2013-07-20','12:30:00',4.69),('14598','2013-07-20','12:35:00',4.72),('14598','2013-07-20','12:40:00',4.74),('14598','2013-07-20','12:45:00',4.75),('14598','2013-07-20','12:50:00',4.74),('14598','2013-07-20','12:55:00',4.83),('14598','2013-07-20','13:00:00',4.85),('14598','2013-07-20','13:05:00',4.86),('14598','2013-07-20','13:10:00',4.88),('14598','2013-07-20','13:15:00',4.9),('14598','2013-07-20','13:20:00',4.91),('14598','2013-07-20','13:25:00',4.9),('14598','2013-07-20','13:30:00',4.91),('14598','2013-07-20','13:35:00',4.91),('14598','2013-07-20','13:40:00',4.92),('14598','2013-07-20','13:45:00',4.94),('14598','2013-07-20','13:50:00',4.94),('14598','2013-07-20','13:55:00',4.93),('14598','2013-07-20','14:00:00',4.95),('14598','2013-07-20','14:05:00',4.92),('14598','2013-07-20','14:10:00',4.92),('14598','2013-07-20','14:15:00',4.91),('14598','2013-07-20','14:20:00',4.9),('14598','2013-07-20','14:25:00',4.89),('14598','2013-07-20','14:30:00',4.86),('14598','2013-07-20','14:35:00',4.84),('14598','2013-07-20','14:40:00',4.86),('14598','2013-07-20','14:45:00',4.84),('14598','2013-07-20','14:50:00',4.81),('14598','2013-07-20','14:55:00',4.77),('14598','2013-07-20','15:00:00',4.75),('14598','2013-07-20','15:05:00',4.73),('14598','2013-07-20','15:10:00',4.7),('14598','2013-07-20','15:15:00',4.68),('14598','2013-07-20','15:20:00',4.64),('14598','2013-07-20','15:25:00',4.6),('14598','2013-07-20','15:30:00',4.54),('14598','2013-07-20','15:35:00',4.5),('14598','2013-07-20','15:40:00',4.49),('14598','2013-07-20','15:45:00',4.45),('14598','2013-07-20','15:50:00',4.36),('14598','2013-07-20','15:55:00',4.34),('14598','2013-07-20','16:00:00',4.3),('14598','2013-07-20','16:05:00',4.26),('14598','2013-07-20','16:10:00',4.21),('14598','2013-07-20','16:15:00',4.16),('14598','2013-07-20','16:20:00',4.09),('14598','2013-07-20','16:25:00',4.06),('14598','2013-07-20','16:30:00',3.99),('14598','2013-07-20','16:35:00',3.95),('14598','2013-07-20','16:40:00',3.85),('14598','2013-07-20','16:45:00',3.79),('14598','2013-07-20','16:50:00',3.72),('14598','2013-07-20','16:55:00',3.65),('14598','2013-07-20','17:00:00',3.58),('14598','2013-07-20','17:05:00',3.49),('14598','2013-07-20','17:10:00',3.43),('14598','2013-07-20','17:15:00',3.36),('14598','2013-07-20','17:20:00',3.28),('14598','2013-07-20','17:25:00',3.19),('14598','2013-07-20','17:30:00',3.11),('14598','2013-07-20','17:35:00',3.03),('14598','2013-07-20','17:40:00',2.94),('14598','2013-07-20','17:45:00',2.86),('14598','2013-07-20','17:50:00',2.76),('14598','2013-07-20','17:55:00',2.67),('14598','2013-07-20','18:00:00',2.57),('14598','2013-07-20','18:05:00',2.49),('14598','2013-07-20','18:10:00',2.4),('14598','2013-07-20','18:15:00',2.31),('14598','2013-07-20','18:20:00',2.2),('14598','2013-07-20','18:25:00',2.11),('14598','2013-07-20','18:30:00',2.01),('14598','2013-07-20','18:35:00',1.9),('14598','2013-07-20','18:40:00',1.79),('14598','2013-07-20','18:45:00',1.68),('14598','2013-07-20','18:50:00',1.59),('14598','2013-07-20','18:55:00',1.45),('14598','2013-07-20','19:00:00',1.37),('14598','2013-07-20','19:05:00',1.25),('14598','2013-07-20','19:10:00',1.14),('14598','2013-07-20','19:15:00',1.03),('14598','2013-07-19','08:05:00',1),('14598','2013-07-19','08:10:00',1.07),('14598','2013-07-19','08:15:00',1.16),('14598','2013-07-19','08:20:00',1.26),('14598','2013-07-19','08:25:00',1.36),('14598','2013-07-19','08:30:00',1.44),('14598','2013-07-19','08:35:00',1.51),('14598','2013-07-19','08:40:00',1.6),('14598','2013-07-19','08:45:00',1.7),('14598','2013-07-19','08:50:00',1.8),('14598','2013-07-19','08:55:00',1.91),('14598','2013-07-19','09:00:00',2.03),('14598','2013-07-19','09:05:00',2.12),('14598','2013-07-19','09:10:00',2.08),('14598','2013-07-19','09:15:00',1.98),('14598','2013-07-19','09:20:00',2.3),('14598','2013-07-19','09:25:00',2.37),('14598','2013-07-19','09:30:00',2.46),('14598','2013-07-19','09:35:00',2.5),('14598','2013-07-19','09:40:00',2.63),('14598','2013-07-19','09:45:00',2.77),('14598','2013-07-19','09:50:00',2.83),('14598','2013-07-19','09:55:00',2.92),('14598','2013-07-19','10:00:00',3.03),('14598','2013-07-19','10:05:00',3.07),('14598','2013-07-19','10:10:00',3.18),('14598','2013-07-19','10:15:00',3.23),('14598','2013-07-19','10:20:00',3.28),('14598','2013-07-19','10:25:00',3.37),('14598','2013-07-19','10:30:00',3.42),('14598','2013-07-19','10:35:00',3.49),('14598','2013-07-19','10:40:00',3.56),('14598','2013-07-19','10:45:00',3.64),('14598','2013-07-19','10:50:00',3.65),('14598','2013-07-19','10:55:00',3.75),('14598','2013-07-19','11:00:00',3.85),('14598','2013-07-19','11:05:00',3.91),('14598','2013-07-19','11:10:00',3.98),('14598','2013-07-19','11:15:00',4.04),('14598','2013-07-19','11:20:00',4.1),('14598','2013-07-19','11:25:00',4.13),('14598','2013-07-19','11:30:00',4.19),('14598','2013-07-19','11:35:00',4.25),('14598','2013-07-19','11:40:00',4.3),('14598','2013-07-19','11:45:00',4.36),('14598','2013-07-19','11:50:00',4.38),('14598','2013-07-19','11:55:00',4.43),('14598','2013-07-19','12:00:00',4.48),('14598','2013-07-19','12:05:00',4.39),('14598','2013-07-19','12:10:00',4.51),('14598','2013-07-19','12:15:00',4.58),('14598','2013-07-19','12:20:00',4.69),('14598','2013-07-19','12:25:00',4.78),('14598','2013-07-19','12:30:00',4.54),('14598','2013-07-19','12:35:00',4.66),('14598','2013-07-19','12:40:00',4.58),('14598','2013-07-19','12:45:00',4.25),('14598','2013-07-19','12:50:00',4.39),('14598','2013-07-19','12:55:00',3.49),('14598','2013-07-19','13:00:00',4.89),('14598','2013-07-19','13:05:00',4.31),('14598','2013-07-19','13:10:00',3.59),('14598','2013-07-19','13:15:00',4.4),('14598','2013-07-19','13:20:00',3.98),('14598','2013-07-19','13:25:00',4.66),('14598','2013-07-19','13:30:00',4.94),('14598','2013-07-19','13:35:00',5.06),('14598','2013-07-19','13:40:00',4.97),('14598','2013-07-19','13:45:00',4.92),('14598','2013-07-19','13:50:00',4.86),('14598','2013-07-19','13:55:00',4.91),('14598','2013-07-19','14:00:00',4.9),('14598','2013-07-19','14:05:00',4.9),('14598','2013-07-19','14:10:00',4.9),('14598','2013-07-19','14:15:00',4.91),('14598','2013-07-19','14:20:00',4.97),('14598','2013-07-19','14:25:00',5.12),('14598','2013-07-19','14:30:00',5.09),('14598','2013-07-19','14:35:00',5.06),('14598','2013-07-19','14:40:00',5.08),('14598','2013-07-19','14:45:00',3.96),('14598','2013-07-19','14:50:00',3.26),('14598','2013-07-19','14:55:00',3.45),('14598','2013-07-19','15:00:00',4.93),('14598','2013-07-19','15:05:00',4.87),('14598','2013-07-19','15:10:00',4.72),('14598','2013-07-19','15:15:00',4.67),('14598','2013-07-19','15:20:00',4.62),('14598','2013-07-19','15:25:00',4.57),('14598','2013-07-19','15:30:00',4.53),('14598','2013-07-19','15:35:00',4.46),('14598','2013-07-19','15:40:00',4.39),('14598','2013-07-19','15:45:00',4.39),('14598','2013-07-19','15:50:00',4.32),('14598','2013-07-19','15:55:00',4.29),('14598','2013-07-19','16:00:00',4),('14598','2013-07-19','16:05:00',4.24),('14598','2013-07-19','16:10:00',4.13),('14598','2013-07-19','16:15:00',4.13),('14598','2013-07-19','16:20:00',4.14),('14598','2013-07-19','16:25:00',3.95),('14598','2013-07-19','16:30:00',3.96),('14598','2013-07-19','16:35:00',3.85),('14598','2013-07-19','16:40:00',3.71),('14598','2013-07-19','16:45:00',3.6),('14598','2013-07-19','16:50:00',2.71),('14598','2013-07-19','16:55:00',1.46),('14598','2013-07-19','17:00:00',1.35),('14598','2013-07-19','17:05:00',1.25),('14598','2013-07-19','17:10:00',1.73),('14598','2013-07-19','17:15:00',2.34),('14598','2013-07-19','17:20:00',2.37),('14598','2013-07-19','17:25:00',2.31),('14598','2013-07-19','17:30:00',1.75),('14598','2013-07-19','17:35:00',1.27),('14598','2013-07-19','17:40:00',1.16),('14598','2013-07-19','17:45:00',1.28),('14598','2013-07-19','17:50:00',1.3),('14598','2013-07-18','08:05:00',1.04),('14598','2013-07-18','08:10:00',1.13),('14598','2013-07-18','08:15:00',1.22),('14598','2013-07-18','08:20:00',1.32),('14598','2013-07-18','08:25:00',1.42),('14598','2013-07-18','08:30:00',1.48),('14598','2013-07-18','08:35:00',1.59),('14598','2013-07-18','08:40:00',1.69),('14598','2013-07-18','08:45:00',1.79),('14598','2013-07-18','08:50:00',1.89),('14598','2013-07-18','08:55:00',2),('14598','2013-07-18','09:00:00',2.11),('14598','2013-07-18','09:05:00',2.21),('14598','2013-07-18','09:10:00',2.3),('14598','2013-07-18','09:15:00',2.38),('14598','2013-07-18','09:20:00',2.46),('14598','2013-07-18','09:25:00',2.54),('14598','2013-07-18','09:30:00',2.64),('14598','2013-07-18','09:35:00',2.73),('14598','2013-07-18','09:40:00',2.8),('14598','2013-07-18','09:45:00',2.87),('14598','2013-07-18','09:50:00',2.92),('14598','2013-07-18','09:55:00',3.03),('14598','2013-07-18','10:00:00',3.09),('14598','2013-07-18','10:05:00',3.16),('14598','2013-07-18','10:10:00',3.22),('14598','2013-07-18','10:15:00',3.19),('14598','2013-07-18','10:20:00',3.33),('14598','2013-07-18','10:25:00',3.39),('14598','2013-07-18','10:30:00',3.46),('14598','2013-07-18','10:35:00',3.53),('14598','2013-07-18','10:40:00',3.56),('14598','2013-07-18','10:45:00',3.63),('14598','2013-07-18','10:50:00',3.75),('14598','2013-07-18','10:55:00',3.83),('14598','2013-07-18','11:00:00',3.9),('14598','2013-07-18','11:05:00',3.94),('14598','2013-07-18','11:10:00',4.02),('14598','2013-07-18','11:15:00',4.07),('14598','2013-07-18','11:20:00',4.13),('14598','2013-07-18','11:25:00',4.19),('14598','2013-07-18','11:30:00',4.24),('14598','2013-07-18','11:35:00',4.29),('14598','2013-07-18','11:40:00',4.34),('14598','2013-07-18','11:45:00',4.41),('14598','2013-07-18','11:50:00',4.44),('14598','2013-07-18','11:55:00',4.46),('14598','2013-07-18','12:00:00',4.5),('14598','2013-07-18','12:05:00',4.55),('14598','2013-07-18','12:10:00',4.6),('14598','2013-07-18','12:15:00',4.64),('14598','2013-07-18','12:20:00',4.69),('14598','2013-07-18','12:25:00',4.71),('14598','2013-07-18','12:30:00',4.74),('14598','2013-07-18','12:35:00',4.75),('14598','2013-07-18','12:40:00',4.79),('14598','2013-07-18','12:45:00',4.82),('14598','2013-07-18','12:50:00',4.79),('14598','2013-07-18','12:55:00',4.84),('14598','2013-07-18','13:00:00',4.86),('14598','2013-07-18','13:05:00',4.87),('14598','2013-07-18','13:10:00',4.89),('14598','2013-07-18','13:15:00',4.91),('14598','2013-07-18','13:20:00',4.92),('14598','2013-07-18','13:25:00',4.94),('14598','2013-07-18','13:30:00',4.94),('14598','2013-07-18','13:35:00',4.95),('14598','2013-07-18','13:40:00',4.95),('14598','2013-07-18','13:45:00',4.95),('14598','2013-07-18','13:50:00',4.95),('14598','2013-07-18','13:55:00',4.95),('14598','2013-07-18','14:00:00',4.92),('14598','2013-07-18','14:05:00',4.88),('14598','2013-07-18','14:10:00',4.88),('14598','2013-07-18','14:15:00',4.87),('14598','2013-07-18','14:20:00',4.86),('14598','2013-07-18','14:25:00',4.84),('14598','2013-07-18','14:30:00',4.84),('14598','2013-07-18','14:35:00',4.75),('14598','2013-07-18','14:40:00',4.77),('14598','2013-07-18','14:45:00',4.75),('14598','2013-07-18','14:50:00',4.72),('14598','2013-07-18','14:55:00',4.67),('14598','2013-07-18','15:00:00',4.65),('14598','2013-07-18','15:05:00',4.64),('14598','2013-07-18','15:10:00',4.63),('14598','2013-07-18','15:15:00',4.6),('14598','2013-07-18','15:20:00',4.57),('14598','2013-07-18','15:25:00',4.55),('14598','2013-07-18','15:30:00',4.51),('14598','2013-07-18','15:35:00',4.44),('14598','2013-07-18','15:40:00',4.39),('14598','2013-07-18','15:45:00',4.34),('14598','2013-07-18','15:50:00',4.28),('14598','2013-07-18','15:55:00',4.26),('14598','2013-07-18','16:00:00',4.23),('14598','2013-07-18','16:05:00',4.15),('14598','2013-07-18','16:10:00',4.08),('14598','2013-07-18','16:15:00',4.05),('14598','2013-07-18','16:20:00',3.96),('14598','2013-07-18','16:25:00',3.89),('14598','2013-07-18','16:30:00',3.83),('14598','2013-07-18','16:35:00',3.75),('14598','2013-07-18','16:40:00',3.67),('14598','2013-07-18','16:45:00',3.62),('14598','2013-07-18','16:50:00',3.57),('14598','2013-07-18','16:55:00',3.48),('14598','2013-07-18','17:00:00',3.41),('14598','2013-07-18','17:05:00',3.48),('14598','2013-07-18','17:10:00',3.5),('14598','2013-07-18','17:15:00',3.35),('14598','2013-07-18','17:20:00',3.35),('14598','2013-07-18','17:25:00',3.1),('14598','2013-07-18','17:30:00',2.98),('14598','2013-07-18','17:35:00',2.85),('14598','2013-07-18','17:40:00',2.76),('14598','2013-07-18','17:45:00',2.66),('14598','2013-07-18','17:50:00',2.56),('14598','2013-07-18','17:55:00',2.49),('14598','2013-07-18','18:00:00',2.4),('14598','2013-07-18','18:05:00',2.32),('14598','2013-07-18','18:10:00',2.23),('14598','2013-07-18','18:15:00',2.15),('14598','2013-07-18','18:20:00',2.03),('14598','2013-07-18','18:25:00',1.94),('14598','2013-07-18','18:30:00',1.83),('14598','2013-07-18','18:35:00',1.77),('14598','2013-07-18','18:40:00',1.65),('14598','2013-07-18','18:45:00',1.58),('14598','2013-07-18','18:50:00',1.47),('14598','2013-07-18','18:55:00',1.36),('14598','2013-07-18','19:00:00',1.27),('14598','2013-07-18','19:05:00',1.17),('14598','2013-07-18','19:10:00',1.06),('14598','2013-07-17','08:05:00',1.06),('14598','2013-07-17','08:10:00',1.14),('14598','2013-07-17','08:15:00',1.23),('14598','2013-07-17','08:20:00',1.33),('14598','2013-07-17','08:25:00',1.43),('14598','2013-07-17','08:30:00',1.53),('14598','2013-07-17','08:35:00',1.6),('14598','2013-07-17','08:40:00',1.69),('14598','2013-07-17','08:45:00',1.79),('14598','2013-07-17','08:50:00',1.9),('14598','2013-07-17','08:55:00',2.01),('14598','2013-07-17','09:00:00',2.08),('14598','2013-07-17','09:05:00',2.22),('14598','2013-07-17','09:10:00',2.31),('14598','2013-07-17','09:15:00',2.39),('14598','2013-07-17','09:20:00',2.47),('14598','2013-07-17','09:25:00',2.56),('14598','2013-07-17','09:30:00',2.64),('14598','2013-07-17','09:35:00',2.72),('14598','2013-07-17','09:40:00',2.8),('14598','2013-07-17','09:45:00',2.89),('14598','2013-07-17','09:50:00',2.95),('14598','2013-07-17','09:55:00',3.02),('14598','2013-07-17','10:00:00',3.1),('14598','2013-07-17','10:05:00',3.16),('14598','2013-07-17','10:10:00',3.23),('14598','2013-07-17','10:15:00',3.32),('14598','2013-07-17','10:20:00',3.35),('14598','2013-07-17','10:25:00',3.44),('14598','2013-07-17','10:30:00',3.49),('14598','2013-07-17','10:35:00',3.57),('14598','2013-07-17','10:40:00',3.64),('14598','2013-07-17','10:45:00',3.72),('14598','2013-07-17','10:50:00',3.78),('14598','2013-07-17','10:55:00',3.83),('14598','2013-07-17','11:00:00',3.91),('14598','2013-07-17','11:05:00',3.94),('14598','2013-07-17','11:10:00',4.02),('14598','2013-07-17','11:15:00',4.05),('14598','2013-07-17','11:20:00',4.06),('14598','2013-07-17','11:25:00',4.11),('14598','2013-07-17','11:30:00',4.21),('14598','2013-07-17','11:35:00',4.24),('14598','2013-07-17','11:40:00',4.28),('14598','2013-07-17','11:45:00',4.33),('14598','2013-07-17','11:50:00',4.36),('14598','2013-07-17','11:55:00',4.42),('14598','2013-07-17','12:00:00',4.44),('14598','2013-07-17','12:05:00',4.38),('14598','2013-07-17','12:10:00',4.47),('14598','2013-07-17','12:15:00',4.5),('14598','2013-07-17','12:20:00',4.54),('14598','2013-07-17','12:25:00',4.56),('14598','2013-07-17','12:30:00',4.55),('14598','2013-07-17','12:35:00',4.57),('14598','2013-07-17','12:40:00',4.61),('14598','2013-07-17','12:45:00',4.63),('14598','2013-07-17','12:50:00',4.67),('14598','2013-07-17','12:55:00',4.7),('14598','2013-07-17','13:00:00',4.71),('14598','2013-07-17','13:05:00',4.75),('14598','2013-07-17','13:10:00',4.86),('14598','2013-07-17','13:15:00',4.92),('14598','2013-07-17','13:20:00',4.9),('14598','2013-07-17','13:25:00',4.93),('14598','2013-07-17','13:30:00',4.97),('14598','2013-07-17','13:35:00',4.98),('14598','2013-07-17','13:40:00',4.99),('14598','2013-07-17','13:45:00',4.97),('14598','2013-07-17','13:50:00',4.97),('14598','2013-07-17','13:55:00',5),('14598','2013-07-17','14:00:00',5.02),('14598','2013-07-17','14:05:00',5.03),('14598','2013-07-17','14:10:00',4.97),('14598','2013-07-17','14:15:00',4.96),('14598','2013-07-17','14:20:00',4.94),('14598','2013-07-17','14:25:00',4.95),('14598','2013-07-17','14:30:00',4.92),('14598','2013-07-17','14:35:00',4.91),('14598','2013-07-17','14:40:00',4.9),('14598','2013-07-17','14:45:00',4.87),('14598','2013-07-17','14:50:00',4.88),('14598','2013-07-17','14:55:00',4.86),('14598','2013-07-17','15:00:00',4.8),('14598','2013-07-17','15:05:00',4.67),('14598','2013-07-17','15:10:00',4.75),('14598','2013-07-17','15:15:00',4.74),('14598','2013-07-17','15:20:00',4.72),('14598','2013-07-17','15:25:00',4.69),('14598','2013-07-17','15:30:00',4.62),('14598','2013-07-17','15:35:00',4.57),('14598','2013-07-17','15:40:00',4.53),('14598','2013-07-17','15:45:00',4.49),('14598','2013-07-17','15:50:00',4.46),('14598','2013-07-17','15:55:00',4.4),('14598','2013-07-17','16:00:00',4.34),('14598','2013-07-17','16:05:00',4.28),('14598','2013-07-17','16:10:00',4.24),('14598','2013-07-17','16:15:00',4.14),('14598','2013-07-17','16:20:00',4.09),('14598','2013-07-17','16:25:00',4.07),('14598','2013-07-17','16:30:00',4.03),('14598','2013-07-17','16:35:00',3.97),('14598','2013-07-17','16:40:00',3.89),('14598','2013-07-17','16:45:00',3.82),('14598','2013-07-17','16:50:00',3.74),('14598','2013-07-17','16:55:00',3.68),('14598','2013-07-17','17:00:00',3.6),('14598','2013-07-17','17:05:00',3.52),('14598','2013-07-17','17:10:00',3.44),('14598','2013-07-17','17:15:00',3.38),('14598','2013-07-17','17:20:00',3.3),('14598','2013-07-17','17:25:00',3.2),('14598','2013-07-17','17:30:00',3.12),('14598','2013-07-17','17:35:00',3.04),('14598','2013-07-17','17:40:00',2.94),('14598','2013-07-17','17:45:00',2.84),('14598','2013-07-17','17:50:00',2.77),('14598','2013-07-17','17:55:00',2.68),('14598','2013-07-17','18:00:00',2.58),('14598','2013-07-17','18:05:00',2.46),('14598','2013-07-17','18:10:00',2.37),('14598','2013-07-17','18:15:00',2.26),('14598','2013-07-17','18:20:00',2.18),('14598','2013-07-17','18:25:00',2.07),('14598','2013-07-17','18:30:00',1.96),('14598','2013-07-17','18:35:00',1.87),('14598','2013-07-17','18:40:00',1.76),('14598','2013-07-17','18:45:00',1.66),('14598','2013-07-17','18:50:00',1.56),('14598','2013-07-17','18:55:00',1.45),('14598','2013-07-17','19:00:00',1.35),('14598','2013-07-17','19:05:00',1.24),('14598','2013-07-17','19:10:00',1.14),('14598','2013-07-17','19:15:00',1.04),('14598','2013-07-16','08:00:00',1.01),('14598','2013-07-16','08:05:00',1.09),('14598','2013-07-16','08:10:00',1.17),('14598','2013-07-16','08:15:00',1.24),('14598','2013-07-16','08:20:00',1.33),('14598','2013-07-16','08:25:00',1.43),('14598','2013-07-16','08:30:00',1.5),('14598','2013-07-16','08:35:00',1.6),('14598','2013-07-16','08:40:00',1.68),('14598','2013-07-16','08:45:00',1.78),('14598','2013-07-16','08:50:00',1.9),('14598','2013-07-16','08:55:00',2.02),('14598','2013-07-16','09:00:00',2.12),('14598','2013-07-16','09:05:00',2.21),('14598','2013-07-16','09:10:00',2.3),('14598','2013-07-16','09:15:00',2.38),('14598','2013-07-16','09:20:00',2.49),('14598','2013-07-16','09:25:00',2.58),('14598','2013-07-16','09:30:00',2.65),('14598','2013-07-16','09:35:00',2.74),('14598','2013-07-16','09:40:00',2.81),('14598','2013-07-16','09:45:00',2.9),('14598','2013-07-16','09:50:00',2.95),('14598','2013-07-16','09:55:00',3.05),('14598','2013-07-16','10:00:00',3.11),('14598','2013-07-16','10:05:00',3.17),('14598','2013-07-16','10:10:00',3.23),('14598','2013-07-16','10:15:00',3.29),('14598','2013-07-16','10:20:00',3.37),('14598','2013-07-16','10:25:00',3.44),('14598','2013-07-16','10:30:00',3.49),('14598','2013-07-16','10:35:00',3.56),('14598','2013-07-16','10:40:00',3.62),('14598','2013-07-16','10:45:00',3.7),('14598','2013-07-16','10:50:00',3.76),('14598','2013-07-16','10:55:00',3.79),('14598','2013-07-16','11:00:00',3.86),('14598','2013-07-16','11:05:00',3.91),('14598','2013-07-16','11:10:00',3.95),('14598','2013-07-16','11:15:00',4),('14598','2013-07-16','11:20:00',4.03),('14598','2013-07-16','11:25:00',4.1),('14598','2013-07-16','11:30:00',4.16),('14598','2013-07-16','11:35:00',4.17),('14598','2013-07-16','11:40:00',4.21),('14598','2013-07-16','11:45:00',4.25),('14598','2013-07-16','11:50:00',4.33),('14598','2013-07-16','11:55:00',4.36),('14598','2013-07-16','12:00:00',4.4),('14598','2013-07-16','12:05:00',4.41),('14598','2013-07-16','12:10:00',4.46),('14598','2013-07-16','12:15:00',4.5),('14598','2013-07-16','12:20:00',4.53),('14598','2013-07-16','12:25:00',4.57),('14598','2013-07-16','12:30:00',4.59),('14598','2013-07-16','12:35:00',4.62),('14598','2013-07-16','12:40:00',4.61),('14598','2013-07-16','12:45:00',4.69),('14598','2013-07-16','12:50:00',4.65),('14598','2013-07-16','12:55:00',4.71),('14598','2013-07-16','13:00:00',4.75),('14598','2013-07-16','13:05:00',4.77),('14598','2013-07-16','13:10:00',4.77),('14598','2013-07-16','13:15:00',4.82),('14598','2013-07-16','13:20:00',4.82),('14598','2013-07-16','13:25:00',4.79),('14598','2013-07-16','13:30:00',4.81),('14598','2013-07-16','13:35:00',4.8),('14598','2013-07-16','13:40:00',4.76),('14598','2013-07-16','13:45:00',4.74),('14598','2013-07-16','13:50:00',4.77),('14598','2013-07-16','13:55:00',4.77),('14598','2013-07-16','14:00:00',4.79),('14598','2013-07-16','14:05:00',4.81),('14598','2013-07-16','14:10:00',4.8),('14598','2013-07-16','14:15:00',4.8),('14598','2013-07-16','14:20:00',4.74),('14598','2013-07-16','14:25:00',4.75),('14598','2013-07-16','14:30:00',4.73),('14598','2013-07-16','14:35:00',4.65),('14598','2013-07-16','14:40:00',4.67),('14598','2013-07-16','14:45:00',4.7),('14598','2013-07-16','14:50:00',4.74),('14598','2013-07-16','14:55:00',4.72),('14598','2013-07-16','15:00:00',4.73),('14598','2013-07-16','15:05:00',4.74),('14598','2013-07-16','15:10:00',4.69),('14598','2013-07-16','15:15:00',4.68),('14598','2013-07-16','15:20:00',4.63),('14598','2013-07-16','15:25:00',4.55),('14598','2013-07-16','15:30:00',4.56),('14598','2013-07-16','15:35:00',4.47),('14598','2013-07-16','15:40:00',4.43),('14598','2013-07-16','15:45:00',4.44),('14598','2013-07-16','15:50:00',4.4),('14598','2013-07-16','15:55:00',4.35),('14598','2013-07-16','16:00:00',4.27),('14598','2013-07-16','16:05:00',4.24),('14598','2013-07-16','16:10:00',4.19),('14598','2013-07-16','16:15:00',4.16),('14598','2013-07-16','16:20:00',4.1),('14598','2013-07-16','16:25:00',4.03),('14598','2013-07-16','16:30:00',3.97),('14598','2013-07-16','16:35:00',3.93),('14598','2013-07-16','16:40:00',3.84),('14598','2013-07-16','16:45:00',3.77),('14598','2013-07-16','16:50:00',3.71),('14598','2013-07-16','16:55:00',3.65),('14598','2013-07-16','17:00:00',3.57),('14598','2013-07-16','17:05:00',3.45),('14598','2013-07-16','17:10:00',3.36),('14598','2013-07-16','17:15:00',3.27),('14598','2013-07-16','17:20:00',3.24),('14598','2013-07-16','17:25:00',3.14),('14598','2013-07-16','17:30:00',3.08),('14598','2013-07-16','17:35:00',2.91),('14598','2013-07-16','17:40:00',2.87),('14598','2013-07-16','17:45:00',2.71),('14598','2013-07-16','17:50:00',2.69),('14598','2013-07-16','17:55:00',2.63),('14598','2013-07-16','18:00:00',2.51),('14598','2013-07-16','18:05:00',2.43),('14598','2013-07-16','18:10:00',2.35),('14598','2013-07-16','18:15:00',2.26),('14598','2013-07-16','18:20:00',2.16),('14598','2013-07-16','18:25:00',2.06),('14598','2013-07-16','18:30:00',1.93),('14598','2013-07-16','18:35:00',1.82),('14598','2013-07-16','18:40:00',1.71),('14598','2013-07-16','18:45:00',1.61),('14598','2013-07-16','18:50:00',1.5),('14598','2013-07-16','18:55:00',1.41),('14598','2013-07-16','19:00:00',1.3),('14598','2013-07-16','19:05:00',1.18),('14598','2013-07-16','19:10:00',1.04),('14598','2013-07-15','08:00:00',1.02),('14598','2013-07-15','08:05:00',1.11),('14598','2013-07-15','08:10:00',1.2),('14598','2013-07-15','08:15:00',1.28),('14598','2013-07-15','08:20:00',1.38),('14598','2013-07-15','08:25:00',1.49),('14598','2013-07-15','08:30:00',1.58),('14598','2013-07-15','08:35:00',1.67),('14598','2013-07-15','08:40:00',1.76),('14598','2013-07-15','08:45:00',1.85),('14598','2013-07-15','08:50:00',1.96),('14598','2013-07-15','08:55:00',2.08),('14598','2013-07-15','09:00:00',2.19),('14598','2013-07-15','09:05:00',2.27),('14598','2013-07-15','09:10:00',2.36),('14598','2013-07-15','09:15:00',2.45),('14598','2013-07-15','09:20:00',2.55),('14598','2013-07-15','09:25:00',2.63),('14598','2013-07-15','09:30:00',2.72),('14598','2013-07-15','09:35:00',2.8),('14598','2013-07-15','09:40:00',2.89),('14598','2013-07-15','09:45:00',2.97),('14598','2013-07-15','09:50:00',3.04),('14598','2013-07-15','09:55:00',3.12),('14598','2013-07-15','10:00:00',3.2),('14598','2013-07-15','10:05:00',3.28),('14598','2013-07-15','10:10:00',3.35),('14598','2013-07-15','10:15:00',3.41),('14598','2013-07-15','10:20:00',3.47),('14598','2013-07-15','10:25:00',3.55),('14598','2013-07-15','10:30:00',3.59),('14598','2013-07-15','10:35:00',3.69),('14598','2013-07-15','10:40:00',3.75),('14598','2013-07-15','10:45:00',3.79),('14598','2013-07-15','10:50:00',3.79),('14598','2013-07-15','10:55:00',3.87),('14598','2013-07-15','11:00:00',3.93),('14598','2013-07-15','11:05:00',3.96),('14598','2013-07-15','11:10:00',4.01),('14598','2013-07-15','11:15:00',4.07),('14598','2013-07-15','11:20:00',4.15),('14598','2013-07-15','11:25:00',4.18),('14598','2013-07-15','11:30:00',4.22),('14598','2013-07-15','11:35:00',4.28),('14598','2013-07-15','11:40:00',4.29),('14598','2013-07-15','11:45:00',4.33),('14598','2013-07-15','11:50:00',4.34),('14598','2013-07-15','11:55:00',4.39),('14598','2013-07-15','12:00:00',4.46),('14598','2013-07-15','12:05:00',4.48),('14598','2013-07-15','12:10:00',4.52),('14598','2013-07-15','12:15:00',4.53),('14598','2013-07-15','12:20:00',4.54),('14598','2013-07-15','12:25:00',4.56),('14598','2013-07-15','12:30:00',4.59),('14598','2013-07-15','12:35:00',4.63),('14598','2013-07-15','12:40:00',4.61),('14598','2013-07-15','12:45:00',4.63),('14598','2013-07-15','12:50:00',4.63),('14598','2013-07-15','12:55:00',4.66),('14598','2013-07-15','13:00:00',4.63),('14598','2013-07-15','13:05:00',4.63),('14598','2013-07-15','13:10:00',4.73),('14598','2013-07-15','13:15:00',4.86),('14598','2013-07-15','13:20:00',4.97),('14598','2013-07-15','13:25:00',4.98),('14598','2013-07-15','13:30:00',5.02),('14598','2013-07-15','13:35:00',5),('14598','2013-07-15','13:40:00',4.99),('14598','2013-07-15','13:45:00',4.97),('14598','2013-07-15','13:50:00',5.01),('14598','2013-07-15','13:55:00',5.06),('14598','2013-07-15','14:00:00',5.05),('14598','2013-07-15','14:05:00',5.02),('14598','2013-07-15','14:10:00',4.99),('14598','2013-07-15','14:15:00',4.97),('14598','2013-07-15','14:20:00',4.98),('14598','2013-07-15','14:25:00',4.95),('14598','2013-07-15','14:30:00',4.95),('14598','2013-07-15','14:35:00',4.93),('14598','2013-07-15','14:40:00',4.87),('14598','2013-07-15','14:45:00',4.85),('14598','2013-07-15','14:50:00',4.85),('14598','2013-07-15','14:55:00',4.88),('14598','2013-07-15','15:00:00',4.86),('14598','2013-07-15','15:05:00',4.82),('14598','2013-07-15','15:10:00',4.77),('14598','2013-07-15','15:15:00',4.76),('14598','2013-07-15','15:20:00',4.75),('14598','2013-07-15','15:25:00',4.71),('14598','2013-07-15','15:30:00',4.68),('14598','2013-07-15','15:35:00',4.64),('14598','2013-07-15','15:40:00',4.58),('14598','2013-07-15','15:45:00',4.5),('14598','2013-07-15','15:50:00',4.47),('14598','2013-07-15','15:55:00',4.43),('14598','2013-07-15','16:00:00',4.36),('14598','2013-07-15','16:05:00',4.34),('14598','2013-07-15','16:10:00',4.27),('14598','2013-07-15','16:15:00',4.21),('14598','2013-07-15','16:20:00',4.13),('14598','2013-07-15','16:25:00',4.07),('14598','2013-07-15','16:30:00',3.99),('14598','2013-07-15','16:35:00',3.93),('14598','2013-07-15','16:40:00',3.91),('14598','2013-07-15','16:45:00',3.82),('14598','2013-07-15','16:50:00',3.75),('14598','2013-07-15','16:55:00',3.64),('14598','2013-07-15','17:00:00',3.53),('14598','2013-07-15','17:05:00',3.44),('14598','2013-07-15','17:10:00',3.39),('14598','2013-07-15','17:15:00',3.32),('14598','2013-07-15','17:20:00',3.23),('14598','2013-07-15','17:25:00',3.14),('14598','2013-07-15','17:30:00',3.06),('14598','2013-07-15','17:35:00',2.98),('14598','2013-07-15','17:40:00',2.9),('14598','2013-07-15','17:45:00',2.8),('14598','2013-07-15','17:50:00',2.71),('14598','2013-07-15','17:55:00',2.61),('14598','2013-07-15','18:00:00',2.48),('14598','2013-07-15','18:05:00',2.41),('14598','2013-07-15','18:10:00',2.31),('14598','2013-07-15','18:15:00',2.21),('14598','2013-07-15','18:20:00',2.09),('14598','2013-07-15','18:25:00',2.01),('14598','2013-07-15','18:30:00',1.89),('14598','2013-07-15','18:35:00',1.76),('14598','2013-07-15','18:40:00',1.66),('14598','2013-07-15','18:45:00',1.55),('14598','2013-07-15','18:50:00',1.48),('14598','2013-07-15','18:55:00',1.38),('14598','2013-07-15','19:00:00',1.29),('14598','2013-07-15','19:05:00',1.19),('14598','2013-07-15','19:10:00',1.09),('14598','2013-07-14','08:00:00',1.19),('14598','2013-07-14','08:05:00',1.27),('14598','2013-07-14','08:10:00',1.46),('14598','2013-07-14','08:15:00',1.26),('14598','2013-07-14','08:20:00',1.36),('14598','2013-07-14','08:25:00',1.19),('14598','2013-07-14','08:30:00',1.73),('14598','2013-07-14','08:35:00',1.71),('14598','2013-07-14','08:40:00',1.52),('14598','2013-07-14','08:45:00',1.38),('14598','2013-07-14','08:50:00',2.03),('14598','2013-07-14','08:55:00',2.7),('14598','2013-07-14','09:00:00',2.07),('14598','2013-07-14','09:05:00',2.19),('14598','2013-07-14','09:10:00',2.38),('14598','2013-07-14','09:15:00',2.52),('14598','2013-07-14','09:20:00',2),('14598','2013-07-14','09:25:00',2.1),('14598','2013-07-14','09:30:00',1.75),('14598','2013-07-14','09:35:00',1.63),('14598','2013-07-14','09:40:00',1.38),('14598','2013-07-14','09:45:00',1.34),('14598','2013-07-14','09:50:00',1.55),('14598','2013-07-14','09:55:00',1.6),('14598','2013-07-14','10:00:00',2.17),('14598','2013-07-14','10:05:00',3.12),('14598','2013-07-14','10:10:00',3),('14598','2013-07-14','10:15:00',3.78),('14598','2013-07-14','10:20:00',3.75),('14598','2013-07-14','10:25:00',3.85),('14598','2013-07-14','10:30:00',4.01),('14598','2013-07-14','10:35:00',4.39),('14598','2013-07-14','10:40:00',3.19),('14598','2013-07-14','10:45:00',2.83),('14598','2013-07-14','10:50:00',2.72),('14598','2013-07-14','10:55:00',2.6),('14598','2013-07-14','11:00:00',2.63),('14598','2013-07-14','11:05:00',3.45),('14598','2013-07-14','11:10:00',2.37),('14598','2013-07-14','11:15:00',4.24),('14598','2013-07-14','11:20:00',4.24),('14598','2013-07-14','11:25:00',4.26),('14598','2013-07-14','11:30:00',4.29),('14598','2013-07-14','11:35:00',4.3),('14598','2013-07-14','11:40:00',4.35),('14598','2013-07-14','11:45:00',4.36),('14598','2013-07-14','11:50:00',4.24),('14598','2013-07-14','11:55:00',4.46),('14598','2013-07-14','12:00:00',3.98),('14598','2013-07-14','12:05:00',4.65),('14598','2013-07-14','12:10:00',4.58),('14598','2013-07-14','12:15:00',4.58),('14598','2013-07-14','12:20:00',4.66),('14598','2013-07-14','12:25:00',4.69),('14598','2013-07-14','12:30:00',4.72),('14598','2013-07-14','12:35:00',4.77),('14598','2013-07-14','12:40:00',4.79),('14598','2013-07-14','12:45:00',4.83),('14598','2013-07-14','12:50:00',4.86),('14598','2013-07-14','12:55:00',4.85),('14598','2013-07-14','13:00:00',4.88),('14598','2013-07-14','13:05:00',4.93),('14598','2013-07-14','13:10:00',4.95),('14598','2013-07-14','13:15:00',4.99),('14598','2013-07-14','13:20:00',5.02),('14598','2013-07-14','13:25:00',5.03),('14598','2013-07-14','13:30:00',5.04),('14598','2013-07-14','13:35:00',5.03),('14598','2013-07-14','13:40:00',5.05),('14598','2013-07-14','13:45:00',5.07),('14598','2013-07-14','13:50:00',5.08),('14598','2013-07-14','13:55:00',5.08),('14598','2013-07-14','14:00:00',5.09),('14598','2013-07-14','14:05:00',5.04),('14598','2013-07-14','14:10:00',5.03),('14598','2013-07-14','14:15:00',5.03),('14598','2013-07-14','14:20:00',5.03),('14598','2013-07-14','14:25:00',5),('14598','2013-07-14','14:30:00',4.99),('14598','2013-07-14','14:35:00',4.99),('14598','2013-07-14','14:40:00',4.94),('14598','2013-07-14','14:45:00',4.92),('14598','2013-07-14','14:50:00',4.86),('14598','2013-07-14','14:55:00',4.81),('14598','2013-07-14','15:00:00',4.82),('14598','2013-07-14','15:05:00',4.8),('14598','2013-07-14','15:10:00',4.67),('14598','2013-07-14','15:15:00',4.69),('14598','2013-07-14','15:20:00',4.68),('14598','2013-07-14','15:25:00',4.62),('14598','2013-07-14','15:30:00',4.58),('14598','2013-07-14','15:35:00',4.59),('14598','2013-07-14','15:40:00',4.55),('14598','2013-07-14','15:45:00',4.53),('14598','2013-07-14','15:50:00',4.48),('14598','2013-07-14','15:55:00',4.42),('14598','2013-07-14','16:00:00',4.26),('14598','2013-07-14','16:05:00',4.38),('14598','2013-07-14','16:10:00',4.34),('14598','2013-07-14','16:15:00',3.95),('14598','2013-07-14','16:20:00',3.94),('14598','2013-07-14','16:25:00',4.14),('14598','2013-07-14','16:30:00',3.71),('14598','2013-07-14','16:35:00',3.54),('14598','2013-07-14','16:40:00',3.91),('14598','2013-07-14','16:45:00',3.56),('14598','2013-07-14','16:50:00',3.74),('14598','2013-07-14','16:55:00',3.62),('14598','2013-07-14','17:00:00',3.51),('14598','2013-07-14','17:05:00',3.56),('14598','2013-07-14','17:10:00',3.15),('14598','2013-07-14','17:15:00',3.17),('14598','2013-07-14','17:20:00',3.25),('14598','2013-07-14','17:25:00',2.08),('14598','2013-07-14','17:30:00',3.35),('14598','2013-07-14','17:35:00',1.73),('14598','2013-07-14','17:40:00',1.84),('14598','2013-07-14','17:45:00',1.37),('14598','2013-07-14','17:50:00',1.84),('14598','2013-07-14','17:55:00',2.76),('14598','2013-07-14','18:00:00',1.95),('14598','2013-07-14','18:45:00',1.55),('14598','2013-07-14','18:50:00',1.84),('14598','2013-07-14','18:55:00',1.6),('14598','2013-07-14','19:00:00',1.34),('14598','2013-07-14','19:05:00',1.15),('14598','2013-07-14','19:10:00',1.03),('14598','2013-07-13','08:05:00',1.08),('14598','2013-07-13','08:10:00',1.14),('14598','2013-07-13','08:15:00',1.23),('14598','2013-07-13','08:20:00',1.33),('14598','2013-07-13','08:25:00',1.44),('14598','2013-07-13','08:30:00',1.53),('14598','2013-07-13','08:35:00',1.61),('14598','2013-07-13','08:40:00',1.68),('14598','2013-07-13','08:45:00',1.79),('14598','2013-07-13','08:50:00',1.89),('14598','2013-07-13','08:55:00',1.99),('14598','2013-07-13','09:00:00',2.12),('14598','2013-07-13','09:05:00',2.2),('14598','2013-07-13','09:10:00',2.29),('14598','2013-07-13','09:15:00',2.34),('14598','2013-07-13','09:20:00',2.48),('14598','2013-07-13','09:25:00',2.51),('14598','2013-07-13','09:30:00',2.47),('14598','2013-07-13','09:35:00',2.68),('14598','2013-07-13','09:40:00',2.85),('14598','2013-07-13','09:45:00',2.89),('14598','2013-07-13','09:50:00',3.04),('14598','2013-07-13','09:55:00',3.14),('14598','2013-07-13','10:00:00',3.11),('14598','2013-07-13','10:05:00',3.2),('14598','2013-07-13','10:10:00',3.28),('14598','2013-07-13','10:15:00',3.33),('14598','2013-07-13','10:20:00',3.45),('14598','2013-07-13','10:25:00',3.47),('14598','2013-07-13','10:30:00',3.57),('14598','2013-07-13','10:35:00',3.67),('14598','2013-07-13','10:40:00',3.72),('14598','2013-07-13','10:45:00',3.77),('14598','2013-07-13','10:50:00',3.87),('14598','2013-07-13','10:55:00',3.92),('14598','2013-07-13','11:00:00',3.97),('14598','2013-07-13','11:05:00',4.03),('14598','2013-07-13','11:10:00',4.09),('14598','2013-07-13','11:15:00',4.15),('14598','2013-07-13','11:20:00',4.07),('14598','2013-07-13','11:25:00',4.23),('14598','2013-07-13','11:30:00',4.25),('14598','2013-07-13','11:35:00',4.36),('14598','2013-07-13','11:40:00',4.41),('14598','2013-07-13','11:45:00',4.43),('14598','2013-07-13','11:50:00',4.49),('14598','2013-07-13','11:55:00',4.53),('14598','2013-07-13','12:00:00',4.57),('14598','2013-07-13','12:05:00',4.65),('14598','2013-07-13','12:10:00',4.7),('14598','2013-07-13','12:15:00',4.73),('14598','2013-07-13','12:20:00',4.75),('14598','2013-07-13','12:25:00',4.78),('14598','2013-07-13','12:30:00',4.81),('14598','2013-07-13','12:35:00',4.83),('14598','2013-07-13','12:40:00',4.87),('14598','2013-07-13','12:45:00',4.92),('14598','2013-07-13','12:50:00',4.91),('14598','2013-07-13','12:55:00',4.96),('14598','2013-07-13','13:00:00',4.95),('14598','2013-07-13','13:05:00',5),('14598','2013-07-13','13:10:00',5),('14598','2013-07-13','13:15:00',5.02),('14598','2013-07-13','13:20:00',5.07),('14598','2013-07-13','13:25:00',5.07),('14598','2013-07-13','13:30:00',5.07),('14598','2013-07-13','13:35:00',5.06),('14598','2013-07-13','13:40:00',4.54),('14598','2013-07-13','13:45:00',5.04),('14598','2013-07-13','13:50:00',5.07),('14598','2013-07-13','13:55:00',5.06),('14598','2013-07-13','14:00:00',5.05),('14598','2013-07-13','14:05:00',5.07),('14598','2013-07-13','14:10:00',5.04),('14598','2013-07-13','14:15:00',4.99),('14598','2013-07-13','14:20:00',4.97),('14598','2013-07-13','14:25:00',5.03),('14598','2013-07-13','14:30:00',5.01),('14598','2013-07-13','14:35:00',5.03),('14598','2013-07-13','14:40:00',5.01),('14598','2013-07-13','14:45:00',5),('14598','2013-07-13','14:50:00',4.99),('14598','2013-07-13','14:55:00',4.78),('14598','2013-07-13','15:00:00',4.64),('14598','2013-07-13','15:05:00',4.88),('14598','2013-07-13','15:10:00',3.45),('14598','2013-07-13','15:15:00',4.28),('14598','2013-07-13','15:20:00',4.5),('14598','2013-07-13','15:25:00',4.06),('14598','2013-07-13','15:30:00',4.83),('14598','2013-07-13','15:35:00',4.71),('14598','2013-07-13','15:40:00',4.67),('14598','2013-07-13','15:45:00',4.48),('14598','2013-07-13','15:50:00',4.56),('14598','2013-07-13','15:55:00',4.52),('14598','2013-07-13','16:00:00',4.45),('14598','2013-07-13','16:05:00',4.38),('14598','2013-07-13','16:10:00',4.29),('14598','2013-07-13','16:15:00',4.29),('14598','2013-07-13','16:20:00',4.19),('14598','2013-07-13','16:25:00',4.13),('14598','2013-07-13','16:30:00',4.08),('14598','2013-07-13','16:35:00',4.03),('14598','2013-07-13','16:40:00',3.95),('14598','2013-07-13','16:45:00',3.9),('14598','2013-07-13','16:50:00',3.84),('14598','2013-07-13','16:55:00',3.64),('14598','2013-07-13','17:00:00',3.69),('14598','2013-07-13','17:05:00',3.59),('14598','2013-07-13','17:10:00',3.3),('14598','2013-07-13','17:15:00',3.43),('14598','2013-07-13','17:20:00',2.92),('14598','2013-07-13','17:25:00',3.28),('14598','2013-07-13','17:30:00',2.72),('14598','2013-07-13','17:35:00',1.72),('14598','2013-07-13','17:40:00',2.61),('14598','2013-07-13','17:45:00',3.13),('14598','2013-07-13','17:50:00',2.87),('14598','2013-07-13','17:55:00',2.8),('14598','2013-07-13','18:00:00',2.73),('14598','2013-07-13','18:05:00',2.63),('14598','2013-07-13','18:10:00',2.46),('14598','2013-07-13','18:15:00',2.45),('14598','2013-07-13','18:20:00',2.3),('14598','2013-07-13','18:25:00',2.19),('14598','2013-07-13','18:30:00',1.65),('14598','2013-07-13','18:35:00',1.16),('14598','2013-07-13','18:40:00',1.75),('14598','2013-07-13','18:45:00',1.99),('14598','2013-07-13','18:50:00',1.6),('14598','2013-07-13','18:55:00',1.67),('14598','2013-07-13','19:00:00',1.41),('14598','2013-07-13','19:05:00',1.34),('14598','2013-07-13','19:10:00',1.07),('14598','2013-07-13','19:15:00',1.08),('14598','2013-07-13','19:20:00',1.03),('14598','2013-07-12','08:00:00',1.17),('14598','2013-07-12','08:05:00',1.07),('14598','2013-07-12','08:15:00',1.07),('14598','2013-07-12','08:20:00',1.17),('14598','2013-07-12','08:25:00',1.24),('14598','2013-07-12','08:30:00',1.07),('14598','2013-07-12','08:40:00',1.43),('14598','2013-07-12','08:45:00',1.33),('14598','2013-07-12','08:50:00',1.96),('14598','2013-07-12','08:55:00',1.43),('14598','2013-07-12','09:00:00',1.2),('14598','2013-07-12','09:05:00',2.33),('14598','2013-07-12','09:10:00',2.51),('14598','2013-07-12','09:20:00',1.77),('14598','2013-07-12','09:25:00',2.49),('14598','2013-07-12','09:30:00',1.13),('14598','2013-07-12','09:40:00',1.12),('14598','2013-07-12','09:45:00',1.32),('14598','2013-07-12','09:50:00',1.48),('14598','2013-07-12','09:55:00',1.94),('14598','2013-07-12','10:00:00',2.61),('14598','2013-07-12','10:05:00',3.23),('14598','2013-07-12','10:10:00',2.9),('14598','2013-07-12','10:15:00',2.61),('14598','2013-07-12','10:20:00',2.31),('14598','2013-07-12','10:25:00',3.15),('14598','2013-07-12','10:30:00',3.42),('14598','2013-07-12','10:35:00',3.69),('14598','2013-07-12','10:40:00',3.7),('14598','2013-07-12','10:45:00',3.71),('14598','2013-07-12','10:50:00',2.98),('14598','2013-07-12','10:55:00',3.88),('14598','2013-07-12','11:00:00',3.88),('14598','2013-07-12','11:05:00',3.96),('14598','2013-07-12','11:10:00',4.02),('14598','2013-07-12','11:15:00',4.12),('14598','2013-07-12','11:20:00',4.16),('14598','2013-07-12','11:25:00',4.22),('14598','2013-07-12','11:30:00',4.25),('14598','2013-07-12','11:35:00',4.32),('14598','2013-07-12','11:40:00',4.34),('14598','2013-07-12','11:45:00',4.44),('14598','2013-07-12','11:50:00',4.51),('14598','2013-07-12','11:55:00',4.47),('14598','2013-07-12','12:00:00',4.5),('14598','2013-07-12','12:05:00',4.55),('14598','2013-07-12','12:10:00',4.61),('14598','2013-07-12','12:15:00',4.65),('14598','2013-07-12','12:20:00',4.68),('14598','2013-07-12','12:25:00',4.74),('14598','2013-07-12','12:30:00',4.76),('14598','2013-07-12','12:35:00',4.8),('14598','2013-07-12','12:40:00',4.79),('14598','2013-07-12','12:45:00',4.68),('14598','2013-07-12','12:50:00',4.83),('14598','2013-07-12','12:55:00',4.83),('14598','2013-07-12','13:00:00',4.84),('14598','2013-07-12','13:05:00',4.83),('14598','2013-07-12','13:10:00',4.91),('14598','2013-07-12','13:15:00',4.95),('14598','2013-07-12','13:20:00',4.95),('14598','2013-07-12','13:25:00',4.97),('14598','2013-07-12','13:30:00',4.98),('14598','2013-07-12','13:35:00',4.96),('14598','2013-07-12','13:40:00',4.97),('14598','2013-07-12','13:45:00',4.97),('14598','2013-07-12','13:50:00',4.98),('14598','2013-07-12','13:55:00',4.99),('14598','2013-07-12','14:00:00',4.97),('14598','2013-07-12','14:05:00',4.94),('14598','2013-07-12','14:10:00',4.95),('14598','2013-07-12','14:15:00',4.94),('14598','2013-07-12','14:20:00',4.94),('14598','2013-07-12','14:25:00',4.92),('14598','2013-07-12','14:30:00',4.88),('14598','2013-07-12','14:35:00',4.87),('14598','2013-07-12','14:40:00',4.88),('14598','2013-07-12','14:45:00',4.84),('14598','2013-07-12','14:50:00',4.86),('14598','2013-07-12','14:55:00',4.84),('14598','2013-07-12','15:00:00',4.81),('14598','2013-07-12','15:05:00',4.79),('14598','2013-07-12','15:10:00',4.74),('14598','2013-07-12','15:15:00',4.69),('14598','2013-07-12','15:20:00',4.7),('14598','2013-07-12','15:25:00',4.63),('14598','2013-07-12','15:30:00',4.56),('14598','2013-07-12','15:35:00',4.53),('14598','2013-07-12','15:40:00',4.49),('14598','2013-07-12','15:45:00',4.46),('14598','2013-07-12','15:50:00',4.38),('14598','2013-07-12','15:55:00',4.38),('14598','2013-07-12','16:00:00',4.32),('14598','2013-07-12','16:05:00',4.25),('14598','2013-07-12','16:10:00',4.23),('14598','2013-07-12','16:15:00',4.18),('14598','2013-07-12','16:20:00',4.1),('14598','2013-07-12','16:25:00',4.02),('14598','2013-07-12','16:30:00',3.99),('14598','2013-07-12','16:35:00',3.94),('14598','2013-07-12','16:40:00',3.87),('14598','2013-07-12','16:45:00',3.78),('14598','2013-07-12','16:50:00',3.73),('14598','2013-07-12','16:55:00',3.66),('14598','2013-07-12','17:00:00',3.56),('14598','2013-07-12','17:05:00',3.5),('14598','2013-07-12','17:10:00',3.45),('14598','2013-07-12','17:15:00',3.39),('14598','2013-07-12','17:20:00',3.3),('14598','2013-07-12','17:25:00',3.23),('14598','2013-07-12','17:30:00',3.2),('14598','2013-07-12','17:35:00',3.09),('14598','2013-07-12','17:40:00',3.09),('14598','2013-07-12','17:45:00',1.63),('14598','2013-07-12','17:50:00',1.27),('14598','2013-07-12','17:55:00',2.66),('14598','2013-07-12','18:00:00',2.73),('14598','2013-07-12','18:05:00',2.54),('14598','2013-07-12','18:10:00',2.36),('14598','2013-07-12','18:15:00',2.24),('14598','2013-07-12','18:20:00',2.15),('14598','2013-07-12','18:25:00',2.04),('14598','2013-07-12','18:30:00',1.93),('14598','2013-07-12','18:35:00',1.84),('14598','2013-07-12','18:40:00',1.75),('14598','2013-07-12','18:45:00',1.63),('14598','2013-07-12','18:50:00',1.52),('14598','2013-07-12','18:55:00',1.41),('14598','2013-07-12','19:00:00',1.31),('14598','2013-07-12','19:05:00',1.19),('14598','2013-07-12','19:10:00',1.11),('14598','2013-07-12','19:15:00',1),('14598','2013-07-11','08:00:00',1.02),('14598','2013-07-11','08:05:00',1.09),('14598','2013-07-11','08:10:00',1.16),('14598','2013-07-11','08:15:00',1.23),('14598','2013-07-11','08:20:00',1.32),('14598','2013-07-11','08:25:00',1.42),('14598','2013-07-11','08:30:00',1.5),('14598','2013-07-11','08:35:00',1.6),('14598','2013-07-11','08:40:00',1.68),('14598','2013-07-11','08:45:00',1.77),('14598','2013-07-11','08:50:00',1.98),('14598','2013-07-11','08:55:00',2.05),('14598','2013-07-11','09:00:00',2.17),('14598','2013-07-11','09:05:00',2.25),('14598','2013-07-11','09:10:00',2.39),('14598','2013-07-11','09:15:00',1.49),('14598','2013-07-11','09:20:00',1.2),('14598','2013-07-11','09:25:00',1.14),('14598','2013-07-11','09:30:00',1.02),('14598','2013-07-11','09:35:00',1.81),('14598','2013-07-11','09:40:00',1.03),('14598','2013-07-11','09:45:00',2.48),('14598','2013-07-11','09:50:00',3.13),('14598','2013-07-11','09:55:00',3.13),('14598','2013-07-11','10:00:00',3.14),('14598','2013-07-11','10:05:00',3.21),('14598','2013-07-11','10:10:00',3.27),('14598','2013-07-11','10:15:00',3.35),('14598','2013-07-11','10:20:00',3.47),('14598','2013-07-11','10:25:00',3.54),('14598','2013-07-11','10:30:00',3.62),('14598','2013-07-11','10:35:00',3.69),('14598','2013-07-11','10:40:00',3.74),('14598','2013-07-11','10:45:00',3.79),('14598','2013-07-11','10:50:00',3.88),('14598','2013-07-11','10:55:00',3.94),('14598','2013-07-11','11:00:00',4.01),('14598','2013-07-11','11:05:00',4.06),('14598','2013-07-11','11:10:00',4.11),('14598','2013-07-11','11:15:00',4.17),('14598','2013-07-11','11:20:00',4.25),('14598','2013-07-11','11:25:00',4.28),('14598','2013-07-11','11:30:00',4.35),('14598','2013-07-11','11:35:00',4.36),('14598','2013-07-11','11:40:00',4.42),('14598','2013-07-11','11:45:00',4.48),('14598','2013-07-11','11:50:00',4.53),('14598','2013-07-11','11:55:00',4.53),('14598','2013-07-11','12:00:00',4.59),('14598','2013-07-11','12:05:00',4.65),('14598','2013-07-11','12:10:00',4.69),('14598','2013-07-11','12:15:00',4.69),('14598','2013-07-11','12:20:00',4.78),('14598','2013-07-11','12:25:00',4.78),('14598','2013-07-11','12:30:00',4.58),('14598','2013-07-11','12:35:00',4.8),('14598','2013-07-11','12:40:00',4.87),('14598','2013-07-11','12:45:00',4.89),('14598','2013-07-11','12:50:00',4.89),('14598','2013-07-11','12:55:00',4.92),('14598','2013-07-11','13:00:00',4.96),('14598','2013-07-11','13:05:00',4.96),('14598','2013-07-11','13:10:00',4.99),('14598','2013-07-11','13:15:00',5.01),('14598','2013-07-11','13:20:00',4.99),('14598','2013-07-11','13:25:00',5),('14598','2013-07-11','13:30:00',5.03),('14598','2013-07-11','13:35:00',5.07),('14598','2013-07-11','13:40:00',4.97),('14598','2013-07-11','13:45:00',5.04),('14598','2013-07-11','13:50:00',5.04),('14598','2013-07-11','13:55:00',5.04),('14598','2013-07-11','14:00:00',5.04),('14598','2013-07-11','14:05:00',5.03),('14598','2013-07-11','14:10:00',5.15),('14598','2013-07-11','14:15:00',5.09),('14598','2013-07-11','14:20:00',5.04),('14598','2013-07-11','14:25:00',4.98),('14598','2013-07-11','14:30:00',4.98),('14598','2013-07-11','14:35:00',4.98),('14598','2013-07-11','14:40:00',4.96),('14598','2013-07-11','14:45:00',4.93),('14598','2013-07-11','14:50:00',4.89),('14598','2013-07-11','14:55:00',4.86),('14598','2013-07-11','15:00:00',4.79),('14598','2013-07-11','15:05:00',4.77),('14598','2013-07-11','15:10:00',4.71),('14598','2013-07-11','15:15:00',4.72),('14598','2013-07-11','15:20:00',4.71),('14598','2013-07-11','15:25:00',4.68),('14598','2013-07-11','15:30:00',4.64),('14598','2013-07-11','15:35:00',4.57),('14598','2013-07-11','15:40:00',4.51),('14598','2013-07-11','15:45:00',4.49),('14598','2013-07-11','15:50:00',4.35),('14598','2013-07-11','15:55:00',4.4),('14598','2013-07-11','16:00:00',4.37),('14598','2013-07-11','16:05:00',4.31),('14598','2013-07-11','16:10:00',4.26),('14598','2013-07-11','16:15:00',4.21),('14598','2013-07-11','16:20:00',4.09),('14598','2013-07-11','16:25:00',4.03),('14598','2013-07-11','16:30:00',3.94),('14598','2013-07-11','16:35:00',3.94),('14598','2013-07-11','16:40:00',3.89),('14598','2013-07-11','16:45:00',3.73),('14598','2013-07-11','16:50:00',3.7),('14598','2013-07-11','16:55:00',3.65),('14598','2013-07-11','17:00:00',3.57),('14598','2013-07-11','17:05:00',3.49),('14598','2013-07-11','17:10:00',3.44),('14598','2013-07-11','17:15:00',3.34),('14598','2013-07-11','17:20:00',3.24),('14598','2013-07-11','17:25:00',3.16),('14598','2013-07-11','17:30:00',3.08),('14598','2013-07-11','17:35:00',2.93),('14598','2013-07-11','17:40:00',2.95),('14598','2013-07-11','17:45:00',2.86),('14598','2013-07-11','17:50:00',2.73),('14598','2013-07-11','17:55:00',2.58),('14598','2013-07-11','18:00:00',2.56),('14598','2013-07-11','18:05:00',2.47),('14598','2013-07-11','18:10:00',2.35),('14598','2013-07-11','18:15:00',2.2),('14598','2013-07-11','18:20:00',2.09),('14598','2013-07-11','18:25:00',1.33),('14598','2013-07-11','18:30:00',1.08),('14598','2013-07-11','18:35:00',1.63),('14598','2013-07-11','18:50:00',1.58),('14598','2013-07-11','18:55:00',1.64),('14598','2013-07-11','19:00:00',1.48),('14598','2013-07-11','19:05:00',1.42),('14598','2013-07-11','19:10:00',1.3),('14598','2013-07-11','19:15:00',1.15),('14598','2013-07-11','19:20:00',1.06),('14598','2014-05-03','07:45:00',1.19),('14598','2014-05-03','08:05:00',1.06),('14598','2014-05-03','08:10:00',1.17),('14598','2014-05-03','08:15:00',1.3),('14598','2014-05-03','08:20:00',1.45),('14598','2014-05-03','08:25:00',1.49),('14598','2014-05-03','08:30:00',1.53),('14598','2014-05-03','08:35:00',1.7),('14598','2014-05-03','08:40:00',2.04),('14598','2014-05-03','08:45:00',1.21),('14598','2014-05-03','08:50:00',2.16),('14598','2014-05-03','08:55:00',2.02),('14598','2014-05-03','10:35:00',1.34),('14598','2014-05-03','10:40:00',1.37),('14598','2014-05-03','10:45:00',1.26),('14598','2014-05-03','10:50:00',1.48),('14598','2014-05-03','10:55:00',1.23),('14598','2014-05-03','11:00:00',1.32),('14598','2014-05-03','11:05:00',1.16),('14598','2014-05-03','12:25:00',1.14),('14598','2014-05-03','12:30:00',1.42),('14598','2014-05-03','12:35:00',1.52),('14598','2014-05-03','12:40:00',1.46),('14598','2014-05-03','12:45:00',1.24),('14598','2014-05-03','12:50:00',1.11),('14598','2014-05-03','12:55:00',1.11),('14598','2014-05-03','13:00:00',1.05),('14598','2014-05-03','13:20:00',1.02),('14598','2014-05-03','13:25:00',1.08),('14598','2014-05-03','13:30:00',1.15),('14598','2014-05-03','13:35:00',1.23),('14598','2014-05-03','13:40:00',1.36),('14598','2014-05-03','13:45:00',1.54),('14598','2014-05-03','13:50:00',1.67),('14598','2014-05-03','13:55:00',1.74),('14598','2014-05-03','14:00:00',1.62),('14598','2014-05-03','14:05:00',1.09),('14598','2014-05-03','14:30:00',1.15),('14598','2014-05-03','14:35:00',1.54),('14598','2014-05-03','14:40:00',1.92),('14598','2014-05-03','14:45:00',2.13),('14598','2014-05-03','14:50:00',2.29),('14598','2014-05-03','14:55:00',2.6),('14598','2014-05-03','15:00:00',2.68),('14598','2014-05-03','15:05:00',2.22),('14598','2014-05-03','15:10:00',3.79),('14598','2014-05-03','15:15:00',2.63),('14598','2014-05-03','15:20:00',2.11),('14598','2014-05-03','15:25:00',1.16),('14598','2014-05-03','15:30:00',1.7),('14598','2014-05-03','15:35:00',1.65),('14598','2014-05-03','15:40:00',1.43),('14598','2014-05-03','15:45:00',1.3),('14598','2014-05-03','15:50:00',1.22),('14598','2014-05-03','15:55:00',1.08),('14598','2014-05-03','17:35:00',1.03),('14598','2014-05-03','17:40:00',1.93),('14598','2014-05-03','17:45:00',2.08),('14598','2014-05-03','17:50:00',2.32),('14598','2014-05-03','17:55:00',3.34),('14598','2014-05-03','18:00:00',2.87),('14598','2014-05-03','18:05:00',2.04),('14598','2014-05-03','18:10:00',2.34),('14598','2014-05-03','18:15:00',1.14),('14598','2014-04-06','08:50:00',1.37),('14598','2014-04-06','08:55:00',1.46),('14598','2014-04-06','09:00:00',1.62),('14598','2014-04-06','09:05:00',1.72),('14598','2014-04-06','09:10:00',1.77),('14598','2014-04-06','09:15:00',1.96),('14598','2014-04-06','09:20:00',2.11),('14598','2014-04-06','09:25:00',2.26),('14598','2014-04-06','09:30:00',2.35),('14598','2014-04-06','09:35:00',2.43),('14598','2014-04-06','09:40:00',2.54),('14598','2014-04-06','09:45:00',2.53),('14598','2014-04-06','09:50:00',1.58),('14598','2014-04-06','09:55:00',1.18),('14598','2014-04-06','10:00:00',1.32),('14598','2014-04-06','10:05:00',1.76),('14598','2014-04-06','10:10:00',1.38),('14598','2014-04-06','10:15:00',1.47),('14598','2014-04-06','10:20:00',1.42),('14598','2014-04-06','10:25:00',2.99),('14598','2014-04-06','10:30:00',2.79),('14598','2014-04-06','10:35:00',1.89),('14598','2014-04-06','10:40:00',1.54),('14598','2014-04-06','10:45:00',1.42),('14598','2014-04-06','10:50:00',1.39),('14598','2014-04-06','10:55:00',1.56),('14598','2014-04-06','11:00:00',1.68),('14598','2014-04-06','11:05:00',2.73),('14598','2014-04-06','11:10:00',4.09),('14598','2014-04-06','11:15:00',4.92),('14598','2014-04-06','11:20:00',4.51),('14598','2014-04-06','11:25:00',4.09),('14598','2014-04-06','11:30:00',4.31),('14598','2014-04-06','11:35:00',4.22),('14598','2014-04-06','11:40:00',4.23),('14598','2014-04-06','11:45:00',4.35),('14598','2014-04-06','11:50:00',4.42),('14598','2014-04-06','11:55:00',4.43),('14598','2014-04-06','12:00:00',4.41),('14598','2014-04-06','12:05:00',4.45),('14598','2014-04-06','12:10:00',4.48),('14598','2014-04-06','12:15:00',4.57),('14598','2014-04-06','12:20:00',4.66),('14598','2014-04-06','12:25:00',4.72),('14598','2014-04-06','12:30:00',4.77),('14598','2014-04-06','12:35:00',4.85),('14598','2014-04-06','12:40:00',4.86),('14598','2014-04-06','12:45:00',4.94),('14598','2014-04-06','12:50:00',4.93),('14598','2014-04-06','12:55:00',4.96),('14598','2014-04-06','13:00:00',5.05),('14598','2014-04-06','13:05:00',5.01),('14598','2014-04-06','13:10:00',4.97),('14598','2014-04-06','13:15:00',4.63),('14598','2014-04-06','13:20:00',4.76),('14598','2014-04-06','13:25:00',4.98),('14598','2014-04-06','13:30:00',4.99),('14598','2014-04-06','13:35:00',4.92),('14598','2014-04-06','13:40:00',4.89),('14598','2014-04-06','13:45:00',4.88),('14598','2014-04-06','13:50:00',4.89),('14598','2014-04-06','13:55:00',4.88),('14598','2014-04-06','14:00:00',4.86),('14598','2014-04-06','14:05:00',4.84),('14598','2014-04-06','14:10:00',4.83),('14598','2014-04-06','14:15:00',4.89),('14598','2014-04-06','14:20:00',4.93),('14598','2014-04-06','14:25:00',4.99),('14598','2014-04-06','14:30:00',5.01),('14598','2014-04-06','14:35:00',4.93),('14598','2014-04-06','14:40:00',4.84),('14598','2014-04-06','14:45:00',4.77),('14598','2014-04-06','14:50:00',4.75),('14598','2014-04-06','14:55:00',4.76),('14598','2014-04-06','15:00:00',4.67),('14598','2014-04-06','15:05:00',4.67),('14598','2014-04-06','15:10:00',4.63),('14598','2014-04-06','15:15:00',4.61),('14598','2014-04-06','15:20:00',4.6),('14598','2014-04-06','15:25:00',4.65),('14598','2014-04-06','15:30:00',4.74),('14598','2014-04-06','15:35:00',4.84),('14598','2014-04-06','15:40:00',4.61),('14598','2014-04-06','15:45:00',4.43),('14598','2014-04-06','15:50:00',4.45),('14598','2014-04-06','15:55:00',4.49),('14598','2014-04-06','16:00:00',4.46),('14598','2014-04-06','16:05:00',4.51),('14598','2014-04-06','16:10:00',4.53),('14598','2014-04-06','16:15:00',3.87),('14598','2014-04-06','16:20:00',2.87),('14598','2014-04-06','16:25:00',2.17),('14598','2014-04-06','16:30:00',2.5),('14598','2014-04-06','16:35:00',3.91),('14598','2014-04-06','16:40:00',3.53),('14598','2014-04-06','16:45:00',1.47),('14598','2014-04-06','16:50:00',1.96),('14598','2014-04-06','16:55:00',3.46),('14598','2014-04-06','17:00:00',3.37),('14598','2014-04-06','17:05:00',3.3),('14598','2014-04-06','17:10:00',3.55),('14598','2014-04-06','17:15:00',3.48),('14598','2014-04-06','17:20:00',1.82),('14598','2014-04-06','17:25:00',2.27),('14598','2014-04-06','17:30:00',2.54),('14598','2014-04-06','17:35:00',2.54),('14598','2014-04-06','17:40:00',2.4),('14598','2014-04-06','17:45:00',2.26),('14598','2014-04-06','17:50:00',2.12),('14598','2014-04-06','17:55:00',2),('14598','2014-04-06','18:00:00',1.91),('14598','2014-04-06','18:05:00',1.62),('14598','2014-04-06','18:10:00',1.72),('14598','2014-04-06','18:15:00',1.56),('14598','2014-04-06','18:20:00',1.44),('14598','2014-04-06','18:25:00',1.32),('14598','2014-04-06','18:30:00',1.19),('14598','2014-04-06','18:35:00',1.03),('14598','2013-07-10','08:00:00',1.06),('14598','2013-07-10','08:05:00',1.19),('14598','2013-07-10','08:10:00',1.25),('14598','2013-07-10','08:15:00',1.34),('14598','2013-07-10','08:20:00',1.44),('14598','2013-07-10','08:25:00',1.57),('14598','2013-07-10','08:30:00',1.66),('14598','2013-07-10','08:35:00',1.8),('14598','2013-07-10','08:40:00',1.91),('14598','2013-07-10','08:45:00',1.87),('14598','2013-07-10','08:50:00',1.85),('14598','2013-07-10','08:55:00',2.34),('14598','2013-07-10','09:00:00',2.43),('14598','2013-07-10','09:05:00',2.4),('14598','2013-07-10','09:10:00',2.42),('14598','2013-07-10','09:15:00',2.49),('14598','2013-07-10','09:20:00',2.61),('14598','2013-07-10','09:25:00',2.7),('14598','2013-07-10','09:30:00',2.74),('14598','2013-07-10','09:35:00',2.81),('14598','2013-07-10','09:40:00',2.86),('14598','2013-07-10','09:45:00',2.96),('14598','2013-07-10','09:50:00',3.04),('14598','2013-07-10','09:55:00',3.12),('14598','2013-07-10','10:00:00',3.15),('14598','2013-07-10','10:05:00',3.21),('14598','2013-07-10','10:10:00',3.28),('14598','2013-07-10','10:15:00',3.37),('14598','2013-07-10','10:20:00',3.45),('14598','2013-07-10','10:25:00',3.47),('14598','2013-07-10','10:30:00',3.47),('14598','2013-07-10','10:35:00',3.64),('14598','2013-07-10','10:40:00',3.72),('14598','2013-07-10','10:45:00',3.82),('14598','2013-07-10','10:50:00',3.9),('14598','2013-07-10','10:55:00',3.95),('14598','2013-07-10','11:00:00',3.99),('14598','2013-07-10','11:05:00',4.06),('14598','2013-07-10','11:10:00',4.11),('14598','2013-07-10','11:15:00',4.2),('14598','2013-07-10','11:20:00',4.25),('14598','2013-07-10','11:25:00',4.31),('14598','2013-07-10','11:30:00',4.37),('14598','2013-07-10','11:35:00',4.42),('14598','2013-07-10','11:40:00',4.45),('14598','2013-07-10','11:45:00',4.46),('14598','2013-07-10','11:50:00',4.55),('14598','2013-07-10','11:55:00',4.59),('14598','2013-07-10','12:00:00',4.62),('14598','2013-07-10','12:05:00',4.7),('14598','2013-07-10','12:10:00',4.71),('14598','2013-07-10','12:15:00',4.74),('14598','2013-07-10','12:20:00',4.74),('14598','2013-07-10','12:25:00',4.77),('14598','2013-07-10','12:30:00',4.82),('14598','2013-07-10','12:35:00',4.87),('14598','2013-07-10','12:40:00',4.91),('14598','2013-07-10','12:45:00',4.94),('14598','2013-07-10','12:50:00',4.96),('14598','2013-07-10','12:55:00',4.98),('14598','2013-07-10','13:00:00',4.98),('14598','2013-07-10','13:05:00',5.01),('14598','2013-07-10','13:10:00',4.99),('14598','2013-07-10','13:15:00',5.02),('14598','2013-07-10','13:20:00',5.01),('14598','2013-07-10','13:25:00',5.02),('14598','2013-07-10','13:30:00',5.01),('14598','2013-07-10','13:35:00',5.06),('14598','2013-07-10','13:40:00',5.07),('14598','2013-07-10','13:45:00',5.07),('14598','2013-07-10','13:50:00',5.07),('14598','2013-07-10','13:55:00',5.05),('14598','2013-07-10','14:00:00',5.05),('14598','2013-07-10','14:05:00',5.06),('14598','2013-07-10','14:10:00',5.05),('14598','2013-07-10','14:15:00',5.04),('14598','2013-07-10','14:20:00',5.02),('14598','2013-07-10','14:25:00',5.01),('14598','2013-07-10','14:30:00',4.99),('14598','2013-07-10','14:35:00',4.99),('14598','2013-07-10','14:40:00',4.95),('14598','2013-07-10','14:45:00',4.89),('14598','2013-07-10','14:50:00',4.92),('14598','2013-07-10','14:55:00',4.92),('14598','2013-07-10','15:00:00',4.88),('14598','2013-07-10','15:05:00',4.87),('14598','2013-07-10','15:10:00',4.84),('14598','2013-07-10','15:15:00',4.81),('14598','2013-07-10','15:20:00',4.77),('14598','2013-07-10','15:25:00',4.73),('14598','2013-07-10','15:30:00',4.69),('14598','2013-07-10','15:35:00',4.65),('14598','2013-07-10','15:40:00',4.62),('14598','2013-07-10','15:45:00',4.57),('14598','2013-07-10','15:50:00',4.52),('14598','2013-07-10','15:55:00',4.47),('14598','2013-07-10','16:00:00',4.42),('14598','2013-07-10','16:05:00',4.38),('14598','2013-07-10','16:10:00',4.31),('14598','2013-07-10','16:15:00',4.25),('14598','2013-07-10','16:20:00',4.19),('14598','2013-07-10','16:25:00',4.14),('14598','2013-07-10','16:30:00',4.02),('14598','2013-07-10','16:35:00',4.02),('14598','2013-07-10','16:40:00',3.96),('14598','2013-07-10','16:45:00',3.9),('14598','2013-07-10','16:50:00',3.84),('14598','2013-07-10','16:55:00',3.77),('14598','2013-07-10','17:00:00',3.71),('14598','2013-07-10','17:05:00',3.67),('14598','2013-07-10','17:10:00',3.65),('14598','2013-07-10','17:15:00',3.56),('14598','2013-07-10','17:20:00',3.56),('14598','2013-07-10','17:25:00',2.83),('14598','2013-07-10','17:30:00',2.51),('14598','2013-07-10','17:35:00',1.68),('14598','2013-07-10','17:40:00',2.6),('14598','2013-07-10','17:45:00',3.24),('14598','2013-07-10','17:50:00',3.21),('14598','2013-07-10','17:55:00',2.97),('14598','2013-07-10','18:00:00',2.69),('14598','2013-07-10','18:05:00',2.6),('14598','2013-07-10','18:10:00',2.54),('14598','2013-07-10','18:15:00',2.45),('14598','2013-07-10','18:20:00',2.35),('14598','2013-07-10','18:25:00',2.29),('14598','2013-07-10','18:30:00',2.22),('14598','2013-07-10','18:35:00',2.12),('14598','2013-07-10','18:40:00',2),('14598','2013-07-10','18:45:00',1.9),('14598','2013-07-10','18:50:00',1.82),('14598','2013-07-10','18:55:00',1.72),('14598','2013-07-10','19:00:00',1.58),('14598','2013-07-10','19:05:00',1.41),('14598','2013-07-10','19:10:00',1.26),('14598','2013-07-10','19:15:00',1.12),('14598','2013-07-10','19:20:00',1.02),('14598','2013-07-09','08:20:00',1.36),('14598','2013-07-09','08:25:00',1.06),('14598','2013-07-09','08:30:00',1.44),('14598','2013-07-09','08:35:00',1.76),('14598','2013-07-09','08:40:00',1.63),('14598','2013-07-09','08:45:00',1.8),('14598','2013-07-09','08:50:00',2),('14598','2013-07-09','08:55:00',2.1),('14598','2013-07-09','09:00:00',2.21),('14598','2013-07-09','09:05:00',2.26),('14598','2013-07-09','09:10:00',2.35),('14598','2013-07-09','09:15:00',2.45),('14598','2013-07-09','09:20:00',2.57),('14598','2013-07-09','09:25:00',2.66),('14598','2013-07-09','09:30:00',2.73),('14598','2013-07-09','09:35:00',2.82),('14598','2013-07-09','09:40:00',2.89),('14598','2013-07-09','09:45:00',2.97),('14598','2013-07-09','09:50:00',3.04),('14598','2013-07-09','09:55:00',3.12),('14598','2013-07-09','10:00:00',3.16),('14598','2013-07-09','10:05:00',3.24),('14598','2013-07-09','10:10:00',3.32),('14598','2013-07-09','10:15:00',3.37),('14598','2013-07-09','10:20:00',3.45),('14598','2013-07-09','10:25:00',3.52),('14598','2013-07-09','10:30:00',3.57),('14598','2013-07-09','10:35:00',3.62),('14598','2013-07-09','10:40:00',3.68),('14598','2013-07-09','10:45:00',3.74),('14598','2013-07-09','10:50:00',3.8),('14598','2013-07-09','10:55:00',3.86),('14598','2013-07-09','11:00:00',3.88),('14598','2013-07-09','11:05:00',3.94),('14598','2013-07-09','11:10:00',3.98),('14598','2013-07-09','11:15:00',4.02),('14598','2013-07-09','11:20:00',4.07),('14598','2013-07-09','11:25:00',4.08),('14598','2013-07-09','11:30:00',4.11),('14598','2013-07-09','11:35:00',4.15),('14598','2013-07-09','11:40:00',4.19),('14598','2013-07-09','11:45:00',4.23),('14598','2013-07-09','11:50:00',4.39),('14598','2013-07-09','11:55:00',4.48),('14598','2013-07-09','12:00:00',4.53),('14598','2013-07-09','12:05:00',4.54),('14598','2013-07-09','12:10:00',4.58),('14598','2013-07-09','12:15:00',4.6),('14598','2013-07-09','12:20:00',4.64),('14598','2013-07-09','12:25:00',4.73),('14598','2013-07-09','12:30:00',4.78),('14598','2013-07-09','12:35:00',4.85),('14598','2013-07-09','12:40:00',4.89),('14598','2013-07-09','12:45:00',4.88),('14598','2013-07-09','12:50:00',4.89),('14598','2013-07-09','12:55:00',4.95),('14598','2013-07-09','13:00:00',4.96),('14598','2013-07-09','13:05:00',4.97),('14598','2013-07-09','13:10:00',4.98),('14598','2013-07-09','13:15:00',4.98),('14598','2013-07-09','13:20:00',5.02),('14598','2013-07-09','13:25:00',5.03),('14598','2013-07-09','13:30:00',5.06),('14598','2013-07-09','13:35:00',5.09),('14598','2013-07-09','13:40:00',5.07),('14598','2013-07-09','13:45:00',5.07),('14598','2013-07-09','13:50:00',5.09),('14598','2013-07-09','13:55:00',5.11),('14598','2013-07-09','14:00:00',5.18),('14598','2013-07-09','14:05:00',5.27),('14598','2013-07-09','14:10:00',4.04),('14598','2013-07-09','14:15:00',4.81),('14598','2013-07-09','14:20:00',5.07),('14598','2013-07-09','14:25:00',5.53),('14598','2013-07-09','14:30:00',5.68),('14598','2013-07-09','14:35:00',4.72),('14598','2013-07-09','14:40:00',3.1),('14598','2013-07-09','14:45:00',2.06),('14598','2013-07-09','14:50:00',1.23),('14598','2013-07-08','07:55:00',1.03),('14598','2013-07-08','08:00:00',1.04),('14598','2013-07-08','08:05:00',1.14),('14598','2013-07-08','08:10:00',1.18),('14598','2013-07-08','08:20:00',1.4),('14598','2013-07-08','08:25:00',1.5),('14598','2013-07-08','08:30:00',1.62),('14598','2013-07-08','08:35:00',1.73),('14598','2013-07-08','08:40:00',1.8),('14598','2013-07-08','08:45:00',1.88),('14598','2013-07-08','08:50:00',2),('14598','2013-07-08','08:55:00',2.11),('14598','2013-07-08','09:00:00',2.21),('14598','2013-07-08','09:05:00',2.27),('14598','2013-07-08','09:10:00',2.35),('14598','2013-07-08','09:15:00',2.42),('14598','2013-07-08','09:20:00',2.52),('14598','2013-07-08','09:25:00',2.62),('14598','2013-07-08','09:30:00',2.71),('14598','2013-07-08','09:35:00',2.79),('14598','2013-07-08','09:40:00',2.87),('14598','2013-07-08','09:45:00',2.95),('14598','2013-07-08','09:50:00',3.03),('14598','2013-07-08','09:55:00',3.12),('14598','2013-07-08','10:00:00',3.19),('14598','2013-07-08','10:05:00',3.25),('14598','2013-07-08','10:10:00',3.3),('14598','2013-07-08','10:15:00',3.37),('14598','2013-07-08','10:20:00',3.44),('14598','2013-07-08','10:25:00',3.49),('14598','2013-07-08','10:30:00',3.56),('14598','2013-07-08','10:35:00',3.63),('14598','2013-07-08','10:40:00',3.67),('14598','2013-07-08','10:45:00',3.74),('14598','2013-07-08','10:50:00',3.81),('14598','2013-07-08','10:55:00',3.88),('14598','2013-07-08','11:00:00',3.92),('14598','2013-07-08','11:05:00',3.94),('14598','2013-07-08','11:10:00',4.01),('14598','2013-07-08','11:15:00',4.03),('14598','2013-07-08','11:20:00',4.1),('14598','2013-07-08','11:25:00',4.21),('14598','2013-07-08','11:30:00',4.28),('14598','2013-07-08','11:35:00',4.22),('14598','2013-07-08','11:40:00',4.19),('14598','2013-07-08','11:45:00',4.02),('14598','2013-07-08','11:50:00',4.14),('14598','2013-07-08','11:55:00',3.55),('14598','2013-07-08','12:00:00',4.17),('14598','2013-07-08','12:05:00',4.54),('14598','2013-07-08','12:10:00',4.42),('14598','2013-07-08','12:15:00',4.55),('14598','2013-07-08','12:20:00',4.37),('14598','2013-07-08','12:25:00',4.53),('14598','2013-07-08','12:30:00',4.56),('14598','2013-07-08','12:35:00',4.49),('14598','2013-07-08','12:40:00',4.66),('14598','2013-07-08','12:45:00',4.66),('14598','2013-07-08','12:50:00',4.87),('14598','2013-07-08','12:55:00',4.89),('14598','2013-07-08','13:00:00',4.93),('14598','2013-07-08','13:05:00',4.98),('14598','2013-07-08','13:10:00',4.98),('14598','2013-07-08','13:15:00',5.01),('14598','2013-07-08','13:20:00',5.07),('14598','2013-07-08','13:25:00',5.17),('14598','2013-07-08','13:30:00',5.18),('14598','2013-07-08','13:35:00',4.42),('14598','2013-07-08','13:40:00',3.83),('14598','2013-07-08','13:45:00',1.37),('14598','2013-07-08','14:45:00',1.07),('14598','2013-07-08','14:50:00',1.22),('14598','2013-07-08','14:55:00',1.29),('14598','2013-07-08','15:00:00',1.58),('14598','2013-07-08','15:05:00',1.67),('14598','2013-07-08','15:10:00',1.55),('14598','2013-07-08','15:15:00',1.48),('14598','2013-07-08','15:20:00',1.37),('14598','2013-07-08','15:25:00',1.35),('14598','2013-07-08','15:30:00',1.39),('14598','2013-07-08','15:35:00',1.33),('14598','2013-07-08','15:40:00',1.06),('14598','2013-07-07','08:00:00',1.06),('14598','2013-07-07','08:05:00',1.14),('14598','2013-07-07','08:10:00',1.2),('14598','2013-07-07','08:15:00',1.31),('14598','2013-07-07','08:20:00',1.4),('14598','2013-07-07','08:25:00',1.49),('14598','2013-07-07','08:30:00',1.59),('14598','2013-07-07','08:35:00',1.69),('14598','2013-07-07','08:40:00',1.78),('14598','2013-07-07','08:45:00',1.88),('14598','2013-07-07','08:50:00',2.02),('14598','2013-07-07','08:55:00',2.13),('14598','2013-07-07','09:00:00',1.7),('14598','2013-07-07','09:05:00',1.91),('14598','2013-07-07','09:10:00',2.42),('14598','2013-07-07','09:15:00',2.54),('14598','2013-07-07','09:20:00',2.49),('14598','2013-07-07','09:25:00',2.76),('14598','2013-07-07','09:30:00',2.71),('14598','2013-07-07','09:35:00',2.63),('14598','2013-07-07','09:40:00',2.36),('14598','2013-07-07','09:45:00',2.39),('14598','2013-07-07','09:50:00',1.88),('14598','2013-07-07','09:55:00',2.47),('14598','2013-07-07','10:00:00',3.15),('14598','2013-07-07','10:05:00',3.58),('14598','2013-07-07','10:10:00',3.43),('14598','2013-07-07','10:15:00',3.44),('14598','2013-07-07','10:20:00',3.4),('14598','2013-07-07','10:25:00',3.26),('14598','2013-07-07','10:30:00',2.79),('14598','2013-07-07','10:35:00',3.02),('14598','2013-07-07','10:40:00',3.63),('14598','2013-07-07','10:45:00',3.97),('14598','2013-07-07','10:50:00',3.98),('14598','2013-07-07','10:55:00',3.96),('14598','2013-07-07','11:00:00',3.99),('14598','2013-07-07','11:05:00',4.05),('14598','2013-07-07','11:10:00',4.07),('14598','2013-07-07','11:15:00',4.08),('14598','2013-07-07','11:20:00',4.14),('14598','2013-07-07','11:25:00',4.15),('14598','2013-07-07','11:30:00',4.06),('14598','2013-07-07','11:35:00',4.22),('14598','2013-07-07','11:40:00',4.02),('14598','2013-07-07','11:45:00',4.1),('14598','2013-07-07','11:50:00',4.19),('14598','2013-07-07','11:55:00',4.05),('14598','2013-07-07','12:00:00',4.38),('14598','2013-07-07','12:05:00',4.26),('14598','2013-07-07','12:10:00',4.21),('14598','2013-07-07','12:15:00',4.21),('14598','2013-07-07','12:20:00',4.23),('14598','2013-07-07','12:25:00',3.83),('14598','2013-07-07','12:30:00',3.17),('14598','2013-07-07','12:35:00',4.12),('14598','2013-07-07','12:40:00',4.55),('14598','2013-07-07','12:45:00',4.49),('14598','2013-07-07','12:50:00',4.69),('14598','2013-07-07','12:55:00',3.88),('14598','2013-07-07','13:00:00',4.72),('14598','2013-07-07','13:05:00',4.81),('14598','2013-07-07','13:10:00',4.74),('14598','2013-07-07','13:15:00',4.51),('14598','2013-07-07','13:20:00',4.63),('14598','2013-07-07','13:25:00',4.85),('14598','2013-07-07','13:30:00',5.06),('14598','2013-07-07','13:35:00',5.09),('14598','2013-07-07','13:40:00',5.11),('14598','2013-07-07','13:45:00',5.11),('14598','2013-07-07','13:50:00',5.19),('14598','2013-07-07','13:55:00',5.22),('14598','2013-07-07','14:00:00',5.26),('14598','2013-07-07','14:05:00',5.45),('14598','2013-07-07','14:10:00',4.69),('14598','2013-07-07','14:15:00',2.23),('14598','2013-07-07','14:20:00',1.05),('14598','2013-07-07','14:25:00',1.02),('14598','2013-07-07','14:30:00',1.28),('14598','2013-07-07','14:35:00',1.26),('14598','2013-07-07','14:40:00',1.67),('14598','2013-07-07','14:45:00',2.89),('14598','2013-07-07','15:20:00',1.2),('14598','2013-07-07','15:25:00',1.32),('14598','2013-07-07','15:30:00',1.79),('14598','2013-07-07','15:35:00',2.19),('14598','2013-07-07','15:40:00',1.71),('14598','2013-07-07','17:25:00',1.03),('14598','2013-07-07','17:30:00',1.15),('14598','2013-07-07','17:35:00',1.22),('14598','2013-07-07','17:40:00',1.29),('14598','2013-07-07','17:45:00',1.36),('14598','2013-07-07','17:50:00',1.39),('14598','2013-07-07','17:55:00',1.3),('14598','2013-07-07','18:00:00',1.36),('14598','2013-07-07','18:05:00',1.68),('14598','2013-07-07','18:10:00',1.72),('14598','2013-07-07','18:15:00',1.38),('14598','2013-07-06','08:00:00',1.04),('14598','2013-07-06','08:05:00',1.12),('14598','2013-07-06','08:10:00',1.21),('14598','2013-07-06','08:15:00',1.3),('14598','2013-07-06','08:20:00',1.38),('14598','2013-07-06','08:25:00',1.47),('14598','2013-07-06','08:30:00',1.56),('14598','2013-07-06','08:35:00',1.66),('14598','2013-07-06','08:40:00',1.75),('14598','2013-07-06','08:45:00',1.84),('14598','2013-07-06','08:50:00',1.96),('14598','2013-07-06','08:55:00',2.06),('14598','2013-07-06','09:00:00',2.15),('14598','2013-07-06','09:05:00',2.24),('14598','2013-07-06','09:10:00',2.32),('14598','2013-07-06','09:15:00',2.43),('14598','2013-07-06','09:20:00',2.53),('14598','2013-07-06','09:25:00',2.62),('14598','2013-07-06','09:30:00',2.69),('14598','2013-07-06','09:35:00',2.77),('14598','2013-07-06','09:40:00',2.85),('14598','2013-07-06','09:45:00',2.93),('14598','2013-07-06','09:50:00',3),('14598','2013-07-06','09:55:00',3.08),('14598','2013-07-06','10:00:00',3.15),('14598','2013-07-06','10:05:00',3.23),('14598','2013-07-06','10:10:00',3.29),('14598','2013-07-06','10:15:00',3.36),('14598','2013-07-06','10:20:00',3.43),('14598','2013-07-06','10:25:00',3.46),('14598','2013-07-06','10:30:00',3.55),('14598','2013-07-06','10:35:00',3.6),('14598','2013-07-06','10:40:00',3.64),('14598','2013-07-06','10:45:00',3.7),('14598','2013-07-06','10:50:00',3.77),('14598','2013-07-06','10:55:00',3.83),('14598','2013-07-06','11:00:00',3.9),('14598','2013-07-06','11:05:00',3.95),('14598','2013-07-06','11:10:00',3.99),('14598','2013-07-06','11:15:00',4.05),('14598','2013-07-06','11:20:00',4.1),('14598','2013-07-06','11:25:00',4.14),('14598','2013-07-06','11:30:00',4.18),('14598','2013-07-06','11:35:00',4.25),('14598','2013-07-06','11:40:00',4.3),('14598','2013-07-06','11:45:00',4.3),('14598','2013-07-06','11:50:00',4.34),('14598','2013-07-06','11:55:00',4.37),('14598','2013-07-06','12:00:00',4.39),('14598','2013-07-06','12:05:00',4.44),('14598','2013-07-06','12:10:00',4.44),('14598','2013-07-06','12:15:00',4.49),('14598','2013-07-06','12:20:00',4.54),('14598','2013-07-06','12:25:00',4.57),('14598','2013-07-06','12:30:00',4.56),('14598','2013-07-06','12:35:00',4.57),('14598','2013-07-06','12:40:00',4.64),('14598','2013-07-06','12:45:00',4.66),('14598','2013-07-06','12:50:00',4.65),('14598','2013-07-06','12:55:00',4.65),('14598','2013-07-06','13:00:00',4.68),('14598','2013-07-06','13:05:00',4.69),('14598','2013-07-06','13:10:00',4.75),('14598','2013-07-06','13:15:00',4.76),('14598','2013-07-06','13:20:00',4.93),('14598','2013-07-06','13:25:00',5),('14598','2013-07-06','13:30:00',5.33),('14598','2013-07-06','13:35:00',5.42),('14598','2013-07-06','13:40:00',4.28),('14598','2013-07-06','13:45:00',2.81),('14598','2013-07-06','13:50:00',3.02),('14598','2013-07-06','13:55:00',3.16),('14598','2013-07-06','14:00:00',2.85),('14598','2013-07-06','14:05:00',1.48),('14598','2013-07-06','14:10:00',3.91),('14598','2013-07-06','14:15:00',5.33),('14598','2013-07-06','14:20:00',5.24),('14598','2013-07-06','14:25:00',5.01),('14598','2013-07-06','14:30:00',4.96),('14598','2013-07-06','14:35:00',4.95),('14598','2013-07-06','14:40:00',4.91),('14598','2013-07-06','14:45:00',4.9),('14598','2013-07-06','14:50:00',4.89),('14598','2013-07-06','14:55:00',4.86),('14598','2013-07-06','15:00:00',4.86),('14598','2013-07-06','15:05:00',4.88),('14598','2013-07-06','15:10:00',4.95),('14598','2013-07-06','15:15:00',4.72),('14598','2013-07-06','15:20:00',3.7),('14598','2013-07-06','15:25:00',2.14),('14598','2013-07-06','15:30:00',2.19),('14598','2013-07-06','15:35:00',2.4),('14598','2013-07-06','15:40:00',1.65),('14598','2013-07-06','15:45:00',1.43),('14598','2013-07-06','15:50:00',1.3),('14598','2013-07-06','15:55:00',1.29),('14598','2013-07-06','16:00:00',1.39),('14598','2013-07-06','16:05:00',1.52),('14598','2013-07-06','16:10:00',1.53),('14598','2013-07-06','16:15:00',1.48),('14598','2013-07-06','16:20:00',1.51),('14598','2013-07-06','16:25:00',1.58),('14598','2013-07-06','16:30:00',1.57),('14598','2013-07-06','16:35:00',1.58),('14598','2013-07-06','16:40:00',1.66),('14598','2013-07-06','16:45:00',2.85),('14598','2013-07-06','16:50:00',3.85),('14598','2013-07-06','16:55:00',3.61),('14598','2013-07-06','17:00:00',2.86),('14598','2013-07-06','17:05:00',2.28),('14598','2013-07-06','17:10:00',1.7),('14598','2013-07-06','17:15:00',1.55),('14598','2013-07-06','17:20:00',1.44),('14598','2013-07-06','17:25:00',1.42),('14598','2013-07-06','17:30:00',1.04),('14598','2013-07-05','07:55:00',1),('14598','2013-07-05','08:00:00',1.08),('14598','2013-07-05','08:05:00',1.15),('14598','2013-07-05','08:10:00',1.23),('14598','2013-07-05','08:15:00',1.32),('14598','2013-07-05','08:20:00',1.41),('14598','2013-07-05','08:25:00',1.49),('14598','2013-07-05','08:30:00',1.57),('14598','2013-07-05','08:35:00',1.68),('14598','2013-07-05','08:40:00',1.76),('14598','2013-07-05','08:45:00',1.86),('14598','2013-07-05','08:50:00',1.97),('14598','2013-07-05','08:55:00',2.1),('14598','2013-07-05','09:00:00',2.18),('14598','2013-07-05','09:05:00',2.24),('14598','2013-07-05','09:10:00',2.31),('14598','2013-07-05','09:15:00',2.44),('14598','2013-07-05','09:20:00',2.56),('14598','2013-07-05','09:25:00',2.64),('14598','2013-07-05','09:30:00',2.73),('14598','2013-07-05','09:35:00',2.81),('14598','2013-07-05','09:40:00',2.88),('14598','2013-07-05','09:45:00',2.92),('14598','2013-07-05','09:50:00',2.99),('14598','2013-07-05','09:55:00',3.08),('14598','2013-07-05','10:00:00',3.13),('14598','2013-07-05','10:05:00',3.2),('14598','2013-07-05','10:10:00',3.25),('14598','2013-07-05','10:15:00',3.32),('14598','2013-07-05','10:20:00',3.38),('14598','2013-07-05','10:25:00',3.42),('14598','2013-07-05','10:30:00',3.52),('14598','2013-07-05','10:35:00',3.57),('14598','2013-07-05','10:40:00',3.61),('14598','2013-07-05','10:45:00',3.68),('14598','2013-07-05','10:50:00',3.76),('14598','2013-07-05','10:55:00',3.78),('14598','2013-07-05','11:00:00',3.84),('14598','2013-07-05','11:05:00',3.9),('14598','2013-07-05','11:10:00',3.97),('14598','2013-07-05','11:15:00',4.03),('14598','2013-07-05','11:20:00',4.05),('14598','2013-07-05','11:25:00',4.1),('14598','2013-07-05','11:30:00',4.16),('14598','2013-07-05','11:35:00',4.19),('14598','2013-07-05','11:40:00',4.22),('14598','2013-07-05','11:45:00',4.29),('14598','2013-07-05','11:50:00',4.32),('14598','2013-07-05','11:55:00',4.37),('14598','2013-07-05','12:00:00',4.38),('14598','2013-07-05','12:05:00',4.44),('14598','2013-07-05','12:10:00',4.41),('14598','2013-07-05','12:15:00',4.46),('14598','2013-07-05','12:20:00',4.5),('14598','2013-07-05','12:25:00',4.54),('14598','2013-07-05','12:30:00',4.54),('14598','2013-07-05','12:35:00',4.66),('14598','2013-07-05','12:40:00',4.7),('14598','2013-07-05','12:45:00',4.7),('14598','2013-07-05','12:50:00',4.76),('14598','2013-07-05','12:55:00',4.72),('14598','2013-07-05','13:00:00',4.81),('14598','2013-07-05','13:05:00',4.52),('14598','2013-07-05','13:10:00',4.74),('14598','2013-07-05','13:15:00',4.92),('14598','2013-07-05','13:20:00',4.95),('14598','2013-07-05','13:25:00',4.95),('14598','2013-07-05','13:30:00',4.94),('14598','2013-07-05','13:35:00',4.88),('14598','2013-07-05','13:40:00',4.67),('14598','2013-07-05','13:45:00',5.01),('14598','2013-07-05','13:50:00',5),('14598','2013-07-05','13:55:00',5.1),('14598','2013-07-05','14:00:00',5.05),('14598','2013-07-05','14:05:00',5.02),('14598','2013-07-05','14:10:00',4.84),('14598','2013-07-05','14:15:00',4.98),('14598','2013-07-05','14:20:00',4.52),('14598','2013-07-05','14:25:00',4.99),('14598','2013-07-05','14:30:00',5.05),('14598','2013-07-05','14:35:00',4.46),('14598','2013-07-05','14:40:00',4.53),('14598','2013-07-05','14:45:00',2.27),('14598','2013-07-05','14:50:00',2.97),('14598','2013-07-05','14:55:00',5.17),('14598','2013-07-05','15:00:00',4.88),('14598','2013-07-05','15:05:00',4.72),('14598','2013-07-05','15:10:00',4.76),('14598','2013-07-05','15:15:00',4.81),('14598','2013-07-05','15:20:00',4.15),('14598','2013-07-05','15:25:00',4.66),('14598','2013-07-05','15:30:00',4.69),('14598','2013-07-05','15:35:00',4.66),('14598','2013-07-05','15:40:00',4.59),('14598','2013-07-05','15:45:00',4.49),('14598','2013-07-05','15:50:00',4.46),('14598','2013-07-05','15:55:00',4.54),('14598','2013-07-05','16:00:00',3.96),('14598','2013-07-05','16:05:00',4.23),('14598','2013-07-05','16:10:00',4.2),('14598','2013-07-05','16:15:00',4.13),('14598','2013-07-05','16:20:00',4.04),('14598','2013-07-05','16:25:00',4.03),('14598','2013-07-05','16:30:00',3.94),('14598','2013-07-05','16:35:00',3.94),('14598','2013-07-05','16:40:00',4.01),('14598','2013-07-05','16:45:00',3.92),('14598','2013-07-05','16:50:00',3.82),('14598','2013-07-05','16:55:00',3.79),('14598','2013-07-05','17:00:00',3.66),('14598','2013-07-05','17:05:00',3.55),('14598','2013-07-05','17:10:00',3.5),('14598','2013-07-05','17:15:00',3.37),('14598','2013-07-05','17:20:00',2.13),('14598','2013-07-05','17:25:00',3.13),('14598','2013-07-05','17:30:00',2.97),('14598','2013-07-05','17:35:00',2.91),('14598','2013-07-05','17:40:00',2.87),('14598','2013-07-05','17:45:00',2.81),('14598','2013-07-05','17:50:00',2.54),('14598','2013-07-05','17:55:00',2.49),('14598','2013-07-05','18:00:00',1.56),('14598','2013-07-05','18:05:00',2.29),('14598','2013-07-05','18:10:00',2.33),('14598','2013-07-05','18:15:00',2.32),('14598','2013-07-05','18:20:00',2.28),('14598','2013-07-05','18:25:00',2.14),('14598','2013-07-05','18:30:00',1.92),('14598','2013-07-05','18:35:00',1.86),('14598','2013-07-05','18:40:00',1.75),('14598','2013-07-05','18:45:00',1.64),('14598','2013-07-05','18:50:00',1.53),('14598','2013-07-05','18:55:00',1.47),('14598','2013-07-05','19:00:00',1.43),('14598','2013-07-05','19:05:00',1.31),('14598','2013-07-05','19:10:00',1.24),('14598','2013-07-05','19:15:00',1.15),('14598','2013-07-04','10:30:00',1.2),('14598','2013-07-04','10:35:00',1.31),('14598','2013-07-04','10:40:00',1.49),('14598','2013-07-04','10:45:00',1.66),('14598','2013-07-04','10:50:00',1.57),('14598','2013-07-04','10:55:00',1.49),('14598','2013-07-04','11:00:00',1.41),('14598','2013-07-04','11:05:00',1.41),('14598','2013-07-04','11:10:00',1.54),('14598','2013-07-04','11:15:00',1.78),('14598','2013-07-04','11:20:00',2.04),('14598','2013-07-04','11:25:00',2.3),('14598','2013-07-04','11:30:00',2.4),('14598','2013-07-04','11:35:00',2.03),('14598','2013-07-04','11:40:00',1.92),('14598','2013-07-04','11:45:00',2.1),('14598','2013-07-04','11:50:00',2.4),('14598','2013-07-04','11:55:00',2.42),('14598','2013-07-04','12:00:00',2.46),('14598','2013-07-04','12:05:00',2.55),('14598','2013-07-04','12:10:00',2.57),('14598','2013-07-04','12:15:00',2.54),('14598','2013-07-04','12:20:00',2.48),('14598','2013-07-04','12:25:00',2.33),('14598','2013-07-04','12:30:00',2.32),('14598','2013-07-04','12:35:00',2.39),('14598','2013-07-04','12:40:00',4.03),('14598','2013-07-04','12:45:00',4.77),('14598','2013-07-04','12:50:00',3.38),('14598','2013-07-04','12:55:00',4.79),('14598','2013-07-04','13:00:00',4.42),('14598','2013-07-04','13:05:00',4.06),('14598','2013-07-04','13:10:00',4.28),('14598','2013-07-04','13:15:00',4.26),('14598','2013-07-04','13:20:00',4.62),('14598','2013-07-04','13:25:00',3.25),('14598','2013-07-04','13:30:00',2.64),('14598','2013-07-04','13:35:00',4.05),('14598','2013-07-04','13:40:00',5.45),('14598','2013-07-04','13:45:00',4.18),('14598','2013-07-04','13:50:00',3.01),('14598','2013-07-04','13:55:00',4.24),('14598','2013-07-04','14:00:00',5.15),('14598','2013-07-04','14:05:00',5.18),('14598','2013-07-04','14:10:00',3.92),('14598','2013-07-04','14:15:00',5.18),('14598','2013-07-04','14:20:00',5.4),('14598','2013-07-04','14:25:00',5.26),('14598','2013-07-04','14:30:00',5.16),('14598','2013-07-04','14:35:00',5.14),('14598','2013-07-04','14:40:00',5.2),('14598','2013-07-04','14:45:00',5.23),('14598','2013-07-04','14:50:00',5.15),('14598','2013-07-04','14:55:00',5.3),('14598','2013-07-04','15:00:00',4.57),('14598','2013-07-04','15:05:00',5.28),('14598','2013-07-04','15:10:00',5.07),('14598','2013-07-04','15:15:00',4.09),('14598','2013-07-04','15:20:00',3.48),('14598','2013-07-04','15:25:00',3.45),('14598','2013-07-04','15:30:00',2.24),('14598','2013-07-04','15:35:00',3.79),('14598','2013-07-04','15:40:00',2.9),('14598','2013-07-04','15:45:00',2.96),('14598','2013-07-04','15:50:00',3.1),('14598','2013-07-04','15:55:00',2.65),('14598','2013-07-04','16:00:00',2.43),('14598','2013-07-04','16:05:00',2.22),('14598','2013-07-04','16:10:00',2.15),('14598','2013-07-04','16:15:00',2.25),('14598','2013-07-04','16:20:00',2.73),('14598','2013-07-04','16:25:00',3.71),('14598','2013-07-04','16:30:00',2.49),('14598','2013-07-04','16:35:00',2.4),('14598','2013-07-04','16:40:00',2.15),('14598','2013-07-04','16:45:00',1.89),('14598','2013-07-04','16:50:00',1.64),('14598','2013-07-04','16:55:00',2.04),('14598','2013-07-04','17:00:00',2.31),('14598','2013-07-04','17:05:00',2.2),('14598','2013-07-04','17:10:00',1.45),('14598','2013-07-04','17:15:00',1.28),('14598','2013-07-04','17:20:00',1.39),('14598','2013-07-04','17:25:00',1.59),('14598','2013-07-04','17:30:00',2.52),('14598','2013-07-04','17:35:00',2.54),('14598','2013-07-04','17:40:00',1.64),('14598','2013-07-04','17:45:00',1.75),('14598','2013-07-04','17:50:00',1.57),('14598','2013-07-04','17:55:00',1.79),('14598','2013-07-04','18:00:00',2.69),('14598','2013-07-04','18:05:00',2.27),('14598','2013-07-04','18:10:00',1.45),('14598','2013-07-04','18:15:00',1),('14598','2013-07-04','18:20:00',1.21),('14598','2013-07-04','18:25:00',1.42),('14598','2013-07-04','18:35:00',1.34),('14598','2013-07-04','18:40:00',1),('14598','2013-07-03','07:55:00',1.03),('14598','2013-07-03','08:00:00',1.11),('14598','2013-07-03','08:05:00',1.2),('14598','2013-07-03','08:10:00',1.28),('14598','2013-07-03','08:15:00',1.36),('14598','2013-07-03','08:20:00',1.45),('14598','2013-07-03','08:25:00',1.53),('14598','2013-07-03','08:30:00',1.63),('14598','2013-07-03','08:35:00',1.76),('14598','2013-07-03','08:40:00',1.84),('14598','2013-07-03','08:45:00',1.92),('14598','2013-07-03','08:50:00',2.04),('14598','2013-07-03','08:55:00',2.12),('14598','2013-07-03','09:00:00',2.15),('14598','2013-07-03','09:05:00',2.17),('14598','2013-07-03','09:10:00',2.33),('14598','2013-07-03','09:15:00',2.57),('14598','2013-07-03','09:20:00',2.6),('14598','2013-07-03','09:25:00',2.74),('14598','2013-07-03','09:30:00',2.84),('14598','2013-07-03','09:35:00',2.93),('14598','2013-07-03','09:40:00',2.95),('14598','2013-07-03','09:45:00',3.11),('14598','2013-07-03','09:50:00',3.19),('14598','2013-07-03','09:55:00',3.28),('14598','2013-07-03','10:00:00',3.36),('14598','2013-07-03','10:05:00',3.44),('14598','2013-07-03','10:10:00',3.51),('14598','2013-07-03','10:15:00',3.58),('14598','2013-07-03','10:20:00',3.67),('14598','2013-07-03','10:25:00',3.73),('14598','2013-07-03','10:30:00',3.8),('14598','2013-07-03','10:35:00',3.88),('14598','2013-07-03','10:40:00',3.95),('14598','2013-07-03','10:45:00',4.01),('14598','2013-07-03','10:50:00',4.07),('14598','2013-07-03','10:55:00',4.07),('14598','2013-07-03','11:00:00',4.19),('14598','2013-07-03','11:05:00',4.25),('14598','2013-07-03','11:10:00',4.3),('14598','2013-07-03','11:15:00',4.36),('14598','2013-07-03','11:20:00',4.41),('14598','2013-07-03','11:25:00',4.45),('14598','2013-07-03','11:30:00',4.5),('14598','2013-07-03','11:35:00',4.57),('14598','2013-07-03','11:40:00',4.63),('14598','2013-07-03','11:45:00',4.66),('14598','2013-07-03','11:50:00',4.69),('14598','2013-07-03','11:55:00',4.74),('14598','2013-07-03','12:00:00',4.76),('14598','2013-07-03','12:05:00',4.81),('14598','2013-07-03','12:10:00',4.86),('14598','2013-07-03','12:15:00',4.86),('14598','2013-07-03','12:20:00',4.89),('14598','2013-07-03','12:25:00',4.92),('14598','2013-07-03','12:30:00',4.95),('14598','2013-07-03','12:35:00',4.96),('14598','2013-07-03','12:40:00',4.99),('14598','2013-07-03','12:45:00',5.03),('14598','2013-07-03','12:50:00',5.05),('14598','2013-07-03','12:55:00',5.08),('14598','2013-07-03','13:00:00',5.09),('14598','2013-07-03','13:05:00',5.11),('14598','2013-07-03','13:10:00',5.11),('14598','2013-07-03','13:15:00',5.11),('14598','2013-07-03','13:20:00',5.13),('14598','2013-07-03','13:25:00',5.12),('14598','2013-07-03','13:30:00',5.14),('14598','2013-07-03','13:35:00',5.14),('14598','2013-07-03','13:40:00',5.13),('14598','2013-07-03','13:45:00',5.16),('14598','2013-07-03','13:50:00',5.15),('14598','2013-07-03','13:55:00',5.1),('14598','2013-07-03','14:00:00',5.15),('14598','2013-07-03','14:05:00',5.16),('14598','2013-07-03','14:10:00',5.14),('14598','2013-07-03','14:15:00',5.13),('14598','2013-07-03','14:20:00',5.13),('14598','2013-07-03','14:25:00',5.12),('14598','2013-07-03','14:30:00',5.1),('14598','2013-07-03','14:35:00',5.09),('14598','2013-07-03','14:40:00',5.08),('14598','2013-07-03','14:45:00',5.04),('14598','2013-07-03','14:50:00',5.02),('14598','2013-07-03','14:55:00',4.96),('14598','2013-07-03','15:00:00',4.96),('14598','2013-07-03','15:05:00',4.97),('14598','2013-07-03','15:10:00',4.92),('14598','2013-07-03','15:15:00',4.88),('14598','2013-07-03','15:20:00',4.85),('14598','2013-07-03','15:25:00',4.8),('14598','2013-07-03','15:30:00',4.79),('14598','2013-07-03','15:35:00',4.76),('14598','2013-07-03','15:40:00',4.69),('14598','2013-07-03','15:45:00',4.68),('14598','2013-07-03','15:50:00',4.64),('14598','2013-07-03','15:55:00',4.58),('14598','2013-07-03','16:00:00',4.54),('14598','2013-07-03','16:05:00',4.5),('14598','2013-07-03','16:10:00',4.44),('14598','2013-07-03','16:15:00',4.39),('14598','2013-07-03','16:20:00',4.34),('14598','2013-07-03','16:25:00',4.27),('14598','2013-07-03','16:30:00',4.2),('14598','2013-07-03','16:35:00',4.16),('14598','2013-07-03','16:40:00',4.09),('14598','2013-07-03','16:45:00',4.02),('14598','2013-07-03','16:50:00',3.96),('14598','2013-07-03','16:55:00',3.88),('14598','2013-07-03','17:00:00',3.84),('14598','2013-07-03','17:05:00',3.76),('14598','2013-07-03','17:10:00',3.68),('14598','2013-07-03','17:15:00',3.62),('14598','2013-07-03','17:20:00',3.55),('14598','2013-07-03','17:25:00',3.46),('14598','2013-07-03','17:30:00',3.39),('14598','2013-07-03','17:35:00',3.31),('14598','2013-07-03','17:40:00',3.22),('14598','2013-07-03','17:45:00',3.13),('14598','2013-07-03','17:50:00',3.05),('14598','2013-07-03','17:55:00',2.96),('14598','2013-07-03','18:00:00',2.86),('14598','2013-07-03','18:05:00',2.77),('14598','2013-07-03','18:10:00',2.67),('14598','2013-07-03','18:15:00',2.57),('14598','2013-07-03','18:20:00',2.47),('14598','2013-07-03','18:25:00',2.38),('14598','2013-07-03','18:30:00',2.27),('14598','2013-07-03','18:35:00',2.17),('14598','2013-07-03','18:40:00',2.05),('14598','2013-07-03','18:45:00',1.9),('14598','2013-07-03','18:50:00',1.83),('14598','2013-07-03','18:55:00',1.73),('14598','2013-07-03','19:00:00',1.63),('14598','2013-07-03','19:05:00',1.53),('14598','2013-07-03','19:10:00',1.42),('14598','2013-07-03','19:15:00',1.32),('14598','2013-07-03','19:20:00',1.24),('14598','2013-07-03','19:25:00',1.14),('14598','2013-07-03','19:30:00',1.03),('14598','2013-07-02','07:55:00',1.01),('14598','2013-07-02','08:00:00',1.09),('14598','2013-07-02','08:05:00',1.17),('14598','2013-07-02','08:10:00',1.26),('14598','2013-07-02','08:15:00',1.34),('14598','2013-07-02','08:20:00',1.43),('14598','2013-07-02','08:25:00',1.52),('14598','2013-07-02','08:30:00',1.61),('14598','2013-07-02','08:35:00',1.72),('14598','2013-07-02','08:40:00',1.8),('14598','2013-07-02','08:45:00',1.88),('14598','2013-07-02','08:50:00',2.01),('14598','2013-07-02','08:55:00',2.12),('14598','2013-07-02','09:00:00',2.22),('14598','2013-07-02','09:05:00',2.3),('14598','2013-07-02','09:10:00',2.39),('14598','2013-07-02','09:15:00',2.47),('14598','2013-07-02','09:20:00',2.58),('14598','2013-07-02','09:25:00',2.67),('14598','2013-07-02','09:30:00',2.76),('14598','2013-07-02','09:35:00',2.83),('14598','2013-07-02','09:40:00',2.89),('14598','2013-07-02','09:45:00',2.96),('14598','2013-07-02','09:50:00',3.01),('14598','2013-07-02','09:55:00',3.07),('14598','2013-07-02','10:00:00',3.14),('14598','2013-07-02','10:05:00',3.25),('14598','2013-07-02','10:10:00',3.35),('14598','2013-07-02','10:15:00',3.43),('14598','2013-07-02','10:20:00',3.52),('14598','2013-07-02','10:25:00',3.59),('14598','2013-07-02','10:30:00',3.67),('14598','2013-07-02','10:35:00',3.76),('14598','2013-07-02','10:40:00',3.81),('14598','2013-07-02','10:45:00',3.88),('14598','2013-07-02','10:50:00',3.94),('14598','2013-07-02','10:55:00',3.95),('14598','2013-07-02','11:00:00',4.05),('14598','2013-07-02','11:05:00',4.12),('14598','2013-07-02','11:10:00',4.18),('14598','2013-07-02','11:15:00',4.22),('14598','2013-07-02','11:20:00',4.29),('14598','2013-07-02','11:25:00',4.34),('14598','2013-07-02','11:30:00',4.41),('14598','2013-07-02','11:35:00',4.48),('14598','2013-07-02','11:40:00',4.54),('14598','2013-07-02','11:45:00',4.57),('14598','2013-07-02','11:50:00',4.62),('14598','2013-07-02','11:55:00',4.66),('14598','2013-07-02','12:00:00',4.71),('14598','2013-07-02','12:05:00',4.73),('14598','2013-07-02','12:10:00',4.73),('14598','2013-07-02','12:15:00',4.8),('14598','2013-07-02','12:20:00',4.83),('14598','2013-07-02','12:25:00',4.87),('14598','2013-07-02','12:30:00',4.91),('14598','2013-07-02','12:35:00',4.93),('14598','2013-07-02','12:40:00',4.95),('14598','2013-07-02','12:45:00',5),('14598','2013-07-02','12:50:00',5),('14598','2013-07-02','12:55:00',5.02),('14598','2013-07-02','13:00:00',5.05),('14598','2013-07-02','13:05:00',5.05),('14598','2013-07-02','13:10:00',5.09),('14598','2013-07-02','13:15:00',5.08),('14598','2013-07-02','13:20:00',5.08),('14598','2013-07-02','13:25:00',5.09),('14598','2013-07-02','13:30:00',5.1),('14598','2013-07-02','13:35:00',5.09),('14598','2013-07-02','13:40:00',5.1),('14598','2013-07-02','13:45:00',5.11),('14598','2013-07-02','13:50:00',5.1),('14598','2013-07-02','13:55:00',5.02),('14598','2013-07-02','14:00:00',5.1),('14598','2013-07-02','14:05:00',5.1),('14598','2013-07-02','14:10:00',5.1),('14598','2013-07-02','14:15:00',5.1),('14598','2013-07-02','14:20:00',5.09),('14598','2013-07-02','14:25:00',5.08),('14598','2013-07-02','14:30:00',5.06),('14598','2013-07-02','14:35:00',5.05),('14598','2013-07-02','14:40:00',5.03),('14598','2013-07-02','14:45:00',4.99),('14598','2013-07-02','14:50:00',4.97),('14598','2013-07-02','14:55:00',4.94),('14598','2013-07-02','15:00:00',4.92),('14598','2013-07-02','15:05:00',4.88),('14598','2013-07-02','15:10:00',4.86),('14598','2013-07-02','15:15:00',4.85),('14598','2013-07-02','15:20:00',4.81),('14598','2013-07-02','15:25:00',4.75),('14598','2013-07-02','15:30:00',4.71),('14598','2013-07-02','15:35:00',4.67),('14598','2013-07-02','15:40:00',4.62),('14598','2013-07-02','15:45:00',4.59),('14598','2013-07-02','15:50:00',4.55),('14598','2013-07-02','15:55:00',4.5),('14598','2013-07-02','16:00:00',4.44),('14598','2013-07-02','16:05:00',4.39),('14598','2013-07-02','16:10:00',4.34),('14598','2013-07-02','16:15:00',4.29),('14598','2013-07-02','16:20:00',4.22),('14598','2013-07-02','16:25:00',4.15),('14598','2013-07-02','16:30:00',4.09),('14598','2013-07-02','16:35:00',4.03),('14598','2013-07-02','16:40:00',3.97),('14598','2013-07-02','16:45:00',3.91),('14598','2013-07-02','16:50:00',3.84),('14598','2013-07-02','16:55:00',3.72),('14598','2013-07-02','17:00:00',3.72),('14598','2013-07-02','17:05:00',3.65),('14598','2013-07-02','17:10:00',3.57),('14598','2013-07-02','17:15:00',3.5),('14598','2013-07-02','17:20:00',3.42),('14598','2013-07-02','17:25:00',3.35),('14598','2013-07-02','17:30:00',3.26),('14598','2013-07-02','17:35:00',3.17),('14598','2013-07-02','17:40:00',3.09),('14598','2013-07-02','17:45:00',3),('14598','2013-07-02','17:50:00',2.9),('14598','2013-07-02','17:55:00',2.81),('14598','2013-07-02','18:00:00',2.73),('14598','2013-07-02','18:05:00',2.63),('14598','2013-07-02','18:10:00',2.54),('14598','2013-07-02','18:15:00',2.46),('14598','2013-07-02','18:20:00',2.37),('14598','2013-07-02','18:25:00',2.26),('14598','2013-07-02','18:30:00',2.16),('14598','2013-07-02','18:35:00',2.05),('14598','2013-07-02','18:40:00',1.96),('14598','2013-07-02','18:45:00',1.87),('14598','2013-07-02','18:50:00',1.77),('14598','2013-07-02','18:55:00',1.67),('14598','2013-07-02','19:00:00',1.57),('14598','2013-07-02','19:05:00',1.47),('14598','2013-07-02','19:10:00',1.37),('14598','2013-07-02','19:15:00',1.27),('14598','2013-07-02','19:20:00',1.16),('14598','2013-07-02','19:25:00',1.04),('14598','2013-07-01','07:55:00',1.05),('14598','2013-07-01','08:00:00',1.13),('14598','2013-07-01','08:05:00',1.21),('14598','2013-07-01','08:10:00',1.29),('14598','2013-07-01','08:15:00',1.37),('14598','2013-07-01','08:20:00',1.47),('14598','2013-07-01','08:25:00',1.56),('14598','2013-07-01','08:30:00',1.65),('14598','2013-07-01','08:35:00',1.76),('14598','2013-07-01','08:40:00',1.84),('14598','2013-07-01','08:45:00',1.96),('14598','2013-07-01','08:50:00',2.09),('14598','2013-07-01','08:55:00',2.19),('14598','2013-07-01','09:00:00',2.25),('14598','2013-07-01','09:05:00',2.32),('14598','2013-07-01','09:10:00',2.44),('14598','2013-07-01','09:15:00',2.54),('14598','2013-07-01','09:20:00',2.65),('14598','2013-07-01','09:25:00',2.74),('14598','2013-07-01','09:30:00',2.81),('14598','2013-07-01','09:35:00',2.89),('14598','2013-07-01','09:40:00',2.97),('14598','2013-07-01','09:45:00',3.03),('14598','2013-07-01','09:50:00',3.11),('14598','2013-07-01','09:55:00',3.14),('14598','2013-07-01','10:00:00',3.25),('14598','2013-07-01','10:05:00',3.32),('14598','2013-07-01','10:10:00',3.39),('14598','2013-07-01','10:15:00',3.46),('14598','2013-07-01','10:20:00',3.52),('14598','2013-07-01','10:25:00',3.59),('14598','2013-07-01','10:30:00',3.64),('14598','2013-07-01','10:35:00',3.73),('14598','2013-07-01','10:40:00',3.84),('14598','2013-07-01','10:45:00',3.92),('14598','2013-07-01','10:50:00',4),('14598','2013-07-01','10:55:00',4.08),('14598','2013-07-01','11:00:00',4.14),('14598','2013-07-01','11:05:00',4.21),('14598','2013-07-01','11:10:00',4.23),('14598','2013-07-01','11:15:00',4.28),('14598','2013-07-01','11:20:00',4.35),('14598','2013-07-01','11:25:00',4.41),('14598','2013-07-01','11:30:00',4.47),('14598','2013-07-01','11:35:00',4.52),('14598','2013-07-01','11:40:00',4.52),('14598','2013-07-01','11:45:00',4.58),('14598','2013-07-01','11:50:00',4.63),('14598','2013-07-01','11:55:00',4.65),('14598','2013-07-01','12:00:00',4.69),('14598','2013-07-01','12:05:00',4.72),('14598','2013-07-01','12:10:00',4.77),('14598','2013-07-01','12:15:00',4.81),('14598','2013-07-01','12:20:00',4.85),('14598','2013-07-01','12:25:00',4.89),('14598','2013-07-01','12:30:00',4.91),('14598','2013-07-01','12:35:00',4.94),('14598','2013-07-01','12:40:00',4.98),('14598','2013-07-01','12:45:00',4.97),('14598','2013-07-01','12:50:00',5.01),('14598','2013-07-01','12:55:00',4.95),('14598','2013-07-01','13:00:00',5.05),('14598','2013-07-01','13:05:00',5.08),('14598','2013-07-01','13:10:00',5.1),('14598','2013-07-01','13:15:00',5.11),('14598','2013-07-01','13:20:00',5.12),('14598','2013-07-01','13:25:00',5.12),('14598','2013-07-01','13:30:00',5.12),('14598','2013-07-01','13:35:00',5.11),('14598','2013-07-01','13:40:00',5.14),('14598','2013-07-01','13:45:00',5.18),('14598','2013-07-01','13:50:00',5.16),('14598','2013-07-01','13:55:00',5.13),('14598','2013-07-01','14:00:00',5.01),('14598','2013-07-01','14:05:00',5.13),('14598','2013-07-01','14:10:00',5.11),('14598','2013-07-01','14:15:00',5.09),('14598','2013-07-01','14:20:00',5.11),('14598','2013-07-01','14:25:00',5.06),('14598','2013-07-01','14:30:00',5.07),('14598','2013-07-01','14:35:00',5.05),('14598','2013-07-01','14:40:00',4.97),('14598','2013-07-01','14:45:00',4.96),('14598','2013-07-01','14:50:00',4.95),('14598','2013-07-01','14:55:00',4.95),('14598','2013-07-01','15:00:00',4.88),('14598','2013-07-01','15:05:00',4.87),('14598','2013-07-01','15:10:00',4.83),('14598','2013-07-01','15:15:00',4.77),('14598','2013-07-01','15:20:00',4.76),('14598','2013-07-01','15:25:00',4.72),('14598','2013-07-01','15:30:00',4.7),('14598','2013-07-01','15:35:00',4.65),('14598','2013-07-01','15:40:00',4.58),('14598','2013-07-01','15:45:00',4.58),('14598','2013-07-01','15:50:00',4.48),('14598','2013-07-01','15:55:00',4.39),('14598','2013-07-01','16:00:00',4.45),('14598','2013-07-01','16:05:00',4.36),('14598','2013-07-01','16:10:00',4.32),('14598','2013-07-01','16:15:00',4.26),('14598','2013-07-01','16:20:00',4.19),('14598','2013-07-01','16:25:00',4.13),('14598','2013-07-01','16:30:00',4.07),('14598','2013-07-01','16:35:00',4.01),('14598','2013-07-01','16:40:00',3.95),('14598','2013-07-01','16:45:00',3.88),('14598','2013-07-01','16:50:00',3.81),('14598','2013-07-01','16:55:00',3.74),('14598','2013-07-01','17:00:00',3.66),('14598','2013-07-01','17:05:00',3.6),('14598','2013-07-01','17:10:00',3.52),('14598','2013-07-01','17:15:00',3.43),('14598','2013-07-01','17:20:00',3.35),('14598','2013-07-01','17:25:00',3.27),('14598','2013-07-01','17:30:00',3.18),('14598','2013-07-01','17:35:00',3.09),('14598','2013-07-01','17:40:00',3.01),('14598','2013-07-01','17:45:00',2.91),('14598','2013-07-01','17:50:00',2.86),('14598','2013-07-01','17:55:00',2.72),('14598','2013-07-01','18:00:00',2.53),('14598','2013-07-01','18:05:00',2.53),('14598','2013-07-01','18:10:00',2.54),('14598','2013-07-01','18:15:00',2.43),('14598','2013-07-01','18:20:00',2.19),('14598','2013-07-01','18:25:00',1.96),('14598','2013-07-01','18:30:00',2.06),('14598','2013-07-01','18:35:00',1.84),('14598','2013-07-01','18:40:00',1.82),('14598','2013-07-01','18:45:00',1.71),('14598','2013-07-01','18:50:00',1.67),('14598','2013-07-01','18:55:00',1.43),('14598','2013-07-01','19:00:00',1.38),('14598','2013-07-01','19:05:00',1.34),('14598','2013-07-01','19:10:00',1.03),('14598','2013-07-01','19:20:00',1.02),('14598','2014-04-05','08:55:00',1.07),('14598','2014-04-05','09:00:00',1.12),('14598','2014-04-05','09:05:00',1.44),('14598','2014-04-05','09:10:00',1.78),('14598','2014-04-05','09:15:00',1.95),('14598','2014-04-05','09:20:00',2.21),('14598','2014-04-05','09:25:00',2.22),('14598','2014-04-05','09:30:00',2.05),('14598','2014-04-05','09:35:00',1.93),('14598','2014-04-05','09:40:00',2.07),('14598','2014-04-05','09:45:00',2.23),('14598','2014-04-05','09:50:00',3.16),('14598','2014-04-05','09:55:00',3.05),('14598','2014-04-05','10:00:00',3.06),('14598','2014-04-05','10:05:00',3.32),('14598','2014-04-05','10:10:00',4.18),('14598','2014-04-05','10:15:00',3.33),('14598','2014-04-05','10:20:00',4.07),('14598','2014-04-05','10:25:00',2.92),('14598','2014-04-05','10:30:00',2.33),('14598','2014-04-05','10:35:00',2.37),('14598','2014-04-05','10:40:00',2.51),('14598','2014-04-05','10:45:00',2.65),('14598','2014-04-05','10:50:00',2.84),('14598','2014-04-05','10:55:00',2.78),('14598','2014-04-05','11:00:00',4.57),('14598','2014-04-05','11:05:00',4.46),('14598','2014-04-05','11:10:00',4.44),('14598','2014-04-05','11:15:00',4.35),('14598','2014-04-05','11:20:00',4.42),('14598','2014-04-05','11:25:00',4.52),('14598','2014-04-05','11:30:00',3.54),('14598','2014-04-05','11:35:00',3.93),('14598','2014-04-05','11:40:00',4.11),('14598','2014-04-05','11:45:00',3.75),('14598','2014-04-05','11:50:00',4),('14598','2014-04-05','11:55:00',3.36),('14598','2014-04-05','12:00:00',3.58),('14598','2014-04-05','12:05:00',4.02),('14598','2014-04-05','12:10:00',4.13),('14598','2014-04-05','12:15:00',3.7),('14598','2014-04-05','12:20:00',3.21),('14598','2014-04-05','12:25:00',3.21),('14598','2014-04-05','12:30:00',3),('14598','2014-04-05','12:35:00',2.87),('14598','2014-04-05','12:40:00',3.57),('14598','2014-04-05','12:45:00',3.52),('14598','2014-04-05','12:50:00',3.28),('14598','2014-04-05','12:55:00',3.21),('14598','2014-04-05','13:00:00',2.99),('14598','2014-04-05','13:05:00',3),('14598','2014-04-05','13:10:00',2.57),('14598','2014-04-05','13:15:00',2.55),('14598','2014-04-05','13:20:00',2.95),('14598','2014-04-05','13:25:00',3.66),('14598','2014-04-05','13:30:00',4.24),('14598','2014-04-05','13:35:00',4.58),('14598','2014-04-05','13:40:00',4.7),('14598','2014-04-05','13:45:00',4.65),('14598','2014-04-05','13:50:00',5.14),('14598','2014-04-05','13:55:00',5.18),('14598','2014-04-05','14:00:00',5.34),('14598','2014-04-05','14:05:00',5.35),('14598','2014-04-05','14:10:00',5.38),('14598','2014-04-05','14:15:00',4.92),('14598','2014-04-05','14:20:00',3.99),('14598','2014-04-05','14:25:00',2.99),('14598','2014-04-05','14:30:00',1.59),('14598','2014-04-05','14:35:00',1.66),('14598','2014-04-05','14:40:00',1.32),('14598','2014-04-05','14:45:00',3.37),('14598','2014-04-05','14:50:00',3.8),('14598','2014-04-05','14:55:00',4.17),('14598','2014-04-05','15:00:00',4.51),('14598','2014-04-05','15:05:00',1.99),('14598','2014-04-05','15:10:00',1.58),('14598','2014-04-05','15:15:00',1.97),('14598','2014-04-05','15:20:00',3.02),('14598','2014-04-05','15:25:00',3.01),('14598','2014-04-05','15:30:00',3.62),('14598','2014-04-05','15:35:00',1.89),('14598','2014-04-05','15:40:00',1.29),('14598','2014-04-05','15:45:00',1.41),('14598','2014-04-05','15:50:00',3.49),('14598','2014-04-05','15:55:00',3.77),('14598','2014-04-05','16:00:00',4.24),('14598','2014-04-05','16:05:00',4.67),('14598','2014-04-05','16:10:00',4.73),('14598','2014-04-05','16:15:00',2.45),('14598','2014-04-05','16:20:00',2.17),('14598','2014-04-05','16:25:00',2.38),('14598','2014-04-05','16:30:00',1.58),('14598','2014-04-05','17:00:00',1.04),('14598','2014-04-05','17:05:00',1.39),('14598','2014-04-05','17:10:00',1.07),('14598','2014-04-05','17:15:00',2.77),('14598','2014-04-05','17:20:00',2),('14598','2013-06-30','07:55:00',1.06),('14598','2013-06-30','08:00:00',1.14),('14598','2013-06-30','08:05:00',1.23),('14598','2013-06-30','08:10:00',1.33),('14598','2013-06-30','08:15:00',1.42),('14598','2013-06-30','08:20:00',1.52),('14598','2013-06-30','08:25:00',1.61),('14598','2013-06-30','08:30:00',1.69),('14598','2013-06-30','08:35:00',1.81),('14598','2013-06-30','08:40:00',1.89),('14598','2013-06-30','08:45:00',1.99),('14598','2013-06-30','08:50:00',2.12),('14598','2013-06-30','08:55:00',2.23),('14598','2013-06-30','09:00:00',2.33),('14598','2013-06-30','09:05:00',2.42),('14598','2013-06-30','09:10:00',2.51),('14598','2013-06-30','09:15:00',2.6),('14598','2013-06-30','09:20:00',2.66),('14598','2013-06-30','09:25:00',2.82),('14598','2013-06-30','09:30:00',2.91),('14598','2013-06-30','09:35:00',3),('14598','2013-06-30','09:40:00',3.07),('14598','2013-06-30','09:45:00',3.16),('14598','2013-06-30','09:50:00',3.23),('14598','2013-06-30','09:55:00',3.31),('14598','2013-06-30','10:00:00',3.38),('14598','2013-06-30','10:05:00',3.45),('14598','2013-06-30','10:10:00',3.52),('14598','2013-06-30','10:15:00',3.57),('14598','2013-06-30','10:20:00',3.64),('14598','2013-06-30','10:25:00',3.69),('14598','2013-06-30','10:30:00',3.77),('14598','2013-06-30','10:35:00',3.83),('14598','2013-06-30','10:40:00',3.85),('14598','2013-06-30','10:45:00',3.95),('14598','2013-06-30','10:50:00',4.05),('14598','2013-06-30','10:55:00',4.12),('14598','2013-06-30','11:00:00',4.21),('14598','2013-06-30','11:05:00',4.27),('14598','2013-06-30','11:10:00',4.29),('14598','2013-06-30','11:15:00',4.35),('14598','2013-06-30','11:20:00',4.44),('14598','2013-06-30','11:25:00',4.46),('14598','2013-06-30','11:30:00',4.51),('14598','2013-06-30','11:35:00',4.57),('14598','2013-06-30','11:40:00',4.59),('14598','2013-06-30','11:45:00',4.66),('14598','2013-06-30','11:50:00',4.71),('14598','2013-06-30','11:55:00',4.8),('14598','2013-06-30','12:00:00',4.82),('14598','2013-06-30','12:05:00',4.86),('14598','2013-06-30','12:10:00',4.88),('14598','2013-06-30','12:15:00',4.9),('14598','2013-06-30','12:20:00',4.91),('14598','2013-06-30','12:25:00',4.86),('14598','2013-06-30','12:30:00',4.91),('14598','2013-06-30','12:35:00',4.97),('14598','2013-06-30','12:40:00',4.99),('14598','2013-06-30','12:45:00',5.03),('14598','2013-06-30','12:50:00',5.08),('14598','2013-06-30','12:55:00',5.13),('14598','2013-06-30','13:00:00',5.13),('14598','2013-06-30','13:05:00',5.14),('14598','2013-06-30','13:10:00',5.12),('14598','2013-06-30','13:15:00',5.12),('14598','2013-06-30','13:20:00',5.17),('14598','2013-06-30','13:25:00',5.17),('14598','2013-06-30','13:30:00',5.16),('14598','2013-06-30','13:35:00',5.16),('14598','2013-06-30','13:40:00',5.15),('14598','2013-06-30','13:45:00',5.16),('14598','2013-06-30','13:50:00',5.15),('14598','2013-06-30','13:55:00',5.18),('14598','2013-06-30','14:00:00',5.18),('14598','2013-06-30','14:05:00',5.17),('14598','2013-06-30','14:10:00',5.16),('14598','2013-06-30','14:15:00',5.09),('14598','2013-06-30','14:20:00',5.06),('14598','2013-06-30','14:25:00',5.07),('14598','2013-06-30','14:30:00',5.08),('14598','2013-06-30','14:35:00',5.09),('14598','2013-06-30','14:40:00',5.07),('14598','2013-06-30','14:45:00',5.05),('14598','2013-06-30','14:50:00',5),('14598','2013-06-30','14:55:00',4.99),('14598','2013-06-30','15:00:00',4.96),('14598','2013-06-30','15:05:00',4.93),('14598','2013-06-30','15:10:00',4.89),('14598','2013-06-30','15:15:00',4.86),('14598','2013-06-30','15:20:00',4.82),('14598','2013-06-30','15:25:00',4.77),('14598','2013-06-30','15:30:00',4.73),('14598','2013-06-30','15:35:00',4.7),('14598','2013-06-30','15:40:00',4.66),('14598','2013-06-30','15:45:00',4.63),('14598','2013-06-30','15:50:00',4.59),('14598','2013-06-30','15:55:00',4.56),('14598','2013-06-30','16:00:00',4.5),('14598','2013-06-30','16:05:00',4.44),('14598','2013-06-30','16:10:00',4.41),('14598','2013-06-30','16:15:00',4.32),('14598','2013-06-30','16:20:00',4.34),('14598','2013-06-30','16:25:00',4.31),('14598','2013-06-30','16:30:00',4.2),('14598','2013-06-30','16:35:00',4.12),('14598','2013-06-30','16:40:00',4.05),('14598','2013-06-30','16:45:00',3.96),('14598','2013-06-30','16:50:00',3.91),('14598','2013-06-30','16:55:00',3.81),('14598','2013-06-30','17:00:00',3.7),('14598','2013-06-30','17:05:00',3.62),('14598','2013-06-30','17:10:00',3.52),('14598','2013-06-30','17:15:00',3.43),('14598','2013-06-30','17:20:00',3.35),('14598','2013-06-30','17:25:00',3.25),('14598','2013-06-30','17:30:00',3.19),('14598','2013-06-30','17:35:00',3.04),('14598','2013-06-30','17:40:00',3),('14598','2013-06-30','17:45:00',2.91),('14598','2013-06-30','17:50:00',2.8),('14598','2013-06-30','17:55:00',2.72),('14598','2013-06-30','18:00:00',2.65),('14598','2013-06-30','18:05:00',2.52),('14598','2013-06-30','18:10:00',2.42),('14598','2013-06-30','18:15:00',2.34),('14598','2013-06-30','18:20:00',2.28),('14598','2013-06-30','18:25:00',2.17),('14598','2013-06-30','18:30:00',2.09),('14598','2013-06-30','18:35:00',1.96),('14598','2013-06-30','18:40:00',1.85),('14598','2013-06-30','18:45:00',1.76),('14598','2013-06-30','18:50:00',1.69),('14598','2013-06-30','18:55:00',1.57),('14598','2013-06-30','19:00:00',1.45),('14598','2013-06-30','19:05:00',1.35),('14598','2013-06-30','19:10:00',1.27),('14598','2013-06-30','19:15:00',1.16),('14598','2013-06-30','19:20:00',1.07),('14598','2013-06-29','08:00:00',1.12),('14598','2013-06-29','08:05:00',1.21),('14598','2013-06-29','08:10:00',1.3),('14598','2013-06-29','08:15:00',1.39),('14598','2013-06-29','08:20:00',1.49),('14598','2013-06-29','08:25:00',1.58),('14598','2013-06-29','08:30:00',1.67),('14598','2013-06-29','08:35:00',1.76),('14598','2013-06-29','08:40:00',1.86),('14598','2013-06-29','08:45:00',1.92),('14598','2013-06-29','08:50:00',2.09),('14598','2013-06-29','08:55:00',2.2),('14598','2013-06-29','09:00:00',2.29),('14598','2013-06-29','09:05:00',2.38),('14598','2013-06-29','09:10:00',2.46),('14598','2013-06-29','09:15:00',2.56),('14598','2013-06-29','09:20:00',2.67),('14598','2013-06-29','09:25:00',2.77),('14598','2013-06-29','09:30:00',2.86),('14598','2013-06-29','09:35:00',2.93),('14598','2013-06-29','09:40:00',3.02),('14598','2013-06-29','09:45:00',3.09),('14598','2013-06-29','09:50:00',3.17),('14598','2013-06-29','09:55:00',3.25),('14598','2013-06-29','10:00:00',3.31),('14598','2013-06-29','10:05:00',3.41),('14598','2013-06-29','10:10:00',3.46),('14598','2013-06-29','10:15:00',3.53),('14598','2013-06-29','10:20:00',3.6),('14598','2013-06-29','10:25:00',3.66),('14598','2013-06-29','10:30:00',3.71),('14598','2013-06-29','10:35:00',3.78),('14598','2013-06-29','10:40:00',3.85),('14598','2013-06-29','10:45:00',3.9),('14598','2013-06-29','10:50:00',3.96),('14598','2013-06-29','10:55:00',4.02),('14598','2013-06-29','11:00:00',4.11),('14598','2013-06-29','11:05:00',4.26),('14598','2013-06-29','11:10:00',4.36),('14598','2013-06-29','11:15:00',4.5),('14598','2013-06-29','11:20:00',2.72),('14598','2013-06-29','11:25:00',3.19),('14598','2013-06-29','11:30:00',4.16),('14598','2013-06-29','11:35:00',4.8),('14598','2013-06-29','11:40:00',4.85),('14598','2013-06-29','11:45:00',4.8),('14598','2013-06-29','11:50:00',4.86),('14598','2013-06-29','11:55:00',4.82),('14598','2013-06-29','12:00:00',4.83),('14598','2013-06-29','12:05:00',4.85),('14598','2013-06-29','12:10:00',4.9),('14598','2013-06-29','12:15:00',4.97),('14598','2013-06-29','12:20:00',5.07),('14598','2013-06-29','12:25:00',5.03),('14598','2013-06-29','12:30:00',5.09),('14598','2013-06-29','12:35:00',5.14),('14598','2013-06-29','12:40:00',4.85),('14598','2013-06-29','12:45:00',4.29),('14598','2013-06-29','12:50:00',2.5),('14598','2013-06-29','12:55:00',2.29),('14598','2013-06-29','13:00:00',4.22),('14598','2013-06-29','13:05:00',5.71),('14598','2013-06-29','13:10:00',4.84),('14598','2013-06-29','13:15:00',5.37),('14598','2013-06-29','13:20:00',5.25),('14598','2013-06-29','13:25:00',5.28),('14598','2013-06-29','13:30:00',5.3),('14598','2013-06-29','13:35:00',5.27),('14598','2013-06-29','13:40:00',5.27),('14598','2013-06-29','13:45:00',5.29),('14598','2013-06-29','13:50:00',5.28),('14598','2013-06-29','13:55:00',5.3),('14598','2013-06-29','14:00:00',5.07),('14598','2013-06-29','14:05:00',5.34),('14598','2013-06-29','14:10:00',5.28),('14598','2013-06-29','14:15:00',5.27),('14598','2013-06-29','14:20:00',5.24),('14598','2013-06-29','14:25:00',5.21),('14598','2013-06-29','14:30:00',5.2),('14598','2013-06-29','14:35:00',5.24),('14598','2013-06-29','14:40:00',5.28),('14598','2013-06-29','14:45:00',5.17),('14598','2013-06-29','14:50:00',5.31),('14598','2013-06-29','14:55:00',5.13),('14598','2013-06-29','15:00:00',3.1),('14598','2013-06-29','15:05:00',3.02),('14598','2013-06-29','15:10:00',3.05),('14598','2013-06-29','15:15:00',4.25),('14598','2013-06-29','15:20:00',4.8),('14598','2013-06-29','15:25:00',4.96),('14598','2013-06-29','15:30:00',4.87),('14598','2013-06-29','15:35:00',4.81),('14598','2013-06-29','15:40:00',4.77),('14598','2013-06-29','15:45:00',4.1),('14598','2013-06-29','15:50:00',4.55),('14598','2013-06-29','15:55:00',4.89),('14598','2013-06-29','16:00:00',5.02),('14598','2013-06-29','16:05:00',5.18),('14598','2013-06-29','16:10:00',4.25),('14598','2013-06-29','16:15:00',5.3),('14598','2013-06-29','16:20:00',5.09),('14598','2013-06-29','16:25:00',4.83),('14598','2013-06-29','16:30:00',4.26),('14598','2013-06-29','16:35:00',3.74),('14598','2013-06-29','16:40:00',3.6),('14598','2013-06-29','16:45:00',2.59),('14598','2013-06-29','16:50:00',4.03),('14598','2013-06-29','16:55:00',4.06),('14598','2013-06-29','17:00:00',3.7),('14598','2013-06-29','17:05:00',3.94),('14598','2013-06-29','17:10:00',3.93),('14598','2013-06-29','17:15:00',3.81),('14598','2013-06-29','17:20:00',2.97),('14598','2013-06-29','17:25:00',3.38),('14598','2013-06-29','17:30:00',2.24),('14598','2013-06-29','17:35:00',2.77),('14598','2013-06-29','17:40:00',1.93),('14598','2013-06-29','17:45:00',2.69),('14598','2013-06-29','17:50:00',1.57),('14598','2013-06-29','17:55:00',1.4),('14598','2013-06-29','18:00:00',2.64),('14598','2013-06-29','18:05:00',2.41),('14598','2013-06-29','18:10:00',2.34),('14598','2013-06-29','18:15:00',2.04),('14598','2013-06-29','18:20:00',2.25),('14598','2013-06-29','18:25:00',2.1),('14598','2013-06-29','18:30:00',2.06),('14598','2013-06-29','18:35:00',2.08),('14598','2013-06-29','18:40:00',2),('14598','2013-06-29','18:45:00',1.88),('14598','2013-06-29','18:50:00',1.3),('14598','2013-06-28','07:55:00',1.03),('14598','2013-06-28','08:00:00',1.11),('14598','2013-06-28','08:05:00',1.2),('14598','2013-06-28','08:10:00',1.31),('14598','2013-06-28','08:15:00',1.4),('14598','2013-06-28','08:20:00',1.48),('14598','2013-06-28','08:25:00',1.59),('14598','2013-06-28','08:30:00',1.67),('14598','2013-06-28','08:35:00',1.77),('14598','2013-06-28','08:40:00',1.55),('14598','2013-06-28','08:45:00',2.01),('14598','2013-06-28','08:50:00',2.33),('14598','2013-06-28','08:55:00',2.44),('14598','2013-06-28','09:10:00',1.2),('14598','2013-06-28','09:20:00',1.23),('14598','2013-06-28','09:25:00',2.47),('14598','2013-06-28','09:30:00',3.03),('14598','2013-06-28','09:35:00',3.05),('14598','2013-06-28','09:40:00',3.13),('14598','2013-06-28','09:45:00',3.22),('14598','2013-06-28','09:50:00',3.3),('14598','2013-06-28','09:55:00',3.37),('14598','2013-06-28','10:00:00',3.43),('14598','2013-06-28','10:05:00',3.5),('14598','2013-06-28','10:10:00',3.52),('14598','2013-06-28','10:15:00',3.67),('14598','2013-06-28','10:20:00',3.76),('14598','2013-06-28','10:25:00',3.83),('14598','2013-06-28','10:30:00',3.98),('14598','2013-06-28','10:35:00',4.07),('14598','2013-06-28','10:40:00',4.13),('14598','2013-06-28','10:45:00',4.25),('14598','2013-06-28','10:50:00',3.67),('14598','2013-06-28','10:55:00',3.8),('14598','2013-06-28','11:00:00',4.43),('14598','2013-06-28','11:05:00',4.56),('14598','2013-06-28','11:10:00',4.81),('14598','2013-06-28','11:15:00',4.24),('14598','2013-06-28','11:20:00',3.62),('14598','2013-06-28','11:25:00',3.95),('14598','2013-06-28','11:30:00',3.08),('14598','2013-06-28','11:35:00',2.46),('14598','2013-06-28','11:40:00',3.87),('14598','2013-06-28','11:45:00',4.04),('14598','2013-06-28','11:50:00',2.94),('14598','2013-06-28','11:55:00',2.3),('14598','2013-06-28','12:00:00',4.26),('14598','2013-06-28','12:05:00',5.04),('14598','2013-06-28','12:10:00',4.89),('14598','2013-06-28','12:15:00',4.91),('14598','2013-06-28','12:20:00',4.93),('14598','2013-06-28','12:25:00',4.97),('14598','2013-06-28','12:30:00',4.98),('14598','2013-06-28','12:35:00',5),('14598','2013-06-28','12:40:00',5.03),('14598','2013-06-28','12:45:00',5.05),('14598','2013-06-28','12:50:00',5.09),('14598','2013-06-28','12:55:00',5.12),('14598','2013-06-28','13:00:00',5.14),('14598','2013-06-28','13:05:00',5.16),('14598','2013-06-28','13:10:00',4.77),('14598','2013-06-28','13:15:00',5.35),('14598','2013-06-28','13:20:00',3.95),('14598','2013-06-28','13:25:00',3.01),('14598','2013-06-28','13:30:00',4.78),('14598','2013-06-28','13:35:00',4.66),('14598','2013-06-28','13:40:00',4.7),('14598','2013-06-28','13:45:00',4.91),('14598','2013-06-28','13:50:00',5.64),('14598','2013-06-28','13:55:00',5.09),('14598','2013-06-28','14:00:00',5.3),('14598','2013-06-28','14:05:00',5.26),('14598','2013-06-28','14:10:00',5.28),('14598','2013-06-28','14:15:00',4.85),('14598','2013-06-28','14:20:00',4.07),('14598','2013-06-28','14:25:00',3.32),('14598','2013-06-28','14:30:00',5.13),('14598','2013-06-28','14:35:00',4.89),('14598','2013-06-28','14:40:00',4.86),('14598','2013-06-28','14:45:00',4.71),('14598','2013-06-28','14:50:00',4.97),('14598','2013-06-28','14:55:00',4.96),('14598','2013-06-28','15:00:00',5.06),('14598','2013-06-28','15:05:00',5.15),('14598','2013-06-28','15:10:00',5.16),('14598','2013-06-28','15:15:00',2.72),('14598','2013-06-28','15:20:00',3.36),('14598','2013-06-28','15:25:00',5.77),('14598','2013-06-28','15:30:00',5),('14598','2013-06-28','15:35:00',4.77),('14598','2013-06-28','15:40:00',4.74),('14598','2013-06-28','15:45:00',4.68),('14598','2013-06-28','15:50:00',4.66),('14598','2013-06-28','15:55:00',4.66),('14598','2013-06-28','16:00:00',4.56),('14598','2013-06-28','16:05:00',4.44),('14598','2013-06-28','16:10:00',4.34),('14598','2013-06-28','16:15:00',4.35),('14598','2013-06-28','16:20:00',4.27),('14598','2013-06-28','16:25:00',4.22),('14598','2013-06-28','16:30:00',4.16),('14598','2013-06-28','16:35:00',4.08),('14598','2013-06-28','16:40:00',4.02),('14598','2013-06-28','16:45:00',3.97),('14598','2013-06-28','16:50:00',3.9),('14598','2013-06-28','16:55:00',3.82),('14598','2013-06-28','17:00:00',3.74),('14598','2013-06-28','17:05:00',3.68),('14598','2013-06-28','17:10:00',3.61),('14598','2013-06-28','17:15:00',3.53),('14598','2013-06-28','17:20:00',3.46),('14598','2013-06-28','17:25:00',3.37),('14598','2013-06-28','17:30:00',3.28),('14598','2013-06-28','17:35:00',3.2),('14598','2013-06-28','17:40:00',3.11),('14598','2013-06-28','17:45:00',2.95),('14598','2013-06-28','17:50:00',2.95),('14598','2013-06-28','17:55:00',2.86),('14598','2013-06-28','18:00:00',2.78),('14598','2013-06-28','18:05:00',2.68),('14598','2013-06-28','18:10:00',2.57),('14598','2013-06-28','18:15:00',2.47),('14598','2013-06-28','18:20:00',2.36),('14598','2013-06-28','18:25:00',2.24),('14598','2013-06-28','18:30:00',2.09),('14598','2013-06-28','18:35:00',2.05),('14598','2013-06-28','18:40:00',1.96),('14598','2013-06-28','18:45:00',1.88),('14598','2013-06-28','18:50:00',1.78),('14598','2013-06-28','18:55:00',1.66),('14598','2013-06-28','19:00:00',1.54),('14598','2013-06-28','19:05:00',1.45),('14598','2013-06-28','19:10:00',1.33),('14598','2013-06-28','19:20:00',1.11),('14598','2013-06-27','07:50:00',1.01),('14598','2013-06-27','07:55:00',1.09),('14598','2013-06-27','08:00:00',1.17),('14598','2013-06-27','08:05:00',1.26),('14598','2013-06-27','08:10:00',1.35),('14598','2013-06-27','08:15:00',1.43),('14598','2013-06-27','08:20:00',1.51),('14598','2013-06-27','08:25:00',1.56),('14598','2013-06-27','08:30:00',1.69),('14598','2013-06-27','08:35:00',1.8),('14598','2013-06-27','08:40:00',1.89),('14598','2013-06-27','08:45:00',2.02),('14598','2013-06-27','08:50:00',2.13),('14598','2013-06-27','08:55:00',2.23),('14598','2013-06-27','09:00:00',2.32),('14598','2013-06-27','09:05:00',2.41),('14598','2013-06-27','09:10:00',2.63),('14598','2013-06-27','09:15:00',2.97),('14598','2013-06-27','09:20:00',3.3),('14598','2013-06-27','09:25:00',3.29),('14598','2013-06-27','09:30:00',3.25),('14598','2013-06-27','09:35:00',3.14),('14598','2013-06-27','09:40:00',3.03),('14598','2013-06-27','09:45:00',3.12),('14598','2013-06-27','09:50:00',3.19),('14598','2013-06-27','09:55:00',3.25),('14598','2013-06-27','10:00:00',3.34),('14598','2013-06-27','10:05:00',3.43),('14598','2013-06-27','10:10:00',3.49),('14598','2013-06-27','10:15:00',3.54),('14598','2013-06-27','10:20:00',3.61),('14598','2013-06-27','10:25:00',3.64),('14598','2013-06-27','10:30:00',3.76),('14598','2013-06-27','10:35:00',2.94),('14598','2013-06-27','10:40:00',3.88),('14598','2013-06-27','10:45:00',2.57),('14598','2013-06-27','10:50:00',2.3),('14598','2013-06-27','10:55:00',4.28),('14598','2013-06-27','11:00:00',4.26),('14598','2013-06-27','11:05:00',4.31),('14598','2013-06-27','11:10:00',4.39),('14598','2013-06-27','11:15:00',4.31),('14598','2013-06-27','11:20:00',4.35),('14598','2013-06-27','11:25:00',4.38),('14598','2013-06-27','11:30:00',4.47),('14598','2013-06-27','11:35:00',4.55),('14598','2013-06-27','11:40:00',4.6),('14598','2013-06-27','11:45:00',4.59),('14598','2013-06-27','11:50:00',4.68),('14598','2013-06-27','11:55:00',4.77),('14598','2013-06-27','12:00:00',4.75),('14598','2013-06-27','12:05:00',4.74),('14598','2013-06-27','12:10:00',4.79),('14598','2013-06-27','12:15:00',4.81),('14598','2013-06-27','12:20:00',4.87),('14598','2013-06-27','12:25:00',4.89),('14598','2013-06-27','12:30:00',4.93),('14598','2013-06-27','12:35:00',4.96),('14598','2013-06-27','12:40:00',4.96),('14598','2013-06-27','12:45:00',4.95),('14598','2013-06-27','12:50:00',4.97),('14598','2013-06-27','12:55:00',4.96),('14598','2013-06-27','13:00:00',4.96),('14598','2013-06-27','13:05:00',4.94),('14598','2013-06-27','13:10:00',5),('14598','2013-06-27','13:15:00',4.99),('14598','2013-06-27','13:20:00',4.97),('14598','2013-06-27','13:25:00',5),('14598','2013-06-27','13:30:00',4.99),('14598','2013-06-27','13:35:00',5.01),('14598','2013-06-27','13:40:00',5.02),('14598','2013-06-27','13:45:00',5.02),('14598','2013-06-27','13:50:00',5.01),('14598','2013-06-27','13:55:00',5.01),('14598','2013-06-27','14:00:00',5.03),('14598','2013-06-27','14:05:00',5.01),('14598','2013-06-27','14:10:00',4.97),('14598','2013-06-27','14:15:00',4.99),('14598','2013-06-27','14:20:00',4.96),('14598','2013-06-27','14:25:00',4.98),('14598','2013-06-27','14:30:00',4.84),('14598','2013-06-27','14:35:00',4.91),('14598','2013-06-27','14:40:00',4.94),('14598','2013-06-27','14:45:00',4.94),('14598','2013-06-27','14:50:00',4.92),('14598','2013-06-27','14:55:00',4.9),('14598','2013-06-27','15:00:00',4.9),('14598','2013-06-27','15:05:00',4.91),('14598','2013-06-27','15:10:00',4.89),('14598','2013-06-27','15:15:00',4.84),('14598','2013-06-27','15:20:00',4.77),('14598','2013-06-27','15:25:00',4.77),('14598','2013-06-27','15:30:00',4.71),('14598','2013-06-27','15:35:00',4.64),('14598','2013-06-27','15:40:00',4.58),('14598','2013-06-27','15:45:00',4.52),('14598','2013-06-27','15:50:00',4.48),('14598','2013-06-27','15:55:00',4.47),('14598','2013-06-27','16:00:00',4.46),('14598','2013-06-27','16:05:00',4.4),('14598','2013-06-27','16:10:00',4.29),('14598','2013-06-27','16:15:00',4.22),('14598','2013-06-27','16:20:00',4.12),('14598','2013-06-27','16:25:00',4.14),('14598','2013-06-27','16:30:00',4.1),('14598','2013-06-27','16:35:00',4.01),('14598','2013-06-27','16:40:00',3.96),('14598','2013-06-27','16:45:00',3.92),('14598','2013-06-27','16:50:00',3.79),('14598','2013-06-27','16:55:00',3.66),('14598','2013-06-27','17:00:00',3.81),('14598','2013-06-27','17:05:00',3.72),('14598','2013-06-27','17:10:00',3.65),('14598','2013-06-27','17:15:00',3.54),('14598','2013-06-27','17:20:00',3.32),('14598','2013-06-27','17:25:00',3.22),('14598','2013-06-27','17:30:00',2.97),('14598','2013-06-27','17:35:00',2.92),('14598','2013-06-27','17:40:00',2.86),('14598','2013-06-27','17:45:00',2.81),('14598','2013-06-27','17:50:00',2.75),('14598','2013-06-27','17:55:00',2.61),('14598','2013-06-27','18:00:00',2.47),('14598','2013-06-27','18:05:00',2.42),('14598','2013-06-27','18:10:00',2.41),('14598','2013-06-27','18:15:00',2.32),('14598','2013-06-27','18:20:00',2.19),('14598','2013-06-27','18:25:00',1.9),('14598','2013-06-27','18:30:00',1.93),('14598','2013-06-27','18:35:00',1.89),('14598','2013-06-27','18:40:00',1.85),('14598','2013-06-27','18:45:00',1.76),('14598','2013-06-27','18:50:00',1.64),('14598','2013-06-27','18:55:00',1.56),('14598','2013-06-27','19:00:00',1.47),('14598','2013-06-27','19:05:00',1.33),('14598','2013-06-26','07:55:00',1.07),('14598','2013-06-26','08:00:00',1.15),('14598','2013-06-26','08:05:00',1.24),('14598','2013-06-26','08:10:00',1.32),('14598','2013-06-26','08:15:00',1.41),('14598','2013-06-26','08:20:00',1.51),('14598','2013-06-26','08:25:00',1.6),('14598','2013-06-26','08:30:00',1.69),('14598','2013-06-26','08:35:00',1.79),('14598','2013-06-26','08:40:00',1.85),('14598','2013-06-26','08:45:00',1.4),('14598','2013-06-26','08:50:00',1.84),('14598','2013-06-26','08:55:00',2.12),('14598','2013-06-26','09:00:00',2.3),('14598','2013-06-26','09:05:00',2.42),('14598','2013-06-26','09:10:00',2.5),('14598','2013-06-26','09:15:00',2.58),('14598','2013-06-26','09:20:00',2.7),('14598','2013-06-26','09:25:00',2.77),('14598','2013-06-26','09:30:00',2.85),('14598','2013-06-26','09:35:00',2.92),('14598','2013-06-26','09:40:00',3),('14598','2013-06-26','09:45:00',3.08),('14598','2013-06-26','09:50:00',3.18),('14598','2013-06-26','09:55:00',3.26),('14598','2013-06-26','10:00:00',3.31),('14598','2013-06-26','10:05:00',3.37),('14598','2013-06-26','10:10:00',3.43),('14598','2013-06-26','10:15:00',3.47),('14598','2013-06-26','10:20:00',3.56),('14598','2013-06-26','10:25:00',3.66),('14598','2013-06-26','10:30:00',3.72),('14598','2013-06-26','10:35:00',3.79),('14598','2013-06-26','10:40:00',3.85),('14598','2013-06-26','10:45:00',3.91),('14598','2013-06-26','10:50:00',3.89),('14598','2013-06-26','10:55:00',3.98),('14598','2013-06-26','11:00:00',4.06),('14598','2013-06-26','11:05:00',4.14),('14598','2013-06-26','11:10:00',4.22),('14598','2013-06-26','11:15:00',4.27),('14598','2013-06-26','11:20:00',4.32),('14598','2013-06-26','11:25:00',4.38),('14598','2013-06-26','11:30:00',4.47),('14598','2013-06-26','11:35:00',4.55),('14598','2013-06-26','11:40:00',4.6),('14598','2013-06-26','11:45:00',4.63),('14598','2013-06-26','11:50:00',4.66),('14598','2013-06-26','11:55:00',4.69),('14598','2013-06-26','12:00:00',4.7),('14598','2013-06-26','12:05:00',4.72),('14598','2013-06-26','12:10:00',4.8),('14598','2013-06-26','12:15:00',4.87),('14598','2013-06-26','12:20:00',4.91),('14598','2013-06-26','12:25:00',4.96),('14598','2013-06-26','12:30:00',5.02),('14598','2013-06-26','12:35:00',5.03),('14598','2013-06-26','12:40:00',5.01),('14598','2013-06-26','12:45:00',5.01),('14598','2013-06-26','12:50:00',5.01),('14598','2013-06-26','12:55:00',5.02),('14598','2013-06-26','13:00:00',5.06),('14598','2013-06-26','13:05:00',5.1),('14598','2013-06-26','13:10:00',5.14),('14598','2013-06-26','13:15:00',5.16),('14598','2013-06-26','13:20:00',5.16),('14598','2013-06-26','13:25:00',5.15),('14598','2013-06-26','13:30:00',5.12),('14598','2013-06-26','13:35:00',5.16),('14598','2013-06-26','13:40:00',5.26),('14598','2013-06-26','13:45:00',5.22),('14598','2013-06-26','13:50:00',5.18),('14598','2013-06-26','13:55:00',5.13),('14598','2013-06-26','14:00:00',5.16),('14598','2013-06-26','14:05:00',5.15),('14598','2013-06-26','14:10:00',5.12),('14598','2013-06-26','14:15:00',5.12),('14598','2013-06-26','14:20:00',5.12),('14598','2013-06-26','14:25:00',5.09),('14598','2013-06-26','14:30:00',5.06),('14598','2013-06-26','14:35:00',5.07),('14598','2013-06-26','14:40:00',5.04),('14598','2013-06-26','14:45:00',5.04),('14598','2013-06-26','14:50:00',5.01),('14598','2013-06-26','14:55:00',4.98),('14598','2013-06-26','15:00:00',4.94),('14598','2013-06-26','15:05:00',4.93),('14598','2013-06-26','15:10:00',4.9),('14598','2013-06-26','15:15:00',4.85),('14598','2013-06-26','15:20:00',4.81),('14598','2013-06-26','15:25:00',4.77),('14598','2013-06-26','15:30:00',4.77),('14598','2013-06-26','15:35:00',4.73),('14598','2013-06-26','15:40:00',4.62),('14598','2013-06-26','15:45:00',4.6),('14598','2013-06-26','15:50:00',4.55),('14598','2013-06-26','15:55:00',4.51),('14598','2013-06-26','16:00:00',4.48),('14598','2013-06-26','16:05:00',4.42),('14598','2013-06-26','16:10:00',4.36),('14598','2013-06-26','16:15:00',4.31),('14598','2013-06-26','16:20:00',4.24),('14598','2013-06-26','16:25:00',4.21),('14598','2013-06-26','16:30:00',4.15),('14598','2013-06-26','16:35:00',4.07),('14598','2013-06-26','16:40:00',4),('14598','2013-06-26','16:45:00',3.92),('14598','2013-06-26','16:50:00',3.84),('14598','2013-06-26','16:55:00',3.74),('14598','2013-06-26','17:00:00',3.68),('14598','2013-06-26','17:05:00',3.59),('14598','2013-06-26','17:10:00',3.53),('14598','2013-06-26','17:15:00',3.46),('14598','2013-06-26','17:20:00',3.38),('14598','2013-06-26','17:25:00',3.3),('14598','2013-06-26','17:30:00',3.24),('14598','2013-06-26','17:35:00',3.14),('14598','2013-06-26','17:40:00',3.06),('14598','2013-06-26','17:45:00',2.95),('14598','2013-06-26','17:50:00',2.84),('14598','2013-06-26','17:55:00',2.73),('14598','2013-06-26','18:00:00',2.35),('14598','2013-06-26','18:05:00',1.94),('14598','2013-06-26','18:10:00',2.59),('14598','2013-06-26','18:15:00',2.37),('14598','2013-06-26','18:20:00',2.29),('14598','2013-06-26','18:25:00',2.19),('14598','2013-06-26','18:30:00',2.15),('14598','2013-06-26','18:35:00',2.14),('14598','2013-06-26','18:40:00',2.17),('14598','2013-06-26','18:45:00',2.08),('14598','2013-06-26','18:50:00',1.47),('14598','2013-06-26','19:00:00',1.3),('14598','2013-06-26','19:05:00',1.27),('14598','2013-06-26','19:10:00',1.13),('14598','2013-06-25','07:55:00',1.07),('14598','2013-06-25','08:00:00',1.13),('14598','2013-06-25','08:05:00',1.24),('14598','2013-06-25','08:10:00',1.34),('14598','2013-06-25','08:15:00',1.43),('14598','2013-06-25','08:20:00',1.53),('14598','2013-06-25','08:25:00',1.62),('14598','2013-06-25','08:30:00',1.69),('14598','2013-06-25','08:35:00',1.8),('14598','2013-06-25','08:40:00',1.86),('14598','2013-06-25','08:45:00',1.97),('14598','2013-06-25','08:50:00',2.2),('14598','2013-06-25','08:55:00',1.9),('14598','2013-06-25','09:00:00',2.35),('14598','2013-06-25','09:05:00',2.46),('14598','2013-06-25','09:10:00',2.57),('14598','2013-06-25','09:15:00',2.69),('14598','2013-06-25','09:20:00',2.75),('14598','2013-06-25','09:25:00',2.82),('14598','2013-06-25','09:30:00',2.98),('14598','2013-06-25','09:35:00',3.07),('14598','2013-06-25','09:40:00',3.32),('14598','2013-06-25','09:45:00',3.42),('14598','2013-06-25','09:50:00',3.56),('14598','2013-06-25','09:55:00',3.68),('14598','2013-06-25','10:00:00',3.62),('14598','2013-06-25','10:05:00',3.59),('14598','2013-06-25','10:10:00',3.83),('14598','2013-06-25','10:15:00',3.96),('14598','2013-06-25','10:20:00',3.83),('14598','2013-06-25','10:25:00',3.85),('14598','2013-06-25','10:30:00',3.89),('14598','2013-06-25','10:35:00',3.96),('14598','2013-06-25','10:40:00',4.04),('14598','2013-06-25','10:45:00',4.07),('14598','2013-06-25','10:50:00',4.11),('14598','2013-06-25','10:55:00',4.17),('14598','2013-06-25','11:00:00',4.2),('14598','2013-06-25','11:05:00',4.27),('14598','2013-06-25','11:10:00',4.35),('14598','2013-06-25','11:15:00',4.41),('14598','2013-06-25','11:20:00',4.45),('14598','2013-06-25','11:25:00',4.49),('14598','2013-06-25','11:30:00',4.55),('14598','2013-06-25','11:35:00',4.59),('14598','2013-06-25','11:40:00',4.64),('14598','2013-06-25','11:45:00',4.66),('14598','2013-06-25','11:50:00',4.73),('14598','2013-06-25','11:55:00',4.77),('14598','2013-06-25','12:00:00',4.81),('14598','2013-06-25','12:05:00',4.83),('14598','2013-06-25','12:10:00',4.86),('14598','2013-06-25','12:15:00',4.89),('14598','2013-06-25','12:20:00',4.94),('14598','2013-06-25','12:25:00',4.96),('14598','2013-06-25','12:30:00',5.01),('14598','2013-06-25','12:35:00',5.06),('14598','2013-06-25','12:40:00',5.05),('14598','2013-06-25','12:45:00',5.06),('14598','2013-06-25','12:50:00',5.04),('14598','2013-06-25','12:55:00',5.1),('14598','2013-06-25','13:00:00',5.12),('14598','2013-06-25','13:05:00',5.16),('14598','2013-06-25','13:10:00',5.17),('14598','2013-06-25','13:15:00',5.16),('14598','2013-06-25','13:20:00',5.16),('14598','2013-06-25','13:25:00',5.14),('14598','2013-06-25','13:30:00',5.17),('14598','2013-06-25','13:35:00',5.15),('14598','2013-06-25','13:40:00',5.16),('14598','2013-06-25','13:45:00',5.18),('14598','2013-06-25','13:50:00',5.17),('14598','2013-06-25','13:55:00',5.15),('14598','2013-06-25','14:00:00',5.19),('14598','2013-06-25','14:05:00',5.2),('14598','2013-06-25','14:10:00',5.17),('14598','2013-06-25','14:15:00',5.18),('14598','2013-06-25','14:20:00',5.16),('14598','2013-06-25','14:25:00',5.14),('14598','2013-06-25','14:30:00',5.13),('14598','2013-06-25','14:35:00',5.12),('14598','2013-06-25','14:40:00',5.07),('14598','2013-06-25','14:45:00',5.05),('14598','2013-06-25','14:50:00',5.04),('14598','2013-06-25','14:55:00',5.03),('14598','2013-06-25','15:00:00',5.01),('14598','2013-06-25','15:05:00',4.99),('14598','2013-06-25','15:10:00',4.94),('14598','2013-06-25','15:15:00',4.87),('14598','2013-06-25','15:20:00',4.85),('14598','2013-06-25','15:25:00',4.81),('14598','2013-06-25','15:30:00',4.78),('14598','2013-06-25','15:35:00',4.72),('14598','2013-06-25','15:40:00',4.68),('14598','2013-06-25','15:45:00',4.64),('14598','2013-06-25','15:50:00',4.6),('14598','2013-06-25','15:55:00',4.49),('14598','2013-06-25','16:00:00',4.48),('14598','2013-06-25','16:05:00',4.46),('14598','2013-06-25','16:10:00',4.41),('14598','2013-06-25','16:15:00',4.35),('14598','2013-06-25','16:20:00',4.3),('14598','2013-06-25','16:25:00',4.22),('14598','2013-06-25','16:30:00',4.14),('14598','2013-06-25','16:35:00',4.08),('14598','2013-06-25','16:40:00',4.03),('14598','2013-06-25','16:45:00',3.95),('14598','2013-06-25','16:50:00',3.89),('14598','2013-06-25','16:55:00',3.81),('14598','2013-06-25','17:00:00',3.74),('14598','2013-06-25','17:05:00',3.69),('14598','2013-06-25','17:10:00',3.6),('14598','2013-06-25','17:15:00',3.51),('14598','2013-06-25','17:20:00',3.44),('14598','2013-06-25','17:25:00',3.36),('14598','2013-06-25','17:30:00',3.26),('14598','2013-06-25','17:35:00',3.17),('14598','2013-06-25','17:40:00',3.07),('14598','2013-06-25','17:45:00',2.99),('14598','2013-06-25','17:50:00',2.91),('14598','2013-06-25','17:55:00',2.83),('14598','2013-06-25','18:00:00',2.73),('14598','2013-06-25','18:05:00',2.63),('14598','2013-06-25','18:10:00',2.52),('14598','2013-06-25','18:15:00',2.44),('14598','2013-06-25','18:20:00',2.35),('14598','2013-06-25','18:25:00',2.24),('14598','2013-06-25','18:30:00',2.14),('14598','2013-06-25','18:35:00',2.02),('14598','2013-06-25','18:40:00',1.9),('14598','2013-06-25','18:45:00',1.82),('14598','2013-06-25','18:50:00',1.71),('14598','2013-06-25','18:55:00',1.61),('14598','2013-06-25','19:00:00',1.53),('14598','2013-06-25','19:05:00',1.44),('14598','2013-06-25','19:10:00',1.33),('14598','2013-06-25','19:15:00',1.23),('14598','2013-06-25','19:20:00',1.12),('14598','2013-06-24','07:55:00',1.08),('14598','2013-06-24','08:00:00',1.18),('14598','2013-06-24','08:05:00',1.27),('14598','2013-06-24','08:10:00',1.37),('14598','2013-06-24','08:15:00',1.48),('14598','2013-06-24','08:20:00',1.59),('14598','2013-06-24','08:25:00',1.61),('14598','2013-06-24','08:30:00',1.51),('14598','2013-06-24','08:35:00',1.72),('14598','2013-06-24','08:40:00',1.98),('14598','2013-06-24','08:45:00',1.81),('14598','2013-06-24','08:50:00',1.72),('14598','2013-06-24','08:55:00',2.79),('14598','2013-06-24','09:00:00',1.59),('14598','2013-06-24','09:05:00',1.07),('14598','2013-06-24','09:10:00',2.66),('14598','2013-06-24','09:15:00',2.71),('14598','2013-06-24','09:20:00',2.81),('14598','2013-06-24','09:25:00',2.91),('14598','2013-06-24','09:30:00',3),('14598','2013-06-24','09:35:00',3.08),('14598','2013-06-24','09:40:00',3.15),('14598','2013-06-24','09:45:00',3.24),('14598','2013-06-24','09:50:00',3.28),('14598','2013-06-24','09:55:00',3.38),('14598','2013-06-24','10:00:00',3.51),('14598','2013-06-24','10:05:00',3.73),('14598','2013-06-24','10:10:00',3.76),('14598','2013-06-24','10:15:00',3.52),('14598','2013-06-24','10:20:00',4.33),('14598','2013-06-24','10:25:00',2.97),('14598','2013-06-24','10:30:00',2),('14598','2013-06-24','10:35:00',3.96),('14598','2013-06-24','10:40:00',4.09),('14598','2013-06-24','10:45:00',3.06),('14598','2013-06-24','10:50:00',2.76),('14598','2013-06-24','10:55:00',1.22),('14598','2013-06-24','11:00:00',1.34),('14598','2013-06-24','11:05:00',2.11),('14598','2013-06-24','11:10:00',2.57),('14598','2013-06-24','11:15:00',2.68),('14598','2013-06-24','11:20:00',2.02),('14598','2013-06-24','11:25:00',3.34),('14598','2013-06-24','11:30:00',3.49),('14598','2013-06-24','11:35:00',2.12),('14598','2013-06-24','11:40:00',2.35),('14598','2013-06-24','11:45:00',2.69),('14598','2013-06-24','11:50:00',4.62),('14598','2013-06-24','11:55:00',4.63),('14598','2013-06-24','12:00:00',4.08),('14598','2013-06-24','12:05:00',4.67),('14598','2013-06-24','12:10:00',5.11),('14598','2013-06-24','12:15:00',4.42),('14598','2013-06-24','12:20:00',3.99),('14598','2013-06-24','12:25:00',5.18),('14598','2013-06-24','12:30:00',4.54),('14598','2013-06-24','12:35:00',5.17),('14598','2013-06-24','12:40:00',5.45),('14598','2013-06-24','12:45:00',4.61),('14598','2013-06-24','12:50:00',5.73),('14598','2013-06-24','12:55:00',5.42),('14598','2013-06-24','13:00:00',5.17),('14598','2013-06-24','13:05:00',5.48),('14598','2013-06-24','13:10:00',5.39),('14598','2013-06-24','13:15:00',5.57),('14598','2013-06-24','13:20:00',5.14),('14598','2013-06-24','13:25:00',5.32),('14598','2013-06-24','13:30:00',5.34),('14598','2013-06-24','13:35:00',5.35),('14598','2013-06-24','13:40:00',5.34),('14598','2013-06-24','13:45:00',4.96),('14598','2013-06-24','13:50:00',5.19),('14598','2013-06-24','13:55:00',5.39),('14598','2013-06-24','14:00:00',5.43),('14598','2013-06-24','14:05:00',5.09),('14598','2013-06-24','14:10:00',3.23),('14598','2013-06-24','14:15:00',4.25),('14598','2013-06-24','14:20:00',4.37),('14598','2013-06-24','14:25:00',4.89),('14598','2013-06-24','14:30:00',4.09),('14598','2013-06-24','14:35:00',4.36),('14598','2013-06-24','14:40:00',4.45),('14598','2013-06-24','14:45:00',4.36),('14598','2013-06-24','14:50:00',5.39),('14598','2013-06-24','14:55:00',4.42),('14598','2013-06-24','15:00:00',3.61),('14598','2013-06-24','15:05:00',4.59),('14598','2013-06-24','15:10:00',3.36),('14598','2013-06-24','15:15:00',4.7),('14598','2013-06-24','15:20:00',3.5),('14598','2013-06-24','15:25:00',4.42),('14598','2013-06-24','15:30:00',5.04),('14598','2013-06-24','15:35:00',4.94),('14598','2013-06-24','15:40:00',4.9),('14598','2013-06-24','15:45:00',3.94),('14598','2013-06-24','15:50:00',4.58),('14598','2013-06-24','15:55:00',4.91),('14598','2013-06-24','16:00:00',3.65),('14598','2013-06-24','16:05:00',4.99),('14598','2013-06-24','16:10:00',4.23),('14598','2013-06-24','16:15:00',3.09),('14598','2013-06-24','16:20:00',3.57),('14598','2013-06-24','16:25:00',3.03),('14598','2013-06-24','16:30:00',2.63),('14598','2013-06-24','16:35:00',2.73),('14598','2013-06-24','16:40:00',1.38),('14598','2013-06-24','16:45:00',3.89),('14598','2013-06-24','16:50:00',4.41),('14598','2013-06-24','16:55:00',4.31),('14598','2013-06-24','17:00:00',3.38),('14598','2013-06-24','17:05:00',4.27),('14598','2013-06-24','17:11:00',2.29),('14598','2013-06-24','17:15:00',1.5),('14598','2013-06-24','17:20:00',3.33),('14598','2013-06-24','17:25:00',3.3),('14598','2013-06-24','17:30:00',1.33),('14598','2013-06-24','17:35:00',1.41),('14598','2013-06-24','17:40:00',2.92),('14598','2013-06-24','17:45:00',2.76),('14598','2013-06-24','17:50:00',3.23),('14598','2013-06-24','17:56:00',2.78),('14598','2013-06-24','18:00:00',1.13),('14598','2013-06-24','18:05:00',1.98),('14598','2013-06-24','18:10:00',1.32),('14598','2013-06-24','18:26:00',2.49),('14598','2013-06-24','18:30:00',1.42),('14598','2013-06-24','18:35:00',2),('14598','2013-06-24','18:40:00',1.6),('14598','2013-06-24','18:45:00',1.5),('14598','2013-06-24','18:50:00',2.07),('14598','2013-06-24','18:56:00',1.27),('14598','2013-06-24','19:00:00',1.82),('14598','2013-06-24','19:05:00',1.7),('14598','2013-06-24','19:10:00',1.49),('14598','2013-06-24','19:15:00',1.24),('14598','2013-06-24','19:20:00',1.23),('14598','2013-06-23','08:45:00',1.48),('14598','2013-06-23','08:50:00',1.99),('14598','2013-06-23','08:55:00',2.28),('14598','2013-06-23','09:00:00',2.39),('14598','2013-06-23','09:05:00',2.42),('14598','2013-06-23','09:10:00',2.46),('14598','2013-06-23','09:15:00',2.56),('14598','2013-06-23','09:20:00',2.66),('14598','2013-06-23','09:25:00',2.79),('14598','2013-06-23','09:30:00',2.83),('14598','2013-06-23','09:35:00',2.89),('14598','2013-06-23','09:40:00',2.97),('14598','2013-06-23','09:45:00',3.09),('14598','2013-06-23','09:50:00',3.15),('14598','2013-06-23','09:55:00',3.24),('14598','2013-06-23','10:00:00',3.32),('14598','2013-06-23','10:05:00',3.38),('14598','2013-06-23','10:10:00',3.42),('14598','2013-06-23','10:15:00',3.44),('14598','2013-06-23','10:20:00',3.56),('14598','2013-06-23','10:25:00',3.69),('14598','2013-06-23','10:30:00',3.76),('14598','2013-06-23','10:35:00',3.82),('14598','2013-06-23','10:40:00',3.94),('14598','2013-06-23','10:45:00',3.96),('14598','2013-06-23','10:50:00',4.04),('14598','2013-06-23','10:55:00',4.11),('14598','2013-06-23','11:00:00',4.19),('14598','2013-06-23','11:05:00',4.25),('14598','2013-06-23','11:10:00',4.31),('14598','2013-06-23','11:15:00',4.37),('14598','2013-06-23','11:20:00',4.42),('14598','2013-06-23','11:25:00',4.49),('14598','2013-06-23','11:30:00',4.56),('14598','2013-06-23','11:35:00',4.59),('14598','2013-06-23','11:40:00',4.63),('14598','2013-06-23','11:45:00',4.69),('14598','2013-06-23','11:50:00',4.75),('14598','2013-06-23','11:55:00',4.78),('14598','2013-06-23','12:00:00',4.83),('14598','2013-06-23','12:05:00',4.86),('14598','2013-06-23','12:10:00',4.89),('14598','2013-06-23','12:15:00',4.93),('14598','2013-06-23','12:20:00',4.91),('14598','2013-06-23','12:25:00',5),('14598','2013-06-23','12:30:00',5.04),('14598','2013-06-23','12:35:00',5.06),('14598','2013-06-23','12:40:00',5.09),('14598','2013-06-23','12:45:00',5.1),('14598','2013-06-23','12:50:00',5.1),('14598','2013-06-23','12:55:00',5.13),('14598','2013-06-23','13:00:00',5.17),('14598','2013-06-23','13:05:00',5.19),('14598','2013-06-23','13:10:00',5.22),('14598','2013-06-23','13:15:00',5.23),('14598','2013-06-23','13:20:00',5.25),('14598','2013-06-23','13:25:00',5.26),('14598','2013-06-23','13:30:00',5.26),('14598','2013-06-23','13:35:00',5.24),('14598','2013-06-23','13:40:00',5.25),('14598','2013-06-23','13:45:00',5.25),('14598','2013-06-23','13:50:00',5.23),('14598','2013-06-23','13:55:00',5.24),('14598','2013-06-23','14:00:00',5.24),('14598','2013-06-23','14:05:00',5.22),('14598','2013-06-23','14:10:00',5.19),('14598','2013-06-23','14:15:00',5.2),('14598','2013-06-23','14:20:00',5.2),('14598','2013-06-23','14:25:00',5.24),('14598','2013-06-23','14:30:00',4.86),('14598','2013-06-23','14:35:00',5.23),('14598','2013-06-23','14:40:00',5.23),('14598','2013-06-23','14:45:00',5.1),('14598','2013-06-23','14:50:00',4.02),('14598','2013-06-23','14:55:00',4.83),('14598','2013-06-23','15:00:00',4.91),('14598','2013-06-23','15:05:00',4.89),('14598','2013-06-23','15:10:00',5.31),('14598','2013-06-23','15:15:00',4.98),('14598','2013-06-23','15:20:00',4.33),('14598','2013-06-23','15:25:00',4.68),('14598','2013-06-23','15:30:00',4.78),('14598','2013-06-23','15:35:00',4.69),('14598','2013-06-23','15:40:00',4.46),('14598','2013-06-23','15:45:00',4.75),('14598','2013-06-23','15:50:00',4.29),('14598','2013-06-23','15:55:00',4.6),('14598','2013-06-23','16:00:00',4.57),('14598','2013-06-23','16:05:00',4.35),('14598','2013-06-23','16:10:00',3.88),('14598','2013-06-23','16:15:00',4.7),('14598','2013-06-23','16:20:00',3.52),('14598','2013-06-23','16:25:00',3.65),('14598','2013-06-23','16:30:00',4.79),('14598','2013-06-23','16:35:00',2.85),('14598','2013-06-23','16:40:00',2.81),('14598','2013-06-23','16:45:00',3.5),('14598','2013-06-23','16:50:00',1.93),('14598','2013-06-23','16:55:00',3.93),('14598','2013-06-23','17:00:00',2.84),('14598','2013-06-23','17:05:00',3.32),('14598','2013-06-23','17:10:00',3.67),('14598','2013-06-23','17:15:00',3.65),('14598','2013-06-23','17:20:00',2.17),('14598','2013-06-23','17:25:00',3.44),('14598','2013-06-23','17:30:00',3.15),('14598','2013-06-23','17:35:00',2.16),('14598','2013-06-23','17:40:00',2.39),('14598','2013-06-23','17:45:00',3.13),('14598','2013-06-23','17:50:00',2.96),('14598','2013-06-23','17:55:00',2.18),('14598','2013-06-23','18:00:00',2.99),('14598','2013-06-23','18:05:00',2.95),('14598','2013-06-23','18:10:00',2.56),('14598','2013-06-23','18:15:00',2.1),('14598','2013-06-23','18:20:00',2.07),('14598','2013-06-23','18:25:00',2.33),('14598','2013-06-23','18:30:00',2.25),('14598','2013-06-23','18:35:00',2.16),('14598','2013-06-23','18:40:00',2.08),('14598','2013-06-23','18:45:00',1.82),('14598','2013-06-23','18:50:00',1.89),('14598','2013-06-23','19:00:00',1.72),('14598','2013-06-23','19:05:00',1.45),('14598','2013-06-23','19:10:00',1.1),('14598','2013-06-22','07:55:00',1.08),('14598','2013-06-22','08:00:00',1.16),('14598','2013-06-22','08:05:00',1.23),('14598','2013-06-22','08:10:00',1.31),('14598','2013-06-22','08:15:00',1.4),('14598','2013-06-22','08:20:00',1.49),('14598','2013-06-22','08:25:00',1.56),('14598','2013-06-22','08:30:00',1.63),('14598','2013-06-22','08:35:00',1.72),('14598','2013-06-22','08:40:00',1.78),('14598','2013-06-22','08:45:00',1.95),('14598','2013-06-22','08:50:00',2.03),('14598','2013-06-22','08:55:00',2.14),('14598','2013-06-22','09:00:00',2.19),('14598','2013-06-22','09:05:00',2.33),('14598','2013-06-22','09:10:00',2.44),('14598','2013-06-22','09:15:00',2.58),('14598','2013-06-22','09:20:00',2.67),('14598','2013-06-22','09:25:00',2.74),('14598','2013-06-22','09:30:00',2.81),('14598','2013-06-22','09:35:00',2.91),('14598','2013-06-22','09:40:00',3),('14598','2013-06-22','09:45:00',3.08),('14598','2013-06-22','09:50:00',3.09),('14598','2013-06-22','09:55:00',3.23),('14598','2013-06-22','10:00:00',3.31),('14598','2013-06-22','10:05:00',3.37),('14598','2013-06-22','10:10:00',3.45),('14598','2013-06-22','10:15:00',3.51),('14598','2013-06-22','10:20:00',3.54),('14598','2013-06-22','10:25:00',3.64),('14598','2013-06-22','10:30:00',3.77),('14598','2013-06-22','10:35:00',3.81),('14598','2013-06-22','10:40:00',3.86),('14598','2013-06-22','10:45:00',3.78),('14598','2013-06-22','10:50:00',4),('14598','2013-06-22','10:55:00',4.06),('14598','2013-06-22','11:00:00',4.12),('14598','2013-06-22','11:05:00',4.16),('14598','2013-06-22','11:10:00',4.22),('14598','2013-06-22','11:15:00',4.29),('14598','2013-06-22','11:20:00',4.34),('14598','2013-06-22','11:25:00',4.36),('14598','2013-06-22','11:30:00',4.44),('14598','2013-06-22','11:35:00',4.49),('14598','2013-06-22','11:40:00',4.51),('14598','2013-06-22','11:45:00',4.57),('14598','2013-06-22','11:50:00',4.63),('14598','2013-06-22','11:55:00',4.57),('14598','2013-06-22','12:00:00',4.58),('14598','2013-06-22','12:05:00',4.49),('14598','2013-06-22','12:10:00',4.05),('14598','2013-06-22','12:15:00',4.79),('14598','2013-06-22','12:20:00',4.82),('14598','2013-06-22','12:25:00',4.86),('14598','2013-06-22','12:30:00',4.89),('14598','2013-06-22','12:35:00',4.9),('14598','2013-06-22','12:40:00',4.9),('14598','2013-06-22','12:45:00',5.04),('14598','2013-06-22','12:50:00',5.09),('14598','2013-06-22','12:55:00',5.12),('14598','2013-06-22','13:00:00',4.68),('14598','2013-06-22','13:05:00',4.68),('14598','2013-06-22','13:10:00',5.42),('14598','2013-06-22','13:15:00',5.52),('14598','2013-06-22','13:20:00',5.6),('14598','2013-06-22','13:25:00',4.84),('14598','2013-06-22','13:30:00',5.46),('14598','2013-06-22','13:35:00',4.72),('14598','2013-06-22','13:40:00',4.26),('14598','2013-06-22','13:45:00',5.3),('14598','2013-06-22','13:50:00',5.61),('14598','2013-06-22','13:55:00',4.43),('14598','2013-06-22','14:00:00',5.26),('14598','2013-06-22','14:05:00',4.23),('14598','2013-06-22','14:10:00',4.49),('14598','2013-06-22','14:15:00',2.2),('14598','2013-06-22','14:20:00',2.58),('14598','2013-06-22','14:25:00',4.19),('14598','2013-06-22','14:30:00',5.93),('14598','2013-06-22','14:35:00',5.36),('14598','2013-06-22','14:40:00',4.21),('14598','2013-06-22','14:45:00',4.51),('14598','2013-06-22','14:50:00',3.84),('14598','2013-06-22','14:55:00',4.28),('14598','2013-06-22','15:00:00',5.43),('14598','2013-06-22','15:05:00',4.45),('14598','2013-06-22','15:10:00',4.64),('14598','2013-06-22','15:15:00',2.56),('14598','2013-06-22','15:20:00',1.2),('14598','2013-06-22','15:25:00',1.63),('14598','2013-06-22','15:30:00',2.03),('14598','2013-06-22','15:35:00',1.97),('14598','2013-06-22','15:40:00',1.94),('14598','2013-06-22','15:45:00',2.07),('14598','2013-06-22','15:50:00',2.03),('14598','2013-06-22','15:55:00',1.87),('14598','2013-06-22','16:00:00',1.7),('14598','2013-06-22','16:05:00',1.51),('14598','2013-06-22','16:10:00',1.5),('14598','2013-06-22','16:15:00',1.56),('14598','2013-06-22','16:20:00',1.64),('14598','2013-06-22','16:25:00',1.73),('14598','2013-06-22','16:30:00',1.66),('14598','2013-06-22','16:35:00',1.91),('14598','2013-06-22','16:40:00',2.24),('14598','2013-06-22','16:45:00',2.24),('14598','2013-06-22','16:50:00',3.97),('14598','2013-06-22','16:55:00',3.58),('14598','2013-06-22','17:00:00',2.5),('14598','2013-06-22','17:05:00',3.56),('14598','2013-06-22','17:10:00',2.43),('14598','2013-06-22','17:15:00',3.56),('14598','2013-06-22','17:20:00',3.38),('14598','2013-06-22','17:25:00',2.76),('14598','2013-06-22','17:30:00',2.51),('14598','2013-06-22','17:35:00',2.85),('14598','2013-06-22','17:40:00',2.83),('14598','2013-06-22','17:45:00',1.93),('14598','2013-06-22','17:50:00',1.76),('14598','2013-06-22','17:55:00',1.65),('14598','2013-06-22','18:00:00',1.84),('14598','2013-06-22','18:05:00',1.84),('14598','2013-06-22','18:10:00',1.61),('14598','2013-06-22','18:15:00',1.02),('14598','2013-06-22','18:25:00',1.06),('14598','2013-06-22','18:40:00',1.69),('14598','2013-06-22','18:45:00',1.59),('14598','2013-06-22','18:50:00',1.76),('14598','2013-06-22','18:55:00',1.79),('14598','2013-06-22','19:00:00',1.91),('14598','2013-06-22','19:05:00',1.75),('14598','2013-06-22','19:10:00',1.58),('14598','2013-06-22','19:15:00',1.31),('14598','2013-06-21','07:50:00',1.01),('14598','2013-06-21','07:55:00',1.09),('14598','2013-06-21','08:00:00',1.16),('14598','2013-06-21','08:05:00',1.23),('14598','2013-06-21','08:10:00',1.31),('14598','2013-06-21','08:15:00',1.39),('14598','2013-06-21','08:20:00',1.49),('14598','2013-06-21','08:25:00',1.57),('14598','2013-06-21','08:30:00',1.65),('14598','2013-06-21','08:35:00',1.75),('14598','2013-06-21','08:40:00',1.83),('14598','2013-06-21','08:45:00',1.94),('14598','2013-06-21','08:50:00',2.05),('14598','2013-06-21','08:55:00',2.15),('14598','2013-06-21','09:00:00',2.25),('14598','2013-06-21','09:05:00',2.35),('14598','2013-06-21','09:10:00',2.43),('14598','2013-06-21','09:15:00',2.5),('14598','2013-06-21','09:20:00',2.61),('14598','2013-06-21','09:25:00',2.67),('14598','2013-06-21','09:30:00',2.74),('14598','2013-06-21','09:35:00',2.83),('14598','2013-06-21','09:40:00',2.96),('14598','2013-06-21','09:45:00',3.02),('14598','2013-06-21','09:50:00',3.08),('14598','2013-06-21','09:55:00',3.18),('14598','2013-06-21','10:00:00',3.25),('14598','2013-06-21','10:05:00',3.3),('14598','2013-06-21','10:10:00',3.38),('14598','2013-06-21','10:15:00',3.46),('14598','2013-06-21','10:20:00',3.55),('14598','2013-06-21','10:25:00',3.64),('14598','2013-06-21','10:30:00',3.71),('14598','2013-06-21','10:35:00',3.77),('14598','2013-06-21','10:40:00',3.84),('14598','2013-06-21','10:45:00',3.91),('14598','2013-06-21','10:50:00',3.98),('14598','2013-06-21','10:55:00',4.04),('14598','2013-06-21','11:00:00',4.1),('14598','2013-06-21','11:05:00',4.14),('14598','2013-06-21','11:10:00',4.21),('14598','2013-06-21','11:15:00',4.27),('14598','2013-06-21','11:20:00',4.32),('14598','2013-06-21','11:25:00',4.37),('14598','2013-06-21','11:30:00',4.44),('14598','2013-06-21','11:35:00',4.5),('14598','2013-06-21','11:40:00',4.55),('14598','2013-06-21','11:45:00',4.59),('14598','2013-06-21','11:50:00',4.63),('14598','2013-06-21','11:55:00',4.66),('14598','2013-06-21','12:00:00',4.69),('14598','2013-06-21','12:05:00',4.72),('14598','2013-06-21','12:10:00',4.75),('14598','2013-06-21','12:15:00',4.76),('14598','2013-06-21','12:20:00',4.81),('14598','2013-06-21','12:25:00',4.84),('14598','2013-06-21','12:30:00',4.88),('14598','2013-06-21','12:35:00',4.91),('14598','2013-06-21','12:40:00',4.95),('14598','2013-06-21','12:45:00',4.94),('14598','2013-06-21','12:50:00',4.88),('14598','2013-06-21','12:55:00',4.95),('14598','2013-06-21','13:00:00',4.96),('14598','2013-06-21','13:05:00',4.97),('14598','2013-06-21','13:10:00',4.99),('14598','2013-06-21','13:15:00',5.01),('14598','2013-06-21','13:20:00',5.03),('14598','2013-06-21','13:25:00',5.05),('14598','2013-06-21','13:30:00',5.04),('14598','2013-06-21','13:35:00',5.07),('14598','2013-06-21','13:40:00',5.05),('14598','2013-06-21','13:45:00',5.05),('14598','2013-06-21','13:50:00',5.07),('14598','2013-06-21','13:55:00',5.06),('14598','2013-06-21','14:00:00',5.06),('14598','2013-06-21','14:05:00',5.04),('14598','2013-06-21','14:10:00',5.03),('14598','2013-06-21','14:15:00',5.02),('14598','2013-06-21','14:20:00',4.97),('14598','2013-06-21','14:25:00',4.95),('14598','2013-06-21','14:30:00',4.96),('14598','2013-06-21','14:35:00',4.91),('14598','2013-06-21','14:40:00',4.92),('14598','2013-06-21','14:45:00',4.9),('14598','2013-06-21','14:50:00',4.87),('14598','2013-06-21','14:55:00',4.86),('14598','2013-06-21','15:00:00',4.83),('14598','2013-06-21','15:05:00',4.83),('14598','2013-06-21','15:10:00',4.78),('14598','2013-06-21','15:15:00',4.73),('14598','2013-06-21','15:20:00',4.7),('14598','2013-06-21','15:25:00',4.68),('14598','2013-06-21','15:30:00',4.65),('14598','2013-06-21','15:35:00',4.61),('14598','2013-06-21','15:40:00',4.58),('14598','2013-06-21','15:45:00',4.55),('14598','2013-06-21','15:50:00',4.5),('14598','2013-06-21','15:55:00',4.42),('14598','2013-06-21','16:00:00',4.41),('14598','2013-06-21','16:05:00',4.36),('14598','2013-06-21','16:10:00',4.31),('14598','2013-06-21','16:15:00',4.26),('14598','2013-06-21','16:20:00',4.22),('14598','2013-06-21','16:25:00',4.14),('14598','2013-06-21','16:30:00',4.06),('14598','2013-06-21','16:35:00',4.01),('14598','2013-06-21','16:40:00',3.95),('14598','2013-06-21','16:45:00',3.92),('14598','2013-06-21','16:50:00',3.82),('14598','2013-06-21','16:55:00',3.77),('14598','2013-06-21','17:00:00',3.68),('14598','2013-06-21','17:05:00',3.6),('14598','2013-06-21','17:10:00',3.5),('14598','2013-06-21','17:15:00',3.43),('14598','2013-06-21','17:20:00',3.34),('14598','2013-06-21','17:25:00',3.26),('14598','2013-06-21','17:30:00',3.17),('14598','2013-06-21','17:35:00',3.1),('14598','2013-06-21','17:40:00',2.95),('14598','2013-06-21','17:45:00',2.94),('14598','2013-06-21','17:50:00',2.87),('14598','2013-06-21','17:55:00',2.79),('14598','2013-06-21','18:00:00',2.68),('14598','2013-06-21','18:05:00',2.59),('14598','2013-06-21','18:10:00',2.48),('14598','2013-06-21','18:15:00',2.39),('14598','2013-06-21','18:20:00',2.26),('14598','2013-06-21','18:25:00',2.13),('14598','2013-06-21','18:30:00',2.03),('14598','2013-06-21','18:35:00',1.95),('14598','2013-06-21','18:40:00',1.85),('14598','2013-06-21','18:45:00',1.75),('14598','2013-06-21','18:50:00',1.66),('14598','2013-06-21','18:55:00',1.54),('14598','2013-06-21','19:00:00',1.44),('14598','2013-06-21','19:05:00',1.31),('14598','2013-06-21','19:10:00',1.18),('14598','2013-06-21','19:15:00',1.07),('14598','2014-04-04','08:45:00',1.36),('14598','2014-04-04','08:50:00',1.59),('14598','2014-04-04','08:55:00',1.48),('14598','2014-04-04','09:00:00',1.1),('14598','2014-04-04','09:55:00',1.11),('14598','2014-04-04','10:00:00',1.26),('14598','2014-04-04','12:15:00',1.01),('14598','2014-04-04','12:20:00',1.08),('14598','2014-04-04','12:35:00',1.37),('14598','2014-04-04','12:40:00',2.06),('14598','2014-04-04','12:45:00',2.17),('14598','2014-04-04','12:50:00',2.59),('14598','2014-04-04','12:55:00',3.17),('14598','2014-04-04','13:00:00',3.51),('14598','2014-04-04','13:05:00',3.91),('14598','2014-04-04','13:10:00',3.3),('14598','2014-04-04','13:15:00',3.14),('14598','2014-04-04','13:20:00',4.98),('14598','2014-04-04','13:25:00',4.91),('14598','2014-04-04','13:30:00',5.22),('14598','2014-04-04','13:35:00',5.56),('14598','2014-04-04','13:40:00',3.56),('14598','2014-04-04','13:45:00',3.51),('14598','2014-04-04','13:50:00',5.26),('14598','2014-04-04','13:55:00',4.71),('14598','2014-04-04','14:00:00',3.97),('14598','2014-04-04','14:05:00',4.97),('14598','2014-04-04','14:10:00',4.81),('14598','2014-04-04','14:15:00',4.81),('14598','2014-04-04','14:20:00',4.81),('14598','2014-04-04','14:25:00',4.83),('14598','2014-04-04','14:30:00',4.24),('14598','2014-04-04','14:35:00',2.51),('14598','2014-04-04','14:40:00',3.95),('14598','2014-04-04','14:45:00',4.59),('14598','2014-04-04','14:50:00',2.96),('14598','2014-04-04','14:55:00',2.53),('14598','2014-04-04','15:00:00',3.41),('14598','2014-04-04','15:05:00',2.94),('14598','2014-04-04','15:10:00',4.77),('14598','2014-04-04','15:15:00',2.87),('14598','2014-04-04','15:20:00',4.4),('14598','2014-04-04','15:25:00',3.97),('14598','2014-04-04','15:30:00',2.25),('14598','2014-04-04','15:35:00',4.13),('14598','2014-04-04','15:40:00',4.6),('14598','2014-04-04','15:45:00',4.28),('14598','2014-04-04','15:50:00',4.26),('14598','2014-04-04','15:55:00',4.2),('14598','2014-04-04','16:00:00',4.19),('14598','2014-04-04','16:05:00',3.97),('14598','2014-04-04','16:10:00',4.02),('14598','2014-04-04','16:15:00',3.94),('14598','2014-04-04','16:20:00',3.9),('14598','2014-04-04','16:25:00',3.72),('14598','2014-04-04','16:30:00',3.86),('14598','2014-04-04','16:35:00',3.73),('14598','2014-04-04','16:40:00',3.63),('14598','2014-04-04','16:45:00',3.54),('14598','2014-04-04','16:50:00',2.33),('14598','2014-04-04','16:55:00',2.49),('14598','2014-04-04','17:00:00',2.1),('14598','2014-04-04','17:05:00',3.24),('14598','2014-04-04','17:10:00',2.96),('14598','2014-04-04','17:15:00',3),('14598','2014-04-04','17:20:00',2.98),('14598','2014-04-04','17:25:00',2.81),('14598','2014-04-04','17:30:00',2.63),('14598','2014-04-04','17:35:00',2.57),('14598','2014-04-04','17:40:00',2.42),('14598','2014-04-04','17:45:00',2.25),('14598','2014-04-04','17:50:00',2.14),('14598','2014-04-04','17:55:00',1.99),('14598','2014-04-04','18:00:00',1.61),('14598','2014-04-04','18:05:00',1.72),('14598','2014-04-04','18:10:00',1.65),('14598','2014-04-04','18:15:00',1.64),('14598','2014-04-04','18:20:00',1.46),('14598','2014-04-04','18:25:00',1.3),('14598','2014-04-04','18:30:00',1.13),('14598','2013-06-20','07:55:00',1.07),('14598','2013-06-20','08:00:00',1.14),('14598','2013-06-20','08:05:00',1.23),('14598','2013-06-20','08:10:00',1.32),('14598','2013-06-20','08:15:00',1.42),('14598','2013-06-20','08:20:00',1.51),('14598','2013-06-20','08:25:00',1.6),('14598','2013-06-20','08:30:00',1.67),('14598','2013-06-20','08:35:00',1.78),('14598','2013-06-20','08:40:00',1.85),('14598','2013-06-20','08:45:00',1.98),('14598','2013-06-20','08:50:00',2.09),('14598','2013-06-20','08:55:00',2.17),('14598','2013-06-20','09:00:00',2.28),('14598','2013-06-20','09:05:00',2.35),('14598','2013-06-20','09:10:00',2.44),('14598','2013-06-20','09:15:00',2.55),('14598','2013-06-20','09:20:00',2.64),('14598','2013-06-20','09:25:00',2.71),('14598','2013-06-20','09:30:00',2.79),('14598','2013-06-20','09:35:00',2.89),('14598','2013-06-20','09:40:00',2.97),('14598','2013-06-20','09:45:00',3.03),('14598','2013-06-20','09:50:00',3.11),('14598','2013-06-20','09:55:00',3.2),('14598','2013-06-20','10:00:00',3.25),('14598','2013-06-20','10:05:00',3.36),('14598','2013-06-20','10:10:00',3.4),('14598','2013-06-20','10:15:00',3.45),('14598','2013-06-20','10:20:00',3.5),('14598','2013-06-20','10:25:00',3.55),('14598','2013-06-20','10:30:00',3.65),('14598','2013-06-20','10:35:00',3.78),('14598','2013-06-20','10:40:00',3.84),('14598','2013-06-20','10:45:00',3.93),('14598','2013-06-20','10:50:00',4),('14598','2013-06-20','10:55:00',4.06),('14598','2013-06-20','11:00:00',4.11),('14598','2013-06-20','11:05:00',4.14),('14598','2013-06-20','11:10:00',4.23),('14598','2013-06-20','11:15:00',4.28),('14598','2013-06-20','11:20:00',4.33),('14598','2013-06-20','11:25:00',4.38),('14598','2013-06-20','11:30:00',4.42),('14598','2013-06-20','11:35:00',4.47),('14598','2013-06-20','11:40:00',4.51),('14598','2013-06-20','11:45:00',4.54),('14598','2013-06-20','11:50:00',4.59),('14598','2013-06-20','11:55:00',4.62),('14598','2013-06-20','12:00:00',4.63),('14598','2013-06-20','12:05:00',4.65),('14598','2013-06-20','12:10:00',4.68),('14598','2013-06-20','12:15:00',4.75),('14598','2013-06-20','12:20:00',4.76),('14598','2013-06-20','12:25:00',4.82),('14598','2013-06-20','12:30:00',4.86),('14598','2013-06-20','12:35:00',4.88),('14598','2013-06-20','12:40:00',4.88),('14598','2013-06-20','12:45:00',4.91),('14598','2013-06-20','12:50:00',4.95),('14598','2013-06-20','12:55:00',4.98),('14598','2013-06-20','13:00:00',5),('14598','2013-06-20','13:05:00',5.02),('14598','2013-06-20','13:10:00',5.04),('14598','2013-06-20','13:15:00',5.06),('14598','2013-06-20','13:20:00',5.07),('14598','2013-06-20','13:25:00',5.08),('14598','2013-06-20','13:30:00',5.09),('14598','2013-06-20','13:35:00',5.11),('14598','2013-06-20','13:40:00',5.12),('14598','2013-06-20','13:45:00',5.12),('14598','2013-06-20','13:50:00',5.14),('14598','2013-06-20','13:55:00',5.17),('14598','2013-06-20','14:00:00',5.17),('14598','2013-06-20','14:05:00',5.1),('14598','2013-06-20','14:10:00',5.17),('14598','2013-06-20','14:15:00',5.14),('14598','2013-06-20','14:20:00',5.14),('14598','2013-06-20','14:25:00',5.11),('14598','2013-06-20','14:30:00',5.09),('14598','2013-06-20','14:35:00',5.09),('14598','2013-06-20','14:40:00',5.06),('14598','2013-06-20','14:45:00',5.05),('14598','2013-06-20','14:50:00',5.01),('14598','2013-06-20','14:55:00',4.97),('14598','2013-06-20','15:00:00',4.93),('14598','2013-06-20','15:05:00',4.88),('14598','2013-06-20','15:10:00',4.8),('14598','2013-06-20','15:15:00',4.75),('14598','2013-06-20','15:20:00',4.68),('14598','2013-06-20','15:25:00',4.66),('14598','2013-06-20','15:30:00',4.66),('14598','2013-06-20','15:35:00',4.65),('14598','2013-06-20','15:40:00',4.6),('14598','2013-06-20','15:45:00',4.56),('14598','2013-06-20','15:50:00',4.47),('14598','2013-06-20','15:55:00',4.43),('14598','2013-06-20','16:00:00',4.38),('14598','2013-06-20','16:05:00',4.39),('14598','2013-06-20','16:10:00',4.34),('14598','2013-06-20','16:15:00',4.29),('14598','2013-06-20','16:20:00',4.23),('14598','2013-06-20','16:25:00',4.16),('14598','2013-06-20','16:30:00',4.11),('14598','2013-06-20','16:35:00',4.05),('14598','2013-06-20','16:40:00',3.99),('14598','2013-06-20','16:45:00',3.95),('14598','2013-06-20','16:50:00',3.88),('14598','2013-06-20','16:55:00',3.81),('14598','2013-06-20','17:00:00',3.74),('14598','2013-06-20','17:05:00',3.65),('14598','2013-06-20','17:10:00',3.6),('14598','2013-06-20','17:15:00',3.52),('14598','2013-06-20','17:20:00',3.45),('14598','2013-06-20','17:25:00',3.37),('14598','2013-06-20','17:30:00',3.29),('14598','2013-06-20','17:35:00',3.2),('14598','2013-06-20','17:40:00',3.11),('14598','2013-06-20','17:45:00',3.03),('14598','2013-06-20','17:50:00',2.94),('14598','2013-06-20','17:55:00',2.84),('14598','2013-06-20','18:00:00',2.73),('14598','2013-06-20','18:05:00',2.64),('14598','2013-06-20','18:10:00',2.55),('14598','2013-06-20','18:15:00',2.44),('14598','2013-06-20','18:20:00',2.33),('14598','2013-06-20','18:25:00',2.24),('14598','2013-06-20','18:30:00',2.13),('14598','2013-06-20','18:35:00',2.03),('14598','2013-06-20','18:40:00',1.93),('14598','2013-06-20','18:45:00',1.84),('14598','2013-06-20','18:50:00',1.74),('14598','2013-06-20','18:55:00',1.59),('14598','2013-06-20','19:00:00',1.52),('14598','2013-06-20','19:05:00',1.42),('14598','2013-06-20','19:10:00',1.32),('14598','2013-06-20','19:15:00',1.23),('14598','2013-06-20','19:20:00',1.15),('14598','2013-06-20','19:25:00',1.05),('14598','2013-06-19','07:55:00',1.06),('14598','2013-06-19','08:00:00',1.14),('14598','2013-06-19','08:05:00',1.22),('14598','2013-06-19','08:10:00',1.3),('14598','2013-06-19','08:15:00',1.39),('14598','2013-06-19','08:20:00',1.47),('14598','2013-06-19','08:25:00',1.55),('14598','2013-06-19','08:30:00',1.64),('14598','2013-06-19','08:35:00',1.74),('14598','2013-06-19','08:40:00',1.84),('14598','2013-06-19','08:45:00',1.95),('14598','2013-06-19','08:50:00',2.05),('14598','2013-06-19','08:55:00',2.15),('14598','2013-06-19','09:00:00',2.22),('14598','2013-06-19','09:05:00',2.32),('14598','2013-06-19','09:10:00',2.39),('14598','2013-06-19','09:15:00',2.49),('14598','2013-06-19','09:20:00',2.59),('14598','2013-06-19','09:25:00',2.66),('14598','2013-06-19','09:30:00',2.74),('14598','2013-06-19','09:35:00',2.82),('14598','2013-06-19','09:40:00',2.89),('14598','2013-06-19','09:45:00',2.96),('14598','2013-06-19','09:50:00',3.04),('14598','2013-06-19','09:55:00',3.11),('14598','2013-06-19','10:00:00',3.17),('14598','2013-06-19','10:05:00',3.25),('14598','2013-06-19','10:10:00',3.33),('14598','2013-06-19','10:15:00',3.44),('14598','2013-06-19','10:20:00',3.48),('14598','2013-06-19','10:25:00',3.57),('14598','2013-06-19','10:30:00',3.65),('14598','2013-06-19','10:35:00',3.7),('14598','2013-06-19','10:40:00',3.75),('14598','2013-06-19','10:45:00',3.81),('14598','2013-06-19','10:50:00',3.88),('14598','2013-06-19','10:55:00',3.95),('14598','2013-06-19','11:00:00',4.01),('14598','2013-06-19','11:05:00',4.07),('14598','2013-06-19','11:10:00',4.13),('14598','2013-06-19','11:15:00',4.18),('14598','2013-06-19','11:20:00',4.23),('14598','2013-06-19','11:25:00',4.29),('14598','2013-06-19','11:30:00',4.34),('14598','2013-06-19','11:35:00',4.37),('14598','2013-06-19','11:40:00',4.42),('14598','2013-06-19','11:45:00',4.47),('14598','2013-06-19','11:50:00',4.5),('14598','2013-06-19','11:55:00',4.51),('14598','2013-06-19','12:00:00',4.55),('14598','2013-06-19','12:05:00',4.51),('14598','2013-06-19','12:10:00',4.63),('14598','2013-06-19','12:15:00',4.65),('14598','2013-06-19','12:20:00',4.69),('14598','2013-06-19','12:25:00',4.72),('14598','2013-06-19','12:30:00',4.75),('14598','2013-06-19','12:35:00',4.79),('14598','2013-06-19','12:40:00',4.81),('14598','2013-06-19','12:45:00',4.82),('14598','2013-06-19','12:50:00',4.84),('14598','2013-06-19','12:55:00',4.88),('14598','2013-06-19','13:00:00',4.89),('14598','2013-06-19','13:05:00',4.93),('14598','2013-06-19','13:10:00',4.96),('14598','2013-06-19','13:15:00',4.97),('14598','2013-06-19','13:20:00',4.96),('14598','2013-06-19','13:25:00',4.98),('14598','2013-06-19','13:30:00',4.99),('14598','2013-06-19','13:35:00',4.99),('14598','2013-06-19','13:40:00',4.97),('14598','2013-06-19','13:45:00',4.98),('14598','2013-06-19','13:50:00',4.94),('14598','2013-06-19','13:55:00',4.92),('14598','2013-06-19','14:00:00',4.92),('14598','2013-06-19','14:05:00',4.92),('14598','2013-06-19','14:10:00',4.9),('14598','2013-06-19','14:15:00',4.88),('14598','2013-06-19','14:20:00',4.87),('14598','2013-06-19','14:25:00',4.87),('14598','2013-06-19','14:30:00',4.84),('14598','2013-06-19','14:35:00',4.83),('14598','2013-06-19','14:40:00',4.8),('14598','2013-06-19','14:45:00',4.8),('14598','2013-06-19','14:50:00',4.78),('14598','2013-06-19','14:55:00',4.75),('14598','2013-06-19','15:00:00',4.71),('14598','2013-06-19','15:05:00',4.63),('14598','2013-06-19','15:10:00',4.64),('14598','2013-06-19','15:15:00',4.62),('14598','2013-06-19','15:20:00',4.58),('14598','2013-06-19','15:25:00',4.55),('14598','2013-06-19','15:30:00',4.53),('14598','2013-06-19','15:35:00',4.48),('14598','2013-06-19','15:40:00',4.45),('14598','2013-06-19','15:45:00',4.4),('14598','2013-06-19','15:50:00',4.36),('14598','2013-06-19','15:55:00',4.32),('14598','2013-06-19','16:00:00',4.27),('14598','2013-06-19','16:05:00',4.23),('14598','2013-06-19','16:10:00',4.2),('14598','2013-06-19','16:15:00',4.14),('14598','2013-06-19','16:20:00',4.07),('14598','2013-06-19','16:25:00',4.02),('14598','2013-06-19','16:30:00',3.98),('14598','2013-06-19','16:35:00',3.93),('14598','2013-06-19','16:40:00',3.89),('14598','2013-06-19','16:45:00',3.84),('14598','2013-06-19','16:50:00',3.78),('14598','2013-06-19','16:55:00',3.72),('14598','2013-06-19','17:00:00',3.64),('14598','2013-06-19','17:05:00',3.54),('14598','2013-06-19','17:10:00',3.47),('14598','2013-06-19','17:15:00',3.38),('14598','2013-06-19','17:20:00',3.31),('14598','2013-06-19','17:25:00',3.24),('14598','2013-06-19','17:30:00',3.16),('14598','2013-06-19','17:35:00',3.07),('14598','2013-06-19','17:40:00',2.99),('14598','2013-06-19','17:45:00',2.91),('14598','2013-06-19','17:50:00',2.81),('14598','2013-06-19','17:55:00',2.74),('14598','2013-06-19','18:00:00',2.64),('14598','2013-06-19','18:05:00',2.55),('14598','2013-06-19','18:10:00',2.42),('14598','2013-06-19','18:15:00',2.34),('14598','2013-06-19','18:20:00',2.24),('14598','2013-06-19','18:25:00',2.15),('14598','2013-06-19','18:30:00',2.06),('14598','2013-06-19','18:35:00',1.98),('14598','2013-06-19','18:40:00',1.88),('14598','2013-06-19','18:45:00',1.79),('14598','2013-06-19','18:50:00',1.68),('14598','2013-06-19','18:55:00',1.57),('14598','2013-06-19','19:00:00',1.47),('14598','2013-06-19','19:05:00',1.37),('14598','2013-06-19','19:10:00',1.26),('14598','2013-06-19','19:15:00',1.17),('14598','2013-06-19','19:20:00',1.07),('14598','2013-06-18','07:55:00',1.04),('14598','2013-06-18','08:00:00',1.13),('14598','2013-06-18','08:05:00',1.21),('14598','2013-06-18','08:10:00',1.29),('14598','2013-06-18','08:15:00',1.37),('14598','2013-06-18','08:20:00',1.46),('14598','2013-06-18','08:25:00',1.55),('14598','2013-06-18','08:30:00',1.64),('14598','2013-06-18','08:35:00',1.74),('14598','2013-06-18','08:40:00',1.84),('14598','2013-06-18','08:45:00',1.96),('14598','2013-06-18','08:50:00',2.06),('14598','2013-06-18','08:55:00',2.17),('14598','2013-06-18','09:00:00',2.22),('14598','2013-06-18','09:05:00',2.34),('14598','2013-06-18','09:10:00',2.42),('14598','2013-06-18','09:15:00',2.52),('14598','2013-06-18','09:20:00',2.61),('14598','2013-06-18','09:25:00',2.68),('14598','2013-06-18','09:30:00',2.75),('14598','2013-06-18','09:35:00',2.82),('14598','2013-06-18','09:40:00',2.89),('14598','2013-06-18','09:45:00',2.97),('14598','2013-06-18','09:50:00',3.06),('14598','2013-06-18','09:55:00',3.11),('14598','2013-06-18','10:00:00',3.16),('14598','2013-06-18','10:05:00',3.23),('14598','2013-06-18','10:10:00',3.3),('14598','2013-06-18','10:15:00',3.37),('14598','2013-06-18','10:20:00',3.41),('14598','2013-06-18','10:25:00',3.52),('14598','2013-06-18','10:30:00',3.59),('14598','2013-06-18','10:35:00',3.65),('14598','2013-06-18','10:40:00',3.72),('14598','2013-06-18','10:45:00',3.78),('14598','2013-06-18','10:50:00',3.82),('14598','2013-06-18','10:55:00',3.89),('14598','2013-06-18','11:00:00',3.98),('14598','2013-06-18','11:05:00',4.05),('14598','2013-06-18','11:10:00',4.08),('14598','2013-06-18','11:15:00',4.12),('14598','2013-06-18','11:20:00',4.17),('14598','2013-06-18','11:25:00',4.2),('14598','2013-06-18','11:30:00',4.24),('14598','2013-06-18','11:35:00',4.3),('14598','2013-06-18','11:40:00',4.35),('14598','2013-06-18','11:45:00',4.41),('14598','2013-06-18','11:50:00',4.47),('14598','2013-06-18','11:55:00',4.54),('14598','2013-06-18','12:00:00',4.57),('14598','2013-06-18','12:05:00',4.58),('14598','2013-06-18','12:10:00',4.64),('14598','2013-06-18','12:15:00',4.69),('14598','2013-06-18','12:20:00',4.72),('14598','2013-06-18','12:25:00',4.73),('14598','2013-06-18','12:30:00',4.79),('14598','2013-06-18','12:35:00',4.82),('14598','2013-06-18','12:40:00',4.84),('14598','2013-06-18','12:45:00',4.87),('14598','2013-06-18','12:50:00',4.91),('14598','2013-06-18','12:55:00',4.91),('14598','2013-06-18','13:00:00',4.92),('14598','2013-06-18','13:05:00',4.93),('14598','2013-06-18','13:10:00',4.93),('14598','2013-06-18','13:15:00',4.95),('14598','2013-06-18','13:20:00',4.94),('14598','2013-06-18','13:25:00',4.97),('14598','2013-06-18','13:30:00',4.99),('14598','2013-06-18','13:35:00',5.02),('14598','2013-06-18','13:40:00',5.05),('14598','2013-06-18','13:45:00',5.06),('14598','2013-06-18','13:50:00',5.06),('14598','2013-06-18','13:55:00',5.06),('14598','2013-06-18','14:00:00',5.07),('14598','2013-06-18','14:05:00',5.07),('14598','2013-06-18','14:10:00',5.07),('14598','2013-06-18','14:15:00',5.06),('14598','2013-06-18','14:20:00',5.06),('14598','2013-06-18','14:25:00',5.06),('14598','2013-06-18','14:30:00',5.05),('14598','2013-06-18','14:35:00',5.05),('14598','2013-06-18','14:40:00',5.05),('14598','2013-06-18','14:45:00',5.03),('14598','2013-06-18','14:50:00',5.03),('14598','2013-06-18','14:55:00',4.99),('14598','2013-06-18','15:00:00',4.95),('14598','2013-06-18','15:05:00',4.84),('14598','2013-06-18','15:10:00',4.82),('14598','2013-06-18','15:15:00',4.76),('14598','2013-06-18','15:20:00',4.73),('14598','2013-06-18','15:25:00',4.69),('14598','2013-06-18','15:30:00',4.64),('14598','2013-06-18','15:35:00',4.62),('14598','2013-06-18','15:40:00',4.57),('14598','2013-06-18','15:45:00',4.51),('14598','2013-06-18','15:50:00',4.47),('14598','2013-06-18','15:55:00',4.43),('14598','2013-06-18','16:00:00',4.41),('14598','2013-06-18','16:05:00',4.34),('14598','2013-06-18','16:10:00',4.31),('14598','2013-06-18','16:15:00',4.24),('14598','2013-06-18','16:20:00',4.18),('14598','2013-06-18','16:25:00',4.13),('14598','2013-06-18','16:30:00',4.07),('14598','2013-06-18','16:35:00',4.03),('14598','2013-06-18','16:40:00',3.96),('14598','2013-06-18','16:45:00',3.89),('14598','2013-06-18','16:50:00',3.8),('14598','2013-06-18','16:55:00',3.78),('14598','2013-06-18','17:00:00',3.71),('14598','2013-06-18','17:05:00',3.62),('14598','2013-06-18','17:10:00',3.53),('14598','2013-06-18','17:15:00',3.45),('14598','2013-06-18','17:20:00',3.38),('14598','2013-06-18','17:25:00',3.3),('14598','2013-06-18','17:30:00',3.2),('14598','2013-06-18','17:35:00',3.11),('14598','2013-06-18','17:40:00',3.01),('14598','2013-06-18','17:45:00',2.93),('14598','2013-06-18','17:50:00',2.83),('14598','2013-06-18','17:55:00',2.75),('14598','2013-06-18','18:00:00',2.67),('14598','2013-06-18','18:05:00',2.54),('14598','2013-06-18','18:10:00',2.46),('14598','2013-06-18','18:15:00',2.35),('14598','2013-06-18','18:20:00',2.27),('14598','2013-06-18','18:25:00',2.19),('14598','2013-06-18','18:30:00',2.1),('14598','2013-06-18','18:35:00',1.98),('14598','2013-06-18','18:40:00',1.88),('14598','2013-06-18','18:45:00',1.79),('14598','2013-06-18','18:50:00',1.69),('14598','2013-06-18','18:55:00',1.59),('14598','2013-06-18','19:00:00',1.5),('14598','2013-06-18','19:05:00',1.38),('14598','2013-06-18','19:10:00',1.28),('14598','2013-06-18','19:15:00',1.18),('14598','2013-06-18','19:20:00',1.09),('14598','2013-06-17','07:50:00',1.01),('14598','2013-06-17','07:55:00',1.09),('14598','2013-06-17','08:00:00',1.16),('14598','2013-06-17','08:05:00',1.25),('14598','2013-06-17','08:10:00',1.33),('14598','2013-06-17','08:15:00',1.41),('14598','2013-06-17','08:20:00',1.5),('14598','2013-06-17','08:25:00',1.59),('14598','2013-06-17','08:30:00',1.69),('14598','2013-06-17','08:35:00',1.8),('14598','2013-06-17','08:40:00',1.88),('14598','2013-06-17','08:45:00',2.02),('14598','2013-06-17','08:50:00',2.11),('14598','2013-06-17','08:55:00',2.21),('14598','2013-06-17','09:00:00',2.29),('14598','2013-06-17','09:05:00',2.39),('14598','2013-06-17','09:10:00',2.48),('14598','2013-06-17','09:15:00',2.56),('14598','2013-06-17','09:20:00',2.66),('14598','2013-06-17','09:25:00',2.73),('14598','2013-06-17','09:30:00',2.83),('14598','2013-06-17','09:35:00',2.9),('14598','2013-06-17','09:40:00',3.02),('14598','2013-06-17','09:45:00',3.1),('14598','2013-06-17','09:50:00',3.17),('14598','2013-06-17','09:55:00',3.25),('14598','2013-06-17','10:00:00',3.31),('14598','2013-06-17','10:05:00',3.39),('14598','2013-06-17','10:10:00',3.48),('14598','2013-06-17','10:15:00',3.56),('14598','2013-06-17','10:20:00',3.63),('14598','2013-06-17','10:25:00',3.7),('14598','2013-06-17','10:30:00',3.77),('14598','2013-06-17','10:35:00',3.85),('14598','2013-06-17','10:40:00',3.9),('14598','2013-06-17','10:45:00',3.97),('14598','2013-06-17','10:50:00',4.03),('14598','2013-06-17','10:55:00',4.1),('14598','2013-06-17','11:00:00',4.17),('14598','2013-06-17','11:05:00',4.21),('14598','2013-06-17','11:10:00',4.27),('14598','2013-06-17','11:15:00',4.32),('14598','2013-06-17','11:20:00',4.34),('14598','2013-06-17','11:25:00',4.39),('14598','2013-06-17','11:30:00',4.45),('14598','2013-06-17','11:35:00',4.5),('14598','2013-06-17','11:40:00',4.56),('14598','2013-06-17','11:45:00',4.62),('14598','2013-06-17','11:50:00',4.66),('14598','2013-06-17','11:55:00',4.7),('14598','2013-06-17','12:00:00',4.73),('14598','2013-06-17','12:05:00',4.76),('14598','2013-06-17','12:10:00',4.82),('14598','2013-06-17','12:15:00',4.86),('14598','2013-06-17','12:20:00',4.88),('14598','2013-06-17','12:25:00',4.9),('14598','2013-06-17','12:30:00',4.91),('14598','2013-06-17','12:35:00',4.87),('14598','2013-06-17','12:40:00',4.96),('14598','2013-06-17','12:45:00',5),('14598','2013-06-17','12:50:00',5.01),('14598','2013-06-17','12:55:00',5.02),('14598','2013-06-17','13:00:00',5.04),('14598','2013-06-17','13:05:00',5.02),('14598','2013-06-17','13:10:00',5.05),('14598','2013-06-17','13:15:00',5.03),('14598','2013-06-17','13:20:00',5.05),('14598','2013-06-17','13:25:00',5.05),('14598','2013-06-17','13:30:00',5.07),('14598','2013-06-17','13:35:00',5.06),('14598','2013-06-17','13:40:00',5.07),('14598','2013-06-17','13:45:00',5.05),('14598','2013-06-17','13:50:00',5.03),('14598','2013-06-17','13:55:00',5.04),('14598','2013-06-17','14:00:00',5.05),('14598','2013-06-17','14:05:00',5.05),('14598','2013-06-17','14:10:00',5.03),('14598','2013-06-17','14:15:00',5.02),('14598','2013-06-17','14:20:00',5.01),('14598','2013-06-17','14:25:00',5.01),('14598','2013-06-17','14:30:00',4.97),('14598','2013-06-17','14:35:00',4.95),('14598','2013-06-17','14:40:00',4.92),('14598','2013-06-17','14:45:00',4.93),('14598','2013-06-17','14:50:00',4.91),('14598','2013-06-17','14:55:00',4.89),('14598','2013-06-17','15:00:00',4.85),('14598','2013-06-17','15:05:00',4.82),('14598','2013-06-17','15:10:00',4.78),('14598','2013-06-17','15:15:00',4.74),('14598','2013-06-17','15:20:00',4.72),('14598','2013-06-17','15:25:00',4.67),('14598','2013-06-17','15:30:00',4.65),('14598','2013-06-17','15:35:00',4.59),('14598','2013-06-17','15:40:00',4.6),('14598','2013-06-17','15:45:00',4.57),('14598','2013-06-17','15:50:00',4.52),('14598','2013-06-17','15:55:00',4.49),('14598','2013-06-17','16:00:00',4.43),('14598','2013-06-17','16:05:00',4.37),('14598','2013-06-17','16:10:00',4.31),('14598','2013-06-17','16:15:00',4.25),('14598','2013-06-17','16:20:00',4.18),('14598','2013-06-17','16:25:00',4.1),('14598','2013-06-17','16:30:00',4.05),('14598','2013-06-17','16:35:00',3.98),('14598','2013-06-17','16:40:00',3.92),('14598','2013-06-17','16:45:00',3.86),('14598','2013-06-17','16:50:00',3.8),('14598','2013-06-17','16:55:00',3.76),('14598','2013-06-17','17:00:00',3.7),('14598','2013-06-17','17:05:00',3.64),('14598','2013-06-17','17:10:00',3.56),('14598','2013-06-17','17:15:00',3.47),('14598','2013-06-17','17:20:00',3.38),('14598','2013-06-17','17:25:00',3.3),('14598','2013-06-17','17:30:00',3.23),('14598','2013-06-17','17:35:00',3.14),('14598','2013-06-17','17:40:00',3.05),('14598','2013-06-17','17:45:00',2.98),('14598','2013-06-17','17:50:00',2.89),('14598','2013-06-17','17:55:00',2.83),('14598','2013-06-17','18:00:00',2.73),('14598','2013-06-17','18:05:00',2.64),('14598','2013-06-17','18:10:00',2.54),('14598','2013-06-17','18:15:00',2.46),('14598','2013-06-17','18:20:00',2.36),('14598','2013-06-17','18:25:00',2.26),('14598','2013-06-17','18:30:00',2.15),('14598','2013-06-17','18:35:00',2.06),('14598','2013-06-17','18:40:00',1.93),('14598','2013-06-17','18:45:00',1.84),('14598','2013-06-17','18:50:00',1.74),('14598','2013-06-17','18:55:00',1.66),('14598','2013-06-17','19:00:00',1.56),('14598','2013-06-17','19:05:00',1.46),('14598','2013-06-17','19:10:00',1.36),('14598','2013-06-17','19:15:00',1.26),('14598','2013-06-17','19:20:00',1.16),('14598','2013-06-17','19:25:00',1.05),('14598','2013-06-16','07:50:00',1.05),('14598','2013-06-16','07:55:00',1.14),('14598','2013-06-16','08:00:00',1.21),('14598','2013-06-16','08:05:00',1.28),('14598','2013-06-16','08:10:00',1.36),('14598','2013-06-16','08:15:00',1.44),('14598','2013-06-16','08:20:00',1.59),('14598','2013-06-16','08:25:00',1.66),('14598','2013-06-16','08:30:00',1.74),('14598','2013-06-16','08:35:00',1.88),('14598','2013-06-16','08:40:00',1.97),('14598','2013-06-16','08:45:00',2.1),('14598','2013-06-16','08:50:00',2.17),('14598','2013-06-16','08:55:00',2.29),('14598','2013-06-16','09:00:00',2.32),('14598','2013-06-16','09:05:00',2.43),('14598','2013-06-16','09:10:00',1.71),('14598','2013-06-16','09:15:00',2.58),('14598','2013-06-16','09:20:00',2.69),('14598','2013-06-16','09:25:00',2.76),('14598','2013-06-16','09:30:00',2.93),('14598','2013-06-16','09:35:00',3.04),('14598','2013-06-16','09:40:00',3.13),('14598','2013-06-16','09:45:00',3.21),('14598','2013-06-16','09:50:00',3.3),('14598','2013-06-16','09:55:00',3.38),('14598','2013-06-16','10:00:00',3.44),('14598','2013-06-16','10:05:00',3.52),('14598','2013-06-16','10:10:00',3.59),('14598','2013-06-16','10:15:00',3.66),('14598','2013-06-16','10:20:00',3.71),('14598','2013-06-16','10:25:00',3.8),('14598','2013-06-16','10:30:00',3.86),('14598','2013-06-16','10:35:00',3.93),('14598','2013-06-16','10:40:00',3.98),('14598','2013-06-16','10:45:00',4.06),('14598','2013-06-16','10:50:00',4.09),('14598','2013-06-16','10:55:00',4.17),('14598','2013-06-16','11:00:00',4.24),('14598','2013-06-16','11:05:00',4.28),('14598','2013-06-16','11:10:00',4.37),('14598','2013-06-16','11:15:00',4.4),('14598','2013-06-16','11:20:00',4.46),('14598','2013-06-16','11:25:00',4.51),('14598','2013-06-16','11:30:00',4.55),('14598','2013-06-16','11:35:00',4.6),('14598','2013-06-16','11:40:00',4.65),('14598','2013-06-16','11:45:00',4.69),('14598','2013-06-16','11:50:00',4.72),('14598','2013-06-16','11:55:00',4.76),('14598','2013-06-16','12:00:00',4.81),('14598','2013-06-16','12:05:00',4.84),('14598','2013-06-16','12:10:00',4.86),('14598','2013-06-16','12:15:00',4.89),('14598','2013-06-16','12:20:00',4.89),('14598','2013-06-16','12:25:00',4.96),('14598','2013-06-16','12:30:00',4.98),('14598','2013-06-16','12:35:00',5.01),('14598','2013-06-16','12:40:00',5.04),('14598','2013-06-16','12:45:00',5.05),('14598','2013-06-16','12:50:00',5.06),('14598','2013-06-16','12:55:00',5.09),('14598','2013-06-16','13:00:00',5.1),('14598','2013-06-16','13:05:00',5.12),('14598','2013-06-16','13:10:00',5.13),('14598','2013-06-16','13:15:00',5.13),('14598','2013-06-16','13:20:00',5.16),('14598','2013-06-16','13:25:00',5.15),('14598','2013-06-16','13:30:00',5.13),('14598','2013-06-16','13:35:00',5.15),('14598','2013-06-16','13:40:00',5.15),('14598','2013-06-16','13:45:00',5.17),('14598','2013-06-16','13:50:00',5.18),('14598','2013-06-16','13:55:00',5.16),('14598','2013-06-16','14:00:00',5.15),('14598','2013-06-16','14:05:00',5.09),('14598','2013-06-16','14:10:00',5.14),('14598','2013-06-16','14:15:00',5.11),('14598','2013-06-16','14:20:00',5.11),('14598','2013-06-16','14:25:00',5.11),('14598','2013-06-16','14:30:00',5.06),('14598','2013-06-16','14:35:00',5.04),('14598','2013-06-16','14:40:00',5.03),('14598','2013-06-16','14:45:00',5.01),('14598','2013-06-16','14:50:00',4.96),('14598','2013-06-16','14:55:00',4.93),('14598','2013-06-16','15:00:00',4.9),('14598','2013-06-16','15:05:00',4.88),('14598','2013-06-16','15:10:00',4.85),('14598','2013-06-16','15:15:00',4.81),('14598','2013-06-16','15:20:00',4.78),('14598','2013-06-16','15:25:00',4.73),('14598','2013-06-16','15:30:00',4.7),('14598','2013-06-16','15:35:00',4.66),('14598','2013-06-16','15:40:00',4.63),('14598','2013-06-16','15:45:00',4.58),('14598','2013-06-16','15:50:00',4.45),('14598','2013-06-16','15:55:00',4.48),('14598','2013-06-16','16:00:00',4.42),('14598','2013-06-16','16:05:00',4.38),('14598','2013-06-16','16:10:00',4.32),('14598','2013-06-16','16:15:00',4.28),('14598','2013-06-16','16:20:00',4.21),('14598','2013-06-16','16:25:00',4.16),('14598','2013-06-16','16:30:00',4.09),('14598','2013-06-16','16:35:00',4.04),('14598','2013-06-16','16:40:00',3.98),('14598','2013-06-16','16:45:00',3.91),('14598','2013-06-16','16:50:00',3.82),('14598','2013-06-16','16:55:00',3.74),('14598','2013-06-16','17:00:00',3.67),('14598','2013-06-16','17:05:00',3.57),('14598','2013-06-16','17:10:00',3.53),('14598','2013-06-16','17:15:00',3.45),('14598','2013-06-16','17:20:00',3.38),('14598','2013-06-16','17:25:00',3.31),('14598','2013-06-16','17:30:00',3.22),('14598','2013-06-16','17:35:00',3.12),('14598','2013-06-16','17:40:00',3.04),('14598','2013-06-16','17:45:00',2.95),('14598','2013-06-16','17:50:00',2.85),('14598','2013-06-16','17:55:00',2.76),('14598','2013-06-16','18:00:00',2.67),('14598','2013-06-16','18:05:00',2.57),('14598','2013-06-16','18:10:00',2.49),('14598','2013-06-16','18:15:00',2.39),('14598','2013-06-16','18:20:00',2.29),('14598','2013-06-16','18:25:00',2.2),('14598','2013-06-16','18:30:00',2.1),('14598','2013-06-16','18:35:00',2),('14598','2013-06-16','18:40:00',1.9),('14598','2013-06-16','18:45:00',1.79),('14598','2013-06-16','18:50:00',1.7),('14598','2013-06-16','18:55:00',1.59),('14598','2013-06-16','19:00:00',1.48),('14598','2013-06-16','19:05:00',1.38),('14598','2013-06-16','19:10:00',1.27),('14598','2013-06-16','19:15:00',1.16),('14598','2013-06-16','19:20:00',1.07),('14598','2013-06-15','07:40:00',1.14),('14598','2013-06-15','07:45:00',1.28),('14598','2013-06-15','07:50:00',1.52),('14598','2013-06-15','07:55:00',1.04),('14598','2013-06-15','08:05:00',1.07),('14598','2013-06-15','08:10:00',1.09),('14598','2013-06-15','08:15:00',1.08),('14598','2013-06-15','08:20:00',1.43),('14598','2013-06-15','08:25:00',1.07),('14598','2013-06-15','08:30:00',1.16),('14598','2013-06-15','08:40:00',1.03),('14598','2013-06-15','08:45:00',1.25),('14598','2013-06-15','08:50:00',1.17),('14598','2013-06-15','08:55:00',2.31),('14598','2013-06-15','09:00:00',2.3),('14598','2013-06-15','09:05:00',2.2),('14598','2013-06-15','09:10:00',2.22),('14598','2013-06-15','09:15:00',2.07),('14598','2013-06-15','09:20:00',2.63),('14598','2013-06-15','09:25:00',2.43),('14598','2013-06-15','09:30:00',2.81),('14598','2013-06-15','09:35:00',3.09),('14598','2013-06-15','09:40:00',3.02),('14598','2013-06-15','09:45:00',3.25),('14598','2013-06-15','09:50:00',3.31),('14598','2013-06-15','09:55:00',3.38),('14598','2013-06-15','10:00:00',3.45),('14598','2013-06-15','10:05:00',3.5),('14598','2013-06-15','10:10:00',3.56),('14598','2013-06-15','10:15:00',3.65),('14598','2013-06-15','10:20:00',3.69),('14598','2013-06-15','10:25:00',3.81),('14598','2013-06-15','10:30:00',3.9),('14598','2013-06-15','10:35:00',3.94),('14598','2013-06-15','10:40:00',4.01),('14598','2013-06-15','10:45:00',4.08),('14598','2013-06-15','10:50:00',4.18),('14598','2013-06-15','10:55:00',4.22),('14598','2013-06-15','11:00:00',4.29),('14598','2013-06-15','11:05:00',4.37),('14598','2013-06-15','11:10:00',4.4),('14598','2013-06-15','11:15:00',4.18),('14598','2013-06-15','11:20:00',4.48),('14598','2013-06-15','11:25:00',4.56),('14598','2013-06-15','11:30:00',4.65),('14598','2013-06-15','11:35:00',4.62),('14598','2013-06-15','11:40:00',4.72),('14598','2013-06-15','11:45:00',4.74),('14598','2013-06-15','11:50:00',4.69),('14598','2013-06-15','11:55:00',4.77),('14598','2013-06-15','12:00:00',4.82),('14598','2013-06-15','12:05:00',4.79),('14598','2013-06-15','12:10:00',4.91),('14598','2013-06-15','12:15:00',4.88),('14598','2013-06-15','12:20:00',4.5),('14598','2013-06-15','12:25:00',4.92),('14598','2013-06-15','12:30:00',4.98),('14598','2013-06-15','12:35:00',5),('14598','2013-06-15','12:40:00',5),('14598','2013-06-15','12:45:00',5.02),('14598','2013-06-15','12:50:00',5.06),('14598','2013-06-15','12:55:00',5.07),('14598','2013-06-15','13:00:00',5.1),('14598','2013-06-15','13:05:00',5.12),('14598','2013-06-15','13:10:00',5.12),('14598','2013-06-15','13:15:00',5.16),('14598','2013-06-15','13:20:00',5.15),('14598','2013-06-15','13:25:00',5.19),('14598','2013-06-15','13:30:00',5.23),('14598','2013-06-15','13:35:00',5.18),('14598','2013-06-15','13:40:00',5.18),('14598','2013-06-15','13:45:00',5.13),('14598','2013-06-15','13:50:00',5.18),('14598','2013-06-15','13:55:00',5.17),('14598','2013-06-15','14:00:00',5.1),('14598','2013-06-15','14:05:00',5.11),('14598','2013-06-15','14:10:00',5.2),('14598','2013-06-15','14:15:00',5.15),('14598','2013-06-15','14:20:00',5.08),('14598','2013-06-15','14:25:00',5.1),('14598','2013-06-15','14:30:00',5.08),('14598','2013-06-15','14:35:00',5.06),('14598','2013-06-15','14:40:00',5.04),('14598','2013-06-15','14:45:00',5.03),('14598','2013-06-15','14:50:00',4.99),('14598','2013-06-15','14:55:00',4.96),('14598','2013-06-15','15:00:00',4.94),('14598','2013-06-15','15:05:00',4.91),('14598','2013-06-15','15:10:00',4.87),('14598','2013-06-15','15:15:00',4.83),('14598','2013-06-15','15:20:00',4.8),('14598','2013-06-15','15:25:00',4.74),('14598','2013-06-15','15:30:00',4.69),('14598','2013-06-15','15:35:00',4.66),('14598','2013-06-15','15:40:00',4.6),('14598','2013-06-15','15:45:00',4.56),('14598','2013-06-15','15:50:00',4.51),('14598','2013-06-15','15:55:00',4.47),('14598','2013-06-15','16:00:00',4.4),('14598','2013-06-15','16:05:00',4.34),('14598','2013-06-15','16:10:00',4.3),('14598','2013-06-15','16:15:00',4.24),('14598','2013-06-15','16:20:00',4.17),('14598','2013-06-15','16:25:00',4.11),('14598','2013-06-15','16:30:00',4.05),('14598','2013-06-15','16:35:00',3.99),('14598','2013-06-15','16:40:00',3.92),('14598','2013-06-15','16:45:00',3.86),('14598','2013-06-15','16:50:00',3.8),('14598','2013-06-15','16:55:00',3.74),('14598','2013-06-15','17:00:00',3.65),('14598','2013-06-15','17:05:00',3.57),('14598','2013-06-15','17:10:00',3.5),('14598','2013-06-15','17:15:00',3.42),('14598','2013-06-15','17:20:00',3.34),('14598','2013-06-15','17:25:00',3.26),('14598','2013-06-15','17:30:00',3.19),('14598','2013-06-15','17:35:00',3.07),('14598','2013-06-15','17:40:00',3),('14598','2013-06-15','17:45:00',2.93),('14598','2013-06-15','17:50:00',2.84),('14598','2013-06-15','17:55:00',2.72),('14598','2013-06-15','18:00:00',2.64),('14598','2013-06-15','18:05:00',2.53),('14598','2013-06-15','18:10:00',2.39),('14598','2013-06-15','18:15:00',2.35),('14598','2013-06-15','18:20:00',2.26),('14598','2013-06-15','18:25:00',2.16),('14598','2013-06-15','18:30:00',2.07),('14598','2013-06-15','18:35:00',1.98),('14598','2013-06-15','18:40:00',1.88),('14598','2013-06-15','18:45:00',1.79),('14598','2013-06-15','18:50:00',1.68),('14598','2013-06-15','18:55:00',1.57),('14598','2013-06-15','19:00:00',1.47),('14598','2013-06-15','19:05:00',1.36),('14598','2013-06-15','19:10:00',1.25),('14598','2013-06-15','19:15:00',1.16),('14598','2013-06-15','19:20:00',1.06),('14598','2013-06-14','07:50:00',1.09),('14598','2013-06-14','07:55:00',1.17),('14598','2013-06-14','08:00:00',1.26),('14598','2013-06-14','08:05:00',1.35),('14598','2013-06-14','08:10:00',1.43),('14598','2013-06-14','08:15:00',1.53),('14598','2013-06-14','08:20:00',1.63),('14598','2013-06-14','08:25:00',1.72),('14598','2013-06-14','08:30:00',1.8),('14598','2013-06-14','08:35:00',1.93),('14598','2013-06-14','08:40:00',2.02),('14598','2013-06-14','08:45:00',2.15),('14598','2013-06-14','08:50:00',2.25),('14598','2013-06-14','08:55:00',2.35),('14598','2013-06-14','09:00:00',2.44),('14598','2013-06-14','09:05:00',2.52),('14598','2013-06-14','09:10:00',2.59),('14598','2013-06-14','09:15:00',2.69),('14598','2013-06-14','09:20:00',2.79),('14598','2013-06-14','09:25:00',2.93),('14598','2013-06-14','09:30:00',3.02),('14598','2013-06-14','09:35:00',3.08),('14598','2013-06-14','09:40:00',3.16),('14598','2013-06-14','09:45:00',3.22),('14598','2013-06-14','09:50:00',3.33),('14598','2013-06-14','09:55:00',3.4),('14598','2013-06-14','10:00:00',3.47),('14598','2013-06-14','10:05:00',3.62),('14598','2013-06-14','10:10:00',3.72),('14598','2013-06-14','10:15:00',3.8),('14598','2013-06-14','10:20:00',3.88),('14598','2013-06-14','10:25:00',3.94),('14598','2013-06-14','10:30:00',4.03),('14598','2013-06-14','10:35:00',4.15),('14598','2013-06-14','10:40:00',4.27),('14598','2013-06-14','10:45:00',4.27),('14598','2013-06-14','10:50:00',4.13),('14598','2013-06-14','10:55:00',4.42),('14598','2013-06-14','11:00:00',4.28),('14598','2013-06-14','11:05:00',4.1),('14598','2013-06-14','11:10:00',4.33),('14598','2013-06-14','11:15:00',4.55),('14598','2013-06-14','11:20:00',4.58),('14598','2013-06-14','11:25:00',4.69),('14598','2013-06-14','11:30:00',4.69),('14598','2013-06-14','11:35:00',4.58),('14598','2013-06-14','11:40:00',4.71),('14598','2013-06-14','11:45:00',4.86),('14598','2013-06-14','11:50:00',4.92),('14598','2013-06-14','11:55:00',4.95),('14598','2013-06-14','12:00:00',4.99),('14598','2013-06-14','12:05:00',5.01),('14598','2013-06-14','12:10:00',5.02),('14598','2013-06-14','12:15:00',5.07),('14598','2013-06-14','12:20:00',5.08),('14598','2013-06-14','12:25:00',5.1),('14598','2013-06-14','12:30:00',5.1),('14598','2013-06-14','12:35:00',5.12),('14598','2013-06-14','12:40:00',5.12),('14598','2013-06-14','12:45:00',5.16),('14598','2013-06-14','12:50:00',5.13),('14598','2013-06-14','12:55:00',5.2),('14598','2013-06-14','13:00:00',5.25),('14598','2013-06-14','13:05:00',5.28),('14598','2013-06-14','13:10:00',5.31),('14598','2013-06-14','13:15:00',5.33),('14598','2013-06-14','13:20:00',5.35),('14598','2013-06-14','13:25:00',5.39),('14598','2013-06-14','13:30:00',5.39),('14598','2013-06-14','13:35:00',5.37),('14598','2013-06-14','13:40:00',5.35),('14598','2013-06-14','13:45:00',5.39),('14598','2013-06-14','13:50:00',5.38),('14598','2013-06-14','13:55:00',5.32),('14598','2013-06-14','14:00:00',5.31),('14598','2013-06-14','14:05:00',5.28),('14598','2013-06-14','14:10:00',5.27),('14598','2013-06-14','14:15:00',5.27),('14598','2013-06-14','14:20:00',5.27),('14598','2013-06-14','14:25:00',5.29),('14598','2013-06-14','14:30:00',5.27),('14598','2013-06-14','14:35:00',5.15),('14598','2013-06-14','14:40:00',5.24),('14598','2013-06-14','14:45:00',5.2),('14598','2013-06-14','14:50:00',5.19),('14598','2013-06-14','14:55:00',5.18),('14598','2013-06-14','15:00:00',5.14),('14598','2013-06-14','15:05:00',5.12),('14598','2013-06-14','15:10:00',5.05),('14598','2013-06-14','15:15:00',5),('14598','2013-06-14','15:20:00',4.97),('14598','2013-06-14','15:25:00',4.9),('14598','2013-06-14','15:30:00',4.86),('14598','2013-06-14','15:35:00',4.81),('14598','2013-06-14','15:40:00',4.79),('14598','2013-06-14','15:45:00',4.75),('14598','2013-06-14','15:50:00',4.66),('14598','2013-06-14','15:55:00',4.64),('14598','2013-06-14','16:00:00',4.57),('14598','2013-06-14','16:05:00',4.52),('14598','2013-06-14','16:10:00',4.5),('14598','2013-06-14','16:15:00',4.45),('14598','2013-06-14','16:20:00',4.4),('14598','2013-06-14','16:25:00',4.36),('14598','2013-06-14','16:30:00',4.28),('14598','2013-06-14','16:35:00',4.19),('14598','2013-06-14','16:40:00',4.1),('14598','2013-06-14','16:45:00',4.04),('14598','2013-06-14','16:50:00',3.92),('14598','2013-06-14','16:55:00',3.89),('14598','2013-06-14','17:00:00',3.81),('14598','2013-06-14','17:05:00',3.78),('14598','2013-06-14','17:10:00',3.69),('14598','2013-06-14','17:15:00',3.63),('14598','2013-06-14','17:20:00',3.49),('14598','2013-06-14','17:25:00',3.43),('14598','2013-06-14','17:30:00',3.35),('14598','2013-06-14','17:35:00',3.22),('14598','2013-06-14','17:40:00',3.17),('14598','2013-06-14','17:45:00',3.08),('14598','2013-06-14','17:50:00',2.98),('14598','2013-06-14','17:55:00',2.88),('14598','2013-06-14','18:00:00',2.79),('14598','2013-06-14','18:05:00',2.69),('14598','2013-06-14','18:10:00',2.59),('14598','2013-06-14','18:15:00',2.51),('14598','2013-06-14','18:20:00',2.43),('14598','2013-06-14','18:25:00',2.32),('14598','2013-06-14','18:30:00',2.21),('14598','2013-06-14','18:35:00',2.11),('14598','2013-06-14','18:40:00',2.01),('14598','2013-06-14','18:45:00',1.89),('14598','2013-06-14','18:50:00',1.79),('14598','2013-06-14','18:55:00',1.68),('14598','2013-06-14','19:00:00',1.57),('14598','2013-06-14','19:05:00',1.46),('14598','2013-06-14','19:10:00',1.35),('14598','2013-06-14','19:15:00',1.26),('14598','2013-06-14','19:20:00',1.14),('14598','2013-06-14','19:25:00',1.04),('14598','2013-06-13','07:45:00',1.01),('14598','2013-06-13','07:50:00',1.09),('14598','2013-06-13','07:55:00',1.18),('14598','2013-06-13','08:00:00',1.27),('14598','2013-06-13','08:05:00',1.36),('14598','2013-06-13','08:10:00',1.46),('14598','2013-06-13','08:15:00',1.56),('14598','2013-06-13','08:20:00',1.66),('14598','2013-06-13','08:25:00',1.75),('14598','2013-06-13','08:30:00',1.85),('14598','2013-06-13','08:35:00',1.96),('14598','2013-06-13','08:40:00',2.06),('14598','2013-06-13','08:45:00',2.19),('14598','2013-06-13','08:50:00',2.3),('14598','2013-06-13','08:55:00',2.41),('14598','2013-06-13','09:00:00',2.5),('14598','2013-06-13','09:05:00',2.59),('14598','2013-06-13','09:10:00',2.68),('14598','2013-06-13','09:15:00',2.78),('14598','2013-06-13','09:20:00',2.86),('14598','2013-06-13','09:25:00',2.96),('14598','2013-06-13','09:30:00',3.04),('14598','2013-06-13','09:35:00',3.13),('14598','2013-06-13','09:40:00',3.21),('14598','2013-06-13','09:45:00',3.28),('14598','2013-06-13','09:50:00',3.37),('14598','2013-06-13','09:55:00',3.43),('14598','2013-06-13','10:00:00',3.49),('14598','2013-06-13','10:05:00',3.56),('14598','2013-06-13','10:10:00',3.63),('14598','2013-06-13','10:15:00',3.7),('14598','2013-06-13','10:20:00',3.78),('14598','2013-06-13','10:25:00',3.84),('14598','2013-06-13','10:30:00',3.9),('14598','2013-06-13','10:35:00',3.94),('14598','2013-06-13','10:40:00',3.99),('14598','2013-06-13','10:45:00',4.06),('14598','2013-06-13','10:50:00',4.12),('14598','2013-06-13','10:55:00',4.16),('14598','2013-06-13','11:00:00',4.19),('14598','2013-06-13','11:05:00',4.23),('14598','2013-06-13','11:10:00',4.26),('14598','2013-06-13','11:15:00',4.31),('14598','2013-06-13','11:20:00',4.37),('14598','2013-06-13','11:25:00',4.47),('14598','2013-06-13','11:30:00',4.54),('14598','2013-06-13','11:35:00',4.57),('14598','2013-06-13','11:40:00',4.63),('14598','2013-06-13','11:45:00',4.73),('14598','2013-06-13','11:50:00',4.8),('14598','2013-06-13','11:55:00',4.84),('14598','2013-06-13','12:00:00',4.86),('14598','2013-06-13','12:05:00',4.91),('14598','2013-06-13','12:10:00',4.97),('14598','2013-06-13','12:15:00',5.01),('14598','2013-06-13','12:20:00',5),('14598','2013-06-13','12:25:00',5.05),('14598','2013-06-13','12:30:00',5.06),('14598','2013-06-13','12:35:00',5.11),('14598','2013-06-13','12:40:00',5.15),('14598','2013-06-13','12:45:00',5.17),('14598','2013-06-13','12:50:00',5.23),('14598','2013-06-13','12:55:00',5.25),('14598','2013-06-13','13:00:00',5.26),('14598','2013-06-13','13:05:00',5.29),('14598','2013-06-13','13:10:00',5.33),('14598','2013-06-13','13:15:00',5.32),('14598','2013-06-13','13:20:00',5.33),('14598','2013-06-13','13:25:00',5.37),('14598','2013-06-13','13:30:00',5.37),('14598','2013-06-13','13:35:00',5.36),('14598','2013-06-13','13:40:00',5.34),('14598','2013-06-13','13:45:00',5.35),('14598','2013-06-13','13:50:00',5.33),('14598','2013-06-13','13:55:00',5.32),('14598','2013-06-13','14:00:00',5.32),('14598','2013-06-13','14:05:00',5.3),('14598','2013-06-13','14:10:00',5.3),('14598','2013-06-13','14:15:00',5.28),('14598','2013-06-13','14:20:00',5.28),('14598','2013-06-13','14:25:00',5.3),('14598','2013-06-13','14:30:00',5.26),('14598','2013-06-13','14:35:00',5.23),('14598','2013-06-13','14:40:00',5.22),('14598','2013-06-13','14:45:00',5.18),('14598','2013-06-13','14:50:00',5.16),('14598','2013-06-13','14:55:00',5.13),('14598','2013-06-13','15:00:00',5.08),('14598','2013-06-13','15:05:00',5.06),('14598','2013-06-13','15:10:00',5.03),('14598','2013-06-13','15:15:00',4.99),('14598','2013-06-13','15:20:00',4.89),('14598','2013-06-13','15:25:00',4.92),('14598','2013-06-13','15:30:00',4.85),('14598','2013-06-13','15:35:00',4.83),('14598','2013-06-13','15:40:00',4.76),('14598','2013-06-13','15:45:00',4.73),('14598','2013-06-13','15:50:00',4.7),('14598','2013-06-13','15:55:00',4.64),('14598','2013-06-13','16:00:00',4.57),('14598','2013-06-13','16:05:00',4.5),('14598','2013-06-13','16:10:00',4.49),('14598','2013-06-13','16:15:00',4.45),('14598','2013-06-13','16:20:00',4.35),('14598','2013-06-13','16:25:00',4.29),('14598','2013-06-13','16:30:00',4.24),('14598','2013-06-13','16:35:00',4.18),('14598','2013-06-13','16:40:00',4.09),('14598','2013-06-13','16:45:00',4.03),('14598','2013-06-13','16:50:00',4),('14598','2013-06-13','16:55:00',3.91),('14598','2013-06-13','17:00:00',3.81),('14598','2013-06-13','17:05:00',3.71),('14598','2013-06-13','17:10:00',3.54),('14598','2013-06-13','17:15:00',3.56),('14598','2013-06-13','17:20:00',3.49),('14598','2013-06-13','17:25:00',3.41),('14598','2013-06-13','17:30:00',3.32),('14598','2013-06-13','17:35:00',3.24),('14598','2013-06-13','17:40:00',3.17),('14598','2013-06-13','17:45:00',3.07),('14598','2013-06-13','17:50:00',2.97),('14598','2013-06-13','17:55:00',2.88),('14598','2013-06-13','18:00:00',2.8),('14598','2013-06-13','18:05:00',2.69),('14598','2013-06-13','18:10:00',2.59),('14598','2013-06-13','18:15:00',2.51),('14598','2013-06-13','18:20:00',2.4),('14598','2013-06-13','18:25:00',2.28),('14598','2013-06-13','18:30:00',2.2),('14598','2013-06-13','18:35:00',2.1),('14598','2013-06-13','18:40:00',1.99),('14598','2013-06-13','18:45:00',1.89),('14598','2013-06-13','18:50:00',1.78),('14598','2013-06-13','18:55:00',1.67),('14598','2013-06-13','19:00:00',1.56),('14598','2013-06-13','19:05:00',1.46),('14598','2013-06-13','19:10:00',1.35),('14598','2013-06-13','19:15:00',1.24),('14598','2013-06-13','19:20:00',1.13),('14598','2013-06-13','19:25:00',1.01),('14598','2013-06-12','07:50:00',1.09),('14598','2013-06-12','07:55:00',1.2),('14598','2013-06-12','08:00:00',1.29),('14598','2013-06-12','08:05:00',1.38),('14598','2013-06-12','08:10:00',1.47),('14598','2013-06-12','08:15:00',1.57),('14598','2013-06-12','08:20:00',1.66),('14598','2013-06-12','08:25:00',1.77),('14598','2013-06-12','08:30:00',1.87),('14598','2013-06-12','08:35:00',1.98),('14598','2013-06-12','08:40:00',2.08),('14598','2013-06-12','08:45:00',2.21),('14598','2013-06-12','08:50:00',2.31),('14598','2013-06-12','08:55:00',2.43),('14598','2013-06-12','09:00:00',2.52),('14598','2013-06-12','09:05:00',2.6),('14598','2013-06-12','09:10:00',2.69),('14598','2013-06-12','09:15:00',2.81),('14598','2013-06-12','09:20:00',2.9),('14598','2013-06-12','09:25:00',2.99),('14598','2013-06-12','09:30:00',3.05),('14598','2013-06-12','09:35:00',3.1),('14598','2013-06-12','09:40:00',3.22),('14598','2013-06-12','09:45:00',3.28),('14598','2013-06-12','09:50:00',3.36),('14598','2013-06-12','09:55:00',3.44),('14598','2013-06-12','10:00:00',3.52),('14598','2013-06-12','10:05:00',3.6),('14598','2013-06-12','10:10:00',3.67),('14598','2013-06-12','10:15:00',3.76),('14598','2013-06-12','10:20:00',3.82),('14598','2013-06-12','10:25:00',3.88),('14598','2013-06-12','10:30:00',3.95),('14598','2013-06-12','10:35:00',4.01),('14598','2013-06-12','10:40:00',4.06),('14598','2013-06-12','10:45:00',4.11),('14598','2013-06-12','10:50:00',4.11),('14598','2013-06-12','10:55:00',4.19),('14598','2013-06-12','11:00:00',4.26),('14598','2013-06-12','11:05:00',4.32),('14598','2013-06-12','11:10:00',4.35),('14598','2013-06-12','11:15:00',4.41),('14598','2013-06-12','11:20:00',4.49),('14598','2013-06-12','11:25:00',4.54),('14598','2013-06-12','11:30:00',4.57),('14598','2013-06-12','11:35:00',4.61),('14598','2013-06-12','11:40:00',4.69),('14598','2013-06-12','11:45:00',4.71),('14598','2013-06-12','11:50:00',4.71),('14598','2013-06-12','11:55:00',4.85),('14598','2013-06-12','12:00:00',4.91),('14598','2013-06-12','12:05:00',4.92),('14598','2013-06-12','12:10:00',4.99),('14598','2013-06-12','12:15:00',5),('14598','2013-06-12','12:20:00',5.02),('14598','2013-06-12','12:25:00',5.07),('14598','2013-06-12','12:30:00',5.15),('14598','2013-06-12','12:35:00',5.15),('14598','2013-06-12','12:40:00',5.21),('14598','2013-06-12','12:45:00',5.23),('14598','2013-06-12','12:50:00',5.28),('14598','2013-06-12','12:55:00',5.29),('14598','2013-06-12','13:00:00',5.28),('14598','2013-06-12','13:05:00',5.29),('14598','2013-06-12','13:10:00',5.31),('14598','2013-06-12','13:15:00',5.31),('14598','2013-06-12','13:20:00',5.33),('14598','2013-06-12','13:25:00',5.37),('14598','2013-06-12','13:30:00',5.39),('14598','2013-06-12','13:35:00',5.4),('14598','2013-06-12','13:40:00',5.4),('14598','2013-06-12','13:45:00',5.39),('14598','2013-06-12','13:50:00',5.32),('14598','2013-06-12','13:55:00',5.36),('14598','2013-06-12','14:00:00',5.37),('14598','2013-06-12','14:05:00',5.36),('14598','2013-06-12','14:10:00',5.32),('14598','2013-06-12','14:15:00',5.28),('14598','2013-06-12','14:20:00',5.29),('14598','2013-06-12','14:25:00',5.26),('14598','2013-06-12','14:30:00',5.28),('14598','2013-06-12','14:35:00',5.26),('14598','2013-06-12','14:40:00',5.21),('14598','2013-06-12','14:45:00',5.19),('14598','2013-06-12','14:50:00',5.19),('14598','2013-06-12','14:55:00',5.2),('14598','2013-06-12','15:00:00',5.14),('14598','2013-06-12','15:05:00',5.11),('14598','2013-06-12','15:10:00',5.08),('14598','2013-06-12','15:15:00',5.05),('14598','2013-06-12','15:20:00',5),('14598','2013-06-12','15:25:00',4.96),('14598','2013-06-12','15:30:00',4.92),('14598','2013-06-12','15:35:00',4.87),('14598','2013-06-12','15:40:00',4.77),('14598','2013-06-12','15:45:00',4.78),('14598','2013-06-12','15:50:00',4.71),('14598','2013-06-12','15:55:00',4.66),('14598','2013-06-12','16:00:00',4.61),('14598','2013-06-12','16:05:00',4.55),('14598','2013-06-12','16:10:00',4.51),('14598','2013-06-12','16:15:00',4.39),('14598','2013-06-12','16:20:00',4.36),('14598','2013-06-12','16:25:00',4.2),('14598','2013-06-12','16:30:00',4.24),('14598','2013-06-12','16:35:00',4.19),('14598','2013-06-12','16:40:00',4.11),('14598','2013-06-12','16:45:00',4.08),('14598','2013-06-12','16:50:00',3.96),('14598','2013-06-12','16:55:00',3.66),('14598','2013-06-12','17:00:00',2.02),('14598','2013-06-12','17:05:00',4.34),('14598','2013-06-12','17:10:00',4.06),('14598','2013-06-12','17:15:00',3.89),('14598','2013-06-12','17:20:00',3.92),('14598','2013-06-12','17:25:00',4.05),('14598','2013-06-12','17:30:00',4.01),('14598','2013-06-12','17:35:00',3.78),('14598','2013-06-12','17:40:00',3.78),('14598','2013-06-12','17:45:00',3.56),('14598','2013-06-12','17:50:00',3.5),('14598','2013-06-12','17:55:00',3.32),('14598','2013-06-12','18:00:00',3.32),('14598','2013-06-12','18:05:00',3.3),('14598','2013-06-12','18:10:00',3.04),('14598','2013-06-12','18:15:00',2.78),('14598','2013-06-12','18:20:00',2.68),('14598','2013-06-12','18:25:00',2.43),('14598','2013-06-12','18:30:00',2.24),('14598','2013-06-12','18:35:00',2.14),('14598','2013-06-12','18:40:00',1.99),('14598','2013-06-12','18:45:00',1.91),('14598','2013-06-12','18:50:00',1.79),('14598','2013-06-12','18:55:00',1.68),('14598','2013-06-12','19:00:00',1.57),('14598','2013-06-12','19:05:00',1.45),('14598','2013-06-12','19:10:00',1.35),('14598','2013-06-12','19:15:00',1.25),('14598','2013-06-12','19:20:00',1.13),('14598','2013-06-12','19:25:00',1),('14598','2013-06-11','07:50:00',1.07),('14598','2013-06-11','07:55:00',1.16),('14598','2013-06-11','08:00:00',1.25),('14598','2013-06-11','08:05:00',1.34),('14598','2013-06-11','08:10:00',1.43),('14598','2013-06-11','08:15:00',1.53),('14598','2013-06-11','08:20:00',1.63),('14598','2013-06-11','08:25:00',1.72),('14598','2013-06-11','08:30:00',1.83),('14598','2013-06-11','08:35:00',1.92),('14598','2013-06-11','08:40:00',2.02),('14598','2013-06-11','08:45:00',2.15),('14598','2013-06-11','08:50:00',2.25),('14598','2013-06-11','08:55:00',2.32),('14598','2013-06-11','09:00:00',2.43),('14598','2013-06-11','09:05:00',2.54),('14598','2013-06-11','09:10:00',2.63),('14598','2013-06-11','09:15:00',2.72),('14598','2013-06-11','09:20:00',2.84),('14598','2013-06-11','09:25:00',2.91),('14598','2013-06-11','09:30:00',3.01),('14598','2013-06-11','09:35:00',3.15),('14598','2013-06-11','09:40:00',3.26),('14598','2013-06-11','09:45:00',3.33),('14598','2013-06-11','09:50:00',3.41),('14598','2013-06-11','09:55:00',3.49),('14598','2013-06-11','10:00:00',3.56),('14598','2013-06-11','10:05:00',3.63),('14598','2013-06-11','10:10:00',3.71),('14598','2013-06-11','10:15:00',3.78),('14598','2013-06-11','10:20:00',3.86),('14598','2013-06-11','10:25:00',3.94),('14598','2013-06-11','10:30:00',3.99),('14598','2013-06-11','10:35:00',4.06),('14598','2013-06-11','10:40:00',4.12),('14598','2013-06-11','10:45:00',4.18),('14598','2013-06-11','10:50:00',4.2),('14598','2013-06-11','10:55:00',4.3),('14598','2013-06-11','11:00:00',4.38),('14598','2013-06-11','11:05:00',4.44),('14598','2013-06-11','11:10:00',4.52),('14598','2013-06-11','11:15:00',4.59),('14598','2013-06-11','11:20:00',4.65),('14598','2013-06-11','11:25:00',4.69),('14598','2013-06-11','11:30:00',4.76),('14598','2013-06-11','11:35:00',4.81),('14598','2013-06-11','11:40:00',4.83),('14598','2013-06-11','11:45:00',4.86),('14598','2013-06-11','11:50:00',4.9),('14598','2013-06-11','11:55:00',4.95),('14598','2013-06-11','12:00:00',4.99),('14598','2013-06-11','12:05:00',5.02),('14598','2013-06-11','12:10:00',5.08),('14598','2013-06-11','12:15:00',5.11),('14598','2013-06-11','12:20:00',5.16),('14598','2013-06-11','12:25:00',5.18),('14598','2013-06-11','12:30:00',5.2),('14598','2013-06-11','12:35:00',5.22),('14598','2013-06-11','12:40:00',5.24),('14598','2013-06-11','12:45:00',5.27),('14598','2013-06-11','12:50:00',5.3),('14598','2013-06-11','12:55:00',5.28),('14598','2013-06-11','13:00:00',5.29),('14598','2013-06-11','13:05:00',5.33),('14598','2013-06-11','13:10:00',5.35),('14598','2013-06-11','13:15:00',5.39),('14598','2013-06-11','13:20:00',5.38),('14598','2013-06-11','13:25:00',5.39),('14598','2013-06-11','13:30:00',5.38),('14598','2013-06-11','13:35:00',5.38),('14598','2013-06-11','13:40:00',5.4),('14598','2013-06-11','13:45:00',5.39),('14598','2013-06-11','13:50:00',5.32),('14598','2013-06-11','13:55:00',5.38),('14598','2013-06-11','14:00:00',5.37),('14598','2013-06-11','14:05:00',5.37),('14598','2013-06-11','14:10:00',5.37),('14598','2013-06-11','14:15:00',5.35),('14598','2013-06-11','14:20:00',5.34),('14598','2013-06-11','14:25:00',5.31),('14598','2013-06-11','14:30:00',5.29),('14598','2013-06-11','14:35:00',5.25),('14598','2013-06-11','14:40:00',5.23),('14598','2013-06-11','14:45:00',5.24),('14598','2013-06-11','14:50:00',5.21),('14598','2013-06-11','14:55:00',5.16),('14598','2013-06-11','15:00:00',5.16),('14598','2013-06-11','15:05:00',5.13),('14598','2013-06-11','15:10:00',5.03),('14598','2013-06-11','15:15:00',5.04),('14598','2013-06-11','15:20:00',4.99),('14598','2013-06-11','15:25:00',4.96),('14598','2013-06-11','15:30:00',4.92),('14598','2013-06-11','15:35:00',4.87),('14598','2013-06-11','15:40:00',4.82),('14598','2013-06-11','15:45:00',4.79),('14598','2013-06-11','15:50:00',4.74),('14598','2013-06-11','15:55:00',4.73),('14598','2013-06-11','16:00:00',4.68),('14598','2013-06-11','16:05:00',4.6),('14598','2013-06-11','16:10:00',4.53),('14598','2013-06-11','16:15:00',4.44),('14598','2013-06-11','16:20:00',4.4),('14598','2013-06-11','16:25:00',4.34),('14598','2013-06-11','16:30:00',4.27),('14598','2013-06-11','16:35:00',4.21),('14598','2013-06-11','16:40:00',4.17),('14598','2013-06-11','16:45:00',4.1),('14598','2013-06-11','16:50:00',4.08),('14598','2013-06-11','16:55:00',4.06),('14598','2013-06-11','17:00:00',4.12),('14598','2013-06-11','17:05:00',4.25),('14598','2013-06-11','17:10:00',4.34),('14598','2013-06-11','17:15:00',4.27),('14598','2013-06-11','17:20:00',4.09),('14598','2013-06-11','17:25:00',3.37),('14598','2013-06-11','17:30:00',2.71),('14598','2013-06-11','17:35:00',3.45),('14598','2013-06-11','17:40:00',1.57),('14598','2013-06-11','17:45:00',1.15),('14598','2013-06-11','19:15:00',1.19),('14598','2013-06-11','19:20:00',1.41),('14598','2013-06-11','19:25:00',1.09),('14598','2014-04-03','08:45:00',1.03),('14598','2014-04-03','08:50:00',1.22),('14598','2014-04-03','08:55:00',1.3),('14598','2014-04-03','09:00:00',1.24),('14598','2014-04-03','09:05:00',1.22),('14598','2014-04-03','09:10:00',1.36),('14598','2014-04-03','09:15:00',1.46),('14598','2014-04-03','09:20:00',1.56),('14598','2014-04-03','09:25:00',1.62),('14598','2014-04-03','09:30:00',1.62),('14598','2014-04-03','09:35:00',1.62),('14598','2014-04-03','09:40:00',1.66),('14598','2014-04-03','09:45:00',1.78),('14598','2014-04-03','09:50:00',1.78),('14598','2014-04-03','09:55:00',2.05),('14598','2014-04-03','10:00:00',2.53),('14598','2014-04-03','10:05:00',3.02),('14598','2014-04-03','10:10:00',2.8),('14598','2014-04-03','10:15:00',2.71),('14598','2014-04-03','10:20:00',2.7),('14598','2014-04-03','10:25:00',2.69),('14598','2014-04-03','10:30:00',2.26),('14598','2014-04-03','10:35:00',2.1),('14598','2014-04-03','10:40:00',1.91),('14598','2014-04-03','10:45:00',1.76),('14598','2014-04-03','10:50:00',1.6),('14598','2014-04-03','10:55:00',1.71),('14598','2014-04-03','11:00:00',1.84),('14598','2014-04-03','11:05:00',1.67),('14598','2014-04-03','11:10:00',1.47),('14598','2014-04-03','11:15:00',1.44),('14598','2014-04-03','11:20:00',1.61),('14598','2014-04-03','11:25:00',1.77),('14598','2014-04-03','11:30:00',1.87),('14598','2014-04-03','11:35:00',1.81),('14598','2014-04-03','11:40:00',2),('14598','2014-04-03','11:45:00',2.24),('14598','2014-04-03','11:50:00',2.57),('14598','2014-04-03','11:55:00',2.59),('14598','2014-04-03','12:00:00',2.37),('14598','2014-04-03','12:05:00',2.59),('14598','2014-04-03','12:10:00',2.52),('14598','2014-04-03','12:15:00',3.45),('14598','2014-04-03','12:20:00',4.49),('14598','2014-04-03','12:25:00',3.78),('14598','2014-04-03','12:30:00',2.97),('14598','2014-04-03','12:35:00',2.7),('14598','2014-04-03','12:40:00',2.15),('14598','2014-04-03','12:45:00',2.34),('14598','2014-04-03','12:50:00',2.25),('14598','2014-04-03','12:55:00',2.18),('14598','2014-04-03','13:00:00',3.4),('14598','2014-04-03','13:05:00',3.96),('14598','2014-04-03','13:10:00',3.93),('14598','2014-04-03','13:15:00',3.35),('14598','2014-04-03','13:20:00',4.23),('14598','2014-04-03','13:25:00',5.05),('14598','2014-04-03','13:30:00',3.44),('14598','2014-04-03','13:35:00',2.3),('14598','2014-04-03','13:40:00',2.66),('14598','2014-04-03','13:45:00',4.27),('14598','2014-04-03','13:50:00',2.62),('14598','2014-04-03','13:55:00',3.55),('14598','2014-04-03','14:00:00',3.45),('14598','2014-04-03','14:05:00',4.18),('14598','2014-04-03','14:10:00',4.46),('14598','2014-04-03','14:15:00',3.53),('14598','2014-04-03','14:20:00',3.99),('14598','2014-04-03','14:25:00',5.26),('14598','2014-04-03','14:30:00',4.74),('14598','2014-04-03','14:35:00',4.85),('14598','2014-04-03','14:40:00',4.69),('14598','2014-04-03','14:45:00',4.63),('14598','2014-04-03','14:50:00',4.62),('14598','2014-04-03','14:55:00',4.63),('14598','2014-04-03','15:00:00',4.63),('14598','2014-04-03','15:05:00',4.55),('14598','2014-04-03','15:10:00',4.55),('14598','2014-04-03','15:15:00',4.53),('14598','2014-04-03','15:20:00',4.47),('14598','2014-04-03','15:25:00',4.45),('14598','2014-04-03','15:30:00',4.41),('14598','2014-04-03','15:35:00',4.38),('14598','2014-04-03','15:40:00',4.28),('14598','2014-04-03','15:45:00',4.05),('14598','2014-04-03','15:50:00',4.39),('14598','2014-04-03','15:55:00',4.22),('14598','2014-04-03','16:00:00',4.18),('14598','2014-04-03','16:05:00',4.14),('14598','2014-04-03','16:10:00',4.06),('14598','2014-04-03','16:15:00',3.96),('14598','2014-04-03','16:20:00',3.87),('14598','2014-04-03','16:25:00',3.79),('14598','2014-04-03','16:30:00',3.76),('14598','2014-04-03','16:35:00',3.67),('14598','2014-04-03','16:40:00',3.58),('14598','2014-04-03','16:45:00',3.46),('14598','2014-04-03','16:50:00',3.12),('14598','2014-04-03','16:55:00',3.32),('14598','2014-04-03','17:00:00',3.48),('14598','2014-04-03','17:05:00',3.28),('14598','2014-04-03','17:10:00',3.07),('14598','2014-04-03','17:15:00',2.97),('14598','2014-04-03','17:20:00',2.78),('14598','2014-04-03','17:25:00',2.33),('14598','2014-04-03','17:30:00',2.43),('14598','2014-04-03','17:35:00',2.76),('14598','2014-04-03','17:40:00',2.58),('14598','2014-04-03','17:45:00',2.38),('14598','2014-04-03','17:50:00',2.19),('14598','2014-04-03','17:55:00',2.05),('14598','2014-04-03','18:00:00',1.94),('14598','2014-04-03','18:05:00',1.82),('14598','2014-04-03','18:10:00',1.69),('14598','2014-04-03','18:15:00',1.57),('14598','2014-04-03','18:20:00',1.2),('14598','2014-04-03','18:30:00',1.05),('14598','2014-04-03','18:35:00',1.11),('14598','2014-04-03','18:40:00',1.01),('14598','2013-06-10','08:25:00',1.19),('14598','2013-06-10','08:30:00',1.47),('14598','2013-06-10','08:35:00',1.8),('14598','2013-06-10','08:40:00',2.35),('14598','2013-06-10','08:45:00',1.1),('14598','2013-06-10','08:50:00',2.05),('14598','2013-06-10','08:55:00',2.31),('14598','2013-06-10','09:00:00',2.93),('14598','2013-06-10','09:05:00',2.6),('14598','2013-06-10','09:10:00',3.39),('14598','2013-06-10','09:15:00',3.53),('14598','2013-06-10','09:20:00',2.83),('14598','2013-06-10','09:25:00',3.64),('14598','2013-06-10','09:30:00',3.24),('14598','2013-06-10','09:35:00',2.59),('14598','2013-06-10','09:40:00',1.86),('14598','2013-06-10','09:45:00',2.3),('14598','2013-06-10','09:50:00',3.66),('14598','2013-06-10','09:55:00',2.32),('14598','2013-06-10','10:00:00',2.28),('14598','2013-06-10','10:05:00',2.15),('14598','2013-06-10','10:10:00',3.6),('14598','2013-06-10','10:15:00',4.15),('14598','2013-06-10','10:20:00',2.42),('14598','2013-06-10','10:25:00',2.04),('14598','2013-06-10','10:30:00',2.08),('14598','2013-06-10','10:35:00',2.61),('14598','2013-06-10','10:40:00',3.24),('14598','2013-06-10','10:45:00',3.68),('14598','2013-06-10','10:50:00',3.88),('14598','2013-06-10','10:55:00',4.29),('14598','2013-06-10','11:00:00',4.4),('14598','2013-06-10','11:05:00',4.86),('14598','2013-06-10','11:10:00',3.39),('14598','2013-06-10','11:15:00',3.11),('14598','2013-06-10','11:20:00',2.58),('14598','2013-06-10','11:25:00',3.06),('14598','2013-06-10','11:30:00',4.43),('14598','2013-06-10','11:35:00',5),('14598','2013-06-10','11:40:00',4.84),('14598','2013-06-10','11:45:00',4.67),('14598','2013-06-10','11:50:00',4.6),('14598','2013-06-10','11:55:00',4.91),('14598','2013-06-10','12:00:00',4.91),('14598','2013-06-10','12:05:00',4.91),('14598','2013-06-10','12:10:00',4.97),('14598','2013-06-10','12:15:00',5.01),('14598','2013-06-10','12:20:00',5.03),('14598','2013-06-10','12:25:00',5.1),('14598','2013-06-10','12:30:00',4.44),('14598','2013-06-10','12:35:00',4.99),('14598','2013-06-10','12:40:00',2.94),('14598','2013-06-10','12:45:00',4.78),('14598','2013-06-10','12:50:00',3.45),('14598','2013-06-10','12:55:00',4.97),('14598','2013-06-10','13:00:00',4.57),('14598','2013-06-10','13:05:00',5.11),('14598','2013-06-10','13:10:00',5.29),('14598','2013-06-10','13:15:00',5.3),('14598','2013-06-10','13:20:00',5.14),('14598','2013-06-10','13:25:00',5.46),('14598','2013-06-10','13:30:00',5.31),('14598','2013-06-10','13:35:00',5.33),('14598','2013-06-10','13:40:00',5.35),('14598','2013-06-10','13:45:00',5.32),('14598','2013-06-10','13:50:00',5.28),('14598','2013-06-10','13:55:00',5.32),('14598','2013-06-10','14:00:00',5.33),('14598','2013-06-10','14:05:00',5.31),('14598','2013-06-10','14:10:00',5.31),('14598','2013-06-10','14:15:00',5.34),('14598','2013-06-10','14:20:00',5.32),('14598','2013-06-10','14:25:00',5.31),('14598','2013-06-10','14:30:00',5.3),('14598','2013-06-10','14:35:00',5.28),('14598','2013-06-10','14:40:00',5.26),('14598','2013-06-10','14:45:00',5.25),('14598','2013-06-10','14:50:00',5.21),('14598','2013-06-10','14:55:00',5.18),('14598','2013-06-10','15:00:00',5.12),('14598','2013-06-10','15:05:00',5.12),('14598','2013-06-10','15:10:00',5.08),('14598','2013-06-10','15:15:00',5.04),('14598','2013-06-10','15:20:00',5),('14598','2013-06-10','15:25:00',4.99),('14598','2013-06-10','15:30:00',4.96),('14598','2013-06-10','15:35:00',4.87),('14598','2013-06-10','15:40:00',4.88),('14598','2013-06-10','15:45:00',4.84),('14598','2013-06-10','15:50:00',4.78),('14598','2013-06-10','15:55:00',4.72),('14598','2013-06-10','16:00:00',4.66),('14598','2013-06-10','16:05:00',4.62),('14598','2013-06-10','16:10:00',4.58),('14598','2013-06-10','16:15:00',4.52),('14598','2013-06-10','16:20:00',4.47),('14598','2013-06-10','16:25:00',4.41),('14598','2013-06-10','16:30:00',4.32),('14598','2013-06-10','16:35:00',4.27),('14598','2013-06-10','16:40:00',4.21),('14598','2013-06-10','16:45:00',4.13),('14598','2013-06-10','16:50:00',4.04),('14598','2013-06-10','16:55:00',4),('14598','2013-06-10','17:00:00',3.91),('14598','2013-06-10','17:05:00',3.84),('14598','2013-06-10','17:10:00',3.77),('14598','2013-06-10','17:15:00',3.69),('14598','2013-06-10','17:20:00',3.61),('14598','2013-06-10','17:25:00',3.54),('14598','2013-06-10','17:30:00',3.45),('14598','2013-06-10','17:35:00',3.34),('14598','2013-06-10','17:40:00',3.27),('14598','2013-06-10','17:45:00',3.18),('14598','2013-06-10','17:50:00',3.08),('14598','2013-06-10','17:55:00',3),('14598','2013-06-10','18:00:00',2.89),('14598','2013-06-10','18:05:00',2.79),('14598','2013-06-10','18:10:00',2.69),('14598','2013-06-10','18:15:00',2.59),('14598','2013-06-10','18:20:00',2.5),('14598','2013-06-10','18:25:00',2.4),('14598','2013-06-10','18:30:00',2.29),('14598','2013-06-10','18:35:00',2.16),('14598','2013-06-10','18:40:00',2.07),('14598','2013-06-10','18:45:00',1.96),('14598','2013-06-10','18:50:00',1.85),('14598','2013-06-10','18:55:00',1.75),('14598','2013-06-10','19:00:00',1.64),('14598','2013-06-10','19:05:00',1.53),('14598','2013-06-10','19:10:00',1.42),('14598','2013-06-10','19:15:00',1.32),('14598','2013-06-10','19:20:00',1.21),('14598','2013-06-10','19:25:00',1.11),('14598','2013-06-09','08:05:00',1.2),('14598','2013-06-09','08:10:00',1.36),('14598','2013-06-09','08:15:00',1.37),('14598','2013-06-09','08:20:00',1.72),('14598','2013-06-09','08:25:00',2),('14598','2013-06-09','08:30:00',1.98),('14598','2013-06-09','08:35:00',1.81),('14598','2013-06-09','08:40:00',1.65),('14598','2013-06-09','08:45:00',2.12),('14598','2013-06-09','08:50:00',1.71),('14598','2013-06-09','08:55:00',2.47),('14598','2013-06-09','09:00:00',1.91),('14598','2013-06-09','09:05:00',2.12),('14598','2013-06-09','09:15:00',2.73),('14598','2013-06-09','09:20:00',3.06),('14598','2013-06-09','09:25:00',1.79),('14598','2013-06-09','09:30:00',2.81),('14598','2013-06-09','09:35:00',2.01),('14598','2013-06-09','09:40:00',2.36),('14598','2013-06-09','09:45:00',3.03),('14598','2013-06-09','09:50:00',3.33),('14598','2013-06-09','09:55:00',3.45),('14598','2013-06-09','10:00:00',3.28),('14598','2013-06-09','10:05:00',3.44),('14598','2013-06-09','10:10:00',3.52),('14598','2013-06-09','10:15:00',3.63),('14598','2013-06-09','10:20:00',3.7),('14598','2013-06-09','10:25:00',3.79),('14598','2013-06-09','10:30:00',3.86),('14598','2013-06-09','10:35:00',3.93),('14598','2013-06-09','10:40:00',3.98),('14598','2013-06-09','10:45:00',4.05),('14598','2013-06-09','10:50:00',4.12),('14598','2013-06-09','10:55:00',4.18),('14598','2013-06-09','11:00:00',4.24),('14598','2013-06-09','11:05:00',4.28),('14598','2013-06-09','11:10:00',4.34),('14598','2013-06-09','11:15:00',4.38),('14598','2013-06-09','11:20:00',4.42),('14598','2013-06-09','11:25:00',4.47),('14598','2013-06-09','11:30:00',4.53),('14598','2013-06-09','11:35:00',4.58),('14598','2013-06-09','11:40:00',4.59),('14598','2013-06-09','11:45:00',4.71),('14598','2013-06-09','11:50:00',4.69),('14598','2013-06-09','11:55:00',4.35),('14598','2013-06-09','12:00:00',5),('14598','2013-06-09','12:05:00',4.85),('14598','2013-06-09','12:10:00',4.88),('14598','2013-06-09','12:15:00',4.98),('14598','2013-06-09','12:20:00',4.69),('14598','2013-06-09','12:25:00',5.25),('14598','2013-06-09','12:30:00',4.09),('14598','2013-06-09','12:35:00',4.61),('14598','2013-06-09','12:40:00',4.56),('14598','2013-06-09','12:45:00',4.77),('14598','2013-06-09','12:50:00',5.02),('14598','2013-06-09','12:55:00',5.27),('14598','2013-06-09','13:00:00',4.39),('14598','2013-06-09','13:05:00',4.96),('14598','2013-06-09','13:10:00',5.48),('14598','2013-06-09','13:15:00',4.65),('14598','2013-06-09','13:20:00',4.78),('14598','2013-06-09','13:25:00',3.9),('14598','2013-06-09','13:30:00',4.72),('14598','2013-06-09','13:35:00',2.62),('14598','2013-06-09','13:40:00',5.47),('14598','2013-06-09','13:45:00',5.53),('14598','2013-06-09','13:50:00',5.58),('14598','2013-06-09','13:55:00',5.87),('14598','2013-06-09','14:00:00',4.31),('14598','2013-06-09','14:05:00',1.77),('14598','2013-06-09','14:10:00',1.83),('14598','2013-06-09','14:15:00',1.94),('14598','2013-06-09','14:20:00',2.14),('14598','2013-06-09','14:25:00',5.16),('14598','2013-06-09','14:30:00',3.18),('14598','2013-06-09','14:35:00',4.26),('14598','2013-06-09','14:40:00',4.33),('14598','2013-06-09','14:45:00',3.74),('14598','2013-06-09','14:50:00',4.75),('14598','2013-06-09','14:55:00',2.63),('14598','2013-06-09','15:00:00',3.93),('14598','2013-06-09','15:05:00',4.3),('14598','2013-06-09','15:10:00',4.39),('14598','2013-06-09','15:15:00',5.47),('14598','2013-06-09','15:20:00',5.14),('14598','2013-06-09','15:25:00',4.54),('14598','2013-06-09','15:30:00',3.22),('14598','2013-06-09','15:35:00',1.98),('14598','2013-06-09','15:40:00',2.4),('14598','2013-06-09','15:45:00',2.86),('14598','2013-06-09','15:50:00',2.48),('14598','2013-06-09','15:55:00',3.07),('14598','2013-06-09','16:00:00',3.19),('14598','2013-06-09','16:05:00',4.67),('14598','2013-06-09','16:10:00',2.6),('14598','2013-06-09','16:15:00',1.98),('14598','2013-06-09','16:20:00',1.5),('14598','2013-06-09','16:25:00',1.39),('14598','2013-06-09','16:30:00',1.69),('14598','2013-06-09','16:35:00',2.2),('14598','2013-06-09','16:40:00',2.62),('14598','2013-06-09','16:45:00',3.34),('14598','2013-06-09','16:50:00',3.15),('14598','2013-06-09','16:55:00',1.55),('14598','2013-06-09','17:00:00',1.09),('14598','2013-06-09','17:55:00',1.7),('14598','2013-06-09','18:00:00',1.47),('14598','2013-06-09','18:05:00',1.03),('14598','2013-06-09','18:20:00',1.01),('14598','2013-06-08','07:45:00',1.02),('14598','2013-06-08','07:50:00',1.15),('14598','2013-06-08','07:55:00',1.13),('14598','2013-06-08','08:00:00',1.22),('14598','2013-06-08','08:05:00',1.31),('14598','2013-06-08','08:10:00',1.38),('14598','2013-06-08','08:15:00',1.48),('14598','2013-06-08','08:20:00',1.56),('14598','2013-06-08','08:25:00',1.68),('14598','2013-06-08','08:30:00',1.8),('14598','2013-06-08','08:35:00',1.64),('14598','2013-06-08','08:40:00',1.96),('14598','2013-06-08','08:45:00',2.11),('14598','2013-06-08','08:50:00',2.22),('14598','2013-06-08','08:55:00',2.28),('14598','2013-06-08','09:00:00',2.33),('14598','2013-06-08','09:05:00',2.47),('14598','2013-06-08','09:10:00',2.62),('14598','2013-06-08','09:15:00',2.39),('14598','2013-06-08','09:20:00',2.67),('14598','2013-06-08','09:25:00',3.68),('14598','2013-06-08','09:30:00',2.56),('14598','2013-06-08','09:35:00',3.07),('14598','2013-06-08','09:40:00',3.19),('14598','2013-06-08','09:45:00',3.29),('14598','2013-06-08','09:50:00',3.37),('14598','2013-06-08','09:55:00',3.4),('14598','2013-06-08','10:00:00',3.49),('14598','2013-06-08','10:05:00',3.59),('14598','2013-06-08','10:10:00',3.66),('14598','2013-06-08','10:15:00',3.74),('14598','2013-06-08','10:20:00',3.81),('14598','2013-06-08','10:25:00',3.9),('14598','2013-06-08','10:30:00',3.98),('14598','2013-06-08','10:35:00',4.02),('14598','2013-06-08','10:40:00',4.03),('14598','2013-06-08','10:45:00',4.16),('14598','2013-06-08','10:50:00',4.22),('14598','2013-06-08','10:55:00',4.29),('14598','2013-06-08','11:00:00',4.34),('14598','2013-06-08','11:05:00',4.4),('14598','2013-06-08','11:10:00',4.46),('14598','2013-06-08','11:15:00',4.51),('14598','2013-06-08','11:20:00',4.56),('14598','2013-06-08','11:25:00',4.61),('14598','2013-06-08','11:30:00',4.65),('14598','2013-06-08','11:35:00',4.68),('14598','2013-06-08','11:40:00',4.72),('14598','2013-06-08','11:45:00',4.77),('14598','2013-06-08','11:50:00',4.82),('14598','2013-06-08','11:55:00',4.9),('14598','2013-06-08','12:00:00',4.95),('14598','2013-06-08','12:05:00',4.9),('14598','2013-06-08','12:10:00',4.99),('14598','2013-06-08','12:15:00',4.83),('14598','2013-06-08','12:20:00',4.76),('14598','2013-06-08','12:25:00',5.01),('14598','2013-06-08','12:30:00',5.1),('14598','2013-06-08','12:35:00',5.13),('14598','2013-06-08','12:40:00',5.11),('14598','2013-06-08','12:45:00',5),('14598','2013-06-08','12:50:00',4.93),('14598','2013-06-08','12:55:00',4.94),('14598','2013-06-08','13:00:00',5.15),('14598','2013-06-08','13:05:00',5.19),('14598','2013-06-08','13:10:00',5.21),('14598','2013-06-08','13:15:00',5.26),('14598','2013-06-08','13:20:00',5.27),('14598','2013-06-08','13:25:00',5.3),('14598','2013-06-08','13:30:00',5.3),('14598','2013-06-08','13:35:00',5.31),('14598','2013-06-08','13:40:00',5.33),('14598','2013-06-08','13:45:00',5.33),('14598','2013-06-08','13:50:00',5.32),('14598','2013-06-08','13:55:00',5.31),('14598','2013-06-08','14:00:00',5.33),('14598','2013-06-08','14:05:00',5.3),('14598','2013-06-08','14:10:00',5.32),('14598','2013-06-08','14:15:00',5.29),('14598','2013-06-08','14:20:00',5.28),('14598','2013-06-08','14:25:00',5.27),('14598','2013-06-08','14:30:00',5.24),('14598','2013-06-08','14:35:00',5.25),('14598','2013-06-08','14:40:00',5.22),('14598','2013-06-08','14:45:00',5.16),('14598','2013-06-08','14:50:00',5.12),('14598','2013-06-08','14:55:00',5.17),('14598','2013-06-08','15:00:00',5.09),('14598','2013-06-08','15:05:00',4.65),('14598','2013-06-08','15:10:00',4.49),('14598','2013-06-08','15:15:00',4.76),('14598','2013-06-08','15:20:00',3.34),('14598','2013-06-08','15:25:00',3.3),('14598','2013-06-08','15:30:00',2.23),('14598','2013-06-08','15:35:00',3.88),('14598','2013-06-08','15:40:00',4.16),('14598','2013-06-08','15:45:00',4.9),('14598','2013-06-08','15:50:00',4.89),('14598','2013-06-08','15:55:00',4.8),('14598','2013-06-08','16:00:00',4.75),('14598','2013-06-08','16:05:00',4.66),('14598','2013-06-08','16:10:00',4.56),('14598','2013-06-08','16:15:00',4.35),('14598','2013-06-08','16:20:00',3.97),('14598','2013-06-08','16:25:00',4.11),('14598','2013-06-08','16:30:00',4.2),('14598','2013-06-08','16:35:00',4.27),('14598','2013-06-08','16:40:00',4.2),('14598','2013-06-08','16:45:00',4.19),('14598','2013-06-08','16:50:00',4.17),('14598','2013-06-08','16:55:00',4.12),('14598','2013-06-08','17:00:00',3.99),('14598','2013-06-08','17:05:00',3.89),('14598','2013-06-08','17:10:00',3.8),('14598','2013-06-08','17:15:00',3.5),('14598','2013-06-08','17:20:00',3.64),('14598','2013-06-08','17:25:00',3.77),('14598','2013-06-08','17:30:00',3.47),('14598','2013-06-08','17:35:00',3.23),('14598','2013-06-08','17:40:00',3.02),('14598','2013-06-08','17:45:00',2.33),('14598','2013-06-08','17:50:00',1.79),('14598','2013-06-08','17:55:00',1.84),('14598','2013-06-08','18:00:00',2.43),('14598','2013-06-08','18:05:00',2.28),('14598','2013-06-08','18:10:00',1.92),('14598','2013-06-08','18:15:00',1.23),('14598','2013-06-08','18:20:00',1.1),('14598','2013-06-07','07:45:00',1.01),('14598','2013-06-07','07:50:00',1.1),('14598','2013-06-07','07:55:00',1.19),('14598','2013-06-07','08:00:00',1.28),('14598','2013-06-07','08:05:00',1.37),('14598','2013-06-07','08:10:00',1.46),('14598','2013-06-07','08:15:00',1.57),('14598','2013-06-07','08:20:00',1.67),('14598','2013-06-07','08:25:00',1.77),('14598','2013-06-07','08:30:00',1.89),('14598','2013-06-07','08:35:00',1.98),('14598','2013-06-07','08:40:00',2.07),('14598','2013-06-07','08:45:00',2.21),('14598','2013-06-07','08:50:00',2.34),('14598','2013-06-07','08:55:00',2.47),('14598','2013-06-07','09:00:00',2.56),('14598','2013-06-07','09:05:00',2.64),('14598','2013-06-07','09:10:00',2.74),('14598','2013-06-07','09:15:00',2.86),('14598','2013-06-07','09:20:00',2.96),('14598','2013-06-07','09:25:00',3.05),('14598','2013-06-07','09:30:00',3.13),('14598','2013-06-07','09:35:00',3.22),('14598','2013-06-07','09:40:00',3.3),('14598','2013-06-07','09:45:00',3.39),('14598','2013-06-07','09:50:00',3.46),('14598','2013-06-07','09:55:00',3.54),('14598','2013-06-07','10:00:00',3.61),('14598','2013-06-07','10:05:00',3.67),('14598','2013-06-07','10:10:00',3.74),('14598','2013-06-07','10:15:00',3.82),('14598','2013-06-07','10:20:00',3.87),('14598','2013-06-07','10:25:00',3.97),('14598','2013-06-07','10:30:00',4.04),('14598','2013-06-07','10:35:00',4.08),('14598','2013-06-07','10:40:00',4.14),('14598','2013-06-07','10:45:00',4.2),('14598','2013-06-07','10:50:00',4.25),('14598','2013-06-07','10:55:00',4.29),('14598','2013-06-07','11:00:00',4.34),('14598','2013-06-07','11:05:00',4.41),('14598','2013-06-07','11:10:00',4.47),('14598','2013-06-07','11:15:00',4.5),('14598','2013-06-07','11:20:00',4.57),('14598','2013-06-07','11:25:00',4.59),('14598','2013-06-07','11:30:00',4.64),('14598','2013-06-07','11:35:00',4.65),('14598','2013-06-07','11:40:00',4.75),('14598','2013-06-07','11:45:00',4.8),('14598','2013-06-07','11:50:00',4.84),('14598','2013-06-07','11:55:00',4.87),('14598','2013-06-07','12:00:00',4.87),('14598','2013-06-07','12:05:00',4.9),('14598','2013-06-07','12:10:00',4.95),('14598','2013-06-07','12:15:00',4.96),('14598','2013-06-07','12:20:00',4.99),('14598','2013-06-07','12:25:00',4.99),('14598','2013-06-07','12:30:00',4.99),('14598','2013-06-07','12:35:00',4.99),('14598','2013-06-07','12:40:00',5.05),('14598','2013-06-07','12:45:00',5.07),('14598','2013-06-07','12:50:00',5.08),('14598','2013-06-07','12:55:00',5.09),('14598','2013-06-07','13:00:00',5.1),('14598','2013-06-07','13:05:00',5.19),('14598','2013-06-07','13:10:00',5.24),('14598','2013-06-07','13:15:00',5.33),('14598','2013-06-07','13:20:00',5.3),('14598','2013-06-07','13:25:00',5.41),('14598','2013-06-07','13:30:00',5.43),('14598','2013-06-07','13:35:00',5.41),('14598','2013-06-07','13:40:00',5.41),('14598','2013-06-07','13:45:00',5.42),('14598','2013-06-07','13:50:00',5.4),('14598','2013-06-07','13:55:00',5.4),('14598','2013-06-07','14:00:00',5.41),('14598','2013-06-07','14:05:00',5.42),('14598','2013-06-07','14:10:00',5.38),('14598','2013-06-07','14:15:00',5.36),('14598','2013-06-07','14:20:00',5.36),('14598','2013-06-07','14:25:00',5.37),('14598','2013-06-07','14:30:00',5.34),('14598','2013-06-07','14:35:00',5.27),('14598','2013-06-07','14:40:00',5.27),('14598','2013-06-07','14:45:00',5.24),('14598','2013-06-07','14:50:00',5.23),('14598','2013-06-07','14:55:00',5.21),('14598','2013-06-07','15:00:00',5.18),('14598','2013-06-07','15:05:00',5.14),('14598','2013-06-07','15:10:00',5.13),('14598','2013-06-07','15:15:00',5.07),('14598','2013-06-07','15:20:00',5.03),('14598','2013-06-07','15:25:00',5),('14598','2013-06-07','15:30:00',4.95),('14598','2013-06-07','15:35:00',4.91),('14598','2013-06-07','15:40:00',4.88),('14598','2013-06-07','15:45:00',4.86),('14598','2013-06-07','15:50:00',4.8),('14598','2013-06-07','15:55:00',4.74),('14598','2013-06-07','16:00:00',4.7),('14598','2013-06-07','16:05:00',4.62),('14598','2013-06-07','16:10:00',4.58),('14598','2013-06-07','16:15:00',4.52),('14598','2013-06-07','16:20:00',4.4),('14598','2013-06-07','16:25:00',4.4),('14598','2013-06-07','16:30:00',4.34),('14598','2013-06-07','16:35:00',4.25),('14598','2013-06-07','16:40:00',4.19),('14598','2013-06-07','16:45:00',4.14),('14598','2013-06-07','16:50:00',4.06),('14598','2013-06-07','16:55:00',3.98),('14598','2013-06-07','17:00:00',3.9),('14598','2013-06-07','17:05:00',3.82),('14598','2013-06-07','17:10:00',3.73),('14598','2013-06-07','17:15:00',3.64),('14598','2013-06-07','17:20:00',3.56),('14598','2013-06-07','17:25:00',3.49),('14598','2013-06-07','17:30:00',3.41),('14598','2013-06-07','17:35:00',3.32),('14598','2013-06-07','17:40:00',3.22),('14598','2013-06-07','17:45:00',3.12),('14598','2013-06-07','17:50:00',3.04),('14598','2013-06-07','17:55:00',2.94),('14598','2013-06-07','18:00:00',2.84),('14598','2013-06-07','18:05:00',2.74),('14598','2013-06-07','18:10:00',2.62),('14598','2013-06-07','18:15:00',2.55),('14598','2013-06-07','18:20:00',2.49),('14598','2013-06-07','18:25:00',2.31),('14598','2013-06-07','18:30:00',2.21),('14598','2013-06-07','18:35:00',2.12),('14598','2013-06-07','18:40:00',1.98),('14598','2013-06-07','18:45:00',1.88),('14598','2013-06-07','18:50:00',1.76),('14598','2013-06-07','18:55:00',1.66),('14598','2013-06-07','19:00:00',1.58),('14598','2013-06-07','19:05:00',1.5),('14598','2013-06-07','19:10:00',1.36),('14598','2013-06-07','19:15:00',1.21),('14598','2013-06-07','19:20:00',1.1),('14598','2013-06-06','07:40:00',1.02),('14598','2013-06-06','07:50:00',1.09),('14598','2013-06-06','07:55:00',1),('14598','2013-06-06','08:05:00',1.44),('14598','2013-06-06','08:10:00',1.51),('14598','2013-06-06','08:15:00',1.54),('14598','2013-06-06','08:20:00',1.62),('14598','2013-06-06','08:25:00',1.7),('14598','2013-06-06','08:30:00',1.85),('14598','2013-06-06','08:35:00',1.93),('14598','2013-06-06','08:40:00',2.07),('14598','2013-06-06','08:45:00',2.17),('14598','2013-06-06','08:50:00',2.02),('14598','2013-06-06','08:55:00',2.34),('14598','2013-06-06','09:00:00',2.42),('14598','2013-06-06','09:05:00',2.58),('14598','2013-06-06','09:10:00',2.73),('14598','2013-06-06','09:15:00',2.83),('14598','2013-06-06','09:20:00',2.88),('14598','2013-06-06','09:25:00',2.6),('14598','2013-06-06','09:30:00',3.05),('14598','2013-06-06','09:35:00',3.22),('14598','2013-06-06','09:40:00',2.78),('14598','2013-06-06','09:45:00',3.4),('14598','2013-06-06','09:50:00',3.43),('14598','2013-06-06','09:55:00',3.55),('14598','2013-06-06','10:00:00',3.71),('14598','2013-06-06','10:05:00',3.73),('14598','2013-06-06','10:10:00',3.59),('14598','2013-06-06','10:15:00',3.63),('14598','2013-06-06','10:20:00',3.73),('14598','2013-06-06','10:25:00',3.9),('14598','2013-06-06','10:30:00',3.79),('14598','2013-06-06','10:35:00',3.78),('14598','2013-06-06','10:40:00',4.09),('14598','2013-06-06','10:45:00',4.2),('14598','2013-06-06','10:50:00',4.16),('14598','2013-06-06','10:55:00',4.3),('14598','2013-06-06','11:00:00',4.3),('14598','2013-06-06','11:05:00',4.41),('14598','2013-06-06','11:10:00',4.44),('14598','2013-06-06','11:15:00',4.47),('14598','2013-06-06','11:20:00',4.55),('14598','2013-06-06','11:25:00',4.62),('14598','2013-06-06','11:30:00',4.66),('14598','2013-06-06','11:35:00',4.68),('14598','2013-06-06','11:40:00',4.74),('14598','2013-06-06','11:45:00',4.8),('14598','2013-06-06','11:50:00',4.8),('14598','2013-06-06','11:55:00',4.86),('14598','2013-06-06','12:00:00',4.91),('14598','2013-06-06','12:05:00',4.92),('14598','2013-06-06','12:10:00',4.95),('14598','2013-06-06','12:15:00',4.98),('14598','2013-06-06','12:20:00',5),('14598','2013-06-06','12:25:00',5.05),('14598','2013-06-06','12:30:00',5.15),('14598','2013-06-06','12:35:00',5.1),('14598','2013-06-06','12:40:00',5.13),('14598','2013-06-06','12:45:00',5.15),('14598','2013-06-06','12:50:00',5.21),('14598','2013-06-06','12:55:00',5.2),('14598','2013-06-06','13:00:00',5.22),('14598','2013-06-06','13:05:00',5.23),('14598','2013-06-06','13:10:00',5.24),('14598','2013-06-06','13:15:00',5.28),('14598','2013-06-06','13:20:00',5.28),('14598','2013-06-06','13:25:00',5.27),('14598','2013-06-06','13:30:00',5.25),('14598','2013-06-06','13:35:00',5.28),('14598','2013-06-06','13:40:00',5.28),('14598','2013-06-06','13:45:00',5.28),('14598','2013-06-06','13:50:00',5.3),('14598','2013-06-06','13:55:00',5.28),('14598','2013-06-06','14:00:00',5.27),('14598','2013-06-06','14:05:00',5.27),('14598','2013-06-06','14:10:00',5.27),('14598','2013-06-06','14:15:00',5.23),('14598','2013-06-06','14:20:00',5.19),('14598','2013-06-06','14:25:00',5.1),('14598','2013-06-06','14:30:00',5.18),('14598','2013-06-06','14:35:00',5.16),('14598','2013-06-06','14:40:00',5.15),('14598','2013-06-06','14:45:00',5.13),('14598','2013-06-06','14:50:00',5.08),('14598','2013-06-06','14:55:00',5.07),('14598','2013-06-06','15:00:00',5.04),('14598','2013-06-06','15:05:00',4.99),('14598','2013-06-06','15:10:00',4.99),('14598','2013-06-06','15:15:00',4.94),('14598','2013-06-06','15:20:00',4.89),('14598','2013-06-06','15:25:00',4.9),('14598','2013-06-06','15:30:00',4.82),('14598','2013-06-06','15:35:00',4.76),('14598','2013-06-06','15:40:00',4.73),('14598','2013-06-06','15:45:00',4.69),('14598','2013-06-06','15:50:00',4.6),('14598','2013-06-06','15:55:00',4.58),('14598','2013-06-06','16:00:00',4.54),('14598','2013-06-06','16:05:00',4.5),('14598','2013-06-06','16:10:00',4.46),('14598','2013-06-06','16:15:00',4.4),('14598','2013-06-06','16:20:00',4.36),('14598','2013-06-06','16:25:00',4.28),('14598','2013-06-06','16:30:00',4.23),('14598','2013-06-06','16:35:00',4.12),('14598','2013-06-06','16:40:00',4.1),('14598','2013-06-06','16:45:00',4.05),('14598','2013-06-06','16:50:00',3.99),('14598','2013-06-06','16:55:00',3.91),('14598','2013-06-06','17:00:00',3.84),('14598','2013-06-06','17:05:00',3.78),('14598','2013-06-06','17:10:00',3.69),('14598','2013-06-06','17:15:00',3.62),('14598','2013-06-06','17:20:00',3.53),('14598','2013-06-06','17:25:00',3.47),('14598','2013-06-06','17:30:00',3.38),('14598','2013-06-06','17:35:00',3.28),('14598','2013-06-06','17:40:00',3.18),('14598','2013-06-06','17:45:00',3.09),('14598','2013-06-06','17:50:00',3),('14598','2013-06-06','17:55:00',2.93),('14598','2013-06-06','18:00:00',2.84),('14598','2013-06-06','18:05:00',2.76),('14598','2013-06-06','18:10:00',2.63),('14598','2013-06-06','18:15:00',2.52),('14598','2013-06-06','18:20:00',2.42),('14598','2013-06-06','18:25:00',2.3),('14598','2013-06-06','18:30:00',2.19),('14598','2013-06-06','18:35:00',2.08),('14598','2013-06-06','18:40:00',1.97),('14598','2013-06-06','18:45:00',1.87),('14598','2013-06-06','18:50:00',1.76),('14598','2013-06-06','18:55:00',1.66),('14598','2013-06-06','19:00:00',1.54),('14598','2013-06-06','19:05:00',1.43),('14598','2013-06-06','19:10:00',1.32),('14598','2013-06-06','19:15:00',1.21),('14598','2013-06-06','19:20:00',1.1),('14598','2013-06-05','07:50:00',1.09),('14598','2013-06-05','07:55:00',1.19),('14598','2013-06-05','08:00:00',1.17),('14598','2013-06-05','08:05:00',1.19),('14598','2013-06-05','08:10:00',1.37),('14598','2013-06-05','08:15:00',1.49),('14598','2013-06-05','08:20:00',1.57),('14598','2013-06-05','08:25:00',1.5),('14598','2013-06-05','08:30:00',1.8),('14598','2013-06-05','08:35:00',1.89),('14598','2013-06-05','08:40:00',1.96),('14598','2013-06-05','08:45:00',2),('14598','2013-06-05','08:50:00',2.23),('14598','2013-06-05','08:55:00',2.33),('14598','2013-06-05','09:00:00',2.55),('14598','2013-06-05','09:05:00',2.92),('14598','2013-06-05','09:10:00',1.86),('14598','2013-06-05','09:20:00',1.15),('14598','2013-06-05','09:25:00',1.41),('14598','2013-06-05','09:30:00',1.37),('14598','2013-06-05','09:35:00',1.36),('14598','2013-06-05','09:40:00',2.23),('14598','2013-06-05','09:45:00',3.73),('14598','2013-06-05','09:50:00',3.54),('14598','2013-06-05','09:55:00',3.42),('14598','2013-06-05','10:00:00',2.04),('14598','2013-06-05','10:10:00',3.37),('14598','2013-06-05','10:15:00',3.96),('14598','2013-06-05','10:20:00',4.02),('14598','2013-06-05','10:25:00',4.03),('14598','2013-06-05','10:30:00',4.07),('14598','2013-06-05','10:35:00',4.16),('14598','2013-06-05','10:40:00',4.27),('14598','2013-06-05','10:45:00',4.32),('14598','2013-06-05','10:50:00',4.34),('14598','2013-06-05','10:55:00',4.22),('14598','2013-06-05','11:00:00',4.46),('14598','2013-06-05','11:05:00',4.47),('14598','2013-06-05','11:10:00',4.53),('14598','2013-06-05','11:15:00',4.54),('14598','2013-06-05','11:20:00',4.59),('14598','2013-06-05','11:25:00',4.67),('14598','2013-06-05','11:30:00',4.74),('14598','2013-06-05','11:35:00',4.77),('14598','2013-06-05','11:40:00',4.82),('14598','2013-06-05','11:45:00',4.87),('14598','2013-06-05','11:50:00',4.83),('14598','2013-06-05','11:55:00',4.94),('14598','2013-06-05','12:00:00',4.97),('14598','2013-06-05','12:05:00',5),('14598','2013-06-05','12:10:00',5.04),('14598','2013-06-05','12:15:00',5.07),('14598','2013-06-05','12:20:00',5.11),('14598','2013-06-05','12:25:00',5.13),('14598','2013-06-05','12:30:00',5.17),('14598','2013-06-05','12:35:00',5.2),('14598','2013-06-05','12:40:00',5.24),('14598','2013-06-05','12:45:00',5.26),('14598','2013-06-05','12:50:00',5.26),('14598','2013-06-05','12:55:00',5.29),('14598','2013-06-05','13:00:00',5.32),('14598','2013-06-05','13:05:00',5.34),('14598','2013-06-05','13:10:00',5.35),('14598','2013-06-05','13:15:00',5.36),('14598','2013-06-05','13:20:00',5.4),('14598','2013-06-05','13:25:00',5.43),('14598','2013-06-05','13:30:00',5.44),('14598','2013-06-05','13:35:00',5.37),('14598','2013-06-05','13:40:00',5.42),('14598','2013-06-05','13:45:00',5.38),('14598','2013-06-05','13:50:00',5.38),('14598','2013-06-05','13:55:00',5.35),('14598','2013-06-05','14:00:00',5.38),('14598','2013-06-05','14:05:00',5.36),('14598','2013-06-05','14:10:00',5.36),('14598','2013-06-05','14:15:00',5.32),('14598','2013-06-05','14:20:00',5.34),('14598','2013-06-05','14:25:00',5.33),('14598','2013-06-05','14:30:00',5.28),('14598','2013-06-05','14:35:00',5.24),('14598','2013-06-05','14:40:00',5.22),('14598','2013-06-05','14:45:00',5.17),('14598','2013-06-05','14:50:00',5.17),('14598','2013-06-05','14:55:00',5.11),('14598','2013-06-05','15:00:00',5.13),('14598','2013-06-05','15:05:00',5.13),('14598','2013-06-05','15:10:00',5.17),('14598','2013-06-05','15:15:00',5.07),('14598','2013-06-05','15:20:00',4.83),('14598','2013-06-05','15:25:00',5),('14598','2013-06-05','15:30:00',4.68),('14598','2013-06-05','15:35:00',4.88),('14598','2013-06-05','15:40:00',4.86),('14598','2013-06-05','15:45:00',4.86),('14598','2013-06-05','15:50:00',4.3),('14598','2013-06-05','15:55:00',3.76),('14598','2013-06-05','16:00:00',4.39),('14598','2013-06-05','16:05:00',4.52),('14598','2013-06-05','16:10:00',4.24),('14598','2013-06-05','16:15:00',4.4),('14598','2013-06-05','16:20:00',4.38),('14598','2013-06-05','16:25:00',4.27),('14598','2013-06-05','16:30:00',4.18),('14598','2013-06-05','16:35:00',4.15),('14598','2013-06-05','16:40:00',4.08),('14598','2013-06-05','16:45:00',4.02),('14598','2013-06-05','16:50:00',3.92),('14598','2013-06-05','16:55:00',3.84),('14598','2013-06-05','17:00:00',3.76),('14598','2013-06-05','17:05:00',3.7),('14598','2013-06-05','17:10:00',3.62),('14598','2013-06-05','17:15:00',3.54),('14598','2013-06-05','17:20:00',3.45),('14598','2013-06-05','17:25:00',3.36),('14598','2013-06-05','17:30:00',3.22),('14598','2013-06-05','17:35:00',3.18),('14598','2013-06-05','17:40:00',3.11),('14598','2013-06-05','17:45:00',3.01),('14598','2013-06-05','17:50:00',2.92),('14598','2013-06-05','17:55:00',2.77),('14598','2013-06-05','18:00:00',2.32),('14598','2013-06-05','18:05:00',2.61),('14598','2013-06-05','18:10:00',2.5),('14598','2013-06-05','18:15:00',2.4),('14598','2013-06-05','18:20:00',2.29),('14598','2013-06-05','18:25:00',2.2),('14598','2013-06-05','18:30:00',2.1),('14598','2013-06-05','18:35:00',2),('14598','2013-06-05','18:40:00',1.91),('14598','2013-06-05','18:45:00',1.76),('14598','2013-06-05','18:50:00',1.69),('14598','2013-06-05','18:55:00',1.47),('14598','2013-06-05','19:00:00',1.45),('14598','2013-06-05','19:05:00',1.36),('14598','2013-06-05','19:10:00',1.25),('14598','2013-06-05','19:15:00',1.17),('14598','2013-06-05','19:20:00',1.03),('14598','2013-06-04','07:30:00',1.03),('14598','2013-06-04','07:35:00',1.1),('14598','2013-06-04','07:40:00',1.04),('14598','2013-06-04','08:15:00',1.07),('14598','2013-06-04','08:20:00',1.26),('14598','2013-06-04','08:25:00',1.27),('14598','2013-06-04','08:30:00',1.09),('14598','2013-06-04','08:35:00',1.02),('14598','2013-06-04','08:40:00',1.24),('14598','2013-06-04','08:45:00',1.5),('14598','2013-06-04','08:50:00',2.01),('14598','2013-06-04','08:55:00',2.1),('14598','2013-06-04','09:00:00',1.89),('14598','2013-06-04','09:05:00',1.76),('14598','2013-06-04','09:10:00',1.78),('14598','2013-06-04','09:15:00',1.53),('14598','2013-06-04','09:20:00',1.28),('14598','2013-06-04','09:25:00',1.32),('14598','2013-06-04','09:30:00',1.4),('14598','2013-06-04','09:35:00',1.54),('14598','2013-06-04','09:40:00',1.62),('14598','2013-06-04','09:45:00',1.85),('14598','2013-06-04','09:50:00',1.88),('14598','2013-06-04','09:55:00',2.46),('14598','2013-06-04','10:00:00',2.54),('14598','2013-06-04','10:05:00',2.85),('14598','2013-06-04','10:10:00',3.11),('14598','2013-06-04','10:15:00',2.85),('14598','2013-06-04','10:20:00',2.54),('14598','2013-06-04','10:25:00',2.7),('14598','2013-06-04','10:30:00',3.35),('14598','2013-06-04','10:35:00',4.22),('14598','2013-06-04','10:40:00',3.05),('14598','2013-06-04','10:45:00',2.2),('14598','2013-06-04','10:50:00',2.11),('14598','2013-06-04','10:55:00',1.9),('14598','2013-06-04','11:00:00',1.68),('14598','2013-06-04','11:05:00',2.2),('14598','2013-06-04','11:10:00',2.68),('14598','2013-06-04','11:15:00',4.31),('14598','2013-06-04','11:20:00',3.79),('14598','2013-06-04','11:25:00',3.6),('14598','2013-06-04','11:30:00',4.42),('14598','2013-06-04','11:35:00',3.66),('14598','2013-06-04','11:40:00',4.73),('14598','2013-06-04','11:45:00',5.18),('14598','2013-06-04','11:50:00',5.06),('14598','2013-06-04','11:55:00',5.5),('14598','2013-06-04','12:00:00',5.53),('14598','2013-06-04','12:05:00',3.38),('14598','2013-06-04','12:10:00',3.63),('14598','2013-06-04','12:15:00',2.9),('14598','2013-06-04','12:20:00',3.33),('14598','2013-06-04','12:25:00',3.82),('14598','2013-06-04','12:30:00',2.42),('14598','2013-06-04','12:35:00',2.63),('14598','2013-06-04','12:40:00',3.22),('14598','2013-06-04','12:45:00',2.21),('14598','2013-06-04','12:50:00',1.92),('14598','2013-06-04','12:55:00',2),('14598','2013-06-04','13:00:00',2.69),('14598','2013-06-04','13:05:00',2.94),('14598','2013-06-04','13:10:00',3.46),('14598','2013-06-04','13:15:00',3.4),('14598','2013-06-04','13:20:00',4.03),('14598','2013-06-04','13:25:00',3.65),('14598','2013-06-04','13:30:00',3.22),('14598','2013-06-04','13:35:00',3.06),('14598','2013-06-04','13:40:00',2.92),('14598','2013-06-04','13:45:00',2.76),('14598','2013-06-04','13:50:00',2.79),('14598','2013-06-04','13:55:00',3.3),('14598','2013-06-04','14:00:00',4.96),('14598','2013-06-04','14:05:00',5.41),('14598','2013-06-04','14:10:00',5.38),('14598','2013-06-04','14:15:00',5.26),('14598','2013-06-04','14:20:00',5.61),('14598','2013-06-04','14:25:00',5.17),('14598','2013-06-04','14:30:00',5.53),('14598','2013-06-04','14:35:00',5.45),('14598','2013-06-04','14:40:00',5.2),('14598','2013-06-04','14:45:00',5.18),('14598','2013-06-04','14:50:00',5.36),('14598','2013-06-04','14:55:00',5.41),('14598','2013-06-04','15:00:00',4.92),('14598','2013-06-04','15:05:00',5.04),('14598','2013-06-04','15:10:00',5.17),('14598','2013-06-04','15:15:00',4.9),('14598','2013-06-04','15:20:00',5.01),('14598','2013-06-04','15:25:00',4.9),('14598','2013-06-04','15:30:00',4.41),('14598','2013-06-04','15:35:00',4.31),('14598','2013-06-04','15:40:00',2.58),('14598','2013-06-04','15:45:00',3.22),('14598','2013-06-04','15:50:00',3.89),('14598','2013-06-04','15:55:00',4.22),('14598','2013-06-04','16:00:00',4.35),('14598','2013-06-04','16:05:00',4.42),('14598','2013-06-04','16:10:00',3.69),('14598','2013-06-04','16:15:00',3.9),('14598','2013-06-04','16:20:00',4.11),('14598','2013-06-04','16:25:00',3.05),('14598','2013-06-04','16:30:00',2.97),('14598','2013-06-04','16:35:00',2.66),('14598','2013-06-04','16:40:00',2.57),('14598','2013-06-04','16:45:00',2.19),('14598','2013-06-04','16:50:00',1.64),('14598','2013-06-04','16:55:00',1.54),('14598','2013-06-04','17:00:00',1.45),('14598','2013-06-04','17:05:00',1.34),('14598','2013-06-04','17:10:00',1.24),('14598','2013-06-04','17:15:00',1.18),('14598','2013-06-04','17:20:00',1.17),('14598','2013-06-04','17:25:00',1.15),('14598','2013-06-04','17:30:00',1.12),('14598','2013-06-04','17:35:00',1.1),('14598','2013-06-04','17:40:00',1.11),('14598','2013-06-04','17:45:00',1.21),('14598','2013-06-04','17:50:00',1.37),('14598','2013-06-04','17:55:00',1.49),('14598','2013-06-04','18:00:00',1.31),('14598','2013-06-04','18:05:00',1.17),('14598','2013-06-04','18:25:00',1.14),('14598','2013-06-04','18:30:00',1.41),('14598','2013-06-04','18:35:00',1.35),('14598','2013-06-04','18:50:00',1.19),('14598','2013-06-03','07:35:00',1.04),('14598','2013-06-03','07:40:00',1.12),('14598','2013-06-03','07:45:00',1.18),('14598','2013-06-03','07:55:00',1.11),('14598','2013-06-03','08:00:00',1.28),('14598','2013-06-03','08:05:00',1.35),('14598','2013-06-03','08:10:00',1.43),('14598','2013-06-03','08:15:00',1.54),('14598','2013-06-03','08:20:00',1.69),('14598','2013-06-03','08:25:00',1.82),('14598','2013-06-03','08:30:00',2.21),('14598','2013-06-03','08:35:00',2.45),('14598','2013-06-03','08:40:00',2.48),('14598','2013-06-03','08:45:00',2.44),('14598','2013-06-03','08:50:00',1.45),('14598','2013-06-03','08:55:00',1.22),('14598','2013-06-03','09:00:00',2.84),('14598','2013-06-03','09:05:00',2.27),('14598','2013-06-03','09:10:00',1.76),('14598','2013-06-03','09:15:00',1.62),('14598','2013-06-03','09:20:00',1.29),('14598','2013-06-03','09:25:00',1.52),('14598','2013-06-03','10:00:00',1.28),('14598','2013-06-03','10:05:00',2.76),('14598','2013-06-03','10:10:00',3.41),('14598','2013-06-03','10:15:00',3.53),('14598','2013-06-03','10:20:00',4.86),('14598','2013-06-03','10:25:00',2.27),('14598','2013-06-03','10:30:00',2.19),('14598','2013-06-03','10:35:00',2.68),('14598','2013-06-03','10:40:00',3.07),('14598','2013-06-03','10:45:00',3.15),('14598','2013-06-03','10:50:00',2.71),('14598','2013-06-03','10:55:00',1.74),('14598','2013-06-03','11:00:00',2.24),('14598','2013-06-03','11:05:00',2.91),('14598','2013-06-03','11:10:00',1.73),('14598','2013-06-03','11:15:00',1.85),('14598','2013-06-03','11:20:00',2.14),('14598','2013-06-03','11:25:00',2.84),('14598','2013-06-03','11:30:00',3.27),('14598','2013-06-03','11:35:00',4.19),('14598','2013-06-03','11:40:00',5.93),('14598','2013-06-03','11:45:00',4.76),('14598','2013-06-03','11:50:00',5.58),('14598','2013-06-03','11:55:00',5.48),('14598','2013-06-03','12:00:00',4.09),('14598','2013-06-03','12:05:00',1.6),('14598','2013-06-03','12:10:00',2.09),('14598','2013-06-03','12:15:00',3),('14598','2013-06-03','12:20:00',2.38),('14598','2013-06-03','12:25:00',1.93),('14598','2013-06-03','12:30:00',2.03),('14598','2013-06-03','12:35:00',2.75),('14598','2013-06-03','12:40:00',3.52),('14598','2013-06-03','12:45:00',3.93),('14598','2013-06-03','12:50:00',5.62),('14598','2013-06-03','12:55:00',6.02),('14598','2013-06-03','13:00:00',5.26),('14598','2013-06-03','13:05:00',3.95),('14598','2013-06-03','13:10:00',4.04),('14598','2013-06-03','13:15:00',2.7),('14598','2013-06-03','13:20:00',4.76),('14598','2013-06-03','13:25:00',5.22),('14598','2013-06-03','13:30:00',2.89),('14598','2013-06-03','13:35:00',2.42),('14598','2013-06-03','13:40:00',5.62),('14598','2013-06-03','13:45:00',4.93),('14598','2013-06-03','13:50:00',5.08),('14598','2013-06-03','13:55:00',2.27),('14598','2013-06-03','14:00:00',4.55),('14598','2013-06-03','14:05:00',2.89),('14598','2013-06-03','14:10:00',5.44),('14598','2013-06-03','14:15:00',5.47),('14598','2013-06-03','14:20:00',5.37),('14598','2013-06-03','14:25:00',5.35),('14598','2013-06-03','14:30:00',5.27),('14598','2013-06-03','14:35:00',5.2),('14598','2013-06-03','14:40:00',5.19),('14598','2013-06-03','14:45:00',5.09),('14598','2013-06-03','14:50:00',5.16),('14598','2013-06-03','14:55:00',5.17),('14598','2013-06-03','15:00:00',5.14),('14598','2013-06-03','15:05:00',5.14),('14598','2013-06-03','15:10:00',5.19),('14598','2013-06-03','15:15:00',5.16),('14598','2013-06-03','15:20:00',5.07),('14598','2013-06-03','15:25:00',5.05),('14598','2013-06-03','15:30:00',5.06),('14598','2013-06-03','15:35:00',5.04),('14598','2013-06-03','15:40:00',4.94),('14598','2013-06-03','15:45:00',4.49),('14598','2013-06-03','15:50:00',4.73),('14598','2013-06-03','15:55:00',4.69),('14598','2013-06-03','16:00:00',4.63),('14598','2013-06-03','16:05:00',4.58),('14598','2013-06-03','16:10:00',4.53),('14598','2013-06-03','16:15:00',4.5),('14598','2013-06-03','16:20:00',4.48),('14598','2013-06-03','16:25:00',4.47),('14598','2013-06-03','16:30:00',4.39),('14598','2013-06-03','16:35:00',4.05),('14598','2013-06-03','16:40:00',3.48),('14598','2013-06-03','16:45:00',2.98),('14598','2013-06-03','16:50:00',3.18),('14598','2013-06-03','16:55:00',4.24),('14598','2013-06-03','17:00:00',2.92),('14598','2013-06-03','17:05:00',4.22),('14598','2013-06-03','17:10:00',4.1),('14598','2013-06-03','17:15:00',3.64),('14598','2013-06-03','17:20:00',3.93),('14598','2013-06-03','17:25:00',4.11),('14598','2013-06-03','17:30:00',3.8),('14598','2013-06-03','17:35:00',3.42),('14598','2013-06-03','17:40:00',3.67),('14598','2013-06-03','17:45:00',3.58),('14598','2013-06-03','17:50:00',2.58),('14598','2013-06-03','17:55:00',1.68),('14598','2013-06-03','18:00:00',1.37),('14598','2013-06-03','18:05:00',1.31),('14598','2013-06-02','08:25:00',1.39),('14598','2013-06-02','08:30:00',2.41),('14598','2013-06-02','08:35:00',1.62),('14598','2013-06-02','08:40:00',1.61),('14598','2013-06-02','08:45:00',2.11),('14598','2013-06-02','08:50:00',2.57),('14598','2013-06-02','08:55:00',2.59),('14598','2013-06-02','09:00:00',2.61),('14598','2013-06-02','09:05:00',2.71),('14598','2013-06-02','09:10:00',2.86),('14598','2013-06-02','09:15:00',2.94),('14598','2013-06-02','09:20:00',2.92),('14598','2013-06-02','09:25:00',2.99),('14598','2013-06-02','09:30:00',3.09),('14598','2013-06-02','09:35:00',3.16),('14598','2013-06-02','09:40:00',3.27),('14598','2013-06-02','09:45:00',3.45),('14598','2013-06-02','09:50:00',2.77),('14598','2013-06-02','09:55:00',2.41),('14598','2013-06-02','10:00:00',3.87),('14598','2013-06-02','10:05:00',3.85),('14598','2013-06-02','10:10:00',3.92),('14598','2013-06-02','10:15:00',4.13),('14598','2013-06-02','10:20:00',3.26),('14598','2013-06-02','10:25:00',4.01),('14598','2013-06-02','10:30:00',4.12),('14598','2013-06-02','10:35:00',4.15),('14598','2013-06-02','10:40:00',4.22),('14598','2013-06-02','10:45:00',4.25),('14598','2013-06-02','10:50:00',4.31),('14598','2013-06-02','10:55:00',4.38),('14598','2013-06-02','11:00:00',4.46),('14598','2013-06-02','11:05:00',4.53),('14598','2013-06-02','11:10:00',4.55),('14598','2013-06-02','11:15:00',4.6),('14598','2013-06-02','11:20:00',4.7),('14598','2013-06-02','11:25:00',4.76),('14598','2013-06-02','11:30:00',4.8),('14598','2013-06-02','11:35:00',4.83),('14598','2013-06-02','11:40:00',4.88),('14598','2013-06-02','11:45:00',4.91),('14598','2013-06-02','11:50:00',4.95),('14598','2013-06-02','11:55:00',4.97),('14598','2013-06-02','12:00:00',4.92),('14598','2013-06-02','12:05:00',5.04),('14598','2013-06-02','12:10:00',5.07),('14598','2013-06-02','12:15:00',5.12),('14598','2013-06-02','12:20:00',5.15),('14598','2013-06-02','12:25:00',5.14),('14598','2013-06-02','12:30:00',5.2),('14598','2013-06-02','12:35:00',5.22),('14598','2013-06-02','12:40:00',5.24),('14598','2013-06-02','12:45:00',5.27),('14598','2013-06-02','12:50:00',5.29),('14598','2013-06-02','12:55:00',5.28),('14598','2013-06-02','13:00:00',5.28),('14598','2013-06-02','13:05:00',5.31),('14598','2013-06-02','13:10:00',5.32),('14598','2013-06-02','13:15:00',5.32),('14598','2013-06-02','13:20:00',5.32),('14598','2013-06-02','13:25:00',5.33),('14598','2013-06-02','13:30:00',5.31),('14598','2013-06-02','13:35:00',5.32),('14598','2013-06-02','13:40:00',5.04),('14598','2013-06-02','13:45:00',5.38),('14598','2013-06-02','13:50:00',5.42),('14598','2013-06-02','13:55:00',5.44),('14598','2013-06-02','14:00:00',4.27),('14598','2013-06-02','14:05:00',5.23),('14598','2013-06-02','14:10:00',5.54),('14598','2013-06-02','14:15:00',5.5),('14598','2013-06-02','14:20:00',5.12),('14598','2013-06-02','14:25:00',4.24),('14598','2013-06-02','14:30:00',5.41),('14598','2013-06-02','14:35:00',5.27),('14598','2013-06-02','14:40:00',5.22),('14598','2013-06-02','14:45:00',5.25),('14598','2013-06-02','14:50:00',5.09),('14598','2013-06-02','14:55:00',4.65),('14598','2013-06-02','15:00:00',5.27),('14598','2013-06-02','15:05:00',4.82),('14598','2013-06-02','15:10:00',3.83),('14598','2013-06-02','15:15:00',2.93),('14598','2013-06-02','15:20:00',3.11),('14598','2013-06-02','15:25:00',3.87),('14598','2013-06-02','15:30:00',5.15),('14598','2013-06-02','15:35:00',4.62),('14598','2013-06-02','15:40:00',4.77),('14598','2013-06-02','15:45:00',4.4),('14598','2013-06-02','15:50:00',4.18),('14598','2013-06-02','15:55:00',4.55),('14598','2013-06-02','16:00:00',3.89),('14598','2013-06-02','16:05:00',4.58),('14598','2013-06-02','16:10:00',4.69),('14598','2013-06-02','16:15:00',3.83),('14598','2013-06-02','16:20:00',4.22),('14598','2013-06-02','16:25:00',4.27),('14598','2013-06-02','16:30:00',4.19),('14598','2013-06-02','16:35:00',3.91),('14598','2013-06-02','16:40:00',4.08),('14598','2013-06-02','16:45:00',3.66),('14598','2013-06-02','16:50:00',3.65),('14598','2013-06-02','16:55:00',3.94),('14598','2013-06-02','17:00:00',2.73),('14598','2013-06-02','17:05:00',2.73),('14598','2013-06-02','17:10:00',2.97),('14598','2013-06-02','17:15:00',3.55),('14598','2013-06-02','17:20:00',2.62),('14598','2013-06-02','17:25:00',2.46),('14598','2013-06-02','17:30:00',3.06),('14598','2013-06-02','17:35:00',3.18),('14598','2013-06-02','17:40:00',1.76),('14598','2013-06-02','17:45:00',2.88),('14598','2013-06-02','17:50:00',3.13),('14598','2013-06-02','17:55:00',3.03),('14598','2013-06-02','18:00:00',2.69),('14598','2013-06-02','18:05:00',2.68),('14598','2013-06-02','18:10:00',2.53),('14598','2013-06-02','18:15:00',2.42),('14598','2013-06-02','18:20:00',2.32),('14598','2013-06-02','18:25:00',2.2),('14598','2013-06-02','18:30:00',2.08),('14598','2013-06-02','18:35:00',1.97),('14598','2013-06-02','18:40:00',1.84),('14598','2013-06-02','18:45:00',1.69),('14598','2013-06-02','18:50:00',1.62),('14598','2013-06-02','18:55:00',1.5),('14598','2013-06-02','19:00:00',1.41),('14598','2013-06-02','19:05:00',1.31),('14598','2013-06-02','19:10:00',1.22),('14598','2013-06-02','19:15:00',1.09),('14598','2013-06-02','19:20:00',1.01),('14598','2013-06-01','07:45:00',1.02),('14598','2013-06-01','08:00:00',1),('14598','2013-06-01','08:05:00',1.19),('14598','2013-06-01','08:10:00',1.34),('14598','2013-06-01','08:15:00',1.07),('14598','2013-06-01','08:20:00',1.34),('14598','2013-06-01','08:25:00',1.18),('14598','2013-06-01','08:30:00',1.27),('14598','2013-06-01','08:35:00',1.11),('14598','2013-06-01','08:55:00',1.03),('14598','2013-06-01','09:05:00',1.52),('14598','2013-06-01','09:10:00',3.52),('14598','2013-06-01','09:15:00',2.78),('14598','2013-06-01','09:20:00',3.76),('14598','2013-06-01','09:25:00',3.48),('14598','2013-06-01','09:30:00',1.19),('14598','2013-06-01','10:20:00',1.34),('14598','2013-06-01','10:25:00',1.64),('14598','2013-06-01','10:30:00',2.42),('14598','2013-06-01','10:35:00',2.83),('14598','2013-06-01','10:40:00',1.13),('14598','2013-06-01','10:50:00',1.06),('14598','2013-06-01','10:55:00',1.35),('14598','2013-06-01','11:00:00',1.62),('14598','2013-06-01','11:05:00',1.97),('14598','2013-06-01','11:10:00',2.25),('14598','2013-06-01','11:15:00',1.83),('14598','2013-06-01','11:20:00',1.75),('14598','2013-06-01','11:25:00',1.37),('14598','2013-06-01','11:30:00',1.11),('14598','2013-06-01','11:35:00',1.18),('14598','2013-06-01','11:40:00',2.06),('14598','2013-06-01','11:45:00',3.58),('14598','2013-06-01','11:50:00',3.81),('14598','2013-06-01','11:55:00',5.36),('14598','2013-06-01','12:00:00',5.16),('14598','2013-06-01','12:05:00',3.15),('14598','2013-06-01','12:10:00',3.04),('14598','2013-06-01','12:15:00',2.91),('14598','2013-06-01','12:20:00',2.97),('14598','2013-06-01','12:25:00',2.96),('14598','2013-06-01','12:30:00',2.97),('14598','2013-06-01','12:35:00',3.1),('14598','2013-06-01','12:40:00',3.35),('14598','2013-06-01','12:45:00',3.41),('14598','2013-06-01','12:50:00',3.26),('14598','2013-06-01','12:55:00',3.38),('14598','2013-06-01','13:00:00',3.59),('14598','2013-06-01','13:05:00',3.8),('14598','2013-06-01','13:10:00',4.11),('14598','2013-06-01','13:15:00',4.23),('14598','2013-06-01','13:20:00',3.56),('14598','2013-06-01','13:25:00',4.12),('14598','2013-06-01','13:30:00',5.35),('14598','2013-06-01','13:35:00',4.58),('14598','2013-06-01','13:40:00',5.36),('14598','2013-06-01','13:45:00',3.58),('14598','2013-06-01','13:50:00',2.32),('14598','2013-06-01','13:55:00',2.27),('14598','2013-06-01','14:00:00',2.82),('14598','2013-06-01','14:05:00',3.44),('14598','2013-06-01','14:10:00',3.18),('14598','2013-06-01','14:15:00',3.19),('14598','2013-06-01','14:20:00',3.72),('14598','2013-06-01','14:25:00',3.19),('14598','2013-06-01','14:30:00',2.97),('14598','2013-06-01','14:35:00',2.51),('14598','2013-06-01','14:40:00',1.57),('14598','2013-06-01','14:45:00',1.63),('14598','2013-06-01','14:50:00',1.89),('14598','2013-06-01','14:55:00',1.48),('14598','2013-06-01','15:00:00',1.4),('14598','2013-06-01','15:05:00',1.37),('14598','2013-06-01','15:10:00',1.08),('14598','2013-06-01','15:15:00',1.27),('14598','2013-06-01','15:20:00',1.17),('14598','2013-06-01','15:30:00',1.23),('14598','2013-06-01','15:35:00',1.55),('14598','2013-06-01','15:40:00',1.41),('14598','2013-06-01','15:45:00',1.21),('14598','2013-06-01','15:50:00',1.08),('14598','2013-06-01','15:55:00',1.13),('14598','2013-06-01','16:00:00',1.16),('14598','2013-06-01','16:05:00',1.49),('14598','2013-06-01','16:10:00',1.72),('14598','2013-06-01','16:15:00',1.57),('14598','2013-06-01','16:20:00',1.26),('14598','2013-06-01','16:25:00',1.23),('14598','2013-06-01','16:30:00',1.24),('14598','2013-06-01','16:35:00',1.24),('14598','2013-06-01','16:40:00',1.16),('14598','2013-06-01','17:45:00',2.42),('14598','2013-06-01','17:50:00',3.85),('14598','2013-06-01','17:55:00',4.07),('14598','2013-06-01','18:00:00',3.54),('14598','2013-06-01','18:05:00',3.12),('14598','2013-06-01','18:10:00',2.85),('14598','2013-06-01','18:15:00',2.81),('14598','2013-06-01','18:20:00',2.94),('14598','2013-06-01','18:25:00',2.81),('14598','2013-06-01','18:30:00',2.55),('14598','2013-06-01','18:35:00',2.27),('14598','2013-06-01','18:40:00',1.94),('14598','2013-06-01','18:45:00',1.2),('14598','2013-06-01','18:50:00',1.74),('14598','2013-06-01','18:55:00',1.62),('14598','2013-06-01','19:20:00',1.2),('14598','2013-06-01','19:25:00',1.14),('14598','2013-06-01','19:30:00',1.1),('14598','2013-06-01','19:35:00',1.04),('14598','2014-04-02','09:00:00',1.34),('14598','2014-04-02','09:05:00',1.33),('14598','2014-04-02','09:10:00',1.09),('14598','2014-04-02','09:15:00',1.03),('14598','2014-04-02','09:20:00',1.08),('14598','2014-04-02','09:25:00',1.08),('14598','2014-04-02','09:30:00',1.11),('14598','2014-04-02','09:35:00',1.09),('14598','2014-04-02','09:40:00',2.1),('14598','2014-04-02','09:45:00',2.55),('14598','2014-04-02','09:50:00',2.51),('14598','2014-04-02','09:55:00',2.59),('14598','2014-04-02','10:00:00',2.81),('14598','2014-04-02','10:05:00',3.15),('14598','2014-04-02','10:10:00',2.13),('14598','2014-04-02','10:25:00',2.64),('14598','2014-04-02','10:30:00',3.85),('14598','2014-04-02','10:35:00',3.8),('14598','2014-04-02','10:40:00',2.57),('14598','2014-04-02','10:45:00',3.42),('14598','2014-04-02','10:50:00',1.91),('14598','2014-04-02','10:55:00',3.19),('14598','2014-04-02','11:00:00',3.49),('14598','2014-04-02','11:05:00',3.84),('14598','2014-04-02','11:10:00',3.8),('14598','2014-04-02','11:15:00',3.92),('14598','2014-04-02','11:20:00',3.93),('14598','2014-04-02','11:25:00',3.96),('14598','2014-04-02','11:30:00',4.14),('14598','2014-04-02','11:35:00',4.2),('14598','2014-04-02','11:40:00',4.22),('14598','2014-04-02','11:45:00',4.21),('14598','2014-04-02','11:50:00',4.26),('14598','2014-04-02','11:55:00',4.32),('14598','2014-04-02','12:00:00',4.37),('14598','2014-04-02','12:05:00',4.41),('14598','2014-04-02','12:10:00',4.43),('14598','2014-04-02','12:15:00',4.46),('14598','2014-04-02','12:20:00',4.54),('14598','2014-04-02','12:25:00',4.6),('14598','2014-04-02','12:30:00',4.64),('14598','2014-04-02','12:35:00',4.66),('14598','2014-04-02','12:40:00',4.75),('14598','2014-04-02','12:45:00',4.76),('14598','2014-04-02','12:50:00',4.77),('14598','2014-04-02','12:55:00',4.8),('14598','2014-04-02','13:00:00',4.8),('14598','2014-04-02','13:05:00',4.83),('14598','2014-04-02','13:10:00',4.95),('14598','2014-04-02','13:15:00',3.9),('14598','2014-04-02','13:20:00',4.74),('14598','2014-04-02','13:25:00',5.09),('14598','2014-04-02','13:30:00',5.08),('14598','2014-04-02','13:35:00',4.84),('14598','2014-04-02','13:40:00',4.62),('14598','2014-04-02','13:45:00',3.83),('14598','2014-04-02','13:50:00',4.84),('14598','2014-04-02','13:55:00',4.99),('14598','2014-04-02','14:00:00',3.79),('14598','2014-04-02','14:05:00',4.61),('14598','2014-04-02','14:10:00',4.86),('14598','2014-04-02','14:15:00',4.73),('14598','2014-04-02','14:20:00',4.78),('14598','2014-04-02','14:25:00',4.66),('14598','2014-04-02','14:30:00',4.76),('14598','2014-04-02','14:35:00',4.72),('14598','2014-04-02','14:40:00',4.64),('14598','2014-04-02','14:45:00',4.49),('14598','2014-04-02','14:50:00',4.47),('14598','2014-04-02','14:55:00',4.51),('14598','2014-04-02','15:00:00',3.7),('14598','2014-04-02','15:05:00',4.57),('14598','2014-04-02','15:10:00',4.47),('14598','2014-04-02','15:15:00',4.36),('14598','2014-04-02','15:20:00',4.35),('14598','2014-04-02','15:25:00',4.38),('14598','2014-04-02','15:30:00',4.29),('14598','2014-04-02','15:35:00',4.13),('14598','2014-04-02','15:40:00',4.24),('14598','2014-04-02','15:45:00',4.1),('14598','2014-04-02','15:50:00',4.05),('14598','2014-04-02','15:55:00',4.05),('14598','2014-04-02','16:00:00',3.9),('14598','2014-04-02','16:05:00',3.88),('14598','2014-04-02','16:10:00',3.88),('14598','2014-04-02','16:15:00',3.78),('14598','2014-04-02','16:20:00',3.72),('14598','2014-04-02','16:25:00',3.52),('14598','2014-04-02','16:30:00',3.39),('14598','2014-04-02','16:35:00',3.27),('14598','2014-04-02','16:40:00',3.1),('14598','2014-04-02','16:45:00',3.12),('14598','2014-04-02','16:50:00',3.23),('14598','2014-04-02','16:55:00',3.04),('14598','2014-04-02','17:00:00',2.9),('14598','2014-04-02','17:05:00',2.54),('14598','2014-04-02','17:10:00',2.2),('14598','2014-04-02','17:15:00',2.35),('14598','2014-04-02','17:20:00',2.22),('14598','2014-04-02','17:25:00',2.1),('14598','2014-04-02','17:30:00',2.11),('14598','2014-04-02','17:35:00',1.77),('14598','2014-04-02','17:40:00',1.88),('14598','2014-04-02','17:45:00',2.3),('14598','2014-04-02','17:50:00',1.94),('14598','2014-04-02','17:55:00',1.51),('14598','2014-04-02','18:00:00',1.24),('14598','2014-04-02','18:05:00',1.02),('14598','2014-04-02','18:10:00',1.03),('14598','2014-04-02','18:15:00',1.04),('14598','2013-05-31','07:45:00',1.08),('14598','2013-05-31','07:50:00',1.13),('14598','2013-05-31','07:55:00',1.25),('14598','2013-05-31','08:00:00',1.35),('14598','2013-05-31','08:05:00',1.41),('14598','2013-05-31','08:10:00',1.53),('14598','2013-05-31','08:15:00',1.65),('14598','2013-05-31','08:20:00',1.79),('14598','2013-05-31','08:25:00',1.94),('14598','2013-05-31','08:30:00',2.04),('14598','2013-05-31','08:35:00',2.14),('14598','2013-05-31','08:40:00',2.09),('14598','2013-05-31','08:45:00',2.08),('14598','2013-05-31','08:50:00',2.14),('14598','2013-05-31','08:55:00',2.49),('14598','2013-05-31','09:00:00',2.6),('14598','2013-05-31','09:05:00',2.81),('14598','2013-05-31','09:10:00',2.7),('14598','2013-05-31','09:15:00',2.83),('14598','2013-05-31','09:20:00',3.19),('14598','2013-05-31','09:25:00',3.43),('14598','2013-05-31','09:30:00',3.81),('14598','2013-05-31','09:35:00',2.61),('14598','2013-05-31','09:40:00',4.16),('14598','2013-05-31','09:45:00',3.97),('14598','2013-05-31','09:50:00',3.56),('14598','2013-05-31','09:55:00',1.46),('14598','2013-05-31','10:00:00',1.22),('14598','2013-05-31','10:05:00',1.52),('14598','2013-05-31','10:10:00',4.46),('14598','2013-05-31','10:15:00',3.15),('14598','2013-05-31','10:20:00',2.85),('14598','2013-05-31','10:25:00',3.41),('14598','2013-05-31','10:30:00',4.73),('14598','2013-05-31','10:35:00',4.98),('14598','2013-05-31','10:40:00',2.97),('14598','2013-05-31','10:45:00',1.51),('14598','2013-05-31','10:50:00',4.46),('14598','2013-05-31','10:55:00',4.74),('14598','2013-05-31','11:00:00',5.12),('14598','2013-05-31','11:05:00',1.61),('14598','2013-05-31','11:10:00',4.6),('14598','2013-05-31','11:15:00',3.49),('14598','2013-05-31','11:20:00',3.85),('14598','2013-05-31','11:25:00',4.88),('14598','2013-05-31','11:30:00',4.98),('14598','2013-05-31','11:35:00',5.04),('14598','2013-05-31','11:40:00',5.36),('14598','2013-05-31','11:45:00',5.94),('14598','2013-05-31','11:50:00',2.7),('14598','2013-05-31','11:55:00',1.49),('14598','2013-05-31','12:00:00',2.85),('14598','2013-05-31','12:05:00',3.3),('14598','2013-05-31','12:10:00',3.07),('14598','2013-05-31','12:15:00',1.98),('14598','2013-05-31','12:20:00',2.06),('14598','2013-05-31','12:25:00',2.19),('14598','2013-05-31','12:30:00',2.93),('14598','2013-05-31','12:35:00',3.51),('14598','2013-05-31','12:40:00',1.8),('14598','2013-05-31','12:45:00',1.06),('14598','2013-05-31','12:50:00',1.97),('14598','2013-05-31','12:55:00',2.86),('14598','2013-05-31','13:00:00',2.81),('14598','2013-05-31','13:05:00',2.27),('14598','2013-05-31','13:10:00',2.48),('14598','2013-05-31','13:15:00',1.87),('14598','2013-05-31','13:20:00',1.96),('14598','2013-05-31','13:25:00',2.22),('14598','2013-05-31','13:30:00',2.36),('14598','2013-05-31','13:35:00',2.5),('14598','2013-05-31','13:40:00',1.26),('14598','2013-05-31','14:05:00',1.02),('14598','2013-05-31','14:10:00',3.41),('14598','2013-05-31','14:15:00',3.03),('14598','2013-05-31','14:20:00',4.48),('14598','2013-05-31','14:25:00',2.64),('14598','2013-05-31','14:30:00',1.42),('14598','2013-05-31','14:35:00',1.51),('14598','2013-05-31','14:45:00',1.01),('14598','2013-05-31','14:50:00',1.58),('14598','2013-05-31','14:55:00',2.23),('14598','2013-05-31','15:00:00',2.46),('14598','2013-05-31','15:05:00',1.79),('14598','2013-05-31','15:10:00',1.86),('14598','2013-05-31','15:15:00',1.77),('14598','2013-05-31','15:20:00',1.6),('14598','2013-05-31','15:25:00',2.13),('14598','2013-05-31','15:30:00',2.98),('14598','2013-05-31','15:35:00',3.19),('14598','2013-05-31','15:40:00',2.16),('14598','2013-05-31','15:45:00',1.12),('14598','2013-05-31','15:55:00',1.07),('14598','2013-05-31','16:00:00',1.35),('14598','2013-05-31','16:05:00',1.43),('14598','2013-05-31','16:10:00',1.1),('14598','2013-05-31','16:20:00',1.4),('14598','2013-05-31','16:25:00',1.31),('14598','2013-05-31','17:00:00',1.15),('14598','2013-05-31','17:05:00',1.24),('14598','2013-05-31','17:10:00',1.25),('14598','2013-05-31','17:15:00',1.2),('14598','2013-05-31','17:20:00',1.03),('14598','2013-05-31','17:25:00',1.05),('14598','2013-05-31','17:30:00',1.19),('14598','2013-05-31','17:35:00',1.19),('14598','2013-05-31','19:20:00',1.12),('14598','2013-05-31','19:25:00',1.12),('14598','2013-05-30','07:30:00',1.08),('14598','2013-05-30','08:15:00',1.73),('14598','2013-05-30','08:20:00',1.86),('14598','2013-05-30','08:25:00',2.12),('14598','2013-05-30','08:30:00',2.31),('14598','2013-05-30','08:35:00',2.26),('14598','2013-05-30','08:40:00',2.36),('14598','2013-05-30','08:45:00',2.65),('14598','2013-05-30','08:50:00',1.95),('14598','2013-05-30','08:55:00',2.34),('14598','2013-05-30','09:00:00',2.65),('14598','2013-05-30','09:05:00',2.73),('14598','2013-05-30','09:10:00',2.84),('14598','2013-05-30','09:15:00',2.96),('14598','2013-05-30','09:20:00',3.06),('14598','2013-05-30','09:25:00',3.21),('14598','2013-05-30','09:30:00',3.28),('14598','2013-05-30','09:35:00',3.47),('14598','2013-05-30','09:40:00',3.68),('14598','2013-05-30','09:45:00',3.46),('14598','2013-05-30','09:50:00',3.2),('14598','2013-05-30','09:55:00',1.85),('14598','2013-05-30','10:00:00',2.12),('14598','2013-05-30','10:05:00',3.38),('14598','2013-05-30','10:10:00',3.71),('14598','2013-05-30','10:15:00',4.06),('14598','2013-05-30','10:20:00',4.09),('14598','2013-05-30','10:25:00',4.16),('14598','2013-05-30','10:30:00',4.21),('14598','2013-05-30','10:35:00',4.31),('14598','2013-05-30','10:40:00',4.42),('14598','2013-05-30','10:45:00',4.43),('14598','2013-05-30','10:50:00',4.53),('14598','2013-05-30','10:55:00',4.64),('14598','2013-05-30','11:00:00',3.93),('14598','2013-05-30','11:05:00',3.45),('14598','2013-05-30','11:10:00',4.24),('14598','2013-05-30','11:15:00',2.19),('14598','2013-05-30','11:20:00',4.05),('14598','2013-05-30','11:25:00',5.46),('14598','2013-05-30','11:30:00',5.52),('14598','2013-05-30','11:35:00',3.78),('14598','2013-05-30','11:40:00',3.78),('14598','2013-05-30','11:45:00',3.58),('14598','2013-05-30','11:50:00',4.54),('14598','2013-05-30','11:55:00',4.01),('14598','2013-05-30','12:00:00',4.14),('14598','2013-05-30','12:05:00',3.95),('14598','2013-05-30','12:10:00',5.5),('14598','2013-05-30','12:15:00',5.62),('14598','2013-05-30','12:20:00',4.4),('14598','2013-05-30','12:25:00',4.33),('14598','2013-05-30','12:30:00',3.43),('14598','2013-05-30','12:35:00',3.96),('14598','2013-05-30','12:40:00',4.83),('14598','2013-05-30','12:45:00',4.47),('14598','2013-05-30','12:50:00',5.98),('14598','2013-05-30','12:55:00',4.4),('14598','2013-05-30','13:00:00',4.42),('14598','2013-05-30','13:05:00',4.51),('14598','2013-05-30','13:10:00',4.01),('14598','2013-05-30','13:15:00',4.93),('14598','2013-05-30','13:20:00',4.88),('14598','2013-05-30','13:25:00',3.79),('14598','2013-05-30','13:30:00',5.78),('14598','2013-05-30','13:35:00',5.73),('14598','2013-05-30','13:40:00',5.64),('14598','2013-05-30','13:45:00',4.61),('14598','2013-05-30','13:50:00',5.36),('14598','2013-05-30','13:55:00',5.24),('14598','2013-05-30','14:00:00',4.4),('14598','2013-05-30','14:05:00',2.87),('14598','2013-05-30','14:10:00',5.47),('14598','2013-05-30','14:15:00',2.38),('14598','2013-05-30','14:20:00',4.19),('14598','2013-05-30','14:25:00',6.03),('14598','2013-05-30','14:30:00',2.92),('14598','2013-05-30','14:35:00',4.3),('14598','2013-05-30','14:40:00',3.14),('14598','2013-05-30','14:45:00',4.23),('14598','2013-05-30','14:50:00',5.66),('14598','2013-05-30','14:55:00',5.55),('14598','2013-05-30','15:00:00',5.18),('14598','2013-05-30','15:05:00',5.14),('14598','2013-05-30','15:10:00',5.68),('14598','2013-05-30','15:15:00',5.26),('14598','2013-05-30','15:20:00',4.98),('14598','2013-05-30','15:25:00',5.51),('14598','2013-05-30','15:30:00',5.61),('14598','2013-05-30','15:35:00',3.69),('14598','2013-05-30','15:40:00',3.63),('14598','2013-05-30','15:45:00',5.51),('14598','2013-05-30','15:50:00',4.66),('14598','2013-05-30','15:55:00',4.99),('14598','2013-05-30','16:00:00',3.26),('14598','2013-05-30','16:05:00',4.3),('14598','2013-05-30','16:10:00',3.45),('14598','2013-05-30','16:15:00',3.39),('14598','2013-05-30','16:20:00',3.23),('14598','2013-05-30','16:25:00',2.61),('14598','2013-05-30','16:30:00',2.52),('14598','2013-05-30','16:35:00',3),('14598','2013-05-30','16:40:00',3.49),('14598','2013-05-30','16:45:00',2.02),('14598','2013-05-30','16:50:00',1.38),('14598','2013-05-30','16:55:00',1.09),('14598','2013-05-30','17:20:00',1.12),('14598','2013-05-30','17:25:00',1.64),('14598','2013-05-30','17:30:00',1.25),('14598','2013-05-30','17:35:00',2.19),('14598','2013-05-30','17:40:00',3.83),('14598','2013-05-30','17:45:00',3.36),('14598','2013-05-30','17:50:00',2.3),('14598','2013-05-30','17:55:00',1.97),('14598','2013-05-30','18:00:00',2.41),('14598','2013-05-30','18:05:00',1.29),('14598','2013-05-30','18:10:00',1.87),('14598','2013-05-30','18:15:00',3.08),('14598','2013-05-30','18:20:00',3.16),('14598','2013-05-30','18:25:00',1.45),('14598','2013-05-30','19:20:00',1.54),('14598','2013-05-30','19:25:00',1.39),('14598','2013-05-29','07:50:00',1.06),('14598','2013-05-29','07:55:00',1.15),('14598','2013-05-29','08:00:00',1.25),('14598','2013-05-29','08:05:00',1.34),('14598','2013-05-29','08:10:00',1.44),('14598','2013-05-29','08:15:00',1.55),('14598','2013-05-29','08:20:00',1.67),('14598','2013-05-29','08:25:00',1.78),('14598','2013-05-29','08:30:00',1.88),('14598','2013-05-29','08:35:00',1.98),('14598','2013-05-29','08:40:00',2.09),('14598','2013-05-29','08:45:00',2.23),('14598','2013-05-29','08:50:00',2.34),('14598','2013-05-29','08:55:00',2.45),('14598','2013-05-29','09:00:00',2.53),('14598','2013-05-29','09:05:00',2.63),('14598','2013-05-29','09:10:00',2.72),('14598','2013-05-29','09:15:00',2.85),('14598','2013-05-29','09:20:00',2.95),('14598','2013-05-29','09:25:00',3.04),('14598','2013-05-29','09:30:00',3.12),('14598','2013-05-29','09:35:00',3.22),('14598','2013-05-29','09:40:00',3.32),('14598','2013-05-29','09:45:00',3.4),('14598','2013-05-29','09:50:00',3.48),('14598','2013-05-29','09:55:00',3.56),('14598','2013-05-29','10:00:00',3.64),('14598','2013-05-29','10:05:00',3.72),('14598','2013-05-29','10:10:00',3.8),('14598','2013-05-29','10:15:00',3.87),('14598','2013-05-29','10:20:00',3.94),('14598','2013-05-29','10:25:00',4.02),('14598','2013-05-29','10:30:00',4.09),('14598','2013-05-29','10:35:00',4.2),('14598','2013-05-29','10:40:00',4.07),('14598','2013-05-29','10:45:00',4.31),('14598','2013-05-29','10:50:00',4.38),('14598','2013-05-29','10:55:00',4.43),('14598','2013-05-29','11:00:00',4.5),('14598','2013-05-29','11:05:00',4.58),('14598','2013-05-29','11:10:00',4.65),('14598','2013-05-29','11:15:00',4.72),('14598','2013-05-29','11:20:00',4.49),('14598','2013-05-29','11:25:00',4.31),('14598','2013-05-29','11:30:00',4.28),('14598','2013-05-29','11:35:00',4.33),('14598','2013-05-29','11:40:00',3.54),('14598','2013-05-29','11:45:00',4.35),('14598','2013-05-29','11:50:00',4.06),('14598','2013-05-29','11:55:00',4.71),('14598','2013-05-29','12:00:00',5.22),('14598','2013-05-29','12:05:00',5.18),('14598','2013-05-29','12:10:00',5.19),('14598','2013-05-29','12:15:00',5.23),('14598','2013-05-29','12:20:00',5.23),('14598','2013-05-29','12:25:00',5.21),('14598','2013-05-29','12:30:00',5.28),('14598','2013-05-29','12:35:00',5.33),('14598','2013-05-29','12:40:00',5.32),('14598','2013-05-29','12:45:00',5.37),('14598','2013-05-29','12:50:00',5.41),('14598','2013-05-29','12:55:00',5.44),('14598','2013-05-29','13:00:00',5.53),('14598','2013-05-29','13:05:00',5.22),('14598','2013-05-29','13:10:00',3.49),('14598','2013-05-29','13:15:00',3.93),('14598','2013-05-29','13:20:00',5.34),('14598','2013-05-29','13:25:00',5.87),('14598','2013-05-29','13:30:00',5.57),('14598','2013-05-29','13:35:00',5.47),('14598','2013-05-29','13:40:00',5.46),('14598','2013-05-29','13:45:00',5.17),('14598','2013-05-29','13:50:00',5.34),('14598','2013-05-29','13:55:00',5.47),('14598','2013-05-29','14:00:00',5.39),('14598','2013-05-29','14:05:00',5.43),('14598','2013-05-29','14:10:00',5.4),('14598','2013-05-29','14:15:00',5.42),('14598','2013-05-29','14:20:00',5.43),('14598','2013-05-29','14:25:00',5.34),('14598','2013-05-29','14:30:00',5.34),('14598','2013-05-29','14:35:00',5.32),('14598','2013-05-29','14:40:00',5.17),('14598','2013-05-29','14:45:00',5.28),('14598','2013-05-29','14:50:00',5.39),('14598','2013-05-29','14:55:00',5.56),('14598','2013-05-29','15:00:00',4.95),('14598','2013-05-29','15:05:00',4.03),('14598','2013-05-29','15:10:00',3.74),('14598','2013-05-29','15:15:00',3.81),('14598','2013-05-29','15:20:00',4.26),('14598','2013-05-29','15:25:00',3.91),('14598','2013-05-29','15:30:00',3.69),('14598','2013-05-29','15:35:00',3.48),('14598','2013-05-29','15:40:00',4.09),('14598','2013-05-29','15:45:00',4.48),('14598','2013-05-29','15:50:00',3.62),('14598','2013-05-29','15:55:00',4.2),('14598','2013-05-29','16:00:00',4.13),('14598','2013-05-29','16:05:00',2.95),('14598','2013-05-29','16:10:00',2.77),('14598','2013-05-29','16:15:00',2.55),('14598','2013-05-29','16:20:00',2.27),('14598','2013-05-29','16:25:00',1.76),('14598','2013-05-29','16:30:00',1.15),('14598','2013-05-29','16:55:00',1.07),('14598','2013-05-29','17:00:00',1.5),('14598','2013-05-29','17:05:00',2.14),('14598','2013-05-29','17:10:00',1.93),('14598','2013-05-29','17:15:00',1.91),('14598','2013-05-29','17:20:00',2.06),('14598','2013-05-29','17:25:00',1.77),('14598','2013-05-29','17:30:00',1.97),('14598','2013-05-29','17:35:00',1.76),('14598','2013-05-29','17:40:00',1.54),('14598','2013-05-29','17:45:00',1.29),('14598','2013-05-29','17:50:00',1.27),('14598','2013-05-29','18:30:00',1.95),('14598','2013-05-29','18:35:00',1.48),('14598','2013-05-29','18:40:00',1.68),('14598','2013-05-29','18:45:00',1.18),('14598','2013-05-29','19:00:00',1.6),('14598','2013-05-29','19:05:00',1.53),('14598','2013-05-28','07:40:00',1.02),('14598','2013-05-28','07:50:00',1.07),('14598','2013-05-28','07:55:00',1.08),('14598','2013-05-28','08:05:00',1.03),('14598','2013-05-28','08:10:00',1.27),('14598','2013-05-28','08:15:00',1.31),('14598','2013-05-28','08:20:00',1.56),('14598','2013-05-28','08:25:00',1.48),('14598','2013-05-28','08:30:00',1.4),('14598','2013-05-28','08:35:00',1.65),('14598','2013-05-28','08:40:00',1.83),('14598','2013-05-28','08:45:00',1.89),('14598','2013-05-28','08:50:00',1.6),('14598','2013-05-28','08:55:00',1.54),('14598','2013-05-28','09:00:00',1.77),('14598','2013-05-28','09:05:00',2),('14598','2013-05-28','09:10:00',1.97),('14598','2013-05-28','09:15:00',1.97),('14598','2013-05-28','09:20:00',2.58),('14598','2013-05-28','09:25:00',2.66),('14598','2013-05-28','09:30:00',2.79),('14598','2013-05-28','09:35:00',2.81),('14598','2013-05-28','09:40:00',3.11),('14598','2013-05-28','09:45:00',2.31),('14598','2013-05-28','09:50:00',2.45),('14598','2013-05-28','09:55:00',2.23),('14598','2013-05-28','10:00:00',2.44),('14598','2013-05-28','10:05:00',2.78),('14598','2013-05-28','10:10:00',2.71),('14598','2013-05-28','10:15:00',2.42),('14598','2013-05-28','10:20:00',2.64),('14598','2013-05-28','10:25:00',2.7),('14598','2013-05-28','10:30:00',2.89),('14598','2013-05-28','10:35:00',3.2),('14598','2013-05-28','10:40:00',3.22),('14598','2013-05-28','10:45:00',2.4),('14598','2013-05-28','10:50:00',2.71),('14598','2013-05-28','10:55:00',2.47),('14598','2013-05-28','11:00:00',2.56),('14598','2013-05-28','11:05:00',2.3),('14598','2013-05-28','11:10:00',2.67),('14598','2013-05-28','11:15:00',4.63),('14598','2013-05-28','11:20:00',4.6),('14598','2013-05-28','11:25:00',4.09),('14598','2013-05-28','11:30:00',3.58),('14598','2013-05-28','11:35:00',2.38),('14598','2013-05-28','11:40:00',2.78),('14598','2013-05-28','11:45:00',2.53),('14598','2013-05-28','11:50:00',2.77),('14598','2013-05-28','11:55:00',3.18),('14598','2013-05-28','12:00:00',4.8),('14598','2013-05-28','12:05:00',5.28),('14598','2013-05-28','12:10:00',3.92),('14598','2013-05-28','12:15:00',3.1),('14598','2013-05-28','12:20:00',3.16),('14598','2013-05-28','12:25:00',2.94),('14598','2013-05-28','12:30:00',2.97),('14598','2013-05-28','12:35:00',2.7),('14598','2013-05-28','12:40:00',2.55),('14598','2013-05-28','12:45:00',2.69),('14598','2013-05-28','12:50:00',4.37),('14598','2013-05-28','12:55:00',4.05),('14598','2013-05-28','13:00:00',3.87),('14598','2013-05-28','13:05:00',4.48),('14598','2013-05-28','13:10:00',3.72),('14598','2013-05-28','13:15:00',4.21),('14598','2013-05-28','13:20:00',4.24),('14598','2013-05-28','13:25:00',4.07),('14598','2013-05-28','13:30:00',2.46),('14598','2013-05-28','13:35:00',2.77),('14598','2013-05-28','13:40:00',2.62),('14598','2013-05-28','13:45:00',2.04),('14598','2013-05-28','13:50:00',1.75),('14598','2013-05-28','13:55:00',1.99),('14598','2013-05-28','14:00:00',2.29),('14598','2013-05-28','14:05:00',2.27),('14598','2013-05-28','14:10:00',2.74),('14598','2013-05-28','14:15:00',3.84),('14598','2013-05-28','14:20:00',3.09),('14598','2013-05-28','14:25:00',4.02),('14598','2013-05-28','14:30:00',3.56),('14598','2013-05-28','14:35:00',3.68),('14598','2013-05-28','14:40:00',3.25),('14598','2013-05-28','14:45:00',4.14),('14598','2013-05-28','14:50:00',3.53),('14598','2013-05-28','14:55:00',2.96),('14598','2013-05-28','15:00:00',3.54),('14598','2013-05-28','15:05:00',4.13),('14598','2013-05-28','15:10:00',3.82),('14598','2013-05-28','15:15:00',3.56),('14598','2013-05-28','15:20:00',2.65),('14598','2013-05-28','15:25:00',2.26),('14598','2013-05-28','15:30:00',2.49),('14598','2013-05-28','15:35:00',2.91),('14598','2013-05-28','15:40:00',2.49),('14598','2013-05-28','15:45:00',3.13),('14598','2013-05-28','15:50:00',2.97),('14598','2013-05-28','15:55:00',2.2),('14598','2013-05-28','16:00:00',2.33),('14598','2013-05-28','16:05:00',2.15),('14598','2013-05-28','16:10:00',2.09),('14598','2013-05-28','16:15:00',2.34),('14598','2013-05-28','16:20:00',2.4),('14598','2013-05-28','16:25:00',4.15),('14598','2013-05-28','16:30:00',2.38),('14598','2013-05-28','16:35:00',1.54),('14598','2013-05-28','16:40:00',1.56),('14598','2013-05-28','16:45:00',2.07),('14598','2013-05-28','16:50:00',1.67),('14598','2013-05-28','16:55:00',1.44),('14598','2013-05-28','17:00:00',1.49),('14598','2013-05-28','17:05:00',1.51),('14598','2013-05-28','17:10:00',1.35),('14598','2013-05-28','17:15:00',1.59),('14598','2013-05-28','17:20:00',2.52),('14598','2013-05-28','17:25:00',2.18),('14598','2013-05-28','17:30:00',2.37),('14598','2013-05-28','17:35:00',1.67),('14598','2013-05-28','17:40:00',1.42),('14598','2013-05-28','17:45:00',1.29),('14598','2013-05-28','17:50:00',1.11),('14598','2013-05-28','17:55:00',1.14),('14598','2013-05-28','18:00:00',1.13),('14598','2013-05-28','18:05:00',1.76),('14598','2013-05-28','18:10:00',2.64),('14598','2013-05-28','18:15:00',2.36),('14598','2013-05-28','18:20:00',2.25),('14598','2013-05-28','18:25:00',2.14),('14598','2013-05-28','18:30:00',2.05),('14598','2013-05-28','18:35:00',1.93),('14598','2013-05-28','18:40:00',1.8),('14598','2013-05-28','18:45:00',1.63),('14598','2013-05-28','18:50:00',1.57),('14598','2013-05-28','18:55:00',1.39),('14598','2013-05-27','07:50:00',1.1),('14598','2013-05-27','07:55:00',1.18),('14598','2013-05-27','08:00:00',1.14),('14598','2013-05-27','08:05:00',1.08),('14598','2013-05-27','08:10:00',1.22),('14598','2013-05-27','08:15:00',1.56),('14598','2013-05-27','08:20:00',1.65),('14598','2013-05-27','08:25:00',1.77),('14598','2013-05-27','08:30:00',1.88),('14598','2013-05-27','08:35:00',1.98),('14598','2013-05-27','08:40:00',2.1),('14598','2013-05-27','08:45:00',2.21),('14598','2013-05-27','08:50:00',2.34),('14598','2013-05-27','08:55:00',2.45),('14598','2013-05-27','09:00:00',2.52),('14598','2013-05-27','09:05:00',2.62),('14598','2013-05-27','09:10:00',2.74),('14598','2013-05-27','09:15:00',2.87),('14598','2013-05-27','09:20:00',2.94),('14598','2013-05-27','09:25:00',3.06),('14598','2013-05-27','09:30:00',3.16),('14598','2013-05-27','09:35:00',3.25),('14598','2013-05-27','09:40:00',3.34),('14598','2013-05-27','09:45:00',3.43),('14598','2013-05-27','09:50:00',3.52),('14598','2013-05-27','09:55:00',3.59),('14598','2013-05-27','10:00:00',3.68),('14598','2013-05-27','10:05:00',3.76),('14598','2013-05-27','10:10:00',3.84),('14598','2013-05-27','10:15:00',3.91),('14598','2013-05-27','10:20:00',3.98),('14598','2013-05-27','10:25:00',4.06),('14598','2013-05-27','10:30:00',4.12),('14598','2013-05-27','10:35:00',4.19),('14598','2013-05-27','10:40:00',4.25),('14598','2013-05-27','10:45:00',4.36),('14598','2013-05-27','10:50:00',4.42),('14598','2013-05-27','10:55:00',4.47),('14598','2013-05-27','11:00:00',4.56),('14598','2013-05-27','11:05:00',4.77),('14598','2013-05-27','11:10:00',4.78),('14598','2013-05-27','11:15:00',4.76),('14598','2013-05-27','11:20:00',4.78),('14598','2013-05-27','11:25:00',4.85),('14598','2013-05-27','11:30:00',4.88),('14598','2013-05-27','11:35:00',4.94),('14598','2013-05-27','11:40:00',5.04),('14598','2013-05-27','11:45:00',4.9),('14598','2013-05-27','11:50:00',5.07),('14598','2013-05-27','11:55:00',5.01),('14598','2013-05-27','12:00:00',5.1),('14598','2013-05-27','12:05:00',4.86),('14598','2013-05-27','12:10:00',5.27),('14598','2013-05-27','12:15:00',5.31),('14598','2013-05-27','12:20:00',5.31),('14598','2013-05-27','12:25:00',5.3),('14598','2013-05-27','12:30:00',5.23),('14598','2013-05-27','12:35:00',5.33),('14598','2013-05-27','12:40:00',5.41),('14598','2013-05-27','12:45:00',5.41),('14598','2013-05-27','12:50:00',5.31),('14598','2013-05-27','12:55:00',5.42),('14598','2013-05-27','13:00:00',5.5),('14598','2013-05-27','13:05:00',5.2),('14598','2013-05-27','13:10:00',5.1),('14598','2013-05-27','13:15:00',5.43),('14598','2013-05-27','13:20:00',5.26),('14598','2013-05-27','13:25:00',5.09),('14598','2013-05-27','13:30:00',4.82),('14598','2013-05-27','13:35:00',5.58),('14598','2013-05-27','13:40:00',5.52),('14598','2013-05-27','13:45:00',5.48),('14598','2013-05-27','13:50:00',5.38),('14598','2013-05-27','13:55:00',5.28),('14598','2013-05-27','14:00:00',5.38),('14598','2013-05-27','14:05:00',5.34),('14598','2013-05-27','14:10:00',5.37),('14598','2013-05-27','14:15:00',5.42),('14598','2013-05-27','14:20:00',5.45),('14598','2013-05-27','14:25:00',5.37),('14598','2013-05-27','14:30:00',5.44),('14598','2013-05-27','14:35:00',5.47),('14598','2013-05-27','14:40:00',5.49),('14598','2013-05-27','14:45:00',5.43),('14598','2013-05-27','14:50:00',4.24),('14598','2013-05-27','14:55:00',3.14),('14598','2013-05-27','15:00:00',4.65),('14598','2013-05-27','15:05:00',4.37),('14598','2013-05-27','15:10:00',4.69),('14598','2013-05-27','15:15:00',5.52),('14598','2013-05-27','15:20:00',4.1),('14598','2013-05-27','15:25:00',5.41),('14598','2013-05-27','15:30:00',4.49),('14598','2013-05-27','15:35:00',4.91),('14598','2013-05-27','15:40:00',4.78),('14598','2013-05-27','15:45:00',4.07),('14598','2013-05-27','15:50:00',3.02),('14598','2013-05-27','15:55:00',3.2),('14598','2013-05-27','16:00:00',3.56),('14598','2013-05-27','16:05:00',3.12),('14598','2013-05-27','16:10:00',4.37),('14598','2013-05-27','16:15:00',5.09),('14598','2013-05-27','16:20:00',4.67),('14598','2013-05-27','16:25:00',3.83),('14598','2013-05-27','16:30:00',2.42),('14598','2013-05-27','16:35:00',1.76),('14598','2013-05-27','16:40:00',1.74),('14598','2013-05-27','16:45:00',1.78),('14598','2013-05-27','16:50:00',1.85),('14598','2013-05-27','16:55:00',1.94),('14598','2013-05-27','17:00:00',2.17),('14598','2013-05-27','17:05:00',1.91),('14598','2013-05-27','17:10:00',1.66),('14598','2013-05-27','17:15:00',1.51),('14598','2013-05-27','17:20:00',1.44),('14598','2013-05-27','17:25:00',1.3),('14598','2013-05-27','17:30:00',1.23),('14598','2013-05-27','17:35:00',1.19),('14598','2013-05-27','17:40:00',1.16),('14598','2013-05-27','17:45:00',1.2),('14598','2013-05-27','17:50:00',1.13),('14598','2013-05-27','17:55:00',1.07),('14598','2013-05-27','18:00:00',1.12),('14598','2013-05-27','18:05:00',1.35),('14598','2013-05-27','18:10:00',1.85),('14598','2013-05-27','18:15:00',2.94),('14598','2013-05-27','18:20:00',2.66),('14598','2013-05-27','18:25:00',1.37),('14598','2013-05-27','18:30:00',1.31),('14598','2013-05-27','18:35:00',1.89),('14598','2013-05-27','18:40:00',1.46),('14598','2013-05-27','18:45:00',1.75),('14598','2013-05-27','18:50:00',1.89),('14598','2013-05-27','18:55:00',2.07),('14598','2013-05-27','19:00:00',1.88),('14598','2013-05-27','19:05:00',1.59),('14598','2013-05-27','19:10:00',1.3),('14598','2013-05-27','19:15:00',1.02),('14598','2013-05-27','19:20:00',1.32),('14598','2013-05-27','19:25:00',1.18),('14598','2013-05-26','07:40:00',1.01),('14598','2013-05-26','07:45:00',1.25),('14598','2013-05-26','07:55:00',1.11),('14598','2013-05-26','08:10:00',1.05),('14598','2013-05-26','08:15:00',1.6),('14598','2013-05-26','08:20:00',1.38),('14598','2013-05-26','08:25:00',1.67),('14598','2013-05-26','08:30:00',2.01),('14598','2013-05-26','08:35:00',2.8),('14598','2013-05-26','08:40:00',2.03),('14598','2013-05-26','08:50:00',1.76),('14598','2013-05-26','08:55:00',2.99),('14598','2013-05-26','09:00:00',2.18),('14598','2013-05-26','09:05:00',3.17),('14598','2013-05-26','09:10:00',1.96),('14598','2013-05-26','09:15:00',1.44),('14598','2013-05-26','09:20:00',2.34),('14598','2013-05-26','09:35:00',2.63),('14598','2013-05-26','09:40:00',3.45),('14598','2013-05-26','09:45:00',3.07),('14598','2013-05-26','09:50:00',3.63),('14598','2013-05-26','09:55:00',3.71),('14598','2013-05-26','10:00:00',3.79),('14598','2013-05-26','10:05:00',3.89),('14598','2013-05-26','10:10:00',3.97),('14598','2013-05-26','10:15:00',4.04),('14598','2013-05-26','10:20:00',4.08),('14598','2013-05-26','10:25:00',4.17),('14598','2013-05-26','10:30:00',4.28),('14598','2013-05-26','10:35:00',4.35),('14598','2013-05-26','10:40:00',4.43),('14598','2013-05-26','10:45:00',4.49),('14598','2013-05-26','10:50:00',4.56),('14598','2013-05-26','10:55:00',4.62),('14598','2013-05-26','11:00:00',4.69),('14598','2013-05-26','11:05:00',4.71),('14598','2013-05-26','11:10:00',4.79),('14598','2013-05-26','11:15:00',4.85),('14598','2013-05-26','11:20:00',4.9),('14598','2013-05-26','11:25:00',4.96),('14598','2013-05-26','11:30:00',5),('14598','2013-05-26','11:35:00',5.05),('14598','2013-05-26','11:40:00',5.11),('14598','2013-05-26','11:45:00',5.16),('14598','2013-05-26','11:50:00',5.2),('14598','2013-05-26','11:55:00',5.21),('14598','2013-05-26','12:00:00',5.23),('14598','2013-05-26','12:05:00',5.28),('14598','2013-05-26','12:10:00',5.3),('14598','2013-05-26','12:15:00',5.39),('14598','2013-05-26','12:20:00',5.43),('14598','2013-05-26','12:25:00',5.47),('14598','2013-05-26','12:30:00',5.49),('14598','2013-05-26','12:35:00',5.5),('14598','2013-05-26','12:40:00',5.54),('14598','2013-05-26','12:45:00',5.44),('14598','2013-05-26','12:50:00',5.57),('14598','2013-05-26','12:55:00',5.59),('14598','2013-05-26','13:00:00',5.59),('14598','2013-05-26','13:05:00',5.57),('14598','2013-05-26','13:10:00',5.61),('14598','2013-05-26','13:15:00',5.59),('14598','2013-05-26','13:20:00',5.6),('14598','2013-05-26','13:25:00',5.65),('14598','2013-05-26','13:30:00',5.62),('14598','2013-05-26','13:35:00',5.64),('14598','2013-05-26','13:40:00',5.66),('14598','2013-05-26','13:45:00',5.67),('14598','2013-05-26','13:50:00',5.66),('14598','2013-05-26','13:55:00',5.68),('14598','2013-05-26','14:00:00',5.59),('14598','2013-05-26','14:05:00',5.61),('14598','2013-05-26','14:10:00',5.61),('14598','2013-05-26','14:15:00',5.56),('14598','2013-05-26','14:20:00',5.57),('14598','2013-05-26','14:25:00',5.55),('14598','2013-05-26','14:30:00',5.54),('14598','2013-05-26','14:35:00',5.52),('14598','2013-05-26','14:40:00',5.48),('14598','2013-05-26','14:45:00',5.46),('14598','2013-05-26','14:50:00',5.44),('14598','2013-05-26','14:55:00',5.39),('14598','2013-05-26','15:00:00',5.35),('14598','2013-05-26','15:05:00',5.32),('14598','2013-05-26','15:10:00',5.29),('14598','2013-05-26','15:15:00',5.26),('14598','2013-05-26','15:20:00',5.2),('14598','2013-05-26','15:25:00',5.18),('14598','2013-05-26','15:30:00',5.14),('14598','2013-05-26','15:35:00',5.09),('14598','2013-05-26','15:40:00',5.01),('14598','2013-05-26','15:45:00',4.84),('14598','2013-05-26','15:50:00',4.89),('14598','2013-05-26','15:55:00',4.85),('14598','2013-05-26','16:00:00',4.8),('14598','2013-05-26','16:05:00',4.72),('14598','2013-05-26','16:10:00',4.66),('14598','2013-05-26','16:15:00',4.6),('14598','2013-05-26','16:20:00',4.52),('14598','2013-05-26','16:25:00',4.46),('14598','2013-05-26','16:30:00',4.39),('14598','2013-05-26','16:35:00',4.33),('14598','2013-05-26','16:40:00',4.26),('14598','2013-05-26','16:45:00',4.2),('14598','2013-05-26','16:50:00',4.12),('14598','2013-05-26','16:55:00',4.04),('14598','2013-05-26','17:00:00',3.96),('14598','2013-05-26','17:05:00',3.9),('14598','2013-05-26','17:10:00',3.82),('14598','2013-05-26','17:15:00',3.74),('14598','2013-05-26','17:20:00',3.65),('14598','2013-05-26','17:25:00',3.55),('14598','2013-05-26','17:30:00',3.46),('14598','2013-05-26','17:35:00',3.38),('14598','2013-05-26','17:40:00',3.28),('14598','2013-05-26','17:45:00',3.19),('14598','2013-05-26','17:50:00',3.08),('14598','2013-05-26','17:55:00',2.96),('14598','2013-05-26','18:00:00',2.87),('14598','2013-05-26','18:05:00',2.77),('14598','2013-05-26','18:10:00',2.66),('14598','2013-05-26','18:15:00',2.56),('14598','2013-05-26','18:20:00',2.45),('14598','2013-05-26','18:25:00',2.34),('14598','2013-05-26','18:30:00',2.22),('14598','2013-05-26','18:35:00',2.11),('14598','2013-05-26','18:40:00',1.99),('14598','2013-05-26','18:45:00',1.87),('14598','2013-05-26','18:50:00',1.77),('14598','2013-05-26','18:55:00',1.65),('14598','2013-05-26','19:00:00',1.54),('14598','2013-05-26','19:05:00',1.43),('14598','2013-05-26','19:10:00',1.31),('14598','2013-05-26','19:15:00',1.2),('14598','2013-05-26','19:20:00',1.09),('14598','2013-05-25','07:50:00',1.14),('14598','2013-05-25','07:55:00',1.23),('14598','2013-05-25','08:00:00',1.34),('14598','2013-05-25','08:05:00',1.06),('14598','2013-05-25','08:10:00',1.81),('14598','2013-05-25','08:15:00',1.31),('14598','2013-05-25','08:20:00',1.03),('14598','2013-05-25','08:35:00',1.72),('14598','2013-05-25','08:40:00',2.69),('14598','2013-05-25','08:45:00',1.22),('14598','2013-05-25','08:50:00',1.05),('14598','2013-05-25','08:55:00',1.44),('14598','2013-05-25','09:00:00',1.72),('14598','2013-05-25','09:05:00',3.1),('14598','2013-05-25','09:10:00',1.8),('14598','2013-05-25','09:15:00',3.46),('14598','2013-05-25','09:20:00',1.76),('14598','2013-05-25','09:25:00',2.14),('14598','2013-05-25','09:30:00',2.97),('14598','2013-05-25','09:35:00',1.3),('14598','2013-05-25','09:40:00',1.88),('14598','2013-05-25','09:45:00',1.76),('14598','2013-05-25','09:50:00',1.94),('14598','2013-05-25','09:55:00',1.9),('14598','2013-05-25','10:00:00',2.03),('14598','2013-05-25','10:05:00',1.8),('14598','2013-05-25','10:10:00',1.17),('14598','2013-05-25','10:15:00',1.3),('14598','2013-05-25','10:20:00',1.08),('14598','2013-05-25','10:25:00',1.01),('14598','2013-05-25','10:30:00',1.34),('14598','2013-05-25','10:35:00',1.75),('14598','2013-05-25','10:40:00',1.27),('14598','2013-05-25','11:00:00',1.21),('14598','2013-05-25','11:05:00',1.45),('14598','2013-05-25','11:10:00',1.74),('14598','2013-05-25','11:15:00',1.59),('14598','2013-05-25','11:20:00',1.93),('14598','2013-05-25','11:25:00',1.65),('14598','2013-05-25','11:30:00',2.27),('14598','2013-05-25','11:35:00',2.68),('14598','2013-05-25','11:40:00',2.74),('14598','2013-05-25','11:45:00',4.21),('14598','2013-05-25','11:50:00',2.84),('14598','2013-05-25','11:55:00',1.59),('14598','2013-05-25','12:00:00',1.05),('14598','2013-05-25','12:10:00',1.33),('14598','2013-05-25','12:15:00',2.28),('14598','2013-05-25','12:20:00',3.52),('14598','2013-05-25','12:25:00',5.83),('14598','2013-05-25','12:30:00',3.9),('14598','2013-05-25','12:35:00',3.95),('14598','2013-05-25','12:40:00',2.51),('14598','2013-05-25','12:45:00',2.84),('14598','2013-05-25','12:50:00',2.52),('14598','2013-05-25','12:55:00',2.39),('14598','2013-05-25','13:00:00',2.12),('14598','2013-05-25','13:05:00',2.37),('14598','2013-05-25','13:10:00',1.81),('14598','2013-05-25','13:15:00',3.09),('14598','2013-05-25','13:20:00',2.76),('14598','2013-05-25','13:25:00',2.81),('14598','2013-05-25','13:30:00',3.25),('14598','2013-05-25','13:35:00',4.34),('14598','2013-05-25','13:40:00',2.84),('14598','2013-05-25','13:45:00',4.2),('14598','2013-05-25','13:50:00',5.03),('14598','2013-05-25','13:55:00',5.76),('14598','2013-05-25','14:00:00',5.6),('14598','2013-05-25','14:05:00',5.6),('14598','2013-05-25','14:10:00',5.57),('14598','2013-05-25','14:15:00',5.73),('14598','2013-05-25','14:20:00',4.8),('14598','2013-05-25','14:25:00',4.72),('14598','2013-05-25','14:30:00',5.69),('14598','2013-05-25','14:35:00',5.15),('14598','2013-05-25','14:40:00',2.95),('14598','2013-05-25','14:45:00',5.64),('14598','2013-05-25','14:50:00',5.05),('14598','2013-05-25','14:55:00',4.59),('14598','2013-05-25','15:00:00',4.58),('14598','2013-05-25','15:05:00',5.61),('14598','2013-05-25','15:10:00',5.3),('14598','2013-05-25','15:15:00',4.18),('14598','2013-05-25','15:20:00',4.16),('14598','2013-05-25','15:25:00',2.58),('14598','2013-05-25','15:30:00',5.47),('14598','2013-05-25','15:35:00',4.52),('14598','2013-05-25','15:40:00',5.02),('14598','2013-05-25','15:45:00',3.99),('14598','2013-05-25','15:50:00',4.12),('14598','2013-05-25','15:55:00',2.83),('14598','2013-05-25','16:00:00',5.58),('14598','2013-05-25','16:05:00',3.96),('14598','2013-05-25','16:10:00',2.41),('14598','2013-05-25','16:15:00',4.89),('14598','2013-05-25','16:20:00',3.75),('14598','2013-05-25','16:25:00',3.8),('14598','2013-05-25','16:30:00',4.84),('14598','2013-05-25','16:35:00',2.23),('14598','2013-05-25','16:40:00',3.64),('14598','2013-05-25','16:45:00',2.61),('14598','2013-05-25','16:50:00',4.36),('14598','2013-05-25','16:55:00',4.11),('14598','2013-05-25','17:00:00',3.87),('14598','2013-05-25','17:05:00',4.03),('14598','2013-05-25','17:10:00',3.34),('14598','2013-05-25','17:15:00',3.11),('14598','2013-05-25','17:20:00',1.48),('14598','2013-05-25','17:25:00',3.81),('14598','2013-05-25','17:30:00',3.7),('14598','2013-05-25','17:35:00',3.67),('14598','2013-05-25','17:40:00',3.64),('14598','2013-05-25','17:45:00',2.91),('14598','2013-05-24','08:00:00',1.19),('14598','2013-05-24','08:05:00',1.31),('14598','2013-05-24','08:10:00',1.41),('14598','2013-05-24','08:15:00',1.54),('14598','2013-05-24','08:20:00',1.69),('14598','2013-05-24','08:25:00',1.95),('14598','2013-05-24','08:30:00',1.62),('14598','2013-05-24','08:35:00',2.22),('14598','2013-05-24','08:40:00',1.44),('14598','2013-05-24','08:50:00',1.89),('14598','2013-05-24','08:55:00',2.72),('14598','2013-05-24','09:00:00',3.02),('14598','2013-05-24','09:05:00',1.6),('14598','2013-05-24','09:10:00',3.08),('14598','2013-05-24','09:15:00',2.92),('14598','2013-05-24','09:20:00',2),('14598','2013-05-24','09:35:00',2.6),('14598','2013-05-24','09:40:00',3.32),('14598','2013-05-24','09:45:00',3.56),('14598','2013-05-24','09:50:00',1.9),('14598','2013-05-24','10:00:00',1.67),('14598','2013-05-24','10:05:00',2.08),('14598','2013-05-24','10:10:00',1.88),('14598','2013-05-24','10:15:00',1.59),('14598','2013-05-24','10:20:00',4.14),('14598','2013-05-24','10:25:00',3.26),('14598','2013-05-24','10:30:00',4.64),('14598','2013-05-24','10:35:00',3.4),('14598','2013-05-24','10:40:00',4.44),('14598','2013-05-24','10:45:00',3.79),('14598','2013-05-24','10:50:00',4.26),('14598','2013-05-24','10:55:00',4.53),('14598','2013-05-24','11:00:00',3.64),('14598','2013-05-24','11:05:00',3.96),('14598','2013-05-24','11:10:00',4.78),('14598','2013-05-24','11:15:00',4.91),('14598','2013-05-24','11:20:00',3.86),('14598','2013-05-24','11:25:00',2.86),('14598','2013-05-24','11:30:00',3.86),('14598','2013-05-24','11:35:00',5.36),('14598','2013-05-24','11:40:00',5.89),('14598','2013-05-24','11:45:00',5.76),('14598','2013-05-24','11:50:00',2.9),('14598','2013-05-24','11:55:00',3.18),('14598','2013-05-24','12:00:00',4.58),('14598','2013-05-24','12:05:00',3.49),('14598','2013-05-24','12:10:00',3.78),('14598','2013-05-24','12:15:00',3.2),('14598','2013-05-24','12:20:00',2.12),('14598','2013-05-24','12:25:00',2.15),('14598','2013-05-24','12:30:00',3.84),('14598','2013-05-24','12:35:00',2.35),('14598','2013-05-24','12:40:00',2.28),('14598','2013-05-24','12:45:00',3.6),('14598','2013-05-24','12:50:00',4.65),('14598','2013-05-24','12:55:00',5.8),('14598','2013-05-24','13:00:00',5.72),('14598','2013-05-24','13:05:00',5.94),('14598','2013-05-24','13:10:00',6.02),('14598','2013-05-24','13:15:00',5.8),('14598','2013-05-24','13:20:00',2.67),('14598','2013-05-24','13:25:00',5.01),('14598','2013-05-24','13:30:00',3),('14598','2013-05-24','13:35:00',6.01),('14598','2013-05-24','13:40:00',5.9),('14598','2013-05-24','13:45:00',5.82),('14598','2013-05-24','13:50:00',4.92),('14598','2013-05-24','13:55:00',3.08),('14598','2013-05-24','14:00:00',5.67),('14598','2013-05-24','14:05:00',6.03),('14598','2013-05-24','14:10:00',6.01),('14598','2013-05-24','14:15:00',4.49),('14598','2013-05-24','14:20:00',2.64),('14598','2013-05-24','14:25:00',5.22),('14598','2013-05-24','14:30:00',3.73),('14598','2013-05-24','14:35:00',3.42),('14598','2013-05-24','14:40:00',1.49),('14598','2013-05-24','14:45:00',4.36),('14598','2013-05-24','14:50:00',4.07),('14598','2013-05-24','14:55:00',5.69),('14598','2013-05-24','15:00:00',5.54),('14598','2013-05-24','15:05:00',5.51),('14598','2013-05-24','15:10:00',5.59),('14598','2013-05-24','15:15:00',4.72),('14598','2013-05-24','15:20:00',3.34),('14598','2013-05-24','15:25:00',3.09),('14598','2013-05-24','15:30:00',4.06),('14598','2013-05-24','15:35:00',4.2),('14598','2013-05-24','15:40:00',2.8),('14598','2013-05-24','15:45:00',2.56),('14598','2013-05-24','15:50:00',2.26),('14598','2013-05-24','15:55:00',2.24),('14598','2013-05-24','16:00:00',2.13),('14598','2013-05-24','16:05:00',1.91),('14598','2013-05-24','16:10:00',1.79),('14598','2013-05-24','16:15:00',1.51),('14598','2013-05-24','16:20:00',1.45),('14598','2013-05-24','16:25:00',1.37),('14598','2013-05-24','16:30:00',1.54),('14598','2013-05-24','16:35:00',2.06),('14598','2013-05-24','16:40:00',1.61),('14598','2013-05-24','16:45:00',1.15),('14598','2013-05-24','16:50:00',1.15),('14598','2013-05-24','16:55:00',1.26),('14598','2013-05-24','17:00:00',1.43),('14598','2013-05-24','17:05:00',1.42),('14598','2013-05-24','17:10:00',1.91),('14598','2013-05-24','17:15:00',2.45),('14598','2013-05-24','17:20:00',2.37),('14598','2013-05-24','17:25:00',1.7),('14598','2013-05-24','17:30:00',1.27),('14598','2013-05-24','17:35:00',1.05),('14598','2013-05-23','07:25:00',1.15),('14598','2013-05-23','07:30:00',1.04),('14598','2013-05-23','07:50:00',1.14),('14598','2013-05-23','07:55:00',1.16),('14598','2013-05-23','08:05:00',1.15),('14598','2013-05-23','08:10:00',1.34),('14598','2013-05-23','08:15:00',2.15),('14598','2013-05-23','08:50:00',2.49),('14598','2013-05-23','08:55:00',2.74),('14598','2013-05-23','09:00:00',1.45),('14598','2013-05-23','09:05:00',2.35),('14598','2013-05-23','09:15:00',2.64),('14598','2013-05-23','09:20:00',1.45),('14598','2013-05-23','09:25:00',1.24),('14598','2013-05-23','09:30:00',2.26),('14598','2013-05-23','09:35:00',2.35),('14598','2013-05-23','09:40:00',2.77),('14598','2013-05-23','09:45:00',3.44),('14598','2013-05-23','09:50:00',3.08),('14598','2013-05-23','09:55:00',3.65),('14598','2013-05-23','10:00:00',3.8),('14598','2013-05-23','10:05:00',3.86),('14598','2013-05-23','10:10:00',3.63),('14598','2013-05-23','10:15:00',3.85),('14598','2013-05-23','10:20:00',4.02),('14598','2013-05-23','10:25:00',4.17),('14598','2013-05-23','10:30:00',4.33),('14598','2013-05-23','10:35:00',4.46),('14598','2013-05-23','10:40:00',2.39),('14598','2013-05-23','10:45:00',1.31),('14598','2013-05-23','10:50:00',2.97),('14598','2013-05-23','10:55:00',3.1),('14598','2013-05-23','11:00:00',2.66),('14598','2013-05-23','11:05:00',4.52),('14598','2013-05-23','11:10:00',2.98),('14598','2013-05-23','11:15:00',1.79),('14598','2013-05-23','11:20:00',2.54),('14598','2013-05-23','11:25:00',2),('14598','2013-05-23','11:35:00',2.26),('14598','2013-05-23','11:40:00',5.41),('14598','2013-05-23','11:45:00',4.53),('14598','2013-05-23','11:50:00',4.3),('14598','2013-05-23','11:55:00',3.27),('14598','2013-05-23','12:00:00',3.87),('14598','2013-05-23','12:05:00',2.09),('14598','2013-05-23','12:10:00',1.34),('14598','2013-05-23','12:15:00',1.66),('14598','2013-05-23','12:20:00',4.5),('14598','2013-05-23','12:25:00',5.7),('14598','2013-05-23','12:30:00',3.01),('14598','2013-05-23','12:35:00',5.25),('14598','2013-05-23','12:40:00',5.24),('14598','2013-05-23','12:45:00',5.41),('14598','2013-05-23','12:50:00',5.39),('14598','2013-05-23','12:55:00',5.47),('14598','2013-05-23','13:00:00',5.45),('14598','2013-05-23','13:05:00',5.49),('14598','2013-05-23','13:10:00',5.48),('14598','2013-05-23','13:15:00',5.51),('14598','2013-05-23','13:20:00',5.65),('14598','2013-05-23','13:25:00',4.19),('14598','2013-05-23','13:30:00',5.83),('14598','2013-05-23','13:35:00',5.72),('14598','2013-05-23','13:40:00',5.62),('14598','2013-05-23','13:45:00',5.65),('14598','2013-05-23','13:50:00',5.26),('14598','2013-05-23','13:55:00',3.82),('14598','2013-05-23','14:00:00',3.55),('14598','2013-05-23','14:05:00',5.8),('14598','2013-05-23','14:10:00',4.2),('14598','2013-05-23','14:15:00',3.77),('14598','2013-05-23','14:20:00',3.81),('14598','2013-05-23','14:25:00',4.14),('14598','2013-05-23','14:30:00',5.96),('14598','2013-05-23','14:35:00',5.53),('14598','2013-05-23','14:40:00',5.66),('14598','2013-05-23','14:45:00',4.47),('14598','2013-05-23','14:50:00',5.22),('14598','2013-05-23','14:55:00',4.1),('14598','2013-05-23','15:00:00',4.76),('14598','2013-05-23','15:05:00',1.22),('14598','2013-05-23','15:10:00',1.24),('14598','2013-05-23','15:15:00',2.3),('14598','2013-05-23','15:20:00',3.05),('14598','2013-05-23','15:25:00',5.42),('14598','2013-05-23','15:30:00',3.65),('14598','2013-05-23','15:35:00',3.38),('14598','2013-05-23','15:40:00',4.95),('14598','2013-05-23','15:45:00',5.36),('14598','2013-05-23','15:50:00',5.37),('14598','2013-05-23','15:55:00',5),('14598','2013-05-23','16:00:00',3.49),('14598','2013-05-23','16:05:00',4.8),('14598','2013-05-23','16:10:00',3.5),('14598','2013-05-23','16:15:00',2.64),('14598','2013-05-23','16:20:00',3.97),('14598','2013-05-23','16:25:00',4.1),('14598','2013-05-23','16:30:00',2.7),('14598','2013-05-23','16:35:00',3.4),('14598','2013-05-23','16:40:00',3.62),('14598','2013-05-23','16:45:00',1.83),('14598','2013-05-23','16:50:00',1.85),('14598','2013-05-23','16:55:00',1.89),('14598','2013-05-23','17:00:00',2.45),('14598','2013-05-23','17:05:00',3.64),('14598','2013-05-23','17:10:00',3.06),('14598','2013-05-23','17:15:00',2.78),('14598','2013-05-23','17:20:00',2.55),('14598','2013-05-23','17:25:00',1.47),('14598','2013-05-23','17:30:00',2.86),('14598','2013-05-23','17:35:00',4.23),('14598','2013-05-23','17:40:00',3.93),('14598','2013-05-23','17:45:00',2.66),('14598','2013-05-23','18:30:00',1.22),('14598','2013-05-23','18:35:00',1.6),('14598','2013-05-22','07:50:00',1.03),('14598','2013-05-22','07:55:00',1.24),('14598','2013-05-22','08:00:00',1.41),('14598','2013-05-22','08:05:00',1.63),('14598','2013-05-22','08:10:00',1.63),('14598','2013-05-22','08:15:00',1.77),('14598','2013-05-22','08:20:00',1.09),('14598','2013-05-22','09:00:00',1.11),('14598','2013-05-22','09:15:00',1.94),('14598','2013-05-22','09:20:00',3.02),('14598','2013-05-22','09:25:00',1.27),('14598','2013-05-22','09:30:00',2.26),('14598','2013-05-22','09:35:00',3.04),('14598','2013-05-22','09:40:00',3.07),('14598','2013-05-22','09:45:00',3.15),('14598','2013-05-22','09:50:00',3.24),('14598','2013-05-22','09:55:00',3.36),('14598','2013-05-22','10:00:00',3.4),('14598','2013-05-22','10:05:00',3.74),('14598','2013-05-22','10:10:00',2.91),('14598','2013-05-22','10:15:00',3.88),('14598','2013-05-22','10:20:00',3.85),('14598','2013-05-22','10:25:00',4.15),('14598','2013-05-22','10:30:00',3.55),('14598','2013-05-22','10:35:00',2.75),('14598','2013-05-22','10:40:00',2.08),('14598','2013-05-22','10:45:00',2.79),('14598','2013-05-22','10:50:00',3.01),('14598','2013-05-22','10:55:00',2.89),('14598','2013-05-22','11:00:00',3.55),('14598','2013-05-22','11:05:00',4.57),('14598','2013-05-22','11:10:00',4.46),('14598','2013-05-22','11:15:00',4.45),('14598','2013-05-22','11:20:00',4.51),('14598','2013-05-22','11:25:00',4.55),('14598','2013-05-22','11:30:00',4.45),('14598','2013-05-22','11:35:00',3.85),('14598','2013-05-22','11:40:00',4.04),('14598','2013-05-22','11:45:00',4.22),('14598','2013-05-22','11:50:00',3.4),('14598','2013-05-22','11:55:00',3.06),('14598','2013-05-22','12:00:00',2.61),('14598','2013-05-22','12:05:00',2.56),('14598','2013-05-22','12:10:00',2.12),('14598','2013-05-22','12:15:00',2.07),('14598','2013-05-22','12:20:00',3.94),('14598','2013-05-22','12:25:00',5.52),('14598','2013-05-22','12:30:00',4.27),('14598','2013-05-22','12:35:00',2.32),('14598','2013-05-22','12:40:00',1.46),('14598','2013-05-22','13:15:00',1.7),('14598','2013-05-22','13:20:00',3.56),('14598','2013-05-22','13:25:00',2.87),('14598','2013-05-22','13:30:00',4.18),('14598','2013-05-22','13:35:00',2.77),('14598','2013-05-22','13:40:00',3.84),('14598','2013-05-22','13:45:00',4.12),('14598','2013-05-22','13:50:00',4.07),('14598','2013-05-22','13:55:00',5.42),('14598','2013-05-22','14:00:00',4.58),('14598','2013-05-22','14:05:00',5.05),('14598','2013-05-22','14:10:00',5.03),('14598','2013-05-22','14:15:00',5),('14598','2013-05-22','14:20:00',5.01),('14598','2013-05-22','14:25:00',4.98),('14598','2013-05-22','14:30:00',4.93),('14598','2013-05-22','14:35:00',4.93),('14598','2013-05-22','14:40:00',4.87),('14598','2013-05-22','14:45:00',4.85),('14598','2013-05-22','14:50:00',4.8),('14598','2013-05-22','14:55:00',4.78),('14598','2013-05-22','15:00:00',4.79),('14598','2013-05-22','15:05:00',4.72),('14598','2013-05-22','15:10:00',4.67),('14598','2013-05-22','15:15:00',4.64),('14598','2013-05-22','15:20:00',4.62),('14598','2013-05-22','15:25:00',4.58),('14598','2013-05-22','15:30:00',4.53),('14598','2013-05-22','15:35:00',4.42),('14598','2013-05-22','15:40:00',4.45),('14598','2013-05-22','15:45:00',4.39),('14598','2013-05-22','15:50:00',4.32),('14598','2013-05-22','15:55:00',4.25),('14598','2013-05-22','16:00:00',4.19),('14598','2013-05-22','16:05:00',4.11),('14598','2013-05-22','16:10:00',4.03),('14598','2013-05-22','16:15:00',3.98),('14598','2013-05-22','16:20:00',3.9),('14598','2013-05-22','16:25:00',3.82),('14598','2013-05-22','16:30:00',3.74),('14598','2013-05-22','16:35:00',3.57),('14598','2013-05-22','16:40:00',3.3),('14598','2013-05-22','16:45:00',3.18),('14598','2013-05-22','16:50:00',2.9),('14598','2013-05-22','16:55:00',2.89),('14598','2013-05-22','17:00:00',2.97),('14598','2013-05-22','17:05:00',3.34),('14598','2013-05-22','17:10:00',3.19),('14598','2013-05-22','17:15:00',3.13),('14598','2013-05-22','17:20:00',3.04),('14598','2013-05-22','17:25:00',2.79),('14598','2013-05-22','17:30:00',3.07),('14598','2013-05-22','17:35:00',2.84),('14598','2013-05-22','17:40:00',2.71),('14598','2013-05-22','17:45:00',2.57),('14598','2013-05-22','17:50:00',2.52),('14598','2013-05-22','17:55:00',2.41),('14598','2013-05-22','18:00:00',2.43),('14598','2013-05-22','18:05:00',2.28),('14598','2013-05-22','18:10:00',2.31),('14598','2013-05-22','18:15:00',2.14),('14598','2013-05-22','18:20:00',2.03),('14598','2013-05-22','18:25:00',1.22),('14598','2013-05-22','18:30:00',1.04),('14598','2013-05-22','18:40:00',1.02),('14598','2013-05-22','18:45:00',1.18),('14598','2013-05-22','18:50:00',1.25),('14598','2013-05-22','18:55:00',1.33),('14598','2013-05-22','19:00:00',1.15),('14598','2014-04-01','08:40:00',1.04),('14598','2014-04-01','08:45:00',1),('14598','2014-04-01','08:50:00',1.18),('14598','2014-04-01','08:55:00',1.23),('14598','2014-04-01','09:00:00',1.38),('14598','2014-04-01','09:05:00',1.52),('14598','2014-04-01','09:10:00',1.62),('14598','2014-04-01','09:15:00',1.73),('14598','2014-04-01','09:20:00',1.87),('14598','2014-04-01','09:25:00',2),('14598','2014-04-01','09:30:00',2.11),('14598','2014-04-01','09:35:00',2.2),('14598','2014-04-01','09:40:00',2.31),('14598','2014-04-01','09:45:00',2.39),('14598','2014-04-01','09:50:00',2.49),('14598','2014-04-01','09:55:00',2.6),('14598','2014-04-01','10:00:00',2.69),('14598','2014-04-01','10:05:00',2.8),('14598','2014-04-01','10:10:00',2.88),('14598','2014-04-01','10:15:00',2.99),('14598','2014-04-01','10:20:00',3.09),('14598','2014-04-01','10:25:00',3.18),('14598','2014-04-01','10:30:00',3.26),('14598','2014-04-01','10:35:00',3.36),('14598','2014-04-01','10:40:00',3.43),('14598','2014-04-01','10:45:00',3.5),('14598','2014-04-01','10:50:00',3.59),('14598','2014-04-01','10:55:00',3.64),('14598','2014-04-01','11:00:00',3.72),('14598','2014-04-01','11:05:00',3.8),('14598','2014-04-01','11:10:00',3.88),('14598','2014-04-01','11:15:00',3.93),('14598','2014-04-01','11:20:00',3.97),('14598','2014-04-01','11:25:00',4.06),('14598','2014-04-01','11:30:00',4.15),('14598','2014-04-01','11:35:00',4.24),('14598','2014-04-01','11:40:00',4.27),('14598','2014-04-01','11:45:00',4.32),('14598','2014-04-01','11:50:00',4.35),('14598','2014-04-01','11:55:00',4.41),('14598','2014-04-01','12:00:00',4.45),('14598','2014-04-01','12:05:00',4.43),('14598','2014-04-01','12:10:00',4.55),('14598','2014-04-01','12:15:00',4.47),('14598','2014-04-01','12:20:00',4.58),('14598','2014-04-01','12:25:00',4.63),('14598','2014-04-01','12:30:00',4.58),('14598','2014-04-01','12:35:00',3.99),('14598','2014-04-01','12:40:00',4.45),('14598','2014-04-01','12:45:00',4.23),('14598','2014-04-01','12:50:00',3.52),('14598','2014-04-01','12:55:00',3.8),('14598','2014-04-01','13:00:00',5.18),('14598','2014-04-01','13:05:00',4.89),('14598','2014-04-01','13:10:00',4.56),('14598','2014-04-01','13:15:00',5.17),('14598','2014-04-01','13:20:00',4.96),('14598','2014-04-01','13:25:00',4.35),('14598','2014-04-01','13:30:00',4.79),('14598','2014-04-01','13:35:00',4.99),('14598','2014-04-01','13:40:00',4.98),('14598','2014-04-01','13:45:00',5.08),('14598','2014-04-01','13:50:00',4.57),('14598','2014-04-01','13:55:00',5.07),('14598','2014-04-01','14:00:00',4.19),('14598','2014-04-01','14:05:00',4.34),('14598','2014-04-01','14:10:00',4.91),('14598','2014-04-01','14:15:00',4.83),('14598','2014-04-01','14:20:00',2.79),('14598','2014-04-01','14:25:00',3.63),('14598','2014-04-01','14:30:00',3.58),('14598','2014-04-01','14:35:00',4.91),('14598','2014-04-01','14:40:00',4.85),('14598','2014-04-01','14:45:00',4.42),('14598','2014-04-01','14:50:00',4.5),('14598','2014-04-01','14:55:00',4.87),('14598','2014-04-01','15:00:00',4.74),('14598','2014-04-01','15:05:00',4.66),('14598','2014-04-01','15:10:00',4.78),('14598','2014-04-01','15:15:00',3.67),('14598','2014-04-01','15:20:00',2.87),('14598','2014-04-01','15:25:00',4.13),('14598','2014-04-01','15:30:00',4.44),('14598','2014-04-01','15:35:00',4.57),('14598','2014-04-01','15:40:00',4.51),('14598','2014-04-01','15:45:00',3.36),('14598','2014-04-01','15:50:00',3.87),('14598','2014-04-01','15:55:00',3.85),('14598','2014-04-01','16:00:00',4.02),('14598','2014-04-01','16:05:00',3.9),('14598','2014-04-01','16:10:00',3.96),('14598','2014-04-01','16:15:00',3.92),('14598','2014-04-01','16:20:00',3.81),('14598','2014-04-01','16:25:00',3.56),('14598','2014-04-01','16:30:00',3.57),('14598','2014-04-01','16:35:00',3.63),('14598','2014-04-01','16:40:00',3.55),('14598','2014-04-01','16:45:00',3.44),('14598','2014-04-01','16:50:00',3.34),('14598','2014-04-01','16:55:00',3.24),('14598','2014-04-01','17:00:00',3.13),('14598','2014-04-01','17:05:00',3.04),('14598','2014-04-01','17:10:00',2.95),('14598','2014-04-01','17:15:00',2.86),('14598','2014-04-01','17:20:00',2.66),('14598','2014-04-01','17:25:00',2.55),('14598','2014-04-01','17:30:00',2.38),('14598','2014-04-01','17:35:00',2.36),('14598','2014-04-01','17:40:00',2.34),('14598','2014-04-01','17:45:00',2.22),('14598','2014-04-01','17:50:00',2.06),('14598','2014-04-01','17:55:00',1.89),('14598','2014-04-01','18:00:00',1.28),('14598','2014-04-01','18:05:00',1.58),('14598','2014-04-01','18:10:00',1.16),('14598','2014-04-01','18:15:00',1.08),('14598','2013-05-21','07:25:00',1),('14598','2013-05-21','07:55:00',1.3),('14598','2013-05-21','08:00:00',1.64),('14598','2013-05-21','08:05:00',1.77),('14598','2013-05-21','08:10:00',1.37),('14598','2013-05-21','08:15:00',1.25),('14598','2013-05-21','08:20:00',1.17),('14598','2013-05-21','08:25:00',1.24),('14598','2013-05-21','08:30:00',1.24),('14598','2013-05-21','08:35:00',1.19),('14598','2013-05-21','08:40:00',1.3),('14598','2013-05-21','08:45:00',1.43),('14598','2013-05-21','08:50:00',1.32),('14598','2013-05-21','08:55:00',1.45),('14598','2013-05-21','09:00:00',1.83),('14598','2013-05-21','09:05:00',1.84),('14598','2013-05-21','09:10:00',2.09),('14598','2013-05-21','09:15:00',2.27),('14598','2013-05-21','09:20:00',2.3),('14598','2013-05-21','09:25:00',2.4),('14598','2013-05-21','09:30:00',1.95),('14598','2013-05-21','09:35:00',1.76),('14598','2013-05-21','09:40:00',1.7),('14598','2013-05-21','09:45:00',1.82),('14598','2013-05-21','09:50:00',2.07),('14598','2013-05-21','09:55:00',2.7),('14598','2013-05-21','10:00:00',2.13),('14598','2013-05-21','10:05:00',2.13),('14598','2013-05-21','10:10:00',2.22),('14598','2013-05-21','10:15:00',2.64),('14598','2013-05-21','10:20:00',2.83),('14598','2013-05-21','10:25:00',2.12),('14598','2013-05-21','10:30:00',2.57),('14598','2013-05-21','10:35:00',2.34),('14598','2013-05-21','10:40:00',2.19),('14598','2013-05-21','10:45:00',1.57),('14598','2013-05-21','10:50:00',1.74),('14598','2013-05-21','10:55:00',2.23),('14598','2013-05-21','11:00:00',2.7),('14598','2013-05-21','11:05:00',2.62),('14598','2013-05-21','11:10:00',3.64),('14598','2013-05-21','11:15:00',4.14),('14598','2013-05-21','11:20:00',3.42),('14598','2013-05-21','11:25:00',3.94),('14598','2013-05-21','11:30:00',2.82),('14598','2013-05-21','11:35:00',2.44),('14598','2013-05-21','11:40:00',2.92),('14598','2013-05-21','11:45:00',3.44),('14598','2013-05-21','11:50:00',3.28),('14598','2013-05-21','11:55:00',2.45),('14598','2013-05-21','12:00:00',2.81),('14598','2013-05-21','12:05:00',2.44),('14598','2013-05-21','12:10:00',2.37),('14598','2013-05-21','12:15:00',3.29),('14598','2013-05-21','12:20:00',3.18),('14598','2013-05-21','12:25:00',5.36),('14598','2013-05-21','12:30:00',3.12),('14598','2013-05-21','12:35:00',4.47),('14598','2013-05-21','12:40:00',3.99),('14598','2013-05-21','12:45:00',3.47),('14598','2013-05-21','12:50:00',2.48),('14598','2013-05-21','12:55:00',2.91),('14598','2013-05-21','13:00:00',4.28),('14598','2013-05-21','13:05:00',3.52),('14598','2013-05-21','13:10:00',3.95),('14598','2013-05-21','13:15:00',3.65),('14598','2013-05-21','13:20:00',2.81),('14598','2013-05-21','13:25:00',2.49),('14598','2013-05-21','13:30:00',2.85),('14598','2013-05-21','13:35:00',2.63),('14598','2013-05-21','13:40:00',1.25),('14598','2013-05-21','14:00:00',1.39),('14598','2013-05-21','14:05:00',2.24),('14598','2013-05-21','14:10:00',2.68),('14598','2013-05-21','14:15:00',3.13),('14598','2013-05-21','14:20:00',5.49),('14598','2013-05-21','14:25:00',4.29),('14598','2013-05-21','14:30:00',2.48),('14598','2013-05-21','14:35:00',1.21),('14598','2013-05-21','15:00:00',1.01),('14598','2013-05-21','15:05:00',1.37),('14598','2013-05-21','15:10:00',1.75),('14598','2013-05-21','15:15:00',1.65),('14598','2013-05-21','15:20:00',2.54),('14598','2013-05-21','15:25:00',2.94),('14598','2013-05-21','15:30:00',2),('14598','2013-05-21','15:35:00',1.78),('14598','2013-05-21','15:40:00',1.69),('14598','2013-05-21','15:45:00',1.24),('14598','2013-05-20','07:25:00',1.16),('14598','2013-05-20','07:30:00',1.06),('14598','2013-05-20','07:55:00',1.11),('14598','2013-05-20','08:20:00',1.41),('14598','2013-05-20','08:30:00',1.75),('14598','2013-05-20','08:35:00',1.28),('14598','2013-05-20','08:40:00',2.53),('14598','2013-05-20','08:45:00',1.92),('14598','2013-05-20','08:50:00',1.67),('14598','2013-05-20','08:55:00',2.27),('14598','2013-05-20','09:00:00',1.9),('14598','2013-05-20','09:05:00',2.64),('14598','2013-05-20','09:10:00',2.8),('14598','2013-05-20','09:15:00',2.9),('14598','2013-05-20','09:20:00',2.98),('14598','2013-05-20','09:25:00',2.93),('14598','2013-05-20','09:30:00',2.97),('14598','2013-05-20','09:35:00',3.14),('14598','2013-05-20','09:40:00',3.25),('14598','2013-05-20','09:45:00',3.36),('14598','2013-05-20','09:50:00',3.46),('14598','2013-05-20','09:55:00',3.54),('14598','2013-05-20','10:00:00',3.63),('14598','2013-05-20','10:05:00',3.77),('14598','2013-05-20','10:10:00',3.77),('14598','2013-05-20','10:15:00',3.88),('14598','2013-05-20','10:20:00',3.94),('14598','2013-05-20','10:25:00',4.01),('14598','2013-05-20','10:30:00',3.84),('14598','2013-05-20','10:35:00',4.19),('14598','2013-05-20','10:40:00',4.1),('14598','2013-05-20','10:45:00',4.3),('14598','2013-05-20','10:50:00',4.33),('14598','2013-05-20','10:55:00',4.37),('14598','2013-05-20','11:00:00',4.4),('14598','2013-05-20','11:05:00',4.46),('14598','2013-05-20','11:10:00',4.54),('14598','2013-05-20','11:15:00',4.61),('14598','2013-05-20','11:20:00',4.61),('14598','2013-05-20','11:25:00',4.69),('14598','2013-05-20','11:30:00',4.76),('14598','2013-05-20','11:35:00',4.8),('14598','2013-05-20','11:40:00',4.86),('14598','2013-05-20','11:45:00',4.91),('14598','2013-05-20','11:50:00',4.96),('14598','2013-05-20','11:55:00',4.98),('14598','2013-05-20','12:00:00',5.03),('14598','2013-05-20','12:05:00',5.06),('14598','2013-05-20','12:10:00',5.09),('14598','2013-05-20','12:15:00',5.12),('14598','2013-05-20','12:20:00',5.17),('14598','2013-05-20','12:25:00',5.2),('14598','2013-05-20','12:30:00',5.21),('14598','2013-05-20','12:35:00',5.23),('14598','2013-05-20','12:40:00',5.22),('14598','2013-05-20','12:45:00',5.27),('14598','2013-05-20','12:50:00',5.31),('14598','2013-05-20','12:55:00',5.32),('14598','2013-05-20','13:00:00',5.32),('14598','2013-05-20','13:05:00',5.35),('14598','2013-05-20','13:10:00',5.36),('14598','2013-05-20','13:15:00',5.38),('14598','2013-05-20','13:20:00',5.39),('14598','2013-05-20','13:25:00',5.41),('14598','2013-05-20','13:30:00',5.3),('14598','2013-05-20','13:35:00',5.4),('14598','2013-05-20','13:40:00',5.39),('14598','2013-05-20','13:45:00',5.39),('14598','2013-05-20','13:50:00',5.38),('14598','2013-05-20','13:55:00',5.38),('14598','2013-05-20','14:00:00',5.33),('14598','2013-05-20','14:05:00',5.35),('14598','2013-05-20','14:10:00',5.3),('14598','2013-05-20','14:15:00',5.29),('14598','2013-05-20','14:20:00',5.26),('14598','2013-05-20','14:25:00',5.25),('14598','2013-05-20','14:30:00',5.22),('14598','2013-05-20','14:35:00',5.19),('14598','2013-05-20','14:40:00',5.19),('14598','2013-05-20','14:45:00',5.17),('14598','2013-05-20','14:50:00',5.11),('14598','2013-05-20','14:55:00',5.13),('14598','2013-05-20','15:00:00',5.09),('14598','2013-05-20','15:05:00',5.04),('14598','2013-05-20','15:10:00',4.99),('14598','2013-05-20','15:15:00',4.95),('14598','2013-05-20','15:20:00',4.9),('14598','2013-05-20','15:25:00',4.91),('14598','2013-05-20','15:30:00',4.87),('14598','2013-05-20','15:35:00',4.82),('14598','2013-05-20','15:40:00',4.72),('14598','2013-05-20','15:45:00',4.71),('14598','2013-05-20','15:50:00',4.66),('14598','2013-05-20','15:55:00',4.59),('14598','2013-05-20','16:00:00',4.57),('14598','2013-05-20','16:05:00',4.54),('14598','2013-05-20','16:10:00',4.51),('14598','2013-05-20','16:15:00',4.34),('14598','2013-05-20','16:20:00',3.4),('14598','2013-05-20','16:25:00',3.44),('14598','2013-05-20','16:30:00',4.08),('14598','2013-05-20','16:35:00',3.19),('14598','2013-05-20','16:40:00',2.54),('14598','2013-05-20','16:45:00',2.32),('14598','2013-05-20','16:50:00',3.78),('14598','2013-05-20','16:55:00',3.89),('14598','2013-05-20','17:00:00',2.86),('14598','2013-05-20','17:05:00',2.62),('14598','2013-05-20','17:10:00',4.35),('14598','2013-05-20','17:15:00',3.68),('14598','2013-05-20','17:20:00',3.52),('14598','2013-05-20','17:25:00',3.42),('14598','2013-05-20','17:30:00',3.21),('14598','2013-05-20','17:35:00',3.1),('14598','2013-05-20','17:40:00',3.02),('14598','2013-05-20','17:45:00',2.96),('14598','2013-05-20','17:50:00',2.48),('14598','2013-05-20','17:55:00',2.84),('14598','2013-05-20','18:00:00',2.58),('14598','2013-05-20','18:05:00',2.63),('14598','2013-05-20','18:10:00',2.4),('14598','2013-05-20','18:15:00',2.28),('14598','2013-05-20','18:20:00',2.16),('14598','2013-05-20','18:25:00',2.09),('14598','2013-05-20','18:30:00',1.95),('14598','2013-05-20','18:35:00',1.88),('14598','2013-05-20','18:40:00',1.78),('14598','2013-05-20','18:45:00',1.65),('14598','2013-05-20','18:50:00',1.53),('14598','2013-05-20','18:55:00',1.43),('14598','2013-05-20','19:00:00',1.33),('14598','2013-05-20','19:05:00',1.21),('14598','2013-05-20','19:10:00',1.09),('14598','2013-05-19','08:20:00',1.12),('14598','2013-05-19','08:25:00',1.22),('14598','2013-05-19','08:30:00',1.23),('14598','2013-05-19','08:35:00',1.08),('14598','2013-05-19','08:40:00',1.58),('14598','2013-05-19','08:45:00',2.15),('14598','2013-05-19','08:50:00',1.81),('14598','2013-05-19','08:55:00',1.55),('14598','2013-05-19','09:00:00',1.76),('14598','2013-05-19','09:05:00',1.71),('14598','2013-05-19','09:10:00',2.51),('14598','2013-05-19','09:15:00',2.49),('14598','2013-05-19','09:20:00',2.27),('14598','2013-05-19','09:25:00',2.16),('14598','2013-05-19','09:30:00',1.91),('14598','2013-05-19','09:35:00',2.79),('14598','2013-05-19','09:40:00',3.11),('14598','2013-05-19','09:45:00',3.22),('14598','2013-05-19','09:50:00',3.31),('14598','2013-05-19','09:55:00',3.29),('14598','2013-05-19','10:00:00',3.37),('14598','2013-05-19','10:05:00',2.81),('14598','2013-05-19','10:10:00',3.61),('14598','2013-05-19','10:15:00',3.79),('14598','2013-05-19','10:20:00',3.88),('14598','2013-05-19','10:25:00',4),('14598','2013-05-19','10:30:00',3.79),('14598','2013-05-19','10:35:00',4.13),('14598','2013-05-19','10:40:00',4.18),('14598','2013-05-19','10:45:00',4.26),('14598','2013-05-19','10:50:00',4.35),('14598','2013-05-19','10:55:00',4.43),('14598','2013-05-19','11:00:00',4.6),('14598','2013-05-19','11:05:00',4.64),('14598','2013-05-19','11:10:00',4.37),('14598','2013-05-19','11:15:00',4.6),('14598','2013-05-19','11:20:00',4.93),('14598','2013-05-19','11:25:00',4.8),('14598','2013-05-19','11:30:00',5.06),('14598','2013-05-19','11:35:00',5.22),('14598','2013-05-19','11:40:00',4.09),('14598','2013-05-19','11:45:00',4.55),('14598','2013-05-19','11:50:00',5.2),('14598','2013-05-19','11:55:00',5.22),('14598','2013-05-19','12:00:00',5.21),('14598','2013-05-19','12:05:00',5.35),('14598','2013-05-19','12:10:00',5.34),('14598','2013-05-19','12:15:00',5.36),('14598','2013-05-19','12:20:00',5.35),('14598','2013-05-19','12:25:00',5.33),('14598','2013-05-19','12:30:00',5.33),('14598','2013-05-19','12:35:00',5.34),('14598','2013-05-19','12:40:00',5.38),('14598','2013-05-19','12:45:00',5.4),('14598','2013-05-19','12:50:00',5.44),('14598','2013-05-19','12:55:00',5.43),('14598','2013-05-19','13:00:00',5.45),('14598','2013-05-19','13:05:00',5.44),('14598','2013-05-19','13:10:00',5.49),('14598','2013-05-19','13:15:00',5.5),('14598','2013-05-19','13:20:00',5.52),('14598','2013-05-19','13:25:00',5.49),('14598','2013-05-19','13:30:00',5.49),('14598','2013-05-19','13:35:00',5.49),('14598','2013-05-19','13:40:00',5.5),('14598','2013-05-19','13:45:00',5.52),('14598','2013-05-19','13:50:00',5.53),('14598','2013-05-19','13:55:00',5.55),('14598','2013-05-19','14:00:00',5.55),('14598','2013-05-19','14:05:00',5.54),('14598','2013-05-19','14:10:00',5.52),('14598','2013-05-19','14:15:00',5.48),('14598','2013-05-19','14:20:00',5.44),('14598','2013-05-19','14:25:00',5.45),('14598','2013-05-19','14:30:00',5.44),('14598','2013-05-19','14:35:00',5.4),('14598','2013-05-19','14:40:00',5.37),('14598','2013-05-19','14:45:00',5.35),('14598','2013-05-19','14:50:00',5.32),('14598','2013-05-19','14:55:00',5.34),('14598','2013-05-19','15:00:00',5.29),('14598','2013-05-19','15:05:00',5.21),('14598','2013-05-19','15:10:00',5.17),('14598','2013-05-19','15:15:00',5.12),('14598','2013-05-19','15:20:00',5.09),('14598','2013-05-19','15:25:00',5.04),('14598','2013-05-19','15:30:00',5.03),('14598','2013-05-19','15:35:00',4.97),('14598','2013-05-19','15:40:00',4.94),('14598','2013-05-19','15:45:00',4.87),('14598','2013-05-19','15:50:00',4.82),('14598','2013-05-19','15:55:00',4.78),('14598','2013-05-19','16:00:00',4.73),('14598','2013-05-19','16:05:00',4.6),('14598','2013-05-19','16:10:00',4.59),('14598','2013-05-19','16:15:00',4.53),('14598','2013-05-19','16:20:00',4.44),('14598','2013-05-19','16:25:00',4.4),('14598','2013-05-19','16:30:00',4.34),('14598','2013-05-19','16:35:00',4.27),('14598','2013-05-19','16:40:00',4.21),('14598','2013-05-19','16:45:00',4.14),('14598','2013-05-19','16:50:00',4.05),('14598','2013-05-19','16:55:00',3.99),('14598','2013-05-19','17:00:00',3.91),('14598','2013-05-19','17:05:00',3.84),('14598','2013-05-19','17:10:00',3.76),('14598','2013-05-19','17:15:00',3.66),('14598','2013-05-19','17:20:00',3.54),('14598','2013-05-19','17:25:00',3.48),('14598','2013-05-19','17:30:00',3.4),('14598','2013-05-19','17:35:00',3.31),('14598','2013-05-19','17:40:00',3.18),('14598','2013-05-19','17:45:00',3.07),('14598','2013-05-19','17:50:00',2.97),('14598','2013-05-19','17:55:00',2.87),('14598','2013-05-19','18:00:00',2.75),('14598','2013-05-19','18:05:00',2.65),('14598','2013-05-19','18:10:00',2.55),('14598','2013-05-19','18:15:00',2.43),('14598','2013-05-19','18:20:00',2.32),('14598','2013-05-19','18:25:00',2.23),('14598','2013-05-19','18:30:00',2.12),('14598','2013-05-19','18:35:00',2.01),('14598','2013-05-19','18:40:00',1.9),('14598','2013-05-19','18:45:00',1.79),('14598','2013-05-19','18:50:00',1.66),('14598','2013-05-19','18:55:00',1.54),('14598','2013-05-19','19:00:00',1.43),('14598','2013-05-19','19:05:00',1.31),('14598','2013-05-19','19:10:00',1.22),('14598','2013-05-19','19:15:00',1.1),('14598','2013-05-18','08:10:00',1.05),('14598','2013-05-18','08:25:00',1.7),('14598','2013-05-18','08:30:00',1.88),('14598','2013-05-18','08:35:00',2),('14598','2013-05-18','08:40:00',1.97),('14598','2013-05-18','08:45:00',2.11),('14598','2013-05-18','08:50:00',2.24),('14598','2013-05-18','08:55:00',2.41),('14598','2013-05-18','09:00:00',2.69),('14598','2013-05-18','09:05:00',2.75),('14598','2013-05-18','09:10:00',2.67),('14598','2013-05-18','09:15:00',2.72),('14598','2013-05-18','09:20:00',2.8),('14598','2013-05-18','09:25:00',2.92),('14598','2013-05-18','09:30:00',3.01),('14598','2013-05-18','09:35:00',3.08),('14598','2013-05-18','09:40:00',3.15),('14598','2013-05-18','09:45:00',3.24),('14598','2013-05-18','09:50:00',3.32),('14598','2013-05-18','09:55:00',3.39),('14598','2013-05-18','10:00:00',3.45),('14598','2013-05-18','10:05:00',3.53),('14598','2013-05-18','10:10:00',3.62),('14598','2013-05-18','10:15:00',3.67),('14598','2013-05-18','10:20:00',3.75),('14598','2013-05-18','10:25:00',3.79),('14598','2013-05-18','10:30:00',3.86),('14598','2013-05-18','10:35:00',3.96),('14598','2013-05-18','10:40:00',4.05),('14598','2013-05-18','10:45:00',3.89),('14598','2013-05-18','10:50:00',3.38),('14598','2013-05-18','10:55:00',3.61),('14598','2013-05-18','11:00:00',4.02),('14598','2013-05-18','11:05:00',3.26),('14598','2013-05-18','11:10:00',2.56),('14598','2013-05-18','11:15:00',2.56),('14598','2013-05-18','11:20:00',4.51),('14598','2013-05-18','11:25:00',4),('14598','2013-05-18','11:30:00',4.03),('14598','2013-05-18','11:35:00',4.26),('14598','2013-05-18','11:40:00',4.57),('14598','2013-05-18','11:45:00',4.19),('14598','2013-05-18','11:50:00',4.58),('14598','2013-05-18','11:55:00',4.59),('14598','2013-05-18','12:00:00',4.61),('14598','2013-05-18','12:05:00',4.67),('14598','2013-05-18','12:10:00',4.64),('14598','2013-05-18','12:15:00',4.85),('14598','2013-05-18','12:20:00',4.82),('14598','2013-05-18','12:25:00',4.78),('14598','2013-05-18','12:30:00',4.82),('14598','2013-05-18','12:35:00',4.85),('14598','2013-05-18','12:40:00',4.81),('14598','2013-05-18','12:45:00',4.81),('14598','2013-05-18','12:50:00',4.81),('14598','2013-05-18','12:55:00',4.87),('14598','2013-05-18','13:00:00',4.88),('14598','2013-05-18','13:05:00',4.88),('14598','2013-05-18','13:10:00',4.6),('14598','2013-05-18','13:15:00',4.89),('14598','2013-05-18','13:20:00',4.89),('14598','2013-05-18','13:25:00',4.89),('14598','2013-05-18','13:30:00',4.92),('14598','2013-05-18','13:35:00',4.89),('14598','2013-05-18','13:40:00',4.85),('14598','2013-05-18','13:45:00',4.83),('14598','2013-05-18','13:50:00',4.85),('14598','2013-05-18','13:55:00',4.96),('14598','2013-05-18','14:00:00',4.54),('14598','2013-05-18','14:05:00',3.74),('14598','2013-05-18','14:10:00',3.59),('14598','2013-05-18','14:15:00',3.5),('14598','2013-05-18','14:20:00',3.21),('14598','2013-05-18','14:25:00',3.45),('14598','2013-05-18','14:30:00',4.39),('14598','2013-05-18','14:35:00',5.09),('14598','2013-05-18','14:40:00',4.77),('14598','2013-05-18','14:45:00',4.76),('14598','2013-05-18','14:50:00',4.72),('14598','2013-05-18','14:55:00',4.53),('14598','2013-05-18','15:00:00',4.53),('14598','2013-05-18','15:05:00',4.54),('14598','2013-05-18','15:10:00',4.54),('14598','2013-05-18','15:15:00',4.2),('14598','2013-05-18','15:20:00',4.38),('14598','2013-05-18','15:25:00',4.44),('14598','2013-05-18','15:30:00',4.35),('14598','2013-05-18','15:35:00',4.29),('14598','2013-05-18','15:40:00',4.21),('14598','2013-05-18','15:45:00',4.12),('14598','2013-05-18','15:50:00',4.05),('14598','2013-05-18','15:55:00',4.01),('14598','2013-05-18','16:00:00',3.96),('14598','2013-05-18','16:05:00',3.89),('14598','2013-05-18','16:10:00',3.81),('14598','2013-05-18','16:15:00',3.71),('14598','2013-05-18','16:20:00',3.68),('14598','2013-05-18','16:25:00',3.62),('14598','2013-05-18','16:30:00',3.55),('14598','2013-05-18','16:35:00',3.48),('14598','2013-05-18','16:40:00',3.42),('14598','2013-05-18','16:45:00',3.35),('14598','2013-05-18','16:50:00',3.27),('14598','2013-05-18','16:55:00',3.22),('14598','2013-05-18','17:00:00',3.15),('14598','2013-05-18','17:05:00',3.06),('14598','2013-05-18','17:10:00',2.99),('14598','2013-05-18','17:15:00',2.92),('14598','2013-05-18','17:20:00',2.85),('14598','2013-05-18','17:25:00',2.75),('14598','2013-05-18','17:30:00',2.66),('14598','2013-05-18','17:35:00',2.57),('14598','2013-05-18','17:40:00',2.48),('14598','2013-05-18','17:45:00',2.38),('14598','2013-05-18','17:50:00',2.3),('14598','2013-05-18','17:55:00',2.21),('14598','2013-05-18','18:00:00',2.12),('14598','2013-05-18','18:05:00',1.95),('14598','2013-05-18','18:10:00',1.89),('14598','2013-05-18','18:15:00',1.79),('14598','2013-05-18','18:20:00',1.69),('14598','2013-05-18','18:25:00',1.58),('14598','2013-05-18','18:30:00',1.48),('14598','2013-05-18','18:35:00',1.37),('14598','2013-05-18','18:40:00',1.28),('14598','2013-05-18','18:45:00',1.18),('14598','2013-05-18','18:50:00',1.07),('14598','2013-05-17','07:40:00',1.1),('14598','2013-05-17','07:45:00',1.07),('14598','2013-05-17','07:50:00',1.55),('14598','2013-05-17','07:55:00',1.55),('14598','2013-05-17','08:00:00',1.53),('14598','2013-05-17','08:05:00',1.32),('14598','2013-05-17','08:10:00',1.25),('14598','2013-05-17','08:55:00',1.22),('14598','2013-05-17','09:00:00',1.69),('14598','2013-05-17','09:05:00',2.26),('14598','2013-05-17','09:10:00',1.05),('14598','2013-05-17','10:00:00',1.21),('14598','2013-05-17','10:05:00',1.62),('14598','2013-05-17','10:10:00',1.7),('14598','2013-05-17','10:15:00',2.05),('14598','2013-05-17','10:20:00',3.05),('14598','2013-05-17','10:25:00',2.14),('14598','2013-05-17','10:30:00',3.56),('14598','2013-05-17','10:35:00',5.06),('14598','2013-05-17','10:40:00',3.58),('14598','2013-05-17','10:45:00',3.82),('14598','2013-05-17','10:50:00',3.54),('14598','2013-05-17','10:55:00',2.21),('14598','2013-05-17','11:00:00',3.93),('14598','2013-05-17','11:05:00',3.66),('14598','2013-05-17','11:10:00',3.81),('14598','2013-05-17','11:15:00',3.91),('14598','2013-05-17','11:20:00',2.95),('14598','2013-05-17','11:25:00',2.96),('14598','2013-05-17','11:30:00',2.75),('14598','2013-05-17','11:35:00',4.14),('14598','2013-05-17','11:40:00',4.37),('14598','2013-05-17','11:45:00',3.79),('14598','2013-05-17','11:50:00',4.48),('14598','2013-05-17','11:55:00',5.54),('14598','2013-05-17','12:00:00',3.94),('14598','2013-05-17','12:05:00',5.13),('14598','2013-05-17','12:10:00',4.43),('14598','2013-05-17','12:15:00',4.63),('14598','2013-05-17','12:20:00',4.8),('14598','2013-05-17','12:25:00',4.07),('14598','2013-05-17','12:30:00',5.23),('14598','2013-05-17','12:35:00',4.89),('14598','2013-05-17','12:40:00',3.26),('14598','2013-05-17','12:45:00',5.7),('14598','2013-05-17','12:50:00',5.44),('14598','2013-05-17','12:55:00',5.37),('14598','2013-05-17','13:00:00',5.4),('14598','2013-05-17','13:05:00',5.44),('14598','2013-05-17','13:10:00',5.4),('14598','2013-05-17','13:15:00',5.49),('14598','2013-05-17','13:20:00',5.43),('14598','2013-05-17','13:25:00',5.17),('14598','2013-05-17','13:30:00',5.53),('14598','2013-05-17','13:35:00',4.04),('14598','2013-05-17','13:40:00',4.84),('14598','2013-05-17','13:45:00',4.63),('14598','2013-05-17','13:50:00',3.29),('14598','2013-05-17','13:55:00',5.09),('14598','2013-05-17','14:00:00',5.14),('14598','2013-05-17','14:05:00',5.71),('14598','2013-05-17','14:10:00',4.88),('14598','2013-05-17','14:15:00',4.64),('14598','2013-05-17','14:20:00',5.41),('14598','2013-05-17','14:25:00',5.15),('14598','2013-05-17','14:30:00',5.02),('14598','2013-05-17','14:35:00',5.36),('14598','2013-05-17','14:40:00',4.94),('14598','2013-05-17','14:45:00',5.38),('14598','2013-05-17','14:50:00',5.21),('14598','2013-05-17','14:55:00',5.15),('14598','2013-05-17','15:00:00',5.13),('14598','2013-05-17','15:05:00',5.1),('14598','2013-05-17','15:10:00',5.08),('14598','2013-05-17','15:15:00',5.04),('14598','2013-05-17','15:20:00',4.97),('14598','2013-05-17','15:25:00',4.93),('14598','2013-05-17','15:30:00',4.89),('14598','2013-05-17','15:35:00',4.86),('14598','2013-05-17','15:40:00',4.8),('14598','2013-05-17','15:45:00',4.74),('14598','2013-05-17','15:50:00',4.69),('14598','2013-05-17','15:55:00',4.63),('14598','2013-05-17','16:00:00',4.57),('14598','2013-05-17','16:05:00',4.53),('14598','2013-05-17','16:10:00',4.45),('14598','2013-05-17','16:15:00',4.42),('14598','2013-05-17','16:20:00',4.37),('14598','2013-05-17','16:25:00',4.31),('14598','2013-05-17','16:30:00',4.23),('14598','2013-05-17','16:35:00',4.15),('14598','2013-05-17','16:40:00',4.09),('14598','2013-05-17','16:45:00',4.01),('14598','2013-05-17','16:50:00',3.92),('14598','2013-05-17','16:55:00',3.84),('14598','2013-05-17','17:00:00',3.78),('14598','2013-05-17','17:05:00',3.7),('14598','2013-05-17','17:10:00',3.62),('14598','2013-05-17','17:15:00',3.53),('14598','2013-05-17','17:20:00',3.44),('14598','2013-05-17','17:25:00',3.36),('14598','2013-05-17','17:30:00',3.28),('14598','2013-05-17','17:35:00',3.17),('14598','2013-05-17','17:40:00',3.08),('14598','2013-05-17','17:45:00',3),('14598','2013-05-17','17:50:00',2.92),('14598','2013-05-17','17:55:00',2.8),('14598','2013-05-17','18:00:00',2.71),('14598','2013-05-17','18:05:00',2.58),('14598','2013-05-17','18:10:00',2.48),('14598','2013-05-17','18:15:00',2.37),('14598','2013-05-17','18:20:00',2.27),('14598','2013-05-17','18:25:00',2.16),('14598','2013-05-17','18:30:00',2.06),('14598','2013-05-17','18:35:00',1.95),('14598','2013-05-17','18:40:00',1.85),('14598','2013-05-17','18:45:00',1.72),('14598','2013-05-17','18:50:00',1.61),('14598','2013-05-17','18:55:00',1.51),('14598','2013-05-17','19:00:00',1.39),('14598','2013-05-17','19:05:00',1.27),('14598','2013-05-17','19:10:00',1.14),('14598','2013-05-17','19:15:00',1.03),('14598','2013-05-16','09:15:00',1.43),('14598','2013-05-16','09:20:00',1.73),('14598','2013-05-16','09:25:00',1.84),('14598','2013-05-16','09:30:00',2.57),('14598','2013-05-16','09:35:00',3.23),('14598','2013-05-16','09:40:00',3.42),('14598','2013-05-16','09:45:00',2.9),('14598','2013-05-16','09:50:00',1.64),('14598','2013-05-16','09:55:00',3.18),('14598','2013-05-16','10:00:00',3.42),('14598','2013-05-16','10:05:00',2.24),('14598','2013-05-16','10:10:00',1.93),('14598','2013-05-16','10:15:00',1.84),('14598','2013-05-16','10:45:00',1.06),('14598','2013-05-16','10:50:00',1.95),('14598','2013-05-16','10:55:00',1.57),('14598','2013-05-16','11:00:00',1.6),('14598','2013-05-16','11:05:00',2.03),('14598','2013-05-16','11:10:00',1.8),('14598','2013-05-16','11:15:00',1.23),('14598','2013-05-16','11:20:00',1.02),('14598','2013-05-16','11:25:00',1.09),('14598','2013-05-16','11:30:00',1.69),('14598','2013-05-16','11:35:00',1.52),('14598','2013-05-16','11:40:00',1.94),('14598','2013-05-16','11:45:00',1.81),('14598','2013-05-16','11:50:00',1.27),('14598','2013-05-16','11:55:00',1.3),('14598','2013-05-16','12:00:00',1.62),('14598','2013-05-16','12:05:00',1.81),('14598','2013-05-16','12:10:00',2.03),('14598','2013-05-16','12:15:00',2.91),('14598','2013-05-16','12:20:00',4.46),('14598','2013-05-16','12:25:00',2.02),('14598','2013-05-16','12:30:00',1.58),('14598','2013-05-16','12:35:00',1.88),('14598','2013-05-16','12:40:00',3.88),('14598','2013-05-16','12:45:00',3.74),('14598','2013-05-16','12:50:00',3.63),('14598','2013-05-16','12:55:00',4.85),('14598','2013-05-16','13:00:00',4.92),('14598','2013-05-16','13:05:00',4.57),('14598','2013-05-16','13:10:00',3.85),('14598','2013-05-16','13:15:00',4.98),('14598','2013-05-16','13:20:00',4.68),('14598','2013-05-16','13:25:00',4.79),('14598','2013-05-16','13:30:00',4.88),('14598','2013-05-16','13:35:00',4.84),('14598','2013-05-16','13:40:00',4.87),('14598','2013-05-16','13:45:00',4.87),('14598','2013-05-16','13:50:00',4.83),('14598','2013-05-16','13:55:00',4.8),('14598','2013-05-16','14:00:00',4.8),('14598','2013-05-16','14:05:00',4.86),('14598','2013-05-16','14:10:00',4.8),('14598','2013-05-16','14:15:00',4.8),('14598','2013-05-16','14:20:00',4.72),('14598','2013-05-16','14:25:00',4.7),('14598','2013-05-16','14:30:00',4.63),('14598','2013-05-16','14:35:00',4.61),('14598','2013-05-16','14:40:00',4.65),('14598','2013-05-16','14:45:00',4.58),('14598','2013-05-16','14:50:00',4.5),('14598','2013-05-16','14:55:00',4.41),('14598','2013-05-16','15:00:00',4.42),('14598','2013-05-16','15:05:00',2.61),('14598','2013-05-16','15:10:00',3.44),('14598','2013-05-16','15:15:00',3.5),('14598','2013-05-16','15:20:00',4.27),('14598','2013-05-16','15:25:00',4.13),('14598','2013-05-16','15:30:00',4.09),('14598','2013-05-16','15:35:00',3.91),('14598','2013-05-16','15:40:00',4.03),('14598','2013-05-16','15:45:00',3.95),('14598','2013-05-16','15:50:00',3.92),('14598','2013-05-16','15:55:00',3.79),('14598','2013-05-16','16:00:00',3.71),('14598','2013-05-16','16:05:00',3.75),('14598','2013-05-16','16:10:00',3.82),('14598','2013-05-16','16:15:00',3.82),('14598','2013-05-16','16:20:00',3.71),('14598','2013-05-16','16:25:00',3.56),('14598','2013-05-16','16:30:00',3.2),('14598','2013-05-16','16:35:00',3.31),('14598','2013-05-16','16:40:00',3.34),('14598','2013-05-16','16:45:00',3.02),('14598','2013-05-16','16:50:00',2.69),('14598','2013-05-16','16:55:00',3.1),('14598','2013-05-16','17:00:00',3.2),('14598','2013-05-16','17:05:00',2.4),('14598','2013-05-16','17:10:00',2.66),('14598','2013-05-16','17:15:00',2.25),('14598','2013-05-16','17:20:00',1.98),('14598','2013-05-16','17:25:00',2.58),('14598','2013-05-16','17:30:00',2.65),('14598','2013-05-16','17:35:00',2.79),('14598','2013-05-16','17:40:00',2.31),('14598','2013-05-16','17:45:00',1.59),('14598','2013-05-16','17:50:00',1.81),('14598','2013-05-16','17:55:00',2.45),('14598','2013-05-16','18:00:00',2.47),('14598','2013-05-16','18:05:00',2.49),('14598','2013-05-16','18:10:00',2.22),('14598','2013-05-16','18:15:00',2),('14598','2013-05-16','18:20:00',1.79),('14598','2013-05-16','18:25:00',1.59),('14598','2013-05-16','18:30:00',1.52),('14598','2013-05-16','18:35:00',1.51),('14598','2013-05-16','18:40:00',1.36),('14598','2013-05-16','18:45:00',1.17),('14598','2013-05-15','08:00:00',1.1),('14598','2013-05-15','08:05:00',1.25),('14598','2013-05-15','08:10:00',1.33),('14598','2013-05-15','08:15:00',1.45),('14598','2013-05-15','08:20:00',1.43),('14598','2013-05-15','08:25:00',1.64),('14598','2013-05-15','08:30:00',1.78),('14598','2013-05-15','08:35:00',1.9),('14598','2013-05-15','08:40:00',2),('14598','2013-05-15','08:45:00',2.14),('14598','2013-05-15','08:50:00',2.07),('14598','2013-05-15','08:55:00',2.33),('14598','2013-05-15','09:00:00',2.34),('14598','2013-05-15','09:05:00',2.42),('14598','2013-05-15','09:10:00',2.42),('14598','2013-05-15','09:15:00',2.53),('14598','2013-05-15','09:20:00',2.76),('14598','2013-05-15','09:25:00',2.88),('14598','2013-05-15','09:30:00',2.88),('14598','2013-05-15','09:35:00',2.98),('14598','2013-05-15','09:40:00',3.08),('14598','2013-05-15','09:45:00',3.05),('14598','2013-05-15','09:50:00',3.14),('14598','2013-05-15','09:55:00',3.27),('14598','2013-05-15','10:00:00',3.36),('14598','2013-05-15','10:05:00',3.41),('14598','2013-05-15','10:10:00',3.65),('14598','2013-05-15','10:15:00',3.8),('14598','2013-05-15','10:20:00',3.88),('14598','2013-05-15','10:25:00',3.74),('14598','2013-05-15','10:30:00',3.52),('14598','2013-05-15','10:35:00',3.86),('14598','2013-05-15','10:40:00',4.04),('14598','2013-05-15','10:45:00',4.1),('14598','2013-05-15','10:50:00',4.22),('14598','2013-05-15','10:55:00',4.23),('14598','2013-05-15','11:00:00',4.29),('14598','2013-05-15','11:05:00',4.44),('14598','2013-05-15','11:10:00',4.27),('14598','2013-05-15','11:15:00',4.52),('14598','2013-05-15','11:20:00',4.76),('14598','2013-05-15','11:25:00',4.72),('14598','2013-05-15','11:30:00',4.95),('14598','2013-05-15','11:35:00',4.83),('14598','2013-05-15','11:40:00',3.55),('14598','2013-05-15','11:45:00',2.66),('14598','2013-05-15','11:50:00',3.55),('14598','2013-05-15','11:55:00',5.38),('14598','2013-05-15','12:00:00',5.03),('14598','2013-05-15','12:05:00',3.95),('14598','2013-05-15','12:10:00',3.79),('14598','2013-05-15','12:15:00',5.53),('14598','2013-05-15','12:20:00',4.69),('14598','2013-05-15','12:25:00',4.29),('14598','2013-05-15','12:30:00',3.87),('14598','2013-05-15','12:35:00',3.88),('14598','2013-05-15','12:40:00',3.69),('14598','2013-05-15','12:45:00',3.96),('14598','2013-05-15','12:50:00',3.76),('14598','2013-05-15','12:55:00',3.28),('14598','2013-05-15','13:00:00',2.99),('14598','2013-05-15','13:05:00',3.63),('14598','2013-05-15','13:10:00',3.46),('14598','2013-05-15','13:15:00',3.79),('14598','2013-05-15','13:20:00',3.36),('14598','2013-05-15','13:25:00',3.92),('14598','2013-05-15','13:30:00',4.14),('14598','2013-05-15','13:35:00',3.34),('14598','2013-05-15','13:40:00',2.89),('14598','2013-05-15','13:45:00',2.89),('14598','2013-05-15','13:50:00',3.33),('14598','2013-05-15','13:55:00',3.31),('14598','2013-05-15','14:00:00',2.65),('14598','2013-05-15','14:05:00',2.47),('14598','2013-05-15','14:10:00',2.3),('14598','2013-05-15','14:15:00',2.14),('14598','2013-05-15','14:20:00',2.08),('14598','2013-05-15','14:25:00',1.89),('14598','2013-05-15','14:30:00',1.54),('14598','2013-05-15','14:35:00',1.32),('14598','2013-05-15','14:40:00',1.26),('14598','2013-05-15','14:45:00',1.31),('14598','2013-05-15','14:50:00',1.34),('14598','2013-05-15','14:55:00',1.33),('14598','2013-05-15','15:00:00',1.21),('14598','2013-05-15','15:05:00',1.12),('14598','2013-05-15','15:10:00',1.09),('14598','2013-05-15','15:15:00',1.4),('14598','2013-05-15','15:20:00',1.51),('14598','2013-05-15','15:25:00',1.59),('14598','2013-05-15','15:30:00',1.56),('14598','2013-05-15','15:35:00',1.33),('14598','2013-05-15','15:40:00',1.33),('14598','2013-05-15','15:45:00',1.41),('14598','2013-05-15','15:50:00',1.62),('14598','2013-05-15','15:55:00',1.97),('14598','2013-05-15','16:00:00',2.05),('14598','2013-05-15','16:05:00',2.14),('14598','2013-05-15','16:10:00',2.44),('14598','2013-05-15','16:15:00',2.36),('14598','2013-05-15','16:20:00',2.24),('14598','2013-05-15','16:25:00',2.35),('14598','2013-05-15','16:30:00',2.04),('14598','2013-05-15','16:35:00',1.74),('14598','2013-05-15','16:40:00',1.92),('14598','2013-05-15','16:45:00',1.88),('14598','2013-05-15','16:50:00',1.98),('14598','2013-05-15','16:55:00',2.28),('14598','2013-05-15','17:00:00',2.35),('14598','2013-05-15','17:05:00',2.8),('14598','2013-05-15','17:10:00',2.41),('14598','2013-05-15','17:15:00',1.21),('14598','2013-05-15','17:20:00',1.32),('14598','2013-05-15','17:25:00',1.34),('14598','2013-05-15','17:30:00',1.07),('14598','2013-05-15','18:15:00',1.24),('14598','2013-05-14','07:55:00',1.04),('14598','2013-05-14','08:00:00',1.15),('14598','2013-05-14','08:05:00',1.24),('14598','2013-05-14','08:10:00',1.36),('14598','2013-05-14','08:15:00',1.48),('14598','2013-05-14','08:20:00',1.58),('14598','2013-05-14','08:25:00',1.69),('14598','2013-05-14','08:30:00',1.79),('14598','2013-05-14','08:35:00',1.91),('14598','2013-05-14','08:40:00',2.03),('14598','2013-05-14','08:45:00',2.14),('14598','2013-05-14','08:50:00',2.26),('14598','2013-05-14','08:55:00',2.39),('14598','2013-05-14','09:00:00',2.49),('14598','2013-05-14','09:05:00',2.59),('14598','2013-05-14','09:10:00',2.69),('14598','2013-05-14','09:15:00',2.79),('14598','2013-05-14','09:20:00',2.89),('14598','2013-05-14','09:25:00',2.98),('14598','2013-05-14','09:30:00',3.07),('14598','2013-05-14','09:35:00',3.14),('14598','2013-05-14','09:40:00',3.24),('14598','2013-05-14','09:45:00',3.33),('14598','2013-05-14','09:50:00',3.42),('14598','2013-05-14','09:55:00',3.49),('14598','2013-05-14','10:00:00',3.57),('14598','2013-05-14','10:05:00',3.63),('14598','2013-05-14','10:10:00',3.71),('14598','2013-05-14','10:15:00',3.78),('14598','2013-05-14','10:20:00',3.84),('14598','2013-05-14','10:25:00',3.91),('14598','2013-05-14','10:30:00',3.99),('14598','2013-05-14','10:35:00',4.04),('14598','2013-05-14','10:40:00',4.1),('14598','2013-05-14','10:45:00',4.19),('14598','2013-05-14','10:50:00',4.18),('14598','2013-05-14','10:55:00',4.26),('14598','2013-05-14','11:00:00',4.3),('14598','2013-05-14','11:05:00',4.35),('14598','2013-05-14','11:10:00',4.4),('14598','2013-05-14','11:15:00',4.45),('14598','2013-05-14','11:20:00',4.55),('14598','2013-05-14','11:25:00',4.64),('14598','2013-05-14','11:30:00',4.72),('14598','2013-05-14','11:35:00',4.79),('14598','2013-05-14','11:40:00',4.84),('14598','2013-05-14','11:45:00',4.89),('14598','2013-05-14','11:50:00',4.93),('14598','2013-05-14','11:55:00',4.99),('14598','2013-05-14','12:00:00',5.01),('14598','2013-05-14','12:05:00',5.04),('14598','2013-05-14','12:10:00',5.11),('14598','2013-05-14','12:15:00',5.14),('14598','2013-05-14','12:20:00',5.14),('14598','2013-05-14','12:25:00',5.17),('14598','2013-05-14','12:30:00',5.2),('14598','2013-05-14','12:35:00',5.2),('14598','2013-05-14','12:40:00',5.24),('14598','2013-05-14','12:45:00',5.28),('14598','2013-05-14','12:50:00',5.3),('14598','2013-05-14','12:55:00',5.33),('14598','2013-05-14','13:00:00',5.33),('14598','2013-05-14','13:05:00',5.35),('14598','2013-05-14','13:10:00',5.38),('14598','2013-05-14','13:15:00',5.39),('14598','2013-05-14','13:20:00',5.4),('14598','2013-05-14','13:25:00',5.41),('14598','2013-05-14','13:30:00',5.42),('14598','2013-05-14','13:35:00',5.44),('14598','2013-05-14','13:40:00',5.42),('14598','2013-05-14','13:45:00',5.41),('14598','2013-05-14','13:50:00',5.33),('14598','2013-05-14','13:55:00',5.4),('14598','2013-05-14','14:00:00',5.39),('14598','2013-05-14','14:05:00',5.37),('14598','2013-05-14','14:10:00',5.34),('14598','2013-05-14','14:15:00',5.31),('14598','2013-05-14','14:20:00',5.29),('14598','2013-05-14','14:25:00',5.3),('14598','2013-05-14','14:30:00',5.28),('14598','2013-05-14','14:35:00',5.25),('14598','2013-05-14','14:40:00',5.22),('14598','2013-05-14','14:45:00',5.18),('14598','2013-05-14','14:50:00',5.14),('14598','2013-05-14','14:55:00',5.14),('14598','2013-05-14','15:00:00',5.1),('14598','2013-05-14','15:05:00',5.07),('14598','2013-05-14','15:10:00',5.02),('14598','2013-05-14','15:15:00',5),('14598','2013-05-14','15:20:00',4.99),('14598','2013-05-14','15:25:00',4.94),('14598','2013-05-14','15:30:00',4.87),('14598','2013-05-14','15:35:00',4.79),('14598','2013-05-14','15:40:00',4.79),('14598','2013-05-14','15:45:00',4.73),('14598','2013-05-14','15:50:00',4.67),('14598','2013-05-14','15:55:00',4.63),('14598','2013-05-14','16:00:00',4.57),('14598','2013-05-14','16:05:00',4.51),('14598','2013-05-14','16:10:00',4.46),('14598','2013-05-14','16:15:00',4.4),('14598','2013-05-14','16:20:00',4.33),('14598','2013-05-14','16:25:00',4.25),('14598','2013-05-14','16:30:00',4.18),('14598','2013-05-14','16:35:00',4.12),('14598','2013-05-14','16:40:00',4.05),('14598','2013-05-14','16:45:00',3.98),('14598','2013-05-14','16:50:00',3.87),('14598','2013-05-14','16:55:00',3.82),('14598','2013-05-14','17:00:00',3.72),('14598','2013-05-14','17:05:00',3.65),('14598','2013-05-14','17:10:00',3.56),('14598','2013-05-14','17:15:00',3.47),('14598','2013-05-14','17:20:00',3.38),('14598','2013-05-14','17:25:00',3.29),('14598','2013-05-14','17:30:00',3.21),('14598','2013-05-14','17:35:00',3.11),('14598','2013-05-14','17:40:00',3.02),('14598','2013-05-14','17:45:00',2.93),('14598','2013-05-14','17:50:00',2.83),('14598','2013-05-14','17:55:00',2.72),('14598','2013-05-14','18:00:00',2.61),('14598','2013-05-14','18:05:00',2.52),('14598','2013-05-14','18:10:00',2.41),('14598','2013-05-14','18:15:00',2.31),('14598','2013-05-14','18:20:00',2.21),('14598','2013-05-14','18:25:00',2.11),('14598','2013-05-14','18:30:00',1.92),('14598','2013-05-14','18:35:00',1.82),('14598','2013-05-14','18:40:00',1.7),('14598','2013-05-14','18:45:00',1.63),('14598','2013-05-14','18:50:00',1.5),('14598','2013-05-14','18:55:00',1.39),('14598','2013-05-14','19:00:00',1.31),('14598','2013-05-14','19:05:00',1.18),('14598','2013-05-14','19:10:00',1.05),('14598','2013-05-13','07:55:00',1.06),('14598','2013-05-13','08:00:00',1.35),('14598','2013-05-13','08:05:00',1.24),('14598','2013-05-13','08:10:00',1.32),('14598','2013-05-13','08:15:00',1.38),('14598','2013-05-13','08:20:00',1.45),('14598','2013-05-13','08:25:00',1.56),('14598','2013-05-13','08:30:00',1.66),('14598','2013-05-13','08:35:00',1.77),('14598','2013-05-13','08:40:00',1.81),('14598','2013-05-13','08:45:00',2),('14598','2013-05-13','08:50:00',2.15),('14598','2013-05-13','08:55:00',2.28),('14598','2013-05-13','09:00:00',2.36),('14598','2013-05-13','09:05:00',2.46),('14598','2013-05-13','09:10:00',2.63),('14598','2013-05-13','09:15:00',1.03),('14598','2013-05-13','09:20:00',2.22),('14598','2013-05-13','09:25:00',1.2),('14598','2013-05-13','09:30:00',3.18),('14598','2013-05-13','09:35:00',3.27),('14598','2013-05-13','09:40:00',3.25),('14598','2013-05-13','09:45:00',1.87),('14598','2013-05-13','09:50:00',2.12),('14598','2013-05-13','09:55:00',2.42),('14598','2013-05-13','10:00:00',2.59),('14598','2013-05-13','10:05:00',2.86),('14598','2013-05-13','10:10:00',3.66),('14598','2013-05-13','10:15:00',3.93),('14598','2013-05-13','10:20:00',3.92),('14598','2013-05-13','10:25:00',4.05),('14598','2013-05-13','10:30:00',3.42),('14598','2013-05-13','10:35:00',4.23),('14598','2013-05-13','10:40:00',4.36),('14598','2013-05-13','10:45:00',4.57),('14598','2013-05-13','10:50:00',3.41),('14598','2013-05-13','10:55:00',2.2),('14598','2013-05-13','11:00:00',1.36),('14598','2013-05-13','11:05:00',1.68),('14598','2013-05-13','11:10:00',4.72),('14598','2013-05-13','11:15:00',4.8),('14598','2013-05-13','11:20:00',4.79),('14598','2013-05-13','11:25:00',4.82),('14598','2013-05-13','11:30:00',4.96),('14598','2013-05-13','11:35:00',5.04),('14598','2013-05-13','11:40:00',4.34),('14598','2013-05-13','11:45:00',4.7),('14598','2013-05-13','11:50:00',5.17),('14598','2013-05-13','11:55:00',5.19),('14598','2013-05-13','12:00:00',5.25),('14598','2013-05-13','12:05:00',2.72),('14598','2013-05-13','12:10:00',5.19),('14598','2013-05-13','12:15:00',5.11),('14598','2013-05-13','12:20:00',5.12),('14598','2013-05-13','12:25:00',5.1),('14598','2013-05-13','12:30:00',5.15),('14598','2013-05-13','12:35:00',5.18),('14598','2013-05-13','12:40:00',5.19),('14598','2013-05-13','12:45:00',5.21),('14598','2013-05-13','12:50:00',5.23),('14598','2013-05-13','12:55:00',5.3),('14598','2013-05-13','13:00:00',5.33),('14598','2013-05-13','13:05:00',5.33),('14598','2013-05-13','13:10:00',5.35),('14598','2013-05-13','13:15:00',5.38),('14598','2013-05-13','13:20:00',5.37),('14598','2013-05-13','13:25:00',5.35),('14598','2013-05-13','13:30:00',5.33),('14598','2013-05-13','13:35:00',5.35),('14598','2013-05-13','13:40:00',5.31),('14598','2013-05-13','13:45:00',5.35),('14598','2013-05-13','13:50:00',5.36),('14598','2013-05-13','13:55:00',5.33),('14598','2013-05-13','14:00:00',5.31),('14598','2013-05-13','14:05:00',5.3),('14598','2013-05-13','14:10:00',5.21),('14598','2013-05-13','14:15:00',5.32),('14598','2013-05-13','14:20:00',5.33),('14598','2013-05-13','14:25:00',5.31),('14598','2013-05-13','14:30:00',5.26),('14598','2013-05-13','14:35:00',5.23),('14598','2013-05-13','14:40:00',5.2),('14598','2013-05-13','14:45:00',5.2),('14598','2013-05-13','14:50:00',5.2),('14598','2013-05-13','14:55:00',5.23),('14598','2013-05-13','15:00:00',5.21),('14598','2013-05-13','15:05:00',5.11),('14598','2013-05-13','15:10:00',5.04),('14598','2013-05-13','15:15:00',4.99),('14598','2013-05-13','15:20:00',4.96),('14598','2013-05-13','15:25:00',4.94),('14598','2013-05-13','15:30:00',4.95),('14598','2013-05-13','15:35:00',4.94),('14598','2013-05-13','15:40:00',4.82),('14598','2013-05-13','15:45:00',4.72),('14598','2013-05-13','15:50:00',4.66),('14598','2013-05-13','15:55:00',4.61),('14598','2013-05-13','16:00:00',4.58),('14598','2013-05-13','16:05:00',4.54),('14598','2013-05-13','16:10:00',4.44),('14598','2013-05-13','16:15:00',4.38),('14598','2013-05-13','16:20:00',4.33),('14598','2013-05-13','16:25:00',4.27),('14598','2013-05-13','16:30:00',4.21),('14598','2013-05-13','16:35:00',4.13),('14598','2013-05-13','16:40:00',4.05),('14598','2013-05-13','16:45:00',3.98),('14598','2013-05-13','16:50:00',3.89),('14598','2013-05-13','16:55:00',3.79),('14598','2013-05-13','17:00:00',3.71),('14598','2013-05-13','17:05:00',3.63),('14598','2013-05-13','17:10:00',3.47),('14598','2013-05-13','17:15:00',3.43),('14598','2013-05-13','17:20:00',3.34),('14598','2013-05-13','17:25:00',3.25),('14598','2013-05-13','17:30:00',3.16),('14598','2013-05-13','17:35:00',3.07),('14598','2013-05-13','17:40:00',2.96),('14598','2013-05-13','17:45:00',2.86),('14598','2013-05-13','17:50:00',2.75),('14598','2013-05-13','17:55:00',2.66),('14598','2013-05-13','18:00:00',2.55),('14598','2013-05-13','18:05:00',2.44),('14598','2013-05-13','18:10:00',2.33),('14598','2013-05-13','18:15:00',2.23),('14598','2013-05-13','18:20:00',2.13),('14598','2013-05-13','18:25:00',2),('14598','2013-05-13','18:30:00',1.89),('14598','2013-05-13','18:35:00',1.76),('14598','2013-05-13','18:40:00',1.64),('14598','2013-05-13','18:45:00',1.53),('14598','2013-05-13','18:50:00',1.4),('14598','2013-05-13','18:55:00',1.27),('14598','2013-05-13','19:00:00',1.19),('14598','2013-05-13','19:05:00',1.14),('14598','2013-05-13','19:10:00',1.07),('14598','2013-05-13','19:15:00',1.06),('14598','2013-05-12','07:30:00',1.04),('14598','2013-05-12','07:40:00',1.09),('14598','2013-05-12','07:55:00',1.11),('14598','2013-05-12','08:00:00',1.02),('14598','2013-05-12','08:05:00',1),('14598','2013-05-12','08:10:00',1.02),('14598','2013-05-12','08:25:00',1.3),('14598','2013-05-12','08:30:00',1.08),('14598','2013-05-12','08:35:00',1.77),('14598','2013-05-12','08:40:00',1.65),('14598','2013-05-12','08:45:00',2.11),('14598','2013-05-12','08:50:00',2.31),('14598','2013-05-12','08:55:00',2.84),('14598','2013-05-12','09:00:00',2.57),('14598','2013-05-12','09:05:00',1.28),('14598','2013-05-12','09:25:00',1.11),('14598','2013-05-12','09:30:00',3.28),('14598','2013-05-12','09:35:00',3.19),('14598','2013-05-12','09:40:00',3.26),('14598','2013-05-12','09:45:00',3.25),('14598','2013-05-12','09:50:00',3.29),('14598','2013-05-12','09:55:00',3.37),('14598','2013-05-12','10:00:00',3.48),('14598','2013-05-12','10:05:00',3.55),('14598','2013-05-12','10:10:00',3.61),('14598','2013-05-12','10:15:00',3.69),('14598','2013-05-12','10:20:00',3.73),('14598','2013-05-12','10:25:00',3.81),('14598','2013-05-12','10:30:00',3.93),('14598','2013-05-12','10:35:00',3.99),('14598','2013-05-12','10:40:00',4.06),('14598','2013-05-12','10:45:00',4.13),('14598','2013-05-12','10:50:00',4.21),('14598','2013-05-12','10:55:00',4.27),('14598','2013-05-12','11:00:00',4.29),('14598','2013-05-12','11:05:00',4.36),('14598','2013-05-12','11:10:00',4.42),('14598','2013-05-12','11:15:00',4.5),('14598','2013-05-12','11:20:00',4.56),('14598','2013-05-12','11:25:00',4.6),('14598','2013-05-12','11:30:00',4.67),('14598','2013-05-12','11:35:00',4.71),('14598','2013-05-12','11:40:00',4.71),('14598','2013-05-12','11:45:00',4.81),('14598','2013-05-12','11:50:00',4.85),('14598','2013-05-12','11:55:00',4.89),('14598','2013-05-12','12:00:00',4.95),('14598','2013-05-12','12:05:00',4.99),('14598','2013-05-12','12:10:00',5.03),('14598','2013-05-12','12:15:00',5.07),('14598','2013-05-12','12:20:00',5.1),('14598','2013-05-12','12:25:00',5.12),('14598','2013-05-12','12:30:00',5.15),('14598','2013-05-12','12:35:00',5.18),('14598','2013-05-12','12:40:00',5.19),('14598','2013-05-12','12:45:00',5.23),('14598','2013-05-12','12:50:00',5.25),('14598','2013-05-12','12:55:00',5.25),('14598','2013-05-12','13:00:00',5.28),('14598','2013-05-12','13:05:00',5.29),('14598','2013-05-12','13:10:00',5.29),('14598','2013-05-12','13:15:00',5.31),('14598','2013-05-12','13:20:00',5.31),('14598','2013-05-12','13:25:00',5.32),('14598','2013-05-12','13:30:00',5.33),('14598','2013-05-12','13:35:00',5.34),('14598','2013-05-12','13:40:00',5.32),('14598','2013-05-12','13:45:00',5.32),('14598','2013-05-12','13:50:00',5.32),('14598','2013-05-12','13:55:00',5.3),('14598','2013-05-12','14:00:00',5.29),('14598','2013-05-12','14:05:00',5.32),('14598','2013-05-12','14:10:00',5.34),('14598','2013-05-12','14:15:00',4.64),('14598','2013-05-12','14:20:00',5.34),('14598','2013-05-12','14:25:00',5.23),('14598','2013-05-12','14:30:00',5.19),('14598','2013-05-12','14:35:00',5.15),('14598','2013-05-12','14:40:00',5.16),('14598','2013-05-12','14:45:00',5.06),('14598','2013-05-12','14:50:00',5.08),('14598','2013-05-12','14:55:00',5.05),('14598','2013-05-12','15:00:00',5.01),('14598','2013-05-12','15:05:00',5),('14598','2013-05-12','15:10:00',4.97),('14598','2013-05-12','15:15:00',4.91),('14598','2013-05-12','15:20:00',4.86),('14598','2013-05-12','15:25:00',4.82),('14598','2013-05-12','15:30:00',4.75),('14598','2013-05-12','15:35:00',4.68),('14598','2013-05-12','15:40:00',4.64),('14598','2013-05-12','15:45:00',4.63),('14598','2013-05-12','15:50:00',3.83),('14598','2013-05-12','15:55:00',4.83),('14598','2013-05-12','16:00:00',3.46),('14598','2013-05-12','16:05:00',2.6),('14598','2013-05-12','16:10:00',3.78),('14598','2013-05-12','16:15:00',3.37),('14598','2013-05-12','16:20:00',3.99),('14598','2013-05-12','16:25:00',3.75),('14598','2013-05-12','16:30:00',4.19),('14598','2013-05-12','16:35:00',4.27),('14598','2013-05-12','16:40:00',4.02),('14598','2013-05-12','16:45:00',3.13),('14598','2013-05-12','16:50:00',3.55),('14598','2013-05-12','16:55:00',3.91),('14598','2013-05-12','17:00:00',3.86),('14598','2013-05-12','17:05:00',3.26),('14598','2013-05-12','17:10:00',2.43),('14598','2013-05-12','17:15:00',1.74),('14598','2013-05-12','17:20:00',2.82),('14598','2013-05-12','17:25:00',3.26),('14598','2013-05-12','17:30:00',1.34),('14598','2013-05-12','17:35:00',1.42),('14598','2013-05-12','17:40:00',3.26),('14598','2013-05-12','17:45:00',2.57),('14598','2013-05-12','17:50:00',2.27),('14598','2013-05-12','17:55:00',1.58),('14598','2013-05-12','18:00:00',1.47),('14598','2013-05-12','18:05:00',1.35),('14598','2013-05-12','18:10:00',1.06),('14598','2013-05-12','18:15:00',1.51),('14598','2013-05-12','18:20:00',1.09),('14598','2013-05-12','18:25:00',1.14),('14598','2013-05-12','18:30:00',1.22),('14598','2013-05-12','18:35:00',1.76),('14598','2014-03-31','08:45:00',1.06),('14598','2014-03-31','08:50:00',1.15),('14598','2014-03-31','08:55:00',1.27),('14598','2014-03-31','09:00:00',1.37),('14598','2014-03-31','09:05:00',1.49),('14598','2014-03-31','09:10:00',1.61),('14598','2014-03-31','09:15:00',1.72),('14598','2014-03-31','09:20:00',1.83),('14598','2014-03-31','09:25:00',1.98),('14598','2014-03-31','09:30:00',2.09),('14598','2014-03-31','09:35:00',2.18),('14598','2014-03-31','09:40:00',2.28),('14598','2014-03-31','09:45:00',2.37),('14598','2014-03-31','09:50:00',2.46),('14598','2014-03-31','09:55:00',2.55),('14598','2014-03-31','10:00:00',2.64),('14598','2014-03-31','10:05:00',2.73),('14598','2014-03-31','10:10:00',2.82),('14598','2014-03-31','10:15:00',2.88),('14598','2014-03-31','10:20:00',2.98),('14598','2014-03-31','10:25:00',3.06),('14598','2014-03-31','10:30:00',3.13),('14598','2014-03-31','10:35:00',3.16),('14598','2014-03-31','10:40:00',3.28),('14598','2014-03-31','10:45:00',3.34),('14598','2014-03-31','10:50:00',3.4),('14598','2014-03-31','10:55:00',3.47),('14598','2014-03-31','11:00:00',3.53),('14598','2014-03-31','11:05:00',3.58),('14598','2014-03-31','11:10:00',3.66),('14598','2014-03-31','11:15:00',3.72),('14598','2014-03-31','11:20:00',3.81),('14598','2014-03-31','11:25:00',3.87),('14598','2014-03-31','11:30:00',3.95),('14598','2014-03-31','11:35:00',4),('14598','2014-03-31','11:40:00',4.04),('14598','2014-03-31','11:45:00',4.11),('14598','2014-03-31','11:50:00',4.17),('14598','2014-03-31','11:55:00',4.24),('14598','2014-03-31','12:00:00',4.28),('14598','2014-03-31','12:05:00',4.34),('14598','2014-03-31','12:10:00',4.37),('14598','2014-03-31','12:15:00',4.42),('14598','2014-03-31','12:20:00',4.45),('14598','2014-03-31','12:25:00',4.48),('14598','2014-03-31','12:30:00',4.53),('14598','2014-03-31','12:35:00',4.57),('14598','2014-03-31','12:40:00',4.59),('14598','2014-03-31','12:45:00',4.63),('14598','2014-03-31','12:50:00',4.65),('14598','2014-03-31','12:55:00',4.66),('14598','2014-03-31','13:00:00',4.7),('14598','2014-03-31','13:05:00',4.72),('14598','2014-03-31','13:10:00',4.75),('14598','2014-03-31','13:15:00',4.76),('14598','2014-03-31','13:20:00',4.77),('14598','2014-03-31','13:25:00',4.77),('14598','2014-03-31','13:30:00',4.77),('14598','2014-03-31','13:35:00',4.69),('14598','2014-03-31','13:40:00',4.76),('14598','2014-03-31','13:45:00',4.75),('14598','2014-03-31','13:50:00',4.77),('14598','2014-03-31','13:55:00',4.76),('14598','2014-03-31','14:00:00',4.78),('14598','2014-03-31','14:05:00',4.82),('14598','2014-03-31','14:10:00',4.82),('14598','2014-03-31','14:15:00',4.8),('14598','2014-03-31','14:20:00',4.78),('14598','2014-03-31','14:25:00',4.74),('14598','2014-03-31','14:30:00',4.71),('14598','2014-03-31','14:35:00',4.7),('14598','2014-03-31','14:40:00',4.67),('14598','2014-03-31','14:45:00',4.65),('14598','2014-03-31','14:50:00',4.6),('14598','2014-03-31','14:55:00',4.59),('14598','2014-03-31','15:00:00',4.56),('14598','2014-03-31','15:05:00',4.52),('14598','2014-03-31','15:10:00',4.5),('14598','2014-03-31','15:15:00',4.46),('14598','2014-03-31','15:20:00',4.42),('14598','2014-03-31','15:25:00',4.37),('14598','2014-03-31','15:30:00',4.33),('14598','2014-03-31','15:35:00',4.28),('14598','2014-03-31','15:40:00',4.25),('14598','2014-03-31','15:45:00',4.19),('14598','2014-03-31','15:50:00',4.13),('14598','2014-03-31','15:55:00',4.06),('14598','2014-03-31','16:00:00',3.98),('14598','2014-03-31','16:05:00',3.9),('14598','2014-03-31','16:10:00',3.85),('14598','2014-03-31','16:15:00',3.79),('14598','2014-03-31','16:20:00',3.71),('14598','2014-03-31','16:25:00',3.63),('14598','2014-03-31','16:30:00',3.55),('14598','2014-03-31','16:35:00',3.45),('14598','2014-03-31','16:40:00',3.37),('14598','2014-03-31','16:45:00',3.3),('14598','2014-03-31','16:50:00',3.21),('14598','2014-03-31','16:55:00',3.11),('14598','2014-03-31','17:00:00',3.01),('14598','2014-03-31','17:05:00',2.91),('14598','2014-03-31','17:10:00',2.82),('14598','2014-03-31','17:15:00',2.72),('14598','2014-03-31','17:20:00',2.6),('14598','2014-03-31','17:25:00',2.52),('14598','2014-03-31','17:30:00',2.41),('14598','2014-03-31','17:35:00',2.3),('14598','2014-03-31','17:40:00',2.19),('14598','2014-03-31','17:45:00',2.08),('14598','2014-03-31','17:50:00',1.98),('14598','2014-03-31','17:55:00',1.85),('14598','2014-03-31','18:00:00',1.72),('14598','2014-03-31','18:05:00',1.61),('14598','2014-03-31','18:10:00',1.5),('14598','2014-03-31','18:15:00',1.38),('14598','2014-03-31','18:20:00',1.26),('14598','2014-03-31','18:25:00',1.13),('14598','2014-03-31','18:30:00',1.01),('14598','2013-05-11','07:55:00',1.18),('14598','2013-05-11','08:00:00',1.13),('14598','2013-05-11','08:05:00',1.21),('14598','2013-05-11','08:10:00',1.28),('14598','2013-05-11','08:15:00',1.72),('14598','2013-05-11','08:20:00',1.53),('14598','2013-05-11','08:25:00',1.73),('14598','2013-05-11','08:35:00',1.13),('14598','2013-05-11','08:40:00',1.42),('14598','2013-05-11','08:45:00',2.24),('14598','2013-05-11','08:50:00',2.52),('14598','2013-05-11','08:55:00',1.99),('14598','2013-05-11','09:00:00',1.02),('14598','2013-05-11','09:10:00',2.19),('14598','2013-05-11','09:15:00',3.09),('14598','2013-05-11','09:20:00',1.67),('14598','2013-05-11','09:25:00',1.29),('14598','2013-05-11','09:30:00',2.64),('14598','2013-05-11','09:35:00',3.27),('14598','2013-05-11','09:40:00',2.86),('14598','2013-05-11','09:45:00',2.48),('14598','2013-05-11','09:50:00',3.49),('14598','2013-05-11','09:55:00',2.46),('14598','2013-05-11','10:00:00',3.61),('14598','2013-05-11','10:05:00',3.64),('14598','2013-05-11','10:10:00',3.6),('14598','2013-05-11','10:15:00',3.64),('14598','2013-05-11','10:20:00',3.28),('14598','2013-05-11','10:25:00',3.35),('14598','2013-05-11','10:30:00',4),('14598','2013-05-11','10:35:00',4.21),('14598','2013-05-11','10:40:00',4.09),('14598','2013-05-11','10:45:00',4.35),('14598','2013-05-11','10:50:00',3.87),('14598','2013-05-11','10:55:00',4.23),('14598','2013-05-11','11:00:00',4.65),('14598','2013-05-11','11:05:00',5.13),('14598','2013-05-11','11:10:00',3.65),('14598','2013-05-11','11:15:00',3.98),('14598','2013-05-11','11:20:00',4.57),('14598','2013-05-11','11:25:00',4.53),('14598','2013-05-11','11:30:00',4.61),('14598','2013-05-11','11:35:00',4.7),('14598','2013-05-11','11:40:00',4.78),('14598','2013-05-11','11:45:00',5.09),('14598','2013-05-11','11:50:00',5.2),('14598','2013-05-11','11:55:00',4.09),('14598','2013-05-11','12:00:00',3.82),('14598','2013-05-11','12:05:00',5.76),('14598','2013-05-11','12:10:00',4.65),('14598','2013-05-11','12:15:00',5.14),('14598','2013-05-11','12:20:00',5.61),('14598','2013-05-11','12:25:00',3.33),('14598','2013-05-11','12:30:00',4.42),('14598','2013-05-11','12:35:00',4.74),('14598','2013-05-11','12:40:00',4.46),('14598','2013-05-11','12:45:00',5.07),('14598','2013-05-11','12:50:00',5.64),('14598','2013-05-11','12:55:00',5.72),('14598','2013-05-11','13:00:00',4.19),('14598','2013-05-11','13:05:00',5.42),('14598','2013-05-11','13:10:00',5.32),('14598','2013-05-11','13:15:00',5.37),('14598','2013-05-11','13:20:00',5.31),('14598','2013-05-11','13:25:00',5.3),('14598','2013-05-11','13:30:00',5.3),('14598','2013-05-11','13:35:00',5.34),('14598','2013-05-11','13:40:00',5.33),('14598','2013-05-11','13:45:00',5.3),('14598','2013-05-11','13:50:00',5.33),('14598','2013-05-11','13:55:00',5.33),('14598','2013-05-11','14:00:00',5.32),('14598','2013-05-11','14:05:00',4.88),('14598','2013-05-11','14:10:00',5.14),('14598','2013-05-11','14:15:00',3.58),('14598','2013-05-11','14:20:00',4.7),('14598','2013-05-11','14:25:00',3.81),('14598','2013-05-11','14:30:00',4.23),('14598','2013-05-11','14:35:00',3.89),('14598','2013-05-11','14:40:00',3.42),('14598','2013-05-11','14:45:00',4.41),('14598','2013-05-11','14:50:00',4.14),('14598','2013-05-11','14:55:00',4.54),('14598','2013-05-11','15:00:00',4.09),('14598','2013-05-11','15:05:00',3.9),('14598','2013-05-11','15:10:00',4.33),('14598','2013-05-11','15:15:00',3.98),('14598','2013-05-11','15:20:00',4.82),('14598','2013-05-11','15:25:00',3.47),('14598','2013-05-11','15:30:00',4.55),('14598','2013-05-11','15:35:00',4.25),('14598','2013-05-11','15:40:00',4.83),('14598','2013-05-11','15:45:00',4.46),('14598','2013-05-11','15:50:00',5.01),('14598','2013-05-11','15:55:00',3.63),('14598','2013-05-11','16:00:00',4),('14598','2013-05-11','16:05:00',4.24),('14598','2013-05-11','16:10:00',4.09),('14598','2013-05-11','16:15:00',3.77),('14598','2013-05-11','16:20:00',3.86),('14598','2013-05-11','16:25:00',4.31),('14598','2013-05-11','16:30:00',4.22),('14598','2013-05-11','16:35:00',4.15),('14598','2013-05-11','16:40:00',3.8),('14598','2013-05-11','16:45:00',3.51),('14598','2013-05-11','16:50:00',3.83),('14598','2013-05-11','16:55:00',3.1),('14598','2013-05-11','17:00:00',3.71),('14598','2013-05-11','17:05:00',3.41),('14598','2013-05-11','17:10:00',3.71),('14598','2013-05-11','17:15:00',3.52),('14598','2013-05-11','17:20:00',2.81),('14598','2013-05-11','17:25:00',3.2),('14598','2013-05-11','17:30:00',2.54),('14598','2013-05-11','17:35:00',2.41),('14598','2013-05-11','17:40:00',1.45),('14598','2013-05-11','17:45:00',1.67),('14598','2013-05-11','17:50:00',2),('14598','2013-05-11','17:55:00',2.26),('14598','2013-05-11','18:00:00',2.21),('14598','2013-05-11','18:05:00',1.36),('14598','2013-05-11','18:10:00',2.09),('14598','2013-05-11','18:15:00',1.37),('14598','2013-05-11','18:20:00',1.02),('14598','2013-05-11','18:25:00',2.47),('14598','2013-05-11','18:30:00',2.07),('14598','2013-05-11','18:35:00',1.3),('14598','2013-05-11','18:40:00',1.75),('14598','2013-05-11','18:45:00',1.62),('14598','2013-05-11','18:50:00',1.51),('14598','2013-05-11','18:55:00',1.34),('14598','2013-05-11','19:00:00',1.07),('14598','2013-05-10','07:25:00',1.05),('14598','2013-05-10','07:30:00',1.07),('14598','2013-05-10','07:35:00',1.07),('14598','2013-05-10','07:40:00',1.15),('14598','2013-05-10','07:45:00',1.18),('14598','2013-05-10','07:50:00',1.22),('14598','2013-05-10','07:55:00',1.27),('14598','2013-05-10','08:00:00',1.29),('14598','2013-05-10','08:25:00',1.24),('14598','2013-05-10','08:30:00',1.71),('14598','2013-05-10','08:35:00',1.78),('14598','2013-05-10','08:40:00',2.11),('14598','2013-05-10','08:45:00',2.32),('14598','2013-05-10','08:50:00',2.35),('14598','2013-05-10','08:55:00',1.15),('14598','2013-05-10','09:00:00',1.29),('14598','2013-05-10','09:05:00',3.09),('14598','2013-05-10','09:10:00',2.63),('14598','2013-05-10','09:15:00',2.76),('14598','2013-05-10','09:20:00',3.04),('14598','2013-05-10','09:25:00',2.69),('14598','2013-05-10','09:30:00',2.95),('14598','2013-05-10','09:35:00',2.97),('14598','2013-05-10','09:40:00',3.11),('14598','2013-05-10','09:45:00',3.21),('14598','2013-05-10','09:50:00',3.3),('14598','2013-05-10','09:55:00',3.39),('14598','2013-05-10','10:00:00',3.44),('14598','2013-05-10','10:05:00',3.53),('14598','2013-05-10','10:10:00',3.26),('14598','2013-05-10','10:15:00',3.76),('14598','2013-05-10','10:20:00',3.79),('14598','2013-05-10','10:25:00',3.86),('14598','2013-05-10','10:30:00',3.95),('14598','2013-05-10','10:35:00',4.04),('14598','2013-05-10','10:40:00',4.13),('14598','2013-05-10','10:45:00',4.29),('14598','2013-05-10','10:50:00',4.42),('14598','2013-05-10','10:55:00',4.58),('14598','2013-05-10','11:00:00',4.75),('14598','2013-05-10','11:05:00',4.74),('14598','2013-05-10','11:10:00',4.09),('14598','2013-05-10','11:15:00',3.42),('14598','2013-05-10','11:20:00',4.93),('14598','2013-05-10','11:25:00',4.83),('14598','2013-05-10','11:30:00',4.59),('14598','2013-05-10','11:35:00',4.24),('14598','2013-05-10','11:40:00',3.59),('14598','2013-05-10','11:45:00',3.25),('14598','2013-05-10','11:50:00',3),('14598','2013-05-10','11:55:00',3.15),('14598','2013-05-10','12:00:00',4.53),('14598','2013-05-10','12:05:00',4.17),('14598','2013-05-10','12:10:00',5.06),('14598','2013-05-10','12:15:00',5.63),('14598','2013-05-10','12:20:00',5.9),('14598','2013-05-10','12:25:00',5.99),('14598','2013-05-10','12:30:00',5.46),('14598','2013-05-10','12:35:00',4.55),('14598','2013-05-10','12:40:00',3.36),('14598','2013-05-10','12:45:00',3.3),('14598','2013-05-10','12:50:00',3.08),('14598','2013-05-10','12:55:00',2.59),('14598','2013-05-10','13:00:00',2.81),('14598','2013-05-10','13:05:00',3.24),('14598','2013-05-10','13:10:00',4.45),('14598','2013-05-10','13:15:00',5.13),('14598','2013-05-10','13:20:00',5.05),('14598','2013-05-10','13:25:00',4.64),('14598','2013-05-10','13:30:00',3.74),('14598','2013-05-10','13:35:00',4.08),('14598','2013-05-10','13:40:00',3.7),('14598','2013-05-10','13:45:00',3.26),('14598','2013-05-10','13:50:00',2.9),('14598','2013-05-10','13:55:00',2.8),('14598','2013-05-10','14:00:00',2.86),('14598','2013-05-10','14:05:00',2.38),('14598','2013-05-10','14:10:00',1.98),('14598','2013-05-10','14:15:00',2.18),('14598','2013-05-10','14:20:00',3.11),('14598','2013-05-10','14:25:00',3.16),('14598','2013-05-10','14:30:00',3.97),('14598','2013-05-10','14:35:00',4.89),('14598','2013-05-10','14:40:00',3.7),('14598','2013-05-10','14:45:00',3.67),('14598','2013-05-10','14:50:00',2.93),('14598','2013-05-10','14:55:00',2.76),('14598','2013-05-10','15:00:00',3.13),('14598','2013-05-10','15:05:00',3.16),('14598','2013-05-10','15:10:00',3.21),('14598','2013-05-10','15:15:00',3.53),('14598','2013-05-10','15:20:00',4.2),('14598','2013-05-10','15:25:00',3.16),('14598','2013-05-10','15:30:00',2.83),('14598','2013-05-10','15:35:00',3.21),('14598','2013-05-10','15:40:00',5.32),('14598','2013-05-10','15:45:00',3.59),('14598','2013-05-10','15:50:00',2.41),('14598','2013-05-10','15:55:00',1.95),('14598','2013-05-10','16:00:00',1.74),('14598','2013-05-10','16:05:00',1.74),('14598','2013-05-10','16:10:00',1.57),('14598','2013-05-10','16:15:00',1.37),('14598','2013-05-10','16:20:00',1.41),('14598','2013-05-10','16:25:00',1.7),('14598','2013-05-10','16:30:00',2.02),('14598','2013-05-10','16:35:00',2.08),('14598','2013-05-10','16:40:00',2.62),('14598','2013-05-10','16:45:00',2.94),('14598','2013-05-10','16:50:00',3.66),('14598','2013-05-10','16:55:00',3.38),('14598','2013-05-10','17:00:00',2.93),('14598','2013-05-10','17:05:00',2.94),('14598','2013-05-10','17:10:00',2.59),('14598','2013-05-10','17:15:00',2.08),('14598','2013-05-10','17:20:00',1.72),('14598','2013-05-10','17:25:00',1.47),('14598','2013-05-10','17:30:00',1.38),('14598','2013-05-10','17:35:00',1.35),('14598','2013-05-10','17:40:00',1.23),('14598','2013-05-10','17:45:00',1.05),('14598','2013-05-10','17:50:00',1),('14598','2013-05-09','08:00:00',1.02),('14598','2013-05-09','08:05:00',1.12),('14598','2013-05-09','08:10:00',1.22),('14598','2013-05-09','08:15:00',1.34),('14598','2013-05-09','08:20:00',1.45),('14598','2013-05-09','08:25:00',1.55),('14598','2013-05-09','08:30:00',1.66),('14598','2013-05-09','08:35:00',1.8),('14598','2013-05-09','08:40:00',1.9),('14598','2013-05-09','08:45:00',1.99),('14598','2013-05-09','08:50:00',2.1),('14598','2013-05-09','08:55:00',2.21),('14598','2013-05-09','09:00:00',2.33),('14598','2013-05-09','09:05:00',2.43),('14598','2013-05-09','09:10:00',2.53),('14598','2013-05-09','09:15:00',2.64),('14598','2013-05-09','09:20:00',2.73),('14598','2013-05-09','09:25:00',2.82),('14598','2013-05-09','09:30:00',2.91),('14598','2013-05-09','09:35:00',2.99),('14598','2013-05-09','09:40:00',3.07),('14598','2013-05-09','09:45:00',3.17),('14598','2013-05-09','09:50:00',3.24),('14598','2013-05-09','09:55:00',3.3),('14598','2013-05-09','10:00:00',3.34),('14598','2013-05-09','10:05:00',3.41),('14598','2013-05-09','10:10:00',3.5),('14598','2013-05-09','10:15:00',3.57),('14598','2013-05-09','10:20:00',3.66),('14598','2013-05-09','10:25:00',3.71),('14598','2013-05-09','10:30:00',3.75),('14598','2013-05-09','10:35:00',3.83),('14598','2013-05-09','10:40:00',3.9),('14598','2013-05-09','10:45:00',3.95),('14598','2013-05-09','10:50:00',3.99),('14598','2013-05-09','10:55:00',3.96),('14598','2013-05-09','11:00:00',4.11),('14598','2013-05-09','11:05:00',4.16),('14598','2013-05-09','11:10:00',4.23),('14598','2013-05-09','11:15:00',4.29),('14598','2013-05-09','11:20:00',4.31),('14598','2013-05-09','11:25:00',4.34),('14598','2013-05-09','11:30:00',4.4),('14598','2013-05-09','11:35:00',4.47),('14598','2013-05-09','11:40:00',4.64),('14598','2013-05-09','11:45:00',4.71),('14598','2013-05-09','11:50:00',4.79),('14598','2013-05-09','11:55:00',4.82),('14598','2013-05-09','12:00:00',4.87),('14598','2013-05-09','12:05:00',4.9),('14598','2013-05-09','12:10:00',4.94),('14598','2013-05-09','12:15:00',4.99),('14598','2013-05-09','12:20:00',5.02),('14598','2013-05-09','12:25:00',5.06),('14598','2013-05-09','12:30:00',5.09),('14598','2013-05-09','12:35:00',5.07),('14598','2013-05-09','12:40:00',5.06),('14598','2013-05-09','12:45:00',5.16),('14598','2013-05-09','12:50:00',5.18),('14598','2013-05-09','12:55:00',5.19),('14598','2013-05-09','13:00:00',5.23),('14598','2013-05-09','13:05:00',5.25),('14598','2013-05-09','13:10:00',5.28),('14598','2013-05-09','13:15:00',5.3),('14598','2013-05-09','13:20:00',5.31),('14598','2013-05-09','13:25:00',5.33),('14598','2013-05-09','13:30:00',5.35),('14598','2013-05-09','13:35:00',5.32),('14598','2013-05-09','13:40:00',5.28),('14598','2013-05-09','13:45:00',5.31),('14598','2013-05-09','13:50:00',5.31),('14598','2013-05-09','13:55:00',5.25),('14598','2013-05-09','14:00:00',5.29),('14598','2013-05-09','14:05:00',5.28),('14598','2013-05-09','14:10:00',5.26),('14598','2013-05-09','14:15:00',5.25),('14598','2013-05-09','14:20:00',5.25),('14598','2013-05-09','14:25:00',5.19),('14598','2013-05-09','14:30:00',5.2),('14598','2013-05-09','14:35:00',5.16),('14598','2013-05-09','14:40:00',5.14),('14598','2013-05-09','14:45:00',5.11),('14598','2013-05-09','14:50:00',5.11),('14598','2013-05-09','14:55:00',5.1),('14598','2013-05-09','15:00:00',5.05),('14598','2013-05-09','15:05:00',5.01),('14598','2013-05-09','15:10:00',4.96),('14598','2013-05-09','15:15:00',4.93),('14598','2013-05-09','15:20:00',4.87),('14598','2013-05-09','15:25:00',4.83),('14598','2013-05-09','15:30:00',4.79),('14598','2013-05-09','15:35:00',4.76),('14598','2013-05-09','15:40:00',4.69),('14598','2013-05-09','15:45:00',4.65),('14598','2013-05-09','15:50:00',4.6),('14598','2013-05-09','15:55:00',4.55),('14598','2013-05-09','16:00:00',4.5),('14598','2013-05-09','16:05:00',4.41),('14598','2013-05-09','16:10:00',4.35),('14598','2013-05-09','16:15:00',4.28),('14598','2013-05-09','16:20:00',4.23),('14598','2013-05-09','16:25:00',4.18),('14598','2013-05-09','16:30:00',4.11),('14598','2013-05-09','16:35:00',4.02),('14598','2013-05-09','16:40:00',3.95),('14598','2013-05-09','16:45:00',3.86),('14598','2013-05-09','16:50:00',3.79),('14598','2013-05-09','16:55:00',3.72),('14598','2013-05-09','17:00:00',3.62),('14598','2013-05-09','17:05:00',3.53),('14598','2013-05-09','17:10:00',3.46),('14598','2013-05-09','17:15:00',3.37),('14598','2013-05-09','17:20:00',3.3),('14598','2013-05-09','17:25:00',3.19),('14598','2013-05-09','17:30:00',3.08),('14598','2013-05-09','17:35:00',2.99),('14598','2013-05-09','17:40:00',2.91),('14598','2013-05-09','17:45:00',2.81),('14598','2013-05-09','17:50:00',2.71),('14598','2013-05-09','17:55:00',2.6),('14598','2013-05-09','18:00:00',2.51),('14598','2013-05-09','18:05:00',2.4),('14598','2013-05-09','18:10:00',2.28),('14598','2013-05-09','18:15:00',2.17),('14598','2013-05-09','18:20:00',2.05),('14598','2013-05-09','18:25:00',1.93),('14598','2013-05-09','18:30:00',1.83),('14598','2013-05-09','18:35:00',1.72),('14598','2013-05-09','18:40:00',1.62),('14598','2013-05-09','18:45:00',1.49),('14598','2013-05-09','18:50:00',1.37),('14598','2013-05-09','18:55:00',1.21),('14598','2013-05-09','19:00:00',1.15),('14598','2013-05-08','08:00:00',1.01),('14598','2013-05-08','08:05:00',1.09),('14598','2013-05-08','08:10:00',1.18),('14598','2013-05-08','08:15:00',1.29),('14598','2013-05-08','08:20:00',1.4),('14598','2013-05-08','08:25:00',1.49),('14598','2013-05-08','08:30:00',1.62),('14598','2013-05-08','08:35:00',1.74),('14598','2013-05-08','08:40:00',1.87),('14598','2013-05-08','08:45:00',2.05),('14598','2013-05-08','08:50:00',2.33),('14598','2013-05-08','08:55:00',1.92),('14598','2013-05-08','09:00:00',2.05),('14598','2013-05-08','09:05:00',2.96),('14598','2013-05-08','09:10:00',2.76),('14598','2013-05-08','09:15:00',2.71),('14598','2013-05-08','09:20:00',2.81),('14598','2013-05-08','09:25:00',2.94),('14598','2013-05-08','09:30:00',2.96),('14598','2013-05-08','09:35:00',2.77),('14598','2013-05-08','09:40:00',2.81),('14598','2013-05-08','09:45:00',3.24),('14598','2013-05-08','09:50:00',3.3),('14598','2013-05-08','09:55:00',3.37),('14598','2013-05-08','10:00:00',3.44),('14598','2013-05-08','10:05:00',3.53),('14598','2013-05-08','10:10:00',3.61),('14598','2013-05-08','10:15:00',3.68),('14598','2013-05-08','10:20:00',3.76),('14598','2013-05-08','10:25:00',3.85),('14598','2013-05-08','10:30:00',3.91),('14598','2013-05-08','10:35:00',3.97),('14598','2013-05-08','10:40:00',4.04),('14598','2013-05-08','10:45:00',4.13),('14598','2013-05-08','10:50:00',4.18),('14598','2013-05-08','10:55:00',4.23),('14598','2013-05-08','11:00:00',4.3),('14598','2013-05-08','11:05:00',4.34),('14598','2013-05-08','11:10:00',4.42),('14598','2013-05-08','11:15:00',4.44),('14598','2013-05-08','11:20:00',4.56),('14598','2013-05-08','11:25:00',4.62),('14598','2013-05-08','11:30:00',4.68),('14598','2013-05-08','11:35:00',4.71),('14598','2013-05-08','11:40:00',4.76),('14598','2013-05-08','11:45:00',4.79),('14598','2013-05-08','11:50:00',4.83),('14598','2013-05-08','11:55:00',4.86),('14598','2013-05-08','12:00:00',4.91),('14598','2013-05-08','12:05:00',4.96),('14598','2013-05-08','12:10:00',4.99),('14598','2013-05-08','12:15:00',5.02),('14598','2013-05-08','12:20:00',5.04),('14598','2013-05-08','12:25:00',5.08),('14598','2013-05-08','12:30:00',5.13),('14598','2013-05-08','12:35:00',5.16),('14598','2013-05-08','12:40:00',5.16),('14598','2013-05-08','12:45:00',5.17),('14598','2013-05-08','12:50:00',5.22),('14598','2013-05-08','12:55:00',5.24),('14598','2013-05-08','13:00:00',5.23),('14598','2013-05-08','13:05:00',5.24),('14598','2013-05-08','13:10:00',5.25),('14598','2013-05-08','13:15:00',5.28),('14598','2013-05-08','13:20:00',5.29),('14598','2013-05-08','13:25:00',5.3),('14598','2013-05-08','13:30:00',5.29),('14598','2013-05-08','13:35:00',5.29),('14598','2013-05-08','13:40:00',5.28),('14598','2013-05-08','13:45:00',5.3),('14598','2013-05-08','13:50:00',5.31),('14598','2013-05-08','13:55:00',5.31),('14598','2013-05-08','14:00:00',5.29),('14598','2013-05-08','14:05:00',5.27),('14598','2013-05-08','14:10:00',5.27),('14598','2013-05-08','14:15:00',5.22),('14598','2013-05-08','14:20:00',5.23),('14598','2013-05-08','14:25:00',5.22),('14598','2013-05-08','14:30:00',5.18),('14598','2013-05-08','14:35:00',5.13),('14598','2013-05-08','14:40:00',5.11),('14598','2013-05-08','14:45:00',5.08),('14598','2013-05-08','14:50:00',5.04),('14598','2013-05-08','14:55:00',5.02),('14598','2013-05-08','15:00:00',4.98),('14598','2013-05-08','15:05:00',4.96),('14598','2013-05-08','15:10:00',4.93),('14598','2013-05-08','15:15:00',4.88),('14598','2013-05-08','15:20:00',4.81),('14598','2013-05-08','15:25:00',4.75),('14598','2013-05-08','15:30:00',4.7),('14598','2013-05-08','15:35:00',4.68),('14598','2013-05-08','15:40:00',4.63),('14598','2013-05-08','15:45:00',4.57),('14598','2013-05-08','15:50:00',4.52),('14598','2013-05-08','15:55:00',4.47),('14598','2013-05-08','16:00:00',4.41),('14598','2013-05-08','16:05:00',4.36),('14598','2013-05-08','16:10:00',4.31),('14598','2013-05-08','16:15:00',4.24),('14598','2013-05-08','16:20:00',3.97),('14598','2013-05-08','16:25:00',4.09),('14598','2013-05-08','16:30:00',3.04),('14598','2013-05-08','16:35:00',2.2),('14598','2013-05-08','16:40:00',3.07),('14598','2013-05-08','16:45:00',2.74),('14598','2013-05-08','16:50:00',2.15),('14598','2013-05-08','16:55:00',1.86),('14598','2013-05-08','17:00:00',2.14),('14598','2013-05-08','17:05:00',2.65),('14598','2013-05-08','17:10:00',3.14),('14598','2013-05-08','17:15:00',3.3),('14598','2013-05-08','17:20:00',3.2),('14598','2013-05-08','17:25:00',3.28),('14598','2013-05-08','17:30:00',3.05),('14598','2013-05-08','17:35:00',2.87),('14598','2013-05-08','17:40:00',2.68),('14598','2013-05-08','17:45:00',2.52),('14598','2013-05-08','17:50:00',2.14),('14598','2013-05-08','17:55:00',2.75),('14598','2013-05-08','18:00:00',1.01),('14598','2013-05-08','18:25:00',1.09),('14598','2013-05-08','18:30:00',1.53),('14598','2013-05-08','18:35:00',1.08),('14598','2013-05-08','18:45:00',1.37),('14598','2013-05-08','18:50:00',1.54),('14598','2013-05-08','18:55:00',1.39),('14598','2013-05-08','19:00:00',1.23),('14598','2013-05-07','08:00:00',1.03),('14598','2013-05-07','08:06:00',1.12),('14598','2013-05-07','08:10:00',1.23),('14598','2013-05-07','08:15:00',1.32),('14598','2013-05-07','08:20:00',1.45),('14598','2013-05-07','08:25:00',1.58),('14598','2013-05-07','08:30:00',1.68),('14598','2013-05-07','08:36:00',1.81),('14598','2013-05-07','08:40:00',1.94),('14598','2013-05-07','08:45:00',2.02),('14598','2013-05-07','08:50:00',2.25),('14598','2013-05-07','08:55:00',2.29),('14598','2013-05-07','09:00:00',2.43),('14598','2013-05-07','09:07:00',1.33),('14598','2013-05-07','09:30:00',2.16),('14598','2013-05-07','09:37:00',3.18),('14598','2013-05-07','09:40:00',1.85),('14598','2013-05-07','09:55:00',2.01),('14598','2013-05-07','10:00:00',3.73),('14598','2013-05-07','10:05:00',3.69),('14598','2013-05-07','10:10:00',3.74),('14598','2013-05-07','10:15:00',3.79),('14598','2013-05-07','10:20:00',3.78),('14598','2013-05-07','10:25:00',3.86),('14598','2013-05-07','10:30:00',3.94),('14598','2013-05-07','10:35:00',3.98),('14598','2013-05-07','10:40:00',4.08),('14598','2013-05-07','10:45:00',4.17),('14598','2013-05-07','10:50:00',4.27),('14598','2013-05-07','10:55:00',4.35),('14598','2013-05-07','11:00:00',4.37),('14598','2013-05-07','11:05:00',4.46),('14598','2013-05-07','11:10:00',4.51),('14598','2013-05-07','11:15:00',4.57),('14598','2013-05-07','11:20:00',4.61),('14598','2013-05-07','11:25:00',4.65),('14598','2013-05-07','11:30:00',4.74),('14598','2013-05-07','11:35:00',4.81),('14598','2013-05-07','11:40:00',4.87),('14598','2013-05-07','11:45:00',4.92),('14598','2013-05-07','11:50:00',4.98),('14598','2013-05-07','11:55:00',5),('14598','2013-05-07','12:00:00',5.2),('14598','2013-05-07','12:05:00',4.46),('14598','2013-05-07','12:10:00',4.08),('14598','2013-05-07','12:15:00',4.19),('14598','2013-05-07','12:20:00',4.63),('14598','2013-05-07','12:25:00',4.63),('14598','2013-05-07','12:30:00',4.71),('14598','2013-05-07','12:35:00',4.64),('14598','2013-05-07','12:40:00',4.46),('14598','2013-05-07','12:45:00',4.05),('14598','2013-05-07','12:50:00',3.73),('14598','2013-05-07','12:55:00',4.53),('14598','2013-05-07','13:00:00',5.16),('14598','2013-05-07','13:05:00',4.79),('14598','2013-05-07','13:10:00',4.64),('14598','2013-05-07','13:15:00',5.44),('14598','2013-05-07','13:20:00',5.46),('14598','2013-05-07','13:25:00',5.41),('14598','2013-05-07','13:30:00',5.45),('14598','2013-05-07','13:35:00',5.07),('14598','2013-05-07','13:40:00',5.44),('14598','2013-05-07','13:45:00',5.7),('14598','2013-05-07','13:50:00',5.28),('14598','2013-05-07','13:55:00',5.23),('14598','2013-05-07','14:00:00',5.6),('14598','2013-05-07','14:05:00',5.21),('14598','2013-05-07','14:10:00',5.41),('14598','2013-05-07','14:15:00',4.59),('14598','2013-05-07','14:20:00',5.48),('14598','2013-05-07','14:25:00',4.76),('14598','2013-05-07','14:30:00',5.1),('14598','2013-05-07','14:35:00',5.29),('14598','2013-05-07','14:40:00',5.28),('14598','2013-05-07','14:45:00',5.13),('14598','2013-05-07','14:50:00',5.11),('14598','2013-05-07','14:55:00',4.86),('14598','2013-05-07','15:00:00',4.61),('14598','2013-05-07','15:05:00',4.08),('14598','2013-05-07','15:10:00',5.08),('14598','2013-05-07','15:15:00',4.59),('14598','2013-05-07','15:20:00',5.09),('14598','2013-05-07','15:25:00',5.06),('14598','2013-05-07','15:30:00',4.19),('14598','2013-05-07','15:35:00',4.2),('14598','2013-05-07','15:40:00',4.05),('14598','2013-05-07','15:45:00',2.81),('14598','2013-05-07','15:50:00',2.42),('14598','2013-05-07','15:55:00',4.01),('14598','2013-05-07','16:00:00',3.45),('14598','2013-05-07','16:05:00',1.68),('14598','2013-05-07','16:10:00',1.9),('14598','2013-05-07','16:15:00',2.78),('14598','2013-05-07','16:20:00',4.36),('14598','2013-05-07','16:25:00',4.47),('14598','2013-05-07','16:30:00',2.88),('14598','2013-05-07','16:35:00',2.1),('14598','2013-05-07','16:40:00',1.69),('14598','2013-05-07','16:45:00',1.61),('14598','2013-05-07','16:50:00',1.82),('14598','2013-05-07','16:55:00',2.68),('14598','2013-05-07','17:00:00',2.07),('14598','2013-05-07','17:05:00',1.68),('14598','2013-05-07','17:10:00',1.34),('14598','2013-05-07','17:15:00',1.35),('14598','2013-05-07','17:20:00',1.35),('14598','2013-05-07','17:25:00',1.28),('14598','2013-05-07','17:30:00',1.01),('14598','2013-05-07','18:10:00',1.4),('14598','2013-05-07','18:15:00',2.41),('14598','2013-05-07','18:20:00',2.14),('14598','2013-05-07','18:25:00',1.44),('14598','2013-05-07','18:30:00',1.75),('14598','2013-05-07','18:35:00',1.22),('14598','2013-05-06','09:00:00',1.17),('14598','2013-05-06','09:05:00',1.49),('14598','2013-05-06','09:40:00',1.89),('14598','2013-05-06','09:45:00',3.23),('14598','2013-05-06','09:50:00',2.13),('14598','2013-05-06','09:55:00',2.18),('14598','2013-05-06','10:00:00',2.28),('14598','2013-05-06','10:05:00',2),('14598','2013-05-06','10:10:00',1.16),('14598','2013-05-06','10:15:00',1.24),('14598','2013-05-06','10:20:00',1.38),('14598','2013-05-06','10:25:00',1.44),('14598','2013-05-06','10:30:00',1.77),('14598','2013-05-06','10:35:00',2.61),('14598','2013-05-06','10:40:00',2.82),('14598','2013-05-06','10:45:00',2.6),('14598','2013-05-06','10:50:00',2.48),('14598','2013-05-06','10:55:00',3.6),('14598','2013-05-06','11:00:00',4.51),('14598','2013-05-06','11:05:00',4.35),('14598','2013-05-06','11:10:00',4),('14598','2013-05-06','11:15:00',4.64),('14598','2013-05-06','11:20:00',3.66),('14598','2013-05-06','11:25:00',4.66),('14598','2013-05-06','11:30:00',4.74),('14598','2013-05-06','11:35:00',4.75),('14598','2013-05-06','11:40:00',4.81),('14598','2013-05-06','11:45:00',4.83),('14598','2013-05-06','11:50:00',4.82),('14598','2013-05-06','11:55:00',4.94),('14598','2013-05-06','12:00:00',4.92),('14598','2013-05-06','12:05:00',4.94),('14598','2013-05-06','12:10:00',4.96),('14598','2013-05-06','12:15:00',5),('14598','2013-05-06','12:20:00',5.03),('14598','2013-05-06','12:25:00',5.06),('14598','2013-05-06','12:30:00',5.09),('14598','2013-05-06','12:35:00',5.13),('14598','2013-05-06','12:40:00',5.17),('14598','2013-05-06','12:45:00',5.19),('14598','2013-05-06','12:50:00',5.24),('14598','2013-05-06','12:55:00',5.24),('14598','2013-05-06','13:00:00',5.26),('14598','2013-05-06','13:05:00',5.24),('14598','2013-05-06','13:10:00',5.01),('14598','2013-05-06','13:15:00',5.28),('14598','2013-05-06','13:20:00',5.42),('14598','2013-05-06','13:25:00',5.2),('14598','2013-05-06','13:30:00',4.89),('14598','2013-05-06','13:35:00',4.29),('14598','2013-05-06','13:40:00',3.32),('14598','2013-05-06','13:45:00',2.81),('14598','2013-05-06','13:50:00',4.9),('14598','2013-05-06','13:55:00',3.96),('14598','2013-05-06','14:00:00',3.83),('14598','2013-05-06','14:05:00',5.73),('14598','2013-05-06','14:10:00',5.49),('14598','2013-05-06','14:15:00',4.53),('14598','2013-05-06','14:20:00',4.97),('14598','2013-05-06','14:25:00',5.31),('14598','2013-05-06','14:30:00',5.12),('14598','2013-05-06','14:35:00',5.4),('14598','2013-05-06','14:40:00',4.56),('14598','2013-05-06','14:45:00',4.7),('14598','2013-05-06','14:50:00',4.08),('14598','2013-05-06','14:55:00',3.56),('14598','2013-05-06','15:00:00',5.26),('14598','2013-05-06','15:05:00',5.06),('14598','2013-05-06','15:10:00',5.02),('14598','2013-05-06','15:15:00',4.8),('14598','2013-05-06','15:20:00',4.28),('14598','2013-05-06','15:25:00',3.57),('14598','2013-05-06','15:30:00',5.37),('14598','2013-05-06','15:35:00',3.38),('14598','2013-05-06','15:40:00',4.25),('14598','2013-05-06','15:45:00',4.67),('14598','2013-05-06','15:50:00',4.16),('14598','2013-05-06','15:55:00',4.38),('14598','2013-05-06','16:00:00',4.71),('14598','2013-05-06','16:05:00',4.36),('14598','2013-05-06','16:10:00',2.59),('14598','2013-05-06','16:15:00',3.08),('14598','2013-05-06','16:20:00',1.9),('14598','2013-05-06','16:25:00',2.55),('14598','2013-05-06','16:30:00',1.96),('14598','2013-05-06','16:35:00',2.57),('14598','2013-05-06','16:40:00',2.26),('14598','2013-05-06','16:45:00',1.78),('14598','2013-05-06','16:50:00',2.1),('14598','2013-05-06','16:55:00',3.33),('14598','2013-05-06','17:00:00',3.31),('14598','2013-05-06','17:05:00',3.4),('14598','2013-05-06','17:10:00',3.62),('14598','2013-05-06','17:15:00',2.75),('14598','2013-05-06','17:20:00',2.08),('14598','2013-05-06','17:25:00',4.02),('14598','2013-05-06','17:30:00',3.49),('14598','2013-05-06','17:35:00',3.52),('14598','2013-05-06','17:40:00',1.74),('14598','2013-05-06','17:45:00',1.76),('14598','2013-05-06','17:50:00',2.93),('14598','2013-05-06','17:55:00',2.48),('14598','2013-05-06','18:00:00',2.83),('14598','2013-05-06','18:05:00',2.76),('14598','2013-05-06','18:10:00',2.63),('14598','2013-05-06','18:15:00',1.08),('14598','2013-05-06','18:20:00',1.04),('14598','2013-05-06','18:25:00',1.65),('14598','2013-05-06','18:30:00',1.26),('14598','2013-05-05','07:55:00',1.19),('14598','2013-05-05','08:00:00',1.07),('14598','2013-05-05','08:07:00',1.52),('14598','2013-05-05','08:10:00',1.77),('14598','2013-05-05','08:15:00',1.7),('14598','2013-05-05','08:20:00',1.38),('14598','2013-05-05','08:25:00',1.26),('14598','2013-05-05','08:30:00',1.13),('14598','2013-05-05','08:50:00',1.15),('14598','2013-05-05','08:55:00',1.39),('14598','2013-05-05','09:00:00',1.57),('14598','2013-05-05','09:05:00',1.78),('14598','2013-05-05','09:10:00',1.42),('14598','2013-05-05','09:15:00',1.89),('14598','2013-05-05','09:20:00',1.46),('14598','2013-05-05','09:25:00',2.56),('14598','2013-05-05','09:30:00',2.95),('14598','2013-05-05','09:35:00',2.98),('14598','2013-05-05','09:40:00',3.36),('14598','2013-05-05','09:45:00',2.75),('14598','2013-05-05','09:50:00',3.58),('14598','2013-05-05','09:55:00',2.5),('14598','2013-05-05','10:00:00',2.1),('14598','2013-05-05','10:05:00',1.94),('14598','2013-05-05','10:10:00',1.32),('14598','2013-05-05','10:15:00',1.4),('14598','2013-05-05','10:20:00',1.75),('14598','2013-05-05','10:25:00',2.29),('14598','2013-05-05','10:30:00',3.12),('14598','2013-05-05','10:35:00',4.14),('14598','2013-05-05','10:40:00',4.01),('14598','2013-05-05','10:45:00',2.93),('14598','2013-05-05','10:50:00',3.95),('14598','2013-05-05','10:55:00',4.15),('14598','2013-05-05','11:00:00',3.6),('14598','2013-05-05','11:05:00',4.29),('14598','2013-05-05','11:10:00',4.77),('14598','2013-05-05','11:15:00',4.71),('14598','2013-05-05','11:20:00',4.65),('14598','2013-05-05','11:25:00',4.45),('14598','2013-05-05','11:30:00',4.74),('14598','2013-05-05','11:35:00',3.97),('14598','2013-05-05','11:40:00',3.97),('14598','2013-05-05','11:45:00',2.76),('14598','2013-05-05','11:50:00',3.19),('14598','2013-05-05','11:55:00',3.8),('14598','2013-05-05','12:00:00',2.17),('14598','2013-05-05','12:05:00',1.46),('14598','2013-05-05','12:10:00',1.18),('14598','2013-05-05','12:15:00',1.77),('14598','2013-05-05','12:20:00',2.07),('14598','2013-05-05','12:25:00',1.92),('14598','2013-05-05','12:30:00',1.64),('14598','2013-05-05','12:35:00',2.58),('14598','2013-05-05','12:40:00',4.85),('14598','2013-05-05','12:45:00',4.74),('14598','2013-05-05','12:50:00',3.69),('14598','2013-05-05','12:55:00',3.97),('14598','2013-05-05','13:00:00',4.8),('14598','2013-05-05','13:05:00',5.1),('14598','2013-05-05','13:10:00',4.89),('14598','2013-05-05','13:15:00',3.4),('14598','2013-05-05','13:20:00',2.8),('14598','2013-05-05','13:25:00',2.8),('14598','2013-05-05','13:30:00',5.24),('14598','2013-05-05','13:35:00',4.67),('14598','2013-05-05','13:40:00',4.76),('14598','2013-05-05','13:45:00',5.3),('14598','2013-05-05','13:50:00',5.21),('14598','2013-05-05','13:55:00',5.16),('14598','2013-05-05','14:00:00',5.13),('14598','2013-05-05','14:05:00',5.01),('14598','2013-05-05','14:10:00',5.08),('14598','2013-05-05','14:15:00',5.03),('14598','2013-05-05','14:20:00',5.03),('14598','2013-05-05','14:25:00',4.99),('14598','2013-05-05','14:30:00',4.96),('14598','2013-05-05','14:35:00',4.94),('14598','2013-05-05','14:40:00',4.92),('14598','2013-05-05','14:45:00',4.79),('14598','2013-05-05','14:50:00',4.88),('14598','2013-05-05','14:55:00',4.84),('14598','2013-05-05','15:00:00',4.76),('14598','2013-05-05','15:05:00',4.71),('14598','2013-05-05','15:10:00',4.69),('14598','2013-05-05','15:15:00',4.66),('14598','2013-05-05','15:20:00',4.61),('14598','2013-05-05','15:25:00',4.54),('14598','2013-05-05','15:30:00',4.51),('14598','2013-05-05','15:35:00',4.45),('14598','2013-05-05','15:40:00',4.41),('14598','2013-05-05','15:45:00',4.35),('14598','2013-05-05','15:50:00',4.28),('14598','2013-05-05','15:55:00',4.2),('14598','2013-05-05','16:00:00',4.16),('14598','2013-05-05','16:05:00',4.1),('14598','2013-05-05','16:10:00',4.05),('14598','2013-05-05','16:15:00',3.99),('14598','2013-05-05','16:20:00',3.92),('14598','2013-05-05','16:25:00',3.86),('14598','2013-05-05','16:30:00',3.78),('14598','2013-05-05','16:35:00',3.7),('14598','2013-05-05','16:40:00',3.65),('14598','2013-05-05','16:45:00',3.56),('14598','2013-05-05','16:50:00',3.5),('14598','2013-05-05','16:55:00',3.45),('14598','2013-05-05','17:00:00',3.37),('14598','2013-05-05','17:05:00',3.28),('14598','2013-05-05','17:10:00',3.16),('14598','2013-05-05','17:15:00',3.09),('14598','2013-05-05','17:20:00',2.99),('14598','2013-05-05','17:25:00',2.89),('14598','2013-05-05','17:30:00',2.8),('14598','2013-05-05','17:35:00',2.71),('14598','2013-05-05','17:40:00',2.49),('14598','2013-05-05','17:45:00',2.48),('14598','2013-05-05','17:50:00',2.39),('14598','2013-05-05','17:55:00',2.29),('14598','2013-05-05','18:00:00',2.2),('14598','2013-05-05','18:05:00',2.09),('14598','2013-05-05','18:11:00',2),('14598','2013-05-05','18:15:00',1.89),('14598','2013-05-05','18:20:00',1.77),('14598','2013-05-05','18:25:00',1.63),('14598','2013-05-05','18:30:00',1.54),('14598','2013-05-05','18:35:00',1.44),('14598','2013-05-05','18:41:00',1.34),('14598','2013-05-05','18:45:00',1.21),('14598','2013-05-05','18:50:00',1.12),('14598','2013-05-05','18:55:00',1.02),('14598','2013-05-04','08:05:00',1.07),('14598','2013-05-04','08:10:00',1.25),('14598','2013-05-04','08:15:00',1.33),('14598','2013-05-04','08:20:00',1.39),('14598','2013-05-04','08:25:00',1.43),('14598','2013-05-04','08:30:00',1.56),('14598','2013-05-04','08:35:00',1.79),('14598','2013-05-04','08:40:00',1.98),('14598','2013-05-04','08:45:00',2.15),('14598','2013-05-04','08:50:00',2.34),('14598','2013-05-04','08:55:00',2.43),('14598','2013-05-04','09:00:00',2.4),('14598','2013-05-04','09:05:00',2.48),('14598','2013-05-04','09:10:00',2.38),('14598','2013-05-04','09:15:00',2.38),('14598','2013-05-04','09:20:00',2.4),('14598','2013-05-04','09:25:00',2.48),('14598','2013-05-04','09:30:00',2.67),('14598','2013-05-04','09:35:00',2.81),('14598','2013-05-04','09:40:00',2.58),('14598','2013-05-04','09:45:00',2.54),('14598','2013-05-04','09:50:00',2.89),('14598','2013-05-04','09:55:00',2.38),('14598','2013-05-04','10:00:00',3.13),('14598','2013-05-04','10:05:00',3.18),('14598','2013-05-04','10:10:00',3.22),('14598','2013-05-04','10:15:00',3.12),('14598','2013-05-04','10:20:00',3.27),('14598','2013-05-04','10:25:00',3.43),('14598','2013-05-04','10:30:00',3.43),('14598','2013-05-04','10:35:00',3.55),('14598','2013-05-04','10:40:00',3.61),('14598','2013-05-04','10:45:00',3.67),('14598','2013-05-04','10:50:00',3.75),('14598','2013-05-04','10:55:00',3.85),('14598','2013-05-04','11:00:00',3.9),('14598','2013-05-04','11:05:00',3.75),('14598','2013-05-04','11:10:00',3.6),('14598','2013-05-04','11:15:00',3.97),('14598','2013-05-04','11:20:00',4.01),('14598','2013-05-04','11:25:00',3.82),('14598','2013-05-04','11:30:00',3.88),('14598','2013-05-04','11:35:00',4.08),('14598','2013-05-04','11:40:00',4.18),('14598','2013-05-04','11:45:00',4.13),('14598','2013-05-04','11:50:00',4.12),('14598','2013-05-04','11:55:00',4.15),('14598','2013-05-04','12:00:00',4.12),('14598','2013-05-04','12:05:00',4.12),('14598','2013-05-04','12:10:00',4.19),('14598','2013-05-04','12:15:00',4.35),('14598','2013-05-04','12:20:00',4.42),('14598','2013-05-04','12:25:00',4.58),('14598','2013-05-04','12:30:00',4.56),('14598','2013-05-04','12:35:00',4.67),('14598','2013-05-04','12:40:00',4.59),('14598','2013-05-04','12:45:00',4.49),('14598','2013-05-04','12:50:00',4.58),('14598','2013-05-04','12:55:00',4.57),('14598','2013-05-04','13:00:00',4.63),('14598','2013-05-04','13:05:00',4.79),('14598','2013-05-04','13:10:00',4.71),('14598','2013-05-04','13:15:00',4.68),('14598','2013-05-04','13:20:00',4.66),('14598','2013-05-04','13:25:00',4.76),('14598','2013-05-04','13:30:00',4.47),('14598','2013-05-04','13:35:00',4.3),('14598','2013-05-04','13:40:00',4.23),('14598','2013-05-04','13:45:00',4.22),('14598','2013-05-04','13:50:00',4.53),('14598','2013-05-04','13:55:00',4.66),('14598','2013-05-04','14:00:00',4.58),('14598','2013-05-04','14:05:00',4.11),('14598','2013-05-04','14:10:00',4.39),('14598','2013-05-04','14:15:00',4.35),('14598','2013-05-04','14:20:00',4.29),('14598','2013-05-04','14:25:00',4.3),('14598','2013-05-04','14:30:00',3.8),('14598','2013-05-04','14:35:00',3.97),('14598','2013-05-04','14:40:00',3.91),('14598','2013-05-04','14:45:00',4.07),('14598','2013-05-04','14:50:00',4.15),('14598','2013-05-04','14:55:00',3.94),('14598','2013-05-04','15:00:00',4.14),('14598','2013-05-04','15:05:00',4.24),('14598','2013-05-04','15:10:00',4.04),('14598','2013-05-04','15:15:00',4.31),('14598','2013-05-04','15:20:00',4.3),('14598','2013-05-04','15:25:00',4.14),('14598','2013-05-04','15:30:00',4.37),('14598','2013-05-04','15:35:00',4.28),('14598','2013-05-04','15:40:00',4.21),('14598','2013-05-04','15:45:00',4.12),('14598','2013-05-04','15:50:00',4.09),('14598','2013-05-04','15:55:00',4.04),('14598','2013-05-04','16:00:00',3.97),('14598','2013-05-04','16:05:00',3.92),('14598','2013-05-04','16:10:00',3.88),('14598','2013-05-04','16:15:00',3.79),('14598','2013-05-04','16:20:00',3.75),('14598','2013-05-04','16:25:00',3.68),('14598','2013-05-04','16:30:00',3.59),('14598','2013-05-04','16:35:00',3.5),('14598','2013-05-04','16:40:00',3.45),('14598','2013-05-04','16:45:00',3.37),('14598','2013-05-04','16:50:00',3.31),('14598','2013-05-04','16:55:00',3.24),('14598','2013-05-04','17:00:00',3.17),('14598','2013-05-04','17:05:00',3.11),('14598','2013-05-04','17:11:00',2.45),('14598','2013-05-04','17:15:00',2.51),('14598','2013-05-04','17:20:00',2.89),('14598','2013-05-04','17:25:00',2.75),('14598','2013-05-04','17:30:00',2.61),('14598','2013-05-04','17:35:00',2.51),('14598','2013-05-04','17:41:00',2.46),('14598','2013-05-04','17:45:00',2.34),('14598','2013-05-04','17:50:00',2.24),('14598','2013-05-04','17:55:00',2.11),('14598','2013-05-04','18:00:00',1.87),('14598','2013-05-04','18:05:00',1.92),('14598','2013-05-04','18:11:00',1.62),('14598','2013-05-04','18:15:00',1.7),('14598','2013-05-04','18:20:00',1.42),('14598','2013-05-03','08:05:00',1.01),('14598','2013-05-03','08:10:00',1.04),('14598','2013-05-03','08:20:00',1.06),('14598','2013-05-03','08:25:00',1.19),('14598','2013-05-03','08:30:00',1.37),('14598','2013-05-03','08:35:00',1.55),('14598','2013-05-03','08:40:00',1.65),('14598','2013-05-03','08:45:00',1.7),('14598','2013-05-03','08:50:00',1.7),('14598','2013-05-03','08:55:00',1.81),('14598','2013-05-03','09:00:00',2.06),('14598','2013-05-03','09:05:00',2.2),('14598','2013-05-03','09:10:00',2.28),('14598','2013-05-03','09:15:00',2.38),('14598','2013-05-03','09:20:00',2.5),('14598','2013-05-03','09:25:00',2.59),('14598','2013-05-03','09:30:00',2.65),('14598','2013-05-03','09:35:00',2.76),('14598','2013-05-03','09:40:00',2.85),('14598','2013-05-03','09:45:00',2.9),('14598','2013-05-03','09:50:00',2.99),('14598','2013-05-03','09:55:00',3.09),('14598','2013-05-03','10:00:00',3.16),('14598','2013-05-03','10:05:00',3.23),('14598','2013-05-03','10:10:00',3.3),('14598','2013-05-03','10:15:00',3.38),('14598','2013-05-03','10:20:00',3.44),('14598','2013-05-03','10:25:00',3.55),('14598','2013-05-03','10:30:00',2.71),('14598','2013-05-03','10:35:00',3.67),('14598','2013-05-03','10:40:00',3.74),('14598','2013-05-03','10:45:00',3.8),('14598','2013-05-03','10:50:00',3.86),('14598','2013-05-03','10:55:00',3.93),('14598','2013-05-03','11:00:00',3.96),('14598','2013-05-03','11:05:00',4),('14598','2013-05-03','11:10:00',4.06),('14598','2013-05-03','11:15:00',4.16),('14598','2013-05-03','11:20:00',4.21),('14598','2013-05-03','11:25:00',4.29),('14598','2013-05-03','11:30:00',4.34),('14598','2013-05-03','11:35:00',4.37),('14598','2013-05-03','11:40:00',4.39),('14598','2013-05-03','11:45:00',4.45),('14598','2013-05-03','11:50:00',4.48),('14598','2013-05-03','11:55:00',4.56),('14598','2013-05-03','12:00:00',4.62),('14598','2013-05-03','12:05:00',4.7),('14598','2013-05-03','12:10:00',4.74),('14598','2013-05-03','12:15:00',4.75),('14598','2013-05-03','12:20:00',4.75),('14598','2013-05-03','12:25:00',4.8),('14598','2013-05-03','12:30:00',4.82),('14598','2013-05-03','12:35:00',4.79),('14598','2013-05-03','12:40:00',4.87),('14598','2013-05-03','12:45:00',4.9),('14598','2013-05-03','12:50:00',4.92),('14598','2013-05-03','12:55:00',4.95),('14598','2013-05-03','13:00:00',4.95),('14598','2013-05-03','13:05:00',4.92),('14598','2013-05-03','13:10:00',4.89),('14598','2013-05-03','13:15:00',4.96),('14598','2013-05-03','13:20:00',5.01),('14598','2013-05-03','13:25:00',4.98),('14598','2013-05-03','13:30:00',4.88),('14598','2013-05-03','13:35:00',4.76),('14598','2013-05-03','13:40:00',4.83),('14598','2013-05-03','13:45:00',4.92),('14598','2013-05-03','13:50:00',4.95),('14598','2013-05-03','13:55:00',5),('14598','2013-05-03','14:00:00',4.99),('14598','2013-05-03','14:05:00',4.99),('14598','2013-05-03','14:10:00',4.93),('14598','2013-05-03','14:15:00',4.92),('14598','2013-05-03','14:20:00',4.88),('14598','2013-05-03','14:25:00',4.86),('14598','2013-05-03','14:30:00',4.82),('14598','2013-05-03','14:35:00',4.8),('14598','2013-05-03','14:40:00',4.77),('14598','2013-05-03','14:45:00',4.76),('14598','2013-05-03','14:50:00',4.7),('14598','2013-05-03','14:55:00',4.7),('14598','2013-05-03','15:00:00',4.65),('14598','2013-05-03','15:05:00',4.6),('14598','2013-05-03','15:10:00',4.59),('14598','2013-05-03','15:15:00',4.52),('14598','2013-05-03','15:20:00',4.47),('14598','2013-05-03','15:25:00',4.39),('14598','2013-05-03','15:30:00',4.35),('14598','2013-05-03','15:35:00',4.26),('14598','2013-05-03','15:40:00',4.26),('14598','2013-05-03','15:45:00',4.21),('14598','2013-05-03','15:50:00',4.18),('14598','2013-05-03','15:55:00',4.12),('14598','2013-05-03','16:00:00',4.11),('14598','2013-05-03','16:05:00',3.97),('14598','2013-05-03','16:10:00',3.76),('14598','2013-05-03','16:15:00',3.93),('14598','2013-05-03','16:20:00',3.86),('14598','2013-05-03','16:25:00',3.79),('14598','2013-05-03','16:30:00',3.72),('14598','2013-05-03','16:35:00',3.67),('14598','2013-05-03','16:40:00',3.59),('14598','2013-05-03','16:45:00',3.51),('14598','2013-05-03','16:50:00',3.43),('14598','2013-05-03','16:55:00',3.35),('14598','2013-05-03','17:00:00',3.23),('14598','2013-05-03','17:05:00',3.16),('14598','2013-05-03','17:10:00',3.08),('14598','2013-05-03','17:15:00',2.98),('14598','2013-05-03','17:20:00',2.87),('14598','2013-05-03','17:25:00',2.78),('14598','2013-05-03','17:30:00',2.65),('14598','2013-05-03','17:35:00',2.57),('14598','2013-05-03','17:40:00',2.49),('14598','2013-05-03','17:45:00',2.39),('14598','2013-05-03','17:50:00',2.29),('14598','2013-05-03','17:55:00',2.19),('14598','2013-05-03','18:00:00',2.07),('14598','2013-05-03','18:05:00',1.98),('14598','2013-05-03','18:10:00',1.88),('14598','2013-05-03','18:15:00',1.76),('14598','2013-05-03','18:20:00',1.66),('14598','2013-05-03','18:25:00',1.53),('14598','2013-05-03','18:30:00',1.38),('14598','2013-05-03','18:35:00',1.32),('14598','2013-05-03','18:40:00',1.22),('14598','2013-05-03','18:45:00',1.13),('14598','2013-05-03','18:50:00',1.03),('14598','2013-05-02','08:45:00',1.1),('14598','2013-05-02','08:50:00',1.06),('14598','2013-05-02','09:00:00',1.07),('14598','2013-05-02','09:05:00',1.92),('14598','2013-05-02','09:10:00',1.46),('14598','2013-05-02','09:15:00',1.13),('14598','2013-05-02','10:00:00',1.58),('14598','2013-05-02','10:05:00',1.95),('14598','2013-05-02','10:10:00',1.76),('14598','2013-05-02','10:15:00',2.22),('14598','2013-05-02','10:20:00',2.32),('14598','2013-05-02','10:25:00',3.01),('14598','2013-05-02','10:30:00',3.19),('14598','2013-05-02','10:35:00',4.1),('14598','2013-05-02','10:40:00',2.62),('14598','2013-05-02','10:45:00',1.87),('14598','2013-05-02','10:50:00',1.82),('14598','2013-05-02','10:55:00',1.98),('14598','2013-05-02','11:00:00',2.19),('14598','2013-05-02','11:05:00',2.92),('14598','2013-05-02','11:10:00',4.59),('14598','2013-05-02','11:15:00',3.07),('14598','2013-05-02','11:20:00',3.51),('14598','2013-05-02','11:25:00',4.7),('14598','2013-05-02','11:30:00',4.63),('14598','2013-05-02','11:35:00',4.39),('14598','2013-05-02','11:40:00',4.35),('14598','2013-05-02','11:45:00',4.38),('14598','2013-05-02','11:50:00',4.38),('14598','2013-05-02','11:55:00',4.37),('14598','2013-05-02','12:00:00',4.39),('14598','2013-05-02','12:05:00',4.42),('14598','2013-05-02','12:10:00',4.4),('14598','2013-05-02','12:15:00',4.43),('14598','2013-05-02','12:20:00',4.51),('14598','2013-05-02','12:25:00',4.66),('14598','2013-05-02','12:30:00',4.7),('14598','2013-05-02','12:35:00',4.76),('14598','2013-05-02','12:40:00',4.79),('14598','2013-05-02','12:45:00',4.84),('14598','2013-05-02','12:50:00',4.86),('14598','2013-05-02','12:55:00',4.87),('14598','2013-05-02','13:00:00',4.91),('14598','2013-05-02','13:05:00',4.96),('14598','2013-05-02','13:10:00',4.95),('14598','2013-05-02','13:15:00',4.94),('14598','2013-05-02','13:20:00',4.94),('14598','2013-05-02','13:25:00',4.91),('14598','2013-05-02','13:30:00',4.93),('14598','2013-05-02','13:35:00',4.92),('14598','2013-05-02','13:40:00',4.89),('14598','2013-05-02','13:45:00',4.87),('14598','2013-05-02','13:50:00',4.91),('14598','2013-05-02','13:55:00',4.92),('14598','2013-05-02','14:00:00',4.95),('14598','2013-05-02','14:05:00',4.94),('14598','2013-05-02','14:10:00',4.92),('14598','2013-05-02','14:15:00',4.89),('14598','2013-05-02','14:20:00',4.87),('14598','2013-05-02','14:25:00',4.82),('14598','2013-05-02','14:30:00',4.83),('14598','2013-05-02','14:35:00',4.83),('14598','2013-05-02','14:40:00',4.82),('14598','2013-05-02','14:45:00',4.79),('14598','2013-05-02','14:50:00',4.75),('14598','2013-05-02','14:55:00',4.7),('14598','2013-05-02','15:00:00',4.67),('14598','2013-05-02','15:05:00',4.64),('14598','2013-05-02','15:10:00',4.6),('14598','2013-05-02','15:15:00',4.55),('14598','2013-05-02','15:20:00',4.5),('14598','2013-05-02','15:25:00',4.41),('14598','2013-05-02','15:30:00',4.44),('14598','2013-05-02','15:35:00',4.39),('14598','2013-05-02','15:40:00',4.32),('14598','2013-05-02','15:45:00',4.27),('14598','2013-05-02','15:50:00',4.21),('14598','2013-05-02','15:55:00',4.18),('14598','2013-05-02','16:00:00',4.12),('14598','2013-05-02','16:05:00',4.06),('14598','2013-05-02','16:10:00',3.98),('14598','2013-05-02','16:15:00',3.91),('14598','2013-05-02','16:20:00',3.84),('14598','2013-05-02','16:25:00',3.79),('14598','2013-05-02','16:30:00',3.73),('14598','2013-05-02','16:35:00',3.66),('14598','2013-05-02','16:40:00',3.58),('14598','2013-05-02','16:45:00',3.49),('14598','2013-05-02','16:50:00',3.42),('14598','2013-05-02','16:55:00',3.35),('14598','2013-05-02','17:00:00',3.27),('14598','2013-05-02','17:05:00',3.18),('14598','2013-05-02','17:10:00',3.08),('14598','2013-05-02','17:15:00',3.01),('14598','2013-05-02','17:20:00',2.93),('14598','2013-05-02','17:25:00',2.83),('14598','2013-05-02','17:30:00',2.74),('14598','2013-05-02','17:35:00',2.64),('14598','2013-05-02','17:40:00',2.55),('14598','2013-05-02','17:45:00',2.45),('14598','2013-05-02','17:50:00',2.35),('14598','2013-05-02','17:55:00',2.26),('14598','2013-05-02','18:00:00',2.15),('14598','2013-05-02','18:05:00',2.04),('14598','2013-05-02','18:10:00',1.95),('14598','2013-05-02','18:15:00',1.85),('14598','2013-05-02','18:20:00',1.74),('14598','2013-05-02','18:25:00',1.62),('14598','2013-05-02','18:30:00',1.53),('14598','2013-05-02','18:35:00',1.43),('14598','2013-05-02','18:40:00',1.32),('14598','2013-05-02','18:45:00',1.21),('14598','2013-05-02','18:50:00',1.09),('14598','2014-03-30','08:40:00',1.07),('14598','2014-03-30','08:45:00',1.12),('14598','2014-03-30','08:50:00',1.23),('14598','2014-03-30','08:55:00',1.3),('14598','2014-03-30','09:00:00',1.43),('14598','2014-03-30','09:05:00',1.56),('14598','2014-03-30','09:10:00',1.67),('14598','2014-03-30','09:15:00',1.73),('14598','2014-03-30','09:20:00',1.76),('14598','2014-03-30','09:25:00',1.95),('14598','2014-03-30','09:30:00',2.2),('14598','2014-03-30','09:35:00',2.24),('14598','2014-03-30','09:40:00',2.28),('14598','2014-03-30','09:45:00',2.39),('14598','2014-03-30','09:50:00',2.4),('14598','2014-03-30','09:55:00',2.52),('14598','2014-03-30','10:00:00',2.52),('14598','2014-03-30','10:05:00',2.57),('14598','2014-03-30','10:10:00',2.69),('14598','2014-03-30','10:15:00',2.77),('14598','2014-03-30','10:20:00',2.76),('14598','2014-03-30','10:25:00',2.85),('14598','2014-03-30','10:30:00',3.03),('14598','2014-03-30','10:35:00',3.22),('14598','2014-03-30','10:40:00',3.34),('14598','2014-03-30','10:45:00',3.26),('14598','2014-03-30','10:50:00',3.36),('14598','2014-03-30','10:55:00',3.59),('14598','2014-03-30','11:00:00',3.83),('14598','2014-03-30','11:05:00',4.01),('14598','2014-03-30','11:10:00',4.04),('14598','2014-03-30','11:15:00',3.93),('14598','2014-03-30','11:20:00',3.81),('14598','2014-03-30','11:25:00',3.91),('14598','2014-03-30','11:30:00',3.84),('14598','2014-03-30','11:35:00',3.98),('14598','2014-03-30','11:40:00',4.07),('14598','2014-03-30','11:45:00',4.12),('14598','2014-03-30','11:50:00',4.17),('14598','2014-03-30','11:55:00',3.83),('14598','2014-03-30','12:00:00',3.88),('14598','2014-03-30','12:05:00',3.89),('14598','2014-03-30','12:10:00',3.95),('14598','2014-03-30','12:15:00',4.06),('14598','2014-03-30','12:20:00',4.35),('14598','2014-03-30','12:25:00',4.25),('14598','2014-03-30','12:30:00',4.24),('14598','2014-03-30','12:35:00',4.07),('14598','2014-03-30','12:40:00',4.35),('14598','2014-03-30','12:45:00',4.42),('14598','2014-03-30','12:50:00',4.42),('14598','2014-03-30','12:55:00',4.4),('14598','2014-03-30','13:00:00',4.37),('14598','2014-03-30','13:05:00',4.31),('14598','2014-03-30','13:10:00',4.54),('14598','2014-03-30','13:15:00',4.89),('14598','2014-03-30','13:20:00',5.08),('14598','2014-03-30','13:25:00',5.11),('14598','2014-03-30','13:30:00',5.13),('14598','2014-03-30','13:35:00',5.14),('14598','2014-03-30','13:40:00',5.13),('14598','2014-03-30','13:45:00',4.84),('14598','2014-03-30','13:50:00',4.5),('14598','2014-03-30','13:55:00',4.03),('14598','2014-03-30','14:00:00',4.33),('14598','2014-03-30','14:05:00',4.61),('14598','2014-03-30','14:10:00',3.9),('14598','2014-03-30','14:15:00',3.7),('14598','2014-03-30','14:20:00',4.18),('14598','2014-03-30','14:25:00',4.83),('14598','2014-03-30','14:30:00',4.91),('14598','2014-03-30','14:35:00',4.88),('14598','2014-03-30','14:40:00',4.73),('14598','2014-03-30','14:45:00',4.89),('14598','2014-03-30','14:50:00',4.75),('14598','2014-03-30','14:55:00',4.6),('14598','2014-03-30','15:00:00',4.85),('14598','2014-03-30','15:05:00',4.85),('14598','2014-03-30','15:10:00',4.98),('14598','2014-03-30','15:15:00',4.79),('14598','2014-03-30','15:20:00',4.7),('14598','2014-03-30','15:25:00',4.73),('14598','2014-03-30','15:30:00',4.57),('14598','2014-03-30','15:35:00',4.4),('14598','2014-03-30','15:40:00',4.4),('14598','2014-03-30','15:45:00',4.18),('14598','2014-03-30','15:50:00',4.04),('14598','2014-03-30','15:55:00',3.98),('14598','2014-03-30','16:00:00',4.14),('14598','2014-03-30','16:05:00',4.15),('14598','2014-03-30','16:10:00',3.91),('14598','2014-03-30','16:15:00',3.91),('14598','2014-03-30','16:20:00',3.74),('14598','2014-03-30','16:25:00',3.94),('14598','2014-03-30','16:30:00',3.79),('14598','2014-03-30','16:35:00',3.81),('14598','2014-03-30','16:40:00',3.74),('14598','2014-03-30','16:45:00',3.64),('14598','2014-03-30','16:50:00',3.56),('14598','2014-03-30','16:55:00',3.42),('14598','2014-03-30','17:00:00',3.31),('14598','2014-03-30','17:05:00',3.26),('14598','2014-03-30','17:10:00',3.14),('14598','2014-03-30','17:15:00',3.06),('14598','2014-03-30','17:20:00',2.66),('14598','2014-03-30','17:25:00',2.79),('14598','2014-03-30','17:30:00',2.7),('14598','2014-03-30','17:35:00',2.32),('14598','2014-03-30','17:40:00',2.45),('14598','2014-03-30','17:45:00',2.34),('14598','2014-03-30','17:50:00',2.21),('14598','2014-03-30','17:55:00',2.13),('14598','2014-03-30','18:00:00',1.9),('14598','2014-03-30','18:05:00',1.93),('14598','2014-03-30','18:10:00',1.71),('14598','2014-03-30','18:15:00',1.23),('14598','2013-05-01','08:10:00',1.04),('14598','2013-05-01','08:15:00',1.13),('14598','2013-05-01','08:20:00',1.2),('14598','2013-05-01','08:25:00',1.27),('14598','2013-05-01','08:30:00',1.38),('14598','2013-05-01','08:35:00',1.5),('14598','2013-05-01','08:40:00',1.6),('14598','2013-05-01','08:45:00',1.69),('14598','2013-05-01','08:50:00',1.75),('14598','2013-05-01','08:55:00',1.86),('14598','2013-05-01','09:00:00',1.95),('14598','2013-05-01','09:05:00',2.04),('14598','2013-05-01','09:10:00',2.15),('14598','2013-05-01','09:15:00',2.24),('14598','2013-05-01','09:20:00',2.29),('14598','2013-05-01','09:25:00',2.37),('14598','2013-05-01','09:30:00',2.45),('14598','2013-05-01','09:35:00',2.55),('14598','2013-05-01','09:40:00',2.64),('14598','2013-05-01','09:45:00',2.75),('14598','2013-05-01','09:50:00',2.82),('14598','2013-05-01','09:55:00',2.88),('14598','2013-05-01','10:00:00',2.95),('14598','2013-05-01','10:05:00',3.1),('14598','2013-05-01','10:10:00',3.21),('14598','2013-05-01','10:15:00',3.26),('14598','2013-05-01','10:20:00',3.31),('14598','2013-05-01','10:25:00',3.4),('14598','2013-05-01','10:30:00',3.47),('14598','2013-05-01','10:35:00',3.53),('14598','2013-05-01','10:40:00',3.59),('14598','2013-05-01','10:45:00',3.66),('14598','2013-05-01','10:50:00',3.72),('14598','2013-05-01','10:55:00',3.83),('14598','2013-05-01','11:00:00',3.88),('14598','2013-05-01','11:05:00',3.91),('14598','2013-05-01','11:10:00',3.69),('14598','2013-05-01','11:15:00',3.15),('14598','2013-05-01','11:20:00',3.25),('14598','2013-05-01','11:25:00',4.21),('14598','2013-05-01','11:30:00',4.31),('14598','2013-05-01','11:35:00',4.29),('14598','2013-05-01','11:40:00',4.31),('14598','2013-05-01','11:45:00',4.29),('14598','2013-05-01','11:50:00',4.24),('14598','2013-05-01','11:55:00',4.29),('14598','2013-05-01','12:00:00',4.33),('14598','2013-05-01','12:05:00',4.41),('14598','2013-05-01','12:10:00',4.53),('14598','2013-05-01','12:15:00',3.83),('14598','2013-05-01','12:20:00',3.57),('14598','2013-05-01','12:25:00',3.41),('14598','2013-05-01','12:30:00',3.39),('14598','2013-05-01','12:35:00',2.51),('14598','2013-05-01','12:40:00',2.72),('14598','2013-05-01','12:45:00',2.29),('14598','2013-05-01','12:50:00',4.34),('14598','2013-05-01','12:55:00',4.81),('14598','2013-05-01','13:00:00',4.75),('14598','2013-05-01','13:05:00',4.35),('14598','2013-05-01','13:10:00',4.6),('14598','2013-05-01','13:15:00',4.72),('14598','2013-05-01','13:20:00',4.77),('14598','2013-05-01','13:25:00',4.8),('14598','2013-05-01','13:30:00',4.85),('14598','2013-05-01','13:35:00',4.48),('14598','2013-05-01','13:40:00',4.64),('14598','2013-05-01','13:45:00',4.65),('14598','2013-05-01','13:50:00',4.17),('14598','2013-05-01','13:55:00',4.71),('14598','2013-05-01','14:00:00',4.71),('14598','2013-05-01','14:05:00',4.44),('14598','2013-05-01','14:10:00',3.71),('14598','2013-05-01','14:15:00',4.62),('14598','2013-05-01','14:20:00',4.09),('14598','2013-05-01','14:25:00',3.97),('14598','2013-05-01','14:30:00',4.43),('14598','2013-05-01','14:35:00',3.91),('14598','2013-05-01','14:40:00',3.92),('14598','2013-05-01','14:45:00',2.28),('14598','2013-05-01','14:50:00',2.37),('14598','2013-05-01','14:55:00',2.41),('14598','2013-05-01','15:00:00',3.51),('14598','2013-05-01','15:05:00',3.21),('14598','2013-05-01','15:10:00',3.87),('14598','2013-05-01','15:15:00',3.33),('14598','2013-05-01','15:20:00',3.07),('14598','2013-05-01','15:25:00',3.1),('14598','2013-05-01','15:30:00',2.95),('14598','2013-05-01','15:35:00',2.62),('14598','2013-05-01','15:40:00',2.33),('14598','2013-05-01','15:45:00',2.32),('14598','2013-05-01','15:50:00',2.55),('14598','2013-05-01','15:55:00',3.1),('14598','2013-05-01','16:00:00',2.48),('14598','2013-05-01','16:05:00',2.54),('14598','2013-05-01','16:10:00',2.49),('14598','2013-05-01','16:15:00',1.95),('14598','2013-05-01','16:20:00',1.42),('14598','2013-05-01','16:25:00',1.25),('14598','2013-05-01','16:30:00',1.24),('14598','2013-05-01','16:35:00',1.21),('14598','2013-05-01','16:40:00',1.16),('14598','2013-05-01','16:45:00',1.08),('14598','2013-05-01','16:50:00',1.02),('14598','2013-05-01','16:55:00',1),('14598','2013-04-30','08:25:00',1.24),('14598','2013-04-30','08:30:00',1.7),('14598','2013-04-30','08:35:00',1.45),('14598','2013-04-30','08:40:00',1.26),('14598','2013-04-30','08:45:00',1.23),('14598','2013-04-30','08:50:00',1.47),('14598','2013-04-30','08:55:00',1.37),('14598','2013-04-30','09:00:00',1.61),('14598','2013-04-30','09:05:00',1.63),('14598','2013-04-30','09:10:00',1.72),('14598','2013-04-30','09:15:00',2.53),('14598','2013-04-30','09:20:00',2.44),('14598','2013-04-30','09:25:00',2.41),('14598','2013-04-30','09:30:00',2.95),('14598','2013-04-30','09:35:00',3.18),('14598','2013-04-30','09:40:00',2.8),('14598','2013-04-30','09:45:00',3.37),('14598','2013-04-30','09:50:00',2.47),('14598','2013-04-30','09:55:00',2.17),('14598','2013-04-30','10:00:00',1.93),('14598','2013-04-30','10:05:00',3.2),('14598','2013-04-30','10:10:00',2.11),('14598','2013-04-30','10:15:00',2.58),('14598','2013-04-30','10:20:00',2.71),('14598','2013-04-30','10:25:00',2.96),('14598','2013-04-30','10:30:00',4.16),('14598','2013-04-30','10:35:00',3.76),('14598','2013-04-30','10:40:00',2.38),('14598','2013-04-30','10:45:00',1.98),('14598','2013-04-30','10:50:00',1.64),('14598','2013-04-30','10:55:00',1.54),('14598','2013-04-30','11:00:00',1.69),('14598','2013-04-30','11:05:00',2.05),('14598','2013-04-30','11:10:00',1.73),('14598','2013-04-30','11:15:00',1.55),('14598','2013-04-30','11:20:00',1.48),('14598','2013-04-30','11:25:00',1.5),('14598','2013-04-30','11:30:00',1.63),('14598','2013-04-30','11:35:00',1.69),('14598','2013-04-30','11:40:00',1.9),('14598','2013-04-30','11:45:00',2.43),('14598','2013-04-30','11:50:00',3.95),('14598','2013-04-30','11:55:00',4.58),('14598','2013-04-30','12:00:00',2.95),('14598','2013-04-30','12:05:00',3.08),('14598','2013-04-30','12:10:00',1.91),('14598','2013-04-30','12:15:00',2.2),('14598','2013-04-30','12:20:00',2.89),('14598','2013-04-30','12:25:00',4.11),('14598','2013-04-30','12:30:00',4.09),('14598','2013-04-30','12:35:00',3.93),('14598','2013-04-30','12:40:00',3.99),('14598','2013-04-30','12:45:00',4.28),('14598','2013-04-30','12:50:00',4.06),('14598','2013-04-30','12:55:00',4.78),('14598','2013-04-30','13:00:00',4.64),('14598','2013-04-30','13:05:00',4.63),('14598','2013-04-30','13:10:00',4.61),('14598','2013-04-30','13:15:00',4.59),('14598','2013-04-30','13:20:00',4.59),('14598','2013-04-30','13:25:00',4.59),('14598','2013-04-30','13:30:00',4.57),('14598','2013-04-30','13:35:00',4.56),('14598','2013-04-30','13:40:00',4.57),('14598','2013-04-30','13:45:00',4.53),('14598','2013-04-30','13:50:00',4.49),('14598','2013-04-30','13:55:00',4.46),('14598','2013-04-30','14:00:00',4.42),('14598','2013-04-30','14:05:00',4.42),('14598','2013-04-30','14:10:00',4.53),('14598','2013-04-30','14:15:00',4.58),('14598','2013-04-30','14:20:00',4.57),('14598','2013-04-30','14:25:00',4.56),('14598','2013-04-30','14:30:00',4.54),('14598','2013-04-30','14:35:00',4.48),('14598','2013-04-30','14:40:00',4.47),('14598','2013-04-30','14:45:00',4.46),('14598','2013-04-30','14:50:00',4.41),('14598','2013-04-30','14:55:00',4.37),('14598','2013-04-30','15:00:00',4.37),('14598','2013-04-30','15:05:00',4.32),('14598','2013-04-30','15:10:00',4.29),('14598','2013-04-30','15:15:00',4.24),('14598','2013-04-30','15:20:00',4.17),('14598','2013-04-30','15:25:00',4.17),('14598','2013-04-30','15:30:00',4.12),('14598','2013-04-30','15:35:00',4.08),('14598','2013-04-30','15:40:00',4.02),('14598','2013-04-30','15:45:00',3.95),('14598','2013-04-30','15:50:00',3.92),('14598','2013-04-30','15:55:00',3.73),('14598','2013-04-30','16:00:00',3.02),('14598','2013-04-30','16:05:00',3.54),('14598','2013-04-30','16:10:00',3.24),('14598','2013-04-30','16:15:00',3.24),('14598','2013-04-30','16:20:00',2.68),('14598','2013-04-30','16:25:00',2.03),('14598','2013-04-30','16:30:00',2.31),('14598','2013-04-30','16:35:00',2.39),('14598','2013-04-30','16:40:00',2.15),('14598','2013-04-30','16:45:00',1.97),('14598','2013-04-30','16:50:00',2.02),('14598','2013-04-30','16:55:00',2.19),('14598','2013-04-30','17:00:00',1.65),('14598','2013-04-30','17:05:00',1.4),('14598','2013-04-30','17:10:00',2.2),('14598','2013-04-30','17:15:00',2.57),('14598','2013-04-30','17:20:00',2.56),('14598','2013-04-30','17:25:00',2.4),('14598','2013-04-30','17:30:00',2.28),('14598','2013-04-30','17:35:00',2.16),('14598','2013-04-30','17:40:00',2.02),('14598','2013-04-30','17:45:00',1.94),('14598','2013-04-30','17:50:00',1.84),('14598','2013-04-30','17:55:00',1.74),('14598','2013-04-30','18:00:00',1.59),('14598','2013-04-30','18:05:00',1.43),('14598','2013-04-30','18:10:00',1.4),('14598','2013-04-30','18:15:00',1.41),('14598','2013-04-30','18:20:00',1.3),('14598','2013-04-30','18:25:00',1.2),('14598','2013-04-30','18:30:00',1.09),('14598','2013-04-29','07:55:00',1.01),('14598','2013-04-29','08:00:00',1.06),('14598','2013-04-29','08:05:00',1.2),('14598','2013-04-29','08:10:00',1.31),('14598','2013-04-29','08:15:00',1.28),('14598','2013-04-29','08:20:00',1.36),('14598','2013-04-29','08:25:00',1.28),('14598','2013-04-29','08:30:00',1.21),('14598','2013-04-29','08:35:00',1.15),('14598','2013-04-29','08:40:00',1.17),('14598','2013-04-29','08:45:00',1.58),('14598','2013-04-29','08:50:00',1.64),('14598','2013-04-29','08:55:00',1.37),('14598','2013-04-29','09:00:00',1.56),('14598','2013-04-29','09:05:00',1.79),('14598','2013-04-29','09:10:00',2.1),('14598','2013-04-29','09:15:00',2.22),('14598','2013-04-29','09:20:00',2.43),('14598','2013-04-29','09:25:00',2.56),('14598','2013-04-29','09:30:00',2.55),('14598','2013-04-29','09:35:00',2.5),('14598','2013-04-29','09:40:00',2.6),('14598','2013-04-29','09:45:00',2.51),('14598','2013-04-29','09:50:00',2.47),('14598','2013-04-29','09:55:00',2.52),('14598','2013-04-29','10:00:00',2.56),('14598','2013-04-29','10:05:00',3.12),('14598','2013-04-29','10:10:00',2.88),('14598','2013-04-29','10:15:00',2.66),('14598','2013-04-29','10:20:00',3.25),('14598','2013-04-29','10:25:00',3.12),('14598','2013-04-29','10:30:00',3.49),('14598','2013-04-29','10:35:00',3.37),('14598','2013-04-29','10:40:00',3.4),('14598','2013-04-29','10:45:00',3.15),('14598','2013-04-29','10:50:00',3.11),('14598','2013-04-29','10:55:00',3.06),('14598','2013-04-29','11:00:00',3.13),('14598','2013-04-29','11:05:00',3.37),('14598','2013-04-29','11:10:00',3.65),('14598','2013-04-29','11:15:00',3.89),('14598','2013-04-29','11:20:00',3.75),('14598','2013-04-29','11:25:00',3.69),('14598','2013-04-29','11:30:00',3.76),('14598','2013-04-29','11:35:00',4),('14598','2013-04-29','11:40:00',4.05),('14598','2013-04-29','11:45:00',4.14),('14598','2013-04-29','11:50:00',3.9),('14598','2013-04-29','11:55:00',3.89),('14598','2013-04-29','12:00:00',4.23),('14598','2013-04-29','12:05:00',4.33),('14598','2013-04-29','12:10:00',4.31),('14598','2013-04-29','12:15:00',4.43),('14598','2013-04-29','12:20:00',4.51),('14598','2013-04-29','12:25:00',4.48),('14598','2013-04-29','12:30:00',4.41),('14598','2013-04-29','12:35:00',4.42),('14598','2013-04-29','12:40:00',4.41),('14598','2013-04-29','12:45:00',4.22),('14598','2013-04-29','12:50:00',4.37),('14598','2013-04-29','12:55:00',4.22),('14598','2013-04-29','13:00:00',4.52),('14598','2013-04-29','13:05:00',4.65),('14598','2013-04-29','13:10:00',4.59),('14598','2013-04-29','13:15:00',4.4),('14598','2013-04-29','13:20:00',4.27),('14598','2013-04-29','13:25:00',4.31),('14598','2013-04-29','13:30:00',4.43),('14598','2013-04-29','13:35:00',4.4),('14598','2013-04-29','13:40:00',4.45),('14598','2013-04-29','13:45:00',4.58),('14598','2013-04-29','13:50:00',4.46),('14598','2013-04-29','13:55:00',4.47),('14598','2013-04-29','14:00:00',4.58),('14598','2013-04-29','14:05:00',4.71),('14598','2013-04-29','14:10:00',4.78),('14598','2013-04-29','14:15:00',4.7),('14598','2013-04-29','14:20:00',4.05),('14598','2013-04-29','14:25:00',4.57),('14598','2013-04-29','14:30:00',4.26),('14598','2013-04-29','14:35:00',4.2),('14598','2013-04-29','14:40:00',4.17),('14598','2013-04-29','14:45:00',4.29),('14598','2013-04-29','14:50:00',4.43),('14598','2013-04-29','14:55:00',4.24),('14598','2013-04-29','15:00:00',4.35),('14598','2013-04-29','15:05:00',4.14),('14598','2013-04-29','15:10:00',3.96),('14598','2013-04-29','15:15:00',3.7),('14598','2013-04-29','15:20:00',3.31),('14598','2013-04-29','15:25:00',3.1),('14598','2013-04-29','15:30:00',3.38),('14598','2013-04-29','15:35:00',3.2),('14598','2013-04-29','15:40:00',3.51),('14598','2013-04-29','15:45:00',3.88),('14598','2013-04-29','15:50:00',4.17),('14598','2013-04-29','15:55:00',3.88),('14598','2013-04-29','16:00:00',3.58),('14598','2013-04-29','16:05:00',3.48),('14598','2013-04-29','16:10:00',3.62),('14598','2013-04-29','16:15:00',3.72),('14598','2013-04-29','16:20:00',3.96),('14598','2013-04-29','16:25:00',3.95),('14598','2013-04-29','16:30:00',3.81),('14598','2013-04-29','16:35:00',3.74),('14598','2013-04-29','16:40:00',3.83),('14598','2013-04-29','16:45:00',3.44),('14598','2013-04-29','16:50:00',3.3),('14598','2013-04-29','16:55:00',3.28),('14598','2013-04-29','17:00:00',3.04),('14598','2013-04-29','17:05:00',2.58),('14598','2013-04-29','17:10:00',3),('14598','2013-04-29','17:15:00',3.28),('14598','2013-04-29','17:20:00',3.34),('14598','2013-04-29','17:25:00',3.16),('14598','2013-04-29','17:30:00',2.82),('14598','2013-04-29','17:35:00',2.66),('14598','2013-04-29','17:40:00',2.74),('14598','2013-04-29','17:45:00',3.06),('14598','2013-04-29','17:50:00',2.79),('14598','2013-04-29','17:55:00',2.66),('14598','2013-04-29','18:00:00',2.56),('14598','2013-04-29','18:05:00',2.44),('14598','2013-04-29','18:10:00',2.23),('14598','2013-04-29','18:15:00',1.97),('14598','2013-04-29','18:20:00',1.78),('14598','2013-04-29','18:25:00',1.53),('14598','2013-04-29','18:30:00',1.44),('14598','2013-04-29','18:35:00',1),('14598','2013-04-29','18:40:00',1),('14598','2013-04-28','08:10:00',1.09),('14598','2013-04-28','08:15:00',1.19),('14598','2013-04-28','08:20:00',1.26),('14598','2013-04-28','08:25:00',1.35),('14598','2013-04-28','08:30:00',1.39),('14598','2013-04-28','08:35:00',1.53),('14598','2013-04-28','08:40:00',1.63),('14598','2013-04-28','08:45:00',1.76),('14598','2013-04-28','08:50:00',1.88),('14598','2013-04-28','08:55:00',1.99),('14598','2013-04-28','09:00:00',2.11),('14598','2013-04-28','09:05:00',2.23),('14598','2013-04-28','09:10:00',2.34),('14598','2013-04-28','09:15:00',2.44),('14598','2013-04-28','09:20:00',2.53),('14598','2013-04-28','09:25:00',2.63),('14598','2013-04-28','09:30:00',2.71),('14598','2013-04-28','09:35:00',2.79),('14598','2013-04-28','09:40:00',2.88),('14598','2013-04-28','09:45:00',2.98),('14598','2013-04-28','09:50:00',3.06),('14598','2013-04-28','09:55:00',3.13),('14598','2013-04-28','10:00:00',3.2),('14598','2013-04-28','10:05:00',3.23),('14598','2013-04-28','10:10:00',3.33),('14598','2013-04-28','10:15:00',3.43),('14598','2013-04-28','10:20:00',3.51),('14598','2013-04-28','10:25:00',3.57),('14598','2013-04-28','10:30:00',3.66),('14598','2013-04-28','10:35:00',3.69),('14598','2013-04-28','10:40:00',3.69),('14598','2013-04-28','10:45:00',3.78),('14598','2013-04-28','10:50:00',3.88),('14598','2013-04-28','10:55:00',3.96),('14598','2013-04-28','11:00:00',3.91),('14598','2013-04-28','11:05:00',3.93),('14598','2013-04-28','11:10:00',3.95),('14598','2013-04-28','11:15:00',3.98),('14598','2013-04-28','11:20:00',4.02),('14598','2013-04-28','11:25:00',4.27),('14598','2013-04-28','11:30:00',4.18),('14598','2013-04-28','11:35:00',4.06),('14598','2013-04-28','11:40:00',4.07),('14598','2013-04-28','11:45:00',3.81),('14598','2013-04-28','11:50:00',3.82),('14598','2013-04-28','11:55:00',4.08),('14598','2013-04-28','12:00:00',3.85),('14598','2013-04-28','12:05:00',4.06),('14598','2013-04-28','12:10:00',4.31),('14598','2013-04-28','12:15:00',4.2),('14598','2013-04-28','12:20:00',4.34),('14598','2013-04-28','12:25:00',3.81),('14598','2013-04-28','12:30:00',3.82),('14598','2013-04-28','12:35:00',4.12),('14598','2013-04-28','12:40:00',4.63),('14598','2013-04-28','12:45:00',4.63),('14598','2013-04-28','12:50:00',4.63),('14598','2013-04-28','12:55:00',4.89),('14598','2013-04-28','13:00:00',4.73),('14598','2013-04-28','13:05:00',4.69),('14598','2013-04-28','13:10:00',4.66),('14598','2013-04-28','13:15:00',4.78),('14598','2013-04-28','13:20:00',4.51),('14598','2013-04-28','13:25:00',4.55),('14598','2013-04-28','13:30:00',5.12),('14598','2013-04-28','13:35:00',5),('14598','2013-04-28','13:40:00',4.87),('14598','2013-04-28','13:45:00',4.88),('14598','2013-04-28','13:50:00',4.92),('14598','2013-04-28','13:55:00',4.92),('14598','2013-04-28','14:00:00',4.61),('14598','2013-04-28','14:05:00',4.82),('14598','2013-04-28','14:10:00',4.91),('14598','2013-04-28','14:15:00',4.86),('14598','2013-04-28','14:20:00',4.82),('14598','2013-04-28','14:25:00',4.78),('14598','2013-04-28','14:30:00',4.74),('14598','2013-04-28','14:35:00',4.71),('14598','2013-04-28','14:40:00',4.68),('14598','2013-04-28','14:45:00',4.65),('14598','2013-04-28','14:50:00',4.6),('14598','2013-04-28','14:55:00',4.57),('14598','2013-04-28','15:00:00',4.57),('14598','2013-04-28','15:05:00',4.57),('14598','2013-04-28','15:10:00',4.54),('14598','2013-04-28','15:15:00',4.49),('14598','2013-04-28','15:20:00',4.45),('14598','2013-04-28','15:25:00',4.4),('14598','2013-04-28','15:30:00',4.34),('14598','2013-04-28','15:35:00',4.3),('14598','2013-04-28','15:40:00',4.24),('14598','2013-04-28','15:45:00',4.19),('14598','2013-04-28','15:50:00',4.13),('14598','2013-04-28','15:55:00',4.07),('14598','2013-04-28','16:00:00',4.04),('14598','2013-04-28','16:05:00',3.98),('14598','2013-04-28','16:10:00',3.88),('14598','2013-04-28','16:15:00',3.82),('14598','2013-04-28','16:20:00',3.75),('14598','2013-04-28','16:25:00',3.67),('14598','2013-04-28','16:30:00',3.6),('14598','2013-04-28','16:35:00',3.55),('14598','2013-04-28','16:40:00',3.51),('14598','2013-04-28','16:45:00',3.46),('14598','2013-04-28','16:50:00',3.38),('14598','2013-04-28','16:55:00',3.15),('14598','2013-04-28','17:00:00',3.01),('14598','2013-04-28','17:05:00',3.02),('14598','2013-04-28','17:10:00',3.06),('14598','2013-04-28','17:15:00',2.99),('14598','2013-04-28','17:20:00',2.82),('14598','2013-04-28','17:25:00',2.41),('14598','2013-04-28','17:30:00',2.55),('14598','2013-04-28','17:35:00',2.54),('14598','2013-04-28','17:40:00',2.48),('14598','2013-04-28','17:45:00',2.29),('14598','2013-04-28','17:50:00',2.08),('14598','2013-04-28','17:55:00',2.12),('14598','2013-04-28','18:00:00',1.8),('14598','2013-04-28','18:05:00',1.5),('14598','2013-04-28','18:10:00',1.93),('14598','2013-04-28','18:15:00',1.81),('14598','2013-04-28','18:20:00',1.35),('14598','2013-04-28','18:25:00',1.24),('14598','2013-04-28','18:30:00',1.35),('14598','2013-04-28','18:35:00',1.14),('14598','2013-04-28','18:45:00',1.01),('14598','2013-04-27','12:15:00',1.07),('14598','2013-04-27','12:20:00',1.23),('14598','2013-04-27','12:25:00',1.48),('14598','2013-04-27','12:30:00',1.71),('14598','2013-04-27','12:35:00',2.03),('14598','2013-04-27','12:40:00',2.05),('14598','2013-04-27','12:45:00',2.02),('14598','2013-04-27','12:50:00',2.97),('14598','2013-04-27','13:25:00',1.16),('14598','2013-04-27','13:30:00',1.74),('14598','2013-04-27','13:35:00',1.88),('14598','2013-04-27','14:10:00',1.74),('14598','2013-04-27','14:15:00',1.59),('14598','2013-04-27','14:20:00',1.37),('14598','2013-04-27','16:15:00',1.7),('14598','2013-04-27','16:20:00',2.12),('14598','2013-04-27','16:25:00',2.77),('14598','2013-04-27','16:30:00',2.47),('14598','2013-04-27','16:40:00',1.39),('14598','2013-04-27','16:45:00',2.1),('14598','2013-04-27','16:50:00',2.32),('14598','2013-04-27','16:55:00',1.97),('14598','2013-04-27','17:00:00',1.67),('14598','2013-04-27','17:05:00',1.5),('14598','2013-04-27','17:10:00',1.43),('14598','2013-04-27','17:20:00',1.29),('14598','2013-04-27','17:25:00',2.29),('14598','2013-04-27','17:30:00',2.1),('14598','2013-04-27','17:35:00',1.26),('14598','2013-04-26','08:10:00',1.07),('14598','2013-04-26','08:15:00',1.17),('14598','2013-04-26','08:20:00',1.26),('14598','2013-04-26','08:25:00',1.37),('14598','2013-04-26','08:30:00',1.46),('14598','2013-04-26','08:35:00',1.46),('14598','2013-04-26','08:40:00',1.53),('14598','2013-04-26','08:45:00',1.45),('14598','2013-04-26','08:50:00',1.06),('14598','2013-04-26','08:55:00',1.15),('14598','2013-04-26','09:05:00',1.67),('14598','2013-04-26','09:10:00',1.83),('14598','2013-04-26','09:15:00',2.11),('14598','2013-04-26','09:20:00',2.34),('14598','2013-04-26','09:25:00',2.44),('14598','2013-04-26','09:30:00',2.54),('14598','2013-04-26','09:35:00',2.72),('14598','2013-04-26','09:40:00',3.13),('14598','2013-04-26','09:45:00',3.6),('14598','2013-04-26','09:50:00',3.69),('14598','2013-04-26','09:55:00',3.56),('14598','2013-04-26','10:00:00',2.67),('14598','2013-04-26','10:05:00',2.29),('14598','2013-04-26','10:10:00',2.68),('14598','2013-04-26','10:15:00',3.57),('14598','2013-04-26','10:20:00',3.04),('14598','2013-04-26','10:25:00',2.48),('14598','2013-04-26','10:30:00',2.4),('14598','2013-04-26','10:35:00',2.43),('14598','2013-04-26','10:40:00',2.42),('14598','2013-04-26','10:45:00',2.5),('14598','2013-04-26','10:50:00',2.48),('14598','2013-04-26','10:55:00',2.63),('14598','2013-04-26','11:00:00',2.59),('14598','2013-04-26','11:05:00',2.44),('14598','2013-04-26','11:10:00',2.49),('14598','2013-04-26','11:15:00',2.53),('14598','2013-04-26','11:20:00',2.46),('14598','2013-04-26','11:25:00',2.53),('14598','2013-04-26','11:30:00',2.95),('14598','2013-04-26','11:35:00',2.87),('14598','2013-04-26','11:40:00',2.88),('14598','2013-04-26','11:45:00',2.72),('14598','2013-04-26','11:50:00',1.91),('14598','2013-04-26','11:55:00',1.92),('14598','2013-04-26','12:00:00',2.37),('14598','2013-04-26','12:05:00',3.23),('14598','2013-04-26','12:10:00',3.63),('14598','2013-04-26','12:15:00',3.36),('14598','2013-04-26','12:20:00',2.9),('14598','2013-04-26','12:25:00',3.24),('14598','2013-04-26','12:30:00',3.13),('14598','2013-04-26','12:35:00',2.6),('14598','2013-04-26','12:40:00',2.4),('14598','2013-04-26','12:45:00',2.61),('14598','2013-04-26','12:50:00',2.58),('14598','2013-04-26','12:55:00',2.93),('14598','2013-04-26','13:00:00',2.78),('14598','2013-04-26','13:05:00',2.4),('14598','2013-04-26','13:10:00',2.64),('14598','2013-04-26','13:15:00',2.94),('14598','2013-04-26','13:20:00',2.23),('14598','2013-04-26','13:25:00',2.89),('14598','2013-04-26','13:30:00',3.72),('14598','2013-04-26','13:35:00',4.98),('14598','2013-04-26','13:40:00',4.68),('14598','2013-04-26','13:45:00',3.91),('14598','2013-04-26','13:50:00',3.68),('14598','2013-04-26','13:55:00',4.42),('14598','2013-04-26','14:00:00',4.24),('14598','2013-04-26','14:05:00',3.43),('14598','2013-04-26','14:10:00',4.63),('14598','2013-04-26','14:15:00',5.78),('14598','2013-04-26','14:20:00',5.64),('14598','2013-04-26','14:25:00',5.31),('14598','2013-04-26','14:30:00',4.41),('14598','2013-04-26','14:35:00',2.81),('14598','2013-04-26','14:40:00',1.78),('14598','2013-04-26','14:45:00',1.8),('14598','2013-04-26','14:50:00',1.29),('14598','2013-04-26','14:55:00',1.1),('14598','2013-04-26','15:00:00',1.12),('14598','2013-04-26','15:05:00',1.92),('14598','2013-04-26','15:10:00',2.41),('14598','2013-04-26','15:15:00',1.83),('14598','2013-04-26','15:20:00',1.53),('14598','2013-04-26','15:25:00',1.83),('14598','2013-04-26','15:30:00',1.14),('14598','2013-04-26','15:35:00',1.14),('14598','2013-04-26','15:40:00',1.13),('14598','2013-04-25','08:20:00',1.14),('14598','2013-04-25','08:25:00',1.41),('14598','2013-04-25','08:30:00',1.38),('14598','2013-04-25','08:35:00',1.33),('14598','2013-04-25','08:40:00',1.56),('14598','2013-04-25','08:45:00',1.22),('14598','2013-04-25','08:50:00',1.3),('14598','2013-04-25','08:55:00',1.17),('14598','2013-04-25','09:00:00',1.09),('14598','2013-04-25','09:05:00',1.21),('14598','2013-04-25','09:10:00',1.63),('14598','2013-04-25','09:15:00',2.14),('14598','2013-04-25','09:20:00',2.42),('14598','2013-04-25','09:25:00',2.72),('14598','2013-04-25','09:30:00',2.79),('14598','2013-04-25','09:35:00',2.42),('14598','2013-04-25','09:40:00',2.61),('14598','2013-04-25','09:45:00',2.64),('14598','2013-04-25','09:50:00',2.8),('14598','2013-04-25','09:55:00',2.91),('14598','2013-04-25','10:00:00',2.91),('14598','2013-04-25','10:05:00',2.89),('14598','2013-04-25','10:10:00',2.74),('14598','2013-04-25','10:15:00',3.03),('14598','2013-04-25','10:20:00',3.37),('14598','2013-04-25','10:25:00',3.48),('14598','2013-04-25','10:30:00',3.57),('14598','2013-04-25','10:35:00',3.63),('14598','2013-04-25','10:40:00',3.67),('14598','2013-04-25','10:45:00',3.72),('14598','2013-04-25','10:50:00',3.79),('14598','2013-04-25','10:55:00',3.86),('14598','2013-04-25','11:00:00',3.91),('14598','2013-04-25','11:05:00',4.01),('14598','2013-04-25','11:10:00',3.97),('14598','2013-04-25','11:15:00',4.1),('14598','2013-04-25','11:20:00',4.26),('14598','2013-04-25','11:25:00',4.18),('14598','2013-04-25','11:30:00',3.72),('14598','2013-04-25','11:35:00',3.96),('14598','2013-04-25','11:40:00',3.7),('14598','2013-04-25','11:45:00',3.18),('14598','2013-04-25','11:50:00',3.41),('14598','2013-04-25','11:55:00',3.92),('14598','2013-04-25','12:00:00',4.5),('14598','2013-04-25','12:05:00',4.79),('14598','2013-04-25','12:10:00',4.81),('14598','2013-04-25','12:15:00',4.62),('14598','2013-04-25','12:20:00',4.66),('14598','2013-04-25','12:25:00',4.58),('14598','2013-04-25','12:30:00',4.85),('14598','2013-04-25','12:35:00',4.46),('14598','2013-04-25','12:40:00',4.96),('14598','2013-04-25','12:45:00',4.68),('14598','2013-04-25','12:50:00',4.27),('14598','2013-04-25','12:55:00',3.61),('14598','2013-04-25','13:00:00',3.91),('14598','2013-04-25','13:05:00',3.74),('14598','2013-04-25','13:10:00',3.55),('14598','2013-04-25','13:15:00',2.87),('14598','2013-04-25','13:20:00',2.66),('14598','2013-04-25','13:25:00',2.46),('14598','2013-04-25','13:30:00',2.24),('14598','2013-04-25','13:35:00',2.32),('14598','2013-04-25','13:40:00',2.35),('14598','2013-04-25','13:45:00',2.44),('14598','2013-04-25','13:50:00',2.51),('14598','2013-04-25','13:55:00',2.41),('14598','2013-04-25','14:00:00',2.58),('14598','2013-04-25','14:05:00',2.8),('14598','2013-04-25','14:10:00',3.18),('14598','2013-04-25','14:15:00',4),('14598','2013-04-25','14:20:00',3.73),('14598','2013-04-25','14:25:00',3.81),('14598','2013-04-25','14:30:00',4.15),('14598','2013-04-25','14:35:00',4.13),('14598','2013-04-25','14:40:00',4.09),('14598','2013-04-25','14:45:00',3.87),('14598','2013-04-25','14:50:00',3.74),('14598','2013-04-25','14:55:00',4.15),('14598','2013-04-25','15:00:00',2.81),('14598','2013-04-25','15:05:00',3.45),('14598','2013-04-25','15:10:00',3.86),('14598','2013-04-25','15:15:00',4.07),('14598','2013-04-25','15:20:00',4.52),('14598','2013-04-25','15:25:00',4.04),('14598','2013-04-25','15:30:00',2.86),('14598','2013-04-25','15:35:00',3.15),('14598','2013-04-25','15:40:00',3.53),('14598','2013-04-25','15:45:00',3.44),('14598','2013-04-25','15:50:00',3.18),('14598','2013-04-25','15:55:00',3.06),('14598','2013-04-25','16:00:00',2.58),('14598','2013-04-25','16:05:00',2.48),('14598','2013-04-25','16:10:00',2.27),('14598','2013-04-25','16:15:00',1.91),('14598','2013-04-25','16:20:00',2.07),('14598','2013-04-25','16:25:00',2.12),('14598','2013-04-25','16:30:00',1.97),('14598','2013-04-25','16:35:00',1.98),('14598','2013-04-25','16:40:00',2.11),('14598','2013-04-25','16:45:00',2.23),('14598','2013-04-25','16:50:00',2.54),('14598','2013-04-25','16:55:00',3.01),('14598','2013-04-25','17:00:00',2.74),('14598','2013-04-25','17:05:00',2.83),('14598','2013-04-25','17:10:00',2.69),('14598','2013-04-25','17:15:00',1.72),('14598','2013-04-25','17:20:00',1.39),('14598','2013-04-25','17:25:00',1.31),('14598','2013-04-25','17:30:00',1.98),('14598','2013-04-25','17:35:00',1.88),('14598','2013-04-25','17:40:00',1.58),('14598','2013-04-25','17:45:00',1.26),('14598','2013-04-25','17:50:00',1.13),('14598','2013-04-25','17:55:00',1.02),('14598','2013-04-24','08:10:00',1.03),('14598','2013-04-24','08:15:00',1.08),('14598','2013-04-24','08:20:00',1.12),('14598','2013-04-24','08:25:00',1.12),('14598','2013-04-24','08:30:00',1.24),('14598','2013-04-24','08:35:00',1.38),('14598','2013-04-24','08:40:00',1.41),('14598','2013-04-24','08:45:00',1.74),('14598','2013-04-24','08:50:00',2.04),('14598','2013-04-24','08:55:00',2.34),('14598','2013-04-24','09:00:00',2.08),('14598','2013-04-24','09:05:00',1.77),('14598','2013-04-24','09:10:00',1.74),('14598','2013-04-24','09:15:00',1.9),('14598','2013-04-24','09:20:00',2.19),('14598','2013-04-24','09:25:00',2.26),('14598','2013-04-24','09:30:00',2.96),('14598','2013-04-24','09:35:00',3.03),('14598','2013-04-24','09:40:00',3.06),('14598','2013-04-24','09:45:00',2.62),('14598','2013-04-24','09:50:00',2.52),('14598','2013-04-24','09:55:00',2.77),('14598','2013-04-24','10:00:00',2.87),('14598','2013-04-24','10:05:00',3.32),('14598','2013-04-24','10:10:00',3.63),('14598','2013-04-24','10:15:00',3.37),('14598','2013-04-24','10:20:00',3.01),('14598','2013-04-24','10:25:00',3.4),('14598','2013-04-24','10:30:00',3.48),('14598','2013-04-24','10:35:00',3.91),('14598','2013-04-24','10:40:00',3.86),('14598','2013-04-24','10:45:00',3.78),('14598','2013-04-24','10:50:00',4),('14598','2013-04-24','10:55:00',4.1),('14598','2013-04-24','11:00:00',4.19),('14598','2013-04-24','11:05:00',4.31),('14598','2013-04-24','11:10:00',4.13),('14598','2013-04-24','11:15:00',3.84),('14598','2013-04-24','11:20:00',3.58),('14598','2013-04-24','11:25:00',3.9),('14598','2013-04-24','11:30:00',4.59),('14598','2013-04-24','11:35:00',4.24),('14598','2013-04-24','11:40:00',3.97),('14598','2013-04-24','11:45:00',2.95),('14598','2013-04-24','11:50:00',3.54),('14598','2013-04-24','11:55:00',3.74),('14598','2013-04-24','12:00:00',3.07),('14598','2013-04-24','12:05:00',4.27),('14598','2013-04-24','12:10:00',2.92),('14598','2013-04-24','12:15:00',3.78),('14598','2013-04-24','12:20:00',3.64),('14598','2013-04-24','12:25:00',4.52),('14598','2013-04-24','12:30:00',4.07),('14598','2013-04-24','12:35:00',4.74),('14598','2013-04-24','12:40:00',4.59),('14598','2013-04-24','12:45:00',4.44),('14598','2013-04-24','12:50:00',3.98),('14598','2013-04-24','12:55:00',4.96),('14598','2013-04-24','13:00:00',4.45),('14598','2013-04-24','13:05:00',4.68),('14598','2013-04-24','13:10:00',4.67),('14598','2013-04-24','13:15:00',4.1),('14598','2013-04-24','13:20:00',4.47),('14598','2013-04-24','13:25:00',5.19),('14598','2013-04-24','13:30:00',4.53),('14598','2013-04-24','13:35:00',3.51),('14598','2013-04-24','13:40:00',4.67),('14598','2013-04-24','13:45:00',4.68),('14598','2013-04-24','13:50:00',3.51),('14598','2013-04-24','13:55:00',4.12),('14598','2013-04-24','14:00:00',5.06),('14598','2013-04-24','14:05:00',4.8),('14598','2013-04-24','14:10:00',4.97),('14598','2013-04-24','14:15:00',4.48),('14598','2013-04-24','14:20:00',4.3),('14598','2013-04-24','14:25:00',3.91),('14598','2013-04-24','14:30:00',4.04),('14598','2013-04-24','14:35:00',3.06),('14598','2013-04-24','14:40:00',2.87),('14598','2013-04-24','14:45:00',2.96),('14598','2013-04-24','14:50:00',3.03),('14598','2013-04-24','14:55:00',2.49),('14598','2013-04-24','15:00:00',2.75),('14598','2013-04-24','15:05:00',2.68),('14598','2013-04-24','15:10:00',2.24),('14598','2013-04-24','15:15:00',2.21),('14598','2013-04-24','15:20:00',2.08),('14598','2013-04-24','15:25:00',2.1),('14598','2013-04-24','15:30:00',2.23),('14598','2013-04-24','15:35:00',2.7),('14598','2013-04-24','15:40:00',2.89),('14598','2013-04-24','15:45:00',3.32),('14598','2013-04-24','15:50:00',3.39),('14598','2013-04-24','15:55:00',3.72),('14598','2013-04-24','16:00:00',4.44),('14598','2013-04-24','16:05:00',3.97),('14598','2013-04-24','16:10:00',3.54),('14598','2013-04-24','16:15:00',2.2),('14598','2013-04-24','16:20:00',3.16),('14598','2013-04-24','16:25:00',3.2),('14598','2013-04-24','16:30:00',3.21),('14598','2013-04-24','16:35:00',3.39),('14598','2013-04-24','16:40:00',3.97),('14598','2013-04-24','16:45:00',3.73),('14598','2013-04-24','16:50:00',3.44),('14598','2013-04-24','16:55:00',3.27),('14598','2013-04-24','17:00:00',2.91),('14598','2013-04-24','17:05:00',3.16),('14598','2013-04-24','17:10:00',2.37),('14598','2013-04-24','17:15:00',1.33),('14598','2013-04-24','17:20:00',1.02),('14598','2013-04-24','17:25:00',1.41),('14598','2013-04-24','17:30:00',1.43),('14598','2013-04-24','17:35:00',2.39),('14598','2013-04-24','17:40:00',2.13),('14598','2013-04-24','17:45:00',2),('14598','2013-04-24','17:50:00',2.19),('14598','2013-04-24','17:55:00',1.46),('14598','2013-04-24','18:00:00',1.08),('14598','2013-04-24','18:10:00',1.37),('14598','2013-04-24','18:15:00',1.85),('14598','2013-04-24','18:20:00',1.45),('14598','2013-04-24','18:25:00',1.25),('14598','2013-04-23','08:15:00',1.08),('14598','2013-04-23','08:20:00',1.19),('14598','2013-04-23','08:25:00',1.3),('14598','2013-04-23','08:30:00',1.41),('14598','2013-04-23','08:35:00',1.53),('14598','2013-04-23','08:40:00',1.64),('14598','2013-04-23','08:45:00',1.73),('14598','2013-04-23','08:50:00',1.85),('14598','2013-04-23','08:55:00',1.97),('14598','2013-04-23','09:00:00',2.11),('14598','2013-04-23','09:05:00',2.27),('14598','2013-04-23','09:10:00',2.39),('14598','2013-04-23','09:15:00',2.49),('14598','2013-04-23','09:20:00',2.6),('14598','2013-04-23','09:25:00',2.69),('14598','2013-04-23','09:30:00',2.79),('14598','2013-04-23','09:35:00',2.89),('14598','2013-04-23','09:40:00',2.99),('14598','2013-04-23','09:45:00',3.03),('14598','2013-04-23','09:50:00',2.82),('14598','2013-04-23','09:55:00',3.19),('14598','2013-04-23','10:00:00',3.33),('14598','2013-04-23','10:05:00',3.4),('14598','2013-04-23','10:10:00',3.48),('14598','2013-04-23','10:15:00',3.61),('14598','2013-04-23','10:20:00',3.7),('14598','2013-04-23','10:25:00',3.78),('14598','2013-04-23','10:30:00',3.85),('14598','2013-04-23','10:35:00',3.89),('14598','2013-04-23','10:40:00',3.96),('14598','2013-04-23','10:45:00',4.05),('14598','2013-04-23','10:50:00',4.09),('14598','2013-04-23','10:55:00',4.13),('14598','2013-04-23','11:00:00',4.17),('14598','2013-04-23','11:05:00',4.23),('14598','2013-04-23','11:10:00',4.31),('14598','2013-04-23','11:15:00',4.37),('14598','2013-04-23','11:20:00',4.39),('14598','2013-04-23','11:25:00',4.43),('14598','2013-04-23','11:30:00',4.47),('14598','2013-04-23','11:35:00',4.53),('14598','2013-04-23','11:40:00',4.54),('14598','2013-04-23','11:45:00',4.5),('14598','2013-04-23','11:50:00',4.58),('14598','2013-04-23','11:55:00',4.62),('14598','2013-04-23','12:00:00',4.64),('14598','2013-04-23','12:05:00',4.69),('14598','2013-04-23','12:10:00',4.72),('14598','2013-04-23','12:15:00',4.85),('14598','2013-04-23','12:20:00',4.61),('14598','2013-04-23','12:25:00',4.68),('14598','2013-04-23','12:30:00',4.79),('14598','2013-04-23','12:35:00',5.07),('14598','2013-04-23','12:40:00',4.96),('14598','2013-04-23','12:45:00',4.91),('14598','2013-04-23','12:50:00',5.11),('14598','2013-04-23','12:55:00',5.13),('14598','2013-04-23','13:00:00',5.1),('14598','2013-04-23','13:05:00',5.11),('14598','2013-04-23','13:10:00',5.09),('14598','2013-04-23','13:15:00',5.09),('14598','2013-04-23','13:20:00',5.37),('14598','2013-04-23','13:25:00',5.32),('14598','2013-04-23','13:30:00',4.78),('14598','2013-04-23','13:35:00',4.56),('14598','2013-04-23','13:40:00',4.89),('14598','2013-04-23','13:45:00',4.83),('14598','2013-04-23','13:50:00',4.47),('14598','2013-04-23','13:55:00',4.73),('14598','2013-04-23','14:00:00',5.46),('14598','2013-04-23','14:05:00',5.33),('14598','2013-04-23','14:10:00',4.95),('14598','2013-04-23','14:15:00',4.85),('14598','2013-04-23','14:20:00',4.84),('14598','2013-04-23','14:25:00',4.72),('14598','2013-04-23','14:30:00',4.83),('14598','2013-04-23','14:35:00',5.1),('14598','2013-04-23','14:40:00',5.13),('14598','2013-04-23','14:45:00',4.6),('14598','2013-04-23','14:50:00',3.45),('14598','2013-04-23','14:55:00',2.64),('14598','2013-04-23','15:00:00',3.03),('14598','2013-04-23','15:05:00',3.4),('14598','2013-04-23','15:10:00',3.69),('14598','2013-04-23','15:15:00',3.77),('14598','2013-04-23','15:20:00',3.49),('14598','2013-04-23','15:25:00',3.24),('14598','2013-04-23','15:30:00',3.51),('14598','2013-04-23','15:35:00',3.66),('14598','2013-04-23','15:40:00',3.79),('14598','2013-04-23','15:45:00',3.41),('14598','2013-04-23','15:50:00',2.77),('14598','2013-04-23','15:55:00',2.8),('14598','2013-04-23','16:00:00',3.08),('14598','2013-04-23','16:05:00',3.21),('14598','2013-04-23','16:10:00',2.61),('14598','2013-04-23','16:15:00',2.35),('14598','2013-04-23','16:20:00',2.84),('14598','2013-04-23','16:25:00',2.88),('14598','2013-04-23','16:30:00',3.71),('14598','2013-04-23','16:35:00',2.73),('14598','2013-04-23','16:40:00',2.78),('14598','2013-04-23','16:45:00',3.55),('14598','2013-04-23','16:50:00',2.21),('14598','2013-04-23','16:55:00',1.78),('14598','2013-04-23','17:00:00',1.58),('14598','2013-04-23','17:05:00',1.44),('14598','2013-04-23','17:10:00',1.45),('14598','2013-04-23','17:15:00',1.76),('14598','2013-04-23','17:20:00',1.41),('14598','2013-04-23','17:25:00',2.1),('14598','2013-04-23','17:30:00',2.5),('14598','2013-04-23','17:35:00',2.25),('14598','2013-04-23','17:40:00',1.06),('14598','2013-04-23','17:45:00',1.78),('14598','2013-04-23','17:50:00',2.23),('14598','2013-04-23','17:55:00',1.93),('14598','2013-04-23','18:00:00',1.31),('14598','2013-04-23','18:05:00',1.8),('14598','2013-04-23','18:10:00',1.71),('14598','2013-04-23','18:15:00',1.35),('14598','2013-04-23','18:25:00',1.24),('14598','2013-04-23','18:30:00',1.39),('14598','2013-04-22','08:35:00',1.15),('14598','2013-04-22','08:40:00',1.06),('14598','2013-04-22','10:20:00',1.04),('14598','2013-04-22','10:40:00',1.98),('14598','2013-04-22','10:45:00',3.55),('14598','2013-04-22','10:50:00',5.26),('14598','2013-04-22','10:55:00',1.69),('14598','2013-04-22','11:00:00',2.4),('14598','2013-04-22','11:05:00',2.38),('14598','2013-04-22','11:10:00',2.05),('14598','2013-04-22','11:15:00',3.51),('14598','2013-04-22','11:20:00',3.74),('14598','2013-04-22','11:25:00',5.09),('14598','2013-04-22','11:30:00',5),('14598','2013-04-22','11:35:00',4.78),('14598','2013-04-22','11:40:00',4.8),('14598','2013-04-22','11:45:00',4.85),('14598','2013-04-22','11:50:00',4.67),('14598','2013-04-22','11:55:00',4.39),('14598','2013-04-22','12:00:00',4.97),('14598','2013-04-22','12:05:00',4.96),('14598','2013-04-22','12:10:00',5.01),('14598','2013-04-22','12:15:00',5.07),('14598','2013-04-22','12:20:00',5.08),('14598','2013-04-22','12:25:00',5.1),('14598','2013-04-22','12:30:00',5.13),('14598','2013-04-22','12:35:00',4.8),('14598','2013-04-22','12:40:00',2.99),('14598','2013-04-22','12:45:00',2.67),('14598','2013-04-22','12:50:00',2.83),('14598','2013-04-22','12:55:00',1.9),('14598','2013-04-22','13:00:00',3.09),('14598','2013-04-22','13:05:00',2.46),('14598','2013-04-22','13:10:00',1.58),('14598','2013-04-22','13:15:00',4.17),('14598','2013-04-22','13:20:00',3.62),('14598','2013-04-22','13:25:00',2.07),('14598','2013-04-22','13:30:00',3.95),('14598','2013-04-22','13:35:00',4.05),('14598','2013-04-22','13:40:00',5.72),('14598','2013-04-22','13:45:00',5.5),('14598','2013-04-22','13:50:00',5.5),('14598','2013-04-22','13:55:00',5.46),('14598','2013-04-22','14:00:00',5.45),('14598','2013-04-22','14:05:00',5.53),('14598','2013-04-22','14:10:00',5.56),('14598','2013-04-22','14:15:00',5.51),('14598','2013-04-22','14:20:00',5.51),('14598','2013-04-22','14:25:00',4.49),('14598','2013-04-22','14:30:00',5.05),('14598','2013-04-22','14:35:00',2.83),('14598','2013-04-22','14:40:00',2.65),('14598','2013-04-22','14:45:00',3.48),('14598','2013-04-22','14:50:00',5.55),('14598','2013-04-22','14:55:00',4.37),('14598','2013-04-22','15:00:00',4.96),('14598','2013-04-22','15:05:00',5.71),('14598','2013-04-22','15:10:00',2.59),('14598','2013-04-22','15:15:00',1.95),('14598','2013-04-22','15:20:00',1.56),('14598','2013-04-22','15:25:00',1.34),('14598','2013-04-22','15:30:00',1.15),('14598','2013-04-22','15:35:00',3.73),('14598','2013-04-22','15:40:00',4.52),('14598','2013-04-22','15:45:00',4.45),('14598','2013-04-22','15:50:00',1.59),('14598','2013-04-22','15:55:00',3.25),('14598','2013-04-22','16:00:00',3.85),('14598','2013-04-22','16:05:00',4.91),('14598','2013-04-22','16:10:00',4.99),('14598','2013-04-22','16:15:00',4.92),('14598','2013-04-22','16:20:00',4.38),('14598','2013-04-22','16:25:00',4.28),('14598','2013-04-22','16:30:00',3.26),('14598','2013-04-22','16:35:00',1.77),('14598','2013-04-22','16:40:00',2.32),('14598','2013-04-22','16:45:00',3.59),('14598','2013-04-22','16:50:00',3.42),('14598','2013-04-22','16:55:00',3.23),('14598','2013-04-22','17:00:00',3.58),('14598','2013-04-22','17:05:00',3.65),('14598','2013-04-22','17:10:00',2.49),('14598','2013-04-22','17:15:00',1.92),('14598','2013-04-22','17:20:00',1.51),('14598','2013-04-22','17:25:00',1.11),('14598','2013-04-22','18:10:00',1.75),('14598','2013-04-22','18:20:00',1.49),('14598','2013-04-22','18:35:00',1.22),('14598','2013-04-22','18:55:00',1.07),('14598','2014-03-29','07:50:00',1.08),('14598','2014-03-29','07:55:00',1.16),('14598','2014-03-29','08:00:00',1.28),('14598','2014-03-29','08:05:00',1.38),('14598','2014-03-29','08:10:00',1.49),('14598','2014-03-29','08:15:00',1.62),('14598','2014-03-29','08:20:00',1.73),('14598','2014-03-29','08:25:00',1.88),('14598','2014-03-29','08:30:00',2),('14598','2014-03-29','08:35:00',2.1),('14598','2014-03-29','08:40:00',2.21),('14598','2014-03-29','08:45:00',2.29),('14598','2014-03-29','08:50:00',2.37),('14598','2014-03-29','08:55:00',2.46),('14598','2014-03-29','09:00:00',2.54),('14598','2014-03-29','09:05:00',2.63),('14598','2014-03-29','09:10:00',2.7),('14598','2014-03-29','09:15:00',2.8),('14598','2014-03-29','09:20:00',2.87),('14598','2014-03-29','09:25:00',2.96),('14598','2014-03-29','09:30:00',3.04),('14598','2014-03-29','09:35:00',3.13),('14598','2014-03-29','09:40:00',3.21),('14598','2014-03-29','09:45:00',3.27),('14598','2014-03-29','09:50:00',3.34),('14598','2014-03-29','09:55:00',3.41),('14598','2014-03-29','10:00:00',3.48),('14598','2014-03-29','10:05:00',3.57),('14598','2014-03-29','10:10:00',3.63),('14598','2014-03-29','10:15:00',3.7),('14598','2014-03-29','10:20:00',3.75),('14598','2014-03-29','10:25:00',3.81),('14598','2014-03-29','10:30:00',3.9),('14598','2014-03-29','10:35:00',3.94),('14598','2014-03-29','10:40:00',3.96),('14598','2014-03-29','10:45:00',3.99),('14598','2014-03-29','10:50:00',4.05),('14598','2014-03-29','10:55:00',4.13),('14598','2014-03-29','11:00:00',4.16),('14598','2014-03-29','11:05:00',4.19),('14598','2014-03-29','11:10:00',4.23),('14598','2014-03-29','11:15:00',4.27),('14598','2014-03-29','11:20:00',4.3),('14598','2014-03-29','11:25:00',4.35),('14598','2014-03-29','11:30:00',4.39),('14598','2014-03-29','11:35:00',4.4),('14598','2014-03-29','11:40:00',4.4),('14598','2014-03-29','11:45:00',4.43),('14598','2014-03-29','11:50:00',4.46),('14598','2014-03-29','11:55:00',4.48),('14598','2014-03-29','12:00:00',4.61),('14598','2014-03-29','12:05:00',4.69),('14598','2014-03-29','12:10:00',4.57),('14598','2014-03-29','12:15:00',4.69),('14598','2014-03-29','12:20:00',4.7),('14598','2014-03-29','12:25:00',4.7),('14598','2014-03-29','12:30:00',4.68),('14598','2014-03-29','12:35:00',4.69),('14598','2014-03-29','12:40:00',4.71),('14598','2014-03-29','12:45:00',4.72),('14598','2014-03-29','12:50:00',4.74),('14598','2014-03-29','12:55:00',4.75),('14598','2014-03-29','13:00:00',4.71),('14598','2014-03-29','13:05:00',4.69),('14598','2014-03-29','13:10:00',4.71),('14598','2014-03-29','13:15:00',4.69),('14598','2014-03-29','13:20:00',4.64),('14598','2014-03-29','13:25:00',4.58),('14598','2014-03-29','13:30:00',4.61),('14598','2014-03-29','13:35:00',4.57),('14598','2014-03-29','13:40:00',4.5),('14598','2014-03-29','13:45:00',4.52),('14598','2014-03-29','13:50:00',4.45),('14598','2014-03-29','13:55:00',4.42),('14598','2014-03-29','14:00:00',4.43),('14598','2014-03-29','14:05:00',4.36),('14598','2014-03-29','14:10:00',4.33),('14598','2014-03-29','14:15:00',4.27),('14598','2014-03-29','14:20:00',4.21),('14598','2014-03-29','14:25:00',4.19),('14598','2014-03-29','14:30:00',4.14),('14598','2014-03-29','14:35:00',4.13),('14598','2014-03-29','14:40:00',4.02),('14598','2014-03-29','14:45:00',3.92),('14598','2014-03-29','14:50:00',3.93),('14598','2014-03-29','14:55:00',3.86),('14598','2014-03-29','15:00:00',3.78),('14598','2014-03-29','15:05:00',3.69),('14598','2014-03-29','15:10:00',3.54),('14598','2014-03-29','15:15:00',3.55),('14598','2014-03-29','15:20:00',3.49),('14598','2014-03-29','15:25:00',3.42),('14598','2014-03-29','15:30:00',3.33),('14598','2014-03-29','15:35:00',3.28),('14598','2014-03-29','15:40:00',3.21),('14598','2014-03-29','15:45:00',3.11),('14598','2014-03-29','15:50:00',3.02),('14598','2014-03-29','15:55:00',2.96),('14598','2014-03-29','16:00:00',2.86),('14598','2014-03-29','16:05:00',2.76),('14598','2014-03-29','16:10:00',2.48),('14598','2014-03-29','16:15:00',2.5),('14598','2014-03-29','16:20:00',2.49),('14598','2014-03-29','16:25:00',2.12),('14598','2014-03-29','16:30:00',1.82),('14598','2014-03-29','16:35:00',1.65),('14598','2014-03-29','16:40:00',1.72),('14598','2014-03-29','16:45:00',1.91),('14598','2014-03-29','16:50:00',1.87),('14598','2014-03-29','16:55:00',1.65),('14598','2014-03-29','17:00:00',1.52),('14598','2014-03-29','17:05:00',1.53),('14598','2014-03-29','17:10:00',1.38),('14598','2014-03-29','17:15:00',1.26),('14598','2014-03-29','17:20:00',1.13),('14598','2013-04-21','08:20:00',1.03),('14598','2013-04-21','08:25:00',1.23),('14598','2013-04-21','08:30:00',1.27),('14598','2013-04-21','08:35:00',1.42),('14598','2013-04-21','08:40:00',1.79),('14598','2013-04-21','08:45:00',1.86),('14598','2013-04-21','08:50:00',1.8),('14598','2013-04-21','08:55:00',1.99),('14598','2013-04-21','09:00:00',1.14),('14598','2013-04-21','09:05:00',1.99),('14598','2013-04-21','09:10:00',1.97),('14598','2013-04-21','09:15:00',1.94),('14598','2013-04-21','09:20:00',1.77),('14598','2013-04-21','09:25:00',1.54),('14598','2013-04-21','09:30:00',1.56),('14598','2013-04-21','09:35:00',2.98),('14598','2013-04-21','09:40:00',3.75),('14598','2013-04-21','09:45:00',2.96),('14598','2013-04-21','09:50:00',2.74),('14598','2013-04-21','09:55:00',1.88),('14598','2013-04-21','10:00:00',3.3),('14598','2013-04-21','10:05:00',3.36),('14598','2013-04-21','10:10:00',3.46),('14598','2013-04-21','10:15:00',3.57),('14598','2013-04-21','10:20:00',3.66),('14598','2013-04-21','10:25:00',3.74),('14598','2013-04-21','10:30:00',3.81),('14598','2013-04-21','10:35:00',3.87),('14598','2013-04-21','10:40:00',3.94),('14598','2013-04-21','10:45:00',4.02),('14598','2013-04-21','10:50:00',4.08),('14598','2013-04-21','10:55:00',4.14),('14598','2013-04-21','11:00:00',4.22),('14598','2013-04-21','11:05:00',4.3),('14598','2013-04-21','11:10:00',4.34),('14598','2013-04-21','11:15:00',4.02),('14598','2013-04-21','11:20:00',3.21),('14598','2013-04-21','11:25:00',3.12),('14598','2013-04-21','11:30:00',3.1),('14598','2013-04-21','11:35:00',3.24),('14598','2013-04-21','11:40:00',2.93),('14598','2013-04-21','11:45:00',2.64),('14598','2013-04-21','11:50:00',2.47),('14598','2013-04-21','11:55:00',2.61),('14598','2013-04-21','12:00:00',3),('14598','2013-04-21','12:05:00',2.99),('14598','2013-04-21','12:10:00',2.74),('14598','2013-04-21','12:15:00',2.92),('14598','2013-04-21','12:20:00',3.23),('14598','2013-04-21','12:25:00',3.7),('14598','2013-04-21','12:30:00',3.39),('14598','2013-04-21','12:35:00',2.92),('14598','2013-04-21','12:40:00',3.16),('14598','2013-04-21','12:45:00',3.32),('14598','2013-04-21','12:50:00',3.7),('14598','2013-04-21','12:55:00',3.48),('14598','2013-04-21','13:00:00',5),('14598','2013-04-21','13:05:00',4.32),('14598','2013-04-21','13:10:00',4.33),('14598','2013-04-21','13:15:00',4.5),('14598','2013-04-21','13:20:00',4.68),('14598','2013-04-21','13:25:00',5.67),('14598','2013-04-21','13:30:00',5.68),('14598','2013-04-21','13:35:00',5.38),('14598','2013-04-21','13:40:00',4.34),('14598','2013-04-21','13:45:00',4.57),('14598','2013-04-21','13:50:00',5.22),('14598','2013-04-21','13:55:00',5.26),('14598','2013-04-21','14:00:00',5.23),('14598','2013-04-21','14:05:00',5.21),('14598','2013-04-21','14:10:00',5.22),('14598','2013-04-21','14:15:00',5.17),('14598','2013-04-21','14:20:00',5.21),('14598','2013-04-21','14:25:00',5.14),('14598','2013-04-21','14:30:00',5.2),('14598','2013-04-21','14:35:00',4.47),('14598','2013-04-21','14:40:00',4.41),('14598','2013-04-21','14:45:00',4.79),('14598','2013-04-21','14:50:00',4.29),('14598','2013-04-21','14:55:00',5.48),('14598','2013-04-21','15:00:00',5.09),('14598','2013-04-21','15:05:00',5.02),('14598','2013-04-21','15:10:00',5.04),('14598','2013-04-21','15:15:00',5.21),('14598','2013-04-21','15:20:00',3.43),('14598','2013-04-21','15:25:00',3.16),('14598','2013-04-21','15:30:00',2.75),('14598','2013-04-21','15:35:00',2.57),('14598','2013-04-21','15:40:00',2.48),('14598','2013-04-21','15:45:00',2.58),('14598','2013-04-21','15:50:00',1.88),('14598','2013-04-21','15:55:00',1.49),('14598','2013-04-21','16:00:00',1.43),('14598','2013-04-21','16:05:00',1.49),('14598','2013-04-21','16:10:00',1.44),('14598','2013-04-21','16:15:00',1.33),('14598','2013-04-21','16:20:00',1.35),('14598','2013-04-21','16:25:00',2.03),('14598','2013-04-21','16:30:00',2.17),('14598','2013-04-21','16:35:00',2.09),('14598','2013-04-21','16:40:00',1.4),('14598','2013-04-21','16:45:00',1.21),('14598','2013-04-21','16:50:00',1.32),('14598','2013-04-21','16:55:00',1.27),('14598','2013-04-20','08:40:00',1.14),('14598','2013-04-20','08:45:00',1.4),('14598','2013-04-20','08:50:00',1.02),('14598','2013-04-20','10:05:00',1.21),('14598','2013-04-20','10:10:00',1.17),('14598','2013-04-20','10:15:00',1.32),('14598','2013-04-20','10:20:00',1.63),('14598','2013-04-20','10:25:00',2.32),('14598','2013-04-20','10:30:00',2.73),('14598','2013-04-20','10:35:00',2.25),('14598','2013-04-20','10:40:00',2.16),('14598','2013-04-20','10:45:00',1.93),('14598','2013-04-20','10:50:00',1.86),('14598','2013-04-20','10:55:00',1.84),('14598','2013-04-20','11:00:00',2.28),('14598','2013-04-20','11:05:00',2.2),('14598','2013-04-20','11:10:00',2.54),('14598','2013-04-20','11:15:00',2.32),('14598','2013-04-20','11:20:00',3.51),('14598','2013-04-20','11:25:00',2.44),('14598','2013-04-20','11:30:00',4.96),('14598','2013-04-20','11:35:00',5.02),('14598','2013-04-20','11:40:00',4.83),('14598','2013-04-20','11:45:00',4.81),('14598','2013-04-20','11:50:00',4.83),('14598','2013-04-20','11:55:00',4.89),('14598','2013-04-20','12:00:00',4.8),('14598','2013-04-20','12:05:00',4.86),('14598','2013-04-20','12:10:00',4.94),('14598','2013-04-20','12:15:00',5.01),('14598','2013-04-20','12:20:00',5.01),('14598','2013-04-20','12:25:00',5.03),('14598','2013-04-20','12:30:00',5.13),('14598','2013-04-20','12:35:00',5.27),('14598','2013-04-20','12:40:00',5.18),('14598','2013-04-20','12:45:00',4.92),('14598','2013-04-20','12:50:00',5.45),('14598','2013-04-20','12:55:00',4.22),('14598','2013-04-20','13:00:00',4.48),('14598','2013-04-20','13:05:00',4.94),('14598','2013-04-20','13:10:00',5.5),('14598','2013-04-20','13:15:00',4.23),('14598','2013-04-20','13:20:00',2.18),('14598','2013-04-20','13:25:00',2.07),('14598','2013-04-20','13:30:00',2.01),('14598','2013-04-20','13:35:00',2.32),('14598','2013-04-20','13:40:00',5.12),('14598','2013-04-20','13:45:00',5.7),('14598','2013-04-20','13:50:00',4.95),('14598','2013-04-20','13:55:00',4.46),('14598','2013-04-20','14:00:00',5.31),('14598','2013-04-20','14:05:00',5.8),('14598','2013-04-20','14:10:00',5.38),('14598','2013-04-20','14:15:00',5.63),('14598','2013-04-20','14:20:00',3.9),('14598','2013-04-20','14:25:00',4.78),('14598','2013-04-20','14:30:00',5.86),('14598','2013-04-20','14:35:00',5.6),('14598','2013-04-20','14:40:00',5.44),('14598','2013-04-20','14:45:00',5.1),('14598','2013-04-20','14:50:00',2.97),('14598','2013-04-20','14:55:00',1.81),('14598','2013-04-20','15:00:00',1.5),('14598','2013-04-20','15:05:00',1.17),('14598','2013-04-20','15:20:00',1.11),('14598','2013-04-20','15:25:00',1.7),('14598','2013-04-20','15:30:00',2.61),('14598','2013-04-20','15:35:00',3.64),('14598','2013-04-20','15:40:00',4.48),('14598','2013-04-20','15:45:00',3.81),('14598','2013-04-20','15:50:00',3.82),('14598','2013-04-20','15:55:00',4.07),('14598','2013-04-20','16:00:00',3.64),('14598','2013-04-20','16:05:00',4.15),('14598','2013-04-20','16:10:00',4.06),('14598','2013-04-20','16:15:00',4.14),('14598','2013-04-20','16:20:00',4.08),('14598','2013-04-20','16:25:00',3.97),('14598','2013-04-20','16:30:00',3.84),('14598','2013-04-20','16:35:00',3.77),('14598','2013-04-20','16:40:00',3.68),('14598','2013-04-20','16:45:00',3.59),('14598','2013-04-20','16:50:00',3.52),('14598','2013-04-20','16:55:00',3.42),('14598','2013-04-20','17:00:00',3.32),('14598','2013-04-20','17:05:00',3.23),('14598','2013-04-20','17:10:00',2.92),('14598','2013-04-20','17:15:00',1.72),('14598','2013-04-20','17:30:00',1.3),('14598','2013-04-20','17:35:00',2.12),('14598','2013-04-20','17:40:00',2.77),('14598','2013-04-20','17:45:00',3.05),('14598','2013-04-20','17:50:00',2.41),('14598','2013-04-20','18:00:00',1.24),('14598','2013-04-20','18:10:00',1.35),('14598','2013-04-20','18:15:00',1.25),('14598','2013-04-19','08:35:00',1.12),('14598','2013-04-19','08:40:00',1.24),('14598','2013-04-19','08:45:00',1.21),('14598','2013-04-19','08:50:00',1.56),('14598','2013-04-19','08:55:00',1.41),('14598','2013-04-19','09:00:00',1.3),('14598','2013-04-19','09:05:00',1.56),('14598','2013-04-19','09:10:00',2.04),('14598','2013-04-19','09:15:00',2.01),('14598','2013-04-19','09:20:00',2.49),('14598','2013-04-19','09:25:00',1.85),('14598','2013-04-19','09:30:00',2.57),('14598','2013-04-19','09:35:00',2.82),('14598','2013-04-19','09:40:00',2.61),('14598','2013-04-19','09:45:00',2.13),('14598','2013-04-19','09:50:00',2.02),('14598','2013-04-19','09:55:00',2.21),('14598','2013-04-19','10:00:00',2.62),('14598','2013-04-19','10:05:00',3.12),('14598','2013-04-19','10:10:00',2.38),('14598','2013-04-19','10:15:00',1.92),('14598','2013-04-19','10:20:00',3.07),('14598','2013-04-19','10:25:00',3.17),('14598','2013-04-19','10:30:00',3.64),('14598','2013-04-19','10:35:00',3.7),('14598','2013-04-19','10:40:00',3.67),('14598','2013-04-19','10:45:00',3.81),('14598','2013-04-19','10:50:00',3.89),('14598','2013-04-19','10:55:00',3.96),('14598','2013-04-19','11:00:00',4.01),('14598','2013-04-19','11:05:00',4.1),('14598','2013-04-19','11:10:00',4.16),('14598','2013-04-19','11:15:00',4.18),('14598','2013-04-19','11:20:00',4.27),('14598','2013-04-19','11:25:00',4.3),('14598','2013-04-19','11:30:00',4.36),('14598','2013-04-19','11:35:00',4.42),('14598','2013-04-19','11:40:00',4.44),('14598','2013-04-19','11:45:00',4.51),('14598','2013-04-19','11:50:00',4.55),('14598','2013-04-19','11:55:00',4.58),('14598','2013-04-19','12:00:00',4.64),('14598','2013-04-19','12:05:00',4.66),('14598','2013-04-19','12:10:00',4.71),('14598','2013-04-19','12:15:00',4.75),('14598','2013-04-19','12:20:00',4.77),('14598','2013-04-19','12:25:00',4.81),('14598','2013-04-19','12:30:00',4.81),('14598','2013-04-19','12:35:00',4.88),('14598','2013-04-19','12:40:00',4.88),('14598','2013-04-19','12:45:00',4.92),('14598','2013-04-19','12:50:00',4.95),('14598','2013-04-19','12:55:00',5),('14598','2013-04-19','13:00:00',5.03),('14598','2013-04-19','13:05:00',5.03),('14598','2013-04-19','13:10:00',5.01),('14598','2013-04-19','13:15:00',4.98),('14598','2013-04-19','13:20:00',5.01),('14598','2013-04-19','13:25:00',5.02),('14598','2013-04-19','13:30:00',4.98),('14598','2013-04-19','13:35:00',4.98),('14598','2013-04-19','13:40:00',5.01),('14598','2013-04-19','13:45:00',5.04),('14598','2013-04-19','13:50:00',5.05),('14598','2013-04-19','13:55:00',5.02),('14598','2013-04-19','14:00:00',5.06),('14598','2013-04-19','14:05:00',5.05),('14598','2013-04-19','14:10:00',5.06),('14598','2013-04-19','14:15:00',5.02),('14598','2013-04-19','14:20:00',5.04),('14598','2013-04-19','14:25:00',5.03),('14598','2013-04-19','14:30:00',5.03),('14598','2013-04-19','14:35:00',4.99),('14598','2013-04-19','14:40:00',4.97),('14598','2013-04-19','14:45:00',4.94),('14598','2013-04-19','14:50:00',4.93),('14598','2013-04-19','14:55:00',4.88),('14598','2013-04-19','15:00:00',4.81),('14598','2013-04-19','15:05:00',4.76),('14598','2013-04-19','15:10:00',4.74),('14598','2013-04-19','15:15:00',4.71),('14598','2013-04-19','15:20:00',4.64),('14598','2013-04-19','15:25:00',4.58),('14598','2013-04-19','15:30:00',4.47),('14598','2013-04-19','15:35:00',4.47),('14598','2013-04-19','15:40:00',4.42),('14598','2013-04-19','15:45:00',4.35),('14598','2013-04-19','15:50:00',4.37),('14598','2013-04-19','15:55:00',4.32),('14598','2013-04-19','16:00:00',4.19),('14598','2013-04-19','16:05:00',4.07),('14598','2013-04-19','16:10:00',4.02),('14598','2013-04-19','16:15:00',3.94),('14598','2013-04-19','16:20:00',3.88),('14598','2013-04-19','16:25:00',3.29),('14598','2013-04-19','16:30:00',3.14),('14598','2013-04-19','16:35:00',3.71),('14598','2013-04-19','16:40:00',3.57),('14598','2013-04-19','16:45:00',3.51),('14598','2013-04-19','16:50:00',3.41),('14598','2013-04-19','16:55:00',3.33),('14598','2013-04-19','17:00:00',3.23),('14598','2013-04-19','17:05:00',3.14),('14598','2013-04-19','17:10:00',3.05),('14598','2013-04-19','17:15:00',2.95),('14598','2013-04-19','17:20:00',2.85),('14598','2013-04-19','17:25:00',2.74),('14598','2013-04-19','17:30:00',2.59),('14598','2013-04-19','17:35:00',2.43),('14598','2013-04-19','17:40:00',2.36),('14598','2013-04-19','17:45:00',2.27),('14598','2013-04-19','17:50:00',2.17),('14598','2013-04-19','17:55:00',2.07),('14598','2013-04-19','18:00:00',1.83),('14598','2013-04-19','18:05:00',1.67),('14598','2013-04-19','18:10:00',1.54),('14598','2013-04-19','18:15:00',1.4),('14598','2013-04-19','18:20:00',1.39),('14598','2013-04-19','18:30:00',1.14),('14598','2013-04-19','18:35:00',1.06),('14598','2013-04-18','08:25:00',1.01),('14598','2013-04-18','08:30:00',1.22),('14598','2013-04-18','08:35:00',1.41),('14598','2013-04-18','08:40:00',1.52),('14598','2013-04-18','08:45:00',1.66),('14598','2013-04-18','08:50:00',1.56),('14598','2013-04-18','08:55:00',1.5),('14598','2013-04-18','09:00:00',1.87),('14598','2013-04-18','09:05:00',2.16),('14598','2013-04-18','09:10:00',2.31),('14598','2013-04-18','09:15:00',2.3),('14598','2013-04-18','09:20:00',2.5),('14598','2013-04-18','09:25:00',2.6),('14598','2013-04-18','09:30:00',2.69),('14598','2013-04-18','09:35:00',2.78),('14598','2013-04-18','09:40:00',2.88),('14598','2013-04-18','09:45:00',2.96),('14598','2013-04-18','09:50:00',3.05),('14598','2013-04-18','09:55:00',3.13),('14598','2013-04-18','10:00:00',3.21),('14598','2013-04-18','10:05:00',3.23),('14598','2013-04-18','10:10:00',3.36),('14598','2013-04-18','10:15:00',3.43),('14598','2013-04-18','10:20:00',3.51),('14598','2013-04-18','10:25:00',3.59),('14598','2013-04-18','10:30:00',3.63),('14598','2013-04-18','10:35:00',3.72),('14598','2013-04-18','10:40:00',3.8),('14598','2013-04-18','10:45:00',3.86),('14598','2013-04-18','10:50:00',3.93),('14598','2013-04-18','10:55:00',4),('14598','2013-04-18','11:00:00',4.07),('14598','2013-04-18','11:05:00',4.14),('14598','2013-04-18','11:10:00',4.22),('14598','2013-04-18','11:15:00',4.28),('14598','2013-04-18','11:20:00',4.31),('14598','2013-04-18','11:25:00',4.41),('14598','2013-04-18','11:30:00',4.47),('14598','2013-04-18','11:35:00',4.5),('14598','2013-04-18','11:40:00',4.52),('14598','2013-04-18','11:45:00',4.52),('14598','2013-04-18','11:50:00',4.54),('14598','2013-04-18','11:55:00',4.59),('14598','2013-04-18','12:00:00',4.65),('14598','2013-04-18','12:05:00',4.63),('14598','2013-04-18','12:10:00',4.76),('14598','2013-04-18','12:15:00',4.79),('14598','2013-04-18','12:20:00',4.79),('14598','2013-04-18','12:25:00',4.79),('14598','2013-04-18','12:30:00',4.83),('14598','2013-04-18','12:35:00',4.9),('14598','2013-04-18','12:40:00',4.97),('14598','2013-04-18','12:45:00',5),('14598','2013-04-18','12:50:00',5.05),('14598','2013-04-18','12:55:00',5.06),('14598','2013-04-18','13:00:00',5.06),('14598','2013-04-18','13:05:00',5.06),('14598','2013-04-18','13:10:00',5.11),('14598','2013-04-18','13:15:00',5.12),('14598','2013-04-18','13:20:00',5.15),('14598','2013-04-18','13:25:00',5.16),('14598','2013-04-18','13:30:00',5.18),('14598','2013-04-18','13:35:00',5.2),('14598','2013-04-18','13:40:00',5.2),('14598','2013-04-18','13:45:00',5.21),('14598','2013-04-18','13:50:00',5.21),('14598','2013-04-18','13:55:00',5.19),('14598','2013-04-18','14:00:00',5.09),('14598','2013-04-18','14:05:00',5.16),('14598','2013-04-18','14:10:00',5.1),('14598','2013-04-18','14:15:00',5.11),('14598','2013-04-18','14:20:00',5.02),('14598','2013-04-18','14:25:00',5.07),('14598','2013-04-18','14:30:00',5.04),('14598','2013-04-18','14:35:00',5.02),('14598','2013-04-18','14:40:00',5),('14598','2013-04-18','14:45:00',4.96),('14598','2013-04-18','14:50:00',4.92),('14598','2013-04-18','14:55:00',4.86),('14598','2013-04-18','15:00:00',4.83),('14598','2013-04-18','15:05:00',4.81),('14598','2013-04-18','15:10:00',4.8),('14598','2013-04-18','15:15:00',4.76),('14598','2013-04-18','15:20:00',4.66),('14598','2013-04-18','15:25:00',4.64),('14598','2013-04-18','15:30:00',4.59),('14598','2013-04-18','15:35:00',4.55),('14598','2013-04-18','15:40:00',4.5),('14598','2013-04-18','15:45:00',4.46),('14598','2013-04-18','15:50:00',4.42),('14598','2013-04-18','15:55:00',4.36),('14598','2013-04-18','16:00:00',4.29),('14598','2013-04-18','16:05:00',4.22),('14598','2013-04-18','16:10:00',4.17),('14598','2013-04-18','16:15:00',4.1),('14598','2013-04-18','16:20:00',4.04),('14598','2013-04-18','16:25:00',3.96),('14598','2013-04-18','16:30:00',3.9),('14598','2013-04-18','16:35:00',3.8),('14598','2013-04-18','16:40:00',3.72),('14598','2013-04-18','16:45:00',3.65),('14598','2013-04-18','16:50:00',3.56),('14598','2013-04-18','16:55:00',3.48),('14598','2013-04-18','17:00:00',3.38),('14598','2013-04-18','17:05:00',3.28),('14598','2013-04-18','17:10:00',3.18),('14598','2013-04-18','17:15:00',3.09),('14598','2013-04-18','17:20:00',2.98),('14598','2013-04-18','17:25:00',2.89),('14598','2013-04-18','17:30:00',2.78),('14598','2013-04-18','17:35:00',2.66),('14598','2013-04-18','17:40:00',2.56),('14598','2013-04-18','17:45:00',2.45),('14598','2013-04-18','17:50:00',2.34),('14598','2013-04-18','17:55:00',2.21),('14598','2013-04-18','18:00:00',2.06),('14598','2013-04-18','18:05:00',1.92),('14598','2013-04-18','18:10:00',1.82),('14598','2013-04-18','18:15:00',1.72),('14598','2013-04-18','18:20:00',1.61),('14598','2013-04-18','18:25:00',1.49),('14598','2013-04-18','18:30:00',1.37),('14598','2013-04-18','18:35:00',1.26),('14598','2013-04-18','18:40:00',1.15),('14598','2013-04-18','18:45:00',1.04),('14598','2013-04-17','08:20:00',1.04),('14598','2013-04-17','08:25:00',1.14),('14598','2013-04-17','08:30:00',1.24),('14598','2013-04-17','08:35:00',1.34),('14598','2013-04-17','08:40:00',1.46),('14598','2013-04-17','08:45:00',1.57),('14598','2013-04-17','08:50:00',1.68),('14598','2013-04-17','08:55:00',1.78),('14598','2013-04-17','09:00:00',1.91),('14598','2013-04-17','09:05:00',2.05),('14598','2013-04-17','09:10:00',2.17),('14598','2013-04-17','09:15:00',2.29),('14598','2013-04-17','09:20:00',2.4),('14598','2013-04-17','09:25:00',2.5),('14598','2013-04-17','09:30:00',2.59),('14598','2013-04-17','09:35:00',2.7),('14598','2013-04-17','09:40:00',2.8),('14598','2013-04-17','09:45:00',2.89),('14598','2013-04-17','09:50:00',2.97),('14598','2013-04-17','09:55:00',3.05),('14598','2013-04-17','10:00:00',3.14),('14598','2013-04-17','10:05:00',3.22),('14598','2013-04-17','10:10:00',3.3),('14598','2013-04-17','10:15:00',3.39),('14598','2013-04-17','10:20:00',3.47),('14598','2013-04-17','10:25:00',3.54),('14598','2013-04-17','10:30:00',3.61),('14598','2013-04-17','10:35:00',3.68),('14598','2013-04-17','10:40:00',3.73),('14598','2013-04-17','10:45:00',3.78),('14598','2013-04-17','10:50:00',3.83),('14598','2013-04-17','10:55:00',3.84),('14598','2013-04-17','11:00:00',3.95),('14598','2013-04-17','11:05:00',4.02),('14598','2013-04-17','11:10:00',4.06),('14598','2013-04-17','11:15:00',4.13),('14598','2013-04-17','11:20:00',4.19),('14598','2013-04-17','11:25:00',4.24),('14598','2013-04-17','11:30:00',4.27),('14598','2013-04-17','11:35:00',4.39),('14598','2013-04-17','11:40:00',4.52),('14598','2013-04-17','11:45:00',4.59),('14598','2013-04-17','11:50:00',4.64),('14598','2013-04-17','11:55:00',4.7),('14598','2013-04-17','12:00:00',4.74),('14598','2013-04-17','12:05:00',4.77),('14598','2013-04-17','12:10:00',4.69),('14598','2013-04-17','12:15:00',4.82),('14598','2013-04-17','12:20:00',4.87),('14598','2013-04-17','12:25:00',4.85),('14598','2013-04-17','12:30:00',4.85),('14598','2013-04-17','12:35:00',4.99),('14598','2013-04-17','12:40:00',4.98),('14598','2013-04-17','12:45:00',5.01),('14598','2013-04-17','12:50:00',4.96),('14598','2013-04-17','12:55:00',5.12),('14598','2013-04-17','13:00:00',5.17),('14598','2013-04-17','13:05:00',5.03),('14598','2013-04-17','13:10:00',5.05),('14598','2013-04-17','13:15:00',5.31),('14598','2013-04-17','13:20:00',4.89),('14598','2013-04-17','13:25:00',4.74),('14598','2013-04-17','13:30:00',5.33),('14598','2013-04-17','13:35:00',5.25),('14598','2013-04-17','13:40:00',4.96),('14598','2013-04-17','13:45:00',5.01),('14598','2013-04-17','13:50:00',5.32),('14598','2013-04-17','13:55:00',5.27),('14598','2013-04-17','14:00:00',5.36),('14598','2013-04-17','14:05:00',5),('14598','2013-04-17','14:10:00',5.08),('14598','2013-04-17','14:15:00',5.32),('14598','2013-04-17','14:20:00',5.39),('14598','2013-04-17','14:25:00',5.31),('14598','2013-04-17','14:30:00',5.26),('14598','2013-04-17','14:35:00',5.23),('14598','2013-04-17','14:40:00',5.27),('14598','2013-04-17','14:45:00',5.37),('14598','2013-04-17','14:50:00',5.11),('14598','2013-04-17','14:55:00',4.4),('14598','2013-04-17','15:00:00',3.7),('14598','2013-04-17','15:05:00',3.35),('14598','2013-04-17','15:10:00',2.9),('14598','2013-04-17','15:15:00',2.4),('14598','2013-04-17','15:20:00',2.94),('14598','2013-04-17','15:25:00',3.21),('14598','2013-04-17','15:30:00',3.68),('14598','2013-04-17','15:35:00',4.39),('14598','2013-04-17','15:40:00',4.73),('14598','2013-04-17','15:45:00',4.83),('14598','2013-04-17','15:50:00',4.99),('14598','2013-04-17','15:55:00',4.92),('14598','2013-04-17','16:00:00',4.68),('14598','2013-04-17','16:05:00',4.41),('14598','2013-04-17','16:10:00',4.2),('14598','2013-04-17','16:15:00',4.26),('14598','2013-04-17','16:20:00',3.61),('14598','2013-04-17','16:25:00',3.71),('14598','2013-04-17','16:30:00',3.94),('14598','2013-04-17','16:35:00',3.84),('14598','2013-04-17','16:40:00',3.75),('14598','2013-04-17','16:45:00',3.65),('14598','2013-04-17','16:50:00',3.57),('14598','2013-04-17','16:55:00',3.42),('14598','2013-04-17','17:00:00',3.37),('14598','2013-04-17','17:05:00',3.27),('14598','2013-04-17','17:10:00',3.17),('14598','2013-04-17','17:15:00',3.07),('14598','2013-04-17','17:20:00',2.97),('14598','2013-04-17','17:25:00',2.89),('14598','2013-04-17','17:30:00',2.79),('14598','2013-04-17','17:35:00',2.67),('14598','2013-04-17','17:40:00',2.57),('14598','2013-04-17','17:45:00',2.45),('14598','2013-04-17','17:50:00',2.33),('14598','2013-04-17','17:55:00',2.22),('14598','2013-04-17','18:00:00',2.1),('14598','2013-04-17','18:05:00',1.99),('14598','2013-04-17','18:10:00',1.86),('14598','2013-04-17','18:15:00',1.78),('14598','2013-04-17','18:20:00',1.66),('14598','2013-04-17','18:25:00',1.55),('14598','2013-04-17','18:30:00',1.42),('14598','2013-04-17','18:35:00',1.29),('14598','2013-04-17','18:40:00',1.17),('14598','2013-04-17','18:45:00',1.06),('14598','2013-04-16','08:25:00',1.05),('14598','2013-04-16','08:30:00',1.18),('14598','2013-04-16','08:35:00',1.27),('14598','2013-04-16','08:40:00',1.37),('14598','2013-04-16','08:45:00',1.48),('14598','2013-04-16','08:50:00',1.57),('14598','2013-04-16','08:55:00',1.67),('14598','2013-04-16','09:00:00',1.8),('14598','2013-04-16','09:05:00',1.98),('14598','2013-04-16','09:10:00',1.54),('14598','2013-04-16','09:15:00',1.08),('14598','2013-04-16','09:25:00',1.27),('14598','2013-04-16','09:30:00',2.15),('14598','2013-04-16','09:35:00',1.96),('14598','2013-04-16','09:40:00',1.88),('14598','2013-04-16','09:45:00',1.97),('14598','2013-04-16','09:50:00',1.81),('14598','2013-04-16','09:55:00',2.13),('14598','2013-04-16','10:00:00',1.91),('14598','2013-04-16','10:05:00',1.94),('14598','2013-04-16','10:10:00',1.68),('14598','2013-04-16','10:15:00',1.7),('14598','2013-04-16','10:20:00',1.79),('14598','2013-04-16','10:25:00',1.7),('14598','2013-04-16','10:30:00',1.78),('14598','2013-04-16','10:35:00',1.75),('14598','2013-04-16','10:40:00',1.63),('14598','2013-04-16','10:45:00',1.55),('14598','2013-04-16','10:50:00',1.6),('14598','2013-04-16','10:55:00',1.69),('14598','2013-04-16','11:00:00',1.75),('14598','2013-04-16','11:05:00',1.76),('14598','2013-04-16','11:10:00',1.82),('14598','2013-04-16','11:15:00',2.11),('14598','2013-04-16','11:20:00',2.26),('14598','2013-04-16','11:25:00',2.41),('14598','2013-04-16','11:30:00',2.53),('14598','2013-04-16','11:35:00',2.49),('14598','2013-04-16','11:40:00',2.45),('14598','2013-04-16','11:45:00',2.62),('14598','2013-04-16','11:50:00',2.86),('14598','2013-04-16','11:55:00',2.97),('14598','2013-04-16','12:00:00',3),('14598','2013-04-16','12:05:00',3.37),('14598','2013-04-16','12:10:00',3.97),('14598','2013-04-16','12:15:00',3.92),('14598','2013-04-16','12:20:00',3.29),('14598','2013-04-16','12:25:00',4.23),('14598','2013-04-16','12:30:00',4.16),('14598','2013-04-16','12:35:00',5.11),('14598','2013-04-16','12:40:00',4.26),('14598','2013-04-16','12:45:00',4.2),('14598','2013-04-16','12:50:00',4.79),('14598','2013-04-16','12:55:00',4.43),('14598','2013-04-16','13:00:00',4.84),('14598','2013-04-16','13:05:00',5),('14598','2013-04-16','13:10:00',5.04),('14598','2013-04-16','13:15:00',5.05),('14598','2013-04-16','13:20:00',5.05),('14598','2013-04-16','13:25:00',5.05),('14598','2013-04-16','13:30:00',5.06),('14598','2013-04-16','13:35:00',5.1),('14598','2013-04-16','13:40:00',5.14),('14598','2013-04-16','13:45:00',5.16),('14598','2013-04-16','13:50:00',5),('14598','2013-04-16','13:55:00',4.79),('14598','2013-04-16','14:00:00',4.76),('14598','2013-04-16','14:05:00',4.98),('14598','2013-04-16','14:10:00',5.06),('14598','2013-04-16','14:15:00',5.23),('14598','2013-04-16','14:20:00',5.24),('14598','2013-04-16','14:25:00',5.08),('14598','2013-04-16','14:30:00',5.15),('14598','2013-04-16','14:35:00',3.69),('14598','2013-04-16','14:40:00',4.59),('14598','2013-04-16','14:45:00',5.1),('14598','2013-04-16','14:50:00',5.01),('14598','2013-04-16','14:55:00',5.28),('14598','2013-04-16','15:00:00',3.68),('14598','2013-04-16','15:05:00',2.36),('14598','2013-04-16','15:10:00',3.23),('14598','2013-04-16','15:15:00',5.07),('14598','2013-04-16','15:20:00',4.76),('14598','2013-04-16','15:25:00',4.67),('14598','2013-04-16','15:30:00',4.6),('14598','2013-04-16','15:35:00',4.36),('14598','2013-04-16','15:40:00',4.42),('14598','2013-04-16','15:45:00',4.23),('14598','2013-04-16','15:50:00',4.25),('14598','2013-04-16','15:55:00',4.29),('14598','2013-04-16','16:00:00',4.24),('14598','2013-04-16','16:05:00',4.17),('14598','2013-04-16','16:10:00',4.13),('14598','2013-04-16','16:15:00',4.11),('14598','2013-04-16','16:20:00',4.06),('14598','2013-04-16','16:25:00',3.69),('14598','2013-04-16','16:30:00',3.25),('14598','2013-04-16','16:35:00',2.02),('14598','2013-04-16','16:40:00',2.05),('14598','2013-04-16','16:45:00',3.62),('14598','2013-04-16','16:50:00',3.59),('14598','2013-04-16','16:55:00',3.39),('14598','2013-04-16','17:00:00',3.29),('14598','2013-04-16','17:05:00',3.2),('14598','2013-04-16','17:10:00',3.09),('14598','2013-04-16','17:15:00',2.99),('14598','2013-04-16','17:20:00',2.89),('14598','2013-04-16','17:25:00',2.79),('14598','2013-04-16','17:30:00',2.68),('14598','2013-04-16','17:35:00',2.57),('14598','2013-04-16','17:40:00',2.45),('14598','2013-04-16','17:45:00',2.3),('14598','2013-04-16','17:50:00',2.23),('14598','2013-04-16','17:55:00',2.14),('14598','2013-04-16','18:00:00',2.04),('14598','2013-04-16','18:05:00',1.9),('14598','2013-04-16','18:10:00',1.38),('14598','2013-04-16','18:15:00',1.6),('14598','2013-04-16','18:20:00',1.54),('14598','2013-04-16','18:25:00',1.41),('14598','2013-04-16','18:30:00',1.26),('14598','2013-04-16','18:35:00',1.16),('14598','2013-04-16','18:40:00',1.05),('14598','2013-04-15','08:25:00',1.09),('14598','2013-04-15','08:30:00',1.2),('14598','2013-04-15','08:35:00',1.32),('14598','2013-04-15','08:40:00',1.42),('14598','2013-04-15','08:45:00',1.52),('14598','2013-04-15','08:50:00',1.63),('14598','2013-04-15','08:55:00',1.74),('14598','2013-04-15','09:00:00',1.86),('14598','2013-04-15','09:05:00',2),('14598','2013-04-15','09:10:00',2.13),('14598','2013-04-15','09:15:00',2.27),('14598','2013-04-15','09:20:00',2.39),('14598','2013-04-15','09:25:00',2.48),('14598','2013-04-15','09:30:00',2.58),('14598','2013-04-15','09:35:00',2.67),('14598','2013-04-15','09:40:00',2.76),('14598','2013-04-15','09:45:00',2.86),('14598','2013-04-15','09:50:00',2.96),('14598','2013-04-15','09:55:00',3.05),('14598','2013-04-15','10:00:00',3.14),('14598','2013-04-15','10:05:00',3.22),('14598','2013-04-15','10:10:00',3.3),('14598','2013-04-15','10:15:00',3.37),('14598','2013-04-15','10:20:00',3.46),('14598','2013-04-15','10:25:00',3.53),('14598','2013-04-15','10:30:00',3.62),('14598','2013-04-15','10:35:00',3.67),('14598','2013-04-15','10:40:00',3.67),('14598','2013-04-15','10:45:00',3.82),('14598','2013-04-15','10:50:00',3.88),('14598','2013-04-15','10:55:00',3.93),('14598','2013-04-15','11:00:00',3.98),('14598','2013-04-15','11:05:00',4.03),('14598','2013-04-15','11:10:00',4.09),('14598','2013-04-15','11:15:00',4.12),('14598','2013-04-15','11:20:00',4.17),('14598','2013-04-15','11:25:00',4.23),('14598','2013-04-15','11:30:00',4.29),('14598','2013-04-15','11:35:00',4.34),('14598','2013-04-15','11:40:00',4.38),('14598','2013-04-15','11:45:00',4.41),('14598','2013-04-15','11:50:00',4.46),('14598','2013-04-15','11:55:00',4.47),('14598','2013-04-15','12:00:00',4.54),('14598','2013-04-15','12:05:00',4.57),('14598','2013-04-15','12:10:00',4.7),('14598','2013-04-15','12:15:00',4.79),('14598','2013-04-15','12:20:00',4.83),('14598','2013-04-15','12:25:00',4.88),('14598','2013-04-15','12:30:00',4.95),('14598','2013-04-15','12:35:00',4.97),('14598','2013-04-15','12:40:00',5),('14598','2013-04-15','12:45:00',5.02),('14598','2013-04-15','12:50:00',5.05),('14598','2013-04-15','12:55:00',5.09),('14598','2013-04-15','13:00:00',5.12),('14598','2013-04-15','13:05:00',5.14),('14598','2013-04-15','13:10:00',5.14),('14598','2013-04-15','13:15:00',5.13),('14598','2013-04-15','13:20:00',5.13),('14598','2013-04-15','13:25:00',5.14),('14598','2013-04-15','13:30:00',5.17),('14598','2013-04-15','13:35:00',5.2),('14598','2013-04-15','13:40:00',5.24),('14598','2013-04-15','13:45:00',5.2),('14598','2013-04-15','13:50:00',5.19),('14598','2013-04-15','13:55:00',5.19),('14598','2013-04-15','14:00:00',5.18),('14598','2013-04-15','14:05:00',5.17),('14598','2013-04-15','14:10:00',5.17),('14598','2013-04-15','14:15:00',5.15),('14598','2013-04-15','14:20:00',5.12),('14598','2013-04-15','14:25:00',5.09),('14598','2013-04-15','14:30:00',5.07),('14598','2013-04-15','14:35:00',5.05),('14598','2013-04-15','14:40:00',5.01),('14598','2013-04-15','14:45:00',5.01),('14598','2013-04-15','14:50:00',5.01),('14598','2013-04-15','14:55:00',4.97),('14598','2013-04-15','15:00:00',4.91),('14598','2013-04-15','15:05:00',4.91),('14598','2013-04-15','15:10:00',4.86),('14598','2013-04-15','15:15:00',4.81),('14598','2013-04-15','15:20:00',4.76),('14598','2013-04-15','15:25:00',4.72),('14598','2013-04-15','15:30:00',4.67),('14598','2013-04-15','15:35:00',4.64),('14598','2013-04-15','15:40:00',4.59),('14598','2013-04-15','15:45:00',4.51),('14598','2013-04-15','15:50:00',4.46),('14598','2013-04-15','15:55:00',4.41),('14598','2013-04-15','16:00:00',4.33),('14598','2013-04-15','16:05:00',4.27),('14598','2013-04-15','16:10:00',4.19),('14598','2013-04-15','16:15:00',4.11),('14598','2013-04-15','16:20:00',4.06),('14598','2013-04-15','16:25:00',4),('14598','2013-04-15','16:30:00',3.93),('14598','2013-04-15','16:35:00',3.85),('14598','2013-04-15','16:40:00',3.75),('14598','2013-04-15','16:45:00',3.6),('14598','2013-04-15','16:50:00',3.59),('14598','2013-04-15','16:55:00',3.5),('14598','2013-04-15','17:00:00',3.41),('14598','2013-04-15','17:05:00',3.32),('14598','2013-04-15','17:10:00',3.22),('14598','2013-04-15','17:15:00',3.13),('14598','2013-04-15','17:20:00',3.02),('14598','2013-04-15','17:25:00',2.92),('14598','2013-04-15','17:30:00',2.82),('14598','2013-04-15','17:35:00',2.72),('14598','2013-04-15','17:40:00',2.62),('14598','2013-04-15','17:45:00',2.51),('14598','2013-04-15','17:50:00',2.4),('14598','2013-04-15','17:55:00',2.28),('14598','2013-04-15','18:00:00',2.16),('14598','2013-04-15','18:05:00',2.05),('14598','2013-04-15','18:10:00',1.93),('14598','2013-04-15','18:15:00',1.82),('14598','2013-04-15','18:20:00',1.69),('14598','2013-04-15','18:25:00',1.57),('14598','2013-04-15','18:30:00',1.45),('14598','2013-04-15','18:35:00',1.33),('14598','2013-04-15','18:40:00',1.22),('14598','2013-04-15','18:45:00',1.1),('14598','2013-04-14','08:25:00',1.02),('14598','2013-04-14','08:30:00',1.09),('14598','2013-04-14','08:35:00',1.24),('14598','2013-04-14','08:40:00',1.35),('14598','2013-04-14','08:45:00',1.45),('14598','2013-04-14','08:50:00',1.55),('14598','2013-04-14','08:55:00',1.67),('14598','2013-04-14','09:00:00',1.78),('14598','2013-04-14','09:05:00',1.91),('14598','2013-04-14','09:10:00',2.02),('14598','2013-04-14','09:15:00',2.17),('14598','2013-04-14','09:20:00',2.27),('14598','2013-04-14','09:25:00',2.38),('14598','2013-04-14','09:30:00',2.47),('14598','2013-04-14','09:35:00',2.55),('14598','2013-04-14','09:40:00',2.65),('14598','2013-04-14','09:45:00',2.75),('14598','2013-04-14','09:50:00',2.83),('14598','2013-04-14','09:55:00',2.92),('14598','2013-04-14','10:00:00',3.01),('14598','2013-04-14','10:05:00',3.11),('14598','2013-04-14','10:10:00',3.18),('14598','2013-04-14','10:15:00',3.25),('14598','2013-04-14','10:20:00',3.33),('14598','2013-04-14','10:25:00',3.42),('14598','2013-04-14','10:30:00',3.46),('14598','2013-04-14','10:35:00',3.56),('14598','2013-04-14','10:40:00',3.63),('14598','2013-04-14','10:45:00',3.69),('14598','2013-04-14','10:50:00',3.75),('14598','2013-04-14','10:55:00',3.8),('14598','2013-04-14','11:00:00',3.86),('14598','2013-04-14','11:05:00',3.92),('14598','2013-04-14','11:10:00',3.97),('14598','2013-04-14','11:15:00',4.05),('14598','2013-04-14','11:20:00',4.16),('14598','2013-04-14','11:25:00',4.24),('14598','2013-04-14','11:30:00',4.29),('14598','2013-04-14','11:35:00',4.36),('14598','2013-04-14','11:40:00',4.41),('14598','2013-04-14','11:45:00',4.46),('14598','2013-04-14','11:50:00',4.52),('14598','2013-04-14','11:55:00',4.57),('14598','2013-04-14','12:00:00',4.59),('14598','2013-04-14','12:05:00',4.63),('14598','2013-04-14','12:10:00',4.67),('14598','2013-04-14','12:15:00',4.69),('14598','2013-04-14','12:20:00',4.73),('14598','2013-04-14','12:25:00',4.74),('14598','2013-04-14','12:30:00',4.78),('14598','2013-04-14','12:35:00',4.83),('14598','2013-04-14','12:40:00',4.86),('14598','2013-04-14','12:45:00',4.89),('14598','2013-04-14','12:50:00',4.91),('14598','2013-04-14','12:55:00',4.95),('14598','2013-04-14','13:00:00',4.95),('14598','2013-04-14','13:05:00',4.98),('14598','2013-04-14','13:10:00',5),('14598','2013-04-14','13:15:00',5),('14598','2013-04-14','13:20:00',5.04),('14598','2013-04-14','13:25:00',5.04),('14598','2013-04-14','13:30:00',4.98),('14598','2013-04-14','13:35:00',5.06),('14598','2013-04-14','13:40:00',5.06),('14598','2013-04-14','13:45:00',5.06),('14598','2013-04-14','13:50:00',5.03),('14598','2013-04-14','13:55:00',5.03),('14598','2013-04-14','14:00:00',5.06),('14598','2013-04-14','14:05:00',5.05),('14598','2013-04-14','14:10:00',5.04),('14598','2013-04-14','14:15:00',5.03),('14598','2013-04-14','14:20:00',5.01),('14598','2013-04-14','14:25:00',4.98),('14598','2013-04-14','14:30:00',4.96),('14598','2013-04-14','14:35:00',4.95),('14598','2013-04-14','14:40:00',4.93),('14598','2013-04-14','14:45:00',4.87),('14598','2013-04-14','14:50:00',4.88),('14598','2013-04-14','14:55:00',4.86),('14598','2013-04-14','15:00:00',4.82),('14598','2013-04-14','15:05:00',4.8),('14598','2013-04-14','15:10:00',4.75),('14598','2013-04-14','15:15:00',4.68),('14598','2013-04-14','15:20:00',4.65),('14598','2013-04-14','15:25:00',4.59),('14598','2013-04-14','15:30:00',4.58),('14598','2013-04-14','15:35:00',4.51),('14598','2013-04-14','15:40:00',4.45),('14598','2013-04-14','15:45:00',4.39),('14598','2013-04-14','15:50:00',4.33),('14598','2013-04-14','15:55:00',4.27),('14598','2013-04-14','16:00:00',4.2),('14598','2013-04-14','16:05:00',4.12),('14598','2013-04-14','16:10:00',4.05),('14598','2013-04-14','16:15:00',3.98),('14598','2013-04-14','16:20:00',3.9),('14598','2013-04-14','16:25:00',3.83),('14598','2013-04-14','16:30:00',3.73),('14598','2013-04-14','16:35:00',3.68),('14598','2013-04-14','16:40:00',3.59),('14598','2013-04-14','16:45:00',3.51),('14598','2013-04-14','16:50:00',3.44),('14598','2013-04-14','16:55:00',3.35),('14598','2013-04-14','17:00:00',3.25),('14598','2013-04-14','17:05:00',3.13),('14598','2013-04-14','17:10:00',3.04),('14598','2013-04-14','17:15:00',2.97),('14598','2013-04-14','17:20:00',2.88),('14598','2013-04-14','17:25:00',2.78),('14598','2013-04-14','17:30:00',2.68),('14598','2013-04-14','17:35:00',2.57),('14598','2013-04-14','17:40:00',2.48),('14598','2013-04-14','17:45:00',2.38),('14598','2013-04-14','17:50:00',2.26),('14598','2013-04-14','17:55:00',2.13),('14598','2013-04-14','18:00:00',2.04),('14598','2013-04-14','18:05:00',1.93),('14598','2013-04-14','18:10:00',1.8),('14598','2013-04-14','18:15:00',1.67),('14598','2013-04-14','18:20:00',1.55),('14598','2013-04-14','18:25:00',1.45),('14598','2013-04-14','18:30:00',1.32),('14598','2013-04-14','18:35:00',1.2),('14598','2013-04-14','18:40:00',1.08),('14598','2013-04-13','08:40:00',1.01),('14598','2013-04-13','08:45:00',1.1),('14598','2013-04-13','08:50:00',1.69),('14598','2013-04-13','08:55:00',2.12),('14598','2013-04-13','09:00:00',2.26),('14598','2013-04-13','09:05:00',2.4),('14598','2013-04-13','09:10:00',2.47),('14598','2013-04-13','09:15:00',1.77),('14598','2013-04-13','09:25:00',1.09),('14598','2013-04-13','09:35:00',2.47),('14598','2013-04-13','09:40:00',2.75),('14598','2013-04-13','09:45:00',2.84),('14598','2013-04-13','09:50:00',2.91),('14598','2013-04-13','09:55:00',2.54),('14598','2013-04-13','10:00:00',3.12),('14598','2013-04-13','10:05:00',3.1),('14598','2013-04-13','10:10:00',3.24),('14598','2013-04-13','10:15:00',3.38),('14598','2013-04-13','10:20:00',3.46),('14598','2013-04-13','10:25:00',3.58),('14598','2013-04-13','10:30:00',3.49),('14598','2013-04-13','10:35:00',3.3),('14598','2013-04-13','10:40:00',3.83),('14598','2013-04-13','10:45:00',3.97),('14598','2013-04-13','10:50:00',3.5),('14598','2013-04-13','10:55:00',3.98),('14598','2013-04-13','11:00:00',3.87),('14598','2013-04-13','11:05:00',3.82),('14598','2013-04-13','11:10:00',4.15),('14598','2013-04-13','11:15:00',4.16),('14598','2013-04-13','11:20:00',4.19),('14598','2013-04-13','11:25:00',4.36),('14598','2013-04-13','11:30:00',4.38),('14598','2013-04-13','11:35:00',4.36),('14598','2013-04-13','11:40:00',4.54),('14598','2013-04-13','11:45:00',4.55),('14598','2013-04-13','11:50:00',4.64),('14598','2013-04-13','11:55:00',4.7),('14598','2013-04-13','12:00:00',4.58),('14598','2013-04-13','12:05:00',4.75),('14598','2013-04-13','12:10:00',4.79),('14598','2013-04-13','12:15:00',4.82),('14598','2013-04-13','12:20:00',4.92),('14598','2013-04-13','12:25:00',4.92),('14598','2013-04-13','12:30:00',4.94),('14598','2013-04-13','12:35:00',5.05),('14598','2013-04-13','12:40:00',5.02),('14598','2013-04-13','12:45:00',4.87),('14598','2013-04-13','12:50:00',4.96),('14598','2013-04-13','12:55:00',5.06),('14598','2013-04-13','13:00:00',5.25),('14598','2013-04-13','13:05:00',5.12),('14598','2013-04-13','13:10:00',4.89),('14598','2013-04-13','13:15:00',4.97),('14598','2013-04-13','13:20:00',5.03),('14598','2013-04-13','13:25:00',4.77),('14598','2013-04-13','13:30:00',4.46),('14598','2013-04-13','13:35:00',4.54),('14598','2013-04-13','13:40:00',4.37),('14598','2013-04-13','13:45:00',4.42),('14598','2013-04-13','13:50:00',4.43),('14598','2013-04-13','13:55:00',4.33),('14598','2013-04-13','14:00:00',4.37),('14598','2013-04-13','14:05:00',4.27),('14598','2013-04-13','14:10:00',4.36),('14598','2013-04-13','14:15:00',4.43),('14598','2013-04-13','14:20:00',4.7),('14598','2013-04-13','14:25:00',4.84),('14598','2013-04-13','14:30:00',4.78),('14598','2013-04-13','14:35:00',4.73),('14598','2013-04-13','14:40:00',4.68),('14598','2013-04-13','14:45:00',4.54),('14598','2013-04-13','14:50:00',4.29),('14598','2013-04-13','14:55:00',4.2),('14598','2013-04-13','15:00:00',4.33),('14598','2013-04-13','15:05:00',4.07),('14598','2013-04-13','15:10:00',3.85),('14598','2013-04-13','15:15:00',3.71),('14598','2013-04-13','15:20:00',3.7),('14598','2013-04-13','15:25:00',3.65),('14598','2013-04-13','15:30:00',3.72),('14598','2013-04-13','15:35:00',3.81),('14598','2013-04-13','15:40:00',3.85),('14598','2013-04-13','15:45:00',3.81),('14598','2013-04-13','15:50:00',3.56),('14598','2013-04-13','15:55:00',3.67),('14598','2013-04-13','16:00:00',3.33),('14598','2013-04-13','16:05:00',3.28),('14598','2013-04-13','16:10:00',3.23),('14598','2013-04-13','16:15:00',3.21),('14598','2013-04-13','16:20:00',2.74),('14598','2013-04-13','16:25:00',2.7),('14598','2013-04-13','16:30:00',2.45),('14598','2013-04-13','16:35:00',1.96),('14598','2013-04-13','16:40:00',2),('14598','2013-04-13','16:45:00',2),('14598','2013-04-13','16:50:00',1.67),('14598','2013-04-13','16:55:00',2.31),('14598','2013-04-13','17:00:00',2.89),('14598','2013-04-13','17:05:00',2.39),('14598','2013-04-13','17:10:00',2.24),('14598','2013-04-13','17:15:00',2.18),('14598','2013-04-13','17:20:00',2.85),('14598','2013-04-13','17:25:00',2.06),('14598','2013-04-13','17:30:00',2.15),('14598','2013-04-13','17:35:00',1.75),('14598','2013-04-13','17:40:00',2.22),('14598','2013-04-13','17:45:00',1.76),('14598','2013-04-13','17:50:00',1.77),('14598','2013-04-13','17:55:00',1.81),('14598','2013-04-13','18:00:00',1.7),('14598','2013-04-13','18:05:00',1.19),('14598','2013-04-13','18:10:00',1.87),('14598','2013-04-13','18:15:00',1.57),('14598','2013-04-13','18:20:00',1.09),('14598','2013-04-13','18:30:00',1.47),('14598','2013-04-13','18:35:00',1.46),('14598','2013-04-13','18:40:00',1.31),('14598','2013-04-13','18:45:00',1.13),('14598','2013-04-13','18:50:00',1.09),('14598','2013-04-13','18:55:00',1.07),('14598','2013-04-12','08:50:00',1.07),('14598','2013-04-12','09:05:00',1.11),('14598','2013-04-12','09:45:00',1.01),('14598','2013-04-12','10:00:00',1.63),('14598','2013-04-12','10:05:00',1.34),('14598','2013-04-12','10:10:00',1.1),('14598','2013-04-12','10:15:00',1.85),('14598','2013-04-12','10:20:00',1.71),('14598','2013-04-12','10:25:00',1.65),('14598','2013-04-12','10:30:00',1.95),('14598','2013-04-12','10:35:00',1.88),('14598','2013-04-12','10:40:00',2.38),('14598','2013-04-12','10:45:00',3.99),('14598','2013-04-12','10:50:00',3.58),('14598','2013-04-12','10:55:00',2.83),('14598','2013-04-12','11:00:00',3.14),('14598','2013-04-12','11:05:00',3.39),('14598','2013-04-12','11:10:00',3.3),('14598','2013-04-12','11:15:00',4.42),('14598','2013-04-12','11:20:00',4.37),('14598','2013-04-12','11:25:00',4.42),('14598','2013-04-12','11:30:00',4.49),('14598','2013-04-12','11:35:00',4.53),('14598','2013-04-12','11:40:00',4.49),('14598','2013-04-12','11:45:00',4.48),('14598','2013-04-12','11:50:00',4.56),('14598','2013-04-12','11:55:00',4.41),('14598','2013-04-12','12:00:00',4.58),('14598','2013-04-12','12:05:00',4.83),('14598','2013-04-12','12:10:00',4.88),('14598','2013-04-12','12:15:00',4.96),('14598','2013-04-12','12:20:00',4.94),('14598','2013-04-12','12:25:00',4.84),('14598','2013-04-12','12:30:00',4.95),('14598','2013-04-12','12:35:00',4.7),('14598','2013-04-12','12:40:00',4.85),('14598','2013-04-12','12:45:00',4.94),('14598','2013-04-12','12:50:00',5.01),('14598','2013-04-12','12:55:00',5.05),('14598','2013-04-12','13:00:00',5.1),('14598','2013-04-12','13:05:00',5.11),('14598','2013-04-12','13:10:00',5.12),('14598','2013-04-12','13:15:00',5.11),('14598','2013-04-12','13:20:00',5.14),('14598','2013-04-12','13:25:00',5.17),('14598','2013-04-12','13:30:00',5.14),('14598','2013-04-12','13:35:00',5.19),('14598','2013-04-12','13:40:00',5.21),('14598','2013-04-12','13:45:00',5.19),('14598','2013-04-12','13:50:00',5.19),('14598','2013-04-12','13:55:00',5.17),('14598','2013-04-12','14:00:00',5.15),('14598','2013-04-12','14:05:00',5.13),('14598','2013-04-12','14:10:00',5.13),('14598','2013-04-12','14:15:00',5.11),('14598','2013-04-12','14:20:00',5.08),('14598','2013-04-12','14:25:00',5.06),('14598','2013-04-12','14:30:00',4.96),('14598','2013-04-12','14:35:00',5.03),('14598','2013-04-12','14:40:00',5),('14598','2013-04-12','14:45:00',4.97),('14598','2013-04-12','14:50:00',4.93),('14598','2013-04-12','14:55:00',4.89),('14598','2013-04-12','15:00:00',4.84),('14598','2013-04-12','15:05:00',4.81),('14598','2013-04-12','15:10:00',4.75),('14598','2013-04-12','15:15:00',4.72),('14598','2013-04-12','15:20:00',4.68),('14598','2013-04-12','15:25:00',4.61),('14598','2013-04-12','15:30:00',4.56),('14598','2013-04-12','15:35:00',4.5),('14598','2013-04-12','15:40:00',4.43),('14598','2013-04-12','15:45:00',4.37),('14598','2013-04-12','15:50:00',4.32),('14598','2013-04-12','15:55:00',4.27),('14598','2013-04-12','16:00:00',4.19),('14598','2013-04-12','16:05:00',4.15),('14598','2013-04-12','16:10:00',4.08),('14598','2013-04-12','16:15:00',3.98),('14598','2013-04-12','16:20:00',3.94),('14598','2013-04-12','16:25:00',3.86),('14598','2013-04-12','16:30:00',3.77),('14598','2013-04-12','16:35:00',3.71),('14598','2013-04-12','16:40:00',3.61),('14598','2013-04-12','16:45:00',3.53),('14598','2013-04-12','16:50:00',3.43),('14598','2013-04-12','16:55:00',3.35),('14598','2013-04-12','17:00:00',3.27),('14598','2013-04-12','17:05:00',3.19),('14598','2013-04-12','17:10:00',3.1),('14598','2013-04-12','17:15:00',3),('14598','2013-04-12','17:20:00',2.9),('14598','2013-04-12','17:25:00',2.81),('14598','2013-04-12','17:30:00',2.7),('14598','2013-04-12','17:35:00',2.59),('14598','2013-04-12','17:40:00',2.48),('14598','2013-04-12','17:45:00',2.36),('14598','2013-04-12','17:50:00',2.25),('14598','2013-04-12','17:55:00',2.12),('14598','2013-04-12','18:00:00',2.02),('14598','2013-04-12','18:05:00',1.9),('14598','2013-04-12','18:10:00',1.28),('14598','2013-04-12','18:15:00',1.08),('14598','2013-04-12','18:20:00',1.18),('14598','2014-03-28','07:50:00',1.09),('14598','2014-03-28','07:55:00',1.16),('14598','2014-03-28','08:00:00',1.29),('14598','2014-03-28','08:05:00',1.38),('14598','2014-03-28','08:10:00',1.5),('14598','2014-03-28','08:15:00',1.63),('14598','2014-03-28','08:20:00',1.78),('14598','2014-03-28','08:25:00',1.94),('14598','2014-03-28','08:30:00',2.08),('14598','2014-03-28','08:35:00',2.22),('14598','2014-03-28','08:40:00',2.4),('14598','2014-03-28','08:45:00',2.6),('14598','2014-03-28','08:50:00',2.85),('14598','2014-03-28','08:55:00',3.14),('14598','2014-03-28','09:00:00',2.74),('14598','2014-03-28','09:05:00',2.78),('14598','2014-03-28','09:10:00',3.19),('14598','2014-03-28','09:15:00',2.12),('14598','2014-03-28','09:20:00',1.88),('14598','2014-03-28','09:25:00',1.69),('14598','2014-03-28','09:30:00',1.83),('14598','2014-03-28','09:35:00',1.63),('14598','2014-03-28','09:40:00',2.36),('14598','2014-03-28','09:45:00',3.12),('14598','2014-03-28','09:50:00',3.66),('14598','2014-03-28','09:55:00',3.68),('14598','2014-03-28','10:00:00',3.71),('14598','2014-03-28','10:05:00',3.75),('14598','2014-03-28','10:10:00',3.8),('14598','2014-03-28','10:15:00',3.86),('14598','2014-03-28','10:20:00',3.9),('14598','2014-03-28','10:25:00',3.95),('14598','2014-03-28','10:30:00',4.01),('14598','2014-03-28','10:35:00',4.03),('14598','2014-03-28','10:40:00',4.13),('14598','2014-03-28','10:45:00',4.21),('14598','2014-03-28','10:50:00',4.36),('14598','2014-03-28','10:55:00',4.46),('14598','2014-03-28','11:00:00',4.24),('14598','2014-03-28','11:05:00',4.07),('14598','2014-03-28','11:10:00',4.49),('14598','2014-03-28','11:15:00',4.55),('14598','2014-03-28','11:20:00',4.61),('14598','2014-03-28','11:25:00',4.64),('14598','2014-03-28','11:30:00',4.65),('14598','2014-03-28','11:35:00',4.68),('14598','2014-03-28','11:40:00',4.71),('14598','2014-03-28','11:45:00',4.74),('14598','2014-03-28','11:50:00',4.76),('14598','2014-03-28','11:55:00',4.78),('14598','2014-03-28','12:00:00',4.8),('14598','2014-03-28','12:05:00',4.84),('14598','2014-03-28','12:10:00',4.8),('14598','2014-03-28','12:15:00',4.87),('14598','2014-03-28','12:20:00',4.88),('14598','2014-03-28','12:25:00',4.84),('14598','2014-03-28','12:30:00',4.92),('14598','2014-03-28','12:35:00',4.91),('14598','2014-03-28','12:40:00',4.92),('14598','2014-03-28','12:45:00',4.93),('14598','2014-03-28','12:50:00',4.96),('14598','2014-03-28','12:55:00',4.94),('14598','2014-03-28','13:00:00',4.91),('14598','2014-03-28','13:05:00',4.94),('14598','2014-03-28','13:10:00',4.92),('14598','2014-03-28','13:15:00',4.9),('14598','2014-03-28','13:20:00',4.36),('14598','2014-03-28','13:25:00',4.73),('14598','2014-03-28','13:30:00',4.77),('14598','2014-03-28','13:35:00',4.81),('14598','2014-03-28','13:40:00',4.8),('14598','2014-03-28','13:45:00',4.78),('14598','2014-03-28','13:50:00',4.73),('14598','2014-03-28','13:55:00',4.69),('14598','2014-03-28','14:00:00',4.65),('14598','2014-03-28','14:05:00',4.61),('14598','2014-03-28','14:10:00',4.59),('14598','2014-03-28','14:15:00',4.55),('14598','2014-03-28','14:20:00',4.51),('14598','2014-03-28','14:25:00',4.47),('14598','2014-03-28','14:30:00',4.42),('14598','2014-03-28','14:35:00',4.38),('14598','2014-03-28','14:40:00',4.34),('14598','2014-03-28','14:45:00',4.29),('14598','2014-03-28','14:50:00',4.21),('14598','2014-03-28','14:55:00',4.15),('14598','2014-03-28','15:00:00',4.07),('14598','2014-03-28','15:05:00',4.02),('14598','2014-03-28','15:10:00',3.93),('14598','2014-03-28','15:15:00',3.87),('14598','2014-03-28','15:20:00',3.82),('14598','2014-03-28','15:25:00',3.74),('14598','2014-03-28','15:30:00',3.68),('14598','2014-03-28','15:35:00',3.6),('14598','2014-03-28','15:40:00',3.51),('14598','2014-03-28','15:45:00',3.41),('14598','2014-03-28','15:50:00',3.34),('14598','2014-03-28','15:55:00',3.26),('14598','2014-03-28','16:00:00',3.16),('14598','2014-03-28','16:05:00',3.07),('14598','2014-03-28','16:10:00',2.96),('14598','2014-03-28','16:15:00',2.87),('14598','2014-03-28','16:20:00',2.77),('14598','2014-03-28','16:25:00',2.67),('14598','2014-03-28','16:30:00',2.56),('14598','2014-03-28','16:35:00',2.5),('14598','2014-03-28','16:40:00',2.47),('14598','2014-03-28','16:45:00',2.56),('14598','2014-03-28','16:50:00',2.59),('14598','2014-03-28','16:55:00',2.33),('14598','2014-03-28','17:00:00',1.89),('14598','2014-03-28','17:05:00',1.71),('14598','2014-03-28','17:10:00',1.58),('14598','2014-03-28','17:15:00',1.49),('14598','2014-03-28','17:20:00',1.23),('14598','2014-03-28','17:25:00',1.24),('14598','2014-03-28','17:30:00',1.1),('14598','2014-03-28','17:35:00',1.01),('14598','2013-04-11','08:30:00',1.03),('14598','2013-04-11','08:35:00',1.12),('14598','2013-04-11','08:40:00',1.24),('14598','2013-04-11','08:45:00',1.36),('14598','2013-04-11','08:50:00',1.48),('14598','2013-04-11','08:55:00',1.59),('14598','2013-04-11','09:00:00',1.7),('14598','2013-04-11','09:05:00',1.82),('14598','2013-04-11','09:10:00',1.96),('14598','2013-04-11','09:15:00',1.97),('14598','2013-04-11','09:20:00',1.92),('14598','2013-04-11','09:25:00',2.49),('14598','2013-04-11','09:30:00',2.74),('14598','2013-04-11','09:35:00',1.14),('14598','2013-04-11','09:40:00',1.65),('14598','2013-04-11','09:45:00',2.56),('14598','2013-04-11','09:50:00',3.36),('14598','2013-04-11','09:55:00',2.87),('14598','2013-04-11','10:00:00',2.7),('14598','2013-04-11','10:05:00',3.27),('14598','2013-04-11','10:10:00',2.57),('14598','2013-04-11','10:15:00',3.09),('14598','2013-04-11','10:20:00',2.96),('14598','2013-04-11','10:25:00',3.02),('14598','2013-04-11','10:30:00',3.57),('14598','2013-04-11','10:35:00',3.68),('14598','2013-04-11','10:40:00',3.79),('14598','2013-04-11','10:45:00',3.84),('14598','2013-04-11','10:50:00',3.87),('14598','2013-04-11','10:55:00',3.94),('14598','2013-04-11','11:00:00',4.01),('14598','2013-04-11','11:05:00',4.08),('14598','2013-04-11','11:10:00',4.15),('14598','2013-04-11','11:15:00',4.21),('14598','2013-04-11','11:20:00',4.27),('14598','2013-04-11','11:25:00',4.35),('14598','2013-04-11','11:30:00',4.4),('14598','2013-04-11','11:35:00',4.46),('14598','2013-04-11','11:40:00',4.52),('14598','2013-04-11','11:45:00',4.57),('14598','2013-04-11','11:50:00',4.62),('14598','2013-04-11','11:55:00',4.65),('14598','2013-04-11','12:00:00',4.69),('14598','2013-04-11','12:05:00',4.75),('14598','2013-04-11','12:10:00',4.8),('14598','2013-04-11','12:15:00',4.84),('14598','2013-04-11','12:20:00',4.82),('14598','2013-04-11','12:25:00',4.88),('14598','2013-04-11','12:30:00',4.93),('14598','2013-04-11','12:35:00',4.98),('14598','2013-04-11','12:40:00',4.99),('14598','2013-04-11','12:45:00',5.02),('14598','2013-04-11','12:50:00',5.02),('14598','2013-04-11','12:55:00',5.06),('14598','2013-04-11','13:00:00',5.07),('14598','2013-04-11','13:05:00',5.09),('14598','2013-04-11','13:10:00',5.1),('14598','2013-04-11','13:15:00',5.11),('14598','2013-04-11','13:20:00',5.11),('14598','2013-04-11','13:25:00',5.15),('14598','2013-04-11','13:30:00',5.17),('14598','2013-04-11','13:35:00',5.13),('14598','2013-04-11','13:40:00',4.84),('14598','2013-04-11','13:45:00',5.17),('14598','2013-04-11','13:50:00',5.17),('14598','2013-04-11','13:55:00',5.16),('14598','2013-04-11','14:00:00',5.15),('14598','2013-04-11','14:05:00',5.14),('14598','2013-04-11','14:10:00',5.13),('14598','2013-04-11','14:15:00',5.14),('14598','2013-04-11','14:20:00',5.11),('14598','2013-04-11','14:25:00',5.08),('14598','2013-04-11','14:30:00',5.05),('14598','2013-04-11','14:35:00',5.01),('14598','2013-04-11','14:40:00',4.99),('14598','2013-04-11','14:45:00',4.97),('14598','2013-04-11','14:50:00',4.94),('14598','2013-04-11','14:55:00',4.9),('14598','2013-04-11','15:00:00',4.85),('14598','2013-04-11','15:05:00',4.81),('14598','2013-04-11','15:10:00',4.8),('14598','2013-04-11','15:15:00',4.76),('14598','2013-04-11','15:20:00',4.7),('14598','2013-04-11','15:25:00',4.64),('14598','2013-04-11','15:30:00',4.61),('14598','2013-04-11','15:35:00',4.57),('14598','2013-04-11','15:40:00',4.52),('14598','2013-04-11','15:45:00',4.47),('14598','2013-04-11','15:50:00',4.42),('14598','2013-04-11','15:55:00',4.35),('14598','2013-04-11','16:00:00',4.28),('14598','2013-04-11','16:05:00',4.22),('14598','2013-04-11','16:10:00',4.12),('14598','2013-04-11','16:15:00',4.1),('14598','2013-04-11','16:20:00',3.95),('14598','2013-04-11','16:25:00',3.97),('14598','2013-04-11','16:30:00',3.9),('14598','2013-04-11','16:35:00',3.83),('14598','2013-04-11','16:40:00',3.75),('14598','2013-04-11','16:45:00',3.66),('14598','2013-04-11','16:50:00',3.58),('14598','2013-04-11','16:55:00',3.5),('14598','2013-04-11','17:00:00',3.4),('14598','2013-04-11','17:05:00',3.32),('14598','2013-04-11','17:10:00',3.22),('14598','2013-04-11','17:15:00',3.13),('14598','2013-04-11','17:20:00',3.03),('14598','2013-04-11','17:25:00',2.93),('14598','2013-04-11','17:30:00',2.83),('14598','2013-04-11','17:35:00',2.74),('14598','2013-04-11','17:40:00',2.61),('14598','2013-04-11','17:45:00',2.42),('14598','2013-04-11','17:50:00',2.31),('14598','2013-04-11','17:55:00',2.27),('14598','2013-04-11','18:00:00',2.07),('14598','2013-04-11','18:05:00',1.95),('14598','2013-04-11','18:10:00',1.87),('14598','2013-04-11','18:15:00',1.87),('14598','2013-04-11','18:20:00',1.73),('14598','2013-04-11','18:25:00',1.59),('14598','2013-04-11','18:30:00',1.46),('14598','2013-04-11','18:35:00',1.3),('14598','2013-04-10','08:55:00',1.57),('14598','2013-04-10','09:00:00',1.7),('14598','2013-04-10','09:05:00',1.8),('14598','2013-04-10','09:10:00',1.92),('14598','2013-04-10','09:15:00',2.02),('14598','2013-04-10','09:20:00',2.14),('14598','2013-04-10','09:25:00',2.34),('14598','2013-04-10','09:30:00',2.41),('14598','2013-04-10','09:35:00',2.53),('14598','2013-04-10','09:40:00',2.65),('14598','2013-04-10','09:45:00',2.76),('14598','2013-04-10','09:50:00',2.85),('14598','2013-04-10','09:55:00',2.91),('14598','2013-04-10','10:00:00',3.03),('14598','2013-04-10','10:05:00',3.13),('14598','2013-04-10','10:10:00',3.24),('14598','2013-04-10','10:15:00',3.33),('14598','2013-04-10','10:20:00',3.42),('14598','2013-04-10','10:25:00',3.51),('14598','2013-04-10','10:30:00',3.62),('14598','2013-04-10','10:35:00',3.73),('14598','2013-04-10','10:40:00',3.7),('14598','2013-04-10','10:45:00',3.76),('14598','2013-04-10','10:50:00',3.73),('14598','2013-04-10','10:55:00',3.61),('14598','2013-04-10','11:00:00',3.75),('14598','2013-04-10','11:05:00',3.83),('14598','2013-04-10','11:10:00',4.04),('14598','2013-04-10','11:15:00',4.22),('14598','2013-04-10','11:20:00',4.27),('14598','2013-04-10','11:25:00',4.31),('14598','2013-04-10','11:30:00',4.35),('14598','2013-04-10','11:35:00',4.43),('14598','2013-04-10','11:40:00',4.48),('14598','2013-04-10','11:45:00',4.57),('14598','2013-04-10','11:50:00',4.6),('14598','2013-04-10','11:55:00',4.66),('14598','2013-04-10','12:00:00',4.78),('14598','2013-04-10','12:05:00',4.95),('14598','2013-04-10','12:10:00',4.33),('14598','2013-04-10','12:15:00',4.99),('14598','2013-04-10','12:20:00',5.23),('14598','2013-04-10','12:25:00',5.08),('14598','2013-04-10','12:30:00',5.32),('14598','2013-04-10','12:35:00',4.98),('14598','2013-04-10','12:40:00',5.02),('14598','2013-04-10','12:45:00',5.09),('14598','2013-04-10','12:50:00',5.11),('14598','2013-04-10','12:55:00',5.21),('14598','2013-04-10','13:00:00',4.48),('14598','2013-04-10','13:05:00',5.12),('14598','2013-04-10','13:10:00',5.13),('14598','2013-04-10','13:15:00',4.82),('14598','2013-04-10','13:20:00',4.69),('14598','2013-04-10','13:25:00',5.19),('14598','2013-04-10','13:30:00',4.62),('14598','2013-04-10','13:35:00',5.13),('14598','2013-04-10','13:40:00',5.09),('14598','2013-04-10','13:45:00',5.11),('14598','2013-04-10','13:50:00',5.11),('14598','2013-04-10','13:55:00',5.1),('14598','2013-04-10','14:00:00',5.11),('14598','2013-04-10','14:05:00',4.82),('14598','2013-04-10','14:10:00',5.13),('14598','2013-04-10','14:15:00',4.96),('14598','2013-04-10','14:20:00',5.12),('14598','2013-04-10','14:25:00',5.03),('14598','2013-04-10','14:30:00',5.04),('14598','2013-04-10','14:35:00',5.08),('14598','2013-04-10','14:40:00',4.57),('14598','2013-04-10','14:45:00',5.18),('14598','2013-04-10','14:50:00',4.09),('14598','2013-04-10','14:55:00',3.49),('14598','2013-04-10','15:00:00',4.97),('14598','2013-04-10','15:05:00',5.05),('14598','2013-04-10','15:10:00',4.8),('14598','2013-04-10','15:15:00',4.75),('14598','2013-04-10','15:20:00',4.72),('14598','2013-04-10','15:25:00',4),('14598','2013-04-10','15:30:00',4.66),('14598','2013-04-10','15:35:00',4.57),('14598','2013-04-10','15:40:00',4.55),('14598','2013-04-10','15:45:00',4.54),('14598','2013-04-10','15:50:00',4.54),('14598','2013-04-10','15:55:00',3.66),('14598','2013-04-10','16:00:00',4.27),('14598','2013-04-10','16:05:00',4.22),('14598','2013-04-10','16:10:00',4.2),('14598','2013-04-10','16:15:00',4.04),('14598','2013-04-10','16:20:00',3.96),('14598','2013-04-10','16:25:00',3.9),('14598','2013-04-10','16:30:00',3.78),('14598','2013-04-10','16:35:00',3.79),('14598','2013-04-10','16:40:00',3.77),('14598','2013-04-10','16:45:00',3.6),('14598','2013-04-10','16:50:00',3.48),('14598','2013-04-10','16:55:00',3.33),('14598','2013-04-10','17:00:00',3.33),('14598','2013-04-10','17:05:00',3.23),('14598','2013-04-10','17:10:00',3.11),('14598','2013-04-10','17:15:00',3.05),('14598','2013-04-10','17:20:00',3.04),('14598','2013-04-10','17:25:00',2.86),('14598','2013-04-10','17:30:00',2.64),('14598','2013-04-10','17:35:00',2.46),('14598','2013-04-10','17:40:00',2.57),('14598','2013-04-10','17:45:00',2.41),('14598','2013-04-10','17:50:00',2.34),('14598','2013-04-10','17:55:00',2.24),('14598','2013-04-10','18:00:00',2.06),('14598','2013-04-10','18:05:00',2.01),('14598','2013-04-10','18:10:00',1.89),('14598','2013-04-10','18:15:00',1.73),('14598','2013-04-10','18:20:00',1.42),('14598','2013-04-10','18:25:00',1.49),('14598','2013-04-10','18:30:00',1.29),('14598','2013-04-09','08:35:00',1.07),('14598','2013-04-09','08:40:00',1.29),('14598','2013-04-09','08:45:00',1.23),('14598','2013-04-09','09:00:00',1.02),('14598','2013-04-09','09:05:00',1.03),('14598','2013-04-09','09:10:00',1.12),('14598','2013-04-09','09:15:00',1.59),('14598','2013-04-09','09:20:00',1.89),('14598','2013-04-09','09:25:00',1.29),('14598','2013-04-09','09:30:00',1.66),('14598','2013-04-09','09:35:00',1.91),('14598','2013-04-09','09:40:00',2.27),('14598','2013-04-09','09:45:00',2.45),('14598','2013-04-09','09:50:00',2.9),('14598','2013-04-09','09:55:00',2.99),('14598','2013-04-09','10:00:00',3.15),('14598','2013-04-09','10:05:00',3),('14598','2013-04-09','10:10:00',3.24),('14598','2013-04-09','10:15:00',3.35),('14598','2013-04-09','10:20:00',3.45),('14598','2013-04-09','10:25:00',3.54),('14598','2013-04-09','10:30:00',3.38),('14598','2013-04-09','10:35:00',3.06),('14598','2013-04-09','10:40:00',3.62),('14598','2013-04-09','10:45:00',3.87),('14598','2013-04-09','10:50:00',3.87),('14598','2013-04-09','10:55:00',4.09),('14598','2013-04-09','11:00:00',3.65),('14598','2013-04-09','11:05:00',1.89),('14598','2013-04-09','11:10:00',1.39),('14598','2013-04-09','11:15:00',4),('14598','2013-04-09','11:20:00',5.14),('14598','2013-04-09','11:25:00',3.44),('14598','2013-04-09','11:30:00',1.33),('14598','2013-04-09','11:35:00',1.48),('14598','2013-04-09','11:40:00',1.5),('14598','2013-04-09','11:45:00',1.15),('14598','2013-04-09','11:50:00',2.75),('14598','2013-04-09','11:55:00',3.24),('14598','2013-04-09','12:00:00',4),('14598','2013-04-09','12:05:00',4.89),('14598','2013-04-09','12:10:00',4.69),('14598','2013-04-09','12:15:00',3.84),('14598','2013-04-09','12:20:00',4.66),('14598','2013-04-09','12:25:00',4.95),('14598','2013-04-09','12:30:00',5.1),('14598','2013-04-09','12:35:00',5.27),('14598','2013-04-09','12:40:00',5.37),('14598','2013-04-09','12:45:00',5.19),('14598','2013-04-09','12:50:00',4.7),('14598','2013-04-09','12:55:00',5.17),('14598','2013-04-09','13:00:00',5.03),('14598','2013-04-09','13:05:00',4.49),('14598','2013-04-09','13:10:00',4.96),('14598','2013-04-09','13:15:00',5.26),('14598','2013-04-09','13:20:00',5.34),('14598','2013-04-09','13:25:00',5.14),('14598','2013-04-09','13:30:00',4.84),('14598','2013-04-09','13:35:00',4.81),('14598','2013-04-09','13:40:00',5.04),('14598','2013-04-09','13:45:00',5.19),('14598','2013-04-09','13:50:00',4.66),('14598','2013-04-09','13:55:00',4.76),('14598','2013-04-09','14:00:00',4.54),('14598','2013-04-09','14:05:00',4.23),('14598','2013-04-09','14:10:00',4.24),('14598','2013-04-09','14:15:00',4.07),('14598','2013-04-09','14:20:00',4.53),('14598','2013-04-09','14:25:00',4.47),('14598','2013-04-09','14:30:00',4.57),('14598','2013-04-09','14:35:00',4.66),('14598','2013-04-09','14:40:00',4.02),('14598','2013-04-09','14:45:00',4.67),('14598','2013-04-09','14:50:00',4.87),('14598','2013-04-09','14:55:00',4.99),('14598','2013-04-09','15:00:00',4.8),('14598','2013-04-09','15:05:00',4.87),('14598','2013-04-09','15:10:00',4.78),('14598','2013-04-09','15:15:00',4.91),('14598','2013-04-09','15:20:00',4.77),('14598','2013-04-09','15:25:00',4.78),('14598','2013-04-09','15:30:00',4.55),('14598','2013-04-09','15:35:00',4.46),('14598','2013-04-09','15:40:00',4.66),('14598','2013-04-09','15:45:00',4.32),('14598','2013-04-09','15:50:00',3.55),('14598','2013-04-09','15:55:00',3.89),('14598','2013-04-09','16:00:00',4.4),('14598','2013-04-09','16:05:00',4.15),('14598','2013-04-09','16:10:00',2.92),('14598','2013-04-09','16:15:00',3.83),('14598','2013-04-09','16:20:00',3.88),('14598','2013-04-09','16:25:00',3.43),('14598','2013-04-09','16:30:00',3.53),('14598','2013-04-09','16:35:00',3.31),('14598','2013-04-09','16:40:00',3.9),('14598','2013-04-09','16:45:00',3.14),('14598','2013-04-09','16:50:00',2.66),('14598','2013-04-09','16:55:00',3.69),('14598','2013-04-09','17:00:00',3.48),('14598','2013-04-09','17:05:00',3.34),('14598','2013-04-09','17:10:00',3.12),('14598','2013-04-09','17:15:00',3.16),('14598','2013-04-09','17:20:00',3.07),('14598','2013-04-09','17:25:00',2.76),('14598','2013-04-09','17:30:00',3.02),('14598','2013-04-09','17:35:00',2.25),('14598','2013-04-09','17:40:00',1.8),('14598','2013-04-09','17:45:00',2),('14598','2013-04-09','17:50:00',1.63),('14598','2013-04-09','17:55:00',1.85),('14598','2013-04-09','18:00:00',1.13),('14598','2013-04-09','18:05:00',1.01),('14598','2013-04-09','18:10:00',1.99),('14598','2013-04-09','18:15:00',1.64),('14598','2013-04-08','08:30:00',1.03),('14598','2013-04-08','08:35:00',1.15),('14598','2013-04-08','08:40:00',1.26),('14598','2013-04-08','08:45:00',1.41),('14598','2013-04-08','08:50:00',1.49),('14598','2013-04-08','08:55:00',1.61),('14598','2013-04-08','09:00:00',1.74),('14598','2013-04-08','09:05:00',1.86),('14598','2013-04-08','09:10:00',2.02),('14598','2013-04-08','09:15:00',2.23),('14598','2013-04-08','09:20:00',2.39),('14598','2013-04-08','09:25:00',2.74),('14598','2013-04-08','09:30:00',2.44),('14598','2013-04-08','09:35:00',1.52),('14598','2013-04-08','09:40:00',2.37),('14598','2013-04-08','09:45:00',2.68),('14598','2013-04-08','09:50:00',2.81),('14598','2013-04-08','09:55:00',2.31),('14598','2013-04-08','10:00:00',2.88),('14598','2013-04-08','10:05:00',3.11),('14598','2013-04-08','10:10:00',3.09),('14598','2013-04-08','10:15:00',3.01),('14598','2013-04-08','10:20:00',3.12),('14598','2013-04-08','10:25:00',3.27),('14598','2013-04-08','10:30:00',3.72),('14598','2013-04-08','10:35:00',3.79),('14598','2013-04-08','10:40:00',3.79),('14598','2013-04-08','10:45:00',3.81),('14598','2013-04-08','10:50:00',3.33),('14598','2013-04-08','10:55:00',2.79),('14598','2013-04-08','11:00:00',2.29),('14598','2013-04-08','11:05:00',2.17),('14598','2013-04-08','11:10:00',2.58),('14598','2013-04-08','11:15:00',3.28),('14598','2013-04-08','11:20:00',3.22),('14598','2013-04-08','11:25:00',2.99),('14598','2013-04-08','11:30:00',2.82),('14598','2013-04-08','11:35:00',3.58),('14598','2013-04-08','11:40:00',2.98),('14598','2013-04-08','11:45:00',3.08),('14598','2013-04-08','11:50:00',3.04),('14598','2013-04-08','11:55:00',3.86),('14598','2013-04-08','12:00:00',3.98),('14598','2013-04-08','12:05:00',3.45),('14598','2013-04-08','12:10:00',3.28),('14598','2013-04-08','12:15:00',3.15),('14598','2013-04-08','12:20:00',3.72),('14598','2013-04-08','12:25:00',4.18),('14598','2013-04-08','12:30:00',4.06),('14598','2013-04-08','12:35:00',3.87),('14598','2013-04-08','12:40:00',4.28),('14598','2013-04-08','12:45:00',4.04),('14598','2013-04-08','12:50:00',3.5),('14598','2013-04-08','12:55:00',3.98),('14598','2013-04-08','13:00:00',3.71),('14598','2013-04-08','13:05:00',4.19),('14598','2013-04-08','13:10:00',4.16),('14598','2013-04-08','13:15:00',4.6),('14598','2013-04-08','13:20:00',4.13),('14598','2013-04-08','13:25:00',3.7),('14598','2013-04-08','13:30:00',4.05),('14598','2013-04-08','13:35:00',4.04),('14598','2013-04-08','13:40:00',3.53),('14598','2013-04-08','13:45:00',4.35),('14598','2013-04-08','13:50:00',4.75),('14598','2013-04-08','13:55:00',4.04),('14598','2013-04-08','14:00:00',3.85),('14598','2013-04-08','14:05:00',4.07),('14598','2013-04-08','14:10:00',4.07),('14598','2013-04-08','14:15:00',4.37),('14598','2013-04-08','14:20:00',4.18),('14598','2013-04-08','14:25:00',4.97),('14598','2013-04-08','14:30:00',4.78),('14598','2013-04-08','14:35:00',5.3),('14598','2013-04-08','14:40:00',3.96),('14598','2013-04-08','14:45:00',4.71),('14598','2013-04-08','14:50:00',4.33),('14598','2013-04-08','14:55:00',4.12),('14598','2013-04-08','15:00:00',4.62),('14598','2013-04-08','15:05:00',4.63),('14598','2013-04-08','15:10:00',4.18),('14598','2013-04-08','15:15:00',4.42),('14598','2013-04-08','15:20:00',4.27),('14598','2013-04-08','15:25:00',4.5),('14598','2013-04-08','15:30:00',4.61),('14598','2013-04-08','15:35:00',4.59),('14598','2013-04-08','15:40:00',4.54),('14598','2013-04-08','15:45:00',4.5),('14598','2013-04-08','15:50:00',4.09),('14598','2013-04-08','15:55:00',3.83),('14598','2013-04-08','16:00:00',4.16),('14598','2013-04-08','16:05:00',4.31),('14598','2013-04-08','16:10:00',4.16),('14598','2013-04-08','16:15:00',4.09),('14598','2013-04-08','16:20:00',3.97),('14598','2013-04-08','16:25:00',3.93),('14598','2013-04-08','16:30:00',3.93),('14598','2013-04-08','16:35:00',3.87),('14598','2013-04-08','16:40:00',3.81),('14598','2013-04-08','16:45:00',3.74),('14598','2013-04-08','16:50:00',3.66),('14598','2013-04-08','16:55:00',3.54),('14598','2013-04-08','17:00:00',3.28),('14598','2013-04-08','17:05:00',3.14),('14598','2013-04-08','17:10:00',2.98),('14598','2013-04-08','17:15:00',2.58),('14598','2013-04-08','17:20:00',2.58),('14598','2013-04-08','17:25:00',2.15),('14598','2013-04-08','17:30:00',2.17),('14598','2013-04-08','17:35:00',2),('14598','2013-04-08','17:40:00',1.96),('14598','2013-04-08','17:45:00',1.96),('14598','2013-04-08','17:50:00',2.06),('14598','2013-04-08','18:05:00',1.55),('14598','2013-04-08','18:10:00',2.22),('14598','2013-04-08','18:15:00',1.89),('14598','2013-04-08','18:20:00',1.17),('14598','2013-04-08','18:25:00',1.17),('14598','2013-04-08','18:30:00',1.06),('14598','2013-04-07','08:40:00',1.01),('14598','2013-04-07','08:45:00',1.08),('14598','2013-04-07','08:50:00',1.22),('14598','2013-04-07','08:55:00',1.32),('14598','2013-04-07','09:00:00',1.44),('14598','2013-04-07','09:05:00',1.52),('14598','2013-04-07','09:10:00',1.58),('14598','2013-04-07','09:15:00',1.68),('14598','2013-04-07','09:20:00',1.8),('14598','2013-04-07','09:25:00',1.96),('14598','2013-04-07','09:30:00',2.08),('14598','2013-04-07','09:35:00',2.11),('14598','2013-04-07','09:40:00',2.14),('14598','2013-04-07','09:45:00',2.3),('14598','2013-04-07','09:50:00',2.47),('14598','2013-04-07','09:55:00',2.64),('14598','2013-04-07','10:00:00',2.73),('14598','2013-04-07','10:05:00',2.79),('14598','2013-04-07','10:10:00',2.89),('14598','2013-04-07','10:15:00',2.79),('14598','2013-04-07','10:20:00',2.86),('14598','2013-04-07','10:25:00',3.03),('14598','2013-04-07','10:30:00',3.28),('14598','2013-04-07','10:35:00',3.45),('14598','2013-04-07','10:40:00',3.47),('14598','2013-04-07','10:45:00',3.3),('14598','2013-04-07','10:50:00',3.37),('14598','2013-04-07','10:55:00',3.49),('14598','2013-04-07','11:00:00',3.45),('14598','2013-04-07','11:05:00',3.51),('14598','2013-04-07','11:10:00',3.37),('14598','2013-04-07','11:15:00',3.3),('14598','2013-04-07','11:20:00',3.83),('14598','2013-04-07','11:25:00',3.93),('14598','2013-04-07','11:30:00',3.9),('14598','2013-04-07','11:35:00',3.81),('14598','2013-04-07','11:40:00',3.96),('14598','2013-04-07','11:45:00',3.78),('14598','2013-04-07','11:50:00',3.68),('14598','2013-04-07','11:55:00',2.84),('14598','2013-04-07','12:00:00',2.65),('14598','2013-04-07','12:05:00',2.84),('14598','2013-04-07','12:10:00',2.8),('14598','2013-04-07','12:15:00',2.86),('14598','2013-04-07','12:20:00',2.68),('14598','2013-04-07','12:25:00',2.74),('14598','2013-04-07','12:30:00',2.73),('14598','2013-04-07','12:35:00',2.8),('14598','2013-04-07','12:40:00',3.07),('14598','2013-04-07','12:45:00',3.04),('14598','2013-04-07','12:50:00',3.22),('14598','2013-04-07','12:55:00',3.64),('14598','2013-04-07','13:00:00',4),('14598','2013-04-07','13:05:00',3.47),('14598','2013-04-07','13:10:00',3.44),('14598','2013-04-07','13:15:00',3.52),('14598','2013-04-07','13:20:00',3.91),('14598','2013-04-07','13:25:00',3.78),('14598','2013-04-07','13:30:00',3.5),('14598','2013-04-07','13:35:00',3.26),('14598','2013-04-07','13:40:00',3.17),('14598','2013-04-07','13:45:00',3.21),('14598','2013-04-07','13:50:00',3.26),('14598','2013-04-07','13:55:00',3.2),('14598','2013-04-07','14:00:00',3.23),('14598','2013-04-07','14:05:00',3.17),('14598','2013-04-07','14:10:00',3.32),('14598','2013-04-07','14:15:00',3.51),('14598','2013-04-07','14:20:00',3.65),('14598','2013-04-07','14:25:00',3.83),('14598','2013-04-07','14:30:00',3.8),('14598','2013-04-07','14:35:00',3.61),('14598','2013-04-07','14:40:00',3.61),('14598','2013-04-07','14:45:00',3.77),('14598','2013-04-07','14:50:00',3.84),('14598','2013-04-07','14:55:00',3.82),('14598','2013-04-07','15:00:00',3.73),('14598','2013-04-07','15:05:00',3.56),('14598','2013-04-07','15:10:00',3.24),('14598','2013-04-07','15:15:00',3.05),('14598','2013-04-07','15:20:00',3.18),('14598','2013-04-07','15:25:00',3.56),('14598','2013-04-07','15:30:00',4.13),('14598','2013-04-07','15:35:00',4.5),('14598','2013-04-07','15:40:00',4.32),('14598','2013-04-07','15:45:00',4.32),('14598','2013-04-07','15:50:00',4.45),('14598','2013-04-07','15:55:00',4.49),('14598','2013-04-07','16:00:00',4.49),('14598','2013-04-07','16:05:00',4.41),('14598','2013-04-07','16:10:00',4.16),('14598','2013-04-07','16:15:00',3.9),('14598','2013-04-07','16:20:00',3.74),('14598','2013-04-07','16:25:00',3.65),('14598','2013-04-07','16:30:00',3.6),('14598','2013-04-07','16:35:00',3.56),('14598','2013-04-07','16:40:00',3.54),('14598','2013-04-07','16:45:00',3.48),('14598','2013-04-07','16:50:00',3.44),('14598','2013-04-07','16:55:00',3.35),('14598','2013-04-07','17:00:00',3.31),('14598','2013-04-07','17:05:00',3.27),('14598','2013-04-07','17:10:00',3.22),('14598','2013-04-07','17:15:00',3.11),('14598','2013-04-07','17:20:00',3.01),('14598','2013-04-07','17:25:00',2.86),('14598','2013-04-07','17:30:00',2.72),('14598','2013-04-07','17:35:00',2.23),('14598','2013-04-07','17:40:00',1.44),('14598','2013-04-06','08:35:00',1.01),('14598','2013-04-06','08:40:00',1.08),('14598','2013-04-06','08:45:00',1.21),('14598','2013-04-06','08:50:00',1.33),('14598','2013-04-06','08:55:00',1.44),('14598','2013-04-06','09:00:00',1.56),('14598','2013-04-06','09:05:00',1.66),('14598','2013-04-06','09:10:00',1.75),('14598','2013-04-06','09:15:00',1.89),('14598','2013-04-06','09:20:00',2),('14598','2013-04-06','09:25:00',2.11),('14598','2013-04-06','09:30:00',2.2),('14598','2013-04-06','09:35:00',2.32),('14598','2013-04-06','09:40:00',2.49),('14598','2013-04-06','09:45:00',2.55),('14598','2013-04-06','09:50:00',2.67),('14598','2013-04-06','09:55:00',1.94),('14598','2013-04-06','10:00:00',2.81),('14598','2013-04-06','10:05:00',2.21),('14598','2013-04-06','10:10:00',2.89),('14598','2013-04-06','10:15:00',3.27),('14598','2013-04-06','10:20:00',3.34),('14598','2013-04-06','10:25:00',3.43),('14598','2013-04-06','10:30:00',3.41),('14598','2013-04-06','10:35:00',3.5),('14598','2013-04-06','10:40:00',3.53),('14598','2013-04-06','10:45:00',3.54),('14598','2013-04-06','10:50:00',3.57),('14598','2013-04-06','10:55:00',3.63),('14598','2013-04-06','11:00:00',3.71),('14598','2013-04-06','11:05:00',3.76),('14598','2013-04-06','11:10:00',3.8),('14598','2013-04-06','11:15:00',3.86),('14598','2013-04-06','11:20:00',3.97),('14598','2013-04-06','11:25:00',4.09),('14598','2013-04-06','11:30:00',4.12),('14598','2013-04-06','11:35:00',4.19),('14598','2013-04-06','11:40:00',4.25),('14598','2013-04-06','11:45:00',4.3),('14598','2013-04-06','11:50:00',4.35),('14598','2013-04-06','11:55:00',4.39),('14598','2013-04-06','12:00:00',4.44),('14598','2013-04-06','12:05:00',4.48),('14598','2013-04-06','12:10:00',4.51),('14598','2013-04-06','12:15:00',4.58),('14598','2013-04-06','12:20:00',4.62),('14598','2013-04-06','12:25:00',4.64),('14598','2013-04-06','12:30:00',4.66),('14598','2013-04-06','12:35:00',4.71),('14598','2013-04-06','12:40:00',4.74),('14598','2013-04-06','12:45:00',4.78),('14598','2013-04-06','12:50:00',4.8),('14598','2013-04-06','12:55:00',4.8),('14598','2013-04-06','13:00:00',4.86),('14598','2013-04-06','13:05:00',4.87),('14598','2013-04-06','13:10:00',4.88),('14598','2013-04-06','13:15:00',4.9),('14598','2013-04-06','13:20:00',4.9),('14598','2013-04-06','13:25:00',4.91),('14598','2013-04-06','13:30:00',4.91),('14598','2013-04-06','13:35:00',4.93),('14598','2013-04-06','13:40:00',4.95),('14598','2013-04-06','13:45:00',4.94),('14598','2013-04-06','13:50:00',4.92),('14598','2013-04-06','13:55:00',4.89),('14598','2013-04-06','14:00:00',4.91),('14598','2013-04-06','14:05:00',4.91),('14598','2013-04-06','14:10:00',4.92),('14598','2013-04-06','14:15:00',4.89),('14598','2013-04-06','14:20:00',4.88),('14598','2013-04-06','14:25:00',4.86),('14598','2013-04-06','14:30:00',4.82),('14598','2013-04-06','14:35:00',4.83),('14598','2013-04-06','14:40:00',4.79),('14598','2013-04-06','14:45:00',4.75),('14598','2013-04-06','14:50:00',4.67),('14598','2013-04-06','14:55:00',4.7),('14598','2013-04-06','15:00:00',4.61),('14598','2013-04-06','15:05:00',4.56),('14598','2013-04-06','15:10:00',4.55),('14598','2013-04-06','15:15:00',4.5),('14598','2013-04-06','15:20:00',4.38),('14598','2013-04-06','15:25:00',4.42),('14598','2013-04-06','15:30:00',4.06),('14598','2013-04-06','15:35:00',3.84),('14598','2013-04-06','15:40:00',4.1),('14598','2013-04-06','15:45:00',3.71),('14598','2013-04-06','15:50:00',3.71),('14598','2013-04-06','15:55:00',3.39),('14598','2013-04-06','16:00:00',2.87),('14598','2013-04-06','16:05:00',3.26),('14598','2013-04-06','16:10:00',3.24),('14598','2013-04-06','16:15:00',3.16),('14598','2013-04-06','16:20:00',2.5),('14598','2013-04-06','16:25:00',2.85),('14598','2013-04-06','16:30:00',2.85),('14598','2013-04-06','16:35:00',1.94),('14598','2013-04-06','16:40:00',2.29),('14598','2013-04-06','16:45:00',2.91),('14598','2013-04-06','16:50:00',3.12),('14598','2013-04-06','16:55:00',2.67),('14598','2013-04-06','17:00:00',2.33),('14598','2013-04-06','17:05:00',2.14),('14598','2013-04-06','17:10:00',1.83),('14598','2013-04-06','17:15:00',1.49),('14598','2013-04-06','17:20:00',1.52),('14598','2013-04-06','17:25:00',1.29),('14598','2013-04-06','17:30:00',1.17),('14598','2013-04-06','17:35:00',1.12),('14598','2013-04-06','17:40:00',1.08),('14598','2013-04-06','17:45:00',1.11),('14598','2013-04-06','17:50:00',1.27),('14598','2013-04-06','17:55:00',1.06),('14598','2013-04-05','08:20:00',1.18),('14598','2013-04-05','08:25:00',1.15),('14598','2013-04-05','08:45:00',1.15),('14598','2013-04-05','08:50:00',1.26),('14598','2013-04-05','08:55:00',1.38),('14598','2013-04-05','09:00:00',1.49),('14598','2013-04-05','09:05:00',1.56),('14598','2013-04-05','09:10:00',1.66),('14598','2013-04-05','09:15:00',1.81),('14598','2013-04-05','09:20:00',1.95),('14598','2013-04-05','09:25:00',2.06),('14598','2013-04-05','09:30:00',2.15),('14598','2013-04-05','09:35:00',2.26),('14598','2013-04-05','09:40:00',2.36),('14598','2013-04-05','09:45:00',2.53),('14598','2013-04-05','09:50:00',2.87),('14598','2013-04-05','09:55:00',2.08),('14598','2013-04-05','10:00:00',2.72),('14598','2013-04-05','10:05:00',2.89),('14598','2013-04-05','10:10:00',2.96),('14598','2013-04-05','10:15:00',2.83),('14598','2013-04-05','10:20:00',3.12),('14598','2013-04-05','10:25:00',3.21),('14598','2013-04-05','10:30:00',3.3),('14598','2013-04-05','10:35:00',3.39),('14598','2013-04-05','10:40:00',3.45),('14598','2013-04-05','10:45:00',3.48),('14598','2013-04-05','10:50:00',3.63),('14598','2013-04-05','10:55:00',3.71),('14598','2013-04-05','11:00:00',3.76),('14598','2013-04-05','11:05:00',3.82),('14598','2013-04-05','11:10:00',3.89),('14598','2013-04-05','11:15:00',3.97),('14598','2013-04-05','11:20:00',4.04),('14598','2013-04-05','11:25:00',4.11),('14598','2013-04-05','11:30:00',4.16),('14598','2013-04-05','11:35:00',4.21),('14598','2013-04-05','11:40:00',4.26),('14598','2013-04-05','11:45:00',4.31),('14598','2013-04-05','11:50:00',4.39),('14598','2013-04-05','11:55:00',4.12),('14598','2013-04-05','12:00:00',3.69),('14598','2013-04-05','12:05:00',4.48),('14598','2013-04-05','12:10:00',2.67),('14598','2013-04-05','12:15:00',1.16),('14598','2013-04-05','12:20:00',2.6),('14598','2013-04-05','12:25:00',5.05),('14598','2013-04-05','12:30:00',4.88),('14598','2013-04-05','12:35:00',4.04),('14598','2013-04-05','12:40:00',4.82),('14598','2013-04-05','12:45:00',4.83),('14598','2013-04-05','12:50:00',4.85),('14598','2013-04-05','12:55:00',4.87),('14598','2013-04-05','13:00:00',4.88),('14598','2013-04-05','13:05:00',4.91),('14598','2013-04-05','13:10:00',4.91),('14598','2013-04-05','13:15:00',4.89),('14598','2013-04-05','13:20:00',4.93),('14598','2013-04-05','13:25:00',4.96),('14598','2013-04-05','13:30:00',4.95),('14598','2013-04-05','13:35:00',4.95),('14598','2013-04-05','13:40:00',4.94),('14598','2013-04-05','13:45:00',4.93),('14598','2013-04-05','13:50:00',4.94),('14598','2013-04-05','13:55:00',4.48),('14598','2013-04-05','14:00:00',4.06),('14598','2013-04-05','14:05:00',4.88),('14598','2013-04-05','14:10:00',2.92),('14598','2013-04-05','14:15:00',2.42),('14598','2013-04-05','14:20:00',2.57),('14598','2013-04-05','14:25:00',1.91),('14598','2013-04-05','14:30:00',1.43),('14598','2013-04-05','14:35:00',2.02),('14598','2013-04-05','14:40:00',2.41),('14598','2013-04-05','14:45:00',2.49),('14598','2013-04-05','14:50:00',2.05),('14598','2013-04-05','14:55:00',1.85),('14598','2013-04-05','15:00:00',1.71),('14598','2013-04-05','15:05:00',1.55),('14598','2013-04-05','15:10:00',1.85),('14598','2013-04-05','15:15:00',1.98),('14598','2013-04-05','15:20:00',1.98),('14598','2013-04-05','15:25:00',1.42),('14598','2013-04-05','15:30:00',1.22),('14598','2013-04-05','15:35:00',1.72),('14598','2013-04-05','15:40:00',4.02),('14598','2013-04-05','15:45:00',2.63),('14598','2013-04-05','15:50:00',2.84),('14598','2013-04-05','15:55:00',3.03),('14598','2013-04-05','16:00:00',1.82),('14598','2013-04-05','16:05:00',2.55),('14598','2013-04-05','16:10:00',3.14),('14598','2013-04-05','16:15:00',4.37),('14598','2013-04-05','16:20:00',3.92),('14598','2013-04-05','16:25:00',3.7),('14598','2013-04-05','16:30:00',3.85),('14598','2013-04-05','16:35:00',3.52),('14598','2013-04-05','16:40:00',3.46),('14598','2013-04-05','16:45:00',3.39),('14598','2013-04-05','16:50:00',3.31),('14598','2013-04-05','16:55:00',3.24),('14598','2013-04-05','17:00:00',2.71),('14598','2013-04-05','17:05:00',2.27),('14598','2013-04-05','17:10:00',3.18),('14598','2013-04-05','17:15:00',2.95),('14598','2013-04-05','17:20:00',2.73),('14598','2013-04-05','17:25:00',2.64),('14598','2013-04-05','17:30:00',2.57),('14598','2013-04-05','17:35:00',2.67),('14598','2013-04-05','17:40:00',1.61),('14598','2013-04-05','17:45:00',2.1),('14598','2013-04-05','17:50:00',2.14),('14598','2013-04-05','17:55:00',2.03),('14598','2013-04-05','18:00:00',1.88),('14598','2013-04-05','18:05:00',1.75),('14598','2013-04-05','18:10:00',1.68),('14598','2013-04-05','18:15:00',1.69),('14598','2013-04-05','18:25:00',1.55),('14598','2013-04-05','18:30:00',1.28),('14598','2013-04-05','18:35:00',1.13),('14598','2013-04-04','08:40:00',1.02),('14598','2013-04-04','08:45:00',1.3),('14598','2013-04-04','08:50:00',1.38),('14598','2013-04-04','08:55:00',1.18),('14598','2013-04-04','09:00:00',1.1),('14598','2013-04-04','09:15:00',1.31),('14598','2013-04-04','09:20:00',2.03),('14598','2013-04-04','09:25:00',2.21),('14598','2013-04-04','09:30:00',1.63),('14598','2013-04-04','09:35:00',1.01),('14598','2013-04-04','09:45:00',1.22),('14598','2013-04-04','09:50:00',1.36),('14598','2013-04-04','09:55:00',1.07),('14598','2013-04-04','10:00:00',1.01),('14598','2013-04-04','10:05:00',1.62),('14598','2013-04-04','10:10:00',3.76),('14598','2013-04-04','10:15:00',3.02),('14598','2013-04-04','10:20:00',1.64),('14598','2013-04-04','10:25:00',3.92),('14598','2013-04-04','10:30:00',1.88),('14598','2013-04-04','10:35:00',1.95),('14598','2013-04-04','10:40:00',3.47),('14598','2013-04-04','10:45:00',3.62),('14598','2013-04-04','10:50:00',1.31),('14598','2013-04-04','10:55:00',1.11),('14598','2013-04-04','11:00:00',1.61),('14598','2013-04-04','11:05:00',1.79),('14598','2013-04-04','11:10:00',1.27),('14598','2013-04-04','11:15:00',1.26),('14598','2013-04-04','11:20:00',1.59),('14598','2013-04-04','11:25:00',2.12),('14598','2013-04-04','11:30:00',2.55),('14598','2013-04-04','11:35:00',3.36),('14598','2013-04-04','11:40:00',4.36),('14598','2013-04-04','11:45:00',3.09),('14598','2013-04-04','11:50:00',3.46),('14598','2013-04-04','11:55:00',4.3),('14598','2013-04-04','12:00:00',3.61),('14598','2013-04-04','12:05:00',3.23),('14598','2013-04-04','12:10:00',2.68),('14598','2013-04-04','12:15:00',2.46),('14598','2013-04-04','12:20:00',2.27),('14598','2013-04-04','12:25:00',3.55),('14598','2013-04-04','12:30:00',4.78),('14598','2013-04-04','12:35:00',4.33),('14598','2013-04-04','12:40:00',3.77),('14598','2013-04-04','12:45:00',4.17),('14598','2013-04-04','12:50:00',3.96),('14598','2013-04-04','12:55:00',4.64),('14598','2013-04-04','13:00:00',4.85),('14598','2013-04-04','13:05:00',4.7),('14598','2013-04-04','13:10:00',4.4),('14598','2013-04-04','13:15:00',4.89),('14598','2013-04-04','13:20:00',4.66),('14598','2013-04-04','13:25:00',4.64),('14598','2013-04-04','13:30:00',4.75),('14598','2013-04-04','13:35:00',4.17),('14598','2013-04-04','13:40:00',3.21),('14598','2013-04-04','13:45:00',3.24),('14598','2013-04-04','13:50:00',3.88),('14598','2013-04-04','13:55:00',4.11),('14598','2013-04-04','14:00:00',4.92),('14598','2013-04-04','14:05:00',4.69),('14598','2013-04-04','14:10:00',4.64),('14598','2013-04-04','14:15:00',4.6),('14598','2013-04-04','14:20:00',4.61),('14598','2013-04-04','14:25:00',4.57),('14598','2013-04-04','14:30:00',4.5),('14598','2013-04-04','14:35:00',4.48),('14598','2013-04-04','14:40:00',4.47),('14598','2013-04-04','14:45:00',4.47),('14598','2013-04-04','14:50:00',4.46),('14598','2013-04-04','14:55:00',4.43),('14598','2013-04-04','15:00:00',4.42),('14598','2013-04-04','15:05:00',4.38),('14598','2013-04-04','15:10:00',4.35),('14598','2013-04-04','15:15:00',4.26),('14598','2013-04-04','15:20:00',4.21),('14598','2013-04-04','15:25:00',4.18),('14598','2013-04-04','15:30:00',4.02),('14598','2013-04-04','15:35:00',3.95),('14598','2013-04-04','15:40:00',3.92),('14598','2013-04-04','15:45:00',3.94),('14598','2013-04-04','15:50:00',3.88),('14598','2013-04-04','15:55:00',3.78),('14598','2013-04-04','16:00:00',3.46),('14598','2013-04-04','16:05:00',2.8),('14598','2013-04-04','16:10:00',1.94),('14598','2013-04-04','16:15:00',2.18),('14598','2013-04-04','16:20:00',2.84),('14598','2013-04-04','16:25:00',2.09),('14598','2013-04-04','16:30:00',1.72),('14598','2013-04-04','16:35:00',2.03),('14598','2013-04-04','16:40:00',2.14),('14598','2013-04-04','16:45:00',2.19),('14598','2013-04-04','16:50:00',1.86),('14598','2013-04-04','16:55:00',1.83),('14598','2013-04-04','17:00:00',1.49),('14598','2013-04-04','17:05:00',1.47),('14598','2013-04-04','17:10:00',1.36),('14598','2013-04-04','17:15:00',1.36),('14598','2013-04-04','17:20:00',1.4),('14598','2013-04-04','17:35:00',1.15),('14598','2013-04-04','17:40:00',1.16),('14598','2013-04-04','17:45:00',1.53),('14598','2013-04-04','17:50:00',1.47),('14598','2013-04-04','17:55:00',1.51),('14598','2013-04-04','18:00:00',1.31),('14598','2013-04-03','08:45:00',1.12),('14598','2013-04-03','08:50:00',1.53),('14598','2013-04-03','08:55:00',1.83),('14598','2013-04-03','09:00:00',1.98),('14598','2013-04-03','09:05:00',2.26),('14598','2013-04-03','09:10:00',1.96),('14598','2013-04-03','09:15:00',1.57),('14598','2013-04-03','09:20:00',2.65),('14598','2013-04-03','09:25:00',1.21),('14598','2013-04-03','09:30:00',1.88),('14598','2013-04-03','09:35:00',1.2),('14598','2013-04-03','09:40:00',2.18),('14598','2013-04-03','09:45:00',1.91),('14598','2013-04-03','09:50:00',2.03),('14598','2013-04-03','09:55:00',2.73),('14598','2013-04-03','10:00:00',2.5),('14598','2013-04-03','10:05:00',3.42),('14598','2013-04-03','10:10:00',2.03),('14598','2013-04-03','10:15:00',2.17),('14598','2013-04-03','10:20:00',2.09),('14598','2013-04-03','10:25:00',1.74),('14598','2013-04-03','10:30:00',1.94),('14598','2013-04-03','10:35:00',2),('14598','2013-04-03','10:40:00',2.25),('14598','2013-04-03','10:45:00',2.75),('14598','2013-04-03','10:50:00',4.15),('14598','2013-04-03','10:55:00',4.52),('14598','2013-04-03','11:00:00',4.74),('14598','2013-04-03','11:05:00',4.68),('14598','2013-04-03','11:10:00',2.7),('14598','2013-04-03','11:15:00',2.25),('14598','2013-04-03','11:20:00',2.2),('14598','2013-04-03','11:25:00',2.15),('14598','2013-04-03','11:30:00',2.54),('14598','2013-04-03','11:35:00',3.65),('14598','2013-04-03','11:40:00',3.47),('14598','2013-04-03','11:45:00',3.6),('14598','2013-04-03','11:50:00',4.57),('14598','2013-04-03','11:55:00',4.64),('14598','2013-04-03','12:00:00',4.75),('14598','2013-04-03','12:05:00',3.66),('14598','2013-04-03','12:10:00',2.37),('14598','2013-04-03','12:15:00',4.86),('14598','2013-04-03','12:20:00',3.78),('14598','2013-04-03','12:25:00',5.05),('14598','2013-04-03','12:30:00',4.94),('14598','2013-04-03','12:35:00',4.99),('14598','2013-04-03','12:40:00',5.01),('14598','2013-04-03','12:45:00',5.06),('14598','2013-04-03','12:50:00',5.07),('14598','2013-04-03','12:55:00',5.15),('14598','2013-04-03','13:05:00',4.93),('14598','2013-04-03','13:10:00',4.56),('14598','2013-04-03','13:15:00',5.86),('14598','2013-04-03','13:20:00',5.58),('14598','2013-04-03','13:25:00',5.56),('14598','2013-04-03','13:30:00',5.39),('14598','2013-04-03','13:35:00',5.35),('14598','2013-04-03','13:40:00',5.39),('14598','2013-04-03','13:45:00',5.37),('14598','2013-04-03','13:50:00',5.27),('14598','2013-04-03','13:55:00',5.24),('14598','2013-04-03','14:00:00',5.2),('14598','2013-04-03','14:05:00',5.22),('14598','2013-04-03','14:10:00',5.15),('14598','2013-04-03','14:15:00',4.04),('14598','2013-04-03','14:20:00',5.27),('14598','2013-04-03','14:25:00',5.19),('14598','2013-04-03','14:30:00',5.11),('14598','2013-04-03','14:35:00',5.08),('14598','2013-04-03','14:40:00',4.94),('14598','2013-04-03','14:45:00',5.02),('14598','2013-04-03','14:50:00',4.97),('14598','2013-04-03','14:55:00',4.92),('14598','2013-04-03','15:00:00',4.9),('14598','2013-04-03','15:05:00',4.86),('14598','2013-04-03','15:10:00',4.83),('14598','2013-04-03','15:15:00',4.78),('14598','2013-04-03','15:20:00',4.75),('14598','2013-04-03','15:25:00',4.72),('14598','2013-04-03','15:30:00',4.65),('14598','2013-04-03','15:35:00',4.6),('14598','2013-04-03','15:40:00',4.54),('14598','2013-04-03','15:45:00',4.5),('14598','2013-04-03','15:50:00',4.42),('14598','2013-04-03','15:55:00',4.32),('14598','2013-04-03','16:00:00',4.32),('14598','2013-04-03','16:05:00',4.24),('14598','2013-04-03','16:10:00',4.17),('14598','2013-04-03','16:15:00',4.1),('14598','2013-04-03','16:20:00',4.01),('14598','2013-04-03','16:25:00',3.94),('14598','2013-04-03','16:30:00',3.87),('14598','2013-04-03','16:35:00',3.77),('14598','2013-04-03','16:40:00',3.69),('14598','2013-04-03','16:45:00',3.61),('14598','2013-04-03','16:50:00',3.53),('14598','2013-04-03','16:55:00',3.43),('14598','2013-04-03','17:00:00',3.35),('14598','2013-04-03','17:05:00',3.24),('14598','2013-04-03','17:10:00',3.14),('14598','2013-04-03','17:15:00',3.04),('14598','2013-04-03','17:20:00',2.95),('14598','2013-04-03','17:25:00',2.84),('14598','2013-04-03','17:30:00',2.7),('14598','2013-04-03','17:35:00',2.62),('14598','2013-04-03','17:40:00',2.51),('14598','2013-04-03','17:45:00',2.42),('14598','2013-04-03','17:50:00',2.3),('14598','2013-04-03','17:55:00',2.18),('14598','2013-04-03','18:00:00',2.05),('14598','2013-04-03','18:05:00',1.93),('14598','2013-04-03','18:10:00',1.81),('14598','2013-04-03','18:15:00',1.69),('14598','2013-04-03','18:20:00',1.56),('14598','2013-04-03','18:25:00',1.42),('14598','2013-04-03','18:30:00',1.3),('14598','2013-04-03','18:35:00',1.17),('14598','2013-04-03','18:40:00',1.04),('14598','2013-04-02','08:10:00',1.15),('14598','2013-04-02','08:15:00',1.15),('14598','2013-04-02','08:40:00',1.03),('14598','2013-04-02','08:45:00',1.11),('14598','2013-04-02','08:50:00',1.32),('14598','2013-04-02','09:00:00',1.28),('14598','2013-04-02','09:05:00',1.27),('14598','2013-04-02','09:10:00',1.66),('14598','2013-04-02','09:15:00',1.75),('14598','2013-04-02','09:20:00',1.96),('14598','2013-04-02','09:25:00',2.46),('14598','2013-04-02','09:30:00',1.87),('14598','2013-04-02','09:35:00',2.29),('14598','2013-04-02','09:40:00',2.39),('14598','2013-04-02','09:45:00',2.51),('14598','2013-04-02','09:50:00',2.62),('14598','2013-04-02','09:55:00',2.38),('14598','2013-04-02','10:00:00',2.55),('14598','2013-04-02','10:05:00',3),('14598','2013-04-02','10:10:00',2.15),('14598','2013-04-02','10:15:00',3.3),('14598','2013-04-02','10:20:00',3.51),('14598','2013-04-02','10:25:00',3.49),('14598','2013-04-02','10:30:00',3.44),('14598','2013-04-02','10:35:00',3.58),('14598','2013-04-02','10:40:00',3.89),('14598','2013-04-02','10:45:00',2.45),('14598','2013-04-02','10:50:00',2.21),('14598','2013-04-02','10:55:00',2.41),('14598','2013-04-02','11:00:00',1.24),('14598','2013-04-02','11:05:00',2.47),('14598','2013-04-02','11:10:00',4.4),('14598','2013-04-02','11:15:00',4.46),('14598','2013-04-02','11:20:00',4.22),('14598','2013-04-02','11:25:00',3.37),('14598','2013-04-02','11:30:00',4.2),('14598','2013-04-02','11:35:00',1.97),('14598','2013-04-02','11:40:00',3.68),('14598','2013-04-02','11:45:00',4.97),('14598','2013-04-02','11:50:00',3.96),('14598','2013-04-02','11:55:00',2.05),('14598','2013-04-02','12:00:00',3.43),('14598','2013-04-02','12:05:00',3.27),('14598','2013-04-02','12:10:00',3.03),('14598','2013-04-02','12:15:00',4.17),('14598','2013-04-02','12:20:00',5.19),('14598','2013-04-02','12:25:00',3.84),('14598','2013-04-02','12:30:00',3),('14598','2013-04-02','12:35:00',3.15),('14598','2013-04-02','12:40:00',1.96),('14598','2013-04-02','12:45:00',2.12),('14598','2013-04-02','12:50:00',2.1),('14598','2013-04-02','12:55:00',2.59),('14598','2013-04-02','13:00:00',2.64),('14598','2013-04-02','13:05:00',1.29),('14598','2013-04-02','13:10:00',1.28),('14598','2013-04-02','13:15:00',1.27),('14598','2013-04-02','13:20:00',1.06),('14598','2013-04-02','13:25:00',1.15),('14598','2013-04-02','13:30:00',2.11),('14598','2013-04-02','13:35:00',4.74),('14598','2013-04-02','13:40:00',5.42),('14598','2013-04-02','13:45:00',5.22),('14598','2013-04-02','13:50:00',4.49),('14598','2013-04-02','13:55:00',3.25),('14598','2013-04-02','14:00:00',1.45),('14598','2013-04-02','14:05:00',1.8),('14598','2013-04-02','14:10:00',2),('14598','2013-04-02','14:15:00',4.51),('14598','2013-04-02','14:20:00',3.09),('14598','2013-04-02','14:25:00',4.62),('14598','2013-04-02','14:30:00',3.7),('14598','2013-04-02','14:35:00',2.57),('14598','2013-04-02','14:40:00',1.95),('14598','2013-04-02','14:45:00',1.94),('14598','2013-04-02','14:50:00',2.6),('14598','2013-04-02','14:55:00',2.37),('14598','2013-04-02','15:00:00',1.84),('14598','2013-04-02','15:05:00',1.4),('14598','2013-04-02','15:15:00',1.34),('14598','2013-04-02','15:30:00',1.05),('14598','2013-04-02','15:45:00',1.03),('14598','2013-04-02','15:50:00',1.09),('14598','2013-04-02','16:00:00',1.11),('14598','2013-04-02','16:05:00',1.58),('14598','2013-04-02','16:10:00',1.45),('14598','2013-04-02','16:15:00',1.2),('14598','2013-04-02','17:15:00',1.3),('14598','2013-04-02','17:20:00',1.14),('14598','2013-04-02','17:30:00',1.74),('14598','2013-04-02','17:35:00',2.43),('14598','2013-04-02','17:40:00',2.24),('14598','2013-04-02','17:45:00',1.01),('14598','2014-05-02','07:45:00',1.08),('14598','2014-05-02','08:25:00',1.09),('14598','2014-05-02','08:30:00',1.38),('14598','2014-05-02','08:35:00',1.41),('14598','2014-05-02','08:40:00',1.18),('14598','2014-05-02','08:45:00',1.19),('14598','2014-05-02','08:50:00',1.28),('14598','2014-05-02','08:55:00',1.3),('14598','2014-05-02','09:00:00',1.33),('14598','2014-05-02','09:05:00',1.86),('14598','2014-05-02','09:10:00',1.85),('14598','2014-05-02','09:15:00',1.54),('14598','2014-05-02','09:20:00',1.51),('14598','2014-05-02','09:25:00',1.75),('14598','2014-05-02','09:30:00',1.57),('14598','2014-05-02','09:35:00',1.21),('14598','2014-05-02','10:10:00',1.02),('14598','2014-05-02','10:15:00',1.09),('14598','2014-05-02','10:20:00',1.23),('14598','2014-05-02','10:25:00',1.4),('14598','2014-05-02','10:30:00',1.4),('14598','2014-05-02','10:35:00',1.33),('14598','2014-05-02','10:40:00',1.25),('14598','2014-05-02','10:45:00',1.31),('14598','2014-05-02','10:50:00',1.09),('14598','2014-05-02','11:10:00',1.16),('14598','2014-05-02','11:15:00',1.36),('14598','2014-05-02','11:20:00',1.5),('14598','2014-05-02','11:25:00',1.5),('14598','2014-05-02','11:30:00',1.51),('14598','2014-05-02','11:35:00',1.87),('14598','2014-05-02','11:40:00',2.24),('14598','2014-05-02','11:45:00',2.26),('14598','2014-05-02','11:50:00',2.29),('14598','2014-05-02','11:55:00',2.54),('14598','2014-05-02','12:00:00',2.45),('14598','2014-05-02','12:05:00',2.24),('14598','2014-05-02','12:10:00',1.74),('14598','2014-05-02','12:15:00',1.77),('14598','2014-05-02','12:20:00',2.1),('14598','2014-05-02','12:25:00',2.07),('14598','2014-05-02','12:30:00',2.26),('14598','2014-05-02','12:35:00',2.16),('14598','2014-05-02','12:40:00',1.8),('14598','2014-05-02','12:45:00',2.1),('14598','2014-05-02','12:50:00',3),('14598','2014-05-02','12:55:00',3.34),('14598','2014-05-02','13:00:00',3.78),('14598','2014-05-02','13:05:00',3.27),('14598','2014-05-02','13:10:00',3.98),('14598','2014-05-02','13:15:00',4.69),('14598','2014-05-02','13:20:00',5.3),('14598','2014-05-02','13:25:00',3.79),('14598','2014-05-02','13:30:00',4.46),('14598','2014-05-02','13:35:00',3.01),('14598','2014-05-02','13:40:00',3.62),('14598','2014-05-02','13:45:00',2.7),('14598','2014-05-02','13:50:00',2.98),('14598','2014-05-02','13:55:00',3.55),('14598','2014-05-02','14:00:00',4.89),('14598','2014-05-02','14:05:00',4.37),('14598','2014-05-02','14:10:00',4.18),('14598','2014-05-02','14:15:00',1.32),('14598','2014-05-02','14:20:00',1.15),('14598','2014-05-02','14:30:00',1.21),('14598','2014-05-02','14:35:00',1.88),('14598','2014-05-02','14:40:00',3.14),('14598','2014-05-02','14:45:00',3),('14598','2014-05-02','14:50:00',2.13),('14598','2014-05-02','14:55:00',1.9),('14598','2014-05-02','15:00:00',1.25),('14598','2014-05-02','15:05:00',1.32),('14598','2014-05-02','15:10:00',1.02),('14598','2014-05-02','15:15:00',1.17),('14598','2014-05-02','15:20:00',1.46),('14598','2014-05-02','15:25:00',1.75),('14598','2014-05-02','15:30:00',1.74),('14598','2014-05-02','15:45:00',1.76),('14598','2014-05-02','15:50:00',2.2),('14598','2014-05-02','15:55:00',2.47),('14598','2014-05-02','16:00:00',1.99),('14598','2014-05-02','16:05:00',1.91),('14598','2014-05-02','16:10:00',2.14),('14598','2014-05-02','16:15:00',1.85),('14598','2014-05-02','16:20:00',1.76),('14598','2014-05-02','16:25:00',1.35),('14598','2014-05-02','16:30:00',1.04),('14598','2014-05-02','16:35:00',1.3),('14598','2014-05-02','16:40:00',1.6),('14598','2014-05-02','16:45:00',1.92),('14598','2014-05-02','16:50:00',2.17),('14598','2014-05-02','16:55:00',1.52),('14598','2014-03-27','09:55:00',1.21),('14598','2014-03-27','10:00:00',1.59),('14598','2014-03-27','10:05:00',1.66),('14598','2014-03-27','10:10:00',1.71),('14598','2014-03-27','10:15:00',1.71),('14598','2014-03-27','10:20:00',1.98),('14598','2014-03-27','10:25:00',2.47),('14598','2014-03-27','10:30:00',3.32),('14598','2014-03-27','10:35:00',3.85),('14598','2014-03-27','10:40:00',3.84),('14598','2014-03-27','10:45:00',4.52),('14598','2014-03-27','10:50:00',4.63),('14598','2014-03-27','10:55:00',4.55),('14598','2014-03-27','11:00:00',3.02),('14598','2014-03-27','11:05:00',4.04),('14598','2014-03-27','11:10:00',4.47),('14598','2014-03-27','11:15:00',3.92),('14598','2014-03-27','11:20:00',4.74),('14598','2014-03-27','11:25:00',4.88),('14598','2014-03-27','11:30:00',4.56),('14598','2014-03-27','11:35:00',3.46),('14598','2014-03-27','11:40:00',3.08),('14598','2014-03-27','11:45:00',1.56),('14598','2014-03-27','12:20:00',1.09),('14598','2014-03-27','12:25:00',1.64),('14598','2014-03-27','12:30:00',1.87),('14598','2014-03-27','12:35:00',1.88),('14598','2014-03-27','12:40:00',2.42),('14598','2014-03-27','12:45:00',3.14),('14598','2014-03-27','12:50:00',3.75),('14598','2014-03-27','12:55:00',4.76),('14598','2014-03-27','13:00:00',5),('14598','2014-03-27','13:05:00',4.75),('14598','2014-03-27','13:10:00',3.53),('14598','2014-03-27','13:15:00',5.37),('14598','2014-03-27','13:20:00',4.15),('14598','2014-03-27','13:25:00',3),('14598','2014-03-27','13:30:00',5.37),('14598','2014-03-27','13:35:00',4.74),('14598','2014-03-27','13:40:00',5.09),('14598','2014-03-27','13:45:00',5.1),('14598','2014-03-27','13:50:00',4.88),('14598','2014-03-27','13:55:00',5.18),('14598','2014-03-27','14:00:00',4.87),('14598','2014-03-27','14:05:00',5.06),('14598','2014-03-27','14:10:00',2.87),('14598','2014-03-27','14:15:00',1.74),('14598','2014-03-27','14:20:00',1.72),('14598','2014-03-27','14:25:00',1.29),('14598','2014-03-27','14:30:00',1.14),('14598','2014-03-27','14:35:00',2.09),('14598','2014-03-27','14:40:00',2.14),('14598','2014-03-27','14:45:00',1.23),('14598','2014-03-27','15:40:00',1.04),('14598','2014-03-27','15:45:00',1.17),('14598','2014-03-27','15:50:00',1.4),('14598','2014-03-27','15:55:00',1.45),('14598','2014-03-27','16:00:00',1.19),('14598','2013-04-01','08:40:00',1.38),('14598','2013-04-01','08:45:00',1.42),('14598','2013-04-01','08:50:00',1.39),('14598','2013-04-01','08:55:00',1.15),('14598','2013-04-01','09:00:00',1.51),('14598','2013-04-01','09:05:00',1.78),('14598','2013-04-01','09:10:00',1.89),('14598','2013-04-01','09:15:00',1.25),('14598','2013-04-01','09:20:00',1.67),('14598','2013-04-01','09:30:00',1.6),('14598','2013-04-01','09:35:00',1.49),('14598','2013-04-01','09:40:00',1.84),('14598','2013-04-01','09:45:00',2.57),('14598','2013-04-01','09:50:00',2.5),('14598','2013-04-01','09:55:00',2.16),('14598','2013-04-01','10:00:00',2.69),('14598','2013-04-01','10:05:00',2.98),('14598','2013-04-01','10:10:00',3.23),('14598','2013-04-01','10:15:00',3.81),('14598','2013-04-01','10:20:00',3.46),('14598','2013-04-01','10:25:00',2.71),('14598','2013-04-01','10:30:00',3.28),('14598','2013-04-01','10:35:00',3.51),('14598','2013-04-01','10:40:00',3.3),('14598','2013-04-01','10:45:00',3.79),('14598','2013-04-01','10:50:00',4.08),('14598','2013-04-01','10:55:00',4.24),('14598','2013-04-01','11:00:00',3.4),('14598','2013-04-01','11:05:00',3.49),('14598','2013-04-01','11:10:00',4.29),('14598','2013-04-01','11:15:00',4.07),('14598','2013-04-01','11:20:00',3.57),('14598','2013-04-01','11:25:00',3.25),('14598','2013-04-01','11:30:00',3.92),('14598','2013-04-01','11:35:00',3.07),('14598','2013-04-01','11:40:00',2.48),('14598','2013-04-01','11:45:00',2.7),('14598','2013-04-01','11:50:00',2.91),('14598','2013-04-01','11:55:00',2.37),('14598','2013-04-01','12:00:00',2.88),('14598','2013-04-01','12:05:00',2.57),('14598','2013-04-01','12:10:00',2.22),('14598','2013-04-01','12:15:00',2.44),('14598','2013-04-01','12:20:00',2.82),('14598','2013-04-01','12:25:00',2.49),('14598','2013-04-01','12:30:00',2.74),('14598','2013-04-01','12:35:00',2.98),('14598','2013-04-01','12:40:00',3.23),('14598','2013-04-01','12:45:00',3.07),('14598','2013-04-01','12:50:00',3.19),('14598','2013-04-01','12:55:00',3.76),('14598','2013-04-01','13:00:00',3.51),('14598','2013-04-01','13:05:00',3.44),('14598','2013-04-01','13:10:00',3.33),('14598','2013-04-01','13:15:00',3.09),('14598','2013-04-01','13:20:00',2.72),('14598','2013-04-01','13:25:00',2.56),('14598','2013-04-01','13:30:00',3.65),('14598','2013-04-01','13:35:00',3.84),('14598','2013-04-01','13:40:00',3.88),('14598','2013-04-01','13:45:00',3.13),('14598','2013-04-01','13:50:00',2.23),('14598','2013-04-01','13:55:00',2.16),('14598','2013-04-01','14:00:00',2.27),('14598','2013-04-01','14:05:00',2.52),('14598','2013-04-01','14:10:00',3.48),('14598','2013-04-01','14:15:00',4),('14598','2013-04-01','14:20:00',3.65),('14598','2013-04-01','14:25:00',3.14),('14598','2013-04-01','14:30:00',2.48),('14598','2013-04-01','14:35:00',2.4),('14598','2013-04-01','14:40:00',2.43),('14598','2013-04-01','14:45:00',2.03),('14598','2013-04-01','14:50:00',1.76),('14598','2013-04-01','14:55:00',1.97),('14598','2013-04-01','15:00:00',2.28),('14598','2013-04-01','15:05:00',2.26),('14598','2013-04-01','15:10:00',2.58),('14598','2013-04-01','15:15:00',2.26),('14598','2013-04-01','15:20:00',2.3),('14598','2013-04-01','15:25:00',2.17),('14598','2013-04-01','15:30:00',1.94),('14598','2013-04-01','15:35:00',2.67),('14598','2013-04-01','15:40:00',3.24),('14598','2013-04-01','15:45:00',2.9),('14598','2013-04-01','15:50:00',2.16),('14598','2013-04-01','15:55:00',1.73),('14598','2013-04-01','16:00:00',1.41),('14598','2013-04-01','16:05:00',1.05),('14598','2013-03-31','09:30:00',2.69),('14598','2013-03-31','09:35:00',2.06),('14598','2013-03-31','09:40:00',1.75),('14598','2013-03-31','09:45:00',1.33),('14598','2013-03-31','09:50:00',1.23),('14598','2013-03-31','09:55:00',1.31),('14598','2013-03-31','10:00:00',1.41),('14598','2013-03-31','10:05:00',1.44),('14598','2013-03-31','10:10:00',2.07),('14598','2013-03-31','10:15:00',1.43),('14598','2013-03-31','10:20:00',1.7),('14598','2013-03-31','10:25:00',2.91),('14598','2013-03-31','10:30:00',2.62),('14598','2013-03-31','10:35:00',3.27),('14598','2013-03-31','10:40:00',3.24),('14598','2013-03-31','10:45:00',2.31),('14598','2013-03-31','10:50:00',2.12),('14598','2013-03-31','10:55:00',2.99),('14598','2013-03-31','11:00:00',2.33),('14598','2013-03-31','11:05:00',2.59),('14598','2013-03-31','11:10:00',2.42),('14598','2013-03-31','11:15:00',1.97),('14598','2013-03-31','11:20:00',1.63),('14598','2013-03-31','11:25:00',1.56),('14598','2013-03-31','11:30:00',1.84),('14598','2013-03-31','11:35:00',1.79),('14598','2013-03-31','11:40:00',1.48),('14598','2013-03-31','11:45:00',1.37),('14598','2013-03-31','11:50:00',1.28),('14598','2013-03-31','11:55:00',1.5),('14598','2013-03-31','12:00:00',1.29),('14598','2013-03-31','12:05:00',1.43),('14598','2013-03-31','12:10:00',1.43),('14598','2013-03-31','12:15:00',1.18),('14598','2013-03-31','12:20:00',1.32),('14598','2013-03-31','12:25:00',1.62),('14598','2013-03-31','12:30:00',2.38),('14598','2013-03-31','12:35:00',1.64),('14598','2013-03-31','12:40:00',2.15),('14598','2013-03-31','12:45:00',2.14),('14598','2013-03-31','12:50:00',3.45),('14598','2013-03-31','12:55:00',4.13),('14598','2013-03-31','13:00:00',2.04),('14598','2013-03-31','13:05:00',3.57),('14598','2013-03-31','13:10:00',2.82),('14598','2013-03-31','13:15:00',2.52),('14598','2013-03-31','13:20:00',2.57),('14598','2013-03-31','13:25:00',2.38),('14598','2013-03-31','13:30:00',2.63),('14598','2013-03-31','13:35:00',3.88),('14598','2013-03-31','13:40:00',4.82),('14598','2013-03-31','13:45:00',3.81),('14598','2013-03-31','13:50:00',5.58),('14598','2013-03-31','13:55:00',5.05),('14598','2013-03-31','14:00:00',4.28),('14598','2013-03-31','14:05:00',3.72),('14598','2013-03-31','14:10:00',5.47),('14598','2013-03-31','14:15:00',5.23),('14598','2013-03-31','14:20:00',5.18),('14598','2013-03-31','14:25:00',5.56),('14598','2013-03-31','14:30:00',5.37),('14598','2013-03-31','14:35:00',4.29),('14598','2013-03-31','14:40:00',5.28),('14598','2013-03-31','14:45:00',5.36),('14598','2013-03-31','14:50:00',5.05),('14598','2013-03-31','14:55:00',4.87),('14598','2013-03-31','15:00:00',4.85),('14598','2013-03-31','15:05:00',4.81),('14598','2013-03-31','15:10:00',4.88),('14598','2013-03-31','15:15:00',2.96),('14598','2013-03-31','15:20:00',3.68),('14598','2013-03-31','15:25:00',4.6),('14598','2013-03-31','15:30:00',3.4),('14598','2013-03-31','15:35:00',1.83),('14598','2013-03-31','15:40:00',1.24),('14598','2013-03-31','16:00:00',1.8),('14598','2013-03-31','16:05:00',1.2),('14598','2013-03-31','16:50:00',1.16),('14598','2013-03-31','16:55:00',1.16),('14598','2013-03-31','17:10:00',1.13),('14598','2013-03-31','17:15:00',1.85),('14598','2013-03-31','17:20:00',1.37),('14598','2013-03-31','17:25:00',1.69),('14598','2013-03-31','17:30:00',2.71),('14598','2013-03-31','17:35:00',1.34),('14598','2013-03-31','17:40:00',1.89),('14598','2013-03-31','17:55:00',2.15),('14598','2013-03-31','18:00:00',2.15),('14598','2013-03-31','18:05:00',1.77),('14598','2013-03-31','18:10:00',1.53),('14598','2013-03-31','18:30:00',1.12),('14598','2013-03-30','08:55:00',1.17),('14598','2013-03-30','09:00:00',1.39),('14598','2013-03-30','09:05:00',1.03),('14598','2013-03-30','09:10:00',1),('14598','2013-03-30','09:15:00',1.11),('14598','2013-03-30','09:20:00',1.67),('14598','2013-03-30','09:25:00',1.42),('14598','2013-03-30','09:30:00',1.32),('14598','2013-03-30','09:35:00',1.69),('14598','2013-03-30','09:40:00',1.25),('14598','2013-03-30','09:45:00',1.84),('14598','2013-03-30','09:50:00',1.89),('14598','2013-03-30','09:55:00',1.57),('14598','2013-03-30','10:00:00',1.21),('14598','2013-03-30','10:05:00',1.3),('14598','2013-03-30','10:10:00',1.73),('14598','2013-03-30','10:15:00',1.57),('14598','2013-03-30','10:20:00',1.36),('14598','2013-03-30','10:25:00',1.6),('14598','2013-03-30','10:30:00',2.01),('14598','2013-03-30','10:35:00',1.87),('14598','2013-03-30','10:40:00',1.27),('14598','2013-03-30','10:45:00',1.15),('14598','2013-03-30','10:50:00',1.24),('14598','2013-03-30','11:00:00',1.02),('14598','2013-03-30','11:10:00',1.39),('14598','2013-03-30','11:15:00',1.33),('14598','2013-03-30','11:20:00',1.75),('14598','2013-03-30','11:25:00',1.69),('14598','2013-03-30','11:30:00',1.58),('14598','2013-03-30','11:35:00',1.95),('14598','2013-03-30','11:40:00',2.22),('14598','2013-03-30','11:45:00',1.81),('14598','2013-03-30','11:50:00',1.04),('14598','2013-03-30','11:55:00',1.02),('14598','2013-03-30','12:30:00',1.35),('14598','2013-03-30','12:35:00',1.05),('14598','2013-03-30','12:40:00',2.35),('14598','2013-03-30','12:45:00',2.4),('14598','2013-03-30','12:50:00',2.48),('14598','2013-03-30','12:55:00',2.8),('14598','2013-03-30','13:00:00',2.13),('14598','2013-03-30','13:05:00',1.47),('14598','2013-03-30','13:25:00',1.21),('14598','2013-03-30','13:35:00',1.47),('14598','2013-03-30','13:40:00',1.75),('14598','2013-03-30','13:45:00',1.91),('14598','2013-03-30','13:50:00',1.84),('14598','2013-03-30','13:55:00',2.1),('14598','2013-03-30','14:00:00',2.2),('14598','2013-03-30','14:05:00',2.42),('14598','2013-03-30','14:10:00',2.99),('14598','2013-03-30','14:15:00',2.13),('14598','2013-03-30','14:20:00',1.98),('14598','2013-03-30','14:25:00',2.05),('14598','2013-03-30','14:30:00',1.65),('14598','2013-03-30','14:35:00',1.54),('14598','2013-03-30','14:40:00',1.09),('14598','2013-03-30','14:45:00',1.17),('14598','2013-03-30','14:50:00',1.04),('14598','2013-03-30','15:10:00',1.06),('14598','2013-03-30','15:15:00',1.04),('14598','2013-03-29','07:45:00',1.36),('14598','2013-03-29','07:50:00',1.75),('14598','2013-03-29','07:55:00',1.27),('14598','2013-03-29','08:00:00',1.04),('14598','2013-03-29','08:10:00',1.06),('14598','2013-03-29','08:16:00',1.71),('14598','2013-03-29','08:20:00',1.71),('14598','2013-03-29','08:25:00',1.66),('14598','2013-03-29','08:30:00',1.81),('14598','2013-03-29','08:35:00',1.78),('14598','2013-03-29','08:40:00',2.12),('14598','2013-03-29','08:45:00',2.19),('14598','2013-03-29','08:50:00',2.45),('14598','2013-03-29','08:55:00',2.57),('14598','2013-03-29','09:00:00',2.72),('14598','2013-03-29','09:05:00',2.64),('14598','2013-03-29','09:10:00',3.04),('14598','2013-03-29','09:15:00',3.13),('14598','2013-03-29','09:20:00',2.99),('14598','2013-03-29','09:25:00',2.71),('14598','2013-03-29','09:30:00',2.61),('14598','2013-03-29','09:35:00',3.26),('14598','2013-03-29','09:40:00',3.33),('14598','2013-03-29','09:45:00',3.45),('14598','2013-03-29','09:50:00',3.4),('14598','2013-03-29','09:55:00',2.78),('14598','2013-03-29','10:00:00',3.04),('14598','2013-03-29','10:05:00',3.05),('14598','2013-03-29','10:10:00',3),('14598','2013-03-29','10:15:00',3.47),('14598','2013-03-29','10:20:00',3.78),('14598','2013-03-29','10:25:00',3.66),('14598','2013-03-29','10:30:00',3.7),('14598','2013-03-29','10:35:00',3.58),('14598','2013-03-29','10:40:00',3.42),('14598','2013-03-29','10:45:00',3.93),('14598','2013-03-29','10:50:00',3.96),('14598','2013-03-29','10:55:00',4.41),('14598','2013-03-29','11:00:00',4.49),('14598','2013-03-29','11:05:00',4.51),('14598','2013-03-29','11:10:00',4.56),('14598','2013-03-29','11:15:00',4.6),('14598','2013-03-29','11:20:00',4.65),('14598','2013-03-29','11:25:00',4.68),('14598','2013-03-29','11:30:00',4.71),('14598','2013-03-29','11:35:00',4.75),('14598','2013-03-29','11:40:00',4.77),('14598','2013-03-29','11:45:00',4.79),('14598','2013-03-29','11:50:00',4.83),('14598','2013-03-29','11:55:00',4.85),('14598','2013-03-29','12:00:00',4.88),('14598','2013-03-29','12:05:00',4.88),('14598','2013-03-29','12:10:00',4.87),('14598','2013-03-29','12:15:00',4.83),('14598','2013-03-29','12:20:00',4.92),('14598','2013-03-29','12:25:00',4.93),('14598','2013-03-29','12:30:00',4.93),('14598','2013-03-29','12:35:00',4.95),('14598','2013-03-29','12:40:00',4.81),('14598','2013-03-29','12:45:00',4.77),('14598','2013-03-29','12:50:00',4.99),('14598','2013-03-29','12:55:00',4.99),('14598','2013-03-29','13:00:00',5.05),('14598','2013-03-29','13:05:00',4.96),('14598','2013-03-29','13:10:00',5.05),('14598','2013-03-29','13:15:00',4.79),('14598','2013-03-29','13:20:00',4.59),('14598','2013-03-29','13:25:00',4.03),('14598','2013-03-29','13:30:00',4.07),('14598','2013-03-29','13:35:00',4.45),('14598','2013-03-29','13:40:00',4.57),('14598','2013-03-29','13:45:00',4.38),('14598','2013-03-29','13:50:00',3.64),('14598','2013-03-29','13:55:00',3.22),('14598','2013-03-29','14:00:00',3.3),('14598','2013-03-29','14:05:00',3.68),('14598','2013-03-29','14:10:00',2.89),('14598','2013-03-29','14:15:00',2.61),('14598','2013-03-29','14:20:00',2.37),('14598','2013-03-29','14:25:00',2.27),('14598','2013-03-29','14:30:00',2.14),('14598','2013-03-29','14:35:00',2.08),('14598','2013-03-29','14:40:00',2.02),('14598','2013-03-29','14:45:00',1.95),('14598','2013-03-29','14:50:00',1.86),('14598','2013-03-29','14:55:00',1.86),('14598','2013-03-29','15:00:00',1.83),('14598','2013-03-29','15:05:00',1.65),('14598','2013-03-29','15:10:00',1.49),('14598','2013-03-29','15:15:00',1.41),('14598','2013-03-29','15:20:00',1.41),('14598','2013-03-29','15:25:00',1.45),('14598','2013-03-29','15:30:00',1.75),('14598','2013-03-29','15:35:00',2.88),('14598','2013-03-29','15:40:00',3.62),('14598','2013-03-29','15:45:00',4.01),('14598','2013-03-29','15:50:00',2.99),('14598','2013-03-29','15:55:00',1.62),('14598','2013-03-29','16:00:00',1.62),('14598','2013-03-29','16:05:00',1.47),('14598','2013-03-29','16:10:00',2.22),('14598','2013-03-29','16:15:00',1.95),('14598','2013-03-29','16:20:00',2.43),('14598','2013-03-29','16:25:00',3.48),('14598','2013-03-29','16:30:00',2.67),('14598','2013-03-29','16:35:00',1.69),('14598','2013-03-29','16:40:00',1.97),('14598','2013-03-29','16:45:00',1.54),('14598','2013-03-29','16:50:00',1.6),('14598','2013-03-29','16:55:00',1),('14598','2013-03-29','17:00:00',1.37),('14598','2013-03-29','17:05:00',1.17),('14598','2013-03-29','17:10:00',1.87),('14598','2013-03-29','17:15:00',1.97),('14598','2013-03-29','17:20:00',1.78),('14598','2013-03-29','17:25:00',1.4),('14598','2013-03-28','08:55:00',1.07),('14598','2013-03-28','09:00:00',1.87),('14598','2013-03-28','09:05:00',2.32),('14598','2013-03-28','09:10:00',1.33),('14598','2013-03-28','09:15:00',1.21),('14598','2013-03-28','09:20:00',1.31),('14598','2013-03-28','09:25:00',1.32),('14598','2013-03-28','09:30:00',1.01),('14598','2013-03-28','11:40:00',1.24),('14598','2013-03-28','11:45:00',1.47),('14598','2013-03-28','11:50:00',1.27),('14598','2013-03-28','12:55:00',1.37),('14598','2013-03-28','13:00:00',1),('14598','2013-03-28','13:05:00',1.5),('14598','2013-03-28','13:10:00',2.94),('14598','2013-03-28','13:15:00',5.8),('14598','2013-03-28','13:20:00',5.25),('14598','2013-03-28','13:25:00',4.37),('14598','2013-03-28','13:30:00',5.35),('14598','2013-03-28','13:35:00',3.7),('14598','2013-03-28','13:40:00',2.59),('14598','2013-03-28','13:45:00',1.56),('14598','2013-03-28','13:50:00',1.2),('14598','2013-03-28','13:55:00',2.12),('14598','2013-03-28','14:00:00',3.44),('14598','2013-03-28','14:05:00',2.7),('14598','2013-03-28','14:10:00',2.06),('14598','2013-03-28','14:15:00',2.31),('14598','2013-03-28','14:20:00',2.5),('14598','2013-03-28','14:25:00',2.18),('14598','2013-03-28','14:30:00',2.47),('14598','2013-03-28','14:35:00',2.29),('14598','2013-03-28','14:40:00',2.05),('14598','2013-03-28','14:45:00',2.1),('14598','2013-03-28','14:50:00',2.45),('14598','2013-03-28','14:55:00',3.61),('14598','2013-03-28','15:00:00',4.57),('14598','2013-03-28','15:05:00',3.81),('14598','2013-03-28','15:10:00',2.33),('14598','2013-03-28','15:15:00',1.96),('14598','2013-03-28','15:20:00',1.27),('14598','2013-03-28','15:25:00',1.36),('14598','2013-03-28','15:30:00',2.05),('14598','2013-03-28','15:35:00',3.08),('14598','2013-03-28','15:40:00',2.03),('14598','2013-03-28','15:45:00',1.93),('14598','2013-03-28','15:55:00',1.69),('14598','2013-03-28','16:00:00',3.76),('14598','2013-03-28','16:05:00',2.15),('14598','2013-03-28','16:10:00',1.66),('14598','2013-03-28','16:15:00',1.85),('14598','2013-03-28','16:20:00',2.51),('14598','2013-03-28','16:25:00',1.93),('14598','2013-03-28','16:30:00',1.68),('14598','2013-03-28','16:35:00',1.09),('14598','2013-03-28','16:40:00',1.21),('14598','2013-03-28','16:45:00',1.07),('14598','2013-03-28','16:50:00',2.12),('14598','2013-03-28','16:55:00',2.43),('14598','2013-03-28','17:00:00',1.77),('14598','2013-03-28','17:05:00',1.41),('14598','2013-03-28','17:10:00',1.18),('14598','2013-03-27','07:40:00',1.1),('14598','2013-03-27','07:45:00',1.39),('14598','2013-03-27','08:00:00',1.28),('14598','2013-03-27','08:05:00',1.35),('14598','2013-03-27','08:10:00',1.19),('14598','2013-03-27','08:15:00',1.54),('14598','2013-03-27','08:20:00',1.89),('14598','2013-03-27','08:25:00',2.31),('14598','2013-03-27','08:30:00',1.67),('14598','2013-03-27','08:35:00',2.09),('14598','2013-03-27','08:40:00',2.03),('14598','2013-03-27','08:45:00',2.45),('14598','2013-03-27','08:50:00',2.31),('14598','2013-03-27','08:55:00',2.33),('14598','2013-03-27','09:00:00',3.06),('14598','2013-03-27','09:05:00',2.47),('14598','2013-03-27','09:10:00',2.6),('14598','2013-03-27','09:15:00',1.53),('14598','2013-03-27','09:20:00',1.91),('14598','2013-03-27','09:25:00',1.66),('14598','2013-03-27','09:30:00',2.44),('14598','2013-03-27','09:35:00',1.49),('14598','2013-03-27','09:40:00',2.7),('14598','2013-03-27','09:45:00',2.11),('14598','2013-03-27','09:50:00',1.17),('14598','2013-03-27','09:55:00',1.84),('14598','2013-03-27','10:00:00',2.78),('14598','2013-03-27','10:05:00',2.33),('14598','2013-03-27','10:10:00',2.69),('14598','2013-03-27','10:15:00',2.73),('14598','2013-03-27','10:20:00',2.37),('14598','2013-03-27','10:25:00',3.15),('14598','2013-03-27','10:30:00',2.98),('14598','2013-03-27','10:35:00',2.64),('14598','2013-03-27','10:40:00',2.34),('14598','2013-03-27','10:45:00',2.07),('14598','2013-03-27','10:50:00',2.05),('14598','2013-03-27','10:55:00',2.07),('14598','2013-03-27','11:00:00',2.14),('14598','2013-03-27','11:05:00',2.11),('14598','2013-03-27','11:10:00',2.33),('14598','2013-03-27','11:15:00',2.29),('14598','2013-03-27','11:20:00',2.18),('14598','2013-03-27','11:25:00',2.13),('14598','2013-03-27','11:30:00',2.1),('14598','2013-03-27','11:35:00',2.72),('14598','2013-03-27','11:40:00',3.84),('14598','2013-03-27','11:45:00',3.78),('14598','2013-03-27','11:50:00',3.39),('14598','2013-03-27','11:55:00',3.87),('14598','2013-03-27','12:00:00',3.67),('14598','2013-03-27','12:05:00',3.22),('14598','2013-03-27','12:10:00',3.28),('14598','2013-03-27','12:15:00',3.67),('14598','2013-03-27','12:20:00',3.76),('14598','2013-03-27','12:25:00',4.06),('14598','2013-03-27','12:30:00',3.16),('14598','2013-03-27','12:35:00',2.95),('14598','2013-03-27','12:40:00',4.14),('14598','2013-03-27','12:45:00',3.85),('14598','2013-03-27','12:50:00',3.71),('14598','2013-03-27','12:55:00',2.77),('14598','2013-03-27','13:00:00',2.4),('14598','2013-03-27','13:05:00',2.36),('14598','2013-03-27','13:10:00',2.32),('14598','2013-03-27','13:15:00',2.31),('14598','2013-03-27','13:20:00',2.53),('14598','2013-03-27','13:25:00',2.52),('14598','2013-03-27','13:30:00',2.56),('14598','2013-03-27','13:35:00',2.71),('14598','2013-03-27','13:40:00',2.26),('14598','2013-03-27','13:45:00',2),('14598','2013-03-27','13:50:00',1.87),('14598','2013-03-27','13:55:00',2.16),('14598','2013-03-27','14:00:00',2.34),('14598','2013-03-27','14:05:00',2.1),('14598','2013-03-27','14:10:00',1.99),('14598','2013-03-27','14:15:00',1.69),('14598','2013-03-27','14:20:00',1.97),('14598','2013-03-27','14:25:00',2.14),('14598','2013-03-27','14:30:00',1.98),('14598','2013-03-27','14:35:00',1.94),('14598','2013-03-27','14:40:00',1.86),('14598','2013-03-27','14:45:00',2.07),('14598','2013-03-27','14:50:00',1.86),('14598','2013-03-27','14:55:00',1.76),('14598','2013-03-27','15:00:00',1.43),('14598','2013-03-27','15:05:00',1.42),('14598','2013-03-27','15:10:00',1.84),('14598','2013-03-27','15:15:00',2.01),('14598','2013-03-27','15:20:00',1.59),('14598','2013-03-27','15:25:00',1.94),('14598','2013-03-27','15:30:00',1.76),('14598','2013-03-27','15:35:00',1.32),('14598','2013-03-27','15:40:00',1.66),('14598','2013-03-27','15:45:00',1.61),('14598','2013-03-27','15:50:00',1.89),('14598','2013-03-27','15:55:00',1.67),('14598','2013-03-27','16:00:00',1.28),('14598','2013-03-27','16:05:00',1.25),('14598','2013-03-27','16:10:00',1.08),('14598','2013-03-27','16:20:00',1),('14598','2013-03-27','16:25:00',1.06),('14598','2013-03-27','16:30:00',1.17),('14598','2013-03-27','16:35:00',1.4),('14598','2013-03-27','16:40:00',1.51),('14598','2013-03-27','16:45:00',1.56),('14598','2013-03-27','16:50:00',2.05),('14598','2013-03-27','16:55:00',1.79),('14598','2013-03-26','08:40:00',1.23),('14598','2013-03-26','08:45:00',1.35),('14598','2013-03-26','09:20:00',1.13),('14598','2013-03-26','09:25:00',2.21),('14598','2013-03-26','09:30:00',1.63),('14598','2013-03-26','09:35:00',1.21),('14598','2013-03-26','09:45:00',1.16),('14598','2013-03-26','10:05:00',1.63),('14598','2013-03-26','10:10:00',1.16),('14598','2013-03-26','10:15:00',1.1),('14598','2013-03-26','10:20:00',1.15),('14598','2013-03-26','10:25:00',1.62),('14598','2013-03-26','10:30:00',2.49),('14598','2013-03-26','10:35:00',2.52),('14598','2013-03-26','10:40:00',1.34),('14598','2013-03-26','10:45:00',1.75),('14598','2013-03-26','10:50:00',3.25),('14598','2013-03-26','10:55:00',2.89),('14598','2013-03-26','11:00:00',1.81),('14598','2013-03-26','11:05:00',2.8),('14598','2013-03-26','11:10:00',3.99),('14598','2013-03-26','11:15:00',4.1),('14598','2013-03-26','11:20:00',2.72),('14598','2013-03-26','11:25:00',2.08),('14598','2013-03-26','11:30:00',3.71),('14598','2013-03-26','11:35:00',5.18),('14598','2013-03-26','11:40:00',3.69),('14598','2013-03-26','11:45:00',3.05),('14598','2013-03-26','11:50:00',2.6),('14598','2013-03-26','11:55:00',1.77),('14598','2013-03-26','12:00:00',1.74),('14598','2013-03-26','12:05:00',2.29),('14598','2013-03-26','12:10:00',2.99),('14598','2013-03-26','12:15:00',3.18),('14598','2013-03-26','12:20:00',1.86),('14598','2013-03-26','12:25:00',2.35),('14598','2013-03-26','12:30:00',2.53),('14598','2013-03-26','12:35:00',3.73),('14598','2013-03-26','12:40:00',3.49),('14598','2013-03-26','12:45:00',2.75),('14598','2013-03-26','12:50:00',3.16),('14598','2013-03-26','12:55:00',3.03),('14598','2013-03-26','13:00:00',2.61),('14598','2013-03-26','13:05:00',2.5),('14598','2013-03-26','13:10:00',2.74),('14598','2013-03-26','13:15:00',2.05),('14598','2013-03-26','13:20:00',2.05),('14598','2013-03-26','13:25:00',2.15),('14598','2013-03-26','13:30:00',1.98),('14598','2013-03-26','13:35:00',1.84),('14598','2013-03-26','13:40:00',2.76),('14598','2013-03-26','13:45:00',3.12),('14598','2013-03-26','13:50:00',3.49),('14598','2013-03-26','13:55:00',2.89),('14598','2013-03-26','14:00:00',2.02),('14598','2013-03-26','14:05:00',1.62),('14598','2013-03-26','14:10:00',1.33),('14598','2013-03-26','14:15:00',1.36),('14598','2013-03-26','14:20:00',1.35),('14598','2013-03-26','14:25:00',1.24),('14598','2013-03-26','14:30:00',1.19),('14598','2013-03-26','14:35:00',1.24),('14598','2013-03-26','14:40:00',1.24),('14598','2013-03-26','14:45:00',1.19),('14598','2013-03-26','14:50:00',1.11),('14598','2013-03-26','14:55:00',1.08),('14598','2013-03-26','15:00:00',1.09),('14598','2013-03-26','15:05:00',1.21),('14598','2013-03-26','15:10:00',1.33),('14598','2013-03-26','15:15:00',1.25),('14598','2013-03-26','15:20:00',1.04),('14598','2013-03-25','07:40:00',1.15),('14598','2013-03-25','07:50:00',1.17),('14598','2013-03-25','07:55:00',1.28),('14598','2013-03-25','08:00:00',1.36),('14598','2013-03-25','08:05:00',1.49),('14598','2013-03-25','08:10:00',1.66),('14598','2013-03-25','08:15:00',1.88),('14598','2013-03-25','08:20:00',1.42),('14598','2013-03-25','08:25:00',2.32),('14598','2013-03-25','08:30:00',3.25),('14598','2013-03-25','08:35:00',2.57),('14598','2013-03-25','08:40:00',1.5),('14598','2013-03-25','08:45:00',1.45),('14598','2013-03-25','08:50:00',1.29),('14598','2013-03-25','08:55:00',1.5),('14598','2013-03-25','09:00:00',3.64),('14598','2013-03-25','09:05:00',1.83),('14598','2013-03-25','09:25:00',1.41),('14598','2013-03-25','09:30:00',3.34),('14598','2013-03-25','09:35:00',3.59),('14598','2013-03-25','09:40:00',2.06),('14598','2013-03-25','09:45:00',1.24),('14598','2013-03-25','09:55:00',1.01),('14598','2013-03-25','10:00:00',2.42),('14598','2013-03-25','10:05:00',2.28),('14598','2013-03-25','10:20:00',1.89),('14598','2013-03-25','10:25:00',2.56),('14598','2013-03-25','10:30:00',2.95),('14598','2013-03-25','10:35:00',4.62),('14598','2013-03-25','10:40:00',3.04),('14598','2013-03-25','10:45:00',2.12),('14598','2013-03-25','10:50:00',3.25),('14598','2013-03-25','10:55:00',4.21),('14598','2013-03-25','11:00:00',4.72),('14598','2013-03-25','11:05:00',4.56),('14598','2013-03-25','11:10:00',3.24),('14598','2013-03-25','11:15:00',3.02),('14598','2013-03-25','11:20:00',3.32),('14598','2013-03-25','11:25:00',4.43),('14598','2013-03-25','11:30:00',5.51),('14598','2013-03-25','11:35:00',3.86),('14598','2013-03-25','11:40:00',4.39),('14598','2013-03-25','11:45:00',2.93),('14598','2013-03-25','11:50:00',3.33),('14598','2013-03-25','11:55:00',4.36),('14598','2013-03-25','12:00:00',4.7),('14598','2013-03-25','12:05:00',5.16),('14598','2013-03-25','12:10:00',5.12),('14598','2013-03-25','12:15:00',5.25),('14598','2013-03-25','12:20:00',4.37),('14598','2013-03-25','12:25:00',4.05),('14598','2013-03-25','12:30:00',2.23),('14598','2013-03-25','12:35:00',5.46),('14598','2013-03-25','12:40:00',5.24),('14598','2013-03-25','12:45:00',3.97),('14598','2013-03-25','12:50:00',2.87),('14598','2013-03-25','12:55:00',3.7),('14598','2013-03-25','13:00:00',4.13),('14598','2013-03-25','13:05:00',4.77),('14598','2013-03-25','13:10:00',5.41),('14598','2013-03-25','13:15:00',4.27),('14598','2013-03-25','13:20:00',5.5),('14598','2013-03-25','13:25:00',5.28),('14598','2013-03-25','13:30:00',4.8),('14598','2013-03-25','13:35:00',4.18),('14598','2013-03-25','13:40:00',4.66),('14598','2013-03-25','13:45:00',4.64),('14598','2013-03-25','13:50:00',4.87),('14598','2013-03-25','13:55:00',5.04),('14598','2013-03-25','14:00:00',4.98),('14598','2013-03-25','14:05:00',4.86),('14598','2013-03-25','14:10:00',4.83),('14598','2013-03-25','14:15:00',4.03),('14598','2013-03-25','14:20:00',4.36),('14598','2013-03-25','14:25:00',4.44),('14598','2013-03-25','14:30:00',3.76),('14598','2013-03-25','14:35:00',3.89),('14598','2013-03-25','14:40:00',4.38),('14598','2013-03-25','14:45:00',4.75),('14598','2013-03-25','14:50:00',4.89),('14598','2013-03-25','14:55:00',4.08),('14598','2013-03-25','15:00:00',4.28),('14598','2013-03-25','15:05:00',3.4),('14598','2013-03-25','15:10:00',3.28),('14598','2013-03-25','15:15:00',2.56),('14598','2013-03-25','15:20:00',3.04),('14598','2013-03-25','15:25:00',2.55),('14598','2013-03-25','15:30:00',3.21),('14598','2013-03-25','15:35:00',3.51),('14598','2013-03-25','15:40:00',1.83),('14598','2013-03-25','15:45:00',1.5),('14598','2013-03-25','15:50:00',2.93),('14598','2013-03-25','15:55:00',2.61),('14598','2013-03-25','16:00:00',3.17),('14598','2013-03-25','16:05:00',2.76),('14598','2013-03-25','16:10:00',2.83),('14598','2013-03-25','16:15:00',3.08),('14598','2013-03-25','16:20:00',1.92),('14598','2013-03-25','16:25:00',3),('14598','2013-03-25','16:30:00',2.2),('14598','2013-03-25','16:35:00',1.97),('14598','2013-03-25','16:40:00',1.52),('14598','2013-03-24','07:55:00',1.08),('14598','2013-03-24','08:00:00',1.2),('14598','2013-03-24','08:05:00',1.3),('14598','2013-03-24','08:10:00',1.37),('14598','2013-03-24','08:15:00',1.45),('14598','2013-03-24','08:20:00',1.56),('14598','2013-03-24','08:25:00',1.76),('14598','2013-03-24','08:30:00',1.88),('14598','2013-03-24','08:35:00',1.96),('14598','2013-03-24','08:40:00',2.05),('14598','2013-03-24','08:45:00',2.18),('14598','2013-03-24','08:50:00',2.26),('14598','2013-03-24','08:55:00',2.38),('14598','2013-03-24','09:00:00',2.47),('14598','2013-03-24','09:05:00',2.55),('14598','2013-03-24','09:10:00',2.64),('14598','2013-03-24','09:15:00',2.74),('14598','2013-03-24','09:20:00',2.83),('14598','2013-03-24','09:25:00',2.92),('14598','2013-03-24','09:30:00',3),('14598','2013-03-24','09:35:00',3.09),('14598','2013-03-24','09:40:00',3.15),('14598','2013-03-24','09:45:00',3.23),('14598','2013-03-24','09:50:00',3.31),('14598','2013-03-24','09:55:00',3.39),('14598','2013-03-24','10:00:00',3.46),('14598','2013-03-24','10:05:00',3.48),('14598','2013-03-24','10:10:00',3.59),('14598','2013-03-24','10:15:00',3.65),('14598','2013-03-24','10:20:00',3.71),('14598','2013-03-24','10:25:00',3.77),('14598','2013-03-24','10:30:00',3.82),('14598','2013-03-24','10:35:00',3.86),('14598','2013-03-24','10:40:00',3.91),('14598','2013-03-24','10:45:00',3.97),('14598','2013-03-24','10:50:00',4.02),('14598','2013-03-24','10:55:00',4.06),('14598','2013-03-24','11:00:00',4.1),('14598','2013-03-24','11:05:00',4.15),('14598','2013-03-24','11:10:00',4.17),('14598','2013-03-24','11:15:00',4.21),('14598','2013-03-24','11:20:00',4.28),('14598','2013-03-24','11:25:00',4.39),('14598','2013-03-24','11:30:00',4.45),('14598','2013-03-24','11:35:00',4.49),('14598','2013-03-24','11:40:00',4.52),('14598','2013-03-24','11:45:00',4.56),('14598','2013-03-24','11:50:00',4.56),('14598','2013-03-24','11:55:00',4.6),('14598','2013-03-24','12:00:00',4.6),('14598','2013-03-24','12:05:00',4.63),('14598','2013-03-24','12:10:00',4.66),('14598','2013-03-24','12:15:00',4.67),('14598','2013-03-24','12:20:00',4.69),('14598','2013-03-24','12:25:00',4.69),('14598','2013-03-24','12:30:00',4.69),('14598','2013-03-24','12:35:00',4.69),('14598','2013-03-24','12:40:00',4.69),('14598','2013-03-24','12:45:00',4.69),('14598','2013-03-24','12:50:00',4.7),('14598','2013-03-24','12:55:00',4.69),('14598','2013-03-24','13:00:00',4.64),('14598','2013-03-24','13:05:00',4.55),('14598','2013-03-24','13:10:00',4.64),('14598','2013-03-24','13:15:00',4.64),('14598','2013-03-24','13:20:00',4.66),('14598','2013-03-24','13:25:00',4.62),('14598','2013-03-24','13:30:00',4.59),('14598','2013-03-24','13:35:00',4.55),('14598','2013-03-24','13:40:00',4.54),('14598','2013-03-24','13:45:00',4.49),('14598','2013-03-24','13:50:00',4.4),('14598','2013-03-24','13:55:00',4.36),('14598','2013-03-24','14:00:00',4.38),('14598','2013-03-24','14:05:00',4.33),('14598','2013-03-24','14:10:00',4.26),('14598','2013-03-24','14:15:00',4.22),('14598','2013-03-24','14:20:00',4.28),('14598','2013-03-24','14:25:00',3.35),('14598','2013-03-24','14:30:00',4.06),('14598','2013-03-24','14:35:00',4.04),('14598','2013-03-24','14:40:00',4.05),('14598','2013-03-24','14:45:00',3.92),('14598','2013-03-24','14:50:00',3.52),('14598','2013-03-24','14:55:00',1.61),('14598','2013-03-24','15:00:00',2.26),('14598','2013-03-24','15:05:00',2.67),('14598','2013-03-24','15:10:00',3.33),('14598','2013-03-24','15:15:00',2.82),('14598','2013-03-24','15:20:00',3.18),('14598','2013-03-24','15:25:00',3.28),('14598','2013-03-24','15:30:00',1.96),('14598','2013-03-24','15:35:00',1.78),('14598','2013-03-24','15:40:00',1.1),('14598','2013-03-24','15:45:00',1.3),('14598','2013-03-24','15:50:00',1.75),('14598','2013-03-24','16:00:00',1.11),('14598','2013-03-24','16:05:00',1.56),('14598','2013-03-24','16:10:00',1.92),('14598','2013-03-24','16:20:00',1.22),('14598','2013-03-24','16:25:00',1.21),('14598','2013-03-23','07:55:00',1.06),('14598','2013-03-23','08:00:00',1.15),('14598','2013-03-23','08:05:00',1.28),('14598','2013-03-23','08:10:00',1.36),('14598','2013-03-23','08:15:00',1.45),('14598','2013-03-23','08:20:00',1.57),('14598','2013-03-23','08:25:00',1.72),('14598','2013-03-23','08:30:00',1.88),('14598','2013-03-23','08:35:00',1.98),('14598','2013-03-23','08:40:00',2.1),('14598','2013-03-23','08:45:00',2.23),('14598','2013-03-23','08:50:00',2.33),('14598','2013-03-23','08:55:00',2.46),('14598','2013-03-23','09:00:00',2.51),('14598','2013-03-23','09:05:00',2.64),('14598','2013-03-23','09:10:00',2.74),('14598','2013-03-23','09:15:00',2.85),('14598','2013-03-23','09:20:00',2.95),('14598','2013-03-23','09:25:00',2.99),('14598','2013-03-23','09:30:00',3.02),('14598','2013-03-23','09:35:00',3.17),('14598','2013-03-23','09:40:00',3.18),('14598','2013-03-23','09:45:00',3.24),('14598','2013-03-23','09:50:00',3.41),('14598','2013-03-23','09:55:00',3.38),('14598','2013-03-23','10:00:00',2.42),('14598','2013-03-23','10:05:00',2.56),('14598','2013-03-23','10:10:00',2.41),('14598','2013-03-23','10:15:00',4.02),('14598','2013-03-23','10:20:00',3.83),('14598','2013-03-23','10:25:00',3.95),('14598','2013-03-23','10:30:00',2.81),('14598','2013-03-23','10:35:00',2.89),('14598','2013-03-23','10:40:00',2.13),('14598','2013-03-23','10:45:00',2.93),('14598','2013-03-23','10:50:00',3.91),('14598','2013-03-23','10:55:00',2.84),('14598','2013-03-23','11:00:00',3.49),('14598','2013-03-23','11:05:00',3.08),('14598','2013-03-23','11:10:00',3.18),('14598','2013-03-23','11:15:00',3.41),('14598','2013-03-23','11:20:00',3.18),('14598','2013-03-23','11:25:00',4.42),('14598','2013-03-23','11:30:00',4.39),('14598','2013-03-23','11:35:00',4.24),('14598','2013-03-23','11:40:00',4.28),('14598','2013-03-23','11:45:00',4.53),('14598','2013-03-23','11:50:00',4.55),('14598','2013-03-23','11:55:00',4.51),('14598','2013-03-23','12:00:00',4.64),('14598','2013-03-23','12:05:00',4.62),('14598','2013-03-23','12:10:00',4.76),('14598','2013-03-23','12:15:00',4.66),('14598','2013-03-23','12:20:00',4.69),('14598','2013-03-23','12:25:00',4.63),('14598','2013-03-23','12:30:00',4.65),('14598','2013-03-23','12:35:00',4.56),('14598','2013-03-23','12:40:00',4.74),('14598','2013-03-23','12:45:00',4.66),('14598','2013-03-23','12:50:00',4.26),('14598','2013-03-23','12:55:00',4.6),('14598','2013-03-23','13:00:00',4.61),('14598','2013-03-23','13:05:00',4.67),('14598','2013-03-23','13:10:00',4.77),('14598','2013-03-23','13:15:00',4.69),('14598','2013-03-23','13:20:00',4.66),('14598','2013-03-23','13:25:00',4.7),('14598','2013-03-23','13:30:00',4.62),('14598','2013-03-23','13:35:00',4.6),('14598','2013-03-23','13:40:00',4.54),('14598','2013-03-23','13:45:00',4.56),('14598','2013-03-23','13:50:00',4.54),('14598','2013-03-23','13:55:00',4.59),('14598','2013-03-23','14:00:00',4.35),('14598','2013-03-23','14:05:00',4.39),('14598','2013-03-23','14:10:00',4.51),('14598','2013-03-23','14:15:00',4.35),('14598','2013-03-23','14:20:00',4.33),('14598','2013-03-23','14:25:00',4.27),('14598','2013-03-23','14:30:00',4.09),('14598','2013-03-23','14:35:00',3.95),('14598','2013-03-23','14:40:00',3.98),('14598','2013-03-23','14:45:00',3.88),('14598','2013-03-23','14:50:00',3.89),('14598','2013-03-23','14:55:00',4),('14598','2013-03-23','15:00:00',3.83),('14598','2013-03-23','15:05:00',3.31),('14598','2013-03-23','15:10:00',3.59),('14598','2013-03-23','15:15:00',3.67),('14598','2013-03-23','15:20:00',3.49),('14598','2013-03-23','15:25:00',3.4),('14598','2013-03-23','15:30:00',3.29),('14598','2013-03-23','15:35:00',3.05),('14598','2013-03-23','15:40:00',2.46),('14598','2013-03-23','15:45:00',2.93),('14598','2013-03-23','15:50:00',2.56),('14598','2013-03-23','15:55:00',2.96),('14598','2013-03-23','16:00:00',2.69),('14598','2013-03-23','16:05:00',2.97),('14598','2013-03-23','16:10:00',2.55),('14598','2013-03-23','16:15:00',2.77),('14598','2013-03-23','16:20:00',2.22),('14598','2013-03-23','16:25:00',2.13),('14598','2013-03-23','16:30:00',1.88),('14598','2013-03-23','16:35:00',1.68),('14598','2013-03-23','16:40:00',1.7),('14598','2013-03-23','16:45:00',1.82),('14598','2013-03-23','16:50:00',1.83),('14598','2013-03-23','16:55:00',2.12),('14598','2013-03-23','17:00:00',1.98),('14598','2013-03-23','17:05:00',1.68),('14598','2013-03-23','17:10:00',1.49),('14598','2013-03-23','17:15:00',1.43),('14598','2013-03-23','17:20:00',1.33),('14598','2013-03-23','17:25:00',1.11),('14598','2014-03-26','07:50:00',1.05),('14598','2014-03-26','07:55:00',1.23),('14598','2014-03-26','08:05:00',1.13),('14598','2014-03-26','08:30:00',1.08),('14598','2014-03-26','08:35:00',1.38),('14598','2014-03-26','08:40:00',1.44),('14598','2014-03-26','08:45:00',1.22),('14598','2014-03-26','08:50:00',1.26),('14598','2014-03-26','08:55:00',1.25),('14598','2014-03-26','09:00:00',1.65),('14598','2014-03-26','09:05:00',2.69),('14598','2014-03-26','09:10:00',2.89),('14598','2014-03-26','09:15:00',2.88),('14598','2014-03-26','09:20:00',2.96),('14598','2014-03-26','09:25:00',3.05),('14598','2014-03-26','09:30:00',3.15),('14598','2014-03-26','09:35:00',3.21),('14598','2014-03-26','09:40:00',3.32),('14598','2014-03-26','09:45:00',3.39),('14598','2014-03-26','09:50:00',3.28),('14598','2014-03-26','09:55:00',3.42),('14598','2014-03-26','10:00:00',3.42),('14598','2014-03-26','10:05:00',2.13),('14598','2014-03-26','10:10:00',3.38),('14598','2014-03-26','10:15:00',3.08),('14598','2014-03-26','10:20:00',2.15),('14598','2014-03-26','10:25:00',4.45),('14598','2014-03-26','10:30:00',1.34),('14598','2014-03-26','10:35:00',3.49),('14598','2014-03-26','10:40:00',3.06),('14598','2014-03-26','10:45:00',2.94),('14598','2014-03-26','10:50:00',3.62),('14598','2014-03-26','10:55:00',1.89),('14598','2014-03-26','11:00:00',2.33),('14598','2014-03-26','11:05:00',2.85),('14598','2014-03-26','11:10:00',2.42),('14598','2014-03-26','11:15:00',2.28),('14598','2014-03-26','11:20:00',2.78),('14598','2014-03-26','11:25:00',1.83),('14598','2014-03-26','11:30:00',1.59),('14598','2014-03-26','11:35:00',1.67),('14598','2014-03-26','11:40:00',1.54),('14598','2014-03-26','11:45:00',2.14),('14598','2014-03-26','11:50:00',3.15),('14598','2014-03-26','11:55:00',4.69),('14598','2014-03-26','12:00:00',5.47),('14598','2014-03-26','12:05:00',4.87),('14598','2014-03-26','12:10:00',4.14),('14598','2014-03-26','12:15:00',3.76),('14598','2014-03-26','12:20:00',3.72),('14598','2014-03-26','12:25:00',5.08),('14598','2014-03-26','12:30:00',5.04),('14598','2014-03-26','12:35:00',4.79),('14598','2014-03-26','12:40:00',4.89),('14598','2014-03-26','12:45:00',4.88),('14598','2014-03-26','12:50:00',4.94),('14598','2014-03-26','12:55:00',4.97),('14598','2014-03-26','13:00:00',4.99),('14598','2014-03-26','13:05:00',5.06),('14598','2014-03-26','13:10:00',4.81),('14598','2014-03-26','13:15:00',4.79),('14598','2014-03-26','13:20:00',4.35),('14598','2014-03-26','13:25:00',4.39),('14598','2014-03-26','13:30:00',4.3),('14598','2014-03-26','13:35:00',3.52),('14598','2014-03-26','13:40:00',3.44),('14598','2014-03-26','13:45:00',3.75),('14598','2014-03-26','13:50:00',4.16),('14598','2014-03-26','13:55:00',4.18),('14598','2014-03-26','14:00:00',4.56),('14598','2014-03-26','14:05:00',4.78),('14598','2014-03-26','14:10:00',4.57),('14598','2014-03-26','14:15:00',4.57),('14598','2014-03-26','14:20:00',3.68),('14598','2014-03-26','14:25:00',3.99),('14598','2014-03-26','14:30:00',3.57),('14598','2014-03-26','14:35:00',3.87),('14598','2014-03-26','14:40:00',3.77),('14598','2014-03-26','14:45:00',2.99),('14598','2014-03-26','14:50:00',3.14),('14598','2014-03-26','14:55:00',3.49),('14598','2014-03-26','15:00:00',3.95),('14598','2014-03-26','15:05:00',4.04),('14598','2014-03-26','15:10:00',3.81),('14598','2014-03-26','15:15:00',3.46),('14598','2014-03-26','15:20:00',3.69),('14598','2014-03-26','15:25:00',3.79),('14598','2014-03-26','15:30:00',3.56),('14598','2014-03-26','15:35:00',3.04),('14598','2014-03-26','15:40:00',3.14),('14598','2014-03-26','15:45:00',2.34),('14598','2014-03-26','15:50:00',2.36),('14598','2014-03-26','15:55:00',1.96),('14598','2014-03-26','16:00:00',1.99),('14598','2014-03-26','16:05:00',2.3),('14598','2014-03-26','16:10:00',2.41),('14598','2014-03-26','16:15:00',2.43),('14598','2014-03-26','16:20:00',1.53),('14598','2014-03-26','16:25:00',1.34),('14598','2014-03-26','16:30:00',1.3),('14598','2014-03-26','16:35:00',1.53),('14598','2014-03-26','16:40:00',1.05),('14598','2013-03-22','07:55:00',1.01),('14598','2013-03-22','08:00:00',1.12),('14598','2013-03-22','08:05:00',1.25),('14598','2013-03-22','08:10:00',1.36),('14598','2013-03-22','08:15:00',1.46),('14598','2013-03-22','08:20:00',1.56),('14598','2013-03-22','08:25:00',1.71),('14598','2013-03-22','08:30:00',1.87),('14598','2013-03-22','08:35:00',1.98),('14598','2013-03-22','08:40:00',2.09),('14598','2013-03-22','08:45:00',2.2),('14598','2013-03-22','08:50:00',2.26),('14598','2013-03-22','08:55:00',2.38),('14598','2013-03-22','09:00:00',2.49),('14598','2013-03-22','09:05:00',2.58),('14598','2013-03-22','09:10:00',2.68),('14598','2013-03-22','09:15:00',2.77),('14598','2013-03-22','09:20:00',2.84),('14598','2013-03-22','09:25:00',2.94),('14598','2013-03-22','09:30:00',3.03),('14598','2013-03-22','09:35:00',3.12),('14598','2013-03-22','09:40:00',3.19),('14598','2013-03-22','09:45:00',3.26),('14598','2013-03-22','09:50:00',3.33),('14598','2013-03-22','09:55:00',3.4),('14598','2013-03-22','10:00:00',3.46),('14598','2013-03-22','10:05:00',3.53),('14598','2013-03-22','10:10:00',3.59),('14598','2013-03-22','10:15:00',3.65),('14598','2013-03-22','10:20:00',3.71),('14598','2013-03-22','10:25:00',3.75),('14598','2013-03-22','10:30:00',3.85),('14598','2013-03-22','10:35:00',3.94),('14598','2013-03-22','10:40:00',4.03),('14598','2013-03-22','10:45:00',4.1),('14598','2013-03-22','10:50:00',4.15),('14598','2013-03-22','10:55:00',4.2),('14598','2013-03-22','11:00:00',4.23),('14598','2013-03-22','11:05:00',4.29),('14598','2013-03-22','11:10:00',4.36),('14598','2013-03-22','11:15:00',4.39),('14598','2013-03-22','11:20:00',4.42),('14598','2013-03-22','11:25:00',4.47),('14598','2013-03-22','11:30:00',4.53),('14598','2013-03-22','11:35:00',4.56),('14598','2013-03-22','11:40:00',4.59),('14598','2013-03-22','11:45:00',4.6),('14598','2013-03-22','11:50:00',4.57),('14598','2013-03-22','11:55:00',4.64),('14598','2013-03-22','12:00:00',4.69),('14598','2013-03-22','12:05:00',4.7),('14598','2013-03-22','12:10:00',4.73),('14598','2013-03-22','12:15:00',4.73),('14598','2013-03-22','12:20:00',4.76),('14598','2013-03-22','12:25:00',4.73),('14598','2013-03-22','12:30:00',4.8),('14598','2013-03-22','12:35:00',4.86),('14598','2013-03-22','12:40:00',4.87),('14598','2013-03-22','12:45:00',4.9),('14598','2013-03-22','12:50:00',4.86),('14598','2013-03-22','12:55:00',4.85),('14598','2013-03-22','13:00:00',4.87),('14598','2013-03-22','13:05:00',4.83),('14598','2013-03-22','13:10:00',4.82),('14598','2013-03-22','13:15:00',4.74),('14598','2013-03-22','13:20:00',4.87),('14598','2013-03-22','13:25:00',4.84),('14598','2013-03-22','13:30:00',4.84),('14598','2013-03-22','13:35:00',4.81),('14598','2013-03-22','13:40:00',4.73),('14598','2013-03-22','13:45:00',4.7),('14598','2013-03-22','13:50:00',4.65),('14598','2013-03-22','13:55:00',4.63),('14598','2013-03-22','14:00:00',4.61),('14598','2013-03-22','14:05:00',4.56),('14598','2013-03-22','14:10:00',4.53),('14598','2013-03-22','14:15:00',4.4),('14598','2013-03-22','14:20:00',4.5),('14598','2013-03-22','14:25:00',3.7),('14598','2013-03-22','14:30:00',3.9),('14598','2013-03-22','14:35:00',3.13),('14598','2013-03-22','14:40:00',2.95),('14598','2013-03-22','14:45:00',4.1),('14598','2013-03-22','14:50:00',3.33),('14598','2013-03-22','14:55:00',3.43),('14598','2013-03-22','15:00:00',3.53),('14598','2013-03-22','15:05:00',2.95),('14598','2013-03-22','15:10:00',2.97),('14598','2013-03-22','15:15:00',3.02),('14598','2013-03-22','15:20:00',2.55),('14598','2013-03-22','15:25:00',1.82),('14598','2013-03-22','15:30:00',1.72),('14598','2013-03-22','15:35:00',1.61),('14598','2013-03-22','15:40:00',1.77),('14598','2013-03-22','15:45:00',2.15),('14598','2013-03-22','15:50:00',3.2),('14598','2013-03-22','15:55:00',3.05),('14598','2013-03-22','16:00:00',2.85),('14598','2013-03-22','16:05:00',3.12),('14598','2013-03-22','16:10:00',3.14),('14598','2013-03-22','16:15:00',3.08),('14598','2013-03-22','16:20:00',3.12),('14598','2013-03-22','16:25:00',2.97),('14598','2013-03-22','16:30:00',2.71),('14598','2013-03-22','16:35:00',2.51),('14598','2013-03-22','16:40:00',2.48),('14598','2013-03-22','16:45:00',1.5),('14598','2013-03-22','16:55:00',2.05),('14598','2013-03-22','17:00:00',1.44),('14598','2013-03-22','17:05:00',1.61),('14598','2013-03-22','17:10:00',1.4),('14598','2013-03-22','17:15:00',1.36),('14598','2013-03-22','17:20:00',1.25),('14598','2013-03-22','17:25:00',1.12),('14598','2013-03-21','08:00:00',1.19),('14598','2013-03-21','08:05:00',1.26),('14598','2013-03-21','08:10:00',1.42),('14598','2013-03-21','08:15:00',1.39),('14598','2013-03-21','08:20:00',1.57),('14598','2013-03-21','08:25:00',1.7),('14598','2013-03-21','08:30:00',1.87),('14598','2013-03-21','08:35:00',2.01),('14598','2013-03-21','08:40:00',2.11),('14598','2013-03-21','08:45:00',2.19),('14598','2013-03-21','08:50:00',2.33),('14598','2013-03-21','08:55:00',2.44),('14598','2013-03-21','09:00:00',2.55),('14598','2013-03-21','09:05:00',2.65),('14598','2013-03-21','09:10:00',2.77),('14598','2013-03-21','09:15:00',2.86),('14598','2013-03-21','09:20:00',2.97),('14598','2013-03-21','09:25:00',3.07),('14598','2013-03-21','09:30:00',3.18),('14598','2013-03-21','09:35:00',3.27),('14598','2013-03-21','09:40:00',3.37),('14598','2013-03-21','09:45:00',3.46),('14598','2013-03-21','09:50:00',3.53),('14598','2013-03-21','09:55:00',3.6),('14598','2013-03-21','10:00:00',3.66),('14598','2013-03-21','10:05:00',3.74),('14598','2013-03-21','10:10:00',3.84),('14598','2013-03-21','10:15:00',3.91),('14598','2013-03-21','10:20:00',3.98),('14598','2013-03-21','10:25:00',4.06),('14598','2013-03-21','10:30:00',4.12),('14598','2013-03-21','10:35:00',4.17),('14598','2013-03-21','10:40:00',4.27),('14598','2013-03-21','10:45:00',4.33),('14598','2013-03-21','10:50:00',4.4),('14598','2013-03-21','10:55:00',4.46),('14598','2013-03-21','11:00:00',4.51),('14598','2013-03-21','11:05:00',4.57),('14598','2013-03-21','11:10:00',4.63),('14598','2013-03-21','11:15:00',4.67),('14598','2013-03-21','11:20:00',4.72),('14598','2013-03-21','11:25:00',4.78),('14598','2013-03-21','11:30:00',4.81),('14598','2013-03-21','11:35:00',4.83),('14598','2013-03-21','11:40:00',4.88),('14598','2013-03-21','11:45:00',4.87),('14598','2013-03-21','11:50:00',4.93),('14598','2013-03-21','11:55:00',4.96),('14598','2013-03-21','12:00:00',5),('14598','2013-03-21','12:05:00',5.01),('14598','2013-03-21','12:10:00',5.01),('14598','2013-03-21','12:15:00',5.04),('14598','2013-03-21','12:20:00',5.04),('14598','2013-03-21','12:25:00',5.02),('14598','2013-03-21','12:30:00',5.05),('14598','2013-03-21','12:35:00',5.06),('14598','2013-03-21','12:40:00',5.07),('14598','2013-03-21','12:45:00',5.08),('14598','2013-03-21','12:50:00',5.07),('14598','2013-03-21','12:55:00',5.05),('14598','2013-03-21','13:00:00',4.95),('14598','2013-03-21','13:05:00',5.01),('14598','2013-03-21','13:10:00',5.01),('14598','2013-03-21','13:15:00',5),('14598','2013-03-21','13:20:00',5),('14598','2013-03-21','13:25:00',4.98),('14598','2013-03-21','13:30:00',4.94),('14598','2013-03-21','13:35:00',4.9),('14598','2013-03-21','13:40:00',4.87),('14598','2013-03-21','13:45:00',4.84),('14598','2013-03-21','13:50:00',4.8),('14598','2013-03-21','13:55:00',4.78),('14598','2013-03-21','14:00:00',4.74),('14598','2013-03-21','14:05:00',4.69),('14598','2013-03-21','14:10:00',4.66),('14598','2013-03-21','14:15:00',4.61),('14598','2013-03-21','14:20:00',4.56),('14598','2013-03-21','14:25:00',4.52),('14598','2013-03-21','14:30:00',4.47),('14598','2013-03-21','14:35:00',4.41),('14598','2013-03-21','14:41:00',4.34),('14598','2013-03-21','14:45:00',4.28),('14598','2013-03-21','14:50:00',4.23),('14598','2013-03-21','14:55:00',4.19),('14598','2013-03-21','15:00:00',4.12),('14598','2013-03-21','15:05:00',4.05),('14598','2013-03-21','15:11:00',3.98),('14598','2013-03-21','15:15:00',3.88),('14598','2013-03-21','15:20:00',3.82),('14598','2013-03-21','15:25:00',3.75),('14598','2013-03-21','15:30:00',3.66),('14598','2013-03-21','15:35:00',3.59),('14598','2013-03-21','15:40:00',3.5),('14598','2013-03-21','15:45:00',3.4),('14598','2013-03-21','15:50:00',3.32),('14598','2013-03-21','15:55:00',3.22),('14598','2013-03-21','16:00:00',3.1),('14598','2013-03-21','16:05:00',2.98),('14598','2013-03-21','16:10:00',2.93),('14598','2013-03-21','16:15:00',2.82),('14598','2013-03-21','16:20:00',2.45),('14598','2013-03-21','16:25:00',2.5),('14598','2013-03-21','16:30:00',2.49),('14598','2013-03-21','16:35:00',2.36),('14598','2013-03-21','16:40:00',2.25),('14598','2013-03-21','16:45:00',2.11),('14598','2013-03-21','16:50:00',2.01),('14598','2013-03-21','16:55:00',1.89),('14598','2013-03-21','17:00:00',1.76),('14598','2013-03-21','17:05:00',1.64),('14598','2013-03-21','17:10:00',1.51),('14598','2013-03-21','17:15:00',1.38),('14598','2013-03-21','17:20:00',1.24),('14598','2013-03-21','17:25:00',1.12),('14598','2013-03-20','08:00:00',1.06),('14598','2013-03-20','08:06:00',1.17),('14598','2013-03-20','08:10:00',1.33),('14598','2013-03-20','08:15:00',1.42),('14598','2013-03-20','08:20:00',1.53),('14598','2013-03-20','08:25:00',1.67),('14598','2013-03-20','08:30:00',1.77),('14598','2013-03-20','08:36:00',1.86),('14598','2013-03-20','08:40:00',2.1),('14598','2013-03-20','08:45:00',1.79),('14598','2013-03-20','08:50:00',1.55),('14598','2013-03-20','08:55:00',1.45),('14598','2013-03-20','09:00:00',1.37),('14598','2013-03-20','09:07:00',1.55),('14598','2013-03-20','09:10:00',1.82),('14598','2013-03-20','09:15:00',2.69),('14598','2013-03-20','09:20:00',2.31),('14598','2013-03-20','09:25:00',2.94),('14598','2013-03-20','09:30:00',2.94),('14598','2013-03-20','09:35:00',2.47),('14598','2013-03-20','09:40:00',1.96),('14598','2013-03-20','09:45:00',2.34),('14598','2013-03-20','09:50:00',2.51),('14598','2013-03-20','09:55:00',2.7),('14598','2013-03-20','10:00:00',3.17),('14598','2013-03-20','10:05:00',3.36),('14598','2013-03-20','10:10:00',3.25),('14598','2013-03-20','10:15:00',3.39),('14598','2013-03-20','10:20:00',3.51),('14598','2013-03-20','10:25:00',3.83),('14598','2013-03-20','10:30:00',3.71),('14598','2013-03-20','10:35:00',3.46),('14598','2013-03-20','10:40:00',2.85),('14598','2013-03-20','10:45:00',3.2),('14598','2013-03-20','10:50:00',2.86),('14598','2013-03-20','10:55:00',2.81),('14598','2013-03-20','11:00:00',2.46),('14598','2013-03-20','11:05:00',2.62),('14598','2013-03-20','11:10:00',3.18),('14598','2013-03-20','11:15:00',2.64),('14598','2013-03-20','11:20:00',2.56),('14598','2013-03-20','11:25:00',2.85),('14598','2013-03-20','11:30:00',3.31),('14598','2013-03-20','11:35:00',2.62),('14598','2013-03-20','11:40:00',2.15),('14598','2013-03-20','11:45:00',2.22),('14598','2013-03-20','11:50:00',2.29),('14598','2013-03-20','11:55:00',2.44),('14598','2013-03-20','12:00:00',2.17),('14598','2013-03-20','12:05:00',1.79),('14598','2013-03-20','12:10:00',1.42),('14598','2013-03-20','12:15:00',1.72),('14598','2013-03-20','12:20:00',1.74),('14598','2013-03-20','12:25:00',1.44),('14598','2013-03-20','12:30:00',2.34),('14598','2013-03-20','12:35:00',2.09),('14598','2013-03-20','12:40:00',1.96),('14598','2013-03-20','12:45:00',1.7),('14598','2013-03-20','12:50:00',1.49),('14598','2013-03-20','12:55:00',1.6),('14598','2013-03-20','13:00:00',2.14),('14598','2013-03-20','13:05:00',1.95),('14598','2013-03-20','13:10:00',1.57),('14598','2013-03-20','13:15:00',1.51),('14598','2013-03-20','13:20:00',1.85),('14598','2013-03-20','13:25:00',1.83),('14598','2013-03-20','13:30:00',1.77),('14598','2013-03-20','13:35:00',2.27),('14598','2013-03-20','13:40:00',2.05),('14598','2013-03-20','13:45:00',1.85),('14598','2013-03-20','13:50:00',1.73),('14598','2013-03-20','13:55:00',1.47),('14598','2013-03-20','14:00:00',1.2),('14598','2013-03-20','14:05:00',1.24),('14598','2013-03-20','14:10:00',1.35),('14598','2013-03-20','14:15:00',1.54),('14598','2013-03-20','14:20:00',1.68),('14598','2013-03-20','14:25:00',1.59),('14598','2013-03-20','14:30:00',1.3),('14598','2013-03-20','14:35:00',1.04),('14598','2013-03-19','08:10:00',1.21),('14598','2013-03-19','08:15:00',1.25),('14598','2013-03-19','08:20:00',1.45),('14598','2013-03-19','08:25:00',1.57),('14598','2013-03-19','08:30:00',1.71),('14598','2013-03-19','08:35:00',1.85),('14598','2013-03-19','08:40:00',1.99),('14598','2013-03-19','08:45:00',2.07),('14598','2013-03-19','08:50:00',2.18),('14598','2013-03-19','08:55:00',2.28),('14598','2013-03-19','09:00:00',2.39),('14598','2013-03-19','09:05:00',2.5),('14598','2013-03-19','09:10:00',2.61),('14598','2013-03-19','09:15:00',2.69),('14598','2013-03-19','09:20:00',2.79),('14598','2013-03-19','09:25:00',2.88),('14598','2013-03-19','09:30:00',2.97),('14598','2013-03-19','09:35:00',3.05),('14598','2013-03-19','09:40:00',3.15),('14598','2013-03-19','09:45:00',3.23),('14598','2013-03-19','09:50:00',3.33),('14598','2013-03-19','09:55:00',3.41),('14598','2013-03-19','10:00:00',3.5),('14598','2013-03-19','10:05:00',3.6),('14598','2013-03-19','10:10:00',3.68),('14598','2013-03-19','10:15:00',3.74),('14598','2013-03-19','10:20:00',3.83),('14598','2013-03-19','10:25:00',3.89),('14598','2013-03-19','10:30:00',3.97),('14598','2013-03-19','10:35:00',4.04),('14598','2013-03-19','10:40:00',4.14),('14598','2013-03-19','10:45:00',4.18),('14598','2013-03-19','10:50:00',4.25),('14598','2013-03-19','10:55:00',4.34),('14598','2013-03-19','11:00:00',4.35),('14598','2013-03-19','11:05:00',4.39),('14598','2013-03-19','11:10:00',4.44),('14598','2013-03-19','11:15:00',4.51),('14598','2013-03-19','11:20:00',4.54),('14598','2013-03-19','11:25:00',3.32),('14598','2013-03-19','11:30:00',3.69),('14598','2013-03-19','11:35:00',3.9),('14598','2013-03-19','11:40:00',4.27),('14598','2013-03-19','11:45:00',4.82),('14598','2013-03-19','11:50:00',4.8),('14598','2013-03-19','11:55:00',4.69),('14598','2013-03-19','12:00:00',4.8),('14598','2013-03-19','12:05:00',4.6),('14598','2013-03-19','12:10:00',4.83),('14598','2013-03-19','12:15:00',4.68),('14598','2013-03-19','12:20:00',4.91),('14598','2013-03-19','12:25:00',4.87),('14598','2013-03-19','12:30:00',4.91),('14598','2013-03-19','12:35:00',4.96),('14598','2013-03-19','12:40:00',4.42),('14598','2013-03-19','12:45:00',4.58),('14598','2013-03-19','12:50:00',4.82),('14598','2013-03-19','12:55:00',4.71),('14598','2013-03-19','13:00:00',4.84),('14598','2013-03-19','13:05:00',4.86),('14598','2013-03-19','13:10:00',4.8),('14598','2013-03-19','13:15:00',4.84),('14598','2013-03-19','13:20:00',4.84),('14598','2013-03-19','13:25:00',4.71),('14598','2013-03-19','13:30:00',4.58),('14598','2013-03-19','13:35:00',4.81),('14598','2013-03-19','13:40:00',4.75),('14598','2013-03-19','13:45:00',4.67),('14598','2013-03-19','13:50:00',4.63),('14598','2013-03-19','13:55:00',4.58),('14598','2013-03-19','14:00:00',4.54),('14598','2013-03-19','14:05:00',4.51),('14598','2013-03-19','14:10:00',4.46),('14598','2013-03-19','14:15:00',4.41),('14598','2013-03-19','14:20:00',4.36),('14598','2013-03-19','14:25:00',4.33),('14598','2013-03-19','14:30:00',4.29),('14598','2013-03-19','14:35:00',4.26),('14598','2013-03-19','14:40:00',4.2),('14598','2013-03-19','14:45:00',4.13),('14598','2013-03-19','14:50:00',4.06),('14598','2013-03-19','14:55:00',4.01),('14598','2013-03-19','15:00:00',3.95),('14598','2013-03-19','15:05:00',3.88),('14598','2013-03-19','15:10:00',3.82),('14598','2013-03-19','15:15:00',3.75),('14598','2013-03-19','15:20:00',3.67),('14598','2013-03-19','15:25:00',3.62),('14598','2013-03-19','15:30:00',3.56),('14598','2013-03-19','15:35:00',3.49),('14598','2013-03-19','15:40:00',3.4),('14598','2013-03-19','15:45:00',3.27),('14598','2013-03-19','15:50:00',3.2),('14598','2013-03-19','15:55:00',3.08),('14598','2013-03-19','16:00:00',3.02),('14598','2013-03-19','16:05:00',2.92),('14598','2013-03-19','16:10:00',2.84),('14598','2013-03-19','16:15:00',2.72),('14598','2013-03-19','16:20:00',2.63),('14598','2013-03-19','16:25:00',2.53),('14598','2013-03-19','16:30:00',2.41),('14598','2013-03-19','16:35:00',2.27),('14598','2013-03-19','16:40:00',1.78),('14598','2013-03-19','16:45:00',1.48),('14598','2013-03-19','16:50:00',1.6),('14598','2013-03-19','16:55:00',1.33),('14598','2013-03-19','17:00:00',1.33),('14598','2013-03-19','17:05:00',1.46),('14598','2013-03-19','17:10:00',1.54),('14598','2013-03-19','17:15:00',1.39),('14598','2013-03-19','17:20:00',1.09),('14598','2013-03-18','09:15:00',1.12),('14598','2013-03-18','09:20:00',1.43),('14598','2013-03-18','09:25:00',2.33),('14598','2013-03-18','09:30:00',1.26),('14598','2013-03-18','09:35:00',1.28),('14598','2013-03-18','09:40:00',1.23),('14598','2013-03-18','09:45:00',2.06),('14598','2013-03-18','09:50:00',2.87),('14598','2013-03-18','09:55:00',2.47),('14598','2013-03-18','10:00:00',2.8),('14598','2013-03-18','10:05:00',3.72),('14598','2013-03-18','10:10:00',3.06),('14598','2013-03-18','10:15:00',2.52),('14598','2013-03-18','10:20:00',2.26),('14598','2013-03-18','10:25:00',2.23),('14598','2013-03-18','10:30:00',2.82),('14598','2013-03-18','10:35:00',2.27),('14598','2013-03-18','10:40:00',2),('14598','2013-03-18','10:45:00',2.39),('14598','2013-03-18','10:50:00',2.65),('14598','2013-03-18','10:55:00',2.72),('14598','2013-03-18','11:00:00',2.87),('14598','2013-03-18','11:05:00',3.63),('14598','2013-03-18','11:10:00',4.09),('14598','2013-03-18','11:15:00',4.41),('14598','2013-03-18','11:20:00',3.48),('14598','2013-03-18','11:25:00',2.5),('14598','2013-03-18','11:30:00',2.01),('14598','2013-03-18','11:35:00',2.09),('14598','2013-03-18','11:40:00',1.92),('14598','2013-03-18','11:45:00',2.11),('14598','2013-03-18','11:50:00',2.22),('14598','2013-03-18','11:55:00',2.21),('14598','2013-03-18','12:00:00',1.84),('14598','2013-03-18','12:05:00',1.5),('14598','2013-03-18','12:10:00',1.86),('14598','2013-03-18','12:15:00',2.63),('14598','2013-03-18','12:20:00',1.97),('14598','2013-03-18','12:25:00',1.5),('14598','2013-03-18','12:30:00',1.54),('14598','2013-03-18','12:35:00',1.96),('14598','2013-03-18','12:40:00',2.24),('14598','2013-03-18','12:45:00',2.1),('14598','2013-03-18','12:50:00',1.17),('14598','2013-03-18','12:55:00',1.5),('14598','2013-03-18','13:00:00',1.95),('14598','2013-03-18','13:05:00',1.99),('14598','2013-03-18','13:10:00',2.25),('14598','2013-03-18','13:15:00',2.84),('14598','2013-03-18','13:20:00',1.58),('14598','2013-03-18','13:25:00',1.06),('14598','2013-03-18','13:30:00',1.6),('14598','2013-03-18','13:35:00',1.73),('14598','2013-03-18','13:40:00',1.29),('14598','2013-03-18','13:45:00',1.49),('14598','2013-03-18','13:50:00',2.6),('14598','2013-03-18','13:55:00',1.89),('14598','2013-03-18','14:00:00',2.95),('14598','2013-03-18','14:05:00',2.9),('14598','2013-03-18','14:10:00',1.45),('14598','2013-03-18','14:15:00',1.29),('14598','2013-03-18','14:30:00',1.19),('14598','2013-03-17','08:10:00',1.12),('14598','2013-03-17','08:15:00',1.13),('14598','2013-03-17','08:20:00',1.04),('14598','2013-03-17','08:25:00',1.08),('14598','2013-03-17','08:30:00',1.16),('14598','2013-03-17','08:35:00',1.07),('14598','2013-03-17','08:40:00',1.11),('14598','2013-03-17','08:45:00',1.06),('14598','2013-03-17','08:50:00',1.19),('14598','2013-03-17','08:55:00',1.49),('14598','2013-03-17','09:00:00',1.53),('14598','2013-03-17','09:05:00',1.38),('14598','2013-03-17','09:10:00',1.46),('14598','2013-03-17','09:15:00',1.49),('14598','2013-03-17','09:20:00',1.59),('14598','2013-03-17','09:25:00',1.58),('14598','2013-03-17','09:30:00',1.53),('14598','2013-03-17','09:35:00',1.59),('14598','2013-03-17','09:40:00',1.71),('14598','2013-03-17','09:45:00',1.71),('14598','2013-03-17','09:50:00',1.68),('14598','2013-03-17','09:55:00',1.74),('14598','2013-03-17','10:00:00',1.78),('14598','2013-03-17','10:05:00',2.02),('14598','2013-03-17','10:10:00',2.08),('14598','2013-03-17','10:15:00',1.88),('14598','2013-03-17','10:20:00',1.94),('14598','2013-03-17','10:25:00',1.94),('14598','2013-03-17','10:30:00',1.99),('14598','2013-03-17','10:35:00',1.72),('14598','2013-03-17','10:40:00',1.56),('14598','2013-03-17','10:45:00',1.61),('14598','2013-03-17','10:50:00',1.88),('14598','2013-03-17','10:55:00',2.33),('14598','2013-03-17','11:00:00',2.35),('14598','2013-03-17','11:05:00',2.4),('14598','2013-03-17','11:10:00',2.2),('14598','2013-03-17','11:15:00',2.23),('14598','2013-03-17','11:20:00',2.16),('14598','2013-03-17','11:25:00',1.97),('14598','2013-03-17','11:30:00',1.74),('14598','2013-03-17','11:35:00',1.56),('14598','2013-03-17','11:40:00',1.46),('14598','2013-03-17','11:45:00',1.31),('14598','2013-03-17','11:50:00',1.52),('14598','2013-03-17','11:55:00',1.84),('14598','2013-03-17','12:00:00',2.48),('14598','2013-03-17','12:05:00',3.6),('14598','2013-03-17','12:10:00',4.56),('14598','2013-03-17','12:15:00',4.21),('14598','2013-03-17','12:20:00',3.46),('14598','2013-03-17','12:25:00',3.18),('14598','2013-03-17','12:30:00',2.54),('14598','2013-03-17','12:35:00',2.48),('14598','2013-03-17','12:40:00',3.09),('14598','2013-03-17','12:45:00',3.15),('14598','2013-03-17','12:50:00',2.79),('14598','2013-03-17','12:55:00',2.45),('14598','2013-03-17','13:00:00',2.66),('14598','2013-03-17','13:05:00',2.41),('14598','2013-03-17','13:10:00',1.96),('14598','2013-03-17','13:15:00',2.36),('14598','2013-03-17','13:20:00',2.52),('14598','2013-03-17','13:25:00',2.57),('14598','2013-03-17','13:30:00',1.83),('14598','2013-03-17','13:35:00',1.67),('14598','2013-03-17','13:40:00',2.32),('14598','2013-03-17','13:45:00',2.05),('14598','2013-03-17','13:50:00',2.07),('14598','2013-03-17','13:55:00',2.36),('14598','2013-03-17','14:00:00',2.56),('14598','2013-03-17','14:05:00',2.45),('14598','2013-03-17','14:10:00',2.59),('14598','2013-03-17','14:15:00',2.19),('14598','2013-03-17','14:20:00',2.25),('14598','2013-03-17','14:25:00',2.29),('14598','2013-03-17','14:30:00',1.97),('14598','2013-03-17','14:35:00',1.91),('14598','2013-03-17','14:40:00',1.66),('14598','2013-03-17','14:45:00',1.72),('14598','2013-03-17','14:50:00',1.76),('14598','2013-03-17','14:55:00',1.93),('14598','2013-03-17','15:00:00',2.38),('14598','2013-03-17','15:05:00',1.99),('14598','2013-03-17','15:10:00',2.25),('14598','2013-03-17','15:15:00',1.89),('14598','2013-03-17','15:20:00',1.39),('14598','2013-03-17','15:25:00',1.1),('14598','2013-03-17','15:30:00',1.04),('14598','2013-03-17','16:05:00',1.23),('14598','2013-03-17','16:30:00',1.01),('14598','2013-03-17','16:35:00',1.76),('14598','2013-03-16','08:05:00',1.02),('14598','2013-03-16','08:20:00',1.26),('14598','2013-03-16','08:25:00',1.83),('14598','2013-03-16','08:30:00',1.88),('14598','2013-03-16','08:35:00',1.66),('14598','2013-03-16','08:40:00',1.61),('14598','2013-03-16','08:45:00',1.62),('14598','2013-03-16','08:50:00',1.48),('14598','2013-03-16','08:55:00',1.61),('14598','2013-03-16','09:00:00',1.96),('14598','2013-03-16','09:05:00',1.91),('14598','2013-03-16','09:10:00',2.37),('14598','2013-03-16','09:15:00',2.69),('14598','2013-03-16','09:20:00',2.77),('14598','2013-03-16','09:25:00',2.89),('14598','2013-03-16','09:30:00',2.63),('14598','2013-03-16','09:35:00',3.24),('14598','2013-03-16','09:40:00',3.58),('14598','2013-03-16','09:45:00',2.8),('14598','2013-03-16','09:50:00',3.53),('14598','2013-03-16','09:55:00',3.97),('14598','2013-03-16','10:00:00',3.71),('14598','2013-03-16','10:05:00',3.85),('14598','2013-03-16','10:10:00',3.93),('14598','2013-03-16','10:15:00',3.82),('14598','2013-03-16','10:20:00',3.79),('14598','2013-03-16','10:25:00',3.86),('14598','2013-03-16','10:30:00',3.96),('14598','2013-03-16','10:35:00',4),('14598','2013-03-16','10:40:00',4.03),('14598','2013-03-16','10:45:00',4.09),('14598','2013-03-16','10:50:00',4.15),('14598','2013-03-16','10:55:00',4.09),('14598','2013-03-16','11:00:00',4.23),('14598','2013-03-16','11:05:00',4.26),('14598','2013-03-16','11:10:00',4.31),('14598','2013-03-16','11:15:00',4.35),('14598','2013-03-16','11:20:00',4.4),('14598','2013-03-16','11:25:00',4.45),('14598','2013-03-16','11:30:00',4.49),('14598','2013-03-16','11:35:00',4.52),('14598','2013-03-16','11:40:00',4.53),('14598','2013-03-16','11:45:00',4.55),('14598','2013-03-16','11:50:00',4.57),('14598','2013-03-16','11:55:00',4.62),('14598','2013-03-16','12:00:00',4.64),('14598','2013-03-16','12:05:00',4.64),('14598','2013-03-16','12:10:00',4.58),('14598','2013-03-16','12:15:00',4.65),('14598','2013-03-16','12:20:00',4.61),('14598','2013-03-16','12:25:00',4.55),('14598','2013-03-16','12:30:00',4.27),('14598','2013-03-16','12:35:00',3.7),('14598','2013-03-16','12:40:00',1.78),('14598','2013-03-16','12:55:00',3.91),('14598','2013-03-16','13:00:00',5.36),('14598','2013-03-16','13:05:00',5.21),('14598','2013-03-16','13:10:00',5.24),('14598','2013-03-16','13:15:00',5),('14598','2013-03-16','13:20:00',4.1),('14598','2013-03-16','13:25:00',4.36),('14598','2013-03-16','13:30:00',3.63),('14598','2013-03-16','13:35:00',3),('14598','2013-03-16','13:40:00',1.68),('14598','2013-03-16','13:45:00',4.44),('14598','2013-03-16','13:50:00',4.35),('14598','2013-03-16','13:55:00',4.68),('14598','2013-03-16','14:00:00',4.4),('14598','2013-03-16','14:05:00',4.35),('14598','2013-03-16','14:10:00',4.32),('14598','2013-03-16','14:15:00',4.25),('14598','2013-03-16','14:20:00',4.28),('14598','2013-03-16','14:25:00',4.29),('14598','2013-03-16','14:30:00',4.28),('14598','2013-03-16','14:35:00',4.22),('14598','2013-03-16','14:40:00',4.15),('14598','2013-03-16','14:45:00',4.08),('14598','2013-03-16','14:50:00',4.04),('14598','2013-03-16','14:55:00',4),('14598','2013-03-16','15:00:00',3.97),('14598','2013-03-16','15:05:00',3.9),('14598','2013-03-16','15:10:00',3.84),('14598','2013-03-16','15:15:00',3.73),('14598','2013-03-16','15:20:00',3.68),('14598','2013-03-16','15:25:00',3.6),('14598','2013-03-16','15:30:00',3.51),('14598','2013-03-16','15:35:00',3.42),('14598','2013-03-16','15:40:00',3.35),('14598','2013-03-16','15:45:00',3.27),('14598','2013-03-16','15:50:00',3.17),('14598','2013-03-16','15:55:00',3.06),('14598','2013-03-16','16:00:00',2.99),('14598','2013-03-16','16:05:00',2.89),('14598','2013-03-16','16:10:00',2.79),('14598','2013-03-16','16:15:00',2.67),('14598','2013-03-16','16:20:00',2.59),('14598','2013-03-16','16:25:00',2.51),('14598','2013-03-16','16:30:00',2.36),('14598','2013-03-16','16:35:00',2.26),('14598','2013-03-16','16:40:00',2.13),('14598','2013-03-16','16:45:00',2.01),('14598','2013-03-16','16:50:00',1.89),('14598','2013-03-16','16:55:00',1.73),('14598','2013-03-16','17:00:00',1.59),('14598','2013-03-16','17:05:00',1.48),('14598','2013-03-16','17:10:00',1.35),('14598','2013-03-16','17:15:00',1.2),('14598','2013-03-16','17:20:00',1.07),('14598','2013-03-15','10:10:00',1.17),('14598','2013-03-15','10:15:00',1.51),('14598','2013-03-15','10:20:00',1.68),('14598','2013-03-15','10:25:00',1.63),('14598','2013-03-15','10:30:00',1.61),('14598','2013-03-15','10:35:00',1.75),('14598','2013-03-15','10:40:00',1.84),('14598','2013-03-15','10:45:00',1.62),('14598','2013-03-15','10:50:00',1.54),('14598','2013-03-15','10:55:00',1.74),('14598','2013-03-15','11:00:00',1.58),('14598','2013-03-15','11:05:00',1.46),('14598','2013-03-15','11:10:00',1.77),('14598','2013-03-15','11:15:00',1.87),('14598','2013-03-15','11:20:00',1.94),('14598','2013-03-15','11:25:00',2.05),('14598','2013-03-15','11:30:00',1.9),('14598','2013-03-15','11:35:00',1.76),('14598','2013-03-15','11:40:00',1.76),('14598','2013-03-15','11:45:00',1.88),('14598','2013-03-15','11:50:00',1.94),('14598','2013-03-15','11:55:00',1.82),('14598','2013-03-15','12:00:00',1.8),('14598','2013-03-15','12:05:00',1.94),('14598','2013-03-15','12:10:00',2.35),('14598','2013-03-15','12:15:00',2.33),('14598','2013-03-15','12:20:00',2.27),('14598','2013-03-15','12:25:00',2.38),('14598','2013-03-15','12:30:00',2.58),('14598','2013-03-15','12:35:00',2.84),('14598','2013-03-15','12:40:00',2.7),('14598','2013-03-15','12:45:00',2.4),('14598','2013-03-15','12:50:00',2.71),('14598','2013-03-15','12:55:00',2.76),('14598','2013-03-15','13:00:00',2.94),('14598','2013-03-15','13:05:00',2.54),('14598','2013-03-15','13:10:00',2.17),('14598','2013-03-15','13:15:00',2.01),('14598','2013-03-15','13:20:00',1.76),('14598','2013-03-15','13:25:00',1.46),('14598','2013-03-15','13:30:00',1.41),('14598','2013-03-15','13:35:00',1.52),('14598','2013-03-15','13:40:00',1.39),('14598','2013-03-15','13:45:00',1.31),('14598','2013-03-15','13:50:00',1.09),('14598','2013-03-15','14:15:00',1.13),('14598','2013-03-15','14:20:00',1.56),('14598','2013-03-15','14:25:00',2.03),('14598','2013-03-15','14:30:00',2.82),('14598','2013-03-15','14:35:00',3.17),('14598','2013-03-15','14:40:00',3.48),('14598','2013-03-15','14:45:00',2.71),('14598','2013-03-15','14:50:00',3.04),('14598','2013-03-15','14:55:00',2.87),('14598','2013-03-15','15:00:00',2.91),('14598','2013-03-15','15:05:00',2.26),('14598','2013-03-15','15:10:00',2.13),('14598','2013-03-15','15:15:00',2.16),('14598','2013-03-15','15:20:00',1.48),('14598','2013-03-15','15:25:00',1.35),('14598','2013-03-15','15:30:00',1.31),('14598','2013-03-15','15:35:00',1.48),('14598','2013-03-15','15:40:00',1.35),('14598','2013-03-15','15:45:00',1.23),('14598','2013-03-15','16:45:00',1.13),('14598','2013-03-15','17:00:00',1.46),('14598','2013-03-15','17:05:00',1.24),('14598','2013-03-15','17:10:00',1.32),('14598','2013-03-15','17:15:00',1.15),('14598','2013-03-15','17:20:00',1.06),('14598','2013-03-15','17:25:00',1.09),('14598','2013-03-14','11:45:00',1.04),('14598','2013-03-14','12:20:00',1.1),('14598','2013-03-14','12:25:00',1.29),('14598','2013-03-14','12:30:00',1.57),('14598','2013-03-14','12:35:00',1.88),('14598','2013-03-14','12:40:00',2.02),('14598','2013-03-14','12:45:00',1.83),('14598','2013-03-14','12:50:00',1.83),('14598','2013-03-14','12:55:00',1.98),('14598','2013-03-14','13:00:00',1.9),('14598','2013-03-14','13:05:00',1.84),('14598','2013-03-14','13:10:00',1.54),('14598','2013-03-14','13:15:00',1.5),('14598','2013-03-14','13:20:00',1.68),('14598','2013-03-14','13:25:00',1.76),('14598','2013-03-14','13:30:00',1.73),('14598','2013-03-14','13:35:00',1.65),('14598','2013-03-14','13:40:00',1.54),('14598','2013-03-14','13:45:00',1.51),('14598','2013-03-14','13:50:00',1.31),('14598','2013-03-14','14:00:00',1.01),('14598','2013-03-14','14:05:00',1.31),('14598','2013-03-14','14:10:00',1.16),('14598','2013-03-14','14:25:00',1.17),('14598','2013-03-14','14:30:00',1.15),('14598','2013-03-14','14:35:00',1.35),('14598','2013-03-14','14:40:00',1.72),('14598','2013-03-14','14:45:00',1.51),('14598','2013-03-14','14:50:00',1.44),('14598','2013-03-14','14:55:00',1.25),('14598','2013-03-14','15:00:00',1.01),('14598','2013-03-14','15:05:00',1.01),('14598','2013-03-13','08:40:00',1.13),('14598','2013-03-13','08:45:00',1.09),('14598','2013-03-13','08:50:00',1.11),('14598','2013-03-13','08:55:00',1.08),('14598','2013-03-13','09:10:00',1.05),('14598','2013-03-13','09:35:00',1.12),('14598','2013-03-13','09:40:00',1.61),('14598','2013-03-13','09:45:00',1.64),('14598','2013-03-13','09:50:00',1.09),('14598','2013-03-13','10:25:00',1.33),('14598','2013-03-13','10:30:00',2.58),('14598','2013-03-13','10:35:00',3.4),('14598','2013-03-13','10:40:00',3.12),('14598','2013-03-13','10:45:00',3.28),('14598','2013-03-13','10:50:00',3.05),('14598','2013-03-13','10:55:00',3.19),('14598','2013-03-13','11:00:00',2.97),('14598','2013-03-13','11:05:00',1.95),('14598','2013-03-13','11:10:00',1.54),('14598','2013-03-13','11:15:00',1.77),('14598','2013-03-13','11:20:00',1.97),('14598','2013-03-13','11:25:00',1.83),('14598','2013-03-13','11:30:00',1.88),('14598','2013-03-13','11:35:00',1.65),('14598','2013-03-13','11:40:00',1.03),('14598','2013-03-13','12:20:00',1.09),('14598','2013-03-13','12:25:00',1.29),('14598','2013-03-13','12:30:00',1.35),('14598','2013-03-13','12:35:00',1.51),('14598','2013-03-13','12:40:00',1.5),('14598','2013-03-13','12:45:00',1.66),('14598','2013-03-13','12:50:00',1.28),('14598','2013-03-13','13:00:00',1.15),('14598','2013-03-13','13:05:00',1.22),('14598','2013-03-13','13:10:00',1.29),('14598','2013-03-13','13:15:00',1.47),('14598','2013-03-13','13:20:00',1.68),('14598','2013-03-13','13:25:00',1.76),('14598','2013-03-13','13:30:00',1.67),('14598','2013-03-13','13:35:00',1.57),('14598','2013-03-13','13:40:00',1.39),('14598','2013-03-13','13:45:00',1.21),('14598','2014-03-25','07:40:00',1.01),('14598','2014-03-25','07:45:00',1.04),('14598','2014-03-25','07:50:00',1.03),('14598','2014-03-25','07:55:00',1.11),('14598','2014-03-25','08:00:00',1.25),('14598','2014-03-25','08:05:00',1.29),('14598','2014-03-25','08:10:00',1.24),('14598','2014-03-25','08:15:00',1.13),('14598','2014-03-25','08:20:00',1.05),('14598','2014-03-25','08:25:00',1.15),('14598','2014-03-25','08:30:00',1.36),('14598','2014-03-25','08:35:00',1.62),('14598','2014-03-25','08:40:00',1.72),('14598','2014-03-25','08:45:00',1.84),('14598','2014-03-25','08:50:00',1.67),('14598','2014-03-25','08:55:00',1.65),('14598','2014-03-25','09:00:00',1.77),('14598','2014-03-25','09:05:00',2.28),('14598','2014-03-25','09:10:00',2.32),('14598','2014-03-25','09:15:00',2.11),('14598','2014-03-25','09:20:00',1.9),('14598','2014-03-25','09:25:00',1.82),('14598','2014-03-25','09:30:00',1.84),('14598','2014-03-25','09:35:00',1.85),('14598','2014-03-25','09:40:00',1.95),('14598','2014-03-25','09:45:00',2.07),('14598','2014-03-25','09:50:00',2.35),('14598','2014-03-25','09:55:00',2.45),('14598','2014-03-25','10:00:00',2.57),('14598','2014-03-25','10:05:00',2.56),('14598','2014-03-25','10:10:00',2.81),('14598','2014-03-25','10:15:00',2.58),('14598','2014-03-25','10:20:00',2.41),('14598','2014-03-25','10:25:00',2.33),('14598','2014-03-25','10:30:00',2.13),('14598','2014-03-25','10:35:00',2.06),('14598','2014-03-25','10:40:00',2.15),('14598','2014-03-25','10:45:00',2.16),('14598','2014-03-25','10:50:00',2.13),('14598','2014-03-25','10:55:00',2.19),('14598','2014-03-25','11:00:00',2.3),('14598','2014-03-25','11:05:00',2.42),('14598','2014-03-25','11:10:00',2.52),('14598','2014-03-25','11:15:00',2.56),('14598','2014-03-25','11:20:00',2.62),('14598','2014-03-25','11:25:00',2.62),('14598','2014-03-25','11:30:00',2.43),('14598','2014-03-25','11:35:00',2.32),('14598','2014-03-25','11:40:00',2.17),('14598','2014-03-25','11:45:00',2.03),('14598','2014-03-25','11:50:00',1.97),('14598','2014-03-25','11:55:00',1.94),('14598','2014-03-25','12:00:00',1.96),('14598','2014-03-25','12:05:00',1.99),('14598','2014-03-25','12:10:00',1.91),('14598','2014-03-25','12:15:00',1.81),('14598','2014-03-25','12:20:00',1.71),('14598','2014-03-25','12:25:00',1.71),('14598','2014-03-25','12:30:00',1.68),('14598','2014-03-25','12:35:00',1.66),('14598','2014-03-25','12:40:00',1.62),('14598','2014-03-25','12:45:00',1.19),('14598','2014-03-25','12:50:00',1.15),('14598','2014-03-25','14:30:00',1.07),('14598','2014-03-25','14:35:00',1.01),('14598','2013-03-12','08:25:00',1.3),('14598','2013-03-12','08:30:00',1.51),('14598','2013-03-12','08:35:00',1.42),('14598','2013-03-12','08:40:00',1.62),('14598','2013-03-12','08:45:00',1.77),('14598','2013-03-12','08:50:00',1.94),('14598','2013-03-12','08:55:00',2.04),('14598','2013-03-12','09:00:00',2.13),('14598','2013-03-12','09:05:00',2.22),('14598','2013-03-12','09:10:00',2.33),('14598','2013-03-12','09:15:00',2.44),('14598','2013-03-12','09:20:00',2.53),('14598','2013-03-12','09:25:00',2.61),('14598','2013-03-12','09:30:00',2.71),('14598','2013-03-12','09:35:00',2.81),('14598','2013-03-12','09:40:00',2.91),('14598','2013-03-12','09:45:00',2.99),('14598','2013-03-12','09:50:00',3.08),('14598','2013-03-12','09:55:00',3.18),('14598','2013-03-12','10:00:00',3.24),('14598','2013-03-12','10:05:00',3.35),('14598','2013-03-12','10:10:00',3.42),('14598','2013-03-12','10:15:00',3.5),('14598','2013-03-12','10:20:00',3.55),('14598','2013-03-12','10:25:00',3.62),('14598','2013-03-12','10:30:00',3.7),('14598','2013-03-12','10:35:00',3.79),('14598','2013-03-12','10:40:00',3.86),('14598','2013-03-12','10:45:00',3.94),('14598','2013-03-12','10:50:00',4.03),('14598','2013-03-12','10:55:00',3.77),('14598','2013-03-12','11:00:00',3.55),('14598','2013-03-12','11:05:00',3.08),('14598','2013-03-12','11:10:00',2.69),('14598','2013-03-12','11:15:00',4.42),('14598','2013-03-12','11:20:00',2.24),('14598','2013-03-12','11:25:00',3.76),('14598','2013-03-12','11:30:00',5.26),('14598','2013-03-12','11:35:00',2.78),('14598','2013-03-12','11:40:00',4.77),('14598','2013-03-12','11:45:00',2.33),('14598','2013-03-12','11:50:00',1.45),('14598','2013-03-12','11:55:00',2.01),('14598','2013-03-12','12:00:00',3.8),('14598','2013-03-12','12:05:00',4.43),('14598','2013-03-12','12:10:00',5.25),('14598','2013-03-12','12:15:00',3.52),('14598','2013-03-12','12:20:00',3.38),('14598','2013-03-12','12:25:00',4.84),('14598','2013-03-12','12:30:00',4.8),('14598','2013-03-12','12:35:00',4.2),('14598','2013-03-12','12:40:00',4.77),('14598','2013-03-12','12:45:00',4.55),('14598','2013-03-12','12:50:00',4.19),('14598','2013-03-12','12:55:00',4.69),('14598','2013-03-12','13:00:00',4.4),('14598','2013-03-12','13:05:00',2.56),('14598','2013-03-12','13:10:00',2.54),('14598','2013-03-12','13:15:00',2.76),('14598','2013-03-12','13:20:00',4.13),('14598','2013-03-12','13:25:00',3.73),('14598','2013-03-12','13:30:00',3.25),('14598','2013-03-12','13:35:00',3.48),('14598','2013-03-12','13:40:00',3.33),('14598','2013-03-12','13:45:00',2.17),('14598','2013-03-12','13:50:00',2.11),('14598','2013-03-12','13:55:00',3.56),('14598','2013-03-12','14:00:00',1.98),('14598','2013-03-12','14:05:00',2.82),('14598','2013-03-12','14:10:00',4.02),('14598','2013-03-12','14:15:00',1.46),('14598','2013-03-12','14:30:00',1.8),('14598','2013-03-12','14:35:00',2.6),('14598','2013-03-12','14:40:00',2.69),('14598','2013-03-12','14:45:00',2.9),('14598','2013-03-12','14:50:00',1.74),('14598','2013-03-12','14:55:00',1.79),('14598','2013-03-12','15:00:00',2.77),('14598','2013-03-12','15:05:00',2.44),('14598','2013-03-12','15:10:00',2.29),('14598','2013-03-12','15:15:00',1.67),('14598','2013-03-12','15:20:00',1.56),('14598','2013-03-12','15:25:00',1.25),('14598','2013-03-12','15:30:00',1.13),('14598','2013-03-12','16:00:00',2.69),('14598','2013-03-12','16:05:00',1.57),('14598','2013-03-12','16:15:00',1.26),('14598','2013-03-12','16:20:00',1.4),('14598','2013-03-12','16:25:00',1.12),('14598','2013-03-11','08:15:00',1.04),('14598','2013-03-11','08:20:00',1.15),('14598','2013-03-11','08:25:00',1.24),('14598','2013-03-11','08:30:00',1.38),('14598','2013-03-11','08:35:00',1.5),('14598','2013-03-11','08:40:00',1.63),('14598','2013-03-11','08:45:00',1.74),('14598','2013-03-11','08:50:00',1.84),('14598','2013-03-11','08:55:00',1.97),('14598','2013-03-11','09:00:00',2.08),('14598','2013-03-11','09:05:00',2.23),('14598','2013-03-11','09:10:00',1.8),('14598','2013-03-11','09:15:00',1.99),('14598','2013-03-11','09:20:00',1.83),('14598','2013-03-11','09:25:00',2.44),('14598','2013-03-11','09:30:00',1.83),('14598','2013-03-11','09:35:00',2.31),('14598','2013-03-11','09:40:00',1.69),('14598','2013-03-11','09:45:00',1.67),('14598','2013-03-11','09:50:00',1.53),('14598','2013-03-11','09:55:00',1.46),('14598','2013-03-11','10:00:00',1.5),('14598','2013-03-11','10:05:00',1.49),('14598','2013-03-11','10:10:00',1.57),('14598','2013-03-11','10:15:00',1.74),('14598','2013-03-11','10:20:00',1.86),('14598','2013-03-11','10:25:00',1.96),('14598','2013-03-11','10:30:00',2.39),('14598','2013-03-11','10:35:00',2.71),('14598','2013-03-11','10:40:00',2.93),('14598','2013-03-11','10:45:00',2.62),('14598','2013-03-11','10:50:00',2.46),('14598','2013-03-11','10:55:00',2.66),('14598','2013-03-11','11:00:00',3.06),('14598','2013-03-11','11:05:00',4.77),('14598','2013-03-11','11:10:00',3.02),('14598','2013-03-11','11:15:00',2.66),('14598','2013-03-11','11:20:00',3.07),('14598','2013-03-11','11:25:00',4.72),('14598','2013-03-11','11:30:00',5),('14598','2013-03-11','11:35:00',5.12),('14598','2013-03-11','11:40:00',4.92),('14598','2013-03-11','11:45:00',5.67),('14598','2013-03-11','11:50:00',4.17),('14598','2013-03-11','11:55:00',3.97),('14598','2013-03-11','12:00:00',4.16),('14598','2013-03-11','12:05:00',3.9),('14598','2013-03-11','12:10:00',3.35),('14598','2013-03-11','12:15:00',3.4),('14598','2013-03-11','12:20:00',3.95),('14598','2013-03-11','12:25:00',3.55),('14598','2013-03-11','12:30:00',3.02),('14598','2013-03-11','12:35:00',2.89),('14598','2013-03-11','12:40:00',3.16),('14598','2013-03-11','12:45:00',3.44),('14598','2013-03-11','12:50:00',4.21),('14598','2013-03-11','12:55:00',3.38),('14598','2013-03-11','13:00:00',3.3),('14598','2013-03-11','13:05:00',4.53),('14598','2013-03-11','13:10:00',4.58),('14598','2013-03-11','13:15:00',4.53),('14598','2013-03-11','13:20:00',4.51),('14598','2013-03-11','13:25:00',4.47),('14598','2013-03-11','13:30:00',4.48),('14598','2013-03-11','13:35:00',4.37),('14598','2013-03-11','13:40:00',4),('14598','2013-03-11','13:45:00',4.45),('14598','2013-03-11','13:50:00',4.35),('14598','2013-03-11','13:55:00',4.25),('14598','2013-03-11','14:00:00',4.28),('14598','2013-03-11','14:05:00',4.26),('14598','2013-03-11','14:10:00',4.23),('14598','2013-03-11','14:15:00',4.2),('14598','2013-03-11','14:20:00',4.16),('14598','2013-03-11','14:25:00',4.06),('14598','2013-03-11','14:30:00',3.79),('14598','2013-03-11','14:35:00',3.91),('14598','2013-03-11','14:40:00',3.43),('14598','2013-03-11','14:45:00',3.87),('14598','2013-03-11','14:50:00',3.73),('14598','2013-03-11','14:55:00',4.03),('14598','2013-03-11','15:00:00',2.87),('14598','2013-03-11','15:05:00',3.52),('14598','2013-03-11','15:10:00',2.95),('14598','2013-03-11','15:15:00',1.96),('14598','2013-03-11','15:20:00',1.63),('14598','2013-03-11','15:25:00',3.24),('14598','2013-03-11','15:30:00',3.54),('14598','2013-03-11','15:35:00',3.38),('14598','2013-03-11','15:40:00',1.46),('14598','2013-03-11','15:45:00',2.1),('14598','2013-03-11','15:50:00',2.89),('14598','2013-03-11','15:55:00',2.61),('14598','2013-03-11','16:00:00',2.41),('14598','2013-03-11','16:05:00',2.64),('14598','2013-03-11','16:10:00',1.76),('14598','2013-03-11','16:15:00',1.19),('14598','2013-03-11','16:20:00',1.34),('14598','2013-03-11','16:30:00',1.56),('14598','2013-03-11','16:35:00',1.56),('14598','2013-03-11','16:50:00',1.42),('14598','2013-03-11','16:55:00',1.2),('14598','2013-03-11','17:00:00',1.63),('14598','2013-03-11','17:05:00',1.33),('14598','2013-03-11','17:10:00',1.02),('14598','2013-03-10','08:15:00',1.03),('14598','2013-03-10','08:20:00',1.14),('14598','2013-03-10','08:25:00',1.24),('14598','2013-03-10','08:30:00',1.41),('14598','2013-03-10','08:35:00',1.53),('14598','2013-03-10','08:40:00',1.66),('14598','2013-03-10','08:45:00',1.78),('14598','2013-03-10','08:50:00',1.89),('14598','2013-03-10','08:55:00',2),('14598','2013-03-10','09:00:00',2.1),('14598','2013-03-10','09:05:00',2.19),('14598','2013-03-10','09:10:00',2.3),('14598','2013-03-10','09:15:00',2.37),('14598','2013-03-10','09:20:00',2.47),('14598','2013-03-10','09:25:00',2.56),('14598','2013-03-10','09:30:00',2.66),('14598','2013-03-10','09:35:00',2.73),('14598','2013-03-10','09:40:00',2.83),('14598','2013-03-10','09:45:00',2.93),('14598','2013-03-10','09:50:00',3),('14598','2013-03-10','09:55:00',3.1),('14598','2013-03-10','10:00:00',3.18),('14598','2013-03-10','10:05:00',3.26),('14598','2013-03-10','10:10:00',3.33),('14598','2013-03-10','10:15:00',3.42),('14598','2013-03-10','10:20:00',3.47),('14598','2013-03-10','10:25:00',3.54),('14598','2013-03-10','10:30:00',3.6),('14598','2013-03-10','10:35:00',3.67),('14598','2013-03-10','10:40:00',3.73),('14598','2013-03-10','10:45:00',3.8),('14598','2013-03-10','10:50:00',3.86),('14598','2013-03-10','10:55:00',3.9),('14598','2013-03-10','11:00:00',3.94),('14598','2013-03-10','11:05:00',4),('14598','2013-03-10','11:10:00',4.04),('14598','2013-03-10','11:15:00',4.09),('14598','2013-03-10','11:20:00',4.16),('14598','2013-03-10','11:25:00',4.11),('14598','2013-03-10','11:30:00',4.24),('14598','2013-03-10','11:35:00',4.24),('14598','2013-03-10','11:40:00',4.28),('14598','2013-03-10','11:45:00',4.32),('14598','2013-03-10','11:50:00',4.35),('14598','2013-03-10','11:55:00',4.39),('14598','2013-03-10','12:00:00',4.42),('14598','2013-03-10','12:05:00',4.45),('14598','2013-03-10','12:10:00',4.47),('14598','2013-03-10','12:15:00',4.45),('14598','2013-03-10','12:20:00',4.45),('14598','2013-03-10','12:25:00',4.51),('14598','2013-03-10','12:30:00',4.38),('14598','2013-03-10','12:35:00',2.26),('14598','2013-03-10','12:40:00',3.09),('14598','2013-03-10','12:45:00',4.91),('14598','2013-03-10','12:50:00',4.94),('14598','2013-03-10','12:55:00',4.66),('14598','2013-03-10','13:00:00',4.77),('14598','2013-03-10','13:05:00',4.71),('14598','2013-03-10','13:10:00',4.22),('14598','2013-03-10','13:15:00',3.64),('14598','2013-03-10','13:20:00',3.86),('14598','2013-03-10','13:25:00',3.03),('14598','2013-03-10','13:30:00',2.83),('14598','2013-03-10','13:35:00',2.29),('14598','2013-03-10','13:40:00',1.93),('14598','2013-03-10','13:45:00',1.81),('14598','2013-03-10','13:50:00',1.74),('14598','2013-03-10','13:55:00',1.82),('14598','2013-03-10','14:00:00',2.35),('14598','2013-03-10','14:05:00',2.73),('14598','2013-03-10','14:10:00',2.02),('14598','2013-03-10','14:15:00',2.42),('14598','2013-03-10','14:20:00',2.22),('14598','2013-03-10','14:25:00',2.17),('14598','2013-03-10','14:30:00',2.21),('14598','2013-03-10','14:35:00',1.8),('14598','2013-03-10','14:40:00',2),('14598','2013-03-10','14:45:00',1.14),('14598','2013-03-10','15:05:00',1.14),('14598','2013-03-09','08:15:00',1.01),('14598','2013-03-09','08:20:00',1.11),('14598','2013-03-09','08:25:00',1.22),('14598','2013-03-09','08:30:00',1.33),('14598','2013-03-09','08:35:00',1.38),('14598','2013-03-09','08:40:00',1.19),('14598','2013-03-09','08:45:00',1.09),('14598','2013-03-09','08:50:00',1.23),('14598','2013-03-09','08:55:00',1.91),('14598','2013-03-09','09:00:00',2.03),('14598','2013-03-09','09:05:00',2.15),('14598','2013-03-09','09:10:00',2.23),('14598','2013-03-09','09:15:00',2.33),('14598','2013-03-09','09:20:00',2.43),('14598','2013-03-09','09:25:00',2.52),('14598','2013-03-09','09:30:00',2.6),('14598','2013-03-09','09:35:00',2.7),('14598','2013-03-09','09:40:00',2.79),('14598','2013-03-09','09:45:00',2.87),('14598','2013-03-09','09:50:00',2.97),('14598','2013-03-09','09:55:00',3.04),('14598','2013-03-09','10:00:00',3.13),('14598','2013-03-09','10:05:00',3.21),('14598','2013-03-09','10:10:00',3.3),('14598','2013-03-09','10:15:00',3.37),('14598','2013-03-09','10:20:00',3.44),('14598','2013-03-09','10:25:00',3.52),('14598','2013-03-09','10:30:00',3.6),('14598','2013-03-09','10:35:00',3.67),('14598','2013-03-09','10:40:00',3.72),('14598','2013-03-09','10:45:00',3.78),('14598','2013-03-09','10:50:00',3.86),('14598','2013-03-09','10:55:00',3.92),('14598','2013-03-09','11:00:00',3.97),('14598','2013-03-09','11:05:00',4.03),('14598','2013-03-09','11:10:00',4.08),('14598','2013-03-09','11:15:00',4.12),('14598','2013-03-09','11:20:00',4.14),('14598','2013-03-09','11:25:00',4.15),('14598','2013-03-09','11:30:00',4.24),('14598','2013-03-09','11:35:00',4.23),('14598','2013-03-09','11:40:00',4.31),('14598','2013-03-09','11:45:00',4.51),('14598','2013-03-09','11:50:00',3.22),('14598','2013-03-09','11:55:00',3.14),('14598','2013-03-09','12:00:00',4.43),('14598','2013-03-09','12:05:00',3.8),('14598','2013-03-09','12:10:00',3.64),('14598','2013-03-09','12:15:00',3.84),('14598','2013-03-09','12:20:00',4.61),('14598','2013-03-09','12:25:00',4.64),('14598','2013-03-09','12:30:00',4.48),('14598','2013-03-09','12:35:00',4.48),('14598','2013-03-09','12:40:00',4.49),('14598','2013-03-09','12:45:00',4.51),('14598','2013-03-09','12:50:00',4.5),('14598','2013-03-09','12:55:00',4.48),('14598','2013-03-09','13:00:00',4.49),('14598','2013-03-09','13:05:00',4.48),('14598','2013-03-09','13:10:00',4.46),('14598','2013-03-09','13:15:00',4.46),('14598','2013-03-09','13:20:00',4.45),('14598','2013-03-09','13:25:00',4.41),('14598','2013-03-09','13:30:00',4.4),('14598','2013-03-09','13:35:00',4.39),('14598','2013-03-09','13:40:00',4.34),('14598','2013-03-09','13:45:00',4.31),('14598','2013-03-09','13:50:00',4.29),('14598','2013-03-09','13:55:00',4.26),('14598','2013-03-09','14:00:00',4.22),('14598','2013-03-09','14:05:00',4.2),('14598','2013-03-09','14:10:00',4.15),('14598','2013-03-09','14:15:00',4.13),('14598','2013-03-09','14:20:00',4.07),('14598','2013-03-09','14:25:00',4),('14598','2013-03-09','14:30:00',3.96),('14598','2013-03-09','14:35:00',3.92),('14598','2013-03-09','14:40:00',3.79),('14598','2013-03-09','14:45:00',3.77),('14598','2013-03-09','14:50:00',3.72),('14598','2013-03-09','14:55:00',3.67),('14598','2013-03-09','15:00:00',3.63),('14598','2013-03-09','15:05:00',3.56),('14598','2013-03-09','15:10:00',3.5),('14598','2013-03-09','15:15:00',3.43),('14598','2013-03-09','15:20:00',3.37),('14598','2013-03-09','15:25:00',3.29),('14598','2013-03-09','15:30:00',3.21),('14598','2013-03-09','15:35:00',3.14),('14598','2013-03-09','15:40:00',3.06),('14598','2013-03-09','15:45:00',2.92),('14598','2013-03-09','15:50:00',2.65),('14598','2013-03-09','15:55:00',2.29),('14598','2013-03-09','16:00:00',2.14),('14598','2013-03-09','16:05:00',2.22),('14598','2013-03-09','16:10:00',1.65),('14598','2013-03-09','16:15:00',1.23),('14598','2013-03-09','16:20:00',1.31),('14598','2013-03-09','16:25:00',1.83),('14598','2013-03-09','16:30:00',1.96),('14598','2013-03-09','16:35:00',1.02),('14598','2013-03-08','08:15:00',1.05),('14598','2013-03-08','08:20:00',1.04),('14598','2013-03-08','08:50:00',1.68),('14598','2013-03-08','08:55:00',2.01),('14598','2013-03-08','09:00:00',2.04),('14598','2013-03-08','09:05:00',2.11),('14598','2013-03-08','09:10:00',1.51),('14598','2013-03-08','09:15:00',1.06),('14598','2013-03-08','09:20:00',1.44),('14598','2013-03-08','09:25:00',1.01),('14598','2013-03-08','09:30:00',1.18),('14598','2013-03-08','09:35:00',1.32),('14598','2013-03-08','09:40:00',1.38),('14598','2013-03-08','09:45:00',1.24),('14598','2013-03-08','09:50:00',1.42),('14598','2013-03-08','09:55:00',1.61),('14598','2013-03-08','10:00:00',1.63),('14598','2013-03-08','10:05:00',1.6),('14598','2013-03-08','10:10:00',1.79),('14598','2013-03-08','10:15:00',1.75),('14598','2013-03-08','10:20:00',2.28),('14598','2013-03-08','10:25:00',2.33),('14598','2013-03-08','10:30:00',2.19),('14598','2013-03-08','10:35:00',2),('14598','2013-03-08','10:40:00',1.27),('14598','2013-03-08','10:55:00',1.1),('14598','2013-03-08','11:15:00',1.01),('14598','2013-03-08','11:20:00',1.19),('14598','2013-03-08','11:25:00',1.52),('14598','2013-03-08','11:30:00',1.38),('14598','2013-03-08','11:35:00',1.17),('14598','2013-03-08','11:40:00',1.02),('14598','2013-03-08','11:45:00',1.04),('14598','2013-03-08','12:05:00',1.08),('14598','2013-03-08','12:10:00',1.28),('14598','2013-03-08','12:15:00',1.86),('14598','2013-03-08','12:20:00',2.03),('14598','2013-03-08','12:25:00',1.68),('14598','2013-03-08','12:30:00',1.43),('14598','2013-03-08','12:35:00',1.18),('14598','2013-03-08','12:40:00',1.63),('14598','2013-03-08','12:45:00',1.03),('14598','2013-03-08','12:50:00',1.26),('14598','2013-03-08','12:55:00',1.66),('14598','2013-03-08','13:00:00',1.88),('14598','2013-03-08','13:05:00',1.19),('14598','2013-03-08','13:10:00',1.41),('14598','2013-03-08','13:15:00',2.37),('14598','2013-03-08','13:20:00',2.76),('14598','2013-03-08','13:25:00',2.52),('14598','2013-03-08','13:30:00',2.44),('14598','2013-03-08','13:35:00',1.7),('14598','2013-03-08','13:40:00',1.63),('14598','2013-03-07','09:10:00',1.03),('14598','2013-03-07','09:15:00',1.43),('14598','2013-03-07','09:20:00',1.23),('14598','2013-03-07','09:45:00',1.42),('14598','2013-03-07','09:50:00',1.65),('14598','2013-03-07','09:55:00',1.23),('14598','2013-03-07','10:00:00',1.2),('14598','2013-03-07','10:25:00',1),('14598','2013-03-07','10:30:00',1.45),('14598','2013-03-07','10:35:00',1.6),('14598','2013-03-07','10:40:00',1.62),('14598','2013-03-07','10:45:00',1.58),('14598','2013-03-07','10:50:00',2.14),('14598','2013-03-07','10:55:00',2.07),('14598','2013-03-07','11:00:00',1.82),('14598','2013-03-07','11:05:00',1.67),('14598','2013-03-07','11:10:00',1.59),('14598','2013-03-07','11:15:00',2.15),('14598','2013-03-07','11:20:00',2.83),('14598','2013-03-07','11:25:00',1.96),('14598','2013-03-07','11:30:00',2.47),('14598','2013-03-07','11:35:00',3.13),('14598','2013-03-07','11:40:00',3.31),('14598','2013-03-07','11:45:00',2.43),('14598','2013-03-07','11:50:00',2.91),('14598','2013-03-07','11:55:00',3),('14598','2013-03-07','12:00:00',2.87),('14598','2013-03-07','12:05:00',1.94),('14598','2013-03-07','12:15:00',2.42),('14598','2013-03-07','12:20:00',1.97),('14598','2013-03-07','12:25:00',1.69),('14598','2013-03-07','12:30:00',1.29),('14598','2013-03-07','12:35:00',1.04),('14598','2013-03-07','12:40:00',1.68),('14598','2013-03-07','12:45:00',2.41),('14598','2013-03-07','12:50:00',2.41),('14598','2013-03-07','12:55:00',2.37),('14598','2013-03-07','13:00:00',1.36),('14598','2013-03-07','13:45:00',1.12),('14598','2013-03-07','13:50:00',1.61),('14598','2013-03-07','13:55:00',1.46),('14598','2013-03-07','14:00:00',1.21),('14598','2013-03-07','14:15:00',1.7),('14598','2013-03-07','14:20:00',1.99),('14598','2013-03-07','14:25:00',1.51),('14598','2013-03-07','14:30:00',1.18),('14598','2013-03-07','14:55:00',1.06),('14598','2013-03-07','15:00:00',1.28),('14598','2013-03-07','15:05:00',2.27),('14598','2013-03-07','15:10:00',1.19),('14598','2013-03-07','15:20:00',1.04),('14598','2013-03-07','16:15:00',1.13),('14598','2013-03-05','08:20:00',1.1),('14598','2013-03-05','08:25:00',1.05),('14598','2013-03-05','08:30:00',1.17),('14598','2013-03-05','08:35:00',1.33),('14598','2013-03-05','08:40:00',1.36),('14598','2013-03-05','08:45:00',1.33),('14598','2013-03-05','08:50:00',1.31),('14598','2013-03-05','08:55:00',1.33),('14598','2013-03-05','09:00:00',1.35),('14598','2013-03-05','09:05:00',1.39),('14598','2013-03-05','09:10:00',1.47),('14598','2013-03-05','09:15:00',1.5),('14598','2013-03-05','09:20:00',1.52),('14598','2013-03-05','09:25:00',1.56),('14598','2013-03-05','09:30:00',1.62),('14598','2013-03-05','09:35:00',1.75),('14598','2013-03-05','09:40:00',2),('14598','2013-03-05','09:45:00',2.14),('14598','2013-03-05','09:50:00',1.81),('14598','2013-03-05','09:55:00',1.66),('14598','2013-03-05','10:00:00',1.79),('14598','2013-03-05','10:05:00',1.81),('14598','2013-03-05','10:10:00',1.73),('14598','2013-03-05','10:15:00',2.05),('14598','2013-03-05','10:20:00',2.25),('14598','2013-03-05','10:25:00',2.29),('14598','2013-03-05','10:30:00',2.42),('14598','2013-03-05','10:35:00',2.49),('14598','2013-03-05','10:40:00',2.62),('14598','2013-03-05','10:45:00',2.79),('14598','2013-03-05','10:50:00',2.76),('14598','2013-03-05','10:55:00',2.67),('14598','2013-03-05','11:00:00',2.86),('14598','2013-03-05','11:05:00',2.91),('14598','2013-03-05','11:10:00',2.69),('14598','2013-03-05','11:15:00',2.89),('14598','2013-03-05','11:20:00',2.97),('14598','2013-03-05','11:25:00',2.94),('14598','2013-03-05','11:30:00',3.09),('14598','2013-03-05','11:35:00',3.26),('14598','2013-03-05','11:40:00',3.39),('14598','2013-03-05','11:45:00',3.43),('14598','2013-03-05','11:50:00',3.53),('14598','2013-03-05','11:55:00',3.62),('14598','2013-03-05','12:00:00',3.43),('14598','2013-03-05','12:05:00',2.89),('14598','2013-03-05','12:10:00',2.35),('14598','2013-03-05','12:15:00',2.67),('14598','2013-03-05','12:20:00',2.43),('14598','2013-03-05','12:25:00',2.59),('14598','2013-03-05','12:30:00',3.06),('14598','2013-03-05','12:35:00',3.33),('14598','2013-03-05','12:40:00',2.75),('14598','2013-03-05','12:45:00',2.13),('14598','2013-03-05','12:50:00',1.97),('14598','2013-03-05','12:55:00',1.94),('14598','2013-03-05','13:00:00',2),('14598','2013-03-05','13:05:00',1.99),('14598','2013-03-05','13:10:00',1.91),('14598','2013-03-05','13:15:00',1.71),('14598','2013-03-05','13:20:00',1.46),('14598','2013-03-05','13:25:00',1.29),('14598','2013-03-05','13:30:00',1.26),('14598','2013-03-05','13:35:00',1.22),('14598','2013-03-05','13:40:00',1.24),('14598','2013-03-05','13:45:00',1.3),('14598','2013-03-05','13:50:00',1.32),('14598','2013-03-05','13:55:00',1.29),('14598','2013-03-05','14:00:00',1.29),('14598','2013-03-05','14:05:00',1.28),('14598','2013-03-05','14:10:00',1.3),('14598','2013-03-05','14:15:00',1.32),('14598','2013-03-05','14:20:00',1.35),('14598','2013-03-05','14:25:00',1.31),('14598','2013-03-05','14:30:00',1.22),('14598','2013-03-05','14:35:00',1.09),('14598','2013-03-05','15:20:00',1),('14598','2013-03-05','15:25:00',1.18),('14598','2013-03-05','15:30:00',1.21),('14598','2013-03-05','15:35:00',1.11),('14598','2013-03-05','15:40:00',1.09),('14598','2013-03-05','15:45:00',1),('14598','2013-03-04','08:20:00',1.02),('14598','2013-03-04','08:25:00',1.16),('14598','2013-03-04','08:30:00',1.3),('14598','2013-03-04','08:35:00',1.34),('14598','2013-03-04','08:40:00',1.43),('14598','2013-03-04','08:45:00',1.55),('14598','2013-03-04','08:50:00',1.65),('14598','2013-03-04','08:55:00',1.76),('14598','2013-03-04','09:00:00',1.87),('14598','2013-03-04','09:05:00',1.98),('14598','2013-03-04','09:10:00',2.06),('14598','2013-03-04','09:15:00',2.14),('14598','2013-03-04','09:20:00',2.23),('14598','2013-03-04','09:25:00',2.34),('14598','2013-03-04','09:30:00',2.45),('14598','2013-03-04','09:35:00',2.54),('14598','2013-03-04','09:40:00',2.63),('14598','2013-03-04','09:45:00',2.7),('14598','2013-03-04','09:50:00',2.8),('14598','2013-03-04','09:55:00',2.9),('14598','2013-03-04','10:00:00',2.97),('14598','2013-03-04','10:05:00',3.05),('14598','2013-03-04','10:10:00',3.11),('14598','2013-03-04','10:15:00',3.19),('14598','2013-03-04','10:20:00',3.23),('14598','2013-03-04','10:25:00',3.32),('14598','2013-03-04','10:30:00',3.36),('14598','2013-03-04','10:35:00',3.42),('14598','2013-03-04','10:40:00',3.5),('14598','2013-03-04','10:45:00',3.58),('14598','2013-03-04','10:50:00',3.63),('14598','2013-03-04','10:55:00',3.65),('14598','2013-03-04','11:00:00',3.67),('14598','2013-03-04','11:05:00',3.72),('14598','2013-03-04','11:10:00',3.76),('14598','2013-03-04','11:15:00',3.8),('14598','2013-03-04','11:20:00',3.7),('14598','2013-03-04','11:25:00',3.98),('14598','2013-03-04','11:30:00',4.04),('14598','2013-03-04','11:35:00',3.98),('14598','2013-03-04','11:40:00',4.05),('14598','2013-03-04','11:45:00',4.08),('14598','2013-03-04','11:51:00',4.13),('14598','2013-03-04','11:55:00',4.14),('14598','2013-03-04','12:00:00',4.19),('14598','2013-03-04','12:05:00',4.2),('14598','2013-03-04','12:10:00',4.24),('14598','2013-03-04','12:15:00',4.26),('14598','2013-03-04','12:20:00',4.27),('14598','2013-03-04','12:25:00',4.27),('14598','2013-03-04','12:30:00',4.28),('14598','2013-03-04','12:35:00',4.29),('14598','2013-03-04','12:40:00',4.3),('14598','2013-03-04','12:45:00',4.29),('14598','2013-03-04','12:50:00',4.28),('14598','2013-03-04','12:55:00',4.27),('14598','2013-03-04','13:00:00',4.28),('14598','2013-03-04','13:05:00',4.32),('14598','2013-03-04','13:10:00',4.3),('14598','2013-03-04','13:15:00',4.32),('14598','2013-03-04','13:20:00',4.32),('14598','2013-03-04','13:25:00',4.26),('14598','2013-03-04','13:30:00',4.23),('14598','2013-03-04','13:35:00',4.18),('14598','2013-03-04','13:40:00',4.12),('14598','2013-03-04','13:45:00',4.09),('14598','2013-03-04','13:50:00',4.07),('14598','2013-03-04','13:55:00',4.04),('14598','2013-03-04','14:00:00',3.99),('14598','2013-03-04','14:05:00',3.98),('14598','2013-03-04','14:10:00',3.95),('14598','2013-03-04','14:15:00',3.93),('14598','2013-03-04','14:20:00',3.88),('14598','2013-03-04','14:25:00',3.83),('14598','2013-03-04','14:30:00',3.8),('14598','2013-03-04','14:35:00',3.69),('14598','2013-03-04','14:40:00',3.72),('14598','2013-03-04','14:45:00',3.67),('14598','2013-03-04','14:50:00',3.6),('14598','2013-03-04','14:55:00',3.55),('14598','2013-03-04','15:00:00',3.5),('14598','2013-03-04','15:05:00',3.42),('14598','2013-03-04','15:10:00',3.36),('14598','2013-03-04','15:15:00',3.3),('14598','2013-03-04','15:20:00',3.22),('14598','2013-03-04','15:25:00',3.12),('14598','2013-03-04','15:30:00',3.04),('14598','2013-03-04','15:35:00',2.98),('14598','2013-03-04','15:40:00',2.88),('14598','2013-03-04','15:45:00',2.8),('14598','2013-03-04','15:50:00',2.71),('14598','2013-03-04','15:55:00',2.6),('14598','2013-03-04','16:00:00',2.54),('14598','2013-03-04','16:05:00',2.47),('14598','2013-03-04','16:10:00',2.36),('14598','2013-03-04','16:15:00',2.25),('14598','2013-03-04','16:20:00',2.16),('14598','2013-03-04','16:25:00',2.06),('14598','2013-03-04','16:30:00',1.96),('14598','2013-03-04','16:35:00',1.86),('14598','2013-03-04','16:40:00',1.67),('14598','2013-03-04','16:45:00',1.6),('14598','2013-03-04','16:50:00',1.49),('14598','2013-03-04','16:55:00',1.36),('14598','2013-03-04','17:00:00',1.24),('14598','2013-03-04','17:05:00',1.14),('14598','2013-03-04','17:10:00',1.01),('14598','2013-03-03','08:25:00',1.1),('14598','2013-03-03','08:30:00',1.2),('14598','2013-03-03','08:35:00',1.31),('14598','2013-03-03','08:40:00',1.41),('14598','2013-03-03','08:45:00',1.57),('14598','2013-03-03','08:50:00',1.71),('14598','2013-03-03','08:55:00',1.81),('14598','2013-03-03','09:00:00',1.92),('14598','2013-03-03','09:05:00',2.03),('14598','2013-03-03','09:10:00',2.14),('14598','2013-03-03','09:15:00',2.24),('14598','2013-03-03','09:20:00',2.34),('14598','2013-03-03','09:25:00',2.43),('14598','2013-03-03','09:30:00',2.54),('14598','2013-03-03','09:35:00',2.64),('14598','2013-03-03','09:40:00',2.73),('14598','2013-03-03','09:45:00',2.82),('14598','2013-03-03','09:50:00',2.85),('14598','2013-03-03','09:55:00',3.01),('14598','2013-03-03','10:00:00',3.1),('14598','2013-03-03','10:05:00',3.18),('14598','2013-03-03','10:10:00',3.25),('14598','2013-03-03','10:15:00',3.32),('14598','2013-03-03','10:20:00',3.4),('14598','2013-03-03','10:25:00',3.46),('14598','2013-03-03','10:30:00',3.53),('14598','2013-03-03','10:35:00',3.62),('14598','2013-03-03','10:40:00',3.67),('14598','2013-03-03','10:45:00',3.71),('14598','2013-03-03','10:50:00',3.76),('14598','2013-03-03','10:55:00',3.82),('14598','2013-03-03','11:00:00',3.87),('14598','2013-03-03','11:05:00',3.87),('14598','2013-03-03','11:10:00',3.96),('14598','2013-03-03','11:15:00',4),('14598','2013-03-03','11:20:00',4.04),('14598','2013-03-03','11:25:00',4.07),('14598','2013-03-03','11:30:00',4.12),('14598','2013-03-03','11:35:00',4.17),('14598','2013-03-03','11:40:00',4.19),('14598','2013-03-03','11:45:00',4.21),('14598','2013-03-03','11:50:00',4.23),('14598','2013-03-03','11:55:00',4.25),('14598','2013-03-03','12:00:00',4.26),('14598','2013-03-03','12:05:00',4.26),('14598','2013-03-03','12:10:00',4.27),('14598','2013-03-03','12:15:00',4.26),('14598','2013-03-03','12:20:00',4.27),('14598','2013-03-03','12:25:00',4.3),('14598','2013-03-03','12:30:00',4.3),('14598','2013-03-03','12:35:00',4.31),('14598','2013-03-03','12:40:00',4.32),('14598','2013-03-03','12:45:00',4.29),('14598','2013-03-03','12:50:00',4.27),('14598','2013-03-03','12:55:00',4.26),('14598','2013-03-03','13:00:00',4.26),('14598','2013-03-03','13:05:00',4.25),('14598','2013-03-03','13:10:00',4.29),('14598','2013-03-03','13:15:00',4.34),('14598','2013-03-03','13:20:00',4.38),('14598','2013-03-03','13:25:00',4.38),('14598','2013-03-03','13:30:00',4.35),('14598','2013-03-03','13:35:00',4.33),('14598','2013-03-03','13:40:00',4.31),('14598','2013-03-03','13:45:00',4.29),('14598','2013-03-03','13:50:00',4.28),('14598','2013-03-03','13:55:00',4.25),('14598','2013-03-03','14:00:00',4.22),('14598','2013-03-03','14:05:00',4.2),('14598','2013-03-03','14:10:00',4.11),('14598','2013-03-03','14:15:00',4.12),('14598','2013-03-03','14:20:00',4.07),('14598','2013-03-03','14:25:00',4.01),('14598','2013-03-03','14:30:00',3.98),('14598','2013-03-03','14:35:00',3.92),('14598','2013-03-03','14:40:00',3.85),('14598','2013-03-03','14:45:00',3.79),('14598','2013-03-03','14:50:00',3.73),('14598','2013-03-03','14:55:00',3.68),('14598','2013-03-03','15:00:00',3.59),('14598','2013-03-03','15:05:00',3.53),('14598','2013-03-03','15:10:00',3.45),('14598','2013-03-03','15:15:00',3.37),('14598','2013-03-03','15:20:00',3.29),('14598','2013-03-03','15:25:00',3.22),('14598','2013-03-03','15:30:00',3.16),('14598','2013-03-03','15:35:00',3.07),('14598','2013-03-03','15:40:00',2.98),('14598','2013-03-03','15:45:00',2.89),('14598','2013-03-03','15:50:00',2.79),('14598','2013-03-03','15:55:00',2.69),('14598','2013-03-03','16:00:00',2.6),('14598','2013-03-03','16:05:00',2.51),('14598','2013-03-03','16:10:00',2.4),('14598','2013-03-03','16:15:00',2.3),('14598','2013-03-03','16:20:00',2.19),('14598','2013-03-03','16:25:00',2.08),('14598','2013-03-03','16:30:00',1.97),('14598','2013-03-03','16:35:00',1.86),('14598','2013-03-03','16:40:00',1.73),('14598','2013-03-03','16:45:00',1.61),('14598','2013-03-03','16:50:00',1.49),('14598','2013-03-03','16:55:00',1.36),('14598','2013-03-03','17:00:00',1.23),('14598','2013-03-03','17:05:00',1.1),('14598','2014-03-24','08:10:00',1.62),('14598','2014-03-24','08:15:00',1.54),('14598','2014-03-24','08:25:00',1.61),('14598','2014-03-24','08:30:00',1.43),('14598','2014-03-24','08:35:00',1.67),('14598','2014-03-24','08:40:00',1.38),('14598','2014-03-24','08:45:00',1.92),('14598','2014-03-24','08:50:00',1.85),('14598','2014-03-24','08:55:00',2.45),('14598','2014-03-24','09:00:00',2.07),('14598','2014-03-24','09:05:00',2.33),('14598','2014-03-24','09:10:00',2.36),('14598','2014-03-24','09:20:00',2.3),('14598','2014-03-24','09:25:00',2.15),('14598','2014-03-24','09:30:00',3.29),('14598','2014-03-24','09:35:00',1.53),('14598','2014-03-24','09:40:00',3.77),('14598','2014-03-24','09:45:00',2.16),('14598','2014-03-24','09:50:00',2.39),('14598','2014-03-24','09:55:00',1.82),('14598','2014-03-24','10:00:00',4.37),('14598','2014-03-24','10:05:00',2.76),('14598','2014-03-24','10:10:00',1.13),('14598','2014-03-24','10:15:00',1.2),('14598','2014-03-24','10:20:00',2.35),('14598','2014-03-24','10:25:00',4.11),('14598','2014-03-24','10:30:00',2.62),('14598','2014-03-24','10:35:00',5.08),('14598','2014-03-24','10:40:00',3.74),('14598','2014-03-24','10:45:00',1.76),('14598','2014-03-24','10:50:00',3.56),('14598','2014-03-24','10:55:00',5.24),('14598','2014-03-24','11:00:00',4.02),('14598','2014-03-24','11:05:00',3.65),('14598','2014-03-24','11:10:00',1.32),('14598','2014-03-24','12:00:00',1.07),('14598','2014-03-24','12:05:00',1.87),('14598','2014-03-24','12:10:00',2.05),('14598','2014-03-24','12:15:00',2.12),('14598','2014-03-24','12:20:00',1.8),('14598','2014-03-24','12:25:00',1.52),('14598','2014-03-24','12:30:00',1.57),('14598','2014-03-24','12:35:00',1.67),('14598','2014-03-24','12:40:00',1.75),('14598','2014-03-24','12:45:00',1.69),('14598','2014-03-24','12:50:00',1.6),('14598','2014-03-24','12:55:00',1.66),('14598','2014-03-24','13:00:00',1.73),('14598','2014-03-24','13:05:00',1.72),('14598','2014-03-24','13:10:00',1.6),('14598','2014-03-24','13:15:00',1.05),('14598','2014-03-24','13:25:00',1.11),('14598','2014-03-24','13:50:00',1.14),('14598','2014-03-24','13:55:00',1.6),('14598','2014-03-24','14:00:00',2.71),('14598','2014-03-24','14:05:00',3.02),('14598','2014-03-24','14:10:00',2.15),('14598','2014-03-24','14:15:00',2),('14598','2014-03-24','14:20:00',2.04),('14598','2014-03-24','14:25:00',2.82),('14598','2014-03-24','14:30:00',3.49),('14598','2014-03-24','14:35:00',3.52),('14598','2014-03-24','14:40:00',3.45),('14598','2014-03-24','14:45:00',3),('14598','2014-03-24','14:50:00',2.64),('14598','2014-03-24','14:55:00',2.32),('14598','2014-03-24','15:00:00',2.68),('14598','2014-03-24','15:05:00',2.39),('14598','2014-03-24','15:10:00',1.75),('14598','2014-03-24','15:15:00',1.61),('14598','2014-03-24','15:20:00',2.28),('14598','2014-03-24','15:25:00',3.97),('14598','2014-03-24','15:30:00',4.04),('14598','2014-03-24','15:35:00',3.29),('14598','2014-03-24','15:40:00',1.32),('14598','2014-03-24','15:45:00',1.15),('14598','2014-03-24','15:50:00',1.65),('14598','2014-03-24','15:55:00',1.25),('14598','2014-03-24','17:30:00',1.13),('14598','2014-03-24','17:35:00',1.18),('14598','2014-03-24','17:40:00',1.05),('14598','2013-03-02','11:05:00',1.03),('14598','2013-03-02','11:10:00',1.13),('14598','2013-03-02','11:15:00',1.35),('14598','2013-03-02','11:20:00',1.44),('14598','2013-03-02','11:25:00',1.37),('14598','2013-03-02','11:30:00',1.43),('14598','2013-03-02','11:35:00',1.59),('14598','2013-03-02','11:40:00',1.39),('14598','2013-03-02','11:45:00',1.34),('14598','2013-03-02','11:50:00',1.34),('14598','2013-03-02','11:55:00',1.34),('14598','2013-03-02','12:00:00',1.34),('14598','2013-03-02','12:05:00',1.43),('14598','2013-03-02','12:10:00',1.45),('14598','2013-03-02','12:15:00',1.44),('14598','2013-03-02','12:20:00',1.41),('14598','2013-03-02','12:25:00',1.4),('14598','2013-03-02','12:30:00',1.42),('14598','2013-03-02','12:35:00',1.47),('14598','2013-03-02','12:40:00',1.42),('14598','2013-03-02','12:45:00',1.35),('14598','2013-03-02','12:50:00',1.34),('14598','2013-03-02','12:55:00',1.21),('14598','2013-03-02','13:00:00',1.11),('14598','2013-03-02','13:05:00',1.03),('14598','2013-03-02','13:10:00',1.12),('14598','2013-03-02','13:15:00',1.16),('14598','2013-03-02','13:20:00',1.27),('14598','2013-03-02','13:25:00',1.29),('14598','2013-03-02','13:30:00',1.32),('14598','2013-03-02','13:35:00',1.26),('14598','2013-03-02','13:40:00',1.09),('14598','2013-03-02','13:45:00',1.06),('14598','2013-03-02','13:50:00',1.04),('14598','2013-03-02','13:55:00',1),('14598','2013-03-02','14:00:00',1.01),('14598','2013-03-02','14:05:00',1.02),('14598','2013-03-02','14:30:00',1.16),('14598','2013-03-02','14:35:00',1.07),('14598','2013-03-02','14:50:00',1.23),('14598','2013-03-02','14:55:00',1.28),('14598','2013-03-02','15:00:00',1.31),('14598','2013-03-02','15:05:00',1.4),('14598','2013-03-02','15:10:00',1.37),('14598','2013-03-02','15:15:00',1.13),('14598','2013-03-02','15:25:00',1.01),('14598','2013-03-02','15:30:00',1.03),('14598','2013-03-02','15:55:00',1.01),('14598','2013-03-02','16:00:00',1.03),('14598','2013-03-01','08:25:00',1.09),('14598','2013-03-01','08:30:00',1.2),('14598','2013-03-01','08:35:00',1.3),('14598','2013-03-01','08:40:00',1.33),('14598','2013-03-01','08:45:00',1.37),('14598','2013-03-01','08:50:00',1.42),('14598','2013-03-01','08:55:00',1.51),('14598','2013-03-01','09:00:00',1.5),('14598','2013-03-01','09:05:00',1.52),('14598','2013-03-01','09:10:00',1.71),('14598','2013-03-01','09:15:00',1.81),('14598','2013-03-01','09:20:00',1.9),('14598','2013-03-01','09:25:00',1.96),('14598','2013-03-01','09:30:00',1.98),('14598','2013-03-01','09:35:00',2),('14598','2013-03-01','09:40:00',1.85),('14598','2013-03-01','09:45:00',1.57),('14598','2013-03-01','09:50:00',1.46),('14598','2013-03-01','09:55:00',1.48),('14598','2013-03-01','10:00:00',1.61),('14598','2013-03-01','10:05:00',1.77),('14598','2013-03-01','10:10:00',1.93),('14598','2013-03-01','10:15:00',2.14),('14598','2013-03-01','10:20:00',2.03),('14598','2013-03-01','10:25:00',1.88),('14598','2013-03-01','10:30:00',1.81),('14598','2013-03-01','10:35:00',1.87),('14598','2013-03-01','10:40:00',1.95),('14598','2013-03-01','10:45:00',2.07),('14598','2013-03-01','10:50:00',2.02),('14598','2013-03-01','10:55:00',2.11),('14598','2013-03-01','11:00:00',2.19),('14598','2013-03-01','11:05:00',2.23),('14598','2013-03-01','11:10:00',2.17),('14598','2013-03-01','11:15:00',2.1),('14598','2013-03-01','11:20:00',2.03),('14598','2013-03-01','11:25:00',1.91),('14598','2013-03-01','11:30:00',1.85),('14598','2013-03-01','11:35:00',1.76),('14598','2013-03-01','11:40:00',1.67),('14598','2013-03-01','11:45:00',1.55),('14598','2013-03-01','11:50:00',1.45),('14598','2013-03-01','11:55:00',1.36),('14598','2013-03-01','12:00:00',1.29),('14598','2013-03-01','12:05:00',1.25),('14598','2013-03-01','12:10:00',1.22),('14598','2013-03-01','12:15:00',1.23),('14598','2013-03-01','12:20:00',1.36),('14598','2013-03-01','12:25:00',1.64),('14598','2013-03-01','12:30:00',1.81),('14598','2013-03-01','12:35:00',1.89),('14598','2013-03-01','12:40:00',1.86),('14598','2013-03-01','12:45:00',1.85),('14598','2013-03-01','12:50:00',1.88),('14598','2013-03-01','12:55:00',1.95),('14598','2013-03-01','13:00:00',2.04),('14598','2013-03-01','13:05:00',2.15),('14598','2013-03-01','13:10:00',2.16),('14598','2013-03-01','13:15:00',1.9),('14598','2013-03-01','13:20:00',1.67),('14598','2013-03-01','13:25:00',1.53),('14598','2013-03-01','13:30:00',1.53),('14598','2013-03-01','13:35:00',1.57),('14598','2013-03-01','13:40:00',1.53),('14598','2013-03-01','13:45:00',1.41),('14598','2013-03-01','13:50:00',1.32),('14598','2013-03-01','13:55:00',1.32),('14598','2013-03-01','14:00:00',1.34),('14598','2013-03-01','14:05:00',1.34),('14598','2013-03-01','14:10:00',1.32),('14598','2013-03-01','14:15:00',1.3),('14598','2013-03-01','14:20:00',1.3),('14598','2013-03-01','14:25:00',1.31),('14598','2013-03-01','14:30:00',1.29),('14598','2013-03-01','14:35:00',1.23),('14598','2013-03-01','14:40:00',1.16),('14598','2013-03-01','14:45:00',1.09),('14598','2013-03-01','14:50:00',1.03),('14598','2013-03-01','14:55:00',1.03),('14598','2013-03-01','15:00:00',1.12),('14598','2013-03-01','15:05:00',1.18),('14598','2013-03-01','15:10:00',1.12),('14598','2013-03-01','15:15:00',1.01),('14598','2013-02-28','08:30:00',1.04),('14598','2013-02-28','08:35:00',1.15),('14598','2013-02-28','08:40:00',1.24),('14598','2013-02-28','08:45:00',1.38),('14598','2013-02-28','08:50:00',1.51),('14598','2013-02-28','08:55:00',1.59),('14598','2013-02-28','09:00:00',1.67),('14598','2013-02-28','09:05:00',1.81),('14598','2013-02-28','09:10:00',1.91),('14598','2013-02-28','09:15:00',1.99),('14598','2013-02-28','09:20:00',2.1),('14598','2013-02-28','09:25:00',2.2),('14598','2013-02-28','09:30:00',2.3),('14598','2013-02-28','09:35:00',2.4),('14598','2013-02-28','09:40:00',2.38),('14598','2013-02-28','09:45:00',2.46),('14598','2013-02-28','09:50:00',2.57),('14598','2013-02-28','09:55:00',2.71),('14598','2013-02-28','10:00:00',2.78),('14598','2013-02-28','10:05:00',2.88),('14598','2013-02-28','10:10:00',2.88),('14598','2013-02-28','10:15:00',2.98),('14598','2013-02-28','10:20:00',2.9),('14598','2013-02-28','10:25:00',3.14),('14598','2013-02-28','10:30:00',3.02),('14598','2013-02-28','10:35:00',3.3),('14598','2013-02-28','10:40:00',3.36),('14598','2013-02-28','10:45:00',3.42),('14598','2013-02-28','10:50:00',3.44),('14598','2013-02-28','10:55:00',3.52),('14598','2013-02-28','11:00:00',3.55),('14598','2013-02-28','11:05:00',3.6),('14598','2013-02-28','11:10:00',3.65),('14598','2013-02-28','11:15:00',3.72),('14598','2013-02-28','11:20:00',3.72),('14598','2013-02-28','11:25:00',3.76),('14598','2013-02-28','11:30:00',3.79),('14598','2013-02-28','11:35:00',3.81),('14598','2013-02-28','11:40:00',3.79),('14598','2013-02-28','11:45:00',3.82),('14598','2013-02-28','11:50:00',3.88),('14598','2013-02-28','11:55:00',3.9),('14598','2013-02-28','12:00:00',3.9),('14598','2013-02-28','12:05:00',3.88),('14598','2013-02-28','12:10:00',3.86),('14598','2013-02-28','12:15:00',3.83),('14598','2013-02-28','12:20:00',3.88),('14598','2013-02-28','12:25:00',3.63),('14598','2013-02-28','12:30:00',4.15),('14598','2013-02-28','12:35:00',4.04),('14598','2013-02-28','12:40:00',4.1),('14598','2013-02-28','12:45:00',4.09),('14598','2013-02-28','12:50:00',3.79),('14598','2013-02-28','12:55:00',4.01),('14598','2013-02-28','13:00:00',4.03),('14598','2013-02-28','13:05:00',4.1),('14598','2013-02-28','13:10:00',4.12),('14598','2013-02-28','13:15:00',4.14),('14598','2013-02-28','13:20:00',4.07),('14598','2013-02-28','13:25:00',4.03),('14598','2013-02-28','13:30:00',3.98),('14598','2013-02-28','13:35:00',3.98),('14598','2013-02-28','13:40:00',4),('14598','2013-02-28','13:45:00',3.98),('14598','2013-02-28','13:50:00',4),('14598','2013-02-28','13:55:00',4),('14598','2013-02-28','14:00:00',3.94),('14598','2013-02-28','14:05:00',3.9),('14598','2013-02-28','14:10:00',3.86),('14598','2013-02-28','14:15:00',3.83),('14598','2013-02-28','14:20:00',3.82),('14598','2013-02-28','14:25:00',3.65),('14598','2013-02-28','14:30:00',3.76),('14598','2013-02-28','14:35:00',3.69),('14598','2013-02-28','14:40:00',3.64),('14598','2013-02-28','14:45:00',3.56),('14598','2013-02-28','14:50:00',3.47),('14598','2013-02-28','14:55:00',3.38),('14598','2013-02-28','15:00:00',3.31),('14598','2013-02-28','15:05:00',3.25),('14598','2013-02-28','15:10:00',3.17),('14598','2013-02-28','15:15:00',3.09),('14598','2013-02-28','15:20:00',3),('14598','2013-02-28','15:25:00',2.94),('14598','2013-02-28','15:30:00',2.84),('14598','2013-02-28','15:35:00',2.75),('14598','2013-02-28','15:40:00',2.66),('14598','2013-02-28','15:45:00',2.62),('14598','2013-02-28','15:50:00',2.55),('14598','2013-02-28','15:55:00',2.44),('14598','2013-02-28','16:00:00',2.3),('14598','2013-02-28','16:05:00',2.23),('14598','2013-02-28','16:10:00',2.12),('14598','2013-02-28','16:15:00',1.95),('14598','2013-02-28','16:20:00',1.91),('14598','2013-02-28','16:25:00',1.8),('14598','2013-02-28','16:30:00',1.69),('14598','2013-02-28','16:35:00',1.58),('14598','2013-02-28','16:40:00',1.46),('14598','2013-02-28','16:45:00',1.35),('14598','2013-02-28','16:50:00',1.24),('14598','2013-02-28','16:55:00',1.13),('14598','2013-02-28','17:00:00',1.01),('14598','2013-02-27','08:35:00',1.09),('14598','2013-02-27','08:40:00',1.19),('14598','2013-02-27','08:45:00',1.32),('14598','2013-02-27','08:50:00',1.44),('14598','2013-02-27','08:55:00',1.56),('14598','2013-02-27','09:00:00',1.67),('14598','2013-02-27','09:05:00',1.78),('14598','2013-02-27','09:10:00',1.88),('14598','2013-02-27','09:15:00',1.98),('14598','2013-02-27','09:20:00',2.06),('14598','2013-02-27','09:25:00',2.17),('14598','2013-02-27','09:30:00',2.26),('14598','2013-02-27','09:35:00',2.35),('14598','2013-02-27','09:40:00',2.43),('14598','2013-02-27','09:45:00',2.52),('14598','2013-02-27','09:50:00',2.61),('14598','2013-02-27','09:55:00',2.69),('14598','2013-02-27','10:00:00',2.78),('14598','2013-02-27','10:05:00',2.86),('14598','2013-02-27','10:10:00',2.93),('14598','2013-02-27','10:15:00',3.01),('14598','2013-02-27','10:20:00',3.09),('14598','2013-02-27','10:25:00',3.12),('14598','2013-02-27','10:30:00',3.2),('14598','2013-02-27','10:35:00',3.26),('14598','2013-02-27','10:40:00',3.31),('14598','2013-02-27','10:45:00',3.36),('14598','2013-02-27','10:50:00',3.4),('14598','2013-02-27','10:55:00',3.47),('14598','2013-02-27','11:00:00',3.47),('14598','2013-02-27','11:05:00',3.59),('14598','2013-02-27','11:10:00',3.53),('14598','2013-02-27','11:15:00',3.62),('14598','2013-02-27','11:20:00',3.66),('14598','2013-02-27','11:25:00',3.77),('14598','2013-02-27','11:30:00',3.86),('14598','2013-02-27','11:35:00',3.95),('14598','2013-02-27','11:40:00',4.02),('14598','2013-02-27','11:45:00',4.11),('14598','2013-02-27','11:50:00',4.17),('14598','2013-02-27','11:55:00',4.07),('14598','2013-02-27','12:00:00',3.98),('14598','2013-02-27','12:05:00',4.1),('14598','2013-02-27','12:10:00',4.28),('14598','2013-02-27','12:15:00',4.19),('14598','2013-02-27','12:20:00',4.17),('14598','2013-02-27','12:25:00',4.17),('14598','2013-02-27','12:30:00',4.11),('14598','2013-02-27','12:35:00',4.16),('14598','2013-02-27','12:40:00',4.19),('14598','2013-02-27','12:45:00',4.21),('14598','2013-02-27','12:50:00',4.19),('14598','2013-02-27','12:55:00',4.18),('14598','2013-02-27','13:00:00',4.2),('14598','2013-02-27','13:05:00',4.2),('14598','2013-02-27','13:10:00',4.19),('14598','2013-02-27','13:15:00',4.21),('14598','2013-02-27','13:20:00',4.19),('14598','2013-02-27','13:25:00',4.16),('14598','2013-02-27','13:30:00',4.16),('14598','2013-02-27','13:35:00',4.14),('14598','2013-02-27','13:40:00',4.1),('14598','2013-02-27','13:45:00',4.07),('14598','2013-02-27','13:50:00',4.02),('14598','2013-02-27','13:55:00',3.99),('14598','2013-02-27','14:00:00',3.95),('14598','2013-02-27','14:05:00',3.94),('14598','2013-02-27','14:10:00',3.89),('14598','2013-02-27','14:15:00',3.83),('14598','2013-02-27','14:20:00',3.79),('14598','2013-02-27','14:25:00',3.73),('14598','2013-02-27','14:30:00',3.7),('14598','2013-02-27','14:35:00',3.68),('14598','2013-02-27','14:40:00',3.62),('14598','2013-02-27','14:45:00',3.58),('14598','2013-02-27','14:50:00',3.56),('14598','2013-02-27','14:55:00',3.49),('14598','2013-02-27','15:00:00',3.41),('14598','2013-02-27','15:05:00',3.35),('14598','2013-02-27','15:10:00',3.26),('14598','2013-02-27','15:15:00',3.18),('14598','2013-02-27','15:20:00',3.09),('14598','2013-02-27','15:25:00',3.03),('14598','2013-02-27','15:30:00',2.92),('14598','2013-02-27','15:35:00',2.82),('14598','2013-02-27','15:40:00',2.71),('14598','2013-02-27','15:45:00',2.64),('14598','2013-02-27','15:50:00',2.55),('14598','2013-02-27','15:55:00',2.44),('14598','2013-02-27','16:00:00',2.34),('14598','2013-02-27','16:05:00',2.24),('14598','2013-02-27','16:10:00',2.13),('14598','2013-02-27','16:15:00',2.03),('14598','2013-02-27','16:20:00',1.92),('14598','2013-02-27','16:25:00',1.82),('14598','2013-02-27','16:30:00',1.72),('14598','2013-02-27','16:35:00',1.61),('14598','2013-02-27','16:40:00',1.52),('14598','2013-02-27','16:45:00',1.43),('14598','2013-02-27','16:50:00',1.32),('14598','2013-02-27','16:55:00',1.2),('14598','2013-02-27','17:00:00',1.07),('14598','2013-02-26','09:10:00',1.18),('14598','2013-02-26','09:15:00',1.42),('14598','2013-02-26','09:20:00',1.72),('14598','2013-02-26','09:25:00',1.76),('14598','2013-02-26','09:30:00',1.61),('14598','2013-02-26','09:35:00',1.77),('14598','2013-02-26','09:40:00',1.83),('14598','2013-02-26','09:45:00',1.62),('14598','2013-02-26','09:50:00',1.35),('14598','2013-02-26','09:55:00',1.26),('14598','2013-02-26','10:00:00',2.11),('14598','2013-02-26','10:05:00',1.7),('14598','2013-02-26','10:10:00',1.4),('14598','2013-02-26','10:15:00',1.46),('14598','2013-02-26','10:20:00',1.39),('14598','2013-02-26','10:25:00',1.41),('14598','2013-02-26','10:30:00',1.46),('14598','2013-02-26','10:35:00',1.43),('14598','2013-02-26','10:40:00',1.44),('14598','2013-02-26','10:45:00',1.37),('14598','2013-02-26','10:50:00',1.37),('14598','2013-02-26','10:55:00',1.48),('14598','2013-02-26','11:00:00',1.46),('14598','2013-02-26','11:05:00',1.46),('14598','2013-02-26','11:10:00',1.54),('14598','2013-02-26','11:15:00',1.62),('14598','2013-02-26','11:20:00',1.95),('14598','2013-02-26','11:25:00',1.76),('14598','2013-02-26','11:30:00',1.86),('14598','2013-02-26','11:35:00',2.07),('14598','2013-02-26','11:40:00',2.82),('14598','2013-02-26','11:45:00',3.84),('14598','2013-02-26','11:50:00',3.94),('14598','2013-02-26','11:55:00',4.15),('14598','2013-02-26','12:00:00',4.11),('14598','2013-02-26','12:05:00',4.13),('14598','2013-02-26','12:10:00',4.19),('14598','2013-02-26','12:15:00',4.38),('14598','2013-02-26','12:20:00',2.42),('14598','2013-02-26','12:25:00',2.41),('14598','2013-02-26','12:30:00',2.44),('14598','2013-02-26','12:35:00',2.21),('14598','2013-02-26','12:40:00',2.21),('14598','2013-02-26','12:45:00',2.1),('14598','2013-02-26','12:50:00',2.1),('14598','2013-02-26','12:55:00',1.97),('14598','2013-02-26','13:00:00',1.85),('14598','2013-02-26','13:05:00',1.69),('14598','2013-02-26','13:10:00',1.71),('14598','2013-02-26','13:15:00',1.69),('14598','2013-02-26','13:20:00',1.59),('14598','2013-02-26','13:25:00',1.51),('14598','2013-02-26','13:30:00',1.38),('14598','2013-02-26','13:35:00',1.35),('14598','2013-02-26','13:40:00',1.4),('14598','2013-02-26','13:45:00',1.42),('14598','2013-02-26','13:50:00',1.39),('14598','2013-02-26','13:55:00',1.5),('14598','2013-02-26','14:00:00',1.45),('14598','2013-02-26','14:05:00',1.29),('14598','2013-02-26','14:10:00',1.25),('14598','2013-02-26','14:15:00',1.26),('14598','2013-02-26','14:20:00',1.25),('14598','2013-02-26','14:25:00',1.16),('14598','2013-02-26','14:30:00',1),('14598','2013-02-26','14:50:00',1.07),('14598','2013-02-26','14:55:00',1.09),('14598','2013-02-26','15:00:00',1.07),('14598','2013-02-25','09:40:00',1.13),('14598','2013-02-25','09:45:00',1.25),('14598','2013-02-25','09:50:00',1.14),('14598','2013-02-25','09:55:00',1.14),('14598','2013-02-25','10:00:00',1.54),('14598','2013-02-25','10:05:00',1.59),('14598','2013-02-25','10:10:00',1.12),('14598','2013-02-25','10:15:00',1.23),('14598','2013-02-25','10:20:00',1.71),('14598','2013-02-25','10:25:00',2.37),('14598','2013-02-25','10:30:00',2.76),('14598','2013-02-25','10:35:00',3.52),('14598','2013-02-25','10:40:00',3.47),('14598','2013-02-25','10:45:00',2.96),('14598','2013-02-25','10:50:00',3.58),('14598','2013-02-25','10:55:00',2.13),('14598','2013-02-25','11:00:00',3.51),('14598','2013-02-25','11:05:00',2.59),('14598','2013-02-25','11:10:00',2.44),('14598','2013-02-25','11:15:00',2.41),('14598','2013-02-25','11:20:00',1.84),('14598','2013-02-25','11:25:00',1.4),('14598','2013-02-25','11:30:00',1.36),('14598','2013-02-25','11:35:00',1.72),('14598','2013-02-25','11:40:00',1.86),('14598','2013-02-25','11:45:00',1.61),('14598','2013-02-25','11:50:00',1.42),('14598','2013-02-25','11:55:00',1.6),('14598','2013-02-25','12:00:00',1.56),('14598','2013-02-25','12:05:00',1.31),('14598','2013-02-25','12:10:00',1.3),('14598','2013-02-25','12:15:00',1.36),('14598','2013-02-25','12:20:00',1.61),('14598','2013-02-25','12:25:00',1.81),('14598','2013-02-25','12:30:00',1.89),('14598','2013-02-25','12:35:00',2.07),('14598','2013-02-25','12:40:00',1.9),('14598','2013-02-25','12:45:00',1.7),('14598','2013-02-25','12:50:00',1.47),('14598','2013-02-25','12:55:00',1.31),('14598','2013-02-25','13:00:00',1.23),('14598','2013-02-25','13:05:00',1.21),('14598','2013-02-25','13:10:00',1.29),('14598','2013-02-25','13:15:00',1.48),('14598','2013-02-25','13:20:00',2.59),('14598','2013-02-25','13:25:00',2.77),('14598','2013-02-25','13:30:00',2.85),('14598','2013-02-25','13:35:00',3.61),('14598','2013-02-25','13:40:00',5.09),('14598','2013-02-25','13:45:00',4.06),('14598','2013-02-25','13:50:00',2.9),('14598','2013-02-25','13:55:00',3.22),('14598','2013-02-25','14:00:00',2.34),('14598','2013-02-25','14:05:00',1.99),('14598','2013-02-25','14:10:00',1.75),('14598','2013-02-25','14:15:00',1.47),('14598','2013-02-25','14:20:00',1.46),('14598','2013-02-25','14:25:00',1.35),('14598','2013-02-25','14:30:00',1.37),('14598','2013-02-25','14:35:00',1.07),('14598','2013-02-25','14:50:00',1.04),('14598','2013-02-25','14:55:00',1.07),('14598','2013-02-25','15:00:00',1.12),('14598','2013-02-25','15:05:00',1.13),('14598','2013-02-25','15:10:00',1.03),('14598','2013-02-25','15:35:00',1.68),('14598','2013-02-25','15:40:00',2.28),('14598','2013-02-25','15:45:00',2.73),('14598','2013-02-25','15:50:00',3.11),('14598','2013-02-25','15:55:00',3.6),('14598','2013-02-25','16:00:00',3.56),('14598','2013-02-25','16:05:00',3.56),('14598','2013-02-25','16:10:00',3.44),('14598','2013-02-25','16:15:00',2.13),('14598','2013-02-25','16:20:00',1.36),('14598','2013-02-25','16:25:00',1.12),('14598','2013-02-25','16:40:00',1.67),('14598','2013-02-25','16:50:00',1.54),('14598','2013-02-25','16:55:00',1.28),('14598','2013-02-25','17:00:00',1.02),('14598','2013-02-24','09:20:00',1.08),('14598','2013-02-24','09:45:00',1.02),('14598','2013-02-24','10:15:00',1.14),('14598','2013-02-24','10:20:00',1.35),('14598','2013-02-24','10:25:00',1.61),('14598','2013-02-24','10:30:00',1.82),('14598','2013-02-24','10:35:00',1.97),('14598','2013-02-24','10:40:00',1.77),('14598','2013-02-24','10:45:00',1),('14598','2013-02-24','11:20:00',1.09),('14598','2013-02-24','11:25:00',1.01),('14598','2013-02-24','11:30:00',1.06),('14598','2013-02-24','11:55:00',1.72),('14598','2013-02-24','12:00:00',2.01),('14598','2013-02-24','12:05:00',1.97),('14598','2013-02-24','12:10:00',2.14),('14598','2013-02-24','12:15:00',2.33),('14598','2013-02-24','12:20:00',1.95),('14598','2013-02-24','12:25:00',2.06),('14598','2013-02-24','12:30:00',2.88),('14598','2013-02-24','12:35:00',3.17),('14598','2013-02-24','12:40:00',2.57),('14598','2013-02-24','12:45:00',2.85),('14598','2013-02-24','12:50:00',1.78),('14598','2013-02-24','12:55:00',2.86),('14598','2013-02-24','13:00:00',4.74),('14598','2013-02-24','13:05:00',2.07),('14598','2013-02-24','13:10:00',2.04),('14598','2013-02-24','13:15:00',4.2),('14598','2013-02-24','13:20:00',4.55),('14598','2013-02-24','13:25:00',4.67),('14598','2013-02-24','13:30:00',3.69),('14598','2013-02-24','13:35:00',2.19),('14598','2013-02-24','13:40:00',4.01),('14598','2013-02-24','13:45:00',3.39),('14598','2013-02-24','13:50:00',2.37),('14598','2013-02-24','13:55:00',1.29),('14598','2013-02-24','14:00:00',1.33),('14598','2013-02-24','14:05:00',1.17),('14598','2013-02-24','14:20:00',1.42),('14598','2013-02-24','14:25:00',2.73),('14598','2013-02-24','14:30:00',3.64),('14598','2013-02-24','14:35:00',2.88),('14598','2013-02-24','14:40:00',3.86),('14598','2013-02-24','14:45:00',3.06),('14598','2013-02-24','14:50:00',4.31),('14598','2013-02-24','14:55:00',3.98),('14598','2013-02-24','15:00:00',3.34),('14598','2013-02-24','15:05:00',1.92),('14598','2013-02-24','15:10:00',3.19),('14598','2013-02-24','15:15:00',2.34),('14598','2013-02-24','15:20:00',3.26),('14598','2013-02-24','15:25:00',3.08),('14598','2013-02-24','15:30:00',2.94),('14598','2013-02-24','15:35:00',2.14),('14598','2013-02-24','15:40:00',2.8),('14598','2013-02-24','15:45:00',2.75),('14598','2013-02-24','15:50:00',2.54),('14598','2013-02-24','15:55:00',1.76),('14598','2013-02-23','11:20:00',1.14),('14598','2013-02-23','11:25:00',1.07),('14598','2013-02-23','11:35:00',1.07),('14598','2013-02-23','11:40:00',1.27),('14598','2013-02-23','13:50:00',1.01),('14598','2013-02-22','11:55:00',1.01),('14598','2013-02-22','12:00:00',1.11),('14598','2013-02-22','13:45:00',1.11),('14598','2013-02-22','14:10:00',1.48),('14598','2013-02-22','14:15:00',1.78),('14598','2013-02-22','14:35:00',1.01),('14598','2013-02-22','14:40:00',1.29),('14598','2013-02-22','14:45:00',1.25),('14598','2013-02-22','14:50:00',2.79),('14598','2013-02-22','14:55:00',1.74),('14598','2013-02-22','15:35:00',1.13),('14598','2013-02-22','15:40:00',1.53),('14598','2013-02-22','15:50:00',1.58),('14598','2013-02-22','15:55:00',1.26),('14598','2013-02-22','16:05:00',1.05),('14598','2013-02-22','16:15:00',1.33);
INSERT INTO `solarlogmod` VALUES ('14598','2013-02-21','11:10:00',1.03),('14598','2013-02-21','11:30:00',1.02),('14598','2013-02-21','11:35:00',1.01),('14598','2013-02-21','11:40:00',1.03),('14598','2013-02-21','11:45:00',1.15),('14598','2013-02-21','11:50:00',1.32),('14598','2013-02-21','11:55:00',1.25),('14598','2013-02-21','12:00:00',1.05),('14598','2013-02-21','12:15:00',1.02),('14598','2013-02-21','12:20:00',1.18),('14598','2013-02-21','12:25:00',1.22),('14598','2013-02-21','12:30:00',1.31),('14598','2013-02-21','12:35:00',1.47),('14598','2013-02-21','12:40:00',1.58),('14598','2013-02-21','12:45:00',1.55),('14598','2013-02-21','12:50:00',1.53),('14598','2013-02-21','12:55:00',1.52),('14598','2013-02-21','13:00:00',1.38),('14598','2013-02-21','13:05:00',1.29),('14598','2013-02-21','13:10:00',1.26),('14598','2013-02-21','13:15:00',1.18),('14598','2013-02-21','13:20:00',1.08),('14598','2013-02-21','13:25:00',1.05),('14598','2013-02-21','13:30:00',1.07),('14598','2013-02-21','13:35:00',1.06),('14598','2013-02-21','13:40:00',1.07),('14598','2013-02-21','13:45:00',1.05),('14598','2013-02-21','13:50:00',1.05),('14598','2013-02-21','13:55:00',1.09),('14598','2013-02-21','14:00:00',1.17),('14598','2013-02-21','14:05:00',1.06),('14598','2013-02-21','14:20:00',1.04),('14598','2013-02-21','14:25:00',1.22),('14598','2013-02-21','14:30:00',1.35),('14598','2013-02-21','14:35:00',1.41),('14598','2013-02-21','14:40:00',1.37),('14598','2013-02-21','14:45:00',1.37),('14598','2013-02-21','14:50:00',1.38),('14598','2013-02-21','14:55:00',1.51),('14598','2013-02-21','15:00:00',1.79),('14598','2013-02-21','15:05:00',1.63),('14598','2013-02-21','15:10:00',1.51),('14598','2013-02-21','15:15:00',1.36),('14598','2013-02-21','15:20:00',1.38),('14598','2013-02-21','15:25:00',2.27),('14598','2013-02-21','15:30:00',2.61),('14598','2013-02-21','15:35:00',2.01),('14598','2013-02-21','15:40:00',1.47),('14598','2013-02-21','15:45:00',2.21),('14598','2013-02-21','15:50:00',2.97),('14598','2013-02-21','15:55:00',2.8),('14598','2013-02-21','16:00:00',2.62),('14598','2013-02-21','16:05:00',2.42),('14598','2013-02-21','16:10:00',2.25),('14598','2013-02-21','16:15:00',2.08),('14598','2013-02-21','16:20:00',1.9),('14598','2013-02-21','16:25:00',1.74),('14598','2013-02-21','16:30:00',1.61),('14598','2013-02-21','16:35:00',1.46),('14598','2013-02-21','16:40:00',1.37),('14598','2013-02-21','16:45:00',1.23),('14598','2013-02-21','16:50:00',1.12),('14598','2014-03-23','08:00:00',1.01),('14598','2014-03-23','08:15:00',1.5),('14598','2014-03-23','08:20:00',1.66),('14598','2014-03-23','08:25:00',1),('14598','2014-03-23','08:30:00',1.16),('14598','2014-03-23','08:35:00',1.59),('14598','2014-03-23','08:40:00',1.76),('14598','2014-03-23','08:45:00',2.09),('14598','2014-03-23','08:50:00',1.96),('14598','2014-03-23','08:55:00',2.35),('14598','2014-03-23','09:00:00',1.32),('14598','2014-03-23','09:40:00',1.1),('14598','2014-03-23','12:40:00',1.28),('14598','2014-03-23','13:15:00',1.5),('14598','2014-03-23','13:20:00',1.58),('14598','2014-03-23','13:25:00',1.1),('14598','2014-03-23','13:45:00',1.2),('14598','2014-03-23','14:35:00',1.54),('14598','2014-03-23','14:40:00',1.13),('14598','2014-03-23','15:00:00',1.06),('14598','2014-03-23','15:25:00',1.99),('14598','2014-03-23','15:30:00',1.21),('14598','2014-03-23','17:05:00',1.75),('14598','2014-03-23','17:10:00',1.19),('14598','2013-02-20','08:40:00',1.05),('14598','2013-02-20','08:45:00',1.17),('14598','2013-02-20','08:50:00',1.33),('14598','2013-02-20','08:55:00',1.53),('14598','2013-02-20','09:00:00',1.63),('14598','2013-02-20','09:05:00',1.71),('14598','2013-02-20','09:10:00',1.78),('14598','2013-02-20','09:15:00',1.11),('14598','2013-02-20','09:25:00',1.67),('14598','2013-02-20','09:30:00',2.14),('14598','2013-02-20','09:35:00',2.1),('14598','2013-02-20','09:40:00',1.02),('14598','2013-02-20','09:50:00',1.41),('14598','2013-02-20','09:55:00',1.38),('14598','2013-02-20','10:00:00',1.94),('14598','2013-02-20','10:05:00',1.59),('14598','2013-02-20','10:10:00',1.59),('14598','2013-02-20','10:15:00',2.95),('14598','2013-02-20','10:20:00',1.62),('14598','2013-02-20','10:25:00',3.46),('14598','2013-02-20','10:30:00',3.28),('14598','2013-02-20','10:35:00',3.24),('14598','2013-02-20','10:40:00',2.07),('14598','2013-02-20','10:45:00',1.96),('14598','2013-02-20','10:55:00',2.51),('14598','2013-02-20','11:00:00',2.15),('14598','2013-02-20','11:05:00',4),('14598','2013-02-20','11:10:00',3.69),('14598','2013-02-20','11:15:00',3.82),('14598','2013-02-20','11:20:00',3.82),('14598','2013-02-20','11:25:00',3.97),('14598','2013-02-20','11:30:00',3.4),('14598','2013-02-20','11:35:00',2.01),('14598','2013-02-20','11:40:00',1.73),('14598','2013-02-20','11:45:00',2.29),('14598','2013-02-20','11:50:00',3.1),('14598','2013-02-20','11:55:00',1.15),('14598','2013-02-20','12:00:00',1.23),('14598','2013-02-20','12:05:00',1.74),('14598','2013-02-20','12:10:00',1.5),('14598','2013-02-20','12:15:00',1.41),('14598','2013-02-20','12:20:00',1.7),('14598','2013-02-20','12:25:00',1.89),('14598','2013-02-20','12:30:00',2.83),('14598','2013-02-20','12:35:00',2.57),('14598','2013-02-20','12:40:00',3.39),('14598','2013-02-20','12:45:00',2.81),('14598','2013-02-20','12:50:00',2.47),('14598','2013-02-20','12:55:00',1.72),('14598','2013-02-20','13:00:00',3.21),('14598','2013-02-20','13:05:00',3.96),('14598','2013-02-20','13:10:00',2.32),('14598','2013-02-20','13:15:00',1.35),('14598','2013-02-20','13:20:00',2.04),('14598','2013-02-20','13:25:00',3.65),('14598','2013-02-20','13:30:00',4.85),('14598','2013-02-20','13:35:00',4.72),('14598','2013-02-20','13:40:00',4.09),('14598','2013-02-20','13:45:00',4.11),('14598','2013-02-20','13:50:00',3.77),('14598','2013-02-20','13:55:00',3.69),('14598','2013-02-20','14:00:00',3.85),('14598','2013-02-20','14:05:00',3.35),('14598','2013-02-20','14:10:00',2.09),('14598','2013-02-20','14:15:00',2.38),('14598','2013-02-20','14:20:00',1.32),('14598','2013-02-20','14:25:00',1.33),('14598','2013-02-20','14:30:00',2.5),('14598','2013-02-20','14:35:00',1.98),('14598','2013-02-20','14:40:00',1.6),('14598','2013-02-20','14:45:00',1.87),('14598','2013-02-20','14:50:00',2.67),('14598','2013-02-20','14:55:00',2.67),('14598','2013-02-20','15:00:00',2.56),('14598','2013-02-20','15:05:00',2.77),('14598','2013-02-20','15:10:00',2.41),('14598','2013-02-20','15:15:00',2.5),('14598','2013-02-20','15:20:00',2.93),('14598','2013-02-20','15:25:00',2.4),('14598','2013-02-20','15:30:00',1.68),('14598','2013-02-20','15:35:00',1.45),('14598','2013-02-20','15:40:00',1.36),('14598','2013-02-20','15:45:00',1.48),('14598','2013-02-20','15:50:00',1.36),('14598','2013-02-20','15:55:00',1.66),('14598','2013-02-20','16:00:00',1.29),('14598','2013-02-20','16:05:00',1.59),('14598','2013-02-20','16:10:00',1.3),('14598','2013-02-20','16:15:00',2.14),('14598','2013-02-20','16:20:00',2.26),('14598','2013-02-20','16:25:00',2.07),('14598','2013-02-20','16:30:00',1.71),('14598','2013-02-20','16:40:00',1.12),('14598','2013-02-20','16:55:00',1.21),('14598','2013-02-20','17:00:00',1.11),('14598','2013-02-19','08:45:00',1.1),('14598','2013-02-19','08:50:00',1.22),('14598','2013-02-19','08:55:00',1.35),('14598','2013-02-19','09:00:00',1.46),('14598','2013-02-19','09:05:00',1.57),('14598','2013-02-19','09:10:00',1.69),('14598','2013-02-19','09:15:00',1.8),('14598','2013-02-19','09:20:00',1.9),('14598','2013-02-19','09:25:00',2),('14598','2013-02-19','09:30:00',2.1),('14598','2013-02-19','09:35:00',2.19),('14598','2013-02-19','09:40:00',2.3),('14598','2013-02-19','09:45:00',2.39),('14598','2013-02-19','09:50:00',2.46),('14598','2013-02-19','09:55:00',2.55),('14598','2013-02-19','10:00:00',2.64),('14598','2013-02-19','10:05:00',2.72),('14598','2013-02-19','10:10:00',2.8),('14598','2013-02-19','10:15:00',2.88),('14598','2013-02-19','10:20:00',2.95),('14598','2013-02-19','10:25:00',3.02),('14598','2013-02-19','10:30:00',3.1),('14598','2013-02-19','10:35:00',3.16),('14598','2013-02-19','10:40:00',3.22),('14598','2013-02-19','10:45:00',3.29),('14598','2013-02-19','10:50:00',3.34),('14598','2013-02-19','10:55:00',3.38),('14598','2013-02-19','11:00:00',3.4),('14598','2013-02-19','11:05:00',3.47),('14598','2013-02-19','11:10:00',3.51),('14598','2013-02-19','11:15:00',3.58),('14598','2013-02-19','11:20:00',3.59),('14598','2013-02-19','11:25:00',3.63),('14598','2013-02-19','11:30:00',3.68),('14598','2013-02-19','11:35:00',3.74),('14598','2013-02-19','11:40:00',3.74),('14598','2013-02-19','11:45:00',3.78),('14598','2013-02-19','11:50:00',3.83),('14598','2013-02-19','11:55:00',3.85),('14598','2013-02-19','12:00:00',3.84),('14598','2013-02-19','12:05:00',3.87),('14598','2013-02-19','12:10:00',3.86),('14598','2013-02-19','12:15:00',3.89),('14598','2013-02-19','12:20:00',3.91),('14598','2013-02-19','12:25:00',3.89),('14598','2013-02-19','12:30:00',3.89),('14598','2013-02-19','12:35:00',3.95),('14598','2013-02-19','12:40:00',3.94),('14598','2013-02-19','12:45:00',4),('14598','2013-02-19','12:50:00',4.04),('14598','2013-02-19','12:55:00',4.07),('14598','2013-02-19','13:00:00',4.07),('14598','2013-02-19','13:05:00',4.06),('14598','2013-02-19','13:10:00',4.06),('14598','2013-02-19','13:15:00',4.05),('14598','2013-02-19','13:20:00',4.02),('14598','2013-02-19','13:25:00',3.99),('14598','2013-02-19','13:30:00',4.02),('14598','2013-02-19','13:35:00',3.99),('14598','2013-02-19','13:40:00',3.97),('14598','2013-02-19','13:45:00',3.95),('14598','2013-02-19','13:50:00',3.87),('14598','2013-02-19','13:55:00',3.85),('14598','2013-02-19','14:00:00',3.83),('14598','2013-02-19','14:05:00',3.78),('14598','2013-02-19','14:10:00',3.74),('14598','2013-02-19','14:15:00',3.71),('14598','2013-02-19','14:20:00',3.65),('14598','2013-02-19','14:25:00',3.62),('14598','2013-02-19','14:30:00',3.55),('14598','2013-02-19','14:35:00',3.52),('14598','2013-02-19','14:40:00',3.46),('14598','2013-02-19','14:45:00',3.4),('14598','2013-02-19','14:50:00',3.34),('14598','2013-02-19','14:55:00',3.28),('14598','2013-02-19','15:00:00',3.2),('14598','2013-02-19','15:05:00',3.14),('14598','2013-02-19','15:10:00',3.06),('14598','2013-02-19','15:15:00',3),('14598','2013-02-19','15:20:00',2.91),('14598','2013-02-19','15:25:00',2.83),('14598','2013-02-19','15:30:00',2.77),('14598','2013-02-19','15:35:00',2.68),('14598','2013-02-19','15:40:00',2.6),('14598','2013-02-19','15:45:00',2.53),('14598','2013-02-19','15:50:00',2.46),('14598','2013-02-19','15:55:00',2.35),('14598','2013-02-19','16:00:00',2.27),('14598','2013-02-19','16:05:00',2.16),('14598','2013-02-19','16:10:00',2.06),('14598','2013-02-19','16:15:00',1.96),('14598','2013-02-19','16:20:00',1.85),('14598','2013-02-19','16:25:00',1.72),('14598','2013-02-19','16:30:00',1.61),('14598','2013-02-19','16:35:00',1.49),('14598','2013-02-19','16:40:00',1.37),('14598','2013-02-19','16:45:00',1.25),('14598','2013-02-19','16:50:00',1.13),('14598','2013-02-19','16:55:00',1),('14598','2013-02-18','08:45:00',1.15),('14598','2013-02-18','08:50:00',1.21),('14598','2013-02-18','08:55:00',1.12),('14598','2013-02-18','09:00:00',1.38),('14598','2013-02-18','09:05:00',1.57),('14598','2013-02-18','09:10:00',1.54),('14598','2013-02-18','09:15:00',1.42),('14598','2013-02-18','09:20:00',1.57),('14598','2013-02-18','09:25:00',1.45),('14598','2013-02-18','09:30:00',2.03),('14598','2013-02-18','09:35:00',1.31),('14598','2013-02-18','09:40:00',1.82),('14598','2013-02-18','09:45:00',1.21),('14598','2013-02-18','09:50:00',1.82),('14598','2013-02-18','09:55:00',1.25),('14598','2013-02-18','10:00:00',1.23),('14598','2013-02-18','10:05:00',1.29),('14598','2013-02-18','10:10:00',1.19),('14598','2013-02-18','10:15:00',1.16),('14598','2013-02-18','10:20:00',1.53),('14598','2013-02-18','10:25:00',1.52),('14598','2013-02-18','10:30:00',1.88),('14598','2013-02-18','10:35:00',3.49),('14598','2013-02-18','10:40:00',2.08),('14598','2013-02-18','10:45:00',1.82),('14598','2013-02-18','10:50:00',2.48),('14598','2013-02-18','10:55:00',2.3),('14598','2013-02-18','11:00:00',2.07),('14598','2013-02-18','11:05:00',2.1),('14598','2013-02-18','11:10:00',1.68),('14598','2013-02-18','11:15:00',1.73),('14598','2013-02-18','11:20:00',1.79),('14598','2013-02-18','11:25:00',1.76),('14598','2013-02-18','11:30:00',1.95),('14598','2013-02-18','11:35:00',1.99),('14598','2013-02-18','11:40:00',1.85),('14598','2013-02-18','11:45:00',1.76),('14598','2013-02-18','11:50:00',1.77),('14598','2013-02-18','11:55:00',1.79),('14598','2013-02-18','12:00:00',1.73),('14598','2013-02-18','12:05:00',1.77),('14598','2013-02-18','12:10:00',2.48),('14598','2013-02-18','12:15:00',1.8),('14598','2013-02-18','12:20:00',1.73),('14598','2013-02-18','12:25:00',1.72),('14598','2013-02-18','12:30:00',1.42),('14598','2013-02-18','12:35:00',1.65),('14598','2013-02-18','12:40:00',1.69),('14598','2013-02-18','12:45:00',1.89),('14598','2013-02-18','12:50:00',2),('14598','2013-02-18','12:55:00',1.94),('14598','2013-02-18','13:00:00',2.5),('14598','2013-02-18','13:05:00',2.29),('14598','2013-02-18','13:10:00',1.68),('14598','2013-02-18','13:15:00',1.32),('14598','2013-02-18','13:20:00',1.2),('14598','2013-02-18','13:25:00',1.19),('14598','2013-02-18','13:30:00',1.19),('14598','2013-02-18','13:35:00',1.39),('14598','2013-02-18','13:40:00',1.77),('14598','2013-02-18','13:45:00',1.93),('14598','2013-02-18','13:50:00',2.17),('14598','2013-02-18','13:55:00',2.56),('14598','2013-02-18','14:00:00',2.81),('14598','2013-02-18','14:05:00',2.23),('14598','2013-02-18','14:10:00',1.46),('14598','2013-02-18','14:15:00',1.24),('14598','2013-02-18','14:20:00',1.24),('14598','2013-02-18','14:25:00',1.64),('14598','2013-02-18','14:30:00',2.63),('14598','2013-02-18','14:35:00',1.94),('14598','2013-02-18','14:40:00',1.29),('14598','2013-02-18','14:45:00',1.4),('14598','2013-02-18','14:50:00',1.44),('14598','2013-02-18','14:55:00',1.19),('14598','2013-02-18','15:00:00',1.07),('14598','2013-02-17','08:45:00',1.05),('14598','2013-02-17','08:50:00',1.15),('14598','2013-02-17','08:55:00',1.26),('14598','2013-02-17','09:00:00',1.37),('14598','2013-02-17','09:05:00',1.47),('14598','2013-02-17','09:10:00',1.55),('14598','2013-02-17','09:15:00',1.65),('14598','2013-02-17','09:20:00',1.75),('14598','2013-02-17','09:25:00',1.84),('14598','2013-02-17','09:30:00',1.94),('14598','2013-02-17','09:35:00',2.03),('14598','2013-02-17','09:40:00',2.11),('14598','2013-02-17','09:45:00',2.2),('14598','2013-02-17','09:50:00',2.28),('14598','2013-02-17','09:55:00',2.37),('14598','2013-02-17','10:00:00',2.46),('14598','2013-02-17','10:05:00',2.55),('14598','2013-02-17','10:10:00',2.62),('14598','2013-02-17','10:15:00',2.69),('14598','2013-02-17','10:20:00',2.75),('14598','2013-02-17','10:25:00',2.82),('14598','2013-02-17','10:30:00',2.89),('14598','2013-02-17','10:35:00',2.97),('14598','2013-02-17','10:40:00',3.03),('14598','2013-02-17','10:45:00',3.08),('14598','2013-02-17','10:50:00',3.15),('14598','2013-02-17','10:55:00',3.18),('14598','2013-02-17','11:00:00',3.23),('14598','2013-02-17','11:05:00',3.28),('14598','2013-02-17','11:10:00',3.34),('14598','2013-02-17','11:15:00',3.39),('14598','2013-02-17','11:20:00',3.45),('14598','2013-02-17','11:25:00',3.47),('14598','2013-02-17','11:30:00',3.5),('14598','2013-02-17','11:35:00',3.56),('14598','2013-02-17','11:40:00',3.62),('14598','2013-02-17','11:45:00',3.54),('14598','2013-02-17','11:50:00',3.63),('14598','2013-02-17','11:55:00',3.61),('14598','2013-02-17','12:00:00',3.64),('14598','2013-02-17','12:05:00',3.63),('14598','2013-02-17','12:10:00',3.62),('14598','2013-02-17','12:15:00',3.57),('14598','2013-02-17','12:20:00',3.63),('14598','2013-02-17','12:25:00',3.71),('14598','2013-02-17','12:30:00',3.7),('14598','2013-02-17','12:35:00',3.69),('14598','2013-02-17','12:40:00',3.72),('14598','2013-02-17','12:45:00',3.75),('14598','2013-02-17','12:50:00',3.79),('14598','2013-02-17','12:55:00',3.79),('14598','2013-02-17','13:00:00',3.79),('14598','2013-02-17','13:05:00',3.82),('14598','2013-02-17','13:10:00',3.82),('14598','2013-02-17','13:15:00',3.79),('14598','2013-02-17','13:20:00',3.78),('14598','2013-02-17','13:25:00',3.76),('14598','2013-02-17','13:30:00',3.77),('14598','2013-02-17','13:35:00',3.76),('14598','2013-02-17','13:40:00',3.72),('14598','2013-02-17','13:45:00',3.68),('14598','2013-02-17','13:50:00',3.66),('14598','2013-02-17','13:55:00',3.66),('14598','2013-02-17','14:00:00',3.63),('14598','2013-02-17','14:05:00',3.62),('14598','2013-02-17','14:10:00',3.58),('14598','2013-02-17','14:15:00',3.56),('14598','2013-02-17','14:20:00',3.53),('14598','2013-02-17','14:25:00',3.49),('14598','2013-02-17','14:30:00',3.46),('14598','2013-02-17','14:35:00',3.45),('14598','2013-02-17','14:40:00',3.46),('14598','2013-02-17','14:45:00',2.14),('14598','2013-02-17','14:50:00',2.35),('14598','2013-02-17','14:55:00',3.33),('14598','2013-02-17','15:00:00',3.21),('14598','2013-02-17','15:05:00',3.18),('14598','2013-02-17','15:10:00',3.17),('14598','2013-02-17','15:15:00',1.56),('14598','2013-02-17','15:20:00',1.77),('14598','2013-02-17','15:25:00',1.75),('14598','2013-02-17','15:30:00',1.77),('14598','2013-02-17','15:35:00',2.71),('14598','2013-02-17','15:40:00',1.2),('14598','2013-02-17','16:00:00',1.01),('14598','2013-02-17','16:05:00',1.13),('14598','2013-02-17','16:10:00',1.04),('14598','2013-02-16','08:45:00',1.01),('14598','2013-02-16','08:50:00',1.12),('14598','2013-02-16','08:55:00',1.24),('14598','2013-02-16','09:00:00',1.35),('14598','2013-02-16','09:05:00',1.43),('14598','2013-02-16','09:10:00',1.52),('14598','2013-02-16','09:15:00',1.61),('14598','2013-02-16','09:20:00',1.7),('14598','2013-02-16','09:25:00',1.8),('14598','2013-02-16','09:30:00',1.89),('14598','2013-02-16','09:35:00',1.99),('14598','2013-02-16','09:40:00',2.07),('14598','2013-02-16','09:45:00',2.15),('14598','2013-02-16','09:50:00',2.23),('14598','2013-02-16','09:55:00',2.33),('14598','2013-02-16','10:00:00',2.42),('14598','2013-02-16','10:05:00',2.51),('14598','2013-02-16','10:10:00',2.59),('14598','2013-02-16','10:15:00',2.66),('14598','2013-02-16','10:20:00',2.73),('14598','2013-02-16','10:25:00',2.81),('14598','2013-02-16','10:30:00',2.86),('14598','2013-02-16','10:35:00',2.91),('14598','2013-02-16','10:40:00',2.95),('14598','2013-02-16','10:45:00',3),('14598','2013-02-16','10:50:00',3.11),('14598','2013-02-16','10:55:00',3.12),('14598','2013-02-16','11:00:00',3.19),('14598','2013-02-16','11:05:00',3.24),('14598','2013-02-16','11:10:00',3.29),('14598','2013-02-16','11:15:00',3.35),('14598','2013-02-16','11:20:00',3.4),('14598','2013-02-16','11:25:00',3.47),('14598','2013-02-16','11:30:00',3.53),('14598','2013-02-16','11:35:00',3.81),('14598','2013-02-16','11:40:00',3.64),('14598','2013-02-16','11:45:00',3.55),('14598','2013-02-16','11:50:00',3.65),('14598','2013-02-16','11:55:00',3.7),('14598','2013-02-16','12:00:00',3.72),('14598','2013-02-16','12:05:00',3.54),('14598','2013-02-16','12:10:00',3.74),('14598','2013-02-16','12:15:00',3.58),('14598','2013-02-16','12:20:00',3.73),('14598','2013-02-16','12:25:00',3.74),('14598','2013-02-16','12:30:00',3.88),('14598','2013-02-16','12:35:00',3.9),('14598','2013-02-16','12:40:00',2.94),('14598','2013-02-16','12:45:00',3.51),('14598','2013-02-16','12:50:00',3.94),('14598','2013-02-16','12:55:00',3.95),('14598','2013-02-16','13:00:00',4.01),('14598','2013-02-16','13:05:00',2.36),('14598','2013-02-16','13:10:00',4.05),('14598','2013-02-16','13:15:00',3.71),('14598','2013-02-16','13:20:00',4.28),('14598','2013-02-16','13:25:00',2.79),('14598','2013-02-16','13:30:00',2),('14598','2013-02-16','13:35:00',1.15),('14598','2013-02-16','13:40:00',1.16),('14598','2013-02-16','13:45:00',1.22),('14598','2013-02-16','13:50:00',1.17),('14598','2013-02-16','14:25:00',1.22),('14598','2013-02-16','14:30:00',1.38),('14598','2013-02-16','14:35:00',1.51),('14598','2013-02-16','14:40:00',1.92),('14598','2013-02-16','14:45:00',2.97),('14598','2013-02-16','14:50:00',2.38),('14598','2013-02-16','14:55:00',2.01),('14598','2013-02-16','15:00:00',1.27),('14598','2013-02-15','08:55:00',1.17),('14598','2013-02-15','09:00:00',1.34),('14598','2013-02-15','09:05:00',1.52),('14598','2013-02-15','09:10:00',1.68),('14598','2013-02-15','09:15:00',1.79),('14598','2013-02-15','09:20:00',1.7),('14598','2013-02-15','09:25:00',1.99),('14598','2013-02-15','09:30:00',2.33),('14598','2013-02-15','09:35:00',2.65),('14598','2013-02-15','09:40:00',2.75),('14598','2013-02-15','09:45:00',2.26),('14598','2013-02-15','09:50:00',1.51),('14598','2013-02-15','09:55:00',1.97),('14598','2013-02-15','10:00:00',1.66),('14598','2013-02-15','10:05:00',1.52),('14598','2013-02-15','10:10:00',2.48),('14598','2013-02-15','10:15:00',3.27),('14598','2013-02-15','10:20:00',2.42),('14598','2013-02-15','10:25:00',2.02),('14598','2013-02-15','10:30:00',1.97),('14598','2013-02-15','10:35:00',1.59),('14598','2013-02-15','10:40:00',1.65),('14598','2013-02-15','10:45:00',2.56),('14598','2013-02-15','10:50:00',3.54),('14598','2013-02-15','10:55:00',3.51),('14598','2013-02-15','11:00:00',2.95),('14598','2013-02-15','11:05:00',3.61),('14598','2013-02-15','11:10:00',3.39),('14598','2013-02-15','11:15:00',3.73),('14598','2013-02-15','11:20:00',3.93),('14598','2013-02-15','11:25:00',3.24),('14598','2013-02-15','11:30:00',3.3),('14598','2013-02-15','11:35:00',2.58),('14598','2013-02-15','11:40:00',3.53),('14598','2013-02-15','11:45:00',3.9),('14598','2013-02-15','11:50:00',3.71),('14598','2013-02-15','11:55:00',3.76),('14598','2013-02-15','12:00:00',3.88),('14598','2013-02-15','12:05:00',3.8),('14598','2013-02-15','12:10:00',3.87),('14598','2013-02-15','12:15:00',3.86),('14598','2013-02-15','12:20:00',3.86),('14598','2013-02-15','12:25:00',3.96),('14598','2013-02-15','12:30:00',3.95),('14598','2013-02-15','12:35:00',4.02),('14598','2013-02-15','12:40:00',4.09),('14598','2013-02-15','12:45:00',3.69),('14598','2013-02-15','12:50:00',3.01),('14598','2013-02-15','12:55:00',3.11),('14598','2013-02-15','13:00:00',3.95),('14598','2013-02-15','13:05:00',3.43),('14598','2013-02-15','13:10:00',4.05),('14598','2013-02-15','13:15:00',3.64),('14598','2013-02-15','13:20:00',2.71),('14598','2013-02-15','13:25:00',4.07),('14598','2013-02-15','13:30:00',4.21),('14598','2013-02-15','13:35:00',4.02),('14598','2013-02-15','13:40:00',3.75),('14598','2013-02-15','13:45:00',3.9),('14598','2013-02-15','13:50:00',4.08),('14598','2013-02-15','13:55:00',3.74),('14598','2013-02-15','14:00:00',3.64),('14598','2013-02-15','14:05:00',3.32),('14598','2013-02-15','14:10:00',3.6),('14598','2013-02-15','14:15:00',2.82),('14598','2013-02-15','14:20:00',2.82),('14598','2013-02-15','14:25:00',2.89),('14598','2013-02-15','14:30:00',2.83),('14598','2013-02-15','14:35:00',2.16),('14598','2013-02-15','14:40:00',2.14),('14598','2013-02-15','14:45:00',1.4),('14598','2013-02-15','14:50:00',2.25),('14598','2013-02-15','14:55:00',2.2),('14598','2013-02-15','15:00:00',2.34),('14598','2013-02-15','15:05:00',2.56),('14598','2013-02-15','15:10:00',2.26),('14598','2013-02-15','15:15:00',2),('14598','2013-02-15','15:20:00',2.08),('14598','2013-02-15','15:25:00',1.36),('14598','2013-02-15','15:30:00',1.15),('14598','2013-02-15','15:35:00',1.17),('14598','2013-02-15','15:40:00',1.08),('14598','2013-02-14','08:45:00',1.05),('14598','2013-02-14','08:50:00',1.14),('14598','2013-02-14','08:55:00',1.22),('14598','2013-02-14','09:00:00',1.27),('14598','2013-02-14','09:05:00',1.42),('14598','2013-02-14','09:10:00',1.57),('14598','2013-02-14','09:15:00',1.68),('14598','2013-02-14','09:20:00',1.76),('14598','2013-02-14','09:25:00',1.87),('14598','2013-02-14','09:30:00',1.96),('14598','2013-02-14','09:35:00',2.06),('14598','2013-02-14','09:40:00',2.15),('14598','2013-02-14','09:45:00',2.24),('14598','2013-02-14','09:50:00',2.33),('14598','2013-02-14','09:55:00',2.42),('14598','2013-02-14','10:00:00',2.5),('14598','2013-02-14','10:05:00',2.59),('14598','2013-02-14','10:10:00',2.68),('14598','2013-02-14','10:15:00',2.76),('14598','2013-02-14','10:20:00',2.84),('14598','2013-02-14','10:25:00',2.91),('14598','2013-02-14','10:30:00',2.98),('14598','2013-02-14','10:35:00',3.05),('14598','2013-02-14','10:40:00',3.13),('14598','2013-02-14','10:45:00',3.19),('14598','2013-02-14','10:50:00',3.25),('14598','2013-02-14','10:55:00',3.31),('14598','2013-02-14','11:00:00',3.37),('14598','2013-02-14','11:05:00',3.37),('14598','2013-02-14','11:10:00',3.45),('14598','2013-02-14','11:15:00',3.51),('14598','2013-02-14','11:20:00',3.56),('14598','2013-02-14','11:25:00',3.61),('14598','2013-02-14','11:30:00',3.66),('14598','2013-02-14','11:35:00',3.69),('14598','2013-02-14','11:40:00',3.71),('14598','2013-02-14','11:45:00',3.76),('14598','2013-02-14','11:50:00',3.79),('14598','2013-02-14','11:55:00',3.81),('14598','2013-02-14','12:00:00',3.85),('14598','2013-02-14','12:05:00',3.77),('14598','2013-02-14','12:10:00',3.89),('14598','2013-02-14','12:15:00',3.91),('14598','2013-02-14','12:20:00',3.91),('14598','2013-02-14','12:25:00',3.93),('14598','2013-02-14','12:30:00',3.93),('14598','2013-02-14','12:35:00',3.94),('14598','2013-02-14','12:40:00',3.94),('14598','2013-02-14','12:45:00',3.93),('14598','2013-02-14','12:50:00',3.94),('14598','2013-02-14','12:55:00',3.94),('14598','2013-02-14','13:00:00',3.94),('14598','2013-02-14','13:05:00',3.94),('14598','2013-02-14','13:10:00',3.93),('14598','2013-02-14','13:15:00',3.92),('14598','2013-02-14','13:20:00',3.9),('14598','2013-02-14','13:25:00',3.88),('14598','2013-02-14','13:30:00',3.86),('14598','2013-02-14','13:35:00',3.83),('14598','2013-02-14','13:40:00',3.8),('14598','2013-02-14','13:45:00',3.78),('14598','2013-02-14','13:50:00',3.76),('14598','2013-02-14','13:55:00',3.73),('14598','2013-02-14','14:00:00',3.68),('14598','2013-02-14','14:05:00',3.61),('14598','2013-02-14','14:10:00',3.61),('14598','2013-02-14','14:15:00',3.56),('14598','2013-02-14','14:20:00',3.52),('14598','2013-02-14','14:25:00',3.46),('14598','2013-02-14','14:30:00',3.42),('14598','2013-02-14','14:35:00',3.36),('14598','2013-02-14','14:40:00',3.32),('14598','2013-02-14','14:45:00',3.24),('14598','2013-02-14','14:50:00',3.2),('14598','2013-02-14','14:55:00',3.14),('14598','2013-02-14','15:00:00',3.08),('14598','2013-02-14','15:05:00',3.01),('14598','2013-02-14','15:10:00',2.94),('14598','2013-02-14','15:15:00',2.85),('14598','2013-02-14','15:20:00',2.73),('14598','2013-02-14','15:25:00',2.66),('14598','2013-02-14','15:30:00',2.58),('14598','2013-02-14','15:35:00',2.49),('14598','2013-02-14','15:40:00',2.44),('14598','2013-02-14','15:45:00',2.35),('14598','2013-02-14','15:50:00',2.26),('14598','2013-02-14','15:55:00',2.16),('14598','2013-02-14','16:00:00',2.05),('14598','2013-02-14','16:05:00',1.95),('14598','2013-02-14','16:10:00',1.85),('14598','2013-02-14','16:15:00',1.74),('14598','2013-02-14','16:20:00',1.64),('14598','2013-02-14','16:25:00',1.54),('14598','2013-02-14','16:30:00',1.43),('14598','2013-02-14','16:35:00',1.31),('14598','2013-02-14','16:40:00',1.19),('14598','2013-02-14','16:45:00',1.03),('14598','2013-02-13','09:00:00',1.02),('14598','2013-02-13','09:05:00',1.09),('14598','2013-02-13','09:10:00',1.13),('14598','2013-02-13','09:15:00',1.26),('14598','2013-02-13','09:20:00',1.33),('14598','2013-02-13','09:25:00',1.4),('14598','2013-02-13','09:30:00',1.52),('14598','2013-02-13','09:35:00',1.67),('14598','2013-02-13','09:40:00',1.71),('14598','2013-02-13','09:45:00',1.97),('14598','2013-02-13','09:50:00',2.22),('14598','2013-02-13','09:55:00',2.41),('14598','2013-02-13','10:00:00',2.5),('14598','2013-02-13','10:05:00',2.34),('14598','2013-02-13','10:10:00',2.29),('14598','2013-02-13','10:15:00',2.26),('14598','2013-02-13','10:20:00',2.16),('14598','2013-02-13','10:25:00',2.2),('14598','2013-02-13','10:30:00',2.62),('14598','2013-02-13','10:35:00',2.94),('14598','2013-02-13','10:40:00',2.95),('14598','2013-02-13','10:45:00',2.7),('14598','2013-02-13','10:50:00',2.92),('14598','2013-02-13','10:55:00',3.26),('14598','2013-02-13','11:00:00',3.26),('14598','2013-02-13','11:05:00',3.2),('14598','2013-02-13','11:10:00',3.27),('14598','2013-02-13','11:15:00',3.3),('14598','2013-02-13','11:20:00',3.1),('14598','2013-02-13','11:25:00',3.42),('14598','2013-02-13','11:30:00',3.69),('14598','2013-02-13','11:35:00',3.82),('14598','2013-02-13','11:40:00',3.81),('14598','2013-02-13','11:45:00',3.68),('14598','2013-02-13','11:50:00',3.46),('14598','2013-02-13','11:55:00',3.2),('14598','2013-02-13','12:00:00',3.43),('14598','2013-02-13','12:05:00',3.89),('14598','2013-02-13','12:10:00',3.55),('14598','2013-02-13','12:15:00',3.57),('14598','2013-02-13','12:20:00',3.89),('14598','2013-02-13','12:25:00',3.83),('14598','2013-02-13','12:30:00',3.86),('14598','2013-02-13','12:35:00',3.77),('14598','2013-02-13','12:40:00',3.79),('14598','2013-02-13','12:45:00',3.69),('14598','2013-02-13','12:50:00',3.95),('14598','2013-02-13','12:55:00',3.86),('14598','2013-02-13','13:00:00',4.31),('14598','2013-02-13','13:05:00',4.42),('14598','2013-02-13','13:10:00',3.89),('14598','2013-02-13','13:15:00',4.1),('14598','2013-02-13','13:20:00',4.19),('14598','2013-02-13','13:25:00',4.17),('14598','2013-02-13','13:30:00',4),('14598','2013-02-13','13:35:00',3.87),('14598','2013-02-13','13:40:00',3.7),('14598','2013-02-13','13:45:00',3.71),('14598','2013-02-13','13:50:00',3.27),('14598','2013-02-13','13:55:00',3.14),('14598','2013-02-13','14:00:00',3.34),('14598','2013-02-13','14:05:00',3.51),('14598','2013-02-13','14:10:00',3.26),('14598','2013-02-13','14:15:00',3.46),('14598','2013-02-13','14:20:00',3.63),('14598','2013-02-13','14:25:00',3.59),('14598','2013-02-13','14:30:00',3.57),('14598','2013-02-13','14:35:00',3.45),('14598','2013-02-13','14:40:00',3.43),('14598','2013-02-13','14:45:00',3.13),('14598','2013-02-13','14:50:00',2.84),('14598','2013-02-13','14:55:00',2.71),('14598','2013-02-13','15:00:00',3.06),('14598','2013-02-13','15:05:00',3.05),('14598','2013-02-13','15:10:00',2.9),('14598','2013-02-13','15:15:00',2.83),('14598','2013-02-13','15:20:00',2.76),('14598','2013-02-13','15:25:00',2.67),('14598','2013-02-13','15:30:00',2.62),('14598','2013-02-13','15:35:00',2.48),('14598','2013-02-13','15:40:00',2.37),('14598','2013-02-13','15:45:00',2.3),('14598','2013-02-13','15:50:00',2.21),('14598','2013-02-13','15:55:00',2.12),('14598','2013-02-13','16:00:00',2.02),('14598','2013-02-13','16:05:00',1.91),('14598','2013-02-13','16:10:00',1.58),('14598','2014-03-22','08:00:00',1.01),('14598','2014-03-22','08:05:00',1.05),('14598','2014-03-22','08:10:00',1.17),('14598','2014-03-22','08:15:00',1.18),('14598','2014-03-22','08:20:00',1.34),('14598','2014-03-22','08:25:00',1.5),('14598','2014-03-22','08:30:00',1.65),('14598','2014-03-22','08:35:00',1.84),('14598','2014-03-22','08:40:00',1.21),('14598','2014-03-22','08:45:00',1.25),('14598','2014-03-22','08:55:00',1.02),('14598','2014-03-22','09:00:00',1.06),('14598','2014-03-22','09:05:00',1.57),('14598','2014-03-22','09:10:00',1.68),('14598','2014-03-22','09:15:00',1.77),('14598','2014-03-22','09:20:00',2.03),('14598','2014-03-22','09:25:00',2.85),('14598','2014-03-22','09:30:00',2.56),('14598','2014-03-22','09:35:00',2.56),('14598','2014-03-22','09:40:00',2.86),('14598','2014-03-22','09:45:00',3.05),('14598','2014-03-22','09:50:00',3.17),('14598','2014-03-22','09:55:00',2.21),('14598','2014-03-22','10:00:00',2.91),('14598','2014-03-22','10:05:00',3.4),('14598','2014-03-22','10:10:00',2.8),('14598','2014-03-22','10:15:00',3.07),('14598','2014-03-22','10:20:00',3.63),('14598','2014-03-22','10:25:00',3.04),('14598','2014-03-22','10:30:00',2.06),('14598','2014-03-22','10:35:00',2.22),('14598','2014-03-22','10:40:00',2.22),('14598','2014-03-22','10:45:00',2.92),('14598','2014-03-22','10:50:00',2.57),('14598','2014-03-22','10:55:00',3.79),('14598','2014-03-22','11:00:00',3.89),('14598','2014-03-22','11:05:00',4.16),('14598','2014-03-22','11:10:00',4.32),('14598','2014-03-22','11:15:00',4.22),('14598','2014-03-22','11:20:00',4.16),('14598','2014-03-22','11:25:00',4.23),('14598','2014-03-22','11:30:00',4.23),('14598','2014-03-22','11:35:00',4.28),('14598','2014-03-22','11:40:00',4.31),('14598','2014-03-22','11:45:00',4.36),('14598','2014-03-22','11:50:00',4.34),('14598','2014-03-22','11:55:00',4.36),('14598','2014-03-22','12:00:00',4.4),('14598','2014-03-22','12:05:00',4.42),('14598','2014-03-22','12:10:00',4.4),('14598','2014-03-22','12:15:00',4.42),('14598','2014-03-22','12:20:00',4.44),('14598','2014-03-22','12:25:00',4.5),('14598','2014-03-22','12:30:00',4.5),('14598','2014-03-22','12:35:00',4.47),('14598','2014-03-22','12:40:00',4.49),('14598','2014-03-22','12:45:00',4.49),('14598','2014-03-22','12:50:00',4.54),('14598','2014-03-22','12:55:00',4.53),('14598','2014-03-22','13:00:00',4.52),('14598','2014-03-22','13:05:00',4.5),('14598','2014-03-22','13:10:00',4.48),('14598','2014-03-22','13:15:00',4.48),('14598','2014-03-22','13:20:00',4.46),('14598','2014-03-22','13:25:00',4.45),('14598','2014-03-22','13:30:00',4.43),('14598','2014-03-22','13:35:00',4.4),('14598','2014-03-22','13:40:00',4.38),('14598','2014-03-22','13:45:00',4.36),('14598','2014-03-22','13:50:00',4.32),('14598','2014-03-22','13:55:00',4.29),('14598','2014-03-22','14:00:00',4.27),('14598','2014-03-22','14:05:00',4.24),('14598','2014-03-22','14:10:00',4.2),('14598','2014-03-22','14:15:00',4.14),('14598','2014-03-22','14:20:00',4.04),('14598','2014-03-22','14:25:00',4.06),('14598','2014-03-22','14:30:00',4.01),('14598','2014-03-22','14:35:00',3.96),('14598','2014-03-22','14:40:00',3.89),('14598','2014-03-22','14:45:00',3.84),('14598','2014-03-22','14:50:00',3.79),('14598','2014-03-22','14:55:00',3.73),('14598','2014-03-22','15:00:00',3.68),('14598','2014-03-22','15:05:00',3.61),('14598','2014-03-22','15:10:00',3.52),('14598','2014-03-22','15:15:00',3.45),('14598','2014-03-22','15:20:00',3.37),('14598','2014-03-22','15:25:00',3.31),('14598','2014-03-22','15:30:00',3.22),('14598','2014-03-22','15:35:00',3.13),('14598','2014-03-22','15:40:00',3.06),('14598','2014-03-22','15:45:00',2.96),('14598','2014-03-22','15:50:00',2.87),('14598','2014-03-22','15:55:00',2.2),('14598','2014-03-22','16:00:00',1.01),('14598','2014-03-22','16:35:00',1.03),('14598','2014-03-22','16:40:00',1.26),('14598','2013-02-10','09:10:00',1.02),('14598','2013-02-10','09:15:00',1.57),('14598','2013-02-10','09:20:00',1.7),('14598','2013-02-10','09:25:00',1.82),('14598','2013-02-10','09:30:00',1.87),('14598','2013-02-10','09:35:00',1.85),('14598','2013-02-10','09:40:00',1.88),('14598','2013-02-10','09:45:00',2.12),('14598','2013-02-10','09:50:00',2.22),('14598','2013-02-10','09:55:00',2.32),('14598','2013-02-10','10:00:00',2.41),('14598','2013-02-10','10:05:00',2.51),('14598','2013-02-10','10:10:00',2.52),('14598','2013-02-10','10:15:00',2.3),('14598','2013-02-10','10:20:00',2.68),('14598','2013-02-10','10:25:00',2.8),('14598','2013-02-10','10:30:00',2.89),('14598','2013-02-10','10:35:00',2.97),('14598','2013-02-10','10:40:00',3.03),('14598','2013-02-10','10:45:00',3.1),('14598','2013-02-10','10:50:00',3.17),('14598','2013-02-10','10:55:00',3.16),('14598','2013-02-10','11:00:00',3.17),('14598','2013-02-10','11:05:00',3.31),('14598','2013-02-10','11:10:00',3.35),('14598','2013-02-10','11:15:00',3.38),('14598','2013-02-10','11:20:00',3.48),('14598','2013-02-10','11:25:00',3.52),('14598','2013-02-10','11:30:00',3.54),('14598','2013-02-10','11:35:00',3.26),('14598','2013-02-10','11:40:00',3.61),('14598','2013-02-10','11:45:00',3.64),('14598','2013-02-10','11:50:00',3.69),('14598','2013-02-10','11:55:00',3.71),('14598','2013-02-10','12:00:00',3.71),('14598','2013-02-10','12:05:00',3.75),('14598','2013-02-10','12:10:00',3.78),('14598','2013-02-10','12:15:00',3.8),('14598','2013-02-10','12:20:00',3.75),('14598','2013-02-10','12:25:00',3.79),('14598','2013-02-10','12:30:00',3.77),('14598','2013-02-10','12:35:00',3.79),('14598','2013-02-10','12:40:00',3.78),('14598','2013-02-10','12:45:00',3.79),('14598','2013-02-10','12:50:00',3.7),('14598','2013-02-10','12:55:00',3.6),('14598','2013-02-10','13:00:00',3.72),('14598','2013-02-10','13:05:00',3.71),('14598','2013-02-10','13:10:00',3.76),('14598','2013-02-10','13:15:00',3.79),('14598','2013-02-10','13:20:00',3.77),('14598','2013-02-10','13:25:00',3.61),('14598','2013-02-10','13:30:00',2.93),('14598','2013-02-10','13:35:00',3.69),('14598','2013-02-10','13:40:00',3.55),('14598','2013-02-10','13:45:00',3.65),('14598','2013-02-10','13:50:00',3.61),('14598','2013-02-10','13:55:00',3.71),('14598','2013-02-10','14:00:00',3.68),('14598','2013-02-10','14:05:00',3.64),('14598','2013-02-10','14:10:00',3.73),('14598','2013-02-10','14:15:00',3.78),('14598','2013-02-10','14:20:00',3.51),('14598','2013-02-10','14:25:00',3.48),('14598','2013-02-10','14:30:00',3.5),('14598','2013-02-10','14:35:00',3.52),('14598','2013-02-10','14:40:00',3.36),('14598','2013-02-10','14:45:00',3.3),('14598','2013-02-10','14:50:00',3.28),('14598','2013-02-10','14:55:00',3.16),('14598','2013-02-10','15:00:00',3.04),('14598','2013-02-10','15:05:00',2.95),('14598','2013-02-10','15:10:00',2.88),('14598','2013-02-10','15:15:00',2.83),('14598','2013-02-10','15:20:00',2.77),('14598','2013-02-10','15:25:00',2.69),('14598','2013-02-10','15:30:00',2.6),('14598','2013-02-10','15:35:00',2.53),('14598','2013-02-10','15:40:00',2.49),('14598','2013-02-10','15:45:00',2.45),('14598','2013-02-10','15:50:00',2.35),('14598','2013-02-10','15:55:00',2.21),('14598','2013-02-10','16:00:00',2.1),('14598','2013-02-10','16:05:00',1.98),('14598','2013-02-10','16:10:00',1.63),('14598','2013-02-09','10:05:00',1.02),('14598','2013-02-09','10:10:00',1.11),('14598','2013-02-09','10:15:00',1.22),('14598','2013-02-09','10:20:00',1.32),('14598','2013-02-09','10:25:00',1.35),('14598','2013-02-09','10:30:00',1.33),('14598','2013-02-09','10:35:00',1.34),('14598','2013-02-09','10:40:00',1.46),('14598','2013-02-09','10:45:00',1.45),('14598','2013-02-09','10:50:00',1.32),('14598','2013-02-09','10:55:00',1.23),('14598','2013-02-09','11:00:00',1.26),('14598','2013-02-09','11:05:00',1.25),('14598','2013-02-09','11:10:00',1.21),('14598','2013-02-09','11:15:00',1.23),('14598','2013-02-09','11:20:00',1.29),('14598','2013-02-09','11:25:00',1.38),('14598','2013-02-09','11:30:00',1.45),('14598','2013-02-09','11:35:00',1.48),('14598','2013-02-09','11:40:00',1.51),('14598','2013-02-09','11:45:00',1.5),('14598','2013-02-09','11:50:00',1.48),('14598','2013-02-09','11:55:00',1.53),('14598','2013-02-09','12:00:00',1.55),('14598','2013-02-09','12:05:00',1.58),('14598','2013-02-09','12:10:00',1.63),('14598','2013-02-09','12:15:00',1.65),('14598','2013-02-09','12:20:00',1.75),('14598','2013-02-09','12:25:00',1.84),('14598','2013-02-09','12:30:00',1.81),('14598','2013-02-09','12:35:00',1.87),('14598','2013-02-09','12:40:00',2.21),('14598','2013-02-09','12:45:00',2.36),('14598','2013-02-09','12:50:00',2.61),('14598','2013-02-09','12:55:00',2.71),('14598','2013-02-09','13:00:00',3.15),('14598','2013-02-09','13:05:00',3.45),('14598','2013-02-09','13:10:00',3.73),('14598','2013-02-09','13:15:00',4.11),('14598','2013-02-09','13:20:00',3.91),('14598','2013-02-09','13:25:00',3.31),('14598','2013-02-09','13:30:00',3.96),('14598','2013-02-09','13:35:00',3.87),('14598','2013-02-09','13:40:00',3.88),('14598','2013-02-09','13:45:00',3.82),('14598','2013-02-09','13:50:00',3.56),('14598','2013-02-09','13:55:00',3.8),('14598','2013-02-09','14:00:00',3.57),('14598','2013-02-09','14:05:00',3.07),('14598','2013-02-09','14:10:00',2.02),('14598','2013-02-09','14:15:00',1.45),('14598','2013-02-09','14:20:00',2.3),('14598','2013-02-09','14:25:00',2.63),('14598','2013-02-09','14:30:00',2.95),('14598','2013-02-09','14:35:00',3.39),('14598','2013-02-09','14:40:00',2.27),('14598','2013-02-09','14:45:00',1.02),('14598','2013-02-09','14:50:00',2.08),('14598','2013-02-09','14:55:00',3.21),('14598','2013-02-09','15:00:00',3.04),('14598','2013-02-09','15:05:00',2.97),('14598','2013-02-09','15:10:00',2.88),('14598','2013-02-09','15:15:00',2.81),('14598','2013-02-09','15:20:00',2.7),('14598','2013-02-09','15:25:00',2.61),('14598','2013-02-09','15:30:00',2.53),('14598','2013-02-09','15:35:00',2.45),('14598','2013-02-09','15:40:00',2.38),('14598','2013-02-09','15:45:00',2.29),('14598','2013-02-09','15:50:00',2.19),('14598','2013-02-09','15:55:00',2.09),('14598','2013-02-09','16:00:00',1.99),('14598','2013-02-09','16:05:00',1.89),('14598','2013-02-09','16:10:00',1.77),('14598','2013-02-09','16:15:00',1.68),('14598','2013-02-09','16:20:00',1.57),('14598','2013-02-09','16:25:00',1.46),('14598','2013-02-09','16:30:00',1.34),('14598','2013-02-09','16:35:00',1.21),('14598','2013-02-09','16:40:00',1.11),('14598','2013-02-08','08:50:00',1.01),('14598','2013-02-08','09:00:00',1.36),('14598','2013-02-08','09:05:00',1.53),('14598','2013-02-08','09:10:00',1.56),('14598','2013-02-08','09:15:00',1.72),('14598','2013-02-08','09:20:00',1.8),('14598','2013-02-08','09:25:00',1.88),('14598','2013-02-08','09:30:00',1.85),('14598','2013-02-08','09:35:00',1.9),('14598','2013-02-08','09:40:00',1.98),('14598','2013-02-08','09:45:00',2.06),('14598','2013-02-08','09:50:00',2.15),('14598','2013-02-08','09:55:00',2.24),('14598','2013-02-08','10:00:00',2.32),('14598','2013-02-08','10:05:00',2.42),('14598','2013-02-08','10:10:00',2.49),('14598','2013-02-08','10:15:00',2.58),('14598','2013-02-08','10:20:00',2.67),('14598','2013-02-08','10:25:00',2.74),('14598','2013-02-08','10:30:00',2.79),('14598','2013-02-08','10:35:00',2.88),('14598','2013-02-08','10:40:00',3.03),('14598','2013-02-08','10:45:00',2.83),('14598','2013-02-08','10:50:00',3.09),('14598','2013-02-08','10:55:00',3.17),('14598','2013-02-08','11:00:00',3.25),('14598','2013-02-08','11:05:00',3.27),('14598','2013-02-08','11:10:00',3.31),('14598','2013-02-08','11:15:00',3.36),('14598','2013-02-08','11:20:00',3.45),('14598','2013-02-08','11:25:00',3.57),('14598','2013-02-08','11:30:00',3.66),('14598','2013-02-08','11:35:00',3.77),('14598','2013-02-08','11:40:00',3.87),('14598','2013-02-08','11:45:00',3.4),('14598','2013-02-08','11:50:00',3.83),('14598','2013-02-08','11:55:00',3.82),('14598','2013-02-08','12:00:00',3.83),('14598','2013-02-08','12:05:00',3.68),('14598','2013-02-08','12:10:00',3.11),('14598','2013-02-08','12:15:00',2.64),('14598','2013-02-08','12:20:00',2.48),('14598','2013-02-08','12:25:00',2.35),('14598','2013-02-08','12:30:00',2.79),('14598','2013-02-08','12:35:00',3.46),('14598','2013-02-08','12:40:00',3.66),('14598','2013-02-08','12:45:00',3.42),('14598','2013-02-08','12:50:00',3.97),('14598','2013-02-08','12:55:00',2.32),('14598','2013-02-08','13:00:00',2.62),('14598','2013-02-08','13:05:00',1.79),('14598','2013-02-08','13:10:00',1.92),('14598','2013-02-08','13:15:00',2.08),('14598','2013-02-08','13:20:00',2.1),('14598','2013-02-08','13:25:00',1.97),('14598','2013-02-08','13:30:00',1.99),('14598','2013-02-08','13:35:00',1.93),('14598','2013-02-08','13:40:00',1.47),('14598','2013-02-08','13:45:00',1.82),('14598','2013-02-08','13:50:00',2.22),('14598','2013-02-08','13:55:00',3.76),('14598','2013-02-08','14:00:00',3.72),('14598','2013-02-08','14:05:00',2.98),('14598','2013-02-08','14:10:00',2.53),('14598','2013-02-08','14:15:00',4.18),('14598','2013-02-08','14:20:00',4.33),('14598','2013-02-08','14:25:00',4.14),('14598','2013-02-08','14:30:00',2.14),('14598','2013-02-08','14:35:00',2.34),('14598','2013-02-08','14:40:00',3.93),('14598','2013-02-08','14:45:00',3.9),('14598','2013-02-08','14:50:00',3.35),('14598','2013-02-08','14:55:00',1.99),('14598','2013-02-08','15:00:00',2.76),('14598','2013-02-08','15:05:00',3.1),('14598','2013-02-08','15:10:00',1.85),('14598','2013-02-08','15:15:00',2.84),('14598','2013-02-08','15:20:00',2.02),('14598','2013-02-08','15:35:00',1.34),('14598','2013-02-08','15:40:00',2.38),('14598','2013-02-08','15:45:00',2.7),('14598','2013-02-08','15:50:00',2.57),('14598','2013-02-08','15:55:00',2.4),('14598','2013-02-08','16:00:00',2.22),('14598','2013-02-08','16:05:00',2.01),('14598','2013-02-08','16:10:00',1.54),('14598','2013-02-08','16:20:00',1.05),('14598','2013-02-07','09:55:00',2.38),('14598','2013-02-07','10:00:00',1.58),('14598','2013-02-07','10:05:00',2.17),('14598','2013-02-07','10:10:00',2.43),('14598','2013-02-07','10:15:00',2.52),('14598','2013-02-07','10:20:00',2.62),('14598','2013-02-07','10:25:00',2.7),('14598','2013-02-07','10:30:00',2.59),('14598','2013-02-07','10:35:00',2.9),('14598','2013-02-07','10:40:00',3.32),('14598','2013-02-07','10:45:00',3.72),('14598','2013-02-07','10:50:00',4.52),('14598','2013-02-07','10:55:00',4.52),('14598','2013-02-07','11:00:00',2.27),('14598','2013-02-07','11:25:00',1.21),('14598','2013-02-07','11:30:00',2.92),('14598','2013-02-07','11:35:00',1.44),('14598','2013-02-07','12:05:00',1.09),('14598','2013-02-07','12:10:00',1.6),('14598','2013-02-07','12:15:00',1.47),('14598','2013-02-07','12:20:00',2.05),('14598','2013-02-07','12:25:00',1.54),('14598','2013-02-07','12:30:00',1.61),('14598','2013-02-07','12:35:00',1.82),('14598','2013-02-07','12:40:00',1.4),('14598','2013-02-07','12:45:00',2.12),('14598','2013-02-07','12:50:00',2.33),('14598','2013-02-07','12:55:00',4.28),('14598','2013-02-07','13:00:00',4.59),('14598','2013-02-07','13:05:00',4.18),('14598','2013-02-07','13:10:00',1.83),('14598','2013-02-07','13:15:00',1.13),('14598','2013-02-07','13:30:00',1.37),('14598','2013-02-07','13:35:00',1.23),('14598','2013-02-07','13:45:00',1.12),('14598','2013-02-07','13:50:00',1.11),('14598','2013-02-07','13:55:00',1.04),('14598','2013-02-07','14:00:00',2.58),('14598','2013-02-07','14:05:00',4.19),('14598','2013-02-07','14:10:00',3.66),('14598','2013-02-07','14:15:00',3.49),('14598','2013-02-07','14:20:00',3.44),('14598','2013-02-07','14:25:00',2.99),('14598','2013-02-07','14:30:00',1.77),('14598','2013-02-07','14:35:00',1.46),('14598','2013-02-07','14:40:00',1.25),('14598','2013-02-07','14:45:00',1.44),('14598','2013-02-07','14:50:00',1.14),('14598','2013-02-07','14:55:00',1.13),('14598','2013-02-07','16:45:00',1.1),('14598','2013-02-07','16:50:00',1.28),('14598','2013-02-07','16:55:00',1),('14598','2013-02-06','09:15:00',1.06),('14598','2013-02-06','09:20:00',1.07),('14598','2013-02-06','09:25:00',1.18),('14598','2013-02-06','09:30:00',1.22),('14598','2013-02-06','09:35:00',1.17),('14598','2013-02-06','09:40:00',1.17),('14598','2013-02-06','09:45:00',1.19),('14598','2013-02-06','09:50:00',1.16),('14598','2013-02-06','09:55:00',1.47),('14598','2013-02-06','10:00:00',1.48),('14598','2013-02-06','10:05:00',1.46),('14598','2013-02-06','10:10:00',2.3),('14598','2013-02-06','10:15:00',1.89),('14598','2013-02-06','10:20:00',1.16),('14598','2013-02-06','10:25:00',1.24),('14598','2013-02-06','10:30:00',1.2),('14598','2013-02-06','10:35:00',1.21),('14598','2013-02-06','10:40:00',1.49),('14598','2013-02-06','10:45:00',1.61),('14598','2013-02-06','10:50:00',1.55),('14598','2013-02-06','10:55:00',1.71),('14598','2013-02-06','11:00:00',1.83),('14598','2013-02-06','11:05:00',1.95),('14598','2013-02-06','11:10:00',1.59),('14598','2013-02-06','11:15:00',1.13),('14598','2013-02-06','11:20:00',1.07),('14598','2013-02-06','11:25:00',1.32),('14598','2013-02-06','11:30:00',1.54),('14598','2013-02-06','11:35:00',1.67),('14598','2013-02-06','11:40:00',1.36),('14598','2013-02-06','11:45:00',1.34),('14598','2013-02-06','11:50:00',1.4),('14598','2013-02-06','11:55:00',1.29),('14598','2013-02-06','12:00:00',1.24),('14598','2013-02-06','12:05:00',1.02),('14598','2013-02-06','12:10:00',1.15),('14598','2013-02-06','12:15:00',1.18),('14598','2013-02-06','12:20:00',1.1),('14598','2013-02-06','12:25:00',1.22),('14598','2013-02-06','12:30:00',1.54),('14598','2013-02-06','12:35:00',1.33),('14598','2013-02-06','12:40:00',1.08),('14598','2013-02-06','12:45:00',1.27),('14598','2013-02-06','12:50:00',1.02),('14598','2013-02-06','13:00:00',1.21),('14598','2013-02-06','13:05:00',1.28),('14598','2013-02-06','13:10:00',1.32),('14598','2013-02-06','13:15:00',1.41),('14598','2013-02-06','13:20:00',1.82),('14598','2013-02-06','13:25:00',1.52),('14598','2013-02-06','13:30:00',2.1),('14598','2013-02-06','13:35:00',2.91),('14598','2013-02-06','13:40:00',2.3),('14598','2013-02-06','13:45:00',1.7),('14598','2013-02-06','13:50:00',1.42),('14598','2013-02-06','14:05:00',1.3),('14598','2013-02-06','14:10:00',1.14),('14598','2013-02-06','14:50:00',1.99),('14598','2013-02-06','14:55:00',3.75),('14598','2013-02-06','15:00:00',2.52),('14598','2013-02-06','15:05:00',1.7),('14598','2013-02-06','15:10:00',2.23),('14598','2013-02-06','15:15:00',1.89),('14598','2013-02-06','15:25:00',1.1),('14598','2013-02-06','15:30:00',1),('14598','2013-02-06','16:40:00',1.12),('14598','2013-02-06','16:45:00',1.24),('14598','2013-02-06','16:50:00',1),('14598','2013-02-05','09:00:00',1.07),('14598','2013-02-05','09:05:00',1.19),('14598','2013-02-05','09:10:00',1.28),('14598','2013-02-05','09:15:00',1.39),('14598','2013-02-05','09:20:00',1.43),('14598','2013-02-05','09:25:00',1.55),('14598','2013-02-05','09:30:00',1.69),('14598','2013-02-05','09:35:00',1.79),('14598','2013-02-05','09:40:00',1.88),('14598','2013-02-05','09:45:00',1.96),('14598','2013-02-05','09:50:00',2.04),('14598','2013-02-05','09:55:00',2.05),('14598','2013-02-05','10:00:00',2.22),('14598','2013-02-05','10:05:00',2.31),('14598','2013-02-05','10:10:00',2.38),('14598','2013-02-05','10:15:00',2.45),('14598','2013-02-05','10:20:00',2.51),('14598','2013-02-05','10:25:00',2.58),('14598','2013-02-05','10:30:00',2.65),('14598','2013-02-05','10:35:00',2.71),('14598','2013-02-05','10:40:00',2.79),('14598','2013-02-05','10:45:00',2.85),('14598','2013-02-05','10:50:00',2.98),('14598','2013-02-05','10:55:00',3),('14598','2013-02-05','11:00:00',2.9),('14598','2013-02-05','11:05:00',2.47),('14598','2013-02-05','11:10:00',2.63),('14598','2013-02-05','11:15:00',2.56),('14598','2013-02-05','11:20:00',2.72),('14598','2013-02-05','11:25:00',3.27),('14598','2013-02-05','11:30:00',3.23),('14598','2013-02-05','11:35:00',3.32),('14598','2013-02-05','11:40:00',3.31),('14598','2013-02-05','11:45:00',3.49),('14598','2013-02-05','11:50:00',2.9),('14598','2013-02-05','11:55:00',3.29),('14598','2013-02-05','12:00:00',3.1),('14598','2013-02-05','12:05:00',3.8),('14598','2013-02-05','12:10:00',3.1),('14598','2013-02-05','12:15:00',2.96),('14598','2013-02-05','12:20:00',3.26),('14598','2013-02-05','12:25:00',2.99),('14598','2013-02-05','12:30:00',2.76),('14598','2013-02-05','12:35:00',2.52),('14598','2013-02-05','12:40:00',2.1),('14598','2013-02-05','12:45:00',2.32),('14598','2013-02-05','12:50:00',2.25),('14598','2013-02-05','12:55:00',2.05),('14598','2013-02-05','13:00:00',1.8),('14598','2013-02-05','13:05:00',1.58),('14598','2013-02-05','13:10:00',1.62),('14598','2013-02-05','13:15:00',2),('14598','2013-02-05','13:20:00',2.05),('14598','2013-02-05','13:25:00',1.88),('14598','2013-02-05','13:30:00',1.58),('14598','2013-02-05','13:35:00',1.64),('14598','2013-02-05','13:40:00',1.76),('14598','2013-02-05','13:45:00',1.72),('14598','2013-02-05','13:50:00',1.71),('14598','2013-02-05','13:55:00',1.75),('14598','2013-02-05','14:00:00',1.82),('14598','2013-02-05','14:05:00',1.98),('14598','2013-02-05','14:10:00',2.07),('14598','2013-02-05','14:15:00',2.17),('14598','2013-02-05','14:20:00',2.46),('14598','2013-02-05','14:25:00',2.88),('14598','2013-02-05','14:30:00',3.43),('14598','2013-02-05','14:35:00',2.79),('14598','2013-02-05','14:40:00',1.48),('14598','2013-02-05','14:45:00',1.24),('14598','2013-02-05','14:50:00',1.19),('14598','2013-02-05','14:55:00',1.96),('14598','2013-02-05','15:00:00',1.21),('14598','2013-02-04','09:00:00',1.07),('14598','2013-02-04','09:05:00',1.18),('14598','2013-02-04','09:10:00',1.29),('14598','2013-02-04','09:15:00',1.44),('14598','2013-02-04','09:20:00',1.48),('14598','2013-02-04','09:25:00',1.55),('14598','2013-02-04','09:30:00',1.63),('14598','2013-02-04','09:35:00',1.6),('14598','2013-02-04','09:40:00',1.75),('14598','2013-02-04','09:45:00',1.27),('14598','2013-02-04','09:50:00',1.06),('14598','2013-02-04','09:55:00',1.91),('14598','2013-02-04','10:00:00',2.3),('14598','2013-02-04','10:05:00',2.35),('14598','2013-02-04','10:10:00',2.26),('14598','2013-02-04','10:15:00',2.42),('14598','2013-02-04','10:20:00',2.57),('14598','2013-02-04','10:25:00',2.65),('14598','2013-02-04','10:30:00',2.68),('14598','2013-02-04','10:35:00',2.83),('14598','2013-02-04','10:40:00',2.89),('14598','2013-02-04','10:45:00',2.9),('14598','2013-02-04','10:50:00',2.99),('14598','2013-02-04','10:55:00',3.05),('14598','2013-02-04','11:00:00',3.11),('14598','2013-02-04','11:05:00',3.17),('14598','2013-02-04','11:10:00',3.21),('14598','2013-02-04','11:15:00',3.26),('14598','2013-02-04','11:20:00',3.31),('14598','2013-02-04','11:25:00',3.34),('14598','2013-02-04','11:30:00',3.38),('14598','2013-02-04','11:35:00',3.43),('14598','2013-02-04','11:40:00',3.46),('14598','2013-02-04','11:45:00',3.49),('14598','2013-02-04','11:50:00',3.52),('14598','2013-02-04','11:55:00',3.55),('14598','2013-02-04','12:00:00',3.58),('14598','2013-02-04','12:05:00',3.61),('14598','2013-02-04','12:10:00',3.63),('14598','2013-02-04','12:15:00',3.64),('14598','2013-02-04','12:20:00',3.66),('14598','2013-02-04','12:25:00',3.67),('14598','2013-02-04','12:30:00',3.64),('14598','2013-02-04','12:35:00',3.67),('14598','2013-02-04','12:40:00',3.67),('14598','2013-02-04','12:45:00',3.66),('14598','2013-02-04','12:50:00',3.65),('14598','2013-02-04','12:55:00',3.65),('14598','2013-02-04','13:00:00',3.65),('14598','2013-02-04','13:05:00',3.64),('14598','2013-02-04','13:10:00',3.62),('14598','2013-02-04','13:15:00',3.62),('14598','2013-02-04','13:20:00',3.59),('14598','2013-02-04','13:25:00',3.6),('14598','2013-02-04','13:30:00',3.57),('14598','2013-02-04','13:35:00',3.55),('14598','2013-02-04','13:40:00',3.52),('14598','2013-02-04','13:45:00',3.44),('14598','2013-02-04','13:50:00',3.45),('14598','2013-02-04','13:55:00',3.4),('14598','2013-02-04','14:00:00',3.37),('14598','2013-02-04','14:05:00',3.35),('14598','2013-02-04','14:10:00',3.32),('14598','2013-02-04','14:15:00',3.28),('14598','2013-02-04','14:20:00',3.24),('14598','2013-02-04','14:25:00',3.21),('14598','2013-02-04','14:30:00',3.17),('14598','2013-02-04','14:35:00',3.12),('14598','2013-02-04','14:40:00',3.08),('14598','2013-02-04','14:45:00',3.03),('14598','2013-02-04','14:50:00',2.97),('14598','2013-02-04','14:55:00',2.9),('14598','2013-02-04','15:00:00',2.83),('14598','2013-02-04','15:05:00',2.78),('14598','2013-02-04','15:10:00',2.7),('14598','2013-02-04','15:15:00',2.63),('14598','2013-02-04','15:20:00',2.56),('14598','2013-02-04','15:25:00',2.48),('14598','2013-02-04','15:30:00',2.4),('14598','2013-02-04','15:35:00',2.33),('14598','2013-02-04','15:40:00',2.22),('14598','2013-02-04','15:45:00',2.13),('14598','2013-02-04','15:50:00',2.04),('14598','2013-02-04','15:55:00',1.94),('14598','2013-02-04','16:00:00',1.84),('14598','2013-02-04','16:05:00',1.74),('14598','2013-02-04','16:10:00',1.63),('14598','2013-02-04','16:15:00',1.53),('14598','2013-02-04','16:20:00',1.42),('14598','2013-02-04','16:25:00',1.31),('14598','2013-02-04','16:30:00',1.2),('14598','2013-02-04','16:35:00',1.08),('14598','2013-02-03','08:45:00',1.04),('14598','2013-02-03','08:50:00',1.52),('14598','2013-02-03','08:55:00',1.55),('14598','2013-02-03','09:00:00',1.33),('14598','2013-02-03','09:05:00',1.23),('14598','2013-02-03','09:55:00',1.1),('14598','2013-02-03','10:00:00',1.04),('14598','2013-02-03','10:10:00',2.62),('14598','2013-02-03','10:15:00',1.77),('14598','2013-02-03','10:20:00',1.42),('14598','2013-02-03','10:25:00',1.86),('14598','2013-02-03','10:30:00',2.22),('14598','2013-02-03','10:35:00',1.68),('14598','2013-02-03','10:45:00',1.04),('14598','2013-02-03','10:50:00',1.51),('14598','2013-02-03','11:15:00',1.06),('14598','2013-02-03','11:20:00',1.96),('14598','2013-02-03','11:25:00',2.4),('14598','2013-02-03','11:30:00',1.41),('14598','2013-02-03','11:35:00',1.05),('14598','2013-02-03','11:40:00',1.7),('14598','2013-02-03','11:45:00',1.85),('14598','2013-02-03','13:10:00',1.11),('14598','2013-02-03','13:15:00',1.1),('14598','2013-02-03','14:05:00',1.13),('14598','2013-02-03','14:15:00',1.04),('14598','2013-02-03','14:20:00',1.19),('14598','2013-02-03','14:25:00',1.29),('14598','2013-02-03','14:30:00',1.06),('14598','2013-02-03','14:40:00',1.02),('14598','2013-02-02','09:35:00',1.02),('14598','2013-02-02','10:00:00',1.67),('14598','2013-02-02','10:05:00',1.83),('14598','2013-02-02','10:10:00',2.1),('14598','2013-02-02','10:15:00',1.94),('14598','2013-02-02','10:20:00',1.56),('14598','2013-02-02','10:25:00',1.43),('14598','2013-02-02','10:30:00',1.73),('14598','2013-02-02','10:35:00',2.12),('14598','2013-02-02','10:40:00',2.06),('14598','2013-02-02','10:45:00',1.89),('14598','2013-02-02','10:50:00',1.94),('14598','2013-02-02','10:55:00',1.99),('14598','2013-02-02','11:00:00',2.2),('14598','2013-02-02','11:05:00',2.1),('14598','2013-02-02','11:10:00',2.1),('14598','2013-02-02','11:15:00',1.9),('14598','2013-02-02','11:20:00',1.69),('14598','2013-02-02','11:25:00',1.57),('14598','2013-02-02','11:30:00',1.13),('14598','2013-02-02','12:25:00',1.62),('14598','2013-02-02','12:30:00',2.38),('14598','2013-02-02','12:35:00',2.03),('14598','2013-02-02','12:40:00',1.28),('14598','2013-02-02','12:55:00',1.23),('14598','2013-02-02','13:00:00',1.19),('14598','2013-02-02','14:50:00',1.06),('14598','2013-02-02','14:55:00',1.18),('14598','2013-02-01','09:10:00',1.08),('14598','2013-02-01','09:15:00',1.8),('14598','2013-02-01','09:20:00',1.68),('14598','2013-02-01','09:25:00',1.49),('14598','2013-02-01','09:30:00',1.3),('14598','2013-02-01','09:35:00',1.52),('14598','2013-02-01','09:40:00',1.16),('14598','2013-02-01','09:45:00',1.4),('14598','2013-02-01','09:50:00',1.46),('14598','2013-02-01','09:55:00',2.26),('14598','2013-02-01','10:00:00',1.26),('14598','2013-02-01','10:05:00',1.77),('14598','2013-02-01','10:10:00',2.37),('14598','2013-02-01','10:15:00',2.03),('14598','2013-02-01','10:45:00',1.14),('14598','2013-02-01','10:50:00',3.6),('14598','2013-02-01','10:55:00',3.28),('14598','2013-02-01','11:00:00',2.92),('14598','2013-02-01','11:05:00',2.92),('14598','2013-02-01','11:10:00',2.93),('14598','2013-02-01','11:15:00',2.95),('14598','2013-02-01','11:20:00',3.01),('14598','2013-02-01','11:25:00',3.01),('14598','2013-02-01','11:30:00',3.09),('14598','2013-02-01','11:35:00',3.13),('14598','2013-02-01','11:40:00',3.19),('14598','2013-02-01','11:45:00',3.22),('14598','2013-02-01','11:50:00',3.25),('14598','2013-02-01','11:55:00',3.21),('14598','2013-02-01','12:00:00',3.36),('14598','2013-02-01','12:05:00',3.39),('14598','2013-02-01','12:10:00',3.4),('14598','2013-02-01','12:15:00',3.53),('14598','2013-02-01','12:20:00',3.49),('14598','2013-02-01','12:25:00',3.33),('14598','2013-02-01','12:30:00',3.38),('14598','2013-02-01','12:35:00',3.42),('14598','2013-02-01','12:40:00',3.36),('14598','2013-02-01','12:45:00',3.34),('14598','2013-02-01','12:50:00',3.35),('14598','2013-02-01','12:55:00',3.36),('14598','2013-02-01','13:00:00',3.39),('14598','2013-02-01','13:05:00',3.34),('14598','2013-02-01','13:10:00',3.14),('14598','2013-02-01','13:15:00',3.11),('14598','2013-02-01','13:20:00',3.37),('14598','2013-02-01','13:25:00',3.35),('14598','2013-02-01','13:30:00',3.21),('14598','2013-02-01','13:35:00',3.34),('14598','2013-02-01','13:40:00',3.16),('14598','2013-02-01','13:45:00',2.76),('14598','2013-02-01','13:50:00',3.03),('14598','2013-02-01','13:55:00',3.21),('14598','2013-02-01','14:00:00',3.1),('14598','2013-02-01','14:05:00',3.17),('14598','2013-02-01','14:10:00',3.11),('14598','2013-02-01','14:15:00',3.03),('14598','2013-02-01','14:20:00',3.02),('14598','2013-02-01','14:25:00',2.97),('14598','2013-02-01','14:30:00',2.93),('14598','2013-02-01','14:35:00',2.9),('14598','2013-02-01','14:40:00',2.71),('14598','2013-02-01','14:45:00',2.67),('14598','2013-02-01','14:50:00',2.61),('14598','2013-02-01','14:55:00',2.58),('14598','2013-02-01','15:00:00',2.54),('14598','2013-02-01','15:05:00',2.48),('14598','2013-02-01','15:10:00',2.39),('14598','2013-02-01','15:15:00',2.24),('14598','2013-02-01','15:20:00',2.39),('14598','2013-02-01','15:25:00',1.69),('14598','2013-02-01','15:40:00',1.3),('14598','2013-02-01','15:45:00',2.18),('14598','2013-02-01','15:50:00',1.48),('14598','2014-03-21','08:00:00',1.07),('14598','2014-03-21','08:05:00',1.17),('14598','2014-03-21','08:10:00',1.28),('14598','2014-03-21','08:15:00',1.36),('14598','2014-03-21','08:20:00',1.47),('14598','2014-03-21','08:25:00',1.58),('14598','2014-03-21','08:30:00',1.73),('14598','2014-03-21','08:35:00',1.83),('14598','2014-03-21','08:40:00',1.93),('14598','2014-03-21','08:45:00',2.01),('14598','2014-03-21','08:50:00',2.07),('14598','2014-03-21','08:55:00',2.16),('14598','2014-03-21','09:00:00',2.24),('14598','2014-03-21','09:05:00',2.33),('14598','2014-03-21','09:10:00',2.43),('14598','2014-03-21','09:15:00',2.55),('14598','2014-03-21','09:20:00',2.61),('14598','2014-03-21','09:25:00',2.58),('14598','2014-03-21','09:30:00',2.74),('14598','2014-03-21','09:35:00',2.76),('14598','2014-03-21','09:40:00',2.81),('14598','2014-03-21','09:45:00',2.94),('14598','2014-03-21','09:50:00',3),('14598','2014-03-21','09:55:00',3.05),('14598','2014-03-21','10:00:00',3.14),('14598','2014-03-21','10:05:00',3.19),('14598','2014-03-21','10:10:00',3.32),('14598','2014-03-21','10:15:00',3.42),('14598','2014-03-21','10:20:00',3.51),('14598','2014-03-21','10:25:00',3.58),('14598','2014-03-21','10:30:00',3.5),('14598','2014-03-21','10:35:00',3.51),('14598','2014-03-21','10:40:00',3.88),('14598','2014-03-21','10:45:00',3.93),('14598','2014-03-21','10:50:00',4),('14598','2014-03-21','10:55:00',4.03),('14598','2014-03-21','11:00:00',4.07),('14598','2014-03-21','11:05:00',4.11),('14598','2014-03-21','11:10:00',4.15),('14598','2014-03-21','11:15:00',4.19),('14598','2014-03-21','11:20:00',4.21),('14598','2014-03-21','11:25:00',4.26),('14598','2014-03-21','11:30:00',4.27),('14598','2014-03-21','11:35:00',4.3),('14598','2014-03-21','11:40:00',4.35),('14598','2014-03-21','11:45:00',4.38),('14598','2014-03-21','11:50:00',4.42),('14598','2014-03-21','11:55:00',4.44),('14598','2014-03-21','12:00:00',4.47),('14598','2014-03-21','12:05:00',4.5),('14598','2014-03-21','12:10:00',4.52),('14598','2014-03-21','12:15:00',4.5),('14598','2014-03-21','12:20:00',4.52),('14598','2014-03-21','12:25:00',4.51),('14598','2014-03-21','12:30:00',4.55),('14598','2014-03-21','12:35:00',4.55),('14598','2014-03-21','12:40:00',4.56),('14598','2014-03-21','12:45:00',4.54),('14598','2014-03-21','12:50:00',4.54),('14598','2014-03-21','12:55:00',4.53),('14598','2014-03-21','13:00:00',4.55),('14598','2014-03-21','13:05:00',4.52),('14598','2014-03-21','13:10:00',4.54),('14598','2014-03-21','13:15:00',4.54),('14598','2014-03-21','13:20:00',4.51),('14598','2014-03-21','13:25:00',4.51),('14598','2014-03-21','13:30:00',4.52),('14598','2014-03-21','13:35:00',4.52),('14598','2014-03-21','13:40:00',4.5),('14598','2014-03-21','13:45:00',4.47),('14598','2014-03-21','13:50:00',4.43),('14598','2014-03-21','13:55:00',4.37),('14598','2014-03-21','14:00:00',3.83),('14598','2014-03-21','14:05:00',3.68),('14598','2014-03-21','14:10:00',1.88),('14598','2014-03-21','14:15:00',1.09),('14598','2014-03-21','14:20:00',1.38),('14598','2014-03-21','14:25:00',2.11),('14598','2014-03-21','14:30:00',1.54),('14598','2014-03-21','14:35:00',3.08),('14598','2014-03-21','14:40:00',3.05),('14598','2014-03-21','14:45:00',4.31),('14598','2014-03-21','14:50:00',4.34),('14598','2014-03-21','14:55:00',4.15),('14598','2014-03-21','15:00:00',3.72),('14598','2014-03-21','15:05:00',2.2),('14598','2014-03-21','15:10:00',2.94),('14598','2014-03-21','15:15:00',3.87),('14598','2014-03-21','15:20:00',3.71),('14598','2014-03-21','15:25:00',3.59),('14598','2014-03-21','15:30:00',3.45),('14598','2014-03-21','15:35:00',3.31),('14598','2014-03-21','15:40:00',2.57),('14598','2014-03-21','15:45:00',2.72),('14598','2014-03-21','15:50:00',3.02),('14598','2014-03-21','15:55:00',3),('14598','2014-03-21','16:00:00',2.84),('14598','2014-03-21','16:05:00',2.7),('14598','2014-03-21','16:10:00',2.62),('14598','2014-03-21','16:15:00',2.52),('14598','2014-03-21','16:20:00',2.41),('14598','2014-03-21','16:25:00',2.28),('14598','2014-03-21','16:30:00',2.16),('14598','2014-03-21','16:35:00',1.99),('14598','2014-03-21','16:40:00',1.84),('14598','2014-03-21','16:45:00',1.64),('14598','2014-03-21','16:50:00',1.58),('14598','2014-03-21','16:55:00',1.45),('14598','2014-03-21','17:00:00',1.39),('14598','2014-03-21','17:05:00',1.28),('14598','2014-03-21','17:10:00',1.15),('14598','2014-03-21','17:15:00',1.06),('14598','2013-01-31','09:30:00',1.07),('14598','2013-01-31','09:35:00',1.57),('14598','2013-01-31','09:40:00',1.62),('14598','2013-01-31','09:45:00',1.72),('14598','2013-01-31','09:50:00',1.8),('14598','2013-01-31','09:55:00',1.88),('14598','2013-01-31','10:00:00',1.97),('14598','2013-01-31','10:05:00',2.04),('14598','2013-01-31','10:10:00',2.11),('14598','2013-01-31','10:15:00',2.2),('14598','2013-01-31','10:20:00',2.25),('14598','2013-01-31','10:25:00',2.36),('14598','2013-01-31','10:30:00',2.43),('14598','2013-01-31','10:35:00',2.49),('14598','2013-01-31','10:40:00',2.6),('14598','2013-01-31','10:45:00',2.53),('14598','2013-01-31','10:50:00',1.58),('14598','2013-01-31','10:55:00',2.78),('14598','2013-01-31','11:00:00',2.89),('14598','2013-01-31','11:05:00',2.42),('14598','2013-01-31','11:10:00',2.96),('14598','2013-01-31','11:15:00',3.3),('14598','2013-01-31','11:20:00',3.3),('14598','2013-01-31','11:25:00',3.28),('14598','2013-01-31','11:30:00',2.89),('14598','2013-01-31','11:35:00',3.11),('14598','2013-01-31','11:40:00',3.2),('14598','2013-01-31','11:45:00',3.3),('14598','2013-01-31','11:50:00',3.46),('14598','2013-01-31','11:55:00',2.05),('14598','2013-01-31','12:00:00',3.53),('14598','2013-01-31','12:05:00',1.53),('14598','2013-01-31','12:10:00',1.52),('14598','2013-01-31','12:15:00',1.66),('14598','2013-01-31','12:20:00',1.14),('14598','2013-01-31','12:25:00',1.44),('14598','2013-01-31','12:35:00',2.13),('14598','2013-01-31','12:40:00',2.29),('14598','2013-01-31','12:45:00',2.26),('14598','2013-01-31','12:50:00',3.25),('14598','2013-01-31','12:55:00',3.38),('14598','2013-01-31','13:00:00',3.38),('14598','2013-01-31','13:05:00',3.38),('14598','2013-01-31','13:10:00',3.34),('14598','2013-01-31','13:15:00',3.3),('14598','2013-01-31','13:20:00',3.27),('14598','2013-01-31','13:25:00',3.28),('14598','2013-01-31','13:30:00',3.3),('14598','2013-01-31','13:35:00',3.31),('14598','2013-01-31','13:40:00',3.31),('14598','2013-01-31','13:45:00',3.28),('14598','2013-01-31','13:50:00',3.23),('14598','2013-01-31','13:55:00',3.2),('14598','2013-01-31','14:00:00',3.16),('14598','2013-01-31','14:05:00',3.07),('14598','2013-01-31','14:10:00',3.01),('14598','2013-01-31','14:15:00',3.01),('14598','2013-01-31','14:20:00',2.98),('14598','2013-01-31','14:25:00',2.94),('14598','2013-01-31','14:30:00',2.88),('14598','2013-01-31','14:35:00',2.8),('14598','2013-01-31','14:40:00',2.77),('14598','2013-01-31','14:45:00',2.71),('14598','2013-01-31','14:50:00',2.51),('14598','2013-01-31','14:55:00',2.61),('14598','2013-01-31','15:00:00',2.46),('14598','2013-01-31','15:05:00',2.47),('14598','2013-01-31','15:10:00',2.41),('14598','2013-01-31','15:15:00',2.32),('14598','2013-01-31','15:20:00',2.19),('14598','2013-01-31','15:25:00',2.2),('14598','2013-01-31','15:30:00',2.11),('14598','2013-01-31','15:35:00',1.89),('14598','2013-01-31','15:40:00',1.55),('14598','2013-01-31','15:45:00',1.31),('14598','2013-01-31','15:50:00',1.52),('14598','2013-01-31','15:55:00',1.68),('14598','2013-01-31','16:00:00',1.31),('14598','2013-01-31','16:05:00',1.07),('14598','2013-01-31','16:10:00',1.29),('14598','2013-01-31','16:15:00',1.33),('14598','2013-01-31','16:20:00',1.18),('14598','2013-01-31','16:25:00',1.07),('14598','2013-01-30','09:05:00',1.03),('14598','2013-01-30','09:10:00',1.21),('14598','2013-01-30','09:15:00',1.79),('14598','2013-01-30','09:20:00',1.82),('14598','2013-01-30','09:25:00',1.18),('14598','2013-01-30','09:30:00',1.09),('14598','2013-01-30','09:35:00',1.21),('14598','2013-01-30','09:40:00',1.13),('14598','2013-01-30','09:45:00',1.13),('14598','2013-01-30','09:50:00',1.17),('14598','2013-01-30','09:55:00',1.11),('14598','2013-01-30','10:00:00',1.17),('14598','2013-01-30','10:05:00',1.28),('14598','2013-01-30','10:10:00',1.23),('14598','2013-01-30','10:15:00',2.17),('14598','2013-01-30','10:20:00',2.35),('14598','2013-01-30','10:25:00',2.35),('14598','2013-01-30','10:30:00',2.29),('14598','2013-01-30','10:35:00',1.99),('14598','2013-01-30','10:40:00',2.52),('14598','2013-01-30','10:45:00',2.59),('14598','2013-01-30','10:50:00',2.61),('14598','2013-01-30','10:55:00',2.68),('14598','2013-01-30','11:00:00',2.72),('14598','2013-01-30','11:05:00',2.74),('14598','2013-01-30','11:10:00',2.84),('14598','2013-01-30','11:15:00',2.92),('14598','2013-01-30','11:20:00',2.9),('14598','2013-01-30','11:25:00',2.89),('14598','2013-01-30','11:30:00',3.01),('14598','2013-01-30','11:35:00',3.03),('14598','2013-01-30','11:40:00',3.01),('14598','2013-01-30','11:45:00',3.01),('14598','2013-01-30','11:50:00',3.15),('14598','2013-01-30','11:55:00',3.07),('14598','2013-01-30','12:00:00',2.67),('14598','2013-01-30','12:05:00',2.07),('14598','2013-01-30','12:10:00',1.89),('14598','2013-01-30','12:15:00',1.82),('14598','2013-01-30','12:20:00',1.89),('14598','2013-01-30','12:25:00',2.06),('14598','2013-01-30','12:30:00',2.04),('14598','2013-01-30','12:35:00',1.84),('14598','2013-01-30','12:40:00',1.61),('14598','2013-01-30','12:45:00',1.49),('14598','2013-01-30','12:50:00',1.66),('14598','2013-01-30','12:55:00',2.55),('14598','2013-01-30','13:00:00',2.14),('14598','2013-01-30','13:05:00',2.8),('14598','2013-01-30','13:10:00',3.31),('14598','2013-01-30','13:15:00',1.76),('14598','2013-01-30','13:20:00',2.85),('14598','2013-01-30','13:25:00',1.85),('14598','2013-01-30','13:30:00',2.5),('14598','2013-01-30','13:35:00',3.7),('14598','2013-01-30','13:40:00',3.35),('14598','2013-01-30','13:45:00',3.1),('14598','2013-01-30','13:50:00',3.06),('14598','2013-01-30','13:55:00',2.81),('14598','2013-01-30','14:00:00',2.45),('14598','2013-01-30','14:05:00',2.53),('14598','2013-01-30','14:10:00',2.8),('14598','2013-01-30','14:15:00',2.62),('14598','2013-01-30','14:20:00',2.44),('14598','2013-01-30','14:25:00',1.78),('14598','2013-01-30','14:30:00',1.4),('14598','2013-01-30','14:35:00',1.87),('14598','2013-01-30','14:40:00',1.6),('14598','2013-01-30','14:45:00',1.57),('14598','2013-01-30','14:50:00',1.48),('14598','2013-01-30','14:55:00',1.52),('14598','2013-01-30','15:00:00',1.47),('14598','2013-01-30','15:05:00',1.38),('14598','2013-01-30','15:10:00',1.24),('14598','2013-01-30','15:15:00',1.09),('14598','2013-01-30','15:20:00',1.01),('14598','2013-01-30','16:10:00',1.38),('14598','2013-01-29','09:05:00',1.01),('14598','2013-01-29','09:10:00',1.11),('14598','2013-01-29','09:15:00',1.21),('14598','2013-01-29','09:20:00',1.3),('14598','2013-01-29','09:25:00',1.39),('14598','2013-01-29','09:30:00',1.49),('14598','2013-01-29','09:35:00',1.58),('14598','2013-01-29','09:40:00',1.68),('14598','2013-01-29','09:45:00',1.76),('14598','2013-01-29','09:50:00',1.85),('14598','2013-01-29','09:55:00',1.92),('14598','2013-01-29','10:00:00',2.01),('14598','2013-01-29','10:05:00',2.07),('14598','2013-01-29','10:10:00',2.15),('14598','2013-01-29','10:15:00',2.25),('14598','2013-01-29','10:20:00',2.33),('14598','2013-01-29','10:25:00',2.42),('14598','2013-01-29','10:30:00',2.48),('14598','2013-01-29','10:35:00',2.56),('14598','2013-01-29','10:40:00',2.61),('14598','2013-01-29','10:45:00',2.69),('14598','2013-01-29','10:50:00',2.76),('14598','2013-01-29','10:55:00',2.76),('14598','2013-01-29','11:00:00',2.84),('14598','2013-01-29','11:05:00',2.94),('14598','2013-01-29','11:10:00',2.96),('14598','2013-01-29','11:15:00',3.04),('14598','2013-01-29','11:20:00',3.16),('14598','2013-01-29','11:25:00',3.15),('14598','2013-01-29','11:30:00',3.21),('14598','2013-01-29','11:35:00',3.06),('14598','2013-01-29','11:40:00',3.05),('14598','2013-01-29','11:45:00',3.15),('14598','2013-01-29','11:50:00',3.01),('14598','2013-01-29','11:55:00',3.38),('14598','2013-01-29','12:00:00',3.23),('14598','2013-01-29','12:05:00',3.34),('14598','2013-01-29','12:10:00',3.45),('14598','2013-01-29','12:15:00',3.4),('14598','2013-01-29','12:20:00',3.43),('14598','2013-01-29','12:25:00',3.46),('14598','2013-01-29','12:30:00',3.48),('14598','2013-01-29','12:35:00',3.5),('14598','2013-01-29','12:40:00',3.42),('14598','2013-01-29','12:45:00',3.3),('14598','2013-01-29','12:50:00',3.33),('14598','2013-01-29','12:55:00',3.41),('14598','2013-01-29','13:00:00',3.43),('14598','2013-01-29','13:05:00',3.39),('14598','2013-01-29','13:10:00',3.39),('14598','2013-01-29','13:15:00',3.37),('14598','2013-01-29','13:20:00',3.36),('14598','2013-01-29','13:25:00',3.34),('14598','2013-01-29','13:30:00',3.32),('14598','2013-01-29','13:35:00',3.34),('14598','2013-01-29','13:40:00',3.36),('14598','2013-01-29','13:45:00',3.62),('14598','2013-01-29','13:50:00',3.5),('14598','2013-01-29','13:55:00',3.33),('14598','2013-01-29','14:00:00',3.26),('14598','2013-01-29','14:05:00',3.22),('14598','2013-01-29','14:10:00',3.19),('14598','2013-01-29','14:15:00',3.14),('14598','2013-01-29','14:20:00',3.08),('14598','2013-01-29','14:25:00',2.97),('14598','2013-01-29','14:30:00',2.98),('14598','2013-01-29','14:35:00',2.92),('14598','2013-01-29','14:40:00',2.87),('14598','2013-01-29','14:45:00',2.82),('14598','2013-01-29','14:50:00',2.74),('14598','2013-01-29','14:55:00',2.69),('14598','2013-01-29','15:00:00',2.62),('14598','2013-01-29','15:05:00',2.56),('14598','2013-01-29','15:10:00',2.48),('14598','2013-01-29','15:15:00',2.41),('14598','2013-01-29','15:20:00',2.34),('14598','2013-01-29','15:25:00',2.26),('14598','2013-01-29','15:30:00',2.17),('14598','2013-01-29','15:35:00',2.08),('14598','2013-01-29','15:40:00',1.99),('14598','2013-01-29','15:45:00',1.9),('14598','2013-01-29','15:50:00',1.79),('14598','2013-01-29','15:55:00',1.71),('14598','2013-01-29','16:00:00',1.24),('14598','2013-01-29','16:05:00',1.51),('14598','2013-01-29','16:10:00',1.4),('14598','2013-01-29','16:15:00',1.3),('14598','2013-01-29','16:20:00',1.2),('14598','2013-01-29','16:25:00',1.1),('14598','2013-01-28','10:45:00',1),('14598','2013-01-28','12:10:00',1.19),('14598','2013-01-28','12:15:00',1.18),('14598','2013-01-28','12:20:00',1.18),('14598','2013-01-28','12:25:00',1.18),('14598','2013-01-28','12:30:00',1.18),('14598','2013-01-28','12:35:00',1.12),('14598','2013-01-28','12:40:00',1.16),('14598','2013-01-28','12:45:00',1.47),('14598','2013-01-28','12:50:00',1.38),('14598','2013-01-28','12:55:00',1.16),('14598','2013-01-28','13:00:00',1.09),('14598','2013-01-28','13:05:00',1.07),('14598','2013-01-28','13:10:00',1.18),('14598','2013-01-28','13:15:00',1.35),('14598','2013-01-28','13:20:00',1.35),('14598','2013-01-28','13:25:00',1.12),('14598','2013-01-28','13:35:00',1),('14598','2013-01-27','09:05:00',1.05),('14598','2013-01-27','09:10:00',1.17),('14598','2013-01-27','09:15:00',1.36),('14598','2013-01-27','09:30:00',1.31),('14598','2013-01-27','09:35:00',1.55),('14598','2013-01-27','09:40:00',1.63),('14598','2013-01-27','09:45:00',1.72),('14598','2013-01-27','09:50:00',1.81),('14598','2013-01-27','09:55:00',1.9),('14598','2013-01-27','10:00:00',1.98),('14598','2013-01-27','10:05:00',2.05),('14598','2013-01-27','10:10:00',2.12),('14598','2013-01-27','10:15:00',2.21),('14598','2013-01-27','10:20:00',2.29),('14598','2013-01-27','10:25:00',2.35),('14598','2013-01-27','10:30:00',2.4),('14598','2013-01-27','10:35:00',2.43),('14598','2013-01-27','10:40:00',2.56),('14598','2013-01-27','10:45:00',2.61),('14598','2013-01-27','10:50:00',2.68),('14598','2013-01-27','10:55:00',2.75),('14598','2013-01-27','11:00:00',2.81),('14598','2013-01-27','11:05:00',2.86),('14598','2013-01-27','11:10:00',2.88),('14598','2013-01-27','11:15:00',2.93),('14598','2013-01-27','11:20:00',2.97),('14598','2013-01-27','11:25:00',3.01),('14598','2013-01-27','11:30:00',3.06),('14598','2013-01-27','11:35:00',3.09),('14598','2013-01-27','11:40:00',3.12),('14598','2013-01-27','11:45:00',3.18),('14598','2013-01-27','11:50:00',3.13),('14598','2013-01-27','11:55:00',3.21),('14598','2013-01-27','12:00:00',3.27),('14598','2013-01-27','12:05:00',3.27),('14598','2013-01-27','12:10:00',3.28),('14598','2013-01-27','12:15:00',3.32),('14598','2013-01-27','12:20:00',3.34),('14598','2013-01-27','12:25:00',3.33),('14598','2013-01-27','12:30:00',3.33),('14598','2013-01-27','12:35:00',3.34),('14598','2013-01-27','12:40:00',3.36),('14598','2013-01-27','12:45:00',3.36),('14598','2013-01-27','12:50:00',3.37),('14598','2013-01-27','12:55:00',3.35),('14598','2013-01-27','13:00:00',3.31),('14598','2013-01-27','13:05:00',3.3),('14598','2013-01-27','13:10:00',3.32),('14598','2013-01-27','13:15:00',3.33),('14598','2013-01-27','13:20:00',3.3),('14598','2013-01-27','13:25:00',3.28),('14598','2013-01-27','13:30:00',3.26),('14598','2013-01-27','13:35:00',3.13),('14598','2013-01-27','13:40:00',3.19),('14598','2013-01-27','13:45:00',3.13),('14598','2013-01-27','13:50:00',3.08),('14598','2013-01-27','13:55:00',3.07),('14598','2013-01-27','14:00:00',3.03),('14598','2013-01-27','14:05:00',2.99),('14598','2013-01-27','14:10:00',2.95),('14598','2013-01-27','14:15:00',2.93),('14598','2013-01-27','14:20:00',2.9),('14598','2013-01-27','14:25:00',2.84),('14598','2013-01-27','14:30:00',2.8),('14598','2013-01-27','14:35:00',2.74),('14598','2013-01-27','14:40:00',2.71),('14598','2013-01-27','14:45:00',2.65),('14598','2013-01-27','14:50:00',2.36),('14598','2013-01-27','14:55:00',2.49),('14598','2013-01-27','15:00:00',2.34),('14598','2013-01-27','15:05:00',2.4),('14598','2013-01-27','15:10:00',2.3),('14598','2013-01-27','15:15:00',2.22),('14598','2013-01-27','15:20:00',2.14),('14598','2013-01-27','15:25:00',2.06),('14598','2013-01-27','15:30:00',1.99),('14598','2013-01-27','15:35:00',1.9),('14598','2013-01-27','15:40:00',1.82),('14598','2013-01-27','15:45:00',1.71),('14598','2013-01-27','15:50:00',1.6),('14598','2013-01-27','15:55:00',1.5),('14598','2013-01-27','16:00:00',1.4),('14598','2013-01-27','16:05:00',1.3),('14598','2013-01-27','16:10:00',1.21),('14598','2013-01-27','16:15:00',1.1),('14598','2013-01-26','10:30:00',1.01),('14598','2013-01-26','10:35:00',1.21),('14598','2013-01-26','10:40:00',1.28),('14598','2013-01-26','10:45:00',1.2),('14598','2013-01-26','10:50:00',1.26),('14598','2013-01-26','10:55:00',1.37),('14598','2013-01-26','11:00:00',1.36),('14598','2013-01-26','11:05:00',1.35),('14598','2013-01-26','11:10:00',1.12),('14598','2013-01-26','11:15:00',1.11),('14598','2013-01-26','11:20:00',1.11),('14598','2013-01-26','11:55:00',1.03),('14598','2013-01-26','12:00:00',1.14),('14598','2013-01-26','12:05:00',1.07),('14598','2013-01-26','12:10:00',1.08),('14598','2013-01-26','12:15:00',1.13),('14598','2013-01-26','12:20:00',1.02),('14598','2013-01-26','12:45:00',1.04),('14598','2013-01-26','13:15:00',1.08),('14598','2013-01-26','13:20:00',1.12),('14598','2013-01-26','13:25:00',1.23),('14598','2013-01-26','13:30:00',1.35),('14598','2013-01-26','13:35:00',1.15),('14598','2013-01-26','13:40:00',1.15),('14598','2013-01-26','13:45:00',1.13),('14598','2013-01-26','13:50:00',1.2),('14598','2013-01-26','13:55:00',1.3),('14598','2013-01-26','14:00:00',1.39),('14598','2013-01-26','14:05:00',1.26),('14598','2013-01-26','14:10:00',1.08),('14598','2013-01-25','09:00:00',1.02),('14598','2013-01-25','09:05:00',1.07),('14598','2013-01-25','09:10:00',1.05),('14598','2013-01-25','09:20:00',1.04),('14598','2013-01-25','09:25:00',1.29),('14598','2013-01-25','09:30:00',1.67),('14598','2013-01-25','09:35:00',1.76),('14598','2013-01-25','09:40:00',1.53),('14598','2013-01-25','09:45:00',1.48),('14598','2013-01-25','09:50:00',2.07),('14598','2013-01-25','09:55:00',2.29),('14598','2013-01-25','10:00:00',2.31),('14598','2013-01-25','10:05:00',1.74),('14598','2013-01-25','10:10:00',1.49),('14598','2013-01-25','10:15:00',2.42),('14598','2013-01-25','10:20:00',2.45),('14598','2013-01-25','10:25:00',2.51),('14598','2013-01-25','10:30:00',2.27),('14598','2013-01-25','10:35:00',2.26),('14598','2013-01-25','10:40:00',2.42),('14598','2013-01-25','10:45:00',2.74),('14598','2013-01-25','10:50:00',2.92),('14598','2013-01-25','10:55:00',2.97),('14598','2013-01-25','11:00:00',3.03),('14598','2013-01-25','11:05:00',3.11),('14598','2013-01-25','11:10:00',3.16),('14598','2013-01-25','11:15:00',3.17),('14598','2013-01-25','11:20:00',3.18),('14598','2013-01-25','11:25:00',3.19),('14598','2013-01-25','11:30:00',3.17),('14598','2013-01-25','11:35:00',3.13),('14598','2013-01-25','11:40:00',3.22),('14598','2013-01-25','11:45:00',3.24),('14598','2013-01-25','11:50:00',3.21),('14598','2013-01-25','11:55:00',3.22),('14598','2013-01-25','12:00:00',3.26),('14598','2013-01-25','12:05:00',3.37),('14598','2013-01-25','12:10:00',3.38),('14598','2013-01-25','12:15:00',3.41),('14598','2013-01-25','12:20:00',3.42),('14598','2013-01-25','12:25:00',3.41),('14598','2013-01-25','12:30:00',3.4),('14598','2013-01-25','12:35:00',3.35),('14598','2013-01-25','12:40:00',3.28),('14598','2013-01-25','12:45:00',3.28),('14598','2013-01-25','12:50:00',3.29),('14598','2013-01-25','12:55:00',3.33),('14598','2013-01-25','13:00:00',3.34),('14598','2013-01-25','13:05:00',3.05),('14598','2013-01-25','13:10:00',2.86),('14598','2013-01-25','13:15:00',3.22),('14598','2013-01-25','13:20:00',3.36),('14598','2013-01-25','13:25:00',3.32),('14598','2013-01-25','13:30:00',3.28),('14598','2013-01-25','13:35:00',3.29),('14598','2013-01-25','13:40:00',3.32),('14598','2013-01-25','13:45:00',3.28),('14598','2013-01-25','13:50:00',3.25),('14598','2013-01-25','13:55:00',3.13),('14598','2013-01-25','14:00:00',2.97),('14598','2013-01-25','14:05:00',2.94),('14598','2013-01-25','14:10:00',2.85),('14598','2013-01-25','14:15:00',2.75),('14598','2013-01-25','14:20:00',2.63),('14598','2013-01-25','14:25:00',2.64),('14598','2013-01-25','14:30:00',2.58),('14598','2013-01-25','14:35:00',2.61),('14598','2013-01-25','14:40:00',2.57),('14598','2013-01-25','14:45:00',2.5),('14598','2013-01-25','14:50:00',2.49),('14598','2013-01-25','14:55:00',2.4),('14598','2013-01-25','15:00:00',2.38),('14598','2013-01-25','15:05:00',2.34),('14598','2013-01-25','15:10:00',1.92),('14598','2013-01-25','15:15:00',2.06),('14598','2013-01-24','09:15:00',1.04),('14598','2013-01-24','09:20:00',1.27),('14598','2013-01-24','09:25:00',1.4),('14598','2013-01-24','09:30:00',1.25),('14598','2013-01-24','09:50:00',1.51),('14598','2013-01-24','09:55:00',1.72),('14598','2013-01-24','10:00:00',1.99),('14598','2013-01-24','10:05:00',2.26),('14598','2013-01-24','10:10:00',2.3),('14598','2013-01-24','10:15:00',2.32),('14598','2013-01-24','10:20:00',2.34),('14598','2013-01-24','10:25:00',2.41),('14598','2013-01-24','10:30:00',1.34),('14598','2013-01-24','10:35:00',1.56),('14598','2013-01-24','10:40:00',1.48),('14598','2013-01-24','11:40:00',1.01),('14598','2013-01-24','11:45:00',1.02),('14598','2013-01-24','11:50:00',1.67),('14598','2013-01-24','11:55:00',2.76),('14598','2013-01-24','12:00:00',2.19),('14598','2013-01-24','12:05:00',1.41),('14598','2013-01-24','12:10:00',1.42),('14598','2013-01-24','12:15:00',1.71),('14598','2013-01-24','12:20:00',1.5),('14598','2013-01-24','12:25:00',1.42),('14598','2013-01-24','12:30:00',1.18),('14598','2013-01-24','13:20:00',1.03),('14598','2013-01-24','13:25:00',1.13),('14598','2013-01-24','13:30:00',1.26),('14598','2013-01-24','13:35:00',1.4),('14598','2013-01-24','13:40:00',1.71),('14598','2013-01-24','13:45:00',2.88),('14598','2013-01-24','13:50:00',2.9),('14598','2013-01-24','13:55:00',3.72),('14598','2013-01-24','14:00:00',3.39),('14598','2013-01-24','14:05:00',2.17),('14598','2013-01-24','14:10:00',1.38),('14598','2013-01-24','14:15:00',3.06),('14598','2013-01-24','14:20:00',3.37),('14598','2013-01-24','14:25:00',3.05),('14598','2013-01-24','14:30:00',3.07),('14598','2013-01-24','14:35:00',3.32),('14598','2013-01-24','14:40:00',2.59),('14598','2013-01-24','14:45:00',1.88),('14598','2013-01-24','14:50:00',1.77),('14598','2013-01-24','15:10:00',1.55),('14598','2013-01-24','15:15:00',2.57),('14598','2013-01-24','15:20:00',2.67),('14598','2013-01-24','15:25:00',2.52),('14598','2013-01-24','15:30:00',2.31),('14598','2013-01-24','15:35:00',2.12),('14598','2013-01-24','15:40:00',1.59),('14598','2013-01-24','15:45:00',1.48),('14598','2013-01-24','15:55:00',1.05),('14598','2013-01-24','16:00:00',1.43),('14598','2013-01-24','16:05:00',1.33),('14598','2013-01-24','16:10:00',1.24),('14598','2013-01-23','09:20:00',1.08),('14598','2013-01-23','09:25:00',1.37),('14598','2013-01-23','09:30:00',1.76),('14598','2013-01-23','09:35:00',1.78),('14598','2013-01-23','09:40:00',1.7),('14598','2013-01-23','09:45:00',2.13),('14598','2013-01-23','09:50:00',1.26),('14598','2013-01-23','09:55:00',1.01),('14598','2013-01-23','11:50:00',1.08),('14598','2013-01-23','11:55:00',1.84),('14598','2013-01-23','12:00:00',2.68),('14598','2013-01-23','12:05:00',3.06),('14598','2013-01-23','12:10:00',1.94),('14598','2013-01-23','12:15:00',1.54),('14598','2013-01-23','12:20:00',1.41),('14598','2013-01-22','09:15:00',1.05),('14598','2013-01-22','09:35:00',1.15),('14598','2013-01-22','09:40:00',1.47),('14598','2013-01-22','09:45:00',1.55),('14598','2013-01-22','09:50:00',1.47),('14598','2013-01-22','09:55:00',1.3),('14598','2013-01-22','10:00:00',1.65),('14598','2013-01-22','10:05:00',2.04),('14598','2013-01-22','10:10:00',1.71),('14598','2013-01-22','10:15:00',2),('14598','2013-01-22','10:20:00',2.41),('14598','2013-01-22','10:25:00',2.45),('14598','2013-01-22','10:30:00',2.41),('14598','2013-01-22','10:35:00',1.48),('14598','2013-01-22','10:40:00',1.65),('14598','2013-01-22','10:45:00',1.96),('14598','2013-01-22','10:55:00',2.52),('14598','2013-01-22','11:00:00',3.08),('14598','2013-01-22','11:05:00',1.55),('14598','2013-01-22','11:15:00',2.79),('14598','2013-01-22','11:20:00',1.51),('14598','2013-01-22','11:25:00',2.34),('14598','2013-01-22','11:30:00',2.16),('14598','2013-01-22','11:35:00',2.42),('14598','2013-01-22','11:40:00',2.61),('14598','2013-01-22','11:45:00',2.09),('14598','2013-01-22','11:50:00',1.93),('14598','2013-01-22','11:55:00',2.86),('14598','2013-01-22','12:00:00',3.27),('14598','2013-01-22','12:05:00',1.15),('14598','2013-01-22','12:10:00',2.45),('14598','2013-01-22','12:15:00',3.87),('14598','2013-01-22','12:20:00',2.65),('14598','2013-01-22','12:25:00',1.32),('14598','2013-01-22','12:30:00',1.2),('14598','2013-01-22','12:35:00',2.84),('14598','2013-01-22','12:40:00',3.01),('14598','2013-01-22','12:45:00',2.48),('14598','2013-01-22','12:50:00',2.6),('14598','2013-01-22','12:55:00',3.15),('14598','2013-01-22','13:00:00',2.94),('14598','2013-01-22','13:05:00',1.95),('14598','2013-01-22','13:10:00',1.53),('14598','2013-01-22','13:15:00',1.95),('14598','2013-01-22','13:20:00',2.49),('14598','2013-01-22','13:25:00',2.32),('14598','2013-01-22','13:30:00',1.04),('14598','2013-01-22','13:35:00',2.38),('14598','2013-01-22','13:40:00',2.64),('14598','2013-01-22','13:45:00',3.06),('14598','2013-01-22','13:50:00',3.28),('14598','2013-01-22','13:55:00',3.16),('14598','2013-01-22','14:00:00',2.22),('14598','2013-01-22','14:05:00',2.25),('14598','2013-01-22','14:10:00',2.95),('14598','2013-01-22','14:15:00',3.02),('14598','2013-01-22','14:20:00',2.66),('14598','2013-01-22','14:25:00',1.82),('14598','2013-01-22','14:30:00',1.18),('14598','2013-01-22','14:40:00',1.64),('14598','2013-01-22','14:45:00',1.59),('14598','2013-01-22','14:50:00',1.31),('14598','2014-03-20','08:05:00',1.01),('14598','2014-03-20','08:10:00',1.17),('14598','2014-03-20','08:15:00',1.27),('14598','2014-03-20','08:20:00',1.39),('14598','2014-03-20','08:25:00',1.51),('14598','2014-03-20','08:30:00',1.66),('14598','2014-03-20','08:35:00',1.8),('14598','2014-03-20','08:40:00',1.88),('14598','2014-03-20','08:45:00',1.93),('14598','2014-03-20','08:50:00',1.98),('14598','2014-03-20','08:55:00',2.11),('14598','2014-03-20','09:00:00',2.21),('14598','2014-03-20','09:05:00',2.25),('14598','2014-03-20','09:10:00',2.35),('14598','2014-03-20','09:15:00',2.4),('14598','2014-03-20','09:20:00',2.47),('14598','2014-03-20','09:25:00',2.61),('14598','2014-03-20','09:30:00',2.64),('14598','2014-03-20','09:35:00',2.77),('14598','2014-03-20','09:40:00',2.83),('14598','2014-03-20','09:45:00',2.98),('14598','2014-03-20','09:50:00',3.06),('14598','2014-03-20','09:55:00',3.07),('14598','2014-03-20','10:00:00',3.12),('14598','2014-03-20','10:05:00',3.25),('14598','2014-03-20','10:10:00',3.33),('14598','2014-03-20','10:15:00',3.37),('14598','2014-03-20','10:20:00',3.42),('14598','2014-03-20','10:25:00',3.38),('14598','2014-03-20','10:30:00',3.27),('14598','2014-03-20','10:35:00',3.26),('14598','2014-03-20','10:40:00',3.36),('14598','2014-03-20','10:45:00',3.6),('14598','2014-03-20','10:50:00',3.81),('14598','2014-03-20','10:55:00',3.64),('14598','2014-03-20','11:00:00',3.27),('14598','2014-03-20','11:05:00',3.53),('14598','2014-03-20','11:10:00',3.63),('14598','2014-03-20','11:15:00',3.78),('14598','2014-03-20','11:20:00',3.81),('14598','2014-03-20','11:25:00',3.72),('14598','2014-03-20','11:30:00',3.74),('14598','2014-03-20','11:35:00',3.82),('14598','2014-03-20','11:40:00',3.87),('14598','2014-03-20','11:45:00',3.77),('14598','2014-03-20','11:50:00',3.75),('14598','2014-03-20','11:55:00',3.99),('14598','2014-03-20','12:00:00',4.1),('14598','2014-03-20','12:05:00',4.11),('14598','2014-03-20','12:10:00',4.02),('14598','2014-03-20','12:15:00',4.23),('14598','2014-03-20','12:20:00',4.35),('14598','2014-03-20','12:25:00',4.5),('14598','2014-03-20','12:30:00',4.48),('14598','2014-03-20','12:35:00',4.43),('14598','2014-03-20','12:40:00',4.44),('14598','2014-03-20','12:45:00',4.3),('14598','2014-03-20','12:50:00',4.23),('14598','2014-03-20','12:55:00',4.08),('14598','2014-03-20','13:00:00',4.15),('14598','2014-03-20','13:05:00',4.12),('14598','2014-03-20','13:10:00',4.18),('14598','2014-03-20','13:15:00',4.14),('14598','2014-03-20','13:20:00',3.89),('14598','2014-03-20','13:25:00',3.71),('14598','2014-03-20','13:30:00',3.9),('14598','2014-03-20','13:35:00',3.86),('14598','2014-03-20','13:40:00',4.11),('14598','2014-03-20','13:45:00',3.89),('14598','2014-03-20','13:50:00',3.81),('14598','2014-03-20','13:55:00',3.69),('14598','2014-03-20','14:00:00',3.66),('14598','2014-03-20','14:05:00',3.72),('14598','2014-03-20','14:10:00',3.59),('14598','2014-03-20','14:15:00',3.62),('14598','2014-03-20','14:20:00',3.72),('14598','2014-03-20','14:25:00',3.55),('14598','2014-03-20','14:30:00',3.48),('14598','2014-03-20','14:35:00',3.24),('14598','2014-03-20','14:40:00',3.3),('14598','2014-03-20','14:45:00',3.07),('14598','2014-03-20','14:50:00',2.85),('14598','2014-03-20','14:55:00',2.81),('14598','2014-03-20','15:00:00',2.84),('14598','2014-03-20','15:05:00',2.69),('14598','2014-03-20','15:10:00',2.75),('14598','2014-03-20','15:15:00',2.34),('14598','2014-03-20','15:20:00',2.2),('14598','2014-03-20','15:25:00',2.18),('14598','2014-03-20','15:30:00',2.23),('14598','2014-03-20','15:35:00',2.08),('14598','2014-03-20','15:40:00',2.12),('14598','2014-03-20','15:45:00',1.97),('14598','2014-03-20','15:50:00',1.67),('14598','2014-03-20','15:55:00',1.77),('14598','2014-03-20','16:00:00',1.48),('14598','2014-03-20','16:05:00',1.48),('14598','2014-03-20','16:10:00',1.4),('14598','2014-03-20','16:15:00',1.34),('14598','2014-03-20','16:20:00',1.62),('14598','2014-03-20','16:25:00',1.49),('14598','2014-03-20','16:30:00',1.28),('14598','2014-03-20','16:35:00',1.16),('14598','2014-03-20','16:40:00',1.1),('14598','2013-01-21','10:50:00',1.1),('14598','2013-01-21','10:55:00',1.4),('14598','2013-01-21','11:00:00',1.21),('14598','2013-01-21','11:10:00',1.11),('14598','2013-01-21','11:20:00',1),('14598','2013-01-21','11:30:00',2.48),('14598','2013-01-21','11:35:00',2.97),('14598','2013-01-21','11:40:00',2.97),('14598','2013-01-21','11:45:00',2.79),('14598','2013-01-21','11:50:00',3.15),('14598','2013-01-21','11:55:00',2.28),('14598','2013-01-21','12:00:00',1.88),('14598','2013-01-21','12:05:00',2.44),('14598','2013-01-21','12:10:00',1.72),('14598','2013-01-21','12:15:00',2.09),('14598','2013-01-21','12:25:00',1.12),('14598','2013-01-21','12:35:00',1.64),('14598','2013-01-21','12:40:00',1.87),('14598','2013-01-21','12:45:00',1.34),('14598','2013-01-21','12:50:00',1.18),('14598','2013-01-21','12:55:00',1.14),('14598','2013-01-21','13:00:00',2.97),('14598','2013-01-21','13:05:00',3.81),('14598','2013-01-21','13:10:00',3.25),('14598','2013-01-21','13:15:00',3.32),('14598','2013-01-21','13:20:00',3.34),('14598','2013-01-21','13:25:00',3.47),('14598','2013-01-21','13:30:00',2.8),('14598','2013-01-21','13:35:00',2.62),('14598','2013-01-21','13:40:00',3.37),('14598','2013-01-21','13:45:00',2.81),('14598','2013-01-21','13:50:00',2.56),('14598','2013-01-21','13:55:00',2.72),('14598','2013-01-21','14:00:00',2.2),('14598','2013-01-21','14:05:00',3.24),('14598','2013-01-21','14:10:00',2.16),('14598','2013-01-21','15:15:00',2.27),('14598','2013-01-21','15:20:00',2.11),('14598','2013-01-20','10:50:00',1.02),('14598','2013-01-20','11:05:00',1.07),('14598','2013-01-20','11:10:00',1.08),('14598','2013-01-20','11:15:00',1.22),('14598','2013-01-20','11:30:00',1.01),('14598','2013-01-20','11:35:00',1.12),('14598','2013-01-19','10:30:00',1.38),('14598','2013-01-19','10:35:00',1.16),('14598','2013-01-19','10:50:00',1.12),('14598','2013-01-19','14:15:00',1.15),('14598','2013-01-18','10:15:00',1.02),('14598','2013-01-18','11:00:00',1.02),('14598','2013-01-18','11:05:00',1.2),('14598','2013-01-18','11:10:00',1.44),('14598','2013-01-18','11:15:00',1.48),('14598','2013-01-18','11:20:00',2.12),('14598','2013-01-18','11:25:00',2.71),('14598','2013-01-18','11:30:00',2.08),('14598','2013-01-18','11:35:00',1.38),('14598','2013-01-18','11:40:00',1.51),('14598','2013-01-18','11:45:00',2.12),('14598','2013-01-18','11:50:00',2.13),('14598','2013-01-18','11:55:00',1.55),('14598','2013-01-18','12:00:00',1.54),('14598','2013-01-18','12:05:00',1.51),('14598','2013-01-18','12:10:00',1.61),('14598','2013-01-18','12:15:00',1.64),('14598','2013-01-18','12:20:00',1.48),('14598','2013-01-18','12:25:00',1.46),('14598','2013-01-18','12:30:00',1.61),('14598','2013-01-18','12:35:00',2.05),('14598','2013-01-18','12:40:00',2.19),('14598','2013-01-18','12:45:00',1.71),('14598','2013-01-18','12:50:00',1.79),('14598','2013-01-18','12:55:00',1.48),('14598','2013-01-18','13:00:00',1.45),('14598','2013-01-18','13:05:00',1.34),('14598','2013-01-18','13:10:00',1.32),('14598','2013-01-18','13:15:00',2.01),('14598','2013-01-18','13:20:00',2.01),('14598','2013-01-18','13:25:00',1.91),('14598','2013-01-18','13:30:00',1.72),('14598','2013-01-18','13:35:00',1.83),('14598','2013-01-18','13:40:00',3.26),('14598','2013-01-18','13:45:00',3.63),('14598','2013-01-18','13:50:00',3.37),('14598','2013-01-18','13:55:00',2.35),('14598','2013-01-18','14:00:00',2.98),('14598','2013-01-18','14:05:00',2.75),('14598','2013-01-18','14:10:00',2.91),('14598','2013-01-18','14:15:00',2.84),('14598','2013-01-18','14:20:00',2.87),('14598','2013-01-18','14:25:00',2.86),('14598','2013-01-18','14:30:00',2.77),('14598','2013-01-18','14:35:00',2.7),('14598','2013-01-18','14:40:00',2.79),('14598','2013-01-18','14:45:00',2.7),('14598','2013-01-18','14:50:00',2.84),('14598','2013-01-18','14:55:00',2.93),('14598','2013-01-18','15:00:00',2.8),('14598','2013-01-18','15:05:00',2.17),('14598','2013-01-18','15:10:00',2.62),('14598','2013-01-18','15:15:00',2.53),('14598','2013-01-18','15:20:00',2.43),('14598','2013-01-18','15:25:00',2.33),('14598','2013-01-18','15:30:00',1.81),('14598','2013-01-18','15:35:00',1.74),('14598','2013-01-18','15:40:00',1.59),('14598','2013-01-18','15:45:00',1.48),('14598','2013-01-18','15:50:00',1.31),('14598','2013-01-18','15:55:00',1.17),('14598','2013-01-18','16:00:00',1.1),('14598','2013-01-17','09:35:00',1.09),('14598','2013-01-17','09:40:00',1.34),('14598','2013-01-17','09:45:00',1.35),('14598','2013-01-17','09:50:00',1.25),('14598','2013-01-17','09:55:00',1.26),('14598','2013-01-17','10:00:00',1.31),('14598','2013-01-17','10:05:00',1.34),('14598','2013-01-17','10:10:00',1.72),('14598','2013-01-17','10:15:00',2.03),('14598','2013-01-17','10:20:00',1.78),('14598','2013-01-17','10:25:00',1.98),('14598','2013-01-17','10:30:00',1.66),('14598','2013-01-17','10:35:00',1.56),('14598','2013-01-17','10:40:00',1.58),('14598','2013-01-17','10:45:00',1.46),('14598','2013-01-17','10:50:00',1.33),('14598','2013-01-17','10:55:00',1.42),('14598','2013-01-17','11:00:00',1.86),('14598','2013-01-17','11:05:00',1.76),('14598','2013-01-17','11:10:00',1.55),('14598','2013-01-17','11:15:00',1.96),('14598','2013-01-17','11:20:00',2.15),('14598','2013-01-17','11:25:00',2.3),('14598','2013-01-17','11:30:00',2.17),('14598','2013-01-17','11:35:00',1.82),('14598','2013-01-17','11:40:00',1.71),('14598','2013-01-17','11:45:00',1.8),('14598','2013-01-17','11:50:00',1.65),('14598','2013-01-17','11:55:00',1.99),('14598','2013-01-17','12:00:00',1.96),('14598','2013-01-17','12:05:00',1.69),('14598','2013-01-17','12:10:00',2.18),('14598','2013-01-17','12:15:00',2.1),('14598','2013-01-17','12:20:00',1.83),('14598','2013-01-17','12:25:00',2.15),('14598','2013-01-17','12:30:00',2.05),('14598','2013-01-17','12:35:00',1.36),('14598','2013-01-17','12:40:00',1.79),('14598','2013-01-17','12:45:00',1.94),('14598','2013-01-17','12:50:00',1.93),('14598','2013-01-17','12:55:00',1.4),('14598','2013-01-17','13:00:00',1.93),('14598','2013-01-17','13:05:00',1.55),('14598','2013-01-17','13:10:00',1),('14598','2013-01-17','13:15:00',1.41),('14598','2013-01-17','13:20:00',1.78),('14598','2013-01-17','13:25:00',2.06),('14598','2013-01-17','13:30:00',2.35),('14598','2013-01-17','13:35:00',1.96),('14598','2013-01-17','13:40:00',1.5),('14598','2013-01-17','13:45:00',1.22),('14598','2013-01-17','13:50:00',1.06),('14598','2013-01-17','14:15:00',1.24),('14598','2013-01-17','14:20:00',1.14),('14598','2013-01-17','14:30:00',1.05),('14598','2013-01-17','14:35:00',1.07),('14598','2013-01-17','14:50:00',1.12),('14598','2013-01-17','14:55:00',1.19),('14598','2013-01-16','09:05:00',1.38),('14598','2013-01-16','09:15:00',1.26),('14598','2013-01-16','09:20:00',1.38),('14598','2013-01-16','09:25:00',1.66),('14598','2013-01-16','09:30:00',1.55),('14598','2013-01-16','09:35:00',1.51),('14598','2013-01-16','10:10:00',1.42),('14598','2013-01-16','10:15:00',2.29),('14598','2013-01-16','10:20:00',2.49),('14598','2013-01-16','10:25:00',2.11),('14598','2013-01-16','10:30:00',1.69),('14598','2013-01-16','10:35:00',2.18),('14598','2013-01-16','10:40:00',3.09),('14598','2013-01-16','10:45:00',2.17),('14598','2013-01-16','11:45:00',1.03),('14598','2013-01-16','11:50:00',1.24),('14598','2013-01-16','11:55:00',1.72),('14598','2013-01-16','12:00:00',1.49),('14598','2013-01-16','12:05:00',1.37),('14598','2013-01-16','12:20:00',3.16),('14598','2013-01-16','12:25:00',3.05),('14598','2013-01-16','12:50:00',1.12),('14598','2013-01-16','12:55:00',3.68),('14598','2013-01-16','13:00:00',1.27),('14598','2013-01-16','15:40:00',1.06),('14598','2013-01-16','15:45:00',1.72),('14598','2013-01-16','15:50:00',1.52),('14598','2013-01-16','15:55:00',1.29),('14598','2013-01-16','16:00:00',1.13),('14598','2013-01-15','09:35:00',1.18),('14598','2013-01-15','10:15:00',1.23),('14598','2013-01-15','10:20:00',1.03),('14598','2013-01-15','10:25:00',1.06),('14598','2013-01-15','10:30:00',2.41),('14598','2013-01-15','10:35:00',2.25),('14598','2013-01-15','11:00:00',1.16),('14598','2013-01-15','11:05:00',1.28),('14598','2013-01-15','11:10:00',1.33),('14598','2013-01-15','11:15:00',1.17),('14598','2013-01-15','11:20:00',1.15),('14598','2013-01-15','11:25:00',1.17),('14598','2013-01-15','11:30:00',1.19),('14598','2013-01-15','11:35:00',1.24),('14598','2013-01-15','11:40:00',1.32),('14598','2013-01-15','11:45:00',1.09),('14598','2013-01-15','11:50:00',1.17),('14598','2013-01-15','11:55:00',1.26),('14598','2013-01-15','12:00:00',1.31),('14598','2013-01-15','12:05:00',1.44),('14598','2013-01-15','12:10:00',1.45),('14598','2013-01-15','12:15:00',1.47),('14598','2013-01-15','12:20:00',1.52),('14598','2013-01-15','12:25:00',1.51),('14598','2013-01-15','12:30:00',1.52),('14598','2013-01-15','12:35:00',1.67),('14598','2013-01-15','12:40:00',1.81),('14598','2013-01-15','12:45:00',1.65),('14598','2013-01-15','12:50:00',1.51),('14598','2013-01-15','12:55:00',1.83),('14598','2013-01-15','13:00:00',1.94),('14598','2013-01-15','13:05:00',1.87),('14598','2013-01-15','13:10:00',2.09),('14598','2013-01-15','13:15:00',2.02),('14598','2013-01-15','13:20:00',1.9),('14598','2013-01-15','13:25:00',1.99),('14598','2013-01-15','13:30:00',2.12),('14598','2013-01-15','13:35:00',2.79),('14598','2013-01-15','13:40:00',2.84),('14598','2013-01-15','13:45:00',2.49),('14598','2013-01-15','13:50:00',2.98),('14598','2013-01-15','13:55:00',1.59),('14598','2013-01-15','14:00:00',1.87),('14598','2013-01-15','14:05:00',1.75),('14598','2013-01-15','14:10:00',1.76),('14598','2013-01-15','14:15:00',3.12),('14598','2013-01-15','14:20:00',2.97),('14598','2013-01-15','14:25:00',2.75),('14598','2013-01-15','14:30:00',2.6),('14598','2013-01-15','14:35:00',2.45),('14598','2013-01-15','14:40:00',2.19),('14598','2013-01-15','14:45:00',2.42),('14598','2013-01-15','14:50:00',2.36),('14598','2013-01-15','14:55:00',2.28),('14598','2013-01-15','15:00:00',2.18),('14598','2013-01-15','15:05:00',2.12),('14598','2013-01-15','15:10:00',2.05),('14598','2013-01-15','15:15:00',1.99),('14598','2013-01-15','15:20:00',1.92),('14598','2013-01-15','15:25:00',1.87),('14598','2013-01-15','15:30:00',1.81),('14598','2013-01-15','15:35:00',1.74),('14598','2013-01-15','15:40:00',1.68),('14598','2013-01-15','15:45:00',1.66),('14598','2013-01-15','15:50:00',1.63),('14598','2013-01-15','15:55:00',1.58),('14598','2013-01-15','16:00:00',1.49),('14598','2013-01-15','16:05:00',1.39),('14598','2013-01-15','16:10:00',1.26),('14598','2013-01-15','16:15:00',1.11),('14598','2013-01-14','10:20:00',1.13),('14598','2013-01-14','10:25:00',1.19),('14598','2013-01-14','10:55:00',1.03),('14598','2013-01-14','11:00:00',1.05),('14598','2013-01-14','11:05:00',1.25),('14598','2013-01-14','11:10:00',1.23),('14598','2013-01-14','11:15:00',1.35),('14598','2013-01-14','11:20:00',1.53),('14598','2013-01-14','11:25:00',1.39),('14598','2013-01-14','11:30:00',1.02),('14598','2013-01-14','15:00:00',1.34),('14598','2013-01-14','15:05:00',1.2),('14598','2013-01-13','10:10:00',1.19),('14598','2013-01-13','10:55:00',1.23),('14598','2013-01-13','11:00:00',1.02),('14598','2013-01-13','11:35:00',1.02),('14598','2013-01-13','11:40:00',1.15),('14598','2013-01-13','11:45:00',1.22),('14598','2013-01-13','11:50:00',1.24),('14598','2013-01-13','11:55:00',1.43),('14598','2013-01-13','12:00:00',1.24),('14598','2013-01-12','09:25:00',1.01),('14598','2013-01-12','09:30:00',1.12),('14598','2013-01-12','09:35:00',1.22),('14598','2013-01-12','09:40:00',1.32),('14598','2013-01-12','09:45:00',1.44),('14598','2013-01-12','09:50:00',1.56),('14598','2013-01-12','09:55:00',1.64),('14598','2013-01-12','10:00:00',1.72),('14598','2013-01-12','10:05:00',1.81),('14598','2013-01-12','10:10:00',1.86),('14598','2013-01-12','10:15:00',1.96),('14598','2013-01-12','10:20:00',2.03),('14598','2013-01-12','10:25:00',2.09),('14598','2013-01-12','10:30:00',2.14),('14598','2013-01-12','10:35:00',2.22),('14598','2013-01-12','10:40:00',2.28),('14598','2013-01-12','10:45:00',2.33),('14598','2013-01-12','10:50:00',2.39),('14598','2013-01-12','10:55:00',2.45),('14598','2013-01-12','11:00:00',2.51),('14598','2013-01-12','11:05:00',2.56),('14598','2013-01-12','11:10:00',2.61),('14598','2013-01-12','11:15:00',2.65),('14598','2013-01-12','11:20:00',2.69),('14598','2013-01-12','11:25:00',2.7),('14598','2013-01-12','11:30:00',2.73),('14598','2013-01-12','11:35:00',2.78),('14598','2013-01-12','11:40:00',2.82),('14598','2013-01-12','11:45:00',2.87),('14598','2013-01-12','11:50:00',2.9),('14598','2013-01-12','11:55:00',2.93),('14598','2013-01-12','12:00:00',2.94),('14598','2013-01-12','12:05:00',2.96),('14598','2013-01-12','12:10:00',2.97),('14598','2013-01-12','12:15:00',2.97),('14598','2013-01-12','12:20:00',2.98),('14598','2013-01-12','12:25:00',2.99),('14598','2013-01-12','12:30:00',3.01),('14598','2013-01-12','12:35:00',2.99),('14598','2013-01-12','12:40:00',2.4),('14598','2013-01-12','12:45:00',1.74),('14598','2013-01-12','12:50:00',1.6),('14598','2013-01-12','12:55:00',2.39),('14598','2013-01-12','13:00:00',1.72),('14598','2013-01-12','13:05:00',3.16),('14598','2013-01-12','13:10:00',1.39),('14598','2013-01-12','13:15:00',2.71),('14598','2013-01-12','13:20:00',3.46),('14598','2013-01-12','13:25:00',3.07),('14598','2013-01-12','13:30:00',2.93),('14598','2013-01-12','13:35:00',2.92),('14598','2013-01-12','13:40:00',2.9),('14598','2013-01-12','13:45:00',2.84),('14598','2013-01-12','13:50:00',2.81),('14598','2013-01-12','13:55:00',2.77),('14598','2013-01-12','14:00:00',2.71),('14598','2013-01-12','14:05:00',2.68),('14598','2013-01-12','14:10:00',2.65),('14598','2013-01-12','14:15:00',2.62),('14598','2013-01-12','14:20:00',2.56),('14598','2013-01-12','14:25:00',2.46),('14598','2013-01-12','14:30:00',2.41),('14598','2013-01-12','14:35:00',2.39),('14598','2013-01-12','14:40:00',2.33),('14598','2013-01-12','14:45:00',2.25),('14598','2013-01-12','14:50:00',2.18),('14598','2013-01-12','14:55:00',2.09),('14598','2013-01-12','15:00:00',1.99),('14598','2013-01-12','15:05:00',1.89),('14598','2013-01-12','15:10:00',1.87),('14598','2013-01-12','15:15:00',1.79),('14598','2013-01-12','15:20:00',1.69),('14598','2013-01-12','15:25:00',1.6),('14598','2013-01-12','15:30:00',1.53),('14598','2013-01-12','15:35:00',1.41),('14598','2013-01-12','15:40:00',1.3),('14598','2013-01-12','15:45:00',1.2),('14598','2013-01-12','15:50:00',1.11),('14598','2013-01-12','15:55:00',1.01),('14598','2014-03-19','08:35:00',1.08),('14598','2014-03-19','08:40:00',1.19),('14598','2014-03-19','08:45:00',1.25),('14598','2014-03-19','08:50:00',1.4),('14598','2014-03-19','08:55:00',1.43),('14598','2014-03-19','09:00:00',1.45),('14598','2014-03-19','09:05:00',1.46),('14598','2014-03-19','09:10:00',1.54),('14598','2014-03-19','09:15:00',2.13),('14598','2014-03-19','09:20:00',1.96),('14598','2014-03-19','09:25:00',2.1),('14598','2014-03-19','09:30:00',2.32),('14598','2014-03-19','09:35:00',2.36),('14598','2014-03-19','09:40:00',2.52),('14598','2014-03-19','09:45:00',1.93),('14598','2014-03-19','09:50:00',1.86),('14598','2014-03-19','09:55:00',1.67),('14598','2014-03-19','10:00:00',2.19),('14598','2014-03-19','10:05:00',4.01),('14598','2014-03-19','10:10:00',4.59),('14598','2014-03-19','10:15:00',4.66),('14598','2014-03-19','10:20:00',3.54),('14598','2014-03-19','10:25:00',2.14),('14598','2014-03-19','10:30:00',2.62),('14598','2014-03-19','10:35:00',4.73),('14598','2014-03-19','10:40:00',4.39),('14598','2014-03-19','10:45:00',4.41),('14598','2014-03-19','10:50:00',4.38),('14598','2014-03-19','10:55:00',4.64),('14598','2014-03-19','11:00:00',4.77),('14598','2014-03-19','11:05:00',4.76),('14598','2014-03-19','11:10:00',4.75),('14598','2014-03-19','11:15:00',4.17),('14598','2014-03-19','11:20:00',4.33),('14598','2014-03-19','11:25:00',5.06),('14598','2014-03-19','11:30:00',4.96),('14598','2014-03-19','11:35:00',4.68),('14598','2014-03-19','11:40:00',4.68),('14598','2014-03-19','11:45:00',4.63),('14598','2014-03-19','11:50:00',4.67),('14598','2014-03-19','11:55:00',4.59),('14598','2014-03-19','12:00:00',4.69),('14598','2014-03-19','12:05:00',4.57),('14598','2014-03-19','12:10:00',4.45),('14598','2014-03-19','12:15:00',4.66),('14598','2014-03-19','12:20:00',4.63),('14598','2014-03-19','12:25:00',4.63),('14598','2014-03-19','12:30:00',4.54),('14598','2014-03-19','12:35:00',4.61),('14598','2014-03-19','12:40:00',4.52),('14598','2014-03-19','12:45:00',4.49),('14598','2014-03-19','12:50:00',4.34),('14598','2014-03-19','12:55:00',4),('14598','2014-03-19','13:00:00',4.19),('14598','2014-03-19','13:05:00',3.91),('14598','2014-03-19','13:10:00',4.61),('14598','2014-03-19','13:15:00',4.34),('14598','2014-03-19','13:20:00',4.46),('14598','2014-03-19','13:25:00',4.31),('14598','2014-03-19','13:30:00',4.41),('14598','2014-03-19','13:35:00',4.44),('14598','2014-03-19','13:40:00',4.42),('14598','2014-03-19','13:45:00',4.39),('14598','2014-03-19','13:50:00',4.32),('14598','2014-03-19','13:55:00',4.29),('14598','2014-03-19','14:00:00',4.27),('14598','2014-03-19','14:05:00',4.22),('14598','2014-03-19','14:10:00',4.16),('14598','2014-03-19','14:15:00',4.17),('14598','2014-03-19','14:20:00',4.02),('14598','2014-03-19','14:25:00',4.09),('14598','2014-03-19','14:30:00',4.04),('14598','2014-03-19','14:35:00',3.97),('14598','2014-03-19','14:40:00',3.93),('14598','2014-03-19','14:45:00',3.92),('14598','2014-03-19','14:50:00',3.86),('14598','2014-03-19','14:55:00',3.79),('14598','2014-03-19','15:00:00',3.75),('14598','2014-03-19','15:05:00',3.66),('14598','2014-03-19','15:10:00',3.62),('14598','2014-03-19','15:15:00',3.54),('14598','2014-03-19','15:20:00',3.42),('14598','2014-03-19','15:25:00',3.31),('14598','2014-03-19','15:30:00',3.2),('14598','2014-03-19','15:35:00',3.16),('14598','2014-03-19','15:40:00',3.1),('14598','2014-03-19','15:45:00',3.04),('14598','2014-03-19','15:50:00',2.96),('14598','2014-03-19','15:55:00',2.86),('14598','2014-03-19','16:00:00',2.77),('14598','2014-03-19','16:05:00',2.64),('14598','2014-03-19','16:10:00',2.53),('14598','2014-03-19','16:15:00',2.44),('14598','2014-03-19','16:20:00',2.28),('14598','2014-03-19','16:25:00',2.07),('14598','2014-03-19','16:30:00',1.99),('14598','2014-03-19','16:35:00',1.99),('14598','2014-03-19','16:40:00',1.77),('14598','2014-03-19','16:45:00',1.65),('14598','2014-03-19','16:50:00',1.45),('14598','2014-03-19','16:55:00',1.33),('14598','2014-03-19','17:05:00',1.04),('14598','2014-03-19','17:10:00',1.03),('14598','2014-03-19','17:15:00',1.06),('14598','2013-01-11','09:45:00',1.12),('14598','2013-01-11','09:50:00',1.38),('14598','2013-01-11','09:55:00',1.53),('14598','2013-01-11','10:00:00',1.56),('14598','2013-01-11','10:05:00',1.67),('14598','2013-01-11','10:10:00',1.74),('14598','2013-01-11','10:15:00',1.82),('14598','2013-01-11','10:20:00',1.9),('14598','2013-01-11','10:25:00',1.98),('14598','2013-01-11','10:30:00',2.05),('14598','2013-01-11','10:35:00',2.08),('14598','2013-01-11','10:40:00',2.13),('14598','2013-01-11','10:45:00',2.18),('14598','2013-01-11','10:50:00',2.2),('14598','2013-01-11','10:55:00',2.29),('14598','2013-01-11','11:00:00',1.48),('14598','2013-01-11','11:05:00',1.28),('14598','2013-01-11','11:10:00',1.12),('14598','2013-01-11','11:15:00',1.34),('14598','2013-01-11','11:20:00',1.66),('14598','2013-01-11','11:25:00',1.21),('14598','2013-01-11','11:30:00',1.99),('14598','2013-01-11','11:35:00',1.37),('14598','2013-01-11','11:40:00',1.09),('14598','2013-01-11','12:00:00',1.07),('14598','2013-01-11','12:25:00',1.31),('14598','2013-01-11','12:30:00',2.08),('14598','2013-01-11','12:35:00',2.41),('14598','2013-01-11','12:40:00',1.45),('14598','2013-01-11','12:45:00',1.63),('14598','2013-01-11','13:15:00',3.09),('14598','2013-01-11','13:20:00',2.55),('14598','2013-01-11','13:25:00',2.22),('14598','2013-01-11','13:30:00',1.06),('14598','2013-01-11','13:50:00',2.12),('14598','2013-01-11','14:10:00',1.54),('14598','2013-01-11','14:15:00',1.28),('14598','2013-01-11','14:20:00',2.07),('14598','2013-01-11','14:25:00',2.88),('14598','2013-01-11','14:30:00',1.56),('14598','2013-01-11','14:35:00',1.41),('14598','2013-01-11','14:40:00',2.36),('14598','2013-01-11','14:45:00',1.76),('14598','2013-01-11','14:50:00',2.03),('14598','2013-01-10','11:55:00',1.07),('14598','2013-01-10','12:00:00',1.34),('14598','2013-01-10','12:05:00',1.64),('14598','2013-01-10','12:10:00',1.42),('14598','2013-01-10','12:15:00',1.17),('14598','2013-01-10','13:00:00',1.11),('14598','2013-01-10','13:05:00',1.14),('14598','2013-01-10','13:25:00',1.03),('14598','2013-01-10','13:30:00',1.06),('14598','2013-01-09','10:05:00',1.03),('14598','2013-01-09','10:10:00',1.37),('14598','2013-01-09','10:15:00',2.54),('14598','2013-01-09','10:20:00',1.73),('14598','2013-01-09','10:25:00',1.94),('14598','2013-01-09','10:30:00',1.35),('14598','2013-01-09','10:35:00',1.15),('14598','2013-01-09','10:40:00',1.1),('14598','2013-01-09','10:45:00',1.29),('14598','2013-01-09','10:50:00',2.53),('14598','2013-01-09','10:55:00',1.67),('14598','2013-01-09','11:00:00',1.67),('14598','2013-01-09','11:05:00',1.57),('14598','2013-01-09','11:10:00',1.44),('14598','2013-01-09','11:15:00',1.56),('14598','2013-01-09','11:20:00',1.8),('14598','2013-01-09','11:25:00',1.85),('14598','2013-01-09','11:30:00',3.05),('14598','2013-01-09','11:35:00',2.5),('14598','2013-01-09','11:40:00',3.06),('14598','2013-01-09','11:45:00',2.32),('14598','2013-01-09','11:50:00',2.94),('14598','2013-01-09','11:55:00',2.57),('14598','2013-01-09','12:00:00',2.85),('14598','2013-01-09','12:05:00',2.81),('14598','2013-01-09','12:10:00',2.89),('14598','2013-01-09','12:15:00',2.93),('14598','2013-01-09','12:20:00',2.78),('14598','2013-01-09','12:25:00',2.3),('14598','2013-01-09','12:30:00',2.97),('14598','2013-01-09','12:35:00',2.93),('14598','2013-01-09','12:40:00',2.9),('14598','2013-01-09','12:45:00',2.89),('14598','2013-01-09','12:50:00',2.87),('14598','2013-01-09','12:55:00',2.89),('14598','2013-01-09','13:00:00',2.84),('14598','2013-01-09','13:05:00',2.81),('14598','2013-01-09','13:10:00',2.73),('14598','2013-01-09','13:15:00',2.79),('14598','2013-01-09','13:20:00',2.68),('14598','2013-01-09','13:25:00',2.78),('14598','2013-01-09','13:30:00',2.72),('14598','2013-01-09','13:35:00',2.72),('14598','2013-01-09','13:40:00',2.2),('14598','2013-01-09','13:45:00',1.59),('14598','2013-01-09','13:50:00',1.46),('14598','2013-01-09','13:55:00',1.9),('14598','2013-01-09','14:00:00',1.93),('14598','2013-01-09','14:05:00',2.49),('14598','2013-01-09','14:10:00',2.81),('14598','2013-01-09','14:15:00',2.71),('14598','2013-01-09','14:20:00',2.22),('14598','2013-01-09','14:25:00',1.46),('14598','2013-01-09','14:30:00',1.38),('14598','2013-01-09','14:35:00',2.03),('14598','2013-01-09','14:40:00',2.17),('14598','2013-01-09','14:45:00',1.98),('14598','2013-01-09','14:50:00',1.97),('14598','2013-01-09','14:55:00',1.8),('14598','2013-01-09','15:00:00',1.5),('14598','2013-01-09','15:05:00',1.32),('14598','2013-01-09','15:10:00',1.5),('14598','2013-01-09','15:15:00',1.68),('14598','2013-01-09','15:20:00',1.57),('14598','2013-01-09','15:25:00',1.45),('14598','2013-01-09','15:30:00',1.39),('14598','2013-01-09','15:35:00',1.3),('14598','2013-01-09','15:40:00',1.14),('14598','2013-01-09','15:50:00',1.09),('14598','2013-01-09','15:55:00',1.04),('14598','2013-01-08','10:20:00',1.42),('14598','2013-01-08','10:25:00',1.89),('14598','2013-01-08','10:30:00',2.07),('14598','2013-01-08','10:35:00',2.12),('14598','2013-01-08','10:40:00',2.14),('14598','2013-01-08','10:45:00',2.15),('14598','2013-01-08','10:50:00',2.32),('14598','2013-01-08','10:55:00',2.38),('14598','2013-01-08','11:00:00',2.44),('14598','2013-01-08','11:05:00',2.5),('14598','2013-01-08','11:10:00',2.51),('14598','2013-01-08','11:15:00',2.53),('14598','2013-01-08','11:20:00',2.65),('14598','2013-01-08','11:25:00',2.65),('14598','2013-01-08','11:30:00',2.71),('14598','2013-01-08','11:35:00',2.74),('14598','2013-01-08','11:40:00',2.79),('14598','2013-01-08','11:45:00',2.87),('14598','2013-01-08','11:50:00',1.89),('14598','2013-01-08','11:55:00',1.41),('14598','2013-01-08','12:00:00',1.36),('14598','2013-01-08','12:05:00',1.97),('14598','2013-01-08','12:10:00',2.04),('14598','2013-01-08','12:15:00',2.41),('14598','2013-01-08','12:20:00',2.17),('14598','2013-01-08','12:25:00',1.63),('14598','2013-01-08','12:30:00',1.48),('14598','2013-01-08','12:35:00',1.26),('14598','2013-01-08','12:40:00',1.14),('14598','2013-01-08','12:45:00',1.01),('14598','2013-01-07','09:30:00',1.06),('14598','2013-01-07','09:35:00',1.15),('14598','2013-01-07','09:40:00',1.25),('14598','2013-01-07','09:45:00',1.38),('14598','2013-01-07','09:50:00',1.48),('14598','2013-01-07','09:55:00',1.55),('14598','2013-01-07','10:00:00',1.63),('14598','2013-01-07','10:05:00',1.72),('14598','2013-01-07','10:10:00',1.8),('14598','2013-01-07','10:15:00',1.87),('14598','2013-01-07','10:20:00',1.94),('14598','2013-01-07','10:25:00',2.01),('14598','2013-01-07','10:30:00',2.08),('14598','2013-01-07','10:35:00',2.14),('14598','2013-01-07','10:40:00',2.2),('14598','2013-01-07','10:45:00',2.25),('14598','2013-01-07','10:50:00',2.3),('14598','2013-01-07','10:55:00',2.37),('14598','2013-01-07','11:00:00',2.42),('14598','2013-01-07','11:05:00',2.47),('14598','2013-01-07','11:10:00',2.52),('14598','2013-01-07','11:15:00',2.57),('14598','2013-01-07','11:20:00',2.6),('14598','2013-01-07','11:25:00',2.63),('14598','2013-01-07','11:30:00',2.68),('14598','2013-01-07','11:35:00',2.71),('14598','2013-01-07','11:40:00',2.75),('14598','2013-01-07','11:45:00',2.77),('14598','2013-01-07','11:50:00',2.8),('14598','2013-01-07','11:55:00',2.81),('14598','2013-01-07','12:00:00',2.8),('14598','2013-01-07','12:05:00',2.87),('14598','2013-01-07','12:10:00',2.87),('14598','2013-01-07','12:15:00',2.86),('14598','2013-01-07','12:20:00',2.84),('14598','2013-01-07','12:25:00',2.86),('14598','2013-01-07','12:30:00',2.89),('14598','2013-01-07','12:35:00',2.9),('14598','2013-01-07','12:40:00',2.9),('14598','2013-01-07','12:45:00',2.9),('14598','2013-01-07','12:50:00',2.9),('14598','2013-01-07','12:55:00',2.88),('14598','2013-01-07','13:00:00',2.87),('14598','2013-01-07','13:05:00',2.87),('14598','2013-01-07','13:10:00',2.86),('14598','2013-01-07','13:15:00',2.83),('14598','2013-01-07','13:20:00',2.81),('14598','2013-01-07','13:25:00',2.79),('14598','2013-01-07','13:30:00',2.76),('14598','2013-01-07','13:35:00',2.71),('14598','2013-01-07','13:40:00',2.68),('14598','2013-01-07','13:45:00',2.65),('14598','2013-01-07','13:50:00',2.63),('14598','2013-01-07','13:55:00',2.6),('14598','2013-01-07','14:00:00',2.56),('14598','2013-01-07','14:05:00',2.52),('14598','2013-01-07','14:10:00',2.48),('14598','2013-01-07','14:15:00',2.43),('14598','2013-01-07','14:20:00',2.38),('14598','2013-01-07','14:25:00',2.33),('14598','2013-01-07','14:30:00',2.26),('14598','2013-01-07','14:35:00',2.19),('14598','2013-01-07','14:40:00',2.13),('14598','2013-01-07','14:45:00',2.07),('14598','2013-01-07','14:50:00',2.01),('14598','2013-01-07','14:55:00',1.97),('14598','2013-01-07','15:00:00',1.87),('14598','2013-01-07','15:05:00',1.83),('14598','2013-01-07','15:10:00',1.75),('14598','2013-01-07','15:15:00',1.68),('14598','2013-01-07','15:20:00',1.61),('14598','2013-01-07','15:25:00',1.51),('14598','2013-01-07','15:30:00',1.42),('14598','2013-01-07','15:35:00',1.33),('14598','2013-01-07','15:40:00',1.25),('14598','2013-01-07','15:45:00',1.16),('14598','2013-01-07','15:50:00',1.07),('14598','2013-01-06','09:30:00',1.11),('14598','2013-01-06','09:35:00',1.2),('14598','2013-01-06','09:40:00',1.29),('14598','2013-01-06','09:45:00',1.41),('14598','2013-01-06','09:50:00',1.5),('14598','2013-01-06','09:55:00',1.58),('14598','2013-01-06','10:00:00',1.67),('14598','2013-01-06','10:05:00',1.74),('14598','2013-01-06','10:10:00',1.81),('14598','2013-01-06','10:15:00',1.89),('14598','2013-01-06','10:20:00',1.96),('14598','2013-01-06','10:25:00',2.02),('14598','2013-01-06','10:30:00',2.08),('14598','2013-01-06','10:35:00',2.14),('14598','2013-01-06','10:40:00',2.19),('14598','2013-01-06','10:45:00',2.25),('14598','2013-01-06','10:50:00',2.3),('14598','2013-01-06','10:55:00',2.32),('14598','2013-01-06','11:00:00',2.35),('14598','2013-01-06','11:05:00',2.43),('14598','2013-01-06','11:10:00',2.49),('14598','2013-01-06','11:15:00',2.51),('14598','2013-01-06','11:20:00',2.54),('14598','2013-01-06','11:25:00',2.57),('14598','2013-01-06','11:30:00',2.61),('14598','2013-01-06','11:35:00',2.66),('14598','2013-01-06','11:40:00',2.72),('14598','2013-01-06','11:45:00',2.78),('14598','2013-01-06','11:50:00',2.8),('14598','2013-01-06','11:55:00',2.82),('14598','2013-01-06','12:00:00',2.84),('14598','2013-01-06','12:05:00',2.87),('14598','2013-01-06','12:10:00',2.89),('14598','2013-01-06','12:15:00',2.88),('14598','2013-01-06','12:20:00',2.9),('14598','2013-01-06','12:25:00',2.87),('14598','2013-01-06','12:30:00',2.89),('14598','2013-01-06','12:35:00',2.9),('14598','2013-01-06','12:40:00',2.92),('14598','2013-01-06','12:45:00',2.88),('14598','2013-01-06','12:50:00',2.87),('14598','2013-01-06','12:55:00',2.88),('14598','2013-01-06','13:00:00',2.87),('14598','2013-01-06','13:05:00',2.85),('14598','2013-01-06','13:10:00',2.82),('14598','2013-01-06','13:15:00',2.8),('14598','2013-01-06','13:20:00',2.76),('14598','2013-01-06','13:25:00',2.73),('14598','2013-01-06','13:30:00',2.68),('14598','2013-01-06','13:35:00',2.67),('14598','2013-01-06','13:40:00',2.64),('14598','2013-01-06','13:45:00',2.61),('14598','2013-01-06','13:50:00',2.55),('14598','2013-01-06','13:55:00',2.52),('14598','2013-01-06','14:00:00',2.5),('14598','2013-01-06','14:05:00',2.52),('14598','2013-01-06','14:10:00',2.49),('14598','2013-01-06','14:15:00',2.46),('14598','2013-01-06','14:20:00',2.42),('14598','2013-01-06','14:25:00',2.37),('14598','2013-01-06','14:30:00',2.3),('14598','2013-01-06','14:35:00',2.25),('14598','2013-01-06','14:40:00',2.17),('14598','2013-01-06','14:45:00',2.1),('14598','2013-01-06','14:50:00',2.03),('14598','2013-01-06','14:55:00',1.93),('14598','2013-01-06','15:00:00',1.86),('14598','2013-01-06','15:05:00',1.79),('14598','2013-01-06','15:10:00',1.71),('14598','2013-01-06','15:15:00',1.63),('14598','2013-01-06','15:20:00',1.58),('14598','2013-01-06','15:25:00',1.5),('14598','2013-01-06','15:30:00',1.4),('14598','2013-01-06','15:35:00',1.27),('14598','2013-01-06','15:40:00',1.17),('14598','2013-01-06','15:45:00',1.09),('14598','2013-01-05','10:20:00',1.18),('14598','2013-01-05','10:25:00',1.55),('14598','2013-01-05','10:30:00',1.94),('14598','2013-01-05','10:35:00',1.78),('14598','2013-01-05','10:40:00',1.84),('14598','2013-01-05','10:45:00',1.94),('14598','2013-01-05','10:50:00',1.93),('14598','2013-01-05','10:55:00',1.84),('14598','2013-01-05','11:00:00',1.74),('14598','2013-01-05','11:05:00',1.96),('14598','2013-01-05','11:10:00',2.17),('14598','2013-01-05','11:15:00',2.4),('14598','2013-01-05','11:20:00',2.39),('14598','2013-01-05','11:25:00',2.54),('14598','2013-01-05','11:30:00',2.52),('14598','2013-01-05','11:35:00',2.65),('14598','2013-01-05','11:40:00',2.62),('14598','2013-01-05','11:45:00',2.5),('14598','2013-01-05','11:50:00',2.46),('14598','2013-01-05','11:55:00',2.38),('14598','2013-01-05','12:00:00',2.43),('14598','2013-01-05','12:05:00',2.18),('14598','2013-01-05','12:10:00',2.34),('14598','2013-01-05','12:15:00',2.58),('14598','2013-01-05','12:20:00',2.39),('14598','2013-01-05','12:25:00',2.35),('14598','2013-01-05','12:30:00',2.09),('14598','2013-01-05','12:35:00',1.93),('14598','2013-01-05','12:40:00',1.96),('14598','2013-01-05','12:45:00',2.58),('14598','2013-01-05','12:50:00',2.37),('14598','2013-01-05','12:55:00',2.5),('14598','2013-01-05','13:00:00',3.09),('14598','2013-01-05','13:05:00',3),('14598','2013-01-05','13:10:00',2.86),('14598','2013-01-05','13:15:00',1.62),('14598','2013-01-05','13:20:00',2.07),('14598','2013-01-05','13:25:00',2.65),('14598','2013-01-05','13:30:00',2.73),('14598','2013-01-05','13:35:00',2.9),('14598','2013-01-05','13:40:00',2.86),('14598','2013-01-05','13:45:00',2.45),('14598','2013-01-05','13:50:00',2.6),('14598','2013-01-05','13:55:00',2.23),('14598','2013-01-05','14:00:00',2.56),('14598','2013-01-05','14:05:00',2.6),('14598','2013-01-05','14:10:00',2.54),('14598','2013-01-05','14:15:00',2.62),('14598','2013-01-05','14:20:00',2.46),('14598','2013-01-05','14:25:00',2.44),('14598','2013-01-05','14:30:00',2.34),('14598','2013-01-05','14:35:00',1.77),('14598','2013-01-05','14:40:00',2.08),('14598','2013-01-05','14:45:00',2.08),('14598','2013-01-05','14:50:00',1.55),('14598','2013-01-05','14:55:00',1.6),('14598','2013-01-05','15:00:00',1.84),('14598','2013-01-05','15:05:00',1.79),('14598','2013-01-05','15:10:00',1.9),('14598','2013-01-05','15:15:00',1.8),('14598','2013-01-05','15:20:00',1.76),('14598','2013-01-05','15:25:00',1.46),('14598','2013-01-05','15:30:00',1.26),('14598','2013-01-05','15:35:00',1.09),('14598','2013-01-05','15:40:00',1.2),('14598','2013-01-05','15:45:00',1.11),('14598','2013-01-04','09:30:00',1.11),('14598','2013-01-04','09:35:00',1.12),('14598','2013-01-04','09:40:00',1.23),('14598','2013-01-04','09:45:00',1.42),('14598','2013-01-04','09:50:00',1.34),('14598','2013-01-04','09:55:00',1.68),('14598','2013-01-04','10:00:00',1.92),('14598','2013-01-04','10:05:00',2.15),('14598','2013-01-04','10:10:00',2.08),('14598','2013-01-04','10:15:00',2.01),('14598','2013-01-04','10:20:00',1.71),('14598','2013-01-04','10:25:00',1.29),('14598','2013-01-04','10:30:00',1.13),('14598','2013-01-04','10:35:00',1.43),('14598','2013-01-04','10:40:00',2.2),('14598','2013-01-04','10:45:00',1.49),('14598','2013-01-04','10:50:00',1.75),('14598','2013-01-04','10:55:00',2.52),('14598','2013-01-04','11:00:00',2.71),('14598','2013-01-04','11:05:00',2.92),('14598','2013-01-04','11:10:00',3.05),('14598','2013-01-04','11:15:00',3.12),('14598','2013-01-04','11:20:00',2.56),('14598','2013-01-04','11:25:00',1.41),('14598','2013-01-04','11:30:00',1.1),('14598','2013-01-04','11:40:00',1.22),('14598','2013-01-04','11:45:00',1.61),('14598','2013-01-04','11:50:00',2.39),('14598','2013-01-04','11:55:00',1.31),('14598','2013-01-04','12:00:00',1.55),('14598','2013-01-04','12:05:00',2.99),('14598','2013-01-04','12:10:00',2.56),('14598','2013-01-04','12:15:00',2.29),('14598','2013-01-04','12:20:00',1.84),('14598','2013-01-04','12:25:00',1.36),('14598','2013-01-04','12:30:00',1.62),('14598','2013-01-04','12:35:00',1.45),('14598','2013-01-04','12:40:00',2.25),('14598','2013-01-04','12:45:00',2.88),('14598','2013-01-04','12:50:00',3.06),('14598','2013-01-04','12:55:00',3.17),('14598','2013-01-04','13:00:00',3.14),('14598','2013-01-04','13:05:00',3.02),('14598','2013-01-04','13:10:00',2.82),('14598','2013-01-04','13:15:00',1.96),('14598','2013-01-04','13:20:00',1.86),('14598','2013-01-04','13:25:00',2.7),('14598','2013-01-04','13:30:00',2.68),('14598','2013-01-04','13:35:00',2.65),('14598','2013-01-04','13:40:00',2.6),('14598','2013-01-04','13:45:00',2.58),('14598','2013-01-04','13:50:00',2.56),('14598','2013-01-04','13:55:00',2.53),('14598','2013-01-04','14:00:00',2.48),('14598','2013-01-04','14:05:00',2.44),('14598','2013-01-04','14:10:00',2.41),('14598','2013-01-04','14:15:00',2.4),('14598','2013-01-04','14:20:00',2.34),('14598','2013-01-04','14:25:00',2.28),('14598','2013-01-04','14:30:00',2.22),('14598','2013-01-04','14:35:00',2.19),('14598','2013-01-04','14:40:00',2.13),('14598','2013-01-04','14:45:00',2.06),('14598','2013-01-04','14:50:00',2.01),('14598','2013-01-04','14:55:00',1.94),('14598','2013-01-04','15:00:00',1.86),('14598','2013-01-04','15:05:00',1.8),('14598','2013-01-04','15:10:00',1.74),('14598','2013-01-04','15:15:00',1.67),('14598','2013-01-04','15:20:00',1.6),('14598','2013-01-04','15:25:00',1.5),('14598','2013-01-04','15:30:00',1.41),('14598','2013-01-04','15:35:00',1.33),('14598','2013-01-04','15:50:00',1.13),('14598','2013-01-04','15:55:00',1.13),('14598','2013-01-04','16:00:00',1.02),('14598','2013-01-03','09:25:00',1.01),('14598','2013-01-03','09:30:00',1.11),('14598','2013-01-03','09:35:00',1.22),('14598','2013-01-03','09:40:00',1.36),('14598','2013-01-03','09:45:00',1.52),('14598','2013-01-03','09:50:00',1.67),('14598','2013-01-03','09:55:00',1.77),('14598','2013-01-03','10:00:00',1.93),('14598','2013-01-03','10:05:00',2.02),('14598','2013-01-03','10:10:00',2.3),('14598','2013-01-03','10:15:00',1.72),('14598','2013-01-03','10:20:00',2.24),('14598','2013-01-03','10:25:00',2.01),('14598','2013-01-03','10:30:00',1.98),('14598','2013-01-03','10:35:00',1.72),('14598','2013-01-03','10:40:00',1.71),('14598','2013-01-03','10:45:00',1.56),('14598','2013-01-03','10:50:00',1.6),('14598','2013-01-03','10:55:00',1.75),('14598','2013-01-03','11:00:00',1.72),('14598','2013-01-03','11:05:00',1.89),('14598','2013-01-03','11:10:00',2.27),('14598','2013-01-03','11:15:00',2.43),('14598','2013-01-03','11:20:00',2.14),('14598','2013-01-03','11:25:00',2.26),('14598','2013-01-03','11:30:00',2.79),('14598','2013-01-03','11:35:00',2.64),('14598','2013-01-03','11:40:00',2.69),('14598','2013-01-03','11:45:00',2.72),('14598','2013-01-03','11:50:00',2.73),('14598','2013-01-03','11:55:00',2.75),('14598','2013-01-03','12:00:00',2.76),('14598','2013-01-03','12:05:00',2.78),('14598','2013-01-03','12:10:00',2.8),('14598','2013-01-03','12:15:00',2.8),('14598','2013-01-03','12:20:00',2.8),('14598','2013-01-03','12:25:00',2.82),('14598','2013-01-03','12:30:00',2.84),('14598','2013-01-03','12:35:00',2.84),('14598','2013-01-03','12:40:00',2.83),('14598','2013-01-03','12:45:00',2.83),('14598','2013-01-03','12:50:00',2.83),('14598','2013-01-03','12:55:00',2.81),('14598','2013-01-03','13:00:00',2.8),('14598','2013-01-03','13:05:00',2.79),('14598','2013-01-03','13:10:00',2.76),('14598','2013-01-03','13:15:00',2.77),('14598','2013-01-03','13:20:00',2.72),('14598','2013-01-03','13:25:00',2.71),('14598','2013-01-03','13:30:00',2.7),('14598','2013-01-03','13:35:00',2.66),('14598','2013-01-03','13:40:00',2.64),('14598','2013-01-03','13:45:00',2.61),('14598','2013-01-03','13:50:00',2.57),('14598','2013-01-03','13:55:00',2.53),('14598','2013-01-03','14:00:00',2.48),('14598','2013-01-03','14:05:00',2.45),('14598','2013-01-03','14:10:00',2.39),('14598','2013-01-03','14:15:00',2.35),('14598','2013-01-03','14:20:00',2.31),('14598','2013-01-03','14:25:00',2.24),('14598','2013-01-03','14:30:00',2.18),('14598','2013-01-03','14:35:00',2.11),('14598','2013-01-03','14:40:00',2.07),('14598','2013-01-03','14:45:00',2.01),('14598','2013-01-03','14:50:00',1.95),('14598','2013-01-03','14:55:00',1.9),('14598','2013-01-03','15:00:00',1.83),('14598','2013-01-03','15:05:00',1.74),('14598','2013-01-03','15:10:00',1.63),('14598','2013-01-03','15:15:00',1.57),('14598','2013-01-03','15:20:00',1.52),('14598','2013-01-03','15:25:00',1.43),('14598','2013-01-03','15:30:00',1.36),('14598','2013-01-03','15:35:00',1.2),('14598','2013-01-03','15:40:00',1.05),('14598','2013-01-02','10:35:00',1.08),('14598','2013-01-02','10:40:00',1.02),('14598','2013-01-02','10:55:00',1.07),('14598','2013-01-02','11:00:00',1.46),('14598','2013-01-02','11:05:00',1.87),('14598','2013-01-02','11:10:00',1.82),('14598','2013-01-02','11:15:00',1.89),('14598','2013-01-02','11:20:00',2),('14598','2013-01-02','11:25:00',2.06),('14598','2013-01-02','11:30:00',2.01),('14598','2013-01-02','11:35:00',1.63),('14598','2013-01-02','11:40:00',1.32),('14598','2013-01-02','11:45:00',1.02),('14598','2013-01-02','11:50:00',1.17),('14598','2013-01-02','11:55:00',1.4),('14598','2013-01-02','12:00:00',1.48),('14598','2013-01-02','12:05:00',1.57),('14598','2013-01-02','12:10:00',1.56),('14598','2013-01-02','12:15:00',1.68),('14598','2013-01-02','12:20:00',1.63),('14598','2013-01-02','12:25:00',1.46),('14598','2013-01-02','12:30:00',1.42),('14598','2013-01-02','12:35:00',1.4),('14598','2013-01-02','12:40:00',1.61),('14598','2013-01-02','12:45:00',1.8),('14598','2013-01-02','12:50:00',1.83),('14598','2013-01-02','12:55:00',2.03),('14598','2013-01-02','13:00:00',2.6),('14598','2013-01-02','13:05:00',2.54),('14598','2013-01-02','13:10:00',2.19),('14598','2013-01-02','13:15:00',1.63),('14598','2013-01-02','13:20:00',1.38),('14598','2013-01-02','13:25:00',1.55),('14598','2013-01-02','13:30:00',1.66),('14598','2013-01-02','13:35:00',1.68),('14598','2013-01-02','13:40:00',1.64),('14598','2013-01-02','13:45:00',1.39),('14598','2013-01-02','13:50:00',1.15),('14598','2013-01-02','13:55:00',1.06),('14598','2014-03-18','08:05:00',1.05),('14598','2014-03-18','08:10:00',1.26),('14598','2014-03-18','08:15:00',1.35),('14598','2014-03-18','08:20:00',1.4),('14598','2014-03-18','08:25:00',1.35),('14598','2014-03-18','08:30:00',1.65),('14598','2014-03-18','08:35:00',1.7),('14598','2014-03-18','08:40:00',1.76),('14598','2014-03-18','08:45:00',1.86),('14598','2014-03-18','08:50:00',2),('14598','2014-03-18','08:55:00',2.08),('14598','2014-03-18','09:00:00',2),('14598','2014-03-18','09:05:00',2.22),('14598','2014-03-18','09:10:00',2.39),('14598','2014-03-18','09:15:00',2.52),('14598','2014-03-18','09:20:00',2.6),('14598','2014-03-18','09:25:00',2.64),('14598','2014-03-18','09:30:00',2.8),('14598','2014-03-18','09:35:00',2.55),('14598','2014-03-18','09:40:00',3.12),('14598','2014-03-18','09:45:00',2.98),('14598','2014-03-18','09:50:00',3.02),('14598','2014-03-18','09:55:00',3.13),('14598','2014-03-18','10:00:00',3.21),('14598','2014-03-18','10:05:00',3.17),('14598','2014-03-18','10:10:00',3.18),('14598','2014-03-18','10:15:00',3.43),('14598','2014-03-18','10:20:00',3.53),('14598','2014-03-18','10:25:00',3.6),('14598','2014-03-18','10:30:00',3.68),('14598','2014-03-18','10:35:00',3.72),('14598','2014-03-18','10:40:00',3.77),('14598','2014-03-18','10:45:00',3.85),('14598','2014-03-18','10:50:00',3.9),('14598','2014-03-18','10:55:00',3.94),('14598','2014-03-18','11:00:00',4),('14598','2014-03-18','11:05:00',4.02),('14598','2014-03-18','11:10:00',4.1),('14598','2014-03-18','11:15:00',4.11),('14598','2014-03-18','11:20:00',4.16),('14598','2014-03-18','11:25:00',4.19),('14598','2014-03-18','11:30:00',4.25),('14598','2014-03-18','11:35:00',4.27),('14598','2014-03-18','11:40:00',4.3),('14598','2014-03-18','11:45:00',4.32),('14598','2014-03-18','11:50:00',4.34),('14598','2014-03-18','11:55:00',4.39),('14598','2014-03-18','12:00:00',4.41),('14598','2014-03-18','12:05:00',4.39),('14598','2014-03-18','12:10:00',4.46),('14598','2014-03-18','12:15:00',4.5),('14598','2014-03-18','12:20:00',4.46),('14598','2014-03-18','12:25:00',4.52),('14598','2014-03-18','12:30:00',4.52),('14598','2014-03-18','12:35:00',4.53),('14598','2014-03-18','12:40:00',4.55),('14598','2014-03-18','12:45:00',4.53),('14598','2014-03-18','12:50:00',4.53),('14598','2014-03-18','12:55:00',4.51),('14598','2014-03-18','13:00:00',4.54),('14598','2014-03-18','13:05:00',4.52),('14598','2014-03-18','13:10:00',4.5),('14598','2014-03-18','13:15:00',4.5),('14598','2014-03-18','13:20:00',4.45),('14598','2014-03-18','13:25:00',4.45),('14598','2014-03-18','13:30:00',4.41),('14598','2014-03-18','13:35:00',4.4),('14598','2014-03-18','13:40:00',4.36),('14598','2014-03-18','13:45:00',4.34),('14598','2014-03-18','13:50:00',4.31),('14598','2014-03-18','13:55:00',4.29),('14598','2014-03-18','14:00:00',4.24),('14598','2014-03-18','14:05:00',4.24),('14598','2014-03-18','14:10:00',4.13),('14598','2014-03-18','14:15:00',4.11),('14598','2014-03-18','14:20:00',4.05),('14598','2014-03-18','14:25:00',4.07),('14598','2014-03-18','14:30:00',4),('14598','2014-03-18','14:35:00',3.94),('14598','2014-03-18','14:40:00',3.91),('14598','2014-03-18','14:45:00',3.83),('14598','2014-03-18','14:50:00',3.67),('14598','2014-03-18','14:55:00',3.71),('14598','2014-03-18','15:00:00',3.63),('14598','2014-03-18','15:05:00',3.56),('14598','2014-03-18','15:10:00',3.44),('14598','2014-03-18','15:15:00',3.44),('14598','2014-03-18','15:20:00',3.47),('14598','2014-03-18','15:25:00',2.94),('14598','2014-03-18','15:30:00',3.25),('14598','2014-03-18','15:35:00',3.25),('14598','2014-03-18','15:40:00',3.05),('14598','2014-03-18','15:45:00',2.98),('14598','2014-03-18','15:50:00',2.92),('14598','2014-03-18','15:55:00',2.83),('14598','2014-03-18','16:00:00',2.71),('14598','2014-03-18','16:05:00',2.64),('14598','2014-03-18','16:10:00',2.5),('14598','2014-03-18','16:15:00',2.44),('14598','2014-03-18','16:20:00',2.3),('14598','2014-03-18','16:25:00',2.21),('14598','2014-03-18','16:30:00',2.04),('14598','2014-03-18','16:35:00',2.01),('14598','2014-03-18','16:40:00',1.72),('14598','2014-03-18','16:45:00',1.77),('14598','2014-03-18','16:50:00',1.69),('14598','2014-03-18','16:55:00',1.56),('14598','2014-03-18','17:00:00',1.46),('14598','2014-03-18','17:05:00',1.34),('14598','2014-03-18','17:10:00',1.16),('14598','2014-03-18','17:15:00',1.08),('14598','2013-01-01','09:10:00',1.01),('14598','2013-01-01','09:15:00',1),('14598','2013-01-01','09:20:00',1.02),('14598','2013-01-01','09:25:00',1.15),('14598','2013-01-01','09:30:00',1.08),('14598','2013-01-01','09:35:00',1.2),('14598','2013-01-01','09:40:00',1.29),('14598','2013-01-01','09:45:00',1.42),('14598','2013-01-01','09:50:00',1.55),('14598','2013-01-01','09:55:00',1.65),('14598','2013-01-01','10:00:00',2.16),('14598','2013-01-01','10:05:00',1.69),('14598','2013-01-01','10:10:00',1.38),('14598','2013-01-01','10:15:00',1.12),('14598','2013-01-01','10:40:00',1.16),('14598','2013-01-01','10:45:00',1.33),('14598','2013-01-01','10:50:00',1.54),('14598','2013-01-01','10:55:00',1.28),('14598','2013-01-01','11:00:00',1.52),('14598','2013-01-01','11:05:00',2.04),('14598','2013-01-01','11:10:00',2.55),('14598','2013-01-01','11:15:00',2.83),('14598','2013-01-01','11:20:00',2.51),('14598','2013-01-01','11:25:00',2),('14598','2013-01-01','11:30:00',2.03),('14598','2013-01-01','11:35:00',2.88),('14598','2013-01-01','11:40:00',1.4),('14598','2013-01-01','11:45:00',1.19),('14598','2013-01-01','11:50:00',1.1),('14598','2013-01-01','11:55:00',1.1),('14598','2013-01-01','12:00:00',1.05),('14598','2013-01-01','13:55:00',1.16),('14598','2013-01-01','14:00:00',1.28),('14598','2013-01-01','14:05:00',1.76),('14598','2013-01-01','14:10:00',1.03),('14598','2013-01-01','14:15:00',1.42),('14598','2013-01-01','14:20:00',1.62),('14598','2013-01-01','14:25:00',1.4),('14598','2013-01-01','14:30:00',1.43),('14598','2012-12-31','09:25:00',1.1),('14598','2012-12-31','09:30:00',1.19),('14598','2012-12-31','09:35:00',1.29),('14598','2012-12-31','09:40:00',1.41),('14598','2012-12-31','09:45:00',1.33),('14598','2012-12-31','09:50:00',1.49),('14598','2012-12-31','09:55:00',1.67),('14598','2012-12-31','10:00:00',1.75),('14598','2012-12-31','10:05:00',1.8),('14598','2012-12-31','10:10:00',1.85),('14598','2012-12-31','10:15:00',1.91),('14598','2012-12-31','10:20:00',1.94),('14598','2012-12-31','10:25:00',2),('14598','2012-12-31','10:30:00',2.1),('14598','2012-12-31','10:35:00',2.19),('14598','2012-12-31','10:40:00',2.23),('14598','2012-12-31','10:45:00',2.31),('14598','2012-12-31','10:50:00',2.37),('14598','2012-12-31','10:55:00',2.38),('14598','2012-12-31','11:00:00',2.44),('14598','2012-12-31','11:05:00',2.52),('14598','2012-12-31','11:10:00',2.57),('14598','2012-12-31','11:15:00',2.6),('14598','2012-12-31','11:20:00',2.65),('14598','2012-12-31','11:25:00',2.69),('14598','2012-12-31','11:30:00',2.73),('14598','2012-12-31','11:35:00',2.77),('14598','2012-12-31','11:40:00',2.79),('14598','2012-12-31','11:45:00',2.82),('14598','2012-12-31','11:50:00',2.84),('14598','2012-12-31','11:55:00',2.86),('14598','2012-12-31','12:00:00',2.89),('14598','2012-12-31','12:05:00',2.92),('14598','2012-12-31','12:10:00',2.92),('14598','2012-12-31','12:15:00',2.93),('14598','2012-12-31','12:20:00',2.94),('14598','2012-12-31','12:25:00',2.94),('14598','2012-12-31','12:30:00',2.93),('14598','2012-12-31','12:35:00',2.92),('14598','2012-12-31','12:40:00',2.93),('14598','2012-12-31','12:45:00',2.92),('14598','2012-12-31','12:50:00',2.9),('14598','2012-12-31','12:55:00',2.89),('14598','2012-12-31','13:00:00',2.88),('14598','2012-12-31','13:05:00',2.88),('14598','2012-12-31','13:10:00',2.87),('14598','2012-12-31','13:15:00',2.86),('14598','2012-12-31','13:20:00',2.83),('14598','2012-12-31','13:25:00',2.8),('14598','2012-12-31','13:30:00',2.78),('14598','2012-12-31','13:35:00',2.75),('14598','2012-12-31','13:40:00',2.72),('14598','2012-12-31','13:45:00',2.68),('14598','2012-12-31','13:50:00',2.64),('14598','2012-12-31','13:55:00',2.59),('14598','2012-12-31','14:00:00',2.55),('14598','2012-12-31','14:05:00',2.5),('14598','2012-12-31','14:10:00',2.47),('14598','2012-12-31','14:15:00',2.41),('14598','2012-12-31','14:20:00',2.37),('14598','2012-12-31','14:25:00',2.33),('14598','2012-12-31','14:30:00',2.27),('14598','2012-12-31','14:35:00',2.22),('14598','2012-12-31','14:40:00',2.15),('14598','2012-12-31','14:45:00',2.06),('14598','2012-12-31','14:50:00',1.97),('14598','2012-12-31','14:55:00',1.91),('14598','2012-12-31','15:00:00',1.83),('14598','2012-12-31','15:05:00',1.73),('14598','2012-12-31','15:10:00',1.64),('14598','2012-12-31','15:15:00',1.54),('14598','2012-12-31','15:20:00',1.48),('14598','2012-12-31','15:25:00',1.41),('14598','2012-12-31','15:30:00',1.31),('14598','2012-12-31','15:35:00',1.22),('14598','2012-12-31','15:40:00',1.14),('14598','2012-12-31','15:45:00',1.05),('14598','2012-12-30','09:25:00',1.02),('14598','2012-12-30','09:30:00',1.11),('14598','2012-12-30','09:35:00',1.21),('14598','2012-12-30','09:40:00',1.32),('14598','2012-12-30','09:45:00',1.42),('14598','2012-12-30','09:50:00',1.51),('14598','2012-12-30','09:55:00',1.59),('14598','2012-12-30','10:00:00',1.67),('14598','2012-12-30','10:05:00',1.75),('14598','2012-12-30','10:10:00',1.83),('14598','2012-12-30','10:15:00',1.9),('14598','2012-12-30','10:20:00',1.97),('14598','2012-12-30','10:25:00',2.04),('14598','2012-12-30','10:30:00',2.1),('14598','2012-12-30','10:35:00',2.17),('14598','2012-12-30','10:40:00',2.23),('14598','2012-12-30','10:45:00',2.28),('14598','2012-12-30','10:50:00',2.34),('14598','2012-12-30','10:55:00',2.39),('14598','2012-12-30','11:00:00',2.44),('14598','2012-12-30','11:05:00',2.49),('14598','2012-12-30','11:10:00',2.54),('14598','2012-12-30','11:15:00',2.58),('14598','2012-12-30','11:20:00',2.63),('14598','2012-12-30','11:25:00',2.67),('14598','2012-12-30','11:30:00',2.69),('14598','2012-12-30','11:35:00',2.74),('14598','2012-12-30','11:40:00',2.77),('14598','2012-12-30','11:45:00',2.81),('14598','2012-12-30','11:50:00',2.84),('14598','2012-12-30','11:55:00',2.85),('14598','2012-12-30','12:00:00',2.89),('14598','2012-12-30','12:05:00',2.91),('14598','2012-12-30','12:10:00',2.93),('14598','2012-12-30','12:15:00',2.93),('14598','2012-12-30','12:20:00',2.94),('14598','2012-12-30','12:25:00',2.95),('14598','2012-12-30','12:30:00',2.95),('14598','2012-12-30','12:35:00',2.93),('14598','2012-12-30','12:40:00',2.92),('14598','2012-12-30','12:45:00',2.9),('14598','2012-12-30','12:50:00',2.9),('14598','2012-12-30','12:55:00',2.9),('14598','2012-12-30','13:00:00',2.88),('14598','2012-12-30','13:05:00',2.88),('14598','2012-12-30','13:10:00',2.86),('14598','2012-12-30','13:15:00',2.83),('14598','2012-12-30','13:20:00',2.83),('14598','2012-12-30','13:25:00',2.81),('14598','2012-12-30','13:30:00',2.81),('14598','2012-12-30','13:35:00',2.79),('14598','2012-12-30','13:40:00',2.75),('14598','2012-12-30','13:45:00',2.72),('14598','2012-12-30','13:50:00',2.68),('14598','2012-12-30','13:55:00',2.64),('14598','2012-12-30','14:00:00',2.59),('14598','2012-12-30','14:05:00',2.54),('14598','2012-12-30','14:10:00',2.5),('14598','2012-12-30','14:15:00',2.45),('14598','2012-12-30','14:20:00',2.4),('14598','2012-12-30','14:25:00',2.34),('14598','2012-12-30','14:30:00',2.25),('14598','2012-12-30','14:35:00',2.22),('14598','2012-12-30','14:40:00',2.15),('14598','2012-12-30','14:45:00',2.09),('14598','2012-12-30','14:50:00',2.02),('14598','2012-12-30','14:55:00',1.95),('14598','2012-12-30','15:00:00',1.88),('14598','2012-12-30','15:05:00',1.8),('14598','2012-12-30','15:10:00',1.73),('14598','2012-12-30','15:15:00',1.65),('14598','2012-12-30','15:20:00',1.57),('14598','2012-12-30','15:25:00',1.48),('14598','2012-12-30','15:30:00',1.39),('14598','2012-12-30','15:35:00',1.3),('14598','2012-12-30','15:40:00',1.2),('14598','2012-12-30','15:45:00',1.1),('14598','2012-12-30','15:50:00',1),('14598','2012-12-29','09:25:00',1.04),('14598','2012-12-29','09:30:00',1.13),('14598','2012-12-29','09:35:00',1.22),('14598','2012-12-29','09:40:00',1.33),('14598','2012-12-29','09:45:00',1.43),('14598','2012-12-29','09:50:00',1.52),('14598','2012-12-29','09:55:00',1.59),('14598','2012-12-29','10:00:00',1.67),('14598','2012-12-29','10:05:00',1.75),('14598','2012-12-29','10:10:00',1.82),('14598','2012-12-29','10:15:00',1.89),('14598','2012-12-29','10:20:00',1.97),('14598','2012-12-29','10:25:00',2.04),('14598','2012-12-29','10:30:00',2.1),('14598','2012-12-29','10:35:00',2.16),('14598','2012-12-29','10:40:00',2.22),('14598','2012-12-29','10:45:00',2.28),('14598','2012-12-29','10:50:00',2.33),('14598','2012-12-29','10:55:00',2.38),('14598','2012-12-29','11:00:00',2.44),('14598','2012-12-29','11:05:00',2.48),('14598','2012-12-29','11:10:00',2.53),('14598','2012-12-29','11:15:00',2.58),('14598','2012-12-29','11:20:00',2.62),('14598','2012-12-29','11:25:00',2.67),('14598','2012-12-29','11:30:00',2.7),('14598','2012-12-29','11:35:00',2.75),('14598','2012-12-29','11:40:00',2.78),('14598','2012-12-29','11:45:00',2.8),('14598','2012-12-29','11:50:00',2.82),('14598','2012-12-29','11:55:00',2.84),('14598','2012-12-29','12:00:00',2.85),('14598','2012-12-29','12:05:00',2.89),('14598','2012-12-29','12:10:00',2.91),('14598','2012-12-29','12:15:00',2.93),('14598','2012-12-29','12:20:00',2.92),('14598','2012-12-29','12:25:00',2.92),('14598','2012-12-29','12:30:00',2.92),('14598','2012-12-29','12:35:00',2.92),('14598','2012-12-29','12:40:00',2.92),('14598','2012-12-29','12:45:00',2.87),('14598','2012-12-29','12:50:00',2.88),('14598','2012-12-29','12:55:00',2.86),('14598','2012-12-29','13:00:00',2.85),('14598','2012-12-29','13:05:00',2.86),('14598','2012-12-29','13:10:00',2.85),('14598','2012-12-29','13:15:00',2.83),('14598','2012-12-29','13:20:00',2.81),('14598','2012-12-29','13:25:00',2.8),('14598','2012-12-29','13:30:00',2.8),('14598','2012-12-29','13:35:00',2.77),('14598','2012-12-29','13:40:00',2.75),('14598','2012-12-29','13:45:00',2.72),('14598','2012-12-29','13:50:00',2.68),('14598','2012-12-29','13:55:00',2.65),('14598','2012-12-29','14:00:00',2.62),('14598','2012-12-29','14:05:00',2.57),('14598','2012-12-29','14:10:00',2.53),('14598','2012-12-29','14:15:00',2.47),('14598','2012-12-29','14:20:00',2.42),('14598','2012-12-29','14:25:00',2.37),('14598','2012-12-29','14:30:00',2.3),('14598','2012-12-29','14:35:00',2.23),('14598','2012-12-29','14:40:00',2.15),('14598','2012-12-29','14:45:00',2.08),('14598','2012-12-29','14:50:00',2.02),('14598','2012-12-29','14:55:00',1.95),('14598','2012-12-29','15:00:00',1.87),('14598','2012-12-29','15:05:00',1.8),('14598','2012-12-29','15:10:00',1.73),('14598','2012-12-29','15:15:00',1.65),('14598','2012-12-29','15:20:00',1.56),('14598','2012-12-29','15:25:00',1.47),('14598','2012-12-29','15:30:00',1.39),('14598','2012-12-29','15:35:00',1.31),('14598','2012-12-29','15:40:00',1.19),('14598','2012-12-29','15:45:00',1.09),('14598','2012-12-29','15:50:00',1.01),('14598','2012-12-28','09:30:00',1.04),('14598','2012-12-28','09:35:00',1.13),('14598','2012-12-28','09:40:00',1.25),('14598','2012-12-28','09:45:00',1.35),('14598','2012-12-28','09:50:00',1.44),('14598','2012-12-28','09:55:00',1.52),('14598','2012-12-28','10:00:00',1.61),('14598','2012-12-28','10:05:00',1.69),('14598','2012-12-28','10:10:00',1.74),('14598','2012-12-28','10:15:00',1.8),('14598','2012-12-28','10:20:00',1.87),('14598','2012-12-28','10:25:00',1.94),('14598','2012-12-28','10:30:00',2),('14598','2012-12-28','10:35:00',2.06),('14598','2012-12-28','10:40:00',2.11),('14598','2012-12-28','10:45:00',2.13),('14598','2012-12-28','10:50:00',2.21),('14598','2012-12-28','10:55:00',2.28),('14598','2012-12-28','11:00:00',2.33),('14598','2012-12-28','11:05:00',2.37),('14598','2012-12-28','11:10:00',2.43),('14598','2012-12-28','11:15:00',2.47),('14598','2012-12-28','11:20:00',2.53),('14598','2012-12-28','11:25:00',2.58),('14598','2012-12-28','11:30:00',2.63),('14598','2012-12-28','11:35:00',2.65),('14598','2012-12-28','11:40:00',2.69),('14598','2012-12-28','11:45:00',2.73),('14598','2012-12-28','11:50:00',2.76),('14598','2012-12-28','11:55:00',2.79),('14598','2012-12-28','12:00:00',2.8),('14598','2012-12-28','12:05:00',2.86),('14598','2012-12-28','12:10:00',2.86),('14598','2012-12-28','12:15:00',2.86),('14598','2012-12-28','12:20:00',2.87),('14598','2012-12-28','12:25:00',2.87),('14598','2012-12-28','12:30:00',2.85),('14598','2012-12-28','12:35:00',2.87),('14598','2012-12-28','12:40:00',2.87),('14598','2012-12-28','12:45:00',2.87),('14598','2012-12-28','12:50:00',2.86),('14598','2012-12-28','12:55:00',2.85),('14598','2012-12-28','13:00:00',2.84),('14598','2012-12-28','13:05:00',2.82),('14598','2012-12-28','13:10:00',2.79),('14598','2012-12-28','13:15:00',2.78),('14598','2012-12-28','13:20:00',2.77),('14598','2012-12-28','13:25:00',2.76),('14598','2012-12-28','13:30:00',2.74),('14598','2012-12-28','13:35:00',2.71),('14598','2012-12-28','13:40:00',2.68),('14598','2012-12-28','13:45:00',2.65),('14598','2012-12-28','13:50:00',2.62),('14598','2012-12-28','13:55:00',2.58),('14598','2012-12-28','14:00:00',2.54),('14598','2012-12-28','14:05:00',2.5),('14598','2012-12-28','14:10:00',2.45),('14598','2012-12-28','14:15:00',2.38),('14598','2012-12-28','14:20:00',2.32),('14598','2012-12-28','14:25:00',2.27),('14598','2012-12-28','14:30:00',2.2),('14598','2012-12-28','14:35:00',2.15),('14598','2012-12-28','14:40:00',2.08),('14598','2012-12-28','14:45:00',2.01),('14598','2012-12-28','14:50:00',1.93),('14598','2012-12-28','14:55:00',1.85),('14598','2012-12-28','15:00:00',1.77),('14598','2012-12-28','15:05:00',1.69),('14598','2012-12-28','15:10:00',1.63),('14598','2012-12-28','15:15:00',1.55),('14598','2012-12-28','15:20:00',1.46),('14598','2012-12-28','15:25:00',1.38),('14598','2012-12-28','15:30:00',1.3),('14598','2012-12-28','15:35:00',1.21),('14598','2012-12-28','15:40:00',1.12),('14598','2012-12-28','15:45:00',1.03),('14598','2012-12-27','09:30:00',1.26),('14598','2012-12-27','09:35:00',1),('14598','2012-12-27','09:40:00',1.15),('14598','2012-12-27','09:45:00',1.41),('14598','2012-12-27','09:50:00',1.32),('14598','2012-12-27','10:05:00',1.12),('14598','2012-12-27','10:10:00',1.35),('14598','2012-12-27','10:15:00',1.82),('14598','2012-12-27','10:20:00',1.82),('14598','2012-12-27','10:25:00',1.8),('14598','2012-12-27','10:30:00',1.9),('14598','2012-12-27','10:35:00',1.99),('14598','2012-12-27','10:40:00',2.03),('14598','2012-12-27','10:45:00',2.02),('14598','2012-12-27','10:50:00',2.14),('14598','2012-12-27','10:55:00',2.2),('14598','2012-12-27','11:00:00',2.23),('14598','2012-12-27','11:05:00',2.26),('14598','2012-12-27','11:10:00',2.28),('14598','2012-12-27','11:15:00',2.31),('14598','2012-12-27','11:20:00',2.39),('14598','2012-12-27','11:25:00',2.46),('14598','2012-12-27','11:30:00',2.49),('14598','2012-12-27','11:35:00',2.51),('14598','2012-12-27','11:40:00',2.45),('14598','2012-12-27','11:45:00',2.48),('14598','2012-12-27','11:50:00',2.95),('14598','2012-12-27','11:55:00',1.06),('14598','2012-12-27','12:00:00',1.95),('14598','2012-12-27','12:05:00',3.15),('14598','2012-12-27','12:10:00',2.95),('14598','2012-12-27','12:15:00',2.86),('14598','2012-12-27','12:20:00',2.86),('14598','2012-12-27','12:25:00',2.83),('14598','2012-12-27','12:30:00',2.8),('14598','2012-12-27','12:35:00',2.77),('14598','2012-12-27','12:40:00',2.78),('14598','2012-12-27','12:45:00',2.81),('14598','2012-12-27','12:50:00',2.77),('14598','2012-12-27','12:55:00',2.73),('14598','2012-12-27','13:00:00',2.83),('14598','2012-12-27','13:05:00',2.19),('14598','2012-12-27','13:10:00',2.84),('14598','2012-12-27','13:15:00',2.73),('14598','2012-12-27','13:20:00',2.68),('14598','2012-12-27','13:25:00',2.68),('14598','2012-12-27','13:30:00',2.68),('14598','2012-12-27','13:35:00',2.6),('14598','2012-12-27','13:40:00',2.59),('14598','2012-12-27','13:45:00',2.56),('14598','2012-12-27','13:50:00',2.54),('14598','2012-12-27','13:55:00',1.25),('14598','2012-12-27','14:00:00',1.06),('14598','2012-12-27','14:05:00',1.51),('14598','2012-12-27','14:10:00',2.4),('14598','2012-12-27','14:15:00',2.28),('14598','2012-12-27','14:20:00',2.1),('14598','2012-12-27','14:25:00',2.25),('14598','2012-12-27','14:30:00',1.96),('14598','2012-12-27','14:35:00',2.1),('14598','2012-12-27','14:40:00',2.06),('14598','2012-12-27','14:45:00',2.01),('14598','2012-12-27','14:50:00',1.93),('14598','2012-12-27','14:55:00',1.85),('14598','2012-12-27','15:00:00',1.79),('14598','2012-12-27','15:05:00',1.73),('14598','2012-12-27','15:10:00',1.67),('14598','2012-12-27','15:15:00',1.58),('14598','2012-12-27','15:20:00',1.51),('14598','2012-12-27','15:25:00',1.45),('14598','2012-12-27','15:30:00',1.33),('14598','2012-12-27','15:35:00',1.28),('14598','2012-12-27','15:40:00',1.1),('14598','2012-12-26','09:30:00',1.05),('14598','2012-12-26','09:35:00',1.13),('14598','2012-12-26','09:40:00',1.25),('14598','2012-12-26','09:45:00',1.36),('14598','2012-12-26','09:50:00',1.43),('14598','2012-12-26','09:55:00',1.05),('14598','2012-12-26','10:05:00',1.8),('14598','2012-12-26','10:10:00',1.99),('14598','2012-12-26','10:15:00',1.65),('14598','2012-12-26','10:20:00',1.96),('14598','2012-12-26','10:25:00',1.95),('14598','2012-12-26','10:30:00',1.64),('14598','2012-12-26','10:35:00',1.6),('14598','2012-12-26','10:40:00',2.34),('14598','2012-12-26','10:45:00',2.25),('14598','2012-12-26','10:50:00',2.13),('14598','2012-12-26','10:55:00',2.33),('14598','2012-12-26','11:00:00',2.3),('14598','2012-12-26','11:05:00',2.31),('14598','2012-12-26','11:10:00',2.26),('14598','2012-12-26','11:15:00',1.7),('14598','2012-12-26','11:20:00',3.09),('14598','2012-12-26','11:25:00',2.91),('14598','2012-12-26','11:30:00',3.13),('14598','2012-12-26','11:35:00',2.11),('14598','2012-12-26','11:40:00',1.49),('14598','2012-12-26','11:45:00',1.4),('14598','2012-12-26','11:50:00',1.09),('14598','2012-12-26','12:00:00',1.03),('14598','2012-12-26','12:05:00',1.6),('14598','2012-12-26','12:10:00',1.39),('14598','2012-12-26','12:15:00',1.31),('14598','2012-12-26','12:40:00',1.22),('14598','2012-12-26','12:45:00',1.29),('14598','2012-12-26','13:00:00',2.01),('14598','2012-12-26','13:05:00',1.93),('14598','2012-12-26','13:15:00',1.08),('14598','2012-12-26','13:30:00',1.36),('14598','2012-12-25','12:10:00',1.01),('14598','2012-12-25','12:45:00',1.15),('14598','2012-12-25','12:50:00',1.16),('14598','2012-12-25','12:55:00',1.14),('14598','2012-12-25','13:00:00',1.46),('14598','2012-12-25','13:05:00',1.33),('14598','2012-12-25','13:10:00',1.15),('14598','2012-12-25','13:15:00',1.05),('14598','2012-12-25','13:20:00',1.03),('14598','2012-12-25','13:40:00',1.03),('14598','2012-12-25','13:45:00',1.07),('14598','2012-12-25','13:55:00',1.2),('14598','2012-12-25','14:15:00',1.38),('14598','2012-12-25','14:20:00',1.75),('14598','2012-12-25','14:25:00',1.99),('14598','2012-12-25','14:30:00',1.89),('14598','2012-12-25','14:35:00',1.67),('14598','2012-12-25','14:40:00',1.53),('14598','2012-12-25','14:45:00',1.51),('14598','2012-12-25','14:50:00',1.24),('14598','2012-12-25','14:55:00',1.07),('14598','2012-12-23','09:30:00',1.06),('14598','2012-12-23','09:35:00',1.14),('14598','2012-12-23','09:40:00',1.25),('14598','2012-12-23','09:45:00',1.37),('14598','2012-12-23','09:50:00',1.48),('14598','2012-12-23','09:55:00',1.55),('14598','2012-12-23','10:00:00',1.62),('14598','2012-12-23','10:05:00',1.7),('14598','2012-12-23','10:10:00',1.78),('14598','2012-12-23','10:15:00',1.88),('14598','2012-12-23','10:20:00',1.96),('14598','2012-12-23','10:25:00',2.02),('14598','2012-12-23','10:30:00',2.06),('14598','2012-12-23','10:35:00',2.14),('14598','2012-12-23','10:40:00',2.19),('14598','2012-12-23','10:45:00',2.21),('14598','2012-12-23','10:50:00',2.3),('14598','2012-12-23','10:55:00',2.33),('14598','2012-12-23','11:00:00',2.36),('14598','2012-12-23','11:05:00',2.42),('14598','2012-12-23','11:10:00',2.49),('14598','2012-12-23','11:15:00',2.55),('14598','2012-12-23','11:20:00',2.48),('14598','2012-12-23','11:25:00',2.42),('14598','2012-12-23','11:30:00',2.53),('14598','2012-12-23','11:35:00',2.66),('14598','2012-12-23','11:40:00',2.62),('14598','2012-12-23','11:45:00',2.4),('14598','2012-12-23','11:50:00',2.64),('14598','2012-12-23','11:55:00',2.64),('14598','2012-12-23','12:00:00',2.51),('14598','2012-12-23','12:05:00',1.93),('14598','2012-12-23','12:10:00',2.67),('14598','2012-12-23','12:15:00',2.69),('14598','2012-12-23','12:20:00',2.67),('14598','2012-12-23','12:25:00',2.6),('14598','2012-12-23','12:30:00',2.43),('14598','2012-12-23','12:35:00',2.17),('14598','2012-12-23','12:40:00',2.1),('14598','2012-12-23','12:45:00',2.63),('14598','2012-12-23','12:50:00',2.88),('14598','2012-12-23','12:55:00',2.73),('14598','2012-12-23','13:00:00',2.41),('14598','2012-12-23','13:05:00',2.32),('14598','2012-12-23','13:10:00',2.54),('14598','2012-12-23','13:15:00',2.62),('14598','2012-12-23','13:20:00',2.96),('14598','2012-12-23','13:25:00',2.21),('14598','2012-12-23','13:30:00',2.16),('14598','2012-12-23','13:35:00',2.36),('14598','2012-12-23','13:40:00',1.68),('14598','2012-12-23','13:45:00',1.3),('14598','2012-12-23','13:50:00',2.15),('14598','2012-12-23','13:55:00',2.7),('14598','2012-12-23','14:00:00',2.56),('14598','2012-12-23','14:05:00',2.28),('14598','2012-12-23','14:10:00',1.8),('14598','2012-12-23','14:15:00',1.47),('14598','2012-12-23','14:20:00',1.11),('14598','2012-12-23','14:25:00',1.18),('14598','2012-12-23','14:30:00',1.18),('14598','2012-12-23','14:35:00',1.21),('14598','2012-12-23','14:40:00',1.58),('14598','2012-12-23','14:45:00',1.79),('14598','2012-12-23','14:50:00',1.86),('14598','2012-12-23','14:55:00',2.05),('14598','2012-12-23','15:00:00',1.85),('14598','2012-12-23','15:05:00',1.79),('14598','2012-12-23','15:10:00',1.63),('14598','2012-12-23','15:15:00',1.53),('14598','2012-12-23','15:20:00',1.48),('14598','2012-12-23','15:25:00',1.09),('14598','2012-12-23','15:40:00',1.01),('14598','2012-12-23','15:45:00',1.04),('14598','2014-05-01','08:05:00',1),('14598','2014-05-01','08:10:00',1.08),('14598','2014-05-01','08:15:00',1.21),('14598','2014-05-01','08:20:00',1.3),('14598','2014-05-01','08:25:00',1.4),('14598','2014-05-01','08:30:00',1.38),('14598','2014-05-01','08:35:00',1.67),('14598','2014-05-01','08:40:00',1.75),('14598','2014-05-01','08:45:00',1.72),('14598','2014-05-01','08:50:00',2.11),('14598','2014-05-01','08:55:00',2.15),('14598','2014-05-01','09:00:00',2.24),('14598','2014-05-01','09:05:00',2.34),('14598','2014-05-01','09:10:00',1.85),('14598','2014-05-01','09:15:00',2.9),('14598','2014-05-01','09:20:00',3.12),('14598','2014-05-01','09:25:00',2.89),('14598','2014-05-01','09:30:00',2.55),('14598','2014-05-01','09:35:00',2.83),('14598','2014-05-01','09:40:00',2.29),('14598','2014-05-01','09:45:00',1.21),('14598','2014-05-01','09:50:00',1.45),('14598','2014-05-01','09:55:00',2.18),('14598','2014-05-01','10:00:00',2.61),('14598','2014-05-01','10:05:00',2.85),('14598','2014-05-01','10:10:00',4.58),('14598','2014-05-01','10:15:00',3.72),('14598','2014-05-01','10:20:00',4.26),('14598','2014-05-01','10:25:00',4.64),('14598','2014-05-01','10:30:00',2.77),('14598','2014-05-01','10:35:00',4.02),('14598','2014-05-01','10:40:00',3.67),('14598','2014-05-01','10:45:00',3.44),('14598','2014-05-01','10:50:00',3.58),('14598','2014-05-01','10:55:00',1.7),('14598','2014-05-01','11:00:00',2.6),('14598','2014-05-01','11:05:00',3.23),('14598','2014-05-01','11:10:00',3.51),('14598','2014-05-01','11:15:00',3.21),('14598','2014-05-01','11:20:00',2.46),('14598','2014-05-01','11:25:00',1.09),('14598','2014-05-01','11:30:00',2.12),('14598','2014-05-01','11:35:00',4.51),('14598','2014-05-01','11:40:00',3.17),('14598','2014-05-01','11:45:00',1.69),('14598','2014-05-01','11:50:00',4.36),('14598','2014-05-01','11:55:00',4.9),('14598','2014-05-01','12:00:00',4.96),('14598','2014-05-01','12:05:00',4.94),('14598','2014-05-01','12:10:00',4.93),('14598','2014-05-01','12:15:00',5.01),('14598','2014-05-01','12:20:00',5.03),('14598','2014-05-01','12:25:00',5.06),('14598','2014-05-01','12:30:00',5.09),('14598','2014-05-01','12:35:00',5.13),('14598','2014-05-01','12:40:00',5.16),('14598','2014-05-01','12:45:00',5.16),('14598','2014-05-01','12:50:00',5.15),('14598','2014-05-01','12:55:00',5.17),('14598','2014-05-01','13:00:00',5.21),('14598','2014-05-01','13:05:00',5.24),('14598','2014-05-01','13:10:00',5.23),('14598','2014-05-01','13:15:00',5.22),('14598','2014-05-01','13:20:00',5.25),('14598','2014-05-01','13:25:00',5.25),('14598','2014-05-01','13:30:00',5.26),('14598','2014-05-01','13:35:00',5.23),('14598','2014-05-01','13:40:00',5.24),('14598','2014-05-01','13:45:00',5.23),('14598','2014-05-01','13:50:00',5.22),('14598','2014-05-01','13:55:00',5.1),('14598','2014-05-01','14:00:00',5.17),('14598','2014-05-01','14:05:00',5.17),('14598','2014-05-01','14:10:00',5.13),('14598','2014-05-01','14:15:00',5.13),('14598','2014-05-01','14:20:00',5.11),('14598','2014-05-01','14:25:00',5.13),('14598','2014-05-01','14:30:00',5.06),('14598','2014-05-01','14:35:00',5.12),('14598','2014-05-01','14:40:00',5.08),('14598','2014-05-01','14:45:00',5),('14598','2014-05-01','14:50:00',4.97),('14598','2014-05-01','14:55:00',4.93),('14598','2014-05-01','15:00:00',5.01),('14598','2014-05-01','15:05:00',4.95),('14598','2014-05-01','15:10:00',4.82),('14598','2014-05-01','15:15:00',4.9),('14598','2014-05-01','15:20:00',4.82),('14598','2014-05-01','15:25:00',4.75),('14598','2014-05-01','15:30:00',4.36),('14598','2014-05-01','15:35:00',4.78),('14598','2014-05-01','15:40:00',4.66),('14598','2014-05-01','15:45:00',4.44),('14598','2014-05-01','15:50:00',4.49),('14598','2014-05-01','15:55:00',4.52),('14598','2014-05-01','16:00:00',4.46),('14598','2014-05-01','16:05:00',4.27),('14598','2014-05-01','16:10:00',4.23),('14598','2014-05-01','16:15:00',4.06),('14598','2014-05-01','16:20:00',4.12),('14598','2014-05-01','16:25:00',4.17),('14598','2014-05-01','16:30:00',4.04),('14598','2014-05-01','16:35:00',3.51),('14598','2014-05-01','16:40:00',3.43),('14598','2014-05-01','16:45:00',3.85),('14598','2014-05-01','16:50:00',3.73),('14598','2014-05-01','16:55:00',3.14),('14598','2014-05-01','17:00:00',3.24),('14598','2014-05-01','17:05:00',2.86),('14598','2014-05-01','17:10:00',3.55),('14598','2014-05-01','17:15:00',3.28),('14598','2014-05-01','17:20:00',3.35),('14598','2014-05-01','17:25:00',2.73),('14598','2014-05-01','17:30:00',2.37),('14598','2014-05-01','17:35:00',3.16),('14598','2014-05-01','17:40:00',2.89),('14598','2014-05-01','17:45:00',2.43),('14598','2014-05-01','17:50:00',2.39),('14598','2014-05-01','17:55:00',2.61),('14598','2014-05-01','18:00:00',2.41),('14598','2014-05-01','18:05:00',2.22),('14598','2014-05-01','18:10:00',2.2),('14598','2014-05-01','18:15:00',2.07),('14598','2014-05-01','18:20:00',1.98),('14598','2014-05-01','18:25:00',1.86),('14598','2014-05-01','18:30:00',1.75),('14598','2014-05-01','18:35:00',1.64),('14598','2014-05-01','18:40:00',1.52),('14598','2014-05-01','18:45:00',1.41),('14598','2014-05-01','18:50:00',1.3),('14598','2014-05-01','18:55:00',1.19),('14598','2014-05-01','19:00:00',1.08),('14598','2014-03-17','08:30:00',1.08),('14598','2014-03-17','08:40:00',1.04),('14598','2014-03-17','08:45:00',1.35),('14598','2014-03-17','08:50:00',1.34),('14598','2014-03-17','08:55:00',1.18),('14598','2014-03-17','09:00:00',1.08),('14598','2014-03-17','09:05:00',1.39),('14598','2014-03-17','09:10:00',1.62),('14598','2014-03-17','09:15:00',1.51),('14598','2014-03-17','09:20:00',1.57),('14598','2014-03-17','09:25:00',1.77),('14598','2014-03-17','09:30:00',1.88),('14598','2014-03-17','09:35:00',1.78),('14598','2014-03-17','09:40:00',1.61),('14598','2014-03-17','09:45:00',1.65),('14598','2014-03-17','09:50:00',1.41),('14598','2014-03-17','09:55:00',1.03),('14598','2014-03-17','10:00:00',1.3),('14598','2014-03-17','10:05:00',1.2),('14598','2014-03-17','10:10:00',1.49),('14598','2014-03-17','10:15:00',2.08),('14598','2014-03-17','10:20:00',4.12),('14598','2014-03-17','10:25:00',4.26),('14598','2014-03-17','10:30:00',2.93),('14598','2014-03-17','10:35:00',2.05),('14598','2014-03-17','10:40:00',2.11),('14598','2014-03-17','10:45:00',2.93),('14598','2014-03-17','10:50:00',3.82),('14598','2014-03-17','10:55:00',2.64),('14598','2014-03-17','11:00:00',2.46),('14598','2014-03-17','11:05:00',2.54),('14598','2014-03-17','11:10:00',2.68),('14598','2014-03-17','11:15:00',3.34),('14598','2014-03-17','11:20:00',2.57),('14598','2014-03-17','11:25:00',2.54),('14598','2014-03-17','11:30:00',2.17),('14598','2014-03-17','11:35:00',2.31),('14598','2014-03-17','11:40:00',2.23),('14598','2014-03-17','11:45:00',2.29),('14598','2014-03-17','11:50:00',2.44),('14598','2014-03-17','11:55:00',2.78),('14598','2014-03-17','12:00:00',2.72),('14598','2014-03-17','12:05:00',2.71),('14598','2014-03-17','12:10:00',2.99),('14598','2014-03-17','12:15:00',4.59),('14598','2014-03-17','12:20:00',4.56),('14598','2014-03-17','12:25:00',2.72),('14598','2014-03-17','12:30:00',3.18),('14598','2014-03-17','12:35:00',3.25),('14598','2014-03-17','12:40:00',4.58),('14598','2014-03-17','12:45:00',3.24),('14598','2014-03-17','12:50:00',3.93),('14598','2014-03-17','12:55:00',3.49),('14598','2014-03-17','13:00:00',2.96),('14598','2014-03-17','13:05:00',3.87),('14598','2014-03-17','13:10:00',4.41),('14598','2014-03-17','13:15:00',2.53),('14598','2014-03-17','13:20:00',3.7),('14598','2014-03-17','13:25:00',2.35),('14598','2014-03-17','13:30:00',2.09),('14598','2014-03-17','13:35:00',2.18),('14598','2014-03-17','13:40:00',2.12),('14598','2014-03-17','13:45:00',2.2),('14598','2014-03-17','13:50:00',2.58),('14598','2014-03-17','13:55:00',2.39),('14598','2014-03-17','14:00:00',2.24),('14598','2014-03-17','14:05:00',1.78),('14598','2014-03-17','14:10:00',1.6),('14598','2014-03-17','14:15:00',1.97),('14598','2014-03-17','14:20:00',2.16),('14598','2014-03-17','14:25:00',2.45),('14598','2014-03-17','14:30:00',2.57),('14598','2014-03-17','14:35:00',1.8),('14598','2014-03-17','14:40:00',2.33),('14598','2014-03-17','14:45:00',3.64),('14598','2014-03-17','14:50:00',2.18),('14598','2014-03-17','14:55:00',3.61),('14598','2014-03-17','15:00:00',2.88),('14598','2014-03-17','15:05:00',1.3),('14598','2014-03-17','15:10:00',1.48),('14598','2014-03-17','15:15:00',1.51),('14598','2014-03-17','15:20:00',1.24),('14598','2014-03-17','15:25:00',1.21),('14598','2014-03-17','15:30:00',1.31),('14598','2014-03-17','15:35:00',1.12),('14598','2014-03-17','15:40:00',1.12),('14598','2014-03-17','15:45:00',1.11),('14598','2014-03-17','15:50:00',1.17),('14598','2014-03-17','15:55:00',1.14),('14598','2014-03-17','16:00:00',1.41),('14598','2014-03-17','16:05:00',1.66),('14598','2014-03-17','16:10:00',1.61),('14598','2012-12-22','10:35:00',1.02),('14598','2012-12-22','10:40:00',1.13),('14598','2012-12-22','10:45:00',1.11),('14598','2012-12-22','10:50:00',1.25),('14598','2012-12-22','10:55:00',1.46),('14598','2012-12-22','11:00:00',1.37),('14598','2012-12-22','11:05:00',1.37),('14598','2012-12-22','11:10:00',1.47),('14598','2012-12-22','11:15:00',1.38),('14598','2012-12-22','11:20:00',1.51),('14598','2012-12-22','11:25:00',1.73),('14598','2012-12-22','11:30:00',1.84),('14598','2012-12-22','11:35:00',1.51),('14598','2012-12-22','11:40:00',3.03),('14598','2012-12-22','11:45:00',3.5),('14598','2012-12-22','11:50:00',2.74),('14598','2012-12-22','11:55:00',1.69),('14598','2012-12-22','12:00:00',1.17),('14598','2012-12-22','12:05:00',1.29),('14598','2012-12-22','12:10:00',2.81),('14598','2012-12-22','12:15:00',3.08),('14598','2012-12-22','12:20:00',3.04),('14598','2012-12-22','12:25:00',3.08),('14598','2012-12-22','12:30:00',2.82),('14598','2012-12-22','12:35:00',1.15),('14598','2012-12-22','12:45:00',3.06),('14598','2012-12-22','12:50:00',2.41),('14598','2012-12-22','12:55:00',3.03),('14598','2012-12-22','13:00:00',1.16),('14598','2012-12-22','13:20:00',1.61),('14598','2012-12-22','13:25:00',3.18),('14598','2012-12-22','13:30:00',3.49),('14598','2012-12-22','13:35:00',2.22),('14598','2012-12-22','13:40:00',1.32),('14598','2012-12-22','13:45:00',1.35),('14598','2012-12-22','14:00:00',1.49),('14598','2012-12-22','14:05:00',2.06),('14598','2012-12-22','14:10:00',2.36),('14598','2012-12-22','14:15:00',1.72),('14598','2012-12-22','14:20:00',2.28),('14598','2012-12-22','14:30:00',2.29),('14598','2012-12-22','14:35:00',2.34),('14598','2012-12-22','14:40:00',2.1),('14598','2012-12-22','14:45:00',1.14),('14598','2012-12-22','14:50:00',2.07),('14598','2012-12-22','14:55:00',2.09),('14598','2012-12-22','15:00:00',1.78),('14598','2012-12-22','15:05:00',1.65),('14598','2012-12-22','15:10:00',1.12),('14598','2012-12-22','15:25:00',1.28),('14598','2012-12-22','15:30:00',1.24),('14598','2012-12-22','15:35:00',1.14),('14598','2012-12-22','15:40:00',1.05),('14598','2014-03-16','08:15:00',1.05),('14598','2014-03-16','08:20:00',1.19),('14598','2014-03-16','08:25:00',1.21),('14598','2014-03-16','08:30:00',1.37),('14598','2014-03-16','08:35:00',1.5),('14598','2014-03-16','08:40:00',1.62),('14598','2014-03-16','08:45:00',1.75),('14598','2014-03-16','08:50:00',1.8),('14598','2014-03-16','08:55:00',1.88),('14598','2014-03-16','09:00:00',1.87),('14598','2014-03-16','09:05:00',2.04),('14598','2014-03-16','09:10:00',2.27),('14598','2014-03-16','09:15:00',2.26),('14598','2014-03-16','09:20:00',2.27),('14598','2014-03-16','09:25:00',2.32),('14598','2014-03-16','09:30:00',2.38),('14598','2014-03-16','09:35:00',2.56),('14598','2014-03-16','09:40:00',2.46),('14598','2014-03-16','09:45:00',2.63),('14598','2014-03-16','09:50:00',2.85),('14598','2014-03-16','09:55:00',2.86),('14598','2014-03-16','10:00:00',2.94),('14598','2014-03-16','10:05:00',3.05),('14598','2014-03-16','10:10:00',3.11),('14598','2014-03-16','10:15:00',3.18),('14598','2014-03-16','10:20:00',3.24),('14598','2014-03-16','10:25:00',3.29),('14598','2014-03-16','10:30:00',3.32),('14598','2014-03-16','10:35:00',3.36),('14598','2014-03-16','10:40:00',3.46),('14598','2014-03-16','10:45:00',3.54),('14598','2014-03-16','10:50:00',3.61),('14598','2014-03-16','10:55:00',3.66),('14598','2014-03-16','11:00:00',3.7),('14598','2014-03-16','11:05:00',3.69),('14598','2014-03-16','11:10:00',3.74),('14598','2014-03-16','11:15:00',3.81),('14598','2014-03-16','11:20:00',3.86),('14598','2014-03-16','11:25:00',3.96),('14598','2014-03-16','11:30:00',3.96),('14598','2014-03-16','11:35:00',4),('14598','2014-03-16','11:40:00',4.07),('14598','2014-03-16','11:45:00',4.11),('14598','2014-03-16','11:50:00',4.13),('14598','2014-03-16','11:55:00',4.19),('14598','2014-03-16','12:00:00',4.19),('14598','2014-03-16','12:05:00',4.23),('14598','2014-03-16','12:10:00',4.26),('14598','2014-03-16','12:15:00',4.28),('14598','2014-03-16','12:20:00',4.28),('14598','2014-03-16','12:25:00',4.3),('14598','2014-03-16','12:30:00',4.33),('14598','2014-03-16','12:35:00',4.34),('14598','2014-03-16','12:40:00',4.36),('14598','2014-03-16','12:45:00',4.36),('14598','2014-03-16','12:50:00',4.36),('14598','2014-03-16','12:55:00',4.36),('14598','2014-03-16','13:00:00',4.36),('14598','2014-03-16','13:05:00',4.38),('14598','2014-03-16','13:10:00',4.31),('14598','2014-03-16','13:15:00',4.27),('14598','2014-03-16','13:20:00',4.36),('14598','2014-03-16','13:25:00',4.33),('14598','2014-03-16','13:30:00',4.3),('14598','2014-03-16','13:35:00',3.88),('14598','2014-03-16','13:40:00',3.96),('14598','2014-03-16','13:45:00',4.31),('14598','2014-03-16','13:50:00',4.26),('14598','2014-03-16','13:55:00',4.2),('14598','2014-03-16','14:00:00',4.16),('14598','2014-03-16','14:05:00',4.1),('14598','2014-03-16','14:10:00',4.08),('14598','2014-03-16','14:15:00',4.02),('14598','2014-03-16','14:20:00',4.04),('14598','2014-03-16','14:25:00',3.88),('14598','2014-03-16','14:30:00',4),('14598','2014-03-16','14:35:00',3.47),('14598','2014-03-16','14:40:00',3.52),('14598','2014-03-16','14:45:00',3.61),('14598','2014-03-16','14:50:00',3),('14598','2014-03-16','14:55:00',2.98),('14598','2014-03-16','15:00:00',2.87),('14598','2014-03-16','15:05:00',2.77),('14598','2014-03-16','15:10:00',2.2),('14598','2014-03-16','15:15:00',2.51),('14598','2014-03-16','15:20:00',2.61),('14598','2014-03-16','15:25:00',2.26),('14598','2014-03-16','15:30:00',2.13),('14598','2014-03-16','15:35:00',2.05),('14598','2014-03-16','15:40:00',2.23),('14598','2014-03-16','15:45:00',1.95),('14598','2014-03-16','15:50:00',1.91),('14598','2014-03-16','15:55:00',2.16),('14598','2014-03-16','16:00:00',2.19),('14598','2014-03-16','16:05:00',2.23),('14598','2014-03-16','16:10:00',2.23),('14598','2014-03-16','16:15:00',2.19),('14598','2014-03-16','16:20:00',2.04),('14598','2014-03-16','16:25:00',2.01),('14598','2014-03-16','16:30:00',1.84),('14598','2014-03-16','16:35:00',1.7),('14598','2014-03-16','16:40:00',1.52),('14598','2014-03-16','16:45:00',1.31),('14598','2014-03-16','16:50:00',1.39),('14598','2014-03-16','16:55:00',1.1),('14598','2014-03-15','08:15:00',1.04),('14598','2014-03-15','08:20:00',1.14),('14598','2014-03-15','08:25:00',1.23),('14598','2014-03-15','08:30:00',1.33),('14598','2014-03-15','08:35:00',1.45),('14598','2014-03-15','08:40:00',1.54),('14598','2014-03-15','08:45:00',1.64),('14598','2014-03-15','08:50:00',1.72),('14598','2014-03-15','08:55:00',1.82),('14598','2014-03-15','09:00:00',1.91),('14598','2014-03-15','09:05:00',1.99),('14598','2014-03-15','09:10:00',2.08),('14598','2014-03-15','09:15:00',2.16),('14598','2014-03-15','09:20:00',2.24),('14598','2014-03-15','09:25:00',2.32),('14598','2014-03-15','09:30:00',2.39),('14598','2014-03-15','09:35:00',2.47),('14598','2014-03-15','09:40:00',2.53),('14598','2014-03-15','09:45:00',2.6),('14598','2014-03-15','09:50:00',2.66),('14598','2014-03-15','09:55:00',2.73),('14598','2014-03-15','10:00:00',2.81),('14598','2014-03-15','10:05:00',2.91),('14598','2014-03-15','10:10:00',2.97),('14598','2014-03-15','10:15:00',3.06),('14598','2014-03-15','10:20:00',3.12),('14598','2014-03-15','10:25:00',3.17),('14598','2014-03-15','10:30:00',3.26),('14598','2014-03-15','10:35:00',3.28),('14598','2014-03-15','10:40:00',3.39),('14598','2014-03-15','10:45:00',3.43),('14598','2014-03-15','10:50:00',3.5),('14598','2014-03-15','10:55:00',3.55),('14598','2014-03-15','11:00:00',3.61),('14598','2014-03-15','11:05:00',3.68),('14598','2014-03-15','11:10:00',3.74),('14598','2014-03-15','11:15:00',3.78),('14598','2014-03-15','11:20:00',3.83),('14598','2014-03-15','11:25:00',3.87),('14598','2014-03-15','11:30:00',3.89),('14598','2014-03-15','11:35:00',3.95),('14598','2014-03-15','11:40:00',4),('14598','2014-03-15','11:45:00',4.02),('14598','2014-03-15','11:50:00',4.01),('14598','2014-03-15','11:55:00',4.06),('14598','2014-03-15','12:00:00',4.08),('14598','2014-03-15','12:05:00',4.12),('14598','2014-03-15','12:10:00',4.14),('14598','2014-03-15','12:15:00',4.14),('14598','2014-03-15','12:20:00',4.17),('14598','2014-03-15','12:25:00',4.19),('14598','2014-03-15','12:30:00',4.18),('14598','2014-03-15','12:35:00',4.21),('14598','2014-03-15','12:40:00',4.22),('14598','2014-03-15','12:45:00',4.24),('14598','2014-03-15','12:50:00',4.28),('14598','2014-03-15','12:55:00',4.3),('14598','2014-03-15','13:00:00',4.34),('14598','2014-03-15','13:05:00',4.34),('14598','2014-03-15','13:10:00',4.29),('14598','2014-03-15','13:15:00',4.24),('14598','2014-03-15','13:20:00',4.2),('14598','2014-03-15','13:25:00',4.19),('14598','2014-03-15','13:30:00',4.2),('14598','2014-03-15','13:35:00',4.16),('14598','2014-03-15','13:40:00',4.04),('14598','2014-03-15','13:45:00',4.12),('14598','2014-03-15','13:50:00',4.1),('14598','2014-03-15','13:55:00',4.04),('14598','2014-03-15','14:00:00',4.04),('14598','2014-03-15','14:05:00',3.96),('14598','2014-03-15','14:10:00',3.93),('14598','2014-03-15','14:15:00',3.9),('14598','2014-03-15','14:20:00',3.86),('14598','2014-03-15','14:25:00',3.82),('14598','2014-03-15','14:30:00',3.76),('14598','2014-03-15','14:35:00',3.71),('14598','2014-03-15','14:40:00',3.65),('14598','2014-03-15','14:45:00',3.59),('14598','2014-03-15','14:50:00',3.54),('14598','2014-03-15','14:55:00',3.43),('14598','2014-03-15','15:00:00',3.36),('14598','2014-03-15','15:05:00',3.25),('14598','2014-03-15','15:10:00',3.19),('14598','2014-03-15','15:15:00',3.11),('14598','2014-03-15','15:20:00',3),('14598','2014-03-15','15:25:00',2.93),('14598','2014-03-15','15:30:00',2.89),('14598','2014-03-15','15:35:00',2.82),('14598','2014-03-15','15:40:00',2.72),('14598','2014-03-15','15:45:00',2.61),('14598','2014-03-15','15:50:00',2.51),('14598','2014-03-15','15:55:00',2.39),('14598','2014-03-15','16:00:00',2.32),('14598','2014-03-15','16:05:00',2.24),('14598','2014-03-15','16:10:00',2.13),('14598','2014-03-15','16:15:00',2.05),('14598','2014-03-15','16:20:00',1.94),('14598','2014-03-15','16:25:00',1.85),('14598','2014-03-15','16:30:00',1.74),('14598','2014-03-15','16:35:00',1.65),('14598','2014-03-15','16:40:00',1.54),('14598','2014-03-15','16:45:00',1.44),('14598','2014-03-15','16:50:00',1.32),('14598','2014-03-15','16:55:00',1.21),('14598','2014-03-15','17:00:00',1.11),('14598','2014-03-14','08:35:00',1),('14598','2014-03-14','08:40:00',1.01),('14598','2014-03-14','08:45:00',1.03),('14598','2014-03-14','08:50:00',1.03),('14598','2014-03-14','08:55:00',1.18),('14598','2014-03-14','09:00:00',1.47),('14598','2014-03-14','09:05:00',1.65),('14598','2014-03-14','09:10:00',1.84),('14598','2014-03-14','09:15:00',1.9),('14598','2014-03-14','09:20:00',2.16),('14598','2014-03-14','09:25:00',2.47),('14598','2014-03-14','09:30:00',2.57),('14598','2014-03-14','09:35:00',2.3),('14598','2014-03-14','09:40:00',1.86),('14598','2014-03-14','09:45:00',1.7),('14598','2014-03-14','09:50:00',2.2),('14598','2014-03-14','09:55:00',2.97),('14598','2014-03-14','10:00:00',3.31),('14598','2014-03-14','10:05:00',3.2),('14598','2014-03-14','10:10:00',3.45),('14598','2014-03-14','10:15:00',3.54),('14598','2014-03-14','10:20:00',3.68),('14598','2014-03-14','10:25:00',3.72),('14598','2014-03-14','10:30:00',3.67),('14598','2014-03-14','10:35:00',3.7),('14598','2014-03-14','10:40:00',3.73),('14598','2014-03-14','10:45:00',3.68),('14598','2014-03-14','10:50:00',3.82),('14598','2014-03-14','10:55:00',3.57),('14598','2014-03-14','11:00:00',3.3),('14598','2014-03-14','11:05:00',3.69),('14598','2014-03-14','11:10:00',3.92),('14598','2014-03-14','11:15:00',4.04),('14598','2014-03-14','11:20:00',4.12),('14598','2014-03-14','11:25:00',3.99),('14598','2014-03-14','11:30:00',4.11),('14598','2014-03-14','11:35:00',4.19),('14598','2014-03-14','11:40:00',4.19),('14598','2014-03-14','11:45:00',4.29),('14598','2014-03-14','11:50:00',4.3),('14598','2014-03-14','11:55:00',4.19),('14598','2014-03-14','12:00:00',4.14),('14598','2014-03-14','12:05:00',4.16),('14598','2014-03-14','12:10:00',4.09),('14598','2014-03-14','12:15:00',4.33),('14598','2014-03-14','12:20:00',4.42),('14598','2014-03-14','12:25:00',4.55),('14598','2014-03-14','12:30:00',4.41),('14598','2014-03-14','12:35:00',4.31),('14598','2014-03-14','12:40:00',3.88),('14598','2014-03-14','12:45:00',2.72),('14598','2014-03-14','12:50:00',2.38),('14598','2014-03-14','12:55:00',2.72),('14598','2014-03-14','13:00:00',3.21),('14598','2014-03-14','13:05:00',3.68),('14598','2014-03-14','13:10:00',3.05),('14598','2014-03-14','13:15:00',3.1),('14598','2014-03-14','13:20:00',3.51),('14598','2014-03-14','13:25:00',3.66),('14598','2014-03-14','13:30:00',2.9),('14598','2014-03-14','13:35:00',2.37),('14598','2014-03-14','13:40:00',2.55),('14598','2014-03-14','13:45:00',3.3),('14598','2014-03-14','13:50:00',3.13),('14598','2014-03-14','13:55:00',3.48),('14598','2014-03-14','14:00:00',3.41),('14598','2014-03-14','14:05:00',3.73),('14598','2014-03-14','14:10:00',4.18),('14598','2014-03-14','14:15:00',4.24),('14598','2014-03-14','14:20:00',4.04),('14598','2014-03-14','14:25:00',4.08),('14598','2014-03-14','14:30:00',4.22),('14598','2014-03-14','14:35:00',4.2),('14598','2014-03-14','14:40:00',3.99),('14598','2014-03-14','14:45:00',3.35),('14598','2014-03-14','14:50:00',3.76),('14598','2014-03-14','14:55:00',3.54),('14598','2014-03-14','15:00:00',3.34),('14598','2014-03-14','15:05:00',2.83),('14598','2014-03-14','15:10:00',2.16),('14598','2014-03-14','15:15:00',1.61),('14598','2014-03-14','15:20:00',1.48),('14598','2014-03-14','15:25:00',1.4),('14598','2014-03-14','15:30:00',1.39),('14598','2014-03-14','15:35:00',1.34),('14598','2014-03-14','15:40:00',1.26),('14598','2014-03-14','15:45:00',1.06),('14598','2014-03-14','16:30:00',1.02),('14598','2014-03-13','08:10:00',1),('14598','2014-03-13','08:15:00',1.1),('14598','2014-03-13','08:20:00',1.21),('14598','2014-03-13','08:25:00',1.33),('14598','2014-03-13','08:30:00',1.46),('14598','2014-03-13','08:35:00',1.57),('14598','2014-03-13','08:40:00',1.7),('14598','2014-03-13','08:45:00',1.81),('14598','2014-03-13','08:50:00',1.91),('14598','2014-03-13','08:55:00',2),('14598','2014-03-13','09:00:00',2.1),('14598','2014-03-13','09:05:00',2.2),('14598','2014-03-13','09:10:00',2.3),('14598','2014-03-13','09:15:00',2.39),('14598','2014-03-13','09:20:00',2.48),('14598','2014-03-13','09:25:00',2.57),('14598','2014-03-13','09:30:00',2.67),('14598','2014-03-13','09:35:00',2.76),('14598','2014-03-13','09:40:00',2.84),('14598','2014-03-13','09:45:00',2.91),('14598','2014-03-13','09:50:00',3),('14598','2014-03-13','09:55:00',3.09),('14598','2014-03-13','10:00:00',3.17),('14598','2014-03-13','10:05:00',3.24),('14598','2014-03-13','10:10:00',3.32),('14598','2014-03-13','10:15:00',3.38),('14598','2014-03-13','10:20:00',3.44),('14598','2014-03-13','10:25:00',3.48),('14598','2014-03-13','10:30:00',3.54),('14598','2014-03-13','10:35:00',3.6),('14598','2014-03-13','10:40:00',3.66),('14598','2014-03-13','10:45:00',3.7),('14598','2014-03-13','10:50:00',3.74),('14598','2014-03-13','10:55:00',3.77),('14598','2014-03-13','11:00:00',3.79),('14598','2014-03-13','11:05:00',3.78),('14598','2014-03-13','11:10:00',3.84),('14598','2014-03-13','11:15:00',3.91),('14598','2014-03-13','11:20:00',4),('14598','2014-03-13','11:25:00',4.07),('14598','2014-03-13','11:30:00',4.13),('14598','2014-03-13','11:35:00',4.15),('14598','2014-03-13','11:40:00',4.19),('14598','2014-03-13','11:45:00',4.21),('14598','2014-03-13','11:50:00',4.24),('14598','2014-03-13','11:55:00',4.25),('14598','2014-03-13','12:00:00',4.27),('14598','2014-03-13','12:05:00',4.28),('14598','2014-03-13','12:10:00',4.3),('14598','2014-03-13','12:15:00',4.33),('14598','2014-03-13','12:20:00',4.34),('14598','2014-03-13','12:25:00',4.35),('14598','2014-03-13','12:30:00',4.37),('14598','2014-03-13','12:35:00',4.41),('14598','2014-03-13','12:40:00',4.42),('14598','2014-03-13','12:45:00',4.43),('14598','2014-03-13','12:50:00',4.42),('14598','2014-03-13','12:55:00',4.41),('14598','2014-03-13','13:00:00',4.43),('14598','2014-03-13','13:05:00',4.42),('14598','2014-03-13','13:10:00',4.39),('14598','2014-03-13','13:15:00',4.38),('14598','2014-03-13','13:20:00',4.38),('14598','2014-03-13','13:25:00',4.34),('14598','2014-03-13','13:30:00',4.31),('14598','2014-03-13','13:35:00',4.29),('14598','2014-03-13','13:40:00',4.26),('14598','2014-03-13','13:45:00',4.23),('14598','2014-03-13','13:50:00',4.2),('14598','2014-03-13','13:55:00',4.17),('14598','2014-03-13','14:00:00',4.13),('14598','2014-03-13','14:05:00',4.09),('14598','2014-03-13','14:10:00',4.03),('14598','2014-03-13','14:15:00',4),('14598','2014-03-13','14:20:00',3.95),('14598','2014-03-13','14:25:00',3.91),('14598','2014-03-13','14:30:00',3.86),('14598','2014-03-13','14:35:00',3.82),('14598','2014-03-13','14:40:00',3.74),('14598','2014-03-13','14:45:00',3.71),('14598','2014-03-13','14:50:00',3.66),('14598','2014-03-13','14:55:00',3.57),('14598','2014-03-13','15:00:00',3.51),('14598','2014-03-13','15:05:00',3.45),('14598','2014-03-13','15:10:00',3.39),('14598','2014-03-13','15:15:00',3.3),('14598','2014-03-13','15:20:00',3.21),('14598','2014-03-13','15:25:00',3.12),('14598','2014-03-13','15:30:00',3.05),('14598','2014-03-13','15:35:00',2.96),('14598','2014-03-13','15:40:00',2.89),('14598','2014-03-13','15:45:00',2.78),('14598','2014-03-13','15:50:00',2.69),('14598','2014-03-13','15:55:00',2.61),('14598','2014-03-13','16:00:00',2.52),('14598','2014-03-13','16:05:00',2.41),('14598','2014-03-13','16:10:00',2.32),('14598','2014-03-13','16:15:00',2.21),('14598','2014-03-13','16:20:00',2.12),('14598','2014-03-13','16:25:00',2.03),('14598','2014-03-13','16:30:00',1.94),('14598','2014-03-13','16:35:00',1.83),('14598','2014-03-13','16:40:00',1.71),('14598','2014-03-13','16:45:00',1.6),('14598','2014-03-13','16:50:00',1.49),('14598','2014-03-13','16:55:00',1.37),('14598','2014-03-13','17:00:00',1.26),('14598','2014-03-13','17:05:00',1.15),('14598','2014-03-13','17:10:00',1.04),('14598','2014-03-12','08:15:00',1.07),('14598','2014-03-12','08:20:00',1.17),('14598','2014-03-12','08:25:00',1.28),('14598','2014-03-12','08:30:00',1.41),('14598','2014-03-12','08:35:00',1.51),('14598','2014-03-12','08:40:00',1.65),('14598','2014-03-12','08:45:00',1.76),('14598','2014-03-12','08:50:00',1.86),('14598','2014-03-12','08:55:00',1.96),('14598','2014-03-12','09:00:00',2.06),('14598','2014-03-12','09:05:00',2.16),('14598','2014-03-12','09:10:00',2.26),('14598','2014-03-12','09:15:00',2.36),('14598','2014-03-12','09:20:00',2.46),('14598','2014-03-12','09:25:00',2.54),('14598','2014-03-12','09:30:00',2.63),('14598','2014-03-12','09:35:00',2.73),('14598','2014-03-12','09:40:00',2.8),('14598','2014-03-12','09:45:00',2.88),('14598','2014-03-12','09:50:00',2.93),('14598','2014-03-12','09:55:00',3.03),('14598','2014-03-12','10:00:00',3.09),('14598','2014-03-12','10:05:00',3.18),('14598','2014-03-12','10:10:00',3.24),('14598','2014-03-12','10:15:00',3.31),('14598','2014-03-12','10:20:00',3.38),('14598','2014-03-12','10:25:00',3.45),('14598','2014-03-12','10:30:00',3.5),('14598','2014-03-12','10:35:00',3.57),('14598','2014-03-12','10:40:00',3.6),('14598','2014-03-12','10:45:00',3.64),('14598','2014-03-12','10:50:00',3.68),('14598','2014-03-12','10:55:00',3.73),('14598','2014-03-12','11:00:00',3.78),('14598','2014-03-12','11:05:00',3.81),('14598','2014-03-12','11:10:00',3.8),('14598','2014-03-12','11:15:00',3.86),('14598','2014-03-12','11:20:00',3.91),('14598','2014-03-12','11:25:00',3.94),('14598','2014-03-12','11:30:00',3.94),('14598','2014-03-12','11:35:00',4.01),('14598','2014-03-12','11:40:00',4.03),('14598','2014-03-12','11:45:00',4.07),('14598','2014-03-12','11:50:00',4.08),('14598','2014-03-12','11:55:00',4.07),('14598','2014-03-12','12:00:00',4.06),('14598','2014-03-12','12:05:00',4.11),('14598','2014-03-12','12:10:00',4.14),('14598','2014-03-12','12:15:00',4.14),('14598','2014-03-12','12:20:00',4.16),('14598','2014-03-12','12:25:00',4.17),('14598','2014-03-12','12:30:00',4.2),('14598','2014-03-12','12:35:00',4.25),('14598','2014-03-12','12:40:00',4.25),('14598','2014-03-12','12:45:00',4.21),('14598','2014-03-12','12:50:00',4.18),('14598','2014-03-12','12:55:00',4.11),('14598','2014-03-12','13:00:00',4.17),('14598','2014-03-12','13:05:00',4.21),('14598','2014-03-12','13:10:00',4.2),('14598','2014-03-12','13:15:00',4.16),('14598','2014-03-12','13:20:00',4.15),('14598','2014-03-12','13:25:00',4.15),('14598','2014-03-12','13:30:00',4.16),('14598','2014-03-12','13:35:00',4.18),('14598','2014-03-12','13:40:00',4.15),('14598','2014-03-12','13:45:00',4.18),('14598','2014-03-12','13:50:00',4.15),('14598','2014-03-12','13:55:00',4.04),('14598','2014-03-12','14:00:00',4.05),('14598','2014-03-12','14:05:00',4.02),('14598','2014-03-12','14:10:00',3.95),('14598','2014-03-12','14:15:00',3.94),('14598','2014-03-12','14:20:00',3.9),('14598','2014-03-12','14:25:00',3.89),('14598','2014-03-12','14:30:00',3.85),('14598','2014-03-12','14:35:00',3.75),('14598','2014-03-12','14:40:00',3.69),('14598','2014-03-12','14:45:00',3.66),('14598','2014-03-12','14:50:00',3.61),('14598','2014-03-12','14:55:00',3.55),('14598','2014-03-12','15:00:00',3.5),('14598','2014-03-12','15:05:00',3.44),('14598','2014-03-12','15:10:00',3.35),('14598','2014-03-12','15:15:00',3.29),('14598','2014-03-12','15:20:00',3.2),('14598','2014-03-12','15:25:00',3.12),('14598','2014-03-12','15:30:00',3.05),('14598','2014-03-12','15:35:00',2.96),('14598','2014-03-12','15:40:00',2.86),('14598','2014-03-12','15:45:00',2.76),('14598','2014-03-12','15:50:00',2.66),('14598','2014-03-12','15:55:00',2.57),('14598','2014-03-12','16:00:00',2.5),('14598','2014-03-12','16:05:00',2.4),('14598','2014-03-12','16:10:00',2.3),('14598','2014-03-12','16:15:00',2.2),('14598','2014-03-12','16:20:00',2.1),('14598','2014-03-12','16:25:00',2),('14598','2014-03-12','16:30:00',1.9),('14598','2014-03-12','16:35:00',1.8),('14598','2014-03-12','16:40:00',1.69),('14598','2014-03-12','16:45:00',1.57),('14598','2014-03-12','16:50:00',1.45),('14598','2014-03-12','16:55:00',1.34),('14598','2014-03-12','17:00:00',1.22),('14598','2014-03-12','17:05:00',1.11),('14598','2014-03-11','08:00:00',1.01),('14598','2014-03-11','08:05:00',1.16),('14598','2014-03-11','08:10:00',1.13),('14598','2014-03-11','08:15:00',1.08),('14598','2014-03-11','08:20:00',1.4),('14598','2014-03-11','08:25:00',1.78),('14598','2014-03-11','08:30:00',1.7),('14598','2014-03-11','08:35:00',1.04),('14598','2014-03-11','09:00:00',1.09),('14598','2014-03-11','09:05:00',1.44),('14598','2014-03-11','09:10:00',1.55),('14598','2014-03-11','09:15:00',1.55),('14598','2014-03-11','09:20:00',1.73),('14598','2014-03-11','09:25:00',1.57),('14598','2014-03-11','09:30:00',1.47),('14598','2014-03-11','09:35:00',1.53),('14598','2014-03-11','09:40:00',1.5),('14598','2014-03-11','09:45:00',1.54),('14598','2014-03-11','09:50:00',1.46),('14598','2014-03-11','09:55:00',1.11),('14598','2014-03-11','10:25:00',1.02),('14598','2014-03-11','10:30:00',1.09),('14598','2014-03-11','10:35:00',1.19),('14598','2014-03-11','10:40:00',1.18),('14598','2014-03-11','10:45:00',1.08),('14598','2014-03-11','10:50:00',1.09),('14598','2014-03-11','10:55:00',1.04),('14598','2014-03-11','11:10:00',1.01),('14598','2014-03-11','12:00:00',1.14),('14598','2014-03-11','12:05:00',1.33),('14598','2014-03-11','12:10:00',1.34),('14598','2014-03-11','12:15:00',1.46),('14598','2014-03-11','12:20:00',1.63),('14598','2014-03-11','12:25:00',1.78),('14598','2014-03-11','12:30:00',1.91),('14598','2014-03-11','12:35:00',2),('14598','2014-03-11','12:40:00',2.28),('14598','2014-03-11','12:45:00',2.57),('14598','2014-03-11','12:50:00',2.85),('14598','2014-03-11','12:55:00',3.27),('14598','2014-03-11','13:00:00',3.39),('14598','2014-03-11','13:05:00',2.61),('14598','2014-03-11','13:10:00',2.96),('14598','2014-03-11','13:15:00',2.81),('14598','2014-03-11','13:20:00',2.86),('14598','2014-03-11','13:25:00',3.1),('14598','2014-03-11','13:30:00',3.27),('14598','2014-03-11','13:35:00',3.05),('14598','2014-03-11','13:40:00',2.93),('14598','2014-03-11','13:45:00',2.6),('14598','2014-03-11','13:50:00',2.48),('14598','2014-03-11','13:55:00',2.93),('14598','2014-03-11','14:00:00',3.28),('14598','2014-03-11','14:05:00',3.44),('14598','2014-03-11','14:10:00',3.55),('14598','2014-03-11','14:15:00',3.56),('14598','2014-03-11','14:20:00',3.34),('14598','2014-03-11','14:25:00',3.24),('14598','2014-03-11','14:30:00',3.28),('14598','2014-03-11','14:35:00',3.14),('14598','2014-03-11','14:40:00',2.63),('14598','2014-03-11','14:45:00',2.66),('14598','2014-03-11','14:50:00',2.54),('14598','2014-03-11','14:55:00',2.53),('14598','2014-03-11','15:00:00',2.15),('14598','2014-03-11','15:05:00',2.12),('14598','2014-03-11','15:10:00',2.04),('14598','2014-03-11','15:15:00',1.55),('14598','2014-03-11','15:20:00',1.26),('14598','2014-03-11','15:25:00',1.01),('14598','2014-03-10','08:25:00',1.03),('14598','2014-03-10','08:30:00',1.1),('14598','2014-03-10','08:35:00',1.25),('14598','2014-03-10','08:40:00',1.38),('14598','2014-03-10','08:45:00',1.35),('14598','2014-03-10','08:50:00',1.36),('14598','2014-03-10','08:55:00',1.44),('14598','2014-03-10','09:00:00',1.53),('14598','2014-03-10','09:05:00',1.72),('14598','2014-03-10','09:10:00',1.81),('14598','2014-03-10','09:15:00',1.69),('14598','2014-03-10','09:20:00',1.71),('14598','2014-03-10','09:25:00',1.66),('14598','2014-03-10','09:30:00',1.61),('14598','2014-03-10','09:35:00',1.74),('14598','2014-03-10','09:40:00',1.83),('14598','2014-03-10','09:45:00',1.94),('14598','2014-03-10','09:50:00',2.06),('14598','2014-03-10','09:55:00',2.1),('14598','2014-03-10','10:00:00',2.18),('14598','2014-03-10','10:05:00',2.15),('14598','2014-03-10','10:10:00',2.14),('14598','2014-03-10','10:15:00',2.24),('14598','2014-03-10','10:20:00',2.35),('14598','2014-03-10','10:25:00',2.26),('14598','2014-03-10','10:30:00',1.73),('14598','2014-03-10','10:35:00',1.31),('14598','2014-03-10','10:40:00',1.36),('14598','2014-03-10','10:45:00',1.45),('14598','2014-03-10','10:50:00',1.48),('14598','2014-03-10','10:55:00',1.49),('14598','2014-03-10','11:00:00',1.6),('14598','2014-03-10','11:05:00',1.47),('14598','2014-03-10','11:10:00',1.42),('14598','2014-03-10','11:15:00',1.68),('14598','2014-03-10','11:20:00',1.56),('14598','2014-03-10','11:25:00',1.19),('14598','2014-03-10','11:30:00',1.08),('14598','2014-03-10','11:35:00',1.14),('14598','2014-03-10','11:40:00',1.21),('14598','2014-03-10','11:45:00',1.11),('14598','2014-03-10','12:30:00',1),('14598','2014-03-10','12:35:00',1.01),('14598','2014-03-10','12:40:00',1.2),('14598','2014-03-10','12:45:00',1.11),('14598','2014-03-10','13:25:00',1.05),('14598','2014-03-10','13:30:00',1.18),('14598','2014-03-10','13:35:00',1.3),('14598','2014-03-10','13:40:00',1.19),('14598','2014-03-10','15:25:00',1.11),('14598','2014-03-10','15:30:00',1.11),('14598','2014-03-10','15:35:00',2.01),('14598','2014-03-10','15:40:00',1.51),('14598','2014-03-10','15:45:00',1.62),('14598','2014-03-10','15:50:00',1.54),('14598','2014-03-10','15:55:00',2.47),('14598','2014-03-10','16:00:00',2.63),('14598','2014-03-10','16:05:00',2.35),('14598','2014-03-10','16:10:00',2.24),('14598','2014-03-10','16:15:00',1.77),('14598','2014-03-10','16:20:00',1.94),('14598','2014-03-10','16:25:00',1.93),('14598','2014-03-10','16:30:00',1.89),('14598','2014-03-10','16:35:00',1.82),('14598','2014-03-10','16:40:00',1.73),('14598','2014-03-10','16:45:00',1.48),('14598','2014-03-10','16:50:00',1.24),('14598','2014-03-09','08:20:00',1.05),('14598','2014-03-09','08:25:00',1.15),('14598','2014-03-09','08:30:00',1.26),('14598','2014-03-09','08:35:00',1.4),('14598','2014-03-09','08:40:00',1.52),('14598','2014-03-09','08:45:00',1.64),('14598','2014-03-09','08:50:00',1.74),('14598','2014-03-09','08:55:00',1.85),('14598','2014-03-09','09:00:00',1.96),('14598','2014-03-09','09:05:00',2.06),('14598','2014-03-09','09:10:00',2.16),('14598','2014-03-09','09:15:00',2.25),('14598','2014-03-09','09:20:00',2.34),('14598','2014-03-09','09:25:00',2.42),('14598','2014-03-09','09:30:00',2.5),('14598','2014-03-09','09:35:00',2.58),('14598','2014-03-09','09:40:00',2.66),('14598','2014-03-09','09:45:00',2.75),('14598','2014-03-09','09:50:00',2.84),('14598','2014-03-09','09:55:00',2.92),('14598','2014-03-09','10:00:00',3.03),('14598','2014-03-09','10:05:00',3.15),('14598','2014-03-09','10:10:00',3.25),('14598','2014-03-09','10:15:00',3.38),('14598','2014-03-09','10:20:00',3.53),('14598','2014-03-09','10:25:00',3.71),('14598','2014-03-09','10:30:00',3.78),('14598','2014-03-09','10:35:00',3.88),('14598','2014-03-09','10:40:00',3.85),('14598','2014-03-09','10:45:00',3.84),('14598','2014-03-09','10:50:00',3.59),('14598','2014-03-09','10:55:00',2.82),('14598','2014-03-09','11:00:00',1.67),('14598','2014-03-09','11:05:00',4.73),('14598','2014-03-09','11:10:00',4.59),('14598','2014-03-09','11:15:00',4.59),('14598','2014-03-09','11:20:00',2.98),('14598','2014-03-09','11:25:00',1.19),('14598','2014-03-09','11:30:00',1.14),('14598','2014-03-09','11:35:00',1.09),('14598','2014-03-09','11:40:00',1.08),('14598','2014-03-09','11:45:00',1.46),('14598','2014-03-09','11:50:00',4.33),('14598','2014-03-09','11:55:00',2.82),('14598','2014-03-09','12:00:00',2.31),('14598','2014-03-09','12:05:00',1.92),('14598','2014-03-09','12:10:00',2.34),('14598','2014-03-09','12:15:00',3.58),('14598','2014-03-09','12:20:00',1.25),('14598','2014-03-09','12:25:00',1.6),('14598','2014-03-09','12:30:00',1.53),('14598','2014-03-09','12:35:00',2.44),('14598','2014-03-09','12:40:00',4.9),('14598','2014-03-09','12:45:00',4.81),('14598','2014-03-09','12:50:00',4.8),('14598','2014-03-09','12:55:00',4.8),('14598','2014-03-09','13:00:00',4.78),('14598','2014-03-09','13:05:00',4.12),('14598','2014-03-09','13:10:00',4.63),('14598','2014-03-09','13:15:00',4.53),('14598','2014-03-09','13:20:00',3.9),('14598','2014-03-09','13:25:00',4.55),('14598','2014-03-09','13:30:00',4.53),('14598','2014-03-09','13:35:00',4.47),('14598','2014-03-09','13:40:00',4.57),('14598','2014-03-09','13:45:00',4.54),('14598','2014-03-09','13:50:00',4.4),('14598','2014-03-09','13:55:00',4.37),('14598','2014-03-09','14:00:00',4.42),('14598','2014-03-09','14:05:00',4.47),('14598','2014-03-09','14:10:00',4.51),('14598','2014-03-09','14:15:00',4.3),('14598','2014-03-09','14:20:00',2.54),('14598','2014-03-09','14:25:00',1.25),('14598','2014-03-09','14:30:00',1.45),('14598','2014-03-09','14:35:00',3.89),('14598','2014-03-09','14:40:00',3.66),('14598','2014-03-09','14:45:00',3.75),('14598','2014-03-09','14:50:00',3.67),('14598','2014-03-09','14:55:00',3.14),('14598','2014-03-09','15:00:00',2.17),('14598','2014-03-09','15:05:00',1.89),('14598','2014-03-09','15:10:00',1.55),('14598','2014-03-09','15:35:00',1.42),('14598','2014-03-09','15:40:00',1.71),('14598','2014-03-09','15:45:00',2.76),('14598','2014-03-09','15:50:00',2.98),('14598','2014-03-09','15:55:00',2.88),('14598','2014-03-09','16:00:00',2.89),('14598','2014-03-09','16:05:00',2.89),('14598','2014-03-09','16:10:00',2.61),('14598','2014-03-09','16:15:00',2.42),('14598','2014-03-09','16:20:00',2.31),('14598','2014-03-09','16:25:00',2.12),('14598','2014-03-09','16:30:00',1.76),('14598','2014-03-09','16:35:00',1.76),('14598','2014-03-09','16:40:00',1.54),('14598','2014-03-09','16:45:00',1.52),('14598','2014-03-09','16:50:00',1.39),('14598','2014-03-09','16:55:00',1.28),('14598','2014-03-09','17:00:00',1.19),('14598','2014-03-09','17:05:00',1.07),('14598','2014-03-08','08:20:00',1.04),('14598','2014-03-08','08:25:00',1.16),('14598','2014-03-08','08:30:00',1.27),('14598','2014-03-08','08:35:00',1.39),('14598','2014-03-08','08:40:00',1.49),('14598','2014-03-08','08:45:00',1.63),('14598','2014-03-08','08:50:00',1.73),('14598','2014-03-08','08:55:00',1.84),('14598','2014-03-08','09:00:00',1.94),('14598','2014-03-08','09:05:00',2.05),('14598','2014-03-08','09:10:00',2.15),('14598','2014-03-08','09:15:00',2.25),('14598','2014-03-08','09:20:00',2.34),('14598','2014-03-08','09:25:00',2.43),('14598','2014-03-08','09:30:00',2.51),('14598','2014-03-08','09:35:00',2.6),('14598','2014-03-08','09:40:00',2.68),('14598','2014-03-08','09:45:00',2.77),('14598','2014-03-08','09:50:00',2.84),('14598','2014-03-08','09:55:00',2.9),('14598','2014-03-08','10:00:00',2.98),('14598','2014-03-08','10:05:00',3.06),('14598','2014-03-08','10:10:00',3.17),('14598','2014-03-08','10:15:00',3.22),('14598','2014-03-08','10:20:00',3.31),('14598','2014-03-08','10:25:00',3.39),('14598','2014-03-08','10:30:00',3.54),('14598','2014-03-08','10:35:00',2.54),('14598','2014-03-08','10:40:00',3.79),('14598','2014-03-08','10:45:00',2.96),('14598','2014-03-08','10:50:00',3.29),('14598','2014-03-08','10:55:00',4.11),('14598','2014-03-08','11:00:00',4.34),('14598','2014-03-08','11:05:00',3.54),('14598','2014-03-08','11:10:00',3.13),('14598','2014-03-08','11:15:00',4.23),('14598','2014-03-08','11:20:00',2.2),('14598','2014-03-08','11:25:00',1.55),('14598','2014-03-08','11:30:00',2.63),('14598','2014-03-08','11:35:00',3.36),('14598','2014-03-08','11:40:00',2.85),('14598','2014-03-08','11:45:00',3.35),('14598','2014-03-08','11:50:00',4.03),('14598','2014-03-08','11:55:00',2.57),('14598','2014-03-08','12:00:00',2.96),('14598','2014-03-08','12:05:00',1.8),('14598','2014-03-08','12:10:00',1.77),('14598','2014-03-08','12:15:00',1.82),('14598','2014-03-08','12:20:00',2.08),('14598','2014-03-08','12:25:00',2.35),('14598','2014-03-08','12:30:00',2.48),('14598','2014-03-08','12:35:00',2.53),('14598','2014-03-08','12:40:00',2.08),('14598','2014-03-08','12:45:00',1.83),('14598','2014-03-08','12:50:00',1.7),('14598','2014-03-08','12:55:00',1.55),('14598','2014-03-08','13:00:00',1.45),('14598','2014-03-08','13:05:00',1.51),('14598','2014-03-08','13:10:00',1.61),('14598','2014-03-08','13:15:00',1.73),('14598','2014-03-08','13:20:00',1.61),('14598','2014-03-08','13:25:00',1.39),('14598','2014-03-08','13:30:00',1.44),('14598','2014-03-08','13:35:00',1.62),('14598','2014-03-08','13:40:00',1.62),('14598','2014-03-08','13:45:00',1.48),('14598','2014-03-08','13:50:00',1.43),('14598','2014-03-08','13:55:00',1.54),('14598','2014-03-08','14:00:00',1.76),('14598','2014-03-08','14:05:00',2.4),('14598','2014-03-08','14:10:00',2.52),('14598','2014-03-08','14:15:00',1.95),('14598','2014-03-08','14:20:00',1.75),('14598','2014-03-08','14:25:00',1.27),('14598','2014-03-08','14:30:00',1.07),('14598','2014-03-08','15:00:00',1.03),('14598','2014-03-08','15:05:00',1.27),('14598','2014-03-08','15:10:00',1.48),('14598','2014-03-08','15:15:00',1.91),('14598','2014-03-08','15:20:00',1.92),('14598','2014-03-08','15:25:00',1.54),('14598','2014-03-08','15:30:00',1.1),('14598','2014-03-08','15:35:00',1.01),('14598','2014-03-08','15:40:00',1.3),('14598','2014-03-08','15:45:00',1.13),('14598','2014-03-08','15:50:00',1.22),('14598','2014-03-08','15:55:00',1.95),('14598','2014-03-08','17:05:00',1.17),('14598','2014-03-08','17:10:00',1.04),('14598','2014-04-30','08:10:00',1.06),('14598','2014-04-30','08:15:00',1.17),('14598','2014-04-30','08:20:00',1.27),('14598','2014-04-30','08:25:00',1.37),('14598','2014-04-30','08:30:00',1.48),('14598','2014-04-30','08:35:00',1.6),('14598','2014-04-30','08:40:00',1.7),('14598','2014-04-30','08:45:00',1.84),('14598','2014-04-30','08:50:00',1.94),('14598','2014-04-30','08:55:00',2.06),('14598','2014-04-30','09:00:00',2.17),('14598','2014-04-30','09:05:00',2.29),('14598','2014-04-30','09:10:00',2.39),('14598','2014-04-30','09:15:00',2.5),('14598','2014-04-30','09:20:00',2.57),('14598','2014-04-30','09:25:00',2.65),('14598','2014-04-30','09:30:00',2.78),('14598','2014-04-30','09:35:00',2.98),('14598','2014-04-30','09:40:00',2.42),('14598','2014-04-30','09:45:00',1.3),('14598','2014-04-30','09:50:00',2.36),('14598','2014-04-30','09:55:00',3.48),('14598','2014-04-30','10:00:00',3.62),('14598','2014-04-30','10:05:00',3.69),('14598','2014-04-30','10:10:00',3.63),('14598','2014-04-30','10:15:00',3.66),('14598','2014-04-30','10:20:00',3.71),('14598','2014-04-30','10:25:00',3.92),('14598','2014-04-30','10:30:00',4.15),('14598','2014-04-30','10:35:00',2.79),('14598','2014-04-30','10:40:00',2.31),('14598','2014-04-30','10:45:00',2.5),('14598','2014-04-30','10:50:00',3.49),('14598','2014-04-30','10:55:00',2.58),('14598','2014-04-30','11:00:00',2.19),('14598','2014-04-30','11:05:00',4.41),('14598','2014-04-30','11:10:00',4.54),('14598','2014-04-30','11:15:00',4.62),('14598','2014-04-30','11:20:00',4.29),('14598','2014-04-30','11:25:00',4.52),('14598','2014-04-30','11:30:00',3.69),('14598','2014-04-30','11:35:00',3.15),('14598','2014-04-30','11:40:00',3.44),('14598','2014-04-30','11:45:00',4.37),('14598','2014-04-30','11:50:00',3.92),('14598','2014-04-30','11:55:00',5.05),('14598','2014-04-30','12:00:00',5.13),('14598','2014-04-30','12:05:00',5.06),('14598','2014-04-30','12:10:00',4.83),('14598','2014-04-30','12:15:00',4.75),('14598','2014-04-30','12:20:00',5.01),('14598','2014-04-30','12:25:00',4.89),('14598','2014-04-30','12:30:00',5.12),('14598','2014-04-30','12:35:00',4.94),('14598','2014-04-30','12:40:00',4.4),('14598','2014-04-30','12:45:00',4.47),('14598','2014-04-30','12:50:00',5.39),('14598','2014-04-30','12:55:00',5.14),('14598','2014-04-30','13:00:00',2.74),('14598','2014-04-30','13:05:00',1.91),('14598','2014-04-30','13:10:00',1.77),('14598','2014-04-30','13:15:00',3.23),('14598','2014-04-30','13:20:00',3.11),('14598','2014-04-30','13:25:00',3.02),('14598','2014-04-30','13:30:00',2.7),('14598','2014-04-30','13:35:00',2.83),('14598','2014-04-30','13:40:00',3.45),('14598','2014-04-30','13:45:00',5.12),('14598','2014-04-30','13:50:00',5.11),('14598','2014-04-30','13:55:00',5.39),('14598','2014-04-30','14:00:00',3.54),('14598','2014-04-30','14:05:00',3.47),('14598','2014-04-30','14:10:00',3.24),('14598','2014-04-30','14:15:00',3.23),('14598','2014-04-30','14:20:00',3.47),('14598','2014-04-30','14:25:00',2.15),('14598','2014-04-30','14:30:00',2.21),('14598','2014-04-30','14:35:00',2.44),('14598','2014-04-30','14:40:00',1.68),('14598','2014-04-30','14:45:00',2.55),('14598','2014-04-30','14:50:00',3.92),('14598','2014-04-30','14:55:00',3.52),('14598','2014-04-30','15:00:00',3.51),('14598','2014-04-30','15:05:00',2.54),('14598','2014-04-30','15:10:00',2.92),('14598','2014-04-30','15:15:00',2.91),('14598','2014-04-30','15:20:00',4.43),('14598','2014-04-30','15:25:00',3.88),('14598','2014-04-30','15:30:00',4.47),('14598','2014-04-30','15:35:00',4.17),('14598','2014-04-30','15:40:00',2.62),('14598','2014-04-30','15:45:00',3.88),('14598','2014-04-30','15:50:00',4.13),('14598','2014-04-30','15:55:00',4.48),('14598','2014-04-30','16:00:00',3.55),('14598','2014-04-30','16:05:00',2.84),('14598','2014-04-30','16:10:00',3.48),('14598','2014-04-30','16:15:00',3.25),('14598','2014-04-30','16:20:00',2.72),('14598','2014-04-30','16:25:00',3.3),('14598','2014-04-30','16:30:00',3.73),('14598','2014-04-30','16:35:00',3.14),('14598','2014-04-30','16:40:00',2.57),('14598','2014-04-30','16:45:00',3.57),('14598','2014-04-30','16:50:00',3.48),('14598','2014-04-30','16:55:00',3.48),('14598','2014-04-30','17:00:00',3.43),('14598','2014-04-30','17:05:00',3.32),('14598','2014-04-30','17:10:00',2.17),('14598','2014-04-30','17:15:00',1.56),('14598','2014-04-30','17:20:00',1.94),('14598','2014-04-30','17:25:00',2.58),('14598','2014-04-30','17:30:00',1.76),('14598','2014-04-30','17:35:00',1.31),('14598','2014-04-30','17:40:00',1.9),('14598','2014-04-30','17:45:00',1.4),('14598','2014-04-30','17:50:00',1.18),('14598','2014-03-07','08:55:00',1.35),('14598','2014-03-07','09:00:00',1.3),('14598','2014-03-07','09:45:00',1.21),('14598','2014-03-07','09:50:00',1.5),('14598','2014-03-07','09:55:00',1.29),('14598','2014-03-07','10:00:00',1.1),('14598','2014-03-07','10:05:00',1.18),('14598','2014-03-07','10:10:00',1.61),('14598','2014-03-07','10:15:00',2.84),('14598','2014-03-07','10:20:00',4.1),('14598','2014-03-07','10:25:00',2.95),('14598','2014-03-07','10:30:00',3.87),('14598','2014-03-07','10:35:00',3.67),('14598','2014-03-07','10:40:00',3.7),('14598','2014-03-07','10:45:00',3.7),('14598','2014-03-07','10:50:00',3.18),('14598','2014-03-07','10:55:00',1.69),('14598','2014-03-07','11:00:00',1.76),('14598','2014-03-07','11:05:00',2.25),('14598','2014-03-07','11:10:00',1.62),('14598','2014-03-07','11:15:00',1.35),('14598','2014-03-07','11:20:00',1.32),('14598','2014-03-07','11:25:00',1.82),('14598','2014-03-07','11:30:00',1.5),('14598','2014-03-07','11:35:00',2.66),('14598','2014-03-07','11:40:00',4.45),('14598','2014-03-07','11:45:00',4.38),('14598','2014-03-07','11:50:00',4.37),('14598','2014-03-07','11:55:00',4.31),('14598','2014-03-07','12:00:00',4.26),('14598','2014-03-07','12:05:00',4.02),('14598','2014-03-07','12:10:00',1.84),('14598','2014-03-07','12:15:00',3.43),('14598','2014-03-07','12:20:00',3.76),('14598','2014-03-07','12:25:00',4.25),('14598','2014-03-07','12:30:00',4.06),('14598','2014-03-07','12:35:00',3.41),('14598','2014-03-07','12:40:00',2.97),('14598','2014-03-07','12:45:00',2.86),('14598','2014-03-07','12:50:00',3.13),('14598','2014-03-07','12:55:00',3.45),('14598','2014-03-07','13:00:00',3.77),('14598','2014-03-07','13:05:00',4.22),('14598','2014-03-07','13:10:00',3.1),('14598','2014-03-07','13:15:00',1.39),('14598','2014-03-07','13:20:00',1.3),('14598','2014-03-07','13:25:00',1.12),('14598','2014-03-07','13:30:00',1.05),('14598','2014-03-07','13:35:00',1.13),('14598','2014-03-07','13:40:00',1.81),('14598','2014-03-07','13:45:00',2.24),('14598','2014-03-07','13:50:00',2.79),('14598','2014-03-07','13:55:00',2.54),('14598','2014-03-07','14:00:00',2.91),('14598','2014-03-07','14:05:00',2.68),('14598','2014-03-07','14:10:00',2.54),('14598','2014-03-07','14:15:00',2.05),('14598','2014-03-07','14:20:00',1.43),('14598','2014-03-07','14:25:00',2.58),('14598','2014-03-07','14:30:00',3.84),('14598','2014-03-07','14:35:00',3.74),('14598','2014-03-07','14:40:00',4.09),('14598','2014-03-07','14:45:00',3.32),('14598','2014-03-07','14:50:00',3.83),('14598','2014-03-07','14:55:00',2.76),('14598','2014-03-07','15:15:00',1.05),('14598','2014-03-07','15:20:00',1.42),('14598','2014-03-07','15:25:00',2.16),('14598','2014-03-07','15:40:00',1.43),('14598','2014-03-07','15:45:00',1.87),('14598','2014-03-07','15:50:00',1.18),('14598','2014-03-07','15:55:00',1.67),('14598','2014-03-07','16:00:00',1.27),('14598','2014-03-07','16:15:00',1.64),('14598','2014-03-07','16:20:00',2.15),('14598','2014-03-07','16:25:00',1.69),('14598','2014-03-07','16:30:00',1.86),('14598','2014-03-07','16:35:00',1.75),('14598','2014-03-07','16:40:00',1.05),('14598','2014-03-06','08:15:00',1.13),('14598','2014-03-06','08:20:00',1.65),('14598','2014-03-06','08:25:00',1.48),('14598','2014-03-06','08:30:00',1.31),('14598','2014-03-06','08:35:00',1.78),('14598','2014-03-06','08:40:00',1.67),('14598','2014-03-06','08:45:00',1.77),('14598','2014-03-06','08:50:00',2.03),('14598','2014-03-06','08:55:00',2.09),('14598','2014-03-06','09:00:00',2.23),('14598','2014-03-06','09:05:00',1.99),('14598','2014-03-06','09:10:00',2.29),('14598','2014-03-06','09:15:00',2.37),('14598','2014-03-06','09:20:00',2.51),('14598','2014-03-06','09:25:00',2.79),('14598','2014-03-06','09:30:00',2.64),('14598','2014-03-06','09:35:00',2.06),('14598','2014-03-06','09:40:00',2.14),('14598','2014-03-06','09:45:00',2.76),('14598','2014-03-06','09:50:00',2.91),('14598','2014-03-06','09:55:00',3.4),('14598','2014-03-06','10:00:00',3.21),('14598','2014-03-06','10:05:00',2.48),('14598','2014-03-06','10:10:00',2.83),('14598','2014-03-06','10:15:00',2.64),('14598','2014-03-06','10:20:00',3),('14598','2014-03-06','10:25:00',3.2),('14598','2014-03-06','10:30:00',3.05),('14598','2014-03-06','10:35:00',3.17),('14598','2014-03-06','10:40:00',3.47),('14598','2014-03-06','10:45:00',3.49),('14598','2014-03-06','10:50:00',3.71),('14598','2014-03-06','10:55:00',4.03),('14598','2014-03-06','11:00:00',4.1),('14598','2014-03-06','11:05:00',4.08),('14598','2014-03-06','11:10:00',1.56),('14598','2014-03-06','11:15:00',1.76),('14598','2014-03-06','11:20:00',1.69),('14598','2014-03-06','11:25:00',1.39),('14598','2014-03-06','11:30:00',1.37),('14598','2014-03-06','11:35:00',1.06),('14598','2014-03-06','11:40:00',1.02),('14598','2014-03-06','11:45:00',3.39),('14598','2014-03-06','11:50:00',4.45),('14598','2014-03-06','11:55:00',1.84),('14598','2014-03-06','12:00:00',2),('14598','2014-03-06','12:05:00',2.01),('14598','2014-03-06','12:10:00',1.88),('14598','2014-03-06','12:15:00',3.3),('14598','2014-03-06','12:20:00',3.09),('14598','2014-03-06','12:25:00',5.49),('14598','2014-03-06','12:30:00',2.48),('14598','2014-03-06','12:35:00',4.3),('14598','2014-03-06','12:40:00',2.01),('14598','2014-03-06','12:45:00',1.67),('14598','2014-03-06','12:50:00',2.94),('14598','2014-03-06','12:55:00',3.15),('14598','2014-03-06','13:00:00',5.01),('14598','2014-03-06','13:05:00',4.71),('14598','2014-03-06','13:10:00',4.83),('14598','2014-03-06','13:15:00',4.86),('14598','2014-03-06','13:20:00',2.77),('14598','2014-03-06','13:25:00',2.17),('14598','2014-03-06','13:30:00',2.63),('14598','2014-03-06','13:35:00',4.47),('14598','2014-03-06','13:40:00',4.11),('14598','2014-03-06','13:45:00',2.57),('14598','2014-03-06','13:50:00',2),('14598','2014-03-06','13:55:00',1.88),('14598','2014-03-06','14:00:00',1.61),('14598','2014-03-06','14:05:00',1.04),('14598','2014-03-06','14:25:00',1.06),('14598','2014-03-06','14:30:00',1.1),('14598','2014-03-06','14:35:00',1.46),('14598','2014-03-06','14:40:00',3.42),('14598','2014-03-06','14:45:00',3.45),('14598','2014-03-06','14:50:00',1.88),('14598','2014-03-06','14:55:00',1.26),('14598','2014-03-06','15:00:00',1.26),('14598','2014-03-06','15:05:00',1.18),('14598','2014-03-06','16:20:00',2.2),('14598','2014-03-06','16:25:00',1.85),('14598','2014-03-06','16:55:00',1.08),('14598','2014-03-05','08:15:00',1.06),('14598','2014-03-05','08:20:00',1.1),('14598','2014-03-05','08:25:00',1.15),('14598','2014-03-05','08:30:00',1.24),('14598','2014-03-05','08:35:00',1.28),('14598','2014-03-05','08:40:00',1.48),('14598','2014-03-05','08:45:00',1.04),('14598','2014-03-05','08:55:00',1.81),('14598','2014-03-05','09:00:00',1.88),('14598','2014-03-05','09:05:00',1.78),('14598','2014-03-05','09:10:00',1.96),('14598','2014-03-05','09:15:00',2.03),('14598','2014-03-05','09:20:00',1.68),('14598','2014-03-05','09:25:00',2.42),('14598','2014-03-05','09:30:00',2.54),('14598','2014-03-05','09:35:00',1.85),('14598','2014-03-05','09:40:00',2.3),('14598','2014-03-05','09:45:00',2.77),('14598','2014-03-05','09:50:00',2.82),('14598','2014-03-05','09:55:00',2.91),('14598','2014-03-05','10:00:00',3),('14598','2014-03-05','10:05:00',3.09),('14598','2014-03-05','10:10:00',3.14),('14598','2014-03-05','10:15:00',3.22),('14598','2014-03-05','10:20:00',3.28),('14598','2014-03-05','10:25:00',3.33),('14598','2014-03-05','10:30:00',3.38),('14598','2014-03-05','10:35:00',3.45),('14598','2014-03-05','10:40:00',3.5),('14598','2014-03-05','10:45:00',3.54),('14598','2014-03-05','10:50:00',3.61),('14598','2014-03-05','10:55:00',3.66),('14598','2014-03-05','11:00:00',3.71),('14598','2014-03-05','11:05:00',3.75),('14598','2014-03-05','11:10:00',3.8),('14598','2014-03-05','11:15:00',3.84),('14598','2014-03-05','11:20:00',3.65),('14598','2014-03-05','11:25:00',4),('14598','2014-03-05','11:30:00',3.91),('14598','2014-03-05','11:35:00',4.6),('14598','2014-03-05','11:40:00',3.29),('14598','2014-03-05','11:45:00',3.78),('14598','2014-03-05','11:50:00',3.42),('14598','2014-03-05','11:55:00',2.14),('14598','2014-03-05','12:00:00',1.28),('14598','2014-03-05','12:05:00',4.39),('14598','2014-03-05','12:10:00',4.44),('14598','2014-03-05','12:15:00',4.06),('14598','2014-03-05','12:20:00',3.04),('14598','2014-03-05','12:25:00',3.94),('14598','2014-03-05','12:30:00',3.52),('14598','2014-03-05','12:35:00',3.53),('14598','2014-03-05','12:40:00',3.67),('14598','2014-03-05','12:45:00',3.57),('14598','2014-03-05','12:50:00',2.57),('14598','2014-03-05','12:55:00',2.99),('14598','2014-03-05','13:00:00',1.99),('14598','2014-03-05','13:05:00',2.35),('14598','2014-03-05','13:10:00',2.9),('14598','2014-03-05','13:15:00',2.32),('14598','2014-03-05','13:20:00',1.64),('14598','2014-03-05','13:25:00',1.4),('14598','2014-03-05','13:30:00',1.1),('14598','2014-03-05','13:35:00',2.23),('14598','2014-03-05','13:40:00',4.1),('14598','2014-03-05','13:45:00',4.49),('14598','2014-03-05','13:50:00',4.2),('14598','2014-03-05','13:55:00',4.32),('14598','2014-03-05','14:00:00',4.52),('14598','2014-03-05','14:05:00',4.08),('14598','2014-03-05','14:10:00',4.8),('14598','2014-03-05','14:15:00',3.91),('14598','2014-03-05','14:20:00',4.62),('14598','2014-03-05','14:25:00',4.87),('14598','2014-03-05','14:30:00',4.91),('14598','2014-03-05','14:35:00',3.22),('14598','2014-03-05','14:40:00',1.79),('14598','2014-03-05','14:45:00',1.82),('14598','2014-03-05','14:50:00',3.78),('14598','2014-03-05','14:55:00',3.14),('14598','2014-03-05','15:00:00',1.92),('14598','2014-03-05','15:05:00',1.59),('14598','2014-03-05','15:10:00',3.07),('14598','2014-03-05','15:15:00',3.18),('14598','2014-03-05','15:20:00',3.9),('14598','2014-03-05','15:25:00',2.78),('14598','2014-03-05','15:30:00',3.22),('14598','2014-03-05','15:35:00',3.51),('14598','2014-03-05','15:40:00',1.8),('14598','2014-03-05','15:50:00',1.2),('14598','2014-03-05','15:55:00',1.27),('14598','2014-03-05','16:00:00',1.49),('14598','2014-03-05','16:05:00',1.11),('14598','2014-03-05','16:15:00',1.25),('14598','2014-03-05','16:20:00',1.26),('14598','2014-03-04','08:35:00',1.03),('14598','2014-03-04','08:40:00',1.05),('14598','2014-03-04','08:45:00',1.55),('14598','2014-03-04','08:50:00',1.34),('14598','2014-03-04','09:50:00',1.64),('14598','2014-03-04','09:55:00',2.87),('14598','2014-03-04','10:00:00',4.18),('14598','2014-03-04','10:05:00',1.68),('14598','2014-03-04','10:10:00',1.4),('14598','2014-03-04','10:15:00',1.74),('14598','2014-03-04','10:20:00',2.21),('14598','2014-03-04','10:25:00',3.1),('14598','2014-03-04','10:30:00',2.42),('14598','2014-03-04','11:05:00',1.15),('14598','2014-03-04','11:10:00',1.26),('14598','2014-03-04','11:15:00',3.84),('14598','2014-03-04','11:20:00',4.66),('14598','2014-03-04','11:25:00',4.51),('14598','2014-03-04','11:30:00',4.88),('14598','2014-03-04','11:35:00',4.74),('14598','2014-03-04','11:40:00',2.56),('14598','2014-03-04','11:45:00',2.63),('14598','2014-03-04','11:50:00',4.08),('14598','2014-03-04','11:55:00',4.44),('14598','2014-03-04','12:00:00',4.28),('14598','2014-03-04','12:05:00',4.13),('14598','2014-03-04','12:10:00',4.26),('14598','2014-03-04','12:15:00',4.15),('14598','2014-03-04','12:20:00',4.3),('14598','2014-03-04','12:25:00',4.31),('14598','2014-03-04','12:30:00',4.33),('14598','2014-03-04','12:35:00',4.37),('14598','2014-03-04','12:40:00',4.31),('14598','2014-03-04','12:45:00',3.88),('14598','2014-03-04','12:50:00',4.37),('14598','2014-03-04','12:55:00',4.62),('14598','2014-03-04','13:00:00',2.04),('14598','2014-03-04','13:10:00',1.59),('14598','2014-03-04','13:15:00',3.11),('14598','2014-03-04','13:20:00',1.79),('14598','2014-03-04','13:25:00',2.55),('14598','2014-03-04','13:30:00',2.13),('14598','2014-03-04','13:35:00',1.53),('14598','2014-03-04','13:40:00',1.46),('14598','2014-03-04','13:45:00',2.23),('14598','2014-03-04','13:50:00',5.14),('14598','2014-03-04','13:55:00',4.54),('14598','2014-03-04','14:00:00',4.23),('14598','2014-03-04','14:05:00',4.37),('14598','2014-03-04','14:10:00',3.7),('14598','2014-03-04','14:15:00',2.06),('14598','2014-03-04','14:20:00',1.98),('14598','2014-03-04','14:25:00',1.56),('14598','2014-03-04','14:30:00',2.13),('14598','2014-03-04','14:35:00',4.23),('14598','2014-03-04','14:40:00',4.05),('14598','2014-03-04','14:45:00',3.83),('14598','2014-03-04','14:50:00',3.73),('14598','2014-03-04','14:55:00',3.64),('14598','2014-03-04','15:00:00',3.63),('14598','2014-03-04','15:05:00',3.6),('14598','2014-03-04','15:10:00',3.47),('14598','2014-03-04','15:15:00',3.37),('14598','2014-03-04','15:20:00',3.3),('14598','2014-03-04','15:25:00',2.16),('14598','2014-03-04','15:30:00',1.49),('14598','2014-03-04','15:35:00',2.47),('14598','2014-03-04','15:40:00',1.56),('14598','2014-03-04','15:45:00',1.6),('14598','2014-03-04','15:50:00',1.74),('14598','2014-03-04','15:55:00',2.76),('14598','2014-03-04','16:00:00',3.09),('14598','2014-03-04','16:05:00',2.56),('14598','2014-03-04','16:10:00',2.44),('14598','2014-03-04','16:15:00',2.24),('14598','2014-03-04','16:20:00',2.06),('14598','2014-03-04','16:25:00',2.04),('14598','2014-03-04','16:30:00',1.97),('14598','2014-03-04','16:35:00',1.7),('14598','2014-03-03','08:30:00',1.13),('14598','2014-03-03','08:35:00',1.22),('14598','2014-03-03','08:40:00',1.33),('14598','2014-03-03','08:45:00',1.51),('14598','2014-03-03','08:50:00',1.67),('14598','2014-03-03','08:55:00',1.82),('14598','2014-03-03','09:00:00',1.87),('14598','2014-03-03','09:05:00',1.21),('14598','2014-03-03','09:10:00',1.57),('14598','2014-03-03','09:15:00',2.05),('14598','2014-03-03','09:20:00',2.28),('14598','2014-03-03','09:25:00',2.38),('14598','2014-03-03','09:30:00',2.46),('14598','2014-03-03','09:35:00',2.56),('14598','2014-03-03','09:40:00',2.65),('14598','2014-03-03','09:45:00',2.73),('14598','2014-03-03','09:50:00',2.81),('14598','2014-03-03','09:55:00',2.88),('14598','2014-03-03','10:00:00',2.97),('14598','2014-03-03','10:05:00',3.03),('14598','2014-03-03','10:10:00',3.09),('14598','2014-03-03','10:15:00',3.16),('14598','2014-03-03','10:20:00',3.21),('14598','2014-03-03','10:25:00',3.26),('14598','2014-03-03','10:30:00',3.33),('14598','2014-03-03','10:35:00',3.39),('14598','2014-03-03','10:40:00',3.45),('14598','2014-03-03','10:45:00',3.51),('14598','2014-03-03','10:50:00',3.56),('14598','2014-03-03','10:55:00',3.62),('14598','2014-03-03','11:00:00',3.71),('14598','2014-03-03','11:05:00',3.77),('14598','2014-03-03','11:10:00',3.82),('14598','2014-03-03','11:15:00',3.86),('14598','2014-03-03','11:20:00',3.91),('14598','2014-03-03','11:25:00',3.96),('14598','2014-03-03','11:30:00',3.99),('14598','2014-03-03','11:35:00',4.03),('14598','2014-03-03','11:40:00',4.04),('14598','2014-03-03','11:45:00',4.12),('14598','2014-03-03','11:50:00',4.15),('14598','2014-03-03','11:55:00',4.18),('14598','2014-03-03','12:00:00',4.21),('14598','2014-03-03','12:05:00',4.23),('14598','2014-03-03','12:10:00',4.25),('14598','2014-03-03','12:15:00',4.27),('14598','2014-03-03','12:20:00',4.28),('14598','2014-03-03','12:25:00',4.29),('14598','2014-03-03','12:30:00',4.3),('14598','2014-03-03','12:35:00',4.31),('14598','2014-03-03','12:40:00',4.32),('14598','2014-03-03','12:45:00',4.32),('14598','2014-03-03','12:50:00',4.31),('14598','2014-03-03','12:55:00',4.3),('14598','2014-03-03','13:00:00',4.32),('14598','2014-03-03','13:05:00',4.31),('14598','2014-03-03','13:10:00',4.3),('14598','2014-03-03','13:15:00',4.28),('14598','2014-03-03','13:20:00',4.26),('14598','2014-03-03','13:25:00',4.24),('14598','2014-03-03','13:30:00',4.22),('14598','2014-03-03','13:35:00',4.18),('14598','2014-03-03','13:40:00',4.16),('14598','2014-03-03','13:45:00',4.13),('14598','2014-03-03','13:50:00',4.1),('14598','2014-03-03','13:55:00',4.09),('14598','2014-03-03','14:00:00',4.06),('14598','2014-03-03','14:05:00',4.03),('14598','2014-03-03','14:10:00',4.01),('14598','2014-03-03','14:15:00',3.97),('14598','2014-03-03','14:20:00',3.93),('14598','2014-03-03','14:25:00',3.89),('14598','2014-03-03','14:30:00',3.85),('14598','2014-03-03','14:35:00',3.8),('14598','2014-03-03','14:40:00',3.7),('14598','2014-03-03','14:45:00',3.7),('14598','2014-03-03','14:50:00',3.64),('14598','2014-03-03','14:55:00',3.58),('14598','2014-03-03','15:00:00',3.53),('14598','2014-03-03','15:05:00',3.46),('14598','2014-03-03','15:10:00',3.4),('14598','2014-03-03','15:15:00',3.34),('14598','2014-03-03','15:20:00',3.25),('14598','2014-03-03','15:25:00',3.17),('14598','2014-03-03','15:30:00',3.1),('14598','2014-03-03','15:35:00',3.01),('14598','2014-03-03','15:40:00',2.93),('14598','2014-03-03','15:45:00',2.85),('14598','2014-03-03','15:50:00',2.76),('14598','2014-03-03','15:55:00',2.66),('14598','2014-03-03','16:00:00',2.58),('14598','2014-03-03','16:05:00',2.48),('14598','2014-03-03','16:10:00',2.38),('14598','2014-03-03','16:15:00',2.29),('14598','2014-03-03','16:20:00',2.18),('14598','2014-03-03','16:25:00',2.07),('14598','2014-03-03','16:30:00',1.96),('14598','2014-03-03','16:35:00',1.8),('14598','2014-03-03','16:40:00',1.75),('14598','2014-03-03','16:45:00',1.65),('14598','2014-03-03','16:50:00',1.55),('14598','2014-03-03','16:55:00',1.44),('14598','2014-03-02','08:10:00',1.24),('14598','2014-03-02','08:15:00',1.16),('14598','2014-03-02','08:20:00',1.21),('14598','2014-03-02','08:25:00',1.65),('14598','2014-03-02','08:30:00',1.68),('14598','2014-03-02','08:35:00',1.92),('14598','2014-03-02','08:40:00',1.04),('14598','2014-03-02','10:10:00',1.28),('14598','2014-03-02','10:15:00',3.01),('14598','2014-03-02','10:20:00',3.62),('14598','2014-03-02','10:25:00',3.68),('14598','2014-03-02','10:30:00',3.66),('14598','2014-03-02','10:35:00',3.64),('14598','2014-03-02','10:40:00',3.36),('14598','2014-03-02','10:45:00',3.07),('14598','2014-03-02','10:50:00',4.2),('14598','2014-03-02','10:55:00',2.07),('14598','2014-03-02','11:00:00',1.69),('14598','2014-03-02','11:05:00',1.37),('14598','2014-03-02','11:10:00',1.16),('14598','2014-03-02','11:15:00',1.3),('14598','2014-03-02','11:20:00',1.5),('14598','2014-03-02','11:25:00',1.77),('14598','2014-03-02','11:30:00',1.73),('14598','2014-03-02','11:35:00',1.41),('14598','2014-03-02','13:15:00',1.06),('14598','2014-03-02','13:20:00',1.09),('14598','2014-03-02','13:25:00',1.04),('14598','2014-03-02','14:20:00',1.03),('14598','2014-03-02','14:25:00',1.09),('14598','2014-03-02','14:30:00',1.15),('14598','2014-03-02','14:35:00',1.21),('14598','2014-03-02','14:40:00',1.25),('14598','2014-03-02','14:45:00',1.27),('14598','2014-03-02','14:50:00',1.27),('14598','2014-03-02','14:55:00',1.3),('14598','2014-03-02','15:00:00',1.33),('14598','2014-03-02','15:05:00',1.39),('14598','2014-03-02','15:10:00',1.43),('14598','2014-03-02','15:15:00',1.47),('14598','2014-03-02','15:20:00',1.53),('14598','2014-03-02','15:25:00',1.57),('14598','2014-03-02','15:30:00',1.5),('14598','2014-03-02','15:35:00',1.39),('14598','2014-03-02','15:40:00',1.3),('14598','2014-03-02','15:45:00',1.22),('14598','2014-03-02','15:50:00',1.14),('14598','2014-03-02','15:55:00',1),('14598','2014-03-01','10:15:00',1.17),('14598','2014-03-01','10:20:00',1.45),('14598','2014-03-01','14:30:00',1.13),('14598','2014-03-01','14:35:00',1),('14598','2014-02-28','08:50:00',1.12),('14598','2014-02-28','08:55:00',1.54),('14598','2014-02-28','09:05:00',1.2),('14598','2014-02-28','09:10:00',1.69),('14598','2014-02-28','09:15:00',1.17),('14598','2014-02-28','09:25:00',1.1),('14598','2014-02-28','09:35:00',1.36),('14598','2014-02-28','09:40:00',2.72),('14598','2014-02-28','09:45:00',1.19),('14598','2014-02-28','09:50:00',1.99),('14598','2014-02-28','09:55:00',2.67),('14598','2014-02-28','10:00:00',1.56),('14598','2014-02-28','10:10:00',1.02),('14598','2014-02-28','10:15:00',1.01),('14598','2014-02-28','11:20:00',1.09),('14598','2014-02-28','11:25:00',1.06),('14598','2014-02-28','12:00:00',1.18),('14598','2014-02-28','12:05:00',1.36),('14598','2014-02-28','12:10:00',1.84),('14598','2014-02-28','12:15:00',2.49),('14598','2014-02-28','12:20:00',2.61),('14598','2014-02-28','12:25:00',2.78),('14598','2014-02-28','12:30:00',2.3),('14598','2014-02-28','12:35:00',1.71),('14598','2014-02-28','12:40:00',3.53),('14598','2014-02-28','12:45:00',4.07),('14598','2014-02-28','12:50:00',3.15),('14598','2014-02-28','12:55:00',4.13),('14598','2014-02-28','13:00:00',2.21),('14598','2014-02-28','13:05:00',3.89),('14598','2014-02-28','13:10:00',2.06),('14598','2014-02-28','13:15:00',1.77),('14598','2014-02-28','13:20:00',1.86),('14598','2014-02-28','13:25:00',2.05),('14598','2014-02-28','13:30:00',2.26),('14598','2014-02-28','13:35:00',2.46),('14598','2014-02-28','13:40:00',1.93),('14598','2014-02-28','13:45:00',1.65),('14598','2014-02-28','13:50:00',1.66),('14598','2014-02-28','13:55:00',1.41),('14598','2014-02-28','14:00:00',1.17),('14598','2014-02-28','14:05:00',1),('14598','2014-02-28','14:10:00',1.01),('14598','2014-02-28','14:15:00',1.04),('14598','2014-02-28','14:25:00',1.38),('14598','2014-02-28','14:30:00',1.77),('14598','2014-02-28','14:35:00',1.01),('14598','2014-02-28','14:45:00',1.14),('14598','2014-02-28','14:50:00',3.5),('14598','2014-02-28','14:55:00',4.15),('14598','2014-02-28','15:00:00',2.72),('14598','2014-02-28','15:05:00',2.97),('14598','2014-02-28','15:10:00',4.33),('14598','2014-02-28','15:15:00',2.14),('14598','2014-02-28','15:20:00',3.17),('14598','2014-02-28','15:25:00',3.05),('14598','2014-02-28','15:30:00',1.71),('14598','2014-02-28','16:30:00',1.07),('14598','2014-02-27','10:40:00',1.17),('14598','2014-02-27','10:45:00',1.3),('14598','2014-02-27','10:50:00',1.4),('14598','2014-02-27','10:55:00',1.45),('14598','2014-02-27','11:00:00',1.55),('14598','2014-02-27','11:05:00',1.63),('14598','2014-02-27','11:10:00',1.7),('14598','2014-02-27','11:15:00',1.66),('14598','2014-02-27','11:20:00',1.59),('14598','2014-02-27','11:25:00',1.59),('14598','2014-02-27','11:30:00',1.57),('14598','2014-02-27','11:35:00',1.57),('14598','2014-02-27','11:40:00',1.59),('14598','2014-02-27','11:45:00',1.6),('14598','2014-02-27','11:50:00',1.62),('14598','2014-02-27','11:55:00',1.65),('14598','2014-02-27','12:00:00',1.7),('14598','2014-02-27','12:05:00',1.76),('14598','2014-02-27','12:10:00',1.8),('14598','2014-02-27','12:15:00',1.87),('14598','2014-02-27','12:20:00',1.91),('14598','2014-02-27','12:25:00',1.95),('14598','2014-02-27','12:30:00',2.01),('14598','2014-02-27','12:35:00',2.06),('14598','2014-02-27','12:40:00',2.02),('14598','2014-02-27','12:45:00',2),('14598','2014-02-27','12:50:00',2.04),('14598','2014-02-27','12:55:00',2.03),('14598','2014-02-27','13:00:00',2.08),('14598','2014-02-27','13:05:00',2.07),('14598','2014-02-27','13:10:00',2.01),('14598','2014-02-27','13:15:00',2.19),('14598','2014-02-27','13:20:00',2.36),('14598','2014-02-27','13:25:00',2.31),('14598','2014-02-27','13:30:00',1.76),('14598','2014-02-27','13:35:00',1.82),('14598','2014-02-27','13:40:00',1.79),('14598','2014-02-27','13:45:00',1.99),('14598','2014-02-27','13:50:00',1.91),('14598','2014-02-27','13:55:00',2.01),('14598','2014-02-27','14:00:00',2.54),('14598','2014-02-27','14:05:00',2.16),('14598','2014-02-27','14:10:00',2.36),('14598','2014-02-27','14:15:00',2.56),('14598','2014-02-27','14:20:00',2.43),('14598','2014-02-27','14:25:00',2.44),('14598','2014-02-27','14:30:00',2.36),('14598','2014-02-27','14:35:00',2.27),('14598','2014-02-27','14:40:00',2.25),('14598','2014-02-27','14:45:00',2.11),('14598','2014-02-27','14:50:00',2.44),('14598','2014-02-27','14:55:00',2.57),('14598','2014-02-27','15:00:00',2.52),('14598','2014-02-27','15:05:00',1.92),('14598','2014-02-27','15:10:00',1.4),('14598','2014-02-27','15:15:00',1.33),('14598','2014-02-27','15:20:00',1.24),('14598','2014-02-27','15:25:00',1.23),('14598','2014-02-27','15:30:00',1.22),('14598','2014-02-27','15:35:00',1.27),('14598','2014-02-27','15:40:00',1.46),('14598','2014-02-27','15:45:00',1.08),('14598','2014-02-27','15:50:00',1.05),('14598','2014-02-27','15:55:00',1.15),('14598','2014-02-27','16:00:00',1.08),('14598','2014-02-27','16:05:00',1.02),('14598','2014-02-27','16:10:00',1.27),('14598','2014-02-27','16:15:00',1.66),('14598','2014-02-27','16:20:00',1.94),('14598','2014-02-27','16:25:00',1.91),('14598','2014-02-27','16:30:00',1.98),('14598','2014-02-27','16:35:00',1.6),('14598','2014-02-27','17:05:00',1.06),('14598','2014-02-26','08:05:00',1.05),('14598','2014-02-26','08:40:00',1.16),('14598','2014-02-26','08:45:00',1.46),('14598','2014-02-26','08:50:00',1.58),('14598','2014-02-26','08:55:00',1.36),('14598','2014-02-26','09:00:00',1.12),('14598','2014-02-26','09:05:00',1.39),('14598','2014-02-26','09:10:00',1.11),('14598','2014-02-26','09:15:00',1),('14598','2014-02-26','09:25:00',1.24),('14598','2014-02-26','10:15:00',1.09),('14598','2014-02-26','10:20:00',1.22),('14598','2014-02-26','10:25:00',1.2),('14598','2014-02-26','10:30:00',1.3),('14598','2014-02-26','10:35:00',1.38),('14598','2014-02-26','10:40:00',1.27),('14598','2014-02-26','10:45:00',1.28),('14598','2014-02-26','10:50:00',1.4),('14598','2014-02-26','10:55:00',1.42),('14598','2014-02-26','11:00:00',1.17),('14598','2014-02-26','11:05:00',1.08),('14598','2014-02-26','11:10:00',1.08),('14598','2014-02-26','11:15:00',1.27),('14598','2014-02-26','11:20:00',1.55),('14598','2014-02-26','11:25:00',1.65),('14598','2014-02-26','11:30:00',1.45),('14598','2014-02-26','11:35:00',1.37),('14598','2014-02-26','11:40:00',1.22),('14598','2014-02-26','11:45:00',1.48),('14598','2014-02-26','11:50:00',1.83),('14598','2014-02-26','11:55:00',2.01),('14598','2014-02-26','12:00:00',2.83),('14598','2014-02-26','12:05:00',3.45),('14598','2014-02-26','12:10:00',3.5),('14598','2014-02-26','12:15:00',3.63),('14598','2014-02-26','12:20:00',3.91),('14598','2014-02-26','12:25:00',3.95),('14598','2014-02-26','12:30:00',3.57),('14598','2014-02-26','12:35:00',3.5),('14598','2014-02-26','12:40:00',3.34),('14598','2014-02-26','12:45:00',3.28),('14598','2014-02-26','12:50:00',3.37),('14598','2014-02-26','12:55:00',3.71),('14598','2014-02-26','13:00:00',3.85),('14598','2014-02-26','13:05:00',3.64),('14598','2014-02-26','13:10:00',3.09),('14598','2014-02-26','13:15:00',3.83),('14598','2014-02-26','13:20:00',4.28),('14598','2014-02-26','13:25:00',4.39),('14598','2014-02-26','13:30:00',4.19),('14598','2014-02-26','13:35:00',3.68),('14598','2014-02-26','13:40:00',2.79),('14598','2014-02-26','13:45:00',3.58),('14598','2014-02-26','13:50:00',3.77),('14598','2014-02-26','13:55:00',3.77),('14598','2014-02-26','14:00:00',3.78),('14598','2014-02-26','14:05:00',3.85),('14598','2014-02-26','14:10:00',3.6),('14598','2014-02-26','14:15:00',3.66),('14598','2014-02-26','14:20:00',3.45),('14598','2014-02-26','14:25:00',3.72),('14598','2014-02-26','14:30:00',3.68),('14598','2014-02-26','14:35:00',3.67),('14598','2014-02-26','14:40:00',3.61),('14598','2014-02-26','14:45:00',3.59),('14598','2014-02-26','14:50:00',3.46),('14598','2014-02-26','14:55:00',2.82),('14598','2014-02-26','15:00:00',2.17),('14598','2014-02-26','15:05:00',1.97),('14598','2014-02-26','15:10:00',2.75),('14598','2014-02-26','15:15:00',3.04),('14598','2014-02-26','15:20:00',2.6),('14598','2014-02-26','15:25:00',2.94),('14598','2014-02-26','15:30:00',2.93),('14598','2014-02-26','15:35:00',3.24),('14598','2014-02-26','15:40:00',2.86),('14598','2014-02-26','15:45:00',2.69),('14598','2014-02-26','15:50:00',2.01),('14598','2014-02-26','15:55:00',1.9),('14598','2014-02-26','16:00:00',2.18),('14598','2014-02-26','16:05:00',1.54),('14598','2014-04-29','09:25:00',1),('14598','2014-04-29','09:30:00',1.11),('14598','2014-04-29','09:35:00',1.38),('14598','2014-04-29','09:40:00',1.25),('14598','2014-04-29','09:45:00',2.99),('14598','2014-04-29','09:50:00',3.25),('14598','2014-04-29','09:55:00',3.26),('14598','2014-04-29','10:00:00',3.63),('14598','2014-04-29','10:05:00',3.68),('14598','2014-04-29','10:10:00',3.71),('14598','2014-04-29','10:15:00',3.85),('14598','2014-04-29','10:20:00',3.32),('14598','2014-04-29','10:25:00',2.87),('14598','2014-04-29','10:30:00',2.37),('14598','2014-04-29','10:35:00',3.98),('14598','2014-04-29','10:40:00',2.34),('14598','2014-04-29','10:45:00',4.22),('14598','2014-04-29','10:50:00',4.41),('14598','2014-04-29','10:55:00',4.3),('14598','2014-04-29','11:00:00',4.39),('14598','2014-04-29','11:05:00',4.46),('14598','2014-04-29','11:10:00',4.67),('14598','2014-04-29','11:15:00',3.13),('14598','2014-04-29','11:20:00',4.79),('14598','2014-04-29','11:25:00',4.91),('14598','2014-04-29','11:30:00',4.93),('14598','2014-04-29','11:35:00',4.89),('14598','2014-04-29','11:40:00',4.67),('14598','2014-04-29','11:45:00',2.81),('14598','2014-04-29','11:50:00',3.09),('14598','2014-04-29','11:55:00',2.84),('14598','2014-04-29','12:00:00',2.43),('14598','2014-04-29','12:05:00',3.27),('14598','2014-04-29','12:10:00',4.78),('14598','2014-04-29','12:15:00',5.11),('14598','2014-04-29','12:20:00',5.13),('14598','2014-04-29','12:25:00',5.19),('14598','2014-04-29','12:30:00',5.18),('14598','2014-04-29','12:35:00',5.16),('14598','2014-04-29','12:40:00',5.2),('14598','2014-04-29','12:45:00',5.15),('14598','2014-04-29','12:50:00',5.2),('14598','2014-04-29','12:55:00',5.23),('14598','2014-04-29','13:00:00',5.24),('14598','2014-04-29','13:05:00',5.26),('14598','2014-04-29','13:10:00',5.26),('14598','2014-04-29','13:15:00',5.25),('14598','2014-04-29','13:20:00',5.26),('14598','2014-04-29','13:25:00',5.25),('14598','2014-04-29','13:30:00',5.27),('14598','2014-04-29','13:35:00',5.28),('14598','2014-04-29','13:40:00',5.26),('14598','2014-04-29','13:45:00',5.26),('14598','2014-04-29','13:50:00',5.25),('14598','2014-04-29','13:55:00',5.29),('14598','2014-04-29','14:00:00',4.85),('14598','2014-04-29','14:05:00',4.65),('14598','2014-04-29','14:10:00',5.14),('14598','2014-04-29','14:15:00',5.24),('14598','2014-04-29','14:20:00',5.21),('14598','2014-04-29','14:25:00',5.18),('14598','2014-04-29','14:30:00',5.15),('14598','2014-04-29','14:35:00',5.12),('14598','2014-04-29','14:40:00',5.11),('14598','2014-04-29','14:45:00',5.14),('14598','2014-04-29','14:50:00',5.03),('14598','2014-04-29','14:55:00',5.54),('14598','2014-04-29','15:00:00',3.65),('14598','2014-04-29','15:05:00',3.61),('14598','2014-04-29','15:10:00',5.22),('14598','2014-04-29','15:15:00',4.94),('14598','2014-04-29','15:20:00',4.89),('14598','2014-04-29','15:25:00',4.8),('14598','2014-04-29','15:30:00',3.98),('14598','2014-04-29','15:35:00',4.73),('14598','2014-04-29','15:40:00',4.68),('14598','2014-04-29','15:45:00',4.64),('14598','2014-04-29','15:50:00',4.57),('14598','2014-04-29','15:55:00',4.55),('14598','2014-04-29','16:00:00',4.54),('14598','2014-04-29','16:05:00',4.44),('14598','2014-04-29','16:10:00',4.37),('14598','2014-04-29','16:15:00',4.36),('14598','2014-04-29','16:20:00',4.29),('14598','2014-04-29','16:25:00',3.38),('14598','2014-04-29','16:30:00',4.37),('14598','2014-04-29','16:35:00',4.6),('14598','2014-04-29','16:40:00',2.87),('14598','2014-04-29','16:45:00',4.36),('14598','2014-04-29','16:50:00',4.12),('14598','2014-04-29','16:55:00',3.72),('14598','2014-04-29','17:00:00',3.59),('14598','2014-04-29','17:05:00',3.48),('14598','2014-04-29','17:10:00',3.39),('14598','2014-04-29','17:15:00',3.33),('14598','2014-04-29','17:20:00',3.24),('14598','2014-04-29','17:25:00',3.15),('14598','2014-04-29','17:30:00',3.05),('14598','2014-04-29','17:35:00',2.97),('14598','2014-04-29','17:40:00',2.89),('14598','2014-04-29','17:45:00',2.82),('14598','2014-04-29','17:50:00',1.94),('14598','2014-04-29','18:25:00',1.39),('14598','2014-04-29','18:35:00',1.83),('14598','2014-04-29','18:40:00',1.68),('14598','2014-04-29','18:45:00',1.43),('14598','2014-04-29','18:50:00',1.31),('14598','2014-02-25','08:35:00',1.02),('14598','2014-02-25','08:40:00',1.12),('14598','2014-02-25','08:45:00',1.25),('14598','2014-02-25','08:50:00',1.37),('14598','2014-02-25','08:55:00',1.49),('14598','2014-02-25','09:00:00',1.59),('14598','2014-02-25','09:05:00',1.7),('14598','2014-02-25','09:10:00',1.8),('14598','2014-02-25','09:15:00',1.9),('14598','2014-02-25','09:20:00',1.99),('14598','2014-02-25','09:25:00',2.08),('14598','2014-02-25','09:30:00',2.17),('14598','2014-02-25','09:35:00',2.26),('14598','2014-02-25','09:40:00',2.35),('14598','2014-02-25','09:45:00',2.43),('14598','2014-02-25','09:50:00',2.51),('14598','2014-02-25','09:55:00',2.59),('14598','2014-02-25','10:00:00',2.67),('14598','2014-02-25','10:05:00',2.74),('14598','2014-02-25','10:10:00',2.82),('14598','2014-02-25','10:15:00',2.89),('14598','2014-02-25','10:20:00',2.96),('14598','2014-02-25','10:25:00',3.02),('14598','2014-02-25','10:30:00',3.1),('14598','2014-02-25','10:35:00',3.15),('14598','2014-02-25','10:40:00',3.19),('14598','2014-02-25','10:45:00',3.26),('14598','2014-02-25','10:50:00',3.3),('14598','2014-02-25','10:55:00',3.36),('14598','2014-02-25','11:00:00',3.4),('14598','2014-02-25','11:05:00',3.45),('14598','2014-02-25','11:10:00',3.49),('14598','2014-02-25','11:15:00',3.53),('14598','2014-02-25','11:20:00',3.56),('14598','2014-02-25','11:25:00',3.58),('14598','2014-02-25','11:30:00',3.59),('14598','2014-02-25','11:35:00',3.65),('14598','2014-02-25','11:40:00',3.69),('14598','2014-02-25','11:45:00',3.76),('14598','2014-02-25','11:50:00',3.84),('14598','2014-02-25','11:55:00',3.88),('14598','2014-02-25','12:00:00',3.9),('14598','2014-02-25','12:05:00',3.92),('14598','2014-02-25','12:10:00',3.96),('14598','2014-02-25','12:15:00',3.97),('14598','2014-02-25','12:20:00',3.99),('14598','2014-02-25','12:25:00',4.01),('14598','2014-02-25','12:30:00',4.02),('14598','2014-02-25','12:35:00',4.05),('14598','2014-02-25','12:40:00',4.05),('14598','2014-02-25','12:45:00',4.02),('14598','2014-02-25','12:50:00',4.05),('14598','2014-02-25','12:55:00',4.06),('14598','2014-02-25','13:00:00',4.06),('14598','2014-02-25','13:05:00',4.05),('14598','2014-02-25','13:10:00',4.04),('14598','2014-02-25','13:15:00',4.05),('14598','2014-02-25','13:20:00',4.02),('14598','2014-02-25','13:25:00',3.96),('14598','2014-02-25','13:30:00',4.02),('14598','2014-02-25','13:35:00',3.95),('14598','2014-02-25','13:40:00',3.76),('14598','2014-02-25','13:45:00',3.89),('14598','2014-02-25','13:50:00',3.54),('14598','2014-02-25','13:55:00',3.69),('14598','2014-02-25','14:00:00',3.34),('14598','2014-02-25','14:05:00',3.11),('14598','2014-02-25','14:10:00',3.24),('14598','2014-02-25','14:15:00',3.31),('14598','2014-02-25','14:20:00',3.84),('14598','2014-02-25','14:25:00',3.86),('14598','2014-02-25','14:30:00',3.73),('14598','2014-02-25','14:35:00',3.62),('14598','2014-02-25','14:40:00',3.8),('14598','2014-02-25','14:45:00',3.55),('14598','2014-02-25','14:50:00',3.49),('14598','2014-02-25','14:55:00',3.42),('14598','2014-02-25','15:00:00',3.41),('14598','2014-02-25','15:05:00',3.11),('14598','2014-02-25','15:10:00',3.09),('14598','2014-02-25','15:15:00',3.13),('14598','2014-02-25','15:20:00',2.51),('14598','2014-02-25','15:25:00',1.39),('14598','2014-02-25','15:30:00',1.66),('14598','2014-02-25','15:35:00',2.1),('14598','2014-02-25','15:40:00',2.17),('14598','2014-02-25','15:45:00',2.12),('14598','2014-02-25','15:50:00',2.04),('14598','2014-02-25','15:55:00',1.35),('14598','2014-02-25','16:00:00',1.43),('14598','2014-02-25','16:05:00',1.68),('14598','2014-02-25','16:10:00',1.45),('14598','2014-02-25','16:15:00',1.05),('14598','2014-02-24','08:25:00',1.09),('14598','2014-02-24','08:30:00',1.04),('14598','2014-02-24','08:40:00',1.28),('14598','2014-02-24','08:45:00',1.31),('14598','2014-02-24','08:50:00',1.19),('14598','2014-02-24','08:55:00',1.33),('14598','2014-02-24','09:00:00',1),('14598','2014-02-24','09:10:00',1.05),('14598','2014-02-24','09:15:00',1.13),('14598','2014-02-24','09:25:00',2.31),('14598','2014-02-24','09:30:00',1.84),('14598','2014-02-24','09:35:00',1.95),('14598','2014-02-24','09:40:00',2.45),('14598','2014-02-24','09:45:00',2.48),('14598','2014-02-24','09:50:00',2.55),('14598','2014-02-24','09:55:00',2.62),('14598','2014-02-24','10:00:00',2.7),('14598','2014-02-24','10:05:00',2.77),('14598','2014-02-24','10:10:00',2.85),('14598','2014-02-24','10:15:00',2.9),('14598','2014-02-24','10:20:00',3),('14598','2014-02-24','10:25:00',3.05),('14598','2014-02-24','10:30:00',3.11),('14598','2014-02-24','10:35:00',3.17),('14598','2014-02-24','10:40:00',3.23),('14598','2014-02-24','10:45:00',3.29),('14598','2014-02-24','10:50:00',3.36),('14598','2014-02-24','10:55:00',3.43),('14598','2014-02-24','11:00:00',3.48),('14598','2014-02-24','11:05:00',3.53),('14598','2014-02-24','11:10:00',3.57),('14598','2014-02-24','11:15:00',3.62),('14598','2014-02-24','11:20:00',3.67),('14598','2014-02-24','11:25:00',3.7),('14598','2014-02-24','11:30:00',3.72),('14598','2014-02-24','11:35:00',3.81),('14598','2014-02-24','11:40:00',3.82),('14598','2014-02-24','11:45:00',3.88),('14598','2014-02-24','11:50:00',3.9),('14598','2014-02-24','11:55:00',3.92),('14598','2014-02-24','12:00:00',3.91),('14598','2014-02-24','12:05:00',3.94),('14598','2014-02-24','12:10:00',3.95),('14598','2014-02-24','12:15:00',3.96),('14598','2014-02-24','12:20:00',4),('14598','2014-02-24','12:25:00',4),('14598','2014-02-24','12:30:00',4),('14598','2014-02-24','12:35:00',4.01),('14598','2014-02-24','12:40:00',4.01),('14598','2014-02-24','12:45:00',4.01),('14598','2014-02-24','12:50:00',4.02),('14598','2014-02-24','12:55:00',4.01),('14598','2014-02-24','13:00:00',4),('14598','2014-02-24','13:05:00',3.99),('14598','2014-02-24','13:10:00',3.99),('14598','2014-02-24','13:15:00',3.97),('14598','2014-02-24','13:20:00',3.92),('14598','2014-02-24','13:25:00',3.96),('14598','2014-02-24','13:30:00',3.98),('14598','2014-02-24','13:35:00',4.02),('14598','2014-02-24','13:40:00',4.17),('14598','2014-02-24','13:45:00',4.15),('14598','2014-02-24','13:50:00',4.41),('14598','2014-02-24','13:55:00',4.11),('14598','2014-02-24','14:00:00',4.65),('14598','2014-02-24','14:05:00',4.79),('14598','2014-02-24','14:10:00',3.62),('14598','2014-02-24','14:15:00',3.73),('14598','2014-02-24','14:20:00',2.99),('14598','2014-02-24','14:25:00',3.88),('14598','2014-02-24','14:30:00',4.48),('14598','2014-02-24','14:35:00',2.05),('14598','2014-02-24','14:45:00',2.37),('14598','2014-02-24','14:50:00',1.68),('14598','2014-02-24','14:55:00',2.12),('14598','2014-02-24','15:00:00',3.23),('14598','2014-02-24','15:05:00',3.09),('14598','2014-02-24','15:10:00',3.08),('14598','2014-02-24','15:15:00',2.98),('14598','2014-02-24','15:20:00',2.91),('14598','2014-02-24','15:25:00',2.89),('14598','2014-02-24','15:30:00',2.84),('14598','2014-02-24','15:35:00',2.75),('14598','2014-02-24','15:40:00',2.68),('14598','2014-02-24','15:45:00',2.65),('14598','2014-02-24','15:50:00',2.54),('14598','2014-02-24','15:55:00',2.45),('14598','2014-02-24','16:00:00',2.31),('14598','2014-02-24','16:05:00',2.16),('14598','2014-02-24','16:10:00',2.06),('14598','2014-02-24','16:15:00',1.96),('14598','2014-02-24','16:20:00',1.85),('14598','2014-02-24','16:25:00',1.77),('14598','2014-02-24','16:30:00',1.67),('14598','2014-02-24','16:35:00',1.56),('14598','2014-02-24','16:40:00',1.44),('14598','2014-02-24','16:45:00',1.31),('14598','2014-02-24','16:50:00',1.19),('14598','2014-02-24','16:55:00',1.09),('14598','2014-02-23','08:40:00',1.08),('14598','2014-02-23','08:45:00',1.24),('14598','2014-02-23','08:50:00',1.43),('14598','2014-02-23','08:55:00',1.62),('14598','2014-02-23','09:00:00',1.76),('14598','2014-02-23','09:05:00',1.7),('14598','2014-02-23','09:10:00',1.38),('14598','2014-02-23','09:15:00',1.56),('14598','2014-02-23','09:20:00',1.52),('14598','2014-02-23','09:25:00',2.08),('14598','2014-02-23','09:30:00',2.09),('14598','2014-02-23','09:35:00',2.25),('14598','2014-02-23','09:40:00',2.34),('14598','2014-02-23','09:45:00',2.43),('14598','2014-02-23','09:50:00',2.52),('14598','2014-02-23','09:55:00',2.61),('14598','2014-02-23','10:00:00',2.69),('14598','2014-02-23','10:05:00',2.75),('14598','2014-02-23','10:10:00',2.85),('14598','2014-02-23','10:15:00',2.6),('14598','2014-02-23','10:20:00',2.88),('14598','2014-02-23','10:25:00',2.97),('14598','2014-02-23','10:30:00',3.04),('14598','2014-02-23','10:35:00',3.19),('14598','2014-02-23','10:40:00',3.25),('14598','2014-02-23','10:45:00',3.32),('14598','2014-02-23','10:50:00',3.4),('14598','2014-02-23','10:55:00',3.53),('14598','2014-02-23','11:00:00',3.38),('14598','2014-02-23','11:05:00',3.14),('14598','2014-02-23','11:10:00',2.98),('14598','2014-02-23','11:15:00',3.16),('14598','2014-02-23','11:20:00',2.95),('14598','2014-02-23','11:25:00',3.16),('14598','2014-02-23','11:30:00',3.88),('14598','2014-02-23','11:35:00',3.97),('14598','2014-02-23','11:40:00',3.87),('14598','2014-02-23','11:45:00',3.15),('14598','2014-02-23','11:50:00',2.22),('14598','2014-02-23','11:55:00',3.37),('14598','2014-02-23','12:00:00',3.99),('14598','2014-02-23','12:05:00',3.23),('14598','2014-02-23','12:10:00',2.89),('14598','2014-02-23','12:15:00',2.78),('14598','2014-02-23','12:20:00',3.43),('14598','2014-02-23','12:25:00',3.27),('14598','2014-02-23','12:30:00',4.22),('14598','2014-02-23','12:35:00',4.18),('14598','2014-02-23','12:40:00',4.16),('14598','2014-02-23','12:45:00',4.19),('14598','2014-02-23','12:50:00',4.22),('14598','2014-02-23','12:55:00',4.39),('14598','2014-02-23','13:00:00',4.41),('14598','2014-02-23','13:05:00',4.54),('14598','2014-02-23','13:10:00',3.43),('14598','2014-02-23','13:15:00',3.89),('14598','2014-02-23','13:20:00',3.74),('14598','2014-02-23','13:25:00',1.74),('14598','2014-02-23','13:30:00',2.73),('14598','2014-02-23','13:35:00',2.75),('14598','2014-02-23','13:40:00',3.62),('14598','2014-02-23','13:45:00',3.59),('14598','2014-02-23','13:50:00',2.81),('14598','2014-02-23','13:55:00',2.08),('14598','2014-02-23','14:00:00',2.14),('14598','2014-02-23','14:05:00',1.67),('14598','2014-02-23','14:10:00',1.56),('14598','2014-02-23','14:15:00',1.97),('14598','2014-02-23','14:20:00',2.98),('14598','2014-02-23','14:25:00',3.41),('14598','2014-02-23','14:30:00',3.56),('14598','2014-02-23','14:35:00',2.92),('14598','2014-02-23','14:40:00',3.64),('14598','2014-02-23','14:45:00',3.58),('14598','2014-02-23','14:50:00',3.1),('14598','2014-02-23','14:55:00',2),('14598','2014-02-23','15:00:00',3.02),('14598','2014-02-23','15:05:00',3.24),('14598','2014-02-23','15:10:00',3.1),('14598','2014-02-23','15:15:00',3),('14598','2014-02-23','15:20:00',2.78),('14598','2014-02-23','15:25:00',2.54),('14598','2014-02-23','15:30:00',2.7),('14598','2014-02-23','15:35:00',1.78),('14598','2014-02-23','15:40:00',2.13),('14598','2014-02-23','15:45:00',2.7),('14598','2014-02-23','15:50:00',2.68),('14598','2014-02-23','15:55:00',2.53),('14598','2014-02-23','16:00:00',2.54),('14598','2014-02-23','16:05:00',2.4),('14598','2014-02-23','16:10:00',2.13),('14598','2014-02-23','16:15:00',1.66),('14598','2014-02-23','16:20:00',1.36),('14598','2014-02-23','16:25:00',1.16),('14598','2014-02-23','16:30:00',1.29),('14598','2014-02-23','16:35:00',1.41),('14598','2014-02-23','16:40:00',1.5),('14598','2014-02-23','16:45:00',1.32),('14598','2014-02-23','16:50:00',1.39),('14598','2014-02-23','16:55:00',1.37),('14598','2014-02-23','17:00:00',1.36),('14598','2014-02-23','17:05:00',1.35),('14598','2014-02-23','17:10:00',1.42),('14598','2014-02-23','17:15:00',1.36),('14598','2014-02-23','17:20:00',1.06),('14598','2014-02-22','09:00:00',1.55),('14598','2014-02-22','09:05:00',1.23),('14598','2014-02-22','09:10:00',1.12),('14598','2014-02-22','09:25:00',1.25),('14598','2014-02-22','09:30:00',1.47),('14598','2014-02-22','09:35:00',1.74),('14598','2014-02-22','09:40:00',1.65),('14598','2014-02-22','09:45:00',1.8),('14598','2014-02-22','09:50:00',1.22),('14598','2014-02-22','09:55:00',1.17),('14598','2014-02-22','10:00:00',1.9),('14598','2014-02-22','10:05:00',1.03),('14598','2014-02-22','10:10:00',1.42),('14598','2014-02-22','10:15:00',1.48),('14598','2014-02-22','10:20:00',1.47),('14598','2014-02-22','10:25:00',1.21),('14598','2014-02-22','11:05:00',1.02),('14598','2014-02-22','11:10:00',1.01),('14598','2014-02-22','11:15:00',1.21),('14598','2014-02-22','11:20:00',1.2),('14598','2014-02-22','11:25:00',1.2),('14598','2014-02-22','11:30:00',1.45),('14598','2014-02-22','11:35:00',1.49),('14598','2014-02-22','11:40:00',2.25),('14598','2014-02-22','11:45:00',1.6),('14598','2014-02-22','11:50:00',1.46),('14598','2014-02-22','11:55:00',1.46),('14598','2014-02-22','12:00:00',3.71),('14598','2014-02-22','12:05:00',3.6),('14598','2014-02-22','12:10:00',3.49),('14598','2014-02-22','12:15:00',4.15),('14598','2014-02-22','12:20:00',4.31),('14598','2014-02-22','12:25:00',3.36),('14598','2014-02-22','12:30:00',1.9),('14598','2014-02-22','12:35:00',4.36),('14598','2014-02-22','12:40:00',4.19),('14598','2014-02-22','12:45:00',4.4),('14598','2014-02-22','12:50:00',3.14),('14598','2014-02-22','12:55:00',2.12),('14598','2014-02-22','13:00:00',4.25),('14598','2014-02-22','13:05:00',3.59),('14598','2014-02-22','13:10:00',2.09),('14598','2014-02-22','13:15:00',4.06),('14598','2014-02-22','13:20:00',4.4),('14598','2014-02-22','13:25:00',3.83),('14598','2014-02-22','13:30:00',4.12),('14598','2014-02-22','13:35:00',4.23),('14598','2014-02-22','13:40:00',3.11),('14598','2014-02-22','13:45:00',3.54),('14598','2014-02-22','13:50:00',2.41),('14598','2014-02-22','13:55:00',3.08),('14598','2014-02-22','14:00:00',3.1),('14598','2014-02-22','14:05:00',1.87),('14598','2014-02-22','14:10:00',4.24),('14598','2014-02-22','14:15:00',3.52),('14598','2014-02-22','14:20:00',4.08),('14598','2014-02-22','14:25:00',3.72),('14598','2014-02-22','14:30:00',3.74),('14598','2014-02-22','14:35:00',3.11),('14598','2014-02-22','14:40:00',2.94),('14598','2014-02-22','14:45:00',3.06),('14598','2014-02-22','14:50:00',3.66),('14598','2014-02-22','14:55:00',3.48),('14598','2014-02-22','15:00:00',3.17),('14598','2014-02-22','15:05:00',3.57),('14598','2014-02-22','15:10:00',2.82),('14598','2014-02-22','15:15:00',3.1),('14598','2014-02-22','15:20:00',2.89),('14598','2014-02-22','15:25:00',2.92),('14598','2014-02-22','15:30:00',2.99),('14598','2014-02-22','15:35:00',2.76),('14598','2014-02-22','15:40:00',2.51),('14598','2014-02-22','15:45:00',2.78),('14598','2014-02-22','15:50:00',2.58),('14598','2014-02-22','15:55:00',2.28),('14598','2014-02-22','16:00:00',2.29),('14598','2014-02-22','16:05:00',1.57),('14598','2014-02-22','16:10:00',1.66),('14598','2014-02-22','16:40:00',1.5),('14598','2014-02-22','16:45:00',1.44),('14598','2014-02-22','16:50:00',1.23),('14598','2014-02-21','09:25:00',1.3),('14598','2014-02-21','09:30:00',1.98),('14598','2014-02-21','09:35:00',2.09),('14598','2014-02-21','09:40:00',1.39),('14598','2014-02-21','09:45:00',1.68),('14598','2014-02-21','09:50:00',2.13),('14598','2014-02-21','09:55:00',2.47),('14598','2014-02-21','10:00:00',2.84),('14598','2014-02-21','10:05:00',2.04),('14598','2014-02-21','10:10:00',2.69),('14598','2014-02-21','10:15:00',2.38),('14598','2014-02-21','10:20:00',2.46),('14598','2014-02-21','10:25:00',2.98),('14598','2014-02-21','10:30:00',3.48),('14598','2014-02-21','10:35:00',3.31),('14598','2014-02-21','10:40:00',3.69),('14598','2014-02-21','10:45:00',3.07),('14598','2014-02-21','10:50:00',1.39),('14598','2014-02-21','10:55:00',1.33),('14598','2014-02-21','11:00:00',1.08),('14598','2014-02-21','11:15:00',1.13),('14598','2014-02-21','11:20:00',1.58),('14598','2014-02-21','11:25:00',2.29),('14598','2014-02-21','11:30:00',3.72),('14598','2014-02-21','11:35:00',3.86),('14598','2014-02-21','11:40:00',4.69),('14598','2014-02-21','11:45:00',3.21),('14598','2014-02-21','11:50:00',2.22),('14598','2014-02-21','11:55:00',2.1),('14598','2014-02-21','12:00:00',2.14),('14598','2014-02-21','12:05:00',2.73),('14598','2014-02-21','12:10:00',2.28),('14598','2014-02-21','12:15:00',2.28),('14598','2014-02-21','12:20:00',1.81),('14598','2014-02-21','12:25:00',1.37),('14598','2014-02-21','12:30:00',1.25),('14598','2014-02-21','12:35:00',1.17),('14598','2014-02-21','12:40:00',1.25),('14598','2014-02-21','12:45:00',1.34),('14598','2014-02-21','12:50:00',1.27),('14598','2014-02-21','12:55:00',1.44),('14598','2014-02-21','13:00:00',1.8),('14598','2014-02-21','13:05:00',3.01),('14598','2014-02-21','13:10:00',3.39),('14598','2014-02-21','13:15:00',2.14),('14598','2014-02-21','13:20:00',1.8),('14598','2014-02-21','13:25:00',1.51),('14598','2014-02-21','13:30:00',1.5),('14598','2014-02-21','13:35:00',1.89),('14598','2014-02-21','13:40:00',1.96),('14598','2014-02-21','13:45:00',1.95),('14598','2014-02-21','13:50:00',2.19),('14598','2014-02-21','13:55:00',2.24),('14598','2014-02-21','14:00:00',1.96),('14598','2014-02-21','14:05:00',3.02),('14598','2014-02-21','14:10:00',3.32),('14598','2014-02-21','14:15:00',4.03),('14598','2014-02-21','14:20:00',3.42),('14598','2014-02-21','14:25:00',3.15),('14598','2014-02-21','14:30:00',3.42),('14598','2014-02-21','14:35:00',3.35),('14598','2014-02-21','14:40:00',3.28),('14598','2014-02-21','14:45:00',3.26),('14598','2014-02-21','14:50:00',3.2),('14598','2014-02-21','14:55:00',3.13),('14598','2014-02-21','15:00:00',3.06),('14598','2014-02-21','15:05:00',3),('14598','2014-02-21','15:10:00',2.93),('14598','2014-02-21','15:15:00',2.85),('14598','2014-02-21','15:20:00',2.78),('14598','2014-02-21','15:25:00',2.71),('14598','2014-02-21','15:30:00',2.63),('14598','2014-02-21','15:35:00',2.54),('14598','2014-02-21','15:40:00',2.46),('14598','2014-02-21','15:45:00',2.38),('14598','2014-02-21','15:50:00',2.27),('14598','2014-02-21','15:55:00',2.2),('14598','2014-02-21','16:00:00',2.08),('14598','2014-02-21','16:05:00',1.97),('14598','2014-02-21','16:10:00',1.86),('14598','2014-02-21','16:15:00',1.76),('14598','2014-02-21','16:20:00',1.65),('14598','2014-02-21','16:25:00',1.54),('14598','2014-02-21','16:30:00',1.43),('14598','2014-02-21','16:35:00',1.33),('14598','2014-02-21','16:40:00',1.24),('14598','2014-02-21','16:45:00',1.15),('14598','2014-02-21','16:50:00',1.05),('14598','2014-02-20','09:35:00',1.03),('14598','2014-02-20','09:40:00',1.2),('14598','2014-02-20','09:45:00',1.18),('14598','2014-02-20','09:50:00',1.12),('14598','2014-02-20','09:55:00',1.07),('14598','2014-02-20','10:00:00',1.13),('14598','2014-02-20','10:05:00',1.04),('14598','2014-02-20','10:10:00',1.07),('14598','2014-02-20','10:15:00',1.15),('14598','2014-02-20','10:20:00',1.19),('14598','2014-02-20','10:25:00',1.37),('14598','2014-02-20','10:30:00',1.41),('14598','2014-02-20','10:35:00',1.47),('14598','2014-02-20','10:40:00',1.49),('14598','2014-02-20','10:45:00',1.55),('14598','2014-02-20','10:50:00',1.73),('14598','2014-02-20','10:55:00',1.93),('14598','2014-02-20','11:00:00',1.99),('14598','2014-02-20','11:05:00',1.67),('14598','2014-02-20','11:10:00',1.69),('14598','2014-02-20','11:15:00',1.85),('14598','2014-02-20','11:20:00',1.65),('14598','2014-02-20','11:25:00',1.74),('14598','2014-02-20','11:30:00',1.58),('14598','2014-02-20','11:35:00',1.72),('14598','2014-02-20','11:40:00',1.57),('14598','2014-02-20','11:45:00',1.37),('14598','2014-02-20','11:50:00',1.39),('14598','2014-02-20','11:55:00',1.61),('14598','2014-02-20','12:00:00',1.75),('14598','2014-02-20','12:05:00',1.74),('14598','2014-02-20','12:10:00',2),('14598','2014-02-20','12:15:00',1.94),('14598','2014-02-20','12:20:00',1.56),('14598','2014-02-20','12:25:00',1.69),('14598','2014-02-20','12:30:00',1.64),('14598','2014-02-20','12:35:00',1.58),('14598','2014-02-20','12:40:00',1.86),('14598','2014-02-20','12:45:00',1.87),('14598','2014-02-20','12:50:00',1.69),('14598','2014-02-20','12:55:00',1.97),('14598','2014-02-20','13:00:00',1.62),('14598','2014-02-20','13:05:00',1.82),('14598','2014-02-20','13:10:00',1.58),('14598','2014-02-20','13:15:00',1.83),('14598','2014-02-20','13:20:00',1.73),('14598','2014-02-20','13:25:00',1.49),('14598','2014-02-20','13:30:00',1.51),('14598','2014-02-20','13:35:00',1.48),('14598','2014-02-20','13:40:00',1.43),('14598','2014-02-20','13:45:00',1.44),('14598','2014-02-20','13:50:00',1.27),('14598','2014-02-20','13:55:00',1.36),('14598','2014-02-20','14:00:00',1.61),('14598','2014-02-20','14:05:00',1.41),('14598','2014-02-20','14:10:00',1.05),('14598','2014-02-20','14:15:00',1.03),('14598','2014-02-20','14:20:00',1.08),('14598','2014-02-20','14:25:00',1.01),('14598','2014-02-19','09:35:00',1.06),('14598','2014-02-19','09:40:00',1.16),('14598','2014-02-19','09:45:00',1.22),('14598','2014-02-19','09:50:00',1.28),('14598','2014-02-19','09:55:00',1.42),('14598','2014-02-19','10:00:00',1.41),('14598','2014-02-19','10:05:00',1.37),('14598','2014-02-19','10:10:00',1.34),('14598','2014-02-19','10:15:00',1.27),('14598','2014-02-19','10:20:00',1.19),('14598','2014-02-19','10:25:00',1.14),('14598','2014-02-19','10:30:00',1.22),('14598','2014-02-19','10:35:00',1.34),('14598','2014-02-19','10:40:00',1.35),('14598','2014-02-19','10:45:00',1.37),('14598','2014-02-19','10:50:00',1.51),('14598','2014-02-19','10:55:00',1.33),('14598','2014-02-19','11:00:00',1.44),('14598','2014-02-19','11:05:00',1.28),('14598','2014-02-19','11:10:00',1.05),('14598','2014-02-19','11:15:00',1.29),('14598','2014-02-19','11:20:00',1.3),('14598','2014-02-19','11:25:00',1.3),('14598','2014-02-19','11:40:00',1.73),('14598','2014-02-19','11:45:00',2.04),('14598','2014-02-19','11:50:00',2.14),('14598','2014-02-19','11:55:00',2.5),('14598','2014-02-19','12:00:00',2.32),('14598','2014-02-19','12:05:00',2.79),('14598','2014-02-19','12:10:00',2.65),('14598','2014-02-19','12:15:00',2.67),('14598','2014-02-19','12:20:00',2.4),('14598','2014-02-19','12:25:00',2.81),('14598','2014-02-19','12:30:00',2.73),('14598','2014-02-19','12:35:00',2.51),('14598','2014-02-19','12:40:00',1.94),('14598','2014-02-19','12:45:00',1.84),('14598','2014-02-19','12:50:00',2.5),('14598','2014-02-19','12:55:00',2.18),('14598','2014-02-19','13:00:00',2.12),('14598','2014-02-19','13:05:00',2.5),('14598','2014-02-19','13:10:00',2.41),('14598','2014-02-19','13:15:00',2.04),('14598','2014-02-19','13:20:00',1.78),('14598','2014-02-19','13:25:00',1.72),('14598','2014-02-19','13:30:00',1.81),('14598','2014-02-19','13:35:00',1.66),('14598','2014-02-19','13:40:00',1.65),('14598','2014-02-19','13:45:00',1.74),('14598','2014-02-19','13:50:00',1.46),('14598','2014-02-19','13:55:00',1.35),('14598','2014-02-19','14:00:00',1.44),('14598','2014-02-19','14:05:00',1.48),('14598','2014-02-19','14:10:00',1.6),('14598','2014-02-19','14:15:00',1.26),('14598','2014-02-19','14:20:00',1.41),('14598','2014-02-19','14:25:00',1.63),('14598','2014-02-19','14:30:00',1.75),('14598','2014-02-19','14:35:00',1.49),('14598','2014-02-19','14:40:00',1.42),('14598','2014-02-19','14:45:00',1.15),('14598','2014-02-19','14:50:00',1.57),('14598','2014-02-19','14:55:00',2.07),('14598','2014-02-19','15:00:00',1.23),('14598','2014-02-19','15:05:00',1.32),('14598','2014-02-19','15:15:00',1.31),('14598','2014-02-19','15:20:00',1.17),('14598','2014-02-19','15:25:00',1.18),('14598','2014-02-19','15:35:00',1.04),('14598','2014-02-19','15:40:00',1.02),('14598','2014-02-19','15:55:00',1.06),('14598','2014-02-18','08:45:00',1.03),('14598','2014-02-18','08:50:00',1.14),('14598','2014-02-18','08:55:00',1.26),('14598','2014-02-18','09:00:00',1.36),('14598','2014-02-18','09:05:00',1.45),('14598','2014-02-18','09:10:00',1.55),('14598','2014-02-18','09:15:00',1.64),('14598','2014-02-18','09:20:00',1.74),('14598','2014-02-18','09:25:00',1.83),('14598','2014-02-18','09:30:00',1.89),('14598','2014-02-18','09:35:00',2.01),('14598','2014-02-18','09:40:00',2.09),('14598','2014-02-18','09:45:00',2.19),('14598','2014-02-18','09:50:00',2.24),('14598','2014-02-18','09:55:00',2.42),('14598','2014-02-18','10:00:00',2.49),('14598','2014-02-18','10:05:00',2.57),('14598','2014-02-18','10:10:00',2.57),('14598','2014-02-18','10:15:00',2.68),('14598','2014-02-18','10:20:00',2.76),('14598','2014-02-18','10:25:00',2.82),('14598','2014-02-18','10:30:00',2.88),('14598','2014-02-18','10:35:00',2.95),('14598','2014-02-18','10:40:00',2.93),('14598','2014-02-18','10:45:00',3.05),('14598','2014-02-18','10:50:00',3.13),('14598','2014-02-18','10:55:00',3.16),('14598','2014-02-18','11:00:00',3.2),('14598','2014-02-18','11:05:00',3.3),('14598','2014-02-18','11:10:00',3.15),('14598','2014-02-18','11:15:00',3.36),('14598','2014-02-18','11:20:00',2.96),('14598','2014-02-18','11:25:00',2.23),('14598','2014-02-18','11:30:00',1.7),('14598','2014-02-18','11:35:00',1.42),('14598','2014-02-18','11:40:00',1.31),('14598','2014-02-18','11:45:00',1.31),('14598','2014-02-18','11:50:00',1.43),('14598','2014-02-18','11:55:00',1.52),('14598','2014-02-18','12:00:00',1.54),('14598','2014-02-18','12:05:00',1.61),('14598','2014-02-18','12:10:00',1.75),('14598','2014-02-18','12:15:00',2.14),('14598','2014-02-18','12:20:00',2.78),('14598','2014-02-18','12:25:00',2.23),('14598','2014-02-18','12:30:00',1.84),('14598','2014-02-18','12:35:00',1.79),('14598','2014-02-18','12:40:00',1.69),('14598','2014-02-18','12:45:00',1.57),('14598','2014-02-18','12:50:00',1.67),('14598','2014-02-18','12:55:00',1.64),('14598','2014-02-18','13:00:00',1.58),('14598','2014-02-18','13:05:00',1.63),('14598','2014-02-18','13:10:00',1.8),('14598','2014-02-18','13:15:00',2.5),('14598','2014-02-18','13:20:00',3.22),('14598','2014-02-18','13:25:00',2.73),('14598','2014-02-18','13:30:00',2.4),('14598','2014-02-18','13:35:00',2.92),('14598','2014-02-18','13:40:00',2.7),('14598','2014-02-18','13:45:00',2.33),('14598','2014-02-18','13:50:00',1.91),('14598','2014-02-18','13:55:00',1.64),('14598','2014-02-18','14:00:00',2.26),('14598','2014-02-18','14:05:00',2.27),('14598','2014-02-18','14:10:00',1.59),('14598','2014-02-18','14:15:00',1.41),('14598','2014-02-18','14:20:00',1.37),('14598','2014-02-18','14:25:00',1.4),('14598','2014-02-18','14:30:00',1.35),('14598','2014-02-18','14:35:00',1.3),('14598','2014-02-18','14:40:00',1.25),('14598','2014-02-18','14:45:00',1.22),('14598','2014-02-18','14:50:00',1.13),('14598','2014-02-18','14:55:00',1.02),('14598','2014-02-18','15:15:00',1.04),('14598','2014-02-18','15:20:00',1.15),('14598','2014-02-18','15:25:00',1.54),('14598','2014-02-18','15:30:00',1.46),('14598','2014-02-18','15:35:00',1.32),('14598','2014-02-18','15:40:00',1.14),('14598','2014-02-18','15:45:00',1.07),('14598','2014-02-18','15:50:00',1.3),('14598','2014-02-18','15:55:00',1.42),('14598','2014-02-18','16:00:00',1.55),('14598','2014-02-18','16:05:00',1.5),('14598','2014-02-18','16:10:00',1.07),('14598','2014-02-17','08:50:00',1.05),('14598','2014-02-17','08:55:00',1.16),('14598','2014-02-17','09:00:00',1.27),('14598','2014-02-17','09:05:00',1.37),('14598','2014-02-17','09:10:00',1.46),('14598','2014-02-17','09:15:00',1.54),('14598','2014-02-17','09:20:00',1.64),('14598','2014-02-17','09:25:00',1.75),('14598','2014-02-17','09:30:00',1.84),('14598','2014-02-17','09:35:00',1.91),('14598','2014-02-17','09:40:00',1.99),('14598','2014-02-17','09:45:00',2.05),('14598','2014-02-17','09:50:00',2.12),('14598','2014-02-17','09:55:00',2.18),('14598','2014-02-17','10:00:00',2.25),('14598','2014-02-17','10:05:00',2.31),('14598','2014-02-17','10:10:00',2.39),('14598','2014-02-17','10:15:00',2.44),('14598','2014-02-17','10:20:00',2.5),('14598','2014-02-17','10:25:00',2.55),('14598','2014-02-17','10:30:00',2.6),('14598','2014-02-17','10:35:00',2.68),('14598','2014-02-17','10:40:00',2.71),('14598','2014-02-17','10:45:00',2.76),('14598','2014-02-17','10:50:00',2.81),('14598','2014-02-17','10:55:00',2.86),('14598','2014-02-17','11:00:00',2.91),('14598','2014-02-17','11:05:00',2.95),('14598','2014-02-17','11:10:00',3),('14598','2014-02-17','11:15:00',3.04),('14598','2014-02-17','11:20:00',3.09),('14598','2014-02-17','11:25:00',3.14),('14598','2014-02-17','11:30:00',3.22),('14598','2014-02-17','11:35:00',3.26),('14598','2014-02-17','11:40:00',3.29),('14598','2014-02-17','11:45:00',3.3),('14598','2014-02-17','11:50:00',3.38),('14598','2014-02-17','11:55:00',3.44),('14598','2014-02-17','12:00:00',3.46),('14598','2014-02-17','12:05:00',3.48),('14598','2014-02-17','12:10:00',3.48),('14598','2014-02-17','12:15:00',3.48),('14598','2014-02-17','12:20:00',3.5),('14598','2014-02-17','12:25:00',3.52),('14598','2014-02-17','12:30:00',3.53),('14598','2014-02-17','12:35:00',3.54),('14598','2014-02-17','12:40:00',3.55),('14598','2014-02-17','12:45:00',3.55),('14598','2014-02-17','12:50:00',3.54),('14598','2014-02-17','12:55:00',3.53),('14598','2014-02-17','13:00:00',3.53),('14598','2014-02-17','13:05:00',3.53),('14598','2014-02-17','13:10:00',3.53),('14598','2014-02-17','13:15:00',3.54),('14598','2014-02-17','13:20:00',3.51),('14598','2014-02-17','13:25:00',3.49),('14598','2014-02-17','13:30:00',3.39),('14598','2014-02-17','13:35:00',3.48),('14598','2014-02-17','13:40:00',3.43),('14598','2014-02-17','13:45:00',3.38),('14598','2014-02-17','13:50:00',3.32),('14598','2014-02-17','13:55:00',3.32),('14598','2014-02-17','14:00:00',3.31),('14598','2014-02-17','14:05:00',3.17),('14598','2014-02-17','14:10:00',3.28),('14598','2014-02-17','14:15:00',3.21),('14598','2014-02-17','14:20:00',3.15),('14598','2014-02-17','14:25:00',2.98),('14598','2014-02-17','14:30:00',2.96),('14598','2014-02-17','14:35:00',2.85),('14598','2014-02-17','14:40:00',2.85),('14598','2014-02-17','14:45:00',2.76),('14598','2014-02-17','14:50:00',2.78),('14598','2014-02-17','14:55:00',2.72),('14598','2014-02-17','15:00:00',2.58),('14598','2014-02-17','15:05:00',2.64),('14598','2014-02-17','15:10:00',2.62),('14598','2014-02-17','15:15:00',2.44),('14598','2014-02-17','15:20:00',2.46),('14598','2014-02-17','15:25:00',2.37),('14598','2014-02-17','15:30:00',2.3),('14598','2014-02-17','15:35:00',2.21),('14598','2014-02-17','15:40:00',2.14),('14598','2014-02-17','15:45:00',2.05),('14598','2014-02-17','15:50:00',1.96),('14598','2014-02-17','15:55:00',1.83),('14598','2014-02-17','16:00:00',1.77),('14598','2014-02-17','16:05:00',1.67),('14598','2014-02-17','16:10:00',1.54),('14598','2014-02-17','16:15:00',1.46),('14598','2014-02-17','16:20:00',1.35),('14598','2014-02-17','16:25:00',1.19),('14598','2014-02-17','16:30:00',1.1),('14598','2014-02-17','16:35:00',1.01),('14598','2014-02-16','08:45:00',1.04),('14598','2014-02-16','08:50:00',1.15),('14598','2014-02-16','08:55:00',1.28),('14598','2014-02-16','09:00:00',1.17),('14598','2014-02-16','09:05:00',1.34),('14598','2014-02-16','09:10:00',1.47),('14598','2014-02-16','09:15:00',1.51),('14598','2014-02-16','09:20:00',1.4),('14598','2014-02-16','09:25:00',1.69),('14598','2014-02-16','09:30:00',1.88),('14598','2014-02-16','09:35:00',1.96),('14598','2014-02-16','09:40:00',1.98),('14598','2014-02-16','09:45:00',1.97),('14598','2014-02-16','09:50:00',2.23),('14598','2014-02-16','09:55:00',2.41),('14598','2014-02-16','10:00:00',2.43),('14598','2014-02-16','10:05:00',2.42),('14598','2014-02-16','10:10:00',2.63),('14598','2014-02-16','10:15:00',2.82),('14598','2014-02-16','10:20:00',2.86),('14598','2014-02-16','10:25:00',2.85),('14598','2014-02-16','10:30:00',2.97),('14598','2014-02-16','10:35:00',2.66),('14598','2014-02-16','10:40:00',2.77),('14598','2014-02-16','10:45:00',3.04),('14598','2014-02-16','10:50:00',3),('14598','2014-02-16','10:55:00',3.03),('14598','2014-02-16','11:00:00',3.08),('14598','2014-02-16','11:05:00',2.76),('14598','2014-02-16','11:10:00',2.76),('14598','2014-02-16','11:15:00',3.03),('14598','2014-02-16','11:20:00',3.38),('14598','2014-02-16','11:25:00',3.11),('14598','2014-02-16','11:30:00',2.95),('14598','2014-02-16','11:35:00',3.11),('14598','2014-02-16','11:40:00',3.41),('14598','2014-02-16','11:45:00',3.53),('14598','2014-02-16','11:50:00',3.48),('14598','2014-02-16','11:55:00',3.57),('14598','2014-02-16','12:00:00',3.6),('14598','2014-02-16','12:05:00',3.61),('14598','2014-02-16','12:10:00',3.6),('14598','2014-02-16','12:15:00',3.59),('14598','2014-02-16','12:20:00',3.6),('14598','2014-02-16','12:25:00',3.62),('14598','2014-02-16','12:30:00',3.62),('14598','2014-02-16','12:35:00',3.62),('14598','2014-02-16','12:40:00',3.63),('14598','2014-02-16','12:45:00',3.62),('14598','2014-02-16','12:50:00',3.69),('14598','2014-02-16','12:55:00',3.59),('14598','2014-02-16','13:00:00',3.69),('14598','2014-02-16','13:05:00',3.74),('14598','2014-02-16','13:10:00',3.71),('14598','2014-02-16','13:15:00',3.68),('14598','2014-02-16','13:20:00',3.69),('14598','2014-02-16','13:25:00',3.66),('14598','2014-02-16','13:30:00',3.74),('14598','2014-02-16','13:35:00',3.53),('14598','2014-02-16','13:40:00',3.63),('14598','2014-02-16','13:45:00',3.64),('14598','2014-02-16','13:50:00',3.63),('14598','2014-02-16','13:55:00',3.6),('14598','2014-02-16','14:00:00',3.52),('14598','2014-02-16','14:05:00',3.5),('14598','2014-02-16','14:10:00',3.48),('14598','2014-02-16','14:15:00',3.48),('14598','2014-02-16','14:20:00',3.38),('14598','2014-02-16','14:25:00',3.2),('14598','2014-02-16','14:30:00',3.34),('14598','2014-02-16','14:35:00',3.32),('14598','2014-02-16','14:40:00',2.7),('14598','2014-02-16','14:45:00',3.03),('14598','2014-02-16','14:50:00',3.15),('14598','2014-02-16','14:55:00',3.04),('14598','2014-02-16','15:00:00',2.97),('14598','2014-02-16','15:05:00',2.9),('14598','2014-02-16','15:10:00',2.82),('14598','2014-02-16','15:15:00',2.77),('14598','2014-02-16','15:20:00',2.69),('14598','2014-02-16','15:25:00',2.24),('14598','2014-02-16','15:30:00',1.96),('14598','2014-02-16','15:35:00',1.88),('14598','2014-02-16','15:40:00',2.04),('14598','2014-02-16','15:50:00',1.6),('14598','2014-02-16','15:55:00',1.02),('14598','2014-02-16','16:00:00',1.28),('14598','2014-02-16','16:05:00',2.33),('14598','2014-02-16','16:10:00',1.94),('14598','2014-02-16','16:15:00',2.04),('14598','2014-02-16','16:20:00',1.91),('14598','2014-02-16','16:25:00',1.34),('14598','2014-02-16','16:30:00',1.32),('14598','2014-04-28','07:40:00',1.1),('14598','2014-04-28','08:20:00',1.88),('14598','2014-04-28','08:25:00',1.54),('14598','2014-04-28','08:30:00',1.71),('14598','2014-04-28','08:35:00',1.43),('14598','2014-04-28','08:40:00',1.79),('14598','2014-04-28','08:45:00',1.71),('14598','2014-04-28','08:50:00',1.55),('14598','2014-04-28','08:55:00',1.72),('14598','2014-04-28','09:00:00',1.67),('14598','2014-04-28','09:05:00',1.75),('14598','2014-04-28','09:10:00',1.54),('14598','2014-04-28','09:15:00',1.27),('14598','2014-04-28','09:20:00',1.32),('14598','2014-04-28','09:25:00',1.4),('14598','2014-04-28','09:30:00',1.49),('14598','2014-04-28','09:35:00',1.55),('14598','2014-04-28','09:40:00',1.18),('14598','2014-04-28','09:45:00',1.63),('14598','2014-04-28','09:50:00',1.48),('14598','2014-04-28','09:55:00',1.46),('14598','2014-04-28','10:00:00',1.97),('14598','2014-04-28','10:05:00',2.85),('14598','2014-04-28','10:10:00',3.58),('14598','2014-04-28','10:15:00',4.2),('14598','2014-04-28','10:20:00',2.1),('14598','2014-04-28','10:25:00',2.25),('14598','2014-04-28','10:30:00',2.92),('14598','2014-04-28','10:35:00',2.79),('14598','2014-04-28','10:40:00',2.35),('14598','2014-04-28','10:45:00',2.28),('14598','2014-04-28','10:50:00',1.65),('14598','2014-04-28','10:55:00',1.32),('14598','2014-04-28','11:00:00',1.32),('14598','2014-04-28','11:05:00',1.4),('14598','2014-04-28','11:10:00',1.42),('14598','2014-04-28','11:15:00',1.68),('14598','2014-04-28','11:20:00',2.33),('14598','2014-04-28','11:25:00',2.89),('14598','2014-04-28','11:30:00',2.53),('14598','2014-04-28','11:35:00',2.58),('14598','2014-04-28','11:40:00',2.62),('14598','2014-04-28','11:45:00',2.53),('14598','2014-04-28','11:50:00',2.44),('14598','2014-04-28','11:55:00',2.36),('14598','2014-04-28','12:00:00',3.11),('14598','2014-04-28','12:05:00',3.64),('14598','2014-04-28','12:10:00',2.53),('14598','2014-04-28','12:15:00',2.85),('14598','2014-04-28','12:20:00',3.59),('14598','2014-04-28','12:25:00',4.11),('14598','2014-04-28','12:30:00',4.34),('14598','2014-04-28','12:35:00',4.32),('14598','2014-04-28','12:40:00',4.98),('14598','2014-04-28','12:45:00',5.61),('14598','2014-04-28','12:50:00',5.45),('14598','2014-04-28','12:55:00',5.69),('14598','2014-04-28','13:00:00',5.39),('14598','2014-04-28','13:05:00',3.94),('14598','2014-04-28','13:10:00',3.56),('14598','2014-04-28','13:15:00',3.24),('14598','2014-04-28','13:20:00',3.97),('14598','2014-04-28','13:25:00',5.73),('14598','2014-04-28','13:30:00',5.71),('14598','2014-04-28','13:35:00',5.35),('14598','2014-04-28','13:40:00',5.1),('14598','2014-04-28','13:45:00',5.24),('14598','2014-04-28','13:50:00',5.25),('14598','2014-04-28','13:55:00',5.28),('14598','2014-04-28','14:00:00',4.98),('14598','2014-04-28','14:05:00',4.22),('14598','2014-04-28','14:10:00',4.94),('14598','2014-04-28','14:15:00',5.29),('14598','2014-04-28','14:20:00',5.04),('14598','2014-04-28','14:25:00',5.17),('14598','2014-04-28','14:30:00',5.15),('14598','2014-04-28','14:35:00',5.14),('14598','2014-04-28','14:40:00',5.21),('14598','2014-04-28','14:45:00',5.08),('14598','2014-04-28','14:50:00',4.99),('14598','2014-04-28','14:55:00',4.68),('14598','2014-04-28','15:00:00',3.74),('14598','2014-04-28','15:05:00',4.93),('14598','2014-04-28','15:10:00',4.79),('14598','2014-04-28','15:15:00',5.07),('14598','2014-04-28','15:20:00',4.76),('14598','2014-04-28','15:25:00',4.94),('14598','2014-04-28','15:30:00',4.68),('14598','2014-04-28','15:35:00',5),('14598','2014-04-28','15:40:00',3),('14598','2014-04-28','15:45:00',2.83),('14598','2014-04-28','15:50:00',2.32),('14598','2014-04-28','15:55:00',1.51),('14598','2014-04-28','16:15:00',1.54),('14598','2014-04-28','16:20:00',1.69),('14598','2014-04-28','16:25:00',3.85),('14598','2014-04-28','16:30:00',3.92),('14598','2014-04-28','16:35:00',2.03),('14598','2014-04-28','16:40:00',3.77),('14598','2014-04-28','16:45:00',3.36),('14598','2014-04-28','16:50:00',1.52),('14598','2014-04-28','16:55:00',1.73),('14598','2014-04-28','17:00:00',3.25),('14598','2014-04-28','17:05:00',1.98),('14598','2014-04-28','17:10:00',1.92),('14598','2014-04-28','17:15:00',2.23),('14598','2014-04-28','17:20:00',2.73),('14598','2014-04-28','17:25:00',1.92),('14598','2014-04-28','17:30:00',1.82),('14598','2014-04-28','17:35:00',1.6),('14598','2014-04-28','17:40:00',1.66),('14598','2014-04-28','17:45:00',1.68),('14598','2014-04-28','17:50:00',1.34),('14598','2014-04-28','17:55:00',1.13),('14598','2014-04-28','18:00:00',1.17),('14598','2014-04-28','18:05:00',1.14),('14598','2014-04-28','18:10:00',1.11),('14598','2014-04-28','18:15:00',1.16),('14598','2014-04-28','18:20:00',1.3),('14598','2014-04-28','18:25:00',1.23),('14598','2014-04-28','18:30:00',1.25),('14598','2014-04-28','18:35:00',1.12),('14598','2014-02-15','08:50:00',1.01),('14598','2014-02-15','08:55:00',1.14),('14598','2014-02-15','09:00:00',1.25),('14598','2014-02-15','09:05:00',1.34),('14598','2014-02-15','09:10:00',1.43),('14598','2014-02-15','09:15:00',1.47),('14598','2014-02-15','09:20:00',1.62),('14598','2014-02-15','09:25:00',1.71),('14598','2014-02-15','09:30:00',1.79),('14598','2014-02-15','09:35:00',1.88),('14598','2014-02-15','09:40:00',1.95),('14598','2014-02-15','09:45:00',2),('14598','2014-02-15','09:50:00',2.11),('14598','2014-02-15','09:55:00',2.19),('14598','2014-02-15','10:00:00',2.25),('14598','2014-02-15','10:05:00',2.32),('14598','2014-02-15','10:10:00',2.34),('14598','2014-02-15','10:15:00',2.47),('14598','2014-02-15','10:20:00',2.53),('14598','2014-02-15','10:25:00',2.61),('14598','2014-02-15','10:30:00',2.69),('14598','2014-02-15','10:35:00',2.73),('14598','2014-02-15','10:40:00',2.8),('14598','2014-02-15','10:45:00',2.86),('14598','2014-02-15','10:50:00',2.94),('14598','2014-02-15','10:55:00',2.94),('14598','2014-02-15','11:00:00',2.92),('14598','2014-02-15','11:05:00',2.63),('14598','2014-02-15','11:10:00',2.52),('14598','2014-02-15','11:15:00',2.46),('14598','2014-02-15','11:20:00',3.06),('14598','2014-02-15','11:25:00',3.22),('14598','2014-02-15','11:30:00',3.43),('14598','2014-02-15','11:35:00',3.44),('14598','2014-02-15','11:40:00',3.45),('14598','2014-02-15','11:45:00',3.47),('14598','2014-02-15','11:50:00',3.53),('14598','2014-02-15','11:55:00',3.56),('14598','2014-02-15','12:00:00',3.56),('14598','2014-02-15','12:05:00',3.6),('14598','2014-02-15','12:10:00',3.64),('14598','2014-02-15','12:15:00',3.66),('14598','2014-02-15','12:20:00',3.67),('14598','2014-02-15','12:25:00',3.7),('14598','2014-02-15','12:30:00',3.71),('14598','2014-02-15','12:35:00',3.72),('14598','2014-02-15','12:40:00',3.72),('14598','2014-02-15','12:45:00',3.72),('14598','2014-02-15','12:50:00',3.73),('14598','2014-02-15','12:55:00',3.73),('14598','2014-02-15','13:00:00',3.73),('14598','2014-02-15','13:05:00',3.73),('14598','2014-02-15','13:10:00',3.73),('14598','2014-02-15','13:15:00',3.72),('14598','2014-02-15','13:20:00',3.7),('14598','2014-02-15','13:25:00',3.68),('14598','2014-02-15','13:30:00',3.67),('14598','2014-02-15','13:35:00',3.65),('14598','2014-02-15','13:40:00',3.62),('14598','2014-02-15','13:45:00',3.6),('14598','2014-02-15','13:50:00',3.58),('14598','2014-02-15','13:55:00',3.55),('14598','2014-02-15','14:00:00',3.48),('14598','2014-02-15','14:05:00',3.47),('14598','2014-02-15','14:10:00',3.43),('14598','2014-02-15','14:15:00',3.41),('14598','2014-02-15','14:20:00',3.37),('14598','2014-02-15','14:25:00',3.33),('14598','2014-02-15','14:30:00',3.27),('14598','2014-02-15','14:35:00',3.21),('14598','2014-02-15','14:40:00',3.17),('14598','2014-02-15','14:45:00',3.11),('14598','2014-02-15','14:50:00',3.07),('14598','2014-02-15','14:55:00',2.99),('14598','2014-02-15','15:00:00',2.94),('14598','2014-02-15','15:05:00',2.87),('14598','2014-02-15','15:10:00',2.81),('14598','2014-02-15','15:15:00',2.74),('14598','2014-02-15','15:20:00',2.67),('14598','2014-02-15','15:25:00',2.59),('14598','2014-02-15','15:30:00',2.51),('14598','2014-02-15','15:35:00',2.44),('14598','2014-02-15','15:40:00',2.36),('14598','2014-02-15','15:45:00',2.27),('14598','2014-02-15','15:50:00',2.18),('14598','2014-02-15','15:55:00',2.09),('14598','2014-02-15','16:00:00',1.99),('14598','2014-02-15','16:05:00',1.9),('14598','2014-02-15','16:10:00',1.81),('14598','2014-02-15','16:15:00',1.7),('14598','2014-02-15','16:20:00',1.6),('14598','2014-02-15','16:25:00',1.5),('14598','2014-02-15','16:30:00',1.4),('14598','2014-02-15','16:35:00',1.29),('14598','2014-02-15','16:40:00',1.17),('14598','2014-02-15','16:45:00',1.06),('14598','2014-02-14','08:55:00',1.09),('14598','2014-02-14','09:00:00',1.16),('14598','2014-02-14','09:05:00',1.31),('14598','2014-02-14','09:10:00',1.42),('14598','2014-02-14','09:15:00',1.49),('14598','2014-02-14','09:20:00',1.58),('14598','2014-02-14','09:25:00',1.67),('14598','2014-02-14','09:30:00',1.76),('14598','2014-02-14','09:35:00',1.86),('14598','2014-02-14','09:40:00',1.95),('14598','2014-02-14','09:45:00',2.02),('14598','2014-02-14','09:50:00',2.11),('14598','2014-02-14','09:55:00',2.19),('14598','2014-02-14','10:00:00',2.29),('14598','2014-02-14','10:05:00',2.36),('14598','2014-02-14','10:10:00',2.47),('14598','2014-02-14','10:15:00',2.51),('14598','2014-02-14','10:20:00',2.63),('14598','2014-02-14','10:25:00',2.68),('14598','2014-02-14','10:30:00',2.78),('14598','2014-02-14','10:35:00',2.83),('14598','2014-02-14','10:40:00',2.87),('14598','2014-02-14','10:45:00',2.91),('14598','2014-02-14','10:50:00',3.05),('14598','2014-02-14','10:55:00',3.11),('14598','2014-02-14','11:00:00',3.17),('14598','2014-02-14','11:05:00',3.24),('14598','2014-02-14','11:10:00',3.3),('14598','2014-02-14','11:15:00',3.36),('14598','2014-02-14','11:20:00',3.41),('14598','2014-02-14','11:25:00',3.45),('14598','2014-02-14','11:30:00',3.48),('14598','2014-02-14','11:35:00',3.51),('14598','2014-02-14','11:40:00',3.55),('14598','2014-02-14','11:45:00',3.58),('14598','2014-02-14','11:50:00',3.61),('14598','2014-02-14','11:55:00',3.63),('14598','2014-02-14','12:00:00',3.61),('14598','2014-02-14','12:05:00',3.7),('14598','2014-02-14','12:10:00',3.71),('14598','2014-02-14','12:15:00',3.73),('14598','2014-02-14','12:20:00',3.78),('14598','2014-02-14','12:25:00',3.8),('14598','2014-02-14','12:30:00',3.82),('14598','2014-02-14','12:35:00',3.83),('14598','2014-02-14','12:40:00',3.83),('14598','2014-02-14','12:45:00',3.83),('14598','2014-02-14','12:50:00',3.83),('14598','2014-02-14','12:55:00',3.83),('14598','2014-02-14','13:00:00',3.79),('14598','2014-02-14','13:05:00',3.77),('14598','2014-02-14','13:10:00',3.79),('14598','2014-02-14','13:15:00',3.79),('14598','2014-02-14','13:20:00',3.79),('14598','2014-02-14','13:25:00',3.76),('14598','2014-02-14','13:30:00',3.74),('14598','2014-02-14','13:35:00',3.7),('14598','2014-02-14','13:40:00',3.67),('14598','2014-02-14','13:45:00',3.65),('14598','2014-02-14','13:50:00',3.64),('14598','2014-02-14','13:55:00',3.61),('14598','2014-02-14','14:00:00',3.56),('14598','2014-02-14','14:05:00',3.5),('14598','2014-02-14','14:10:00',3.47),('14598','2014-02-14','14:15:00',3.41),('14598','2014-02-14','14:20:00',3.36),('14598','2014-02-14','14:25:00',3.33),('14598','2014-02-14','14:30:00',3.28),('14598','2014-02-14','14:35:00',3.25),('14598','2014-02-14','14:40:00',3.2),('14598','2014-02-14','14:45:00',3.15),('14598','2014-02-14','14:50:00',3.09),('14598','2014-02-14','14:55:00',3.03),('14598','2014-02-14','15:00:00',2.9),('14598','2014-02-14','15:05:00',2.88),('14598','2014-02-14','15:10:00',2.81),('14598','2014-02-14','15:15:00',2.72),('14598','2014-02-14','15:20:00',2.65),('14598','2014-02-14','15:25:00',2.59),('14598','2014-02-14','15:30:00',2.51),('14598','2014-02-14','15:35:00',2.41),('14598','2014-02-14','15:40:00',2.29),('14598','2014-02-14','15:45:00',2.2),('14598','2014-02-14','15:50:00',2.14),('14598','2014-02-14','15:55:00',2.05),('14598','2014-02-14','16:00:00',1.95),('14598','2014-02-14','16:05:00',1.83),('14598','2014-02-14','16:10:00',1.74),('14598','2014-02-14','16:15:00',1.64),('14598','2014-02-14','16:20:00',1.55),('14598','2014-02-14','16:25:00',1.43),('14598','2014-02-14','16:30:00',1.32),('14598','2014-02-14','16:35:00',1.23),('14598','2014-02-14','16:40:00',1.13),('14598','2014-02-14','16:45:00',1.02),('14598','2014-02-13','08:55:00',1.1),('14598','2014-02-13','09:00:00',1.2),('14598','2014-02-13','09:05:00',1.29),('14598','2014-02-13','09:10:00',1.39),('14598','2014-02-13','09:15:00',1.5),('14598','2014-02-13','09:20:00',1.61),('14598','2014-02-13','09:25:00',1.7),('14598','2014-02-13','09:30:00',1.79),('14598','2014-02-13','09:35:00',1.89),('14598','2014-02-13','09:40:00',1.98),('14598','2014-02-13','09:45:00',2.06),('14598','2014-02-13','09:50:00',2.15),('14598','2014-02-13','09:55:00',2.25),('14598','2014-02-13','10:00:00',2.33),('14598','2014-02-13','10:05:00',2.41),('14598','2014-02-13','10:10:00',2.48),('14598','2014-02-13','10:15:00',2.56),('14598','2014-02-13','10:20:00',2.64),('14598','2014-02-13','10:25:00',2.68),('14598','2014-02-13','10:30:00',2.75),('14598','2014-02-13','10:35:00',2.79),('14598','2014-02-13','10:40:00',2.84),('14598','2014-02-13','10:45:00',2.9),('14598','2014-02-13','10:50:00',2.96),('14598','2014-02-13','10:55:00',3),('14598','2014-02-13','11:00:00',3.08),('14598','2014-02-13','11:05:00',3.17),('14598','2014-02-13','11:10:00',3.22),('14598','2014-02-13','11:15:00',3.29),('14598','2014-02-13','11:20:00',2.66),('14598','2014-02-13','11:25:00',3.31),('14598','2014-02-13','11:30:00',3.41),('14598','2014-02-13','11:35:00',3.42),('14598','2014-02-13','11:40:00',3.45),('14598','2014-02-13','11:45:00',3.49),('14598','2014-02-13','11:50:00',3.54),('14598','2014-02-13','11:55:00',3.57),('14598','2014-02-13','12:00:00',3.62),('14598','2014-02-13','12:05:00',3.56),('14598','2014-02-13','12:10:00',3.69),('14598','2014-02-13','12:15:00',3.71),('14598','2014-02-13','12:20:00',3.72),('14598','2014-02-13','12:25:00',3.72),('14598','2014-02-13','12:30:00',3.74),('14598','2014-02-13','12:35:00',3.75),('14598','2014-02-13','12:40:00',3.76),('14598','2014-02-13','12:45:00',3.77),('14598','2014-02-13','12:50:00',3.78),('14598','2014-02-13','12:55:00',3.78),('14598','2014-02-13','13:00:00',3.79),('14598','2014-02-13','13:05:00',3.77),('14598','2014-02-13','13:10:00',3.76),('14598','2014-02-13','13:15:00',3.75),('14598','2014-02-13','13:20:00',3.7),('14598','2014-02-13','13:25:00',3.69),('14598','2014-02-13','13:30:00',3.69),('14598','2014-02-13','13:35:00',3.67),('14598','2014-02-13','13:40:00',3.66),('14598','2014-02-13','13:45:00',3.62),('14598','2014-02-13','13:50:00',3.58),('14598','2014-02-13','13:55:00',3.57),('14598','2014-02-13','14:00:00',3.54),('14598','2014-02-13','14:05:00',3.5),('14598','2014-02-13','14:10:00',3.46),('14598','2014-02-13','14:15:00',3.41),('14598','2014-02-13','14:20:00',3.36),('14598','2014-02-13','14:25:00',3.32),('14598','2014-02-13','14:30:00',3.27),('14598','2014-02-13','14:35:00',3.22),('14598','2014-02-13','14:40:00',3.17),('14598','2014-02-13','14:45:00',3.12),('14598','2014-02-13','14:50:00',3.07),('14598','2014-02-13','14:55:00',3.02),('14598','2014-02-13','15:00:00',2.95),('14598','2014-02-13','15:05:00',2.88),('14598','2014-02-13','15:10:00',2.82),('14598','2014-02-13','15:15:00',2.76),('14598','2014-02-13','15:20:00',2.68),('14598','2014-02-13','15:25:00',2.6),('14598','2014-02-13','15:30:00',2.52),('14598','2014-02-13','15:35:00',2.42),('14598','2014-02-13','15:40:00',2.34),('14598','2014-02-13','15:45:00',2.26),('14598','2014-02-13','15:50:00',2.07),('14598','2014-02-13','15:55:00',1.69),('14598','2014-02-13','16:00:00',1.93),('14598','2014-02-13','16:05:00',1.35),('14598','2014-02-13','16:10:00',1.76),('14598','2014-02-13','16:15:00',1.51),('14598','2014-02-13','16:45:00',1.13),('14598','2014-02-12','09:25:00',1.09),('14598','2014-02-12','09:30:00',1.26),('14598','2014-02-12','09:35:00',1.26),('14598','2014-02-12','09:40:00',1.75),('14598','2014-02-12','09:45:00',1.69),('14598','2014-02-12','09:50:00',1.9),('14598','2014-02-12','09:55:00',1.43),('14598','2014-02-12','10:05:00',1.15),('14598','2014-02-12','10:10:00',1.38),('14598','2014-02-12','10:15:00',1.72),('14598','2014-02-12','10:20:00',1.76),('14598','2014-02-12','10:25:00',1.34),('14598','2014-02-12','10:30:00',1.18),('14598','2014-02-12','10:35:00',1.09),('14598','2014-02-12','10:40:00',1.11),('14598','2014-02-12','10:45:00',1.13),('14598','2014-02-12','10:50:00',1.01),('14598','2014-02-12','11:00:00',1.27),('14598','2014-02-12','11:05:00',1.73),('14598','2014-02-12','11:10:00',1.42),('14598','2014-02-12','11:15:00',1.72),('14598','2014-02-12','11:20:00',2.18),('14598','2014-02-12','11:25:00',1.72),('14598','2014-02-12','11:30:00',1.26),('14598','2014-02-12','11:35:00',1.38),('14598','2014-02-12','11:40:00',1.63),('14598','2014-02-12','11:45:00',1.63),('14598','2014-02-12','11:50:00',1.43),('14598','2014-02-12','11:55:00',1.56),('14598','2014-02-12','12:00:00',1.74),('14598','2014-02-12','12:05:00',2.12),('14598','2014-02-12','12:10:00',2.12),('14598','2014-02-12','12:15:00',2.17),('14598','2014-02-12','12:20:00',1.98),('14598','2014-02-12','12:25:00',1.7),('14598','2014-02-12','12:30:00',1.76),('14598','2014-02-12','12:35:00',1.93),('14598','2014-02-12','12:40:00',2.33),('14598','2014-02-12','12:45:00',2.82),('14598','2014-02-12','12:50:00',3.08),('14598','2014-02-12','12:55:00',2.43),('14598','2014-02-12','13:00:00',2.77),('14598','2014-02-12','13:05:00',2.85),('14598','2014-02-12','13:10:00',2.3),('14598','2014-02-12','13:15:00',2.63),('14598','2014-02-12','13:20:00',1.78),('14598','2014-02-12','13:25:00',1.6),('14598','2014-02-12','13:30:00',1.79),('14598','2014-02-12','13:35:00',1.74),('14598','2014-02-12','13:40:00',1.76),('14598','2014-02-12','13:45:00',1.6),('14598','2014-02-12','13:50:00',1.52),('14598','2014-02-12','13:55:00',1.66),('14598','2014-02-12','14:00:00',1.94),('14598','2014-02-12','14:05:00',2.58),('14598','2014-02-12','14:10:00',4.65),('14598','2014-02-12','14:15:00',4.47),('14598','2014-02-12','14:20:00',4.04),('14598','2014-02-12','14:25:00',3.78),('14598','2014-02-12','14:30:00',3.56),('14598','2014-02-12','14:35:00',3.35),('14598','2014-02-12','14:40:00',3.03),('14598','2014-02-12','14:45:00',3.17),('14598','2014-02-12','14:50:00',2.93),('14598','2014-02-12','14:55:00',2.75),('14598','2014-02-12','15:00:00',2.8),('14598','2014-02-12','15:05:00',3),('14598','2014-02-12','15:10:00',2.82),('14598','2014-02-12','15:15:00',2.33),('14598','2014-02-12','15:20:00',2.84),('14598','2014-02-12','15:25:00',2.66),('14598','2014-02-12','15:30:00',2.56),('14598','2014-02-12','15:35:00',2.48),('14598','2014-02-12','15:40:00',2.33),('14598','2014-02-12','15:45:00',1.79),('14598','2014-02-12','15:50:00',2.1),('14598','2014-02-12','15:55:00',1.69),('14598','2014-02-12','16:00:00',1.09),('14598','2014-02-12','16:05:00',1.69),('14598','2014-02-12','16:10:00',1.18),('14598','2014-02-11','09:55:00',1.03),('14598','2014-02-11','10:00:00',1.24),('14598','2014-02-11','10:05:00',1.97),('14598','2014-02-11','10:10:00',1.78),('14598','2014-02-11','10:15:00',1.67),('14598','2014-02-11','10:20:00',1.79),('14598','2014-02-11','10:25:00',1.68),('14598','2014-02-11','10:30:00',1.69),('14598','2014-02-11','10:35:00',1.77),('14598','2014-02-11','10:40:00',1.56),('14598','2014-02-11','10:45:00',1.66),('14598','2014-02-11','10:50:00',1.88),('14598','2014-02-11','10:55:00',1.89),('14598','2014-02-11','11:00:00',1.57),('14598','2014-02-11','11:05:00',1.48),('14598','2014-02-11','11:10:00',1.48),('14598','2014-02-11','11:15:00',1.54),('14598','2014-02-11','11:20:00',1.75),('14598','2014-02-11','11:25:00',2.13),('14598','2014-02-11','11:30:00',2.03),('14598','2014-02-11','11:35:00',2.45),('14598','2014-02-11','11:40:00',2.32),('14598','2014-02-11','11:45:00',2.47),('14598','2014-02-11','11:50:00',2.52),('14598','2014-02-11','11:55:00',2.51),('14598','2014-02-11','12:00:00',2.47),('14598','2014-02-11','12:05:00',2.43),('14598','2014-02-11','12:10:00',2.29),('14598','2014-02-11','12:15:00',1.53),('14598','2014-02-11','12:20:00',1.72),('14598','2014-02-11','12:25:00',1.57),('14598','2014-02-11','12:30:00',1.7),('14598','2014-02-11','12:35:00',2.59),('14598','2014-02-11','12:40:00',2.63),('14598','2014-02-11','12:45:00',1.7),('14598','2014-02-11','12:50:00',2.37),('14598','2014-02-11','12:55:00',2.71),('14598','2014-02-11','13:00:00',3),('14598','2014-02-11','13:05:00',2.41),('14598','2014-02-11','13:10:00',2.62),('14598','2014-02-11','13:15:00',3.03),('14598','2014-02-11','13:20:00',2.96),('14598','2014-02-11','13:25:00',3.28),('14598','2014-02-11','13:30:00',3.08),('14598','2014-02-11','13:35:00',2.85),('14598','2014-02-11','13:40:00',2.54),('14598','2014-02-11','13:45:00',2.25),('14598','2014-02-11','13:50:00',2.49),('14598','2014-02-11','13:55:00',1.62),('14598','2014-02-11','14:00:00',2.07),('14598','2014-02-11','14:05:00',2.35),('14598','2014-02-11','14:10:00',1.38),('14598','2014-02-11','14:15:00',1.82),('14598','2014-02-11','14:20:00',1.38),('14598','2014-02-11','14:25:00',3.24),('14598','2014-02-11','14:30:00',2.46),('14598','2014-02-11','14:35:00',2.28),('14598','2014-02-11','14:40:00',1.66),('14598','2014-02-11','14:45:00',1.74),('14598','2014-02-11','14:50:00',1.7),('14598','2014-02-11','14:55:00',1.36),('14598','2014-02-11','15:00:00',1.4),('14598','2014-02-11','15:05:00',1.46),('14598','2014-02-11','15:10:00',1.41),('14598','2014-02-11','15:15:00',1.44),('14598','2014-02-11','15:20:00',2.14),('14598','2014-02-11','15:25:00',1.86),('14598','2014-02-11','15:30:00',2.36),('14598','2014-02-11','15:35:00',1.54),('14598','2014-02-11','15:40:00',1.36),('14598','2014-02-11','15:45:00',1.3),('14598','2014-02-11','15:50:00',1.13),('14598','2014-02-11','16:10:00',1.07),('14598','2014-02-10','12:45:00',1.01),('14598','2014-02-10','12:55:00',1.04),('14598','2014-02-10','13:30:00',1.1),('14598','2014-02-10','13:35:00',1.1),('14598','2014-02-10','13:40:00',1.03),('14598','2014-02-10','13:50:00',1.02),('14598','2014-02-10','13:55:00',1.1),('14598','2014-02-10','14:10:00',1.01),('14598','2014-02-10','15:05:00',1.06),('14598','2014-02-10','15:20:00',1.01),('14598','2014-02-10','15:25:00',1.03),('14598','2014-02-09','11:20:00',1.46),('14598','2014-02-09','11:45:00',1.44),('14598','2014-02-09','11:50:00',3.38),('14598','2014-02-09','11:55:00',1.92),('14598','2014-02-09','12:00:00',3.54),('14598','2014-02-09','12:05:00',1.47),('14598','2014-02-09','12:10:00',1.37),('14598','2014-02-09','12:15:00',1.33),('14598','2014-02-09','12:20:00',1.78),('14598','2014-02-09','12:25:00',1.8),('14598','2014-02-09','12:30:00',1.89),('14598','2014-02-09','12:35:00',1.44),('14598','2014-02-09','12:40:00',2.04),('14598','2014-02-09','12:45:00',3.17),('14598','2014-02-09','12:50:00',2.81),('14598','2014-02-09','12:55:00',4.42),('14598','2014-02-09','13:00:00',2.03),('14598','2014-02-09','13:05:00',3.33),('14598','2014-02-09','13:10:00',2.19),('14598','2014-02-09','13:15:00',1.01),('14598','2014-02-09','13:20:00',2.67),('14598','2014-02-09','13:25:00',4),('14598','2014-02-09','13:30:00',1.99),('14598','2014-02-09','13:35:00',2.4),('14598','2014-02-09','13:40:00',3.88),('14598','2014-02-09','13:45:00',3.76),('14598','2014-02-09','13:50:00',2.86),('14598','2014-02-09','13:55:00',1.15),('14598','2014-02-09','14:05:00',1.78),('14598','2014-02-09','14:10:00',2.07),('14598','2014-02-09','14:15:00',3.61),('14598','2014-02-09','14:20:00',3.11),('14598','2014-02-09','14:25:00',3.08),('14598','2014-02-09','14:30:00',3.23),('14598','2014-02-09','14:35:00',3.08),('14598','2014-02-09','14:40:00',2.86),('14598','2014-02-09','14:45:00',2.99),('14598','2014-02-09','14:50:00',2.65),('14598','2014-02-09','14:55:00',2.52),('14598','2014-02-09','15:00:00',2.81),('14598','2014-02-09','15:05:00',2.74),('14598','2014-02-09','15:10:00',2.61),('14598','2014-02-09','15:15:00',2.53),('14598','2014-02-09','15:20:00',2.46),('14598','2014-02-09','15:25:00',2.38),('14598','2014-02-09','15:30:00',2.28),('14598','2014-02-09','15:35:00',2.05),('14598','2014-02-09','15:40:00',2.09),('14598','2014-02-09','15:45:00',1.86),('14598','2014-02-09','15:50:00',1.6),('14598','2014-02-09','15:55:00',1.51),('14598','2014-02-09','16:00:00',1.54),('14598','2014-02-09','16:05:00',1.52),('14598','2014-02-09','16:10:00',1.44),('14598','2014-02-09','16:15:00',1.38),('14598','2014-02-09','16:20:00',1.27),('14598','2014-02-09','16:25:00',1.15),('14598','2014-02-08','09:25:00',1.19),('14598','2014-02-08','09:30:00',1.14),('14598','2014-02-08','09:35:00',1.72),('14598','2014-02-08','09:40:00',1.84),('14598','2014-02-08','09:45:00',1.92),('14598','2014-02-08','09:50:00',2.01),('14598','2014-02-08','09:55:00',1.98),('14598','2014-02-08','10:00:00',2.05),('14598','2014-02-08','10:05:00',2.18),('14598','2014-02-08','10:10:00',2.4),('14598','2014-02-08','10:15:00',2.4),('14598','2014-02-08','10:20:00',2.42),('14598','2014-02-08','10:25:00',2.74),('14598','2014-02-08','10:30:00',2.36),('14598','2014-02-08','10:35:00',2.76),('14598','2014-02-08','10:40:00',2.77),('14598','2014-02-08','10:45:00',2.75),('14598','2014-02-08','10:50:00',2.61),('14598','2014-02-08','10:55:00',2.75),('14598','2014-02-08','11:00:00',3.24),('14598','2014-02-08','11:05:00',3.19),('14598','2014-02-08','11:15:00',2.24),('14598','2014-02-08','11:20:00',2.75),('14598','2014-02-08','11:25:00',3.55),('14598','2014-02-08','11:30:00',2.07),('14598','2014-02-08','11:35:00',2.45),('14598','2014-02-08','11:40:00',1.77),('14598','2014-02-08','11:45:00',3.81),('14598','2014-02-08','11:50:00',3.49),('14598','2014-02-08','11:55:00',3.54),('14598','2014-02-08','12:00:00',3.59),('14598','2014-02-08','12:05:00',3.59),('14598','2014-02-08','12:10:00',3.59),('14598','2014-02-08','12:15:00',3.61),('14598','2014-02-08','12:20:00',3.63),('14598','2014-02-08','12:25:00',3.89),('14598','2014-02-08','12:30:00',3.64),('14598','2014-02-08','12:35:00',3.8),('14598','2014-02-08','12:40:00',3.42),('14598','2014-02-08','12:45:00',3.74),('14598','2014-02-08','12:50:00',2.73),('14598','2014-02-08','13:00:00',3.34),('14598','2014-02-08','13:05:00',3.84),('14598','2014-02-08','13:10:00',3.7),('14598','2014-02-08','13:15:00',2.54),('14598','2014-02-08','13:20:00',3.75),('14598','2014-02-08','13:25:00',3.86),('14598','2014-02-08','13:30:00',3.66),('14598','2014-02-08','13:35:00',3.59),('14598','2014-02-08','13:40:00',3.63),('14598','2014-02-08','13:45:00',3.61),('14598','2014-02-08','13:50:00',3.57),('14598','2014-02-08','13:55:00',3.6),('14598','2014-02-08','14:00:00',3.19),('14598','2014-02-08','14:05:00',2.66),('14598','2014-02-08','14:10:00',2.93),('14598','2014-02-08','14:15:00',3.31),('14598','2014-02-08','14:20:00',3.39),('14598','2014-02-08','14:25:00',2.07),('14598','2014-02-08','14:30:00',1.51),('14598','2014-02-08','14:35:00',2.27),('14598','2014-02-08','14:40:00',3.46),('14598','2014-02-08','14:45:00',3.34),('14598','2014-02-08','14:50:00',3.22),('14598','2014-02-08','14:55:00',2.51),('14598','2014-02-08','15:00:00',2.77),('14598','2014-02-08','15:05:00',2.41),('14598','2014-02-08','15:10:00',2.81),('14598','2014-02-08','15:15:00',2.66),('14598','2014-02-08','15:20:00',2.56),('14598','2014-02-08','15:25:00',2.49),('14598','2014-02-08','15:30:00',2.55),('14598','2014-02-08','15:35:00',2.46),('14598','2014-02-08','15:40:00',2.29),('14598','2014-02-08','15:45:00',2.01),('14598','2014-02-08','15:50:00',2.06),('14598','2014-02-08','15:55:00',2.12),('14598','2014-02-08','16:00:00',1.93),('14598','2014-02-08','16:05:00',1.05),('14598','2014-02-08','16:10:00',1.65),('14598','2014-02-08','16:15:00',1.93),('14598','2014-02-08','16:20:00',1.7),('14598','2014-02-08','16:25:00',1.46),('14598','2014-02-08','16:30:00',1.56),('14598','2014-02-07','08:50:00',1.13),('14598','2014-02-07','08:55:00',1.08),('14598','2014-02-07','09:10:00',1.07),('14598','2014-02-07','09:15:00',1.37),('14598','2014-02-07','09:20:00',1.45),('14598','2014-02-07','09:25:00',1.61),('14598','2014-02-07','09:30:00',1.82),('14598','2014-02-07','09:35:00',1.97),('14598','2014-02-07','09:40:00',2.21),('14598','2014-02-07','09:45:00',2.26),('14598','2014-02-07','09:50:00',2.28),('14598','2014-02-07','09:55:00',2.04),('14598','2014-02-07','10:00:00',2.13),('14598','2014-02-07','10:05:00',2.18),('14598','2014-02-07','10:10:00',2.26),('14598','2014-02-07','10:15:00',2.33),('14598','2014-02-07','10:20:00',2.39),('14598','2014-02-07','10:25:00',2.48),('14598','2014-02-07','10:30:00',2.55),('14598','2014-02-07','10:35:00',2.59),('14598','2014-02-07','10:40:00',2.54),('14598','2014-02-07','10:45:00',2.71),('14598','2014-02-07','10:50:00',2.83),('14598','2014-02-07','10:55:00',2.64),('14598','2014-02-07','11:00:00',3.13),('14598','2014-02-07','11:05:00',3.29),('14598','2014-02-07','11:10:00',3.39),('14598','2014-02-07','11:15:00',3.49),('14598','2014-02-07','11:20:00',3.42),('14598','2014-02-07','11:25:00',2.45),('14598','2014-02-07','11:30:00',3.36),('14598','2014-02-07','11:35:00',3.38),('14598','2014-02-07','11:40:00',3.42),('14598','2014-02-07','11:45:00',3.41),('14598','2014-02-07','11:50:00',3.43),('14598','2014-02-07','11:55:00',3.45),('14598','2014-02-07','12:00:00',3.48),('14598','2014-02-07','12:05:00',3.5),('14598','2014-02-07','12:10:00',3.54),('14598','2014-02-07','12:15:00',3.32),('14598','2014-02-07','12:20:00',3.61),('14598','2014-02-07','12:25:00',3.59),('14598','2014-02-07','12:30:00',3.59),('14598','2014-02-07','12:35:00',3.6),('14598','2014-02-07','12:40:00',3.6),('14598','2014-02-07','12:45:00',3.61),('14598','2014-02-07','12:50:00',3.62),('14598','2014-02-07','12:55:00',3.56),('14598','2014-02-07','13:00:00',3.61),('14598','2014-02-07','13:05:00',3.7),('14598','2014-02-07','13:10:00',3.89),('14598','2014-02-07','13:15:00',3.8),('14598','2014-02-07','13:20:00',3.79),('14598','2014-02-07','13:25:00',3.73),('14598','2014-02-07','13:30:00',2.91),('14598','2014-02-07','13:35:00',3.93),('14598','2014-02-07','13:40:00',3.2),('14598','2014-02-07','13:45:00',4.12),('14598','2014-02-07','13:55:00',3.75),('14598','2014-02-07','14:00:00',3.64),('14598','2014-02-07','14:05:00',3.43),('14598','2014-02-07','14:10:00',3.3),('14598','2014-02-07','14:15:00',3.27),('14598','2014-02-07','14:20:00',3.21),('14598','2014-02-07','14:25:00',3.17),('14598','2014-02-07','14:30:00',3.13),('14598','2014-02-07','14:35:00',3.08),('14598','2014-02-07','14:40:00',3.04),('14598','2014-02-07','14:45:00',2.99),('14598','2014-02-07','14:50:00',2.92),('14598','2014-02-07','14:55:00',2.85),('14598','2014-02-07','15:00:00',2.79),('14598','2014-02-07','15:05:00',2.73),('14598','2014-02-07','15:10:00',2.66),('14598','2014-02-07','15:15:00',2.59),('14598','2014-02-07','15:20:00',2.52),('14598','2014-02-07','15:25:00',2.44),('14598','2014-02-07','15:30:00',2.36),('14598','2014-02-07','15:35:00',2.27),('14598','2014-02-07','15:40:00',2.19),('14598','2014-02-07','15:45:00',2.1),('14598','2014-02-07','15:50:00',2.01),('14598','2014-02-07','15:55:00',1.91),('14598','2014-02-07','16:00:00',1.83),('14598','2014-02-07','16:05:00',1.73),('14598','2014-02-07','16:10:00',1.62),('14598','2014-02-07','16:15:00',1.52),('14598','2014-02-07','16:20:00',1.42),('14598','2014-02-07','16:25:00',1.3),('14598','2014-02-07','16:30:00',1.2),('14598','2014-02-07','16:35:00',1.08),('14598','2014-02-06','09:00:00',1.01),('14598','2014-02-06','09:05:00',1.13),('14598','2014-02-06','09:10:00',1.22),('14598','2014-02-06','09:15:00',1.33),('14598','2014-02-06','09:20:00',1.42),('14598','2014-02-06','09:25:00',1.51),('14598','2014-02-06','09:30:00',1.62),('14598','2014-02-06','09:35:00',1.68),('14598','2014-02-06','09:40:00',1.78),('14598','2014-02-06','09:45:00',1.88),('14598','2014-02-06','09:50:00',1.95),('14598','2014-02-06','09:55:00',2.05),('14598','2014-02-06','10:00:00',2.13),('14598','2014-02-06','10:05:00',2.21),('14598','2014-02-06','10:10:00',2.32),('14598','2014-02-06','10:15:00',2.4),('14598','2014-02-06','10:20:00',2.46),('14598','2014-02-06','10:25:00',2.51),('14598','2014-02-06','10:30:00',2.58),('14598','2014-02-06','10:35:00',2.71),('14598','2014-02-06','10:40:00',2.99),('14598','2014-02-06','10:45:00',2.85),('14598','2014-02-06','10:50:00',2.88),('14598','2014-02-06','10:55:00',2.94),('14598','2014-02-06','11:00:00',3.01),('14598','2014-02-06','11:05:00',3.08),('14598','2014-02-06','11:10:00',3.13),('14598','2014-02-06','11:15:00',3.18),('14598','2014-02-06','11:20:00',3.2),('14598','2014-02-06','11:25:00',3.24),('14598','2014-02-06','11:30:00',3.27),('14598','2014-02-06','11:35:00',3.35),('14598','2014-02-06','11:40:00',3.38),('14598','2014-02-06','11:45:00',3.43),('14598','2014-02-06','11:50:00',3.44),('14598','2014-02-06','11:55:00',3.48),('14598','2014-02-06','12:00:00',3.47),('14598','2014-02-06','12:05:00',3.54),('14598','2014-02-06','12:10:00',3.59),('14598','2014-02-06','12:15:00',3.63),('14598','2014-02-06','12:20:00',3.65),('14598','2014-02-06','12:25:00',3.66),('14598','2014-02-06','12:30:00',3.65),('14598','2014-02-06','12:35:00',3.66),('14598','2014-02-06','12:40:00',3.64),('14598','2014-02-06','12:45:00',3.65),('14598','2014-02-06','12:50:00',3.67),('14598','2014-02-06','12:55:00',3.66),('14598','2014-02-06','13:00:00',3.66),('14598','2014-02-06','13:05:00',3.64),('14598','2014-02-06','13:10:00',3.66),('14598','2014-02-06','13:15:00',3.62),('14598','2014-02-06','13:20:00',3.63),('14598','2014-02-06','13:25:00',3.61),('14598','2014-02-06','13:30:00',3.6),('14598','2014-02-06','13:35:00',3.59),('14598','2014-02-06','13:40:00',3.55),('14598','2014-02-06','13:45:00',3.5),('14598','2014-02-06','13:50:00',3.49),('14598','2014-02-06','13:55:00',3.48),('14598','2014-02-06','14:00:00',3.43),('14598','2014-02-06','14:05:00',3.39),('14598','2014-02-06','14:10:00',3.34),('14598','2014-02-06','14:15:00',3.29),('14598','2014-02-06','14:20:00',3.25),('14598','2014-02-06','14:25:00',3.21),('14598','2014-02-06','14:30:00',3.14),('14598','2014-02-06','14:35:00',3.1),('14598','2014-02-06','14:40:00',3.04),('14598','2014-02-06','14:45:00',2.98),('14598','2014-02-06','14:50:00',2.91),('14598','2014-02-06','14:55:00',2.86),('14598','2014-02-06','15:00:00',2.78),('14598','2014-02-06','15:05:00',2.73),('14598','2014-02-06','15:10:00',2.65),('14598','2014-02-06','15:15:00',2.58),('14598','2014-02-06','15:20:00',2.5),('14598','2014-02-06','15:25:00',2.42),('14598','2014-02-06','15:30:00',2.34),('14598','2014-02-06','15:35:00',2.26),('14598','2014-02-06','15:40:00',2.16),('14598','2014-02-06','15:45:00',2.08),('14598','2014-02-06','15:50:00',1.99),('14598','2014-02-06','15:55:00',1.9),('14598','2014-02-06','16:00:00',1.8),('14598','2014-02-06','16:05:00',1.69),('14598','2014-02-06','16:10:00',1.59),('14598','2014-02-06','16:15:00',1.49),('14598','2014-02-06','16:20:00',1.37),('14598','2014-02-06','16:25:00',1.27),('14598','2014-02-06','16:30:00',1.16),('14598','2014-02-06','16:35:00',1.05),('14598','2014-04-27','08:20:00',1.04),('14598','2014-04-27','10:00:00',1.39),('14598','2014-04-27','10:05:00',1.28),('14598','2014-04-27','10:10:00',1.24),('14598','2014-04-27','10:15:00',1.77),('14598','2014-04-27','10:20:00',1.66),('14598','2014-04-27','10:25:00',1.22),('14598','2014-04-27','10:30:00',2.01),('14598','2014-04-27','10:35:00',1.41),('14598','2014-04-27','10:40:00',1.21),('14598','2014-04-27','10:45:00',1.95),('14598','2014-04-27','10:50:00',2.11),('14598','2014-04-27','10:55:00',2.28),('14598','2014-04-27','11:00:00',1.93),('14598','2014-04-27','11:05:00',2.35),('14598','2014-04-27','11:10:00',4.88),('14598','2014-04-27','11:15:00',3.42),('14598','2014-04-27','11:20:00',3.69),('14598','2014-04-27','11:25:00',3.66),('14598','2014-04-27','11:30:00',4.21),('14598','2014-04-27','11:35:00',2.79),('14598','2014-04-27','11:40:00',2.55),('14598','2014-04-27','11:45:00',3.63),('14598','2014-04-27','11:50:00',4.37),('14598','2014-04-27','11:55:00',4.61),('14598','2014-04-27','12:00:00',4.67),('14598','2014-04-27','12:05:00',5.3),('14598','2014-04-27','12:10:00',5.03),('14598','2014-04-27','12:15:00',4.34),('14598','2014-04-27','12:20:00',4.49),('14598','2014-04-27','12:25:00',4.22),('14598','2014-04-27','12:30:00',3.11),('14598','2014-04-27','12:35:00',2.98),('14598','2014-04-27','12:40:00',2.43),('14598','2014-04-27','12:45:00',1.97),('14598','2014-04-27','12:50:00',2.47),('14598','2014-04-27','12:55:00',2.49),('14598','2014-04-27','13:00:00',2.93),('14598','2014-04-27','13:05:00',3.24),('14598','2014-04-27','13:10:00',2.49),('14598','2014-04-27','13:15:00',1.63),('14598','2014-04-27','13:20:00',1.61),('14598','2014-04-27','13:25:00',2.03),('14598','2014-04-27','13:30:00',2.65),('14598','2014-04-27','13:35:00',3.8),('14598','2014-04-27','13:40:00',2.89),('14598','2014-04-27','13:45:00',1.99),('14598','2014-04-27','13:50:00',2.16),('14598','2014-04-27','13:55:00',2.48),('14598','2014-04-27','14:00:00',2.43),('14598','2014-04-27','14:05:00',2.43),('14598','2014-04-27','14:10:00',2.49),('14598','2014-04-27','14:15:00',3.04),('14598','2014-04-27','14:20:00',3.1),('14598','2014-04-27','14:25:00',3.21),('14598','2014-04-27','14:30:00',2.97),('14598','2014-04-27','14:35:00',3.38),('14598','2014-04-27','14:40:00',3.15),('14598','2014-04-27','14:45:00',3.42),('14598','2014-04-27','14:50:00',3.98),('14598','2014-04-27','14:55:00',4.05),('14598','2014-04-27','15:00:00',3.12),('14598','2014-04-27','15:05:00',2.27),('14598','2014-04-27','15:10:00',1.85),('14598','2014-04-27','15:15:00',1.42),('14598','2014-04-27','15:20:00',1.1),('14598','2014-04-27','15:35:00',1.02),('14598','2014-02-05','08:55:00',1.11),('14598','2014-02-05','09:00:00',1.26),('14598','2014-02-05','09:05:00',1.4),('14598','2014-02-05','09:10:00',1.77),('14598','2014-02-05','09:15:00',1.27),('14598','2014-02-05','09:20:00',1.05),('14598','2014-02-05','09:50:00',1.96),('14598','2014-02-05','09:55:00',2.67),('14598','2014-02-05','10:00:00',2.56),('14598','2014-02-05','10:05:00',1.71),('14598','2014-02-05','10:10:00',2.28),('14598','2014-02-05','10:15:00',2.38),('14598','2014-02-05','10:20:00',2.49),('14598','2014-02-05','10:25:00',2.52),('14598','2014-02-05','10:30:00',2.58),('14598','2014-02-05','10:35:00',2.78),('14598','2014-02-05','10:40:00',2.98),('14598','2014-02-05','10:45:00',3.03),('14598','2014-02-05','10:50:00',2.66),('14598','2014-02-05','10:55:00',1.97),('14598','2014-02-05','11:00:00',1.52),('14598','2014-02-05','11:05:00',1.18),('14598','2014-02-05','11:30:00',1.67),('14598','2014-02-05','11:35:00',3.03),('14598','2014-02-05','11:40:00',3.11),('14598','2014-02-05','11:45:00',3.6),('14598','2014-02-05','11:50:00',2.41),('14598','2014-02-05','11:55:00',1.82),('14598','2014-02-05','12:00:00',2.25),('14598','2014-02-05','12:05:00',3.68),('14598','2014-02-05','12:10:00',2.32),('14598','2014-02-05','12:15:00',1.79),('14598','2014-02-05','12:20:00',1.39),('14598','2014-02-05','12:25:00',1.43),('14598','2014-02-05','12:30:00',1.83),('14598','2014-02-05','12:35:00',2.22),('14598','2014-02-05','12:40:00',2.76),('14598','2014-02-05','12:45:00',3.21),('14598','2014-02-05','12:50:00',2.75),('14598','2014-02-05','12:55:00',1.68),('14598','2014-02-05','13:00:00',1.12),('14598','2014-02-05','13:20:00',1.32),('14598','2014-02-05','13:25:00',1.56),('14598','2014-02-05','13:30:00',1.6),('14598','2014-02-05','13:35:00',1.45),('14598','2014-02-05','13:40:00',1.45),('14598','2014-02-05','13:45:00',1.46),('14598','2014-02-05','13:50:00',1.78),('14598','2014-02-05','13:55:00',1.68),('14598','2014-02-05','14:00:00',1.38),('14598','2014-02-05','14:05:00',1.35),('14598','2014-02-05','14:10:00',1.33),('14598','2014-02-05','14:15:00',1.37),('14598','2014-02-05','14:20:00',1.15),('14598','2014-02-05','14:25:00',1.2),('14598','2014-02-05','15:10:00',1.19),('14598','2014-02-05','15:15:00',1.12),('14598','2014-02-05','15:20:00',1.03),('14598','2014-02-05','15:50:00',1.48),('14598','2014-02-05','15:55:00',1.71),('14598','2014-02-05','16:00:00',1.09),('14598','2014-02-04','09:35:00',1.24),('14598','2014-02-04','09:40:00',1.34),('14598','2014-02-04','09:45:00',1.14),('14598','2014-02-04','09:55:00',2.38),('14598','2014-02-04','10:00:00',2.45),('14598','2014-02-04','10:05:00',2.65),('14598','2014-02-04','10:10:00',2.96),('14598','2014-02-04','10:15:00',2.92),('14598','2014-02-04','10:20:00',2.84),('14598','2014-02-04','10:25:00',2.97),('14598','2014-02-04','10:30:00',3),('14598','2014-02-04','10:35:00',3.1),('14598','2014-02-04','10:40:00',3.39),('14598','2014-02-04','10:45:00',3.57),('14598','2014-02-04','10:50:00',3.07),('14598','2014-02-04','10:55:00',2.06),('14598','2014-02-04','11:00:00',2.89),('14598','2014-02-04','11:05:00',1.59),('14598','2014-02-04','11:10:00',1.09),('14598','2014-02-04','11:25:00',1.1),('14598','2014-02-04','11:30:00',1.36),('14598','2014-02-04','11:35:00',2.11),('14598','2014-02-04','11:40:00',2.28),('14598','2014-02-04','11:45:00',2.39),('14598','2014-02-04','11:50:00',1.59),('14598','2014-02-04','11:55:00',1.46),('14598','2014-02-04','12:00:00',1.53),('14598','2014-02-04','12:05:00',1.76),('14598','2014-02-04','12:10:00',2.17),('14598','2014-02-04','12:15:00',1.93),('14598','2014-02-04','12:20:00',1.57),('14598','2014-02-04','12:25:00',1.15),('14598','2014-02-04','13:05:00',1.2),('14598','2014-02-04','13:10:00',1.22),('14598','2014-02-04','13:15:00',1.14),('14598','2014-02-04','13:20:00',1.3),('14598','2014-02-04','13:25:00',1.36),('14598','2014-02-04','13:30:00',1.1),('14598','2014-02-04','13:35:00',1.01),('14598','2014-02-04','13:40:00',1.14),('14598','2014-02-03','09:50:00',1.05),('14598','2014-02-03','09:55:00',1.38),('14598','2014-02-03','10:00:00',1.72),('14598','2014-02-03','10:05:00',2.33),('14598','2014-02-03','10:10:00',2.69),('14598','2014-02-03','10:15:00',1.62),('14598','2014-02-03','10:20:00',1.03),('14598','2014-02-02','12:20:00',1.01),('14598','2014-02-02','12:40:00',1.08),('14598','2014-02-02','12:45:00',1.06),('14598','2014-02-01','10:25:00',1.17),('14598','2014-02-01','10:40:00',1.03),('14598','2014-02-01','10:45:00',1.05),('14598','2014-02-01','10:50:00',1.02),('14598','2014-02-01','10:55:00',1.06),('14598','2014-02-01','11:00:00',1.37),('14598','2014-02-01','11:05:00',1.38),('14598','2014-02-01','11:10:00',1.25),('14598','2014-02-01','11:15:00',1.59),('14598','2014-02-01','11:20:00',2.03),('14598','2014-02-01','11:25:00',1.52),('14598','2014-02-01','11:30:00',1.68),('14598','2014-02-01','11:35:00',1.65),('14598','2014-02-01','11:40:00',1.05),('14598','2014-02-01','11:45:00',1.85),('14598','2014-02-01','11:50:00',2.36),('14598','2014-02-01','11:55:00',1.8),('14598','2014-02-01','12:00:00',1.1),('14598','2014-02-01','12:05:00',1.6),('14598','2014-02-01','12:10:00',2.31),('14598','2014-02-01','12:15:00',2.03),('14598','2014-02-01','12:20:00',2.3),('14598','2014-02-01','12:25:00',2.32),('14598','2014-02-01','12:30:00',2.13),('14598','2014-02-01','12:35:00',1.99),('14598','2014-02-01','12:40:00',2.32),('14598','2014-02-01','12:45:00',2.33),('14598','2014-02-01','12:50:00',2.16),('14598','2014-02-01','12:55:00',2.05),('14598','2014-02-01','13:00:00',1.86),('14598','2014-02-01','13:05:00',1.5),('14598','2014-02-01','13:10:00',1.55),('14598','2014-02-01','13:15:00',1.41),('14598','2014-02-01','13:20:00',1.71),('14598','2014-02-01','13:25:00',1.87),('14598','2014-02-01','13:30:00',1.69),('14598','2014-02-01','13:35:00',1.42),('14598','2014-02-01','13:40:00',1.22),('14598','2014-02-01','13:45:00',1.16),('14598','2014-02-01','13:50:00',1.12),('14598','2014-02-01','13:55:00',1.19),('14598','2014-02-01','14:00:00',1.2),('14598','2014-02-01','14:05:00',1.14),('14598','2014-02-01','14:10:00',1.06),('14598','2014-01-30','09:35:00',1.01),('14598','2014-01-30','09:40:00',1.05),('14598','2014-01-30','09:45:00',1.81),('14598','2014-01-30','09:50:00',2.14),('14598','2014-01-30','09:55:00',2.52),('14598','2014-01-30','10:00:00',2.75),('14598','2014-01-30','10:05:00',2.69),('14598','2014-01-30','10:10:00',2.49),('14598','2014-01-30','10:15:00',2.41),('14598','2014-01-30','10:20:00',2.03),('14598','2014-01-30','10:25:00',2.65),('14598','2014-01-30','10:30:00',2.79),('14598','2014-01-30','10:35:00',2.96),('14598','2014-01-30','10:40:00',3.31),('14598','2014-01-30','10:45:00',3.05),('14598','2014-01-30','10:50:00',2.65),('14598','2014-01-30','10:55:00',2.74),('14598','2014-01-30','11:00:00',2.63),('14598','2014-01-30','11:05:00',3.16),('14598','2014-01-30','11:10:00',2.54),('14598','2014-01-30','11:15:00',3.21),('14598','2014-01-30','11:20:00',2.72),('14598','2014-01-30','11:25:00',1.96),('14598','2014-01-30','11:30:00',2.23),('14598','2014-01-30','11:35:00',1.8),('14598','2014-01-30','11:40:00',2.22),('14598','2014-01-30','11:45:00',1.97),('14598','2014-01-30','11:50:00',1.69),('14598','2014-01-30','11:55:00',1.71),('14598','2014-01-30','12:00:00',1.32),('14598','2014-01-30','12:05:00',1.62),('14598','2014-01-30','12:10:00',1.93),('14598','2014-01-30','12:15:00',1.98),('14598','2014-01-30','12:20:00',2.18),('14598','2014-01-30','12:25:00',2.65),('14598','2014-01-30','12:30:00',2.61),('14598','2014-01-30','12:35:00',2.63),('14598','2014-01-30','12:40:00',2.12),('14598','2014-01-30','12:45:00',2.47),('14598','2014-01-30','12:50:00',2.65),('14598','2014-01-30','12:55:00',2.35),('14598','2014-01-30','13:00:00',2.99),('14598','2014-01-30','13:05:00',2.88),('14598','2014-01-30','13:10:00',2.26),('14598','2014-01-30','13:15:00',1.4),('14598','2014-01-30','13:20:00',1.47),('14598','2014-01-30','13:25:00',1.15),('14598','2014-01-30','13:30:00',1.93),('14598','2014-01-30','13:35:00',2.6),('14598','2014-01-30','13:40:00',2.14),('14598','2014-01-30','13:45:00',2),('14598','2014-01-30','13:50:00',1.67),('14598','2014-01-30','13:55:00',1.43),('14598','2014-01-30','14:00:00',1.46),('14598','2014-01-30','14:05:00',1.42),('14598','2014-01-30','14:10:00',1.89),('14598','2014-01-30','14:15:00',2.29),('14598','2014-01-30','14:20:00',1.75),('14598','2014-01-30','14:25:00',1.88),('14598','2014-01-30','14:30:00',2.55),('14598','2014-01-30','14:35:00',2.24),('14598','2014-01-30','14:40:00',2.52),('14598','2014-01-30','14:45:00',2.58),('14598','2014-01-30','14:50:00',2.39),('14598','2014-01-30','14:55:00',2.24),('14598','2014-01-30','15:00:00',2.1),('14598','2014-01-30','15:05:00',2.14),('14598','2014-01-30','15:10:00',2),('14598','2014-01-30','15:15:00',2.37),('14598','2014-01-30','15:20:00',2.23),('14598','2014-01-30','15:25:00',2.06),('14598','2014-01-30','15:30:00',1.55),('14598','2014-01-30','15:35:00',1.1),('14598','2014-01-29','09:05:00',1.13),('14598','2014-01-29','09:10:00',1),('14598','2014-01-29','09:15:00',1),('14598','2014-01-29','09:25:00',1.01),('14598','2014-01-29','09:30:00',1.02),('14598','2014-01-29','09:35:00',1.02),('14598','2014-01-29','09:40:00',1.09),('14598','2014-01-29','09:45:00',1.14),('14598','2014-01-29','10:05:00',1.99),('14598','2014-01-29','10:10:00',2.61),('14598','2014-01-29','10:15:00',1.76),('14598','2014-01-29','10:20:00',2.2),('14598','2014-01-29','10:25:00',1.85),('14598','2014-01-29','10:30:00',1.82),('14598','2014-01-29','10:35:00',1.91),('14598','2014-01-29','10:40:00',1.94),('14598','2014-01-29','10:45:00',2.42),('14598','2014-01-29','10:50:00',2.21),('14598','2014-01-29','10:55:00',2.37),('14598','2014-01-29','11:00:00',2.71),('14598','2014-01-29','11:05:00',2.74),('14598','2014-01-29','11:10:00',2.12),('14598','2014-01-29','11:15:00',1.85),('14598','2014-01-29','11:20:00',1.53),('14598','2014-01-29','11:25:00',1.84),('14598','2014-01-29','11:30:00',2.4),('14598','2014-01-29','11:35:00',2.86),('14598','2014-01-29','11:40:00',3),('14598','2014-01-29','11:45:00',2.4),('14598','2014-01-29','11:50:00',1.76),('14598','2014-01-29','11:55:00',1.06),('14598','2014-01-29','12:10:00',2.01),('14598','2014-01-29','12:15:00',3.73),('14598','2014-01-29','12:20:00',3.44),('14598','2014-01-29','12:25:00',3.03),('14598','2014-01-29','12:30:00',2.93),('14598','2014-01-29','12:35:00',2.2),('14598','2014-01-29','12:40:00',1.27),('14598','2014-01-29','12:45:00',1.14),('14598','2014-01-29','12:50:00',1.4),('14598','2014-01-29','12:55:00',1.34),('14598','2014-01-29','13:00:00',1.44),('14598','2014-01-29','13:05:00',1.3),('14598','2014-01-29','13:10:00',1.55),('14598','2014-01-29','13:15:00',1.61),('14598','2014-01-29','13:30:00',2.25),('14598','2014-01-29','13:35:00',3.36),('14598','2014-01-29','13:40:00',3.45),('14598','2014-01-29','13:45:00',2.75),('14598','2014-01-29','13:50:00',1.17),('14598','2014-01-29','13:55:00',1.08),('14598','2014-01-29','14:00:00',1.26),('14598','2014-01-29','14:05:00',1.2),('14598','2014-01-29','14:45:00',1.19),('14598','2014-01-29','14:50:00',1.33),('14598','2014-01-29','14:55:00',1.66),('14598','2014-01-29','15:00:00',1.45),('14598','2014-01-29','15:05:00',1.29),('14598','2014-01-29','15:10:00',1.29),('14598','2014-01-28','09:25:00',1.15),('14598','2014-01-28','09:30:00',1.06),('14598','2014-01-28','09:35:00',1.06),('14598','2014-01-28','09:40:00',1.32),('14598','2014-01-28','09:45:00',1.39),('14598','2014-01-28','09:50:00',1.67),('14598','2014-01-28','09:55:00',1.83),('14598','2014-01-28','10:00:00',2.13),('14598','2014-01-28','10:05:00',2.32),('14598','2014-01-28','10:10:00',2.46),('14598','2014-01-28','10:15:00',2.52),('14598','2014-01-28','10:20:00',2.22),('14598','2014-01-28','10:25:00',2.08),('14598','2014-01-28','10:30:00',1.98),('14598','2014-01-28','10:35:00',1.91),('14598','2014-01-28','10:40:00',2.28),('14598','2014-01-28','10:45:00',2.2),('14598','2014-01-28','10:50:00',2.13),('14598','2014-01-28','10:55:00',2.17),('14598','2014-01-28','11:00:00',2.16),('14598','2014-01-28','11:05:00',2.47),('14598','2014-01-28','11:10:00',2.94),('14598','2014-01-28','11:15:00',2.72),('14598','2014-01-28','11:20:00',2.71),('14598','2014-01-28','11:25:00',3.2),('14598','2014-01-28','11:30:00',3.16),('14598','2014-01-28','11:35:00',2.65),('14598','2014-01-28','11:40:00',2.02),('14598','2014-01-28','11:45:00',2.87),('14598','2014-01-28','11:50:00',1.62),('14598','2014-01-28','11:55:00',1.48),('14598','2014-01-28','12:00:00',1.65),('14598','2014-01-28','12:05:00',1.66),('14598','2014-01-28','12:10:00',1.79),('14598','2014-01-28','12:15:00',1.6),('14598','2014-01-28','12:20:00',2.6),('14598','2014-01-28','12:25:00',2.69),('14598','2014-01-28','12:30:00',3.18),('14598','2014-01-28','12:35:00',2.84),('14598','2014-01-28','12:40:00',3.88),('14598','2014-01-28','12:45:00',3.61),('14598','2014-01-28','12:50:00',3.56),('14598','2014-01-28','12:55:00',3.22),('14598','2014-01-28','13:00:00',3.35),('14598','2014-01-28','13:05:00',3.64),('14598','2014-01-28','13:10:00',3.61),('14598','2014-01-28','13:15:00',3.55),('14598','2014-01-28','13:20:00',3.51),('14598','2014-01-28','13:25:00',3.47),('14598','2014-01-28','13:30:00',3.45),('14598','2014-01-28','13:35:00',3.43),('14598','2014-01-28','13:40:00',3.38),('14598','2014-01-28','13:45:00',3.36),('14598','2014-01-28','13:50:00',3.33),('14598','2014-01-28','13:55:00',3.28),('14598','2014-01-28','14:00:00',3.25),('14598','2014-01-28','14:05:00',3.21),('14598','2014-01-28','14:10:00',3.16),('14598','2014-01-28','14:15:00',3.12),('14598','2014-01-28','14:20:00',3.07),('14598','2014-01-28','14:25:00',3.02),('14598','2014-01-28','14:30:00',2.96),('14598','2014-01-28','14:35:00',2.91),('14598','2014-01-28','14:40:00',2.83),('14598','2014-01-28','14:45:00',2.77),('14598','2014-01-28','14:50:00',2.7),('14598','2014-01-28','14:55:00',2.63),('14598','2014-01-28','15:00:00',2.56),('14598','2014-01-28','15:05:00',2.51),('14598','2014-01-28','15:10:00',2.42),('14598','2014-01-28','15:15:00',2.33),('14598','2014-01-28','15:20:00',2.24),('14598','2014-01-28','15:25:00',2.17),('14598','2014-01-28','15:30:00',2.09),('14598','2014-01-28','15:35:00',2),('14598','2014-01-28','15:40:00',1.91),('14598','2014-01-28','15:45:00',1.82),('14598','2014-01-28','15:50:00',1.72),('14598','2014-01-28','15:55:00',1.62),('14598','2014-01-28','16:00:00',1.5),('14598','2014-01-28','16:05:00',1.34),('14598','2014-01-28','16:10:00',1.09),('14598','2014-01-27','09:35:00',1.09),('14598','2014-01-27','09:40:00',1.05),('14598','2014-01-27','10:55:00',1.17),('14598','2014-01-27','11:00:00',1.21),('14598','2014-01-27','12:50:00',1.15),('14598','2014-01-27','12:55:00',1.16),('15087','2014-05-05','07:45:00',1.18),('15087','2014-05-05','07:50:00',1.29),('15087','2014-05-05','07:55:00',1.43),('15087','2014-05-05','08:00:00',1.53),('15087','2014-05-05','08:05:00',1.64),('15087','2014-05-05','08:10:00',1.75),('15087','2014-05-05','08:15:00',1.86),('15087','2014-05-05','08:20:00',1.98),('15087','2014-05-05','08:25:00',2.08),('15087','2014-05-05','08:30:00',2.17),('15087','2014-05-05','08:35:00',2.29),('15087','2014-05-05','08:40:00',2.39),('15087','2014-05-05','08:45:00',2.48),('15087','2014-05-05','08:50:00',2.56),('15087','2014-05-05','08:55:00',2.65),('15087','2014-05-05','09:00:00',2.74),('15087','2014-05-05','09:05:00',2.8),('15087','2014-05-05','09:10:00',2.89),('15087','2014-05-05','09:15:00',2.98),('15087','2014-05-05','09:20:00',3.06),('15087','2014-05-05','09:25:00',3.12),('15087','2014-05-05','09:30:00',3.26),('15087','2014-05-05','09:35:00',3.33),('15087','2014-05-05','09:40:00',3.4),('15087','2014-05-05','09:45:00',3.49),('15087','2014-05-05','09:50:00',3.56),('15087','2014-05-05','09:55:00',3.65),('15087','2014-05-05','10:00:00',3.72),('15087','2014-05-05','10:05:00',3.81),('15087','2014-05-05','10:10:00',3.87),('15087','2014-05-05','10:15:00',3.92),('15087','2014-05-05','10:20:00',3.95),('15087','2014-05-05','10:25:00',4.01),('15087','2014-05-05','10:30:00',4.07),('15087','2014-05-05','10:35:00',4.13),('15087','2014-05-05','10:40:00',4.17),('15087','2014-05-05','10:45:00',4.22),('15087','2014-05-05','10:50:00',4.27),('15087','2014-05-05','10:55:00',4.3),('15087','2014-05-05','11:00:00',4.36),('15087','2014-05-05','11:05:00',4.39),('15087','2014-05-05','11:10:00',4.42),('15087','2014-05-05','11:15:00',4.52),('15087','2014-05-05','11:20:00',4.53),('15087','2014-05-05','11:25:00',4.53),('15087','2014-05-05','11:30:00',4.46),('15087','2014-05-05','11:35:00',4.57),('15087','2014-05-05','11:40:00',4.6),('15087','2014-05-05','11:45:00',4.66),('15087','2014-05-05','11:50:00',4.7),('15087','2014-05-05','11:55:00',4.33),('15087','2014-05-05','12:00:00',4.83),('15087','2014-05-05','12:05:00',3.83),('15087','2014-05-05','12:10:00',2.05),('15087','2014-05-05','12:15:00',2.52),('15087','2014-05-05','12:20:00',2.07),('15087','2014-05-05','12:25:00',2.11),('15087','2014-05-05','12:30:00',4.41),('15087','2014-05-05','12:35:00',3.72),('15087','2014-05-05','12:40:00',1.6),('15087','2014-05-05','12:45:00',2.46),('15087','2014-05-05','12:50:00',4.98),('15087','2014-05-05','12:55:00',2.26),('15087','2014-05-05','13:00:00',1.37),('15087','2014-05-05','13:05:00',2.93),('15087','2014-05-05','13:10:00',5.3),('15087','2014-05-05','13:15:00',5.12),('15087','2014-05-05','13:20:00',4.99),('15087','2014-05-05','13:25:00',4.89),('15087','2014-05-05','13:30:00',4.91),('15087','2014-05-05','13:35:00',4.93),('15087','2014-05-05','13:40:00',4.93),('15087','2014-05-05','13:45:00',4.99),('15087','2014-05-05','13:50:00',4.95),('15087','2014-05-05','13:55:00',4.94),('15087','2014-05-05','14:00:00',4.78),('15087','2014-05-05','14:05:00',3.31),('15087','2014-05-05','14:10:00',2.99),('15087','2014-05-05','14:15:00',4.61),('15087','2014-05-05','14:20:00',5.08),('15087','2014-05-05','14:25:00',5.28),('15087','2014-05-05','14:30:00',4.25),('15087','2014-05-05','14:35:00',2.92),('15087','2014-05-05','14:40:00',2.75),('15087','2014-05-05','14:45:00',1.58),('15087','2014-05-05','14:50:00',1.5),('15087','2014-05-05','14:55:00',1.74),('15087','2014-05-05','15:00:00',2.69),('15087','2014-05-05','15:05:00',3.96),('15087','2014-05-05','15:10:00',2.76),('15087','2014-05-05','15:15:00',1.4),('15087','2014-05-05','15:20:00',1.42),('15087','2014-05-05','15:25:00',1.85),('15087','2014-05-05','15:30:00',3.85),('15087','2014-05-05','15:35:00',1.85),('15087','2014-05-05','15:40:00',2.35),('15087','2014-05-05','15:45:00',3.71),('15087','2014-05-05','15:50:00',1.31),('15087','2014-05-05','15:55:00',1.25),('15087','2014-05-05','16:00:00',2.01),('15087','2014-05-05','16:05:00',2.06),('15087','2014-05-05','16:10:00',2.37),('15087','2014-05-05','16:15:00',1.36),('15087','2014-05-05','16:20:00',1.49),('15087','2014-05-05','16:25:00',1.32),('15087','2014-05-05','16:30:00',1.39),('15087','2014-05-05','16:35:00',3.38),('15087','2014-05-05','16:40:00',3.04),('15087','2014-05-05','16:45:00',2.91),('15087','2014-05-05','16:50:00',2.95),('15087','2014-05-05','16:55:00',2.69),('15087','2014-05-05','17:00:00',2.5),('15087','2014-05-05','17:05:00',2.47),('15087','2014-05-05','17:10:00',2.46),('15087','2014-05-05','17:15:00',2.38),('15087','2014-05-05','17:20:00',2.25),('15087','2014-05-05','17:25:00',2.07),('15087','2014-05-05','17:30:00',1.79),('15087','2014-05-05','17:35:00',1.79),('15087','2014-05-05','17:40:00',1.62),('15087','2014-05-05','17:45:00',1.58),('15087','2014-05-05','17:50:00',1.61),('15087','2014-05-05','17:55:00',1.45),('15087','2014-05-05','18:00:00',1.3),('15087','2014-05-05','18:05:00',1.35),('15087','2014-05-05','18:10:00',1.22),('15087','2014-05-05','18:15:00',1.12),('15087','2014-05-05','18:20:00',1.02),('15087','2014-04-26','09:05:00',1.01),('15087','2014-04-26','09:55:00',1.42),('15087','2014-04-26','10:00:00',1.54),('15087','2014-04-26','10:05:00',1.38),('15087','2014-04-26','10:10:00',1.31),('15087','2014-04-26','10:15:00',1.37),('15087','2014-04-26','10:20:00',1.56),('15087','2014-04-26','10:25:00',1.77),('15087','2014-04-26','10:30:00',2.05),('15087','2014-04-26','10:35:00',2.32),('15087','2014-04-26','10:40:00',2.32),('15087','2014-04-26','10:45:00',2.3),('15087','2014-04-26','10:50:00',2.57),('15087','2014-04-26','10:55:00',4.09),('15087','2014-04-26','11:00:00',4),('15087','2014-04-26','11:05:00',3.88),('15087','2014-04-26','11:10:00',3.64),('15087','2014-04-26','11:15:00',3.45),('15087','2014-04-26','11:20:00',3.48),('15087','2014-04-26','11:25:00',3.36),('15087','2014-04-26','11:30:00',3.49),('15087','2014-04-26','11:35:00',3.38),('15087','2014-04-26','11:40:00',3.18),('15087','2014-04-26','11:45:00',3.43),('15087','2014-04-26','11:50:00',3.42),('15087','2014-04-26','11:55:00',3.21),('15087','2014-04-26','12:00:00',3.3),('15087','2014-04-26','12:05:00',3.55),('15087','2014-04-26','12:10:00',3.55),('15087','2014-04-26','12:15:00',2.64),('15087','2014-04-26','12:20:00',3.18),('15087','2014-04-26','12:25:00',2.97),('15087','2014-04-26','12:30:00',2.44),('15087','2014-04-26','12:35:00',3.97),('15087','2014-04-26','12:40:00',3.86),('15087','2014-04-26','12:45:00',4.12),('15087','2014-04-26','12:50:00',4.14),('15087','2014-04-26','12:55:00',4.75),('15087','2014-04-26','13:00:00',4.67),('15087','2014-04-26','13:05:00',3.19),('15087','2014-04-26','13:10:00',3.6),('15087','2014-04-26','13:15:00',4.73),('15087','2014-04-26','13:20:00',5.09),('15087','2014-04-26','13:25:00',4.11),('15087','2014-04-26','13:30:00',1.56),('15087','2014-04-26','13:35:00',2.19),('15087','2014-04-26','13:40:00',5.07),('15087','2014-04-26','13:45:00',4.8),('15087','2014-04-26','13:50:00',4.65),('15087','2014-04-26','13:55:00',4.66),('15087','2014-04-26','14:00:00',3.43),('15087','2014-04-26','14:10:00',1.69),('15087','2014-04-26','14:15:00',1.52),('15087','2014-04-26','14:35:00',1.46),('15087','2014-04-26','14:40:00',2.46),('15087','2014-01-26','09:05:00',1.3),('15087','2014-01-26','09:30:00',1.61),('15087','2014-01-26','09:35:00',1.66),('15087','2014-01-26','09:45:00',1.28),('15087','2014-01-26','09:50:00',1.56),('15087','2014-01-26','09:55:00',1.12),('15087','2014-01-26','10:10:00',1.95),('15087','2014-01-26','10:15:00',2.33),('15087','2014-01-26','10:20:00',1.18),('15087','2014-01-26','10:25:00',1.05),('15087','2014-01-26','11:25:00',1.15),('15087','2014-01-26','12:15:00',1.25),('15087','2014-01-26','12:20:00',1.34),('15087','2014-01-26','12:25:00',1.47),('15087','2014-01-26','12:30:00',2.82),('15087','2014-01-26','12:35:00',2.07),('15087','2014-01-26','12:40:00',1.36),('15087','2014-01-26','12:45:00',1.15),('15087','2014-01-26','13:00:00',1.06),('15087','2014-01-26','13:05:00',1.23),('15087','2014-01-26','13:10:00',1.37),('15087','2014-01-26','13:15:00',1.54),('15087','2014-01-26','13:20:00',1.6),('15087','2014-01-26','13:25:00',1.29),('15087','2014-01-26','13:50:00',1),('15087','2014-01-26','15:45:00',1.02),('15087','2014-01-25','09:05:00',1.37),('15087','2014-01-25','09:10:00',1.27),('15087','2014-01-25','09:20:00',1.29),('15087','2014-01-25','09:50:00',1.69),('15087','2014-01-25','09:55:00',2.08),('15087','2014-01-25','10:00:00',1.21),('15087','2014-01-25','10:05:00',2.56),('15087','2014-01-25','10:10:00',2.8),('15087','2014-01-25','10:15:00',2.99),('15087','2014-01-25','10:20:00',2.91),('15087','2014-01-25','10:25:00',1.95),('15087','2014-01-25','10:30:00',1.83),('15087','2014-01-25','10:45:00',1.45),('15087','2014-01-25','10:50:00',2.19),('15087','2014-01-25','10:55:00',1.86),('15087','2014-01-25','11:00:00',1.35),('15087','2014-01-25','11:15:00',1.16),('15087','2014-01-25','11:20:00',1.2),('15087','2014-01-25','11:25:00',1.54),('15087','2014-01-25','11:30:00',3.98),('15087','2014-01-25','11:35:00',2.27),('15087','2014-01-25','11:40:00',2.01),('15087','2014-01-25','11:45:00',1.49),('15087','2014-01-25','11:50:00',1.68),('15087','2014-01-25','11:55:00',1.49),('15087','2014-01-25','12:00:00',1.7),('15087','2014-01-25','12:05:00',1.85),('15087','2014-01-25','12:10:00',1.98),('15087','2014-01-25','12:15:00',1.52),('15087','2014-01-25','12:20:00',1.98),('15087','2014-01-25','12:25:00',2.14),('15087','2014-01-25','12:30:00',2.02),('15087','2014-01-25','12:35:00',1.5),('15087','2014-01-25','12:40:00',1.88),('15087','2014-01-25','12:45:00',2.29),('15087','2014-01-25','12:50:00',2.32),('15087','2014-01-25','12:55:00',2.7),('15087','2014-01-25','13:00:00',2.73),('15087','2014-01-25','13:05:00',2.45),('15087','2014-01-25','13:10:00',2.86),('15087','2014-01-25','13:15:00',2.32),('15087','2014-01-25','13:20:00',1.15),('15087','2014-01-25','13:25:00',1.65),('15087','2014-01-25','13:30:00',1.61),('15087','2014-01-25','13:35:00',1.46),('15087','2014-01-25','13:40:00',1.02),('15087','2014-01-25','13:45:00',1.43),('15087','2014-01-25','13:50:00',1.31),('15087','2014-01-25','14:00:00',1.36),('15087','2014-01-25','14:05:00',1.44),('15087','2014-01-25','14:10:00',2.09),('15087','2014-01-25','14:15:00',1.58),('15087','2014-01-25','14:20:00',2.2),('15087','2014-01-25','14:25:00',2.25),('15087','2014-01-25','14:30:00',2.49),('15087','2014-01-25','14:35:00',2.6),('15087','2014-01-25','14:40:00',2.28),('15087','2014-01-25','14:45:00',2.37),('15087','2014-01-25','14:50:00',2.17),('15087','2014-01-25','14:55:00',1.97),('15087','2014-01-25','15:00:00',1.66),('15087','2014-01-25','15:05:00',1.64),('15087','2014-01-25','15:10:00',1.48),('15087','2014-01-25','15:15:00',1.36),('15087','2014-01-25','15:20:00',1.25),('15087','2014-01-25','15:25:00',1.12),('15087','2014-01-25','15:30:00',1.01),('15087','2014-01-24','10:05:00',1.04),('15087','2014-01-24','10:10:00',1.19),('15087','2014-01-24','10:15:00',1.83),('15087','2014-01-24','10:25:00',1.07),('15087','2014-01-24','10:30:00',1.79),('15087','2014-01-24','10:35:00',1.67),('15087','2014-01-24','10:40:00',2.29),('15087','2014-01-24','10:45:00',2.02),('15087','2014-01-24','10:50:00',1.21),('15087','2014-01-24','10:55:00',1.06),('15087','2014-01-24','11:00:00',1.12),('15087','2014-01-24','11:25:00',1.19),('15087','2014-01-24','11:30:00',1.63),('15087','2014-01-24','11:35:00',1.4),('15087','2014-01-24','11:45:00',1.96),('15087','2014-01-24','11:50:00',3.42),('15087','2014-01-24','11:55:00',3.22),('15087','2014-01-24','12:00:00',1.87),('15087','2014-01-24','12:05:00',1.49),('15087','2014-01-24','12:10:00',1.11),('15087','2014-01-24','12:25:00',1.95),('15087','2014-01-24','12:30:00',1.36),('15087','2014-01-24','12:35:00',3.02),('15087','2014-01-24','12:40:00',2.91),('15087','2014-01-24','12:45:00',1.7),('15087','2014-01-24','12:50:00',1.24),('15087','2014-01-24','12:55:00',1.69),('15087','2014-01-24','13:00:00',1.85),('15087','2014-01-24','13:05:00',2.12),('15087','2014-01-24','13:10:00',1.28),('15087','2014-01-24','13:30:00',1.22),('15087','2014-01-24','13:35:00',1.73),('15087','2014-01-24','13:40:00',1.53),('15087','2014-01-24','13:45:00',1.15),('15087','2014-01-24','13:50:00',1.03),('15087','2014-01-24','13:55:00',1.63),('15087','2014-01-24','14:00:00',1.39),('15087','2014-01-24','14:10:00',2.88),('15087','2014-01-24','14:15:00',2.45),('15087','2014-01-24','14:20:00',2.23),('15087','2014-01-24','14:25:00',1.99),('15087','2014-01-23','11:00:00',1.09),('15087','2014-01-23','11:05:00',1.08),('15087','2014-01-23','11:10:00',1.07),('15087','2014-01-23','11:15:00',1.06),('15087','2014-01-23','11:20:00',1.03),('15087','2014-01-23','12:30:00',1.07),('15087','2014-01-22','11:10:00',1.02),('15087','2014-01-22','11:20:00',1),('15087','2014-01-22','13:10:00',1.03),('15087','2014-01-22','13:15:00',1.75),('15087','2014-01-22','13:20:00',1.01),('15087','2014-01-21','10:00:00',1.25),('15087','2014-01-21','10:05:00',1.25),('15087','2014-01-21','10:55:00',1.7),('15087','2014-01-21','11:00:00',2.45),('15087','2014-01-21','11:50:00',1.05),('15087','2014-01-21','12:00:00',1),('15087','2014-01-21','12:05:00',1.8),('15087','2014-01-21','12:10:00',1.92),('15087','2014-01-21','12:15:00',1.36),('15087','2014-01-21','12:20:00',1.13),('15087','2014-01-21','12:25:00',1.55),('15087','2014-01-21','12:30:00',1.95),('15087','2014-01-21','12:35:00',1.62),('15087','2014-01-21','12:40:00',1.43),('15087','2014-01-21','12:45:00',1.3),('15087','2014-01-21','12:50:00',2),('15087','2014-01-21','13:20:00',1.03),('15087','2014-01-21','14:00:00',1.08),('15087','2014-01-21','14:05:00',1.41),('15087','2014-01-21','14:10:00',1.26),('15087','2014-01-21','14:15:00',1.02),('15087','2014-01-20','11:15:00',1),('15087','2014-01-20','11:20:00',1.75),('15087','2014-01-20','11:25:00',2.06),('15087','2014-01-20','11:30:00',2.14),('15087','2014-01-20','11:35:00',2.08),('15087','2014-01-20','11:40:00',3.1),('15087','2014-01-20','11:45:00',3.28),('15087','2014-01-20','11:50:00',1.81),('15087','2014-01-20','12:05:00',1.09),('15087','2014-01-20','12:25:00',1.03),('15087','2014-01-20','12:30:00',1.16),('15087','2014-01-20','13:15:00',1.03),('15087','2014-01-20','13:20:00',3.82),('15087','2014-01-20','13:25:00',3.32),('15087','2014-01-20','13:30:00',2.98),('15087','2014-01-20','13:35:00',2.77),('15087','2014-01-20','13:40:00',2.14),('15087','2014-01-20','13:45:00',2.35),('15087','2014-01-20','13:50:00',1.15),('15087','2014-01-20','13:55:00',1.4),('15087','2014-01-20','14:00:00',2.76),('15087','2014-01-20','14:05:00',1.63),('15087','2014-01-20','14:10:00',1.15),('15087','2014-01-19','12:00:00',1.05),('15087','2014-01-19','12:05:00',1.08),('15087','2014-01-19','12:10:00',1.03),('15087','2014-01-19','13:05:00',1.03),('15087','2014-01-19','13:10:00',1.15),('15087','2014-01-19','14:20:00',1.43),('15087','2014-01-19','14:25:00',1.65),('15087','2014-01-19','14:30:00',1.95),('15087','2014-01-19','14:35:00',1.2),('15087','2014-01-18','10:00:00',1.26),('15087','2014-01-18','10:05:00',1.83),('15087','2014-01-18','10:10:00',2.37),('15087','2014-01-18','10:15:00',2.55),('15087','2014-01-18','10:20:00',2.17),('15087','2014-01-18','10:25:00',1.64),('15087','2014-01-18','10:30:00',1.75),('15087','2014-01-18','10:35:00',1.13),('15087','2014-01-18','10:40:00',1.12),('15087','2014-01-18','10:45:00',1.26),('15087','2014-01-18','10:50:00',1.28),('15087','2014-01-18','10:55:00',1.13),('15087','2014-01-18','11:05:00',1.39),('15087','2014-01-18','11:10:00',2.34),('15087','2014-01-18','11:15:00',2.93),('15087','2014-01-18','11:20:00',2.79),('15087','2014-01-18','11:25:00',2.67),('15087','2014-01-18','11:30:00',2.74),('15087','2014-01-18','11:35:00',2.79),('15087','2014-01-18','11:40:00',2.9),('15087','2014-01-18','11:45:00',3.18),('15087','2014-01-18','11:50:00',2.91),('15087','2014-01-18','11:55:00',3.33),('15087','2014-01-18','12:00:00',3.19),('15087','2014-01-18','12:05:00',2.42),('15087','2014-01-18','12:10:00',3.02),('15087','2014-01-18','12:15:00',2.85),('15087','2014-01-18','12:20:00',2.85),('15087','2014-01-18','12:25:00',2.85),('15087','2014-01-18','12:30:00',2.86),('15087','2014-01-18','12:35:00',2.83),('15087','2014-01-18','12:40:00',2.86),('15087','2014-01-18','12:45:00',2.72),('15087','2014-01-18','12:50:00',2.33),('15087','2014-01-18','12:55:00',2.84),('15087','2014-01-18','13:00:00',1.97),('15087','2014-01-18','13:05:00',1.68),('15087','2014-01-18','13:10:00',2.26),('15087','2014-01-18','13:15:00',2.76),('15087','2014-01-18','13:20:00',1.78),('15087','2014-01-18','13:25:00',1.31),('15087','2014-01-18','13:30:00',2.35),('15087','2014-01-18','13:35:00',1.5),('15087','2014-01-18','13:40:00',2.06),('15087','2014-01-18','13:45:00',2.33),('15087','2014-01-18','13:50:00',1.71),('15087','2014-01-18','13:55:00',2.2),('15087','2014-01-18','14:00:00',2.23),('15087','2014-01-18','14:05:00',2.07),('15087','2014-01-18','14:10:00',1.93),('15087','2014-01-18','14:15:00',1.89),('15087','2014-01-18','14:20:00',1.94),('15087','2014-01-18','14:25:00',1.77),('15087','2014-01-18','14:30:00',1.7),('15087','2014-01-18','14:35:00',1.62),('15087','2014-01-18','14:40:00',1.56),('15087','2014-01-18','14:45:00',1.5),('15087','2014-01-18','14:50:00',1.39),('15087','2014-01-17','09:25:00',1.09),('15087','2014-01-17','09:30:00',1.19),('15087','2014-01-17','09:35:00',1.33),('15087','2014-01-17','09:40:00',1.6),('15087','2014-01-17','09:45:00',1.79),('15087','2014-01-17','09:50:00',1.02),('15087','2014-01-17','11:25:00',1.16),('15087','2014-01-17','11:30:00',1.76),('15087','2014-01-17','11:35:00',2.03),('15087','2014-01-17','11:40:00',1.81),('15087','2014-01-17','11:55:00',1.2),('15087','2014-01-17','12:00:00',1.48),('15087','2014-01-17','12:05:00',1.64),('15087','2014-01-17','12:10:00',1.25),('15087','2014-01-17','12:40:00',1.01),('15087','2014-01-17','12:45:00',1.16),('15087','2014-04-25','08:00:00',1.21),('15087','2014-04-25','08:05:00',1.35),('15087','2014-04-25','08:10:00',1.42),('15087','2014-04-25','08:15:00',1.43),('15087','2014-04-25','08:20:00',1.53),('15087','2014-04-25','08:25:00',1.67),('15087','2014-04-25','08:30:00',1.77),('15087','2014-04-25','08:35:00',1.84),('15087','2014-04-25','08:40:00',1.93),('15087','2014-04-25','08:45:00',2.01),('15087','2014-04-25','08:50:00',2.13),('15087','2014-04-25','08:55:00',1.33),('15087','2014-04-25','09:00:00',1.16),('15087','2014-04-25','09:05:00',1.07),('15087','2014-04-25','09:25:00',1.34),('15087','2014-04-25','09:30:00',1.12),('15087','2014-04-25','09:35:00',1.04),('15087','2014-04-25','09:45:00',1),('15087','2014-04-25','09:50:00',1.01),('15087','2014-04-25','09:55:00',1.11),('15087','2014-04-25','10:00:00',1.32),('15087','2014-04-25','10:05:00',1.25),('15087','2014-04-25','10:10:00',1.35),('15087','2014-04-25','10:15:00',1.26),('15087','2014-04-25','10:20:00',1.4),('15087','2014-04-25','10:25:00',1.45),('15087','2014-04-25','10:30:00',2.94),('15087','2014-04-25','10:35:00',3.37),('15087','2014-04-25','10:40:00',3.47),('15087','2014-04-25','10:45:00',4.25),('15087','2014-04-25','10:50:00',2.2),('15087','2014-04-25','10:55:00',3.64),('15087','2014-04-25','11:00:00',3.72),('15087','2014-04-25','11:05:00',2.47),('15087','2014-04-25','11:10:00',4.4),('15087','2014-04-25','11:15:00',4.43),('15087','2014-04-25','11:20:00',4.27),('15087','2014-04-25','11:25:00',4.41),('15087','2014-04-25','11:30:00',2.36),('15087','2014-04-25','11:35:00',3.45),('15087','2014-04-25','11:40:00',3.12),('15087','2014-04-25','11:45:00',1.41),('15087','2014-04-25','11:50:00',1.49),('15087','2014-04-25','11:55:00',4.79),('15087','2014-04-25','12:00:00',2.98),('15087','2014-04-25','12:05:00',5.09),('15087','2014-04-25','12:10:00',4.04),('15087','2014-04-25','12:15:00',1.59),('15087','2014-04-25','12:20:00',3.64),('15087','2014-04-25','12:25:00',4.28),('15087','2014-04-25','12:30:00',4.83),('15087','2014-04-25','12:35:00',4.9),('15087','2014-04-25','12:40:00',5.07),('15087','2014-04-25','12:45:00',5.15),('15087','2014-04-25','12:50:00',2.36),('15087','2014-04-25','12:55:00',2.89),('15087','2014-04-25','13:00:00',2.97),('15087','2014-04-25','13:05:00',2.39),('15087','2014-04-25','13:10:00',4.32),('15087','2014-04-25','13:15:00',2.03),('15087','2014-04-25','13:20:00',1.92),('15087','2014-04-25','13:25:00',3.32),('15087','2014-04-25','13:30:00',1.34),('15087','2014-04-25','13:35:00',1.09),('15087','2014-04-25','13:40:00',1.48),('15087','2014-04-25','13:45:00',1.32),('15087','2014-04-25','13:50:00',2.01),('15087','2014-04-25','13:55:00',2.59),('15087','2014-04-25','14:00:00',1.43),('15087','2014-04-25','14:05:00',1.52),('15087','2014-04-25','14:10:00',1.22),('15087','2014-04-25','14:15:00',1.4),('15087','2014-04-25','14:20:00',4.06),('15087','2014-04-25','14:25:00',2.22),('15087','2014-04-25','14:30:00',2.38),('15087','2014-04-25','14:35:00',4.11),('15087','2014-04-25','14:40:00',3.85),('15087','2014-04-25','14:45:00',3.81),('15087','2014-04-25','14:50:00',3.97),('15087','2014-04-25','14:55:00',3.92),('15087','2014-04-25','15:00:00',3.77),('15087','2014-04-25','15:05:00',3.79),('15087','2014-04-25','15:10:00',3.76),('15087','2014-04-25','15:15:00',3.64),('15087','2014-04-25','15:20:00',3.21),('15087','2014-04-25','15:25:00',3.17),('15087','2014-04-25','15:30:00',3.18),('15087','2014-04-25','15:35:00',3.41),('15087','2014-04-25','15:40:00',3.29),('15087','2014-04-25','15:45:00',3.17),('15087','2014-04-25','15:50:00',3.18),('15087','2014-04-25','15:55:00',3.12),('15087','2014-04-25','16:00:00',3.09),('15087','2014-04-25','16:05:00',2.88),('15087','2014-04-25','16:10:00',2.75),('15087','2014-04-25','16:15:00',2.72),('15087','2014-04-25','16:20:00',2.51),('15087','2014-04-25','16:25:00',2.55),('15087','2014-04-25','16:30:00',2.53),('15087','2014-04-25','16:35:00',2.68),('15087','2014-04-25','16:40:00',2.69),('15087','2014-04-25','16:45:00',2.56),('15087','2014-04-25','16:50:00',2.25),('15087','2014-04-25','16:55:00',1.85),('15087','2014-04-25','17:00:00',1.79),('15087','2014-04-25','17:05:00',2.13),('15087','2014-04-25','17:10:00',1.72),('15087','2014-04-25','17:15:00',1.76),('15087','2014-04-25','17:20:00',1.18),('15087','2014-04-25','17:35:00',1),('15087','2014-01-16','09:20:00',1.05),('15087','2014-01-16','09:25:00',1.21),('15087','2014-01-16','09:30:00',1.32),('15087','2014-01-16','09:35:00',1.52),('15087','2014-01-16','09:40:00',1.78),('15087','2014-01-16','09:45:00',1.65),('15087','2014-01-16','09:50:00',1.3),('15087','2014-01-16','09:55:00',1.01),('15087','2014-01-16','10:10:00',1.08),('15087','2014-01-16','10:15:00',1.37),('15087','2014-01-16','10:20:00',1.3),('15087','2014-01-16','10:25:00',1.55),('15087','2014-01-16','10:30:00',2.22),('15087','2014-01-16','10:35:00',2.8),('15087','2014-01-16','10:40:00',2.44),('15087','2014-01-16','10:45:00',1.84),('15087','2014-01-16','10:50:00',1.99),('15087','2014-01-16','10:55:00',2.17),('15087','2014-01-16','11:00:00',2.18),('15087','2014-01-16','11:05:00',2.16),('15087','2014-01-16','11:10:00',2.27),('15087','2014-01-16','11:15:00',2.18),('15087','2014-01-16','11:20:00',1.99),('15087','2014-01-16','11:25:00',2.05),('15087','2014-01-16','11:30:00',1.88),('15087','2014-01-16','11:35:00',1.8),('15087','2014-01-16','11:40:00',1.66),('15087','2014-01-16','11:45:00',1.83),('15087','2014-01-16','11:50:00',1.46),('15087','2014-01-16','11:55:00',1.54),('15087','2014-01-16','12:00:00',1.53),('15087','2014-01-16','12:05:00',1.65),('15087','2014-01-16','12:10:00',1.89),('15087','2014-01-16','12:15:00',1.76),('15087','2014-01-16','12:20:00',1.58),('15087','2014-01-16','12:25:00',1.49),('15087','2014-01-16','12:30:00',1.62),('15087','2014-01-16','12:35:00',1.98),('15087','2014-01-16','12:40:00',2.01),('15087','2014-01-16','12:45:00',2.02),('15087','2014-01-16','12:50:00',2.19),('15087','2014-01-16','12:55:00',2.19),('15087','2014-01-16','13:00:00',2.26),('15087','2014-01-16','13:05:00',1.98),('15087','2014-01-16','13:10:00',2.25),('15087','2014-01-16','13:15:00',1.85),('15087','2014-01-16','13:20:00',1.64),('15087','2014-01-16','13:25:00',1.93),('15087','2014-01-16','13:30:00',1.15),('15087','2014-01-16','13:35:00',1.05),('15087','2014-01-16','13:40:00',1.57),('15087','2014-01-16','13:45:00',2.06),('15087','2014-01-16','13:50:00',1.9),('15087','2014-01-16','13:55:00',2.05),('15087','2014-01-16','14:00:00',1.08),('15087','2014-01-16','14:05:00',1.09),('15087','2014-01-16','14:10:00',1.03),('15087','2014-01-15','10:15:00',1.56),('15087','2014-01-15','10:20:00',2.04),('15087','2014-01-15','10:25:00',2.25),('15087','2014-01-15','10:30:00',1.86),('15087','2014-01-15','10:35:00',1.56),('15087','2014-01-15','10:40:00',2.02),('15087','2014-01-15','10:45:00',1.67),('15087','2014-01-15','10:50:00',1.04),('15087','2014-01-15','10:55:00',1.09),('15087','2014-01-15','11:00:00',1.47),('15087','2014-01-15','11:05:00',2),('15087','2014-01-15','11:10:00',2.57),('15087','2014-01-15','11:15:00',2.71),('15087','2014-01-15','11:20:00',2.6),('15087','2014-01-15','11:25:00',2.42),('15087','2014-01-15','11:30:00',2.1),('15087','2014-01-15','11:35:00',1.25),('15087','2014-01-15','11:40:00',2.1),('15087','2014-01-15','11:45:00',2.41),('15087','2014-01-15','11:50:00',2.42),('15087','2014-01-15','11:55:00',2.1),('15087','2014-01-15','12:00:00',2.04),('15087','2014-01-15','12:05:00',1.77),('15087','2014-01-15','12:10:00',1.71),('15087','2014-01-15','12:15:00',1.99),('15087','2014-01-15','12:20:00',2.6),('15087','2014-01-15','12:25:00',2.05),('15087','2014-01-15','12:30:00',1.46),('15087','2014-01-15','12:35:00',1.72),('15087','2014-01-15','12:40:00',1.43),('15087','2014-01-15','12:45:00',1.54),('15087','2014-01-15','12:50:00',1.61),('15087','2014-01-15','12:55:00',1.4),('15087','2014-01-15','13:00:00',1.3),('15087','2014-01-15','13:05:00',1.4),('15087','2014-01-15','13:10:00',1.88),('15087','2014-01-15','13:15:00',2.66),('15087','2014-01-15','13:20:00',2.71),('15087','2014-01-15','13:25:00',2.69),('15087','2014-01-15','13:30:00',2.48),('15087','2014-01-15','13:35:00',2.09),('15087','2014-01-15','13:40:00',2.24),('15087','2014-01-15','13:45:00',2.21),('15087','2014-01-15','13:50:00',1.9),('15087','2014-01-15','13:55:00',1.03),('15087','2014-01-15','14:00:00',1.87),('15087','2014-01-15','14:05:00',1.85),('15087','2014-01-15','14:10:00',1.97),('15087','2014-01-15','14:15:00',1.7),('15087','2014-01-15','14:20:00',1.76),('15087','2014-01-15','14:25:00',1.77),('15087','2014-01-15','14:30:00',1.73),('15087','2014-01-15','14:35:00',1.67),('15087','2014-01-15','14:40:00',1.68),('15087','2014-01-15','14:45:00',1.65),('15087','2014-01-15','14:50:00',1.43),('15087','2014-01-15','14:55:00',1.33),('15087','2014-01-15','15:00:00',1.23),('15087','2014-01-15','15:05:00',1.12),('15087','2014-01-15','15:10:00',1.03),('15087','2014-01-14','10:25:00',1.71),('15087','2014-01-14','10:30:00',2.92),('15087','2014-01-14','10:35:00',2.95),('15087','2014-01-14','10:40:00',2.52),('15087','2014-01-14','10:45:00',2.36),('15087','2014-01-14','10:50:00',1.42),('15087','2014-01-14','10:55:00',1.24),('15087','2014-01-14','11:00:00',1.59),('15087','2014-01-14','11:05:00',1.15),('15087','2014-01-14','11:30:00',1.02),('15087','2014-01-14','11:35:00',1.14),('15087','2014-01-14','11:40:00',1.35),('15087','2014-01-13','09:30:00',1.01),('15087','2014-01-13','09:35:00',1.14),('15087','2014-01-13','09:40:00',1.23),('15087','2014-01-13','09:45:00',1.33),('15087','2014-01-13','09:50:00',1.43),('15087','2014-01-13','09:55:00',1.51),('15087','2014-01-13','10:00:00',1.62),('15087','2014-01-13','10:05:00',1.71),('15087','2014-01-13','10:10:00',1.77),('15087','2014-01-13','10:15:00',1.84),('15087','2014-01-13','10:20:00',1.93),('15087','2014-01-13','10:25:00',1.99),('15087','2014-01-13','10:30:00',2.05),('15087','2014-01-13','10:35:00',2.1),('15087','2014-01-13','10:40:00',2.18),('15087','2014-01-13','10:45:00',2.21),('15087','2014-01-13','10:50:00',2.23),('15087','2014-01-13','10:55:00',2.3),('15087','2014-01-13','11:00:00',2.36),('15087','2014-01-13','11:05:00',2.39),('15087','2014-01-13','11:10:00',2.44),('15087','2014-01-13','11:15:00',2.49),('15087','2014-01-13','11:20:00',2.49),('15087','2014-01-13','11:25:00',2.51),('15087','2014-01-13','11:30:00',2.53),('15087','2014-01-13','11:35:00',2.55),('15087','2014-01-13','11:40:00',2.57),('15087','2014-01-13','11:45:00',2.55),('15087','2014-01-13','11:50:00',2.52),('15087','2014-01-13','11:55:00',2.53),('15087','2014-01-13','12:00:00',2.55),('15087','2014-01-13','12:05:00',2.52),('15087','2014-01-13','12:10:00',2.53),('15087','2014-01-13','12:15:00',2.54),('15087','2014-01-13','12:20:00',2.55),('15087','2014-01-13','12:25:00',2.55),('15087','2014-01-13','12:30:00',2.54),('15087','2014-01-13','12:35:00',2.49),('15087','2014-01-13','12:40:00',2.39),('15087','2014-01-13','12:45:00',2.24),('15087','2014-01-13','12:50:00',2.23),('15087','2014-01-13','12:55:00',2.06),('15087','2014-01-13','13:00:00',2.04),('15087','2014-01-13','13:05:00',2.15),('15087','2014-01-13','13:10:00',2.18),('15087','2014-01-13','13:15:00',2.12),('15087','2014-01-13','13:20:00',2.1),('15087','2014-01-13','13:25:00',2.12),('15087','2014-01-13','13:30:00',2.01),('15087','2014-01-13','13:35:00',1.93),('15087','2014-01-13','13:40:00',1.86),('15087','2014-01-13','13:45:00',1.8),('15087','2014-01-13','13:50:00',1.82),('15087','2014-01-13','13:55:00',1.8),('15087','2014-01-13','14:00:00',1.73),('15087','2014-01-13','14:05:00',1.68),('15087','2014-01-13','14:10:00',1.71),('15087','2014-01-13','14:15:00',1.63),('15087','2014-01-13','14:20:00',1.6),('15087','2014-01-13','14:25:00',1.53),('15087','2014-01-13','14:30:00',1.47),('15087','2014-01-13','14:35:00',1.36),('15087','2014-01-13','14:40:00',1.31),('15087','2014-01-13','14:45:00',1.24),('15087','2014-01-13','14:50:00',1.07),('15087','2014-01-13','14:55:00',1),('15087','2014-01-12','10:20:00',1.12),('15087','2014-01-12','10:25:00',1.06),('15087','2014-01-12','10:30:00',1.07),('15087','2014-01-12','10:35:00',1.26),('15087','2014-01-12','10:40:00',1.44),('15087','2014-01-12','10:45:00',1.42),('15087','2014-01-12','10:50:00',1.55),('15087','2014-01-12','10:55:00',1.69),('15087','2014-01-12','11:00:00',1.61),('15087','2014-01-12','11:05:00',1.69),('15087','2014-01-12','11:10:00',2.02),('15087','2014-01-12','11:15:00',1.77),('15087','2014-01-12','11:20:00',1.59),('15087','2014-01-12','11:25:00',1.58),('15087','2014-01-12','11:30:00',1.66),('15087','2014-01-12','11:35:00',1.46),('15087','2014-01-12','11:40:00',1.91),('15087','2014-01-12','11:45:00',2.15),('15087','2014-01-12','11:50:00',2.11),('15087','2014-01-12','11:55:00',1.93),('15087','2014-01-12','12:00:00',1.54),('15087','2014-01-12','12:05:00',1.54),('15087','2014-01-12','12:10:00',1.31),('15087','2014-01-12','12:15:00',1.24),('15087','2014-01-12','12:20:00',1.23),('15087','2014-01-12','12:25:00',1.18),('15087','2014-01-12','12:30:00',1.23),('15087','2014-01-12','12:35:00',1.27),('15087','2014-01-12','12:40:00',1.39),('15087','2014-01-12','12:45:00',1.3),('15087','2014-01-12','12:50:00',1.39),('15087','2014-01-12','12:55:00',1.31),('15087','2014-01-12','13:00:00',1.33),('15087','2014-01-12','13:05:00',1.2),('15087','2014-01-12','13:10:00',1.13),('15087','2014-01-12','13:15:00',1.1),('15087','2014-01-12','13:20:00',1.16),('15087','2014-01-12','13:25:00',1.22),('15087','2014-01-12','13:30:00',1.43),('15087','2014-01-12','13:35:00',1.27),('15087','2014-01-12','13:40:00',1.13),('15087','2014-01-11','09:55:00',1.33),('15087','2014-01-11','10:00:00',1.44),('15087','2014-01-11','10:05:00',1.15),('15087','2014-01-11','10:10:00',1.14),('15087','2014-01-11','10:15:00',1.3),('15087','2014-01-11','10:20:00',1.36),('15087','2014-01-11','10:25:00',1.64),('15087','2014-01-11','10:30:00',1.64),('15087','2014-01-11','10:35:00',1.72),('15087','2014-01-11','10:40:00',2.19),('15087','2014-01-11','10:45:00',2.31),('15087','2014-01-11','10:50:00',2.34),('15087','2014-01-11','10:55:00',2.35),('15087','2014-01-11','11:00:00',2.29),('15087','2014-01-11','11:05:00',2.25),('15087','2014-01-11','11:10:00',2.38),('15087','2014-01-11','11:15:00',2.15),('15087','2014-01-11','11:20:00',1.99),('15087','2014-01-11','11:25:00',2.05),('15087','2014-01-11','11:30:00',2.05),('15087','2014-01-11','11:35:00',1.82),('15087','2014-01-11','11:40:00',1.65),('15087','2014-01-11','11:45:00',1.71),('15087','2014-01-11','11:50:00',1.89),('15087','2014-01-11','11:55:00',1.91),('15087','2014-01-11','12:00:00',1.98),('15087','2014-01-11','12:05:00',2.2),('15087','2014-01-11','12:10:00',2.02),('15087','2014-01-11','12:15:00',1.99),('15087','2014-01-11','12:20:00',2),('15087','2014-01-11','12:25:00',1.86),('15087','2014-01-11','12:30:00',1.71),('15087','2014-01-11','12:35:00',1.53),('15087','2014-01-11','12:40:00',1.37),('15087','2014-01-11','12:45:00',1.69),('15087','2014-01-11','12:50:00',2),('15087','2014-01-11','12:55:00',2.04),('15087','2014-01-11','13:00:00',2.02),('15087','2014-01-11','13:05:00',1.86),('15087','2014-01-11','13:10:00',1.62),('15087','2014-01-11','13:15:00',2.02),('15087','2014-01-11','13:20:00',1.75),('15087','2014-01-11','13:25:00',1.48),('15087','2014-01-11','13:30:00',1.13),('15087','2014-01-11','13:35:00',1.13),('15087','2014-01-11','13:40:00',1.09),('15087','2014-01-11','13:45:00',1.24),('15087','2014-01-11','13:55:00',1.06),('15087','2014-01-11','14:00:00',1.46),('15087','2014-01-11','14:05:00',1.53),('15087','2014-01-11','14:10:00',1.22),('15087','2014-01-10','13:05:00',1),('15087','2014-01-09','09:30:00',1.1),('15087','2014-01-09','09:35:00',1.08),('15087','2014-01-09','09:40:00',1.29),('15087','2014-01-09','09:45:00',1.67),('15087','2014-01-09','09:50:00',1.76),('15087','2014-01-09','09:55:00',1.74),('15087','2014-01-09','10:00:00',1.81),('15087','2014-01-09','10:05:00',1.76),('15087','2014-01-09','10:10:00',1.63),('15087','2014-01-09','10:15:00',1.66),('15087','2014-01-09','10:20:00',1.71),('15087','2014-01-09','10:25:00',1.86),('15087','2014-01-09','10:30:00',1.9),('15087','2014-01-09','10:35:00',1.98),('15087','2014-01-09','10:40:00',2.24),('15087','2014-01-09','10:45:00',1.92),('15087','2014-01-09','10:50:00',1.19),('15087','2014-01-09','10:55:00',1.24),('15087','2014-01-09','11:00:00',1.39),('15087','2014-01-09','11:05:00',1.33),('15087','2014-01-09','11:10:00',1.15),('15087','2014-01-09','11:15:00',1.23),('15087','2014-01-09','11:20:00',1.52),('15087','2014-01-09','11:25:00',1.41),('15087','2014-01-09','11:30:00',1.31),('15087','2014-01-09','11:35:00',1.76),('15087','2014-01-09','11:40:00',1.75),('15087','2014-01-09','11:45:00',1.13),('15087','2014-01-09','13:15:00',1.05),('15087','2014-01-08','09:40:00',1.09),('15087','2014-01-08','09:45:00',1.21),('15087','2014-01-08','09:50:00',1.28),('15087','2014-01-08','09:55:00',1.43),('15087','2014-01-08','10:00:00',1.53),('15087','2014-01-08','10:05:00',1.5),('15087','2014-01-08','10:10:00',1.6),('15087','2014-01-08','10:15:00',1.66),('15087','2014-01-08','10:20:00',1.79),('15087','2014-01-08','10:25:00',1.95),('15087','2014-01-08','10:30:00',2.02),('15087','2014-01-08','10:35:00',1.97),('15087','2014-01-08','10:40:00',1.96),('15087','2014-01-08','10:45:00',2.13),('15087','2014-01-08','10:50:00',2.21),('15087','2014-01-08','10:55:00',2.24),('15087','2014-01-08','11:00:00',2.3),('15087','2014-01-08','11:05:00',2.35),('15087','2014-01-08','11:10:00',2.39),('15087','2014-01-08','11:15:00',2.43),('15087','2014-01-08','11:20:00',2.45),('15087','2014-01-08','11:25:00',2.45),('15087','2014-01-08','11:30:00',2.49),('15087','2014-01-08','11:35:00',2.58),('15087','2014-01-08','11:40:00',2.61),('15087','2014-01-08','11:45:00',2.61),('15087','2014-01-08','11:50:00',2.6),('15087','2014-01-08','11:55:00',2.56),('15087','2014-01-08','12:00:00',2.57),('15087','2014-01-08','12:05:00',2.5),('15087','2014-01-08','12:10:00',2.52),('15087','2014-01-08','12:15:00',2.54),('15087','2014-01-08','12:20:00',2.53),('15087','2014-01-08','12:25:00',2.51),('15087','2014-01-08','12:30:00',2.53),('15087','2014-01-08','12:35:00',2.53),('15087','2014-01-08','12:40:00',2.29),('15087','2014-01-08','12:45:00',2.29),('15087','2014-01-08','12:50:00',2.22),('15087','2014-01-08','12:55:00',2.11),('15087','2014-01-08','13:00:00',2.29),('15087','2014-01-08','13:05:00',2.1),('15087','2014-01-08','13:10:00',1.99),('15087','2014-01-08','13:15:00',2.07),('15087','2014-01-08','13:20:00',1.96),('15087','2014-01-08','13:25:00',1.84),('15087','2014-01-08','13:30:00',1.91),('15087','2014-01-08','13:35:00',1.8),('15087','2014-01-08','13:40:00',1.74),('15087','2014-01-08','13:45:00',1.81),('15087','2014-01-08','13:50:00',1.78),('15087','2014-01-08','13:55:00',1.66),('15087','2014-01-08','14:00:00',1.71),('15087','2014-01-08','14:05:00',1.66),('15087','2014-01-08','14:10:00',1.63),('15087','2014-01-08','14:15:00',1.6),('15087','2014-01-08','14:20:00',1.58),('15087','2014-01-08','14:25:00',1.52),('15087','2014-01-08','14:30:00',1.44),('15087','2014-01-08','14:35:00',1.35),('15087','2014-01-08','14:40:00',1.21),('15087','2014-01-08','14:45:00',1.07),('15087','2014-01-07','09:35:00',1.05),('15087','2014-01-07','09:40:00',1.13),('15087','2014-01-07','09:45:00',1.2),('15087','2014-01-07','09:50:00',1.26),('15087','2014-01-07','09:55:00',1.41),('15087','2014-01-07','10:00:00',1.57),('15087','2014-01-07','10:05:00',1.67),('15087','2014-01-07','10:10:00',1.76),('15087','2014-01-07','10:15:00',1.85),('15087','2014-01-07','10:20:00',1.93),('15087','2014-01-07','10:25:00',2),('15087','2014-01-07','10:30:00',2.05),('15087','2014-01-07','10:35:00',2.09),('15087','2014-01-07','10:40:00',2.14),('15087','2014-01-07','10:45:00',2.2),('15087','2014-01-07','10:50:00',2.27),('15087','2014-01-07','10:55:00',2.32),('15087','2014-01-07','11:00:00',2.38),('15087','2014-01-07','11:05:00',2.42),('15087','2014-01-07','11:10:00',2.48),('15087','2014-01-07','11:15:00',2.51),('15087','2014-01-07','11:20:00',2.55),('15087','2014-01-07','11:25:00',2.57),('15087','2014-01-07','11:30:00',2.58),('15087','2014-01-07','11:35:00',2.61),('15087','2014-01-07','11:40:00',2.64),('15087','2014-01-07','11:45:00',2.65),('15087','2014-01-07','11:50:00',2.66),('15087','2014-01-07','11:55:00',2.66),('15087','2014-01-07','12:00:00',2.68),('15087','2014-01-07','12:05:00',2.66),('15087','2014-01-07','12:10:00',2.64),('15087','2014-01-07','12:15:00',2.65),('15087','2014-01-07','12:20:00',2.64),('15087','2014-01-07','12:25:00',2.62),('15087','2014-01-07','12:30:00',2.6),('15087','2014-01-07','12:35:00',2.53),('15087','2014-01-07','12:40:00',2.34),('15087','2014-01-07','12:45:00',2.51),('15087','2014-01-07','12:50:00',2.38),('15087','2014-01-07','12:55:00',2.19),('15087','2014-01-07','13:00:00',2.27),('15087','2014-01-07','13:05:00',2.06),('15087','2014-01-07','13:10:00',1.99),('15087','2014-01-07','13:15:00',2.13),('15087','2014-01-07','13:20:00',1.98),('15087','2014-01-07','13:25:00',1.86),('15087','2014-01-07','13:30:00',1.9),('15087','2014-01-07','13:35:00',1.81),('15087','2014-01-07','13:40:00',1.8),('15087','2014-01-07','13:45:00',1.94),('15087','2014-01-07','13:50:00',1.95),('15087','2014-01-07','13:55:00',1.87),('15087','2014-01-07','14:00:00',1.74),('15087','2014-01-07','14:05:00',1.66),('15087','2014-01-07','14:10:00',1.61),('15087','2014-01-07','14:15:00',1.58),('15087','2014-01-07','14:20:00',1.52),('15087','2014-01-07','14:25:00',1.42),('15087','2014-01-07','14:30:00',1.3),('15087','2014-01-07','14:35:00',1.25),('15087','2014-01-07','14:40:00',1.15),('15087','2014-01-07','14:45:00',1.01),('15087','2014-04-24','07:50:00',1.04),('15087','2014-04-24','07:55:00',1.13),('15087','2014-04-24','08:10:00',1.36),('15087','2014-04-24','08:15:00',1.47),('15087','2014-04-24','08:20:00',1.57),('15087','2014-04-24','08:25:00',1.71),('15087','2014-04-24','08:30:00',1.55),('15087','2014-04-24','08:35:00',1.93),('15087','2014-04-24','08:40:00',2.01),('15087','2014-04-24','08:45:00',2.1),('15087','2014-04-24','08:50:00',1.72),('15087','2014-04-24','08:55:00',2.29),('15087','2014-04-24','09:00:00',2.36),('15087','2014-04-24','09:05:00',2.44),('15087','2014-04-24','09:10:00',1.95),('15087','2014-04-24','09:15:00',2.61),('15087','2014-04-24','09:20:00',2.7),('15087','2014-04-24','09:25:00',2.78),('15087','2014-04-24','09:30:00',2.4),('15087','2014-04-24','09:35:00',2.69),('15087','2014-04-24','09:40:00',3.01),('15087','2014-04-24','09:45:00',3.08),('15087','2014-04-24','09:50:00',3.14),('15087','2014-04-24','09:55:00',3.22),('15087','2014-04-24','10:00:00',3.3),('15087','2014-04-24','10:05:00',3.36),('15087','2014-04-24','10:10:00',3.4),('15087','2014-04-24','10:15:00',3.46),('15087','2014-04-24','10:20:00',3.54),('15087','2014-04-24','10:25:00',3.6),('15087','2014-04-24','10:30:00',3.62),('15087','2014-04-24','10:35:00',3.71),('15087','2014-04-24','10:40:00',3.77),('15087','2014-04-24','10:45:00',3.82),('15087','2014-04-24','10:50:00',3.88),('15087','2014-04-24','10:55:00',3.91),('15087','2014-04-24','11:00:00',3.86),('15087','2014-04-24','11:05:00',3.94),('15087','2014-04-24','11:10:00',4),('15087','2014-04-24','11:15:00',4.07),('15087','2014-04-24','11:20:00',4.1),('15087','2014-04-24','11:25:00',4.15),('15087','2014-04-24','11:30:00',4.15),('15087','2014-04-24','11:35:00',4.19),('15087','2014-04-24','11:40:00',4.23),('15087','2014-04-24','11:45:00',4.26),('15087','2014-04-24','11:50:00',4.23),('15087','2014-04-24','11:55:00',4.26),('15087','2014-04-24','12:00:00',4.34),('15087','2014-04-24','12:05:00',4.42),('15087','2014-04-24','12:10:00',3.93),('15087','2014-04-24','12:15:00',4.56),('15087','2014-04-24','12:20:00',4.52),('15087','2014-04-24','12:25:00',4.52),('15087','2014-04-24','12:30:00',4.6),('15087','2014-04-24','12:35:00',4.55),('15087','2014-04-24','12:40:00',4.58),('15087','2014-04-24','12:45:00',4.45),('15087','2014-04-24','12:50:00',4.47),('15087','2014-04-24','12:55:00',4.61),('15087','2014-04-24','13:00:00',4.59),('15087','2014-04-24','13:05:00',4.53),('15087','2014-04-24','13:10:00',4.61),('15087','2014-04-24','13:15:00',4.72),('15087','2014-04-24','13:20:00',4.67),('15087','2014-04-24','13:25:00',4.68),('15087','2014-04-24','13:30:00',3.04),('15087','2014-04-24','13:35:00',1.89),('15087','2014-04-24','13:40:00',1.16),('15087','2014-04-24','13:45:00',1.48),('15087','2014-04-24','13:50:00',5.11),('15087','2014-04-24','13:55:00',5.13),('15087','2014-04-24','14:00:00',4.91),('15087','2014-04-24','14:05:00',5.03),('15087','2014-04-24','14:10:00',4.73),('15087','2014-04-24','14:15:00',3.76),('15087','2014-04-24','14:20:00',4.76),('15087','2014-04-24','14:25:00',4.44),('15087','2014-04-24','14:30:00',4),('15087','2014-04-24','14:35:00',3.72),('15087','2014-04-24','14:40:00',2.9),('15087','2014-04-24','14:45:00',2.46),('15087','2014-04-24','14:50:00',2.39),('15087','2014-04-24','14:55:00',4.78),('15087','2014-04-24','15:00:00',4.28),('15087','2014-04-24','15:05:00',4.39),('15087','2014-04-24','15:10:00',4.62),('15087','2014-04-24','15:15:00',4.57),('15087','2014-04-24','15:20:00',3.3),('15087','2014-04-24','15:25:00',2.38),('15087','2014-04-24','15:30:00',2.86),('15087','2014-04-24','15:35:00',2.82),('15087','2014-04-24','15:40:00',2.61),('15087','2014-04-24','15:45:00',2.29),('15087','2014-04-24','15:50:00',2.57),('15087','2014-04-24','15:55:00',2.68),('15087','2014-04-24','16:00:00',3.84),('15087','2014-04-24','16:05:00',3.54),('15087','2014-04-24','16:10:00',2.88),('15087','2014-04-24','16:15:00',3.66),('15087','2014-04-24','16:20:00',3.08),('15087','2014-04-24','16:25:00',2.81),('15087','2014-04-24','16:30:00',3.08),('15087','2014-04-24','16:35:00',1.99),('15087','2014-04-24','16:40:00',2.09),('15087','2014-04-24','16:45:00',1.61),('15087','2014-04-24','16:50:00',1.37),('15087','2014-04-24','16:55:00',1.37),('15087','2014-04-24','17:00:00',1.41),('15087','2014-04-24','17:05:00',1.3),('15087','2014-04-24','17:10:00',1.23),('15087','2014-04-24','17:15:00',1.09),('15087','2014-04-24','17:20:00',1.07),('15087','2014-04-24','17:25:00',1.07),('15087','2014-04-24','17:30:00',1.08),('15087','2014-01-06','11:15:00',1.06),('15087','2014-01-06','11:20:00',1.02),('15087','2014-01-06','11:35:00',1.26),('15087','2014-01-06','11:40:00',2.61),('15087','2014-01-06','11:45:00',2.74),('15087','2014-01-06','11:50:00',2.62),('15087','2014-01-06','11:55:00',2.72),('15087','2014-01-06','12:00:00',2.78),('15087','2014-01-06','12:05:00',2.72),('15087','2014-01-06','12:10:00',2.66),('15087','2014-01-06','12:15:00',2.64),('15087','2014-01-06','12:20:00',2.63),('15087','2014-01-06','12:25:00',2.62),('15087','2014-01-06','12:30:00',2.62),('15087','2014-01-06','12:35:00',2.58),('15087','2014-01-06','12:40:00',2.52),('15087','2014-01-06','12:45:00',2.53),('15087','2014-01-06','12:50:00',2.44),('15087','2014-01-06','12:55:00',2.44),('15087','2014-01-06','13:00:00',2.32),('15087','2014-01-06','13:05:00',2.14),('15087','2014-01-06','13:10:00',2.31),('15087','2014-01-06','13:15:00',2.32),('15087','2014-01-06','13:20:00',2.11),('15087','2014-01-06','13:25:00',2.16),('15087','2014-01-06','13:30:00',1.92),('15087','2014-01-06','13:35:00',1.87),('15087','2014-01-06','13:40:00',1.92),('15087','2014-01-06','13:45:00',1.74),('15087','2014-01-06','13:50:00',1.75),('15087','2014-01-06','13:55:00',1.8),('15087','2014-01-06','14:00:00',1.5),('15087','2014-01-06','14:15:00',1.73),('15087','2014-01-06','14:20:00',1.43),('15087','2014-01-06','14:35:00',1.24),('15087','2014-01-06','14:40:00',1.37),('15087','2014-01-06','14:45:00',1.51),('15087','2014-01-06','14:50:00',1.14),('15087','2014-01-03','09:35:00',1.13),('15087','2014-01-03','09:40:00',1.43),('15087','2014-01-03','09:45:00',1.38),('15087','2014-01-03','09:50:00',1.04),('15087','2014-01-03','09:55:00',1),('15087','2014-01-03','10:00:00',1.58),('15087','2014-01-03','10:05:00',1.26),('15087','2014-01-03','10:10:00',1.6),('15087','2014-01-03','10:15:00',1.22),('15087','2014-01-03','10:20:00',1.58),('15087','2014-01-03','10:40:00',1.01),('15087','2014-01-03','10:45:00',1.22),('15087','2014-01-03','10:50:00',1.14),('15087','2014-01-03','11:35:00',1.15),('15087','2014-01-03','11:40:00',1.32),('15087','2014-01-03','11:45:00',1.39),('15087','2014-01-03','11:50:00',1.29),('15087','2014-01-03','11:55:00',1.3),('15087','2014-01-03','12:00:00',1.78),('15087','2014-01-03','12:05:00',1.92),('15087','2014-01-03','12:10:00',2.14),('15087','2014-01-03','12:15:00',2.94),('15087','2014-01-03','12:20:00',2.8),('15087','2014-01-03','12:25:00',2.37),('15087','2014-01-03','12:30:00',2.16),('15087','2014-01-03','12:35:00',1.79),('15087','2014-01-03','12:40:00',1.85),('15087','2014-01-03','12:45:00',1.8),('15087','2014-01-03','12:50:00',1.65),('15087','2014-01-03','12:55:00',1.46),('15087','2014-01-03','13:00:00',1.08),('15087','2014-01-03','13:05:00',1.73),('15087','2014-01-03','13:10:00',1.38),('15087','2014-01-03','13:15:00',1.17),('15087','2014-01-03','13:30:00',1.32),('15087','2014-01-03','13:35:00',1.63),('15087','2014-01-03','13:40:00',1.27),('15087','2014-01-03','13:45:00',1.1),('15087','2014-01-02','09:40:00',1.05),('15087','2014-01-02','09:45:00',1.11),('15087','2014-01-02','09:50:00',1.18),('15087','2014-01-02','09:55:00',1.21),('15087','2014-01-02','10:00:00',1.43),('15087','2014-01-02','10:05:00',1.51),('15087','2014-01-02','10:10:00',1.61),('15087','2014-01-02','10:15:00',1.73),('15087','2014-01-02','10:20:00',1.81),('15087','2014-01-02','10:25:00',1.89),('15087','2014-01-02','10:30:00',1.95),('15087','2014-01-02','10:35:00',1.98),('15087','2014-01-02','10:40:00',2.02),('15087','2014-01-02','10:45:00',2.08),('15087','2014-01-02','10:50:00',2.17),('15087','2014-01-02','10:55:00',2.3),('15087','2014-01-02','11:00:00',2.22),('15087','2014-01-02','11:05:00',2.28),('15087','2014-01-02','11:10:00',1.68),('15087','2014-01-02','11:15:00',1.38),('15087','2014-01-02','11:20:00',1.53),('15087','2014-01-02','11:25:00',1.66),('15087','2014-01-02','11:30:00',1.79),('15087','2014-01-02','11:35:00',2.31),('15087','2014-01-02','11:40:00',1.93),('15087','2014-01-02','11:45:00',1.71),('15087','2014-01-02','11:50:00',1.32),('15087','2014-01-02','11:55:00',1.23),('15087','2014-01-02','12:00:00',1.09),('15087','2014-01-02','12:05:00',1.16),('15087','2014-01-02','12:10:00',1.09),('15087','2014-01-02','12:50:00',1.53),('15087','2014-01-02','12:55:00',1.48),('15087','2014-01-02','13:30:00',1.27),('15087','2014-01-02','13:35:00',1.96),('15087','2014-01-02','13:40:00',1.85),('15087','2014-01-02','13:45:00',1.07),('15087','2014-01-01','09:35:00',1.21),('15087','2014-01-01','09:40:00',1.07),('15087','2014-01-01','09:45:00',1.25),('15087','2014-01-01','09:50:00',1.83),('15087','2014-01-01','09:55:00',1.42),('15087','2014-01-01','10:00:00',1.3),('15087','2014-01-01','10:05:00',1.08),('15087','2014-01-01','12:00:00',1.07),('15087','2014-01-01','12:05:00',1.12),('15087','2014-01-01','12:10:00',1.19),('15087','2014-01-01','12:15:00',1.22),('15087','2014-01-01','12:20:00',1.26),('15087','2014-01-01','12:25:00',1.27),('15087','2014-01-01','12:30:00',1.26),('15087','2014-01-01','12:35:00',1.28),('15087','2014-01-01','12:40:00',1.17),('15087','2014-01-01','12:45:00',1.2),('15087','2014-01-01','12:50:00',1.22),('15087','2014-01-01','12:55:00',1.21),('15087','2014-01-01','13:00:00',1.19),('15087','2014-01-01','13:05:00',1.09),('15087','2014-01-01','13:10:00',1.05),('15087','2014-01-01','13:15:00',1.04),('15087','2014-01-01','13:20:00',1.13),('15087','2014-01-01','13:25:00',1.31),('15087','2014-01-01','13:30:00',1.25),('15087','2014-01-01','13:35:00',1.29),('15087','2014-01-01','13:40:00',1.26),('15087','2014-01-01','13:45:00',1.13),('15087','2014-01-01','13:50:00',1.54),('15087','2014-01-01','13:55:00',1.48),('15087','2014-01-01','14:00:00',1.42),('15087','2014-01-01','14:05:00',1.06),('15087','2014-01-01','14:10:00',1.05),('15087','2014-01-01','14:15:00',1.17),('15087','2014-01-01','15:05:00',1.03),('15087','2013-12-31','09:30:00',1.08),('15087','2013-12-31','09:35:00',1.18),('15087','2013-12-31','09:40:00',1.08),('15087','2013-12-31','09:50:00',1.45),('15087','2013-12-31','09:55:00',1.08),('15087','2013-12-31','10:00:00',1.04),('15087','2013-12-31','10:05:00',1.02),('15087','2013-12-31','10:50:00',1.28),('15087','2013-12-31','10:55:00',1.36),('15087','2013-12-31','11:00:00',1.25),('15087','2013-12-31','11:05:00',1.29),('15087','2013-12-31','11:10:00',1.25),('15087','2013-12-31','11:15:00',1.71),('15087','2013-12-31','11:20:00',1.91),('15087','2013-12-31','11:25:00',2.6),('15087','2013-12-31','11:30:00',2.92),('15087','2013-12-31','11:35:00',1.86),('15087','2013-12-31','11:40:00',2.52),('15087','2013-12-31','11:50:00',1.47),('15087','2013-12-31','11:55:00',2),('15087','2013-12-31','12:00:00',2.73),('15087','2013-12-31','12:05:00',2.66),('15087','2013-12-31','12:10:00',2.65),('15087','2013-12-31','12:15:00',2.63),('15087','2013-12-31','12:20:00',2.59),('15087','2013-12-31','12:25:00',2.6),('15087','2013-12-31','12:30:00',2.58),('15087','2013-12-31','12:35:00',2.52),('15087','2013-12-31','12:40:00',2.48),('15087','2013-12-31','12:45:00',2.45),('15087','2013-12-31','12:50:00',2.39),('15087','2013-12-31','12:55:00',2.36),('15087','2013-12-31','13:00:00',2.31),('15087','2013-12-31','13:05:00',2.27),('15087','2013-12-31','13:10:00',2.21),('15087','2013-12-31','13:15:00',2.16),('15087','2013-12-31','13:20:00',2.11),('15087','2013-12-31','13:25:00',2.05),('15087','2013-12-31','13:30:00',1.93),('15087','2013-12-31','13:35:00',1.86),('15087','2013-12-31','13:40:00',1.79),('15087','2013-12-31','13:45:00',1.77),('15087','2013-12-31','13:50:00',1.78),('15087','2013-12-31','13:55:00',1.71),('15087','2013-12-31','14:00:00',1.63),('15087','2013-12-31','14:05:00',1.58),('15087','2013-12-31','14:10:00',1.42),('15087','2013-12-31','14:15:00',1.4),('15087','2013-12-31','14:20:00',1.32),('15087','2013-12-31','14:25:00',1.23),('15087','2013-12-31','14:30:00',1.11),('15087','2013-12-31','14:35:00',1.07),('15087','2013-12-31','14:40:00',1.03),('15087','2013-12-30','11:25:00',1.06),('15087','2013-12-30','11:30:00',1.06),('15087','2013-12-29','09:35:00',1.05),('15087','2013-12-29','09:40:00',1.12),('15087','2013-12-29','09:45:00',1.2),('15087','2013-12-29','09:50:00',1.16),('15087','2013-12-29','09:55:00',1.07),('15087','2013-12-29','10:00:00',1.16),('15087','2013-12-29','10:05:00',1.32),('15087','2013-12-29','10:10:00',1.68),('15087','2013-12-29','10:15:00',1.76),('15087','2013-12-29','10:20:00',1.98),('15087','2013-12-29','10:25:00',1.85),('15087','2013-12-29','10:30:00',2.5),('15087','2013-12-29','10:35:00',2.74),('15087','2013-12-29','10:40:00',1.7),('15087','2013-12-29','10:45:00',1.45),('15087','2013-12-29','10:55:00',1.1),('15087','2013-12-29','11:05:00',1),('15087','2013-12-28','09:35:00',1.04),('15087','2013-12-28','09:40:00',1.1),('15087','2013-12-28','09:45:00',1.15),('15087','2013-12-28','09:50:00',1.22),('15087','2013-12-28','09:55:00',1.31),('15087','2013-12-28','10:00:00',1.45),('15087','2013-12-28','10:05:00',1.54),('15087','2013-12-28','10:10:00',1.63),('15087','2013-12-28','10:15:00',1.71),('15087','2013-12-28','10:20:00',1.79),('15087','2013-12-28','10:25:00',1.87),('15087','2013-12-28','10:30:00',1.91),('15087','2013-12-28','10:35:00',1.97),('15087','2013-12-28','10:40:00',2.03),('15087','2013-12-28','10:45:00',2.11),('15087','2013-12-28','10:50:00',2.18),('15087','2013-12-28','10:55:00',2.22),('15087','2013-12-28','11:00:00',2.28),('15087','2013-12-28','11:05:00',2.32),('15087','2013-12-28','11:10:00',2.35),('15087','2013-12-28','11:15:00',2.39),('15087','2013-12-28','11:20:00',2.43),('15087','2013-12-28','11:25:00',2.45),('15087','2013-12-28','11:30:00',2.47),('15087','2013-12-28','11:35:00',2.48),('15087','2013-12-28','11:40:00',2.49),('15087','2013-12-28','11:45:00',2.51),('15087','2013-12-28','11:50:00',2.52),('15087','2013-12-28','11:55:00',2.53),('15087','2013-12-28','12:00:00',2.51),('15087','2013-12-28','12:05:00',2.53),('15087','2013-12-28','12:10:00',2.52),('15087','2013-12-28','12:15:00',2.5),('15087','2013-12-28','12:20:00',2.47),('15087','2013-12-28','12:25:00',2.46),('15087','2013-12-28','12:30:00',2.46),('15087','2013-12-28','12:35:00',2.33),('15087','2013-12-28','12:40:00',2.37),('15087','2013-12-28','12:45:00',2.27),('15087','2013-12-28','12:50:00',2.12),('15087','2013-12-28','12:55:00',2.08),('15087','2013-12-28','13:00:00',2.16),('15087','2013-12-28','13:05:00',2.11),('15087','2013-12-28','13:10:00',2.05),('15087','2013-12-28','13:15:00',1.9),('15087','2013-12-28','13:20:00',1.74),('15087','2013-12-28','13:25:00',1.86),('15087','2013-12-28','13:30:00',1.7),('15087','2013-12-28','13:35:00',1.61),('15087','2013-12-28','13:40:00',1.58),('15087','2013-12-28','13:45:00',1.67),('15087','2013-12-28','13:50:00',1.59),('15087','2013-12-28','13:55:00',1.54),('15087','2013-12-28','14:00:00',1.47),('15087','2013-12-28','14:05:00',1.37),('15087','2013-12-28','14:10:00',1.25),('15087','2013-12-28','14:15:00',1.18),('15087','2013-12-28','14:20:00',1.12),('15087','2013-12-28','14:25:00',1.08),('15087','2013-12-28','14:30:00',1.04),('15087','2014-04-23','13:10:00',1.03),('15087','2014-04-23','13:15:00',1.21),('15087','2014-04-23','13:20:00',1.37),('15087','2014-04-23','13:25:00',1.42),('15087','2014-04-23','13:30:00',1.57),('15087','2014-04-23','13:35:00',1.64),('15087','2014-04-23','13:40:00',1.73),('15087','2014-04-23','13:45:00',1.78),('15087','2014-04-23','13:50:00',1.76),('15087','2014-04-23','13:55:00',1.77),('15087','2014-04-23','14:00:00',1.67),('15087','2014-04-23','14:05:00',1.67),('15087','2014-04-23','14:10:00',1.6),('15087','2014-04-23','14:15:00',1.29),('15087','2014-04-23','14:20:00',1.1),('15087','2014-04-23','14:45:00',1.07),('15087','2014-04-23','14:50:00',1.33),('15087','2014-04-23','14:55:00',1.59),('15087','2014-04-23','15:00:00',1.81),('15087','2014-04-23','15:05:00',1.91),('15087','2014-04-23','15:10:00',1.86),('15087','2014-04-23','15:15:00',1.94),('15087','2014-04-23','15:20:00',1.64),('15087','2014-04-23','15:25:00',1.46),('15087','2014-04-23','15:30:00',1.36),('15087','2014-04-23','15:35:00',1.29),('15087','2014-04-23','15:40:00',1.27),('15087','2014-04-23','15:45:00',1.5),('15087','2014-04-23','15:50:00',1.13),('15087','2014-04-23','15:55:00',1.03),('15087','2013-12-27','12:05:00',1.05),('15087','2013-12-27','12:10:00',2),('15087','2013-12-27','12:15:00',1.6),('15087','2013-12-27','12:20:00',1.88),('15087','2013-12-27','12:25:00',1.3),('15087','2013-12-27','12:30:00',1.04),('15087','2013-12-27','12:35:00',1.23),('15087','2013-12-27','12:40:00',1.51),('15087','2013-12-27','12:45:00',1.87),('15087','2013-12-27','12:50:00',2.1),('15087','2013-12-27','12:55:00',2.16),('15087','2013-12-27','13:00:00',2.17),('15087','2013-12-27','13:05:00',1.95),('15087','2013-12-27','13:10:00',1.26),('15087','2013-12-27','13:15:00',1.33),('15087','2013-12-27','13:20:00',1.71),('15087','2013-12-27','13:25:00',1.64),('15087','2013-12-27','13:30:00',2.31),('15087','2013-12-27','13:35:00',2.11),('15087','2013-12-27','13:40:00',1.38),('15087','2013-12-27','13:45:00',1.19),('15087','2013-12-27','13:50:00',1.02),('15087','2013-12-27','14:10:00',1.08),('15087','2013-12-27','14:15:00',1.13),('15087','2013-12-27','14:20:00',1.06),('15087','2013-12-27','14:25:00',1.03),('15087','2013-12-27','14:30:00',1.08),('15087','2013-12-27','14:35:00',1.15),('15087','2013-12-27','14:40:00',1.18),('15087','2013-12-25','10:30:00',1.52),('15087','2013-12-25','10:35:00',1.51),('15087','2013-12-25','10:40:00',1.36),('15087','2013-12-25','10:45:00',1.5),('15087','2013-12-25','10:50:00',1.34),('15087','2013-12-25','11:15:00',1.45),('15087','2013-12-25','11:20:00',2.06),('15087','2013-12-25','11:25:00',1.45),('15087','2013-12-25','11:30:00',1.73),('15087','2013-12-25','11:40:00',1.58),('15087','2013-12-25','11:45:00',2.25),('15087','2013-12-25','11:50:00',1.51),('15087','2013-12-25','11:55:00',2.31),('15087','2013-12-25','12:00:00',1.55),('15087','2013-12-25','12:05:00',1.34),('15087','2013-12-25','12:10:00',1.53),('15087','2013-12-25','12:15:00',1.06),('15087','2013-12-25','12:20:00',1.27),('15087','2013-12-25','12:25:00',1.56),('15087','2013-12-25','12:30:00',1.41),('15087','2013-12-25','12:45:00',1.06),('15087','2013-12-25','12:50:00',1.42),('15087','2013-12-25','13:25:00',1.15),('15087','2013-12-25','13:40:00',1.14),('15087','2013-12-25','13:45:00',1.11),('15087','2013-12-25','13:50:00',1.25),('15087','2013-12-25','13:55:00',1.08),('15087','2013-12-24','09:40:00',1.03),('15087','2013-12-24','09:45:00',1.07),('15087','2013-12-24','09:50:00',1.1),('15087','2013-12-24','09:55:00',1.13),('15087','2013-12-24','10:00:00',1.29),('15087','2013-12-24','10:05:00',1.43),('15087','2013-12-24','10:10:00',1.5),('15087','2013-12-24','10:15:00',1.56),('15087','2013-12-24','10:20:00',1.66),('15087','2013-12-24','10:25:00',1.73),('15087','2013-12-24','10:30:00',1.75),('15087','2013-12-24','10:35:00',1.82),('15087','2013-12-24','10:40:00',1.87),('15087','2013-12-24','10:45:00',1.9),('15087','2013-12-24','10:50:00',1.96),('15087','2013-12-24','10:55:00',1.98),('15087','2013-12-24','11:00:00',2.02),('15087','2013-12-24','11:05:00',2.11),('15087','2013-12-24','11:10:00',2.1),('15087','2013-12-24','11:15:00',2.09),('15087','2013-12-24','11:20:00',2.13),('15087','2013-12-24','11:25:00',2.16),('15087','2013-12-24','11:30:00',2.22),('15087','2013-12-24','11:35:00',2.24),('15087','2013-12-24','11:40:00',2.26),('15087','2013-12-24','11:45:00',2.26),('15087','2013-12-24','11:50:00',2.3),('15087','2013-12-24','11:55:00',2.28),('15087','2013-12-24','12:00:00',2.24),('15087','2013-12-24','12:05:00',2.24),('15087','2013-12-24','12:10:00',2.24),('15087','2013-12-24','12:15:00',2.25),('15087','2013-12-24','12:20:00',2.26),('15087','2013-12-24','12:25:00',2.22),('15087','2013-12-24','12:30:00',2.16),('15087','2013-12-24','12:35:00',2),('15087','2013-12-24','12:40:00',1.95),('15087','2013-12-24','12:45:00',1.93),('15087','2013-12-24','12:50:00',1.99),('15087','2013-12-24','12:55:00',1.96),('15087','2013-12-24','13:00:00',1.87),('15087','2013-12-24','13:05:00',1.85),('15087','2013-12-24','13:10:00',1.83),('15087','2013-12-24','13:15:00',1.76),('15087','2013-12-24','13:20:00',1.75),('15087','2013-12-24','13:25:00',1.64),('15087','2013-12-24','13:30:00',1.61),('15087','2013-12-24','13:35:00',1.64),('15087','2013-12-24','13:40:00',1.51),('15087','2013-12-24','13:45:00',1.48),('15087','2013-12-24','13:50:00',1.39),('15087','2013-12-24','13:55:00',1.33),('15087','2013-12-24','14:00:00',1.26),('15087','2013-12-24','14:05:00',1.13),('15087','2013-12-24','14:10:00',1.12),('15087','2013-12-24','14:15:00',1.04),('15087','2013-12-23','09:50:00',1.14),('15087','2013-12-23','09:55:00',1.35),('15087','2013-12-23','10:00:00',1.61),('15087','2013-12-23','10:05:00',1.76),('15087','2013-12-23','10:10:00',1.75),('15087','2013-12-23','10:15:00',1.81),('15087','2013-12-23','10:20:00',1.86),('15087','2013-12-23','10:25:00',1.81),('15087','2013-12-23','10:30:00',1.75),('15087','2013-12-23','10:35:00',1.79),('15087','2013-12-23','10:40:00',1.83),('15087','2013-12-23','10:45:00',1.88),('15087','2013-12-23','10:50:00',1.94),('15087','2013-12-23','10:55:00',2.12),('15087','2013-12-23','11:00:00',2.32),('15087','2013-12-23','11:05:00',2.41),('15087','2013-12-23','11:10:00',2.42),('15087','2013-12-23','11:15:00',2.38),('15087','2013-12-23','11:20:00',2.35),('15087','2013-12-23','11:25:00',2.33),('15087','2013-12-23','11:30:00',2.41),('15087','2013-12-23','11:35:00',2.46),('15087','2013-12-23','11:40:00',2.31),('15087','2013-12-23','11:45:00',2.05),('15087','2013-12-23','11:50:00',2.24),('15087','2013-12-23','11:55:00',2.28),('15087','2013-12-23','12:00:00',2.39),('15087','2013-12-23','12:05:00',2.37),('15087','2013-12-23','12:10:00',2.43),('15087','2013-12-23','12:15:00',2.32),('15087','2013-12-23','12:20:00',2.27),('15087','2013-12-23','12:25:00',2.26),('15087','2013-12-23','12:30:00',2.22),('15087','2013-12-23','12:35:00',2.23),('15087','2013-12-23','12:40:00',2.29),('15087','2013-12-23','12:45:00',2.18),('15087','2013-12-23','12:50:00',2.14),('15087','2013-12-23','12:55:00',2.14),('15087','2013-12-23','13:00:00',2.09),('15087','2013-12-23','13:05:00',2.07),('15087','2013-12-23','13:10:00',2),('15087','2013-12-23','13:15:00',1.97),('15087','2013-12-23','13:20:00',1.6),('15087','2013-12-23','13:25:00',1.71),('15087','2013-12-23','13:30:00',1.57),('15087','2013-12-23','13:40:00',1.47),('15087','2013-12-23','13:50:00',1.3),('15087','2013-12-23','13:55:00',1.4),('15087','2013-12-23','14:00:00',1.46),('15087','2013-12-23','14:05:00',1.38),('15087','2013-12-23','14:10:00',1.28),('15087','2013-12-23','14:15:00',1.19),('15087','2013-12-23','14:20:00',1.1),('15087','2013-12-23','14:25:00',1.01),('15087','2013-12-22','09:30:00',1),('15087','2013-12-22','09:35:00',1.34),('15087','2013-12-22','09:40:00',1.61),('15087','2013-12-22','09:45:00',1.71),('15087','2013-12-22','09:50:00',1.83),('15087','2013-12-22','09:55:00',1.82),('15087','2013-12-22','10:00:00',1.87),('15087','2013-12-22','10:05:00',1.91),('15087','2013-12-22','10:10:00',1.97),('15087','2013-12-22','10:15:00',1.96),('15087','2013-12-22','10:20:00',1.94),('15087','2013-12-22','10:25:00',1.96),('15087','2013-12-22','10:30:00',2.05),('15087','2013-12-22','10:35:00',1.92),('15087','2013-12-22','10:40:00',1.84),('15087','2013-12-22','10:45:00',2.04),('15087','2013-12-22','10:50:00',2.05),('15087','2013-12-22','10:55:00',1.93),('15087','2013-12-22','11:00:00',1.78),('15087','2013-12-22','11:05:00',1.86),('15087','2013-12-22','11:10:00',2.4),('15087','2013-12-22','11:15:00',2.32),('15087','2013-12-22','11:20:00',2.13),('15087','2013-12-22','11:25:00',2.17),('15087','2013-12-22','11:30:00',2.04),('15087','2013-12-22','11:35:00',2.08),('15087','2013-12-22','11:40:00',2.19),('15087','2013-12-22','11:45:00',2.01),('15087','2013-12-22','11:50:00',1.51),('15087','2013-12-22','11:55:00',1.08),('15087','2013-12-22','12:20:00',1.12),('15087','2013-12-22','12:25:00',1.23),('15087','2013-12-22','12:30:00',1.57),('15087','2013-12-22','12:35:00',1.77),('15087','2013-12-22','12:40:00',1.71),('15087','2013-12-22','12:45:00',1.67),('15087','2013-12-22','12:50:00',1.99),('15087','2013-12-22','12:55:00',2.35),('15087','2013-12-22','13:00:00',2.25),('15087','2013-12-22','13:05:00',2.55),('15087','2013-12-22','13:10:00',2.6),('15087','2013-12-22','13:15:00',2),('15087','2013-12-22','13:20:00',1.89),('15087','2013-12-22','13:25:00',1.86),('15087','2013-12-22','13:30:00',1.69),('15087','2013-12-22','13:35:00',1.61),('15087','2013-12-22','13:40:00',1.29),('15087','2013-12-22','13:45:00',1.46),('15087','2013-12-22','13:50:00',1.26),('15087','2013-12-22','13:55:00',1.15),('15087','2013-12-22','14:00:00',1),('15087','2013-12-22','14:05:00',1.16),('15087','2013-12-22','14:10:00',1.24),('15087','2013-12-21','09:40:00',1.04),('15087','2013-12-21','09:45:00',1.11),('15087','2013-12-21','09:50:00',1.15),('15087','2013-12-21','09:55:00',1.25),('15087','2013-12-21','10:00:00',1.36),('15087','2013-12-21','10:05:00',1.46),('15087','2013-12-21','10:10:00',1.57),('15087','2013-12-21','10:15:00',1.66),('15087','2013-12-21','10:20:00',1.74),('15087','2013-12-21','10:25:00',1.79),('15087','2013-12-21','10:30:00',1.86),('15087','2013-12-21','10:35:00',1.91),('15087','2013-12-21','10:40:00',1.98),('15087','2013-12-21','10:45:00',2.04),('15087','2013-12-21','10:50:00',2.08),('15087','2013-12-21','10:55:00',2.12),('15087','2013-12-21','11:00:00',2.18),('15087','2013-12-21','11:05:00',2.23),('15087','2013-12-21','11:10:00',2.25),('15087','2013-12-21','11:15:00',2.27),('15087','2013-12-21','11:20:00',2.32),('15087','2013-12-21','11:25:00',2.34),('15087','2013-12-21','11:30:00',2.39),('15087','2013-12-21','11:35:00',2.41),('15087','2013-12-21','11:40:00',2.43),('15087','2013-12-21','11:45:00',2.43),('15087','2013-12-21','11:50:00',2.44),('15087','2013-12-21','11:55:00',2.46),('15087','2013-12-21','12:00:00',2.47),('15087','2013-12-21','12:05:00',2.47),('15087','2013-12-21','12:10:00',2.46),('15087','2013-12-21','12:15:00',2.45),('15087','2013-12-21','12:20:00',2.44),('15087','2013-12-21','12:25:00',2.43),('15087','2013-12-21','12:30:00',2.4),('15087','2013-12-21','12:35:00',2.36),('15087','2013-12-21','12:40:00',2.34),('15087','2013-12-21','12:45:00',2.28),('15087','2013-12-21','12:50:00',2.25),('15087','2013-12-21','12:55:00',2.2),('15087','2013-12-21','13:00:00',2.15),('15087','2013-12-21','13:05:00',2.08),('15087','2013-12-21','13:10:00',2.03),('15087','2013-12-21','13:15:00',1.97),('15087','2013-12-21','13:20:00',1.92),('15087','2013-12-21','13:25:00',1.83),('15087','2013-12-21','13:30:00',1.84),('15087','2013-12-21','13:35:00',1.72),('15087','2013-12-21','13:40:00',1.68),('15087','2013-12-21','13:45:00',1.61),('15087','2013-12-21','13:50:00',1.54),('15087','2013-12-21','13:55:00',1.52),('15087','2013-12-21','14:00:00',1.41),('15087','2013-12-21','14:05:00',1.28),('15087','2013-12-21','14:10:00',1.25),('15087','2013-12-21','14:15:00',1.13),('15087','2013-12-21','14:20:00',1.07),('15087','2013-12-21','14:25:00',1.06),('15087','2013-12-21','14:30:00',1.02),('15087','2013-12-20','09:40:00',1.01),('15087','2013-12-20','09:45:00',1.07),('15087','2013-12-20','09:50:00',1.13),('15087','2013-12-20','09:55:00',1.18),('15087','2013-12-20','10:00:00',1.28),('15087','2013-12-20','10:05:00',1.42),('15087','2013-12-20','10:10:00',1.51),('15087','2013-12-20','10:15:00',1.6),('15087','2013-12-20','10:20:00',1.67),('15087','2013-12-20','10:25:00',1.7),('15087','2013-12-20','10:30:00',1.78),('15087','2013-12-20','10:35:00',1.83),('15087','2013-12-20','10:40:00',1.88),('15087','2013-12-20','10:45:00',1.94),('15087','2013-12-20','10:50:00',2),('15087','2013-12-20','10:55:00',2.04),('15087','2013-12-20','11:00:00',2.06),('15087','2013-12-20','11:05:00',2.11),('15087','2013-12-20','11:10:00',2.17),('15087','2013-12-20','11:15:00',2.18),('15087','2013-12-20','11:20:00',2.22),('15087','2013-12-20','11:25:00',2.24),('15087','2013-12-20','11:30:00',2.23),('15087','2013-12-20','11:35:00',2.29),('15087','2013-12-20','11:40:00',2.28),('15087','2013-12-20','11:45:00',2.31),('15087','2013-12-20','11:50:00',2.32),('15087','2013-12-20','11:55:00',2.31),('15087','2013-12-20','12:00:00',2.35),('15087','2013-12-20','12:05:00',2.32),('15087','2013-12-20','12:10:00',2.3),('15087','2013-12-20','12:15:00',2.29),('15087','2013-12-20','12:20:00',2.31),('15087','2013-12-20','12:25:00',2.27),('15087','2013-12-20','12:30:00',2.21),('15087','2013-12-20','12:35:00',2.21),('15087','2013-12-20','12:40:00',2.15),('15087','2013-12-20','12:45:00',2.07),('15087','2013-12-20','12:50:00',2.07),('15087','2013-12-20','12:55:00',1.99),('15087','2013-12-20','13:00:00',1.96),('15087','2013-12-20','13:05:00',1.89),('15087','2013-12-20','13:10:00',1.83),('15087','2013-12-20','13:15:00',1.78),('15087','2013-12-20','13:20:00',1.77),('15087','2013-12-20','13:25:00',1.6),('15087','2013-12-20','13:30:00',1.56),('15087','2013-12-20','13:35:00',1.57),('15087','2013-12-20','13:40:00',1.52),('15087','2013-12-20','13:45:00',1.45),('15087','2013-12-20','13:50:00',1.44),('15087','2013-12-20','13:55:00',1.39),('15087','2013-12-20','14:00:00',1.05),('15087','2013-12-19','09:20:00',1.16),('15087','2013-12-19','09:30:00',1.19),('15087','2013-12-19','09:35:00',1),('15087','2013-12-19','09:50:00',1.27),('15087','2013-12-19','09:55:00',1.44),('15087','2013-12-19','10:00:00',1.43),('15087','2013-12-19','10:05:00',1.73),('15087','2013-12-19','10:10:00',2.04),('15087','2013-12-19','10:15:00',1.88),('15087','2013-12-19','10:20:00',1.29),('15087','2013-12-19','10:25:00',1.26),('15087','2013-12-19','10:30:00',1.02),('15087','2013-12-19','10:40:00',1.57),('15087','2013-12-19','10:45:00',2.33),('15087','2013-12-19','10:50:00',1.65),('15087','2013-12-19','11:15:00',1.26),('15087','2013-12-19','11:20:00',1.14),('15087','2013-12-19','14:30:00',1.29),('15087','2013-12-19','14:35:00',1.07),('15087','2013-12-18','09:35:00',1.03),('15087','2013-12-18','09:40:00',1.09),('15087','2013-12-18','09:45:00',1.15),('15087','2013-12-18','09:50:00',1.24),('15087','2013-12-18','09:55:00',1.35),('15087','2013-12-18','10:00:00',1.42),('15087','2013-12-18','10:05:00',1.53),('15087','2013-12-18','10:10:00',1.62),('15087','2013-12-18','10:15:00',1.71),('15087','2013-12-18','10:20:00',1.79),('15087','2013-12-18','10:25:00',1.85),('15087','2013-12-18','10:30:00',1.92),('15087','2013-12-18','10:35:00',1.97),('15087','2013-12-18','10:40:00',2.02),('15087','2013-12-18','10:45:00',2.07),('15087','2013-12-18','10:50:00',2.12),('15087','2013-12-18','10:55:00',2.16),('15087','2013-12-18','11:00:00',2.21),('15087','2013-12-18','11:05:00',2.25),('15087','2013-12-18','11:10:00',2.29),('15087','2013-12-18','11:15:00',2.32),('15087','2013-12-18','11:20:00',2.33),('15087','2013-12-18','11:25:00',2.33),('15087','2013-12-18','11:30:00',2.35),('15087','2013-12-18','11:35:00',2.35),('15087','2013-12-18','11:40:00',2.39),('15087','2013-12-18','11:45:00',2.37),('15087','2013-12-18','11:50:00',2.38),('15087','2013-12-18','11:55:00',2.4),('15087','2013-12-18','12:00:00',2.41),('15087','2013-12-18','12:05:00',2.4),('15087','2013-12-18','12:10:00',2.39),('15087','2013-12-18','12:15:00',2.4),('15087','2013-12-18','12:20:00',2.39),('15087','2013-12-18','12:25:00',2.37),('15087','2013-12-18','12:30:00',2.25),('15087','2013-12-18','12:35:00',2.27),('15087','2013-12-18','12:40:00',2.22),('15087','2013-12-18','12:45:00',2.13),('15087','2013-12-18','12:50:00',2.07),('15087','2013-12-18','12:55:00',2.09),('15087','2013-12-18','13:00:00',1.99),('15087','2013-12-18','13:05:00',1.97),('15087','2013-12-18','13:10:00',1.98),('15087','2013-12-18','13:15:00',1.89),('15087','2013-12-18','13:20:00',1.82),('15087','2013-12-18','13:25:00',1.81),('15087','2013-12-18','13:30:00',1.76),('15087','2013-12-18','13:35:00',1.64),('15087','2013-12-18','13:40:00',1.58),('15087','2013-12-18','13:45:00',1.5),('15087','2013-12-18','13:50:00',1.45),('15087','2013-12-18','13:55:00',1.43),('15087','2013-12-18','14:00:00',1.29),('15087','2013-12-18','14:05:00',1.2),('15087','2013-12-18','14:10:00',1.15),('15087','2013-12-18','14:15:00',1.11),('15087','2013-12-18','14:20:00',1.02),('15087','2013-12-18','14:25:00',1.03),('15087','2014-04-22','07:55:00',1.05),('15087','2014-04-22','08:00:00',1.14),('15087','2014-04-22','08:05:00',1.22),('15087','2014-04-22','08:10:00',1.32),('15087','2014-04-22','08:15:00',1.42),('15087','2014-04-22','08:20:00',1.5),('15087','2014-04-22','08:25:00',1.6),('15087','2014-04-22','08:30:00',1.75),('15087','2014-04-22','08:35:00',1.85),('15087','2014-04-22','08:40:00',1.99),('15087','2014-04-22','08:45:00',2.01),('15087','2014-04-22','08:50:00',2.14),('15087','2014-04-22','08:55:00',2.19),('15087','2014-04-22','09:00:00',2.21),('15087','2014-04-22','09:05:00',2.51),('15087','2014-04-22','09:10:00',2.3),('15087','2014-04-22','09:15:00',2.32),('15087','2014-04-22','09:20:00',2.59),('15087','2014-04-22','09:25:00',2.88),('15087','2014-04-22','09:30:00',2.8),('15087','2014-04-22','09:35:00',3.02),('15087','2014-04-22','09:40:00',3),('15087','2014-04-22','09:45:00',3.23),('15087','2014-04-22','09:50:00',2.42),('15087','2014-04-22','09:55:00',1.49),('15087','2014-04-22','10:00:00',1.38),('15087','2014-04-22','10:05:00',1.5),('15087','2014-04-22','10:10:00',2.13),('15087','2014-04-22','10:15:00',2.22),('15087','2014-04-22','10:20:00',3.39),('15087','2014-04-22','10:25:00',2.37),('15087','2014-04-22','10:30:00',3.85),('15087','2014-04-22','10:35:00',3.92),('15087','2014-04-22','10:40:00',3.77),('15087','2014-04-22','10:45:00',4.1),('15087','2014-04-22','10:50:00',4.33),('15087','2014-04-22','10:55:00',3.18),('15087','2014-04-22','11:00:00',2.17),('15087','2014-04-22','11:05:00',2.51),('15087','2014-04-22','11:10:00',1.79),('15087','2014-04-22','11:15:00',1.48),('15087','2014-04-22','11:20:00',1.28),('15087','2014-04-22','11:25:00',1.27),('15087','2014-04-22','11:30:00',1.15),('15087','2014-04-22','11:35:00',1.2),('15087','2014-04-22','11:40:00',1.07),('15087','2014-04-22','12:00:00',1),('15087','2014-04-22','12:05:00',1.22),('15087','2014-04-22','12:10:00',1.23),('15087','2014-04-22','12:15:00',1.23),('15087','2014-04-22','12:20:00',1.3),('15087','2014-04-22','12:25:00',1.43),('15087','2014-04-22','12:30:00',1.7),('15087','2014-04-22','12:35:00',1.41),('15087','2014-04-22','12:40:00',1.05),('15087','2014-04-22','13:15:00',1.57),('15087','2014-04-22','13:20:00',2.42),('15087','2014-04-22','13:25:00',2.83),('15087','2014-04-22','13:30:00',3.01),('15087','2014-04-22','13:35:00',2.88),('15087','2014-04-22','13:40:00',3.43),('15087','2014-04-22','13:45:00',3.46),('15087','2014-04-22','13:50:00',2.89),('15087','2014-04-22','13:55:00',1.67),('15087','2014-04-22','14:00:00',1.43),('15087','2014-04-22','14:05:00',2.06),('15087','2014-04-22','14:10:00',3.83),('15087','2014-04-22','14:15:00',3.55),('15087','2014-04-22','14:20:00',4.32),('15087','2014-04-22','14:25:00',2.65),('15087','2014-04-22','14:30:00',2.28),('15087','2014-04-22','14:35:00',2.73),('15087','2014-04-22','14:40:00',3.56),('15087','2014-04-22','14:45:00',4.4),('15087','2014-04-22','14:50:00',4.04),('15087','2014-04-22','14:55:00',3.05),('15087','2014-04-22','15:00:00',1.39),('15087','2014-04-22','15:05:00',1.31),('15087','2014-04-22','15:10:00',1.22),('15087','2014-04-22','15:15:00',1.21),('15087','2014-04-22','15:20:00',1.35),('15087','2014-04-22','15:25:00',1.5),('15087','2014-04-22','15:30:00',1.95),('15087','2014-04-22','15:35:00',2.74),('15087','2014-04-22','15:40:00',2.32),('15087','2014-04-22','15:45:00',2.07),('15087','2014-04-22','15:50:00',2.39),('15087','2014-04-22','15:55:00',1.96),('15087','2014-04-22','16:00:00',2.32),('15087','2014-04-22','16:05:00',1.57),('15087','2014-04-22','16:10:00',1.51),('15087','2014-04-22','16:15:00',1.42),('15087','2014-04-22','16:20:00',1.66),('15087','2014-04-22','16:25:00',1.59),('15087','2014-04-22','16:30:00',1.32),('15087','2014-04-22','16:35:00',1.48),('15087','2014-04-22','16:40:00',1.92),('15087','2014-04-22','16:45:00',1.7),('15087','2014-04-22','16:50:00',1.33),('15087','2014-04-22','16:55:00',1.16),('15087','2014-04-22','17:00:00',1.34),('15087','2014-04-22','17:05:00',1.52),('15087','2014-04-22','17:10:00',1.13),('15087','2014-04-22','17:15:00',1.01),('15087','2013-12-17','09:30:00',1.01),('15087','2013-12-17','09:35:00',1.08),('15087','2013-12-17','09:40:00',1.15),('15087','2013-12-17','09:45:00',1.22),('15087','2013-12-17','09:50:00',1.31),('15087','2013-12-17','09:55:00',1.44),('15087','2013-12-17','10:00:00',1.52),('15087','2013-12-17','10:05:00',1.61),('15087','2013-12-17','10:10:00',1.69),('15087','2013-12-17','10:15:00',1.79),('15087','2013-12-17','10:20:00',1.86),('15087','2013-12-17','10:25:00',1.89),('15087','2013-12-17','10:30:00',1.95),('15087','2013-12-17','10:35:00',2),('15087','2013-12-17','10:40:00',2.11),('15087','2013-12-17','10:45:00',2.15),('15087','2013-12-17','10:50:00',2.19),('15087','2013-12-17','10:55:00',2.23),('15087','2013-12-17','11:00:00',2.27),('15087','2013-12-17','11:05:00',2.31),('15087','2013-12-17','11:10:00',2.34),('15087','2013-12-17','11:15:00',2.39),('15087','2013-12-17','11:20:00',2.4),('15087','2013-12-17','11:25:00',2.42),('15087','2013-12-17','11:30:00',2.43),('15087','2013-12-17','11:35:00',2.46),('15087','2013-12-17','11:40:00',2.46),('15087','2013-12-17','11:45:00',2.48),('15087','2013-12-17','11:50:00',2.52),('15087','2013-12-17','11:55:00',2.53),('15087','2013-12-17','12:00:00',2.54),('15087','2013-12-17','12:05:00',2.52),('15087','2013-12-17','12:10:00',2.51),('15087','2013-12-17','12:15:00',2.51),('15087','2013-12-17','12:20:00',2.51),('15087','2013-12-17','12:25:00',2.52),('15087','2013-12-17','12:30:00',2.45),('15087','2013-12-17','12:35:00',2.44),('15087','2013-12-17','12:40:00',2.32),('15087','2013-12-17','12:45:00',2.23),('15087','2013-12-17','12:50:00',2.19),('15087','2013-12-17','12:55:00',2.23),('15087','2013-12-17','13:00:00',2.18),('15087','2013-12-17','13:05:00',2.1),('15087','2013-12-17','13:10:00',2.06),('15087','2013-12-17','13:15:00',2),('15087','2013-12-17','13:20:00',1.93),('15087','2013-12-17','13:25:00',1.91),('15087','2013-12-17','13:30:00',1.87),('15087','2013-12-17','13:35:00',1.68),('15087','2013-12-17','13:40:00',1.71),('15087','2013-12-17','13:45:00',1.59),('15087','2013-12-17','13:50:00',1.59),('15087','2013-12-17','13:55:00',1.53),('15087','2013-12-17','14:00:00',1.42),('15087','2013-12-17','14:05:00',1.35),('15087','2013-12-17','14:10:00',1.26),('15087','2013-12-17','14:15:00',1.14),('15087','2013-12-17','14:20:00',1.06),('15087','2013-12-17','14:25:00',1.08),('15087','2013-12-17','14:30:00',1),('15087','2013-12-16','09:30:00',1.02),('15087','2013-12-16','09:35:00',1.08),('15087','2013-12-16','09:40:00',1.15),('15087','2013-12-16','09:45:00',1.19),('15087','2013-12-16','09:50:00',1.29),('15087','2013-12-16','09:55:00',1.41),('15087','2013-12-16','10:00:00',1.48),('15087','2013-12-16','10:05:00',1.59),('15087','2013-12-16','10:10:00',1.66),('15087','2013-12-16','10:15:00',1.77),('15087','2013-12-16','10:20:00',1.81),('15087','2013-12-16','10:25:00',1.83),('15087','2013-12-16','10:30:00',1.87),('15087','2013-12-16','10:35:00',1.95),('15087','2013-12-16','10:40:00',2.05),('15087','2013-12-16','10:45:00',2.09),('15087','2013-12-16','10:50:00',2.13),('15087','2013-12-16','10:55:00',2.18),('15087','2013-12-16','11:00:00',2.23),('15087','2013-12-16','11:05:00',2.27),('15087','2013-12-16','11:10:00',2.27),('15087','2013-12-16','11:15:00',2.3),('15087','2013-12-16','11:20:00',2.3),('15087','2013-12-16','11:25:00',2.38),('15087','2013-12-16','11:30:00',2.39),('15087','2013-12-16','11:35:00',2.42),('15087','2013-12-16','11:40:00',2.45),('15087','2013-12-16','11:45:00',2.47),('15087','2013-12-16','11:50:00',2.48),('15087','2013-12-16','11:55:00',2.5),('15087','2013-12-16','12:00:00',2.51),('15087','2013-12-16','12:05:00',2.52),('15087','2013-12-16','12:10:00',2.51),('15087','2013-12-16','12:15:00',2.5),('15087','2013-12-16','12:20:00',2.51),('15087','2013-12-16','12:25:00',2.51),('15087','2013-12-16','12:30:00',2.33),('15087','2013-12-16','12:35:00',2.39),('15087','2013-12-16','12:40:00',2.28),('15087','2013-12-16','12:45:00',2.18),('15087','2013-12-16','12:50:00',2.18),('15087','2013-12-16','12:55:00',2.21),('15087','2013-12-16','13:00:00',2.17),('15087','2013-12-16','13:05:00',2.12),('15087','2013-12-16','13:10:00',2.07),('15087','2013-12-16','13:15:00',1.99),('15087','2013-12-16','13:20:00',1.93),('15087','2013-12-16','13:25:00',1.9),('15087','2013-12-16','13:30:00',1.86),('15087','2013-12-16','13:35:00',1.67),('15087','2013-12-16','13:40:00',1.7),('15087','2013-12-16','13:45:00',1.56),('15087','2013-12-16','13:50:00',1.58),('15087','2013-12-16','13:55:00',1.51),('15087','2013-12-16','14:00:00',1.35),('15087','2013-12-16','14:05:00',1.34),('15087','2013-12-16','14:10:00',1.25),('15087','2013-12-16','14:15:00',1.16),('15087','2013-12-16','14:20:00',1.06),('15087','2013-12-16','14:25:00',1.08),('15087','2013-12-15','10:20:00',1.29),('15087','2013-12-15','10:25:00',1.24),('15087','2013-12-15','10:30:00',1.13),('15087','2013-12-15','10:35:00',1.25),('15087','2013-12-15','10:40:00',1.26),('15087','2013-12-15','10:45:00',1.26),('15087','2013-12-14','09:30:00',1.02),('15087','2013-12-14','09:35:00',1.09),('15087','2013-12-14','09:40:00',1.15),('15087','2013-12-14','09:45:00',1.23),('15087','2013-12-14','09:50:00',1.33),('15087','2013-12-14','09:55:00',1.43),('15087','2013-12-14','10:00:00',1.53),('15087','2013-12-14','10:05:00',1.6),('15087','2013-12-14','10:10:00',1.69),('15087','2013-12-14','10:15:00',1.77),('15087','2013-12-14','10:20:00',1.83),('15087','2013-12-14','10:25:00',1.86),('15087','2013-12-14','10:30:00',1.91),('15087','2013-12-14','10:35:00',1.97),('15087','2013-12-14','10:40:00',2.03),('15087','2013-12-14','10:45:00',2.09),('15087','2013-12-14','10:50:00',2.11),('15087','2013-12-14','10:55:00',2.14),('15087','2013-12-14','11:00:00',2.19),('15087','2013-12-14','11:05:00',2.2),('15087','2013-12-14','11:10:00',2.26),('15087','2013-12-14','11:15:00',2.3),('15087','2013-12-14','11:20:00',2.33),('15087','2013-12-14','11:25:00',2.32),('15087','2013-12-14','11:30:00',2.35),('15087','2013-12-14','11:35:00',2.37),('15087','2013-12-14','11:40:00',2.35),('15087','2013-12-14','11:45:00',2.37),('15087','2013-12-14','11:50:00',2.33),('15087','2013-12-14','11:55:00',2.33),('15087','2013-12-14','12:00:00',2.34),('15087','2013-12-14','12:05:00',2.35),('15087','2013-12-14','12:10:00',2.38),('15087','2013-12-14','12:15:00',2.34),('15087','2013-12-14','12:20:00',2.31),('15087','2013-12-14','12:25:00',2.26),('15087','2013-12-14','12:30:00',2.21),('15087','2013-12-14','12:35:00',2.3),('15087','2013-12-14','12:40:00',2.15),('15087','2013-12-14','12:45:00',2.13),('15087','2013-12-14','12:50:00',2.12),('15087','2013-12-14','12:55:00',2.03),('15087','2013-12-14','13:00:00',1.99),('15087','2013-12-14','13:05:00',2.01),('15087','2013-12-14','13:10:00',1.96),('15087','2013-12-14','13:15:00',1.92),('15087','2013-12-14','13:20:00',1.9),('15087','2013-12-14','13:25:00',1.88),('15087','2013-12-14','13:30:00',1.82),('15087','2013-12-14','13:35:00',1.69),('15087','2013-12-14','13:40:00',1.69),('15087','2013-12-14','13:45:00',1.57),('15087','2013-12-14','13:50:00',1.55),('15087','2013-12-14','13:55:00',1.51),('15087','2013-12-14','14:00:00',1.34),('15087','2013-12-14','14:05:00',1.36),('15087','2013-12-14','14:10:00',1.24),('15087','2013-12-14','14:15:00',1.16),('15087','2013-12-14','14:20:00',1.08),('15087','2013-12-14','14:25:00',1.03),('15087','2013-12-13','09:40:00',1.05),('15087','2013-12-13','09:45:00',1.1),('15087','2013-12-13','09:50:00',1.24),('15087','2013-12-13','09:55:00',1.33),('15087','2013-12-13','10:00:00',1.43),('15087','2013-12-13','10:05:00',1.53),('15087','2013-12-13','10:10:00',1.62),('15087','2013-12-13','10:15:00',1.67),('15087','2013-12-13','10:20:00',1.72),('15087','2013-12-13','10:25:00',1.75),('15087','2013-12-13','10:30:00',1.8),('15087','2013-12-13','10:35:00',1.87),('15087','2013-12-13','10:40:00',1.92),('15087','2013-12-13','10:45:00',1.95),('15087','2013-12-13','10:50:00',2.01),('15087','2013-12-13','10:55:00',2.06),('15087','2013-12-13','11:00:00',2.13),('15087','2013-12-13','11:05:00',2.17),('15087','2013-12-13','11:10:00',2.17),('15087','2013-12-13','11:15:00',2.21),('15087','2013-12-13','11:20:00',2.19),('15087','2013-12-13','11:25:00',2.23),('15087','2013-12-13','11:30:00',2.23),('15087','2013-12-13','11:35:00',2.26),('15087','2013-12-13','11:40:00',2.29),('15087','2013-12-13','11:45:00',2.35),('15087','2013-12-13','11:50:00',2.34),('15087','2013-12-13','11:55:00',2.37),('15087','2013-12-13','12:00:00',2.35),('15087','2013-12-13','12:05:00',2.34),('15087','2013-12-13','12:10:00',2.36),('15087','2013-12-13','12:15:00',2.31),('15087','2013-12-13','12:20:00',2.31),('15087','2013-12-13','12:25:00',2.29),('15087','2013-12-13','12:30:00',2.13),('15087','2013-12-13','12:35:00',2.13),('15087','2013-12-13','12:40:00',2.16),('15087','2013-12-13','12:45:00',2.03),('15087','2013-12-13','12:50:00',2.04),('15087','2013-12-13','12:55:00',2.01),('15087','2013-12-13','13:00:00',2.01),('15087','2013-12-13','13:05:00',1.93),('15087','2013-12-13','13:10:00',1.86),('15087','2013-12-13','13:15:00',1.7),('15087','2013-12-13','13:20:00',1.78),('15087','2013-12-13','13:25:00',1.77),('15087','2013-12-13','13:30:00',1.71),('15087','2013-12-13','13:35:00',1.73),('15087','2013-12-13','13:40:00',1.71),('15087','2013-12-13','13:45:00',1.61),('15087','2013-12-13','13:50:00',1.58),('15087','2013-12-13','13:55:00',1.52),('15087','2013-12-13','14:00:00',1.39),('15087','2013-12-13','14:05:00',1.38),('15087','2013-12-13','14:10:00',1.27),('15087','2013-12-13','14:15:00',1.19),('15087','2013-12-13','14:20:00',1.11),('15087','2013-12-13','14:25:00',1.05),('15087','2013-12-12','09:30:00',1.01),('15087','2013-12-12','09:35:00',1.1),('15087','2013-12-12','09:40:00',1.17),('15087','2013-12-12','09:45:00',1.22),('15087','2013-12-12','09:50:00',1.31),('15087','2013-12-12','09:55:00',1.48),('15087','2013-12-12','10:00:00',1.53),('15087','2013-12-12','10:05:00',1.65),('15087','2013-12-12','10:10:00',1.72),('15087','2013-12-12','10:15:00',1.8),('15087','2013-12-12','10:20:00',1.84),('15087','2013-12-12','10:25:00',1.91),('15087','2013-12-12','10:30:00',1.96),('15087','2013-12-12','10:35:00',2.01),('15087','2013-12-12','10:40:00',2.08),('15087','2013-12-12','10:45:00',2.11),('15087','2013-12-12','10:50:00',2.14),('15087','2013-12-12','10:55:00',2.18),('15087','2013-12-12','11:00:00',2.22),('15087','2013-12-12','11:05:00',2.23),('15087','2013-12-12','11:10:00',2.25),('15087','2013-12-12','11:15:00',2.28),('15087','2013-12-12','11:20:00',2.28),('15087','2013-12-12','11:25:00',2.32),('15087','2013-12-12','11:30:00',2.37),('15087','2013-12-12','11:35:00',2.37),('15087','2013-12-12','11:40:00',2.38),('15087','2013-12-12','11:45:00',2.39),('15087','2013-12-12','11:50:00',2.38),('15087','2013-12-12','11:55:00',2.4),('15087','2013-12-12','12:00:00',2.4),('15087','2013-12-12','12:05:00',2.41),('15087','2013-12-12','12:10:00',2.41),('15087','2013-12-12','12:15:00',2.39),('15087','2013-12-12','12:20:00',2.37),('15087','2013-12-12','12:25:00',2.33),('15087','2013-12-12','12:30:00',2.19),('15087','2013-12-12','12:35:00',2.15),('15087','2013-12-12','12:40:00',2.13),('15087','2013-12-12','12:45:00',2.04),('15087','2013-12-12','12:50:00',2.03),('15087','2013-12-12','12:55:00',2.08),('15087','2013-12-12','13:00:00',2.05),('15087','2013-12-12','13:05:00',1.96),('15087','2013-12-12','13:10:00',1.97),('15087','2013-12-12','13:15:00',1.89),('15087','2013-12-12','13:20:00',1.82),('15087','2013-12-12','13:25:00',1.85),('15087','2013-12-12','13:30:00',1.65),('15087','2013-12-12','13:35:00',1.6),('15087','2013-12-12','13:40:00',1.66),('15087','2013-12-12','13:45:00',1.6),('15087','2013-12-12','13:50:00',1.59),('15087','2013-12-12','13:55:00',1.53),('15087','2013-12-12','14:00:00',1.37),('15087','2013-12-12','14:05:00',1.33),('15087','2013-12-12','14:10:00',1.24),('15087','2013-12-12','14:15:00',1.15),('15087','2013-12-12','14:20:00',1.07),('15087','2013-12-12','14:25:00',1),('15087','2013-12-11','09:30:00',1.03),('15087','2013-12-11','09:35:00',1.1),('15087','2013-12-11','09:40:00',1.17),('15087','2013-12-11','09:45:00',1.27),('15087','2013-12-11','09:50:00',1.44),('15087','2013-12-11','09:55:00',1.52),('15087','2013-12-11','10:00:00',1.59),('15087','2013-12-11','10:05:00',1.69),('15087','2013-12-11','10:10:00',1.79),('15087','2013-12-11','10:15:00',1.87),('15087','2013-12-11','10:20:00',1.89),('15087','2013-12-11','10:25:00',1.97),('15087','2013-12-11','10:30:00',2.01),('15087','2013-12-11','10:35:00',2.13),('15087','2013-12-11','10:40:00',2.17),('15087','2013-12-11','10:45:00',2.2),('15087','2013-12-11','10:50:00',2.21),('15087','2013-12-11','10:55:00',2.28),('15087','2013-12-11','11:00:00',2.31),('15087','2013-12-11','11:05:00',2.38),('15087','2013-12-11','11:10:00',2.42),('15087','2013-12-11','11:15:00',2.43),('15087','2013-12-11','11:20:00',2.46),('15087','2013-12-11','11:25:00',2.48),('15087','2013-12-11','11:30:00',2.42),('15087','2013-12-11','11:35:00',2.47),('15087','2013-12-11','11:40:00',2.49),('15087','2013-12-11','11:45:00',2.5),('15087','2013-12-11','11:50:00',2.53),('15087','2013-12-11','11:55:00',2.55),('15087','2013-12-11','12:00:00',2.57),('15087','2013-12-11','12:05:00',2.56),('15087','2013-12-11','12:10:00',2.56),('15087','2013-12-11','12:15:00',2.52),('15087','2013-12-11','12:20:00',2.51),('15087','2013-12-11','12:25:00',2.42),('15087','2013-12-11','12:30:00',2.37),('15087','2013-12-11','12:35:00',2.37),('15087','2013-12-11','12:40:00',2.32),('15087','2013-12-11','12:45:00',2.32),('15087','2013-12-11','12:50:00',2.27),('15087','2013-12-11','12:55:00',2.22),('15087','2013-12-11','13:00:00',2.19),('15087','2013-12-11','13:05:00',2.13),('15087','2013-12-11','13:10:00',2.06),('15087','2013-12-11','13:15:00',1.99),('15087','2013-12-11','13:20:00',1.86),('15087','2013-12-11','13:25:00',1.84),('15087','2013-12-11','13:30:00',1.72),('15087','2013-12-11','13:35:00',1.77),('15087','2013-12-11','13:40:00',1.71),('15087','2013-12-11','13:45:00',1.61),('15087','2013-12-11','13:50:00',1.61),('15087','2013-12-11','13:55:00',1.53),('15087','2013-12-11','14:00:00',1.4),('15087','2013-12-11','14:05:00',1.39),('15087','2013-12-11','14:10:00',1.29),('15087','2013-12-11','14:15:00',1.18),('15087','2013-12-11','14:20:00',1.11),('15087','2013-12-11','14:25:00',1.08),('15087','2013-12-11','14:30:00',1.02),('15087','2013-12-10','09:25:00',1.03),('15087','2013-12-10','09:30:00',1.06),('15087','2013-12-10','09:35:00',1.13),('15087','2013-12-10','09:40:00',1.19),('15087','2013-12-10','09:45:00',1.3),('15087','2013-12-10','09:50:00',1.47),('15087','2013-12-10','09:55:00',1.58),('15087','2013-12-10','10:00:00',1.65),('15087','2013-12-10','10:05:00',1.74),('15087','2013-12-10','10:10:00',1.85),('15087','2013-12-10','10:15:00',1.92),('15087','2013-12-10','10:20:00',1.95),('15087','2013-12-10','10:25:00',2.01),('15087','2013-12-10','10:30:00',2.08),('15087','2013-12-10','10:35:00',2.16),('15087','2013-12-10','10:40:00',2.21),('15087','2013-12-10','10:45:00',2.23),('15087','2013-12-10','10:50:00',2.26),('15087','2013-12-10','10:55:00',2.3),('15087','2013-12-10','11:00:00',2.35),('15087','2013-12-10','11:05:00',2.39),('15087','2013-12-10','11:10:00',2.44),('15087','2013-12-10','11:15:00',2.47),('15087','2013-12-10','11:20:00',2.5),('15087','2013-12-10','11:25:00',2.53),('15087','2013-12-10','11:30:00',2.56),('15087','2013-12-10','11:35:00',2.58),('15087','2013-12-10','11:40:00',2.58),('15087','2013-12-10','11:45:00',2.59),('15087','2013-12-10','11:50:00',2.6),('15087','2013-12-10','11:55:00',2.6),('15087','2013-12-10','12:00:00',2.58),('15087','2013-12-10','12:05:00',2.58),('15087','2013-12-10','12:10:00',2.56),('15087','2013-12-10','12:15:00',2.55),('15087','2013-12-10','12:20:00',2.54),('15087','2013-12-10','12:25:00',2.41),('15087','2013-12-10','12:30:00',2.3),('15087','2013-12-10','12:35:00',2.37),('15087','2013-12-10','12:40:00',2.25),('15087','2013-12-10','12:45:00',2.29),('15087','2013-12-10','12:50:00',2.21),('15087','2013-12-10','12:55:00',2.18),('15087','2013-12-10','13:00:00',2.09),('15087','2013-12-10','13:05:00',2.04),('15087','2013-12-10','13:10:00',2.03),('15087','2013-12-10','13:15:00',1.9),('15087','2013-12-10','13:20:00',1.88),('15087','2013-12-10','13:25:00',1.83),('15087','2013-12-10','13:30:00',1.67),('15087','2013-12-10','13:35:00',1.8),('15087','2013-12-10','13:40:00',1.69),('15087','2013-12-10','13:45:00',1.67),('15087','2013-12-10','13:50:00',1.63),('15087','2013-12-10','13:55:00',1.59),('15087','2013-12-10','14:00:00',1.45),('15087','2013-12-10','14:05:00',1.4),('15087','2013-12-10','14:10:00',1.29),('15087','2013-12-10','14:15:00',1.23),('15087','2013-12-10','14:20:00',1.15),('15087','2013-12-10','14:25:00',1.11),('15087','2013-12-10','14:30:00',1.04),('15087','2013-12-09','09:35:00',1.13),('15087','2013-12-09','09:40:00',1.23),('15087','2013-12-09','09:45:00',1.37),('15087','2013-12-09','09:50:00',1.48),('15087','2013-12-09','09:55:00',1.59),('15087','2013-12-09','10:00:00',1.71),('15087','2013-12-09','10:05:00',1.96),('15087','2013-12-09','10:10:00',2.26),('15087','2013-12-09','10:15:00',2.54),('15087','2013-12-09','10:20:00',2.72),('15087','2013-12-09','10:25:00',1.45),('15087','2013-12-09','12:25:00',1.02),('15087','2013-12-09','12:30:00',2.26),('15087','2013-12-09','12:35:00',1.2),('15087','2013-12-09','12:40:00',1.24),('15087','2013-12-09','12:45:00',1.63),('15087','2013-12-09','12:50:00',1.54),('15087','2013-12-09','12:55:00',1.95),('15087','2013-12-09','13:00:00',2.26),('15087','2013-12-09','13:05:00',1.34),('15087','2013-12-09','13:10:00',1.93),('15087','2013-12-09','13:15:00',1.55),('15087','2013-12-09','13:20:00',1.71),('15087','2013-12-09','13:25:00',1.15),('15087','2013-12-09','13:50:00',1.1),('15087','2013-12-09','13:55:00',1.15),('15087','2013-12-08','10:40:00',1.06),('15087','2013-12-08','10:45:00',1.1),('15087','2013-12-08','10:50:00',1.14),('15087','2013-12-08','10:55:00',1.21),('15087','2013-12-08','11:00:00',1.49),('15087','2013-12-08','11:05:00',1.22),('15087','2013-12-08','11:10:00',1.28),('15087','2013-12-08','11:15:00',2.21),('15087','2013-12-08','11:20:00',1.17),('15087','2013-12-08','12:55:00',1.31),('15087','2013-12-08','13:00:00',1.19),('15087','2013-12-08','13:05:00',1.35),('15087','2013-12-08','13:10:00',2.08),('15087','2013-12-08','13:15:00',1.63),('15087','2013-12-08','13:25:00',1.57),('15087','2013-12-08','13:30:00',1.43),('15087','2014-04-21','09:00:00',1.01),('15087','2014-04-21','09:10:00',1),('15087','2014-04-21','09:15:00',1.06),('15087','2014-04-21','09:20:00',1.64),('15087','2014-04-21','09:25:00',1.39),('15087','2014-04-21','09:50:00',1.01),('15087','2014-04-21','09:55:00',1.08),('15087','2014-04-21','10:00:00',1.49),('15087','2014-04-21','10:05:00',3.31),('15087','2014-04-21','10:10:00',3.36),('15087','2014-04-21','10:15:00',3.58),('15087','2014-04-21','10:20:00',3.58),('15087','2014-04-21','10:25:00',3.6),('15087','2014-04-21','10:30:00',3.61),('15087','2014-04-21','10:35:00',3.66),('15087','2014-04-21','10:40:00',3.7),('15087','2014-04-21','10:45:00',3.75),('15087','2014-04-21','10:50:00',3.8),('15087','2014-04-21','10:55:00',3.84),('15087','2014-04-21','11:00:00',3.88),('15087','2014-04-21','11:05:00',3.92),('15087','2014-04-21','11:10:00',3.94),('15087','2014-04-21','11:15:00',3.98),('15087','2014-04-21','11:20:00',4.04),('15087','2014-04-21','11:25:00',4.11),('15087','2014-04-21','11:30:00',4.14),('15087','2014-04-21','11:35:00',4.17),('15087','2014-04-21','11:40:00',4.15),('15087','2014-04-21','11:45:00',4.25),('15087','2014-04-21','11:50:00',4.29),('15087','2014-04-21','11:55:00',4.33),('15087','2014-04-21','12:00:00',4.35),('15087','2014-04-21','12:05:00',4.38),('15087','2014-04-21','12:10:00',4.42),('15087','2014-04-21','12:15:00',4.48),('15087','2014-04-21','12:20:00',4.49),('15087','2014-04-21','12:25:00',4.5),('15087','2014-04-21','12:30:00',4.51),('15087','2014-04-21','12:35:00',4.51),('15087','2014-04-21','12:40:00',4.54),('15087','2014-04-21','12:45:00',4.56),('15087','2014-04-21','12:50:00',4.59),('15087','2014-04-21','12:55:00',4.58),('15087','2014-04-21','13:00:00',4.58),('15087','2014-04-21','13:05:00',4.59),('15087','2014-04-21','13:10:00',4.56),('15087','2014-04-21','13:15:00',4.57),('15087','2014-04-21','13:20:00',4.57),('15087','2014-04-21','13:25:00',4.58),('15087','2014-04-21','13:30:00',4.56),('15087','2014-04-21','13:35:00',4.53),('15087','2014-04-21','13:40:00',4.54),('15087','2014-04-21','13:45:00',4.56),('15087','2014-04-21','13:50:00',4.53),('15087','2014-04-21','13:55:00',4.3),('15087','2014-04-21','14:00:00',4.45),('15087','2014-04-21','14:05:00',4.45),('15087','2014-04-21','14:10:00',4.44),('15087','2014-04-21','14:15:00',4.33),('15087','2014-04-21','14:20:00',4.16),('15087','2014-04-21','14:25:00',4.2),('15087','2014-04-21','14:30:00',4.26),('15087','2014-04-21','14:35:00',4.16),('15087','2014-04-21','14:40:00',4.06),('15087','2014-04-21','14:45:00',4.07),('15087','2014-04-21','14:50:00',4.04),('15087','2014-04-21','14:55:00',3.97),('15087','2014-04-21','15:00:00',3.88),('15087','2014-04-21','15:05:00',3.8),('15087','2014-04-21','15:10:00',3.74),('15087','2014-04-21','15:15:00',3.68),('15087','2014-04-21','15:20:00',3.64),('15087','2014-04-21','15:25:00',3.6),('15087','2014-04-21','15:30:00',3.52),('15087','2014-04-21','15:35:00',3.29),('15087','2014-04-21','15:40:00',3.2),('15087','2014-04-21','15:45:00',3.3),('15087','2014-04-21','15:50:00',3.26),('15087','2014-04-21','15:55:00',3.2),('15087','2014-04-21','16:00:00',3.17),('15087','2014-04-21','16:05:00',2.97),('15087','2014-04-21','16:10:00',2.79),('15087','2014-04-21','16:15:00',3.07),('15087','2014-04-21','16:20:00',2.93),('15087','2014-04-21','16:25:00',2.58),('15087','2014-04-21','16:30:00',2.75),('15087','2014-04-21','16:35:00',2.72),('15087','2014-04-21','16:40:00',2.65),('15087','2014-04-21','16:45:00',2.57),('15087','2014-04-21','16:50:00',2.5),('15087','2014-04-21','16:55:00',2.41),('15087','2014-04-21','17:00:00',2.33),('15087','2014-04-21','17:05:00',2.26),('15087','2014-04-21','17:10:00',2.17),('15087','2014-04-21','17:15:00',2.07),('15087','2014-04-21','17:20:00',1.98),('15087','2014-04-21','17:25:00',1.87),('15087','2014-04-21','17:30:00',1.75),('15087','2014-04-21','17:35:00',1.67),('15087','2014-04-21','17:40:00',1.43),('15087','2014-04-21','17:45:00',1.44),('15087','2014-04-21','17:50:00',1.45),('15087','2014-04-21','17:55:00',1.36),('15087','2014-04-21','18:00:00',1.27),('15087','2014-04-21','18:05:00',1.15),('15087','2014-04-21','18:10:00',1.09),('15087','2013-12-07','09:25:00',1.07),('15087','2013-12-07','09:30:00',1.15),('15087','2013-12-07','09:35:00',1.2),('15087','2013-12-07','09:40:00',1.27),('15087','2013-12-07','09:45:00',1.46),('15087','2013-12-07','09:50:00',1.58),('15087','2013-12-07','09:55:00',1.67),('15087','2013-12-07','10:00:00',1.75),('15087','2013-12-07','10:05:00',1.84),('15087','2013-12-07','10:10:00',1.9),('15087','2013-12-07','10:15:00',1.94),('15087','2013-12-07','10:20:00',1.98),('15087','2013-12-07','10:25:00',2.04),('15087','2013-12-07','10:30:00',2.08),('15087','2013-12-07','10:35:00',2.14),('15087','2013-12-07','10:40:00',2.23),('15087','2013-12-07','10:45:00',2.27),('15087','2013-12-07','10:50:00',2.28),('15087','2013-12-07','10:55:00',2.28),('15087','2013-12-07','11:00:00',2.34),('15087','2013-12-07','11:05:00',2.38),('15087','2013-12-07','11:10:00',2.41),('15087','2013-12-07','11:15:00',2.44),('15087','2013-12-07','11:20:00',2.46),('15087','2013-12-07','11:25:00',2.48),('15087','2013-12-07','11:30:00',2.47),('15087','2013-12-07','11:35:00',2.46),('15087','2013-12-07','11:40:00',2.46),('15087','2013-12-07','11:45:00',2.48),('15087','2013-12-07','11:50:00',2.46),('15087','2013-12-07','11:55:00',2.46),('15087','2013-12-07','12:00:00',2.47),('15087','2013-12-07','12:05:00',2.46),('15087','2013-12-07','12:10:00',2.46),('15087','2013-12-07','12:15:00',2.46),('15087','2013-12-07','12:20:00',2.46),('15087','2013-12-07','12:25:00',2.28),('15087','2013-12-07','12:30:00',2.29),('15087','2013-12-07','12:35:00',2.28),('15087','2013-12-07','12:40:00',2.1),('15087','2013-12-07','12:45:00',2.15),('15087','2013-12-07','12:50:00',2.1),('15087','2013-12-07','12:55:00',2.11),('15087','2013-12-07','13:00:00',2.05),('15087','2013-12-07','13:05:00',2.09),('15087','2013-12-07','13:10:00',2.04),('15087','2013-12-07','13:15:00',1.98),('15087','2013-12-07','13:20:00',1.87),('15087','2013-12-07','13:25:00',1.84),('15087','2013-12-07','13:30:00',1.79),('15087','2013-12-07','13:35:00',1.76),('15087','2013-12-07','13:40:00',1.69),('15087','2013-12-07','13:45:00',1.7),('15087','2013-12-07','13:50:00',1.66),('15087','2013-12-07','13:55:00',1.61),('15087','2013-12-07','14:00:00',1.51),('15087','2013-12-07','14:05:00',1.45),('15087','2013-12-07','14:10:00',1.35),('15087','2013-12-07','14:15:00',1.24),('15087','2013-12-07','14:20:00',1.11),('15087','2013-12-07','14:25:00',1.02),('15087','2013-12-06','10:10:00',1.16),('15087','2013-12-06','10:15:00',1.02),('15087','2013-12-06','11:25:00',1.01),('15087','2013-12-06','11:30:00',1.09),('15087','2013-12-06','11:35:00',1.5),('15087','2013-12-06','11:40:00',2.18),('15087','2013-12-06','11:45:00',1.83),('15087','2013-12-06','11:50:00',1.93),('15087','2013-12-06','11:55:00',2),('15087','2013-12-06','12:00:00',1.87),('15087','2013-12-06','12:05:00',1.58),('15087','2013-12-06','12:10:00',1.93),('15087','2013-12-06','12:15:00',1.38),('15087','2013-12-06','12:20:00',1.95),('15087','2013-12-06','12:25:00',1.11),('15087','2013-12-06','12:30:00',1.23),('15087','2013-12-06','12:35:00',1.41),('15087','2013-12-06','12:40:00',2.26),('15087','2013-12-06','12:45:00',1.13),('15087','2013-12-06','12:50:00',1.04),('15087','2013-12-05','09:20:00',1.07),('15087','2013-12-05','09:25:00',1.15),('15087','2013-12-05','09:30:00',1.27),('15087','2013-12-05','09:35:00',1.37),('15087','2013-12-05','09:40:00',1.48),('15087','2013-12-05','09:45:00',1.55),('15087','2013-12-05','09:50:00',1.65),('15087','2013-12-05','09:55:00',1.73),('15087','2013-12-05','10:00:00',1.82),('15087','2013-12-05','10:05:00',1.91),('15087','2013-12-05','10:10:00',1.98),('15087','2013-12-05','10:15:00',2.02),('15087','2013-12-05','10:20:00',2.08),('15087','2013-12-05','10:25:00',2.15),('15087','2013-12-05','10:30:00',2.18),('15087','2013-12-05','10:35:00',2.23),('15087','2013-12-05','10:40:00',2.26),('15087','2013-12-05','10:45:00',2.32),('15087','2013-12-05','10:50:00',2.37),('15087','2013-12-05','10:55:00',2.41),('15087','2013-12-05','11:00:00',2.47),('15087','2013-12-05','11:05:00',2.48),('15087','2013-12-05','11:10:00',2.51),('15087','2013-12-05','11:15:00',2.52),('15087','2013-12-05','11:20:00',2.56),('15087','2013-12-05','11:25:00',2.61),('15087','2013-12-05','11:30:00',2.62),('15087','2013-12-05','11:35:00',2.58),('15087','2013-12-05','11:40:00',2.57),('15087','2013-12-05','11:45:00',2.56),('15087','2013-12-05','11:50:00',2.59),('15087','2013-12-05','11:55:00',2.57),('15087','2013-12-05','12:00:00',2.6),('15087','2013-12-05','12:05:00',2.6),('15087','2013-12-05','12:10:00',2.53),('15087','2013-12-05','12:15:00',2.55),('15087','2013-12-05','12:20:00',2.53),('15087','2013-12-05','12:25:00',2.3),('15087','2013-12-05','12:30:00',2.39),('15087','2013-12-05','12:35:00',2.34),('15087','2013-12-05','12:40:00',2.16),('15087','2013-12-05','12:45:00',2.21),('15087','2013-12-05','12:50:00',2.11),('15087','2013-12-05','12:55:00',1.76),('15087','2013-12-05','13:00:00',2.25),('15087','2013-12-05','13:05:00',2.12),('15087','2013-12-05','13:10:00',2.06),('15087','2013-12-05','13:15:00',1.99),('15087','2013-12-05','13:20:00',1.92),('15087','2013-12-05','13:25:00',1.84),('15087','2013-12-05','13:30:00',1.86),('15087','2013-12-05','13:35:00',1.77),('15087','2013-12-05','13:40:00',1.71),('15087','2013-12-05','13:45:00',1.66),('15087','2013-12-05','13:50:00',1.67),('15087','2013-12-05','13:55:00',1.62),('15087','2013-12-05','14:00:00',1.57),('15087','2013-12-05','14:05:00',1.5),('15087','2013-12-05','14:10:00',1.4),('15087','2013-12-05','14:15:00',1.29),('15087','2013-12-05','14:20:00',1.23),('15087','2013-12-05','14:25:00',1.09),('15087','2013-12-03','09:40:00',1.18),('15087','2013-12-03','09:45:00',1.37),('15087','2013-12-03','09:50:00',1.53),('15087','2013-12-03','09:55:00',1.42),('15087','2013-12-03','10:00:00',1.92),('15087','2013-12-03','10:05:00',2.03),('15087','2013-12-03','10:10:00',2.1),('15087','2013-12-03','10:15:00',2.14),('15087','2013-12-03','10:20:00',2.19),('15087','2013-12-03','10:25:00',2.26),('15087','2013-12-03','10:30:00',2.32),('15087','2013-12-03','10:35:00',2.35),('15087','2013-12-03','10:40:00',2.43),('15087','2013-12-03','10:45:00',2.48),('15087','2013-12-03','10:50:00',2.54),('15087','2013-12-03','10:55:00',2.61),('15087','2013-12-03','11:00:00',2.66),('15087','2013-12-03','11:05:00',2.7),('15087','2013-12-03','11:10:00',2.74),('15087','2013-12-03','11:15:00',2.77),('15087','2013-12-03','11:20:00',2.77),('15087','2013-12-03','11:25:00',2.78),('15087','2013-12-03','11:30:00',2.77),('15087','2013-12-03','11:35:00',2.79),('15087','2013-12-03','11:40:00',2.8),('15087','2013-12-03','11:45:00',2.82),('15087','2013-12-03','11:50:00',2.82),('15087','2013-12-03','11:55:00',2.84),('15087','2013-12-03','12:00:00',2.84),('15087','2013-12-03','12:05:00',2.86),('15087','2013-12-03','12:10:00',2.88),('15087','2013-12-03','12:15:00',2.9),('15087','2013-12-03','12:20:00',2.88),('15087','2013-12-03','12:25:00',2.85),('15087','2013-12-03','12:30:00',2.88),('15087','2013-12-03','12:35:00',2.87),('15087','2013-12-03','12:40:00',2.9),('15087','2013-12-03','12:45:00',2.91),('15087','2013-12-03','12:50:00',2.98),('15087','2013-12-03','12:55:00',3.04),('15087','2013-12-03','13:00:00',2.92),('15087','2013-12-03','13:05:00',2.99),('15087','2013-12-03','13:10:00',2.99),('15087','2013-12-03','13:15:00',2.88),('15087','2013-12-03','13:20:00',2.78),('15087','2013-12-03','13:25:00',2.7),('15087','2013-12-03','13:30:00',2.53),('15087','2013-12-03','13:35:00',2.51),('15087','2013-12-03','13:40:00',2.31),('15087','2013-12-03','13:45:00',2.16),('15087','2013-12-03','13:50:00',2.09),('15087','2013-12-03','13:55:00',1.94),('15087','2013-12-03','14:00:00',1.86),('15087','2013-12-03','14:05:00',1.64),('15087','2013-12-03','14:10:00',1.52),('15087','2013-12-03','14:15:00',1.37),('15087','2013-12-03','14:20:00',1.15),('15087','2013-12-03','14:25:00',1.01),('15087','2013-12-03','14:35:00',1.01),('15087','2013-12-01','11:35:00',1.17),('15087','2013-12-01','11:40:00',1.19),('15087','2013-12-01','11:55:00',1.35),('15087','2013-12-01','12:00:00',1.18),('15087','2013-12-01','12:05:00',1.35),('15087','2013-12-01','12:10:00',1.71),('15087','2013-12-01','12:15:00',1.21),('15087','2013-11-30','09:10:00',1.22),('15087','2013-11-30','09:15:00',1.37),('15087','2013-11-30','09:20:00',1.56),('15087','2013-11-30','09:25:00',1.57),('15087','2013-11-30','09:30:00',1.78),('15087','2013-11-30','09:35:00',2.01),('15087','2013-11-30','09:40:00',2.02),('15087','2013-11-30','09:45:00',1.57),('15087','2013-11-30','09:50:00',1.34),('15087','2013-11-30','09:55:00',1.24),('15087','2013-11-30','10:00:00',1.18),('15087','2013-11-30','10:05:00',1.05),('15087','2013-11-30','10:15:00',1.11),('15087','2013-11-30','10:20:00',1.25),('15087','2013-11-30','10:25:00',1.18),('15087','2013-11-30','10:30:00',1.29),('15087','2013-11-30','10:35:00',1.44),('15087','2013-11-30','10:40:00',1.59),('15087','2013-11-30','10:45:00',1.5),('15087','2013-11-30','10:50:00',1.32),('15087','2013-11-30','10:55:00',1.18),('15087','2013-11-30','11:00:00',1.1),('15087','2013-11-30','11:05:00',1.46),('15087','2013-11-30','11:10:00',1.47),('15087','2013-11-30','11:15:00',1.41),('15087','2013-11-30','11:20:00',1.32),('15087','2013-11-30','11:25:00',1.38),('15087','2013-11-30','11:30:00',1.17),('15087','2013-11-30','11:35:00',1.09),('15087','2013-11-30','11:40:00',1.01),('15087','2013-11-29','09:10:00',1.09),('15087','2013-11-29','09:15:00',1.15),('15087','2013-11-29','09:20:00',1.24),('15087','2013-11-29','09:25:00',1.41),('15087','2013-11-29','09:30:00',1.55),('15087','2013-11-29','09:35:00',1.65),('15087','2013-11-29','09:40:00',1.77),('15087','2013-11-29','09:45:00',1.87),('15087','2013-11-29','09:50:00',1.96),('15087','2013-11-29','09:55:00',2.05),('15087','2013-11-29','10:00:00',2.13),('15087','2013-11-29','10:05:00',2.19),('15087','2013-11-29','10:10:00',2.25),('15087','2013-11-29','10:15:00',2.31),('15087','2013-11-29','10:20:00',2.37),('15087','2013-11-29','10:25:00',2.43),('15087','2013-11-29','10:30:00',2.48),('15087','2013-11-29','10:35:00',2.5),('15087','2013-11-29','10:40:00',2.59),('15087','2013-11-29','10:45:00',2.64),('15087','2013-11-29','10:50:00',2.67),('15087','2013-11-29','10:55:00',2.7),('15087','2013-11-29','11:00:00',2.73),('15087','2013-11-29','11:05:00',2.76),('15087','2013-11-29','11:10:00',2.79),('15087','2013-11-29','11:15:00',2.8),('15087','2013-11-29','11:20:00',2.82),('15087','2013-11-29','11:25:00',2.84),('15087','2013-11-29','11:30:00',2.86),('15087','2013-11-29','11:35:00',2.86),('15087','2013-11-29','11:40:00',2.87),('15087','2013-11-29','11:45:00',2.87),('15087','2013-11-29','11:50:00',2.88),('15087','2013-11-29','11:55:00',2.87),('15087','2013-11-29','12:00:00',2.88),('15087','2013-11-29','12:05:00',2.87),('15087','2013-11-29','12:10:00',2.86),('15087','2013-11-29','12:15:00',2.84),('15087','2013-11-29','12:20:00',2.7),('15087','2013-11-29','12:25:00',2.77),('15087','2013-11-29','12:30:00',2.7),('15087','2013-11-29','12:35:00',2.64),('15087','2013-11-29','12:40:00',2.64),('15087','2013-11-29','12:45:00',2.55),('15087','2013-11-29','12:50:00',2.56),('15087','2013-11-29','12:55:00',2.41),('15087','2013-11-29','13:00:00',2.3),('15087','2013-11-29','13:05:00',2.32),('15087','2013-11-29','13:10:00',2.31),('15087','2013-11-29','13:15:00',2.24),('15087','2013-11-29','13:20:00',2.12),('15087','2013-11-29','13:25:00',2.12),('15087','2013-11-29','13:30:00',2.05),('15087','2013-11-29','13:35:00',2.03),('15087','2013-11-29','13:40:00',1.99),('15087','2013-11-29','13:45:00',1.85),('15087','2013-11-29','13:50:00',1.78),('15087','2013-11-29','13:55:00',1.84),('15087','2013-11-29','14:00:00',1.67),('15087','2013-11-29','14:05:00',1.62),('15087','2013-11-29','14:10:00',1.57),('15087','2013-11-29','14:15:00',1.51),('15087','2013-11-29','14:20:00',1.4),('15087','2013-11-29','14:25:00',1.31),('15087','2013-11-29','14:30:00',1.18),('15087','2013-11-29','14:35:00',1.07),('15087','2013-11-28','12:55:00',1.14),('15087','2014-04-20','07:50:00',1.03),('15087','2014-04-20','07:55:00',1.14),('15087','2014-04-20','08:00:00',1.1),('15087','2014-04-20','08:05:00',1.18),('15087','2014-04-20','08:10:00',1.31),('15087','2014-04-20','08:15:00',1.46),('15087','2014-04-20','08:20:00',1.96),('15087','2014-04-20','08:25:00',2.27),('15087','2014-04-20','08:30:00',2.41),('15087','2014-04-20','08:35:00',2.01),('15087','2014-04-20','08:45:00',1.89),('15087','2014-04-20','08:50:00',1.34),('15087','2014-04-20','08:55:00',1.39),('15087','2014-04-20','09:00:00',2.32),('15087','2014-04-20','09:05:00',1.41),('15087','2014-04-20','09:10:00',2.39),('15087','2014-04-20','09:15:00',2.83),('15087','2014-04-20','09:20:00',2.9),('15087','2014-04-20','09:25:00',3.38),('15087','2014-04-20','09:30:00',3.88),('15087','2014-04-20','09:35:00',3.48),('15087','2014-04-20','09:40:00',2.17),('15087','2014-04-20','09:45:00',1.46),('15087','2014-04-20','09:50:00',1.78),('15087','2014-04-20','09:55:00',2.03),('15087','2014-04-20','10:00:00',2.43),('15087','2014-04-20','10:05:00',3.17),('15087','2014-04-20','10:10:00',3.04),('15087','2014-04-20','10:15:00',3.17),('15087','2014-04-20','10:20:00',3.25),('15087','2014-04-20','10:25:00',3.13),('15087','2014-04-20','10:30:00',2.87),('15087','2014-04-20','10:35:00',3.09),('15087','2014-04-20','10:40:00',2.89),('15087','2014-04-20','10:45:00',2.98),('15087','2014-04-20','10:50:00',3.26),('15087','2014-04-20','10:55:00',3.24),('15087','2014-04-20','11:00:00',3.79),('15087','2014-04-20','11:05:00',3.77),('15087','2014-04-20','11:10:00',3.91),('15087','2014-04-20','11:15:00',3),('15087','2014-04-20','11:20:00',3.14),('15087','2014-04-20','11:25:00',4.58),('15087','2014-04-20','11:30:00',4.67),('15087','2014-04-20','11:35:00',4.69),('15087','2014-04-20','11:40:00',2.46),('15087','2014-04-20','11:45:00',2.98),('15087','2014-04-20','11:50:00',3.18),('15087','2014-04-20','11:55:00',4.59),('15087','2014-04-20','12:00:00',4.82),('15087','2014-04-20','12:05:00',4.74),('15087','2014-04-20','12:10:00',3.49),('15087','2014-04-20','12:15:00',1.75),('15087','2014-04-20','12:20:00',3.68),('15087','2014-04-20','12:25:00',2.31),('15087','2014-04-20','12:30:00',5.09),('15087','2014-04-20','12:35:00',4.78),('15087','2014-04-20','12:40:00',4.78),('15087','2014-04-20','12:45:00',4.76),('15087','2014-04-20','12:50:00',4.79),('15087','2014-04-20','12:55:00',4.79),('15087','2014-04-20','13:00:00',4.78),('15087','2014-04-20','13:05:00',4.78),('15087','2014-04-20','13:10:00',4.83),('15087','2014-04-20','13:15:00',4.86),('15087','2014-04-20','13:20:00',4.73),('15087','2014-04-20','13:25:00',4.72),('15087','2014-04-20','13:30:00',4.74),('15087','2014-04-20','13:35:00',4.74),('15087','2014-04-20','13:40:00',4.73),('15087','2014-04-20','13:45:00',4.7),('15087','2014-04-20','13:50:00',4.68),('15087','2014-04-20','13:55:00',4.5),('15087','2014-04-20','14:00:00',4.49),('15087','2014-04-20','14:05:00',4.44),('15087','2014-04-20','14:10:00',4.53),('15087','2014-04-20','14:15:00',4.64),('15087','2014-04-20','14:20:00',3.51),('15087','2014-04-20','14:25:00',3.47),('15087','2014-04-20','14:30:00',3.24),('15087','2014-04-20','14:35:00',2.74),('15087','2014-04-20','14:40:00',2.72),('15087','2014-04-20','14:45:00',2.96),('15087','2014-04-20','14:50:00',2.89),('15087','2014-04-20','14:55:00',3.22),('15087','2014-04-20','15:00:00',4.25),('15087','2014-04-20','15:05:00',3.61),('15087','2014-04-20','15:10:00',3.93),('15087','2014-04-20','15:15:00',3.88),('15087','2014-04-20','15:20:00',3.66),('15087','2014-04-20','15:25:00',3.69),('15087','2014-04-20','15:30:00',3.57),('15087','2014-04-20','15:35:00',3.44),('15087','2014-04-20','15:40:00',3.6),('15087','2014-04-20','15:45:00',2.61),('15087','2014-04-20','15:50:00',2.66),('15087','2014-04-20','15:55:00',3.35),('15087','2014-04-20','16:00:00',3.07),('15087','2014-04-20','16:05:00',2.91),('15087','2014-04-20','16:10:00',3.15),('15087','2014-04-20','16:15:00',3.13),('15087','2014-04-20','16:20:00',3.09),('15087','2014-04-20','16:25:00',2.82),('15087','2014-04-20','16:30:00',3.03),('15087','2014-04-20','16:35:00',2.79),('15087','2014-04-20','16:40:00',2.36),('15087','2014-04-20','16:45:00',2.05),('15087','2014-04-20','16:50:00',2.45),('15087','2014-04-20','16:55:00',2.6),('15087','2014-04-20','17:00:00',2.46),('15087','2014-04-20','17:05:00',2.34),('15087','2014-04-20','17:10:00',2.2),('15087','2014-04-20','17:15:00',2.12),('15087','2014-04-20','17:20:00',2.03),('15087','2014-04-20','17:25:00',1.89),('15087','2014-04-20','17:30:00',1.67),('15087','2014-04-20','17:35:00',1.52),('15087','2014-04-20','17:40:00',1.53),('15087','2014-04-20','17:45:00',1.35),('15087','2014-04-20','17:50:00',1.28),('15087','2014-04-20','17:55:00',1.33),('15087','2014-04-20','18:00:00',1.24),('15087','2014-04-20','18:05:00',1.11),('15087','2014-04-20','18:10:00',1.05),('15087','2013-11-27','09:35:00',1.01),('15087','2013-11-27','09:40:00',1.1),('15087','2013-11-27','09:50:00',1.19),('15087','2013-11-27','09:55:00',1.56),('15087','2013-11-27','10:00:00',1.3),('15087','2013-11-27','10:05:00',1.31),('15087','2013-11-27','10:10:00',1.3),('15087','2013-11-27','10:15:00',1.33),('15087','2013-11-27','10:20:00',1.2),('15087','2013-11-27','10:25:00',1.11),('15087','2013-11-27','10:30:00',1.14),('15087','2013-11-27','10:35:00',1.21),('15087','2013-11-27','10:40:00',1.35),('15087','2013-11-27','10:45:00',1.51),('15087','2013-11-27','10:50:00',1.38),('15087','2013-11-27','10:55:00',1.41),('15087','2013-11-27','11:00:00',1.49),('15087','2013-11-27','11:05:00',1.51),('15087','2013-11-27','11:10:00',1.96),('15087','2013-11-27','11:15:00',1.49),('15087','2013-11-27','11:20:00',1.48),('15087','2013-11-27','11:25:00',1.54),('15087','2013-11-27','11:30:00',2.47),('15087','2013-11-27','11:35:00',2.3),('15087','2013-11-27','11:40:00',1.67),('15087','2013-11-27','11:45:00',1.72),('15087','2013-11-27','11:50:00',2.8),('15087','2013-11-27','11:55:00',3.08),('15087','2013-11-27','12:00:00',3.28),('15087','2013-11-27','12:05:00',2.31),('15087','2013-11-27','12:10:00',1.62),('15087','2013-11-27','12:15:00',2.08),('15087','2013-11-27','12:20:00',3.2),('15087','2013-11-27','12:25:00',1.82),('15087','2013-11-27','12:30:00',1.36),('15087','2013-11-27','12:35:00',2.89),('15087','2013-11-27','12:40:00',1.42),('15087','2013-11-27','12:50:00',1.01),('15087','2013-11-27','12:55:00',1.02),('15087','2013-11-27','13:00:00',1.09),('15087','2013-11-27','13:05:00',1.07),('15087','2013-11-27','13:10:00',1.06),('15087','2013-11-27','13:15:00',1.07),('15087','2013-11-27','13:20:00',1.03),('15087','2013-11-27','13:25:00',1.01),('15087','2013-11-27','13:30:00',1.04),('15087','2013-11-27','13:40:00',1.02),('15087','2013-11-26','09:05:00',1),('15087','2013-11-26','09:10:00',1.27),('15087','2013-11-26','09:15:00',1.22),('15087','2013-11-26','09:20:00',1.15),('15087','2013-11-26','09:25:00',1.13),('15087','2013-11-26','09:30:00',1.22),('15087','2013-11-26','09:35:00',1.37),('15087','2013-11-26','09:40:00',1.6),('15087','2013-11-26','09:45:00',1.22),('15087','2013-11-26','09:50:00',1.25),('15087','2013-11-26','09:55:00',1.98),('15087','2013-11-26','10:00:00',1.43),('15087','2013-11-26','10:05:00',1.59),('15087','2013-11-26','10:10:00',1.33),('15087','2013-11-26','10:20:00',1.47),('15087','2013-11-26','10:25:00',2.06),('15087','2013-11-26','10:30:00',2.33),('15087','2013-11-26','10:35:00',2.8),('15087','2013-11-26','10:40:00',2.82),('15087','2013-11-26','10:45:00',2.89),('15087','2013-11-26','10:50:00',2.88),('15087','2013-11-26','10:55:00',2.91),('15087','2013-11-26','11:00:00',3.07),('15087','2013-11-26','11:05:00',2.81),('15087','2013-11-26','11:10:00',3.43),('15087','2013-11-26','11:15:00',3.63),('15087','2013-11-26','11:20:00',2.45),('15087','2013-11-26','11:25:00',3.4),('15087','2013-11-26','11:30:00',3.44),('15087','2013-11-26','11:35:00',2.47),('15087','2013-11-26','11:40:00',2.97),('15087','2013-11-26','11:45:00',3.5),('15087','2013-11-26','11:50:00',2.85),('15087','2013-11-26','11:55:00',2.03),('15087','2013-11-26','12:00:00',1.18),('15087','2013-11-26','12:05:00',1.7),('15087','2013-11-26','12:15:00',1.38),('15087','2013-11-26','12:20:00',3.05),('15087','2013-11-26','12:25:00',2.97),('15087','2013-11-26','12:30:00',2.85),('15087','2013-11-26','12:35:00',2.88),('15087','2013-11-26','12:40:00',2.88),('15087','2013-11-26','12:45:00',2.76),('15087','2013-11-26','12:50:00',2.72),('15087','2013-11-26','12:55:00',2.67),('15087','2013-11-26','13:00:00',2.51),('15087','2013-11-26','13:05:00',2.54),('15087','2013-11-26','13:10:00',2.43),('15087','2013-11-26','13:15:00',2.23),('15087','2013-11-26','13:20:00',2.26),('15087','2013-11-26','13:25:00',2.38),('15087','2013-11-26','13:30:00',2.27),('15087','2013-11-26','13:35:00',2.23),('15087','2013-11-26','13:40:00',2.19),('15087','2013-11-26','13:45:00',2.13),('15087','2013-11-26','13:50:00',2.19),('15087','2013-11-26','13:55:00',2.18),('15087','2013-11-26','14:00:00',2.34),('15087','2013-11-26','14:05:00',2.23),('15087','2013-11-26','14:10:00',2.4),('15087','2013-11-26','14:15:00',2.71),('15087','2013-11-26','14:20:00',2.44),('15087','2013-11-26','14:25:00',1.61),('15087','2013-11-26','14:30:00',1.15),('15087','2013-11-26','14:35:00',1.37),('15087','2013-11-26','14:40:00',1.32),('15087','2013-11-26','14:45:00',1.4),('15087','2013-11-26','14:50:00',1.34),('15087','2013-11-26','14:55:00',1.45),('15087','2013-11-26','15:00:00',1.24),('15087','2013-11-25','08:45:00',1.05),('15087','2013-11-25','08:50:00',1.22),('15087','2013-11-25','08:55:00',1.44),('15087','2013-11-25','09:00:00',1.6),('15087','2013-11-25','09:05:00',1.84),('15087','2013-11-25','09:10:00',1.92),('15087','2013-11-25','09:15:00',2.09),('15087','2013-11-25','09:20:00',2.35),('15087','2013-11-25','09:25:00',1.72),('15087','2013-11-25','09:30:00',1.8),('15087','2013-11-25','09:35:00',2.09),('15087','2013-11-25','09:40:00',2.22),('15087','2013-11-25','09:45:00',1.07),('15087','2013-11-25','09:50:00',1.9),('15087','2013-11-25','09:55:00',1.48),('15087','2013-11-25','10:00:00',1.43),('15087','2013-11-25','10:05:00',2.07),('15087','2013-11-25','10:10:00',1.45),('15087','2013-11-25','10:15:00',2.24),('15087','2013-11-25','10:20:00',1.2),('15087','2013-11-25','10:25:00',1.53),('15087','2013-11-25','10:30:00',1.91),('15087','2013-11-25','10:35:00',2.38),('15087','2013-11-25','10:40:00',3.37),('15087','2013-11-25','10:45:00',3.04),('15087','2013-11-25','10:50:00',2.41),('15087','2013-11-25','10:55:00',2.26),('15087','2013-11-25','11:00:00',2.91),('15087','2013-11-25','11:05:00',3.1),('15087','2013-11-25','11:10:00',3.53),('15087','2013-11-25','11:15:00',3.08),('15087','2013-11-25','11:20:00',1.16),('15087','2013-11-25','11:25:00',1.29),('15087','2013-11-25','11:30:00',1.58),('15087','2013-11-25','11:35:00',1.33),('15087','2013-11-25','11:40:00',1.08),('15087','2013-11-25','11:45:00',1.22),('15087','2013-11-25','11:50:00',1.47),('15087','2013-11-25','11:55:00',1.36),('15087','2013-11-25','12:00:00',1.69),('15087','2013-11-25','12:05:00',1.66),('15087','2013-11-25','12:10:00',2.42),('15087','2013-11-25','12:15:00',1.82),('15087','2013-11-25','12:20:00',1.51),('15087','2013-11-25','12:25:00',1.54),('15087','2013-11-25','12:30:00',1.36),('15087','2013-11-25','12:35:00',1.26),('15087','2013-11-25','12:40:00',2.68),('15087','2013-11-25','12:45:00',2.85),('15087','2013-11-25','12:50:00',2.37),('15087','2013-11-25','12:55:00',2.55),('15087','2013-11-25','13:00:00',2.98),('15087','2013-11-25','13:05:00',2.82),('15087','2013-11-25','13:10:00',2.26),('15087','2013-11-25','13:15:00',1.95),('15087','2013-11-25','13:20:00',3.15),('15087','2013-11-25','13:25:00',3.01),('15087','2013-11-25','13:30:00',1.56),('15087','2013-11-25','13:35:00',1.05),('15087','2013-11-24','09:55:00',1.28),('15087','2013-11-24','10:00:00',1.51),('15087','2013-11-24','10:05:00',1.6),('15087','2013-11-24','10:10:00',1.64),('15087','2013-11-24','10:15:00',1.52),('15087','2013-11-24','10:20:00',1.33),('15087','2013-11-24','10:25:00',1.87),('15087','2013-11-24','10:30:00',1.62),('15087','2013-11-24','10:35:00',1.39),('15087','2013-11-24','10:40:00',1.13),('15087','2013-11-24','10:45:00',1.05),('15087','2013-11-24','10:50:00',1.1),('15087','2013-11-24','10:55:00',1.21),('15087','2013-11-24','11:00:00',1.25),('15087','2013-11-24','11:05:00',1.3),('15087','2013-11-24','11:10:00',1.37),('15087','2013-11-24','11:15:00',1.42),('15087','2013-11-24','11:20:00',1.58),('15087','2013-11-24','11:25:00',1.59),('15087','2013-11-24','11:30:00',1.53),('15087','2013-11-24','11:35:00',1.3),('15087','2013-11-24','11:40:00',1.19),('15087','2013-11-24','11:45:00',1.18),('15087','2013-11-24','11:50:00',1.32),('15087','2013-11-24','11:55:00',1.18),('15087','2013-11-24','12:25:00',1.05),('15087','2013-11-24','12:30:00',1.02),('15087','2013-11-24','12:35:00',1.02),('15087','2013-11-24','12:40:00',1.06),('15087','2013-11-24','12:45:00',1.03),('15087','2013-11-24','12:50:00',1.02),('15087','2013-11-24','13:00:00',1.14),('15087','2013-11-24','13:05:00',1.52),('15087','2013-11-24','13:10:00',1.59),('15087','2013-11-24','13:15:00',1.53),('15087','2013-11-24','13:20:00',1.24),('15087','2013-11-24','13:25:00',1),('15087','2013-11-23','10:15:00',1.23),('15087','2013-11-23','10:20:00',1.28),('15087','2013-11-23','10:25:00',1.69),('15087','2013-11-23','10:30:00',1.93),('15087','2013-11-23','10:35:00',1.1),('15087','2013-11-23','10:40:00',2.63),('15087','2013-11-23','13:20:00',1.17),('15087','2013-11-23','13:25:00',1.33),('15087','2013-11-23','13:30:00',1.2),('15087','2013-11-23','13:35:00',1.6),('15087','2013-11-23','13:40:00',1.3),('15087','2013-11-23','13:55:00',1.1),('15087','2013-11-23','14:00:00',1.14),('15087','2013-11-23','14:05:00',1.05),('15087','2013-11-21','09:10:00',1.05),('15087','2013-11-21','09:15:00',1.09),('15087','2013-11-21','09:20:00',1.16),('15087','2013-11-21','09:25:00',1.12),('15087','2013-11-21','09:40:00',1.59),('15087','2013-11-21','09:45:00',1.94),('15087','2013-11-21','09:50:00',1.42),('15087','2013-11-21','09:55:00',1.95),('15087','2013-11-21','10:00:00',1.82),('15087','2013-11-21','10:05:00',2.33),('15087','2013-11-21','10:10:00',2.33),('15087','2013-11-21','10:15:00',2.64),('15087','2013-11-21','10:20:00',2.26),('15087','2013-11-21','10:25:00',1.65),('15087','2013-11-21','10:30:00',2.56),('15087','2013-11-21','10:35:00',2.7),('15087','2013-11-21','10:40:00',2.96),('15087','2013-11-21','10:45:00',1.85),('15087','2013-11-21','11:15:00',1.39),('15087','2013-11-21','11:20:00',1.48),('15087','2013-11-21','11:25:00',1.71),('15087','2013-11-21','11:30:00',2.27),('15087','2013-11-21','11:35:00',1.96),('15087','2013-11-21','11:40:00',2.27),('15087','2013-11-21','11:45:00',2.6),('15087','2013-11-21','11:50:00',2.71),('15087','2013-11-21','11:55:00',2.98),('15087','2013-11-21','12:00:00',1.41),('15087','2013-11-21','12:05:00',2.99),('15087','2013-11-21','12:10:00',2.99),('15087','2013-11-21','12:15:00',2.97),('15087','2013-11-21','12:20:00',2.97),('15087','2013-11-21','12:25:00',2.85),('15087','2013-11-21','12:30:00',3.02),('15087','2013-11-21','12:35:00',3.11),('15087','2013-11-21','12:40:00',3.24),('15087','2013-11-21','12:45:00',3.15),('15087','2013-11-21','12:50:00',3.1),('15087','2013-11-21','12:55:00',3.02),('15087','2013-11-21','13:00:00',3.06),('15087','2013-11-21','13:05:00',2.81),('15087','2013-11-21','13:10:00',2.56),('15087','2013-11-21','13:15:00',2.88),('15087','2013-11-21','13:20:00',2.58),('15087','2013-11-21','13:25:00',2.04),('15087','2013-11-21','13:40:00',1.74),('15087','2013-11-21','13:45:00',2.32),('15087','2013-11-21','13:50:00',1.25),('15087','2013-11-21','13:55:00',2.31),('15087','2013-11-21','14:00:00',2.17),('15087','2013-11-21','14:05:00',1.12),('15087','2013-11-21','14:10:00',1.08),('15087','2013-11-21','14:25:00',1.11),('15087','2013-11-21','14:40:00',1.28),('15087','2013-11-21','14:45:00',1.13),('15087','2013-11-20','09:10:00',1.16),('15087','2013-11-20','09:15:00',1.55),('15087','2013-11-20','09:20:00',1.64),('15087','2013-11-20','09:25:00',1.77),('15087','2013-11-20','09:30:00',1.9),('15087','2013-11-20','10:00:00',1.84),('15087','2013-11-20','10:10:00',1.03),('15087','2013-11-20','10:15:00',2.07),('15087','2013-11-20','11:20:00',1.03),('15087','2013-11-20','11:25:00',1.25),('15087','2013-11-20','11:30:00',1.12),('15087','2013-11-20','11:35:00',1.11),('15087','2013-11-20','11:40:00',1.25),('15087','2013-11-20','11:45:00',4.25),('15087','2013-11-20','11:50:00',3.9),('15087','2013-11-20','11:55:00',1.77),('15087','2013-11-20','12:15:00',1.06),('15087','2013-11-20','12:20:00',1.86),('15087','2013-11-20','12:25:00',1.33),('15087','2013-11-20','12:45:00',1.2),('15087','2013-11-20','12:50:00',2.03),('15087','2013-11-20','12:55:00',2.56),('15087','2013-11-20','13:00:00',1.77),('15087','2013-11-20','13:05:00',1.75),('15087','2013-11-20','13:20:00',1.4),('15087','2013-11-20','13:25:00',1.21),('15087','2013-11-20','13:35:00',1.25),('15087','2013-11-20','13:45:00',1.3),('15087','2013-11-20','13:50:00',1.75),('15087','2013-11-20','14:25:00',1.5),('15087','2013-11-20','14:40:00',1.05),('15087','2013-11-20','14:45:00',1.18),('15087','2013-11-20','15:05:00',1.03),('15087','2013-11-19','09:35:00',1.26),('15087','2013-11-19','09:40:00',2.17),('15087','2013-11-19','09:45:00',2.12),('15087','2013-11-19','10:00:00',1.43),('15087','2013-11-19','10:05:00',1.19),('15087','2013-11-19','10:50:00',1.44),('15087','2013-11-19','11:20:00',2.2),('15087','2013-11-19','11:25:00',2.43),('15087','2013-11-19','11:30:00',2.51),('15087','2013-11-19','11:35:00',3.09),('15087','2013-11-19','11:40:00',2.61),('15087','2013-11-19','11:45:00',2.79),('15087','2013-11-19','11:50:00',2.65),('15087','2013-11-19','11:55:00',2.48),('15087','2013-11-19','12:00:00',2.07),('15087','2013-11-19','12:05:00',2.82),('15087','2013-11-19','12:10:00',2.69),('15087','2013-11-19','12:15:00',2.72),('15087','2013-11-19','12:20:00',1.2),('15087','2013-11-19','12:30:00',1.71),('15087','2013-11-19','12:40:00',1.38),('15087','2013-11-19','12:45:00',2.24),('15087','2013-11-19','12:50:00',2.2),('15087','2013-11-19','12:55:00',2.97),('15087','2013-11-19','13:00:00',1.04),('15087','2013-11-19','13:10:00',1.09),('15087','2013-11-19','13:15:00',1.93),('15087','2013-11-19','13:20:00',1.91),('15087','2013-11-19','15:25:00',1.06),('15087','2013-11-19','15:30:00',1.24),('15087','2013-11-18','09:15:00',1.25),('15087','2013-11-18','09:20:00',1.6),('15087','2013-11-18','09:25:00',1.7),('15087','2013-11-18','09:30:00',1.56),('15087','2013-11-18','09:35:00',2.13),('15087','2013-11-18','09:40:00',1.56),('15087','2013-11-18','09:45:00',1.37),('15087','2013-11-18','09:50:00',1.04),('15087','2013-11-18','09:55:00',1.08),('15087','2013-11-18','10:00:00',1.24),('15087','2013-11-18','10:05:00',1.45),('15087','2013-11-18','10:10:00',1.8),('15087','2013-11-18','10:15:00',1.87),('15087','2013-11-18','10:20:00',1.52),('15087','2013-11-18','10:25:00',1.42),('15087','2013-11-18','10:30:00',1.25),('15087','2013-11-18','10:35:00',1.24),('15087','2013-11-18','10:40:00',1.29),('15087','2013-11-18','10:45:00',1.35),('15087','2013-11-18','10:50:00',1.25),('15087','2013-11-18','10:55:00',1.1),('15087','2013-11-18','11:30:00',1.1),('15087','2013-11-18','11:35:00',1.16),('15087','2013-11-18','11:40:00',1.2),('15087','2013-11-18','11:45:00',1.24),('15087','2013-11-18','11:50:00',1.32),('15087','2013-11-18','11:55:00',1.43),('15087','2013-11-18','12:00:00',1.53),('15087','2013-11-18','12:05:00',1.61),('15087','2013-11-18','12:10:00',1.58),('15087','2013-11-18','12:15:00',1.67),('15087','2013-11-18','12:20:00',1.77),('15087','2013-11-18','12:25:00',1.81),('15087','2013-11-18','12:30:00',1.61),('15087','2013-11-18','12:35:00',1.39),('15087','2013-11-18','12:40:00',1.15),('15087','2013-11-18','12:45:00',1.02),('15087','2013-11-18','13:10:00',1.08),('15087','2013-11-18','13:15:00',1.01),('15087','2013-11-18','13:35:00',1.17),('15087','2013-11-18','13:40:00',1.22),('15087','2013-11-18','13:45:00',1.11),('15087','2013-11-18','13:50:00',1.03),('15087','2014-04-19','07:40:00',1.06),('15087','2014-04-19','07:55:00',2.02),('15087','2014-04-19','08:00:00',1.49),('15087','2014-04-19','08:05:00',1.17),('15087','2014-04-19','08:10:00',1.56),('15087','2014-04-19','08:15:00',1.16),('15087','2014-04-19','08:20:00',1.27),('15087','2014-04-19','08:25:00',1.75),('15087','2014-04-19','08:30:00',2.35),('15087','2014-04-19','08:35:00',2.44),('15087','2014-04-19','08:40:00',2.27),('15087','2014-04-19','08:45:00',1.96),('15087','2014-04-19','08:50:00',1.52),('15087','2014-04-19','09:20:00',1.13),('15087','2014-04-19','09:25:00',1.67),('15087','2014-04-19','09:30:00',2.38),('15087','2014-04-19','09:35:00',2.1),('15087','2014-04-19','09:40:00',1.22),('15087','2014-04-19','10:40:00',1.35),('15087','2014-04-19','10:45:00',1.22),('15087','2014-04-19','10:50:00',1.35),('15087','2014-04-19','10:55:00',1.77),('15087','2014-04-19','11:00:00',1.77),('15087','2014-04-19','11:05:00',1.39),('15087','2014-04-19','11:10:00',1.38),('15087','2014-04-19','11:15:00',2.17),('15087','2014-04-19','11:20:00',3.36),('15087','2014-04-19','11:25:00',2.8),('15087','2014-04-19','11:30:00',2.76),('15087','2014-04-19','11:35:00',2.83),('15087','2014-04-19','11:40:00',2.67),('15087','2014-04-19','11:45:00',2.27),('15087','2014-04-19','11:50:00',1.79),('15087','2014-04-19','11:55:00',1.08),('15087','2014-04-19','13:15:00',1.69),('15087','2014-04-19','13:20:00',1.41),('15087','2014-04-19','14:30:00',1.57),('15087','2014-04-19','14:35:00',1.68),('15087','2014-04-19','14:40:00',2.08),('15087','2014-04-19','14:45:00',2.15),('15087','2014-04-19','14:50:00',1.29),('15087','2014-04-19','14:55:00',1.19),('15087','2014-04-19','15:00:00',1.63),('15087','2014-04-19','15:05:00',1.27),('15087','2014-04-19','15:25:00',1.21),('15087','2014-04-19','15:30:00',1.14),('15087','2014-04-19','15:45:00',1.14),('15087','2014-04-19','15:50:00',3.59),('15087','2014-04-19','15:55:00',2.89),('15087','2014-04-19','16:00:00',2.64),('15087','2014-04-19','16:05:00',2.4),('15087','2014-04-19','16:10:00',2.07),('15087','2014-04-19','16:15:00',1.94),('15087','2014-04-19','16:20:00',2.23),('15087','2014-04-19','16:25:00',2.14),('15087','2014-04-19','16:30:00',3.19),('15087','2014-04-19','16:35:00',1.68),('15087','2014-04-19','16:40:00',1.14),('15087','2014-04-19','16:45:00',1.04),('15087','2014-04-19','17:10:00',1.01),('15087','2014-04-19','17:15:00',1.17),('15087','2014-04-19','17:20:00',1.93),('15087','2014-04-19','17:25:00',1.4),('15087','2014-04-19','17:30:00',1.24),('15087','2013-11-16','13:05:00',1.06),('15087','2013-11-15','09:10:00',1.1),('15087','2013-11-15','09:15:00',1.28),('15087','2013-11-15','09:20:00',1.04),('15087','2013-11-15','09:30:00',1.27),('15087','2013-11-15','09:35:00',1.39),('15087','2013-11-15','09:40:00',1.14),('15087','2013-11-15','10:10:00',1.14),('15087','2013-11-15','10:15:00',1.45),('15087','2013-11-15','10:20:00',1.32),('15087','2013-11-15','10:25:00',1.02),('15087','2013-11-15','10:50:00',1.15),('15087','2013-11-15','10:55:00',1.44),('15087','2013-11-15','11:00:00',1.38),('15087','2013-11-15','11:05:00',1.3),('15087','2013-11-15','11:10:00',1.24),('15087','2013-11-15','11:15:00',1.38),('15087','2013-11-15','11:20:00',1.8),('15087','2013-11-15','11:25:00',1.89),('15087','2013-11-15','11:30:00',2),('15087','2013-11-15','11:35:00',1.85),('15087','2013-11-15','11:40:00',2.09),('15087','2013-11-15','11:45:00',1.62),('15087','2013-11-15','11:50:00',1.36),('15087','2013-11-15','11:55:00',1.22),('15087','2013-11-15','12:00:00',1.23),('15087','2013-11-15','12:05:00',1.46),('15087','2013-11-15','12:10:00',1.13),('15087','2013-11-15','12:15:00',1.26),('15087','2013-11-15','12:20:00',1.59),('15087','2013-11-15','12:25:00',1.79),('15087','2013-11-15','12:30:00',1.38),('15087','2013-11-15','12:35:00',1.21),('15087','2013-11-15','12:40:00',1.13),('15087','2013-11-15','12:45:00',1.11),('15087','2013-11-15','12:50:00',1.18),('15087','2013-11-15','12:55:00',1.41),('15087','2013-11-15','13:00:00',1.5),('15087','2013-11-15','13:05:00',1.26),('15087','2013-11-15','13:10:00',1.11),('15087','2013-11-15','13:30:00',1.1),('15087','2013-11-15','13:35:00',1.26),('15087','2013-11-15','13:40:00',1.42),('15087','2013-11-15','13:45:00',1.87),('15087','2013-11-15','13:50:00',1.94),('15087','2013-11-15','13:55:00',1.27),('15087','2013-11-15','14:00:00',1.07),('15087','2013-11-14','09:00:00',1.79),('15087','2013-11-14','09:05:00',1.81),('15087','2013-11-14','09:10:00',1.61),('15087','2013-11-14','09:15:00',1.52),('15087','2013-11-14','09:20:00',2),('15087','2013-11-14','09:25:00',2.03),('15087','2013-11-14','09:30:00',2.08),('15087','2013-11-14','09:35:00',2.14),('15087','2013-11-14','09:40:00',2.17),('15087','2013-11-14','09:45:00',2.23),('15087','2013-11-14','09:50:00',1.71),('15087','2013-11-14','09:55:00',1.31),('15087','2013-11-14','10:05:00',1.72),('15087','2013-11-14','10:10:00',1.73),('15087','2013-11-14','10:15:00',2.54),('15087','2013-11-14','10:20:00',2.6),('15087','2013-11-14','10:25:00',2.59),('15087','2013-11-14','10:30:00',2.62),('15087','2013-11-14','10:35:00',2.63),('15087','2013-11-14','10:40:00',2.62),('15087','2013-11-14','10:45:00',2.6),('15087','2013-11-14','10:50:00',2.69),('15087','2013-11-14','10:55:00',2.72),('15087','2013-11-14','11:00:00',2.71),('15087','2013-11-14','11:05:00',2.85),('15087','2013-11-14','11:10:00',2.91),('15087','2013-11-14','11:15:00',2.97),('15087','2013-11-14','11:20:00',3.03),('15087','2013-11-14','11:25:00',3.05),('15087','2013-11-14','11:30:00',3.05),('15087','2013-11-14','11:35:00',2.73),('15087','2013-11-14','11:40:00',2.62),('15087','2013-11-14','11:45:00',1.91),('15087','2013-11-14','11:50:00',2.11),('15087','2013-11-14','11:55:00',2.4),('15087','2013-11-14','12:00:00',3.25),('15087','2013-11-14','12:05:00',2.07),('15087','2013-11-14','12:10:00',1.43),('15087','2013-11-14','12:15:00',1.46),('15087','2013-11-14','12:20:00',1.34),('15087','2013-11-14','12:25:00',1.12),('15087','2013-11-14','12:30:00',1.11),('15087','2013-11-14','12:35:00',1.15),('15087','2013-11-14','12:40:00',1.13),('15087','2013-11-14','12:45:00',1.16),('15087','2013-11-14','12:50:00',1.19),('15087','2013-11-14','12:55:00',1.16),('15087','2013-11-14','13:00:00',1.14),('15087','2013-11-14','13:05:00',1.01),('15087','2013-11-14','13:55:00',1.3),('15087','2013-11-13','10:05:00',1.11),('15087','2013-11-13','10:10:00',1.12),('15087','2013-11-13','10:15:00',1.17),('15087','2013-11-13','10:20:00',2.51),('15087','2013-11-13','10:25:00',3.59),('15087','2013-11-13','10:30:00',3.16),('15087','2013-11-13','10:35:00',3.56),('15087','2013-11-13','10:40:00',3.39),('15087','2013-11-13','10:45:00',3.16),('15087','2013-11-13','10:50:00',3.71),('15087','2013-11-13','10:55:00',3.28),('15087','2013-11-13','11:00:00',1.58),('15087','2013-11-13','11:30:00',1.04),('15087','2013-11-13','11:45:00',1.05),('15087','2013-11-13','11:50:00',1.21),('15087','2013-11-13','11:55:00',1.11),('15087','2013-11-13','12:55:00',1.01),('15087','2013-11-13','13:00:00',1.15),('15087','2013-11-13','13:05:00',1.36),('15087','2013-11-13','13:10:00',1.24),('15087','2013-11-13','13:15:00',1.21),('15087','2013-11-13','13:40:00',1.01),('15087','2013-11-13','13:55:00',1.59),('15087','2013-11-13','14:00:00',1.82),('15087','2013-11-13','14:05:00',1.71),('15087','2013-11-13','14:10:00',1.64),('15087','2013-11-13','14:15:00',1.66),('15087','2013-11-13','14:20:00',1.53),('15087','2013-11-13','14:25:00',1.63),('15087','2013-11-13','14:30:00',1.51),('15087','2013-11-13','14:35:00',1.13),('15087','2013-11-12','11:25:00',1.5),('15087','2013-11-12','11:35:00',1.13),('15087','2013-11-12','11:40:00',2.15),('15087','2013-11-12','11:45:00',1.13),('15087','2013-11-12','11:50:00',2.03),('15087','2013-11-12','11:55:00',1.06),('15087','2013-11-12','12:00:00',2.72),('15087','2013-11-12','12:05:00',1.66),('15087','2013-11-12','12:30:00',3.94),('15087','2013-11-12','12:35:00',3.55),('15087','2013-11-12','12:40:00',2.22),('15087','2013-11-12','12:45:00',2.1),('15087','2013-11-12','12:50:00',2.1),('15087','2013-11-12','12:55:00',2.44),('15087','2013-11-12','13:00:00',2.08),('15087','2013-11-12','13:05:00',2.11),('15087','2013-11-12','13:10:00',2.48),('15087','2013-11-12','13:15:00',2.36),('15087','2013-11-12','13:20:00',2.06),('15087','2013-11-12','13:25:00',2.23),('15087','2013-11-12','13:30:00',2),('15087','2013-11-12','13:35:00',2.08),('15087','2013-11-12','13:40:00',2.19),('15087','2013-11-12','13:45:00',1.82),('15087','2013-11-12','13:50:00',1.38),('15087','2013-11-12','13:55:00',1.52),('15087','2013-11-12','14:00:00',1.42),('15087','2013-11-12','14:05:00',1.32),('15087','2013-11-12','14:10:00',2.52),('15087','2013-11-12','14:15:00',2.55),('15087','2013-11-12','14:20:00',2.07),('15087','2013-11-12','14:25:00',1.22),('15087','2013-11-12','14:30:00',1.58),('15087','2013-11-12','14:35:00',1.51),('15087','2013-11-12','14:40:00',1.59),('15087','2013-11-12','14:45:00',1.35),('15087','2013-11-12','14:50:00',1.02),('15087','2013-11-11','09:50:00',1.28),('15087','2013-11-11','09:55:00',1.32),('15087','2013-11-11','10:00:00',1.03),('15087','2013-11-11','10:05:00',1.08),('15087','2013-11-11','10:10:00',1.32),('15087','2013-11-11','10:15:00',2.14),('15087','2013-11-11','10:20:00',2.6),('15087','2013-11-11','10:25:00',1.44),('15087','2013-11-11','11:05:00',1.61),('15087','2013-11-11','11:10:00',3.75),('15087','2013-11-11','11:15:00',2.9),('15087','2013-11-11','11:20:00',2.36),('15087','2013-11-11','11:25:00',2.75),('15087','2013-11-11','11:30:00',3.89),('15087','2013-11-11','11:35:00',2.72),('15087','2013-11-11','11:40:00',4.04),('15087','2013-11-11','11:45:00',2.95),('15087','2013-11-11','11:50:00',3.98),('15087','2013-11-11','11:55:00',3.72),('15087','2013-11-11','12:00:00',3.48),('15087','2013-11-11','12:05:00',3.33),('15087','2013-11-11','12:10:00',3.25),('15087','2013-11-11','12:15:00',2.83),('15087','2013-11-11','12:20:00',3.2),('15087','2013-11-11','12:25:00',3.29),('15087','2013-11-11','12:30:00',1.37),('15087','2013-11-11','12:40:00',1.81),('15087','2013-11-11','12:45:00',2.36),('15087','2013-11-11','12:50:00',1),('15087','2013-11-11','13:00:00',1.24),('15087','2013-11-11','13:05:00',1.04),('15087','2013-11-11','13:10:00',1.79),('15087','2013-11-11','13:15:00',1.99),('15087','2013-11-11','13:35:00',1.19),('15087','2013-11-11','13:40:00',1.7),('15087','2013-11-11','14:00:00',2.27),('15087','2013-11-11','14:05:00',1.56),('15087','2013-11-11','14:20:00',1.38),('15087','2013-11-11','14:25:00',1.95),('15087','2013-11-11','14:30:00',1.78),('15087','2013-11-11','14:35:00',1.7),('15087','2013-11-11','14:40:00',1.53),('15087','2013-11-10','08:35:00',1.33),('15087','2013-11-10','08:40:00',1.65),('15087','2013-11-10','08:45:00',1.25),('15087','2013-11-10','08:50:00',1.65),('15087','2013-11-10','08:55:00',1.61),('15087','2013-11-10','09:00:00',1.53),('15087','2013-11-10','09:05:00',1.2),('15087','2013-11-10','09:10:00',1.12),('15087','2013-11-10','09:15:00',1.58),('15087','2013-11-10','09:20:00',2.01),('15087','2013-11-10','09:25:00',2.18),('15087','2013-11-10','09:30:00',1.87),('15087','2013-11-10','09:35:00',1.87),('15087','2013-11-10','09:40:00',2.06),('15087','2013-11-10','09:45:00',2.29),('15087','2013-11-10','09:50:00',2.41),('15087','2013-11-10','09:55:00',2.4),('15087','2013-11-10','10:00:00',2.39),('15087','2013-11-10','10:05:00',2.66),('15087','2013-11-10','10:10:00',2.81),('15087','2013-11-10','10:15:00',2.76),('15087','2013-11-10','10:20:00',2.49),('15087','2013-11-10','10:25:00',3.06),('15087','2013-11-10','10:30:00',3.01),('15087','2013-11-10','10:35:00',1.96),('15087','2013-11-10','10:40:00',3.01),('15087','2013-11-10','10:45:00',2.37),('15087','2013-11-10','10:50:00',3.45),('15087','2013-11-10','10:55:00',3.26),('15087','2013-11-10','11:00:00',2.13),('15087','2013-11-10','11:05:00',1.61),('15087','2013-11-10','11:10:00',1.04),('15087','2013-11-10','11:20:00',1.02),('15087','2013-11-10','11:25:00',1.27),('15087','2013-11-10','11:35:00',1.25),('15087','2013-11-10','11:40:00',2.25),('15087','2013-11-10','11:45:00',2.4),('15087','2013-11-10','11:55:00',1.62),('15087','2013-11-10','12:05:00',1.61),('15087','2013-11-10','12:10:00',1.94),('15087','2013-11-10','12:15:00',3.09),('15087','2013-11-10','12:20:00',2.78),('15087','2013-11-10','12:25:00',2.67),('15087','2013-11-10','12:30:00',1.61),('15087','2013-11-10','12:35:00',2.52),('15087','2013-11-10','12:40:00',3.08),('15087','2013-11-10','12:45:00',3.17),('15087','2013-11-10','12:50:00',3.08),('15087','2013-11-10','12:55:00',1.65),('15087','2013-11-10','13:00:00',1.29),('15087','2013-11-10','13:45:00',1.1),('15087','2013-11-10','13:50:00',2.37),('15087','2013-11-10','13:55:00',1.77),('15087','2013-11-10','14:30:00',1.01),('15087','2013-11-09','09:30:00',1.02),('15087','2013-11-09','09:40:00',1.96),('15087','2013-11-09','09:45:00',1.5),('15087','2013-11-09','09:50:00',3.05),('15087','2013-11-09','09:55:00',2.89),('15087','2013-11-09','10:00:00',2.81),('15087','2013-11-09','10:05:00',2.49),('15087','2013-11-09','10:10:00',2.21),('15087','2013-11-09','10:15:00',2.43),('15087','2013-11-09','10:20:00',2.43),('15087','2013-11-09','10:25:00',1.49),('15087','2013-11-09','10:30:00',1.18),('15087','2013-11-09','10:35:00',1.39),('15087','2013-11-09','10:40:00',1.42),('15087','2013-11-09','10:45:00',1.58),('15087','2013-11-09','10:50:00',1.73),('15087','2013-11-09','10:55:00',2.1),('15087','2013-11-09','11:00:00',1.96),('15087','2013-11-09','11:05:00',2.71),('15087','2013-11-09','11:10:00',3.12),('15087','2013-11-09','11:15:00',2.9),('15087','2013-11-09','11:20:00',1.8),('15087','2013-11-09','11:25:00',2.55),('15087','2013-11-09','11:30:00',2.16),('15087','2013-11-09','11:35:00',1.66),('15087','2013-11-09','11:40:00',3.05),('15087','2013-11-09','11:45:00',3.46),('15087','2013-11-09','11:50:00',2.79),('15087','2013-11-09','11:55:00',3.37),('15087','2013-11-09','12:00:00',3.89),('15087','2013-11-09','12:05:00',3.67),('15087','2013-11-09','12:10:00',1.83),('15087','2013-11-09','12:15:00',2.14),('15087','2013-11-09','12:20:00',1.14),('15087','2013-11-09','12:25:00',1.76),('15087','2013-11-09','12:30:00',2.31),('15087','2013-11-09','12:35:00',3.6),('15087','2013-11-09','12:40:00',3.53),('15087','2013-11-09','12:45:00',2),('15087','2013-11-09','12:50:00',1.86),('15087','2013-11-09','12:55:00',1.68),('15087','2013-11-09','13:00:00',2.99),('15087','2013-11-09','13:05:00',2.21),('15087','2013-11-09','13:10:00',2.84),('15087','2013-11-09','13:15:00',2.73),('15087','2013-11-09','13:25:00',2.44),('15087','2013-11-09','13:30:00',2.36),('15087','2013-11-09','13:35:00',2.32),('15087','2013-11-09','13:40:00',2.25),('15087','2013-11-09','13:45:00',2.26),('15087','2013-11-09','13:50:00',2.24),('15087','2013-11-09','13:55:00',2.21),('15087','2013-11-09','14:00:00',2.02),('15087','2013-11-09','14:05:00',1.73),('15087','2013-11-09','14:10:00',1),('15087','2013-11-09','14:15:00',1.28),('15087','2013-11-09','14:20:00',1.89),('15087','2013-11-09','14:25:00',1.4),('15087','2013-11-09','14:35:00',1.1),('15087','2013-11-09','14:40:00',1.2),('15087','2013-11-09','14:50:00',1.29),('15087','2013-11-08','09:10:00',1.26),('15087','2013-11-08','09:15:00',1.12),('15087','2013-11-08','09:25:00',1.23),('15087','2013-11-08','09:30:00',2.13),('15087','2013-11-08','09:35:00',1.62),('15087','2013-11-08','09:40:00',1.37),('15087','2013-11-08','09:50:00',2.52),('15087','2013-11-08','09:55:00',1.65),('15087','2013-11-08','10:00:00',2.56),('15087','2013-11-08','10:05:00',1.77),('15087','2013-11-08','10:10:00',1.23),('15087','2013-11-08','10:40:00',1.14),('15087','2013-11-08','10:45:00',2.03),('15087','2013-11-08','10:50:00',3.2),('15087','2013-11-08','11:20:00',2.04),('15087','2013-11-08','11:35:00',2.45),('15087','2013-11-08','11:40:00',3.18),('15087','2013-11-08','11:45:00',3.23),('15087','2013-11-08','11:50:00',3.36),('15087','2013-11-08','11:55:00',3.33),('15087','2013-11-08','12:00:00',2.86),('15087','2013-11-08','12:05:00',3.02),('15087','2013-11-08','12:10:00',3.01),('15087','2013-11-08','12:20:00',1.24),('15087','2013-11-08','12:35:00',2.46),('15087','2013-11-08','12:40:00',2.75),('15087','2013-11-08','12:45:00',3.07),('15087','2013-11-08','12:50:00',2.99),('15087','2013-11-08','12:55:00',2.89),('15087','2013-11-08','13:00:00',2.71),('15087','2013-11-08','13:05:00',2.58),('15087','2013-11-08','13:10:00',2.82),('15087','2013-11-08','13:15:00',1.4),('15087','2013-11-08','13:20:00',2.31),('15087','2013-11-08','13:30:00',1.29),('15087','2013-11-08','13:35:00',2.39),('15087','2013-11-08','13:40:00',2.29),('15087','2013-11-08','13:45:00',2.19),('15087','2013-11-08','13:50:00',2.06),('15087','2013-11-08','13:55:00',2.16),('15087','2013-11-08','14:00:00',2.08),('15087','2013-11-08','14:05:00',1.79),('15087','2013-11-08','14:10:00',1.84),('15087','2013-11-08','14:15:00',1.05),('15087','2013-11-08','14:20:00',1.6),('15087','2013-11-08','14:25:00',1.54),('15087','2013-11-08','14:30:00',1.54),('15087','2013-11-08','14:35:00',1.6),('15087','2013-11-08','14:40:00',1.44),('15087','2013-11-08','14:45:00',1.41),('15087','2013-11-08','14:50:00',1.1),('15087','2013-11-08','15:00:00',1.06),('15087','2013-11-08','15:05:00',1.12),('15087','2013-11-08','15:10:00',1.02),('15087','2014-04-18','08:05:00',1.72),('15087','2014-04-18','08:10:00',1.73),('15087','2014-04-18','08:35:00',1),('15087','2014-04-18','08:40:00',1.54),('15087','2014-04-18','08:45:00',1.64),('15087','2014-04-18','08:50:00',1.17),('15087','2014-04-18','08:55:00',1.05),('15087','2014-04-18','09:00:00',1.21),('15087','2014-04-18','09:05:00',2.53),('15087','2014-04-18','09:10:00',3.45),('15087','2014-04-18','09:15:00',3.23),('15087','2014-04-18','09:20:00',3),('15087','2014-04-18','09:25:00',1.76),('15087','2014-04-18','09:30:00',3.34),('15087','2014-04-18','09:35:00',1.96),('15087','2014-04-18','09:40:00',1.09),('15087','2014-04-18','09:45:00',2.07),('15087','2014-04-18','09:50:00',3.1),('15087','2014-04-18','09:55:00',3.47),('15087','2014-04-18','10:00:00',2.84),('15087','2014-04-18','10:05:00',1.84),('15087','2014-04-18','10:10:00',1.6),('15087','2014-04-18','10:15:00',1.76),('15087','2014-04-18','10:20:00',1.61),('15087','2014-04-18','10:25:00',1.67),('15087','2014-04-18','10:30:00',1.37),('15087','2014-04-18','10:35:00',1.22),('15087','2014-04-18','10:40:00',1.47),('15087','2014-04-18','10:45:00',2.58),('15087','2014-04-18','10:50:00',3.19),('15087','2014-04-18','10:55:00',3.36),('15087','2014-04-18','11:00:00',2.1),('15087','2014-04-18','11:05:00',1.86),('15087','2014-04-18','11:10:00',2.07),('15087','2014-04-18','11:15:00',3.42),('15087','2014-04-18','11:20:00',2.14),('15087','2014-04-18','11:25:00',1.5),('15087','2014-04-18','11:30:00',1.82),('15087','2014-04-18','11:35:00',1.82),('15087','2014-04-18','11:40:00',1.91),('15087','2014-04-18','11:45:00',1.82),('15087','2014-04-18','11:50:00',2.21),('15087','2014-04-18','11:55:00',1.97),('15087','2014-04-18','12:00:00',2.07),('15087','2014-04-18','12:05:00',3.88),('15087','2014-04-18','12:10:00',3.75),('15087','2014-04-18','12:15:00',4.09),('15087','2014-04-18','12:20:00',4.38),('15087','2014-04-18','12:25:00',3.16),('15087','2014-04-18','12:30:00',4.92),('15087','2014-04-18','12:35:00',4.75),('15087','2014-04-18','12:40:00',4.9),('15087','2014-04-18','12:45:00',4.03),('15087','2014-04-18','12:50:00',4.07),('15087','2014-04-18','12:55:00',3.12),('15087','2014-04-18','13:00:00',4.74),('15087','2014-04-18','13:05:00',2.79),('15087','2014-04-18','13:10:00',2.8),('15087','2014-04-18','13:15:00',2.67),('15087','2014-04-18','13:20:00',2.52),('15087','2014-04-18','13:25:00',1.84),('15087','2014-04-18','13:30:00',1.43),('15087','2014-04-18','13:35:00',1.44),('15087','2014-04-18','13:40:00',1.41),('15087','2014-04-18','13:45:00',1.2),('15087','2014-04-18','13:50:00',1.45),('15087','2014-04-18','13:55:00',2.58),('15087','2014-04-18','14:00:00',2.25),('15087','2014-04-18','14:05:00',1.95),('15087','2014-04-18','14:10:00',1.63),('15087','2014-04-18','14:15:00',1.42),('15087','2014-04-18','14:20:00',1.69),('15087','2014-04-18','14:25:00',2.24),('15087','2014-04-18','14:30:00',2.53),('15087','2014-04-18','14:35:00',2.89),('15087','2014-04-18','14:40:00',2.53),('15087','2014-04-18','14:45:00',2.9),('15087','2014-04-18','14:50:00',3.29),('15087','2014-04-18','14:55:00',2.72),('15087','2014-04-18','15:00:00',4.44),('15087','2014-04-18','15:05:00',2.84),('15087','2014-04-18','15:10:00',2.03),('15087','2014-04-18','15:15:00',2.47),('15087','2014-04-18','15:20:00',2.09),('15087','2014-04-18','15:25:00',2.54),('15087','2014-04-18','15:30:00',3.33),('15087','2014-04-18','15:35:00',3.47),('15087','2014-04-18','15:40:00',3.67),('15087','2014-04-18','15:45:00',2.5),('15087','2014-04-18','15:50:00',2.87),('15087','2014-04-18','15:55:00',3.15),('15087','2014-04-18','16:00:00',2.64),('15087','2014-04-18','16:05:00',2.05),('15087','2014-04-18','16:10:00',1.57),('15087','2014-04-18','16:15:00',1.35),('15087','2014-04-18','16:20:00',1.42),('15087','2014-04-18','16:25:00',2.43),('15087','2014-04-18','16:30:00',2.64),('15087','2014-04-18','16:35:00',2.94),('15087','2014-04-18','16:40:00',2.98),('15087','2014-04-18','16:45:00',2.73),('15087','2014-04-18','16:50:00',2.72),('15087','2014-04-18','16:55:00',2.68),('15087','2014-04-18','17:00:00',2.84),('15087','2014-04-18','17:05:00',2.71),('15087','2014-04-18','17:10:00',2.32),('15087','2014-04-18','17:15:00',1.97),('15087','2014-04-18','17:20:00',2.03),('15087','2014-04-18','17:25:00',1.96),('15087','2014-04-18','17:30:00',1.77),('15087','2014-04-18','17:35:00',1.64),('15087','2014-04-18','17:40:00',1.49),('15087','2014-04-18','17:45:00',1.43),('15087','2014-04-18','17:50:00',1.34),('15087','2014-04-18','17:55:00',1.3),('15087','2014-04-18','18:00:00',1.27),('15087','2014-04-18','18:05:00',1.07),('15087','2013-11-07','08:25:00',1.08),('15087','2013-11-07','08:30:00',1.22),('15087','2013-11-07','08:35:00',1.35),('15087','2013-11-07','08:40:00',1.45),('15087','2013-11-07','08:45:00',1.57),('15087','2013-11-07','08:50:00',1.66),('15087','2013-11-07','08:55:00',1.7),('15087','2013-11-07','09:00:00',1.8),('15087','2013-11-07','09:05:00',1.85),('15087','2013-11-07','09:10:00',1.95),('15087','2013-11-07','09:15:00',2.01),('15087','2013-11-07','09:20:00',2.06),('15087','2013-11-07','09:25:00',2.15),('15087','2013-11-07','09:30:00',2.18),('15087','2013-11-07','09:35:00',2.26),('15087','2013-11-07','09:40:00',2.31),('15087','2013-11-07','09:45:00',2.36),('15087','2013-11-07','09:50:00',2.39),('15087','2013-11-07','09:55:00',2.44),('15087','2013-11-07','10:00:00',2.49),('15087','2013-11-07','10:05:00',2.51),('15087','2013-11-07','10:10:00',2.53),('15087','2013-11-07','10:15:00',2.56),('15087','2013-11-07','10:20:00',2.59),('15087','2013-11-07','10:25:00',2.63),('15087','2013-11-07','10:30:00',2.66),('15087','2013-11-07','10:35:00',2.69),('15087','2013-11-07','10:40:00',2.73),('15087','2013-11-07','10:45:00',2.74),('15087','2013-11-07','10:50:00',2.74),('15087','2013-11-07','10:55:00',2.75),('15087','2013-11-07','11:00:00',2.77),('15087','2013-11-07','11:05:00',2.78),('15087','2013-11-07','11:10:00',2.76),('15087','2013-11-07','11:15:00',2.78),('15087','2013-11-07','11:20:00',2.79),('15087','2013-11-07','11:25:00',2.78),('15087','2013-11-07','11:30:00',2.84),('15087','2013-11-07','11:35:00',2.87),('15087','2013-11-07','11:40:00',2.83),('15087','2013-11-07','11:45:00',2.83),('15087','2013-11-07','11:50:00',2.86),('15087','2013-11-07','11:55:00',2.85),('15087','2013-11-07','12:00:00',2.82),('15087','2013-11-07','12:05:00',2.79),('15087','2013-11-07','12:10:00',2.81),('15087','2013-11-07','12:15:00',2.76),('15087','2013-11-07','12:20:00',2.71),('15087','2013-11-07','12:25:00',2.54),('15087','2013-11-07','12:30:00',2.76),('15087','2013-11-07','12:35:00',2.62),('15087','2013-11-07','12:40:00',2.49),('15087','2013-11-07','12:45:00',2.62),('15087','2013-11-07','12:50:00',2.47),('15087','2013-11-07','12:55:00',2.4),('15087','2013-11-07','13:00:00',2.64),('15087','2013-11-07','13:05:00',2.69),('15087','2013-11-07','13:10:00',1.38),('15087','2013-11-07','13:15:00',1.07),('15087','2013-11-07','13:20:00',1.03),('15087','2013-11-07','13:25:00',1.89),('15087','2013-11-07','13:30:00',1.52),('15087','2013-11-07','13:35:00',2.4),('15087','2013-11-07','13:40:00',1.81),('15087','2013-11-07','13:45:00',1.45),('15087','2013-11-07','13:50:00',2.09),('15087','2013-11-07','13:55:00',1.95),('15087','2013-11-07','14:00:00',1.09),('15087','2013-11-07','14:05:00',1.26),('15087','2013-11-07','14:10:00',1.65),('15087','2013-11-07','14:20:00',1.25),('15087','2013-11-07','14:25:00',1.54),('15087','2013-11-07','14:30:00',1.51),('15087','2013-11-07','14:35:00',1.37),('15087','2013-11-07','14:40:00',1.41),('15087','2013-11-07','14:45:00',1.35),('15087','2013-11-07','14:50:00',1.31),('15087','2013-11-07','14:55:00',1.14),('15087','2013-11-07','15:00:00',1.12),('15087','2013-11-07','15:05:00',1.04),('15087','2013-11-06','08:15:00',1.06),('15087','2013-11-06','08:20:00',1.05),('15087','2013-11-06','08:35:00',1.5),('15087','2013-11-06','08:40:00',1.6),('15087','2013-11-06','08:45:00',1.74),('15087','2013-11-06','08:50:00',1.88),('15087','2013-11-06','08:55:00',1.76),('15087','2013-11-06','09:00:00',1.17),('15087','2013-11-06','09:05:00',1.2),('15087','2013-11-06','09:10:00',1.28),('15087','2013-11-06','09:15:00',1.76),('15087','2013-11-06','09:20:00',1.81),('15087','2013-11-06','09:25:00',2.19),('15087','2013-11-06','09:30:00',2.32),('15087','2013-11-06','09:35:00',2.37),('15087','2013-11-06','09:40:00',2.42),('15087','2013-11-06','09:45:00',2.48),('15087','2013-11-06','09:50:00',2.53),('15087','2013-11-06','09:55:00',2.57),('15087','2013-11-06','10:00:00',2.61),('15087','2013-11-06','10:05:00',2.65),('15087','2013-11-06','10:10:00',2.65),('15087','2013-11-06','10:15:00',2.72),('15087','2013-11-06','10:20:00',2.76),('15087','2013-11-06','10:25:00',2.8),('15087','2013-11-06','10:30:00',2.83),('15087','2013-11-06','10:35:00',2.85),('15087','2013-11-06','10:40:00',2.87),('15087','2013-11-06','10:45:00',2.91),('15087','2013-11-06','10:50:00',2.95),('15087','2013-11-06','10:55:00',2.98),('15087','2013-11-06','11:00:00',3),('15087','2013-11-06','11:05:00',3.01),('15087','2013-11-06','11:10:00',3.03),('15087','2013-11-06','11:15:00',3.05),('15087','2013-11-06','11:20:00',3.07),('15087','2013-11-06','11:25:00',3.07),('15087','2013-11-06','11:30:00',3.09),('15087','2013-11-06','11:35:00',3.08),('15087','2013-11-06','11:40:00',3.07),('15087','2013-11-06','11:45:00',3.1),('15087','2013-11-06','11:50:00',3.07),('15087','2013-11-06','11:55:00',3.07),('15087','2013-11-06','12:00:00',3.09),('15087','2013-11-06','12:05:00',3.07),('15087','2013-11-06','12:10:00',3.06),('15087','2013-11-06','12:15:00',3.04),('15087','2013-11-06','12:20:00',2.94),('15087','2013-11-06','12:25:00',2.88),('15087','2013-11-06','12:30:00',2.96),('15087','2013-11-06','12:35:00',2.81),('15087','2013-11-06','12:40:00',2.78),('15087','2013-11-06','12:45:00',2.82),('15087','2013-11-06','12:50:00',2.57),('15087','2013-11-06','12:55:00',2.64),('15087','2013-11-06','13:00:00',2.67),('15087','2013-11-06','13:05:00',2.54),('15087','2013-11-06','13:10:00',2.5),('15087','2013-11-06','13:15:00',2.47),('15087','2013-11-06','13:20:00',2.33),('15087','2013-11-06','13:25:00',2.34),('15087','2013-11-06','13:30:00',2.26),('15087','2013-11-06','13:35:00',2.05),('15087','2013-11-06','13:40:00',2.08),('15087','2013-11-06','13:45:00',1.96),('15087','2013-11-06','13:50:00',1.92),('15087','2013-11-06','13:55:00',2.07),('15087','2013-11-06','14:00:00',1.86),('15087','2013-11-06','14:05:00',1.84),('15087','2013-11-06','14:10:00',1.82),('15087','2013-11-06','14:15:00',1.72),('15087','2013-11-06','14:20:00',1.6),('15087','2013-11-06','14:25:00',1.58),('15087','2013-11-06','14:30:00',1.49),('15087','2013-11-06','14:35:00',1.45),('15087','2013-11-06','14:40:00',1.38),('15087','2013-11-06','14:45:00',1.34),('15087','2013-11-06','14:50:00',1.26),('15087','2013-11-06','14:55:00',1.2),('15087','2013-11-06','15:00:00',1.08),('15087','2013-11-06','15:05:00',1.05),('15087','2013-11-06','15:10:00',1.03),('15087','2013-11-04','08:20:00',1.12),('15087','2013-11-04','08:25:00',1.13),('15087','2013-11-04','08:30:00',1.18),('15087','2013-11-04','08:35:00',1.13),('15087','2013-11-04','09:10:00',2.16),('15087','2013-11-04','09:15:00',2.38),('15087','2013-11-04','09:20:00',2.61),('15087','2013-11-04','09:25:00',2.9),('15087','2013-11-04','09:30:00',1.19),('15087','2013-11-04','10:00:00',2.1),('15087','2013-11-04','10:05:00',2.74),('15087','2013-11-04','10:10:00',2.77),('15087','2013-11-04','10:15:00',2.84),('15087','2013-11-04','10:20:00',2.83),('15087','2013-11-04','10:25:00',3.21),('15087','2013-11-04','10:30:00',3.31),('15087','2013-11-04','10:35:00',2.64),('15087','2013-11-04','10:40:00',3.68),('15087','2013-11-04','10:45:00',2.09),('15087','2013-11-04','10:50:00',2.35),('15087','2013-11-04','10:55:00',3.15),('15087','2013-11-04','11:00:00',2.76),('15087','2013-11-04','11:05:00',3.41),('15087','2013-11-04','11:10:00',1.37),('15087','2013-11-04','11:15:00',1.95),('15087','2013-11-04','11:20:00',1.6),('15087','2013-11-04','11:25:00',1.43),('15087','2013-11-04','11:30:00',2.78),('15087','2013-11-04','11:35:00',2.72),('15087','2013-11-04','11:40:00',2.26),('15087','2013-11-04','11:45:00',2.66),('15087','2013-11-04','11:50:00',4.08),('15087','2013-11-04','11:55:00',3.56),('15087','2013-11-04','12:00:00',3.5),('15087','2013-11-04','12:05:00',3.25),('15087','2013-11-04','12:10:00',3.24),('15087','2013-11-04','12:15:00',3.2),('15087','2013-11-04','12:20:00',3.13),('15087','2013-11-04','12:25:00',3.1),('15087','2013-11-04','12:30:00',3.08),('15087','2013-11-04','12:35:00',3),('15087','2013-11-04','12:40:00',2.99),('15087','2013-11-04','12:45:00',2.98),('15087','2013-11-04','12:50:00',2.84),('15087','2013-11-04','12:55:00',2.81),('15087','2013-11-04','13:00:00',2.79),('15087','2013-11-04','13:05:00',2.7),('15087','2013-11-04','13:10:00',2.64),('15087','2013-11-04','13:15:00',2.67),('15087','2013-11-04','13:20:00',2.24),('15087','2013-11-04','13:25:00',2.51),('15087','2013-11-04','13:30:00',2.38),('15087','2013-11-04','13:35:00',2.32),('15087','2013-11-04','13:40:00',1.94),('15087','2013-11-04','13:45:00',2.49),('15087','2013-11-04','13:50:00',2.3),('15087','2013-11-04','13:55:00',1.58),('15087','2013-11-04','14:00:00',1.27),('15087','2013-11-04','14:05:00',1.75),('15087','2013-11-04','14:10:00',2.25),('15087','2013-11-04','14:15:00',1.91),('15087','2013-11-04','14:20:00',2.15),('15087','2013-11-04','14:25:00',1.12),('15087','2013-11-04','14:30:00',1.12),('15087','2013-11-04','14:35:00',1.91),('15087','2013-11-04','14:40:00',1.64),('15087','2013-11-04','14:45:00',1.57),('15087','2013-11-04','14:50:00',1.49),('15087','2013-11-04','14:55:00',1.37),('15087','2013-11-04','15:00:00',1.31),('15087','2013-11-04','15:15:00',1.03),('15087','2013-11-04','15:20:00',1),('15087','2013-11-04','15:25:00',1.01),('15087','2013-11-03','08:35:00',1.29),('15087','2013-11-03','08:50:00',1.72),('15087','2013-11-03','08:55:00',1.01),('15087','2013-11-03','09:35:00',1.13),('15087','2013-11-03','09:40:00',2.81),('15087','2013-11-03','09:45:00',1.35),('15087','2013-11-03','10:05:00',1.06),('15087','2013-11-03','10:10:00',1.41),('15087','2013-11-03','10:20:00',2.7),('15087','2013-11-03','10:25:00',1.82),('15087','2013-11-03','10:30:00',2.96),('15087','2013-11-03','10:35:00',1.9),('15087','2013-11-03','11:15:00',1.04),('15087','2013-11-03','11:20:00',1.98),('15087','2013-11-03','11:25:00',1.29),('15087','2013-11-03','11:30:00',2.6),('15087','2013-11-03','11:35:00',2.91),('15087','2013-11-03','11:40:00',3.37),('15087','2013-11-03','11:45:00',3.46),('15087','2013-11-03','11:50:00',3.45),('15087','2013-11-03','11:55:00',2.62),('15087','2013-11-03','12:00:00',2.72),('15087','2013-11-03','12:05:00',3.7),('15087','2013-11-03','12:10:00',2.75),('15087','2013-11-03','12:15:00',1.82),('15087','2013-11-03','12:25:00',1.32),('15087','2013-11-03','12:35:00',1.21),('15087','2013-11-03','12:40:00',1.35),('15087','2013-11-03','12:45:00',1.07),('15087','2013-11-03','12:50:00',1.07),('15087','2013-11-03','13:25:00',1),('15087','2013-11-03','13:35:00',1.17),('15087','2013-11-03','13:40:00',1.49),('15087','2013-11-03','13:45:00',2.19),('15087','2013-11-03','13:55:00',1.4),('15087','2013-11-03','14:00:00',1.33),('15087','2013-11-03','14:05:00',2.01),('15087','2013-11-03','14:10:00',2.23),('15087','2013-11-03','14:15:00',2.03),('15087','2013-11-03','14:20:00',1.79),('15087','2013-11-03','14:25:00',1.85),('15087','2013-11-03','14:30:00',1.22),('15087','2013-11-03','14:35:00',1.19),('15087','2013-11-03','14:40:00',1.67),('15087','2013-11-03','14:45:00',1.45),('15087','2013-11-03','14:50:00',1.12),('15087','2013-11-02','08:15:00',1.05),('15087','2013-11-02','08:20:00',1.13),('15087','2013-11-02','08:25:00',1.21),('15087','2013-11-02','08:30:00',1.3),('15087','2013-11-02','08:35:00',1.38),('15087','2013-11-02','08:40:00',1.45),('15087','2013-11-02','08:45:00',1.51),('15087','2013-11-02','08:50:00',1.61),('15087','2013-11-02','08:55:00',1.69),('15087','2013-11-02','09:00:00',1.79),('15087','2013-11-02','09:05:00',2.03),('15087','2013-11-02','09:10:00',1.89),('15087','2013-11-02','09:15:00',2),('15087','2013-11-02','09:20:00',1.95),('15087','2013-11-02','09:25:00',2.16),('15087','2013-11-02','09:30:00',2.25),('15087','2013-11-02','09:35:00',2.23),('15087','2013-11-02','09:40:00',2.3),('15087','2013-11-02','09:45:00',2.29),('15087','2013-11-02','09:50:00',2.57),('15087','2013-11-02','09:55:00',2.6),('15087','2013-11-02','10:00:00',2.63),('15087','2013-11-02','10:05:00',2.53),('15087','2013-11-02','10:10:00',1.31),('15087','2013-11-02','10:15:00',1.25),('15087','2013-11-02','11:00:00',1.26),('15087','2013-11-02','11:05:00',1.42),('15087','2013-11-02','11:10:00',1.2),('15087','2013-11-02','11:50:00',1.44),('15087','2013-11-02','11:55:00',2.3),('15087','2013-11-02','12:00:00',3.46),('15087','2013-11-02','12:05:00',3.64),('15087','2013-11-02','12:10:00',3.34),('15087','2013-11-02','12:15:00',2.84),('15087','2013-11-02','12:20:00',3.51),('15087','2013-11-02','12:25:00',3.51),('15087','2013-11-02','12:30:00',3.8),('15087','2013-11-02','12:35:00',3.16),('15087','2013-11-02','12:40:00',3.05),('15087','2013-11-02','12:45:00',2.07),('15087','2013-11-02','12:50:00',3.05),('15087','2013-11-02','12:55:00',3.04),('15087','2013-11-02','13:00:00',2.32),('15087','2013-11-02','13:05:00',3.11),('15087','2013-11-02','13:10:00',3.37),('15087','2013-11-02','13:15:00',1.53),('15087','2013-11-02','13:20:00',1.01),('15087','2013-11-02','13:30:00',1.29),('15087','2013-11-02','13:35:00',2.39),('15087','2013-11-02','13:40:00',2.56),('15087','2013-11-02','13:45:00',3.01),('15087','2013-11-02','13:50:00',3),('15087','2013-11-02','13:55:00',2.8),('15087','2013-11-02','14:00:00',2.47),('15087','2013-11-02','14:05:00',2.16),('15087','2013-11-02','14:10:00',2.01),('15087','2013-11-02','14:15:00',1.89),('15087','2013-11-02','14:20:00',1.73),('15087','2013-11-02','14:25:00',1.61),('15087','2013-11-02','14:30:00',1.57),('15087','2013-11-02','14:35:00',1.45),('15087','2013-11-02','14:40:00',1.45),('15087','2013-11-02','14:45:00',1.37),('15087','2013-11-02','14:50:00',1.33),('15087','2013-11-02','15:00:00',1.13),('15087','2013-11-02','15:10:00',1.05),('15087','2013-11-01','08:25:00',1.05),('15087','2013-11-01','08:30:00',1.22),('15087','2013-11-01','08:35:00',1.35),('15087','2013-11-01','08:40:00',1.48),('15087','2013-11-01','08:45:00',1.47),('15087','2013-11-01','08:50:00',1.46),('15087','2013-11-01','08:55:00',1.54),('15087','2013-11-01','09:00:00',1.64),('15087','2013-11-01','09:05:00',1.86),('15087','2013-11-01','09:10:00',1.96),('15087','2013-11-01','09:15:00',2.02),('15087','2013-11-01','09:20:00',2.09),('15087','2013-11-01','09:25:00',2.15),('15087','2013-11-01','09:30:00',2.22),('15087','2013-11-01','09:35:00',2.26),('15087','2013-11-01','09:40:00',2.34),('15087','2013-11-01','09:45:00',2.4),('15087','2013-11-01','09:50:00',2.46),('15087','2013-11-01','09:55:00',2.51),('15087','2013-11-01','10:00:00',2.56),('15087','2013-11-01','10:05:00',2.6),('15087','2013-11-01','10:10:00',2.66),('15087','2013-11-01','10:15:00',2.69),('15087','2013-11-01','10:20:00',2.73),('15087','2013-11-01','10:25:00',2.77),('15087','2013-11-01','10:30:00',2.7),('15087','2013-11-01','10:35:00',2.76),('15087','2013-11-01','10:40:00',2.8),('15087','2013-11-01','10:45:00',2.78),('15087','2013-11-01','10:50:00',2.76),('15087','2013-11-01','10:55:00',2.8),('15087','2013-11-01','11:00:00',2.84),('15087','2013-11-01','11:05:00',2.56),('15087','2013-11-01','11:10:00',2.27),('15087','2013-11-01','11:15:00',2.56),('15087','2013-11-01','11:20:00',3.02),('15087','2013-11-01','11:25:00',3.16),('15087','2013-11-01','11:30:00',3.16),('15087','2013-11-01','11:35:00',3.01),('15087','2013-11-01','11:40:00',2.64),('15087','2013-11-01','11:45:00',2.9),('15087','2013-11-01','11:50:00',3.14),('15087','2013-11-01','11:55:00',3.17),('15087','2013-11-01','12:00:00',3.07),('15087','2013-11-01','12:05:00',2.98),('15087','2013-11-01','12:10:00',2.8),('15087','2013-11-01','12:15:00',2.47),('15087','2013-11-01','12:20:00',2.57),('15087','2013-11-01','12:25:00',2.65),('15087','2013-11-01','12:30:00',1.77),('15087','2013-11-01','13:10:00',1.05),('15087','2013-11-01','13:15:00',1.22),('15087','2013-11-01','13:20:00',1.22),('15087','2013-11-01','13:25:00',1.05),('15087','2013-11-01','13:30:00',1.18),('15087','2013-11-01','13:35:00',1.24),('15087','2013-11-01','13:40:00',1.11),('15087','2013-10-31','08:25:00',1.08),('15087','2013-10-31','08:30:00',1.29),('15087','2013-10-31','08:35:00',1.38),('15087','2013-10-31','08:40:00',1.65),('15087','2013-10-31','08:45:00',1.6),('15087','2013-10-31','08:50:00',1.71),('15087','2013-10-31','08:55:00',1.62),('15087','2013-10-31','09:00:00',1.6),('15087','2013-10-31','09:05:00',1.39),('15087','2013-10-31','09:20:00',1.57),('15087','2013-10-31','09:25:00',1.63),('15087','2013-10-31','09:30:00',1.79),('15087','2013-10-31','09:35:00',1.84),('15087','2013-10-31','09:40:00',1.77),('15087','2013-10-31','09:45:00',1.77),('15087','2013-10-31','09:50:00',1.77),('15087','2013-10-31','09:55:00',1.87),('15087','2013-10-31','10:00:00',1.96),('15087','2013-10-31','10:05:00',1.93),('15087','2013-10-31','10:10:00',1.73),('15087','2013-10-31','10:15:00',1.59),('15087','2013-10-31','10:20:00',1.41),('15087','2013-10-31','10:25:00',1.65),('15087','2013-10-31','10:30:00',1.72),('15087','2013-10-31','10:35:00',1.95),('15087','2013-10-31','10:40:00',2.01),('15087','2013-10-31','10:45:00',1.8),('15087','2013-10-31','10:50:00',1.84),('15087','2013-10-31','10:55:00',2.09),('15087','2013-10-31','11:00:00',2.47),('15087','2013-10-31','11:05:00',2.85),('15087','2013-10-31','11:10:00',2.82),('15087','2013-10-31','11:15:00',2.89),('15087','2013-10-31','11:20:00',2.76),('15087','2013-10-31','11:25:00',2.49),('15087','2013-10-31','11:30:00',2.76),('15087','2013-10-31','11:35:00',2.62),('15087','2013-10-31','11:40:00',2.9),('15087','2013-10-31','11:45:00',3.03),('15087','2013-10-31','11:50:00',2.99),('15087','2013-10-31','11:55:00',2.98),('15087','2013-10-31','12:00:00',2.91),('15087','2013-10-31','12:05:00',2.85),('15087','2013-10-31','12:10:00',2.95),('15087','2013-10-31','12:15:00',2.92),('15087','2013-10-31','12:20:00',2.85),('15087','2013-10-31','12:25:00',2.69),('15087','2013-10-31','12:30:00',2.64),('15087','2013-10-31','12:35:00',2.55),('15087','2013-10-31','12:40:00',2.57),('15087','2013-10-31','12:45:00',2.59),('15087','2013-10-31','12:50:00',2.73),('15087','2013-10-31','12:55:00',2.69),('15087','2013-10-31','13:00:00',2.57),('15087','2013-10-31','13:05:00',2.6),('15087','2013-10-31','13:10:00',2.48),('15087','2013-10-31','13:15:00',2.37),('15087','2013-10-31','13:20:00',2.42),('15087','2013-10-31','13:25:00',2.41),('15087','2013-10-31','13:30:00',2.32),('15087','2013-10-31','13:35:00',2.25),('15087','2013-10-31','13:40:00',2.1),('15087','2013-10-31','13:45:00',2),('15087','2013-10-31','13:50:00',1.49),('15087','2013-10-31','13:55:00',1.35),('15087','2013-10-31','14:00:00',1.85),('15087','2013-10-31','14:05:00',1.83),('15087','2013-10-31','14:10:00',1.63),('15087','2013-10-31','14:15:00',1.21),('15087','2013-10-31','14:25:00',1.2),('15087','2013-10-30','08:15:00',1.02),('15087','2013-10-30','08:20:00',1.08),('15087','2013-10-30','08:25:00',1.14),('15087','2013-10-30','08:30:00',1.19),('15087','2013-10-30','08:35:00',1.28),('15087','2013-10-30','08:40:00',1.4),('15087','2013-10-30','08:45:00',1.5),('15087','2013-10-30','08:50:00',1.56),('15087','2013-10-30','08:55:00',1.56),('15087','2013-10-30','09:00:00',1.6),('15087','2013-10-30','09:05:00',1.77),('15087','2013-10-30','09:10:00',1.92),('15087','2013-10-30','09:15:00',1.98),('15087','2013-10-30','09:20:00',2.06),('15087','2013-10-30','09:25:00',2.15),('15087','2013-10-30','09:30:00',2.2),('15087','2013-10-30','09:35:00',2.24),('15087','2013-10-30','09:40:00',2.23),('15087','2013-10-30','09:45:00',2.34),('15087','2013-10-30','09:50:00',2.38),('15087','2013-10-30','09:55:00',2.2),('15087','2013-10-30','10:00:00',1.86),('15087','2013-10-30','10:05:00',1.98),('15087','2013-10-30','10:10:00',2.49),('15087','2013-10-30','10:15:00',2.65),('15087','2013-10-30','10:20:00',2.55),('15087','2013-10-30','10:25:00',2.51),('15087','2013-10-30','10:30:00',2.6),('15087','2013-10-30','10:35:00',2.53),('15087','2013-10-30','10:40:00',2.68),('15087','2013-10-30','10:45:00',2.75),('15087','2013-10-30','10:50:00',1.82),('15087','2013-10-30','10:55:00',1.74),('15087','2013-10-30','11:00:00',2.58),('15087','2013-10-30','11:05:00',2.66),('15087','2013-10-30','11:10:00',2.93),('15087','2013-10-30','11:15:00',2.94),('15087','2013-10-30','11:20:00',2.32),('15087','2013-10-30','11:25:00',1.35),('15087','2013-10-30','11:30:00',1.08),('15087','2013-10-30','11:40:00',1.13),('15087','2013-10-30','11:45:00',1.32),('15087','2013-10-30','11:50:00',1.39),('15087','2013-10-30','12:00:00',1.04),('15087','2013-10-30','12:05:00',1.13),('15087','2013-10-30','12:10:00',1.16),('15087','2013-10-30','12:15:00',2.24),('15087','2013-10-30','12:20:00',3.05),('15087','2013-10-30','12:25:00',2.17),('15087','2013-10-30','12:30:00',1.97),('15087','2013-10-30','12:35:00',1.19),('15087','2013-10-30','12:40:00',1.18),('15087','2013-10-30','12:45:00',1.18),('15087','2013-10-30','12:50:00',1.36),('15087','2013-10-30','12:55:00',2.64),('15087','2013-10-30','13:00:00',1.73),('15087','2013-10-30','13:05:00',2.75),('15087','2013-10-30','13:10:00',2.79),('15087','2013-10-30','13:15:00',2.93),('15087','2013-10-30','13:20:00',2.82),('15087','2013-10-30','13:25:00',2.68),('15087','2013-10-30','13:30:00',1.47),('15087','2013-10-30','13:35:00',1.78),('15087','2013-10-30','13:40:00',2.51),('15087','2013-10-30','13:45:00',2.02),('15087','2013-10-30','13:50:00',1.36),('15087','2013-10-30','13:55:00',2.25),('15087','2013-10-30','14:00:00',2.31),('15087','2013-10-30','14:05:00',2.31),('15087','2013-10-30','14:10:00',1.16),('15087','2013-10-30','14:35:00',1.14),('15087','2013-10-30','14:40:00',1.52),('15087','2013-10-30','14:45:00',1.3),('15087','2013-10-29','08:35:00',1.11),('15087','2013-10-29','08:45:00',1.51),('15087','2013-10-29','08:50:00',1.68),('15087','2013-10-29','08:55:00',1.78),('15087','2013-10-29','09:00:00',1.88),('15087','2013-10-29','09:05:00',1.95),('15087','2013-10-29','09:10:00',2),('15087','2013-10-29','09:15:00',2.08),('15087','2013-10-29','09:20:00',2.13),('15087','2013-10-29','09:25:00',2.17),('15087','2013-10-29','09:30:00',2.23),('15087','2013-10-29','09:35:00',2.38),('15087','2013-10-29','09:40:00',2.08),('15087','2013-10-29','09:45:00',2.47),('15087','2013-10-29','09:50:00',2.46),('15087','2013-10-29','09:55:00',2.07),('15087','2013-10-29','10:00:00',2.26),('15087','2013-10-29','10:05:00',1.73),('15087','2013-10-29','10:10:00',1.81),('15087','2013-10-29','10:15:00',2.17),('15087','2013-10-29','10:25:00',1.14),('15087','2013-10-29','10:30:00',1.34),('15087','2013-10-29','10:35:00',2.02),('15087','2013-10-29','10:40:00',2.82),('15087','2013-10-29','10:45:00',3.19),('15087','2013-10-29','10:50:00',3.23),('15087','2013-10-29','10:55:00',3.39),('15087','2013-10-29','11:00:00',3.28),('15087','2013-10-29','11:05:00',3.37),('15087','2013-10-29','11:10:00',3.28),('15087','2013-10-29','11:15:00',3.13),('15087','2013-10-29','11:20:00',3.14),('15087','2013-10-29','11:25:00',3.13),('15087','2013-10-29','11:30:00',3.16),('15087','2013-10-29','11:35:00',3.18),('15087','2013-10-29','11:40:00',3.15),('15087','2013-10-29','11:45:00',3.17),('15087','2013-10-29','11:50:00',3.19),('15087','2013-10-29','11:55:00',3.08),('15087','2013-10-29','12:00:00',2.98),('15087','2013-10-29','12:05:00',3.01),('15087','2013-10-29','12:10:00',2.99),('15087','2013-10-29','12:15:00',2.99),('15087','2013-10-29','12:20:00',2.91),('15087','2013-10-29','12:25:00',2.61),('15087','2013-10-29','12:30:00',2.47),('15087','2013-10-29','12:35:00',2.69),('15087','2013-10-29','12:40:00',2.75),('15087','2013-10-29','12:45:00',2.25),('15087','2013-10-29','12:50:00',2.43),('15087','2013-10-29','12:55:00',2.57),('15087','2013-10-29','13:00:00',2.57),('15087','2013-10-29','13:05:00',2.59),('15087','2013-10-29','13:10:00',2.57),('15087','2013-10-29','13:15:00',2.5),('15087','2013-10-29','13:20:00',2.41),('15087','2013-10-29','13:25:00',2.43),('15087','2013-10-29','13:30:00',2.39),('15087','2013-10-29','13:35:00',2.25),('15087','2013-10-29','13:40:00',2.06),('15087','2013-10-29','13:45:00',2.01),('15087','2013-10-29','13:50:00',2.11),('15087','2013-10-29','13:55:00',1.88),('15087','2013-10-29','14:00:00',1.63),('15087','2013-10-29','14:05:00',1.84),('15087','2013-10-29','14:10:00',1.75),('15087','2013-10-29','14:15:00',1.69),('15087','2013-10-29','14:20:00',1.67),('15087','2013-10-29','14:25:00',1.58),('15087','2013-10-29','14:30:00',1.5),('15087','2013-10-29','14:35:00',1.44),('15087','2013-10-29','14:40:00',1.41),('15087','2013-10-29','14:45:00',1.36),('15087','2013-10-29','14:50:00',1.28),('15087','2013-10-29','14:55:00',1.24),('15087','2013-10-29','15:00:00',1.18),('15087','2013-10-29','15:05:00',1.12),('15087','2013-10-29','15:10:00',1.1),('15087','2013-10-29','15:15:00',1.03),('15087','2014-04-17','08:00:00',1.2),('15087','2014-04-17','08:05:00',1.36),('15087','2014-04-17','08:10:00',1.46),('15087','2014-04-17','08:15:00',1.58),('15087','2014-04-17','08:20:00',1.62),('15087','2014-04-17','08:25:00',1.75),('15087','2014-04-17','08:30:00',1.86),('15087','2014-04-17','08:35:00',1.96),('15087','2014-04-17','08:40:00',2.06),('15087','2014-04-17','08:45:00',2.17),('15087','2014-04-17','08:50:00',2.29),('15087','2014-04-17','08:55:00',2.17),('15087','2014-04-17','09:00:00',2.01),('15087','2014-04-17','09:05:00',2.44),('15087','2014-04-17','09:10:00',2.64),('15087','2014-04-17','09:15:00',2.74),('15087','2014-04-17','09:20:00',2.86),('15087','2014-04-17','09:25:00',2.94),('15087','2014-04-17','09:30:00',3.03),('15087','2014-04-17','09:35:00',3.13),('15087','2014-04-17','09:40:00',3.22),('15087','2014-04-17','09:45:00',3.29),('15087','2014-04-17','09:50:00',3.38),('15087','2014-04-17','09:55:00',3.48),('15087','2014-04-17','10:00:00',3.63),('15087','2014-04-17','10:05:00',3.94),('15087','2014-04-17','10:10:00',3.82),('15087','2014-04-17','10:15:00',2.82),('15087','2014-04-17','10:20:00',4.01),('15087','2014-04-17','10:25:00',4.15),('15087','2014-04-17','10:30:00',4.46),('15087','2014-04-17','10:35:00',4.71),('15087','2014-04-17','10:40:00',4.31),('15087','2014-04-17','10:45:00',3.97),('15087','2014-04-17','10:50:00',2.91),('15087','2014-04-17','10:55:00',2.68),('15087','2014-04-17','11:00:00',3.04),('15087','2014-04-17','11:05:00',3.25),('15087','2014-04-17','11:10:00',3.38),('15087','2014-04-17','11:15:00',2.5),('15087','2014-04-17','11:20:00',3.28),('15087','2014-04-17','11:25:00',4.39),('15087','2014-04-17','11:30:00',2.82),('15087','2014-04-17','11:35:00',2.51),('15087','2014-04-17','11:40:00',2.7),('15087','2014-04-17','11:45:00',4.45),('15087','2014-04-17','11:50:00',3.51),('15087','2014-04-17','11:55:00',2.52),('15087','2014-04-17','12:00:00',3.23),('15087','2014-04-17','12:05:00',3.34),('15087','2014-04-17','12:10:00',2.89),('15087','2014-04-17','12:15:00',2.57),('15087','2014-04-17','12:20:00',2.7),('15087','2014-04-17','12:25:00',3.03),('15087','2014-04-17','12:30:00',3.73),('15087','2014-04-17','12:35:00',4.11),('15087','2014-04-17','12:40:00',4.75),('15087','2014-04-17','12:45:00',4.59),('15087','2014-04-17','12:50:00',2.38),('15087','2014-04-17','12:55:00',3.41),('15087','2014-04-17','13:25:00',4.02),('15087','2014-04-17','13:30:00',5.16),('15087','2014-04-17','13:35:00',1.9),('15087','2014-04-17','13:50:00',2.51),('15087','2014-04-17','13:55:00',1.94),('15087','2014-04-17','14:00:00',1.03),('15087','2014-04-17','14:05:00',1.14),('15087','2014-04-17','14:10:00',2.85),('15087','2014-04-17','14:15:00',4.37),('15087','2014-04-17','14:20:00',1.58),('15087','2014-04-17','14:25:00',1.86),('15087','2014-04-17','14:30:00',2.12),('15087','2014-04-17','14:35:00',2.56),('15087','2014-04-17','14:40:00',4.71),('15087','2014-04-17','14:45:00',1.37),('15087','2014-04-17','15:25:00',1.25),('15087','2014-04-17','15:30:00',2.13),('15087','2014-04-17','15:35:00',2.82),('15087','2014-04-17','15:40:00',2.04),('15087','2014-04-17','15:45:00',1.49),('15087','2014-04-17','15:50:00',1.29),('15087','2014-04-17','15:55:00',1.49),('15087','2014-04-17','16:00:00',1.2),('15087','2014-04-17','16:10:00',1.1),('15087','2014-04-17','16:15:00',1.1),('15087','2014-04-17','16:20:00',1.07),('15087','2014-04-17','16:25:00',1.24),('15087','2014-04-17','16:30:00',1.26),('15087','2014-04-17','16:35:00',1.11),('15087','2014-04-17','16:40:00',1.36),('15087','2014-04-17','16:45:00',1.93),('15087','2014-04-17','16:50:00',1.81),('15087','2014-04-17','16:55:00',1.32),('15087','2014-04-17','17:00:00',1.05),('15087','2014-04-17','17:15:00',1.01),('15087','2014-04-17','17:20:00',1.13),('15087','2014-04-17','17:30:00',1),('15087','2014-04-17','17:35:00',1.05),('15087','2013-10-28','08:50:00',1.29),('15087','2013-10-28','08:55:00',1.84),('15087','2013-10-28','09:00:00',1.96),('15087','2013-10-28','09:05:00',2.2),('15087','2013-10-28','09:10:00',2.27),('15087','2013-10-28','09:15:00',2.12),('15087','2013-10-28','09:20:00',1.86),('15087','2013-10-28','09:25:00',2.33),('15087','2013-10-28','09:30:00',2.36),('15087','2013-10-28','09:35:00',1.85),('15087','2013-10-28','09:40:00',2.6),('15087','2013-10-28','09:45:00',2.45),('15087','2013-10-28','09:50:00',2.15),('15087','2013-10-28','09:55:00',1.45),('15087','2013-10-28','10:45:00',1.18),('15087','2013-10-28','10:50:00',3.06),('15087','2013-10-28','10:55:00',2.95),('15087','2013-10-28','11:00:00',3.04),('15087','2013-10-28','11:05:00',3.05),('15087','2013-10-28','11:10:00',3.08),('15087','2013-10-28','11:15:00',3.09),('15087','2013-10-28','11:20:00',3.08),('15087','2013-10-28','11:25:00',3.1),('15087','2013-10-28','11:30:00',3.12),('15087','2013-10-28','11:35:00',3.08),('15087','2013-10-28','11:40:00',3.11),('15087','2013-10-28','11:45:00',3.08),('15087','2013-10-28','11:50:00',3.14),('15087','2013-10-28','11:55:00',2.4),('15087','2013-10-28','12:00:00',2.62),('15087','2013-10-28','12:05:00',2.71),('15087','2013-10-28','12:10:00',3.24),('15087','2013-10-28','12:15:00',3.22),('15087','2013-10-28','12:20:00',2.69),('15087','2013-10-28','12:25:00',2.24),('15087','2013-10-28','12:30:00',3.24),('15087','2013-10-28','12:35:00',3.48),('15087','2013-10-28','12:40:00',2.9),('15087','2013-10-28','12:45:00',3.03),('15087','2013-10-28','12:50:00',3.1),('15087','2013-10-28','12:55:00',2.77),('15087','2013-10-28','13:00:00',2.58),('15087','2013-10-28','13:05:00',2.78),('15087','2013-10-28','13:10:00',2.53),('15087','2013-10-28','13:15:00',2.49),('15087','2013-10-28','13:20:00',2.48),('15087','2013-10-28','13:25:00',2.25),('15087','2013-10-28','13:30:00',2.25),('15087','2013-10-28','13:35:00',2.42),('15087','2013-10-28','13:40:00',2.43),('15087','2013-10-28','13:45:00',2.36),('15087','2013-10-28','13:50:00',2.33),('15087','2013-10-28','13:55:00',2.33),('15087','2013-10-28','14:00:00',2.28),('15087','2013-10-28','14:05:00',2.25),('15087','2013-10-28','14:10:00',2.17),('15087','2013-10-28','14:15:00',1.87),('15087','2013-10-28','14:20:00',1.97),('15087','2013-10-28','14:25:00',1.88),('15087','2013-10-28','14:30:00',1.02),('15087','2013-10-28','14:35:00',1.63),('15087','2013-10-28','14:45:00',1.56),('15087','2013-10-28','14:50:00',1.44),('15087','2013-10-28','14:55:00',1.37),('15087','2013-10-28','15:00:00',1.27),('15087','2013-10-28','15:05:00',1.22),('15087','2013-10-28','15:10:00',1.13),('15087','2013-10-27','09:55:00',1.03),('15087','2013-10-27','10:00:00',1.07),('15087','2013-10-27','10:05:00',1.09),('15087','2013-10-27','10:10:00',1.17),('15087','2013-10-27','10:15:00',1.26),('15087','2013-10-27','10:20:00',1.37),('15087','2013-10-27','10:25:00',1.32),('15087','2013-10-27','10:30:00',1.3),('15087','2013-10-27','10:35:00',1.33),('15087','2013-10-27','10:40:00',1.37),('15087','2013-10-27','10:45:00',1.56),('15087','2013-10-27','10:50:00',1.5),('15087','2013-10-27','10:55:00',1.33),('15087','2013-10-27','11:00:00',1.17),('15087','2013-10-27','11:30:00',1.12),('15087','2013-10-27','11:35:00',1.7),('15087','2013-10-27','11:40:00',2.35),('15087','2013-10-27','11:45:00',2.68),('15087','2013-10-27','11:50:00',1.31),('15087','2013-10-27','11:55:00',1.11),('15087','2013-10-27','12:00:00',1.23),('15087','2013-10-27','12:05:00',1.29),('15087','2013-10-27','12:10:00',1.16),('15087','2013-10-27','12:15:00',1.63),('15087','2013-10-27','12:20:00',2.71),('15087','2013-10-27','12:25:00',2.8),('15087','2013-10-27','12:30:00',2.68),('15087','2013-10-27','12:35:00',3.56),('15087','2013-10-27','12:40:00',2.04),('15087','2013-10-27','12:45:00',2.99),('15087','2013-10-27','12:50:00',2.94),('15087','2013-10-27','12:55:00',2.35),('15087','2013-10-27','13:00:00',1.22),('15087','2013-10-27','13:05:00',1.42),('15087','2013-10-27','13:10:00',1.78),('15087','2013-10-27','13:15:00',1),('15087','2013-10-27','13:25:00',2.28),('15087','2013-10-27','13:30:00',2.55),('15087','2013-10-27','13:35:00',2.1),('15087','2013-10-27','13:40:00',1.1),('15087','2013-10-27','14:00:00',1.1),('15087','2013-10-27','14:10:00',1.16),('15087','2013-10-27','14:15:00',1.39),('15087','2013-10-27','14:20:00',1.07),('15087','2013-10-27','14:25:00',1.21),('15087','2013-10-27','14:30:00',1.74),('15087','2013-10-27','14:35:00',1.46),('15087','2013-10-27','14:40:00',1.54),('15087','2013-10-27','14:45:00',1.01),('15087','2013-10-27','14:55:00',1.12),('15087','2013-10-27','15:00:00',1.29),('15087','2013-10-27','15:05:00',1.13),('15087','2013-10-27','15:10:00',1.19),('15087','2013-10-27','15:15:00',1.11),('15087','2013-10-27','15:20:00',1.05),('15087','2013-10-26','09:05:00',1.03),('15087','2013-10-26','09:10:00',1.1),('15087','2013-10-26','09:15:00',1.19),('15087','2013-10-26','09:20:00',1.25),('15087','2013-10-26','09:25:00',1.33),('15087','2013-10-26','09:30:00',1.4),('15087','2013-10-26','09:35:00',1.48),('15087','2013-10-26','09:40:00',1.55),('15087','2013-10-26','09:45:00',1.64),('15087','2013-10-26','09:50:00',1.71),('15087','2013-10-26','09:55:00',1.76),('15087','2013-10-26','10:00:00',1.84),('15087','2013-10-26','10:05:00',1.92),('15087','2013-10-26','10:10:00',2.01),('15087','2013-10-26','10:15:00',2.1),('15087','2013-10-26','10:20:00',2.15),('15087','2013-10-26','10:25:00',2.23),('15087','2013-10-26','10:30:00',2.29),('15087','2013-10-26','10:35:00',2.34),('15087','2013-10-26','10:40:00',2.41),('15087','2013-10-26','10:45:00',2.49),('15087','2013-10-26','10:50:00',2.55),('15087','2013-10-26','10:55:00',2.58),('15087','2013-10-26','11:00:00',2.62),('15087','2013-10-26','11:05:00',2.66),('15087','2013-10-26','11:10:00',2.69),('15087','2013-10-26','11:15:00',2.73),('15087','2013-10-26','11:20:00',2.77),('15087','2013-10-26','11:25:00',2.82),('15087','2013-10-26','11:30:00',2.82),('15087','2013-10-26','11:35:00',2.86),('15087','2013-10-26','11:40:00',2.88),('15087','2013-10-26','11:45:00',2.9),('15087','2013-10-26','11:50:00',2.94),('15087','2013-10-26','11:55:00',2.94),('15087','2013-10-26','12:00:00',2.94),('15087','2013-10-26','12:05:00',2.98),('15087','2013-10-26','12:10:00',2.97),('15087','2013-10-26','12:15:00',2.97),('15087','2013-10-26','12:20:00',3.03),('15087','2013-10-26','12:25:00',2.99),('15087','2013-10-26','12:30:00',2.9),('15087','2013-10-26','12:35:00',3.04),('15087','2013-10-26','12:40:00',2.97),('15087','2013-10-26','12:45:00',2.81),('15087','2013-10-26','12:50:00',2.96),('15087','2013-10-26','12:55:00',2.84),('15087','2013-10-26','13:00:00',3.01),('15087','2013-10-26','13:05:00',2.81),('15087','2013-10-26','13:10:00',2.72),('15087','2013-10-26','13:15:00',3.02),('15087','2013-10-26','13:20:00',2.82),('15087','2013-10-26','13:25:00',2.77),('15087','2013-10-26','13:30:00',2.94),('15087','2013-10-26','13:35:00',2.98),('15087','2013-10-26','13:40:00',2.88),('15087','2013-10-26','13:45:00',2.71),('15087','2013-10-26','13:50:00',2.71),('15087','2013-10-26','13:55:00',2.45),('15087','2013-10-26','14:00:00',2.45),('15087','2013-10-26','14:05:00',2.14),('15087','2013-10-26','14:10:00',2.14),('15087','2013-10-26','14:15:00',1.52),('15087','2013-10-26','14:20:00',1.7),('15087','2013-10-26','14:25:00',1.68),('15087','2013-10-26','14:30:00',2.05),('15087','2013-10-26','14:35:00',2.01),('15087','2013-10-26','14:40:00',1.96),('15087','2013-10-26','14:45:00',1.46),('15087','2013-10-26','14:50:00',1.1),('15087','2013-10-26','14:55:00',2.01),('15087','2013-10-26','15:00:00',1.99),('15087','2013-10-26','15:05:00',1.83),('15087','2013-10-26','15:10:00',1.82),('15087','2013-10-26','15:15:00',1.62),('15087','2013-10-26','15:20:00',1.59),('15087','2013-10-26','15:25:00',1.67),('15087','2013-10-26','15:30:00',1.65),('15087','2013-10-26','15:35:00',1.68),('15087','2013-10-26','15:40:00',1.52),('15087','2013-10-26','15:45:00',1.46),('15087','2013-10-26','15:50:00',1.37),('15087','2013-10-26','15:55:00',1.26),('15087','2013-10-26','16:00:00',1.22),('15087','2013-10-26','16:05:00',1.18),('15087','2013-10-26','16:10:00',1.12),('15087','2013-10-26','16:15:00',1.05),('15087','2013-10-25','09:05:00',1.07),('15087','2013-10-25','09:10:00',1.14),('15087','2013-10-25','09:15:00',1.22),('15087','2013-10-25','09:20:00',1.31),('15087','2013-10-25','09:25:00',1.37),('15087','2013-10-25','09:30:00',1.46),('15087','2013-10-25','09:35:00',1.54),('15087','2013-10-25','09:40:00',1.6),('15087','2013-10-25','09:45:00',1.68),('15087','2013-10-25','09:50:00',1.77),('15087','2013-10-25','09:55:00',1.8),('15087','2013-10-25','10:00:00',1.94),('15087','2013-10-25','10:05:00',1.98),('15087','2013-10-25','10:10:00',2.04),('15087','2013-10-25','10:15:00',2.09),('15087','2013-10-25','10:20:00',2.22),('15087','2013-10-25','10:25:00',2.3),('15087','2013-10-25','10:30:00',2.37),('15087','2013-10-25','10:35:00',2.4),('15087','2013-10-25','10:40:00',2.47),('15087','2013-10-25','10:45:00',2.53),('15087','2013-10-25','10:50:00',2.56),('15087','2013-10-25','10:55:00',2.61),('15087','2013-10-25','11:00:00',2.63),('15087','2013-10-25','11:05:00',2.67),('15087','2013-10-25','11:10:00',2.75),('15087','2013-10-25','11:15:00',2.73),('15087','2013-10-25','11:20:00',2.74),('15087','2013-10-25','11:25:00',2.79),('15087','2013-10-25','11:30:00',2.84),('15087','2013-10-25','11:35:00',2.91),('15087','2013-10-25','11:40:00',2.98),('15087','2013-10-25','11:45:00',3),('15087','2013-10-25','11:50:00',3.04),('15087','2013-10-25','11:55:00',3.05),('15087','2013-10-25','12:00:00',3.09),('15087','2013-10-25','12:05:00',3.11),('15087','2013-10-25','12:10:00',3.14),('15087','2013-10-25','12:15:00',3.11),('15087','2013-10-25','12:20:00',3.14),('15087','2013-10-25','12:25:00',3.14),('15087','2013-10-25','12:30:00',3.15),('15087','2013-10-25','12:35:00',3.15),('15087','2013-10-25','12:40:00',3.18),('15087','2013-10-25','12:45:00',3.18),('15087','2013-10-25','12:50:00',3.18),('15087','2013-10-25','12:55:00',3.17),('15087','2013-10-25','13:00:00',3.15),('15087','2013-10-25','13:05:00',3.13),('15087','2013-10-25','13:10:00',3.12),('15087','2013-10-25','13:15:00',3.09),('15087','2013-10-25','13:20:00',3.06),('15087','2013-10-25','13:25:00',2.83),('15087','2013-10-25','13:30:00',2.95),('15087','2013-10-25','13:35:00',2.95),('15087','2013-10-25','13:40:00',2.76),('15087','2013-10-25','13:45:00',2.82),('15087','2013-10-25','13:50:00',2.83),('15087','2013-10-25','13:55:00',2.62),('15087','2013-10-25','14:00:00',2.64),('15087','2013-10-25','14:05:00',2.68),('15087','2013-10-25','14:10:00',2.47),('15087','2013-10-25','14:15:00',2.51),('15087','2013-10-25','14:20:00',2.53),('15087','2013-10-25','14:25:00',2.38),('15087','2013-10-25','14:30:00',2.45),('15087','2013-10-25','14:35:00',2.33),('15087','2013-10-25','14:40:00',2.23),('15087','2013-10-25','14:45:00',2.27),('15087','2013-10-25','14:50:00',2.3),('15087','2013-10-25','14:55:00',2.25),('15087','2013-10-25','15:00:00',2.14),('15087','2013-10-25','15:05:00',1.93),('15087','2013-10-25','15:10:00',1.77),('15087','2013-10-25','15:15:00',1.79),('15087','2013-10-25','15:20:00',1.73),('15087','2013-10-25','15:25:00',1.63),('15087','2013-10-25','15:30:00',1.55),('15087','2013-10-25','15:35:00',1.53),('15087','2013-10-25','15:40:00',1.5),('15087','2013-10-25','15:45:00',1.48),('15087','2013-10-25','15:50:00',1.38),('15087','2013-10-25','15:55:00',1.35),('15087','2013-10-25','16:00:00',1.31),('15087','2013-10-25','16:05:00',1.2),('15087','2013-10-25','16:10:00',1.12),('15087','2013-10-25','16:15:00',1.1),('15087','2013-10-25','16:20:00',1.03),('15087','2013-10-24','09:05:00',1.21),('15087','2013-10-24','09:10:00',1.21),('15087','2013-10-24','09:15:00',1.58),('15087','2013-10-24','09:20:00',1.19),('15087','2013-10-24','09:35:00',1.03),('15087','2013-10-24','09:40:00',1.1),('15087','2013-10-24','09:45:00',1.14),('15087','2013-10-24','09:50:00',1.16),('15087','2013-10-24','09:55:00',1.12),('15087','2013-10-24','10:00:00',1.08),('15087','2013-10-24','10:05:00',1.04),('15087','2013-10-24','10:20:00',1.62),('15087','2013-10-24','10:35:00',1.88),('15087','2013-10-24','10:40:00',1.1),('15087','2013-10-24','10:45:00',2.2),('15087','2013-10-24','10:50:00',1.69),('15087','2013-10-24','10:55:00',2.14),('15087','2013-10-24','11:00:00',3.15),('15087','2013-10-24','11:05:00',3.52),('15087','2013-10-24','11:10:00',2.27),('15087','2013-10-24','11:15:00',1.96),('15087','2013-10-24','11:20:00',1.81),('15087','2013-10-24','11:25:00',1.62),('15087','2013-10-24','11:30:00',1.21),('15087','2013-10-24','11:35:00',1.19),('15087','2013-10-24','11:40:00',1.12),('15087','2013-10-24','11:45:00',1.23),('15087','2013-10-24','11:50:00',2.02),('15087','2013-10-24','11:55:00',2.89),('15087','2013-10-24','12:00:00',1.75),('15087','2013-10-24','12:05:00',1.41),('15087','2013-10-24','12:10:00',1.34),('15087','2013-10-24','12:15:00',1.34),('15087','2013-10-24','12:20:00',1.41),('15087','2013-10-24','12:25:00',1.54),('15087','2013-10-24','12:30:00',1.62),('15087','2013-10-24','12:35:00',1.8),('15087','2013-10-24','12:40:00',2.19),('15087','2013-10-24','12:45:00',2.46),('15087','2013-10-24','12:50:00',2.02),('15087','2013-10-24','12:55:00',3.09),('15087','2013-10-24','13:00:00',3.41),('15087','2013-10-24','13:05:00',3.34),('15087','2013-10-24','13:10:00',2.74),('15087','2013-10-24','13:15:00',2.39),('15087','2013-10-24','13:20:00',2.53),('15087','2013-10-24','13:25:00',1.92),('15087','2013-10-24','13:30:00',1.36),('15087','2013-10-24','13:35:00',1.31),('15087','2013-10-24','13:40:00',1.34),('15087','2013-10-24','13:45:00',1.46),('15087','2013-10-24','13:50:00',1.91),('15087','2013-10-24','13:55:00',2.38),('15087','2013-10-24','14:00:00',2.28),('15087','2013-10-24','14:05:00',1.54),('15087','2013-10-24','14:10:00',1.4),('15087','2013-10-24','14:15:00',1.34),('15087','2013-10-24','14:20:00',1.48),('15087','2013-10-24','14:25:00',1.49),('15087','2013-10-24','14:30:00',1.56),('15087','2013-10-24','14:35:00',1.84),('15087','2013-10-24','14:40:00',2.06),('15087','2013-10-24','14:45:00',2.14),('15087','2013-10-24','14:50:00',1.55),('15087','2013-10-24','15:05:00',1.33),('15087','2013-10-24','15:10:00',1.81),('15087','2013-10-24','15:15:00',1.11),('15087','2013-10-24','15:20:00',1.26),('15087','2013-10-24','15:30:00',1.32),('15087','2013-10-24','15:35:00',2),('15087','2013-10-24','15:40:00',1.83),('15087','2013-10-24','15:45:00',1.74),('15087','2013-10-24','15:50:00',1.08),('15087','2013-10-23','10:20:00',1.13),('15087','2013-10-23','10:25:00',1.21),('15087','2013-10-23','10:30:00',1.16),('15087','2013-10-23','10:35:00',1.12),('15087','2013-10-23','10:40:00',1.24),('15087','2013-10-23','10:45:00',1.17),('15087','2013-10-23','10:50:00',1.34),('15087','2013-10-23','10:55:00',1.36),('15087','2013-10-23','11:00:00',1.45),('15087','2013-10-23','11:05:00',1.78),('15087','2013-10-23','11:10:00',1.72),('15087','2013-10-23','11:15:00',1.56),('15087','2013-10-23','11:20:00',2.87),('15087','2013-10-23','11:25:00',2.89),('15087','2013-10-23','11:30:00',3.01),('15087','2013-10-23','11:35:00',2.81),('15087','2013-10-23','11:40:00',2.97),('15087','2013-10-23','11:45:00',2.93),('15087','2013-10-23','11:50:00',3.03),('15087','2013-10-23','11:55:00',2.96),('15087','2013-10-23','12:00:00',2.9),('15087','2013-10-23','12:05:00',2.82),('15087','2013-10-23','12:10:00',2.73),('15087','2013-10-23','12:15:00',2.63),('15087','2013-10-23','12:20:00',2.89),('15087','2013-10-23','12:25:00',2.93),('15087','2013-10-23','12:30:00',2.97),('15087','2013-10-23','12:35:00',3.03),('15087','2013-10-23','12:40:00',2.9),('15087','2013-10-23','12:45:00',2.91),('15087','2013-10-23','12:50:00',1.91),('15087','2013-10-23','12:55:00',2.09),('15087','2013-10-23','13:00:00',2.76),('15087','2013-10-23','13:05:00',2.94),('15087','2013-10-23','13:10:00',2.85),('15087','2013-10-23','13:15:00',2.82),('15087','2013-10-23','13:20:00',2.92),('15087','2013-10-23','13:25:00',2.87),('15087','2013-10-23','13:30:00',2.68),('15087','2013-10-23','13:35:00',2.65),('15087','2013-10-23','13:40:00',2.65),('15087','2013-10-23','13:45:00',2.55),('15087','2013-10-23','13:50:00',2.3),('15087','2013-10-23','13:55:00',2.25),('15087','2013-10-23','14:00:00',2.39),('15087','2013-10-23','14:05:00',2.54),('15087','2013-10-23','14:10:00',2.41),('15087','2013-10-23','14:15:00',2.27),('15087','2013-10-23','14:20:00',2.27),('15087','2013-10-23','14:25:00',2.21),('15087','2013-10-23','14:30:00',2.12),('15087','2013-10-23','14:35:00',2.08),('15087','2013-10-23','14:40:00',2.23),('15087','2013-10-23','14:45:00',2.16),('15087','2013-10-23','14:50:00',2.08),('15087','2013-10-23','14:55:00',2.09),('15087','2013-10-23','15:00:00',2.09),('15087','2013-10-23','15:05:00',2.01),('15087','2013-10-23','15:10:00',1.8),('15087','2013-10-23','15:15:00',1.8),('15087','2013-10-23','15:20:00',1.82),('15087','2013-10-23','15:25:00',1.81),('15087','2013-10-23','15:30:00',1.61),('15087','2013-10-23','15:35:00',1.49),('15087','2013-10-23','15:40:00',1.63),('15087','2013-10-23','15:45:00',1.52),('15087','2013-10-23','15:50:00',1.43),('15087','2013-10-23','15:55:00',1.21),('15087','2013-10-22','09:00:00',1.01),('15087','2013-10-22','09:05:00',1.08),('15087','2013-10-22','09:10:00',1.14),('15087','2013-10-22','09:15:00',1.21),('15087','2013-10-22','09:20:00',1.29),('15087','2013-10-22','09:25:00',1.37),('15087','2013-10-22','09:30:00',1.45),('15087','2013-10-22','09:35:00',1.54),('15087','2013-10-22','09:40:00',1.61),('15087','2013-10-22','09:45:00',1.71),('15087','2013-10-22','09:50:00',1.78),('15087','2013-10-22','09:55:00',1.88),('15087','2013-10-22','10:00:00',1.94),('15087','2013-10-22','10:05:00',2.04),('15087','2013-10-22','10:10:00',2.09),('15087','2013-10-22','10:15:00',2.17),('15087','2013-10-22','10:20:00',2.24),('15087','2013-10-22','10:25:00',2.3),('15087','2013-10-22','10:30:00',2.35),('15087','2013-10-22','10:35:00',2.4),('15087','2013-10-22','10:40:00',2.42),('15087','2013-10-22','10:45:00',2.5),('15087','2013-10-22','10:50:00',2.55),('15087','2013-10-22','10:55:00',2.6),('15087','2013-10-22','11:00:00',2.65),('15087','2013-10-22','11:05:00',2.67),('15087','2013-10-22','11:10:00',2.7),('15087','2013-10-22','11:15:00',2.69),('15087','2013-10-22','11:20:00',2.72),('15087','2013-10-22','11:25:00',2.74),('15087','2013-10-22','11:30:00',2.81),('15087','2013-10-22','11:35:00',2.79),('15087','2013-10-22','11:40:00',2.8),('15087','2013-10-22','11:45:00',2.82),('15087','2013-10-22','11:50:00',2.86),('15087','2013-10-22','11:55:00',2.9),('15087','2013-10-22','12:00:00',2.93),('15087','2013-10-22','12:05:00',2.91),('15087','2013-10-22','12:10:00',2.96),('15087','2013-10-22','12:15:00',2.94),('15087','2013-10-22','12:20:00',2.88),('15087','2013-10-22','12:25:00',2.95),('15087','2013-10-22','12:30:00',3.01),('15087','2013-10-22','12:35:00',3.04),('15087','2013-10-22','12:40:00',2.96),('15087','2013-10-22','12:45:00',2.96),('15087','2013-10-22','12:50:00',2.99),('15087','2013-10-22','12:55:00',2.92),('15087','2013-10-22','13:00:00',2.91),('15087','2013-10-22','13:05:00',2.93),('15087','2013-10-22','13:10:00',2.92),('15087','2013-10-22','13:15:00',2.98),('15087','2013-10-22','13:20:00',2.94),('15087','2013-10-22','13:25:00',2.94),('15087','2013-10-22','13:30:00',2.79),('15087','2013-10-22','13:35:00',2.82),('15087','2013-10-22','13:40:00',2.59),('15087','2013-10-22','13:45:00',2.59),('15087','2013-10-22','13:50:00',2.74),('15087','2013-10-22','13:55:00',2.5),('15087','2013-10-22','14:00:00',2.51),('15087','2013-10-22','14:05:00',2.73),('15087','2013-10-22','14:10:00',2.74),('15087','2013-10-22','14:15:00',2.76),('15087','2013-10-22','14:20:00',2.79),('15087','2013-10-22','14:25:00',2.84),('15087','2013-10-22','14:30:00',2.63),('15087','2013-10-22','14:35:00',2.47),('15087','2013-10-22','14:40:00',2.33),('15087','2013-10-22','14:45:00',2.28),('15087','2013-10-22','14:50:00',2.19),('15087','2013-10-22','14:55:00',2.11),('15087','2013-10-22','15:00:00',2.09),('15087','2013-10-22','15:05:00',1.99),('15087','2013-10-22','15:10:00',1.89),('15087','2013-10-22','15:15:00',1.85),('15087','2013-10-22','15:20:00',1.78),('15087','2013-10-22','15:25:00',1.68),('15087','2013-10-22','15:30:00',1.68),('15087','2013-10-22','15:35:00',1.67),('15087','2013-10-22','15:40:00',1.65),('15087','2013-10-22','15:45:00',1.37),('15087','2013-10-22','15:50:00',1.45),('15087','2013-10-22','15:55:00',1.4),('15087','2013-10-22','16:00:00',1.3),('15087','2013-10-22','16:05:00',1.26),('15087','2013-10-22','16:10:00',1.17),('15087','2013-10-22','16:15:00',1.1),('15087','2013-10-22','16:20:00',1.03),('15087','2013-10-22','16:25:00',1.01),('15087','2013-10-21','09:10:00',1.09),('15087','2013-10-21','09:15:00',1.21),('15087','2013-10-21','09:20:00',1.48),('15087','2013-10-21','09:25:00',1.51),('15087','2013-10-21','09:30:00',1.39),('15087','2013-10-21','09:35:00',1.35),('15087','2013-10-21','09:40:00',1.58),('15087','2013-10-21','09:45:00',1.42),('15087','2013-10-21','09:50:00',1.58),('15087','2013-10-21','09:55:00',1.83),('15087','2013-10-21','10:00:00',1.74),('15087','2013-10-21','10:05:00',2.15),('15087','2013-10-21','10:10:00',2.18),('15087','2013-10-21','10:15:00',2.27),('15087','2013-10-21','10:20:00',2.28),('15087','2013-10-21','10:25:00',2.41),('15087','2013-10-21','10:30:00',2.34),('15087','2013-10-21','10:35:00',2.4),('15087','2013-10-21','10:40:00',2.36),('15087','2013-10-21','10:45:00',2.4),('15087','2013-10-21','10:50:00',2.57),('15087','2013-10-21','10:55:00',2.53),('15087','2013-10-21','11:00:00',2.78),('15087','2013-10-21','11:05:00',2.36),('15087','2013-10-21','11:10:00',2.52),('15087','2013-10-21','11:15:00',2.87),('15087','2013-10-21','11:20:00',2.83),('15087','2013-10-21','11:25:00',2.83),('15087','2013-10-21','11:30:00',2.96),('15087','2013-10-21','11:35:00',2.91),('15087','2013-10-21','11:40:00',2.9),('15087','2013-10-21','11:45:00',3),('15087','2013-10-21','11:50:00',3.06),('15087','2013-10-21','11:55:00',3.08),('15087','2013-10-21','12:00:00',3.16),('15087','2013-10-21','12:05:00',3.2),('15087','2013-10-21','12:10:00',3.22),('15087','2013-10-21','12:15:00',3.17),('15087','2013-10-21','12:20:00',3.16),('15087','2013-10-21','12:25:00',3.14),('15087','2013-10-21','12:30:00',3.04),('15087','2013-10-21','12:35:00',3.2),('15087','2013-10-21','12:40:00',3.24),('15087','2013-10-21','12:45:00',3.22),('15087','2013-10-21','12:50:00',3.21),('15087','2013-10-21','12:55:00',3.2),('15087','2013-10-21','13:00:00',3.15),('15087','2013-10-21','13:05:00',3.1),('15087','2013-10-21','13:10:00',3.04),('15087','2013-10-21','13:15:00',3.09),('15087','2013-10-21','13:20:00',3.02),('15087','2013-10-21','13:25:00',2.94),('15087','2013-10-21','13:30:00',3),('15087','2013-10-21','13:35:00',3.07),('15087','2013-10-21','13:40:00',2.85),('15087','2013-10-21','13:45:00',2.82),('15087','2013-10-21','13:50:00',2.82),('15087','2013-10-21','13:55:00',2.69),('15087','2013-10-21','14:00:00',2.67),('15087','2013-10-21','14:05:00',2.77),('15087','2013-10-21','14:10:00',2.64),('15087','2013-10-21','14:15:00',2.55),('15087','2013-10-21','14:20:00',2.58),('15087','2013-10-21','14:25:00',2.45),('15087','2013-10-21','14:30:00',2.41),('15087','2013-10-21','14:35:00',2.39),('15087','2013-10-21','14:40:00',2.24),('15087','2013-10-21','14:45:00',2.18),('15087','2013-10-21','14:50:00',2.14),('15087','2013-10-21','14:55:00',2.11),('15087','2013-10-21','15:00:00',2.07),('15087','2013-10-21','15:05:00',2.11),('15087','2013-10-21','15:10:00',1.95),('15087','2013-10-21','15:15:00',1.81),('15087','2013-10-21','15:20:00',1.84),('15087','2013-10-21','15:25:00',1.72),('15087','2013-10-21','15:30:00',1.64),('15087','2013-10-21','15:35:00',1.62),('15087','2013-10-21','15:40:00',1.58),('15087','2013-10-21','15:45:00',1.55),('15087','2013-10-21','15:50:00',1.51),('15087','2013-10-21','15:55:00',1.41),('15087','2013-10-21','16:00:00',1.4),('15087','2013-10-21','16:05:00',1.36),('15087','2013-10-21','16:10:00',1.29),('15087','2013-10-21','16:15:00',1.2),('15087','2013-10-21','16:20:00',1.12),('15087','2013-10-21','16:25:00',1.04),('15087','2013-10-20','08:55:00',1.04),('15087','2013-10-20','09:00:00',1.08),('15087','2013-10-20','09:05:00',1.17),('15087','2013-10-20','09:10:00',1.3),('15087','2013-10-20','09:15:00',1.37),('15087','2013-10-20','09:20:00',1.48),('15087','2013-10-20','09:25:00',1.54),('15087','2013-10-20','09:30:00',1.61),('15087','2013-10-20','09:35:00',1.68),('15087','2013-10-20','09:40:00',1.77),('15087','2013-10-20','09:45:00',1.82),('15087','2013-10-20','09:50:00',1.89),('15087','2013-10-20','09:55:00',1.97),('15087','2013-10-20','10:00:00',2.09),('15087','2013-10-20','10:05:00',2.19),('15087','2013-10-20','10:10:00',2.26),('15087','2013-10-20','10:15:00',2.32),('15087','2013-10-20','10:20:00',2.36),('15087','2013-10-20','10:25:00',2.44),('15087','2013-10-20','10:30:00',2.49),('15087','2013-10-20','10:35:00',2.55),('15087','2013-10-20','10:40:00',2.59),('15087','2013-10-20','10:45:00',2.65),('15087','2013-10-20','10:50:00',2.69),('15087','2013-10-20','10:55:00',2.77),('15087','2013-10-20','11:00:00',2.81),('15087','2013-10-20','11:05:00',2.85),('15087','2013-10-20','11:10:00',2.87),('15087','2013-10-20','11:15:00',2.91),('15087','2013-10-20','11:20:00',2.97),('15087','2013-10-20','11:25:00',3),('15087','2013-10-20','11:30:00',3.07),('15087','2013-10-20','11:35:00',3.11),('15087','2013-10-20','11:40:00',3.12),('15087','2013-10-20','11:45:00',3.13),('15087','2013-10-20','11:50:00',3.16),('15087','2013-10-20','11:55:00',3.13),('15087','2013-10-20','12:00:00',3.1),('15087','2013-10-20','12:05:00',3.22),('15087','2013-10-20','12:10:00',3.24),('15087','2013-10-20','12:15:00',2.6),('15087','2013-10-20','12:20:00',2.4),('15087','2013-10-20','12:25:00',2.66),('15087','2013-10-20','12:30:00',3.64),('15087','2013-10-20','12:35:00',2.1),('15087','2013-10-20','12:40:00',1.21),('15087','2013-10-20','12:45:00',2.6),('15087','2013-10-20','12:50:00',2.28),('15087','2013-10-20','12:55:00',1.78),('15087','2013-10-20','13:00:00',3.2),('15087','2013-10-20','13:05:00',1.95),('15087','2013-10-20','13:10:00',1.97),('15087','2013-10-20','13:15:00',1.11),('15087','2013-10-20','13:20:00',1.99),('15087','2013-10-20','13:25:00',1.88),('15087','2013-10-20','13:30:00',1.12),('15087','2013-10-20','13:35:00',1.09),('15087','2013-10-20','13:40:00',2.07),('15087','2013-10-20','13:45:00',1.65),('15087','2013-10-20','13:50:00',1.11),('15087','2013-10-20','13:55:00',1.29),('15087','2013-10-20','14:10:00',1.01),('15087','2013-10-20','16:35:00',1.03),('15087','2013-10-20','16:50:00',1.18),('15087','2013-10-20','16:55:00',1.16),('15087','2013-10-20','17:00:00',1.05),('15087','2013-10-19','08:50:00',1.15),('15087','2013-10-19','09:00:00',1.03),('15087','2013-10-19','09:05:00',1.09),('15087','2013-10-19','09:10:00',1.38),('15087','2013-10-19','09:15:00',1.74),('15087','2013-10-19','09:20:00',1.82),('15087','2013-10-19','09:25:00',1.86),('15087','2013-10-19','09:30:00',1.89),('15087','2013-10-19','09:35:00',1.97),('15087','2013-10-19','09:40:00',2.11),('15087','2013-10-19','09:45:00',2.19),('15087','2013-10-19','09:50:00',2.3),('15087','2013-10-19','09:55:00',2.41),('15087','2013-10-19','10:00:00',2.37),('15087','2013-10-19','10:05:00',2.36),('15087','2013-10-19','10:10:00',2.52),('15087','2013-10-19','10:15:00',2.44),('15087','2013-10-19','10:20:00',2.58),('15087','2013-10-19','10:25:00',2.81),('15087','2013-10-19','10:30:00',2.87),('15087','2013-10-19','10:35:00',2.88),('15087','2013-10-19','10:40:00',2.92),('15087','2013-10-19','10:45:00',2.9),('15087','2013-10-19','10:50:00',2.95),('15087','2013-10-19','10:55:00',3.09),('15087','2013-10-19','11:00:00',2.86),('15087','2013-10-19','11:05:00',2.87),('15087','2013-10-19','11:10:00',1.14),('15087','2013-10-19','11:15:00',1.28),('15087','2013-10-19','11:20:00',2.83),('15087','2013-10-19','11:25:00',3.4),('15087','2013-10-19','11:30:00',3.44),('15087','2013-10-19','11:35:00',3.4),('15087','2013-10-19','11:40:00',3.26),('15087','2013-10-19','11:45:00',3.44),('15087','2013-10-19','11:50:00',3.07),('15087','2013-10-19','11:55:00',3.45),('15087','2013-10-19','12:00:00',3.51),('15087','2013-10-19','12:05:00',3.52),('15087','2013-10-19','12:10:00',3.47),('15087','2013-10-19','12:15:00',3.49),('15087','2013-10-19','12:20:00',3.43),('15087','2013-10-19','12:25:00',3.21),('15087','2013-10-19','12:30:00',3.48),('15087','2013-10-19','12:35:00',3.56),('15087','2013-10-19','12:40:00',3.68),('15087','2013-10-19','12:45:00',3.76),('15087','2013-10-19','12:50:00',3.75),('15087','2013-10-19','12:55:00',3.89),('15087','2013-10-19','13:00:00',4.02),('15087','2013-10-19','13:05:00',3.26),('15087','2013-10-19','13:10:00',3.56),('15087','2013-10-19','13:15:00',3.35),('15087','2013-10-19','13:20:00',3.38),('15087','2013-10-19','13:25:00',3.45),('15087','2013-10-19','13:30:00',3.61),('15087','2013-10-19','13:35:00',2.62),('15087','2013-10-19','13:40:00',2.3),('15087','2013-10-19','13:45:00',2.23),('15087','2013-10-19','13:50:00',2.79),('15087','2013-10-19','13:55:00',3.41),('15087','2013-10-19','14:00:00',2.8),('15087','2013-10-19','14:05:00',2.35),('15087','2013-10-19','14:10:00',1.84),('15087','2013-10-19','14:15:00',2.48),('15087','2013-10-19','14:20:00',1.88),('15087','2013-10-19','14:25:00',1.72),('15087','2013-10-19','14:30:00',2.38),('15087','2013-10-19','14:35:00',2.73),('15087','2013-10-19','14:40:00',2.43),('15087','2013-10-19','14:45:00',2.05),('15087','2013-10-19','14:50:00',2.67),('15087','2013-10-19','14:55:00',2.6),('15087','2013-10-19','15:00:00',2.52),('15087','2013-10-19','15:05:00',2.24),('15087','2013-10-19','15:10:00',2.35),('15087','2013-10-19','15:15:00',2.11),('15087','2013-10-19','15:20:00',1.87),('15087','2013-10-19','15:25:00',1.99),('15087','2013-10-19','15:30:00',1.82),('15087','2013-10-19','15:35:00',1.79),('15087','2013-10-19','15:40:00',1.71),('15087','2013-10-19','15:45:00',1.41),('15087','2013-10-19','15:50:00',1.57),('15087','2013-10-19','15:55:00',1.77),('15087','2013-10-19','16:00:00',1.43),('15087','2013-10-19','16:05:00',1.55),('15087','2013-10-19','16:10:00',1.41),('15087','2013-10-19','16:15:00',1.5),('15087','2013-10-19','16:20:00',1.25),('15087','2013-10-19','16:25:00',1.02),('15087','2013-10-19','16:30:00',1.23),('15087','2013-10-19','16:35:00',1.15),('15087','2013-10-19','16:40:00',1.18),('15087','2013-10-19','16:45:00',1.07),('15087','2014-05-04','07:45:00',1.37),('15087','2014-05-04','07:50:00',1.45),('15087','2014-05-04','07:55:00',1.53),('15087','2014-05-04','08:00:00',1.61),('15087','2014-05-04','08:05:00',1.76),('15087','2014-05-04','08:10:00',1.83),('15087','2014-05-04','08:15:00',1.96),('15087','2014-05-04','08:20:00',2.08),('15087','2014-05-04','08:25:00',2.17),('15087','2014-05-04','08:30:00',2.19),('15087','2014-05-04','08:35:00',2.6),('15087','2014-05-04','08:40:00',1.65),('15087','2014-05-04','08:45:00',1.38),('15087','2014-05-04','08:50:00',1.66),('15087','2014-05-04','08:55:00',1.21),('15087','2014-05-04','09:00:00',1.41),('15087','2014-05-04','09:05:00',2.24),('15087','2014-05-04','09:10:00',2.27),('15087','2014-05-04','09:15:00',2.22),('15087','2014-05-04','09:20:00',3.74),('15087','2014-05-04','09:25:00',3.9),('15087','2014-05-04','09:30:00',2.31),('15087','2014-05-04','09:35:00',1.31),('15087','2014-05-04','09:40:00',1.56),('15087','2014-05-04','09:45:00',2.42),('15087','2014-05-04','09:50:00',2.27),('15087','2014-05-04','09:55:00',2.25),('15087','2014-05-04','10:00:00',3.97),('15087','2014-05-04','10:05:00',4.16),('15087','2014-05-04','10:10:00',3.37),('15087','2014-05-04','10:15:00',2.89),('15087','2014-05-04','10:20:00',2.15),('15087','2014-05-04','10:25:00',2.15),('15087','2014-05-04','10:30:00',2.35),('15087','2014-05-04','10:35:00',2.41),('15087','2014-05-04','10:40:00',2.49),('15087','2014-05-04','10:45:00',2.88),('15087','2014-05-04','10:50:00',3.14),('15087','2014-05-04','10:55:00',2.87),('15087','2014-05-04','11:00:00',2.66),('15087','2014-05-04','11:05:00',2.74),('15087','2014-05-04','11:10:00',4.68),('15087','2014-05-04','11:15:00',4.2),('15087','2014-05-04','11:20:00',5.03),('15087','2014-05-04','11:25:00',5.02),('15087','2014-05-04','11:30:00',4.58),('15087','2014-05-04','11:35:00',4.02),('15087','2014-05-04','11:40:00',3.43),('15087','2014-05-04','11:45:00',4.32),('15087','2014-05-04','11:50:00',3.83),('15087','2014-05-04','11:55:00',4.28),('15087','2014-05-04','12:00:00',3.03),('15087','2014-05-04','12:05:00',2.44),('15087','2014-05-04','12:10:00',2.03),('15087','2014-05-04','12:15:00',1.85),('15087','2014-05-04','12:20:00',1.75),('15087','2014-05-04','12:25:00',1.98),('15087','2014-05-04','12:30:00',3.73),('15087','2014-05-04','12:35:00',5.75),('15087','2014-05-04','12:40:00',3.75),('15087','2014-05-04','12:45:00',3.37),('15087','2014-05-04','12:50:00',1.89),('15087','2014-05-04','12:55:00',2.16),('15087','2014-05-04','13:00:00',2.82),('15087','2014-05-04','13:05:00',1.86),('15087','2014-05-04','13:10:00',1.97),('15087','2014-05-04','13:15:00',1.93),('15087','2014-05-04','13:20:00',1.78),('15087','2014-05-04','13:25:00',1.72),('15087','2014-05-04','13:30:00',1.65),('15087','2014-05-04','13:35:00',1.8),('15087','2014-05-04','13:40:00',1.76),('15087','2014-05-04','13:45:00',1.54),('15087','2014-05-04','13:50:00',1.44),('15087','2014-05-04','13:55:00',1.51),('15087','2014-05-04','14:00:00',1.54),('15087','2014-05-04','14:05:00',1.58),('15087','2014-05-04','14:10:00',1.51),('15087','2014-05-04','14:15:00',1.39),('15087','2014-05-04','14:20:00',1.02),('15087','2014-05-04','14:50:00',1.24),('15087','2014-05-04','14:55:00',1.92),('15087','2014-05-04','15:00:00',2.2),('15087','2014-05-04','15:05:00',2.43),('15087','2014-05-04','15:10:00',3.68),('15087','2014-05-04','15:15:00',2.54),('15087','2014-05-04','15:20:00',2.21),('15087','2014-05-04','15:25:00',1.74),('15087','2014-05-04','15:30:00',1.4),('15087','2014-05-04','15:50:00',1.18),('15087','2014-05-04','15:55:00',1.23),('15087','2014-05-04','16:00:00',1.08),('15087','2014-05-04','16:05:00',1.13),('15087','2014-05-04','16:10:00',1.38),('15087','2014-05-04','16:15:00',1.31),('15087','2014-05-04','16:20:00',1.08),('15087','2014-05-04','17:35:00',1.05),('15087','2014-05-04','17:40:00',1.11),('15087','2014-04-16','07:55:00',1.03),('15087','2014-04-16','08:00:00',1.13),('15087','2014-04-16','08:05:00',1.26),('15087','2014-04-16','08:10:00',1.41),('15087','2014-04-16','08:15:00',1.54),('15087','2013-10-17','08:45:00',1.04),('15087','2013-10-17','08:50:00',1.11),('15087','2013-10-17','08:55:00',1.19),('15087','2013-10-17','09:00:00',1.28),('15087','2013-10-17','09:05:00',1.38),('15087','2013-10-17','09:10:00',1.48),('15087','2013-10-17','09:15:00',1.57),('15087','2013-10-17','09:20:00',1.66),('15087','2013-10-17','09:25:00',1.77),('15087','2013-10-17','09:30:00',1.85),('15087','2013-10-17','09:35:00',1.96),('15087','2013-10-17','09:40:00',2.04),('15087','2013-10-17','09:45:00',2.14),('15087','2013-10-17','09:50:00',2.22),('15087','2013-10-17','09:55:00',2.3),('15087','2013-10-17','10:00:00',2.36),('15087','2013-10-17','10:05:00',2.41),('15087','2013-10-17','10:10:00',2.49),('15087','2013-10-17','10:15:00',2.58),('15087','2013-10-17','10:20:00',2.65),('15087','2013-10-17','10:25:00',2.71),('15087','2013-10-17','10:30:00',2.76),('15087','2013-10-17','10:35:00',2.82),('15087','2013-10-17','10:40:00',2.89),('15087','2013-10-17','10:45:00',2.97),('15087','2013-10-17','10:50:00',3.03),('15087','2013-10-17','10:55:00',3.07),('15087','2013-10-17','11:00:00',3.1),('15087','2013-10-17','11:05:00',3.14),('15087','2013-10-17','11:10:00',3.18),('15087','2013-10-17','11:15:00',3.24),('15087','2013-10-17','11:20:00',3.28),('15087','2013-10-17','11:25:00',3.3),('15087','2013-10-17','11:30:00',3.34),('15087','2013-10-17','11:35:00',3.38),('15087','2013-10-17','11:40:00',3.41),('15087','2013-10-17','11:45:00',3.4),('15087','2013-10-17','11:50:00',3.41),('15087','2013-10-17','11:55:00',3.45),('15087','2013-10-17','12:00:00',3.49),('15087','2013-10-17','12:05:00',3.5),('15087','2013-10-17','12:10:00',3.5),('15087','2013-10-17','12:15:00',3.51),('15087','2013-10-17','12:20:00',3.52),('15087','2013-10-17','12:25:00',3.53),('15087','2013-10-17','12:30:00',3.51),('15087','2013-10-17','12:35:00',3.55),('15087','2013-10-17','12:40:00',3.59),('15087','2013-10-17','12:45:00',3.6),('15087','2013-10-17','12:50:00',3.6),('15087','2013-10-17','12:55:00',3.59),('15087','2013-10-17','13:00:00',3.58),('15087','2013-10-17','13:05:00',3.56),('15087','2013-10-17','13:10:00',3.55),('15087','2013-10-17','13:15:00',3.54),('15087','2013-10-17','13:20:00',3.5),('15087','2013-10-17','13:25:00',3.29),('15087','2013-10-17','13:30:00',3.13),('15087','2013-10-17','13:35:00',3.41),('15087','2013-10-17','13:40:00',3.19),('15087','2013-10-17','13:45:00',2.96),('15087','2013-10-17','13:50:00',3.29),('15087','2013-10-17','13:55:00',3.11),('15087','2013-10-17','14:00:00',2.94),('15087','2013-10-17','14:05:00',3.11),('15087','2013-10-17','14:10:00',3.12),('15087','2013-10-17','14:15:00',2.9),('15087','2013-10-17','14:20:00',2.98),('15087','2013-10-17','14:25:00',2.87),('15087','2013-10-17','14:30:00',2.71),('15087','2013-10-17','14:35:00',2.77),('15087','2013-10-17','14:40:00',2.69),('15087','2013-10-17','14:45:00',2.64),('15087','2013-10-17','14:50:00',2.59),('15087','2013-10-17','14:55:00',2.53),('15087','2013-10-17','15:00:00',2.44),('15087','2013-10-17','15:05:00',2.45),('15087','2013-10-17','15:10:00',2.4),('15087','2013-10-17','15:15:00',2.04),('15087','2013-10-17','15:20:00',2.1),('15087','2013-10-17','15:25:00',2),('15087','2013-10-17','15:30:00',1.72),('15087','2013-10-17','15:35:00',1.93),('15087','2013-10-17','15:40:00',1.79),('15087','2013-10-17','15:45:00',1.65),('15087','2013-10-17','15:50:00',1.7),('15087','2013-10-17','15:55:00',1.56),('15087','2013-10-17','16:00:00',1.55),('15087','2013-10-17','16:05:00',1.58),('15087','2013-10-17','16:10:00',1.49),('15087','2013-10-17','16:15:00',1.42),('15087','2013-10-17','16:20:00',1.33),('15087','2013-10-17','16:25:00',1.22),('15087','2013-10-17','16:30:00',1.13),('15087','2013-10-17','16:35:00',1.07),('15087','2013-10-17','16:40:00',1.01),('15087','2013-10-16','09:45:00',1.7),('15087','2013-10-16','09:50:00',1.48),('15087','2013-10-16','11:15:00',1.35),('15087','2013-10-16','11:55:00',1.21),('15087','2013-10-16','12:10:00',1.62),('15087','2013-10-16','12:15:00',3.49),('15087','2013-10-16','12:20:00',1.84),('15087','2013-10-16','12:30:00',1.38),('15087','2013-10-16','12:35:00',1.41),('15087','2013-10-16','12:40:00',4.05),('15087','2013-10-16','12:45:00',2.9),('15087','2013-10-16','12:50:00',3.55),('15087','2013-10-16','12:55:00',2.15),('15087','2013-10-16','13:00:00',2.55),('15087','2013-10-16','13:05:00',3.82),('15087','2013-10-16','13:10:00',3.1),('15087','2013-10-16','13:20:00',2.75),('15087','2013-10-16','13:25:00',3.65),('15087','2013-10-16','13:30:00',3.5),('15087','2013-10-16','13:35:00',3.44),('15087','2013-10-16','13:40:00',2.42),('15087','2013-10-16','13:45:00',3.36),('15087','2013-10-16','13:50:00',3.1),('15087','2013-10-16','13:55:00',3.39),('15087','2013-10-16','14:00:00',2.03),('15087','2013-10-16','14:05:00',2.15),('15087','2013-10-16','14:10:00',3.45),('15087','2013-10-16','14:15:00',2.66),('15087','2013-10-16','14:20:00',1.86),('15087','2013-10-16','14:25:00',3.26),('15087','2013-10-16','14:30:00',2.99),('15087','2013-10-16','14:35:00',2.78),('15087','2013-10-16','14:40:00',2.52),('15087','2013-10-16','14:45:00',1.84),('15087','2013-10-16','14:50:00',2.49),('15087','2013-10-16','14:55:00',2.38),('15087','2013-10-16','15:00:00',2.58),('15087','2013-10-16','15:05:00',1.83),('15087','2013-10-16','15:10:00',2.15),('15087','2013-10-16','15:15:00',2.15),('15087','2013-10-16','15:20:00',1.98),('15087','2013-10-16','15:25:00',1.49),('15087','2013-10-16','15:35:00',1.52),('15087','2013-10-16','15:40:00',2.05),('15087','2013-10-16','15:45:00',1.83),('15087','2013-10-16','15:50:00',1.74),('15087','2013-10-16','15:55:00',1.73),('15087','2013-10-16','16:00:00',1.71),('15087','2013-10-16','16:05:00',1.65),('15087','2013-10-16','16:10:00',1.52),('15087','2013-10-16','16:15:00',1.42),('15087','2013-10-16','16:20:00',1.32),('15087','2013-10-16','16:25:00',1.26),('15087','2013-10-16','16:30:00',1.17),('15087','2013-10-16','16:40:00',1.04),('15087','2013-10-15','09:10:00',1.01),('15087','2013-10-15','09:20:00',1.06),('15087','2013-10-15','09:25:00',1.11),('15087','2013-10-15','09:30:00',1.59),('15087','2013-10-15','09:35:00',1.06),('15087','2013-10-15','09:40:00',1.45),('15087','2013-10-15','09:45:00',2.03),('15087','2013-10-15','09:50:00',2.22),('15087','2013-10-15','09:55:00',2.33),('15087','2013-10-15','10:00:00',2.3),('15087','2013-10-15','10:05:00',2.56),('15087','2013-10-15','10:10:00',1.93),('15087','2013-10-15','10:15:00',1.17),('15087','2013-10-15','10:20:00',1.18),('15087','2013-10-15','10:25:00',1.58),('15087','2013-10-15','10:30:00',2.01),('15087','2013-10-15','10:35:00',1.7),('15087','2013-10-15','10:40:00',2.07),('15087','2013-10-15','10:45:00',2.42),('15087','2013-10-15','10:50:00',2.29),('15087','2013-10-15','10:55:00',2),('15087','2013-10-15','11:00:00',1.97),('15087','2013-10-15','11:05:00',2.16),('15087','2013-10-15','11:10:00',2.79),('15087','2013-10-15','11:15:00',3.02),('15087','2013-10-15','11:20:00',3.07),('15087','2013-10-15','11:25:00',2.85),('15087','2013-10-15','11:30:00',2.97),('15087','2013-10-15','11:35:00',2.48),('15087','2013-10-15','11:40:00',1.96),('15087','2013-10-15','11:45:00',1.55),('15087','2013-10-15','11:50:00',1.48),('15087','2013-10-15','11:55:00',1.48),('15087','2013-10-15','12:00:00',1.53),('15087','2013-10-15','12:05:00',1.54),('15087','2013-10-15','12:10:00',1.57),('15087','2013-10-15','12:15:00',1.54),('15087','2013-10-15','12:20:00',1.62),('15087','2013-10-15','12:25:00',1.45),('15087','2013-10-15','12:30:00',1.33),('15087','2013-10-15','12:35:00',1.3),('15087','2013-10-15','12:40:00',1.3),('15087','2013-10-15','12:45:00',1.44),('15087','2013-10-15','12:50:00',1.38),('15087','2013-10-15','12:55:00',1.24),('15087','2013-10-15','13:00:00',1.23),('15087','2013-10-15','13:05:00',1.67),('15087','2013-10-15','13:10:00',1.91),('15087','2013-10-15','13:15:00',1.96),('15087','2013-10-15','13:20:00',2.88),('15087','2013-10-15','13:25:00',3.21),('15087','2013-10-15','13:30:00',2),('15087','2013-10-15','13:35:00',1.66),('15087','2013-10-15','13:40:00',1.55),('15087','2013-10-15','13:45:00',1.65),('15087','2013-10-15','13:50:00',1.5),('15087','2013-10-15','13:55:00',1.32),('15087','2013-10-15','14:00:00',1.2),('15087','2013-10-15','14:05:00',1.19),('15087','2013-10-15','14:10:00',1.33),('15087','2013-10-15','14:15:00',1.88),('15087','2013-10-15','14:20:00',2.08),('15087','2013-10-15','14:25:00',2.31),('15087','2013-10-15','14:30:00',2.09),('15087','2013-10-15','14:35:00',1.42),('15087','2013-10-15','14:40:00',2.07),('15087','2013-10-15','14:45:00',2.06),('15087','2013-10-15','14:50:00',2.51),('15087','2013-10-15','14:55:00',1.95),('15087','2013-10-15','15:00:00',1.3),('15087','2013-10-15','15:05:00',1.34),('15087','2013-10-15','15:10:00',1.37),('15087','2013-10-15','15:15:00',1.25),('15087','2013-10-15','15:20:00',1.13),('15087','2013-10-15','15:25:00',1.02),('15087','2013-10-15','15:35:00',1.03),('15087','2013-10-15','15:40:00',1.08),('15087','2013-10-15','15:45:00',1.04),('15087','2013-10-15','16:30:00',1.15),('15087','2013-10-15','16:35:00',1.16),('15087','2013-10-14','08:45:00',1.06),('15087','2013-10-14','08:50:00',1.03),('15087','2013-10-14','08:55:00',1.22),('15087','2013-10-14','09:00:00',1.05),('15087','2013-10-14','09:05:00',1.16),('15087','2013-10-14','09:20:00',1.06),('15087','2013-10-14','09:25:00',1.67),('15087','2013-10-14','09:30:00',1.9),('15087','2013-10-14','09:35:00',1.74),('15087','2013-10-14','09:40:00',1.58),('15087','2013-10-14','09:45:00',1.31),('15087','2013-10-14','09:50:00',1.73),('15087','2013-10-14','09:55:00',2.04),('15087','2013-10-14','10:00:00',2.02),('15087','2013-10-14','10:05:00',2.21),('15087','2013-10-14','10:10:00',2.35),('15087','2013-10-14','10:15:00',2.49),('15087','2013-10-14','10:20:00',2.54),('15087','2013-10-14','10:25:00',2.58),('15087','2013-10-14','10:30:00',2.63),('15087','2013-10-14','10:35:00',2.66),('15087','2013-10-14','10:40:00',2.62),('15087','2013-10-14','10:45:00',2.71),('15087','2013-10-14','10:50:00',2.81),('15087','2013-10-14','10:55:00',2.87),('15087','2013-10-14','11:00:00',2.92),('15087','2013-10-14','11:05:00',2.94),('15087','2013-10-14','11:10:00',3.1),('15087','2013-10-14','11:15:00',3.05),('15087','2013-10-14','11:20:00',3.09),('15087','2013-10-14','11:25:00',3.16),('15087','2013-10-14','11:30:00',3.24),('15087','2013-10-14','11:35:00',3.17),('15087','2013-10-14','11:40:00',3.2),('15087','2013-10-14','11:45:00',3.16),('15087','2013-10-14','11:50:00',3.23),('15087','2013-10-14','11:55:00',3.25),('15087','2013-10-14','12:00:00',3.26),('15087','2013-10-14','12:05:00',3.28),('15087','2013-10-14','12:10:00',3.34),('15087','2013-10-14','12:15:00',3.26),('15087','2013-10-14','12:20:00',3.01),('15087','2013-10-14','12:25:00',3.27),('15087','2013-10-14','12:30:00',3.4),('15087','2013-10-14','12:35:00',3.36),('15087','2013-10-14','12:40:00',3.38),('15087','2013-10-14','12:45:00',3.4),('15087','2013-10-14','12:50:00',3.34),('15087','2013-10-14','12:55:00',3.37),('15087','2013-10-14','13:00:00',3.34),('15087','2013-10-14','13:05:00',3.34),('15087','2013-10-14','13:10:00',3.32),('15087','2013-10-14','13:15:00',3.3),('15087','2013-10-14','13:20:00',3.32),('15087','2013-10-14','13:25:00',3.29),('15087','2013-10-14','13:30:00',3.14),('15087','2013-10-14','13:35:00',3.17),('15087','2013-10-14','13:40:00',3.18),('15087','2013-10-14','13:45:00',3),('15087','2013-10-14','13:50:00',3.07),('15087','2013-10-14','13:55:00',3.03),('15087','2013-10-14','14:00:00',2.83),('15087','2013-10-14','14:05:00',2.92),('15087','2013-10-14','14:10:00',2.95),('15087','2013-10-14','14:15:00',2.75),('15087','2013-10-14','14:20:00',2.77),('15087','2013-10-14','14:25:00',2.75),('15087','2013-10-14','14:30:00',2.63),('15087','2013-10-14','14:35:00',2.61),('15087','2013-10-14','14:40:00',2.58),('15087','2013-10-14','14:45:00',2.55),('15087','2013-10-14','14:50:00',2.52),('15087','2013-10-14','14:55:00',2.33),('15087','2013-10-14','15:00:00',2.21),('15087','2013-10-14','15:05:00',2.25),('15087','2013-10-14','15:10:00',2.11),('15087','2013-10-14','15:15:00',2.07),('15087','2013-10-14','15:20:00',2.12),('15087','2013-10-14','15:25:00',1.99),('15087','2013-10-14','15:30:00',2),('15087','2013-10-14','15:35:00',1.88),('15087','2013-10-14','15:40:00',1.61),('15087','2013-10-14','15:45:00',1.34),('15087','2013-10-14','15:50:00',1.38),('15087','2013-10-14','16:00:00',1.3),('15087','2013-10-14','16:05:00',1.03),('15087','2013-10-13','09:00:00',1.06),('15087','2013-10-13','09:05:00',1.09),('15087','2013-10-13','09:10:00',1.12),('15087','2013-10-13','09:15:00',1.76),('15087','2013-10-13','09:20:00',1.89),('15087','2013-10-13','09:25:00',1.63),('15087','2013-10-13','09:30:00',1.14),('15087','2013-10-13','09:35:00',1.52),('15087','2013-10-13','09:40:00',2.2),('15087','2013-10-13','09:45:00',2.82),('15087','2013-10-13','09:50:00',2.77),('15087','2013-10-13','09:55:00',2.84),('15087','2013-10-13','10:00:00',1.96),('15087','2013-10-13','10:05:00',1.51),('15087','2013-10-13','10:10:00',2.27),('15087','2013-10-13','10:15:00',2.36),('15087','2013-10-13','10:20:00',1.9),('15087','2013-10-13','10:25:00',2.16),('15087','2013-10-13','10:30:00',2.88),('15087','2013-10-13','10:35:00',3.3),('15087','2013-10-13','10:40:00',3.39),('15087','2013-10-13','10:45:00',3.48),('15087','2013-10-13','10:50:00',2.93),('15087','2013-10-13','10:55:00',2.43),('15087','2013-10-13','11:00:00',3.02),('15087','2013-10-13','11:05:00',3.03),('15087','2013-10-13','11:10:00',2.96),('15087','2013-10-13','11:15:00',3.35),('15087','2013-10-13','11:20:00',3.24),('15087','2013-10-13','11:25:00',3.18),('15087','2013-10-13','11:30:00',3.26),('15087','2013-10-13','11:35:00',3.24),('15087','2013-10-13','11:40:00',3.27),('15087','2013-10-13','11:45:00',3.26),('15087','2013-10-13','11:50:00',3.32),('15087','2013-10-13','11:55:00',3.32),('15087','2013-10-13','12:00:00',3.34),('15087','2013-10-13','12:05:00',3.34),('15087','2013-10-13','12:10:00',3.34),('15087','2013-10-13','12:15:00',3.39),('15087','2013-10-13','12:20:00',3.31),('15087','2013-10-13','12:25:00',3.3),('15087','2013-10-13','12:30:00',3.42),('15087','2013-10-13','12:35:00',3.45),('15087','2013-10-13','12:40:00',3.46),('15087','2013-10-13','12:45:00',3.41),('15087','2013-10-13','12:50:00',3.37),('15087','2013-10-13','12:55:00',3.34),('15087','2013-10-13','13:00:00',3.36),('15087','2013-10-13','13:05:00',3.36),('15087','2013-10-13','13:10:00',3.4),('15087','2013-10-13','13:15:00',3.44),('15087','2013-10-13','13:20:00',3.47),('15087','2013-10-13','13:25:00',3.02),('15087','2013-10-13','13:30:00',2.48),('15087','2013-10-13','13:35:00',2.72),('15087','2013-10-13','13:40:00',1.85),('15087','2013-10-13','13:45:00',2.18),('15087','2013-10-13','13:50:00',2.38),('15087','2013-10-13','13:55:00',2.39),('15087','2013-10-13','14:00:00',3.1),('15087','2013-10-13','14:05:00',3.09),('15087','2013-10-13','14:10:00',3.1),('15087','2013-10-13','14:15:00',2.8),('15087','2013-10-13','14:20:00',2.97),('15087','2013-10-13','14:25:00',2.94),('15087','2013-10-13','14:30:00',2.43),('15087','2013-10-13','14:35:00',2.3),('15087','2013-10-13','14:40:00',2.62),('15087','2013-10-13','14:45:00',2.05),('15087','2013-10-13','14:50:00',1.7),('15087','2013-10-13','14:55:00',2.09),('15087','2013-10-13','15:00:00',2.61),('15087','2013-10-13','15:05:00',2.22),('15087','2013-10-13','15:10:00',1.55),('15087','2013-10-13','15:15:00',1.88),('15087','2013-10-13','15:20:00',2.15),('15087','2013-10-13','15:25:00',2.15),('15087','2013-10-13','15:30:00',1.64),('15087','2013-10-13','15:35:00',1.48),('15087','2013-10-13','15:40:00',1.46),('15087','2013-10-13','15:45:00',1.4),('15087','2013-10-13','15:50:00',1.32),('15087','2013-10-13','15:55:00',1.26),('15087','2013-10-13','16:00:00',1.4),('15087','2013-10-13','16:05:00',1.66),('15087','2013-10-13','16:10:00',1.41),('15087','2013-10-13','16:15:00',1.24),('15087','2013-10-13','16:20:00',1.3),('15087','2013-10-13','16:25:00',1.62),('15087','2013-10-13','16:30:00',1.55),('15087','2013-10-13','16:35:00',1.3),('15087','2013-10-13','16:40:00',1.04),('15087','2013-10-12','11:20:00',1.11),('15087','2013-10-12','11:25:00',1.08),('15087','2013-10-12','11:30:00',1.47),('15087','2013-10-12','11:35:00',2.06),('15087','2013-10-12','11:40:00',3.15),('15087','2013-10-12','11:45:00',1.49),('15087','2013-10-12','11:50:00',1.4),('15087','2013-10-12','11:55:00',1.24),('15087','2013-10-12','12:15:00',1.14),('15087','2013-10-12','12:20:00',2.23),('15087','2013-10-12','12:25:00',3.75),('15087','2013-10-12','12:30:00',2.78),('15087','2013-10-12','12:35:00',3.38),('15087','2013-10-12','12:40:00',3.44),('15087','2013-10-12','12:45:00',3),('15087','2013-10-12','12:50:00',3.04),('15087','2013-10-12','12:55:00',2.63),('15087','2013-10-12','13:00:00',1.94),('15087','2013-10-12','13:05:00',1.05),('15087','2013-10-12','13:15:00',1.33),('15087','2013-10-12','13:20:00',1.41),('15087','2013-10-12','13:25:00',1.69),('15087','2013-10-12','13:30:00',4),('15087','2013-10-12','13:35:00',1.57),('15087','2013-10-12','16:00:00',1.14),('15087','2013-10-12','16:05:00',1.08),('15087','2013-10-12','16:10:00',1.14),('15087','2013-10-12','16:15:00',1.77),('15087','2013-10-12','16:20:00',1.97),('15087','2013-10-12','16:25:00',1.09),('15087','2013-10-11','09:15:00',1.14),('15087','2013-10-11','09:20:00',1.27),('15087','2013-10-11','09:25:00',1.09),('15087','2013-10-11','09:30:00',1.13),('15087','2013-10-11','09:35:00',1.15),('15087','2013-10-11','09:40:00',1.41),('15087','2013-10-11','09:45:00',2.27),('15087','2013-10-11','09:50:00',2.34),('15087','2013-10-11','09:55:00',2.41),('15087','2013-10-11','10:00:00',2.47),('15087','2013-10-11','10:05:00',2.57),('15087','2013-10-11','10:10:00',2.64),('15087','2013-10-11','10:15:00',2.44),('15087','2013-10-11','10:20:00',2.51),('15087','2013-10-11','10:25:00',2.78),('15087','2013-10-11','10:30:00',2.98),('15087','2013-10-11','10:35:00',3.11),('15087','2013-10-11','10:40:00',1.6),('15087','2013-10-11','11:05:00',2.73),('15087','2013-10-11','11:10:00',2.26),('15087','2013-10-11','11:15:00',1.03),('15087','2013-10-11','11:20:00',1.09),('15087','2013-10-11','11:25:00',1.07),('15087','2013-10-11','11:35:00',1.3),('15087','2013-10-11','11:40:00',2.09),('15087','2013-10-11','11:45:00',1.88),('15087','2013-10-11','11:50:00',2.16),('15087','2013-10-11','11:55:00',1.96),('15087','2013-10-11','12:00:00',2.59),('15087','2013-10-11','12:05:00',3.2),('15087','2013-10-11','12:10:00',1.55),('15087','2013-10-11','12:15:00',1.16),('15087','2013-10-11','12:25:00',1.63),('15087','2013-10-11','12:30:00',1.35),('15087','2013-10-11','13:05:00',2.23),('15087','2013-10-11','13:10:00',2.02),('15087','2013-10-11','13:15:00',1.66),('15087','2013-10-11','13:20:00',2.13),('15087','2013-10-11','13:25:00',4.19),('15087','2013-10-11','13:30:00',1.63),('15087','2013-10-11','13:40:00',2.01),('15087','2013-10-11','13:45:00',3.02),('15087','2013-10-11','13:50:00',1.18),('15087','2013-10-11','15:35:00',1.17),('15087','2013-10-11','15:40:00',1.64),('15087','2013-10-11','15:45:00',1.12),('15087','2013-10-11','16:00:00',2.02),('15087','2013-10-11','17:00:00',1.02),('15087','2013-10-10','08:50:00',1.15),('15087','2013-10-10','08:55:00',1.51),('15087','2013-10-10','09:05:00',1.04),('15087','2013-10-10','09:10:00',1.67),('15087','2013-10-10','09:15:00',1.79),('15087','2013-10-10','09:20:00',1.84),('15087','2013-10-10','09:25:00',1.84),('15087','2013-10-10','09:30:00',1.83),('15087','2013-10-10','09:40:00',1.72),('15087','2013-10-10','09:45:00',1.94),('15087','2013-10-10','09:50:00',2.25),('15087','2013-10-10','09:55:00',2.06),('15087','2013-10-10','10:10:00',1.91),('15087','2013-10-10','10:15:00',2.69),('15087','2013-10-10','10:20:00',2.72),('15087','2013-10-10','10:25:00',1.75),('15087','2013-10-10','10:30:00',1.54),('15087','2013-10-10','10:35:00',1.23),('15087','2013-10-10','10:40:00',2.58),('15087','2013-10-10','10:45:00',3.04),('15087','2013-10-10','10:50:00',2.39),('15087','2013-10-10','10:55:00',2.05),('15087','2013-10-10','11:20:00',2.58),('15087','2013-10-10','11:25:00',3.75),('15087','2013-10-10','11:35:00',2.46),('15087','2013-10-10','11:40:00',2.2),('15087','2013-10-10','11:50:00',3.03),('15087','2013-10-10','11:55:00',3.65),('15087','2013-10-10','12:00:00',3.85),('15087','2013-10-10','12:05:00',3.94),('15087','2013-10-10','12:10:00',1.12),('15087','2013-10-10','12:20:00',2.84),('15087','2013-10-10','12:25:00',3.62),('15087','2013-10-10','12:35:00',3.96),('15087','2013-10-10','12:40:00',4.13),('15087','2013-10-10','12:45:00',3.1),('15087','2013-10-10','12:50:00',1.73),('15087','2013-10-10','12:55:00',3.96),('15087','2013-10-10','13:00:00',4.14),('15087','2013-10-10','13:05:00',4.21),('15087','2013-10-10','13:10:00',3.84),('15087','2013-10-10','13:15:00',2.46),('15087','2013-10-10','13:20:00',1.21),('15087','2013-10-10','13:25:00',4.07),('15087','2013-10-10','13:30:00',4.07),('15087','2013-10-10','13:35:00',3.8),('15087','2013-10-10','13:40:00',2.71),('15087','2013-10-10','13:45:00',2.86),('15087','2013-10-10','13:50:00',3.96),('15087','2013-10-10','13:55:00',3.64),('15087','2013-10-10','14:00:00',3.6),('15087','2013-10-10','14:05:00',3.34),('15087','2013-10-10','14:10:00',3.36),('15087','2013-10-10','14:15:00',2.08),('15087','2013-10-10','14:20:00',3.24),('15087','2013-10-10','14:25:00',3.54),('15087','2013-10-10','14:30:00',3.57),('15087','2013-10-10','14:35:00',3.55),('15087','2013-10-10','14:40:00',3.19),('15087','2013-10-10','14:45:00',3.04),('15087','2013-10-10','14:50:00',2.89),('15087','2013-10-10','14:55:00',2.77),('15087','2013-10-10','15:00:00',2.6),('15087','2013-10-10','15:05:00',2.63),('15087','2013-10-10','15:10:00',2.88),('15087','2013-10-10','15:15:00',1.94),('15087','2013-10-10','15:20:00',2.31),('15087','2013-10-10','15:25:00',1.74),('15087','2013-10-10','15:30:00',1.97),('15087','2013-10-10','15:40:00',2.45),('15087','2013-10-10','15:45:00',1.45),('15087','2013-10-10','15:50:00',1.54),('15087','2013-10-10','15:55:00',2.2),('15087','2013-10-10','16:00:00',1.61),('15087','2013-10-10','16:15:00',1.22),('15087','2013-10-10','16:25:00',1.6),('15087','2013-10-10','16:55:00',1.01),('15087','2013-10-09','08:40:00',1.12),('15087','2013-10-09','08:45:00',1.2),('15087','2013-10-09','08:50:00',1.27),('15087','2013-10-09','08:55:00',1.36),('15087','2013-10-09','09:00:00',1.43),('15087','2013-10-09','09:05:00',1.55),('15087','2013-10-09','09:10:00',1.72),('15087','2013-10-09','09:15:00',1.58),('15087','2013-10-09','09:20:00',1.68),('15087','2013-10-09','09:25:00',1.99),('15087','2013-10-09','09:30:00',2.08),('15087','2013-10-09','09:35:00',2.16),('15087','2013-10-09','09:40:00',2.27),('15087','2013-10-09','09:45:00',2.36),('15087','2013-10-09','09:50:00',2.44),('15087','2013-10-09','09:55:00',2.57),('15087','2013-10-09','10:00:00',2.73),('15087','2013-10-09','10:05:00',2.85),('15087','2013-10-09','10:10:00',2.17),('15087','2013-10-09','10:15:00',1.44),('15087','2013-10-09','10:25:00',1.02),('15087','2013-10-09','10:30:00',1.21),('15087','2013-10-09','10:35:00',1.27),('15087','2013-10-09','10:40:00',1.35),('15087','2013-10-09','10:45:00',2.39),('15087','2013-10-09','10:50:00',4.09),('15087','2013-10-09','10:55:00',3.1),('15087','2013-10-09','11:00:00',3.33),('15087','2013-10-09','11:05:00',4.19),('15087','2013-10-09','11:10:00',4.24),('15087','2013-10-09','11:15:00',3.91),('15087','2013-10-09','11:20:00',2.94),('15087','2013-10-09','11:25:00',3.68),('15087','2013-10-09','11:30:00',4.24),('15087','2013-10-09','11:35:00',4.44),('15087','2013-10-09','11:40:00',4.26),('15087','2013-10-09','11:45:00',3.87),('15087','2013-10-09','11:50:00',3.52),('15087','2013-10-09','11:55:00',3.3),('15087','2013-10-09','12:00:00',1.36),('15087','2013-10-09','12:05:00',2.43),('15087','2013-10-09','12:10:00',2.38),('15087','2013-10-09','12:15:00',5.18),('15087','2013-10-09','12:20:00',4.09),('15087','2013-10-09','12:25:00',2.65),('15087','2013-10-09','12:30:00',2.09),('15087','2013-10-09','12:35:00',2.68),('15087','2013-10-09','12:40:00',1.4),('15087','2013-10-09','12:55:00',1.15),('15087','2013-10-09','13:10:00',1.26),('15087','2013-10-09','13:15:00',1.4),('15087','2013-10-09','13:20:00',2.2),('15087','2013-10-09','13:25:00',3.38),('15087','2013-10-09','13:30:00',3.55),('15087','2013-10-09','13:35:00',3.57),('15087','2013-10-09','13:40:00',2.57),('15087','2013-10-09','13:45:00',2.18),('15087','2013-10-09','13:50:00',1.78),('15087','2013-10-09','13:55:00',4.03),('15087','2013-10-09','14:00:00',2.39),('15087','2013-10-09','14:05:00',2.49),('15087','2013-10-09','14:50:00',1.09),('15087','2013-10-09','14:55:00',2.57),('15087','2013-10-09','15:00:00',1.41),('15087','2013-10-09','15:05:00',3.15),('15087','2013-10-09','15:10:00',2.83),('15087','2013-10-09','15:15:00',2.86),('15087','2013-10-09','15:20:00',2.6),('15087','2013-10-09','15:25:00',2.59),('15087','2013-10-09','15:30:00',2.16),('15087','2013-10-09','15:35:00',2.15),('15087','2013-10-09','15:40:00',1.82),('15087','2013-10-09','15:45:00',1.26),('15087','2013-10-09','16:15:00',1.13),('15087','2013-10-09','16:20:00',1.56),('15087','2013-10-09','16:25:00',1.72),('15087','2013-10-09','16:30:00',1.97),('15087','2013-10-09','16:35:00',1.42),('15087','2013-10-09','16:40:00',1.29),('15087','2013-10-09','17:35:00',1.05),('15087','2014-04-15','09:00:00',1.79),('15087','2014-04-15','09:05:00',1.81),('15087','2014-04-15','09:10:00',2.11),('15087','2014-04-15','09:15:00',2.34),('15087','2014-04-15','09:20:00',2.78),('15087','2014-04-15','09:25:00',3.22),('15087','2014-04-15','09:30:00',1.96),('15087','2014-04-15','09:45:00',1.24),('15087','2014-04-15','09:50:00',2.52),('15087','2014-04-15','10:05:00',2.05),('15087','2014-04-15','10:10:00',2.61),('15087','2014-04-15','10:15:00',2.12),('15087','2014-04-15','10:20:00',1.97),('15087','2014-04-15','10:25:00',2.68),('15087','2014-04-15','10:30:00',3.89),('15087','2014-04-15','10:35:00',1.99),('15087','2014-04-15','10:40:00',2.88),('15087','2014-04-15','10:45:00',2.38),('15087','2014-04-15','10:50:00',2.72),('15087','2014-04-15','10:55:00',1.97),('15087','2014-04-15','11:00:00',2.59),('15087','2014-04-15','11:05:00',2.12),('15087','2014-04-15','11:10:00',1.91),('15087','2014-04-15','11:15:00',1.57),('15087','2014-04-15','11:20:00',1.15),('15087','2014-04-15','11:25:00',1.53),('15087','2014-04-15','11:30:00',1.25),('15087','2014-04-15','11:45:00',1.22),('15087','2014-04-15','11:50:00',1.47),('15087','2014-04-15','11:55:00',1.04),('15087','2014-04-15','12:10:00',1.01),('15087','2014-04-15','12:15:00',1.79),('15087','2014-04-15','12:20:00',1.86),('15087','2014-04-15','13:05:00',1.11),('15087','2014-04-15','13:10:00',1.49),('15087','2014-04-15','13:15:00',2.68),('15087','2014-04-15','13:20:00',2.85),('15087','2014-04-15','13:25:00',2.29),('15087','2014-04-15','13:30:00',2.81),('15087','2014-04-15','13:35:00',3.05),('15087','2014-04-15','13:40:00',1.78),('15087','2014-04-15','14:00:00',3.55),('15087','2014-04-15','14:05:00',1.59),('15087','2014-04-15','14:10:00',2.95),('15087','2014-04-15','14:15:00',3.44),('15087','2014-04-15','14:20:00',3.41),('15087','2014-04-15','14:25:00',3.35),('15087','2014-04-15','14:30:00',1.96),('15087','2014-04-15','14:35:00',1.62),('15087','2014-04-15','14:40:00',2.93),('15087','2014-04-15','14:45:00',2.71),('15087','2014-04-15','14:50:00',2.76),('15087','2014-04-15','14:55:00',1.7),('15087','2014-04-15','15:05:00',1.05),('15087','2014-04-15','15:10:00',1.17),('15087','2014-04-15','15:15:00',1.88),('15087','2014-04-15','15:20:00',2.12),('15087','2014-04-15','15:25:00',2.18),('15087','2014-04-15','15:30:00',1.72),('15087','2014-04-15','15:35:00',1.54),('15087','2014-04-15','15:40:00',1.57),('15087','2014-04-15','15:45:00',1.45),('15087','2014-04-15','15:50:00',1.45),('15087','2014-04-15','15:55:00',1.49),('15087','2014-04-15','16:00:00',1.68),('15087','2014-04-15','16:05:00',1.67),('15087','2013-10-08','08:15:00',1.11),('15087','2013-10-08','08:20:00',1.05),('15087','2013-10-08','10:05:00',1),('15087','2013-10-08','10:55:00',1.07),('15087','2013-10-08','11:00:00',1.8),('15087','2013-10-08','11:05:00',1.22),('15087','2013-10-08','11:10:00',1.64),('15087','2013-10-08','11:15:00',2.96),('15087','2013-10-08','11:20:00',4.2),('15087','2013-10-08','11:25:00',2.12),('15087','2013-10-08','11:30:00',2.43),('15087','2013-10-08','11:35:00',2.32),('15087','2013-10-08','11:40:00',1.59),('15087','2013-10-08','11:45:00',1.42),('15087','2013-10-08','12:20:00',1.13),('15087','2013-10-08','12:25:00',1.6),('15087','2013-10-08','12:30:00',2.27),('15087','2013-10-08','12:35:00',2.37),('15087','2013-10-08','12:40:00',4.53),('15087','2013-10-08','12:45:00',4.2),('15087','2013-10-08','12:50:00',3.5),('15087','2013-10-08','12:55:00',4.32),('15087','2013-10-08','13:00:00',4.06),('15087','2013-10-08','13:05:00',2.78),('15087','2013-10-08','13:10:00',1.65),('15087','2013-10-08','13:15:00',3.18),('15087','2013-10-08','13:20:00',1.54),('15087','2013-10-08','13:25:00',2.98),('15087','2013-10-08','13:30:00',2.33),('15087','2013-10-08','13:35:00',1.59),('15087','2013-10-08','13:40:00',1.13),('15087','2013-10-08','14:05:00',1.37),('15087','2013-10-08','14:10:00',1.9),('15087','2013-10-08','14:15:00',2.35),('15087','2013-10-08','14:20:00',2.59),('15087','2013-10-08','14:25:00',2.83),('15087','2013-10-08','14:30:00',2.39),('15087','2013-10-08','14:35:00',1.31),('15087','2013-10-08','14:40:00',1.56),('15087','2013-10-08','14:45:00',2.87),('15087','2013-10-08','14:50:00',3.13),('15087','2013-10-08','14:55:00',2.95),('15087','2013-10-08','15:00:00',2.82),('15087','2013-10-08','15:05:00',2.78),('15087','2013-10-08','15:10:00',2.67),('15087','2013-10-08','15:15:00',2.54),('15087','2013-10-08','15:20:00',2.5),('15087','2013-10-08','15:25:00',3.21),('15087','2013-10-08','15:30:00',3.1),('15087','2013-10-08','15:35:00',2.74),('15087','2013-10-08','15:40:00',1.47),('15087','2013-10-08','15:45:00',1.17),('15087','2013-10-08','15:50:00',2.07),('15087','2013-10-08','15:55:00',1.3),('15087','2013-10-08','16:00:00',1.1),('15087','2013-10-07','08:40:00',1.12),('15087','2013-10-07','09:00:00',1.72),('15087','2013-10-07','09:05:00',1.78),('15087','2013-10-07','09:10:00',1.76),('15087','2013-10-07','09:15:00',1.84),('15087','2013-10-07','09:20:00',1.88),('15087','2013-10-07','09:25:00',1.99),('15087','2013-10-07','09:30:00',2.06),('15087','2013-10-07','09:35:00',2.15),('15087','2013-10-07','09:40:00',2.21),('15087','2013-10-07','09:45:00',2.3),('15087','2013-10-07','09:50:00',2.38),('15087','2013-10-07','09:55:00',2.45),('15087','2013-10-07','10:00:00',2.51),('15087','2013-10-07','10:05:00',2.58),('15087','2013-10-07','10:10:00',2.64),('15087','2013-10-07','10:15:00',2.69),('15087','2013-10-07','10:20:00',2.76),('15087','2013-10-07','10:25:00',2.61),('15087','2013-10-07','10:30:00',2.94),('15087','2013-10-07','10:35:00',3.18),('15087','2013-10-07','10:40:00',3.06),('15087','2013-10-07','10:45:00',3.11),('15087','2013-10-07','10:50:00',3.18),('15087','2013-10-07','10:55:00',2.82),('15087','2013-10-07','11:00:00',2.76),('15087','2013-10-07','11:05:00',3.43),('15087','2013-10-07','11:10:00',3.14),('15087','2013-10-07','11:15:00',3.19),('15087','2013-10-07','11:20:00',3.43),('15087','2013-10-07','11:25:00',3.42),('15087','2013-10-07','11:30:00',3.44),('15087','2013-10-07','11:35:00',3.48),('15087','2013-10-07','11:40:00',3.52),('15087','2013-10-07','11:45:00',3.55),('15087','2013-10-07','11:50:00',3.59),('15087','2013-10-07','11:55:00',3.6),('15087','2013-10-07','12:00:00',3.62),('15087','2013-10-07','12:05:00',3.74),('15087','2013-10-07','12:10:00',3.92),('15087','2013-10-07','12:15:00',1.61),('15087','2013-10-07','12:20:00',2.12),('15087','2013-10-07','12:25:00',3.42),('15087','2013-10-07','12:30:00',4.25),('15087','2013-10-07','12:35:00',4),('15087','2013-10-07','12:40:00',2.46),('15087','2013-10-07','12:45:00',4.07),('15087','2013-10-07','12:50:00',2.6),('15087','2013-10-07','12:55:00',4.16),('15087','2013-10-07','13:00:00',4.07),('15087','2013-10-07','13:05:00',3.69),('15087','2013-10-07','13:10:00',3.64),('15087','2013-10-07','13:15:00',4.09),('15087','2013-10-07','13:20:00',3.84),('15087','2013-10-07','13:25:00',2.98),('15087','2013-10-07','13:30:00',1.85),('15087','2013-10-07','13:35:00',2.42),('15087','2013-10-07','13:40:00',1.8),('15087','2013-10-07','13:45:00',1.32),('15087','2013-10-07','13:50:00',2.92),('15087','2013-10-07','13:55:00',4.36),('15087','2013-10-07','14:00:00',2.96),('15087','2013-10-07','14:05:00',2.3),('15087','2013-10-07','14:10:00',1.29),('15087','2013-10-07','14:15:00',1.07),('15087','2013-10-07','14:20:00',1.24),('15087','2013-10-07','14:30:00',2.79),('15087','2013-10-07','14:35:00',3.73),('15087','2013-10-07','14:40:00',2.02),('15087','2013-10-07','14:45:00',2.67),('15087','2013-10-07','14:50:00',3.22),('15087','2013-10-07','14:55:00',3.12),('15087','2013-10-07','15:00:00',2.74),('15087','2013-10-07','15:05:00',2.69),('15087','2013-10-07','15:10:00',1.88),('15087','2013-10-07','15:15:00',2.61),('15087','2013-10-07','15:20:00',1.39),('15087','2013-10-07','15:25:00',2.59),('15087','2013-10-07','15:30:00',1.39),('15087','2013-10-07','15:35:00',1.23),('15087','2013-10-07','15:40:00',2.13),('15087','2013-10-07','15:45:00',2.9),('15087','2013-10-07','15:50:00',2.36),('15087','2013-10-07','16:00:00',1.43),('15087','2013-10-07','16:05:00',1.77),('15087','2013-10-07','16:10:00',2.03),('15087','2013-10-07','16:15:00',1.97),('15087','2013-10-07','16:20:00',1.86),('15087','2013-10-07','16:25:00',1.74),('15087','2013-10-07','16:35:00',1.43),('15087','2013-10-07','16:40:00',1.45),('15087','2013-10-07','16:45:00',1.36),('15087','2013-10-07','16:50:00',1.24),('15087','2013-10-07','16:55:00',1.12),('15087','2013-10-07','17:00:00',1),('15087','2013-10-06','09:05:00',1.14),('15087','2013-10-06','09:30:00',1.34),('15087','2013-10-06','09:35:00',1.68),('15087','2013-10-06','09:40:00',1.44),('15087','2013-10-06','09:45:00',1.27),('15087','2013-10-06','09:50:00',2.27),('15087','2013-10-06','09:55:00',2.64),('15087','2013-10-06','10:00:00',3.06),('15087','2013-10-06','10:05:00',3.08),('15087','2013-10-06','10:10:00',2.99),('15087','2013-10-06','10:15:00',2.76),('15087','2013-10-06','10:20:00',2.83),('15087','2013-10-06','10:25:00',3.14),('15087','2013-10-06','10:30:00',3.1),('15087','2013-10-06','10:35:00',3.04),('15087','2013-10-06','10:40:00',2.59),('15087','2013-10-06','10:45:00',2.05),('15087','2013-10-06','10:50:00',2.37),('15087','2013-10-06','10:55:00',2.43),('15087','2013-10-06','11:00:00',2.64),('15087','2013-10-06','11:05:00',2.94),('15087','2013-10-06','11:10:00',3.05),('15087','2013-10-06','11:15:00',2.96),('15087','2013-10-06','11:20:00',3.09),('15087','2013-10-06','11:25:00',3.12),('15087','2013-10-06','11:30:00',3.04),('15087','2013-10-06','11:35:00',2.98),('15087','2013-10-06','11:40:00',2.16),('15087','2013-10-06','11:45:00',2.26),('15087','2013-10-06','11:50:00',2.08),('15087','2013-10-06','11:55:00',2.53),('15087','2013-10-06','12:00:00',2.79),('15087','2013-10-06','12:05:00',2.72),('15087','2013-10-06','12:10:00',3.44),('15087','2013-10-06','12:15:00',3.39),('15087','2013-10-06','12:20:00',3.18),('15087','2013-10-06','12:25:00',2.5),('15087','2013-10-06','12:30:00',2.66),('15087','2013-10-06','12:35:00',2.88),('15087','2013-10-06','12:40:00',2.76),('15087','2013-10-06','12:45:00',2.84),('15087','2013-10-06','12:50:00',3.03),('15087','2013-10-06','12:55:00',3.43),('15087','2013-10-06','13:00:00',3.5),('15087','2013-10-06','13:05:00',3.39),('15087','2013-10-06','13:10:00',3.28),('15087','2013-10-06','13:15:00',4.11),('15087','2013-10-06','13:20:00',1.97),('15087','2013-10-06','13:25:00',1.05),('15087','2013-10-06','13:45:00',1.74),('15087','2013-10-06','13:50:00',3.88),('15087','2013-10-06','13:55:00',3.52),('15087','2013-10-06','14:00:00',2.62),('15087','2013-10-06','14:05:00',1.99),('15087','2013-10-06','14:10:00',1.69),('15087','2013-10-06','14:15:00',1.46),('15087','2013-10-06','14:20:00',1.61),('15087','2013-10-06','14:25:00',1.64),('15087','2013-10-06','14:30:00',2.54),('15087','2013-10-06','14:35:00',2.35),('15087','2013-10-06','14:40:00',2.28),('15087','2013-10-06','14:45:00',1.74),('15087','2013-10-06','14:50:00',2.03),('15087','2013-10-06','14:55:00',2.69),('15087','2013-10-06','15:00:00',2.11),('15087','2013-10-06','15:05:00',1.46),('15087','2013-10-06','15:10:00',1.18),('15087','2013-10-06','15:15:00',1.16),('15087','2013-10-06','15:55:00',1.04),('15087','2013-10-06','16:00:00',1.1),('15087','2013-10-05','16:00:00',1.02),('15087','2013-10-05','16:05:00',1.26),('15087','2013-10-05','16:10:00',1.2),('15087','2013-10-05','16:15:00',1.1),('15087','2013-10-05','16:20:00',1.13),('15087','2013-10-05','16:25:00',1.08),('15087','2013-10-04','09:25:00',1.02),('15087','2013-10-04','09:30:00',1.1),('15087','2013-10-04','09:35:00',1.18),('15087','2013-10-04','09:40:00',1.21),('15087','2013-10-04','09:45:00',1.18),('15087','2013-10-04','09:50:00',1.47),('15087','2013-10-04','09:55:00',2.85),('15087','2013-10-04','10:00:00',2.27),('15087','2013-10-04','10:05:00',1.54),('15087','2013-10-04','10:10:00',1.6),('15087','2013-10-04','10:15:00',1.84),('15087','2013-10-04','10:20:00',1.68),('15087','2013-10-04','10:25:00',1.96),('15087','2013-10-04','10:30:00',2.66),('15087','2013-10-04','10:35:00',2.53),('15087','2013-10-04','10:40:00',2.68),('15087','2013-10-04','10:45:00',2.49),('15087','2013-10-04','10:50:00',2.08),('15087','2013-10-04','10:55:00',2.84),('15087','2013-10-04','11:00:00',2.21),('15087','2013-10-04','11:05:00',1.78),('15087','2013-10-04','11:10:00',2.03),('15087','2013-10-04','11:15:00',3.34),('15087','2013-10-04','11:20:00',3.13),('15087','2013-10-04','11:25:00',2.83),('15087','2013-10-04','11:30:00',3.91),('15087','2013-10-04','11:35:00',3.69),('15087','2013-10-04','11:40:00',3.8),('15087','2013-10-04','11:45:00',3.79),('15087','2013-10-04','11:50:00',3.73),('15087','2013-10-04','11:55:00',3.74),('15087','2013-10-04','12:00:00',3.76),('15087','2013-10-04','12:05:00',3.8),('15087','2013-10-04','12:10:00',3.83),('15087','2013-10-04','12:15:00',3.59),('15087','2013-10-04','12:20:00',3.79),('15087','2013-10-04','12:25:00',3.93),('15087','2013-10-04','12:30:00',4.05),('15087','2013-10-04','12:35:00',3.65),('15087','2013-10-04','12:40:00',3.79),('15087','2013-10-04','12:45:00',3.84),('15087','2013-10-04','12:50:00',3.73),('15087','2013-10-04','12:55:00',3.71),('15087','2013-10-04','13:00:00',3.72),('15087','2013-10-04','13:05:00',3.81),('15087','2013-10-04','13:10:00',3.83),('15087','2013-10-04','13:15:00',4),('15087','2013-10-04','13:20:00',3.88),('15087','2013-10-04','13:25:00',3.62),('15087','2013-10-04','13:30:00',3.9),('15087','2013-10-04','13:35:00',3.85),('15087','2013-10-04','13:40:00',3.63),('15087','2013-10-04','13:45:00',3.6),('15087','2013-10-04','13:50:00',3.57),('15087','2013-10-04','13:55:00',3.36),('15087','2013-10-04','14:00:00',3.2),('15087','2013-10-04','14:05:00',3.38),('15087','2013-10-04','14:10:00',2.97),('15087','2013-10-04','14:15:00',2.56),('15087','2013-10-04','14:20:00',3.14),('15087','2013-10-04','14:25:00',3.12),('15087','2013-10-04','14:30:00',2.66),('15087','2013-10-04','14:35:00',1.94),('15087','2013-10-04','14:40:00',1.6),('15087','2013-10-04','14:45:00',1.98),('15087','2013-10-04','14:50:00',2.53),('15087','2013-10-04','14:55:00',2.45),('15087','2013-10-04','15:00:00',2.11),('15087','2013-10-04','15:05:00',2.35),('15087','2013-10-04','15:10:00',1.94),('15087','2013-10-04','15:15:00',1.58),('15087','2013-10-04','15:20:00',1.39),('15087','2013-10-04','15:25:00',2.55),('15087','2013-10-04','15:30:00',2.08),('15087','2013-10-04','15:35:00',1.21),('15087','2013-10-04','16:00:00',1.05),('15087','2013-10-04','16:05:00',1.13),('15087','2013-10-04','16:10:00',1.03),('15087','2013-10-03','08:30:00',1.02),('15087','2013-10-03','08:35:00',1.12),('15087','2013-10-03','08:40:00',1.11),('15087','2013-10-03','08:45:00',1.31),('15087','2013-10-03','08:50:00',1.43),('15087','2013-10-03','08:55:00',1.54),('15087','2013-10-03','09:00:00',1.39),('15087','2013-10-03','09:05:00',1.77),('15087','2013-10-03','09:10:00',1.89),('15087','2013-10-03','09:15:00',1.97),('15087','2013-10-03','09:20:00',1.7),('15087','2013-10-03','09:25:00',2.17),('15087','2013-10-03','09:30:00',2.26),('15087','2013-10-03','09:35:00',2.35),('15087','2013-10-03','09:40:00',1.87),('15087','2013-10-03','09:45:00',2.48),('15087','2013-10-03','09:50:00',2.6),('15087','2013-10-03','09:55:00',2.68),('15087','2013-10-03','10:00:00',2.76),('15087','2013-10-03','10:05:00',2.84),('15087','2013-10-03','10:10:00',2.92),('15087','2013-10-03','10:15:00',2.99),('15087','2013-10-03','10:20:00',3.06),('15087','2013-10-03','10:25:00',3.13),('15087','2013-10-03','10:30:00',3.19),('15087','2013-10-03','10:35:00',3.26),('15087','2013-10-03','10:40:00',3.32),('15087','2013-10-03','10:45:00',3.38),('15087','2013-10-03','10:50:00',3.43),('15087','2013-10-03','10:55:00',3.48),('15087','2013-10-03','11:00:00',3.46),('15087','2013-10-03','11:05:00',3.57),('15087','2013-10-03','11:10:00',3.62),('15087','2013-10-03','11:15:00',3.64),('15087','2013-10-03','11:20:00',3.71),('15087','2013-10-03','11:25:00',3.75),('15087','2013-10-03','11:30:00',3.78),('15087','2013-10-03','11:35:00',3.82),('15087','2013-10-03','11:40:00',3.87),('15087','2013-10-03','11:45:00',3.9),('15087','2013-10-03','11:50:00',3.92),('15087','2013-10-03','11:55:00',3.94),('15087','2013-10-03','12:00:00',3.97),('15087','2013-10-03','12:05:00',4),('15087','2013-10-03','12:10:00',4.02),('15087','2013-10-03','12:15:00',4.01),('15087','2013-10-03','12:20:00',4),('15087','2013-10-03','12:25:00',4.03),('15087','2013-10-03','12:30:00',4.05),('15087','2013-10-03','12:35:00',4.06),('15087','2013-10-03','12:40:00',4.03),('15087','2013-10-03','12:45:00',4.03),('15087','2013-10-03','12:50:00',4.03),('15087','2013-10-03','12:55:00',4.05),('15087','2013-10-03','13:00:00',4.03),('15087','2013-10-03','13:05:00',3.96),('15087','2013-10-03','13:10:00',4.03),('15087','2013-10-03','13:15:00',4.01),('15087','2013-10-03','13:20:00',3.97),('15087','2013-10-03','13:25:00',3.97),('15087','2013-10-03','13:30:00',3.99),('15087','2013-10-03','13:35:00',3.91),('15087','2013-10-03','13:40:00',3.9),('15087','2013-10-03','13:45:00',3.86),('15087','2013-10-03','13:50:00',3.8),('15087','2013-10-03','13:55:00',3.7),('15087','2013-10-03','14:00:00',3.7),('15087','2013-10-03','14:05:00',3.72),('15087','2013-10-03','14:10:00',3.59),('15087','2013-10-03','14:15:00',3.46),('15087','2013-10-03','14:20:00',3.53),('15087','2013-10-03','14:25:00',3.38),('15087','2013-10-03','14:30:00',3.31),('15087','2013-10-03','14:35:00',3.32),('15087','2013-10-03','14:40:00',3.31),('15087','2013-10-03','14:45:00',3.05),('15087','2013-10-03','14:50:00',3.07),('15087','2013-10-03','14:55:00',3.04),('15087','2013-10-03','15:00:00',3),('15087','2013-10-03','15:05:00',2.92),('15087','2013-10-03','15:10:00',2.8),('15087','2013-10-03','15:15:00',2.83),('15087','2013-10-03','15:20:00',2.79),('15087','2013-10-03','15:25:00',2.75),('15087','2013-10-03','15:30:00',2.56),('15087','2013-10-03','15:35:00',2.61),('15087','2013-10-03','15:40:00',2.51),('15087','2013-10-03','15:45:00',2.41),('15087','2013-10-03','15:50:00',2.29),('15087','2013-10-03','15:55:00',2.25),('15087','2013-10-03','16:00:00',2.11),('15087','2013-10-03','16:05:00',2.04),('15087','2013-10-03','16:10:00',1.93),('15087','2013-10-03','16:15:00',1.77),('15087','2013-10-03','16:20:00',1.78),('15087','2013-10-03','16:25:00',1.77),('15087','2013-10-03','16:30:00',1.66),('15087','2013-10-03','16:35:00',1.54),('15087','2013-10-03','16:40:00',1.44),('15087','2013-10-03','16:45:00',1.35),('15087','2013-10-03','16:50:00',1.26),('15087','2013-10-03','16:55:00',1.19),('15087','2013-10-03','17:00:00',1.14),('15087','2013-10-03','17:05:00',1.07),('15087','2013-10-02','08:30:00',1.06),('15087','2013-10-02','08:35:00',1.06),('15087','2013-10-02','08:40:00',1.14),('15087','2013-10-02','08:45:00',1.24),('15087','2013-10-02','08:50:00',1.32),('15087','2013-10-02','08:55:00',1.43),('15087','2013-10-02','09:00:00',1.55),('15087','2013-10-02','09:05:00',1.69),('15087','2013-10-02','09:10:00',1.77),('15087','2013-10-02','09:15:00',1.88),('15087','2013-10-02','09:20:00',1.99),('15087','2013-10-02','09:25:00',2.08),('15087','2013-10-02','09:30:00',2.16),('15087','2013-10-02','09:35:00',2.25),('15087','2013-10-02','09:40:00',2.33),('15087','2013-10-02','09:45:00',2.38),('15087','2013-10-02','09:50:00',2.47),('15087','2013-10-02','09:55:00',2.55),('15087','2013-10-02','10:00:00',2.61),('15087','2013-10-02','10:05:00',2.68),('15087','2013-10-02','10:10:00',2.73),('15087','2013-10-02','10:15:00',2.8),('15087','2013-10-02','10:20:00',2.88),('15087','2013-10-02','10:25:00',2.95),('15087','2013-10-02','10:30:00',3.01),('15087','2013-10-02','10:35:00',3.09),('15087','2013-10-02','10:40:00',3.17),('15087','2013-10-02','10:45:00',3.25),('15087','2013-10-02','10:50:00',3.32),('15087','2013-10-02','10:55:00',3.37),('15087','2013-10-02','11:00:00',3.41),('15087','2013-10-02','11:05:00',3.46),('15087','2013-10-02','11:10:00',3.5),('15087','2013-10-02','11:15:00',3.55),('15087','2013-10-02','11:20:00',3.59),('15087','2013-10-02','11:25:00',3.62),('15087','2013-10-02','11:30:00',3.65),('15087','2013-10-02','11:35:00',3.68),('15087','2013-10-02','11:40:00',3.7),('15087','2013-10-02','11:45:00',3.74),('15087','2013-10-02','11:50:00',3.77),('15087','2013-10-02','11:55:00',3.8),('15087','2013-10-02','12:00:00',3.77),('15087','2013-10-02','12:05:00',3.83),('15087','2013-10-02','12:10:00',3.86),('15087','2013-10-02','12:15:00',3.88),('15087','2013-10-02','12:20:00',3.9),('15087','2013-10-02','12:25:00',3.89),('15087','2013-10-02','12:30:00',3.87),('15087','2013-10-02','12:35:00',3.9),('15087','2013-10-02','12:40:00',3.9),('15087','2013-10-02','12:45:00',3.91),('15087','2013-10-02','12:50:00',3.91),('15087','2013-10-02','12:55:00',3.91),('15087','2013-10-02','13:00:00',3.89),('15087','2013-10-02','13:05:00',3.92),('15087','2013-10-02','13:10:00',3.92),('15087','2013-10-02','13:15:00',3.92),('15087','2013-10-02','13:20:00',3.91),('15087','2013-10-02','13:25:00',3.89),('15087','2013-10-02','13:30:00',3.87),('15087','2013-10-02','13:35:00',3.8),('15087','2013-10-02','13:40:00',3.79),('15087','2013-10-02','13:45:00',3.77),('15087','2013-10-02','13:50:00',3.72),('15087','2013-10-02','13:55:00',3.62),('15087','2013-10-02','14:00:00',3.44),('15087','2013-10-02','14:05:00',3.59),('15087','2013-10-02','14:10:00',3.56),('15087','2013-10-02','14:15:00',3.31),('15087','2013-10-02','14:20:00',3.37),('15087','2013-10-02','14:25:00',3.37),('15087','2013-10-02','14:30:00',3.15),('15087','2013-10-02','14:35:00',3.17),('15087','2013-10-02','14:40:00',3.18),('15087','2013-10-02','14:45:00',3.14),('15087','2013-10-02','14:50:00',3.04),('15087','2013-10-02','14:55:00',2.95),('15087','2013-10-02','15:00:00',2.9),('15087','2013-10-02','15:05:00',2.88),('15087','2013-10-02','15:10:00',2.79),('15087','2013-10-02','15:15:00',2.77),('15087','2013-10-02','15:20:00',2.75),('15087','2013-10-02','15:25:00',2.69),('15087','2013-10-02','15:30:00',2.53),('15087','2013-10-02','15:35:00',2.53),('15087','2013-10-02','15:40:00',2.46),('15087','2013-10-02','15:45:00',2.36),('15087','2013-10-02','15:50:00',2.27),('15087','2013-10-02','15:55:00',2.24),('15087','2013-10-02','16:00:00',2.11),('15087','2013-10-02','16:05:00',2),('15087','2013-10-02','16:10:00',1.89),('15087','2013-10-02','16:15:00',1.81),('15087','2013-10-02','16:20:00',1.76),('15087','2013-10-02','16:25:00',1.72),('15087','2013-10-02','16:30:00',1.62),('15087','2013-10-02','16:35:00',1.56),('15087','2013-10-02','16:40:00',1.46),('15087','2013-10-02','16:45:00',1.35),('15087','2013-10-02','16:50:00',1.28),('15087','2013-10-02','16:55:00',1.19),('15087','2013-10-02','17:00:00',1.14),('15087','2013-10-02','17:05:00',1.07),('15087','2013-10-01','08:35:00',1.1),('15087','2013-10-01','08:40:00',1.19),('15087','2013-10-01','08:45:00',1.3),('15087','2013-10-01','08:50:00',1.41),('15087','2013-10-01','08:55:00',1.49),('15087','2013-10-01','09:00:00',1.59),('15087','2013-10-01','09:05:00',1.71),('15087','2013-10-01','09:10:00',1.78),('15087','2013-10-01','09:15:00',1.88),('15087','2013-10-01','09:20:00',1.93),('15087','2013-10-01','09:25:00',2.02),('15087','2013-10-01','09:30:00',2.11),('15087','2013-10-01','09:35:00',2.2),('15087','2013-10-01','09:40:00',2.29),('15087','2013-10-01','09:45:00',2.34),('15087','2013-10-01','09:50:00',2.42),('15087','2013-10-01','09:55:00',2.48),('15087','2013-10-01','10:00:00',2.56),('15087','2013-10-01','10:05:00',2.64),('15087','2013-10-01','10:10:00',2.67),('15087','2013-10-01','10:15:00',2.78),('15087','2013-10-01','10:20:00',2.88),('15087','2013-10-01','10:25:00',2.94),('15087','2013-10-01','10:30:00',3.01),('15087','2013-10-01','10:35:00',3.03),('15087','2013-10-01','10:40:00',3.09),('15087','2013-10-01','10:45:00',3.17),('15087','2013-10-01','10:50:00',3.26),('15087','2013-10-01','10:55:00',3.33),('15087','2013-10-01','11:00:00',3.38),('15087','2013-10-01','11:05:00',3.61),('15087','2013-10-01','11:10:00',3.83),('15087','2013-10-01','11:15:00',3.88),('15087','2013-10-01','11:20:00',1.69),('15087','2013-10-01','11:30:00',2.08),('15087','2013-10-01','11:35:00',3.89),('15087','2013-10-01','11:40:00',3.84),('15087','2013-10-01','11:45:00',3.85),('15087','2013-10-01','11:50:00',2.68),('15087','2013-10-01','11:55:00',1.59),('15087','2013-10-01','12:00:00',3.97),('15087','2013-10-01','12:05:00',3.98),('15087','2013-10-01','12:10:00',3.92),('15087','2013-10-01','12:15:00',4.01),('15087','2013-10-01','12:20:00',4.08),('15087','2013-10-01','12:25:00',3.12),('15087','2013-10-01','12:30:00',3.93),('15087','2013-10-01','12:40:00',1.02),('15087','2013-10-01','12:45:00',3.81),('15087','2013-10-01','12:50:00',1.24),('15087','2013-10-01','12:55:00',2.05),('15087','2013-10-01','13:00:00',4.21),('15087','2013-10-01','13:05:00',3.63),('15087','2013-10-01','13:10:00',1.09),('15087','2013-10-01','13:15:00',2.37),('15087','2013-10-01','13:20:00',4.26),('15087','2013-10-01','13:25:00',2.74),('15087','2013-10-01','13:30:00',1.63),('15087','2013-10-01','13:35:00',4.34),('15087','2013-10-01','13:40:00',3.85),('15087','2013-10-01','13:45:00',3.93),('15087','2013-10-01','13:50:00',3.94),('15087','2013-10-01','13:55:00',3.64),('15087','2013-10-01','14:00:00',3.37),('15087','2013-10-01','14:05:00',3.37),('15087','2013-10-01','14:10:00',3.43),('15087','2013-10-01','14:15:00',3.21),('15087','2013-10-01','14:20:00',3.2),('15087','2013-10-01','14:25:00',3.22),('15087','2013-10-01','14:30:00',3.16),('15087','2013-10-01','14:35:00',3),('15087','2013-10-01','14:40:00',2.47),('15087','2013-10-01','14:45:00',3.24),('15087','2013-10-01','14:50:00',3.14),('15087','2013-10-01','14:55:00',2.95),('15087','2013-10-01','15:00:00',2.7),('15087','2013-10-01','15:05:00',2.74),('15087','2013-10-01','15:10:00',2.84),('15087','2013-10-01','15:15:00',2.75),('15087','2013-10-01','15:20:00',2.74),('15087','2013-10-01','15:25:00',2.62),('15087','2013-10-01','15:30:00',2.55),('15087','2013-10-01','15:35:00',2.52),('15087','2013-10-01','15:40:00',2.51),('15087','2013-10-01','15:45:00',2.33),('15087','2013-10-01','15:50:00',2.27),('15087','2013-10-01','15:55:00',2.2),('15087','2013-10-01','16:00:00',2.01),('15087','2013-10-01','16:05:00',1.95),('15087','2013-10-01','16:10:00',1.9),('15087','2013-10-01','16:15:00',1.8),('15087','2013-10-01','16:20:00',1.72),('15087','2013-10-01','16:25:00',1.67),('15087','2013-10-01','16:30:00',1.59),('15087','2013-10-01','16:35:00',1.5),('15087','2013-10-01','16:40:00',1.42),('15087','2013-10-01','16:45:00',1.29),('15087','2013-10-01','16:50:00',1.25),('15087','2013-10-01','16:55:00',1.23),('15087','2013-10-01','17:00:00',1.09),('15087','2013-10-01','17:05:00',1.06),('15087','2013-09-30','09:45:00',1),('15087','2013-09-30','09:50:00',1.3),('15087','2013-09-30','09:55:00',1.07),('15087','2013-09-30','10:00:00',1.01),('15087','2013-09-30','10:10:00',1.09),('15087','2013-09-30','10:15:00',1.1),('15087','2013-09-30','10:20:00',1.12),('15087','2013-09-30','10:25:00',1.31),('15087','2013-09-30','10:30:00',1.54),('15087','2013-09-30','10:35:00',1.75),('15087','2013-09-30','10:40:00',2.31),('15087','2013-09-30','10:45:00',3.38),('15087','2013-09-30','10:50:00',3.47),('15087','2013-09-30','10:55:00',3.13),('15087','2013-09-30','11:00:00',2.39),('15087','2013-09-30','11:05:00',2.15),('15087','2013-09-30','11:10:00',3.5),('15087','2013-09-30','11:15:00',2.62),('15087','2013-09-30','11:20:00',3.29),('15087','2013-09-30','11:25:00',2.11),('15087','2013-09-30','11:30:00',2.29),('15087','2013-09-30','11:35:00',2.07),('15087','2013-09-30','11:40:00',4.28),('15087','2013-09-30','11:45:00',1.89),('15087','2013-09-30','11:50:00',1.49),('15087','2013-09-30','11:55:00',1.35),('15087','2013-09-30','12:00:00',1.49),('15087','2013-09-30','12:05:00',1.05),('15087','2013-09-30','12:10:00',2.28),('15087','2013-09-30','12:15:00',4.14),('15087','2013-09-30','12:20:00',4.19),('15087','2013-09-30','12:25:00',4.13),('15087','2013-09-30','12:30:00',4),('15087','2013-09-30','12:35:00',4.03),('15087','2013-09-30','12:40:00',3.85),('15087','2013-09-30','12:45:00',3.43),('15087','2013-09-30','12:50:00',4.19),('15087','2013-09-30','12:55:00',4.12),('15087','2013-09-30','13:00:00',3.97),('15087','2013-09-30','13:05:00',4.28),('15087','2013-09-30','13:10:00',4.1),('15087','2013-09-30','13:15:00',4.23),('15087','2013-09-30','13:20:00',4.52),('15087','2013-09-30','13:25:00',4.68),('15087','2013-09-30','13:30:00',4.4),('15087','2013-09-30','13:35:00',3.8),('15087','2013-09-30','13:40:00',3.31),('15087','2013-09-30','13:45:00',1.65),('15087','2013-09-30','13:50:00',3.74),('15087','2013-09-30','13:55:00',3.01),('15087','2013-09-30','14:00:00',1.97),('15087','2013-09-30','14:05:00',1.33),('15087','2013-09-30','14:10:00',1.32),('15087','2013-09-30','14:15:00',1.25),('15087','2013-09-30','14:20:00',1.06),('15087','2013-09-30','14:25:00',1.22),('15087','2013-09-30','14:30:00',2.84),('15087','2013-09-30','14:35:00',2.57),('15087','2013-09-30','14:40:00',3.83),('15087','2013-09-30','14:45:00',3.45),('15087','2013-09-30','14:50:00',2.64),('15087','2013-09-30','14:55:00',2.1),('15087','2013-09-30','15:00:00',1.99),('15087','2013-09-30','15:05:00',2.85),('15087','2013-09-30','15:10:00',3.6),('15087','2013-09-30','15:15:00',2.07),('15087','2013-09-30','15:20:00',1.68),('15087','2013-09-30','15:25:00',2.72),('15087','2013-09-30','15:30:00',1.6),('15087','2013-09-30','15:35:00',3.12),('15087','2013-09-30','15:40:00',3.12),('15087','2013-09-30','15:45:00',1.7),('15087','2013-09-30','16:10:00',1.25),('15087','2013-09-30','16:15:00',1.62),('15087','2013-09-30','16:20:00',1.47),('15087','2013-09-30','16:45:00',1.17),('15087','2013-09-29','08:50:00',1.25),('15087','2013-09-29','08:55:00',1.07),('15087','2013-09-29','09:00:00',1.04),('15087','2013-09-29','09:10:00',1.04),('15087','2013-09-29','09:15:00',1.25),('15087','2013-09-29','09:55:00',1.05),('15087','2013-09-29','10:00:00',1.25),('15087','2013-09-29','10:05:00',1.8),('15087','2013-09-29','10:10:00',2.1),('15087','2013-09-29','10:15:00',2.66),('15087','2013-09-29','10:20:00',2.14),('15087','2013-09-29','10:25:00',2.15),('15087','2013-09-29','10:30:00',2.45),('15087','2013-09-29','10:35:00',2.66),('15087','2013-09-29','10:40:00',2.67),('15087','2013-09-29','10:45:00',2.78),('15087','2013-09-29','10:50:00',2.91),('15087','2013-09-29','10:55:00',2.92),('15087','2013-09-29','11:00:00',2.97),('15087','2013-09-29','11:05:00',2.84),('15087','2013-09-29','11:10:00',2.88),('15087','2013-09-29','11:15:00',3.1),('15087','2013-09-29','11:20:00',3.08),('15087','2013-09-29','11:25:00',2.9),('15087','2013-09-29','11:30:00',3.12),('15087','2013-09-29','11:35:00',3.06),('15087','2013-09-29','11:40:00',3.06),('15087','2013-09-29','11:45:00',3.33),('15087','2013-09-29','11:50:00',3.42),('15087','2013-09-29','11:55:00',3.52),('15087','2013-09-29','12:00:00',3.1),('15087','2013-09-29','12:05:00',2.53),('15087','2013-09-29','12:10:00',3.67),('15087','2013-09-29','12:15:00',3.92),('15087','2013-09-29','12:20:00',2.14),('15087','2013-09-29','12:25:00',1.79),('15087','2013-09-29','12:30:00',1.96),('15087','2013-09-29','12:35:00',1.88),('15087','2013-09-29','12:40:00',1.6),('15087','2013-09-29','12:45:00',1.39),('15087','2013-09-29','12:50:00',1.37),('15087','2013-09-29','12:55:00',1.22),('15087','2013-09-29','13:00:00',1.18),('15087','2013-09-29','13:05:00',1.04),('15087','2013-09-29','13:10:00',1.05),('15087','2013-09-29','13:25:00',1.42),('15087','2013-09-29','13:30:00',1.81),('15087','2013-09-29','13:35:00',2.02),('15087','2013-09-29','13:40:00',1.8),('15087','2013-09-29','13:45:00',1.58),('15087','2013-09-29','13:50:00',1.73),('15087','2013-09-29','13:55:00',2.06),('15087','2013-09-29','14:00:00',1.94),('15087','2013-09-29','14:05:00',2.31),('15087','2013-09-29','14:10:00',1.32),('15087','2013-09-29','14:15:00',1.77),('15087','2013-09-29','14:20:00',2.62),('15087','2013-09-29','14:25:00',1.47),('15087','2013-09-29','14:30:00',1.51),('15087','2013-09-29','14:35:00',1.27),('15087','2013-09-29','14:55:00',1.02),('15087','2013-09-29','15:00:00',1.16),('15087','2013-09-29','16:00:00',1.16),('15087','2013-09-29','16:30:00',1.15),('15087','2013-09-29','16:35:00',1.04),('15087','2014-04-14','08:00:00',1.04),('15087','2014-04-14','08:05:00',1.13),('15087','2014-04-14','08:10:00',1.23),('15087','2014-04-14','08:15:00',1.34),('15087','2014-04-14','08:20:00',1.43),('15087','2014-04-14','08:25:00',1.52),('15087','2014-04-14','08:30:00',1.67),('15087','2014-04-14','08:35:00',1.8),('15087','2014-04-14','08:40:00',1.9),('15087','2014-04-14','08:45:00',1.99),('15087','2014-04-14','08:50:00',2.1),('15087','2014-04-14','08:55:00',2.2),('15087','2014-04-14','09:00:00',2.3),('15087','2014-04-14','09:05:00',2.4),('15087','2014-04-14','09:10:00',2.48),('15087','2014-04-14','09:15:00',2.57),('15087','2014-04-14','09:20:00',2.64),('15087','2014-04-14','09:25:00',2.72),('15087','2014-04-14','09:30:00',2.81),('15087','2014-04-14','09:35:00',2.89),('15087','2014-04-14','09:40:00',2.96),('15087','2014-04-14','09:45:00',3.05),('15087','2014-04-14','09:50:00',3.15),('15087','2014-04-14','09:55:00',3.2),('15087','2014-04-14','10:00:00',3.29),('15087','2014-04-14','10:05:00',3.37),('15087','2014-04-14','10:10:00',3.43),('15087','2014-04-14','10:15:00',3.51),('15087','2014-04-14','10:20:00',3.57),('15087','2014-04-14','10:25:00',3.63),('15087','2014-04-14','10:30:00',3.7),('15087','2014-04-14','10:35:00',3.76),('15087','2014-04-14','10:40:00',3.77),('15087','2014-04-14','10:45:00',3.88),('15087','2014-04-14','10:50:00',3.92),('15087','2014-04-14','10:55:00',3.96),('15087','2014-04-14','11:00:00',4),('15087','2014-04-14','11:05:00',4.07),('15087','2014-04-14','11:10:00',4.04),('15087','2014-04-14','11:15:00',4.15),('15087','2014-04-14','11:20:00',4.19),('15087','2014-04-14','11:25:00',4.25),('15087','2014-04-14','11:30:00',4.3),('15087','2014-04-14','11:35:00',4.35),('15087','2014-04-14','11:40:00',4.37),('15087','2014-04-14','11:45:00',4.4),('15087','2014-04-14','11:50:00',4.42),('15087','2014-04-14','11:55:00',4.46),('15087','2014-04-14','12:00:00',4.49),('15087','2014-04-14','12:05:00',4.53),('15087','2014-04-14','12:10:00',4.55),('15087','2014-04-14','12:15:00',4.56),('15087','2014-04-14','12:20:00',4.57),('15087','2014-04-14','12:25:00',4.6),('15087','2014-04-14','12:30:00',4.59),('15087','2014-04-14','12:35:00',4.62),('15087','2014-04-14','12:40:00',4.62),('15087','2014-04-14','12:45:00',4.63),('15087','2014-04-14','12:50:00',4.64),('15087','2014-04-14','12:55:00',4.65),('15087','2014-04-14','13:00:00',4.66),('15087','2014-04-14','13:05:00',4.63),('15087','2014-04-14','13:10:00',4.61),('15087','2014-04-14','13:15:00',4.69),('15087','2014-04-14','13:20:00',4.66),('15087','2014-04-14','13:25:00',4.65),('15087','2014-04-14','13:30:00',4.64),('15087','2014-04-14','13:35:00',4.68),('15087','2014-04-14','13:40:00',4.68),('15087','2014-04-14','13:45:00',4.64),('15087','2014-04-14','13:50:00',4.62),('15087','2014-04-14','13:55:00',4.38),('15087','2014-04-14','14:00:00',4.5),('15087','2014-04-14','14:05:00',4.55),('15087','2014-04-14','14:10:00',4.51),('15087','2014-04-14','14:15:00',4.45),('15087','2014-04-14','14:20:00',4.42),('15087','2014-04-14','14:25:00',4.39),('15087','2014-04-14','14:30:00',4.35),('15087','2014-04-14','14:35:00',4.17),('15087','2014-04-14','14:40:00',4),('15087','2014-04-14','14:45:00',4.13),('15087','2014-04-14','14:50:00',4.13),('15087','2014-04-14','14:55:00',4.06),('15087','2014-04-14','15:00:00',3.97),('15087','2014-04-14','15:05:00',3.94),('15087','2014-04-14','15:10:00',3.9),('15087','2014-04-14','15:15:00',3.69),('15087','2014-04-14','15:20:00',3.57),('15087','2014-04-14','15:25:00',3.35),('15087','2014-04-14','15:30:00',3.51),('15087','2014-04-14','15:35:00',3.49),('15087','2014-04-14','15:40:00',3.34),('15087','2014-04-14','15:45:00',3.39),('15087','2014-04-14','15:50:00',3.36),('15087','2014-04-14','15:55:00',3.3),('15087','2014-04-14','16:00:00',3.23),('15087','2014-04-14','16:05:00',3.16),('15087','2014-04-14','16:10:00',3.09),('15087','2014-04-14','16:15:00',3.02),('15087','2014-04-14','16:20:00',2.96),('15087','2014-04-14','16:25:00',2.89),('15087','2014-04-14','16:30:00',2.8),('15087','2014-04-14','16:35:00',2.73),('15087','2014-04-14','16:40:00',2.65),('15087','2014-04-14','16:45:00',2.58),('15087','2014-04-14','16:50:00',2.49),('15087','2014-04-14','16:55:00',2.4),('15087','2014-04-14','17:00:00',2.32),('15087','2014-04-14','17:05:00',2.24),('15087','2014-04-14','17:10:00',2.14),('15087','2014-04-14','17:15:00',2),('15087','2014-04-14','17:20:00',1.87),('15087','2014-04-14','17:25:00',1.68),('15087','2014-04-14','17:30:00',1.58),('15087','2014-04-14','17:35:00',1.43),('15087','2014-04-14','17:40:00',1.32),('15087','2014-04-14','17:45:00',1.29),('15087','2014-04-14','17:50:00',1.18),('15087','2014-04-14','17:55:00',1.16),('15087','2014-04-14','18:00:00',1.05),('15087','2014-04-14','18:05:00',1.02),('15087','2013-09-28','08:35:00',1.03),('15087','2013-09-28','08:40:00',1.15),('15087','2013-09-28','08:45:00',1.23),('15087','2013-09-28','08:50:00',1.31),('15087','2013-09-28','08:55:00',1.38),('15087','2013-09-28','09:00:00',1.43),('15087','2013-09-28','09:05:00',1.53),('15087','2013-09-28','09:10:00',1.66),('15087','2013-09-28','09:15:00',1.74),('15087','2013-09-28','09:20:00',1.81),('15087','2013-09-28','09:25:00',2),('15087','2013-09-28','09:30:00',1.95),('15087','2013-09-28','09:35:00',2.08),('15087','2013-09-28','09:40:00',2.2),('15087','2013-09-28','09:45:00',2.32),('15087','2013-09-28','09:50:00',2.5),('15087','2013-09-28','09:55:00',2.57),('15087','2013-09-28','10:00:00',2.12),('15087','2013-09-28','10:05:00',1.8),('15087','2013-09-28','10:10:00',1.14),('15087','2013-09-28','10:15:00',2.53),('15087','2013-09-28','10:20:00',2.61),('15087','2013-09-28','10:25:00',1.29),('15087','2013-09-28','10:30:00',2.25),('15087','2013-09-28','10:35:00',2.1),('15087','2013-09-28','10:40:00',2.57),('15087','2013-09-28','10:45:00',3.66),('15087','2013-09-28','10:50:00',3.76),('15087','2013-09-28','10:55:00',2.96),('15087','2013-09-28','11:05:00',1.01),('15087','2013-09-28','11:10:00',2.51),('15087','2013-09-28','11:15:00',3.9),('15087','2013-09-28','11:20:00',3.99),('15087','2013-09-28','11:25:00',4.03),('15087','2013-09-28','11:30:00',4.04),('15087','2013-09-28','11:35:00',2.55),('15087','2013-09-28','11:50:00',1.8),('15087','2013-09-28','11:55:00',2.08),('15087','2013-09-28','12:00:00',4.18),('15087','2013-09-28','12:05:00',2.77),('15087','2013-09-28','12:10:00',3.24),('15087','2013-09-28','12:15:00',2.69),('15087','2013-09-28','12:20:00',4),('15087','2013-09-28','12:25:00',3.25),('15087','2013-09-28','12:30:00',3.34),('15087','2013-09-28','12:35:00',3.86),('15087','2013-09-28','12:40:00',4.03),('15087','2013-09-28','12:45:00',3.45),('15087','2013-09-28','12:50:00',3.21),('15087','2013-09-28','12:55:00',4.19),('15087','2013-09-28','13:00:00',3.82),('15087','2013-09-28','13:05:00',1.35),('15087','2013-09-28','13:10:00',2.94),('15087','2013-09-28','13:15:00',4.04),('15087','2013-09-28','13:20:00',4.08),('15087','2013-09-28','13:25:00',3.36),('15087','2013-09-28','13:30:00',1.55),('15087','2013-09-28','13:35:00',1.71),('15087','2013-09-28','13:40:00',1.74),('15087','2013-09-28','13:45:00',3.3),('15087','2013-09-28','13:50:00',1.84),('15087','2013-09-28','13:55:00',1.93),('15087','2013-09-28','14:00:00',2.05),('15087','2013-09-28','14:05:00',1.79),('15087','2013-09-28','14:10:00',3.05),('15087','2013-09-28','14:15:00',4.06),('15087','2013-09-28','14:20:00',3.9),('15087','2013-09-28','14:25:00',3.56),('15087','2013-09-28','14:30:00',3.59),('15087','2013-09-28','14:35:00',3.65),('15087','2013-09-28','14:40:00',3.44),('15087','2013-09-28','14:45:00',3.1),('15087','2013-09-28','14:50:00',3.27),('15087','2013-09-28','14:55:00',3.22),('15087','2013-09-28','15:00:00',3.18),('15087','2013-09-28','15:05:00',3.15),('15087','2013-09-28','15:10:00',2.78),('15087','2013-09-28','15:15:00',2.81),('15087','2013-09-28','15:20:00',2.9),('15087','2013-09-28','15:25:00',2.68),('15087','2013-09-28','15:30:00',2.69),('15087','2013-09-28','15:35:00',2.59),('15087','2013-09-28','15:40:00',2.52),('15087','2013-09-28','15:45:00',2.46),('15087','2013-09-28','15:50:00',2.18),('15087','2013-09-28','15:55:00',2.16),('15087','2013-09-28','16:00:00',2.24),('15087','2013-09-28','16:05:00',2.24),('15087','2013-09-28','16:10:00',2.09),('15087','2013-09-28','16:15:00',1.34),('15087','2013-09-28','16:20:00',1.22),('15087','2013-09-28','16:25:00',1.61),('15087','2013-09-28','16:30:00',1.57),('15087','2013-09-28','16:35:00',1.54),('15087','2013-09-28','16:40:00',1.44),('15087','2013-09-28','16:45:00',1.35),('15087','2013-09-28','16:50:00',1.28),('15087','2013-09-28','16:55:00',1.24),('15087','2013-09-28','17:00:00',1.19),('15087','2013-09-28','17:05:00',1.03),('15087','2013-09-27','08:35:00',1.16),('15087','2013-09-27','08:40:00',1.11),('15087','2013-09-27','08:45:00',1.09),('15087','2013-09-27','08:50:00',1.29),('15087','2013-09-27','08:55:00',1.59),('15087','2013-09-27','09:00:00',1.48),('15087','2013-09-27','09:05:00',1.05),('15087','2013-09-27','09:15:00',1.1),('15087','2013-09-27','09:50:00',2.28),('15087','2013-09-27','09:55:00',2.13),('15087','2013-09-27','10:00:00',2.37),('15087','2013-09-27','10:05:00',1.78),('15087','2013-09-27','10:10:00',2.43),('15087','2013-09-27','10:15:00',1.84),('15087','2013-09-27','10:20:00',2.7),('15087','2013-09-27','10:25:00',1.64),('15087','2013-09-27','10:30:00',1.39),('15087','2013-09-27','10:35:00',1.34),('15087','2013-09-27','10:40:00',1.42),('15087','2013-09-27','10:45:00',1.16),('15087','2013-09-27','10:50:00',1.41),('15087','2013-09-27','10:55:00',2.9),('15087','2013-09-27','11:00:00',2.77),('15087','2013-09-27','11:05:00',2.49),('15087','2013-09-27','11:10:00',2.41),('15087','2013-09-27','11:15:00',2.3),('15087','2013-09-27','11:20:00',3.5),('15087','2013-09-27','11:25:00',2.81),('15087','2013-09-27','11:30:00',1.72),('15087','2013-09-27','11:35:00',1.09),('15087','2013-09-27','11:40:00',1.02),('15087','2013-09-27','11:45:00',1.23),('15087','2013-09-27','11:50:00',1.32),('15087','2013-09-27','11:55:00',1.81),('15087','2013-09-27','12:00:00',3.17),('15087','2013-09-27','12:05:00',2.2),('15087','2013-09-27','12:10:00',3.89),('15087','2013-09-27','12:15:00',1.06),('15087','2013-09-27','12:40:00',1.48),('15087','2013-09-27','12:45:00',1.88),('15087','2013-09-27','12:50:00',3.46),('15087','2013-09-27','12:55:00',3.84),('15087','2013-09-27','13:00:00',3.71),('15087','2013-09-27','13:05:00',3.35),('15087','2013-09-27','13:10:00',3.35),('15087','2013-09-27','13:15:00',1.58),('15087','2013-09-27','13:20:00',1.92),('15087','2013-09-27','13:25:00',1.14),('15087','2013-09-27','13:40:00',2.49),('15087','2013-09-27','13:45:00',1.04),('15087','2013-09-27','13:50:00',1.02),('15087','2013-09-27','13:55:00',1.96),('15087','2013-09-27','14:00:00',3.68),('15087','2013-09-27','14:05:00',3.49),('15087','2013-09-27','14:10:00',3.49),('15087','2013-09-27','14:15:00',3.52),('15087','2013-09-27','14:20:00',3.54),('15087','2013-09-27','14:25:00',2.48),('15087','2013-09-27','14:30:00',3.2),('15087','2013-09-27','14:35:00',3.24),('15087','2013-09-27','14:40:00',3.3),('15087','2013-09-27','14:45:00',3.13),('15087','2013-09-27','14:50:00',2.81),('15087','2013-09-27','14:55:00',2.94),('15087','2013-09-27','15:00:00',3.03),('15087','2013-09-27','15:05:00',1.37),('15087','2013-09-27','15:10:00',2.67),('15087','2013-09-27','15:15:00',2.69),('15087','2013-09-27','15:20:00',2.48),('15087','2013-09-27','15:25:00',2.52),('15087','2013-09-27','15:30:00',2.78),('15087','2013-09-27','15:35:00',2.65),('15087','2013-09-27','15:40:00',1.34),('15087','2013-09-27','15:45:00',2.08),('15087','2013-09-27','15:50:00',2.59),('15087','2013-09-27','15:55:00',2.28),('15087','2013-09-27','16:00:00',1.72),('15087','2013-09-27','16:05:00',1.23),('15087','2013-09-27','16:10:00',1.15),('15087','2013-09-27','16:15:00',1.71),('15087','2013-09-27','16:20:00',1.88),('15087','2013-09-27','16:25:00',1.53),('15087','2013-09-27','16:30:00',1.68),('15087','2013-09-27','16:35:00',1.6),('15087','2013-09-27','16:40:00',1.49),('15087','2013-09-27','16:45:00',1.43),('15087','2013-09-27','16:50:00',1.33),('15087','2013-09-27','17:10:00',1.15),('15087','2013-09-27','17:15:00',1.07),('15087','2013-09-26','08:35:00',1.02),('15087','2013-09-26','08:40:00',1.22),('15087','2013-09-26','08:45:00',1.34),('15087','2013-09-26','08:50:00',1.42),('15087','2013-09-26','08:55:00',1.52),('15087','2013-09-26','09:00:00',1.64),('15087','2013-09-26','09:05:00',1.71),('15087','2013-09-26','09:10:00',1.82),('15087','2013-09-26','09:15:00',1.92),('15087','2013-09-26','09:20:00',1.98),('15087','2013-09-26','09:25:00',2.07),('15087','2013-09-26','09:30:00',2.19),('15087','2013-09-26','09:35:00',2.28),('15087','2013-09-26','09:40:00',2.36),('15087','2013-09-26','09:45:00',2.43),('15087','2013-09-26','09:50:00',2.5),('15087','2013-09-26','09:55:00',2.55),('15087','2013-09-26','10:00:00',2.63),('15087','2013-09-26','10:05:00',2.71),('15087','2013-09-26','10:10:00',2.75),('15087','2013-09-26','10:15:00',2.79),('15087','2013-09-26','10:20:00',2.87),('15087','2013-09-26','10:25:00',2.86),('15087','2013-09-26','10:30:00',2.98),('15087','2013-09-26','10:35:00',3.05),('15087','2013-09-26','10:40:00',3.08),('15087','2013-09-26','10:45:00',3.11),('15087','2013-09-26','10:50:00',3.16),('15087','2013-09-26','10:55:00',3.15),('15087','2013-09-26','11:00:00',3.2),('15087','2013-09-26','11:05:00',3.29),('15087','2013-09-26','11:10:00',3.36),('15087','2013-09-26','11:15:00',3.34),('15087','2013-09-26','11:20:00',3.31),('15087','2013-09-26','11:25:00',3.33),('15087','2013-09-26','11:30:00',2.58),('15087','2013-09-26','11:35:00',2.19),('15087','2013-09-26','11:40:00',3.56),('15087','2013-09-26','11:45:00',3.34),('15087','2013-09-26','11:50:00',3.71),('15087','2013-09-26','11:55:00',3.93),('15087','2013-09-26','12:00:00',3.21),('15087','2013-09-26','12:05:00',4.1),('15087','2013-09-26','12:10:00',1.29),('15087','2013-09-26','12:15:00',1.39),('15087','2013-09-26','12:20:00',1.85),('15087','2013-09-26','12:25:00',1.23),('15087','2013-09-26','12:30:00',1.43),('15087','2013-09-26','12:35:00',1.73),('15087','2013-09-26','12:40:00',1.57),('15087','2013-09-26','12:45:00',1.59),('15087','2013-09-26','12:50:00',1.69),('15087','2013-09-26','12:55:00',3.8),('15087','2013-09-26','13:00:00',2.71),('15087','2013-09-26','13:05:00',2.33),('15087','2013-09-26','13:10:00',2.42),('15087','2013-09-26','13:15:00',4.4),('15087','2013-09-26','13:20:00',4.3),('15087','2013-09-26','13:25:00',2.71),('15087','2013-09-26','13:30:00',2.42),('15087','2013-09-26','13:35:00',1.97),('15087','2013-09-26','13:40:00',1.62),('15087','2013-09-26','13:45:00',1.48),('15087','2013-09-26','13:50:00',2.2),('15087','2013-09-26','13:55:00',2.2),('15087','2013-09-26','14:00:00',2.5),('15087','2013-09-26','14:05:00',4.06),('15087','2013-09-26','14:10:00',3.41),('15087','2013-09-26','14:15:00',2.69),('15087','2013-09-26','14:20:00',1.48),('15087','2013-09-26','14:30:00',1.94),('15087','2013-09-26','14:35:00',1.03),('15087','2013-09-26','14:40:00',2.12),('15087','2013-09-26','14:45:00',3.82),('15087','2013-09-26','14:50:00',3.25),('15087','2013-09-26','14:55:00',1.61),('15087','2013-09-26','15:00:00',1.24),('15087','2013-09-26','15:05:00',1.79),('15087','2013-09-26','15:10:00',1.04),('15087','2013-09-26','15:15:00',1.08),('15087','2013-09-26','15:20:00',2.61),('15087','2013-09-26','15:25:00',1.12),('15087','2013-09-26','15:35:00',2.19),('15087','2013-09-26','15:45:00',1.06),('15087','2013-09-26','15:50:00',2.07),('15087','2013-09-26','15:55:00',2.39),('15087','2013-09-26','16:00:00',2.15),('15087','2013-09-26','16:10:00',1.92),('15087','2013-09-26','16:15:00',1.88),('15087','2013-09-26','16:20:00',1.76),('15087','2013-09-26','16:25:00',1.77),('15087','2013-09-26','16:30:00',1.7),('15087','2013-09-26','16:35:00',1.65),('15087','2013-09-26','16:40:00',1.57),('15087','2013-09-26','16:45:00',1.46),('15087','2013-09-26','16:50:00',1.36),('15087','2013-09-26','16:55:00',1.24),('15087','2013-09-26','17:00:00',1.2),('15087','2013-09-26','17:05:00',1.1),('15087','2013-09-26','17:10:00',1.06),('15087','2013-09-25','08:30:00',1.02),('15087','2013-09-25','08:45:00',1.42),('15087','2013-09-25','09:05:00',1.6),('15087','2013-09-25','09:10:00',1.74),('15087','2013-09-25','09:15:00',1.29),('15087','2013-09-25','09:20:00',1.12),('15087','2013-09-25','09:25:00',1.87),('15087','2013-09-25','09:30:00',1.57),('15087','2013-09-25','09:35:00',2.41),('15087','2013-09-25','09:40:00',2.15),('15087','2013-09-25','09:55:00',2.22),('15087','2013-09-25','10:00:00',2.44),('15087','2013-09-25','10:05:00',1.3),('15087','2013-09-25','10:20:00',1.62),('15087','2013-09-25','10:25:00',1.51),('15087','2013-09-25','10:30:00',1.57),('15087','2013-09-25','10:35:00',1.24),('15087','2013-09-25','10:40:00',2.09),('15087','2013-09-25','10:45:00',3.43),('15087','2013-09-25','10:50:00',3.43),('15087','2013-09-25','10:55:00',2.45),('15087','2013-09-25','11:00:00',2.29),('15087','2013-09-25','11:05:00',1.56),('15087','2013-09-25','11:10:00',1.24),('15087','2013-09-25','11:15:00',2.91),('15087','2013-09-25','11:20:00',2.99),('15087','2013-09-25','11:25:00',3.53),('15087','2013-09-25','11:30:00',3.59),('15087','2013-09-25','11:35:00',3.3),('15087','2013-09-25','11:40:00',3.82),('15087','2013-09-25','11:45:00',2.95),('15087','2013-09-25','11:50:00',1.57),('15087','2013-09-25','11:55:00',1.48),('15087','2013-09-25','12:10:00',2.66),('15087','2013-09-25','12:15:00',3.89),('15087','2013-09-25','12:20:00',1.17),('15087','2013-09-25','12:25:00',1.14),('15087','2013-09-25','12:30:00',4.2),('15087','2013-09-25','12:35:00',3.67),('15087','2013-09-25','12:40:00',1.05),('15087','2013-09-25','12:45:00',1.96),('15087','2013-09-25','12:50:00',1.41),('15087','2013-09-25','12:55:00',1.02),('15087','2013-09-25','13:00:00',1.83),('15087','2013-09-25','13:10:00',1.4),('15087','2013-09-25','13:15:00',2),('15087','2013-09-25','13:20:00',1.34),('15087','2013-09-25','13:25:00',3.86),('15087','2013-09-25','13:30:00',2.17),('15087','2013-09-25','13:35:00',4.58),('15087','2013-09-25','13:40:00',4.48),('15087','2013-09-25','13:45:00',4.43),('15087','2013-09-25','13:50:00',4.26),('15087','2013-09-25','13:55:00',1.16),('15087','2013-09-25','14:05:00',1.06),('15087','2013-09-25','14:10:00',1.11),('15087','2013-09-25','14:20:00',1.11),('15087','2013-09-25','14:25:00',1.4),('15087','2013-09-25','14:30:00',3.05),('15087','2013-09-25','14:35:00',3.95),('15087','2013-09-25','14:40:00',3.86),('15087','2013-09-25','14:45:00',1.9),('15087','2013-09-25','14:50:00',3.34),('15087','2013-09-25','14:55:00',2.8),('15087','2013-09-25','15:00:00',3.44),('15087','2013-09-25','15:05:00',3.18),('15087','2013-09-25','15:10:00',3.06),('15087','2013-09-25','15:15:00',2.6),('15087','2013-09-25','15:20:00',2.64),('15087','2013-09-25','15:25:00',2.92),('15087','2013-09-25','15:30:00',2.14),('15087','2013-09-25','15:35:00',2.96),('15087','2013-09-25','15:40:00',2.81),('15087','2013-09-25','15:45:00',2.65),('15087','2013-09-25','15:50:00',2.47),('15087','2013-09-25','15:55:00',2.48),('15087','2013-09-25','16:00:00',2.32),('15087','2013-09-25','16:05:00',2.23),('15087','2013-09-25','16:10:00',2.18),('15087','2013-09-25','16:15:00',2.08),('15087','2013-09-25','16:20:00',1.57),('15087','2013-09-25','16:25:00',1.41),('15087','2013-09-25','16:30:00',1.85),('15087','2013-09-25','16:35:00',1.77),('15087','2013-09-25','16:40:00',1.4),('15087','2013-09-25','16:45:00',1.52),('15087','2013-09-25','16:50:00',1.4),('15087','2013-09-25','16:55:00',1.36),('15087','2013-09-25','17:00:00',1.32),('15087','2013-09-25','17:05:00',1.22),('15087','2013-09-25','17:10:00',1.1),('15087','2013-09-25','17:15:00',1.08),('15087','2013-09-24','08:25:00',1.03),('15087','2013-09-24','08:30:00',1.13),('15087','2013-09-24','08:35:00',1.22),('15087','2013-09-24','08:40:00',1.34),('15087','2013-09-24','08:45:00',1.42),('15087','2013-09-24','08:50:00',1.51),('15087','2013-09-24','08:55:00',1.63),('15087','2013-09-24','09:00:00',1.75),('15087','2013-09-24','09:05:00',1.84),('15087','2013-09-24','09:10:00',1.93),('15087','2013-09-24','09:15:00',2.04),('15087','2013-09-24','09:20:00',2.14),('15087','2013-09-24','09:25:00',2.23),('15087','2013-09-24','09:30:00',2.32),('15087','2013-09-24','09:35:00',2.4),('15087','2013-09-24','09:40:00',2.47),('15087','2013-09-24','09:45:00',2.54),('15087','2013-09-24','09:50:00',2.61),('15087','2013-09-24','09:55:00',2.69),('15087','2013-09-24','10:00:00',2.78),('15087','2013-09-24','10:05:00',2.83),('15087','2013-09-24','10:10:00',2.89),('15087','2013-09-24','10:15:00',2.97),('15087','2013-09-24','10:20:00',3.03),('15087','2013-09-24','10:25:00',3.1),('15087','2013-09-24','10:30:00',3.15),('15087','2013-09-24','10:35:00',3.21),('15087','2013-09-24','10:40:00',3.24),('15087','2013-09-24','10:45:00',3.3),('15087','2013-09-24','10:50:00',3.35),('15087','2013-09-24','10:55:00',3.35),('15087','2013-09-24','11:00:00',3.43),('15087','2013-09-24','11:05:00',3.48),('15087','2013-09-24','11:10:00',3.51),('15087','2013-09-24','11:15:00',3.52),('15087','2013-09-24','11:20:00',3.56),('15087','2013-09-24','11:25:00',3.61),('15087','2013-09-24','11:30:00',3.68),('15087','2013-09-24','11:35:00',3.67),('15087','2013-09-24','11:40:00',3.69),('15087','2013-09-24','11:45:00',3.7),('15087','2013-09-24','11:50:00',3.73),('15087','2013-09-24','11:55:00',3.77),('15087','2013-09-24','12:00:00',3.76),('15087','2013-09-24','12:05:00',3.78),('15087','2013-09-24','12:10:00',3.82),('15087','2013-09-24','12:15:00',3.82),('15087','2013-09-24','12:20:00',3.85),('15087','2013-09-24','12:25:00',3.86),('15087','2013-09-24','12:30:00',3.92),('15087','2013-09-24','12:35:00',3.88),('15087','2013-09-24','12:40:00',3.92),('15087','2013-09-24','12:45:00',3.94),('15087','2013-09-24','12:50:00',3.92),('15087','2013-09-24','12:55:00',3.95),('15087','2013-09-24','13:00:00',3.97),('15087','2013-09-24','13:05:00',3.98),('15087','2013-09-24','13:10:00',3.94),('15087','2013-09-24','13:15:00',3.96),('15087','2013-09-24','13:20:00',3.95),('15087','2013-09-24','13:25:00',3.88),('15087','2013-09-24','13:30:00',3.92),('15087','2013-09-24','13:35:00',3.92),('15087','2013-09-24','13:40:00',3.83),('15087','2013-09-24','13:45:00',3.54),('15087','2013-09-24','13:50:00',3.47),('15087','2013-09-24','13:55:00',3.7),('15087','2013-09-24','14:00:00',3.68),('15087','2013-09-24','14:05:00',3.47),('15087','2013-09-24','14:10:00',3.56),('15087','2013-09-24','14:15:00',3.58),('15087','2013-09-24','14:20:00',3.44),('15087','2013-09-24','14:25:00',3.43),('15087','2013-09-24','14:30:00',3.39),('15087','2013-09-24','14:35:00',3.31),('15087','2013-09-24','14:40:00',3.28),('15087','2013-09-24','14:45:00',3.18),('15087','2013-09-24','14:50:00',3.14),('15087','2013-09-24','14:55:00',3.06),('15087','2013-09-24','15:00:00',2.99),('15087','2013-09-24','15:05:00',2.75),('15087','2013-09-24','15:10:00',2.89),('15087','2013-09-24','15:15:00',2.81),('15087','2013-09-24','15:20:00',2.79),('15087','2013-09-24','15:25:00',2.67),('15087','2013-09-24','15:30:00',2.74),('15087','2013-09-24','15:35:00',2.63),('15087','2013-09-24','15:40:00',2.59),('15087','2013-09-24','15:45:00',2.59),('15087','2013-09-24','15:50:00',2.51),('15087','2013-09-24','15:55:00',2.42),('15087','2013-09-24','16:00:00',2.34),('15087','2013-09-24','16:05:00',2.22),('15087','2013-09-24','16:10:00',2.15),('15087','2013-09-24','16:15:00',2.11),('15087','2013-09-24','16:20:00',1.9),('15087','2013-09-24','16:25:00',1.85),('15087','2013-09-24','16:30:00',1.81),('15087','2013-09-24','16:35:00',1.69),('15087','2013-09-24','16:40:00',1.65),('15087','2013-09-24','16:45:00',1.58),('15087','2013-09-24','16:50:00',1.46),('15087','2013-09-24','16:55:00',1.4),('15087','2013-09-24','17:00:00',1.33),('15087','2013-09-24','17:05:00',1.25),('15087','2013-09-24','17:10:00',1.15),('15087','2013-09-24','17:15:00',1.06),('15087','2013-09-23','08:25:00',1.09),('15087','2013-09-23','08:30:00',1.18),('15087','2013-09-23','08:35:00',1.28),('15087','2013-09-23','08:40:00',1.38),('15087','2013-09-23','08:45:00',1.48),('15087','2013-09-23','08:50:00',1.58),('15087','2013-09-23','08:55:00',1.68),('15087','2013-09-23','09:00:00',1.79),('15087','2013-09-23','09:05:00',1.92),('15087','2013-09-23','09:10:00',2.02),('15087','2013-09-23','09:15:00',2.12),('15087','2013-09-23','09:20:00',2.2),('15087','2013-09-23','09:25:00',2.29),('15087','2013-09-23','09:30:00',2.38),('15087','2013-09-23','09:35:00',2.46),('15087','2013-09-23','09:40:00',2.53),('15087','2013-09-23','09:45:00',2.61),('15087','2013-09-23','09:50:00',2.68),('15087','2013-09-23','09:55:00',2.75),('15087','2013-09-23','10:00:00',2.82),('15087','2013-09-23','10:05:00',2.9),('15087','2013-09-23','10:10:00',2.95),('15087','2013-09-23','10:15:00',3.01),('15087','2013-09-23','10:20:00',3.07),('15087','2013-09-23','10:25:00',3.14),('15087','2013-09-23','10:30:00',3.2),('15087','2013-09-23','10:35:00',3.26),('15087','2013-09-23','10:40:00',3.33),('15087','2013-09-23','10:45:00',3.38),('15087','2013-09-23','10:50:00',3.44),('15087','2013-09-23','10:55:00',3.5),('15087','2013-09-23','11:00:00',3.52),('15087','2013-09-23','11:05:00',3.54),('15087','2013-09-23','11:10:00',3.63),('15087','2013-09-23','11:15:00',3.69),('15087','2013-09-23','11:20:00',3.74),('15087','2013-09-23','11:25:00',3.77),('15087','2013-09-23','11:30:00',3.83),('15087','2013-09-23','11:35:00',3.87),('15087','2013-09-23','11:40:00',3.88),('15087','2013-09-23','11:45:00',3.92),('15087','2013-09-23','11:50:00',3.96),('15087','2013-09-23','11:55:00',4),('15087','2013-09-23','12:00:00',4.02),('15087','2013-09-23','12:05:00',4.03),('15087','2013-09-23','12:10:00',4.06),('15087','2013-09-23','12:15:00',4.08),('15087','2013-09-23','12:20:00',4.06),('15087','2013-09-23','12:25:00',4.08),('15087','2013-09-23','12:30:00',4.08),('15087','2013-09-23','12:35:00',4.08),('15087','2013-09-23','12:40:00',4.1),('15087','2013-09-23','12:45:00',4.08),('15087','2013-09-23','12:50:00',4.06),('15087','2013-09-23','12:55:00',4.04),('15087','2013-09-23','13:00:00',4.08),('15087','2013-09-23','13:05:00',4.06),('15087','2013-09-23','13:10:00',4.02),('15087','2013-09-23','13:15:00',4.01),('15087','2013-09-23','13:20:00',3.99),('15087','2013-09-23','13:25:00',3.87),('15087','2013-09-23','13:30:00',3.95),('15087','2013-09-23','13:35:00',3.95),('15087','2013-09-23','13:40:00',3.88),('15087','2013-09-23','13:45:00',3.72),('15087','2013-09-23','13:50:00',3.51),('15087','2013-09-23','13:55:00',3.75),('15087','2013-09-23','14:00:00',3.68),('15087','2013-09-23','14:05:00',3.54),('15087','2013-09-23','14:10:00',3.54),('15087','2013-09-23','14:15:00',3.67),('15087','2013-09-23','14:20:00',3.53),('15087','2013-09-23','14:25:00',3.52),('15087','2013-09-23','14:30:00',3.54),('15087','2013-09-23','14:35:00',3.35),('15087','2013-09-23','14:40:00',3.32),('15087','2013-09-23','14:45:00',3.18),('15087','2013-09-23','14:50:00',2.99),('15087','2013-09-23','14:55:00',3.01),('15087','2013-09-23','15:00:00',3.22),('15087','2013-09-23','15:05:00',3.22),('15087','2013-09-23','15:10:00',1.79),('15087','2013-09-23','15:15:00',2.79),('15087','2013-09-23','15:20:00',2.27),('15087','2013-09-23','15:25:00',2.51),('15087','2013-09-23','15:30:00',2.8),('15087','2013-09-23','15:35:00',2.73),('15087','2013-09-23','15:40:00',2.62),('15087','2013-09-23','15:45:00',2.56),('15087','2013-09-23','15:50:00',2.18),('15087','2013-09-23','15:55:00',2.23),('15087','2013-09-23','16:00:00',2.27),('15087','2013-09-23','16:05:00',2.16),('15087','2013-09-23','16:10:00',1.93),('15087','2013-09-23','16:15:00',2),('15087','2013-09-23','16:20:00',1.99),('15087','2013-09-23','16:25:00',1.93),('15087','2013-09-23','16:30:00',1.74),('15087','2013-09-23','16:35:00',1.57),('15087','2013-09-23','16:40:00',1.72),('15087','2013-09-23','16:45:00',1.6),('15087','2013-09-23','16:50:00',1.45),('15087','2013-09-23','16:55:00',1.36),('15087','2013-09-23','17:00:00',1.28),('15087','2013-09-23','17:05:00',1.22),('15087','2013-09-23','17:10:00',1.12),('15087','2013-09-23','17:15:00',1.01),('15087','2013-09-22','08:25:00',1.09),('15087','2013-09-22','08:30:00',1.16),('15087','2013-09-22','08:35:00',1.25),('15087','2013-09-22','08:40:00',1.33),('15087','2013-09-22','08:45:00',1.43),('15087','2013-09-22','08:50:00',1.52),('15087','2013-09-22','08:55:00',1.62),('15087','2013-09-22','09:00:00',1.75),('15087','2013-09-22','09:05:00',1.89),('15087','2013-09-22','09:10:00',1.99),('15087','2013-09-22','09:15:00',2.1),('15087','2013-09-22','09:20:00',2.2),('15087','2013-09-22','09:25:00',2.29),('15087','2013-09-22','09:30:00',2.38),('15087','2013-09-22','09:35:00',2.47),('15087','2013-09-22','09:40:00',2.52),('15087','2013-09-22','09:45:00',2.6),('15087','2013-09-22','09:50:00',2.69),('15087','2013-09-22','09:55:00',2.76),('15087','2013-09-22','10:00:00',2.85),('15087','2013-09-22','10:05:00',2.94),('15087','2013-09-22','10:10:00',3),('15087','2013-09-22','10:15:00',3.08),('15087','2013-09-22','10:20:00',3.14),('15087','2013-09-22','10:25:00',3.19),('15087','2013-09-22','10:30:00',3.27),('15087','2013-09-22','10:35:00',3.35),('15087','2013-09-22','10:40:00',3.37),('15087','2013-09-22','10:45:00',3.43),('15087','2013-09-22','10:50:00',3.5),('15087','2013-09-22','10:55:00',3.55),('15087','2013-09-22','11:00:00',3.59),('15087','2013-09-22','11:05:00',3.62),('15087','2013-09-22','11:10:00',3.65),('15087','2013-09-22','11:15:00',3.69),('15087','2013-09-22','11:20:00',3.75),('15087','2013-09-22','11:25:00',3.79),('15087','2013-09-22','11:30:00',3.85),('15087','2013-09-22','11:35:00',3.89),('15087','2013-09-22','11:40:00',3.93),('15087','2013-09-22','11:45:00',3.96),('15087','2013-09-22','11:50:00',4),('15087','2013-09-22','11:55:00',4.02),('15087','2013-09-22','12:00:00',4.04),('15087','2013-09-22','12:05:00',4.07),('15087','2013-09-22','12:10:00',4.09),('15087','2013-09-22','12:15:00',4.1),('15087','2013-09-22','12:20:00',4.11),('15087','2013-09-22','12:25:00',4.07),('15087','2013-09-22','12:30:00',4.16),('15087','2013-09-22','12:35:00',4.15),('15087','2013-09-22','12:40:00',4.18),('15087','2013-09-22','12:45:00',4.18),('15087','2013-09-22','12:50:00',4.2),('15087','2013-09-22','12:55:00',4.22),('15087','2013-09-22','13:00:00',4.2),('15087','2013-09-22','13:05:00',4.16),('15087','2013-09-22','13:10:00',4.17),('15087','2013-09-22','13:15:00',4.15),('15087','2013-09-22','13:20:00',4.13),('15087','2013-09-22','13:25:00',4.06),('15087','2013-09-22','13:30:00',4.07),('15087','2013-09-22','13:35:00',4.08),('15087','2013-09-22','13:40:00',3.98),('15087','2013-09-22','13:45:00',3.99),('15087','2013-09-22','13:50:00',4.01),('15087','2013-09-22','13:55:00',4),('15087','2013-09-22','14:00:00',3.81),('15087','2013-09-22','14:05:00',3.77),('15087','2013-09-22','14:10:00',3.8),('15087','2013-09-22','14:15:00',3.69),('15087','2013-09-22','14:20:00',3),('15087','2013-09-22','14:25:00',3.39),('15087','2013-09-22','14:30:00',1.07),('15087','2013-09-22','14:35:00',3.46),('15087','2013-09-22','14:40:00',3.56),('15087','2013-09-22','14:45:00',3.53),('15087','2013-09-22','14:50:00',3.44),('15087','2013-09-22','14:55:00',3.37),('15087','2013-09-22','15:00:00',3.23),('15087','2013-09-22','15:05:00',3.28),('15087','2013-09-22','15:10:00',3.27),('15087','2013-09-22','15:15:00',3.53),('15087','2013-09-22','15:20:00',3.73),('15087','2013-09-22','15:25:00',1.98),('15087','2013-09-22','15:30:00',1.29),('15087','2013-09-22','15:35:00',1.1),('15087','2013-09-22','15:40:00',3.08),('15087','2013-09-22','15:45:00',2.86),('15087','2013-09-22','15:50:00',2.61),('15087','2013-09-22','15:55:00',2.64),('15087','2013-09-22','16:00:00',2.77),('15087','2013-09-22','16:05:00',2.81),('15087','2013-09-22','16:10:00',3.02),('15087','2013-09-22','16:15:00',2.83),('15087','2013-09-22','16:20:00',2.13),('15087','2013-09-22','16:25:00',1.51),('15087','2013-09-22','16:30:00',1.4),('15087','2013-09-22','16:35:00',1.14),('15087','2013-09-22','16:40:00',1.02),('15087','2013-09-22','16:45:00',1.55),('15087','2013-09-22','16:50:00',1.92),('15087','2013-09-22','16:55:00',1.46),('15087','2013-09-22','17:00:00',1.36),('15087','2013-09-22','17:05:00',1.73),('15087','2013-09-22','17:10:00',1.44),('15087','2013-09-21','08:25:00',1.07),('15087','2013-09-21','08:30:00',1.15),('15087','2013-09-21','08:35:00',1.25),('15087','2013-09-21','08:40:00',1.34),('15087','2013-09-21','08:45:00',1.43),('15087','2013-09-21','08:50:00',1.52),('15087','2013-09-21','08:55:00',1.63),('15087','2013-09-21','09:00:00',1.73),('15087','2013-09-21','09:05:00',1.86),('15087','2013-09-21','09:10:00',1.91),('15087','2013-09-21','09:15:00',2.02),('15087','2013-09-21','09:20:00',2.14),('15087','2013-09-21','09:25:00',2.22),('15087','2013-09-21','09:30:00',2.31),('15087','2013-09-21','09:35:00',2.4),('15087','2013-09-21','09:40:00',2.45),('15087','2013-09-21','09:45:00',2.55),('15087','2013-09-21','09:50:00',2.63),('15087','2013-09-21','09:55:00',2.69),('15087','2013-09-21','10:00:00',2.77),('15087','2013-09-21','10:05:00',2.85),('15087','2013-09-21','10:10:00',2.91),('15087','2013-09-21','10:15:00',2.98),('15087','2013-09-21','10:20:00',3.03),('15087','2013-09-21','10:25:00',3.1),('15087','2013-09-21','10:30:00',3.17),('15087','2013-09-21','10:35:00',3.21),('15087','2013-09-21','10:40:00',3.27),('15087','2013-09-21','10:45:00',3.34),('15087','2013-09-21','10:50:00',3.39),('15087','2013-09-21','10:55:00',3.45),('15087','2013-09-21','11:00:00',3.48),('15087','2013-09-21','11:05:00',3.51),('15087','2013-09-21','11:10:00',3.55),('15087','2013-09-21','11:15:00',3.6),('15087','2013-09-21','11:20:00',3.65),('15087','2013-09-21','11:25:00',3.7),('15087','2013-09-21','11:30:00',3.73),('15087','2013-09-21','11:35:00',3.76),('15087','2013-09-21','11:40:00',3.83),('15087','2013-09-21','11:45:00',3.86),('15087','2013-09-21','11:50:00',3.91),('15087','2013-09-21','11:55:00',3.84),('15087','2013-09-21','12:00:00',3.9),('15087','2013-09-21','12:05:00',3.95),('15087','2013-09-21','12:10:00',3.96),('15087','2013-09-21','12:15:00',4.02),('15087','2013-09-21','12:20:00',3.85),('15087','2013-09-21','12:25:00',3.69),('15087','2013-09-21','12:30:00',4.09),('15087','2013-09-21','12:35:00',3.95),('15087','2013-09-21','12:40:00',3.86),('15087','2013-09-21','12:45:00',3.95),('15087','2013-09-21','12:50:00',4.02),('15087','2013-09-21','12:55:00',4.1),('15087','2013-09-21','13:00:00',4.07),('15087','2013-09-21','13:05:00',3.96),('15087','2013-09-21','13:10:00',4.05),('15087','2013-09-21','13:15:00',4.15),('15087','2013-09-21','13:20:00',3.42),('15087','2013-09-21','13:25:00',3.9),('15087','2013-09-21','13:30:00',3.89),('15087','2013-09-21','13:35:00',3.88),('15087','2013-09-21','13:40:00',3.4),('15087','2013-09-21','13:45:00',3.2),('15087','2013-09-21','13:50:00',3.31),('15087','2013-09-21','13:55:00',3.39),('15087','2013-09-21','14:00:00',3.57),('15087','2013-09-21','14:05:00',3.53),('15087','2013-09-21','14:10:00',3.59),('15087','2013-09-21','14:15:00',3.72),('15087','2013-09-21','14:20:00',3.57),('15087','2013-09-21','14:25:00',3.63),('15087','2013-09-21','14:30:00',3.56),('15087','2013-09-21','14:35:00',3.51),('15087','2013-09-21','14:40:00',3.34),('15087','2013-09-21','14:45:00',3.32),('15087','2013-09-21','14:50:00',3.23),('15087','2013-09-21','14:55:00',3.21),('15087','2013-09-21','15:00:00',3.03),('15087','2013-09-21','15:05:00',2.89),('15087','2013-09-21','15:10:00',3.01),('15087','2013-09-21','15:15:00',2.85),('15087','2013-09-21','15:20:00',2.9),('15087','2013-09-21','15:25:00',2.86),('15087','2013-09-21','15:30:00',2.81),('15087','2013-09-21','15:35:00',2.75),('15087','2013-09-21','15:40:00',2.43),('15087','2013-09-21','15:45:00',1.66),('15087','2013-09-21','15:50:00',2.52),('15087','2013-09-21','15:55:00',2.34),('15087','2013-09-21','16:00:00',1.68),('15087','2013-09-21','16:05:00',1.16),('15087','2013-09-21','16:10:00',1.4),('15087','2013-09-21','16:15:00',1.23),('15087','2013-09-21','16:20:00',1.48),('15087','2013-09-21','16:30:00',1.11),('15087','2013-09-21','16:35:00',1.34),('15087','2013-09-21','16:55:00',1.07),('15087','2013-09-20','08:30:00',1.22),('15087','2013-09-20','08:35:00',1.29),('15087','2013-09-20','08:40:00',1.51),('15087','2013-09-20','08:45:00',1.34),('15087','2013-09-20','09:00:00',1.08),('15087','2013-09-20','09:05:00',1.23),('15087','2013-09-20','09:10:00',1.06),('15087','2013-09-20','09:15:00',1.25),('15087','2013-09-20','09:20:00',1.35),('15087','2013-09-20','09:25:00',1.41),('15087','2013-09-20','09:30:00',1.2),('15087','2013-09-20','09:35:00',1.22),('15087','2013-09-20','09:40:00',1.26),('15087','2013-09-20','09:45:00',1.35),('15087','2013-09-20','09:50:00',1.34),('15087','2013-09-20','09:55:00',1.54),('15087','2013-09-20','10:00:00',2),('15087','2013-09-20','10:05:00',2.36),('15087','2013-09-20','10:10:00',2.37),('15087','2013-09-20','10:15:00',3.68),('15087','2013-09-20','10:20:00',3.07),('15087','2013-09-20','10:25:00',2.56),('15087','2013-09-20','10:30:00',2.61),('15087','2013-09-20','10:35:00',2.92),('15087','2013-09-20','10:40:00',3.58),('15087','2013-09-20','10:45:00',3.02),('15087','2013-09-20','10:50:00',2.8),('15087','2013-09-20','10:55:00',2.31),('15087','2013-09-20','11:00:00',2.06),('15087','2013-09-20','11:05:00',2.1),('15087','2013-09-20','11:10:00',2.33),('15087','2013-09-20','11:15:00',2.47),('15087','2013-09-20','11:20:00',2.81),('15087','2013-09-20','11:25:00',2.47),('15087','2013-09-20','11:30:00',2.7),('15087','2013-09-20','11:35:00',2.86),('15087','2013-09-20','11:40:00',3.94),('15087','2013-09-20','11:45:00',4.16),('15087','2013-09-20','11:50:00',4.13),('15087','2013-09-20','11:55:00',4.05),('15087','2013-09-20','12:00:00',3.99),('15087','2013-09-20','12:05:00',4.02),('15087','2013-09-20','12:10:00',4.05),('15087','2013-09-20','12:15:00',4.14),('15087','2013-09-20','12:20:00',4.23),('15087','2013-09-20','12:25:00',3.39),('15087','2013-09-20','12:30:00',3.83),('15087','2013-09-20','12:35:00',2.82),('15087','2013-09-20','12:40:00',3.72),('15087','2013-09-20','12:45:00',2.82),('15087','2013-09-20','12:50:00',4.35),('15087','2013-09-20','12:55:00',4.17),('15087','2013-09-20','13:00:00',3.21),('15087','2013-09-20','13:10:00',1.22),('15087','2013-09-20','13:15:00',2.55),('15087','2013-09-20','13:20:00',2.58),('15087','2013-09-20','13:25:00',2.21),('15087','2013-09-20','13:30:00',2.84),('15087','2013-09-20','13:35:00',3.52),('15087','2013-09-20','13:40:00',3.7),('15087','2013-09-20','13:45:00',3.81),('15087','2013-09-20','13:50:00',2.88),('15087','2013-09-20','13:55:00',3.14),('15087','2013-09-20','14:00:00',2.98),('15087','2013-09-20','14:10:00',3.59),('15087','2013-09-20','14:15:00',2.56),('15087','2013-09-20','14:20:00',2.34),('15087','2013-09-20','14:25:00',3.8),('15087','2013-09-20','14:30:00',3.81),('15087','2013-09-20','14:35:00',2.47),('15087','2013-09-20','14:40:00',3.59),('15087','2013-09-20','14:45:00',3.53),('15087','2013-09-20','14:50:00',3.52),('15087','2013-09-20','14:55:00',3.45),('15087','2013-09-20','15:00:00',2.43),('15087','2013-09-20','15:05:00',3.43),('15087','2013-09-20','15:10:00',2.27),('15087','2013-09-20','15:15:00',2.5),('15087','2013-09-20','15:20:00',1.61),('15087','2013-09-20','15:25:00',1.26),('15087','2013-09-20','15:30:00',1.03),('15087','2013-09-20','15:35:00',3.14),('15087','2013-09-20','15:40:00',3),('15087','2013-09-20','15:45:00',2.81),('15087','2013-09-20','15:50:00',2.8),('15087','2013-09-20','15:55:00',2.8),('15087','2013-09-20','16:00:00',3.01),('15087','2013-09-20','16:05:00',1.97),('15087','2013-09-20','16:10:00',1.52),('15087','2013-09-20','16:15:00',1.99),('15087','2013-09-20','16:20:00',1.72),('15087','2013-09-20','16:25:00',1.21),('15087','2013-09-20','16:45:00',1.61),('15087','2013-09-20','16:50:00',1.74),('15087','2013-09-20','16:55:00',2.07),('15087','2013-09-20','17:00:00',1.94),('15087','2013-09-20','17:05:00',2.04),('15087','2013-09-20','17:10:00',2.12),('15087','2013-09-20','17:15:00',1.92),('15087','2013-09-20','17:20:00',1.86),('15087','2013-09-20','17:25:00',1.57),('15087','2013-09-20','17:30:00',1.25),('15087','2013-09-20','17:35:00',1.07),('15087','2013-09-20','17:40:00',1.05),('15087','2013-09-20','17:45:00',1),('15087','2013-09-19','08:25:00',1.03),('15087','2013-09-19','08:30:00',1.24),('15087','2013-09-19','08:35:00',1.2),('15087','2013-09-19','08:40:00',1.18),('15087','2013-09-19','08:45:00',1.18),('15087','2013-09-19','08:50:00',1.28),('15087','2013-09-19','08:55:00',1.33),('15087','2013-09-19','09:00:00',1.2),('15087','2013-09-19','09:10:00',1.99),('15087','2013-09-19','09:15:00',1.87),('15087','2013-09-19','09:20:00',1.43),('15087','2013-09-19','10:05:00',2.77),('15087','2013-09-19','10:10:00',1.65),('15087','2013-09-19','10:15:00',1.18),('15087','2013-09-19','10:25:00',1.12),('15087','2013-09-19','10:30:00',1.21),('15087','2013-09-19','10:35:00',3.54),('15087','2013-09-19','10:40:00',3.07),('15087','2013-09-19','10:45:00',1.69),('15087','2013-09-19','10:50:00',1.69),('15087','2013-09-19','10:55:00',3.82),('15087','2013-09-19','11:00:00',4.11),('15087','2013-09-19','11:05:00',1.9),('15087','2013-09-19','11:10:00',2.47),('15087','2013-09-19','11:15:00',1.7),('15087','2013-09-19','11:20:00',2.52),('15087','2013-09-19','11:25:00',3),('15087','2013-09-19','11:30:00',3.5),('15087','2013-09-19','11:35:00',4.14),('15087','2013-09-19','11:40:00',2.45),('15087','2013-09-19','11:45:00',4.08),('15087','2013-09-19','11:50:00',3.65),('15087','2013-09-19','11:55:00',3.85),('15087','2013-09-19','12:00:00',2.93),('15087','2013-09-19','12:05:00',1.75),('15087','2013-09-19','12:10:00',3.64),('15087','2013-09-19','12:15:00',2.15),('15087','2013-09-19','12:20:00',4.43),('15087','2013-09-19','12:25:00',4.35),('15087','2013-09-19','12:30:00',4.41),('15087','2013-09-19','12:35:00',4.3),('15087','2013-09-19','12:40:00',3.96),('15087','2013-09-19','12:45:00',2.81),('15087','2013-09-19','12:50:00',4.53),('15087','2013-09-19','12:55:00',4.44),('15087','2013-09-19','13:00:00',4.45),('15087','2013-09-19','13:05:00',4.54),('15087','2013-09-19','13:10:00',4.69),('15087','2013-09-19','13:15:00',4.69),('15087','2013-09-19','13:20:00',4.13),('15087','2013-09-19','13:25:00',3.81),('15087','2013-09-19','13:30:00',4.36),('15087','2013-09-19','13:35:00',4.41),('15087','2013-09-19','13:40:00',4.69),('15087','2013-09-19','13:45:00',4.74),('15087','2013-09-19','13:50:00',3.21),('15087','2013-09-19','13:55:00',1.6),('15087','2013-09-19','14:00:00',1.42),('15087','2013-09-19','14:05:00',4.22),('15087','2013-09-19','14:10:00',4.09),('15087','2013-09-19','14:15:00',3.96),('15087','2013-09-19','14:20:00',3.83),('15087','2013-09-19','14:25:00',3.65),('15087','2013-09-19','14:30:00',3.71),('15087','2013-09-19','14:35:00',3.67),('15087','2013-09-19','14:40:00',3.33),('15087','2013-09-19','14:45:00',3.44),('15087','2013-09-19','14:50:00',3.28),('15087','2013-09-19','14:55:00',3.46),('15087','2013-09-19','15:00:00',3.17),('15087','2013-09-19','15:05:00',2.88),('15087','2013-09-19','15:10:00',2.74),('15087','2013-09-19','15:15:00',2.63),('15087','2013-09-19','15:20:00',3.23),('15087','2013-09-19','15:25:00',2.7),('15087','2013-09-19','15:30:00',1.94),('15087','2013-09-19','15:35:00',2.11),('15087','2013-09-19','15:40:00',3.09),('15087','2013-09-19','15:45:00',2.96),('15087','2013-09-19','15:50:00',2.72),('15087','2013-09-19','15:55:00',2.45),('15087','2013-09-19','16:00:00',2.55),('15087','2013-09-19','16:05:00',2.5),('15087','2013-09-19','16:10:00',2.14),('15087','2013-09-19','16:15:00',2.34),('15087','2013-09-19','16:20:00',2.25),('15087','2013-09-19','16:25:00',1.89),('15087','2013-09-19','16:30:00',1.78),('15087','2013-09-19','16:35:00',1.75),('15087','2013-09-19','16:40:00',1.21),('15087','2013-09-19','16:45:00',1.55),('15087','2013-09-19','16:50:00',1.49),('15087','2013-09-19','16:55:00',1.85),('15087','2013-09-19','17:00:00',1.41),('15087','2013-09-19','17:05:00',1.43),('15087','2013-09-19','17:10:00',1.32),('15087','2013-09-19','17:15:00',1.24),('15087','2013-09-19','17:20:00',1.04),('15087','2013-09-19','17:25:00',1.02),('15087','2014-04-13','09:05:00',1.39),('15087','2014-04-13','09:10:00',1.63),('15087','2014-04-13','09:15:00',1.34),('15087','2014-04-13','09:20:00',1.52),('15087','2014-04-13','09:25:00',1.71),('15087','2014-04-13','09:30:00',2.48),('15087','2014-04-13','09:35:00',1.79),('15087','2014-04-13','09:40:00',2.26),('15087','2014-04-13','09:45:00',2.04),('15087','2014-04-13','09:50:00',1.53),('15087','2014-04-13','09:55:00',1.6),('15087','2014-04-13','10:00:00',3),('15087','2014-04-13','10:05:00',4.08),('15087','2014-04-13','10:10:00',2.91),('15087','2014-04-13','10:15:00',2.63),('15087','2014-04-13','10:20:00',2.95),('15087','2014-04-13','10:25:00',2.08),('15087','2014-04-13','10:30:00',3.69),('15087','2014-04-13','10:35:00',3.75),('15087','2014-04-13','10:40:00',3.79),('15087','2014-04-13','10:45:00',3.89),('15087','2014-04-13','10:50:00',3.95),('15087','2014-04-13','10:55:00',3.98),('15087','2014-04-13','11:00:00',3.77),('15087','2014-04-13','11:05:00',4.11),('15087','2014-04-13','11:10:00',4),('15087','2014-04-13','11:15:00',4.27),('15087','2014-04-13','11:20:00',4.16),('15087','2014-04-13','11:25:00',2.69),('15087','2014-04-13','11:30:00',2.42),('15087','2014-04-13','11:35:00',3.01),('15087','2014-04-13','11:40:00',4.58),('15087','2014-04-13','11:45:00',4.22),('15087','2014-04-13','11:50:00',4.32),('15087','2014-04-13','11:55:00',2.9),('15087','2014-04-13','12:00:00',2.47),('15087','2014-04-13','12:05:00',1.79),('15087','2014-04-13','12:10:00',1.56),('15087','2014-04-13','12:15:00',1.47),('15087','2014-04-13','12:20:00',1.33),('15087','2014-04-13','13:05:00',1.44),('15087','2014-04-13','13:10:00',2.19),('15087','2014-04-13','13:15:00',2.23),('15087','2014-04-13','13:20:00',3.15),('15087','2014-04-13','13:25:00',3.77),('15087','2014-04-13','13:30:00',4.89),('15087','2014-04-13','13:35:00',4.43),('15087','2014-04-13','13:40:00',3.91),('15087','2014-04-13','13:45:00',2.18),('15087','2014-04-13','13:50:00',3.28),('15087','2014-04-13','13:55:00',3),('15087','2014-04-13','14:00:00',4.68),('15087','2014-04-13','14:05:00',4.23),('15087','2014-04-13','14:10:00',4.22),('15087','2014-04-13','14:15:00',4.78),('15087','2014-04-13','14:20:00',2.13),('15087','2014-04-13','14:25:00',1.78),('15087','2014-04-13','14:30:00',1.82),('15087','2014-04-13','14:35:00',1.69),('15087','2014-04-13','14:40:00',1.46),('15087','2014-04-13','14:45:00',2.44),('15087','2014-04-13','14:50:00',4.52),('15087','2014-04-13','14:55:00',3.44),('15087','2014-04-13','15:00:00',3.26),('15087','2014-04-13','15:05:00',3.88),('15087','2014-04-13','15:10:00',3.91),('15087','2014-04-13','15:15:00',3.41),('15087','2014-04-13','15:20:00',3.33),('15087','2014-04-13','15:25:00',3.59),('15087','2014-04-13','15:30:00',3.3),('15087','2014-04-13','15:35:00',2.36),('15087','2014-04-13','15:40:00',1.51),('15087','2014-04-13','15:45:00',1.7),('15087','2014-04-13','15:50:00',1.96),('15087','2014-04-13','15:55:00',1.83),('15087','2014-04-13','16:00:00',3.36),('15087','2014-04-13','16:05:00',2.82),('15087','2014-04-13','16:10:00',1.28),('15087','2014-04-13','16:15:00',1.53),('15087','2014-04-13','16:20:00',1.4),('15087','2014-04-13','16:25:00',1.77),('15087','2014-04-13','16:30:00',1.38),('15087','2014-04-13','16:35:00',1.51),('15087','2014-04-13','16:40:00',2.74),('15087','2014-04-13','16:45:00',2.64),('15087','2014-04-13','16:50:00',2.32),('15087','2014-04-13','16:55:00',2.27),('15087','2014-04-13','17:00:00',1.85),('15087','2014-04-13','17:05:00',1.56),('15087','2014-04-13','17:10:00',1.02),('15087','2014-04-13','17:15:00',1.08),('15087','2014-04-13','17:20:00',1.62),('15087','2014-04-13','17:25:00',1.35),('15087','2014-04-13','17:55:00',1.11),('15087','2013-09-18','08:45:00',1.22),('15087','2013-09-18','08:50:00',1.05),('15087','2013-09-18','08:55:00',1.61),('15087','2013-09-18','09:00:00',1.58),('15087','2013-09-18','09:05:00',1.36),('15087','2013-09-18','09:15:00',1.71),('15087','2013-09-18','09:20:00',2.52),('15087','2013-09-18','09:25:00',2.03),('15087','2013-09-18','09:35:00',2.38),('15087','2013-09-18','09:40:00',2.18),('15087','2013-09-18','09:55:00',2.11),('15087','2013-09-18','10:00:00',2.99),('15087','2013-09-18','10:05:00',2.77),('15087','2013-09-18','10:10:00',2.98),('15087','2013-09-18','10:15:00',2.96),('15087','2013-09-18','10:20:00',3.04),('15087','2013-09-18','10:25:00',3.09),('15087','2013-09-18','10:30:00',3.14),('15087','2013-09-18','10:35:00',3.19),('15087','2013-09-18','10:40:00',3.24),('15087','2013-09-18','10:45:00',3.28),('15087','2013-09-18','10:50:00',2.73),('15087','2013-09-18','10:55:00',2.87),('15087','2013-09-18','11:00:00',3.67),('15087','2013-09-18','11:05:00',3.76),('15087','2013-09-18','11:10:00',3.8),('15087','2013-09-18','11:15:00',3.18),('15087','2013-09-18','11:20:00',3.43),('15087','2013-09-18','11:25:00',3.85),('15087','2013-09-18','11:30:00',3.85),('15087','2013-09-18','11:35:00',4.22),('15087','2013-09-18','11:40:00',2.98),('15087','2013-09-18','11:45:00',4.03),('15087','2013-09-18','11:50:00',4.04),('15087','2013-09-18','11:55:00',3.85),('15087','2013-09-18','12:00:00',4.1),('15087','2013-09-18','12:05:00',4.25),('15087','2013-09-18','12:10:00',4.27),('15087','2013-09-18','12:15:00',4.35),('15087','2013-09-18','12:20:00',3.81),('15087','2013-09-18','12:25:00',1.88),('15087','2013-09-18','12:30:00',2.69),('15087','2013-09-18','12:35:00',4.71),('15087','2013-09-18','12:40:00',2.83),('15087','2013-09-18','12:45:00',3.78),('15087','2013-09-18','12:50:00',4),('15087','2013-09-18','12:55:00',3.53),('15087','2013-09-18','13:00:00',1.65),('15087','2013-09-18','13:05:00',4.11),('15087','2013-09-18','13:10:00',4.45),('15087','2013-09-18','13:15:00',4.38),('15087','2013-09-18','13:20:00',4.3),('15087','2013-09-18','13:25:00',4.36),('15087','2013-09-18','13:30:00',4.29),('15087','2013-09-18','13:35:00',4.29),('15087','2013-09-18','13:40:00',4.29),('15087','2013-09-18','13:45:00',3.94),('15087','2013-09-18','13:50:00',4.32),('15087','2013-09-18','13:55:00',4.3),('15087','2013-09-18','14:00:00',3.98),('15087','2013-09-18','14:05:00',2.03),('15087','2013-09-18','14:10:00',3.3),('15087','2013-09-18','14:15:00',2.98),('15087','2013-09-18','14:20:00',3.9),('15087','2013-09-18','14:25:00',3.78),('15087','2013-09-18','14:30:00',3.64),('15087','2013-09-18','14:35:00',3.68),('15087','2013-09-18','14:40:00',3.65),('15087','2013-09-18','14:45:00',3.49),('15087','2013-09-18','14:50:00',3.37),('15087','2013-09-18','14:55:00',2.56),('15087','2013-09-18','15:00:00',3.34),('15087','2013-09-18','15:05:00',2.41),('15087','2013-09-18','15:10:00',1.43),('15087','2013-09-18','15:15:00',2.26),('15087','2013-09-18','15:20:00',2.1),('15087','2013-09-18','15:25:00',3.27),('15087','2013-09-18','15:30:00',2.93),('15087','2013-09-18','15:35:00',3.18),('15087','2013-09-18','15:40:00',2.94),('15087','2013-09-18','15:45:00',2.6),('15087','2013-09-18','15:50:00',1.79),('15087','2013-09-18','15:55:00',2.51),('15087','2013-09-18','16:00:00',2.84),('15087','2013-09-18','16:05:00',2.86),('15087','2013-09-18','16:10:00',2.62),('15087','2013-09-18','16:15:00',2.32),('15087','2013-09-18','16:20:00',2.26),('15087','2013-09-18','16:25:00',1.99),('15087','2013-09-18','16:30:00',1.91),('15087','2013-09-18','16:35:00',1.73),('15087','2013-09-18','16:40:00',1.85),('15087','2013-09-18','16:45:00',1.82),('15087','2013-09-18','16:50:00',1.58),('15087','2013-09-18','16:55:00',1.51),('15087','2013-09-18','17:00:00',1.59),('15087','2013-09-18','17:05:00',1.35),('15087','2013-09-18','17:10:00',1.35),('15087','2013-09-18','17:15:00',1.21),('15087','2013-09-18','17:20:00',1.09),('15087','2013-09-18','17:30:00',1.05),('15087','2013-09-17','09:20:00',1.46),('15087','2013-09-17','09:30:00',1.13),('15087','2013-09-17','09:40:00',1.45),('15087','2013-09-17','09:45:00',2.31),('15087','2013-09-17','09:50:00',1.25),('15087','2013-09-17','09:55:00',1.9),('15087','2013-09-17','10:00:00',2.15),('15087','2013-09-17','10:05:00',1.65),('15087','2013-09-17','10:10:00',1.86),('15087','2013-09-17','10:20:00',1.37),('15087','2013-09-17','10:25:00',2.25),('15087','2013-09-17','10:30:00',3.22),('15087','2013-09-17','10:35:00',1.79),('15087','2013-09-17','10:40:00',1.87),('15087','2013-09-17','10:45:00',2.7),('15087','2013-09-17','10:50:00',3.91),('15087','2013-09-17','10:55:00',3.18),('15087','2013-09-17','11:00:00',2.48),('15087','2013-09-17','11:05:00',1.88),('15087','2013-09-17','11:10:00',3.9),('15087','2013-09-17','11:15:00',3.02),('15087','2013-09-17','11:20:00',2.6),('15087','2013-09-17','11:25:00',1.78),('15087','2013-09-17','11:30:00',2.01),('15087','2013-09-17','11:35:00',3.37),('15087','2013-09-17','11:40:00',3.39),('15087','2013-09-17','11:45:00',3.02),('15087','2013-09-17','11:50:00',3.7),('15087','2013-09-17','11:55:00',3.47),('15087','2013-09-17','12:00:00',3.71),('15087','2013-09-17','12:05:00',3.62),('15087','2013-09-17','12:10:00',1.89),('15087','2013-09-17','12:15:00',2.26),('15087','2013-09-17','12:20:00',2.48),('15087','2013-09-17','12:25:00',4.31),('15087','2013-09-17','12:30:00',2.9),('15087','2013-09-17','12:35:00',2.38),('15087','2013-09-17','12:40:00',3.44),('15087','2013-09-17','12:45:00',4.06),('15087','2013-09-17','12:50:00',3.04),('15087','2013-09-17','12:55:00',3.29),('15087','2013-09-17','13:00:00',2.19),('15087','2013-09-17','13:05:00',1.47),('15087','2013-09-17','13:10:00',3.21),('15087','2013-09-17','13:15:00',3),('15087','2013-09-17','13:20:00',2.79),('15087','2013-09-17','13:25:00',2.44),('15087','2013-09-17','13:30:00',1.97),('15087','2013-09-17','13:35:00',2.36),('15087','2013-09-17','13:40:00',2.46),('15087','2013-09-17','13:45:00',1.5),('15087','2013-09-17','13:55:00',1.39),('15087','2013-09-17','14:00:00',2.01),('15087','2013-09-17','14:05:00',1.37),('15087','2013-09-17','14:15:00',1.23),('15087','2013-09-17','14:25:00',1.75),('15087','2013-09-17','14:30:00',1.01),('15087','2013-09-17','14:35:00',1.19),('15087','2013-09-17','14:50:00',1.44),('15087','2013-09-17','14:55:00',3.51),('15087','2013-09-17','15:00:00',3.32),('15087','2013-09-17','15:05:00',2.84),('15087','2013-09-17','15:10:00',2.48),('15087','2013-09-17','15:15:00',3.03),('15087','2013-09-17','15:20:00',3.07),('15087','2013-09-17','15:25:00',2.8),('15087','2013-09-17','15:30:00',2.29),('15087','2013-09-17','15:35:00',1.16),('15087','2013-09-17','15:45:00',1.41),('15087','2013-09-17','15:50:00',1.86),('15087','2013-09-17','15:55:00',2.01),('15087','2013-09-17','16:00:00',1.42),('15087','2013-09-17','16:05:00',1.96),('15087','2013-09-17','16:10:00',1.8),('15087','2013-09-17','16:15:00',1.62),('15087','2013-09-17','16:20:00',1.03),('15087','2013-09-17','16:40:00',1.28),('15087','2013-09-17','16:45:00',1.58),('15087','2013-09-17','16:50:00',1.23),('15087','2013-09-17','16:55:00',1.02),('15087','2013-09-17','17:00:00',1.58),('15087','2013-09-17','17:05:00',1.74),('15087','2013-09-17','17:10:00',1.61),('15087','2013-09-17','17:15:00',1.59),('15087','2013-09-17','17:20:00',1.19),('15087','2013-09-17','17:25:00',1.28),('15087','2013-09-17','17:30:00',1.21),('15087','2013-09-16','08:10:00',1.02),('15087','2013-09-16','08:20:00',1.07),('15087','2013-09-16','08:25:00',1.16),('15087','2013-09-16','08:30:00',1.25),('15087','2013-09-16','08:35:00',1.34),('15087','2013-09-16','08:40:00',1.58),('15087','2013-09-16','08:45:00',1.32),('15087','2013-09-16','08:50:00',1.18),('15087','2013-09-16','09:05:00',1.98),('15087','2013-09-16','09:10:00',1.85),('15087','2013-09-16','09:15:00',2.12),('15087','2013-09-16','09:20:00',2.24),('15087','2013-09-16','09:25:00',2.09),('15087','2013-09-16','09:30:00',1.91),('15087','2013-09-16','09:35:00',2.45),('15087','2013-09-16','09:40:00',2.55),('15087','2013-09-16','09:45:00',2.66),('15087','2013-09-16','09:50:00',2.72),('15087','2013-09-16','09:55:00',2.24),('15087','2013-09-16','10:00:00',2.68),('15087','2013-09-16','10:05:00',3.11),('15087','2013-09-16','10:10:00',1.82),('15087','2013-09-16','10:15:00',1.34),('15087','2013-09-16','10:20:00',2.77),('15087','2013-09-16','10:25:00',2.32),('15087','2013-09-16','10:30:00',3.54),('15087','2013-09-16','10:35:00',3.73),('15087','2013-09-16','10:40:00',3.98),('15087','2013-09-16','10:45:00',4.21),('15087','2013-09-16','10:50:00',3.26),('15087','2013-09-16','10:55:00',1.19),('15087','2013-09-16','11:00:00',1.41),('15087','2013-09-16','11:05:00',1.37),('15087','2013-09-16','11:25:00',4.05),('15087','2013-09-16','11:30:00',4.18),('15087','2013-09-16','11:35:00',4.14),('15087','2013-09-16','11:40:00',4.17),('15087','2013-09-16','11:45:00',3.05),('15087','2013-09-16','11:50:00',4.35),('15087','2013-09-16','11:55:00',4.24),('15087','2013-09-16','12:00:00',4.4),('15087','2013-09-16','12:05:00',4.12),('15087','2013-09-16','12:10:00',4.64),('15087','2013-09-16','12:15:00',4.08),('15087','2013-09-16','12:20:00',4.29),('15087','2013-09-16','12:25:00',4.28),('15087','2013-09-16','12:30:00',4.27),('15087','2013-09-16','12:35:00',4.33),('15087','2013-09-16','12:40:00',4.54),('15087','2013-09-16','12:45:00',3.32),('15087','2013-09-16','12:50:00',4.99),('15087','2013-09-16','12:55:00',3.83),('15087','2013-09-16','13:00:00',3.26),('15087','2013-09-16','13:05:00',3.29),('15087','2013-09-16','13:10:00',4.72),('15087','2013-09-16','13:15:00',4.15),('15087','2013-09-16','13:20:00',4.28),('15087','2013-09-16','13:25:00',4.27),('15087','2013-09-16','13:30:00',4.22),('15087','2013-09-16','13:35:00',4.24),('15087','2013-09-16','13:40:00',4.24),('15087','2013-09-16','13:45:00',4.04),('15087','2013-09-16','13:50:00',4.06),('15087','2013-09-16','13:55:00',4.26),('15087','2013-09-16','14:00:00',3.68),('15087','2013-09-16','14:05:00',3.98),('15087','2013-09-16','14:10:00',3.93),('15087','2013-09-16','14:15:00',3.91),('15087','2013-09-16','14:20:00',3.82),('15087','2013-09-16','14:25:00',3.58),('15087','2013-09-16','14:30:00',3.56),('15087','2013-09-16','14:35:00',3.55),('15087','2013-09-16','14:40:00',3.61),('15087','2013-09-16','14:45:00',3.56),('15087','2013-09-16','14:50:00',3.53),('15087','2013-09-16','14:55:00',3.47),('15087','2013-09-16','15:00:00',3.34),('15087','2013-09-16','15:05:00',3.19),('15087','2013-09-16','15:10:00',3.3),('15087','2013-09-16','15:15:00',3.18),('15087','2013-09-16','15:20:00',2.97),('15087','2013-09-16','15:25:00',2.99),('15087','2013-09-16','15:30:00',2.89),('15087','2013-09-16','15:35:00',2.88),('15087','2013-09-16','15:40:00',2.95),('15087','2013-09-16','15:45:00',2.76),('15087','2013-09-16','15:50:00',2.68),('15087','2013-09-16','15:55:00',2.65),('15087','2013-09-16','16:00:00',2.44),('15087','2013-09-16','16:05:00',1.97),('15087','2013-09-16','16:10:00',2.53),('15087','2013-09-16','16:15:00',2.29),('15087','2013-09-16','16:20:00',2.22),('15087','2013-09-16','16:25:00',2.18),('15087','2013-09-16','16:30:00',2.1),('15087','2013-09-16','16:35:00',2.02),('15087','2013-09-16','16:40:00',2.03),('15087','2013-09-16','16:45:00',1.96),('15087','2013-09-16','16:50:00',1.87),('15087','2013-09-16','16:55:00',1.74),('15087','2013-09-16','17:00:00',1.57),('15087','2013-09-16','17:05:00',1.49),('15087','2013-09-16','17:10:00',1.38),('15087','2013-09-16','17:15:00',1.29),('15087','2013-09-16','17:20:00',1.2),('15087','2013-09-16','17:25:00',1.12),('15087','2013-09-16','17:30:00',1.08),('15087','2013-09-15','08:15:00',1.03),('15087','2013-09-15','08:20:00',1.12),('15087','2013-09-15','08:25:00',1.23),('15087','2013-09-15','08:30:00',1.32),('15087','2013-09-15','08:35:00',1.43),('15087','2013-09-15','08:40:00',1.55),('15087','2013-09-15','08:45:00',1.64),('15087','2013-09-15','08:50:00',1.66),('15087','2013-09-15','08:55:00',1.61),('15087','2013-09-15','09:00:00',1.76),('15087','2013-09-15','09:05:00',1.85),('15087','2013-09-15','09:10:00',2.03),('15087','2013-09-15','09:15:00',2.26),('15087','2013-09-15','09:20:00',2.18),('15087','2013-09-15','09:25:00',2.32),('15087','2013-09-15','09:30:00',2.33),('15087','2013-09-15','09:35:00',2.52),('15087','2013-09-15','09:40:00',2.58),('15087','2013-09-15','09:45:00',2.62),('15087','2013-09-15','09:50:00',2.74),('15087','2013-09-15','09:55:00',2.81),('15087','2013-09-15','10:00:00',2.9),('15087','2013-09-15','10:05:00',2.99),('15087','2013-09-15','10:10:00',3.03),('15087','2013-09-15','10:15:00',3),('15087','2013-09-15','10:20:00',3.05),('15087','2013-09-15','10:25:00',3.09),('15087','2013-09-15','10:30:00',2.94),('15087','2013-09-15','10:35:00',1.82),('15087','2013-09-15','10:40:00',1.8),('15087','2013-09-15','10:50:00',2.02),('15087','2013-09-15','10:55:00',3.53),('15087','2013-09-15','11:00:00',3.94),('15087','2013-09-15','11:05:00',4.07),('15087','2013-09-15','11:10:00',2.67),('15087','2013-09-15','11:15:00',1.72),('15087','2013-09-15','11:20:00',1.47),('15087','2013-09-15','11:30:00',2.99),('15087','2013-09-15','11:35:00',2.11),('15087','2013-09-15','11:40:00',1.47),('15087','2013-09-15','11:45:00',2.79),('15087','2013-09-15','11:50:00',2.85),('15087','2013-09-15','11:55:00',1.6),('15087','2013-09-15','12:00:00',1.28),('15087','2013-09-15','12:05:00',1.19),('15087','2013-09-15','12:10:00',1.17),('15087','2013-09-15','12:15:00',1.28),('15087','2013-09-15','12:20:00',1.59),('15087','2013-09-15','12:25:00',1.83),('15087','2013-09-15','12:30:00',1.68),('15087','2013-09-15','12:35:00',1.5),('15087','2013-09-15','12:40:00',1.46),('15087','2013-09-15','12:45:00',1.2),('15087','2013-09-15','12:50:00',1.38),('15087','2013-09-15','12:55:00',1.41),('15087','2013-09-15','13:00:00',1.28),('15087','2013-09-15','13:05:00',1.03),('15087','2013-09-15','13:25:00',1.13),('15087','2013-09-15','13:30:00',1.12),('15087','2013-09-15','13:35:00',1.21),('15087','2013-09-15','13:40:00',1.41),('15087','2013-09-15','13:45:00',2.57),('15087','2013-09-15','13:50:00',1.79),('15087','2013-09-15','13:55:00',1.22),('15087','2013-09-15','14:00:00',1.98),('15087','2013-09-15','14:05:00',1.84),('15087','2013-09-15','14:10:00',1.62),('15087','2013-09-15','14:15:00',1.55),('15087','2013-09-15','14:20:00',1.47),('15087','2013-09-15','14:25:00',1.42),('15087','2013-09-15','14:30:00',1.33),('15087','2013-09-15','14:35:00',1.11),('15087','2013-09-15','14:40:00',1.15),('15087','2013-09-15','14:45:00',1.05),('15087','2013-09-15','14:50:00',1.1),('15087','2013-09-15','14:55:00',1.11),('15087','2013-09-15','15:00:00',1.13),('15087','2013-09-15','15:05:00',1.2),('15087','2013-09-15','15:10:00',1.4),('15087','2013-09-15','15:15:00',2.95),('15087','2013-09-15','15:20:00',2.16),('15087','2013-09-15','15:25:00',1.53),('15087','2013-09-15','15:30:00',1.12),('15087','2013-09-15','15:35:00',1.12),('15087','2013-09-15','15:40:00',1.04),('15087','2013-09-14','08:20:00',1.06),('15087','2013-09-14','08:25:00',1.14),('15087','2013-09-14','08:30:00',1.24),('15087','2013-09-14','08:35:00',1.34),('15087','2013-09-14','08:40:00',1.44),('15087','2013-09-14','08:45:00',1.54),('15087','2013-09-14','08:50:00',1.62),('15087','2013-09-14','08:55:00',1.73),('15087','2013-09-14','09:00:00',1.87),('15087','2013-09-14','09:05:00',1.93),('15087','2013-09-14','09:10:00',2.06),('15087','2013-09-14','09:15:00',2.17),('15087','2013-09-14','09:20:00',2.25),('15087','2013-09-14','09:25:00',2.33),('15087','2013-09-14','09:30:00',2.43),('15087','2013-09-14','09:35:00',2.51),('15087','2013-09-14','09:40:00',2.57),('15087','2013-09-14','09:45:00',2.64),('15087','2013-09-14','09:50:00',2.69),('15087','2013-09-14','09:55:00',2.85),('15087','2013-09-14','10:00:00',2.8),('15087','2013-09-14','10:05:00',2.86),('15087','2013-09-14','10:10:00',2.71),('15087','2013-09-14','10:15:00',2.8),('15087','2013-09-14','10:20:00',3),('15087','2013-09-14','10:25:00',3.13),('15087','2013-09-14','10:30:00',3.2),('15087','2013-09-14','10:35:00',3.45),('15087','2013-09-14','10:40:00',3.53),('15087','2013-09-14','10:45:00',2.54),('15087','2013-09-14','10:50:00',4.15),('15087','2013-09-14','10:55:00',2.57),('15087','2013-09-14','11:00:00',2.37),('15087','2013-09-14','11:10:00',2.93),('15087','2013-09-14','11:15:00',1.24),('15087','2013-09-14','11:25:00',3.71),('15087','2013-09-14','11:30:00',4.01),('15087','2013-09-14','11:35:00',4.11),('15087','2013-09-14','11:40:00',4.13),('15087','2013-09-14','11:45:00',4.16),('15087','2013-09-14','11:50:00',2.56),('15087','2013-09-14','12:10:00',1.58),('15087','2013-09-14','12:30:00',1.42),('15087','2013-09-14','12:35:00',2.63),('15087','2013-09-14','12:40:00',1.12),('15087','2013-09-14','12:55:00',1.14),('15087','2013-09-14','13:05:00',1.23),('15087','2013-09-14','13:10:00',3.39),('15087','2013-09-14','13:15:00',4.71),('15087','2013-09-14','13:20:00',3.09),('15087','2013-09-14','13:25:00',4.6),('15087','2013-09-14','13:30:00',3.46),('15087','2013-09-14','13:35:00',2.61),('15087','2013-09-14','13:40:00',4.08),('15087','2013-09-14','13:45:00',3.06),('15087','2013-09-14','13:50:00',3.08),('15087','2013-09-14','13:55:00',4.62),('15087','2013-09-14','14:00:00',4.37),('15087','2013-09-14','14:05:00',4.07),('15087','2013-09-14','14:10:00',3.85),('15087','2013-09-14','14:15:00',3.97),('15087','2013-09-14','14:20:00',3.91),('15087','2013-09-14','14:25:00',3.82),('15087','2013-09-14','14:30:00',3.8),('15087','2013-09-14','14:35:00',3.75),('15087','2013-09-14','14:40:00',3.72),('15087','2013-09-14','14:45:00',3.56),('15087','2013-09-14','14:50:00',3.46),('15087','2013-09-14','14:55:00',3.46),('15087','2013-09-14','15:00:00',3.4),('15087','2013-09-14','15:05:00',3.24),('15087','2013-09-14','15:10:00',3.16),('15087','2013-09-14','15:15:00',3.2),('15087','2013-09-14','15:20:00',3.12),('15087','2013-09-14','15:25:00',2.67),('15087','2013-09-14','15:30:00',3.1),('15087','2013-09-14','15:35:00',3.02),('15087','2013-09-14','15:40:00',2.92),('15087','2013-09-14','15:45:00',2.85),('15087','2013-09-14','15:50:00',2.74),('15087','2013-09-14','15:55:00',2.67),('15087','2013-09-14','16:00:00',2.55),('15087','2013-09-14','16:05:00',2.46),('15087','2013-09-14','16:10:00',2.36),('15087','2013-09-14','16:15:00',2.35),('15087','2013-09-14','16:20:00',2.26),('15087','2013-09-14','16:25:00',2.2),('15087','2013-09-14','16:30:00',2.14),('15087','2013-09-14','16:35:00',2.01),('15087','2013-09-14','16:40:00',1.98),('15087','2013-09-14','16:45:00',1.95),('15087','2013-09-14','16:50:00',1.85),('15087','2013-09-14','16:55:00',1.73),('15087','2013-09-14','17:00:00',1.65),('15087','2013-09-14','17:05:00',1.55),('15087','2013-09-14','17:10:00',1.45),('15087','2013-09-14','17:15:00',1.32),('15087','2013-09-14','17:20:00',1.23),('15087','2013-09-14','17:25:00',1.13),('15087','2013-09-14','17:30:00',1.09),('15087','2013-09-13','08:55:00',1.04),('15087','2013-09-13','09:00:00',1.02),('15087','2013-09-13','09:20:00',1.03),('15087','2013-09-13','09:25:00',1.15),('15087','2013-09-13','09:30:00',1.23),('15087','2013-09-13','09:35:00',1.33),('15087','2013-09-13','09:40:00',1.44),('15087','2013-09-13','09:45:00',1.38),('15087','2013-09-13','09:50:00',1.7),('15087','2013-09-13','09:55:00',2.97),('15087','2013-09-13','10:00:00',2.46),('15087','2013-09-13','10:05:00',1.5),('15087','2013-09-13','10:10:00',2.55),('15087','2013-09-13','10:15:00',3.95),('15087','2013-09-13','10:20:00',3.55),('15087','2013-09-13','10:25:00',1.6),('15087','2013-09-13','10:30:00',2.83),('15087','2013-09-13','10:35:00',3.42),('15087','2013-09-13','10:40:00',3.45),('15087','2013-09-13','10:45:00',3.47),('15087','2013-09-13','10:50:00',3.53),('15087','2013-09-13','10:55:00',3.58),('15087','2013-09-13','11:00:00',3.62),('15087','2013-09-13','11:05:00',3.65),('15087','2013-09-13','11:10:00',3.73),('15087','2013-09-13','11:15:00',3.69),('15087','2013-09-13','11:20:00',3.81),('15087','2013-09-13','11:25:00',3.84),('15087','2013-09-13','11:30:00',3.9),('15087','2013-09-13','11:35:00',3.96),('15087','2013-09-13','11:40:00',3.97),('15087','2013-09-13','11:45:00',4),('15087','2013-09-13','11:50:00',3.99),('15087','2013-09-13','11:55:00',4.04),('15087','2013-09-13','12:00:00',4.06),('15087','2013-09-13','12:05:00',4.08),('15087','2013-09-13','12:10:00',4.08),('15087','2013-09-13','12:15:00',4.16),('15087','2013-09-13','12:20:00',4.2),('15087','2013-09-13','12:25:00',4.24),('15087','2013-09-13','12:30:00',4.12),('15087','2013-09-13','12:35:00',4.26),('15087','2013-09-13','12:40:00',4.34),('15087','2013-09-13','12:45:00',4.33),('15087','2013-09-13','12:50:00',4.35),('15087','2013-09-13','12:55:00',4.34),('15087','2013-09-13','13:00:00',4.25),('15087','2013-09-13','13:05:00',4.21),('15087','2013-09-13','13:10:00',4.18),('15087','2013-09-13','13:15:00',4.15),('15087','2013-09-13','13:20:00',4.16),('15087','2013-09-13','13:25:00',4.12),('15087','2013-09-13','13:30:00',4.09),('15087','2013-09-13','13:35:00',4.02),('15087','2013-09-13','13:40:00',4.07),('15087','2013-09-13','13:45:00',4.05),('15087','2013-09-13','13:50:00',4.01),('15087','2013-09-13','13:55:00',3.98),('15087','2013-09-13','14:00:00',3.93),('15087','2013-09-13','14:05:00',3.87),('15087','2013-09-13','14:10:00',3.81),('15087','2013-09-13','14:15:00',3.58),('15087','2013-09-13','14:20:00',3.79),('15087','2013-09-13','14:25:00',1.45),('15087','2013-09-13','14:35:00',3.85),('15087','2013-09-13','14:40:00',3.72),('15087','2013-09-13','14:45:00',3.01),('15087','2013-09-13','14:50:00',3.55),('15087','2013-09-13','14:55:00',3.51),('15087','2013-09-13','15:00:00',3.47),('15087','2013-09-13','15:05:00',3.4),('15087','2013-09-13','15:10:00',3.37),('15087','2013-09-13','15:15:00',3.27),('15087','2013-09-13','15:20:00',3.2),('15087','2013-09-13','15:25:00',3.13),('15087','2013-09-13','15:30:00',3.1),('15087','2013-09-13','15:35:00',3.05),('15087','2013-09-13','15:40:00',2.95),('15087','2013-09-13','15:45:00',2.8),('15087','2013-09-13','15:50:00',2.65),('15087','2013-09-13','15:55:00',2.72),('15087','2013-09-13','16:00:00',2.6),('15087','2013-09-13','16:05:00',2.51),('15087','2013-09-13','16:10:00',2.44),('15087','2013-09-13','16:15:00',2.38),('15087','2013-09-13','16:20:00',2.35),('15087','2013-09-13','16:25:00',2.2),('15087','2013-09-13','16:30:00',2.08),('15087','2013-09-13','16:35:00',2.15),('15087','2013-09-13','16:40:00',2.04),('15087','2013-09-13','16:45:00',1.94),('15087','2013-09-13','16:50:00',1.86),('15087','2013-09-13','16:55:00',1.71),('15087','2013-09-13','17:00:00',1.66),('15087','2013-09-13','17:05:00',1.55),('15087','2013-09-13','17:10:00',1.44),('15087','2013-09-13','17:15:00',1.33),('15087','2013-09-13','17:20:00',1.27),('15087','2013-09-13','17:25:00',1.23),('15087','2013-09-13','17:30:00',1.04),('15087','2013-09-13','17:35:00',1.02),('15087','2013-09-12','08:15:00',1.19),('15087','2013-09-12','08:20:00',1.23),('15087','2013-09-12','08:25:00',1.46),('15087','2013-09-12','08:30:00',1.62),('15087','2013-09-12','08:35:00',1.59),('15087','2013-09-12','08:40:00',1),('15087','2013-09-12','08:55:00',1.54),('15087','2013-09-12','09:00:00',1.88),('15087','2013-09-12','09:05:00',1.75),('15087','2013-09-12','09:10:00',1.3),('15087','2013-09-12','09:15:00',2.05),('15087','2013-09-12','09:20:00',2.12),('15087','2013-09-12','09:25:00',2.29),('15087','2013-09-12','09:30:00',2.49),('15087','2013-09-12','09:35:00',2.39),('15087','2013-09-12','09:40:00',1.76),('15087','2013-09-12','09:45:00',2.45),('15087','2013-09-12','09:50:00',2.01),('15087','2013-09-12','09:55:00',1.15),('15087','2013-09-12','10:00:00',1.08),('15087','2013-09-12','10:05:00',1.51),('15087','2013-09-12','10:10:00',1.9),('15087','2013-09-12','10:15:00',1.95),('15087','2013-09-12','10:20:00',1.21),('15087','2013-09-12','10:25:00',1.44),('15087','2013-09-12','10:30:00',2.81),('15087','2013-09-12','10:35:00',1.91),('15087','2013-09-12','10:55:00',2.22),('15087','2013-09-12','11:00:00',2.52),('15087','2013-09-12','11:05:00',3.88),('15087','2013-09-12','11:10:00',2.89),('15087','2013-09-12','11:15:00',2.68),('15087','2013-09-12','11:20:00',1.35),('15087','2013-09-12','11:40:00',1.45),('15087','2013-09-12','11:45:00',2.25),('15087','2013-09-12','11:50:00',1.67),('15087','2013-09-12','11:55:00',2.99),('15087','2013-09-12','12:00:00',3.04),('15087','2013-09-12','12:05:00',4.11),('15087','2013-09-12','12:10:00',2.88),('15087','2013-09-12','12:15:00',2.85),('15087','2013-09-12','12:20:00',1.4),('15087','2013-09-12','12:25:00',2.08),('15087','2013-09-12','12:30:00',1.48),('15087','2013-09-12','12:35:00',3.48),('15087','2013-09-12','12:40:00',3.2),('15087','2013-09-12','12:45:00',1.04),('15087','2013-09-12','12:50:00',2.19),('15087','2013-09-12','12:55:00',2.52),('15087','2013-09-12','13:00:00',4.05),('15087','2013-09-12','13:05:00',2.45),('15087','2013-09-12','13:10:00',2.74),('15087','2013-09-12','13:15:00',4.6),('15087','2013-09-12','13:20:00',4.87),('15087','2013-09-12','13:25:00',4.52),('15087','2013-09-12','13:30:00',3.71),('15087','2013-09-12','13:35:00',2.38),('15087','2013-09-12','13:40:00',3.68),('15087','2013-09-12','13:45:00',2.5),('15087','2013-09-12','13:50:00',4.11),('15087','2013-09-12','13:55:00',4.23),('15087','2013-09-12','14:00:00',3.94),('15087','2013-09-12','14:05:00',3.88),('15087','2013-09-12','14:10:00',3.75),('15087','2013-09-12','14:15:00',3.77),('15087','2013-09-12','14:20:00',4.13),('15087','2013-09-12','14:25:00',3.89),('15087','2013-09-12','14:30:00',4.05),('15087','2013-09-12','14:35:00',1.99),('15087','2013-09-12','14:40:00',3.25),('15087','2013-09-12','14:45:00',3.61),('15087','2013-09-12','14:50:00',3.71),('15087','2013-09-12','14:55:00',3.61),('15087','2013-09-12','15:00:00',3.15),('15087','2013-09-12','15:05:00',2.21),('15087','2013-09-12','15:10:00',2.62),('15087','2013-09-12','15:15:00',3.42),('15087','2013-09-12','15:20:00',3.13),('15087','2013-09-12','15:25:00',2.77),('15087','2013-09-12','15:30:00',3.18),('15087','2013-09-12','15:35:00',3.09),('15087','2013-09-12','15:40:00',3.04),('15087','2013-09-12','15:45:00',2.94),('15087','2013-09-12','15:50:00',2.89),('15087','2013-09-12','15:55:00',2.79),('15087','2013-09-12','16:00:00',2.83),('15087','2013-09-12','16:05:00',1.4),('15087','2013-09-12','16:10:00',2.81),('15087','2013-09-12','16:15:00',1.87),('15087','2013-09-12','16:20:00',1.89),('15087','2013-09-12','16:25:00',1.37),('15087','2013-09-12','16:30:00',2.31),('15087','2013-09-12','16:40:00',2.32),('15087','2013-09-12','16:45:00',2.16),('15087','2013-09-12','16:55:00',1.13),('15087','2013-09-12','17:00:00',1.85),('15087','2013-09-12','17:05:00',1.79),('15087','2013-09-12','17:10:00',1.52),('15087','2013-09-12','17:15:00',1.15),('15087','2013-09-12','17:30:00',1.32),('15087','2013-09-12','17:35:00',1.15),('15087','2013-09-12','17:40:00',1.07),('15087','2013-09-11','08:10:00',1.09),('15087','2013-09-11','08:15:00',1.01),('15087','2013-09-11','08:30:00',1.15),('15087','2013-09-11','08:55:00',1.23),('15087','2013-09-11','09:00:00',1.99),('15087','2013-09-11','09:05:00',2.15),('15087','2013-09-11','09:10:00',1.99),('15087','2013-09-11','09:15:00',2.38),('15087','2013-09-11','09:20:00',2.59),('15087','2013-09-11','09:25:00',1.63),('15087','2013-09-11','09:30:00',1.24),('15087','2013-09-11','09:35:00',2.05),('15087','2013-09-11','09:40:00',1.54),('15087','2013-09-11','10:00:00',1.1),('15087','2013-09-11','10:05:00',2.14),('15087','2013-09-11','10:15:00',3.11),('15087','2013-09-11','10:20:00',2.72),('15087','2013-09-11','10:25:00',2.32),('15087','2013-09-11','10:30:00',3.08),('15087','2013-09-11','10:35:00',2.65),('15087','2013-09-11','10:40:00',2.29),('15087','2013-09-11','10:45:00',2.5),('15087','2013-09-11','10:50:00',2.94),('15087','2013-09-11','10:55:00',1.79),('15087','2013-09-11','11:00:00',1.98),('15087','2013-09-11','11:05:00',2.63),('15087','2013-09-11','11:10:00',3.31),('15087','2013-09-11','11:15:00',3.74),('15087','2013-09-11','11:20:00',3.36),('15087','2013-09-11','11:25:00',1.84),('15087','2013-09-11','11:30:00',2.46),('15087','2013-09-11','11:35:00',2.35),('15087','2013-09-11','11:40:00',4.25),('15087','2013-09-11','11:45:00',4.18),('15087','2013-09-11','11:50:00',4),('15087','2013-09-11','11:55:00',3.23),('15087','2013-09-11','12:00:00',4.2),('15087','2013-09-11','12:05:00',3.54),('15087','2013-09-11','12:10:00',2.58),('15087','2013-09-11','12:15:00',1.99),('15087','2013-09-11','12:20:00',2.17),('15087','2013-09-11','12:25:00',3.64),('15087','2013-09-11','12:30:00',1.94),('15087','2013-09-11','12:35:00',2.93),('15087','2013-09-11','12:40:00',2.08),('15087','2013-09-11','12:45:00',3.35),('15087','2013-09-11','12:50:00',5),('15087','2013-09-11','12:55:00',2.06),('15087','2013-09-11','13:00:00',4.11),('15087','2013-09-11','13:05:00',4.51),('15087','2013-09-11','13:10:00',4.56),('15087','2013-09-11','13:15:00',4.69),('15087','2013-09-11','13:20:00',4.57),('15087','2013-09-11','13:25:00',2.93),('15087','2013-09-11','13:30:00',2.32),('15087','2013-09-11','13:35:00',4.6),('15087','2013-09-11','13:40:00',2.65),('15087','2013-09-11','13:45:00',4.33),('15087','2013-09-11','13:50:00',3.41),('15087','2013-09-11','13:55:00',2.5),('15087','2013-09-11','14:00:00',4.19),('15087','2013-09-11','14:05:00',3.69),('15087','2013-09-11','14:10:00',3.06),('15087','2013-09-11','14:15:00',3.96),('15087','2013-09-11','14:20:00',3.26),('15087','2013-09-11','14:25:00',3.51),('15087','2013-09-11','14:30:00',2.32),('15087','2013-09-11','14:35:00',2.91),('15087','2013-09-11','14:40:00',2.83),('15087','2013-09-11','14:45:00',3.3),('15087','2013-09-11','14:50:00',3.78),('15087','2013-09-11','14:55:00',1.61),('15087','2013-09-11','15:00:00',3.54),('15087','2013-09-11','15:05:00',3.23),('15087','2013-09-11','15:10:00',2.87),('15087','2013-09-11','15:15:00',3.35),('15087','2013-09-11','15:20:00',3.57),('15087','2013-09-11','15:25:00',1.41),('15087','2013-09-11','15:30:00',1.71),('15087','2013-09-11','15:40:00',1.46),('15087','2013-09-11','15:45:00',2.96),('15087','2013-09-11','15:50:00',3.05),('15087','2013-09-11','15:55:00',2.61),('15087','2013-09-11','16:00:00',2.24),('15087','2013-09-11','16:05:00',3.08),('15087','2013-09-11','16:10:00',2.58),('15087','2013-09-11','16:15:00',2.62),('15087','2013-09-11','16:20:00',2.11),('15087','2013-09-11','16:25:00',2.13),('15087','2013-09-11','16:30:00',1.32),('15087','2013-09-11','16:40:00',1.55),('15087','2013-09-11','16:45:00',2.12),('15087','2013-09-11','16:50:00',1.81),('15087','2013-09-11','16:55:00',1.08),('15087','2013-09-11','17:00:00',1.7),('15087','2013-09-11','17:05:00',1.59),('15087','2013-09-11','17:10:00',1.49),('15087','2013-09-11','17:15:00',1.4),('15087','2013-09-11','17:20:00',1.33),('15087','2013-09-11','17:25:00',1.2),('15087','2013-09-11','17:30:00',1.16),('15087','2013-09-11','17:35:00',1.1),('15087','2013-09-10','08:55:00',1.63),('15087','2013-09-10','09:00:00',1.76),('15087','2013-09-10','09:05:00',1.78),('15087','2013-09-10','09:10:00',2.33),('15087','2013-09-10','09:15:00',1.99),('15087','2013-09-10','09:20:00',1.58),('15087','2013-09-10','09:25:00',1.61),('15087','2013-09-10','09:30:00',2.77),('15087','2013-09-10','09:35:00',2.9),('15087','2013-09-10','09:40:00',1.61),('15087','2013-09-10','09:45:00',1.36),('15087','2013-09-10','09:50:00',1.23),('15087','2013-09-10','09:55:00',1.09),('15087','2013-09-10','10:25:00',1.02),('15087','2013-09-10','10:30:00',1),('15087','2013-09-10','10:35:00',1.16),('15087','2013-09-10','10:40:00',1.57),('15087','2013-09-10','10:45:00',2.28),('15087','2013-09-10','10:50:00',1.26),('15087','2013-09-10','10:55:00',1.36),('15087','2013-09-10','11:00:00',1.66),('15087','2013-09-10','11:05:00',1.43),('15087','2013-09-10','11:10:00',1.42),('15087','2013-09-10','11:15:00',1.21),('15087','2013-09-10','11:20:00',1.33),('15087','2013-09-10','11:25:00',1.42),('15087','2013-09-10','11:30:00',1.08),('15087','2013-09-10','11:45:00',1.34),('15087','2013-09-10','11:50:00',1.31),('15087','2013-09-10','11:55:00',1.63),('15087','2013-09-10','12:00:00',1.4),('15087','2013-09-10','12:05:00',1.04),('15087','2013-09-10','12:10:00',1.04),('15087','2013-09-10','12:15:00',1.07),('15087','2013-09-10','13:25:00',1.1),('15087','2013-09-10','13:30:00',1.01),('15087','2013-09-10','13:35:00',1.1),('15087','2013-09-10','13:40:00',1.9),('15087','2013-09-10','13:45:00',2.93),('15087','2013-09-10','13:50:00',1.87),('15087','2013-09-10','13:55:00',1.56),('15087','2013-09-10','14:00:00',1.14),('15087','2013-09-10','14:05:00',1.32),('15087','2013-09-10','14:10:00',1.37),('15087','2013-09-10','14:15:00',1.64),('15087','2013-09-10','14:20:00',1.63),('15087','2013-09-10','14:25:00',2.37),('15087','2013-09-10','14:30:00',2.02),('15087','2013-09-10','14:35:00',1.49),('15087','2013-09-10','14:40:00',1.82),('15087','2013-09-10','14:45:00',1.93),('15087','2013-09-10','14:50:00',2.26),('15087','2013-09-10','14:55:00',1.96),('15087','2013-09-10','15:00:00',2.58),('15087','2013-09-10','15:05:00',2.32),('15087','2013-09-10','15:10:00',1.75),('15087','2013-09-10','15:15:00',1.62),('15087','2013-09-10','15:20:00',2.04),('15087','2013-09-10','15:25:00',1.79),('15087','2013-09-10','15:30:00',2.18),('15087','2013-09-10','15:35:00',1.78),('15087','2013-09-10','15:40:00',1.18),('15087','2013-09-10','15:45:00',1.01),('15087','2013-09-10','15:50:00',1.07),('15087','2013-09-10','15:55:00',1.02),('15087','2013-09-10','16:00:00',1.02),('15087','2013-09-10','16:05:00',1.11),('15087','2013-09-10','16:10:00',1.33),('15087','2013-09-10','16:15:00',1.45),('15087','2013-09-10','16:20:00',1.02),('15087','2013-09-09','08:55:00',1.19),('15087','2013-09-09','09:00:00',1.23),('15087','2013-09-09','09:05:00',1.09),('15087','2013-09-09','09:35:00',1.15),('15087','2013-09-09','10:00:00',1.49),('15087','2013-09-09','10:05:00',1.85),('15087','2013-09-09','10:10:00',1.78),('15087','2013-09-09','10:15:00',1.73),('15087','2013-09-09','10:20:00',1.64),('15087','2013-09-09','10:25:00',1.65),('15087','2013-09-09','10:30:00',1.61),('15087','2013-09-09','10:35:00',1.64),('15087','2013-09-09','10:40:00',1.82),('15087','2013-09-09','10:45:00',2.14),('15087','2013-09-09','10:50:00',2.75),('15087','2013-09-09','10:55:00',2.62),('15087','2013-09-09','11:00:00',2.88),('15087','2013-09-09','11:05:00',2.12),('15087','2013-09-09','11:10:00',2.25),('15087','2013-09-09','11:15:00',2.33),('15087','2013-09-09','11:20:00',2.5),('15087','2013-09-09','11:25:00',2.47),('15087','2013-09-09','11:30:00',2.27),('15087','2013-09-09','11:35:00',2.34),('15087','2013-09-09','11:40:00',3.4),('15087','2013-09-09','11:45:00',3.48),('15087','2013-09-09','11:50:00',3.78),('15087','2013-09-09','11:55:00',2.5),('15087','2013-09-09','12:00:00',3.07),('15087','2013-09-09','12:05:00',3.06),('15087','2013-09-09','12:10:00',3.12),('15087','2013-09-09','12:15:00',2.59),('15087','2013-09-09','12:20:00',1.48),('15087','2013-09-09','12:25:00',1.13),('15087','2013-09-09','12:30:00',1.06),('15087','2013-09-09','12:35:00',1.06),('15087','2013-09-09','12:40:00',1.59),('15087','2013-09-09','12:45:00',1.47),('15087','2013-09-09','12:50:00',1.22),('15087','2013-09-09','12:55:00',1.63),('15087','2013-09-09','13:00:00',1.76),('15087','2013-09-09','13:05:00',2.56),('15087','2013-09-09','13:10:00',2.19),('15087','2013-09-09','13:15:00',3.73),('15087','2013-09-09','13:20:00',3.24),('15087','2013-09-09','13:25:00',2.95),('15087','2013-09-09','13:30:00',3.59),('15087','2013-09-09','13:35:00',4.09),('15087','2013-09-09','13:40:00',3.28),('15087','2013-09-09','13:45:00',4.12),('15087','2013-09-09','13:50:00',3.75),('15087','2013-09-09','13:55:00',4.1),('15087','2013-09-09','14:00:00',3.76),('15087','2013-09-09','14:05:00',3.67),('15087','2013-09-09','14:10:00',3.69),('15087','2013-09-09','14:15:00',2.3),('15087','2013-09-09','14:20:00',2.03),('15087','2013-09-09','14:25:00',1.54),('15087','2013-09-09','14:30:00',2.2),('15087','2013-09-09','14:35:00',3.59),('15087','2013-09-09','14:40:00',3.72),('15087','2013-09-09','14:45:00',2.81),('15087','2013-09-09','14:50:00',3.59),('15087','2013-09-09','14:55:00',2.55),('15087','2013-09-09','15:00:00',2.6),('15087','2013-09-09','15:05:00',2.79),('15087','2013-09-09','15:10:00',2.41),('15087','2013-09-09','15:15:00',1.31),('15087','2013-09-09','15:20:00',2.43),('15087','2013-09-09','15:25:00',1.33),('15087','2013-09-09','15:30:00',2.89),('15087','2013-09-09','15:35:00',2.37),('15087','2013-09-09','15:40:00',2.2),('15087','2013-09-09','15:45:00',1.37),('15087','2013-09-09','15:50:00',1.41),('15087','2013-09-09','15:55:00',1.55),('15087','2013-09-09','16:00:00',1.73),('15087','2013-09-09','16:05:00',1.32),('15087','2013-09-09','16:10:00',1.83),('15087','2013-09-09','16:15:00',2.13),('15087','2013-09-09','16:20:00',1.72),('15087','2013-09-09','16:25:00',1.12),('15087','2013-09-09','16:30:00',1.08),('15087','2013-09-09','16:35:00',1.24),('15087','2013-09-09','16:40:00',1.35),('15087','2013-09-09','16:45:00',1.91),('15087','2013-09-09','17:00:00',1.02),('15087','2014-04-12','09:05:00',1.15),('15087','2014-04-12','09:10:00',1.09),('15087','2014-04-12','09:15:00',1.7),('15087','2014-04-12','09:20:00',2.56),('15087','2014-04-12','09:25:00',2.73),('15087','2014-04-12','09:30:00',1.9),('15087','2014-04-12','09:35:00',1.56),('15087','2014-04-12','09:40:00',1.36),('15087','2014-04-12','09:45:00',1.34),('15087','2014-04-12','09:50:00',1.51),('15087','2014-04-12','09:55:00',1.49),('15087','2014-04-12','10:00:00',1.51),('15087','2014-04-12','10:05:00',1.53),('15087','2014-04-12','10:10:00',1.71),('15087','2014-04-12','10:15:00',1.87),('15087','2014-04-12','10:20:00',2.02),('15087','2014-04-12','10:25:00',2.1),('15087','2014-04-12','10:30:00',2.25),('15087','2014-04-12','10:35:00',2.47),('15087','2014-04-12','10:40:00',2.52),('15087','2014-04-12','10:45:00',2.76),('15087','2014-04-12','10:50:00',2.79),('15087','2014-04-12','10:55:00',3.25),('15087','2014-04-12','11:00:00',3.21),('15087','2014-04-12','11:05:00',2.5),('15087','2014-04-12','11:10:00',2.28),('15087','2014-04-12','11:15:00',3.62),('15087','2014-04-12','11:20:00',4.48),('15087','2014-04-12','11:25:00',3.24),('15087','2014-04-12','11:30:00',3.78),('15087','2014-04-12','11:35:00',4.28),('15087','2014-04-12','11:40:00',3.95),('15087','2014-04-12','11:45:00',3.96),('15087','2014-04-12','11:50:00',3.01),('15087','2014-04-12','11:55:00',3.33),('15087','2014-04-12','12:00:00',3.26),('15087','2014-04-12','12:05:00',1.95),('15087','2014-04-12','12:10:00',1.95),('15087','2014-04-12','12:15:00',1.98),('15087','2014-04-12','12:20:00',3.47),('15087','2014-04-12','12:25:00',3.19),('15087','2014-04-12','12:30:00',3.06),('15087','2014-04-12','12:35:00',2.89),('15087','2014-04-12','12:40:00',3.29),('15087','2014-04-12','12:45:00',2.4),('15087','2014-04-12','12:50:00',2.65),('15087','2014-04-12','12:55:00',2.35),('15087','2014-04-12','13:00:00',2.48),('15087','2014-04-12','13:05:00',3.54),('15087','2014-04-12','13:10:00',3.07),('15087','2014-04-12','13:15:00',4.1),('15087','2014-04-12','13:20:00',4.18),('15087','2014-04-12','13:25:00',4.68),('15087','2014-04-12','13:30:00',2.44),('15087','2014-04-12','13:35:00',1.5),('15087','2014-04-12','13:40:00',2.7),('15087','2014-04-12','13:45:00',4.13),('15087','2014-04-12','13:50:00',1.8),('15087','2014-04-12','13:55:00',3.42),('15087','2014-04-12','14:00:00',4.18),('15087','2014-04-12','14:05:00',4.52),('15087','2014-04-12','14:10:00',3.79),('15087','2014-04-12','14:15:00',2.33),('15087','2014-04-12','14:20:00',3.37),('15087','2014-04-12','14:25:00',1.87),('15087','2014-04-12','14:30:00',3.3),('15087','2014-04-12','14:35:00',1.85),('15087','2014-04-12','14:40:00',1.7),('15087','2014-04-12','14:45:00',3.63),('15087','2014-04-12','14:50:00',4.41),('15087','2014-04-12','14:55:00',3.57),('15087','2014-04-12','15:00:00',2.24),('15087','2014-04-12','15:05:00',3.64),('15087','2014-04-12','15:10:00',3.68),('15087','2014-04-12','15:15:00',3.6),('15087','2014-04-12','15:20:00',2.59),('15087','2014-04-12','15:25:00',2.19),('15087','2014-04-12','15:30:00',2.37),('15087','2014-04-12','15:35:00',2.12),('15087','2014-04-12','15:40:00',2.69),('15087','2014-04-12','15:45:00',3),('15087','2014-04-12','15:50:00',3.26),('15087','2014-04-12','15:55:00',3.18),('15087','2014-04-12','16:00:00',3.14),('15087','2014-04-12','16:05:00',2.94),('15087','2014-04-12','16:10:00',2.85),('15087','2014-04-12','16:15:00',3.17),('15087','2014-04-12','16:20:00',3.15),('15087','2014-04-12','16:25:00',2.77),('15087','2014-04-12','16:30:00',2.69),('15087','2014-04-12','16:35:00',2.29),('15087','2014-04-12','16:40:00',2.25),('15087','2014-04-12','16:45:00',2.32),('15087','2014-04-12','16:50:00',1.65),('15087','2014-04-12','16:55:00',2.27),('15087','2014-04-12','17:00:00',2.22),('15087','2014-04-12','17:05:00',2.08),('15087','2014-04-12','17:10:00',2.04),('15087','2014-04-12','17:15:00',1.92),('15087','2014-04-12','17:20:00',1.46),('15087','2014-04-12','17:25:00',1.72),('15087','2014-04-12','17:30:00',1.6),('15087','2014-04-12','17:35:00',1.26),('15087','2014-04-12','17:40:00',1.71),('15087','2014-04-12','17:45:00',1.68),('15087','2014-04-12','17:50:00',1.44),('15087','2014-04-12','17:55:00',1.28),('15087','2014-04-12','18:00:00',1.01),('15087','2013-09-08','09:05:00',1.09),('15087','2013-09-08','09:10:00',1.12),('15087','2013-09-08','09:15:00',1.2),('15087','2013-09-08','09:20:00',1.2),('15087','2013-09-08','09:25:00',1.53),('15087','2013-09-08','09:30:00',2.11),('15087','2013-09-08','09:35:00',2.33),('15087','2013-09-08','09:40:00',2.24),('15087','2013-09-08','09:45:00',2.5),('15087','2013-09-08','09:50:00',2.54),('15087','2013-09-08','09:55:00',2.56),('15087','2013-09-08','10:00:00',2.65),('15087','2013-09-08','10:05:00',2.75),('15087','2013-09-08','10:10:00',2.83),('15087','2013-09-08','10:15:00',2.87),('15087','2013-09-08','10:20:00',2.93),('15087','2013-09-08','10:25:00',3),('15087','2013-09-08','10:30:00',3.05),('15087','2013-09-08','10:35:00',3.13),('15087','2013-09-08','10:40:00',3.19),('15087','2013-09-08','10:45:00',3.21),('15087','2013-09-08','10:50:00',3.26),('15087','2013-09-08','10:55:00',3.3),('15087','2013-09-08','11:00:00',3.24),('15087','2013-09-08','11:05:00',3.3),('15087','2013-09-08','11:10:00',3.38),('15087','2013-09-08','11:15:00',3.47),('15087','2013-09-08','11:20:00',3.48),('15087','2013-09-08','11:25:00',3.44),('15087','2013-09-08','11:30:00',3.47),('15087','2013-09-08','11:35:00',3.47),('15087','2013-09-08','11:40:00',3.57),('15087','2013-09-08','11:45:00',3.59),('15087','2013-09-08','11:50:00',3.55),('15087','2013-09-08','11:55:00',3.53),('15087','2013-09-08','12:00:00',3.53),('15087','2013-09-08','12:05:00',3.44),('15087','2013-09-08','12:10:00',3.54),('15087','2013-09-08','12:15:00',3.8),('15087','2013-09-08','12:20:00',3.75),('15087','2013-09-08','12:25:00',3.73),('15087','2013-09-08','12:30:00',3.71),('15087','2013-09-08','12:35:00',3.62),('15087','2013-09-08','12:40:00',3.59),('15087','2013-09-08','12:45:00',3.79),('15087','2013-09-08','12:50:00',3.78),('15087','2013-09-08','12:55:00',3.79),('15087','2013-09-08','13:00:00',3.73),('15087','2013-09-08','13:05:00',3.84),('15087','2013-09-08','13:10:00',3.72),('15087','2013-09-08','13:15:00',3.72),('15087','2013-09-08','13:20:00',3.76),('15087','2013-09-08','13:25:00',3.39),('15087','2013-09-08','13:30:00',3.37),('15087','2013-09-08','13:35:00',3.29),('15087','2013-09-08','13:40:00',2.38),('15087','2013-09-08','13:45:00',2.18),('15087','2013-09-08','13:50:00',3.03),('15087','2013-09-08','13:55:00',3.06),('15087','2013-09-08','14:00:00',3.54),('15087','2013-09-08','14:05:00',3.41),('15087','2013-09-08','14:10:00',3.83),('15087','2013-09-08','14:15:00',3.37),('15087','2013-09-08','14:20:00',3.77),('15087','2013-09-08','14:25:00',4.01),('15087','2013-09-08','14:30:00',3.49),('15087','2013-09-08','14:35:00',3.62),('15087','2013-09-08','14:40:00',3.48),('15087','2013-09-08','14:45:00',3.45),('15087','2013-09-08','14:50:00',3.45),('15087','2013-09-08','14:55:00',3.4),('15087','2013-09-08','15:00:00',3.38),('15087','2013-09-08','15:05:00',2.61),('15087','2013-09-08','15:10:00',1.77),('15087','2013-09-08','15:15:00',2.41),('15087','2013-09-08','15:20:00',3.08),('15087','2013-09-08','15:25:00',3.04),('15087','2013-09-08','15:30:00',2.97),('15087','2013-09-08','15:35:00',2.79),('15087','2013-09-08','15:40:00',2.75),('15087','2013-09-08','15:45:00',2.84),('15087','2013-09-08','15:50:00',2.72),('15087','2013-09-08','15:55:00',2.17),('15087','2013-09-08','16:00:00',2.3),('15087','2013-09-08','16:05:00',2.32),('15087','2013-09-08','16:10:00',2.1),('15087','2013-09-08','16:15:00',2.31),('15087','2013-09-08','16:20:00',1.98),('15087','2013-09-08','16:25:00',1.96),('15087','2013-09-08','16:30:00',2.08),('15087','2013-09-08','16:35:00',1.88),('15087','2013-09-08','16:40:00',1.6),('15087','2013-09-08','16:45:00',1.18),('15087','2013-09-08','16:50:00',1.13),('15087','2013-09-08','16:55:00',1.04),('15087','2013-09-08','17:00:00',1.36),('15087','2013-09-08','17:05:00',1.79),('15087','2013-09-08','17:10:00',1.67),('15087','2013-09-08','17:15:00',1.47),('15087','2013-09-08','17:20:00',1.24),('15087','2013-09-08','17:25:00',1.24),('15087','2013-09-08','17:30:00',1.13),('15087','2013-09-07','08:20:00',1.07),('15087','2013-09-07','08:25:00',1.16),('15087','2013-09-07','08:30:00',1.25),('15087','2013-09-07','08:35:00',1.34),('15087','2013-09-07','08:40:00',1.41),('15087','2013-09-07','08:45:00',1.49),('15087','2013-09-07','08:50:00',1.57),('15087','2013-09-07','08:55:00',1.67),('15087','2013-09-07','09:00:00',1.75),('15087','2013-09-07','09:05:00',1.85),('15087','2013-09-07','09:10:00',1.93),('15087','2013-09-07','09:15:00',2.04),('15087','2013-09-07','09:20:00',2.14),('15087','2013-09-07','09:25:00',2.25),('15087','2013-09-07','09:30:00',2.36),('15087','2013-09-07','09:35:00',2.44),('15087','2013-09-07','09:40:00',2.51),('15087','2013-09-07','09:45:00',2.56),('15087','2013-09-07','09:50:00',2.63),('15087','2013-09-07','09:55:00',2.71),('15087','2013-09-07','10:00:00',2.78),('15087','2013-09-07','10:05:00',2.84),('15087','2013-09-07','10:10:00',2.87),('15087','2013-09-07','10:15:00',2.91),('15087','2013-09-07','10:20:00',3.01),('15087','2013-09-07','10:25:00',3.07),('15087','2013-09-07','10:30:00',3.1),('15087','2013-09-07','10:35:00',3.17),('15087','2013-09-07','10:40:00',3.23),('15087','2013-09-07','10:45:00',3.27),('15087','2013-09-07','10:50:00',3.32),('15087','2013-09-07','10:55:00',3.37),('15087','2013-09-07','11:00:00',3.41),('15087','2013-09-07','11:05:00',3.4),('15087','2013-09-07','11:10:00',3.49),('15087','2013-09-07','11:15:00',3.53),('15087','2013-09-07','11:20:00',3.57),('15087','2013-09-07','11:25:00',3.62),('15087','2013-09-07','11:30:00',3.67),('15087','2013-09-07','11:35:00',3.71),('15087','2013-09-07','11:40:00',3.76),('15087','2013-09-07','11:45:00',3.78),('15087','2013-09-07','11:50:00',3.8),('15087','2013-09-07','11:55:00',3.83),('15087','2013-09-07','12:00:00',3.85),('15087','2013-09-07','12:05:00',3.87),('15087','2013-09-07','12:10:00',3.89),('15087','2013-09-07','12:15:00',3.88),('15087','2013-09-07','12:20:00',3.91),('15087','2013-09-07','12:25:00',3.9),('15087','2013-09-07','12:30:00',3.9),('15087','2013-09-07','12:35:00',3.92),('15087','2013-09-07','12:40:00',3.92),('15087','2013-09-07','12:45:00',3.91),('15087','2013-09-07','12:50:00',3.95),('15087','2013-09-07','12:55:00',3.85),('15087','2013-09-07','13:00:00',3.89),('15087','2013-09-07','13:05:00',3.96),('15087','2013-09-07','13:10:00',3.95),('15087','2013-09-07','13:15:00',3.95),('15087','2013-09-07','13:20:00',4),('15087','2013-09-07','13:25:00',3.97),('15087','2013-09-07','13:30:00',4.05),('15087','2013-09-07','13:35:00',4),('15087','2013-09-07','13:40:00',3.84),('15087','2013-09-07','13:45:00',3.91),('15087','2013-09-07','13:50:00',3.81),('15087','2013-09-07','13:55:00',3.7),('15087','2013-09-07','14:00:00',3.95),('15087','2013-09-07','14:05:00',3.92),('15087','2013-09-07','14:10:00',3.83),('15087','2013-09-07','14:15:00',3.73),('15087','2013-09-07','14:20:00',3.49),('15087','2013-09-07','14:25:00',3.63),('15087','2013-09-07','14:30:00',3.58),('15087','2013-09-07','14:35:00',3.54),('15087','2013-09-07','14:40:00',3.55),('15087','2013-09-07','14:45:00',3.54),('15087','2013-09-07','14:50:00',3.4),('15087','2013-09-07','14:55:00',3.41),('15087','2013-09-07','15:00:00',3.38),('15087','2013-09-07','15:05:00',3.3),('15087','2013-09-07','15:10:00',3.22),('15087','2013-09-07','15:15:00',3.21),('15087','2013-09-07','15:20:00',3.15),('15087','2013-09-07','15:25:00',3.1),('15087','2013-09-07','15:30:00',3.05),('15087','2013-09-07','15:35:00',2.99),('15087','2013-09-07','15:40:00',2.88),('15087','2013-09-07','15:45:00',2.84),('15087','2013-09-07','15:50:00',2.78),('15087','2013-09-07','15:55:00',2.71),('15087','2013-09-07','16:00:00',2.67),('15087','2013-09-07','16:05:00',2.6),('15087','2013-09-07','16:10:00',2.53),('15087','2013-09-07','16:15:00',2.46),('15087','2013-09-07','16:20:00',2.36),('15087','2013-09-07','16:25:00',2.27),('15087','2013-09-07','16:30:00',2.15),('15087','2013-09-07','16:35:00',2),('15087','2013-09-07','16:40:00',1.98),('15087','2013-09-07','16:45:00',1.94),('15087','2013-09-07','16:50:00',1.83),('15087','2013-09-07','16:55:00',1.76),('15087','2013-09-07','17:00:00',1.64),('15087','2013-09-07','17:05:00',1.51),('15087','2013-09-07','17:10:00',1.46),('15087','2013-09-07','17:15:00',1.38),('15087','2013-09-07','17:20:00',1.28),('15087','2013-09-07','17:25:00',1.2),('15087','2013-09-07','17:30:00',1.09),('15087','2013-09-07','17:35:00',1.04),('15087','2013-09-06','08:15:00',1.03),('15087','2013-09-06','08:20:00',1.11),('15087','2013-09-06','08:25:00',1.2),('15087','2013-09-06','08:30:00',1.28),('15087','2013-09-06','08:35:00',1.37),('15087','2013-09-06','08:40:00',1.47),('15087','2013-09-06','08:45:00',1.56),('15087','2013-09-06','08:50:00',1.62),('15087','2013-09-06','08:55:00',1.74),('15087','2013-09-06','09:00:00',1.81),('15087','2013-09-06','09:05:00',1.93),('15087','2013-09-06','09:10:00',2),('15087','2013-09-06','09:15:00',2.12),('15087','2013-09-06','09:20:00',2.22),('15087','2013-09-06','09:25:00',2.3),('15087','2013-09-06','09:30:00',2.39),('15087','2013-09-06','09:35:00',2.46),('15087','2013-09-06','09:40:00',2.57),('15087','2013-09-06','09:45:00',2.64),('15087','2013-09-06','09:50:00',2.69),('15087','2013-09-06','09:55:00',2.75),('15087','2013-09-06','10:00:00',2.81),('15087','2013-09-06','10:05:00',2.88),('15087','2013-09-06','10:10:00',2.94),('15087','2013-09-06','10:15:00',3),('15087','2013-09-06','10:20:00',3.05),('15087','2013-09-06','10:25:00',3.12),('15087','2013-09-06','10:30:00',3.18),('15087','2013-09-06','10:35:00',3.25),('15087','2013-09-06','10:40:00',3.35),('15087','2013-09-06','10:45:00',3.38),('15087','2013-09-06','10:50:00',3.4),('15087','2013-09-06','10:55:00',3.44),('15087','2013-09-06','11:00:00',3.5),('15087','2013-09-06','11:05:00',3.47),('15087','2013-09-06','11:10:00',3.6),('15087','2013-09-06','11:15:00',3.63),('15087','2013-09-06','11:20:00',3.65),('15087','2013-09-06','11:25:00',3.68),('15087','2013-09-06','11:30:00',3.71),('15087','2013-09-06','11:35:00',3.75),('15087','2013-09-06','11:40:00',3.8),('15087','2013-09-06','11:45:00',3.81),('15087','2013-09-06','11:50:00',3.84),('15087','2013-09-06','11:55:00',3.87),('15087','2013-09-06','12:00:00',3.83),('15087','2013-09-06','12:05:00',3.83),('15087','2013-09-06','12:10:00',3.88),('15087','2013-09-06','12:15:00',3.97),('15087','2013-09-06','12:20:00',3.99),('15087','2013-09-06','12:25:00',4.02),('15087','2013-09-06','12:30:00',4.03),('15087','2013-09-06','12:35:00',4.04),('15087','2013-09-06','12:40:00',4.06),('15087','2013-09-06','12:45:00',4.07),('15087','2013-09-06','12:50:00',4.03),('15087','2013-09-06','12:55:00',4.03),('15087','2013-09-06','13:00:00',4.04),('15087','2013-09-06','13:05:00',4.04),('15087','2013-09-06','13:10:00',4.02),('15087','2013-09-06','13:15:00',4.02),('15087','2013-09-06','13:20:00',3.99),('15087','2013-09-06','13:25:00',3.99),('15087','2013-09-06','13:30:00',3.96),('15087','2013-09-06','13:35:00',3.99),('15087','2013-09-06','13:40:00',3.98),('15087','2013-09-06','13:45:00',3.94),('15087','2013-09-06','13:50:00',3.81),('15087','2013-09-06','13:55:00',3.79),('15087','2013-09-06','14:00:00',3.77),('15087','2013-09-06','14:05:00',3.76),('15087','2013-09-06','14:10:00',3.7),('15087','2013-09-06','14:15:00',3.69),('15087','2013-09-06','14:20:00',3.67),('15087','2013-09-06','14:25:00',3.66),('15087','2013-09-06','14:30:00',3.48),('15087','2013-09-06','14:35:00',3.37),('15087','2013-09-06','14:40:00',3.46),('15087','2013-09-06','14:45:00',3.4),('15087','2013-09-06','14:50:00',3.38),('15087','2013-09-06','14:55:00',3.43),('15087','2013-09-06','15:00:00',3.38),('15087','2013-09-06','15:05:00',3.3),('15087','2013-09-06','15:10:00',3.12),('15087','2013-09-06','15:15:00',3.02),('15087','2013-09-06','15:20:00',2.79),('15087','2013-09-06','15:25:00',2.97),('15087','2013-09-06','15:30:00',2.63),('15087','2013-09-06','15:35:00',2.64),('15087','2013-09-06','15:40:00',2.82),('15087','2013-09-06','15:45:00',2.83),('15087','2013-09-06','15:50:00',2.76),('15087','2013-09-06','15:55:00',2.71),('15087','2013-09-06','16:00:00',2.64),('15087','2013-09-06','16:05:00',2.59),('15087','2013-09-06','16:10:00',2.49),('15087','2013-09-06','16:15:00',2.46),('15087','2013-09-06','16:20:00',2.37),('15087','2013-09-06','16:25:00',2.32),('15087','2013-09-06','16:30:00',2.2),('15087','2013-09-06','16:35:00',2.08),('15087','2013-09-06','16:40:00',2.06),('15087','2013-09-06','16:45:00',1.94),('15087','2013-09-06','16:50:00',1.88),('15087','2013-09-06','16:55:00',1.8),('15087','2013-09-06','17:00:00',1.73),('15087','2013-09-06','17:05:00',1.56),('15087','2013-09-06','17:10:00',1.49),('15087','2013-09-06','17:15:00',1.42),('15087','2013-09-06','17:20:00',1.27),('15087','2013-09-06','17:25:00',1.19),('15087','2013-09-06','17:30:00',1.14),('15087','2013-09-06','17:35:00',1.07),('15087','2013-09-06','17:40:00',1.04),('15087','2013-09-05','08:10:00',1.04),('15087','2013-09-05','08:15:00',1.14),('15087','2013-09-05','08:20:00',1.23),('15087','2013-09-05','08:25:00',1.33),('15087','2013-09-05','08:30:00',1.42),('15087','2013-09-05','08:35:00',1.51),('15087','2013-09-05','08:40:00',1.6),('15087','2013-09-05','08:45:00',1.71),('15087','2013-09-05','08:50:00',1.79),('15087','2013-09-05','08:55:00',1.89),('15087','2013-09-05','09:00:00',1.98),('15087','2013-09-05','09:05:00',2.06),('15087','2013-09-05','09:10:00',2.18),('15087','2013-09-05','09:15:00',2.31),('15087','2013-09-05','09:20:00',2.4),('15087','2013-09-05','09:25:00',2.49),('15087','2013-09-05','09:30:00',2.55),('15087','2013-09-05','09:35:00',2.6),('15087','2013-09-05','09:40:00',2.69),('15087','2013-09-05','09:45:00',2.76),('15087','2013-09-05','09:50:00',2.85),('15087','2013-09-05','09:55:00',2.93),('15087','2013-09-05','10:00:00',2.98),('15087','2013-09-05','10:05:00',3.05),('15087','2013-09-05','10:10:00',3.11),('15087','2013-09-05','10:15:00',3.17),('15087','2013-09-05','10:20:00',3.22),('15087','2013-09-05','10:25:00',3.27),('15087','2013-09-05','10:30:00',3.32),('15087','2013-09-05','10:35:00',3.39),('15087','2013-09-05','10:40:00',3.43),('15087','2013-09-05','10:45:00',3.49),('15087','2013-09-05','10:50:00',3.51),('15087','2013-09-05','10:55:00',3.57),('15087','2013-09-05','11:00:00',3.62),('15087','2013-09-05','11:05:00',3.68),('15087','2013-09-05','11:10:00',3.72),('15087','2013-09-05','11:15:00',3.73),('15087','2013-09-05','11:20:00',3.74),('15087','2013-09-05','11:25:00',3.82),('15087','2013-09-05','11:30:00',3.83),('15087','2013-09-05','11:35:00',3.83),('15087','2013-09-05','11:40:00',3.82),('15087','2013-09-05','11:45:00',3.84),('15087','2013-09-05','11:50:00',3.86),('15087','2013-09-05','11:55:00',3.97),('15087','2013-09-05','12:00:00',3.96),('15087','2013-09-05','12:05:00',3.98),('15087','2013-09-05','12:10:00',4.04),('15087','2013-09-05','12:15:00',4.07),('15087','2013-09-05','12:20:00',4.04),('15087','2013-09-05','12:25:00',4.08),('15087','2013-09-05','12:30:00',4.09),('15087','2013-09-05','12:35:00',4.11),('15087','2013-09-05','12:40:00',4.11),('15087','2013-09-05','12:45:00',4.13),('15087','2013-09-05','12:50:00',4.15),('15087','2013-09-05','12:55:00',4.16),('15087','2013-09-05','13:00:00',4.13),('15087','2013-09-05','13:05:00',4.12),('15087','2013-09-05','13:10:00',4.14),('15087','2013-09-05','13:15:00',4.14),('15087','2013-09-05','13:20:00',4.15),('15087','2013-09-05','13:25:00',4.16),('15087','2013-09-05','13:30:00',4.17),('15087','2013-09-05','13:35:00',4.13),('15087','2013-09-05','13:40:00',4.12),('15087','2013-09-05','13:45:00',4.05),('15087','2013-09-05','13:50:00',3.94),('15087','2013-09-05','13:55:00',3.96),('15087','2013-09-05','14:00:00',3.94),('15087','2013-09-05','14:05:00',3.9),('15087','2013-09-05','14:10:00',3.87),('15087','2013-09-05','14:15:00',3.68),('15087','2013-09-05','14:20:00',3.75),('15087','2013-09-05','14:25:00',3.75),('15087','2013-09-05','14:30:00',3.65),('15087','2013-09-05','14:35:00',3.5),('15087','2013-09-05','14:40:00',3.61),('15087','2013-09-05','14:45:00',3.58),('15087','2013-09-05','14:50:00',3.5),('15087','2013-09-05','14:55:00',3.49),('15087','2013-09-05','15:00:00',3.47),('15087','2013-09-05','15:05:00',3.41),('15087','2013-09-05','15:10:00',3.26),('15087','2013-09-05','15:15:00',3.11),('15087','2013-09-05','15:20:00',2.97),('15087','2013-09-05','15:25:00',3.11),('15087','2013-09-05','15:30:00',2.99),('15087','2013-09-05','15:35:00',3.01),('15087','2013-09-05','15:40:00',2.98),('15087','2013-09-05','15:45:00',2.93),('15087','2013-09-05','15:50:00',2.88),('15087','2013-09-05','15:55:00',2.84),('15087','2013-09-05','16:00:00',2.76),('15087','2013-09-05','16:05:00',2.72),('15087','2013-09-05','16:10:00',2.66),('15087','2013-09-05','16:15:00',2.6),('15087','2013-09-05','16:20:00',2.5),('15087','2013-09-05','16:25:00',2.44),('15087','2013-09-05','16:30:00',2.28),('15087','2013-09-05','16:35:00',2.28),('15087','2013-09-05','16:40:00',2.23),('15087','2013-09-05','16:45:00',2.19),('15087','2013-09-05','16:50:00',1.8),('15087','2013-09-05','16:55:00',1.42),('15087','2013-09-05','17:00:00',1.13),('15087','2013-09-05','17:05:00',1.24),('15087','2013-09-05','17:10:00',1.24),('15087','2013-09-05','17:15:00',1.11),('15087','2013-09-05','17:20:00',1.23),('15087','2013-09-05','17:25:00',1.24),('15087','2013-09-05','17:30:00',1.24),('15087','2013-09-05','17:35:00',1.31),('15087','2013-09-05','17:40:00',1.36),('15087','2013-09-05','17:45:00',1.16),('15087','2013-09-05','17:50:00',1.06),('15087','2013-09-04','08:10:00',1.05),('15087','2013-09-04','08:15:00',1.14),('15087','2013-09-04','08:20:00',1.23),('15087','2013-09-04','08:25:00',1.32),('15087','2013-09-04','08:30:00',1.42),('15087','2013-09-04','08:35:00',1.5),('15087','2013-09-04','08:40:00',1.59),('15087','2013-09-04','08:45:00',1.68),('15087','2013-09-04','08:50:00',1.78),('15087','2013-09-04','08:55:00',1.87),('15087','2013-09-04','09:00:00',1.97),('15087','2013-09-04','09:05:00',2.07),('15087','2013-09-04','09:10:00',2.18),('15087','2013-09-04','09:15:00',2.32),('15087','2013-09-04','09:20:00',2.42),('15087','2013-09-04','09:25:00',2.53),('15087','2013-09-04','09:30:00',2.62),('15087','2013-09-04','09:35:00',2.72),('15087','2013-09-04','09:40:00',2.81),('15087','2013-09-04','09:45:00',2.86),('15087','2013-09-04','09:50:00',2.94),('15087','2013-09-04','09:55:00',3.02),('15087','2013-09-04','10:00:00',3.11),('15087','2013-09-04','10:05:00',3.15),('15087','2013-09-04','10:10:00',3.23),('15087','2013-09-04','10:15:00',3.27),('15087','2013-09-04','10:20:00',3.33),('15087','2013-09-04','10:25:00',3.4),('15087','2013-09-04','10:30:00',3.46),('15087','2013-09-04','10:35:00',3.52),('15087','2013-09-04','10:40:00',3.59),('15087','2013-09-04','10:45:00',3.63),('15087','2013-09-04','10:50:00',3.67),('15087','2013-09-04','10:55:00',3.73),('15087','2013-09-04','11:00:00',3.78),('15087','2013-09-04','11:05:00',3.84),('15087','2013-09-04','11:10:00',3.88),('15087','2013-09-04','11:15:00',3.88),('15087','2013-09-04','11:20:00',3.94),('15087','2013-09-04','11:25:00',3.97),('15087','2013-09-04','11:30:00',4),('15087','2013-09-04','11:35:00',4.05),('15087','2013-09-04','11:40:00',4.11),('15087','2013-09-04','11:45:00',4.13),('15087','2013-09-04','11:50:00',4.15),('15087','2013-09-04','11:55:00',4.17),('15087','2013-09-04','12:00:00',4.19),('15087','2013-09-04','12:05:00',4.19),('15087','2013-09-04','12:10:00',4.25),('15087','2013-09-04','12:15:00',4.23),('15087','2013-09-04','12:20:00',4.22),('15087','2013-09-04','12:25:00',4.28),('15087','2013-09-04','12:30:00',4.29),('15087','2013-09-04','12:35:00',4.3),('15087','2013-09-04','12:40:00',4.34),('15087','2013-09-04','12:45:00',4.35),('15087','2013-09-04','12:50:00',4.29),('15087','2013-09-04','12:55:00',4.33),('15087','2013-09-04','13:00:00',4.35),('15087','2013-09-04','13:05:00',4.32),('15087','2013-09-04','13:10:00',4.34),('15087','2013-09-04','13:15:00',4.36),('15087','2013-09-04','13:20:00',4.33),('15087','2013-09-04','13:25:00',4.31),('15087','2013-09-04','13:30:00',4.29),('15087','2013-09-04','13:35:00',4.31),('15087','2013-09-04','13:40:00',4.3),('15087','2013-09-04','13:45:00',4.29),('15087','2013-09-04','13:50:00',4.19),('15087','2013-09-04','13:55:00',3.93),('15087','2013-09-04','14:00:00',4.01),('15087','2013-09-04','14:05:00',4.08),('15087','2013-09-04','14:10:00',4.08),('15087','2013-09-04','14:15:00',4.02),('15087','2013-09-04','14:20:00',3.96),('15087','2013-09-04','14:25:00',3.95),('15087','2013-09-04','14:30:00',3.87),('15087','2013-09-04','14:35:00',3.72),('15087','2013-09-04','14:40:00',3.82),('15087','2013-09-04','14:45:00',3.78),('15087','2013-09-04','14:50:00',3.71),('15087','2013-09-04','14:55:00',3.49),('15087','2013-09-04','15:00:00',3.51),('15087','2013-09-04','15:05:00',3.48),('15087','2013-09-04','15:10:00',3.41),('15087','2013-09-04','15:15:00',3.29),('15087','2013-09-04','15:20:00',3.21),('15087','2013-09-04','15:25:00',3.29),('15087','2013-09-04','15:30:00',3.17),('15087','2013-09-04','15:35:00',3.05),('15087','2013-09-04','15:40:00',3.09),('15087','2013-09-04','15:45:00',3.04),('15087','2013-09-04','15:50:00',2.98),('15087','2013-09-04','15:55:00',2.92),('15087','2013-09-04','16:00:00',2.84),('15087','2013-09-04','16:05:00',2.77),('15087','2013-09-04','16:10:00',2.71),('15087','2013-09-04','16:15:00',2.65),('15087','2013-09-04','16:20:00',2.59),('15087','2013-09-04','16:25:00',2.51),('15087','2013-09-04','16:30:00',2.45),('15087','2013-09-04','16:35:00',2.38),('15087','2013-09-04','16:40:00',2.28),('15087','2013-09-04','16:45:00',2.2),('15087','2013-09-04','16:50:00',2.08),('15087','2013-09-04','16:55:00',2),('15087','2013-09-04','17:00:00',1.93),('15087','2013-09-04','17:05:00',1.76),('15087','2013-09-04','17:10:00',1.66),('15087','2013-09-04','17:15:00',1.5),('15087','2013-09-04','17:20:00',1.4),('15087','2013-09-04','17:25:00',1.36),('15087','2013-09-04','17:30:00',1.26),('15087','2013-09-04','17:35:00',1.19),('15087','2013-09-04','17:40:00',1.08),('15087','2013-09-03','08:15:00',1.03),('15087','2013-09-03','08:20:00',1.11),('15087','2013-09-03','08:25:00',1.19),('15087','2013-09-03','08:30:00',1.28),('15087','2013-09-03','08:35:00',1.37),('15087','2013-09-03','08:40:00',1.45),('15087','2013-09-03','08:45:00',1.54),('15087','2013-09-03','08:50:00',1.62),('15087','2013-09-03','08:55:00',1.74),('15087','2013-09-03','09:00:00',1.81),('15087','2013-09-03','09:05:00',1.88),('15087','2013-09-03','09:10:00',1.98),('15087','2013-09-03','09:15:00',2.08),('15087','2013-09-03','09:20:00',2.26),('15087','2013-09-03','09:25:00',2.35),('15087','2013-09-03','09:30:00',2.45),('15087','2013-09-03','09:35:00',2.53),('15087','2013-09-03','09:40:00',2.6),('15087','2013-09-03','09:45:00',2.68),('15087','2013-09-03','09:50:00',2.74),('15087','2013-09-03','09:55:00',2.79),('15087','2013-09-03','10:00:00',2.86),('15087','2013-09-03','10:05:00',2.92),('15087','2013-09-03','10:10:00',2.99),('15087','2013-09-03','10:15:00',3.06),('15087','2013-09-03','10:20:00',3.16),('15087','2013-09-03','10:25:00',3.23),('15087','2013-09-03','10:30:00',3.28),('15087','2013-09-03','10:35:00',3.36),('15087','2013-09-03','10:40:00',3.46),('15087','2013-09-03','10:45:00',3.52),('15087','2013-09-03','10:50:00',3.55),('15087','2013-09-03','10:55:00',3.6),('15087','2013-09-03','11:00:00',3.64),('15087','2013-09-03','11:05:00',3.68),('15087','2013-09-03','11:10:00',3.72),('15087','2013-09-03','11:15:00',3.76),('15087','2013-09-03','11:20:00',3.76),('15087','2013-09-03','11:25:00',3.82),('15087','2013-09-03','11:30:00',3.86),('15087','2013-09-03','11:35:00',3.9),('15087','2013-09-03','11:40:00',3.92),('15087','2013-09-03','11:45:00',3.95),('15087','2013-09-03','11:50:00',3.97),('15087','2013-09-03','11:55:00',4.02),('15087','2013-09-03','12:00:00',4.06),('15087','2013-09-03','12:05:00',4.08),('15087','2013-09-03','12:10:00',4.09),('15087','2013-09-03','12:15:00',4.15),('15087','2013-09-03','12:20:00',4.18),('15087','2013-09-03','12:25:00',4.18),('15087','2013-09-03','12:30:00',4.19),('15087','2013-09-03','12:35:00',4.19),('15087','2013-09-03','12:40:00',4.21),('15087','2013-09-03','12:45:00',4.22),('15087','2013-09-03','12:50:00',4.21),('15087','2013-09-03','12:55:00',4.23),('15087','2013-09-03','13:00:00',4.24),('15087','2013-09-03','13:05:00',4.23),('15087','2013-09-03','13:10:00',4.24),('15087','2013-09-03','13:15:00',4.25),('15087','2013-09-03','13:20:00',4.22),('15087','2013-09-03','13:25:00',4.17),('15087','2013-09-03','13:30:00',4.17),('15087','2013-09-03','13:35:00',4.14),('15087','2013-09-03','13:40:00',4.17),('15087','2013-09-03','13:45:00',4.13),('15087','2013-09-03','13:50:00',4.15),('15087','2013-09-03','13:55:00',3.92),('15087','2013-09-03','14:00:00',3.88),('15087','2013-09-03','14:05:00',3.87),('15087','2013-09-03','14:10:00',3.92),('15087','2013-09-03','14:15:00',3.73),('15087','2013-09-03','14:20:00',3.72),('15087','2013-09-03','14:25:00',3.84),('15087','2013-09-03','14:30:00',3.82),('15087','2013-09-03','14:35:00',3.73),('15087','2013-09-03','14:40:00',3.75),('15087','2013-09-03','14:45:00',3.7),('15087','2013-09-03','14:50:00',3.68),('15087','2013-09-03','14:55:00',3.53),('15087','2013-09-03','15:00:00',3.43),('15087','2013-09-03','15:05:00',3.42),('15087','2013-09-03','15:10:00',3.35),('15087','2013-09-03','15:15:00',3.3),('15087','2013-09-03','15:20:00',3.13),('15087','2013-09-03','15:25:00',3.2),('15087','2013-09-03','15:30:00',3.12),('15087','2013-09-03','15:35:00',2.98),('15087','2013-09-03','15:40:00',3),('15087','2013-09-03','15:45:00',2.92),('15087','2013-09-03','15:50:00',2.9),('15087','2013-09-03','15:55:00',2.85),('15087','2013-09-03','16:00:00',2.81),('15087','2013-09-03','16:05:00',2.77),('15087','2013-09-03','16:10:00',2.63),('15087','2013-09-03','16:15:00',2.43),('15087','2013-09-03','16:20:00',2.39),('15087','2013-09-03','16:25:00',2.47),('15087','2013-09-03','16:30:00',2.38),('15087','2013-09-03','16:35:00',2.35),('15087','2013-09-03','16:40:00',2.26),('15087','2013-09-03','16:45:00',2.19),('15087','2013-09-03','16:50:00',2.06),('15087','2013-09-03','16:55:00',1.97),('15087','2013-09-03','17:00:00',1.89),('15087','2013-09-03','17:05:00',1.75),('15087','2013-09-03','17:10:00',1.64),('15087','2013-09-03','17:15:00',1.5),('15087','2013-09-03','17:20:00',1.39),('15087','2013-09-03','17:25:00',1.39),('15087','2013-09-03','17:30:00',1.3),('15087','2013-09-03','17:35:00',1.17),('15087','2013-09-03','17:40:00',1.12),('15087','2013-09-02','08:15:00',1.08),('15087','2013-09-02','08:20:00',1.16),('15087','2013-09-02','08:25:00',1.24),('15087','2013-09-02','08:30:00',1.33),('15087','2013-09-02','08:35:00',1.43),('15087','2013-09-02','08:40:00',1.53),('15087','2013-09-02','08:45:00',1.61),('15087','2013-09-02','08:50:00',1.7),('15087','2013-09-02','08:55:00',1.79),('15087','2013-09-02','09:00:00',1.89),('15087','2013-09-02','09:05:00',2.06),('15087','2013-09-02','09:10:00',2.13),('15087','2013-09-02','09:15:00',2.24),('15087','2013-09-02','09:20:00',2.34),('15087','2013-09-02','09:25:00',2.42),('15087','2013-09-02','09:30:00',2.5),('15087','2013-09-02','09:35:00',2.59),('15087','2013-09-02','09:40:00',2.66),('15087','2013-09-02','09:45:00',2.74),('15087','2013-09-02','09:50:00',2.82),('15087','2013-09-02','09:55:00',2.88),('15087','2013-09-02','10:00:00',2.95),('15087','2013-09-02','10:05:00',3.02),('15087','2013-09-02','10:10:00',3.08),('15087','2013-09-02','10:15:00',3.14),('15087','2013-09-02','10:20:00',3.23),('15087','2013-09-02','10:25:00',3.29),('15087','2013-09-02','10:30:00',3.34),('15087','2013-09-02','10:35:00',3.39),('15087','2013-09-02','10:40:00',3.45),('15087','2013-09-02','10:45:00',3.51),('15087','2013-09-02','10:50:00',3.55),('15087','2013-09-02','10:55:00',3.58),('15087','2013-09-02','11:00:00',3.62),('15087','2013-09-02','11:05:00',3.69),('15087','2013-09-02','11:10:00',3.73),('15087','2013-09-02','11:15:00',3.76),('15087','2013-09-02','11:20:00',3.77),('15087','2013-09-02','11:25:00',3.79),('15087','2013-09-02','11:30:00',3.84),('15087','2013-09-02','11:35:00',3.87),('15087','2013-09-02','11:40:00',3.93),('15087','2013-09-02','11:45:00',3.93),('15087','2013-09-02','11:50:00',3.95),('15087','2013-09-02','11:55:00',3.99),('15087','2013-09-02','12:00:00',3.99),('15087','2013-09-02','12:05:00',4.01),('15087','2013-09-02','12:10:00',4.07),('15087','2013-09-02','12:15:00',4.1),('15087','2013-09-02','12:20:00',4.09),('15087','2013-09-02','12:25:00',4.12),('15087','2013-09-02','12:30:00',4.04),('15087','2013-09-02','12:35:00',4.1),('15087','2013-09-02','12:40:00',4.12),('15087','2013-09-02','12:45:00',4.1),('15087','2013-09-02','12:50:00',4.17),('15087','2013-09-02','12:55:00',4.19),('15087','2013-09-02','13:00:00',4.18),('15087','2013-09-02','13:05:00',4.15),('15087','2013-09-02','13:10:00',4.16),('15087','2013-09-02','13:15:00',4.13),('15087','2013-09-02','13:20:00',4.11),('15087','2013-09-02','13:25:00',4.11),('15087','2013-09-02','13:30:00',4.04),('15087','2013-09-02','13:35:00',4.06),('15087','2013-09-02','13:40:00',4.11),('15087','2013-09-02','13:45:00',4.07),('15087','2013-09-02','13:50:00',3.07),('15087','2013-09-02','14:00:00',4.16),('15087','2013-09-02','14:05:00',4.17),('15087','2013-09-02','14:10:00',4.07),('15087','2013-09-02','14:15:00',3.93),('15087','2013-09-02','14:20:00',3.83),('15087','2013-09-02','14:25:00',3.82),('15087','2013-09-02','14:30:00',3.85),('15087','2013-09-02','14:35:00',3.73),('15087','2013-09-02','14:40:00',3.6),('15087','2013-09-02','14:45:00',3.73),('15087','2013-09-02','14:50:00',3.52),('15087','2013-09-02','14:55:00',1.68),('15087','2013-09-02','15:00:00',1.48),('15087','2013-09-02','15:05:00',3.35),('15087','2013-09-02','15:10:00',2.33),('15087','2013-09-02','15:15:00',1.72),('15087','2013-09-02','15:25:00',2.36),('15087','2013-09-02','15:30:00',3.14),('15087','2013-09-02','15:35:00',3.1),('15087','2013-09-02','15:40:00',2.72),('15087','2013-09-02','15:45:00',2.88),('15087','2013-09-02','15:50:00',2.94),('15087','2013-09-02','15:55:00',2.83),('15087','2013-09-02','16:00:00',2.67),('15087','2013-09-02','16:05:00',2.7),('15087','2013-09-02','16:10:00',2.69),('15087','2013-09-02','16:15:00',2.58),('15087','2013-09-02','16:20:00',2.61),('15087','2013-09-02','16:25:00',2.54),('15087','2013-09-02','16:30:00',2.43),('15087','2013-09-02','16:35:00',2.32),('15087','2013-09-02','16:40:00',2.17),('15087','2013-09-02','16:45:00',2.06),('15087','2013-09-02','16:50:00',1.98),('15087','2013-09-02','16:55:00',1.86),('15087','2013-09-02','17:00:00',1.79),('15087','2013-09-02','17:05:00',1.67),('15087','2013-09-02','17:10:00',1.56),('15087','2013-09-02','17:15:00',1.5),('15087','2013-09-02','17:20:00',1.41),('15087','2013-09-02','17:25:00',1.31),('15087','2013-09-02','17:30:00',1.23),('15087','2013-09-02','17:35:00',1.2),('15087','2013-09-02','17:40:00',1.11),('15087','2013-09-02','17:45:00',1.05),('15087','2013-09-01','08:10:00',1.07),('15087','2013-09-01','08:15:00',1.15),('15087','2013-09-01','08:20:00',1.24),('15087','2013-09-01','08:25:00',1.31),('15087','2013-09-01','08:30:00',1.33),('15087','2013-09-01','08:35:00',1.5),('15087','2013-09-01','08:40:00',1.61),('15087','2013-09-01','08:45:00',1.68),('15087','2013-09-01','08:50:00',1.77),('15087','2013-09-01','08:55:00',1.88),('15087','2013-09-01','09:00:00',1.95),('15087','2013-09-01','09:05:00',2.08),('15087','2013-09-01','09:10:00',2.22),('15087','2013-09-01','09:15:00',2.31),('15087','2013-09-01','09:20:00',2.39),('15087','2013-09-01','09:25:00',2.48),('15087','2013-09-01','09:30:00',2.56),('15087','2013-09-01','09:35:00',2.64),('15087','2013-09-01','09:40:00',2.72),('15087','2013-09-01','09:45:00',2.78),('15087','2013-09-01','09:50:00',2.86),('15087','2013-09-01','09:55:00',2.92),('15087','2013-09-01','10:00:00',2.98),('15087','2013-09-01','10:05:00',3.04),('15087','2013-09-01','10:10:00',3.12),('15087','2013-09-01','10:15:00',3.17),('15087','2013-09-01','10:20:00',3.21),('15087','2013-09-01','10:25:00',3.29),('15087','2013-09-01','10:30:00',3.35),('15087','2013-09-01','10:35:00',3.41),('15087','2013-09-01','10:40:00',3.46),('15087','2013-09-01','10:45:00',3.48),('15087','2013-09-01','10:50:00',3.54),('15087','2013-09-01','10:55:00',3.61),('15087','2013-09-01','11:00:00',3.67),('15087','2013-09-01','11:05:00',3.72),('15087','2013-09-01','11:10:00',3.75),('15087','2013-09-01','11:15:00',3.77),('15087','2013-09-01','11:20:00',3.77),('15087','2013-09-01','11:25:00',3.83),('15087','2013-09-01','11:30:00',3.84),('15087','2013-09-01','11:35:00',3.87),('15087','2013-09-01','11:40:00',3.92),('15087','2013-09-01','11:45:00',3.96),('15087','2013-09-01','11:50:00',4.02),('15087','2013-09-01','11:55:00',4),('15087','2013-09-01','12:00:00',4.02),('15087','2013-09-01','12:05:00',3.98),('15087','2013-09-01','12:10:00',4.04),('15087','2013-09-01','12:15:00',4.07),('15087','2013-09-01','12:20:00',4.11),('15087','2013-09-01','12:25:00',3.99),('15087','2013-09-01','12:30:00',4.14),('15087','2013-09-01','12:35:00',4.16),('15087','2013-09-01','12:40:00',4.17),('15087','2013-09-01','12:45:00',4.12),('15087','2013-09-01','12:50:00',4.14),('15087','2013-09-01','12:55:00',4.14),('15087','2013-09-01','13:00:00',4.23),('15087','2013-09-01','13:05:00',4.2),('15087','2013-09-01','13:10:00',4.23),('15087','2013-09-01','13:15:00',3.94),('15087','2013-09-01','13:20:00',4.23),('15087','2013-09-01','13:25:00',4.2),('15087','2013-09-01','13:30:00',4.26),('15087','2013-09-01','13:35:00',4.18),('15087','2013-09-01','13:40:00',4.18),('15087','2013-09-01','13:45:00',3.93),('15087','2013-09-01','13:50:00',3.48),('15087','2013-09-01','13:55:00',3.5),('15087','2013-09-01','14:00:00',3.1),('15087','2013-09-01','14:05:00',3.22),('15087','2013-09-01','14:10:00',3.68),('15087','2013-09-01','14:15:00',3.61),('15087','2013-09-01','14:20:00',3.24),('15087','2013-09-01','14:25:00',3.25),('15087','2013-09-01','14:30:00',3.36),('15087','2013-09-01','14:35:00',3.34),('15087','2013-09-01','14:40:00',3.35),('15087','2013-09-01','14:45:00',3.37),('15087','2013-09-01','14:50:00',3.34),('15087','2013-09-01','14:55:00',3.1),('15087','2013-09-01','15:00:00',3.06),('15087','2013-09-01','15:05:00',3.17),('15087','2013-09-01','15:10:00',3.19),('15087','2013-09-01','15:15:00',3.03),('15087','2013-09-01','15:20:00',2.95),('15087','2013-09-01','15:25:00',2.5),('15087','2013-09-01','15:30:00',2.19),('15087','2013-09-01','15:35:00',2.36),('15087','2013-09-01','15:40:00',2.81),('15087','2013-09-01','15:45:00',2.58),('15087','2013-09-01','15:50:00',1.9),('15087','2013-09-01','15:55:00',2.11),('15087','2013-09-01','16:00:00',2.63),('15087','2013-09-01','16:05:00',2.75),('15087','2013-09-01','16:10:00',2.66),('15087','2013-09-01','16:15:00',2.57),('15087','2013-09-01','16:20:00',2.36),('15087','2013-09-01','16:25:00',2.39),('15087','2013-09-01','16:30:00',2.49),('15087','2013-09-01','16:35:00',2.47),('15087','2013-09-01','16:40:00',2.32),('15087','2013-09-01','16:45:00',2.11),('15087','2013-09-01','16:50:00',2.03),('15087','2013-09-01','16:55:00',1.77),('15087','2013-09-01','17:00:00',1.47),('15087','2013-09-01','17:05:00',1.55),('15087','2013-09-01','17:10:00',1.29),('15087','2013-09-01','17:15:00',1.35),('15087','2013-09-01','17:20:00',1.43),('15087','2013-09-01','17:25:00',1.36),('15087','2013-09-01','17:30:00',1.21),('15087','2013-09-01','17:35:00',1.21),('15087','2013-09-01','17:40:00',1.25),('15087','2013-09-01','17:45:00',1.06),('15087','2013-08-31','08:20:00',1),('15087','2013-08-31','08:25:00',1.21),('15087','2013-08-31','08:30:00',1.44),('15087','2013-08-31','08:35:00',1.5),('15087','2013-08-31','08:40:00',1.65),('15087','2013-08-31','08:45:00',1.83),('15087','2013-08-31','08:50:00',2.03),('15087','2013-08-31','08:55:00',2.22),('15087','2013-08-31','09:00:00',2.33),('15087','2013-08-31','09:05:00',2.07),('15087','2013-08-31','09:10:00',1.64),('15087','2013-08-31','09:15:00',2.17),('15087','2013-08-31','09:20:00',2.41),('15087','2013-08-31','09:25:00',2.64),('15087','2013-08-31','09:30:00',2.7),('15087','2013-08-31','09:35:00',2.82),('15087','2013-08-31','09:40:00',2.85),('15087','2013-08-31','09:45:00',2.72),('15087','2013-08-31','09:50:00',2.74),('15087','2013-08-31','09:55:00',2.96),('15087','2013-08-31','10:00:00',3.14),('15087','2013-08-31','10:05:00',3.08),('15087','2013-08-31','10:10:00',3.26),('15087','2013-08-31','10:15:00',3.29),('15087','2013-08-31','10:20:00',3.32),('15087','2013-08-31','10:25:00',3.37),('15087','2013-08-31','10:30:00',3.47),('15087','2013-08-31','10:35:00',3.57),('15087','2013-08-31','10:40:00',3.58),('15087','2013-08-31','10:45:00',3.63),('15087','2013-08-31','10:50:00',3.74),('15087','2013-08-31','10:55:00',3.75),('15087','2013-08-31','11:00:00',3.86),('15087','2013-08-31','11:05:00',3.9),('15087','2013-08-31','11:10:00',3.93),('15087','2013-08-31','11:15:00',3.99),('15087','2013-08-31','11:20:00',4.03),('15087','2013-08-31','11:25:00',4.06),('15087','2013-08-31','11:30:00',4.08),('15087','2013-08-31','11:35:00',4.14),('15087','2013-08-31','11:40:00',4.19),('15087','2013-08-31','11:45:00',4.22),('15087','2013-08-31','11:50:00',4.26),('15087','2013-08-31','11:55:00',4.29),('15087','2013-08-31','12:00:00',4.07),('15087','2013-08-31','12:05:00',3.62),('15087','2013-08-31','12:10:00',3.46),('15087','2013-08-31','12:15:00',4.03),('15087','2013-08-31','12:20:00',4.28),('15087','2013-08-31','12:25:00',4.22),('15087','2013-08-31','12:30:00',4.27),('15087','2013-08-31','12:35:00',4.32),('15087','2013-08-31','12:40:00',4.26),('15087','2013-08-31','12:45:00',4.29),('15087','2013-08-31','12:50:00',4.29),('15087','2013-08-31','12:55:00',4.31),('15087','2013-08-31','13:00:00',4.3),('15087','2013-08-31','13:05:00',4.32),('15087','2013-08-31','13:10:00',4.26),('15087','2013-08-31','13:15:00',4.31),('15087','2013-08-31','13:20:00',4.28),('15087','2013-08-31','13:25:00',4.26),('15087','2013-08-31','13:30:00',4.31),('15087','2013-08-31','13:35:00',4.24),('15087','2013-08-31','13:40:00',4.25),('15087','2013-08-31','13:45:00',4.2),('15087','2013-08-31','13:50:00',4.25),('15087','2013-08-31','13:55:00',4.1),('15087','2013-08-31','14:00:00',4.1),('15087','2013-08-31','14:05:00',4.1),('15087','2013-08-31','14:10:00',4.05),('15087','2013-08-31','14:15:00',3.97),('15087','2013-08-31','14:20:00',3.93),('15087','2013-08-31','14:25:00',3.89),('15087','2013-08-31','14:30:00',3.84),('15087','2013-08-31','14:35:00',3.58),('15087','2013-08-31','14:40:00',3.66),('15087','2013-08-31','14:45:00',3.67),('15087','2013-08-31','14:50:00',3.65),('15087','2013-08-31','14:55:00',3.4),('15087','2013-08-31','15:00:00',3.43),('15087','2013-08-31','15:05:00',3.42),('15087','2013-08-31','15:10:00',3.4),('15087','2013-08-31','15:15:00',3.26),('15087','2013-08-31','15:20:00',3.13),('15087','2013-08-31','15:25:00',2.99),('15087','2013-08-31','15:30:00',3.1),('15087','2013-08-31','15:35:00',2.98),('15087','2013-08-31','15:40:00',2.97),('15087','2013-08-31','15:45:00',2.93),('15087','2013-08-31','15:50:00',2.89),('15087','2013-08-31','15:55:00',2.82),('15087','2013-08-31','16:00:00',2.77),('15087','2013-08-31','16:05:00',2.72),('15087','2013-08-31','16:10:00',2.68),('15087','2013-08-31','16:15:00',2.59),('15087','2013-08-31','16:20:00',2.43),('15087','2013-08-31','16:25:00',2.32),('15087','2013-08-31','16:30:00',2.43),('15087','2013-08-31','16:35:00',2.36),('15087','2013-08-31','16:40:00',2.24),('15087','2013-08-31','16:45:00',2.14),('15087','2013-08-31','16:50:00',2.04),('15087','2013-08-31','16:55:00',1.95),('15087','2013-08-31','17:00:00',1.85),('15087','2013-08-31','17:05:00',1.82),('15087','2013-08-31','17:10:00',1.67),('15087','2013-08-31','17:15:00',1.59),('15087','2013-08-31','17:20:00',1.49),('15087','2013-08-31','17:25:00',1.41),('15087','2013-08-31','17:30:00',1.33),('15087','2013-08-31','17:35:00',1.2),('15087','2013-08-31','17:40:00',1.16),('15087','2013-08-31','17:45:00',1.06),('15087','2013-08-30','08:05:00',1.12),('15087','2013-08-30','08:10:00',1.27),('15087','2013-08-30','08:15:00',1.23),('15087','2013-08-30','08:20:00',1.32),('15087','2013-08-30','08:25:00',1.36),('15087','2013-08-30','08:30:00',1.42),('15087','2013-08-30','08:35:00',1.52),('15087','2013-08-30','08:40:00',1.54),('15087','2013-08-30','08:45:00',1.38),('15087','2013-08-30','08:50:00',1.26),('15087','2013-08-30','08:55:00',1.27),('15087','2013-08-30','09:00:00',1.48),('15087','2013-08-30','09:05:00',1.66),('15087','2013-08-30','09:10:00',1.45),('15087','2013-08-30','09:15:00',1.33),('15087','2013-08-30','09:20:00',1.19),('15087','2013-08-30','09:25:00',1.29),('15087','2013-08-30','09:30:00',1.68),('15087','2013-08-30','09:35:00',1.95),('15087','2013-08-30','09:40:00',1.86),('15087','2013-08-30','09:45:00',1.9),('15087','2013-08-30','09:50:00',1.91),('15087','2013-08-30','09:55:00',2.03),('15087','2013-08-30','10:00:00',2.08),('15087','2013-08-30','10:05:00',2.07),('15087','2013-08-30','10:10:00',2.06),('15087','2013-08-30','10:15:00',2.22),('15087','2013-08-30','10:20:00',2.28),('15087','2013-08-30','10:25:00',2.14),('15087','2013-08-30','10:30:00',2.36),('15087','2013-08-30','10:35:00',2.27),('15087','2013-08-30','10:40:00',2.13),('15087','2013-08-30','10:45:00',2.09),('15087','2013-08-30','10:50:00',2.25),('15087','2013-08-30','10:55:00',2.12),('15087','2013-08-30','11:00:00',2.24),('15087','2013-08-30','11:05:00',2.37),('15087','2013-08-30','11:10:00',2.5),('15087','2013-08-30','11:15:00',2.52),('15087','2013-08-30','11:20:00',2.54),('15087','2013-08-30','11:25:00',2.62),('15087','2013-08-30','11:30:00',2.78),('15087','2013-08-30','11:35:00',2.63),('15087','2013-08-30','11:40:00',2.87),('15087','2013-08-30','11:45:00',2.85),('15087','2013-08-30','11:50:00',3.25),('15087','2013-08-30','11:55:00',2.83),('15087','2013-08-30','12:00:00',2.55),('15087','2013-08-30','12:05:00',2.2),('15087','2013-08-30','12:10:00',2.41),('15087','2013-08-30','12:15:00',2.65),('15087','2013-08-30','12:20:00',2.83),('15087','2013-08-30','12:25:00',3.22),('15087','2013-08-30','12:30:00',3.55),('15087','2013-08-30','12:35:00',3.35),('15087','2013-08-30','12:40:00',3.27),('15087','2013-08-30','12:45:00',3.41),('15087','2013-08-30','12:50:00',3.31),('15087','2013-08-30','12:55:00',3.08),('15087','2013-08-30','13:00:00',3.05),('15087','2013-08-30','13:05:00',3),('15087','2013-08-30','13:10:00',3.06),('15087','2013-08-30','13:15:00',2.94),('15087','2013-08-30','13:20:00',3.54),('15087','2013-08-30','13:25:00',3.96),('15087','2013-08-30','13:30:00',4.27),('15087','2013-08-30','13:35:00',3.98),('15087','2013-08-30','13:40:00',4.21),('15087','2013-08-30','13:45:00',3.8),('15087','2013-08-30','13:50:00',3.79),('15087','2013-08-30','13:55:00',4.02),('15087','2013-08-30','14:00:00',4.18),('15087','2013-08-30','14:05:00',3.91),('15087','2013-08-30','14:10:00',4.06),('15087','2013-08-30','14:15:00',3.9),('15087','2013-08-30','14:20:00',3.99),('15087','2013-08-30','14:25:00',3.98),('15087','2013-08-30','14:30:00',3.98),('15087','2013-08-30','14:35:00',3.95),('15087','2013-08-30','14:40:00',3.79),('15087','2013-08-30','14:45:00',3),('15087','2013-08-30','14:50:00',2.64),('15087','2013-08-30','14:55:00',3.02),('15087','2013-08-30','15:00:00',2.56),('15087','2013-08-30','15:05:00',2.41),('15087','2013-08-30','15:10:00',2.42),('15087','2013-08-30','15:15:00',2.98),('15087','2013-08-30','15:20:00',2.53),('15087','2013-08-30','15:25:00',2.31),('15087','2013-08-30','15:30:00',2.19),('15087','2013-08-30','15:35:00',1.76),('15087','2013-08-30','15:40:00',1.93),('15087','2013-08-30','15:45:00',2.33),('15087','2013-08-30','15:50:00',2.47),('15087','2013-08-30','15:55:00',2.4),('15087','2013-08-30','16:00:00',2.29),('15087','2013-08-30','16:05:00',1.98),('15087','2013-08-30','16:10:00',1.6),('15087','2013-08-30','16:15:00',1.47),('15087','2013-08-30','16:20:00',1.69),('15087','2013-08-30','16:25:00',1.62),('15087','2013-08-30','16:30:00',1.83),('15087','2013-08-30','16:35:00',1.45),('15087','2013-08-30','16:40:00',1.98),('15087','2013-08-30','16:45:00',2.36),('15087','2013-08-30','16:50:00',2.12),('15087','2013-08-30','16:55:00',1.52),('15087','2013-08-30','17:00:00',1.83),('15087','2013-08-30','17:05:00',1.33),('15087','2013-08-30','17:10:00',1.5),('15087','2013-08-30','17:15:00',1.34),('15087','2013-08-30','17:20:00',1.17),('15087','2013-08-30','17:25:00',1.23),('15087','2013-08-30','17:30:00',1.27),('15087','2013-08-30','17:35:00',1.47),('15087','2013-08-30','17:40:00',1.07),('15087','2013-08-30','17:45:00',1.28),('15087','2013-08-30','17:50:00',1.1),('15087','2013-08-30','17:55:00',1.04),('15087','2014-04-11','08:35:00',1.86),('15087','2014-04-11','08:40:00',1.98),('15087','2014-04-11','08:45:00',2.08),('15087','2014-04-11','08:50:00',2.1),('15087','2014-04-11','08:55:00',2.14),('15087','2014-04-11','09:00:00',2.15),('15087','2014-04-11','09:05:00',2.24),('15087','2014-04-11','09:10:00',2.34),('15087','2014-04-11','09:15:00',2.44),('15087','2014-04-11','09:20:00',2.52),('15087','2014-04-11','09:25:00',2.61),('15087','2014-04-11','09:30:00',2.68),('15087','2014-04-11','09:35:00',2.77),('15087','2014-04-11','09:40:00',2.87),('15087','2014-04-11','09:45:00',2.93),('15087','2014-04-11','09:50:00',3.02),('15087','2014-04-11','09:55:00',3.12),('15087','2014-04-11','10:00:00',3.19),('15087','2014-04-11','10:05:00',3.25),('15087','2014-04-11','10:10:00',3.36),('15087','2014-04-11','10:15:00',3.43),('15087','2014-04-11','10:20:00',3.51),('15087','2014-04-11','10:25:00',3.58),('15087','2014-04-11','10:30:00',3.62),('15087','2014-04-11','10:35:00',3.67),('15087','2014-04-11','10:40:00',3.73),('15087','2014-04-11','10:45:00',3.83),('15087','2014-04-11','10:50:00',3.9),('15087','2014-04-11','10:55:00',3.94),('15087','2014-04-11','11:00:00',4),('15087','2014-04-11','11:05:00',4.04),('15087','2014-04-11','11:10:00',4.05),('15087','2014-04-11','11:15:00',4.13),('15087','2014-04-11','11:20:00',4.21),('15087','2014-04-11','11:25:00',4.26),('15087','2014-04-11','11:30:00',4.3),('15087','2014-04-11','11:35:00',4.36),('15087','2014-04-11','11:40:00',4.34),('15087','2014-04-11','11:45:00',4.43),('15087','2014-04-11','11:50:00',4.5),('15087','2014-04-11','11:55:00',4.68),('15087','2014-04-11','12:00:00',4.71),('15087','2014-04-11','12:05:00',4.63),('15087','2014-04-11','12:10:00',4.76),('15087','2014-04-11','12:15:00',4.06),('15087','2014-04-11','12:20:00',4.56),('15087','2014-04-11','12:25:00',4.73),('15087','2014-04-11','12:30:00',4.81),('15087','2014-04-11','12:35:00',4.85),('15087','2014-04-11','12:40:00',4.83),('15087','2014-04-11','12:45:00',4.44),('15087','2014-04-11','12:50:00',5.12),('15087','2014-04-11','12:55:00',4.9),('15087','2014-04-11','13:00:00',3.64),('15087','2014-04-11','13:05:00',4.54),('15087','2014-04-11','13:10:00',3.32),('15087','2014-04-11','13:15:00',3.93),('15087','2014-04-11','13:20:00',3.67),('15087','2014-04-11','13:25:00',3.8),('15087','2014-04-11','13:30:00',2.55),('15087','2014-04-11','13:35:00',3.82),('15087','2014-04-11','13:40:00',2.64),('15087','2014-04-11','13:45:00',4.77),('15087','2014-04-11','13:50:00',3.23),('15087','2014-04-11','13:55:00',4.57),('15087','2014-04-11','14:00:00',2.82),('15087','2014-04-11','14:05:00',4.81),('15087','2014-04-11','14:10:00',2.01),('15087','2014-04-11','14:15:00',2.82),('15087','2014-04-11','14:20:00',3.23),('15087','2014-04-11','14:25:00',3.18),('15087','2014-04-11','14:30:00',4.68),('15087','2014-04-11','14:35:00',4.5),('15087','2014-04-11','14:40:00',2.43),('15087','2014-04-11','14:45:00',3.46),('15087','2014-04-11','14:50:00',4.07),('15087','2014-04-11','14:55:00',3.53),('15087','2014-04-11','15:00:00',4.64),('15087','2014-04-11','15:05:00',3.84),('15087','2014-04-11','15:10:00',4.02),('15087','2014-04-11','15:15:00',3.53),('15087','2014-04-11','15:20:00',3.65),('15087','2014-04-11','15:25:00',3.6),('15087','2014-04-11','15:30:00',3.64),('15087','2014-04-11','15:35:00',1.83),('15087','2014-04-11','15:40:00',3.47),('15087','2014-04-11','15:45:00',3.33),('15087','2014-04-11','15:50:00',3.04),('15087','2014-04-11','15:55:00',3.18),('15087','2014-04-11','16:00:00',3),('15087','2014-04-11','16:05:00',2.97),('15087','2014-04-11','16:10:00',2.37),('15087','2014-04-11','16:15:00',2.81),('15087','2014-04-11','16:20:00',2.85),('15087','2014-04-11','16:25:00',2.78),('15087','2014-04-11','16:30:00',2.71),('15087','2014-04-11','16:35:00',2.19),('15087','2014-04-11','16:40:00',2.52),('15087','2014-04-11','16:45:00',2.29),('15087','2014-04-11','16:50:00',1.51),('15087','2014-04-11','16:55:00',1.88),('15087','2014-04-11','17:00:00',2.1),('15087','2014-04-11','17:05:00',2.03),('15087','2014-04-11','17:10:00',2.02),('15087','2014-04-11','17:15:00',1.84),('15087','2014-04-11','17:20:00',1.84),('15087','2014-04-11','17:25:00',1.67),('15087','2014-04-11','17:30:00',1.69),('15087','2014-04-11','17:35:00',1.64),('15087','2014-04-11','17:40:00',1.55),('15087','2014-04-11','17:45:00',1.32),('15087','2014-04-11','17:50:00',1.16),('15087','2014-04-11','17:55:00',1.04),('15087','2013-08-29','08:05:00',1.05),('15087','2013-08-29','08:10:00',1.15),('15087','2013-08-29','08:15:00',1.3),('15087','2013-08-29','08:20:00',1.46),('15087','2013-08-29','08:25:00',1.65),('15087','2013-08-29','08:30:00',1.93),('15087','2013-08-29','08:35:00',1.86),('15087','2013-08-29','08:40:00',1.38),('15087','2013-08-29','08:45:00',1.09),('15087','2013-08-29','08:50:00',1.3),('15087','2013-08-29','08:55:00',1.73),('15087','2013-08-29','09:00:00',1.65),('15087','2013-08-29','09:05:00',1.61),('15087','2013-08-29','09:10:00',1.58),('15087','2013-08-29','09:15:00',1.73),('15087','2013-08-29','09:20:00',1.67),('15087','2013-08-29','09:25:00',1.52),('15087','2013-08-29','09:30:00',1.58),('15087','2013-08-29','09:35:00',1.76),('15087','2013-08-29','09:40:00',1.77),('15087','2013-08-29','09:45:00',1.55),('15087','2013-08-29','09:50:00',1.5),('15087','2013-08-29','09:55:00',1.56),('15087','2013-08-29','10:00:00',1.66),('15087','2013-08-29','10:05:00',1.58),('15087','2013-08-29','10:10:00',1.57),('15087','2013-08-29','10:15:00',1.55),('15087','2013-08-29','10:20:00',1.57),('15087','2013-08-29','10:25:00',1.58),('15087','2013-08-29','10:30:00',1.61),('15087','2013-08-29','10:35:00',1.52),('15087','2013-08-29','10:40:00',1.39),('15087','2013-08-29','10:45:00',1.29),('15087','2013-08-29','10:50:00',1.29),('15087','2013-08-29','10:55:00',1.44),('15087','2013-08-29','11:00:00',1.54),('15087','2013-08-29','11:05:00',1.57),('15087','2013-08-29','11:10:00',2.42),('15087','2013-08-29','11:15:00',2.71),('15087','2013-08-29','11:20:00',2.54),('15087','2013-08-29','11:25:00',1.91),('15087','2013-08-29','11:30:00',1.59),('15087','2013-08-29','11:35:00',1.43),('15087','2013-08-29','11:40:00',1.64),('15087','2013-08-29','11:45:00',1.94),('15087','2013-08-29','11:50:00',2.05),('15087','2013-08-29','11:55:00',1.91),('15087','2013-08-29','12:00:00',1.93),('15087','2013-08-29','12:05:00',2.28),('15087','2013-08-29','12:10:00',2.76),('15087','2013-08-29','12:15:00',3.15),('15087','2013-08-29','12:20:00',2.83),('15087','2013-08-29','12:25:00',2.87),('15087','2013-08-29','12:30:00',2.9),('15087','2013-08-29','12:35:00',3.52),('15087','2013-08-29','12:40:00',4.89),('15087','2013-08-29','12:45:00',4.63),('15087','2013-08-29','12:50:00',2.69),('15087','2013-08-29','12:55:00',4.12),('15087','2013-08-29','13:00:00',2.93),('15087','2013-08-29','13:05:00',2.8),('15087','2013-08-29','13:10:00',2.7),('15087','2013-08-29','13:15:00',2.6),('15087','2013-08-29','13:20:00',2.51),('15087','2013-08-29','13:25:00',2.16),('15087','2013-08-29','13:30:00',1.94),('15087','2013-08-29','13:35:00',1.78),('15087','2013-08-29','13:40:00',1.71),('15087','2013-08-29','13:45:00',1.6),('15087','2013-08-29','13:50:00',1.58),('15087','2013-08-29','13:55:00',1.87),('15087','2013-08-29','14:00:00',2.48),('15087','2013-08-29','14:05:00',1.73),('15087','2013-08-29','14:10:00',1.56),('15087','2013-08-29','14:15:00',1.29),('15087','2013-08-29','14:20:00',1.04),('15087','2013-08-29','14:45:00',1.04),('15087','2013-08-29','14:50:00',1.22),('15087','2013-08-29','14:55:00',1.41),('15087','2013-08-29','15:00:00',1.57),('15087','2013-08-29','15:05:00',1.78),('15087','2013-08-29','15:10:00',1.38),('15087','2013-08-29','15:15:00',1.2),('15087','2013-08-29','15:20:00',1.33),('15087','2013-08-29','15:25:00',1.53),('15087','2013-08-29','15:30:00',2.6),('15087','2013-08-29','15:35:00',2.35),('15087','2013-08-29','15:40:00',2.28),('15087','2013-08-29','15:45:00',2.47),('15087','2013-08-29','15:50:00',3),('15087','2013-08-29','15:55:00',3.33),('15087','2013-08-29','16:00:00',3.03),('15087','2013-08-29','16:05:00',3.19),('15087','2013-08-29','16:10:00',2.9),('15087','2013-08-29','16:15:00',2.91),('15087','2013-08-29','16:20:00',2.65),('15087','2013-08-29','16:25:00',2.51),('15087','2013-08-29','16:30:00',2.56),('15087','2013-08-29','16:35:00',2.47),('15087','2013-08-29','16:40:00',2.22),('15087','2013-08-29','16:45:00',2.31),('15087','2013-08-29','16:50:00',2.27),('15087','2013-08-29','16:55:00',2.19),('15087','2013-08-29','17:00:00',2.14),('15087','2013-08-29','17:05:00',2.05),('15087','2013-08-29','17:10:00',1.9),('15087','2013-08-29','17:15:00',1.76),('15087','2013-08-29','17:20:00',1.64),('15087','2013-08-29','17:25:00',1.49),('15087','2013-08-29','17:30:00',1.44),('15087','2013-08-29','17:35:00',1.37),('15087','2013-08-29','17:40:00',1.24),('15087','2013-08-29','17:45:00',1.16),('15087','2013-08-29','17:50:00',1),('15087','2013-08-28','08:05:00',1.05),('15087','2013-08-28','08:10:00',1.13),('15087','2013-08-28','08:15:00',1.21),('15087','2013-08-28','08:20:00',1.3),('15087','2013-08-28','08:25:00',1.31),('15087','2013-08-28','08:30:00',1.47),('15087','2013-08-28','08:35:00',1.63),('15087','2013-08-28','08:40:00',1.61),('15087','2013-08-28','08:45:00',1.29),('15087','2013-08-28','08:50:00',1.28),('15087','2013-08-28','08:55:00',1.09),('15087','2013-08-28','09:00:00',1.81),('15087','2013-08-28','09:10:00',1.19),('15087','2013-08-28','09:15:00',1.95),('15087','2013-08-28','09:20:00',1.14),('15087','2013-08-28','09:30:00',1.26),('15087','2013-08-28','09:35:00',2.32),('15087','2013-08-28','09:40:00',2.72),('15087','2013-08-28','09:45:00',2.84),('15087','2013-08-28','09:50:00',2.95),('15087','2013-08-28','09:55:00',2.97),('15087','2013-08-28','10:00:00',2.99),('15087','2013-08-28','10:05:00',3.08),('15087','2013-08-28','10:10:00',3.2),('15087','2013-08-28','10:15:00',3.36),('15087','2013-08-28','10:20:00',2.48),('15087','2013-08-28','10:25:00',1.22),('15087','2013-08-28','10:30:00',3.03),('15087','2013-08-28','10:35:00',1.89),('15087','2013-08-28','10:40:00',2.52),('15087','2013-08-28','10:45:00',3.86),('15087','2013-08-28','10:50:00',3.28),('15087','2013-08-28','10:55:00',3.74),('15087','2013-08-28','11:00:00',1.78),('15087','2013-08-28','11:05:00',3.51),('15087','2013-08-28','11:10:00',2.35),('15087','2013-08-28','11:15:00',4.21),('15087','2013-08-28','11:20:00',4.23),('15087','2013-08-28','11:25:00',4.33),('15087','2013-08-28','11:30:00',4.4),('15087','2013-08-28','11:35:00',4.41),('15087','2013-08-28','11:40:00',4.51),('15087','2013-08-28','11:45:00',3.18),('15087','2013-08-28','11:50:00',3.41),('15087','2013-08-28','11:55:00',1.92),('15087','2013-08-28','12:00:00',3.38),('15087','2013-08-28','12:05:00',3.38),('15087','2013-08-28','12:10:00',4.63),('15087','2013-08-28','12:15:00',4.54),('15087','2013-08-28','12:20:00',4.31),('15087','2013-08-28','12:25:00',4.48),('15087','2013-08-28','12:30:00',4.43),('15087','2013-08-28','12:35:00',4.44),('15087','2013-08-28','12:40:00',4.49),('15087','2013-08-28','12:45:00',4.63),('15087','2013-08-28','12:50:00',4.55),('15087','2013-08-28','12:55:00',4.52),('15087','2013-08-28','13:00:00',4.63),('15087','2013-08-28','13:05:00',4.23),('15087','2013-08-28','13:10:00',4.67),('15087','2013-08-28','13:15:00',4.58),('15087','2013-08-28','13:20:00',4.54),('15087','2013-08-28','13:25:00',4.57),('15087','2013-08-28','13:30:00',4.46),('15087','2013-08-28','13:35:00',4.56),('15087','2013-08-28','13:40:00',3.59),('15087','2013-08-28','13:45:00',3.4),('15087','2013-08-28','13:50:00',4.63),('15087','2013-08-28','13:55:00',3.58),('15087','2013-08-28','14:00:00',4.4),('15087','2013-08-28','14:05:00',4.35),('15087','2013-08-28','14:10:00',4.37),('15087','2013-08-28','14:15:00',4.26),('15087','2013-08-28','14:20:00',4.22),('15087','2013-08-28','14:25:00',4.2),('15087','2013-08-28','14:30:00',3.27),('15087','2013-08-28','14:35:00',3.27),('15087','2013-08-28','14:40:00',4.05),('15087','2013-08-28','14:45:00',3.85),('15087','2013-08-28','14:50:00',3.96),('15087','2013-08-28','14:55:00',3.89),('15087','2013-08-28','15:00:00',3.68),('15087','2013-08-28','15:05:00',3.74),('15087','2013-08-28','15:10:00',3.8),('15087','2013-08-28','15:15:00',3.69),('15087','2013-08-28','15:20:00',3.48),('15087','2013-08-28','15:25:00',2.22),('15087','2013-08-28','15:30:00',2.9),('15087','2013-08-28','15:35:00',2.62),('15087','2013-08-28','15:45:00',1.96),('15087','2013-08-28','15:50:00',1.63),('15087','2013-08-28','15:55:00',3.09),('15087','2013-08-28','16:00:00',3.3),('15087','2013-08-28','16:05:00',2.96),('15087','2013-08-28','16:10:00',1.8),('15087','2013-08-28','16:15:00',2.1),('15087','2013-08-28','16:20:00',2.35),('15087','2013-08-28','16:25:00',2.87),('15087','2013-08-28','16:30:00',2.69),('15087','2013-08-28','16:35:00',2.64),('15087','2013-08-28','16:40:00',2.53),('15087','2013-08-28','16:45:00',2.33),('15087','2013-08-28','16:50:00',2.23),('15087','2013-08-28','16:55:00',2.26),('15087','2013-08-28','17:00:00',2.2),('15087','2013-08-28','17:05:00',2.08),('15087','2013-08-28','17:10:00',1.55),('15087','2013-08-28','17:15:00',1.66),('15087','2013-08-28','17:20:00',1.12),('15087','2013-08-28','17:25:00',1.44),('15087','2013-08-28','17:35:00',1.46),('15087','2013-08-28','17:40:00',1.37),('15087','2013-08-28','17:55:00',1.11),('15087','2013-08-27','08:20:00',1.17),('15087','2013-08-27','08:25:00',1.52),('15087','2013-08-27','08:30:00',1.51),('15087','2013-08-27','08:35:00',1.05),('15087','2013-08-27','08:40:00',1.02),('15087','2013-08-27','08:45:00',1.19),('15087','2013-08-27','09:05:00',1.05),('15087','2013-08-27','09:10:00',1.32),('15087','2013-08-27','09:15:00',1.36),('15087','2013-08-27','09:20:00',1.65),('15087','2013-08-27','09:25:00',2.18),('15087','2013-08-27','09:30:00',2.4),('15087','2013-08-27','09:35:00',1.3),('15087','2013-08-27','09:40:00',1.03),('15087','2013-08-27','09:45:00',1.08),('15087','2013-08-27','09:50:00',1.14),('15087','2013-08-27','09:55:00',1.51),('15087','2013-08-27','10:00:00',2.04),('15087','2013-08-27','10:05:00',2.47),('15087','2013-08-27','10:10:00',3.06),('15087','2013-08-27','10:15:00',3.1),('15087','2013-08-27','10:20:00',3.24),('15087','2013-08-27','10:25:00',3.3),('15087','2013-08-27','10:30:00',3.33),('15087','2013-08-27','10:35:00',3.36),('15087','2013-08-27','10:40:00',3.35),('15087','2013-08-27','10:45:00',3.46),('15087','2013-08-27','10:50:00',3.49),('15087','2013-08-27','10:55:00',3.53),('15087','2013-08-27','11:00:00',3.61),('15087','2013-08-27','11:05:00',3.71),('15087','2013-08-27','11:10:00',3.72),('15087','2013-08-27','11:15:00',3.75),('15087','2013-08-27','11:20:00',3.7),('15087','2013-08-27','11:25:00',3.62),('15087','2013-08-27','11:30:00',3.73),('15087','2013-08-27','11:35:00',3.72),('15087','2013-08-27','11:40:00',3.56),('15087','2013-08-27','11:45:00',4.47),('15087','2013-08-27','11:50:00',3.19),('15087','2013-08-27','11:55:00',4.29),('15087','2013-08-27','12:00:00',4.44),('15087','2013-08-27','12:05:00',3.94),('15087','2013-08-27','12:10:00',3.35),('15087','2013-08-27','12:15:00',4.17),('15087','2013-08-27','12:20:00',4.06),('15087','2013-08-27','12:25:00',4.08),('15087','2013-08-27','12:30:00',3.53),('15087','2013-08-27','12:35:00',4.72),('15087','2013-08-27','12:40:00',4.18),('15087','2013-08-27','12:45:00',3.13),('15087','2013-08-27','12:50:00',2.06),('15087','2013-08-27','12:55:00',1.72),('15087','2013-08-27','13:00:00',1.29),('15087','2013-08-27','13:05:00',1.71),('15087','2013-08-27','13:10:00',1.95),('15087','2013-08-27','13:15:00',1.84),('15087','2013-08-27','13:20:00',2.25),('15087','2013-08-27','13:25:00',2.39),('15087','2013-08-27','13:30:00',2.65),('15087','2013-08-27','13:35:00',1.97),('15087','2013-08-27','13:40:00',1.86),('15087','2013-08-27','13:45:00',2.75),('15087','2013-08-27','13:50:00',3.92),('15087','2013-08-27','13:55:00',3.07),('15087','2013-08-27','14:00:00',3.91),('15087','2013-08-27','14:05:00',2.03),('15087','2013-08-27','14:10:00',2.58),('15087','2013-08-27','14:15:00',3.43),('15087','2013-08-27','14:20:00',1.95),('15087','2013-08-27','14:25:00',1.27),('15087','2013-08-27','14:30:00',1.24),('15087','2013-08-27','14:35:00',1.1),('15087','2013-08-27','14:40:00',1.24),('15087','2013-08-27','14:45:00',1.27),('15087','2013-08-27','15:55:00',1.4),('15087','2013-08-27','16:00:00',1.48),('15087','2013-08-27','16:05:00',1.89),('15087','2013-08-27','16:10:00',3.58),('15087','2013-08-27','16:15:00',3.26),('15087','2013-08-27','16:20:00',2.26),('15087','2013-08-27','16:25:00',2.26),('15087','2013-08-27','16:35:00',1.17),('15087','2013-08-27','16:40:00',1.65),('15087','2013-08-27','16:45:00',1.89),('15087','2013-08-27','16:50:00',2.28),('15087','2013-08-27','16:55:00',1.91),('15087','2013-08-27','17:05:00',1.21),('15087','2013-08-27','17:10:00',2.55),('15087','2013-08-27','17:15:00',1.31),('15087','2013-08-27','17:45:00',1.17),('15087','2013-08-27','17:50:00',1.29),('15087','2013-08-27','17:55:00',1.34),('15087','2013-08-27','18:00:00',1.04),('15087','2013-08-26','08:05:00',1.41),('15087','2013-08-26','08:10:00',1.26),('15087','2013-08-26','08:20:00',1.54),('15087','2013-08-26','08:25:00',1.32),('15087','2013-08-26','08:30:00',1.59),('15087','2013-08-26','08:35:00',1.34),('15087','2013-08-26','08:40:00',1.61),('15087','2013-08-26','08:45:00',1.73),('15087','2013-08-26','08:50:00',1.81),('15087','2013-08-26','08:55:00',1.91),('15087','2013-08-26','09:00:00',1.98),('15087','2013-08-26','09:05:00',2.09),('15087','2013-08-26','09:10:00',2.15),('15087','2013-08-26','09:15:00',2.3),('15087','2013-08-26','09:20:00',2.41),('15087','2013-08-26','09:25:00',2.49),('15087','2013-08-26','09:30:00',2.56),('15087','2013-08-26','09:35:00',2.65),('15087','2013-08-26','09:40:00',2.74),('15087','2013-08-26','09:45:00',2.81),('15087','2013-08-26','09:50:00',2.85),('15087','2013-08-26','09:55:00',2.88),('15087','2013-08-26','10:00:00',2.95),('15087','2013-08-26','10:05:00',3.02),('15087','2013-08-26','10:10:00',3.09),('15087','2013-08-26','10:15:00',3.12),('15087','2013-08-26','10:20:00',3.26),('15087','2013-08-26','10:25:00',3.31),('15087','2013-08-26','10:30:00',3.35),('15087','2013-08-26','10:35:00',3.41),('15087','2013-08-26','10:40:00',3.49),('15087','2013-08-26','10:45:00',3.57),('15087','2013-08-26','10:50:00',3.59),('15087','2013-08-26','10:55:00',3.61),('15087','2013-08-26','11:00:00',3.68),('15087','2013-08-26','11:05:00',3.69),('15087','2013-08-26','11:10:00',3.76),('15087','2013-08-26','11:15:00',3.82),('15087','2013-08-26','11:20:00',3.83),('15087','2013-08-26','11:25:00',3.84),('15087','2013-08-26','11:30:00',3.92),('15087','2013-08-26','11:35:00',3.96),('15087','2013-08-26','11:40:00',3.97),('15087','2013-08-26','11:45:00',4.01),('15087','2013-08-26','11:50:00',4.06),('15087','2013-08-26','11:55:00',4.07),('15087','2013-08-26','12:00:00',4.07),('15087','2013-08-26','12:05:00',4.11),('15087','2013-08-26','12:10:00',4.12),('15087','2013-08-26','12:15:00',4.13),('15087','2013-08-26','12:20:00',4.1),('15087','2013-08-26','12:25:00',4.12),('15087','2013-08-26','12:30:00',4.13),('15087','2013-08-26','12:35:00',4.15),('15087','2013-08-26','12:40:00',4.21),('15087','2013-08-26','12:45:00',4.22),('15087','2013-08-26','12:50:00',4.22),('15087','2013-08-26','12:55:00',4.27),('15087','2013-08-26','13:00:00',4.39),('15087','2013-08-26','13:05:00',5.01),('15087','2013-08-26','13:10:00',4.1),('15087','2013-08-26','13:15:00',4.03),('15087','2013-08-26','13:20:00',2.9),('15087','2013-08-26','13:25:00',3.18),('15087','2013-08-26','13:30:00',3.07),('15087','2013-08-26','13:35:00',4.01),('15087','2013-08-26','13:40:00',4.18),('15087','2013-08-26','13:45:00',4.24),('15087','2013-08-26','13:50:00',4.12),('15087','2013-08-26','13:55:00',3.09),('15087','2013-08-26','14:00:00',2.85),('15087','2013-08-26','14:05:00',3.61),('15087','2013-08-26','14:10:00',2.79),('15087','2013-08-26','14:15:00',3.97),('15087','2013-08-26','14:20:00',3.98),('15087','2013-08-26','14:25:00',3.84),('15087','2013-08-26','14:30:00',3.84),('15087','2013-08-26','14:35:00',3.68),('15087','2013-08-26','14:40:00',3.31),('15087','2013-08-26','14:45:00',2.4),('15087','2013-08-26','14:50:00',2.12),('15087','2013-08-26','14:55:00',1.97),('15087','2013-08-26','15:00:00',1.87),('15087','2013-08-26','15:05:00',1.35),('15087','2013-08-26','15:10:00',1.06),('15087','2013-08-26','15:35:00',1.01),('15087','2013-08-26','15:40:00',1.6),('15087','2013-08-26','15:45:00',1.71),('15087','2013-08-26','15:50:00',1.72),('15087','2013-08-26','15:55:00',1.58),('15087','2013-08-26','16:00:00',2.5),('15087','2013-08-26','16:05:00',3.2),('15087','2013-08-26','16:10:00',2.76),('15087','2013-08-26','16:15:00',2.68),('15087','2013-08-26','16:20:00',2.55),('15087','2013-08-26','16:25:00',2.38),('15087','2013-08-26','16:30:00',2.46),('15087','2013-08-26','16:35:00',2.42),('15087','2013-08-26','16:40:00',2.35),('15087','2013-08-26','16:45:00',2.23),('15087','2013-08-26','16:50:00',1.97),('15087','2013-08-26','16:55:00',1.91),('15087','2013-08-26','17:00:00',1.93),('15087','2013-08-26','17:05:00',1.74),('15087','2013-08-26','17:10:00',1.77),('15087','2013-08-26','17:15:00',1.69),('15087','2013-08-26','17:20:00',1.22),('15087','2013-08-26','17:30:00',1.22),('15087','2013-08-26','17:40:00',1.01),('15087','2013-08-26','17:45:00',1.18),('15087','2013-08-26','17:50:00',1.33),('15087','2013-08-26','17:55:00',1.24),('15087','2013-08-26','18:00:00',1.08),('15087','2013-08-25','08:05:00',1.02),('15087','2013-08-25','08:10:00',1.23),('15087','2013-08-25','08:15:00',1.19),('15087','2013-08-25','08:20:00',1.14),('15087','2013-08-25','08:25:00',1.19),('15087','2013-08-25','08:35:00',1.01),('15087','2013-08-25','08:40:00',1.36),('15087','2013-08-25','08:45:00',1.35),('15087','2013-08-25','09:15:00',1.07),('15087','2013-08-25','09:20:00',2.37),('15087','2013-08-25','09:25:00',2.38),('15087','2013-08-25','09:30:00',2.15),('15087','2013-08-25','09:40:00',2.98),('15087','2013-08-25','09:45:00',3.6),('15087','2013-08-25','09:50:00',3.1),('15087','2013-08-25','09:55:00',2.93),('15087','2013-08-25','10:00:00',2.4),('15087','2013-08-25','10:05:00',1.47),('15087','2013-08-25','15:10:00',1.05),('15087','2013-08-25','15:15:00',1.23),('15087','2013-08-25','15:20:00',1.5),('15087','2013-08-25','15:25:00',1.63),('15087','2013-08-25','15:30:00',2.28),('15087','2013-08-25','15:35:00',3.44),('15087','2013-08-25','15:40:00',3.46),('15087','2013-08-25','15:45:00',3.62),('15087','2013-08-25','15:50:00',2.23),('15087','2013-08-25','15:55:00',2.72),('15087','2013-08-25','16:00:00',3.34),('15087','2013-08-25','16:05:00',2.97),('15087','2013-08-25','16:10:00',2.75),('15087','2013-08-25','16:15:00',2.74),('15087','2013-08-25','16:20:00',2.58),('15087','2013-08-25','16:25:00',2.66),('15087','2013-08-25','16:30:00',2.67),('15087','2013-08-25','16:35:00',2.56),('15087','2013-08-25','16:40:00',1.76),('15087','2013-08-25','16:45:00',1.15),('15087','2013-08-25','16:50:00',1.83),('15087','2013-08-25','16:55:00',2.51),('15087','2013-08-25','17:00:00',2.36),('15087','2013-08-25','17:05:00',2.22),('15087','2013-08-25','17:10:00',2.08),('15087','2013-08-25','17:15:00',1.9),('15087','2013-08-25','17:20:00',1.76),('15087','2013-08-25','17:25:00',1.6),('15087','2013-08-25','17:30:00',1.49),('15087','2013-08-25','17:35:00',1.24),('15087','2013-08-25','17:40:00',1.13),('15087','2013-08-25','17:45:00',1.31),('15087','2013-08-25','17:50:00',1.14),('15087','2013-08-25','17:55:00',1),('15087','2013-08-24','08:20:00',1.08),('15087','2013-08-24','08:25:00',1.24),('15087','2013-08-24','08:30:00',1.27),('15087','2013-08-24','08:35:00',1.49),('15087','2013-08-24','08:40:00',1.55),('15087','2013-08-24','08:45:00',1.72),('15087','2013-08-24','08:50:00',1.78),('15087','2013-08-24','08:55:00',1.88),('15087','2013-08-24','09:00:00',1.89),('15087','2013-08-24','09:05:00',2.08),('15087','2013-08-24','09:10:00',1.79),('15087','2013-08-24','09:15:00',2.22),('15087','2013-08-24','09:25:00',2.44),('15087','2013-08-24','09:30:00',2.61),('15087','2013-08-24','09:35:00',2.57),('15087','2013-08-24','09:40:00',1.89),('15087','2013-08-24','09:45:00',2.6),('15087','2013-08-24','09:50:00',2.57),('15087','2013-08-24','09:55:00',2.66),('15087','2013-08-24','10:00:00',3.02),('15087','2013-08-24','10:05:00',3.01),('15087','2013-08-24','10:10:00',3.09),('15087','2013-08-24','10:15:00',3.13),('15087','2013-08-24','10:20:00',3.22),('15087','2013-08-24','10:25:00',3.25),('15087','2013-08-24','10:30:00',3.3),('15087','2013-08-24','10:35:00',3.39),('15087','2013-08-24','10:40:00',3.39),('15087','2013-08-24','10:45:00',2.75),('15087','2013-08-24','10:50:00',2.43),('15087','2013-08-24','10:55:00',3.67),('15087','2013-08-24','11:00:00',3.66),('15087','2013-08-24','11:05:00',3.77),('15087','2013-08-24','11:10:00',3.77),('15087','2013-08-24','11:15:00',3.73),('15087','2013-08-24','11:20:00',3.79),('15087','2013-08-24','11:25:00',3.77),('15087','2013-08-24','11:30:00',3.87),('15087','2013-08-24','11:35:00',3.92),('15087','2013-08-24','11:40:00',3.96),('15087','2013-08-24','11:45:00',4.01),('15087','2013-08-24','11:50:00',3.99),('15087','2013-08-24','11:55:00',4.03),('15087','2013-08-24','12:00:00',4.01),('15087','2013-08-24','12:05:00',4.06),('15087','2013-08-24','12:10:00',4.12),('15087','2013-08-24','12:15:00',4.08),('15087','2013-08-24','12:20:00',4.14),('15087','2013-08-24','12:25:00',4.12),('15087','2013-08-24','12:30:00',4.14),('15087','2013-08-24','12:35:00',4.18),('15087','2013-08-24','12:40:00',4.19),('15087','2013-08-24','12:45:00',4.18),('15087','2013-08-24','12:50:00',4.22),('15087','2013-08-24','12:55:00',4.15),('15087','2013-08-24','13:00:00',4.19),('15087','2013-08-24','13:05:00',4.22),('15087','2013-08-24','13:10:00',4.18),('15087','2013-08-24','13:15:00',4.21),('15087','2013-08-24','13:20:00',4.25),('15087','2013-08-24','13:25:00',4.21),('15087','2013-08-24','13:30:00',4.22),('15087','2013-08-24','13:35:00',4.22),('15087','2013-08-24','13:40:00',4.15),('15087','2013-08-24','13:45:00',4.21),('15087','2013-08-24','13:50:00',4.16),('15087','2013-08-24','13:55:00',4.15),('15087','2013-08-24','14:00:00',4.06),('15087','2013-08-24','14:05:00',3.96),('15087','2013-08-24','14:10:00',3.94),('15087','2013-08-24','14:15:00',4.01),('15087','2013-08-24','14:20:00',3.89),('15087','2013-08-24','14:25:00',3.9),('15087','2013-08-24','14:30:00',3.9),('15087','2013-08-24','14:35:00',3.86),('15087','2013-08-24','14:40:00',3.72),('15087','2013-08-24','14:45:00',3.74),('15087','2013-08-24','14:50:00',3.7),('15087','2013-08-24','14:55:00',3.66),('15087','2013-08-24','15:00:00',3.5),('15087','2013-08-24','15:05:00',3.46),('15087','2013-08-24','15:10:00',3.44),('15087','2013-08-24','15:15:00',3.42),('15087','2013-08-24','15:20:00',3.33),('15087','2013-08-24','15:25:00',3.17),('15087','2013-08-24','15:30:00',3.19),('15087','2013-08-24','15:35:00',3.04),('15087','2013-08-24','15:40:00',2.96),('15087','2013-08-24','15:45:00',3.03),('15087','2013-08-24','15:50:00',3),('15087','2013-08-24','15:55:00',2.91),('15087','2013-08-24','16:00:00',2.9),('15087','2013-08-24','16:05:00',2.84),('15087','2013-08-24','16:10:00',2.78),('15087','2013-08-24','16:15:00',2.74),('15087','2013-08-24','16:20:00',2.67),('15087','2013-08-24','16:25:00',2.61),('15087','2013-08-24','16:30:00',2.49),('15087','2013-08-24','16:35:00',2.34),('15087','2013-08-24','16:40:00',2.16),('15087','2013-08-24','16:45:00',2.23),('15087','2013-08-24','16:50:00',2.16),('15087','2013-08-24','16:55:00',2.05),('15087','2013-08-24','17:00:00',1.98),('15087','2013-08-24','17:05:00',1.9),('15087','2013-08-24','17:10:00',1.84),('15087','2013-08-24','17:15:00',1.76),('15087','2013-08-24','17:20:00',1.68),('15087','2013-08-24','17:25:00',1.57),('15087','2013-08-24','17:30:00',1.5),('15087','2013-08-24','17:35:00',1.32),('15087','2013-08-24','17:40:00',1.24),('15087','2013-08-24','17:45:00',1.26),('15087','2013-08-24','17:50:00',1.14),('15087','2013-08-24','17:55:00',1.08),('15087','2013-08-24','18:00:00',1.04),('15087','2013-08-23','08:15:00',1.04),('15087','2013-08-23','08:20:00',1.14),('15087','2013-08-23','08:25:00',1.22),('15087','2013-08-23','08:30:00',1.26),('15087','2013-08-23','08:35:00',1.31),('15087','2013-08-23','08:40:00',1.43),('15087','2013-08-23','08:45:00',1.52),('15087','2013-08-23','08:50:00',1.58),('15087','2013-08-23','08:55:00',1.68),('15087','2013-08-23','09:00:00',1.75),('15087','2013-08-23','09:05:00',1.82),('15087','2013-08-23','09:10:00',1.91),('15087','2013-08-23','09:15:00',2.03),('15087','2013-08-23','09:20:00',2.07),('15087','2013-08-23','09:25:00',2.19),('15087','2013-08-23','09:30:00',2.27),('15087','2013-08-23','09:35:00',2.33),('15087','2013-08-23','09:40:00',2.4),('15087','2013-08-23','09:45:00',2.53),('15087','2013-08-23','09:50:00',2.54),('15087','2013-08-23','09:55:00',2.64),('15087','2013-08-23','10:00:00',2.72),('15087','2013-08-23','10:05:00',2.76),('15087','2013-08-23','10:10:00',2.84),('15087','2013-08-23','10:15:00',2.9),('15087','2013-08-23','10:20:00',2.92),('15087','2013-08-23','10:25:00',3.01),('15087','2013-08-23','10:30:00',3.07),('15087','2013-08-23','10:35:00',3.08),('15087','2013-08-23','10:40:00',3.1),('15087','2013-08-23','10:45:00',3.12),('15087','2013-08-23','10:50:00',3.28),('15087','2013-08-23','10:55:00',3.25),('15087','2013-08-23','11:00:00',3.1),('15087','2013-08-23','11:05:00',2.89),('15087','2013-08-23','11:10:00',1.37),('15087','2013-08-23','11:15:00',1.15),('15087','2013-08-23','11:20:00',1.54),('15087','2013-08-23','11:25:00',2.4),('15087','2013-08-23','11:30:00',2.5),('15087','2013-08-23','11:35:00',3.72),('15087','2013-08-23','11:40:00',3.9),('15087','2013-08-23','11:45:00',3.94),('15087','2013-08-23','11:50:00',3.42),('15087','2013-08-23','11:55:00',1.23),('15087','2013-08-23','12:00:00',1.71),('15087','2013-08-23','12:05:00',3.53),('15087','2013-08-23','12:10:00',3.58),('15087','2013-08-23','12:15:00',1.01),('15087','2013-08-23','12:25:00',1.02),('15087','2013-08-23','12:30:00',1.75),('15087','2013-08-23','12:35:00',2.22),('15087','2013-08-23','12:40:00',1.26),('15087','2013-08-23','12:45:00',2.02),('15087','2013-08-23','12:50:00',2.52),('15087','2013-08-23','13:00:00',1.57),('15087','2013-08-23','13:05:00',3.59),('15087','2013-08-23','13:10:00',1.62),('15087','2013-08-23','13:15:00',2.48),('15087','2013-08-23','13:20:00',3.73),('15087','2013-08-23','13:25:00',4.14),('15087','2013-08-23','13:30:00',4.41),('15087','2013-08-23','13:35:00',3.01),('15087','2013-08-23','13:40:00',3.76),('15087','2013-08-23','13:45:00',2.96),('15087','2013-08-23','13:50:00',2.38),('15087','2013-08-23','13:55:00',4.52),('15087','2013-08-23','14:00:00',4.26),('15087','2013-08-23','14:05:00',3.93),('15087','2013-08-23','14:10:00',4.14),('15087','2013-08-23','14:15:00',4.06),('15087','2013-08-23','14:20:00',3.94),('15087','2013-08-23','14:25:00',3.86),('15087','2013-08-23','14:30:00',3.88),('15087','2013-08-23','14:35:00',3.78),('15087','2013-08-23','14:40:00',3.73),('15087','2013-08-23','14:45:00',3.77),('15087','2013-08-23','14:50:00',3.72),('15087','2013-08-23','14:55:00',3.4),('15087','2013-08-23','15:00:00',3.4),('15087','2013-08-23','15:05:00',3.29),('15087','2013-08-23','15:10:00',3.41),('15087','2013-08-23','15:15:00',3.24),('15087','2013-08-23','15:20:00',3.26),('15087','2013-08-23','15:25:00',3.28),('15087','2013-08-23','15:30:00',3.38),('15087','2013-08-23','15:35:00',3.06),('15087','2013-08-23','15:40:00',3.08),('15087','2013-08-23','15:45:00',3.02),('15087','2013-08-23','15:50:00',2.72),('15087','2013-08-23','15:55:00',2.78),('15087','2013-08-23','16:00:00',2.73),('15087','2013-08-23','16:05:00',2.6),('15087','2013-08-23','16:10:00',2.33),('15087','2013-08-23','16:15:00',2.59),('15087','2013-08-23','16:20:00',2.78),('15087','2013-08-23','16:25:00',2.67),('15087','2013-08-23','16:30:00',2.61),('15087','2013-08-23','16:35:00',2.53),('15087','2013-08-23','16:40:00',2.4),('15087','2013-08-23','16:45:00',2.42),('15087','2013-08-23','16:50:00',2.19),('15087','2013-08-23','16:55:00',2),('15087','2013-08-23','17:00:00',1.99),('15087','2013-08-23','17:05:00',1.9),('15087','2013-08-23','17:10:00',1.81),('15087','2013-08-23','17:15:00',1.73),('15087','2013-08-23','17:20:00',1.66),('15087','2013-08-23','17:25:00',1.55),('15087','2013-08-23','17:30:00',1.41),('15087','2013-08-23','17:35:00',1.34),('15087','2013-08-23','17:40:00',1.23),('15087','2013-08-23','17:45:00',1.19),('15087','2013-08-23','17:50:00',1.12),('15087','2013-08-23','17:55:00',1.07),('15087','2013-08-23','18:00:00',1.03),('15087','2013-08-22','08:10:00',1.04),('15087','2013-08-22','08:15:00',1.1),('15087','2013-08-22','08:20:00',1.19),('15087','2013-08-22','08:25:00',1.25),('15087','2013-08-22','08:30:00',1.37),('15087','2013-08-22','08:35:00',1.46),('15087','2013-08-22','08:40:00',1.51),('15087','2013-08-22','08:45:00',1.63),('15087','2013-08-22','08:50:00',1.7),('15087','2013-08-22','08:55:00',1.84),('15087','2013-08-22','09:00:00',1.93),('15087','2013-08-22','09:05:00',2.12),('15087','2013-08-22','09:10:00',2.35),('15087','2013-08-22','09:15:00',2.43),('15087','2013-08-22','09:20:00',2.59),('15087','2013-08-22','09:25:00',2.64),('15087','2013-08-22','09:30:00',2.77),('15087','2013-08-22','09:35:00',1.68),('15087','2013-08-22','09:40:00',1.93),('15087','2013-08-22','09:45:00',2.73),('15087','2013-08-22','09:50:00',2.91),('15087','2013-08-22','09:55:00',2.53),('15087','2013-08-22','10:00:00',3.17),('15087','2013-08-22','10:05:00',3.17),('15087','2013-08-22','10:10:00',3.2),('15087','2013-08-22','10:15:00',3.19),('15087','2013-08-22','10:20:00',3.19),('15087','2013-08-22','10:25:00',3.22),('15087','2013-08-22','10:30:00',3.31),('15087','2013-08-22','10:35:00',3.37),('15087','2013-08-22','10:40:00',3.4),('15087','2013-08-22','10:45:00',3.43),('15087','2013-08-22','10:50:00',3.48),('15087','2013-08-22','10:55:00',3.53),('15087','2013-08-22','11:00:00',3.58),('15087','2013-08-22','11:05:00',3.62),('15087','2013-08-22','11:10:00',3.65),('15087','2013-08-22','11:15:00',3.66),('15087','2013-08-22','11:20:00',3.71),('15087','2013-08-22','11:25:00',3.74),('15087','2013-08-22','11:30:00',3.81),('15087','2013-08-22','11:35:00',3.83),('15087','2013-08-22','11:40:00',3.88),('15087','2013-08-22','11:45:00',3.9),('15087','2013-08-22','11:50:00',3.9),('15087','2013-08-22','11:55:00',3.95),('15087','2013-08-22','12:00:00',3.96),('15087','2013-08-22','12:05:00',3.98),('15087','2013-08-22','12:10:00',3.97),('15087','2013-08-22','12:15:00',3.97),('15087','2013-08-22','12:20:00',4.04),('15087','2013-08-22','12:25:00',4.05),('15087','2013-08-22','12:30:00',4.03),('15087','2013-08-22','12:35:00',4),('15087','2013-08-22','12:40:00',4.04),('15087','2013-08-22','12:45:00',4.07),('15087','2013-08-22','12:50:00',4.07),('15087','2013-08-22','12:55:00',4.07),('15087','2013-08-22','13:00:00',4.06),('15087','2013-08-22','13:05:00',4.04),('15087','2013-08-22','13:10:00',3.9),('15087','2013-08-22','13:15:00',3.99),('15087','2013-08-22','13:20:00',3.99),('15087','2013-08-22','13:25:00',4.02),('15087','2013-08-22','13:30:00',4.01),('15087','2013-08-22','13:35:00',3.99),('15087','2013-08-22','13:40:00',3.95),('15087','2013-08-22','13:45:00',4.01),('15087','2013-08-22','13:50:00',4.01),('15087','2013-08-22','13:55:00',3.96),('15087','2013-08-22','14:00:00',3.82),('15087','2013-08-22','14:05:00',3.9),('15087','2013-08-22','14:10:00',3.86),('15087','2013-08-22','14:15:00',3.86),('15087','2013-08-22','14:20:00',3.84),('15087','2013-08-22','14:25:00',3.81),('15087','2013-08-22','14:30:00',3.72),('15087','2013-08-22','14:35:00',3.8),('15087','2013-08-22','14:40:00',3.72),('15087','2013-08-22','14:45:00',3.52),('15087','2013-08-22','14:50:00',3.6),('15087','2013-08-22','14:55:00',3.55),('15087','2013-08-22','15:00:00',3.5),('15087','2013-08-22','15:05:00',3.42),('15087','2013-08-22','15:10:00',3.46),('15087','2013-08-22','15:15:00',3.26),('15087','2013-08-22','15:20:00',3.21),('15087','2013-08-22','15:25:00',3.19),('15087','2013-08-22','15:30:00',3.09),('15087','2013-08-22','15:35:00',3.06),('15087','2013-08-22','15:40:00',2.96),('15087','2013-08-22','15:45:00',2.99),('15087','2013-08-22','15:50:00',2.89),('15087','2013-08-22','15:55:00',2.8),('15087','2013-08-22','16:00:00',2.79),('15087','2013-08-22','16:05:00',2.63),('15087','2013-08-22','16:10:00',2.61),('15087','2013-08-22','16:15:00',2.66),('15087','2013-08-22','16:20:00',2.6),('15087','2013-08-22','16:25:00',2.5),('15087','2013-08-22','16:30:00',2.46),('15087','2013-08-22','16:35:00',2.32),('15087','2013-08-22','16:40:00',2.15),('15087','2013-08-22','16:45:00',2.14),('15087','2013-08-22','16:50:00',1.98),('15087','2013-08-22','16:55:00',1.92),('15087','2013-08-22','17:00:00',1.89),('15087','2013-08-22','17:05:00',1.79),('15087','2013-08-22','17:10:00',1.72),('15087','2013-08-22','17:15:00',1.64),('15087','2013-08-22','17:20:00',1.56),('15087','2013-08-22','17:25:00',1.51),('15087','2013-08-22','17:30:00',1.43),('15087','2013-08-22','17:35:00',1.33),('15087','2013-08-22','17:40:00',1.24),('15087','2013-08-22','17:45:00',1.2),('15087','2013-08-22','17:50:00',1.12),('15087','2013-08-22','17:55:00',1.06),('15087','2013-08-22','18:00:00',1.04),('15087','2013-08-21','09:05:00',1.38),('15087','2013-08-21','09:10:00',1.4),('15087','2013-08-21','09:15:00',2.55),('15087','2013-08-21','09:20:00',2.61),('15087','2013-08-21','09:25:00',1.25),('15087','2013-08-21','09:40:00',1.04),('15087','2013-08-21','09:45:00',1.26),('15087','2013-08-21','09:50:00',2.62),('15087','2013-08-21','09:55:00',3.86),('15087','2013-08-21','10:00:00',3.63),('15087','2013-08-21','10:05:00',3.06),('15087','2013-08-21','10:10:00',2.71),('15087','2013-08-21','10:15:00',2.37),('15087','2013-08-21','10:20:00',2.34),('15087','2013-08-21','10:25:00',1.84),('15087','2013-08-21','10:30:00',2.61),('15087','2013-08-21','10:35:00',3.22),('15087','2013-08-21','10:40:00',1.99),('15087','2013-08-21','10:45:00',2.26),('15087','2013-08-21','10:50:00',2.34),('15087','2013-08-21','10:55:00',1.91),('15087','2013-08-21','11:00:00',2.75),('15087','2013-08-21','11:05:00',2.07),('15087','2013-08-21','11:10:00',1.8),('15087','2013-08-21','11:15:00',2.22),('15087','2013-08-21','11:20:00',2.92),('15087','2013-08-21','11:25:00',2.71),('15087','2013-08-21','11:30:00',3.36),('15087','2013-08-21','11:35:00',4.62),('15087','2013-08-21','11:40:00',4.36),('15087','2013-08-21','11:45:00',4.32),('15087','2013-08-21','11:50:00',4.07),('15087','2013-08-21','11:55:00',4.02),('15087','2013-08-21','12:00:00',4.3),('15087','2013-08-21','12:05:00',4.29),('15087','2013-08-21','12:10:00',4.29),('15087','2013-08-21','12:15:00',4.33),('15087','2013-08-21','12:20:00',4.27),('15087','2013-08-21','12:25:00',2.94),('15087','2013-08-21','12:30:00',2.58),('15087','2013-08-21','12:35:00',2.04),('15087','2013-08-21','12:40:00',3.87),('15087','2013-08-21','12:45:00',4.18),('15087','2013-08-21','12:50:00',3.99),('15087','2013-08-21','12:55:00',3.97),('15087','2013-08-21','13:00:00',4.13),('15087','2013-08-21','13:05:00',4.14),('15087','2013-08-21','13:10:00',4.23),('15087','2013-08-21','13:15:00',4.31),('15087','2013-08-21','13:20:00',4.32),('15087','2013-08-21','13:25:00',4.3),('15087','2013-08-21','13:30:00',4.18),('15087','2013-08-21','13:35:00',4.14),('15087','2013-08-21','13:40:00',4.14),('15087','2013-08-21','13:45:00',4.24),('15087','2013-08-21','13:50:00',4.1),('15087','2013-08-21','13:55:00',3.96),('15087','2013-08-21','14:00:00',3.78),('15087','2013-08-21','14:05:00',3.91),('15087','2013-08-21','14:10:00',4.02),('15087','2013-08-21','14:15:00',2.83),('15087','2013-08-21','14:20:00',1.58),('15087','2013-08-21','14:25:00',1.89),('15087','2013-08-21','14:30:00',3.55),('15087','2013-08-21','14:35:00',3.62),('15087','2013-08-21','14:40:00',3.63),('15087','2013-08-21','14:45:00',3.49),('15087','2013-08-21','14:50:00',3.39),('15087','2013-08-21','14:55:00',3.42),('15087','2013-08-21','15:00:00',3.45),('15087','2013-08-21','15:05:00',3.42),('15087','2013-08-21','15:10:00',3.34),('15087','2013-08-21','15:15:00',3.29),('15087','2013-08-21','15:20:00',3.14),('15087','2013-08-21','15:25:00',2.97),('15087','2013-08-21','15:30:00',2.94),('15087','2013-08-21','15:35:00',2.84),('15087','2013-08-21','15:40:00',2.64),('15087','2013-08-21','15:45:00',2.69),('15087','2013-08-21','15:50:00',2.72),('15087','2013-08-21','15:55:00',2.68),('15087','2013-08-21','16:00:00',2.56),('15087','2013-08-21','16:05:00',2.41),('15087','2013-08-21','16:10:00',2.34),('15087','2013-08-21','16:15:00',2.38),('15087','2013-08-21','16:20:00',2.5),('15087','2013-08-21','16:25:00',2.48),('15087','2013-08-21','16:30:00',2.59),('15087','2013-08-21','16:35:00',2.52),('15087','2013-08-21','16:40:00',2.45),('15087','2013-08-21','16:45:00',2.39),('15087','2013-08-21','16:50:00',2.27),('15087','2013-08-21','16:55:00',2.17),('15087','2013-08-21','17:00:00',2.14),('15087','2013-08-21','17:05:00',2.11),('15087','2013-08-21','17:10:00',2.03),('15087','2013-08-21','17:15:00',1.94),('15087','2013-08-21','17:20:00',1.91),('15087','2013-08-21','17:25:00',1.85),('15087','2013-08-21','17:30:00',1.72),('15087','2013-08-21','17:35:00',1.68),('15087','2013-08-21','17:40:00',1.6),('15087','2013-08-21','17:45:00',1.52),('15087','2013-08-21','17:50:00',1.47),('15087','2013-08-21','17:55:00',1.45),('15087','2013-08-21','18:00:00',1.4),('15087','2013-08-21','18:05:00',1.32),('15087','2013-08-21','18:10:00',1.21),('15087','2013-08-21','18:15:00',1.12),('15087','2013-08-21','18:20:00',1.01),('15087','2013-08-20','07:55:00',1.07),('15087','2013-08-20','08:55:00',1.01),('15087','2013-08-20','09:20:00',1.29),('15087','2013-08-20','09:25:00',2.04),('15087','2013-08-20','09:30:00',2.66),('15087','2013-08-20','09:35:00',3.05),('15087','2013-08-20','09:40:00',3.33),('15087','2013-08-20','09:45:00',2.33),('15087','2013-08-20','09:50:00',2.1),('15087','2013-08-20','09:55:00',3.3),('15087','2013-08-20','10:00:00',2.51),('15087','2013-08-20','10:05:00',1.61),('15087','2013-08-20','10:10:00',1.38),('15087','2013-08-20','10:15:00',2.19),('15087','2013-08-20','10:20:00',1.32),('15087','2013-08-20','10:30:00',1.02),('15087','2013-08-20','10:35:00',1.04),('15087','2013-08-20','10:40:00',1.69),('15087','2013-08-20','10:45:00',3.49),('15087','2013-08-20','10:50:00',3.87),('15087','2013-08-20','10:55:00',1.56),('15087','2013-08-20','11:00:00',1),('15087','2013-08-20','11:10:00',3.13),('15087','2013-08-20','11:15:00',4.18),('15087','2013-08-20','11:20:00',4.15),('15087','2013-08-20','11:25:00',2.73),('15087','2013-08-20','11:30:00',2.92),('15087','2013-08-20','11:35:00',4.2),('15087','2013-08-20','11:40:00',4.39),('15087','2013-08-20','11:45:00',4.53),('15087','2013-08-20','11:50:00',4.86),('15087','2013-08-20','11:55:00',3.59),('15087','2013-08-20','12:00:00',2.43),('15087','2013-08-20','12:05:00',1.68),('15087','2013-08-20','12:10:00',1.6),('15087','2013-08-20','12:25:00',1.2),('15087','2013-08-20','12:30:00',1.56),('15087','2013-08-20','12:35:00',1.72),('15087','2013-08-20','12:40:00',1.83),('15087','2013-08-20','12:45:00',1.79),('15087','2013-08-20','12:50:00',1.8),('15087','2013-08-20','12:55:00',1.9),('15087','2013-08-20','13:00:00',1.84),('15087','2013-08-20','13:05:00',1.69),('15087','2013-08-20','13:10:00',1.67),('15087','2013-08-20','13:15:00',1.7),('15087','2013-08-20','13:20:00',1.77),('15087','2013-08-20','13:25:00',1.84),('15087','2013-08-20','13:30:00',2.02),('15087','2013-08-20','13:35:00',2.88),('15087','2013-08-20','13:40:00',4.53),('15087','2013-08-20','13:45:00',3.75),('15087','2013-08-20','13:50:00',4.59),('15087','2013-08-20','13:55:00',4.42),('15087','2013-08-20','14:00:00',4.24),('15087','2013-08-20','14:05:00',3.9),('15087','2013-08-20','14:10:00',3.58),('15087','2013-08-20','14:15:00',3.81),('15087','2013-08-20','14:20:00',4.12),('15087','2013-08-20','14:25:00',3.56),('15087','2013-08-20','14:30:00',3.72),('15087','2013-08-20','14:35:00',4.33),('15087','2013-08-20','14:40:00',3.94),('15087','2013-08-20','14:45:00',3.66),('15087','2013-08-20','14:50:00',4.05),('15087','2013-08-20','14:55:00',3.67),('15087','2013-08-20','15:00:00',3.41),('15087','2013-08-20','15:05:00',3.85),('15087','2013-08-20','15:10:00',3.79),('15087','2013-08-20','15:15:00',3.84),('15087','2013-08-20','15:20:00',3.61),('15087','2013-08-20','15:25:00',3.66),('15087','2013-08-20','15:30:00',3.64),('15087','2013-08-20','15:35:00',3.55),('15087','2013-08-20','15:40:00',3.56),('15087','2013-08-20','15:45:00',3.56),('15087','2013-08-20','15:50:00',3.86),('15087','2013-08-20','15:55:00',3.79),('15087','2013-08-20','16:00:00',3.67),('15087','2013-08-20','16:05:00',3.68),('15087','2013-08-20','16:10:00',3.6),('15087','2013-08-20','16:15:00',3.57),('15087','2013-08-20','16:20:00',3.49),('15087','2013-08-20','16:25:00',3.37),('15087','2013-08-20','16:30:00',3.07),('15087','2013-08-20','16:35:00',2.99),('15087','2013-08-20','16:40:00',2.95),('15087','2013-08-20','16:45:00',2.8),('15087','2013-08-20','16:50:00',2.67),('15087','2013-08-20','16:55:00',2.6),('15087','2013-08-20','17:00:00',2.38),('15087','2013-08-20','17:05:00',2.22),('15087','2013-08-20','17:10:00',2.11),('15087','2013-08-20','17:15:00',1.91),('15087','2013-08-20','17:20:00',1.84),('15087','2013-08-20','17:25:00',1.76),('15087','2013-08-20','17:30:00',1.7),('15087','2013-08-20','17:35:00',1.64),('15087','2013-08-20','17:40:00',1.52),('15087','2013-08-20','17:45:00',1.4),('15087','2013-08-20','17:50:00',1.3),('15087','2013-08-20','17:55:00',1.27),('15087','2013-08-20','18:00:00',1.15),('15087','2013-08-20','18:05:00',1.12),('15087','2013-08-20','18:10:00',1.17),('15087','2013-08-20','18:15:00',1.1),('15087','2013-08-20','18:20:00',1.08),('15087','2013-08-20','18:25:00',1.02),('15087','2013-08-20','18:30:00',1.01),('15087','2014-04-10','08:05:00',1.08),('15087','2014-04-10','08:10:00',1.18),('15087','2014-04-10','08:15:00',1.29),('15087','2014-04-10','08:20:00',1.45),('15087','2014-04-10','08:25:00',1.56),('15087','2014-04-10','08:30:00',1.64),('15087','2014-04-10','08:35:00',1.79),('15087','2014-04-10','08:40:00',1.9),('15087','2014-04-10','08:45:00',2.01),('15087','2014-04-10','08:50:00',2.11),('15087','2014-04-10','08:55:00',2.19),('15087','2014-04-10','09:00:00',2.27),('15087','2014-04-10','09:05:00',2.4),('15087','2014-04-10','09:10:00',2.48),('15087','2014-04-10','09:15:00',2.54),('15087','2014-04-10','09:20:00',2.55),('15087','2014-04-10','09:25:00',2.74),('15087','2014-04-10','09:30:00',2.85),('15087','2014-04-10','09:35:00',2.93),('15087','2014-04-10','09:40:00',2.99),('15087','2014-04-10','09:45:00',3.06),('15087','2014-04-10','09:50:00',3.16),('15087','2014-04-10','09:55:00',3.25),('15087','2014-04-10','10:00:00',3.31),('15087','2014-04-10','10:05:00',3.38),('15087','2014-04-10','10:10:00',3.48),('15087','2014-04-10','10:15:00',3.47),('15087','2014-04-10','10:20:00',3.54),('15087','2014-04-10','10:25:00',3.62),('15087','2014-04-10','10:30:00',3.67),('15087','2014-04-10','10:35:00',3.79),('15087','2014-04-10','10:40:00',3.86),('15087','2014-04-10','10:45:00',3.87),('15087','2014-04-10','10:50:00',3.82),('15087','2014-04-10','10:55:00',3.95),('15087','2014-04-10','11:00:00',3.98),('15087','2014-04-10','11:05:00',4.12),('15087','2014-04-10','11:10:00',4.03),('15087','2014-04-10','11:15:00',4.19),('15087','2014-04-10','11:20:00',4.31),('15087','2014-04-10','11:25:00',4.4),('15087','2014-04-10','11:30:00',4.41),('15087','2014-04-10','11:35:00',4.47),('15087','2014-04-10','11:40:00',4.3),('15087','2014-04-10','11:45:00',4.45),('15087','2014-04-10','11:50:00',4.31),('15087','2014-04-10','11:55:00',4.53),('15087','2014-04-10','12:00:00',4.45),('15087','2014-04-10','12:05:00',4.17),('15087','2014-04-10','12:10:00',4.34),('15087','2014-04-10','12:15:00',4.42),('15087','2014-04-10','12:20:00',4.49),('15087','2014-04-10','12:25:00',4.25),('15087','2014-04-10','12:30:00',4.35),('15087','2014-04-10','12:35:00',4.64),('15087','2014-04-10','12:40:00',4.41),('15087','2014-04-10','12:45:00',4.58),('15087','2014-04-10','12:50:00',4.57),('15087','2014-04-10','12:55:00',4.49),('15087','2014-04-10','13:00:00',4.42),('15087','2014-04-10','13:05:00',4.21),('15087','2014-04-10','13:10:00',4.43),('15087','2014-04-10','13:15:00',4.4),('15087','2014-04-10','13:20:00',4.27),('15087','2014-04-10','13:25:00',4.63),('15087','2014-04-10','13:30:00',4.54),('15087','2014-04-10','13:35:00',4.63),('15087','2014-04-10','13:40:00',4.38),('15087','2014-04-10','13:45:00',4.6),('15087','2014-04-10','13:50:00',4.58),('15087','2014-04-10','13:55:00',4.49),('15087','2014-04-10','14:00:00',4.29),('15087','2014-04-10','14:05:00',4.25),('15087','2014-04-10','14:10:00',4.34),('15087','2014-04-10','14:15:00',4.3),('15087','2014-04-10','14:20:00',4.29),('15087','2014-04-10','14:25:00',4.25),('15087','2014-04-10','14:30:00',4.18),('15087','2014-04-10','14:35:00',4.12),('15087','2014-04-10','14:40:00',4.09),('15087','2014-04-10','14:45:00',3.68),('15087','2014-04-10','14:50:00',4.07),('15087','2014-04-10','14:55:00',3.93),('15087','2014-04-10','15:00:00',3.84),('15087','2014-04-10','15:05:00',3.78),('15087','2014-04-10','15:10:00',3.71),('15087','2014-04-10','15:15:00',3.6),('15087','2014-04-10','15:20:00',3.54),('15087','2014-04-10','15:25:00',3.58),('15087','2014-04-10','15:30:00',3.24),('15087','2014-04-10','15:35:00',2.98),('15087','2014-04-10','15:40:00',3.06),('15087','2014-04-10','15:45:00',3.09),('15087','2014-04-10','15:50:00',3.05),('15087','2014-04-10','15:55:00',3.11),('15087','2014-04-10','16:00:00',3.03),('15087','2014-04-10','16:05:00',3.08),('15087','2014-04-10','16:10:00',3.08),('15087','2014-04-10','16:15:00',3.12),('15087','2014-04-10','16:20:00',2.99),('15087','2014-04-10','16:25:00',2.94),('15087','2014-04-10','16:30:00',2.9),('15087','2014-04-10','16:35:00',2.78),('15087','2014-04-10','16:40:00',2.73),('15087','2014-04-10','16:45:00',2.72),('15087','2014-04-10','16:50:00',2.51),('15087','2014-04-10','16:55:00',2.44),('15087','2014-04-10','17:00:00',2.33),('15087','2014-04-10','17:05:00',2.19),('15087','2014-04-10','17:10:00',2.04),('15087','2014-04-10','17:15:00',1.89),('15087','2014-04-10','17:20:00',1.8),('15087','2014-04-10','17:25:00',1.69),('15087','2014-04-10','17:30:00',1.53),('15087','2014-04-10','17:35:00',1.46),('15087','2014-04-10','17:40:00',1.33),('15087','2014-04-10','17:45:00',1.22),('15087','2014-04-10','17:50:00',1.17),('15087','2014-04-10','17:55:00',1.07),('15087','2014-04-10','18:00:00',1.01),('15087','2013-08-19','08:05:00',1.06),('15087','2013-08-19','08:10:00',1.13),('15087','2013-08-19','08:15:00',1.21),('15087','2013-08-19','08:20:00',1.3),('15087','2013-08-19','08:25:00',1.38),('15087','2013-08-19','08:30:00',1.45),('15087','2013-08-19','08:35:00',1.53),('15087','2013-08-19','08:40:00',1.61),('15087','2013-08-19','08:45:00',1.71),('15087','2013-08-19','08:50:00',1.82),('15087','2013-08-19','08:55:00',1.93),('15087','2013-08-19','09:00:00',2.04),('15087','2013-08-19','09:05:00',2.13),('15087','2013-08-19','09:10:00',2.19),('15087','2013-08-19','09:15:00',2.32),('15087','2013-08-19','09:20:00',2.43),('15087','2013-08-19','09:25:00',2.5),('15087','2013-08-19','09:30:00',2.6),('15087','2013-08-19','09:35:00',2.66),('15087','2013-08-19','09:40:00',2.75),('15087','2013-08-19','09:45:00',2.8),('15087','2013-08-19','09:50:00',2.87),('15087','2013-08-19','09:55:00',2.95),('15087','2013-08-19','10:00:00',3.01),('15087','2013-08-19','10:05:00',3.07),('15087','2013-08-19','10:10:00',3.13),('15087','2013-08-19','10:15:00',3.2),('15087','2013-08-19','10:20:00',3.19),('15087','2013-08-19','10:25:00',3.26),('15087','2013-08-19','10:30:00',3.35),('15087','2013-08-19','10:35:00',3.4),('15087','2013-08-19','10:40:00',3.43),('15087','2013-08-19','10:45:00',3.48),('15087','2013-08-19','10:50:00',3.53),('15087','2013-08-19','10:55:00',3.59),('15087','2013-08-19','11:00:00',3.66),('15087','2013-08-19','11:05:00',3.68),('15087','2013-08-19','11:10:00',3.75),('15087','2013-08-19','11:15:00',3.77),('15087','2013-08-19','11:20:00',3.8),('15087','2013-08-19','11:25:00',3.83),('15087','2013-08-19','11:30:00',3.86),('15087','2013-08-19','11:35:00',3.86),('15087','2013-08-19','11:40:00',3.87),('15087','2013-08-19','11:45:00',3.88),('15087','2013-08-19','11:50:00',3.89),('15087','2013-08-19','11:55:00',3.9),('15087','2013-08-19','12:00:00',4.03),('15087','2013-08-19','12:05:00',4.02),('15087','2013-08-19','12:10:00',4.05),('15087','2013-08-19','12:15:00',4.11),('15087','2013-08-19','12:20:00',4.11),('15087','2013-08-19','12:25:00',4.14),('15087','2013-08-19','12:30:00',4.17),('15087','2013-08-19','12:35:00',4.16),('15087','2013-08-19','12:40:00',4.2),('15087','2013-08-19','12:45:00',4.21),('15087','2013-08-19','12:50:00',4.22),('15087','2013-08-19','12:55:00',4.29),('15087','2013-08-19','13:00:00',4.28),('15087','2013-08-19','13:05:00',4.27),('15087','2013-08-19','13:10:00',4.25),('15087','2013-08-19','13:15:00',4.27),('15087','2013-08-19','13:20:00',4.29),('15087','2013-08-19','13:25:00',4.28),('15087','2013-08-19','13:30:00',4.29),('15087','2013-08-19','13:35:00',4.29),('15087','2013-08-19','13:40:00',4.28),('15087','2013-08-19','13:45:00',4.27),('15087','2013-08-19','13:50:00',4.26),('15087','2013-08-19','13:55:00',4.24),('15087','2013-08-19','14:00:00',4.12),('15087','2013-08-19','14:05:00',4.09),('15087','2013-08-19','14:10:00',4.16),('15087','2013-08-19','14:15:00',4.1),('15087','2013-08-19','14:20:00',4.03),('15087','2013-08-19','14:25:00',3.94),('15087','2013-08-19','14:30:00',3.84),('15087','2013-08-19','14:35:00',3.9),('15087','2013-08-19','14:40:00',3.79),('15087','2013-08-19','14:45:00',3.84),('15087','2013-08-19','14:50:00',3.72),('15087','2013-08-19','14:55:00',3.78),('15087','2013-08-19','15:00:00',3.71),('15087','2013-08-19','15:05:00',3.63),('15087','2013-08-19','15:10:00',3.64),('15087','2013-08-19','15:15:00',3.59),('15087','2013-08-19','15:20:00',3.51),('15087','2013-08-19','15:25:00',3.32),('15087','2013-08-19','15:30:00',3.19),('15087','2013-08-19','15:35:00',3.14),('15087','2013-08-19','15:40:00',3.26),('15087','2013-08-19','15:45:00',3.21),('15087','2013-08-19','15:50:00',3.15),('15087','2013-08-19','15:55:00',3.1),('15087','2013-08-19','16:00:00',3.03),('15087','2013-08-19','16:05:00',2.98),('15087','2013-08-19','16:10:00',2.93),('15087','2013-08-19','16:15:00',2.84),('15087','2013-08-19','16:20:00',2.8),('15087','2013-08-19','16:25:00',2.67),('15087','2013-08-19','16:30:00',2.54),('15087','2013-08-19','16:35:00',2.37),('15087','2013-08-19','16:40:00',2.4),('15087','2013-08-19','16:45:00',2.3),('15087','2013-08-19','16:50:00',2.15),('15087','2013-08-19','16:55:00',2.23),('15087','2013-08-19','17:00:00',2.13),('15087','2013-08-19','17:05:00',2.05),('15087','2013-08-19','17:10:00',1.98),('15087','2013-08-19','17:15:00',1.9),('15087','2013-08-19','17:20:00',1.83),('15087','2013-08-19','17:25:00',1.74),('15087','2013-08-19','17:30:00',1.67),('15087','2013-08-19','17:35:00',1.58),('15087','2013-08-19','17:40:00',1.5),('15087','2013-08-19','17:45:00',1.35),('15087','2013-08-19','17:50:00',1.34),('15087','2013-08-19','17:55:00',1.32),('15087','2013-08-19','18:00:00',1.26),('15087','2013-08-19','18:05:00',1.21),('15087','2013-08-19','18:10:00',1.1),('15087','2013-08-18','08:00:00',1.02),('15087','2013-08-18','08:05:00',1.11),('15087','2013-08-18','08:10:00',1.2),('15087','2013-08-18','08:15:00',1.3),('15087','2013-08-18','08:20:00',1.39),('15087','2013-08-18','08:25:00',1.47),('15087','2013-08-18','08:30:00',1.55),('15087','2013-08-18','08:35:00',1.64),('15087','2013-08-18','08:40:00',1.73),('15087','2013-08-18','08:45:00',1.81),('15087','2013-08-18','08:50:00',1.88),('15087','2013-08-18','08:55:00',1.97),('15087','2013-08-18','09:00:00',2.09),('15087','2013-08-18','09:05:00',2.19),('15087','2013-08-18','09:10:00',2.3),('15087','2013-08-18','09:15:00',2.43),('15087','2013-08-18','09:20:00',2.52),('15087','2013-08-18','09:25:00',2.62),('15087','2013-08-18','09:30:00',2.69),('15087','2013-08-18','09:35:00',2.75),('15087','2013-08-18','09:40:00',2.78),('15087','2013-08-18','09:45:00',2.66),('15087','2013-08-18','09:50:00',2.84),('15087','2013-08-18','09:55:00',2.27),('15087','2013-08-18','10:00:00',2.9),('15087','2013-08-18','10:05:00',2.49),('15087','2013-08-18','10:10:00',3.13),('15087','2013-08-18','10:15:00',3.2),('15087','2013-08-18','10:20:00',3.28),('15087','2013-08-18','10:25:00',3.32),('15087','2013-08-18','10:30:00',3.37),('15087','2013-08-18','10:35:00',3.4),('15087','2013-08-18','10:40:00',3.42),('15087','2013-08-18','10:45:00',3.46),('15087','2013-08-18','10:50:00',3.51),('15087','2013-08-18','10:55:00',3.47),('15087','2013-08-18','11:00:00',3.61),('15087','2013-08-18','11:05:00',3.67),('15087','2013-08-18','11:10:00',3.71),('15087','2013-08-18','11:15:00',3.76),('15087','2013-08-18','11:20:00',3.76),('15087','2013-08-18','11:25:00',3.8),('15087','2013-08-18','11:30:00',3.83),('15087','2013-08-18','11:35:00',3.88),('15087','2013-08-18','11:40:00',3.9),('15087','2013-08-18','11:45:00',3.93),('15087','2013-08-18','11:50:00',3.94),('15087','2013-08-18','11:55:00',3.96),('15087','2013-08-18','12:00:00',4.05),('15087','2013-08-18','12:05:00',4.08),('15087','2013-08-18','12:10:00',4.16),('15087','2013-08-18','12:15:00',4.25),('15087','2013-08-18','12:20:00',4.19),('15087','2013-08-18','12:25:00',3.58),('15087','2013-08-18','12:30:00',1.32),('15087','2013-08-18','12:45:00',1.18),('15087','2013-08-18','12:50:00',1.79),('15087','2013-08-18','12:55:00',1.65),('15087','2013-08-18','13:00:00',3.81),('15087','2013-08-18','13:05:00',4.09),('15087','2013-08-18','13:10:00',4.38),('15087','2013-08-18','13:15:00',4.36),('15087','2013-08-18','13:20:00',4.37),('15087','2013-08-18','13:25:00',4.28),('15087','2013-08-18','13:30:00',4.28),('15087','2013-08-18','13:35:00',4.3),('15087','2013-08-18','13:40:00',4.33),('15087','2013-08-18','13:45:00',4.29),('15087','2013-08-18','13:50:00',4.2),('15087','2013-08-18','13:55:00',4.18),('15087','2013-08-18','14:00:00',4.23),('15087','2013-08-18','14:05:00',4.13),('15087','2013-08-18','14:10:00',4.12),('15087','2013-08-18','14:15:00',4.13),('15087','2013-08-18','14:20:00',4.06),('15087','2013-08-18','14:25:00',4.01),('15087','2013-08-18','14:30:00',3.89),('15087','2013-08-18','14:35:00',3.94),('15087','2013-08-18','14:40:00',3.89),('15087','2013-08-18','14:45:00',3.83),('15087','2013-08-18','14:50:00',3.74),('15087','2013-08-18','14:55:00',3.64),('15087','2013-08-18','15:00:00',3.68),('15087','2013-08-18','15:05:00',3.61),('15087','2013-08-18','15:10:00',3.62),('15087','2013-08-18','15:15:00',3.57),('15087','2013-08-18','15:20:00',3.46),('15087','2013-08-18','15:25:00',3.09),('15087','2013-08-18','15:30:00',3.17),('15087','2013-08-18','15:35:00',3.22),('15087','2013-08-18','15:40:00',3.24),('15087','2013-08-18','15:45:00',3.12),('15087','2013-08-18','15:50:00',3.1),('15087','2013-08-18','15:55:00',3.07),('15087','2013-08-18','16:00:00',3.02),('15087','2013-08-18','16:05:00',2.94),('15087','2013-08-18','16:10:00',2.73),('15087','2013-08-18','16:15:00',2.5),('15087','2013-08-18','16:20:00',2.72),('15087','2013-08-18','16:25:00',2.68),('15087','2013-08-18','16:30:00',2.58),('15087','2013-08-18','16:35:00',2.5),('15087','2013-08-18','16:40:00',2.41),('15087','2013-08-18','16:45:00',2.34),('15087','2013-08-18','16:50:00',2.25),('15087','2013-08-18','16:55:00',2.21),('15087','2013-08-18','17:00:00',2.21),('15087','2013-08-18','17:05:00',2.09),('15087','2013-08-18','17:10:00',2.04),('15087','2013-08-18','17:15:00',1.92),('15087','2013-08-18','17:20:00',1.85),('15087','2013-08-18','17:25:00',1.78),('15087','2013-08-18','17:30:00',1.69),('15087','2013-08-18','17:35:00',1.59),('15087','2013-08-18','17:40:00',1.51),('15087','2013-08-18','17:45:00',1.35),('15087','2013-08-18','17:50:00',1.37),('15087','2013-08-18','17:55:00',1.31),('15087','2013-08-18','18:00:00',1.26),('15087','2013-08-18','18:05:00',1.22),('15087','2013-08-18','18:10:00',1.13),('15087','2013-08-18','18:15:00',1),('15087','2013-08-17','08:05:00',1.07),('15087','2013-08-17','08:10:00',1.15),('15087','2013-08-17','08:15:00',1.23),('15087','2013-08-17','08:20:00',1.32),('15087','2013-08-17','08:25:00',1.41),('15087','2013-08-17','08:30:00',1.5),('15087','2013-08-17','08:35:00',1.59),('15087','2013-08-17','08:40:00',1.69),('15087','2013-08-17','08:45:00',1.77),('15087','2013-08-17','08:50:00',1.87),('15087','2013-08-17','08:55:00',1.96),('15087','2013-08-17','09:00:00',2.07),('15087','2013-08-17','09:05:00',2.22),('15087','2013-08-17','09:10:00',2.28),('15087','2013-08-17','09:15:00',2.37),('15087','2013-08-17','09:20:00',2.49),('15087','2013-08-17','09:25:00',2.59),('15087','2013-08-17','09:30:00',2.66),('15087','2013-08-17','09:35:00',2.72),('15087','2013-08-17','09:40:00',2.79),('15087','2013-08-17','09:45:00',2.85),('15087','2013-08-17','09:50:00',2.91),('15087','2013-08-17','09:55:00',2.99),('15087','2013-08-17','10:00:00',3.05),('15087','2013-08-17','10:05:00',3.11),('15087','2013-08-17','10:10:00',3.16),('15087','2013-08-17','10:15:00',3.23),('15087','2013-08-17','10:20:00',3.29),('15087','2013-08-17','10:25:00',3.35),('15087','2013-08-17','10:30:00',3.4),('15087','2013-08-17','10:35:00',3.46),('15087','2013-08-17','10:40:00',3.5),('15087','2013-08-17','10:45:00',3.56),('15087','2013-08-17','10:50:00',3.6),('15087','2013-08-17','10:55:00',3.64),('15087','2013-08-17','11:00:00',3.61),('15087','2013-08-17','11:05:00',3.71),('15087','2013-08-17','11:10:00',3.74),('15087','2013-08-17','11:15:00',3.77),('15087','2013-08-17','11:20:00',3.84),('15087','2013-08-17','11:25:00',3.88),('15087','2013-08-17','11:30:00',3.87),('15087','2013-08-17','11:35:00',3.91),('15087','2013-08-17','11:40:00',3.97),('15087','2013-08-17','11:45:00',4.03),('15087','2013-08-17','11:50:00',3.95),('15087','2013-08-17','11:55:00',3.86),('15087','2013-08-17','12:00:00',4.02),('15087','2013-08-17','12:05:00',4.11),('15087','2013-08-17','12:10:00',4.09),('15087','2013-08-17','12:15:00',4.03),('15087','2013-08-17','12:20:00',4.01),('15087','2013-08-17','12:25:00',4.24),('15087','2013-08-17','12:30:00',4.28),('15087','2013-08-17','12:35:00',4.27),('15087','2013-08-17','12:40:00',3.89),('15087','2013-08-17','12:45:00',4.16),('15087','2013-08-17','12:50:00',4.27),('15087','2013-08-17','12:55:00',4.32),('15087','2013-08-17','13:00:00',4.35),('15087','2013-08-17','13:05:00',4.17),('15087','2013-08-17','13:10:00',2.22),('15087','2013-08-17','13:15:00',4.3),('15087','2013-08-17','13:20:00',4.44),('15087','2013-08-17','13:25:00',4.44),('15087','2013-08-17','13:30:00',4.44),('15087','2013-08-17','13:35:00',4.11),('15087','2013-08-17','13:40:00',1.27),('15087','2013-08-17','13:45:00',4.29),('15087','2013-08-17','13:50:00',1.79),('15087','2013-08-17','13:55:00',2.96),('15087','2013-08-17','14:00:00',4.19),('15087','2013-08-17','14:05:00',4.16),('15087','2013-08-17','14:10:00',3.66),('15087','2013-08-17','14:15:00',3.59),('15087','2013-08-17','14:20:00',4.16),('15087','2013-08-17','14:25:00',4.04),('15087','2013-08-17','14:30:00',3.99),('15087','2013-08-17','14:35:00',3.93),('15087','2013-08-17','14:40:00',3.81),('15087','2013-08-17','14:45:00',3.79),('15087','2013-08-17','14:50:00',3.82),('15087','2013-08-17','14:55:00',3.78),('15087','2013-08-17','15:00:00',3.72),('15087','2013-08-17','15:05:00',3.67),('15087','2013-08-17','15:10:00',3.6),('15087','2013-08-17','15:15:00',3.56),('15087','2013-08-17','15:20:00',3.55),('15087','2013-08-17','15:25:00',3.39),('15087','2013-08-17','15:30:00',3.23),('15087','2013-08-17','15:35:00',3.29),('15087','2013-08-17','15:40:00',3.29),('15087','2013-08-17','15:45:00',3.18),('15087','2013-08-17','15:50:00',3.13),('15087','2013-08-17','15:55:00',3.1),('15087','2013-08-17','16:00:00',3.05),('15087','2013-08-17','16:05:00',2.97),('15087','2013-08-17','16:10:00',2.92),('15087','2013-08-17','16:15:00',2.89),('15087','2013-08-17','16:20:00',2.83),('15087','2013-08-17','16:25:00',2.77),('15087','2013-08-17','16:30:00',2.73),('15087','2013-08-17','16:35:00',2.67),('15087','2013-08-17','16:40:00',2.52),('15087','2013-08-17','16:45:00',2.32),('15087','2013-08-17','16:50:00',2.34),('15087','2013-08-17','16:55:00',2.25),('15087','2013-08-17','17:00:00',2.08),('15087','2013-08-17','17:05:00',2.08),('15087','2013-08-17','17:10:00',1.96),('15087','2013-08-17','17:15:00',1.78),('15087','2013-08-17','17:20:00',1.81),('15087','2013-08-17','17:25:00',1.85),('15087','2013-08-17','17:30:00',1.8),('15087','2013-08-17','17:35:00',1.72),('15087','2013-08-17','17:40:00',1.52),('15087','2013-08-17','17:45:00',1.5),('15087','2013-08-17','17:50:00',1.46),('15087','2013-08-17','17:55:00',1.39),('15087','2013-08-17','18:00:00',1.36),('15087','2013-08-17','18:05:00',1.28),('15087','2013-08-17','18:10:00',1.21),('15087','2013-08-17','18:15:00',1.07),('15087','2013-08-16','08:00:00',1.02),('15087','2013-08-16','08:05:00',1.11),('15087','2013-08-16','08:10:00',1.2),('15087','2013-08-16','08:15:00',1.29),('15087','2013-08-16','08:20:00',1.39),('15087','2013-08-16','08:25:00',1.48),('15087','2013-08-16','08:30:00',1.57),('15087','2013-08-16','08:35:00',1.65),('15087','2013-08-16','08:40:00',1.76),('15087','2013-08-16','08:45:00',1.83),('15087','2013-08-16','08:50:00',1.92),('15087','2013-08-16','08:55:00',2.08),('15087','2013-08-16','09:00:00',2.19),('15087','2013-08-16','09:05:00',2.3),('15087','2013-08-16','09:10:00',2.4),('15087','2013-08-16','09:15:00',2.49),('15087','2013-08-16','09:20:00',2.58),('15087','2013-08-16','09:25:00',2.66),('15087','2013-08-16','09:30:00',2.71),('15087','2013-08-16','09:35:00',2.82),('15087','2013-08-16','09:40:00',2.89),('15087','2013-08-16','09:45:00',2.96),('15087','2013-08-16','09:50:00',3.04),('15087','2013-08-16','09:55:00',3.12),('15087','2013-08-16','10:00:00',3.18),('15087','2013-08-16','10:05:00',3.25),('15087','2013-08-16','10:10:00',3.3),('15087','2013-08-16','10:15:00',3.35),('15087','2013-08-16','10:20:00',3.42),('15087','2013-08-16','10:25:00',3.49),('15087','2013-08-16','10:30:00',3.54),('15087','2013-08-16','10:35:00',3.58),('15087','2013-08-16','10:40:00',3.63),('15087','2013-08-16','10:45:00',3.69),('15087','2013-08-16','10:50:00',3.75),('15087','2013-08-16','10:55:00',3.81),('15087','2013-08-16','11:00:00',3.84),('15087','2013-08-16','11:05:00',3.88),('15087','2013-08-16','11:10:00',3.94),('15087','2013-08-16','11:15:00',3.96),('15087','2013-08-16','11:20:00',3.97),('15087','2013-08-16','11:25:00',4.01),('15087','2013-08-16','11:30:00',4.02),('15087','2013-08-16','11:35:00',4.06),('15087','2013-08-16','11:40:00',4.1),('15087','2013-08-16','11:45:00',4.07),('15087','2013-08-16','11:50:00',4.11),('15087','2013-08-16','11:55:00',4.13),('15087','2013-08-16','12:00:00',4.13),('15087','2013-08-16','12:05:00',4.2),('15087','2013-08-16','12:10:00',4.22),('15087','2013-08-16','12:15:00',4.21),('15087','2013-08-16','12:20:00',4.23),('15087','2013-08-16','12:25:00',4.24),('15087','2013-08-16','12:30:00',4.27),('15087','2013-08-16','12:35:00',4.28),('15087','2013-08-16','12:40:00',4.28),('15087','2013-08-16','12:45:00',4.28),('15087','2013-08-16','12:50:00',4.29),('15087','2013-08-16','12:55:00',4.27),('15087','2013-08-16','13:00:00',4.26),('15087','2013-08-16','13:05:00',4.28),('15087','2013-08-16','13:10:00',4.26),('15087','2013-08-16','13:15:00',4.26),('15087','2013-08-16','13:20:00',4.26),('15087','2013-08-16','13:25:00',4.24),('15087','2013-08-16','13:30:00',4.25),('15087','2013-08-16','13:35:00',4.25),('15087','2013-08-16','13:40:00',4.23),('15087','2013-08-16','13:45:00',4.2),('15087','2013-08-16','13:50:00',4.22),('15087','2013-08-16','13:55:00',4.23),('15087','2013-08-16','14:00:00',4.11),('15087','2013-08-16','14:05:00',4.1),('15087','2013-08-16','14:10:00',4.07),('15087','2013-08-16','14:15:00',4.06),('15087','2013-08-16','14:20:00',3.99),('15087','2013-08-16','14:25:00',3.86),('15087','2013-08-16','14:30:00',3.85),('15087','2013-08-16','14:35:00',3.86),('15087','2013-08-16','14:40:00',3.86),('15087','2013-08-16','14:45:00',3.68),('15087','2013-08-16','14:50:00',3.73),('15087','2013-08-16','14:55:00',3.68),('15087','2013-08-16','15:00:00',3.62),('15087','2013-08-16','15:05:00',3.51),('15087','2013-08-16','15:10:00',3.42),('15087','2013-08-16','15:15:00',3.49),('15087','2013-08-16','15:20:00',3.52),('15087','2013-08-16','15:25:00',3.44),('15087','2013-08-16','15:30:00',3.31),('15087','2013-08-16','15:35:00',3.34),('15087','2013-08-16','15:40:00',3.28),('15087','2013-08-16','15:45:00',3.19),('15087','2013-08-16','15:50:00',3.06),('15087','2013-08-16','15:55:00',2.95),('15087','2013-08-16','16:00:00',2.84),('15087','2013-08-16','16:05:00',2.99),('15087','2013-08-16','16:10:00',2.95),('15087','2013-08-16','16:15:00',2.88),('15087','2013-08-16','16:20:00',2.81),('15087','2013-08-16','16:25:00',2.75),('15087','2013-08-16','16:30:00',2.71),('15087','2013-08-16','16:35:00',2.66),('15087','2013-08-16','16:40:00',2.52),('15087','2013-08-16','16:45:00',2.36),('15087','2013-08-16','16:50:00',2.38),('15087','2013-08-16','16:55:00',2.25),('15087','2013-08-16','17:00:00',2.2),('15087','2013-08-16','17:05:00',2.12),('15087','2013-08-16','17:10:00',2.05),('15087','2013-08-16','17:15:00',1.96),('15087','2013-08-16','17:20:00',1.85),('15087','2013-08-16','17:25:00',1.77),('15087','2013-08-16','17:30:00',1.69),('15087','2013-08-16','17:35:00',1.6),('15087','2013-08-16','17:40:00',1.51),('15087','2013-08-16','17:45:00',1.47),('15087','2013-08-16','17:50:00',1.38),('15087','2013-08-16','17:55:00',1.31),('15087','2013-08-16','18:00:00',1.26),('15087','2013-08-16','18:05:00',1.2),('15087','2013-08-16','18:10:00',1.12),('15087','2013-08-16','18:15:00',1.04),('15087','2013-08-15','08:05:00',1.1),('15087','2013-08-15','08:10:00',1.29),('15087','2013-08-15','08:15:00',1.3),('15087','2013-08-15','08:20:00',1.35),('15087','2013-08-15','08:25:00',1.54),('15087','2013-08-15','08:30:00',1.62),('15087','2013-08-15','08:35:00',1.71),('15087','2013-08-15','08:40:00',1.81),('15087','2013-08-15','08:45:00',1.93),('15087','2013-08-15','08:50:00',2.06),('15087','2013-08-15','08:55:00',2.12),('15087','2013-08-15','09:00:00',2.35),('15087','2013-08-15','09:05:00',2.25),('15087','2013-08-15','09:10:00',1.35),('15087','2013-08-15','09:15:00',2.09),('15087','2013-08-15','09:20:00',2.73),('15087','2013-08-15','09:25:00',2.66),('15087','2013-08-15','09:30:00',2.72),('15087','2013-08-15','09:35:00',2.8),('15087','2013-08-15','09:40:00',2.88),('15087','2013-08-15','09:45:00',2.96),('15087','2013-08-15','09:50:00',3.05),('15087','2013-08-15','09:55:00',3.12),('15087','2013-08-15','10:00:00',3.16),('15087','2013-08-15','10:05:00',3.25),('15087','2013-08-15','10:10:00',3.31),('15087','2013-08-15','10:15:00',3.38),('15087','2013-08-15','10:20:00',3.47),('15087','2013-08-15','10:25:00',3.53),('15087','2013-08-15','10:30:00',3.58),('15087','2013-08-15','10:35:00',3.63),('15087','2013-08-15','10:40:00',3.68),('15087','2013-08-15','10:45:00',3.73),('15087','2013-08-15','10:50:00',3.74),('15087','2013-08-15','10:55:00',3.45),('15087','2013-08-15','11:00:00',3.14),('15087','2013-08-15','11:05:00',3.32),('15087','2013-08-15','11:10:00',2.5),('15087','2013-08-15','11:15:00',2.39),('15087','2013-08-15','11:20:00',2.81),('15087','2013-08-15','11:25:00',3.28),('15087','2013-08-15','11:30:00',3.59),('15087','2013-08-15','11:35:00',4.02),('15087','2013-08-15','11:40:00',4.29),('15087','2013-08-15','11:45:00',4.4),('15087','2013-08-15','11:50:00',4.48),('15087','2013-08-15','11:55:00',4.49),('15087','2013-08-15','12:00:00',4.52),('15087','2013-08-15','12:05:00',4.48),('15087','2013-08-15','12:10:00',4.44),('15087','2013-08-15','12:15:00',4.42),('15087','2013-08-15','12:20:00',4.46),('15087','2013-08-15','12:25:00',4.47),('15087','2013-08-15','12:30:00',4.44),('15087','2013-08-15','12:35:00',4.47),('15087','2013-08-15','12:40:00',4.49),('15087','2013-08-15','12:45:00',4.46),('15087','2013-08-15','12:50:00',4.46),('15087','2013-08-15','12:55:00',4.36),('15087','2013-08-15','13:00:00',4.15),('15087','2013-08-15','13:05:00',4.25),('15087','2013-08-15','13:10:00',4.34),('15087','2013-08-15','13:15:00',4.23),('15087','2013-08-15','13:20:00',4.17),('15087','2013-08-15','13:25:00',4.26),('15087','2013-08-15','13:30:00',4.33),('15087','2013-08-15','13:35:00',4.4),('15087','2013-08-15','13:40:00',4.38),('15087','2013-08-15','13:45:00',4.35),('15087','2013-08-15','13:50:00',4.32),('15087','2013-08-15','13:55:00',4.25),('15087','2013-08-15','14:00:00',4.12),('15087','2013-08-15','14:05:00',4.17),('15087','2013-08-15','14:10:00',4.19),('15087','2013-08-15','14:15:00',4.19),('15087','2013-08-15','14:20:00',4.13),('15087','2013-08-15','14:25:00',3.94),('15087','2013-08-15','14:30:00',3.93),('15087','2013-08-15','14:35:00',3.87),('15087','2013-08-15','14:40:00',3.93),('15087','2013-08-15','14:45:00',3.79),('15087','2013-08-15','14:50:00',3.7),('15087','2013-08-15','14:55:00',3.75),('15087','2013-08-15','15:00:00',3.69),('15087','2013-08-15','15:05:00',3.61),('15087','2013-08-15','15:10:00',3.46),('15087','2013-08-15','15:15:00',3.52),('15087','2013-08-15','15:20:00',3.48),('15087','2013-08-15','15:25:00',3.44),('15087','2013-08-15','15:30:00',3.32),('15087','2013-08-15','15:35:00',3.27),('15087','2013-08-15','15:40:00',3.24),('15087','2013-08-15','15:45:00',3.16),('15087','2013-08-15','15:50:00',3.07),('15087','2013-08-15','15:55:00',3.01),('15087','2013-08-15','16:00:00',2.96),('15087','2013-08-15','16:05:00',2.96),('15087','2013-08-15','16:10:00',2.91),('15087','2013-08-15','16:15:00',2.76),('15087','2013-08-15','16:20:00',2.75),('15087','2013-08-15','16:25:00',2.47),('15087','2013-08-15','16:30:00',2.44),('15087','2013-08-15','16:35:00',2.41),('15087','2013-08-15','16:40:00',2.32),('15087','2013-08-15','16:45:00',2.22),('15087','2013-08-15','16:50:00',2.15),('15087','2013-08-15','16:55:00',2.24),('15087','2013-08-15','17:00:00',2.06),('15087','2013-08-15','17:05:00',1.99),('15087','2013-08-15','17:10:00',1.97),('15087','2013-08-15','17:15:00',1.86),('15087','2013-08-15','17:20:00',1.76),('15087','2013-08-15','17:25:00',1.7),('15087','2013-08-15','17:30:00',1.63),('15087','2013-08-15','17:35:00',1.57),('15087','2013-08-15','17:40:00',1.5),('15087','2013-08-15','17:45:00',1.43),('15087','2013-08-15','17:50:00',1.33),('15087','2013-08-15','17:55:00',1.31),('15087','2013-08-15','18:00:00',1.25),('15087','2013-08-15','18:05:00',1.16),('15087','2013-08-15','18:10:00',1.09),('15087','2013-08-14','08:00:00',1.02),('15087','2013-08-14','08:05:00',1.11),('15087','2013-08-14','08:10:00',1.19),('15087','2013-08-14','08:15:00',1.29),('15087','2013-08-14','08:20:00',1.35),('15087','2013-08-14','08:25:00',1.39),('15087','2013-08-14','08:30:00',1.52),('15087','2013-08-14','08:35:00',1.57),('15087','2013-08-14','08:40:00',1.56),('15087','2013-08-14','08:45:00',1.69),('15087','2013-08-14','08:50:00',1.84),('15087','2013-08-14','08:55:00',1.91),('15087','2013-08-14','09:00:00',2.09),('15087','2013-08-14','09:05:00',1.93),('15087','2013-08-14','09:10:00',2.3),('15087','2013-08-14','09:15:00',2.46),('15087','2013-08-14','09:20:00',2.59),('15087','2013-08-14','09:25:00',2.47),('15087','2013-08-14','09:30:00',2.74),('15087','2013-08-14','09:35:00',2.06),('15087','2013-08-14','09:40:00',1.24),('15087','2013-08-14','09:45:00',2.78),('15087','2013-08-14','09:50:00',2.32),('15087','2013-08-14','09:55:00',2.81),('15087','2013-08-14','10:00:00',3.12),('15087','2013-08-14','10:05:00',2.74),('15087','2013-08-14','10:10:00',1.56),('15087','2013-08-14','10:15:00',1.1),('15087','2013-08-14','10:20:00',2.66),('15087','2013-08-14','10:25:00',3.5),('15087','2013-08-14','10:30:00',3.86),('15087','2013-08-14','10:35:00',2.99),('15087','2013-08-14','10:40:00',1.51),('15087','2013-08-14','10:45:00',1.03),('15087','2013-08-14','10:50:00',1.05),('15087','2013-08-14','10:55:00',1.22),('15087','2013-08-14','11:00:00',3.57),('15087','2013-08-14','11:05:00',3.92),('15087','2013-08-14','11:10:00',3.73),('15087','2013-08-14','11:15:00',3.84),('15087','2013-08-14','11:20:00',3.61),('15087','2013-08-14','11:25:00',3.78),('15087','2013-08-14','11:30:00',4.38),('15087','2013-08-14','11:35:00',3.32),('15087','2013-08-14','11:40:00',1.65),('15087','2013-08-14','11:45:00',1.46),('15087','2013-08-14','11:50:00',1.82),('15087','2013-08-14','11:55:00',4.12),('15087','2013-08-14','12:00:00',4.09),('15087','2013-08-14','12:05:00',2.93),('15087','2013-08-14','12:10:00',1.62),('15087','2013-08-14','12:15:00',1.34),('15087','2013-08-14','12:20:00',1.17),('15087','2013-08-14','12:25:00',1.86),('15087','2013-08-14','12:30:00',1.2),('15087','2013-08-14','12:35:00',1.28),('15087','2013-08-14','12:40:00',1.47),('15087','2013-08-14','12:45:00',1.98),('15087','2013-08-14','12:50:00',2.38),('15087','2013-08-14','12:55:00',2.98),('15087','2013-08-14','13:00:00',2.72),('15087','2013-08-14','13:05:00',1.07),('15087','2013-08-14','13:10:00',1.14),('15087','2013-08-14','13:15:00',1.46),('15087','2013-08-14','13:20:00',1.28),('15087','2013-08-14','13:25:00',3.39),('15087','2013-08-14','13:30:00',3.72),('15087','2013-08-14','13:35:00',1.96),('15087','2013-08-14','13:40:00',3),('15087','2013-08-14','13:45:00',4.51),('15087','2013-08-14','13:50:00',3.71),('15087','2013-08-14','13:55:00',3),('15087','2013-08-14','14:00:00',4.78),('15087','2013-08-14','14:05:00',4.4),('15087','2013-08-14','14:10:00',3.24),('15087','2013-08-14','14:15:00',4.47),('15087','2013-08-14','14:20:00',3.78),('15087','2013-08-14','14:25:00',3.61),('15087','2013-08-14','14:30:00',4.35),('15087','2013-08-14','14:35:00',4.17),('15087','2013-08-14','14:40:00',3.94),('15087','2013-08-14','14:45:00',3.96),('15087','2013-08-14','14:50:00',4.03),('15087','2013-08-14','14:55:00',3.96),('15087','2013-08-14','15:00:00',3.82),('15087','2013-08-14','15:05:00',3.67),('15087','2013-08-14','15:10:00',3.62),('15087','2013-08-14','15:15:00',3.73),('15087','2013-08-14','15:20:00',3.69),('15087','2013-08-14','15:25:00',3.4),('15087','2013-08-14','15:30:00',3.31),('15087','2013-08-14','15:35:00',3.36),('15087','2013-08-14','15:40:00',3.35),('15087','2013-08-14','15:45:00',3.26),('15087','2013-08-14','15:50:00',3.15),('15087','2013-08-14','15:55:00',3.03),('15087','2013-08-14','16:00:00',2.87),('15087','2013-08-14','16:05:00',3.01),('15087','2013-08-14','16:10:00',3.01),('15087','2013-08-14','16:15:00',2.99),('15087','2013-08-14','16:20:00',2.92),('15087','2013-08-14','16:25:00',2.8),('15087','2013-08-14','16:30:00',2.75),('15087','2013-08-14','16:35:00',2.71),('15087','2013-08-14','16:40:00',2.67),('15087','2013-08-14','16:45:00',2.59),('15087','2013-08-14','16:50:00',2.51),('15087','2013-08-14','16:55:00',2.36),('15087','2013-08-14','17:00:00',2.12),('15087','2013-08-14','17:05:00',2.16),('15087','2013-08-14','17:10:00',2.08),('15087','2013-08-14','17:15:00',2),('15087','2013-08-14','17:20:00',1.91),('15087','2013-08-14','17:25:00',1.81),('15087','2013-08-14','17:30:00',1.71),('15087','2013-08-14','17:35:00',1.57),('15087','2013-08-14','17:40:00',1.56),('15087','2013-08-14','17:45:00',1.4),('15087','2013-08-14','17:50:00',1.45),('15087','2013-08-14','17:55:00',1.35),('15087','2013-08-14','18:00:00',1.28),('15087','2013-08-14','18:05:00',1.26),('15087','2013-08-14','18:10:00',1.15),('15087','2013-08-14','18:15:00',1.09),('15087','2013-08-14','18:20:00',1.02),('15087','2013-08-13','08:00:00',1.06),('15087','2013-08-13','08:05:00',1.07),('15087','2013-08-13','08:10:00',1.22),('15087','2013-08-13','08:15:00',1.3),('15087','2013-08-13','08:20:00',1.38),('15087','2013-08-13','08:25:00',1.48),('15087','2013-08-13','08:30:00',1.57),('15087','2013-08-13','08:35:00',1.65),('15087','2013-08-13','08:40:00',1.75),('15087','2013-08-13','08:45:00',1.82),('15087','2013-08-13','08:50:00',1.94),('15087','2013-08-13','08:55:00',2.05),('15087','2013-08-13','09:00:00',2.17),('15087','2013-08-13','09:05:00',2.29),('15087','2013-08-13','09:10:00',2.39),('15087','2013-08-13','09:15:00',2.47),('15087','2013-08-13','09:20:00',2.54),('15087','2013-08-13','09:25:00',2.61),('15087','2013-08-13','09:30:00',2.72),('15087','2013-08-13','09:35:00',2.8),('15087','2013-08-13','09:40:00',2.81),('15087','2013-08-13','09:45:00',2.89),('15087','2013-08-13','09:50:00',2.97),('15087','2013-08-13','09:55:00',3.07),('15087','2013-08-13','10:00:00',3.12),('15087','2013-08-13','10:05:00',3.18),('15087','2013-08-13','10:10:00',2.94),('15087','2013-08-13','10:15:00',3.26),('15087','2013-08-13','10:20:00',3.34),('15087','2013-08-13','10:25:00',3.46),('15087','2013-08-13','10:30:00',3.5),('15087','2013-08-13','10:35:00',3.49),('15087','2013-08-13','10:40:00',3.5),('15087','2013-08-13','10:45:00',3.51),('15087','2013-08-13','10:50:00',3.64),('15087','2013-08-13','10:55:00',3.66),('15087','2013-08-13','11:00:00',3.74),('15087','2013-08-13','11:05:00',3.77),('15087','2013-08-13','11:10:00',3.78),('15087','2013-08-13','11:15:00',3.83),('15087','2013-08-13','11:20:00',3.89),('15087','2013-08-13','11:25:00',3.91),('15087','2013-08-13','11:30:00',3.92),('15087','2013-08-13','11:35:00',3.92),('15087','2013-08-13','11:40:00',3.94),('15087','2013-08-13','11:45:00',3.95),('15087','2013-08-13','11:50:00',4.05),('15087','2013-08-13','11:55:00',4.12),('15087','2013-08-13','12:00:00',3.25),('15087','2013-08-13','12:05:00',4.15),('15087','2013-08-13','12:10:00',4.31),('15087','2013-08-13','12:15:00',4.43),('15087','2013-08-13','12:20:00',4.38),('15087','2013-08-13','12:25:00',4.48),('15087','2013-08-13','12:30:00',4.53),('15087','2013-08-13','12:35:00',3.46),('15087','2013-08-13','12:40:00',2.21),('15087','2013-08-13','12:45:00',1.33),('15087','2013-08-13','12:50:00',2.59),('15087','2013-08-13','12:55:00',1.87),('15087','2013-08-13','13:00:00',1.32),('15087','2013-08-13','13:05:00',1.75),('15087','2013-08-13','13:10:00',4.88),('15087','2013-08-13','13:15:00',3.75),('15087','2013-08-13','13:20:00',3.44),('15087','2013-08-13','13:25:00',1.3),('15087','2013-08-13','13:30:00',2.27),('15087','2013-08-13','13:35:00',4.85),('15087','2013-08-13','13:40:00',3.04),('15087','2013-08-13','13:45:00',1.43),('15087','2013-08-13','13:50:00',1.45),('15087','2013-08-13','13:55:00',3.63),('15087','2013-08-13','14:00:00',4.75),('15087','2013-08-13','14:05:00',4.18),('15087','2013-08-13','14:10:00',4.49),('15087','2013-08-13','14:15:00',4.25),('15087','2013-08-13','14:20:00',4.28),('15087','2013-08-13','14:25:00',4.05),('15087','2013-08-13','14:30:00',4.68),('15087','2013-08-13','14:35:00',3.66),('15087','2013-08-13','14:40:00',3.68),('15087','2013-08-13','14:45:00',2.3),('15087','2013-08-13','14:50:00',2.4),('15087','2013-08-13','14:55:00',3.92),('15087','2013-08-13','15:00:00',3.96),('15087','2013-08-13','15:05:00',2.94),('15087','2013-08-13','15:10:00',3.91),('15087','2013-08-13','15:15:00',3.73),('15087','2013-08-13','15:20:00',3.39),('15087','2013-08-13','15:25:00',3.61),('15087','2013-08-13','15:30:00',3.46),('15087','2013-08-13','15:35:00',3.26),('15087','2013-08-13','15:40:00',3.41),('15087','2013-08-13','15:45:00',3.33),('15087','2013-08-13','15:50:00',3.2),('15087','2013-08-13','15:55:00',3.05),('15087','2013-08-13','16:00:00',3.01),('15087','2013-08-13','16:05:00',3.04),('15087','2013-08-13','16:10:00',2.98),('15087','2013-08-13','16:15:00',2.92),('15087','2013-08-13','16:20:00',2.87),('15087','2013-08-13','16:25:00',2.79),('15087','2013-08-13','16:30:00',2.75),('15087','2013-08-13','16:35:00',2.53),('15087','2013-08-13','16:40:00',2.45),('15087','2013-08-13','16:45:00',2.42),('15087','2013-08-13','16:50:00',2.47),('15087','2013-08-13','16:55:00',2.35),('15087','2013-08-13','17:00:00',2.25),('15087','2013-08-13','17:05:00',2.19),('15087','2013-08-13','17:10:00',2.09),('15087','2013-08-13','17:15:00',1.99),('15087','2013-08-13','17:20:00',1.92),('15087','2013-08-13','17:25:00',1.83),('15087','2013-08-13','17:30:00',1.7),('15087','2013-08-13','17:35:00',1.61),('15087','2013-08-13','17:40:00',1.58),('15087','2013-08-13','17:45:00',1.52),('15087','2013-08-13','17:50:00',1.44),('15087','2013-08-13','17:55:00',1.31),('15087','2013-08-13','18:00:00',1.28),('15087','2013-08-13','18:05:00',1.23),('15087','2013-08-13','18:10:00',1.15),('15087','2013-08-13','18:15:00',1.07),('15087','2013-08-12','08:00:00',1.05),('15087','2013-08-12','08:05:00',1.13),('15087','2013-08-12','08:10:00',1.21),('15087','2013-08-12','08:15:00',1.3),('15087','2013-08-12','08:20:00',1.38),('15087','2013-08-12','08:25:00',1.46),('15087','2013-08-12','08:30:00',1.54),('15087','2013-08-12','08:35:00',1.64),('15087','2013-08-12','08:40:00',1.73),('15087','2013-08-12','08:45:00',1.81),('15087','2013-08-12','08:50:00',1.89),('15087','2013-08-12','08:55:00',1.97),('15087','2013-08-12','09:00:00',2.05),('15087','2013-08-12','09:05:00',2.16),('15087','2013-08-12','09:10:00',2.28),('15087','2013-08-12','09:15:00',2.42),('15087','2013-08-12','09:20:00',2.52),('15087','2013-08-12','09:25:00',2.58),('15087','2013-08-12','09:30:00',2.65),('15087','2013-08-12','09:35:00',2.74),('15087','2013-08-12','09:40:00',2.8),('15087','2013-08-12','09:45:00',2.87),('15087','2013-08-12','09:50:00',2.93),('15087','2013-08-12','09:55:00',2.98),('15087','2013-08-12','10:00:00',3.05),('15087','2013-08-12','10:05:00',3.12),('15087','2013-08-12','10:10:00',3.16),('15087','2013-08-12','10:15:00',3.21),('15087','2013-08-12','10:20:00',3.28),('15087','2013-08-12','10:25:00',3.35),('15087','2013-08-12','10:30:00',3.37),('15087','2013-08-12','10:35:00',3.41),('15087','2013-08-12','10:40:00',3.5),('15087','2013-08-12','10:45:00',3.56),('15087','2013-08-12','10:50:00',3.6),('15087','2013-08-12','10:55:00',3.63),('15087','2013-08-12','11:00:00',3.65),('15087','2013-08-12','11:05:00',3.71),('15087','2013-08-12','11:10:00',3.72),('15087','2013-08-12','11:15:00',3.76),('15087','2013-08-12','11:20:00',3.82),('15087','2013-08-12','11:25:00',3.86),('15087','2013-08-12','11:30:00',3.92),('15087','2013-08-12','11:35:00',3.98),('15087','2013-08-12','11:40:00',3.99),('15087','2013-08-12','11:45:00',4.04),('15087','2013-08-12','11:50:00',4.14),('15087','2013-08-12','11:55:00',3.53),('15087','2013-08-12','12:00:00',4.26),('15087','2013-08-12','12:05:00',4.24),('15087','2013-08-12','12:10:00',4.15),('15087','2013-08-12','12:15:00',1.39),('15087','2013-08-12','12:20:00',2.47),('15087','2013-08-12','12:25:00',1.58),('15087','2013-08-12','12:30:00',1.98),('15087','2013-08-12','12:35:00',4.09),('15087','2013-08-12','12:40:00',2.83),('15087','2013-08-12','12:45:00',1.31),('15087','2013-08-12','12:50:00',1.28),('15087','2013-08-12','12:55:00',1.93),('15087','2013-08-12','13:15:00',1.04),('15087','2013-08-12','13:20:00',1.33),('15087','2013-08-12','13:25:00',1.52),('15087','2013-08-12','13:30:00',1.31),('15087','2013-08-12','13:35:00',1.33),('15087','2013-08-12','13:40:00',1.17),('15087','2013-08-12','13:45:00',1.26),('15087','2013-08-12','13:50:00',4.67),('15087','2013-08-12','13:55:00',3.42),('15087','2013-08-12','14:00:00',4.46),('15087','2013-08-12','14:05:00',4.32),('15087','2013-08-12','14:10:00',1.27),('15087','2013-08-12','14:15:00',1.05),('15087','2013-08-12','14:35:00',1.16),('15087','2013-08-12','14:40:00',1.23),('15087','2013-08-12','14:45:00',1.8),('15087','2013-08-12','14:50:00',3.08),('15087','2013-08-12','14:55:00',4.2),('15087','2013-08-12','15:00:00',4.26),('15087','2013-08-12','15:05:00',3.74),('15087','2013-08-12','15:10:00',2.93),('15087','2013-08-12','15:15:00',2.39),('15087','2013-08-12','15:20:00',3.23),('15087','2013-08-12','15:25:00',3.7),('15087','2013-08-12','15:30:00',3.56),('15087','2013-08-12','15:35:00',3.38),('15087','2013-08-12','15:40:00',3.21),('15087','2013-08-12','15:45:00',3.29),('15087','2013-08-12','15:50:00',3.27),('15087','2013-08-12','15:55:00',3.1),('15087','2013-08-12','16:00:00',3.04),('15087','2013-08-12','16:05:00',3.01),('15087','2013-08-12','16:10:00',2.96),('15087','2013-08-12','16:15:00',2.88),('15087','2013-08-12','16:20:00',2.85),('15087','2013-08-12','16:25:00',2.6),('15087','2013-08-12','16:30:00',2.62),('15087','2013-08-12','16:35:00',2.57),('15087','2013-08-12','16:40:00',2.34),('15087','2013-08-12','16:45:00',2.4),('15087','2013-08-12','16:50:00',2.42),('15087','2013-08-12','16:55:00',2.43),('15087','2013-08-12','17:00:00',2.25),('15087','2013-08-12','17:05:00',2.2),('15087','2013-08-12','17:10:00',2.03),('15087','2013-08-12','17:15:00',1.96),('15087','2013-08-12','17:20:00',1.89),('15087','2013-08-12','17:25:00',1.81),('15087','2013-08-12','17:30:00',1.69),('15087','2013-08-12','17:35:00',1.59),('15087','2013-08-12','17:40:00',1.56),('15087','2013-08-12','17:45:00',1.48),('15087','2013-08-12','17:50:00',1.38),('15087','2013-08-12','17:55:00',1.31),('15087','2013-08-12','18:00:00',1.26),('15087','2013-08-12','18:05:00',1.19),('15087','2013-08-12','18:10:00',1.11),('15087','2013-08-12','18:15:00',1.07),('15087','2013-08-12','18:20:00',1.01),('15087','2013-08-11','07:55:00',1),('15087','2013-08-11','08:00:00',1.09),('15087','2013-08-11','08:05:00',1.18),('15087','2013-08-11','08:10:00',1.26),('15087','2013-08-11','08:15:00',1.36),('15087','2013-08-11','08:20:00',1.44),('15087','2013-08-11','08:25:00',1.51),('15087','2013-08-11','08:30:00',1.61),('15087','2013-08-11','08:35:00',1.68),('15087','2013-08-11','08:40:00',1.79),('15087','2013-08-11','08:45:00',1.88),('15087','2013-08-11','08:50:00',1.97),('15087','2013-08-11','08:55:00',2.1),('15087','2013-08-11','09:00:00',2.21),('15087','2013-08-11','09:05:00',2.29),('15087','2013-08-11','09:10:00',2.4),('15087','2013-08-11','09:15:00',2.5),('15087','2013-08-11','09:20:00',2.58),('15087','2013-08-11','09:25:00',2.65),('15087','2013-08-11','09:30:00',2.73),('15087','2013-08-11','09:35:00',2.81),('15087','2013-08-11','09:40:00',2.88),('15087','2013-08-11','09:45:00',2.94),('15087','2013-08-11','09:50:00',3.02),('15087','2013-08-11','09:55:00',3.09),('15087','2013-08-11','10:00:00',3.16),('15087','2013-08-11','10:05:00',3.23),('15087','2013-08-11','10:10:00',3.3),('15087','2013-08-11','10:15:00',3.36),('15087','2013-08-11','10:20:00',3.4),('15087','2013-08-11','10:25:00',3.47),('15087','2013-08-11','10:30:00',3.52),('15087','2013-08-11','10:35:00',3.58),('15087','2013-08-11','10:40:00',3.59),('15087','2013-08-11','10:45:00',3.64),('15087','2013-08-11','10:50:00',3.7),('15087','2013-08-11','10:55:00',3.76),('15087','2013-08-11','11:00:00',3.81),('15087','2013-08-11','11:05:00',3.88),('15087','2013-08-11','11:10:00',3.91),('15087','2013-08-11','11:15:00',3.97),('15087','2013-08-11','11:20:00',3.98),('15087','2013-08-11','11:25:00',4.02),('15087','2013-08-11','11:30:00',4.08),('15087','2013-08-11','11:35:00',4.09),('15087','2013-08-11','11:40:00',4.09),('15087','2013-08-11','11:45:00',4.11),('15087','2013-08-11','11:50:00',4.11),('15087','2013-08-11','11:55:00',4.17),('15087','2013-08-11','12:00:00',4.24),('15087','2013-08-11','12:05:00',4.24),('15087','2013-08-11','12:10:00',4.28),('15087','2013-08-11','12:15:00',4.28),('15087','2013-08-11','12:20:00',4.26),('15087','2013-08-11','12:25:00',4.27),('15087','2013-08-11','12:30:00',4.3),('15087','2013-08-11','12:35:00',4.31),('15087','2013-08-11','12:40:00',4.32),('15087','2013-08-11','12:45:00',4.35),('15087','2013-08-11','12:50:00',4.3),('15087','2013-08-11','12:55:00',4.29),('15087','2013-08-11','13:00:00',4.32),('15087','2013-08-11','13:05:00',4.33),('15087','2013-08-11','13:10:00',4.33),('15087','2013-08-11','13:15:00',4.3),('15087','2013-08-11','13:20:00',4.23),('15087','2013-08-11','13:25:00',4.26),('15087','2013-08-11','13:30:00',4.28),('15087','2013-08-11','13:35:00',4.33),('15087','2013-08-11','13:40:00',4.31),('15087','2013-08-11','13:45:00',4.32),('15087','2013-08-11','13:50:00',4.24),('15087','2013-08-11','13:55:00',4.23),('15087','2013-08-11','14:00:00',4.22),('15087','2013-08-11','14:05:00',4.13),('15087','2013-08-11','14:10:00',4.04),('15087','2013-08-11','14:15:00',4.12),('15087','2013-08-11','14:20:00',4.06),('15087','2013-08-11','14:25:00',4.05),('15087','2013-08-11','14:30:00',3.91),('15087','2013-08-11','14:35:00',3.76),('15087','2013-08-11','14:40:00',3.86),('15087','2013-08-11','14:45:00',3.91),('15087','2013-08-11','14:50:00',3.87),('15087','2013-08-11','14:55:00',3.65),('15087','2013-08-11','15:00:00',2.96),('15087','2013-08-11','15:05:00',3.52),('15087','2013-08-11','15:10:00',3.3),('15087','2013-08-11','15:15:00',3.43),('15087','2013-08-11','15:20:00',3.29),('15087','2013-08-11','15:25:00',3.2),('15087','2013-08-11','15:30:00',2.87),('15087','2013-08-11','15:35:00',3.26),('15087','2013-08-11','15:40:00',3.21),('15087','2013-08-11','15:45:00',3.19),('15087','2013-08-11','15:50:00',3.21),('15087','2013-08-11','15:55:00',3.16),('15087','2013-08-11','16:00:00',3.07),('15087','2013-08-11','16:05:00',3.03),('15087','2013-08-11','16:10:00',2.98),('15087','2013-08-11','16:15:00',2.93),('15087','2013-08-11','16:20:00',2.86),('15087','2013-08-11','16:25:00',2.8),('15087','2013-08-11','16:30:00',2.72),('15087','2013-08-11','16:35:00',2.55),('15087','2013-08-11','16:40:00',2.37),('15087','2013-08-11','16:45:00',2.42),('15087','2013-08-11','16:50:00',2.38),('15087','2013-08-11','16:55:00',2.3),('15087','2013-08-11','17:00:00',2.17),('15087','2013-08-11','17:05:00',2.05),('15087','2013-08-11','17:10:00',1.97),('15087','2013-08-11','17:15:00',1.98),('15087','2013-08-11','17:20:00',1.91),('15087','2013-08-11','17:25:00',1.81),('15087','2013-08-11','17:30:00',1.67),('15087','2013-08-11','17:35:00',1.6),('15087','2013-08-11','17:40:00',1.56),('15087','2013-08-11','17:45:00',1.49),('15087','2013-08-11','17:50:00',1.39),('15087','2013-08-11','17:55:00',1.32),('15087','2013-08-11','18:00:00',1.27),('15087','2013-08-11','18:05:00',1.21),('15087','2013-08-11','18:10:00',1.1),('15087','2013-08-11','18:15:00',1.05),('15087','2013-08-10','07:55:00',1.01),('15087','2013-08-10','08:00:00',1.1),('15087','2013-08-10','08:05:00',1.2),('15087','2013-08-10','08:10:00',1.29),('15087','2013-08-10','08:15:00',1.39),('15087','2013-08-10','08:20:00',1.51),('15087','2013-08-10','08:25:00',1.59),('15087','2013-08-10','08:30:00',1.7),('15087','2013-08-10','08:35:00',1.77),('15087','2013-08-10','08:40:00',1.84),('15087','2013-08-10','08:45:00',1.95),('15087','2013-08-10','08:50:00',2.08),('15087','2013-08-10','08:55:00',2.21),('15087','2013-08-10','09:00:00',2.26),('15087','2013-08-10','09:05:00',2.35),('15087','2013-08-10','09:10:00',2.44),('15087','2013-08-10','09:15:00',2.55),('15087','2013-08-10','09:20:00',2.63),('15087','2013-08-10','09:25:00',2.7),('15087','2013-08-10','09:30:00',2.78),('15087','2013-08-10','09:35:00',2.85),('15087','2013-08-10','09:40:00',2.91),('15087','2013-08-10','09:45:00',2.93),('15087','2013-08-10','09:50:00',3.05),('15087','2013-08-10','09:55:00',3.12),('15087','2013-08-10','10:00:00',3.17),('15087','2013-08-10','10:05:00',3.24),('15087','2013-08-10','10:10:00',3.3),('15087','2013-08-10','10:15:00',3.34),('15087','2013-08-10','10:20:00',3.41),('15087','2013-08-10','10:25:00',3.46),('15087','2013-08-10','10:30:00',3.52),('15087','2013-08-10','10:35:00',3.59),('15087','2013-08-10','10:40:00',3.61),('15087','2013-08-10','10:45:00',3.66),('15087','2013-08-10','10:50:00',3.73),('15087','2013-08-10','10:55:00',3.79),('15087','2013-08-10','11:00:00',3.9),('15087','2013-08-10','11:05:00',3.96),('15087','2013-08-10','11:10:00',4.02),('15087','2013-08-10','11:15:00',4.05),('15087','2013-08-10','11:20:00',3.8),('15087','2013-08-10','11:25:00',3.22),('15087','2013-08-10','11:30:00',4.12),('15087','2013-08-10','11:35:00',3.88),('15087','2013-08-10','11:40:00',4.16),('15087','2013-08-10','11:45:00',4.19),('15087','2013-08-10','11:50:00',4.21),('15087','2013-08-10','11:55:00',4.25),('15087','2013-08-10','12:00:00',4.28),('15087','2013-08-10','12:05:00',4.33),('15087','2013-08-10','12:10:00',4.35),('15087','2013-08-10','12:15:00',4.31),('15087','2013-08-10','12:20:00',4.3),('15087','2013-08-10','12:25:00',4.35),('15087','2013-08-10','12:30:00',4.37),('15087','2013-08-10','12:35:00',4.38),('15087','2013-08-10','12:40:00',4.44),('15087','2013-08-10','12:45:00',4.45),('15087','2013-08-10','12:50:00',4.59),('15087','2013-08-10','12:55:00',4.55),('15087','2013-08-10','13:00:00',4.52),('15087','2013-08-10','13:05:00',4.44),('15087','2013-08-10','13:10:00',4.49),('15087','2013-08-10','13:15:00',4.67),('15087','2013-08-10','13:20:00',4.62),('15087','2013-08-10','13:25:00',4.77),('15087','2013-08-10','13:30:00',4.88),('15087','2013-08-10','13:35:00',3.35),('15087','2013-08-10','13:40:00',1.47),('15087','2013-08-10','13:50:00',1.8),('15087','2013-08-10','13:55:00',4.35),('15087','2013-08-10','14:00:00',4.74),('15087','2013-08-10','14:05:00',4.96),('15087','2013-08-10','14:10:00',2.92),('15087','2013-08-10','14:15:00',4.71),('15087','2013-08-10','14:20:00',2.74),('15087','2013-08-10','14:25:00',1.35),('15087','2013-08-10','14:30:00',1.25),('15087','2013-08-10','14:35:00',1.1),('15087','2013-08-10','14:40:00',1.01),('15087','2013-08-10','15:00:00',1.02),('15087','2013-08-10','15:05:00',1.07),('15087','2013-08-10','15:10:00',1.13),('15087','2013-08-10','15:15:00',1.25),('15087','2013-08-10','15:20:00',1.24),('15087','2013-08-10','15:25:00',1.1),('15087','2013-08-10','15:30:00',1.07),('15087','2013-08-10','15:35:00',1.36),('15087','2013-08-10','15:40:00',1.31),('15087','2013-08-10','15:45:00',1.48),('15087','2013-08-10','15:50:00',1.98),('15087','2013-08-10','15:55:00',2.35),('15087','2013-08-10','16:00:00',2.41),('15087','2013-08-10','16:05:00',4.36),('15087','2013-08-10','16:10:00',2.67),('15087','2013-08-10','16:15:00',2.32),('15087','2013-08-10','16:20:00',2.97),('15087','2013-08-10','16:25:00',1.13),('15087','2013-08-10','16:30:00',2.1),('15087','2013-08-10','16:35:00',2.38),('15087','2013-08-10','16:40:00',2.5),('15087','2013-08-10','16:45:00',2.86),('15087','2013-08-10','16:50:00',2.73),('15087','2013-08-10','16:55:00',2.57),('15087','2013-08-10','17:00:00',1.71),('15087','2013-08-10','17:05:00',1.64),('15087','2013-08-10','17:10:00',1.08),('15087','2013-08-10','17:15:00',1.16),('15087','2013-08-10','17:20:00',1.22),('15087','2013-08-10','17:25:00',1.62),('15087','2013-08-10','17:30:00',1.08),('15087','2014-04-09','08:05:00',1.08),('15087','2014-04-09','08:20:00',1.15),('15087','2014-04-09','09:00:00',1.04),('15087','2014-04-09','09:30:00',1.01),('15087','2014-04-09','09:50:00',2.53),('15087','2014-04-09','09:55:00',3.1),('15087','2014-04-09','10:00:00',3.13),('15087','2014-04-09','10:05:00',3.14),('15087','2014-04-09','10:10:00',3.24),('15087','2014-04-09','10:15:00',3.05),('15087','2014-04-09','10:20:00',3.52),('15087','2014-04-09','10:25:00',3.75),('15087','2014-04-09','10:30:00',3.97),('15087','2014-04-09','10:35:00',2.84),('15087','2014-04-09','10:40:00',1.47),('15087','2014-04-09','10:45:00',2.34),('15087','2014-04-09','10:50:00',1.24),('15087','2014-04-09','10:55:00',3.95),('15087','2014-04-09','11:00:00',3.93),('15087','2014-04-09','11:05:00',4.53),('15087','2014-04-09','11:10:00',4.6),('15087','2014-04-09','11:15:00',4.72),('15087','2014-04-09','11:20:00',3.43),('15087','2014-04-09','11:25:00',1.63),('15087','2014-04-09','11:30:00',1.3),('15087','2014-04-09','11:35:00',4.8),('15087','2014-04-09','11:40:00',4.74),('15087','2014-04-09','11:45:00',2.71),('15087','2014-04-09','11:50:00',3.9),('15087','2014-04-09','11:55:00',4.98),('15087','2014-04-09','12:00:00',5.07),('15087','2014-04-09','12:05:00',5.1),('15087','2014-04-09','12:10:00',4.25),('15087','2014-04-09','12:15:00',2.14),('15087','2014-04-09','12:20:00',1.52),('15087','2014-04-09','12:25:00',1.11),('15087','2014-04-09','13:15:00',1.08),('15087','2014-04-09','13:20:00',1.5),('15087','2014-04-09','13:25:00',1.45),('15087','2014-04-09','13:30:00',1.16),('15087','2014-04-09','13:35:00',1.18),('15087','2014-04-09','14:00:00',1.08),('15087','2014-04-09','14:05:00',1.5),('15087','2014-04-09','14:10:00',1.64),('15087','2014-04-09','14:15:00',1.58),('15087','2014-04-09','14:20:00',1.41),('15087','2014-04-09','14:25:00',1.46),('15087','2014-04-09','14:30:00',1.74),('15087','2014-04-09','14:35:00',2.39),('15087','2014-04-09','14:40:00',2.18),('15087','2014-04-09','14:45:00',2.31),('15087','2014-04-09','14:50:00',2.31),('15087','2014-04-09','14:55:00',2.98),('15087','2014-04-09','15:00:00',2.05),('15087','2014-04-09','15:05:00',3.91),('15087','2014-04-09','15:10:00',4.35),('15087','2014-04-09','15:15:00',3.33),('15087','2014-04-09','15:20:00',4.26),('15087','2014-04-09','15:25:00',3.14),('15087','2014-04-09','15:30:00',2.23),('15087','2014-04-09','15:35:00',2.53),('15087','2014-04-09','15:40:00',2.46),('15087','2014-04-09','15:45:00',1.78),('15087','2014-04-09','15:50:00',1.35),('15087','2014-04-09','15:55:00',1.24),('15087','2014-04-09','16:00:00',1.48),('15087','2014-04-09','16:05:00',1.94),('15087','2014-04-09','16:10:00',2.79),('15087','2014-04-09','16:15:00',2.98),('15087','2014-04-09','16:20:00',2.85),('15087','2014-04-09','16:25:00',2.5),('15087','2014-04-09','16:30:00',3.11),('15087','2014-04-09','16:35:00',3.24),('15087','2014-04-09','16:40:00',2.47),('15087','2014-04-09','16:45:00',2.83),('15087','2014-04-09','16:50:00',2.55),('15087','2014-04-09','16:55:00',2.09),('15087','2014-04-09','17:00:00',2.13),('15087','2014-04-09','17:05:00',2.6),('15087','2014-04-09','17:10:00',2.11),('15087','2014-04-09','17:15:00',1.87),('15087','2014-04-09','17:20:00',1.76),('15087','2014-04-09','17:25:00',1.67),('15087','2014-04-09','17:30:00',1.41),('15087','2014-04-09','17:45:00',1.19),('15087','2014-04-09','17:50:00',1.21),('15087','2014-04-09','17:55:00',1.16),('15087','2013-08-09','08:05:00',1.03),('15087','2013-08-09','08:35:00',1.15),('15087','2013-08-09','08:40:00',1.67),('15087','2013-08-09','08:45:00',1.74),('15087','2013-08-09','08:50:00',1.78),('15087','2013-08-09','08:55:00',1.92),('15087','2013-08-09','09:00:00',1.98),('15087','2013-08-09','09:05:00',2.15),('15087','2013-08-09','09:10:00',1.98),('15087','2013-08-09','09:15:00',2.45),('15087','2013-08-09','09:20:00',1.74),('15087','2013-08-09','09:25:00',1.71),('15087','2013-08-09','09:30:00',1.61),('15087','2013-08-09','09:35:00',2.22),('15087','2013-08-09','09:40:00',2.22),('15087','2013-08-09','09:45:00',2.69),('15087','2013-08-09','09:50:00',2.07),('15087','2013-08-09','09:55:00',1.65),('15087','2013-08-09','10:00:00',1.89),('15087','2013-08-09','10:05:00',2.08),('15087','2013-08-09','10:10:00',2.62),('15087','2013-08-09','10:15:00',3.01),('15087','2013-08-09','10:20:00',2.99),('15087','2013-08-09','10:25:00',3),('15087','2013-08-09','10:30:00',2.86),('15087','2013-08-09','10:35:00',2.98),('15087','2013-08-09','10:40:00',2.95),('15087','2013-08-09','10:45:00',3.35),('15087','2013-08-09','10:50:00',3.32),('15087','2013-08-09','10:55:00',3.45),('15087','2013-08-09','11:00:00',3.53),('15087','2013-08-09','11:05:00',3.53),('15087','2013-08-09','11:10:00',3.53),('15087','2013-08-09','11:15:00',3.65),('15087','2013-08-09','11:20:00',3.69),('15087','2013-08-09','11:25:00',3.69),('15087','2013-08-09','11:30:00',3.73),('15087','2013-08-09','11:35:00',3.73),('15087','2013-08-09','11:40:00',3.82),('15087','2013-08-09','11:45:00',3.83),('15087','2013-08-09','11:50:00',3.84),('15087','2013-08-09','11:55:00',3.87),('15087','2013-08-09','12:00:00',3.89),('15087','2013-08-09','12:05:00',3.94),('15087','2013-08-09','12:10:00',3.9),('15087','2013-08-09','12:15:00',3.99),('15087','2013-08-09','12:20:00',4.15),('15087','2013-08-09','12:25:00',3.13),('15087','2013-08-09','12:30:00',2.88),('15087','2013-08-09','12:35:00',3.14),('15087','2013-08-09','12:40:00',4.2),('15087','2013-08-09','12:45:00',3.61),('15087','2013-08-09','12:50:00',2.53),('15087','2013-08-09','12:55:00',3.11),('15087','2013-08-09','13:00:00',1.31),('15087','2013-08-09','13:15:00',1.16),('15087','2013-08-09','13:20:00',1.58),('15087','2013-08-09','13:25:00',2.29),('15087','2013-08-09','13:30:00',1.92),('15087','2013-08-09','13:35:00',1.52),('15087','2013-08-09','13:40:00',1.49),('15087','2013-08-09','13:45:00',1.42),('15087','2013-08-09','13:50:00',1.52),('15087','2013-08-09','13:55:00',1.33),('15087','2013-08-09','14:00:00',1.28),('15087','2013-08-09','14:05:00',1.24),('15087','2013-08-09','14:10:00',1.5),('15087','2013-08-09','14:25:00',1.01),('15087','2013-08-09','14:30:00',1.01),('15087','2013-08-09','15:05:00',1.31),('15087','2013-08-09','15:10:00',2.93),('15087','2013-08-09','15:15:00',2.68),('15087','2013-08-09','15:20:00',1.62),('15087','2013-08-09','15:25:00',1.21),('15087','2013-08-09','15:30:00',1.25),('15087','2013-08-09','15:35:00',2.32),('15087','2013-08-09','15:40:00',1.71),('15087','2013-08-09','15:45:00',2.89),('15087','2013-08-09','15:50:00',2.17),('15087','2013-08-09','15:55:00',1.92),('15087','2013-08-09','16:00:00',1.21),('15087','2013-08-09','16:50:00',1.6),('15087','2013-08-09','16:55:00',2.33),('15087','2013-08-09','17:00:00',1.51),('15087','2013-08-09','17:05:00',1.71),('15087','2013-08-08','08:05:00',1.05),('15087','2013-08-08','08:10:00',1.14),('15087','2013-08-08','08:15:00',1.23),('15087','2013-08-08','08:20:00',1.31),('15087','2013-08-08','08:25:00',1.39),('15087','2013-08-08','08:30:00',1.46),('15087','2013-08-08','08:35:00',1.54),('15087','2013-08-08','08:40:00',1.62),('15087','2013-08-08','08:45:00',1.71),('15087','2013-08-08','08:50:00',1.79),('15087','2013-08-08','08:55:00',1.87),('15087','2013-08-08','09:00:00',1.95),('15087','2013-08-08','09:05:00',2.04),('15087','2013-08-08','09:10:00',2.17),('15087','2013-08-08','09:15:00',2.24),('15087','2013-08-08','09:20:00',2.35),('15087','2013-08-08','09:25:00',2.46),('15087','2013-08-08','09:30:00',2.52),('15087','2013-08-08','09:35:00',2.58),('15087','2013-08-08','09:40:00',2.66),('15087','2013-08-08','09:45:00',2.74),('15087','2013-08-08','09:50:00',2.8),('15087','2013-08-08','09:55:00',2.86),('15087','2013-08-08','10:00:00',2.93),('15087','2013-08-08','10:05:00',2.98),('15087','2013-08-08','10:10:00',3.07),('15087','2013-08-08','10:15:00',3.13),('15087','2013-08-08','10:20:00',3.17),('15087','2013-08-08','10:25:00',3.22),('15087','2013-08-08','10:30:00',3.28),('15087','2013-08-08','10:35:00',3.32),('15087','2013-08-08','10:40:00',3.35),('15087','2013-08-08','10:45:00',3.41),('15087','2013-08-08','10:50:00',3.44),('15087','2013-08-08','10:55:00',3.47),('15087','2013-08-08','11:00:00',3.52),('15087','2013-08-08','11:05:00',3.55),('15087','2013-08-08','11:10:00',3.59),('15087','2013-08-08','11:15:00',3.61),('15087','2013-08-08','11:20:00',3.59),('15087','2013-08-08','11:25:00',3.67),('15087','2013-08-08','11:30:00',3.73),('15087','2013-08-08','11:35:00',3.69),('15087','2013-08-08','11:40:00',3.76),('15087','2013-08-08','11:45:00',3.8),('15087','2013-08-08','11:50:00',3.85),('15087','2013-08-08','11:55:00',3.82),('15087','2013-08-08','12:00:00',3.85),('15087','2013-08-08','12:05:00',3.92),('15087','2013-08-08','12:10:00',3.93),('15087','2013-08-08','12:15:00',3.9),('15087','2013-08-08','12:20:00',3.95),('15087','2013-08-08','12:25:00',3.94),('15087','2013-08-08','12:30:00',3.88),('15087','2013-08-08','12:35:00',4.05),('15087','2013-08-08','12:40:00',4.06),('15087','2013-08-08','12:45:00',4.07),('15087','2013-08-08','12:50:00',4.09),('15087','2013-08-08','12:55:00',4.1),('15087','2013-08-08','13:00:00',4.11),('15087','2013-08-08','13:05:00',4.16),('15087','2013-08-08','13:10:00',4.13),('15087','2013-08-08','13:15:00',4.11),('15087','2013-08-08','13:20:00',4.14),('15087','2013-08-08','13:25:00',4.12),('15087','2013-08-08','13:30:00',4.11),('15087','2013-08-08','13:35:00',4.08),('15087','2013-08-08','13:40:00',3.97),('15087','2013-08-08','13:45:00',4.07),('15087','2013-08-08','13:50:00',4.08),('15087','2013-08-08','13:55:00',4.07),('15087','2013-08-08','14:00:00',4.07),('15087','2013-08-08','14:05:00',4.03),('15087','2013-08-08','14:10:00',3.9),('15087','2013-08-08','14:15:00',3.84),('15087','2013-08-08','14:20:00',3.87),('15087','2013-08-08','14:25:00',3.85),('15087','2013-08-08','14:30:00',3.84),('15087','2013-08-08','14:35:00',3.73),('15087','2013-08-08','14:40:00',3.68),('15087','2013-08-08','14:45:00',3.68),('15087','2013-08-08','14:50:00',3.66),('15087','2013-08-08','14:55:00',3.59),('15087','2013-08-08','15:00:00',3.46),('15087','2013-08-08','15:05:00',3.43),('15087','2013-08-08','15:10:00',3.44),('15087','2013-08-08','15:15:00',3.42),('15087','2013-08-08','15:20:00',3.32),('15087','2013-08-08','15:25:00',3.26),('15087','2013-08-08','15:30:00',3.23),('15087','2013-08-08','15:35:00',3.2),('15087','2013-08-08','15:40:00',3.14),('15087','2013-08-08','15:45:00',3.02),('15087','2013-08-08','15:50:00',2.74),('15087','2013-08-08','15:55:00',2.79),('15087','2013-08-08','16:00:00',2.9),('15087','2013-08-08','16:05:00',2.84),('15087','2013-08-08','16:10:00',2.8),('15087','2013-08-08','16:15:00',2.75),('15087','2013-08-08','16:20:00',2.72),('15087','2013-08-08','16:25:00',2.65),('15087','2013-08-08','16:30:00',2.63),('15087','2013-08-08','16:35:00',2.49),('15087','2013-08-08','16:40:00',2.44),('15087','2013-08-08','16:45:00',2.41),('15087','2013-08-08','16:50:00',2.16),('15087','2013-08-08','16:55:00',2.13),('15087','2013-08-08','17:00:00',2.11),('15087','2013-08-08','17:05:00',1.96),('15087','2013-08-08','17:10:00',1.96),('15087','2013-08-08','17:15:00',1.87),('15087','2013-08-08','17:20:00',1.8),('15087','2013-08-08','17:25:00',1.72),('15087','2013-08-08','17:30:00',1.6),('15087','2013-08-08','17:35:00',1.44),('15087','2013-08-08','17:40:00',1.42),('15087','2013-08-08','17:45:00',1.37),('15087','2013-08-08','17:50:00',1.29),('15087','2013-08-08','17:55:00',1.24),('15087','2013-08-08','18:00:00',1.23),('15087','2013-08-08','18:05:00',1.13),('15087','2013-08-08','18:10:00',1.06),('15087','2013-08-07','08:00:00',1.03),('15087','2013-08-07','08:05:00',1.11),('15087','2013-08-07','08:10:00',1.19),('15087','2013-08-07','08:15:00',1.28),('15087','2013-08-07','08:20:00',1.36),('15087','2013-08-07','08:25:00',1.45),('15087','2013-08-07','08:30:00',1.53),('15087','2013-08-07','08:35:00',1.6),('15087','2013-08-07','08:40:00',1.69),('15087','2013-08-07','08:45:00',1.78),('15087','2013-08-07','08:50:00',1.86),('15087','2013-08-07','08:55:00',1.92),('15087','2013-08-07','09:00:00',2.01),('15087','2013-08-07','09:05:00',2.14),('15087','2013-08-07','09:10:00',2.22),('15087','2013-08-07','09:15:00',2.28),('15087','2013-08-07','09:20:00',2.37),('15087','2013-08-07','09:25:00',2.5),('15087','2013-08-07','09:30:00',2.59),('15087','2013-08-07','09:35:00',2.64),('15087','2013-08-07','09:40:00',2.71),('15087','2013-08-07','09:45:00',2.77),('15087','2013-08-07','09:50:00',2.84),('15087','2013-08-07','09:55:00',2.92),('15087','2013-08-07','10:00:00',2.97),('15087','2013-08-07','10:05:00',3.03),('15087','2013-08-07','10:10:00',3.12),('15087','2013-08-07','10:15:00',3.17),('15087','2013-08-07','10:20:00',3.22),('15087','2013-08-07','10:25:00',3.25),('15087','2013-08-07','10:30:00',3.32),('15087','2013-08-07','10:35:00',3.35),('15087','2013-08-07','10:40:00',3.4),('15087','2013-08-07','10:45:00',3.42),('15087','2013-08-07','10:50:00',3.48),('15087','2013-08-07','10:55:00',3.53),('15087','2013-08-07','11:00:00',3.57),('15087','2013-08-07','11:05:00',3.61),('15087','2013-08-07','11:10:00',3.64),('15087','2013-08-07','11:15:00',3.69),('15087','2013-08-07','11:20:00',3.71),('15087','2013-08-07','11:25:00',3.73),('15087','2013-08-07','11:30:00',3.75),('15087','2013-08-07','11:35:00',3.79),('15087','2013-08-07','11:40:00',3.78),('15087','2013-08-07','11:45:00',3.81),('15087','2013-08-07','11:50:00',3.87),('15087','2013-08-07','11:55:00',3.91),('15087','2013-08-07','12:00:00',3.91),('15087','2013-08-07','12:05:00',3.93),('15087','2013-08-07','12:10:00',3.92),('15087','2013-08-07','12:15:00',3.91),('15087','2013-08-07','12:20:00',3.86),('15087','2013-08-07','12:25:00',3.93),('15087','2013-08-07','12:30:00',4),('15087','2013-08-07','12:35:00',3.95),('15087','2013-08-07','12:40:00',4.02),('15087','2013-08-07','12:45:00',4.01),('15087','2013-08-07','12:50:00',3.98),('15087','2013-08-07','12:55:00',4.02),('15087','2013-08-07','13:00:00',4.03),('15087','2013-08-07','13:05:00',4.2),('15087','2013-08-07','13:10:00',4.18),('15087','2013-08-07','13:15:00',4.17),('15087','2013-08-07','13:20:00',4.08),('15087','2013-08-07','13:25:00',4.12),('15087','2013-08-07','13:30:00',4.17),('15087','2013-08-07','13:35:00',4.14),('15087','2013-08-07','13:40:00',4.18),('15087','2013-08-07','13:45:00',4.13),('15087','2013-08-07','13:50:00',4.14),('15087','2013-08-07','13:55:00',4.15),('15087','2013-08-07','14:00:00',4.13),('15087','2013-08-07','14:05:00',4.08),('15087','2013-08-07','14:10:00',3.98),('15087','2013-08-07','14:15:00',3.84),('15087','2013-08-07','14:20:00',3.83),('15087','2013-08-07','14:25:00',3.82),('15087','2013-08-07','14:30:00',3.75),('15087','2013-08-07','14:35:00',3.69),('15087','2013-08-07','14:40:00',3.7),('15087','2013-08-07','14:45:00',3.7),('15087','2013-08-07','14:50:00',3.73),('15087','2013-08-07','14:55:00',3.66),('15087','2013-08-07','15:00:00',3.58),('15087','2013-08-07','15:05:00',3.43),('15087','2013-08-07','15:10:00',3.5),('15087','2013-08-07','15:15:00',3.49),('15087','2013-08-07','15:20:00',3.46),('15087','2013-08-07','15:25:00',3.32),('15087','2013-08-07','15:30:00',3.32),('15087','2013-08-07','15:35:00',3.28),('15087','2013-08-07','15:40:00',3.22),('15087','2013-08-07','15:45:00',3.12),('15087','2013-08-07','15:50:00',2.95),('15087','2013-08-07','15:55:00',3.01),('15087','2013-08-07','16:00:00',2.93),('15087','2013-08-07','16:05:00',2.84),('15087','2013-08-07','16:10:00',2.78),('15087','2013-08-07','16:15:00',2.72),('15087','2013-08-07','16:20:00',2.48),('15087','2013-08-07','16:25:00',2.6),('15087','2013-08-07','16:30:00',2.53),('15087','2013-08-07','16:35:00',2.55),('15087','2013-08-07','16:40:00',2.46),('15087','2013-08-07','16:45:00',2.44),('15087','2013-08-07','16:50:00',2.33),('15087','2013-08-07','16:55:00',2.3),('15087','2013-08-07','17:00:00',2.21),('15087','2013-08-07','17:05:00',2.09),('15087','2013-08-07','17:10:00',2.06),('15087','2013-08-07','17:15:00',1.87),('15087','2013-08-07','17:20:00',1.87),('15087','2013-08-07','17:25:00',1.76),('15087','2013-08-07','17:30:00',1.65),('15087','2013-08-07','17:35:00',1.35),('15087','2013-08-07','17:40:00',1.48),('15087','2013-08-07','17:45:00',1.4),('15087','2013-08-07','17:50:00',1.3),('15087','2013-08-07','17:55:00',1.26),('15087','2013-08-07','18:00:00',1.22),('15087','2013-08-07','18:05:00',1.1),('15087','2013-08-07','18:10:00',1.06),('15087','2013-08-07','18:15:00',1.04),('15087','2013-08-06','08:00:00',1.01),('15087','2013-08-06','08:05:00',1.09),('15087','2013-08-06','08:10:00',1.17),('15087','2013-08-06','08:15:00',1.26),('15087','2013-08-06','08:20:00',1.32),('15087','2013-08-06','08:25:00',1.41),('15087','2013-08-06','08:30:00',1.5),('15087','2013-08-06','08:35:00',1.58),('15087','2013-08-06','08:40:00',1.66),('15087','2013-08-06','08:45:00',1.75),('15087','2013-08-06','08:50:00',1.83),('15087','2013-08-06','08:55:00',1.9),('15087','2013-08-06','09:00:00',1.99),('15087','2013-08-06','09:05:00',2.11),('15087','2013-08-06','09:10:00',2.19),('15087','2013-08-06','09:15:00',2.31),('15087','2013-08-06','09:20:00',2.4),('15087','2013-08-06','09:25:00',2.47),('15087','2013-08-06','09:30:00',2.56),('15087','2013-08-06','09:35:00',2.65),('15087','2013-08-06','09:40:00',2.71),('15087','2013-08-06','09:45:00',2.77),('15087','2013-08-06','09:50:00',2.82),('15087','2013-08-06','09:55:00',2.9),('15087','2013-08-06','10:00:00',2.98),('15087','2013-08-06','10:05:00',3.03),('15087','2013-08-06','10:10:00',3.09),('15087','2013-08-06','10:15:00',3.15),('15087','2013-08-06','10:20:00',3.2),('15087','2013-08-06','10:25:00',3.24),('15087','2013-08-06','10:30:00',3.3),('15087','2013-08-06','10:35:00',3.31),('15087','2013-08-06','10:40:00',3.38),('15087','2013-08-06','10:45:00',3.4),('15087','2013-08-06','10:50:00',3.45),('15087','2013-08-06','10:55:00',3.5),('15087','2013-08-06','11:00:00',3.54),('15087','2013-08-06','11:05:00',3.57),('15087','2013-08-06','11:10:00',3.6),('15087','2013-08-06','11:15:00',3.63),('15087','2013-08-06','11:20:00',3.7),('15087','2013-08-06','11:25:00',3.74),('15087','2013-08-06','11:30:00',3.77),('15087','2013-08-06','11:35:00',3.8),('15087','2013-08-06','11:40:00',3.81),('15087','2013-08-06','11:45:00',3.82),('15087','2013-08-06','11:50:00',3.87),('15087','2013-08-06','11:55:00',3.88),('15087','2013-08-06','12:00:00',3.89),('15087','2013-08-06','12:05:00',3.89),('15087','2013-08-06','12:10:00',3.93),('15087','2013-08-06','12:15:00',3.93),('15087','2013-08-06','12:20:00',3.89),('15087','2013-08-06','12:25:00',3.94),('15087','2013-08-06','12:30:00',3.93),('15087','2013-08-06','12:35:00',3.95),('15087','2013-08-06','12:40:00',3.98),('15087','2013-08-06','12:45:00',4.06),('15087','2013-08-06','12:50:00',4.04),('15087','2013-08-06','12:55:00',3.96),('15087','2013-08-06','13:00:00',4.01),('15087','2013-08-06','13:05:00',4.01),('15087','2013-08-06','13:10:00',4.11),('15087','2013-08-06','13:15:00',4.11),('15087','2013-08-06','13:20:00',4.1),('15087','2013-08-06','13:25:00',4.07),('15087','2013-08-06','13:30:00',4.16),('15087','2013-08-06','13:35:00',4.16),('15087','2013-08-06','13:40:00',4.18),('15087','2013-08-06','13:45:00',4.19),('15087','2013-08-06','13:50:00',4.2),('15087','2013-08-06','13:55:00',4.19),('15087','2013-08-06','14:00:00',4.17),('15087','2013-08-06','14:05:00',4.16),('15087','2013-08-06','14:10:00',4.15),('15087','2013-08-06','14:15:00',4.06),('15087','2013-08-06','14:20:00',4.02),('15087','2013-08-06','14:25:00',4),('15087','2013-08-06','14:30:00',3.79),('15087','2013-08-06','14:35:00',3.86),('15087','2013-08-06','14:40:00',3.89),('15087','2013-08-06','14:45:00',3.88),('15087','2013-08-06','14:50:00',3.87),('15087','2013-08-06','14:55:00',3.83),('15087','2013-08-06','15:00:00',3.73),('15087','2013-08-06','15:05:00',3.57),('15087','2013-08-06','15:10:00',3.6),('15087','2013-08-06','15:15:00',3.63),('15087','2013-08-06','15:20:00',3.6),('15087','2013-08-06','15:25:00',3.52),('15087','2013-08-06','15:30:00',3.47),('15087','2013-08-06','15:35:00',3.42),('15087','2013-08-06','15:40:00',3.36),('15087','2013-08-06','15:45:00',3.27),('15087','2013-08-06','15:50:00',3.08),('15087','2013-08-06','15:55:00',3.12),('15087','2013-08-06','16:00:00',3.11),('15087','2013-08-06','16:05:00',3.02),('15087','2013-08-06','16:10:00',2.93),('15087','2013-08-06','16:15:00',2.85),('15087','2013-08-06','16:20:00',2.65),('15087','2013-08-06','16:25:00',2.63),('15087','2013-08-06','16:30:00',2.69),('15087','2013-08-06','16:35:00',2.61),('15087','2013-08-06','16:40:00',2.56),('15087','2013-08-06','16:45:00',2.54),('15087','2013-08-06','16:50:00',2.38),('15087','2013-08-06','16:55:00',2.28),('15087','2013-08-06','17:00:00',2.27),('15087','2013-08-06','17:05:00',2.19),('15087','2013-08-06','17:10:00',2.12),('15087','2013-08-06','17:15:00',2.01),('15087','2013-08-06','17:20:00',1.88),('15087','2013-08-06','17:25:00',1.83),('15087','2013-08-06','17:30:00',1.72),('15087','2013-08-06','17:35:00',1.49),('15087','2013-08-06','17:40:00',1.53),('15087','2013-08-06','17:45:00',1.48),('15087','2013-08-06','17:50:00',1.34),('15087','2013-08-06','17:55:00',1.32),('15087','2013-08-06','18:00:00',1.25),('15087','2013-08-06','18:05:00',1.12),('15087','2013-08-06','18:10:00',1.12),('15087','2013-08-06','18:15:00',1.1),('15087','2013-08-05','07:55:00',1.01),('15087','2013-08-05','08:00:00',1.09),('15087','2013-08-05','08:05:00',1.16),('15087','2013-08-05','08:10:00',1.25),('15087','2013-08-05','08:15:00',1.33),('15087','2013-08-05','08:20:00',1.41),('15087','2013-08-05','08:25:00',1.48),('15087','2013-08-05','08:30:00',1.56),('15087','2013-08-05','08:35:00',1.64),('15087','2013-08-05','08:40:00',1.72),('15087','2013-08-05','08:45:00',1.79),('15087','2013-08-05','08:50:00',1.87),('15087','2013-08-05','08:55:00',1.94),('15087','2013-08-05','09:00:00',2.03),('15087','2013-08-05','09:05:00',2.16),('15087','2013-08-05','09:10:00',2.2),('15087','2013-08-05','09:15:00',2.33),('15087','2013-08-05','09:20:00',2.45),('15087','2013-08-05','09:25:00',2.5),('15087','2013-08-05','09:30:00',2.57),('15087','2013-08-05','09:35:00',2.65),('15087','2013-08-05','09:40:00',2.72),('15087','2013-08-05','09:45:00',2.8),('15087','2013-08-05','09:50:00',2.86),('15087','2013-08-05','09:55:00',2.91),('15087','2013-08-05','10:00:00',3),('15087','2013-08-05','10:05:00',3.03),('15087','2013-08-05','10:10:00',3.1),('15087','2013-08-05','10:15:00',3.18),('15087','2013-08-05','10:20:00',3.23),('15087','2013-08-05','10:25:00',3.28),('15087','2013-08-05','10:30:00',3.32),('15087','2013-08-05','10:35:00',3.39),('15087','2013-08-05','10:40:00',3.45),('15087','2013-08-05','10:45:00',3.51),('15087','2013-08-05','10:50:00',3.55),('15087','2013-08-05','10:55:00',3.6),('15087','2013-08-05','11:00:00',3.65),('15087','2013-08-05','11:05:00',3.69),('15087','2013-08-05','11:10:00',3.72),('15087','2013-08-05','11:15:00',3.8),('15087','2013-08-05','11:20:00',3.75),('15087','2013-08-05','11:25:00',3.85),('15087','2013-08-05','11:30:00',3.86),('15087','2013-08-05','11:35:00',3.93),('15087','2013-08-05','11:40:00',3.95),('15087','2013-08-05','11:45:00',3.93),('15087','2013-08-05','11:50:00',3.96),('15087','2013-08-05','11:55:00',4.02),('15087','2013-08-05','12:00:00',4.02),('15087','2013-08-05','12:05:00',4.06),('15087','2013-08-05','12:10:00',4.05),('15087','2013-08-05','12:15:00',4.04),('15087','2013-08-05','12:20:00',4.03),('15087','2013-08-05','12:25:00',4.08),('15087','2013-08-05','12:30:00',4.1),('15087','2013-08-05','12:35:00',4.11),('15087','2013-08-05','12:40:00',4.13),('15087','2013-08-05','12:45:00',4.15),('15087','2013-08-05','12:50:00',4.12),('15087','2013-08-05','12:55:00',4.12),('15087','2013-08-05','13:00:00',4.14),('15087','2013-08-05','13:05:00',4.16),('15087','2013-08-05','13:10:00',4.16),('15087','2013-08-05','13:15:00',4.13),('15087','2013-08-05','13:20:00',4.14),('15087','2013-08-05','13:25:00',4.16),('15087','2013-08-05','13:30:00',4.16),('15087','2013-08-05','13:35:00',4.06),('15087','2013-08-05','13:40:00',4.12),('15087','2013-08-05','13:45:00',4.04),('15087','2013-08-05','13:50:00',4.13),('15087','2013-08-05','13:55:00',4.07),('15087','2013-08-05','14:00:00',4.12),('15087','2013-08-05','14:05:00',4.09),('15087','2013-08-05','14:10:00',4.04),('15087','2013-08-05','14:15:00',3.96),('15087','2013-08-05','14:20:00',3.88),('15087','2013-08-05','14:25:00',3.92),('15087','2013-08-05','14:30:00',3.9),('15087','2013-08-05','14:35:00',3.88),('15087','2013-08-05','14:40:00',3.78),('15087','2013-08-05','14:45:00',3.72),('15087','2013-08-05','14:50:00',3.7),('15087','2013-08-05','14:55:00',3.7),('15087','2013-08-05','15:00:00',3.66),('15087','2013-08-05','15:05:00',3.56),('15087','2013-08-05','15:10:00',3.61),('15087','2013-08-05','15:15:00',3.56),('15087','2013-08-05','15:20:00',3.54),('15087','2013-08-05','15:25:00',3.48),('15087','2013-08-05','15:30:00',3.35),('15087','2013-08-05','15:35:00',3.23),('15087','2013-08-05','15:40:00',3.33),('15087','2013-08-05','15:45:00',3.28),('15087','2013-08-05','15:50:00',3.06),('15087','2013-08-05','15:55:00',3.11),('15087','2013-08-05','16:00:00',3.09),('15087','2013-08-05','16:05:00',3.04),('15087','2013-08-05','16:10:00',2.9),('15087','2013-08-05','16:15:00',2.73),('15087','2013-08-05','16:20:00',2.67),('15087','2013-08-05','16:25:00',2.77),('15087','2013-08-05','16:30:00',2.66),('15087','2013-08-05','16:35:00',2.64),('15087','2013-08-05','16:40:00',2.59),('15087','2013-08-05','16:45:00',2.56),('15087','2013-08-05','16:50:00',2.4),('15087','2013-08-05','16:55:00',2.33),('15087','2013-08-05','17:00:00',2.26),('15087','2013-08-05','17:05:00',2.2),('15087','2013-08-05','17:10:00',2.07),('15087','2013-08-05','17:15:00',1.94),('15087','2013-08-05','17:20:00',1.85),('15087','2013-08-05','17:25:00',1.82),('15087','2013-08-05','17:30:00',1.71),('15087','2013-08-05','17:35:00',1.64),('15087','2013-08-05','17:40:00',1.54),('15087','2013-08-05','17:45:00',1.42),('15087','2013-08-05','17:50:00',1.34),('15087','2013-08-05','17:55:00',1.35),('15087','2013-08-05','18:00:00',1.26),('15087','2013-08-05','18:05:00',1.12),('15087','2013-08-05','18:10:00',1.12),('15087','2013-08-05','18:15:00',1.06),('15087','2013-08-04','07:55:00',1.07),('15087','2013-08-04','08:00:00',1.16),('15087','2013-08-04','08:05:00',1.24),('15087','2013-08-04','08:10:00',1.33),('15087','2013-08-04','08:15:00',1.42),('15087','2013-08-04','08:20:00',1.5),('15087','2013-08-04','08:25:00',1.6),('15087','2013-08-04','08:30:00',1.68),('15087','2013-08-04','08:35:00',1.76),('15087','2013-08-04','08:40:00',1.84),('15087','2013-08-04','08:45:00',1.94),('15087','2013-08-04','08:50:00',2.04),('15087','2013-08-04','08:55:00',2.11),('15087','2013-08-04','09:00:00',2.24),('15087','2013-08-04','09:05:00',2.35),('15087','2013-08-04','09:10:00',2.43),('15087','2013-08-04','09:15:00',2.5),('15087','2013-08-04','09:20:00',2.57),('15087','2013-08-04','09:25:00',2.68),('15087','2013-08-04','09:30:00',2.74),('15087','2013-08-04','09:35:00',2.81),('15087','2013-08-04','09:40:00',2.89),('15087','2013-08-04','09:45:00',2.96),('15087','2013-08-04','09:50:00',3.03),('15087','2013-08-04','09:55:00',3.08),('15087','2013-08-04','10:00:00',3.15),('15087','2013-08-04','10:05:00',3.15),('15087','2013-08-04','10:10:00',3.26),('15087','2013-08-04','10:15:00',3.32),('15087','2013-08-04','10:20:00',3.38),('15087','2013-08-04','10:25:00',3.44),('15087','2013-08-04','10:30:00',3.47),('15087','2013-08-04','10:35:00',3.48),('15087','2013-08-04','10:40:00',3.56),('15087','2013-08-04','10:45:00',3.6),('15087','2013-08-04','10:50:00',3.65),('15087','2013-08-04','10:55:00',3.7),('15087','2013-08-04','11:00:00',3.72),('15087','2013-08-04','11:05:00',3.73),('15087','2013-08-04','11:10:00',3.75),('15087','2013-08-04','11:15:00',3.82),('15087','2013-08-04','11:20:00',3.87),('15087','2013-08-04','11:25:00',3.92),('15087','2013-08-04','11:30:00',3.99),('15087','2013-08-04','11:35:00',4),('15087','2013-08-04','11:40:00',4.01),('15087','2013-08-04','11:45:00',4.08),('15087','2013-08-04','11:50:00',4.14),('15087','2013-08-04','11:55:00',4.18),('15087','2013-08-04','12:00:00',4.15),('15087','2013-08-04','12:05:00',4.14),('15087','2013-08-04','12:10:00',4.22),('15087','2013-08-04','12:15:00',4.22),('15087','2013-08-04','12:20:00',4.21),('15087','2013-08-04','12:25:00',4.22),('15087','2013-08-04','12:30:00',4.24),('15087','2013-08-04','12:35:00',4.22),('15087','2013-08-04','12:40:00',4.3),('15087','2013-08-04','12:45:00',4.28),('15087','2013-08-04','12:50:00',4.27),('15087','2013-08-04','12:55:00',4.26),('15087','2013-08-04','13:00:00',4.17),('15087','2013-08-04','13:05:00',4.21),('15087','2013-08-04','13:10:00',4.22),('15087','2013-08-04','13:15:00',4.18),('15087','2013-08-04','13:20:00',4.23),('15087','2013-08-04','13:25:00',4.28),('15087','2013-08-04','13:30:00',4.28),('15087','2013-08-04','13:35:00',4.34),('15087','2013-08-04','13:40:00',4.34),('15087','2013-08-04','13:45:00',4.35),('15087','2013-08-04','13:50:00',4.33),('15087','2013-08-04','13:55:00',4.33),('15087','2013-08-04','14:00:00',4.33),('15087','2013-08-04','14:05:00',4.31),('15087','2013-08-04','14:10:00',4.27),('15087','2013-08-04','14:15:00',4.17),('15087','2013-08-04','14:20:00',4.08),('15087','2013-08-04','14:25:00',4.13),('15087','2013-08-04','14:30:00',4.1),('15087','2013-08-04','14:35:00',4.08),('15087','2013-08-04','14:40:00',3.99),('15087','2013-08-04','14:45:00',3.87),('15087','2013-08-04','14:50:00',3.93),('15087','2013-08-04','14:55:00',3.91),('15087','2013-08-04','15:00:00',3.84),('15087','2013-08-04','15:05:00',3.73),('15087','2013-08-04','15:10:00',3.77),('15087','2013-08-04','15:15:00',3.71),('15087','2013-08-04','15:20:00',3.68),('15087','2013-08-04','15:25:00',3.61),('15087','2013-08-04','15:30:00',3.42),('15087','2013-08-04','15:35:00',3.36),('15087','2013-08-04','15:40:00',3.44),('15087','2013-08-04','15:45:00',3.33),('15087','2013-08-04','15:50:00',3.2),('15087','2013-08-04','15:55:00',3.22),('15087','2013-08-04','16:00:00',3.12),('15087','2013-08-04','16:05:00',3.11),('15087','2013-08-04','16:10:00',2.98),('15087','2013-08-04','16:15:00',2.63),('15087','2013-08-04','16:20:00',2.6),('15087','2013-08-04','16:25:00',2.88),('15087','2013-08-04','16:30:00',2.76),('15087','2013-08-04','16:35:00',2.72),('15087','2013-08-04','16:40:00',2.67),('15087','2013-08-04','16:45:00',2.59),('15087','2013-08-04','16:50:00',2.5),('15087','2013-08-04','16:55:00',2.42),('15087','2013-08-04','17:00:00',2.38),('15087','2013-08-04','17:05:00',2.3),('15087','2013-08-04','17:10:00',2.18),('15087','2013-08-04','17:15:00',2.11),('15087','2013-08-04','17:20:00',1.96),('15087','2013-08-04','17:25:00',1.92),('15087','2013-08-04','17:30:00',1.78),('15087','2013-08-04','17:35:00',1.73),('15087','2013-08-04','17:40:00',1.54),('15087','2013-08-04','17:45:00',1.44),('15087','2013-08-04','17:50:00',1.38),('15087','2013-08-04','17:55:00',1.42),('15087','2013-08-04','18:00:00',1.29),('15087','2013-08-04','18:05:00',1.09),('15087','2013-08-04','18:10:00',1.19),('15087','2013-08-04','18:15:00',1.1),('15087','2013-08-04','18:20:00',1),('15087','2013-08-03','07:55:00',1.07),('15087','2013-08-03','08:00:00',1.15),('15087','2013-08-03','08:05:00',1.23),('15087','2013-08-03','08:10:00',1.32),('15087','2013-08-03','08:15:00',1.41),('15087','2013-08-03','08:20:00',1.5),('15087','2013-08-03','08:25:00',1.58),('15087','2013-08-03','08:30:00',1.67),('15087','2013-08-03','08:35:00',1.74),('15087','2013-08-03','08:40:00',1.82),('15087','2013-08-03','08:45:00',1.92),('15087','2013-08-03','08:50:00',1.99),('15087','2013-08-03','08:55:00',2.08),('15087','2013-08-03','09:00:00',2.14),('15087','2013-08-03','09:05:00',2.31),('15087','2013-08-03','09:10:00',2.42),('15087','2013-08-03','09:15:00',2.5),('15087','2013-08-03','09:20:00',2.58),('15087','2013-08-03','09:25:00',2.65),('15087','2013-08-03','09:30:00',2.7),('15087','2013-08-03','09:35:00',2.79),('15087','2013-08-03','09:40:00',2.84),('15087','2013-08-03','09:45:00',2.93),('15087','2013-08-03','09:50:00',2.99),('15087','2013-08-03','09:55:00',3.05),('15087','2013-08-03','10:00:00',3.1),('15087','2013-08-03','10:05:00',3.18),('15087','2013-08-03','10:10:00',3.24),('15087','2013-08-03','10:15:00',3.32),('15087','2013-08-03','10:20:00',3.37),('15087','2013-08-03','10:25:00',3.43),('15087','2013-08-03','10:30:00',3.44),('15087','2013-08-03','10:35:00',3.49),('15087','2013-08-03','10:40:00',3.57),('15087','2013-08-03','10:45:00',3.63),('15087','2013-08-03','10:50:00',3.67),('15087','2013-08-03','10:55:00',3.72),('15087','2013-08-03','11:00:00',3.78),('15087','2013-08-03','11:05:00',3.82),('15087','2013-08-03','11:10:00',3.82),('15087','2013-08-03','11:15:00',3.81),('15087','2013-08-03','11:20:00',3.89),('15087','2013-08-03','11:25:00',3.95),('15087','2013-08-03','11:30:00',3.95),('15087','2013-08-03','11:35:00',3.97),('15087','2013-08-03','11:40:00',4.02),('15087','2013-08-03','11:45:00',4.08),('15087','2013-08-03','11:50:00',4.07),('15087','2013-08-03','11:55:00',4.09),('15087','2013-08-03','12:00:00',4.11),('15087','2013-08-03','12:05:00',4.13),('15087','2013-08-03','12:10:00',4.08),('15087','2013-08-03','12:15:00',4.11),('15087','2013-08-03','12:20:00',4.15),('15087','2013-08-03','12:25:00',4.12),('15087','2013-08-03','12:30:00',4.15),('15087','2013-08-03','12:35:00',4.16),('15087','2013-08-03','12:40:00',4.12),('15087','2013-08-03','12:45:00',4.13),('15087','2013-08-03','12:50:00',4.11),('15087','2013-08-03','12:55:00',4.09),('15087','2013-08-03','13:00:00',4.15),('15087','2013-08-03','13:05:00',4.19),('15087','2013-08-03','13:10:00',4.16),('15087','2013-08-03','13:15:00',4.12),('15087','2013-08-03','13:20:00',4.12),('15087','2013-08-03','13:25:00',4.11),('15087','2013-08-03','13:30:00',4.06),('15087','2013-08-03','13:35:00',4.13),('15087','2013-08-03','13:40:00',4.19),('15087','2013-08-03','13:45:00',4.14),('15087','2013-08-03','13:50:00',4.12),('15087','2013-08-03','13:55:00',4.08),('15087','2013-08-03','14:00:00',4.06),('15087','2013-08-03','14:05:00',3.99),('15087','2013-08-03','14:10:00',4),('15087','2013-08-03','14:15:00',3.94),('15087','2013-08-03','14:20:00',3.92),('15087','2013-08-03','14:25:00',3.95),('15087','2013-08-03','14:30:00',3.95),('15087','2013-08-03','14:35:00',3.99),('15087','2013-08-03','14:40:00',3.95),('15087','2013-08-03','14:45:00',3.82),('15087','2013-08-03','14:50:00',3.88),('15087','2013-08-03','14:55:00',3.88),('15087','2013-08-03','15:00:00',3.83),('15087','2013-08-03','15:05:00',3.74),('15087','2013-08-03','15:10:00',3.7),('15087','2013-08-03','15:15:00',3.65),('15087','2013-08-03','15:20:00',3.59),('15087','2013-08-03','15:25:00',3.59),('15087','2013-08-03','15:30:00',3.5),('15087','2013-08-03','15:35:00',3.41),('15087','2013-08-03','15:40:00',3.4),('15087','2013-08-03','15:45:00',3.38),('15087','2013-08-03','15:50:00',3.29),('15087','2013-08-03','15:55:00',3.08),('15087','2013-08-03','16:00:00',3.02),('15087','2013-08-03','16:05:00',2.98),('15087','2013-08-03','16:10:00',2.97),('15087','2013-08-03','16:15:00',2.71),('15087','2013-08-03','16:20:00',2.71),('15087','2013-08-03','16:25:00',2.8),('15087','2013-08-03','16:30:00',2.71),('15087','2013-08-03','16:35:00',2.66),('15087','2013-08-03','16:40:00',2.46),('15087','2013-08-03','16:45:00',2.43),('15087','2013-08-03','16:50:00',2.39),('15087','2013-08-03','16:55:00',2.35),('15087','2013-08-03','17:00:00',2.3),('15087','2013-08-03','17:05:00',2.2),('15087','2013-08-03','17:10:00',2.15),('15087','2013-08-03','17:15:00',2.1),('15087','2013-08-03','17:20:00',1.98),('15087','2013-08-03','17:25:00',1.88),('15087','2013-08-03','17:30:00',1.78),('15087','2013-08-03','17:35:00',1.71),('15087','2013-08-03','17:40:00',1.61),('15087','2013-08-03','17:45:00',1.44),('15087','2013-08-03','17:50:00',1.42),('15087','2013-08-03','17:55:00',1.43),('15087','2013-08-03','18:00:00',1.32),('15087','2013-08-03','18:05:00',1.24),('15087','2013-08-03','18:10:00',1.22),('15087','2013-08-03','18:15:00',1.13),('15087','2013-08-03','18:20:00',1.06),('15087','2013-08-02','07:50:00',1.05),('15087','2013-08-02','07:55:00',1.14),('15087','2013-08-02','08:00:00',1.23),('15087','2013-08-02','08:05:00',1.32),('15087','2013-08-02','08:10:00',1.41),('15087','2013-08-02','08:15:00',1.49),('15087','2013-08-02','08:20:00',1.58),('15087','2013-08-02','08:25:00',1.67),('15087','2013-08-02','08:30:00',1.74),('15087','2013-08-02','08:35:00',1.86),('15087','2013-08-02','08:40:00',1.92),('15087','2013-08-02','08:45:00',2.01),('15087','2013-08-02','08:50:00',2.09),('15087','2013-08-02','08:55:00',2.18),('15087','2013-08-02','09:00:00',2.32),('15087','2013-08-02','09:05:00',2.45),('15087','2013-08-02','09:10:00',2.53),('15087','2013-08-02','09:15:00',2.61),('15087','2013-08-02','09:20:00',2.68),('15087','2013-08-02','09:25:00',2.76),('15087','2013-08-02','09:30:00',2.81),('15087','2013-08-02','09:35:00',2.9),('15087','2013-08-02','09:40:00',2.96),('15087','2013-08-02','09:45:00',3.02),('15087','2013-08-02','09:50:00',3.08),('15087','2013-08-02','09:55:00',3.12),('15087','2013-08-02','10:00:00',3.19),('15087','2013-08-02','10:05:00',3.27),('15087','2013-08-02','10:10:00',3.31),('15087','2013-08-02','10:15:00',3.35),('15087','2013-08-02','10:20:00',3.42),('15087','2013-08-02','10:25:00',3.46),('15087','2013-08-02','10:30:00',3.52),('15087','2013-08-02','10:35:00',3.58),('15087','2013-08-02','10:40:00',3.65),('15087','2013-08-02','10:45:00',3.69),('15087','2013-08-02','10:50:00',3.73),('15087','2013-08-02','10:55:00',3.73),('15087','2013-08-02','11:00:00',3.8),('15087','2013-08-02','11:05:00',3.86),('15087','2013-08-02','11:10:00',3.9),('15087','2013-08-02','11:15:00',3.87),('15087','2013-08-02','11:20:00',3.96),('15087','2013-08-02','11:25:00',4.01),('15087','2013-08-02','11:30:00',4.04),('15087','2013-08-02','11:35:00',4.07),('15087','2013-08-02','11:40:00',4.1),('15087','2013-08-02','11:45:00',4.12),('15087','2013-08-02','11:50:00',4.14),('15087','2013-08-02','11:55:00',4.2),('15087','2013-08-02','12:00:00',4.22),('15087','2013-08-02','12:05:00',4.26),('15087','2013-08-02','12:10:00',4.25),('15087','2013-08-02','12:15:00',4.26),('15087','2013-08-02','12:20:00',4.26),('15087','2013-08-02','12:25:00',4.27),('15087','2013-08-02','12:30:00',4.27),('15087','2013-08-02','12:35:00',4.27),('15087','2013-08-02','12:40:00',4.27),('15087','2013-08-02','12:45:00',4.28),('15087','2013-08-02','12:50:00',4.27),('15087','2013-08-02','12:55:00',4.31),('15087','2013-08-02','13:00:00',4.3),('15087','2013-08-02','13:05:00',4.29),('15087','2013-08-02','13:10:00',4.3),('15087','2013-08-02','13:15:00',4.32),('15087','2013-08-02','13:20:00',4.3),('15087','2013-08-02','13:25:00',4.32),('15087','2013-08-02','13:30:00',4.26),('15087','2013-08-02','13:35:00',4.34),('15087','2013-08-02','13:40:00',4.35),('15087','2013-08-02','13:45:00',4.32),('15087','2013-08-02','13:50:00',4.31),('15087','2013-08-02','13:55:00',4.32),('15087','2013-08-02','14:00:00',4.28),('15087','2013-08-02','14:05:00',4.25),('15087','2013-08-02','14:10:00',4.2),('15087','2013-08-02','14:15:00',4.15),('15087','2013-08-02','14:20:00',4),('15087','2013-08-02','14:25:00',3.95),('15087','2013-08-02','14:30:00',3.99),('15087','2013-08-02','14:35:00',4.13),('15087','2013-08-02','14:40:00',4.11),('15087','2013-08-02','14:45:00',3.98),('15087','2013-08-02','14:50:00',3.97),('15087','2013-08-02','14:55:00',3.96),('15087','2013-08-02','15:00:00',3.92),('15087','2013-08-02','15:05:00',3.83),('15087','2013-08-02','15:10:00',3.62),('15087','2013-08-02','15:15:00',3.61),('15087','2013-08-02','15:20:00',3.67),('15087','2013-08-02','15:25:00',3.67),('15087','2013-08-02','15:30:00',3.58),('15087','2013-08-02','15:35:00',3.51),('15087','2013-08-02','15:40:00',3.46),('15087','2013-08-02','15:45:00',3.41),('15087','2013-08-02','15:50:00',3.32),('15087','2013-08-02','15:55:00',3.16),('15087','2013-08-02','16:00:00',3.07),('15087','2013-08-02','16:05:00',3.12),('15087','2013-08-02','16:10:00',3.05),('15087','2013-08-02','16:15:00',2.87),('15087','2013-08-02','16:20:00',2.87),('15087','2013-08-02','16:25:00',2.91),('15087','2013-08-02','16:30:00',2.84),('15087','2013-08-02','16:35:00',2.78),('15087','2013-08-02','16:40:00',2.58),('15087','2013-08-02','16:45:00',2.58),('15087','2013-08-02','16:50:00',2.55),('15087','2013-08-02','16:55:00',2.45),('15087','2013-08-02','17:00:00',2.36),('15087','2013-08-02','17:05:00',2.36),('15087','2013-08-02','17:10:00',2.25),('15087','2013-08-02','17:15:00',2.15),('15087','2013-08-02','17:20:00',2.09),('15087','2013-08-02','17:25:00',1.97),('15087','2013-08-02','17:30:00',1.86),('15087','2013-08-02','17:35:00',1.81),('15087','2013-08-02','17:40:00',1.72),('15087','2013-08-02','17:45:00',1.66),('15087','2013-08-02','17:50:00',1.54),('15087','2013-08-02','17:55:00',1.48),('15087','2013-08-02','18:00:00',1.39),('15087','2013-08-02','18:05:00',1.29),('15087','2013-08-02','18:10:00',1.18),('15087','2013-08-02','18:15:00',1.17),('15087','2013-08-02','18:20:00',1.1),('15087','2013-08-02','18:25:00',1.03),('15087','2013-08-01','07:50:00',1.07),('15087','2013-08-01','07:55:00',1.15),('15087','2013-08-01','08:00:00',1.23),('15087','2013-08-01','08:05:00',1.32),('15087','2013-08-01','08:10:00',1.4),('15087','2013-08-01','08:15:00',1.49),('15087','2013-08-01','08:20:00',1.58),('15087','2013-08-01','08:25:00',1.68),('15087','2013-08-01','08:30:00',1.78),('15087','2013-08-01','08:35:00',1.86),('15087','2013-08-01','08:40:00',1.96),('15087','2013-08-01','08:45:00',2.04),('15087','2013-08-01','08:50:00',2.14),('15087','2013-08-01','08:55:00',2.26),('15087','2013-08-01','09:00:00',2.37),('15087','2013-08-01','09:05:00',2.49),('15087','2013-08-01','09:10:00',2.58),('15087','2013-08-01','09:15:00',2.68),('15087','2013-08-01','09:20:00',2.77),('15087','2013-08-01','09:25:00',2.84),('15087','2013-08-01','09:30:00',2.91),('15087','2013-08-01','09:35:00',2.99),('15087','2013-08-01','09:40:00',3.07),('15087','2013-08-01','09:45:00',3.15),('15087','2013-08-01','09:50:00',3.22),('15087','2013-08-01','09:55:00',3.29),('15087','2013-08-01','10:00:00',3.37),('15087','2013-08-01','10:05:00',3.41),('15087','2013-08-01','10:10:00',3.47),('15087','2013-08-01','10:15:00',3.54),('15087','2013-08-01','10:20:00',3.57),('15087','2013-08-01','10:25:00',3.65),('15087','2013-08-01','10:30:00',3.69),('15087','2013-08-01','10:35:00',3.74),('15087','2013-08-01','10:40:00',3.79),('15087','2013-08-01','10:45:00',3.82),('15087','2013-08-01','10:50:00',3.92),('15087','2013-08-01','10:55:00',3.95),('15087','2013-08-01','11:00:00',3.98),('15087','2013-08-01','11:05:00',4.06),('15087','2013-08-01','11:10:00',4.1),('15087','2013-08-01','11:15:00',4.15),('15087','2013-08-01','11:20:00',4.17),('15087','2013-08-01','11:25:00',4.23),('15087','2013-08-01','11:30:00',4.25),('15087','2013-08-01','11:35:00',4.3),('15087','2013-08-01','11:40:00',4.37),('15087','2013-08-01','11:45:00',4.39),('15087','2013-08-01','11:50:00',4.39),('15087','2013-08-01','11:55:00',4.45),('15087','2013-08-01','12:00:00',4.44),('15087','2013-08-01','12:05:00',4.46),('15087','2013-08-01','12:10:00',4.45),('15087','2013-08-01','12:15:00',4.48),('15087','2013-08-01','12:20:00',4.52),('15087','2013-08-01','12:25:00',4.54),('15087','2013-08-01','12:30:00',4.54),('15087','2013-08-01','12:35:00',4.56),('15087','2013-08-01','12:40:00',4.59),('15087','2013-08-01','12:45:00',4.61),('15087','2013-08-01','12:50:00',4.59),('15087','2013-08-01','12:55:00',4.54),('15087','2013-08-01','13:00:00',4.52),('15087','2013-08-01','13:05:00',4.56),('15087','2013-08-01','13:10:00',4.59),('15087','2013-08-01','13:15:00',4.31),('15087','2013-08-01','13:20:00',4.45),('15087','2013-08-01','13:25:00',4.59),('15087','2013-08-01','13:30:00',4.57),('15087','2013-08-01','13:35:00',4.56),('15087','2013-08-01','13:40:00',4.6),('15087','2013-08-01','13:45:00',4.66),('15087','2013-08-01','13:50:00',4.66),('15087','2013-08-01','13:55:00',4.01),('15087','2013-08-01','14:00:00',4.57),('15087','2013-08-01','14:05:00',4.5),('15087','2013-08-01','14:10:00',4.45),('15087','2013-08-01','14:15:00',4.31),('15087','2013-08-01','14:20:00',4.25),('15087','2013-08-01','14:25:00',4.18),('15087','2013-08-01','14:30:00',4.19),('15087','2013-08-01','14:35:00',4.07),('15087','2013-08-01','14:40:00',4.18),('15087','2013-08-01','14:45:00',4.12),('15087','2013-08-01','14:50:00',2.81),('15087','2013-08-01','14:55:00',4.09),('15087','2013-08-01','15:00:00',3.98),('15087','2013-08-01','15:05:00',3.99),('15087','2013-08-01','15:10:00',3.88),('15087','2013-08-01','15:15:00',3.75),('15087','2013-08-01','15:20:00',3.86),('15087','2013-08-01','15:25:00',3.81),('15087','2013-08-01','15:30:00',3.72),('15087','2013-08-01','15:35:00',3.62),('15087','2013-08-01','15:40:00',3.07),('15087','2013-08-01','15:45:00',3.52),('15087','2013-08-01','15:50:00',3.48),('15087','2013-08-01','15:55:00',3.34),('15087','2013-08-01','16:00:00',3.17),('15087','2013-08-01','16:05:00',3.34),('15087','2013-08-01','16:10:00',3.21),('15087','2013-08-01','16:15:00',3.03),('15087','2013-08-01','16:20:00',3.04),('15087','2013-08-01','16:25:00',3.03),('15087','2013-08-01','16:30:00',2.94),('15087','2013-08-01','16:35:00',2.84),('15087','2013-08-01','16:40:00',2.63),('15087','2013-08-01','16:45:00',2.66),('15087','2013-08-01','16:50:00',2.65),('15087','2013-08-01','16:55:00',2.6),('15087','2013-08-01','17:00:00',2.51),('15087','2013-08-01','17:05:00',2.46),('15087','2013-08-01','17:10:00',2.39),('15087','2013-08-01','17:15:00',2.27),('15087','2013-08-01','17:20:00',2.2),('15087','2013-08-01','17:25:00',2.07),('15087','2013-08-01','17:30:00',1.97),('15087','2013-08-01','17:35:00',1.88),('15087','2013-08-01','17:40:00',1.82),('15087','2013-08-01','17:45:00',1.68),('15087','2013-08-01','17:50:00',1.63),('15087','2013-08-01','17:55:00',1.55),('15087','2013-08-01','18:00:00',1.49),('15087','2013-08-01','18:05:00',1.38),('15087','2013-08-01','18:10:00',1.3),('15087','2013-08-01','18:15:00',1.23),('15087','2013-08-01','18:20:00',1.12),('15087','2013-08-01','18:25:00',1.07),('15087','2013-07-31','07:45:00',1.01),('15087','2013-07-31','07:50:00',1.09),('15087','2013-07-31','07:55:00',1.18),('15087','2013-07-31','08:00:00',1.28),('15087','2013-07-31','08:05:00',1.37),('15087','2013-07-31','08:10:00',1.47),('15087','2013-07-31','08:15:00',1.54),('15087','2013-07-31','08:20:00',1.66),('15087','2013-07-31','08:25:00',1.76),('15087','2013-07-31','08:30:00',1.88),('15087','2013-07-31','08:35:00',1.97),('15087','2013-07-31','08:40:00',2.07),('15087','2013-07-31','08:45:00',2.18),('15087','2013-07-31','08:50:00',2.29),('15087','2013-07-31','08:55:00',2.39),('15087','2013-07-31','09:00:00',2.47),('15087','2013-07-31','09:05:00',2.56),('15087','2013-07-31','09:10:00',2.64),('15087','2013-07-31','09:15:00',2.71),('15087','2013-07-31','09:20:00',2.79),('15087','2013-07-31','09:25:00',2.87),('15087','2013-07-31','09:30:00',2.94),('15087','2013-07-31','09:35:00',3.02),('15087','2013-07-31','09:40:00',3.1),('15087','2013-07-31','09:45:00',3.16),('15087','2013-07-31','09:50:00',3.24),('15087','2013-07-31','09:55:00',3.3),('15087','2013-07-31','10:00:00',3.35),('15087','2013-07-31','10:05:00',3.42),('15087','2013-07-31','10:10:00',3.47),('15087','2013-07-31','10:15:00',3.53),('15087','2013-07-31','10:20:00',3.61),('15087','2013-07-31','10:25:00',3.65),('15087','2013-07-31','10:30:00',3.67),('15087','2013-07-31','10:35:00',3.74),('15087','2013-07-31','10:40:00',3.85),('15087','2013-07-31','10:45:00',3.9),('15087','2013-07-31','10:50:00',3.98),('15087','2013-07-31','10:55:00',4.03),('15087','2013-07-31','11:00:00',4.06),('15087','2013-07-31','11:05:00',4.1),('15087','2013-07-31','11:10:00',4.16),('15087','2013-07-31','11:15:00',4.2),('15087','2013-07-31','11:20:00',4.23),('15087','2013-07-31','11:25:00',4.28),('15087','2013-07-31','11:30:00',4.29),('15087','2013-07-31','11:35:00',4.34),('15087','2013-07-31','11:40:00',4.38),('15087','2013-07-31','11:45:00',4.43),('15087','2013-07-31','11:50:00',4.47),('15087','2013-07-31','11:55:00',4.52),('15087','2013-07-31','12:00:00',4.48),('15087','2013-07-31','12:05:00',4.48),('15087','2013-07-31','12:10:00',4.53),('15087','2013-07-31','12:15:00',4.61),('15087','2013-07-31','12:20:00',4.58),('15087','2013-07-31','12:25:00',4.65),('15087','2013-07-31','12:30:00',4.63),('15087','2013-07-31','12:35:00',4.59),('15087','2013-07-31','12:40:00',4.66),('15087','2013-07-31','12:45:00',3.83),('15087','2013-07-31','12:50:00',2.06),('15087','2013-07-31','12:55:00',4.87),('15087','2013-07-31','13:00:00',1.69),('15087','2013-07-31','13:05:00',4.1),('15087','2013-07-31','13:10:00',4.26),('15087','2013-07-31','13:15:00',4.71),('15087','2013-07-31','13:20:00',4.61),('15087','2013-07-31','13:25:00',4.24),('15087','2013-07-31','13:30:00',4.37),('15087','2013-07-31','13:35:00',4.59),('15087','2013-07-31','13:40:00',4.66),('15087','2013-07-31','13:45:00',4.73),('15087','2013-07-31','13:50:00',4.78),('15087','2013-07-31','13:55:00',2.77),('15087','2013-07-31','14:00:00',3.68),('15087','2013-07-31','14:05:00',4.68),('15087','2013-07-31','14:10:00',4.66),('15087','2013-07-31','14:15:00',3.66),('15087','2013-07-31','14:20:00',3.81),('15087','2013-07-31','14:25:00',3.39),('15087','2013-07-31','14:30:00',4.45),('15087','2013-07-31','14:35:00',4.31),('15087','2013-07-31','14:40:00',4.41),('15087','2013-07-31','14:45:00',4.25),('15087','2013-07-31','14:50:00',4.31),('15087','2013-07-31','14:55:00',3.04),('15087','2013-07-31','15:00:00',1.04),('15087','2013-07-31','15:05:00',3.98),('15087','2013-07-31','15:10:00',4.01),('15087','2013-07-31','15:15:00',3.46),('15087','2013-07-31','15:20:00',3.66),('15087','2013-07-31','15:25:00',3.96),('15087','2013-07-31','15:30:00',3.36),('15087','2013-07-31','15:35:00',3.75),('15087','2013-07-31','15:40:00',3.74),('15087','2013-07-31','15:45:00',3.6),('15087','2013-07-31','15:50:00',3.51),('15087','2013-07-31','15:55:00',3.37),('15087','2013-07-31','16:00:00',3.19),('15087','2013-07-31','16:05:00',3.32),('15087','2013-07-31','16:10:00',3.29),('15087','2013-07-31','16:15:00',3.18),('15087','2013-07-31','16:20:00',3.06),('15087','2013-07-31','16:25:00',3.01),('15087','2013-07-31','16:30:00',2.99),('15087','2013-07-31','16:35:00',2.86),('15087','2013-07-31','16:40:00',2.71),('15087','2013-07-31','16:45:00',2.67),('15087','2013-07-31','16:50:00',2.69),('15087','2013-07-31','16:55:00',2.65),('15087','2013-07-31','17:00:00',2.55),('15087','2013-07-31','17:05:00',2.38),('15087','2013-07-31','17:10:00',2.17),('15087','2013-07-31','17:15:00',2.35),('15087','2013-07-31','17:20:00',1.45),('15087','2013-07-31','17:25:00',2.11),('15087','2013-07-31','17:30:00',2),('15087','2013-07-31','17:35:00',1.77),('15087','2013-07-31','17:40:00',1.77),('15087','2013-07-31','17:45:00',1.67),('15087','2013-07-31','17:50:00',1.63),('15087','2013-07-31','17:55:00',1.55),('15087','2013-07-31','18:00:00',1.47),('15087','2013-07-31','18:05:00',1.38),('15087','2013-07-31','18:10:00',1.26),('15087','2013-07-31','18:15:00',1.19),('15087','2013-07-31','18:20:00',1.16),('15087','2013-07-31','18:25:00',1.11),('15087','2013-07-31','18:30:00',1.02),('15087','2014-04-08','08:15:00',1.06),('15087','2014-04-08','08:20:00',1.47),('15087','2014-04-08','08:25:00',1.03),('15087','2014-04-08','08:30:00',1.5),('15087','2014-04-08','08:35:00',1.42),('15087','2014-04-08','08:40:00',1.31),('15087','2014-04-08','08:45:00',1.7),('15087','2014-04-08','08:50:00',1.74),('15087','2014-04-08','08:55:00',1.9),('15087','2014-04-08','09:00:00',1.98),('15087','2014-04-08','09:05:00',2.07),('15087','2014-04-08','09:10:00',2.15),('15087','2014-04-08','09:15:00',2.25),('15087','2014-04-08','09:20:00',2.33),('15087','2014-04-08','09:25:00',2.44),('15087','2014-04-08','09:30:00',2.5),('15087','2014-04-08','09:35:00',2.57),('15087','2014-04-08','09:40:00',2.62),('15087','2014-04-08','09:45:00',2.7),('15087','2014-04-08','09:50:00',2.77),('15087','2014-04-08','09:55:00',2.82),('15087','2014-04-08','10:00:00',2.88),('15087','2014-04-08','10:05:00',2.86),('15087','2014-04-08','10:10:00',3.02),('15087','2014-04-08','10:15:00',3.17),('15087','2014-04-08','10:20:00',3.25),('15087','2014-04-08','10:25:00',3.3),('15087','2014-04-08','10:30:00',3.37),('15087','2014-04-08','10:35:00',3.4),('15087','2014-04-08','10:40:00',3.5),('15087','2014-04-08','10:45:00',3.53),('15087','2014-04-08','10:50:00',3.57),('15087','2014-04-08','10:55:00',3.68),('15087','2014-04-08','11:00:00',3.64),('15087','2014-04-08','11:05:00',3.59),('15087','2014-04-08','11:10:00',3.75),('15087','2014-04-08','11:15:00',3.73),('15087','2014-04-08','11:20:00',3.91),('15087','2014-04-08','11:25:00',3.83),('15087','2014-04-08','11:30:00',3.88),('15087','2014-04-08','11:35:00',3.82),('15087','2014-04-08','11:40:00',3.99),('15087','2014-04-08','11:45:00',4.02),('15087','2014-04-08','11:50:00',4.05),('15087','2014-04-08','11:55:00',4.07),('15087','2014-04-08','12:00:00',4.12),('15087','2014-04-08','12:05:00',4.07),('15087','2014-04-08','12:10:00',3.99),('15087','2014-04-08','12:15:00',3.74),('15087','2014-04-08','12:20:00',3.78),('15087','2014-04-08','12:25:00',3.74),('15087','2014-04-08','12:30:00',4.38),('15087','2014-04-08','12:35:00',4.41),('15087','2014-04-08','12:40:00',3.68),('15087','2014-04-08','12:45:00',2.79),('15087','2014-04-08','12:50:00',3.79),('15087','2014-04-08','12:55:00',4.25),('15087','2014-04-08','13:00:00',4.1),('15087','2014-04-08','13:05:00',4.27),('15087','2014-04-08','13:10:00',4.35),('15087','2014-04-08','13:15:00',4.49),('15087','2014-04-08','13:20:00',4.43),('15087','2014-04-08','13:25:00',4.47),('15087','2014-04-08','13:30:00',4.46),('15087','2014-04-08','13:35:00',4.5),('15087','2014-04-08','13:40:00',4.46),('15087','2014-04-08','13:45:00',4.38),('15087','2014-04-08','13:50:00',4.4),('15087','2014-04-08','13:55:00',4.37),('15087','2014-04-08','14:00:00',4.33),('15087','2014-04-08','14:05:00',4.33),('15087','2014-04-08','14:10:00',4.3),('15087','2014-04-08','14:15:00',4.13),('15087','2014-04-08','14:20:00',3.72),('15087','2014-04-08','14:25:00',3.89),('15087','2014-04-08','14:30:00',4.17),('15087','2014-04-08','14:35:00',3.91),('15087','2014-04-08','14:40:00',3.49),('15087','2014-04-08','14:45:00',3.56),('15087','2014-04-08','14:50:00',3.83),('15087','2014-04-08','14:55:00',3.89),('15087','2014-04-08','15:00:00',3.68),('15087','2014-04-08','15:05:00',3.7),('15087','2014-04-08','15:10:00',3.62),('15087','2014-04-08','15:15:00',3.57),('15087','2014-04-08','15:20:00',3.37),('15087','2014-04-08','15:25:00',3.14),('15087','2014-04-08','15:30:00',3.03),('15087','2014-04-08','15:35:00',3.07),('15087','2014-04-08','15:40:00',3.11),('15087','2014-04-08','15:45:00',3.05),('15087','2014-04-08','15:50:00',3.1),('15087','2014-04-08','15:55:00',3.06),('15087','2014-04-08','16:00:00',2.76),('15087','2014-04-08','16:05:00',2.64),('15087','2014-04-08','16:10:00',2.63),('15087','2014-04-08','16:15:00',2.52),('15087','2014-04-08','16:20:00',2.3),('15087','2014-04-08','16:25:00',2.46),('15087','2014-04-08','16:30:00',2.56),('15087','2014-04-08','16:35:00',2.45),('15087','2014-04-08','16:40:00',2.31),('15087','2014-04-08','16:45:00',2.27),('15087','2014-04-08','16:50:00',2.3),('15087','2014-04-08','16:55:00',2.07),('15087','2014-04-08','17:00:00',1.92),('15087','2014-04-08','17:05:00',2),('15087','2014-04-08','17:10:00',1.8),('15087','2014-04-08','17:15:00',1.72),('15087','2014-04-08','17:20:00',1.61),('15087','2014-04-08','17:25:00',1.39),('15087','2014-04-08','17:30:00',1.29),('15087','2014-04-08','17:35:00',1.18),('15087','2014-04-08','17:40:00',1.19),('15087','2014-04-08','17:45:00',1.08),('15087','2014-04-08','17:50:00',1.03),('15087','2013-07-30','07:45:00',1.01),('15087','2013-07-30','07:50:00',1.04),('15087','2013-07-30','07:55:00',1.12),('15087','2013-07-30','08:00:00',1.26),('15087','2013-07-30','08:05:00',1.39),('15087','2013-07-30','08:10:00',1.49),('15087','2013-07-30','08:15:00',1.61),('15087','2013-07-30','08:20:00',1.82),('15087','2013-07-30','08:25:00',1.74),('15087','2013-07-30','08:30:00',1.81),('15087','2013-07-30','08:35:00',1.86),('15087','2013-07-30','08:40:00',1.94),('15087','2013-07-30','08:45:00',2.05),('15087','2013-07-30','08:50:00',2.12),('15087','2013-07-30','08:55:00',2.35),('15087','2013-07-30','09:00:00',2.47),('15087','2013-07-30','09:05:00',2.54),('15087','2013-07-30','09:10:00',2.58),('15087','2013-07-30','09:15:00',2.73),('15087','2013-07-30','09:20:00',2.83),('15087','2013-07-30','09:25:00',2.71),('15087','2013-07-30','09:30:00',2.75),('15087','2013-07-30','09:35:00',2.95),('15087','2013-07-30','09:55:00',2.29),('15087','2013-07-30','10:00:00',2.36),('15087','2013-07-30','10:05:00',2.52),('15087','2013-07-30','10:10:00',3.69),('15087','2013-07-30','10:15:00',3.63),('15087','2013-07-30','10:20:00',3.76),('15087','2013-07-30','10:25:00',3.85),('15087','2013-07-30','10:30:00',3.87),('15087','2013-07-30','10:35:00',3.85),('15087','2013-07-30','10:40:00',3.82),('15087','2013-07-30','10:45:00',3.88),('15087','2013-07-30','10:50:00',3.85),('15087','2013-07-30','10:55:00',3.82),('15087','2013-07-30','11:00:00',3.63),('15087','2013-07-30','11:05:00',3.86),('15087','2013-07-30','11:10:00',3.94),('15087','2013-07-30','11:15:00',3.31),('15087','2013-07-30','11:20:00',4.31),('15087','2013-07-30','11:25:00',4.1),('15087','2013-07-30','11:30:00',4.1),('15087','2013-07-30','11:35:00',4.38),('15087','2013-07-30','11:40:00',4.32),('15087','2013-07-30','11:45:00',4.01),('15087','2013-07-30','11:50:00',1.32),('15087','2013-07-30','11:55:00',3.91),('15087','2013-07-30','12:00:00',4.34),('15087','2013-07-30','12:05:00',4.36),('15087','2013-07-30','12:10:00',4.18),('15087','2013-07-30','12:15:00',4.33),('15087','2013-07-30','12:20:00',4.45),('15087','2013-07-30','12:25:00',4.47),('15087','2013-07-30','12:30:00',4.43),('15087','2013-07-30','12:35:00',2.78),('15087','2013-07-30','12:45:00',3.89),('15087','2013-07-30','12:50:00',4.69),('15087','2013-07-30','12:55:00',4.2),('15087','2013-07-30','13:00:00',3.14),('15087','2013-07-30','13:05:00',2.96),('15087','2013-07-30','13:10:00',3.25),('15087','2013-07-30','13:15:00',2.57),('15087','2013-07-30','13:20:00',4.64),('15087','2013-07-30','13:25:00',4.77),('15087','2013-07-30','13:30:00',4.7),('15087','2013-07-30','13:35:00',4.6),('15087','2013-07-30','13:40:00',4.63),('15087','2013-07-30','13:45:00',4.53),('15087','2013-07-30','13:50:00',4.58),('15087','2013-07-30','13:55:00',4.64),('15087','2013-07-30','14:00:00',4.6),('15087','2013-07-30','14:05:00',2.29),('15087','2013-07-30','14:10:00',4.13),('15087','2013-07-30','14:15:00',4.51),('15087','2013-07-30','14:20:00',4.49),('15087','2013-07-30','14:25:00',3.87),('15087','2013-07-30','14:30:00',4.22),('15087','2013-07-30','14:35:00',4.32),('15087','2013-07-30','14:40:00',4.16),('15087','2013-07-30','14:45:00',4.1),('15087','2013-07-30','14:50:00',4.05),('15087','2013-07-30','14:55:00',3.97),('15087','2013-07-30','15:00:00',4),('15087','2013-07-30','15:05:00',3.9),('15087','2013-07-30','15:10:00',3.74),('15087','2013-07-30','15:15:00',3.54),('15087','2013-07-30','15:20:00',3.61),('15087','2013-07-30','15:25:00',3.7),('15087','2013-07-30','15:30:00',3.64),('15087','2013-07-30','15:35:00',3.52),('15087','2013-07-30','15:40:00',3.36),('15087','2013-07-30','15:45:00',3.27),('15087','2013-07-30','15:50:00',3.32),('15087','2013-07-30','15:55:00',3.31),('15087','2013-07-30','16:00:00',3.14),('15087','2013-07-30','16:05:00',3.03),('15087','2013-07-30','16:10:00',3.11),('15087','2013-07-30','16:15:00',3.06),('15087','2013-07-30','16:20:00',2.93),('15087','2013-07-30','16:25:00',2.92),('15087','2013-07-30','16:30:00',2.86),('15087','2013-07-30','16:35:00',2.77),('15087','2013-07-30','16:40:00',2.67),('15087','2013-07-30','16:45:00',2.69),('15087','2013-07-30','16:50:00',2.61),('15087','2013-07-30','16:55:00',2.55),('15087','2013-07-30','17:00:00',2.49),('15087','2013-07-30','17:05:00',2.35),('15087','2013-07-30','17:10:00',2.31),('15087','2013-07-30','17:15:00',2.17),('15087','2013-07-30','17:20:00',2.13),('15087','2013-07-30','17:25:00',2.01),('15087','2013-07-30','17:30:00',1.98),('15087','2013-07-30','17:35:00',1.87),('15087','2013-07-30','17:40:00',1.82),('15087','2013-07-30','17:45:00',1.6),('15087','2013-07-30','17:50:00',1.6),('15087','2013-07-30','17:55:00',1.52),('15087','2013-07-30','18:00:00',1.43),('15087','2013-07-30','18:05:00',1.33),('15087','2013-07-30','18:10:00',1.24),('15087','2013-07-30','18:15:00',1.13),('15087','2013-07-30','18:20:00',1.12),('15087','2013-07-30','18:25:00',1.07),('15087','2013-07-29','07:55:00',1.06),('15087','2013-07-29','08:00:00',1.15),('15087','2013-07-29','08:05:00',1.24),('15087','2013-07-29','08:10:00',1.32),('15087','2013-07-29','08:15:00',1.38),('15087','2013-07-29','08:20:00',1.47),('15087','2013-07-29','08:25:00',1.54),('15087','2013-07-29','08:30:00',1.62),('15087','2013-07-29','08:35:00',1.7),('15087','2013-07-29','08:40:00',1.71),('15087','2013-07-29','08:45:00',1.79),('15087','2013-07-29','08:50:00',1.92),('15087','2013-07-29','08:55:00',1.99),('15087','2013-07-29','09:00:00',2.09),('15087','2013-07-29','09:05:00',2.21),('15087','2013-07-29','09:10:00',2.31),('15087','2013-07-29','09:15:00',2.38),('15087','2013-07-29','09:20:00',2.46),('15087','2013-07-29','09:25:00',2.53),('15087','2013-07-29','09:30:00',2.57),('15087','2013-07-29','09:35:00',2.67),('15087','2013-07-29','09:40:00',2.79),('15087','2013-07-29','09:45:00',2.88),('15087','2013-07-29','09:50:00',2.96),('15087','2013-07-29','09:55:00',3.03),('15087','2013-07-29','10:00:00',3.09),('15087','2013-07-29','10:05:00',3.17),('15087','2013-07-29','10:10:00',3.22),('15087','2013-07-29','10:15:00',3.25),('15087','2013-07-29','10:20:00',3.34),('15087','2013-07-29','10:25:00',3.42),('15087','2013-07-29','10:30:00',3.49),('15087','2013-07-29','10:35:00',3.49),('15087','2013-07-29','10:40:00',3.55),('15087','2013-07-29','10:45:00',3.57),('15087','2013-07-29','10:50:00',3.63),('15087','2013-07-29','10:55:00',3.65),('15087','2013-07-29','11:00:00',3.68),('15087','2013-07-29','11:05:00',3.72),('15087','2013-07-29','11:10:00',3.75),('15087','2013-07-29','11:15:00',3.75),('15087','2013-07-29','11:20:00',3.84),('15087','2013-07-29','11:25:00',3.87),('15087','2013-07-29','11:30:00',3.87),('15087','2013-07-29','11:35:00',3.89),('15087','2013-07-29','11:40:00',3.93),('15087','2013-07-29','11:45:00',3.95),('15087','2013-07-29','11:50:00',3.95),('15087','2013-07-29','11:55:00',3.95),('15087','2013-07-29','12:00:00',4.06),('15087','2013-07-29','12:05:00',4.1),('15087','2013-07-29','12:10:00',4.11),('15087','2013-07-29','12:15:00',4.09),('15087','2013-07-29','12:20:00',4.1),('15087','2013-07-29','12:25:00',4.13),('15087','2013-07-29','12:30:00',4.13),('15087','2013-07-29','12:35:00',4.14),('15087','2013-07-29','12:40:00',4.15),('15087','2013-07-29','12:45:00',4.16),('15087','2013-07-29','12:50:00',4.12),('15087','2013-07-29','12:55:00',4.08),('15087','2013-07-29','13:00:00',4.19),('15087','2013-07-29','13:05:00',4.16),('15087','2013-07-29','13:10:00',4.26),('15087','2013-07-29','13:15:00',4.26),('15087','2013-07-29','13:20:00',4.31),('15087','2013-07-29','13:25:00',4.34),('15087','2013-07-29','13:30:00',4.33),('15087','2013-07-29','13:35:00',4.36),('15087','2013-07-29','13:40:00',4.36),('15087','2013-07-29','13:45:00',4.39),('15087','2013-07-29','13:50:00',4.37),('15087','2013-07-29','13:55:00',4.33),('15087','2013-07-29','14:00:00',4.32),('15087','2013-07-29','14:05:00',4.31),('15087','2013-07-29','14:10:00',4.27),('15087','2013-07-29','14:15:00',4.28),('15087','2013-07-29','14:20:00',4.24),('15087','2013-07-29','14:25:00',4.16),('15087','2013-07-29','14:30:00',4.1),('15087','2013-07-29','14:35:00',4.11),('15087','2013-07-29','14:40:00',4.07),('15087','2013-07-29','14:45:00',4.04),('15087','2013-07-29','14:50:00',3.95),('15087','2013-07-29','14:55:00',3.83),('15087','2013-07-29','15:00:00',3.88),('15087','2013-07-29','15:05:00',3.85),('15087','2013-07-29','15:10:00',3.79),('15087','2013-07-29','15:15:00',3.68),('15087','2013-07-29','15:20:00',3.68),('15087','2013-07-29','15:25:00',3.64),('15087','2013-07-29','15:30:00',3.6),('15087','2013-07-29','15:35:00',3.56),('15087','2013-07-29','15:40:00',3.51),('15087','2013-07-29','15:45:00',3.51),('15087','2013-07-29','15:50:00',2.72),('15087','2013-07-29','15:55:00',1.96),('15087','2013-07-29','16:00:00',1.87),('15087','2013-07-29','16:05:00',3.01),('15087','2013-07-29','16:10:00',3.14),('15087','2013-07-29','16:15:00',2.45),('15087','2013-07-29','16:20:00',2.51),('15087','2013-07-29','16:25:00',2.5),('15087','2013-07-29','16:30:00',2.84),('15087','2013-07-29','16:35:00',2.55),('15087','2013-07-29','16:40:00',2.47),('15087','2013-07-29','16:45:00',2.89),('15087','2013-07-29','16:50:00',2.59),('15087','2013-07-29','16:55:00',1.87),('15087','2013-07-29','17:00:00',1.35),('15087','2013-07-29','17:05:00',1.93),('15087','2013-07-29','17:10:00',1.31),('15087','2013-07-29','17:15:00',1.13),('15087','2013-07-29','17:20:00',2.08),('15087','2013-07-29','17:25:00',1.86),('15087','2013-07-29','17:30:00',1.32),('15087','2013-07-29','17:40:00',1.18),('15087','2013-07-29','17:45:00',1.8),('15087','2013-07-29','17:50:00',1.64),('15087','2013-07-29','17:55:00',1.36),('15087','2013-07-29','18:10:00',1.19),('15087','2013-07-29','18:15:00',1.03),('15087','2013-07-29','18:20:00',1.1),('15087','2013-07-29','18:25:00',1.04),('15087','2013-07-28','07:55:00',1.05),('15087','2013-07-28','08:00:00',1.13),('15087','2013-07-28','08:05:00',1.22),('15087','2013-07-28','08:10:00',1.28),('15087','2013-07-28','08:15:00',1.38),('15087','2013-07-28','08:20:00',1.46),('15087','2013-07-28','08:25:00',1.56),('15087','2013-07-28','08:30:00',1.65),('15087','2013-07-28','08:35:00',1.73),('15087','2013-07-28','08:40:00',1.81),('15087','2013-07-28','08:45:00',1.87),('15087','2013-07-28','08:50:00',1.97),('15087','2013-07-28','08:55:00',2.04),('15087','2013-07-28','09:00:00',2.14),('15087','2013-07-28','09:05:00',2.3),('15087','2013-07-28','09:10:00',2.38),('15087','2013-07-28','09:15:00',2.49),('15087','2013-07-28','09:20:00',2.53),('15087','2013-07-28','09:25:00',2.65),('15087','2013-07-28','09:30:00',2.71),('15087','2013-07-28','09:35:00',2.7),('15087','2013-07-28','09:40:00',2.78),('15087','2013-07-28','09:45:00',2.89),('15087','2013-07-28','09:50:00',2.96),('15087','2013-07-28','09:55:00',3.05),('15087','2013-07-28','10:00:00',3.07),('15087','2013-07-28','10:05:00',3.16),('15087','2013-07-28','10:10:00',3.23),('15087','2013-07-28','10:15:00',3.28),('15087','2013-07-28','10:20:00',3.31),('15087','2013-07-28','10:25:00',3.32),('15087','2013-07-28','10:30:00',3.44),('15087','2013-07-28','10:35:00',3.52),('15087','2013-07-28','10:40:00',3.56),('15087','2013-07-28','10:45:00',3.56),('15087','2013-07-28','10:50:00',3.62),('15087','2013-07-28','10:55:00',3.63),('15087','2013-07-28','11:00:00',3.7),('15087','2013-07-28','11:05:00',3.72),('15087','2013-07-28','11:10:00',3.71),('15087','2013-07-28','11:15:00',3.79),('15087','2013-07-28','11:20:00',3.8),('15087','2013-07-28','11:25:00',3.83),('15087','2013-07-28','11:30:00',3.91),('15087','2013-07-28','11:35:00',3.91),('15087','2013-07-28','11:40:00',3.96),('15087','2013-07-28','11:45:00',3.95),('15087','2013-07-28','11:50:00',3.98),('15087','2013-07-28','11:55:00',4.01),('15087','2013-07-28','12:00:00',4.05),('15087','2013-07-28','12:05:00',4.03),('15087','2013-07-28','12:10:00',3.95),('15087','2013-07-28','12:15:00',4.01),('15087','2013-07-28','12:20:00',4.1),('15087','2013-07-28','12:25:00',4.15),('15087','2013-07-28','12:30:00',4.24),('15087','2013-07-28','12:35:00',4.21),('15087','2013-07-28','12:40:00',4.2),('15087','2013-07-28','12:45:00',4.15),('15087','2013-07-28','12:50:00',4.2),('15087','2013-07-28','12:55:00',4.19),('15087','2013-07-28','13:00:00',4.13),('15087','2013-07-28','13:05:00',4.28),('15087','2013-07-28','13:10:00',4.25),('15087','2013-07-28','13:15:00',3.72),('15087','2013-07-28','13:20:00',4.07),('15087','2013-07-28','13:25:00',4.24),('15087','2013-07-28','13:30:00',4.3),('15087','2013-07-28','13:35:00',4.34),('15087','2013-07-28','13:40:00',4.33),('15087','2013-07-28','13:45:00',4.4),('15087','2013-07-28','13:50:00',4.32),('15087','2013-07-28','13:55:00',4.31),('15087','2013-07-28','14:00:00',4.27),('15087','2013-07-28','14:05:00',4.3),('15087','2013-07-28','14:10:00',4.31),('15087','2013-07-28','14:15:00',4.22),('15087','2013-07-28','14:20:00',4.2),('15087','2013-07-28','14:25:00',4.14),('15087','2013-07-28','14:30:00',4.06),('15087','2013-07-28','14:35:00',4.04),('15087','2013-07-28','14:40:00',4.07),('15087','2013-07-28','14:45:00',4),('15087','2013-07-28','14:50:00',3.95),('15087','2013-07-28','14:55:00',3.75),('15087','2013-07-28','15:00:00',3.84),('15087','2013-07-28','15:05:00',3.85),('15087','2013-07-28','15:10:00',3.77),('15087','2013-07-28','15:15:00',3.66),('15087','2013-07-28','15:20:00',3.62),('15087','2013-07-28','15:25:00',3.63),('15087','2013-07-28','15:30:00',3.53),('15087','2013-07-28','15:35:00',3.52),('15087','2013-07-28','15:40:00',3.4),('15087','2013-07-28','15:45:00',3.35),('15087','2013-07-28','15:50:00',3.35),('15087','2013-07-28','15:55:00',3.31),('15087','2013-07-28','16:00:00',3.14),('15087','2013-07-28','16:05:00',2.92),('15087','2013-07-28','16:10:00',2.78),('15087','2013-07-28','16:15:00',2.95),('15087','2013-07-28','16:20:00',2.89),('15087','2013-07-28','16:25:00',2.77),('15087','2013-07-28','16:30:00',2.77),('15087','2013-07-28','16:35:00',2.88),('15087','2013-07-28','16:40:00',2.65),('15087','2013-07-28','16:45:00',2.72),('15087','2013-07-28','16:50:00',2.69),('15087','2013-07-28','16:55:00',2.64),('15087','2013-07-28','17:00:00',2.54),('15087','2013-07-28','17:05:00',2.37),('15087','2013-07-28','17:10:00',2.24),('15087','2013-07-28','17:15:00',2.25),('15087','2013-07-28','17:20:00',2.18),('15087','2013-07-28','17:25:00',2.07),('15087','2013-07-28','17:30:00',2.02),('15087','2013-07-28','17:35:00',1.97),('15087','2013-07-28','17:40:00',1.83),('15087','2013-07-28','17:45:00',1.72),('15087','2013-07-28','17:50:00',1.67),('15087','2013-07-28','17:55:00',1.42),('15087','2013-07-28','18:00:00',1.36),('15087','2013-07-28','18:05:00',1.39),('15087','2013-07-28','18:10:00',1.23),('15087','2013-07-28','18:15:00',1.23),('15087','2013-07-28','18:20:00',1.17),('15087','2013-07-28','18:25:00',1.05),('15087','2013-07-27','07:55:00',1.09),('15087','2013-07-27','08:00:00',1.18),('15087','2013-07-27','08:05:00',1.26),('15087','2013-07-27','08:10:00',1.34),('15087','2013-07-27','08:15:00',1.43),('15087','2013-07-27','08:20:00',1.52),('15087','2013-07-27','08:25:00',1.6),('15087','2013-07-27','08:30:00',1.69),('15087','2013-07-27','08:35:00',1.77),('15087','2013-07-27','08:40:00',1.84),('15087','2013-07-27','08:45:00',1.93),('15087','2013-07-27','08:50:00',2.02),('15087','2013-07-27','08:55:00',2.13),('15087','2013-07-27','09:00:00',2.25),('15087','2013-07-27','09:05:00',2.38),('15087','2013-07-27','09:10:00',2.48),('15087','2013-07-27','09:15:00',2.54),('15087','2013-07-27','09:20:00',2.61),('15087','2013-07-27','09:25:00',2.69),('15087','2013-07-27','09:30:00',2.78),('15087','2013-07-27','09:35:00',2.87),('15087','2013-07-27','09:40:00',2.91),('15087','2013-07-27','09:45:00',2.96),('15087','2013-07-27','09:50:00',3.03),('15087','2013-07-27','09:55:00',3.11),('15087','2013-07-27','10:00:00',3.18),('15087','2013-07-27','10:05:00',3.23),('15087','2013-07-27','10:10:00',3.24),('15087','2013-07-27','10:15:00',3.35),('15087','2013-07-27','10:20:00',3.39),('15087','2013-07-27','10:25:00',3.48),('15087','2013-07-27','10:30:00',3.52),('15087','2013-07-27','10:35:00',3.57),('15087','2013-07-27','10:40:00',3.62),('15087','2013-07-27','10:45:00',3.68),('15087','2013-07-27','10:50:00',3.69),('15087','2013-07-27','10:55:00',3.73),('15087','2013-07-27','11:00:00',3.78),('15087','2013-07-27','11:05:00',3.86),('15087','2013-07-27','11:10:00',3.95),('15087','2013-07-27','11:15:00',3.98),('15087','2013-07-27','11:20:00',4),('15087','2013-07-27','11:25:00',3.99),('15087','2013-07-27','11:30:00',4.01),('15087','2013-07-27','11:35:00',4.04),('15087','2013-07-27','11:40:00',4.06),('15087','2013-07-27','11:45:00',4.09),('15087','2013-07-27','11:50:00',4.12),('15087','2013-07-27','11:55:00',4.12),('15087','2013-07-27','12:00:00',4.14),('15087','2013-07-27','12:05:00',4.15),('15087','2013-07-27','12:10:00',4.13),('15087','2013-07-27','12:15:00',4.14),('15087','2013-07-27','12:20:00',4.1),('15087','2013-07-27','12:25:00',4.13),('15087','2013-07-27','12:30:00',4.2),('15087','2013-07-27','12:35:00',4.22),('15087','2013-07-27','12:40:00',4.14),('15087','2013-07-27','12:45:00',4.28),('15087','2013-07-27','12:50:00',4.3),('15087','2013-07-27','12:55:00',4.34),('15087','2013-07-27','13:00:00',3.52),('15087','2013-07-27','13:05:00',1),('15087','2013-07-27','13:10:00',2.41),('15087','2013-07-27','13:15:00',4.08),('15087','2013-07-27','13:20:00',4.34),('15087','2013-07-27','13:25:00',4.36),('15087','2013-07-27','13:30:00',4.37),('15087','2013-07-27','13:35:00',4.28),('15087','2013-07-27','13:40:00',4.36),('15087','2013-07-27','13:45:00',4.37),('15087','2013-07-27','13:50:00',4.32),('15087','2013-07-27','13:55:00',4.35),('15087','2013-07-27','14:00:00',4.17),('15087','2013-07-27','14:05:00',4.38),('15087','2013-07-27','14:10:00',4.4),('15087','2013-07-27','14:15:00',4.25),('15087','2013-07-27','14:20:00',4.19),('15087','2013-07-27','14:25:00',4.2),('15087','2013-07-27','14:30:00',4.08),('15087','2013-07-27','14:35:00',4.08),('15087','2013-07-27','14:40:00',4),('15087','2013-07-27','14:45:00',4),('15087','2013-07-27','14:50:00',3.99),('15087','2013-07-27','14:55:00',3.81),('15087','2013-07-27','15:00:00',3.86),('15087','2013-07-27','15:05:00',3.88),('15087','2013-07-27','15:10:00',3.79),('15087','2013-07-27','15:15:00',3.74),('15087','2013-07-27','15:20:00',3.58),('15087','2013-07-27','15:25:00',3.56),('15087','2013-07-27','15:30:00',3.62),('15087','2013-07-27','15:35:00',3.58),('15087','2013-07-27','15:40:00',3.44),('15087','2013-07-27','15:45:00',3.43),('15087','2013-07-27','15:50:00',3.4),('15087','2013-07-27','15:55:00',3.35),('15087','2013-07-27','16:00:00',3.27),('15087','2013-07-27','16:05:00',3.03),('15087','2013-07-27','16:10:00',2.8),('15087','2013-07-27','16:15:00',3.02),('15087','2013-07-27','16:20:00',2.91),('15087','2013-07-27','16:25:00',2.83),('15087','2013-07-27','16:30:00',2.9),('15087','2013-07-27','16:35:00',2.88),('15087','2013-07-27','16:40:00',2.75),('15087','2013-07-27','16:45:00',2.76),('15087','2013-07-27','16:50:00',2.68),('15087','2013-07-27','16:55:00',2.62),('15087','2013-07-27','17:00:00',2.5),('15087','2013-07-27','17:05:00',2.41),('15087','2013-07-27','17:10:00',2.32),('15087','2013-07-27','17:15:00',2.27),('15087','2013-07-27','17:20:00',2.09),('15087','2013-07-27','17:25:00',2.1),('15087','2013-07-27','17:30:00',2.04),('15087','2013-07-27','17:35:00',1.96),('15087','2013-07-27','17:40:00',1.81),('15087','2013-07-27','17:45:00',1.75),('15087','2013-07-27','17:50:00',1.66),('15087','2013-07-27','17:55:00',1.46),('15087','2013-07-27','18:00:00',1.49),('15087','2013-07-27','18:05:00',1.4),('15087','2013-07-27','18:10:00',1.26),('15087','2013-07-27','18:15:00',1.26),('15087','2013-07-27','18:20:00',1.18),('15087','2013-07-27','18:25:00',1.09),('15087','2013-07-27','18:30:00',1.01),('15087','2013-07-26','07:55:00',1.04),('15087','2013-07-26','08:00:00',1.14),('15087','2013-07-26','08:05:00',1.24),('15087','2013-07-26','08:10:00',1.31),('15087','2013-07-26','08:15:00',1.37),('15087','2013-07-26','08:20:00',1.45),('15087','2013-07-26','08:25:00',1.56),('15087','2013-07-26','08:30:00',1.64),('15087','2013-07-26','08:35:00',1.72),('15087','2013-07-26','08:40:00',1.77),('15087','2013-07-26','08:45:00',1.88),('15087','2013-07-26','08:50:00',1.99),('15087','2013-07-26','08:55:00',2.06),('15087','2013-07-26','09:00:00',2.22),('15087','2013-07-26','09:05:00',2.32),('15087','2013-07-26','09:10:00',2.39),('15087','2013-07-26','09:15:00',2.46),('15087','2013-07-26','09:20:00',2.52),('15087','2013-07-26','09:25:00',2.59),('15087','2013-07-26','09:30:00',2.6),('15087','2013-07-26','09:35:00',2.7),('15087','2013-07-26','09:40:00',2.76),('15087','2013-07-26','09:45:00',2.84),('15087','2013-07-26','09:50:00',2.89),('15087','2013-07-26','09:55:00',3.04),('15087','2013-07-26','10:00:00',3.11),('15087','2013-07-26','10:05:00',3.21),('15087','2013-07-26','10:10:00',3.21),('15087','2013-07-26','10:15:00',3.23),('15087','2013-07-26','10:20:00',3.33),('15087','2013-07-26','10:25:00',3.39),('15087','2013-07-26','10:30:00',3.46),('15087','2013-07-26','10:35:00',3.47),('15087','2013-07-26','10:40:00',3.58),('15087','2013-07-26','10:45:00',3.61),('15087','2013-07-26','10:50:00',3.58),('15087','2013-07-26','10:55:00',3.65),('15087','2013-07-26','11:00:00',3.67),('15087','2013-07-26','11:05:00',3.74),('15087','2013-07-26','11:10:00',3.83),('15087','2013-07-26','11:15:00',3.89),('15087','2013-07-26','11:20:00',3.97),('15087','2013-07-26','11:25:00',3.98),('15087','2013-07-26','11:30:00',4.01),('15087','2013-07-26','11:35:00',4.04),('15087','2013-07-26','11:40:00',4.06),('15087','2013-07-26','11:45:00',4.05),('15087','2013-07-26','11:50:00',4.15),('15087','2013-07-26','11:55:00',4.1),('15087','2013-07-26','12:00:00',3.5),('15087','2013-07-26','12:05:00',3.84),('15087','2013-07-26','12:10:00',3.87),('15087','2013-07-26','12:15:00',4.26),('15087','2013-07-26','12:20:00',4.37),('15087','2013-07-26','12:25:00',4.41),('15087','2013-07-26','12:30:00',4.44),('15087','2013-07-26','12:35:00',4.44),('15087','2013-07-26','12:40:00',4.52),('15087','2013-07-26','12:45:00',4.49),('15087','2013-07-26','12:50:00',3.78),('15087','2013-07-26','12:55:00',1.88),('15087','2013-07-26','13:00:00',1.58),('15087','2013-07-26','13:05:00',1.25),('15087','2013-07-26','13:10:00',1.55),('15087','2013-07-26','13:15:00',1.7),('15087','2013-07-26','13:20:00',1.46),('15087','2013-07-26','13:25:00',1.57),('15087','2013-07-26','13:30:00',4.25),('15087','2013-07-26','13:35:00',4.61),('15087','2013-07-26','13:40:00',4.4),('15087','2013-07-26','13:45:00',4.65),('15087','2013-07-26','13:50:00',4.52),('15087','2013-07-26','13:55:00',4.39),('15087','2013-07-26','14:00:00',4.47),('15087','2013-07-26','14:05:00',2.37),('15087','2013-07-26','14:10:00',4.52),('15087','2013-07-26','14:15:00',4.46),('15087','2013-07-26','14:20:00',4.32),('15087','2013-07-26','14:25:00',4.27),('15087','2013-07-26','14:30:00',4.16),('15087','2013-07-26','14:35:00',4.08),('15087','2013-07-26','14:40:00',4.08),('15087','2013-07-26','14:45:00',4.13),('15087','2013-07-26','14:50:00',4.05),('15087','2013-07-26','14:55:00',3.93),('15087','2013-07-26','15:00:00',3.97),('15087','2013-07-26','15:05:00',3.91),('15087','2013-07-26','15:10:00',3.86),('15087','2013-07-26','15:15:00',3.81),('15087','2013-07-26','15:20:00',3.62),('15087','2013-07-26','15:25:00',3.53),('15087','2013-07-26','15:30:00',3.63),('15087','2013-07-26','15:35:00',3.59),('15087','2013-07-26','15:40:00',3.5),('15087','2013-07-26','15:45:00',3.47),('15087','2013-07-26','15:50:00',3.43),('15087','2013-07-26','15:55:00',3.37),('15087','2013-07-26','16:00:00',3.29),('15087','2013-07-26','16:05:00',3.14),('15087','2013-07-26','16:10:00',2.92),('15087','2013-07-26','16:15:00',3.1),('15087','2013-07-26','16:20:00',2.97),('15087','2013-07-26','16:25:00',2.94),('15087','2013-07-26','16:30:00',2.94),('15087','2013-07-26','16:35:00',2.91),('15087','2013-07-26','16:40:00',2.8),('15087','2013-07-26','16:45:00',2.77),('15087','2013-07-26','16:50:00',2.74),('15087','2013-07-26','16:55:00',2.63),('15087','2013-07-26','17:00:00',2.59),('15087','2013-07-26','17:05:00',2.47),('15087','2013-07-26','17:10:00',2.43),('15087','2013-07-26','17:15:00',2.3),('15087','2013-07-26','17:20:00',2.14),('15087','2013-07-26','17:25:00',2.15),('15087','2013-07-26','17:30:00',2.07),('15087','2013-07-26','17:35:00',1.95),('15087','2013-07-26','17:40:00',1.82),('15087','2013-07-26','17:45:00',1.75),('15087','2013-07-26','17:50:00',1.53),('15087','2013-07-26','17:55:00',1.45),('15087','2013-07-26','18:00:00',1.39),('15087','2013-07-26','18:05:00',1.29),('15087','2013-07-26','18:10:00',1.22),('15087','2013-07-26','18:15:00',1.19),('15087','2013-07-26','18:20:00',1.13),('15087','2013-07-26','18:25:00',1.08),('15087','2013-07-25','07:55:00',1.08),('15087','2013-07-25','08:00:00',1.15),('15087','2013-07-25','08:05:00',1.25),('15087','2013-07-25','08:10:00',1.31),('15087','2013-07-25','08:15:00',1.39),('15087','2013-07-25','08:20:00',1.48),('15087','2013-07-25','08:25:00',1.59),('15087','2013-07-25','08:30:00',1.67),('15087','2013-07-25','08:35:00',1.74),('15087','2013-07-25','08:40:00',1.79),('15087','2013-07-25','08:45:00',1.91),('15087','2013-07-25','08:50:00',1.99),('15087','2013-07-25','08:55:00',2.19),('15087','2013-07-25','09:00:00',2.17),('15087','2013-07-25','09:05:00',2.18),('15087','2013-07-25','09:10:00',2.41),('15087','2013-07-25','09:15:00',2.71),('15087','2013-07-25','09:20:00',2.4),('15087','2013-07-25','09:25:00',2.15),('15087','2013-07-25','09:30:00',2.01),('15087','2013-07-25','09:35:00',1.5),('15087','2013-07-25','09:40:00',1.64),('15087','2013-07-25','09:45:00',1.13),('15087','2013-07-25','09:50:00',1.06),('15087','2013-07-25','10:00:00',2.77),('15087','2013-07-25','10:05:00',3.22),('15087','2013-07-25','10:10:00',3.24),('15087','2013-07-25','10:15:00',3.25),('15087','2013-07-25','10:20:00',3.35),('15087','2013-07-25','10:25:00',1.78),('15087','2013-07-25','10:30:00',1.4),('15087','2013-07-25','10:35:00',2.15),('15087','2013-07-25','10:40:00',2.52),('15087','2013-07-25','10:45:00',3.92),('15087','2013-07-25','10:50:00',3.88),('15087','2013-07-25','10:55:00',3.84),('15087','2013-07-25','11:00:00',4.01),('15087','2013-07-25','11:05:00',4.01),('15087','2013-07-25','11:10:00',4.04),('15087','2013-07-25','11:15:00',4.1),('15087','2013-07-25','11:20:00',3.99),('15087','2013-07-25','11:25:00',4.19),('15087','2013-07-25','11:30:00',4.26),('15087','2013-07-25','11:35:00',2.68),('15087','2013-07-25','11:40:00',4.1),('15087','2013-07-25','11:45:00',2.91),('15087','2013-07-25','11:50:00',4.56),('15087','2013-07-25','11:55:00',3.99),('15087','2013-07-25','12:00:00',4.42),('15087','2013-07-25','12:05:00',1.18),('15087','2013-07-25','12:10:00',3.52),('15087','2013-07-25','12:15:00',1.93),('15087','2013-07-25','12:20:00',3.95),('15087','2013-07-25','12:25:00',4.12),('15087','2013-07-25','12:30:00',4.6),('15087','2013-07-25','12:35:00',3.29),('15087','2013-07-25','12:40:00',4.25),('15087','2013-07-25','12:45:00',3.92),('15087','2013-07-25','12:50:00',4.57),('15087','2013-07-25','12:55:00',4.75),('15087','2013-07-25','13:00:00',4.55),('15087','2013-07-25','13:05:00',4.64),('15087','2013-07-25','13:10:00',4.73),('15087','2013-07-25','13:15:00',4.62),('15087','2013-07-25','13:20:00',4.6),('15087','2013-07-25','13:25:00',4.53),('15087','2013-07-25','13:30:00',4.51),('15087','2013-07-25','13:35:00',4.52),('15087','2013-07-25','13:40:00',4.5),('15087','2013-07-25','13:45:00',4.55),('15087','2013-07-25','13:50:00',4.57),('15087','2013-07-25','13:55:00',4.55),('15087','2013-07-25','14:00:00',4.55),('15087','2013-07-25','14:05:00',4.59),('15087','2013-07-25','14:10:00',4.54),('15087','2013-07-25','14:15:00',4.52),('15087','2013-07-25','14:20:00',4.47),('15087','2013-07-25','14:25:00',4.41),('15087','2013-07-25','14:30:00',4.29),('15087','2013-07-25','14:35:00',4.05),('15087','2013-07-25','14:40:00',4.19),('15087','2013-07-25','14:45:00',4.28),('15087','2013-07-25','14:50:00',4.23),('15087','2013-07-25','14:55:00',4.06),('15087','2013-07-25','15:00:00',4.13),('15087','2013-07-25','15:05:00',4.07),('15087','2013-07-25','15:10:00',4.02),('15087','2013-07-25','15:15:00',3.97),('15087','2013-07-25','15:20:00',3.76),('15087','2013-07-25','15:25:00',3.65),('15087','2013-07-25','15:30:00',3.8),('15087','2013-07-25','15:35:00',3.79),('15087','2013-07-25','15:40:00',3.73),('15087','2013-07-25','15:45:00',3.52),('15087','2013-07-25','15:50:00',3.24),('15087','2013-07-25','15:55:00',3.14),('15087','2013-07-25','16:00:00',3.45),('15087','2013-07-25','16:05:00',3.33),('15087','2013-07-25','16:10:00',3.11),('15087','2013-07-25','16:15:00',3.23),('15087','2013-07-25','16:20:00',3.08),('15087','2013-07-25','16:25:00',3.05),('15087','2013-07-25','16:30:00',3),('15087','2013-07-25','16:35:00',2.96),('15087','2013-07-25','16:40:00',2.92),('15087','2013-07-25','16:45:00',2.88),('15087','2013-07-25','16:50:00',2.83),('15087','2013-07-25','16:55:00',2.78),('15087','2013-07-25','17:00:00',2.71),('15087','2013-07-25','17:05:00',2.6),('15087','2013-07-25','17:10:00',2.49),('15087','2013-07-25','17:15:00',2.42),('15087','2013-07-25','17:20:00',2.3),('15087','2013-07-25','17:25:00',2.31),('15087','2013-07-25','17:30:00',2.26),('15087','2013-07-25','17:35:00',2.08),('15087','2013-07-25','17:40:00',1.94),('15087','2013-07-25','17:45:00',1.87),('15087','2013-07-25','17:50:00',1.6),('15087','2013-07-25','17:55:00',1.53),('15087','2013-07-25','18:00:00',1.58),('15087','2013-07-25','18:05:00',1.4),('15087','2013-07-25','18:10:00',1.31),('15087','2013-07-25','18:15:00',1.3),('15087','2013-07-25','18:20:00',1.23),('15087','2013-07-25','18:25:00',1.05),('15087','2013-07-25','18:30:00',1.03),('15087','2013-07-24','08:15:00',1.43),('15087','2013-07-24','08:20:00',1.27),('15087','2013-07-24','08:25:00',1.14),('15087','2013-07-24','08:30:00',1.09),('15087','2013-07-24','08:35:00',1.14),('15087','2013-07-24','08:40:00',1.02),('15087','2013-07-24','08:45:00',1.83),('15087','2013-07-24','08:50:00',2.24),('15087','2013-07-24','08:55:00',2.25),('15087','2013-07-24','09:00:00',1.89),('15087','2013-07-24','09:05:00',1.86),('15087','2013-07-24','09:10:00',2.57),('15087','2013-07-24','09:15:00',1.94),('15087','2013-07-24','09:20:00',2.21),('15087','2013-07-24','09:25:00',1.67),('15087','2013-07-24','09:30:00',2.37),('15087','2013-07-24','09:35:00',2.08),('15087','2013-07-24','09:40:00',1.62),('15087','2013-07-24','09:45:00',1.54),('15087','2013-07-24','09:50:00',1.38),('15087','2013-07-24','09:55:00',1.3),('15087','2013-07-24','10:10:00',1.64),('15087','2013-07-24','10:15:00',2.43),('15087','2013-07-24','10:20:00',3.05),('15087','2013-07-24','10:25:00',3.78),('15087','2013-07-24','10:30:00',3.8),('15087','2013-07-24','10:35:00',3.88),('15087','2013-07-24','10:40:00',2.68),('15087','2013-07-24','10:45:00',1.99),('15087','2013-07-24','10:50:00',1.96),('15087','2013-07-24','10:55:00',1.8),('15087','2013-07-24','11:00:00',2.59),('15087','2013-07-24','11:05:00',2.89),('15087','2013-07-24','11:10:00',4.23),('15087','2013-07-24','11:15:00',4.2),('15087','2013-07-24','11:20:00',3.87),('15087','2013-07-24','11:25:00',3.94),('15087','2013-07-24','11:30:00',3.54),('15087','2013-07-24','11:35:00',4.15),('15087','2013-07-24','11:40:00',4.25),('15087','2013-07-24','11:45:00',4.32),('15087','2013-07-24','11:50:00',4.2),('15087','2013-07-24','11:55:00',4.26),('15087','2013-07-24','12:00:00',4.53),('15087','2013-07-24','12:05:00',3.85),('15087','2013-07-24','12:10:00',4.77),('15087','2013-07-24','12:15:00',4.49),('15087','2013-07-24','12:20:00',3.22),('15087','2013-07-24','12:25:00',1.95),('15087','2013-07-24','12:30:00',4.1),('15087','2013-07-24','12:35:00',1.32),('15087','2013-07-24','12:40:00',3.44),('15087','2013-07-24','12:45:00',3.95),('15087','2013-07-24','12:50:00',2.78),('15087','2013-07-24','12:55:00',4.41),('15087','2013-07-24','13:00:00',4.02),('15087','2013-07-24','13:05:00',4.4),('15087','2013-07-24','13:10:00',2.84),('15087','2013-07-24','13:15:00',3.64),('15087','2013-07-24','13:20:00',1.67),('15087','2013-07-24','13:25:00',4.78),('15087','2013-07-24','13:30:00',4.73),('15087','2013-07-24','13:35:00',2.53),('15087','2013-07-24','13:40:00',1.51),('15087','2013-07-24','13:45:00',4.61),('15087','2013-07-24','13:50:00',4.89),('15087','2013-07-24','13:55:00',3.98),('15087','2013-07-24','14:00:00',4.56),('15087','2013-07-24','14:05:00',4.71),('15087','2013-07-24','14:10:00',4.64),('15087','2013-07-24','14:15:00',4.66),('15087','2013-07-24','14:20:00',4.72),('15087','2013-07-24','14:25:00',4.67),('15087','2013-07-24','14:30:00',4.59),('15087','2013-07-24','14:35:00',4.6),('15087','2013-07-24','14:40:00',4.38),('15087','2013-07-24','14:45:00',4.4),('15087','2013-07-24','14:50:00',4.36),('15087','2013-07-24','14:55:00',4.24),('15087','2013-07-24','15:00:00',4.17),('15087','2013-07-24','15:05:00',4.11),('15087','2013-07-24','15:10:00',4.09),('15087','2013-07-24','15:15:00',4.07),('15087','2013-07-24','15:20:00',3.93),('15087','2013-07-24','15:25:00',3.84),('15087','2013-07-24','15:30:00',3.71),('15087','2013-07-24','15:35:00',3.65),('15087','2013-07-24','15:40:00',3.76),('15087','2013-07-24','15:45:00',3.57),('15087','2013-07-24','15:50:00',3.35),('15087','2013-07-24','15:55:00',3.35),('15087','2013-07-24','16:00:00',3.47),('15087','2013-07-24','16:05:00',3.35),('15087','2013-07-24','16:10:00',3.3),('15087','2013-07-24','16:15:00',3.3),('15087','2013-07-24','16:20:00',3.27),('15087','2013-07-24','16:25:00',3.27),('15087','2013-07-24','16:30:00',3.13),('15087','2013-07-24','16:35:00',3),('15087','2013-07-24','16:40:00',3.04),('15087','2013-07-24','16:45:00',3.01),('15087','2013-07-24','16:50:00',3.04),('15087','2013-07-24','16:55:00',3),('15087','2013-07-24','17:00:00',2.88),('15087','2013-07-24','17:05:00',2.81),('15087','2013-07-24','17:10:00',2.46),('15087','2013-07-24','17:15:00',2.57),('15087','2013-07-24','17:20:00',2.42),('15087','2013-07-24','17:25:00',2.36),('15087','2013-07-24','17:30:00',2.28),('15087','2013-07-24','17:35:00',2.01),('15087','2013-07-24','17:40:00',1.95),('15087','2013-07-24','17:45:00',1.86),('15087','2013-07-24','17:50:00',1.72),('15087','2013-07-24','17:55:00',1.63),('15087','2013-07-24','18:00:00',1.57),('15087','2013-07-24','18:05:00',1.43),('15087','2013-07-24','18:10:00',1.32),('15087','2013-07-24','18:15:00',1.25),('15087','2013-07-24','18:20:00',1.17),('15087','2013-07-24','18:25:00',1.09),('15087','2013-07-24','18:30:00',1.03),('15087','2013-07-23','07:45:00',1.05),('15087','2013-07-23','07:50:00',1.13),('15087','2013-07-23','07:55:00',1.21),('15087','2013-07-23','08:00:00',1.24),('15087','2013-07-23','08:05:00',1.33),('15087','2013-07-23','08:10:00',1.46),('15087','2013-07-23','08:15:00',1.58),('15087','2013-07-23','08:20:00',1.67),('15087','2013-07-23','08:25:00',1.76),('15087','2013-07-23','08:30:00',1.84),('15087','2013-07-23','08:35:00',1.92),('15087','2013-07-23','08:40:00',2.01),('15087','2013-07-23','08:45:00',2.12),('15087','2013-07-23','08:50:00',2.22),('15087','2013-07-23','08:55:00',2.38),('15087','2013-07-23','09:00:00',2.47),('15087','2013-07-23','09:05:00',2.52),('15087','2013-07-23','09:10:00',2.6),('15087','2013-07-23','09:15:00',2.65),('15087','2013-07-23','09:20:00',2.73),('15087','2013-07-23','09:25:00',2.78),('15087','2013-07-23','09:30:00',2.85),('15087','2013-07-23','09:35:00',2.9),('15087','2013-07-23','09:40:00',2.96),('15087','2013-07-23','09:45:00',3),('15087','2013-07-23','09:50:00',3.05),('15087','2013-07-23','09:55:00',3.15),('15087','2013-07-23','10:00:00',3.17),('15087','2013-07-23','10:05:00',3.23),('15087','2013-07-23','10:10:00',3.29),('15087','2013-07-23','10:15:00',3.32),('15087','2013-07-23','10:20:00',3.37),('15087','2013-07-23','10:25:00',3.52),('15087','2013-07-23','10:30:00',3.64),('15087','2013-07-23','10:35:00',3.69),('15087','2013-07-23','10:40:00',3.74),('15087','2013-07-23','10:45:00',3.76),('15087','2013-07-23','10:50:00',3.77),('15087','2013-07-23','10:55:00',3.87),('15087','2013-07-23','11:00:00',3.9),('15087','2013-07-23','11:05:00',3.95),('15087','2013-07-23','11:10:00',4),('15087','2013-07-23','11:15:00',4.09),('15087','2013-07-23','11:20:00',4.15),('15087','2013-07-23','11:25:00',4.12),('15087','2013-07-23','11:30:00',4.12),('15087','2013-07-23','11:35:00',4.16),('15087','2013-07-23','11:40:00',4.25),('15087','2013-07-23','11:45:00',4.27),('15087','2013-07-23','11:50:00',4.25),('15087','2013-07-23','11:55:00',4.37),('15087','2013-07-23','12:00:00',4.4),('15087','2013-07-23','12:05:00',4.43),('15087','2013-07-23','12:10:00',4.47),('15087','2013-07-23','12:15:00',4.51),('15087','2013-07-23','12:20:00',4.49),('15087','2013-07-23','12:25:00',4.38),('15087','2013-07-23','12:30:00',3.89),('15087','2013-07-23','12:35:00',1.22),('15087','2013-07-23','12:45:00',1.63),('15087','2013-07-23','12:50:00',2.26),('15087','2013-07-23','12:55:00',4.36),('15087','2013-07-23','13:00:00',1.19),('15087','2013-07-23','13:30:00',3.14),('15087','2013-07-23','13:35:00',4.21),('15087','2013-07-23','13:40:00',2.47),('15087','2013-07-23','13:55:00',1.64),('15087','2013-07-23','14:00:00',4.36),('15087','2013-07-23','14:05:00',4.63),('15087','2013-07-23','14:10:00',1.32),('15087','2013-07-23','14:25:00',1.64),('15087','2013-07-23','14:30:00',2.49),('15087','2013-07-23','14:35:00',2.96),('15087','2013-07-23','14:40:00',1.77),('15087','2013-07-23','14:45:00',3.3),('15087','2013-07-23','14:50:00',2.03),('15087','2013-07-23','14:55:00',3.58),('15087','2013-07-23','15:00:00',4.72),('15087','2013-07-23','15:05:00',4.15),('15087','2013-07-23','15:10:00',4.11),('15087','2013-07-23','15:15:00',4.11),('15087','2013-07-23','15:20:00',3.88),('15087','2013-07-23','15:25:00',3.78),('15087','2013-07-23','15:30:00',3.78),('15087','2013-07-23','15:35:00',3.8),('15087','2013-07-23','15:40:00',3.6),('15087','2013-07-23','15:45:00',3.5),('15087','2013-07-23','15:50:00',3.3),('15087','2013-07-23','15:55:00',3.4),('15087','2013-07-23','16:00:00',3.41),('15087','2013-07-23','16:05:00',3.32),('15087','2013-07-23','16:10:00',3.21),('15087','2013-07-23','16:15:00',3.17),('15087','2013-07-23','16:20:00',3.12),('15087','2013-07-23','16:25:00',3.08),('15087','2013-07-23','16:30:00',2.98),('15087','2013-07-23','16:35:00',2.76),('15087','2013-07-23','16:40:00',2.83),('15087','2013-07-23','16:45:00',2.86),('15087','2013-07-23','16:50:00',2.82),('15087','2013-07-23','16:55:00',2.74),('15087','2013-07-23','17:00:00',2.67),('15087','2013-07-23','17:05:00',2.57),('15087','2013-07-23','17:10:00',2.48),('15087','2013-07-23','17:15:00',2.46),('15087','2013-07-23','17:20:00',2.4),('15087','2013-07-23','17:25:00',2.33),('15087','2013-07-23','17:30:00',2.27),('15087','2013-07-23','17:35:00',2.05),('15087','2013-07-23','17:40:00',2.01),('15087','2013-07-23','17:45:00',1.91),('15087','2013-07-23','17:50:00',1.68),('15087','2013-07-23','17:55:00',1.62),('15087','2013-07-23','18:00:00',1.65),('15087','2013-07-23','18:05:00',1.46),('15087','2013-07-23','18:10:00',1.43),('15087','2013-07-23','18:15:00',1.36),('15087','2013-07-23','18:20:00',1.23),('15087','2013-07-23','18:25:00',1.19),('15087','2013-07-23','18:30:00',1.09),('15087','2013-07-22','07:45:00',1.03),('15087','2013-07-22','07:50:00',1.1),('15087','2013-07-22','07:55:00',1.19),('15087','2013-07-22','08:00:00',1.27),('15087','2013-07-22','08:05:00',1.36),('15087','2013-07-22','08:10:00',1.45),('15087','2013-07-22','08:15:00',1.55),('15087','2013-07-22','08:20:00',1.63),('15087','2013-07-22','08:25:00',1.72),('15087','2013-07-22','08:30:00',1.82),('15087','2013-07-22','08:35:00',1.88),('15087','2013-07-22','08:40:00',1.98),('15087','2013-07-22','08:45:00',2.09),('15087','2013-07-22','08:50:00',2.2),('15087','2013-07-22','08:55:00',2.31),('15087','2013-07-22','09:00:00',2.41),('15087','2013-07-22','09:05:00',2.52),('15087','2013-07-22','09:10:00',2.59),('15087','2013-07-22','09:15:00',2.66),('15087','2013-07-22','09:20:00',2.73),('15087','2013-07-22','09:25:00',2.8),('15087','2013-07-22','09:30:00',2.89),('15087','2013-07-22','09:35:00',2.95),('15087','2013-07-22','09:40:00',3.02),('15087','2013-07-22','09:45:00',3.1),('15087','2013-07-22','09:50:00',3.16),('15087','2013-07-22','09:55:00',3.22),('15087','2013-07-22','10:00:00',3.28),('15087','2013-07-22','10:05:00',3.36),('15087','2013-07-22','10:10:00',3.43),('15087','2013-07-22','10:15:00',3.49),('15087','2013-07-22','10:20:00',3.54),('15087','2013-07-22','10:25:00',3.6),('15087','2013-07-22','10:30:00',3.67),('15087','2013-07-22','10:35:00',3.73),('15087','2013-07-22','10:40:00',3.77),('15087','2013-07-22','10:45:00',3.8),('15087','2013-07-22','10:50:00',3.86),('15087','2013-07-22','10:55:00',3.9),('15087','2013-07-22','11:00:00',3.92),('15087','2013-07-22','11:05:00',3.95),('15087','2013-07-22','11:10:00',3.98),('15087','2013-07-22','11:15:00',4.04),('15087','2013-07-22','11:20:00',4.09),('15087','2013-07-22','11:25:00',4.09),('15087','2013-07-22','11:30:00',4.1),('15087','2013-07-22','11:35:00',4.14),('15087','2013-07-22','11:40:00',4.18),('15087','2013-07-22','11:45:00',4.18),('15087','2013-07-22','11:50:00',4.22),('15087','2013-07-22','11:55:00',4.24),('15087','2013-07-22','12:00:00',4.25),('15087','2013-07-22','12:05:00',4.32),('15087','2013-07-22','12:10:00',4.34),('15087','2013-07-22','12:15:00',4.37),('15087','2013-07-22','12:20:00',4.41),('15087','2013-07-22','12:25:00',4.39),('15087','2013-07-22','12:30:00',4.43),('15087','2013-07-22','12:35:00',4.49),('15087','2013-07-22','12:40:00',4.48),('15087','2013-07-22','12:45:00',4.45),('15087','2013-07-22','12:50:00',4.41),('15087','2013-07-22','12:55:00',4.42),('15087','2013-07-22','13:00:00',4.41),('15087','2013-07-22','13:05:00',4.46),('15087','2013-07-22','13:10:00',4.42),('15087','2013-07-22','13:15:00',4.43),('15087','2013-07-22','13:20:00',4.47),('15087','2013-07-22','13:25:00',4.52),('15087','2013-07-22','13:30:00',4.46),('15087','2013-07-22','13:35:00',4.45),('15087','2013-07-22','13:40:00',4.44),('15087','2013-07-22','13:45:00',4.47),('15087','2013-07-22','13:50:00',4.46),('15087','2013-07-22','13:55:00',4.41),('15087','2013-07-22','14:00:00',4.39),('15087','2013-07-22','14:05:00',4.38),('15087','2013-07-22','14:10:00',4.39),('15087','2013-07-22','14:15:00',4.33),('15087','2013-07-22','14:20:00',4.3),('15087','2013-07-22','14:25:00',4.25),('15087','2013-07-22','14:30:00',4.29),('15087','2013-07-22','14:35:00',4.06),('15087','2013-07-22','14:40:00',4.09),('15087','2013-07-22','14:45:00',4.15),('15087','2013-07-22','14:50:00',4.13),('15087','2013-07-22','14:55:00',4.03),('15087','2013-07-22','15:00:00',3.81),('15087','2013-07-22','15:05:00',3.76),('15087','2013-07-22','15:10:00',3.97),('15087','2013-07-22','15:15:00',3.89),('15087','2013-07-22','15:20:00',3.79),('15087','2013-07-22','15:25:00',3.75),('15087','2013-07-22','15:30:00',2.42),('15087','2013-07-22','15:40:00',1.02),('15087','2013-07-22','15:45:00',2.15),('15087','2013-07-22','15:50:00',3.82),('15087','2013-07-22','15:55:00',3.88),('15087','2013-07-22','16:00:00',3.87),('15087','2013-07-22','16:05:00',3.77),('15087','2013-07-22','16:10:00',3.59),('15087','2013-07-22','16:15:00',3.23),('15087','2013-07-22','16:20:00',3.49),('15087','2013-07-22','16:25:00',3.36),('15087','2013-07-22','16:30:00',3.17),('15087','2013-07-22','16:35:00',3.03),('15087','2013-07-22','16:40:00',2.83),('15087','2013-07-22','16:45:00',2.83),('15087','2013-07-22','16:50:00',2.74),('15087','2013-07-22','16:55:00',2.7),('15087','2013-07-22','17:00:00',2.63),('15087','2013-07-22','17:05:00',2.58),('15087','2013-07-22','17:10:00',2.47),('15087','2013-07-22','17:15:00',2.38),('15087','2013-07-22','17:20:00',2.34),('15087','2013-07-22','17:25:00',2.26),('15087','2013-07-22','17:30:00',2.09),('15087','2013-07-22','17:35:00',2.07),('15087','2013-07-22','17:40:00',1.99),('15087','2013-07-22','17:45:00',1.73),('15087','2013-07-22','17:50:00',1.61),('15087','2013-07-22','17:55:00',1.6),('15087','2013-07-22','18:00:00',1.63),('15087','2013-07-22','18:05:00',1.48),('15087','2013-07-22','18:10:00',1.36),('15087','2013-07-22','18:15:00',1.24),('15087','2013-07-22','18:20:00',1.18),('15087','2013-07-22','18:25:00',1.13),('15087','2013-07-22','18:30:00',1),('15087','2013-07-21','07:45:00',1.03),('15087','2013-07-21','07:50:00',1.08),('15087','2013-07-21','07:55:00',1.14),('15087','2013-07-21','08:00:00',1.19),('15087','2013-07-21','08:05:00',1.26),('15087','2013-07-21','08:10:00',1.37),('15087','2013-07-21','08:15:00',1.45),('15087','2013-07-21','08:20:00',1.52),('15087','2013-07-21','08:25:00',1.62),('15087','2013-07-21','08:30:00',1.73),('15087','2013-07-21','08:35:00',1.79),('15087','2013-07-21','08:40:00',1.89),('15087','2013-07-21','08:45:00',1.95),('15087','2013-07-21','08:50:00',2.03),('15087','2013-07-21','08:55:00',2.19),('15087','2013-07-21','09:00:00',2.31),('15087','2013-07-21','09:05:00',2.39),('15087','2013-07-21','09:10:00',2.49),('15087','2013-07-21','09:15:00',2.57),('15087','2013-07-21','09:20:00',2.65),('15087','2013-07-21','09:25:00',2.71),('15087','2013-07-21','09:30:00',2.78),('15087','2013-07-21','09:35:00',2.83),('15087','2013-07-21','09:40:00',2.93),('15087','2013-07-21','09:45:00',2.99),('15087','2013-07-21','09:50:00',3.04),('15087','2013-07-21','09:55:00',3.1),('15087','2013-07-21','10:00:00',3.19),('15087','2013-07-21','10:05:00',3.26),('15087','2013-07-21','10:10:00',3.31),('15087','2013-07-21','10:15:00',3.37),('15087','2013-07-21','10:20:00',3.42),('15087','2013-07-21','10:25:00',3.47),('15087','2013-07-21','10:30:00',3.53),('15087','2013-07-21','10:35:00',3.58),('15087','2013-07-21','10:40:00',3.62),('15087','2013-07-21','10:45:00',3.64),('15087','2013-07-21','10:50:00',3.77),('15087','2013-07-21','10:55:00',3.77),('15087','2013-07-21','11:00:00',3.84),('15087','2013-07-21','11:05:00',3.89),('15087','2013-07-21','11:10:00',3.91),('15087','2013-07-21','11:15:00',3.93),('15087','2013-07-21','11:20:00',3.94),('15087','2013-07-21','11:25:00',4.03),('15087','2013-07-21','11:30:00',4.09),('15087','2013-07-21','11:35:00',4.09),('15087','2013-07-21','11:40:00',4.23),('15087','2013-07-21','11:45:00',4.25),('15087','2013-07-21','11:50:00',4.2),('15087','2013-07-21','11:55:00',4.22),('15087','2013-07-21','12:00:00',4.28),('15087','2013-07-21','12:05:00',4.14),('15087','2013-07-21','12:10:00',4.2),('15087','2013-07-21','12:15:00',4.29),('15087','2013-07-21','12:20:00',4.59),('15087','2013-07-21','12:25:00',4.85),('15087','2013-07-21','12:30:00',4.95),('15087','2013-07-21','12:35:00',5.19),('15087','2013-07-21','12:40:00',5.2),('15087','2013-07-21','12:45:00',5.07),('15087','2013-07-21','12:50:00',4.48),('15087','2013-07-21','12:55:00',5.24),('15087','2013-07-21','13:00:00',5.05),('15087','2013-07-21','13:05:00',5.12),('15087','2013-07-21','13:10:00',3.94),('15087','2013-07-21','13:15:00',4.09),('15087','2013-07-21','13:20:00',3.71),('15087','2013-07-21','13:25:00',4.24),('15087','2013-07-21','13:30:00',4.65),('15087','2013-07-21','13:35:00',4.87),('15087','2013-07-21','13:40:00',4.34),('15087','2013-07-21','13:45:00',4.54),('15087','2013-07-21','13:50:00',2.72),('15087','2013-07-21','13:55:00',1.01),('15087','2013-07-21','14:00:00',1.04),('15087','2013-07-21','14:05:00',1.15),('15087','2013-07-21','14:10:00',1.08),('15087','2013-07-21','14:15:00',1.08),('15087','2013-07-21','14:20:00',1.34),('15087','2013-07-21','14:25:00',1.5),('15087','2013-07-21','14:30:00',1.24),('15087','2013-07-21','14:35:00',1.26),('15087','2013-07-21','14:40:00',1.26),('15087','2013-07-21','14:45:00',1.43),('15087','2013-07-21','14:50:00',1.68),('15087','2013-07-21','14:55:00',1.72),('15087','2013-07-21','15:00:00',1.9),('15087','2013-07-21','15:05:00',1.72),('15087','2013-07-21','15:10:00',1.76),('15087','2013-07-21','15:15:00',4.1),('15087','2013-07-21','15:20:00',4.38),('15087','2013-07-21','15:25:00',1.71),('15087','2013-07-21','15:30:00',1.52),('15087','2013-07-21','15:35:00',1.71),('15087','2013-07-21','15:40:00',2.75),('15087','2013-07-21','15:45:00',3.71),('15087','2013-07-21','15:50:00',3.16),('15087','2013-07-21','15:55:00',2.18),('15087','2013-07-21','16:00:00',1.45),('15087','2013-07-21','16:05:00',1.06),('15087','2013-07-21','16:55:00',1.07),('15087','2013-07-21','17:00:00',1.19),('15087','2013-07-21','17:05:00',1.32),('15087','2013-07-21','17:10:00',1.38),('15087','2013-07-21','17:15:00',1.13),('15087','2013-07-21','17:20:00',1),('15087','2014-04-07','08:20:00',1.03),('15087','2014-04-07','08:25:00',1.06),('15087','2014-04-07','08:30:00',1.28),('15087','2014-04-07','08:35:00',1.72),('15087','2014-04-07','08:40:00',1.78),('15087','2014-04-07','08:45:00',1.57),('15087','2014-04-07','08:50:00',1.45),('15087','2014-04-07','08:55:00',1.26),('15087','2014-04-07','09:00:00',1.18),('15087','2014-04-07','09:05:00',1.2),('15087','2014-04-07','09:10:00',1.44),('15087','2014-04-07','09:15:00',1.71),('15087','2014-04-07','09:20:00',1.3),('15087','2014-04-07','09:25:00',1.22),('15087','2014-04-07','09:30:00',1.21),('15087','2014-04-07','09:35:00',1.16),('15087','2014-04-07','09:40:00',1.2),('15087','2014-04-07','09:45:00',1.28),('15087','2014-04-07','09:50:00',1.35),('15087','2014-04-07','09:55:00',1.45),('15087','2014-04-07','10:00:00',1.46),('15087','2014-04-07','10:05:00',1.46),('15087','2014-04-07','10:10:00',1.5),('15087','2014-04-07','10:15:00',1.35),('15087','2014-04-07','10:20:00',1.34),('15087','2014-04-07','10:25:00',1.4),('15087','2014-04-07','10:30:00',1.41),('15087','2014-04-07','10:35:00',1.53),('15087','2014-04-07','10:40:00',1.58),('15087','2014-04-07','10:45:00',1.65),('15087','2014-04-07','10:50:00',1.75),('15087','2014-04-07','10:55:00',1.89),('15087','2014-04-07','11:00:00',2.03),('15087','2014-04-07','11:05:00',2.08),('15087','2014-04-07','11:10:00',2.29),('15087','2014-04-07','11:15:00',2.46),('15087','2014-04-07','11:20:00',2.49),('15087','2014-04-07','11:25:00',2.18),('15087','2014-04-07','11:30:00',2.17),('15087','2014-04-07','11:35:00',2.15),('15087','2014-04-07','11:40:00',2.11),('15087','2014-04-07','11:45:00',2.01),('15087','2014-04-07','11:50:00',1.9),('15087','2014-04-07','11:55:00',1.83),('15087','2014-04-07','12:00:00',2.05),('15087','2014-04-07','12:05:00',2.54),('15087','2014-04-07','12:10:00',2.69),('15087','2014-04-07','12:15:00',3.61),('15087','2014-04-07','12:20:00',4.28),('15087','2014-04-07','12:25:00',3.97),('15087','2014-04-07','12:30:00',2.58),('15087','2014-04-07','12:35:00',2.33),('15087','2014-04-07','12:40:00',2.82),('15087','2014-04-07','12:45:00',4.3),('15087','2014-04-07','12:50:00',4.36),('15087','2014-04-07','12:55:00',4.27),('15087','2014-04-07','13:00:00',4.31),('15087','2014-04-07','13:05:00',4.33),('15087','2014-04-07','13:10:00',4.28),('15087','2014-04-07','13:15:00',4.27),('15087','2014-04-07','13:20:00',4.25),('15087','2014-04-07','13:25:00',4.25),('15087','2014-04-07','13:30:00',4.28),('15087','2014-04-07','13:35:00',4.24),('15087','2014-04-07','13:40:00',4.22),('15087','2014-04-07','13:45:00',4.23),('15087','2014-04-07','13:50:00',4.26),('15087','2014-04-07','13:55:00',4.14),('15087','2014-04-07','14:00:00',4.16),('15087','2014-04-07','14:05:00',4.14),('15087','2014-04-07','14:10:00',4.07),('15087','2014-04-07','14:15:00',3.93),('15087','2014-04-07','14:20:00',3.84),('15087','2014-04-07','14:25:00',4.05),('15087','2014-04-07','14:30:00',4.04),('15087','2014-04-07','14:35:00',3.86),('15087','2014-04-07','14:40:00',3.74),('15087','2014-04-07','14:45:00',3.72),('15087','2014-04-07','14:50:00',3.77),('15087','2014-04-07','14:55:00',3.6),('15087','2014-04-07','15:00:00',3.32),('15087','2014-04-07','15:05:00',3.69),('15087','2014-04-07','15:10:00',3.59),('15087','2014-04-07','15:15:00',3.68),('15087','2014-04-07','15:20:00',3.77),('15087','2014-04-07','15:25:00',3.59),('15087','2014-04-07','15:30:00',3.49),('15087','2014-04-07','15:35:00',3.42),('15087','2014-04-07','15:40:00',3.37),('15087','2014-04-07','15:45:00',3.33),('15087','2014-04-07','15:50:00',3.49),('15087','2014-04-07','15:55:00',3.43),('15087','2014-04-07','16:00:00',2.63),('15087','2014-04-07','16:05:00',2.18),('15087','2014-04-07','16:10:00',3.04),('15087','2014-04-07','16:15:00',2.78),('15087','2014-04-07','16:20:00',2.59),('15087','2014-04-07','16:25:00',2.5),('15087','2014-04-07','16:30:00',2.39),('15087','2014-04-07','16:35:00',1.29),('15087','2014-04-07','16:40:00',1.38),('15087','2014-04-07','16:45:00',1.69),('15087','2014-04-07','16:50:00',2.33),('15087','2014-04-07','16:55:00',2.42),('15087','2014-04-07','17:00:00',2.46),('15087','2014-04-07','17:05:00',2.33),('15087','2014-04-07','17:10:00',1.64),('15087','2014-04-07','17:15:00',1.83),('15087','2014-04-07','17:20:00',1.49),('15087','2013-07-20','07:45:00',1.03),('15087','2013-07-20','07:50:00',1.12),('15087','2013-07-20','07:55:00',1.21),('15087','2013-07-20','08:00:00',1.28),('15087','2013-07-20','08:05:00',1.37),('15087','2013-07-20','08:10:00',1.46),('15087','2013-07-20','08:15:00',1.55),('15087','2013-07-20','08:20:00',1.65),('15087','2013-07-20','08:25:00',1.73),('15087','2013-07-20','08:30:00',1.81),('15087','2013-07-20','08:35:00',1.91),('15087','2013-07-20','08:40:00',1.99),('15087','2013-07-20','08:45:00',2.12),('15087','2013-07-20','08:50:00',2.2),('15087','2013-07-20','08:55:00',2.36),('15087','2013-07-20','09:00:00',2.46),('15087','2013-07-20','09:05:00',2.57),('15087','2013-07-20','09:10:00',2.7),('15087','2013-07-20','09:15:00',2.81),('15087','2013-07-20','09:20:00',2.79),('15087','2013-07-20','09:25:00',2.79),('15087','2013-07-20','09:30:00',2.79),('15087','2013-07-20','09:35:00',2.82),('15087','2013-07-20','09:40:00',2.86),('15087','2013-07-20','09:45:00',3.13),('15087','2013-07-20','09:50:00',3.09),('15087','2013-07-20','09:55:00',3.07),('15087','2013-07-20','10:00:00',3.27),('15087','2013-07-20','10:05:00',3.35),('15087','2013-07-20','10:10:00',3.44),('15087','2013-07-20','10:15:00',3.47),('15087','2013-07-20','10:20:00',3.52),('15087','2013-07-20','10:25:00',3.56),('15087','2013-07-20','10:30:00',3.61),('15087','2013-07-20','10:35:00',3.65),('15087','2013-07-20','10:40:00',3.71),('15087','2013-07-20','10:45:00',3.73),('15087','2013-07-20','10:50:00',3.79),('15087','2013-07-20','10:55:00',3.86),('15087','2013-07-20','11:00:00',3.92),('15087','2013-07-20','11:05:00',3.92),('15087','2013-07-20','11:10:00',3.93),('15087','2013-07-20','11:15:00',3.98),('15087','2013-07-20','11:20:00',3.97),('15087','2013-07-20','11:25:00',4.02),('15087','2013-07-20','11:30:00',4.1),('15087','2013-07-20','11:35:00',4.05),('15087','2013-07-20','11:40:00',4.18),('15087','2013-07-20','11:45:00',4.21),('15087','2013-07-20','11:50:00',4.22),('15087','2013-07-20','11:55:00',4.32),('15087','2013-07-20','12:00:00',4.35),('15087','2013-07-20','12:05:00',4.41),('15087','2013-07-20','12:10:00',4.46),('15087','2013-07-20','12:15:00',4.46),('15087','2013-07-20','12:20:00',4.46),('15087','2013-07-20','12:25:00',4.4),('15087','2013-07-20','12:30:00',4.39),('15087','2013-07-20','12:35:00',4.46),('15087','2013-07-20','12:40:00',4.49),('15087','2013-07-20','12:45:00',4.58),('15087','2013-07-20','12:50:00',4.59),('15087','2013-07-20','12:55:00',4.52),('15087','2013-07-20','13:00:00',4.66),('15087','2013-07-20','13:05:00',4.63),('15087','2013-07-20','13:10:00',1.83),('15087','2013-07-20','13:15:00',1.09),('15087','2013-07-20','13:20:00',2.92),('15087','2013-07-20','13:25:00',1.93),('15087','2013-07-20','13:30:00',4.9),('15087','2013-07-20','13:35:00',4.77),('15087','2013-07-20','13:40:00',4.77),('15087','2013-07-20','13:45:00',3.64),('15087','2013-07-20','13:50:00',1.84),('15087','2013-07-20','14:00:00',4.13),('15087','2013-07-20','14:05:00',4.61),('15087','2013-07-20','14:10:00',4.67),('15087','2013-07-20','14:15:00',4.72),('15087','2013-07-20','14:20:00',4.63),('15087','2013-07-20','14:25:00',4.41),('15087','2013-07-20','14:30:00',4.25),('15087','2013-07-20','14:35:00',4.06),('15087','2013-07-20','14:40:00',4.43),('15087','2013-07-20','14:45:00',4.38),('15087','2013-07-20','14:50:00',4.35),('15087','2013-07-20','14:55:00',3.44),('15087','2013-07-20','15:00:00',4.2),('15087','2013-07-20','15:05:00',3.96),('15087','2013-07-20','15:10:00',4.08),('15087','2013-07-20','15:15:00',3.99),('15087','2013-07-20','15:20:00',3.88),('15087','2013-07-20','15:25:00',3.7),('15087','2013-07-20','15:30:00',3.48),('15087','2013-07-20','15:35:00',3.46),('15087','2013-07-20','15:40:00',3.67),('15087','2013-07-20','15:45:00',3.63),('15087','2013-07-20','15:50:00',3.51),('15087','2013-07-20','15:55:00',3.45),('15087','2013-07-20','16:00:00',3.4),('15087','2013-07-20','16:05:00',3.36),('15087','2013-07-20','16:10:00',3.27),('15087','2013-07-20','16:15:00',3.1),('15087','2013-07-20','16:20:00',3.01),('15087','2013-07-20','16:25:00',3.14),('15087','2013-07-20','16:30:00',3.13),('15087','2013-07-20','16:35:00',2.95),('15087','2013-07-20','16:40:00',2.99),('15087','2013-07-20','16:45:00',2.9),('15087','2013-07-20','16:50:00',2.83),('15087','2013-07-20','16:55:00',2.72),('15087','2013-07-20','17:00:00',2.64),('15087','2013-07-20','17:05:00',2.57),('15087','2013-07-20','17:10:00',2.42),('15087','2013-07-20','17:15:00',2.42),('15087','2013-07-20','17:20:00',2.37),('15087','2013-07-20','17:25:00',2.3),('15087','2013-07-20','17:30:00',2.18),('15087','2013-07-20','17:35:00',2.11),('15087','2013-07-20','17:40:00',2.02),('15087','2013-07-20','17:45:00',1.73),('15087','2013-07-20','17:50:00',1.76),('15087','2013-07-20','17:55:00',1.7),('15087','2013-07-20','18:00:00',1.59),('15087','2013-07-20','18:05:00',1.48),('15087','2013-07-20','18:10:00',1.39),('15087','2013-07-20','18:15:00',1.26),('15087','2013-07-20','18:20:00',1.24),('15087','2013-07-20','18:25:00',1.15),('15087','2013-07-20','18:30:00',1.01),('15087','2013-07-19','07:45:00',1.01),('15087','2013-07-19','07:50:00',1.09),('15087','2013-07-19','07:55:00',1.17),('15087','2013-07-19','08:00:00',1.25),('15087','2013-07-19','08:05:00',1.32),('15087','2013-07-19','08:10:00',1.41),('15087','2013-07-19','08:15:00',1.5),('15087','2013-07-19','08:20:00',1.57),('15087','2013-07-19','08:25:00',1.64),('15087','2013-07-19','08:30:00',1.73),('15087','2013-07-19','08:35:00',1.82),('15087','2013-07-19','08:40:00',1.91),('15087','2013-07-19','08:45:00',2.04),('15087','2013-07-19','08:50:00',2.15),('15087','2013-07-19','08:55:00',2.27),('15087','2013-07-19','09:00:00',2.34),('15087','2013-07-19','09:05:00',2.42),('15087','2013-07-19','09:10:00',2.51),('15087','2013-07-19','09:15:00',2.58),('15087','2013-07-19','09:20:00',2.63),('15087','2013-07-19','09:25:00',2.7),('15087','2013-07-19','09:30:00',2.79),('15087','2013-07-19','09:35:00',2.84),('15087','2013-07-19','09:40:00',2.88),('15087','2013-07-19','09:45:00',2.95),('15087','2013-07-19','09:50:00',3.03),('15087','2013-07-19','09:55:00',3.09),('15087','2013-07-19','10:00:00',3.14),('15087','2013-07-19','10:05:00',3.18),('15087','2013-07-19','10:10:00',3.26),('15087','2013-07-19','10:15:00',3.31),('15087','2013-07-19','10:20:00',3.33),('15087','2013-07-19','10:25:00',3.43),('15087','2013-07-19','10:30:00',3.43),('15087','2013-07-19','10:35:00',3.52),('15087','2013-07-19','10:40:00',3.58),('15087','2013-07-19','10:45:00',3.63),('15087','2013-07-19','10:50:00',3.61),('15087','2013-07-19','10:55:00',3.66),('15087','2013-07-19','11:00:00',3.72),('15087','2013-07-19','11:05:00',3.78),('15087','2013-07-19','11:10:00',3.83),('15087','2013-07-19','11:15:00',3.88),('15087','2013-07-19','11:20:00',3.95),('15087','2013-07-19','11:25:00',3.95),('15087','2013-07-19','11:30:00',3.96),('15087','2013-07-19','11:35:00',4.02),('15087','2013-07-19','11:40:00',4.08),('15087','2013-07-19','11:45:00',4.04),('15087','2013-07-19','11:50:00',4),('15087','2013-07-19','11:55:00',4.11),('15087','2013-07-19','12:00:00',4.21),('15087','2013-07-19','12:05:00',4.3),('15087','2013-07-19','12:10:00',4.28),('15087','2013-07-19','12:15:00',4.44),('15087','2013-07-19','12:20:00',4.47),('15087','2013-07-19','12:25:00',4.36),('15087','2013-07-19','12:30:00',4.34),('15087','2013-07-19','12:35:00',4.3),('15087','2013-07-19','12:40:00',4.27),('15087','2013-07-19','12:45:00',4.29),('15087','2013-07-19','12:50:00',4.56),('15087','2013-07-19','12:55:00',4.45),('15087','2013-07-19','13:00:00',3.68),('15087','2013-07-19','13:05:00',4.55),('15087','2013-07-19','13:10:00',3.55),('15087','2013-07-19','13:15:00',1.72),('15087','2013-07-19','13:20:00',2.63),('15087','2013-07-19','13:25:00',4.91),('15087','2013-07-19','13:30:00',4.71),('15087','2013-07-19','13:35:00',4.63),('15087','2013-07-19','13:40:00',4.6),('15087','2013-07-19','13:45:00',4.6),('15087','2013-07-19','13:50:00',4.65),('15087','2013-07-19','13:55:00',4.63),('15087','2013-07-19','14:00:00',4.59),('15087','2013-07-19','14:05:00',4.56),('15087','2013-07-19','14:10:00',4.14),('15087','2013-07-19','14:15:00',4.44),('15087','2013-07-19','14:20:00',4.6),('15087','2013-07-19','14:25:00',4.04),('15087','2013-07-19','14:30:00',4.48),('15087','2013-07-19','14:35:00',3.82),('15087','2013-07-19','14:40:00',4.28),('15087','2013-07-19','14:45:00',4.31),('15087','2013-07-19','14:50:00',4.14),('15087','2013-07-19','14:55:00',4.32),('15087','2013-07-19','15:00:00',4.18),('15087','2013-07-19','15:05:00',4.08),('15087','2013-07-19','15:10:00',4.12),('15087','2013-07-19','15:15:00',2.22),('15087','2013-07-19','15:20:00',2.83),('15087','2013-07-19','15:25:00',3.46),('15087','2013-07-19','15:30:00',3.88),('15087','2013-07-19','15:35:00',3.8),('15087','2013-07-19','15:40:00',3.92),('15087','2013-07-19','15:45:00',3.82),('15087','2013-07-19','15:50:00',3.74),('15087','2013-07-19','15:55:00',3.5),('15087','2013-07-19','16:00:00',3.21),('15087','2013-07-19','16:05:00',3.3),('15087','2013-07-19','16:10:00',3.46),('15087','2013-07-19','16:15:00',3.33),('15087','2013-07-19','16:20:00',3.25),('15087','2013-07-19','16:25:00',3.31),('15087','2013-07-19','16:30:00',3.33),('15087','2013-07-19','16:35:00',3.21),('15087','2013-07-19','16:40:00',3.21),('15087','2013-07-19','16:45:00',3.16),('15087','2013-07-19','16:50:00',3.1),('15087','2013-07-19','16:55:00',3.06),('15087','2013-07-19','17:00:00',2.57),('15087','2013-07-19','17:05:00',2.99),('15087','2013-07-19','17:10:00',2.71),('15087','2013-07-19','17:15:00',2.74),('15087','2013-07-19','17:20:00',2.5),('15087','2013-07-19','17:25:00',1.93),('15087','2013-07-19','17:30:00',2.35),('15087','2013-07-19','17:35:00',2.59),('15087','2013-07-19','17:40:00',2),('15087','2013-07-19','17:45:00',1.41),('15087','2013-07-19','17:50:00',1.01),('15087','2014-05-03','07:35:00',1.02),('15087','2014-05-03','07:40:00',1.12),('15087','2014-05-03','07:45:00',1.21),('15087','2014-05-03','07:50:00',1.33),('15087','2014-05-03','07:55:00',1.49),('15087','2014-05-03','08:00:00',1.67),('15087','2014-05-03','08:05:00',1.82),('15087','2014-05-03','08:10:00',2.17),('15087','2014-05-03','08:15:00',2.07),('15087','2014-05-03','08:20:00',1.19),('15087','2014-05-03','08:25:00',1.19),('15087','2014-05-03','08:30:00',1.77),('15087','2014-05-03','08:45:00',1.63),('15087','2014-05-03','08:50:00',2.86),('15087','2014-05-03','08:55:00',3.03),('15087','2014-05-03','09:00:00',2.3),('15087','2014-05-03','09:05:00',2.12),('15087','2014-05-03','09:10:00',1.52),('15087','2014-05-03','09:15:00',2.8),('15087','2014-05-03','09:20:00',3.72),('15087','2014-05-03','09:25:00',2.23),('15087','2014-05-03','09:30:00',2.32),('15087','2014-05-03','09:35:00',3.25),('15087','2014-05-03','09:40:00',2.68),('15087','2014-05-03','09:45:00',3.71),('15087','2014-05-03','09:50:00',2.24),('15087','2014-05-03','09:55:00',3.77),('15087','2014-05-03','10:00:00',3.97),('15087','2014-05-03','10:05:00',3.97),('15087','2014-05-03','10:10:00',4.27),('15087','2014-05-03','10:15:00',4.1),('15087','2014-05-03','10:20:00',2.42),('15087','2014-05-03','10:25:00',1.55),('15087','2014-05-03','10:30:00',2.2),('15087','2014-05-03','10:35:00',1.25),('15087','2014-05-03','10:40:00',1.27),('15087','2014-05-03','10:45:00',1.23),('15087','2014-05-03','10:50:00',1.13),('15087','2014-05-03','10:55:00',1.51),('15087','2014-05-03','11:00:00',1.28),('15087','2014-05-03','11:05:00',4.54),('15087','2014-05-03','11:10:00',4.6),('15087','2014-05-03','11:15:00',5.41),('15087','2014-05-03','11:20:00',5.3),('15087','2014-05-03','11:25:00',4.15),('15087','2014-05-03','11:30:00',5.15),('15087','2014-05-03','11:35:00',3.09),('15087','2014-05-03','11:40:00',3.44),('15087','2014-05-03','11:45:00',2.98),('15087','2014-05-03','11:50:00',2.66),('15087','2014-05-03','11:55:00',2.69),('15087','2014-05-03','12:00:00',2.02),('15087','2014-05-03','12:05:00',1.56),('15087','2014-05-03','12:10:00',1.38),('15087','2014-05-03','12:15:00',1.29),('15087','2014-05-03','12:20:00',1.22),('15087','2014-05-03','12:25:00',1.32),('15087','2014-05-03','12:30:00',1.84),('15087','2014-05-03','12:35:00',2.38),('15087','2014-05-03','12:40:00',2.31),('15087','2014-05-03','12:45:00',2.26),('15087','2014-05-03','12:50:00',1.94),('15087','2014-05-03','12:55:00',1.9),('15087','2014-05-03','13:00:00',2.15),('15087','2014-05-03','13:05:00',2.71),('15087','2014-05-03','13:10:00',3.02),('15087','2014-05-03','13:15:00',3.13),('15087','2014-05-03','13:20:00',2.51),('15087','2014-05-03','13:25:00',2.97),('15087','2014-05-03','13:30:00',3.75),('15087','2014-05-03','13:35:00',3.52),('15087','2014-05-03','13:40:00',2.33),('15087','2014-05-03','13:45:00',2.08),('15087','2014-05-03','13:50:00',2.04),('15087','2014-05-03','13:55:00',2.05),('15087','2014-05-03','14:00:00',2.03),('15087','2014-05-03','14:05:00',2.07),('15087','2014-05-03','14:10:00',2.29),('15087','2014-05-03','14:15:00',2.72),('15087','2014-05-03','14:20:00',3.13),('15087','2014-05-03','14:25:00',3.7),('15087','2014-05-03','14:30:00',2.22),('15087','2014-05-03','14:35:00',1.7),('15087','2014-05-03','14:40:00',1.19),('15087','2014-05-03','14:55:00',3.35),('15087','2014-05-03','15:00:00',2.51),('15087','2014-05-03','15:05:00',1.3),('15087','2014-05-03','15:10:00',1.02),('15087','2014-05-03','17:05:00',1),('15087','2014-05-03','17:10:00',1.01),('15087','2014-05-03','17:50:00',1.14),('15087','2014-05-03','17:55:00',1.21),('15087','2014-04-06','08:15:00',1.13),('15087','2014-04-06','08:20:00',1.21),('15087','2014-04-06','08:25:00',1.33),('15087','2014-04-06','08:30:00',1.45),('15087','2014-04-06','08:35:00',1.57),('15087','2014-04-06','08:40:00',1.74),('15087','2014-04-06','08:45:00',1.8),('15087','2014-04-06','08:50:00',1.68),('15087','2014-04-06','09:10:00',1.95),('15087','2014-04-06','09:15:00',2.57),('15087','2014-04-06','09:20:00',2.36),('15087','2014-04-06','09:25:00',2.03),('15087','2014-04-06','09:30:00',1.89),('15087','2014-04-06','09:35:00',2.4),('15087','2014-04-06','09:40:00',2.65),('15087','2014-04-06','09:45:00',3.22),('15087','2014-04-06','09:50:00',3.86),('15087','2014-04-06','09:55:00',3.93),('15087','2014-04-06','10:00:00',3.7),('15087','2014-04-06','10:05:00',2.51),('15087','2014-04-06','10:10:00',2.09),('15087','2014-04-06','10:15:00',2.5),('15087','2014-04-06','10:20:00',1.98),('15087','2014-04-06','10:25:00',1.29),('15087','2014-04-06','10:30:00',1.4),('15087','2014-04-06','10:35:00',1.56),('15087','2014-04-06','10:40:00',1.75),('15087','2014-04-06','10:45:00',2.74),('15087','2014-04-06','10:50:00',3.04),('15087','2014-04-06','10:55:00',1.55),('15087','2014-04-06','11:00:00',2.94),('15087','2014-04-06','11:05:00',3.45),('15087','2014-04-06','11:10:00',4.65),('15087','2014-04-06','11:15:00',1.86),('15087','2014-04-06','11:20:00',3.97),('15087','2014-04-06','11:25:00',4.41),('15087','2014-04-06','11:30:00',4.64),('15087','2014-04-06','11:35:00',4.95),('15087','2014-04-06','11:40:00',4.44),('15087','2014-04-06','11:45:00',4.85),('15087','2014-04-06','11:50:00',3.66),('15087','2014-04-06','11:55:00',4.36),('15087','2014-04-06','12:00:00',4.81),('15087','2014-04-06','12:05:00',4.69),('15087','2014-04-06','12:10:00',4.66),('15087','2014-04-06','12:15:00',4.71),('15087','2014-04-06','12:20:00',3.82),('15087','2014-04-06','12:25:00',1.79),('15087','2014-04-06','12:30:00',2.15),('15087','2014-04-06','12:35:00',2.07),('15087','2014-04-06','12:40:00',1.4),('15087','2014-04-06','12:45:00',1.11),('15087','2014-04-06','12:50:00',1.07),('15087','2014-04-06','12:55:00',1.5),('15087','2014-04-06','13:00:00',4.71),('15087','2014-04-06','13:05:00',3.7),('15087','2014-04-06','13:10:00',4.87),('15087','2014-04-06','13:15:00',4.72),('15087','2014-04-06','13:20:00',2.74),('15087','2014-04-06','13:25:00',1.36),('15087','2014-04-06','13:30:00',3.83),('15087','2014-04-06','13:35:00',4.52),('15087','2014-04-06','13:40:00',1.44),('15087','2014-04-06','13:45:00',3.41),('15087','2014-04-06','13:50:00',4.89),('15087','2014-04-06','13:55:00',4.71),('15087','2014-04-06','14:00:00',4.54),('15087','2014-04-06','14:05:00',4.24),('15087','2014-04-06','14:10:00',4.64),('15087','2014-04-06','14:15:00',4.62),('15087','2014-04-06','14:20:00',2.06),('15087','2014-04-06','14:25:00',1.6),('15087','2014-04-06','14:30:00',1.12),('15087','2014-04-06','14:35:00',1.31),('15087','2014-04-06','14:40:00',1.46),('15087','2014-04-06','14:45:00',4.83),('15087','2014-04-06','14:50:00',3.83),('15087','2014-04-06','14:55:00',3.04),('15087','2014-04-06','15:00:00',2.28),('15087','2014-04-06','15:05:00',1.29),('15087','2014-04-06','15:10:00',3.16),('15087','2014-04-06','15:15:00',3.21),('15087','2014-04-06','15:20:00',3),('15087','2014-04-06','15:25:00',1.62),('15087','2014-04-06','15:30:00',1.23),('15087','2014-04-06','15:50:00',1.29),('15087','2014-04-06','15:55:00',3.55),('15087','2014-04-06','16:00:00',3.2),('15087','2014-04-06','16:05:00',1.8),('15087','2014-04-06','16:10:00',2.27),('15087','2014-04-06','16:15:00',1.36),('15087','2014-04-06','16:35:00',1.36),('15087','2014-04-06','16:40:00',2.16),('15087','2014-04-06','16:45:00',2.98),('15087','2014-04-06','16:50:00',2.98),('15087','2014-04-06','16:55:00',2.31),('15087','2014-04-06','17:25:00',1.7),('15087','2014-04-06','17:30:00',1.63),('15087','2014-04-06','17:35:00',1.17),('15087','2014-04-06','17:45:00',1),('15087','2014-04-06','17:50:00',1.28),('15087','2014-04-06','17:55:00',1.1),('15087','2014-04-06','18:00:00',1.03),('15087','2013-07-10','07:25:00',1.18),('15087','2013-07-10','07:30:00',1.32),('15087','2013-07-10','07:35:00',1.48),('15087','2013-07-10','07:40:00',1.63),('15087','2013-07-10','07:45:00',1.72),('15087','2013-07-10','07:50:00',1.93),('15087','2013-07-10','07:55:00',2.11),('15087','2013-07-10','08:00:00',1.72),('15087','2013-07-10','08:05:00',1.45),('15087','2013-07-10','08:10:00',1.86),('15087','2013-07-10','08:15:00',1.97),('15087','2013-07-10','08:20:00',2.18),('15087','2013-07-10','08:25:00',2.04),('15087','2013-07-10','08:30:00',1.83),('15087','2013-07-10','08:35:00',2.06),('15087','2013-07-10','08:40:00',2.64),('15087','2013-07-10','08:45:00',2.61),('15087','2013-07-10','08:50:00',2.62),('15087','2013-07-10','08:55:00',2.6),('15087','2013-07-10','09:00:00',2.62),('15087','2013-07-10','09:05:00',2.77),('15087','2013-07-10','09:10:00',2.86),('15087','2013-07-10','09:15:00',2.97),('15087','2013-07-10','09:20:00',2.37),('15087','2013-07-10','09:25:00',1.71),('15087','2013-07-10','09:30:00',2.78),('15087','2013-07-10','09:35:00',3.1),('15087','2013-07-10','09:40:00',3.11),('15087','2013-07-10','09:45:00',3.19),('15087','2013-07-10','09:50:00',3.24),('15087','2013-07-10','09:55:00',2.44),('15087','2013-07-10','10:00:00',3.35),('15087','2013-07-10','10:05:00',3.42),('15087','2013-07-10','10:10:00',3.48),('15087','2013-07-10','10:15:00',3.54),('15087','2013-07-10','10:20:00',3.63),('15087','2013-07-10','10:25:00',3.67),('15087','2013-07-10','10:30:00',3.75),('15087','2013-07-10','10:35:00',3.79),('15087','2013-07-10','10:40:00',3.83),('15087','2013-07-10','10:45:00',3.89),('15087','2013-07-10','10:50:00',3.93),('15087','2013-07-10','10:55:00',3.93),('15087','2013-07-10','11:00:00',3.95),('15087','2013-07-10','11:05:00',3.98),('15087','2013-07-10','11:10:00',4.02),('15087','2013-07-10','11:15:00',4.07),('15087','2013-07-10','11:20:00',4.11),('15087','2013-07-10','11:25:00',4.14),('15087','2013-07-10','11:30:00',4.12),('15087','2013-07-10','11:35:00',4.17),('15087','2013-07-10','11:40:00',4.23),('15087','2013-07-10','11:45:00',4.29),('15087','2013-07-10','11:50:00',4.3),('15087','2013-07-10','11:55:00',4.35),('15087','2013-07-10','12:00:00',4.4),('15087','2013-07-10','12:05:00',4.4),('15087','2013-07-10','12:10:00',4.46),('15087','2013-07-10','12:15:00',4.44),('15087','2013-07-10','12:20:00',4.47),('15087','2013-07-10','12:25:00',4.56),('15087','2013-07-10','12:30:00',4.51),('15087','2013-07-10','12:35:00',4.58),('15087','2013-07-10','12:40:00',4.58),('15087','2013-07-10','12:45:00',4.57),('15087','2013-07-10','12:50:00',4.57),('15087','2013-07-10','12:55:00',4.6),('15087','2013-07-10','13:00:00',4.61),('15087','2013-07-10','13:05:00',4.63),('15087','2013-07-10','13:10:00',4.66),('15087','2013-07-10','13:15:00',4.6),('15087','2013-07-10','13:20:00',4.58),('15087','2013-07-10','13:25:00',4.62),('15087','2013-07-10','13:30:00',4.59),('15087','2013-07-10','13:35:00',4.6),('15087','2013-07-10','13:40:00',4.62),('15087','2013-07-10','13:45:00',4.62),('15087','2013-07-10','13:50:00',4.61),('15087','2013-07-10','13:55:00',4.62),('15087','2013-07-10','14:00:00',4.63),('15087','2013-07-10','14:05:00',4.62),('15087','2013-07-10','14:10:00',4.62),('15087','2013-07-10','14:15:00',4.61),('15087','2013-07-10','14:20:00',4.59),('15087','2013-07-10','14:25:00',4.55),('15087','2013-07-10','14:30:00',4.52),('15087','2013-07-10','14:35:00',4.49),('15087','2013-07-10','14:40:00',4.44),('15087','2013-07-10','14:45:00',4.34),('15087','2013-07-10','14:50:00',4.32),('15087','2013-07-10','14:55:00',4.32),('15087','2013-07-10','15:00:00',4.26),('15087','2013-07-10','15:05:00',4.2),('15087','2013-07-10','15:10:00',4),('15087','2013-07-10','15:15:00',4.01),('15087','2013-07-10','15:20:00',4.05),('15087','2013-07-10','15:25:00',4.02),('15087','2013-07-10','15:30:00',3.92),('15087','2013-07-10','15:35:00',3.73),('15087','2013-07-10','15:45:00',1.59),('15087','2013-07-10','15:50:00',3.55),('15087','2013-07-10','15:55:00',3.58),('15087','2013-07-10','16:00:00',3.51),('15087','2013-07-10','16:05:00',2.37),('15087','2013-07-10','16:10:00',3.34),('15087','2013-07-10','16:15:00',3.38),('15087','2013-07-10','16:20:00',3.39),('15087','2013-07-10','16:25:00',2.54),('15087','2013-07-10','16:30:00',3.04),('15087','2013-07-10','16:35:00',3.11),('15087','2013-07-10','16:40:00',3.07),('15087','2013-07-10','16:45:00',2.83),('15087','2013-07-10','16:50:00',2.39),('15087','2013-07-10','16:55:00',2.9),('15087','2013-07-10','17:00:00',2.96),('15087','2013-07-10','17:05:00',2.46),('15087','2013-07-10','17:10:00',1.9),('15087','2013-07-10','17:15:00',1.57),('15087','2013-07-10','17:20:00',1.81),('15087','2013-07-10','17:35:00',1.92),('15087','2013-07-10','17:40:00',1.78),('15087','2013-07-10','17:45:00',1.98),('15087','2013-07-10','17:50:00',1.92),('15087','2013-07-10','17:55:00',1.72),('15087','2013-07-10','18:00:00',1.77),('15087','2013-07-10','18:05:00',1.4),('15087','2013-07-10','18:10:00',1.09),('15087','2013-07-09','07:40:00',1.12),('15087','2013-07-09','07:45:00',1.19),('15087','2013-07-09','07:50:00',1.27),('15087','2013-07-09','07:55:00',1.36),('15087','2013-07-09','08:00:00',1.41),('15087','2013-07-09','08:05:00',1.51),('15087','2013-07-09','08:10:00',1.58),('15087','2013-07-09','08:15:00',1.67),('15087','2013-07-09','08:20:00',1.74),('15087','2013-07-09','08:25:00',1.82),('15087','2013-07-09','08:30:00',1.94),('15087','2013-07-09','08:35:00',2.04),('15087','2013-07-09','08:40:00',2.15),('15087','2013-07-09','08:45:00',2.23),('15087','2013-07-09','08:50:00',2.35),('15087','2013-07-09','08:55:00',2.42),('15087','2013-07-09','09:00:00',2.49),('15087','2013-07-09','09:05:00',2.58),('15087','2013-07-09','09:10:00',2.67),('15087','2013-07-09','09:15:00',2.76),('15087','2013-07-09','09:20:00',2.82),('15087','2013-07-09','09:25:00',2.89),('15087','2013-07-09','09:30:00',2.96),('15087','2013-07-09','09:35:00',3.02),('15087','2013-07-09','09:40:00',3.08),('15087','2013-07-09','09:45:00',3.16),('15087','2013-07-09','09:50:00',3.23),('15087','2013-07-09','09:55:00',3.3),('15087','2013-07-09','10:00:00',3.08),('15087','2013-07-09','10:05:00',3.26),('15087','2013-07-09','10:10:00',3.46),('15087','2013-07-09','10:15:00',3.5),('15087','2013-07-09','10:20:00',3.58),('15087','2013-07-09','10:25:00',3.62),('15087','2013-07-09','10:30:00',3.68),('15087','2013-07-09','10:35:00',3.73),('15087','2013-07-09','10:40:00',3.79),('15087','2013-07-09','10:45:00',3.84),('15087','2013-07-09','10:50:00',3.91),('15087','2013-07-09','10:55:00',3.95),('15087','2013-07-09','11:00:00',4.01),('15087','2013-07-09','11:05:00',4.03),('15087','2013-07-09','11:10:00',4.04),('15087','2013-07-09','11:15:00',3.93),('15087','2013-07-09','11:20:00',3.99),('15087','2013-07-09','11:25:00',3.73),('15087','2013-07-09','11:30:00',2.46),('15087','2013-07-09','11:35:00',3.09),('15087','2013-07-09','11:40:00',3.64),('15087','2013-07-09','11:45:00',4.2),('15087','2013-07-09','11:50:00',4.86),('15087','2013-07-09','11:55:00',4.71),('15087','2013-07-09','12:00:00',4.7),('15087','2013-07-09','12:05:00',4.65),('15087','2013-07-09','12:10:00',4.58),('15087','2013-07-09','12:15:00',4.54),('15087','2013-07-09','12:20:00',4.49),('15087','2013-07-09','12:25:00',4.47),('15087','2013-07-09','12:30:00',4.47),('15087','2013-07-09','12:35:00',4.47),('15087','2013-07-09','12:40:00',4.51),('15087','2013-07-09','12:45:00',4.52),('15087','2013-07-09','12:50:00',4.48),('15087','2013-07-09','12:55:00',4.48),('15087','2013-07-09','13:00:00',4.53),('15087','2013-07-09','13:05:00',4.67),('15087','2013-07-09','13:10:00',4.7),('15087','2013-07-09','13:15:00',4.63),('15087','2013-07-09','13:20:00',4.56),('15087','2013-07-09','13:25:00',4.68),('15087','2013-07-09','13:30:00',4.76),('15087','2013-07-09','13:35:00',4.6),('15087','2013-07-09','13:40:00',4.6),('15087','2013-07-09','13:45:00',4.07),('15087','2013-07-09','13:50:00',3.43),('15087','2013-07-09','13:55:00',3.66),('15087','2013-07-09','14:00:00',3.69),('15087','2013-07-09','14:05:00',3.48),('15087','2013-07-09','14:10:00',3.83),('15087','2013-07-09','14:15:00',3.96),('15087','2013-07-09','14:20:00',2.87),('15087','2013-07-09','14:25:00',2.92),('15087','2013-07-09','14:30:00',1.83),('15087','2013-07-09','14:35:00',1.08),('15087','2013-07-08','07:40:00',1.39),('15087','2013-07-08','07:45:00',1.37),('15087','2013-07-08','07:50:00',1.07),('15087','2013-07-08','07:55:00',1.09),('15087','2013-07-08','08:00:00',1.25),('15087','2013-07-08','08:05:00',1.28),('15087','2013-07-08','08:10:00',1.47),('15087','2013-07-08','08:15:00',1.65),('15087','2013-07-08','08:20:00',1.76),('15087','2013-07-08','08:25:00',1.85),('15087','2013-07-08','08:30:00',1.99),('15087','2013-07-08','08:35:00',2.09),('15087','2013-07-08','08:40:00',2.15),('15087','2013-07-08','08:45:00',2.25),('15087','2013-07-08','08:50:00',2.35),('15087','2013-07-08','08:55:00',2.44),('15087','2013-07-08','09:00:00',2.51),('15087','2013-07-08','09:05:00',2.59),('15087','2013-07-08','09:10:00',2.65),('15087','2013-07-08','09:15:00',2.71),('15087','2013-07-08','09:20:00',2.78),('15087','2013-07-08','09:25:00',2.76),('15087','2013-07-08','09:30:00',2.85),('15087','2013-07-08','09:35:00',3.08),('15087','2013-07-08','09:40:00',3.14),('15087','2013-07-08','09:45:00',3.22),('15087','2013-07-08','09:50:00',3.24),('15087','2013-07-08','09:55:00',3.31),('15087','2013-07-08','10:00:00',3.41),('15087','2013-07-08','10:05:00',3.46),('15087','2013-07-08','10:10:00',3.5),('15087','2013-07-08','10:15:00',3.57),('15087','2013-07-08','10:20:00',3.63),('15087','2013-07-08','10:25:00',3.69),('15087','2013-07-08','10:30:00',3.73),('15087','2013-07-08','10:35:00',3.78),('15087','2013-07-08','10:40:00',3.79),('15087','2013-07-08','10:45:00',3.84),('15087','2013-07-08','10:50:00',3.88),('15087','2013-07-08','10:55:00',3.88),('15087','2013-07-08','11:00:00',3.9),('15087','2013-07-08','11:05:00',3.97),('15087','2013-07-08','11:10:00',4.04),('15087','2013-07-08','11:15:00',4.11),('15087','2013-07-08','11:20:00',4.19),('15087','2013-07-08','11:25:00',4.27),('15087','2013-07-08','11:30:00',4.3),('15087','2013-07-08','11:35:00',4.34),('15087','2013-07-08','11:40:00',4.16),('15087','2013-07-08','11:45:00',4.28),('15087','2013-07-08','11:50:00',4.42),('15087','2013-07-08','11:55:00',4.41),('15087','2013-07-08','12:00:00',4.42),('15087','2013-07-08','12:05:00',4.53),('15087','2013-07-08','12:10:00',4.59),('15087','2013-07-08','12:15:00',4.7),('15087','2013-07-08','12:20:00',4.8),('15087','2013-07-08','12:25:00',4.75),('15087','2013-07-08','12:30:00',4.08),('15087','2013-07-08','12:35:00',4.62),('15087','2013-07-08','12:40:00',4.59),('15087','2013-07-08','12:45:00',4.6),('15087','2013-07-08','12:50:00',4.57),('15087','2013-07-08','12:55:00',4.65),('15087','2013-07-08','13:00:00',4.84),('15087','2013-07-08','13:05:00',4.97),('15087','2013-07-08','13:10:00',4.64),('15087','2013-07-08','13:15:00',5.22),('15087','2013-07-08','13:20:00',3.23),('15087','2013-07-08','13:25:00',1.38),('15087','2013-07-08','14:30:00',1),('15087','2013-07-08','14:35:00',1.19),('15087','2013-07-08','14:40:00',1.25),('15087','2013-07-08','14:45:00',1.19),('15087','2013-07-08','14:50:00',1.16),('15087','2013-07-08','14:55:00',1.15),('15087','2013-07-08','15:00:00',1.06),('15087','2013-07-08','17:35:00',1.05),('15087','2013-07-08','17:45:00',1.07),('15087','2013-07-08','17:50:00',1.07),('15087','2013-07-08','17:55:00',1.03),('15087','2013-07-08','18:40:00',1.21),('15087','2013-07-08','18:45:00',1.16),('15087','2013-07-08','18:50:00',1.03),('15087','2013-07-07','07:35:00',1.07),('15087','2013-07-07','07:40:00',1.16),('15087','2013-07-07','07:45:00',1.24),('15087','2013-07-07','07:50:00',1.33),('15087','2013-07-07','07:55:00',1.41),('15087','2013-07-07','08:00:00',1.51),('15087','2013-07-07','08:05:00',1.61),('15087','2013-07-07','08:10:00',1.71),('15087','2013-07-07','08:15:00',1.79),('15087','2013-07-07','08:20:00',1.4),('15087','2013-07-07','08:25:00',1.52),('15087','2013-07-07','08:30:00',1.84),('15087','2013-07-07','08:35:00',2.31),('15087','2013-07-07','08:40:00',1.68),('15087','2013-07-07','08:50:00',1.82),('15087','2013-07-07','08:55:00',2.64),('15087','2013-07-07','09:00:00',2.71),('15087','2013-07-07','09:05:00',2.43),('15087','2013-07-07','09:10:00',2.58),('15087','2013-07-07','09:15:00',2.67),('15087','2013-07-07','09:20:00',1.75),('15087','2013-07-07','09:25:00',2.17),('15087','2013-07-07','09:30:00',3.08),('15087','2013-07-07','09:35:00',3.15),('15087','2013-07-07','09:40:00',3.07),('15087','2013-07-07','09:45:00',3.28),('15087','2013-07-07','09:50:00',3.42),('15087','2013-07-07','09:55:00',3.57),('15087','2013-07-07','10:00:00',3.65),('15087','2013-07-07','10:05:00',3.41),('15087','2013-07-07','10:10:00',3.45),('15087','2013-07-07','10:15:00',3.45),('15087','2013-07-07','10:20:00',3.4),('15087','2013-07-07','10:25:00',3.72),('15087','2013-07-07','10:30:00',3.24),('15087','2013-07-07','10:35:00',4),('15087','2013-07-07','10:40:00',3.8),('15087','2013-07-07','10:45:00',3.93),('15087','2013-07-07','10:50:00',4.13),('15087','2013-07-07','10:55:00',4.09),('15087','2013-07-07','11:00:00',4.13),('15087','2013-07-07','11:05:00',4.16),('15087','2013-07-07','11:10:00',4.24),('15087','2013-07-07','11:15:00',4.26),('15087','2013-07-07','11:20:00',3.95),('15087','2013-07-07','11:25:00',3.7),('15087','2013-07-07','11:30:00',3.75),('15087','2013-07-07','11:35:00',3.64),('15087','2013-07-07','11:40:00',3.87),('15087','2013-07-07','11:45:00',3.17),('15087','2013-07-07','11:50:00',3.35),('15087','2013-07-07','11:55:00',2.46),('15087','2013-07-07','12:00:00',2.41),('15087','2013-07-07','12:05:00',4.31),('15087','2013-07-07','12:10:00',4.39),('15087','2013-07-07','12:15:00',4.47),('15087','2013-07-07','12:20:00',4.58),('15087','2013-07-07','12:25:00',4.39),('15087','2013-07-07','12:30:00',4.31),('15087','2013-07-07','12:35:00',4.5),('15087','2013-07-07','12:40:00',4.7),('15087','2013-07-07','12:45:00',4.75),('15087','2013-07-07','12:50:00',4.55),('15087','2013-07-07','12:55:00',4.83),('15087','2013-07-07','13:00:00',4.69),('15087','2013-07-07','13:05:00',4.72),('15087','2013-07-07','13:10:00',4.71),('15087','2013-07-07','13:15:00',4.74),('15087','2013-07-07','13:20:00',4.67),('15087','2013-07-07','13:25:00',4.21),('15087','2013-07-07','13:30:00',3.82),('15087','2013-07-07','13:35:00',4.79),('15087','2013-07-07','13:40:00',4.89),('15087','2013-07-07','13:45:00',3.58),('15087','2013-07-07','13:50:00',5.2),('15087','2013-07-07','13:55:00',4.35),('15087','2013-07-07','14:00:00',3.06),('15087','2013-07-07','14:05:00',3.64),('15087','2013-07-07','14:10:00',2.77),('15087','2013-07-07','14:15:00',1.56),('15087','2013-07-07','14:20:00',1.29),('15087','2013-07-07','14:25:00',1.12),('15087','2013-07-07','14:30:00',1.06),('15087','2013-07-07','15:00:00',1.01),('15087','2013-07-07','15:05:00',1.16),('15087','2013-07-07','17:05:00',1.03),('15087','2013-07-07','17:10:00',1.07),('15087','2013-07-07','17:15:00',1.11),('15087','2013-07-07','17:20:00',1.12),('15087','2013-07-07','17:25:00',1.1),('15087','2013-07-07','17:30:00',1.06),('15087','2013-07-06','07:35:00',1.02),('15087','2013-07-06','07:40:00',1.1),('15087','2013-07-06','07:45:00',1.18),('15087','2013-07-06','07:50:00',1.27),('15087','2013-07-06','07:55:00',1.37),('15087','2013-07-06','08:00:00',1.46),('15087','2013-07-06','08:05:00',1.54),('15087','2013-07-06','08:10:00',1.63),('15087','2013-07-06','08:15:00',1.71),('15087','2013-07-06','08:20:00',1.78),('15087','2013-07-06','08:25:00',1.88),('15087','2013-07-06','08:30:00',1.99),('15087','2013-07-06','08:35:00',2.07),('15087','2013-07-06','08:40:00',2.22),('15087','2013-07-06','08:45:00',2.33),('15087','2013-07-06','08:50:00',2.41),('15087','2013-07-06','08:55:00',2.47),('15087','2013-07-06','09:00:00',2.58),('15087','2013-07-06','09:05:00',2.66),('15087','2013-07-06','09:10:00',2.75),('15087','2013-07-06','09:15:00',2.81),('15087','2013-07-06','09:20:00',2.9),('15087','2013-07-06','09:25:00',2.96),('15087','2013-07-06','09:30:00',3.01),('15087','2013-07-06','09:35:00',3.08),('15087','2013-07-06','09:40:00',3.14),('15087','2013-07-06','09:45:00',3.21),('15087','2013-07-06','09:50:00',3.28),('15087','2013-07-06','09:55:00',3.37),('15087','2013-07-06','10:00:00',3.44),('15087','2013-07-06','10:05:00',3.53),('15087','2013-07-06','10:10:00',3.61),('15087','2013-07-06','10:15:00',3.65),('15087','2013-07-06','10:20:00',3.69),('15087','2013-07-06','10:25:00',3.73),('15087','2013-07-06','10:30:00',3.77),('15087','2013-07-06','10:35:00',3.81),('15087','2013-07-06','10:40:00',3.83),('15087','2013-07-06','10:45:00',3.91),('15087','2013-07-06','10:50:00',3.95),('15087','2013-07-06','10:55:00',4.02),('15087','2013-07-06','11:00:00',4.08),('15087','2013-07-06','11:05:00',4.12),('15087','2013-07-06','11:10:00',4.15),('15087','2013-07-06','11:15:00',4.2),('15087','2013-07-06','11:20:00',4.17),('15087','2013-07-06','11:25:00',4.22),('15087','2013-07-06','11:30:00',4.26),('15087','2013-07-06','11:35:00',4.3),('15087','2013-07-06','11:40:00',4.32),('15087','2013-07-06','11:45:00',4.37),('15087','2013-07-06','11:50:00',4.42),('15087','2013-07-06','11:55:00',4.39),('15087','2013-07-06','12:00:00',4.42),('15087','2013-07-06','12:05:00',4.48),('15087','2013-07-06','12:10:00',4.57),('15087','2013-07-06','12:15:00',4.59),('15087','2013-07-06','12:20:00',4.61),('15087','2013-07-06','12:25:00',4.64),('15087','2013-07-06','12:30:00',4.65),('15087','2013-07-06','12:35:00',4.66),('15087','2013-07-06','12:40:00',4.63),('15087','2013-07-06','12:45:00',4.63),('15087','2013-07-06','12:50:00',4.65),('15087','2013-07-06','12:55:00',4.64),('15087','2013-07-06','13:00:00',4.7),('15087','2013-07-06','13:05:00',4.68),('15087','2013-07-06','13:10:00',4.68),('15087','2013-07-06','13:15:00',4.68),('15087','2013-07-06','13:20:00',4.69),('15087','2013-07-06','13:25:00',4.64),('15087','2013-07-06','13:30:00',4.71),('15087','2013-07-06','13:35:00',4.64),('15087','2013-07-06','13:40:00',4.72),('15087','2013-07-06','13:45:00',4.69),('15087','2013-07-06','13:50:00',4.61),('15087','2013-07-06','13:55:00',4.57),('15087','2013-07-06','14:00:00',4.62),('15087','2013-07-06','14:05:00',4.64),('15087','2013-07-06','14:10:00',4.59),('15087','2013-07-06','14:15:00',4.6),('15087','2013-07-06','14:20:00',4.57),('15087','2013-07-06','14:25:00',4.59),('15087','2013-07-06','14:30:00',4.51),('15087','2013-07-06','14:35:00',4.51),('15087','2013-07-06','14:40:00',4.49),('15087','2013-07-06','14:45:00',4.35),('15087','2013-07-06','14:50:00',4.16),('15087','2013-07-06','14:55:00',3.42),('15087','2013-07-06','15:00:00',4.03),('15087','2013-07-06','15:05:00',4.42),('15087','2013-07-06','15:10:00',4.25),('15087','2013-07-06','15:15:00',4.13),('15087','2013-07-06','15:20:00',4.06),('15087','2013-07-06','15:25:00',4.06),('15087','2013-07-06','15:30:00',3.29),('15087','2013-07-06','15:35:00',2.51),('15087','2013-07-06','15:40:00',1.02),('15087','2013-07-06','16:50:00',1.65),('15087','2013-07-06','16:55:00',2.03),('15087','2013-07-06','17:00:00',1.14),('15087','2013-07-06','17:05:00',1.07),('15087','2013-07-06','17:10:00',1.28),('15087','2013-07-06','17:15:00',2.32),('15087','2013-07-06','17:20:00',1.28),('15087','2013-07-06','17:25:00',1.05),('15087','2013-07-06','17:30:00',1.22),('15087','2013-07-06','17:35:00',1.16),('15087','2013-07-05','07:30:00',1),('15087','2013-07-05','07:35:00',1.1),('15087','2013-07-05','07:40:00',1.18),('15087','2013-07-05','07:45:00',1.25),('15087','2013-07-05','07:50:00',1.33),('15087','2013-07-05','07:55:00',1.41),('15087','2013-07-05','08:00:00',1.51),('15087','2013-07-05','08:05:00',1.59),('15087','2013-07-05','08:10:00',1.67),('15087','2013-07-05','08:15:00',1.76),('15087','2013-07-05','08:20:00',1.82),('15087','2013-07-05','08:25:00',1.89),('15087','2013-07-05','08:30:00',1.99),('15087','2013-07-05','08:35:00',2.07),('15087','2013-07-05','08:40:00',2.22),('15087','2013-07-05','08:45:00',2.3),('15087','2013-07-05','08:50:00',2.4),('15087','2013-07-05','08:55:00',2.44),('15087','2013-07-05','09:00:00',2.57),('15087','2013-07-05','09:05:00',2.65),('15087','2013-07-05','09:10:00',2.73),('15087','2013-07-05','09:15:00',2.8),('15087','2013-07-05','09:20:00',2.88),('15087','2013-07-05','09:25:00',2.96),('15087','2013-07-05','09:30:00',3.03),('15087','2013-07-05','09:35:00',3.08),('15087','2013-07-05','09:40:00',3.16),('15087','2013-07-05','09:45:00',3.23),('15087','2013-07-05','09:50:00',3.28),('15087','2013-07-05','09:55:00',3.34),('15087','2013-07-05','10:00:00',3.41),('15087','2013-07-05','10:05:00',3.47),('15087','2013-07-05','10:10:00',3.54),('15087','2013-07-05','10:15:00',3.59),('15087','2013-07-05','10:20:00',3.64),('15087','2013-07-05','10:25:00',3.69),('15087','2013-07-05','10:30:00',3.75),('15087','2013-07-05','10:35:00',3.8),('15087','2013-07-05','10:40:00',3.84),('15087','2013-07-05','10:45:00',3.88),('15087','2013-07-05','10:50:00',3.92),('15087','2013-07-05','10:55:00',3.95),('15087','2013-07-05','11:00:00',3.97),('15087','2013-07-05','11:05:00',4),('15087','2013-07-05','11:10:00',4.04),('15087','2013-07-05','11:15:00',4.08),('15087','2013-07-05','11:20:00',4.13),('15087','2013-07-05','11:25:00',4.16),('15087','2013-07-05','11:30:00',4.21),('15087','2013-07-05','11:35:00',4.27),('15087','2013-07-05','11:40:00',4.3),('15087','2013-07-05','11:45:00',4.31),('15087','2013-07-05','11:50:00',4.32),('15087','2013-07-05','11:55:00',4.41),('15087','2013-07-05','12:00:00',4.39),('15087','2013-07-05','12:05:00',4.41),('15087','2013-07-05','12:10:00',4.43),('15087','2013-07-05','12:15:00',4.45),('15087','2013-07-05','12:20:00',4.56),('15087','2013-07-05','12:25:00',3.56),('15087','2013-07-05','12:30:00',4.3),('15087','2013-07-05','12:35:00',3.4),('15087','2013-07-05','12:40:00',3.77),('15087','2013-07-05','12:45:00',4.59),('15087','2013-07-05','12:50:00',4.64),('15087','2013-07-05','12:55:00',4.69),('15087','2013-07-05','13:00:00',3.93),('15087','2013-07-05','13:05:00',2.85),('15087','2013-07-05','13:10:00',4.84),('15087','2013-07-05','13:15:00',4.78),('15087','2013-07-05','13:20:00',2.92),('15087','2013-07-05','13:25:00',4.77),('15087','2013-07-05','13:30:00',4.72),('15087','2013-07-05','13:35:00',4.44),('15087','2013-07-05','13:40:00',4.72),('15087','2013-07-05','13:45:00',4.67),('15087','2013-07-05','13:50:00',4.62),('15087','2013-07-05','13:55:00',4.65),('15087','2013-07-05','14:00:00',4.69),('15087','2013-07-05','14:05:00',4.44),('15087','2013-07-05','14:10:00',3.35),('15087','2013-07-05','14:15:00',4.57),('15087','2013-07-05','14:20:00',4.48),('15087','2013-07-05','14:25:00',4.46),('15087','2013-07-05','14:30:00',4.42),('15087','2013-07-05','14:35:00',4.3),('15087','2013-07-05','14:40:00',4.41),('15087','2013-07-05','14:45:00',2.82),('15087','2013-07-05','14:50:00',3.61),('15087','2013-07-05','14:55:00',4.23),('15087','2013-07-05','15:00:00',4.29),('15087','2013-07-05','15:05:00',2.74),('15087','2013-07-05','15:10:00',4.28),('15087','2013-07-05','15:15:00',4.16),('15087','2013-07-05','15:20:00',3.01),('15087','2013-07-05','15:25:00',4.02),('15087','2013-07-05','15:30:00',3.83),('15087','2013-07-05','15:35:00',3.88),('15087','2013-07-05','15:40:00',3.61),('15087','2013-07-05','15:45:00',3.81),('15087','2013-07-05','15:50:00',3.78),('15087','2013-07-05','15:55:00',3.67),('15087','2013-07-05','16:00:00',3.55),('15087','2013-07-05','16:05:00',3.55),('15087','2013-07-05','16:10:00',3.28),('15087','2013-07-05','16:15:00',3.44),('15087','2013-07-05','16:20:00',3.4),('15087','2013-07-05','16:25:00',3.36),('15087','2013-07-05','16:30:00',3.32),('15087','2013-07-05','16:35:00',3.19),('15087','2013-07-05','16:40:00',3.11),('15087','2013-07-05','16:45:00',3.04),('15087','2013-07-05','16:50:00',2.98),('15087','2013-07-05','16:55:00',2.91),('15087','2013-07-05','17:00:00',2.85),('15087','2013-07-05','17:05:00',2.78),('15087','2013-07-05','17:10:00',2.7),('15087','2013-07-05','17:15:00',2.7),('15087','2013-07-05','17:20:00',2.65),('15087','2013-07-05','17:25:00',2.51),('15087','2013-07-05','17:30:00',2.46),('15087','2013-07-05','17:35:00',2.3),('15087','2013-07-05','17:40:00',2.12),('15087','2013-07-05','17:45:00',1.96),('15087','2013-07-05','17:50:00',1.81),('15087','2013-07-05','17:55:00',1.74),('15087','2013-07-05','18:00:00',1.71),('15087','2013-07-05','18:05:00',1.55),('15087','2013-07-05','18:10:00',1.38),('15087','2013-07-05','18:15:00',1.08),('15087','2013-07-05','18:20:00',1.08),('15087','2013-07-04','11:10:00',1.09),('15087','2013-07-04','11:15:00',1.13),('15087','2013-07-04','11:20:00',1.09),('15087','2013-07-04','11:25:00',1.17),('15087','2013-07-04','11:30:00',1.28),('15087','2013-07-04','11:35:00',1.49),('15087','2013-07-04','11:40:00',1.72),('15087','2013-07-04','11:45:00',1.84),('15087','2013-07-04','11:50:00',1.87),('15087','2013-07-04','11:55:00',1.67),('15087','2013-07-04','12:00:00',1.53),('15087','2013-07-04','12:05:00',2.14),('15087','2013-07-04','12:10:00',2.76),('15087','2013-07-04','12:15:00',2.77),('15087','2013-07-04','12:20:00',2.68),('15087','2013-07-04','12:25:00',3.6),('15087','2013-07-04','12:30:00',2.97),('15087','2013-07-04','12:35:00',2.48),('15087','2013-07-04','12:40:00',1.76),('15087','2013-07-04','12:45:00',1.36),('15087','2013-07-04','12:50:00',1.07),('15087','2013-07-04','13:00:00',1.1),('15087','2013-07-04','13:05:00',1.35),('15087','2013-07-04','13:10:00',1.85),('15087','2013-07-04','13:15:00',2.25),('15087','2013-07-04','13:20:00',2.24),('15087','2013-07-04','13:25:00',3.19),('15087','2013-07-04','13:30:00',2.55),('15087','2013-07-04','13:35:00',2.68),('15087','2013-07-04','13:40:00',3.08),('15087','2013-07-04','13:45:00',5.33),('15087','2013-07-04','13:50:00',5.61),('15087','2013-07-04','13:55:00',4.18),('15087','2013-07-04','14:00:00',3.73),('15087','2013-07-04','14:05:00',2.56),('15087','2013-07-04','14:10:00',2.42),('15087','2013-07-04','14:15:00',2.47),('15087','2013-07-04','14:20:00',2.5),('15087','2013-07-04','14:25:00',2.2),('15087','2013-07-04','14:30:00',2.16),('15087','2013-07-04','14:35:00',2.28),('15087','2013-07-04','14:40:00',2.76),('15087','2013-07-04','14:45:00',3.66),('15087','2013-07-04','14:50:00',2.77),('15087','2013-07-04','14:55:00',2.35),('15087','2013-07-04','15:00:00',1.99),('15087','2013-07-04','15:05:00',2.33),('15087','2013-07-04','15:10:00',3.75),('15087','2013-07-04','15:15:00',3.27),('15087','2013-07-04','15:20:00',3.02),('15087','2013-07-04','15:25:00',2.94),('15087','2013-07-04','15:30:00',2.76),('15087','2013-07-04','15:35:00',2.66),('15087','2013-07-04','15:40:00',2.81),('15087','2013-07-04','15:45:00',3.75),('15087','2013-07-04','15:50:00',2.28),('15087','2013-07-04','15:55:00',2.48),('15087','2013-07-04','16:00:00',2.64),('15087','2013-07-04','16:05:00',2.59),('15087','2013-07-04','16:10:00',1.98),('15087','2013-07-04','16:15:00',1.89),('15087','2013-07-04','16:20:00',1.98),('15087','2013-07-04','16:25:00',2.32),('15087','2013-07-04','16:30:00',2.4),('15087','2013-07-04','16:35:00',2.43),('15087','2013-07-04','16:40:00',1.9),('15087','2013-07-04','16:45:00',1.66),('15087','2013-07-04','16:50:00',1.59),('15087','2013-07-04','16:55:00',1.52),('15087','2013-07-04','17:00:00',1.33),('15087','2013-07-04','17:05:00',1.31),('15087','2013-07-04','17:10:00',2.05),('15087','2013-07-04','17:15:00',2.66),('15087','2013-07-04','17:20:00',2.41),('15087','2013-07-04','17:25:00',2.97),('15087','2013-07-04','17:30:00',2.65),('15087','2013-07-04','17:35:00',1.93),('15087','2013-07-04','17:40:00',2.4),('15087','2013-07-04','17:45:00',2.38),('15087','2013-07-04','17:50:00',2.21),('15087','2013-07-04','17:55:00',1.9),('15087','2013-07-04','18:00:00',1.99),('15087','2013-07-04','18:05:00',1.83),('15087','2013-07-04','18:10:00',1.76),('15087','2013-07-04','18:15:00',1.74),('15087','2013-07-04','18:20:00',1.59),('15087','2013-07-04','18:25:00',1.3),('15087','2013-07-03','07:30:00',1.02),('15087','2013-07-03','07:35:00',1.1),('15087','2013-07-03','07:40:00',1.19),('15087','2013-07-03','07:45:00',1.28),('15087','2013-07-03','07:50:00',1.37),('15087','2013-07-03','07:55:00',1.45),('15087','2013-07-03','08:00:00',1.55),('15087','2013-07-03','08:05:00',1.65),('15087','2013-07-03','08:10:00',1.74),('15087','2013-07-03','08:15:00',1.83),('15087','2013-07-03','08:20:00',1.91),('15087','2013-07-03','08:25:00',2.03),('15087','2013-07-03','08:30:00',2.15),('15087','2013-07-03','08:35:00',2.23),('15087','2013-07-03','08:40:00',2.36),('15087','2013-07-03','08:45:00',2.46),('15087','2013-07-03','08:50:00',2.55),('15087','2013-07-03','08:55:00',2.62),('15087','2013-07-03','09:00:00',2.67),('15087','2013-07-03','09:05:00',2.74),('15087','2013-07-03','09:10:00',2.82),('15087','2013-07-03','09:15:00',2.92),('15087','2013-07-03','09:20:00',2.95),('15087','2013-07-03','09:25:00',3.02),('15087','2013-07-03','09:30:00',3.12),('15087','2013-07-03','09:35:00',3.12),('15087','2013-07-03','09:40:00',3.22),('15087','2013-07-03','09:45:00',3.25),('15087','2013-07-03','09:50:00',3.3),('15087','2013-07-03','09:55:00',3.37),('15087','2013-07-03','10:00:00',3.46),('15087','2013-07-03','10:05:00',3.52),('15087','2013-07-03','10:10:00',3.6),('15087','2013-07-03','10:15:00',3.61),('15087','2013-07-03','10:20:00',3.65),('15087','2013-07-03','10:25:00',3.63),('15087','2013-07-03','10:30:00',3.71),('15087','2013-07-03','10:35:00',3.85),('15087','2013-07-03','10:40:00',3.88),('15087','2013-07-03','10:45:00',3.94),('15087','2013-07-03','10:50:00',3.92),('15087','2013-07-03','10:55:00',3.97),('15087','2013-07-03','11:00:00',4.08),('15087','2013-07-03','11:05:00',4.16),('15087','2013-07-03','11:10:00',4.22),('15087','2013-07-03','11:15:00',4.28),('15087','2013-07-03','11:20:00',4.25),('15087','2013-07-03','11:25:00',4.24),('15087','2013-07-03','11:30:00',4.27),('15087','2013-07-03','11:35:00',4.28),('15087','2013-07-03','11:40:00',4.46),('15087','2013-07-03','11:45:00',4.44),('15087','2013-07-03','11:50:00',4.38),('15087','2013-07-03','11:55:00',4.48),('15087','2013-07-03','12:00:00',4.49),('15087','2013-07-03','12:05:00',4.5),('15087','2013-07-03','12:10:00',4.52),('15087','2013-07-03','12:15:00',4.55),('15087','2013-07-03','12:20:00',4.61),('15087','2013-07-03','12:25:00',4.58),('15087','2013-07-03','12:30:00',4.67),('15087','2013-07-03','12:35:00',4.66),('15087','2013-07-03','12:40:00',4.68),('15087','2013-07-03','12:45:00',4.72),('15087','2013-07-03','12:50:00',4.74),('15087','2013-07-03','12:55:00',4.75),('15087','2013-07-03','13:00:00',4.74),('15087','2013-07-03','13:05:00',4.76),('15087','2013-07-03','13:10:00',4.75),('15087','2013-07-03','13:15:00',4.78),('15087','2013-07-03','13:20:00',4.74),('15087','2013-07-03','13:25:00',4.73),('15087','2013-07-03','13:30:00',4.7),('15087','2013-07-03','13:35:00',4.72),('15087','2013-07-03','13:40:00',4.73),('15087','2013-07-03','13:45:00',4.7),('15087','2013-07-03','13:50:00',4.69),('15087','2013-07-03','13:55:00',4.66),('15087','2013-07-03','14:00:00',4.65),('15087','2013-07-03','14:05:00',4.68),('15087','2013-07-03','14:10:00',4.55),('15087','2013-07-03','14:15:00',4.62),('15087','2013-07-03','14:20:00',4.59),('15087','2013-07-03','14:25:00',4.58),('15087','2013-07-03','14:30:00',4.57),('15087','2013-07-03','14:35:00',4.55),('15087','2013-07-03','14:40:00',4.51),('15087','2013-07-03','14:45:00',4.47),('15087','2013-07-03','14:50:00',4.42),('15087','2013-07-03','14:55:00',4.38),('15087','2013-07-03','15:00:00',4.38),('15087','2013-07-03','15:05:00',4.31),('15087','2013-07-03','15:10:00',4.21),('15087','2013-07-03','15:15:00',3.94),('15087','2013-07-03','15:20:00',3.85),('15087','2013-07-03','15:25:00',4.09),('15087','2013-07-03','15:30:00',4.05),('15087','2013-07-03','15:35:00',3.86),('15087','2013-07-03','15:40:00',3.83),('15087','2013-07-03','15:45:00',3.83),('15087','2013-07-03','15:50:00',3.74),('15087','2013-07-03','15:55:00',3.68),('15087','2013-07-03','16:00:00',3.64),('15087','2013-07-03','16:05:00',3.63),('15087','2013-07-03','16:10:00',3.5),('15087','2013-07-03','16:15:00',3.55),('15087','2013-07-03','16:20:00',3.46),('15087','2013-07-03','16:25:00',3.39),('15087','2013-07-03','16:30:00',3.38),('15087','2013-07-03','16:35:00',3.23),('15087','2013-07-03','16:40:00',3.18),('15087','2013-07-03','16:45:00',3.07),('15087','2013-07-03','16:50:00',3.1),('15087','2013-07-03','16:55:00',3.08),('15087','2013-07-03','17:00:00',2.97),('15087','2013-07-03','17:05:00',2.91),('15087','2013-07-03','17:10:00',2.79),('15087','2013-07-03','17:15:00',2.73),('15087','2013-07-03','17:20:00',2.68),('15087','2013-07-03','17:25:00',2.61),('15087','2013-07-03','17:30:00',2.55),('15087','2013-07-03','17:35:00',2.38),('15087','2013-07-03','17:40:00',2.27),('15087','2013-07-03','17:45:00',2.11),('15087','2013-07-03','17:50:00',1.97),('15087','2013-07-03','17:55:00',1.86),('15087','2013-07-03','18:00:00',1.77),('15087','2013-07-03','18:05:00',1.62),('15087','2013-07-03','18:10:00',1.54),('15087','2013-07-03','18:15:00',1.42),('15087','2013-07-03','18:20:00',1.36),('15087','2013-07-03','18:25:00',1.26),('15087','2013-07-03','18:30:00',1.17),('15087','2013-07-03','18:35:00',1.08),('15087','2013-07-03','18:40:00',1.01),('15087','2013-07-02','07:35:00',1.08),('15087','2013-07-02','07:40:00',1.16),('15087','2013-07-02','07:45:00',1.25),('15087','2013-07-02','07:50:00',1.33),('15087','2013-07-02','07:55:00',1.42),('15087','2013-07-02','08:00:00',1.52),('15087','2013-07-02','08:05:00',1.61),('15087','2013-07-02','08:10:00',1.7),('15087','2013-07-02','08:15:00',1.79),('15087','2013-07-02','08:20:00',1.9),('15087','2013-07-02','08:25:00',2.02),('15087','2013-07-02','08:30:00',2.16),('15087','2013-07-02','08:35:00',2.24),('15087','2013-07-02','08:40:00',2.32),('15087','2013-07-02','08:45:00',2.4),('15087','2013-07-02','08:50:00',2.47),('15087','2013-07-02','08:55:00',2.57),('15087','2013-07-02','09:00:00',2.64),('15087','2013-07-02','09:05:00',2.72),('15087','2013-07-02','09:10:00',2.79),('15087','2013-07-02','09:15:00',2.83),('15087','2013-07-02','09:20:00',2.9),('15087','2013-07-02','09:25:00',2.99),('15087','2013-07-02','09:30:00',3.06),('15087','2013-07-02','09:35:00',3.12),('15087','2013-07-02','09:40:00',3.17),('15087','2013-07-02','09:45:00',3.25),('15087','2013-07-02','09:50:00',3.32),('15087','2013-07-02','09:55:00',3.37),('15087','2013-07-02','10:00:00',3.44),('15087','2013-07-02','10:05:00',3.46),('15087','2013-07-02','10:10:00',3.53),('15087','2013-07-02','10:15:00',3.57),('15087','2013-07-02','10:20:00',3.65),('15087','2013-07-02','10:25:00',3.69),('15087','2013-07-02','10:30:00',3.71),('15087','2013-07-02','10:35:00',3.71),('15087','2013-07-02','10:40:00',3.79),('15087','2013-07-02','10:45:00',3.85),('15087','2013-07-02','10:50:00',3.91),('15087','2013-07-02','10:55:00',3.96),('15087','2013-07-02','11:00:00',3.98),('15087','2013-07-02','11:05:00',3.96),('15087','2013-07-02','11:10:00',4),('15087','2013-07-02','11:15:00',4),('15087','2013-07-02','11:20:00',4.08),('15087','2013-07-02','11:25:00',4.13),('15087','2013-07-02','11:30:00',4.1),('15087','2013-07-02','11:35:00',4.14),('15087','2013-07-02','11:40:00',4.17),('15087','2013-07-02','11:45:00',4.19),('15087','2013-07-02','11:50:00',4.24),('15087','2013-07-02','11:55:00',4.23),('15087','2013-07-02','12:00:00',4.31),('15087','2013-07-02','12:05:00',4.36),('15087','2013-07-02','12:10:00',4.38),('15087','2013-07-02','12:15:00',4.37),('15087','2013-07-02','12:20:00',4.35),('15087','2013-07-02','12:25:00',4.37),('15087','2013-07-02','12:30:00',4.49),('15087','2013-07-02','12:35:00',4.63),('15087','2013-07-02','12:40:00',4.69),('15087','2013-07-02','12:45:00',4.73),('15087','2013-07-02','12:50:00',4.88),('15087','2013-07-02','12:55:00',4.29),('15087','2013-07-02','13:00:00',1.82),('15087','2013-07-02','13:05:00',5.07),('15087','2013-07-02','13:10:00',4.56),('15087','2013-07-02','13:15:00',3.4),('15087','2013-07-02','13:20:00',4.7),('15087','2013-07-02','13:25:00',4.58),('15087','2013-07-02','13:30:00',4.71),('15087','2013-07-02','13:35:00',4.7),('15087','2013-07-02','13:40:00',4.52),('15087','2013-07-02','13:45:00',4.51),('15087','2013-07-02','13:50:00',4.5),('15087','2013-07-02','13:55:00',4.52),('15087','2013-07-02','14:00:00',4.49),('15087','2013-07-02','14:05:00',4.49),('15087','2013-07-02','14:10:00',4.5),('15087','2013-07-02','14:15:00',4.54),('15087','2013-07-02','14:20:00',4.52),('15087','2013-07-02','14:25:00',4.48),('15087','2013-07-02','14:30:00',4.44),('15087','2013-07-02','14:35:00',4.43),('15087','2013-07-02','14:40:00',4.41),('15087','2013-07-02','14:45:00',4.31),('15087','2013-07-02','14:50:00',4.08),('15087','2013-07-02','14:55:00',4.18),('15087','2013-07-02','15:00:00',4.23),('15087','2013-07-02','15:05:00',4.19),('15087','2013-07-02','15:10:00',4.06),('15087','2013-07-02','15:15:00',3.83),('15087','2013-07-02','15:20:00',3.74),('15087','2013-07-02','15:25:00',3.98),('15087','2013-07-02','15:30:00',3.96),('15087','2013-07-02','15:35:00',3.8),('15087','2013-07-02','15:40:00',3.77),('15087','2013-07-02','15:45:00',3.76),('15087','2013-07-02','15:50:00',3.67),('15087','2013-07-02','15:55:00',3.64),('15087','2013-07-02','16:00:00',3.6),('15087','2013-07-02','16:05:00',3.57),('15087','2013-07-02','16:10:00',3.46),('15087','2013-07-02','16:15:00',3.47),('15087','2013-07-02','16:20:00',3.38),('15087','2013-07-02','16:25:00',3.33),('15087','2013-07-02','16:30:00',3.28),('15087','2013-07-02','16:35:00',3.16),('15087','2013-07-02','16:40:00',3.1),('15087','2013-07-02','16:45:00',2.92),('15087','2013-07-02','16:50:00',2.92),('15087','2013-07-02','16:55:00',3.02),('15087','2013-07-02','17:00:00',2.93),('15087','2013-07-02','17:05:00',2.83),('15087','2013-07-02','17:10:00',2.72),('15087','2013-07-02','17:15:00',2.66),('15087','2013-07-02','17:20:00',2.59),('15087','2013-07-02','17:25:00',2.5),('15087','2013-07-02','17:30:00',2.46),('15087','2013-07-02','17:35:00',2.23),('15087','2013-07-02','17:40:00',2.14),('15087','2013-07-02','17:45:00',2),('15087','2013-07-02','17:50:00',1.79),('15087','2013-07-02','17:55:00',1.74),('15087','2013-07-02','18:00:00',1.61),('15087','2013-07-02','18:05:00',1.44),('15087','2013-07-02','18:10:00',1.36),('15087','2013-07-02','18:15:00',1.39),('15087','2013-07-02','18:20:00',1.3),('15087','2013-07-02','18:25:00',1.19),('15087','2013-07-02','18:30:00',1.1),('15087','2013-07-02','18:35:00',1.03),('15087','2013-07-01','07:30:00',1.02),('15087','2013-07-01','07:35:00',1.11),('15087','2013-07-01','07:40:00',1.19),('15087','2013-07-01','07:45:00',1.27),('15087','2013-07-01','07:50:00',1.35),('15087','2013-07-01','07:55:00',1.45),('15087','2013-07-01','08:00:00',1.57),('15087','2013-07-01','08:05:00',1.66),('15087','2013-07-01','08:10:00',1.74),('15087','2013-07-01','08:15:00',1.86),('15087','2013-07-01','08:20:00',1.96),('15087','2013-07-01','08:25:00',2.06),('15087','2013-07-01','08:30:00',2.2),('15087','2013-07-01','08:35:00',2.29),('15087','2013-07-01','08:40:00',2.39),('15087','2013-07-01','08:45:00',2.48),('15087','2013-07-01','08:50:00',2.54),('15087','2013-07-01','08:55:00',2.63),('15087','2013-07-01','09:00:00',2.71),('15087','2013-07-01','09:05:00',2.79),('15087','2013-07-01','09:10:00',2.86),('15087','2013-07-01','09:15:00',2.94),('15087','2013-07-01','09:20:00',3.02),('15087','2013-07-01','09:25:00',3.1),('15087','2013-07-01','09:30:00',3.19),('15087','2013-07-01','09:35:00',3.25),('15087','2013-07-01','09:40:00',3.3),('15087','2013-07-01','09:45:00',3.36),('15087','2013-07-01','09:50:00',3.42),('15087','2013-07-01','09:55:00',3.46),('15087','2013-07-01','10:00:00',3.5),('15087','2013-07-01','10:05:00',3.55),('15087','2013-07-01','10:10:00',3.62),('15087','2013-07-01','10:15:00',3.69),('15087','2013-07-01','10:20:00',3.74),('15087','2013-07-01','10:25:00',3.78),('15087','2013-07-01','10:30:00',3.85),('15087','2013-07-01','10:35:00',3.93),('15087','2013-07-01','10:40:00',3.97),('15087','2013-07-01','10:45:00',4.03),('15087','2013-07-01','10:50:00',4.07),('15087','2013-07-01','10:55:00',4.14),('15087','2013-07-01','11:00:00',4.21),('15087','2013-07-01','11:05:00',4.2),('15087','2013-07-01','11:10:00',4.23),('15087','2013-07-01','11:15:00',4.3),('15087','2013-07-01','11:20:00',4.38),('15087','2013-07-01','11:25:00',4.43),('15087','2013-07-01','11:30:00',4.43),('15087','2013-07-01','11:35:00',4.4),('15087','2013-07-01','11:40:00',4.48),('15087','2013-07-01','11:45:00',4.54),('15087','2013-07-01','11:50:00',4.57),('15087','2013-07-01','11:55:00',4.53),('15087','2013-07-01','12:00:00',4.51),('15087','2013-07-01','12:05:00',4.51),('15087','2013-07-01','12:10:00',4.52),('15087','2013-07-01','12:15:00',4.56),('15087','2013-07-01','12:20:00',4.61),('15087','2013-07-01','12:25:00',4.57),('15087','2013-07-01','12:30:00',4.6),('15087','2013-07-01','12:35:00',4.66),('15087','2013-07-01','12:40:00',4.61),('15087','2013-07-01','12:45:00',4.6),('15087','2013-07-01','12:50:00',4.63),('15087','2013-07-01','12:55:00',4.66),('15087','2013-07-01','13:00:00',4.68),('15087','2013-07-01','13:05:00',4.68),('15087','2013-07-01','13:10:00',4.7),('15087','2013-07-01','13:15:00',4.67),('15087','2013-07-01','13:20:00',4.71),('15087','2013-07-01','13:25:00',4.71),('15087','2013-07-01','13:30:00',4.71),('15087','2013-07-01','13:35:00',4.7),('15087','2013-07-01','13:40:00',4.7),('15087','2013-07-01','13:45:00',4.64),('15087','2013-07-01','13:50:00',4.64),('15087','2013-07-01','13:55:00',4.64),('15087','2013-07-01','14:00:00',4.64),('15087','2013-07-01','14:05:00',4.66),('15087','2013-07-01','14:10:00',4.66),('15087','2013-07-01','14:15:00',4.61),('15087','2013-07-01','14:20:00',4.58),('15087','2013-07-01','14:25:00',4.53),('15087','2013-07-01','14:30:00',4.5),('15087','2013-07-01','14:35:00',4.5),('15087','2013-07-01','14:40:00',4.4),('15087','2013-07-01','14:45:00',4.35),('15087','2013-07-01','14:50:00',4.15),('15087','2013-07-01','14:55:00',4.1),('15087','2013-07-01','15:00:00',4.17),('15087','2013-07-01','15:05:00',4.12),('15087','2013-07-01','15:10:00',4.09),('15087','2013-07-01','15:15:00',4.04),('15087','2013-07-01','15:20:00',4),('15087','2013-07-01','15:25:00',3.94),('15087','2013-07-01','15:30:00',3.89),('15087','2013-07-01','15:35:00',3.74),('15087','2013-07-01','15:40:00',3.67),('15087','2013-07-01','15:45:00',3.71),('15087','2013-07-01','15:50:00',3.65),('15087','2013-07-01','15:55:00',3.59),('15087','2013-07-01','16:00:00',3.55),('15087','2013-07-01','16:05:00',3.55),('15087','2013-07-01','16:10:00',3.39),('15087','2013-07-01','16:15:00',3.43),('15087','2013-07-01','16:20:00',3.34),('15087','2013-07-01','16:25:00',3.27),('15087','2013-07-01','16:30:00',3.25),('15087','2013-07-01','16:35:00',3.11),('15087','2013-07-01','16:40:00',3.07),('15087','2013-07-01','16:45:00',2.93),('15087','2013-07-01','16:50:00',2.97),('15087','2013-07-01','16:55:00',2.95),('15087','2013-07-01','17:00:00',2.9),('15087','2013-07-01','17:05:00',2.81),('15087','2013-07-01','17:10:00',2.7),('15087','2013-07-01','17:15:00',2.64),('15087','2013-07-01','17:20:00',2.58),('15087','2013-07-01','17:25:00',2.48),('15087','2013-07-01','17:30:00',2.35),('15087','2013-07-01','17:35:00',2.19),('15087','2013-07-01','17:40:00',2.12),('15087','2013-07-01','17:45:00',1.99),('15087','2013-07-01','17:50:00',1.78),('15087','2013-07-01','17:55:00',1.79),('15087','2013-07-01','18:00:00',1.55),('15087','2013-07-01','18:05:00',1.55),('15087','2013-07-01','18:10:00',1.46),('15087','2013-07-01','18:15:00',1.16),('15087','2013-07-01','18:20:00',1.22),('15087','2013-07-01','18:25:00',1.25),('15087','2013-07-01','18:30:00',1.17),('15087','2013-07-01','18:35:00',1.05),('15087','2014-04-05','09:15:00',1.15),('15087','2014-04-05','09:20:00',1.72),('15087','2014-04-05','09:25:00',2.06),('15087','2014-04-05','09:30:00',3.93),('15087','2014-04-05','09:35:00',3.91),('15087','2014-04-05','09:40:00',3.91),('15087','2014-04-05','09:45:00',3.67),('15087','2014-04-05','09:50:00',2.18),('15087','2014-04-05','09:55:00',1.71),('15087','2014-04-05','10:00:00',2.34),('15087','2014-04-05','10:05:00',2.17),('15087','2014-04-05','10:10:00',2.55),('15087','2014-04-05','10:15:00',1.87),('15087','2014-04-05','10:20:00',2.4),('15087','2014-04-05','10:25:00',2.9),('15087','2014-04-05','10:30:00',2.76),('15087','2014-04-05','10:35:00',2.98),('15087','2014-04-05','10:40:00',3.2),('15087','2014-04-05','10:45:00',3.65),('15087','2014-04-05','10:50:00',2.9),('15087','2014-04-05','10:55:00',3.07),('15087','2014-04-05','11:00:00',3.56),('15087','2014-04-05','11:05:00',3.72),('15087','2014-04-05','11:10:00',4.14),('15087','2014-04-05','11:15:00',4.29),('15087','2014-04-05','11:20:00',4.62),('15087','2014-04-05','11:25:00',4.24),('15087','2014-04-05','11:30:00',2.92),('15087','2014-04-05','11:35:00',2.35),('15087','2014-04-05','11:40:00',3.02),('15087','2014-04-05','11:45:00',4.11),('15087','2014-04-05','11:50:00',4.38),('15087','2014-04-05','11:55:00',4.17),('15087','2014-04-05','12:00:00',4.45),('15087','2014-04-05','12:05:00',3.44),('15087','2014-04-05','12:10:00',3.26),('15087','2014-04-05','12:15:00',3.74),('15087','2014-04-05','12:20:00',3.24),('15087','2014-04-05','12:25:00',4.12),('15087','2014-04-05','12:30:00',3.17),('15087','2014-04-05','12:35:00',2.59),('15087','2014-04-05','12:40:00',3.17),('15087','2014-04-05','12:45:00',4.78),('15087','2014-04-05','12:50:00',4.56),('15087','2014-04-05','12:55:00',4.93),('15087','2014-04-05','13:00:00',3.93),('15087','2014-04-05','13:05:00',3.14),('15087','2014-04-05','13:10:00',2.67),('15087','2014-04-05','13:15:00',2.19),('15087','2014-04-05','13:20:00',2.91),('15087','2014-04-05','13:25:00',4.83),('15087','2014-04-05','13:30:00',4.41),('15087','2014-04-05','13:35:00',4.56),('15087','2014-04-05','13:40:00',3.35),('15087','2014-04-05','13:45:00',4.7),('15087','2014-04-05','13:50:00',5.12),('15087','2014-04-05','13:55:00',3.86),('15087','2014-04-05','14:00:00',4.18),('15087','2014-04-05','14:05:00',5.12),('15087','2014-04-05','14:10:00',3.51),('15087','2014-04-05','14:25:00',1.13),('15087','2014-04-05','14:30:00',1.82),('15087','2014-04-05','14:35:00',1.04),('15087','2014-04-05','14:55:00',4.19),('15087','2014-04-05','15:00:00',4.29),('15087','2014-04-05','15:05:00',4.18),('15087','2014-04-05','15:10:00',3.31),('15087','2014-04-05','15:15:00',1.86),('15087','2014-04-05','15:20:00',3.41),('15087','2014-04-05','15:25:00',2.58),('15087','2014-04-05','15:30:00',1.69),('15087','2014-04-05','15:35:00',1.57),('15087','2014-04-05','15:40:00',2.05),('15087','2014-04-05','15:45:00',2.22),('15087','2014-04-05','15:50:00',2.59),('15087','2014-04-05','15:55:00',1.35),('15087','2014-04-05','16:00:00',1.3),('15087','2014-04-05','16:05:00',1.33),('15087','2014-04-05','16:10:00',1.25),('15087','2014-04-05','16:15:00',1.66),('15087','2014-04-05','16:20:00',3.98),('15087','2014-04-05','16:25:00',2.85),('15087','2014-04-05','16:30:00',2.14),('15087','2014-04-05','16:35:00',2.9),('15087','2014-04-05','16:40:00',1.65),('15087','2014-04-05','16:45:00',2.31),('15087','2014-04-05','16:50:00',1.63),('15087','2014-04-05','16:55:00',2.51),('15087','2014-04-05','17:00:00',1.45),('15087','2014-04-05','17:05:00',1.97),('15087','2014-04-05','17:10:00',1.66),('15087','2014-04-05','17:20:00',1.19),('15087','2014-04-05','17:25:00',1.19),('15087','2014-04-05','17:30:00',1.3),('15087','2014-04-05','17:35:00',1.09),('15087','2014-04-05','17:50:00',1.05),('15087','2014-04-05','17:55:00',1.06),('15087','2014-04-05','18:00:00',1.02),('15087','2013-06-30','07:25:00',1.02),('15087','2013-06-30','07:30:00',1.1),('15087','2013-06-30','07:35:00',1.19),('15087','2013-06-30','07:40:00',1.27),('15087','2013-06-30','07:45:00',1.36),('15087','2013-06-30','07:50:00',1.45),('15087','2013-06-30','07:55:00',1.54),('15087','2013-06-30','08:00:00',1.66),('15087','2013-06-30','08:05:00',1.75),('15087','2013-06-30','08:10:00',1.85),('15087','2013-06-30','08:15:00',1.97),('15087','2013-06-30','08:20:00',2.07),('15087','2013-06-30','08:25:00',2.16),('15087','2013-06-30','08:30:00',2.28),('15087','2013-06-30','08:35:00',2.38),('15087','2013-06-30','08:40:00',2.47),('15087','2013-06-30','08:45:00',2.55),('15087','2013-06-30','08:50:00',2.63),('15087','2013-06-30','08:55:00',2.71),('15087','2013-06-30','09:00:00',2.79),('15087','2013-06-30','09:05:00',2.85),('15087','2013-06-30','09:10:00',2.95),('15087','2013-06-30','09:15:00',3.02),('15087','2013-06-30','09:20:00',3.1),('15087','2013-06-30','09:25:00',3.18),('15087','2013-06-30','09:30:00',3.26),('15087','2013-06-30','09:35:00',3.31),('15087','2013-06-30','09:40:00',3.4),('15087','2013-06-30','09:45:00',3.48),('15087','2013-06-30','09:50:00',3.54),('15087','2013-06-30','09:55:00',3.59),('15087','2013-06-30','10:00:00',3.66),('15087','2013-06-30','10:05:00',3.7),('15087','2013-06-30','10:10:00',3.79),('15087','2013-06-30','10:15:00',3.85),('15087','2013-06-30','10:20:00',3.89),('15087','2013-06-30','10:25:00',3.92),('15087','2013-06-30','10:30:00',3.95),('15087','2013-06-30','10:35:00',4.02),('15087','2013-06-30','10:40:00',4.09),('15087','2013-06-30','10:45:00',4.15),('15087','2013-06-30','10:50:00',4.16),('15087','2013-06-30','10:55:00',4.18),('15087','2013-06-30','11:00:00',4.2),('15087','2013-06-30','11:05:00',4.26),('15087','2013-06-30','11:10:00',4.32),('15087','2013-06-30','11:15:00',4.34),('15087','2013-06-30','11:20:00',4.34),('15087','2013-06-30','11:25:00',4.38),('15087','2013-06-30','11:30:00',4.41),('15087','2013-06-30','11:35:00',4.43),('15087','2013-06-30','11:40:00',4.46),('15087','2013-06-30','11:45:00',4.47),('15087','2013-06-30','11:50:00',4.45),('15087','2013-06-30','11:55:00',4.55),('15087','2013-06-30','12:00:00',4.54),('15087','2013-06-30','12:05:00',4.47),('15087','2013-06-30','12:10:00',4.66),('15087','2013-06-30','12:15:00',4.66),('15087','2013-06-30','12:20:00',4.67),('15087','2013-06-30','12:25:00',4.64),('15087','2013-06-30','12:30:00',4.65),('15087','2013-06-30','12:35:00',4.68),('15087','2013-06-30','12:40:00',4.7),('15087','2013-06-30','12:45:00',4.67),('15087','2013-06-30','12:50:00',4.76),('15087','2013-06-30','12:55:00',4.79),('15087','2013-06-30','13:00:00',4.76),('15087','2013-06-30','13:05:00',4.73),('15087','2013-06-30','13:10:00',4.72),('15087','2013-06-30','13:15:00',4.77),('15087','2013-06-30','13:20:00',4.76),('15087','2013-06-30','13:25:00',4.77),('15087','2013-06-30','13:30:00',4.76),('15087','2013-06-30','13:35:00',4.77),('15087','2013-06-30','13:40:00',4.38),('15087','2013-06-30','13:45:00',4.65),('15087','2013-06-30','13:50:00',4.87),('15087','2013-06-30','13:55:00',4.82),('15087','2013-06-30','14:00:00',4.62),('15087','2013-06-30','14:05:00',4.79),('15087','2013-06-30','14:10:00',4.74),('15087','2013-06-30','14:15:00',4.61),('15087','2013-06-30','14:20:00',4.62),('15087','2013-06-30','14:25:00',4.59),('15087','2013-06-30','14:30:00',4.5),('15087','2013-06-30','14:35:00',4.47),('15087','2013-06-30','14:40:00',4.52),('15087','2013-06-30','14:45:00',4.45),('15087','2013-06-30','14:50:00',4.35),('15087','2013-06-30','14:55:00',4.35),('15087','2013-06-30','15:00:00',4.29),('15087','2013-06-30','15:05:00',4.23),('15087','2013-06-30','15:10:00',4.19),('15087','2013-06-30','15:15:00',3.94),('15087','2013-06-30','15:20:00',3.68),('15087','2013-06-30','15:25:00',4.04),('15087','2013-06-30','15:30:00',4.05),('15087','2013-06-30','15:35:00',3.93),('15087','2013-06-30','15:40:00',3.93),('15087','2013-06-30','15:45:00',3.89),('15087','2013-06-30','15:50:00',3.85),('15087','2013-06-30','15:55:00',3.76),('15087','2013-06-30','16:00:00',3.72),('15087','2013-06-30','16:05:00',3.7),('15087','2013-06-30','16:10:00',3.67),('15087','2013-06-30','16:15:00',3.5),('15087','2013-06-30','16:20:00',3.65),('15087','2013-06-30','16:25:00',3.67),('15087','2013-06-30','16:30:00',3.58),('15087','2013-06-30','16:35:00',3.47),('15087','2013-06-30','16:40:00',3.23),('15087','2013-06-30','16:45:00',3.11),('15087','2013-06-30','16:50:00',3.15),('15087','2013-06-30','16:55:00',3.06),('15087','2013-06-30','17:00:00',2.95),('15087','2013-06-30','17:05:00',2.82),('15087','2013-06-30','17:10:00',2.78),('15087','2013-06-30','17:15:00',2.69),('15087','2013-06-30','17:20:00',2.63),('15087','2013-06-30','17:25:00',2.55),('15087','2013-06-30','17:30:00',2.43),('15087','2013-06-30','17:35:00',2.24),('15087','2013-06-30','17:40:00',2.18),('15087','2013-06-30','17:45:00',2.02),('15087','2013-06-30','17:50:00',1.83),('15087','2013-06-30','17:55:00',1.8),('15087','2013-06-30','18:00:00',1.6),('15087','2013-06-30','18:05:00',1.44),('15087','2013-06-30','18:10:00',1.42),('15087','2013-06-30','18:15:00',1.36),('15087','2013-06-30','18:20:00',1.34),('15087','2013-06-30','18:25:00',1.24),('15087','2013-06-30','18:30:00',1.13),('15087','2013-06-30','18:35:00',1.04),('15087','2013-06-29','07:30:00',1.35),('15087','2013-06-29','07:35:00',1.66),('15087','2013-06-29','07:40:00',1.74),('15087','2013-06-29','07:45:00',1.71),('15087','2013-06-29','07:50:00',1.86),('15087','2013-06-29','07:55:00',2.06),('15087','2013-06-29','08:00:00',2.25),('15087','2013-06-29','08:05:00',2.49),('15087','2013-06-29','08:10:00',2.54),('15087','2013-06-29','08:15:00',2.07),('15087','2013-06-29','08:20:00',1.4),('15087','2013-06-29','08:25:00',2.38),('15087','2013-06-29','08:30:00',2.4),('15087','2013-06-29','08:35:00',2.49),('15087','2013-06-29','08:40:00',1.34),('15087','2013-06-29','08:45:00',2.39),('15087','2013-06-29','08:50:00',2.65),('15087','2013-06-29','08:55:00',2.71),('15087','2013-06-29','09:00:00',2.77),('15087','2013-06-29','09:05:00',2.84),('15087','2013-06-29','09:10:00',2.9),('15087','2013-06-29','09:15:00',2.96),('15087','2013-06-29','09:20:00',3.05),('15087','2013-06-29','09:25:00',3.12),('15087','2013-06-29','09:30:00',3.17),('15087','2013-06-29','09:35:00',3.24),('15087','2013-06-29','09:40:00',3.35),('15087','2013-06-29','09:45:00',3.44),('15087','2013-06-29','09:50:00',3.49),('15087','2013-06-29','09:55:00',3.53),('15087','2013-06-29','10:00:00',3.58),('15087','2013-06-29','10:05:00',3.66),('15087','2013-06-29','10:10:00',3.74),('15087','2013-06-29','10:15:00',3.78),('15087','2013-06-29','10:20:00',3.82),('15087','2013-06-29','10:25:00',3.89),('15087','2013-06-29','10:30:00',3.9),('15087','2013-06-29','10:35:00',3.98),('15087','2013-06-29','10:40:00',4.07),('15087','2013-06-29','10:45:00',4.03),('15087','2013-06-29','10:50:00',1.07),('15087','2013-06-29','10:55:00',3.15),('15087','2013-06-29','11:00:00',4.33),('15087','2013-06-29','11:05:00',4.4),('15087','2013-06-29','11:10:00',4.45),('15087','2013-06-29','11:15:00',4.57),('15087','2013-06-29','11:20:00',4.29),('15087','2013-06-29','11:25:00',4.91),('15087','2013-06-29','11:30:00',4.02),('15087','2013-06-29','11:35:00',3.18),('15087','2013-06-29','11:40:00',3.01),('15087','2013-06-29','11:45:00',5.14),('15087','2013-06-29','11:50:00',5.24),('15087','2013-06-29','11:55:00',4.09),('15087','2013-06-29','12:00:00',4.23),('15087','2013-06-29','12:05:00',4.01),('15087','2013-06-29','12:10:00',4.95),('15087','2013-06-29','12:15:00',5.08),('15087','2013-06-29','12:20:00',3.09),('15087','2013-06-29','12:25:00',4.75),('15087','2013-06-29','12:30:00',5.14),('15087','2013-06-29','12:35:00',2.54),('15087','2013-06-29','12:40:00',3.05),('15087','2013-06-29','12:45:00',5.44),('15087','2013-06-29','12:50:00',3.77),('15087','2013-06-29','12:55:00',5.28),('15087','2013-06-29','13:00:00',3.76),('15087','2013-06-29','13:05:00',4.51),('15087','2013-06-29','13:10:00',3.95),('15087','2013-06-29','13:15:00',4.24),('15087','2013-06-29','13:20:00',2.44),('15087','2013-06-29','13:25:00',3.72),('15087','2013-06-29','13:30:00',1.13),('15087','2013-06-29','13:40:00',1.03),('15087','2013-06-29','13:45:00',1.95),('15087','2013-06-29','13:50:00',1.87),('15087','2013-06-29','13:55:00',3.63),('15087','2013-06-29','14:00:00',5.42),('15087','2013-06-29','14:05:00',5.37),('15087','2013-06-29','14:10:00',5.22),('15087','2013-06-29','14:15:00',5.22),('15087','2013-06-29','14:20:00',5.43),('15087','2013-06-29','14:25:00',5.31),('15087','2013-06-29','14:30:00',5.13),('15087','2013-06-29','14:35:00',5.07),('15087','2013-06-29','14:40:00',5.05),('15087','2013-06-29','14:45:00',5.06),('15087','2013-06-29','14:50:00',5.25),('15087','2013-06-29','14:55:00',3.41),('15087','2013-06-29','15:00:00',4.24),('15087','2013-06-29','15:05:00',5.35),('15087','2013-06-29','15:10:00',3.1),('15087','2013-06-29','15:15:00',2.89),('15087','2013-06-29','15:20:00',1.58),('15087','2013-06-29','15:25:00',1.15),('15087','2013-06-29','16:40:00',1.3),('15087','2013-06-29','16:45:00',1.71),('15087','2013-06-29','16:50:00',2.72),('15087','2013-06-29','16:55:00',1.32),('15087','2013-06-29','17:00:00',1.24),('15087','2013-06-29','17:05:00',1.61),('15087','2013-06-29','17:10:00',1.17),('15087','2013-06-29','17:15:00',1.11),('15087','2013-06-29','17:20:00',1.36),('15087','2013-06-29','17:25:00',1.62),('15087','2013-06-29','17:30:00',3.01),('15087','2013-06-29','17:35:00',1.91),('15087','2013-06-29','17:40:00',1.31),('15087','2013-06-29','17:45:00',2.25),('15087','2013-06-29','17:50:00',1.98),('15087','2013-06-29','17:55:00',1.92),('15087','2013-06-29','18:00:00',1.69),('15087','2013-06-29','18:05:00',1.63),('15087','2013-06-29','18:15:00',1.24),('15087','2013-06-29','18:20:00',1.36),('15087','2013-06-29','18:25:00',1.02),('15087','2013-06-29','18:35:00',1.07),('15087','2013-06-29','18:40:00',1.08),('15087','2013-06-28','07:25:00',1.01),('15087','2013-06-28','07:30:00',1.11),('15087','2013-06-28','07:35:00',1.16),('15087','2013-06-28','07:40:00',1.17),('15087','2013-06-28','07:45:00',1.38),('15087','2013-06-28','07:50:00',1.42),('15087','2013-06-28','07:55:00',1.5),('15087','2013-06-28','08:00:00',1.55),('15087','2013-06-28','08:05:00',1.53),('15087','2013-06-28','08:10:00',1.64),('15087','2013-06-28','08:15:00',1.83),('15087','2013-06-28','08:20:00',1.86),('15087','2013-06-28','08:25:00',1.86),('15087','2013-06-28','08:30:00',2.13),('15087','2013-06-28','08:35:00',2.25),('15087','2013-06-28','08:40:00',2.35),('15087','2013-06-28','08:45:00',2.45),('15087','2013-06-28','08:50:00',2.54),('15087','2013-06-28','08:55:00',2.63),('15087','2013-06-28','09:00:00',2.72),('15087','2013-06-28','09:05:00',2.79),('15087','2013-06-28','09:10:00',2.98),('15087','2013-06-28','09:15:00',2.36),('15087','2013-06-28','09:25:00',2.02),('15087','2013-06-28','09:30:00',3.36),('15087','2013-06-28','09:35:00',3.36),('15087','2013-06-28','09:40:00',3.52),('15087','2013-06-28','09:45:00',3.65),('15087','2013-06-28','09:50:00',3.43),('15087','2013-06-28','09:55:00',3.36),('15087','2013-06-28','10:05:00',2.71),('15087','2013-06-28','10:10:00',3.93),('15087','2013-06-28','10:15:00',3.78),('15087','2013-06-28','10:20:00',1.4),('15087','2013-06-28','10:25:00',1.4),('15087','2013-06-28','10:30:00',4.22),('15087','2013-06-28','10:35:00',4.96),('15087','2013-06-28','10:40:00',3.71),('15087','2013-06-28','10:45:00',4.28),('15087','2013-06-28','10:50:00',1.68),('15087','2013-06-28','10:55:00',2.35),('15087','2013-06-28','11:00:00',2.69),('15087','2013-06-28','11:05:00',1.96),('15087','2013-06-28','11:10:00',1.76),('15087','2013-06-28','11:15:00',2.21),('15087','2013-06-28','11:20:00',1.65),('15087','2013-06-28','11:25:00',4.69),('15087','2013-06-28','11:30:00',4.63),('15087','2013-06-28','11:35:00',3.93),('15087','2013-06-28','11:40:00',4.29),('15087','2013-06-28','11:45:00',4.17),('15087','2013-06-28','11:50:00',4.65),('15087','2013-06-28','11:55:00',2.78),('15087','2013-06-28','12:00:00',2.88),('15087','2013-06-28','12:05:00',3.21),('15087','2013-06-28','12:10:00',5.1),('15087','2013-06-28','12:15:00',5.06),('15087','2013-06-28','12:20:00',4.93),('15087','2013-06-28','12:25:00',4.52),('15087','2013-06-28','12:30:00',4.78),('15087','2013-06-28','12:35:00',3.38),('15087','2013-06-28','12:40:00',2.85),('15087','2013-06-28','12:45:00',5.04),('15087','2013-06-28','12:50:00',4.97),('15087','2013-06-28','12:55:00',4.85),('15087','2013-06-28','13:00:00',4.89),('15087','2013-06-28','13:05:00',4.71),('15087','2013-06-28','13:10:00',4.46),('15087','2013-06-28','13:15:00',4.87),('15087','2013-06-28','13:20:00',3.7),('15087','2013-06-28','13:25:00',4.89),('15087','2013-06-28','13:30:00',4.88),('15087','2013-06-28','13:35:00',4.95),('15087','2013-06-28','13:40:00',4.61),('15087','2013-06-28','13:45:00',4.97),('15087','2013-06-28','13:50:00',4.8),('15087','2013-06-28','13:55:00',4.74),('15087','2013-06-28','14:00:00',3.49),('15087','2013-06-28','14:05:00',5.14),('15087','2013-06-28','14:10:00',3.89),('15087','2013-06-28','14:15:00',4.51),('15087','2013-06-28','14:20:00',4.71),('15087','2013-06-28','14:25:00',2.18),('15087','2013-06-28','14:30:00',3.07),('15087','2013-06-28','14:35:00',4.41),('15087','2013-06-28','14:40:00',4.62),('15087','2013-06-28','14:45:00',4.9),('15087','2013-06-28','14:50:00',4.42),('15087','2013-06-28','14:55:00',4.24),('15087','2013-06-28','15:00:00',3.62),('15087','2013-06-28','15:05:00',4.41),('15087','2013-06-28','15:10:00',4.49),('15087','2013-06-28','15:15:00',4.44),('15087','2013-06-28','15:20:00',4.49),('15087','2013-06-28','15:25:00',4.18),('15087','2013-06-28','15:30:00',3.34),('15087','2013-06-28','15:35:00',3.98),('15087','2013-06-28','15:40:00',2.69),('15087','2013-06-28','15:45:00',3.4),('15087','2013-06-28','15:50:00',3.54),('15087','2013-06-28','15:55:00',3.42),('15087','2013-06-28','16:00:00',3.71),('15087','2013-06-28','16:05:00',2.97),('15087','2013-06-28','16:10:00',1.38),('15087','2013-06-28','16:15:00',3.05),('15087','2013-06-28','16:20:00',3.65),('15087','2013-06-28','16:25:00',2.05),('15087','2013-06-28','16:30:00',3.59),('15087','2013-06-28','16:40:00',2.18),('15087','2013-06-28','16:45:00',2.25),('15087','2013-06-28','16:50:00',3.58),('15087','2013-06-28','16:55:00',3.34),('15087','2013-06-28','17:00:00',3.09),('15087','2013-06-28','17:05:00',2.3),('15087','2013-06-28','17:10:00',2.54),('15087','2013-06-28','17:15:00',2.68),('15087','2013-06-28','17:20:00',2.6),('15087','2013-06-28','17:25:00',2.6),('15087','2013-06-28','17:30:00',2.51),('15087','2013-06-28','17:35:00',2.36),('15087','2013-06-28','17:40:00',2.2),('15087','2013-06-28','17:45:00',2.12),('15087','2013-06-28','17:50:00',1.96),('15087','2013-06-28','17:55:00',1.85),('15087','2013-06-28','18:00:00',1.78),('15087','2013-06-28','18:05:00',1.66),('15087','2013-06-28','18:10:00',1.5),('15087','2013-06-28','18:15:00',1.5),('15087','2013-06-28','18:20:00',1.38),('15087','2013-06-28','18:25:00',1.21),('15087','2013-06-27','07:30:00',1.04),('15087','2013-06-27','07:35:00',1.12),('15087','2013-06-27','07:40:00',1.21),('15087','2013-06-27','07:45:00',1.31),('15087','2013-06-27','07:50:00',1.43),('15087','2013-06-27','07:55:00',1.51),('15087','2013-06-27','08:00:00',1.6),('15087','2013-06-27','08:05:00',1.77),('15087','2013-06-27','08:10:00',1.83),('15087','2013-06-27','08:15:00',1.93),('15087','2013-06-27','08:20:00',2.02),('15087','2013-06-27','08:25:00',2.12),('15087','2013-06-27','08:30:00',2.2),('15087','2013-06-27','08:35:00',2.27),('15087','2013-06-27','08:40:00',2.35),('15087','2013-06-27','08:45:00',2.46),('15087','2013-06-27','08:50:00',2.55),('15087','2013-06-27','08:55:00',2.65),('15087','2013-06-27','09:00:00',2.76),('15087','2013-06-27','09:05:00',2.81),('15087','2013-06-27','09:10:00',2.9),('15087','2013-06-27','09:15:00',2.96),('15087','2013-06-27','09:20:00',3.08),('15087','2013-06-27','09:25:00',3.15),('15087','2013-06-27','09:30:00',3.2),('15087','2013-06-27','09:35:00',3.28),('15087','2013-06-27','09:40:00',3.34),('15087','2013-06-27','09:45:00',3.35),('15087','2013-06-27','09:50:00',3.5),('15087','2013-06-27','09:55:00',3.63),('15087','2013-06-27','10:00:00',3.59),('15087','2013-06-27','10:05:00',3.82),('15087','2013-06-27','10:10:00',3.49),('15087','2013-06-27','10:15:00',2.99),('15087','2013-06-27','10:20:00',3.15),('15087','2013-06-27','10:25:00',3.95),('15087','2013-06-27','10:30:00',4.03),('15087','2013-06-27','10:35:00',4.16),('15087','2013-06-27','10:40:00',4.4),('15087','2013-06-27','10:45:00',4.48),('15087','2013-06-27','10:50:00',4.29),('15087','2013-06-27','10:55:00',4.41),('15087','2013-06-27','11:00:00',4.41),('15087','2013-06-27','11:05:00',4.49),('15087','2013-06-27','11:10:00',4.57),('15087','2013-06-27','11:15:00',4.61),('15087','2013-06-27','11:20:00',4.62),('15087','2013-06-27','11:25:00',4.66),('15087','2013-06-27','11:30:00',4.59),('15087','2013-06-27','11:35:00',4.64),('15087','2013-06-27','11:40:00',4.87),('15087','2013-06-27','11:45:00',4.88),('15087','2013-06-27','11:50:00',3.86),('15087','2013-06-27','11:55:00',1.33),('15087','2013-06-27','12:00:00',1.43),('15087','2013-06-27','12:05:00',1.29),('15087','2013-06-27','12:10:00',1.25),('15087','2013-06-27','12:15:00',1.08),('15087','2013-06-27','12:20:00',1.16),('15087','2013-06-27','12:25:00',1.9),('15087','2013-06-27','12:30:00',1.77),('15087','2013-06-27','12:35:00',2.93),('15087','2013-06-27','12:40:00',1.84),('15087','2013-06-27','12:45:00',1.84),('15087','2013-06-27','12:50:00',1.39),('15087','2013-06-27','12:55:00',1.18),('15087','2013-06-27','13:00:00',1),('15087','2013-06-27','13:05:00',1.16),('15087','2013-06-27','13:10:00',1.42),('15087','2013-06-27','13:15:00',1.94),('15087','2013-06-27','13:20:00',1.54),('15087','2013-06-27','13:25:00',1.64),('15087','2013-06-27','13:30:00',1.47),('15087','2013-06-27','13:35:00',1.38),('15087','2013-06-27','13:40:00',1.29),('15087','2013-06-27','13:45:00',1.38),('15087','2013-06-27','13:50:00',1.69),('15087','2013-06-27','13:55:00',1.43),('15087','2013-06-27','14:00:00',1.44),('15087','2013-06-27','14:05:00',1.41),('15087','2013-06-27','14:10:00',2.28),('15087','2013-06-27','14:15:00',3.96),('15087','2013-06-27','14:20:00',3.36),('15087','2013-06-27','14:25:00',2.63),('15087','2013-06-27','14:30:00',3.25),('15087','2013-06-27','14:35:00',1.81),('15087','2013-06-27','14:40:00',4.43),('15087','2013-06-27','14:45:00',2.56),('15087','2013-06-27','14:50:00',2.57),('15087','2013-06-27','14:55:00',4.17),('15087','2013-06-27','15:00:00',4.25),('15087','2013-06-27','15:05:00',4.18),('15087','2013-06-27','15:10:00',4.11),('15087','2013-06-27','15:15:00',3.85),('15087','2013-06-27','15:20:00',3.6),('15087','2013-06-27','15:25:00',3.99),('15087','2013-06-27','15:30:00',3.92),('15087','2013-06-27','15:35:00',3.81),('15087','2013-06-27','15:40:00',3.69),('15087','2013-06-27','15:45:00',3.74),('15087','2013-06-27','15:50:00',3.71),('15087','2013-06-27','15:55:00',3.59),('15087','2013-06-27','16:00:00',3.56),('15087','2013-06-27','16:05:00',3.49),('15087','2013-06-27','16:10:00',3.36),('15087','2013-06-27','16:15:00',3.46),('15087','2013-06-27','16:20:00',3.39),('15087','2013-06-27','16:25:00',3.24),('15087','2013-06-27','16:30:00',3.3),('15087','2013-06-27','16:35:00',2.99),('15087','2013-06-27','16:40:00',3.07),('15087','2013-06-27','16:45:00',3.06),('15087','2013-06-27','16:50:00',3),('15087','2013-06-27','16:55:00',2.94),('15087','2013-06-27','17:00:00',2.87),('15087','2013-06-27','17:05:00',2.73),('15087','2013-06-27','17:10:00',2.58),('15087','2013-06-27','17:15:00',2.5),('15087','2013-06-27','17:20:00',2.62),('15087','2013-06-27','17:25:00',2.54),('15087','2013-06-27','17:30:00',2.46),('15087','2013-06-27','17:35:00',2.3),('15087','2013-06-27','17:40:00',1.66),('15087','2013-06-27','17:45:00',1.09),('15087','2013-06-27','17:50:00',1.83),('15087','2013-06-27','17:55:00',1.78),('15087','2013-06-27','18:00:00',1.68),('15087','2013-06-27','18:05:00',1.49),('15087','2013-06-27','18:10:00',1.35),('15087','2013-06-27','18:15:00',1.33),('15087','2013-06-27','18:20:00',1.28),('15087','2013-06-27','18:25:00',1.24),('15087','2013-06-27','18:30:00',1.18),('15087','2013-06-27','18:35:00',1.07),('15087','2013-06-26','07:30:00',1.07),('15087','2013-06-26','07:35:00',1.17),('15087','2013-06-26','07:40:00',1.26),('15087','2013-06-26','07:45:00',1.35),('15087','2013-06-26','07:50:00',1.45),('15087','2013-06-26','07:55:00',1.52),('15087','2013-06-26','08:00:00',1.59),('15087','2013-06-26','08:05:00',1.69),('15087','2013-06-26','08:10:00',1.8),('15087','2013-06-26','08:15:00',1.9),('15087','2013-06-26','08:20:00',1.92),('15087','2013-06-26','08:25:00',2.04),('15087','2013-06-26','08:30:00',2.17),('15087','2013-06-26','08:35:00',2.23),('15087','2013-06-26','08:40:00',2.32),('15087','2013-06-26','08:45:00',2.46),('15087','2013-06-26','08:50:00',2.5),('15087','2013-06-26','08:55:00',2.6),('15087','2013-06-26','09:00:00',2.68),('15087','2013-06-26','09:05:00',2.77),('15087','2013-06-26','09:10:00',2.83),('15087','2013-06-26','09:15:00',2.89),('15087','2013-06-26','09:20:00',2.95),('15087','2013-06-26','09:25:00',3.04),('15087','2013-06-26','09:30:00',3.11),('15087','2013-06-26','09:35:00',3.16),('15087','2013-06-26','09:40:00',3.22),('15087','2013-06-26','09:45:00',3.31),('15087','2013-06-26','09:50:00',3.36),('15087','2013-06-26','09:55:00',3.41),('15087','2013-06-26','10:00:00',3.48),('15087','2013-06-26','10:05:00',3.55),('15087','2013-06-26','10:10:00',3.64),('15087','2013-06-26','10:15:00',3.74),('15087','2013-06-26','10:20:00',3.77),('15087','2013-06-26','10:25:00',3.81),('15087','2013-06-26','10:30:00',3.83),('15087','2013-06-26','10:35:00',3.87),('15087','2013-06-26','10:40:00',3.95),('15087','2013-06-26','10:45:00',4.01),('15087','2013-06-26','10:50:00',4.08),('15087','2013-06-26','10:55:00',4.14),('15087','2013-06-26','11:00:00',4.15),('15087','2013-06-26','11:05:00',4.09),('15087','2013-06-26','11:10:00',4.2),('15087','2013-06-26','11:15:00',4.24),('15087','2013-06-26','11:20:00',4.31),('15087','2013-06-26','11:25:00',4.3),('15087','2013-06-26','11:30:00',4.31),('15087','2013-06-26','11:35:00',4.32),('15087','2013-06-26','11:40:00',4.35),('15087','2013-06-26','11:45:00',4.38),('15087','2013-06-26','11:50:00',4.44),('15087','2013-06-26','11:55:00',4.51),('15087','2013-06-26','12:00:00',4.56),('15087','2013-06-26','12:05:00',4.57),('15087','2013-06-26','12:10:00',4.54),('15087','2013-06-26','12:15:00',4.58),('15087','2013-06-26','12:20:00',4.53),('15087','2013-06-26','12:25:00',4.48),('15087','2013-06-26','12:30:00',4.22),('15087','2013-06-26','12:35:00',1.54),('15087','2013-06-26','12:40:00',2.84),('15087','2013-06-26','12:45:00',2.41),('15087','2013-06-26','12:55:00',1.02),('15087','2013-06-26','13:00:00',1.1),('15087','2013-06-26','13:05:00',1.13),('15087','2013-06-26','13:10:00',2.34),('15087','2013-06-26','13:15:00',5.04),('15087','2013-06-26','13:20:00',2.92),('15087','2013-06-26','13:25:00',3.2),('15087','2013-06-26','13:30:00',5.32),('15087','2013-06-26','13:35:00',1.52),('15087','2013-06-26','13:40:00',1.11),('15087','2013-06-26','13:45:00',1.33),('15087','2013-06-26','13:50:00',4.23),('15087','2013-06-26','13:55:00',1.49),('15087','2013-06-26','14:00:00',4.63),('15087','2013-06-26','14:05:00',5.06),('15087','2013-06-26','14:10:00',4.15),('15087','2013-06-26','14:15:00',4.48),('15087','2013-06-26','14:20:00',4.78),('15087','2013-06-26','14:25:00',4.63),('15087','2013-06-26','14:30:00',4.68),('15087','2013-06-26','14:35:00',4.2),('15087','2013-06-26','14:40:00',4.17),('15087','2013-06-26','14:45:00',3.05),('15087','2013-06-26','14:50:00',4.59),('15087','2013-06-26','14:55:00',4.54),('15087','2013-06-26','15:00:00',4.29),('15087','2013-06-26','15:05:00',4.23),('15087','2013-06-26','15:10:00',4.13),('15087','2013-06-26','15:15:00',3.85),('15087','2013-06-26','15:20:00',3.64),('15087','2013-06-26','15:25:00',3.96),('15087','2013-06-26','15:30:00',3.88),('15087','2013-06-26','15:35:00',3.77),('15087','2013-06-26','15:40:00',3.82),('15087','2013-06-26','15:45:00',3.76),('15087','2013-06-26','15:50:00',3.78),('15087','2013-06-26','15:55:00',3.67),('15087','2013-06-26','16:00:00',3.64),('15087','2013-06-26','16:05:00',3.6),('15087','2013-06-26','16:10:00',3.53),('15087','2013-06-26','16:15:00',3.5),('15087','2013-06-26','16:20:00',3.44),('15087','2013-06-26','16:25:00',3.4),('15087','2013-06-26','16:30:00',3.31),('15087','2013-06-26','16:35:00',3.14),('15087','2013-06-26','16:40:00',3.1),('15087','2013-06-26','16:45:00',3.01),('15087','2013-06-26','16:50:00',3.02),('15087','2013-06-26','16:55:00',2.99),('15087','2013-06-26','17:00:00',2.92),('15087','2013-06-26','17:05:00',2.8),('15087','2013-06-26','17:10:00',2.73),('15087','2013-06-26','17:15:00',2.64),('15087','2013-06-26','17:20:00',2.59),('15087','2013-06-26','17:25:00',2.51),('15087','2013-06-26','17:30:00',2.37),('15087','2013-06-26','17:35:00',2.25);
INSERT INTO `solarlogmod` VALUES ('15087','2013-06-26','17:40:00',2.16),('15087','2013-06-26','17:45:00',2.01),('15087','2013-06-26','17:50:00',1.83),('15087','2013-06-26','17:55:00',1.77),('15087','2013-06-26','18:00:00',1.68),('15087','2013-06-26','18:05:00',1.56),('15087','2013-06-26','18:10:00',1.85),('15087','2013-06-26','18:15:00',1.34),('15087','2013-06-25','07:30:00',1.05),('15087','2013-06-25','07:35:00',1.18),('15087','2013-06-25','07:40:00',1.29),('15087','2013-06-25','07:45:00',1.41),('15087','2013-06-25','07:50:00',1.06),('15087','2013-06-25','08:00:00',1.49),('15087','2013-06-25','08:05:00',1.67),('15087','2013-06-25','08:20:00',1.24),('15087','2013-06-25','08:25:00',2.08),('15087','2013-06-25','08:30:00',2.28),('15087','2013-06-25','08:35:00',2.33),('15087','2013-06-25','08:40:00',2.42),('15087','2013-06-25','08:45:00',2.51),('15087','2013-06-25','08:50:00',2.57),('15087','2013-06-25','08:55:00',2.67),('15087','2013-06-25','09:00:00',2.76),('15087','2013-06-25','09:05:00',2.81),('15087','2013-06-25','09:10:00',2.89),('15087','2013-06-25','09:15:00',2.99),('15087','2013-06-25','09:20:00',3.05),('15087','2013-06-25','09:25:00',3.12),('15087','2013-06-25','09:30:00',3.25),('15087','2013-06-25','09:35:00',3.44),('15087','2013-06-25','09:40:00',3.54),('15087','2013-06-25','09:45:00',2.62),('15087','2013-06-25','09:50:00',2.4),('15087','2013-06-25','09:55:00',1.8),('15087','2013-06-25','10:00:00',4.13),('15087','2013-06-25','10:05:00',4.16),('15087','2013-06-25','10:10:00',4.28),('15087','2013-06-25','10:15:00',4.29),('15087','2013-06-25','10:20:00',1.8),('15087','2013-06-25','10:25:00',1.01),('15087','2013-06-25','10:30:00',4.31),('15087','2013-06-25','10:35:00',4.42),('15087','2013-06-25','10:40:00',4.39),('15087','2013-06-25','10:45:00',3.47),('15087','2013-06-25','10:50:00',1.59),('15087','2013-06-25','10:55:00',3.43),('15087','2013-06-25','11:00:00',2.17),('15087','2013-06-25','11:05:00',3.18),('15087','2013-06-25','11:10:00',1.85),('15087','2013-06-25','11:15:00',2.09),('15087','2013-06-25','11:20:00',1.06),('15087','2013-06-25','11:25:00',1.1),('15087','2013-06-25','11:30:00',1.12),('15087','2013-06-25','11:35:00',3.77),('15087','2013-06-25','11:40:00',5.4),('15087','2013-06-25','11:45:00',5.06),('15087','2013-06-25','11:50:00',5),('15087','2013-06-25','11:55:00',2.04),('15087','2013-06-25','12:00:00',1.14),('15087','2013-06-25','12:05:00',1.05),('15087','2013-06-25','12:10:00',1.17),('15087','2013-06-25','12:15:00',1.16),('15087','2013-06-25','12:20:00',1.28),('15087','2013-06-25','12:25:00',1.28),('15087','2013-06-25','12:30:00',1.37),('15087','2013-06-25','12:35:00',3.26),('15087','2013-06-25','12:40:00',3.16),('15087','2013-06-25','12:45:00',5.44),('15087','2013-06-25','12:50:00',1.84),('15087','2013-06-25','12:55:00',2.01),('15087','2013-06-25','13:00:00',4.68),('15087','2013-06-25','13:05:00',4.63),('15087','2013-06-25','13:10:00',3.08),('15087','2013-06-25','13:15:00',4.43),('15087','2013-06-25','13:20:00',4.54),('15087','2013-06-25','13:25:00',4.57),('15087','2013-06-25','13:30:00',4.26),('15087','2013-06-25','13:35:00',4.3),('15087','2013-06-25','13:40:00',5.12),('15087','2013-06-25','13:45:00',4.49),('15087','2013-06-25','13:50:00',4.12),('15087','2013-06-25','13:55:00',4.42),('15087','2013-06-25','14:00:00',4.23),('15087','2013-06-25','14:05:00',4.85),('15087','2013-06-25','14:10:00',4.84),('15087','2013-06-25','14:15:00',4.86),('15087','2013-06-25','14:20:00',4.74),('15087','2013-06-25','14:25:00',4.63),('15087','2013-06-25','14:30:00',4.57),('15087','2013-06-25','14:35:00',4.55),('15087','2013-06-25','14:40:00',4.36),('15087','2013-06-25','14:45:00',4.52),('15087','2013-06-25','14:50:00',4.3),('15087','2013-06-25','14:55:00',4.35),('15087','2013-06-25','15:00:00',4.32),('15087','2013-06-25','15:05:00',4.29),('15087','2013-06-25','15:10:00',4.21),('15087','2013-06-25','15:15:00',4.06),('15087','2013-06-25','15:20:00',4.08),('15087','2013-06-25','15:25:00',4.01),('15087','2013-06-25','15:30:00',3.92),('15087','2013-06-25','15:35:00',3.79),('15087','2013-06-25','15:40:00',3.81),('15087','2013-06-25','15:45:00',3.72),('15087','2013-06-25','15:50:00',3.66),('15087','2013-06-25','15:55:00',3.58),('15087','2013-06-25','16:00:00',3.61),('15087','2013-06-25','16:05:00',3.56),('15087','2013-06-25','16:10:00',3.49),('15087','2013-06-25','16:15:00',3.48),('15087','2013-06-25','16:20:00',3.4),('15087','2013-06-25','16:25:00',3.35),('15087','2013-06-25','16:30:00',3.31),('15087','2013-06-25','16:35:00',3.16),('15087','2013-06-25','16:40:00',3.12),('15087','2013-06-25','16:45:00',3.04),('15087','2013-06-25','16:50:00',3.03),('15087','2013-06-25','16:55:00',2.97),('15087','2013-06-25','17:00:00',2.88),('15087','2013-06-25','17:05:00',2.76),('15087','2013-06-25','17:10:00',2.67),('15087','2013-06-25','17:15:00',2.62),('15087','2013-06-25','17:20:00',2.59),('15087','2013-06-25','17:25:00',2.5),('15087','2013-06-25','17:30:00',2.38),('15087','2013-06-25','17:35:00',2.22),('15087','2013-06-25','17:40:00',2.11),('15087','2013-06-25','17:45:00',1.99),('15087','2013-06-25','17:50:00',1.82),('15087','2013-06-25','17:55:00',1.73),('15087','2013-06-25','18:00:00',1.54),('15087','2013-06-25','18:05:00',1.44),('15087','2013-06-25','18:10:00',1.4),('15087','2013-06-25','18:15:00',1.35),('15087','2013-06-25','18:20:00',1.29),('15087','2013-06-25','18:25:00',1.19),('15087','2013-06-25','18:30:00',1.11),('15087','2013-06-25','18:35:00',1.04),('15087','2013-06-24','08:40:00',2.06),('15087','2013-06-24','08:45:00',2.7),('15087','2013-06-24','08:50:00',2.76),('15087','2013-06-24','08:55:00',2.62),('15087','2013-06-24','09:00:00',2.47),('15087','2013-06-24','09:05:00',2.2),('15087','2013-06-24','09:10:00',1.88),('15087','2013-06-24','09:15:00',2.59),('15087','2013-06-24','09:20:00',2.96),('15087','2013-06-24','09:25:00',3.89),('15087','2013-06-24','09:30:00',2.68),('15087','2013-06-24','09:35:00',3.01),('15087','2013-06-24','09:40:00',3.55),('15087','2013-06-24','09:45:00',3.55),('15087','2013-06-24','09:50:00',3.82),('15087','2013-06-24','09:55:00',3.75),('15087','2013-06-24','10:00:00',3.77),('15087','2013-06-24','10:05:00',3.88),('15087','2013-06-24','10:10:00',4.11),('15087','2013-06-24','10:15:00',3.63),('15087','2013-06-24','10:20:00',4.29),('15087','2013-06-24','10:25:00',4.62),('15087','2013-06-24','10:30:00',4.15),('15087','2013-06-24','10:35:00',4.18),('15087','2013-06-24','10:40:00',1.51),('15087','2013-06-24','10:45:00',2.11),('15087','2013-06-24','10:50:00',4.58),('15087','2013-06-24','10:55:00',3.17),('15087','2013-06-24','11:00:00',4.07),('15087','2013-06-24','11:05:00',4.34),('15087','2013-06-24','11:10:00',1.35),('15087','2013-06-24','11:15:00',4.45),('15087','2013-06-24','11:20:00',3.63),('15087','2013-06-24','11:25:00',1.75),('15087','2013-06-24','11:30:00',2.36),('15087','2013-06-24','11:35:00',1.44),('15087','2013-06-24','11:40:00',1.31),('15087','2013-06-24','11:45:00',2.74),('15087','2013-06-24','11:50:00',2),('15087','2013-06-24','11:55:00',4.84),('15087','2013-06-24','12:00:00',2.86),('15087','2013-06-24','12:05:00',3.66),('15087','2013-06-24','12:10:00',4.97),('15087','2013-06-24','12:15:00',2.45),('15087','2013-06-24','12:20:00',5.47),('15087','2013-06-24','12:25:00',4.13),('15087','2013-06-24','12:30:00',3.18),('15087','2013-06-24','12:35:00',5.58),('15087','2013-06-24','12:40:00',3.9),('15087','2013-06-24','12:45:00',4.09),('15087','2013-06-24','12:50:00',4.57),('15087','2013-06-24','12:55:00',5.17),('15087','2013-06-24','13:00:00',4.53),('15087','2013-06-24','13:05:00',5.59),('15087','2013-06-24','13:10:00',3.67),('15087','2013-06-24','13:15:00',3.08),('15087','2013-06-24','13:20:00',2.16),('15087','2013-06-24','13:25:00',4.03),('15087','2013-06-24','13:30:00',4.99),('15087','2013-06-24','13:35:00',3.62),('15087','2013-06-24','13:40:00',4.68),('15087','2013-06-24','13:45:00',5.08),('15087','2013-06-24','13:50:00',4.98),('15087','2013-06-24','13:55:00',4.95),('15087','2013-06-24','14:00:00',4.21),('15087','2013-06-24','14:05:00',4.88),('15087','2013-06-24','14:10:00',4.87),('15087','2013-06-24','14:15:00',4.82),('15087','2013-06-24','14:20:00',4.77),('15087','2013-06-24','14:25:00',4.83),('15087','2013-06-24','14:30:00',4.83),('15087','2013-06-24','14:35:00',4.82),('15087','2013-06-24','14:40:00',4.81),('15087','2013-06-24','14:45:00',4.82),('15087','2013-06-24','14:50:00',4.17),('15087','2013-06-24','14:55:00',3.05),('15087','2013-06-24','15:00:00',4.04),('15087','2013-06-24','15:05:00',2.41),('15087','2013-06-24','15:10:00',3.99),('15087','2013-06-24','15:15:00',4),('15087','2013-06-24','15:20:00',3.52),('15087','2013-06-24','15:25:00',3.21),('15087','2013-06-24','15:30:00',3.58),('15087','2013-06-24','15:35:00',1.9),('15087','2013-06-24','15:40:00',3.05),('15087','2013-06-24','15:45:00',2.98),('15087','2013-06-24','15:50:00',3.5),('15087','2013-06-24','15:55:00',3.81),('15087','2013-06-24','16:00:00',4.23),('15087','2013-06-24','16:05:00',3.93),('15087','2013-06-24','16:10:00',2.71),('15087','2013-06-24','16:15:00',4.02),('15087','2013-06-24','16:20:00',2.5),('15087','2013-06-24','16:25:00',3.04),('15087','2013-06-24','16:30:00',3.85),('15087','2013-06-24','16:35:00',3.11),('15087','2013-06-24','16:40:00',2.43),('15087','2013-06-24','16:45:00',2.15),('15087','2013-06-24','16:50:00',2.13),('15087','2013-06-24','16:55:00',1.32),('15087','2013-06-24','17:00:00',1.48),('15087','2013-06-24','17:05:00',2.69),('15087','2013-06-24','17:10:00',2.88),('15087','2013-06-24','17:15:00',3.07),('15087','2013-06-24','17:20:00',1.99),('15087','2013-06-24','17:25:00',2.66),('15087','2013-06-24','17:30:00',1.7),('15087','2013-06-24','17:50:00',1.6),('15087','2013-06-24','17:55:00',1.34),('15087','2013-06-24','18:00:00',2.09),('15087','2013-06-24','18:05:00',1.62),('15087','2013-06-24','18:10:00',1.47),('15087','2013-06-24','18:15:00',1.57),('15087','2013-06-24','18:20:00',1.42),('15087','2013-06-24','18:25:00',1.39),('15087','2013-06-24','18:30:00',1.04),('15087','2013-06-24','18:35:00',1.19),('15087','2013-06-24','18:45:00',1.07),('15087','2013-06-23','08:45:00',1.08),('15087','2013-06-23','08:50:00',1.58),('15087','2013-06-23','08:55:00',1.13),('15087','2013-06-23','09:00:00',2.03),('15087','2013-06-23','09:05:00',1.42),('15087','2013-06-23','09:20:00',1.9),('15087','2013-06-23','09:25:00',3.01),('15087','2013-06-23','09:30:00',3.21),('15087','2013-06-23','09:35:00',3.32),('15087','2013-06-23','09:40:00',3.88),('15087','2013-06-23','09:45:00',2.11),('15087','2013-06-23','09:50:00',1.13),('15087','2013-06-23','09:55:00',1.91),('15087','2013-06-23','10:00:00',3.68),('15087','2013-06-23','10:05:00',3.21),('15087','2013-06-23','10:10:00',1.62),('15087','2013-06-23','10:15:00',3.46),('15087','2013-06-23','10:20:00',1.35),('15087','2013-06-23','10:25:00',2.34),('15087','2013-06-23','10:30:00',2.92),('15087','2013-06-23','10:35:00',1.76),('15087','2013-06-23','10:40:00',3.88),('15087','2013-06-23','10:45:00',3.97),('15087','2013-06-23','10:50:00',3.99),('15087','2013-06-23','10:55:00',4.01),('15087','2013-06-23','11:00:00',4.07),('15087','2013-06-23','11:05:00',4.14),('15087','2013-06-23','11:10:00',4.17),('15087','2013-06-23','11:15:00',3.19),('15087','2013-06-23','11:20:00',4.25),('15087','2013-06-23','11:25:00',4.32),('15087','2013-06-23','11:30:00',4.18),('15087','2013-06-23','11:35:00',4.25),('15087','2013-06-23','11:40:00',4.27),('15087','2013-06-23','11:45:00',4.4),('15087','2013-06-23','11:50:00',4.28),('15087','2013-06-23','11:55:00',4.4),('15087','2013-06-23','12:00:00',4.55),('15087','2013-06-23','12:05:00',4.58),('15087','2013-06-23','12:10:00',4.61),('15087','2013-06-23','12:15:00',4.59),('15087','2013-06-23','12:20:00',4.59),('15087','2013-06-23','12:25:00',4.68),('15087','2013-06-23','12:30:00',4.65),('15087','2013-06-23','12:35:00',4.66),('15087','2013-06-23','12:40:00',4.68),('15087','2013-06-23','12:45:00',4.68),('15087','2013-06-23','12:50:00',4.69),('15087','2013-06-23','12:55:00',4.68),('15087','2013-06-23','13:00:00',4.68),('15087','2013-06-23','13:05:00',4.69),('15087','2013-06-23','13:10:00',4.7),('15087','2013-06-23','13:15:00',4.68),('15087','2013-06-23','13:20:00',4.67),('15087','2013-06-23','13:25:00',4.69),('15087','2013-06-23','13:30:00',4.71),('15087','2013-06-23','13:35:00',4.74),('15087','2013-06-23','13:40:00',4.7),('15087','2013-06-23','13:45:00',4.7),('15087','2013-06-23','13:50:00',4.7),('15087','2013-06-23','13:55:00',4.68),('15087','2013-06-23','14:00:00',4.65),('15087','2013-06-23','14:05:00',4.62),('15087','2013-06-23','14:10:00',4.56),('15087','2013-06-23','14:15:00',4.53),('15087','2013-06-23','14:20:00',4.59),('15087','2013-06-23','14:25:00',4.59),('15087','2013-06-23','14:30:00',4.54),('15087','2013-06-23','14:35:00',4.53),('15087','2013-06-23','14:40:00',4.52),('15087','2013-06-23','14:45:00',4.43),('15087','2013-06-23','14:50:00',4.19),('15087','2013-06-23','14:55:00',4.24),('15087','2013-06-23','15:00:00',4.34),('15087','2013-06-23','15:05:00',4.26),('15087','2013-06-23','15:10:00',4.17),('15087','2013-06-23','15:15:00',4.05),('15087','2013-06-23','15:20:00',4.11),('15087','2013-06-23','15:25:00',4.02),('15087','2013-06-23','15:30:00',3.91),('15087','2013-06-23','15:35:00',3.86),('15087','2013-06-23','15:40:00',3.79),('15087','2013-06-23','15:45:00',3.76),('15087','2013-06-23','15:50:00',3.74),('15087','2013-06-23','15:55:00',3.67),('15087','2013-06-23','16:00:00',3.63),('15087','2013-06-23','16:05:00',3.55),('15087','2013-06-23','16:10:00',3.42),('15087','2013-06-23','16:15:00',3.46),('15087','2013-06-23','16:20:00',3.36),('15087','2013-06-23','16:25:00',3.24),('15087','2013-06-23','16:30:00',3.24),('15087','2013-06-23','16:35:00',3.17),('15087','2013-06-23','16:40:00',3.13),('15087','2013-06-23','16:45:00',3.08),('15087','2013-06-23','16:50:00',3.06),('15087','2013-06-23','16:55:00',2.98),('15087','2013-06-23','17:00:00',2.87),('15087','2013-06-23','17:05:00',2.74),('15087','2013-06-23','17:10:00',2.72),('15087','2013-06-23','17:15:00',2.66),('15087','2013-06-23','17:20:00',2.41),('15087','2013-06-23','17:25:00',2.52),('15087','2013-06-23','17:30:00',2.39),('15087','2013-06-23','17:35:00',2.24),('15087','2013-06-23','17:40:00',2.16),('15087','2013-06-23','17:45:00',2.03),('15087','2013-06-23','17:50:00',1.92),('15087','2013-06-23','17:55:00',1.75),('15087','2013-06-23','18:00:00',1.7),('15087','2013-06-23','18:05:00',1.6),('15087','2013-06-23','18:10:00',1.4),('15087','2013-06-23','18:15:00',1.28),('15087','2013-06-23','18:20:00',1.31),('15087','2013-06-23','18:25:00',1.18),('15087','2013-06-23','18:30:00',1.13),('15087','2013-06-23','18:35:00',1.03),('15087','2013-06-22','07:35:00',1.07),('15087','2013-06-22','07:40:00',1.14),('15087','2013-06-22','07:45:00',1.23),('15087','2013-06-22','07:50:00',1.32),('15087','2013-06-22','07:55:00',1.39),('15087','2013-06-22','08:00:00',1.47),('15087','2013-06-22','08:05:00',1.55),('15087','2013-06-22','08:10:00',1.62),('15087','2013-06-22','08:15:00',1.71),('15087','2013-06-22','08:20:00',1.82),('15087','2013-06-22','08:25:00',1.91),('15087','2013-06-22','08:30:00',2),('15087','2013-06-22','08:35:00',2.1),('15087','2013-06-22','08:40:00',2.18),('15087','2013-06-22','08:45:00',2.26),('15087','2013-06-22','08:50:00',2.44),('15087','2013-06-22','08:55:00',2.53),('15087','2013-06-22','09:00:00',2.58),('15087','2013-06-22','09:05:00',2.65),('15087','2013-06-22','09:10:00',2.73),('15087','2013-06-22','09:15:00',2.8),('15087','2013-06-22','09:20:00',2.86),('15087','2013-06-22','09:25:00',2.92),('15087','2013-06-22','09:30:00',3),('15087','2013-06-22','09:35:00',3.07),('15087','2013-06-22','09:40:00',3.13),('15087','2013-06-22','09:45:00',3.17),('15087','2013-06-22','09:50:00',3.27),('15087','2013-06-22','09:55:00',3.36),('15087','2013-06-22','10:00:00',3.4),('15087','2013-06-22','10:05:00',3.49),('15087','2013-06-22','10:10:00',3.53),('15087','2013-06-22','10:15:00',3.61),('15087','2013-06-22','10:20:00',3.69),('15087','2013-06-22','10:25:00',3.71),('15087','2013-06-22','10:30:00',3.7),('15087','2013-06-22','10:35:00',3.78),('15087','2013-06-22','10:40:00',3.86),('15087','2013-06-22','10:45:00',3.92),('15087','2013-06-22','10:50:00',3.98),('15087','2013-06-22','10:55:00',4),('15087','2013-06-22','11:00:00',4.05),('15087','2013-06-22','11:05:00',4.1),('15087','2013-06-22','11:10:00',4.15),('15087','2013-06-22','11:15:00',4.16),('15087','2013-06-22','11:20:00',4.21),('15087','2013-06-22','11:25:00',4.24),('15087','2013-06-22','11:30:00',4.31),('15087','2013-06-22','11:35:00',4.35),('15087','2013-06-22','11:40:00',4.35),('15087','2013-06-22','11:45:00',4.37),('15087','2013-06-22','11:50:00',4.34),('15087','2013-06-22','11:55:00',4.37),('15087','2013-06-22','12:00:00',4.42),('15087','2013-06-22','12:05:00',4.35),('15087','2013-06-22','12:10:00',4.29),('15087','2013-06-22','12:15:00',4.47),('15087','2013-06-22','12:20:00',4.41),('15087','2013-06-22','12:25:00',4.47),('15087','2013-06-22','12:30:00',4.49),('15087','2013-06-22','12:35:00',4.51),('15087','2013-06-22','12:40:00',4.55),('15087','2013-06-22','12:45:00',4.49),('15087','2013-06-22','12:50:00',4.42),('15087','2013-06-22','12:55:00',4.4),('15087','2013-06-22','13:00:00',4.35),('15087','2013-06-22','13:05:00',4.39),('15087','2013-06-22','13:10:00',4.4),('15087','2013-06-22','13:15:00',4.31),('15087','2013-06-22','13:20:00',4.23),('15087','2013-06-22','13:25:00',4.55),('15087','2013-06-22','13:30:00',4.74),('15087','2013-06-22','13:35:00',4.77),('15087','2013-06-22','13:40:00',4.22),('15087','2013-06-22','13:45:00',4.58),('15087','2013-06-22','13:50:00',4.62),('15087','2013-06-22','13:55:00',3.22),('15087','2013-06-22','14:00:00',3.04),('15087','2013-06-22','14:05:00',5.03),('15087','2013-06-22','14:10:00',4.82),('15087','2013-06-22','14:15:00',4.75),('15087','2013-06-22','14:20:00',3.96),('15087','2013-06-22','14:25:00',4.62),('15087','2013-06-22','14:30:00',3.29),('15087','2013-06-22','14:35:00',2.5),('15087','2013-06-22','14:40:00',1.78),('15087','2013-06-22','14:45:00',2.46),('15087','2013-06-22','14:50:00',3.94),('15087','2013-06-22','14:55:00',4.33),('15087','2013-06-22','15:00:00',4.27),('15087','2013-06-22','15:05:00',3.3),('15087','2013-06-22','15:10:00',4.27),('15087','2013-06-22','15:15:00',4.16),('15087','2013-06-22','15:20:00',3.77),('15087','2013-06-22','15:25:00',3.54),('15087','2013-06-22','15:30:00',2.57),('15087','2013-06-22','15:35:00',1.93),('15087','2013-06-22','15:40:00',2.41),('15087','2013-06-22','15:45:00',3.05),('15087','2013-06-22','15:50:00',2.73),('15087','2013-06-22','15:55:00',2.74),('15087','2013-06-22','16:00:00',1.93),('15087','2013-06-22','16:05:00',1.28),('15087','2013-06-22','16:10:00',1.32),('15087','2013-06-22','16:15:00',1.68),('15087','2013-06-22','16:20:00',1.9),('15087','2013-06-22','16:25:00',1.33),('15087','2013-06-22','16:30:00',1.07),('15087','2013-06-22','16:55:00',1.3),('15087','2013-06-22','17:00:00',1.6),('15087','2013-06-22','17:05:00',1.53),('15087','2013-06-22','17:10:00',2.25),('15087','2013-06-22','17:15:00',3.21),('15087','2013-06-22','17:20:00',3.02),('15087','2013-06-22','17:25:00',3.03),('15087','2013-06-22','17:30:00',2.39),('15087','2013-06-22','17:35:00',1.96),('15087','2013-06-22','17:40:00',2.29),('15087','2013-06-22','17:45:00',2.19),('15087','2013-06-22','17:50:00',1.93),('15087','2013-06-22','17:55:00',1.89),('15087','2013-06-22','18:00:00',1.66),('15087','2013-06-22','18:05:00',1.34),('15087','2013-06-21','07:35:00',1.06),('15087','2013-06-21','07:40:00',1.14),('15087','2013-06-21','07:45:00',1.23),('15087','2013-06-21','07:50:00',1.31),('15087','2013-06-21','07:55:00',1.4),('15087','2013-06-21','08:00:00',1.48),('15087','2013-06-21','08:05:00',1.57),('15087','2013-06-21','08:10:00',1.65),('15087','2013-06-21','08:15:00',1.72),('15087','2013-06-21','08:20:00',1.79),('15087','2013-06-21','08:25:00',1.88),('15087','2013-06-21','08:30:00',1.98),('15087','2013-06-21','08:35:00',2.06),('15087','2013-06-21','08:40:00',2.14),('15087','2013-06-21','08:45:00',2.28),('15087','2013-06-21','08:50:00',2.36),('15087','2013-06-21','08:55:00',2.42),('15087','2013-06-21','09:00:00',2.52),('15087','2013-06-21','09:05:00',2.56),('15087','2013-06-21','09:10:00',2.6),('15087','2013-06-21','09:15:00',2.66),('15087','2013-06-21','09:20:00',2.68),('15087','2013-06-21','09:25:00',2.82),('15087','2013-06-21','09:30:00',2.89),('15087','2013-06-21','09:35:00',2.91),('15087','2013-06-21','09:40:00',2.97),('15087','2013-06-21','09:45:00',3.06),('15087','2013-06-21','09:50:00',3.11),('15087','2013-06-21','09:55:00',3.16),('15087','2013-06-21','10:00:00',3.21),('15087','2013-06-21','10:05:00',3.26),('15087','2013-06-21','10:10:00',3.32),('15087','2013-06-21','10:15:00',3.39),('15087','2013-06-21','10:20:00',3.4),('15087','2013-06-21','10:25:00',3.45),('15087','2013-06-21','10:30:00',3.49),('15087','2013-06-21','10:35:00',3.54),('15087','2013-06-21','10:40:00',3.59),('15087','2013-06-21','10:45:00',3.67),('15087','2013-06-21','10:50:00',3.67),('15087','2013-06-21','10:55:00',3.66),('15087','2013-06-21','11:00:00',3.72),('15087','2013-06-21','11:05:00',3.76),('15087','2013-06-21','11:10:00',3.8),('15087','2013-06-21','11:15:00',3.87),('15087','2013-06-21','11:20:00',3.93),('15087','2013-06-21','11:25:00',3.99),('15087','2013-06-21','11:30:00',4.03),('15087','2013-06-21','11:35:00',4.01),('15087','2013-06-21','11:40:00',4.03),('15087','2013-06-21','11:45:00',4.06),('15087','2013-06-21','11:50:00',4.1),('15087','2013-06-21','11:55:00',4.15),('15087','2013-06-21','12:00:00',4.14),('15087','2013-06-21','12:05:00',4.15),('15087','2013-06-21','12:10:00',4.2),('15087','2013-06-21','12:15:00',4.17),('15087','2013-06-21','12:20:00',4.19),('15087','2013-06-21','12:25:00',4.15),('15087','2013-06-21','12:30:00',4.16),('15087','2013-06-21','12:35:00',4.15),('15087','2013-06-21','12:40:00',4.21),('15087','2013-06-21','12:45:00',4.25),('15087','2013-06-21','12:50:00',4.21),('15087','2013-06-21','12:55:00',4.19),('15087','2013-06-21','13:00:00',4.19),('15087','2013-06-21','13:05:00',4.18),('15087','2013-06-21','13:10:00',4.17),('15087','2013-06-21','13:15:00',4.22),('15087','2013-06-21','13:20:00',4.28),('15087','2013-06-21','13:25:00',4.32),('15087','2013-06-21','13:30:00',4.37),('15087','2013-06-21','13:35:00',4.3),('15087','2013-06-21','13:40:00',4.3),('15087','2013-06-21','13:45:00',4.32),('15087','2013-06-21','13:50:00',4.27),('15087','2013-06-21','13:55:00',4.3),('15087','2013-06-21','14:00:00',4.35),('15087','2013-06-21','14:05:00',4.34),('15087','2013-06-21','14:10:00',4.33),('15087','2013-06-21','14:15:00',4.31),('15087','2013-06-21','14:20:00',4.3),('15087','2013-06-21','14:25:00',4.38),('15087','2013-06-21','14:30:00',4.34),('15087','2013-06-21','14:35:00',4.3),('15087','2013-06-21','14:40:00',4.29),('15087','2013-06-21','14:45:00',4.21),('15087','2013-06-21','14:50:00',4.09),('15087','2013-06-21','14:55:00',4.12),('15087','2013-06-21','15:00:00',4.1),('15087','2013-06-21','15:05:00',4.03),('15087','2013-06-21','15:10:00',3.96),('15087','2013-06-21','15:15:00',3.69),('15087','2013-06-21','15:20:00',3.6),('15087','2013-06-21','15:25:00',3.85),('15087','2013-06-21','15:30:00',3.77),('15087','2013-06-21','15:35:00',3.7),('15087','2013-06-21','15:40:00',3.69),('15087','2013-06-21','15:45:00',3.64),('15087','2013-06-21','15:50:00',3.56),('15087','2013-06-21','15:55:00',3.54),('15087','2013-06-21','16:00:00',3.52),('15087','2013-06-21','16:05:00',3.46),('15087','2013-06-21','16:10:00',3.4),('15087','2013-06-21','16:15:00',3.38),('15087','2013-06-21','16:20:00',3.32),('15087','2013-06-21','16:25:00',3.29),('15087','2013-06-21','16:30:00',3.22),('15087','2013-06-21','16:35:00',3.07),('15087','2013-06-21','16:40:00',3.02),('15087','2013-06-21','16:45:00',2.98),('15087','2013-06-21','16:50:00',2.98),('15087','2013-06-21','16:55:00',2.91),('15087','2013-06-21','17:00:00',2.81),('15087','2013-06-21','17:05:00',2.7),('15087','2013-06-21','17:10:00',2.61),('15087','2013-06-21','17:15:00',2.53),('15087','2013-06-21','17:20:00',2.43),('15087','2013-06-21','17:25:00',2.34),('15087','2013-06-21','17:30:00',2.2),('15087','2013-06-21','17:35:00',2.06),('15087','2013-06-21','17:40:00',2.01),('15087','2013-06-21','17:45:00',1.88),('15087','2013-06-21','17:50:00',1.74),('15087','2013-06-21','17:55:00',1.66),('15087','2013-06-21','18:00:00',1.58),('15087','2013-06-21','18:05:00',1.41),('15087','2013-06-21','18:10:00',1.38),('15087','2013-06-21','18:15:00',1.3),('15087','2013-06-21','18:20:00',1.22),('15087','2013-06-21','18:25:00',1.11),('15087','2013-06-21','18:30:00',1.06),('15087','2014-04-04','09:00:00',1.01),('15087','2014-04-04','09:05:00',1.69),('15087','2014-04-04','09:10:00',2.19),('15087','2014-04-04','09:15:00',2.12),('15087','2014-04-04','09:20:00',1.35),('15087','2014-04-04','13:10:00',1.27),('15087','2014-04-04','13:20:00',2.03),('15087','2014-04-04','13:25:00',2.4),('15087','2014-04-04','13:30:00',2.35),('15087','2014-04-04','13:35:00',2.86),('15087','2014-04-04','13:40:00',5.03),('15087','2014-04-04','13:45:00',3.57),('15087','2014-04-04','13:50:00',4.5),('15087','2014-04-04','13:55:00',2.16),('15087','2014-04-04','14:00:00',3.48),('15087','2014-04-04','14:05:00',4.92),('15087','2014-04-04','14:10:00',4.78),('15087','2014-04-04','14:15:00',3.36),('15087','2014-04-04','14:20:00',3.44),('15087','2014-04-04','14:25:00',3.46),('15087','2014-04-04','14:30:00',1.33),('15087','2014-04-04','14:35:00',2.37),('15087','2014-04-04','14:40:00',1.43),('15087','2014-04-04','14:45:00',1.52),('15087','2014-04-04','14:50:00',3.05),('15087','2014-04-04','14:55:00',3.97),('15087','2014-04-04','15:00:00',4.05),('15087','2014-04-04','15:05:00',3.72),('15087','2014-04-04','15:10:00',3.51),('15087','2014-04-04','15:15:00',3.24),('15087','2014-04-04','15:20:00',2.16),('15087','2014-04-04','15:25:00',2.05),('15087','2014-04-04','15:30:00',1.54),('15087','2014-04-04','15:35:00',1.46),('15087','2014-04-04','15:40:00',2.4),('15087','2014-04-04','15:45:00',1.88),('15087','2014-04-04','15:50:00',1.71),('15087','2014-04-04','15:55:00',3.25),('15087','2014-04-04','16:00:00',3.09),('15087','2014-04-04','16:05:00',2.73),('15087','2014-04-04','16:10:00',3.5),('15087','2014-04-04','16:15:00',1.74),('15087','2014-04-04','16:20:00',1.2),('15087','2014-04-04','16:25:00',1.1),('15087','2014-04-04','16:30:00',2.21),('15087','2014-04-04','16:35:00',1.7),('15087','2014-04-04','16:40:00',1.44),('15087','2014-04-04','16:45:00',2.56),('15087','2014-04-04','16:50:00',2.49),('15087','2014-04-04','16:55:00',2.44),('15087','2014-04-04','17:00:00',2.12),('15087','2014-04-04','17:05:00',1.89),('15087','2014-04-04','17:10:00',1.7),('15087','2014-04-04','17:15:00',1.64),('15087','2014-04-04','17:20:00',1.98),('15087','2014-04-04','17:25:00',1.62),('15087','2014-04-04','17:30:00',2.13),('15087','2014-04-04','17:35:00',1.62),('15087','2014-04-04','17:40:00',1.24),('15087','2014-04-04','17:45:00',1.4),('15087','2014-04-04','17:50:00',1.31),('15087','2014-04-04','17:55:00',1.09),('15087','2013-06-20','07:35:00',1.03),('15087','2013-06-20','07:40:00',1.08),('15087','2013-06-20','07:45:00',1.18),('15087','2013-06-20','07:50:00',1.26),('15087','2013-06-20','07:55:00',1.34),('15087','2013-06-20','08:00:00',1.44),('15087','2013-06-20','08:05:00',1.54),('15087','2013-06-20','08:10:00',1.63),('15087','2013-06-20','08:15:00',1.72),('15087','2013-06-20','08:20:00',1.8),('15087','2013-06-20','08:25:00',1.89),('15087','2013-06-20','08:30:00',2.01),('15087','2013-06-20','08:35:00',2.07),('15087','2013-06-20','08:40:00',2.17),('15087','2013-06-20','08:45:00',2.26),('15087','2013-06-20','08:50:00',2.41),('15087','2013-06-20','08:55:00',2.49),('15087','2013-06-20','09:00:00',2.55),('15087','2013-06-20','09:05:00',2.63),('15087','2013-06-20','09:10:00',2.7),('15087','2013-06-20','09:15:00',2.76),('15087','2013-06-20','09:20:00',2.82),('15087','2013-06-20','09:25:00',2.89),('15087','2013-06-20','09:30:00',2.94),('15087','2013-06-20','09:35:00',3.03),('15087','2013-06-20','09:40:00',3.08),('15087','2013-06-20','09:45:00',3.13),('15087','2013-06-20','09:50:00',3.2),('15087','2013-06-20','09:55:00',3.28),('15087','2013-06-20','10:00:00',3.35),('15087','2013-06-20','10:05:00',3.4),('15087','2013-06-20','10:10:00',3.48),('15087','2013-06-20','10:15:00',3.49),('15087','2013-06-20','10:20:00',3.55),('15087','2013-06-20','10:25:00',3.62),('15087','2013-06-20','10:30:00',3.66),('15087','2013-06-20','10:35:00',3.74),('15087','2013-06-20','10:40:00',3.75),('15087','2013-06-20','10:45:00',3.76),('15087','2013-06-20','10:50:00',3.76),('15087','2013-06-20','10:55:00',3.84),('15087','2013-06-20','11:00:00',3.89),('15087','2013-06-20','11:05:00',3.92),('15087','2013-06-20','11:10:00',3.95),('15087','2013-06-20','11:15:00',3.94),('15087','2013-06-20','11:20:00',3.91),('15087','2013-06-20','11:25:00',3.92),('15087','2013-06-20','11:30:00',3.97),('15087','2013-06-20','11:35:00',4.09),('15087','2013-06-20','11:40:00',4.16),('15087','2013-06-20','11:45:00',4.13),('15087','2013-06-20','11:50:00',3.93),('15087','2013-06-20','11:55:00',4.04),('15087','2013-06-20','12:00:00',3.94),('15087','2013-06-20','12:05:00',4.05),('15087','2013-06-20','12:10:00',3.6),('15087','2013-06-20','12:15:00',3.95),('15087','2013-06-20','12:20:00',3.26),('15087','2013-06-20','12:25:00',4.2),('15087','2013-06-20','12:30:00',4.34),('15087','2013-06-20','12:35:00',4.33),('15087','2013-06-20','12:40:00',4.21),('15087','2013-06-20','12:45:00',3.87),('15087','2013-06-20','12:50:00',4.15),('15087','2013-06-20','12:55:00',4.35),('15087','2013-06-20','13:00:00',4.48),('15087','2013-06-20','13:05:00',4.45),('15087','2013-06-20','13:10:00',4.26),('15087','2013-06-20','13:15:00',2.03),('15087','2013-06-20','13:20:00',4.34),('15087','2013-06-20','13:25:00',4.31),('15087','2013-06-20','13:30:00',4.15),('15087','2013-06-20','13:35:00',4.42),('15087','2013-06-20','13:40:00',4.41),('15087','2013-06-20','13:45:00',4.45),('15087','2013-06-20','13:50:00',4.46),('15087','2013-06-20','13:55:00',4.42),('15087','2013-06-20','14:00:00',4.48),('15087','2013-06-20','14:05:00',4.46),('15087','2013-06-20','14:10:00',4.45),('15087','2013-06-20','14:15:00',4.48),('15087','2013-06-20','14:20:00',4.51),('15087','2013-06-20','14:25:00',4.46),('15087','2013-06-20','14:30:00',4.48),('15087','2013-06-20','14:35:00',4.44),('15087','2013-06-20','14:40:00',4.43),('15087','2013-06-20','14:45:00',4.34),('15087','2013-06-20','14:50:00',4.25),('15087','2013-06-20','14:55:00',4.25),('15087','2013-06-20','15:00:00',4.21),('15087','2013-06-20','15:05:00',4.11),('15087','2013-06-20','15:10:00',4.04),('15087','2013-06-20','15:15:00',4.03),('15087','2013-06-20','15:20:00',3.99),('15087','2013-06-20','15:25:00',3.94),('15087','2013-06-20','15:30:00',3.83),('15087','2013-06-20','15:35:00',3.77),('15087','2013-06-20','15:40:00',3.77),('15087','2013-06-20','15:45:00',3.7),('15087','2013-06-20','15:50:00',3.65),('15087','2013-06-20','15:55:00',3.59),('15087','2013-06-20','16:00:00',3.58),('15087','2013-06-20','16:05:00',3.54),('15087','2013-06-20','16:10:00',3.47),('15087','2013-06-20','16:15:00',3.47),('15087','2013-06-20','16:20:00',3.34),('15087','2013-06-20','16:25:00',3.32),('15087','2013-06-20','16:30:00',3.25),('15087','2013-06-20','16:35:00',3.11),('15087','2013-06-20','16:40:00',3.04),('15087','2013-06-20','16:45:00',2.98),('15087','2013-06-20','16:50:00',2.99),('15087','2013-06-20','16:55:00',2.91),('15087','2013-06-20','17:00:00',2.79),('15087','2013-06-20','17:05:00',2.71),('15087','2013-06-20','17:10:00',2.63),('15087','2013-06-20','17:15:00',2.55),('15087','2013-06-20','17:20:00',2.46),('15087','2013-06-20','17:25:00',2.35),('15087','2013-06-20','17:30:00',2.21),('15087','2013-06-20','17:35:00',2.11),('15087','2013-06-20','17:40:00',2.03),('15087','2013-06-20','17:45:00',1.89),('15087','2013-06-20','17:50:00',1.75),('15087','2013-06-20','17:55:00',1.68),('15087','2013-06-20','18:00:00',1.54),('15087','2013-06-20','18:05:00',1.43),('15087','2013-06-20','18:10:00',1.37),('15087','2013-06-20','18:15:00',1.33),('15087','2013-06-20','18:20:00',1.25),('15087','2013-06-20','18:25:00',1.15),('15087','2013-06-20','18:30:00',1.1),('15087','2013-06-19','07:35:00',1.03),('15087','2013-06-19','07:40:00',1.11),('15087','2013-06-19','07:45:00',1.19),('15087','2013-06-19','07:50:00',1.28),('15087','2013-06-19','07:55:00',1.35),('15087','2013-06-19','08:00:00',1.42),('15087','2013-06-19','08:05:00',1.5),('15087','2013-06-19','08:10:00',1.59),('15087','2013-06-19','08:15:00',1.67),('15087','2013-06-19','08:20:00',1.75),('15087','2013-06-19','08:25:00',1.84),('15087','2013-06-19','08:30:00',1.89),('15087','2013-06-19','08:35:00',2.02),('15087','2013-06-19','08:40:00',2.1),('15087','2013-06-19','08:45:00',2.15),('15087','2013-06-19','08:50:00',2.28),('15087','2013-06-19','08:55:00',2.37),('15087','2013-06-19','09:00:00',2.49),('15087','2013-06-19','09:05:00',2.56),('15087','2013-06-19','09:10:00',2.65),('15087','2013-06-19','09:15:00',2.73),('15087','2013-06-19','09:20:00',2.78),('15087','2013-06-19','09:25:00',2.85),('15087','2013-06-19','09:30:00',2.9),('15087','2013-06-19','09:35:00',2.97),('15087','2013-06-19','09:40:00',3.03),('15087','2013-06-19','09:45:00',3.08),('15087','2013-06-19','09:50:00',3.15),('15087','2013-06-19','09:55:00',3.2),('15087','2013-06-19','10:00:00',3.26),('15087','2013-06-19','10:05:00',3.33),('15087','2013-06-19','10:10:00',3.38),('15087','2013-06-19','10:15:00',3.43),('15087','2013-06-19','10:20:00',3.47),('15087','2013-06-19','10:25:00',3.52),('15087','2013-06-19','10:30:00',3.57),('15087','2013-06-19','10:35:00',3.61),('15087','2013-06-19','10:40:00',3.64),('15087','2013-06-19','10:45:00',3.68),('15087','2013-06-19','10:50:00',3.7),('15087','2013-06-19','10:55:00',3.73),('15087','2013-06-19','11:00:00',3.75),('15087','2013-06-19','11:05:00',3.82),('15087','2013-06-19','11:10:00',3.82),('15087','2013-06-19','11:15:00',3.8),('15087','2013-06-19','11:20:00',3.93),('15087','2013-06-19','11:25:00',3.92),('15087','2013-06-19','11:30:00',3.99),('15087','2013-06-19','11:35:00',3.97),('15087','2013-06-19','11:40:00',3.99),('15087','2013-06-19','11:45:00',4.05),('15087','2013-06-19','11:50:00',4.05),('15087','2013-06-19','11:55:00',4.12),('15087','2013-06-19','12:00:00',4.12),('15087','2013-06-19','12:05:00',4.12),('15087','2013-06-19','12:10:00',4.1),('15087','2013-06-19','12:15:00',4.11),('15087','2013-06-19','12:20:00',4.07),('15087','2013-06-19','12:25:00',4.08),('15087','2013-06-19','12:30:00',4.22),('15087','2013-06-19','12:35:00',4.33),('15087','2013-06-19','12:40:00',4.33),('15087','2013-06-19','12:45:00',4.31),('15087','2013-06-19','12:50:00',4.37),('15087','2013-06-19','12:55:00',4.35),('15087','2013-06-19','13:00:00',4.34),('15087','2013-06-19','13:05:00',4.35),('15087','2013-06-19','13:10:00',4.33),('15087','2013-06-19','13:15:00',4.3),('15087','2013-06-19','13:20:00',4.36),('15087','2013-06-19','13:25:00',4.42),('15087','2013-06-19','13:30:00',4.39),('15087','2013-06-19','13:35:00',4.4),('15087','2013-06-19','13:40:00',4.38),('15087','2013-06-19','13:45:00',4.37),('15087','2013-06-19','13:50:00',4.37),('15087','2013-06-19','13:55:00',4.38),('15087','2013-06-19','14:00:00',4.39),('15087','2013-06-19','14:05:00',4.39),('15087','2013-06-19','14:10:00',4.34),('15087','2013-06-19','14:15:00',4.26),('15087','2013-06-19','14:20:00',4.28),('15087','2013-06-19','14:25:00',4.27),('15087','2013-06-19','14:30:00',4.23),('15087','2013-06-19','14:35:00',4.19),('15087','2013-06-19','14:40:00',4.13),('15087','2013-06-19','14:45:00',4.04),('15087','2013-06-19','14:50:00',3.97),('15087','2013-06-19','14:55:00',4.01),('15087','2013-06-19','15:00:00',3.98),('15087','2013-06-19','15:05:00',3.95),('15087','2013-06-19','15:10:00',3.86),('15087','2013-06-19','15:15:00',3.54),('15087','2013-06-19','15:20:00',3.55),('15087','2013-06-19','15:25:00',3.75),('15087','2013-06-19','15:30:00',3.64),('15087','2013-06-19','15:35:00',3.59),('15087','2013-06-19','15:40:00',3.56),('15087','2013-06-19','15:45:00',3.52),('15087','2013-06-19','15:50:00',3.41),('15087','2013-06-19','15:55:00',3.39),('15087','2013-06-19','16:00:00',3.38),('15087','2013-06-19','16:05:00',3.32),('15087','2013-06-19','16:10:00',3.25),('15087','2013-06-19','16:15:00',3.27),('15087','2013-06-19','16:20:00',3.18),('15087','2013-06-19','16:25:00',3.14),('15087','2013-06-19','16:30:00',3.07),('15087','2013-06-19','16:35:00',2.95),('15087','2013-06-19','16:40:00',2.9),('15087','2013-06-19','16:45:00',2.89),('15087','2013-06-19','16:50:00',2.87),('15087','2013-06-19','16:55:00',2.81),('15087','2013-06-19','17:00:00',2.71),('15087','2013-06-19','17:05:00',2.59),('15087','2013-06-19','17:10:00',2.49),('15087','2013-06-19','17:15:00',2.46),('15087','2013-06-19','17:20:00',2.38),('15087','2013-06-19','17:25:00',2.31),('15087','2013-06-19','17:30:00',2.19),('15087','2013-06-19','17:35:00',2.07),('15087','2013-06-19','17:40:00',1.98),('15087','2013-06-19','17:45:00',1.85),('15087','2013-06-19','17:50:00',1.71),('15087','2013-06-19','17:55:00',1.65),('15087','2013-06-19','18:00:00',1.58),('15087','2013-06-19','18:05:00',1.48),('15087','2013-06-19','18:10:00',1.32),('15087','2013-06-19','18:15:00',1.21),('15087','2013-06-19','18:20:00',1.18),('15087','2013-06-19','18:25:00',1.07),('15087','2013-06-19','18:30:00',1.02),('15087','2013-06-17','07:30:00',1.02),('15087','2013-06-17','07:35:00',1.09),('15087','2013-06-17','07:40:00',1.18),('15087','2013-06-17','07:45:00',1.25),('15087','2013-06-17','07:50:00',1.35),('15087','2013-06-17','07:55:00',1.44),('15087','2013-06-17','08:00:00',1.52),('15087','2013-06-17','08:05:00',1.62),('15087','2013-06-17','08:10:00',1.71),('15087','2013-06-17','08:15:00',1.79),('15087','2013-06-17','08:20:00',1.88),('15087','2013-06-17','08:25:00',1.97),('15087','2013-06-17','08:30:00',2.04),('15087','2013-06-17','08:35:00',2.16),('15087','2013-06-17','08:40:00',2.27),('15087','2013-06-17','08:45:00',2.35),('15087','2013-06-17','08:50:00',2.45),('15087','2013-06-17','08:55:00',2.53),('15087','2013-06-17','09:00:00',2.62),('15087','2013-06-17','09:05:00',2.69),('15087','2013-06-17','09:10:00',2.76),('15087','2013-06-17','09:15:00',2.83),('15087','2013-06-17','09:20:00',2.9),('15087','2013-06-17','09:25:00',2.95),('15087','2013-06-17','09:30:00',3.02),('15087','2013-06-17','09:35:00',3.09),('15087','2013-06-17','09:40:00',3.13),('15087','2013-06-17','09:45:00',3.19),('15087','2013-06-17','09:50:00',3.25),('15087','2013-06-17','09:55:00',3.32),('15087','2013-06-17','10:00:00',3.32),('15087','2013-06-17','10:05:00',3.41),('15087','2013-06-17','10:10:00',3.46),('15087','2013-06-17','10:15:00',3.5),('15087','2013-06-17','10:20:00',3.54),('15087','2013-06-17','10:25:00',3.6),('15087','2013-06-17','10:30:00',3.64),('15087','2013-06-17','10:35:00',3.72),('15087','2013-06-17','10:40:00',3.75),('15087','2013-06-17','10:45:00',3.79),('15087','2013-06-17','10:50:00',3.85),('15087','2013-06-17','10:55:00',3.85),('15087','2013-06-17','11:00:00',3.9),('15087','2013-06-17','11:05:00',3.95),('15087','2013-06-17','11:10:00',3.96),('15087','2013-06-17','11:15:00',3.99),('15087','2013-06-17','11:20:00',4.02),('15087','2013-06-17','11:25:00',4.07),('15087','2013-06-17','11:30:00',4.11),('15087','2013-06-17','11:35:00',4.14),('15087','2013-06-17','11:40:00',4.15),('15087','2013-06-17','11:45:00',4.15),('15087','2013-06-17','11:50:00',4.15),('15087','2013-06-17','11:55:00',4.16),('15087','2013-06-17','12:00:00',4.17),('15087','2013-06-17','12:05:00',4.23),('15087','2013-06-17','12:10:00',4.21),('15087','2013-06-17','12:15:00',4.19),('15087','2013-06-17','12:20:00',4.19),('15087','2013-06-17','12:25:00',4.23),('15087','2013-06-17','12:30:00',4.21),('15087','2013-06-17','12:35:00',4.27),('15087','2013-06-17','12:40:00',4.28),('15087','2013-06-17','12:45:00',4.4),('15087','2013-06-17','12:50:00',4.35),('15087','2013-06-17','12:55:00',4.48),('15087','2013-06-17','13:00:00',4.49),('15087','2013-06-17','13:05:00',4.47),('15087','2013-06-17','13:10:00',4.43),('15087','2013-06-17','13:15:00',4.47),('15087','2013-06-17','13:20:00',4.45),('15087','2013-06-17','13:25:00',4.43),('15087','2013-06-17','13:30:00',4.44),('15087','2013-06-17','13:35:00',4.42),('15087','2013-06-17','13:40:00',4.44),('15087','2013-06-17','13:45:00',4.41),('15087','2013-06-17','13:50:00',4.41),('15087','2013-06-17','13:55:00',4.37),('15087','2013-06-17','14:00:00',4.36),('15087','2013-06-17','14:05:00',4.36),('15087','2013-06-17','14:10:00',4.36),('15087','2013-06-17','14:15:00',4.33),('15087','2013-06-17','14:20:00',4.33),('15087','2013-06-17','14:25:00',4.3),('15087','2013-06-17','14:30:00',4.27),('15087','2013-06-17','14:35:00',4.24),('15087','2013-06-17','14:40:00',4.22),('15087','2013-06-17','14:45:00',4.13),('15087','2013-06-17','14:50:00',4.1),('15087','2013-06-17','14:55:00',4.08),('15087','2013-06-17','15:00:00',4.03),('15087','2013-06-17','15:05:00',3.96),('15087','2013-06-17','15:10:00',3.88),('15087','2013-06-17','15:15:00',3.54),('15087','2013-06-17','15:20:00',3.67),('15087','2013-06-17','15:25:00',3.81),('15087','2013-06-17','15:30:00',3.7),('15087','2013-06-17','15:35:00',3.66),('15087','2013-06-17','15:40:00',3.61),('15087','2013-06-17','15:45:00',3.57),('15087','2013-06-17','15:50:00',3.5),('15087','2013-06-17','15:55:00',3.48),('15087','2013-06-17','16:00:00',3.47),('15087','2013-06-17','16:05:00',3.38),('15087','2013-06-17','16:10:00',3.31),('15087','2013-06-17','16:15:00',3.33),('15087','2013-06-17','16:20:00',3.26),('15087','2013-06-17','16:25:00',3.23),('15087','2013-06-17','16:30:00',3.16),('15087','2013-06-17','16:35:00',3.08),('15087','2013-06-17','16:40:00',2.96),('15087','2013-06-17','16:45:00',2.92),('15087','2013-06-17','16:50:00',2.9),('15087','2013-06-17','16:55:00',2.89),('15087','2013-06-17','17:00:00',2.77),('15087','2013-06-17','17:05:00',2.68),('15087','2013-06-17','17:10:00',2.61),('15087','2013-06-17','17:15:00',2.55),('15087','2013-06-17','17:20:00',2.51),('15087','2013-06-17','17:25:00',2.37),('15087','2013-06-17','17:30:00',2.23),('15087','2013-06-17','17:35:00',2.13),('15087','2013-06-17','17:40:00',2.05),('15087','2013-06-17','17:45:00',1.91),('15087','2013-06-17','17:50:00',1.77),('15087','2013-06-17','17:55:00',1.68),('15087','2013-06-17','18:00:00',1.5),('15087','2013-06-17','18:05:00',1.46),('15087','2013-06-17','18:10:00',1.4),('15087','2013-06-17','18:15:00',1.32),('15087','2013-06-17','18:20:00',1.29),('15087','2013-06-17','18:25:00',1.1),('15087','2013-06-17','18:30:00',1.11),('15087','2013-06-16','07:30:00',1.03),('15087','2013-06-16','07:35:00',1.12),('15087','2013-06-16','07:40:00',1.21),('15087','2013-06-16','07:45:00',1.29),('15087','2013-06-16','07:50:00',1.38),('15087','2013-06-16','07:55:00',1.46),('15087','2013-06-16','08:00:00',1.54),('15087','2013-06-16','08:05:00',1.62),('15087','2013-06-16','08:10:00',1.71),('15087','2013-06-16','08:15:00',1.81),('15087','2013-06-16','08:20:00',1.89),('15087','2013-06-16','08:25:00',2.03),('15087','2013-06-16','08:30:00',2.1),('15087','2013-06-16','08:35:00',2.21),('15087','2013-06-16','08:40:00',2.3),('15087','2013-06-16','08:45:00',2.41),('15087','2013-06-16','08:50:00',2.51),('15087','2013-06-16','08:55:00',2.59),('15087','2013-06-16','09:00:00',2.62),('15087','2013-06-16','09:05:00',2.69),('15087','2013-06-16','09:10:00',2.78),('15087','2013-06-16','09:15:00',2.86),('15087','2013-06-16','09:20:00',2.93),('15087','2013-06-16','09:25:00',3.02),('15087','2013-06-16','09:30:00',3.06),('15087','2013-06-16','09:35:00',3.13),('15087','2013-06-16','09:40:00',3.2),('15087','2013-06-16','09:45:00',3.22),('15087','2013-06-16','09:50:00',3.3),('15087','2013-06-16','09:55:00',3.38),('15087','2013-06-16','10:00:00',3.46),('15087','2013-06-16','10:05:00',3.49),('15087','2013-06-16','10:10:00',3.56),('15087','2013-06-16','10:15:00',3.57),('15087','2013-06-16','10:20:00',3.59),('15087','2013-06-16','10:25:00',3.65),('15087','2013-06-16','10:30:00',3.71),('15087','2013-06-16','10:35:00',3.77),('15087','2013-06-16','10:40:00',3.83),('15087','2013-06-16','10:45:00',3.86),('15087','2013-06-16','10:50:00',3.96),('15087','2013-06-16','10:55:00',3.98),('15087','2013-06-16','11:00:00',3.97),('15087','2013-06-16','11:05:00',4.02),('15087','2013-06-16','11:10:00',4.06),('15087','2013-06-16','11:15:00',4.07),('15087','2013-06-16','11:20:00',4.14),('15087','2013-06-16','11:25:00',4.21),('15087','2013-06-16','11:30:00',4.22),('15087','2013-06-16','11:35:00',4.24),('15087','2013-06-16','11:40:00',4.27),('15087','2013-06-16','11:45:00',4.28),('15087','2013-06-16','11:50:00',4.33),('15087','2013-06-16','11:55:00',4.35),('15087','2013-06-16','12:00:00',4.39),('15087','2013-06-16','12:05:00',4.44),('15087','2013-06-16','12:10:00',4.42),('15087','2013-06-16','12:15:00',4.45),('15087','2013-06-16','12:20:00',4.46),('15087','2013-06-16','12:25:00',4.44),('15087','2013-06-16','12:30:00',4.46),('15087','2013-06-16','12:35:00',4.46),('15087','2013-06-16','12:40:00',4.46),('15087','2013-06-16','12:45:00',4.5),('15087','2013-06-16','12:50:00',4.47),('15087','2013-06-16','12:55:00',4.51),('15087','2013-06-16','13:00:00',4.59),('15087','2013-06-16','13:05:00',4.61),('15087','2013-06-16','13:10:00',4.65),('15087','2013-06-16','13:15:00',4.61),('15087','2013-06-16','13:20:00',4.63),('15087','2013-06-16','13:25:00',4.62),('15087','2013-06-16','13:30:00',4.57),('15087','2013-06-16','13:35:00',4.6),('15087','2013-06-16','13:40:00',4.6),('15087','2013-06-16','13:45:00',4.57),('15087','2013-06-16','13:50:00',4.59),('15087','2013-06-16','13:55:00',4.55),('15087','2013-06-16','14:00:00',4.55),('15087','2013-06-16','14:05:00',4.53),('15087','2013-06-16','14:10:00',4.53),('15087','2013-06-16','14:15:00',4.5),('15087','2013-06-16','14:20:00',4.48),('15087','2013-06-16','14:25:00',4.43),('15087','2013-06-16','14:30:00',4.41),('15087','2013-06-16','14:35:00',4.39),('15087','2013-06-16','14:40:00',4.35),('15087','2013-06-16','14:45:00',4.21),('15087','2013-06-16','14:50:00',4.17),('15087','2013-06-16','14:55:00',4.19),('15087','2013-06-16','15:00:00',4.16),('15087','2013-06-16','15:05:00',4.1),('15087','2013-06-16','15:10:00',3.97),('15087','2013-06-16','15:15:00',3.98),('15087','2013-06-16','15:20:00',3.97),('15087','2013-06-16','15:25:00',3.93),('15087','2013-06-16','15:30:00',3.79),('15087','2013-06-16','15:35:00',3.75),('15087','2013-06-16','15:40:00',3.72),('15087','2013-06-16','15:45:00',3.66),('15087','2013-06-16','15:50:00',3.54),('15087','2013-06-16','15:55:00',3.57),('15087','2013-06-16','16:00:00',3.54),('15087','2013-06-16','16:05:00',3.42),('15087','2013-06-16','16:10:00',3.37),('15087','2013-06-16','16:15:00',3.39),('15087','2013-06-16','16:20:00',3.3),('15087','2013-06-16','16:25:00',3.29),('15087','2013-06-16','16:30:00',3.2),('15087','2013-06-16','16:35:00',3.1),('15087','2013-06-16','16:40:00',3),('15087','2013-06-16','16:45:00',2.98),('15087','2013-06-16','16:50:00',2.96),('15087','2013-06-16','16:55:00',2.9),('15087','2013-06-16','17:00:00',2.76),('15087','2013-06-16','17:05:00',2.64),('15087','2013-06-16','17:10:00',2.6),('15087','2013-06-16','17:15:00',2.56),('15087','2013-06-16','17:20:00',2.51),('15087','2013-06-16','17:25:00',2.36),('15087','2013-06-16','17:30:00',2.2),('15087','2013-06-16','17:35:00',2.1),('15087','2013-06-16','17:40:00',1.98),('15087','2013-06-16','17:45:00',1.83),('15087','2013-06-16','17:50:00',1.7),('15087','2013-06-16','17:55:00',1.59),('15087','2013-06-16','18:00:00',1.42),('15087','2013-06-16','18:05:00',1.38),('15087','2013-06-16','18:10:00',1.31),('15087','2013-06-16','18:15:00',1.25),('15087','2013-06-16','18:20:00',1.2),('15087','2013-06-16','18:25:00',1.07),('15087','2013-06-16','18:30:00',1.04),('15087','2013-06-15','07:35:00',1.08),('15087','2013-06-15','07:40:00',1.16),('15087','2013-06-15','07:45:00',1.24),('15087','2013-06-15','07:50:00',1.33),('15087','2013-06-15','07:55:00',1.41),('15087','2013-06-15','08:00:00',1.5),('15087','2013-06-15','08:05:00',1.58),('15087','2013-06-15','08:10:00',1.64),('15087','2013-06-15','08:15:00',1.77),('15087','2013-06-15','08:20:00',1.82),('15087','2013-06-15','08:25:00',1.91),('15087','2013-06-15','08:30:00',2.01),('15087','2013-06-15','08:35:00',2.12),('15087','2013-06-15','08:40:00',2.2),('15087','2013-06-15','08:45:00',2.36),('15087','2013-06-15','08:50:00',2.41),('15087','2013-06-15','08:55:00',2.48),('15087','2013-06-15','09:00:00',2.4),('15087','2013-06-15','09:05:00',2.49),('15087','2013-06-15','09:10:00',2.68),('15087','2013-06-15','09:15:00',2.72),('15087','2013-06-15','09:20:00',2.97),('15087','2013-06-15','09:25:00',2.96),('15087','2013-06-15','09:30:00',3.14),('15087','2013-06-15','09:35:00',3.36),('15087','2013-06-15','09:40:00',3.29),('15087','2013-06-15','09:45:00',3.21),('15087','2013-06-15','09:50:00',3.25),('15087','2013-06-15','09:55:00',2.34),('15087','2013-06-15','10:00:00',3.2),('15087','2013-06-15','10:05:00',3.5),('15087','2013-06-15','10:10:00',3.42),('15087','2013-06-15','10:15:00',2.9),('15087','2013-06-15','10:20:00',3.71),('15087','2013-06-15','10:25:00',3.67),('15087','2013-06-15','10:30:00',2.97),('15087','2013-06-15','10:35:00',2.16),('15087','2013-06-15','10:40:00',2.36),('15087','2013-06-15','10:45:00',3.63),('15087','2013-06-15','10:50:00',2.56),('15087','2013-06-15','10:55:00',3.34),('15087','2013-06-15','11:00:00',4.27),('15087','2013-06-15','11:05:00',3.66),('15087','2013-06-15','11:10:00',4.08),('15087','2013-06-15','11:15:00',2.73),('15087','2013-06-15','11:20:00',3.09),('15087','2013-06-15','11:25:00',4.54),('15087','2013-06-15','11:30:00',4.29),('15087','2013-06-15','11:35:00',4.42),('15087','2013-06-15','11:40:00',4.4),('15087','2013-06-15','11:45:00',3.23),('15087','2013-06-15','11:50:00',4.64),('15087','2013-06-15','11:55:00',4.58),('15087','2013-06-15','12:00:00',4.36),('15087','2013-06-15','12:05:00',4.49),('15087','2013-06-15','12:10:00',4.56),('15087','2013-06-15','12:15:00',4.6),('15087','2013-06-15','12:20:00',4.6),('15087','2013-06-15','12:25:00',4.53),('15087','2013-06-15','12:30:00',4.57),('15087','2013-06-15','12:35:00',4.58),('15087','2013-06-15','12:40:00',4.59),('15087','2013-06-15','12:45:00',4.55),('15087','2013-06-15','12:50:00',4.62),('15087','2013-06-15','12:55:00',4.65),('15087','2013-06-15','13:00:00',4.63),('15087','2013-06-15','13:05:00',4.65),('15087','2013-06-15','13:10:00',4.65),('15087','2013-06-15','13:15:00',4.66),('15087','2013-06-15','13:20:00',4.63),('15087','2013-06-15','13:25:00',4.61),('15087','2013-06-15','13:30:00',4.57),('15087','2013-06-15','13:35:00',4.5),('15087','2013-06-15','13:40:00',4.59),('15087','2013-06-15','13:45:00',4.57),('15087','2013-06-15','13:50:00',4.52),('15087','2013-06-15','13:55:00',4.54),('15087','2013-06-15','14:00:00',4.51),('15087','2013-06-15','14:05:00',4.49),('15087','2013-06-15','14:10:00',4.49),('15087','2013-06-15','14:15:00',4.46),('15087','2013-06-15','14:20:00',4.46),('15087','2013-06-15','14:25:00',4.37),('15087','2013-06-15','14:30:00',4.34),('15087','2013-06-15','14:35:00',4.27),('15087','2013-06-15','14:40:00',4.31),('15087','2013-06-15','14:45:00',4.13),('15087','2013-06-15','14:50:00',4.07),('15087','2013-06-15','14:55:00',4.14),('15087','2013-06-15','15:00:00',4.08),('15087','2013-06-15','15:05:00',4.06),('15087','2013-06-15','15:10:00',3.93),('15087','2013-06-15','15:15:00',3.61),('15087','2013-06-15','15:20:00',3.79),('15087','2013-06-15','15:25:00',3.93),('15087','2013-06-15','15:30:00',3.82),('15087','2013-06-15','15:35:00',3.77),('15087','2013-06-15','15:40:00',3.73),('15087','2013-06-15','15:45:00',3.67),('15087','2013-06-15','15:50:00',3.61),('15087','2013-06-15','15:55:00',3.58),('15087','2013-06-15','16:00:00',3.54),('15087','2013-06-15','16:05:00',3.49),('15087','2013-06-15','16:10:00',3.43),('15087','2013-06-15','16:15:00',3.41),('15087','2013-06-15','16:20:00',3.31),('15087','2013-06-15','16:25:00',3.28),('15087','2013-06-15','16:30:00',3.2),('15087','2013-06-15','16:35:00',3.09),('15087','2013-06-15','16:40:00',2.98),('15087','2013-06-15','16:45:00',2.98),('15087','2013-06-15','16:50:00',2.98),('15087','2013-06-15','16:55:00',2.9),('15087','2013-06-15','17:00:00',2.78),('15087','2013-06-15','17:05:00',2.67),('15087','2013-06-15','17:10:00',2.61),('15087','2013-06-15','17:15:00',2.55),('15087','2013-06-15','17:20:00',2.48),('15087','2013-06-15','17:25:00',2.37),('15087','2013-06-15','17:30:00',2.16),('15087','2013-06-15','17:35:00',2.07),('15087','2013-06-15','17:40:00',1.95),('15087','2013-06-15','17:45:00',1.77),('15087','2013-06-15','17:50:00',1.65),('15087','2013-06-15','17:55:00',1.6),('15087','2013-06-15','18:00:00',1.47),('15087','2013-06-15','18:05:00',1.37),('15087','2013-06-15','18:10:00',1.29),('15087','2013-06-15','18:15:00',1.25),('15087','2013-06-15','18:20:00',1.18),('15087','2013-06-15','18:25:00',1.06),('15087','2013-06-15','18:30:00',1.02),('15087','2013-06-14','07:25:00',1.05),('15087','2013-06-14','07:30:00',1.13),('15087','2013-06-14','07:35:00',1.23),('15087','2013-06-14','07:40:00',1.32),('15087','2013-06-14','07:45:00',1.41),('15087','2013-06-14','07:50:00',1.49),('15087','2013-06-14','07:55:00',1.58),('15087','2013-06-14','08:00:00',1.7),('15087','2013-06-14','08:05:00',1.79),('15087','2013-06-14','08:10:00',1.88),('15087','2013-06-14','08:15:00',1.99),('15087','2013-06-14','08:20:00',2.1),('15087','2013-06-14','08:25:00',2.19),('15087','2013-06-14','08:30:00',2.28),('15087','2013-06-14','08:35:00',2.37),('15087','2013-06-14','08:40:00',2.47),('15087','2013-06-14','08:45:00',2.55),('15087','2013-06-14','08:50:00',2.63),('15087','2013-06-14','08:55:00',2.7),('15087','2013-06-14','09:00:00',2.77),('15087','2013-06-14','09:05:00',2.85),('15087','2013-06-14','09:10:00',2.93),('15087','2013-06-14','09:15:00',2.97),('15087','2013-06-14','09:20:00',3.06),('15087','2013-06-14','09:25:00',3.14),('15087','2013-06-14','09:30:00',3.2),('15087','2013-06-14','09:35:00',3.28),('15087','2013-06-14','09:40:00',3.36),('15087','2013-06-14','09:45:00',3.42),('15087','2013-06-14','09:50:00',3.49),('15087','2013-06-14','09:55:00',3.55),('15087','2013-06-14','10:00:00',3.6),('15087','2013-06-14','10:05:00',3.64),('15087','2013-06-14','10:10:00',3.71),('15087','2013-06-14','10:15:00',3.72),('15087','2013-06-14','10:20:00',3.78),('15087','2013-06-14','10:25:00',3.83),('15087','2013-06-14','10:30:00',3.81),('15087','2013-06-14','10:35:00',4),('15087','2013-06-14','10:40:00',4.03),('15087','2013-06-14','10:45:00',4.06),('15087','2013-06-14','10:50:00',4.08),('15087','2013-06-14','10:55:00',4.06),('15087','2013-06-14','11:00:00',4.06),('15087','2013-06-14','11:05:00',4.13),('15087','2013-06-14','11:10:00',4.19),('15087','2013-06-14','11:15:00',4.25),('15087','2013-06-14','11:20:00',4.23),('15087','2013-06-14','11:25:00',4.14),('15087','2013-06-14','11:30:00',4.37),('15087','2013-06-14','11:35:00',4.4),('15087','2013-06-14','11:40:00',4.43),('15087','2013-06-14','11:45:00',4.43),('15087','2013-06-14','11:50:00',4.42),('15087','2013-06-14','11:55:00',4.46),('15087','2013-06-14','12:00:00',4.43),('15087','2013-06-14','12:05:00',4.48),('15087','2013-06-14','12:10:00',4.45),('15087','2013-06-14','12:15:00',4.47),('15087','2013-06-14','12:20:00',4.5),('15087','2013-06-14','12:25:00',4.48),('15087','2013-06-14','12:30:00',4.55),('15087','2013-06-14','12:35:00',4.52),('15087','2013-06-14','12:40:00',4.52),('15087','2013-06-14','12:45:00',4.61),('15087','2013-06-14','12:50:00',4.57),('15087','2013-06-14','12:55:00',4.6),('15087','2013-06-14','13:00:00',4.61),('15087','2013-06-14','13:05:00',4.64),('15087','2013-06-14','13:10:00',4.68),('15087','2013-06-14','13:15:00',4.68),('15087','2013-06-14','13:20:00',4.66),('15087','2013-06-14','13:25:00',4.7),('15087','2013-06-14','13:30:00',4.6),('15087','2013-06-14','13:35:00',4.57),('15087','2013-06-14','13:40:00',4.55),('15087','2013-06-14','13:45:00',4.52),('15087','2013-06-14','13:50:00',4.56),('15087','2013-06-14','13:55:00',4.47),('15087','2013-06-14','14:00:00',4.46),('15087','2013-06-14','14:05:00',4.51),('15087','2013-06-14','14:10:00',4.54),('15087','2013-06-14','14:15:00',4.52),('15087','2013-06-14','14:20:00',4.41),('15087','2013-06-14','14:25:00',4.41),('15087','2013-06-14','14:30:00',4.38),('15087','2013-06-14','14:35:00',4.38),('15087','2013-06-14','14:40:00',4.36),('15087','2013-06-14','14:45:00',4.19),('15087','2013-06-14','14:50:00',4.24),('15087','2013-06-14','14:55:00',4.24),('15087','2013-06-14','15:00:00',4.2),('15087','2013-06-14','15:05:00',4.12),('15087','2013-06-14','15:10:00',3.97),('15087','2013-06-14','15:15:00',3.58),('15087','2013-06-14','15:20:00',3.88),('15087','2013-06-14','15:25:00',3.98),('15087','2013-06-14','15:30:00',3.85),('15087','2013-06-14','15:35:00',3.82),('15087','2013-06-14','15:40:00',3.79),('15087','2013-06-14','15:45:00',3.74),('15087','2013-06-14','15:50:00',3.7),('15087','2013-06-14','15:55:00',3.64),('15087','2013-06-14','16:00:00',3.6),('15087','2013-06-14','16:05:00',3.53),('15087','2013-06-14','16:10:00',3.48),('15087','2013-06-14','16:15:00',3.45),('15087','2013-06-14','16:20:00',3.4),('15087','2013-06-14','16:25:00',3.33),('15087','2013-06-14','16:30:00',3.25),('15087','2013-06-14','16:35:00',3.14),('15087','2013-06-14','16:40:00',2.98),('15087','2013-06-14','16:45:00',3),('15087','2013-06-14','16:50:00',3.03),('15087','2013-06-14','16:55:00',2.93),('15087','2013-06-14','17:00:00',2.85),('15087','2013-06-14','17:05:00',2.67),('15087','2013-06-14','17:10:00',2.64),('15087','2013-06-14','17:15:00',2.64),('15087','2013-06-14','17:20:00',2.58),('15087','2013-06-14','17:25:00',2.45),('15087','2013-06-14','17:30:00',2.17),('15087','2013-06-14','17:35:00',2.12),('15087','2013-06-14','17:40:00',2.07),('15087','2013-06-14','17:45:00',1.89),('15087','2013-06-14','17:50:00',1.81),('15087','2013-06-14','17:55:00',1.72),('15087','2013-06-14','18:00:00',1.6),('15087','2013-06-14','18:05:00',1.53),('15087','2013-06-14','18:10:00',1.34),('15087','2013-06-14','18:15:00',1.32),('15087','2013-06-14','18:20:00',1.23),('15087','2013-06-14','18:25:00',1.13),('15087','2013-06-14','18:30:00',1.05),('15087','2013-06-13','07:25:00',1.06),('15087','2013-06-13','07:30:00',1.15),('15087','2013-06-13','07:35:00',1.24),('15087','2013-06-13','07:40:00',1.34),('15087','2013-06-13','07:45:00',1.43),('15087','2013-06-13','07:50:00',1.51),('15087','2013-06-13','07:55:00',1.6),('15087','2013-06-13','08:00:00',1.7),('15087','2013-06-13','08:05:00',1.84),('15087','2013-06-13','08:10:00',1.89),('15087','2013-06-13','08:15:00',2.04),('15087','2013-06-13','08:20:00',2.11),('15087','2013-06-13','08:25:00',2.16),('15087','2013-06-13','08:30:00',2.25),('15087','2013-06-13','08:35:00',2.37),('15087','2013-06-13','08:40:00',2.47),('15087','2013-06-13','08:45:00',2.53),('15087','2013-06-13','08:50:00',2.6),('15087','2013-06-13','08:55:00',2.68),('15087','2013-06-13','09:00:00',2.79),('15087','2013-06-13','09:05:00',2.89),('15087','2013-06-13','09:10:00',2.96),('15087','2013-06-13','09:15:00',3.05),('15087','2013-06-13','09:20:00',3.09),('15087','2013-06-13','09:25:00',3.21),('15087','2013-06-13','09:30:00',3.3),('15087','2013-06-13','09:35:00',3.38),('15087','2013-06-13','09:40:00',3.46),('15087','2013-06-13','09:45:00',3.52),('15087','2013-06-13','09:50:00',3.54),('15087','2013-06-13','09:55:00',3.66),('15087','2013-06-13','10:00:00',3.69),('15087','2013-06-13','10:05:00',3.75),('15087','2013-06-13','10:10:00',3.79),('15087','2013-06-13','10:15:00',3.85),('15087','2013-06-13','10:20:00',3.93),('15087','2013-06-13','10:25:00',3.96),('15087','2013-06-13','10:30:00',4.02),('15087','2013-06-13','10:35:00',4.09),('15087','2013-06-13','10:40:00',4.11),('15087','2013-06-13','10:45:00',4.18),('15087','2013-06-13','10:50:00',4.24),('15087','2013-06-13','10:55:00',4.29),('15087','2013-06-13','11:00:00',4.32),('15087','2013-06-13','11:05:00',4.34),('15087','2013-06-13','11:10:00',4.36),('15087','2013-06-13','11:15:00',4.39),('15087','2013-06-13','11:20:00',4.42),('15087','2013-06-13','11:25:00',4.48),('15087','2013-06-13','11:30:00',4.53),('15087','2013-06-13','11:35:00',4.56),('15087','2013-06-13','11:40:00',4.59),('15087','2013-06-13','11:45:00',4.64),('15087','2013-06-13','11:50:00',4.68),('15087','2013-06-13','11:55:00',4.67),('15087','2013-06-13','12:00:00',4.68),('15087','2013-06-13','12:05:00',4.65),('15087','2013-06-13','12:10:00',4.8),('15087','2013-06-13','12:15:00',4.78),('15087','2013-06-13','12:20:00',4.78),('15087','2013-06-13','12:25:00',4.77),('15087','2013-06-13','12:30:00',4.81),('15087','2013-06-13','12:35:00',4.82),('15087','2013-06-13','12:40:00',4.81),('15087','2013-06-13','12:45:00',4.8),('15087','2013-06-13','12:50:00',4.81),('15087','2013-06-13','12:55:00',4.79),('15087','2013-06-13','13:00:00',4.84),('15087','2013-06-13','13:05:00',4.83),('15087','2013-06-13','13:10:00',4.78),('15087','2013-06-13','13:15:00',4.83),('15087','2013-06-13','13:20:00',4.78),('15087','2013-06-13','13:25:00',4.81),('15087','2013-06-13','13:30:00',4.78),('15087','2013-06-13','13:35:00',4.79),('15087','2013-06-13','13:40:00',4.77),('15087','2013-06-13','13:45:00',4.71),('15087','2013-06-13','13:50:00',4.71),('15087','2013-06-13','13:55:00',4.69),('15087','2013-06-13','14:00:00',4.74),('15087','2013-06-13','14:05:00',4.73),('15087','2013-06-13','14:10:00',4.68),('15087','2013-06-13','14:15:00',4.67),('15087','2013-06-13','14:20:00',4.62),('15087','2013-06-13','14:25:00',4.64),('15087','2013-06-13','14:30:00',4.17),('15087','2013-06-13','14:35:00',4.63),('15087','2013-06-13','14:40:00',4.63),('15087','2013-06-13','14:45:00',4.41),('15087','2013-06-13','14:50:00',4.18),('15087','2013-06-13','14:55:00',4.31),('15087','2013-06-13','15:00:00',4.33),('15087','2013-06-13','15:05:00',4.24),('15087','2013-06-13','15:10:00',3.99),('15087','2013-06-13','15:15:00',3.99),('15087','2013-06-13','15:20:00',4.07),('15087','2013-06-13','15:25:00',4.02),('15087','2013-06-13','15:30:00',3.87),('15087','2013-06-13','15:35:00',3.8),('15087','2013-06-13','15:40:00',3.82),('15087','2013-06-13','15:45:00',3.77),('15087','2013-06-13','15:50:00',3.73),('15087','2013-06-13','15:55:00',3.67),('15087','2013-06-13','16:00:00',3.64),('15087','2013-06-13','16:05:00',3.51),('15087','2013-06-13','16:10:00',3.5),('15087','2013-06-13','16:15:00',3.45),('15087','2013-06-13','16:20:00',3.33),('15087','2013-06-13','16:25:00',3.32),('15087','2013-06-13','16:30:00',3.2),('15087','2013-06-13','16:35:00',3.09),('15087','2013-06-13','16:40:00',3.07),('15087','2013-06-13','16:45:00',3.01),('15087','2013-06-13','16:50:00',2.94),('15087','2013-06-13','16:55:00',2.88),('15087','2013-06-13','17:00:00',2.77),('15087','2013-06-13','17:05:00',2.71),('15087','2013-06-13','17:10:00',2.64),('15087','2013-06-13','17:15:00',2.59),('15087','2013-06-13','17:20:00',2.56),('15087','2013-06-13','17:25:00',2.47),('15087','2013-06-13','17:30:00',2.29),('15087','2013-06-13','17:35:00',2.2),('15087','2013-06-13','17:40:00',2.06),('15087','2013-06-13','17:45:00',1.89),('15087','2013-06-13','17:50:00',1.8),('15087','2013-06-13','17:55:00',1.64),('15087','2013-06-13','18:00:00',1.47),('15087','2013-06-13','18:05:00',1.35),('15087','2013-06-13','18:10:00',1.41),('15087','2013-06-13','18:15:00',1.33),('15087','2013-06-13','18:20:00',1.22),('15087','2013-06-13','18:25:00',1.14),('15087','2013-06-13','18:30:00',1.06),('15087','2013-06-12','07:20:00',1.01),('15087','2013-06-12','07:25:00',1.09),('15087','2013-06-12','07:30:00',1.19),('15087','2013-06-12','07:35:00',1.27),('15087','2013-06-12','07:40:00',1.36),('15087','2013-06-12','07:45:00',1.44),('15087','2013-06-12','07:50:00',1.52),('15087','2013-06-12','07:55:00',1.63),('15087','2013-06-12','08:00:00',1.72),('15087','2013-06-12','08:05:00',1.83),('15087','2013-06-12','08:10:00',1.91),('15087','2013-06-12','08:15:00',2.01),('15087','2013-06-12','08:20:00',2.16),('15087','2013-06-12','08:25:00',2.28),('15087','2013-06-12','08:30:00',2.38),('15087','2013-06-12','08:35:00',2.45),('15087','2013-06-12','08:40:00',2.55),('15087','2013-06-12','08:45:00',2.64),('15087','2013-06-12','08:50:00',2.72),('15087','2013-06-12','08:55:00',2.8),('15087','2013-06-12','09:00:00',2.89),('15087','2013-06-12','09:05:00',2.96),('15087','2013-06-12','09:10:00',3.04),('15087','2013-06-12','09:15:00',3.14),('15087','2013-06-12','09:20:00',3.21),('15087','2013-06-12','09:25:00',3.3),('15087','2013-06-12','09:30:00',3.36),('15087','2013-06-12','09:35:00',3.4),('15087','2013-06-12','09:40:00',3.48),('15087','2013-06-12','09:45:00',3.54),('15087','2013-06-12','09:50:00',3.61),('15087','2013-06-12','09:55:00',3.69),('15087','2013-06-12','10:00:00',3.75),('15087','2013-06-12','10:05:00',3.76),('15087','2013-06-12','10:10:00',3.84),('15087','2013-06-12','10:15:00',3.88),('15087','2013-06-12','10:20:00',3.98),('15087','2013-06-12','10:25:00',4.03),('15087','2013-06-12','10:30:00',4.05),('15087','2013-06-12','10:35:00',4.1),('15087','2013-06-12','10:40:00',4.13),('15087','2013-06-12','10:45:00',4.19),('15087','2013-06-12','10:50:00',4.25),('15087','2013-06-12','10:55:00',4.32),('15087','2013-06-12','11:00:00',4.37),('15087','2013-06-12','11:05:00',4.44),('15087','2013-06-12','11:10:00',4.47),('15087','2013-06-12','11:15:00',4.49),('15087','2013-06-12','11:20:00',4.53),('15087','2013-06-12','11:25:00',4.53),('15087','2013-06-12','11:30:00',4.58),('15087','2013-06-12','11:35:00',4.57),('15087','2013-06-12','11:40:00',4.58),('15087','2013-06-12','11:45:00',4.65),('15087','2013-06-12','11:50:00',4.6),('15087','2013-06-12','11:55:00',4.66),('15087','2013-06-12','12:00:00',4.67),('15087','2013-06-12','12:05:00',4.63),('15087','2013-06-12','12:10:00',4.68),('15087','2013-06-12','12:15:00',4.75),('15087','2013-06-12','12:20:00',4.9),('15087','2013-06-12','12:25:00',3.37),('15087','2013-06-12','12:30:00',2.23),('15087','2013-06-12','12:35:00',5.11),('15087','2013-06-12','12:40:00',4.93),('15087','2013-06-12','12:45:00',1.36),('15087','2013-06-12','12:50:00',2.03),('15087','2013-06-12','12:55:00',2.66),('15087','2013-06-12','13:00:00',4.82),('15087','2013-06-12','13:05:00',1.83),('15087','2013-06-12','13:10:00',5.03),('15087','2013-06-12','13:15:00',4.89),('15087','2013-06-12','13:20:00',4.86),('15087','2013-06-12','13:25:00',4.8),('15087','2013-06-12','13:30:00',4.82),('15087','2013-06-12','13:35:00',4.85),('15087','2013-06-12','13:40:00',4.86),('15087','2013-06-12','13:45:00',4.51),('15087','2013-06-12','13:50:00',4.79),('15087','2013-06-12','13:55:00',4.9),('15087','2013-06-12','14:00:00',2.97),('15087','2013-06-12','14:05:00',3.1),('15087','2013-06-12','14:10:00',1.45),('15087','2013-06-12','14:15:00',4.78),('15087','2013-06-12','14:20:00',2.53),('15087','2013-06-12','14:25:00',2.93),('15087','2013-06-12','14:30:00',4.38),('15087','2013-06-12','14:35:00',3.84),('15087','2013-06-12','14:40:00',4.24),('15087','2013-06-12','14:45:00',4.53),('15087','2013-06-12','14:50:00',4.38),('15087','2013-06-12','14:55:00',4.58),('15087','2013-06-12','15:00:00',4.49),('15087','2013-06-12','15:05:00',4.32),('15087','2013-06-12','15:10:00',4.14),('15087','2013-06-12','15:15:00',3.67),('15087','2013-06-12','15:20:00',4.27),('15087','2013-06-12','15:25:00',4.05),('15087','2013-06-12','15:30:00',3.95),('15087','2013-06-12','15:35:00',3.97),('15087','2013-06-12','15:40:00',3.96),('15087','2013-06-12','15:45:00',3.88),('15087','2013-06-12','15:50:00',3.8),('15087','2013-06-12','15:55:00',3.82),('15087','2013-06-12','16:00:00',3.88),('15087','2013-06-12','16:05:00',3.54),('15087','2013-06-12','16:10:00',3.65),('15087','2013-06-12','16:15:00',3.6),('15087','2013-06-12','16:20:00',3.46),('15087','2013-06-12','16:25:00',3.51),('15087','2013-06-12','16:30:00',2.86),('15087','2013-06-12','16:35:00',3.06),('15087','2013-06-12','16:40:00',3.26),('15087','2013-06-12','16:45:00',2.43),('15087','2013-06-12','16:50:00',3.15),('15087','2013-06-12','16:55:00',2.51),('15087','2013-06-12','17:00:00',2.89),('15087','2013-06-12','17:05:00',2.81),('15087','2013-06-12','17:10:00',2.73),('15087','2013-06-12','17:15:00',2.7),('15087','2013-06-12','17:20:00',2.63),('15087','2013-06-12','17:25:00',2.51),('15087','2013-06-12','17:30:00',2.37),('15087','2013-06-12','17:35:00',2.32),('15087','2013-06-12','17:40:00',2.2),('15087','2013-06-12','18:05:00',1.38),('15087','2013-06-12','18:10:00',1.5),('15087','2013-06-12','18:15:00',1.42),('15087','2013-06-12','18:20:00',1.3),('15087','2013-06-12','18:25:00',1.15),('15087','2013-06-12','18:30:00',1.08),('15087','2013-06-11','07:25:00',1.07),('15087','2013-06-11','07:30:00',1.11),('15087','2013-06-11','07:35:00',1.18),('15087','2013-06-11','07:40:00',1.23),('15087','2013-06-11','07:45:00',1.02),('15087','2013-06-11','07:50:00',1.48),('15087','2013-06-11','07:55:00',1.68),('15087','2013-06-11','08:00:00',1.84),('15087','2013-06-11','08:05:00',2.07),('15087','2013-06-11','08:10:00',1.58),('15087','2013-06-11','08:15:00',1.64),('15087','2013-06-11','08:25:00',2.46),('15087','2013-06-11','08:30:00',2.58),('15087','2013-06-11','08:35:00',2.63),('15087','2013-06-11','08:40:00',2.3),('15087','2013-06-11','08:45:00',2.08),('15087','2013-06-11','08:50:00',1.23),('15087','2013-06-11','08:55:00',1.46),('15087','2013-06-11','09:00:00',3.03),('15087','2013-06-11','09:05:00',3.09),('15087','2013-06-11','09:10:00',3.22),('15087','2013-06-11','09:15:00',3.32),('15087','2013-06-11','09:20:00',3.39),('15087','2013-06-11','09:25:00',2.38),('15087','2013-06-11','09:30:00',2.8),('15087','2013-06-11','09:40:00',3.07),('15087','2013-06-11','09:45:00',3.71),('15087','2013-06-11','09:50:00',3.75),('15087','2013-06-11','09:55:00',3.64),('15087','2013-06-11','10:00:00',2.14),('15087','2013-06-11','10:05:00',2.29),('15087','2013-06-11','10:10:00',3.77),('15087','2013-06-11','10:15:00',4.12),('15087','2013-06-11','10:20:00',4.2),('15087','2013-06-11','10:25:00',4.15),('15087','2013-06-11','10:30:00',4.17),('15087','2013-06-11','10:35:00',4.24),('15087','2013-06-11','10:40:00',4.23),('15087','2013-06-11','10:45:00',4.36),('15087','2013-06-11','10:50:00',2.9),('15087','2013-06-11','10:55:00',1.65),('15087','2013-06-11','11:00:00',4.72),('15087','2013-06-11','11:05:00',2.64),('15087','2013-06-11','11:10:00',3.41),('15087','2013-06-11','11:15:00',4.76),('15087','2013-06-11','11:20:00',4.6),('15087','2013-06-11','11:25:00',4.59),('15087','2013-06-11','11:30:00',4.61),('15087','2013-06-11','11:35:00',4.66),('15087','2013-06-11','11:40:00',4.64),('15087','2013-06-11','11:45:00',4.72),('15087','2013-06-11','11:50:00',4.76),('15087','2013-06-11','11:55:00',4.79),('15087','2013-06-11','12:00:00',4.81),('15087','2013-06-11','12:05:00',4.9),('15087','2013-06-11','12:10:00',4.87),('15087','2013-06-11','12:15:00',4.88),('15087','2013-06-11','12:20:00',4.86),('15087','2013-06-11','12:25:00',4.87),('15087','2013-06-11','12:30:00',4.9),('15087','2013-06-11','12:35:00',4.91),('15087','2013-06-11','12:40:00',4.94),('15087','2013-06-11','12:45:00',4.97),('15087','2013-06-11','12:50:00',5),('15087','2013-06-11','12:55:00',4.99),('15087','2013-06-11','13:00:00',4.98),('15087','2013-06-11','13:05:00',4.99),('15087','2013-06-11','13:10:00',4.99),('15087','2013-06-11','13:15:00',5.01),('15087','2013-06-11','13:20:00',4.98),('15087','2013-06-11','13:25:00',4.97),('15087','2013-06-11','13:30:00',4.99),('15087','2013-06-11','13:35:00',4.78),('15087','2013-06-11','13:40:00',5.02),('15087','2013-06-11','13:45:00',4.2),('15087','2013-06-11','13:50:00',4.74),('15087','2013-06-11','13:55:00',4.98),('15087','2013-06-11','14:00:00',4.95),('15087','2013-06-11','14:05:00',4.84),('15087','2013-06-11','14:10:00',4.83),('15087','2013-06-11','14:15:00',4.79),('15087','2013-06-11','14:20:00',4.74),('15087','2013-06-11','14:25:00',4.73),('15087','2013-06-11','14:30:00',4.72),('15087','2013-06-11','14:35:00',4.67),('15087','2013-06-11','14:40:00',4.57),('15087','2013-06-11','14:45:00',4.47),('15087','2013-06-11','14:50:00',4.52),('15087','2013-06-11','14:55:00',4.45),('15087','2013-06-11','15:00:00',4.42),('15087','2013-06-11','15:05:00',4.29),('15087','2013-06-11','15:10:00',4.24),('15087','2013-06-11','15:15:00',4.2),('15087','2013-06-11','15:20:00',4.16),('15087','2013-06-11','15:25:00',4.1),('15087','2013-06-11','15:30:00',3.99),('15087','2013-06-11','15:35:00',3.83),('15087','2013-06-11','15:40:00',3.8),('15087','2013-06-11','15:45:00',4.02),('15087','2013-06-11','15:50:00',3.83),('15087','2013-06-11','15:55:00',3.86),('15087','2013-06-11','16:00:00',3.64),('15087','2013-06-11','16:05:00',3.56),('15087','2013-06-11','16:10:00',3.68),('15087','2013-06-11','16:15:00',3.62),('15087','2013-06-11','16:20:00',3.51),('15087','2013-06-11','16:25:00',3.51),('15087','2013-06-11','16:30:00',3.42),('15087','2013-06-11','16:35:00',3.34),('15087','2013-06-11','16:40:00',3.38),('15087','2013-06-11','16:45:00',3.58),('15087','2013-06-11','16:50:00',3.66),('15087','2013-06-11','16:55:00',3.43),('15087','2013-06-11','17:00:00',2.85),('15087','2013-06-11','17:05:00',1.86),('15087','2014-04-03','08:55:00',1.15),('15087','2014-04-03','09:00:00',1.29),('15087','2014-04-03','09:05:00',1.44),('15087','2014-04-03','09:10:00',1.39),('15087','2014-04-03','09:15:00',1.24),('15087','2014-04-03','09:20:00',1.25),('15087','2014-04-03','09:25:00',1.37),('15087','2014-04-03','09:30:00',1.64),('15087','2014-04-03','09:35:00',1.95),('15087','2014-04-03','09:40:00',2.06),('15087','2014-04-03','09:45:00',2.03),('15087','2014-04-03','09:50:00',1.93),('15087','2014-04-03','09:55:00',2.04),('15087','2014-04-03','10:00:00',2.43),('15087','2014-04-03','10:05:00',2.82),('15087','2014-04-03','10:10:00',2.99),('15087','2014-04-03','10:15:00',3.38),('15087','2014-04-03','10:20:00',3.47),('15087','2014-04-03','10:25:00',3.11),('15087','2014-04-03','10:30:00',2.94),('15087','2014-04-03','10:35:00',3.13),('15087','2014-04-03','10:40:00',2.46),('15087','2014-04-03','10:45:00',2.65),('15087','2014-04-03','10:50:00',2.29),('15087','2014-04-03','10:55:00',2.39),('15087','2014-04-03','11:00:00',2.22),('15087','2014-04-03','11:05:00',1.88),('15087','2014-04-03','11:10:00',1.77),('15087','2014-04-03','11:15:00',1.62),('15087','2014-04-03','11:20:00',1.51),('15087','2014-04-03','11:25:00',1.39),('15087','2014-04-03','11:30:00',1.38),('15087','2014-04-03','11:35:00',1.49),('15087','2014-04-03','11:40:00',1.7),('15087','2014-04-03','11:45:00',1.95),('15087','2014-04-03','11:50:00',2.4),('15087','2014-04-03','11:55:00',2.62),('15087','2014-04-03','12:00:00',2.5),('15087','2014-04-03','12:05:00',2.52),('15087','2014-04-03','12:10:00',2.44),('15087','2014-04-03','12:15:00',2.39),('15087','2014-04-03','12:20:00',2.68),('15087','2014-04-03','12:25:00',3.31),('15087','2014-04-03','12:30:00',4.19),('15087','2014-04-03','12:35:00',4.06),('15087','2014-04-03','12:40:00',4.48),('15087','2014-04-03','12:45:00',2.51),('15087','2014-04-03','12:50:00',3.05),('15087','2014-04-03','12:55:00',2.94),('15087','2014-04-03','13:00:00',2.82),('15087','2014-04-03','13:05:00',3.59),('15087','2014-04-03','13:10:00',2.76),('15087','2014-04-03','13:15:00',4.9),('15087','2014-04-03','13:20:00',2.91),('15087','2014-04-03','13:25:00',3.06),('15087','2014-04-03','13:30:00',3.15),('15087','2014-04-03','13:35:00',4.96),('15087','2014-04-03','13:40:00',4.25),('15087','2014-04-03','13:45:00',2.35),('15087','2014-04-03','13:50:00',2.37),('15087','2014-04-03','13:55:00',2.86),('15087','2014-04-03','14:00:00',3.99),('15087','2014-04-03','14:05:00',3.71),('15087','2014-04-03','14:10:00',2.92),('15087','2014-04-03','14:15:00',3.83),('15087','2014-04-03','14:20:00',3.89),('15087','2014-04-03','14:25:00',4.06),('15087','2014-04-03','14:30:00',4.1),('15087','2014-04-03','14:35:00',4.07),('15087','2014-04-03','14:40:00',3.8),('15087','2014-04-03','14:45:00',3.7),('15087','2014-04-03','14:50:00',3.75),('15087','2014-04-03','14:55:00',3.65),('15087','2014-04-03','15:00:00',3.51),('15087','2014-04-03','15:05:00',3.52),('15087','2014-04-03','15:10:00',3.5),('15087','2014-04-03','15:15:00',3.43),('15087','2014-04-03','15:20:00',3.4),('15087','2014-04-03','15:25:00',3.38),('15087','2014-04-03','15:30:00',3.3),('15087','2014-04-03','15:35:00',3.2),('15087','2014-04-03','15:40:00',3.12),('15087','2014-04-03','15:45:00',2.98),('15087','2014-04-03','15:50:00',3.05),('15087','2014-04-03','15:55:00',3.07),('15087','2014-04-03','16:00:00',2.9),('15087','2014-04-03','16:05:00',2.89),('15087','2014-04-03','16:10:00',2.9),('15087','2014-04-03','16:15:00',2.7),('15087','2014-04-03','16:20:00',2.76),('15087','2014-04-03','16:25:00',2.7),('15087','2014-04-03','16:30:00',2.6),('15087','2014-04-03','16:35:00',2.53),('15087','2014-04-03','16:40:00',2.47),('15087','2014-04-03','16:45:00',2.29),('15087','2014-04-03','16:50:00',1.65),('15087','2014-04-03','16:55:00',1.41),('15087','2014-04-03','17:00:00',1.08),('15087','2014-04-03','17:50:00',1.14),('15087','2013-06-10','07:30:00',1.27),('15087','2013-06-10','07:35:00',1.78),('15087','2013-06-10','08:00:00',1.23),('15087','2013-06-10','08:05:00',1.73),('15087','2013-06-10','08:10:00',2.37),('15087','2013-06-10','08:15:00',1.8),('15087','2013-06-10','08:20:00',1.85),('15087','2013-06-10','08:25:00',1.58),('15087','2013-06-10','08:30:00',1.23),('15087','2013-06-10','08:35:00',1.06),('15087','2013-06-10','08:40:00',1.74),('15087','2013-06-10','08:55:00',1.09),('15087','2013-06-10','09:00:00',1.15),('15087','2013-06-10','09:05:00',1.16),('15087','2013-06-10','09:10:00',1.36),('15087','2013-06-10','09:15:00',1.48),('15087','2013-06-10','09:20:00',2.86),('15087','2013-06-10','09:25:00',3.47),('15087','2013-06-10','09:30:00',2.36),('15087','2013-06-10','09:35:00',3.61),('15087','2013-06-10','09:40:00',2.81),('15087','2013-06-10','09:45:00',4.32),('15087','2013-06-10','09:50:00',1.96),('15087','2013-06-10','09:55:00',1.69),('15087','2013-06-10','10:00:00',2.38),('15087','2013-06-10','10:05:00',2.56),('15087','2013-06-10','10:10:00',2.16),('15087','2013-06-10','10:15:00',2.09),('15087','2013-06-10','10:20:00',2.14),('15087','2013-06-10','10:25:00',1.76),('15087','2013-06-10','10:30:00',1.53),('15087','2013-06-10','10:35:00',2.19),('15087','2013-06-10','10:40:00',1.65),('15087','2013-06-10','10:45:00',1.28),('15087','2013-06-10','10:50:00',2.26),('15087','2013-06-10','10:55:00',3.96),('15087','2013-06-10','11:00:00',2.65),('15087','2013-06-10','11:05:00',2.39),('15087','2013-06-10','11:10:00',2.43),('15087','2013-06-10','11:15:00',4.23),('15087','2013-06-10','11:20:00',4.83),('15087','2013-06-10','11:25:00',4.36),('15087','2013-06-10','11:30:00',4.75),('15087','2013-06-10','11:35:00',4.25),('15087','2013-06-10','11:40:00',2.91),('15087','2013-06-10','11:45:00',3.05),('15087','2013-06-10','11:50:00',2.17),('15087','2013-06-10','11:55:00',4.83),('15087','2013-06-10','12:00:00',4.11),('15087','2013-06-10','12:05:00',1.51),('15087','2013-06-10','12:10:00',4.52),('15087','2013-06-10','12:15:00',4.58),('15087','2013-06-10','12:20:00',5.1),('15087','2013-06-10','12:25:00',5.06),('15087','2013-06-10','12:30:00',5.44),('15087','2013-06-10','12:35:00',4.31),('15087','2013-06-10','12:40:00',4.91),('15087','2013-06-10','12:45:00',2.93),('15087','2013-06-10','12:50:00',2.69),('15087','2013-06-10','12:55:00',4.39),('15087','2013-06-10','13:00:00',5.69),('15087','2013-06-10','13:05:00',4.51),('15087','2013-06-10','13:10:00',2.13),('15087','2013-06-10','13:15:00',4.87),('15087','2013-06-10','13:20:00',3.55),('15087','2013-06-10','13:25:00',2.93),('15087','2013-06-10','13:30:00',2.9),('15087','2013-06-10','13:35:00',5.33),('15087','2013-06-10','13:40:00',4.85),('15087','2013-06-10','13:45:00',4.93),('15087','2013-06-10','13:50:00',4.74),('15087','2013-06-10','13:55:00',4.54),('15087','2013-06-10','14:00:00',4.3),('15087','2013-06-10','14:05:00',5.19),('15087','2013-06-10','14:10:00',4.13),('15087','2013-06-10','14:15:00',5.02),('15087','2013-06-10','14:20:00',4.9),('15087','2013-06-10','14:25:00',4.83),('15087','2013-06-10','14:30:00',4.71),('15087','2013-06-10','14:35:00',4.7),('15087','2013-06-10','14:40:00',4.21),('15087','2013-06-10','14:45:00',4.44),('15087','2013-06-10','14:50:00',4.29),('15087','2013-06-10','14:55:00',4.51),('15087','2013-06-10','15:00:00',4.47),('15087','2013-06-10','15:05:00',4.34),('15087','2013-06-10','15:10:00',4.32),('15087','2013-06-10','15:15:00',4.3),('15087','2013-06-10','15:20:00',4.26),('15087','2013-06-10','15:25:00',4.21),('15087','2013-06-10','15:30:00',4.04),('15087','2013-06-10','15:35:00',3.9),('15087','2013-06-10','15:40:00',4.02),('15087','2013-06-10','15:45:00',3.95),('15087','2013-06-10','15:50:00',3.88),('15087','2013-06-10','15:55:00',3.8),('15087','2013-06-10','16:00:00',3.78),('15087','2013-06-10','16:05:00',3.56),('15087','2013-06-10','16:10:00',3.68),('15087','2013-06-10','16:15:00',3.59),('15087','2013-06-10','16:20:00',3.5),('15087','2013-06-10','16:25:00',3.53),('15087','2013-06-10','16:30:00',3.36),('15087','2013-06-10','16:35:00',3.3),('15087','2013-06-10','16:40:00',3.23),('15087','2013-06-10','16:45:00',3.22),('15087','2013-06-10','16:50:00',3.22),('15087','2013-06-10','16:55:00',3.13),('15087','2013-06-10','17:00:00',3.05),('15087','2013-06-10','17:05:00',2.93),('15087','2013-06-10','17:10:00',2.84),('15087','2013-06-10','17:15:00',2.81),('15087','2013-06-10','17:20:00',2.74),('15087','2013-06-10','17:25:00',2.64),('15087','2013-06-10','17:30:00',2.48),('15087','2013-06-10','17:35:00',2.39),('15087','2013-06-10','17:40:00',2.23),('15087','2013-06-10','17:45:00',2.08),('15087','2013-06-10','17:50:00',1.96),('15087','2013-06-10','17:55:00',1.89),('15087','2013-06-10','18:00:00',1.78),('15087','2013-06-10','18:05:00',1.62),('15087','2013-06-10','18:10:00',1.54),('15087','2013-06-10','18:15:00',1.41),('15087','2013-06-10','18:20:00',1.31),('15087','2013-06-10','18:25:00',1.22),('15087','2013-06-10','18:30:00',1.11),('15087','2013-06-10','18:35:00',1.05),('15087','2013-06-09','07:35:00',1.37),('15087','2013-06-09','07:40:00',1.17),('15087','2013-06-09','07:50:00',1.13),('15087','2013-06-09','07:55:00',1.47),('15087','2013-06-09','08:00:00',1.65),('15087','2013-06-09','08:05:00',1.75),('15087','2013-06-09','08:10:00',1.76),('15087','2013-06-09','08:15:00',1.18),('15087','2013-06-09','08:20:00',1.3),('15087','2013-06-09','08:25:00',2.16),('15087','2013-06-09','08:30:00',2.28),('15087','2013-06-09','08:35:00',2.36),('15087','2013-06-09','08:40:00',2.41),('15087','2013-06-09','08:45:00',2.45),('15087','2013-06-09','08:50:00',2.58),('15087','2013-06-09','08:55:00',2.66),('15087','2013-06-09','09:00:00',2.74),('15087','2013-06-09','09:05:00',2.79),('15087','2013-06-09','09:10:00',2.87),('15087','2013-06-09','09:15:00',2.97),('15087','2013-06-09','09:20:00',3.02),('15087','2013-06-09','09:25:00',3.09),('15087','2013-06-09','09:30:00',3.19),('15087','2013-06-09','09:35:00',3.25),('15087','2013-06-09','09:40:00',3.23),('15087','2013-06-09','09:45:00',3.27),('15087','2013-06-09','09:50:00',3.45),('15087','2013-06-09','09:55:00',3.51),('15087','2013-06-09','10:00:00',3.57),('15087','2013-06-09','10:05:00',3.6),('15087','2013-06-09','10:10:00',3.66),('15087','2013-06-09','10:15:00',3.69),('15087','2013-06-09','10:20:00',3.7),('15087','2013-06-09','10:25:00',3.76),('15087','2013-06-09','10:30:00',3.85),('15087','2013-06-09','10:35:00',3.85),('15087','2013-06-09','10:40:00',3.96),('15087','2013-06-09','10:45:00',3.97),('15087','2013-06-09','10:50:00',4.02),('15087','2013-06-09','10:55:00',4.03),('15087','2013-06-09','11:00:00',4.02),('15087','2013-06-09','11:05:00',4.02),('15087','2013-06-09','11:10:00',4.1),('15087','2013-06-09','11:15:00',4.2),('15087','2013-06-09','11:20:00',4.2),('15087','2013-06-09','11:25:00',4.18),('15087','2013-06-09','11:30:00',4.25),('15087','2013-06-09','11:35:00',4.3),('15087','2013-06-09','11:40:00',4.34),('15087','2013-06-09','11:45:00',4.45),('15087','2013-06-09','11:50:00',4.41),('15087','2013-06-09','11:55:00',4.38),('15087','2013-06-09','12:00:00',4.38),('15087','2013-06-09','12:05:00',4.44),('15087','2013-06-09','12:10:00',3.74),('15087','2013-06-09','12:15:00',4.42),('15087','2013-06-09','12:20:00',4.49),('15087','2013-06-09','12:25:00',4.45),('15087','2013-06-09','12:30:00',4.52),('15087','2013-06-09','12:35:00',4.43),('15087','2013-06-09','12:40:00',4.51),('15087','2013-06-09','12:45:00',4.41),('15087','2013-06-09','12:50:00',4.68),('15087','2013-06-09','12:55:00',4),('15087','2013-06-09','13:00:00',4.56),('15087','2013-06-09','13:05:00',3.81),('15087','2013-06-09','13:10:00',2.02),('15087','2013-06-09','13:15:00',2.74),('15087','2013-06-09','13:20:00',3.35),('15087','2013-06-09','13:25:00',5.05),('15087','2013-06-09','13:30:00',4.78),('15087','2013-06-09','13:35:00',4.84),('15087','2013-06-09','13:40:00',4.98),('15087','2013-06-09','13:45:00',4.98),('15087','2013-06-09','13:50:00',5.17),('15087','2013-06-09','13:55:00',4.3),('15087','2013-06-09','14:00:00',5.18),('15087','2013-06-09','14:05:00',4.77),('15087','2013-06-09','14:10:00',4.76),('15087','2013-06-09','14:15:00',3.04),('15087','2013-06-09','14:20:00',1.95),('15087','2013-06-09','14:25:00',1.2),('15087','2013-06-09','14:30:00',1.67),('15087','2013-06-09','14:35:00',4.26),('15087','2013-06-09','14:40:00',4.4),('15087','2013-06-09','14:45:00',4.25),('15087','2013-06-09','14:50:00',4.38),('15087','2013-06-09','14:55:00',4.47),('15087','2013-06-09','15:00:00',4.34),('15087','2013-06-09','15:05:00',4.08),('15087','2013-06-09','15:10:00',3.97),('15087','2013-06-09','15:15:00',3.63),('15087','2013-06-09','15:20:00',3.82),('15087','2013-06-09','15:25:00',3.99),('15087','2013-06-09','15:30:00',3.75),('15087','2013-06-09','15:35:00',3.87),('15087','2013-06-09','15:40:00',3.08),('15087','2013-06-09','15:45:00',3.22),('15087','2013-06-09','15:50:00',3.62),('15087','2013-06-09','15:55:00',3.77),('15087','2013-06-09','16:00:00',2.54),('15087','2013-06-09','16:05:00',3.51),('15087','2013-06-09','16:10:00',3.51),('15087','2013-06-09','16:15:00',1.55),('15087','2013-06-09','16:20:00',1.67),('15087','2013-06-09','16:25:00',2.43),('15087','2013-06-09','16:30:00',1.42),('15087','2013-06-09','17:05:00',1.01),('15087','2013-06-09','18:00:00',1.04),('15087','2013-06-09','18:10:00',1.36),('15087','2013-06-08','07:25:00',1.03),('15087','2013-06-08','07:30:00',1.11),('15087','2013-06-08','07:35:00',1.19),('15087','2013-06-08','07:40:00',1.27),('15087','2013-06-08','07:45:00',1.36),('15087','2013-06-08','07:50:00',1.43),('15087','2013-06-08','07:55:00',1.5),('15087','2013-06-08','08:00:00',1.59),('15087','2013-06-08','08:05:00',1.69),('15087','2013-06-08','08:10:00',1.79),('15087','2013-06-08','08:15:00',1.88),('15087','2013-06-08','08:20:00',2),('15087','2013-06-08','08:25:00',2.11),('15087','2013-06-08','08:30:00',2.18),('15087','2013-06-08','08:35:00',2.29),('15087','2013-06-08','08:40:00',2.4),('15087','2013-06-08','08:45:00',2.5),('15087','2013-06-08','08:50:00',2.61),('15087','2013-06-08','08:55:00',2.68),('15087','2013-06-08','09:00:00',2.74),('15087','2013-06-08','09:05:00',2.81),('15087','2013-06-08','09:10:00',2.87),('15087','2013-06-08','09:15:00',2.91),('15087','2013-06-08','09:20:00',3.02),('15087','2013-06-08','09:25:00',3.08),('15087','2013-06-08','09:30:00',3.15),('15087','2013-06-08','09:35:00',3.23),('15087','2013-06-08','09:40:00',3.28),('15087','2013-06-08','09:45:00',3.36),('15087','2013-06-08','09:50:00',3.44),('15087','2013-06-08','09:55:00',3.56),('15087','2013-06-08','10:00:00',3.57),('15087','2013-06-08','10:05:00',3.07),('15087','2013-06-08','10:10:00',3.14),('15087','2013-06-08','10:15:00',3.12),('15087','2013-06-08','10:20:00',3.79),('15087','2013-06-08','10:25:00',3.76),('15087','2013-06-08','10:30:00',3.62),('15087','2013-06-08','10:35:00',3.93),('15087','2013-06-08','10:40:00',4.07),('15087','2013-06-08','10:45:00',4.12),('15087','2013-06-08','10:50:00',4.25),('15087','2013-06-08','10:55:00',1.92),('15087','2013-06-08','11:00:00',1.58),('15087','2013-06-08','11:05:00',3.91),('15087','2013-06-08','11:10:00',3.71),('15087','2013-06-08','11:15:00',4.94),('15087','2013-06-08','11:20:00',4.42),('15087','2013-06-08','11:25:00',2.04),('15087','2013-06-08','11:30:00',1.12),('15087','2013-06-08','11:35:00',3.98),('15087','2013-06-08','11:40:00',4.91),('15087','2013-06-08','11:45:00',1.89),('15087','2013-06-08','11:50:00',4.58),('15087','2013-06-08','11:55:00',5.05),('15087','2013-06-08','12:00:00',4.35),('15087','2013-06-08','12:05:00',1.19),('15087','2013-06-08','12:10:00',3.66),('15087','2013-06-08','12:15:00',4.05),('15087','2013-06-08','12:20:00',1.21),('15087','2013-06-08','12:25:00',3.65),('15087','2013-06-08','12:30:00',1.56),('15087','2013-06-08','12:35:00',4.91),('15087','2013-06-08','12:40:00',4.76),('15087','2013-06-08','12:45:00',4.94),('15087','2013-06-08','12:50:00',4.93),('15087','2013-06-08','12:55:00',4.85),('15087','2013-06-08','13:00:00',4.93),('15087','2013-06-08','13:05:00',4.87),('15087','2013-06-08','13:10:00',4.91),('15087','2013-06-08','13:15:00',4.38),('15087','2013-06-08','13:20:00',4.99),('15087','2013-06-08','13:25:00',4.94),('15087','2013-06-08','13:30:00',5.02),('15087','2013-06-08','13:35:00',4.93),('15087','2013-06-08','13:40:00',4.85),('15087','2013-06-08','13:45:00',4.81),('15087','2013-06-08','13:50:00',4.78),('15087','2013-06-08','13:55:00',4.8),('15087','2013-06-08','14:00:00',4.81),('15087','2013-06-08','14:05:00',4.79),('15087','2013-06-08','14:10:00',4.79),('15087','2013-06-08','14:15:00',4.78),('15087','2013-06-08','14:20:00',4.72),('15087','2013-06-08','14:25:00',4.68),('15087','2013-06-08','14:30:00',4.64),('15087','2013-06-08','14:35:00',4.62),('15087','2013-06-08','14:40:00',4.51),('15087','2013-06-08','14:45:00',4.26),('15087','2013-06-08','14:50:00',4.42),('15087','2013-06-08','14:55:00',4.48),('15087','2013-06-08','15:00:00',4.41),('15087','2013-06-08','15:05:00',4.17),('15087','2013-06-08','15:10:00',3.81),('15087','2013-06-08','15:15:00',4.03),('15087','2013-06-08','15:20:00',4.19),('15087','2013-06-08','15:25:00',3.9),('15087','2013-06-08','15:30:00',3.85),('15087','2013-06-08','15:35:00',3.81),('15087','2013-06-08','15:40:00',3.84),('15087','2013-06-08','15:45:00',4.05),('15087','2013-06-08','15:50:00',4.02),('15087','2013-06-08','15:55:00',3.68),('15087','2013-06-08','16:00:00',3.81),('15087','2013-06-08','16:05:00',3.7),('15087','2013-06-08','16:10:00',3.8),('15087','2013-06-08','16:15:00',3.75),('15087','2013-06-08','16:20:00',3.68),('15087','2013-06-08','16:25:00',3.53),('15087','2013-06-08','16:30:00',3.29),('15087','2013-06-08','16:35:00',3.23),('15087','2013-06-08','16:40:00',3.03),('15087','2013-06-08','16:45:00',3.09),('15087','2013-06-08','16:50:00',2.66),('15087','2013-06-08','16:55:00',2.73),('15087','2013-06-08','17:00:00',3.01),('15087','2013-06-08','17:05:00',2.83),('15087','2013-06-08','17:10:00',3.1),('15087','2013-06-08','17:15:00',3.06),('15087','2013-06-08','17:20:00',2.9),('15087','2013-06-08','17:25:00',2.71),('15087','2013-06-08','17:30:00',1.83),('15087','2013-06-08','17:35:00',1.36),('15087','2013-06-08','17:40:00',2.17),('15087','2013-06-08','17:45:00',2.18),('15087','2013-06-08','17:50:00',1.98),('15087','2013-06-08','17:55:00',1.9),('15087','2013-06-08','18:00:00',1.47),('15087','2013-06-08','18:05:00',1.27),('15087','2013-06-08','18:10:00',1.11),('15087','2013-06-08','18:15:00',1.14),('15087','2013-06-08','18:20:00',1.11),('15087','2013-06-08','18:25:00',1.02),('15087','2013-06-07','07:25:00',1.06),('15087','2013-06-07','07:30:00',1.15),('15087','2013-06-07','07:35:00',1.25),('15087','2013-06-07','07:40:00',1.34),('15087','2013-06-07','07:45:00',1.44),('15087','2013-06-07','07:50:00',1.53),('15087','2013-06-07','07:55:00',1.62),('15087','2013-06-07','08:00:00',1.72),('15087','2013-06-07','08:05:00',1.86),('15087','2013-06-07','08:10:00',1.94),('15087','2013-06-07','08:15:00',2.04),('15087','2013-06-07','08:20:00',2.16),('15087','2013-06-07','08:25:00',2.28),('15087','2013-06-07','08:30:00',2.38),('15087','2013-06-07','08:35:00',2.46),('15087','2013-06-07','08:40:00',2.57),('15087','2013-06-07','08:45:00',2.67),('15087','2013-06-07','08:50:00',2.75),('15087','2013-06-07','08:55:00',2.84),('15087','2013-06-07','09:00:00',2.92),('15087','2013-06-07','09:05:00',2.99),('15087','2013-06-07','09:10:00',3.07),('15087','2013-06-07','09:15:00',3.09),('15087','2013-06-07','09:20:00',3.22),('15087','2013-06-07','09:25:00',3.31),('15087','2013-06-07','09:30:00',3.37),('15087','2013-06-07','09:35:00',3.44),('15087','2013-06-07','09:40:00',3.54),('15087','2013-06-07','09:45:00',3.63),('15087','2013-06-07','09:50:00',3.69),('15087','2013-06-07','09:55:00',3.76),('15087','2013-06-07','10:00:00',3.83),('15087','2013-06-07','10:05:00',3.88),('15087','2013-06-07','10:10:00',3.94),('15087','2013-06-07','10:15:00',3.99),('15087','2013-06-07','10:20:00',4.05),('15087','2013-06-07','10:25:00',4.1),('15087','2013-06-07','10:30:00',4.15),('15087','2013-06-07','10:35:00',4.2),('15087','2013-06-07','10:40:00',4.25),('15087','2013-06-07','10:45:00',4.29),('15087','2013-06-07','10:50:00',4.34),('15087','2013-06-07','10:55:00',4.37),('15087','2013-06-07','11:00:00',4.42),('15087','2013-06-07','11:05:00',4.47),('15087','2013-06-07','11:10:00',4.52),('15087','2013-06-07','11:15:00',4.55),('15087','2013-06-07','11:20:00',4.55),('15087','2013-06-07','11:25:00',4.59),('15087','2013-06-07','11:30:00',4.64),('15087','2013-06-07','11:35:00',4.62),('15087','2013-06-07','11:40:00',4.69),('15087','2013-06-07','11:45:00',4.73),('15087','2013-06-07','11:50:00',4.75),('15087','2013-06-07','11:55:00',4.78),('15087','2013-06-07','12:00:00',4.8),('15087','2013-06-07','12:05:00',4.82),('15087','2013-06-07','12:10:00',4.85),('15087','2013-06-07','12:15:00',4.86),('15087','2013-06-07','12:20:00',4.86),('15087','2013-06-07','12:25:00',4.85),('15087','2013-06-07','12:30:00',4.86),('15087','2013-06-07','12:35:00',4.86),('15087','2013-06-07','12:40:00',4.86),('15087','2013-06-07','12:45:00',4.9),('15087','2013-06-07','12:50:00',4.89),('15087','2013-06-07','12:55:00',4.87),('15087','2013-06-07','13:00:00',4.87),('15087','2013-06-07','13:05:00',4.87),('15087','2013-06-07','13:10:00',4.87),('15087','2013-06-07','13:15:00',4.87),('15087','2013-06-07','13:20:00',4.83),('15087','2013-06-07','13:25:00',4.81),('15087','2013-06-07','13:30:00',4.82),('15087','2013-06-07','13:35:00',4.82),('15087','2013-06-07','13:40:00',4.73),('15087','2013-06-07','13:45:00',4.71),('15087','2013-06-07','13:50:00',4.64),('15087','2013-06-07','13:55:00',4.68),('15087','2013-06-07','14:00:00',4.64),('15087','2013-06-07','14:05:00',4.62),('15087','2013-06-07','14:10:00',4.64),('15087','2013-06-07','14:15:00',4.61),('15087','2013-06-07','14:20:00',4.49),('15087','2013-06-07','14:25:00',4.47),('15087','2013-06-07','14:30:00',4.41),('15087','2013-06-07','14:35:00',4.35),('15087','2013-06-07','14:40:00',4.29),('15087','2013-06-07','14:45:00',4.08),('15087','2013-06-07','14:50:00',4.16),('15087','2013-06-07','14:55:00',4.25),('15087','2013-06-07','15:00:00',4.22),('15087','2013-06-07','15:05:00',4.23),('15087','2013-06-07','15:10:00',4.16),('15087','2013-06-07','15:15:00',4.11),('15087','2013-06-07','15:20:00',4.09),('15087','2013-06-07','15:25:00',4.09),('15087','2013-06-07','15:30:00',3.89),('15087','2013-06-07','15:35:00',3.78),('15087','2013-06-07','15:40:00',3.87),('15087','2013-06-07','15:45:00',3.79),('15087','2013-06-07','15:50:00',3.75),('15087','2013-06-07','15:55:00',3.64),('15087','2013-06-07','16:00:00',3.61),('15087','2013-06-07','16:05:00',3.37),('15087','2013-06-07','16:10:00',3.48),('15087','2013-06-07','16:15:00',3.29),('15087','2013-06-07','16:20:00',3.32),('15087','2013-06-07','16:25:00',3.38),('15087','2013-06-07','16:30:00',3.25),('15087','2013-06-07','16:35:00',3.2),('15087','2013-06-07','16:40:00',3.11),('15087','2013-06-07','16:45:00',3.11),('15087','2013-06-07','16:50:00',3.1),('15087','2013-06-07','16:55:00',3.01),('15087','2013-06-07','17:00:00',2.94),('15087','2013-06-07','17:05:00',2.82),('15087','2013-06-07','17:10:00',2.78),('15087','2013-06-07','17:15:00',2.65),('15087','2013-06-07','17:20:00',2.59),('15087','2013-06-07','17:25:00',2.54),('15087','2013-06-07','17:30:00',2.4),('15087','2013-06-07','17:35:00',2.29),('15087','2013-06-07','17:40:00',2.17),('15087','2013-06-07','17:45:00',2.03),('15087','2013-06-07','17:50:00',1.95),('15087','2013-06-07','17:55:00',1.77),('15087','2013-06-07','18:00:00',1.59),('15087','2013-06-07','18:05:00',1.44),('15087','2013-06-07','18:10:00',1.5),('15087','2013-06-07','18:15:00',1.34),('15087','2013-06-07','18:20:00',1.24),('15087','2013-06-07','18:25:00',1.09),('15087','2013-06-07','18:30:00',1.04),('15087','2013-06-06','07:05:00',1.1),('15087','2013-06-06','07:15:00',1.15),('15087','2013-06-06','07:50:00',1.34),('15087','2013-06-06','07:55:00',1.78),('15087','2013-06-06','08:00:00',1.84),('15087','2013-06-06','08:05:00',1.4),('15087','2013-06-06','08:10:00',1.92),('15087','2013-06-06','08:15:00',1.52),('15087','2013-06-06','08:20:00',1.89),('15087','2013-06-06','08:25:00',2.27),('15087','2013-06-06','08:30:00',2.35),('15087','2013-06-06','08:35:00',2.43),('15087','2013-06-06','08:40:00',2.5),('15087','2013-06-06','08:45:00',2.57),('15087','2013-06-06','08:50:00',2.67),('15087','2013-06-06','08:55:00',2.74),('15087','2013-06-06','09:00:00',2.81),('15087','2013-06-06','09:05:00',2.92),('15087','2013-06-06','09:10:00',2.99),('15087','2013-06-06','09:15:00',3.1),('15087','2013-06-06','09:20:00',3.18),('15087','2013-06-06','09:25:00',3.25),('15087','2013-06-06','09:30:00',3.3),('15087','2013-06-06','09:35:00',3.27),('15087','2013-06-06','09:40:00',3.4),('15087','2013-06-06','09:45:00',3.5),('15087','2013-06-06','09:50:00',3.58),('15087','2013-06-06','09:55:00',3.64),('15087','2013-06-06','10:00:00',3.59),('15087','2013-06-06','10:05:00',3.64),('15087','2013-06-06','10:10:00',3.64),('15087','2013-06-06','10:15:00',3.84),('15087','2013-06-06','10:20:00',3.94),('15087','2013-06-06','10:25:00',3.98),('15087','2013-06-06','10:30:00',4),('15087','2013-06-06','10:35:00',4),('15087','2013-06-06','10:40:00',4.1),('15087','2013-06-06','10:45:00',4.08),('15087','2013-06-06','10:50:00',4.2),('15087','2013-06-06','10:55:00',4.27),('15087','2013-06-06','11:00:00',4.29),('15087','2013-06-06','11:05:00',4.31),('15087','2013-06-06','11:10:00',4.26),('15087','2013-06-06','11:15:00',4.34),('15087','2013-06-06','11:20:00',4.36),('15087','2013-06-06','11:25:00',4.44),('15087','2013-06-06','11:30:00',4.47),('15087','2013-06-06','11:35:00',4.49),('15087','2013-06-06','11:40:00',4.44),('15087','2013-06-06','11:45:00',4.54),('15087','2013-06-06','11:50:00',4.58),('15087','2013-06-06','11:55:00',4.66),('15087','2013-06-06','12:00:00',4.61),('15087','2013-06-06','12:05:00',4.59),('15087','2013-06-06','12:10:00',4.62),('15087','2013-06-06','12:15:00',4.58),('15087','2013-06-06','12:20:00',4.62),('15087','2013-06-06','12:25:00',4.65),('15087','2013-06-06','12:30:00',4.64),('15087','2013-06-06','12:35:00',4.63),('15087','2013-06-06','12:40:00',4.67),('15087','2013-06-06','12:45:00',4.72),('15087','2013-06-06','12:50:00',4.77),('15087','2013-06-06','12:55:00',4.76),('15087','2013-06-06','13:00:00',4.75),('15087','2013-06-06','13:05:00',4.84),('15087','2013-06-06','13:10:00',4.87),('15087','2013-06-06','13:15:00',4.86),('15087','2013-06-06','13:20:00',4.77),('15087','2013-06-06','13:25:00',4.71),('15087','2013-06-06','13:30:00',4.9),('15087','2013-06-06','13:35:00',4.68),('15087','2013-06-06','13:40:00',1),('15087','2013-06-06','13:50:00',1.99),('15087','2013-06-06','13:55:00',4.34),('15087','2013-06-06','14:00:00',4.51),('15087','2013-06-06','14:05:00',1.36),('15087','2013-06-06','14:10:00',2.4),('15087','2013-06-06','14:15:00',3.46),('15087','2013-06-06','14:20:00',3.49),('15087','2013-06-06','14:25:00',3.91),('15087','2013-06-06','14:30:00',4.4),('15087','2013-06-06','14:35:00',4.56),('15087','2013-06-06','14:40:00',4.58),('15087','2013-06-06','14:45:00',4.06),('15087','2013-06-06','14:50:00',4.74),('15087','2013-06-06','14:55:00',4.45),('15087','2013-06-06','15:00:00',4.32),('15087','2013-06-06','15:05:00',4.34),('15087','2013-06-06','15:10:00',4.1),('15087','2013-06-06','15:15:00',3.75),('15087','2013-06-06','15:20:00',4.05),('15087','2013-06-06','15:25:00',3.71),('15087','2013-06-06','15:30:00',3.79),('15087','2013-06-06','15:35:00',3.82),('15087','2013-06-06','15:40:00',3.86),('15087','2013-06-06','15:45:00',3.8),('15087','2013-06-06','15:50:00',3.75),('15087','2013-06-06','15:55:00',3.72),('15087','2013-06-06','16:00:00',3.75),('15087','2013-06-06','16:05:00',3.73),('15087','2013-06-06','16:10:00',3.58),('15087','2013-06-06','16:15:00',3.3),('15087','2013-06-06','16:20:00',3.36),('15087','2013-06-06','16:25:00',3.28),('15087','2013-06-06','16:30:00',3.16),('15087','2013-06-06','16:35:00',3.21),('15087','2013-06-06','16:40:00',3.09),('15087','2013-06-06','16:45:00',3.01),('15087','2013-06-06','16:50:00',2.99),('15087','2013-06-06','16:55:00',2.86),('15087','2013-06-06','17:00:00',2.81),('15087','2013-06-06','17:05:00',2.7),('15087','2013-06-06','17:10:00',2.66),('15087','2013-06-06','17:15:00',2.56),('15087','2013-06-06','17:20:00',2.5),('15087','2013-06-06','17:25:00',2.45),('15087','2013-06-06','17:30:00',2.29),('15087','2013-06-06','17:35:00',2.15),('15087','2013-06-06','17:40:00',2.03),('15087','2013-06-06','17:45:00',1.82),('15087','2013-06-06','17:50:00',1.73),('15087','2013-06-06','17:55:00',1.59),('15087','2013-06-06','18:00:00',1.46),('15087','2013-06-06','18:05:00',1.43),('15087','2013-06-06','18:10:00',1.38),('15087','2013-06-06','18:15:00',1.26),('15087','2013-06-06','18:20:00',1.18),('15087','2013-06-06','18:25:00',1.07),('15087','2013-06-06','18:30:00',1.02),('15087','2013-06-05','07:45:00',1.3),('15087','2013-06-05','07:50:00',1.76),('15087','2013-06-05','07:55:00',2),('15087','2013-06-05','08:00:00',1.92),('15087','2013-06-05','08:05:00',1.64),('15087','2013-06-05','08:10:00',1.88),('15087','2013-06-05','08:15:00',2.03),('15087','2013-06-05','08:20:00',2.12),('15087','2013-06-05','08:25:00',2.25),('15087','2013-06-05','08:30:00',2.33),('15087','2013-06-05','08:35:00',2.41),('15087','2013-06-05','08:40:00',2.5),('15087','2013-06-05','08:45:00',2.59),('15087','2013-06-05','08:50:00',2.64),('15087','2013-06-05','08:55:00',2.77),('15087','2013-06-05','09:00:00',2.81),('15087','2013-06-05','09:05:00',3.02),('15087','2013-06-05','09:10:00',3.13),('15087','2013-06-05','09:15:00',3.2),('15087','2013-06-05','09:20:00',3.29),('15087','2013-06-05','09:25:00',3.55),('15087','2013-06-05','09:30:00',2.69),('15087','2013-06-05','09:35:00',4.11),('15087','2013-06-05','09:40:00',4.07),('15087','2013-06-05','09:45:00',2.05),('15087','2013-06-05','09:50:00',1.4),('15087','2013-06-05','09:55:00',2.73),('15087','2013-06-05','10:00:00',3.79),('15087','2013-06-05','10:05:00',3.54),('15087','2013-06-05','10:10:00',3.69),('15087','2013-06-05','10:15:00',1.84),('15087','2013-06-05','10:20:00',1.97),('15087','2013-06-05','10:25:00',1.54),('15087','2013-06-05','10:30:00',1.6),('15087','2013-06-05','10:35:00',2.24),('15087','2013-06-05','10:40:00',4.7),('15087','2013-06-05','10:45:00',4.78),('15087','2013-06-05','10:50:00',4.69),('15087','2013-06-05','10:55:00',4.37),('15087','2013-06-05','11:00:00',1.87),('15087','2013-06-05','11:05:00',1.49),('15087','2013-06-05','11:10:00',1.19),('15087','2013-06-05','11:15:00',1.18),('15087','2013-06-05','11:20:00',1.12),('15087','2013-06-05','11:25:00',1.17),('15087','2013-06-05','11:30:00',1.42),('15087','2013-06-05','11:35:00',4.32),('15087','2013-06-05','11:40:00',3.87),('15087','2013-06-05','11:45:00',2.37),('15087','2013-06-05','11:50:00',2.9),('15087','2013-06-05','11:55:00',5.21),('15087','2013-06-05','12:00:00',5.24),('15087','2013-06-05','12:05:00',5.19),('15087','2013-06-05','12:10:00',5.23),('15087','2013-06-05','12:15:00',5.2),('15087','2013-06-05','12:20:00',5.47),('15087','2013-06-05','12:25:00',4.86),('15087','2013-06-05','12:30:00',5.07),('15087','2013-06-05','12:35:00',4.07),('15087','2013-06-05','12:40:00',5.38),('15087','2013-06-05','12:45:00',4.98),('15087','2013-06-05','12:50:00',2.13),('15087','2013-06-05','12:55:00',2.8),('15087','2013-06-05','13:00:00',5.15),('15087','2013-06-05','13:05:00',3.11),('15087','2013-06-05','13:10:00',4.73),('15087','2013-06-05','13:15:00',4.12),('15087','2013-06-05','13:20:00',2.55),('15087','2013-06-05','13:25:00',3.1),('15087','2013-06-05','13:30:00',4.79),('15087','2013-06-05','13:35:00',5.38),('15087','2013-06-05','13:40:00',5.01),('15087','2013-06-05','13:45:00',5.08),('15087','2013-06-05','13:50:00',4.99),('15087','2013-06-05','13:55:00',4.98),('15087','2013-06-05','14:00:00',4.89),('15087','2013-06-05','14:05:00',4.93),('15087','2013-06-05','14:10:00',4.89),('15087','2013-06-05','14:15:00',4.84),('15087','2013-06-05','14:20:00',4.77),('15087','2013-06-05','14:25:00',4.74),('15087','2013-06-05','14:30:00',4.06),('15087','2013-06-05','14:35:00',4.72),('15087','2013-06-05','14:40:00',4.52),('15087','2013-06-05','14:45:00',4.34),('15087','2013-06-05','14:50:00',4.34),('15087','2013-06-05','14:55:00',4.52),('15087','2013-06-05','15:00:00',4.39),('15087','2013-06-05','15:05:00',4.26),('15087','2013-06-05','15:10:00',4.3),('15087','2013-06-05','15:15:00',4.26),('15087','2013-06-05','15:20:00',4.21),('15087','2013-06-05','15:25:00',4.16),('15087','2013-06-05','15:30:00',3.99),('15087','2013-06-05','15:35:00',3.89),('15087','2013-06-05','15:40:00',4.02),('15087','2013-06-05','15:45:00',3.97),('15087','2013-06-05','15:50:00',3.89),('15087','2013-06-05','15:55:00',3.82),('15087','2013-06-05','16:00:00',3.74),('15087','2013-06-05','16:05:00',3.56),('15087','2013-06-05','16:10:00',3.6),('15087','2013-06-05','16:15:00',3.66),('15087','2013-06-05','16:20:00',3.57),('15087','2013-06-05','16:25:00',3.49),('15087','2013-06-05','16:30:00',3.32),('15087','2013-06-05','16:35:00',3.29),('15087','2013-06-05','16:40:00',3.18),('15087','2013-06-05','16:45:00',3.18),('15087','2013-06-05','16:50:00',3.14),('15087','2013-06-05','16:55:00',3.11),('15087','2013-06-05','17:00:00',1.35),('15087','2013-06-05','17:05:00',2.39),('15087','2013-06-05','17:10:00',1.81),('15087','2013-06-05','17:15:00',1.96),('15087','2013-06-05','17:20:00',2.17),('15087','2013-06-05','17:25:00',2.08),('15087','2013-06-05','17:30:00',2.03),('15087','2013-06-05','17:35:00',1.74),('15087','2013-06-05','17:40:00',2.26),('15087','2013-06-05','17:45:00',1.95),('15087','2013-06-05','17:50:00',1.82),('15087','2013-06-05','17:55:00',1.69),('15087','2013-06-05','18:00:00',1.5),('15087','2013-06-05','18:10:00',1.08),('15087','2013-06-05','18:25:00',1.2),('15087','2013-06-05','18:30:00',1.13),('15087','2013-06-05','18:35:00',1.13),('15087','2013-06-04','07:25:00',1.07),('15087','2013-06-04','07:30:00',1.17),('15087','2013-06-04','07:35:00',1.27),('15087','2013-06-04','07:40:00',1.47),('15087','2013-06-04','07:45:00',1.74),('15087','2013-06-04','07:50:00',1.95),('15087','2013-06-04','07:55:00',2.09),('15087','2013-06-04','08:00:00',2.33),('15087','2013-06-04','08:05:00',2.49),('15087','2013-06-04','08:10:00',2.52),('15087','2013-06-04','08:15:00',2.56),('15087','2013-06-04','08:20:00',2.55),('15087','2013-06-04','08:25:00',2.52),('15087','2013-06-04','08:30:00',2.79),('15087','2013-06-04','08:35:00',2.38),('15087','2013-06-04','08:40:00',2.19),('15087','2013-06-04','08:45:00',1.9),('15087','2013-06-04','08:50:00',1.52),('15087','2013-06-04','08:55:00',1.52),('15087','2013-06-04','09:00:00',1.83),('15087','2013-06-04','09:05:00',1.88),('15087','2013-06-04','09:10:00',2.72),('15087','2013-06-04','09:15:00',3.48),('15087','2013-06-04','09:20:00',3.73),('15087','2013-06-04','09:25:00',2.72),('15087','2013-06-04','09:30:00',3.6),('15087','2013-06-04','09:35:00',2.47),('15087','2013-06-04','09:40:00',2.29),('15087','2013-06-04','09:45:00',2.28),('15087','2013-06-04','09:50:00',2.12),('15087','2013-06-04','09:55:00',1.96),('15087','2013-06-04','10:00:00',2.24),('15087','2013-06-04','10:05:00',3.07),('15087','2013-06-04','10:10:00',2.61),('15087','2013-06-04','10:15:00',1.96),('15087','2013-06-04','10:20:00',2.13),('15087','2013-06-04','10:25:00',2.05),('15087','2013-06-04','10:30:00',1.82),('15087','2013-06-04','10:35:00',1.85),('15087','2013-06-04','10:40:00',2.12),('15087','2013-06-04','10:45:00',2.58),('15087','2013-06-04','10:50:00',3.31),('15087','2013-06-04','10:55:00',3.08),('15087','2013-06-04','11:00:00',2.51),('15087','2013-06-04','11:05:00',3.15),('15087','2013-06-04','11:10:00',4.13),('15087','2013-06-04','11:15:00',3.52),('15087','2013-06-04','11:20:00',2.56),('15087','2013-06-04','11:25:00',3.19),('15087','2013-06-04','11:30:00',3.67),('15087','2013-06-04','11:35:00',3.3),('15087','2013-06-04','11:40:00',3.64),('15087','2013-06-04','11:45:00',4.23),('15087','2013-06-04','11:50:00',4.88),('15087','2013-06-04','11:55:00',3.9),('15087','2013-06-04','12:00:00',2.72),('15087','2013-06-04','12:05:00',4.17),('15087','2013-06-04','12:10:00',2.95),('15087','2013-06-04','12:15:00',2.53),('15087','2013-06-04','12:20:00',2.16),('15087','2013-06-04','12:25:00',2.58),('15087','2013-06-04','12:30:00',3.51),('15087','2013-06-04','12:35:00',4.14),('15087','2013-06-04','12:40:00',2.65),('15087','2013-06-04','12:45:00',3.16),('15087','2013-06-04','12:50:00',2.19),('15087','2013-06-04','12:55:00',1.84),('15087','2013-06-04','13:00:00',1.81),('15087','2013-06-04','13:05:00',1.59),('15087','2013-06-04','13:10:00',1.54),('15087','2013-06-04','13:15:00',1.18),('15087','2013-06-04','13:20:00',1.23),('15087','2013-06-04','13:25:00',1.5),('15087','2013-06-04','13:30:00',2.45),('15087','2013-06-04','13:35:00',4.41),('15087','2013-06-04','13:40:00',3.59),('15087','2013-06-04','13:45:00',3.06),('15087','2013-06-04','13:50:00',4.53),('15087','2013-06-04','13:55:00',3.57),('15087','2013-06-04','14:00:00',2.5),('15087','2013-06-04','14:05:00',4.31),('15087','2013-06-04','14:10:00',5),('15087','2013-06-04','14:15:00',2.61),('15087','2013-06-04','14:20:00',5.35),('15087','2013-06-04','14:25:00',1.45),('15087','2013-06-04','14:30:00',1.24),('15087','2013-06-04','14:35:00',1.55),('15087','2013-06-04','14:40:00',2.74),('15087','2013-06-04','14:45:00',1.35),('15087','2013-06-04','14:50:00',1.41),('15087','2013-06-04','14:55:00',3.55),('15087','2013-06-04','15:00:00',5.41),('15087','2013-06-04','15:05:00',2.63),('15087','2013-06-04','15:10:00',1.75),('15087','2013-06-04','15:15:00',2.16),('15087','2013-06-04','15:20:00',1.19),('15087','2013-06-03','07:40:00',1.33),('15087','2013-06-03','07:45:00',1.4),('15087','2013-06-03','07:50:00',1.63),('15087','2013-06-03','07:55:00',1.71),('15087','2013-06-03','08:00:00',1.82),('15087','2013-06-03','08:05:00',1.88),('15087','2013-06-03','08:10:00',1.97),('15087','2013-06-03','08:15:00',2.07),('15087','2013-06-03','08:20:00',2.15),('15087','2013-06-03','08:25:00',2.26),('15087','2013-06-03','08:30:00',2.34),('15087','2013-06-03','08:35:00',2.41),('15087','2013-06-03','08:40:00',2.51),('15087','2013-06-03','08:45:00',2.58),('15087','2013-06-03','08:50:00',2.63),('15087','2013-06-03','08:55:00',2.74),('15087','2013-06-03','09:00:00',2.88),('15087','2013-06-03','09:05:00',2.97),('15087','2013-06-03','09:10:00',3.1),('15087','2013-06-03','09:15:00',3.42),('15087','2013-06-03','09:20:00',2.68),('15087','2013-06-03','09:25:00',2.48),('15087','2013-06-03','09:30:00',1.93),('15087','2013-06-03','09:35:00',1.99),('15087','2013-06-03','09:40:00',3),('15087','2013-06-03','09:45:00',3.86),('15087','2013-06-03','09:50:00',3.7),('15087','2013-06-03','09:55:00',3.98),('15087','2013-06-03','10:00:00',4.09),('15087','2013-06-03','10:05:00',4.03),('15087','2013-06-03','10:10:00',3.05),('15087','2013-06-03','10:15:00',1.25),('15087','2013-06-03','10:30:00',1.09),('15087','2013-06-03','10:35:00',1.25),('15087','2013-06-03','10:40:00',1.41),('15087','2013-06-03','10:45:00',2.44),('15087','2013-06-03','10:50:00',4.24),('15087','2013-06-03','10:55:00',3.46),('15087','2013-06-03','11:00:00',4.32),('15087','2013-06-03','11:05:00',3.3),('15087','2013-06-03','11:10:00',1.65),('15087','2013-06-03','11:15:00',1.46),('15087','2013-06-03','11:20:00',1.79),('15087','2013-06-03','11:25:00',1.77),('15087','2013-06-03','11:30:00',2.61),('15087','2013-06-03','11:35:00',1.49),('15087','2013-06-03','11:40:00',1.51),('15087','2013-06-03','11:45:00',1.56),('15087','2013-06-03','11:50:00',1.75),('15087','2013-06-03','11:55:00',1.79),('15087','2013-06-03','12:00:00',1.9),('15087','2013-06-03','12:05:00',1.37),('15087','2013-06-03','12:10:00',1.93),('15087','2013-06-03','12:15:00',1.37),('15087','2013-06-03','12:20:00',1.49),('15087','2013-06-03','12:25:00',1.28),('15087','2013-06-03','12:30:00',1.47),('15087','2013-06-03','12:35:00',2.64),('15087','2013-06-03','12:40:00',5.02),('15087','2013-06-03','12:45:00',3.59),('15087','2013-06-03','12:50:00',2.46),('15087','2013-06-03','12:55:00',4.03),('15087','2013-06-03','13:00:00',3.17),('15087','2013-06-03','13:05:00',2.42),('15087','2013-06-03','13:10:00',2.4),('15087','2013-06-03','13:15:00',4.9),('15087','2013-06-03','13:20:00',5.56),('15087','2013-06-03','13:25:00',5.57),('15087','2013-06-03','13:30:00',4.43),('15087','2013-06-03','13:35:00',5.4),('15087','2013-06-03','13:40:00',5.16),('15087','2013-06-03','13:45:00',4.87),('15087','2013-06-03','13:50:00',4.78),('15087','2013-06-03','13:55:00',2.18),('15087','2013-06-03','14:00:00',3.12),('15087','2013-06-03','14:05:00',3.74),('15087','2013-06-03','14:10:00',2.64),('15087','2013-06-03','14:15:00',3.02),('15087','2013-06-03','14:20:00',3.25),('15087','2013-06-03','14:25:00',2.88),('15087','2013-06-03','14:30:00',5.29),('15087','2013-06-03','14:35:00',5.23),('15087','2013-06-03','14:40:00',3.76),('15087','2013-06-03','14:45:00',3.26),('15087','2013-06-03','14:50:00',2.84),('15087','2013-06-03','14:55:00',3.92),('15087','2013-06-03','15:00:00',4.21),('15087','2013-06-03','15:05:00',4.52),('15087','2013-06-03','15:10:00',4.11),('15087','2013-06-03','15:15:00',4.79),('15087','2013-06-03','15:20:00',3.39),('15087','2013-06-03','15:25:00',4.22),('15087','2013-06-03','15:30:00',4.13),('15087','2013-06-03','15:35:00',4.1),('15087','2013-06-03','15:40:00',4),('15087','2013-06-03','15:45:00',3.91),('15087','2013-06-03','15:50:00',3.89),('15087','2013-06-03','15:55:00',3.82),('15087','2013-06-03','16:00:00',3.66),('15087','2013-06-03','16:05:00',3.58),('15087','2013-06-03','16:10:00',3.74),('15087','2013-06-03','16:15:00',3.63),('15087','2013-06-03','16:20:00',3.35),('15087','2013-06-03','16:25:00',3.59),('15087','2013-06-03','16:30:00',3.63),('15087','2013-06-03','16:35:00',3.52),('15087','2013-06-03','16:40:00',3.5),('15087','2013-06-03','16:45:00',3.02),('15087','2013-06-03','16:50:00',2.55),('15087','2013-06-03','16:55:00',2.13),('15087','2013-06-03','17:00:00',2.88),('15087','2013-06-03','17:05:00',3.41),('15087','2013-06-03','17:10:00',3.12),('15087','2013-06-03','17:15:00',2.72),('15087','2013-06-03','17:20:00',2.41),('15087','2013-06-03','17:25:00',1.68),('15087','2013-06-02','06:55:00',1.1),('15087','2013-06-02','08:45:00',1.06),('15087','2013-06-02','08:50:00',1.09),('15087','2013-06-02','09:05:00',1.04),('15087','2013-06-02','09:10:00',1.15),('15087','2013-06-02','09:15:00',1.42),('15087','2013-06-02','09:20:00',2.48),('15087','2013-06-02','09:25:00',3.75),('15087','2013-06-02','09:30:00',3.6),('15087','2013-06-02','09:35:00',3.58),('15087','2013-06-02','09:40:00',3.57),('15087','2013-06-02','09:45:00',3.57),('15087','2013-06-02','09:50:00',3.66),('15087','2013-06-02','09:55:00',3.71),('15087','2013-06-02','10:00:00',3.81),('15087','2013-06-02','10:05:00',3.85),('15087','2013-06-02','10:10:00',3.92),('15087','2013-06-02','10:15:00',3.99),('15087','2013-06-02','10:20:00',4.04),('15087','2013-06-02','10:25:00',3.5),('15087','2013-06-02','10:30:00',4.07),('15087','2013-06-02','10:35:00',1.36),('15087','2013-06-02','10:40:00',1.46),('15087','2013-06-02','10:45:00',4.31),('15087','2013-06-02','10:50:00',4.69),('15087','2013-06-02','10:55:00',4.92),('15087','2013-06-02','11:00:00',5.07),('15087','2013-06-02','11:05:00',4.47),('15087','2013-06-02','11:10:00',1.48),('15087','2013-06-02','11:15:00',4.35),('15087','2013-06-02','11:20:00',4.99),('15087','2013-06-02','11:25:00',4.09),('15087','2013-06-02','11:30:00',1.94),('15087','2013-06-02','11:35:00',2.54),('15087','2013-06-02','11:40:00',2.29),('15087','2013-06-02','11:45:00',1.87),('15087','2013-06-02','11:50:00',1.68),('15087','2013-06-02','11:55:00',3.47),('15087','2013-06-02','12:00:00',1.75),('15087','2013-06-02','12:05:00',1.49),('15087','2013-06-02','12:10:00',3.64),('15087','2013-06-02','12:15:00',2.55),('15087','2013-06-02','12:20:00',2.72),('15087','2013-06-02','12:25:00',3.96),('15087','2013-06-02','12:30:00',3.76),('15087','2013-06-02','12:35:00',3.46),('15087','2013-06-02','12:40:00',4.34),('15087','2013-06-02','12:45:00',3.48),('15087','2013-06-02','12:50:00',2.54),('15087','2013-06-02','12:55:00',4.17),('15087','2013-06-02','13:00:00',3.17),('15087','2013-06-02','13:05:00',3.27),('15087','2013-06-02','13:10:00',5.06),('15087','2013-06-02','13:15:00',5.21),('15087','2013-06-02','13:20:00',5.05),('15087','2013-06-02','13:25:00',5.01),('15087','2013-06-02','13:30:00',4.97),('15087','2013-06-02','13:35:00',4.94),('15087','2013-06-02','13:40:00',4.93),('15087','2013-06-02','13:45:00',4.91),('15087','2013-06-02','13:50:00',4.88),('15087','2013-06-02','13:55:00',4.89),('15087','2013-06-02','14:00:00',4.88),('15087','2013-06-02','14:05:00',4.84),('15087','2013-06-02','14:10:00',4.87),('15087','2013-06-02','14:15:00',4.78),('15087','2013-06-02','14:20:00',4.76),('15087','2013-06-02','14:25:00',4.77),('15087','2013-06-02','14:30:00',4.75),('15087','2013-06-02','14:35:00',4.63),('15087','2013-06-02','14:40:00',4.6),('15087','2013-06-02','14:45:00',4.56),('15087','2013-06-02','14:50:00',4.54),('15087','2013-06-02','14:55:00',4.46),('15087','2013-06-02','15:00:00',4.33),('15087','2013-06-02','15:05:00',4.11),('15087','2013-06-02','15:10:00',4.28),('15087','2013-06-02','15:15:00',4.28),('15087','2013-06-02','15:20:00',2.62),('15087','2013-06-02','15:25:00',4.03),('15087','2013-06-02','15:30:00',3.45),('15087','2013-06-02','15:35:00',3.18),('15087','2013-06-02','15:40:00',3.33),('15087','2013-06-02','15:45:00',3.2),('15087','2013-06-02','15:50:00',3.07),('15087','2013-06-02','15:55:00',4.03),('15087','2013-06-02','16:00:00',3.69),('15087','2013-06-02','16:05:00',3.62),('15087','2013-06-02','16:10:00',3.62),('15087','2013-06-02','16:15:00',3.69),('15087','2013-06-02','16:20:00',3.25),('15087','2013-06-02','16:25:00',3.57),('15087','2013-06-02','16:30:00',3.36),('15087','2013-06-02','16:35:00',3.35),('15087','2013-06-02','16:40:00',3.32),('15087','2013-06-02','16:45:00',2.54),('15087','2013-06-02','16:50:00',3.17),('15087','2013-06-02','16:55:00',3.05),('15087','2013-06-02','17:00:00',2.46),('15087','2013-06-02','17:05:00',2.93),('15087','2013-06-02','17:10:00',2.84),('15087','2013-06-02','17:15:00',2.79),('15087','2013-06-02','17:20:00',2.65),('15087','2013-06-02','17:25:00',2.59),('15087','2013-06-02','17:30:00',2.09),('15087','2013-06-02','17:35:00',1.54),('15087','2013-06-02','17:40:00',1.22),('15087','2013-06-02','17:45:00',1.54),('15087','2013-06-02','17:50:00',1.6),('15087','2013-06-01','07:20:00',1.02),('15087','2013-06-01','07:25:00',1.11),('15087','2013-06-01','07:30:00',1.2),('15087','2013-06-01','07:35:00',1.3),('15087','2013-06-01','07:40:00',1.42),('15087','2013-06-01','07:45:00',1.55),('15087','2013-06-01','07:50:00',1.12),('15087','2013-06-01','07:55:00',1.37),('15087','2013-06-01','08:10:00',1.04),('15087','2013-06-01','08:15:00',1.49),('15087','2013-06-01','08:20:00',1.1),('15087','2013-06-01','08:30:00',1.53),('15087','2013-06-01','08:35:00',1.25),('15087','2013-06-01','10:35:00',1.38),('15087','2013-06-01','10:40:00',1.12),('15087','2013-06-01','10:50:00',2.74),('15087','2013-06-01','10:55:00',2.89),('15087','2013-06-01','11:50:00',1.56),('15087','2013-06-01','11:55:00',1.97),('15087','2013-06-01','12:00:00',3.98),('15087','2013-06-01','12:05:00',2.87),('15087','2013-06-01','12:10:00',3.27),('15087','2013-06-01','12:15:00',1.37),('15087','2013-06-01','12:20:00',1.06),('15087','2013-06-01','12:25:00',1.3),('15087','2013-06-01','12:30:00',1.18),('15087','2013-06-01','12:40:00',1.22),('15087','2013-06-01','12:45:00',2.03),('15087','2013-06-01','12:50:00',2.18),('15087','2013-06-01','12:55:00',2.31),('15087','2013-06-01','13:00:00',2.46),('15087','2013-06-01','13:05:00',2.57),('15087','2013-06-01','13:10:00',2.72),('15087','2013-06-01','13:15:00',2.89),('15087','2013-06-01','13:20:00',2.41),('15087','2013-06-01','13:25:00',2.05),('15087','2013-06-01','13:30:00',1.7),('15087','2013-06-01','13:35:00',1.27),('15087','2013-06-01','13:40:00',1.11),('15087','2013-06-01','13:45:00',1.23),('15087','2013-06-01','13:50:00',1.41),('15087','2013-06-01','13:55:00',1.67),('15087','2013-06-01','14:00:00',2.39),('15087','2013-06-01','14:05:00',2.63),('15087','2013-06-01','14:10:00',2.58),('15087','2013-06-01','14:15:00',2.95),('15087','2013-06-01','14:20:00',2.68),('15087','2013-06-01','14:25:00',1.75),('15087','2013-06-01','14:30:00',1.43),('15087','2013-06-01','14:35:00',1.44),('15087','2013-06-01','14:40:00',1.33),('15087','2013-06-01','14:45:00',1.25),('15087','2013-06-01','14:50:00',1.16),('15087','2013-06-01','18:30:00',1.01),('15087','2013-06-01','18:35:00',1.04),('15087','2013-06-01','19:00:00',1.39),('15087','2014-04-02','08:50:00',1.29),('15087','2014-04-02','08:55:00',1.41),('15087','2014-04-02','09:15:00',1.07),('15087','2014-04-02','09:50:00',1.61),('15087','2014-04-02','09:55:00',3.06),('15087','2014-04-02','10:00:00',2.5),('15087','2014-04-02','10:05:00',3.29),('15087','2014-04-02','10:10:00',3.71),('15087','2014-04-02','10:15:00',3.29),('15087','2014-04-02','10:20:00',3.03),('15087','2014-04-02','10:25:00',2.53),('15087','2014-04-02','10:30:00',1.39),('15087','2014-04-02','10:35:00',1.27),('15087','2014-04-02','10:40:00',1.38),('15087','2014-04-02','10:45:00',1.48),('15087','2014-04-02','10:50:00',3.5),('15087','2014-04-02','10:55:00',4.23),('15087','2014-04-02','11:00:00',3.22),('15087','2014-04-02','11:05:00',1.73),('15087','2014-04-02','11:10:00',1.31),('15087','2014-04-02','11:15:00',4.09),('15087','2014-04-02','11:20:00',4.17),('15087','2014-04-02','11:25:00',4.71),('15087','2014-04-02','11:30:00',3.8),('15087','2014-04-02','11:35:00',1.3),('15087','2014-04-02','11:40:00',1.21),('15087','2014-04-02','11:45:00',3.19),('15087','2014-04-02','11:50:00',4.59),('15087','2014-04-02','11:55:00',4.71),('15087','2014-04-02','12:00:00',4.75),('15087','2014-04-02','12:05:00',1.83),('15087','2014-04-02','12:10:00',2.21),('15087','2014-04-02','12:15:00',4.64),('15087','2014-04-02','12:20:00',4.39),('15087','2014-04-02','12:25:00',1.77),('15087','2014-04-02','12:30:00',5.14),('15087','2014-04-02','12:35:00',4.24),('15087','2014-04-02','12:40:00',4.81),('15087','2014-04-02','12:45:00',4.37),('15087','2014-04-02','12:50:00',4.96),('15087','2014-04-02','12:55:00',2.09),('15087','2014-04-02','13:00:00',3.37),('15087','2014-04-02','13:05:00',5.14),('15087','2014-04-02','13:10:00',4.4),('15087','2014-04-02','13:15:00',4.8),('15087','2014-04-02','13:20:00',4.78),('15087','2014-04-02','13:25:00',4.74),('15087','2014-04-02','13:30:00',4.77),('15087','2014-04-02','13:35:00',4.42),('15087','2014-04-02','13:40:00',4.78),('15087','2014-04-02','13:45:00',4.57),('15087','2014-04-02','13:50:00',4.58),('15087','2014-04-02','13:55:00',4.45),('15087','2014-04-02','14:00:00',4.31),('15087','2014-04-02','14:05:00',4.4),('15087','2014-04-02','14:10:00',4.4),('15087','2014-04-02','14:15:00',4.24),('15087','2014-04-02','14:20:00',3.95),('15087','2014-04-02','14:25:00',4.3),('15087','2014-04-02','14:30:00',4.22),('15087','2014-04-02','14:35:00',4.06),('15087','2014-04-02','14:40:00',4),('15087','2014-04-02','14:45:00',4.05),('15087','2014-04-02','14:50:00',3.34),('15087','2014-04-02','14:55:00',3.55),('15087','2014-04-02','15:00:00',3.69),('15087','2014-04-02','15:05:00',3.72),('15087','2014-04-02','15:10:00',3.41),('15087','2014-04-02','15:15:00',3.5),('15087','2014-04-02','15:20:00',3.38),('15087','2014-04-02','15:25:00',3.38),('15087','2014-04-02','15:30:00',3.09),('15087','2014-04-02','15:35:00',2.98),('15087','2014-04-02','15:40:00',3.11),('15087','2014-04-02','15:45:00',3.08),('15087','2014-04-02','15:50:00',3.04),('15087','2014-04-02','15:55:00',2.75),('15087','2014-04-02','16:00:00',2.68),('15087','2014-04-02','16:05:00',2.68),('15087','2014-04-02','16:10:00',2.77),('15087','2014-04-02','16:15:00',2.69),('15087','2014-04-02','16:20:00',2.55),('15087','2014-04-02','16:25:00',2.5),('15087','2014-04-02','16:30:00',2.5),('15087','2014-04-02','16:35:00',2.37),('15087','2014-04-02','16:40:00',2.38),('15087','2014-04-02','16:45:00',2.31),('15087','2014-04-02','16:50:00',2.12),('15087','2014-04-02','16:55:00',2.06),('15087','2014-04-02','17:00:00',2.09),('15087','2014-04-02','17:05:00',1.89),('15087','2014-04-02','17:10:00',1.77),('15087','2014-04-02','17:15:00',1.53),('15087','2014-04-02','17:20:00',1.52),('15087','2014-04-02','17:25:00',1.4),('15087','2014-04-02','17:30:00',1.25),('15087','2014-04-02','17:35:00',1.23),('15087','2014-04-02','17:50:00',1.1),('15087','2013-05-31','07:20:00',1.02),('15087','2013-05-31','07:25:00',1.12),('15087','2013-05-31','07:30:00',1.22),('15087','2013-05-31','07:35:00',1.31),('15087','2013-05-31','07:40:00',1.45),('15087','2013-05-31','07:45:00',1.54),('15087','2013-05-31','07:50:00',1.66),('15087','2013-05-31','07:55:00',1.82),('15087','2013-05-31','08:00:00',1.92),('15087','2013-05-31','08:05:00',1.99),('15087','2013-05-31','08:10:00',2.07),('15087','2013-05-31','08:15:00',2.15),('15087','2013-05-31','08:20:00',2.23),('15087','2013-05-31','08:25:00',2.37),('15087','2013-05-31','08:30:00',2.04),('15087','2013-05-31','08:35:00',2.66),('15087','2013-05-31','08:40:00',1.33),('15087','2013-05-31','08:45:00',1.94),('15087','2013-05-31','08:50:00',2.76),('15087','2013-05-31','08:55:00',1.14),('15087','2013-05-31','09:10:00',1.08),('15087','2013-05-31','09:15:00',1.48),('15087','2013-05-31','09:25:00',1),('15087','2013-05-31','09:30:00',1.88),('15087','2013-05-31','09:35:00',2.33),('15087','2013-05-31','09:40:00',3.08),('15087','2013-05-31','09:45:00',3.77),('15087','2013-05-31','09:50:00',4.05),('15087','2013-05-31','09:55:00',3.71),('15087','2013-05-31','10:00:00',4.15),('15087','2013-05-31','10:05:00',2.88),('15087','2013-05-31','10:10:00',2.14),('15087','2013-05-31','10:15:00',3.54),('15087','2013-05-31','10:20:00',4.04),('15087','2013-05-31','10:25:00',1.69),('15087','2013-05-31','10:30:00',3),('15087','2013-05-31','10:35:00',2.19),('15087','2013-05-31','10:40:00',4.56),('15087','2013-05-31','10:45:00',4.68),('15087','2013-05-31','10:50:00',2.09),('15087','2013-05-31','10:55:00',4.08),('15087','2013-05-31','11:00:00',1.61),('15087','2013-05-31','11:05:00',2.61),('15087','2013-05-31','11:10:00',5.44),('15087','2013-05-31','11:15:00',4.43),('15087','2013-05-31','11:20:00',1.32),('15087','2013-05-31','11:25:00',3.18),('15087','2013-05-31','11:30:00',3.44),('15087','2013-05-31','11:35:00',2.65),('15087','2013-05-31','11:45:00',5),('15087','2013-05-31','11:50:00',3.41),('15087','2013-05-31','11:55:00',3.74),('15087','2013-05-31','12:00:00',1.75),('15087','2013-05-31','12:05:00',5.58),('15087','2013-05-31','12:10:00',3.7),('15087','2013-05-31','12:15:00',1.74),('15087','2013-05-31','12:20:00',1.98),('15087','2013-05-31','12:25:00',3.93),('15087','2013-05-31','12:30:00',1.83),('15087','2013-05-31','12:35:00',2.57),('15087','2013-05-31','12:40:00',4.76),('15087','2013-05-31','12:45:00',1.98),('15087','2013-05-31','12:55:00',1.66),('15087','2013-05-31','13:00:00',5.66),('15087','2013-05-31','13:05:00',1.74),('15087','2013-05-31','13:20:00',1.35),('15087','2013-05-31','13:25:00',2.08),('15087','2013-05-31','13:30:00',4.24),('15087','2013-05-31','13:35:00',5.08),('15087','2013-05-31','13:40:00',2.72),('15087','2013-05-31','13:45:00',1.39),('15087','2013-05-31','13:55:00',1.6),('15087','2013-05-31','14:00:00',2.05),('15087','2013-05-31','14:25:00',1.07),('15087','2013-05-31','15:00:00',1.08),('15087','2013-05-31','15:05:00',1.69),('15087','2013-05-31','15:10:00',2.04),('15087','2013-05-31','15:15:00',3.34),('15087','2013-05-31','15:20:00',5.28),('15087','2013-05-31','15:25:00',3.76),('15087','2013-05-31','15:30:00',2.68),('15087','2013-05-31','15:35:00',2.27),('15087','2013-05-31','15:40:00',1.91),('15087','2013-05-31','15:45:00',1.75),('15087','2013-05-31','15:50:00',2.64),('15087','2013-05-31','15:55:00',2.42),('15087','2013-05-31','16:00:00',1.59),('15087','2013-05-31','16:05:00',1.37),('15087','2013-05-31','16:10:00',1),('15087','2013-05-31','16:20:00',1.15),('15087','2013-05-31','16:25:00',1.42),('15087','2013-05-31','16:30:00',1.25),('15087','2013-05-31','16:35:00',1.08),('15087','2013-05-31','16:40:00',1.25),('15087','2013-05-31','16:45:00',1.27),('15087','2013-05-30','07:45:00',1.12),('15087','2013-05-30','07:50:00',1.28),('15087','2013-05-30','08:25:00',1.46),('15087','2013-05-30','08:35:00',1.18),('15087','2013-05-30','08:40:00',2.77),('15087','2013-05-30','08:45:00',2.8),('15087','2013-05-30','08:50:00',2.86),('15087','2013-05-30','08:55:00',2.94),('15087','2013-05-30','09:00:00',3.02),('15087','2013-05-30','09:05:00',3.02),('15087','2013-05-30','09:10:00',3.21),('15087','2013-05-30','09:15:00',3.32),('15087','2013-05-30','09:20:00',3.41),('15087','2013-05-30','09:25:00',3.52),('15087','2013-05-30','09:30:00',3.62),('15087','2013-05-30','09:35:00',3.64),('15087','2013-05-30','09:40:00',3.88),('15087','2013-05-30','09:45:00',3.07),('15087','2013-05-30','09:50:00',4.47),('15087','2013-05-30','09:55:00',1.67),('15087','2013-05-30','10:00:00',1.49),('15087','2013-05-30','10:05:00',1.69),('15087','2013-05-30','10:10:00',3.14),('15087','2013-05-30','10:15:00',2.65),('15087','2013-05-30','10:20:00',4.44),('15087','2013-05-30','10:25:00',1.16),('15087','2013-05-30','10:30:00',1.81),('15087','2013-05-30','10:35:00',1.91),('15087','2013-05-30','10:40:00',3.18),('15087','2013-05-30','10:45:00',4.79),('15087','2013-05-30','10:50:00',4.14),('15087','2013-05-30','10:55:00',3.99),('15087','2013-05-30','11:00:00',5.36),('15087','2013-05-30','11:05:00',4.86),('15087','2013-05-30','11:10:00',1.01),('15087','2013-05-30','11:15:00',2.71),('15087','2013-05-30','11:20:00',3.47),('15087','2013-05-30','11:25:00',1.8),('15087','2013-05-30','11:30:00',4.64),('15087','2013-05-30','11:35:00',5.48),('15087','2013-05-30','11:40:00',4.64),('15087','2013-05-30','11:45:00',4.44),('15087','2013-05-30','11:50:00',4.55),('15087','2013-05-30','11:55:00',1.81),('15087','2013-05-30','12:00:00',5.63),('15087','2013-05-30','12:05:00',5.62),('15087','2013-05-30','12:10:00',2.61),('15087','2013-05-30','12:15:00',4.22),('15087','2013-05-30','12:20:00',3.76),('15087','2013-05-30','12:25:00',5.19),('15087','2013-05-30','12:30:00',3.58),('15087','2013-05-30','12:35:00',3.37),('15087','2013-05-30','12:40:00',5.07),('15087','2013-05-30','12:45:00',3.26),('15087','2013-05-30','12:50:00',3.89),('15087','2013-05-30','12:55:00',5.72),('15087','2013-05-30','13:00:00',4.38),('15087','2013-05-30','13:05:00',4.11),('15087','2013-05-30','13:10:00',2.64),('15087','2013-05-30','13:15:00',2.17),('15087','2013-05-30','13:20:00',2.13),('15087','2013-05-30','13:25:00',1.86),('15087','2013-05-30','13:30:00',2.39),('15087','2013-05-30','13:35:00',2.36),('15087','2013-05-30','13:40:00',4.45),('15087','2013-05-30','13:45:00',4.83),('15087','2013-05-30','13:50:00',1.86),('15087','2013-05-30','13:55:00',2.13),('15087','2013-05-30','14:00:00',4.46),('15087','2013-05-30','14:05:00',5.69),('15087','2013-05-30','14:10:00',3.7),('15087','2013-05-30','14:15:00',5.18),('15087','2013-05-30','14:20:00',3.78),('15087','2013-05-30','14:25:00',4.71),('15087','2013-05-30','14:30:00',5.22),('15087','2013-05-30','14:35:00',4.2),('15087','2013-05-30','14:40:00',5.08),('15087','2013-05-30','14:45:00',5.1),('15087','2013-05-30','14:50:00',5.01),('15087','2013-05-30','14:55:00',4.48),('15087','2013-05-30','15:00:00',4.68),('15087','2013-05-30','15:05:00',2.89),('15087','2013-05-30','15:10:00',2.13),('15087','2013-05-30','15:15:00',4.47),('15087','2013-05-30','15:20:00',4.68),('15087','2013-05-30','15:25:00',4.26),('15087','2013-05-30','15:30:00',4.28),('15087','2013-05-30','15:35:00',4.43),('15087','2013-05-30','15:40:00',4.38),('15087','2013-05-30','15:45:00',4.6),('15087','2013-05-30','15:50:00',2.65),('15087','2013-05-30','15:55:00',4.11),('15087','2013-05-30','16:00:00',3.91),('15087','2013-05-30','16:05:00',4.37),('15087','2013-05-30','16:10:00',4.11),('15087','2013-05-30','16:15:00',3.87),('15087','2013-05-30','16:20:00',3.48),('15087','2013-05-30','16:25:00',1.99),('15087','2013-05-30','16:30:00',1.2),('15087','2013-05-30','16:35:00',2.54),('15087','2013-05-30','16:40:00',1.02),('15087','2013-05-30','16:45:00',3.08),('15087','2013-05-30','16:50:00',2.68),('15087','2013-05-30','16:55:00',2.19),('15087','2013-05-30','17:00:00',1.74),('15087','2013-05-30','17:05:00',2.15),('15087','2013-05-30','17:20:00',1.37),('15087','2013-05-30','17:30:00',1.07),('15087','2013-05-30','18:00:00',1),('15087','2013-05-30','18:05:00',1.08),('15087','2013-05-30','18:10:00',1.25),('15087','2013-05-30','18:35:00',1.38),('15087','2013-05-30','18:40:00',1.31),('15087','2013-05-30','18:45:00',1.48),('15087','2013-05-30','18:50:00',1.32),('15087','2013-05-29','07:25:00',1.05),('15087','2013-05-29','07:30:00',1.15),('15087','2013-05-29','07:35:00',1.25),('15087','2013-05-29','07:40:00',1.35),('15087','2013-05-29','07:45:00',1.43),('15087','2013-05-29','07:50:00',1.52),('15087','2013-05-29','07:55:00',1.63),('15087','2013-05-29','08:00:00',1.75),('15087','2013-05-29','08:05:00',1.86),('15087','2013-05-29','08:10:00',2),('15087','2013-05-29','08:15:00',2.1),('15087','2013-05-29','08:20:00',2.2),('15087','2013-05-29','08:25:00',2.29),('15087','2013-05-29','08:30:00',2.4),('15087','2013-05-29','08:35:00',2.51),('15087','2013-05-29','08:40:00',2.6),('15087','2013-05-29','08:45:00',2.68),('15087','2013-05-29','08:50:00',2.76),('15087','2013-05-29','08:55:00',2.87),('15087','2013-05-29','09:00:00',2.95),('15087','2013-05-29','09:05:00',3.03),('15087','2013-05-29','09:10:00',3.11),('15087','2013-05-29','09:15:00',3.19),('15087','2013-05-29','09:20:00',3.27),('15087','2013-05-29','09:25:00',3.35),('15087','2013-05-29','09:30:00',3.42),('15087','2013-05-29','09:35:00',3.52),('15087','2013-05-29','09:40:00',3.58),('15087','2013-05-29','09:45:00',3.65),('15087','2013-05-29','09:50:00',3.74),('15087','2013-05-29','09:55:00',3.81),('15087','2013-05-29','10:00:00',3.85),('15087','2013-05-29','10:05:00',3.85),('15087','2013-05-29','10:10:00',3.99),('15087','2013-05-29','10:15:00',4.07),('15087','2013-05-29','10:20:00',4.15),('15087','2013-05-29','10:25:00',4.19),('15087','2013-05-29','10:30:00',4.27),('15087','2013-05-29','10:35:00',4.32),('15087','2013-05-29','10:40:00',4.38),('15087','2013-05-29','10:45:00',4.44),('15087','2013-05-29','10:50:00',4.48),('15087','2013-05-29','10:55:00',4.54),('15087','2013-05-29','11:00:00',4.61),('15087','2013-05-29','11:05:00',4.6),('15087','2013-05-29','11:10:00',4.43),('15087','2013-05-29','11:15:00',3.6),('15087','2013-05-29','11:20:00',5.04),('15087','2013-05-29','11:25:00',4.88),('15087','2013-05-29','11:30:00',5.13),('15087','2013-05-29','11:35:00',5.13),('15087','2013-05-29','11:40:00',4.06),('15087','2013-05-29','11:45:00',3.49),('15087','2013-05-29','11:50:00',4.13),('15087','2013-05-29','11:55:00',4.86),('15087','2013-05-29','12:00:00',3.34),('15087','2013-05-29','12:05:00',3.22),('15087','2013-05-29','12:10:00',5.37),('15087','2013-05-29','12:15:00',4.24),('15087','2013-05-29','12:20:00',5.31),('15087','2013-05-29','12:25:00',5.21),('15087','2013-05-29','12:30:00',5.17),('15087','2013-05-29','12:35:00',5.14),('15087','2013-05-29','12:40:00',3.85),('15087','2013-05-29','12:45:00',5.19),('15087','2013-05-29','12:50:00',4.89),('15087','2013-05-29','12:55:00',5.12),('15087','2013-05-29','13:00:00',5.2),('15087','2013-05-29','13:05:00',4.83),('15087','2013-05-29','13:10:00',4.74),('15087','2013-05-29','13:15:00',4.28),('15087','2013-05-29','13:20:00',4.17),('15087','2013-05-29','13:25:00',5.76),('15087','2013-05-29','13:30:00',5.45),('15087','2013-05-29','13:35:00',4.13),('15087','2013-05-29','13:40:00',5.25),('15087','2013-05-29','13:45:00',4.85),('15087','2013-05-29','13:50:00',4.66),('15087','2013-05-29','13:55:00',4.43),('15087','2013-05-29','14:00:00',5.14),('15087','2013-05-29','14:05:00',4.87),('15087','2013-05-29','14:10:00',4.88),('15087','2013-05-29','14:15:00',4.98),('15087','2013-05-29','14:20:00',5.01),('15087','2013-05-29','14:25:00',4.51),('15087','2013-05-29','14:30:00',4.91),('15087','2013-05-29','14:35:00',3.64),('15087','2013-05-29','14:40:00',4.94),('15087','2013-05-29','14:45:00',4.9),('15087','2013-05-29','14:50:00',4.01),('15087','2013-05-29','14:55:00',4.37),('15087','2013-05-29','15:00:00',4.57),('15087','2013-05-29','15:05:00',1.95),('15087','2013-05-29','15:15:00',3.57),('15087','2013-05-29','15:20:00',3.87),('15087','2013-05-29','15:25:00',3.03),('15087','2013-05-29','15:30:00',3.1),('15087','2013-05-29','15:35:00',2.81),('15087','2013-05-29','15:40:00',2.89),('15087','2013-05-29','15:45:00',3.31),('15087','2013-05-29','15:50:00',3.34),('15087','2013-05-29','15:55:00',2.12),('15087','2013-05-29','16:00:00',2.96),('15087','2013-05-29','16:05:00',2.98),('15087','2013-05-29','16:10:00',2.57),('15087','2013-05-29','16:15:00',1.91),('15087','2013-05-29','16:20:00',2.4),('15087','2013-05-29','16:25:00',2.52),('15087','2013-05-29','16:30:00',2.01),('15087','2013-05-29','16:35:00',1.76),('15087','2013-05-29','16:40:00',2.58),('15087','2013-05-29','16:45:00',2.27),('15087','2013-05-29','16:50:00',1.68),('15087','2013-05-29','16:55:00',1.55),('15087','2013-05-29','17:00:00',1.4),('15087','2013-05-29','17:35:00',1.21),('15087','2013-05-29','17:40:00',1.75),('15087','2013-05-29','17:45:00',1.15),('15087','2013-05-29','18:00:00',1.02),('15087','2013-05-29','18:05:00',1.27),('15087','2013-05-29','18:10:00',1.38),('15087','2013-05-29','18:15:00',2.23),('15087','2013-05-29','18:20:00',1.54),('15087','2013-05-28','07:15:00',1.04),('15087','2013-05-28','07:20:00',1.2),('15087','2013-05-28','07:25:00',1.27),('15087','2013-05-28','07:40:00',1.16),('15087','2013-05-28','07:45:00',1.22),('15087','2013-05-28','07:50:00',1.26),('15087','2013-05-28','07:55:00',1.21),('15087','2013-05-28','08:00:00',1.31),('15087','2013-05-28','08:05:00',1.43),('15087','2013-05-28','08:10:00',1.66),('15087','2013-05-28','08:15:00',1.96),('15087','2013-05-28','08:20:00',2.05),('15087','2013-05-28','08:25:00',1.76),('15087','2013-05-28','08:30:00',2.07),('15087','2013-05-28','08:35:00',1.86),('15087','2013-05-28','08:40:00',1.63),('15087','2013-05-28','08:45:00',1.57),('15087','2013-05-28','08:50:00',1.87),('15087','2013-05-28','08:55:00',1.71),('15087','2013-05-28','09:00:00',1.79),('15087','2013-05-28','09:05:00',2.07),('15087','2013-05-28','09:10:00',1.87),('15087','2013-05-28','09:15:00',1.79),('15087','2013-05-28','09:20:00',2.1),('15087','2013-05-28','09:25:00',2.36),('15087','2013-05-28','09:30:00',2.53),('15087','2013-05-28','09:35:00',2.59),('15087','2013-05-28','09:40:00',2.48),('15087','2013-05-28','09:45:00',2.36),('15087','2013-05-28','09:50:00',2.42),('15087','2013-05-28','09:55:00',2.57),('15087','2013-05-28','10:00:00',2.38),('15087','2013-05-28','10:05:00',2.55),('15087','2013-05-28','10:10:00',2.84),('15087','2013-05-28','10:15:00',2.96),('15087','2013-05-28','10:20:00',3.1),('15087','2013-05-28','10:25:00',3.07),('15087','2013-05-28','10:30:00',3.29),('15087','2013-05-28','10:35:00',3.42),('15087','2013-05-28','10:40:00',3.11),('15087','2013-05-28','10:45:00',2.99),('15087','2013-05-28','10:50:00',3.1),('15087','2013-05-28','10:55:00',2.73),('15087','2013-05-28','11:00:00',2.77),('15087','2013-05-28','11:05:00',2.65),('15087','2013-05-28','11:10:00',2.72),('15087','2013-05-28','11:15:00',2.6),('15087','2013-05-28','11:20:00',2.41),('15087','2013-05-28','11:25:00',2.54),('15087','2013-05-28','11:30:00',4.67),('15087','2013-05-28','11:35:00',3.49),('15087','2013-05-28','11:40:00',4.5),('15087','2013-05-28','11:45:00',3.71),('15087','2013-05-28','11:50:00',1.2),('15087','2013-05-28','11:55:00',1.86),('15087','2013-05-28','12:00:00',1.64),('15087','2013-05-28','12:05:00',2.19),('15087','2013-05-28','12:10:00',3.05),('15087','2013-05-28','12:15:00',2.96),('15087','2013-05-28','12:20:00',2.64),('15087','2013-05-28','12:25:00',2.73),('15087','2013-05-28','12:30:00',3.01),('15087','2013-05-28','12:35:00',2.91),('15087','2013-05-28','12:40:00',3),('15087','2013-05-28','12:45:00',3.3),('15087','2013-05-28','12:50:00',2.97),('15087','2013-05-28','12:55:00',3.05),('15087','2013-05-28','13:00:00',3.1),('15087','2013-05-28','13:05:00',3.36),('15087','2013-05-28','13:10:00',3.48),('15087','2013-05-28','13:15:00',3.06),('15087','2013-05-28','13:20:00',3.36),('15087','2013-05-28','13:25:00',1.9),('15087','2013-05-28','13:30:00',2.42),('15087','2013-05-28','13:35:00',1.99),('15087','2013-05-28','13:40:00',2.28),('15087','2013-05-28','13:45:00',2.16),('15087','2013-05-28','13:50:00',2.93),('15087','2013-05-28','13:55:00',2.92),('15087','2013-05-28','14:00:00',2.88),('15087','2013-05-28','14:05:00',3.05),('15087','2013-05-28','14:10:00',4.18),('15087','2013-05-28','14:15:00',4.28),('15087','2013-05-28','14:20:00',2.78),('15087','2013-05-28','14:25:00',3.05),('15087','2013-05-28','14:30:00',3.79),('15087','2013-05-28','14:35:00',3.21),('15087','2013-05-28','14:40:00',3.54),('15087','2013-05-28','14:45:00',4.14),('15087','2013-05-28','14:50:00',3.26),('15087','2013-05-28','14:55:00',3.1),('15087','2013-05-28','15:00:00',2.87),('15087','2013-05-28','15:05:00',3.74),('15087','2013-05-28','15:10:00',1.81),('15087','2013-05-28','15:15:00',2.9),('15087','2013-05-28','15:20:00',3.33),('15087','2013-05-28','15:25:00',2.43),('15087','2013-05-28','15:30:00',1.6),('15087','2013-05-28','15:35:00',1.63),('15087','2013-05-28','15:40:00',2.82),('15087','2013-05-28','15:45:00',3.82),('15087','2013-05-28','15:50:00',3.3),('15087','2013-05-28','15:55:00',2.31),('15087','2013-05-28','16:00:00',1.75),('15087','2013-05-28','16:05:00',1.4),('15087','2013-05-28','16:10:00',1.49),('15087','2013-05-28','16:15:00',1.71),('15087','2013-05-28','16:20:00',2.79),('15087','2013-05-28','16:25:00',2.33),('15087','2013-05-28','16:30:00',3.01),('15087','2013-05-28','16:35:00',3.21),('15087','2013-05-28','16:40:00',2.79),('15087','2013-05-28','16:45:00',2.69),('15087','2013-05-28','16:50:00',2.84),('15087','2013-05-28','16:55:00',2.79),('15087','2013-05-28','17:00:00',2.74),('15087','2013-05-28','17:05:00',2.72),('15087','2013-05-28','17:10:00',2.62),('15087','2013-05-28','17:15:00',2.56),('15087','2013-05-28','17:20:00',2.49),('15087','2013-05-28','17:25:00',2.36),('15087','2013-05-28','17:30:00',2.26),('15087','2013-05-28','17:35:00',2.05),('15087','2013-05-28','17:40:00',1.84),('15087','2013-05-28','17:45:00',1.81),('15087','2013-05-28','17:50:00',1.72),('15087','2013-05-28','17:55:00',1.57),('15087','2013-05-28','18:00:00',1.54),('15087','2013-05-28','18:05:00',1.49),('15087','2013-05-27','07:25:00',1.08),('15087','2013-05-27','07:30:00',1.2),('15087','2013-05-27','07:35:00',1.34),('15087','2013-05-27','07:40:00',1.42),('15087','2013-05-27','07:45:00',1.59),('15087','2013-05-27','07:50:00',1.53),('15087','2013-05-27','08:00:00',1.59),('15087','2013-05-27','08:05:00',2.09),('15087','2013-05-27','08:10:00',2.24),('15087','2013-05-27','08:15:00',2.23),('15087','2013-05-27','08:20:00',1.44),('15087','2013-05-27','08:25:00',2.09),('15087','2013-05-27','08:30:00',2.46),('15087','2013-05-27','08:35:00',2.53),('15087','2013-05-27','08:40:00',2.63),('15087','2013-05-27','08:45:00',2.95),('15087','2013-05-27','08:50:00',2.58),('15087','2013-05-27','08:55:00',2.94),('15087','2013-05-27','09:00:00',3.38),('15087','2013-05-27','09:05:00',3.54),('15087','2013-05-27','09:10:00',2.07),('15087','2013-05-27','09:15:00',2.74),('15087','2013-05-27','09:20:00',1.91),('15087','2013-05-27','09:25:00',3.07),('15087','2013-05-27','09:30:00',3.66),('15087','2013-05-27','09:35:00',3.68),('15087','2013-05-27','09:40:00',3.74),('15087','2013-05-27','09:45:00',3.65),('15087','2013-05-27','09:50:00',3.08),('15087','2013-05-27','09:55:00',4.18),('15087','2013-05-27','10:00:00',4.11),('15087','2013-05-27','10:05:00',3.93),('15087','2013-05-27','10:10:00',4.24),('15087','2013-05-27','10:15:00',3.7),('15087','2013-05-27','10:20:00',2.5),('15087','2013-05-27','10:25:00',4.44),('15087','2013-05-27','10:30:00',1.86),('15087','2013-05-27','10:35:00',1.81),('15087','2013-05-27','10:40:00',4.05),('15087','2013-05-27','10:45:00',2.34),('15087','2013-05-27','10:50:00',2.83),('15087','2013-05-27','10:55:00',1.68),('15087','2013-05-27','11:00:00',4.54),('15087','2013-05-27','11:05:00',2.99),('15087','2013-05-27','11:10:00',3.88),('15087','2013-05-27','11:15:00',1.9),('15087','2013-05-27','11:20:00',4.01),('15087','2013-05-27','11:25:00',3.68),('15087','2013-05-27','11:30:00',3.26),('15087','2013-05-27','11:35:00',1.71),('15087','2013-05-27','11:40:00',5.49),('15087','2013-05-27','11:45:00',1.82),('15087','2013-05-27','11:50:00',1.82),('15087','2013-05-27','11:55:00',3),('15087','2013-05-27','12:00:00',5.18),('15087','2013-05-27','12:05:00',2.35),('15087','2013-05-27','12:10:00',5.19),('15087','2013-05-27','12:15:00',4.12),('15087','2013-05-27','12:20:00',5.49),('15087','2013-05-27','12:25:00',4.03),('15087','2013-05-27','12:30:00',5.25),('15087','2013-05-27','12:35:00',3.88),('15087','2013-05-27','12:40:00',5.67),('15087','2013-05-27','12:45:00',2.23),('15087','2013-05-27','12:50:00',5.6),('15087','2013-05-27','12:55:00',3.2),('15087','2013-05-27','13:00:00',1.85),('15087','2013-05-27','13:05:00',3.07),('15087','2013-05-27','13:10:00',4.77),('15087','2013-05-27','13:15:00',2.12),('15087','2013-05-27','13:20:00',5.44),('15087','2013-05-27','13:25:00',4.66),('15087','2013-05-27','13:30:00',5.12),('15087','2013-05-27','13:35:00',3.73),('15087','2013-05-27','13:40:00',5.44),('15087','2013-05-27','13:45:00',4.9),('15087','2013-05-27','13:50:00',5.04),('15087','2013-05-27','13:55:00',5.11),('15087','2013-05-27','14:00:00',4.95),('15087','2013-05-27','14:05:00',4.73),('15087','2013-05-27','14:10:00',4.27),('15087','2013-05-27','14:15:00',4.53),('15087','2013-05-27','14:20:00',2.87),('15087','2013-05-27','14:25:00',4.94),('15087','2013-05-27','14:30:00',4.8),('15087','2013-05-27','14:35:00',3.34),('15087','2013-05-27','14:40:00',3.38),('15087','2013-05-27','14:45:00',4.94),('15087','2013-05-27','14:50:00',4.86),('15087','2013-05-27','14:55:00',3.99),('15087','2013-05-27','15:00:00',3.04),('15087','2013-05-27','15:05:00',2.91),('15087','2013-05-27','15:10:00',4.57),('15087','2013-05-27','15:15:00',3.13),('15087','2013-05-27','15:20:00',3.78),('15087','2013-05-27','15:25:00',3.34),('15087','2013-05-27','15:30:00',3.62),('15087','2013-05-27','15:35:00',4.05),('15087','2013-05-27','15:40:00',3.59),('15087','2013-05-27','15:45:00',3.3),('15087','2013-05-27','15:50:00',3.96),('15087','2013-05-27','15:55:00',2.69),('15087','2013-05-27','16:00:00',3.25),('15087','2013-05-27','16:05:00',2.34),('15087','2013-05-27','16:10:00',2.69),('15087','2013-05-27','16:15:00',2.55),('15087','2013-05-27','16:20:00',3.99),('15087','2013-05-27','16:25:00',3.82),('15087','2013-05-27','16:30:00',3.58),('15087','2013-05-27','16:35:00',2.96),('15087','2013-05-27','16:40:00',1.47),('15087','2013-05-27','16:45:00',1.32),('15087','2013-05-27','16:50:00',1.34),('15087','2013-05-27','16:55:00',1.43),('15087','2013-05-27','17:00:00',1.51),('15087','2013-05-27','17:05:00',1.57),('15087','2013-05-27','17:10:00',2.04),('15087','2013-05-27','17:15:00',1.56),('15087','2013-05-27','17:20:00',1.33),('15087','2013-05-27','17:25:00',1.22),('15087','2013-05-27','17:30:00',1.18),('15087','2013-05-27','17:35:00',1.1),('15087','2013-05-27','17:40:00',1.02),('15087','2013-05-27','18:20:00',1.29),('15087','2013-05-27','18:25:00',1.75),('15087','2013-05-27','18:30:00',1.34),('15087','2013-05-26','07:20:00',1.16),('15087','2013-05-26','07:35:00',1.27),('15087','2013-05-26','07:40:00',1.51),('15087','2013-05-26','07:45:00',1.72),('15087','2013-05-26','07:50:00',2.41),('15087','2013-05-26','08:05:00',2.49),('15087','2013-05-26','08:10:00',1.78),('15087','2013-05-26','08:20:00',1.21),('15087','2013-05-26','08:25:00',1.59),('15087','2013-05-26','08:30:00',2.26),('15087','2013-05-26','08:35:00',1.91),('15087','2013-05-26','08:40:00',2.57),('15087','2013-05-26','08:45:00',2.96),('15087','2013-05-26','08:50:00',3.14),('15087','2013-05-26','08:55:00',1.15),('15087','2013-05-26','09:00:00',1.93),('15087','2013-05-26','09:10:00',2.78),('15087','2013-05-26','09:15:00',1.38),('15087','2013-05-26','09:25:00',1.68),('15087','2013-05-26','09:40:00',1.61),('15087','2013-05-26','09:45:00',2.1),('15087','2013-05-26','09:55:00',1.44),('15087','2013-05-26','10:00:00',1.26),('15087','2013-05-26','10:05:00',3.76),('15087','2013-05-26','10:10:00',4.18),('15087','2013-05-26','10:15:00',1.99),('15087','2013-05-26','10:20:00',3.15),('15087','2013-05-26','10:25:00',3.63),('15087','2013-05-26','10:30:00',4.25),('15087','2013-05-26','10:35:00',4.67),('15087','2013-05-26','10:40:00',4.51),('15087','2013-05-26','10:45:00',4.6),('15087','2013-05-26','10:50:00',4.78),('15087','2013-05-26','10:55:00',4.21),('15087','2013-05-26','11:00:00',4.7),('15087','2013-05-26','11:05:00',4.85),('15087','2013-05-26','11:10:00',4.86),('15087','2013-05-26','11:15:00',4.91),('15087','2013-05-26','11:20:00',4.87),('15087','2013-05-26','11:25:00',5.02),('15087','2013-05-26','11:35:00',2.38),('15087','2013-05-26','11:40:00',4.94),('15087','2013-05-26','11:45:00',4.83),('15087','2013-05-26','11:50:00',5.17),('15087','2013-05-26','11:55:00',2.87),('15087','2013-05-26','12:00:00',5.05),('15087','2013-05-26','12:05:00',5.27),('15087','2013-05-26','12:10:00',4.71),('15087','2013-05-26','12:15:00',2.76),('15087','2013-05-26','12:20:00',3.58),('15087','2013-05-26','12:25:00',4.67),('15087','2013-05-26','12:30:00',5.4),('15087','2013-05-26','12:35:00',4.22),('15087','2013-05-26','12:40:00',3.71),('15087','2013-05-26','12:45:00',5.18),('15087','2013-05-26','12:50:00',5.21),('15087','2013-05-26','12:55:00',5.38),('15087','2013-05-26','13:00:00',2.32),('15087','2013-05-26','13:05:00',5),('15087','2013-05-26','13:10:00',5.45),('15087','2013-05-26','13:15:00',5.43),('15087','2013-05-26','13:20:00',5.4),('15087','2013-05-26','13:25:00',5.34),('15087','2013-05-26','13:30:00',5.38),('15087','2013-05-26','13:35:00',5.33),('15087','2013-05-26','13:40:00',5.27),('15087','2013-05-26','13:45:00',5.29),('15087','2013-05-26','13:50:00',5.29),('15087','2013-05-26','13:55:00',5.18),('15087','2013-05-26','14:00:00',5.08),('15087','2013-05-26','14:05:00',5.15),('15087','2013-05-26','14:10:00',5.12),('15087','2013-05-26','14:15:00',5.09),('15087','2013-05-26','14:20:00',5.05),('15087','2013-05-26','14:25:00',4.95),('15087','2013-05-26','14:30:00',4.9),('15087','2013-05-26','14:35:00',4.87),('15087','2013-05-26','14:40:00',4.85),('15087','2013-05-26','14:45:00',4.77),('15087','2013-05-26','14:50:00',4.7),('15087','2013-05-26','14:55:00',4.57),('15087','2013-05-26','15:00:00',4.56),('15087','2013-05-26','15:05:00',4.58),('15087','2013-05-26','15:10:00',4.55),('15087','2013-05-26','15:15:00',4.4),('15087','2013-05-26','15:20:00',4.27),('15087','2013-05-26','15:25:00',4.16),('15087','2013-05-26','15:30:00',4.19),('15087','2013-05-26','15:35:00',4.21),('15087','2013-05-26','15:40:00',4.11),('15087','2013-05-26','15:45:00',4.03),('15087','2013-05-26','15:50:00',3.99),('15087','2013-05-26','15:55:00',3.93),('15087','2013-05-26','16:00:00',3.85),('15087','2013-05-26','16:05:00',3.74),('15087','2013-05-26','16:10:00',3.66),('15087','2013-05-26','16:15:00',3.65),('15087','2013-05-26','16:20:00',3.64),('15087','2013-05-26','16:25:00',3.6),('15087','2013-05-26','16:30:00',3.49),('15087','2013-05-26','16:35:00',3.41),('15087','2013-05-26','16:40:00',3.33),('15087','2013-05-26','16:45:00',3.23),('15087','2013-05-26','16:50:00',3.17),('15087','2013-05-26','16:55:00',3.06),('15087','2013-05-26','17:00:00',3),('15087','2013-05-26','17:05:00',2.98),('15087','2013-05-26','17:10:00',2.91),('15087','2013-05-26','17:15:00',2.81),('15087','2013-05-26','17:20:00',2.73),('15087','2013-05-26','17:25:00',2.64),('15087','2013-05-26','17:30:00',2.53),('15087','2013-05-26','17:35:00',2.28),('15087','2013-05-26','17:40:00',2.23),('15087','2013-05-26','17:45:00',2.16),('15087','2013-05-26','17:50:00',1.99),('15087','2013-05-26','17:55:00',1.89),('15087','2013-05-26','18:00:00',1.76),('15087','2013-05-26','18:05:00',1.61),('15087','2013-05-26','18:10:00',1.56),('15087','2013-05-26','18:15:00',1.43),('15087','2013-05-26','18:20:00',1.32),('15087','2013-05-26','18:25:00',1.22),('15087','2013-05-26','18:30:00',1.09),('15087','2013-05-25','07:15:00',1.13),('15087','2013-05-25','07:30:00',1.38),('15087','2013-05-25','07:35:00',1.87),('15087','2013-05-25','07:40:00',1.32),('15087','2013-05-25','07:55:00',1.97),('15087','2013-05-25','08:00:00',2.39),('15087','2013-05-25','08:05:00',2.09),('15087','2013-05-25','08:10:00',1.5),('15087','2013-05-25','08:20:00',1.75),('15087','2013-05-25','08:25:00',2.75),('15087','2013-05-25','08:30:00',2.86),('15087','2013-05-25','08:35:00',1.39),('15087','2013-05-25','08:40:00',1.48),('15087','2013-05-25','08:45:00',1.27),('15087','2013-05-25','08:50:00',1.97),('15087','2013-05-25','08:55:00',1.84),('15087','2013-05-25','09:00:00',2.53),('15087','2013-05-25','09:05:00',2.93),('15087','2013-05-25','09:10:00',3.2),('15087','2013-05-25','09:15:00',3.68),('15087','2013-05-25','09:20:00',1.55),('15087','2013-05-25','09:25:00',1.61),('15087','2013-05-25','09:30:00',1.14),('15087','2013-05-25','09:35:00',2.9),('15087','2013-05-25','09:40:00',3.85),('15087','2013-05-25','09:45:00',2.93),('15087','2013-05-25','09:50:00',3.96),('15087','2013-05-25','09:55:00',2.18),('15087','2013-05-25','10:10:00',1.27),('15087','2013-05-25','10:15:00',1.09),('15087','2013-05-25','10:40:00',1.76),('15087','2013-05-25','10:45:00',1.48),('15087','2013-05-25','10:50:00',1.46),('15087','2013-05-25','11:00:00',1.23),('15087','2013-05-25','11:05:00',2.25),('15087','2013-05-25','11:10:00',4.36),('15087','2013-05-25','11:15:00',4.57),('15087','2013-05-25','11:20:00',2.9),('15087','2013-05-25','11:35:00',1.93),('15087','2013-05-25','11:40:00',2.38),('15087','2013-05-25','11:45:00',2.79),('15087','2013-05-25','11:50:00',2.04),('15087','2013-05-25','11:55:00',2.14),('15087','2013-05-25','12:00:00',1.9),('15087','2013-05-25','12:05:00',1.51),('15087','2013-05-25','12:10:00',1.96),('15087','2013-05-25','12:15:00',1.29),('15087','2013-05-25','12:20:00',1.75),('15087','2013-05-25','12:25:00',2.25),('15087','2013-05-25','12:30:00',1.45),('15087','2013-05-25','12:35:00',1.75),('15087','2013-05-25','12:40:00',2.06),('15087','2013-05-25','12:45:00',2.01),('15087','2013-05-25','12:50:00',1.45),('15087','2013-05-25','12:55:00',2.06),('15087','2013-05-25','13:00:00',1.1),('15087','2013-05-25','13:05:00',1.87),('15087','2013-05-25','13:10:00',1.58),('15087','2013-05-25','13:15:00',2.12),('15087','2013-05-25','13:20:00',2.31),('15087','2013-05-25','13:25:00',4.13),('15087','2013-05-25','13:30:00',1.65),('15087','2013-05-25','13:35:00',1.58),('15087','2013-05-25','13:40:00',2.33),('15087','2013-05-25','13:45:00',2.14),('15087','2013-05-25','13:50:00',2.85),('15087','2013-05-25','13:55:00',3.77),('15087','2013-05-25','14:00:00',4.33),('15087','2013-05-25','14:05:00',4.45),('15087','2013-05-25','14:10:00',4.94),('15087','2013-05-25','14:15:00',4.28),('15087','2013-05-25','14:20:00',4.12),('15087','2013-05-25','14:25:00',3.07),('15087','2013-05-25','14:30:00',2.73),('15087','2013-05-25','14:35:00',2.97),('15087','2013-05-25','14:40:00',1.55),('15087','2013-05-25','14:45:00',3.3),('15087','2013-05-25','14:50:00',1.32),('15087','2013-05-25','14:55:00',1.97),('15087','2013-05-25','15:00:00',4.61),('15087','2013-05-25','15:05:00',2.81),('15087','2013-05-25','15:20:00',1.68),('15087','2013-05-25','15:25:00',2.78),('15087','2013-05-25','15:30:00',3.04),('15087','2013-05-25','15:35:00',4.18),('15087','2013-05-25','15:40:00',3.07),('15087','2013-05-25','15:45:00',3.96),('15087','2013-05-25','15:50:00',4.49),('15087','2013-05-25','15:55:00',3.89),('15087','2013-05-25','16:00:00',1.45),('15087','2013-05-25','16:05:00',2.32),('15087','2013-05-25','16:10:00',2.17),('15087','2013-05-25','16:15:00',1.86),('15087','2013-05-25','16:20:00',1.18),('15087','2013-05-25','16:25:00',1.93),('15087','2013-05-25','16:30:00',2.9),('15087','2013-05-25','16:35:00',3.63),('15087','2013-05-25','16:40:00',2.16),('15087','2013-05-25','16:45:00',2.57),('15087','2013-05-25','16:50:00',1.66),('15087','2013-05-25','17:05:00',2),('15087','2013-05-25','17:10:00',3.19),('15087','2013-05-25','17:15:00',2.43),('15087','2013-05-25','17:20:00',2.08),('15087','2013-05-25','17:35:00',1.8),('15087','2013-05-25','17:40:00',1.09),('15087','2013-05-25','17:45:00',1.18),('15087','2013-05-25','17:50:00',1.7),('15087','2013-05-25','18:00:00',1.06),('15087','2013-05-25','18:10:00',1.02),('15087','2013-05-24','08:00:00',1.11),('15087','2013-05-24','08:05:00',2.09),('15087','2013-05-24','08:10:00',2.44),('15087','2013-05-24','08:15:00',1.81),('15087','2013-05-24','08:25:00',1.7),('15087','2013-05-24','08:30:00',2.58),('15087','2013-05-24','08:35:00',1.61),('15087','2013-05-24','08:40:00',1.56),('15087','2013-05-24','08:45:00',2.81),('15087','2013-05-24','08:50:00',2.81),('15087','2013-05-24','08:55:00',2.93),('15087','2013-05-24','09:00:00',3.16),('15087','2013-05-24','09:05:00',3.15),('15087','2013-05-24','09:20:00',2.77),('15087','2013-05-24','09:25:00',1.57),('15087','2013-05-24','09:30:00',1.98),('15087','2013-05-24','09:40:00',1.84),('15087','2013-05-24','09:45:00',1.15),('15087','2013-05-24','09:50:00',1.58),('15087','2013-05-24','09:55:00',3.61),('15087','2013-05-24','10:00:00',1.77),('15087','2013-05-24','10:20:00',1.56),('15087','2013-05-24','10:25:00',3.06),('15087','2013-05-24','10:30:00',4.44),('15087','2013-05-24','10:35:00',4.3),('15087','2013-05-24','10:40:00',4.04),('15087','2013-05-24','10:45:00',3.77),('15087','2013-05-24','10:50:00',3.24),('15087','2013-05-24','10:55:00',5.16),('15087','2013-05-24','11:00:00',3.1),('15087','2013-05-24','11:05:00',3.87),('15087','2013-05-24','11:10:00',4.49),('15087','2013-05-24','11:15:00',3.45),('15087','2013-05-24','11:20:00',5),('15087','2013-05-24','11:25:00',5.22),('15087','2013-05-24','11:30:00',2.99),('15087','2013-05-24','11:35:00',1.45),('15087','2013-05-24','11:45:00',3.76),('15087','2013-05-24','11:50:00',5.56),('15087','2013-05-24','11:55:00',3.36),('15087','2013-05-24','12:00:00',3.03),('15087','2013-05-24','12:05:00',2.76),('15087','2013-05-24','12:10:00',4.37),('15087','2013-05-24','12:15:00',2.78),('15087','2013-05-24','12:20:00',2.51),('15087','2013-05-24','12:25:00',4.23),('15087','2013-05-24','12:30:00',4.81),('15087','2013-05-24','12:35:00',2.57),('15087','2013-05-24','12:40:00',3.04),('15087','2013-05-24','12:45:00',3.79),('15087','2013-05-24','12:50:00',3.56),('15087','2013-05-24','12:55:00',2.97),('15087','2013-05-24','13:00:00',2.86),('15087','2013-05-24','13:05:00',2.48),('15087','2013-05-24','13:10:00',2.88),('15087','2013-05-24','13:15:00',3.33),('15087','2013-05-24','13:20:00',3.38),('15087','2013-05-24','13:25:00',2.61),('15087','2013-05-24','13:30:00',2.27),('15087','2013-05-24','13:35:00',2.84),('15087','2013-05-24','13:40:00',2.41),('15087','2013-05-24','13:45:00',1.2),('15087','2013-05-24','13:50:00',1.37),('15087','2013-05-24','13:55:00',2.79),('15087','2013-05-24','14:00:00',2.41),('15087','2013-05-24','14:05:00',2.13),('15087','2013-05-24','14:10:00',1.57),('15087','2013-05-24','14:15:00',4.29),('15087','2013-05-24','14:20:00',3.76),('15087','2013-05-24','14:25:00',3.7),('15087','2013-05-24','14:30:00',2.7),('15087','2013-05-24','14:35:00',3.87),('15087','2013-05-24','14:40:00',2.93),('15087','2013-05-24','14:45:00',3.11),('15087','2013-05-24','14:50:00',1.51),('15087','2013-05-24','14:55:00',1.87),('15087','2013-05-24','15:00:00',3.02),('15087','2013-05-24','15:05:00',3.54),('15087','2013-05-24','15:10:00',2.59),('15087','2013-05-24','15:15:00',4.08),('15087','2013-05-24','15:20:00',4.24),('15087','2013-05-24','15:25:00',3.92),('15087','2013-05-24','15:30:00',4.99),('15087','2013-05-24','15:35:00',4.25),('15087','2013-05-24','15:40:00',3.53),('15087','2013-05-24','15:45:00',4.59),('15087','2013-05-24','15:50:00',4.7),('15087','2013-05-24','15:55:00',4.62),('15087','2013-05-24','16:00:00',2.45),('15087','2013-05-24','16:05:00',2.45),('15087','2013-05-24','16:10:00',2.6),('15087','2013-05-24','16:15:00',3.12),('15087','2013-05-24','16:20:00',2.48),('15087','2013-05-24','16:25:00',3.43),('15087','2013-05-24','16:30:00',3.08),('15087','2013-05-24','16:35:00',1.74),('15087','2013-05-24','16:50:00',1.61),('15087','2013-05-24','16:55:00',1.96),('15087','2013-05-24','17:00:00',1.44),('15087','2013-05-24','17:05:00',1.03),('15087','2013-05-24','17:20:00',1.07),('15087','2013-05-24','17:25:00',1.1),('15087','2013-05-24','17:30:00',1.15),('15087','2013-05-24','17:35:00',1.15),('15087','2013-05-23','07:55:00',1.01),('15087','2013-05-23','08:00:00',1.26),('15087','2013-05-23','08:05:00',1.76),('15087','2013-05-23','08:10:00',1.27),('15087','2013-05-23','08:30:00',2.31),('15087','2013-05-23','08:35:00',2.03),('15087','2013-05-23','08:40:00',2.63),('15087','2013-05-23','08:45:00',1.73),('15087','2013-05-23','08:55:00',1.24),('15087','2013-05-23','09:00:00',3.09),('15087','2013-05-23','09:05:00',1.1),('15087','2013-05-23','09:15:00',1.18),('15087','2013-05-23','09:20:00',2.58),('15087','2013-05-23','09:25:00',3.73),('15087','2013-05-23','09:30:00',3.35),('15087','2013-05-23','09:35:00',3.04),('15087','2013-05-23','09:40:00',3.39),('15087','2013-05-23','09:45:00',2.37),('15087','2013-05-23','09:50:00',3.11),('15087','2013-05-23','09:55:00',1.77),('15087','2013-05-23','10:00:00',1.35),('15087','2013-05-23','10:05:00',4.27),('15087','2013-05-23','10:10:00',3.9),('15087','2013-05-23','10:15:00',4.56),('15087','2013-05-23','10:20:00',2.29),('15087','2013-05-23','10:25:00',4.12),('15087','2013-05-23','10:30:00',3.9),('15087','2013-05-23','10:35:00',4.12),('15087','2013-05-23','10:40:00',4),('15087','2013-05-23','10:45:00',4.46),('15087','2013-05-23','10:50:00',2.78),('15087','2013-05-23','10:55:00',4.53),('15087','2013-05-23','11:00:00',2.53),('15087','2013-05-23','11:05:00',4.15),('15087','2013-05-23','11:10:00',2.48),('15087','2013-05-23','11:15:00',2.65),('15087','2013-05-23','11:20:00',1.62),('15087','2013-05-23','11:25:00',2.93),('15087','2013-05-23','11:30:00',3.4),('15087','2013-05-23','11:35:00',3.92),('15087','2013-05-23','11:40:00',5.31),('15087','2013-05-23','11:45:00',2.61),('15087','2013-05-23','11:50:00',3.12),('15087','2013-05-23','11:55:00',4.45),('15087','2013-05-23','12:00:00',5.45),('15087','2013-05-23','12:05:00',5.31),('15087','2013-05-23','12:10:00',5.41),('15087','2013-05-23','12:15:00',3.31),('15087','2013-05-23','12:20:00',3.82),('15087','2013-05-23','12:25:00',3.63),('15087','2013-05-23','12:30:00',5.04),('15087','2013-05-23','12:35:00',1.99),('15087','2013-05-23','12:40:00',5.69),('15087','2013-05-23','12:45:00',3.15),('15087','2013-05-23','12:50:00',4.4),('15087','2013-05-23','12:55:00',4.96),('15087','2013-05-23','13:00:00',5.2),('15087','2013-05-23','13:05:00',4.22),('15087','2013-05-23','13:10:00',5.18),('15087','2013-05-23','13:15:00',4.5),('15087','2013-05-23','13:20:00',3.74),('15087','2013-05-23','13:25:00',5.19),('15087','2013-05-23','13:30:00',3.74),('15087','2013-05-23','13:35:00',2.56),('15087','2013-05-23','13:40:00',2.49),('15087','2013-05-23','13:45:00',3.91),('15087','2013-05-23','13:50:00',4.05),('15087','2013-05-23','13:55:00',4.34),('15087','2013-05-23','14:00:00',4.37),('15087','2013-05-23','14:05:00',5.22),('15087','2013-05-23','14:10:00',4.88),('15087','2013-05-23','14:15:00',4.38),('15087','2013-05-23','14:20:00',4.03),('15087','2013-05-23','14:25:00',2.66),('15087','2013-05-23','14:30:00',2.33),('15087','2013-05-23','14:35:00',5.34),('15087','2013-05-23','14:40:00',3.57),('15087','2013-05-23','14:45:00',2.07),('15087','2013-05-23','14:50:00',2.06),('15087','2013-05-23','14:55:00',3.73),('15087','2013-05-23','15:00:00',3.95),('15087','2013-05-23','15:05:00',3.09),('15087','2013-05-23','15:10:00',1.41),('15087','2013-05-23','15:15:00',1.88),('15087','2013-05-23','15:20:00',3.5),('15087','2013-05-23','15:25:00',1.66),('15087','2013-05-23','15:30:00',4.13),('15087','2013-05-23','15:35:00',3.48),('15087','2013-05-23','15:40:00',1.48),('15087','2013-05-23','15:45:00',2.82),('15087','2013-05-23','15:50:00',1.25),('15087','2013-05-23','15:55:00',2.3),('15087','2013-05-23','16:00:00',2.9),('15087','2013-05-23','16:05:00',4.31),('15087','2013-05-23','16:10:00',1.98),('15087','2013-05-23','16:15:00',3.22),('15087','2013-05-23','16:20:00',2.77),('15087','2013-05-23','16:25:00',3.05),('15087','2013-05-23','16:30:00',3.21),('15087','2013-05-23','16:35:00',1.8),('15087','2013-05-23','16:40:00',1.26),('15087','2013-05-23','16:45:00',2.32),('15087','2013-05-23','16:50:00',1.07),('15087','2013-05-23','17:05:00',1.26),('15087','2013-05-23','17:10:00',2.62),('15087','2013-05-23','17:15:00',1.96),('15087','2013-05-23','17:20:00',1.67),('15087','2013-05-23','17:35:00',1.68),('15087','2013-05-23','17:40:00',1.06),('15087','2013-05-23','17:55:00',1.57),('15087','2013-05-23','18:00:00',1.97),('15087','2013-05-23','18:05:00',2.41),('15087','2013-05-23','18:50:00',1.16),('15087','2013-05-22','07:50:00',1),('15087','2013-05-22','07:55:00',1.08),('15087','2013-05-22','08:00:00',1.23),('15087','2013-05-22','08:05:00',1.55),('15087','2013-05-22','08:10:00',1.33),('15087','2013-05-22','08:15:00',2.36),('15087','2013-05-22','08:20:00',2.21),('15087','2013-05-22','08:25:00',1.88),('15087','2013-05-22','08:30:00',2.45),('15087','2013-05-22','08:35:00',2.9),('15087','2013-05-22','08:40:00',1.57),('15087','2013-05-22','08:45:00',1.77),('15087','2013-05-22','08:50:00',1.02),('15087','2013-05-22','09:25:00',1.27),('15087','2013-05-22','09:30:00',3.3),('15087','2013-05-22','09:35:00',3.28),('15087','2013-05-22','09:40:00',3.27),('15087','2013-05-22','09:45:00',3.28),('15087','2013-05-22','09:50:00',3.34),('15087','2013-05-22','09:55:00',3.4),('15087','2013-05-22','10:00:00',3.43),('15087','2013-05-22','10:05:00',3.55),('15087','2013-05-22','10:10:00',3.62),('15087','2013-05-22','10:15:00',3.68),('15087','2013-05-22','10:20:00',3.49),('15087','2013-05-22','10:25:00',3.8),('15087','2013-05-22','10:30:00',3.85),('15087','2013-05-22','10:35:00',3.87),('15087','2013-05-22','10:40:00',4.14),('15087','2013-05-22','10:45:00',4.12),('15087','2013-05-22','10:50:00',4.05),('15087','2013-05-22','10:55:00',4.08),('15087','2013-05-22','11:00:00',4.16),('15087','2013-05-22','11:05:00',4.29),('15087','2013-05-22','11:10:00',3.42),('15087','2013-05-22','11:15:00',4.25),('15087','2013-05-22','11:20:00',4.38),('15087','2013-05-22','11:25:00',4.25),('15087','2013-05-22','11:30:00',3.43),('15087','2013-05-22','11:35:00',3.63),('15087','2013-05-22','11:40:00',3.74),('15087','2013-05-22','11:45:00',4.44),('15087','2013-05-22','11:50:00',2.42),('15087','2013-05-22','11:55:00',2.23),('15087','2013-05-22','12:00:00',3.25),('15087','2013-05-22','12:05:00',2.57),('15087','2013-05-22','12:10:00',2.54),('15087','2013-05-22','12:15:00',3.49),('15087','2013-05-22','12:20:00',3.82),('15087','2013-05-22','12:25:00',3.49),('15087','2013-05-22','12:30:00',2.38),('15087','2013-05-22','12:35:00',2.57),('15087','2013-05-22','12:40:00',1.71),('15087','2013-05-22','13:05:00',4.49),('15087','2013-05-22','13:10:00',2.8),('15087','2013-05-22','13:15:00',3.21),('15087','2013-05-22','13:20:00',3.16),('15087','2013-05-22','13:25:00',1.15),('15087','2013-05-22','13:30:00',1.86),('15087','2013-05-22','13:35:00',3.94),('15087','2013-05-22','13:40:00',3.02),('15087','2013-05-22','13:45:00',2.73),('15087','2013-05-22','13:50:00',1.78),('15087','2013-05-22','13:55:00',2.23),('15087','2013-05-22','14:00:00',2.86),('15087','2013-05-22','14:05:00',3.47),('15087','2013-05-22','14:10:00',4.74),('15087','2013-05-22','14:15:00',4.69),('15087','2013-05-22','14:20:00',4.55),('15087','2013-05-22','14:25:00',4.44),('15087','2013-05-22','14:30:00',4.31),('15087','2013-05-22','14:35:00',4.33),('15087','2013-05-22','14:40:00',4.32),('15087','2013-05-22','14:45:00',4.3),('15087','2013-05-22','14:50:00',4.12),('15087','2013-05-22','14:55:00',4.11),('15087','2013-05-22','15:00:00',4.08),('15087','2013-05-22','15:05:00',4.03),('15087','2013-05-22','15:10:00',3.98),('15087','2013-05-22','15:15:00',3.71),('15087','2013-05-22','15:20:00',3.43),('15087','2013-05-22','15:25:00',2.41),('15087','2013-05-22','15:30:00',2.07),('15087','2013-05-22','15:35:00',2.02),('15087','2013-05-22','15:40:00',3.67),('15087','2013-05-22','15:45:00',2.97),('15087','2013-05-22','15:50:00',3.39),('15087','2013-05-22','15:55:00',3.39),('15087','2013-05-22','16:00:00',3.35),('15087','2013-05-22','16:05:00',3.23),('15087','2013-05-22','16:10:00',3.21),('15087','2013-05-22','16:15:00',3.11),('15087','2013-05-22','16:20:00',3.13),('15087','2013-05-22','16:25:00',3.06),('15087','2013-05-22','16:30:00',2.96),('15087','2013-05-22','16:35:00',2.77),('15087','2013-05-22','16:40:00',2.84),('15087','2013-05-22','16:45:00',2.59),('15087','2013-05-22','16:50:00',1.09),('15087','2013-05-22','17:15:00',1.15),('15087','2013-05-22','17:20:00',1.25),('15087','2013-05-22','17:25:00',1.64),('15087','2013-05-22','17:30:00',1.32),('15087','2013-05-22','17:35:00',1.76),('15087','2013-05-22','17:55:00',1.59),('15087','2013-05-22','18:00:00',1.67),('15087','2014-04-01','08:20:00',1.01),('15087','2014-04-01','08:25:00',1.16),('15087','2014-04-01','08:30:00',1.27),('15087','2014-04-01','08:35:00',1.41),('15087','2014-04-01','08:40:00',1.53),('15087','2014-04-01','08:45:00',1.64),('15087','2014-04-01','08:50:00',1.73),('15087','2014-04-01','08:55:00',1.84),('15087','2014-04-01','09:00:00',1.95),('15087','2014-04-01','09:05:00',2.03),('15087','2014-04-01','09:10:00',2.13),('15087','2014-04-01','09:15:00',2.22),('15087','2014-04-01','09:20:00',2.3),('15087','2014-04-01','09:25:00',2.4),('15087','2014-04-01','09:30:00',2.45),('15087','2014-04-01','09:35:00',2.58),('15087','2014-04-01','09:40:00',2.71),('15087','2014-04-01','09:45:00',2.75),('15087','2014-04-01','09:50:00',2.87),('15087','2014-04-01','09:55:00',2.95),('15087','2014-04-01','10:00:00',3.03),('15087','2014-04-01','10:05:00',3.06),('15087','2014-04-01','10:10:00',3.14),('15087','2014-04-01','10:15:00',3.3),('15087','2014-04-01','10:20:00',3.15),('15087','2014-04-01','10:25:00',3.18),('15087','2014-04-01','10:30:00',3.64),('15087','2014-04-01','10:35:00',3.22),('15087','2014-04-01','10:40:00',1.88),('15087','2014-04-01','10:45:00',2.69),('15087','2014-04-01','10:50:00',3.83),('15087','2014-04-01','10:55:00',3.81),('15087','2014-04-01','11:00:00',3.86),('15087','2014-04-01','11:05:00',3.88),('15087','2014-04-01','11:10:00',3.91),('15087','2014-04-01','11:15:00',3.91),('15087','2014-04-01','11:20:00',4.02),('15087','2014-04-01','11:25:00',4.1),('15087','2014-04-01','11:30:00',4.15),('15087','2014-04-01','11:35:00',4.17),('15087','2014-04-01','11:40:00',4.2),('15087','2014-04-01','11:45:00',4.3),('15087','2014-04-01','11:50:00',4.27),('15087','2014-04-01','11:55:00',4.33),('15087','2014-04-01','12:00:00',4.37),('15087','2014-04-01','12:05:00',4.4),('15087','2014-04-01','12:10:00',4.41),('15087','2014-04-01','12:15:00',4.44),('15087','2014-04-01','12:20:00',4.49),('15087','2014-04-01','12:25:00',4.54),('15087','2014-04-01','12:30:00',4.58),('15087','2014-04-01','12:35:00',4.61),('15087','2014-04-01','12:40:00',4.63),('15087','2014-04-01','12:45:00',4.66),('15087','2014-04-01','12:50:00',4.55),('15087','2014-04-01','12:55:00',4.65),('15087','2014-04-01','13:00:00',4.66),('15087','2014-04-01','13:05:00',4.55),('15087','2014-04-01','13:10:00',4.71),('15087','2014-04-01','13:15:00',4.23),('15087','2014-04-01','13:20:00',4.21),('15087','2014-04-01','13:25:00',4.62),('15087','2014-04-01','13:30:00',4.62),('15087','2014-04-01','13:35:00',4.66),('15087','2014-04-01','13:40:00',4.69),('15087','2014-04-01','13:45:00',4.62),('15087','2014-04-01','13:50:00',4.56),('15087','2014-04-01','13:55:00',4.54),('15087','2014-04-01','14:00:00',4.5),('15087','2014-04-01','14:05:00',4.51),('15087','2014-04-01','14:10:00',3.93),('15087','2014-04-01','14:15:00',4.01),('15087','2014-04-01','14:20:00',2.89),('15087','2014-04-01','14:25:00',3.96),('15087','2014-04-01','14:30:00',3.54),('15087','2014-04-01','14:35:00',4.39),('15087','2014-04-01','14:40:00',3.39),('15087','2014-04-01','14:45:00',4.41),('15087','2014-04-01','14:50:00',4.05),('15087','2014-04-01','14:55:00',3.19),('15087','2014-04-01','15:00:00',4.03),('15087','2014-04-01','15:05:00',3.16),('15087','2014-04-01','15:10:00',3.89),('15087','2014-04-01','15:15:00',2.92),('15087','2014-04-01','15:20:00',1.72),('15087','2014-04-01','15:25:00',3.54),('15087','2014-04-01','15:30:00',3.48),('15087','2014-04-01','15:35:00',2.54),('15087','2014-04-01','15:40:00',3.59),('15087','2014-04-01','15:45:00',2.82),('15087','2014-04-01','15:50:00',3.21),('15087','2014-04-01','15:55:00',2.96),('15087','2014-04-01','16:00:00',1.78),('15087','2014-04-01','16:05:00',2.91),('15087','2014-04-01','16:10:00',2.63),('15087','2014-04-01','16:15:00',1.95),('15087','2014-04-01','16:20:00',1.37),('15087','2014-04-01','16:25:00',2.23),('15087','2014-04-01','16:30:00',2.57),('15087','2014-04-01','16:35:00',2.63),('15087','2014-04-01','16:40:00',2.49),('15087','2014-04-01','16:45:00',1.37),('15087','2014-04-01','16:50:00',1.53),('15087','2014-04-01','16:55:00',1.87),('15087','2014-04-01','17:00:00',2.19),('15087','2014-04-01','17:05:00',1.97),('15087','2014-04-01','17:10:00',1.59),('15087','2014-04-01','17:15:00',1.85),('15087','2014-04-01','17:20:00',1.66),('15087','2014-04-01','17:25:00',1.32),('15087','2014-04-01','17:30:00',1.45),('15087','2014-04-01','17:35:00',1.35),('15087','2014-04-01','17:40:00',1.27),('15087','2014-04-01','17:45:00',1.11),('15087','2014-04-01','17:50:00',1.08),('15087','2013-05-21','07:30:00',1.09),('15087','2013-05-21','07:35:00',1.35),('15087','2013-05-21','07:40:00',1.6),('15087','2013-05-21','07:45:00',1.27),('15087','2013-05-21','07:50:00',1.05),('15087','2013-05-21','07:55:00',1.13),('15087','2013-05-21','08:00:00',1.2),('15087','2013-05-21','08:10:00',1.57),('15087','2013-05-21','08:15:00',2.02),('15087','2013-05-21','08:20:00',1.66),('15087','2013-05-21','08:25:00',2),('15087','2013-05-21','08:30:00',1.36),('15087','2013-05-21','08:35:00',1.3),('15087','2013-05-21','08:40:00',1.53),('15087','2013-05-21','08:45:00',1.28),('15087','2013-05-21','08:50:00',1.41),('15087','2013-05-21','08:55:00',1.88),('15087','2013-05-21','09:00:00',1.57),('15087','2013-05-21','09:05:00',1.36),('15087','2013-05-21','09:10:00',1.55),('15087','2013-05-21','09:15:00',1.71),('15087','2013-05-21','09:20:00',2.47),('15087','2013-05-21','09:25:00',2.49),('15087','2013-05-21','09:30:00',2.02),('15087','2013-05-21','09:35:00',2.12),('15087','2013-05-21','09:40:00',2.14),('15087','2013-05-21','09:45:00',1.78),('15087','2013-05-21','09:50:00',1.71),('15087','2013-05-21','09:55:00',1.98),('15087','2013-05-21','10:00:00',2.16),('15087','2013-05-21','10:05:00',2.39),('15087','2013-05-21','10:10:00',2.45),('15087','2013-05-21','10:15:00',2.62),('15087','2013-05-21','10:20:00',2.16),('15087','2013-05-21','10:25:00',2.1),('15087','2013-05-21','10:30:00',1.88),('15087','2013-05-21','10:35:00',1.96),('15087','2013-05-21','10:40:00',2.21),('15087','2013-05-21','10:45:00',3.19),('15087','2013-05-21','10:50:00',2.24),('15087','2013-05-21','10:55:00',1.67),('15087','2013-05-21','11:00:00',2.04),('15087','2013-05-21','11:05:00',1.89),('15087','2013-05-21','11:10:00',3.11),('15087','2013-05-21','11:15:00',3.93),('15087','2013-05-21','11:20:00',3.97),('15087','2013-05-21','11:25:00',4.32),('15087','2013-05-21','11:30:00',3.46),('15087','2013-05-21','11:35:00',2.78),('15087','2013-05-21','11:40:00',2.87),('15087','2013-05-21','11:45:00',3.42),('15087','2013-05-21','11:50:00',3.08),('15087','2013-05-21','11:55:00',3.99),('15087','2013-05-21','12:00:00',3.57),('15087','2013-05-21','12:05:00',4.23),('15087','2013-05-21','12:10:00',2.98),('15087','2013-05-21','12:15:00',3.34),('15087','2013-05-21','12:20:00',2.55),('15087','2013-05-21','12:25:00',3.46),('15087','2013-05-21','12:30:00',4.39),('15087','2013-05-21','12:35:00',2.83),('15087','2013-05-21','12:40:00',4.68),('15087','2013-05-21','12:45:00',4.21),('15087','2013-05-21','12:50:00',2.97),('15087','2013-05-21','12:55:00',4.97),('15087','2013-05-21','13:00:00',4.27),('15087','2013-05-21','13:05:00',4.39),('15087','2013-05-21','13:10:00',2.77),('15087','2013-05-21','13:15:00',3.85),('15087','2013-05-21','13:20:00',3.15),('15087','2013-05-21','13:25:00',3.19),('15087','2013-05-21','13:30:00',3.11),('15087','2013-05-21','13:35:00',1.47),('15087','2013-05-21','14:05:00',1.14),('15087','2013-05-21','14:10:00',1.79),('15087','2013-05-21','14:15:00',2.16),('15087','2013-05-21','14:20:00',1.73),('15087','2013-05-21','14:25:00',2.97),('15087','2013-05-21','14:30:00',2.81),('15087','2013-05-21','14:35:00',2.07),('15087','2013-05-21','14:40:00',1.93),('15087','2013-05-21','14:45:00',1.59),('15087','2013-05-21','15:15:00',1.14),('15087','2013-05-21','15:20:00',1.53),('15087','2013-05-21','15:25:00',1.56),('15087','2013-05-21','15:30:00',2.62),('15087','2013-05-21','15:35:00',1.68),('15087','2013-05-21','15:40:00',1.35),('15087','2013-05-21','15:45:00',1.41),('15087','2013-05-21','15:50:00',1.25),('15087','2013-05-21','15:55:00',1.2),('15087','2013-05-21','16:00:00',1.17),('15087','2013-05-21','16:05:00',1.19),('15087','2013-05-21','16:10:00',1.32),('15087','2013-05-21','16:15:00',1.1),('15087','2013-05-21','16:25:00',1.28),('15087','2013-05-21','16:30:00',1.8),('15087','2013-05-21','16:35:00',2.14),('15087','2013-05-21','16:40:00',1.93),('15087','2013-05-21','16:45:00',1.78),('15087','2013-05-21','16:50:00',1.1),('15087','2013-05-20','07:30:00',1.05),('15087','2013-05-20','07:35:00',1.17),('15087','2013-05-20','07:40:00',1.25),('15087','2013-05-20','07:45:00',1.31),('15087','2013-05-20','07:50:00',1.37),('15087','2013-05-20','07:55:00',1.48),('15087','2013-05-20','08:00:00',1.57),('15087','2013-05-20','08:05:00',1.23),('15087','2013-05-20','08:10:00',1.38),('15087','2013-05-20','08:15:00',1.26),('15087','2013-05-20','08:20:00',1.72),('15087','2013-05-20','08:45:00',2.47),('15087','2013-05-20','08:50:00',3.19),('15087','2013-05-20','08:55:00',2.77),('15087','2013-05-20','09:00:00',2.74),('15087','2013-05-20','09:05:00',2.25),('15087','2013-05-20','09:10:00',3.67),('15087','2013-05-20','09:15:00',1.47),('15087','2013-05-20','09:20:00',2.04),('15087','2013-05-20','09:25:00',1.17),('15087','2013-05-20','09:30:00',1.13),('15087','2013-05-20','09:35:00',2.54),('15087','2013-05-20','09:45:00',2.13),('15087','2013-05-20','09:50:00',2.6),('15087','2013-05-20','10:00:00',1.06),('15087','2013-05-20','10:05:00',1.57),('15087','2013-05-20','10:10:00',2.6),('15087','2013-05-20','10:25:00',2.2),('15087','2013-05-20','10:30:00',3.65),('15087','2013-05-20','10:35:00',1.98),('15087','2013-05-20','10:40:00',1.78),('15087','2013-05-20','10:45:00',1.66),('15087','2013-05-20','10:50:00',1.71),('15087','2013-05-20','10:55:00',1.12),('15087','2013-05-20','11:00:00',4.68),('15087','2013-05-20','11:05:00',3.33),('15087','2013-05-20','11:10:00',4.77),('15087','2013-05-20','11:15:00',3.74),('15087','2013-05-20','11:20:00',2.7),('15087','2013-05-20','11:25:00',3.86),('15087','2013-05-20','11:40:00',1.95),('15087','2013-05-20','11:45:00',2),('15087','2013-05-20','11:50:00',1.71),('15087','2013-05-20','11:55:00',3.52),('15087','2013-05-20','12:00:00',3.04),('15087','2013-05-20','12:05:00',3.43),('15087','2013-05-20','12:10:00',2.16),('15087','2013-05-20','12:15:00',2.15),('15087','2013-05-20','12:20:00',2.36),('15087','2013-05-20','12:25:00',2.37),('15087','2013-05-20','12:30:00',2.83),('15087','2013-05-20','12:35:00',2.46),('15087','2013-05-20','12:40:00',2.85),('15087','2013-05-20','12:45:00',3.93),('15087','2013-05-20','12:50:00',1.77),('15087','2013-05-20','12:55:00',3.5),('15087','2013-05-20','13:00:00',2.05),('15087','2013-05-20','13:05:00',3.04),('15087','2013-05-20','13:10:00',2.21),('15087','2013-05-20','13:15:00',2.31),('15087','2013-05-20','13:20:00',4.45),('15087','2013-05-20','13:25:00',5.53),('15087','2013-05-20','13:30:00',1.39),('15087','2013-05-20','13:35:00',5.04),('15087','2013-05-20','13:40:00',1.58),('15087','2013-05-20','13:45:00',5.1),('15087','2013-05-20','13:50:00',3.3),('15087','2013-05-20','13:55:00',4.75),('15087','2013-05-20','14:00:00',4.57),('15087','2013-05-20','14:10:00',3.55),('15087','2013-05-20','14:15:00',3.74),('15087','2013-05-20','14:20:00',2.16),('15087','2013-05-20','14:25:00',4.51),('15087','2013-05-20','14:30:00',4.84),('15087','2013-05-20','14:35:00',3.31),('15087','2013-05-20','14:40:00',2.32),('15087','2013-05-20','14:45:00',4.54),('15087','2013-05-20','14:50:00',3.56),('15087','2013-05-20','14:55:00',4.77),('15087','2013-05-20','15:00:00',2.39),('15087','2013-05-20','15:05:00',2.59),('15087','2013-05-20','15:10:00',4.56),('15087','2013-05-20','15:15:00',1.86),('15087','2013-05-20','15:20:00',4.54),('15087','2013-05-20','15:25:00',4),('15087','2013-05-20','15:30:00',4.38),('15087','2013-05-20','15:35:00',4.31),('15087','2013-05-20','15:40:00',1.88),('15087','2013-05-20','15:45:00',1.91),('15087','2013-05-20','15:50:00',2.7),('15087','2013-05-20','15:55:00',2.33),('15087','2013-05-20','16:00:00',2.28),('15087','2013-05-20','16:05:00',3.65),('15087','2013-05-20','16:10:00',3.69),('15087','2013-05-20','16:15:00',3.21),('15087','2013-05-20','16:20:00',3.37),('15087','2013-05-20','16:25:00',3.34),('15087','2013-05-20','16:30:00',3.15),('15087','2013-05-20','16:35:00',3),('15087','2013-05-20','16:40:00',3.04),('15087','2013-05-20','16:45:00',2.8),('15087','2013-05-20','16:50:00',2.71),('15087','2013-05-20','16:55:00',2.67),('15087','2013-05-20','17:00:00',2.48),('15087','2013-05-20','17:05:00',2.56),('15087','2013-05-20','17:10:00',1.94),('15087','2013-05-20','17:15:00',1.25),('15087','2013-05-20','17:20:00',2.24),('15087','2013-05-20','17:25:00',2.67),('15087','2013-05-20','17:30:00',2.63),('15087','2013-05-20','17:35:00',2.05),('15087','2013-05-20','17:40:00',1.88),('15087','2013-05-20','17:45:00',1.75),('15087','2013-05-20','17:50:00',1.61),('15087','2013-05-20','17:55:00',1.59),('15087','2013-05-20','18:00:00',1.5),('15087','2013-05-20','18:05:00',1.56),('15087','2013-05-20','18:10:00',1.27),('15087','2013-05-20','18:15:00',1.4),('15087','2013-05-20','18:20:00',1.19),('15087','2013-05-20','18:25:00',1.04),('15087','2013-05-19','08:35:00',1.28),('15087','2013-05-19','08:45:00',1.06),('15087','2013-05-19','08:50:00',1.29),('15087','2013-05-19','08:55:00',1.43),('15087','2013-05-19','09:00:00',1.28),('15087','2013-05-19','09:05:00',1.19),('15087','2013-05-19','09:10:00',1.37),('15087','2013-05-19','09:15:00',1.36),('15087','2013-05-19','09:40:00',1.13),('15087','2013-05-19','09:45:00',1.26),('15087','2013-05-19','09:55:00',1.1),('15087','2013-05-19','10:00:00',1.4),('15087','2013-05-19','10:05:00',1.73),('15087','2013-05-19','10:10:00',2.57),('15087','2013-05-19','10:15:00',3.12),('15087','2013-05-19','10:20:00',3.15),('15087','2013-05-19','10:25:00',2.66),('15087','2013-05-19','10:30:00',3.47),('15087','2013-05-19','10:35:00',4.03),('15087','2013-05-19','10:40:00',4.39),('15087','2013-05-19','10:45:00',4.39),('15087','2013-05-19','11:00:00',3.66),('15087','2013-05-19','11:05:00',2.16),('15087','2013-05-19','11:10:00',3.45),('15087','2013-05-19','11:15:00',4.31),('15087','2013-05-19','11:20:00',3.22),('15087','2013-05-19','11:25:00',4.72),('15087','2013-05-19','11:30:00',4.76),('15087','2013-05-19','11:35:00',4.75),('15087','2013-05-19','11:40:00',2.68),('15087','2013-05-19','11:45:00',4.82),('15087','2013-05-19','11:50:00',4.83),('15087','2013-05-19','11:55:00',4.96),('15087','2013-05-19','12:00:00',2.96),('15087','2013-05-19','12:05:00',4.79),('15087','2013-05-19','12:10:00',4.89),('15087','2013-05-19','12:15:00',5.05),('15087','2013-05-19','12:20:00',3.67),('15087','2013-05-19','12:25:00',3.47),('15087','2013-05-19','12:30:00',3.23),('15087','2013-05-19','12:35:00',3.22),('15087','2013-05-19','12:40:00',4.23),('15087','2013-05-19','12:45:00',4.48),('15087','2013-05-19','12:50:00',3.5),('15087','2013-05-19','12:55:00',2.88),('15087','2013-05-19','13:00:00',3.94),('15087','2013-05-19','13:05:00',4.06),('15087','2013-05-19','13:10:00',4.15),('15087','2013-05-19','13:15:00',4.04),('15087','2013-05-19','13:20:00',3.97),('15087','2013-05-19','13:25:00',4.9),('15087','2013-05-19','13:30:00',4.8),('15087','2013-05-19','13:35:00',4.89),('15087','2013-05-19','13:40:00',4.88),('15087','2013-05-19','13:45:00',4.86),('15087','2013-05-19','13:50:00',4.86),('15087','2013-05-19','13:55:00',4.82),('15087','2013-05-19','14:00:00',4.82),('15087','2013-05-19','14:05:00',4.79),('15087','2013-05-19','14:10:00',4.78),('15087','2013-05-19','14:15:00',4.71),('15087','2013-05-19','14:20:00',4.56),('15087','2013-05-19','14:25:00',4.29),('15087','2013-05-19','14:30:00',4.37),('15087','2013-05-19','14:35:00',4.59),('15087','2013-05-19','14:40:00',4.57),('15087','2013-05-19','14:45:00',4.39),('15087','2013-05-19','14:50:00',4.37),('15087','2013-05-19','14:55:00',4.4),('15087','2013-05-19','15:00:00',4.36),('15087','2013-05-19','15:05:00',4.31),('15087','2013-05-19','15:10:00',4.04),('15087','2013-05-19','15:15:00',3.75),('15087','2013-05-19','15:20:00',4.07),('15087','2013-05-19','15:25:00',4.08),('15087','2013-05-19','15:30:00',3.99),('15087','2013-05-19','15:35:00',3.87),('15087','2013-05-19','15:40:00',3.8),('15087','2013-05-19','15:45:00',3.77),('15087','2013-05-19','15:50:00',3.7),('15087','2013-05-19','15:55:00',3.58),('15087','2013-05-19','16:00:00',3.38),('15087','2013-05-19','16:05:00',3.44),('15087','2013-05-19','16:10:00',3.38),('15087','2013-05-19','16:15:00',3.29),('15087','2013-05-19','16:20:00',3.22),('15087','2013-05-19','16:25:00',3.18),('15087','2013-05-19','16:30:00',3.1),('15087','2013-05-19','16:35:00',3.05),('15087','2013-05-19','16:40:00',3.03),('15087','2013-05-19','16:45:00',2.93),('15087','2013-05-19','16:50:00',2.84),('15087','2013-05-19','16:55:00',2.78),('15087','2013-05-19','17:00:00',2.73),('15087','2013-05-19','17:05:00',2.65),('15087','2013-05-19','17:10:00',2.58),('15087','2013-05-19','17:15:00',2.55),('15087','2013-05-19','17:20:00',2.53),('15087','2013-05-19','17:25:00',2.37),('15087','2013-05-19','17:30:00',2.25),('15087','2013-05-19','17:35:00',2.11),('15087','2013-05-19','17:40:00',1.98),('15087','2013-05-19','17:45:00',1.91),('15087','2013-05-19','17:50:00',1.86),('15087','2013-05-19','17:55:00',1.68),('15087','2013-05-19','18:00:00',1.62),('15087','2013-05-19','18:05:00',1.53),('15087','2013-05-19','18:10:00',1.46),('15087','2013-05-19','18:15:00',1.34),('15087','2013-05-19','18:20:00',1.22),('15087','2013-05-19','18:25:00',1.12),('15087','2013-05-19','18:30:00',1),('15087','2013-05-18','07:30:00',1.02),('15087','2013-05-18','07:35:00',1.1),('15087','2013-05-18','07:40:00',1.23),('15087','2013-05-18','07:45:00',1.19),('15087','2013-05-18','07:50:00',1.19),('15087','2013-05-18','07:55:00',1.84),('15087','2013-05-18','08:00:00',2.04),('15087','2013-05-18','08:05:00',1.89),('15087','2013-05-18','08:20:00',1.47),('15087','2013-05-18','08:25:00',2.61),('15087','2013-05-18','08:30:00',2.19),('15087','2013-05-18','08:35:00',2.07),('15087','2013-05-18','08:40:00',2.47),('15087','2013-05-18','08:45:00',2.43),('15087','2013-05-18','08:50:00',2.51),('15087','2013-05-18','08:55:00',2.6),('15087','2013-05-18','09:00:00',2.68),('15087','2013-05-18','09:05:00',2.68),('15087','2013-05-18','09:10:00',2.88),('15087','2013-05-18','09:15:00',2.93),('15087','2013-05-18','09:20:00',2.99),('15087','2013-05-18','09:25:00',3.04),('15087','2013-05-18','09:30:00',3.13),('15087','2013-05-18','09:35:00',3.21),('15087','2013-05-18','09:40:00',3.28),('15087','2013-05-18','09:45:00',3.35),('15087','2013-05-18','09:50:00',3.4),('15087','2013-05-18','09:55:00',3.49),('15087','2013-05-18','10:00:00',3.53),('15087','2013-05-18','10:05:00',3.61),('15087','2013-05-18','10:10:00',3.68),('15087','2013-05-18','10:15:00',3.72),('15087','2013-05-18','10:20:00',3.78),('15087','2013-05-18','10:25:00',3.82),('15087','2013-05-18','10:30:00',3.84),('15087','2013-05-18','10:35:00',3.9),('15087','2013-05-18','10:40:00',3.93),('15087','2013-05-18','10:45:00',4.01),('15087','2013-05-18','10:50:00',4.08),('15087','2013-05-18','10:55:00',3.93),('15087','2013-05-18','11:00:00',4.35),('15087','2013-05-18','11:05:00',3.86),('15087','2013-05-18','11:10:00',3.51),('15087','2013-05-18','11:15:00',4.53),('15087','2013-05-18','11:20:00',4.45),('15087','2013-05-18','11:25:00',4.53),('15087','2013-05-18','11:30:00',4.11),('15087','2013-05-18','11:35:00',4.26),('15087','2013-05-18','11:40:00',4.44),('15087','2013-05-18','11:45:00',4.37),('15087','2013-05-18','11:50:00',4.16),('15087','2013-05-18','11:55:00',4.12),('15087','2013-05-18','12:00:00',4.17),('15087','2013-05-18','12:05:00',4.44),('15087','2013-05-18','12:10:00',4.4),('15087','2013-05-18','12:15:00',4.45),('15087','2013-05-18','12:20:00',4.5),('15087','2013-05-18','12:25:00',4.6),('15087','2013-05-18','12:30:00',3.42),('15087','2013-05-18','12:35:00',4.56),('15087','2013-05-18','12:40:00',4.52),('15087','2013-05-18','12:45:00',4.01),('15087','2013-05-18','12:50:00',4.54),('15087','2013-05-18','12:55:00',4.38),('15087','2013-05-18','13:00:00',4.51),('15087','2013-05-18','13:05:00',4.5),('15087','2013-05-18','13:10:00',4.54),('15087','2013-05-18','13:15:00',4.49),('15087','2013-05-18','13:20:00',4.54),('15087','2013-05-18','13:25:00',4.55),('15087','2013-05-18','13:30:00',4.49),('15087','2013-05-18','13:35:00',4.19),('15087','2013-05-18','13:40:00',4.36),('15087','2013-05-18','13:45:00',4.74),('15087','2013-05-18','13:50:00',4.32),('15087','2013-05-18','13:55:00',3.46),('15087','2013-05-18','14:00:00',3.3),('15087','2013-05-18','14:05:00',3.6),('15087','2013-05-18','14:10:00',4.78),('15087','2013-05-18','14:15:00',4.65),('15087','2013-05-18','14:20:00',4.56),('15087','2013-05-18','14:25:00',4.33),('15087','2013-05-18','14:30:00',4.32),('15087','2013-05-18','14:35:00',4.31),('15087','2013-05-18','14:40:00',4.52),('15087','2013-05-18','14:45:00',4.31),('15087','2013-05-18','14:50:00',4.14),('15087','2013-05-18','14:55:00',3.7),('15087','2013-05-18','15:00:00',3.84),('15087','2013-05-18','15:05:00',3.76),('15087','2013-05-18','15:10:00',3.61),('15087','2013-05-18','15:15:00',3.55),('15087','2013-05-18','15:20:00',3.55),('15087','2013-05-18','15:25:00',3.5),('15087','2013-05-18','15:30:00',3.42),('15087','2013-05-18','15:35:00',3.31),('15087','2013-05-18','15:40:00',3.13),('15087','2013-05-18','15:45:00',3.08),('15087','2013-05-18','15:50:00',3.15),('15087','2013-05-18','15:55:00',3.09),('15087','2013-05-18','16:00:00',3.01),('15087','2013-05-18','16:05:00',2.97),('15087','2013-05-18','16:10:00',2.89),('15087','2013-05-18','16:15:00',2.84),('15087','2013-05-18','16:20:00',2.78),('15087','2013-05-18','16:25:00',2.68),('15087','2013-05-18','16:30:00',2.68),('15087','2013-05-18','16:35:00',2.62),('15087','2013-05-18','16:40:00',2.6),('15087','2013-05-18','16:45:00',2.42),('15087','2013-05-18','16:50:00',2.35),('15087','2013-05-18','16:55:00',2.18),('15087','2013-05-18','17:00:00',2.12),('15087','2013-05-18','17:05:00',2.13),('15087','2013-05-18','17:10:00',2.06),('15087','2013-05-18','17:15:00',2.01),('15087','2013-05-18','17:20:00',1.96),('15087','2013-05-18','17:25:00',1.87),('15087','2013-05-18','17:30:00',1.77),('15087','2013-05-18','17:35:00',1.69),('15087','2013-05-18','17:40:00',1.6),('15087','2013-05-18','17:45:00',1.51),('15087','2013-05-18','17:50:00',1.44),('15087','2013-05-18','17:55:00',1.34),('15087','2013-05-18','18:00:00',1.28),('15087','2013-05-18','18:05:00',1.21),('15087','2013-05-18','18:10:00',1.17),('15087','2013-05-18','18:15:00',1.08),('15087','2013-05-18','18:20:00',1),('15087','2013-05-17','07:40:00',1.18),('15087','2013-05-17','07:45:00',1.19),('15087','2013-05-17','07:50:00',1.23),('15087','2013-05-17','07:55:00',1.25),('15087','2013-05-17','08:00:00',1.15),('15087','2013-05-17','08:10:00',1.31),('15087','2013-05-17','08:15:00',2.03),('15087','2013-05-17','08:20:00',2.26),('15087','2013-05-17','08:25:00',1.66),('15087','2013-05-17','09:25:00',1.11),('15087','2013-05-17','10:25:00',1.44),('15087','2013-05-17','10:30:00',1.77),('15087','2013-05-17','10:35:00',1.29),('15087','2013-05-17','10:40:00',1.51),('15087','2013-05-17','10:45:00',1.67),('15087','2013-05-17','10:50:00',3),('15087','2013-05-17','10:55:00',3.23),('15087','2013-05-17','11:00:00',2.55),('15087','2013-05-17','11:05:00',2.17),('15087','2013-05-17','11:10:00',1.54),('15087','2013-05-17','11:15:00',2.37),('15087','2013-05-17','11:20:00',2.11),('15087','2013-05-17','11:25:00',1.86),('15087','2013-05-17','11:30:00',1.75),('15087','2013-05-17','11:35:00',2.31),('15087','2013-05-17','11:40:00',1.86),('15087','2013-05-17','11:45:00',4.26),('15087','2013-05-17','11:50:00',4.81),('15087','2013-05-17','11:55:00',4.01),('15087','2013-05-17','12:00:00',4.89),('15087','2013-05-17','12:05:00',3.52),('15087','2013-05-17','12:10:00',3.79),('15087','2013-05-17','12:15:00',2.38),('15087','2013-05-17','12:20:00',4.06),('15087','2013-05-17','12:25:00',3.51),('15087','2013-05-17','12:30:00',2.49),('15087','2013-05-17','12:35:00',3.09),('15087','2013-05-17','12:40:00',5.15),('15087','2013-05-17','12:45:00',5.23),('15087','2013-05-17','12:50:00',5.19),('15087','2013-05-17','12:55:00',4.66),('15087','2013-05-17','13:00:00',3.96),('15087','2013-05-17','13:05:00',4.42),('15087','2013-05-17','13:10:00',4.26),('15087','2013-05-17','13:15:00',5.03),('15087','2013-05-17','13:20:00',5.21),('15087','2013-05-17','13:25:00',4.87),('15087','2013-05-17','13:30:00',3.8),('15087','2013-05-17','13:35:00',4.92),('15087','2013-05-17','13:40:00',4.31),('15087','2013-05-17','13:45:00',4.21),('15087','2013-05-17','13:50:00',4.46),('15087','2013-05-17','13:55:00',5.23),('15087','2013-05-17','14:00:00',3.32),('15087','2013-05-17','14:05:00',3.95),('15087','2013-05-17','14:10:00',4.18),('15087','2013-05-17','14:15:00',4.54),('15087','2013-05-17','14:20:00',4.81),('15087','2013-05-17','14:25:00',4.09),('15087','2013-05-17','14:30:00',4.29),('15087','2013-05-17','14:35:00',4.2),('15087','2013-05-17','14:40:00',2.76),('15087','2013-05-17','14:45:00',3.55),('15087','2013-05-17','14:50:00',4.53),('15087','2013-05-17','14:55:00',2.42),('15087','2013-05-17','15:00:00',4.75),('15087','2013-05-17','15:05:00',2.84),('15087','2013-05-17','15:10:00',1.36),('15087','2013-05-17','15:15:00',3.43),('15087','2013-05-17','15:20:00',2.15),('15087','2013-05-17','15:25:00',1.75),('15087','2013-05-17','15:30:00',2.18),('15087','2013-05-17','15:35:00',2.71),('15087','2013-05-17','15:40:00',2.99),('15087','2013-05-17','15:45:00',1.64),('15087','2013-05-17','15:50:00',3.7),('15087','2013-05-17','15:55:00',4.01),('15087','2013-05-17','16:00:00',3.88),('15087','2013-05-17','16:05:00',2.73),('15087','2013-05-17','16:10:00',3.8),('15087','2013-05-17','16:15:00',2.99),('15087','2013-05-17','16:20:00',2.77),('15087','2013-05-17','16:25:00',3.19),('15087','2013-05-17','16:30:00',3.37),('15087','2013-05-17','16:35:00',3.49),('15087','2013-05-17','16:40:00',3.4),('15087','2013-05-17','16:45:00',3.06),('15087','2013-05-17','16:50:00',2.77),('15087','2013-05-17','16:55:00',2.67),('15087','2013-05-17','17:00:00',2.61),('15087','2013-05-17','17:05:00',2.52),('15087','2013-05-17','17:10:00',2.43),('15087','2013-05-17','17:15:00',2.4),('15087','2013-05-17','17:20:00',2.37),('15087','2013-05-17','17:25:00',2.29),('15087','2013-05-17','17:30:00',2.18),('15087','2013-05-17','17:35:00',2.07),('15087','2013-05-17','17:40:00',1.92),('15087','2013-05-17','17:45:00',1.76),('15087','2013-05-17','17:50:00',1.61),('15087','2013-05-17','17:55:00',1.59),('15087','2013-05-17','18:00:00',1.55),('15087','2013-05-17','18:05:00',1.5),('15087','2013-05-17','18:10:00',1.38),('15087','2013-05-17','18:15:00',1.27),('15087','2013-05-17','18:20:00',1.15),('15087','2013-05-17','18:25:00',1.06),('15087','2013-05-16','09:20:00',1.19),('15087','2013-05-16','09:25:00',1.69),('15087','2013-05-16','09:30:00',1.72),('15087','2013-05-16','09:35:00',2.09),('15087','2013-05-16','09:40:00',2.33),('15087','2013-05-16','09:45:00',2.79),('15087','2013-05-16','09:50:00',1.36),('15087','2013-05-16','09:55:00',1.34),('15087','2013-05-16','10:00:00',1.7),('15087','2013-05-16','10:05:00',1.37),('15087','2013-05-16','10:10:00',1.24),('15087','2013-05-16','10:15:00',1.69),('15087','2013-05-16','10:20:00',2.24),('15087','2013-05-16','10:25:00',1.98),('15087','2013-05-16','10:30:00',2.1),('15087','2013-05-16','10:35:00',1.46),('15087','2013-05-16','10:40:00',1.42),('15087','2013-05-16','10:45:00',1.28),('15087','2013-05-16','10:50:00',1.51),('15087','2013-05-16','10:55:00',1.75),('15087','2013-05-16','11:00:00',4.34),('15087','2013-05-16','11:05:00',3.77),('15087','2013-05-16','11:10:00',3.43),('15087','2013-05-16','11:15:00',2.39),('15087','2013-05-16','11:20:00',1.2),('15087','2013-05-16','11:25:00',1.27),('15087','2013-05-16','11:30:00',1.6),('15087','2013-05-16','11:35:00',2.8),('15087','2013-05-16','11:40:00',3.88),('15087','2013-05-16','11:45:00',3.55),('15087','2013-05-16','11:50:00',3.75),('15087','2013-05-16','11:55:00',2.73),('15087','2013-05-16','12:00:00',1.97),('15087','2013-05-16','12:05:00',1.8),('15087','2013-05-16','12:10:00',1.8),('15087','2013-05-16','12:15:00',2.59),('15087','2013-05-16','12:20:00',2.07),('15087','2013-05-16','12:25:00',2.23),('15087','2013-05-16','12:30:00',3.61),('15087','2013-05-16','12:35:00',3.73),('15087','2013-05-16','12:40:00',5.11),('15087','2013-05-16','12:45:00',3.31),('15087','2013-05-16','12:50:00',2.96),('15087','2013-05-16','12:55:00',4.34),('15087','2013-05-16','13:00:00',4.44),('15087','2013-05-16','13:05:00',4.5),('15087','2013-05-16','13:10:00',4.43),('15087','2013-05-16','13:15:00',4.13),('15087','2013-05-16','13:20:00',3.32),('15087','2013-05-16','13:25:00',4.47),('15087','2013-05-16','13:30:00',4.38),('15087','2013-05-16','13:35:00',4.35),('15087','2013-05-16','13:40:00',4.29),('15087','2013-05-16','13:45:00',4.26),('15087','2013-05-16','13:50:00',4.31),('15087','2013-05-16','13:55:00',4.27),('15087','2013-05-16','14:00:00',4.22),('15087','2013-05-16','14:05:00',4.25),('15087','2013-05-16','14:10:00',4.21),('15087','2013-05-16','14:15:00',4.16),('15087','2013-05-16','14:20:00',4.06),('15087','2013-05-16','14:25:00',3.98),('15087','2013-05-16','14:30:00',4),('15087','2013-05-16','14:35:00',3.89),('15087','2013-05-16','14:40:00',3.86),('15087','2013-05-16','14:45:00',3.78),('15087','2013-05-16','14:50:00',3.46),('15087','2013-05-16','14:55:00',3.28),('15087','2013-05-16','15:00:00',3.73),('15087','2013-05-16','15:05:00',3.59),('15087','2013-05-16','15:10:00',3.46),('15087','2013-05-16','15:15:00',3.33),('15087','2013-05-16','15:20:00',3.51),('15087','2013-05-16','15:25:00',3.34),('15087','2013-05-16','15:30:00',3.22),('15087','2013-05-16','15:35:00',3.13),('15087','2013-05-16','15:40:00',3.27),('15087','2013-05-16','15:45:00',3.16),('15087','2013-05-16','15:50:00',3.12),('15087','2013-05-16','15:55:00',3.03),('15087','2013-05-16','16:00:00',2.96),('15087','2013-05-16','16:05:00',2.76),('15087','2013-05-16','16:10:00',2.93),('15087','2013-05-16','16:15:00',2.69),('15087','2013-05-16','16:20:00',2.89),('15087','2013-05-16','16:25:00',2.83),('15087','2013-05-16','16:30:00',2.83),('15087','2013-05-16','16:35:00',2.6),('15087','2013-05-16','16:40:00',1.56),('15087','2013-05-16','16:45:00',1.39),('15087','2013-05-16','16:50:00',1.88),('15087','2013-05-16','16:55:00',1.76),('15087','2013-05-16','17:00:00',1.55),('15087','2013-05-16','17:15:00',1.33),('15087','2013-05-16','17:20:00',1.45),('15087','2013-05-16','17:25:00',1.53),('15087','2013-05-16','17:30:00',1.87),('15087','2013-05-16','17:35:00',1.73),('15087','2013-05-16','17:40:00',1.44),('15087','2013-05-16','17:45:00',1.02),('15087','2013-05-15','07:30:00',1.05),('15087','2013-05-15','07:35:00',1.14),('15087','2013-05-15','07:40:00',1.23),('15087','2013-05-15','07:45:00',1.42),('15087','2013-05-15','07:50:00',1.46),('15087','2013-05-15','07:55:00',1.38),('15087','2013-05-15','08:00:00',1.46),('15087','2013-05-15','08:05:00',1.41),('15087','2013-05-15','08:10:00',1.68),('15087','2013-05-15','08:15:00',1.84),('15087','2013-05-15','08:20:00',1.91),('15087','2013-05-15','08:25:00',1.95),('15087','2013-05-15','08:30:00',2.02),('15087','2013-05-15','08:35:00',2.23),('15087','2013-05-15','08:40:00',2.35),('15087','2013-05-15','08:45:00',2.42),('15087','2013-05-15','08:50:00',2.54),('15087','2013-05-15','08:55:00',2.63),('15087','2013-05-15','09:00:00',2.53),('15087','2013-05-15','09:05:00',2.74),('15087','2013-05-15','09:10:00',2.75),('15087','2013-05-15','09:15:00',2.82),('15087','2013-05-15','09:20:00',2.83),('15087','2013-05-15','09:25:00',2.95),('15087','2013-05-15','09:30:00',3.1),('15087','2013-05-15','09:35:00',3.17),('15087','2013-05-15','09:40:00',3.19),('15087','2013-05-15','09:45:00',3.29),('15087','2013-05-15','09:50:00',3.36),('15087','2013-05-15','09:55:00',3.4),('15087','2013-05-15','10:00:00',3.49),('15087','2013-05-15','10:05:00',3.56),('15087','2013-05-15','10:10:00',3.62),('15087','2013-05-15','10:15:00',3.57),('15087','2013-05-15','10:20:00',3.67),('15087','2013-05-15','10:25:00',3.79),('15087','2013-05-15','10:30:00',3.74),('15087','2013-05-15','10:35:00',3.87),('15087','2013-05-15','10:40:00',3.97),('15087','2013-05-15','10:45:00',4.02),('15087','2013-05-15','10:50:00',4.05),('15087','2013-05-15','10:55:00',3.93),('15087','2013-05-15','11:00:00',3.94),('15087','2013-05-15','11:05:00',4.17),('15087','2013-05-15','11:10:00',4.2),('15087','2013-05-15','11:15:00',4.26),('15087','2013-05-15','11:20:00',4.05),('15087','2013-05-15','11:25:00',4.27),('15087','2013-05-15','11:30:00',4.16),('15087','2013-05-15','11:35:00',4.15),('15087','2013-05-15','11:40:00',3.4),('15087','2013-05-15','11:45:00',3.15),('15087','2013-05-15','11:50:00',2.84),('15087','2013-05-15','11:55:00',1.96),('15087','2013-05-15','12:00:00',2.28),('15087','2013-05-15','12:05:00',3.58),('15087','2013-05-15','12:10:00',5.13),('15087','2013-05-15','12:15:00',4.73),('15087','2013-05-15','12:20:00',3.37),('15087','2013-05-15','12:25:00',4.11),('15087','2013-05-15','12:30:00',3.03),('15087','2013-05-15','12:35:00',3.77),('15087','2013-05-15','12:40:00',4.98),('15087','2013-05-15','12:45:00',2.75),('15087','2013-05-15','12:50:00',2.74),('15087','2013-05-15','12:55:00',3.05),('15087','2013-05-15','13:00:00',2.98),('15087','2013-05-15','13:05:00',3.88),('15087','2013-05-15','13:10:00',3.01),('15087','2013-05-15','13:15:00',2.76),('15087','2013-05-15','13:20:00',2.98),('15087','2013-05-15','13:25:00',3.02),('15087','2013-05-15','13:30:00',2.99),('15087','2013-05-15','13:35:00',2.64),('15087','2013-05-15','13:40:00',2.95),('15087','2013-05-15','13:45:00',2.73),('15087','2013-05-15','13:50:00',2.34),('15087','2013-05-15','13:55:00',2.31),('15087','2013-05-15','14:00:00',1.96),('15087','2013-05-15','14:05:00',1.7),('15087','2013-05-15','14:10:00',1.79),('15087','2013-05-15','14:15:00',1.76),('15087','2013-05-15','14:20:00',1.89),('15087','2013-05-15','14:25:00',1.74),('15087','2013-05-15','14:30:00',1.52),('15087','2013-05-15','14:35:00',1.51),('15087','2013-05-15','14:40:00',1.68),('15087','2013-05-15','14:45:00',1.52),('15087','2013-05-15','14:50:00',1.51),('15087','2013-05-15','14:55:00',1.53),('15087','2013-05-15','15:00:00',1.5),('15087','2013-05-15','15:05:00',1.15),('15087','2013-05-15','15:45:00',1.14),('15087','2013-05-15','15:50:00',1.59),('15087','2013-05-15','15:55:00',2.18),('15087','2013-05-15','16:00:00',2.07),('15087','2013-05-15','16:05:00',1.92),('15087','2013-05-15','16:10:00',1.68),('15087','2013-05-15','16:15:00',1.48),('15087','2013-05-15','16:20:00',1.61),('15087','2013-05-15','16:25:00',1.63),('15087','2013-05-15','16:30:00',1.42),('15087','2013-05-15','16:35:00',1.32),('15087','2013-05-15','16:40:00',1.25),('15087','2013-05-15','16:45:00',1.2),('15087','2013-05-15','16:50:00',1.24),('15087','2013-05-15','16:55:00',1.43),('15087','2013-05-15','17:00:00',1.78),('15087','2013-05-15','17:05:00',2.09),('15087','2013-05-15','17:10:00',2.54),('15087','2013-05-15','17:15:00',2.71),('15087','2013-05-15','17:20:00',1.71),('15087','2013-05-15','17:30:00',1.02),('15087','2013-05-14','07:30:00',1.05),('15087','2013-05-14','07:35:00',1.15),('15087','2013-05-14','07:40:00',1.25),('15087','2013-05-14','07:45:00',1.35),('15087','2013-05-14','07:50:00',1.46),('15087','2013-05-14','07:55:00',1.54),('15087','2013-05-14','08:00:00',1.66),('15087','2013-05-14','08:05:00',1.79),('15087','2013-05-14','08:10:00',1.9),('15087','2013-05-14','08:15:00',2.01),('15087','2013-05-14','08:20:00',2.13),('15087','2013-05-14','08:25:00',2.23),('15087','2013-05-14','08:30:00',2.33),('15087','2013-05-14','08:35:00',2.43),('15087','2013-05-14','08:40:00',2.51),('15087','2013-05-14','08:45:00',2.6),('15087','2013-05-14','08:50:00',2.67),('15087','2013-05-14','08:55:00',2.77),('15087','2013-05-14','09:00:00',2.85),('15087','2013-05-14','09:05:00',2.94),('15087','2013-05-14','09:10:00',3.03),('15087','2013-05-14','09:15:00',3.1),('15087','2013-05-14','09:20:00',3.18),('15087','2013-05-14','09:25:00',3.25),('15087','2013-05-14','09:30:00',3.32),('15087','2013-05-14','09:35:00',3.39),('15087','2013-05-14','09:40:00',3.45),('15087','2013-05-14','09:45:00',3.52),('15087','2013-05-14','09:50:00',3.57),('15087','2013-05-14','09:55:00',3.62),('15087','2013-05-14','10:00:00',3.73),('15087','2013-05-14','10:05:00',3.81),('15087','2013-05-14','10:10:00',3.87),('15087','2013-05-14','10:15:00',3.93),('15087','2013-05-14','10:20:00',3.99),('15087','2013-05-14','10:25:00',3.99),('15087','2013-05-14','10:30:00',4.02),('15087','2013-05-14','10:35:00',4.12),('15087','2013-05-14','10:40:00',4.12),('15087','2013-05-14','10:45:00',4.22),('15087','2013-05-14','10:50:00',4.26),('15087','2013-05-14','10:55:00',4.26),('15087','2013-05-14','11:00:00',4.27),('15087','2013-05-14','11:05:00',4.37),('15087','2013-05-14','11:10:00',4.4),('15087','2013-05-14','11:15:00',4.41),('15087','2013-05-14','11:20:00',4.44),('15087','2013-05-14','11:25:00',4.47),('15087','2013-05-14','11:30:00',4.46),('15087','2013-05-14','11:35:00',4.47),('15087','2013-05-14','11:40:00',4.5),('15087','2013-05-14','11:45:00',4.53),('15087','2013-05-14','11:50:00',4.59),('15087','2013-05-14','11:55:00',4.63),('15087','2013-05-14','12:00:00',4.63),('15087','2013-05-14','12:05:00',4.65),('15087','2013-05-14','12:10:00',4.67),('15087','2013-05-14','12:15:00',4.72),('15087','2013-05-14','12:20:00',4.74),('15087','2013-05-14','12:25:00',4.77),('15087','2013-05-14','12:30:00',4.76),('15087','2013-05-14','12:35:00',4.78),('15087','2013-05-14','12:40:00',4.79),('15087','2013-05-14','12:45:00',4.78),('15087','2013-05-14','12:50:00',4.77),('15087','2013-05-14','12:55:00',4.81),('15087','2013-05-14','13:00:00',4.79),('15087','2013-05-14','13:05:00',1.91),('15087','2013-05-14','13:15:00',4.41),('15087','2013-05-14','13:20:00',4.71),('15087','2013-05-14','13:25:00',4.71),('15087','2013-05-14','13:30:00',3.69),('15087','2013-05-14','13:35:00',3.78),('15087','2013-05-14','13:40:00',4.69),('15087','2013-05-14','13:45:00',4.68),('15087','2013-05-14','13:50:00',4.63),('15087','2013-05-14','13:55:00',2.87),('15087','2013-05-14','14:00:00',4.62),('15087','2013-05-14','14:05:00',4.57),('15087','2013-05-14','14:10:00',4.54),('15087','2013-05-14','14:15:00',2.72),('15087','2013-05-14','14:20:00',4.38),('15087','2013-05-14','14:25:00',4.39),('15087','2013-05-14','14:30:00',4.39),('15087','2013-05-14','14:35:00',2.88),('15087','2013-05-14','14:40:00',4.21),('15087','2013-05-14','14:45:00',4.33),('15087','2013-05-14','14:50:00',4.33),('15087','2013-05-14','14:55:00',4.29),('15087','2013-05-14','15:00:00',4.21),('15087','2013-05-14','15:05:00',4.06),('15087','2013-05-14','15:10:00',4.13),('15087','2013-05-14','15:15:00',4.09),('15087','2013-05-14','15:20:00',4.04),('15087','2013-05-14','15:25:00',3.97),('15087','2013-05-14','15:30:00',3.73),('15087','2013-05-14','15:35:00',3.73),('15087','2013-05-14','15:40:00',3.78),('15087','2013-05-14','15:45:00',3.7),('15087','2013-05-14','15:50:00',3.6),('15087','2013-05-14','15:55:00',3.56),('15087','2013-05-14','16:00:00',3.49),('15087','2013-05-14','16:05:00',3.4),('15087','2013-05-14','16:10:00',3.12),('15087','2013-05-14','16:15:00',2.95),('15087','2013-05-14','16:20:00',3.07),('15087','2013-05-14','16:25:00',3.11),('15087','2013-05-14','16:30:00',2.94),('15087','2013-05-14','16:35:00',3.01),('15087','2013-05-14','16:40:00',2.9),('15087','2013-05-14','16:45:00',2.85),('15087','2013-05-14','16:50:00',2.8),('15087','2013-05-14','16:55:00',2.71),('15087','2013-05-14','17:00:00',2.66),('15087','2013-05-14','17:05:00',2.57),('15087','2013-05-14','17:10:00',2.45),('15087','2013-05-14','17:15:00',2.37),('15087','2013-05-14','17:20:00',2.32),('15087','2013-05-14','17:25:00',2.28),('15087','2013-05-14','17:30:00',2.13),('15087','2013-05-14','17:35:00',1.92),('15087','2013-05-14','17:40:00',1.9),('15087','2013-05-14','17:45:00',1.56),('15087','2013-05-14','17:50:00',1.67),('15087','2013-05-14','17:55:00',1.58),('15087','2013-05-14','18:00:00',1.37),('15087','2013-05-14','18:05:00',1.4),('15087','2013-05-14','18:10:00',1.22),('15087','2013-05-14','18:15:00',1.23),('15087','2013-05-14','18:20:00',1.11),('15087','2013-05-13','07:35:00',1.05),('15087','2013-05-13','07:40:00',1.14),('15087','2013-05-13','07:45:00',1.23),('15087','2013-05-13','07:50:00',1.28),('15087','2013-05-13','07:55:00',1.3),('15087','2013-05-13','08:00:00',1.35),('15087','2013-05-13','08:05:00',1.59),('15087','2013-05-13','08:10:00',1.7),('15087','2013-05-13','08:15:00',1.85),('15087','2013-05-13','08:20:00',1.95),('15087','2013-05-13','08:25:00',2),('15087','2013-05-13','08:30:00',2.11),('15087','2013-05-13','08:35:00',2.2),('15087','2013-05-13','08:40:00',2.3),('15087','2013-05-13','08:45:00',2.42),('15087','2013-05-13','08:50:00',2.48),('15087','2013-05-13','08:55:00',2.57),('15087','2013-05-13','09:00:00',2.67),('15087','2013-05-13','09:05:00',2.72),('15087','2013-05-13','09:10:00',2.83),('15087','2013-05-13','09:15:00',2.88),('15087','2013-05-13','09:20:00',2.99),('15087','2013-05-13','09:25:00',3.07),('15087','2013-05-13','09:30:00',3.13),('15087','2013-05-13','09:35:00',3.21),('15087','2013-05-13','09:40:00',3.29),('15087','2013-05-13','09:45:00',3.46),('15087','2013-05-13','09:50:00',3.21),('15087','2013-05-13','09:55:00',3.68),('15087','2013-05-13','10:00:00',3.05),('15087','2013-05-13','10:05:00',3.86),('15087','2013-05-13','10:10:00',3.8),('15087','2013-05-13','10:15:00',3.88),('15087','2013-05-13','10:20:00',4.04),('15087','2013-05-13','10:25:00',4.17),('15087','2013-05-13','10:30:00',4.21),('15087','2013-05-13','10:35:00',1.48),('15087','2013-05-13','10:40:00',1.46),('15087','2013-05-13','10:50:00',3.47),('15087','2013-05-13','10:55:00',2.21),('15087','2013-05-13','11:00:00',4.81),('15087','2013-05-13','11:05:00',2.93),('15087','2013-05-13','11:10:00',3.29),('15087','2013-05-13','11:15:00',2.03),('15087','2013-05-13','11:20:00',1.63),('15087','2013-05-13','11:25:00',1.74),('15087','2013-05-13','11:30:00',1.73),('15087','2013-05-13','11:35:00',2.58),('15087','2013-05-13','11:40:00',4.73),('15087','2013-05-13','11:45:00',2.6),('15087','2013-05-13','11:50:00',3.21),('15087','2013-05-13','11:55:00',1.9),('15087','2013-05-13','12:00:00',2.1),('15087','2013-05-13','12:05:00',2.03),('15087','2013-05-13','12:10:00',4.51),('15087','2013-05-13','12:15:00',2.26),('15087','2013-05-13','12:20:00',1.25),('15087','2013-05-13','12:25:00',1.12),('15087','2013-05-13','12:30:00',1.37),('15087','2013-05-13','12:35:00',5.51),('15087','2013-05-13','12:40:00',5.26),('15087','2013-05-13','12:45:00',5.11),('15087','2013-05-13','12:50:00',4.66),('15087','2013-05-13','12:55:00',3.98),('15087','2013-05-13','13:00:00',3.79),('15087','2013-05-13','13:05:00',5.48),('15087','2013-05-13','13:10:00',4.76),('15087','2013-05-13','13:15:00',3.75),('15087','2013-05-13','13:20:00',4.94),('15087','2013-05-13','13:25:00',5.01),('15087','2013-05-13','13:30:00',4.51),('15087','2013-05-13','13:35:00',4.7),('15087','2013-05-13','13:40:00',4.92),('15087','2013-05-13','13:45:00',4.43),('15087','2013-05-13','13:50:00',1.95),('15087','2013-05-13','13:55:00',3.87),('15087','2013-05-13','14:00:00',4.46),('15087','2013-05-13','14:05:00',5.02),('15087','2013-05-13','14:15:00',1.39),('15087','2013-05-13','14:20:00',4.7),('15087','2013-05-13','14:25:00',4.76),('15087','2013-05-13','14:30:00',3.91),('15087','2013-05-13','14:35:00',2.41),('15087','2013-05-13','14:40:00',2.17),('15087','2013-05-13','14:45:00',2.95),('15087','2013-05-13','14:50:00',4.87),('15087','2013-05-13','14:55:00',3.76),('15087','2013-05-13','15:00:00',3.41),('15087','2013-05-13','15:05:00',1.59),('15087','2013-05-13','15:10:00',1.26),('15087','2013-05-13','15:20:00',1.09),('15087','2013-05-13','16:00:00',1.92),('15087','2013-05-13','16:05:00',2.32),('15087','2013-05-13','16:10:00',2.05),('15087','2013-05-13','16:15:00',1.29),('15087','2013-05-13','16:20:00',1.35),('15087','2013-05-13','16:25:00',1.43),('15087','2013-05-13','16:30:00',2.04),('15087','2013-05-13','16:35:00',1.22),('15087','2013-05-13','16:40:00',1.56),('15087','2013-05-13','16:45:00',2.5),('15087','2013-05-13','16:50:00',3.21),('15087','2013-05-13','16:55:00',3),('15087','2013-05-13','17:00:00',2.94),('15087','2013-05-13','17:05:00',2.89),('15087','2013-05-13','17:10:00',1.17),('15087','2013-05-13','17:15:00',2.62),('15087','2013-05-13','17:20:00',3.26),('15087','2013-05-13','17:25:00',3.12),('15087','2013-05-13','17:30:00',2.95),('15087','2013-05-13','17:35:00',2.69),('15087','2013-05-13','17:40:00',2.4),('15087','2013-05-13','17:45:00',2.23),('15087','2013-05-13','17:50:00',2.03),('15087','2013-05-13','17:55:00',1.21),('15087','2013-05-13','18:00:00',1.76),('15087','2013-05-13','18:05:00',1.62),('15087','2013-05-13','18:10:00',1.06),('15087','2013-05-13','18:15:00',1.32),('15087','2013-05-13','18:20:00',1.01),('15087','2013-05-12','08:10:00',1.47),('15087','2013-05-12','08:15:00',1.45),('15087','2013-05-12','08:20:00',1.34),('15087','2013-05-12','08:25:00',2.02),('15087','2013-05-12','08:30:00',1.12),('15087','2013-05-12','08:40:00',1.03),('15087','2013-05-12','08:45:00',2.56),('15087','2013-05-12','08:50:00',1.35),('15087','2013-05-12','08:55:00',1.15),('15087','2013-05-12','09:00:00',2.07),('15087','2013-05-12','09:05:00',2.96),('15087','2013-05-12','09:10:00',1.73),('15087','2013-05-12','09:15:00',2.31),('15087','2013-05-12','09:20:00',2.2),('15087','2013-05-12','09:25:00',1.91),('15087','2013-05-12','09:30:00',1.23),('15087','2013-05-12','09:35:00',1.18),('15087','2013-05-12','09:40:00',1.17),('15087','2013-05-12','09:45:00',2.33),('15087','2013-05-12','09:50:00',4.14),('15087','2013-05-12','09:55:00',4.09),('15087','2013-05-12','10:00:00',3.74),('15087','2013-05-12','10:05:00',1.57),('15087','2013-05-12','10:10:00',4.02),('15087','2013-05-12','10:15:00',2.7),('15087','2013-05-12','10:20:00',1.81),('15087','2013-05-12','10:25:00',4.31),('15087','2013-05-12','10:30:00',1.97),('15087','2013-05-12','10:35:00',1.37),('15087','2013-05-12','10:40:00',1.03),('15087','2013-05-12','10:45:00',1.42),('15087','2013-05-12','10:50:00',2.16),('15087','2013-05-12','10:55:00',4.01),('15087','2013-05-12','11:00:00',3.43),('15087','2013-05-12','11:05:00',3.2),('15087','2013-05-12','11:10:00',4.87),('15087','2013-05-12','11:15:00',4.77),('15087','2013-05-12','11:20:00',4.84),('15087','2013-05-12','11:25:00',3.89),('15087','2013-05-12','11:30:00',2.97),('15087','2013-05-12','11:35:00',4.93),('15087','2013-05-12','11:40:00',3.66),('15087','2013-05-12','11:45:00',2.65),('15087','2013-05-12','11:50:00',1.88),('15087','2013-05-12','11:55:00',1.49),('15087','2013-05-12','12:00:00',2.87),('15087','2013-05-12','12:05:00',3.3),('15087','2013-05-12','12:10:00',1.71),('15087','2013-05-12','12:15:00',1.26),('15087','2013-05-12','12:20:00',1.16),('15087','2013-05-12','12:25:00',1.19),('15087','2013-05-12','12:30:00',2.4),('15087','2013-05-12','12:35:00',4.57),('15087','2013-05-12','12:40:00',3.09),('15087','2013-05-12','12:45:00',3.62),('15087','2013-05-12','12:50:00',4.48),('15087','2013-05-12','12:55:00',4.09),('15087','2013-05-12','13:00:00',1.45),('15087','2013-05-12','13:05:00',3.07),('15087','2013-05-12','13:10:00',4.42),('15087','2013-05-12','13:15:00',1.75),('15087','2013-05-12','13:20:00',3.64),('15087','2013-05-12','13:25:00',3.98),('15087','2013-05-12','13:30:00',5.17),('15087','2013-05-12','13:35:00',4.29),('15087','2013-05-12','13:40:00',4),('15087','2013-05-12','13:45:00',4.27),('15087','2013-05-12','13:50:00',5.55),('15087','2013-05-12','13:55:00',2.13),('15087','2013-05-12','14:00:00',4.25),('15087','2013-05-12','14:05:00',4.76),('15087','2013-05-12','14:10:00',5.2),('15087','2013-05-12','14:15:00',4.53),('15087','2013-05-12','14:20:00',4.98),('15087','2013-05-12','14:25:00',4.24),('15087','2013-05-12','14:30:00',4.77),('15087','2013-05-12','14:35:00',4.78),('15087','2013-05-12','14:40:00',4.44),('15087','2013-05-12','14:45:00',3.98),('15087','2013-05-12','14:50:00',4.51),('15087','2013-05-12','14:55:00',3.67),('15087','2013-05-12','15:00:00',4.46),('15087','2013-05-12','15:05:00',4.08),('15087','2013-05-12','15:10:00',2.54),('15087','2013-05-12','15:15:00',3.75),('15087','2013-05-12','15:20:00',2.18),('15087','2013-05-12','15:25:00',3.97),('15087','2013-05-12','15:30:00',3.76),('15087','2013-05-12','15:35:00',3.86),('15087','2013-05-12','15:40:00',3.81),('15087','2013-05-12','15:45:00',3.7),('15087','2013-05-12','15:50:00',3.59),('15087','2013-05-12','15:55:00',3.48),('15087','2013-05-12','16:00:00',3.26),('15087','2013-05-12','16:05:00',3.34),('15087','2013-05-12','16:10:00',3.13),('15087','2013-05-12','16:15:00',3.04),('15087','2013-05-12','16:20:00',3.18),('15087','2013-05-12','16:25:00',3.02),('15087','2013-05-12','16:30:00',2.96),('15087','2013-05-12','16:35:00',3.02),('15087','2013-05-12','16:40:00',2.98),('15087','2013-05-12','16:45:00',2.92),('15087','2013-05-12','16:50:00',2.78),('15087','2013-05-12','16:55:00',3.49),('15087','2013-05-12','17:00:00',3.4),('15087','2013-05-12','17:05:00',2.82),('15087','2013-05-12','17:10:00',3.28),('15087','2013-05-12','17:15:00',2.75),('15087','2013-05-12','17:20:00',2.96),('15087','2013-05-12','17:25:00',2.35),('15087','2013-05-12','17:30:00',1.96),('15087','2013-05-12','17:35:00',2.59),('15087','2013-05-12','17:40:00',1.7),('15087','2013-05-12','17:45:00',1.61),('15087','2013-05-12','17:50:00',1.33),('15087','2013-05-12','18:00:00',1.85),('15087','2013-05-12','18:05:00',1.85),('15087','2013-05-12','18:10:00',1.8),('15087','2013-05-12','18:15:00',1.55),('15087','2013-05-12','18:20:00',1.13),('15087','2013-05-12','18:25:00',1.35),('15087','2013-05-12','18:30:00',1.2),('15087','2013-05-12','18:35:00',1.24),('15087','2013-05-12','18:40:00',1.01),('15087','2014-03-31','08:20:00',1.09),('15087','2014-03-31','08:25:00',1.18),('15087','2014-03-31','08:30:00',1.3),('15087','2014-03-31','08:35:00',1.39),('15087','2014-03-31','08:40:00',1.48),('15087','2014-03-31','08:45:00',1.6),('15087','2014-03-31','08:50:00',1.69),('15087','2014-03-31','08:55:00',1.77),('15087','2014-03-31','09:00:00',1.9),('15087','2014-03-31','09:05:00',2.02),('15087','2014-03-31','09:10:00',2.12),('15087','2014-03-31','09:15:00',2.21),('15087','2014-03-31','09:20:00',2.29),('15087','2014-03-31','09:25:00',2.4),('15087','2014-03-31','09:30:00',2.49),('15087','2014-03-31','09:35:00',2.57),('15087','2014-03-31','09:40:00',2.65),('15087','2014-03-31','09:45:00',2.73),('15087','2014-03-31','09:50:00',2.81),('15087','2014-03-31','09:55:00',2.9),('15087','2014-03-31','10:00:00',2.95),('15087','2014-03-31','10:05:00',3),('15087','2014-03-31','10:10:00',3.06),('15087','2014-03-31','10:15:00',3.13),('15087','2014-03-31','10:20:00',3.23),('15087','2014-03-31','10:25:00',3.32),('15087','2014-03-31','10:30:00',3.35),('15087','2014-03-31','10:35:00',3.39),('15087','2014-03-31','10:40:00',3.47),('15087','2014-03-31','10:45:00',3.56),('15087','2014-03-31','10:50:00',3.62),('15087','2014-03-31','10:55:00',3.64),('15087','2014-03-31','11:00:00',3.68),('15087','2014-03-31','11:05:00',3.73),('15087','2014-03-31','11:10:00',3.78),('15087','2014-03-31','11:15:00',3.82),('15087','2014-03-31','11:20:00',3.88),('15087','2014-03-31','11:25:00',3.96),('15087','2014-03-31','11:30:00',3.98),('15087','2014-03-31','11:35:00',3.98),('15087','2014-03-31','11:40:00',4.02),('15087','2014-03-31','11:45:00',4.08),('15087','2014-03-31','11:50:00',4.12),('15087','2014-03-31','11:55:00',4.16),('15087','2014-03-31','12:00:00',4.14),('15087','2014-03-31','12:05:00',4.14),('15087','2014-03-31','12:10:00',4.19),('15087','2014-03-31','12:15:00',4.26),('15087','2014-03-31','12:20:00',4.25),('15087','2014-03-31','12:25:00',4.27),('15087','2014-03-31','12:30:00',4.31),('15087','2014-03-31','12:35:00',4.35),('15087','2014-03-31','12:40:00',4.36),('15087','2014-03-31','12:45:00',4.3),('15087','2014-03-31','12:50:00',4.29),('15087','2014-03-31','12:55:00',4.29),('15087','2014-03-31','13:00:00',4.34),('15087','2014-03-31','13:05:00',4.38),('15087','2014-03-31','13:10:00',4.39),('15087','2014-03-31','13:15:00',4.4),('15087','2014-03-31','13:20:00',4.35),('15087','2014-03-31','13:25:00',4.38),('15087','2014-03-31','13:30:00',4.4),('15087','2014-03-31','13:35:00',4.39),('15087','2014-03-31','13:40:00',4.41),('15087','2014-03-31','13:45:00',4.39),('15087','2014-03-31','13:50:00',4.35),('15087','2014-03-31','13:55:00',4.2),('15087','2014-03-31','14:00:00',4.13),('15087','2014-03-31','14:05:00',4.12),('15087','2014-03-31','14:10:00',4.25),('15087','2014-03-31','14:15:00',4.08),('15087','2014-03-31','14:20:00',4.07),('15087','2014-03-31','14:25:00',4.11),('15087','2014-03-31','14:30:00',4.04),('15087','2014-03-31','14:35:00',3.92),('15087','2014-03-31','14:40:00',3.98),('15087','2014-03-31','14:45:00',3.94),('15087','2014-03-31','14:50:00',3.88),('15087','2014-03-31','14:55:00',3.69),('15087','2014-03-31','15:00:00',3.67),('15087','2014-03-31','15:05:00',3.57),('15087','2014-03-31','15:10:00',3.6),('15087','2014-03-31','15:15:00',3.42),('15087','2014-03-31','15:20:00',3.4),('15087','2014-03-31','15:25:00',3.42),('15087','2014-03-31','15:30:00',3.16),('15087','2014-03-31','15:35:00',2.99),('15087','2014-03-31','15:40:00',3.21),('15087','2014-03-31','15:45:00',3.11),('15087','2014-03-31','15:50:00',3.1),('15087','2014-03-31','15:55:00',2.99),('15087','2014-03-31','16:00:00',2.77),('15087','2014-03-31','16:05:00',2.7),('15087','2014-03-31','16:10:00',2.74),('15087','2014-03-31','16:15:00',2.68),('15087','2014-03-31','16:20:00',2.65),('15087','2014-03-31','16:25:00',2.6),('15087','2014-03-31','16:30:00',2.45),('15087','2014-03-31','16:35:00',2.36),('15087','2014-03-31','16:40:00',2.3),('15087','2014-03-31','16:45:00',2.22),('15087','2014-03-31','16:50:00',2.14),('15087','2014-03-31','16:55:00',1.99),('15087','2014-03-31','17:00:00',1.97),('15087','2014-03-31','17:05:00',1.86),('15087','2014-03-31','17:10:00',1.73),('15087','2014-03-31','17:15:00',1.63),('15087','2014-03-31','17:20:00',1.48),('15087','2014-03-31','17:25:00',1.41),('15087','2014-03-31','17:30:00',1.32),('15087','2014-03-31','17:35:00',1.25),('15087','2014-03-31','17:40:00',1.18),('15087','2014-03-31','17:45:00',1.09),('15087','2013-05-11','07:45:00',1.22),('15087','2013-05-11','07:50:00',1.39),('15087','2013-05-11','07:55:00',1.57),('15087','2013-05-11','08:00:00',1.46),('15087','2013-05-11','08:05:00',1.27),('15087','2013-05-11','08:15:00',1.64),('15087','2013-05-11','08:20:00',1.48),('15087','2013-05-11','09:05:00',1.43),('15087','2013-05-11','09:10:00',1.5),('15087','2013-05-11','09:15:00',1.52),('15087','2013-05-11','09:20:00',1.79),('15087','2013-05-11','09:25:00',2.2),('15087','2013-05-11','09:30:00',2.53),('15087','2013-05-11','09:35:00',2.27),('15087','2013-05-11','09:40:00',1.49),('15087','2013-05-11','09:45:00',1.51),('15087','2013-05-11','09:51:00',2.71),('15087','2013-05-11','09:55:00',3.02),('15087','2013-05-11','10:00:00',2.44),('15087','2013-05-11','10:05:00',1.19),('15087','2013-05-11','10:20:00',1.19),('15087','2013-05-11','10:25:00',1.01),('15087','2013-05-11','10:30:00',1.43),('15087','2013-05-11','10:35:00',1.21),('15087','2013-05-11','10:45:00',1.04),('15087','2013-05-11','10:50:00',1.34),('15087','2013-05-11','10:55:00',4.35),('15087','2013-05-11','11:00:00',4.86),('15087','2013-05-11','11:05:00',2.13),('15087','2013-05-11','11:10:00',1.22),('15087','2013-05-11','11:25:00',1.13),('15087','2013-05-11','11:30:00',3.44),('15087','2013-05-11','11:35:00',2.61),('15087','2013-05-11','11:40:00',3.37),('15087','2013-05-11','11:45:00',5.13),('15087','2013-05-11','11:50:00',1.6),('15087','2013-05-11','11:55:00',1.09),('15087','2013-05-11','12:00:00',1.82),('15087','2013-05-11','12:05:00',2.38),('15087','2013-05-11','12:10:00',1.43),('15087','2013-05-11','12:15:00',1.39),('15087','2013-05-11','12:20:00',3.39),('15087','2013-05-11','12:25:00',5.41),('15087','2013-05-11','12:30:00',2.04),('15087','2013-05-11','12:35:00',2.07),('15087','2013-05-11','12:40:00',1.93),('15087','2013-05-11','12:45:00',1.75),('15087','2013-05-11','12:50:00',1.68),('15087','2013-05-11','12:55:00',1.59),('15087','2013-05-11','13:00:00',1.85),('15087','2013-05-11','13:05:00',1.47),('15087','2013-05-11','13:10:00',1.01),('15087','2013-05-11','13:25:00',1.01),('15087','2013-05-11','13:30:00',1.12),('15087','2013-05-11','13:35:00',1.17),('15087','2013-05-11','13:50:00',1.02),('15087','2013-05-11','13:55:00',1.16),('15087','2013-05-11','14:00:00',2.23),('15087','2013-05-11','14:05:00',4.05),('15087','2013-05-11','14:10:00',2.61),('15087','2013-05-11','14:15:00',3.4),('15087','2013-05-11','14:20:00',4.77),('15087','2013-05-11','14:25:00',3.85),('15087','2013-05-11','14:30:00',1.93),('15087','2013-05-11','14:35:00',3.39),('15087','2013-05-11','14:40:00',3.7),('15087','2013-05-11','14:45:00',4.56),('15087','2013-05-11','14:50:00',4.74),('15087','2013-05-11','14:55:00',4.43),('15087','2013-05-11','15:00:00',4.27),('15087','2013-05-11','15:05:00',4.28),('15087','2013-05-11','15:10:00',4.17),('15087','2013-05-11','15:15:00',4.17),('15087','2013-05-11','15:20:00',4.02),('15087','2013-05-11','15:25:00',4.05),('15087','2013-05-11','15:30:00',3.69),('15087','2013-05-11','15:35:00',3.62),('15087','2013-05-11','15:40:00',3.97),('15087','2013-05-11','15:45:00',2.9),('15087','2013-05-11','15:50:00',3.21),('15087','2013-05-11','15:55:00',3.61),('15087','2013-05-11','16:00:00',3.13),('15087','2013-05-11','16:05:00',3.56),('15087','2013-05-11','16:10:00',2.94),('15087','2013-05-11','16:15:00',3.38),('15087','2013-05-11','16:20:00',3.4),('15087','2013-05-11','16:25:00',3.24),('15087','2013-05-11','16:30:00',2.76),('15087','2013-05-11','16:35:00',2.02),('15087','2013-05-11','16:40:00',2.83),('15087','2013-05-11','16:45:00',2.93),('15087','2013-05-11','16:50:00',2.85),('15087','2013-05-11','16:55:00',2.85),('15087','2013-05-11','17:00:00',2.76),('15087','2013-05-11','17:05:00',1.74),('15087','2013-05-11','17:10:00',2.31),('15087','2013-05-11','17:15:00',1.44),('15087','2013-05-11','17:20:00',2.12),('15087','2013-05-11','17:25:00',1.65),('15087','2013-05-11','17:30:00',2.1),('15087','2013-05-11','17:35:00',1.73),('15087','2013-05-11','17:40:00',1.88),('15087','2013-05-11','17:45:00',1.87),('15087','2013-05-11','17:55:00',1.25),('15087','2013-05-11','18:05:00',1.55),('15087','2013-05-11','18:10:00',1.69),('15087','2013-05-11','18:15:00',1.03),('15087','2013-05-11','18:20:00',1.02),('15087','2013-05-11','18:25:00',1.02),('15087','2013-05-11','18:30:00',1.06),('15087','2013-05-10','07:40:00',1.16),('15087','2013-05-10','07:45:00',1.01),('15087','2013-05-10','07:55:00',1.3),('15087','2013-05-10','08:00:00',1.64),('15087','2013-05-10','08:05:00',2.21),('15087','2013-05-10','08:10:00',2.28),('15087','2013-05-10','08:15:00',2.35),('15087','2013-05-10','08:20:00',2.17),('15087','2013-05-10','08:25:00',2.12),('15087','2013-05-10','08:30:00',2.12),('15087','2013-05-10','08:35:00',2.12),('15087','2013-05-10','09:00:00',1.69),('15087','2013-05-10','09:05:00',2.55),('15087','2013-05-10','09:10:00',2.86),('15087','2013-05-10','09:15:00',2.99),('15087','2013-05-10','09:20:00',2.86),('15087','2013-05-10','09:25:00',2.74),('15087','2013-05-10','09:30:00',2.78),('15087','2013-05-10','09:35:00',3.31),('15087','2013-05-10','09:40:00',3.07),('15087','2013-05-10','09:45:00',2.62),('15087','2013-05-10','09:50:00',3.45),('15087','2013-05-10','09:55:00',1.45),('15087','2013-05-10','10:00:00',1.55),('15087','2013-05-10','10:05:00',1.39),('15087','2013-05-10','10:10:00',1.14),('15087','2013-05-10','10:15:00',1.47),('15087','2013-05-10','10:20:00',3.1),('15087','2013-05-10','10:25:00',2.32),('15087','2013-05-10','10:30:00',3.87),('15087','2013-05-10','10:35:00',4.29),('15087','2013-05-10','10:40:00',4.27),('15087','2013-05-10','10:45:00',4.4),('15087','2013-05-10','10:50:00',3.41),('15087','2013-05-10','10:55:00',4.36),('15087','2013-05-10','11:00:00',4.37),('15087','2013-05-10','11:05:00',4.33),('15087','2013-05-10','11:10:00',4.02),('15087','2013-05-10','11:15:00',4.51),('15087','2013-05-10','11:20:00',4.83),('15087','2013-05-10','11:25:00',3.83),('15087','2013-05-10','11:30:00',4.03),('15087','2013-05-10','11:35:00',2.33),('15087','2013-05-10','11:40:00',4.17),('15087','2013-05-10','11:45:00',3.3),('15087','2013-05-10','11:50:00',4.01),('15087','2013-05-10','11:55:00',4.28),('15087','2013-05-10','12:00:00',2.3),('15087','2013-05-10','12:05:00',2.09),('15087','2013-05-10','12:10:00',2.23),('15087','2013-05-10','12:15:00',3.03),('15087','2013-05-10','12:20:00',3.24),('15087','2013-05-10','12:25:00',2.45),('15087','2013-05-10','12:30:00',2.45),('15087','2013-05-10','12:35:00',2.21),('15087','2013-05-10','12:40:00',3.69),('15087','2013-05-10','12:45:00',4.88),('15087','2013-05-10','12:50:00',3.4),('15087','2013-05-10','12:55:00',3.15),('15087','2013-05-10','13:00:00',3.82),('15087','2013-05-10','13:05:00',4.59),('15087','2013-05-10','13:10:00',5.45),('15087','2013-05-10','13:15:00',4.74),('15087','2013-05-10','13:20:00',3.57),('15087','2013-05-10','13:25:00',3.12),('15087','2013-05-10','13:30:00',3.95),('15087','2013-05-10','13:35:00',4.24),('15087','2013-05-10','13:40:00',4.24),('15087','2013-05-10','13:45:00',4.24),('15087','2013-05-10','13:50:00',2.46),('15087','2013-05-10','13:55:00',2.31),('15087','2013-05-10','14:00:00',2.07),('15087','2013-05-10','14:05:00',2.29),('15087','2013-05-10','14:10:00',2.78),('15087','2013-05-10','14:15:00',3.03),('15087','2013-05-10','14:20:00',2.81),('15087','2013-05-10','14:25:00',2.9),('15087','2013-05-10','14:30:00',2.86),('15087','2013-05-10','14:35:00',3.36),('15087','2013-05-10','14:40:00',2.99),('15087','2013-05-10','14:45:00',2.02),('15087','2013-05-10','14:50:00',1.51),('15087','2013-05-10','14:55:00',1.32),('15087','2013-05-10','15:00:00',1.27),('15087','2013-05-10','15:05:00',1.46),('15087','2013-05-10','15:10:00',2.17),('15087','2013-05-10','15:15:00',3.63),('15087','2013-05-10','15:20:00',2.65),('15087','2013-05-10','15:25:00',2.13),('15087','2013-05-10','15:30:00',2.08),('15087','2013-05-10','15:35:00',2.2),('15087','2013-05-10','15:40:00',2.28),('15087','2013-05-10','15:45:00',2.11),('15087','2013-05-10','15:50:00',1.84),('15087','2013-05-10','15:55:00',1.76),('15087','2013-05-10','16:00:00',1.75),('15087','2013-05-10','16:05:00',1.67),('15087','2013-05-10','16:10:00',1.61),('15087','2013-05-10','16:15:00',1.47),('15087','2013-05-10','16:20:00',1.35),('15087','2013-05-10','16:25:00',1.39),('15087','2013-05-10','16:30:00',1.53),('15087','2013-05-10','16:35:00',1.58),('15087','2013-05-10','16:40:00',1.48),('15087','2013-05-10','16:45:00',1.5),('15087','2013-05-10','16:50:00',1.39),('15087','2013-05-10','16:55:00',1.12),('15087','2013-05-10','17:05:00',1),('15087','2013-05-10','17:10:00',1.39),('15087','2013-05-10','17:15:00',1.61),('15087','2013-05-10','17:20:00',2.53),('15087','2013-05-10','17:25:00',2.37),('15087','2013-05-10','17:30:00',2.13),('15087','2013-05-10','17:35:00',2.24),('15087','2013-05-10','17:40:00',1.41),('15087','2013-05-10','17:45:00',1.47),('15087','2013-05-10','17:50:00',1.12),('15087','2013-05-09','07:35:00',1.06),('15087','2013-05-09','07:40:00',1.14),('15087','2013-05-09','07:45:00',1.23),('15087','2013-05-09','07:50:00',1.31),('15087','2013-05-09','07:55:00',1.38),('15087','2013-05-09','08:00:00',1.49),('15087','2013-05-09','08:05:00',1.59),('15087','2013-05-09','08:10:00',1.7),('15087','2013-05-09','08:15:00',1.79),('15087','2013-05-09','08:20:00',1.89),('15087','2013-05-09','08:25:00',1.95),('15087','2013-05-09','08:30:00',2.12),('15087','2013-05-09','08:35:00',2.24),('15087','2013-05-09','08:40:00',2.34),('15087','2013-05-09','08:45:00',2.42),('15087','2013-05-09','08:50:00',2.51),('15087','2013-05-09','08:55:00',2.58),('15087','2013-05-09','09:00:00',2.67),('15087','2013-05-09','09:05:00',2.75),('15087','2013-05-09','09:10:00',2.84),('15087','2013-05-09','09:15:00',2.94),('15087','2013-05-09','09:20:00',3.03),('15087','2013-05-09','09:25:00',3.11),('15087','2013-05-09','09:30:00',3.2),('15087','2013-05-09','09:35:00',3.29),('15087','2013-05-09','09:40:00',3.36),('15087','2013-05-09','09:45:00',3.42),('15087','2013-05-09','09:50:00',3.49),('15087','2013-05-09','09:55:00',3.55),('15087','2013-05-09','10:00:00',3.62),('15087','2013-05-09','10:05:00',3.69),('15087','2013-05-09','10:10:00',3.74),('15087','2013-05-09','10:15:00',3.79),('15087','2013-05-09','10:20:00',3.86),('15087','2013-05-09','10:25:00',3.9),('15087','2013-05-09','10:30:00',3.95),('15087','2013-05-09','10:35:00',3.98),('15087','2013-05-09','10:40:00',4.02),('15087','2013-05-09','10:45:00',4.08),('15087','2013-05-09','10:50:00',4.14),('15087','2013-05-09','10:55:00',4.19),('15087','2013-05-09','11:00:00',4.22),('15087','2013-05-09','11:05:00',4.26),('15087','2013-05-09','11:10:00',4.29),('15087','2013-05-09','11:15:00',4.36),('15087','2013-05-09','11:20:00',4.37),('15087','2013-05-09','11:25:00',4.4),('15087','2013-05-09','11:30:00',4.42),('15087','2013-05-09','11:35:00',4.45),('15087','2013-05-09','11:40:00',4.47),('15087','2013-05-09','11:45:00',4.55),('15087','2013-05-09','11:50:00',4.57),('15087','2013-05-09','11:55:00',4.55),('15087','2013-05-09','12:00:00',4.59),('15087','2013-05-09','12:05:00',4.6),('15087','2013-05-09','12:10:00',4.61),('15087','2013-05-09','12:15:00',4.66),('15087','2013-05-09','12:20:00',4.71),('15087','2013-05-09','12:25:00',4.65),('15087','2013-05-09','12:30:00',4.71),('15087','2013-05-09','12:35:00',4.72),('15087','2013-05-09','12:40:00',4.72),('15087','2013-05-09','12:45:00',4.73),('15087','2013-05-09','12:50:00',4.79),('15087','2013-05-09','12:55:00',4.77),('15087','2013-05-09','13:00:00',4.72),('15087','2013-05-09','13:05:00',4.71),('15087','2013-05-09','13:10:00',4.69),('15087','2013-05-09','13:15:00',4.73),('15087','2013-05-09','13:20:00',4.73),('15087','2013-05-09','13:25:00',4.69),('15087','2013-05-09','13:30:00',4.7),('15087','2013-05-09','13:35:00',4.72),('15087','2013-05-09','13:40:00',4.73),('15087','2013-05-09','13:45:00',4.84),('15087','2013-05-09','13:50:00',4.79),('15087','2013-05-09','13:55:00',4.85),('15087','2013-05-09','14:00:00',4.52),('15087','2013-05-09','14:05:00',2.55),('15087','2013-05-09','14:10:00',4.84),('15087','2013-05-09','14:15:00',4.65),('15087','2013-05-09','14:20:00',3.7),('15087','2013-05-09','14:25:00',3.86),('15087','2013-05-09','14:30:00',4.43),('15087','2013-05-09','14:35:00',4.27),('15087','2013-05-09','14:40:00',4.17),('15087','2013-05-09','14:45:00',4.26),('15087','2013-05-09','14:50:00',4.2),('15087','2013-05-09','14:55:00',4.2),('15087','2013-05-09','15:00:00',4.13),('15087','2013-05-09','15:05:00',4.1),('15087','2013-05-09','15:10:00',4),('15087','2013-05-09','15:15:00',3.98),('15087','2013-05-09','15:20:00',3.85),('15087','2013-05-09','15:25:00',3.68),('15087','2013-05-09','15:30:00',3.74),('15087','2013-05-09','15:35:00',3.71),('15087','2013-05-09','15:40:00',3.64),('15087','2013-05-09','15:45:00',3.58),('15087','2013-05-09','15:50:00',3.52),('15087','2013-05-09','15:55:00',3.45),('15087','2013-05-09','16:00:00',3.33),('15087','2013-05-09','16:05:00',3.12),('15087','2013-05-09','16:10:00',3.06),('15087','2013-05-09','16:15:00',3.14),('15087','2013-05-09','16:20:00',3.08),('15087','2013-05-09','16:25:00',2.98),('15087','2013-05-09','16:30:00',2.97),('15087','2013-05-09','16:35:00',2.9),('15087','2013-05-09','16:40:00',2.79),('15087','2013-05-09','16:45:00',2.69),('15087','2013-05-09','16:50:00',2.58),('15087','2013-05-09','16:55:00',2.54),('15087','2013-05-09','17:00:00',2.49),('15087','2013-05-09','17:05:00',2.42),('15087','2013-05-09','17:10:00',2.33),('15087','2013-05-09','17:15:00',2.23),('15087','2013-05-09','17:20:00',2.14),('15087','2013-05-09','17:25:00',2),('15087','2013-05-09','17:30:00',1.89),('15087','2013-05-09','17:35:00',1.83),('15087','2013-05-09','17:40:00',1.72),('15087','2013-05-09','17:45:00',1.65),('15087','2013-05-09','17:50:00',1.55),('15087','2013-05-09','17:55:00',1.47),('15087','2013-05-09','18:00:00',1.41),('15087','2013-05-09','18:05:00',1.32),('15087','2013-05-09','18:10:00',1.24),('15087','2013-05-09','18:15:00',1.15),('15087','2013-05-09','18:20:00',1.07),('15087','2013-05-08','08:05:00',1.82),('15087','2013-05-08','08:10:00',1.8),('15087','2013-05-08','08:15:00',1.89),('15087','2013-05-08','08:20:00',2.02),('15087','2013-05-08','08:25:00',2.05),('15087','2013-05-08','08:30:00',2.07),('15087','2013-05-08','08:35:00',2.16),('15087','2013-05-08','08:40:00',2.34),('15087','2013-05-08','08:45:00',2.29),('15087','2013-05-08','08:50:00',1.07),('15087','2013-05-08','08:55:00',1.16),('15087','2013-05-08','09:35:00',3.14),('15087','2013-05-08','09:40:00',4.05),('15087','2013-05-08','09:45:00',3.24),('15087','2013-05-08','09:50:00',3.36),('15087','2013-05-08','09:55:00',1.7),('15087','2013-05-08','10:00:00',1.35),('15087','2013-05-08','10:05:00',4.16),('15087','2013-05-08','10:10:00',2.14),('15087','2013-05-08','10:20:00',1.07),('15087','2013-05-08','10:30:00',1),('15087','2013-05-08','10:50:00',1.08),('15087','2013-05-08','10:55:00',2.43),('15087','2013-05-08','11:00:00',3.2),('15087','2013-05-08','11:05:00',4.58),('15087','2013-05-08','11:10:00',3.14),('15087','2013-05-08','11:15:00',2.95),('15087','2013-05-08','11:20:00',3.7),('15087','2013-05-08','11:25:00',4.74),('15087','2013-05-08','11:30:00',4.88),('15087','2013-05-08','11:35:00',4.88),('15087','2013-05-08','11:40:00',2.33),('15087','2013-05-08','11:45:00',3.33),('15087','2013-05-08','11:50:00',2.03),('15087','2013-05-08','11:55:00',2.66),('15087','2013-05-08','12:00:00',2.57),('15087','2013-05-08','12:05:00',1.01),('15087','2013-05-08','12:15:00',1.17),('15087','2013-05-08','12:20:00',3.21),('15087','2013-05-08','12:25:00',2),('15087','2013-05-08','12:30:00',1.36),('15087','2013-05-08','12:35:00',1.41),('15087','2013-05-08','12:40:00',1.4),('15087','2013-05-08','12:45:00',1.28),('15087','2013-05-08','12:50:00',2.74),('15087','2013-05-08','12:55:00',2.97),('15087','2013-05-08','13:00:00',1.61),('15087','2013-05-08','13:05:00',1.78),('15087','2013-05-08','13:10:00',5.74),('15087','2013-05-08','13:15:00',3.03),('15087','2013-05-08','13:20:00',1.19),('15087','2013-05-08','13:25:00',2.56),('15087','2013-05-08','13:30:00',1.08),('15087','2013-05-08','13:35:00',1.03),('15087','2013-05-08','13:40:00',3.3),('15087','2013-05-08','13:45:00',5.55),('15087','2013-05-08','13:50:00',5.51),('15087','2013-05-08','13:55:00',5.12),('15087','2013-05-08','14:00:00',5),('15087','2013-05-08','14:05:00',3.99),('15087','2013-05-08','14:10:00',1.67),('15087','2013-05-08','14:15:00',2.67),('15087','2013-05-08','14:20:00',2.12),('15087','2013-05-08','14:25:00',2.21),('15087','2013-05-08','14:30:00',4.41),('15087','2013-05-08','14:35:00',3.27),('15087','2013-05-08','14:40:00',4.57),('15087','2013-05-08','14:45:00',3.76),('15087','2013-05-08','14:50:00',4.57),('15087','2013-05-08','14:55:00',3.73),('15087','2013-05-08','15:00:00',4.23),('15087','2013-05-08','15:05:00',4.14),('15087','2013-05-08','15:10:00',4.12),('15087','2013-05-08','15:15:00',4.05),('15087','2013-05-08','15:20:00',3.89),('15087','2013-05-08','15:25:00',3.69),('15087','2013-05-08','15:30:00',3.82),('15087','2013-05-08','15:35:00',3.76),('15087','2013-05-08','15:40:00',3.64),('15087','2013-05-08','15:45:00',3.58),('15087','2013-05-08','15:50:00',3.53),('15087','2013-05-08','15:55:00',3.49),('15087','2013-05-08','16:00:00',3.42),('15087','2013-05-08','16:05:00',3.14),('15087','2013-05-08','16:10:00',2.69),('15087','2013-05-08','16:15:00',3.2),('15087','2013-05-08','16:20:00',2.94),('15087','2013-05-08','16:25:00',2.83),('15087','2013-05-08','16:30:00',3.04),('15087','2013-05-08','16:35:00',2.9),('15087','2013-05-08','16:40:00',1.96),('15087','2013-05-08','16:45:00',2.84),('15087','2013-05-08','16:50:00',1.57),('15087','2013-05-08','16:55:00',2.61),('15087','2013-05-08','17:00:00',2.64),('15087','2013-05-08','17:05:00',2.64),('15087','2013-05-08','17:10:00',2.21),('15087','2013-05-08','17:15:00',2.46),('15087','2013-05-08','17:20:00',2.13),('15087','2013-05-08','17:25:00',2.05),('15087','2013-05-08','17:30:00',2.23),('15087','2013-05-08','17:35:00',2.13),('15087','2013-05-08','17:40:00',2.06),('15087','2013-05-08','17:45:00',2.24),('15087','2013-05-08','17:50:00',2.2),('15087','2013-05-08','17:55:00',2.06),('15087','2013-05-08','18:00:00',1.09),('15087','2013-05-08','18:15:00',1.47),('15087','2013-05-08','18:20:00',1.36),('15087','2013-05-08','18:25:00',1.15),('15087','2013-05-07','07:35:00',1.03),('15087','2013-05-07','07:40:00',1.12),('15087','2013-05-07','07:45:00',1.2),('15087','2013-05-07','07:50:00',1.28),('15087','2013-05-07','07:55:00',1.35),('15087','2013-05-07','08:00:00',1.49),('15087','2013-05-07','08:05:00',1.59),('15087','2013-05-07','08:10:00',1.69),('15087','2013-05-07','08:15:00',1.84),('15087','2013-05-07','08:20:00',1.96),('15087','2013-05-07','08:25:00',2.06),('15087','2013-05-07','08:30:00',2.14),('15087','2013-05-07','08:35:00',2.27),('15087','2013-05-07','08:40:00',2.37),('15087','2013-05-07','08:45:00',2.44),('15087','2013-05-07','08:50:00',2.58),('15087','2013-05-07','08:55:00',2.25),('15087','2013-05-07','09:00:00',2.53),('15087','2013-05-07','09:05:00',1.28),('15087','2013-05-07','09:15:00',2.55),('15087','2013-05-07','09:20:00',1.06),('15087','2013-05-07','09:30:00',1.62),('15087','2013-05-07','09:35:00',2.74),('15087','2013-05-07','09:40:00',2.16),('15087','2013-05-07','09:45:00',1.99),('15087','2013-05-07','09:50:00',1.5),('15087','2013-05-07','10:50:00',1),('15087','2013-05-07','10:55:00',1.25),('15087','2013-05-07','11:00:00',1.4),('15087','2013-05-07','11:05:00',1.44),('15087','2013-05-07','11:10:00',1.74),('15087','2013-05-07','11:15:00',1.49),('15087','2013-05-07','11:20:00',3.03),('15087','2013-05-07','11:25:00',1.31),('15087','2013-05-07','11:55:00',1.41),('15087','2013-05-07','12:00:00',1.59),('15087','2013-05-07','12:05:00',5.61),('15087','2013-05-07','12:10:00',4.46),('15087','2013-05-07','12:15:00',3.21),('15087','2013-05-07','12:20:00',5.54),('15087','2013-05-07','12:25:00',2.38),('15087','2013-05-07','12:30:00',1.09),('15087','2013-05-07','13:10:00',1.26),('15087','2013-05-07','13:15:00',1.42),('15087','2013-05-07','13:20:00',1.52),('15087','2013-05-07','13:25:00',3.07),('15087','2013-05-07','13:30:00',3.45),('15087','2013-05-07','13:35:00',5.74),('15087','2013-05-07','13:40:00',5.7),('15087','2013-05-07','13:45:00',5.35),('15087','2013-05-07','13:50:00',4.98),('15087','2013-05-07','13:55:00',2),('15087','2013-05-07','14:00:00',5.34),('15087','2013-05-07','14:05:00',5.24),('15087','2013-05-07','14:10:00',3.68),('15087','2013-05-07','14:15:00',5.19),('15087','2013-05-07','14:20:00',1.3),('15087','2013-05-07','14:25:00',4.87),('15087','2013-05-07','14:30:00',2.66),('15087','2013-05-07','14:35:00',3.93),('15087','2013-05-07','14:40:00',4.32),('15087','2013-05-07','14:45:00',3.26),('15087','2013-05-07','14:50:00',4.03),('15087','2013-05-07','14:55:00',3.32),('15087','2013-05-07','15:00:00',3.97),('15087','2013-05-07','15:05:00',3.92),('15087','2013-05-07','15:10:00',3.96),('15087','2013-05-07','15:15:00',4.29),('15087','2013-05-07','15:20:00',4.43),('15087','2013-05-07','15:25:00',3.02),('15087','2013-05-07','15:30:00',2.92),('15087','2013-05-07','15:35:00',3.11),('15087','2013-05-07','15:40:00',3.26),('15087','2013-05-07','15:45:00',3.34),('15087','2013-05-07','15:50:00',2.01),('15087','2013-05-07','15:55:00',2.55),('15087','2013-05-07','16:00:00',4.14),('15087','2013-05-07','16:05:00',1.48),('15087','2013-05-07','16:10:00',1.74),('15087','2013-05-07','16:15:00',3.5),('15087','2013-05-07','16:20:00',3.92),('15087','2013-05-07','16:25:00',3.77),('15087','2013-05-07','16:30:00',3.53),('15087','2013-05-07','16:35:00',3.57),('15087','2013-05-07','16:40:00',3.41),('15087','2013-05-07','16:45:00',3.27),('15087','2013-05-07','16:50:00',3.11),('15087','2013-05-07','16:55:00',2.56),('15087','2013-05-07','17:00:00',2.81),('15087','2013-05-07','17:05:00',2.79),('15087','2013-05-07','17:10:00',1.31),('15087','2013-05-07','17:15:00',1.22),('15087','2013-05-07','17:20:00',1.26),('15087','2013-05-07','17:25:00',1.23),('15087','2013-05-07','17:30:00',1.11),('15087','2013-05-07','17:35:00',1.03),('15087','2013-05-06','08:25:00',1.23),('15087','2013-05-06','08:30:00',1.31),('15087','2013-05-06','08:35:00',1.2),('15087','2013-05-06','08:40:00',1.1),('15087','2013-05-06','08:50:00',1.44),('15087','2013-05-06','08:55:00',2.69),('15087','2013-05-06','09:00:00',2.53),('15087','2013-05-06','09:05:00',1.72),('15087','2013-05-06','09:10:00',1.46),('15087','2013-05-06','09:15:00',1.38),('15087','2013-05-06','09:20:00',1.69),('15087','2013-05-06','09:25:00',1.3),('15087','2013-05-06','09:55:00',1.15),('15087','2013-05-06','10:00:00',2),('15087','2013-05-06','10:05:00',1.2),('15087','2013-05-06','10:10:00',1.07),('15087','2013-05-06','10:15:00',1.53),('15087','2013-05-06','10:20:00',2.64),('15087','2013-05-06','10:25:00',2.18),('15087','2013-05-06','10:30:00',2.16),('15087','2013-05-06','10:35:00',2.13),('15087','2013-05-06','10:40:00',2.03),('15087','2013-05-06','10:45:00',2.78),('15087','2013-05-06','10:50:00',2.34),('15087','2013-05-06','10:55:00',2.02),('15087','2013-05-06','11:00:00',1.9),('15087','2013-05-06','11:05:00',2.18),('15087','2013-05-06','11:10:00',2.19),('15087','2013-05-06','11:15:00',1.89),('15087','2013-05-06','11:20:00',2.32),('15087','2013-05-06','11:25:00',2.23),('15087','2013-05-06','11:30:00',1.29),('15087','2013-05-06','11:35:00',2.02),('15087','2013-05-06','11:40:00',2.38),('15087','2013-05-06','11:45:00',3.9),('15087','2013-05-06','11:50:00',2.22),('15087','2013-05-06','11:55:00',1.8),('15087','2013-05-06','12:00:00',2.16),('15087','2013-05-06','12:05:00',1.98),('15087','2013-05-06','12:10:00',2.79),('15087','2013-05-06','12:15:00',2.56),('15087','2013-05-06','12:20:00',2.62),('15087','2013-05-06','12:25:00',4.06),('15087','2013-05-06','12:30:00',4.36),('15087','2013-05-06','12:35:00',4.44),('15087','2013-05-06','12:40:00',2.1),('15087','2013-05-06','12:45:00',2.64),('15087','2013-05-06','12:50:00',4.09),('15087','2013-05-06','12:55:00',2.79),('15087','2013-05-06','13:00:00',2.07),('15087','2013-05-06','13:05:00',4.14),('15087','2013-05-06','13:10:00',3.74),('15087','2013-05-06','13:15:00',3.45),('15087','2013-05-06','13:20:00',4.09),('15087','2013-05-06','13:25:00',3.58),('15087','2013-05-06','13:30:00',2.93),('15087','2013-05-06','13:35:00',3.54),('15087','2013-05-06','13:40:00',3.78),('15087','2013-05-06','13:45:00',4.32),('15087','2013-05-06','13:50:00',5.2),('15087','2013-05-06','13:55:00',4.89),('15087','2013-05-06','14:00:00',4.07),('15087','2013-05-06','14:05:00',3.58),('15087','2013-05-06','14:10:00',3.42),('15087','2013-05-06','14:15:00',4.77),('15087','2013-05-06','14:20:00',4.66),('15087','2013-05-06','14:25:00',2.09),('15087','2013-05-06','14:30:00',4.67),('15087','2013-05-06','14:35:00',4.24),('15087','2013-05-06','14:40:00',3.13),('15087','2013-05-06','14:45:00',2.5),('15087','2013-05-06','14:50:00',3.13),('15087','2013-05-06','14:55:00',4.27),('15087','2013-05-06','15:00:00',2.68),('15087','2013-05-06','15:05:00',2.8),('15087','2013-05-06','15:10:00',3.01),('15087','2013-05-06','15:15:00',2.94),('15087','2013-05-06','15:20:00',2.2),('15087','2013-05-06','15:25:00',2.41),('15087','2013-05-06','15:30:00',2.44),('15087','2013-05-06','15:35:00',2.73),('15087','2013-05-06','15:40:00',1.31),('15087','2013-05-06','15:45:00',1.44),('15087','2013-05-06','15:50:00',2.4),('15087','2013-05-06','15:55:00',1.45),('15087','2013-05-06','16:00:00',1.81),('15087','2013-05-06','16:05:00',1.54),('15087','2013-05-06','16:10:00',1.45),('15087','2013-05-06','16:15:00',1.62),('15087','2013-05-06','16:20:00',2.59),('15087','2013-05-06','16:25:00',2.32),('15087','2013-05-06','16:30:00',2.53),('15087','2013-05-06','16:35:00',2.4),('15087','2013-05-06','16:40:00',2.24),('15087','2013-05-06','16:45:00',1.88),('15087','2013-05-06','16:50:00',3.03),('15087','2013-05-06','16:55:00',2.39),('15087','2013-05-06','17:15:00',1.42),('15087','2013-05-06','17:35:00',1.58),('15087','2013-05-06','17:40:00',1.4),('15087','2013-05-06','17:45:00',1.18),('15087','2013-05-06','17:55:00',1.25),('15087','2013-05-06','18:00:00',1.38),('15087','2013-05-06','18:05:00',1.5),('15087','2013-05-06','18:15:00',1.15),('15087','2013-05-06','18:20:00',1.41),('15087','2013-05-06','18:25:00',1.05),('15087','2013-05-05','07:45:00',1.05),('15087','2013-05-05','07:50:00',1.1),('15087','2013-05-05','07:55:00',1.05),('15087','2013-05-05','08:00:00',1.2),('15087','2013-05-05','08:05:00',1.39),('15087','2013-05-05','08:10:00',1.51),('15087','2013-05-05','08:15:00',1.62),('15087','2013-05-05','08:20:00',1.93),('15087','2013-05-05','08:25:00',2.41),('15087','2013-05-05','08:30:00',2.48),('15087','2013-05-05','08:35:00',2.32),('15087','2013-05-05','08:40:00',2.24),('15087','2013-05-05','08:45:00',1.68),('15087','2013-05-05','08:50:00',1.32),('15087','2013-05-05','08:55:00',1.43),('15087','2013-05-05','09:00:00',1.42),('15087','2013-05-05','09:05:00',1.39),('15087','2013-05-05','09:10:00',1.37),('15087','2013-05-05','09:15:00',1.27),('15087','2013-05-05','09:20:00',1.24),('15087','2013-05-05','09:25:00',1.49),('15087','2013-05-05','09:30:00',1.78),('15087','2013-05-05','09:35:00',1.55),('15087','2013-05-05','09:40:00',2.5),('15087','2013-05-05','09:45:00',3.37),('15087','2013-05-05','09:50:00',3.36),('15087','2013-05-05','09:55:00',3.31),('15087','2013-05-05','10:00:00',3.26),('15087','2013-05-05','10:05:00',2.93),('15087','2013-05-05','10:10:00',2.21),('15087','2013-05-05','10:15:00',3.36),('15087','2013-05-05','10:20:00',3.98),('15087','2013-05-05','10:25:00',2.28),('15087','2013-05-05','10:30:00',2.91),('15087','2013-05-05','10:35:00',3.13),('15087','2013-05-05','10:40:00',3.27),('15087','2013-05-05','10:45:00',2.93),('15087','2013-05-05','10:50:00',1.72),('15087','2013-05-05','10:55:00',1.47),('15087','2013-05-05','11:00:00',1.46),('15087','2013-05-05','11:05:00',1.7),('15087','2013-05-05','11:10:00',1.54),('15087','2013-05-05','11:15:00',1.7),('15087','2013-05-05','11:20:00',2.88),('15087','2013-05-05','11:25:00',3.36),('15087','2013-05-05','11:30:00',2.82),('15087','2013-05-05','11:35:00',3.99),('15087','2013-05-05','11:40:00',3.12),('15087','2013-05-05','11:45:00',2.84),('15087','2013-05-05','11:50:00',3.18),('15087','2013-05-05','11:55:00',4.41),('15087','2013-05-05','12:00:00',3.24),('15087','2013-05-05','12:05:00',3.31),('15087','2013-05-05','12:10:00',3.43),('15087','2013-05-05','12:15:00',3.54),('15087','2013-05-05','12:20:00',3.39),('15087','2013-05-05','12:25:00',4.42),('15087','2013-05-05','12:30:00',3.93),('15087','2013-05-05','12:35:00',4.32),('15087','2013-05-05','12:40:00',4.92),('15087','2013-05-05','12:45:00',4.93),('15087','2013-05-05','12:50:00',4.37),('15087','2013-05-05','12:55:00',4.77),('15087','2013-05-05','13:00:00',4.74),('15087','2013-05-05','13:05:00',4.61),('15087','2013-05-05','13:10:00',4.77),('15087','2013-05-05','13:15:00',3.46),('15087','2013-05-05','13:20:00',2.94),('15087','2013-05-05','13:25:00',1.89),('15087','2013-05-05','13:30:00',1.81),('15087','2013-05-05','13:35:00',4.49),('15087','2013-05-05','13:40:00',4.61),('15087','2013-05-05','13:45:00',4.58),('15087','2013-05-05','13:50:00',4.68),('15087','2013-05-05','13:55:00',4.71),('15087','2013-05-05','14:00:00',4.76),('15087','2013-05-05','14:05:00',4.36),('15087','2013-05-05','14:10:00',3.43),('15087','2013-05-05','14:15:00',3.87),('15087','2013-05-05','14:20:00',4.2),('15087','2013-05-05','14:25:00',4),('15087','2013-05-05','14:30:00',3.83),('15087','2013-05-05','14:35:00',3.77),('15087','2013-05-05','14:40:00',3.78),('15087','2013-05-05','14:45:00',3.79),('15087','2013-05-05','14:50:00',3.7),('15087','2013-05-05','14:55:00',3.57),('15087','2013-05-05','15:00:00',3.64),('15087','2013-05-05','15:05:00',3.6),('15087','2013-05-05','15:10:00',3.55),('15087','2013-05-05','15:15:00',3.4),('15087','2013-05-05','15:20:00',3.21),('15087','2013-05-05','15:25:00',3.14),('15087','2013-05-05','15:30:00',3.33),('15087','2013-05-05','15:35:00',3.25),('15087','2013-05-05','15:40:00',3.05),('15087','2013-05-05','15:45:00',3.13),('15087','2013-05-05','15:50:00',3.09),('15087','2013-05-05','15:55:00',3),('15087','2013-05-05','16:00:00',2.95),('15087','2013-05-05','16:05:00',2.85),('15087','2013-05-05','16:10:00',2.67),('15087','2013-05-05','16:15:00',2.79),('15087','2013-05-05','16:20:00',2.63),('15087','2013-05-05','16:25:00',2.63),('15087','2013-05-05','16:30:00',2.6),('15087','2013-05-05','16:35:00',2.58),('15087','2013-05-05','16:40:00',2.41),('15087','2013-05-05','16:45:00',2.38),('15087','2013-05-05','16:50:00',2.32),('15087','2013-05-05','16:55:00',2.16),('15087','2013-05-05','17:00:00',2.11),('15087','2013-05-05','17:05:00',2.03),('15087','2013-05-05','17:10:00',1.93),('15087','2013-05-05','17:15:00',1.88),('15087','2013-05-05','17:20:00',1.78),('15087','2013-05-05','17:25:00',1.64),('15087','2013-05-05','17:30:00',1.6),('15087','2013-05-05','17:35:00',1.55),('15087','2013-05-05','17:40:00',1.48),('15087','2013-05-05','17:45:00',1.42),('15087','2013-05-05','17:50:00',1.35),('15087','2013-05-05','17:55:00',1.22),('15087','2013-05-05','18:00:00',1.19),('15087','2013-05-05','18:05:00',1.08),('15087','2013-05-05','18:10:00',1),('15087','2013-05-04','07:50:00',1.02),('15087','2013-05-04','07:55:00',1.2),('15087','2013-05-04','08:00:00',1.34),('15087','2013-05-04','08:05:00',1.41),('15087','2013-05-04','08:10:00',1.48),('15087','2013-05-04','08:15:00',1.53),('15087','2013-05-04','08:20:00',1.57),('15087','2013-05-04','08:25:00',1.6),('15087','2013-05-04','08:30:00',1.67),('15087','2013-05-04','08:35:00',1.75),('15087','2013-05-04','08:40:00',1.83),('15087','2013-05-04','08:45:00',1.93),('15087','2013-05-04','08:50:00',1.99),('15087','2013-05-04','08:55:00',2.06),('15087','2013-05-04','09:00:00',2.17),('15087','2013-05-04','09:05:00',2.29),('15087','2013-05-04','09:10:00',2.39),('15087','2013-05-04','09:15:00',2.46),('15087','2013-05-04','09:20:00',2.57),('15087','2013-05-04','09:25:00',2.64),('15087','2013-05-04','09:30:00',2.66),('15087','2013-05-04','09:35:00',2.78),('15087','2013-05-04','09:40:00',2.85),('15087','2013-05-04','09:45:00',2.95),('15087','2013-05-04','09:50:00',3.02),('15087','2013-05-04','09:55:00',3.1),('15087','2013-05-04','10:00:00',3.14),('15087','2013-05-04','10:05:00',3.18),('15087','2013-05-04','10:10:00',3.29),('15087','2013-05-04','10:15:00',3.36),('15087','2013-05-04','10:20:00',3.42),('15087','2013-05-04','10:25:00',3.46),('15087','2013-05-04','10:30:00',3.5),('15087','2013-05-04','10:35:00',3.55),('15087','2013-05-04','10:40:00',3.54),('15087','2013-05-04','10:45:00',3.55),('15087','2013-05-04','10:50:00',3.47),('15087','2013-05-04','10:55:00',3.54),('15087','2013-05-04','11:00:00',3.51),('15087','2013-05-04','11:05:00',3.5),('15087','2013-05-04','11:10:00',3.32),('15087','2013-05-04','11:15:00',3.3),('15087','2013-05-04','11:20:00',3.59),('15087','2013-05-04','11:25:00',3.6),('15087','2013-05-04','11:30:00',3.54),('15087','2013-05-04','11:35:00',3.58),('15087','2013-05-04','11:40:00',3.48),('15087','2013-05-04','11:45:00',3.6),('15087','2013-05-04','11:50:00',3.58),('15087','2013-05-04','11:55:00',3.58),('15087','2013-05-04','12:00:00',3.57),('15087','2013-05-04','12:05:00',3.66),('15087','2013-05-04','12:10:00',3.71),('15087','2013-05-04','12:15:00',3.79),('15087','2013-05-04','12:20:00',3.84),('15087','2013-05-04','12:25:00',3.88),('15087','2013-05-04','12:30:00',3.97),('15087','2013-05-04','12:35:00',3.99),('15087','2013-05-04','12:40:00',3.99),('15087','2013-05-04','12:45:00',4.02),('15087','2013-05-04','12:50:00',3.87),('15087','2013-05-04','12:55:00',3.86),('15087','2013-05-04','13:00:00',3.8),('15087','2013-05-04','13:05:00',3.41),('15087','2013-05-04','13:10:00',3.77),('15087','2013-05-04','13:15:00',4.2),('15087','2013-05-04','13:20:00',4.2),('15087','2013-05-04','13:25:00',3.99),('15087','2013-05-04','13:30:00',4.1),('15087','2013-05-04','13:35:00',3.78),('15087','2013-05-04','13:40:00',3.91),('15087','2013-05-04','13:45:00',3.91),('15087','2013-05-04','13:50:00',3.48),('15087','2013-05-04','13:55:00',3.57),('15087','2013-05-04','14:00:00',3.91),('15087','2013-05-04','14:05:00',3.73),('15087','2013-05-04','14:10:00',3.62),('15087','2013-05-04','14:15:00',3.69),('15087','2013-05-04','14:20:00',3.6),('15087','2013-05-04','14:25:00',3.41),('15087','2013-05-04','14:30:00',3.53),('15087','2013-05-04','14:35:00',3.32),('15087','2013-05-04','14:40:00',3.37),('15087','2013-05-04','14:45:00',3.35),('15087','2013-05-04','14:50:00',3.26),('15087','2013-05-04','14:55:00',3.32),('15087','2013-05-04','15:00:00',3.36),('15087','2013-05-04','15:05:00',3.23),('15087','2013-05-04','15:10:00',3.1),('15087','2013-05-04','15:15:00',3.21),('15087','2013-05-04','15:20:00',3.12),('15087','2013-05-04','15:25:00',3.13),('15087','2013-05-04','15:30:00',3.17),('15087','2013-05-04','15:35:00',3.01),('15087','2013-05-04','15:40:00',2.99),('15087','2013-05-04','15:45:00',3.07),('15087','2013-05-04','15:50:00',2.99),('15087','2013-05-04','15:55:00',2.87),('15087','2013-05-04','16:00:00',2.86),('15087','2013-05-04','16:05:00',2.75),('15087','2013-05-04','16:10:00',2.52),('15087','2013-05-04','16:15:00',2.69),('15087','2013-05-04','16:20:00',2.44),('15087','2013-05-04','16:25:00',2.3),('15087','2013-05-04','16:30:00',2.45),('15087','2013-05-04','16:35:00',2.37),('15087','2013-05-04','16:40:00',2.17),('15087','2013-05-04','16:45:00',2.2),('15087','2013-05-04','16:50:00',2.06),('15087','2013-05-04','16:55:00',1.96),('15087','2013-05-04','17:00:00',1.97),('15087','2013-05-04','17:05:00',1.83),('15087','2013-05-04','17:10:00',1.38),('15087','2013-05-04','17:15:00',1.67),('15087','2013-05-04','17:20:00',1.72),('15087','2013-05-04','17:25:00',1.52),('15087','2013-05-04','17:30:00',1.51),('15087','2013-05-04','17:35:00',1.41),('15087','2013-05-04','17:40:00',1.33),('15087','2013-05-04','17:45:00',1.33),('15087','2013-05-04','17:50:00',1.27),('15087','2013-05-04','17:55:00',1.22),('15087','2013-05-04','18:00:00',1.18),('15087','2013-05-04','18:05:00',1.12),('15087','2013-05-03','08:05:00',1.36),('15087','2013-05-03','08:10:00',1.56),('15087','2013-05-03','08:15:00',1.77),('15087','2013-05-03','08:20:00',1.69),('15087','2013-05-03','08:25:00',1.84),('15087','2013-05-03','08:30:00',1.93),('15087','2013-05-03','08:35:00',1.98),('15087','2013-05-03','08:40:00',2.07),('15087','2013-05-03','08:45:00',2.11),('15087','2013-05-03','08:50:00',2.05),('15087','2013-05-03','08:55:00',2.13),('15087','2013-05-03','09:00:00',2.31),('15087','2013-05-03','09:05:00',2.44),('15087','2013-05-03','09:10:00',2.51),('15087','2013-05-03','09:15:00',2.58),('15087','2013-05-03','09:20:00',2.64),('15087','2013-05-03','09:25:00',2.71),('15087','2013-05-03','09:30:00',2.79),('15087','2013-05-03','09:35:00',2.86),('15087','2013-05-03','09:40:00',2.94),('15087','2013-05-03','09:45:00',3.01),('15087','2013-05-03','09:50:00',3.07),('15087','2013-05-03','09:55:00',3.16),('15087','2013-05-03','10:00:00',3.21),('15087','2013-05-03','10:05:00',3.31),('15087','2013-05-03','10:10:00',3.36),('15087','2013-05-03','10:15:00',3.41),('15087','2013-05-03','10:20:00',3.46),('15087','2013-05-03','10:25:00',3.52),('15087','2013-05-03','10:30:00',3.55),('15087','2013-05-03','10:35:00',3.6),('15087','2013-05-03','10:40:00',3.67),('15087','2013-05-03','10:45:00',3.66),('15087','2013-05-03','10:50:00',3.78),('15087','2013-05-03','10:55:00',3.83),('15087','2013-05-03','11:00:00',3.83),('15087','2013-05-03','11:05:00',3.85),('15087','2013-05-03','11:10:00',3.88),('15087','2013-05-03','11:15:00',3.93),('15087','2013-05-03','11:20:00',4),('15087','2013-05-03','11:25:00',4.05),('15087','2013-05-03','11:30:00',4.03),('15087','2013-05-03','11:35:00',4.08),('15087','2013-05-03','11:40:00',4.13),('15087','2013-05-03','11:45:00',4.13),('15087','2013-05-03','11:50:00',4.15),('15087','2013-05-03','11:55:00',4.18),('15087','2013-05-03','12:00:00',4.15),('15087','2013-05-03','12:05:00',4.13),('15087','2013-05-03','12:10:00',4.18),('15087','2013-05-03','12:15:00',4.24),('15087','2013-05-03','12:20:00',4.27),('15087','2013-05-03','12:25:00',4.29),('15087','2013-05-03','12:30:00',4.27),('15087','2013-05-03','12:35:00',4.28),('15087','2013-05-03','12:40:00',4.28),('15087','2013-05-03','12:45:00',4.2),('15087','2013-05-03','12:50:00',4.33),('15087','2013-05-03','12:55:00',4.34),('15087','2013-05-03','13:00:00',4.31),('15087','2013-05-03','13:05:00',4.3),('15087','2013-05-03','13:10:00',4.31),('15087','2013-05-03','13:15:00',4.3),('15087','2013-05-03','13:20:00',4.29),('15087','2013-05-03','13:25:00',4.29),('15087','2013-05-03','13:30:00',4.27),('15087','2013-05-03','13:35:00',4.14),('15087','2013-05-03','13:40:00',4.07),('15087','2013-05-03','13:45:00',4.05),('15087','2013-05-03','13:50:00',4.09),('15087','2013-05-03','13:55:00',4.1),('15087','2013-05-03','14:00:00',3.97),('15087','2013-05-03','14:05:00',3.82),('15087','2013-05-03','14:10:00',3.83),('15087','2013-05-03','14:15:00',3.82),('15087','2013-05-03','14:20:00',3.94),('15087','2013-05-03','14:25:00',3.84),('15087','2013-05-03','14:30:00',3.74),('15087','2013-05-03','14:35:00',3.8),('15087','2013-05-03','14:40:00',3.51),('15087','2013-05-03','14:45:00',3.3),('15087','2013-05-03','14:50:00',3.52),('15087','2013-05-03','14:55:00',3.59),('15087','2013-05-03','15:00:00',3.59),('15087','2013-05-03','15:05:00',3.52),('15087','2013-05-03','15:10:00',3.48),('15087','2013-05-03','15:15:00',3.36),('15087','2013-05-03','15:20:00',3.38),('15087','2013-05-03','15:25:00',3.39),('15087','2013-05-03','15:30:00',3.33),('15087','2013-05-03','15:35:00',3.24),('15087','2013-05-03','15:40:00',3.19),('15087','2013-05-03','15:45:00',3.15),('15087','2013-05-03','15:50:00',3),('15087','2013-05-03','15:55:00',2.85),('15087','2013-05-03','16:00:00',2.65),('15087','2013-05-03','16:05:00',2.84),('15087','2013-05-03','16:10:00',2.85),('15087','2013-05-03','16:15:00',2.78),('15087','2013-05-03','16:20:00',2.6),('15087','2013-05-03','16:25:00',2.51),('15087','2013-05-03','16:30:00',2.59),('15087','2013-05-03','16:35:00',2.5),('15087','2013-05-03','16:40:00',2.32),('15087','2013-05-03','16:45:00',2.11),('15087','2013-05-03','16:50:00',2.18),('15087','2013-05-03','16:55:00',2.07),('15087','2013-05-03','17:00:00',1.99),('15087','2013-05-03','17:05:00',1.95),('15087','2013-05-03','17:10:00',1.86),('15087','2013-05-03','17:15:00',1.77),('15087','2013-05-03','17:20:00',1.68),('15087','2013-05-03','17:25:00',1.56),('15087','2013-05-03','17:30:00',1.49),('15087','2013-05-03','17:35:00',1.43),('15087','2013-05-03','17:40:00',1.39),('15087','2013-05-03','17:45:00',1.28),('15087','2013-05-03','17:50:00',1.18),('15087','2013-05-03','17:55:00',1.16),('15087','2013-05-03','18:00:00',1.07),('15087','2013-05-03','18:05:00',1.06),('15087','2013-05-02','08:55:00',1.34),('15087','2013-05-02','09:00:00',1.77),('15087','2013-05-02','09:05:00',1.44),('15087','2013-05-02','09:20:00',1.02),('15087','2013-05-02','09:25:00',1.88),('15087','2013-05-02','09:30:00',2.33),('15087','2013-05-02','09:35:00',2.03),('15087','2013-05-02','09:40:00',1.54),('15087','2013-05-02','09:45:00',2.83),('15087','2013-05-02','09:50:00',1.36),('15087','2013-05-02','09:55:00',1.03),('15087','2013-05-02','10:00:00',1.03),('15087','2013-05-02','10:05:00',1.5),('15087','2013-05-02','10:10:00',1.38),('15087','2013-05-02','10:15:00',1.45),('15087','2013-05-02','10:20:00',1.48),('15087','2013-05-02','10:25:00',1.8),('15087','2013-05-02','10:30:00',2.91),('15087','2013-05-02','10:35:00',2.87),('15087','2013-05-02','10:40:00',3.66),('15087','2013-05-02','10:45:00',3.2),('15087','2013-05-02','10:50:00',3.89),('15087','2013-05-02','10:55:00',4.2),('15087','2013-05-02','11:00:00',4.13),('15087','2013-05-02','11:05:00',3.74),('15087','2013-05-02','11:10:00',3.28),('15087','2013-05-02','11:15:00',3.07),('15087','2013-05-02','11:20:00',3.41),('15087','2013-05-02','11:25:00',3.95),('15087','2013-05-02','11:30:00',4.16),('15087','2013-05-02','11:35:00',4.01),('15087','2013-05-02','11:40:00',4.06),('15087','2013-05-02','11:45:00',4.07),('15087','2013-05-02','11:50:00',4.06),('15087','2013-05-02','11:55:00',4.06),('15087','2013-05-02','12:00:00',4.06),('15087','2013-05-02','12:05:00',4.07),('15087','2013-05-02','12:10:00',4.06),('15087','2013-05-02','12:15:00',4.1),('15087','2013-05-02','12:20:00',4.11),('15087','2013-05-02','12:25:00',4.13),('15087','2013-05-02','12:30:00',4.18),('15087','2013-05-02','12:35:00',4.23),('15087','2013-05-02','12:40:00',4.26),('15087','2013-05-02','12:45:00',4.3),('15087','2013-05-02','12:50:00',4.3),('15087','2013-05-02','12:55:00',4.35),('15087','2013-05-02','13:00:00',4.39),('15087','2013-05-02','13:05:00',4.43),('15087','2013-05-02','13:10:00',4.44),('15087','2013-05-02','13:15:00',4.36),('15087','2013-05-02','13:20:00',4.41),('15087','2013-05-02','13:25:00',4.42),('15087','2013-05-02','13:30:00',4.41),('15087','2013-05-02','13:35:00',4.38),('15087','2013-05-02','13:40:00',4.38),('15087','2013-05-02','13:45:00',4.33),('15087','2013-05-02','13:50:00',4.33),('15087','2013-05-02','13:55:00',4.3),('15087','2013-05-02','14:00:00',4.21),('15087','2013-05-02','14:05:00',4.16),('15087','2013-05-02','14:10:00',4.13),('15087','2013-05-02','14:15:00',4.11),('15087','2013-05-02','14:20:00',4.07),('15087','2013-05-02','14:25:00',3.95),('15087','2013-05-02','14:30:00',3.91),('15087','2013-05-02','14:35:00',3.92),('15087','2013-05-02','14:40:00',3.86),('15087','2013-05-02','14:45:00',3.77),('15087','2013-05-02','14:50:00',3.65),('15087','2013-05-02','14:55:00',3.66),('15087','2013-05-02','15:00:00',3.61),('15087','2013-05-02','15:05:00',3.62),('15087','2013-05-02','15:10:00',3.48),('15087','2013-05-02','15:15:00',3.39),('15087','2013-05-02','15:20:00',3.41),('15087','2013-05-02','15:25:00',3.35),('15087','2013-05-02','15:30:00',3.26),('15087','2013-05-02','15:35:00',3.1),('15087','2013-05-02','15:40:00',2.9),('15087','2013-05-02','15:45:00',2.94),('15087','2013-05-02','15:50:00',2.99),('15087','2013-05-02','15:55:00',2.78),('15087','2013-05-02','16:00:00',2.76),('15087','2013-05-02','16:05:00',2.78),('15087','2013-05-02','16:10:00',2.67),('15087','2013-05-02','16:15:00',2.71),('15087','2013-05-02','16:20:00',2.7),('15087','2013-05-02','16:25:00',2.52),('15087','2013-05-02','16:30:00',2.42),('15087','2013-05-02','16:35:00',2.45),('15087','2013-05-02','16:40:00',2.31),('15087','2013-05-02','16:45:00',2.28),('15087','2013-05-02','16:50:00',2.18),('15087','2013-05-02','16:55:00',2.04),('15087','2013-05-02','17:00:00',1.98),('15087','2013-05-02','17:05:00',1.95),('15087','2013-05-02','17:10:00',1.87),('15087','2013-05-02','17:15:00',1.77),('15087','2013-05-02','17:20:00',1.74),('15087','2013-05-02','17:25:00',1.59),('15087','2013-05-02','17:30:00',1.57),('15087','2013-05-02','17:35:00',1.52),('15087','2013-05-02','17:40:00',1.47),('15087','2013-05-02','17:45:00',1.4),('15087','2013-05-02','17:50:00',1.31),('15087','2013-05-02','17:55:00',1.23),('15087','2013-05-02','18:00:00',1.17),('15087','2013-05-02','18:05:00',1.11),('15087','2013-05-02','18:10:00',1.04),('15087','2014-03-30','08:20:00',1.1),('15087','2014-03-30','08:25:00',1.2),('15087','2014-03-30','08:30:00',1.33),('15087','2014-03-30','08:35:00',1.37),('15087','2014-03-30','08:40:00',1.42),('15087','2014-03-30','08:45:00',1.36),('15087','2014-03-30','08:50:00',1.4),('15087','2014-03-30','08:55:00',1.47),('15087','2014-03-30','09:00:00',1.54),('15087','2014-03-30','09:05:00',1.53),('15087','2014-03-30','09:10:00',1.44),('15087','2014-03-30','09:15:00',1.56),('15087','2014-03-30','09:20:00',1.83),('15087','2014-03-30','09:25:00',2),('15087','2014-03-30','09:30:00',2.23),('15087','2014-03-30','09:35:00',2.35),('15087','2014-03-30','09:40:00',2.41),('15087','2014-03-30','09:45:00',2.53),('15087','2014-03-30','09:50:00',2.58),('15087','2014-03-30','09:55:00',2.51),('15087','2014-03-30','10:00:00',2.62),('15087','2014-03-30','10:05:00',2.89),('15087','2014-03-30','10:10:00',2.93),('15087','2014-03-30','10:15:00',2.89),('15087','2014-03-30','10:20:00',2.95),('15087','2014-03-30','10:25:00',3.16),('15087','2014-03-30','10:30:00',3.26),('15087','2014-03-30','10:35:00',3.33),('15087','2014-03-30','10:40:00',3.38),('15087','2014-03-30','10:45:00',3.4),('15087','2014-03-30','10:50:00',3.43),('15087','2014-03-30','10:55:00',3.43),('15087','2014-03-30','11:00:00',3.4),('15087','2014-03-30','11:05:00',3.38),('15087','2014-03-30','11:10:00',3.41),('15087','2014-03-30','11:15:00',3.25),('15087','2014-03-30','11:20:00',3.29),('15087','2014-03-30','11:25:00',3.41),('15087','2014-03-30','11:30:00',3.75),('15087','2014-03-30','11:35:00',3.73),('15087','2014-03-30','11:40:00',3.87),('15087','2014-03-30','11:45:00',4.01),('15087','2014-03-30','11:50:00',4.04),('15087','2014-03-30','11:55:00',4.14),('15087','2014-03-30','12:00:00',4.22),('15087','2014-03-30','12:05:00',4.35),('15087','2014-03-30','12:10:00',4.42),('15087','2014-03-30','12:15:00',4.51),('15087','2014-03-30','12:20:00',4.42),('15087','2014-03-30','12:25:00',4.44),('15087','2014-03-30','12:30:00',4.03),('15087','2014-03-30','12:35:00',4.1),('15087','2014-03-30','12:40:00',4.26),('15087','2014-03-30','12:45:00',4.21),('15087','2014-03-30','12:50:00',4.25),('15087','2014-03-30','12:55:00',4.34),('15087','2014-03-30','13:00:00',4.42),('15087','2014-03-30','13:05:00',4.53),('15087','2014-03-30','13:10:00',4.45),('15087','2014-03-30','13:15:00',4.45),('15087','2014-03-30','13:20:00',4.47),('15087','2014-03-30','13:25:00',4.47),('15087','2014-03-30','13:30:00',4.44),('15087','2014-03-30','13:35:00',4.51),('15087','2014-03-30','13:40:00',4.52),('15087','2014-03-30','13:45:00',4.52),('15087','2014-03-30','13:50:00',4.46),('15087','2014-03-30','13:55:00',4.26),('15087','2014-03-30','14:00:00',4.18),('15087','2014-03-30','14:05:00',4.21),('15087','2014-03-30','14:10:00',4.05),('15087','2014-03-30','14:15:00',4),('15087','2014-03-30','14:20:00',4.1),('15087','2014-03-30','14:25:00',4.21),('15087','2014-03-30','14:30:00',4.06),('15087','2014-03-30','14:35:00',3.4),('15087','2014-03-30','14:40:00',3.47),('15087','2014-03-30','14:45:00',3.16),('15087','2014-03-30','14:50:00',2.4),('15087','2014-03-30','14:55:00',1.82),('15087','2014-03-30','15:00:00',1.69),('15087','2014-03-30','15:05:00',2.01),('15087','2014-03-30','15:10:00',1.98),('15087','2014-03-30','15:15:00',2.81),('15087','2014-03-30','15:20:00',2.92),('15087','2014-03-30','15:25:00',3.17),('15087','2014-03-30','15:30:00',3.2),('15087','2014-03-30','15:35:00',3.11),('15087','2014-03-30','15:40:00',3.04),('15087','2014-03-30','15:45:00',2.95),('15087','2014-03-30','15:50:00',3.08),('15087','2014-03-30','15:55:00',2.97),('15087','2014-03-30','16:00:00',2.49),('15087','2014-03-30','16:05:00',2.59),('15087','2014-03-30','16:10:00',2.4),('15087','2014-03-30','16:15:00',2.71),('15087','2014-03-30','16:20:00',2.8),('15087','2014-03-30','16:25:00',2.74),('15087','2014-03-30','16:30:00',2.63),('15087','2014-03-30','16:35:00',2.62),('15087','2014-03-30','16:40:00',2.45),('15087','2014-03-30','16:45:00',2.18),('15087','2014-03-30','16:50:00',1.89),('15087','2014-03-30','16:55:00',1.77),('15087','2014-03-30','17:00:00',1.91),('15087','2014-03-30','17:05:00',1.94),('15087','2014-03-30','17:10:00',1.99),('15087','2014-03-30','17:15:00',1.81),('15087','2014-03-30','17:20:00',1.73),('15087','2014-03-30','17:25:00',1.5),('15087','2014-03-30','17:30:00',1.45),('15087','2014-03-30','17:35:00',1.37),('15087','2014-03-30','17:40:00',1.15),('15087','2014-03-30','17:45:00',1.11),('15087','2014-03-30','17:50:00',1),('15087','2013-05-01','07:55:00',1.03),('15087','2013-05-01','08:00:00',1.11),('15087','2013-05-01','08:05:00',1.18),('15087','2013-05-01','08:10:00',1.23),('15087','2013-05-01','08:15:00',1.35),('15087','2013-05-01','08:20:00',1.45),('15087','2013-05-01','08:25:00',1.55),('15087','2013-05-01','08:30:00',1.66),('15087','2013-05-01','08:35:00',1.78),('15087','2013-05-01','08:40:00',1.86),('15087','2013-05-01','08:45:00',1.94),('15087','2013-05-01','08:50:00',2.1),('15087','2013-05-01','08:55:00',2.17),('15087','2013-05-01','09:00:00',2.29),('15087','2013-05-01','09:05:00',2.38),('15087','2013-05-01','09:10:00',2.44),('15087','2013-05-01','09:15:00',2.5),('15087','2013-05-01','09:20:00',2.55),('15087','2013-05-01','09:25:00',2.62),('15087','2013-05-01','09:30:00',2.64),('15087','2013-05-01','09:35:00',2.73),('15087','2013-05-01','09:40:00',2.81),('15087','2013-05-01','09:45:00',2.87),('15087','2013-05-01','09:50:00',2.88),('15087','2013-05-01','09:55:00',3),('15087','2013-05-01','10:00:00',3.04),('15087','2013-05-01','10:05:00',3.07),('15087','2013-05-01','10:10:00',3.21),('15087','2013-05-01','10:15:00',3.29),('15087','2013-05-01','10:20:00',3.35),('15087','2013-05-01','10:25:00',3.41),('15087','2013-05-01','10:30:00',3.46),('15087','2013-05-01','10:35:00',3.53),('15087','2013-05-01','10:40:00',3.74),('15087','2013-05-01','10:45:00',3.8),('15087','2013-05-01','10:50:00',3.83),('15087','2013-05-01','10:55:00',3.84),('15087','2013-05-01','11:00:00',3.9),('15087','2013-05-01','11:05:00',3.9),('15087','2013-05-01','11:10:00',3.98),('15087','2013-05-01','11:15:00',3.65),('15087','2013-05-01','11:20:00',3.73),('15087','2013-05-01','11:25:00',3.73),('15087','2013-05-01','11:30:00',3.63),('15087','2013-05-01','11:35:00',3.71),('15087','2013-05-01','11:40:00',2.83),('15087','2013-05-01','11:45:00',2.81),('15087','2013-05-01','11:50:00',3.73),('15087','2013-05-01','11:55:00',4.23),('15087','2013-05-01','12:00:00',4.2),('15087','2013-05-01','12:05:00',4.08),('15087','2013-05-01','12:10:00',4.19),('15087','2013-05-01','12:15:00',4.13),('15087','2013-05-01','12:20:00',4.17),('15087','2013-05-01','12:25:00',4.24),('15087','2013-05-01','12:30:00',4.31),('15087','2013-05-01','12:35:00',4.36),('15087','2013-05-01','12:40:00',4.46),('15087','2013-05-01','12:45:00',3.97),('15087','2013-05-01','12:50:00',2.53),('15087','2013-05-01','12:55:00',1.54),('15087','2013-05-01','13:00:00',1.63),('15087','2013-05-01','13:05:00',1.95),('15087','2013-05-01','13:10:00',2.42),('15087','2013-05-01','13:15:00',4.47),('15087','2013-05-01','13:20:00',5.01),('15087','2013-05-01','13:25:00',4.4),('15087','2013-05-01','13:30:00',3.86),('15087','2013-05-01','13:35:00',4.55),('15087','2013-05-01','13:40:00',4.76),('15087','2013-05-01','13:45:00',4.67),('15087','2013-05-01','13:50:00',4.43),('15087','2013-05-01','13:55:00',4.27),('15087','2013-05-01','14:00:00',4.15),('15087','2013-05-01','14:05:00',4.15),('15087','2013-05-01','14:10:00',4.11),('15087','2013-05-01','14:15:00',3.6),('15087','2013-05-01','14:20:00',4.29),('15087','2013-05-01','14:25:00',4.18),('15087','2013-05-01','14:30:00',4.26),('15087','2013-05-01','14:35:00',4.01),('15087','2013-05-01','14:40:00',3.71),('15087','2013-05-01','14:45:00',3.7),('15087','2013-05-01','14:50:00',3.28),('15087','2013-05-01','14:55:00',2.95),('15087','2013-05-01','15:00:00',3.17),('15087','2013-05-01','15:05:00',3.54),('15087','2013-05-01','15:10:00',3.63),('15087','2013-05-01','15:15:00',3.46),('15087','2013-05-01','15:20:00',3.44),('15087','2013-05-01','15:25:00',3.39),('15087','2013-05-01','15:30:00',2.83),('15087','2013-05-01','15:35:00',2.5),('15087','2013-05-01','15:40:00',2.52),('15087','2013-05-01','15:45:00',2.44),('15087','2013-05-01','15:50:00',1.75),('15087','2013-05-01','15:55:00',1.75),('15087','2013-05-01','16:00:00',2.08),('15087','2013-05-01','16:05:00',1.98),('15087','2013-05-01','16:10:00',1.79),('15087','2013-05-01','16:15:00',1.65),('15087','2013-05-01','16:20:00',1.43),('15087','2013-05-01','16:25:00',1.14),('15087','2013-05-01','16:30:00',1.05),('15087','2013-05-01','16:35:00',1.1),('15087','2013-05-01','16:40:00',1.18),('15087','2013-05-01','16:45:00',1.1),('15087','2013-04-30','08:50:00',1.21),('15087','2013-04-30','08:55:00',1.99),('15087','2013-04-30','09:00:00',1.83),('15087','2013-04-30','09:05:00',1.5),('15087','2013-04-30','09:10:00',2.34),('15087','2013-04-30','09:15:00',2.8),('15087','2013-04-30','09:20:00',2.91),('15087','2013-04-30','09:25:00',3.09),('15087','2013-04-30','09:30:00',2.96),('15087','2013-04-30','09:35:00',2.41),('15087','2013-04-30','09:40:00',1.51),('15087','2013-04-30','09:45:00',2.32),('15087','2013-04-30','09:50:00',2.84),('15087','2013-04-30','09:55:00',3.17),('15087','2013-04-30','10:00:00',3.64),('15087','2013-04-30','10:05:00',3.16),('15087','2013-04-30','10:10:00',3.07),('15087','2013-04-30','10:15:00',2.33),('15087','2013-04-30','10:20:00',2.29),('15087','2013-04-30','10:25:00',3.78),('15087','2013-04-30','10:30:00',2.58),('15087','2013-04-30','10:35:00',1.95),('15087','2013-04-30','10:40:00',1.72),('15087','2013-04-30','10:45:00',1.36),('15087','2013-04-30','10:50:00',1.48),('15087','2013-04-30','10:55:00',1.59),('15087','2013-04-30','11:00:00',1.67),('15087','2013-04-30','11:05:00',1.94),('15087','2013-04-30','11:10:00',1.95),('15087','2013-04-30','11:15:00',2.11),('15087','2013-04-30','11:20:00',2.45),('15087','2013-04-30','11:25:00',2.18),('15087','2013-04-30','11:30:00',2.23),('15087','2013-04-30','11:35:00',2.44),('15087','2013-04-30','11:40:00',2.15),('15087','2013-04-30','11:45:00',1.73),('15087','2013-04-30','11:50:00',1.73),('15087','2013-04-30','11:55:00',1.79),('15087','2013-04-30','12:00:00',1.83),('15087','2013-04-30','12:05:00',1.94),('15087','2013-04-30','12:10:00',1.81),('15087','2013-04-30','12:15:00',1.63),('15087','2013-04-30','12:20:00',1.49),('15087','2013-04-30','12:25:00',1.39),('15087','2013-04-30','12:30:00',1.44),('15087','2013-04-30','12:35:00',2.98),('15087','2013-04-30','12:40:00',4.74),('15087','2013-04-30','12:45:00',4.85),('15087','2013-04-30','12:50:00',4.69),('15087','2013-04-30','12:55:00',4.23),('15087','2013-04-30','13:00:00',4.53),('15087','2013-04-30','13:05:00',4.51),('15087','2013-04-30','13:10:00',4.48),('15087','2013-04-30','13:15:00',4.42),('15087','2013-04-30','13:20:00',4.37),('15087','2013-04-30','13:25:00',4.34),('15087','2013-04-30','13:30:00',4.31),('15087','2013-04-30','13:35:00',4.28),('15087','2013-04-30','13:40:00',4.25),('15087','2013-04-30','13:45:00',4.21),('15087','2013-04-30','13:50:00',4.2),('15087','2013-04-30','13:55:00',4.13),('15087','2013-04-30','14:00:00',4.04),('15087','2013-04-30','14:05:00',4.07),('15087','2013-04-30','14:10:00',4.02),('15087','2013-04-30','14:15:00',3.99),('15087','2013-04-30','14:20:00',3.95),('15087','2013-04-30','14:25:00',3.89),('15087','2013-04-30','14:30:00',3.93),('15087','2013-04-30','14:35:00',3.82),('15087','2013-04-30','14:40:00',3.81),('15087','2013-04-30','14:45:00',3.71),('15087','2013-04-30','14:50:00',3.63),('15087','2013-04-30','14:55:00',3.58),('15087','2013-04-30','15:00:00',3.46),('15087','2013-04-30','15:05:00',3.43),('15087','2013-04-30','15:10:00',3.37),('15087','2013-04-30','15:15:00',3.35),('15087','2013-04-30','15:20:00',3.25),('15087','2013-04-30','15:25:00',3.16),('15087','2013-04-30','15:30:00',3.12),('15087','2013-04-30','15:35:00',3.14),('15087','2013-04-30','15:40:00',3.07),('15087','2013-04-30','15:45:00',3.02),('15087','2013-04-30','15:50:00',2.93),('15087','2013-04-30','15:55:00',2.82),('15087','2013-04-30','16:00:00',2.78),('15087','2013-04-30','16:05:00',2.76),('15087','2013-04-30','16:10:00',2.65),('15087','2013-04-30','16:15:00',2.6),('15087','2013-04-30','16:20:00',2.61),('15087','2013-04-30','16:25:00',2.54),('15087','2013-04-30','16:30:00',2.38),('15087','2013-04-30','16:35:00',2.19),('15087','2013-04-30','16:40:00',1.88),('15087','2013-04-30','16:45:00',1.97),('15087','2013-04-30','16:50:00',1.82),('15087','2013-04-30','16:55:00',1.94),('15087','2013-04-30','17:00:00',1.84),('15087','2013-04-30','17:05:00',1.78),('15087','2013-04-30','17:10:00',1.48),('15087','2013-04-30','17:20:00',1.39),('15087','2013-04-30','17:25:00',1.52),('15087','2013-04-30','17:30:00',1.44),('15087','2013-04-30','17:35:00',1.41),('15087','2013-04-30','17:40:00',1.34),('15087','2013-04-30','17:45:00',1.29),('15087','2013-04-30','17:50:00',1.2),('15087','2013-04-30','17:55:00',1.13),('15087','2013-04-30','18:00:00',1.06),('15087','2013-04-29','07:55:00',1.09),('15087','2013-04-29','08:00:00',1.24),('15087','2013-04-29','08:05:00',1.32),('15087','2013-04-29','08:10:00',1.27),('15087','2013-04-29','08:15:00',1.32),('15087','2013-04-29','08:20:00',1.45),('15087','2013-04-29','08:25:00',1.67),('15087','2013-04-29','08:30:00',1.97),('15087','2013-04-29','08:35:00',2.21),('15087','2013-04-29','08:40:00',2.2),('15087','2013-04-29','08:45:00',2.17),('15087','2013-04-29','08:50:00',2.31),('15087','2013-04-29','08:55:00',2.25),('15087','2013-04-29','09:00:00',1.79),('15087','2013-04-29','09:05:00',2.48),('15087','2013-04-29','09:10:00',2.72),('15087','2013-04-29','09:15:00',2.86),('15087','2013-04-29','09:20:00',2.69),('15087','2013-04-29','09:25:00',2.6),('15087','2013-04-29','09:30:00',2.69),('15087','2013-04-29','09:35:00',2.81),('15087','2013-04-29','09:40:00',2.84),('15087','2013-04-29','09:45:00',2.9),('15087','2013-04-29','09:50:00',3.05),('15087','2013-04-29','09:55:00',2.9),('15087','2013-04-29','10:00:00',3.03),('15087','2013-04-29','10:05:00',3.01),('15087','2013-04-29','10:10:00',2.96),('15087','2013-04-29','10:15:00',2.42),('15087','2013-04-29','10:20:00',2.57),('15087','2013-04-29','10:25:00',3),('15087','2013-04-29','10:30:00',3.2),('15087','2013-04-29','10:35:00',3.55),('15087','2013-04-29','10:40:00',3.56),('15087','2013-04-29','10:45:00',3.55),('15087','2013-04-29','10:50:00',3.45),('15087','2013-04-29','10:55:00',3.23),('15087','2013-04-29','11:00:00',3.66),('15087','2013-04-29','11:05:00',3.41),('15087','2013-04-29','11:10:00',3.31),('15087','2013-04-29','11:15:00',3.2),('15087','2013-04-29','11:20:00',3.74),('15087','2013-04-29','11:25:00',3.86),('15087','2013-04-29','11:30:00',4.01),('15087','2013-04-29','11:35:00',3.84),('15087','2013-04-29','11:40:00',3.96),('15087','2013-04-29','11:45:00',3.75),('15087','2013-04-29','11:50:00',4.24),('15087','2013-04-29','11:55:00',4.09),('15087','2013-04-29','12:00:00',4.25),('15087','2013-04-29','12:05:00',4.18),('15087','2013-04-29','12:10:00',4.12),('15087','2013-04-29','12:15:00',4.18),('15087','2013-04-29','12:20:00',4.17),('15087','2013-04-29','12:25:00',4.08),('15087','2013-04-29','12:30:00',4.23),('15087','2013-04-29','12:35:00',4.3),('15087','2013-04-29','12:40:00',4.34),('15087','2013-04-29','12:45:00',4.33),('15087','2013-04-29','12:50:00',4.25),('15087','2013-04-29','12:55:00',4.25),('15087','2013-04-29','13:00:00',4.35),('15087','2013-04-29','13:05:00',4.26),('15087','2013-04-29','13:10:00',4.14),('15087','2013-04-29','13:15:00',3.68),('15087','2013-04-29','13:20:00',4.22),('15087','2013-04-29','13:25:00',4.41),('15087','2013-04-29','13:30:00',4.25),('15087','2013-04-29','13:35:00',4.13),('15087','2013-04-29','13:40:00',4.22),('15087','2013-04-29','13:45:00',4.21),('15087','2013-04-29','13:50:00',4.09),('15087','2013-04-29','13:55:00',4.5),('15087','2013-04-29','14:00:00',4.09),('15087','2013-04-29','14:05:00',4.04),('15087','2013-04-29','14:10:00',4.1),('15087','2013-04-29','14:15:00',4.23),('15087','2013-04-29','14:20:00',4.22),('15087','2013-04-29','14:25:00',3.95),('15087','2013-04-29','14:30:00',3.83),('15087','2013-04-29','14:35:00',3.76),('15087','2013-04-29','14:40:00',3.53),('15087','2013-04-29','14:45:00',3.7),('15087','2013-04-29','14:50:00',3.76),('15087','2013-04-29','14:55:00',3.72),('15087','2013-04-29','15:00:00',3.56),('15087','2013-04-29','15:05:00',3.63),('15087','2013-04-29','15:10:00',3.21),('15087','2013-04-29','15:15:00',3.28),('15087','2013-04-29','15:20:00',3.4),('15087','2013-04-29','15:25:00',3.53),('15087','2013-04-29','15:30:00',3.36),('15087','2013-04-29','15:35:00',3),('15087','2013-04-29','15:40:00',2.76),('15087','2013-04-29','15:45:00',2.69),('15087','2013-04-29','15:50:00',2.76),('15087','2013-04-29','15:55:00',2.9),('15087','2013-04-29','16:00:00',2.86),('15087','2013-04-29','16:05:00',3.01),('15087','2013-04-29','16:10:00',2.89),('15087','2013-04-29','16:15:00',3.32),('15087','2013-04-29','16:20:00',3.04),('15087','2013-04-29','16:25:00',2.53),('15087','2013-04-29','16:30:00',2.52),('15087','2013-04-29','16:35:00',2.51),('15087','2013-04-29','16:40:00',2.69),('15087','2013-04-29','16:45:00',2.66),('15087','2013-04-29','16:50:00',2.71),('15087','2013-04-29','16:55:00',2.76),('15087','2013-04-29','17:00:00',2.55),('15087','2013-04-29','17:05:00',2.17),('15087','2013-04-29','17:10:00',2.24),('15087','2013-04-29','17:15:00',1.84),('15087','2013-04-29','17:20:00',1.51),('15087','2013-04-29','17:25:00',1.44),('15087','2013-04-29','17:30:00',1.44),('15087','2013-04-29','17:35:00',1.34),('15087','2013-04-29','17:40:00',1.15),('15087','2013-04-29','17:45:00',1.07),('15087','2013-04-29','17:50:00',1.34),('15087','2013-04-29','17:55:00',1.49),('15087','2013-04-29','18:00:00',1.42),('15087','2013-04-29','18:05:00',1.52),('15087','2013-04-29','18:10:00',1.35),('15087','2013-04-29','18:15:00',1.26),('15087','2013-04-29','18:20:00',1.05),('15087','2013-04-29','18:25:00',1.02),('15087','2013-04-28','07:45:00',1.03),('15087','2013-04-28','07:50:00',1.12),('15087','2013-04-28','07:55:00',1.2),('15087','2013-04-28','08:00:00',1.27),('15087','2013-04-28','08:05:00',1.39),('15087','2013-04-28','08:10:00',1.51),('15087','2013-04-28','08:15:00',1.6),('15087','2013-04-28','08:20:00',1.69),('15087','2013-04-28','08:25:00',1.84),('15087','2013-04-28','08:30:00',1.92),('15087','2013-04-28','08:35:00',1.99),('15087','2013-04-28','08:40:00',2.07),('15087','2013-04-28','08:45:00',2.18),('15087','2013-04-28','08:50:00',2.29),('15087','2013-04-28','08:55:00',2.37),('15087','2013-04-28','09:00:00',2.45),('15087','2013-04-28','09:05:00',2.53),('15087','2013-04-28','09:10:00',2.63),('15087','2013-04-28','09:15:00',2.71),('15087','2013-04-28','09:20:00',2.8),('15087','2013-04-28','09:25:00',2.86),('15087','2013-04-28','09:30:00',2.94),('15087','2013-04-28','09:35:00',3.01),('15087','2013-04-28','09:40:00',3.1),('15087','2013-04-28','09:45:00',3.18),('15087','2013-04-28','09:50:00',3.26),('15087','2013-04-28','09:55:00',3.32),('15087','2013-04-28','10:00:00',3.39),('15087','2013-04-28','10:05:00',3.43),('15087','2013-04-28','10:10:00',3.48),('15087','2013-04-28','10:15:00',3.55),('15087','2013-04-28','10:20:00',3.61),('15087','2013-04-28','10:25:00',3.74),('15087','2013-04-28','10:30:00',3.64),('15087','2013-04-28','10:35:00',3.8),('15087','2013-04-28','10:40:00',3.46),('15087','2013-04-28','10:45:00',3.93),('15087','2013-04-28','10:50:00',3.96),('15087','2013-04-28','10:55:00',4),('15087','2013-04-28','11:00:00',4.02),('15087','2013-04-28','11:05:00',4.02),('15087','2013-04-28','11:10:00',4.07),('15087','2013-04-28','11:15:00',4.16),('15087','2013-04-28','11:20:00',4.13),('15087','2013-04-28','11:25:00',4.2),('15087','2013-04-28','11:30:00',4.22),('15087','2013-04-28','11:35:00',4.16),('15087','2013-04-28','11:40:00',4.21),('15087','2013-04-28','11:45:00',4.05),('15087','2013-04-28','11:50:00',3.98),('15087','2013-04-28','11:55:00',4.24),('15087','2013-04-28','12:00:00',3.71),('15087','2013-04-28','12:05:00',3.69),('15087','2013-04-28','12:10:00',4.07),('15087','2013-04-28','12:15:00',4.15),('15087','2013-04-28','12:20:00',4.14),('15087','2013-04-28','12:25:00',3.71),('15087','2013-04-28','12:30:00',3.55),('15087','2013-04-28','12:35:00',3.37),('15087','2013-04-28','12:40:00',3.33),('15087','2013-04-28','12:45:00',4.31),('15087','2013-04-28','12:50:00',4.33),('15087','2013-04-28','12:55:00',4.14),('15087','2013-04-28','13:00:00',4.21),('15087','2013-04-28','13:05:00',4.55),('15087','2013-04-28','13:10:00',4.43),('15087','2013-04-28','13:15:00',4.09),('15087','2013-04-28','13:20:00',4.24),('15087','2013-04-28','13:25:00',4.04),('15087','2013-04-28','13:30:00',4.18),('15087','2013-04-28','13:35:00',3.37),('15087','2013-04-28','13:40:00',2.58),('15087','2013-04-28','13:45:00',1.75),('15087','2013-04-28','13:50:00',1.68),('15087','2013-04-28','13:55:00',1.74),('15087','2013-04-28','14:00:00',2.76),('15087','2013-04-28','14:05:00',3.95),('15087','2013-04-28','14:10:00',3.95),('15087','2013-04-28','14:15:00',4.11),('15087','2013-04-28','14:20:00',4.03),('15087','2013-04-28','14:25:00',3.66),('15087','2013-04-28','14:30:00',4),('15087','2013-04-28','14:35:00',4.06),('15087','2013-04-28','14:40:00',3.89),('15087','2013-04-28','14:45:00',3.77),('15087','2013-04-28','14:50:00',3.82),('15087','2013-04-28','14:55:00',3.78),('15087','2013-04-28','15:00:00',3.72),('15087','2013-04-28','15:05:00',3.61),('15087','2013-04-28','15:10:00',3.63),('15087','2013-04-28','15:15:00',3.58),('15087','2013-04-28','15:20:00',3.53),('15087','2013-04-28','15:25:00',3.41),('15087','2013-04-28','15:30:00',3.25),('15087','2013-04-28','15:35:00',3.23),('15087','2013-04-28','15:40:00',3.21),('15087','2013-04-28','15:45:00',3.19),('15087','2013-04-28','15:50:00',3),('15087','2013-04-28','15:55:00',2.99),('15087','2013-04-28','16:00:00',2.89),('15087','2013-04-28','16:05:00',2.77),('15087','2013-04-28','16:10:00',2.85),('15087','2013-04-28','16:15:00',2.82),('15087','2013-04-28','16:20:00',2.58),('15087','2013-04-28','16:25:00',2.66),('15087','2013-04-28','16:30:00',2.69),('15087','2013-04-28','16:35:00',2.59),('15087','2013-04-28','16:40:00',2.49),('15087','2013-04-28','16:45:00',2.46),('15087','2013-04-28','16:50:00',2.31),('15087','2013-04-28','16:55:00',2.21),('15087','2013-04-28','17:00:00',2.17),('15087','2013-04-28','17:05:00',1.97),('15087','2013-04-28','17:10:00',1.88),('15087','2013-04-28','17:15:00',1.93),('15087','2013-04-28','17:20:00',1.84),('15087','2013-04-28','17:25:00',1.73),('15087','2013-04-28','17:30:00',1.43),('15087','2013-04-28','17:35:00',1.39),('15087','2013-04-28','17:40:00',1.37),('15087','2013-04-28','17:45:00',1.42),('15087','2013-04-28','17:50:00',1.34),('15087','2013-04-28','17:55:00',1.17),('15087','2013-04-28','18:00:00',1.15),('15087','2013-04-28','18:05:00',1.07),('15087','2013-04-27','12:50:00',1.07),('15087','2013-04-27','12:55:00',1.45),('15087','2013-04-27','13:00:00',1.57),('15087','2013-04-27','13:05:00',1.11),('15087','2013-04-27','13:10:00',1.22),('15087','2013-04-27','13:15:00',1.66),('15087','2013-04-27','13:20:00',1.74),('15087','2013-04-27','13:25:00',1.2),('15087','2013-04-27','13:30:00',1.33),('15087','2013-04-27','13:35:00',1.7),('15087','2013-04-27','13:40:00',1.89),('15087','2013-04-27','13:45:00',1.23),('15087','2013-04-27','13:50:00',1.17),('15087','2013-04-27','14:25:00',1.37),('15087','2013-04-27','14:30:00',2.39),('15087','2013-04-27','14:35:00',2.01),('15087','2013-04-27','14:40:00',1.39),('15087','2013-04-27','14:45:00',1.2),('15087','2013-04-27','15:00:00',1.11),('15087','2013-04-27','15:05:00',1.92),('15087','2013-04-27','15:10:00',1.43),('15087','2013-04-27','15:15:00',1.03),('15087','2013-04-27','16:40:00',1.06),('15087','2013-04-27','16:45:00',1.45),('15087','2013-04-27','16:50:00',2.09),('15087','2013-04-27','16:55:00',2.19),('15087','2013-04-27','17:00:00',2.49),('15087','2013-04-27','17:05:00',1.6),('15087','2013-04-27','17:20:00',1.15),('15087','2013-04-27','17:40:00',1.23),('15087','2013-04-26','08:05:00',1.03),('15087','2013-04-26','08:10:00',1.24),('15087','2013-04-26','08:15:00',1.37),('15087','2013-04-26','08:20:00',1.45),('15087','2013-04-26','08:25:00',1.53),('15087','2013-04-26','08:30:00',1.62),('15087','2013-04-26','08:35:00',1.8),('15087','2013-04-26','08:40:00',1.86),('15087','2013-04-26','08:45:00',1.96),('15087','2013-04-26','08:50:00',1.6),('15087','2013-04-26','08:55:00',1.44),('15087','2013-04-26','09:00:00',1.5),('15087','2013-04-26','09:05:00',2.15),('15087','2013-04-26','09:10:00',1.81),('15087','2013-04-26','09:15:00',1.24),('15087','2013-04-26','09:20:00',1.25),('15087','2013-04-26','09:25:00',1.95),('15087','2013-04-26','09:30:00',2.1),('15087','2013-04-26','09:35:00',1.84),('15087','2013-04-26','09:40:00',2.01),('15087','2013-04-26','09:45:00',2.48),('15087','2013-04-26','09:50:00',2.99),('15087','2013-04-26','09:55:00',1.84),('15087','2013-04-26','10:00:00',2.94),('15087','2013-04-26','10:05:00',3.37),('15087','2013-04-26','10:10:00',3.4),('15087','2013-04-26','10:15:00',3.5),('15087','2013-04-26','10:20:00',3.32),('15087','2013-04-26','10:25:00',3.36),('15087','2013-04-26','10:30:00',3.53),('15087','2013-04-26','10:35:00',3.78),('15087','2013-04-26','10:40:00',3.61),('15087','2013-04-26','10:45:00',3.72),('15087','2013-04-26','10:50:00',2.69),('15087','2013-04-26','10:55:00',1.94),('15087','2013-04-26','11:00:00',3.64),('15087','2013-04-26','11:05:00',3.76),('15087','2013-04-26','11:10:00',3.66),('15087','2013-04-26','11:15:00',3.26),('15087','2013-04-26','11:20:00',2.69),('15087','2013-04-26','11:25:00',3.44),('15087','2013-04-26','11:30:00',3.46),('15087','2013-04-26','11:35:00',3.95),('15087','2013-04-26','11:40:00',3.22),('15087','2013-04-26','11:45:00',3.67),('15087','2013-04-26','11:50:00',2.8),('15087','2013-04-26','11:55:00',2.67),('15087','2013-04-26','12:00:00',3.37),('15087','2013-04-26','12:05:00',2.8),('15087','2013-04-26','12:10:00',2.75),('15087','2013-04-26','12:15:00',3.07),('15087','2013-04-26','12:20:00',3.13),('15087','2013-04-26','12:25:00',1.91),('15087','2013-04-26','12:30:00',1.87),('15087','2013-04-26','12:35:00',2.67),('15087','2013-04-26','12:40:00',3.42),('15087','2013-04-26','12:45:00',3.16),('15087','2013-04-26','12:50:00',2.28),('15087','2013-04-26','12:55:00',2.03),('15087','2013-04-26','13:00:00',1.39),('15087','2013-04-26','13:05:00',1.35),('15087','2013-04-26','13:10:00',1.73),('15087','2013-04-26','13:15:00',2.85),('15087','2013-04-26','13:20:00',1.89),('15087','2013-04-26','13:25:00',2.33),('15087','2013-04-26','13:30:00',3.47),('15087','2013-04-26','13:35:00',2.63),('15087','2013-04-26','13:40:00',3.13),('15087','2013-04-26','13:45:00',2.53),('15087','2013-04-26','13:50:00',3.44),('15087','2013-04-26','13:55:00',3.08),('15087','2013-04-26','14:00:00',3.34),('15087','2013-04-26','14:05:00',3.81),('15087','2013-04-26','14:10:00',3.41),('15087','2013-04-26','14:15:00',3.48),('15087','2013-04-26','14:20:00',3.8),('15087','2013-04-26','14:25:00',4.16),('15087','2013-04-26','14:30:00',4.12),('15087','2013-04-26','14:35:00',2.78),('15087','2013-04-26','14:40:00',1.82),('15087','2013-04-26','14:45:00',1.61),('15087','2013-04-26','14:50:00',3.99),('15087','2013-04-26','14:55:00',4.03),('15087','2013-04-26','15:00:00',3.78),('15087','2013-04-26','15:05:00',2.26),('15087','2013-04-26','15:10:00',1.63),('15087','2013-04-26','15:15:00',2.21),('15087','2013-04-26','15:20:00',1.51),('15087','2013-04-26','15:25:00',1.71),('15087','2013-04-26','15:30:00',2.56),('15087','2013-04-26','15:35:00',1.98),('15087','2013-04-26','15:40:00',2.19),('15087','2013-04-26','15:45:00',2.65),('15087','2013-04-26','15:50:00',2.01),('15087','2013-04-26','15:55:00',1.1),('15087','2013-04-25','08:05:00',1.09),('15087','2013-04-25','08:10:00',1.12),('15087','2013-04-25','08:15:00',1.52),('15087','2013-04-25','08:20:00',1.12),('15087','2013-04-25','08:30:00',1.02),('15087','2013-04-25','08:35:00',1.06),('15087','2013-04-25','08:40:00',1.13),('15087','2013-04-25','08:45:00',1.59),('15087','2013-04-25','08:50:00',2.43),('15087','2013-04-25','08:55:00',2.58),('15087','2013-04-25','09:00:00',2.03),('15087','2013-04-25','09:05:00',1.47),('15087','2013-04-25','09:10:00',1.46),('15087','2013-04-25','09:15:00',1.29),('15087','2013-04-25','09:20:00',1.45),('15087','2013-04-25','09:25:00',1.6),('15087','2013-04-25','09:30:00',1.49),('15087','2013-04-25','09:35:00',1.74),('15087','2013-04-25','09:40:00',2.44),('15087','2013-04-25','09:45:00',3.01),('15087','2013-04-25','09:50:00',3.35),('15087','2013-04-25','09:55:00',3.39),('15087','2013-04-25','10:00:00',3.4),('15087','2013-04-25','10:05:00',3.2),('15087','2013-04-25','10:10:00',2.94),('15087','2013-04-25','10:15:00',3.22),('15087','2013-04-25','10:20:00',3.47),('15087','2013-04-25','10:25:00',3.64),('15087','2013-04-25','10:30:00',3.78),('15087','2013-04-25','10:35:00',3.82),('15087','2013-04-25','10:40:00',3.81),('15087','2013-04-25','10:45:00',3.72),('15087','2013-04-25','10:50:00',3.93),('15087','2013-04-25','10:55:00',3.84),('15087','2013-04-25','11:00:00',4.05),('15087','2013-04-25','11:05:00',4.07),('15087','2013-04-25','11:10:00',4.12),('15087','2013-04-25','11:15:00',4.14),('15087','2013-04-25','11:20:00',4.22),('15087','2013-04-25','11:25:00',4.26),('15087','2013-04-25','11:30:00',4.28),('15087','2013-04-25','11:35:00',4.23),('15087','2013-04-25','11:40:00',4.36),('15087','2013-04-25','11:45:00',4.39),('15087','2013-04-25','11:50:00',4.45),('15087','2013-04-25','11:55:00',4.39),('15087','2013-04-25','12:00:00',4.32),('15087','2013-04-25','12:05:00',4.35),('15087','2013-04-25','12:10:00',4.44),('15087','2013-04-25','12:15:00',4.47),('15087','2013-04-25','12:20:00',4.44),('15087','2013-04-25','12:25:00',4.45),('15087','2013-04-25','12:30:00',4.48),('15087','2013-04-25','12:35:00',4.48),('15087','2013-04-25','12:40:00',4.48),('15087','2013-04-25','12:45:00',4.48),('15087','2013-04-25','12:50:00',4.47),('15087','2013-04-25','12:55:00',4.49),('15087','2013-04-25','13:00:00',4.55),('15087','2013-04-25','13:05:00',4.63),('15087','2013-04-25','13:10:00',4.51),('15087','2013-04-25','13:15:00',4.49),('15087','2013-04-25','13:20:00',4.11),('15087','2013-04-25','13:25:00',3.68),('15087','2013-04-25','13:30:00',2.89),('15087','2013-04-25','13:35:00',2.86),('15087','2013-04-25','13:40:00',2.6),('15087','2013-04-25','13:45:00',2.44),('15087','2013-04-25','13:50:00',2.33),('15087','2013-04-25','13:55:00',2.51),('15087','2013-04-25','14:00:00',2.58),('15087','2013-04-25','14:05:00',2.38),('15087','2013-04-25','14:10:00',2.57),('15087','2013-04-25','14:15:00',2.77),('15087','2013-04-25','14:20:00',2.81),('15087','2013-04-25','14:25:00',2.89),('15087','2013-04-25','14:30:00',3.43),('15087','2013-04-25','14:35:00',3.94),('15087','2013-04-25','14:40:00',3.68),('15087','2013-04-25','14:45:00',3.69),('15087','2013-04-25','14:50:00',3.36),('15087','2013-04-25','14:55:00',3.5),('15087','2013-04-25','15:00:00',3.29),('15087','2013-04-25','15:05:00',2.96),('15087','2013-04-25','15:10:00',3.02),('15087','2013-04-25','15:15:00',3.35),('15087','2013-04-25','15:20:00',3.56),('15087','2013-04-25','15:25:00',3.57),('15087','2013-04-25','15:30:00',3.48),('15087','2013-04-25','15:35:00',3.34),('15087','2013-04-25','15:40:00',3.06),('15087','2013-04-25','15:45:00',2.95),('15087','2013-04-25','15:50:00',2.76),('15087','2013-04-25','15:55:00',2.71),('15087','2013-04-25','16:00:00',2.73),('15087','2013-04-25','16:05:00',2.35),('15087','2013-04-25','16:10:00',2.34),('15087','2013-04-25','16:15:00',2.29),('15087','2013-04-25','16:20:00',2.44),('15087','2013-04-25','16:25:00',2.11),('15087','2013-04-25','16:30:00',2.03),('15087','2013-04-25','16:35:00',2.4),('15087','2013-04-25','16:40:00',2.15),('15087','2013-04-25','16:45:00',2.19),('15087','2013-04-25','16:50:00',1.85),('15087','2013-04-25','16:55:00',1.99),('15087','2013-04-25','17:00:00',1.88),('15087','2013-04-25','17:05:00',2.25),('15087','2013-04-25','17:10:00',2.32),('15087','2013-04-25','17:15:00',2.15),('15087','2013-04-25','17:20:00',2.15),('15087','2013-04-25','17:25:00',1.77),('15087','2013-04-25','17:30:00',1.44),('15087','2013-04-25','17:35:00',1.37),('15087','2013-04-25','17:40:00',1.38),('15087','2013-04-25','17:45:00',1.19),('15087','2013-04-24','07:55:00',1.08),('15087','2013-04-24','08:00:00',1.14),('15087','2013-04-24','08:05:00',1.22),('15087','2013-04-24','08:10:00',1.43),('15087','2013-04-24','08:15:00',1.65),('15087','2013-04-24','08:20:00',1.7),('15087','2013-04-24','08:25:00',1.86),('15087','2013-04-24','08:30:00',1.83),('15087','2013-04-24','08:35:00',1.77),('15087','2013-04-24','08:40:00',1.85),('15087','2013-04-24','08:45:00',1.9),('15087','2013-04-24','08:50:00',2.03),('15087','2013-04-24','08:55:00',2.13),('15087','2013-04-24','09:00:00',2.37),('15087','2013-04-24','09:05:00',2.63),('15087','2013-04-24','09:10:00',2.76),('15087','2013-04-24','09:15:00',2.31),('15087','2013-04-24','09:20:00',2.05),('15087','2013-04-24','09:25:00',2.79),('15087','2013-04-24','09:30:00',2.81),('15087','2013-04-24','09:35:00',3.1),('15087','2013-04-24','09:40:00',2.89),('15087','2013-04-24','09:45:00',2.9),('15087','2013-04-24','09:50:00',3.02),('15087','2013-04-24','09:55:00',3.38),('15087','2013-04-24','10:00:00',3.54),('15087','2013-04-24','10:05:00',3.63),('15087','2013-04-24','10:10:00',3.67),('15087','2013-04-24','10:15:00',3.63),('15087','2013-04-24','10:20:00',3.59),('15087','2013-04-24','10:25:00',3.56),('15087','2013-04-24','10:30:00',3.51),('15087','2013-04-24','10:35:00',3.53),('15087','2013-04-24','10:40:00',3.92),('15087','2013-04-24','10:45:00',3.95),('15087','2013-04-24','10:50:00',4.01),('15087','2013-04-24','10:55:00',4.14),('15087','2013-04-24','11:00:00',4.13),('15087','2013-04-24','11:05:00',4.01),('15087','2013-04-24','11:10:00',4.4),('15087','2013-04-24','11:15:00',4.43),('15087','2013-04-24','11:20:00',4.57),('15087','2013-04-24','11:25:00',4.56),('15087','2013-04-24','11:30:00',4.4),('15087','2013-04-24','11:35:00',4),('15087','2013-04-24','11:40:00',3.21),('15087','2013-04-24','11:45:00',2.98),('15087','2013-04-24','11:50:00',2.24),('15087','2013-04-24','11:55:00',3.37),('15087','2013-04-24','12:00:00',3.69),('15087','2013-04-24','12:05:00',2.63),('15087','2013-04-24','12:10:00',3.24),('15087','2013-04-24','12:15:00',4.37),('15087','2013-04-24','12:20:00',5),('15087','2013-04-24','12:25:00',4.25),('15087','2013-04-24','12:30:00',4.24),('15087','2013-04-24','12:35:00',4.38),('15087','2013-04-24','12:40:00',4.16),('15087','2013-04-24','12:45:00',4.29),('15087','2013-04-24','12:50:00',4.55),('15087','2013-04-24','12:55:00',4.42),('15087','2013-04-24','13:00:00',4.29),('15087','2013-04-24','13:05:00',3.81),('15087','2013-04-24','13:10:00',4.91),('15087','2013-04-24','13:15:00',4.51),('15087','2013-04-24','13:20:00',4.27),('15087','2013-04-24','13:25:00',4.48),('15087','2013-04-24','13:30:00',4.04),('15087','2013-04-24','13:35:00',4.41),('15087','2013-04-24','13:40:00',4.83),('15087','2013-04-24','13:45:00',3.97),('15087','2013-04-24','13:50:00',3.11),('15087','2013-04-24','13:55:00',4.64),('15087','2013-04-24','14:00:00',4.42),('15087','2013-04-24','14:05:00',3.18),('15087','2013-04-24','14:10:00',3.33),('15087','2013-04-24','14:15:00',4.4),('15087','2013-04-24','14:20:00',4.07),('15087','2013-04-24','14:25:00',4.17),('15087','2013-04-24','14:30:00',3.88),('15087','2013-04-24','14:35:00',3.53),('15087','2013-04-24','14:40:00',3.28),('15087','2013-04-24','14:45:00',3.19),('15087','2013-04-24','14:50:00',2.89),('15087','2013-04-24','14:55:00',2.57),('15087','2013-04-24','15:00:00',2.8),('15087','2013-04-24','15:05:00',2.58),('15087','2013-04-24','15:10:00',2.39),('15087','2013-04-24','15:15:00',2.55),('15087','2013-04-24','15:20:00',2.73),('15087','2013-04-24','15:25:00',2.25),('15087','2013-04-24','15:30:00',1.95),('15087','2013-04-24','15:35:00',1.85),('15087','2013-04-24','15:40:00',1.87),('15087','2013-04-24','15:45:00',1.87),('15087','2013-04-24','15:50:00',1.91),('15087','2013-04-24','15:55:00',2.43),('15087','2013-04-24','16:00:00',2.88),('15087','2013-04-24','16:05:00',2.96),('15087','2013-04-24','16:10:00',2.87),('15087','2013-04-24','16:15:00',2.75),('15087','2013-04-24','16:20:00',3.34),('15087','2013-04-24','16:25:00',2.6),('15087','2013-04-24','16:30:00',2.2),('15087','2013-04-24','16:35:00',1.98),('15087','2013-04-24','16:40:00',2.49),('15087','2013-04-24','16:45:00',2.51),('15087','2013-04-24','16:50:00',2.33),('15087','2013-04-24','16:55:00',2.75),('15087','2013-04-24','17:00:00',2.69),('15087','2013-04-24','17:05:00',2.55),('15087','2013-04-24','17:10:00',2.41),('15087','2013-04-24','17:15:00',1.72),('15087','2013-04-24','17:20:00',1.75),('15087','2013-04-24','17:25:00',1.49),('15087','2013-04-24','17:50:00',1.1),('15087','2013-04-24','17:55:00',1.44),('15087','2013-04-24','18:00:00',1.1),('15087','2013-04-24','18:05:00',1.16),('15087','2013-04-23','07:45:00',1.02),('15087','2013-04-23','07:50:00',1.12),('15087','2013-04-23','07:55:00',1.22),('15087','2013-04-23','08:00:00',1.34),('15087','2013-04-23','08:05:00',1.49),('15087','2013-04-23','08:10:00',1.61),('15087','2013-04-23','08:15:00',1.71),('15087','2013-04-23','08:20:00',1.82),('15087','2013-04-23','08:25:00',1.92),('15087','2013-04-23','08:30:00',2.01),('15087','2013-04-23','08:35:00',2.1),('15087','2013-04-23','08:40:00',2.2),('15087','2013-04-23','08:45:00',2.28),('15087','2013-04-23','08:50:00',2.39),('15087','2013-04-23','08:55:00',2.5),('15087','2013-04-23','09:00:00',2.57),('15087','2013-04-23','09:05:00',2.66),('15087','2013-04-23','09:10:00',2.75),('15087','2013-04-23','09:15:00',2.87),('15087','2013-04-23','09:20:00',2.96),('15087','2013-04-23','09:25:00',3.04),('15087','2013-04-23','09:30:00',3.12),('15087','2013-04-23','09:35:00',3.2),('15087','2013-04-23','09:40:00',2.93),('15087','2013-04-23','09:45:00',2.98),('15087','2013-04-23','09:50:00',3.49),('15087','2013-04-23','09:55:00',3.53),('15087','2013-04-23','10:00:00',3.56),('15087','2013-04-23','10:05:00',3.65),('15087','2013-04-23','10:10:00',3.71),('15087','2013-04-23','10:15:00',3.74),('15087','2013-04-23','10:20:00',3.78),('15087','2013-04-23','10:25:00',3.83),('15087','2013-04-23','10:30:00',3.9),('15087','2013-04-23','10:35:00',3.99),('15087','2013-04-23','10:40:00',4.04),('15087','2013-04-23','10:45:00',4),('15087','2013-04-23','10:50:00',4.15),('15087','2013-04-23','10:55:00',4.23),('15087','2013-04-23','11:00:00',4.26),('15087','2013-04-23','11:05:00',4.25),('15087','2013-04-23','11:10:00',4.3),('15087','2013-04-23','11:15:00',4.33),('15087','2013-04-23','11:20:00',4.39),('15087','2013-04-23','11:25:00',4.42),('15087','2013-04-23','11:30:00',4.42),('15087','2013-04-23','11:35:00',4.43),('15087','2013-04-23','11:40:00',4.49),('15087','2013-04-23','11:45:00',4.48),('15087','2013-04-23','11:50:00',4.46),('15087','2013-04-23','11:55:00',4.48),('15087','2013-04-23','12:00:00',4.53),('15087','2013-04-23','12:05:00',4.58),('15087','2013-04-23','12:10:00',4.58),('15087','2013-04-23','12:15:00',4.55),('15087','2013-04-23','12:20:00',4.58),('15087','2013-04-23','12:25:00',4.66),('15087','2013-04-23','12:30:00',4.83),('15087','2013-04-23','12:35:00',5.07),('15087','2013-04-23','12:40:00',5.09),('15087','2013-04-23','12:45:00',4.19),('15087','2013-04-23','12:50:00',2.14),('15087','2013-04-23','12:55:00',4.63),('15087','2013-04-23','13:00:00',5.19),('15087','2013-04-23','13:05:00',4.93),('15087','2013-04-23','13:10:00',2.65),('15087','2013-04-23','13:15:00',3.94),('15087','2013-04-23','13:20:00',4.87),('15087','2013-04-23','13:25:00',4.95),('15087','2013-04-23','13:30:00',4.84),('15087','2013-04-23','13:35:00',4.94),('15087','2013-04-23','13:40:00',4.87),('15087','2013-04-23','13:45:00',3.43),('15087','2013-04-23','13:50:00',4.42),('15087','2013-04-23','13:55:00',4.74),('15087','2013-04-23','14:00:00',4.55),('15087','2013-04-23','14:05:00',4.81),('15087','2013-04-23','14:10:00',4.32),('15087','2013-04-23','14:15:00',4.22),('15087','2013-04-23','14:20:00',4.12),('15087','2013-04-23','14:25:00',3.75),('15087','2013-04-23','14:30:00',4.43),('15087','2013-04-23','14:35:00',4.12),('15087','2013-04-23','14:40:00',4.25),('15087','2013-04-23','14:45:00',3.61),('15087','2013-04-23','14:50:00',2.34),('15087','2013-04-23','14:55:00',2.52),('15087','2013-04-23','15:00:00',2.62),('15087','2013-04-23','15:05:00',2.8),('15087','2013-04-23','15:10:00',3.33),('15087','2013-04-23','15:15:00',3.23),('15087','2013-04-23','15:20:00',2.98),('15087','2013-04-23','15:25:00',2.71),('15087','2013-04-23','15:30:00',2.71),('15087','2013-04-23','15:35:00',2.58),('15087','2013-04-23','15:40:00',2.35),('15087','2013-04-23','15:45:00',2.79),('15087','2013-04-23','15:50:00',2.12),('15087','2013-04-23','15:55:00',2.01),('15087','2013-04-23','16:00:00',2.37),('15087','2013-04-23','16:05:00',2.69),('15087','2013-04-23','16:10:00',2.66),('15087','2013-04-23','16:15:00',2.27),('15087','2013-04-23','16:20:00',1.45),('15087','2013-04-23','16:25:00',1.41),('15087','2013-04-23','16:30:00',1.21),('15087','2013-04-23','16:35:00',1.15),('15087','2013-04-23','16:40:00',1.13),('15087','2013-04-23','16:45:00',1.15),('15087','2013-04-23','16:50:00',1.03),('15087','2013-04-23','16:55:00',1.07),('15087','2013-04-23','17:00:00',1.13),('15087','2013-04-23','17:05:00',1.19),('15087','2013-04-23','17:10:00',1.69),('15087','2013-04-23','17:15:00',1.27),('15087','2013-04-23','17:25:00',1.72),('15087','2013-04-23','17:30:00',1.48),('15087','2013-04-23','17:35:00',1.06),('15087','2013-04-22','09:30:00',1.26),('15087','2013-04-22','09:35:00',1.07),('15087','2013-04-22','10:35:00',2.28),('15087','2013-04-22','10:40:00',3.85),('15087','2013-04-22','10:45:00',5.02),('15087','2013-04-22','10:50:00',2.66),('15087','2013-04-22','10:55:00',2.62),('15087','2013-04-22','11:00:00',2.21),('15087','2013-04-22','11:05:00',1.96),('15087','2013-04-22','11:10:00',2.43),('15087','2013-04-22','11:15:00',1.53),('15087','2013-04-22','11:20:00',1.64),('15087','2013-04-22','11:25:00',2),('15087','2013-04-22','11:30:00',3.39),('15087','2013-04-22','11:35:00',4.93),('15087','2013-04-22','11:40:00',4),('15087','2013-04-22','11:45:00',2.72),('15087','2013-04-22','11:50:00',1.9),('15087','2013-04-22','11:55:00',3.78),('15087','2013-04-22','12:00:00',3.74),('15087','2013-04-22','12:05:00',4.05),('15087','2013-04-22','12:10:00',3.19),('15087','2013-04-22','12:15:00',2.64),('15087','2013-04-22','12:20:00',2.49),('15087','2013-04-22','12:25:00',2.14),('15087','2013-04-22','12:30:00',2.45),('15087','2013-04-22','12:35:00',2.3),('15087','2013-04-22','12:40:00',4.15),('15087','2013-04-22','12:45:00',3.81),('15087','2013-04-22','12:50:00',5.16),('15087','2013-04-22','12:55:00',5.18),('15087','2013-04-22','13:00:00',4.56),('15087','2013-04-22','13:05:00',4.5),('15087','2013-04-22','13:10:00',3.29),('15087','2013-04-22','13:15:00',4.52),('15087','2013-04-22','13:20:00',5.26),('15087','2013-04-22','13:25:00',2.26),('15087','2013-04-22','13:30:00',1.79),('15087','2013-04-22','13:35:00',2.24),('15087','2013-04-22','13:40:00',2.18),('15087','2013-04-22','13:45:00',1.67),('15087','2013-04-22','13:50:00',1.18),('15087','2013-04-22','13:55:00',2.68),('15087','2013-04-22','14:00:00',1.5),('15087','2013-04-22','14:05:00',2.19),('15087','2013-04-22','14:10:00',2.71),('15087','2013-04-22','14:15:00',4.57),('15087','2013-04-22','14:20:00',4.95),('15087','2013-04-22','14:25:00',3.08),('15087','2013-04-22','14:30:00',2.65),('15087','2013-04-22','14:35:00',3.27),('15087','2013-04-22','14:40:00',4.76),('15087','2013-04-22','14:45:00',3.91),('15087','2013-04-22','14:50:00',4.61),('15087','2013-04-22','14:55:00',3.89),('15087','2013-04-22','15:00:00',1.04),('15087','2013-04-22','15:05:00',1.56),('15087','2013-04-22','15:10:00',1.26),('15087','2013-04-22','15:15:00',1.18),('15087','2013-04-22','15:20:00',2.79),('15087','2013-04-22','15:25:00',4.08),('15087','2013-04-22','15:30:00',1.79),('15087','2013-04-22','15:35:00',2.26),('15087','2013-04-22','15:40:00',3.25),('15087','2013-04-22','15:45:00',4.15),('15087','2013-04-22','15:50:00',2.38),('15087','2013-04-22','15:55:00',1.34),('15087','2013-04-22','16:45:00',1.14),('15087','2013-04-22','16:50:00',1.09),('15087','2014-03-29','07:25:00',1.05),('15087','2014-03-29','07:30:00',1.15),('15087','2014-03-29','07:35:00',1.25),('15087','2014-03-29','07:40:00',1.37),('15087','2014-03-29','07:45:00',1.53),('15087','2014-03-29','07:50:00',1.64),('15087','2014-03-29','07:55:00',1.73),('15087','2014-03-29','08:00:00',1.84),('15087','2014-03-29','08:05:00',1.95),('15087','2014-03-29','08:10:00',2.06),('15087','2014-03-29','08:15:00',2.15),('15087','2014-03-29','08:20:00',2.22),('15087','2014-03-29','08:25:00',2.34),('15087','2014-03-29','08:30:00',2.41),('15087','2014-03-29','08:35:00',2.5),('15087','2014-03-29','08:40:00',2.58),('15087','2014-03-29','08:45:00',2.65),('15087','2014-03-29','08:50:00',2.73),('15087','2014-03-29','08:55:00',2.8),('15087','2014-03-29','09:00:00',2.85),('15087','2014-03-29','09:05:00',2.93),('15087','2014-03-29','09:10:00',3.02),('15087','2014-03-29','09:15:00',3.12),('15087','2014-03-29','09:20:00',3.21),('15087','2014-03-29','09:25:00',3.28),('15087','2014-03-29','09:30:00',3.34),('15087','2014-03-29','09:35:00',3.37),('15087','2014-03-29','09:40:00',3.48),('15087','2014-03-29','09:45:00',3.52),('15087','2014-03-29','09:50:00',3.6),('15087','2014-03-29','09:55:00',3.68),('15087','2014-03-29','10:00:00',3.73),('15087','2014-03-29','10:05:00',3.77),('15087','2014-03-29','10:10:00',3.87),('15087','2014-03-29','10:15:00',3.97),('15087','2014-03-29','10:20:00',3.98),('15087','2014-03-29','10:25:00',4.03),('15087','2014-03-29','10:30:00',4.06),('15087','2014-03-29','10:35:00',4.05),('15087','2014-03-29','10:40:00',4.11),('15087','2014-03-29','10:45:00',4.13),('15087','2014-03-29','10:50:00',4.2),('15087','2014-03-29','10:55:00',4.25),('15087','2014-03-29','11:00:00',4.28),('15087','2014-03-29','11:05:00',4.28),('15087','2014-03-29','11:10:00',4.3),('15087','2014-03-29','11:15:00',4.34),('15087','2014-03-29','11:20:00',4.36),('15087','2014-03-29','11:25:00',4.37),('15087','2014-03-29','11:30:00',4.36),('15087','2014-03-29','11:35:00',4.37),('15087','2014-03-29','11:40:00',4.26),('15087','2014-03-29','11:45:00',4.47),('15087','2014-03-29','11:50:00',4.46),('15087','2014-03-29','11:55:00',4.44),('15087','2014-03-29','12:00:00',4.43),('15087','2014-03-29','12:05:00',4.45),('15087','2014-03-29','12:10:00',4.43),('15087','2014-03-29','12:15:00',4.44),('15087','2014-03-29','12:20:00',4.46),('15087','2014-03-29','12:25:00',4.48),('15087','2014-03-29','12:30:00',4.47),('15087','2014-03-29','12:35:00',4.45),('15087','2014-03-29','12:40:00',4.41),('15087','2014-03-29','12:45:00',4.43),('15087','2014-03-29','12:50:00',4.43),('15087','2014-03-29','12:55:00',4.34),('15087','2014-03-29','13:00:00',4.09),('15087','2014-03-29','13:05:00',4.08),('15087','2014-03-29','13:10:00',4.22),('15087','2014-03-29','13:15:00',4.17),('15087','2014-03-29','13:20:00',4),('15087','2014-03-29','13:25:00',3.98),('15087','2014-03-29','13:30:00',4.03),('15087','2014-03-29','13:35:00',3.89),('15087','2014-03-29','13:40:00',3.85),('15087','2014-03-29','13:45:00',3.8),('15087','2014-03-29','13:50:00',3.73),('15087','2014-03-29','13:55:00',3.67),('15087','2014-03-29','14:00:00',3.56),('15087','2014-03-29','14:05:00',3.57),('15087','2014-03-29','14:10:00',3.43),('15087','2014-03-29','14:15:00',3.43),('15087','2014-03-29','14:20:00',3.31),('15087','2014-03-29','14:25:00',3.25),('15087','2014-03-29','14:30:00',3.03),('15087','2014-03-29','14:35:00',2.72),('15087','2014-03-29','14:40:00',2.21),('15087','2014-03-29','14:45:00',3.06),('15087','2014-03-29','14:50:00',3),('15087','2014-03-29','14:55:00',2.95),('15087','2014-03-29','15:00:00',2.8),('15087','2014-03-29','15:05:00',2.59),('15087','2014-03-29','15:10:00',2.64),('15087','2014-03-29','15:15:00',2.64),('15087','2014-03-29','15:20:00',2.5),('15087','2014-03-29','15:25:00',2.39),('15087','2014-03-29','15:30:00',2.32),('15087','2014-03-29','15:35:00',2.19),('15087','2014-03-29','15:40:00',2.2),('15087','2014-03-29','15:45:00',2.17),('15087','2014-03-29','15:50:00',2.02),('15087','2014-03-29','15:55:00',1.98),('15087','2014-03-29','16:00:00',1.95),('15087','2014-03-29','16:05:00',1.82),('15087','2014-03-29','16:10:00',1.71),('15087','2014-03-29','16:15:00',1.58),('15087','2014-03-29','16:20:00',1.4),('15087','2014-03-29','16:25:00',1.39),('15087','2014-03-29','16:30:00',1.32),('15087','2014-03-29','16:35:00',1.19),('15087','2013-04-21','08:05:00',1.07),('15087','2013-04-21','08:10:00',1.02),('15087','2013-04-21','08:15:00',1.16),('15087','2013-04-21','08:20:00',1.09),('15087','2013-04-21','08:25:00',1.29),('15087','2013-04-21','08:30:00',1.58),('15087','2013-04-21','08:35:00',1.51),('15087','2013-04-21','08:40:00',1.44),('15087','2013-04-21','08:45:00',1.1),('15087','2013-04-21','08:50:00',1.24),('15087','2013-04-21','08:55:00',1.85),('15087','2013-04-21','09:00:00',2.13),('15087','2013-04-21','09:05:00',2.7),('15087','2013-04-21','09:10:00',2.03),('15087','2013-04-21','09:15:00',1.52),('15087','2013-04-21','09:20:00',1.52),('15087','2013-04-21','09:25:00',2.43),('15087','2013-04-21','09:30:00',3.13),('15087','2013-04-21','09:35:00',3.21),('15087','2013-04-21','09:40:00',3.19),('15087','2013-04-21','09:45:00',3.53),('15087','2013-04-21','09:50:00',3.52),('15087','2013-04-21','09:55:00',3.96),('15087','2013-04-21','10:00:00',2.83),('15087','2013-04-21','10:05:00',2.14),('15087','2013-04-21','10:10:00',1.88),('15087','2013-04-21','10:15:00',1.75),('15087','2013-04-21','10:20:00',4.18),('15087','2013-04-21','10:25:00',2.3),('15087','2013-04-21','10:30:00',2.12),('15087','2013-04-21','10:35:00',1.88),('15087','2013-04-21','10:40:00',2.53),('15087','2013-04-21','10:45:00',2.68),('15087','2013-04-21','10:50:00',2.54),('15087','2013-04-21','10:55:00',2.47),('15087','2013-04-21','11:00:00',4.08),('15087','2013-04-21','11:05:00',3.17),('15087','2013-04-21','11:10:00',3.9),('15087','2013-04-21','11:15:00',3.33),('15087','2013-04-21','11:20:00',3.3),('15087','2013-04-21','11:25:00',2.96),('15087','2013-04-21','11:30:00',2.84),('15087','2013-04-21','11:35:00',2.91),('15087','2013-04-21','11:40:00',3.14),('15087','2013-04-21','11:45:00',3.8),('15087','2013-04-21','11:50:00',3.28),('15087','2013-04-21','11:55:00',3.63),('15087','2013-04-21','12:00:00',2.61),('15087','2013-04-21','12:05:00',2.63),('15087','2013-04-21','12:10:00',2.44),('15087','2013-04-21','12:15:00',2.31),('15087','2013-04-21','12:20:00',2.06),('15087','2013-04-21','12:25:00',2.04),('15087','2013-04-21','12:30:00',2.21),('15087','2013-04-21','12:35:00',2.28),('15087','2013-04-21','12:40:00',2.28),('15087','2013-04-21','12:45:00',2.3),('15087','2013-04-21','12:50:00',2.19),('15087','2013-04-21','12:55:00',2.1),('15087','2013-04-21','13:00:00',2.46),('15087','2013-04-21','13:05:00',2.84),('15087','2013-04-21','13:10:00',2.76),('15087','2013-04-21','13:15:00',2.54),('15087','2013-04-21','13:20:00',2.4),('15087','2013-04-21','13:25:00',2.39),('15087','2013-04-21','13:30:00',3.44),('15087','2013-04-21','13:35:00',4.29),('15087','2013-04-21','13:40:00',3.31),('15087','2013-04-21','13:45:00',3.64),('15087','2013-04-21','13:50:00',3.33),('15087','2013-04-21','13:55:00',3.94),('15087','2013-04-21','14:00:00',4.17),('15087','2013-04-21','14:05:00',4.89),('15087','2013-04-21','14:10:00',4.3),('15087','2013-04-21','14:15:00',4.77),('15087','2013-04-21','14:20:00',4.85),('15087','2013-04-21','14:25:00',4.53),('15087','2013-04-21','14:30:00',3.9),('15087','2013-04-21','14:35:00',4.74),('15087','2013-04-21','14:40:00',4.55),('15087','2013-04-21','14:45:00',3.58),('15087','2013-04-21','14:50:00',2.31),('15087','2013-04-21','14:55:00',2.24),('15087','2013-04-21','15:00:00',2.05),('15087','2013-04-21','15:05:00',3.42),('15087','2013-04-21','15:10:00',3.94),('15087','2013-04-21','15:15:00',2.72),('15087','2013-04-21','15:20:00',1.76),('15087','2013-04-21','15:25:00',1.93),('15087','2013-04-21','15:30:00',1.69),('15087','2013-04-21','15:35:00',1.44),('15087','2013-04-21','15:40:00',1.51),('15087','2013-04-21','15:45:00',1.22),('15087','2013-04-20','07:55:00',1.02),('15087','2013-04-20','08:00:00',1.14),('15087','2013-04-20','08:05:00',1.25),('15087','2013-04-20','08:10:00',1.34),('15087','2013-04-20','08:15:00',1.16),('15087','2013-04-20','08:20:00',1.18),('15087','2013-04-20','08:25:00',1.25),('15087','2013-04-20','08:30:00',1.46),('15087','2013-04-20','08:35:00',1.62),('15087','2013-04-20','08:40:00',1.85),('15087','2013-04-20','08:45:00',1.91),('15087','2013-04-20','08:50:00',1.95),('15087','2013-04-20','08:55:00',1.96),('15087','2013-04-20','09:00:00',2.26),('15087','2013-04-20','09:05:00',2.32),('15087','2013-04-20','09:10:00',2.2),('15087','2013-04-20','09:15:00',2.37),('15087','2013-04-20','09:20:00',2.78),('15087','2013-04-20','09:25:00',2.39),('15087','2013-04-20','09:30:00',2.39),('15087','2013-04-20','09:35:00',1.6),('15087','2013-04-20','09:45:00',1.04),('15087','2013-04-20','10:40:00',1.52),('15087','2013-04-20','10:45:00',2.76),('15087','2013-04-20','10:50:00',3.41),('15087','2013-04-20','10:55:00',3.74),('15087','2013-04-20','11:00:00',3.56),('15087','2013-04-20','11:05:00',2.88),('15087','2013-04-20','11:10:00',4.39),('15087','2013-04-20','11:15:00',4.59),('15087','2013-04-20','11:20:00',3.22),('15087','2013-04-20','11:25:00',4.75),('15087','2013-04-20','11:30:00',3.11),('15087','2013-04-20','11:35:00',1.94),('15087','2013-04-20','11:40:00',2.34),('15087','2013-04-20','11:45:00',2.27),('15087','2013-04-20','11:50:00',4.35),('15087','2013-04-20','11:55:00',4.9),('15087','2013-04-20','12:00:00',4.57),('15087','2013-04-20','12:05:00',3.4),('15087','2013-04-20','12:10:00',4.8),('15087','2013-04-20','12:15:00',4.81),('15087','2013-04-20','12:20:00',4.59),('15087','2013-04-20','12:25:00',4.54),('15087','2013-04-20','12:30:00',3.78),('15087','2013-04-20','12:35:00',2.85),('15087','2013-04-20','12:40:00',4.5),('15087','2013-04-20','12:45:00',4.93),('15087','2013-04-20','12:50:00',1.81),('15087','2013-04-20','12:55:00',5.05),('15087','2013-04-20','13:00:00',2.01),('15087','2013-04-20','13:05:00',2.93),('15087','2013-04-20','13:10:00',3.25),('15087','2013-04-20','13:15:00',4.31),('15087','2013-04-20','13:20:00',2.52),('15087','2013-04-20','13:25:00',3.17),('15087','2013-04-20','13:30:00',1.53),('15087','2013-04-20','13:35:00',4.77),('15087','2013-04-20','13:40:00',3.08),('15087','2013-04-20','13:45:00',2.16),('15087','2013-04-20','13:50:00',1.63),('15087','2013-04-20','13:55:00',3.77),('15087','2013-04-20','14:00:00',2.96),('15087','2013-04-20','14:05:00',3.56),('15087','2013-04-20','14:10:00',4.47),('15087','2013-04-20','14:15:00',4.23),('15087','2013-04-20','14:20:00',3.93),('15087','2013-04-20','14:25:00',4.02),('15087','2013-04-20','14:30:00',3.91),('15087','2013-04-20','14:35:00',3.9),('15087','2013-04-20','14:40:00',3.76),('15087','2013-04-20','14:45:00',3.89),('15087','2013-04-20','14:50:00',3.76),('15087','2013-04-20','14:55:00',3.72),('15087','2013-04-20','15:00:00',3.74),('15087','2013-04-20','15:05:00',3.73),('15087','2013-04-20','15:10:00',2.28),('15087','2013-04-20','15:15:00',2.49),('15087','2013-04-20','15:20:00',3.07),('15087','2013-04-20','15:25:00',3.11),('15087','2013-04-20','15:30:00',1.4),('15087','2013-04-20','16:05:00',1.11),('15087','2013-04-20','16:10:00',2.04),('15087','2013-04-20','16:15:00',2.34),('15087','2013-04-20','16:20:00',2.23),('15087','2013-04-20','16:25:00',2.63),('15087','2013-04-20','16:30:00',2.9),('15087','2013-04-20','16:35:00',2.56),('15087','2013-04-20','16:40:00',2.78),('15087','2013-04-20','16:45:00',2.67),('15087','2013-04-20','16:50:00',2.44),('15087','2013-04-20','16:55:00',2.24),('15087','2013-04-20','17:00:00',2.07),('15087','2013-04-20','17:05:00',2.1),('15087','2013-04-20','17:10:00',2.03),('15087','2013-04-20','17:15:00',1.66),('15087','2013-04-20','17:20:00',1.8),('15087','2013-04-20','17:25:00',1.76),('15087','2013-04-20','17:30:00',1.83),('15087','2013-04-20','17:35:00',1.72),('15087','2013-04-20','17:40:00',1.56),('15087','2013-04-20','17:55:00',1.45),('15087','2013-04-20','18:00:00',1.09),('15087','2013-04-20','18:05:00',1.11),('15087','2013-04-20','18:10:00',1.29),('15087','2013-04-19','08:05:00',1.01),('15087','2013-04-19','08:15:00',1.03),('15087','2013-04-19','08:20:00',1.36),('15087','2013-04-19','08:25:00',1.29),('15087','2013-04-19','08:30:00',1.39),('15087','2013-04-19','08:35:00',1.64),('15087','2013-04-19','08:40:00',1.77),('15087','2013-04-19','08:45:00',1.88),('15087','2013-04-19','08:50:00',1.97),('15087','2013-04-19','08:55:00',2.08),('15087','2013-04-19','09:00:00',2.14),('15087','2013-04-19','09:05:00',2.2),('15087','2013-04-19','09:10:00',2.27),('15087','2013-04-19','09:15:00',2.34),('15087','2013-04-19','09:20:00',2.44),('15087','2013-04-19','09:25:00',2.52),('15087','2013-04-19','09:30:00',2.62),('15087','2013-04-19','09:35:00',2.69),('15087','2013-04-19','09:40:00',2.74),('15087','2013-04-19','09:45:00',2.79),('15087','2013-04-19','09:50:00',2.84),('15087','2013-04-19','09:55:00',2.91),('15087','2013-04-19','10:00:00',2.95),('15087','2013-04-19','10:05:00',3.02),('15087','2013-04-19','10:10:00',3.08),('15087','2013-04-19','10:15:00',3.18),('15087','2013-04-19','10:20:00',3.29),('15087','2013-04-19','10:25:00',3.36),('15087','2013-04-19','10:30:00',3.46),('15087','2013-04-19','10:35:00',2.55),('15087','2013-04-19','10:40:00',3.5),('15087','2013-04-19','10:45:00',3.52),('15087','2013-04-19','10:50:00',3.55),('15087','2013-04-19','10:55:00',3.52),('15087','2013-04-19','11:00:00',3.57),('15087','2013-04-19','11:05:00',3.66),('15087','2013-04-19','11:10:00',3.71),('15087','2013-04-19','11:15:00',3.75),('15087','2013-04-19','11:20:00',3.79),('15087','2013-04-19','11:25:00',3.82),('15087','2013-04-19','11:30:00',3.75),('15087','2013-04-19','11:35:00',3.88),('15087','2013-04-19','11:40:00',3.95),('15087','2013-04-19','11:45:00',3.99),('15087','2013-04-19','11:50:00',4.02),('15087','2013-04-19','11:55:00',4.03),('15087','2013-04-19','12:00:00',4.08),('15087','2013-04-19','12:05:00',4.07),('15087','2013-04-19','12:10:00',4.03),('15087','2013-04-19','12:15:00',4.04),('15087','2013-04-19','12:20:00',4.08),('15087','2013-04-19','12:25:00',4.15),('15087','2013-04-19','12:30:00',4.16),('15087','2013-04-19','12:35:00',4.14),('15087','2013-04-19','12:40:00',4.17),('15087','2013-04-19','12:45:00',4.04),('15087','2013-04-19','12:50:00',4.18),('15087','2013-04-19','12:55:00',4.17),('15087','2013-04-19','13:00:00',4.16),('15087','2013-04-19','13:05:00',4.25),('15087','2013-04-19','13:10:00',4.25),('15087','2013-04-19','13:15:00',4.2),('15087','2013-04-19','13:20:00',4.17),('15087','2013-04-19','13:25:00',4.3),('15087','2013-04-19','13:30:00',4.2),('15087','2013-04-19','13:35:00',4.15),('15087','2013-04-19','13:40:00',4.2),('15087','2013-04-19','13:45:00',4.08),('15087','2013-04-19','13:50:00',4.05),('15087','2013-04-19','13:55:00',3.99),('15087','2013-04-19','14:00:00',3.97),('15087','2013-04-19','14:05:00',4),('15087','2013-04-19','14:10:00',3.96),('15087','2013-04-19','14:15:00',3.89),('15087','2013-04-19','14:20:00',3.84),('15087','2013-04-19','14:25:00',3.85),('15087','2013-04-19','14:30:00',3.82),('15087','2013-04-19','14:35:00',3.73),('15087','2013-04-19','14:40:00',3.32),('15087','2013-04-19','14:45:00',3.26),('15087','2013-04-19','14:50:00',3.58),('15087','2013-04-19','14:55:00',3.62),('15087','2013-04-19','15:00:00',3.41),('15087','2013-04-19','15:05:00',3.41),('15087','2013-04-19','15:10:00',3.34),('15087','2013-04-19','15:15:00',3.24),('15087','2013-04-19','15:20:00',3.14),('15087','2013-04-19','15:25:00',3.1),('15087','2013-04-19','15:30:00',3.04),('15087','2013-04-19','15:35:00',3.03),('15087','2013-04-19','15:40:00',3.05),('15087','2013-04-19','15:45:00',2.92),('15087','2013-04-19','15:50:00',2.82),('15087','2013-04-19','15:55:00',2.84),('15087','2013-04-19','16:00:00',2.72),('15087','2013-04-19','16:05:00',2.68),('15087','2013-04-19','16:10:00',2.65),('15087','2013-04-19','16:15:00',2.63),('15087','2013-04-19','16:20:00',2.55),('15087','2013-04-19','16:25:00',2.53),('15087','2013-04-19','16:30:00',2.36),('15087','2013-04-19','16:35:00',2.24),('15087','2013-04-19','16:40:00',2.25),('15087','2013-04-19','16:45:00',2.15),('15087','2013-04-19','16:50:00',1.94),('15087','2013-04-19','16:55:00',1.91),('15087','2013-04-19','17:00:00',1.82),('15087','2013-04-19','17:05:00',1.74),('15087','2013-04-19','17:10:00',1.66),('15087','2013-04-19','17:15:00',1.54),('15087','2013-04-19','17:20:00',1.49),('15087','2013-04-19','17:25:00',1.4),('15087','2013-04-19','17:30:00',1.32),('15087','2013-04-19','17:35:00',1.23),('15087','2013-04-19','17:40:00',1.15),('15087','2013-04-19','17:45:00',1.09),('15087','2013-04-18','08:10:00',1.14),('15087','2013-04-18','08:15:00',1.11),('15087','2013-04-18','08:20:00',1.27),('15087','2013-04-18','08:25:00',1.19),('15087','2013-04-18','08:30:00',1.33),('15087','2013-04-18','08:35:00',1.43),('15087','2013-04-18','08:40:00',1.34),('15087','2013-04-18','08:45:00',1.39),('15087','2013-04-18','08:50:00',1.55),('15087','2013-04-18','08:55:00',1.76),('15087','2013-04-18','09:00:00',1.94),('15087','2013-04-18','09:05:00',2.03),('15087','2013-04-18','09:10:00',2.01),('15087','2013-04-18','09:15:00',2.11),('15087','2013-04-18','09:20:00',2.09),('15087','2013-04-18','09:25:00',2.14),('15087','2013-04-18','09:30:00',2.28),('15087','2013-04-18','09:35:00',2.63),('15087','2013-04-18','09:40:00',2.85),('15087','2013-04-18','09:45:00',2.84),('15087','2013-04-18','09:50:00',2.44),('15087','2013-04-18','09:55:00',2.36),('15087','2013-04-18','10:00:00',2.75),('15087','2013-04-18','10:05:00',3.01),('15087','2013-04-18','10:10:00',3.26),('15087','2013-04-18','10:15:00',3.46),('15087','2013-04-18','10:20:00',3.5),('15087','2013-04-18','10:25:00',3.48),('15087','2013-04-18','10:30:00',3.54),('15087','2013-04-18','10:35:00',3.56),('15087','2013-04-18','10:40:00',3.61),('15087','2013-04-18','10:45:00',3.67),('15087','2013-04-18','10:50:00',3.7),('15087','2013-04-18','10:55:00',3.73),('15087','2013-04-18','11:00:00',3.8),('15087','2013-04-18','11:05:00',3.84),('15087','2013-04-18','11:10:00',3.88),('15087','2013-04-18','11:15:00',3.99),('15087','2013-04-18','11:20:00',4.02),('15087','2013-04-18','11:25:00',4.04),('15087','2013-04-18','11:30:00',4.05),('15087','2013-04-18','11:35:00',4.08),('15087','2013-04-18','11:40:00',4.09),('15087','2013-04-18','11:45:00',4.06),('15087','2013-04-18','11:50:00',4.19),('15087','2013-04-18','11:55:00',4.23),('15087','2013-04-18','12:00:00',4.2),('15087','2013-04-18','12:05:00',4.26),('15087','2013-04-18','12:10:00',4.31),('15087','2013-04-18','12:15:00',4.29),('15087','2013-04-18','12:20:00',4.36),('15087','2013-04-18','12:25:00',4.38),('15087','2013-04-18','12:30:00',4.4),('15087','2013-04-18','12:35:00',4.39),('15087','2013-04-18','12:40:00',4.44),('15087','2013-04-18','12:45:00',4.44),('15087','2013-04-18','12:50:00',4.46),('15087','2013-04-18','12:55:00',4.48),('15087','2013-04-18','13:00:00',4.46),('15087','2013-04-18','13:05:00',4.41),('15087','2013-04-18','13:10:00',4.43),('15087','2013-04-18','13:15:00',4.38),('15087','2013-04-18','13:20:00',4.41),('15087','2013-04-18','13:25:00',4.44),('15087','2013-04-18','13:30:00',4.43),('15087','2013-04-18','13:35:00',4.44),('15087','2013-04-18','13:40:00',4.4),('15087','2013-04-18','13:45:00',4.39),('15087','2013-04-18','13:50:00',4.41),('15087','2013-04-18','13:55:00',4.26),('15087','2013-04-18','14:00:00',4.27),('15087','2013-04-18','14:05:00',4.3),('15087','2013-04-18','14:10:00',4.26),('15087','2013-04-18','14:15:00',4.16),('15087','2013-04-18','14:20:00',4.13),('15087','2013-04-18','14:25:00',4.09),('15087','2013-04-18','14:30:00',4.07),('15087','2013-04-18','14:35:00',3.93),('15087','2013-04-18','14:40:00',3.86),('15087','2013-04-18','14:45:00',3.87),('15087','2013-04-18','14:50:00',3.84),('15087','2013-04-18','14:55:00',3.75),('15087','2013-04-18','15:00:00',3.58),('15087','2013-04-18','15:05:00',3.64),('15087','2013-04-18','15:10:00',3.61),('15087','2013-04-18','15:15:00',3.53),('15087','2013-04-18','15:20:00',3.35),('15087','2013-04-18','15:25:00',3.12),('15087','2013-04-18','15:30:00',3.08),('15087','2013-04-18','15:35:00',3.23),('15087','2013-04-18','15:40:00',3.18),('15087','2013-04-18','15:45:00',3.12),('15087','2013-04-18','15:50:00',3.06),('15087','2013-04-18','15:55:00',2.98),('15087','2013-04-18','16:00:00',2.91),('15087','2013-04-18','16:05:00',2.81),('15087','2013-04-18','16:10:00',2.76),('15087','2013-04-18','16:15:00',2.72),('15087','2013-04-18','16:20:00',2.68),('15087','2013-04-18','16:25:00',2.61),('15087','2013-04-18','16:30:00',2.54),('15087','2013-04-18','16:35:00',2.41),('15087','2013-04-18','16:40:00',2.37),('15087','2013-04-18','16:45:00',2.26),('15087','2013-04-18','16:50:00',2.2),('15087','2013-04-18','16:55:00',2.07),('15087','2013-04-18','17:00:00',1.98),('15087','2013-04-18','17:05:00',1.86),('15087','2013-04-18','17:10:00',1.78),('15087','2013-04-18','17:15:00',1.71),('15087','2013-04-18','17:20:00',1.62),('15087','2013-04-18','17:25:00',1.49),('15087','2013-04-18','17:30:00',1.4),('15087','2013-04-18','17:35:00',1.32),('15087','2013-04-18','17:40:00',1.22),('15087','2013-04-18','17:45:00',1.14),('15087','2013-04-18','17:50:00',1.15),('15087','2013-04-18','17:55:00',1.07),('15087','2013-04-17','08:00:00',1.02),('15087','2013-04-17','08:05:00',1.11),('15087','2013-04-17','08:10:00',1.21),('15087','2013-04-17','08:15:00',1.3),('15087','2013-04-17','08:20:00',1.39),('15087','2013-04-17','08:25:00',1.48),('15087','2013-04-17','08:30:00',1.61),('15087','2013-04-17','08:35:00',1.68),('15087','2013-04-17','08:40:00',1.81),('15087','2013-04-17','08:45:00',1.92),('15087','2013-04-17','08:50:00',2.02),('15087','2013-04-17','08:55:00',2.11),('15087','2013-04-17','09:00:00',2.21),('15087','2013-04-17','09:05:00',2.29),('15087','2013-04-17','09:10:00',2.39),('15087','2013-04-17','09:15:00',2.46),('15087','2013-04-17','09:20:00',2.54),('15087','2013-04-17','09:25:00',2.63),('15087','2013-04-17','09:30:00',2.71),('15087','2013-04-17','09:35:00',2.8),('15087','2013-04-17','09:40:00',2.89),('15087','2013-04-17','09:45:00',2.96),('15087','2013-04-17','09:50:00',3.02),('15087','2013-04-17','09:55:00',3.11),('15087','2013-04-17','10:00:00',3.18),('15087','2013-04-17','10:05:00',3.26),('15087','2013-04-17','10:10:00',3.32),('15087','2013-04-17','10:15:00',3.38),('15087','2013-04-17','10:20:00',3.4),('15087','2013-04-17','10:25:00',3.5),('15087','2013-04-17','10:30:00',3.55),('15087','2013-04-17','10:35:00',3.61),('15087','2013-04-17','10:40:00',3.67),('15087','2013-04-17','10:45:00',3.72),('15087','2013-04-17','10:50:00',3.76),('15087','2013-04-17','10:55:00',3.81),('15087','2013-04-17','11:00:00',3.86),('15087','2013-04-17','11:05:00',3.93),('15087','2013-04-17','11:10:00',3.98),('15087','2013-04-17','11:15:00',4),('15087','2013-04-17','11:20:00',4.04),('15087','2013-04-17','11:25:00',4.06),('15087','2013-04-17','11:30:00',4.07),('15087','2013-04-17','11:35:00',4.1),('15087','2013-04-17','11:40:00',4.15),('15087','2013-04-17','11:45:00',4.17),('15087','2013-04-17','11:50:00',4.2),('15087','2013-04-17','11:55:00',4.26),('15087','2013-04-17','12:00:00',4.28),('15087','2013-04-17','12:05:00',4.28),('15087','2013-04-17','12:10:00',4.26),('15087','2013-04-17','12:15:00',4.27),('15087','2013-04-17','12:20:00',4.3),('15087','2013-04-17','12:25:00',4.34),('15087','2013-04-17','12:30:00',4.37),('15087','2013-04-17','12:35:00',4.39),('15087','2013-04-17','12:40:00',4.39),('15087','2013-04-17','12:45:00',4.41),('15087','2013-04-17','12:50:00',4.39),('15087','2013-04-17','12:55:00',4.36),('15087','2013-04-17','13:00:00',4.34),('15087','2013-04-17','13:05:00',4.34),('15087','2013-04-17','13:10:00',4.34),('15087','2013-04-17','13:15:00',4.47),('15087','2013-04-17','13:20:00',4.48),('15087','2013-04-17','13:25:00',4.47),('15087','2013-04-17','13:30:00',4.43),('15087','2013-04-17','13:35:00',4.44),('15087','2013-04-17','13:40:00',4.44),('15087','2013-04-17','13:45:00',4.4),('15087','2013-04-17','13:50:00',4.27),('15087','2013-04-17','13:55:00',4.46),('15087','2013-04-17','14:00:00',4.2),('15087','2013-04-17','14:05:00',4.48),('15087','2013-04-17','14:10:00',4.59),('15087','2013-04-17','14:15:00',4.18),('15087','2013-04-17','14:20:00',4.1),('15087','2013-04-17','14:25:00',3.83),('15087','2013-04-17','14:30:00',4.14),('15087','2013-04-17','14:35:00',4.22),('15087','2013-04-17','14:40:00',3.85),('15087','2013-04-17','14:45:00',3.76),('15087','2013-04-17','14:50:00',4.25),('15087','2013-04-17','14:55:00',4.05),('15087','2013-04-17','15:00:00',3.97),('15087','2013-04-17','15:05:00',4.06),('15087','2013-04-17','15:10:00',4.19),('15087','2013-04-17','15:15:00',3.81),('15087','2013-04-17','15:20:00',2.29),('15087','2013-04-17','15:25:00',1.72),('15087','2013-04-17','15:30:00',3.03),('15087','2013-04-17','15:35:00',3.35),('15087','2013-04-17','15:40:00',3.45),('15087','2013-04-17','15:45:00',3.32),('15087','2013-04-17','15:50:00',3.22),('15087','2013-04-17','15:55:00',3.29),('15087','2013-04-17','16:00:00',3.16),('15087','2013-04-17','16:05:00',2.34),('15087','2013-04-17','16:10:00',2.99),('15087','2013-04-17','16:15:00',2.93),('15087','2013-04-17','16:20:00',2.76),('15087','2013-04-17','16:25:00',2.73),('15087','2013-04-17','16:30:00',2.68),('15087','2013-04-17','16:35:00',2.65),('15087','2013-04-17','16:40:00',2.23),('15087','2013-04-17','16:45:00',2.43),('15087','2013-04-17','16:50:00',2.19),('15087','2013-04-17','16:55:00',2.14),('15087','2013-04-17','17:00:00',2.07),('15087','2013-04-17','17:05:00',1.94),('15087','2013-04-17','17:10:00',1.82),('15087','2013-04-17','17:15:00',1.76),('15087','2013-04-17','17:20:00',1.64),('15087','2013-04-17','17:25:00',1.51),('15087','2013-04-17','17:30:00',1.38),('15087','2013-04-17','17:35:00',1.33),('15087','2013-04-17','17:40:00',1.25),('15087','2013-04-17','17:45:00',1.2),('15087','2013-04-17','17:50:00',1.12),('15087','2013-04-17','17:55:00',1.03),('15087','2013-04-16','08:05:00',1.01),('15087','2013-04-16','08:10:00',1),('15087','2013-04-16','08:50:00',1.06),('15087','2013-04-16','08:55:00',1.02),('15087','2013-04-16','09:10:00',1.75),('15087','2013-04-16','09:15:00',2.46),('15087','2013-04-16','09:20:00',1.39),('15087','2013-04-16','09:25:00',1.36),('15087','2013-04-16','09:30:00',1.61),('15087','2013-04-16','09:35:00',1.64),('15087','2013-04-16','09:40:00',1.51),('15087','2013-04-16','09:45:00',1.64),('15087','2013-04-16','09:50:00',1.42),('15087','2013-04-16','09:55:00',1.36),('15087','2013-04-16','10:00:00',1.29),('15087','2013-04-16','10:05:00',1.27),('15087','2013-04-16','10:10:00',1.37),('15087','2013-04-16','10:15:00',1.47),('15087','2013-04-16','10:20:00',1.58),('15087','2013-04-16','10:25:00',1.63),('15087','2013-04-16','10:30:00',1.62),('15087','2013-04-16','10:35:00',1.67),('15087','2013-04-16','10:40:00',1.65),('15087','2013-04-16','10:45:00',1.56),('15087','2013-04-16','10:50:00',1.56),('15087','2013-04-16','10:55:00',1.7),('15087','2013-04-16','11:00:00',1.88),('15087','2013-04-16','11:05:00',1.94),('15087','2013-04-16','11:10:00',1.93),('15087','2013-04-16','11:15:00',1.97),('15087','2013-04-16','11:20:00',2.02),('15087','2013-04-16','11:25:00',1.98),('15087','2013-04-16','11:30:00',1.91),('15087','2013-04-16','11:35:00',1.81),('15087','2013-04-16','11:40:00',2),('15087','2013-04-16','11:45:00',2.34),('15087','2013-04-16','11:50:00',2.53),('15087','2013-04-16','11:55:00',2.62),('15087','2013-04-16','12:00:00',2.69),('15087','2013-04-16','12:05:00',2.91),('15087','2013-04-16','12:10:00',3.2),('15087','2013-04-16','12:15:00',3.16),('15087','2013-04-16','12:20:00',3.25),('15087','2013-04-16','12:25:00',3.25),('15087','2013-04-16','12:30:00',2.59),('15087','2013-04-16','12:35:00',2.86),('15087','2013-04-16','12:40:00',3.93),('15087','2013-04-16','12:45:00',3.72),('15087','2013-04-16','12:50:00',3.38),('15087','2013-04-16','12:55:00',3.89),('15087','2013-04-16','13:00:00',4.38),('15087','2013-04-16','13:05:00',4.31),('15087','2013-04-16','13:10:00',4.25),('15087','2013-04-16','13:15:00',4.29),('15087','2013-04-16','13:20:00',4.32),('15087','2013-04-16','13:25:00',4.34),('15087','2013-04-16','13:30:00',4.32),('15087','2013-04-16','13:35:00',4.27),('15087','2013-04-16','13:40:00',4.27),('15087','2013-04-16','13:45:00',4.07),('15087','2013-04-16','13:50:00',4.2),('15087','2013-04-16','13:55:00',3.99),('15087','2013-04-16','14:00:00',4.12),('15087','2013-04-16','14:05:00',4.16),('15087','2013-04-16','14:10:00',4.13),('15087','2013-04-16','14:15:00',4.15),('15087','2013-04-16','14:20:00',3.95),('15087','2013-04-16','14:25:00',3.61),('15087','2013-04-16','14:30:00',3.67),('15087','2013-04-16','14:35:00',2.83),('15087','2013-04-16','14:40:00',3.67),('15087','2013-04-16','14:45:00',3.74),('15087','2013-04-16','14:50:00',3.7),('15087','2013-04-16','14:55:00',3.43),('15087','2013-04-16','15:00:00',3.57),('15087','2013-04-16','15:05:00',3.6),('15087','2013-04-16','15:10:00',3.6),('15087','2013-04-16','15:15:00',3.47),('15087','2013-04-16','15:20:00',3.3),('15087','2013-04-16','15:25:00',2.87),('15087','2013-04-16','15:30:00',3.02),('15087','2013-04-16','15:35:00',3.03),('15087','2013-04-16','15:40:00',3.11),('15087','2013-04-16','15:45:00',3.04),('15087','2013-04-16','15:50:00',2.99),('15087','2013-04-16','15:55:00',2.95),('15087','2013-04-16','16:00:00',2.76),('15087','2013-04-16','16:05:00',2.75),('15087','2013-04-16','16:10:00',2.67),('15087','2013-04-16','16:15:00',2.63),('15087','2013-04-16','16:20:00',2.64),('15087','2013-04-16','16:25:00',2.55),('15087','2013-04-16','16:30:00',2.55),('15087','2013-04-16','16:35:00',2.5),('15087','2013-04-16','16:40:00',2.54),('15087','2013-04-16','16:45:00',2.57),('15087','2013-04-16','16:50:00',2.37),('15087','2013-04-16','16:55:00',1.91),('15087','2013-04-16','17:00:00',1.94),('15087','2013-04-16','17:05:00',2),('15087','2013-04-16','17:10:00',1.96),('15087','2013-04-16','17:15:00',1.92),('15087','2013-04-16','17:20:00',1.94),('15087','2013-04-16','17:25:00',1.9),('15087','2013-04-16','17:30:00',1.69),('15087','2013-04-16','17:35:00',1.66),('15087','2013-04-16','17:40:00',1.59),('15087','2013-04-16','17:45:00',1.45),('15087','2013-04-16','17:50:00',1.31),('15087','2013-04-16','17:55:00',1.07),('15087','2013-04-15','08:00:00',1.03),('15087','2013-04-15','08:05:00',1.11),('15087','2013-04-15','08:10:00',1.19),('15087','2013-04-15','08:15:00',1.28),('15087','2013-04-15','08:20:00',1.37),('15087','2013-04-15','08:25:00',1.47),('15087','2013-04-15','08:30:00',1.56),('15087','2013-04-15','08:35:00',1.66),('15087','2013-04-15','08:40:00',1.79),('15087','2013-04-15','08:45:00',1.83),('15087','2013-04-15','08:50:00',1.99),('15087','2013-04-15','08:55:00',2.09),('15087','2013-04-15','09:00:00',2.21),('15087','2013-04-15','09:05:00',2.3),('15087','2013-04-15','09:10:00',2.4),('15087','2013-04-15','09:15:00',2.5),('15087','2013-04-15','09:20:00',2.57),('15087','2013-04-15','09:25:00',2.65),('15087','2013-04-15','09:30:00',2.73),('15087','2013-04-15','09:35:00',2.8),('15087','2013-04-15','09:40:00',2.87),('15087','2013-04-15','09:45:00',2.93),('15087','2013-04-15','09:50:00',3.01),('15087','2013-04-15','09:55:00',3.06),('15087','2013-04-15','10:00:00',3.16),('15087','2013-04-15','10:05:00',3.24),('15087','2013-04-15','10:10:00',3.31),('15087','2013-04-15','10:15:00',3.36),('15087','2013-04-15','10:20:00',3.45),('15087','2013-04-15','10:25:00',3.5),('15087','2013-04-15','10:30:00',3.54),('15087','2013-04-15','10:35:00',3.59),('15087','2013-04-15','10:40:00',3.65),('15087','2013-04-15','10:45:00',3.7),('15087','2013-04-15','10:50:00',3.74),('15087','2013-04-15','10:55:00',3.8),('15087','2013-04-15','11:00:00',3.85),('15087','2013-04-15','11:05:00',3.89),('15087','2013-04-15','11:10:00',3.97),('15087','2013-04-15','11:15:00',4.02),('15087','2013-04-15','11:20:00',4.03),('15087','2013-04-15','11:25:00',4.05),('15087','2013-04-15','11:30:00',4.07),('15087','2013-04-15','11:35:00',4.12),('15087','2013-04-15','11:40:00',4.14),('15087','2013-04-15','11:45:00',4.2),('15087','2013-04-15','11:50:00',4.22),('15087','2013-04-15','11:55:00',4.24),('15087','2013-04-15','12:00:00',4.26),('15087','2013-04-15','12:05:00',4.31),('15087','2013-04-15','12:10:00',4.27),('15087','2013-04-15','12:15:00',4.31),('15087','2013-04-15','12:20:00',4.31),('15087','2013-04-15','12:25:00',4.33),('15087','2013-04-15','12:30:00',4.33),('15087','2013-04-15','12:35:00',4.37),('15087','2013-04-15','12:40:00',4.37),('15087','2013-04-15','12:45:00',4.37),('15087','2013-04-15','12:50:00',4.35),('15087','2013-04-15','12:55:00',4.36),('15087','2013-04-15','13:00:00',4.39),('15087','2013-04-15','13:05:00',4.4),('15087','2013-04-15','13:10:00',4.43),('15087','2013-04-15','13:15:00',4.4),('15087','2013-04-15','13:20:00',4.38),('15087','2013-04-15','13:25:00',4.42),('15087','2013-04-15','13:30:00',4.39),('15087','2013-04-15','13:35:00',4.37),('15087','2013-04-15','13:40:00',4.33),('15087','2013-04-15','13:45:00',4.33),('15087','2013-04-15','13:50:00',4.36),('15087','2013-04-15','13:55:00',4.26),('15087','2013-04-15','14:00:00',4.29),('15087','2013-04-15','14:05:00',4.29),('15087','2013-04-15','14:10:00',4.27),('15087','2013-04-15','14:15:00',4.17),('15087','2013-04-15','14:20:00',4.01),('15087','2013-04-15','14:25:00',3.91),('15087','2013-04-15','14:30:00',4.1),('15087','2013-04-15','14:35:00',4.03),('15087','2013-04-15','14:40:00',3.91),('15087','2013-04-15','14:45:00',3.92),('15087','2013-04-15','14:50:00',3.89),('15087','2013-04-15','14:55:00',3.78),('15087','2013-04-15','15:00:00',3.7),('15087','2013-04-15','15:05:00',3.61),('15087','2013-04-15','15:10:00',3.6),('15087','2013-04-15','15:15:00',3.48),('15087','2013-04-15','15:20:00',3.39),('15087','2013-04-15','15:25:00',3.09),('15087','2013-04-15','15:30:00',3.33),('15087','2013-04-15','15:35:00',2.95),('15087','2013-04-15','15:40:00',2.82),('15087','2013-04-15','15:45:00',3.14),('15087','2013-04-15','15:50:00',3.1),('15087','2013-04-15','15:55:00',3.04),('15087','2013-04-15','16:00:00',2.88),('15087','2013-04-15','16:05:00',2.8),('15087','2013-04-15','16:10:00',2.73),('15087','2013-04-15','16:15:00',2.77),('15087','2013-04-15','16:20:00',2.67),('15087','2013-04-15','16:25:00',2.43),('15087','2013-04-15','16:30:00',2.54),('15087','2013-04-15','16:35:00',2.46),('15087','2013-04-15','16:40:00',2.32),('15087','2013-04-15','16:45:00',2.3),('15087','2013-04-15','16:50:00',2.23),('15087','2013-04-15','16:55:00',2.11),('15087','2013-04-15','17:00:00',2.02),('15087','2013-04-15','17:05:00',1.93),('15087','2013-04-15','17:10:00',1.83),('15087','2013-04-15','17:15:00',1.73),('15087','2013-04-15','17:20:00',1.61),('15087','2013-04-15','17:25:00',1.51),('15087','2013-04-15','17:30:00',1.41),('15087','2013-04-15','17:35:00',1.24),('15087','2013-04-15','17:40:00',1.19),('15087','2013-04-15','17:45:00',1.17),('15087','2013-04-15','17:50:00',1.07),('15087','2013-04-15','17:55:00',1.05),('15087','2013-04-14','08:00:00',1.04),('15087','2013-04-14','08:05:00',1.05),('15087','2013-04-14','08:10:00',1.17),('15087','2013-04-14','08:15:00',1.29),('15087','2013-04-14','08:20:00',1.36),('15087','2013-04-14','08:25:00',1.46),('15087','2013-04-14','08:30:00',1.55),('15087','2013-04-14','08:35:00',1.63),('15087','2013-04-14','08:40:00',1.72),('15087','2013-04-14','08:45:00',1.83),('15087','2013-04-14','08:50:00',1.93),('15087','2013-04-14','08:55:00',2.02),('15087','2013-04-14','09:00:00',2.1),('15087','2013-04-14','09:05:00',2.21),('15087','2013-04-14','09:10:00',2.31),('15087','2013-04-14','09:15:00',2.39),('15087','2013-04-14','09:20:00',2.44),('15087','2013-04-14','09:25:00',2.52),('15087','2013-04-14','09:30:00',2.6),('15087','2013-04-14','09:35:00',2.69),('15087','2013-04-14','09:40:00',2.75),('15087','2013-04-14','09:45:00',2.82),('15087','2013-04-14','09:50:00',2.84),('15087','2013-04-14','09:55:00',2.94),('15087','2013-04-14','10:00:00',3.07),('15087','2013-04-14','10:05:00',3.14),('15087','2013-04-14','10:10:00',3.2),('15087','2013-04-14','10:15:00',3.29),('15087','2013-04-14','10:20:00',3.36),('15087','2013-04-14','10:25:00',3.42),('15087','2013-04-14','10:30:00',3.47),('15087','2013-04-14','10:35:00',3.5),('15087','2013-04-14','10:40:00',3.57),('15087','2013-04-14','10:45:00',3.63),('15087','2013-04-14','10:50:00',3.64),('15087','2013-04-14','10:55:00',3.71),('15087','2013-04-14','11:00:00',3.78),('15087','2013-04-14','11:05:00',3.81),('15087','2013-04-14','11:10:00',3.9),('15087','2013-04-14','11:15:00',3.92),('15087','2013-04-14','11:20:00',3.97),('15087','2013-04-14','11:25:00',4),('15087','2013-04-14','11:30:00',4.01),('15087','2013-04-14','11:35:00',4.04),('15087','2013-04-14','11:40:00',4.03),('15087','2013-04-14','11:45:00',4.11),('15087','2013-04-14','11:50:00',4.17),('15087','2013-04-14','11:55:00',4.11),('15087','2013-04-14','12:00:00',4.19),('15087','2013-04-14','12:05:00',4.17),('15087','2013-04-14','12:10:00',4.18),('15087','2013-04-14','12:15:00',4.24),('15087','2013-04-14','12:20:00',4.28),('15087','2013-04-14','12:25:00',4.3),('15087','2013-04-14','12:30:00',4.31),('15087','2013-04-14','12:35:00',4.3),('15087','2013-04-14','12:40:00',4.02),('15087','2013-04-14','12:45:00',2.05),('15087','2013-04-14','12:50:00',4.02),('15087','2013-04-14','12:55:00',4.5),('15087','2013-04-14','13:00:00',3.51),('15087','2013-04-14','13:05:00',2.82),('15087','2013-04-14','13:10:00',4.49),('15087','2013-04-14','13:15:00',4.15),('15087','2013-04-14','13:20:00',4.5),('15087','2013-04-14','13:25:00',4.46),('15087','2013-04-14','13:30:00',4.41),('15087','2013-04-14','13:35:00',4.36),('15087','2013-04-14','13:40:00',4.3),('15087','2013-04-14','13:45:00',4.24),('15087','2013-04-14','13:50:00',4.23),('15087','2013-04-14','13:55:00',4.08),('15087','2013-04-14','14:00:00',4.14),('15087','2013-04-14','14:05:00',4.16),('15087','2013-04-14','14:10:00',4.14),('15087','2013-04-14','14:15:00',3.97),('15087','2013-04-14','14:20:00',3.86),('15087','2013-04-14','14:25:00',3.91),('15087','2013-04-14','14:30:00',3.97),('15087','2013-04-14','14:35:00',4.01),('15087','2013-04-14','14:40:00',3.98),('15087','2013-04-14','14:45:00',4.05),('15087','2013-04-14','14:50:00',3.87),('15087','2013-04-14','14:55:00',3.88),('15087','2013-04-14','15:00:00',3.8),('15087','2013-04-14','15:05:00',3.73),('15087','2013-04-14','15:10:00',3.7),('15087','2013-04-14','15:15:00',3.17),('15087','2013-04-14','15:20:00',3.48),('15087','2013-04-14','15:25:00',3.23),('15087','2013-04-14','15:30:00',2.88),('15087','2013-04-14','15:35:00',3.35),('15087','2013-04-14','15:40:00',3.3),('15087','2013-04-14','15:45:00',3.26),('15087','2013-04-14','15:50:00',2.96),('15087','2013-04-14','15:55:00',2.85),('15087','2013-04-14','16:00:00',2.61),('15087','2013-04-14','16:05:00',2.77),('15087','2013-04-14','16:10:00',2.75),('15087','2013-04-14','16:15:00',2.7),('15087','2013-04-14','16:20:00',2.51),('15087','2013-04-14','16:25:00',2.39),('15087','2013-04-14','16:30:00',2.43),('15087','2013-04-14','16:35:00',2.35),('15087','2013-04-14','16:40:00',2.19),('15087','2013-04-14','16:45:00',2.19),('15087','2013-04-14','16:50:00',2.15),('15087','2013-04-14','16:55:00',2.08),('15087','2013-04-14','17:00:00',1.89),('15087','2013-04-14','17:05:00',1.81),('15087','2013-04-14','17:10:00',1.73),('15087','2013-04-14','17:15:00',1.62),('15087','2013-04-14','17:20:00',1.53),('15087','2013-04-14','17:25:00',1.4),('15087','2013-04-14','17:30:00',1.34),('15087','2013-04-14','17:35:00',1.24),('15087','2013-04-14','17:40:00',1.15),('15087','2013-04-14','17:45:00',1.13),('15087','2013-04-14','17:50:00',1.05),('15087','2013-04-14','17:55:00',1.01),('15087','2013-04-13','08:10:00',1.07),('15087','2013-04-13','08:15:00',1.15),('15087','2013-04-13','08:50:00',1.12),('15087','2013-04-13','08:55:00',1.62),('15087','2013-04-13','09:05:00',1.57),('15087','2013-04-13','09:10:00',1.67),('15087','2013-04-13','09:20:00',1.54),('15087','2013-04-13','09:25:00',1.92),('15087','2013-04-13','09:30:00',2.59),('15087','2013-04-13','09:35:00',2.59),('15087','2013-04-13','09:40:00',2.47),('15087','2013-04-13','09:45:00',2.86),('15087','2013-04-13','09:50:00',2.93),('15087','2013-04-13','09:55:00',3.01),('15087','2013-04-13','10:00:00',3.14),('15087','2013-04-13','10:05:00',3.18),('15087','2013-04-13','10:10:00',3.24),('15087','2013-04-13','10:15:00',3.2),('15087','2013-04-13','10:20:00',3.58),('15087','2013-04-13','10:25:00',3.64),('15087','2013-04-13','10:30:00',3.32),('15087','2013-04-13','10:35:00',3.58),('15087','2013-04-13','10:40:00',3.9),('15087','2013-04-13','10:45:00',3.34),('15087','2013-04-13','10:50:00',4.1),('15087','2013-04-13','10:55:00',2.89),('15087','2013-04-13','11:00:00',2.31),('15087','2013-04-13','11:05:00',3.84),('15087','2013-04-13','11:10:00',4.16),('15087','2013-04-13','11:15:00',4.43),('15087','2013-04-13','11:20:00',2.39),('15087','2013-04-13','11:25:00',1.66),('15087','2013-04-13','11:30:00',4.31),('15087','2013-04-13','11:35:00',4.48),('15087','2013-04-13','11:40:00',3.09),('15087','2013-04-13','11:45:00',3.34),('15087','2013-04-13','11:50:00',2.68),('15087','2013-04-13','11:55:00',4.58),('15087','2013-04-13','12:00:00',4.71),('15087','2013-04-13','12:05:00',4.58),('15087','2013-04-13','12:10:00',4.61),('15087','2013-04-13','12:15:00',4.04),('15087','2013-04-13','12:20:00',4.53),('15087','2013-04-13','12:25:00',4.66),('15087','2013-04-13','12:30:00',4.62),('15087','2013-04-13','12:35:00',4.56),('15087','2013-04-13','12:40:00',4.52),('15087','2013-04-13','12:45:00',4.5),('15087','2013-04-13','12:50:00',4.38),('15087','2013-04-13','12:55:00',3.99),('15087','2013-04-13','13:00:00',4.35),('15087','2013-04-13','13:05:00',4.49),('15087','2013-04-13','13:10:00',4.68),('15087','2013-04-13','13:15:00',4.54),('15087','2013-04-13','13:20:00',4.53),('15087','2013-04-13','13:25:00',4.47),('15087','2013-04-13','13:30:00',4.29),('15087','2013-04-13','13:35:00',3.53),('15087','2013-04-13','13:40:00',3.91),('15087','2013-04-13','13:45:00',3.52),('15087','2013-04-13','13:50:00',2.04),('15087','2013-04-13','13:55:00',2.2),('15087','2013-04-13','14:00:00',2.29),('15087','2013-04-13','14:05:00',2.01),('15087','2013-04-13','14:10:00',2.33),('15087','2013-04-13','14:15:00',3.84),('15087','2013-04-13','14:20:00',3.69),('15087','2013-04-13','14:25:00',3.81),('15087','2013-04-13','14:30:00',3.76),('15087','2013-04-13','14:35:00',3.81),('15087','2013-04-13','14:40:00',3.68),('15087','2013-04-13','14:45:00',3.73),('15087','2013-04-13','14:50:00',3.52),('15087','2013-04-13','14:55:00',3.63),('15087','2013-04-13','15:00:00',3.25),('15087','2013-04-13','15:05:00',2.87),('15087','2013-04-13','15:10:00',2.89),('15087','2013-04-13','15:15:00',2.75),('15087','2013-04-13','15:20:00',2.91),('15087','2013-04-13','15:25:00',2.71),('15087','2013-04-13','15:30:00',2.77),('15087','2013-04-13','15:35:00',2.67),('15087','2013-04-13','15:40:00',2.74),('15087','2013-04-13','15:45:00',2.73),('15087','2013-04-13','15:50:00',2.61),('15087','2013-04-13','15:55:00',2.67),('15087','2013-04-13','16:00:00',2.6),('15087','2013-04-13','16:05:00',2.49),('15087','2013-04-13','16:10:00',2.38),('15087','2013-04-13','16:15:00',2.42),('15087','2013-04-13','16:20:00',2.33),('15087','2013-04-13','16:25:00',2.15),('15087','2013-04-13','16:30:00',2.03),('15087','2013-04-13','16:35:00',1.92),('15087','2013-04-13','16:40:00',1.8),('15087','2013-04-13','16:45:00',1.72),('15087','2013-04-13','16:50:00',1.74),('15087','2013-04-13','16:55:00',1.42),('15087','2013-04-13','17:00:00',1.21),('15087','2013-04-13','17:05:00',1.16),('15087','2013-04-13','17:10:00',1.63),('15087','2013-04-13','17:15:00',1.84),('15087','2013-04-13','17:20:00',1.5),('15087','2013-04-13','17:25:00',1.67),('15087','2013-04-13','17:30:00',1.41),('15087','2013-04-13','17:35:00',1.36),('15087','2013-04-13','17:40:00',1.29),('15087','2013-04-13','17:45:00',1.15),('15087','2013-04-13','17:50:00',1.01),('15087','2013-04-13','17:55:00',1.03),('15087','2013-04-12','08:05:00',1.1),('15087','2013-04-12','08:10:00',1.09),('15087','2013-04-12','08:35:00',1.12),('15087','2013-04-12','08:45:00',1.13),('15087','2013-04-12','08:50:00',1.38),('15087','2013-04-12','08:55:00',1.97),('15087','2013-04-12','09:00:00',1.5),('15087','2013-04-12','09:05:00',1.3),('15087','2013-04-12','09:10:00',1.39),('15087','2013-04-12','09:15:00',2.15),('15087','2013-04-12','09:21:00',2.03),('15087','2013-04-12','09:25:00',2.4),('15087','2013-04-12','09:30:00',1.49),('15087','2013-04-12','09:35:00',1.19),('15087','2013-04-12','09:40:00',1.35),('15087','2013-04-12','09:45:00',1.17),('15087','2013-04-12','10:05:00',1.33),('15087','2013-04-12','10:15:00',1.31),('15087','2013-04-12','10:20:00',3.13),('15087','2013-04-12','10:25:00',2.47),('15087','2013-04-12','10:30:00',1.86),('15087','2013-04-12','10:35:00',2.84),('15087','2013-04-12','10:40:00',3.64),('15087','2013-04-12','10:45:00',4.39),('15087','2013-04-12','10:50:00',3.07),('15087','2013-04-12','10:55:00',1.3),('15087','2013-04-12','11:00:00',1.28),('15087','2013-04-12','11:05:00',1.78),('15087','2013-04-12','11:10:00',3.09),('15087','2013-04-12','11:15:00',4.93),('15087','2013-04-12','11:20:00',4.6),('15087','2013-04-12','11:25:00',4.73),('15087','2013-04-12','11:30:00',4.99),('15087','2013-04-12','11:35:00',3.28),('15087','2013-04-12','11:40:00',1.68),('15087','2013-04-12','11:45:00',1.84),('15087','2013-04-12','11:50:00',2.16),('15087','2013-04-12','11:55:00',4.2),('15087','2013-04-12','12:00:00',4.7),('15087','2013-04-12','12:05:00',4.57),('15087','2013-04-12','12:10:00',4.38),('15087','2013-04-12','12:15:00',4.65),('15087','2013-04-12','12:20:00',4.61),('15087','2013-04-12','12:25:00',4.63),('15087','2013-04-12','12:30:00',4.58),('15087','2013-04-12','12:35:00',4.47),('15087','2013-04-12','12:40:00',4.29),('15087','2013-04-12','12:45:00',4.47),('15087','2013-04-12','12:50:00',3.46),('15087','2013-04-12','12:55:00',4.36),('15087','2013-04-12','13:00:00',4.4),('15087','2013-04-12','13:05:00',4.32),('15087','2013-04-12','13:10:00',4.48),('15087','2013-04-12','13:15:00',4.5),('15087','2013-04-12','13:20:00',4.49),('15087','2013-04-12','13:25:00',4.49),('15087','2013-04-12','13:30:00',4.46),('15087','2013-04-12','13:35:00',4.48),('15087','2013-04-12','13:40:00',4.43),('15087','2013-04-12','13:45:00',4.43),('15087','2013-04-12','13:50:00',4.4),('15087','2013-04-12','13:55:00',4.25),('15087','2013-04-12','14:00:00',4.28),('15087','2013-04-12','14:05:00',4.32),('15087','2013-04-12','14:10:00',4.3),('15087','2013-04-12','14:15:00',4.13),('15087','2013-04-12','14:20:00',4.03),('15087','2013-04-12','14:25:00',4.11),('15087','2013-04-12','14:30:00',4.05),('15087','2013-04-12','14:35:00',3.97),('15087','2013-04-12','14:40:00',3.92),('15087','2013-04-12','14:45:00',3.87),('15087','2013-04-12','14:50:00',3.81),('15087','2013-04-12','14:55:00',3.64),('15087','2013-04-12','15:00:00',3.39),('15087','2013-04-12','15:05:00',3.56),('15087','2013-04-12','15:10:00',3.55),('15087','2013-04-12','15:15:00',3.47),('15087','2013-04-12','15:20:00',3.28),('15087','2013-04-12','15:25:00',3.35),('15087','2013-04-12','15:30:00',3.27),('15087','2013-04-12','15:35:00',3.17),('15087','2013-04-12','15:40:00',3.13),('15087','2013-04-12','15:45:00',3.09),('15087','2013-04-12','15:50:00',3.03),('15087','2013-04-12','15:55:00',2.96),('15087','2013-04-12','16:00:00',2.92),('15087','2013-04-12','16:05:00',2.84),('15087','2013-04-12','16:10:00',2.84),('15087','2013-04-12','16:15:00',2.55),('15087','2013-04-12','16:20:00',2.55),('15087','2013-04-12','16:25:00',2.64),('15087','2013-04-12','16:30:00',1.49),('15087','2013-04-12','16:35:00',1.21),('15087','2013-04-12','16:40:00',1.64),('15087','2013-04-12','16:45:00',2.23),('15087','2013-04-12','16:50:00',2.04),('15087','2013-04-12','16:55:00',2.08),('15087','2013-04-12','17:00:00',2.01),('15087','2013-04-12','17:05:00',1.92),('15087','2013-04-12','17:10:00',1.8),('15087','2013-04-12','17:15:00',1.67),('15087','2013-04-12','17:20:00',1.6),('15087','2013-04-12','17:25:00',1.5),('15087','2013-04-12','17:30:00',1.41),('15087','2013-04-12','17:35:00',1.29),('15087','2013-04-12','17:40:00',1.2),('15087','2013-04-12','17:45:00',1.1),('15087','2013-04-11','08:05:00',1.07),('15087','2013-04-11','08:10:00',1.15),('15087','2013-04-11','08:15:00',1.24),('15087','2013-04-11','08:20:00',1.34),('15087','2013-04-11','08:25:00',1.44),('15087','2013-04-11','08:30:00',1.53),('15087','2013-04-11','08:35:00',1.65),('15087','2013-04-11','08:40:00',1.73),('15087','2013-04-11','08:45:00',1.81),('15087','2013-04-11','08:50:00',1.91),('15087','2013-04-11','08:55:00',2),('15087','2013-04-11','09:00:00',2.08),('15087','2013-04-11','09:05:00',2.16),('15087','2013-04-11','09:10:00',2.25),('15087','2013-04-11','09:15:00',2.29),('15087','2013-04-11','09:20:00',2.41),('15087','2013-04-11','09:25:00',2.46),('15087','2013-04-11','09:30:00',2.58),('15087','2013-04-11','09:35:00',2.64),('15087','2013-04-11','09:40:00',2.7),('15087','2013-04-11','09:45:00',2.99),('15087','2013-04-11','09:50:00',1.72),('15087','2013-04-11','09:55:00',1.19),('15087','2013-04-11','10:00:00',2.51),('15087','2013-04-11','10:10:00',2.29),('15087','2013-04-11','10:15:00',3.41),('15087','2013-04-11','10:20:00',3.47),('15087','2013-04-11','10:25:00',3.79),('15087','2013-04-11','10:30:00',3.81),('15087','2013-04-11','10:35:00',3.79),('15087','2013-04-11','10:40:00',4.02),('15087','2013-04-11','10:45:00',2.88),('15087','2013-04-11','11:00:00',1.69),('15087','2013-04-11','11:05:00',3.92),('15087','2013-04-11','11:10:00',4.42),('15087','2013-04-11','11:15:00',3.64),('15087','2013-04-11','11:20:00',2.1),('15087','2013-04-11','11:25:00',3.74),('15087','2013-04-11','11:30:00',4.14),('15087','2013-04-11','11:35:00',2.58),('15087','2013-04-11','11:40:00',1.2),('15087','2013-04-11','11:45:00',1.13),('15087','2013-04-11','11:50:00',4.59),('15087','2013-04-11','11:55:00',5.16),('15087','2013-04-11','12:00:00',4.44),('15087','2013-04-11','12:05:00',4.79),('15087','2013-04-11','12:10:00',4.8),('15087','2013-04-11','12:15:00',4.6),('15087','2013-04-11','12:20:00',4.41),('15087','2013-04-11','12:25:00',4.62),('15087','2013-04-11','12:30:00',3.86),('15087','2013-04-11','12:35:00',4.04),('15087','2013-04-11','12:40:00',3.06),('15087','2013-04-11','12:45:00',2.55),('15087','2013-04-11','12:50:00',4.65),('15087','2013-04-11','12:55:00',4.81),('15087','2013-04-11','13:00:00',4.95),('15087','2013-04-11','13:05:00',4.51),('15087','2013-04-11','13:10:00',4.66),('15087','2013-04-11','13:15:00',3.61),('15087','2013-04-11','13:20:00',4.66),('15087','2013-04-11','13:25:00',4.61),('15087','2013-04-11','13:30:00',4.55),('15087','2013-04-11','13:35:00',4.61),('15087','2013-04-11','13:40:00',4.51),('15087','2013-04-11','13:45:00',4.42),('15087','2013-04-11','13:50:00',4.39),('15087','2013-04-11','13:55:00',4.34),('15087','2013-04-11','14:00:00',3.11),('15087','2013-04-11','14:05:00',4.42),('15087','2013-04-11','14:10:00',4.47),('15087','2013-04-11','14:15:00',4.3),('15087','2013-04-11','14:20:00',4.24),('15087','2013-04-11','14:25:00',4.18),('15087','2013-04-11','14:30:00',4.14),('15087','2013-04-11','14:35:00',4.06),('15087','2013-04-11','14:40:00',4.08),('15087','2013-04-11','14:45:00',3.87),('15087','2013-04-11','14:50:00',3.95),('15087','2013-04-11','14:55:00',3.82),('15087','2013-04-11','15:00:00',3.64),('15087','2013-04-11','15:05:00',3.69),('15087','2013-04-11','15:10:00',3.66),('15087','2013-04-11','15:15:00',3.5),('15087','2013-04-11','15:20:00',3.48),('15087','2013-04-11','15:25:00',3.45),('15087','2013-04-11','15:30:00',3.32),('15087','2013-04-11','15:35:00',3.26),('15087','2013-04-11','15:40:00',3.2),('15087','2013-04-11','15:45:00',3.15),('15087','2013-04-11','15:50:00',3.1),('15087','2013-04-11','15:55:00',3.03),('15087','2013-04-11','16:00:00',2.98),('15087','2013-04-11','16:05:00',2.85),('15087','2013-04-11','16:10:00',2.85),('15087','2013-04-11','16:15:00',2.76),('15087','2013-04-11','16:20:00',2.72),('15087','2013-04-11','16:25:00',2.64),('15087','2013-04-11','16:30:00',2.52),('15087','2013-04-11','16:35:00',2.43),('15087','2013-04-11','16:40:00',2.33),('15087','2013-04-11','16:45:00',2.23),('15087','2013-04-11','16:50:00',2.22),('15087','2013-04-11','16:55:00',2.18),('15087','2013-04-11','17:00:00',2.06),('15087','2013-04-11','17:05:00',1.97),('15087','2013-04-11','17:10:00',1.83),('15087','2013-04-11','17:15:00',1.65),('15087','2013-04-11','17:20:00',1.59),('15087','2013-04-11','17:25:00',1.5),('15087','2013-04-11','17:30:00',1.37),('15087','2013-04-11','17:35:00',1.33),('15087','2013-04-11','17:40:00',1.24),('15087','2013-04-11','17:45:00',1.13),('15087','2013-04-11','17:50:00',1.06),('15087','2013-04-10','08:50:00',1.1),('15087','2013-04-10','08:55:00',1.82),('15087','2013-04-10','09:00:00',2.11),('15087','2013-04-10','09:05:00',2.3),('15087','2013-04-10','09:10:00',2.42),('15087','2013-04-10','09:15:00',2.47),('15087','2013-04-10','09:20:00',2.48),('15087','2013-04-10','09:25:00',2.56),('15087','2013-04-10','09:30:00',2.67),('15087','2013-04-10','09:35:00',2.72),('15087','2013-04-10','09:40:00',2.81),('15087','2013-04-10','09:45:00',2.81),('15087','2013-04-10','09:50:00',2.89),('15087','2013-04-10','09:55:00',2.95),('15087','2013-04-10','10:00:00',3.22),('15087','2013-04-10','10:05:00',3.35),('15087','2013-04-10','10:10:00',3.53),('15087','2013-04-10','10:15:00',3.65),('15087','2013-04-10','10:20:00',3.68),('15087','2013-04-10','10:25:00',3.71),('15087','2013-04-10','10:30:00',3.72),('15087','2013-04-10','10:35:00',3.77),('15087','2013-04-10','10:40:00',3.77),('15087','2013-04-10','10:45:00',3.88),('15087','2013-04-10','10:50:00',3.66),('15087','2013-04-10','10:55:00',3.77),('15087','2013-04-10','11:00:00',3.76),('15087','2013-04-10','11:05:00',3.71),('15087','2013-04-10','11:10:00',3.84),('15087','2013-04-10','11:15:00',3.84),('15087','2013-04-10','11:20:00',4),('15087','2013-04-10','11:25:00',4.19),('15087','2013-04-10','11:30:00',4.2),('15087','2013-04-10','11:35:00',4.23),('15087','2013-04-10','11:40:00',4.31),('15087','2013-04-10','11:45:00',4.31),('15087','2013-04-10','11:50:00',4.39),('15087','2013-04-10','11:55:00',4.37),('15087','2013-04-10','12:00:00',4.49),('15087','2013-04-10','12:05:00',4.55),('15087','2013-04-10','12:10:00',4.6),('15087','2013-04-10','12:15:00',4.6),('15087','2013-04-10','12:20:00',4.6),('15087','2013-04-10','12:25:00',4.67),('15087','2013-04-10','12:30:00',4.72),('15087','2013-04-10','12:35:00',3.98),('15087','2013-04-10','12:40:00',4.69),('15087','2013-04-10','12:45:00',4.69),('15087','2013-04-10','12:50:00',4.37),('15087','2013-04-10','12:55:00',4.64),('15087','2013-04-10','13:00:00',3.07),('15087','2013-04-10','13:05:00',1.92),('15087','2013-04-10','13:10:00',1.46),('15087','2013-04-10','13:15:00',3.15),('15087','2013-04-10','13:20:00',5.2),('15087','2013-04-10','13:25:00',5),('15087','2013-04-10','13:30:00',4.34),('15087','2013-04-10','13:35:00',4.34),('15087','2013-04-10','13:40:00',3.94),('15087','2013-04-10','13:45:00',2.98),('15087','2013-04-10','13:50:00',4.96),('15087','2013-04-10','13:55:00',2.97),('15087','2013-04-10','14:00:00',4.65),('15087','2013-04-10','14:05:00',4.5),('15087','2013-04-10','14:10:00',4.44),('15087','2013-04-10','14:15:00',4.33),('15087','2013-04-10','14:20:00',4.3),('15087','2013-04-10','14:25:00',4.34),('15087','2013-04-10','14:30:00',4.36),('15087','2013-04-10','14:35:00',4.18),('15087','2013-04-10','14:40:00',4.12),('15087','2013-04-10','14:45:00',4.24),('15087','2013-04-10','14:50:00',4.17),('15087','2013-04-10','14:55:00',3.44),('15087','2013-04-10','15:00:00',3.83),('15087','2013-04-10','15:05:00',3.85),('15087','2013-04-10','15:10:00',2.87),('15087','2013-04-10','15:15:00',3.61),('15087','2013-04-10','15:20:00',3.71),('15087','2013-04-10','15:25:00',3.28),('15087','2013-04-10','15:30:00',3.32),('15087','2013-04-10','15:35:00',3),('15087','2013-04-10','15:40:00',2.77),('15087','2013-04-10','15:45:00',3.21),('15087','2013-04-10','15:50:00',3.21),('15087','2013-04-10','15:55:00',3.13),('15087','2013-04-10','16:00:00',2.63),('15087','2013-04-10','16:05:00',3.18),('15087','2013-04-10','16:10:00',2.93),('15087','2013-04-10','16:15:00',2.63),('15087','2013-04-10','16:20:00',2.57),('15087','2013-04-10','16:25:00',2.55),('15087','2013-04-10','16:30:00',2.31),('15087','2013-04-10','16:35:00',1.76),('15087','2013-04-10','16:40:00',2.23),('15087','2013-04-10','16:45:00',2.49),('15087','2013-04-10','16:50:00',2),('15087','2013-04-10','16:55:00',2.28),('15087','2013-04-10','17:00:00',2.01),('15087','2013-04-10','17:05:00',1.65),('15087','2013-04-10','17:10:00',1.74),('15087','2013-04-10','17:15:00',1.96),('15087','2013-04-10','17:20:00',1.79),('15087','2013-04-10','17:25:00',1.64),('15087','2013-04-10','17:30:00',1.48),('15087','2013-04-10','17:35:00',1.17),('15087','2013-04-10','17:45:00',1.2),('15087','2013-04-10','17:50:00',1.09),('15087','2013-04-10','17:55:00',1.01),('15087','2013-04-09','07:55:00',1.06),('15087','2013-04-09','08:00:00',1),('15087','2013-04-09','08:10:00',1.17),('15087','2013-04-09','08:20:00',1.5),('15087','2013-04-09','09:15:00',1.03),('15087','2013-04-09','09:25:00',1.05),('15087','2013-04-09','09:30:00',1.02),('15087','2013-04-09','09:45:00',1.75),('15087','2013-04-09','09:50:00',3.15),('15087','2013-04-09','09:55:00',3.25),('15087','2013-04-09','10:00:00',1.76),('15087','2013-04-09','10:05:00',1.18),('15087','2013-04-09','10:10:00',1.72),('15087','2013-04-09','10:15:00',2.03),('15087','2013-04-09','10:20:00',1.3),('15087','2013-04-09','10:30:00',1.19),('15087','2013-04-09','10:35:00',3.1),('15087','2013-04-09','10:40:00',2.97),('15087','2013-04-09','10:45:00',4.5),('15087','2013-04-09','10:50:00',3.61),('15087','2013-04-09','10:55:00',3.93),('15087','2013-04-09','11:00:00',3.73),('15087','2013-04-09','11:05:00',4.17),('15087','2013-04-09','11:10:00',3.54),('15087','2013-04-09','11:20:00',1.67),('15087','2013-04-09','11:25:00',3.91),('15087','2013-04-09','11:30:00',5.07),('15087','2013-04-09','11:35:00',1.94),('15087','2013-04-09','11:40:00',1.5),('15087','2013-04-09','11:45:00',3.5),('15087','2013-04-09','11:50:00',4.02),('15087','2013-04-09','11:55:00',3.39),('15087','2013-04-09','12:00:00',4.88),('15087','2013-04-09','12:05:00',4.87),('15087','2013-04-09','12:10:00',4.92),('15087','2013-04-09','12:15:00',4.88),('15087','2013-04-09','12:20:00',3.91),('15087','2013-04-09','12:25:00',4.66),('15087','2013-04-09','12:30:00',4.76),('15087','2013-04-09','12:35:00',4.54),('15087','2013-04-09','12:40:00',4.57),('15087','2013-04-09','12:45:00',4.66),('15087','2013-04-09','12:50:00',4.95),('15087','2013-04-09','12:55:00',4.93),('15087','2013-04-09','13:00:00',4.86),('15087','2013-04-09','13:05:00',4.43),('15087','2013-04-09','13:10:00',5.24),('15087','2013-04-09','13:15:00',3.72),('15087','2013-04-09','13:20:00',3.4),('15087','2013-04-09','13:25:00',4.25),('15087','2013-04-09','13:30:00',1.56),('15087','2013-04-09','13:35:00',2.32),('15087','2013-04-09','13:40:00',1.63),('15087','2013-04-09','13:45:00',2.17),('15087','2013-04-09','13:50:00',4.77),('15087','2013-04-09','13:55:00',4.5),('15087','2013-04-09','14:00:00',4.06),('15087','2013-04-09','14:05:00',3.07),('15087','2013-04-09','14:10:00',3.26),('15087','2013-04-09','14:15:00',3.66),('15087','2013-04-09','14:20:00',2.53),('15087','2013-04-09','14:25:00',3),('15087','2013-04-09','14:30:00',3.58),('15087','2013-04-09','14:35:00',3.71),('15087','2013-04-09','14:40:00',3.97),('15087','2013-04-09','14:45:00',3.6),('15087','2013-04-09','14:50:00',3.36),('15087','2013-04-09','14:55:00',2.73),('15087','2013-04-09','15:00:00',3.62),('15087','2013-04-09','15:05:00',4.07),('15087','2013-04-09','15:10:00',3.37),('15087','2013-04-09','15:15:00',2.76),('15087','2013-04-09','15:20:00',3.79),('15087','2013-04-09','15:25:00',3.73),('15087','2013-04-09','15:30:00',1.87),('15087','2013-04-09','15:35:00',3.72),('15087','2013-04-09','15:40:00',3.47),('15087','2013-04-09','15:45:00',2.84),('15087','2013-04-09','15:50:00',3.41),('15087','2013-04-09','15:55:00',2.76),('15087','2013-04-09','16:00:00',2.52),('15087','2013-04-09','16:05:00',2.63),('15087','2013-04-09','16:10:00',1.91),('15087','2013-04-09','16:15:00',1.84),('15087','2013-04-09','16:25:00',1.21),('15087','2013-04-09','16:30:00',1.09),('15087','2013-04-09','16:35:00',1.23),('15087','2013-04-09','16:40:00',1.06),('15087','2013-04-09','16:50:00',2.63),('15087','2013-04-09','16:55:00',1.95),('15087','2013-04-09','17:15:00',1.11),('15087','2013-04-08','08:40:00',1.33),('15087','2013-04-08','08:45:00',1.19),('15087','2013-04-08','08:50:00',1.89),('15087','2013-04-08','08:55:00',2.05),('15087','2013-04-08','09:00:00',1.37),('15087','2013-04-08','09:05:00',1.67),('15087','2013-04-08','09:10:00',1.3),('15087','2013-04-08','09:15:00',2.41),('15087','2013-04-08','09:20:00',2.6),('15087','2013-04-08','09:25:00',2.57),('15087','2013-04-08','09:30:00',2.75),('15087','2013-04-08','09:35:00',2.94),('15087','2013-04-08','09:40:00',2.92),('15087','2013-04-08','09:45:00',2.98),('15087','2013-04-08','09:50:00',1.65),('15087','2013-04-08','09:55:00',2.01),('15087','2013-04-08','10:00:00',3.16),('15087','2013-04-08','10:05:00',3.13),('15087','2013-04-08','10:10:00',3.31),('15087','2013-04-08','10:15:00',3.32),('15087','2013-04-08','10:20:00',3.35),('15087','2013-04-08','10:25:00',3.36),('15087','2013-04-08','10:30:00',3.47),('15087','2013-04-08','10:35:00',3.31),('15087','2013-04-08','10:40:00',3.71),('15087','2013-04-08','10:45:00',3.88),('15087','2013-04-08','10:50:00',3.89),('15087','2013-04-08','10:55:00',3.71),('15087','2013-04-08','11:00:00',3.87),('15087','2013-04-08','11:05:00',3.38),('15087','2013-04-08','11:10:00',3.3),('15087','2013-04-08','11:15:00',2.89),('15087','2013-04-08','11:20:00',2.45),('15087','2013-04-08','11:25:00',2.16),('15087','2013-04-08','11:30:00',2.53),('15087','2013-04-08','11:35:00',3.34),('15087','2013-04-08','11:40:00',3.42),('15087','2013-04-08','11:45:00',3.06),('15087','2013-04-08','11:50:00',2.79),('15087','2013-04-08','11:55:00',2.53),('15087','2013-04-08','12:00:00',2.35),('15087','2013-04-08','12:05:00',2.28),('15087','2013-04-08','12:10:00',2.5),('15087','2013-04-08','12:15:00',2.93),('15087','2013-04-08','12:20:00',2.97),('15087','2013-04-08','12:25:00',2.91),('15087','2013-04-08','12:30:00',3.23),('15087','2013-04-08','12:35:00',2.89),('15087','2013-04-08','12:40:00',2.86),('15087','2013-04-08','12:45:00',4.01),('15087','2013-04-08','12:50:00',2.52),('15087','2013-04-08','12:55:00',2.12),('15087','2013-04-08','13:00:00',2.13),('15087','2013-04-08','13:05:00',2.89),('15087','2013-04-08','13:10:00',2.94),('15087','2013-04-08','13:15:00',3.07),('15087','2013-04-08','13:20:00',3.9),('15087','2013-04-08','13:25:00',3.53),('15087','2013-04-08','13:30:00',3.02),('15087','2013-04-08','13:35:00',2.16),('15087','2013-04-08','13:40:00',3.07),('15087','2013-04-08','13:45:00',3.1),('15087','2013-04-08','13:50:00',3.34),('15087','2013-04-08','13:55:00',4.2),('15087','2013-04-08','14:00:00',3.94),('15087','2013-04-08','14:05:00',3.52),('15087','2013-04-08','14:10:00',3.54),('15087','2013-04-08','14:15:00',4),('15087','2013-04-08','14:20:00',3.5),('15087','2013-04-08','14:25:00',4.11),('15087','2013-04-08','14:30:00',3.98),('15087','2013-04-08','14:35:00',3.62),('15087','2013-04-08','14:40:00',3.73),('15087','2013-04-08','14:45:00',3.87),('15087','2013-04-08','14:50:00',3.68),('15087','2013-04-08','14:55:00',3.77),('15087','2013-04-08','15:00:00',2.85),('15087','2013-04-08','15:05:00',2.91),('15087','2013-04-08','15:10:00',3.03),('15087','2013-04-08','15:15:00',2.84),('15087','2013-04-08','15:20:00',3.05),('15087','2013-04-08','15:25:00',3.23),('15087','2013-04-08','15:30:00',3.39),('15087','2013-04-08','15:35:00',3.34),('15087','2013-04-08','15:40:00',3.23),('15087','2013-04-08','15:45:00',3.17),('15087','2013-04-08','15:50:00',3.11),('15087','2013-04-08','15:55:00',3.05),('15087','2013-04-08','16:00:00',2.95),('15087','2013-04-08','16:05:00',2.78),('15087','2013-04-08','16:10:00',2.65),('15087','2013-04-08','16:15:00',2.76),('15087','2013-04-08','16:20:00',2.76),('15087','2013-04-08','16:25:00',2.66),('15087','2013-04-08','16:30:00',2.58),('15087','2013-04-08','16:35:00',2.42),('15087','2013-04-08','16:40:00',2.32),('15087','2013-04-08','16:45:00',2.27),('15087','2013-04-08','16:50:00',2.25),('15087','2013-04-08','16:55:00',2.17),('15087','2013-04-08','17:00:00',2.08),('15087','2013-04-08','17:05:00',2),('15087','2013-04-08','17:10:00',1.83),('15087','2013-04-08','17:15:00',1.7),('15087','2013-04-08','17:20:00',1.56),('15087','2013-04-08','17:25:00',1.57),('15087','2013-04-08','17:30:00',1.42),('15087','2013-04-08','17:35:00',1.31),('15087','2013-04-08','17:40:00',1.17),('15087','2013-04-08','17:45:00',1.09),('15087','2013-04-07','08:30:00',1.01),('15087','2013-04-07','08:35:00',1.12),('15087','2013-04-07','08:40:00',1.16),('15087','2013-04-07','08:45:00',1.19),('15087','2013-04-07','08:50:00',1.18),('15087','2013-04-07','08:55:00',1.24),('15087','2013-04-07','09:00:00',1.32),('15087','2013-04-07','09:05:00',1.42),('15087','2013-04-07','09:10:00',1.54),('15087','2013-04-07','09:15:00',1.6),('15087','2013-04-07','09:20:00',1.71),('15087','2013-04-07','09:25:00',1.73),('15087','2013-04-07','09:30:00',1.62),('15087','2013-04-07','09:35:00',1.54),('15087','2013-04-07','09:40:00',1.49),('15087','2013-04-07','09:45:00',1.61),('15087','2013-04-07','09:50:00',2.07),('15087','2013-04-07','09:55:00',2.26),('15087','2013-04-07','10:00:00',2.61),('15087','2013-04-07','10:05:00',2.88),('15087','2013-04-07','10:10:00',2.88),('15087','2013-04-07','10:15:00',2.96),('15087','2013-04-07','10:20:00',2.99),('15087','2013-04-07','10:25:00',3.11),('15087','2013-04-07','10:30:00',2.72),('15087','2013-04-07','10:35:00',2.77),('15087','2013-04-07','10:40:00',2.96),('15087','2013-04-07','10:45:00',2.87),('15087','2013-04-07','10:50:00',2.81),('15087','2013-04-07','10:55:00',2.48),('15087','2013-04-07','11:00:00',2.3),('15087','2013-04-07','11:05:00',2.05),('15087','2013-04-07','11:10:00',2.13),('15087','2013-04-07','11:15:00',2.86),('15087','2013-04-07','11:20:00',3.75),('15087','2013-04-07','11:25:00',3.93),('15087','2013-04-07','11:30:00',4.08),('15087','2013-04-07','11:35:00',3.78),('15087','2013-04-07','11:40:00',3.5),('15087','2013-04-07','11:45:00',2.79),('15087','2013-04-07','11:50:00',2.48),('15087','2013-04-07','11:55:00',2.57),('15087','2013-04-07','12:00:00',2.63),('15087','2013-04-07','12:05:00',2.63),('15087','2013-04-07','12:10:00',2.81),('15087','2013-04-07','12:15:00',2.79),('15087','2013-04-07','12:20:00',2.98),('15087','2013-04-07','12:25:00',3.32),('15087','2013-04-07','12:30:00',3.03),('15087','2013-04-07','12:35:00',3.04),('15087','2013-04-07','12:40:00',3.11),('15087','2013-04-07','12:45:00',2.62),('15087','2013-04-07','12:50:00',2.82),('15087','2013-04-07','12:55:00',2.79),('15087','2013-04-07','13:00:00',3.31),('15087','2013-04-07','13:05:00',3.69),('15087','2013-04-07','13:10:00',3.57),('15087','2013-04-07','13:15:00',3.22),('15087','2013-04-07','13:20:00',3.1),('15087','2013-04-07','13:25:00',3.45),('15087','2013-04-07','13:30:00',3.1),('15087','2013-04-07','13:35:00',3.25),('15087','2013-04-07','13:40:00',3.58),('15087','2013-04-07','13:45:00',3.34),('15087','2013-04-07','13:50:00',2.87),('15087','2013-04-07','13:55:00',3.06),('15087','2013-04-07','14:00:00',3.82),('15087','2013-04-07','14:05:00',3.67),('15087','2013-04-07','14:10:00',1.94),('15087','2013-04-07','14:15:00',2.85),('15087','2013-04-07','14:20:00',2.67),('15087','2013-04-07','14:25:00',1.99),('15087','2013-04-07','14:30:00',1.6),('15087','2013-04-07','14:35:00',1.95),('15087','2013-04-07','14:40:00',2.15),('15087','2013-04-07','14:45:00',1.87),('15087','2013-04-07','14:50:00',2.3),('15087','2013-04-07','14:55:00',2.53),('15087','2013-04-07','15:00:00',1.68),('15087','2013-04-07','15:05:00',2.35),('15087','2013-04-07','15:10:00',2.39),('15087','2013-04-07','15:15:00',2.86),('15087','2013-04-07','15:20:00',2.29),('15087','2013-04-07','15:25:00',2.81),('15087','2013-04-07','15:30:00',2.95),('15087','2013-04-07','15:35:00',2.86),('15087','2013-04-07','15:40:00',2.6),('15087','2013-04-07','15:45:00',2.14),('15087','2013-04-07','15:50:00',2.62),('15087','2013-04-07','15:55:00',2.44),('15087','2013-04-07','16:00:00',2.27),('15087','2013-04-07','16:05:00',2.02),('15087','2013-04-07','16:10:00',1.83),('15087','2013-04-07','16:15:00',1.51),('15087','2013-04-07','16:20:00',1.51),('15087','2013-04-07','16:25:00',1.27),('15087','2013-04-07','16:30:00',1.4),('15087','2013-04-07','16:35:00',1.91),('15087','2013-04-07','16:40:00',1.68),('15087','2013-04-07','16:45:00',2.01),('15087','2013-04-07','16:50:00',2.27),('15087','2013-04-07','16:55:00',2.05),('15087','2013-04-07','17:00:00',2.1),('15087','2013-04-07','17:05:00',1.9),('15087','2013-04-07','17:10:00',1.74),('15087','2013-04-07','17:15:00',1.15),('15087','2013-04-07','17:20:00',1.57),('15087','2013-04-07','17:25:00',1.85),('15087','2013-04-07','17:30:00',1.65),('15087','2013-04-07','17:35:00',1.56),('15087','2013-04-07','17:40:00',1.57),('15087','2013-04-07','17:45:00',1.48),('15087','2013-04-07','17:50:00',1.28),('15087','2013-04-07','17:55:00',1.07),('15087','2013-04-06','08:10:00',1.06),('15087','2013-04-06','08:15:00',1.14),('15087','2013-04-06','08:20:00',1.23),('15087','2013-04-06','08:25:00',1.37),('15087','2013-04-06','08:30:00',1.47),('15087','2013-04-06','08:35:00',1.57),('15087','2013-04-06','08:40:00',1.63),('15087','2013-04-06','08:45:00',1.75),('15087','2013-04-06','08:50:00',1.86),('15087','2013-04-06','08:55:00',1.95),('15087','2013-04-06','09:00:00',2.04),('15087','2013-04-06','09:05:00',2.14),('15087','2013-04-06','09:10:00',2.21),('15087','2013-04-06','09:15:00',2.3),('15087','2013-04-06','09:20:00',2.43),('15087','2013-04-06','09:25:00',2.53),('15087','2013-04-06','09:30:00',2.61),('15087','2013-04-06','09:35:00',2.63),('15087','2013-04-06','09:40:00',2.76),('15087','2013-04-06','09:45:00',2.83),('15087','2013-04-06','09:50:00',2.91),('15087','2013-04-06','09:55:00',2.99),('15087','2013-04-06','10:00:00',3.05),('15087','2013-04-06','10:05:00',3.13),('15087','2013-04-06','10:10:00',3.2),('15087','2013-04-06','10:15:00',3.25),('15087','2013-04-06','10:20:00',3.33),('15087','2013-04-06','10:25:00',3.34),('15087','2013-04-06','10:30:00',3.41),('15087','2013-04-06','10:35:00',3.47),('15087','2013-04-06','10:40:00',3.56),('15087','2013-04-06','10:45:00',3.6),('15087','2013-04-06','10:50:00',3.63),('15087','2013-04-06','10:55:00',3.69),('15087','2013-04-06','11:00:00',3.78),('15087','2013-04-06','11:05:00',3.83),('15087','2013-04-06','11:10:00',3.87),('15087','2013-04-06','11:15:00',3.9),('15087','2013-04-06','11:20:00',3.98),('15087','2013-04-06','11:25:00',3.98),('15087','2013-04-06','11:30:00',4.03),('15087','2013-04-06','11:35:00',4.05),('15087','2013-04-06','11:40:00',3.99),('15087','2013-04-06','11:45:00',4.06),('15087','2013-04-06','11:50:00',4.13),('15087','2013-04-06','11:55:00',4.12),('15087','2013-04-06','12:00:00',4.13),('15087','2013-04-06','12:05:00',4.25),('15087','2013-04-06','12:10:00',4.26),('15087','2013-04-06','12:15:00',4.32),('15087','2013-04-06','12:20:00',4.36),('15087','2013-04-06','12:25:00',4.39),('15087','2013-04-06','12:30:00',4.41),('15087','2013-04-06','12:35:00',4.48),('15087','2013-04-06','12:40:00',4.46),('15087','2013-04-06','12:45:00',4.48),('15087','2013-04-06','12:50:00',4.49),('15087','2013-04-06','12:55:00',4.45),('15087','2013-04-06','13:00:00',2.93),('15087','2013-04-06','13:05:00',4.51),('15087','2013-04-06','13:10:00',4.65),('15087','2013-04-06','13:15:00',5),('15087','2013-04-06','13:20:00',2.69),('15087','2013-04-06','13:25:00',1.91),('15087','2013-04-06','13:30:00',4.44),('15087','2013-04-06','13:35:00',4.21),('15087','2013-04-06','13:40:00',1.2),('15087','2013-04-06','13:45:00',2.13),('15087','2013-04-06','13:50:00',5.02),('15087','2013-04-06','13:55:00',5.07),('15087','2013-04-06','14:00:00',4.98),('15087','2013-04-06','14:05:00',4.84),('15087','2013-04-06','14:10:00',4.7),('15087','2013-04-06','14:15:00',2.89),('15087','2013-04-06','14:20:00',2.37),('15087','2013-04-06','14:25:00',1.54),('15087','2013-04-06','14:30:00',3.3),('15087','2013-04-06','14:35:00',4.14),('15087','2013-04-06','14:40:00',4.09),('15087','2013-04-06','14:45:00',3.29),('15087','2013-04-06','14:50:00',3.91),('15087','2013-04-06','14:55:00',2.44),('15087','2013-04-06','15:00:00',3.74),('15087','2013-04-06','15:05:00',3.69),('15087','2013-04-06','15:10:00',3.59),('15087','2013-04-06','15:15:00',3.41),('15087','2013-04-06','15:20:00',3.26),('15087','2013-04-06','15:25:00',3.05),('15087','2013-04-06','15:30:00',3.16),('15087','2013-04-06','15:35:00',3.1),('15087','2013-04-06','15:40:00',3.06),('15087','2013-04-06','15:45:00',2.56),('15087','2013-04-06','15:50:00',2.64),('15087','2013-04-06','15:55:00',2.86),('15087','2013-04-06','16:00:00',2.64),('15087','2013-04-06','16:05:00',2.72),('15087','2013-04-06','16:10:00',2.61),('15087','2013-04-06','16:15:00',2.59),('15087','2013-04-06','16:20:00',2.03),('15087','2013-04-06','16:25:00',1.76),('15087','2013-04-06','16:30:00',2.23),('15087','2013-04-06','16:35:00',2.01),('15087','2013-04-06','16:40:00',1.68),('15087','2013-04-06','16:45:00',2.14),('15087','2013-04-06','16:50:00',1.97),('15087','2013-04-06','16:55:00',1.75),('15087','2013-04-06','17:00:00',1.83),('15087','2013-04-06','17:05:00',1.54),('15087','2013-04-06','17:10:00',1.35),('15087','2013-04-06','17:15:00',1.08),('15087','2013-04-05','08:20:00',1.36),('15087','2013-04-05','09:05:00',2.34),('15087','2013-04-05','09:10:00',1.35),('15087','2013-04-05','09:15:00',2.49),('15087','2013-04-05','09:20:00',2.63),('15087','2013-04-05','09:25:00',1.1),('15087','2013-04-05','09:35:00',1.04),('15087','2013-04-05','09:40:00',2.55),('15087','2013-04-05','09:45:00',1.85),('15087','2013-04-05','09:50:00',1.29),('15087','2013-04-05','10:00:00',1.74),('15087','2013-04-05','10:05:00',1.12),('15087','2013-04-05','10:10:00',3.04),('15087','2013-04-05','10:15:00',3.23),('15087','2013-04-05','10:20:00',1.2),('15087','2013-04-05','10:25:00',3.24),('15087','2013-04-05','10:30:00',1.97),('15087','2013-04-05','10:35:00',2.15),('15087','2013-04-05','10:40:00',4.25),('15087','2013-04-05','10:45:00',1.52),('15087','2013-04-05','10:50:00',2.19),('15087','2013-04-05','10:55:00',2.96),('15087','2013-04-05','11:00:00',2.97),('15087','2013-04-05','11:05:00',3.23),('15087','2013-04-05','11:10:00',4.28),('15087','2013-04-05','11:15:00',3.47),('15087','2013-04-05','11:20:00',3.67),('15087','2013-04-05','11:25:00',3.24),('15087','2013-04-05','11:30:00',4.31),('15087','2013-04-05','11:35:00',4.53),('15087','2013-04-05','11:40:00',4.15),('15087','2013-04-05','11:45:00',3.81),('15087','2013-04-05','11:50:00',4.5),('15087','2013-04-05','11:55:00',4.58),('15087','2013-04-05','12:00:00',4.67),('15087','2013-04-05','12:05:00',2.8),('15087','2013-04-05','12:10:00',1.95),('15087','2013-04-05','12:15:00',3.35),('15087','2013-04-05','12:20:00',1.68),('15087','2013-04-05','12:25:00',2.5),('15087','2013-04-05','12:30:00',1.39),('15087','2013-04-05','12:35:00',1.46),('15087','2013-04-05','12:40:00',1.86),('15087','2013-04-05','12:45:00',3.55),('15087','2013-04-05','12:50:00',4.22),('15087','2013-04-05','12:55:00',3.68),('15087','2013-04-05','13:00:00',3.81),('15087','2013-04-05','13:05:00',3.62),('15087','2013-04-05','13:10:00',3.15),('15087','2013-04-05','13:15:00',4.19),('15087','2013-04-05','13:20:00',4.21),('15087','2013-04-05','13:25:00',3.5),('15087','2013-04-05','13:30:00',4.08),('15087','2013-04-05','13:35:00',3.91),('15087','2013-04-05','13:40:00',3.68),('15087','2013-04-05','13:45:00',4.06),('15087','2013-04-05','13:50:00',4.38),('15087','2013-04-05','13:55:00',3.31),('15087','2013-04-05','14:00:00',3.32),('15087','2013-04-05','14:05:00',4.85),('15087','2013-04-05','14:10:00',4.26),('15087','2013-04-05','14:15:00',4.36),('15087','2013-04-05','14:20:00',3.58),('15087','2013-04-05','14:25:00',4.21),('15087','2013-04-05','14:30:00',4.04),('15087','2013-04-05','14:35:00',3.78),('15087','2013-04-05','14:40:00',4.01),('15087','2013-04-05','14:45:00',2.69),('15087','2013-04-05','14:50:00',2.85),('15087','2013-04-05','14:55:00',4.35),('15087','2013-04-05','15:00:00',3.83),('15087','2013-04-05','15:05:00',3.83),('15087','2013-04-05','15:10:00',2.38),('15087','2013-04-05','15:15:00',1.62),('15087','2013-04-05','15:20:00',1.72),('15087','2013-04-05','15:25:00',1.81),('15087','2013-04-05','15:30:00',1.58),('15087','2013-04-05','15:35:00',1.24),('15087','2013-04-05','15:40:00',1.12),('15087','2013-04-05','15:45:00',1.4),('15087','2013-04-05','15:50:00',1.78),('15087','2013-04-05','15:55:00',1.69),('15087','2013-04-05','16:00:00',1.73),('15087','2013-04-05','16:05:00',1.64),('15087','2013-04-05','16:10:00',1.71),('15087','2013-04-05','16:15:00',2.03),('15087','2013-04-05','16:20:00',1.69),('15087','2013-04-05','16:25:00',1.45),('15087','2013-04-05','16:30:00',1.59),('15087','2013-04-05','16:35:00',1.8),('15087','2013-04-05','16:40:00',1.57),('15087','2013-04-05','16:45:00',1.98),('15087','2013-04-05','16:50:00',2.46),('15087','2013-04-05','16:55:00',1.3),('15087','2013-04-05','17:00:00',1.24),('15087','2013-04-05','17:05:00',1.06),('15087','2013-04-05','17:10:00',2.63),('15087','2013-04-05','17:15:00',2.15),('15087','2013-04-05','17:20:00',1.74),('15087','2013-04-05','17:25:00',1.92),('15087','2013-04-05','17:30:00',1.35),('15087','2013-04-05','17:35:00',1.59),('15087','2013-04-05','17:40:00',1.07),('15087','2013-04-05','17:50:00',1.08),('15087','2013-04-05','17:55:00',1.41),('15087','2013-04-04','08:55:00',1.46),('15087','2013-04-04','09:00:00',2.16),('15087','2013-04-04','09:05:00',1.48),('15087','2013-04-04','09:10:00',1.44),('15087','2013-04-04','09:15:00',1.41),('15087','2013-04-04','09:20:00',1.29),('15087','2013-04-04','09:25:00',1.04),('15087','2013-04-04','09:30:00',1.68),('15087','2013-04-04','09:35:00',2.78),('15087','2013-04-04','09:40:00',2.48),('15087','2013-04-04','09:45:00',2.18),('15087','2013-04-04','09:50:00',1.13),('15087','2013-04-04','09:55:00',1.34),('15087','2013-04-04','10:00:00',2.05),('15087','2013-04-04','10:05:00',2.65),('15087','2013-04-04','10:10:00',2.17),('15087','2013-04-04','10:15:00',1.71),('15087','2013-04-04','10:20:00',2.05),('15087','2013-04-04','10:25:00',3.94),('15087','2013-04-04','10:30:00',3.18),('15087','2013-04-04','10:35:00',2.14),('15087','2013-04-04','10:40:00',4.07),('15087','2013-04-04','10:45:00',2.18),('15087','2013-04-04','10:50:00',2.52),('15087','2013-04-04','10:55:00',4.2),('15087','2013-04-04','11:00:00',2.44),('15087','2013-04-04','11:05:00',1.27),('15087','2013-04-04','11:10:00',1.13),('15087','2013-04-04','11:15:00',1.59),('15087','2013-04-04','11:20:00',1.44),('15087','2013-04-04','11:25:00',1.08),('15087','2013-04-04','11:30:00',1.2),('15087','2013-04-04','11:35:00',1.91),('15087','2013-04-04','11:40:00',3.21),('15087','2013-04-04','11:45:00',3.69),('15087','2013-04-04','11:50:00',3.98),('15087','2013-04-04','11:55:00',3.59),('15087','2013-04-04','12:00:00',2.7),('15087','2013-04-04','12:05:00',4.33),('15087','2013-04-04','12:10:00',4.37),('15087','2013-04-04','12:15:00',3.84),('15087','2013-04-04','12:20:00',3.41),('15087','2013-04-04','12:25:00',3.06),('15087','2013-04-04','12:30:00',3.64),('15087','2013-04-04','12:35:00',4.51),('15087','2013-04-04','12:40:00',4.62),('15087','2013-04-04','12:45:00',4.23),('15087','2013-04-04','12:50:00',3.5),('15087','2013-04-04','12:55:00',3.92),('15087','2013-04-04','13:00:00',4.14),('15087','2013-04-04','13:05:00',4.12),('15087','2013-04-04','13:10:00',4.29),('15087','2013-04-04','13:15:00',4.4),('15087','2013-04-04','13:20:00',4.24),('15087','2013-04-04','13:25:00',4.43),('15087','2013-04-04','13:30:00',4.24),('15087','2013-04-04','13:35:00',3.85),('15087','2013-04-04','13:40:00',3.28),('15087','2013-04-04','13:45:00',3.61),('15087','2013-04-04','13:50:00',3.48),('15087','2013-04-04','13:55:00',2.68),('15087','2013-04-04','14:00:00',2.92),('15087','2013-04-04','14:05:00',3.88),('15087','2013-04-04','14:10:00',4.18),('15087','2013-04-04','14:15:00',4.06),('15087','2013-04-04','14:20:00',4.05),('15087','2013-04-04','14:25:00',3.89),('15087','2013-04-04','14:30:00',3.87),('15087','2013-04-04','14:35:00',3.55),('15087','2013-04-04','14:40:00',3.86),('15087','2013-04-04','14:45:00',3.69),('15087','2013-04-04','14:50:00',3.71),('15087','2013-04-04','14:55:00',3.66),('15087','2013-04-04','15:00:00',3.62),('15087','2013-04-04','15:05:00',3.47),('15087','2013-04-04','15:10:00',3.32),('15087','2013-04-04','15:15:00',3.21),('15087','2013-04-04','15:20:00',3.23),('15087','2013-04-04','15:25:00',3.34),('15087','2013-04-04','15:30:00',3.28),('15087','2013-04-04','15:35:00',3.06),('15087','2013-04-04','15:40:00',3),('15087','2013-04-04','15:45:00',3.01),('15087','2013-04-04','15:50:00',2.88),('15087','2013-04-04','15:55:00',2.91),('15087','2013-04-04','16:00:00',2.81),('15087','2013-04-04','16:05:00',2.68),('15087','2013-04-04','16:10:00',2.6),('15087','2013-04-04','16:15:00',2.49),('15087','2013-04-04','16:20:00',2.36),('15087','2013-04-04','16:25:00',2.22),('15087','2013-04-04','16:30:00',1.85),('15087','2013-04-04','16:35:00',1.81),('15087','2013-04-04','16:40:00',1.95),('15087','2013-04-04','16:45:00',1.69),('15087','2013-04-04','16:50:00',1.64),('15087','2013-04-04','16:55:00',1.85),('15087','2013-04-04','17:00:00',1.7),('15087','2013-04-04','17:05:00',1.66),('15087','2013-04-04','17:10:00',1.56),('15087','2013-04-04','17:15:00',1.37),('15087','2013-04-04','17:25:00',1.03),('15087','2013-04-04','17:55:00',1.07),('15087','2013-04-03','08:15:00',1.17),('15087','2013-04-03','08:20:00',1.33),('15087','2013-04-03','08:25:00',1.19),('15087','2013-04-03','08:30:00',1.58),('15087','2013-04-03','08:40:00',1.02),('15087','2013-04-03','08:45:00',1.8),('15087','2013-04-03','08:50:00',1.97),('15087','2013-04-03','08:55:00',2.06),('15087','2013-04-03','09:00:00',2.16),('15087','2013-04-03','09:05:00',2.28),('15087','2013-04-03','09:10:00',2.45),('15087','2013-04-03','09:15:00',2.55),('15087','2013-04-03','09:20:00',2.56),('15087','2013-04-03','09:25:00',3.07),('15087','2013-04-03','09:30:00',2.67),('15087','2013-04-03','09:35:00',1.59),('15087','2013-04-03','09:40:00',3.05),('15087','2013-04-03','09:45:00',2.84),('15087','2013-04-03','09:50:00',2.88),('15087','2013-04-03','09:55:00',2.39),('15087','2013-04-03','10:00:00',1.98),('15087','2013-04-03','10:05:00',1.23),('15087','2013-04-03','10:10:00',1.36),('15087','2013-04-03','10:15:00',2.48),('15087','2013-04-03','10:20:00',4.19),('15087','2013-04-03','10:25:00',3.48),('15087','2013-04-03','10:30:00',4.33),('15087','2013-04-03','10:35:00',2.58),('15087','2013-04-03','10:40:00',1.79),('15087','2013-04-03','10:45:00',1.54),('15087','2013-04-03','10:50:00',1.65),('15087','2013-04-03','10:55:00',2.25),('15087','2013-04-03','11:00:00',4.52),('15087','2013-04-03','11:05:00',3.62),('15087','2013-04-03','11:10:00',2.45),('15087','2013-04-03','11:15:00',4.78),('15087','2013-04-03','11:20:00',4.07),('15087','2013-04-03','11:25:00',1.89),('15087','2013-04-03','11:30:00',2.1),('15087','2013-04-03','11:35:00',3.08),('15087','2013-04-03','11:40:00',1.65),('15087','2013-04-03','11:45:00',2.18),('15087','2013-04-03','11:50:00',4.34),('15087','2013-04-03','11:55:00',2.62),('15087','2013-04-03','12:00:00',3.15),('15087','2013-04-03','12:05:00',4.65),('15087','2013-04-03','12:10:00',2.89),('15087','2013-04-03','12:15:00',3.44),('15087','2013-04-03','12:20:00',4.17),('15087','2013-04-03','12:25:00',5.14),('15087','2013-04-03','12:30:00',4.73),('15087','2013-04-03','12:35:00',5.42),('15087','2013-04-03','12:40:00',5.02),('15087','2013-04-03','12:45:00',4.88),('15087','2013-04-03','12:50:00',5.23),('15087','2013-04-03','12:55:00',2.36),('15087','2013-04-03','13:05:00',4.39),('15087','2013-04-03','13:10:00',3.69),('15087','2013-04-03','13:15:00',4.93),('15087','2013-04-03','13:20:00',2.7),('15087','2013-04-03','13:25:00',2.76),('15087','2013-04-03','13:30:00',3.72),('15087','2013-04-03','13:35:00',4.33),('15087','2013-04-03','13:40:00',4.09),('15087','2013-04-03','13:45:00',2.63),('15087','2013-04-03','13:50:00',4),('15087','2013-04-03','13:55:00',3.12),('15087','2013-04-03','14:00:00',4.33),('15087','2013-04-03','14:05:00',2.99),('15087','2013-04-03','14:10:00',3.81),('15087','2013-04-03','14:15:00',1.96),('15087','2013-04-03','14:20:00',3.29),('15087','2013-04-03','14:25:00',2.41),('15087','2013-04-03','14:30:00',4.47),('15087','2013-04-03','14:35:00',4.22),('15087','2013-04-03','14:40:00',2.12),('15087','2013-04-03','14:45:00',3.24),('15087','2013-04-03','14:50:00',4.13),('15087','2013-04-03','14:55:00',3.99),('15087','2013-04-03','15:00:00',3.58),('15087','2013-04-03','15:05:00',3.74),('15087','2013-04-03','15:10:00',3.77),('15087','2013-04-03','15:15:00',3.96),('15087','2013-04-03','15:20:00',3.36),('15087','2013-04-03','15:25:00',3.88),('15087','2013-04-03','15:30:00',2.16),('15087','2013-04-03','15:35:00',2.72),('15087','2013-04-03','15:40:00',2.98),('15087','2013-04-03','15:45:00',2.79),('15087','2013-04-03','15:50:00',3.74),('15087','2013-04-03','15:55:00',3.56),('15087','2013-04-03','16:00:00',3.37),('15087','2013-04-03','16:05:00',3.34),('15087','2013-04-03','16:10:00',2.97),('15087','2013-04-03','16:15:00',3.03),('15087','2013-04-03','16:20:00',2.96),('15087','2013-04-03','16:25:00',2.91),('15087','2013-04-03','16:30:00',2.85),('15087','2013-04-03','16:35:00',2.39),('15087','2013-04-03','16:40:00',2.63),('15087','2013-04-03','16:45:00',2.43),('15087','2013-04-03','16:50:00',2.46),('15087','2013-04-03','16:55:00',2.37),('15087','2013-04-03','17:00:00',2.27),('15087','2013-04-03','17:05:00',2.14),('15087','2013-04-03','17:10:00',2.01),('15087','2013-04-03','17:15:00',1.93),('15087','2013-04-03','17:20:00',1.8),('15087','2013-04-03','17:25:00',1.63),('15087','2013-04-03','17:30:00',1.49),('15087','2013-04-03','17:35:00',1.41),('15087','2013-04-03','17:40:00',1.34),('15087','2013-04-03','17:45:00',1.24),('15087','2013-04-03','17:50:00',1.14),('15087','2013-04-03','17:55:00',1.02),('15087','2013-04-02','08:40:00',1.73),('15087','2013-04-02','08:45:00',1.82),('15087','2013-04-02','08:50:00',1.34),('15087','2013-04-02','08:55:00',1.36),('15087','2013-04-02','09:00:00',2.08),('15087','2013-04-02','09:05:00',2.16),('15087','2013-04-02','09:10:00',1.87),('15087','2013-04-02','09:15:00',1.66),('15087','2013-04-02','09:20:00',2.03),('15087','2013-04-02','09:25:00',1.54),('15087','2013-04-02','09:30:00',1.7),('15087','2013-04-02','09:35:00',2.66),('15087','2013-04-02','09:40:00',3.06),('15087','2013-04-02','09:45:00',2.46),('15087','2013-04-02','09:50:00',2.2),('15087','2013-04-02','09:55:00',2.28),('15087','2013-04-02','10:00:00',2.39),('15087','2013-04-02','10:05:00',1.44),('15087','2013-04-02','10:10:00',1.36),('15087','2013-04-02','10:15:00',1.37),('15087','2013-04-02','10:20:00',1.85),('15087','2013-04-02','10:25:00',2.14),('15087','2013-04-02','10:35:00',3.35),('15087','2013-04-02','10:40:00',2.29),('15087','2013-04-02','10:45:00',2.54),('15087','2013-04-02','10:50:00',4.25),('15087','2013-04-02','10:55:00',1.49),('15087','2013-04-02','11:00:00',1.15),('15087','2013-04-02','11:05:00',3.34),('15087','2013-04-02','11:10:00',1.73),('15087','2013-04-02','11:15:00',1.19),('15087','2013-04-02','11:25:00',1.21),('15087','2013-04-02','11:30:00',1.35),('15087','2013-04-02','11:35:00',1.3),('15087','2013-04-02','11:40:00',1.06),('15087','2013-04-02','11:45:00',2.74),('15087','2013-04-02','11:50:00',2.49),('15087','2013-04-02','11:55:00',1.11),('15087','2013-04-02','12:00:00',1.1),('15087','2013-04-02','12:05:00',3.31),('15087','2013-04-02','12:10:00',2),('15087','2013-04-02','12:15:00',2.17),('15087','2013-04-02','12:30:00',1.03),('15087','2013-04-02','12:35:00',1.92),('15087','2013-04-02','12:40:00',2.18),('15087','2013-04-02','12:45:00',2.56),('15087','2013-04-02','12:50:00',2.41),('15087','2013-04-02','12:55:00',2.35),('15087','2013-04-02','13:00:00',2.72),('15087','2013-04-02','13:05:00',2.75),('15087','2013-04-02','13:10:00',3.46),('15087','2013-04-02','13:15:00',2.68),('15087','2013-04-02','13:20:00',2.16),('15087','2013-04-02','13:25:00',3.59),('15087','2013-04-02','13:30:00',2.66),('15087','2013-04-02','13:35:00',2.11),('15087','2013-04-02','13:40:00',3.16),('15087','2013-04-02','13:45:00',2.9),('15087','2013-04-02','13:50:00',2.31),('15087','2013-04-02','13:55:00',2.19),('15087','2013-04-02','14:00:00',2.5),('15087','2013-04-02','14:05:00',2.14),('15087','2013-04-02','14:10:00',2.75),('15087','2013-04-02','14:15:00',2.42),('15087','2013-04-02','14:20:00',3.85),('15087','2013-04-02','14:25:00',4.31),('15087','2013-04-02','14:30:00',2.6),('15087','2013-04-02','14:35:00',2.11),('15087','2013-04-02','14:40:00',2.83),('15087','2013-04-02','14:45:00',2.96),('15087','2013-04-02','14:50:00',2.06),('15087','2013-04-02','14:55:00',1.82),('15087','2013-04-02','15:00:00',1.55),('15087','2013-04-02','15:45:00',1.21),('15087','2013-04-02','16:00:00',1.12),('15087','2013-04-02','16:05:00',1.18),('15087','2013-04-02','16:15:00',1.11),('15087','2013-04-02','16:20:00',1.04),('15087','2014-05-02','07:40:00',1.08),('15087','2014-05-02','07:45:00',1.17),('15087','2014-05-02','07:50:00',1.27),('15087','2014-05-02','07:55:00',1.49),('15087','2014-05-02','08:00:00',1.6),('15087','2014-05-02','08:05:00',1.46),('15087','2014-05-02','08:15:00',2.55),('15087','2014-05-02','08:20:00',1.96),('15087','2014-05-02','08:25:00',1.12),('15087','2014-05-02','08:45:00',1.35),('15087','2014-05-02','08:50:00',1.98),('15087','2014-05-02','09:15:00',1.31),('15087','2014-05-02','09:20:00',1.63),('15087','2014-05-02','09:25:00',1.91),('15087','2014-05-02','09:30:00',2.17),('15087','2014-05-02','09:35:00',2.04),('15087','2014-05-02','09:40:00',1.85),('15087','2014-05-02','09:45:00',1.92),('15087','2014-05-02','09:50:00',1.72),('15087','2014-05-02','09:55:00',1.67),('15087','2014-05-02','10:00:00',2.04),('15087','2014-05-02','10:05:00',2.31),('15087','2014-05-02','10:10:00',2),('15087','2014-05-02','10:15:00',1.76),('15087','2014-05-02','10:20:00',1.62),('15087','2014-05-02','10:25:00',1.32),('15087','2014-05-02','10:40:00',1.07),('15087','2014-05-02','10:45:00',1.38),('15087','2014-05-02','10:50:00',1.12),('15087','2014-05-02','12:30:00',1.13),('15087','2014-05-02','12:35:00',1.25),('15087','2014-05-02','12:40:00',1.27),('15087','2014-05-02','12:45:00',1.72),('15087','2014-05-02','12:50:00',2.09),('15087','2014-05-02','12:55:00',1.6),('15087','2014-05-02','13:00:00',1.81),('15087','2014-05-02','13:05:00',2.02),('15087','2014-05-02','13:10:00',2.04),('15087','2014-05-02','13:15:00',2.79),('15087','2014-05-02','13:20:00',3.42),('15087','2014-05-02','13:25:00',3.89),('15087','2014-05-02','13:30:00',2.81),('15087','2014-05-02','13:35:00',3.2),('15087','2014-05-02','13:40:00',2.66),('15087','2014-05-02','13:45:00',2.3),('15087','2014-05-02','13:50:00',1.92),('15087','2014-05-02','13:55:00',1.46),('15087','2014-05-02','14:00:00',1.58),('15087','2014-05-02','14:05:00',2.75),('15087','2014-05-02','14:10:00',1),('15087','2014-05-02','14:30:00',1.16),('15087','2014-05-02','14:35:00',1.83),('15087','2014-05-02','14:40:00',3.16),('15087','2014-05-02','14:45:00',1.74),('15087','2014-05-02','14:50:00',1.52),('15087','2014-05-02','14:55:00',2.2),('15087','2014-05-02','15:00:00',2.62),('15087','2014-05-02','15:05:00',2.24),('15087','2014-05-02','15:10:00',4.49),('15087','2014-05-02','15:15:00',3.39),('15087','2014-05-02','15:20:00',2.86),('15087','2014-05-02','15:25:00',1.69),('15087','2014-05-02','15:30:00',1.39),('15087','2014-05-02','15:35:00',2.93),('15087','2014-05-02','15:40:00',3.74),('15087','2014-05-02','15:45:00',1.4),('15087','2014-05-02','16:00:00',1.56),('15087','2014-05-02','16:05:00',1.92),('15087','2014-05-02','16:10:00',1.14),('15087','2014-05-02','16:15:00',1.33),('15087','2014-05-02','16:20:00',2.33),('15087','2014-05-02','17:20:00',1.06),('15087','2014-05-02','17:25:00',1.26),('15087','2013-04-01','08:25:00',1.35),('15087','2013-04-01','08:30:00',1.33),('15087','2013-04-01','08:35:00',1.56),('15087','2013-04-01','08:40:00',1.42),('15087','2013-04-01','08:55:00',1.54),('15087','2013-04-01','09:00:00',2.03),('15087','2013-04-01','09:05:00',2.16),('15087','2013-04-01','09:10:00',2.31),('15087','2013-04-01','09:15:00',1.46),('15087','2013-04-01','09:20:00',1.73),('15087','2013-04-01','09:25:00',1.84),('15087','2013-04-01','09:30:00',1.9),('15087','2013-04-01','09:35:00',2.4),('15087','2013-04-01','09:40:00',1.77),('15087','2013-04-01','09:45:00',2.98),('15087','2013-04-01','09:50:00',3.04),('15087','2013-04-01','09:55:00',2.91),('15087','2013-04-01','10:00:00',3.28),('15087','2013-04-01','10:05:00',3.32),('15087','2013-04-01','10:10:00',2.48),('15087','2013-04-01','10:15:00',2.99),('15087','2013-04-01','10:20:00',1.63),('15087','2013-04-01','10:25:00',3.31),('15087','2013-04-01','10:30:00',2.47),('15087','2013-04-01','10:35:00',1.36),('15087','2013-04-01','10:40:00',2.06),('15087','2013-04-01','10:45:00',3.98),('15087','2013-04-01','10:50:00',1.9),('15087','2013-04-01','10:55:00',2.07),('15087','2013-04-01','11:00:00',1.2),('15087','2013-04-01','11:05:00',1.58),('15087','2013-04-01','11:10:00',2.95),('15087','2013-04-01','11:15:00',2.7),('15087','2013-04-01','11:20:00',3.9),('15087','2013-04-01','11:25:00',1.87),('15087','2013-04-01','11:30:00',1.69),('15087','2013-04-01','11:35:00',2.03),('15087','2013-04-01','11:40:00',3.21),('15087','2013-04-01','11:45:00',3.22),('15087','2013-04-01','11:50:00',2.73),('15087','2013-04-01','11:55:00',2.4),('15087','2013-04-01','12:00:00',3.16),('15087','2013-04-01','12:05:00',1.94),('15087','2013-04-01','12:10:00',2.57),('15087','2013-04-01','12:15:00',2.07),('15087','2013-04-01','12:20:00',1.74),('15087','2013-04-01','12:25:00',1.99),('15087','2013-04-01','12:30:00',2.84),('15087','2013-04-01','12:35:00',2.6),('15087','2013-04-01','12:40:00',2.64),('15087','2013-04-01','12:45:00',2.96),('15087','2013-04-01','12:50:00',3.15),('15087','2013-04-01','12:55:00',3.32),('15087','2013-04-01','13:00:00',3.29),('15087','2013-04-01','13:05:00',3.5),('15087','2013-04-01','13:10:00',3.12),('15087','2013-04-01','13:15:00',3.33),('15087','2013-04-01','13:20:00',3.12),('15087','2013-04-01','13:25:00',3),('15087','2013-04-01','13:30:00',3.23),('15087','2013-04-01','13:35:00',2.91),('15087','2013-04-01','13:40:00',3.9),('15087','2013-04-01','13:45:00',4.14),('15087','2013-04-01','13:50:00',4.58),('15087','2013-04-01','13:55:00',4.37),('15087','2013-04-01','14:00:00',2.57),('15087','2013-04-01','14:05:00',2.04),('15087','2013-04-01','14:10:00',2.64),('15087','2013-04-01','14:15:00',2.88),('15087','2013-04-01','14:20:00',3.07),('15087','2013-04-01','14:25:00',4.47),('15087','2013-04-01','14:30:00',2.75),('15087','2013-04-01','14:35:00',2.37),('15087','2013-04-01','14:40:00',2.05),('15087','2013-04-01','14:45:00',2.1),('15087','2013-04-01','14:50:00',2.27),('15087','2013-04-01','14:55:00',2.39),('15087','2013-04-01','15:00:00',2.16),('15087','2013-04-01','15:05:00',2.16),('15087','2013-04-01','15:10:00',2.22),('15087','2013-04-01','15:15:00',2.38),('15087','2013-04-01','15:20:00',2.47),('15087','2013-04-01','15:25:00',2.5),('15087','2013-04-01','15:30:00',2.2),('15087','2013-04-01','15:35:00',2.73),('15087','2013-04-01','15:40:00',2.55),('15087','2013-04-01','15:45:00',2.65),('15087','2013-04-01','15:50:00',2.9),('15087','2013-04-01','15:55:00',2.21),('15087','2013-04-01','16:00:00',2.06),('15087','2013-04-01','16:05:00',1.65),('15087','2013-04-01','16:10:00',1.35),('15087','2013-04-01','16:15:00',1.08),('15087','2013-04-01','16:20:00',1.05),('15087','2013-03-31','08:30:00',1.03),('15087','2013-03-31','08:35:00',1.08),('15087','2013-03-31','08:40:00',1.13),('15087','2013-03-31','08:45:00',1.4),('15087','2013-03-31','08:50:00',1.11),('15087','2013-03-31','08:55:00',1.21),('15087','2013-03-31','09:00:00',1.12),('15087','2013-03-31','09:05:00',1.08),('15087','2013-03-31','09:10:00',1.19),('15087','2013-03-31','09:15:00',1.56),('15087','2013-03-31','09:20:00',2.69),('15087','2013-03-31','09:25:00',3.06),('15087','2013-03-31','09:30:00',2.22),('15087','2013-03-31','09:35:00',2.29),('15087','2013-03-31','09:40:00',1.52),('15087','2013-03-31','09:45:00',2.59),('15087','2013-03-31','09:50:00',1.59),('15087','2013-03-31','09:55:00',2.19),('15087','2013-03-31','10:00:00',1.94),('15087','2013-03-31','10:15:00',1.07),('15087','2013-03-31','10:20:00',2.48),('15087','2013-03-31','10:25:00',2.57),('15087','2013-03-31','10:30:00',3.08),('15087','2013-03-31','10:35:00',3.13),('15087','2013-03-31','10:45:00',1.33),('15087','2013-03-31','10:50:00',2.19),('15087','2013-03-31','11:10:00',1.54),('15087','2013-03-31','11:15:00',1.35),('15087','2013-03-31','11:20:00',1.21),('15087','2013-03-31','11:25:00',1.71),('15087','2013-03-31','11:30:00',1.29),('15087','2013-03-31','11:35:00',1.68),('15087','2013-03-31','11:40:00',1.74),('15087','2013-03-31','11:45:00',1.56),('15087','2013-03-31','11:50:00',1.73),('15087','2013-03-31','11:55:00',1.84),('15087','2013-03-31','12:00:00',1.71),('15087','2013-03-31','12:05:00',1.58),('15087','2013-03-31','12:10:00',1.39),('15087','2013-03-31','12:15:00',1.52),('15087','2013-03-31','12:20:00',1.38),('15087','2013-03-31','12:25:00',1.77),('15087','2013-03-31','12:30:00',2.06),('15087','2013-03-31','12:35:00',3.24),('15087','2013-03-31','12:40:00',3.47),('15087','2013-03-31','12:45:00',1.78),('15087','2013-03-31','12:50:00',1.93),('15087','2013-03-31','12:55:00',2.25),('15087','2013-03-31','13:00:00',2.71),('15087','2013-03-31','13:05:00',2.11),('15087','2013-03-31','13:10:00',3.32),('15087','2013-03-31','13:15:00',3.27),('15087','2013-03-31','13:20:00',4.06),('15087','2013-03-31','13:25:00',2.36),('15087','2013-03-31','13:40:00',1.95),('15087','2013-03-31','13:45:00',1.76),('15087','2013-03-31','13:50:00',2.47),('15087','2013-03-31','13:55:00',1.73),('15087','2013-03-31','14:00:00',2.12),('15087','2013-03-31','14:05:00',3.28),('15087','2013-03-31','14:10:00',2.79),('15087','2013-03-31','14:15:00',2.82),('15087','2013-03-31','14:20:00',1.82),('15087','2013-03-31','14:25:00',1.98),('15087','2013-03-31','14:30:00',2.88),('15087','2013-03-31','14:35:00',4.51),('15087','2013-03-31','14:40:00',4.65),('15087','2013-03-31','14:45:00',3.57),('15087','2013-03-31','14:50:00',3.34),('15087','2013-03-31','14:55:00',3.31),('15087','2013-03-31','15:00:00',3.51),('15087','2013-03-31','15:05:00',2.33),('15087','2013-03-31','15:10:00',3.37),('15087','2013-03-31','15:15:00',3.41),('15087','2013-03-31','15:20:00',4.11),('15087','2013-03-31','15:25:00',2.56),('15087','2013-03-31','15:30:00',2.67),('15087','2013-03-31','15:35:00',3.33),('15087','2013-03-31','15:40:00',4.05),('15087','2013-03-31','15:45:00',2.67),('15087','2013-03-31','16:00:00',3.18),('15087','2013-03-31','16:05:00',1.19),('15087','2013-03-31','16:10:00',1.74),('15087','2013-03-31','16:15:00',2.55),('15087','2013-03-31','16:20:00',1.9),('15087','2013-03-31','16:25:00',1.32),('15087','2013-03-31','16:30:00',1.1),('15087','2013-03-31','16:35:00',1.17),('15087','2013-03-31','16:40:00',1.38),('15087','2013-03-31','16:45:00',1.11),('15087','2013-03-31','17:00:00',1.2),('15087','2013-03-31','17:05:00',1.39),('15087','2013-03-31','17:10:00',1.13),('15087','2013-03-31','17:20:00',1.11),('15087','2013-03-31','17:25:00',1.16),('15087','2013-03-31','17:30:00',1.27),('15087','2013-03-31','17:35:00',1.17),('15087','2013-03-31','17:50:00',1.03),('15087','2013-03-31','17:55:00',1.52),('15087','2013-03-31','18:15:00',1.23),('15087','2013-03-30','08:35:00',1.18),('15087','2013-03-30','08:40:00',1.09),('15087','2013-03-30','09:05:00',1.75),('15087','2013-03-30','09:10:00',1.88),('15087','2013-03-30','09:15:00',2.13),('15087','2013-03-30','09:20:00',4.02),('15087','2013-03-30','09:25:00',1.72),('15087','2013-03-30','09:30:00',1.23),('15087','2013-03-30','09:35:00',1.39),('15087','2013-03-30','09:40:00',1.45),('15087','2013-03-30','09:45:00',1.19),('15087','2013-03-30','09:55:00',1.29),('15087','2013-03-30','10:00:00',2.05),('15087','2013-03-30','10:05:00',1.92),('15087','2013-03-30','10:10:00',2.09),('15087','2013-03-30','10:15:00',1.85),('15087','2013-03-30','10:20:00',1.58),('15087','2013-03-30','10:25:00',1.59),('15087','2013-03-30','10:30:00',1.83),('15087','2013-03-30','10:35:00',2.21),('15087','2013-03-30','10:40:00',2.65),('15087','2013-03-30','10:45:00',3.47),('15087','2013-03-30','10:50:00',3.21),('15087','2013-03-30','10:55:00',2.45),('15087','2013-03-30','11:00:00',3.73),('15087','2013-03-30','11:05:00',4.3),('15087','2013-03-30','11:10:00',4.74),('15087','2013-03-30','11:15:00',4.15),('15087','2013-03-30','11:20:00',5.5),('15087','2013-03-30','11:25:00',4.81),('15087','2013-03-30','11:30:00',2.87),('15087','2013-03-30','11:35:00',3.86),('15087','2013-03-30','11:40:00',3.4),('15087','2013-03-30','11:45:00',4.33),('15087','2013-03-30','11:50:00',4.86),('15087','2013-03-30','11:55:00',4.32),('15087','2013-03-30','12:00:00',4.02),('15087','2013-03-30','12:05:00',2.82),('15087','2013-03-30','12:10:00',2.26),('15087','2013-03-30','12:15:00',2.22),('15087','2013-03-30','12:20:00',1.96),('15087','2013-03-30','12:25:00',1.05),('15087','2013-03-30','13:10:00',3.22),('15087','2013-03-30','13:15:00',3.38),('15087','2013-03-30','13:20:00',2.23),('15087','2013-03-30','13:25:00',2.05),('15087','2013-03-30','13:30:00',1.13),('15087','2013-03-30','13:45:00',2.74),('15087','2013-03-30','13:50:00',4.02),('15087','2013-03-30','13:55:00',1.77),('15087','2013-03-30','14:00:00',2.22),('15087','2013-03-30','14:05:00',1.91),('15087','2013-03-30','14:10:00',1.12),('15087','2013-03-30','14:15:00',1.04),('15087','2013-03-30','14:20:00',1.72),('15087','2013-03-30','14:25:00',1.4),('15087','2013-03-30','14:30:00',2),('15087','2013-03-30','14:35:00',2.16),('15087','2013-03-30','14:40:00',1.38),('15087','2013-03-30','14:45:00',1.01),('15087','2013-03-30','14:50:00',1.52),('15087','2013-03-29','07:20:00',1.02),('15087','2013-03-29','07:25:00',1.05),('15087','2013-03-29','07:30:00',1.3),('15087','2013-03-29','07:35:00',1.27),('15087','2013-03-29','07:40:00',1.47),('15087','2013-03-29','07:45:00',1.63),('15087','2013-03-29','07:50:00',1.05),('15087','2013-03-29','08:00:00',1.14),('15087','2013-03-29','08:05:00',1.74),('15087','2013-03-29','08:10:00',2.18),('15087','2013-03-29','08:15:00',2.21),('15087','2013-03-29','08:20:00',2.32),('15087','2013-03-29','08:25:00',2.41),('15087','2013-03-29','08:30:00',2.54),('15087','2013-03-29','08:35:00',2.62),('15087','2013-03-29','08:40:00',2.71),('15087','2013-03-29','08:45:00',2.63),('15087','2013-03-29','08:50:00',2.73),('15087','2013-03-29','08:55:00',2.38),('15087','2013-03-29','09:00:00',2.59),('15087','2013-03-29','09:05:00',2.91),('15087','2013-03-29','09:10:00',2.94),('15087','2013-03-29','09:15:00',3.3),('15087','2013-03-29','09:20:00',3.45),('15087','2013-03-29','09:25:00',3.29),('15087','2013-03-29','09:30:00',3.9),('15087','2013-03-29','09:35:00',3.85),('15087','2013-03-29','09:40:00',3.83),('15087','2013-03-29','09:45:00',3.35),('15087','2013-03-29','09:50:00',3.65),('15087','2013-03-29','09:55:00',3.75),('15087','2013-03-29','10:00:00',3.7),('15087','2013-03-29','10:05:00',3.62),('15087','2013-03-29','10:10:00',3.11),('15087','2013-03-29','10:15:00',3.68),('15087','2013-03-29','10:20:00',3.45),('15087','2013-03-29','10:25:00',3.09),('15087','2013-03-29','10:30:00',3.07),('15087','2013-03-29','10:35:00',3.5),('15087','2013-03-29','10:40:00',4.12),('15087','2013-03-29','10:45:00',3.29),('15087','2013-03-29','10:50:00',3),('15087','2013-03-29','10:55:00',3.79),('15087','2013-03-29','11:00:00',4.28),('15087','2013-03-29','11:05:00',3.93),('15087','2013-03-29','11:10:00',2.1),('15087','2013-03-29','11:15:00',1.83),('15087','2013-03-29','11:20:00',4.89),('15087','2013-03-29','11:25:00',4.87),('15087','2013-03-29','11:30:00',4.65),('15087','2013-03-29','11:35:00',4.54),('15087','2013-03-29','11:40:00',4.59),('15087','2013-03-29','11:45:00',4.58),('15087','2013-03-29','11:50:00',4.66),('15087','2013-03-29','11:55:00',4.67),('15087','2013-03-29','12:00:00',4.66),('15087','2013-03-29','12:05:00',4.76),('15087','2013-03-29','12:10:00',4.71),('15087','2013-03-29','12:15:00',4.38),('15087','2013-03-29','12:30:00',1.34),('15087','2013-03-29','12:35:00',4.27),('15087','2013-03-29','12:40:00',4.41),('15087','2013-03-29','12:45:00',4.21),('15087','2013-03-29','12:50:00',3.22),('15087','2013-03-29','12:55:00',4.06),('15087','2013-03-29','13:00:00',4.27),('15087','2013-03-29','13:05:00',3.79),('15087','2013-03-29','13:10:00',3.33),('15087','2013-03-29','13:15:00',3.23),('15087','2013-03-29','13:20:00',3.73),('15087','2013-03-29','13:25:00',4.28),('15087','2013-03-29','13:30:00',3.83),('15087','2013-03-29','13:35:00',2.46),('15087','2013-03-29','13:40:00',3.45),('15087','2013-03-29','13:45:00',3.69),('15087','2013-03-29','13:50:00',3.45),('15087','2013-03-29','13:55:00',2.3),('15087','2013-03-29','14:00:00',3.7),('15087','2013-03-29','14:05:00',3.05),('15087','2013-03-29','14:10:00',2.58),('15087','2013-03-29','14:15:00',2.58),('15087','2013-03-29','14:20:00',2.58),('15087','2013-03-29','14:25:00',2.69),('15087','2013-03-29','14:30:00',2.25),('15087','2013-03-29','14:35:00',2.23),('15087','2013-03-29','14:40:00',2.17),('15087','2013-03-29','14:45:00',1.96),('15087','2013-03-29','14:50:00',1.9),('15087','2013-03-29','14:55:00',1.84),('15087','2013-03-29','15:00:00',1.62),('15087','2013-03-29','15:05:00',1.64),('15087','2013-03-29','15:10:00',1.53),('15087','2013-03-29','15:15:00',1.52),('15087','2013-03-29','15:20:00',1.4),('15087','2013-03-29','15:25:00',1.27),('15087','2013-03-29','15:30:00',1.17),('15087','2013-03-29','15:35:00',1.11),('15087','2013-03-29','15:40:00',1.06),('15087','2013-03-29','15:45:00',1.03),('15087','2013-03-29','15:50:00',1.14),('15087','2013-03-29','15:55:00',1.34),('15087','2013-03-29','16:00:00',1.71),('15087','2013-03-29','16:05:00',1.62),('15087','2013-03-29','16:10:00',1.11),('15087','2013-03-29','16:15:00',1),('15087','2013-03-29','16:25:00',1.05),('15087','2013-03-29','16:30:00',1.07),('15087','2013-03-29','16:35:00',1.2),('15087','2013-03-29','16:40:00',1.84),('15087','2013-03-29','16:45:00',1.51),('15087','2013-03-29','16:50:00',1.11),('15087','2013-03-29','17:00:00',1.05),('15087','2013-03-28','09:10:00',2.03),('15087','2013-03-28','09:15:00',3.11),('15087','2013-03-28','09:20:00',1.71),('15087','2013-03-28','09:25:00',1.65),('15087','2013-03-28','09:30:00',1.14),('15087','2013-03-28','09:45:00',1.11),('15087','2013-03-28','09:50:00',1.21),('15087','2013-03-28','09:55:00',1.05),('15087','2013-03-28','10:00:00',1.11),('15087','2013-03-28','11:35:00',1.23),('15087','2013-03-28','11:40:00',1.69),('15087','2013-03-28','11:45:00',1.24),('15087','2013-03-28','11:50:00',1.25),('15087','2013-03-28','11:55:00',2.43),('15087','2013-03-28','12:00:00',1.51),('15087','2013-03-28','12:10:00',1.06),('15087','2013-03-28','12:15:00',1.38),('15087','2013-03-28','12:20:00',1.02),('15087','2013-03-28','12:30:00',1.28),('15087','2013-03-28','12:40:00',1.5),('15087','2013-03-28','12:45:00',1.91),('15087','2013-03-28','12:50:00',3.81),('15087','2013-03-28','12:55:00',4.07),('15087','2013-03-28','13:00:00',3.23),('15087','2013-03-28','13:05:00',4.49),('15087','2013-03-28','13:10:00',4.54),('15087','2013-03-28','13:15:00',3.39),('15087','2013-03-28','13:20:00',3.22),('15087','2013-03-28','13:25:00',2.12),('15087','2013-03-28','13:30:00',3),('15087','2013-03-28','13:35:00',3.48),('15087','2013-03-28','13:40:00',2.45),('15087','2013-03-28','13:45:00',2.45),('15087','2013-03-28','13:50:00',2.62),('15087','2013-03-28','13:55:00',1.75),('15087','2013-03-28','14:00:00',2.04),('15087','2013-03-28','14:05:00',2.02),('15087','2013-03-28','14:10:00',1.32),('15087','2013-03-28','14:15:00',1.49),('15087','2013-03-28','14:20:00',1.98),('15087','2013-03-28','14:25:00',1.74),('15087','2013-03-28','14:30:00',2.8),('15087','2013-03-28','14:35:00',1.76),('15087','2013-03-28','14:40:00',1.1),('15087','2013-03-28','14:45:00',1.21),('15087','2013-03-28','14:50:00',1),('15087','2013-03-28','15:00:00',1.28),('15087','2013-03-28','15:05:00',1.48),('15087','2013-03-28','15:10:00',2.68),('15087','2013-03-28','15:15:00',1.93),('15087','2013-03-28','15:20:00',1.87),('15087','2013-03-28','15:25:00',1.01),('15087','2013-03-28','15:30:00',1.61),('15087','2013-03-28','15:35:00',2.26),('15087','2013-03-28','15:40:00',1.62),('15087','2013-03-28','15:45:00',2.11),('15087','2013-03-28','15:50:00',1.49),('15087','2013-03-28','15:55:00',2.73),('15087','2013-03-28','16:00:00',1.25),('15087','2013-03-28','16:05:00',1.08),('15087','2013-03-28','16:10:00',1.6),('15087','2013-03-28','16:35:00',1.54),('15087','2013-03-28','16:40:00',1.03),('15087','2013-03-28','17:00:00',1.39),('15087','2013-03-28','17:05:00',1.17),('15087','2013-03-27','07:25:00',1.07),('15087','2013-03-27','07:30:00',1.13),('15087','2013-03-27','07:40:00',1.19),('15087','2013-03-27','07:55:00',1.4),('15087','2013-03-27','08:00:00',1.52),('15087','2013-03-27','08:05:00',1.55),('15087','2013-03-27','08:10:00',1.4),('15087','2013-03-27','08:15:00',1.58),('15087','2013-03-27','08:20:00',1.36),('15087','2013-03-27','08:25:00',1.66),('15087','2013-03-27','08:30:00',2.16),('15087','2013-03-27','08:35:00',1.8),('15087','2013-03-27','08:40:00',1.31),('15087','2013-03-27','08:45:00',1.4),('15087','2013-03-27','08:50:00',2.03),('15087','2013-03-27','08:55:00',1.35),('15087','2013-03-27','09:00:00',1.54),('15087','2013-03-27','09:05:00',1.2),('15087','2013-03-27','09:15:00',1.75),('15087','2013-03-27','09:20:00',1.66),('15087','2013-03-27','09:25:00',1.09),('15087','2013-03-27','09:40:00',1.02),('15087','2013-03-27','09:45:00',1.83),('15087','2013-03-27','09:50:00',1.72),('15087','2013-03-27','09:55:00',1.57),('15087','2013-03-27','10:00:00',1.57),('15087','2013-03-27','10:10:00',1.53),('15087','2013-03-27','10:15:00',2.08),('15087','2013-03-27','10:20:00',1.54),('15087','2013-03-27','10:25:00',2.06),('15087','2013-03-27','10:30:00',2.64),('15087','2013-03-27','10:35:00',2.21),('15087','2013-03-27','10:40:00',2.54),('15087','2013-03-27','10:45:00',2.28),('15087','2013-03-27','10:50:00',2.56),('15087','2013-03-27','10:55:00',2.31),('15087','2013-03-27','11:00:00',1.98),('15087','2013-03-27','11:05:00',1.76),('15087','2013-03-27','11:10:00',1.84),('15087','2013-03-27','11:15:00',1.98),('15087','2013-03-27','11:20:00',2.03),('15087','2013-03-27','11:25:00',1.9),('15087','2013-03-27','11:30:00',2.1),('15087','2013-03-27','11:35:00',1.97),('15087','2013-03-27','11:40:00',1.75),('15087','2013-03-27','11:45:00',1.95),('15087','2013-03-27','11:50:00',1.89),('15087','2013-03-27','11:55:00',2.97),('15087','2013-03-27','12:00:00',2.88),('15087','2013-03-27','12:05:00',2.7),('15087','2013-03-27','12:10:00',2.33),('15087','2013-03-27','12:15:00',1.85),('15087','2013-03-27','12:20:00',2.06),('15087','2013-03-27','12:25:00',1.93),('15087','2013-03-27','12:30:00',4.35),('15087','2013-03-27','12:35:00',4.12),('15087','2013-03-27','12:40:00',4.29),('15087','2013-03-27','12:45:00',4.08),('15087','2013-03-27','12:50:00',3.05),('15087','2013-03-27','12:55:00',1.73),('15087','2013-03-27','13:00:00',1.66),('15087','2013-03-27','13:05:00',1.68),('15087','2013-03-27','13:10:00',2.32),('15087','2013-03-27','13:15:00',1.79),('15087','2013-03-27','13:20:00',1.4),('15087','2013-03-27','13:25:00',1.47),('15087','2013-03-27','13:30:00',1.69),('15087','2013-03-27','13:35:00',2.54),('15087','2013-03-27','13:40:00',1.79),('15087','2013-03-27','13:45:00',2.07),('15087','2013-03-27','13:50:00',2.34),('15087','2013-03-27','13:55:00',2.13),('15087','2013-03-27','14:00:00',1.9),('15087','2013-03-27','14:05:00',1.65),('15087','2013-03-27','14:10:00',1.71),('15087','2013-03-27','14:15:00',1.96),('15087','2013-03-27','14:20:00',2.44),('15087','2013-03-27','14:25:00',1.96),('15087','2013-03-27','14:30:00',1.6),('15087','2013-03-27','14:35:00',1.94),('15087','2013-03-27','14:40:00',2.72),('15087','2013-03-27','14:45:00',2.54),('15087','2013-03-27','14:50:00',1.88),('15087','2013-03-27','14:55:00',1.27),('15087','2013-03-27','15:00:00',1.01),('15087','2013-03-27','15:05:00',1.37),('15087','2013-03-27','15:10:00',1.43),('15087','2013-03-27','15:15:00',1.04),('15087','2013-03-27','15:20:00',1.01),('15087','2013-03-27','15:25:00',1.05),('15087','2013-03-27','16:40:00',1.02),('15087','2013-03-27','16:45:00',1.2),('15087','2013-03-27','16:50:00',1.06),('15087','2013-03-27','16:55:00',1.24),('15087','2013-03-27','17:00:00',1.24),('15087','2013-03-27','17:05:00',1.37),('15087','2013-03-27','17:10:00',1.16),('15087','2013-03-26','07:45:00',1.28),('15087','2013-03-26','07:50:00',1.8),('15087','2013-03-26','07:55:00',1.69),('15087','2013-03-26','08:30:00',1.01),('15087','2013-03-26','08:35:00',1.65),('15087','2013-03-26','08:40:00',1.63),('15087','2013-03-26','09:10:00',1.29),('15087','2013-03-26','09:15:00',2.04),('15087','2013-03-26','09:20:00',1.07),('15087','2013-03-26','09:50:00',1.57),('15087','2013-03-26','09:55:00',2.72),('15087','2013-03-26','10:00:00',1.14),('15087','2013-03-26','10:50:00',1.05),('15087','2013-03-26','10:55:00',1.06),('15087','2013-03-26','11:00:00',1.26),('15087','2013-03-26','11:05:00',1.17),('15087','2013-03-26','11:10:00',2.43),('15087','2013-03-26','11:15:00',1.82),('15087','2013-03-26','11:20:00',1.94),('15087','2013-03-26','11:45:00',1.3),('15087','2013-03-26','11:50:00',2.5),('15087','2013-03-26','11:55:00',1.05),('15087','2013-03-26','12:00:00',1.58),('15087','2013-03-26','12:05:00',1.36),('15087','2013-03-26','12:10:00',1.49),('15087','2013-03-26','12:15:00',1.57),('15087','2013-03-26','12:20:00',1.71),('15087','2013-03-26','12:25:00',2.49),('15087','2013-03-26','12:30:00',2.11),('15087','2013-03-26','12:35:00',3.49),('15087','2013-03-26','12:40:00',2.06),('15087','2013-03-26','12:45:00',2.69),('15087','2013-03-26','12:50:00',1.83),('15087','2013-03-26','12:55:00',1.16),('15087','2013-03-26','13:00:00',2.16),('15087','2013-03-26','13:05:00',2.61),('15087','2013-03-26','13:10:00',2.75),('15087','2013-03-26','13:15:00',1.79),('15087','2013-03-26','13:20:00',2.14),('15087','2013-03-26','13:25:00',2.3),('15087','2013-03-26','13:30:00',1.85),('15087','2013-03-26','13:35:00',2.38),('15087','2013-03-26','13:40:00',2.57),('15087','2013-03-26','13:45:00',2.22),('15087','2013-03-26','13:50:00',1.86),('15087','2013-03-26','13:55:00',1.7),('15087','2013-03-26','14:00:00',1.64),('15087','2013-03-26','14:05:00',1.63),('15087','2013-03-26','14:10:00',1.72),('15087','2013-03-26','14:15:00',1.57),('15087','2013-03-26','14:20:00',1.28),('15087','2013-03-26','14:25:00',1.18),('15087','2013-03-25','08:20:00',1.14),('15087','2013-03-25','08:25:00',2.6),('15087','2013-03-25','08:30:00',1.52),('15087','2013-03-25','08:55:00',1.27),('15087','2013-03-25','09:00:00',1.13),('15087','2013-03-25','09:05:00',1.12),('15087','2013-03-25','09:10:00',1.31),('15087','2013-03-25','09:15:00',1.23),('15087','2013-03-25','09:20:00',2.55),('15087','2013-03-25','09:25:00',2.5),('15087','2013-03-25','09:30:00',1.64),('15087','2013-03-25','09:35:00',1.06),('15087','2013-03-25','09:45:00',1.23),('15087','2013-03-25','09:50:00',5.15),('15087','2013-03-25','09:55:00',4.86),('15087','2013-03-25','10:00:00',1.2),('15087','2013-03-25','10:05:00',1.24),('15087','2013-03-25','10:10:00',1.26),('15087','2013-03-25','10:15:00',1.19),('15087','2013-03-25','10:20:00',1.71),('15087','2013-03-25','10:25:00',2.85),('15087','2013-03-25','10:30:00',2.49),('15087','2013-03-25','10:35:00',2.05),('15087','2013-03-25','10:40:00',1.99),('15087','2013-03-25','10:45:00',2.79),('15087','2013-03-25','10:50:00',3.13),('15087','2013-03-25','10:55:00',3.79),('15087','2013-03-25','11:00:00',2.59),('15087','2013-03-25','11:05:00',2.53),('15087','2013-03-25','11:10:00',2.43),('15087','2013-03-25','11:15:00',2.51),('15087','2013-03-25','11:20:00',4.3),('15087','2013-03-25','11:25:00',4.12),('15087','2013-03-25','11:30:00',5.49),('15087','2013-03-25','11:35:00',3.31),('15087','2013-03-25','11:40:00',1.38),('15087','2013-03-25','11:45:00',1.79),('15087','2013-03-25','11:50:00',2.04),('15087','2013-03-25','11:55:00',3.41),('15087','2013-03-25','12:00:00',4.81),('15087','2013-03-25','12:05:00',4.25),('15087','2013-03-25','12:10:00',4.38),('15087','2013-03-25','12:15:00',3.88),('15087','2013-03-25','12:20:00',3.1),('15087','2013-03-25','12:25:00',4.35),('15087','2013-03-25','12:30:00',3.67),('15087','2013-03-25','12:35:00',3.14),('15087','2013-03-25','12:40:00',2.88),('15087','2013-03-25','12:45:00',2.78),('15087','2013-03-25','12:50:00',3.06),('15087','2013-03-25','12:55:00',3.5),('15087','2013-03-25','13:00:00',3.92),('15087','2013-03-25','13:05:00',5.02),('15087','2013-03-25','13:10:00',4.68),('15087','2013-03-25','13:15:00',4.38),('15087','2013-03-25','13:20:00',3.88),('15087','2013-03-25','13:25:00',1.88),('15087','2013-03-25','13:30:00',1.92),('15087','2013-03-25','13:35:00',1.17),('15087','2013-03-25','13:40:00',1.25),('15087','2013-03-25','13:45:00',2.61),('15087','2013-03-25','13:50:00',2.19),('15087','2013-03-25','13:55:00',1.93),('15087','2013-03-25','14:05:00',1.3),('15087','2013-03-25','14:10:00',3.61),('15087','2013-03-25','14:15:00',2.06),('15087','2013-03-25','14:20:00',2.9),('15087','2013-03-25','14:25:00',3.41),('15087','2013-03-25','14:30:00',2.11),('15087','2013-03-25','14:35:00',1.74),('15087','2013-03-25','14:40:00',1.46),('15087','2013-03-25','14:45:00',2.34),('15087','2013-03-25','14:50:00',2.05),('15087','2013-03-25','14:55:00',2.98),('15087','2013-03-25','15:00:00',2.96),('15087','2013-03-25','15:05:00',2.87),('15087','2013-03-25','15:10:00',3.14),('15087','2013-03-25','15:15:00',2.69),('15087','2013-03-25','15:20:00',2.32),('15087','2013-03-25','15:25:00',2.53),('15087','2013-03-25','15:30:00',2.65),('15087','2013-03-25','15:35:00',2.04),('15087','2013-03-25','15:40:00',2.97),('15087','2013-03-25','15:45:00',2.2),('15087','2013-03-25','15:50:00',1.19),('15087','2013-03-25','15:55:00',2.03),('15087','2013-03-25','16:00:00',2.29),('15087','2013-03-25','16:05:00',1.01),('15087','2013-03-25','16:10:00',1.36),('15087','2013-03-25','16:30:00',1.43),('15087','2013-03-25','16:35:00',1.99),('15087','2013-03-25','16:40:00',1.7),('15087','2013-03-24','07:45:00',1.04),('15087','2013-03-24','07:50:00',1.26),('15087','2013-03-24','07:55:00',1.48),('15087','2013-03-24','08:00:00',1.77),('15087','2013-03-24','08:05:00',1.86),('15087','2013-03-24','08:10:00',1.91),('15087','2013-03-24','08:15:00',2.03),('15087','2013-03-24','08:20:00',2.12),('15087','2013-03-24','08:25:00',2.2),('15087','2013-03-24','08:30:00',2.29),('15087','2013-03-24','08:35:00',2.38),('15087','2013-03-24','08:40:00',2.46),('15087','2013-03-24','08:45:00',2.52),('15087','2013-03-24','08:50:00',2.56),('15087','2013-03-24','08:55:00',2.65),('15087','2013-03-24','09:00:00',2.71),('15087','2013-03-24','09:05:00',2.81),('15087','2013-03-24','09:10:00',2.9),('15087','2013-03-24','09:15:00',2.98),('15087','2013-03-24','09:20:00',3.04),('15087','2013-03-24','09:25:00',3.11),('15087','2013-03-24','09:30:00',3.18),('15087','2013-03-24','09:35:00',3.23),('15087','2013-03-24','09:40:00',3.29),('15087','2013-03-24','09:45:00',3.36),('15087','2013-03-24','09:50:00',3.39),('15087','2013-03-24','09:55:00',3.47),('15087','2013-03-24','10:00:00',3.54),('15087','2013-03-24','10:05:00',3.59),('15087','2013-03-24','10:10:00',3.66),('15087','2013-03-24','10:15:00',3.72),('15087','2013-03-24','10:20:00',3.77),('15087','2013-03-24','10:25:00',3.81),('15087','2013-03-24','10:30:00',3.85),('15087','2013-03-24','10:35:00',3.87),('15087','2013-03-24','10:40:00',3.9),('15087','2013-03-24','10:45:00',3.94),('15087','2013-03-24','10:50:00',3.95),('15087','2013-03-24','10:55:00',4.01),('15087','2013-03-24','11:00:00',4.03),('15087','2013-03-24','11:05:00',4.05),('15087','2013-03-24','11:10:00',4.07),('15087','2013-03-24','11:15:00',4.04),('15087','2013-03-24','11:20:00',4.09),('15087','2013-03-24','11:25:00',4.14),('15087','2013-03-24','11:30:00',4.17),('15087','2013-03-24','11:35:00',4.14),('15087','2013-03-24','11:40:00',4.18),('15087','2013-03-24','11:45:00',4.15),('15087','2013-03-24','11:50:00',4.17),('15087','2013-03-24','11:55:00',4.17),('15087','2013-03-24','12:00:00',4.17),('15087','2013-03-24','12:05:00',4.21),('15087','2013-03-24','12:10:00',4.27),('15087','2013-03-24','12:15:00',4.31),('15087','2013-03-24','12:20:00',4.34),('15087','2013-03-24','12:25:00',4.36),('15087','2013-03-24','12:30:00',4.36),('15087','2013-03-24','12:35:00',4.39),('15087','2013-03-24','12:40:00',4.35),('15087','2013-03-24','12:45:00',4.36),('15087','2013-03-24','12:50:00',4.31),('15087','2013-03-24','12:55:00',4.25),('15087','2013-03-24','13:00:00',4.19),('15087','2013-03-24','13:05:00',4.2),('15087','2013-03-24','13:10:00',4.19),('15087','2013-03-24','13:15:00',4.13),('15087','2013-03-24','13:20:00',4.06),('15087','2013-03-24','13:25:00',3.94),('15087','2013-03-24','13:30:00',3.97),('15087','2013-03-24','13:35:00',3.89),('15087','2013-03-24','13:40:00',3.86),('15087','2013-03-24','13:45:00',3.84),('15087','2013-03-24','13:50:00',3.74),('15087','2013-03-24','13:55:00',3.69),('15087','2013-03-24','14:00:00',3.63),('15087','2013-03-24','14:05:00',3.57),('15087','2013-03-24','14:10:00',3.46),('15087','2013-03-24','14:15:00',3.43),('15087','2013-03-24','14:20:00',3.26),('15087','2013-03-24','14:25:00',3.27),('15087','2013-03-24','14:30:00',3.04),('15087','2013-03-24','14:35:00',2.97),('15087','2013-03-24','14:40:00',2.99),('15087','2013-03-24','14:45:00',2.88),('15087','2013-03-24','14:50:00',2.8),('15087','2013-03-24','14:55:00',2.79),('15087','2013-03-24','15:00:00',2.65),('15087','2013-03-24','15:05:00',2.57),('15087','2013-03-24','15:10:00',2.41),('15087','2013-03-24','15:15:00',2.72),('15087','2013-03-24','15:20:00',2.52),('15087','2013-03-24','15:25:00',2.4),('15087','2013-03-24','15:30:00',2.16),('15087','2013-03-24','15:35:00',2.11),('15087','2013-03-24','15:40:00',2.13),('15087','2013-03-24','15:45:00',1.71),('15087','2013-03-24','15:50:00',1.24),('15087','2013-03-24','15:55:00',1.2),('15087','2013-03-24','16:00:00',1.19),('15087','2013-03-24','16:05:00',1.44),('15087','2013-03-24','16:10:00',1.03),('15087','2013-03-24','16:15:00',1.49),('15087','2013-03-24','16:20:00',1.18),('15087','2013-03-24','16:25:00',1.06),('15087','2013-03-24','16:30:00',1.18),('15087','2013-03-24','16:35:00',1),('15087','2013-03-23','07:35:00',1.02),('15087','2013-03-23','07:40:00',1.21),('15087','2013-03-23','07:45:00',1.2),('15087','2013-03-23','07:50:00',1.37),('15087','2013-03-23','07:55:00',1.58),('15087','2013-03-23','08:00:00',1.74),('15087','2013-03-23','08:05:00',1.9),('15087','2013-03-23','08:10:00',1.97),('15087','2013-03-23','08:15:00',2.06),('15087','2013-03-23','08:20:00',2.14),('15087','2013-03-23','08:25:00',2.23),('15087','2013-03-23','08:30:00',2.28),('15087','2013-03-23','08:35:00',2.38),('15087','2013-03-23','08:40:00',2.52),('15087','2013-03-23','08:45:00',2.57),('15087','2013-03-23','08:50:00',2.68),('15087','2013-03-23','08:55:00',2.82),('15087','2013-03-23','09:00:00',2.88),('15087','2013-03-23','09:05:00',2.99),('15087','2013-03-23','09:10:00',3),('15087','2013-03-23','09:15:00',3.05),('15087','2013-03-23','09:20:00',3.11),('15087','2013-03-23','09:25:00',3.23),('15087','2013-03-23','09:30:00',3.37),('15087','2013-03-23','09:35:00',3.38),('15087','2013-03-23','09:40:00',3.31),('15087','2013-03-23','09:45:00',3.5),('15087','2013-03-23','09:50:00',3.55),('15087','2013-03-23','09:55:00',3.66),('15087','2013-03-23','10:00:00',3.65),('15087','2013-03-23','10:05:00',3.42),('15087','2013-03-23','10:10:00',3.66),('15087','2013-03-23','10:15:00',3.83),('15087','2013-03-23','10:20:00',3.76),('15087','2013-03-23','10:25:00',3.78),('15087','2013-03-23','10:30:00',3.97),('15087','2013-03-23','10:35:00',3.99),('15087','2013-03-23','10:40:00',4.01),('15087','2013-03-23','10:45:00',3.96),('15087','2013-03-23','10:50:00',3.92),('15087','2013-03-23','10:55:00',3.88),('15087','2013-03-23','11:00:00',3.77),('15087','2013-03-23','11:05:00',3.52),('15087','2013-03-23','11:10:00',3.18),('15087','2013-03-23','11:15:00',3.45),('15087','2013-03-23','11:20:00',3.8),('15087','2013-03-23','11:25:00',3.99),('15087','2013-03-23','11:30:00',3.98),('15087','2013-03-23','11:35:00',4.2),('15087','2013-03-23','11:40:00',4.18),('15087','2013-03-23','11:45:00',4.16),('15087','2013-03-23','11:50:00',3.96),('15087','2013-03-23','11:55:00',4.15),('15087','2013-03-23','12:00:00',4.24),('15087','2013-03-23','12:05:00',4.18),('15087','2013-03-23','12:10:00',4.21),('15087','2013-03-23','12:15:00',4.35),('15087','2013-03-23','12:20:00',4.37),('15087','2013-03-23','12:25:00',4.26),('15087','2013-03-23','12:30:00',4.31),('15087','2013-03-23','12:35:00',4.29),('15087','2013-03-23','12:40:00',4.19),('15087','2013-03-23','12:45:00',4.27),('15087','2013-03-23','12:50:00',4.3),('15087','2013-03-23','12:55:00',4.08),('15087','2013-03-23','13:00:00',3.32),('15087','2013-03-23','13:05:00',4.19),('15087','2013-03-23','13:10:00',4.18),('15087','2013-03-23','13:15:00',3.97),('15087','2013-03-23','13:20:00',4.04),('15087','2013-03-23','13:25:00',3.9),('15087','2013-03-23','13:30:00',3.76),('15087','2013-03-23','13:35:00',3.85),('15087','2013-03-23','13:40:00',3.68),('15087','2013-03-23','13:45:00',3.64),('15087','2013-03-23','13:50:00',3.79),('15087','2013-03-23','13:55:00',3.59),('15087','2013-03-23','14:00:00',3.5),('15087','2013-03-23','14:05:00',3.57),('15087','2013-03-23','14:10:00',3.41),('15087','2013-03-23','14:15:00',3.26),('15087','2013-03-23','14:20:00',3.41),('15087','2013-03-23','14:25:00',3.3),('15087','2013-03-23','14:30:00',3.24),('15087','2013-03-23','14:35:00',3.15),('15087','2013-03-23','14:40:00',2.93),('15087','2013-03-23','14:45:00',2.76),('15087','2013-03-23','14:50:00',2.87),('15087','2013-03-23','14:55:00',2.78),('15087','2013-03-23','15:00:00',2.56),('15087','2013-03-23','15:05:00',2.59),('15087','2013-03-23','15:10:00',2.63),('15087','2013-03-23','15:15:00',2.44),('15087','2013-03-23','15:20:00',2.5),('15087','2013-03-23','15:25:00',2.36),('15087','2013-03-23','15:30:00',1.98),('15087','2013-03-23','15:35:00',2.19),('15087','2013-03-23','15:40:00',2.03),('15087','2013-03-23','15:45:00',1.87),('15087','2013-03-23','15:50:00',1.84),('15087','2013-03-23','15:55:00',1.81),('15087','2013-03-23','16:00:00',1.68),('15087','2013-03-23','16:05:00',1.5),('15087','2013-03-23','16:10:00',1.92),('15087','2013-03-23','16:15:00',1.64),('15087','2013-03-23','16:20:00',1.36),('15087','2013-03-23','16:25:00',1.38),('15087','2013-03-23','16:30:00',1.04),('15087','2013-03-23','16:35:00',1.11),('15087','2013-03-22','07:35:00',1.14),('15087','2013-03-22','07:40:00',1.28),('15087','2013-03-22','07:45:00',1.43),('15087','2013-03-22','07:50:00',1.52),('15087','2013-03-22','07:55:00',1.61),('15087','2013-03-22','08:00:00',1.71),('15087','2013-03-22','08:05:00',1.8),('15087','2013-03-22','08:10:00',1.91),('15087','2013-03-22','08:15:00',2.02),('15087','2013-03-22','08:20:00',2.11),('15087','2013-03-22','08:25:00',2.21),('15087','2013-03-22','08:30:00',2.3),('15087','2013-03-22','08:35:00',2.4),('15087','2013-03-22','08:40:00',2.49),('15087','2013-03-22','08:45:00',2.58),('15087','2013-03-22','08:50:00',2.65),('15087','2013-03-22','08:55:00',2.73),('15087','2013-03-22','09:00:00',2.79),('15087','2013-03-22','09:05:00',2.88),('15087','2013-03-22','09:10:00',2.95),('15087','2013-03-22','09:15:00',3),('15087','2013-03-22','09:20:00',3.07),('15087','2013-03-22','09:25:00',3.13),('15087','2013-03-22','09:30:00',3.21),('15087','2013-03-22','09:35:00',3.28),('15087','2013-03-22','09:40:00',3.37),('15087','2013-03-22','09:45:00',3.45),('15087','2013-03-22','09:50:00',3.5),('15087','2013-03-22','09:55:00',3.57),('15087','2013-03-22','10:00:00',3.65),('15087','2013-03-22','10:05:00',3.72),('15087','2013-03-22','10:10:00',3.74),('15087','2013-03-22','10:15:00',3.75),('15087','2013-03-22','10:20:00',3.89),('15087','2013-03-22','10:25:00',3.97),('15087','2013-03-22','10:30:00',4.03),('15087','2013-03-22','10:35:00',4.02),('15087','2013-03-22','10:40:00',4.09),('15087','2013-03-22','10:45:00',4.12),('15087','2013-03-22','10:50:00',4.17),('15087','2013-03-22','10:55:00',4.19),('15087','2013-03-22','11:00:00',4.25),('15087','2013-03-22','11:05:00',4.26),('15087','2013-03-22','11:10:00',4.28),('15087','2013-03-22','11:15:00',4.32),('15087','2013-03-22','11:20:00',4.32),('15087','2013-03-22','11:25:00',4.31),('15087','2013-03-22','11:30:00',4.37),('15087','2013-03-22','11:35:00',4.36),('15087','2013-03-22','11:40:00',4.44),('15087','2013-03-22','11:45:00',4.45),('15087','2013-03-22','11:50:00',4.46),('15087','2013-03-22','11:55:00',4.49),('15087','2013-03-22','12:00:00',4.48),('15087','2013-03-22','12:05:00',4.5),('15087','2013-03-22','12:10:00',4.48),('15087','2013-03-22','12:15:00',4.47),('15087','2013-03-22','12:20:00',4.48),('15087','2013-03-22','12:25:00',4.49),('15087','2013-03-22','12:30:00',4.5),('15087','2013-03-22','12:35:00',4.5),('15087','2013-03-22','12:40:00',4.5),('15087','2013-03-22','12:45:00',4.49),('15087','2013-03-22','12:50:00',4.34),('15087','2013-03-22','12:55:00',4.19),('15087','2013-03-22','13:00:00',4.03),('15087','2013-03-22','13:05:00',4.33),('15087','2013-03-22','13:10:00',4.37),('15087','2013-03-22','13:15:00',4.15),('15087','2013-03-22','13:20:00',4),('15087','2013-03-22','13:25:00',3.93),('15087','2013-03-22','13:30:00',3.88),('15087','2013-03-22','13:35:00',3.94),('15087','2013-03-22','13:40:00',3.49),('15087','2013-03-22','13:45:00',3.65),('15087','2013-03-22','13:50:00',3.97),('15087','2013-03-22','13:55:00',3.71),('15087','2013-03-22','14:00:00',3.67),('15087','2013-03-22','14:05:00',3.63),('15087','2013-03-22','14:10:00',3.58),('15087','2013-03-22','14:15:00',3.44),('15087','2013-03-22','14:20:00',3.29),('15087','2013-03-22','14:25:00',3.38),('15087','2013-03-22','14:30:00',3.23),('15087','2013-03-22','14:35:00',3.17),('15087','2013-03-22','14:40:00',3.21),('15087','2013-03-22','14:45:00',3.16),('15087','2013-03-22','14:50:00',3.08),('15087','2013-03-22','14:55:00',3.01),('15087','2013-03-22','15:00:00',2.84),('15087','2013-03-22','15:05:00',2.86),('15087','2013-03-22','15:10:00',2.45),('15087','2013-03-22','15:15:00',2.02),('15087','2013-03-22','15:20:00',1.85),('15087','2013-03-22','15:25:00',1.94),('15087','2013-03-22','15:30:00',1.86),('15087','2013-03-22','15:35:00',2.08),('15087','2013-03-22','15:40:00',2.01),('15087','2013-03-22','15:45:00',1.71),('15087','2013-03-22','15:50:00',1.95),('15087','2013-03-22','15:55:00',1.7),('15087','2013-03-22','16:00:00',1.28),('15087','2013-03-22','16:05:00',1.32),('15087','2013-03-22','16:10:00',1.48),('15087','2013-03-22','16:15:00',1.74),('15087','2013-03-22','16:20:00',1.35),('15087','2013-03-22','16:25:00',1.39),('15087','2013-03-22','16:30:00',1.45),('15087','2013-03-22','16:35:00',1.37),('15087','2013-03-22','16:40:00',1.34),('15087','2013-03-22','16:45:00',1.24),('15087','2013-03-22','16:50:00',1.2),('15087','2013-03-22','16:55:00',1.11),('15087','2013-03-21','07:40:00',1.24),('15087','2013-03-21','07:45:00',1.26),('15087','2013-03-21','07:50:00',1.65),('15087','2013-03-21','08:10:00',1.03),('15087','2013-03-21','08:15:00',1.57),('15087','2013-03-21','08:20:00',1.92),('15087','2013-03-21','08:25:00',1.81),('15087','2013-03-21','08:30:00',2.04),('15087','2013-03-21','08:35:00',2.6),('15087','2013-03-21','08:40:00',2.83),('15087','2013-03-21','08:45:00',2.72),('15087','2013-03-21','08:50:00',2.42),('15087','2013-03-21','08:55:00',2.91),('15087','2013-03-21','09:00:00',3.06),('15087','2013-03-21','09:05:00',3.44),('15087','2013-03-21','09:10:00',3.39),('15087','2013-03-21','09:15:00',2.3),('15087','2013-03-21','09:20:00',2.51),('15087','2013-03-21','09:25:00',1.89),('15087','2013-03-21','09:30:00',2.37),('15087','2013-03-21','09:35:00',3.37),('15087','2013-03-21','09:40:00',3.37),('15087','2013-03-21','09:45:00',3.74),('15087','2013-03-21','09:50:00',3.79),('15087','2013-03-21','09:55:00',3.89),('15087','2013-03-21','10:00:00',3.94),('15087','2013-03-21','10:05:00',3.98),('15087','2013-03-21','10:10:00',4.01),('15087','2013-03-21','10:15:00',4.07),('15087','2013-03-21','10:20:00',4.09),('15087','2013-03-21','10:25:00',4.12),('15087','2013-03-21','10:30:00',4.2),('15087','2013-03-21','10:35:00',4.26),('15087','2013-03-21','10:40:00',4.26),('15087','2013-03-21','10:45:00',4.25),('15087','2013-03-21','10:50:00',4.27),('15087','2013-03-21','10:55:00',4.17),('15087','2013-03-21','11:00:00',4.37),('15087','2013-03-21','11:05:00',4.44),('15087','2013-03-21','11:10:00',4.46),('15087','2013-03-21','11:15:00',4.5),('15087','2013-03-21','11:20:00',4.45),('15087','2013-03-21','11:25:00',4.58),('15087','2013-03-21','11:30:00',4.6),('15087','2013-03-21','11:35:00',4.62),('15087','2013-03-21','11:40:00',4.62),('15087','2013-03-21','11:45:00',4.65),('15087','2013-03-21','11:50:00',4.68),('15087','2013-03-21','11:55:00',4.7),('15087','2013-03-21','12:00:00',4.71),('15087','2013-03-21','12:05:00',4.72),('15087','2013-03-21','12:10:00',4.7),('15087','2013-03-21','12:15:00',4.7),('15087','2013-03-21','12:20:00',4.68),('15087','2013-03-21','12:25:00',4.7),('15087','2013-03-21','12:30:00',4.68),('15087','2013-03-21','12:35:00',4.66),('15087','2013-03-21','12:40:00',4.66),('15087','2013-03-21','12:45:00',4.62),('15087','2013-03-21','12:50:00',4.6),('15087','2013-03-21','12:55:00',4.54),('15087','2013-03-21','13:00:00',4.5),('15087','2013-03-21','13:05:00',4.46),('15087','2013-03-21','13:10:00',4.42),('15087','2013-03-21','13:15:00',4.35),('15087','2013-03-21','13:20:00',4.3),('15087','2013-03-21','13:25:00',4.27),('15087','2013-03-21','13:30:00',4.2),('15087','2013-03-21','13:35:00',4.14),('15087','2013-03-21','13:40:00',4.1),('15087','2013-03-21','13:45:00',4.06),('15087','2013-03-21','13:50:00',3.98),('15087','2013-03-21','13:55:00',3.9),('15087','2013-03-21','14:00:00',3.85),('15087','2013-03-21','14:05:00',3.73),('15087','2013-03-21','14:10:00',3.56),('15087','2013-03-21','14:15:00',3.38),('15087','2013-03-21','14:20:00',3.38),('15087','2013-03-21','14:25:00',3.38),('15087','2013-03-21','14:30:00',3.24),('15087','2013-03-21','14:35:00',3.18),('15087','2013-03-21','14:40:00',3.22),('15087','2013-03-21','14:45:00',3.19),('15087','2013-03-21','14:50:00',3.1),('15087','2013-03-21','14:55:00',3.01),('15087','2013-03-21','15:00:00',2.96),('15087','2013-03-21','15:05:00',2.88),('15087','2013-03-21','15:10:00',2.73),('15087','2013-03-21','15:15:00',2.67),('15087','2013-03-21','15:20:00',2.6),('15087','2013-03-21','15:25:00',2.46),('15087','2013-03-21','15:30:00',2.4),('15087','2013-03-21','15:35:00',2.29),('15087','2013-03-21','15:40:00',2.16),('15087','2013-03-21','15:45:00',2.1),('15087','2013-03-21','15:50:00',2.07),('15087','2013-03-21','15:55:00',2.03),('15087','2013-03-21','16:00:00',1.92),('15087','2013-03-21','16:05:00',1.82),('15087','2013-03-21','16:10:00',1.7),('15087','2013-03-21','16:15:00',1.58),('15087','2013-03-21','16:20:00',1.51),('15087','2013-03-21','16:25:00',1.41),('15087','2013-03-21','16:30:00',1.24),('15087','2013-03-21','16:35:00',1.16),('15087','2013-03-21','16:40:00',1.08),('15087','2013-03-21','16:45:00',1.01),('15087','2013-03-20','07:30:00',1.05),('15087','2013-03-20','07:35:00',1.09),('15087','2013-03-20','07:40:00',1.23),('15087','2013-03-20','07:45:00',1.33),('15087','2013-03-20','07:50:00',1.37),('15087','2013-03-20','07:55:00',1.69),('15087','2013-03-20','08:00:00',1.21),('15087','2013-03-20','08:05:00',1.59),('15087','2013-03-20','08:10:00',1.82),('15087','2013-03-20','08:15:00',1.92),('15087','2013-03-20','08:20:00',2.01),('15087','2013-03-20','08:25:00',2.13),('15087','2013-03-20','08:30:00',2.26),('15087','2013-03-20','08:35:00',2.38),('15087','2013-03-20','08:40:00',2.26),('15087','2013-03-20','08:45:00',2.42),('15087','2013-03-20','08:50:00',2.52),('15087','2013-03-20','08:55:00',2.49),('15087','2013-03-20','09:00:00',2.48),('15087','2013-03-20','09:05:00',3.24),('15087','2013-03-20','09:10:00',2.83),('15087','2013-03-20','09:15:00',2.95),('15087','2013-03-20','09:20:00',3.03),('15087','2013-03-20','09:25:00',3.05),('15087','2013-03-20','09:30:00',3.25),('15087','2013-03-20','09:35:00',3.15),('15087','2013-03-20','09:40:00',3.35),('15087','2013-03-20','09:45:00',3.42),('15087','2013-03-20','09:50:00',3.46),('15087','2013-03-20','09:55:00',3.45),('15087','2013-03-20','10:00:00',3.59),('15087','2013-03-20','10:05:00',3.44),('15087','2013-03-20','10:10:00',3.12),('15087','2013-03-20','10:15:00',2.93),('15087','2013-03-20','10:20:00',2.64),('15087','2013-03-20','10:25:00',2.68),('15087','2013-03-20','10:30:00',3.3),('15087','2013-03-20','10:35:00',4.19),('15087','2013-03-20','10:40:00',3.2),('15087','2013-03-20','10:45:00',2.84),('15087','2013-03-20','10:50:00',3.4),('15087','2013-03-20','10:55:00',3.08),('15087','2013-03-20','11:00:00',3.22),('15087','2013-03-20','11:05:00',3.7),('15087','2013-03-20','11:10:00',2.56),('15087','2013-03-20','11:15:00',2.58),('15087','2013-03-20','11:20:00',3.03),('15087','2013-03-20','11:25:00',2.79),('15087','2013-03-20','11:30:00',2.6),('15087','2013-03-20','11:35:00',2.9),('15087','2013-03-20','11:40:00',2.35),('15087','2013-03-20','11:45:00',2.25),('15087','2013-03-20','11:50:00',2.18),('15087','2013-03-20','11:55:00',2.39),('15087','2013-03-20','12:00:00',2.36),('15087','2013-03-20','12:05:00',2.56),('15087','2013-03-20','12:10:00',2.12),('15087','2013-03-20','12:15:00',1.81),('15087','2013-03-20','12:20:00',1.61),('15087','2013-03-20','12:25:00',1.33),('15087','2013-03-20','12:30:00',1.09),('15087','2013-03-20','12:35:00',1.45),('15087','2013-03-20','12:45:00',1.13),('15087','2013-03-20','12:50:00',1.6),('15087','2013-03-20','12:55:00',1.95),('15087','2013-03-20','13:00:00',2.04),('15087','2013-03-20','13:05:00',1.53),('15087','2013-03-20','13:10:00',1.5),('15087','2013-03-20','13:15:00',1.23),('15087','2013-03-20','13:20:00',1.32),('15087','2013-03-20','13:25:00',1.41),('15087','2013-03-20','13:30:00',1.52),('15087','2013-03-20','13:35:00',1.46),('15087','2013-03-20','13:40:00',1.91),('15087','2013-03-20','13:45:00',2.22),('15087','2013-03-20','13:50:00',1.86),('15087','2013-03-20','13:55:00',1.74),('15087','2013-03-20','14:00:00',1.72),('15087','2013-03-20','14:05:00',1.4),('15087','2013-03-20','14:10:00',1.32),('15087','2013-03-20','14:15:00',1.89),('15087','2013-03-20','14:20:00',2.31),('15087','2013-03-20','14:25:00',2.11),('15087','2013-03-20','14:30:00',1.81),('15087','2013-03-20','14:35:00',1.42),('15087','2013-03-20','14:40:00',1.13),('15087','2013-03-20','14:45:00',1.09),('15087','2013-03-19','07:35:00',1),('15087','2013-03-19','07:40:00',1.12),('15087','2013-03-19','07:45:00',1.23),('15087','2013-03-19','07:50:00',1.37),('15087','2013-03-19','07:55:00',1.38),('15087','2013-03-19','08:00:00',1.01),('15087','2013-03-19','08:05:00',1.38),('15087','2013-03-19','08:10:00',1.74),('15087','2013-03-19','08:15:00',1.91),('15087','2013-03-19','08:20:00',1.98),('15087','2013-03-19','08:25:00',2.05),('15087','2013-03-19','08:30:00',2.22),('15087','2013-03-19','08:35:00',1.67),('15087','2013-03-19','08:40:00',2.25),('15087','2013-03-19','08:45:00',2.53),('15087','2013-03-19','08:50:00',2.62),('15087','2013-03-19','08:55:00',2.68),('15087','2013-03-19','09:00:00',2.76),('15087','2013-03-19','09:05:00',2.85),('15087','2013-03-19','09:10:00',2.94),('15087','2013-03-19','09:15:00',3.04),('15087','2013-03-19','09:20:00',2.21),('15087','2013-03-19','09:25:00',3.12),('15087','2013-03-19','09:30:00',3.3),('15087','2013-03-19','09:35:00',3.27),('15087','2013-03-19','09:40:00',3.47),('15087','2013-03-19','09:45:00',3.4),('15087','2013-03-19','09:50:00',3.37),('15087','2013-03-19','09:55:00',3.33),('15087','2013-03-19','10:00:00',3.1),('15087','2013-03-19','10:05:00',3.31),('15087','2013-03-19','10:10:00',3.82),('15087','2013-03-19','10:15:00',3.88),('15087','2013-03-19','10:20:00',3.93),('15087','2013-03-19','10:25:00',3.62),('15087','2013-03-19','10:30:00',4.05),('15087','2013-03-19','10:35:00',4.1),('15087','2013-03-19','10:40:00',4.12),('15087','2013-03-19','10:45:00',4.19),('15087','2013-03-19','10:50:00',3.96),('15087','2013-03-19','10:55:00',4.35),('15087','2013-03-19','11:00:00',4.34),('15087','2013-03-19','11:05:00',4.36),('15087','2013-03-19','11:10:00',4.24),('15087','2013-03-19','11:15:00',4.45),('15087','2013-03-19','11:20:00',4.44),('15087','2013-03-19','11:25:00',4.43),('15087','2013-03-19','11:30:00',4.41),('15087','2013-03-19','11:35:00',2.69),('15087','2013-03-19','11:40:00',4.12),('15087','2013-03-19','11:45:00',4.08),('15087','2013-03-19','11:50:00',4.7),('15087','2013-03-19','11:55:00',4.61),('15087','2013-03-19','12:00:00',4.55),('15087','2013-03-19','12:05:00',4.51),('15087','2013-03-19','12:10:00',4.49),('15087','2013-03-19','12:15:00',4.31),('15087','2013-03-19','12:20:00',4.55),('15087','2013-03-19','12:25:00',4.46),('15087','2013-03-19','12:30:00',4.44),('15087','2013-03-19','12:35:00',4.51),('15087','2013-03-19','12:40:00',4.46),('15087','2013-03-19','12:45:00',4.47),('15087','2013-03-19','12:50:00',4.48),('15087','2013-03-19','12:55:00',4.39),('15087','2013-03-19','13:00:00',4.37),('15087','2013-03-19','13:05:00',4.32),('15087','2013-03-19','13:10:00',4.28),('15087','2013-03-19','13:15:00',4.17),('15087','2013-03-19','13:20:00',4.13),('15087','2013-03-19','13:25:00',4.08),('15087','2013-03-19','13:30:00',4.04),('15087','2013-03-19','13:35:00',3.95),('15087','2013-03-19','13:40:00',3.84),('15087','2013-03-19','13:45:00',3.85),('15087','2013-03-19','13:50:00',3.74),('15087','2013-03-19','13:55:00',3.72),('15087','2013-03-19','14:00:00',3.68),('15087','2013-03-19','14:05:00',3.64),('15087','2013-03-19','14:10:00',3.51),('15087','2013-03-19','14:15:00',3.4),('15087','2013-03-19','14:20:00',3.38),('15087','2013-03-19','14:25:00',3.3),('15087','2013-03-19','14:30:00',3.27),('15087','2013-03-19','14:35:00',3.14),('15087','2013-03-19','14:40:00',3.15),('15087','2013-03-19','14:45:00',3.05),('15087','2013-03-19','14:50:00',3),('15087','2013-03-19','14:55:00',2.91),('15087','2013-03-19','15:00:00',2.89),('15087','2013-03-19','15:05:00',2.79),('15087','2013-03-19','15:10:00',2.65),('15087','2013-03-19','15:15:00',2.63),('15087','2013-03-19','15:20:00',2.52),('15087','2013-03-19','15:25:00',2.42),('15087','2013-03-19','15:30:00',2.25),('15087','2013-03-19','15:35:00',2.21),('15087','2013-03-19','15:40:00',2.17),('15087','2013-03-19','15:45:00',2.11),('15087','2013-03-19','15:50:00',2.03),('15087','2013-03-19','15:55:00',1.99),('15087','2013-03-19','16:00:00',1.87),('15087','2013-03-19','16:05:00',1.74),('15087','2013-03-19','16:10:00',1.6),('15087','2013-03-19','16:15:00',1.53),('15087','2013-03-19','16:20:00',1.46),('15087','2013-03-19','16:25:00',1.31),('15087','2013-03-19','16:30:00',1.23),('15087','2013-03-19','16:35:00',1.16),('15087','2013-03-19','16:40:00',1.09),('15087','2013-03-18','09:55:00',1.07),('15087','2013-03-18','10:00:00',1.4),('15087','2013-03-18','10:05:00',1.69),('15087','2013-03-18','10:10:00',1.67),('15087','2013-03-18','10:15:00',1.43),('15087','2013-03-18','10:20:00',1.71),('15087','2013-03-18','10:25:00',2.05),('15087','2013-03-18','10:30:00',1.98),('15087','2013-03-18','10:35:00',1.68),('15087','2013-03-18','10:40:00',1.58),('15087','2013-03-18','10:45:00',1.66),('15087','2013-03-18','10:50:00',1.55),('15087','2013-03-18','10:55:00',1.26),('15087','2013-03-18','11:00:00',1.4),('15087','2013-03-18','11:05:00',1.56),('15087','2013-03-18','11:10:00',1.77),('15087','2013-03-18','11:15:00',1.94),('15087','2013-03-18','11:20:00',1.99),('15087','2013-03-18','11:25:00',2.1),('15087','2013-03-18','11:30:00',2.66),('15087','2013-03-18','11:35:00',2.18),('15087','2013-03-18','11:40:00',1.99),('15087','2013-03-18','11:45:00',1.69),('15087','2013-03-18','11:50:00',1.39),('15087','2013-03-18','11:55:00',1.69),('15087','2013-03-18','12:00:00',1.74),('15087','2013-03-18','12:05:00',3.03),('15087','2013-03-18','12:10:00',2.84),('15087','2013-03-18','12:15:00',3.35),('15087','2013-03-18','12:20:00',3.15),('15087','2013-03-18','12:25:00',2.34),('15087','2013-03-18','12:30:00',3.65),('15087','2013-03-18','12:35:00',4.34),('15087','2013-03-18','12:40:00',3.09),('15087','2013-03-18','12:45:00',2.98),('15087','2013-03-18','12:50:00',3.99),('15087','2013-03-18','12:55:00',4.28),('15087','2013-03-18','13:00:00',3.9),('15087','2013-03-18','13:05:00',1.83),('15087','2013-03-18','13:10:00',1.3),('15087','2013-03-18','13:20:00',1.2),('15087','2013-03-18','13:25:00',2.2),('15087','2013-03-18','13:30:00',1.4),('15087','2013-03-18','13:35:00',1.27),('15087','2013-03-18','13:40:00',2.34),('15087','2013-03-18','13:45:00',2.03),('15087','2013-03-18','13:50:00',1.85),('15087','2013-03-18','13:55:00',1.65),('15087','2013-03-18','14:00:00',1.88),('15087','2013-03-18','14:05:00',2.82),('15087','2013-03-18','14:10:00',2.48),('15087','2013-03-18','14:15:00',1.3),('15087','2013-03-18','14:20:00',1.34),('15087','2013-03-18','14:25:00',1.88),('15087','2013-03-18','14:35:00',1.21),('15087','2013-03-18','14:40:00',1.25),('15087','2013-03-18','14:45:00',1.11),('15087','2013-03-18','15:00:00',1.12),('15087','2013-03-17','08:15:00',1.09),('15087','2013-03-17','08:20:00',1.26),('15087','2013-03-17','08:25:00',1.65),('15087','2013-03-17','08:30:00',1.46),('15087','2013-03-17','08:35:00',1.27),('15087','2013-03-17','08:40:00',1.33),('15087','2013-03-17','08:45:00',1.59),('15087','2013-03-17','08:50:00',1.53),('15087','2013-03-17','08:55:00',1.44),('15087','2013-03-17','09:00:00',1.41),('15087','2013-03-17','09:05:00',1.64),('15087','2013-03-17','09:10:00',1.89),('15087','2013-03-17','09:15:00',2.06),('15087','2013-03-17','09:20:00',1.67),('15087','2013-03-17','09:25:00',1.4),('15087','2013-03-17','09:30:00',1.59),('15087','2013-03-17','09:35:00',1.72),('15087','2013-03-17','09:40:00',1.69),('15087','2013-03-17','09:45:00',1.75),('15087','2013-03-17','09:50:00',1.96),('15087','2013-03-17','09:55:00',2.11),('15087','2013-03-17','10:00:00',2.34),('15087','2013-03-17','10:05:00',1.92),('15087','2013-03-17','10:10:00',1.9),('15087','2013-03-17','10:15:00',2.07),('15087','2013-03-17','10:20:00',2.11),('15087','2013-03-17','10:25:00',2.2),('15087','2013-03-17','10:30:00',2.13),('15087','2013-03-17','10:35:00',2.04),('15087','2013-03-17','10:40:00',1.93),('15087','2013-03-17','10:45:00',2.03),('15087','2013-03-17','10:50:00',1.91),('15087','2013-03-17','10:55:00',1.78),('15087','2013-03-17','11:00:00',1.73),('15087','2013-03-17','11:05:00',1.47),('15087','2013-03-17','11:10:00',1.45),('15087','2013-03-17','11:15:00',1.64),('15087','2013-03-17','11:20:00',1.88),('15087','2013-03-17','11:25:00',1.86),('15087','2013-03-17','11:30:00',1.71),('15087','2013-03-17','11:35:00',1.69),('15087','2013-03-17','11:40:00',1.6),('15087','2013-03-17','11:45:00',1.48),('15087','2013-03-17','11:50:00',1.37),('15087','2013-03-17','11:55:00',1.16),('15087','2013-03-17','12:00:00',1.1),('15087','2013-03-17','12:05:00',1.13),('15087','2013-03-17','12:10:00',1.58),('15087','2013-03-17','12:15:00',2.16),('15087','2013-03-17','12:20:00',2.61),('15087','2013-03-17','12:25:00',3.63),('15087','2013-03-17','12:30:00',3.79),('15087','2013-03-17','12:35:00',2.7),('15087','2013-03-17','12:40:00',2.83),('15087','2013-03-17','12:45:00',2.63),('15087','2013-03-17','12:50:00',2.34),('15087','2013-03-17','12:55:00',1.94),('15087','2013-03-17','13:00:00',2.3),('15087','2013-03-17','13:05:00',2.48),('15087','2013-03-17','13:10:00',2.79),('15087','2013-03-17','13:15:00',2.73),('15087','2013-03-17','13:20:00',2.28),('15087','2013-03-17','13:25:00',2.02),('15087','2013-03-17','13:30:00',2.99),('15087','2013-03-17','13:35:00',2.97),('15087','2013-03-17','13:40:00',2.21),('15087','2013-03-17','13:45:00',1.97),('15087','2013-03-17','13:50:00',1.6),('15087','2013-03-17','13:55:00',2.53),('15087','2013-03-17','14:00:00',2.31),('15087','2013-03-17','14:05:00',2.41),('15087','2013-03-17','14:10:00',2.81),('15087','2013-03-17','14:15:00',2.78),('15087','2013-03-17','14:20:00',2.99),('15087','2013-03-17','14:25:00',2.5),('15087','2013-03-17','14:30:00',2.44),('15087','2013-03-17','14:35:00',2.09),('15087','2013-03-17','14:40:00',1.57),('15087','2013-03-17','14:45:00',1.42),('15087','2013-03-17','14:50:00',1.17),('15087','2013-03-17','14:55:00',1.28),('15087','2013-03-17','15:00:00',1.74),('15087','2013-03-17','15:05:00',1.95),('15087','2013-03-17','15:10:00',2.49),('15087','2013-03-17','15:15:00',2.21),('15087','2013-03-17','15:20:00',2.53),('15087','2013-03-17','15:25:00',2.57),('15087','2013-03-17','15:30:00',1.59),('15087','2013-03-17','15:35:00',2.19),('15087','2013-03-17','15:40:00',1.67),('15087','2013-03-17','15:45:00',1.49),('15087','2013-03-17','16:45:00',1.2),('15087','2013-03-16','08:05:00',1.08),('15087','2013-03-16','08:10:00',1.86),('15087','2013-03-16','08:15:00',2.09),('15087','2013-03-16','08:20:00',2.25),('15087','2013-03-16','08:25:00',2.26),('15087','2013-03-16','08:30:00',2.28),('15087','2013-03-16','08:35:00',2.43),('15087','2013-03-16','08:40:00',2.45),('15087','2013-03-16','08:45:00',2.51),('15087','2013-03-16','08:50:00',2.77),('15087','2013-03-16','08:55:00',2.95),('15087','2013-03-16','09:00:00',2.93),('15087','2013-03-16','09:05:00',3.01),('15087','2013-03-16','09:10:00',2.88),('15087','2013-03-16','09:15:00',3.21),('15087','2013-03-16','09:20:00',2.89),('15087','2013-03-16','09:25:00',1.83),('15087','2013-03-16','09:30:00',2.85),('15087','2013-03-16','09:35:00',3.69),('15087','2013-03-16','09:40:00',2.95),('15087','2013-03-16','09:45:00',3.5),('15087','2013-03-16','09:50:00',3.76),('15087','2013-03-16','09:55:00',3.88),('15087','2013-03-16','10:00:00',3.01),('15087','2013-03-16','10:05:00',2.83),('15087','2013-03-16','10:10:00',3.48),('15087','2013-03-16','10:15:00',2.73),('15087','2013-03-16','10:20:00',2.46),('15087','2013-03-16','10:25:00',2.85),('15087','2013-03-16','10:30:00',2.51),('15087','2013-03-16','10:35:00',3.81),('15087','2013-03-16','10:40:00',4.26),('15087','2013-03-16','10:45:00',4.23),('15087','2013-03-16','10:50:00',4.29),('15087','2013-03-16','10:55:00',4.31),('15087','2013-03-16','11:00:00',4.34),('15087','2013-03-16','11:05:00',4.37),('15087','2013-03-16','11:10:00',4.41),('15087','2013-03-16','11:15:00',4.43),('15087','2013-03-16','11:20:00',4.45),('15087','2013-03-16','11:25:00',4.46),('15087','2013-03-16','11:30:00',4.51),('15087','2013-03-16','11:35:00',4.5),('15087','2013-03-16','11:40:00',4.52),('15087','2013-03-16','11:45:00',4.53),('15087','2013-03-16','11:50:00',4.56),('15087','2013-03-16','11:55:00',4.54),('15087','2013-03-16','12:00:00',4.54),('15087','2013-03-16','12:05:00',4.53),('15087','2013-03-16','12:10:00',4.51),('15087','2013-03-16','12:15:00',4.53),('15087','2013-03-16','12:20:00',4.54),('15087','2013-03-16','12:25:00',4.51),('15087','2013-03-16','12:30:00',4.54),('15087','2013-03-16','12:35:00',4.51),('15087','2013-03-16','12:40:00',4.45),('15087','2013-03-16','12:45:00',4.48),('15087','2013-03-16','12:50:00',4.47),('15087','2013-03-16','12:55:00',4.33),('15087','2013-03-16','13:00:00',3.95),('15087','2013-03-16','13:05:00',4.06),('15087','2013-03-16','13:10:00',4.19),('15087','2013-03-16','13:15:00',4.08),('15087','2013-03-16','13:20:00',4),('15087','2013-03-16','13:25:00',2.05),('15087','2013-03-16','13:30:00',1.95),('15087','2013-03-16','13:35:00',1.11),('15087','2013-03-16','13:40:00',3.55),('15087','2013-03-16','13:45:00',3.2),('15087','2013-03-16','13:50:00',3.46),('15087','2013-03-16','13:55:00',2.86),('15087','2013-03-16','14:00:00',3.17),('15087','2013-03-16','14:05:00',3.12),('15087','2013-03-16','14:15:00',3.61),('15087','2013-03-16','14:20:00',1.26),('15087','2013-03-16','14:25:00',2.6),('15087','2013-03-16','14:30:00',3.59),('15087','2013-03-16','14:35:00',3.09),('15087','2013-03-16','14:40:00',2.45),('15087','2013-03-16','14:45:00',1.21),('15087','2013-03-16','14:55:00',1.11),('15087','2013-03-16','16:00:00',1.72),('15087','2013-03-16','16:05:00',1.8),('15087','2013-03-16','16:10:00',1.77),('15087','2013-03-16','16:15:00',1.75),('15087','2013-03-16','16:20:00',1.01),('15087','2013-03-16','16:55:00',1.04),('15087','2013-03-15','10:35:00',1.15),('15087','2013-03-15','10:40:00',1.3),('15087','2013-03-15','10:45:00',1.52),('15087','2013-03-15','10:50:00',1.54),('15087','2013-03-15','10:55:00',1.67),('15087','2013-03-15','11:00:00',1.65),('15087','2013-03-15','11:05:00',1.4),('15087','2013-03-15','11:10:00',1.41),('15087','2013-03-15','11:15:00',1.17),('15087','2013-03-15','11:20:00',1.38),('15087','2013-03-15','11:25:00',1.72),('15087','2013-03-15','11:30:00',1.9),('15087','2013-03-15','11:35:00',2.42),('15087','2013-03-15','11:40:00',2.54),('15087','2013-03-15','11:45:00',2.5),('15087','2013-03-15','11:50:00',2.22),('15087','2013-03-15','11:55:00',2.33),('15087','2013-03-15','12:00:00',2.11),('15087','2013-03-15','12:05:00',2.02),('15087','2013-03-15','12:10:00',2.19),('15087','2013-03-15','12:15:00',1.93),('15087','2013-03-15','12:20:00',1.87),('15087','2013-03-15','12:25:00',2.01),('15087','2013-03-15','12:30:00',2.09),('15087','2013-03-15','12:35:00',2.38),('15087','2013-03-15','12:40:00',2),('15087','2013-03-15','12:45:00',1.64),('15087','2013-03-15','12:50:00',1.55),('15087','2013-03-15','12:55:00',1.49),('15087','2013-03-15','13:00:00',1.39),('15087','2013-03-15','13:05:00',1.29),('15087','2013-03-15','13:10:00',1.35),('15087','2013-03-15','13:15:00',1.49),('15087','2013-03-15','13:20:00',1.6),('15087','2013-03-15','13:25:00',1.79),('15087','2013-03-15','13:30:00',1.71),('15087','2013-03-15','13:35:00',1.57),('15087','2013-03-15','13:40:00',1.64),('15087','2013-03-15','13:45:00',1.77),('15087','2013-03-15','13:50:00',1.44),('15087','2013-03-15','13:55:00',1.22),('15087','2013-03-15','14:00:00',1.09),('15087','2013-03-15','14:50:00',1.1),('15087','2013-03-15','14:55:00',1.27),('15087','2013-03-15','15:00:00',1.37),('15087','2013-03-15','15:05:00',1.28),('15087','2013-03-15','15:10:00',1.28),('15087','2013-03-15','15:15:00',1.38),('15087','2013-03-15','15:20:00',1.42),('15087','2013-03-15','15:25:00',1.56),('15087','2013-03-15','15:30:00',1.34),('15087','2013-03-15','15:35:00',1.13),('15087','2013-03-14','13:05:00',1.1),('15087','2013-03-14','13:10:00',1.2),('15087','2013-03-14','13:15:00',1.17),('15087','2013-03-14','13:20:00',1.2),('15087','2013-03-14','13:25:00',1.16),('15087','2013-03-14','13:30:00',1.23),('15087','2013-03-14','13:35:00',1.42),('15087','2013-03-14','13:40:00',1.26),('15087','2013-03-14','13:45:00',1.27),('15087','2013-03-14','13:50:00',1.62),('15087','2013-03-14','13:55:00',1.88),('15087','2013-03-14','14:00:00',1.79),('15087','2013-03-14','14:05:00',1.97),('15087','2013-03-14','14:10:00',1.64),('15087','2013-03-14','14:15:00',1.38),('15087','2013-03-14','14:20:00',1.28),('15087','2013-03-14','14:25:00',1.28),('15087','2013-03-14','14:30:00',1.04),('15087','2013-03-14','15:10:00',1.37),('15087','2013-03-14','15:15:00',1.37),('15087','2013-03-14','15:20:00',1.28),('15087','2013-03-14','15:25:00',1.38),('15087','2013-03-14','15:30:00',1.36),('15087','2013-03-14','15:35:00',1.03),('15087','2013-03-13','08:50:00',1.27),('15087','2013-03-13','08:55:00',1.16),('15087','2013-03-13','09:10:00',1.24),('15087','2013-03-13','09:45:00',1.05),('15087','2013-03-13','10:05:00',1.11),('15087','2013-03-13','10:10:00',1.44),('15087','2013-03-13','10:15:00',2.25),('15087','2013-03-13','10:20:00',1.73),('15087','2013-03-13','10:25:00',2.61),('15087','2013-03-13','10:30:00',3.53),('15087','2013-03-13','10:35:00',3.5),('15087','2013-03-13','10:40:00',2.46),('15087','2013-03-13','10:45:00',1.64),('15087','2013-03-13','10:50:00',1.24),('15087','2013-03-13','10:55:00',1.06),('15087','2013-03-13','11:00:00',1.1),('15087','2013-03-13','11:10:00',1.33),('15087','2013-03-13','11:15:00',1.14),('15087','2013-03-13','11:30:00',1.34),('15087','2013-03-13','11:35:00',1.38),('15087','2013-03-13','11:40:00',1.35),('15087','2013-03-13','11:45:00',1.56),('15087','2013-03-13','11:50:00',1.34),('15087','2013-03-13','12:45:00',1.2),('15087','2013-03-13','12:50:00',1.46),('15087','2013-03-13','12:55:00',1.31),('15087','2013-03-13','13:00:00',1.25),('15087','2013-03-13','13:05:00',1.17),('15087','2013-03-13','13:10:00',1.06),('15087','2013-03-13','13:35:00',1.09),('15087','2013-03-12','08:20:00',1.97),('15087','2013-03-12','08:25:00',1.96),('15087','2013-03-12','08:30:00',2.06),('15087','2013-03-12','08:35:00',1.76),('15087','2013-03-12','08:40:00',2.02),('15087','2013-03-12','08:45:00',2.47),('15087','2013-03-12','08:50:00',1.17),('15087','2013-03-12','09:00:00',1.87),('15087','2013-03-12','09:05:00',2.7),('15087','2013-03-12','09:10:00',2.74),('15087','2013-03-12','09:15:00',2.84),('15087','2013-03-12','09:20:00',2.92),('15087','2013-03-12','09:25:00',2.99),('15087','2013-03-12','09:30:00',3.07),('15087','2013-03-12','09:35:00',3.17),('15087','2013-03-12','09:40:00',3.12),('15087','2013-03-12','09:45:00',2.03),('15087','2013-03-12','09:50:00',2.76),('15087','2013-03-12','09:55:00',3.6),('15087','2013-03-12','10:00:00',3.6),('15087','2013-03-12','10:05:00',3.48),('15087','2013-03-12','10:10:00',3.51),('15087','2013-03-12','10:15:00',2.44),('15087','2013-03-12','10:20:00',2.02),('15087','2013-03-12','10:25:00',3.29),('15087','2013-03-12','10:30:00',2.07),('15087','2013-03-12','10:35:00',2.16),('15087','2013-03-12','10:40:00',3.28),('15087','2013-03-12','10:45:00',2.15),('15087','2013-03-12','10:50:00',4.32),('15087','2013-03-12','10:55:00',4.25),('15087','2013-03-12','11:00:00',4.44),('15087','2013-03-12','11:05:00',3.96),('15087','2013-03-12','11:10:00',4.06),('15087','2013-03-12','11:15:00',3.96),('15087','2013-03-12','11:20:00',4.18),('15087','2013-03-12','11:25:00',1.5),('15087','2013-03-12','11:30:00',1.73),('15087','2013-03-12','11:35:00',2.26),('15087','2013-03-12','11:40:00',2.28),('15087','2013-03-12','11:45:00',2.56),('15087','2013-03-12','11:50:00',3),('15087','2013-03-12','11:55:00',3.09),('15087','2013-03-12','12:05:00',1.43),('15087','2013-03-12','12:10:00',4.86),('15087','2013-03-12','12:15:00',2.26),('15087','2013-03-12','12:20:00',2.54),('15087','2013-03-12','12:25:00',3.88),('15087','2013-03-12','12:30:00',5.28),('15087','2013-03-12','12:35:00',3.08),('15087','2013-03-12','12:40:00',3.7),('15087','2013-03-12','12:45:00',1.29),('15087','2013-03-12','12:50:00',1.78),('15087','2013-03-12','12:55:00',2.91),('15087','2013-03-12','13:00:00',4.6),('15087','2013-03-12','13:05:00',2.12),('15087','2013-03-12','13:10:00',3.04),('15087','2013-03-12','13:15:00',2.28),('15087','2013-03-12','13:20:00',3.27),('15087','2013-03-12','13:25:00',2),('15087','2013-03-12','13:30:00',1.62),('15087','2013-03-12','13:35:00',1.96),('15087','2013-03-12','13:40:00',1.61),('15087','2013-03-12','13:45:00',1.36),('15087','2013-03-12','13:50:00',1.3),('15087','2013-03-12','13:55:00',2.21),('15087','2013-03-12','14:00:00',2.85),('15087','2013-03-12','14:05:00',2.4),('15087','2013-03-12','14:10:00',1.66),('15087','2013-03-12','14:15:00',1.22),('15087','2013-03-12','15:00:00',1.07),('15087','2013-03-12','15:20:00',1.06),('15087','2013-03-11','08:10:00',1.39),('15087','2013-03-11','08:15:00',1.64),('15087','2013-03-11','08:20:00',1.73),('15087','2013-03-11','08:25:00',1.84),('15087','2013-03-11','08:30:00',1.96),('15087','2013-03-11','08:35:00',2.05),('15087','2013-03-11','08:40:00',2.13),('15087','2013-03-11','08:45:00',2.24),('15087','2013-03-11','08:50:00',2.36),('15087','2013-03-11','08:55:00',2.43),('15087','2013-03-11','09:00:00',2.52),('15087','2013-03-11','09:05:00',2.56),('15087','2013-03-11','09:10:00',2.67),('15087','2013-03-11','09:15:00',2.77),('15087','2013-03-11','09:20:00',2.38),('15087','2013-03-11','09:25:00',1.62),('15087','2013-03-11','09:35:00',4.08),('15087','2013-03-11','09:40:00',2.51),('15087','2013-03-11','09:45:00',2.6),('15087','2013-03-11','10:10:00',1.2),('15087','2013-03-11','10:15:00',1.21),('15087','2013-03-11','10:20:00',1.35),('15087','2013-03-11','10:25:00',1.5),('15087','2013-03-11','10:30:00',1.4),('15087','2013-03-11','10:35:00',1.68),('15087','2013-03-11','10:40:00',2.28),('15087','2013-03-11','10:45:00',2.7),('15087','2013-03-11','10:50:00',3.68),('15087','2013-03-11','10:55:00',2.04),('15087','2013-03-11','11:00:00',1.71),('15087','2013-03-11','11:05:00',1.36),('15087','2013-03-11','11:10:00',1.48),('15087','2013-03-11','11:15:00',1.54),('15087','2013-03-11','11:20:00',1.32),('15087','2013-03-11','11:25:00',1.27),('15087','2013-03-11','11:30:00',2.1),('15087','2013-03-11','11:35:00',2.01),('15087','2013-03-11','11:40:00',2.08),('15087','2013-03-11','11:45:00',2.67),('15087','2013-03-11','11:50:00',2.54),('15087','2013-03-11','11:55:00',2.18),('15087','2013-03-11','12:00:00',1.98),('15087','2013-03-11','12:05:00',1.96),('15087','2013-03-11','12:10:00',2.43),('15087','2013-03-11','12:30:00',1.09),('15087','2013-03-11','12:35:00',1.65),('15087','2013-03-11','12:40:00',1.26),('15087','2013-03-11','12:45:00',1.45),('15087','2013-03-11','12:50:00',2.58),('15087','2013-03-11','12:55:00',3.14),('15087','2013-03-11','13:00:00',1.91),('15087','2013-03-11','13:05:00',2.07),('15087','2013-03-11','13:10:00',3.55),('15087','2013-03-11','13:15:00',3.59),('15087','2013-03-11','13:20:00',4.33),('15087','2013-03-11','13:25:00',4.14),('15087','2013-03-11','13:30:00',3.84),('15087','2013-03-11','13:35:00',4.01),('15087','2013-03-11','13:40:00',2.5),('15087','2013-03-11','13:45:00',3.69),('15087','2013-03-11','13:50:00',3.4),('15087','2013-03-11','13:55:00',1.69),('15087','2013-03-11','14:20:00',1.42),('15087','2013-03-11','14:25:00',1.68),('15087','2013-03-11','14:30:00',1.28),('15087','2013-03-11','14:35:00',1.01),('15087','2013-03-11','14:40:00',1.78),('15087','2013-03-11','15:25:00',1.56),('15087','2013-03-11','15:30:00',2.64),('15087','2013-03-11','15:35:00',1.52),('15087','2013-03-11','15:40:00',1.91),('15087','2013-03-11','15:45:00',2.66),('15087','2013-03-11','15:50:00',2.08),('15087','2013-03-11','15:55:00',1.73),('15087','2013-03-11','16:00:00',1.69),('15087','2013-03-11','16:05:00',1.51),('15087','2013-03-11','16:10:00',1.66),('15087','2013-03-11','16:15:00',1.19),('15087','2013-03-11','16:20:00',1.3),('15087','2013-03-11','16:25:00',1.23),('15087','2013-03-11','16:30:00',1.24),('15087','2013-03-11','16:35:00',1.04),('15087','2013-03-11','16:40:00',1.14),('15087','2013-03-11','16:45:00',1.2),('15087','2013-03-10','07:55:00',1.22),('15087','2013-03-10','08:00:00',1.34),('15087','2013-03-10','08:05:00',1.46),('15087','2013-03-10','08:10:00',1.37),('15087','2013-03-10','08:15:00',1.53),('15087','2013-03-10','08:20:00',1.75),('15087','2013-03-10','08:25:00',1.85),('15087','2013-03-10','08:30:00',1.93),('15087','2013-03-10','08:35:00',2.01),('15087','2013-03-10','08:40:00',2.1),('15087','2013-03-10','08:45:00',2.19),('15087','2013-03-10','08:50:00',2.26),('15087','2013-03-10','08:55:00',2.37),('15087','2013-03-10','09:00:00',2.47),('15087','2013-03-10','09:05:00',2.54),('15087','2013-03-10','09:10:00',2.62),('15087','2013-03-10','09:15:00',2.7),('15087','2013-03-10','09:20:00',2.77),('15087','2013-03-10','09:25:00',2.85),('15087','2013-03-10','09:30:00',2.95),('15087','2013-03-10','09:35:00',3.03),('15087','2013-03-10','09:40:00',3.17),('15087','2013-03-10','09:45:00',2.33),('15087','2013-03-10','09:50:00',3.46),('15087','2013-03-10','09:55:00',2.75),('15087','2013-03-10','10:00:00',3.63),('15087','2013-03-10','10:05:00',2.24),('15087','2013-03-10','10:10:00',2.96),('15087','2013-03-10','10:15:00',3.5),('15087','2013-03-10','10:20:00',2.65),('15087','2013-03-10','10:25:00',3.67),('15087','2013-03-10','10:30:00',2.89),('15087','2013-03-10','10:35:00',2.37),('15087','2013-03-10','10:40:00',3.57),('15087','2013-03-10','10:45:00',3.93),('15087','2013-03-10','10:50:00',2.19),('15087','2013-03-10','10:55:00',2.04),('15087','2013-03-10','11:00:00',1.72),('15087','2013-03-10','11:05:00',3.17),('15087','2013-03-10','11:10:00',1.91),('15087','2013-03-10','11:15:00',1.73),('15087','2013-03-10','11:20:00',2.34),('15087','2013-03-10','11:25:00',2.45),('15087','2013-03-10','11:30:00',2.13),('15087','2013-03-10','11:35:00',2.65),('15087','2013-03-10','11:40:00',1.3),('15087','2013-03-10','11:45:00',1.43),('15087','2013-03-10','11:50:00',4.02),('15087','2013-03-10','11:55:00',4.3),('15087','2013-03-10','12:00:00',4.26),('15087','2013-03-10','12:05:00',4.15),('15087','2013-03-10','12:10:00',4.21),('15087','2013-03-10','12:15:00',2.5),('15087','2013-03-10','12:20:00',4.37),('15087','2013-03-10','12:25:00',3.66),('15087','2013-03-10','12:30:00',4.1),('15087','2013-03-10','12:35:00',3.55),('15087','2013-03-10','12:40:00',4.31),('15087','2013-03-10','12:45:00',4.39),('15087','2013-03-10','12:50:00',4.25),('15087','2013-03-10','12:55:00',4.15),('15087','2013-03-10','13:00:00',4.01),('15087','2013-03-10','13:05:00',3.96),('15087','2013-03-10','13:10:00',3.73),('15087','2013-03-10','13:15:00',3.88),('15087','2013-03-10','13:20:00',3.85),('15087','2013-03-10','13:25:00',3.83),('15087','2013-03-10','13:30:00',3.56),('15087','2013-03-10','13:35:00',3.36),('15087','2013-03-10','13:40:00',2.16),('15087','2013-03-10','13:45:00',2.36),('15087','2013-03-10','13:50:00',2.05),('15087','2013-03-10','13:55:00',1.9),('15087','2013-03-10','14:00:00',1.54),('15087','2013-03-10','14:05:00',2.12),('15087','2013-03-10','14:10:00',2.2),('15087','2013-03-10','14:15:00',3.07),('15087','2013-03-10','14:20:00',2.91),('15087','2013-03-10','14:25:00',1.73),('15087','2013-03-10','14:30:00',2.61),('15087','2013-03-10','14:35:00',3.08),('15087','2013-03-10','14:40:00',2.57),('15087','2013-03-10','14:45:00',1.74),('15087','2013-03-10','14:50:00',1.75),('15087','2013-03-10','14:55:00',1.52),('15087','2013-03-10','15:00:00',1.19),('15087','2013-03-10','15:05:00',1.45),('15087','2013-03-10','15:10:00',1.37),('15087','2013-03-09','08:00:00',1.31),('15087','2013-03-09','08:05:00',1.41),('15087','2013-03-09','08:10:00',1.51),('15087','2013-03-09','08:15:00',1.58),('15087','2013-03-09','08:20:00',1.67),('15087','2013-03-09','08:25:00',1.78),('15087','2013-03-09','08:30:00',1.88),('15087','2013-03-09','08:35:00',1.92),('15087','2013-03-09','08:40:00',1.98),('15087','2013-03-09','08:45:00',1.99),('15087','2013-03-09','08:50:00',1.83),('15087','2013-03-09','08:55:00',2.03),('15087','2013-03-09','09:00:00',2.01),('15087','2013-03-09','09:05:00',2.09),('15087','2013-03-09','09:20:00',1.87),('15087','2013-03-09','09:25:00',2.08),('15087','2013-03-09','09:30:00',2.52),('15087','2013-03-09','09:35:00',2.6),('15087','2013-03-09','09:40:00',3.09),('15087','2013-03-09','09:45:00',3.91),('15087','2013-03-09','09:50:00',1.69),('15087','2013-03-09','09:55:00',2.94),('15087','2013-03-09','10:05:00',1.19),('15087','2013-03-09','10:10:00',1.04),('15087','2013-03-09','10:15:00',2.06),('15087','2013-03-09','10:20:00',1.05),('15087','2013-03-09','10:35:00',2.13),('15087','2013-03-09','10:40:00',2.87),('15087','2013-03-09','10:45:00',4.39),('15087','2013-03-09','10:50:00',3.97),('15087','2013-03-09','10:55:00',3),('15087','2013-03-09','11:00:00',4.12),('15087','2013-03-09','11:05:00',4.12),('15087','2013-03-09','11:10:00',4.17),('15087','2013-03-09','11:15:00',4.23),('15087','2013-03-09','11:20:00',4.34),('15087','2013-03-09','11:25:00',3.94),('15087','2013-03-09','11:30:00',4.23),('15087','2013-03-09','11:35:00',4.16),('15087','2013-03-09','11:40:00',4.2),('15087','2013-03-09','11:45:00',4.21),('15087','2013-03-09','11:50:00',4.15),('15087','2013-03-09','11:55:00',3.87),('15087','2013-03-09','12:00:00',2.98),('15087','2013-03-09','12:05:00',1.32),('15087','2013-03-09','12:10:00',2.06),('15087','2013-03-09','12:15:00',2.09),('15087','2013-03-09','12:20:00',2.61),('15087','2013-03-09','12:25:00',1.79),('15087','2013-03-09','12:30:00',1.6),('15087','2013-03-09','12:35:00',1.83),('15087','2013-03-09','12:40:00',1.69),('15087','2013-03-09','12:45:00',2.45),('15087','2013-03-09','12:50:00',2.27),('15087','2013-03-09','12:55:00',4.16),('15087','2013-03-09','13:00:00',4.08),('15087','2013-03-09','13:05:00',3.99),('15087','2013-03-09','13:10:00',4.01),('15087','2013-03-09','13:15:00',4.33),('15087','2013-03-09','13:20:00',3.5),('15087','2013-03-09','13:25:00',3.36),('15087','2013-03-09','13:30:00',4.01),('15087','2013-03-09','13:35:00',3.87),('15087','2013-03-09','13:40:00',3.41),('15087','2013-03-09','13:45:00',3.65),('15087','2013-03-09','13:50:00',2.74),('15087','2013-03-09','14:00:00',1.01),('15087','2013-03-09','14:05:00',1.26),('15087','2013-03-09','14:10:00',2.88),('15087','2013-03-09','14:15:00',3.17),('15087','2013-03-09','14:20:00',2.98),('15087','2013-03-09','14:25:00',2.85),('15087','2013-03-09','14:30:00',2.84),('15087','2013-03-09','14:35:00',2.74),('15087','2013-03-09','14:40:00',2.66),('15087','2013-03-09','14:45:00',2.83),('15087','2013-03-09','14:50:00',2.68),('15087','2013-03-09','14:55:00',2.71),('15087','2013-03-09','15:00:00',2.63),('15087','2013-03-09','15:05:00',2.49),('15087','2013-03-09','15:10:00',2.32),('15087','2013-03-09','15:15:00',2.28),('15087','2013-03-09','15:20:00',2.18),('15087','2013-03-09','15:25:00',2.08),('15087','2013-03-09','15:30:00',2.05),('15087','2013-03-09','15:35:00',1.92),('15087','2013-03-09','15:40:00',1.81),('15087','2013-03-09','15:45:00',1.85),('15087','2013-03-09','15:50:00',1.74),('15087','2013-03-09','15:55:00',1.48),('15087','2013-03-09','16:00:00',1.42),('15087','2013-03-09','16:05:00',1.4),('15087','2013-03-09','16:10:00',1.16),('15087','2013-03-09','16:15:00',1.4),('15087','2013-03-09','16:20:00',1.07),('15087','2013-03-09','16:25:00',1.28),('15087','2013-03-09','16:30:00',1.1),('15087','2013-03-08','08:25:00',1.05),('15087','2013-03-08','08:30:00',1.88),('15087','2013-03-08','08:35:00',1.6),('15087','2013-03-08','08:50:00',1),('15087','2013-03-08','09:30:00',2.17),('15087','2013-03-08','09:35:00',1.94),('15087','2013-03-08','09:40:00',1.78),('15087','2013-03-08','09:45:00',1.38),('15087','2013-03-08','09:50:00',1.87),('15087','2013-03-08','09:55:00',1.68),('15087','2013-03-08','10:05:00',1.15),('15087','2013-03-08','10:10:00',1.69),('15087','2013-03-08','10:15:00',1.82),('15087','2013-03-08','10:20:00',1.28),('15087','2013-03-08','10:25:00',1.53),('15087','2013-03-08','10:30:00',1.91),('15087','2013-03-08','10:35:00',2.45),('15087','2013-03-08','10:40:00',1.44),('15087','2013-03-08','10:45:00',1.07),('15087','2013-03-08','10:50:00',1.43),('15087','2013-03-08','10:55:00',1.25),('15087','2013-03-08','11:00:00',1.1),('15087','2013-03-08','11:35:00',1.85),('15087','2013-03-08','11:40:00',2.31),('15087','2013-03-08','11:45:00',1.8),('15087','2013-03-08','11:50:00',1.56),('15087','2013-03-08','11:55:00',2.04),('15087','2013-03-08','12:00:00',2.3),('15087','2013-03-08','12:05:00',1.43),('15087','2013-03-08','12:10:00',1.07),('15087','2013-03-08','12:20:00',1.4),('15087','2013-03-08','12:25:00',1.2),('15087','2013-03-08','12:30:00',1.06),('15087','2013-03-08','12:35:00',1.78),('15087','2013-03-08','12:40:00',2.26),('15087','2013-03-08','12:45:00',2.11),('15087','2013-03-08','12:50:00',2.63),('15087','2013-03-08','12:55:00',2.32),('15087','2013-03-08','13:00:00',2.28),('15087','2013-03-08','13:05:00',2.39),('15087','2013-03-08','13:10:00',1.5),('15087','2013-03-08','13:15:00',1.16),('15087','2013-03-08','13:20:00',1.13),('15087','2013-03-08','13:25:00',1.57),('15087','2013-03-08','13:30:00',2.25),('15087','2013-03-08','13:35:00',1.58),('15087','2013-03-08','13:40:00',1.32),('15087','2013-03-08','17:10:00',1.25),('15087','2013-03-07','08:40:00',1.03),('15087','2013-03-07','08:45:00',1.01),('15087','2013-03-07','08:50:00',1.15),('15087','2013-03-07','10:50:00',1.26),('15087','2013-03-07','10:55:00',1.24),('15087','2013-03-07','11:00:00',1.24),('15087','2013-03-07','11:05:00',1.51),('15087','2013-03-07','11:10:00',1.04),('15087','2013-03-07','11:30:00',2.04),('15087','2013-03-07','11:35:00',2.53),('15087','2013-03-07','11:40:00',2.32),('15087','2013-03-07','11:45:00',2.57),('15087','2013-03-07','11:50:00',2.55),('15087','2013-03-07','11:55:00',1.86),('15087','2013-03-07','12:00:00',1.28),('15087','2013-03-07','12:05:00',1.04),('15087','2013-03-07','12:25:00',1.25),('15087','2013-03-07','12:40:00',1.41),('15087','2013-03-07','12:45:00',2.08),('15087','2013-03-07','12:50:00',1.89),('15087','2013-03-07','12:55:00',1.66),('15087','2013-03-07','13:00:00',1.95),('15087','2013-03-07','13:05:00',1.97),('15087','2013-03-07','13:10:00',1.82),('15087','2013-03-07','13:15:00',2.03),('15087','2013-03-07','13:20:00',2.42),('15087','2013-03-07','13:25:00',2.07),('15087','2013-03-07','13:30:00',1.77),('15087','2013-03-07','13:35:00',1.62),('15087','2013-03-07','14:10:00',1.05),('15087','2013-03-05','08:15:00',1.33),('15087','2013-03-05','08:25:00',1.43),('15087','2013-03-05','08:30:00',2.02),('15087','2013-03-05','08:35:00',1.81),('15087','2013-03-05','08:40:00',1.87),('15087','2013-03-05','08:45:00',1.58),('15087','2013-03-05','08:50:00',1.78),('15087','2013-03-05','08:55:00',1.66),('15087','2013-03-05','09:00:00',1.71),('15087','2013-03-05','09:05:00',1.79),('15087','2013-03-05','09:10:00',1.64),('15087','2013-03-05','09:15:00',1.59),('15087','2013-03-05','09:20:00',1.62),('15087','2013-03-05','09:25:00',1.6),('15087','2013-03-05','09:30:00',1.68),('15087','2013-03-05','09:35:00',1.81),('15087','2013-03-05','09:40:00',1.92),('15087','2013-03-05','09:45:00',1.93),('15087','2013-03-05','09:50:00',1.9),('15087','2013-03-05','09:55:00',1.83),('15087','2013-03-05','10:00:00',1.75),('15087','2013-03-05','10:05:00',1.91),('15087','2013-03-05','10:10:00',1.96),('15087','2013-03-05','10:15:00',2.08),('15087','2013-03-05','10:20:00',2.26),('15087','2013-03-05','10:25:00',2.05),('15087','2013-03-05','10:30:00',2.02),('15087','2013-03-05','10:35:00',2.41),('15087','2013-03-05','10:40:00',2.46),('15087','2013-03-05','10:45:00',2.58),('15087','2013-03-05','10:50:00',2.78),('15087','2013-03-05','10:55:00',2.8),('15087','2013-03-05','11:00:00',2.62),('15087','2013-03-05','11:05:00',2.83),('15087','2013-03-05','11:10:00',2.92),('15087','2013-03-05','11:15:00',2.87),('15087','2013-03-05','11:20:00',2.8),('15087','2013-03-05','11:25:00',2.7),('15087','2013-03-05','11:30:00',2.77),('15087','2013-03-05','11:35:00',3.05),('15087','2013-03-05','11:40:00',3.33),('15087','2013-03-05','11:45:00',3.2),('15087','2013-03-05','11:50:00',3.23),('15087','2013-03-05','11:55:00',3.32),('15087','2013-03-05','12:00:00',3.41),('15087','2013-03-05','12:05:00',3.5),('15087','2013-03-05','12:10:00',3.65),('15087','2013-03-05','12:15:00',2.94),('15087','2013-03-05','12:20:00',3.37),('15087','2013-03-05','12:25:00',3.33),('15087','2013-03-05','12:30:00',2.78),('15087','2013-03-05','12:35:00',2.64),('15087','2013-03-05','12:40:00',2.68),('15087','2013-03-05','12:45:00',2.83),('15087','2013-03-05','12:50:00',2.46),('15087','2013-03-05','12:55:00',2.2),('15087','2013-03-05','13:00:00',1.86),('15087','2013-03-05','13:05:00',1.77),('15087','2013-03-05','13:10:00',1.92),('15087','2013-03-05','13:15:00',2.04),('15087','2013-03-05','13:20:00',1.94),('15087','2013-03-05','13:25:00',1.75),('15087','2013-03-05','13:30:00',1.57),('15087','2013-03-05','13:35:00',1.46),('15087','2013-03-05','13:40:00',1.36),('15087','2013-03-05','13:45:00',1.23),('15087','2013-03-05','13:50:00',1.11),('15087','2013-03-05','13:55:00',1.06),('15087','2013-03-05','14:00:00',1.05),('15087','2013-03-05','14:05:00',1.08),('15087','2013-03-05','14:10:00',1.12),('15087','2013-03-05','14:15:00',1.04),('15087','2013-03-05','14:40:00',1.01),('15087','2013-03-05','14:45:00',1.03),('15087','2013-03-05','14:50:00',1),('15087','2013-03-05','15:45:00',1.17),('15087','2013-03-05','15:50:00',1.13),('15087','2013-03-04','08:00:00',1.13),('15087','2013-03-04','08:05:00',1.24),('15087','2013-03-04','08:10:00',1.35),('15087','2013-03-04','08:15:00',1.45),('15087','2013-03-04','08:20:00',1.55),('15087','2013-03-04','08:25:00',1.65),('15087','2013-03-04','08:30:00',1.75),('15087','2013-03-04','08:35:00',1.85),('15087','2013-03-04','08:40:00',1.94),('15087','2013-03-04','08:45:00',2.02),('15087','2013-03-04','08:50:00',2.12),('15087','2013-03-04','08:55:00',2.2),('15087','2013-03-04','09:00:00',2.27),('15087','2013-03-04','09:05:00',2.36),('15087','2013-03-04','09:10:00',2.45),('15087','2013-03-04','09:15:00',2.52),('15087','2013-03-04','09:20:00',2.59),('15087','2013-03-04','09:25:00',2.66),('15087','2013-03-04','09:30:00',2.75),('15087','2013-03-04','09:35:00',2.83),('15087','2013-03-04','09:40:00',2.88),('15087','2013-03-04','09:45:00',2.96),('15087','2013-03-04','09:50:00',3.01),('15087','2013-03-04','09:55:00',3.11),('15087','2013-03-04','10:00:00',3.09),('15087','2013-03-04','10:05:00',3.23),('15087','2013-03-04','10:10:00',3.27),('15087','2013-03-04','10:15:00',3.31),('15087','2013-03-04','10:20:00',3.37),('15087','2013-03-04','10:25:00',3.43),('15087','2013-03-04','10:30:00',3.46),('15087','2013-03-04','10:35:00',3.49),('15087','2013-03-04','10:40:00',3.52),('15087','2013-03-04','10:45:00',3.56),('15087','2013-03-04','10:50:00',3.6),('15087','2013-03-04','10:55:00',3.64),('15087','2013-03-04','11:00:00',3.7),('15087','2013-03-04','11:05:00',3.76),('15087','2013-03-04','11:10:00',3.77),('15087','2013-03-04','11:15:00',3.78),('15087','2013-03-04','11:20:00',3.8),('15087','2013-03-04','11:25:00',3.83),('15087','2013-03-04','11:30:00',3.83),('15087','2013-03-04','11:35:00',3.85),('15087','2013-03-04','11:40:00',3.89),('15087','2013-03-04','11:45:00',3.88),('15087','2013-03-04','11:50:00',3.88),('15087','2013-03-04','11:55:00',3.89),('15087','2013-03-04','12:00:00',3.91),('15087','2013-03-04','12:05:00',3.94),('15087','2013-03-04','12:10:00',3.96),('15087','2013-03-04','12:15:00',3.97),('15087','2013-03-04','12:20:00',3.92),('15087','2013-03-04','12:25:00',3.95),('15087','2013-03-04','12:30:00',3.96),('15087','2013-03-04','12:35:00',3.96),('15087','2013-03-04','12:40:00',3.94),('15087','2013-03-04','12:45:00',3.89),('15087','2013-03-04','12:50:00',3.84),('15087','2013-03-04','12:55:00',3.79),('15087','2013-03-04','13:00:00',3.69),('15087','2013-03-04','13:05:00',3.68),('15087','2013-03-04','13:10:00',3.49),('15087','2013-03-04','13:15:00',3.28),('15087','2013-03-04','13:20:00',3.52),('15087','2013-03-04','13:25:00',3.09),('15087','2013-03-04','13:30:00',3.01),('15087','2013-03-04','13:35:00',3.57),('15087','2013-03-04','13:40:00',3.2),('15087','2013-03-04','13:45:00',2.83),('15087','2013-03-04','13:50:00',3.16),('15087','2013-03-04','13:55:00',3.06),('15087','2013-03-04','14:00:00',3.08),('15087','2013-03-04','14:05:00',3.05),('15087','2013-03-04','14:10:00',2.76),('15087','2013-03-04','14:15:00',2.65),('15087','2013-03-04','14:20:00',2.75),('15087','2013-03-04','14:25:00',2.7),('15087','2013-03-04','14:30:00',2.6),('15087','2013-03-04','14:35:00',2.68),('15087','2013-03-04','14:40:00',2.65),('15087','2013-03-04','14:45:00',2.49),('15087','2013-03-04','14:50:00',2.42),('15087','2013-03-04','14:55:00',2.33),('15087','2013-03-04','15:00:00',2.1),('15087','2013-03-04','15:05:00',2.2),('15087','2013-03-04','15:10:00',2.16),('15087','2013-03-04','15:15:00',1.94),('15087','2013-03-04','15:20:00',1.98),('15087','2013-03-04','15:25:00',1.87),('15087','2013-03-04','15:30:00',1.72),('15087','2013-03-04','15:35:00',1.79),('15087','2013-03-04','15:40:00',1.7),('15087','2013-03-04','15:45:00',1.61),('15087','2013-03-04','15:50:00',1.56),('15087','2013-03-04','15:55:00',1.42),('15087','2013-03-04','16:00:00',1.35),('15087','2013-03-04','16:05:00',1.3),('15087','2013-03-04','16:10:00',1.22),('15087','2013-03-04','16:15:00',1.11),('15087','2013-03-04','16:20:00',1.04),('15087','2013-03-04','16:25:00',1.01),('15087','2013-03-03','08:00:00',1.01),('15087','2013-03-03','08:05:00',1.24),('15087','2013-03-03','08:10:00',1.35),('15087','2013-03-03','08:15:00',1.47),('15087','2013-03-03','08:20:00',1.54),('15087','2013-03-03','08:25:00',1.68),('15087','2013-03-03','08:30:00',1.78),('15087','2013-03-03','08:35:00',1.88),('15087','2013-03-03','08:40:00',1.99),('15087','2013-03-03','08:45:00',2.08),('15087','2013-03-03','08:50:00',2.18),('15087','2013-03-03','08:55:00',2.26),('15087','2013-03-03','09:00:00',2.35),('15087','2013-03-03','09:05:00',2.44),('15087','2013-03-03','09:10:00',2.53),('15087','2013-03-03','09:15:00',2.61),('15087','2013-03-03','09:20:00',2.68),('15087','2013-03-03','09:25:00',2.78),('15087','2013-03-03','09:30:00',2.85),('15087','2013-03-03','09:35:00',2.9),('15087','2013-03-03','09:40:00',2.98),('15087','2013-03-03','09:45:00',3.06),('15087','2013-03-03','09:50:00',3.15),('15087','2013-03-03','09:55:00',3.25),('15087','2013-03-03','10:00:00',3.34),('15087','2013-03-03','10:05:00',3.39),('15087','2013-03-03','10:10:00',3.45),('15087','2013-03-03','10:15:00',3.52),('15087','2013-03-03','10:20:00',3.57),('15087','2013-03-03','10:25:00',3.63),('15087','2013-03-03','10:30:00',3.68),('15087','2013-03-03','10:35:00',3.7),('15087','2013-03-03','10:40:00',3.76),('15087','2013-03-03','10:45:00',3.8),('15087','2013-03-03','10:50:00',3.84),('15087','2013-03-03','10:55:00',3.88),('15087','2013-03-03','11:00:00',3.91),('15087','2013-03-03','11:05:00',3.9),('15087','2013-03-03','11:10:00',3.93),('15087','2013-03-03','11:15:00',3.94),('15087','2013-03-03','11:20:00',3.96),('15087','2013-03-03','11:25:00',3.97),('15087','2013-03-03','11:30:00',4.03),('15087','2013-03-03','11:35:00',4.05),('15087','2013-03-03','11:40:00',4.02),('15087','2013-03-03','11:45:00',4.03),('15087','2013-03-03','11:50:00',4.05),('15087','2013-03-03','11:55:00',4.05),('15087','2013-03-03','12:00:00',4.07),('15087','2013-03-03','12:05:00',4.07),('15087','2013-03-03','12:10:00',4.07),('15087','2013-03-03','12:15:00',4.05),('15087','2013-03-03','12:20:00',4.03),('15087','2013-03-03','12:25:00',4.03),('15087','2013-03-03','12:30:00',4.05),('15087','2013-03-03','12:35:00',4.06),('15087','2013-03-03','12:40:00',4.06),('15087','2013-03-03','12:45:00',4.06),('15087','2013-03-03','12:50:00',4),('15087','2013-03-03','12:55:00',4),('15087','2013-03-03','13:00:00',3.93),('15087','2013-03-03','13:05:00',3.87),('15087','2013-03-03','13:10:00',3.86),('15087','2013-03-03','13:15:00',3.83),('15087','2013-03-03','13:20:00',3.72),('15087','2013-03-03','13:25:00',3.76),('15087','2013-03-03','13:30:00',3.7),('15087','2013-03-03','13:35:00',3.5),('15087','2013-03-03','13:40:00',3.56),('15087','2013-03-03','13:45:00',3.48),('15087','2013-03-03','13:50:00',3.34),('15087','2013-03-03','13:55:00',3.33),('15087','2013-03-03','14:00:00',3.27),('15087','2013-03-03','14:05:00',3.13),('15087','2013-03-03','14:10:00',3.1),('15087','2013-03-03','14:15:00',2.99),('15087','2013-03-03','14:20:00',2.86),('15087','2013-03-03','14:25:00',2.99),('15087','2013-03-03','14:30:00',2.79),('15087','2013-03-03','14:35:00',2.79),('15087','2013-03-03','14:40:00',2.82),('15087','2013-03-03','14:45:00',2.68),('15087','2013-03-03','14:50:00',2.54),('15087','2013-03-03','14:55:00',2.58),('15087','2013-03-03','15:00:00',2.52),('15087','2013-03-03','15:05:00',2.4),('15087','2013-03-03','15:10:00',2.31),('15087','2013-03-03','15:15:00',2.27),('15087','2013-03-03','15:20:00',2.16),('15087','2013-03-03','15:25:00',2.13),('15087','2013-03-03','15:30:00',2.05),('15087','2013-03-03','15:35:00',1.96),('15087','2013-03-03','15:40:00',1.87),('15087','2013-03-03','15:45:00',1.75),('15087','2013-03-03','15:50:00',1.61),('15087','2013-03-03','15:55:00',1.53),('15087','2013-03-03','16:00:00',1.42),('15087','2013-03-03','16:05:00',1.35),('15087','2013-03-03','16:10:00',1.27),('15087','2013-03-03','16:15:00',1.15),('15087','2013-03-03','16:20:00',1.08),('15087','2013-03-03','16:25:00',1.04),('15087','2013-03-02','10:40:00',1.02),('15087','2013-03-02','10:45:00',1.02),('15087','2013-03-02','10:50:00',1.18),('15087','2013-03-02','10:55:00',1.23),('15087','2013-03-02','11:00:00',1.33),('15087','2013-03-02','11:05:00',1.41),('15087','2013-03-02','11:10:00',1.46),('15087','2013-03-02','11:15:00',1.68),('15087','2013-03-02','11:20:00',1.48),('15087','2013-03-02','11:25:00',1.29),('15087','2013-03-02','11:30:00',1.16),('15087','2013-03-02','11:35:00',1.19),('15087','2013-03-02','11:40:00',1.4),('15087','2013-03-02','11:45:00',1.26),('15087','2013-03-02','11:50:00',1.3),('15087','2013-03-02','11:55:00',1.18),('15087','2013-03-02','12:00:00',1.14),('15087','2013-03-02','12:05:00',1.36),('15087','2013-03-02','12:10:00',1.33),('15087','2013-03-02','12:15:00',1.41),('15087','2013-03-02','12:20:00',1.31),('15087','2013-03-02','12:25:00',1.38),('15087','2013-03-02','12:30:00',1.54),('15087','2013-03-02','12:35:00',1.63),('15087','2013-03-02','12:40:00',1.88),('15087','2013-03-02','12:45:00',1.83),('15087','2013-03-02','12:50:00',1.61),('15087','2013-03-02','12:55:00',1.95),('15087','2013-03-02','13:00:00',1.76),('15087','2013-03-02','13:05:00',1.6),('15087','2013-03-02','13:10:00',1.11),('15087','2013-03-02','13:30:00',1.02),('15087','2013-03-02','13:35:00',1.04),('15087','2013-03-02','13:40:00',1.13),('15087','2013-03-02','13:45:00',1.26),('15087','2013-03-02','13:50:00',1.21),('15087','2013-03-02','13:55:00',1.27),('15087','2013-03-02','14:00:00',1.43),('15087','2013-03-02','14:05:00',1.36),('15087','2013-03-02','14:10:00',1.19),('15087','2013-03-02','14:15:00',1.05),('15087','2013-03-02','14:20:00',1),('15087','2013-03-01','08:10:00',1.01),('15087','2013-03-01','08:15:00',1.12),('15087','2013-03-01','08:20:00',1.19),('15087','2013-03-01','08:25:00',1.18),('15087','2013-03-01','08:30:00',1.31),('15087','2013-03-01','08:35:00',1.41),('15087','2013-03-01','08:40:00',1.52),('15087','2013-03-01','08:45:00',1.6),('15087','2013-03-01','08:50:00',1.7),('15087','2013-03-01','08:55:00',1.82),('15087','2013-03-01','09:00:00',1.95),('15087','2013-03-01','09:05:00',2.11),('15087','2013-03-01','09:10:00',2.09),('15087','2013-03-01','09:15:00',2.14),('15087','2013-03-01','09:20:00',2.19),('15087','2013-03-01','09:25:00',2.21),('15087','2013-03-01','09:30:00',2.41),('15087','2013-03-01','09:35:00',2.35),('15087','2013-03-01','09:40:00',2.54),('15087','2013-03-01','09:45:00',2.67),('15087','2013-03-01','09:50:00',2.66),('15087','2013-03-01','09:55:00',2.64),('15087','2013-03-01','10:00:00',2.7),('15087','2013-03-01','10:05:00',2.68),('15087','2013-03-01','10:10:00',2.59),('15087','2013-03-01','10:15:00',2.27),('15087','2013-03-01','10:20:00',2.26),('15087','2013-03-01','10:25:00',2.4),('15087','2013-03-01','10:30:00',2.76),('15087','2013-03-01','10:35:00',2.84),('15087','2013-03-01','10:40:00',2.54),('15087','2013-03-01','10:45:00',2.43),('15087','2013-03-01','10:50:00',2.31),('15087','2013-03-01','10:55:00',2.17),('15087','2013-03-01','11:00:00',1.88),('15087','2013-03-01','11:05:00',1.69),('15087','2013-03-01','11:10:00',1.67),('15087','2013-03-01','11:15:00',1.88),('15087','2013-03-01','11:20:00',1.94),('15087','2013-03-01','11:25:00',1.93),('15087','2013-03-01','11:30:00',1.98),('15087','2013-03-01','11:35:00',1.98),('15087','2013-03-01','11:40:00',1.88),('15087','2013-03-01','11:45:00',1.8),('15087','2013-03-01','11:50:00',1.76),('15087','2013-03-01','11:55:00',1.69),('15087','2013-03-01','12:00:00',1.62),('15087','2013-03-01','12:05:00',1.53),('15087','2013-03-01','12:10:00',1.42),('15087','2013-03-01','12:15:00',1.28),('15087','2013-03-01','12:20:00',1.17),('15087','2013-03-01','12:25:00',1.18),('15087','2013-03-01','12:30:00',1.23),('15087','2013-03-01','12:35:00',1.22),('15087','2013-03-01','12:40:00',1.18),('15087','2013-03-01','12:45:00',1.17),('15087','2013-03-01','12:50:00',1.23),('15087','2013-03-01','12:55:00',1.32),('15087','2013-03-01','13:00:00',1.4),('15087','2013-03-01','13:05:00',1.41),('15087','2013-03-01','13:10:00',1.47),('15087','2013-03-01','13:15:00',1.57),('15087','2013-03-01','13:20:00',1.71),('15087','2013-03-01','13:25:00',1.86),('15087','2013-03-01','13:30:00',1.78),('15087','2013-03-01','13:35:00',1.66),('15087','2013-03-01','13:40:00',1.58),('15087','2013-03-01','13:45:00',1.58),('15087','2013-03-01','13:50:00',1.56),('15087','2013-03-01','13:55:00',1.49),('15087','2013-03-01','14:00:00',1.45),('15087','2013-03-01','14:05:00',1.38),('15087','2013-03-01','14:10:00',1.27),('15087','2013-03-01','14:15:00',1.16),('15087','2013-03-01','14:20:00',1.12),('15087','2013-03-01','14:25:00',1.14),('15087','2013-03-01','14:30:00',1.16),('15087','2013-03-01','14:35:00',1.17),('15087','2013-03-01','14:40:00',1.08),('15087','2013-03-01','14:45:00',1.03),('15087','2013-02-28','08:10:00',1.13),('15087','2013-02-28','08:15:00',1.23),('15087','2013-02-28','08:20:00',1.34),('15087','2013-02-28','08:25:00',1.42),('15087','2013-02-28','08:30:00',1.53),('15087','2013-02-28','08:35:00',1.63),('15087','2013-02-28','08:40:00',1.72),('15087','2013-02-28','08:45:00',1.82),('15087','2013-02-28','08:50:00',1.94),('15087','2013-02-28','08:55:00',2.06),('15087','2013-02-28','09:00:00',2.15),('15087','2013-02-28','09:05:00',2.23),('15087','2013-02-28','09:10:00',2.26),('15087','2013-02-28','09:15:00',2.34),('15087','2013-02-28','09:20:00',2.44),('15087','2013-02-28','09:25:00',2.48),('15087','2013-02-28','09:30:00',2.55),('15087','2013-02-28','09:35:00',2.63),('15087','2013-02-28','09:40:00',2.68),('15087','2013-02-28','09:45:00',2.79),('15087','2013-02-28','09:50:00',2.64),('15087','2013-02-28','09:55:00',2.84),('15087','2013-02-28','10:00:00',2.95),('15087','2013-02-28','10:05:00',3.02),('15087','2013-02-28','10:10:00',3.06),('15087','2013-02-28','10:15:00',3.09),('15087','2013-02-28','10:20:00',3.15),('15087','2013-02-28','10:25:00',3.21),('15087','2013-02-28','10:30:00',3.2),('15087','2013-02-28','10:35:00',3.24),('15087','2013-02-28','10:40:00',3.29),('15087','2013-02-28','10:45:00',3.36),('15087','2013-02-28','10:50:00',3.44),('15087','2013-02-28','10:55:00',3.41),('15087','2013-02-28','11:00:00',3.54),('15087','2013-02-28','11:05:00',3.61),('15087','2013-02-28','11:10:00',3.62),('15087','2013-02-28','11:15:00',3.63),('15087','2013-02-28','11:20:00',3.67),('15087','2013-02-28','11:25:00',3.73),('15087','2013-02-28','11:30:00',3.77),('15087','2013-02-28','11:35:00',3.7),('15087','2013-02-28','11:40:00',3.71),('15087','2013-02-28','11:45:00',3.63),('15087','2013-02-28','11:50:00',3.55),('15087','2013-02-28','11:55:00',3.63),('15087','2013-02-28','12:00:00',3.7),('15087','2013-02-28','12:05:00',3.71),('15087','2013-02-28','12:10:00',3.66),('15087','2013-02-28','12:15:00',3.72),('15087','2013-02-28','12:20:00',3.82),('15087','2013-02-28','12:25:00',3.8),('15087','2013-02-28','12:30:00',3.81),('15087','2013-02-28','12:35:00',3.84),('15087','2013-02-28','12:40:00',3.79),('15087','2013-02-28','12:45:00',3.68),('15087','2013-02-28','12:50:00',3.69),('15087','2013-02-28','12:55:00',3.73),('15087','2013-02-28','13:00:00',3.45),('15087','2013-02-28','13:05:00',3.67),('15087','2013-02-28','13:10:00',3.58),('15087','2013-02-28','13:15:00',3.37),('15087','2013-02-28','13:20:00',3.13),('15087','2013-02-28','13:25:00',3.08),('15087','2013-02-28','13:30:00',3.44),('15087','2013-02-28','13:35:00',3.4),('15087','2013-02-28','13:40:00',3.42),('15087','2013-02-28','13:45:00',3.29),('15087','2013-02-28','13:50:00',3.17),('15087','2013-02-28','13:55:00',3.25),('15087','2013-02-28','14:00:00',3.29),('15087','2013-02-28','14:05:00',3.24),('15087','2013-02-28','14:10:00',3.12),('15087','2013-02-28','14:15:00',3.02),('15087','2013-02-28','14:20:00',2.93),('15087','2013-02-28','14:25:00',2.77),('15087','2013-02-28','14:30:00',2.62),('15087','2013-02-28','14:35:00',2.39),('15087','2013-02-28','14:40:00',2.59),('15087','2013-02-28','14:45:00',2.34),('15087','2013-02-28','14:50:00',2.16),('15087','2013-02-28','14:55:00',2.05),('15087','2013-02-28','15:00:00',2.26),('15087','2013-02-28','15:05:00',2),('15087','2013-02-28','15:10:00',1.9),('15087','2013-02-28','15:15:00',2.06),('15087','2013-02-28','15:20:00',1.92),('15087','2013-02-28','15:25:00',1.73),('15087','2013-02-28','15:30:00',1.72),('15087','2013-02-28','15:35:00',1.6),('15087','2013-02-28','15:40:00',1.53),('15087','2013-02-28','15:45:00',1.55),('15087','2013-02-28','15:50:00',1.45),('15087','2013-02-28','15:55:00',1.37),('15087','2013-02-28','16:00:00',1.28),('15087','2013-02-28','16:05:00',1.18),('15087','2013-02-28','16:10:00',1.06),('15087','2013-02-28','16:15:00',1.01),('15087','2013-02-27','08:15:00',1.16),('15087','2013-02-27','08:20:00',1.28),('15087','2013-02-27','08:25:00',1.38),('15087','2013-02-27','08:30:00',1.48),('15087','2013-02-27','08:35:00',1.57),('15087','2013-02-27','08:40:00',1.66),('15087','2013-02-27','08:45:00',1.73),('15087','2013-02-27','08:50:00',1.82),('15087','2013-02-27','08:55:00',1.91),('15087','2013-02-27','09:00:00',2),('15087','2013-02-27','09:05:00',2.1),('15087','2013-02-27','09:10:00',2.18),('15087','2013-02-27','09:15:00',2.27),('15087','2013-02-27','09:20:00',2.34),('15087','2013-02-27','09:25:00',2.43),('15087','2013-02-27','09:30:00',2.49),('15087','2013-02-27','09:35:00',2.58),('15087','2013-02-27','09:40:00',2.63),('15087','2013-02-27','09:45:00',2.71),('15087','2013-02-27','09:50:00',2.78),('15087','2013-02-27','09:55:00',2.88),('15087','2013-02-27','10:00:00',2.93),('15087','2013-02-27','10:05:00',2.99),('15087','2013-02-27','10:10:00',3.05),('15087','2013-02-27','10:15:00',3.1),('15087','2013-02-27','10:20:00',3.17),('15087','2013-02-27','10:25:00',3.22),('15087','2013-02-27','10:30:00',3.25),('15087','2013-02-27','10:35:00',3.33),('15087','2013-02-27','10:40:00',3.29),('15087','2013-02-27','10:45:00',3.34),('15087','2013-02-27','10:50:00',3.43),('15087','2013-02-27','10:55:00',3.43),('15087','2013-02-27','11:00:00',3.51),('15087','2013-02-27','11:05:00',3.51),('15087','2013-02-27','11:10:00',3.59),('15087','2013-02-27','11:15:00',3.63),('15087','2013-02-27','11:20:00',3.52),('15087','2013-02-27','11:25:00',2.23),('15087','2013-02-27','11:30:00',1.97),('15087','2013-02-27','11:35:00',2.8),('15087','2013-02-27','11:45:00',2.23),('15087','2013-02-27','11:50:00',1.96),('15087','2013-02-27','11:55:00',4.14),('15087','2013-02-27','12:00:00',3.91),('15087','2013-02-27','12:05:00',3.15),('15087','2013-02-27','12:15:00',3.61),('15087','2013-02-27','12:20:00',4.09),('15087','2013-02-27','12:25:00',3.86),('15087','2013-02-27','12:30:00',3.91),('15087','2013-02-27','12:35:00',3.95),('15087','2013-02-27','12:40:00',3.94),('15087','2013-02-27','12:45:00',3.94),('15087','2013-02-27','12:50:00',3.8),('15087','2013-02-27','12:55:00',3.77),('15087','2013-02-27','13:00:00',3.65),('15087','2013-02-27','13:05:00',3.77),('15087','2013-02-27','13:10:00',3.54),('15087','2013-02-27','13:15:00',3.54),('15087','2013-02-27','13:20:00',3.68),('15087','2013-02-27','13:25:00',3.59),('15087','2013-02-27','13:30:00',3.46),('15087','2013-02-27','13:35:00',3.55),('15087','2013-02-27','13:40:00',3.45),('15087','2013-02-27','13:45:00',3.31),('15087','2013-02-27','13:50:00',3.35),('15087','2013-02-27','13:55:00',3.24),('15087','2013-02-27','14:00:00',3.02),('15087','2013-02-27','14:05:00',2.62),('15087','2013-02-27','14:10:00',1.74),('15087','2013-02-27','14:15:00',2.64),('15087','2013-02-27','14:20:00',2.47),('15087','2013-02-27','14:25:00',1.62),('15087','2013-02-27','14:30:00',2.04),('15087','2013-02-27','14:35:00',2.5),('15087','2013-02-27','14:40:00',2.49),('15087','2013-02-27','14:45:00',2.54),('15087','2013-02-27','14:50:00',2.21),('15087','2013-02-27','14:55:00',2.19),('15087','2013-02-27','15:00:00',2.34),('15087','2013-02-27','15:05:00',2.39),('15087','2013-02-27','15:10:00',2.1),('15087','2013-02-27','15:15:00',2.04),('15087','2013-02-27','15:20:00',1.85),('15087','2013-02-27','15:25:00',1.78),('15087','2013-02-27','15:30:00',1.8),('15087','2013-02-27','15:35:00',1.75),('15087','2013-02-27','15:40:00',1.69),('15087','2013-02-27','15:45:00',1.58),('15087','2013-02-27','15:50:00',1.55),('15087','2013-02-27','15:55:00',1.45),('15087','2013-02-27','16:00:00',1.34),('15087','2013-02-27','16:05:00',1.25),('15087','2013-02-27','16:10:00',1.15),('15087','2013-02-27','16:15:00',1.07),('15087','2013-02-26','09:15:00',1.02),('15087','2013-02-26','09:20:00',1.09),('15087','2013-02-26','09:25:00',1.18),('15087','2013-02-26','09:30:00',1.4),('15087','2013-02-26','09:35:00',1.79),('15087','2013-02-26','09:40:00',1.99),('15087','2013-02-26','09:45:00',2),('15087','2013-02-26','09:50:00',2.06),('15087','2013-02-26','09:55:00',2.29),('15087','2013-02-26','10:00:00',2.2),('15087','2013-02-26','10:05:00',2.17),('15087','2013-02-26','10:10:00',2.48),('15087','2013-02-26','10:15:00',2.7),('15087','2013-02-26','10:20:00',3.29),('15087','2013-02-26','10:25:00',3.36),('15087','2013-02-26','10:30:00',3.24),('15087','2013-02-26','10:35:00',2.81),('15087','2013-02-26','10:40:00',2.15),('15087','2013-02-26','10:45:00',1.68),('15087','2013-02-26','10:50:00',1.95),('15087','2013-02-26','10:55:00',1.92),('15087','2013-02-26','11:00:00',2.29),('15087','2013-02-26','11:05:00',2.7),('15087','2013-02-26','11:10:00',2.58),('15087','2013-02-26','11:15:00',1.98),('15087','2013-02-26','11:20:00',1.95),('15087','2013-02-26','11:25:00',1.89),('15087','2013-02-26','11:30:00',1.73),('15087','2013-02-26','11:35:00',1.62),('15087','2013-02-26','11:40:00',1.66),('15087','2013-02-26','11:45:00',1.72),('15087','2013-02-26','11:50:00',1.86),('15087','2013-02-26','11:55:00',2.12),('15087','2013-02-26','12:00:00',1.77),('15087','2013-02-26','12:05:00',1.72),('15087','2013-02-26','12:10:00',1.77),('15087','2013-02-26','12:15:00',1.6),('15087','2013-02-26','12:20:00',1.62),('15087','2013-02-26','12:25:00',1.5),('15087','2013-02-26','12:30:00',1.47),('15087','2013-02-26','12:35:00',1.35),('15087','2013-02-26','12:40:00',1.23),('15087','2013-02-26','12:45:00',1.08),('15087','2013-02-26','12:55:00',1.08),('15087','2013-02-26','13:00:00',1.15),('15087','2013-02-26','13:25:00',1.01),('15087','2013-02-26','13:30:00',1.03),('15087','2013-02-26','13:35:00',1.05),('15087','2013-02-26','13:40:00',1.08),('15087','2013-02-26','13:45:00',1.01),('15087','2013-02-25','08:40:00',1.18),('15087','2013-02-25','08:45:00',1.14),('15087','2013-02-25','08:50:00',1.04),('15087','2013-02-25','09:00:00',1.19),('15087','2013-02-25','09:20:00',1.12),('15087','2013-02-25','09:25:00',1.52),('15087','2013-02-25','09:30:00',1.66),('15087','2013-02-25','09:35:00',1.57),('15087','2013-02-25','09:40:00',1.16),('15087','2013-02-25','10:45:00',1.93),('15087','2013-02-25','10:50:00',3.57),('15087','2013-02-25','10:55:00',4.82),('15087','2013-02-25','11:00:00',4.13),('15087','2013-02-25','11:05:00',2.24),('15087','2013-02-25','11:10:00',2.47),('15087','2013-02-25','11:15:00',2.32),('15087','2013-02-25','11:20:00',1.37),('15087','2013-02-25','11:25:00',1.41),('15087','2013-02-25','11:30:00',1.71),('15087','2013-02-25','11:35:00',1.52),('15087','2013-02-25','11:40:00',1.95),('15087','2013-02-25','11:45:00',2.08),('15087','2013-02-25','11:50:00',3.12),('15087','2013-02-25','11:55:00',5.12),('15087','2013-02-25','12:00:00',3.35),('15087','2013-02-25','12:05:00',2.62),('15087','2013-02-25','12:10:00',2.19),('15087','2013-02-25','12:15:00',2.31),('15087','2013-02-25','12:20:00',4.38),('15087','2013-02-25','12:25:00',4.65),('15087','2013-02-25','12:30:00',3.45),('15087','2013-02-25','12:35:00',3.14),('15087','2013-02-25','12:40:00',4.37),('15087','2013-02-25','12:45:00',3.4),('15087','2013-02-25','12:50:00',4),('15087','2013-02-25','12:55:00',3.72),('15087','2013-02-25','13:00:00',2.09),('15087','2013-02-25','13:05:00',2.56),('15087','2013-02-25','13:10:00',1.65),('15087','2013-02-25','13:15:00',2.64),('15087','2013-02-25','13:20:00',2.01),('15087','2013-02-25','13:25:00',1.74),('15087','2013-02-25','13:30:00',1.82),('15087','2013-02-25','13:35:00',1.75),('15087','2013-02-25','13:40:00',1.39),('15087','2013-02-25','13:45:00',1.09),('15087','2013-02-24','10:45:00',1.07),('15087','2013-02-24','10:50:00',1.63),('15087','2013-02-24','10:55:00',1.47),('15087','2013-02-24','11:00:00',1.13),('15087','2013-02-24','11:05:00',1.03),('15087','2013-02-24','11:30:00',1.03),('15087','2013-02-24','12:35:00',1.03),('15087','2013-02-24','12:40:00',1.21),('15087','2013-02-24','12:45:00',1.33),('15087','2013-02-24','12:50:00',1.06),('15087','2013-02-24','12:55:00',1.02),('15087','2013-02-24','13:00:00',1.33),('15087','2013-02-24','13:05:00',1.62),('15087','2013-02-24','13:10:00',1.64),('15087','2013-02-24','13:15:00',1.45),('15087','2013-02-24','13:20:00',1.66),('15087','2013-02-24','13:30:00',1.25),('15087','2013-02-24','13:35:00',1.47),('15087','2013-02-24','13:40:00',1.26),('15087','2013-02-24','13:45:00',1.38),('15087','2013-02-24','13:50:00',1.09),('15087','2013-02-24','13:55:00',1.03),('15087','2013-02-24','14:00:00',1.11),('15087','2013-02-24','14:05:00',2.04),('15087','2013-02-24','14:10:00',1.54),('15087','2013-02-24','14:15:00',1.16),('15087','2013-02-24','14:20:00',1.01),('15087','2013-02-24','14:30:00',1.25),('15087','2013-02-24','14:35:00',1.25),('15087','2013-02-24','15:10:00',2.39),('15087','2013-02-24','15:20:00',1.5),('15087','2013-02-24','15:25:00',1.46),('15087','2013-02-24','15:30:00',1.53),('15087','2013-02-24','15:35:00',1.41),('15087','2013-02-24','15:40:00',1.1),('15087','2013-02-24','15:45:00',1.51),('15087','2013-02-24','15:55:00',1.61),('15087','2013-02-24','16:00:00',1.54),('15087','2013-02-23','08:00:00',1.05),('15087','2013-02-23','08:05:00',1.2),('15087','2013-02-23','08:10:00',1.31),('15087','2013-02-23','08:15:00',1.79),('15087','2013-02-23','08:20:00',1),('15087','2013-02-23','08:55:00',1.11),('15087','2013-02-23','09:00:00',1.52),('15087','2013-02-23','09:05:00',1.39),('15087','2013-02-23','09:10:00',1.03),('15087','2013-02-23','09:40:00',1.06),('15087','2013-02-23','09:45:00',1.49),('15087','2013-02-23','09:50:00',1.51),('15087','2013-02-23','09:55:00',1.47),('15087','2013-02-23','10:00:00',1.12),('15087','2013-02-23','10:05:00',1.04),('15087','2013-02-23','10:25:00',1.14),('15087','2013-02-23','10:30:00',1.08),('15087','2013-02-23','10:50:00',1.02),('15087','2013-02-23','13:55:00',1.03),('15087','2013-02-23','14:00:00',1.08),('15087','2013-02-23','14:05:00',1.96),('15087','2013-02-23','14:10:00',1.4),('15087','2013-02-22','12:55:00',1.04),('15087','2013-02-22','14:35:00',1.51),('15087','2013-02-22','14:40:00',1.51),('15087','2013-02-22','14:45:00',1.07),('15087','2013-02-22','14:50:00',1.24),('15087','2013-02-22','14:55:00',1.35),('15087','2013-02-22','16:20:00',1.35),('15087','2013-02-22','16:25:00',1.35),('15087','2013-02-22','16:30:00',1.04),('15087','2013-02-21','11:35:00',1.04),('15087','2013-02-21','11:40:00',1.02),('15087','2013-02-21','11:45:00',1.1),('15087','2013-02-21','11:50:00',1.24),('15087','2013-02-21','11:55:00',1.29),('15087','2013-02-21','12:00:00',1.23),('15087','2013-02-21','12:05:00',1.28),('15087','2013-02-21','12:10:00',1.31),('15087','2013-02-21','12:15:00',1.41),('15087','2013-02-21','12:20:00',1.51),('15087','2013-02-21','12:25:00',1.45),('15087','2013-02-21','12:30:00',1.35),('15087','2013-02-21','12:35:00',1.29),('15087','2013-02-21','12:40:00',1.25),('15087','2013-02-21','12:45:00',1.25),('15087','2013-02-21','12:50:00',1.28),('15087','2013-02-21','12:55:00',1.39),('15087','2013-02-21','13:00:00',1.38),('15087','2013-02-21','13:05:00',1.26),('15087','2013-02-21','13:10:00',1.18),('15087','2013-02-21','13:15:00',1.24),('15087','2013-02-21','13:20:00',1.34),('15087','2013-02-21','13:25:00',1.38),('15087','2013-02-21','13:30:00',1.38),('15087','2013-02-21','13:35:00',1.39),('15087','2013-02-21','13:40:00',1.31),('15087','2013-02-21','13:45:00',1.23),('15087','2013-02-21','13:50:00',1.27),('15087','2013-02-21','13:55:00',1.26),('15087','2013-02-21','14:00:00',1.26),('15087','2013-02-21','14:05:00',1.19),('15087','2013-02-21','14:10:00',1.07),('15087','2013-02-21','16:05:00',1),('15087','2013-02-21','16:20:00',1.3),('15087','2013-02-21','16:25:00',1.36),('15087','2013-02-21','16:30:00',1.24),('15087','2013-02-21','16:35:00',1.04),('15087','2014-03-23','08:35:00',1.05),('15087','2014-03-23','08:50:00',1.26),('15087','2014-03-23','08:55:00',1.63),('15087','2014-03-23','09:00:00',1),('15087','2014-03-23','09:05:00',1.92),('15087','2014-03-23','09:10:00',2.89),('15087','2014-03-23','09:15:00',2.68),('15087','2014-03-23','09:20:00',1.88),('15087','2014-03-23','09:25:00',1.08),('15087','2014-03-23','09:30:00',1.53),('15087','2014-03-23','09:35:00',1.59),('15087','2014-03-23','09:40:00',1.39),('15087','2014-03-23','10:25:00',1.25),('15087','2014-03-23','10:40:00',1.29),('15087','2014-03-23','10:45:00',1.17),('15087','2014-03-23','10:50:00',1.34),('15087','2014-03-23','10:55:00',1.83),('15087','2014-03-23','11:00:00',1.31),('15087','2014-03-23','11:05:00',1.07),('15087','2014-03-23','11:10:00',1.41),('15087','2014-03-23','11:25:00',1.05),('15087','2014-03-23','11:35:00',1.79),('15087','2014-03-23','11:40:00',3.7),('15087','2014-03-23','13:40:00',1.09),('15087','2014-03-23','13:45:00',2.39),('15087','2014-03-23','13:50:00',1.72),('15087','2014-03-23','13:55:00',1.34),('15087','2014-03-23','15:05:00',1.06),('15087','2014-03-23','15:10:00',1.37),('15087','2014-03-23','15:15:00',1.76),('15087','2014-03-23','15:20:00',1.73),('15087','2014-03-23','15:25:00',1.78),('15087','2014-03-23','15:30:00',1.26),('15087','2013-02-20','08:20:00',1.09),('15087','2013-02-20','08:25:00',1.33),('15087','2013-02-20','08:30:00',1.4),('15087','2013-02-20','08:35:00',1.51),('15087','2013-02-20','08:40:00',1.61),('15087','2013-02-20','08:45:00',1.71),('15087','2013-02-20','08:50:00',1.8),('15087','2013-02-20','08:55:00',1.82),('15087','2013-02-20','09:00:00',1.85),('15087','2013-02-20','09:05:00',1.15),('15087','2013-02-20','09:10:00',1.59),('15087','2013-02-20','09:15:00',1.87),('15087','2013-02-20','09:20:00',1.97),('15087','2013-02-20','09:25:00',2.47),('15087','2013-02-20','09:30:00',1.76),('15087','2013-02-20','09:35:00',2.01),('15087','2013-02-20','09:40:00',1.06),('15087','2013-02-20','09:45:00',1.31),('15087','2013-02-20','09:50:00',2.05),('15087','2013-02-20','09:55:00',1.92),('15087','2013-02-20','10:00:00',1.7),('15087','2013-02-20','10:05:00',2.49),('15087','2013-02-20','10:10:00',1.7),('15087','2013-02-20','10:45:00',2.76),('15087','2013-02-20','10:50:00',2.62),('15087','2013-02-20','10:55:00',1.27),('15087','2013-02-20','11:05:00',2.8),('15087','2013-02-20','11:10:00',4.2),('15087','2013-02-20','11:15:00',3.41),('15087','2013-02-20','11:20:00',3.28),('15087','2013-02-20','11:25:00',1.91),('15087','2013-02-20','11:30:00',1.32),('15087','2013-02-20','11:35:00',3.99),('15087','2013-02-20','11:40:00',3.99),('15087','2013-02-20','11:45:00',4.49),('15087','2013-02-20','11:50:00',3.95),('15087','2013-02-20','11:55:00',4.03),('15087','2013-02-20','12:00:00',1.43),('15087','2013-02-20','12:05:00',1.09),('15087','2013-02-20','12:10:00',2.63),('15087','2013-02-20','12:15:00',3.88),('15087','2013-02-20','12:20:00',2.06),('15087','2013-02-20','12:25:00',4.74),('15087','2013-02-20','12:30:00',4.68),('15087','2013-02-20','12:35:00',1.91),('15087','2013-02-20','12:45:00',1.08),('15087','2013-02-20','12:50:00',1.27),('15087','2013-02-20','12:55:00',2.34),('15087','2013-02-20','13:00:00',3.2),('15087','2013-02-20','13:05:00',2.91),('15087','2013-02-20','13:10:00',3.94),('15087','2013-02-20','13:15:00',3.78),('15087','2013-02-20','13:20:00',2.19),('15087','2013-02-20','13:25:00',1.45),('15087','2013-02-20','13:30:00',2.08),('15087','2013-02-20','13:35:00',1.54),('15087','2013-02-20','13:40:00',1.88),('15087','2013-02-20','13:45:00',1.44),('15087','2013-02-20','13:50:00',1.23),('15087','2013-02-20','13:55:00',1.98),('15087','2013-02-20','14:00:00',1.37),('15087','2013-02-20','14:35:00',1.04),('15087','2013-02-20','14:40:00',1.5),('15087','2013-02-20','14:45:00',1.25),('15087','2013-02-20','15:05:00',1.45),('15087','2013-02-20','15:10:00',2.24),('15087','2013-02-20','15:15:00',2.57),('15087','2013-02-20','15:20:00',2.23),('15087','2013-02-20','15:25:00',2.21),('15087','2013-02-20','15:30:00',1.75),('15087','2013-02-20','16:05:00',1.49),('15087','2013-02-20','16:10:00',1.58),('15087','2013-02-20','16:15:00',1.48),('15087','2013-02-20','16:20:00',1.24),('15087','2013-02-20','16:25:00',1.01),('15087','2013-02-19','08:15:00',1.08),('15087','2013-02-19','08:20:00',1.06),('15087','2013-02-19','08:25:00',1.29),('15087','2013-02-19','08:30:00',1.4),('15087','2013-02-19','08:35:00',1.48),('15087','2013-02-19','08:40:00',1.58),('15087','2013-02-19','08:45:00',1.67),('15087','2013-02-19','08:50:00',1.77),('15087','2013-02-19','08:55:00',1.84),('15087','2013-02-19','09:00:00',1.91),('15087','2013-02-19','09:05:00',2),('15087','2013-02-19','09:10:00',2.09),('15087','2013-02-19','09:15:00',2.18),('15087','2013-02-19','09:20:00',2.27),('15087','2013-02-19','09:25:00',2.36),('15087','2013-02-19','09:30:00',2.43),('15087','2013-02-19','09:35:00',2.49),('15087','2013-02-19','09:40:00',2.55),('15087','2013-02-19','09:45:00',2.64),('15087','2013-02-19','09:50:00',2.7),('15087','2013-02-19','09:55:00',2.77),('15087','2013-02-19','10:00:00',2.84),('15087','2013-02-19','10:05:00',2.89),('15087','2013-02-19','10:10:00',2.96),('15087','2013-02-19','10:15:00',3.03),('15087','2013-02-19','10:20:00',3.08),('15087','2013-02-19','10:25:00',3.12),('15087','2013-02-19','10:30:00',3.17),('15087','2013-02-19','10:35:00',3.24),('15087','2013-02-19','10:40:00',3.27),('15087','2013-02-19','10:45:00',3.29),('15087','2013-02-19','10:50:00',3.34),('15087','2013-02-19','10:55:00',3.38),('15087','2013-02-19','11:00:00',3.44),('15087','2013-02-19','11:05:00',3.46),('15087','2013-02-19','11:10:00',3.52),('15087','2013-02-19','11:15:00',3.57),('15087','2013-02-19','11:20:00',3.56),('15087','2013-02-19','11:25:00',3.58),('15087','2013-02-19','11:30:00',3.61),('15087','2013-02-19','11:35:00',3.65),('15087','2013-02-19','11:40:00',3.66),('15087','2013-02-19','11:45:00',3.66),('15087','2013-02-19','11:50:00',3.7),('15087','2013-02-19','11:55:00',3.66),('15087','2013-02-19','12:00:00',3.64),('15087','2013-02-19','12:05:00',3.68),('15087','2013-02-19','12:10:00',3.67),('15087','2013-02-19','12:15:00',3.67),('15087','2013-02-19','12:20:00',3.68),('15087','2013-02-19','12:25:00',3.64),('15087','2013-02-19','12:30:00',3.63),('15087','2013-02-19','12:35:00',3.7),('15087','2013-02-19','12:40:00',3.64),('15087','2013-02-19','12:45:00',3.69),('15087','2013-02-19','12:50:00',3.65),('15087','2013-02-19','12:55:00',3.58),('15087','2013-02-19','13:00:00',3.62),('15087','2013-02-19','13:05:00',3.56),('15087','2013-02-19','13:10:00',3.47),('15087','2013-02-19','13:15:00',3.51),('15087','2013-02-19','13:20:00',3.46),('15087','2013-02-19','13:25:00',3.33),('15087','2013-02-19','13:30:00',3.32),('15087','2013-02-19','13:35:00',3.28),('15087','2013-02-19','13:40:00',3.18),('15087','2013-02-19','13:45:00',3.13),('15087','2013-02-19','13:50:00',3.04),('15087','2013-02-19','13:55:00',2.93),('15087','2013-02-19','14:00:00',2.88),('15087','2013-02-19','14:05:00',2.84),('15087','2013-02-19','14:10:00',2.77),('15087','2013-02-19','14:15:00',2.7),('15087','2013-02-19','14:20:00',2.57),('15087','2013-02-19','14:25:00',2.53),('15087','2013-02-19','14:30:00',2.49),('15087','2013-02-19','14:35:00',2.4),('15087','2013-02-19','14:40:00',2.34),('15087','2013-02-19','14:45:00',2.29),('15087','2013-02-19','14:50:00',2.05),('15087','2013-02-19','14:55:00',2.1),('15087','2013-02-19','15:00:00',2.12),('15087','2013-02-19','15:05:00',2.01),('15087','2013-02-19','15:10:00',1.99),('15087','2013-02-19','15:15:00',1.92),('15087','2013-02-19','15:20:00',1.84),('15087','2013-02-19','15:25:00',1.86),('15087','2013-02-19','15:30:00',1.7),('15087','2013-02-19','15:35:00',1.62),('15087','2013-02-19','15:40:00',1.55),('15087','2013-02-19','15:45:00',1.43),('15087','2013-02-19','15:50:00',1.34),('15087','2013-02-19','15:55:00',1.25),('15087','2013-02-19','16:00:00',1.17),('15087','2013-02-19','16:05:00',1.09),('15087','2013-02-19','16:10:00',1),('15087','2013-02-18','08:15:00',1),('15087','2013-02-18','08:20:00',1.11),('15087','2013-02-18','08:25:00',1.06),('15087','2013-02-18','08:30:00',1.31),('15087','2013-02-18','08:35:00',1.41),('15087','2013-02-18','08:40:00',1.48),('15087','2013-02-18','08:45:00',1.56),('15087','2013-02-18','08:50:00',1.66),('15087','2013-02-18','08:55:00',1.74),('15087','2013-02-18','09:00:00',1.83),('15087','2013-02-18','09:05:00',1.92),('15087','2013-02-18','09:10:00',2),('15087','2013-02-18','09:15:00',2.12),('15087','2013-02-18','09:20:00',2.21),('15087','2013-02-18','09:25:00',2.58),('15087','2013-02-18','09:30:00',1.56),('15087','2013-02-18','09:35:00',1.28),('15087','2013-02-18','09:45:00',1.15),('15087','2013-02-18','09:50:00',1.44),('15087','2013-02-18','09:55:00',1.06),('15087','2013-02-18','10:05:00',1.09),('15087','2013-02-18','10:55:00',1.03),('15087','2013-02-18','11:00:00',1.29),('15087','2013-02-18','11:05:00',1.34),('15087','2013-02-18','11:10:00',1.46),('15087','2013-02-18','11:15:00',1.27),('15087','2013-02-18','11:20:00',1.62),('15087','2013-02-18','11:25:00',1.62),('15087','2013-02-18','11:30:00',1.53),('15087','2013-02-18','11:35:00',1.62),('15087','2013-02-18','11:40:00',1.57),('15087','2013-02-18','11:45:00',1.44),('15087','2013-02-18','11:50:00',1.57),('15087','2013-02-18','11:55:00',2),('15087','2013-02-18','12:00:00',2.05),('15087','2013-02-18','12:05:00',1.76),('15087','2013-02-18','12:10:00',1.61),('15087','2013-02-18','12:15:00',1.56),('15087','2013-02-18','12:20:00',1.53),('15087','2013-02-18','12:25:00',1.58),('15087','2013-02-18','12:30:00',1.44),('15087','2013-02-18','12:35:00',1.35),('15087','2013-02-18','12:40:00',1.42),('15087','2013-02-18','12:45:00',1.71),('15087','2013-02-18','12:50:00',1.69),('15087','2013-02-18','12:55:00',1.56),('15087','2013-02-18','13:00:00',1.57),('15087','2013-02-18','13:05:00',1.6),('15087','2013-02-18','13:10:00',1.55),('15087','2013-02-18','13:15:00',1.93),('15087','2013-02-18','13:20:00',1.56),('15087','2013-02-18','13:25:00',1.84),('15087','2013-02-18','13:30:00',1.62),('15087','2013-02-18','13:35:00',1.39),('15087','2013-02-18','13:40:00',1.37),('15087','2013-02-18','13:45:00',1.24),('15087','2013-02-18','13:50:00',1.27),('15087','2013-02-18','13:55:00',1.57),('15087','2013-02-18','14:00:00',1.59),('15087','2013-02-18','14:05:00',1.47),('15087','2013-02-18','14:10:00',1.23),('15087','2013-02-18','14:15:00',1.05),('15087','2013-02-18','14:20:00',1.12),('15087','2013-02-17','08:25:00',1.08),('15087','2013-02-17','08:30:00',1.27),('15087','2013-02-17','08:35:00',1.43),('15087','2013-02-17','08:40:00',1.55),('15087','2013-02-17','08:45:00',1.56),('15087','2013-02-17','08:50:00',1.32),('15087','2013-02-17','08:55:00',1.66),('15087','2013-02-17','09:00:00',1.76),('15087','2013-02-17','09:05:00',1.71),('15087','2013-02-17','09:10:00',1.88),('15087','2013-02-17','09:15:00',2.03),('15087','2013-02-17','09:20:00',2.11),('15087','2013-02-17','09:25:00',2.18),('15087','2013-02-17','09:30:00',2.23),('15087','2013-02-17','09:35:00',2.3),('15087','2013-02-17','09:40:00',2.39),('15087','2013-02-17','09:45:00',2.46),('15087','2013-02-17','09:50:00',2.54),('15087','2013-02-17','09:55:00',2.61),('15087','2013-02-17','10:00:00',2.66),('15087','2013-02-17','10:05:00',2.72),('15087','2013-02-17','10:10:00',2.81),('15087','2013-02-17','10:15:00',2.87),('15087','2013-02-17','10:20:00',2.89),('15087','2013-02-17','10:25:00',2.94),('15087','2013-02-17','10:30:00',3.02),('15087','2013-02-17','10:35:00',3.09),('15087','2013-02-17','10:40:00',3.1),('15087','2013-02-17','10:45:00',3.17),('15087','2013-02-17','10:50:00',3.19),('15087','2013-02-17','10:55:00',3.24),('15087','2013-02-17','11:00:00',3.27),('15087','2013-02-17','11:05:00',3.28),('15087','2013-02-17','11:10:00',3.34),('15087','2013-02-17','11:15:00',3.39),('15087','2013-02-17','11:20:00',3.44),('15087','2013-02-17','11:25:00',3.45),('15087','2013-02-17','11:30:00',3.46),('15087','2013-02-17','11:35:00',3.47),('15087','2013-02-17','11:40:00',3.48),('15087','2013-02-17','11:45:00',3.51),('15087','2013-02-17','11:50:00',3.56),('15087','2013-02-17','11:55:00',3.58),('15087','2013-02-17','12:00:00',3.58),('15087','2013-02-17','12:05:00',3.58),('15087','2013-02-17','12:10:00',3.6),('15087','2013-02-17','12:15:00',3.59),('15087','2013-02-17','12:20:00',3.58),('15087','2013-02-17','12:25:00',3.57),('15087','2013-02-17','12:30:00',3.57),('15087','2013-02-17','12:35:00',3.53),('15087','2013-02-17','12:40:00',3.48),('15087','2013-02-17','12:45:00',3.48),('15087','2013-02-17','12:50:00',3.49),('15087','2013-02-17','12:55:00',3.22),('15087','2013-02-17','13:00:00',3.43),('15087','2013-02-17','13:05:00',3.34),('15087','2013-02-17','13:10:00',3.05),('15087','2013-02-17','13:15:00',3.22),('15087','2013-02-17','13:20:00',1.1),('15087','2013-02-17','13:25:00',1.04),('15087','2013-02-17','13:30:00',2.35),('15087','2013-02-17','13:35:00',2.45),('15087','2013-02-17','13:40:00',2.57),('15087','2013-02-17','13:45:00',2.56),('15087','2013-02-17','13:50:00',1.8),('15087','2013-02-17','13:55:00',1.82),('15087','2013-02-17','14:05:00',1.67),('15087','2013-02-17','14:10:00',2.57),('15087','2013-02-17','14:15:00',1.26),('15087','2013-02-17','14:20:00',1.09),('15087','2013-02-17','14:25:00',1.95),('15087','2013-02-17','14:30:00',2.53),('15087','2013-02-17','14:35:00',2.4),('15087','2013-02-17','14:40:00',1.82),('15087','2013-02-17','15:00:00',1.82),('15087','2013-02-17','15:05:00',1.85),('15087','2013-02-17','15:10:00',2.19),('15087','2013-02-17','15:15:00',2.26),('15087','2013-02-17','15:20:00',2.2),('15087','2013-02-17','15:25:00',1.97),('15087','2013-02-17','15:30:00',1.88),('15087','2013-02-17','15:35:00',1.87),('15087','2013-02-17','15:40:00',1.75),('15087','2013-02-17','15:45:00',1.56),('15087','2013-02-17','15:50:00',1.5),('15087','2013-02-17','15:55:00',1.38),('15087','2013-02-17','16:00:00',1.29),('15087','2013-02-17','16:05:00',1.15),('15087','2013-02-17','16:25:00',1.15),('15087','2013-02-17','16:30:00',1.09),('15087','2013-02-16','08:30:00',1.07),('15087','2013-02-16','08:35:00',1.17),('15087','2013-02-16','08:40:00',1.26),('15087','2013-02-16','08:45:00',1.28),('15087','2013-02-16','09:05:00',1.44),('15087','2013-02-16','09:15:00',1.91),('15087','2013-02-16','09:20:00',2.14),('15087','2013-02-16','09:25:00',2.18),('15087','2013-02-16','09:30:00',2.23),('15087','2013-02-16','09:35:00',2.3),('15087','2013-02-16','09:40:00',2.34),('15087','2013-02-16','09:45:00',2.43),('15087','2013-02-16','09:50:00',2.54),('15087','2013-02-16','09:55:00',2.61),('15087','2013-02-16','10:00:00',2.68),('15087','2013-02-16','10:05:00',2.74),('15087','2013-02-16','10:10:00',2.85),('15087','2013-02-16','10:15:00',2.89),('15087','2013-02-16','10:20:00',2.96),('15087','2013-02-16','10:25:00',3),('15087','2013-02-16','10:30:00',3.05),('15087','2013-02-16','10:35:00',3.04),('15087','2013-02-16','10:41:00',2.87),('15087','2013-02-16','10:45:00',3.37),('15087','2013-02-16','10:50:00',3.27),('15087','2013-02-16','10:55:00',3.12),('15087','2013-02-16','11:00:00',3.42),('15087','2013-02-16','11:05:00',3.44),('15087','2013-02-16','11:10:00',3.38),('15087','2013-02-16','11:15:00',3.44),('15087','2013-02-16','11:20:00',3.37),('15087','2013-02-16','11:25:00',3.42),('15087','2013-02-16','11:30:00',3.56),('15087','2013-02-16','11:35:00',3.58),('15087','2013-02-16','11:40:00',3.6),('15087','2013-02-16','11:45:00',3.61),('15087','2013-02-16','11:50:00',3.66),('15087','2013-02-16','11:55:00',3.69),('15087','2013-02-16','12:00:00',3.67),('15087','2013-02-16','12:05:00',3.69),('15087','2013-02-16','12:10:00',3.66),('15087','2013-02-16','12:15:00',3.66),('15087','2013-02-16','12:20:00',3.64),('15087','2013-02-16','12:25:00',3.65),('15087','2013-02-16','12:30:00',3.66),('15087','2013-02-16','12:35:00',3.66),('15087','2013-02-16','12:40:00',3.64),('15087','2013-02-16','12:45:00',3.66),('15087','2013-02-16','12:50:00',3.65),('15087','2013-02-16','12:55:00',3.57),('15087','2013-02-16','13:00:00',3.56),('15087','2013-02-16','13:05:00',3.51),('15087','2013-02-16','13:10:00',3.42),('15087','2013-02-16','13:15:00',3.45),('15087','2013-02-16','13:20:00',3.33),('15087','2013-02-16','13:25:00',3.32),('15087','2013-02-16','13:30:00',3.26),('15087','2013-02-16','13:35:00',3.25),('15087','2013-02-16','13:40:00',3.1),('15087','2013-02-16','13:45:00',3.13),('15087','2013-02-16','13:50:00',3.11),('15087','2013-02-16','13:55:00',2.91),('15087','2013-02-16','14:00:00',2.89),('15087','2013-02-16','14:05:00',2.81),('15087','2013-02-16','14:10:00',2.57),('15087','2013-02-16','14:15:00',2.65),('15087','2013-02-16','14:20:00',2.2),('15087','2013-02-16','14:25:00',1.66),('15087','2013-02-16','14:45:00',1.06),('15087','2013-02-16','14:50:00',1.07),('15087','2013-02-16','14:55:00',1.14),('15087','2013-02-16','15:20:00',1.08),('15087','2013-02-16','15:25:00',1.25),('15087','2013-02-16','15:30:00',1.99),('15087','2013-02-16','15:35:00',2.03),('15087','2013-02-16','15:40:00',1.9),('15087','2013-02-16','15:45:00',1.3),('15087','2013-02-16','15:50:00',1.62),('15087','2013-02-16','15:55:00',1.44),('15087','2013-02-16','16:05:00',1.07),('15087','2013-02-15','09:20:00',1.5),('15087','2013-02-15','09:25:00',1.61),('15087','2013-02-15','09:30:00',1.09),('15087','2013-02-15','09:35:00',1.06),('15087','2013-02-15','09:40:00',1.01),('15087','2013-02-15','09:50:00',1.34),('15087','2013-02-15','09:55:00',1.53),('15087','2013-02-15','10:00:00',1.91),('15087','2013-02-15','10:05:00',1.77),('15087','2013-02-15','10:10:00',1.17),('15087','2013-02-15','10:15:00',1.3),('15087','2013-02-15','10:20:00',1.72),('15087','2013-02-15','10:25:00',2.21),('15087','2013-02-15','10:30:00',2.13),('15087','2013-02-15','10:35:00',2.97),('15087','2013-02-15','10:40:00',2.9),('15087','2013-02-15','10:45:00',2.91),('15087','2013-02-15','10:50:00',2.55),('15087','2013-02-15','10:55:00',1.84),('15087','2013-02-15','11:00:00',1.9),('15087','2013-02-15','11:05:00',2.18),('15087','2013-02-15','11:10:00',2.09),('15087','2013-02-15','11:15:00',3.05),('15087','2013-02-15','11:20:00',3.31),('15087','2013-02-15','11:25:00',3.5),('15087','2013-02-15','11:30:00',3.43),('15087','2013-02-15','11:35:00',2.35),('15087','2013-02-15','11:40:00',2.07),('15087','2013-02-15','11:45:00',2.77),('15087','2013-02-15','11:50:00',4.01),('15087','2013-02-15','11:55:00',3.29),('15087','2013-02-15','12:00:00',3.14),('15087','2013-02-15','12:05:00',3.07),('15087','2013-02-15','12:10:00',3.18),('15087','2013-02-15','12:15:00',3.64),('15087','2013-02-15','12:20:00',4.03),('15087','2013-02-15','12:25:00',3.66),('15087','2013-02-15','12:30:00',3.74),('15087','2013-02-15','12:35:00',3.68),('15087','2013-02-15','12:40:00',3.63),('15087','2013-02-15','12:45:00',3.66),('15087','2013-02-15','12:50:00',3.61),('15087','2013-02-15','12:55:00',3.58),('15087','2013-02-15','13:00:00',3.53),('15087','2013-02-15','13:05:00',3.47),('15087','2013-02-15','13:10:00',3.31),('15087','2013-02-15','13:15:00',3.42),('15087','2013-02-15','13:20:00',3.15),('15087','2013-02-15','13:25:00',2.85),('15087','2013-02-15','13:30:00',2.16),('15087','2013-02-15','13:35:00',2.33),('15087','2013-02-15','13:40:00',2.95),('15087','2013-02-15','13:45:00',2.46),('15087','2013-02-15','13:50:00',2.34),('15087','2013-02-15','13:55:00',2.43),('15087','2013-02-15','14:00:00',2.04),('15087','2013-02-15','14:05:00',3.11),('15087','2013-02-15','14:10:00',3.04),('15087','2013-02-15','14:15:00',2.13),('15087','2013-02-15','14:20:00',2.17),('15087','2013-02-15','14:25:00',1.6),('15087','2013-02-15','14:30:00',1.49),('15087','2013-02-15','14:35:00',2.32),('15087','2013-02-15','14:40:00',2.51),('15087','2013-02-15','14:45:00',1.87),('15087','2013-02-15','14:50:00',1.21),('15087','2013-02-15','14:55:00',1.13),('15087','2013-02-15','15:00:00',1.71),('15087','2013-02-15','15:05:00',1.15),('15087','2013-02-15','15:10:00',1.28),('15087','2013-02-15','15:15:00',1.46),('15087','2013-02-15','15:20:00',1.19),('15087','2013-02-15','15:25:00',1.4),('15087','2013-02-15','15:30:00',1.5),('15087','2013-02-15','15:35:00',1.26),('15087','2013-02-15','15:40:00',1.27),('15087','2013-02-15','15:45:00',1.13),('15087','2013-02-14','08:30:00',1.11),('15087','2013-02-14','08:35:00',1.22),('15087','2013-02-14','08:40:00',1.31),('15087','2013-02-14','08:45:00',1.41),('15087','2013-02-14','08:50:00',1.52),('15087','2013-02-14','08:55:00',1.62),('15087','2013-02-14','09:00:00',1.71),('15087','2013-02-14','09:05:00',1.79),('15087','2013-02-14','09:10:00',1.87),('15087','2013-02-14','09:15:00',1.97),('15087','2013-02-14','09:20:00',2.09),('15087','2013-02-14','09:25:00',2.19),('15087','2013-02-14','09:30:00',2.26),('15087','2013-02-14','09:35:00',2.35),('15087','2013-02-14','09:40:00',2.42),('15087','2013-02-14','09:45:00',2.49),('15087','2013-02-14','09:50:00',2.6),('15087','2013-02-14','09:55:00',2.67),('15087','2013-02-14','10:00:00',2.72),('15087','2013-02-14','10:05:00',2.81),('15087','2013-02-14','10:10:00',2.87),('15087','2013-02-14','10:15:00',2.96),('15087','2013-02-14','10:20:00',3.03),('15087','2013-02-14','10:25:00',3.08),('15087','2013-02-14','10:30:00',3.13),('15087','2013-02-14','10:35:00',3.22),('15087','2013-02-14','10:40:00',3.29),('15087','2013-02-14','10:45:00',3.33),('15087','2013-02-14','10:50:00',3.38),('15087','2013-02-14','10:55:00',3.42),('15087','2013-02-14','11:00:00',3.47),('15087','2013-02-14','11:05:00',3.49),('15087','2013-02-14','11:10:00',3.53),('15087','2013-02-14','11:15:00',3.55),('15087','2013-02-14','11:20:00',3.58),('15087','2013-02-14','11:25:00',3.6),('15087','2013-02-14','11:30:00',3.64),('15087','2013-02-14','11:35:00',3.66),('15087','2013-02-14','11:40:00',3.67),('15087','2013-02-14','11:45:00',3.68),('15087','2013-02-14','11:50:00',3.7),('15087','2013-02-14','11:55:00',3.71),('15087','2013-02-14','12:00:00',3.73),('15087','2013-02-14','12:05:00',3.75),('15087','2013-02-14','12:10:00',3.74),('15087','2013-02-14','12:15:00',3.74),('15087','2013-02-14','12:20:00',3.71),('15087','2013-02-14','12:25:00',3.74),('15087','2013-02-14','12:30:00',3.73),('15087','2013-02-14','12:35:00',3.73),('15087','2013-02-14','12:40:00',3.73),('15087','2013-02-14','12:45:00',3.7),('15087','2013-02-14','12:50:00',3.63),('15087','2013-02-14','12:55:00',3.31),('15087','2013-02-14','13:00:00',3.32),('15087','2013-02-14','13:05:00',3.51),('15087','2013-02-14','13:10:00',3.5),('15087','2013-02-14','13:15:00',3.49),('15087','2013-02-14','13:20:00',3.37),('15087','2013-02-14','13:25:00',3.36),('15087','2013-02-14','13:30:00',3.32),('15087','2013-02-14','13:35:00',3.25),('15087','2013-02-14','13:40:00',3.09),('15087','2013-02-14','13:45:00',3.07),('15087','2013-02-14','13:50:00',3.05),('15087','2013-02-14','13:55:00',2.97),('15087','2013-02-14','14:00:00',2.9),('15087','2013-02-14','14:05:00',2.84),('15087','2013-02-14','14:10:00',2.82),('15087','2013-02-14','14:15:00',2.77),('15087','2013-02-14','14:20:00',2.72),('15087','2013-02-14','14:25:00',2.64),('15087','2013-02-14','14:30:00',2.51),('15087','2013-02-14','14:35:00',2.43),('15087','2013-02-14','14:40:00',2.33),('15087','2013-02-14','14:45:00',2.08),('15087','2013-02-14','14:50:00',2.23),('15087','2013-02-14','14:55:00',2.01),('15087','2013-02-14','15:00:00',1.94),('15087','2013-02-14','15:05:00',1.93),('15087','2013-02-14','15:10:00',1.93),('15087','2013-02-14','15:15:00',1.85),('15087','2013-02-14','15:20:00',1.78),('15087','2013-02-14','15:25:00',1.7),('15087','2013-02-14','15:30:00',1.65),('15087','2013-02-14','15:35:00',1.49),('15087','2013-02-14','15:40:00',1.4),('15087','2013-02-14','15:45:00',1.38),('15087','2013-02-14','15:50:00',1.28),('15087','2013-02-14','15:55:00',1.15),('15087','2013-02-13','09:00:00',1.08),('15087','2013-02-13','09:05:00',1.17),('15087','2013-02-13','09:10:00',1.2),('15087','2013-02-13','09:15:00',1.22),('15087','2013-02-13','09:20:00',1.2),('15087','2013-02-13','09:25:00',1.51),('15087','2013-02-13','09:30:00',1.59),('15087','2013-02-13','09:35:00',2.05),('15087','2013-02-13','09:40:00',2.16),('15087','2013-02-13','09:45:00',2.38),('15087','2013-02-13','09:50:00',2.46),('15087','2013-02-13','09:55:00',2.36),('15087','2013-02-13','10:00:00',2.41),('15087','2013-02-13','10:05:00',2.56),('15087','2013-02-13','10:10:00',2.75),('15087','2013-02-13','10:15:00',2.89),('15087','2013-02-13','10:20:00',3.03),('15087','2013-02-13','10:25:00',3.09),('15087','2013-02-13','10:30:00',3.26),('15087','2013-02-13','10:35:00',3.35),('15087','2013-02-13','10:40:00',3.28),('15087','2013-02-13','10:45:00',3.44),('15087','2013-02-13','10:50:00',3.55),('15087','2013-02-13','10:55:00',3.53),('15087','2013-02-13','11:00:00',3.44),('15087','2013-02-13','11:05:00',3.59),('15087','2013-02-13','11:10:00',3.43),('15087','2013-02-13','11:15:00',3.34),('15087','2013-02-13','11:20:00',3.12),('15087','2013-02-13','11:25:00',3.05),('15087','2013-02-13','11:30:00',3.13),('15087','2013-02-13','11:35:00',1.77),('15087','2013-02-13','11:40:00',1.42),('15087','2013-02-13','11:45:00',1.61),('15087','2013-02-13','11:50:00',2.15),('15087','2013-02-13','11:55:00',1.36),('15087','2013-02-13','12:00:00',1.16),('15087','2013-02-13','12:05:00',1.6),('15087','2013-02-13','12:10:00',2.85),('15087','2013-02-13','12:15:00',2.51),('15087','2013-02-13','12:20:00',3.02),('15087','2013-02-13','12:25:00',1.97),('15087','2013-02-13','12:30:00',1.16),('15087','2013-02-13','12:35:00',1.64),('15087','2013-02-13','12:40:00',1.19),('15087','2013-02-13','12:45:00',2.58),('15087','2013-02-13','12:50:00',2.83),('15087','2013-02-13','12:55:00',2.43),('15087','2013-02-13','13:00:00',2.77),('15087','2013-02-13','13:05:00',1.8),('15087','2013-02-13','13:10:00',2.56),('15087','2013-02-13','13:15:00',2.61),('15087','2013-02-13','13:20:00',3.32),('15087','2013-02-13','13:25:00',3.27),('15087','2013-02-13','13:30:00',3.37),('15087','2013-02-13','13:35:00',3.48),('15087','2013-02-13','13:40:00',3.08),('15087','2013-02-13','13:45:00',2.71),('15087','2013-02-13','13:50:00',2.54),('15087','2013-02-13','13:55:00',2.48),('15087','2013-02-13','14:00:00',2.68),('15087','2013-02-13','14:05:00',2.9),('15087','2013-02-13','14:10:00',2.65),('15087','2013-02-13','14:15:00',2.53),('15087','2013-02-13','14:20:00',2.59),('15087','2013-02-13','14:25:00',2.29),('15087','2013-02-13','14:30:00',2.46),('15087','2013-02-13','14:35:00',2.47),('15087','2013-02-13','14:40:00',2.42),('15087','2013-02-13','14:45:00',2.15),('15087','2013-02-13','14:50:00',2.23),('15087','2013-02-13','14:55:00',2.03),('15087','2013-02-13','15:00:00',2.03),('15087','2013-02-13','15:05:00',1.96),('15087','2013-02-13','15:10:00',1.8),('15087','2013-02-13','15:15:00',1.84),('15087','2013-02-13','15:20:00',1.78),('15087','2013-02-13','15:25:00',1.67),('15087','2013-02-13','15:30:00',1.59),('15087','2013-02-13','15:35:00',1.45),('15087','2013-02-13','15:40:00',1.39),('15087','2013-02-13','15:45:00',1.31),('15087','2013-02-13','15:50:00',1.21),('15087','2013-02-13','15:55:00',1.14),('15087','2013-02-13','16:00:00',1.08),('15087','2013-02-13','16:05:00',1),('15087','2013-02-11','10:20:00',1.09),('15087','2013-02-11','10:25:00',1.14),('15087','2013-02-11','10:30:00',1.15),('15087','2013-02-11','10:35:00',1.38),('15087','2013-02-11','10:40:00',1.19),('15087','2013-02-11','11:00:00',1.05),('15087','2013-02-11','11:05:00',1.24),('15087','2013-02-11','11:10:00',1.53),('15087','2013-02-11','11:15:00',1.61),('15087','2013-02-11','11:20:00',1.21),('15087','2013-02-11','11:45:00',1.32),('15087','2013-02-11','12:45:00',1.4),('15087','2013-02-11','14:00:00',1.04),('15087','2013-02-11','14:05:00',1.13),('15087','2013-02-11','14:10:00',1.27),('15087','2013-02-11','14:15:00',1.04),('15087','2013-02-11','14:20:00',1.08),('15087','2013-02-11','14:25:00',1.7),('15087','2013-02-11','14:30:00',2.14),('15087','2013-02-11','14:35:00',1.26),('15087','2013-02-11','14:40:00',1.79),('15087','2013-02-11','14:45:00',1.44),('15087','2014-03-22','07:40:00',1.24),('15087','2014-03-22','07:45:00',1.32),('15087','2014-03-22','07:50:00',1.15),('15087','2014-03-22','08:10:00',1.26),('15087','2014-03-22','08:15:00',1.52),('15087','2014-03-22','08:20:00',1.81),('15087','2014-03-22','08:25:00',1.81),('15087','2014-03-22','08:30:00',1.68),('15087','2014-03-22','08:35:00',1.03),('15087','2014-03-22','08:40:00',2.33),('15087','2014-03-22','08:45:00',2.27),('15087','2014-03-22','08:50:00',1.81),('15087','2014-03-22','08:55:00',2.06),('15087','2014-03-22','09:00:00',2.09),('15087','2014-03-22','09:05:00',1.39),('15087','2014-03-22','09:10:00',1.52),('15087','2013-02-10','09:45:00',1.39),('15087','2013-02-10','09:50:00',1.44),('15087','2013-02-10','10:00:00',2.66),('15087','2013-02-10','10:05:00',2.71),('15087','2013-02-10','10:10:00',2.73),('15087','2013-02-10','10:15:00',2.86),('15087','2013-02-10','10:20:00',2.93),('15087','2013-02-10','10:25:00',3),('15087','2013-02-10','10:30:00',3.05),('15087','2013-02-10','10:35:00',3.11),('15087','2013-02-10','10:40:00',3.19),('15087','2013-02-10','10:45:00',3.22),('15087','2013-02-10','10:50:00',3.27),('15087','2013-02-10','10:55:00',3.31),('15087','2013-02-10','11:00:00',3.35),('15087','2013-02-10','11:05:00',3.38),('15087','2013-02-10','11:10:00',3.43),('15087','2013-02-10','11:15:00',3.42),('15087','2013-02-10','11:20:00',3.46),('15087','2013-02-10','11:25:00',3.48),('15087','2013-02-10','11:30:00',3.52),('15087','2013-02-10','11:35:00',3.55),('15087','2013-02-10','11:40:00',3.55),('15087','2013-02-10','11:45:00',3.51),('15087','2013-02-10','11:50:00',3.59),('15087','2013-02-10','11:55:00',3.61),('15087','2013-02-10','12:00:00',3.65),('15087','2013-02-10','12:05:00',3.67),('15087','2013-02-10','12:10:00',3.68),('15087','2013-02-10','12:15:00',3.67),('15087','2013-02-10','12:20:00',3.7),('15087','2013-02-10','12:25:00',3.69),('15087','2013-02-10','12:30:00',3.68),('15087','2013-02-10','12:35:00',3.68),('15087','2013-02-10','12:40:00',3.65),('15087','2013-02-10','12:45:00',3.63),('15087','2013-02-10','12:50:00',3.58),('15087','2013-02-10','12:55:00',3.42),('15087','2013-02-10','13:00:00',3.54),('15087','2013-02-10','13:05:00',3.4),('15087','2013-02-10','13:10:00',3.07),('15087','2013-02-10','13:15:00',3.07),('15087','2013-02-10','13:20:00',3.18),('15087','2013-02-10','13:25:00',2.92),('15087','2013-02-10','13:30:00',2.87),('15087','2013-02-10','13:35:00',3.08),('15087','2013-02-10','13:40:00',2.84),('15087','2013-02-10','13:45:00',2.66),('15087','2013-02-10','13:50:00',2.81),('15087','2013-02-10','13:55:00',2.64),('15087','2013-02-10','14:00:00',2.48),('15087','2013-02-10','14:05:00',2.72),('15087','2013-02-10','14:10:00',2.67),('15087','2013-02-10','14:15:00',2.63),('15087','2013-02-10','14:20:00',2.62),('15087','2013-02-10','14:25:00',2.41),('15087','2013-02-10','14:30:00',2.26),('15087','2013-02-10','14:35:00',2.34),('15087','2013-02-10','14:40:00',2.31),('15087','2013-02-10','14:45:00',2.12),('15087','2013-02-10','14:50:00',1.97),('15087','2013-02-10','14:55:00',1.7),('15087','2013-02-10','15:00:00',1.5),('15087','2013-02-10','15:05:00',1.76),('15087','2013-02-10','15:10:00',1.79),('15087','2013-02-10','15:15:00',1.5),('15087','2013-02-10','15:20:00',1.85),('15087','2013-02-10','15:25:00',1.97),('15087','2013-02-10','15:30:00',1.46),('15087','2013-02-10','15:35:00',1.54),('15087','2013-02-10','15:40:00',1.29),('15087','2013-02-09','10:55:00',1.06),('15087','2013-02-09','11:00:00',1.14),('15087','2013-02-09','11:05:00',1.18),('15087','2013-02-09','11:10:00',1.22),('15087','2013-02-09','11:15:00',1.27),('15087','2013-02-09','11:20:00',1.3),('15087','2013-02-09','11:25:00',1.32),('15087','2013-02-09','11:30:00',1.34),('15087','2013-02-09','11:35:00',1.3),('15087','2013-02-09','11:40:00',1.27),('15087','2013-02-09','11:45:00',1.29),('15087','2013-02-09','11:50:00',1.27),('15087','2013-02-09','11:55:00',1.24),('15087','2013-02-09','12:00:00',1.25),('15087','2013-02-09','12:05:00',1.25),('15087','2013-02-09','12:10:00',1.22),('15087','2013-02-09','12:15:00',1.22),('15087','2013-02-09','12:20:00',1.24),('15087','2013-02-09','12:25:00',1.25),('15087','2013-02-09','12:30:00',1.27),('15087','2013-02-09','12:35:00',1.35),('15087','2013-02-09','12:40:00',1.37),('15087','2013-02-09','12:45:00',1.38),('15087','2013-02-09','12:50:00',1.4),('15087','2013-02-09','12:55:00',1.38),('15087','2013-02-09','13:00:00',1.49),('15087','2013-02-09','13:05:00',1.7),('15087','2013-02-09','13:10:00',1.9),('15087','2013-02-09','13:15:00',2.06),('15087','2013-02-09','13:20:00',2.3),('15087','2013-02-09','13:25:00',2.4),('15087','2013-02-09','13:30:00',2.58),('15087','2013-02-09','13:35:00',2.77),('15087','2013-02-09','13:40:00',2.69),('15087','2013-02-09','13:45:00',2.92),('15087','2013-02-09','13:50:00',2.96),('15087','2013-02-09','13:55:00',3.09),('15087','2013-02-09','14:00:00',2.81),('15087','2013-02-09','14:05:00',2.71),('15087','2013-02-09','14:10:00',2.29),('15087','2013-02-09','14:15:00',2.8),('15087','2013-02-09','14:20:00',3.18),('15087','2013-02-09','14:25:00',3.01),('15087','2013-02-09','14:30:00',2.69),('15087','2013-02-09','14:35:00',2.52),('15087','2013-02-09','14:40:00',2.21),('15087','2013-02-09','14:45:00',2.15),('15087','2013-02-09','14:50:00',2.01),('15087','2013-02-09','14:55:00',1.94),('15087','2013-02-09','15:00:00',1.83),('15087','2013-02-09','15:05:00',1.76),('15087','2013-02-09','15:10:00',1.71),('15087','2013-02-09','15:15:00',1.53),('15087','2013-02-09','15:20:00',1.64),('15087','2013-02-09','15:25:00',1.31),('15087','2013-02-09','15:30:00',1.36),('15087','2013-02-09','15:35:00',1.38),('15087','2013-02-09','15:40:00',1.27),('15087','2013-02-09','15:45:00',1.2),('15087','2013-02-09','15:50:00',1.18),('15087','2013-02-08','09:35:00',2.04),('15087','2013-02-08','09:40:00',2.86),('15087','2013-02-08','09:45:00',2.79),('15087','2013-02-08','09:50:00',2.72),('15087','2013-02-08','09:55:00',2.91),('15087','2013-02-08','10:00:00',3),('15087','2013-02-08','10:05:00',3.23),('15087','2013-02-08','10:10:00',3.24),('15087','2013-02-08','10:15:00',3.42),('15087','2013-02-08','10:20:00',2.91),('15087','2013-02-08','10:25:00',3.37),('15087','2013-02-08','10:30:00',2.44),('15087','2013-02-08','10:35:00',2.24),('15087','2013-02-08','10:40:00',3.65),('15087','2013-02-08','10:45:00',3.54),('15087','2013-02-08','10:50:00',3.65),('15087','2013-02-08','10:55:00',3.59),('15087','2013-02-08','11:00:00',3.5),('15087','2013-02-08','11:05:00',3.45),('15087','2013-02-08','11:10:00',3.48),('15087','2013-02-08','11:15:00',3.51),('15087','2013-02-08','11:20:00',3.52),('15087','2013-02-08','11:25:00',3.53),('15087','2013-02-08','11:30:00',3.54),('15087','2013-02-08','11:35:00',3.51),('15087','2013-02-08','11:40:00',3.57),('15087','2013-02-08','11:45:00',3.58),('15087','2013-02-08','11:50:00',3.59),('15087','2013-02-08','11:55:00',3.59),('15087','2013-02-08','12:00:00',3.61),('15087','2013-02-08','12:05:00',3.61),('15087','2013-02-08','12:10:00',3.64),('15087','2013-02-08','12:15:00',3.63),('15087','2013-02-08','12:20:00',3.63),('15087','2013-02-08','12:25:00',3.65),('15087','2013-02-08','12:30:00',3.63),('15087','2013-02-08','12:35:00',3.64),('15087','2013-02-08','12:40:00',3.84),('15087','2013-02-08','12:45:00',3.87),('15087','2013-02-08','12:50:00',2.15),('15087','2013-02-08','12:55:00',2.31),('15087','2013-02-08','13:00:00',2.16),('15087','2013-02-08','13:05:00',1.85),('15087','2013-02-08','13:10:00',1.99),('15087','2013-02-08','13:15:00',1.95),('15087','2013-02-08','13:20:00',2.02),('15087','2013-02-08','13:25:00',1.89),('15087','2013-02-08','13:30:00',1.89),('15087','2013-02-08','13:35:00',2.46),('15087','2013-02-08','13:40:00',1.99),('15087','2013-02-08','13:45:00',1.54),('15087','2013-02-08','13:50:00',1.59),('15087','2013-02-08','13:55:00',1.69),('15087','2013-02-08','14:00:00',1.52),('15087','2013-02-08','14:05:00',1.51),('15087','2013-02-08','14:10:00',1.4),('15087','2013-02-08','14:15:00',1.33),('15087','2013-02-08','14:20:00',1.41),('15087','2013-02-08','14:25:00',1.84),('15087','2013-02-08','14:30:00',2.32),('15087','2013-02-08','14:35:00',2.4),('15087','2013-02-08','14:40:00',3.3),('15087','2013-02-08','14:45:00',2.4),('15087','2013-02-08','14:50:00',2.24),('15087','2013-02-08','14:55:00',2.57),('15087','2013-02-08','15:00:00',2.56),('15087','2013-02-08','15:05:00',2.67),('15087','2013-02-08','15:10:00',2.54),('15087','2013-02-08','15:15:00',2.23),('15087','2013-02-08','15:20:00',1.31),('15087','2013-02-08','15:25:00',1.55),('15087','2013-02-08','15:30:00',1.53),('15087','2013-02-08','15:35:00',1.47),('15087','2013-02-08','15:40:00',1.43),('15087','2013-02-08','15:45:00',1.37),('15087','2013-02-08','15:50:00',1.27),('15087','2013-02-08','15:55:00',1.2),('15087','2013-02-08','16:00:00',1.1),('15087','2013-02-08','16:05:00',1),('15087','2013-02-07','15:05:00',2.41),('15087','2013-02-07','15:10:00',2.41),('15087','2013-02-07','15:15:00',1.61),('15087','2013-02-07','15:25:00',1.15),('15087','2014-03-20','07:35:00',1.01),('15087','2014-03-20','07:40:00',1.13),('15087','2014-03-20','07:45:00',1.22),('15087','2014-03-20','07:50:00',1.33),('15087','2014-03-20','07:55:00',1.44),('15087','2014-03-20','08:00:00',1.56),('15087','2014-03-20','08:05:00',1.64),('15087','2014-03-20','08:10:00',1.7),('15087','2014-03-20','08:15:00',1.76),('15087','2014-03-20','08:20:00',1.8),('15087','2014-03-20','08:25:00',1.9),('15087','2014-03-20','08:30:00',2.01),('15087','2014-03-20','08:35:00',2.11),('15087','2014-03-20','08:40:00',2.24),('15087','2014-03-20','08:45:00',2.35),('15087','2014-03-20','08:50:00',2.42),('15087','2014-03-20','08:55:00',2.49),('15087','2014-03-20','09:00:00',2.53),('15087','2014-03-20','09:05:00',2.64),('15087','2014-03-20','09:10:00',2.73),('15087','2014-03-20','09:15:00',2.78),('15087','2014-03-20','09:20:00',2.86),('15087','2014-03-20','09:25:00',2.9),('15087','2014-03-20','09:30:00',2.97),('15087','2014-03-20','09:35:00',3.06),('15087','2014-03-20','09:40:00',3.08),('15087','2014-03-20','09:45:00',3.12),('15087','2014-03-20','09:50:00',3.11),('15087','2014-03-20','09:55:00',3.19),('15087','2014-03-20','10:00:00',3.37),('15087','2014-03-20','10:05:00',3.46),('15087','2014-03-20','10:10:00',3.49),('15087','2014-03-20','10:15:00',3.48),('15087','2014-03-20','10:20:00',3.48),('15087','2014-03-20','10:25:00',3.57),('15087','2014-03-20','10:30:00',3.58),('15087','2014-03-20','10:35:00',3.46),('15087','2014-03-20','10:40:00',3.4),('15087','2014-03-20','10:45:00',3.49),('15087','2014-03-20','10:50:00',3.64),('15087','2014-03-20','10:55:00',3.9),('15087','2014-03-20','11:00:00',3.95),('15087','2014-03-20','11:05:00',3.92),('15087','2014-03-20','11:10:00',3.89),('15087','2014-03-20','11:15:00',3.69),('15087','2014-03-20','11:20:00',3.89),('15087','2014-03-20','11:25:00',3.92),('15087','2014-03-20','11:30:00',3.99),('15087','2014-03-20','11:35:00',4.1),('15087','2014-03-20','11:40:00',4.03),('15087','2014-03-20','11:45:00',4.02),('15087','2014-03-20','11:50:00',4.12),('15087','2014-03-20','11:55:00',3.79),('15087','2014-03-20','12:00:00',3.59),('15087','2014-03-20','12:05:00',3.95),('15087','2014-03-20','12:10:00',4.08),('15087','2014-03-20','12:15:00',4.11),('15087','2014-03-20','12:20:00',3.99),('15087','2014-03-20','12:25:00',3.84),('15087','2014-03-20','12:30:00',3.98),('15087','2014-03-20','12:35:00',4.01),('15087','2014-03-20','12:40:00',4.03),('15087','2014-03-20','12:45:00',4.12),('15087','2014-03-20','12:50:00',4.05),('15087','2014-03-20','12:55:00',3.99),('15087','2014-03-20','13:00:00',3.83),('15087','2014-03-20','13:05:00',3.81),('15087','2014-03-20','13:10:00',3.8),('15087','2014-03-20','13:15:00',3.7),('15087','2014-03-20','13:20:00',3.7),('15087','2014-03-20','13:25:00',3.59),('15087','2014-03-20','13:30:00',3.65),('15087','2014-03-20','13:35:00',3.52),('15087','2014-03-20','13:40:00',3.37),('15087','2014-03-20','13:45:00',3.17),('15087','2014-03-20','13:50:00',3.09),('15087','2014-03-20','13:55:00',2.88),('15087','2014-03-20','14:00:00',3.05),('15087','2014-03-20','14:05:00',3.28),('15087','2014-03-20','14:10:00',3.11),('15087','2014-03-20','14:15:00',2.87),('15087','2014-03-20','14:20:00',2.85),('15087','2014-03-20','14:25:00',2.86),('15087','2014-03-20','14:30:00',2.45),('15087','2014-03-20','14:35:00',2.29),('15087','2014-03-20','14:40:00',2.52),('15087','2014-03-20','14:45:00',2.45),('15087','2014-03-20','14:50:00',2.27),('15087','2014-03-20','14:55:00',2.22),('15087','2014-03-20','15:00:00',1.96),('15087','2014-03-20','15:05:00',1.97),('15087','2014-03-20','15:10:00',2.03),('15087','2014-03-20','15:15:00',1.93),('15087','2014-03-20','15:20:00',2.05),('15087','2014-03-20','15:25:00',1.84),('15087','2014-03-20','15:30:00',1.76),('15087','2014-03-20','15:35:00',1.68),('15087','2014-03-20','15:40:00',1.51),('15087','2014-03-20','15:45:00',1.55),('15087','2014-03-20','15:50:00',1.35),('15087','2014-03-20','15:55:00',1.24),('15087','2014-03-20','16:00:00',1.08),('15087','2014-03-19','09:00:00',1.02),('15087','2014-03-19','09:05:00',1.26),('15087','2014-03-19','09:10:00',1.43),('15087','2014-03-19','09:15:00',1.79),('15087','2014-03-19','09:20:00',1.74),('15087','2014-03-19','09:25:00',2.88),('15087','2014-03-19','09:30:00',3.69),('15087','2014-03-19','09:35:00',2.99),('15087','2014-03-19','09:40:00',3.29),('15087','2014-03-19','09:45:00',2.74),('15087','2014-03-19','09:50:00',2.59),('15087','2014-03-19','09:55:00',2.01),('15087','2014-03-19','10:00:00',1.42),('15087','2014-03-19','10:25:00',1.06),('15087','2014-03-19','10:30:00',1.39),('15087','2014-03-19','10:35:00',2.64),('15087','2014-03-19','10:40:00',2.14),('15087','2014-03-19','10:45:00',1.88),('15087','2014-03-19','10:50:00',1.66),('15087','2014-03-19','10:55:00',1.96),('15087','2014-03-19','11:00:00',3.96),('15087','2014-03-19','11:05:00',3.63),('15087','2014-03-19','11:10:00',1.91),('15087','2014-03-19','11:15:00',1.89),('15087','2014-03-19','11:20:00',1.73),('15087','2014-03-19','11:25:00',1.88),('15087','2014-03-19','11:30:00',1.87),('15087','2014-03-19','11:35:00',2.33),('15087','2014-03-19','11:40:00',2.1),('15087','2014-03-19','11:45:00',2.04),('15087','2014-03-19','11:50:00',2.01),('15087','2014-03-19','11:55:00',2),('15087','2014-03-19','12:00:00',2.64),('15087','2014-03-19','12:05:00',4.33),('15087','2014-03-19','12:10:00',4.54),('15087','2014-03-19','12:15:00',4.49),('15087','2014-03-19','12:20:00',4.49),('15087','2014-03-19','12:25:00',3.88),('15087','2014-03-19','12:30:00',3.51),('15087','2014-03-19','12:35:00',2.48),('15087','2014-03-19','12:40:00',2.96),('15087','2014-03-19','12:45:00',4.18),('15087','2014-03-19','12:50:00',4.04),('15087','2014-03-19','12:55:00',3.54),('15087','2014-03-19','13:00:00',3.94),('15087','2014-03-19','13:05:00',3.83),('15087','2014-03-19','13:10:00',3.81),('15087','2014-03-19','13:15:00',3.57),('15087','2014-03-19','13:20:00',3.51),('15087','2014-03-19','13:25:00',3.23),('15087','2014-03-19','13:30:00',3.64),('15087','2014-03-19','13:35:00',3.73),('15087','2014-03-19','13:40:00',3.54),('15087','2014-03-19','13:45:00',3.43),('15087','2014-03-19','13:50:00',3.4),('15087','2014-03-19','13:55:00',3.44),('15087','2014-03-19','14:00:00',3.35),('15087','2014-03-19','14:05:00',3.38),('15087','2014-03-19','14:10:00',3.29),('15087','2014-03-19','14:15:00',3.18),('15087','2014-03-19','14:20:00',3.13),('15087','2014-03-19','14:25:00',2.99),('15087','2014-03-19','14:30:00',2.87),('15087','2014-03-19','14:35:00',2.99),('15087','2014-03-19','14:40:00',2.83),('15087','2014-03-19','14:45:00',2.76),('15087','2014-03-19','14:50:00',2.7),('15087','2014-03-19','14:55:00',2.52),('15087','2014-03-19','15:00:00',2.56),('15087','2014-03-19','15:05:00',2.58),('15087','2014-03-19','15:10:00',2.5),('15087','2014-03-19','15:15:00',2.33),('15087','2014-03-19','15:20:00',2.34),('15087','2014-03-19','15:25:00',2.28),('15087','2014-03-19','15:30:00',2.09),('15087','2014-03-19','15:35:00',2.08),('15087','2014-03-19','15:40:00',2.02),('15087','2014-03-19','15:45:00',1.9),('15087','2014-03-19','15:50:00',1.87),('15087','2014-03-19','15:55:00',1.81),('15087','2014-03-19','16:00:00',1.69),('15087','2014-03-19','16:05:00',1.59),('15087','2014-03-19','16:10:00',1.51),('15087','2014-03-19','16:15:00',1.41),('15087','2014-03-19','16:20:00',1.33),('15087','2014-03-19','16:25:00',1.18),('15087','2014-03-19','16:30:00',1.1),('15087','2014-03-18','07:55:00',1.06),('15087','2014-03-18','08:15:00',1),('15087','2014-03-18','08:20:00',1.93),('15087','2014-03-18','08:25:00',1.1),('15087','2014-03-18','08:30:00',1.28),('15087','2014-03-18','08:50:00',2.04),('15087','2014-03-18','08:55:00',2.83),('15087','2014-03-18','09:00:00',2.17),('15087','2014-03-18','09:05:00',1.63),('15087','2014-03-18','09:10:00',1.72),('15087','2014-03-18','09:15:00',1.89),('15087','2014-03-18','09:20:00',2.37),('15087','2014-03-18','09:25:00',1.95),('15087','2014-03-18','09:30:00',2.82),('15087','2014-03-18','09:35:00',1.81),('15087','2014-03-18','09:40:00',1.13),('15087','2014-03-18','09:45:00',1.61),('15087','2014-03-18','09:50:00',2.71),('15087','2014-03-18','09:55:00',1.62),('15087','2014-03-18','10:00:00',3.04),('15087','2014-03-18','10:05:00',3.6),('15087','2014-03-18','10:10:00',3.75),('15087','2014-03-18','10:15:00',3.82),('15087','2014-03-18','10:20:00',3.27),('15087','2014-03-18','10:25:00',2.17),('15087','2014-03-18','10:30:00',3.52),('15087','2014-03-18','10:35:00',3.78),('15087','2014-03-18','10:40:00',2.42),('15087','2014-03-18','10:45:00',3.37),('15087','2014-03-18','10:50:00',4.61),('15087','2014-03-18','10:55:00',3.21),('15087','2014-03-18','11:00:00',1.99),('15087','2014-03-18','11:05:00',2.28),('15087','2014-03-18','11:10:00',1.48),('15087','2014-03-18','11:15:00',2.74),('15087','2014-03-18','11:20:00',4.19),('15087','2014-03-18','11:25:00',3.42),('15087','2014-03-18','11:30:00',3.18),('15087','2014-03-18','11:35:00',4.88),('15087','2014-03-18','11:40:00',3),('15087','2014-03-18','11:45:00',3.78),('15087','2014-03-18','11:50:00',2.45),('15087','2014-03-18','11:55:00',1.87),('15087','2014-03-18','12:00:00',2.44),('15087','2014-03-18','12:05:00',4.07),('15087','2014-03-18','12:10:00',3.99),('15087','2014-03-18','12:15:00',2.23),('15087','2014-03-18','12:20:00',1.52),('15087','2014-03-18','12:25:00',1.23),('15087','2014-03-18','12:30:00',2.29),('15087','2014-03-18','12:35:00',1.85),('15087','2014-03-18','12:40:00',2.6),('15087','2014-03-18','12:45:00',4.52),('15087','2014-03-18','12:50:00',4.32),('15087','2014-03-18','12:55:00',4.18),('15087','2014-03-18','13:00:00',3.87),('15087','2014-03-18','13:05:00',4.1),('15087','2014-03-18','13:10:00',4.04),('15087','2014-03-18','13:15:00',3.87),('15087','2014-03-18','13:20:00',3.69),('15087','2014-03-18','13:25:00',2.92),('15087','2014-03-18','13:30:00',3.76),('15087','2014-03-18','13:35:00',3.63),('15087','2014-03-18','13:40:00',3.49),('15087','2014-03-18','13:45:00',3.43),('15087','2014-03-18','13:50:00',3.46),('15087','2014-03-18','13:55:00',3.35),('15087','2014-03-18','14:00:00',3.27),('15087','2014-03-18','14:05:00',3.35),('15087','2014-03-18','14:10:00',3.2),('15087','2014-03-18','14:15:00',3.13),('15087','2014-03-18','14:20:00',3.17),('15087','2014-03-18','14:25:00',2.95),('15087','2014-03-18','14:30:00',2.87),('15087','2014-03-18','14:35:00',2.93),('15087','2014-03-18','14:40:00',2.7),('15087','2014-03-18','14:45:00',2.68),('15087','2014-03-18','14:50:00',2.72),('15087','2014-03-18','14:55:00',2.52),('15087','2014-03-18','15:00:00',2.65),('15087','2014-03-18','15:05:00',2.58),('15087','2014-03-18','15:10:00',2.41),('15087','2014-03-18','15:15:00',2.23),('15087','2014-03-18','15:20:00',2.26),('15087','2014-03-18','15:25:00',2.21),('15087','2014-03-18','15:30:00',2.03),('15087','2014-03-18','15:35:00',1.98),('15087','2014-03-18','15:40:00',1.91),('15087','2014-03-18','15:45:00',1.86),('15087','2014-03-18','15:50:00',1.8),('15087','2014-03-18','15:55:00',1.73),('15087','2014-03-18','16:00:00',1.64),('15087','2014-03-18','16:05:00',1.57),('15087','2014-03-18','16:10:00',1.49),('15087','2014-03-18','16:15:00',1.4),('15087','2014-03-18','16:20:00',1.29),('15087','2014-03-18','16:25:00',1.18),('15087','2014-03-18','16:30:00',1.1),('15087','2014-03-18','16:35:00',1.01),('15087','2014-05-01','07:50:00',1.27),('15087','2014-05-01','07:55:00',1.44),('15087','2014-05-01','08:00:00',1.6),('15087','2014-05-01','08:05:00',1.63),('15087','2014-05-01','08:10:00',1.7),('15087','2014-05-01','08:15:00',1.81),('15087','2014-05-01','08:20:00',1.91),('15087','2014-05-01','08:25:00',2.01),('15087','2014-05-01','08:30:00',2.11),('15087','2014-05-01','08:35:00',2.21),('15087','2014-05-01','08:40:00',2.31),('15087','2014-05-01','08:45:00',2.41),('15087','2014-05-01','08:50:00',2.62),('15087','2014-05-01','08:55:00',2.83),('15087','2014-05-01','09:00:00',1.67),('15087','2014-05-01','09:05:00',1.17),('15087','2014-05-01','09:10:00',2.42),('15087','2014-05-01','09:15:00',2.62),('15087','2014-05-01','09:20:00',1.96),('15087','2014-05-01','09:25:00',3.21),('15087','2014-05-01','09:30:00',3.19),('15087','2014-05-01','09:35:00',3.43),('15087','2014-05-01','09:40:00',3.75),('15087','2014-05-01','09:45:00',2.42),('15087','2014-05-01','09:50:00',2.72),('15087','2014-05-01','09:55:00',2.37),('15087','2014-05-01','10:00:00',1.88),('15087','2014-05-01','10:05:00',1.78),('15087','2014-05-01','10:10:00',2.73),('15087','2014-05-01','10:15:00',3.13),('15087','2014-05-01','10:20:00',1.68),('15087','2014-05-01','10:25:00',1.35),('15087','2014-05-01','10:30:00',3.33),('15087','2014-05-01','10:35:00',3.7),('15087','2014-05-01','10:40:00',1.8),('15087','2014-05-01','10:45:00',3.76),('15087','2014-05-01','10:50:00',4.61),('15087','2014-05-01','10:55:00',3.98),('15087','2014-05-01','11:00:00',3.94),('15087','2014-05-01','11:05:00',4.73),('15087','2014-05-01','11:10:00',3.43),('15087','2014-05-01','11:20:00',1.69),('15087','2014-05-01','11:25:00',5.11),('15087','2014-05-01','11:30:00',4.99),('15087','2014-05-01','11:35:00',4.87),('15087','2014-05-01','11:40:00',3.42),('15087','2014-05-01','11:45:00',5.12),('15087','2014-05-01','11:50:00',5.17),('15087','2014-05-01','11:55:00',2.16),('15087','2014-05-01','12:00:00',1.02),('15087','2014-05-01','12:05:00',5.24),('15087','2014-05-01','12:10:00',3.94),('15087','2014-05-01','12:15:00',3.3),('15087','2014-05-01','12:20:00',4),('15087','2014-05-01','12:25:00',5.29),('15087','2014-05-01','12:30:00',4),('15087','2014-05-01','12:35:00',5.28),('15087','2014-05-01','12:40:00',5.06),('15087','2014-05-01','12:45:00',2.19),('15087','2014-05-01','12:50:00',5.22),('15087','2014-05-01','12:55:00',5.39),('15087','2014-05-01','13:00:00',5.28),('15087','2014-05-01','13:05:00',5.17),('15087','2014-05-01','13:10:00',4.31),('15087','2014-05-01','13:15:00',4.56),('15087','2014-05-01','13:20:00',5.2),('15087','2014-05-01','13:25:00',1.32),('15087','2014-05-01','13:30:00',1.82),('15087','2014-05-01','13:35:00',1.88),('15087','2014-05-01','13:40:00',5.43),('15087','2014-05-01','13:45:00',5.38),('15087','2014-05-01','13:50:00',5.61),('15087','2014-05-01','13:55:00',5.24),('15087','2014-05-01','14:00:00',4.41),('15087','2014-05-01','14:05:00',4.99),('15087','2014-05-01','14:10:00',4.83),('15087','2014-05-01','14:15:00',4.78),('15087','2014-05-01','14:20:00',4.6),('15087','2014-05-01','14:25:00',4.61),('15087','2014-05-01','14:30:00',4.41),('15087','2014-05-01','14:35:00',4.35),('15087','2014-05-01','14:40:00',4.66),('15087','2014-05-01','14:45:00',4.55),('15087','2014-05-01','14:50:00',4.47),('15087','2014-05-01','14:55:00',4.09),('15087','2014-05-01','15:00:00',4.3),('15087','2014-05-01','15:05:00',4.51),('15087','2014-05-01','15:10:00',3.95),('15087','2014-05-01','15:15:00',4.02),('15087','2014-05-01','15:20:00',4.06),('15087','2014-05-01','15:25:00',3.98),('15087','2014-05-01','15:30:00',3.75),('15087','2014-05-01','15:35:00',3.5),('15087','2014-05-01','15:40:00',3.59),('15087','2014-05-01','15:45:00',3.49),('15087','2014-05-01','15:50:00',3.49),('15087','2014-05-01','15:55:00',3.35),('15087','2014-05-01','16:00:00',3.43),('15087','2014-05-01','16:05:00',3.41),('15087','2014-05-01','16:10:00',3.23),('15087','2014-05-01','16:15:00',3.21),('15087','2014-05-01','16:20:00',3.06),('15087','2014-05-01','16:25:00',2.81),('15087','2014-05-01','16:30:00',2.98),('15087','2014-05-01','16:35:00',2.95),('15087','2014-05-01','16:40:00',2.75),('15087','2014-05-01','16:45:00',2.34),('15087','2014-05-01','16:50:00',2.12),('15087','2014-05-01','16:55:00',2.37),('15087','2014-05-01','17:00:00',2.37),('15087','2014-05-01','17:05:00',2.26),('15087','2014-05-01','17:10:00',2.45),('15087','2014-05-01','17:15:00',2.31),('15087','2014-05-01','17:20:00',2.1),('15087','2014-05-01','17:25:00',2.05),('15087','2014-05-01','17:30:00',1.94),('15087','2014-05-01','17:35:00',1.68),('15087','2014-05-01','17:40:00',1.74),('15087','2014-05-01','17:45:00',1.61),('15087','2014-05-01','17:50:00',1.58),('15087','2014-05-01','17:55:00',1.55),('15087','2014-05-01','18:00:00',1.54),('15087','2014-05-01','18:05:00',1.33),('15087','2014-05-01','18:10:00',1.2),('15087','2014-05-01','18:15:00',1.12),('15087','2014-05-01','18:20:00',1.04),('15087','2014-03-17','09:15:00',1.19),('15087','2014-03-17','09:20:00',1.26),('15087','2014-03-17','09:25:00',1.6),('15087','2014-03-17','09:30:00',1.81),('15087','2014-03-17','09:35:00',1.47),('15087','2014-03-17','09:40:00',1.28),('15087','2014-03-17','09:45:00',1.33),('15087','2014-03-17','09:50:00',2.26),('15087','2014-03-17','09:55:00',1.91),('15087','2014-03-17','10:00:00',2.01),('15087','2014-03-17','10:05:00',1.88),('15087','2014-03-17','10:10:00',1.74),('15087','2014-03-17','10:15:00',1.88),('15087','2014-03-17','10:20:00',2.09),('15087','2014-03-17','10:25:00',1.82),('15087','2014-03-17','10:30:00',1.56),('15087','2014-03-17','10:35:00',1.4),('15087','2014-03-17','10:40:00',1.55),('15087','2014-03-17','10:45:00',1.94),('15087','2014-03-17','10:50:00',1.58),('15087','2014-03-17','10:55:00',1.53),('15087','2014-03-17','11:00:00',1.65),('15087','2014-03-17','11:05:00',1.46),('15087','2014-03-17','11:10:00',1.95),('15087','2014-03-17','11:15:00',1.73),('15087','2014-03-17','11:20:00',1.44),('15087','2014-03-17','11:25:00',1.86),('15087','2014-03-17','11:30:00',1.54),('15087','2014-03-17','11:35:00',1.49),('15087','2014-03-17','11:40:00',1.31),('15087','2014-03-17','11:45:00',1.7),('15087','2014-03-17','11:50:00',1.78),('15087','2014-03-17','11:55:00',1.87),('15087','2014-03-17','12:00:00',2.02),('15087','2014-03-17','12:05:00',2.19),('15087','2014-03-17','12:10:00',1.55),('15087','2014-03-17','12:15:00',1.93),('15087','2014-03-17','12:20:00',3.7),('15087','2014-03-17','12:25:00',1.63),('15087','2014-03-17','12:30:00',1.82),('15087','2014-03-17','12:35:00',2.11),('15087','2014-03-17','12:40:00',3.53),('15087','2014-03-17','12:45:00',3.72),('15087','2014-03-17','12:50:00',4.35),('15087','2014-03-17','12:55:00',4.02),('15087','2014-03-17','13:00:00',1.64),('15087','2014-03-17','13:05:00',2.19),('15087','2014-03-17','13:10:00',4.03),('15087','2014-03-17','13:15:00',3.99),('15087','2014-03-17','13:20:00',3.79),('15087','2014-03-17','13:25:00',3.41),('15087','2014-03-17','13:30:00',3.56),('15087','2014-03-17','13:35:00',3.7),('15087','2014-03-17','13:40:00',3.51),('15087','2014-03-17','13:45:00',1.81),('15087','2014-03-17','13:50:00',3.68),('15087','2014-03-17','13:55:00',1.79),('15087','2014-03-17','14:00:00',3.19),('15087','2014-03-17','14:05:00',2.81),('15087','2014-03-17','14:10:00',1.17),('15087','2014-03-17','14:15:00',3.1),('15087','2014-03-17','14:20:00',2),('15087','2014-03-17','14:25:00',2.66),('15087','2014-03-17','14:30:00',1.75),('15087','2014-03-17','14:35:00',2.16),('15087','2014-03-17','14:40:00',2.81),('15087','2014-03-17','14:45:00',2),('15087','2014-03-17','14:50:00',2.86),('15087','2014-03-17','14:55:00',2.39),('15087','2014-03-17','15:00:00',2.73),('15087','2014-03-17','15:05:00',2.12),('15087','2014-03-17','15:10:00',2.11),('15087','2014-03-17','15:15:00',1.51),('15087','2014-03-17','15:20:00',2.03),('15087','2014-03-17','15:25:00',2.11),('15087','2014-03-17','15:30:00',2.1),('15087','2014-03-17','15:35:00',1.89),('15087','2014-03-17','15:40:00',1.81),('15087','2014-03-17','15:45:00',1.79),('15087','2014-03-17','15:50:00',1.69),('15087','2014-03-17','15:55:00',1.71),('15087','2014-03-17','16:00:00',1.65),('15087','2014-03-17','16:05:00',1.2),('15087','2014-03-17','16:15:00',1.08),('15087','2014-03-17','16:20:00',1.38),('15087','2014-03-17','16:25:00',1.29),('15087','2014-03-17','16:30:00',1.13),('15087','2014-03-17','16:35:00',1.23),('15087','2014-03-17','16:40:00',1.02),('15087','2014-03-16','07:55:00',1.07),('15087','2014-03-16','08:00:00',1.24),('15087','2014-03-16','08:05:00',1.37),('15087','2014-03-16','08:10:00',1.4),('15087','2014-03-16','08:15:00',1.45),('15087','2014-03-16','08:20:00',1.55),('15087','2014-03-16','08:25:00',1.65),('15087','2014-03-16','08:30:00',1.74),('15087','2014-03-16','08:35:00',1.81),('15087','2014-03-16','08:40:00',1.87),('15087','2014-03-16','08:45:00',1.94),('15087','2014-03-16','08:50:00',2.06),('15087','2014-03-16','08:55:00',2.11),('15087','2014-03-16','09:00:00',2.08),('15087','2014-03-16','09:05:00',2.17),('15087','2014-03-16','09:10:00',2.33),('15087','2014-03-16','09:15:00',2.5),('15087','2014-03-16','09:20:00',2.56),('15087','2014-03-16','09:25:00',2.54),('15087','2014-03-16','09:30:00',2.61),('15087','2014-03-16','09:35:00',2.59),('15087','2014-03-16','09:40:00',2.68),('15087','2014-03-16','09:45:00',2.85),('15087','2014-03-16','09:50:00',3.01),('15087','2014-03-16','09:55:00',2.99),('15087','2014-03-16','10:00:00',2.97),('15087','2014-03-16','10:05:00',3.11),('15087','2014-03-16','10:10:00',3.1),('15087','2014-03-16','10:15:00',3.27),('15087','2014-03-16','10:20:00',3.26),('15087','2014-03-16','10:25:00',3.27),('15087','2014-03-16','10:30:00',3.29),('15087','2014-03-16','10:35:00',3.35),('15087','2014-03-16','10:40:00',3.43),('15087','2014-03-16','10:45:00',3.51),('15087','2014-03-16','10:50:00',3.58),('15087','2014-03-16','10:55:00',3.58),('15087','2014-03-16','11:00:00',3.64),('15087','2014-03-16','11:05:00',3.63),('15087','2014-03-16','11:10:00',3.68),('15087','2014-03-16','11:15:00',3.65),('15087','2014-03-16','11:20:00',3.66),('15087','2014-03-16','11:25:00',3.71),('15087','2014-03-16','11:30:00',3.8),('15087','2014-03-16','11:35:00',3.8),('15087','2014-03-16','11:40:00',3.8),('15087','2014-03-16','11:45:00',3.72),('15087','2014-03-16','11:50:00',3.7),('15087','2014-03-16','11:55:00',3.58),('15087','2014-03-16','12:00:00',3.79),('15087','2014-03-16','12:05:00',3.82),('15087','2014-03-16','12:10:00',3.77),('15087','2014-03-16','12:15:00',3.63),('15087','2014-03-16','12:20:00',3.63),('15087','2014-03-16','12:25:00',3.82),('15087','2014-03-16','12:30:00',3.82),('15087','2014-03-16','12:35:00',3.84),('15087','2014-03-16','12:40:00',3.81),('15087','2014-03-16','12:45:00',3.78),('15087','2014-03-16','12:50:00',3.75),('15087','2014-03-16','12:55:00',3.73),('15087','2014-03-16','13:00:00',3.64),('15087','2014-03-16','13:05:00',3.63),('15087','2014-03-16','13:10:00',3.55),('15087','2014-03-16','13:15:00',3.52),('15087','2014-03-16','13:20:00',3.33),('15087','2014-03-16','13:25:00',3.44),('15087','2014-03-16','13:30:00',3.41),('15087','2014-03-16','13:35:00',3.31),('15087','2014-03-16','13:40:00',3.44),('15087','2014-03-16','13:45:00',3.35),('15087','2014-03-16','13:50:00',3.29),('15087','2014-03-16','13:55:00',3.31),('15087','2014-03-16','14:00:00',3.15),('15087','2014-03-16','14:05:00',3.1),('15087','2014-03-16','14:10:00',3.06),('15087','2014-03-16','14:15:00',2.91),('15087','2014-03-16','14:20:00',2.89),('15087','2014-03-16','14:25:00',2.89),('15087','2014-03-16','14:30:00',2.75),('15087','2014-03-16','14:35:00',2.76),('15087','2014-03-16','14:40:00',2.69),('15087','2014-03-16','14:45:00',2.57),('15087','2014-03-16','14:50:00',2.45),('15087','2014-03-16','14:55:00',2.5),('15087','2014-03-16','15:00:00',2.56),('15087','2014-03-16','15:05:00',2.37),('15087','2014-03-16','15:10:00',2.21),('15087','2014-03-16','15:15:00',2.07),('15087','2014-03-16','15:20:00',1.79),('15087','2014-03-16','15:25:00',2.01),('15087','2014-03-16','15:30:00',1.85),('15087','2014-03-16','15:35:00',1.75),('15087','2014-03-16','15:40:00',1.39),('15087','2014-03-16','15:45:00',1.29),('15087','2014-03-16','15:50:00',1.47),('15087','2014-03-16','15:55:00',1.32),('15087','2014-03-16','16:00:00',1.1),('15087','2014-03-16','16:05:00',1.31),('15087','2014-03-16','16:10:00',1.37),('15087','2014-03-16','16:15:00',1.37),('15087','2014-03-16','16:20:00',1.25),('15087','2014-03-16','16:25:00',1.19),('15087','2014-03-16','16:30:00',1.22),('15087','2014-03-16','16:35:00',1.12),('15087','2014-03-15','07:55:00',1.01),('15087','2014-03-15','08:00:00',1.11),('15087','2014-03-15','08:05:00',1.21),('15087','2014-03-15','08:10:00',1.33),('15087','2014-03-15','08:15:00',1.43),('15087','2014-03-15','08:20:00',1.52),('15087','2014-03-15','08:25:00',1.59),('15087','2014-03-15','08:30:00',1.68),('15087','2014-03-15','08:35:00',1.76),('15087','2014-03-15','08:40:00',1.84),('15087','2014-03-15','08:45:00',1.91),('15087','2014-03-15','08:50:00',2),('15087','2014-03-15','08:55:00',2.07),('15087','2014-03-15','09:00:00',2.16),('15087','2014-03-15','09:05:00',2.25),('15087','2014-03-15','09:10:00',2.32),('15087','2014-03-15','09:15:00',2.42),('15087','2014-03-15','09:20:00',2.47),('15087','2014-03-15','09:25:00',2.54),('15087','2014-03-15','09:30:00',2.6),('15087','2014-03-15','09:35:00',2.66),('15087','2014-03-15','09:40:00',2.72),('15087','2014-03-15','09:45:00',2.77),('15087','2014-03-15','09:50:00',2.81),('15087','2014-03-15','09:55:00',2.87),('15087','2014-03-15','10:00:00',2.91),('15087','2014-03-15','10:05:00',2.99),('15087','2014-03-15','10:10:00',3.11),('15087','2014-03-15','10:15:00',3.13),('15087','2014-03-15','10:20:00',3.15),('15087','2014-03-15','10:25:00',3.2),('15087','2014-03-15','10:30:00',3.23),('15087','2014-03-15','10:35:00',3.22),('15087','2014-03-15','10:40:00',3.3),('15087','2014-03-15','10:45:00',3.34),('15087','2014-03-15','10:50:00',3.34),('15087','2014-03-15','10:55:00',3.37),('15087','2014-03-15','11:00:00',3.43),('15087','2014-03-15','11:05:00',3.49),('15087','2014-03-15','11:10:00',3.5),('15087','2014-03-15','11:15:00',3.62),('15087','2014-03-15','11:20:00',3.66),('15087','2014-03-15','11:25:00',3.74),('15087','2014-03-15','11:30:00',3.64),('15087','2014-03-15','11:35:00',3.73),('15087','2014-03-15','11:40:00',3.72),('15087','2014-03-15','11:45:00',3.82),('15087','2014-03-15','11:50:00',3.7),('15087','2014-03-15','11:55:00',3.71),('15087','2014-03-15','12:00:00',3.71),('15087','2014-03-15','12:05:00',3.74),('15087','2014-03-15','12:10:00',3.79),('15087','2014-03-15','12:15:00',3.83),('15087','2014-03-15','12:20:00',3.75),('15087','2014-03-15','12:25:00',3.81),('15087','2014-03-15','12:30:00',3.88),('15087','2014-03-15','12:35:00',3.85),('15087','2014-03-15','12:40:00',3.84),('15087','2014-03-15','12:45:00',3.83),('15087','2014-03-15','12:50:00',3.85),('15087','2014-03-15','12:55:00',3.73),('15087','2014-03-15','13:00:00',3.69),('15087','2014-03-15','13:05:00',3.76),('15087','2014-03-15','13:10:00',3.73),('15087','2014-03-15','13:15:00',3.65),('15087','2014-03-15','13:20:00',3.55),('15087','2014-03-15','13:25:00',3.5),('15087','2014-03-15','13:30:00',3.44),('15087','2014-03-15','13:35:00',3.33),('15087','2014-03-15','13:40:00',3.42),('15087','2014-03-15','13:45:00',3.29),('15087','2014-03-15','13:50:00',3.19),('15087','2014-03-15','13:55:00',3.35),('15087','2014-03-15','14:00:00',3.15),('15087','2014-03-15','14:05:00',3.1),('15087','2014-03-15','14:10:00',3.21),('15087','2014-03-15','14:15:00',3.03),('15087','2014-03-15','14:20:00',2.88),('15087','2014-03-15','14:25:00',2.99),('15087','2014-03-15','14:30:00',2.81),('15087','2014-03-15','14:35:00',2.87),('15087','2014-03-15','14:40:00',2.72),('15087','2014-03-15','14:45:00',2.64),('15087','2014-03-15','14:50:00',2.58),('15087','2014-03-15','14:55:00',2.62),('15087','2014-03-15','15:00:00',2.52),('15087','2014-03-15','15:05:00',2.43),('15087','2014-03-15','15:10:00',2.33),('15087','2014-03-15','15:15:00',2.26),('15087','2014-03-15','15:20:00',2.15),('15087','2014-03-15','15:25:00',2.11),('15087','2014-03-15','15:30:00',1.99),('15087','2014-03-15','15:35:00',1.92),('15087','2014-03-15','15:40:00',1.86),('15087','2014-03-15','15:45:00',1.8),('15087','2014-03-15','15:50:00',1.77),('15087','2014-03-15','15:55:00',1.68),('15087','2014-03-15','16:00:00',1.52),('15087','2014-03-15','16:05:00',1.41),('15087','2014-03-15','16:10:00',1.35),('15087','2014-03-15','16:15:00',1.27),('15087','2014-03-15','16:20:00',1.19),('15087','2014-03-15','16:25:00',1.05),('15087','2014-03-14','08:15:00',1.05),('15087','2014-03-14','08:20:00',1.18),('15087','2014-03-14','08:25:00',1.24),('15087','2014-03-14','08:30:00',1.33),('15087','2014-03-14','08:35:00',1.32),('15087','2014-03-14','08:40:00',1.29),('15087','2014-03-14','08:45:00',1.08),('15087','2014-03-14','08:50:00',1.03),('15087','2014-03-14','08:55:00',1.06),('15087','2014-03-14','09:00:00',1.18),('15087','2014-03-14','09:05:00',1.41),('15087','2014-03-14','09:10:00',1.58),('15087','2014-03-14','09:15:00',1.65),('15087','2014-03-14','09:20:00',1.59),('15087','2014-03-14','09:25:00',1.67),('15087','2014-03-14','09:30:00',1.68),('15087','2014-03-14','09:35:00',1.96),('15087','2014-03-14','09:40:00',2.45),('15087','2014-03-14','09:45:00',2.82),('15087','2014-03-14','09:50:00',3.32),('15087','2014-03-14','09:55:00',3.52),('15087','2014-03-14','10:00:00',3.64),('15087','2014-03-14','10:05:00',3.66),('15087','2014-03-14','10:10:00',3.6),('15087','2014-03-14','10:15:00',3.55),('15087','2014-03-14','10:20:00',3.48),('15087','2014-03-14','10:25:00',3.3),('15087','2014-03-14','10:30:00',3.3),('15087','2014-03-14','10:35:00',3.47),('15087','2014-03-14','10:40:00',3.61),('15087','2014-03-14','10:45:00',3.14),('15087','2014-03-14','10:50:00',2.08),('15087','2014-03-14','10:55:00',2.81),('15087','2014-03-14','11:00:00',3.37),('15087','2014-03-14','11:05:00',3.58),('15087','2014-03-14','11:10:00',3.9),('15087','2014-03-14','11:15:00',4.01),('15087','2014-03-14','11:20:00',3.85),('15087','2014-03-14','11:25:00',3.75),('15087','2014-03-14','11:30:00',3.72),('15087','2014-03-14','11:35:00',3.78),('15087','2014-03-14','11:40:00',3.78),('15087','2014-03-14','11:45:00',3.91),('15087','2014-03-14','11:50:00',4.03),('15087','2014-03-14','11:55:00',4.01),('15087','2014-03-14','12:00:00',4.03),('15087','2014-03-14','12:05:00',3.94),('15087','2014-03-14','12:10:00',3.71),('15087','2014-03-14','12:15:00',3.65),('15087','2014-03-14','12:20:00',3.04),('15087','2014-03-14','12:25:00',2.56),('15087','2014-03-14','12:30:00',2.42),('15087','2014-03-14','12:35:00',1.96),('15087','2014-03-14','12:40:00',2.35),('15087','2014-03-14','12:45:00',2.58),('15087','2014-03-14','12:50:00',3.08),('15087','2014-03-14','12:55:00',3.36),('15087','2014-03-14','13:00:00',2.21),('15087','2014-03-14','13:05:00',2.01),('15087','2014-03-14','13:10:00',2.44),('15087','2014-03-14','13:15:00',2.62),('15087','2014-03-14','13:20:00',2.99),('15087','2014-03-14','13:25:00',2.73),('15087','2014-03-14','13:30:00',2.47),('15087','2014-03-14','13:35:00',2.18),('15087','2014-03-14','13:40:00',2.14),('15087','2014-03-14','13:45:00',2.21),('15087','2014-03-14','13:50:00',2.25),('15087','2014-03-14','13:55:00',2.12),('15087','2014-03-14','14:00:00',2.48),('15087','2014-03-14','14:05:00',2.82),('15087','2014-03-14','14:10:00',2.69),('15087','2014-03-14','14:15:00',2.87),('15087','2014-03-14','14:20:00',2.81),('15087','2014-03-14','14:25:00',2.56),('15087','2014-03-14','14:30:00',2.57),('15087','2014-03-14','14:35:00',2.47),('15087','2014-03-14','14:40:00',2.05),('15087','2014-03-14','14:45:00',1.67),('15087','2014-03-14','14:50:00',1.5),('15087','2014-03-14','14:55:00',1.37),('15087','2014-03-14','15:00:00',1.26),('15087','2014-03-14','15:05:00',1.26),('15087','2014-03-14','15:10:00',1.19),('15087','2014-03-14','15:15:00',1.15),('15087','2014-03-14','15:20:00',1.23),('15087','2014-03-14','15:25:00',1.33),('15087','2014-03-14','15:30:00',1.39),('15087','2014-03-14','15:35:00',1.7),('15087','2014-03-14','15:40:00',1.54),('15087','2014-03-14','15:45:00',1.26),('15087','2014-03-14','15:50:00',1.11),('15087','2014-03-14','15:55:00',1.13),('15087','2014-03-14','16:00:00',1.06),('15087','2014-03-14','16:05:00',1.06),('15087','2014-03-13','07:50:00',1.16),('15087','2014-03-13','07:55:00',1.31),('15087','2014-03-13','08:00:00',1.43),('15087','2014-03-13','08:05:00',1.52),('15087','2014-03-13','08:10:00',1.62),('15087','2014-03-13','08:15:00',1.7),('15087','2014-03-13','08:20:00',1.78),('15087','2014-03-13','08:25:00',1.87),('15087','2014-03-13','08:30:00',1.96),('15087','2014-03-13','08:35:00',2.04),('15087','2014-03-13','08:40:00',2.15),('15087','2014-03-13','08:45:00',2.23),('15087','2014-03-13','08:50:00',2.33),('15087','2014-03-13','08:55:00',2.42),('15087','2014-03-13','09:00:00',2.51),('15087','2014-03-13','09:05:00',2.56),('15087','2014-03-13','09:10:00',2.67),('15087','2014-03-13','09:15:00',2.74),('15087','2014-03-13','09:20:00',2.8),('15087','2014-03-13','09:25:00',2.86),('15087','2014-03-13','09:30:00',2.94),('15087','2014-03-13','09:35:00',3.02),('15087','2014-03-13','09:40:00',3.09),('15087','2014-03-13','09:45:00',3.16),('15087','2014-03-13','09:50:00',3.24),('15087','2014-03-13','09:55:00',3.31),('15087','2014-03-13','10:00:00',3.38),('15087','2014-03-13','10:05:00',3.44),('15087','2014-03-13','10:10:00',3.49),('15087','2014-03-13','10:15:00',3.55),('15087','2014-03-13','10:20:00',3.58),('15087','2014-03-13','10:25:00',3.61),('15087','2014-03-13','10:30:00',3.65),('15087','2014-03-13','10:35:00',3.68),('15087','2014-03-13','10:40:00',3.72),('15087','2014-03-13','10:45:00',3.75),('15087','2014-03-13','10:50:00',3.79),('15087','2014-03-13','10:55:00',3.84),('15087','2014-03-13','11:00:00',3.87),('15087','2014-03-13','11:05:00',3.89),('15087','2014-03-13','11:10:00',3.91),('15087','2014-03-13','11:15:00',3.93),('15087','2014-03-13','11:20:00',3.94),('15087','2014-03-13','11:25:00',4.01),('15087','2014-03-13','11:30:00',4.01),('15087','2014-03-13','11:35:00',4.02),('15087','2014-03-13','11:40:00',4.03),('15087','2014-03-13','11:45:00',4.05),('15087','2014-03-13','11:50:00',3.99),('15087','2014-03-13','11:55:00',4.08),('15087','2014-03-13','12:00:00',4.1),('15087','2014-03-13','12:05:00',4.1),('15087','2014-03-13','12:10:00',4.05),('15087','2014-03-13','12:15:00',4.06),('15087','2014-03-13','12:20:00',4.02),('15087','2014-03-13','12:25:00',4.01),('15087','2014-03-13','12:30:00',4),('15087','2014-03-13','12:35:00',4.02),('15087','2014-03-13','12:40:00',3.99),('15087','2014-03-13','12:45:00',3.96),('15087','2014-03-13','12:50:00',3.93),('15087','2014-03-13','12:55:00',3.83),('15087','2014-03-13','13:00:00',3.48),('15087','2014-03-13','13:05:00',3.56),('15087','2014-03-13','13:10:00',3.72),('15087','2014-03-13','13:15:00',3.63),('15087','2014-03-13','13:20:00',3.61),('15087','2014-03-13','13:25:00',3.61),('15087','2014-03-13','13:30:00',3.63),('15087','2014-03-13','13:35:00',3.48),('15087','2014-03-13','13:40:00',3.35),('15087','2014-03-13','13:45:00',2.98),('15087','2014-03-13','13:50:00',3.06),('15087','2014-03-13','13:55:00',3.15),('15087','2014-03-13','14:00:00',2.75),('15087','2014-03-13','14:05:00',2.94),('15087','2014-03-13','14:10:00',3.05),('15087','2014-03-13','14:15:00',2.85),('15087','2014-03-13','14:20:00',2.93),('15087','2014-03-13','14:25:00',2.85),('15087','2014-03-13','14:30:00',2.73),('15087','2014-03-13','14:35:00',2.76),('15087','2014-03-13','14:40:00',2.62),('15087','2014-03-13','14:45:00',2.62),('15087','2014-03-13','14:50:00',2.59),('15087','2014-03-13','14:55:00',2.59),('15087','2014-03-13','15:00:00',2.48),('15087','2014-03-13','15:05:00',2.4),('15087','2014-03-13','15:10:00',2.32),('15087','2014-03-13','15:15:00',2.06),('15087','2014-03-13','15:20:00',1.94),('15087','2014-03-13','15:25:00',1.99),('15087','2014-03-13','15:30:00',1.87),('15087','2014-03-13','15:35:00',1.83),('15087','2014-03-13','15:40:00',1.78),('15087','2014-03-13','15:45:00',1.71),('15087','2014-03-13','15:50:00',1.72),('15087','2014-03-13','15:55:00',1.62),('15087','2014-03-13','16:00:00',1.49),('15087','2014-03-13','16:05:00',1.38),('15087','2014-03-13','16:10:00',1.33),('15087','2014-03-13','16:15:00',1.24),('15087','2014-03-13','16:20:00',1.15),('15087','2014-03-13','16:25:00',1.03),('15087','2014-03-12','07:50:00',1.06),('15087','2014-03-12','07:55:00',1.16),('15087','2014-03-12','08:00:00',1.29),('15087','2014-03-12','08:05:00',1.42),('15087','2014-03-12','08:10:00',1.52),('15087','2014-03-12','08:15:00',1.63),('15087','2014-03-12','08:20:00',1.72),('15087','2014-03-12','08:25:00',1.82),('15087','2014-03-12','08:30:00',1.92),('15087','2014-03-12','08:35:00',2.02),('15087','2014-03-12','08:40:00',2.11),('15087','2014-03-12','08:45:00',2.21),('15087','2014-03-12','08:50:00',2.29),('15087','2014-03-12','08:55:00',2.39),('15087','2014-03-12','09:00:00',2.47),('15087','2014-03-12','09:05:00',2.52),('15087','2014-03-12','09:10:00',2.63),('15087','2014-03-12','09:15:00',2.7),('15087','2014-03-12','09:20:00',2.79),('15087','2014-03-12','09:25:00',2.87),('15087','2014-03-12','09:30:00',2.94),('15087','2014-03-12','09:35:00',2.99),('15087','2014-03-12','09:40:00',3.06),('15087','2014-03-12','09:45:00',3.12),('15087','2014-03-12','09:50:00',3.18),('15087','2014-03-12','09:55:00',3.25),('15087','2014-03-12','10:00:00',3.32),('15087','2014-03-12','10:05:00',3.38),('15087','2014-03-12','10:10:00',3.44),('15087','2014-03-12','10:15:00',3.51),('15087','2014-03-12','10:20:00',3.54),('15087','2014-03-12','10:25:00',3.58),('15087','2014-03-12','10:30:00',3.65),('15087','2014-03-12','10:35:00',3.7),('15087','2014-03-12','10:40:00',3.77),('15087','2014-03-12','10:45:00',3.82),('15087','2014-03-12','10:50:00',3.85),('15087','2014-03-12','10:55:00',3.88),('15087','2014-03-12','11:00:00',3.93),('15087','2014-03-12','11:05:00',3.98),('15087','2014-03-12','11:10:00',4.02),('15087','2014-03-12','11:15:00',4.07),('15087','2014-03-12','11:20:00',4),('15087','2014-03-12','11:25:00',4.09),('15087','2014-03-12','11:30:00',4.11),('15087','2014-03-12','11:35:00',4.12),('15087','2014-03-12','11:40:00',4.14),('15087','2014-03-12','11:45:00',4.14),('15087','2014-03-12','11:50:00',4.13),('15087','2014-03-12','11:55:00',4.18),('15087','2014-03-12','12:00:00',4.16),('15087','2014-03-12','12:05:00',4.14),('15087','2014-03-12','12:10:00',4.14),('15087','2014-03-12','12:15:00',4.14),('15087','2014-03-12','12:20:00',4.14),('15087','2014-03-12','12:25:00',4.15),('15087','2014-03-12','12:30:00',4.13),('15087','2014-03-12','12:35:00',4.11),('15087','2014-03-12','12:40:00',4.11),('15087','2014-03-12','12:45:00',4.07),('15087','2014-03-12','12:50:00',4.1),('15087','2014-03-12','12:55:00',3.99),('15087','2014-03-12','13:00:00',3.9),('15087','2014-03-12','13:05:00',3.95),('15087','2014-03-12','13:10:00',3.93),('15087','2014-03-12','13:15:00',3.76),('15087','2014-03-12','13:20:00',3.6),('15087','2014-03-12','13:25:00',3.72),('15087','2014-03-12','13:30:00',3.72),('15087','2014-03-12','13:35:00',3.46),('15087','2014-03-12','13:40:00',3.51),('15087','2014-03-12','13:45:00',3.51),('15087','2014-03-12','13:50:00',3.37),('15087','2014-03-12','13:55:00',3.32),('15087','2014-03-12','14:00:00',3.4),('15087','2014-03-12','14:05:00',3.35),('15087','2014-03-12','14:10:00',3.1),('15087','2014-03-12','14:15:00',2.74),('15087','2014-03-12','14:20:00',2.73),('15087','2014-03-12','14:25:00',3.01),('15087','2014-03-12','14:30:00',2.97),('15087','2014-03-12','14:35:00',2.76),('15087','2014-03-12','14:40:00',2.76),('15087','2014-03-12','14:45:00',2.75),('15087','2014-03-12','14:50:00',2.57),('15087','2014-03-12','14:55:00',2.57),('15087','2014-03-12','15:00:00',2.27),('15087','2014-03-12','15:05:00',2.39),('15087','2014-03-12','15:10:00',2.33),('15087','2014-03-12','15:15:00',2.21),('15087','2014-03-12','15:20:00',2.06),('15087','2014-03-12','15:25:00',1.96),('15087','2014-03-12','15:30:00',1.86),('15087','2014-03-12','15:35:00',1.8),('15087','2014-03-12','15:40:00',1.86),('15087','2014-03-12','15:45:00',1.84),('15087','2014-03-12','15:50:00',1.76),('15087','2014-03-12','15:55:00',1.65),('15087','2014-03-12','16:00:00',1.56),('15087','2014-03-12','16:05:00',1.42),('15087','2014-03-12','16:10:00',1.35),('15087','2014-03-12','16:15:00',1.28),('15087','2014-03-12','16:20:00',1.13),('15087','2014-03-12','16:25:00',1.08),('15087','2014-03-11','11:00:00',1.03),('15087','2014-03-11','11:05:00',1.08),('15087','2014-03-11','11:10:00',1.06),('15087','2014-03-11','11:15:00',1.09),('15087','2014-03-11','11:40:00',1.01),('15087','2014-03-11','11:45:00',1.07),('15087','2014-03-11','11:55:00',1.02),('15087','2014-03-11','12:00:00',1.08),('15087','2014-03-11','12:05:00',1.1),('15087','2014-03-11','12:10:00',1.13),('15087','2014-03-11','12:15:00',1.33),('15087','2014-03-11','12:20:00',1.43),('15087','2014-03-11','12:25:00',1.31),('15087','2014-03-11','12:30:00',1.28),('15087','2014-03-11','12:35:00',1.37),('15087','2014-03-11','12:40:00',1.52),('15087','2014-03-11','12:45:00',1.5),('15087','2014-03-11','12:50:00',1.41),('15087','2014-03-11','12:55:00',1.32),('15087','2014-03-11','13:00:00',1.26),('15087','2014-03-11','13:05:00',1.45),('15087','2014-03-11','13:10:00',1.45),('15087','2014-03-11','13:15:00',1.38),('15087','2014-03-11','13:20:00',1.43),('15087','2014-03-11','13:25:00',1.21),('15087','2014-03-11','13:30:00',1.19),('15087','2014-03-11','13:35:00',1.11),('15087','2014-03-11','13:40:00',1.15),('15087','2014-03-11','13:45:00',1.48),('15087','2014-03-11','13:50:00',1.74),('15087','2014-03-11','13:55:00',2.03),('15087','2014-03-11','14:00:00',2.13),('15087','2014-03-11','14:05:00',2.14),('15087','2014-03-11','14:10:00',2.6),('15087','2014-03-11','14:15:00',2.67),('15087','2014-03-11','14:20:00',2.57),('15087','2014-03-11','14:25:00',2.07),('15087','2014-03-11','14:30:00',1.54),('15087','2014-03-11','14:35:00',1.63),('15087','2014-03-11','14:40:00',1.54),('15087','2014-03-11','14:45:00',1.64),('15087','2014-03-11','14:50:00',1.48),('15087','2014-03-11','14:55:00',1.44),('15087','2014-03-11','15:00:00',1.67),('15087','2014-03-11','15:05:00',1.75),('15087','2014-03-11','15:10:00',1.98),('15087','2014-03-11','15:15:00',1.84),('15087','2014-03-11','15:20:00',1.95),('15087','2014-03-11','15:25:00',1.5),('15087','2014-03-11','15:30:00',1.39),('15087','2014-03-11','15:35:00',1.19),('15087','2014-03-11','15:40:00',1.13),('15087','2014-03-11','15:45:00',1.08),('15087','2014-03-11','15:50:00',1.08),('15087','2014-03-10','09:05:00',1.09),('15087','2014-03-10','09:10:00',1.11),('15087','2014-03-10','09:15:00',1.02),('15087','2014-03-10','09:25:00',1),('15087','2014-03-10','09:30:00',1.05),('15087','2014-03-10','09:35:00',1.08),('15087','2014-03-10','09:40:00',1.14),('15087','2014-03-10','09:45:00',1.02),('15087','2014-03-10','10:10:00',1.05),('15087','2014-03-10','10:15:00',1.26),('15087','2014-03-10','10:30:00',1.11),('15087','2014-03-10','10:35:00',1.35),('15087','2014-03-10','11:20:00',1.05),('15087','2014-03-10','12:45:00',1.05),('15087','2014-03-10','12:50:00',1.19),('15087','2014-03-10','12:55:00',1.29),('15087','2014-03-10','13:00:00',1.36),('15087','2014-03-10','13:05:00',1.39),('15087','2014-03-10','13:10:00',1.47),('15087','2014-03-10','13:15:00',1.61),('15087','2014-03-10','13:20:00',1.62),('15087','2014-03-10','13:25:00',1.46),('15087','2014-03-10','13:30:00',1.2),('15087','2014-03-10','13:50:00',1.24),('15087','2014-03-10','13:55:00',1.42),('15087','2014-03-10','14:00:00',1.24),('15087','2014-03-10','14:05:00',1.85),('15087','2014-03-10','14:10:00',2.26),('15087','2014-03-10','14:15:00',3.14),('15087','2014-03-10','14:20:00',2.29),('15087','2014-03-10','14:25:00',1.69),('15087','2014-03-10','14:30:00',1.45),('15087','2014-03-10','14:35:00',1.96),('15087','2014-03-10','14:40:00',2.59),('15087','2014-03-10','14:45:00',2.74),('15087','2014-03-10','14:50:00',2.64),('15087','2014-03-10','14:55:00',1.38),('15087','2014-03-10','15:00:00',1.72),('15087','2014-03-10','15:05:00',1.48),('15087','2014-03-10','15:15:00',1.47),('15087','2014-03-10','15:20:00',1.83),('15087','2014-03-10','15:25:00',2.32),('15087','2014-03-10','15:30:00',1.64),('15087','2014-03-10','15:35:00',1.23),('15087','2014-03-10','15:40:00',1.06),('15087','2014-03-09','07:55:00',1.03),('15087','2014-03-09','08:00:00',1.17),('15087','2014-03-09','08:05:00',1.29),('15087','2014-03-09','08:10:00',1.41),('15087','2014-03-09','08:15:00',1.53),('15087','2014-03-09','08:20:00',1.57),('15087','2014-03-09','08:25:00',1.56),('15087','2014-03-09','08:30:00',1.46),('15087','2014-03-09','08:35:00',1.27),('15087','2014-03-09','08:40:00',1.27),('15087','2014-03-09','08:45:00',1.19),('15087','2014-03-09','08:55:00',1.79),('15087','2014-03-09','09:00:00',2.3),('15087','2014-03-09','09:05:00',1.93),('15087','2014-03-09','09:15:00',2.69),('15087','2014-03-09','09:20:00',2.78),('15087','2014-03-09','09:25:00',2.86),('15087','2014-03-09','09:30:00',3.05),('15087','2014-03-09','09:35:00',3.23),('15087','2014-03-09','09:40:00',3.28),('15087','2014-03-09','09:45:00',3.35),('15087','2014-03-09','09:50:00',3.39),('15087','2014-03-09','09:55:00',3.39),('15087','2014-03-09','10:00:00',3.41),('15087','2014-03-09','10:05:00',3.47),('15087','2014-03-09','10:10:00',3.57),('15087','2014-03-09','10:15:00',3.61),('15087','2014-03-09','10:20:00',3.6),('15087','2014-03-09','10:25:00',3.51),('15087','2014-03-09','10:30:00',3.76),('15087','2014-03-09','10:35:00',3.79),('15087','2014-03-09','10:40:00',3.8),('15087','2014-03-09','10:45:00',3.85),('15087','2014-03-09','10:50:00',3.96),('15087','2014-03-09','10:55:00',4.06),('15087','2014-03-09','11:00:00',4.29),('15087','2014-03-09','11:05:00',4.17),('15087','2014-03-09','11:10:00',4.46),('15087','2014-03-09','11:15:00',4.55),('15087','2014-03-09','11:20:00',3.06),('15087','2014-03-09','11:25:00',2.07),('15087','2014-03-09','11:30:00',1.43),('15087','2014-03-09','11:35:00',2.05),('15087','2014-03-09','11:40:00',2.08),('15087','2014-03-09','11:45:00',1.84),('15087','2014-03-09','11:50:00',3.6),('15087','2014-03-09','11:55:00',3.54),('15087','2014-03-09','12:00:00',4.05),('15087','2014-03-09','12:05:00',4.67),('15087','2014-03-09','12:10:00',4.84),('15087','2014-03-09','12:15:00',4.75),('15087','2014-03-09','12:20:00',4.7),('15087','2014-03-09','12:25:00',4.62),('15087','2014-03-09','12:30:00',4.64),('15087','2014-03-09','12:35:00',4.78),('15087','2014-03-09','12:40:00',4.52),('15087','2014-03-09','12:45:00',4.41),('15087','2014-03-09','12:50:00',4.44),('15087','2014-03-09','12:55:00',4.45),('15087','2014-03-09','13:00:00',4.49),('15087','2014-03-09','13:05:00',4.54),('15087','2014-03-09','13:10:00',4.45),('15087','2014-03-09','13:15:00',4.15),('15087','2014-03-09','13:20:00',3.99),('15087','2014-03-09','13:25:00',3.8),('15087','2014-03-09','13:30:00',3.84),('15087','2014-03-09','13:35:00',3.68),('15087','2014-03-09','13:40:00',1.07),('15087','2014-03-09','13:45:00',1.16),('15087','2014-03-09','13:50:00',2.36),('15087','2014-03-09','13:55:00',1.06),('15087','2014-03-09','14:00:00',1.93),('15087','2014-03-09','14:05:00',3.35),('15087','2014-03-09','14:10:00',3.37),('15087','2014-03-09','14:15:00',3.19),('15087','2014-03-09','14:20:00',1.58),('15087','2014-03-09','14:25:00',3.15),('15087','2014-03-09','14:30:00',1.29),('15087','2014-03-09','14:45:00',2.28),('15087','2014-03-09','14:50:00',1.45),('15087','2014-03-09','14:55:00',2.84),('15087','2014-03-09','15:00:00',2.72),('15087','2014-03-09','15:05:00',2.39),('15087','2014-03-09','15:10:00',2.32),('15087','2014-03-09','15:15:00',2.38),('15087','2014-03-09','15:20:00',2.37),('15087','2014-03-09','15:25:00',2.25),('15087','2014-03-09','15:30:00',2.22),('15087','2014-03-09','15:35:00',2.09),('15087','2014-03-09','15:40:00',2.02),('15087','2014-03-09','15:45:00',1.71),('15087','2014-03-09','15:55:00',1.51),('15087','2014-03-09','16:00:00',1.7),('15087','2014-03-09','16:05:00',1.57),('15087','2014-03-09','16:10:00',1.17),('15087','2014-03-09','16:15:00',1.11),('15087','2014-03-09','16:25:00',1.12),('15087','2014-03-09','16:30:00',1.04),('15087','2014-03-09','16:40:00',1.01),('15087','2014-03-08','07:55:00',1.04),('15087','2014-03-08','08:00:00',1.17),('15087','2014-03-08','08:05:00',1.3),('15087','2014-03-08','08:10:00',1.39),('15087','2014-03-08','08:15:00',1.5),('15087','2014-03-08','08:20:00',1.61),('15087','2014-03-08','08:25:00',1.71),('15087','2014-03-08','08:30:00',1.81),('15087','2014-03-08','08:35:00',1.91),('15087','2014-03-08','08:40:00',2.01),('15087','2014-03-08','08:45:00',2.1),('15087','2014-03-08','08:50:00',2.2),('15087','2014-03-08','08:55:00',2.29),('15087','2014-03-08','09:00:00',2.38),('15087','2014-03-08','09:05:00',2.47),('15087','2014-03-08','09:10:00',2.55),('15087','2014-03-08','09:15:00',2.62),('15087','2014-03-08','09:20:00',2.71),('15087','2014-03-08','09:25:00',2.79),('15087','2014-03-08','09:30:00',2.88),('15087','2014-03-08','09:35:00',2.94),('15087','2014-03-08','09:40:00',3),('15087','2014-03-08','09:45:00',3.07),('15087','2014-03-08','09:50:00',3.15),('15087','2014-03-08','09:55:00',3.2),('15087','2014-03-08','10:00:00',3.28),('15087','2014-03-08','10:05:00',3.34),('15087','2014-03-08','10:10:00',3.4),('15087','2014-03-08','10:15:00',3.47),('15087','2014-03-08','10:20:00',3.53),('15087','2014-03-08','10:25:00',3.57),('15087','2014-03-08','10:30:00',3.65),('15087','2014-03-08','10:35:00',3.7),('15087','2014-03-08','10:40:00',3.75),('15087','2014-03-08','10:45:00',3.8),('15087','2014-03-08','10:50:00',3.83),('15087','2014-03-08','10:55:00',3.84),('15087','2014-03-08','11:00:00',3.87),('15087','2014-03-08','11:05:00',3.91),('15087','2014-03-08','11:10:00',3.93),('15087','2014-03-08','11:15:00',4),('15087','2014-03-08','11:20:00',4.07),('15087','2014-03-08','11:25:00',4.19),('15087','2014-03-08','11:30:00',4.4),('15087','2014-03-08','11:35:00',4.28),('15087','2014-03-08','11:40:00',2.55),('15087','2014-03-08','11:45:00',2.11),('15087','2014-03-08','11:50:00',1.6),('15087','2014-03-08','11:55:00',2.96),('15087','2014-03-08','12:00:00',2.35),('15087','2014-03-08','12:05:00',1.03),('15087','2014-03-08','12:10:00',1.07),('15087','2014-03-08','12:15:00',1.14),('15087','2014-03-08','12:20:00',1.37),('15087','2014-03-08','12:25:00',1.57),('15087','2014-03-08','12:30:00',1.69),('15087','2014-03-08','12:35:00',3.6),('15087','2014-03-08','12:40:00',2.15),('15087','2014-03-08','12:45:00',2.38),('15087','2014-03-08','12:50:00',2.31),('15087','2014-03-08','12:55:00',3.44),('15087','2014-03-08','13:00:00',2.29),('15087','2014-03-08','13:05:00',1.83),('15087','2014-03-08','13:10:00',1.61),('15087','2014-03-08','13:15:00',1.24),('15087','2014-03-08','13:20:00',1.02),('15087','2014-03-08','13:25:00',1.05),('15087','2014-03-08','13:30:00',1.68),('15087','2014-03-08','13:35:00',1.8),('15087','2014-03-08','13:40:00',2.36),('15087','2014-03-08','13:45:00',2.69),('15087','2014-03-08','13:50:00',2.48),('15087','2014-03-08','13:55:00',1.51),('15087','2014-03-08','14:00:00',1.14),('15087','2014-03-08','14:05:00',1.08),('15087','2014-03-08','14:10:00',1),('15087','2014-03-08','14:40:00',1.04),('15087','2014-03-08','14:50:00',1),('15087','2014-03-08','14:55:00',1.06),('15087','2014-03-08','15:15:00',1.26),('15087','2014-03-08','15:20:00',1.62),('15087','2014-03-08','15:25:00',1.49),('15087','2014-03-08','15:30:00',1.77),('15087','2014-03-08','16:35:00',1.1),('15087','2014-04-30','07:40:00',1.01),('15087','2014-04-30','07:45:00',1.1),('15087','2014-04-30','07:50:00',1.2),('15087','2014-04-30','07:55:00',1.31),('15087','2014-04-30','08:00:00',1.43),('15087','2014-04-30','08:05:00',1.52),('15087','2014-04-30','08:10:00',1.67),('15087','2014-04-30','08:15:00',1.77),('15087','2014-04-30','08:20:00',1.85),('15087','2014-04-30','08:25:00',1.94),('15087','2014-04-30','08:30:00',2.03),('15087','2014-04-30','08:35:00',2.13),('15087','2014-04-30','08:40:00',2.22),('15087','2014-04-30','08:45:00',2.3),('15087','2014-04-30','08:50:00',2.2),('15087','2014-04-30','08:55:00',2.46),('15087','2014-04-30','09:00:00',2.6),('15087','2014-04-30','09:05:00',2.92),('15087','2014-04-30','09:10:00',2.78),('15087','2014-04-30','09:15:00',1.39),('15087','2014-04-30','09:20:00',2.21),('15087','2014-04-30','09:25:00',2.25),('15087','2014-04-30','09:30:00',2.05),('15087','2014-04-30','09:35:00',3.32),('15087','2014-04-30','09:40:00',3.43),('15087','2014-04-30','09:45:00',2.73),('15087','2014-04-30','09:50:00',2.24),('15087','2014-04-30','09:55:00',3.42),('15087','2014-04-30','10:00:00',3.99),('15087','2014-04-30','10:05:00',2.74),('15087','2014-04-30','10:10:00',3.06),('15087','2014-04-30','10:15:00',2.62),('15087','2014-04-30','10:20:00',1.88),('15087','2014-04-30','10:25:00',1.84),('15087','2014-04-30','10:30:00',2.22),('15087','2014-04-30','10:35:00',2.36),('15087','2014-04-30','10:40:00',2.4),('15087','2014-04-30','10:45:00',1.76),('15087','2014-04-30','10:50:00',2.17),('15087','2014-04-30','10:55:00',4.53),('15087','2014-04-30','11:00:00',4.56),('15087','2014-04-30','11:05:00',3.55),('15087','2014-04-30','11:10:00',3.18),('15087','2014-04-30','11:15:00',2.29),('15087','2014-04-30','11:20:00',2.39),('15087','2014-04-30','11:25:00',2.55),('15087','2014-04-30','11:30:00',2.46),('15087','2014-04-30','11:35:00',3.94),('15087','2014-04-30','11:40:00',3.11),('15087','2014-04-30','11:45:00',3.56),('15087','2014-04-30','11:50:00',4.14),('15087','2014-04-30','11:55:00',3.67),('15087','2014-04-30','12:00:00',2.96),('15087','2014-04-30','12:05:00',1.48),('15087','2014-04-30','12:10:00',1.48),('15087','2014-04-30','12:15:00',2.01),('15087','2014-04-30','12:20:00',1.87),('15087','2014-04-30','12:25:00',1.66),('15087','2014-04-30','12:30:00',2.12),('15087','2014-04-30','12:35:00',2.12),('15087','2014-04-30','12:40:00',1.45),('15087','2014-04-30','12:45:00',1.43),('15087','2014-04-30','12:50:00',2.28),('15087','2014-04-30','12:55:00',4.78),('15087','2014-04-30','13:00:00',4.18),('15087','2014-04-30','13:05:00',3.02),('15087','2014-04-30','13:10:00',3.95),('15087','2014-04-30','13:15:00',2.48),('15087','2014-04-30','13:20:00',2.55),('15087','2014-04-30','13:25:00',3.97),('15087','2014-04-30','13:30:00',2.08),('15087','2014-04-30','13:35:00',2.51),('15087','2014-04-30','13:40:00',4.1),('15087','2014-04-30','13:45:00',3.83),('15087','2014-04-30','13:50:00',3.34),('15087','2014-04-30','13:55:00',3.79),('15087','2014-04-30','14:00:00',2.25),('15087','2014-04-30','14:05:00',2.01),('15087','2014-04-30','14:10:00',1.74),('15087','2014-04-30','14:15:00',2.12),('15087','2014-04-30','14:20:00',4.18),('15087','2014-04-30','14:25:00',4.48),('15087','2014-04-30','14:30:00',5.03),('15087','2014-04-30','14:35:00',3.89),('15087','2014-04-30','14:40:00',2.23),('15087','2014-04-30','14:45:00',1.52),('15087','2014-04-30','14:50:00',1.84),('15087','2014-04-30','14:55:00',2.04),('15087','2014-04-30','15:00:00',1.64),('15087','2014-04-30','15:05:00',1.61),('15087','2014-04-30','15:10:00',1.85),('15087','2014-04-30','15:15:00',1.42),('15087','2014-04-30','15:20:00',1.3),('15087','2014-04-30','15:25:00',1.47),('15087','2014-04-30','15:30:00',1.94),('15087','2014-04-30','15:35:00',3.57),('15087','2014-04-30','15:40:00',4.8),('15087','2014-04-30','15:45:00',3.86),('15087','2014-04-30','15:50:00',4.01),('15087','2014-04-30','15:55:00',2.68),('15087','2014-04-30','16:00:00',1.5),('15087','2014-04-30','16:05:00',1.86),('15087','2014-04-30','16:10:00',2.31),('15087','2014-04-30','16:15:00',3.03),('15087','2014-04-30','16:20:00',1.72),('15087','2014-04-30','16:25:00',2.11),('15087','2014-04-30','16:30:00',2.08),('15087','2014-04-30','16:35:00',1.46),('15087','2014-04-30','16:40:00',2.45),('15087','2014-04-30','16:45:00',1.71),('15087','2014-04-30','16:50:00',2.68),('15087','2014-04-30','16:55:00',2.56),('15087','2014-04-30','17:00:00',1.92),('15087','2014-04-30','17:05:00',1.61),('15087','2014-04-30','17:20:00',1.07),('15087','2014-04-30','17:35:00',1.07),('15087','2014-04-30','17:40:00',1.09),('15087','2014-03-07','11:20:00',1.02),('15087','2014-03-07','11:25:00',1.02),('15087','2014-03-07','11:30:00',1.14),('15087','2014-03-07','11:35:00',1.08),('15087','2014-03-07','11:45:00',1.89),('15087','2014-03-07','11:50:00',3.46),('15087','2014-03-07','11:55:00',4.06),('15087','2014-03-07','12:00:00',5.01),('15087','2014-03-07','12:05:00',4.28),('15087','2014-03-07','12:10:00',4.63),('15087','2014-03-07','12:15:00',4.48),('15087','2014-03-07','12:20:00',4.5),('15087','2014-03-07','12:25:00',4.5),('15087','2014-03-07','12:30:00',2.48),('15087','2014-03-07','12:35:00',3.7),('15087','2014-03-07','12:40:00',2.77),('15087','2014-03-07','12:50:00',1.44),('15087','2014-03-07','13:00:00',3.47),('15087','2014-03-07','13:05:00',3.56),('15087','2014-03-07','13:10:00',1.81),('15087','2014-03-07','13:15:00',1.26),('15087','2014-03-07','13:20:00',2.68),('15087','2014-03-07','13:25:00',3.58),('15087','2014-03-07','13:30:00',3.33),('15087','2014-03-07','13:35:00',2.75),('15087','2014-03-07','13:40:00',2.69),('15087','2014-03-07','13:45:00',2.42),('15087','2014-03-07','13:50:00',1.66),('15087','2014-03-07','13:55:00',1.28),('15087','2014-03-07','14:00:00',1.22),('15087','2014-03-07','14:05:00',1.14),('15087','2014-03-07','14:10:00',1.16),('15087','2014-03-07','14:15:00',1.15),('15087','2014-03-07','14:20:00',1.13),('15087','2014-03-07','14:25:00',1.09),('15087','2014-03-07','14:30:00',1.16),('15087','2014-03-07','14:35:00',1.23),('15087','2014-03-07','14:40:00',1.37),('15087','2014-03-07','14:45:00',1.39),('15087','2014-03-07','14:50:00',1.79),('15087','2014-03-07','14:55:00',2.42),('15087','2014-03-07','15:00:00',2.83),('15087','2014-03-07','15:05:00',3.04),('15087','2014-03-07','15:10:00',3.09),('15087','2014-03-07','15:15:00',3.15),('15087','2014-03-07','15:20:00',3.1),('15087','2014-03-07','15:25:00',2.83),('15087','2014-03-07','15:30:00',2.77),('15087','2014-03-07','15:35:00',2.49),('15087','2014-03-07','15:40:00',1.97),('15087','2014-03-07','15:45:00',2.21),('15087','2014-03-07','15:50:00',1.76),('15087','2014-03-07','15:55:00',1.39),('15087','2014-03-07','16:00:00',1.71),('15087','2014-03-07','16:05:00',1.6),('15087','2014-03-07','16:10:00',1.56),('15087','2014-03-07','16:15:00',1.6),('15087','2014-03-07','16:20:00',1.41),('15087','2014-03-07','16:25:00',1.33),('15087','2014-03-07','16:30:00',1.23),('15087','2014-03-07','16:35:00',1.14),('15087','2014-03-07','16:40:00',1.21),('15087','2014-03-07','16:45:00',1.18),('15087','2014-03-07','16:50:00',1.06),('15087','2014-03-07','16:55:00',1.01),('15087','2014-03-05','07:45:00',1.16),('15087','2014-03-05','07:50:00',1.28),('15087','2014-03-05','07:55:00',1.37),('15087','2014-03-05','08:00:00',1.21),('15087','2014-03-05','08:05:00',1.45),('15087','2014-03-05','08:10:00',1.59),('15087','2014-03-05','08:15:00',1.78),('15087','2014-03-05','08:20:00',1.02),('15087','2014-03-05','08:35:00',2.56),('15087','2014-03-05','08:40:00',2.19),('15087','2014-03-05','08:45:00',2.52),('15087','2014-03-05','08:50:00',1.81),('15087','2014-03-05','09:00:00',2.04),('15087','2014-03-05','09:05:00',2.41),('15087','2014-03-05','09:10:00',1.23),('15087','2014-03-05','09:15:00',2.79),('15087','2014-03-05','09:20:00',2.8),('15087','2014-03-05','09:25:00',2.83),('15087','2014-03-05','09:30:00',2.9),('15087','2014-03-05','09:35:00',2.66),('15087','2014-03-05','09:40:00',3.04),('15087','2014-03-05','09:45:00',3.1),('15087','2014-03-05','09:50:00',3.14),('15087','2014-03-05','09:55:00',3.23),('15087','2014-03-05','10:00:00',3.3),('15087','2014-03-05','10:05:00',3.37),('15087','2014-03-05','10:10:00',3.45),('15087','2014-03-05','10:15:00',3.48),('15087','2014-03-05','10:20:00',3.49),('15087','2014-03-05','10:25:00',3.56),('15087','2014-03-05','10:30:00',3.59),('15087','2014-03-05','10:35:00',3.66),('15087','2014-03-05','10:40:00',3.69),('15087','2014-03-05','10:45:00',3.7),('15087','2014-03-05','10:50:00',3.76),('15087','2014-03-05','10:55:00',3.82),('15087','2014-03-05','11:00:00',3.84),('15087','2014-03-05','11:05:00',3.92),('15087','2014-03-05','11:10:00',3.95),('15087','2014-03-05','11:15:00',4.04),('15087','2014-03-05','11:20:00',4.09),('15087','2014-03-05','11:25:00',4.14),('15087','2014-03-05','11:30:00',4.17),('15087','2014-03-05','11:35:00',4.32),('15087','2014-03-05','11:40:00',4.09),('15087','2014-03-05','11:45:00',4.28),('15087','2014-03-05','11:50:00',4.2),('15087','2014-03-05','11:55:00',3.57),('15087','2014-03-05','12:00:00',3.72),('15087','2014-03-05','12:05:00',3.37),('15087','2014-03-05','12:10:00',2.56),('15087','2014-03-05','12:15:00',1.08),('15087','2014-03-05','12:30:00',1.28),('15087','2014-03-05','12:35:00',2.16),('15087','2014-03-05','12:40:00',2.05),('15087','2014-03-05','12:45:00',1.14),('15087','2014-03-05','12:50:00',1.54),('15087','2014-03-05','12:55:00',1.55),('15087','2014-03-05','13:00:00',1.96),('15087','2014-03-05','13:05:00',2.97),('15087','2014-03-05','13:10:00',3.62),('15087','2014-03-05','13:15:00',2.47),('15087','2014-03-05','13:20:00',2.41),('15087','2014-03-05','13:25:00',1.81),('15087','2014-03-05','13:30:00',1.28),('15087','2014-03-05','13:35:00',1.33),('15087','2014-03-05','13:40:00',1.7),('15087','2014-03-05','13:45:00',1.62),('15087','2014-03-05','13:50:00',1.34),('15087','2014-03-05','13:55:00',1.17),('15087','2014-03-05','14:00:00',1.09),('15087','2014-03-05','14:05:00',1.14),('15087','2014-03-05','14:10:00',1.09),('15087','2014-03-05','14:15:00',1.22),('15087','2014-03-05','14:20:00',1.32),('15087','2014-03-05','14:25:00',1.55),('15087','2014-03-05','14:30:00',1.56),('15087','2014-03-05','14:35:00',1.27),('15087','2014-03-05','14:40:00',1.85),('15087','2014-03-05','14:45:00',2.86),('15087','2014-03-05','14:50:00',2.95),('15087','2014-03-05','14:55:00',2.1),('15087','2014-03-05','15:35:00',1.33),('15087','2014-03-05','15:40:00',1.8),('15087','2014-03-05','15:45:00',1.95),('15087','2014-03-05','15:50:00',1.4),('15087','2014-03-05','15:55:00',1.98),('15087','2014-03-05','16:00:00',2.63),('15087','2014-03-05','16:05:00',2.34),('15087','2014-03-05','16:10:00',1.99),('15087','2014-03-05','16:15:00',1.44),('15087','2014-03-04','09:05:00',1.15),('15087','2014-03-04','09:10:00',1.53),('15087','2014-03-04','09:15:00',2.47),('15087','2014-03-04','09:20:00',2.39),('15087','2014-03-04','09:30:00',1.03),('15087','2014-03-04','09:35:00',1.01),('15087','2014-03-04','09:40:00',1.22),('15087','2014-03-04','09:45:00',1.06),('15087','2014-03-04','09:55:00',2.02),('15087','2014-03-04','10:00:00',1.46),('15087','2014-03-04','10:20:00',1.04),('15087','2014-03-04','10:25:00',3.25),('15087','2014-03-04','10:30:00',1.99),('15087','2014-03-04','10:35:00',4.14),('15087','2014-03-04','10:40:00',4.53),('15087','2014-03-04','10:45:00',4.23),('15087','2014-03-04','10:50:00',1.14),('15087','2014-03-04','10:55:00',3.71),('15087','2014-03-04','11:00:00',2.37),('15087','2014-03-04','11:05:00',2.54),('15087','2014-03-04','11:10:00',4.62),('15087','2014-03-04','11:15:00',5.04),('15087','2014-03-04','11:20:00',2.79),('15087','2014-03-04','11:25:00',1.03),('15087','2014-03-04','11:30:00',1.06),('15087','2014-03-04','11:45:00',2.06),('15087','2014-03-04','11:50:00',5.12),('15087','2014-03-04','11:55:00',4.44),('15087','2014-03-04','12:00:00',4.33),('15087','2014-03-04','12:05:00',4.23),('15087','2014-03-04','12:10:00',4.23),('15087','2014-03-04','12:15:00',4.21),('15087','2014-03-04','12:20:00',4.23),('15087','2014-03-04','12:25:00',4.22),('15087','2014-03-04','12:30:00',4.12),('15087','2014-03-04','12:35:00',4.11),('15087','2014-03-04','12:40:00',4.16),('15087','2014-03-04','12:45:00',2.27),('15087','2014-03-04','12:50:00',3.52),('15087','2014-03-04','12:55:00',2.81),('15087','2014-03-04','13:00:00',4.03),('15087','2014-03-04','13:05:00',2.89),('15087','2014-03-04','13:10:00',4.34),('15087','2014-03-04','13:15:00',2.2),('15087','2014-03-04','13:20:00',1.92),('15087','2014-03-04','13:25:00',1.01),('15087','2014-03-04','13:30:00',1.07),('15087','2014-03-04','13:45:00',1.25),('15087','2014-03-04','13:50:00',1.44),('15087','2014-03-04','13:55:00',1.13),('15087','2014-03-04','14:05:00',2.02),('15087','2014-03-04','14:10:00',2.69),('15087','2014-03-04','14:15:00',3.46),('15087','2014-03-04','14:20:00',2.04),('15087','2014-03-04','14:25:00',3.47),('15087','2014-03-04','14:30:00',3.05),('15087','2014-03-04','14:35:00',2.89),('15087','2014-03-04','14:40:00',2.89),('15087','2014-03-04','14:45:00',2.66),('15087','2014-03-04','14:50:00',3),('15087','2014-03-04','14:55:00',1.99),('15087','2014-03-04','15:00:00',2.8),('15087','2014-03-04','15:05:00',2.58),('15087','2014-03-04','15:10:00',2.28),('15087','2014-03-04','15:15:00',2.11),('15087','2014-03-04','15:20:00',1.31),('15087','2014-03-04','15:25:00',1.89),('15087','2014-03-04','15:35:00',2.55),('15087','2014-03-04','15:40:00',2.1),('15087','2014-03-04','15:45:00',1.9),('15087','2014-03-04','15:50:00',1.6),('15087','2014-03-04','16:20:00',1.03),('15087','2014-03-04','16:25:00',1.25),('15087','2014-03-03','08:10:00',1.39),('15087','2014-03-03','08:15:00',1.52),('15087','2014-03-03','08:20:00',1.61),('15087','2014-03-03','08:25:00',1.69),('15087','2014-03-03','08:30:00',1.8),('15087','2014-03-03','08:35:00',1.88),('15087','2014-03-03','08:40:00',2),('15087','2014-03-03','08:45:00',2.09),('15087','2014-03-03','08:50:00',2.04),('15087','2014-03-03','08:55:00',2.31),('15087','2014-03-03','09:00:00',2.33),('15087','2014-03-03','09:05:00',2.33),('15087','2014-03-03','09:10:00',2.14),('15087','2014-03-03','09:15:00',2.32),('15087','2014-03-03','09:20:00',2.59),('15087','2014-03-03','09:25:00',2.72),('15087','2014-03-03','09:30:00',2.79),('15087','2014-03-03','09:35:00',2.51),('15087','2014-03-03','09:40:00',2.15),('15087','2014-03-03','09:45:00',2.43),('15087','2014-03-03','09:50:00',2.56),('15087','2014-03-03','09:55:00',2.81),('15087','2014-03-03','10:00:00',3.07),('15087','2014-03-03','10:05:00',3.26),('15087','2014-03-03','10:10:00',3.28),('15087','2014-03-03','10:15:00',3.34),('15087','2014-03-03','10:20:00',3.4),('15087','2014-03-03','10:25:00',3.45),('15087','2014-03-03','10:30:00',3.48),('15087','2014-03-03','10:35:00',3.54),('15087','2014-03-03','10:40:00',3.56),('15087','2014-03-03','10:45:00',3.61),('15087','2014-03-03','10:50:00',3.61),('15087','2014-03-03','10:55:00',3.63),('15087','2014-03-03','11:00:00',3.72),('15087','2014-03-03','11:05:00',3.74),('15087','2014-03-03','11:10:00',3.75),('15087','2014-03-03','11:15:00',3.8),('15087','2014-03-03','11:20:00',3.86),('15087','2014-03-03','11:25:00',3.9),('15087','2014-03-03','11:30:00',3.71),('15087','2014-03-03','11:35:00',2.21),('15087','2014-03-03','11:40:00',4.03),('15087','2014-03-03','11:45:00',4.04),('15087','2014-03-03','11:50:00',4.13),('15087','2014-03-03','11:55:00',4.09),('15087','2014-03-03','12:00:00',4.08),('15087','2014-03-03','12:05:00',4.11),('15087','2014-03-03','12:10:00',4.1),('15087','2014-03-03','12:15:00',4.12),('15087','2014-03-03','12:20:00',4.13),('15087','2014-03-03','12:25:00',4.11),('15087','2014-03-03','12:30:00',4.12),('15087','2014-03-03','12:35:00',4.11),('15087','2014-03-03','12:40:00',4.09),('15087','2014-03-03','12:45:00',4.09),('15087','2014-03-03','12:50:00',4.07),('15087','2014-03-03','12:55:00',4.05),('15087','2014-03-03','13:00:00',3.99),('15087','2014-03-03','13:05:00',3.82),('15087','2014-03-03','13:10:00',3.75),('15087','2014-03-03','13:15:00',3.86),('15087','2014-03-03','13:20:00',3.7),('15087','2014-03-03','13:25:00',3.61),('15087','2014-03-03','13:30:00',3.74),('15087','2014-03-03','13:35:00',3.45),('15087','2014-03-03','13:40:00',3.45),('15087','2014-03-03','13:45:00',3.53),('15087','2014-03-03','13:50:00',3.42),('15087','2014-03-03','13:55:00',3.37),('15087','2014-03-03','14:00:00',3.33),('15087','2014-03-03','14:05:00',3.31),('15087','2014-03-03','14:10:00',3.27),('15087','2014-03-03','14:15:00',3.17),('15087','2014-03-03','14:20:00',2.78),('15087','2014-03-03','14:25:00',2.66),('15087','2014-03-03','14:30:00',2.84),('15087','2014-03-03','14:35:00',2.72),('15087','2014-03-03','14:40:00',2.8),('15087','2014-03-03','14:45:00',2.76),('15087','2014-03-03','14:50:00',2.62),('15087','2014-03-03','14:55:00',2.67),('15087','2014-03-03','15:00:00',2.31),('15087','2014-03-03','15:05:00',2.45),('15087','2014-03-03','15:10:00',2.38),('15087','2014-03-03','15:15:00',2.26),('15087','2014-03-03','15:20:00',2.24),('15087','2014-03-03','15:25:00',2.18),('15087','2014-03-03','15:30:00',2.09),('15087','2014-03-03','15:35:00',1.97),('15087','2014-03-03','15:40:00',1.84),('15087','2014-03-03','15:45:00',1.78),('15087','2014-03-03','15:50:00',1.61),('15087','2014-03-03','15:55:00',1.5),('15087','2014-03-03','16:00:00',1.41),('15087','2014-03-03','16:05:00',1.34),('15087','2014-03-03','16:10:00',1.24),('15087','2014-03-03','16:15:00',1.2),('15087','2014-03-03','16:20:00',1.12),('15087','2014-03-03','16:25:00',1.06),('15087','2014-03-02','08:00:00',1.09),('15087','2014-03-02','08:05:00',1.08),('15087','2014-03-02','08:10:00',1.94),('15087','2014-03-02','08:15:00',1.79),('15087','2014-03-02','08:20:00',1.86),('15087','2014-03-02','08:25:00',1.75),('15087','2014-03-02','08:30:00',1.75),('15087','2014-03-02','08:35:00',1.83),('15087','2014-03-02','08:40:00',1.95),('15087','2014-03-02','08:45:00',2.05),('15087','2014-03-02','08:50:00',2.16),('15087','2014-03-02','08:55:00',2.26),('15087','2014-03-02','09:00:00',2.36),('15087','2014-03-02','09:05:00',2.46),('15087','2014-03-02','09:10:00',2.6),('15087','2014-03-02','09:15:00',2.68),('15087','2014-03-02','09:20:00',2.04),('15087','2014-03-02','09:25:00',2.97),('15087','2014-03-02','09:30:00',3.09),('15087','2014-03-02','09:35:00',3.04),('15087','2014-03-02','09:40:00',2.49),('15087','2014-03-02','09:55:00',1.28),('15087','2014-03-02','10:00:00',1.66),('15087','2014-03-02','10:05:00',1.74),('15087','2014-03-02','10:10:00',1.48),('15087','2014-03-02','10:15:00',1.37),('15087','2014-03-02','10:20:00',1.41),('15087','2014-03-02','10:25:00',1.7),('15087','2014-03-02','10:30:00',1.8),('15087','2014-03-02','10:35:00',3.18),('15087','2014-03-02','10:40:00',2.79),('15087','2014-03-02','10:45:00',1.04),('15087','2014-03-02','10:50:00',1.82),('15087','2014-03-02','10:55:00',1.79),('15087','2014-03-02','11:00:00',3.58),('15087','2014-03-02','11:05:00',3.29),('15087','2014-03-02','11:10:00',1.76),('15087','2014-03-02','11:15:00',1.37),('15087','2014-03-02','11:20:00',1.96),('15087','2014-03-02','11:25:00',2.09),('15087','2014-03-02','11:30:00',2.52),('15087','2014-03-02','11:35:00',3.32),('15087','2014-03-02','11:40:00',2.86),('15087','2014-03-02','11:45:00',5.12),('15087','2014-03-02','11:50:00',4.88),('15087','2014-03-02','11:55:00',4.62),('15087','2014-03-02','12:00:00',2.99),('15087','2014-03-02','12:05:00',2.36),('15087','2014-03-02','12:10:00',1.93),('15087','2014-03-02','12:15:00',2.94),('15087','2014-03-02','12:20:00',2.49),('15087','2014-03-02','12:25:00',2.45),('15087','2014-03-02','12:30:00',1.54),('15087','2014-03-02','12:35:00',1.19),('15087','2014-03-02','12:50:00',1.1),('15087','2014-03-02','12:55:00',1.38),('15087','2014-03-02','13:00:00',1.58),('15087','2014-03-02','13:05:00',1.66),('15087','2014-03-02','13:10:00',1.62),('15087','2014-03-02','13:15:00',1.44),('15087','2014-03-02','13:20:00',1.34),('15087','2014-03-02','13:25:00',1.26),('15087','2014-03-02','13:30:00',1.17),('15087','2014-03-02','13:35:00',1.01),('15087','2014-03-02','13:50:00',1.03),('15087','2014-03-02','13:55:00',1.1),('15087','2014-03-02','14:00:00',1.38),('15087','2014-03-02','14:05:00',1.51),('15087','2014-03-02','14:10:00',1.44),('15087','2014-03-02','14:15:00',1.36),('15087','2014-03-02','14:20:00',1.24),('15087','2014-03-02','14:25:00',1.22),('15087','2014-03-02','14:30:00',1.3),('15087','2014-03-02','14:35:00',1.32),('15087','2014-03-02','14:40:00',1.31),('15087','2014-03-02','14:45:00',1.36),('15087','2014-03-02','14:50:00',1.37),('15087','2014-03-02','14:55:00',1.34),('15087','2014-03-02','15:00:00',1.39),('15087','2014-03-02','15:05:00',1.48),('15087','2014-03-02','15:10:00',1.52),('15087','2014-03-02','15:15:00',1.49),('15087','2014-03-02','15:20:00',1.42),('15087','2014-03-02','15:25:00',1.47),('15087','2014-03-02','15:30:00',1.49),('15087','2014-03-02','15:35:00',1.45),('15087','2014-03-02','15:40:00',1.47),('15087','2014-03-02','15:45:00',1.21),('15087','2014-03-02','15:50:00',1.06),('15087','2014-02-28','07:55:00',1.02),('15087','2014-02-28','08:00:00',1.34),('15087','2014-02-28','08:05:00',1.07),('15087','2014-02-28','08:15:00',1.23),('15087','2014-02-28','08:20:00',1.76),('15087','2014-02-28','08:25:00',1.27),('15087','2014-02-28','08:35:00',2.22),('15087','2014-02-28','09:15:00',1.27),('15087','2014-02-28','09:20:00',1.37),('15087','2014-02-28','09:25:00',1.76),('15087','2014-02-28','09:30:00',2.04),('15087','2014-02-28','09:40:00',2.74),('15087','2014-02-28','09:45:00',3.21),('15087','2014-02-28','09:50:00',3.67),('15087','2014-02-28','09:55:00',2.41),('15087','2014-02-28','10:00:00',1.2),('15087','2014-02-28','10:05:00',1.25),('15087','2014-02-28','10:10:00',1.79),('15087','2014-02-28','10:15:00',1.23),('15087','2014-02-28','10:20:00',2.23),('15087','2014-02-28','10:25:00',3.3),('15087','2014-02-28','10:30:00',4.05),('15087','2014-02-28','10:35:00',2.75),('15087','2014-02-28','10:40:00',1.29),('15087','2014-02-28','11:15:00',1.1),('15087','2014-02-28','11:20:00',1.51),('15087','2014-02-28','11:25:00',1.48),('15087','2014-02-28','11:30:00',1.17),('15087','2014-02-28','11:50:00',1.12),('15087','2014-02-28','11:55:00',1.24),('15087','2014-02-28','12:00:00',1.64),('15087','2014-02-28','12:05:00',2.39),('15087','2014-02-28','12:10:00',2.08),('15087','2014-02-28','12:15:00',1.11),('15087','2014-02-28','12:20:00',1.02),('15087','2014-02-28','12:25:00',2.2),('15087','2014-02-28','12:30:00',2.21),('15087','2014-02-28','12:35:00',4.27),('15087','2014-02-28','12:40:00',2.77),('15087','2014-02-28','12:45:00',1.41),('15087','2014-02-28','12:50:00',3.57),('15087','2014-02-28','12:55:00',1.93),('15087','2014-02-28','13:00:00',2.75),('15087','2014-02-28','13:05:00',1.92),('15087','2014-02-28','13:10:00',1.72),('15087','2014-02-28','13:15:00',1.07),('15087','2014-02-28','13:45:00',1.17),('15087','2014-02-28','13:50:00',4.54),('15087','2014-02-28','13:55:00',2.24),('15087','2014-02-28','14:00:00',1.5),('15087','2014-02-28','14:15:00',1.2),('15087','2014-02-28','14:20:00',1.6),('15087','2014-02-28','14:25:00',2.29),('15087','2014-02-28','14:30:00',2.06),('15087','2014-02-28','14:35:00',1.6),('15087','2014-02-28','14:40:00',1.47),('15087','2014-02-28','14:45:00',1.41),('15087','2014-02-28','14:50:00',1.52),('15087','2014-02-28','14:55:00',1.65),('15087','2014-02-28','15:00:00',2.27),('15087','2014-02-28','15:05:00',1.58),('15087','2014-02-28','15:25:00',2.48),('15087','2014-02-28','15:30:00',1.95),('15087','2014-02-28','15:35:00',1.89),('15087','2014-02-28','15:40:00',1.84),('15087','2014-02-28','16:10:00',1.09),('15087','2014-02-28','16:15:00',1.84),('15087','2014-02-28','16:20:00',1.45),('15087','2014-02-28','16:40:00',1.24),('15087','2014-02-28','16:45:00',1.38),('15087','2014-02-28','16:50:00',1.18),('15087','2014-02-27','10:35:00',1.02),('15087','2014-02-27','10:40:00',1.25),('15087','2014-02-27','10:45:00',1.38),('15087','2014-02-27','10:50:00',1.44),('15087','2014-02-27','10:55:00',1.53),('15087','2014-02-27','11:00:00',1.74),('15087','2014-02-27','11:05:00',1.91),('15087','2014-02-27','11:10:00',1.78),('15087','2014-02-27','11:15:00',1.73),('15087','2014-02-27','11:20:00',1.58),('15087','2014-02-27','11:25:00',1.82),('15087','2014-02-27','11:30:00',2.16),('15087','2014-02-27','11:35:00',1.95),('15087','2014-02-27','11:40:00',1.65),('15087','2014-02-27','11:45:00',1.38),('15087','2014-02-27','11:50:00',1.35),('15087','2014-02-27','11:55:00',1.42),('15087','2014-02-27','12:00:00',1.38),('15087','2014-02-27','12:05:00',1.33),('15087','2014-02-27','12:10:00',1.19),('15087','2014-02-27','12:15:00',1.32),('15087','2014-02-27','12:20:00',1.41),('15087','2014-02-27','12:25:00',1.42),('15087','2014-02-27','12:30:00',1.31),('15087','2014-02-27','12:35:00',1.25),('15087','2014-02-27','12:40:00',1.22),('15087','2014-02-27','12:45:00',1.21),('15087','2014-02-27','12:50:00',1.19),('15087','2014-02-27','12:55:00',1.22),('15087','2014-02-27','13:00:00',1.31),('15087','2014-02-27','13:05:00',1.16),('15087','2014-02-27','13:10:00',1.24),('15087','2014-02-27','13:15:00',1.36),('15087','2014-02-27','13:20:00',1.37),('15087','2014-02-27','13:25:00',1.48),('15087','2014-02-27','13:30:00',1.71),('15087','2014-02-27','13:35:00',1.84),('15087','2014-02-27','13:40:00',1.89),('15087','2014-02-27','13:45:00',1.89),('15087','2014-02-27','13:50:00',1.9),('15087','2014-02-27','13:55:00',2.18),('15087','2014-02-27','14:00:00',2.2),('15087','2014-02-27','14:05:00',1.89),('15087','2014-02-27','14:10:00',1.69),('15087','2014-02-27','14:15:00',1.59),('15087','2014-02-27','14:20:00',1.58),('15087','2014-02-27','14:25:00',1.55),('15087','2014-02-27','14:30:00',1.65),('15087','2014-02-27','14:35:00',1.52),('15087','2014-02-27','14:40:00',1.29),('15087','2014-02-27','14:45:00',1.38),('15087','2014-02-27','14:50:00',1.29),('15087','2014-02-27','14:55:00',1.18),('15087','2014-02-27','15:00:00',1.27),('15087','2014-02-27','15:05:00',1.24),('15087','2014-02-27','15:10:00',1.29),('15087','2014-02-27','15:15:00',1.53),('15087','2014-02-27','15:20:00',1.65),('15087','2014-02-27','15:25:00',1.4),('15087','2014-02-27','15:30:00',1.38),('15087','2014-02-27','15:35:00',1.36),('15087','2014-02-27','15:40:00',1.03),('15087','2014-02-27','16:45:00',1.15),('15087','2014-02-27','16:50:00',1.2),('15087','2014-02-27','16:55:00',1.06),('15087','2014-02-26','08:10:00',1.14),('15087','2014-02-26','08:15:00',1.33),('15087','2014-02-26','08:20:00',1.42),('15087','2014-02-26','08:25:00',1.51),('15087','2014-02-26','08:30:00',1.6),('15087','2014-02-26','08:35:00',1.74),('15087','2014-02-26','08:40:00',1.87),('15087','2014-02-26','08:45:00',2.13),('15087','2014-02-26','08:50:00',1.97),('15087','2014-02-26','08:55:00',2.09),('15087','2014-02-26','09:00:00',2.11),('15087','2014-02-26','09:05:00',2.12),('15087','2014-02-26','09:10:00',2.18),('15087','2014-02-26','09:15:00',2.33),('15087','2014-02-26','09:20:00',2.46),('15087','2014-02-26','09:25:00',2.53),('15087','2014-02-26','09:30:00',2.49),('15087','2014-02-26','09:35:00',2.25),('15087','2014-02-26','09:40:00',2.05),('15087','2014-02-26','09:45:00',1.83),('15087','2014-02-26','09:50:00',2.08),('15087','2014-02-26','09:55:00',1.34),('15087','2014-02-26','10:00:00',1.35),('15087','2014-02-26','11:00:00',1.04),('15087','2014-02-26','11:05:00',1.08),('15087','2014-02-26','11:10:00',1.05),('15087','2014-02-26','11:15:00',1.01),('15087','2014-02-26','11:50:00',1.11),('15087','2014-02-26','11:55:00',1.24),('15087','2014-02-26','12:00:00',1.52),('15087','2014-02-26','12:05:00',1.51),('15087','2014-02-26','12:10:00',1.46),('15087','2014-02-26','12:15:00',1.26),('15087','2014-02-26','12:20:00',1.58),('15087','2014-02-26','12:25:00',2.42),('15087','2014-02-26','12:30:00',2.6),('15087','2014-02-26','12:35:00',2.65),('15087','2014-02-26','12:40:00',4.13),('15087','2014-02-26','12:45:00',4.03),('15087','2014-02-26','12:50:00',3.52),('15087','2014-02-26','12:55:00',3.74),('15087','2014-02-26','13:00:00',2.86),('15087','2014-02-26','13:05:00',2.92),('15087','2014-02-26','13:10:00',3.08),('15087','2014-02-26','13:15:00',2.9),('15087','2014-02-26','13:20:00',2.68),('15087','2014-02-26','13:25:00',2.7),('15087','2014-02-26','13:30:00',3.26),('15087','2014-02-26','13:35:00',2.93),('15087','2014-02-26','13:40:00',3.09),('15087','2014-02-26','13:45:00',1.67),('15087','2014-02-26','13:50:00',1.46),('15087','2014-02-26','13:55:00',2.84),('15087','2014-02-26','14:00:00',3.54),('15087','2014-02-26','14:05:00',1.9),('15087','2014-02-26','14:10:00',1.57),('15087','2014-02-26','14:15:00',2.47),('15087','2014-02-26','14:20:00',2.7),('15087','2014-02-26','14:25:00',2.91),('15087','2014-02-26','14:35:00',2.56),('15087','2014-02-26','14:40:00',2.85),('15087','2014-02-26','14:45:00',2.76),('15087','2014-02-26','14:50:00',2.86),('15087','2014-02-26','14:55:00',2.69),('15087','2014-02-26','15:00:00',2.11),('15087','2014-02-26','15:05:00',2.2),('15087','2014-02-26','15:10:00',1.78),('15087','2014-02-26','15:15:00',1.85),('15087','2014-02-26','15:20:00',1.36),('15087','2014-02-26','15:25:00',1.04),('15087','2014-02-26','15:30:00',1.17),('15087','2014-02-26','15:35:00',1.57),('15087','2014-02-26','15:40:00',1.61),('15087','2014-02-26','15:45:00',1.24),('15087','2014-02-26','15:50:00',1.28),('15087','2014-02-26','15:55:00',1.48),('15087','2014-02-26','16:00:00',1.67),('15087','2014-02-26','16:05:00',1.49),('15087','2014-04-29','09:50:00',1.11),('15087','2014-04-29','09:55:00',1.26),('15087','2014-04-29','10:00:00',1.33),('15087','2014-04-29','10:05:00',2.47),('15087','2014-04-29','10:10:00',4.39),('15087','2014-04-29','10:15:00',3.41),('15087','2014-04-29','10:20:00',3.35),('15087','2014-04-29','10:25:00',4.43),('15087','2014-04-29','10:30:00',4.16),('15087','2014-04-29','10:35:00',4.26),('15087','2014-04-29','10:40:00',4.32),('15087','2014-04-29','10:45:00',4.32),('15087','2014-04-29','10:50:00',4.44),('15087','2014-04-29','10:55:00',4.19),('15087','2014-04-29','11:00:00',4.42),('15087','2014-04-29','11:05:00',4.42),('15087','2014-04-29','11:10:00',4.4),('15087','2014-04-29','11:15:00',5.29),('15087','2014-04-29','11:20:00',3.16),('15087','2014-04-29','11:25:00',4.06),('15087','2014-04-29','11:30:00',1.69),('15087','2014-04-29','11:35:00',2.93),('15087','2014-04-29','11:40:00',3.74),('15087','2014-04-29','11:45:00',1.67),('15087','2014-04-29','11:50:00',1.15),('15087','2014-04-29','11:55:00',1.18),('15087','2014-04-29','12:00:00',1.7),('15087','2014-04-29','12:05:00',1.86),('15087','2014-04-29','12:10:00',1.91),('15087','2014-04-29','12:15:00',1.79),('15087','2014-04-29','12:20:00',2.4),('15087','2014-04-29','12:25:00',1.94),('15087','2014-04-29','12:30:00',1.65),('15087','2014-04-29','12:35:00',1.91),('15087','2014-04-29','12:40:00',2.03),('15087','2014-04-29','12:45:00',4.65),('15087','2014-04-29','12:50:00',2.54),('15087','2014-04-29','12:55:00',1.93),('15087','2014-04-29','13:00:00',2.6),('15087','2014-04-29','13:05:00',3.14),('15087','2014-04-29','13:10:00',2.65),('15087','2014-04-29','13:15:00',3.32),('15087','2014-04-29','13:20:00',4.56),('15087','2014-04-29','13:25:00',3),('15087','2014-04-29','13:30:00',3.48),('15087','2014-04-29','13:35:00',1.78),('15087','2014-04-29','13:40:00',1.86),('15087','2014-04-29','13:45:00',3.37),('15087','2014-04-29','13:50:00',3.2),('15087','2014-04-29','13:55:00',1.01),('15087','2014-04-29','16:25:00',1.01),('15087','2014-04-29','17:05:00',1.26),('15087','2014-04-29','17:10:00',1.15),('15087','2014-04-29','17:20:00',1.25),('15087','2014-04-29','17:25:00',1.36),('15087','2014-04-29','17:30:00',1.82),('15087','2014-04-29','17:35:00',1.3),('15087','2014-04-29','17:40:00',1.8),('15087','2014-04-29','17:45:00',1.85),('15087','2014-02-23','08:10:00',1.03),('15087','2014-02-23','08:20:00',1.26),('15087','2014-02-23','08:25:00',1.36),('15087','2014-02-23','08:30:00',1.46),('15087','2014-02-23','08:35:00',1.55),('15087','2014-02-23','08:40:00',1.65),('15087','2014-02-23','08:45:00',1.74),('15087','2014-02-23','08:50:00',1.79),('15087','2014-02-23','08:55:00',1.92),('15087','2014-02-23','09:00:00',2.02),('15087','2014-02-23','09:05:00',2.12),('15087','2014-02-23','09:10:00',2.22),('15087','2014-02-23','09:15:00',2.32),('15087','2014-02-23','09:20:00',2.4),('15087','2014-02-23','09:25:00',2.19),('15087','2014-02-23','09:30:00',2.21),('15087','2014-02-23','09:35:00',2.55),('15087','2014-02-23','09:40:00',2.63),('15087','2014-02-23','09:45:00',2.69),('15087','2014-02-23','09:50:00',2.72),('15087','2014-02-23','09:55:00',2.78),('15087','2014-02-23','10:00:00',2.83),('15087','2014-02-23','10:05:00',2.87),('15087','2014-02-23','10:10:00',2.93),('15087','2014-02-23','10:15:00',2.99),('15087','2014-02-23','10:20:00',3.07),('15087','2014-02-23','10:25:00',3.13),('15087','2014-02-23','10:30:00',3.18),('15087','2014-02-23','10:35:00',3.24),('15087','2014-02-23','10:40:00',3.28),('15087','2014-02-23','10:45:00',3.38),('15087','2014-02-23','10:50:00',3.37),('15087','2014-02-23','10:55:00',3.41),('15087','2014-02-23','11:00:00',3.48),('15087','2014-02-23','11:05:00',3.51),('15087','2014-02-23','11:10:00',3.56),('15087','2014-02-23','11:15:00',3.65),('15087','2014-02-23','11:20:00',3.69),('15087','2014-02-23','11:25:00',3.68),('15087','2014-02-23','11:30:00',3.74),('15087','2014-02-23','11:35:00',3.74),('15087','2014-02-23','11:40:00',3.61),('15087','2014-02-23','11:45:00',2.95),('15087','2014-02-23','11:50:00',3.48),('15087','2014-02-23','11:55:00',3.46),('15087','2014-02-23','12:00:00',3.97),('15087','2014-02-23','12:05:00',3.83),('15087','2014-02-23','12:10:00',1.77),('15087','2014-02-23','12:15:00',4.31),('15087','2014-02-23','12:20:00',3.55),('15087','2014-02-23','12:25:00',2.45),('15087','2014-02-23','12:30:00',3.12),('15087','2014-02-23','12:35:00',4.08),('15087','2014-02-23','12:40:00',2.25),('15087','2014-02-23','12:45:00',2.6),('15087','2014-02-23','12:50:00',2.09),('15087','2014-02-23','12:55:00',2.08),('15087','2014-02-23','13:00:00',2.6),('15087','2014-02-23','13:05:00',3.6),('15087','2014-02-23','13:10:00',3.68),('15087','2014-02-23','13:15:00',3.61),('15087','2014-02-23','13:20:00',3.56),('15087','2014-02-23','13:25:00',3.52),('15087','2014-02-23','13:30:00',3.46),('15087','2014-02-23','13:35:00',3.32),('15087','2014-02-23','13:40:00',2.87),('15087','2014-02-23','13:45:00',2.54),('15087','2014-02-23','13:50:00',1.83),('15087','2014-02-23','14:00:00',1.27),('15087','2014-02-23','14:05:00',2.84),('15087','2014-02-23','14:10:00',3.04),('15087','2014-02-23','14:15:00',2.24),('15087','2014-02-23','14:20:00',1.95),('15087','2014-02-23','14:25:00',2.89),('15087','2014-02-23','14:30:00',3.44),('15087','2014-02-23','14:35:00',2.7),('15087','2014-02-23','14:40:00',1.95),('15087','2014-02-23','14:45:00',1.59),('15087','2014-02-23','14:50:00',1.65),('15087','2014-02-23','14:55:00',1.02),('15087','2014-02-23','15:00:00',1.05),('15087','2014-02-22','09:10:00',1.12),('15087','2014-02-22','10:00:00',1.86),('15087','2014-02-22','10:05:00',1.77),('15087','2014-02-22','10:10:00',3.02),('15087','2014-02-22','10:15:00',2),('15087','2014-02-22','10:20:00',1.46),('15087','2014-02-22','10:25:00',2.4),('15087','2014-02-22','10:30:00',2.43),('15087','2014-02-22','10:35:00',1.98),('15087','2014-02-22','10:40:00',1.66),('15087','2014-02-22','10:45:00',4.04),('15087','2014-02-22','10:50:00',3.57),('15087','2014-02-22','10:55:00',1.09),('15087','2014-02-22','12:05:00',1.52),('15087','2014-02-22','12:10:00',1.75),('15087','2014-02-22','12:15:00',1.98),('15087','2014-02-22','12:20:00',1.95),('15087','2014-02-22','12:25:00',1.73),('15087','2014-02-22','12:30:00',1.12),('15087','2014-02-22','12:35:00',1.29),('15087','2014-02-22','12:40:00',1.54),('15087','2014-02-22','12:45:00',3.78),('15087','2014-02-22','12:50:00',3.82),('15087','2014-02-22','12:55:00',1.65),('15087','2014-02-22','13:00:00',1.56),('15087','2014-02-22','13:05:00',2.9),('15087','2014-02-22','13:10:00',4.96),('15087','2014-02-22','13:15:00',3.04),('15087','2014-02-22','13:20:00',1.63),('15087','2014-02-22','13:30:00',1.29),('15087','2014-02-22','13:35:00',2.22),('15087','2014-02-22','13:40:00',2.09),('15087','2014-02-22','13:45:00',1.74),('15087','2014-02-22','13:50:00',1.89),('15087','2014-02-22','13:55:00',3.54),('15087','2014-02-22','14:00:00',3.31),('15087','2014-02-22','14:05:00',2.88),('15087','2014-02-22','14:10:00',3.14),('15087','2014-02-22','14:15:00',3.09),('15087','2014-02-22','14:20:00',2.77),('15087','2014-02-22','14:25:00',2.33),('15087','2014-02-22','14:30:00',1.77),('15087','2014-02-22','14:35:00',2.26),('15087','2014-02-22','14:40:00',2.33),('15087','2014-02-22','14:45:00',2.71),('15087','2014-02-22','14:50:00',2.13),('15087','2014-02-22','15:00:00',1.5),('15087','2014-02-22','15:05:00',2.29),('15087','2014-02-22','15:10:00',1.11),('15087','2014-02-22','15:15:00',1.14),('15087','2014-02-22','15:25:00',1.27),('15087','2014-02-22','15:30:00',1.88),('15087','2014-02-22','15:45:00',1.72),('15087','2014-02-22','15:50:00',1.52),('15087','2014-02-22','16:00:00',1.22),('15087','2014-02-22','16:10:00',1.07),('15087','2014-02-22','16:15:00',1.03),('15087','2014-02-21','09:40:00',1.06),('15087','2014-02-21','09:45:00',1.22),('15087','2014-02-21','09:50:00',1.28),('15087','2014-02-21','09:55:00',1.2),('15087','2014-02-21','10:00:00',1.28),('15087','2014-02-21','10:05:00',1.6),('15087','2014-02-21','10:10:00',1.37),('15087','2014-02-21','10:15:00',1.69),('15087','2014-02-21','10:20:00',2.3),('15087','2014-02-21','10:25:00',2.58),('15087','2014-02-21','10:30:00',2.84),('15087','2014-02-21','10:35:00',1.99),('15087','2014-02-21','10:40:00',1.92),('15087','2014-02-21','10:45:00',1.75),('15087','2014-02-21','10:50:00',1.85),('15087','2014-02-21','10:55:00',2.54),('15087','2014-02-21','11:00:00',1.9),('15087','2014-02-21','11:05:00',1.71),('15087','2014-02-21','11:10:00',1.66),('15087','2014-02-21','11:15:00',1.82),('15087','2014-02-21','11:20:00',1.67),('15087','2014-02-21','11:25:00',1.74),('15087','2014-02-21','11:30:00',1.85),('15087','2014-02-21','11:35:00',1.85),('15087','2014-02-21','11:40:00',1.96),('15087','2014-02-21','11:45:00',1.89),('15087','2014-02-21','11:50:00',1.65),('15087','2014-02-21','11:55:00',1.6),('15087','2014-02-21','12:00:00',2.41),('15087','2014-02-21','12:05:00',3.88),('15087','2014-02-21','12:10:00',4.33),('15087','2014-02-21','12:15:00',4.37),('15087','2014-02-21','12:20:00',3.76),('15087','2014-02-21','12:25:00',2.56),('15087','2014-02-21','12:30:00',1.64),('15087','2014-02-21','12:35:00',1.29),('15087','2014-02-21','12:40:00',1.04),('15087','2014-02-21','15:00:00',1.15),('15087','2014-02-21','15:05:00',1.23),('15087','2014-02-21','15:30:00',1.46),('15087','2014-02-21','15:35:00',1.75),('15087','2014-02-21','15:40:00',1.56),('15087','2014-02-21','15:45:00',1.51),('15087','2014-02-21','15:50:00',1.41),('15087','2014-02-21','15:55:00',1.26),('15087','2014-02-21','16:00:00',1.18),('15087','2014-02-21','16:05:00',1.1),('15087','2014-02-21','16:10:00',1.02),('15087','2014-02-20','11:20:00',1.11),('15087','2014-02-20','11:25:00',1.23),('15087','2014-02-20','11:30:00',1.23),('15087','2014-02-20','12:25:00',1.1),('15087','2014-02-20','12:30:00',1.04),('15087','2014-02-20','12:35:00',1.09),('15087','2014-02-20','12:40:00',1.21),('15087','2014-02-20','12:45:00',1.06),('15087','2014-02-20','12:50:00',1.07),('15087','2014-02-20','12:55:00',1.27),('15087','2014-02-20','13:00:00',1.56),('15087','2014-02-20','13:15:00',1.24),('15087','2014-02-20','13:30:00',1.25),('15087','2014-02-20','13:35:00',1.07),('15087','2014-02-19','09:30:00',1.03),('15087','2014-02-19','09:35:00',1.18),('15087','2014-02-19','09:40:00',1.29),('15087','2014-02-19','09:45:00',1.62),('15087','2014-02-19','09:50:00',1.48),('15087','2014-02-19','09:55:00',1.31),('15087','2014-02-19','10:00:00',1.3),('15087','2014-02-19','10:05:00',1.28),('15087','2014-02-19','10:10:00',1.44),('15087','2014-02-19','10:15:00',1.51),('15087','2014-02-19','10:20:00',1.34),('15087','2014-02-19','10:25:00',1.4),('15087','2014-02-19','10:30:00',1.5),('15087','2014-02-19','10:35:00',1.61),('15087','2014-02-19','10:40:00',1.85),('15087','2014-02-19','10:45:00',2),('15087','2014-02-19','10:50:00',1.89),('15087','2014-02-19','10:55:00',1.67),('15087','2014-02-19','11:00:00',1.51),('15087','2014-02-19','11:05:00',1.55),('15087','2014-02-19','11:10:00',1.75),('15087','2014-02-19','11:15:00',1.74),('15087','2014-02-19','11:20:00',1.89),('15087','2014-02-19','11:25:00',1.75),('15087','2014-02-19','11:30:00',1.59),('15087','2014-02-19','11:35:00',1.63),('15087','2014-02-19','11:40:00',1.53),('15087','2014-02-19','11:45:00',1.47),('15087','2014-02-19','11:50:00',1.5),('15087','2014-02-19','11:55:00',1.28),('15087','2014-02-19','12:00:00',1.33),('15087','2014-02-19','12:05:00',1.46),('15087','2014-02-19','12:10:00',1.41),('15087','2014-02-19','12:15:00',1.38),('15087','2014-02-19','12:20:00',1.17),('15087','2014-02-19','12:25:00',1.45),('15087','2014-02-19','12:30:00',1.64),('15087','2014-02-19','12:35:00',1.26),('15087','2014-02-19','12:40:00',1.17),('15087','2014-02-19','12:45:00',1.19),('15087','2014-02-19','13:05:00',1.04),('15087','2014-02-19','13:10:00',1.02),('15087','2014-02-19','13:15:00',1.19),('15087','2014-02-19','13:20:00',1.15),('15087','2014-02-19','13:25:00',1.57),('15087','2014-02-19','13:30:00',1.6),('15087','2014-02-19','13:35:00',1.78),('15087','2014-02-19','13:40:00',1.65),('15087','2014-02-19','13:45:00',2.14),('15087','2014-02-19','13:50:00',2.22),('15087','2014-02-19','13:55:00',1.95),('15087','2014-02-19','14:00:00',1.83),('15087','2014-02-19','14:05:00',1.9),('15087','2014-02-19','14:10:00',1.47),('15087','2014-02-19','14:15:00',1.3),('15087','2014-02-19','14:20:00',2.16),('15087','2014-02-19','14:25:00',1.66),('15087','2014-02-19','14:30:00',1.58),('15087','2014-02-19','14:35:00',1.71),('15087','2014-02-19','14:40:00',1.37),('15087','2014-02-19','14:45:00',1.26),('15087','2014-02-19','14:50:00',1.7),('15087','2014-02-19','14:55:00',1.39),('15087','2014-02-19','15:00:00',1.03),('15087','2014-02-19','15:05:00',1.07),('15087','2014-02-19','15:10:00',1.13),('15087','2014-02-19','15:15:00',1.29),('15087','2014-02-19','15:25:00',1.11),('15087','2014-02-19','15:50:00',1.14),('15087','2014-02-18','08:25:00',1.12),('15087','2014-02-18','08:30:00',1.22),('15087','2014-02-18','08:35:00',1.31),('15087','2014-02-18','08:40:00',1.41),('15087','2014-02-18','08:45:00',1.49),('15087','2014-02-18','08:50:00',1.52),('15087','2014-02-18','08:55:00',1.66),('15087','2014-02-18','09:00:00',1.73),('15087','2014-02-18','09:05:00',1.82),('15087','2014-02-18','09:10:00',1.92),('15087','2014-02-18','09:15:00',1.98),('15087','2014-02-18','09:20:00',2.08),('15087','2014-02-18','09:25:00',2.14),('15087','2014-02-18','09:30:00',2.23),('15087','2014-02-18','09:35:00',2.3),('15087','2014-02-18','09:40:00',2.37),('15087','2014-02-18','09:45:00',2.43),('15087','2014-02-18','09:50:00',2.5),('15087','2014-02-18','09:55:00',2.57),('15087','2014-02-18','10:00:00',2.63),('15087','2014-02-18','10:05:00',2.69),('15087','2014-02-18','10:10:00',2.74),('15087','2014-02-18','10:15:00',2.78),('15087','2014-02-18','10:20:00',2.82),('15087','2014-02-18','10:25:00',2.89),('15087','2014-02-18','10:30:00',2.93),('15087','2014-02-18','10:35:00',2.96),('15087','2014-02-18','10:40:00',3.01),('15087','2014-02-18','10:45:00',3.05),('15087','2014-02-18','10:50:00',3.09),('15087','2014-02-18','10:55:00',3.12),('15087','2014-02-18','11:00:00',3.17),('15087','2014-02-18','11:05:00',2.73),('15087','2014-02-18','11:10:00',2.63),('15087','2014-02-18','11:15:00',2.57),('15087','2014-02-18','11:20:00',2.87),('15087','2014-02-18','11:25:00',3.23),('15087','2014-02-18','11:30:00',2.86),('15087','2014-02-18','11:35:00',2.78),('15087','2014-02-18','11:40:00',2.25),('15087','2014-02-18','11:45:00',2.2),('15087','2014-02-18','11:50:00',1.81),('15087','2014-02-18','11:55:00',1.54),('15087','2014-02-18','12:00:00',1.51),('15087','2014-02-18','12:05:00',1.52),('15087','2014-02-18','12:10:00',1.78),('15087','2014-02-18','12:15:00',1.94),('15087','2014-02-18','12:20:00',1.92),('15087','2014-02-18','12:25:00',2.26),('15087','2014-02-18','12:30:00',2.46),('15087','2014-02-18','12:35:00',1.82),('15087','2014-02-18','12:40:00',1.62),('15087','2014-02-18','12:45:00',1.56),('15087','2014-02-18','12:50:00',1.74),('15087','2014-02-18','12:55:00',1.89),('15087','2014-02-18','13:00:00',1.42),('15087','2014-02-18','13:05:00',1.34),('15087','2014-02-18','13:10:00',1.42),('15087','2014-02-18','13:15:00',1.94),('15087','2014-02-18','13:20:00',2.17),('15087','2014-02-18','13:25:00',2.6),('15087','2014-02-18','13:30:00',1.82),('15087','2014-02-18','13:35:00',1.48),('15087','2014-02-18','13:40:00',1.96),('15087','2014-02-18','13:45:00',2.26),('15087','2014-02-18','13:50:00',1.71),('15087','2014-02-18','13:55:00',1.7),('15087','2014-02-18','14:00:00',1.91),('15087','2014-02-18','14:05:00',2.64),('15087','2014-02-18','14:10:00',1.6),('15087','2014-02-18','14:15:00',1.26),('15087','2014-02-18','14:20:00',1.12),('15087','2014-02-18','14:25:00',1.15),('15087','2014-02-18','14:30:00',1.45),('15087','2014-02-18','14:35:00',1.37),('15087','2014-02-18','14:40:00',1.16),('15087','2014-02-18','14:45:00',1.06),('15087','2014-02-18','15:35:00',1.03),('15087','2014-02-18','15:40:00',1.25),('15087','2014-02-18','15:45:00',1.31),('15087','2014-02-18','15:50:00',1.04),('15087','2014-02-18','16:05:00',1.03),('15087','2014-02-17','08:25:00',1.02),('15087','2014-02-17','08:30:00',1.09),('15087','2014-02-17','08:35:00',1.17),('15087','2014-02-17','08:40:00',1.26),('15087','2014-02-17','08:45:00',1.34),('15087','2014-02-17','08:50:00',1.39),('15087','2014-02-17','08:55:00',1.51),('15087','2014-02-17','09:00:00',1.56),('15087','2014-02-17','09:05:00',1.65),('15087','2014-02-17','09:10:00',1.76),('15087','2014-02-17','09:15:00',1.85),('15087','2014-02-17','09:20:00',1.93),('15087','2014-02-17','09:25:00',1.98),('15087','2014-02-17','09:30:00',2.09),('15087','2014-02-17','09:35:00',2.16),('15087','2014-02-17','09:40:00',2.22),('15087','2014-02-17','09:45:00',2.28),('15087','2014-02-17','09:50:00',2.32),('15087','2014-02-17','09:55:00',2.37),('15087','2014-02-17','10:00:00',2.43),('15087','2014-02-17','10:05:00',2.49),('15087','2014-02-17','10:10:00',2.53),('15087','2014-02-17','10:15:00',2.56),('15087','2014-02-17','10:20:00',2.58),('15087','2014-02-17','10:25:00',2.62),('15087','2014-02-17','10:30:00',2.68),('15087','2014-02-17','10:35:00',2.68),('15087','2014-02-17','10:40:00',2.69),('15087','2014-02-17','10:45:00',2.71),('15087','2014-02-17','10:50:00',2.75),('15087','2014-02-17','10:55:00',2.8),('15087','2014-02-17','11:00:00',2.81),('15087','2014-02-17','11:05:00',2.87),('15087','2014-02-17','11:10:00',2.88),('15087','2014-02-17','11:15:00',2.95),('15087','2014-02-17','11:20:00',3),('15087','2014-02-17','11:25:00',3.07),('15087','2014-02-17','11:30:00',3.12),('15087','2014-02-17','11:35:00',3.18),('15087','2014-02-17','11:40:00',3.19),('15087','2014-02-17','11:45:00',3.24),('15087','2014-02-17','11:50:00',3.25),('15087','2014-02-17','11:55:00',3.25),('15087','2014-02-17','12:00:00',3.26),('15087','2014-02-17','12:05:00',3.27),('15087','2014-02-17','12:10:00',3.25),('15087','2014-02-17','12:15:00',3.24),('15087','2014-02-17','12:20:00',3.24),('15087','2014-02-17','12:25:00',3.25),('15087','2014-02-17','12:30:00',3.24),('15087','2014-02-17','12:35:00',3.24),('15087','2014-02-17','12:40:00',3.2),('15087','2014-02-17','12:45:00',3.19),('15087','2014-02-17','12:50:00',3.16),('15087','2014-02-17','12:55:00',2.99),('15087','2014-02-17','13:00:00',3.1),('15087','2014-02-17','13:05:00',3.06),('15087','2014-02-17','13:10:00',2.93),('15087','2014-02-17','13:15:00',2.99),('15087','2014-02-17','13:20:00',2.95),('15087','2014-02-17','13:25:00',2.8),('15087','2014-02-17','13:30:00',2.9),('15087','2014-02-17','13:35:00',2.86),('15087','2014-02-17','13:40:00',2.76),('15087','2014-02-17','13:45:00',2.63),('15087','2014-02-17','13:50:00',2.55),('15087','2014-02-17','13:55:00',2.44),('15087','2014-02-17','14:00:00',2.54),('15087','2014-02-17','14:05:00',2.46),('15087','2014-02-17','14:10:00',2.33),('15087','2014-02-17','14:15:00',2.32),('15087','2014-02-17','14:20:00',2.34),('15087','2014-02-17','14:25:00',2.22),('15087','2014-02-17','14:30:00',2.25),('15087','2014-02-17','14:35:00',2.12),('15087','2014-02-17','14:40:00',1.97),('15087','2014-02-17','14:45:00',2.13),('15087','2014-02-17','14:50:00',1.96),('15087','2014-02-17','14:55:00',1.82),('15087','2014-02-17','15:00:00',1.79),('15087','2014-02-17','15:05:00',1.73),('15087','2014-02-17','15:10:00',1.62),('15087','2014-02-17','15:15:00',1.74),('15087','2014-02-17','15:20:00',1.69),('15087','2014-02-17','15:25:00',1.51),('15087','2014-02-17','15:30:00',1.52),('15087','2014-02-17','15:35:00',1.42),('15087','2014-02-17','15:40:00',1.26),('15087','2014-02-17','15:45:00',1.24),('15087','2014-02-17','15:50:00',1.17),('15087','2014-02-17','15:55:00',1.07),('15087','2014-02-16','08:25:00',1.12),('15087','2014-02-16','08:30:00',1.26),('15087','2014-02-16','08:35:00',1.4),('15087','2014-02-16','08:40:00',1.38),('15087','2014-02-16','08:45:00',1.58),('15087','2014-02-16','08:50:00',1.49),('15087','2014-02-16','08:55:00',1.72),('15087','2014-02-16','09:00:00',1.86),('15087','2014-02-16','09:05:00',1.94),('15087','2014-02-16','09:10:00',1.87),('15087','2014-02-16','09:15:00',1.5),('15087','2014-02-16','09:20:00',2.08),('15087','2014-02-16','09:25:00',2.05),('15087','2014-02-16','09:30:00',2.11),('15087','2014-02-16','09:35:00',1.75),('15087','2014-02-16','09:40:00',2.29),('15087','2014-02-16','09:45:00',2.47),('15087','2014-02-16','09:50:00',2.55),('15087','2014-02-16','09:55:00',2.49),('15087','2014-02-16','10:00:00',2.45),('15087','2014-02-16','10:05:00',2.7),('15087','2014-02-16','10:10:00',2.75),('15087','2014-02-16','10:15:00',2.79),('15087','2014-02-16','10:20:00',2.88),('15087','2014-02-16','10:25:00',2.98),('15087','2014-02-16','10:30:00',3),('15087','2014-02-16','10:35:00',3.09),('15087','2014-02-16','10:40:00',3.19),('15087','2014-02-16','10:45:00',3.17),('15087','2014-02-16','10:50:00',2.72),('15087','2014-02-16','10:55:00',2.8),('15087','2014-02-16','11:00:00',3.22),('15087','2014-02-16','11:05:00',3.29),('15087','2014-02-16','11:10:00',3.13),('15087','2014-02-16','11:15:00',3.25),('15087','2014-02-16','11:20:00',3.13),('15087','2014-02-16','11:25:00',3.11),('15087','2014-02-16','11:30:00',3.18),('15087','2014-02-16','11:35:00',3.34),('15087','2014-02-16','11:40:00',3.31),('15087','2014-02-16','11:45:00',3.01),('15087','2014-02-16','11:50:00',3.31),('15087','2014-02-16','11:55:00',2.89),('15087','2014-02-16','12:00:00',3.42),('15087','2014-02-16','12:05:00',3.38),('15087','2014-02-16','12:10:00',3.39),('15087','2014-02-16','12:15:00',3.38),('15087','2014-02-16','12:20:00',3.4),('15087','2014-02-16','12:25:00',3.28),('15087','2014-02-16','12:30:00',3.34),('15087','2014-02-16','12:35:00',3.33),('15087','2014-02-16','12:40:00',3.31),('15087','2014-02-16','12:45:00',3.3),('15087','2014-02-16','12:50:00',3.28),('15087','2014-02-16','12:55:00',3.02),('15087','2014-02-16','13:00:00',3.25),('15087','2014-02-16','13:05:00',3.19),('15087','2014-02-16','13:10:00',2.86),('15087','2014-02-16','13:15:00',3.15),('15087','2014-02-16','13:20:00',3.06),('15087','2014-02-16','13:25:00',2.83),('15087','2014-02-16','13:30:00',2.98),('15087','2014-02-16','13:35:00',2.91),('15087','2014-02-16','13:40:00',2.72),('15087','2014-02-16','13:45:00',2.89),('15087','2014-02-16','13:50:00',2.78),('15087','2014-02-16','13:55:00',2.62),('15087','2014-02-16','14:00:00',2.75),('15087','2014-02-16','14:05:00',2.59),('15087','2014-02-16','14:10:00',2.37),('15087','2014-02-16','14:15:00',2.58),('15087','2014-02-16','14:20:00',2.58),('15087','2014-02-16','14:25:00',2.56),('15087','2014-02-16','14:30:00',2.45),('15087','2014-02-16','14:35:00',2.36),('15087','2014-02-16','14:40:00',2.11),('15087','2014-02-16','14:45:00',2.21),('15087','2014-02-16','14:50:00',2.13),('15087','2014-02-16','14:55:00',1.99),('15087','2014-02-16','15:00:00',1.96),('15087','2014-02-16','15:05:00',1.83),('15087','2014-02-16','15:10:00',1.74),('15087','2014-02-16','15:15:00',1.8),('15087','2014-02-16','15:20:00',1.59),('15087','2014-02-16','15:25:00',1.62),('15087','2014-02-16','15:30:00',1.55),('15087','2014-02-16','15:35:00',1.22),('15087','2014-02-16','15:40:00',1.08),('15087','2014-02-16','15:45:00',1.28),('15087','2014-02-16','16:25:00',1.05),('15087','2014-04-28','08:15:00',1.88),('15087','2014-04-28','08:20:00',1.99),('15087','2014-04-28','08:25:00',2.09),('15087','2014-04-28','08:30:00',1.27),('15087','2014-04-28','08:35:00',1.3),('15087','2014-04-28','08:40:00',1.31),('15087','2014-04-28','08:45:00',1.2),('15087','2014-04-28','08:50:00',1.26),('15087','2014-04-28','08:55:00',1.43),('15087','2014-04-28','09:00:00',1.02),('15087','2014-04-28','09:05:00',1.89),('15087','2014-04-28','09:10:00',3.01),('15087','2014-04-28','09:15:00',2.96),('15087','2014-04-28','09:20:00',2.28),('15087','2014-04-28','09:25:00',1.48),('15087','2014-04-28','09:30:00',3.38),('15087','2014-04-28','09:35:00',2.86),('15087','2014-04-28','09:40:00',2.12),('15087','2014-04-28','09:45:00',1.93),('15087','2014-04-28','09:50:00',1.64),('15087','2014-04-28','09:55:00',1.4),('15087','2014-04-28','10:00:00',2.47),('15087','2014-04-28','10:05:00',2.68),('15087','2014-04-28','10:10:00',2.58),('15087','2014-04-28','10:15:00',2.15),('15087','2014-04-28','10:20:00',1.67),('15087','2014-04-28','10:40:00',1.19),('15087','2014-04-28','10:45:00',1.85),('15087','2014-04-28','10:50:00',2.17),('15087','2014-04-28','10:55:00',1.98),('15087','2014-04-28','11:00:00',2.21),('15087','2014-04-28','11:05:00',2.74),('15087','2014-04-28','11:10:00',3.07),('15087','2014-04-28','11:15:00',2.85),('15087','2014-04-28','11:20:00',2.49),('15087','2014-04-28','11:25:00',2.08),('15087','2014-04-28','11:30:00',2.09),('15087','2014-04-28','11:35:00',1.79),('15087','2014-04-28','11:40:00',1.6),('15087','2014-04-28','11:45:00',1.86),('15087','2014-04-28','11:50:00',2.21),('15087','2014-04-28','11:55:00',2.27),('15087','2014-04-28','12:00:00',1.96),('15087','2014-04-28','12:05:00',1.59),('15087','2014-04-28','12:10:00',2.38),('15087','2014-04-28','12:15:00',3.18),('15087','2014-04-28','12:20:00',3.16),('15087','2014-04-28','12:25:00',3.1),('15087','2014-04-28','12:30:00',3.12),('15087','2014-04-28','12:35:00',2.75),('15087','2014-04-28','12:40:00',2.34),('15087','2014-04-28','12:45:00',2.19),('15087','2014-04-28','12:50:00',2.53),('15087','2014-04-28','12:55:00',2.52),('15087','2014-04-28','13:00:00',2.61),('15087','2014-04-28','13:05:00',3.96),('15087','2014-04-28','13:10:00',3.36),('15087','2014-04-28','13:15:00',2.48),('15087','2014-04-28','13:20:00',2.93),('15087','2014-04-28','13:25:00',3.85),('15087','2014-04-28','13:30:00',5.56),('15087','2014-04-28','13:35:00',4.7),('15087','2014-04-28','13:40:00',2.89),('15087','2014-04-28','13:45:00',4.5),('15087','2014-04-28','13:50:00',4.78),('15087','2014-04-28','13:55:00',2.91),('15087','2014-04-28','14:00:00',2.42),('15087','2014-04-28','14:05:00',4.23),('15087','2014-04-28','14:10:00',4.65),('15087','2014-04-28','14:15:00',2.84),('15087','2014-04-28','14:20:00',4.59),('15087','2014-04-28','14:25:00',3.26),('15087','2014-04-28','14:30:00',3.69),('15087','2014-04-28','14:35:00',2.48),('15087','2014-04-28','14:40:00',4.65),('15087','2014-04-28','14:45:00',3.89),('15087','2014-04-28','14:50:00',3.84),('15087','2014-04-28','14:55:00',4.22),('15087','2014-04-28','15:00:00',3.27),('15087','2014-04-28','15:05:00',3.28),('15087','2014-04-28','15:10:00',2.22),('15087','2014-04-28','15:15:00',2.96),('15087','2014-04-28','15:20:00',2.19),('15087','2014-04-28','15:25:00',1.61),('15087','2014-04-28','15:30:00',2.14),('15087','2014-04-28','15:35:00',3.64),('15087','2014-04-28','15:40:00',2.27),('15087','2014-04-28','15:45:00',3.26),('15087','2014-04-28','15:50:00',2.45),('15087','2014-04-28','15:55:00',1.46),('15087','2014-04-28','16:00:00',2.58),('15087','2014-04-28','16:05:00',2.82),('15087','2014-04-28','16:10:00',3.86),('15087','2014-04-28','16:15:00',2.11),('15087','2014-04-28','16:20:00',2.1),('15087','2014-04-28','16:25:00',2.09),('15087','2014-04-28','16:30:00',2.81),('15087','2014-04-28','16:35:00',2.85),('15087','2014-04-28','16:50:00',1.2),('15087','2014-04-28','16:55:00',1.8),('15087','2014-04-28','17:35:00',1.31),('15087','2014-04-28','17:40:00',1.4),('15087','2014-02-15','08:30:00',1.13),('15087','2014-02-15','08:35:00',1.22),('15087','2014-02-15','08:40:00',1.32),('15087','2014-02-15','08:45:00',1.42),('15087','2014-02-15','08:50:00',1.47),('15087','2014-02-15','08:55:00',1.5),('15087','2014-02-15','09:00:00',1.68),('15087','2014-02-15','09:05:00',1.76),('15087','2014-02-15','09:10:00',1.84),('15087','2014-02-15','09:15:00',1.91),('15087','2014-02-15','09:20:00',2.02),('15087','2014-02-15','09:25:00',2.07),('15087','2014-02-15','09:30:00',2.14),('15087','2014-02-15','09:35:00',2.21),('15087','2014-02-15','09:40:00',2.27),('15087','2014-02-15','09:45:00',2.35),('15087','2014-02-15','09:50:00',2.42),('15087','2014-02-15','09:55:00',2.48),('15087','2014-02-15','10:00:00',2.52),('15087','2014-02-15','10:05:00',2.59),('15087','2014-02-15','10:10:00',2.64),('15087','2014-02-15','10:15:00',2.68),('15087','2014-02-15','10:20:00',2.72),('15087','2014-02-15','10:25:00',2.74),('15087','2014-02-15','10:30:00',2.77),('15087','2014-02-15','10:35:00',2.79),('15087','2014-02-15','10:40:00',2.82),('15087','2014-02-15','10:45:00',2.9),('15087','2014-02-15','10:50:00',2.93),('15087','2014-02-15','10:55:00',2.97),('15087','2014-02-15','11:00:00',2.4),('15087','2014-02-15','11:05:00',3.09),('15087','2014-02-15','11:10:00',3.15),('15087','2014-02-15','11:15:00',2.36),('15087','2014-02-15','11:20:00',1.88),('15087','2014-02-15','11:25:00',3.48),('15087','2014-02-15','11:30:00',2.82),('15087','2014-02-15','11:35:00',2.46),('15087','2014-02-15','11:40:00',3.64),('15087','2014-02-15','11:45:00',3.66),('15087','2014-02-15','11:50:00',2.73),('15087','2014-02-15','11:55:00',2.2),('15087','2014-02-15','12:00:00',1.12),('15087','2014-02-15','12:05:00',1.41),('15087','2014-02-15','12:10:00',3.76),('15087','2014-02-15','12:15:00',3.58),('15087','2014-02-15','12:20:00',3.19),('15087','2014-02-15','12:25:00',1.22),('15087','2014-02-15','12:30:00',2.83),('15087','2014-02-15','12:35:00',3.69),('15087','2014-02-15','12:40:00',3.11),('15087','2014-02-15','12:45:00',3.92),('15087','2014-02-15','12:50:00',3.82),('15087','2014-02-15','12:55:00',2.57),('15087','2014-02-15','13:00:00',3.42),('15087','2014-02-15','13:05:00',3.71),('15087','2014-02-15','13:10:00',3.46),('15087','2014-02-15','13:15:00',3.16),('15087','2014-02-15','13:20:00',3.19),('15087','2014-02-15','13:25:00',2.9),('15087','2014-02-15','13:30:00',3.01),('15087','2014-02-15','13:35:00',3.01),('15087','2014-02-15','13:40:00',2.81),('15087','2014-02-15','13:45:00',2.84),('15087','2014-02-15','13:50:00',2.85),('15087','2014-02-15','13:55:00',2.68),('15087','2014-02-15','14:00:00',2.65),('15087','2014-02-15','14:05:00',2.63),('15087','2014-02-15','14:10:00',2.57),('15087','2014-02-15','14:15:00',2.5),('15087','2014-02-15','14:20:00',2.51),('15087','2014-02-15','14:25:00',2.45),('15087','2014-02-15','14:30:00',2.2),('15087','2014-02-15','14:35:00',2.25),('15087','2014-02-15','14:40:00',2.12),('15087','2014-02-15','14:45:00',2.08),('15087','2014-02-15','14:50:00',1.88),('15087','2014-02-15','14:55:00',1.85),('15087','2014-02-15','15:00:00',1.89),('15087','2014-02-15','15:05:00',1.74),('15087','2014-02-15','15:10:00',1.71),('15087','2014-02-15','15:15:00',1.69),('15087','2014-02-15','15:20:00',1.63),('15087','2014-02-15','15:25:00',1.56),('15087','2014-02-15','15:30:00',1.48),('15087','2014-02-15','15:35:00',1.32),('15087','2014-02-15','15:40:00',1.24),('15087','2014-02-15','15:45:00',1.2),('15087','2014-02-15','15:50:00',1.12),('15087','2014-02-15','15:55:00',1.02),('15087','2014-02-14','08:45:00',1.2),('15087','2014-02-14','08:50:00',1.49),('15087','2014-02-14','08:55:00',1.57),('15087','2014-02-14','09:00:00',1.64),('15087','2014-02-14','09:05:00',1.73),('15087','2014-02-14','09:10:00',1.46),('15087','2014-02-14','09:15:00',1.55),('15087','2014-02-14','09:20:00',1.97),('15087','2014-02-14','09:25:00',2.21),('15087','2014-02-14','09:30:00',1.84),('15087','2014-02-14','09:35:00',1.47),('15087','2014-02-14','09:45:00',1.39),('15087','2014-02-14','09:50:00',2.8),('15087','2014-02-14','09:55:00',2.48),('15087','2014-02-14','10:00:00',2.71),('15087','2014-02-14','10:05:00',2.8),('15087','2014-02-14','10:10:00',2.85),('15087','2014-02-14','10:15:00',1.71),('15087','2014-02-14','10:20:00',3.08),('15087','2014-02-14','10:25:00',3.01),('15087','2014-02-14','10:30:00',3.03),('15087','2014-02-14','10:35:00',2.84),('15087','2014-02-14','10:40:00',3.07),('15087','2014-02-14','10:45:00',3.19),('15087','2014-02-14','10:50:00',3.21),('15087','2014-02-14','10:55:00',3.22),('15087','2014-02-14','11:00:00',3.28),('15087','2014-02-14','11:05:00',3.29),('15087','2014-02-14','11:10:00',3.3),('15087','2014-02-14','11:15:00',3.34),('15087','2014-02-14','11:20:00',3.39),('15087','2014-02-14','11:25:00',3.41),('15087','2014-02-14','11:30:00',3.46),('15087','2014-02-14','11:35:00',3.47),('15087','2014-02-14','11:40:00',3.48),('15087','2014-02-14','11:45:00',3.51),('15087','2014-02-14','11:50:00',3.5),('15087','2014-02-14','11:55:00',3.54),('15087','2014-02-14','12:00:00',3.1),('15087','2014-02-14','12:05:00',3.53),('15087','2014-02-14','12:10:00',3.59),('15087','2014-02-14','12:15:00',3.52),('15087','2014-02-14','12:20:00',3.53),('15087','2014-02-14','12:25:00',3.53),('15087','2014-02-14','12:30:00',3.5),('15087','2014-02-14','12:35:00',3.52),('15087','2014-02-14','12:40:00',3.49),('15087','2014-02-14','12:45:00',3.47),('15087','2014-02-14','12:50:00',3.41),('15087','2014-02-14','12:55:00',3.31),('15087','2014-02-14','13:00:00',3.37),('15087','2014-02-14','13:05:00',3.3),('15087','2014-02-14','13:10:00',2.97),('15087','2014-02-14','13:15:00',2.9),('15087','2014-02-14','13:20:00',3.01),('15087','2014-02-14','13:25:00',2.85),('15087','2014-02-14','13:30:00',2.8),('15087','2014-02-14','13:35:00',2.92),('15087','2014-02-14','13:40:00',2.97),('15087','2014-02-14','13:45:00',2.91),('15087','2014-02-14','13:50:00',2.86),('15087','2014-02-14','13:55:00',2.84),('15087','2014-02-14','14:00:00',2.77),('15087','2014-02-14','14:05:00',2.67),('15087','2014-02-14','14:10:00',2.66),('15087','2014-02-14','14:15:00',2.6),('15087','2014-02-14','14:20:00',2.55),('15087','2014-02-14','14:25:00',2.51),('15087','2014-02-14','14:30:00',2.4),('15087','2014-02-14','14:35:00',2.29),('15087','2014-02-14','14:40:00',2.22),('15087','2014-02-14','14:45:00',1.95),('15087','2014-02-14','14:50:00',2.02),('15087','2014-02-14','14:55:00',1.88),('15087','2014-02-14','15:00:00',1.82),('15087','2014-02-14','15:05:00',1.81),('15087','2014-02-14','15:10:00',1.78),('15087','2014-02-14','15:15:00',1.77),('15087','2014-02-14','15:20:00',1.73),('15087','2014-02-14','15:25:00',1.51),('15087','2014-02-14','15:30:00',1.41),('15087','2014-02-14','15:35:00',1.36),('15087','2014-02-14','15:40:00',1.24),('15087','2014-02-14','15:45:00',1.17),('15087','2014-02-14','15:50:00',1.11),('15087','2014-02-14','15:55:00',1.01),('15087','2014-02-12','08:45:00',1.4),('15087','2014-02-12','08:50:00',1.45),('15087','2014-02-12','08:55:00',1.19),('15087','2014-02-12','09:10:00',1.53),('15087','2014-02-12','09:15:00',1.91),('15087','2014-02-12','09:20:00',1.74),('15087','2014-02-12','09:25:00',1.77),('15087','2014-02-12','09:40:00',1.9),('15087','2014-02-12','09:45:00',2.33),('15087','2014-02-12','09:50:00',2.47),('15087','2014-02-12','09:55:00',1.04),('15087','2014-02-12','10:00:00',1.12),('15087','2014-02-12','10:05:00',1.65),('15087','2014-02-12','10:10:00',1.46),('15087','2014-02-12','10:15:00',1.13),('15087','2014-02-12','10:20:00',1.06),('15087','2014-02-12','10:25:00',1.14),('15087','2014-02-12','10:30:00',1.49),('15087','2014-02-12','10:35:00',1.58),('15087','2014-02-12','10:40:00',1.39),('15087','2014-02-12','10:45:00',1.92),('15087','2014-02-12','10:50:00',1.47),('15087','2014-02-12','10:55:00',1.5),('15087','2014-02-12','11:00:00',1.59),('15087','2014-02-12','11:05:00',2.28),('15087','2014-02-12','11:10:00',1.66),('15087','2014-02-12','11:15:00',1.54),('15087','2014-02-12','11:20:00',1.55),('15087','2014-02-12','11:25:00',1.71),('15087','2014-02-12','11:30:00',1.7),('15087','2014-02-12','11:35:00',2.29),('15087','2014-02-12','11:40:00',1.14),('15087','2014-02-12','12:10:00',1.24),('15087','2014-02-12','12:15:00',1.38),('15087','2014-02-12','12:20:00',1.4),('15087','2014-02-12','12:25:00',1.47),('15087','2014-02-12','12:30:00',1.54),('15087','2014-02-12','12:35:00',1.48),('15087','2014-02-12','12:40:00',1.46),('15087','2014-02-12','12:45:00',1.63),('15087','2014-02-12','12:50:00',1.79),('15087','2014-02-12','12:55:00',1.89),('15087','2014-02-12','13:00:00',2.2),('15087','2014-02-12','13:05:00',1.99),('15087','2014-02-12','13:10:00',2.02),('15087','2014-02-12','13:15:00',1.36),('15087','2014-02-12','13:20:00',1.31),('15087','2014-02-12','13:25:00',1.71),('15087','2014-02-12','13:30:00',2.69),('15087','2014-02-12','13:35:00',2.85),('15087','2014-02-11','09:20:00',1.17),('15087','2014-02-11','09:25:00',1.33),('15087','2014-02-11','09:30:00',1.31),('15087','2014-02-11','09:35:00',1.32),('15087','2014-02-11','09:40:00',1.25),('15087','2014-02-11','09:45:00',1.24),('15087','2014-02-11','09:50:00',1.36),('15087','2014-02-11','09:55:00',1.34),('15087','2014-02-11','10:00:00',1.12),('15087','2014-02-11','10:15:00',1.66),('15087','2014-02-11','10:20:00',2.07),('15087','2014-02-11','10:25:00',2.13),('15087','2014-02-11','10:30:00',2.29),('15087','2014-02-11','10:35:00',2),('15087','2014-02-11','10:40:00',2.41),('15087','2014-02-11','10:45:00',2.34),('15087','2014-02-11','10:50:00',2.53),('15087','2014-02-11','10:55:00',1.68),('15087','2014-02-11','11:00:00',2.13),('15087','2014-02-11','11:05:00',2.23),('15087','2014-02-11','11:10:00',2.26),('15087','2014-02-11','11:15:00',1.77),('15087','2014-02-11','11:20:00',1.59),('15087','2014-02-11','11:25:00',1.77),('15087','2014-02-11','11:30:00',1.95),('15087','2014-02-11','11:35:00',1.55),('15087','2014-02-11','11:40:00',1.66),('15087','2014-02-11','11:45:00',2.25),('15087','2014-02-11','11:50:00',1.41),('15087','2014-02-11','11:55:00',1.24),('15087','2014-02-11','12:00:00',1.34),('15087','2014-02-11','12:05:00',1.7),('15087','2014-02-11','12:10:00',1.96),('15087','2014-02-11','12:15:00',1.71),('15087','2014-02-11','12:20:00',1.84),('15087','2014-02-11','12:25:00',2.47),('15087','2014-02-11','12:30:00',2.37),('15087','2014-02-11','12:35:00',2.13),('15087','2014-02-11','12:40:00',1.54),('15087','2014-02-11','12:45:00',1.86),('15087','2014-02-11','12:50:00',1.45),('15087','2014-02-11','12:55:00',1.83),('15087','2014-02-11','13:00:00',1.89),('15087','2014-02-11','13:05:00',2.36),('15087','2014-02-11','13:10:00',2.92),('15087','2014-02-11','13:15:00',2.71),('15087','2014-02-11','13:20:00',3.09),('15087','2014-02-11','13:25:00',2.77),('15087','2014-02-11','13:30:00',2.56),('15087','2014-02-11','13:35:00',2.38),('15087','2014-02-11','13:40:00',2.74),('15087','2014-02-11','13:45:00',2.07),('15087','2014-02-11','13:50:00',1.73),('15087','2014-02-11','13:55:00',1.4),('15087','2014-02-11','14:00:00',1.93),('15087','2014-02-11','14:05:00',2.24),('15087','2014-02-11','14:10:00',1.56),('15087','2014-02-11','14:15:00',2.21),('15087','2014-02-11','14:20:00',1.58),('15087','2014-02-11','14:25:00',1.45),('15087','2014-02-11','14:30:00',1.46),('15087','2014-02-11','14:35:00',1.39),('15087','2014-02-11','14:40:00',1.11),('15087','2014-02-11','14:45:00',1.14),('15087','2014-02-11','15:15:00',1.33),('15087','2014-02-11','15:20:00',1.39),('15087','2014-02-11','15:25:00',1.11),('15087','2014-02-10','12:55:00',1.01),('15087','2014-02-10','13:00:00',1.37),('15087','2014-02-10','13:05:00',1.12),('15087','2014-02-10','14:00:00',1.03),('15087','2014-02-10','14:30:00',1.03),('15087','2014-02-10','14:35:00',1.11),('15087','2014-02-10','14:40:00',1.16),('15087','2014-02-10','14:45:00',1.05),('15087','2014-02-09','11:25:00',1.05),('15087','2014-02-09','11:30:00',1.19),('15087','2014-02-09','11:35:00',1.53),('15087','2014-02-08','09:50:00',2.54),('15087','2014-02-08','09:55:00',1.08),('15087','2014-02-08','10:15:00',1.55),('15087','2014-02-08','10:20:00',1.11),('15087','2014-02-08','10:25:00',1.12),('15087','2014-02-08','10:30:00',2.44),('15087','2014-02-08','10:35:00',2.64),('15087','2014-02-08','10:40:00',1.15),('15087','2014-02-08','10:45:00',1.66),('15087','2014-02-08','10:50:00',2.19),('15087','2014-02-08','10:55:00',2.24),('15087','2014-02-08','11:00:00',2.17),('15087','2014-02-08','11:05:00',3.32),('15087','2014-02-08','11:10:00',2.14),('15087','2014-02-08','11:15:00',2.14),('15087','2014-02-08','11:20:00',1.04),('15087','2014-02-08','11:30:00',2.45),('15087','2014-02-08','11:35:00',3.69),('15087','2014-02-08','11:40:00',1.67),('15087','2014-02-08','11:50:00',2.16),('15087','2014-02-08','11:55:00',3.62),('15087','2014-02-08','12:05:00',1.37),('15087','2014-02-08','12:10:00',2.65),('15087','2014-02-08','12:15:00',2.92),('15087','2014-02-08','12:25:00',3.41),('15087','2014-02-08','12:30:00',3.43),('15087','2014-02-08','12:35:00',2.89),('15087','2014-02-08','12:40:00',1.82),('15087','2014-02-08','12:45:00',3.82),('15087','2014-02-08','12:50:00',2.82),('15087','2014-02-08','12:55:00',3.11),('15087','2014-02-08','13:00:00',2.44),('15087','2014-02-08','13:10:00',2.59),('15087','2014-02-08','13:15:00',4.1),('15087','2014-02-08','13:20:00',3.55),('15087','2014-02-08','13:25:00',2.82),('15087','2014-02-08','13:30:00',1.78),('15087','2014-02-08','13:35:00',2.55),('15087','2014-02-08','13:40:00',2.75),('15087','2014-02-08','13:45:00',3.2),('15087','2014-02-08','13:50:00',2.66),('15087','2014-02-08','13:55:00',2.74),('15087','2014-02-08','14:00:00',2.73),('15087','2014-02-08','14:05:00',2.61),('15087','2014-02-08','14:10:00',2.47),('15087','2014-02-08','14:15:00',1.35),('15087','2014-02-08','14:20:00',2.05),('15087','2014-02-08','14:25:00',1.8),('15087','2014-02-08','14:30:00',2.55),('15087','2014-02-08','14:35:00',1.32),('15087','2014-02-08','14:40:00',1.38),('15087','2014-02-08','14:50:00',2.23),('15087','2014-02-08','14:55:00',2.05),('15087','2014-02-08','15:15:00',1.07),('15087','2014-02-08','15:20:00',1.8),('15087','2014-02-08','15:40:00',1.58),('15087','2014-02-08','15:45:00',1.47),('15087','2014-02-08','15:50:00',1.17),('15087','2014-02-07','08:40:00',1.01),('15087','2014-02-07','08:45:00',1.17),('15087','2014-02-07','08:50:00',1.31),('15087','2014-02-07','08:55:00',1.43),('15087','2014-02-07','09:00:00',1.54),('15087','2014-02-07','09:05:00',1.65),('15087','2014-02-07','09:10:00',1.73),('15087','2014-02-07','09:15:00',1.82),('15087','2014-02-07','09:20:00',1.86),('15087','2014-02-07','09:25:00',1.97),('15087','2014-02-07','09:30:00',2.04),('15087','2014-02-07','09:35:00',2.1),('15087','2014-02-07','09:40:00',2.16),('15087','2014-02-07','09:45:00',2.22),('15087','2014-02-07','09:50:00',2.28),('15087','2014-02-07','09:55:00',2.33),('15087','2014-02-07','10:00:00',2.41),('15087','2014-02-07','10:05:00',2.47),('15087','2014-02-07','10:10:00',2.54),('15087','2014-02-07','10:15:00',2.71),('15087','2014-02-07','10:20:00',2.76),('15087','2014-02-07','10:25:00',2.73),('15087','2014-02-07','10:30:00',2.41),('15087','2014-02-07','10:35:00',2.78),('15087','2014-02-07','10:40:00',2.1),('15087','2014-02-07','10:45:00',2.89),('15087','2014-02-07','10:50:00',3.22),('15087','2014-02-07','10:55:00',3.12),('15087','2014-02-07','11:00:00',3.42),('15087','2014-02-07','11:05:00',3.4),('15087','2014-02-07','11:10:00',3.54),('15087','2014-02-07','11:15:00',3.58),('15087','2014-02-07','11:20:00',3.47),('15087','2014-02-07','11:25:00',2.02),('15087','2014-02-07','11:30:00',3.45),('15087','2014-02-07','11:35:00',3.11),('15087','2014-02-07','11:40:00',3.48),('15087','2014-02-07','11:45:00',2.88),('15087','2014-02-07','11:50:00',2.76),('15087','2014-02-07','11:55:00',3.27),('15087','2014-02-07','12:00:00',2.8),('15087','2014-02-07','12:05:00',1.99),('15087','2014-02-07','12:10:00',1.84),('15087','2014-02-07','12:15:00',3.96),('15087','2014-02-07','12:20:00',2.71),('15087','2014-02-07','12:25:00',1.52),('15087','2014-02-07','12:30:00',1.99),('15087','2014-02-07','12:35:00',1.13),('15087','2014-02-07','12:40:00',1.64),('15087','2014-02-07','12:45:00',2.57),('15087','2014-02-07','12:50:00',4.14),('15087','2014-02-07','12:55:00',3.95),('15087','2014-02-07','13:00:00',1.39),('15087','2014-02-07','13:05:00',2.82),('15087','2014-02-07','13:10:00',3.21),('15087','2014-02-07','13:15:00',1.14),('15087','2014-02-07','13:20:00',1.98),('15087','2014-02-07','13:25:00',1.04),('15087','2014-02-07','13:30:00',1.21),('15087','2014-02-07','13:35:00',2.05),('15087','2014-02-07','13:45:00',2.96),('15087','2014-02-07','13:50:00',2.98),('15087','2014-02-07','13:55:00',3.03),('15087','2014-02-07','14:00:00',1.71),('15087','2014-02-07','14:05:00',2.16),('15087','2014-02-07','14:10:00',2.67),('15087','2014-02-07','14:15:00',2.56),('15087','2014-02-07','14:20:00',2.08),('15087','2014-02-07','14:25:00',1.48),('15087','2014-02-07','14:30:00',2.16),('15087','2014-02-07','14:35:00',2.69),('15087','2014-02-07','14:40:00',2.44),('15087','2014-02-07','14:45:00',2.08),('15087','2014-02-07','14:50:00',2.01),('15087','2014-02-07','14:55:00',1.92),('15087','2014-02-07','15:00:00',1.78),('15087','2014-02-07','15:05:00',1.76),('15087','2014-02-07','15:10:00',1.69),('15087','2014-02-07','15:15:00',1.63),('15087','2014-02-07','15:20:00',1.61),('15087','2014-02-07','15:25:00',1.38),('15087','2014-02-07','15:30:00',1.37),('15087','2014-02-07','15:35:00',1.32),('15087','2014-02-07','15:40:00',1.25),('15087','2014-02-07','15:45:00',1.18),('15087','2014-02-07','15:50:00',1.11),('15087','2014-02-07','15:55:00',1.06),('15087','2014-02-06','08:45:00',1.04),('15087','2014-02-06','08:50:00',1.26),('15087','2014-02-06','08:55:00',1.58),('15087','2014-02-06','09:00:00',1.91),('15087','2014-02-06','09:05:00',2.12),('15087','2014-02-06','09:10:00',1.98),('15087','2014-02-06','09:15:00',1.79),('15087','2014-02-06','09:30:00',1.68),('15087','2014-02-06','09:35:00',2.17),('15087','2014-02-06','09:40:00',2.17),('15087','2014-02-06','09:45:00',2.28),('15087','2014-02-06','09:50:00',2.33),('15087','2014-02-06','09:55:00',2.41),('15087','2014-02-06','10:00:00',2.47),('15087','2014-02-06','10:05:00',2.53),('15087','2014-02-06','10:10:00',2.58),('15087','2014-02-06','10:15:00',2.66),('15087','2014-02-06','10:20:00',2.71),('15087','2014-02-06','10:25:00',2.54),('15087','2014-02-06','10:30:00',2.82),('15087','2014-02-06','10:35:00',2.47),('15087','2014-02-06','10:40:00',2.56),('15087','2014-02-06','10:45:00',2.44),('15087','2014-02-06','10:50:00',2.25),('15087','2014-02-06','10:55:00',2.56),('15087','2014-02-06','11:00:00',2.28),('15087','2014-02-06','11:05:00',2.1),('15087','2014-02-06','11:10:00',1.56),('15087','2014-02-06','11:15:00',1.52),('15087','2014-02-06','11:20:00',3.3),('15087','2014-02-06','11:25:00',2.17),('15087','2014-02-06','11:30:00',3.68),('15087','2014-02-06','11:35:00',3.42),('15087','2014-02-06','11:40:00',3.34),('15087','2014-02-06','11:45:00',3.38),('15087','2014-02-06','11:50:00',3.42),('15087','2014-02-06','11:55:00',3.43),('15087','2014-02-06','12:00:00',3.46),('15087','2014-02-06','12:05:00',3.55),('15087','2014-02-06','12:10:00',3.51),('15087','2014-02-06','12:15:00',3.49),('15087','2014-02-06','12:20:00',3.49),('15087','2014-02-06','12:25:00',3.45),('15087','2014-02-06','12:30:00',3.44),('15087','2014-02-06','12:35:00',2.97),('15087','2014-02-06','12:40:00',3.52),('15087','2014-02-06','12:45:00',3.46),('15087','2014-02-06','12:50:00',3.33),('15087','2014-02-06','12:55:00',3.04),('15087','2014-02-06','13:00:00',3.33),('15087','2014-02-06','13:05:00',2.66),('15087','2014-02-06','13:10:00',3.36),('15087','2014-02-06','13:15:00',3.28),('15087','2014-02-06','13:20:00',3.16),('15087','2014-02-06','13:25:00',1.77),('15087','2014-02-06','13:30:00',3.19),('15087','2014-02-06','13:35:00',2.93),('15087','2014-02-06','13:40:00',2.85),('15087','2014-02-06','13:45:00',2.88),('15087','2014-02-06','13:50:00',2.74),('15087','2014-02-06','13:55:00',2.7),('15087','2014-02-06','14:00:00',2.58),('15087','2014-02-06','14:05:00',2.48),('15087','2014-02-06','14:10:00',2.08),('15087','2014-02-06','14:15:00',2.39),('15087','2014-02-06','14:20:00',2.34),('15087','2014-02-06','14:25:00',2.31),('15087','2014-02-06','14:30:00',2.47),('15087','2014-02-06','14:35:00',2.35),('15087','2014-02-06','14:40:00',2.1),('15087','2014-02-06','14:45:00',2.23),('15087','2014-02-06','14:50:00',2.08),('15087','2014-02-06','14:55:00',1.93),('15087','2014-02-06','15:00:00',1.87),('15087','2014-02-06','15:05:00',1.75),('15087','2014-02-06','15:10:00',1.7),('15087','2014-02-06','15:15:00',1.62),('15087','2014-02-06','15:20:00',1.61),('15087','2014-02-06','15:25:00',1.37),('15087','2014-02-06','15:30:00',1.34),('15087','2014-02-06','15:35:00',1.27),('15087','2014-02-06','15:40:00',1.18),('15087','2014-02-06','15:45:00',1.14),('15087','2014-02-06','15:50:00',1.05),('15087','2014-02-06','15:55:00',1.01),('15087','2014-02-05','10:15:00',1.87),('15087','2014-02-05','10:20:00',3.17),('15087','2014-02-05','10:25:00',2.95),('15087','2014-02-05','10:35:00',1.1),('15087','2014-02-05','10:40:00',1.59),('15087','2014-02-05','11:10:00',1),('15087','2014-02-05','11:15:00',2.51),('15087','2014-02-05','11:20:00',4.15),('15087','2014-02-05','11:25:00',2.12),('15087','2014-02-05','11:30:00',1.35),('15087','2014-02-05','12:55:00',1.42),('15087','2014-02-05','13:00:00',1.11),('15087','2014-02-05','13:05:00',1.28),('15087','2014-02-05','13:10:00',1.66),('15087','2014-02-05','13:15:00',1.33),('15087','2014-02-05','13:20:00',1.63),('15087','2014-02-05','13:25:00',1.8),('15087','2014-02-05','13:30:00',1.78),('15087','2014-02-05','13:35:00',2.14),('15087','2014-02-05','13:40:00',2.2),('15087','2014-02-05','13:45:00',2.1),('15087','2014-02-05','13:50:00',1.87),('15087','2014-02-05','13:55:00',1.29),('15087','2014-02-05','14:30:00',2.72),('15087','2014-02-05','14:35:00',1.76),('15087','2014-02-04','09:15:00',1.14),('15087','2014-02-04','09:20:00',1.46),('15087','2014-02-04','09:25:00',1.47),('15087','2014-02-04','09:30:00',1.68),('15087','2014-02-04','09:35:00',1.45),('15087','2014-02-04','09:40:00',2.18),('15087','2014-02-04','09:45:00',2.33),('15087','2014-02-04','09:50:00',2.39),('15087','2014-02-04','09:55:00',1.5),('15087','2014-02-04','10:00:00',2.33),('15087','2014-02-04','10:05:00',2.73),('15087','2014-02-04','10:10:00',2.09),('15087','2014-02-04','10:15:00',1.82),('15087','2014-02-04','10:20:00',1.67),('15087','2014-02-04','10:40:00',1.22),('15087','2014-02-04','10:45:00',1.5),('15087','2014-02-04','10:50:00',2.25),('15087','2014-02-04','10:55:00',2.76),('15087','2014-02-04','11:00:00',3.51),('15087','2014-02-04','11:05:00',1.56),('15087','2014-02-04','11:10:00',1.15),('15087','2014-02-04','11:20:00',1.2),('15087','2014-02-04','11:25:00',1.01),('15087','2014-02-04','11:30:00',1.1),('15087','2014-02-04','11:50:00',1.64),('15087','2014-02-04','11:55:00',3.05),('15087','2014-02-04','12:00:00',2.79),('15087','2014-02-04','12:05:00',1.94),('15087','2014-02-04','12:10:00',2.13),('15087','2014-02-04','12:15:00',1.73),('15087','2014-02-04','12:20:00',1.73),('15087','2014-02-04','12:25:00',1.41),('15087','2014-02-04','12:45:00',1.18),('15087','2014-02-04','12:50:00',1.16),('15087','2014-02-04','12:55:00',1.07),('15087','2014-02-04','13:00:00',1.36),('15087','2014-02-04','13:05:00',1.38),('15087','2014-02-04','13:10:00',1.21),('15087','2014-02-04','13:15:00',1.42),('15087','2014-02-04','13:20:00',1.98),('15087','2014-02-04','13:25:00',1.68),('15087','2014-02-04','13:30:00',1.23),('15087','2014-02-04','13:35:00',1.07),('15087','2014-02-03','09:50:00',1.01),('15087','2014-02-03','10:15:00',1.13),('15087','2014-02-03','10:20:00',1.04),('15087','2014-02-03','10:25:00',1.07),('15087','2014-02-03','10:30:00',1.09),('15087','2014-02-03','10:35:00',1.09),('15087','2014-02-03','10:40:00',1.15),('15087','2014-02-03','10:45:00',1.18),('15087','2014-02-03','10:50:00',1.16),('15087','2014-02-03','10:55:00',1.16),('15087','2014-02-03','11:00:00',1.07),('15087','2014-02-03','11:05:00',1.04),('15087','2014-02-03','11:10:00',1.02),('15087','2014-02-03','11:15:00',1),('15087','2014-02-03','11:20:00',1.06),('15087','2014-02-03','11:25:00',1.19),('15087','2014-02-03','11:30:00',1.36),('15087','2014-02-03','11:35:00',1.42),('15087','2014-02-03','11:40:00',1.43),('15087','2014-02-03','11:45:00',1.46),('15087','2014-02-03','11:50:00',1.42),('15087','2014-02-03','11:55:00',1.28),('15087','2014-02-03','12:00:00',1.12),('15087','2014-02-03','12:05:00',1.03),('15087','2014-02-03','12:10:00',1.03),('15087','2014-02-03','12:15:00',1.11),('15087','2014-02-03','12:20:00',1.11),('15087','2014-02-03','12:25:00',1),('15087','2014-02-02','12:00:00',1.01),('15087','2014-02-02','12:05:00',1.04),('15087','2014-02-02','12:10:00',1.01),('15087','2014-02-01','11:00:00',1.19),('15087','2014-02-01','11:05:00',1.03),('15087','2014-02-01','11:15:00',1.01),('15087','2014-02-01','11:20:00',1.83),('15087','2014-02-01','11:25:00',1.31),('15087','2014-02-01','11:30:00',1.64),('15087','2014-02-01','11:35:00',1.66),('15087','2014-02-01','11:55:00',1.56),('15087','2014-02-01','12:00:00',1.31),('15087','2014-02-01','12:05:00',1.19),('15087','2014-02-01','12:10:00',2.1),('15087','2014-02-01','12:15:00',1.42),('15087','2014-02-01','12:20:00',2.4),('15087','2014-02-01','12:25:00',1.8),('15087','2014-02-01','12:35:00',1.01),('15087','2014-02-01','12:40:00',1.3),('15087','2014-02-01','12:45:00',2.16),('15087','2014-02-01','12:50:00',2.21),('15087','2014-02-01','12:55:00',1.78),('15087','2014-02-01','13:00:00',1.79),('15087','2014-02-01','13:05:00',1.25),('15087','2014-01-30','09:50:00',1.33),('15087','2014-01-30','09:55:00',2.01),('15087','2014-01-30','10:00:00',1.91),('15087','2014-01-30','10:05:00',1.38),('15087','2014-01-30','10:10:00',1.81),('15087','2014-01-30','10:15:00',2.39),('15087','2014-01-30','10:20:00',2.05),('15087','2014-01-30','10:25:00',2.47),('15087','2014-01-30','10:30:00',2.66),('15087','2014-01-30','10:35:00',2.68),('15087','2014-01-30','10:40:00',2.71),('15087','2014-01-30','10:45:00',2.36),('15087','2014-01-30','10:50:00',2.96),('15087','2014-01-30','10:55:00',3.41),('15087','2014-01-30','11:00:00',3.38),('15087','2014-01-30','11:05:00',3.22),('15087','2014-01-30','11:10:00',2.69),('15087','2014-01-30','11:15:00',2.66),('15087','2014-01-30','11:20:00',1.76),('15087','2014-01-30','11:25:00',2.61),('15087','2014-01-30','11:30:00',2.46),('15087','2014-01-30','11:35:00',2.64),('15087','2014-01-30','11:40:00',2.18),('15087','2014-01-30','11:45:00',3.15),('15087','2014-01-30','11:50:00',3.21),('15087','2014-01-30','11:55:00',3.11),('15087','2014-01-30','12:00:00',2.6),('15087','2014-01-30','12:05:00',3.31),('15087','2014-01-30','12:10:00',3.32),('15087','2014-01-30','12:15:00',3),('15087','2014-01-30','12:20:00',3.46),('15087','2014-01-30','12:25:00',2.82),('15087','2014-01-30','12:30:00',2.62),('15087','2014-01-30','12:35:00',2.69),('15087','2014-01-30','12:40:00',2.59),('15087','2014-01-30','12:45:00',3.13),('15087','2014-01-30','12:50:00',3.14),('15087','2014-01-30','12:55:00',2.97),('15087','2014-01-30','13:00:00',3.13),('15087','2014-01-30','13:05:00',3.22),('15087','2014-01-30','13:10:00',2.6),('15087','2014-01-30','13:15:00',2.87),('15087','2014-01-30','13:20:00',2.51),('15087','2014-01-30','13:25:00',2.61),('15087','2014-01-30','13:30:00',2.16),('15087','2014-01-30','13:35:00',1.98),('15087','2014-01-30','13:40:00',2.5),('15087','2014-01-30','13:45:00',2.65),('15087','2014-01-30','13:50:00',2.33),('15087','2014-01-30','13:55:00',2.13),('15087','2014-01-30','14:00:00',2.17),('15087','2014-01-30','14:05:00',1.94),('15087','2014-01-30','14:10:00',1.98),('15087','2014-01-30','14:15:00',1.78),('15087','2014-01-30','14:20:00',1.63),('15087','2014-01-30','14:25:00',1.76),('15087','2014-01-30','14:30:00',1.84),('15087','2014-01-30','14:35:00',1.69),('15087','2014-01-30','14:40:00',1.93),('15087','2014-01-30','14:45:00',1.81),('15087','2014-01-30','14:50:00',1.85),('15087','2014-01-30','14:55:00',1.71),('15087','2014-01-30','15:00:00',1.65),('15087','2014-01-30','15:05:00',1.63),('15087','2014-01-30','15:10:00',1.55),('15087','2014-01-30','15:15:00',1.46),('15087','2014-01-30','15:20:00',1.47),('15087','2014-01-30','15:25:00',1.42),('15087','2014-01-30','15:30:00',1.27),('15087','2014-01-30','15:35:00',1.25),('15087','2014-01-30','15:40:00',1.14),('15087','2014-01-29','09:20:00',1.35),('15087','2014-01-29','09:30:00',1.34),('15087','2014-01-29','09:35:00',2.1),('15087','2014-01-29','09:40:00',1.7),('15087','2014-01-29','09:45:00',1.87),('15087','2014-01-29','09:50:00',1.7),('15087','2014-01-29','09:55:00',1.74),('15087','2014-01-29','10:00:00',1.34),('15087','2014-01-29','10:05:00',1.35),('15087','2014-01-29','10:10:00',1.77),('15087','2014-01-29','10:15:00',1.77),('15087','2014-01-29','10:20:00',1.37),('15087','2014-01-29','10:25:00',2.92),('15087','2014-01-29','10:30:00',3.18),('15087','2014-01-29','10:35:00',2.53),('15087','2014-01-29','10:40:00',2.26),('15087','2014-01-29','10:45:00',2.12),('15087','2014-01-29','10:50:00',2.17),('15087','2014-01-29','10:55:00',1.92),('15087','2014-01-29','11:00:00',1.98),('15087','2014-01-29','11:05:00',2.22),('15087','2014-01-29','11:10:00',1.9),('15087','2014-01-29','11:15:00',1.94),('15087','2014-01-29','11:20:00',2.1),('15087','2014-01-29','11:25:00',2.2),('15087','2014-01-29','11:30:00',2.85),('15087','2014-01-29','11:35:00',2.33),('15087','2014-01-29','11:40:00',1.21),('15087','2014-01-29','11:45:00',1.18),('15087','2014-01-29','12:45:00',1.26),('15087','2014-01-29','12:50:00',2.86),('15087','2014-01-29','12:55:00',3.31),('15087','2014-01-29','13:00:00',1.75),('15087','2014-01-29','13:05:00',1.48),('15087','2014-01-29','13:35:00',1.85),('15087','2014-01-29','13:40:00',3.13),('15087','2014-01-29','13:45:00',2.15),('15087','2014-01-29','13:50:00',2.31),('15087','2014-01-29','13:55:00',2.63),('15087','2014-01-29','14:00:00',1.18),('15087','2014-01-29','15:10:00',1),('15087','2014-01-29','15:15:00',1.6),('15087','2014-01-29','15:20:00',1.05),('15087','2014-01-28','09:10:00',1.17),('15087','2014-01-28','09:15:00',1.27),('15087','2014-01-28','09:20:00',1.31),('15087','2014-01-28','09:25:00',1.35),('15087','2014-01-28','09:30:00',1.37),('15087','2014-01-28','09:35:00',1.56),('15087','2014-01-28','09:40:00',1.37),('15087','2014-01-28','09:45:00',1.7),('15087','2014-01-28','09:50:00',1.99),('15087','2014-01-28','09:55:00',2.16),('15087','2014-01-28','10:00:00',2.19),('15087','2014-01-28','10:05:00',2.1),('15087','2014-01-28','10:10:00',2.09),('15087','2014-01-28','10:15:00',2.25),('15087','2014-01-28','10:20:00',2.42),('15087','2014-01-28','10:25:00',2.56),('15087','2014-01-28','10:30:00',2.57),('15087','2014-01-28','10:35:00',2.69),('15087','2014-01-28','10:40:00',2.71),('15087','2014-01-28','10:45:00',2.53),('15087','2014-01-28','10:50:00',2.51),('15087','2014-01-28','10:55:00',2.19),('15087','2014-01-28','11:00:00',2.94),('15087','2014-01-28','11:05:00',1.86),('15087','2014-01-28','11:10:00',2.1),('15087','2014-01-28','11:15:00',1.41),('15087','2014-01-28','11:25:00',2.37),('15087','2014-01-28','11:30:00',1.29),('15087','2014-01-28','11:35:00',2.41),('15087','2014-01-28','11:40:00',3.51),('15087','2014-01-28','11:45:00',2.84),('15087','2014-01-28','12:00:00',2.87),('15087','2014-01-28','12:05:00',3.18),('15087','2014-01-28','12:10:00',2.2),('15087','2014-01-28','12:15:00',2.81),('15087','2014-01-28','12:20:00',1.58),('15087','2014-01-28','12:25:00',1.2),('15087','2014-01-28','12:30:00',1.2),('15087','2014-01-28','12:35:00',1.62),('15087','2014-01-28','12:40:00',1.77),('15087','2014-01-28','12:45:00',2.67),('15087','2014-01-28','12:50:00',2.81),('15087','2014-01-28','12:55:00',3.41),('15087','2014-01-28','13:00:00',3.45),('15087','2014-01-28','13:05:00',3.41),('15087','2014-01-28','13:10:00',2.42),('15087','2014-01-28','13:15:00',2.8),('15087','2014-01-28','13:20:00',2.41),('15087','2014-01-28','13:25:00',2.81),('15087','2014-01-28','13:30:00',2.76),('15087','2014-01-28','13:35:00',2.91),('15087','2014-01-28','13:40:00',2.75),('15087','2014-01-28','13:45:00',2.65),('15087','2014-01-28','13:50:00',2.48),('15087','2014-01-28','13:55:00',2.34),('15087','2014-01-28','14:00:00',2.23),('15087','2014-01-28','14:05:00',2.26),('15087','2014-01-28','14:10:00',2.27),('15087','2014-01-28','14:15:00',2.35),('15087','2014-01-28','14:20:00',2.26),('15087','2014-01-28','14:25:00',2.34),('15087','2014-01-28','14:30:00',2.27),('15087','2014-01-28','14:35:00',2.08),('15087','2014-01-28','14:40:00',1.98),('15087','2014-01-28','14:45:00',1.84),('15087','2014-01-28','14:50:00',1.8),('15087','2014-01-28','14:55:00',1.72),('15087','2014-01-28','15:00:00',1.65),('15087','2014-01-28','15:05:00',1.58),('15087','2014-01-28','15:10:00',1.49),('15087','2014-01-28','15:15:00',1.41),('15087','2014-01-28','15:20:00',1.29),('15087','2014-01-28','15:25:00',1.2),('15087','2014-01-28','15:30:00',1.12),('15128','2014-05-04','08:15:00',1.02),('15128','2014-05-04','08:20:00',1.09),('15128','2014-05-04','08:25:00',1.17),('15128','2014-05-04','08:30:00',1.22),('15128','2014-05-04','08:35:00',1.29),('15128','2014-05-04','08:40:00',1.37),('15128','2014-05-04','08:45:00',1.44),('15128','2014-05-04','08:50:00',1.52),('15128','2014-05-04','08:55:00',1.58),('15128','2014-05-04','09:00:00',1.67),('15128','2014-05-04','09:05:00',1.75),('15128','2014-05-04','09:10:00',1.85),('15128','2014-05-04','09:15:00',1.92),('15128','2014-05-04','09:20:00',2),('15128','2014-05-04','09:25:00',2.05),('15128','2014-05-04','09:30:00',2.04),('15128','2014-05-04','09:35:00',2.07),('15128','2014-05-04','09:40:00',2.03),('15128','2014-05-04','09:45:00',2.2),('15128','2014-05-04','09:50:00',2.25),('15128','2014-05-04','09:55:00',2.29),('15128','2014-05-04','10:00:00',2.36),('15128','2014-05-04','10:05:00',2.46),('15128','2014-05-04','10:10:00',2.59),('15128','2014-05-04','10:15:00',2.67),('15128','2014-05-04','10:20:00',2.63),('15128','2014-05-04','10:25:00',2.65),('15128','2014-05-04','10:30:00',2.68),('15128','2014-05-04','10:35:00',2.78),('15128','2014-05-04','10:40:00',2.85),('15128','2014-05-04','10:45:00',2.93),('15128','2014-05-04','10:50:00',3.01),('15128','2014-05-04','10:55:00',3.11),('15128','2014-05-04','11:00:00',3.03),('15128','2014-05-04','11:05:00',3.18),('15128','2014-05-04','11:10:00',3.14),('15128','2014-05-04','11:15:00',3.26),('15128','2014-05-04','11:20:00',3.29),('15128','2014-05-04','11:25:00',3.38),('15128','2014-05-04','11:30:00',3.51),('15128','2014-05-04','11:35:00',3.47),('15128','2014-05-04','11:40:00',3.78),('15128','2014-05-04','11:45:00',2.98),('15128','2014-05-04','11:50:00',2.86),('15128','2014-05-04','11:55:00',2.29),('15128','2014-05-04','12:00:00',2.86),('15128','2014-05-04','12:05:00',2.91),('15128','2014-05-04','12:10:00',4.24),('15128','2014-05-04','12:15:00',4.17),('15128','2014-05-04','12:20:00',4.22),('15128','2014-05-04','12:25:00',4.24),('15128','2014-05-04','12:30:00',4.28),('15128','2014-05-04','12:35:00',4.21),('15128','2014-05-04','12:40:00',4.21),('15128','2014-05-04','12:45:00',4.2),('15128','2014-05-04','12:50:00',4.17),('15128','2014-05-04','12:55:00',4.16),('15128','2014-05-04','13:00:00',4.15),('15128','2014-05-04','13:05:00',4.19),('15128','2014-05-04','13:10:00',4.27),('15128','2014-05-04','13:15:00',4.3),('15128','2014-05-04','13:20:00',4.28),('15128','2014-05-04','13:25:00',4.32),('15128','2014-05-04','13:30:00',4.45),('15128','2014-05-04','13:35:00',4.47),('15128','2014-05-04','13:40:00',4.62),('15128','2014-05-04','13:45:00',4.39),('15128','2014-05-04','13:50:00',2.06),('15128','2014-05-04','13:55:00',1.87),('15128','2014-05-04','14:00:00',1.53),('15128','2014-05-04','14:05:00',2.51),('15128','2014-05-04','14:10:00',4.95),('15128','2014-05-04','14:15:00',4.64),('15128','2014-05-04','14:20:00',4.57),('15128','2014-05-04','14:25:00',4.62),('15128','2014-05-04','14:30:00',4.56),('15128','2014-05-04','14:35:00',4.47),('15128','2014-05-04','14:40:00',4.39),('15128','2014-05-04','14:45:00',4.41),('15128','2014-05-04','14:50:00',4.4),('15128','2014-05-04','14:55:00',4.48),('15128','2014-05-04','15:00:00',4.25),('15128','2014-05-04','15:05:00',4.14),('15128','2014-05-04','15:10:00',4.13),('15128','2014-05-04','15:15:00',4.05),('15128','2014-05-04','15:20:00',4.04),('15128','2014-05-04','15:25:00',3.97),('15128','2014-05-04','15:30:00',3.94),('15128','2014-05-04','15:35:00',3.94),('15128','2014-05-04','15:40:00',3.9),('15128','2014-05-04','15:45:00',3.85),('15128','2014-05-04','15:50:00',3.83),('15128','2014-05-04','15:55:00',3.76),('15128','2014-05-04','16:00:00',3.7),('15128','2014-05-04','16:05:00',3.65),('15128','2014-05-04','16:10:00',3.65),('15128','2014-05-04','16:15:00',3.59),('15128','2014-05-04','16:20:00',3.56),('15128','2014-05-04','16:25:00',3.49),('15128','2014-05-04','16:30:00',3.41),('15128','2014-05-04','16:35:00',3.35),('15128','2014-05-04','16:40:00',3.29),('15128','2014-05-04','16:45:00',3.22),('15128','2014-05-04','16:50:00',3.2),('15128','2014-05-04','16:55:00',3.1),('15128','2014-05-04','17:00:00',2.99),('15128','2014-05-04','17:05:00',2.91),('15128','2014-05-04','17:10:00',2.86),('15128','2014-05-04','17:15:00',2.8),('15128','2014-05-04','17:20:00',2.72),('15128','2014-05-04','17:25:00',2.68),('15128','2014-05-04','17:30:00',2.67),('15128','2014-05-04','17:35:00',2.48),('15128','2014-05-04','17:40:00',2.29),('15128','2014-05-04','17:45:00',2.16),('15128','2014-05-04','17:50:00',2.07),('15128','2014-05-04','17:55:00',1.99),('15128','2014-05-04','18:00:00',1.89),('15128','2014-05-04','18:05:00',1.81),('15128','2014-05-04','18:10:00',1.72),('15128','2014-05-04','18:15:00',1.66),('15128','2014-05-04','18:20:00',1.6),('15128','2014-05-04','18:25:00',1.48),('15128','2014-05-04','18:30:00',1.4),('15128','2014-05-04','18:35:00',1.31),('15128','2014-05-04','18:40:00',1.2),('15128','2014-05-04','18:45:00',1.09),('15128','2014-04-25','09:10:00',1.03),('15128','2014-04-25','09:15:00',1.09),('15128','2014-04-25','09:20:00',1.17),('15128','2014-04-25','09:25:00',1.05),('15128','2014-04-25','09:45:00',1.09),('15128','2014-04-25','09:50:00',1.28),('15128','2014-04-25','09:55:00',1.43),('15128','2014-04-25','10:00:00',1.81),('15128','2014-04-25','10:05:00',1.94),('15128','2014-04-25','10:10:00',1.87),('15128','2014-04-25','10:15:00',2.3),('15128','2014-04-25','10:20:00',2.46),('15128','2014-04-25','10:25:00',1.98),('15128','2014-04-25','10:30:00',2.44),('15128','2014-04-25','10:35:00',1.74),('15128','2014-04-25','10:40:00',1.67),('15128','2014-04-25','10:45:00',1.8),('15128','2014-04-25','10:50:00',2.03),('15128','2014-04-25','10:55:00',1.98),('15128','2014-04-25','11:00:00',2.15),('15128','2014-04-25','11:05:00',2.35),('15128','2014-04-25','11:10:00',2.55),('15128','2014-04-25','11:15:00',3.32),('15128','2014-04-25','11:20:00',2.98),('15128','2014-04-25','11:25:00',2.67),('15128','2014-04-25','11:30:00',2.76),('15128','2014-04-25','11:35:00',3.19),('15128','2014-04-25','11:40:00',3.38),('15128','2014-04-25','11:45:00',1.93),('15128','2014-04-25','11:50:00',2.64),('15128','2014-04-25','11:55:00',3.24),('15128','2014-04-25','12:00:00',3.2),('15128','2014-04-25','12:05:00',2.74),('15128','2014-04-25','12:10:00',2.87),('15128','2014-04-25','12:15:00',2.52),('15128','2014-04-25','12:20:00',3.12),('15128','2014-04-25','12:25:00',2.92),('15128','2014-04-25','12:30:00',2.45),('15128','2014-04-25','12:35:00',3.32),('15128','2014-04-25','12:40:00',3.36),('15128','2014-04-25','12:45:00',3.23),('15128','2014-04-25','12:50:00',3.43),('15128','2014-04-25','12:55:00',3.61),('15128','2014-04-25','13:00:00',3.81),('15128','2014-04-25','13:05:00',2.96),('15128','2014-04-25','13:10:00',3.16),('15128','2014-04-25','13:15:00',3.43),('15128','2014-04-25','13:20:00',3.88),('15128','2014-04-25','13:25:00',3.9),('15128','2014-04-25','13:30:00',3.11),('15128','2014-04-25','13:35:00',3.85),('15128','2014-04-25','13:40:00',4.38),('15128','2014-04-25','13:45:00',3.66),('15128','2014-04-25','13:50:00',3.86),('15128','2014-04-25','13:55:00',3.57),('15128','2014-04-25','14:00:00',2.95),('15128','2014-04-25','14:05:00',2.05),('15128','2014-04-25','14:10:00',2.39),('15128','2014-04-25','14:15:00',3.48),('15128','2014-04-25','14:20:00',2.16),('15128','2014-04-25','14:25:00',1.71),('15128','2014-04-25','14:30:00',1.2),('15128','2014-04-25','14:45:00',3.18),('15128','2014-04-25','14:50:00',1.83),('15128','2014-04-25','18:30:00',1),('15128','2014-04-25','18:35:00',1.16),('15128','2014-04-25','18:40:00',1.29),('15128','2014-04-25','18:45:00',1.13),('15128','2014-01-25','09:45:00',1.01),('15128','2014-01-25','10:10:00',1.14),('15128','2014-01-25','10:15:00',1.21),('15128','2014-01-25','11:00:00',1.03),('15128','2014-01-25','11:05:00',1.02),('15128','2014-01-25','11:20:00',1.22),('15128','2014-01-25','11:25:00',1.38),('15128','2014-01-25','12:10:00',1.2),('15128','2014-01-25','12:15:00',1.29),('15128','2014-01-25','12:20:00',1.53),('15128','2014-01-25','12:25:00',2.29),('15128','2014-01-25','12:30:00',1.69),('15128','2014-01-25','12:35:00',1.15),('15128','2014-01-25','12:40:00',1.05),('15128','2014-01-25','12:55:00',1.02),('15128','2014-01-25','13:00:00',1.13),('15128','2014-01-25','13:05:00',1.2),('15128','2014-01-25','13:10:00',1.3),('15128','2014-01-25','13:15:00',1.37),('15128','2014-01-25','13:20:00',1.28),('15128','2014-01-25','13:25:00',1.02),('15128','2014-01-25','13:45:00',1.28),('15128','2014-01-25','15:40:00',1.51),('15128','2014-01-24','09:50:00',1.2),('15128','2014-01-24','09:55:00',1.05),('15128','2014-01-24','10:00:00',1.6),('15128','2014-01-24','10:05:00',1.73),('15128','2014-01-24','10:10:00',1.73),('15128','2014-01-24','10:15:00',1.75),('15128','2014-01-24','10:20:00',1.81),('15128','2014-01-24','10:25:00',1.74),('15128','2014-01-24','10:30:00',1.98),('15128','2014-01-24','10:35:00',1.51),('15128','2014-01-24','10:40:00',1.53),('15128','2014-01-24','10:45:00',1.98),('15128','2014-01-24','10:50:00',2.1),('15128','2014-01-24','10:55:00',2.08),('15128','2014-01-24','11:00:00',2.29),('15128','2014-01-24','11:05:00',2.22),('15128','2014-01-24','11:10:00',2.43),('15128','2014-01-24','11:15:00',2.64),('15128','2014-01-24','11:20:00',3.06),('15128','2014-01-24','11:25:00',2.93),('15128','2014-01-24','11:30:00',2.79),('15128','2014-01-24','11:35:00',2.03),('15128','2014-01-24','11:40:00',1.96),('15128','2014-01-24','11:45:00',1.84),('15128','2014-01-24','11:50:00',1.73),('15128','2014-01-24','11:55:00',1.62),('15128','2014-01-24','12:00:00',1.81),('15128','2014-01-24','12:05:00',1.92),('15128','2014-01-24','12:10:00',1.9),('15128','2014-01-24','12:15:00',1.72),('15128','2014-01-24','12:20:00',1.68),('15128','2014-01-24','12:25:00',1.65),('15128','2014-01-24','12:30:00',1.76),('15128','2014-01-24','12:35:00',1.84),('15128','2014-01-24','12:40:00',1.36),('15128','2014-01-24','12:45:00',1.52),('15128','2014-01-24','12:50:00',1.95),('15128','2014-01-24','12:55:00',2.08),('15128','2014-01-24','13:00:00',2.11),('15128','2014-01-24','13:05:00',2.55),('15128','2014-01-24','13:10:00',2.63),('15128','2014-01-24','13:15:00',2.66),('15128','2014-01-24','13:20:00',2.65),('15128','2014-01-24','13:25:00',2.68),('15128','2014-01-24','13:30:00',2.64),('15128','2014-01-24','13:35:00',2.72),('15128','2014-01-24','13:40:00',2.76),('15128','2014-01-24','13:45:00',2.73),('15128','2014-01-24','13:50:00',2.34),('15128','2014-01-24','13:55:00',2.51),('15128','2014-01-24','14:00:00',2.22),('15128','2014-01-24','14:05:00',1.75),('15128','2014-01-24','14:10:00',2.48),('15128','2014-01-24','14:15:00',2.43),('15128','2014-01-24','14:20:00',2.36),('15128','2014-01-24','14:25:00',2.5),('15128','2014-01-24','14:30:00',2.56),('15128','2014-01-24','14:35:00',2.4),('15128','2014-01-24','15:00:00',1.49),('15128','2014-01-24','15:05:00',1.93),('15128','2014-01-24','15:10:00',1.82),('15128','2014-01-24','15:15:00',1.78),('15128','2014-01-24','15:20:00',1.69),('15128','2014-01-24','15:25:00',1.6),('15128','2014-01-24','15:30:00',1.51),('15128','2014-01-24','15:35:00',1.42),('15128','2014-01-24','15:40:00',1.32),('15128','2014-01-24','15:45:00',1.2),('15128','2014-01-24','15:50:00',1.13),('15128','2014-01-24','15:55:00',1.01),('15128','2014-01-23','10:00:00',1.15),('15128','2014-01-23','10:05:00',1.38),('15128','2014-01-23','10:10:00',1.95),('15128','2014-01-23','10:15:00',1.68),('15128','2014-01-23','10:20:00',1.36),('15128','2014-01-23','10:30:00',1.45),('15128','2014-01-23','10:35:00',1.62),('15128','2014-01-23','10:40:00',2.43),('15128','2014-01-23','10:45:00',1.33),('15128','2014-01-23','10:50:00',1.42),('15128','2014-01-23','11:00:00',1.94),('15128','2014-01-23','11:05:00',1.07),('15128','2014-01-23','11:25:00',1.21),('15128','2014-01-23','11:30:00',1.55),('15128','2014-01-23','11:35:00',1.33),('15128','2014-01-23','11:40:00',3.08),('15128','2014-01-23','11:45:00',2.5),('15128','2014-01-23','11:50:00',2.54),('15128','2014-01-23','11:55:00',2.09),('15128','2014-01-23','12:00:00',2.25),('15128','2014-01-23','12:05:00',2.81),('15128','2014-01-23','12:10:00',1.37),('15128','2014-01-23','12:15:00',1.33),('15128','2014-01-23','12:20:00',2.34),('15128','2014-01-23','12:25:00',1.07),('15128','2014-01-23','12:35:00',1.32),('15128','2014-01-23','12:40:00',1.74),('15128','2014-01-23','12:45:00',1.48),('15128','2014-01-23','13:05:00',1.2),('15128','2014-01-23','13:10:00',1.64),('15128','2014-01-23','13:15:00',1.97),('15128','2014-01-23','13:20:00',1.08),('15128','2014-01-23','13:25:00',2.22),('15128','2014-01-23','13:30:00',2.34),('15128','2014-01-23','13:35:00',2),('15128','2014-01-23','13:40:00',2.46),('15128','2014-01-23','13:50:00',1.51),('15128','2014-01-23','14:00:00',1.04),('15128','2014-01-23','14:05:00',2.67),('15128','2014-01-23','14:10:00',2.89),('15128','2014-01-23','14:15:00',1.49),('15128','2014-01-23','14:20:00',1.24),('15128','2014-01-23','14:25:00',1.97),('15128','2014-01-23','14:30:00',1.22),('15128','2014-01-23','14:40:00',2.23),('15128','2014-01-23','14:45:00',1.57),('15128','2014-01-23','14:50:00',1.59),('15128','2014-01-22','10:45:00',1.1),('15128','2014-01-22','10:50:00',1),('15128','2014-01-22','12:05:00',1.11),('15128','2014-01-22','12:10:00',1.05),('15128','2014-01-22','12:40:00',1.06),('15128','2014-01-21','11:15:00',1.06),('15128','2014-01-21','11:20:00',1.04),('15128','2014-01-21','12:40:00',1.26),('15128','2014-01-21','12:45:00',1.56),('15128','2014-01-21','12:50:00',1.65),('15128','2014-01-21','12:55:00',1.07),('15128','2014-01-20','10:55:00',1.01),('15128','2014-01-20','11:00:00',1.07),('15128','2014-01-20','11:30:00',1.58),('15128','2014-01-20','11:35:00',2.79),('15128','2014-01-20','11:40:00',2.7),('15128','2014-01-20','11:45:00',1.3),('15128','2014-01-20','11:50:00',1.21),('15128','2014-01-20','11:55:00',1.74),('15128','2014-01-20','12:00:00',1.7),('15128','2014-01-20','12:05:00',1.43),('15128','2014-01-20','12:10:00',1.07),('15128','2014-01-20','12:15:00',1.51),('15128','2014-01-20','12:20:00',1.49),('15128','2014-01-20','12:25:00',1.53),('15128','2014-01-20','12:30:00',1.38),('15128','2014-01-20','12:35:00',1.13),('15128','2014-01-20','13:00:00',1.11),('15128','2014-01-20','13:05:00',1),('15128','2014-01-20','13:15:00',1.02),('15128','2014-01-20','15:00:00',1.26),('15128','2014-01-20','15:30:00',1.06),('15128','2014-01-20','15:35:00',1.28),('15128','2014-01-19','11:50:00',1.15),('15128','2014-01-19','11:55:00',1.87),('15128','2014-01-19','12:00:00',1.38),('15128','2014-01-19','12:05:00',1.53),('15128','2014-01-19','12:50:00',2.59),('15128','2014-01-19','12:55:00',2.25),('15128','2014-01-19','13:25:00',1.54),('15128','2014-01-19','13:30:00',2.02),('15128','2014-01-19','13:35:00',1.01),('15128','2014-01-19','13:40:00',1.07),('15128','2014-01-19','14:15:00',1.67),('15128','2014-01-19','14:20:00',1.17),('15128','2014-01-18','11:50:00',1.05),('15128','2014-01-18','11:55:00',1.18),('15128','2014-01-18','12:00:00',1.08),('15128','2014-01-18','12:05:00',1.02),('15128','2014-01-18','12:25:00',1.02),('15128','2014-01-18','13:10:00',1.06),('15128','2014-01-18','14:15:00',1.13),('15128','2014-01-18','14:20:00',1.55),('15128','2014-01-18','14:25:00',1.3),('15128','2014-01-18','14:30:00',1.14),('15128','2014-01-17','09:50:00',1),('15128','2014-01-17','10:00:00',1.04),('15128','2014-01-17','10:10:00',1.29),('15128','2014-01-17','10:15:00',1.67),('15128','2014-01-17','10:20:00',1.53),('15128','2014-01-17','10:25:00',1.43),('15128','2014-01-17','10:30:00',1.41),('15128','2014-01-17','10:35:00',1.4),('15128','2014-01-17','10:40:00',1.48),('15128','2014-01-17','10:45:00',1.04),('15128','2014-01-17','10:50:00',1.01),('15128','2014-01-17','11:05:00',1.63),('15128','2014-01-17','11:10:00',1.02),('15128','2014-01-17','11:20:00',1.9),('15128','2014-01-17','11:25:00',1.97),('15128','2014-01-17','11:30:00',2.07),('15128','2014-01-17','11:35:00',1.9),('15128','2014-01-17','11:40:00',1.31),('15128','2014-01-17','11:55:00',1.17),('15128','2014-01-17','12:00:00',1.87),('15128','2014-01-17','12:05:00',1.26),('15128','2014-01-17','12:10:00',2.39),('15128','2014-01-17','12:15:00',2.37),('15128','2014-01-17','12:20:00',2.4),('15128','2014-01-17','12:25:00',2.42),('15128','2014-01-17','12:30:00',2.42),('15128','2014-01-17','12:35:00',2.46),('15128','2014-01-17','12:40:00',2.23),('15128','2014-01-17','12:45:00',2.21),('15128','2014-01-17','12:50:00',1.93),('15128','2014-01-17','12:55:00',2),('15128','2014-01-17','13:00:00',2.17),('15128','2014-01-17','13:05:00',1.77),('15128','2014-01-17','13:10:00',2.29),('15128','2014-01-17','13:15:00',2.51),('15128','2014-01-17','13:20:00',2.63),('15128','2014-01-17','13:25:00',1.98),('15128','2014-01-17','13:30:00',2.36),('15128','2014-01-17','13:35:00',2.51),('15128','2014-01-17','13:40:00',2.18),('15128','2014-01-17','13:45:00',2.37),('15128','2014-01-17','13:50:00',2.09),('15128','2014-01-17','13:55:00',1.17),('15128','2014-01-17','14:00:00',2.33),('15128','2014-01-17','14:05:00',2.19),('15128','2014-01-17','14:10:00',2.02),('15128','2014-01-17','14:15:00',1.96),('15128','2014-01-17','14:20:00',2.05),('15128','2014-01-17','14:25:00',1.99),('15128','2014-01-17','14:30:00',1.93),('15128','2014-01-17','14:35:00',1.88),('15128','2014-01-17','14:40:00',1.84),('15128','2014-01-17','14:45:00',1.8),('15128','2014-01-17','14:50:00',1.72),('15128','2014-01-16','09:40:00',1.04),('15128','2014-01-16','09:45:00',1.09),('15128','2014-04-24','08:35:00',1.04),('15128','2014-04-24','08:40:00',1.08),('15128','2014-04-24','08:45:00',1.16),('15128','2014-04-24','08:50:00',1.34),('15128','2014-04-24','08:55:00',1.09),('15128','2014-04-24','09:00:00',1.35),('15128','2014-04-24','09:05:00',1.15),('15128','2014-04-24','09:45:00',1.07),('15128','2014-04-24','09:50:00',1.26),('15128','2014-04-24','09:55:00',1.33),('15128','2014-04-24','10:00:00',1.39),('15128','2014-04-24','10:05:00',1.31),('15128','2014-04-24','10:10:00',1.27),('15128','2014-04-24','10:15:00',1.15),('15128','2014-04-24','10:20:00',1.72),('15128','2014-04-24','10:25:00',2.05),('15128','2014-04-24','10:30:00',1.7),('15128','2014-04-24','10:35:00',1.67),('15128','2014-04-24','10:40:00',2.11),('15128','2014-04-24','10:45:00',1.24),('15128','2014-04-24','10:55:00',1.05),('15128','2014-04-24','11:00:00',1.18),('15128','2014-04-24','11:05:00',1.4),('15128','2014-04-24','11:10:00',3.52),('15128','2014-04-24','11:15:00',3.46),('15128','2014-04-24','11:20:00',2.42),('15128','2014-04-24','11:25:00',2.97),('15128','2014-04-24','11:30:00',1.43),('15128','2014-04-24','11:35:00',1.05),('15128','2014-04-24','11:40:00',2.01),('15128','2014-04-24','11:45:00',3.17),('15128','2014-04-24','11:50:00',1.7),('15128','2014-04-24','11:55:00',1.01),('15128','2014-04-24','12:00:00',1.08),('15128','2014-04-24','12:05:00',2.83),('15128','2014-04-24','12:10:00',2.65),('15128','2014-04-24','12:15:00',3.09),('15128','2014-04-24','12:20:00',4.26),('15128','2014-04-24','12:25:00',3.47),('15128','2014-04-24','12:30:00',3.29),('15128','2014-04-24','12:35:00',3.96),('15128','2014-04-24','12:40:00',3.96),('15128','2014-04-24','12:45:00',3.86),('15128','2014-04-24','12:50:00',2.34),('15128','2014-04-24','12:55:00',2.5),('15128','2014-04-24','13:00:00',3.99),('15128','2014-04-24','13:05:00',4.38),('15128','2014-04-24','13:10:00',4.24),('15128','2014-04-24','13:15:00',2.76),('15128','2014-04-24','13:20:00',1.74),('15128','2014-04-24','13:25:00',3.95),('15128','2014-04-24','13:30:00',3.7),('15128','2014-04-24','13:35:00',3.61),('15128','2014-04-24','13:40:00',4.7),('15128','2014-04-24','13:45:00',4.41),('15128','2014-04-24','13:50:00',3.28),('15128','2014-04-24','13:55:00',3.61),('15128','2014-04-24','14:00:00',3.98),('15128','2014-04-24','14:05:00',4.05),('15128','2014-04-24','14:10:00',3.97),('15128','2014-04-24','14:15:00',4.01),('15128','2014-04-24','14:20:00',3.96),('15128','2014-04-24','14:25:00',4),('15128','2014-04-24','14:30:00',3.98),('15128','2014-04-24','14:35:00',3.96),('15128','2014-04-24','14:40:00',3.93),('15128','2014-04-24','14:45:00',3.92),('15128','2014-04-24','14:50:00',3.89),('15128','2014-04-24','14:55:00',3.89),('15128','2014-04-24','15:00:00',3.87),('15128','2014-04-24','15:05:00',3.85),('15128','2014-04-24','15:10:00',3.78),('15128','2014-04-24','15:15:00',3.72),('15128','2014-04-24','15:20:00',3.7),('15128','2014-04-24','15:25:00',3.76),('15128','2014-04-24','15:30:00',3.66),('15128','2014-04-24','15:35:00',3.66),('15128','2014-04-24','15:40:00',3.55),('15128','2014-04-24','15:45:00',3.44),('15128','2014-04-24','15:50:00',3.49),('15128','2014-04-24','15:55:00',3.47),('15128','2014-04-24','16:00:00',3.34),('15128','2014-04-24','16:05:00',3.22),('15128','2014-04-24','16:10:00',3.03),('15128','2014-04-24','16:15:00',2.84),('15128','2014-04-24','16:20:00',3.03),('15128','2014-04-24','16:25:00',2.86),('15128','2014-04-24','16:30:00',2.68),('15128','2014-04-24','16:35:00',2.94),('15128','2014-04-24','16:40:00',2.99),('15128','2014-04-24','16:45:00',2.83),('15128','2014-04-24','16:50:00',2.25),('15128','2014-04-24','16:55:00',1.96),('15128','2014-04-24','17:00:00',2.03),('15128','2014-04-24','17:05:00',2.27),('15128','2014-04-24','17:10:00',2.38),('15128','2014-04-24','17:15:00',2.33),('15128','2014-04-24','17:20:00',2.11),('15128','2014-04-24','17:25:00',1.71),('15128','2014-04-24','17:30:00',2.05),('15128','2014-04-24','17:35:00',1.41),('15128','2014-04-24','17:40:00',1.29),('15128','2014-04-24','17:45:00',1.11),('15128','2014-04-24','17:55:00',1.01),('15128','2014-01-15','09:35:00',1.1),('15128','2014-01-15','09:40:00',1.09),('15128','2014-01-15','10:10:00',1.01),('15128','2014-01-15','10:20:00',1.11),('15128','2014-01-15','10:25:00',1.47),('15128','2014-01-15','10:30:00',1.8),('15128','2014-01-15','10:35:00',1.53),('15128','2014-01-15','10:40:00',1.24),('15128','2014-01-15','10:45:00',1.42),('15128','2014-01-15','10:50:00',1.47),('15128','2014-01-15','10:55:00',1.47),('15128','2014-01-15','11:00:00',1.53),('15128','2014-01-15','11:05:00',1.66),('15128','2014-01-15','11:10:00',1.67),('15128','2014-01-15','11:15:00',1.56),('15128','2014-01-15','11:20:00',1.65),('15128','2014-01-15','11:25:00',1.57),('15128','2014-01-15','11:30:00',1.52),('15128','2014-01-15','11:35:00',1.57),('15128','2014-01-15','11:40:00',1.6),('15128','2014-01-15','11:45:00',1.68),('15128','2014-01-15','11:50:00',1.75),('15128','2014-01-15','11:55:00',1.81),('15128','2014-01-15','12:00:00',1.73),('15128','2014-01-15','12:05:00',1.76),('15128','2014-01-15','12:10:00',1.69),('15128','2014-01-15','12:15:00',1.53),('15128','2014-01-15','12:20:00',1.47),('15128','2014-01-15','12:25:00',1.49),('15128','2014-01-15','12:30:00',1.7),('15128','2014-01-15','12:35:00',1.82),('15128','2014-01-15','12:40:00',1.86),('15128','2014-01-15','12:45:00',1.96),('15128','2014-01-15','12:50:00',2.03),('15128','2014-01-15','12:55:00',2.12),('15128','2014-01-15','13:00:00',2.19),('15128','2014-01-15','13:05:00',2.18),('15128','2014-01-15','13:10:00',2.17),('15128','2014-01-15','13:15:00',2.21),('15128','2014-01-15','13:20:00',2.21),('15128','2014-01-15','13:25:00',2.26),('15128','2014-01-15','13:30:00',2.31),('15128','2014-01-15','13:35:00',1.71),('15128','2014-01-15','13:40:00',1.22),('15128','2014-01-15','13:45:00',1.9),('15128','2014-01-15','13:50:00',1.09),('15128','2014-01-15','13:55:00',1.08),('15128','2014-01-15','14:00:00',1.08),('15128','2014-01-15','14:05:00',1.07),('15128','2014-01-15','14:10:00',1.02),('15128','2014-01-15','14:15:00',1.01),('15128','2014-01-15','15:00:00',1.07),('15128','2014-01-14','10:05:00',1.12),('15128','2014-01-14','10:10:00',1.19),('15128','2014-01-14','10:15:00',1.3),('15128','2014-01-14','10:20:00',1.35),('15128','2014-01-14','10:25:00',1.41),('15128','2014-01-14','10:30:00',1.48),('15128','2014-01-14','10:35:00',1.54),('15128','2014-01-14','10:40:00',1.16),('15128','2014-01-14','10:45:00',1.16),('15128','2014-01-14','10:50:00',1.16),('15128','2014-01-14','10:55:00',1.32),('15128','2014-01-14','11:00:00',1.79),('15128','2014-01-14','11:05:00',1.84),('15128','2014-01-14','11:10:00',1.92),('15128','2014-01-14','11:15:00',2.03),('15128','2014-01-14','11:20:00',2.09),('15128','2014-01-14','11:25:00',2.16),('15128','2014-01-14','11:30:00',1.59),('15128','2014-01-14','11:35:00',1.17),('15128','2014-01-14','11:40:00',1.44),('15128','2014-01-14','11:45:00',1.2),('15128','2014-01-14','11:50:00',1.14),('15128','2014-01-14','11:55:00',1.2),('15128','2014-01-14','12:00:00',1.41),('15128','2014-01-14','12:05:00',1.49),('15128','2014-01-14','12:10:00',1.74),('15128','2014-01-14','12:15:00',1.64),('15128','2014-01-14','12:20:00',1.18),('15128','2014-01-14','12:25:00',1.23),('15128','2014-01-14','12:30:00',1.77),('15128','2014-01-14','12:35:00',2.69),('15128','2014-01-14','12:40:00',1.97),('15128','2014-01-14','12:45:00',2.07),('15128','2014-01-14','12:50:00',2.18),('15128','2014-01-14','12:55:00',2.48),('15128','2014-01-14','13:00:00',2.57),('15128','2014-01-14','13:05:00',2.51),('15128','2014-01-14','13:10:00',2.52),('15128','2014-01-14','13:15:00',2.52),('15128','2014-01-14','13:20:00',2.5),('15128','2014-01-14','13:25:00',2.46),('15128','2014-01-14','13:30:00',2.41),('15128','2014-01-14','13:35:00',2.38),('15128','2014-01-14','13:40:00',2.35),('15128','2014-01-14','13:45:00',2.31),('15128','2014-01-14','13:50:00',2.29),('15128','2014-01-14','13:55:00',2.26),('15128','2014-01-14','14:00:00',2.1),('15128','2014-01-14','14:15:00',2.17),('15128','2014-01-14','14:20:00',2.07),('15128','2014-01-14','14:25:00',1.99),('15128','2014-01-14','14:30:00',1.92),('15128','2014-01-14','14:35:00',1.89),('15128','2014-01-14','14:40:00',1.86),('15128','2014-01-14','14:45:00',1.81),('15128','2014-01-14','14:50:00',1.78),('15128','2014-01-14','14:55:00',1.74),('15128','2014-01-14','15:00:00',1.68),('15128','2014-01-14','15:05:00',1.06),('15128','2014-01-14','15:10:00',1.44),('15128','2014-01-14','15:15:00',1.43),('15128','2014-01-14','15:20:00',1.37),('15128','2014-01-14','15:25:00',1.24),('15128','2014-01-14','15:30:00',1.15),('15128','2014-01-14','15:35:00',1.09),('15128','2014-01-13','10:25:00',1.34),('15128','2014-01-13','10:30:00',1.73),('15128','2014-01-13','10:35:00',1.35),('15128','2014-01-13','10:40:00',1.08),('15128','2014-01-13','10:45:00',1.04),('15128','2014-01-13','10:55:00',1.01),('15128','2014-01-12','10:05:00',1.02),('15128','2014-01-12','10:10:00',1.1),('15128','2014-01-12','10:15:00',1.14),('15128','2014-01-12','10:20:00',1.19),('15128','2014-01-12','10:25:00',1.25),('15128','2014-01-12','10:30:00',1.28),('15128','2014-01-12','10:35:00',1.31),('15128','2014-01-12','10:40:00',1.35),('15128','2014-01-12','10:45:00',1.4),('15128','2014-01-12','10:50:00',1.44),('15128','2014-01-12','10:55:00',1.48),('15128','2014-01-12','11:00:00',1.52),('15128','2014-01-12','11:05:00',1.56),('15128','2014-01-12','11:10:00',1.58),('15128','2014-01-12','11:15:00',1.63),('15128','2014-01-12','11:20:00',1.7),('15128','2014-01-12','11:25:00',1.73),('15128','2014-01-12','11:30:00',1.86),('15128','2014-01-12','11:35:00',1.9),('15128','2014-01-12','11:40:00',1.94),('15128','2014-01-12','11:45:00',1.95),('15128','2014-01-12','11:50:00',1.95),('15128','2014-01-12','11:55:00',1.99),('15128','2014-01-12','12:00:00',2),('15128','2014-01-12','12:05:00',2.01),('15128','2014-01-12','12:10:00',2.01),('15128','2014-01-12','12:15:00',2.02),('15128','2014-01-12','12:20:00',2.05),('15128','2014-01-12','12:25:00',2.07),('15128','2014-01-12','12:30:00',2.07),('15128','2014-01-12','12:35:00',2.1),('15128','2014-01-12','12:40:00',2.1),('15128','2014-01-12','12:45:00',2.07),('15128','2014-01-12','12:50:00',2.07),('15128','2014-01-12','12:55:00',2.13),('15128','2014-01-12','13:00:00',2.12),('15128','2014-01-12','13:05:00',2.13),('15128','2014-01-12','13:10:00',2.1),('15128','2014-01-12','13:15:00',2.05),('15128','2014-01-12','13:20:00',1.99),('15128','2014-01-12','13:25:00',1.96),('15128','2014-01-12','13:30:00',1.97),('15128','2014-01-12','13:35:00',1.99),('15128','2014-01-12','13:40:00',2.02),('15128','2014-01-12','13:45:00',2.04),('15128','2014-01-12','13:50:00',2.01),('15128','2014-01-12','13:55:00',1.98),('15128','2014-01-12','14:00:00',1.95),('15128','2014-01-12','14:05:00',1.91),('15128','2014-01-12','14:10:00',1.89),('15128','2014-01-12','14:15:00',1.82),('15128','2014-01-12','14:20:00',1.75),('15128','2014-01-12','14:25:00',1.68),('15128','2014-01-12','14:30:00',1.63),('15128','2014-01-12','14:35:00',1.58),('15128','2014-01-12','14:40:00',1.57),('15128','2014-01-12','14:45:00',1.52),('15128','2014-01-12','14:50:00',1.5),('15128','2014-01-12','14:55:00',1.48),('15128','2014-01-12','15:00:00',1.46),('15128','2014-01-12','15:05:00',1.41),('15128','2014-01-12','15:10:00',1.33),('15128','2014-01-12','15:15:00',1.25),('15128','2014-01-12','15:20:00',1.13),('15128','2014-01-11','10:35:00',1.02),('15128','2014-01-11','10:40:00',1.2),('15128','2014-01-11','10:45:00',1.23),('15128','2014-01-11','10:50:00',1.18),('15128','2014-01-11','10:55:00',1.21),('15128','2014-01-11','11:00:00',1.34),('15128','2014-01-11','11:05:00',1.44),('15128','2014-01-11','11:10:00',1.54),('15128','2014-01-11','11:15:00',1.61),('15128','2014-01-11','11:20:00',1.79),('15128','2014-01-11','11:25:00',1.64),('15128','2014-01-11','11:30:00',1.97),('15128','2014-01-11','11:35:00',2.07),('15128','2014-01-11','11:40:00',1.6),('15128','2014-01-11','11:45:00',1.83),('15128','2014-01-11','11:50:00',1.98),('15128','2014-01-11','11:55:00',1.57),('15128','2014-01-11','12:00:00',1.43),('15128','2014-01-11','12:05:00',1.4),('15128','2014-01-11','12:10:00',1.27),('15128','2014-01-11','12:15:00',1.23),('15128','2014-01-11','12:20:00',1.16),('15128','2014-01-11','12:25:00',1.15),('15128','2014-01-11','12:30:00',1.15),('15128','2014-01-11','12:35:00',1.09),('15128','2014-01-11','12:40:00',1),('15128','2014-01-11','13:20:00',1.07),('15128','2014-01-11','13:25:00',1.04),('15128','2014-01-11','13:30:00',1.26),('15128','2014-01-11','13:35:00',1.21),('15128','2014-01-11','13:40:00',1.17),('15128','2014-01-11','13:45:00',1.13),('15128','2014-01-11','13:50:00',1.04),('15128','2014-01-11','13:55:00',1),('15128','2014-01-10','10:10:00',1.01),('15128','2014-01-10','10:20:00',1.11),('15128','2014-01-10','10:25:00',1.02),('15128','2014-01-10','10:30:00',1.13),('15128','2014-01-10','10:35:00',1.25),('15128','2014-01-10','10:40:00',1.39),('15128','2014-01-10','10:45:00',1.51),('15128','2014-01-10','10:50:00',1.53),('15128','2014-01-10','10:55:00',1.56),('15128','2014-01-10','11:00:00',1.64),('15128','2014-01-10','11:05:00',1.54),('15128','2014-01-10','11:10:00',1.3),('15128','2014-01-10','11:15:00',1.35),('15128','2014-01-10','11:20:00',1.44),('15128','2014-01-10','11:25:00',1.4),('15128','2014-01-10','11:30:00',1.5),('15128','2014-01-10','11:35:00',1.74),('15128','2014-01-10','11:40:00',1.66),('15128','2014-01-10','11:45:00',1.63),('15128','2014-01-10','11:50:00',1.69),('15128','2014-01-10','11:55:00',1.78),('15128','2014-01-10','12:00:00',1.63),('15128','2014-01-10','12:05:00',1.63),('15128','2014-01-10','12:10:00',2),('15128','2014-01-10','12:15:00',2.21),('15128','2014-01-10','12:20:00',1.24),('15128','2014-01-10','12:25:00',1.49),('15128','2014-01-10','12:30:00',1.71),('15128','2014-01-10','12:35:00',1.39),('15128','2014-01-10','12:40:00',1.24),('15128','2014-01-10','12:45:00',1.32),('15128','2014-01-10','12:50:00',1.95),('15128','2014-01-10','12:55:00',1.75),('15128','2014-01-10','13:00:00',1.59),('15128','2014-01-10','13:05:00',1.43),('15128','2014-01-10','13:10:00',1.28),('15128','2014-01-10','13:15:00',1.48),('15128','2014-01-10','13:20:00',1.51),('15128','2014-01-10','13:25:00',1.26),('15128','2014-01-10','13:30:00',1.24),('15128','2014-01-10','13:35:00',1.05),('15128','2014-01-10','13:40:00',1.05),('15128','2014-01-10','13:50:00',1),('15128','2014-01-10','13:55:00',1.18),('15128','2014-01-10','14:00:00',1.39),('15128','2014-01-10','14:05:00',1.2),('15128','2014-01-09','11:50:00',1.08),('15128','2014-01-09','11:55:00',1.05),('15128','2014-01-08','10:35:00',1.09),('15128','2014-01-08','10:40:00',1.16),('15128','2014-01-08','10:45:00',1.13),('15128','2014-01-08','10:50:00',1.1),('15128','2014-01-08','10:55:00',1.03),('15128','2014-01-08','11:00:00',1.1),('15128','2014-01-08','11:05:00',1.19),('15128','2014-01-08','11:10:00',1.26),('15128','2014-01-08','11:15:00',1.4),('15128','2014-01-08','11:20:00',1.41),('15128','2014-01-08','11:25:00',1.31),('15128','2014-01-08','11:30:00',1.36),('15128','2014-01-08','11:35:00',1.24),('15128','2014-01-08','11:40:00',1.29),('15128','2014-01-08','11:45:00',1.29),('15128','2014-01-08','11:50:00',1.41),('15128','2014-01-08','11:55:00',1.31),('15128','2014-01-08','12:00:00',1.33),('15128','2014-01-08','12:05:00',1.49),('15128','2014-01-08','12:10:00',1.35),('15128','2014-01-08','12:15:00',1.5),('15128','2014-01-08','12:20:00',1.29),('15128','2014-01-08','12:25:00',1.25),('15128','2014-01-08','12:30:00',1.15),('15128','2014-01-08','12:35:00',1.32),('15128','2014-01-08','12:40:00',1.27),('15128','2014-01-08','12:45:00',1.24),('15128','2014-01-08','12:50:00',1.24),('15128','2014-01-08','12:55:00',1.38),('15128','2014-01-08','13:00:00',1.64),('15128','2014-01-08','13:05:00',1.56),('15128','2014-01-08','13:10:00',1.48),('15128','2014-01-08','13:15:00',1.57),('15128','2014-01-08','13:20:00',1.49),('15128','2014-01-08','13:25:00',1.08),('15128','2014-01-08','13:30:00',1.13),('15128','2014-01-08','13:35:00',1.15),('15128','2014-01-08','13:40:00',1.18),('15128','2014-01-08','13:45:00',1.22),('15128','2014-01-08','14:05:00',1.06),('15128','2014-01-08','14:10:00',1.03),('15128','2014-01-08','14:15:00',1.01),('15128','2014-01-08','14:25:00',1.03),('15128','2014-01-08','14:30:00',1.04),('15128','2014-01-08','14:45:00',1.01),('15128','2014-01-07','10:10:00',1.05),('15128','2014-01-07','10:15:00',1.15),('15128','2014-01-07','10:20:00',1.21),('15128','2014-01-07','10:25:00',1.25),('15128','2014-01-07','10:30:00',1.19),('15128','2014-01-07','10:35:00',1.22),('15128','2014-01-07','10:40:00',1.34),('15128','2014-01-07','10:45:00',1.39),('15128','2014-01-07','10:50:00',1.42),('15128','2014-01-07','10:55:00',1.47),('15128','2014-01-07','11:00:00',1.51),('15128','2014-01-07','11:05:00',1.56),('15128','2014-01-07','11:10:00',1.59),('15128','2014-01-07','11:15:00',1.62),('15128','2014-01-07','11:20:00',1.71),('15128','2014-01-07','11:25:00',1.82),('15128','2014-01-07','11:30:00',1.93),('15128','2014-01-07','11:35:00',2.01),('15128','2014-01-07','11:40:00',2.02),('15128','2014-01-07','11:45:00',2),('15128','2014-01-07','11:50:00',1.98),('15128','2014-01-07','11:55:00',1.98),('15128','2014-01-07','12:00:00',2.01),('15128','2014-01-07','12:05:00',2.09),('15128','2014-01-07','12:10:00',2.11),('15128','2014-01-07','12:15:00',2.11),('15128','2014-01-07','12:20:00',2.13),('15128','2014-01-07','12:25:00',2.14),('15128','2014-01-07','12:30:00',2.15),('15128','2014-01-07','12:35:00',2.14),('15128','2014-01-07','12:40:00',2.04),('15128','2014-01-07','12:45:00',2.07),('15128','2014-01-07','12:50:00',2.04),('15128','2014-01-07','12:55:00',2.03),('15128','2014-01-07','13:00:00',2.06),('15128','2014-01-07','13:05:00',2.07),('15128','2014-01-07','13:10:00',2.07),('15128','2014-01-07','13:15:00',2.07),('15128','2014-01-07','13:20:00',2.01),('15128','2014-01-07','13:25:00',2.04),('15128','2014-01-07','13:30:00',2.11),('15128','2014-01-07','13:35:00',2.1),('15128','2014-01-07','13:40:00',1.99),('15128','2014-01-07','13:45:00',1.98),('15128','2014-01-07','13:50:00',1.87),('15128','2014-01-07','13:55:00',1.92),('15128','2014-01-07','14:00:00',1.92),('15128','2014-01-07','14:05:00',1.76),('15128','2014-01-07','14:10:00',1.89),('15128','2014-01-07','14:15:00',1.81),('15128','2014-01-07','14:20:00',1.72),('15128','2014-01-07','14:25:00',1.8),('15128','2014-01-07','14:30:00',1.75),('15128','2014-01-07','14:35:00',1.54),('15128','2014-01-07','14:40:00',1.5),('15128','2014-01-07','14:45:00',1.56),('15128','2014-01-07','14:50:00',1.36),('15128','2014-01-07','14:55:00',1.13),('15128','2014-01-07','15:00:00',1.13),('15128','2014-01-07','15:05:00',1.01),('15128','2014-01-06','10:05:00',1.04),('15128','2014-01-06','10:10:00',1.1),('15128','2014-01-06','10:15:00',1.15),('15128','2014-01-06','10:20:00',1.2),('15128','2014-01-06','10:25:00',1.26),('15128','2014-01-06','10:30:00',1.3),('15128','2014-01-06','10:35:00',1.33),('15128','2014-01-06','10:40:00',1.35),('15128','2014-01-06','10:45:00',1.39),('15128','2014-01-06','10:50:00',1.45),('15128','2014-01-06','10:55:00',1.5),('15128','2014-01-06','11:00:00',1.56),('15128','2014-01-06','11:05:00',1.57),('15128','2014-01-06','11:10:00',1.6),('15128','2014-01-06','11:15:00',1.62),('15128','2014-01-06','11:20:00',1.71),('15128','2014-01-06','11:25:00',1.78),('15128','2014-01-06','11:30:00',1.89),('15128','2014-01-06','11:35:00',1.91),('15128','2014-01-06','11:40:00',1.98),('15128','2014-01-06','11:45:00',2.03),('15128','2014-01-06','11:50:00',2.04),('15128','2014-01-06','11:55:00',2.11),('15128','2014-01-06','12:00:00',2.15),('15128','2014-01-06','12:05:00',2.15),('15128','2014-01-06','12:10:00',2.18),('15128','2014-01-06','12:15:00',2.24),('15128','2014-01-06','12:20:00',2.26),('15128','2014-01-06','12:25:00',2.27),('15128','2014-01-06','12:30:00',2.27),('15128','2014-01-06','12:35:00',2.31),('15128','2014-01-06','12:40:00',2.24),('15128','2014-01-06','12:45:00',2.3),('15128','2014-01-06','12:50:00',2.3),('15128','2014-01-06','12:55:00',2.33),('15128','2014-01-06','13:00:00',2.31),('15128','2014-01-06','13:05:00',2.26),('15128','2014-01-06','13:10:00',2.26),('15128','2014-01-06','13:15:00',2.18),('15128','2014-01-06','13:20:00',2.11),('15128','2014-01-06','13:25:00',2.09),('15128','2014-01-06','13:30:00',2.09),('15128','2014-01-06','13:35:00',2.06),('15128','2014-01-06','13:40:00',2.13),('15128','2014-01-06','13:45:00',2.14),('15128','2014-01-06','13:50:00',2.08),('15128','2014-01-06','13:55:00',2.02),('15128','2014-01-06','14:00:00',1.95),('15128','2014-01-06','14:05:00',1.87),('15128','2014-01-06','14:10:00',1.88),('15128','2014-01-06','14:15:00',1.88),('15128','2014-01-06','14:20:00',1.8),('15128','2014-01-06','14:25:00',1.82),('15128','2014-01-06','14:30:00',1.72),('15128','2014-01-06','14:35:00',1.74),('15128','2014-01-06','14:40:00',1.69),('15128','2014-01-06','14:45:00',1.57),('15128','2014-01-06','14:50:00',1.55),('15128','2014-01-06','14:55:00',1.47),('15128','2014-01-06','15:00:00',1.51),('15128','2014-01-06','15:05:00',1.44),('15128','2014-01-06','15:10:00',1.28),('15128','2014-01-06','15:15:00',1.26),('15128','2014-01-06','15:20:00',1.13),('15128','2014-04-23','08:35:00',1.04),('15128','2014-04-23','08:40:00',1.09),('15128','2014-04-23','08:45:00',1.13),('15128','2014-04-23','08:50:00',1.24),('15128','2014-04-23','08:55:00',1.31),('15128','2014-04-23','09:00:00',1.37),('15128','2014-04-23','09:05:00',1.42),('15128','2014-04-23','09:10:00',1.5),('15128','2014-04-23','09:15:00',1.57),('15128','2014-04-23','09:20:00',1.67),('15128','2014-04-23','09:25:00',1.72),('15128','2014-04-23','09:30:00',1.8),('15128','2014-04-23','09:35:00',1.85),('15128','2014-04-23','09:40:00',1.84),('15128','2014-04-23','09:45:00',1.89),('15128','2014-04-23','09:50:00',1.95),('15128','2014-04-23','09:55:00',1.99),('15128','2014-04-23','10:00:00',2.06),('15128','2014-04-23','10:05:00',2.11),('15128','2014-04-23','10:10:00',2.17),('15128','2014-04-23','10:15:00',2.23),('15128','2014-04-23','10:20:00',2.33),('15128','2014-04-23','10:25:00',2.38),('15128','2014-04-23','10:30:00',2.45),('15128','2014-04-23','10:35:00',2.57),('15128','2014-04-23','10:40:00',2.59),('15128','2014-04-23','10:45:00',2.63),('15128','2014-04-23','10:50:00',2.66),('15128','2014-04-23','10:55:00',2.77),('15128','2014-04-23','11:00:00',2.83),('15128','2014-04-23','11:05:00',2.93),('15128','2014-04-23','11:10:00',3.01),('15128','2014-04-23','11:15:00',2.96),('15128','2014-04-23','11:20:00',3.07),('15128','2014-04-23','11:25:00',3.19),('15128','2014-04-23','11:30:00',3.17),('15128','2014-04-23','11:35:00',2.58),('15128','2014-04-23','11:40:00',1.03),('15128','2014-04-23','11:45:00',1.56),('15128','2014-04-23','11:50:00',3.58),('15128','2014-04-23','11:55:00',3.7),('15128','2014-04-23','12:00:00',3.63),('15128','2014-04-23','12:05:00',3.71),('15128','2014-04-23','12:10:00',3.72),('15128','2014-04-23','12:15:00',3.73),('15128','2014-04-23','12:20:00',3.75),('15128','2014-04-23','12:25:00',3.74),('15128','2014-04-23','12:30:00',3.75),('15128','2014-04-23','12:35:00',3.73),('15128','2014-04-23','12:40:00',3.8),('15128','2014-04-23','12:45:00',3.88),('15128','2014-04-23','12:50:00',3.94),('15128','2014-04-23','12:55:00',3.82),('15128','2014-04-23','13:00:00',2.57),('15128','2014-04-23','13:05:00',3.14),('15128','2014-04-23','13:10:00',4.07),('15128','2014-04-23','13:15:00',4.04),('15128','2014-04-23','13:20:00',3.81),('15128','2014-04-23','13:25:00',3.39),('15128','2014-04-23','13:30:00',2.3),('15128','2014-04-23','13:35:00',2.31),('15128','2014-04-23','13:40:00',2.67),('15128','2014-04-23','13:45:00',4.37),('15128','2014-04-23','13:50:00',3.96),('15128','2014-04-23','13:55:00',4.22),('15128','2014-04-23','14:00:00',4.2),('15128','2014-04-23','14:05:00',4.19),('15128','2014-04-23','14:10:00',4.19),('15128','2014-04-23','14:15:00',4.27),('15128','2014-04-23','14:20:00',4.41),('15128','2014-04-23','14:25:00',4.5),('15128','2014-04-23','14:30:00',4.7),('15128','2014-04-23','14:35:00',4.54),('15128','2014-04-23','14:40:00',4.32),('15128','2014-04-23','14:45:00',4.13),('15128','2014-04-23','14:50:00',4.06),('15128','2014-04-23','14:55:00',4.09),('15128','2014-04-23','15:00:00',4.27),('15128','2014-04-23','15:05:00',4.61),('15128','2014-04-23','15:10:00',3.8),('15128','2014-04-23','15:15:00',2.87),('15128','2014-04-23','15:20:00',3.27),('15128','2014-04-23','15:25:00',3.09),('15128','2014-04-23','15:30:00',4.44),('15128','2014-04-23','15:35:00',2.99),('15128','2014-04-23','15:40:00',3.34),('15128','2014-04-23','15:45:00',4.18),('15128','2014-04-23','15:50:00',4.31),('15128','2014-04-23','15:55:00',3.17),('15128','2014-04-23','16:00:00',3.62),('15128','2014-04-23','16:05:00',4),('15128','2014-04-23','16:10:00',3.52),('15128','2014-04-23','16:15:00',3.43),('15128','2014-04-23','16:20:00',2.97),('15128','2014-04-23','16:25:00',3.93),('15128','2014-04-23','16:30:00',3.97),('15128','2014-04-23','16:35:00',2.51),('15128','2014-04-23','16:40:00',3.03),('15128','2014-04-23','16:45:00',3.4),('15128','2014-04-23','16:50:00',2.07),('15128','2014-04-23','16:55:00',1.64),('15128','2014-04-23','17:00:00',1.43),('15128','2014-04-23','17:05:00',1.45),('15128','2014-04-23','17:10:00',1.55),('15128','2014-04-23','17:15:00',1.41),('15128','2014-04-23','17:20:00',1.35),('15128','2014-04-23','17:25:00',1.38),('15128','2014-04-23','17:30:00',1.15),('15128','2014-01-05','11:00:00',1.03),('15128','2014-01-05','11:25:00',1.19),('15128','2014-01-05','11:30:00',1.21),('15128','2014-01-05','11:35:00',1.4),('15128','2014-01-05','11:40:00',1.7),('15128','2014-01-05','11:45:00',2.1),('15128','2014-01-05','11:50:00',2.12),('15128','2014-01-05','11:55:00',2.18),('15128','2014-01-05','12:35:00',2.18),('15128','2014-01-05','12:40:00',2.19),('15128','2014-01-05','12:45:00',2.21),('15128','2014-01-05','12:50:00',2.22),('15128','2014-01-05','12:55:00',2.2),('15128','2014-01-05','13:00:00',2.2),('15128','2014-01-05','13:05:00',2.21),('15128','2014-01-05','13:10:00',2.21),('15128','2014-01-05','13:15:00',2.24),('15128','2014-01-05','13:20:00',2.25),('15128','2014-01-05','13:25:00',2.32),('15128','2014-01-05','13:30:00',2.44),('15128','2014-01-05','13:35:00',2.28),('15128','2014-01-05','13:40:00',2.2),('15128','2014-01-05','13:45:00',2.13),('15128','2014-01-05','13:50:00',2.09),('15128','2014-01-05','13:55:00',2.06),('15128','2014-01-05','14:00:00',2.04),('15128','2014-01-05','14:05:00',2.01),('15128','2014-01-05','14:10:00',1.94),('15128','2014-01-05','14:15:00',1.88),('15128','2014-01-05','14:20:00',2.06),('15128','2014-01-05','14:25:00',2.01),('15128','2014-01-05','14:30:00',1.89),('15128','2014-01-05','14:40:00',1.47),('15128','2014-01-05','14:45:00',1.84),('15128','2014-01-05','14:50:00',1.84),('15128','2014-01-05','14:55:00',1.71),('15128','2014-01-05','15:00:00',1.68),('15128','2014-01-05','15:05:00',1.49),('15128','2014-01-05','15:10:00',1.37),('15128','2014-01-05','15:15:00',1.26),('15128','2014-01-05','15:20:00',1.1),('15128','2014-01-05','15:25:00',1.18),('15128','2014-01-02','10:00:00',1.13),('15128','2014-01-02','10:05:00',1.43),('15128','2014-01-02','10:10:00',1.08),('15128','2014-01-02','10:15:00',1.09),('15128','2014-01-02','10:45:00',1.01),('15128','2014-01-02','10:50:00',1.1),('15128','2014-01-02','11:00:00',1.06),('15128','2014-01-02','11:05:00',1.02),('15128','2014-01-02','12:00:00',1.39),('15128','2014-01-02','12:05:00',2.15),('15128','2014-01-02','12:10:00',2.43),('15128','2014-01-02','12:15:00',2.43),('15128','2014-01-02','12:20:00',1.96),('15128','2014-01-02','12:25:00',1.97),('15128','2014-01-02','12:30:00',1.92),('15128','2014-01-02','12:35:00',2.11),('15128','2014-01-02','12:40:00',1.74),('15128','2014-01-02','12:45:00',2.51),('15128','2014-01-02','12:50:00',1.58),('15128','2014-01-02','12:55:00',2.15),('15128','2014-01-02','13:00:00',1.56),('15128','2014-01-02','13:05:00',1.64),('15128','2014-01-02','13:10:00',1.34),('15128','2014-01-02','13:15:00',1.36),('15128','2014-01-02','13:20:00',1.48),('15128','2014-01-02','13:25:00',1.63),('15128','2014-01-02','13:30:00',1.42),('15128','2014-01-02','13:35:00',1.42),('15128','2014-01-02','13:40:00',1.37),('15128','2014-01-02','13:45:00',1.37),('15128','2014-01-02','13:50:00',1.14),('15128','2014-01-02','13:55:00',1.02),('15128','2014-01-01','10:45:00',1.59),('15128','2014-01-01','10:50:00',1.12),('15128','2014-01-01','10:55:00',1.21),('15128','2014-01-01','11:00:00',1.4),('15128','2014-01-01','11:05:00',1.37),('15128','2014-01-01','11:10:00',1.32),('15128','2014-01-01','11:15:00',1.15),('15128','2014-01-01','11:20:00',1.19),('15128','2014-01-01','11:25:00',1.24),('15128','2014-01-01','11:30:00',1.38),('15128','2014-01-01','11:35:00',1.53),('15128','2014-01-01','11:40:00',1.32),('15128','2014-01-01','11:45:00',1.24),('15128','2014-01-01','11:50:00',1.16),('15128','2014-01-01','11:55:00',1.17),('15128','2014-01-01','12:00:00',1.11),('15128','2014-01-01','12:35:00',1.05),('15128','2014-01-01','12:40:00',1.18),('15128','2014-01-01','12:45:00',1.38),('15128','2014-01-01','12:50:00',2.02),('15128','2014-01-01','12:55:00',2.6),('15128','2014-01-01','13:00:00',2.18),('15128','2014-01-01','13:05:00',1.25),('15128','2013-12-31','11:10:00',1.01),('15128','2013-12-31','11:15:00',1.03),('15128','2013-12-31','11:20:00',1.04),('15128','2013-12-31','11:25:00',1.02),('15128','2013-12-31','11:30:00',1.02),('15128','2013-12-31','11:35:00',1.11),('15128','2013-12-31','11:40:00',1.12),('15128','2013-12-31','11:45:00',1.08),('15128','2013-12-31','11:50:00',1.05),('15128','2013-12-31','11:55:00',1.08),('15128','2013-12-31','12:00:00',1.12),('15128','2013-12-31','12:05:00',1.17),('15128','2013-12-31','12:10:00',1.23),('15128','2013-12-31','12:15:00',1.24),('15128','2013-12-31','12:20:00',1.25),('15128','2013-12-31','12:25:00',1.29),('15128','2013-12-31','12:30:00',1.34),('15128','2013-12-31','12:35:00',1.27),('15128','2013-12-31','12:40:00',1.33),('15128','2013-12-31','12:45:00',1.37),('15128','2013-12-31','12:50:00',1.49),('15128','2013-12-31','12:55:00',1.25),('15128','2013-12-31','13:00:00',1.14),('15128','2013-12-31','13:05:00',1.12),('15128','2013-12-31','13:10:00',1.13),('15128','2013-12-31','13:15:00',1.17),('15128','2013-12-31','13:20:00',1.16),('15128','2013-12-31','13:25:00',1.15),('15128','2013-12-31','13:30:00',1.56),('15128','2013-12-31','13:35:00',2.62),('15128','2013-12-31','13:40:00',2.14),('15128','2013-12-31','13:45:00',1.49),('15128','2013-12-31','13:50:00',2.06),('15128','2013-12-31','13:55:00',1.6),('15128','2013-12-31','14:00:00',2.28),('15128','2013-12-31','14:05:00',1.07),('15128','2013-12-31','14:10:00',1.46),('15128','2013-12-31','14:15:00',1.23),('15128','2013-12-31','14:40:00',1.26),('15128','2013-12-31','14:45:00',1.08),('15128','2013-12-31','15:00:00',1.26),('15128','2013-12-31','15:05:00',1.57),('15128','2013-12-31','15:10:00',1.22),('15128','2013-12-31','15:15:00',1.11),('15128','2013-12-31','15:20:00',1.01),('15128','2013-12-30','10:25:00',1.19),('15128','2013-12-30','11:05:00',1.03),('15128','2013-12-30','11:10:00',1.02),('15128','2013-12-30','11:20:00',1.13),('15128','2013-12-30','11:25:00',1.94),('15128','2013-12-30','11:30:00',2.31),('15128','2013-12-30','11:35:00',2.27),('15128','2013-12-30','11:40:00',2.17),('15128','2013-12-30','11:45:00',2.16),('15128','2013-12-30','11:50:00',2.15),('15128','2013-12-30','11:55:00',2.17),('15128','2013-12-30','12:00:00',2.17),('15128','2013-12-30','12:05:00',2.15),('15128','2013-12-30','12:10:00',2.13),('15128','2013-12-30','12:15:00',2.18),('15128','2013-12-30','12:20:00',2.18),('15128','2013-12-30','12:25:00',2.19),('15128','2013-12-30','12:30:00',2.2),('15128','2013-12-30','12:35:00',2.21),('15128','2013-12-30','12:40:00',2.22),('15128','2013-12-30','12:45:00',2.21),('15128','2013-12-30','12:50:00',2.21),('15128','2013-12-30','12:55:00',2.21),('15128','2013-12-30','13:00:00',2.21),('15128','2013-12-30','13:05:00',2.19),('15128','2013-12-30','13:10:00',2.17),('15128','2013-12-30','13:15:00',2.16),('15128','2013-12-30','13:20:00',2.15),('15128','2013-12-30','13:25:00',2.12),('15128','2013-12-30','13:30:00',2.11),('15128','2013-12-30','13:35:00',2.09),('15128','2013-12-30','13:40:00',2.07),('15128','2013-12-30','13:45:00',2.05),('15128','2013-12-30','13:50:00',2.01),('15128','2013-12-30','13:55:00',1.98),('15128','2013-12-30','14:00:00',1.95),('15128','2013-12-30','14:05:00',1.93),('15128','2013-12-30','14:10:00',1.88),('15128','2013-12-30','14:15:00',1.84),('15128','2013-12-30','14:20:00',1.8),('15128','2013-12-30','14:25:00',1.76),('15128','2013-12-30','14:30:00',1.7),('15128','2013-12-30','14:35:00',1.65),('15128','2013-12-30','14:40:00',1.55),('15128','2013-12-30','14:45:00',1.53),('15128','2013-12-30','14:50:00',1.46),('15128','2013-12-30','14:55:00',1.38),('15128','2013-12-30','15:00:00',1.27),('15128','2013-12-30','15:05:00',1.22),('15128','2013-12-30','15:10:00',1.14),('15128','2013-12-30','15:15:00',1.05),('15128','2013-12-28','09:45:00',1.02),('15128','2013-12-28','09:50:00',1.14),('15128','2013-12-28','10:05:00',1.2),('15128','2013-12-28','10:10:00',1.41),('15128','2013-12-28','10:15:00',1.65),('15128','2013-12-28','10:20:00',1.64),('15128','2013-12-28','10:25:00',1.62),('15128','2013-12-28','10:30:00',1.86),('15128','2013-12-28','10:35:00',1.62),('15128','2013-12-28','10:45:00',2.01),('15128','2013-12-28','10:50:00',1.9),('15128','2013-12-28','10:55:00',1.07),('15128','2013-12-28','11:05:00',1.02),('15128','2013-12-28','11:20:00',1.67),('15128','2013-12-28','11:25:00',1.5),('15128','2013-12-28','11:30:00',1.08),('15128','2013-12-28','11:35:00',1.1),('15128','2013-12-27','10:05:00',1.06),('15128','2013-12-27','10:10:00',1.12),('15128','2013-12-27','10:15:00',1.17),('15128','2013-12-27','10:20:00',1.23),('15128','2013-12-27','10:25:00',1.28),('15128','2013-12-27','10:30:00',1.32),('15128','2013-12-27','10:35:00',1.35),('15128','2013-12-27','10:40:00',1.39),('15128','2013-12-27','10:45:00',1.44),('15128','2013-12-27','10:50:00',1.49),('15128','2013-12-27','10:55:00',1.55),('15128','2013-12-27','11:00:00',1.58),('15128','2013-12-27','11:05:00',1.61),('15128','2013-12-27','11:10:00',1.66),('15128','2013-12-27','11:15:00',1.71),('15128','2013-12-27','11:20:00',1.79),('15128','2013-12-27','11:25:00',1.87),('15128','2013-12-27','11:30:00',1.91),('15128','2013-12-27','11:35:00',1.96),('15128','2013-12-27','11:40:00',2),('15128','2013-12-27','11:45:00',2.03),('15128','2013-12-27','11:50:00',2.07),('15128','2013-12-27','11:55:00',2.11),('15128','2013-12-27','12:00:00',2.12),('15128','2013-12-27','12:05:00',2.12),('15128','2013-12-27','12:10:00',2.17),('15128','2013-12-27','12:15:00',2.21),('15128','2013-12-27','12:20:00',2.17),('15128','2013-12-27','12:25:00',2.18),('15128','2013-12-27','12:30:00',2.18),('15128','2013-12-27','12:35:00',2.19),('15128','2013-12-27','12:40:00',2.18),('15128','2013-12-27','12:45:00',2.18),('15128','2013-12-27','12:50:00',2.2),('15128','2013-12-27','12:55:00',2.2),('15128','2013-12-27','13:00:00',2.15),('15128','2013-12-27','13:05:00',2.14),('15128','2013-12-27','13:10:00',2.11),('15128','2013-12-27','13:15:00',2.1),('15128','2013-12-27','13:20:00',2.08),('15128','2013-12-27','13:25:00',2.04),('15128','2013-12-27','13:30:00',2.03),('15128','2013-12-27','13:35:00',2.02),('15128','2013-12-27','13:40:00',2),('15128','2013-12-27','13:45:00',1.98),('15128','2013-12-27','13:50:00',1.97),('15128','2013-12-27','13:55:00',1.95),('15128','2013-12-27','14:00:00',1.94),('15128','2013-12-27','14:05:00',1.89),('15128','2013-12-27','14:10:00',1.84),('15128','2013-12-27','14:15:00',1.82),('15128','2013-12-27','14:20:00',1.8),('15128','2013-12-27','14:25:00',1.76),('15128','2013-12-27','14:30:00',1.73),('15128','2013-12-27','14:35:00',1.61),('15128','2013-12-27','14:40:00',1.27),('15128','2013-12-27','14:50:00',1),('15128','2013-12-27','14:55:00',1.34),('15128','2013-12-27','15:00:00',1.41),('15128','2013-12-27','15:05:00',1.3),('15128','2013-12-27','15:10:00',1.16),('15128','2013-12-27','15:15:00',1.08),('15128','2014-04-22','10:50:00',1.08),('15128','2014-04-22','10:55:00',1.16),('15128','2014-04-22','11:00:00',1.17),('15128','2014-04-22','11:05:00',1.11),('15128','2014-04-22','11:10:00',1.07),('15128','2014-04-22','13:30:00',1.05),('15128','2014-04-22','13:35:00',1.18),('15128','2014-04-22','13:40:00',1.28),('15128','2014-04-22','13:45:00',1.38),('15128','2014-04-22','13:50:00',1.36),('15128','2014-04-22','13:55:00',1.41),('15128','2014-04-22','14:00:00',1.49),('15128','2014-04-22','14:05:00',1.53),('15128','2014-04-22','14:10:00',1.53),('15128','2014-04-22','14:15:00',1.49),('15128','2014-04-22','14:20:00',1.43),('15128','2014-04-22','14:25:00',1.35),('15128','2014-04-22','14:30:00',1.26),('15128','2014-04-22','14:35:00',1.1),('15128','2014-04-22','14:40:00',1.02),('15128','2014-04-22','14:45:00',1.01),('15128','2014-04-22','14:50:00',1),('15128','2014-04-22','15:10:00',1),('15128','2014-04-22','15:15:00',1.09),('15128','2014-04-22','15:20:00',1.13),('15128','2014-04-22','15:25:00',1.16),('15128','2014-04-22','15:30:00',1.19),('15128','2014-04-22','15:35:00',1.13),('15128','2013-12-26','11:45:00',1.02),('15128','2013-12-26','11:50:00',1.25),('15128','2013-12-26','11:55:00',1.41),('15128','2013-12-26','12:00:00',1.67),('15128','2013-12-26','12:05:00',1.71),('15128','2013-12-26','12:10:00',1.54),('15128','2013-12-26','12:25:00',1.03),('15128','2013-12-26','12:35:00',1.08),('15128','2013-12-26','12:40:00',1.71),('15128','2013-12-26','12:45:00',1.99),('15128','2013-12-26','12:50:00',1.89),('15128','2013-12-26','12:55:00',1.72),('15128','2013-12-26','13:00:00',2.07),('15128','2013-12-26','13:05:00',2.12),('15128','2013-12-26','13:10:00',2.14),('15128','2013-12-26','13:15:00',2.14),('15128','2013-12-26','13:20:00',2.21),('15128','2013-12-26','13:25:00',2.56),('15128','2013-12-26','13:30:00',1.54),('15128','2013-12-26','13:35:00',1.4),('15128','2013-12-26','13:40:00',1.27),('15128','2013-12-26','13:45:00',1.17),('15128','2013-12-26','13:50:00',1.17),('15128','2013-12-26','13:55:00',1.25),('15128','2013-12-26','14:00:00',1.64),('15128','2013-12-26','14:05:00',1.89),('15128','2013-12-26','14:10:00',2.19),('15128','2013-12-26','14:15:00',1.27),('15128','2013-12-26','14:20:00',1.09),('15128','2013-12-26','14:25:00',1.16),('15128','2013-12-26','14:30:00',1.22),('15128','2013-12-26','14:35:00',1.31),('15128','2013-12-24','10:40:00',1.02),('15128','2013-12-24','10:45:00',1.01),('15128','2013-12-24','11:05:00',1.09),('15128','2013-12-24','11:10:00',1.29),('15128','2013-12-24','11:15:00',1.05),('15128','2013-12-24','11:35:00',1.04),('15128','2013-12-24','11:45:00',1.13),('15128','2013-12-24','11:50:00',1.34),('15128','2013-12-24','11:55:00',1.38),('15128','2013-12-24','12:05:00',1.23),('15128','2013-12-24','12:10:00',2.19),('15128','2013-12-24','12:15:00',2.22),('15128','2013-12-24','12:20:00',2.25),('15128','2013-12-24','12:25:00',1.54),('15128','2013-12-24','12:35:00',1.03),('15128','2013-12-24','12:40:00',1.42),('15128','2013-12-24','12:45:00',1.51),('15128','2013-12-24','12:50:00',1.14),('15128','2013-12-24','12:55:00',1.09),('15128','2013-12-24','13:00:00',1.04),('15128','2013-12-24','13:05:00',1.13),('15128','2013-12-24','13:40:00',1.16),('15128','2013-12-24','13:45:00',1.24),('15128','2013-12-24','13:50:00',1.16),('15128','2013-12-23','10:05:00',1.02),('15128','2013-12-23','10:10:00',1.09),('15128','2013-12-23','10:15:00',1.15),('15128','2013-12-23','10:20:00',1.18),('15128','2013-12-23','10:25:00',1.21),('15128','2013-12-23','10:30:00',1.22),('15128','2013-12-23','10:35:00',1.24),('15128','2013-12-23','10:40:00',1.29),('15128','2013-12-23','10:45:00',1.33),('15128','2013-12-23','10:50:00',1.37),('15128','2013-12-23','10:55:00',1.4),('15128','2013-12-23','11:00:00',1.43),('15128','2013-12-23','11:05:00',1.47),('15128','2013-12-23','11:10:00',1.54),('15128','2013-12-23','11:15:00',1.57),('15128','2013-12-23','11:20:00',1.69),('15128','2013-12-23','11:25:00',1.71),('15128','2013-12-23','11:30:00',1.8),('15128','2013-12-23','11:35:00',1.81),('15128','2013-12-23','11:40:00',1.83),('15128','2013-12-23','11:45:00',1.89),('15128','2013-12-23','11:50:00',1.91),('15128','2013-12-23','11:55:00',1.93),('15128','2013-12-23','12:00:00',1.94),('15128','2013-12-23','12:05:00',1.96),('15128','2013-12-23','12:10:00',1.95),('15128','2013-12-23','12:15:00',1.96),('15128','2013-12-23','12:20:00',1.95),('15128','2013-12-23','12:25:00',1.94),('15128','2013-12-23','12:30:00',1.96),('15128','2013-12-23','12:35:00',2.02),('15128','2013-12-23','12:40:00',2),('15128','2013-12-23','12:45:00',1.98),('15128','2013-12-23','12:50:00',1.97),('15128','2013-12-23','12:55:00',1.92),('15128','2013-12-23','13:00:00',1.88),('15128','2013-12-23','13:05:00',1.91),('15128','2013-12-23','13:10:00',1.88),('15128','2013-12-23','13:15:00',1.85),('15128','2013-12-23','13:20:00',1.84),('15128','2013-12-23','13:25:00',1.82),('15128','2013-12-23','13:30:00',1.78),('15128','2013-12-23','13:35:00',1.77),('15128','2013-12-23','13:40:00',1.72),('15128','2013-12-23','13:45:00',1.72),('15128','2013-12-23','13:50:00',1.69),('15128','2013-12-23','13:55:00',1.64),('15128','2013-12-23','14:00:00',1.61),('15128','2013-12-23','14:05:00',1.55),('15128','2013-12-23','14:10:00',1.52),('15128','2013-12-23','14:15:00',1.45),('15128','2013-12-23','14:20:00',1.4),('15128','2013-12-23','14:25:00',1.36),('15128','2013-12-23','14:30:00',1.28),('15128','2013-12-23','14:35:00',1.24),('15128','2013-12-23','14:40:00',1.21),('15128','2013-12-23','14:45:00',1.15),('15128','2013-12-23','14:50:00',1.1),('15128','2013-12-23','14:55:00',1.03),('15128','2013-12-22','10:15:00',1.14),('15128','2013-12-22','10:20:00',1.18),('15128','2013-12-22','10:25:00',1.35),('15128','2013-12-22','10:30:00',1.43),('15128','2013-12-22','10:35:00',1.41),('15128','2013-12-22','10:40:00',1.15),('15128','2013-12-22','10:45:00',1.27),('15128','2013-12-22','10:50:00',1.47),('15128','2013-12-22','10:55:00',1.49),('15128','2013-12-22','11:00:00',1.61),('15128','2013-12-22','11:05:00',1.67),('15128','2013-12-22','11:10:00',1.51),('15128','2013-12-22','11:15:00',1.68),('15128','2013-12-22','11:20:00',1.84),('15128','2013-12-22','11:25:00',1.83),('15128','2013-12-22','11:30:00',2.08),('15128','2013-12-22','11:35:00',2.15),('15128','2013-12-22','11:40:00',2.12),('15128','2013-12-22','11:45:00',2.11),('15128','2013-12-22','11:50:00',1.84),('15128','2013-12-22','11:55:00',2.11),('15128','2013-12-22','12:00:00',2.19),('15128','2013-12-22','12:05:00',2.15),('15128','2013-12-22','12:10:00',2.11),('15128','2013-12-22','12:15:00',2.08),('15128','2013-12-22','12:20:00',2.06),('15128','2013-12-22','12:25:00',2.06),('15128','2013-12-22','12:30:00',2.06),('15128','2013-12-22','12:35:00',2.03),('15128','2013-12-22','12:40:00',2.04),('15128','2013-12-22','12:45:00',2.04),('15128','2013-12-22','12:50:00',2.02),('15128','2013-12-22','12:55:00',1.99),('15128','2013-12-22','13:00:00',1.99),('15128','2013-12-22','13:05:00',2),('15128','2013-12-22','13:10:00',2),('15128','2013-12-22','13:15:00',2.01),('15128','2013-12-22','13:20:00',2.01),('15128','2013-12-22','13:25:00',2.01),('15128','2013-12-22','13:30:00',1.96),('15128','2013-12-22','13:35:00',1.92),('15128','2013-12-22','13:40:00',1.93),('15128','2013-12-22','13:45:00',1.79),('15128','2013-12-22','13:50:00',1.65),('15128','2013-12-22','13:55:00',1.89),('15128','2013-12-22','14:00:00',1.84),('15128','2013-12-22','14:05:00',1.8),('15128','2013-12-22','14:10:00',1.75),('15128','2013-12-22','14:15:00',1.72),('15128','2013-12-22','14:20:00',1.66),('15128','2013-12-22','14:25:00',1.61),('15128','2013-12-22','14:30:00',1.5),('15128','2013-12-22','14:35:00',1.49),('15128','2013-12-22','14:40:00',1.45),('15128','2013-12-22','14:45:00',1.4),('15128','2013-12-22','14:50:00',1.29),('15128','2013-12-22','14:55:00',1.26),('15128','2013-12-22','15:00:00',1.17),('15128','2013-12-22','15:05:00',1.07),('15128','2013-12-21','09:35:00',1.03),('15128','2013-12-21','09:40:00',1.22),('15128','2013-12-21','09:45:00',1.34),('15128','2013-12-21','09:50:00',1.4),('15128','2013-12-21','09:55:00',1.44),('15128','2013-12-21','10:00:00',1.54),('15128','2013-12-21','10:05:00',1.51),('15128','2013-12-21','10:10:00',1.5),('15128','2013-12-21','10:15:00',1.58),('15128','2013-12-21','10:20:00',1.57),('15128','2013-12-21','10:25:00',1.53),('15128','2013-12-21','10:30:00',1.46),('15128','2013-12-21','10:35:00',1.45),('15128','2013-12-21','10:40:00',1.55),('15128','2013-12-21','10:45:00',1.47),('15128','2013-12-21','10:50:00',1.62),('15128','2013-12-21','10:55:00',1.73),('15128','2013-12-21','11:00:00',1.68),('15128','2013-12-21','11:05:00',1.84),('15128','2013-12-21','11:10:00',1.79),('15128','2013-12-21','11:15:00',1.69),('15128','2013-12-21','11:20:00',1.95),('15128','2013-12-21','11:25:00',1.9),('15128','2013-12-21','11:30:00',1.78),('15128','2013-12-21','11:35:00',1.93),('15128','2013-12-21','11:40:00',1.91),('15128','2013-12-21','11:45:00',1.92),('15128','2013-12-21','11:50:00',1.52),('15128','2013-12-21','11:55:00',1.23),('15128','2013-12-21','12:00:00',1.01),('15128','2013-12-21','12:25:00',1.07),('15128','2013-12-21','12:30:00',1.15),('15128','2013-12-21','12:35:00',1.31),('15128','2013-12-21','12:40:00',1.5),('15128','2013-12-21','12:45:00',1.57),('15128','2013-12-21','12:50:00',1.37),('15128','2013-12-21','12:55:00',1.57),('15128','2013-12-21','13:00:00',2.15),('15128','2013-12-21','13:05:00',2.28),('15128','2013-12-21','13:10:00',2.35),('15128','2013-12-21','13:15:00',2.38),('15128','2013-12-21','13:20:00',1.98),('15128','2013-12-21','13:25:00',2.22),('15128','2013-12-21','13:30:00',2.21),('15128','2013-12-21','13:35:00',1.82),('15128','2013-12-21','13:40:00',1.91),('15128','2013-12-21','13:45:00',1.5),('15128','2013-12-21','13:50:00',1.19),('15128','2013-12-21','13:55:00',1.15),('15128','2013-12-21','14:00:00',1.33),('15128','2013-12-21','14:05:00',1.34),('15128','2013-12-21','14:10:00',1.41),('15128','2013-12-21','14:15:00',1.34),('15128','2013-12-21','14:20:00',1.04),('15128','2013-12-21','14:35:00',1.35),('15128','2013-12-21','14:40:00',1.57),('15128','2013-12-21','14:45:00',1.48),('15128','2013-12-21','14:50:00',1.03),('15128','2013-12-20','10:00:00',1.02),('15128','2013-12-20','10:05:00',1.05),('15128','2013-12-20','10:10:00',1.1),('15128','2013-12-20','10:15:00',1.17),('15128','2013-12-20','10:20:00',1.22),('15128','2013-12-20','10:25:00',1.26),('15128','2013-12-20','10:30:00',1.29),('15128','2013-12-20','10:35:00',1.33),('15128','2013-12-20','10:40:00',1.37),('15128','2013-12-20','10:45:00',1.42),('15128','2013-12-20','10:50:00',1.46),('15128','2013-12-20','10:55:00',1.5),('15128','2013-12-20','11:00:00',1.53),('15128','2013-12-20','11:05:00',1.57),('15128','2013-12-20','11:10:00',1.62),('15128','2013-12-20','11:15:00',1.68),('15128','2013-12-20','11:20:00',1.82),('15128','2013-12-20','11:25:00',1.86),('15128','2013-12-20','11:30:00',1.9),('15128','2013-12-20','11:35:00',1.93),('15128','2013-12-20','11:40:00',1.95),('15128','2013-12-20','11:45:00',2),('15128','2013-12-20','11:50:00',2.03),('15128','2013-12-20','11:55:00',2.04),('15128','2013-12-20','12:00:00',2.06),('15128','2013-12-20','12:05:00',2.08),('15128','2013-12-20','12:10:00',2.09),('15128','2013-12-20','12:15:00',2.09),('15128','2013-12-20','12:20:00',2.11),('15128','2013-12-20','12:25:00',2.11),('15128','2013-12-20','12:30:00',2.1),('15128','2013-12-20','12:35:00',2.1),('15128','2013-12-20','12:40:00',2.12),('15128','2013-12-20','12:45:00',2.12),('15128','2013-12-20','12:50:00',2.12),('15128','2013-12-20','12:55:00',2.13),('15128','2013-12-20','13:00:00',2.12),('15128','2013-12-20','13:05:00',2.1),('15128','2013-12-20','13:10:00',2.1),('15128','2013-12-20','13:15:00',2.1),('15128','2013-12-20','13:20:00',2.09),('15128','2013-12-20','13:25:00',2.09),('15128','2013-12-20','13:30:00',2.07),('15128','2013-12-20','13:35:00',2.05),('15128','2013-12-20','13:40:00',2.03),('15128','2013-12-20','13:45:00',2.01),('15128','2013-12-20','13:50:00',1.99),('15128','2013-12-20','13:55:00',1.95),('15128','2013-12-20','14:00:00',1.9),('15128','2013-12-20','14:05:00',1.84),('15128','2013-12-20','14:10:00',1.79),('15128','2013-12-20','14:15:00',1.76),('15128','2013-12-20','14:20:00',1.71),('15128','2013-12-20','14:25:00',1.64),('15128','2013-12-20','14:30:00',1.57),('15128','2013-12-20','14:35:00',1.52),('15128','2013-12-20','14:40:00',1.46),('15128','2013-12-20','14:45:00',1.41),('15128','2013-12-20','14:50:00',1.3),('15128','2013-12-20','14:55:00',1.28),('15128','2013-12-20','15:00:00',1.2),('15128','2013-12-20','15:05:00',1.1),('15128','2013-12-20','15:10:00',1.01),('15128','2013-12-19','10:05:00',1.02),('15128','2013-12-19','10:10:00',1.07),('15128','2013-12-19','10:15:00',1.14),('15128','2013-12-19','10:20:00',1.18),('15128','2013-12-19','10:25:00',1.21),('15128','2013-12-19','10:30:00',1.24),('15128','2013-12-19','10:35:00',1.27),('15128','2013-12-19','10:40:00',1.32),('15128','2013-12-19','10:45:00',1.36),('15128','2013-12-19','10:50:00',1.4),('15128','2013-12-19','10:55:00',1.42),('15128','2013-12-19','11:00:00',1.47),('15128','2013-12-19','11:05:00',1.49),('15128','2013-12-19','11:10:00',1.54),('15128','2013-12-19','11:15:00',1.62),('15128','2013-12-19','11:20:00',1.73),('15128','2013-12-19','11:25:00',1.79),('15128','2013-12-19','11:30:00',1.82),('15128','2013-12-19','11:35:00',1.85),('15128','2013-12-19','11:40:00',1.88),('15128','2013-12-19','11:45:00',1.89),('15128','2013-12-19','11:50:00',1.91),('15128','2013-12-19','11:55:00',1.96),('15128','2013-12-19','12:00:00',1.96),('15128','2013-12-19','12:05:00',1.97),('15128','2013-12-19','12:10:00',2),('15128','2013-12-19','12:15:00',1.98),('15128','2013-12-19','12:20:00',1.97),('15128','2013-12-19','12:25:00',1.99),('15128','2013-12-19','12:30:00',2),('15128','2013-12-19','12:35:00',2),('15128','2013-12-19','12:40:00',2),('15128','2013-12-19','12:45:00',1.98),('15128','2013-12-19','12:50:00',1.94),('15128','2013-12-19','12:55:00',1.96),('15128','2013-12-19','13:00:00',1.95),('15128','2013-12-19','13:05:00',1.94),('15128','2013-12-19','13:10:00',1.9),('15128','2013-12-19','13:15:00',1.84),('15128','2013-12-19','13:20:00',1.83),('15128','2013-12-19','13:25:00',1.86),('15128','2013-12-19','13:30:00',1.82),('15128','2013-12-19','13:35:00',1.75),('15128','2013-12-19','13:40:00',1.75),('15128','2013-12-19','13:45:00',1.74),('15128','2013-12-19','13:50:00',1.67),('15128','2013-12-19','13:55:00',1.49),('15128','2013-12-19','14:00:00',1.41),('15128','2013-12-19','14:05:00',1.52),('15128','2013-12-19','14:10:00',1.52),('15128','2013-12-19','14:15:00',1.42),('15128','2013-12-19','14:20:00',1.42),('15128','2013-12-19','14:30:00',1.08),('15128','2013-12-19','14:40:00',1.06),('15128','2013-12-19','14:45:00',1.2),('15128','2013-12-19','14:50:00',1.17),('15128','2013-12-19','14:55:00',1.07),('15128','2013-12-18','09:45:00',1.11),('15128','2013-12-18','10:40:00',1.46),('15128','2013-12-18','10:55:00',1.06),('15128','2013-12-18','12:25:00',1.05),('15128','2013-12-18','12:30:00',1.38),('15128','2013-12-18','14:30:00',1.04),('15128','2013-12-18','14:35:00',1.5),('15128','2013-12-18','14:40:00',1.52),('15128','2013-12-18','14:45:00',1.4),('15128','2013-12-18','14:50:00',1.12),('15128','2013-12-18','15:05:00',1.06),('15128','2013-12-17','10:00:00',1.04),('15128','2013-12-17','10:05:00',1.1),('15128','2013-12-17','10:10:00',1.16),('15128','2013-12-17','10:15:00',1.22),('15128','2013-12-17','10:20:00',1.26),('15128','2013-12-17','10:25:00',1.29),('15128','2013-12-17','10:30:00',1.32),('15128','2013-12-17','10:35:00',1.36),('15128','2013-12-17','10:40:00',1.4),('15128','2013-12-17','10:45:00',1.46),('15128','2013-12-17','10:50:00',1.49),('15128','2013-12-17','10:55:00',1.51),('15128','2013-12-17','11:00:00',1.55),('15128','2013-12-17','11:05:00',1.58),('15128','2013-12-17','11:10:00',1.62),('15128','2013-12-17','11:15:00',1.7),('15128','2013-12-17','11:20:00',1.83),('15128','2013-12-17','11:25:00',1.89),('15128','2013-12-17','11:30:00',1.92),('15128','2013-12-17','11:35:00',1.94),('15128','2013-12-17','11:40:00',1.98),('15128','2013-12-17','11:45:00',2),('15128','2013-12-17','11:50:00',2.04),('15128','2013-12-17','11:55:00',2.05),('15128','2013-12-17','12:00:00',2.07),('15128','2013-12-17','12:05:00',2.11),('15128','2013-12-17','12:10:00',2.12),('15128','2013-12-17','12:15:00',2.15),('15128','2013-12-17','12:20:00',2.15),('15128','2013-12-17','12:25:00',2.15),('15128','2013-12-17','12:30:00',2.16),('15128','2013-12-17','12:35:00',2.14),('15128','2013-12-17','12:40:00',2.16),('15128','2013-12-17','12:45:00',2.17),('15128','2013-12-17','12:50:00',2.17),('15128','2013-12-17','12:55:00',2.14),('15128','2013-12-17','13:00:00',2.11),('15128','2013-12-17','13:05:00',2.12),('15128','2013-12-17','13:10:00',2.13),('15128','2013-12-17','13:15:00',2.1),('15128','2013-12-17','13:20:00',2.1),('15128','2013-12-17','13:25:00',2.1),('15128','2013-12-17','13:30:00',2.06),('15128','2013-12-17','13:35:00',2.02),('15128','2013-12-17','13:40:00',2),('15128','2013-12-17','13:45:00',1.97),('15128','2013-12-17','13:50:00',1.94),('15128','2013-12-17','13:55:00',1.92),('15128','2013-12-17','14:00:00',1.87),('15128','2013-12-17','14:05:00',1.8),('15128','2013-12-17','14:10:00',1.76),('15128','2013-12-17','14:15:00',1.72),('15128','2013-12-17','14:20:00',1.68),('15128','2013-12-17','14:25:00',1.63),('15128','2013-12-17','14:30:00',1.54),('15128','2013-12-17','14:35:00',1.49),('15128','2013-12-17','14:40:00',1.43),('15128','2013-12-17','14:45:00',1.35),('15128','2013-12-17','14:50:00',1.27),('15128','2013-12-17','14:55:00',1.22),('15128','2013-12-17','15:00:00',1.13),('15128','2013-12-17','15:05:00',1.06),('15128','2014-04-21','08:30:00',1.01),('15128','2014-04-21','08:35:00',1.03),('15128','2014-04-21','08:40:00',1.06),('15128','2014-04-21','08:45:00',1.22),('15128','2014-04-21','08:50:00',1.31),('15128','2014-04-21','08:55:00',1.33),('15128','2014-04-21','09:00:00',1.46),('15128','2014-04-21','09:05:00',1.3),('15128','2014-04-21','09:15:00',1.46),('15128','2014-04-21','09:20:00',1.73),('15128','2014-04-21','09:25:00',1.9),('15128','2014-04-21','09:30:00',1.89),('15128','2014-04-21','09:35:00',1.98),('15128','2014-04-21','09:40:00',1.83),('15128','2014-04-21','09:45:00',2.24),('15128','2014-04-21','09:50:00',1.33),('15128','2014-04-21','09:55:00',1.25),('15128','2014-04-21','10:00:00',1.54),('15128','2014-04-21','10:05:00',1.55),('15128','2014-04-21','10:10:00',1.61),('15128','2014-04-21','10:15:00',1.69),('15128','2014-04-21','10:20:00',2.69),('15128','2014-04-21','10:25:00',1.55),('15128','2014-04-21','10:30:00',1.91),('15128','2014-04-21','10:35:00',1.85),('15128','2014-04-21','10:40:00',2.36),('15128','2014-04-21','10:45:00',2.71),('15128','2014-04-21','10:50:00',2.49),('15128','2014-04-21','10:55:00',2.59),('15128','2014-04-21','11:00:00',2.89),('15128','2014-04-21','11:05:00',2.54),('15128','2014-04-21','11:10:00',1.56),('15128','2014-04-21','11:15:00',1.55),('15128','2014-04-21','11:20:00',1.33),('15128','2014-04-21','11:25:00',1.09),('15128','2014-04-21','11:40:00',1),('15128','2014-04-21','11:45:00',1.05),('15128','2014-04-21','11:50:00',1.22),('15128','2014-04-21','11:55:00',1.08),('15128','2014-04-21','12:00:00',1.03),('15128','2014-04-21','12:05:00',1.12),('15128','2014-04-21','12:10:00',1.11),('15128','2014-04-21','12:15:00',1.14),('15128','2014-04-21','12:20:00',1.21),('15128','2014-04-21','12:25:00',1.26),('15128','2014-04-21','12:30:00',1.15),('15128','2014-04-21','12:50:00',1),('15128','2014-04-21','12:55:00',1.09),('15128','2014-04-21','13:00:00',1.13),('15128','2014-04-21','13:05:00',1.23),('15128','2014-04-21','13:10:00',1.43),('15128','2014-04-21','13:15:00',1.41),('15128','2014-04-21','13:20:00',1.31),('15128','2014-04-21','13:25:00',1.81),('15128','2014-04-21','13:30:00',2.57),('15128','2014-04-21','13:35:00',2.58),('15128','2014-04-21','13:40:00',2.85),('15128','2014-04-21','13:45:00',3.22),('15128','2014-04-21','13:50:00',2.05),('15128','2014-04-21','13:55:00',2.01),('15128','2014-04-21','14:00:00',1.86),('15128','2014-04-21','14:05:00',3.64),('15128','2014-04-21','14:10:00',3.64),('15128','2014-04-21','14:15:00',2.98),('15128','2014-04-21','14:20:00',2.04),('15128','2014-04-21','14:25:00',1.85),('15128','2014-04-21','14:30:00',2.17),('15128','2014-04-21','14:35:00',2.51),('15128','2014-04-21','14:40:00',1.8),('15128','2014-04-21','14:45:00',1.9),('15128','2014-04-21','14:50:00',3.09),('15128','2014-04-21','14:55:00',2.62),('15128','2014-04-21','15:00:00',1.55),('15128','2014-04-21','15:05:00',1.73),('15128','2014-04-21','15:10:00',1.45),('15128','2014-04-21','15:15:00',1.47),('15128','2014-04-21','15:20:00',1.58),('15128','2014-04-21','15:25:00',2.49),('15128','2014-04-21','15:30:00',2.1),('15128','2014-04-21','15:35:00',2.49),('15128','2014-04-21','15:40:00',2.23),('15128','2014-04-21','15:45:00',2.73),('15128','2014-04-21','15:50:00',2.56),('15128','2014-04-21','15:55:00',2.46),('15128','2014-04-21','16:00:00',3.03),('15128','2014-04-21','16:05:00',2.01),('15128','2014-04-21','16:10:00',1.67),('15128','2014-04-21','16:15:00',1.48),('15128','2014-04-21','16:20:00',1.59),('15128','2014-04-21','16:25:00',1.5),('15128','2014-04-21','16:30:00',1.39),('15128','2014-04-21','16:35:00',1.42),('15128','2014-04-21','16:40:00',1.42),('15128','2014-04-21','16:45:00',1.48),('15128','2014-04-21','16:50:00',1.38),('15128','2014-04-21','16:55:00',1.44),('15128','2014-04-21','17:00:00',1.87),('15128','2014-04-21','17:05:00',1.34),('15128','2014-04-21','17:10:00',1.02),('15128','2013-12-16','09:55:00',1.02),('15128','2013-12-16','10:00:00',1.08),('15128','2013-12-16','10:05:00',1.15),('15128','2013-12-16','10:10:00',1.2),('15128','2013-12-16','10:15:00',1.27),('15128','2013-12-16','10:20:00',1.3),('15128','2013-12-16','10:25:00',1.31),('15128','2013-12-16','10:30:00',1.34),('15128','2013-12-16','10:35:00',1.39),('15128','2013-12-16','10:40:00',1.44),('15128','2013-12-16','10:45:00',1.49),('15128','2013-12-16','10:50:00',1.54),('15128','2013-12-16','10:55:00',1.58),('15128','2013-12-16','11:00:00',1.61),('15128','2013-12-16','11:05:00',1.65),('15128','2013-12-16','11:10:00',1.69),('15128','2013-12-16','11:15:00',1.81),('15128','2013-12-16','11:20:00',1.93),('15128','2013-12-16','11:25:00',1.97),('15128','2013-12-16','11:30:00',2.01),('15128','2013-12-16','11:35:00',2.06),('15128','2013-12-16','11:40:00',2.09),('15128','2013-12-16','11:45:00',2.12),('15128','2013-12-16','11:50:00',2.13),('15128','2013-12-16','11:55:00',2.16),('15128','2013-12-16','12:00:00',2.19),('15128','2013-12-16','12:05:00',2.23),('15128','2013-12-16','12:10:00',2.24),('15128','2013-12-16','12:15:00',2.24),('15128','2013-12-16','12:20:00',2.25),('15128','2013-12-16','12:25:00',2.26),('15128','2013-12-16','12:30:00',2.26),('15128','2013-12-16','12:35:00',2.26),('15128','2013-12-16','12:40:00',2.28),('15128','2013-12-16','12:45:00',2.27),('15128','2013-12-16','12:50:00',2.27),('15128','2013-12-16','12:55:00',2.25),('15128','2013-12-16','13:00:00',2.25),('15128','2013-12-16','13:05:00',2.23),('15128','2013-12-16','13:10:00',2.22),('15128','2013-12-16','13:15:00',2.19),('15128','2013-12-16','13:20:00',2.16),('15128','2013-12-16','13:25:00',2.14),('15128','2013-12-16','13:30:00',2.1),('15128','2013-12-16','13:35:00',2.07),('15128','2013-12-16','13:40:00',2.05),('15128','2013-12-16','13:45:00',2.02),('15128','2013-12-16','13:50:00',2),('15128','2013-12-16','13:55:00',1.92),('15128','2013-12-16','14:00:00',1.89),('15128','2013-12-16','14:05:00',1.86),('15128','2013-12-16','14:10:00',1.83),('15128','2013-12-16','14:15:00',1.79),('15128','2013-12-16','14:20:00',1.75),('15128','2013-12-16','14:25:00',1.67),('15128','2013-12-16','14:30:00',1.6),('15128','2013-12-16','14:35:00',1.57),('15128','2013-12-16','14:40:00',1.51),('15128','2013-12-16','14:45:00',1.42),('15128','2013-12-16','14:50:00',1.34),('15128','2013-12-16','14:55:00',1.3),('15128','2013-12-16','15:00:00',1.2),('15128','2013-12-16','15:05:00',1.11),('15128','2013-12-16','15:10:00',1.03),('15128','2013-12-15','10:05:00',1.16),('15128','2013-12-15','10:10:00',1.19),('15128','2013-12-15','10:15:00',1.25),('15128','2013-12-15','10:20:00',1.28),('15128','2013-12-15','10:25:00',1.32),('15128','2013-12-15','10:30:00',1.35),('15128','2013-12-15','10:35:00',1.39),('15128','2013-12-15','10:40:00',1.45),('15128','2013-12-15','10:45:00',1.48),('15128','2013-12-15','10:50:00',1.54),('15128','2013-12-15','10:55:00',1.56),('15128','2013-12-15','11:00:00',1.58),('15128','2013-12-15','11:05:00',1.63),('15128','2013-12-15','11:10:00',1.68),('15128','2013-12-15','11:15:00',1.83),('15128','2013-12-15','11:20:00',1.93),('15128','2013-12-15','11:25:00',1.97),('15128','2013-12-15','11:30:00',2.01),('15128','2013-12-15','11:35:00',2.06),('15128','2013-12-15','11:40:00',2.09),('15128','2013-12-15','11:45:00',2.12),('15128','2013-12-15','11:50:00',2.14),('15128','2013-12-15','11:55:00',2.15),('15128','2013-12-15','12:00:00',2.17),('15128','2013-12-15','12:05:00',2.18),('15128','2013-12-15','12:10:00',2.2),('15128','2013-12-15','12:15:00',2.22),('15128','2013-12-15','12:25:00',2.23),('15128','2013-12-15','12:30:00',2.2),('15128','2013-12-15','12:35:00',2.22),('15128','2013-12-15','12:40:00',2.22),('15128','2013-12-15','12:45:00',2.23),('15128','2013-12-15','12:50:00',2.19),('15128','2013-12-15','12:55:00',2.2),('15128','2013-12-15','13:00:00',2.24),('15128','2013-12-15','13:05:00',2.21),('15128','2013-12-15','13:10:00',2.2),('15128','2013-12-15','13:15:00',2.14),('15128','2013-12-15','13:20:00',2.16),('15128','2013-12-15','13:25:00',2.12),('15128','2013-12-15','13:30:00',2.11),('15128','2013-12-15','13:35:00',2.08),('15128','2013-12-15','13:40:00',2.06),('15128','2013-12-15','13:45:00',2.04),('15128','2013-12-15','13:50:00',2.03),('15128','2013-12-15','13:55:00',1.98),('15128','2013-12-15','14:00:00',1.95),('15128','2013-12-15','14:05:00',1.9),('15128','2013-12-15','14:10:00',1.87),('15128','2013-12-15','14:15:00',1.82),('15128','2013-12-15','14:20:00',1.76),('15128','2013-12-15','14:25:00',1.7),('15128','2013-12-15','14:30:00',1.59),('15128','2013-12-15','14:35:00',1.54),('15128','2013-12-15','14:40:00',1.51),('15128','2013-12-15','14:45:00',1.42),('15128','2013-12-15','14:50:00',1.36),('15128','2013-12-15','14:55:00',1.32),('15128','2013-12-15','15:00:00',1.25),('15128','2013-12-15','15:05:00',1.14),('15128','2013-12-15','15:10:00',1.06),('15128','2013-12-14','10:25:00',1.16),('15128','2013-12-14','10:30:00',1.05),('15128','2013-12-14','11:15:00',1.07),('15128','2013-12-14','11:20:00',1.01),('15128','2013-12-14','11:25:00',1.02),('15128','2013-12-14','11:30:00',1.04),('15128','2013-12-14','11:55:00',1.03),('15128','2013-12-14','12:00:00',1.04),('15128','2013-12-13','09:55:00',1.01),('15128','2013-12-13','10:00:00',1.08),('15128','2013-12-13','10:05:00',1.13),('15128','2013-12-13','10:10:00',1.2),('15128','2013-12-13','10:15:00',1.26),('15128','2013-12-13','10:20:00',1.28),('15128','2013-12-13','10:25:00',1.31),('15128','2013-12-13','10:30:00',1.33),('15128','2013-12-13','10:35:00',1.38),('15128','2013-12-13','10:40:00',1.41),('15128','2013-12-13','10:45:00',1.47),('15128','2013-12-13','10:50:00',1.51),('15128','2013-12-13','10:55:00',1.55),('15128','2013-12-13','11:00:00',1.57),('15128','2013-12-13','11:05:00',1.61),('15128','2013-12-13','11:10:00',1.63),('15128','2013-12-13','11:15:00',1.76),('15128','2013-12-13','11:20:00',1.8),('15128','2013-12-13','11:25:00',1.84),('15128','2013-12-13','11:30:00',1.87),('15128','2013-12-13','11:35:00',1.9),('15128','2013-12-13','11:40:00',1.94),('15128','2013-12-13','11:45:00',2),('15128','2013-12-13','11:50:00',1.99),('15128','2013-12-13','11:55:00',2.01),('15128','2013-12-13','12:00:00',2.02),('15128','2013-12-13','12:05:00',2.03),('15128','2013-12-13','12:10:00',2.06),('15128','2013-12-13','12:15:00',2.1),('15128','2013-12-13','12:20:00',2.09),('15128','2013-12-13','12:25:00',2.11),('15128','2013-12-13','12:30:00',2.11),('15128','2013-12-13','12:35:00',2.12),('15128','2013-12-13','12:40:00',2.12),('15128','2013-12-13','12:45:00',2.13),('15128','2013-12-13','12:50:00',2.12),('15128','2013-12-13','12:55:00',2.12),('15128','2013-12-13','13:00:00',2.06),('15128','2013-12-13','13:05:00',2.08),('15128','2013-12-13','13:10:00',2.07),('15128','2013-12-13','13:15:00',2.08),('15128','2013-12-13','13:20:00',2.02),('15128','2013-12-13','13:25:00',2.01),('15128','2013-12-13','13:30:00',1.95),('15128','2013-12-13','13:35:00',1.92),('15128','2013-12-13','13:40:00',1.88),('15128','2013-12-13','13:45:00',1.89),('15128','2013-12-13','13:50:00',1.83),('15128','2013-12-13','13:55:00',1.81),('15128','2013-12-13','14:00:00',1.78),('15128','2013-12-13','14:05:00',1.75),('15128','2013-12-13','14:10:00',1.74),('15128','2013-12-13','14:15:00',1.72),('15128','2013-12-13','14:20:00',1.67),('15128','2013-12-13','14:25:00',1.62),('15128','2013-12-13','14:30:00',1.51),('15128','2013-12-13','14:35:00',1.48),('15128','2013-12-13','14:40:00',1.41),('15128','2013-12-13','14:45:00',1.33),('15128','2013-12-13','14:50:00',1.27),('15128','2013-12-13','14:55:00',1.21),('15128','2013-12-13','15:00:00',1.14),('15128','2013-12-13','15:05:00',1.02),('15128','2013-12-12','09:55:00',1.01),('15128','2013-12-12','10:00:00',1.08),('15128','2013-12-12','10:05:00',1.14),('15128','2013-12-12','10:10:00',1.17),('15128','2013-12-12','10:15:00',1.2),('15128','2013-12-12','10:20:00',1.25),('15128','2013-12-12','10:25:00',1.27),('15128','2013-12-12','10:30:00',1.31),('15128','2013-12-12','10:35:00',1.36),('15128','2013-12-12','10:40:00',1.39),('15128','2013-12-12','10:45:00',1.44),('15128','2013-12-12','10:50:00',1.48),('15128','2013-12-12','10:55:00',1.51),('15128','2013-12-12','11:00:00',1.54),('15128','2013-12-12','11:05:00',1.58),('15128','2013-12-12','11:10:00',1.62),('15128','2013-12-12','11:15:00',1.72),('15128','2013-12-12','11:20:00',1.8),('15128','2013-12-12','11:25:00',1.81),('15128','2013-12-12','11:30:00',1.84),('15128','2013-12-12','11:35:00',1.84),('15128','2013-12-12','11:40:00',1.89),('15128','2013-12-12','11:45:00',1.95),('15128','2013-12-12','11:50:00',1.96),('15128','2013-12-12','11:55:00',1.99),('15128','2013-12-12','12:00:00',2),('15128','2013-12-12','12:05:00',1.99),('15128','2013-12-12','12:10:00',1.98),('15128','2013-12-12','12:15:00',2.03),('15128','2013-12-12','12:20:00',2),('15128','2013-12-12','12:25:00',1.82),('15128','2013-12-12','12:30:00',1.91),('15128','2013-12-12','12:35:00',2),('15128','2013-12-12','12:40:00',2.02),('15128','2013-12-12','12:45:00',1.98),('15128','2013-12-12','12:50:00',2),('15128','2013-12-12','12:55:00',2.08),('15128','2013-12-12','13:00:00',2.02),('15128','2013-12-12','13:05:00',2),('15128','2013-12-12','13:10:00',1.98),('15128','2013-12-12','13:15:00',2.04),('15128','2013-12-12','13:20:00',2.03),('15128','2013-12-12','13:25:00',2.05),('15128','2013-12-12','13:30:00',2.03),('15128','2013-12-12','13:35:00',2.01),('15128','2013-12-12','13:40:00',1.97),('15128','2013-12-12','13:45:00',1.93),('15128','2013-12-12','13:50:00',1.87),('15128','2013-12-12','13:55:00',1.86),('15128','2013-12-12','14:00:00',1.79),('15128','2013-12-12','14:05:00',1.76),('15128','2013-12-12','14:10:00',1.7),('15128','2013-12-12','14:15:00',1.7),('15128','2013-12-12','14:20:00',1.6),('15128','2013-12-12','14:25:00',1.56),('15128','2013-12-12','14:30:00',1.47),('15128','2013-12-12','14:35:00',1.47),('15128','2013-12-12','14:40:00',1.4),('15128','2013-12-12','14:45:00',1.33),('15128','2013-12-12','14:50:00',1.26),('15128','2013-12-12','14:55:00',1.17),('15128','2013-12-12','15:00:00',1.11),('15128','2013-12-12','15:05:00',1.02),('15128','2013-12-11','09:55:00',1.01),('15128','2013-12-11','10:00:00',1.08),('15128','2013-12-11','10:05:00',1.13),('15128','2013-12-11','10:10:00',1.18),('15128','2013-12-11','10:15:00',1.23),('15128','2013-12-11','10:20:00',1.25),('15128','2013-12-11','10:25:00',1.3),('15128','2013-12-11','10:30:00',1.36),('15128','2013-12-11','10:35:00',1.39),('15128','2013-12-11','10:40:00',1.41),('15128','2013-12-11','10:45:00',1.43),('15128','2013-12-11','10:50:00',1.49),('15128','2013-12-11','10:55:00',1.53),('15128','2013-12-11','11:00:00',1.58),('15128','2013-12-11','11:05:00',1.62),('15128','2013-12-11','11:10:00',1.69),('15128','2013-12-11','11:15:00',1.78),('15128','2013-12-11','11:20:00',1.82),('15128','2013-12-11','11:25:00',1.86),('15128','2013-12-11','11:30:00',1.92),('15128','2013-12-11','11:35:00',1.95),('15128','2013-12-11','11:40:00',1.96),('15128','2013-12-11','11:45:00',2),('15128','2013-12-11','11:50:00',2.02),('15128','2013-12-11','11:55:00',2.05),('15128','2013-12-11','12:00:00',2.07),('15128','2013-12-11','12:05:00',2.08),('15128','2013-12-11','12:10:00',2.09),('15128','2013-12-11','12:15:00',2.1),('15128','2013-12-11','12:20:00',2.13),('15128','2013-12-11','12:25:00',2.15),('15128','2013-12-11','12:30:00',2.15),('15128','2013-12-11','12:35:00',2.17),('15128','2013-12-11','12:40:00',2.17),('15128','2013-12-11','12:45:00',2.15),('15128','2013-12-11','12:50:00',2.15),('15128','2013-12-11','12:55:00',2.14),('15128','2013-12-11','13:00:00',2.12),('15128','2013-12-11','13:05:00',2.13),('15128','2013-12-11','13:10:00',2.1),('15128','2013-12-11','13:15:00',2.09),('15128','2013-12-11','13:20:00',2.06),('15128','2013-12-11','13:25:00',2.05),('15128','2013-12-11','13:30:00',1.98),('15128','2013-12-11','13:35:00',1.98),('15128','2013-12-11','13:40:00',1.93),('15128','2013-12-11','13:45:00',1.91),('15128','2013-12-11','13:50:00',1.89),('15128','2013-12-11','13:55:00',1.86),('15128','2013-12-11','14:00:00',1.8),('15128','2013-12-11','14:05:00',1.79),('15128','2013-12-11','14:10:00',1.75),('15128','2013-12-11','14:15:00',1.7),('15128','2013-12-11','14:20:00',1.64),('15128','2013-12-11','14:25:00',1.57),('15128','2013-12-11','14:30:00',1.47),('15128','2013-12-11','14:35:00',1.46),('15128','2013-12-11','14:40:00',1.39),('15128','2013-12-11','14:45:00',1.31),('15128','2013-12-11','14:50:00',1.19),('15128','2013-12-11','14:55:00',1.17),('15128','2013-12-11','15:00:00',1.09),('15128','2013-12-10','09:55:00',1.04),('15128','2013-12-10','10:00:00',1.12),('15128','2013-12-10','10:05:00',1.18),('15128','2013-12-10','10:10:00',1.23),('15128','2013-12-10','10:15:00',1.27),('15128','2013-12-10','10:20:00',1.32),('15128','2013-12-10','10:25:00',1.35),('15128','2013-12-10','10:30:00',1.41),('15128','2013-12-10','10:35:00',1.45),('15128','2013-12-10','10:40:00',1.49),('15128','2013-12-10','10:45:00',1.51),('15128','2013-12-10','10:50:00',1.53),('15128','2013-12-10','10:55:00',1.54),('15128','2013-12-10','11:00:00',1.6),('15128','2013-12-10','11:05:00',1.65),('15128','2013-12-10','11:10:00',1.74),('15128','2013-12-10','11:15:00',1.85),('15128','2013-12-10','11:20:00',1.9),('15128','2013-12-10','11:25:00',1.92),('15128','2013-12-10','11:30:00',1.95),('15128','2013-12-10','11:35:00',2),('15128','2013-12-10','11:40:00',2.05),('15128','2013-12-10','11:45:00',2.09),('15128','2013-12-10','11:50:00',2.13),('15128','2013-12-10','11:55:00',2.15),('15128','2013-12-10','12:00:00',2.18),('15128','2013-12-10','12:05:00',2.19),('15128','2013-12-10','12:10:00',2.17),('15128','2013-12-10','12:15:00',2.19),('15128','2013-12-10','12:20:00',2.22),('15128','2013-12-10','12:25:00',2.23),('15128','2013-12-10','12:30:00',2.23),('15128','2013-12-10','12:35:00',2.23),('15128','2013-12-10','12:40:00',2.2),('15128','2013-12-10','12:45:00',2.22),('15128','2013-12-10','12:50:00',2.22),('15128','2013-12-10','12:55:00',2.22),('15128','2013-12-10','13:00:00',2.19),('15128','2013-12-10','13:05:00',2.19),('15128','2013-12-10','13:10:00',2.19),('15128','2013-12-10','13:15:00',2.17),('15128','2013-12-10','13:20:00',2.14),('15128','2013-12-10','13:25:00',2.12),('15128','2013-12-10','13:30:00',2.1),('15128','2013-12-10','13:35:00',2.05),('15128','2013-12-10','13:40:00',1.99),('15128','2013-12-10','13:45:00',1.99),('15128','2013-12-10','13:50:00',1.97),('15128','2013-12-10','13:55:00',1.95),('15128','2013-12-10','14:00:00',1.91),('15128','2013-12-10','14:05:00',1.88),('15128','2013-12-10','14:10:00',1.86),('15128','2013-12-10','14:15:00',1.79),('15128','2013-12-10','14:20:00',1.73),('15128','2013-12-10','14:25:00',1.69),('15128','2013-12-10','14:30:00',1.6),('15128','2013-12-10','14:35:00',1.55),('15128','2013-12-10','14:40:00',1.51),('15128','2013-12-10','14:45:00',1.42),('15128','2013-12-10','14:50:00',1.3),('15128','2013-12-10','14:55:00',1.25),('15128','2013-12-10','15:00:00',1.16),('15128','2013-12-10','15:05:00',1.05),('15128','2013-12-09','09:55:00',1.07),('15128','2013-12-09','10:00:00',1.13),('15128','2013-12-09','10:05:00',1.19),('15128','2013-12-09','10:10:00',1.25),('15128','2013-12-09','10:15:00',1.27),('15128','2013-12-09','10:20:00',1.31),('15128','2013-12-09','10:25:00',1.35),('15128','2013-12-09','10:30:00',1.41),('15128','2013-12-09','10:35:00',1.47),('15128','2013-12-09','10:40:00',1.5),('15128','2013-12-09','10:45:00',1.53),('15128','2013-12-09','10:50:00',1.58),('15128','2013-12-09','10:55:00',1.6),('15128','2013-12-09','11:00:00',1.67),('15128','2013-12-09','11:05:00',1.71),('15128','2013-12-09','11:10:00',1.82),('15128','2013-12-09','11:15:00',1.91),('15128','2013-12-09','11:20:00',1.95),('15128','2013-12-09','11:25:00',1.99),('15128','2013-12-09','11:30:00',2.01),('15128','2013-12-09','11:35:00',2.04),('15128','2013-12-09','11:40:00',2.08),('15128','2013-12-09','11:45:00',2.12),('15128','2013-12-09','11:50:00',2.13),('15128','2013-12-09','11:55:00',2.15),('15128','2013-12-09','12:00:00',2.16),('15128','2013-12-09','12:05:00',2.18),('15128','2013-12-09','12:10:00',2.17),('15128','2013-12-09','12:15:00',2.18),('15128','2013-12-09','12:20:00',2.21),('15128','2013-12-09','12:25:00',2.22),('15128','2013-12-09','12:30:00',2.24),('15128','2013-12-09','12:35:00',2.26),('15128','2013-12-09','12:40:00',2.25),('15128','2013-12-09','12:45:00',2.24),('15128','2013-12-09','12:50:00',2.22),('15128','2013-12-09','12:55:00',2.24),('15128','2013-12-09','13:00:00',2.22),('15128','2013-12-09','13:05:00',2.2),('15128','2013-12-09','13:10:00',2.18),('15128','2013-12-09','13:15:00',2.16),('15128','2013-12-09','13:20:00',2.14),('15128','2013-12-09','13:25:00',2.1),('15128','2013-12-09','13:30:00',2.06),('15128','2013-12-09','13:35:00',2.04),('15128','2013-12-09','13:40:00',2.03),('15128','2013-12-09','13:45:00',2.02),('15128','2013-12-09','13:50:00',1.97),('15128','2013-12-09','13:55:00',1.93),('15128','2013-12-09','14:00:00',1.91),('15128','2013-12-09','14:05:00',1.87),('15128','2013-12-09','14:10:00',1.82),('15128','2013-12-09','14:15:00',1.79),('15128','2013-12-09','14:20:00',1.74),('15128','2013-12-09','14:25:00',1.71),('15128','2013-12-09','14:30:00',1.64),('15128','2013-12-09','14:35:00',1.56),('15128','2013-12-09','14:40:00',1.41),('15128','2013-12-09','14:45:00',1.4),('15128','2013-12-09','14:50:00',1.29),('15128','2013-12-09','14:55:00',1.26),('15128','2013-12-09','15:00:00',1.19),('15128','2013-12-09','15:05:00',1.09),('15128','2013-12-08','09:40:00',1.02),('15128','2013-12-08','09:45:00',1.2),('15128','2013-12-08','09:50:00',1.55),('15128','2013-12-08','09:55:00',1.74),('15128','2013-12-08','10:00:00',1.69),('15128','2013-12-08','12:25:00',1.11),('15128','2013-12-08','12:30:00',1.21),('15128','2013-12-08','12:40:00',1.17),('15128','2013-12-08','12:45:00',1.83),('15128','2013-12-08','12:50:00',2.39),('15128','2013-12-08','12:55:00',2.27),('15128','2013-12-08','13:00:00',2.13),('15128','2013-12-08','13:05:00',2.11),('15128','2013-12-08','13:10:00',1.74),('15128','2013-12-08','13:15:00',1.97),('15128','2013-12-08','13:20:00',2.63),('15128','2013-12-08','13:25:00',2.24),('15128','2013-12-08','13:30:00',1.25),('15128','2013-12-08','13:35:00',1.48),('15128','2013-12-08','13:40:00',1.4),('15128','2013-12-08','13:45:00',1.26),('15128','2013-12-08','13:50:00',1.12),('15128','2013-12-07','11:25:00',1.05),('15128','2013-12-07','11:30:00',1),('15128','2013-12-07','12:30:00',1.15),('15128','2013-12-07','12:35:00',1.07),('15128','2013-12-07','12:40:00',1.25),('15128','2013-12-07','12:45:00',1.17),('15128','2013-12-07','12:50:00',1.3),('15128','2013-12-07','12:55:00',1.04),('15128','2013-12-07','15:00:00',1.22),('15128','2013-12-07','15:05:00',1.05),('15128','2014-04-20','08:50:00',1.07),('15128','2014-04-20','08:55:00',1.47),('15128','2014-04-20','09:00:00',1.38),('15128','2014-04-20','09:05:00',1.33),('15128','2014-04-20','09:10:00',1.17),('15128','2014-04-20','09:15:00',1.05),('15128','2014-04-20','09:25:00',1.19),('15128','2014-04-20','09:30:00',2.31),('15128','2014-04-20','09:35:00',2.31),('15128','2014-04-20','09:40:00',1.38),('15128','2014-04-20','09:50:00',1.06),('15128','2014-04-20','09:55:00',1.25),('15128','2014-04-20','10:00:00',1.34),('15128','2014-04-20','10:05:00',1.45),('15128','2014-04-20','10:10:00',1.77),('15128','2014-04-20','10:15:00',2.1),('15128','2014-04-20','10:20:00',2.17),('15128','2014-04-20','10:25:00',2.55),('15128','2014-04-20','10:30:00',2.48),('15128','2014-04-20','10:35:00',2.54),('15128','2014-04-20','10:40:00',2.65),('15128','2014-04-20','10:45:00',2.63),('15128','2014-04-20','10:50:00',2.68),('15128','2014-04-20','10:55:00',2.71),('15128','2014-04-20','11:00:00',2.77),('15128','2014-04-20','11:05:00',2.83),('15128','2014-04-20','11:10:00',2.91),('15128','2014-04-20','11:15:00',2.99),('15128','2014-04-20','11:20:00',3.04),('15128','2014-04-20','11:25:00',3.05),('15128','2014-04-20','11:30:00',3.09),('15128','2014-04-20','11:35:00',3.14),('15128','2014-04-20','11:40:00',3.24),('15128','2014-04-20','11:45:00',3.34),('15128','2014-04-20','11:50:00',3.49),('15128','2014-04-20','11:55:00',3.57),('15128','2014-04-20','12:00:00',3.62),('15128','2014-04-20','12:05:00',3.67),('15128','2014-04-20','12:10:00',3.71),('15128','2014-04-20','12:15:00',3.75),('15128','2014-04-20','12:20:00',3.78),('15128','2014-04-20','12:25:00',3.81),('15128','2014-04-20','12:30:00',3.84),('15128','2014-04-20','12:35:00',3.84),('15128','2014-04-20','12:40:00',3.86),('15128','2014-04-20','12:45:00',3.88),('15128','2014-04-20','12:50:00',3.92),('15128','2014-04-20','12:55:00',3.93),('15128','2014-04-20','13:00:00',3.96),('15128','2014-04-20','13:05:00',3.97),('15128','2014-04-20','13:10:00',3.98),('15128','2014-04-20','13:15:00',3.98),('15128','2014-04-20','13:20:00',3.97),('15128','2014-04-20','13:25:00',3.99),('15128','2014-04-20','13:30:00',4.02),('15128','2014-04-20','13:35:00',4.05),('15128','2014-04-20','13:40:00',4.06),('15128','2014-04-20','13:45:00',4.08),('15128','2014-04-20','13:50:00',4.08),('15128','2014-04-20','13:55:00',4.07),('15128','2014-04-20','14:00:00',4.08),('15128','2014-04-20','14:05:00',4.09),('15128','2014-04-20','14:10:00',4.09),('15128','2014-04-20','14:15:00',4.09),('15128','2014-04-20','14:20:00',4.09),('15128','2014-04-20','14:25:00',4.07),('15128','2014-04-20','14:30:00',4.05),('15128','2014-04-20','14:35:00',4.05),('15128','2014-04-20','14:40:00',4.04),('15128','2014-04-20','14:45:00',4.03),('15128','2014-04-20','14:50:00',3.99),('15128','2014-04-20','14:55:00',3.96),('15128','2014-04-20','15:00:00',3.91),('15128','2014-04-20','15:05:00',3.89),('15128','2014-04-20','15:10:00',3.87),('15128','2014-04-20','15:15:00',3.85),('15128','2014-04-20','15:20:00',3.82),('15128','2014-04-20','15:25:00',3.75),('15128','2014-04-20','15:30:00',3.74),('15128','2014-04-20','15:35:00',3.67),('15128','2014-04-20','15:40:00',3.63),('15128','2014-04-20','15:45:00',3.6),('15128','2014-04-20','15:50:00',3.55),('15128','2014-04-20','15:55:00',3.52),('15128','2014-04-20','16:00:00',3.46),('15128','2014-04-20','16:05:00',2.05),('15128','2014-04-20','16:10:00',3.53),('15128','2014-04-20','16:15:00',3.4),('15128','2014-04-20','16:20:00',3.34),('15128','2014-04-20','16:25:00',3.27),('15128','2014-04-20','16:30:00',3.18),('15128','2014-04-20','16:35:00',3.13),('15128','2014-04-20','16:40:00',3.09),('15128','2014-04-20','16:45:00',3.03),('15128','2014-04-20','16:50:00',2.97),('15128','2014-04-20','16:55:00',2.91),('15128','2014-04-20','17:00:00',2.85),('15128','2014-04-20','17:05:00',2.79),('15128','2014-04-20','17:10:00',2.71),('15128','2014-04-20','17:15:00',2.6),('15128','2014-04-20','17:20:00',2.53),('15128','2014-04-20','17:25:00',2.44),('15128','2014-04-20','17:30:00',2.36),('15128','2014-04-20','17:35:00',2.26),('15128','2014-04-20','17:40:00',2.15),('15128','2014-04-20','17:45:00',2.07),('15128','2014-04-20','17:50:00',1.91),('15128','2014-04-20','17:55:00',1.83),('15128','2014-04-20','18:00:00',1.74),('15128','2014-04-20','18:05:00',1.66),('15128','2014-04-20','18:10:00',1.56),('15128','2014-04-20','18:15:00',1.5),('15128','2014-04-20','18:20:00',1.41),('15128','2014-04-20','18:25:00',1.32),('15128','2014-04-20','18:30:00',1.23),('15128','2014-04-20','18:35:00',1.14),('15128','2014-04-20','18:40:00',1.02),('15128','2013-12-06','09:50:00',1.06),('15128','2013-12-06','09:55:00',1.1),('15128','2013-12-06','10:00:00',1.18),('15128','2013-12-06','10:05:00',1.25),('15128','2013-12-06','10:10:00',1.29),('15128','2013-12-06','10:15:00',1.33),('15128','2013-12-06','10:20:00',1.36),('15128','2013-12-06','10:25:00',1.39),('15128','2013-12-06','10:30:00',1.45),('15128','2013-12-06','10:35:00',1.51),('15128','2013-12-06','10:40:00',1.54),('15128','2013-12-06','10:45:00',1.59),('15128','2013-12-06','10:50:00',1.62),('15128','2013-12-06','10:55:00',1.62),('15128','2013-12-06','11:00:00',1.65),('15128','2013-12-06','11:05:00',1.72),('15128','2013-12-06','11:10:00',1.82),('15128','2013-12-06','11:15:00',1.88),('15128','2013-12-06','11:20:00',1.9),('15128','2013-12-06','11:25:00',1.93),('15128','2013-12-06','11:30:00',1.98),('15128','2013-12-06','11:35:00',2.03),('15128','2013-12-06','11:40:00',2.07),('15128','2013-12-06','11:45:00',2.09),('15128','2013-12-06','11:50:00',2.1),('15128','2013-12-06','11:55:00',2.11),('15128','2013-12-06','12:00:00',2.14),('15128','2013-12-06','12:05:00',2.15),('15128','2013-12-06','12:10:00',2.13),('15128','2013-12-06','12:15:00',2.13),('15128','2013-12-06','12:20:00',2.11),('15128','2013-12-06','12:25:00',2.11),('15128','2013-12-06','12:30:00',2.12),('15128','2013-12-06','12:35:00',2.12),('15128','2013-12-06','12:40:00',2.11),('15128','2013-12-06','12:45:00',2.13),('15128','2013-12-06','12:50:00',2.09),('15128','2013-12-06','12:55:00',2.08),('15128','2013-12-06','13:00:00',2.07),('15128','2013-12-06','13:05:00',2.07),('15128','2013-12-06','13:10:00',2.07),('15128','2013-12-06','13:15:00',2.08),('15128','2013-12-06','13:20:00',2.04),('15128','2013-12-06','13:25:00',2.02),('15128','2013-12-06','13:30:00',1.99),('15128','2013-12-06','13:35:00',1.96),('15128','2013-12-06','13:40:00',1.91),('15128','2013-12-06','13:45:00',1.88),('15128','2013-12-06','13:50:00',1.84),('15128','2013-12-06','13:55:00',1.81),('15128','2013-12-06','14:00:00',1.76),('15128','2013-12-06','14:05:00',1.75),('15128','2013-12-06','14:10:00',1.74),('15128','2013-12-06','14:15:00',1.69),('15128','2013-12-06','14:20:00',1.63),('15128','2013-12-06','14:25:00',1.6),('15128','2013-12-06','14:30:00',1.57),('15128','2013-12-06','14:35:00',1.47),('15128','2013-12-06','14:40:00',1.43),('15128','2013-12-06','14:45:00',1.36),('15128','2013-12-06','14:50:00',1.29),('15128','2013-12-06','14:55:00',1.21),('15128','2013-12-06','15:00:00',1.13),('15128','2013-12-05','10:15:00',1.14),('15128','2013-12-05','10:20:00',1.01),('15128','2013-12-05','10:40:00',1.26),('15128','2013-12-05','10:45:00',1.11),('15128','2013-12-05','11:00:00',1.01),('15128','2013-12-05','11:10:00',1.02),('15128','2013-12-05','11:15:00',1.08),('15128','2013-12-05','11:20:00',1.33),('15128','2013-12-05','11:25:00',1.44),('15128','2013-12-05','11:30:00',1.58),('15128','2013-12-05','11:35:00',2.04),('15128','2013-12-05','11:40:00',2.27),('15128','2013-12-05','11:45:00',1.94),('15128','2013-12-05','11:50:00',1.62),('15128','2013-12-05','11:55:00',1.85),('15128','2013-12-05','12:00:00',1.78),('15128','2013-12-05','12:05:00',1.96),('15128','2013-12-05','12:10:00',1.98),('15128','2013-12-05','12:15:00',2.64),('15128','2013-12-05','12:20:00',1.61),('15128','2013-12-05','12:25:00',1.25),('15128','2013-12-05','12:30:00',1.24),('15128','2013-12-05','12:35:00',1.09),('15128','2013-12-05','12:40:00',1.02),('15128','2013-12-05','13:25:00',1.01),('15128','2013-12-05','13:35:00',1.03),('15128','2013-12-05','13:40:00',1.06),('15128','2013-12-05','14:45:00',1.17),('15128','2013-12-05','14:55:00',1.39),('15128','2013-12-05','15:00:00',1.28),('15128','2013-12-05','15:05:00',1.15),('15128','2013-12-05','15:10:00',1.18),('15128','2013-12-05','15:15:00',1.27),('15128','2013-12-05','15:20:00',1.08),('15128','2013-12-04','09:45:00',1.02),('15128','2013-12-04','09:50:00',1.08),('15128','2013-12-04','09:55:00',1.13),('15128','2013-12-04','10:00:00',1.18),('15128','2013-12-04','10:05:00',1.24),('15128','2013-12-04','10:10:00',1.3),('15128','2013-12-04','10:15:00',1.35),('15128','2013-12-04','10:20:00',1.38),('15128','2013-12-04','10:25:00',1.41),('15128','2013-12-04','10:30:00',1.46),('15128','2013-12-04','10:35:00',1.51),('15128','2013-12-04','10:40:00',1.55),('15128','2013-12-04','10:45:00',1.6),('15128','2013-12-04','10:50:00',1.64),('15128','2013-12-04','10:55:00',1.69),('15128','2013-12-04','11:00:00',1.7),('15128','2013-12-04','11:05:00',1.76),('15128','2013-12-04','11:10:00',1.87),('15128','2013-12-04','11:15:00',1.95),('15128','2013-12-04','11:20:00',1.96),('15128','2013-12-04','11:25:00',2),('15128','2013-12-04','11:30:00',2.02),('15128','2013-12-04','11:35:00',2.04),('15128','2013-12-04','11:40:00',2.08),('15128','2013-12-04','11:45:00',2.11),('15128','2013-12-04','11:50:00',2.1),('15128','2013-12-04','11:55:00',2.11),('15128','2013-12-04','12:00:00',2.18),('15128','2013-12-04','12:05:00',2.22),('15128','2013-12-04','12:10:00',2.24),('15128','2013-12-04','12:15:00',2.27),('15128','2013-12-04','12:20:00',2.25),('15128','2013-12-04','12:25:00',2.24),('15128','2013-12-04','12:30:00',2.27),('15128','2013-12-04','12:35:00',2.31),('15128','2013-12-04','12:40:00',2.29),('15128','2013-12-04','12:45:00',2.24),('15128','2013-12-04','12:50:00',2.28),('15128','2013-12-04','12:55:00',2.28),('15128','2013-12-04','13:00:00',2.28),('15128','2013-12-04','13:05:00',2.24),('15128','2013-12-04','13:10:00',2.18),('15128','2013-12-04','13:15:00',2.2),('15128','2013-12-04','13:20:00',2.12),('15128','2013-12-04','13:25:00',2.06),('15128','2013-12-04','13:30:00',2.09),('15128','2013-12-04','13:35:00',2.07),('15128','2013-12-04','13:40:00',2),('15128','2013-12-04','13:45:00',2.03),('15128','2013-12-04','13:50:00',1.94),('15128','2013-12-04','13:55:00',1.92),('15128','2013-12-04','14:00:00',1.97),('15128','2013-12-04','14:05:00',1.9),('15128','2013-12-04','14:10:00',1.76),('15128','2013-12-04','14:15:00',1.64),('15128','2013-12-04','14:20:00',1.71),('15128','2013-12-04','14:25:00',1.72),('15128','2013-12-04','14:30:00',1.63),('15128','2013-12-04','14:35:00',1.57),('15128','2013-12-04','14:40:00',1.48),('15128','2013-12-04','14:45:00',1.4),('15128','2013-12-04','14:50:00',1.35),('15128','2013-12-04','14:55:00',1.21),('15128','2013-12-04','15:00:00',1.2),('15128','2013-12-04','15:05:00',1.06),('15128','2013-12-03','09:40:00',1.02),('15128','2013-12-03','09:45:00',1.09),('15128','2013-12-03','09:50:00',1.16),('15128','2013-12-03','09:55:00',1.22),('15128','2013-12-03','10:00:00',1.29),('15128','2013-12-03','10:05:00',1.33),('15128','2013-12-03','10:10:00',1.39),('15128','2013-12-03','10:15:00',1.43),('15128','2013-12-03','10:20:00',1.46),('15128','2013-12-03','10:25:00',1.51),('15128','2013-12-03','10:30:00',1.56),('15128','2013-12-03','10:35:00',1.58),('15128','2013-12-03','10:40:00',1.64),('15128','2013-12-03','10:45:00',1.68),('15128','2013-12-03','10:50:00',1.73),('15128','2013-12-03','10:55:00',1.76),('15128','2013-12-03','11:00:00',1.78),('15128','2013-12-03','11:05:00',1.89),('15128','2013-12-03','11:10:00',2.02),('15128','2013-12-03','11:15:00',2.06),('15128','2013-12-03','11:20:00',2.09),('15128','2013-12-03','11:25:00',2.12),('15128','2013-12-03','11:30:00',2.16),('15128','2013-12-03','11:35:00',2.21),('15128','2013-12-03','11:40:00',2.26),('15128','2013-12-03','11:45:00',2.29),('15128','2013-12-03','11:50:00',2.32),('15128','2013-12-03','11:55:00',2.34),('15128','2013-12-03','12:00:00',2.37),('15128','2013-12-03','12:05:00',2.4),('15128','2013-12-03','12:10:00',2.39),('15128','2013-12-03','12:15:00',2.39),('15128','2013-12-03','12:20:00',2.38),('15128','2013-12-03','12:25:00',2.4),('15128','2013-12-03','12:30:00',2.41),('15128','2013-12-03','12:35:00',2.41),('15128','2013-12-03','12:40:00',2.4),('15128','2013-12-03','12:45:00',2.4),('15128','2013-12-03','12:50:00',2.37),('15128','2013-12-03','12:55:00',2.37),('15128','2013-12-03','13:00:00',2.35),('15128','2013-12-03','13:05:00',2.35),('15128','2013-12-03','13:10:00',2.35),('15128','2013-12-03','13:15:00',2.33),('15128','2013-12-03','13:20:00',2.32),('15128','2013-12-03','13:25:00',2.29),('15128','2013-12-03','13:30:00',2.29),('15128','2013-12-03','13:35:00',2.25),('15128','2013-12-03','13:40:00',2.22),('15128','2013-12-03','13:45:00',2.19),('15128','2013-12-03','13:50:00',2.16),('15128','2013-12-03','13:55:00',2.11),('15128','2013-12-03','14:00:00',2.08),('15128','2013-12-03','14:05:00',2.03),('15128','2013-12-03','14:10:00',1.98),('15128','2013-12-03','14:15:00',1.95),('15128','2013-12-03','14:20:00',1.91),('15128','2013-12-03','14:25:00',1.85),('15128','2013-12-03','14:30:00',1.8),('15128','2013-12-03','14:35:00',1.75),('15128','2013-12-03','14:40:00',1.67),('15128','2013-12-03','14:45:00',1.62),('15128','2013-12-03','14:50:00',1.55),('15128','2013-12-03','14:55:00',1.36),('15128','2013-12-03','15:00:00',1.35),('15128','2013-12-03','15:05:00',1.25),('15128','2013-12-03','15:10:00',1.15),('15128','2013-12-03','15:15:00',1.06),('15128','2013-12-02','09:55:00',1.19),('15128','2013-12-02','10:00:00',1.29),('15128','2013-12-02','10:05:00',1.33),('15128','2013-12-02','10:10:00',1.39),('15128','2013-12-02','10:15:00',1.43),('15128','2013-12-02','10:20:00',1.47),('15128','2013-12-02','10:25:00',1.51),('15128','2013-12-02','10:30:00',1.57),('15128','2013-12-02','10:35:00',1.6),('15128','2013-12-02','10:40:00',1.64),('15128','2013-12-02','10:45:00',1.68),('15128','2013-12-02','10:50:00',1.72),('15128','2013-12-02','10:55:00',1.77),('15128','2013-12-02','11:00:00',1.84),('15128','2013-12-02','11:05:00',1.92),('15128','2013-12-02','11:10:00',2.06),('15128','2013-12-02','11:15:00',2.12),('15128','2013-12-02','11:20:00',2.19),('15128','2013-12-02','11:25:00',2.23),('15128','2013-12-02','11:30:00',2.27),('15128','2013-12-02','11:35:00',2.31),('15128','2013-12-02','11:40:00',2.34),('15128','2013-12-02','11:45:00',2.39),('15128','2013-12-02','11:50:00',2.43),('15128','2013-12-02','11:55:00',2.45),('15128','2013-12-02','12:00:00',2.48),('15128','2013-12-02','12:05:00',2.52),('15128','2013-12-02','12:10:00',2.58),('15128','2013-12-02','12:15:00',2.61),('15128','2013-12-02','12:20:00',2.64),('15128','2013-12-02','12:25:00',2.69),('15128','2013-12-02','12:30:00',2.74),('15128','2013-12-02','12:35:00',2.79),('15128','2013-12-02','12:40:00',2.83),('15128','2013-12-02','12:45:00',2.88),('15128','2013-12-02','12:50:00',2.94),('15128','2013-12-02','12:55:00',3.04),('15128','2013-12-02','13:00:00',3.13),('15128','2013-12-02','13:05:00',3.13),('15128','2013-12-02','13:10:00',3.11),('15128','2013-12-02','13:15:00',2.95),('15128','2013-12-02','13:20:00',2.39),('15128','2013-12-02','13:25:00',1.67),('15128','2013-12-02','13:30:00',1.44),('15128','2013-12-02','13:35:00',1.61),('15128','2013-12-02','13:40:00',1.34),('15128','2013-12-02','13:45:00',1.1),('15128','2013-12-02','13:50:00',1.02),('15128','2013-12-02','14:00:00',1.01),('15128','2013-12-02','14:05:00',1.38),('15128','2013-12-02','14:10:00',1.74),('15128','2013-12-02','14:15:00',1.78),('15128','2013-12-02','14:20:00',1.8),('15128','2013-12-02','14:25:00',1.81),('15128','2013-12-02','14:30:00',1.8),('15128','2013-12-02','14:35:00',1.74),('15128','2013-12-02','14:40:00',1.32),('15128','2013-12-02','14:45:00',1.2),('15128','2013-12-02','14:50:00',1.46),('15128','2013-12-02','14:55:00',1.35),('15128','2013-12-02','15:00:00',1.3),('15128','2013-12-02','15:05:00',1.19),('15128','2013-12-02','15:10:00',1.09),('15128','2013-12-02','15:15:00',1.01),('15128','2013-11-30','11:35:00',1.42),('15128','2013-11-30','11:40:00',2.17),('15128','2013-11-30','11:45:00',1.9),('15128','2013-11-30','11:50:00',1.69),('15128','2013-11-30','11:55:00',1.81),('15128','2013-11-30','12:00:00',2.29),('15128','2013-11-30','12:05:00',1.93),('15128','2013-11-30','12:10:00',2.12),('15128','2013-11-30','12:15:00',2.42),('15128','2013-11-30','12:20:00',1.43),('15128','2013-11-30','12:25:00',1.32),('15128','2013-11-30','12:50:00',2.11),('15128','2013-11-30','12:55:00',1.1),('15128','2013-11-30','13:00:00',1.08),('15128','2013-11-29','09:25:00',1.01),('15128','2013-11-29','09:30:00',1.23),('15128','2013-11-29','09:35:00',1.16),('15128','2013-11-29','09:40:00',1.05),('15128','2013-11-29','10:20:00',1.03),('15128','2013-11-29','10:25:00',1.01),('15128','2013-11-29','10:45:00',1.04),('15128','2013-11-29','10:50:00',1.02),('15128','2013-11-29','10:55:00',1.22),('15128','2013-11-29','11:00:00',1.19),('15128','2013-11-29','11:05:00',1.13),('15128','2013-11-29','11:10:00',1.2),('15128','2013-11-29','11:15:00',1.26),('15128','2013-11-29','11:20:00',1.34),('15128','2013-11-29','11:25:00',1.25),('15128','2013-11-29','11:30:00',1.29),('15128','2013-11-29','11:35:00',1.18),('15128','2013-11-29','11:50:00',1.01),('15128','2013-11-28','09:40:00',1.02),('15128','2013-11-28','09:45:00',1.11),('15128','2013-11-28','09:50:00',1.19),('15128','2013-11-28','09:55:00',1.26),('15128','2013-11-28','10:00:00',1.3),('15128','2013-11-28','10:05:00',1.35),('15128','2013-11-28','10:10:00',1.4),('15128','2013-11-28','10:15:00',1.44),('15128','2013-11-28','10:20:00',1.48),('15128','2013-11-28','10:25:00',1.55),('15128','2013-11-28','10:30:00',1.58),('15128','2013-11-28','10:35:00',1.62),('15128','2013-11-28','10:40:00',1.68),('15128','2013-11-28','10:45:00',1.72),('15128','2013-11-28','10:50:00',1.75),('15128','2013-11-28','10:55:00',1.81),('15128','2013-11-28','11:00:00',1.84),('15128','2013-11-28','11:05:00',1.9),('15128','2013-11-28','11:10:00',2.07),('15128','2013-11-28','11:15:00',2.13),('15128','2013-11-28','11:20:00',2.17),('15128','2013-11-28','11:25:00',2.22),('15128','2013-11-28','11:30:00',2.26),('15128','2013-11-28','11:35:00',2.28),('15128','2013-11-28','11:40:00',2.31),('15128','2013-11-28','11:45:00',2.35),('15128','2013-11-28','11:50:00',2.38),('15128','2013-11-28','11:55:00',2.4),('15128','2013-11-28','12:00:00',2.41),('15128','2013-11-28','12:05:00',2.42),('15128','2013-11-28','12:10:00',2.43),('15128','2013-11-28','12:15:00',2.44),('15128','2013-11-28','12:20:00',2.44),('15128','2013-11-28','12:25:00',2.46),('15128','2013-11-28','12:30:00',2.47),('15128','2013-11-28','12:35:00',2.46),('15128','2013-11-28','12:40:00',2.47),('15128','2013-11-28','12:45:00',2.47),('15128','2013-11-28','12:50:00',2.44),('15128','2013-11-28','12:55:00',2.42),('15128','2013-11-28','13:00:00',2.41),('15128','2013-11-28','13:05:00',2.4),('15128','2013-11-28','13:10:00',2.37),('15128','2013-11-28','13:15:00',2.35),('15128','2013-11-28','13:20:00',2.34),('15128','2013-11-28','13:25:00',2.31),('15128','2013-11-28','13:30:00',2.28),('15128','2013-11-28','13:35:00',2.24),('15128','2013-11-28','13:40:00',2.21),('15128','2013-11-28','13:45:00',2.19),('15128','2013-11-28','13:50:00',2.14),('15128','2013-11-28','13:55:00',2.1),('15128','2013-11-28','14:00:00',2.06),('15128','2013-11-28','14:05:00',2.01),('15128','2013-11-28','14:10:00',1.98),('15128','2013-11-28','14:15:00',1.95),('15128','2013-11-28','14:20:00',1.9),('15128','2013-11-28','14:25:00',1.82),('15128','2013-11-28','14:30:00',1.76),('15128','2013-11-28','14:35:00',1.73),('15128','2013-11-28','14:40:00',1.67),('15128','2013-11-28','14:45:00',1.56),('15128','2013-11-28','14:50:00',1.49),('15128','2013-11-28','14:55:00',1.39),('15128','2013-11-28','15:00:00',1.27),('15128','2013-11-28','15:05:00',1.2),('15128','2013-11-28','15:10:00',1.12),('15128','2013-11-28','15:15:00',1.01),('15128','2014-04-19','08:20:00',1.19),('15128','2014-04-19','08:25:00',1.67),('15128','2014-04-19','08:50:00',1.11),('15128','2014-04-19','08:55:00',1.35),('15128','2014-04-19','09:05:00',1.48),('15128','2014-04-19','09:10:00',1.54),('15128','2014-04-19','09:15:00',1.14),('15128','2014-04-19','09:20:00',1.78),('15128','2014-04-19','09:25:00',1.99),('15128','2014-04-19','09:30:00',2),('15128','2014-04-19','09:35:00',2.13),('15128','2014-04-19','09:40:00',2.48),('15128','2014-04-19','09:45:00',2.14),('15128','2014-04-19','09:50:00',1.66),('15128','2014-04-19','09:55:00',1.53),('15128','2014-04-19','10:00:00',1.71),('15128','2014-04-19','10:05:00',1.86),('15128','2014-04-19','10:10:00',2.25),('15128','2014-04-19','10:15:00',1.94),('15128','2014-04-19','10:20:00',1.65),('15128','2014-04-19','10:25:00',2.13),('15128','2014-04-19','10:30:00',1.94),('15128','2014-04-19','10:35:00',2),('15128','2014-04-19','10:40:00',1.91),('15128','2014-04-19','10:45:00',2.22),('15128','2014-04-19','10:50:00',2.31),('15128','2014-04-19','10:55:00',2.91),('15128','2014-04-19','11:00:00',2.71),('15128','2014-04-19','11:05:00',2.68),('15128','2014-04-19','11:10:00',2.7),('15128','2014-04-19','11:15:00',3.72),('15128','2014-04-19','11:20:00',3.56),('15128','2014-04-19','11:25:00',3.37),('15128','2014-04-19','11:30:00',3.37),('15128','2014-04-19','11:35:00',3.36),('15128','2014-04-19','11:40:00',3.44),('15128','2014-04-19','11:45:00',2.95),('15128','2014-04-19','11:50:00',3.61),('15128','2014-04-19','11:55:00',3.78),('15128','2014-04-19','12:00:00',3.8),('15128','2014-04-19','12:05:00',3.86),('15128','2014-04-19','12:10:00',3.88),('15128','2014-04-19','12:15:00',3.9),('15128','2014-04-19','12:20:00',3.93),('15128','2014-04-19','12:25:00',3.93),('15128','2014-04-19','12:30:00',3.93),('15128','2014-04-19','12:35:00',4),('15128','2014-04-19','12:40:00',3.96),('15128','2014-04-19','12:45:00',4),('15128','2014-04-19','12:50:00',4.07),('15128','2014-04-19','12:55:00',4.1),('15128','2014-04-19','13:00:00',4.1),('15128','2014-04-19','13:05:00',3.75),('15128','2014-04-19','13:10:00',2.43),('15128','2014-04-19','13:15:00',4.32),('15128','2014-04-19','13:20:00',4.27),('15128','2014-04-19','13:25:00',4.21),('15128','2014-04-19','13:30:00',4.16),('15128','2014-04-19','13:35:00',4.2),('15128','2014-04-19','13:40:00',4.18),('15128','2014-04-19','13:45:00',4.14),('15128','2014-04-19','13:50:00',4.14),('15128','2014-04-19','13:55:00',4.13),('15128','2014-04-19','14:00:00',4.13),('15128','2014-04-19','14:05:00',4.17),('15128','2014-04-19','14:10:00',3.95),('15128','2014-04-19','14:15:00',4.02),('15128','2014-04-19','14:20:00',3.46),('15128','2014-04-19','14:25:00',2.64),('15128','2014-04-19','14:30:00',2.64),('15128','2014-04-19','14:35:00',2.37),('15128','2014-04-19','14:40:00',2.23),('15128','2014-04-19','14:45:00',2.32),('15128','2014-04-19','14:50:00',2.65),('15128','2014-04-19','14:55:00',2.79),('15128','2014-04-19','15:00:00',4.24),('15128','2014-04-19','15:05:00',4.33),('15128','2014-04-19','15:10:00',4.01),('15128','2014-04-19','15:15:00',3.93),('15128','2014-04-19','15:20:00',3.91),('15128','2014-04-19','15:25:00',3.87),('15128','2014-04-19','15:30:00',3.6),('15128','2014-04-19','15:35:00',3.87),('15128','2014-04-19','15:40:00',3.81),('15128','2014-04-19','15:45:00',3.17),('15128','2014-04-19','15:50:00',3.31),('15128','2014-04-19','15:55:00',3.64),('15128','2014-04-19','16:00:00',3.58),('15128','2014-04-19','16:05:00',3.51),('15128','2014-04-19','16:10:00',3.47),('15128','2014-04-19','16:15:00',3.42),('15128','2014-04-19','16:20:00',3.41),('15128','2014-04-19','16:25:00',3.4),('15128','2014-04-19','16:30:00',3.25),('15128','2014-04-19','16:35:00',3.2),('15128','2014-04-19','16:40:00',3.12),('15128','2014-04-19','16:45:00',2.37),('15128','2014-04-19','16:50:00',3.11),('15128','2014-04-19','16:55:00',2.99),('15128','2014-04-19','17:00:00',2.86),('15128','2014-04-19','17:05:00',2.76),('15128','2014-04-19','17:10:00',2.67),('15128','2014-04-19','17:15:00',2.56),('15128','2014-04-19','17:20:00',2.39),('15128','2014-04-19','17:25:00',2.37),('15128','2014-04-19','17:30:00',2.28),('15128','2014-04-19','17:35:00',2.09),('15128','2014-04-19','17:40:00',1.95),('15128','2014-04-19','17:45:00',1.94),('15128','2014-04-19','17:50:00',1.79),('15128','2014-04-19','17:55:00',1.73),('15128','2014-04-19','18:00:00',1.65),('15128','2014-04-19','18:05:00',1.62),('15128','2014-04-19','18:10:00',1.55),('15128','2014-04-19','18:15:00',1.32),('15128','2014-04-19','18:20:00',1.26),('15128','2014-04-19','18:25:00',1.03),('15128','2014-04-19','18:30:00',1.22),('15128','2014-04-19','18:35:00',1.2),('15128','2014-04-19','18:40:00',1.03),('15128','2013-11-26','09:30:00',1.09),('15128','2013-11-26','09:40:00',1),('15128','2013-11-26','10:05:00',1),('15128','2013-11-26','10:10:00',1.13),('15128','2013-11-26','10:15:00',1.15),('15128','2013-11-26','10:20:00',1.22),('15128','2013-11-26','10:25:00',1.23),('15128','2013-11-26','10:30:00',1.35),('15128','2013-11-26','10:35:00',1.18),('15128','2013-11-26','10:40:00',1.14),('15128','2013-11-26','10:45:00',1.12),('15128','2013-11-26','10:50:00',1.2),('15128','2013-11-26','10:55:00',1.26),('15128','2013-11-26','11:00:00',1.29),('15128','2013-11-26','11:05:00',1.71),('15128','2013-11-26','11:10:00',1.48),('15128','2013-11-26','11:15:00',1.38),('15128','2013-11-26','11:20:00',1.91),('15128','2013-11-26','11:25:00',2.19),('15128','2013-11-26','11:30:00',2.01),('15128','2013-11-26','11:35:00',1.43),('15128','2013-11-26','11:40:00',1.53),('15128','2013-11-26','11:45:00',1.75),('15128','2013-11-26','11:50:00',2.54),('15128','2013-11-26','11:55:00',2.81),('15128','2013-11-26','12:00:00',1.51),('15128','2013-11-26','12:05:00',1.76),('15128','2013-11-26','12:10:00',1.78),('15128','2013-11-26','12:15:00',2.35),('15128','2013-11-26','12:20:00',2.17),('15128','2013-11-26','12:25:00',2.04),('15128','2013-11-26','12:30:00',1.91),('15128','2013-11-26','12:35:00',1.78),('15128','2013-11-26','12:40:00',1.69),('15128','2013-11-26','12:45:00',1.47),('15128','2013-11-26','13:10:00',1.05),('15128','2013-11-26','13:15:00',1.13),('15128','2013-11-26','13:20:00',1.07),('15128','2013-11-26','13:25:00',1.18),('15128','2013-11-26','13:30:00',1.07),('15128','2013-11-26','13:35:00',1.02),('15128','2013-11-25','09:50:00',1),('15128','2013-11-25','09:55:00',1.73),('15128','2013-11-25','10:20:00',1.03),('15128','2013-11-25','10:25:00',1.32),('15128','2013-11-25','10:30:00',1.98),('15128','2013-11-25','10:35:00',1.93),('15128','2013-11-25','10:40:00',2.02),('15128','2013-11-25','10:45:00',2.12),('15128','2013-11-25','10:50:00',2.06),('15128','2013-11-25','10:55:00',2.14),('15128','2013-11-25','11:00:00',2.35),('15128','2013-11-25','11:05:00',1.94),('15128','2013-11-25','11:10:00',1.29),('15128','2013-11-25','11:15:00',2.45),('15128','2013-11-25','11:20:00',2.76),('15128','2013-11-25','11:25:00',3.01),('15128','2013-11-25','11:30:00',1.62),('15128','2013-11-25','11:40:00',2.31),('15128','2013-11-25','11:45:00',3.09),('15128','2013-11-25','11:50:00',2.97),('15128','2013-11-25','11:55:00',2.58),('15128','2013-11-25','12:00:00',2.95),('15128','2013-11-25','12:05:00',2.07),('15128','2013-11-25','12:10:00',1.71),('15128','2013-11-25','12:15:00',2.65),('15128','2013-11-25','12:20:00',2.7),('15128','2013-11-25','12:25:00',2.43),('15128','2013-11-25','12:30:00',2.6),('15128','2013-11-25','12:35:00',2.78),('15128','2013-11-25','12:40:00',2.72),('15128','2013-11-25','12:45:00',2.72),('15128','2013-11-25','12:50:00',2.72),('15128','2013-11-25','12:55:00',2.7),('15128','2013-11-25','13:00:00',2.69),('15128','2013-11-25','13:05:00',2.67),('15128','2013-11-25','13:10:00',2.66),('15128','2013-11-25','13:15:00',2.64),('15128','2013-11-25','13:20:00',2.62),('15128','2013-11-25','13:25:00',2.6),('15128','2013-11-25','13:30:00',2.6),('15128','2013-11-25','13:35:00',2.56),('15128','2013-11-25','13:40:00',2.54),('15128','2013-11-25','13:45:00',2.43),('15128','2013-11-25','13:50:00',1.88),('15128','2013-11-25','13:55:00',1.64),('15128','2013-11-25','14:00:00',1.76),('15128','2013-11-25','14:05:00',2.65),('15128','2013-11-25','14:10:00',2.64),('15128','2013-11-25','14:15:00',2.75),('15128','2013-11-25','14:20:00',1.72),('15128','2013-11-25','14:25:00',1.6),('15128','2013-11-25','14:30:00',1.94),('15128','2013-11-25','14:35:00',2.2),('15128','2013-11-25','14:40:00',2.01),('15128','2013-11-25','14:45:00',1.48),('15128','2013-11-25','14:50:00',1.61),('15128','2013-11-25','14:55:00',1.75),('15128','2013-11-25','15:00:00',1.3),('15128','2013-11-25','15:05:00',1.44),('15128','2013-11-25','15:10:00',1.38),('15128','2013-11-25','15:15:00',1.25),('15128','2013-11-25','15:20:00',1.16),('15128','2013-11-25','15:25:00',1.06),('15128','2013-11-24','10:05:00',1.37),('15128','2013-11-24','10:10:00',1.67),('15128','2013-11-24','10:15:00',1.85),('15128','2013-11-24','10:20:00',1.15),('15128','2013-11-24','10:25:00',1.55),('15128','2013-11-24','10:30:00',1.57),('15128','2013-11-24','10:35:00',2.27),('15128','2013-11-24','10:40:00',2.08),('15128','2013-11-24','10:45:00',1.94),('15128','2013-11-24','10:50:00',1.98),('15128','2013-11-24','10:55:00',2.05),('15128','2013-11-24','11:00:00',2.18),('15128','2013-11-24','11:05:00',2.09),('15128','2013-11-24','11:20:00',1.96),('15128','2013-11-24','11:25:00',1.1),('15128','2013-11-24','11:30:00',1.26),('15128','2013-11-24','11:35:00',1.72),('15128','2013-11-24','11:40:00',2.27),('15128','2013-11-24','11:45:00',2.35),('15128','2013-11-24','11:50:00',1.77),('15128','2013-11-24','11:55:00',1.56),('15128','2013-11-24','12:00:00',1.22),('15128','2013-11-24','12:05:00',1.14),('15128','2013-11-24','12:10:00',1.26),('15128','2013-11-24','12:15:00',1.45),('15128','2013-11-24','12:20:00',1.37),('15128','2013-11-24','12:25:00',1.35),('15128','2013-11-24','12:30:00',1.11),('15128','2013-11-24','12:35:00',1),('15128','2013-11-24','12:40:00',1.5),('15128','2013-11-24','12:45:00',2.62),('15128','2013-11-24','12:50:00',2.67),('15128','2013-11-24','12:55:00',1.96),('15128','2013-11-24','13:00:00',1.47),('15128','2013-11-24','13:05:00',2.99),('15128','2013-11-24','13:10:00',3.26),('15128','2013-11-24','13:15:00',3.07),('15128','2013-11-24','13:20:00',2.72),('15128','2013-11-24','13:25:00',1.95),('15128','2013-11-24','13:30:00',1.24),('15128','2013-11-24','13:35:00',1.05),('15128','2013-11-24','13:40:00',1.21),('15128','2013-11-24','13:45:00',1.3),('15128','2013-11-24','13:50:00',1.24),('15128','2013-11-21','12:15:00',1.05),('15128','2013-11-21','12:20:00',1.23),('15128','2013-11-21','12:25:00',1.2),('15128','2013-11-20','09:50:00',1.5),('15128','2013-11-20','09:55:00',1.5),('15128','2013-11-20','10:00:00',1.54),('15128','2013-11-20','10:05:00',1.6),('15128','2013-11-20','10:10:00',1.44),('15128','2013-11-20','10:15:00',1.78),('15128','2013-11-20','10:20:00',2.29),('15128','2013-11-20','10:25:00',2.17),('15128','2013-11-20','10:30:00',1.49),('15128','2013-11-20','10:35:00',1.68),('15128','2013-11-20','10:40:00',1.97),('15128','2013-11-20','10:45:00',1.68),('15128','2013-11-20','10:50:00',1.82),('15128','2013-11-20','10:55:00',2.59),('15128','2013-11-20','11:00:00',2.01),('15128','2013-11-20','11:05:00',1.59),('15128','2013-11-20','11:10:00',2.22),('15128','2013-11-20','11:15:00',1.61),('15128','2013-11-20','11:20:00',2.02),('15128','2013-11-20','11:25:00',2.38),('15128','2013-11-20','11:30:00',2.46),('15128','2013-11-20','11:35:00',2.5),('15128','2013-11-20','11:40:00',2.52),('15128','2013-11-20','11:45:00',2.56),('15128','2013-11-20','11:50:00',2.58),('15128','2013-11-20','11:55:00',2.65),('15128','2013-11-20','12:00:00',2.79),('15128','2013-11-20','12:05:00',2.93),('15128','2013-11-20','12:10:00',3.04),('15128','2013-11-20','12:15:00',3.24),('15128','2013-11-20','12:20:00',2.99),('15128','2013-11-20','12:25:00',1.55),('15128','2013-11-20','12:55:00',2.57),('15128','2013-11-20','13:00:00',2.53),('15128','2013-11-20','13:05:00',2.42),('15128','2013-11-20','13:10:00',2.44),('15128','2013-11-20','13:15:00',2.12),('15128','2013-11-20','13:20:00',2),('15128','2013-11-20','13:25:00',2.21),('15128','2013-11-20','13:30:00',2.76),('15128','2013-11-20','13:35:00',2.56),('15128','2013-11-20','13:40:00',2.31),('15128','2013-11-20','13:45:00',2.23),('15128','2013-11-20','13:50:00',2.64),('15128','2013-11-20','13:55:00',1.74),('15128','2013-11-20','14:10:00',2.29),('15128','2013-11-20','14:15:00',1.3),('15128','2013-11-20','14:20:00',2.07),('15128','2013-11-20','14:25:00',2.06),('15128','2013-11-20','14:30:00',2.01),('15128','2013-11-20','14:35:00',1.92),('15128','2013-11-20','14:40:00',1.86),('15128','2013-11-20','14:45:00',1.8),('15128','2013-11-20','14:50:00',1.73),('15128','2013-11-20','14:55:00',1.61),('15128','2013-11-20','15:00:00',1.51),('15128','2013-11-20','15:05:00',1.39),('15128','2013-11-19','09:15:00',1.1),('15128','2013-11-19','09:20:00',1.16),('15128','2013-11-19','11:50:00',1.23),('15128','2013-11-19','11:55:00',1.3),('15128','2013-11-19','12:15:00',1.61),('15128','2013-11-19','12:20:00',1.73),('15128','2013-11-19','12:25:00',1.6),('15128','2013-11-19','12:30:00',1.15),('15128','2013-11-19','13:00:00',1.55),('15128','2013-11-19','13:05:00',1.03),('15128','2013-11-19','13:20:00',1.04),('15128','2013-11-19','13:25:00',1.39),('15128','2013-11-19','13:30:00',1.01),('15128','2013-11-19','13:35:00',1.07),('15128','2013-11-19','13:40:00',1.2),('15128','2013-11-19','13:45:00',1.47),('15128','2013-11-19','13:50:00',1.81),('15128','2013-11-19','13:55:00',1.03),('15128','2013-11-19','14:15:00',1.27),('15128','2013-11-19','14:25:00',1.08),('15128','2013-11-19','14:35:00',1.93),('15128','2013-11-19','14:40:00',1.45),('15128','2013-11-19','14:45:00',1.13),('15128','2013-11-19','14:50:00',1.82),('15128','2013-11-19','14:55:00',1.78),('15128','2013-11-19','15:00:00',1.36),('15128','2013-11-19','15:05:00',1.41),('15128','2013-11-19','15:10:00',1.37),('15128','2013-11-19','15:15:00',1.13),('15128','2013-11-19','15:20:00',1.05),('15128','2013-11-18','09:35:00',1.24),('15128','2013-11-18','09:40:00',1.36),('15128','2013-11-18','09:45:00',1.44),('15128','2013-11-18','09:50:00',1.46),('15128','2013-11-18','09:55:00',1.46),('15128','2013-11-18','10:00:00',1.7),('15128','2013-11-18','10:05:00',1.81),('15128','2013-11-18','10:10:00',1.84),('15128','2013-11-18','10:15:00',1.66),('15128','2013-11-18','11:15:00',1.48),('15128','2013-11-18','11:20:00',1.11),('15128','2013-11-18','11:25:00',1.29),('15128','2013-11-18','11:30:00',2.34),('15128','2013-11-18','11:35:00',2.3),('15128','2013-11-18','11:40:00',2.33),('15128','2013-11-18','11:45:00',1.84),('15128','2013-11-18','11:50:00',2.17),('15128','2013-11-18','11:55:00',2.4),('15128','2013-11-18','12:00:00',2.4),('15128','2013-11-18','12:05:00',2.41),('15128','2013-11-18','12:10:00',2.26),('15128','2013-11-18','12:15:00',2.47),('15128','2013-11-18','12:20:00',2.3),('15128','2013-11-18','12:25:00',1.78),('15128','2013-11-18','12:30:00',1.87),('15128','2013-11-18','12:35:00',2.45),('15128','2013-11-18','12:40:00',1.33),('15128','2013-11-18','12:45:00',1.64),('15128','2013-11-18','12:50:00',1.78),('15128','2013-11-18','13:15:00',1.89),('15128','2013-11-18','13:20:00',1.6),('15128','2013-11-18','13:30:00',1.3),('15128','2013-11-18','15:20:00',1.11),('15128','2013-11-18','15:25:00',1.44),('15128','2013-11-18','15:30:00',1.53),('15128','2013-11-18','15:35:00',1.12),('15128','2013-11-17','09:20:00',1.09),('15128','2013-11-17','09:25:00',1.14),('15128','2013-11-17','09:30:00',1.29),('15128','2013-11-17','09:35:00',1.39),('15128','2013-11-17','09:40:00',1.11),('15128','2013-11-17','10:00:00',1.05),('15128','2013-11-17','10:05:00',1.26),('15128','2013-11-17','10:10:00',1.37),('15128','2013-11-17','10:15:00',1.53),('15128','2013-11-17','10:20:00',1.42),('15128','2013-11-17','10:25:00',1.15),('15128','2013-11-17','10:30:00',1.07),('15128','2013-11-17','10:35:00',1.13),('15128','2013-11-17','10:40:00',1.26),('15128','2013-11-17','10:45:00',1.4),('15128','2013-11-17','10:50:00',1.29),('15128','2013-11-17','10:55:00',1.09),('15128','2013-11-17','11:25:00',1.08),('15128','2013-11-17','11:30:00',1.16),('15128','2013-11-17','11:35:00',1.21),('15128','2013-11-17','11:40:00',1.22),('15128','2013-11-17','11:45:00',1.23),('15128','2013-11-17','11:50:00',1.31),('15128','2013-11-17','11:55:00',1.37),('15128','2013-11-17','12:00:00',1.46),('15128','2013-11-17','12:05:00',1.42),('15128','2013-11-17','12:10:00',1.39),('15128','2013-11-17','12:15:00',1.42),('15128','2013-11-17','12:20:00',1.58),('15128','2013-11-17','12:25:00',1.93),('15128','2013-11-17','12:30:00',1.94),('15128','2013-11-17','12:35:00',1.57),('15128','2013-11-17','12:40:00',1.32),('15128','2013-11-17','12:45:00',1.1),('15128','2013-11-17','13:10:00',1.06),('15128','2013-11-17','13:15:00',1.03),('15128','2013-11-17','13:20:00',1),('15128','2013-11-17','13:35:00',1),('15128','2013-11-17','13:40:00',1.1),('15128','2013-11-17','13:45:00',1.19),('15128','2013-11-17','13:50:00',1.14),('15128','2014-04-18','08:15:00',1.09),('15128','2014-04-18','08:20:00',1.11),('15128','2014-04-18','08:25:00',1.05),('15128','2014-04-18','08:40:00',1.03),('15128','2014-04-18','09:20:00',1.09),('15128','2014-04-18','09:25:00',1.43),('15128','2014-04-18','09:30:00',1.09),('15128','2014-04-18','10:35:00',1.53),('15128','2014-04-18','10:40:00',1.69),('15128','2014-04-18','10:45:00',1.62),('15128','2014-04-18','10:50:00',1.83),('15128','2014-04-18','10:55:00',1.46),('15128','2014-04-18','11:00:00',1.07),('15128','2014-04-18','11:05:00',1.66),('15128','2014-04-18','11:10:00',2.43),('15128','2014-04-18','11:15:00',2.6),('15128','2014-04-18','11:20:00',3),('15128','2014-04-18','11:25:00',3.41),('15128','2014-04-18','11:30:00',3.18),('15128','2014-04-18','11:35:00',2.41),('15128','2014-04-18','11:40:00',2.06),('15128','2014-04-18','11:45:00',1.5),('15128','2014-04-18','11:50:00',1.12),('15128','2014-04-18','14:35:00',1.12),('15128','2014-04-18','14:40:00',1.33),('15128','2014-04-18','14:45:00',1.01),('15128','2014-04-18','15:00:00',1.28),('15128','2014-04-18','15:05:00',1.26),('15128','2014-04-18','15:25:00',1.14),('15128','2014-04-18','15:40:00',1.83),('15128','2014-04-18','15:45:00',4.11),('15128','2014-04-18','15:50:00',3.41),('15128','2014-04-18','15:55:00',2.42),('15128','2014-04-18','16:00:00',1.25),('15128','2014-04-18','16:05:00',1.42),('15128','2014-04-18','16:10:00',1.3),('15128','2014-04-18','16:15:00',2.27),('15128','2014-04-18','16:20:00',2.31),('15128','2014-04-18','16:25:00',2.56),('15128','2014-04-18','16:30:00',1.73),('15128','2014-04-18','16:35:00',1.33),('15128','2014-04-18','16:40:00',1.58),('15128','2014-04-18','17:00:00',1.35),('15128','2014-04-18','17:05:00',1.34),('15128','2014-04-18','17:10:00',1.07),('15128','2014-04-18','17:15:00',1.37),('15128','2014-04-18','17:20:00',1.3),('15128','2013-11-16','09:15:00',1.06),('15128','2013-11-16','09:20:00',1.03),('15128','2013-11-16','09:25:00',1.09),('15128','2013-11-16','09:30:00',1.17),('15128','2013-11-16','09:35:00',1.14),('15128','2013-11-16','09:40:00',1.19),('15128','2013-11-16','09:45:00',1.34),('15128','2013-11-16','09:50:00',1.34),('15128','2013-11-16','09:55:00',1.4),('15128','2013-11-16','10:00:00',1.45),('15128','2013-11-16','10:05:00',1.49),('15128','2013-11-16','10:10:00',1.53),('15128','2013-11-16','10:15:00',1.58),('15128','2013-11-16','10:20:00',1.63),('15128','2013-11-16','10:25:00',1.65),('15128','2013-11-16','10:30:00',1.72),('15128','2013-11-16','10:35:00',1.75),('15128','2013-11-16','10:40:00',1.79),('15128','2013-11-16','10:45:00',1.83),('15128','2013-11-16','10:50:00',1.86),('15128','2013-11-16','10:55:00',1.95),('15128','2013-11-16','11:00:00',2.07),('15128','2013-11-16','11:05:00',2.14),('15128','2013-11-16','11:10:00',2.2),('15128','2013-11-16','11:15:00',2.24),('15128','2013-11-16','11:20:00',2.28),('15128','2013-11-16','11:25:00',2.3),('15128','2013-11-16','11:30:00',2.33),('15128','2013-11-16','11:35:00',2.39),('15128','2013-11-16','11:40:00',2.42),('15128','2013-11-16','11:45:00',2.45),('15128','2013-11-16','11:50:00',2.47),('15128','2013-11-16','11:55:00',2.48),('15128','2013-11-16','12:00:00',2.49),('15128','2013-11-16','12:05:00',2.5),('15128','2013-11-16','12:10:00',2.52),('15128','2013-11-16','12:15:00',2.54),('15128','2013-11-16','12:20:00',2.59),('15128','2013-11-16','12:25:00',2.56),('15128','2013-11-16','12:30:00',2.53),('15128','2013-11-16','12:35:00',2.52),('15128','2013-11-16','12:40:00',2.52),('15128','2013-11-16','12:45:00',2.5),('15128','2013-11-16','12:50:00',2.49),('15128','2013-11-16','12:55:00',2.48),('15128','2013-11-16','13:00:00',2.47),('15128','2013-11-16','13:05:00',2.48),('15128','2013-11-16','13:10:00',2.45),('15128','2013-11-16','13:15:00',2.42),('15128','2013-11-16','13:20:00',2.44),('15128','2013-11-16','13:25:00',2.44),('15128','2013-11-16','13:30:00',2.45),('15128','2013-11-16','13:35:00',2.41),('15128','2013-11-16','13:40:00',2.32),('15128','2013-11-16','13:45:00',2.27),('15128','2013-11-16','13:50:00',2.18),('15128','2013-11-16','13:55:00',2.19),('15128','2013-11-16','14:00:00',2.07),('15128','2013-11-16','14:10:00',1.13),('15128','2013-11-16','14:15:00',1.92),('15128','2013-11-16','14:20:00',1.91),('15128','2013-11-16','14:25:00',1.83),('15128','2013-11-16','14:30:00',1.47),('15128','2013-11-16','14:40:00',1.16),('15128','2013-11-16','14:50:00',1.68),('15128','2013-11-16','14:55:00',1.37),('15128','2013-11-16','15:00:00',1.35),('15128','2013-11-16','15:05:00',1.52),('15128','2013-11-16','15:10:00',1.29),('15128','2013-11-16','15:15:00',1.16),('15128','2013-11-16','15:20:00',1.1),('15128','2013-11-16','15:25:00',1.07),('15128','2013-11-15','12:55:00',1.43),('15128','2013-11-15','13:00:00',1.43),('15128','2013-11-15','13:05:00',1.44),('15128','2013-11-15','13:10:00',1.12),('15128','2013-11-15','13:15:00',1.05),('15128','2013-11-14','09:20:00',1.12),('15128','2013-11-14','09:50:00',1.56),('15128','2013-11-14','09:55:00',1.35),('15128','2013-11-14','10:00:00',1.11),('15128','2013-11-14','10:05:00',1.11),('15128','2013-11-14','10:10:00',1.17),('15128','2013-11-14','10:15:00',1.24),('15128','2013-11-14','10:20:00',1.24),('15128','2013-11-14','10:25:00',1.24),('15128','2013-11-14','10:30:00',1.35),('15128','2013-11-14','10:35:00',1.46),('15128','2013-11-14','10:40:00',1.11),('15128','2013-11-14','11:00:00',1.03),('15128','2013-11-14','11:05:00',1.26),('15128','2013-11-14','11:10:00',1.51),('15128','2013-11-14','11:15:00',1.68),('15128','2013-11-14','11:20:00',1.31),('15128','2013-11-14','11:25:00',1.11),('15128','2013-11-14','11:30:00',1.12),('15128','2013-11-14','11:35:00',1.78),('15128','2013-11-14','11:40:00',1.67),('15128','2013-11-14','11:45:00',1.49),('15128','2013-11-14','11:50:00',1.63),('15128','2013-11-14','11:55:00',1.47),('15128','2013-11-14','12:00:00',1.3),('15128','2013-11-14','12:05:00',1.1),('15128','2013-11-14','13:00:00',1.01),('15128','2013-11-14','13:10:00',1.01),('15128','2013-11-14','13:15:00',1.02),('15128','2013-11-13','09:20:00',1.12),('15128','2013-11-13','09:25:00',1.15),('15128','2013-11-13','09:30:00',1.24),('15128','2013-11-13','09:35:00',1.31),('15128','2013-11-13','09:40:00',1.36),('15128','2013-11-13','09:45:00',1.42),('15128','2013-11-13','09:50:00',1.47),('15128','2013-11-13','09:55:00',1.51),('15128','2013-11-13','10:00:00',1.54),('15128','2013-11-13','10:05:00',1.55),('15128','2013-11-13','10:10:00',1.54),('15128','2013-11-13','10:15:00',1.6),('15128','2013-11-13','10:20:00',1.56),('15128','2013-11-13','10:25:00',1.58),('15128','2013-11-13','10:30:00',1.7),('15128','2013-11-13','10:35:00',1.83),('15128','2013-11-13','10:40:00',1.91),('15128','2013-11-13','10:45:00',1.99),('15128','2013-11-13','10:50:00',2.08),('15128','2013-11-13','10:55:00',2.2),('15128','2013-11-13','11:00:00',2.35),('15128','2013-11-13','11:05:00',2.51),('15128','2013-11-13','11:10:00',2.41),('15128','2013-11-13','11:15:00',1.92),('15128','2013-11-13','11:20:00',2.57),('15128','2013-11-13','11:25:00',2.75),('15128','2013-11-13','11:30:00',2.54),('15128','2013-11-13','11:35:00',2.32),('15128','2013-11-13','11:40:00',2.24),('15128','2013-11-13','11:45:00',2.3),('15128','2013-11-13','11:50:00',1.19),('15128','2013-11-13','11:55:00',1.15),('15128','2013-11-13','12:00:00',1.12),('15128','2013-11-13','12:05:00',1.1),('15128','2013-11-13','12:10:00',1.1),('15128','2013-11-13','12:15:00',1.07),('15128','2013-11-13','12:20:00',1.19),('15128','2013-11-13','12:25:00',1.46),('15128','2013-11-13','12:30:00',2.03),('15128','2013-11-13','12:35:00',2.1),('15128','2013-11-13','12:40:00',1.64),('15128','2013-11-13','12:45:00',1.97),('15128','2013-11-13','12:50:00',1.65),('15128','2013-11-13','12:55:00',1.7),('15128','2013-11-13','13:00:00',1.57),('15128','2013-11-13','13:05:00',1.1),('15128','2013-11-13','13:10:00',1.18),('15128','2013-11-13','13:15:00',1.46),('15128','2013-11-13','13:20:00',2.51),('15128','2013-11-13','13:25:00',3.12),('15128','2013-11-13','13:30:00',2.85),('15128','2013-11-13','13:35:00',2.34),('15128','2013-11-13','13:40:00',2.63),('15128','2013-11-13','13:45:00',2.85),('15128','2013-11-13','13:50:00',2.65),('15128','2013-11-13','13:55:00',2),('15128','2013-11-13','14:00:00',1.17),('15128','2013-11-13','14:05:00',2.43),('15128','2013-11-13','14:10:00',1.05),('15128','2013-11-12','10:10:00',1.2),('15128','2013-11-12','10:15:00',1),('15128','2013-11-12','10:20:00',1.03),('15128','2013-11-12','10:25:00',1.13),('15128','2013-11-12','10:35:00',1.02),('15128','2013-11-12','10:40:00',1.12),('15128','2013-11-12','10:45:00',1.1),('15128','2013-11-12','10:50:00',1.2),('15128','2013-11-12','10:55:00',1.14),('15128','2013-11-12','11:00:00',1.03),('15128','2013-11-12','11:05:00',1.01),('15128','2013-11-12','11:10:00',1.96),('15128','2013-11-12','11:15:00',2.1),('15128','2013-11-12','11:20:00',2.86),('15128','2013-11-12','11:25:00',3.33),('15128','2013-11-12','11:30:00',2.28),('15128','2013-11-12','11:55:00',1.18),('15128','2013-11-12','12:00:00',2.63),('15128','2013-11-12','12:05:00',1.84),('15128','2013-11-12','12:10:00',1.2),('15128','2013-11-12','12:15:00',1.03),('15128','2013-11-12','12:20:00',1.01),('15128','2013-11-12','12:50:00',1.1),('15128','2013-11-12','12:55:00',1.15),('15128','2013-11-12','13:00:00',1.14),('15128','2013-11-12','13:05:00',1.18),('15128','2013-11-12','13:10:00',1.29),('15128','2013-11-12','13:15:00',1.34),('15128','2013-11-12','13:20:00',1.5),('15128','2013-11-12','13:25:00',1.39),('15128','2013-11-12','13:30:00',1.13),('15128','2013-11-12','13:45:00',1.24),('15128','2013-11-12','13:50:00',1.25),('15128','2013-11-12','13:55:00',1.36),('15128','2013-11-12','14:00:00',1.73),('15128','2013-11-12','14:05:00',2),('15128','2013-11-12','14:10:00',2.14),('15128','2013-11-12','14:15:00',1.91),('15128','2013-11-12','14:20:00',1.7),('15128','2013-11-12','14:25:00',1.71),('15128','2013-11-12','14:30:00',1.81),('15128','2013-11-12','14:35:00',1.3),('15128','2013-11-11','11:40:00',2.35),('15128','2013-11-11','11:45:00',1.3),('15128','2013-11-11','12:00:00',1.89),('15128','2013-11-11','12:05:00',1.98),('15128','2013-11-11','12:10:00',1.07),('15128','2013-11-11','12:35:00',3.45),('15128','2013-11-11','12:40:00',3.05),('15128','2013-11-11','12:45:00',3.03),('15128','2013-11-11','12:50:00',1.88),('15128','2013-11-11','12:55:00',1.46),('15128','2013-11-11','13:00:00',1.79),('15128','2013-11-11','13:05:00',1.71),('15128','2013-11-11','13:10:00',1.59),('15128','2013-11-11','13:15:00',1.82),('15128','2013-11-11','13:20:00',1.85),('15128','2013-11-11','13:25:00',1.68),('15128','2013-11-11','13:30:00',1.68),('15128','2013-11-11','13:35:00',1.99),('15128','2013-11-11','13:40:00',2.86),('15128','2013-11-11','13:45:00',2.93),('15128','2013-11-11','13:50:00',3.09),('15128','2013-11-11','13:55:00',3.34),('15128','2013-11-11','14:00:00',1.73),('15128','2013-11-11','14:05:00',1.46),('15128','2013-11-11','14:10:00',1.5),('15128','2013-11-11','14:15:00',1.97),('15128','2013-11-11','14:20:00',2.66),('15128','2013-11-11','14:25:00',1.97),('15128','2013-11-11','14:35:00',1.03),('15128','2013-11-11','14:40:00',1.51),('15128','2013-11-11','14:45:00',1.66),('15128','2013-11-11','14:50:00',1.83),('15128','2013-11-11','14:55:00',1.79),('15128','2013-11-11','15:00:00',1.55),('15128','2013-11-11','15:05:00',1.48),('15128','2013-11-11','15:10:00',1.25),('15128','2013-11-11','15:25:00',1.16),('15128','2013-11-10','10:40:00',1.08),('15128','2013-11-10','10:45:00',1.06),('15128','2013-11-10','10:55:00',1.04),('15128','2013-11-10','11:00:00',1.21),('15128','2013-11-10','11:15:00',2.01),('15128','2013-11-10','11:20:00',3.41),('15128','2013-11-10','11:25:00',3.47),('15128','2013-11-10','11:30:00',2.58),('15128','2013-11-10','11:45:00',1.62),('15128','2013-11-10','11:50:00',1.99),('15128','2013-11-10','12:00:00',1.1),('15128','2013-11-10','12:05:00',1.81),('15128','2013-11-10','12:10:00',2.46),('15128','2013-11-10','12:15:00',2.73),('15128','2013-11-10','12:20:00',3.46),('15128','2013-11-10','12:25:00',3.01),('15128','2013-11-10','12:30:00',3.22),('15128','2013-11-10','12:35:00',2.85),('15128','2013-11-10','12:40:00',2.04),('15128','2013-11-10','12:45:00',1.17),('15128','2013-11-10','12:50:00',1.24),('15128','2013-11-10','12:55:00',1.15),('15128','2013-11-10','13:00:00',2.92),('15128','2013-11-10','13:05:00',2.8),('15128','2013-11-10','13:10:00',2.34),('15128','2013-11-10','13:15:00',2.79),('15128','2013-11-10','13:20:00',2.84),('15128','2013-11-10','13:25:00',2.58),('15128','2013-11-10','13:50:00',1.29),('15128','2013-11-10','13:55:00',2.23),('15128','2013-11-10','14:10:00',2.49),('15128','2013-11-10','14:15:00',2.71),('15128','2013-11-10','14:20:00',2.51),('15128','2013-11-10','14:25:00',2.34),('15128','2013-11-10','14:30:00',2.26),('15128','2013-11-10','14:35:00',2.15),('15128','2013-11-10','14:40:00',2.12),('15128','2013-11-10','14:45:00',2.07),('15128','2013-11-10','14:50:00',1.41),('15128','2013-11-10','14:55:00',1.76),('15128','2013-11-10','15:00:00',1.19),('15128','2013-11-09','08:55:00',1.02),('15128','2013-11-09','09:00:00',1.01),('15128','2013-11-09','09:10:00',1.13),('15128','2013-11-09','09:15:00',1.34),('15128','2013-11-09','09:20:00',1.43),('15128','2013-11-09','09:25:00',1.14),('15128','2013-11-09','09:35:00',1.39),('15128','2013-11-09','09:40:00',1.45),('15128','2013-11-09','09:45:00',1.6),('15128','2013-11-09','09:50:00',1.62),('15128','2013-11-09','09:55:00',1.58),('15128','2013-11-09','10:00:00',1.7),('15128','2013-11-09','10:05:00',1.86),('15128','2013-11-09','10:10:00',1.5),('15128','2013-11-09','10:15:00',1.15),('15128','2013-11-09','10:20:00',1.44),('15128','2013-11-09','10:25:00',1.58),('15128','2013-11-09','10:30:00',1.64),('15128','2013-11-09','10:35:00',1.85),('15128','2013-11-09','10:40:00',1.95),('15128','2013-11-09','10:45:00',1.26),('15128','2013-11-09','10:50:00',1.89),('15128','2013-11-09','10:55:00',1.32),('15128','2013-11-09','11:15:00',1.99),('15128','2013-11-09','11:20:00',1.25),('15128','2013-11-09','11:25:00',1.62),('15128','2013-11-09','11:30:00',1.57),('15128','2013-11-09','11:35:00',2.05),('15128','2013-11-09','11:40:00',1.72),('15128','2013-11-09','11:45:00',1.87),('15128','2013-11-09','11:50:00',1.29),('15128','2013-11-09','11:55:00',2.92),('15128','2013-11-09','12:00:00',1.4),('15128','2013-11-09','12:05:00',2.76),('15128','2013-11-09','12:10:00',2.88),('15128','2013-11-09','12:20:00',2.86),('15128','2013-11-09','12:25:00',1.49),('15128','2013-11-09','12:30:00',2.75),('15128','2013-11-09','12:35:00',2.9),('15128','2013-11-09','12:40:00',1.56),('15128','2013-11-09','12:45:00',1.02),('15128','2013-11-09','12:50:00',1.42),('15128','2013-11-09','12:55:00',1.7),('15128','2013-11-09','13:00:00',1.28),('15128','2013-11-09','13:05:00',2.19),('15128','2013-11-09','13:10:00',1.95),('15128','2013-11-09','13:25:00',2.46),('15128','2013-11-09','13:30:00',3.09),('15128','2013-11-09','13:35:00',1.82),('15128','2013-11-09','13:40:00',1.28),('15128','2013-11-08','09:30:00',1.07),('15128','2013-11-08','09:35:00',1.18),('15128','2013-11-08','09:40:00',1.6),('15128','2013-11-08','09:45:00',1.92),('15128','2013-11-08','09:50:00',1.97),('15128','2013-11-08','09:55:00',1.79),('15128','2013-11-08','10:00:00',1.36),('15128','2013-11-08','10:10:00',1),('15128','2013-11-08','10:15:00',1.09),('15128','2013-11-08','10:20:00',1.99),('15128','2013-11-08','10:25:00',1.62),('15128','2013-11-08','10:35:00',1.87),('15128','2013-11-08','10:40:00',1.97),('15128','2013-11-08','10:45:00',1.28),('15128','2013-11-08','10:55:00',1.8),('15128','2013-11-08','11:00:00',3.25),('15128','2013-11-08','11:05:00',1.71),('15128','2013-11-08','11:10:00',1.19),('15128','2013-11-08','11:15:00',1.01),('15128','2013-11-08','11:20:00',1.38),('15128','2013-11-08','11:25:00',2.44),('15128','2013-11-08','11:30:00',1.7),('15128','2013-11-08','11:35:00',2.88),('15128','2013-11-08','11:40:00',2.93),('15128','2013-11-08','11:45:00',3.35),('15128','2013-11-08','11:50:00',2.1),('15128','2013-11-08','11:55:00',1.98),('15128','2013-11-08','12:00:00',2.57),('15128','2013-11-08','12:05:00',2.13),('15128','2013-11-08','12:10:00',1.21),('15128','2013-11-08','12:15:00',1.02),('15128','2013-11-08','12:30:00',1.07),('15128','2013-11-08','12:35:00',1.19),('15128','2013-11-08','12:40:00',1.25),('15128','2013-11-08','12:45:00',1.13),('15128','2013-11-08','12:50:00',1.32),('15128','2013-11-08','12:55:00',2.31),('15128','2013-11-08','13:00:00',2.31),('15128','2013-11-08','13:05:00',2.34),('15128','2013-11-08','13:10:00',1.99),('15128','2013-11-08','13:15:00',1.65),('15128','2013-11-08','13:20:00',2.67),('15128','2013-11-08','13:25:00',2.86),('15128','2013-11-08','13:30:00',2.14),('15128','2013-11-08','13:35:00',1.74),('15128','2013-11-08','13:40:00',3.07),('15128','2013-11-08','13:45:00',2.59),('15128','2013-11-08','13:50:00',1.59),('15128','2013-11-08','13:55:00',2.36),('15128','2013-11-08','14:00:00',1.17),('15128','2013-11-08','14:15:00',2.02),('15128','2013-11-08','14:20:00',1.96),('15128','2013-11-08','14:25:00',1.76),('15128','2013-11-08','14:30:00',2.21),('15128','2013-11-08','14:35:00',2.13),('15128','2013-11-08','14:40:00',1.87),('15128','2013-11-08','14:45:00',1.63),('15128','2013-11-08','15:20:00',1.08),('15128','2013-11-08','15:25:00',1.39),('15128','2013-11-07','09:15:00',1.05),('15128','2013-11-07','09:25:00',1.22),('15128','2013-11-07','09:30:00',1.15),('15128','2013-11-07','09:35:00',1.59),('15128','2013-11-07','09:40:00',1.33),('15128','2013-11-07','09:45:00',1.27),('15128','2013-11-07','09:50:00',1.59),('15128','2013-11-07','09:55:00',1.33),('15128','2013-11-07','10:00:00',1.36),('15128','2013-11-07','10:05:00',2.06),('15128','2013-11-07','10:10:00',2.14),('15128','2013-11-07','10:15:00',2.09),('15128','2013-11-07','10:20:00',1.3),('15128','2013-11-07','10:30:00',1.16),('15128','2013-11-07','10:35:00',1.19),('15128','2013-11-07','10:40:00',2.33),('15128','2013-11-07','10:45:00',2.62),('15128','2013-11-07','10:50:00',2.52),('15128','2013-11-07','10:55:00',2.38),('15128','2013-11-07','11:00:00',1.59),('15128','2013-11-07','11:15:00',3.02),('15128','2013-11-07','11:20:00',2.88),('15128','2013-11-07','11:25:00',3.16),('15128','2013-11-07','11:30:00',3.01),('15128','2013-11-07','11:35:00',3.07),('15128','2013-11-07','11:40:00',2.32),('15128','2013-11-07','11:45:00',2.42),('15128','2013-11-07','11:50:00',2.46),('15128','2013-11-07','11:55:00',2.87),('15128','2013-11-07','12:00:00',2.84),('15128','2013-11-07','12:05:00',2.73),('15128','2013-11-07','12:10:00',2.73),('15128','2013-11-07','12:15:00',2.81),('15128','2013-11-07','12:20:00',2.95),('15128','2013-11-07','12:25:00',3.07),('15128','2013-11-07','12:30:00',3.02),('15128','2013-11-07','12:35:00',2.83),('15128','2013-11-07','12:40:00',2.85),('15128','2013-11-07','12:45:00',2.86),('15128','2013-11-07','12:50:00',2.85),('15128','2013-11-07','12:55:00',2.81),('15128','2013-11-07','13:00:00',2.85),('15128','2013-11-07','13:05:00',2.66),('15128','2013-11-07','13:10:00',1.29),('15128','2013-11-07','13:15:00',1.33),('15128','2013-11-07','13:20:00',2.77),('15128','2013-11-07','13:25:00',2.93),('15128','2013-11-07','13:30:00',2.82),('15128','2013-11-07','13:35:00',2.71),('15128','2013-11-07','13:40:00',2.17),('15128','2013-11-07','13:45:00',1.17),('15128','2013-11-07','13:50:00',2.4),('15128','2013-11-07','13:55:00',2.42),('15128','2013-11-07','14:00:00',2.35),('15128','2013-11-07','14:05:00',2.24),('15128','2013-11-07','14:10:00',2.15),('15128','2013-11-07','14:15:00',2.56),('15128','2013-11-07','14:20:00',1.55),('15128','2013-11-07','14:25:00',2.08),('15128','2013-11-07','14:30:00',2.23),('15128','2013-11-07','14:35:00',2.08),('15128','2013-11-07','14:40:00',2.01),('15128','2013-11-07','14:45:00',1.98),('15128','2013-11-07','14:50:00',1.43),('15128','2013-11-07','14:55:00',1.51),('15128','2013-11-07','15:00:00',1.76),('15128','2013-11-07','15:10:00',1.24),('15128','2013-11-07','15:15:00',1.46),('15128','2013-11-07','15:20:00',1.46),('15128','2013-11-07','15:25:00',1.42),('15128','2013-11-07','15:30:00',1.29),('15128','2013-11-07','15:35:00',1.08),('15128','2014-04-17','08:45:00',1.61),('15128','2014-04-17','08:50:00',1.2),('15128','2014-04-17','09:05:00',1.04),('15128','2014-04-17','09:10:00',2.06),('15128','2014-04-17','09:15:00',1.85),('15128','2014-04-17','09:20:00',1.92),('15128','2014-04-17','09:25:00',1.65),('15128','2014-04-17','09:30:00',1.88),('15128','2014-04-17','09:35:00',1.15),('15128','2014-04-17','09:40:00',1.81),('15128','2014-04-17','09:45:00',1.82),('15128','2014-04-17','09:50:00',1.79),('15128','2014-04-17','09:55:00',1.55),('15128','2014-04-17','10:00:00',1.44),('15128','2014-04-17','10:05:00',1.35),('15128','2014-04-17','10:10:00',1.41),('15128','2014-04-17','10:15:00',1.28),('15128','2014-04-17','10:20:00',1.57),('15128','2014-04-17','10:25:00',1.41),('15128','2014-04-17','10:30:00',1.32),('15128','2014-04-17','10:35:00',1.5),('15128','2014-04-17','10:40:00',2.28),('15128','2014-04-17','10:45:00',2.13),('15128','2014-04-17','10:50:00',2.78),('15128','2014-04-17','10:55:00',2.52),('15128','2014-04-17','11:00:00',2.35),('15128','2014-04-17','11:05:00',2.22),('15128','2014-04-17','11:10:00',1.94),('15128','2014-04-17','11:15:00',2.39),('15128','2014-04-17','11:20:00',1.77),('15128','2014-04-17','11:25:00',2.27),('15128','2014-04-17','11:30:00',2.72),('15128','2014-04-17','11:35:00',2.41),('15128','2014-04-17','11:40:00',2.75),('15128','2014-04-17','11:45:00',2.64),('15128','2014-04-17','11:50:00',2.44),('15128','2014-04-17','11:55:00',1.88),('15128','2014-04-17','12:00:00',1.96),('15128','2014-04-17','12:05:00',3.4),('15128','2014-04-17','12:10:00',4.51),('15128','2014-04-17','12:15:00',4.02),('15128','2014-04-17','12:20:00',4.17),('15128','2014-04-17','12:25:00',2.88),('15128','2014-04-17','12:30:00',4.13),('15128','2014-04-17','12:35:00',4.23),('15128','2014-04-17','12:40:00',3.66),('15128','2014-04-17','12:45:00',4.12),('15128','2014-04-17','12:50:00',2.89),('15128','2014-04-17','12:55:00',3.41),('15128','2014-04-17','13:00:00',2.59),('15128','2014-04-17','13:05:00',2.9),('15128','2014-04-17','13:10:00',2.77),('15128','2014-04-17','13:15:00',2.49),('15128','2014-04-17','13:20:00',2.15),('15128','2014-04-17','13:25:00',1.84),('15128','2014-04-17','13:30:00',1.29),('15128','2014-04-17','13:35:00',1.43),('15128','2014-04-17','13:40:00',1.52),('15128','2014-04-17','13:45:00',1.45),('15128','2014-04-17','13:50:00',1.27),('15128','2014-04-17','13:55:00',1.43),('15128','2014-04-17','14:00:00',1.53),('15128','2014-04-17','14:05:00',1.5),('15128','2014-04-17','14:10:00',1.63),('15128','2014-04-17','14:15:00',1.96),('15128','2014-04-17','14:20:00',1.81),('15128','2014-04-17','14:25:00',2),('15128','2014-04-17','14:30:00',2.3),('15128','2014-04-17','14:35:00',2.19),('15128','2014-04-17','14:40:00',2.71),('15128','2014-04-17','14:45:00',3.37),('15128','2014-04-17','14:50:00',3.73),('15128','2014-04-17','14:55:00',4.71),('15128','2014-04-17','15:00:00',4.17),('15128','2014-04-17','15:05:00',4.27),('15128','2014-04-17','15:10:00',3.96),('15128','2014-04-17','15:15:00',4.51),('15128','2014-04-17','15:20:00',4.21),('15128','2014-04-17','15:25:00',2.39),('15128','2014-04-17','15:30:00',4.2),('15128','2014-04-17','15:35:00',2.43),('15128','2014-04-17','15:40:00',3.59),('15128','2014-04-17','15:45:00',4.18),('15128','2014-04-17','15:50:00',2.14),('15128','2014-04-17','15:55:00',3.06),('15128','2014-04-17','16:00:00',2.27),('15128','2014-04-17','16:05:00',3.39),('15128','2014-04-17','16:10:00',3.74),('15128','2014-04-17','16:15:00',4.07),('15128','2014-04-17','16:20:00',3.63),('15128','2014-04-17','16:25:00',3.55),('15128','2014-04-17','16:30:00',3.52),('15128','2014-04-17','16:35:00',3.16),('15128','2014-04-17','16:40:00',2.57),('15128','2014-04-17','16:50:00',1.81),('15128','2014-04-17','16:55:00',3.11),('15128','2014-04-17','17:00:00',2.96),('15128','2014-04-17','17:05:00',2.83),('15128','2014-04-17','17:10:00',2.75),('15128','2014-04-17','17:15:00',2.65),('15128','2014-04-17','17:20:00',2.57),('15128','2014-04-17','17:25:00',1.77),('15128','2014-04-17','17:30:00',1.04),('15128','2014-04-17','17:35:00',2.26),('15128','2014-04-17','17:40:00',2.1),('15128','2014-04-17','17:45:00',1.99),('15128','2014-04-17','17:50:00',1.91),('15128','2014-04-17','17:55:00',1.79),('15128','2014-04-17','18:00:00',1.73),('15128','2014-04-17','18:05:00',1.65),('15128','2014-04-17','18:10:00',1.57),('15128','2014-04-17','18:15:00',1.44),('15128','2014-04-17','18:20:00',1.34),('15128','2014-04-17','18:25:00',1.21),('15128','2014-04-17','18:30:00',1.1),('15128','2014-04-17','18:35:00',1.06),('15128','2013-11-06','09:10:00',1.08),('15128','2013-11-06','09:15:00',1.13),('15128','2013-11-06','09:20:00',1.19),('15128','2013-11-06','09:25:00',1.29),('15128','2013-11-06','09:30:00',1.35),('15128','2013-11-06','09:35:00',1.41),('15128','2013-11-06','09:40:00',1.46),('15128','2013-11-06','09:45:00',1.49),('15128','2013-11-06','09:50:00',1.56),('15128','2013-11-06','09:55:00',1.6),('15128','2013-11-06','10:00:00',1.62),('15128','2013-11-06','10:05:00',1.68),('15128','2013-11-06','10:10:00',1.7),('15128','2013-11-06','10:15:00',1.78),('15128','2013-11-06','10:20:00',1.83),('15128','2013-11-06','10:25:00',1.89),('15128','2013-11-06','10:30:00',1.91),('15128','2013-11-06','10:35:00',1.95),('15128','2013-11-06','10:40:00',1.98),('15128','2013-11-06','10:45:00',1.99),('15128','2013-11-06','10:50:00',2.09),('15128','2013-11-06','10:55:00',2.2),('15128','2013-11-06','11:00:00',2.27),('15128','2013-11-06','11:05:00',2.32),('15128','2013-11-06','11:10:00',2.36),('15128','2013-11-06','11:15:00',2.38),('15128','2013-11-06','11:20:00',2.41),('15128','2013-11-06','11:25:00',2.45),('15128','2013-11-06','11:30:00',2.5),('15128','2013-11-06','11:35:00',2.51),('15128','2013-11-06','11:40:00',2.53),('15128','2013-11-06','11:45:00',2.44),('15128','2013-11-06','11:50:00',2.54),('15128','2013-11-06','11:55:00',2.53),('15128','2013-11-06','12:00:00',2.44),('15128','2013-11-06','12:05:00',2.21),('15128','2013-11-06','12:10:00',1.55),('15128','2013-11-06','12:15:00',2.21),('15128','2013-11-06','12:20:00',2.9),('15128','2013-11-06','12:25:00',3.01),('15128','2013-11-06','12:30:00',2.55),('15128','2013-11-06','12:35:00',3.04),('15128','2013-11-06','12:40:00',2.73),('15128','2013-11-06','12:45:00',1.65),('15128','2013-11-06','12:50:00',2.82),('15128','2013-11-06','12:55:00',2.91),('15128','2013-11-06','13:05:00',1.49),('15128','2013-11-06','13:10:00',1.04),('15128','2013-11-06','13:15:00',2.35),('15128','2013-11-06','13:20:00',3.09),('15128','2013-11-06','13:25:00',2.68),('15128','2013-11-06','13:30:00',2.57),('15128','2013-11-06','13:35:00',2.5),('15128','2013-11-06','13:40:00',2.46),('15128','2013-11-06','13:45:00',2.43),('15128','2013-11-06','13:50:00',2.43),('15128','2013-11-06','13:55:00',2.42),('15128','2013-11-06','14:00:00',2.4),('15128','2013-11-06','14:05:00',2.17),('15128','2013-11-06','14:10:00',2.38),('15128','2013-11-06','14:15:00',2.27),('15128','2013-11-06','14:20:00',2.22),('15128','2013-11-06','14:25:00',2.14),('15128','2013-11-06','14:30:00',2.11),('15128','2013-11-06','14:35:00',2.09),('15128','2013-11-06','14:40:00',2),('15128','2013-11-06','14:45:00',1.95),('15128','2013-11-06','14:50:00',1.89),('15128','2013-11-06','14:55:00',1.82),('15128','2013-11-06','15:00:00',1.74),('15128','2013-11-06','15:05:00',1.7),('15128','2013-11-06','15:10:00',1.62),('15128','2013-11-06','15:15:00',1.55),('15128','2013-11-06','15:20:00',1.45),('15128','2013-11-06','15:25:00',1.37),('15128','2013-11-06','15:30:00',1.29),('15128','2013-11-06','15:35:00',1.18),('15128','2013-11-06','15:40:00',1.06),('15128','2013-11-05','09:10:00',1.07),('15128','2013-11-05','09:15:00',1.09),('15128','2013-11-05','09:20:00',1.29),('15128','2013-11-05','09:25:00',1.35),('15128','2013-11-05','09:30:00',1.39),('15128','2013-11-05','09:35:00',1.46),('15128','2013-11-05','09:40:00',1.51),('15128','2013-11-05','09:45:00',1.55),('15128','2013-11-05','09:50:00',1.6),('15128','2013-11-05','09:55:00',1.65),('15128','2013-11-05','10:00:00',1.68),('15128','2013-11-05','10:05:00',1.74),('15128','2013-11-05','10:10:00',1.79),('15128','2013-11-05','10:15:00',1.84),('15128','2013-11-05','10:20:00',1.86),('15128','2013-11-05','10:25:00',1.94),('15128','2013-11-05','10:30:00',1.95),('15128','2013-11-05','10:35:00',2.02),('15128','2013-11-05','10:40:00',2.01),('15128','2013-11-05','10:45:00',2.08),('15128','2013-11-05','10:50:00',2.11),('15128','2013-11-05','10:55:00',2.24),('15128','2013-11-05','11:00:00',2.39),('15128','2013-11-05','11:05:00',2.45),('15128','2013-11-05','11:10:00',2.48),('15128','2013-11-05','11:15:00',2.52),('15128','2013-11-05','11:20:00',2.55),('15128','2013-11-05','11:25:00',2.59),('15128','2013-11-05','11:30:00',2.63),('15128','2013-11-05','11:35:00',2.66),('15128','2013-11-05','11:40:00',2.69),('15128','2013-11-05','11:45:00',2.72),('15128','2013-11-05','11:50:00',2.74),('15128','2013-11-05','11:55:00',2.77),('15128','2013-11-05','12:00:00',2.78),('15128','2013-11-05','12:05:00',2.79),('15128','2013-11-05','12:10:00',2.79),('15128','2013-11-05','12:15:00',2.79),('15128','2013-11-05','12:20:00',2.81),('15128','2013-11-05','12:25:00',2.82),('15128','2013-11-05','12:30:00',2.82),('15128','2013-11-05','12:35:00',2.82),('15128','2013-11-05','12:40:00',2.83),('15128','2013-11-05','12:45:00',2.8),('15128','2013-11-05','12:50:00',2.78),('15128','2013-11-05','12:55:00',2.76),('15128','2013-11-05','13:00:00',2.76),('15128','2013-11-05','13:05:00',2.75),('15128','2013-11-05','13:10:00',2.75),('15128','2013-11-05','13:15:00',2.74),('15128','2013-11-05','13:20:00',2.71),('15128','2013-11-05','13:25:00',2.68),('15128','2013-11-05','13:30:00',2.66),('15128','2013-11-05','13:35:00',2.63),('15128','2013-11-05','13:40:00',2.62),('15128','2013-11-05','13:45:00',2.58),('15128','2013-11-05','13:50:00',2.55),('15128','2013-11-05','13:55:00',2.5),('15128','2013-11-05','14:00:00',2.46),('15128','2013-11-05','14:05:00',2.43),('15128','2013-11-05','14:10:00',2.39),('15128','2013-11-05','14:15:00',2.35),('15128','2013-11-05','14:20:00',2.3),('15128','2013-11-05','14:25:00',2.25),('15128','2013-11-05','14:30:00',2.18),('15128','2013-11-05','14:35:00',2.12),('15128','2013-11-05','14:40:00',2.07),('15128','2013-11-05','14:45:00',2.01),('15128','2013-11-05','14:50:00',1.95),('15128','2013-11-05','14:55:00',1.88),('15128','2013-11-05','15:00:00',1.81),('15128','2013-11-05','15:05:00',1.74),('15128','2013-11-05','15:10:00',1.65),('15128','2013-11-05','15:15:00',1.57),('15128','2013-11-05','15:20:00',1.48),('15128','2013-11-05','15:25:00',1.42),('15128','2013-11-05','15:30:00',1.34),('15128','2013-11-05','15:35:00',1.25),('15128','2013-11-05','15:40:00',1.13),('15128','2013-11-05','15:45:00',1.04),('15128','2013-11-04','08:55:00',1.03),('15128','2013-11-04','10:20:00',1.07),('15128','2013-11-04','10:25:00',1.05),('15128','2013-11-04','10:30:00',1.17),('15128','2013-11-04','10:35:00',1.13),('15128','2013-11-04','10:40:00',1.33),('15128','2013-11-04','10:45:00',1.45),('15128','2013-11-04','10:50:00',1.13),('15128','2013-11-04','11:30:00',1.01),('15128','2013-11-04','11:35:00',1.33),('15128','2013-11-04','11:40:00',1.39),('15128','2013-11-04','11:45:00',1.13),('15128','2013-11-04','11:50:00',1.04),('15128','2013-11-04','12:25:00',1.25),('15128','2013-11-04','12:30:00',1.15),('15128','2013-11-04','12:40:00',1.14),('15128','2013-11-04','12:45:00',1.16),('15128','2013-11-04','13:10:00',1.06),('15128','2013-11-04','13:15:00',1.3),('15128','2013-11-04','13:20:00',1.51),('15128','2013-11-04','13:25:00',1.52),('15128','2013-11-04','13:30:00',1.53),('15128','2013-11-04','13:35:00',2.21),('15128','2013-11-04','13:40:00',2.42),('15128','2013-11-04','13:45:00',2.04),('15128','2013-11-04','13:50:00',2.66),('15128','2013-11-04','13:55:00',1.95),('15128','2013-11-04','14:00:00',1.28),('15128','2013-11-04','14:05:00',2.35),('15128','2013-11-04','14:10:00',2.78),('15128','2013-11-04','14:15:00',2.37),('15128','2013-11-04','14:20:00',2.32),('15128','2013-11-04','14:25:00',2.56),('15128','2013-11-04','14:30:00',2.15),('15128','2013-11-04','14:35:00',2.17),('15128','2013-11-04','14:40:00',2.31),('15128','2013-11-04','14:45:00',1.93),('15128','2013-11-04','14:50:00',1.62),('15128','2013-11-04','15:30:00',1.53),('15128','2013-11-04','15:35:00',1.35),('15128','2013-11-04','15:40:00',1.32),('15128','2013-11-04','15:45:00',1.25),('15128','2013-11-04','15:50:00',1.16),('15128','2013-11-04','15:55:00',1.02),('15128','2013-11-03','09:45:00',1.63),('15128','2013-11-03','09:50:00',1.53),('15128','2013-11-03','09:55:00',1.18),('15128','2013-11-03','10:00:00',1.04),('15128','2013-11-03','10:05:00',1.35),('15128','2013-11-03','10:10:00',1.45),('15128','2013-11-03','10:20:00',1.32),('15128','2013-11-03','10:40:00',1.93),('15128','2013-11-03','10:45:00',2.36),('15128','2013-11-03','10:50:00',2.39),('15128','2013-11-03','10:55:00',2.6),('15128','2013-11-03','11:00:00',2.91),('15128','2013-11-03','11:05:00',3.13),('15128','2013-11-03','11:10:00',2.13),('15128','2013-11-03','11:15:00',1.29),('15128','2013-11-03','11:20:00',1.81),('15128','2013-11-03','11:45:00',2.24),('15128','2013-11-03','11:50:00',2.74),('15128','2013-11-03','11:55:00',3.08),('15128','2013-11-03','12:00:00',3.06),('15128','2013-11-03','12:05:00',3.07),('15128','2013-11-03','12:10:00',3.02),('15128','2013-11-03','12:15:00',3),('15128','2013-11-03','12:20:00',2.03),('15128','2013-11-03','12:25:00',1.02),('15128','2013-11-03','12:30:00',1.29),('15128','2013-11-03','12:35:00',1.22),('15128','2013-11-03','12:40:00',2.34),('15128','2013-11-03','12:45:00',2.09),('15128','2013-11-03','12:50:00',2.59),('15128','2013-11-03','12:55:00',2.9),('15128','2013-11-03','13:00:00',1.84),('15128','2013-11-03','13:05:00',1.12),('15128','2013-11-03','13:10:00',2.52),('15128','2013-11-03','13:15:00',1.08),('15128','2013-11-03','13:20:00',1.77),('15128','2013-11-03','13:25:00',2.76),('15128','2013-11-03','13:30:00',1.51),('15128','2013-11-03','13:35:00',1.68),('15128','2013-11-03','13:40:00',2.86),('15128','2013-11-03','13:45:00',1.97),('15128','2013-11-03','13:50:00',1.88),('15128','2013-11-03','13:55:00',1.8),('15128','2013-11-03','14:00:00',1.27),('15128','2013-11-03','14:20:00',1.13),('15128','2013-11-03','14:25:00',1.65),('15128','2013-11-03','14:30:00',2.05),('15128','2013-11-03','14:35:00',1.97),('15128','2013-11-03','15:00:00',1.02),('15128','2013-11-03','15:10:00',1.86),('15128','2013-11-03','15:15:00',1.74),('15128','2013-11-03','15:25:00',1.49),('15128','2013-11-03','15:30:00',1.41),('15128','2013-11-02','08:45:00',1.05),('15128','2013-11-02','08:50:00',1.13),('15128','2013-11-02','09:10:00',1.06),('15128','2013-11-02','09:15:00',1.1),('15128','2013-11-02','09:20:00',1.07),('15128','2013-11-02','09:25:00',1.16),('15128','2013-11-02','09:30:00',1.43),('15128','2013-11-02','09:35:00',1.18),('15128','2013-11-02','09:50:00',1.03),('15128','2013-11-02','09:55:00',1.71),('15128','2013-11-02','10:00:00',1.91),('15128','2013-11-02','10:05:00',1.56),('15128','2013-11-02','10:10:00',1.83),('15128','2013-11-02','10:15:00',1.85),('15128','2013-11-02','10:20:00',1.62),('15128','2013-11-02','10:25:00',2.08),('15128','2013-11-02','10:30:00',1.94),('15128','2013-11-02','10:35:00',1.44),('15128','2013-11-02','10:40:00',1.18),('15128','2013-11-02','10:45:00',1.05),('15128','2013-11-02','11:05:00',1.34),('15128','2013-11-02','11:10:00',2.74),('15128','2013-11-02','11:15:00',3.13),('15128','2013-11-02','11:20:00',2.85),('15128','2013-11-02','11:25:00',2.24),('15128','2013-11-02','11:30:00',2.74),('15128','2013-11-02','11:35:00',3.57),('15128','2013-11-02','11:40:00',3.41),('15128','2013-11-02','11:45:00',3.12),('15128','2013-11-02','11:50:00',1.07),('15128','2013-11-02','11:55:00',1.32),('15128','2013-11-02','12:00:00',1.45),('15128','2013-11-02','12:05:00',1.31),('15128','2013-11-02','12:10:00',3),('15128','2013-11-02','12:15:00',2.84),('15128','2013-11-02','12:20:00',2.71),('15128','2013-11-02','12:45:00',1.11),('15128','2013-11-02','12:50:00',1.02),('15128','2013-11-02','12:55:00',1.05),('15128','2013-11-02','13:00:00',1.11),('15128','2013-11-02','13:05:00',1.06),('15128','2013-11-02','13:10:00',1.23),('15128','2013-11-02','13:15:00',1.1),('15128','2013-11-02','13:20:00',1.07),('15128','2013-11-02','14:00:00',1.28),('15128','2013-11-02','14:05:00',2.52),('15128','2013-11-02','14:15:00',1.54),('15128','2013-11-02','14:20:00',2.61),('15128','2013-11-02','14:25:00',2.1),('15128','2013-11-02','14:30:00',1.48),('15128','2013-11-02','14:35:00',1.28),('15128','2013-11-02','14:40:00',1.12),('15128','2013-11-02','14:50:00',1.04),('15128','2013-11-02','14:55:00',1.39),('15128','2013-11-02','15:15:00',1.1),('15128','2013-11-02','15:20:00',1.05),('15128','2013-11-02','15:25:00',1.18),('15128','2013-11-02','15:30:00',1.13),('15128','2013-11-01','08:55:00',1.28),('15128','2013-11-01','09:00:00',1.28),('15128','2013-11-01','09:05:00',1.24),('15128','2013-11-01','09:10:00',1.42),('15128','2013-11-01','09:15:00',1.26),('15128','2013-11-01','09:20:00',1.17),('15128','2013-11-01','09:25:00',1.35),('15128','2013-11-01','09:30:00',1.39),('15128','2013-11-01','09:35:00',1.5),('15128','2013-11-01','09:40:00',1.61),('15128','2013-11-01','09:45:00',1.68),('15128','2013-11-01','09:50:00',1.21),('15128','2013-11-01','09:55:00',1.65),('15128','2013-11-01','10:00:00',1.94),('15128','2013-11-01','10:05:00',1.57),('15128','2013-11-01','10:10:00',1.16),('15128','2013-11-01','10:55:00',1.26),('15128','2013-11-01','11:00:00',1.4),('15128','2013-11-01','11:05:00',1.58),('15128','2013-11-01','11:10:00',2.69),('15128','2013-11-01','11:15:00',2.37),('15128','2013-11-01','11:20:00',1.01),('15128','2013-11-01','11:25:00',1.19),('15128','2013-11-01','11:30:00',3.17),('15128','2013-11-01','11:35:00',3.19),('15128','2013-11-01','11:40:00',3.23),('15128','2013-11-01','11:45:00',3.11),('15128','2013-11-01','11:50:00',2.94),('15128','2013-11-01','11:55:00',2.89),('15128','2013-11-01','12:00:00',2.59),('15128','2013-11-01','12:05:00',1.72),('15128','2013-11-01','12:10:00',1.82),('15128','2013-11-01','12:15:00',1.27),('15128','2013-11-01','12:20:00',1.03),('15128','2013-11-01','12:25:00',1.01),('15128','2013-11-01','12:30:00',1.54),('15128','2013-11-01','12:35:00',1.45),('15128','2013-11-01','12:40:00',3.09),('15128','2013-11-01','12:45:00',1.08),('15128','2013-11-01','13:00:00',2.91),('15128','2013-11-01','13:05:00',2.9),('15128','2013-11-01','13:10:00',2.57),('15128','2013-11-01','13:15:00',2.65),('15128','2013-11-01','13:30:00',1.32),('15128','2013-11-01','13:35:00',2.2),('15128','2013-11-01','13:40:00',2.14),('15128','2013-11-01','13:45:00',2.65),('15128','2013-11-01','13:50:00',2.55),('15128','2013-11-01','13:55:00',3.14),('15128','2013-11-01','14:00:00',2.78),('15128','2013-11-01','14:05:00',2.48),('15128','2013-11-01','14:10:00',2.38),('15128','2013-11-01','14:15:00',2.39),('15128','2013-11-01','14:20:00',2.3),('15128','2013-11-01','14:25:00',2.24),('15128','2013-11-01','14:30:00',2.2),('15128','2013-11-01','14:35:00',2.16),('15128','2013-11-01','14:40:00',2.1),('15128','2013-11-01','14:45:00',2.08),('15128','2013-11-01','14:50:00',2),('15128','2013-11-01','14:55:00',2.14),('15128','2013-11-01','15:00:00',1.98),('15128','2013-11-01','15:05:00',1.89),('15128','2013-11-01','15:10:00',1.46),('15128','2013-11-01','15:20:00',1.15),('15128','2013-11-01','15:25:00',1.25),('15128','2013-11-01','15:45:00',1.19),('15128','2013-11-01','15:50:00',1.2),('15128','2013-10-31','09:00:00',1.08),('15128','2013-10-31','09:05:00',1.14),('15128','2013-10-31','09:10:00',1.21),('15128','2013-10-31','09:15:00',1.27),('15128','2013-10-31','09:20:00',1.33),('15128','2013-10-31','09:25:00',1.36),('15128','2013-10-31','09:30:00',1.43),('15128','2013-10-31','09:35:00',1.47),('15128','2013-10-31','09:40:00',1.52),('15128','2013-10-31','09:45:00',1.56),('15128','2013-10-31','09:50:00',1.62),('15128','2013-10-31','09:55:00',1.65),('15128','2013-10-31','10:00:00',1.72),('15128','2013-10-31','10:05:00',1.81),('15128','2013-10-31','10:10:00',1.86),('15128','2013-10-31','10:15:00',1.91),('15128','2013-10-31','10:20:00',1.95),('15128','2013-10-31','10:25:00',1.98),('15128','2013-10-31','10:30:00',2.06),('15128','2013-10-31','10:35:00',2.11),('15128','2013-10-31','10:40:00',2.19),('15128','2013-10-31','10:45:00',2.21),('15128','2013-10-31','10:50:00',2.22),('15128','2013-10-31','10:55:00',2.35),('15128','2013-10-31','11:00:00',2.51),('15128','2013-10-31','11:05:00',2.54),('15128','2013-10-31','11:10:00',2.31),('15128','2013-10-31','11:15:00',2.11),('15128','2013-10-31','11:20:00',2.08),('15128','2013-10-31','11:25:00',2.43),('15128','2013-10-31','11:30:00',2.73),('15128','2013-10-31','11:35:00',2.61),('15128','2013-10-31','11:40:00',2.41),('15128','2013-10-31','11:45:00',2.45),('15128','2013-10-31','11:50:00',2.62),('15128','2013-10-31','11:55:00',2.86),('15128','2013-10-31','12:00:00',2.98),('15128','2013-10-31','12:05:00',2.88),('15128','2013-10-31','12:10:00',2.49),('15128','2013-10-31','12:15:00',2.01),('15128','2013-10-31','12:20:00',2.31),('15128','2013-10-31','12:25:00',2.8),('15128','2013-10-31','12:30:00',2.23),('15128','2013-10-31','12:35:00',1.58),('15128','2013-10-31','12:40:00',1.16),('15128','2013-10-31','12:45:00',1.35),('15128','2013-10-31','12:50:00',2.67),('15128','2013-10-31','12:55:00',2.05),('15128','2013-10-31','13:00:00',2.06),('15128','2013-10-31','13:05:00',2.11),('15128','2013-10-31','13:10:00',1.87),('15128','2013-10-31','13:15:00',1.82),('15128','2013-10-31','13:20:00',1.37),('15128','2013-10-31','13:25:00',1.63),('15128','2013-10-31','13:30:00',1.11),('15128','2013-10-31','13:40:00',1.02),('15128','2013-10-31','14:00:00',1.03),('15128','2013-10-31','14:05:00',1.56),('15128','2013-10-31','14:10:00',1.44),('15128','2013-10-31','14:15:00',1.05),('15128','2013-10-31','14:20:00',1),('15128','2013-10-30','09:05:00',1.03),('15128','2013-10-30','09:10:00',1.24),('15128','2013-10-30','09:15:00',1.34),('15128','2013-10-30','09:20:00',1.34),('15128','2013-10-30','09:25:00',1.23),('15128','2013-10-30','09:30:00',1.16),('15128','2013-10-30','09:35:00',1.21),('15128','2013-10-30','09:40:00',1.31),('15128','2013-10-30','09:45:00',1.29),('15128','2013-10-30','09:50:00',1.35),('15128','2013-10-30','09:55:00',1.44),('15128','2013-10-30','10:00:00',1.64),('15128','2013-10-30','10:05:00',1.65),('15128','2013-10-30','10:10:00',1.75),('15128','2013-10-30','10:15:00',1.79),('15128','2013-10-30','10:20:00',1.82),('15128','2013-10-30','10:25:00',1.84),('15128','2013-10-30','10:30:00',1.8),('15128','2013-10-30','10:35:00',1.89),('15128','2013-10-30','10:40:00',1.94),('15128','2013-10-30','10:45:00',2.14),('15128','2013-10-30','10:50:00',2.05),('15128','2013-10-30','10:55:00',2.03),('15128','2013-10-30','11:00:00',1.9),('15128','2013-10-30','11:05:00',2.08),('15128','2013-10-30','11:10:00',2.33),('15128','2013-10-30','11:15:00',2.45),('15128','2013-10-30','11:20:00',2.26),('15128','2013-10-30','11:25:00',2.29),('15128','2013-10-30','11:30:00',2.33),('15128','2013-10-30','11:35:00',2.13),('15128','2013-10-30','11:40:00',1.98),('15128','2013-10-30','11:45:00',2.38),('15128','2013-10-30','11:50:00',2.4),('15128','2013-10-30','11:55:00',2.75),('15128','2013-10-30','12:00:00',2.8),('15128','2013-10-30','12:05:00',2.83),('15128','2013-10-30','12:10:00',2.84),('15128','2013-10-30','12:15:00',2.82),('15128','2013-10-30','12:20:00',2.8),('15128','2013-10-30','12:25:00',2.76),('15128','2013-10-30','12:30:00',2.76),('15128','2013-10-30','12:35:00',2.65),('15128','2013-10-30','12:40:00',2.61),('15128','2013-10-30','12:45:00',2.61),('15128','2013-10-30','12:50:00',2.7),('15128','2013-10-30','12:55:00',2.67),('15128','2013-10-30','13:00:00',2.67),('15128','2013-10-30','13:05:00',2.74),('15128','2013-10-30','13:10:00',2.71),('15128','2013-10-30','13:15:00',2.63),('15128','2013-10-30','13:20:00',2.64),('15128','2013-10-30','13:25:00',2.64),('15128','2013-10-30','13:30:00',2.59),('15128','2013-10-30','13:35:00',2.52),('15128','2013-10-30','13:40:00',2.47),('15128','2013-10-30','13:45:00',2.47),('15128','2013-10-30','13:50:00',2.41),('15128','2013-10-30','13:55:00',2.4),('15128','2013-10-30','14:00:00',2.34),('15128','2013-10-30','14:05:00',1.98),('15128','2013-10-30','14:10:00',2.23),('15128','2013-10-30','14:15:00',2.24),('15128','2013-10-30','14:20:00',2.21),('15128','2013-10-30','14:25:00',1.93),('15128','2013-10-30','14:30:00',1.88),('15128','2013-10-30','14:35:00',1.9),('15128','2013-10-30','14:40:00',1.79),('15128','2013-10-30','14:45:00',1.55),('15128','2013-10-30','14:50:00',1.59),('15128','2013-10-30','14:55:00',1.63),('15128','2013-10-30','15:00:00',1.57),('15128','2013-10-30','15:05:00',1.5),('15128','2013-10-30','15:10:00',1.42),('15128','2013-10-30','15:15:00',1.31),('15128','2013-10-30','15:20:00',1.21),('15128','2013-10-30','15:25:00',1.19),('15128','2013-10-30','15:30:00',1.03),('15128','2013-10-29','08:55:00',1.05),('15128','2013-10-29','09:00:00',1.11),('15128','2013-10-29','09:05:00',1.2),('15128','2013-10-29','09:10:00',1.24),('15128','2013-10-29','09:15:00',1.29),('15128','2013-10-29','09:20:00',1.35),('15128','2013-10-29','09:25:00',1.42),('15128','2013-10-29','09:30:00',1.38),('15128','2013-10-29','09:35:00',1.34),('15128','2013-10-29','09:40:00',1.38),('15128','2013-10-29','09:45:00',1.5),('15128','2013-10-29','09:50:00',1.52),('15128','2013-10-29','09:55:00',1.71),('15128','2013-10-29','10:00:00',1.64),('15128','2013-10-29','10:05:00',1.71),('15128','2013-10-29','10:10:00',1.85),('15128','2013-10-29','10:15:00',1.75),('15128','2013-10-29','10:20:00',1.96),('15128','2013-10-29','10:25:00',2.02),('15128','2013-10-29','10:30:00',2.18),('15128','2013-10-29','10:35:00',2.19),('15128','2013-10-29','10:40:00',2.08),('15128','2013-10-29','10:45:00',2.08),('15128','2013-10-29','10:50:00',2.13),('15128','2013-10-29','10:55:00',2.35),('15128','2013-10-29','11:00:00',2.46),('15128','2013-10-29','11:05:00',2.01),('15128','2013-10-29','11:10:00',1.82),('15128','2013-10-29','11:15:00',2.28),('15128','2013-10-29','11:20:00',1.11),('15128','2013-10-29','11:25:00',1.73),('15128','2013-10-29','11:30:00',1.21),('15128','2013-10-29','11:35:00',1.4),('15128','2013-10-29','11:40:00',1.64),('15128','2013-10-29','11:45:00',1.37),('15128','2013-10-29','11:50:00',1.37),('15128','2013-10-29','11:55:00',2.41),('15128','2013-10-29','12:00:00',2.72),('15128','2013-10-29','12:05:00',2.65),('15128','2013-10-29','12:10:00',1.85),('15128','2013-10-29','12:35:00',1.04),('15128','2013-10-29','12:40:00',1.43),('15128','2013-10-29','12:45:00',1.32),('15128','2013-10-29','12:50:00',2.31),('15128','2013-10-29','12:55:00',2.54),('15128','2013-10-29','13:00:00',2.08),('15128','2013-10-29','13:10:00',1.84),('15128','2013-10-29','13:15:00',2.58),('15128','2013-10-29','13:20:00',2.6),('15128','2013-10-29','13:25:00',2.04),('15128','2013-10-29','13:30:00',2.44),('15128','2013-10-29','13:35:00',2.78),('15128','2013-10-29','13:40:00',2.66),('15128','2013-10-29','13:45:00',2.49),('15128','2013-10-29','13:50:00',2.4),('15128','2013-10-29','13:55:00',2.36),('15128','2013-10-29','14:00:00',1.9),('15128','2013-10-29','14:55:00',1.65),('15128','2013-10-29','15:00:00',1.86),('15128','2013-10-29','15:05:00',1.53),('15128','2013-10-29','15:10:00',1.44),('15128','2013-10-29','15:15:00',1.59),('15128','2013-10-29','15:20:00',1.5),('15128','2013-10-29','15:45:00',1.02),('15128','2013-10-28','08:50:00',1.02),('15128','2013-10-28','08:55:00',1.07),('15128','2013-10-28','09:00:00',1.11),('15128','2013-10-28','09:05:00',1.19),('15128','2013-10-28','09:10:00',1.25),('15128','2013-10-28','09:15:00',1.32),('15128','2013-10-28','09:20:00',1.35),('15128','2013-10-28','09:25:00',1.42),('15128','2013-10-28','09:30:00',1.46),('15128','2013-10-28','09:35:00',1.49),('15128','2013-10-28','09:40:00',1.53),('15128','2013-10-28','09:45:00',1.55),('15128','2013-10-28','09:50:00',1.62),('15128','2013-10-28','09:55:00',1.74),('15128','2013-10-28','10:00:00',1.8),('15128','2013-10-28','10:05:00',1.88),('15128','2013-10-28','10:10:00',1.84),('15128','2013-10-28','10:15:00',1.16),('15128','2013-10-28','10:20:00',1.35),('15128','2013-10-28','10:25:00',1.18),('15128','2013-10-28','10:30:00',1.18),('15128','2013-10-28','10:35:00',1.84),('15128','2013-10-28','10:40:00',1.96),('15128','2013-10-28','10:50:00',1.52),('15128','2013-10-28','10:55:00',2.21),('15128','2013-10-28','11:00:00',2.71),('15128','2013-10-28','11:05:00',2.79),('15128','2013-10-28','11:10:00',1.64),('15128','2013-10-28','11:15:00',1.8),('15128','2013-10-28','11:20:00',1.88),('15128','2013-10-28','11:25:00',1.74),('15128','2013-10-28','11:30:00',1.95),('15128','2013-10-28','11:35:00',1.04),('15128','2013-10-28','11:40:00',2),('15128','2013-10-28','11:45:00',3.33),('15128','2013-10-28','11:50:00',3.34),('15128','2013-10-28','11:55:00',3.16),('15128','2013-10-28','12:00:00',3.1),('15128','2013-10-28','12:05:00',2.99),('15128','2013-10-28','12:10:00',2.83),('15128','2013-10-28','12:15:00',2.84),('15128','2013-10-28','12:20:00',2.82),('15128','2013-10-28','12:25:00',2.83),('15128','2013-10-28','12:30:00',2.86),('15128','2013-10-28','12:35:00',2.9),('15128','2013-10-28','12:40:00',2.82),('15128','2013-10-28','12:45:00',2.78),('15128','2013-10-28','12:50:00',2.78),('15128','2013-10-28','12:55:00',2.77),('15128','2013-10-28','13:00:00',2.73),('15128','2013-10-28','13:05:00',2.7),('15128','2013-10-28','13:10:00',1.89),('15128','2013-10-28','13:15:00',1.9),('15128','2013-10-28','13:20:00',2.57),('15128','2013-10-28','13:25:00',2.71),('15128','2013-10-28','13:30:00',2.72),('15128','2013-10-28','13:35:00',2.75),('15128','2013-10-28','13:40:00',1.96),('15128','2013-10-28','13:45:00',1.94),('15128','2013-10-28','13:50:00',1.73),('15128','2013-10-28','13:55:00',2.42),('15128','2013-10-28','14:00:00',2.39),('15128','2013-10-28','14:05:00',2.23),('15128','2013-10-28','14:10:00',2.29),('15128','2013-10-28','14:15:00',2.22),('15128','2013-10-28','14:20:00',2.23),('15128','2013-10-28','14:25:00',2.18),('15128','2013-10-28','14:30:00',2.11),('15128','2013-10-28','14:35:00',2.04),('15128','2013-10-28','14:40:00',1.99),('15128','2013-10-28','14:45:00',1.95),('15128','2013-10-28','14:50:00',1.9),('15128','2013-10-28','14:55:00',1.83),('15128','2013-10-28','15:00:00',1.74),('15128','2013-10-28','15:05:00',1.68),('15128','2013-10-28','15:10:00',1.6),('15128','2013-10-28','15:15:00',1.51),('15128','2013-10-28','15:20:00',1.44),('15128','2013-10-28','15:25:00',1.35),('15128','2013-10-28','15:30:00',1.26),('15128','2013-10-28','15:35:00',1.2),('15128','2013-10-28','15:40:00',1.11),('15128','2014-04-16','08:35:00',1.03),('15128','2014-04-16','08:40:00',1.09),('15128','2014-04-16','08:45:00',1.17),('15128','2014-04-16','08:50:00',1.25),('15128','2014-04-16','08:55:00',1.32),('15128','2014-04-16','09:00:00',1.41),('15128','2014-04-16','09:05:00',1.47),('15128','2014-04-16','09:10:00',1.54),('15128','2014-04-16','09:15:00',1.62),('15128','2014-04-16','09:20:00',1.71),('15128','2014-04-16','09:25:00',1.79),('15128','2014-04-16','09:30:00',1.87),('15128','2014-04-16','09:35:00',1.95),('15128','2014-04-16','09:40:00',2.02),('15128','2014-04-16','09:45:00',2.04),('15128','2014-04-16','09:50:00',2.11),('15128','2014-04-16','09:55:00',2.16),('15128','2014-04-16','10:00:00',2.28),('15128','2014-04-16','10:05:00',1.34),('15128','2014-04-16','10:10:00',1.46),('15128','2014-04-16','10:15:00',2.2),('15128','2014-04-16','10:20:00',1.41),('15128','2014-04-16','10:25:00',1.66),('15128','2014-04-16','10:30:00',1.7),('15128','2014-04-16','10:35:00',2.4),('15128','2014-04-16','10:40:00',2.34),('15128','2014-04-16','10:45:00',2.13),('15128','2014-04-16','10:50:00',2.06),('15128','2014-04-16','10:55:00',2.55),('15128','2014-04-16','11:00:00',2.1),('15128','2014-04-16','11:05:00',2.5),('15128','2014-04-16','11:10:00',2.22),('15128','2014-04-16','11:15:00',2.96),('15128','2014-04-16','11:20:00',2.54),('15128','2014-04-16','11:25:00',2.3),('15128','2014-04-16','11:30:00',3.2),('15128','2014-04-16','11:35:00',2.45),('15128','2014-04-16','11:40:00',3.74),('15128','2014-04-16','11:45:00',3.15),('15128','2014-04-16','11:50:00',2.8),('15128','2014-04-16','11:55:00',2.45),('15128','2014-04-16','12:00:00',2.58),('15128','2014-04-16','12:05:00',1.99),('15128','2014-04-16','12:10:00',2.33),('15128','2014-04-16','12:15:00',2.24),('15128','2014-04-16','12:20:00',2.87),('15128','2014-04-16','12:25:00',3.29),('15128','2014-04-16','12:30:00',3.87),('15128','2014-04-16','12:35:00',3.97),('15128','2014-04-16','12:40:00',4.05),('15128','2014-04-16','12:45:00',4.19),('15128','2014-04-16','12:50:00',4.27),('15128','2014-04-16','12:55:00',4.24),('15128','2014-04-16','13:00:00',4.25),('15128','2014-04-16','13:05:00',4.26),('15128','2014-04-16','13:10:00',4.27),('15128','2014-04-16','13:15:00',4.39),('15128','2014-04-16','13:20:00',4.44),('15128','2014-04-16','13:25:00',4.67),('15128','2014-04-16','13:30:00',4.52),('15128','2014-04-16','13:35:00',4.77),('15128','2014-04-16','13:40:00',4.76),('15128','2014-04-16','13:45:00',4.79),('15128','2014-04-16','13:50:00',4.88),('15128','2014-04-16','13:55:00',4.81),('15128','2014-04-16','14:00:00',3.74),('15128','2014-04-16','14:05:00',4.74),('15128','2014-04-16','14:10:00',4.79),('15128','2014-04-16','14:15:00',4.84),('15128','2014-04-16','14:20:00',3.19),('15128','2014-04-16','14:25:00',5.14),('15128','2014-04-16','14:30:00',4.9),('15128','2014-04-16','14:35:00',2.76),('15128','2014-04-16','14:40:00',3.92),('15128','2014-04-16','14:45:00',2),('15128','2014-04-16','14:50:00',1.13),('15128','2014-04-16','14:55:00',1.08),('15128','2014-04-16','15:00:00',1.11),('15128','2014-04-16','15:10:00',1.17),('15128','2014-04-16','15:15:00',1.53),('15128','2014-04-16','15:20:00',1.55),('15128','2014-04-16','15:25:00',1.29),('15128','2014-04-16','15:30:00',1.16),('15128','2014-04-16','15:35:00',1.04),('15128','2014-04-16','15:40:00',1.13),('15128','2014-04-16','15:45:00',1.26),('15128','2014-04-16','15:50:00',1.11),('15128','2014-04-16','16:25:00',1.01),('15128','2014-04-16','16:30:00',1.16),('15128','2014-04-16','16:35:00',1.2),('15128','2014-04-16','16:40:00',1.41),('15128','2014-04-16','16:45:00',1.82),('15128','2014-04-16','16:50:00',1.31),('15128','2014-04-16','16:55:00',1.23),('15128','2014-04-16','17:00:00',1.08),('15128','2014-04-16','17:15:00',1.11),('15128','2014-04-16','17:20:00',1.8),('15128','2014-04-16','17:25:00',1.61),('15128','2014-04-16','17:30:00',1.63),('15128','2014-04-16','17:35:00',1.56),('15128','2014-04-16','17:40:00',1.53),('15128','2014-04-16','17:45:00',1.09),('15128','2013-10-27','09:00:00',1.11),('15128','2013-10-27','09:05:00',1.16),('15128','2013-10-27','09:10:00',1.28),('15128','2013-10-27','09:15:00',1.33),('15128','2013-10-27','09:20:00',1.38),('15128','2013-10-27','09:25:00',1.49),('15128','2013-10-27','09:30:00',1.77),('15128','2013-10-27','09:35:00',2.05),('15128','2013-10-27','09:40:00',1.85),('15128','2013-10-27','09:45:00',1.07),('15128','2013-10-27','10:30:00',1.47),('15128','2013-10-27','10:35:00',2.13),('15128','2013-10-27','10:40:00',2.17),('15128','2013-10-27','10:45:00',2.23),('15128','2013-10-27','10:50:00',2.2),('15128','2013-10-27','10:55:00',2.33),('15128','2013-10-27','11:00:00',2.46),('15128','2013-10-27','11:05:00',2.49),('15128','2013-10-27','11:10:00',2.55),('15128','2013-10-27','11:15:00',2.58),('15128','2013-10-27','11:20:00',2.59),('15128','2013-10-27','11:25:00',2.61),('15128','2013-10-27','11:30:00',2.69),('15128','2013-10-27','11:35:00',2.64),('15128','2013-10-27','11:40:00',2.67),('15128','2013-10-27','11:45:00',2.7),('15128','2013-10-27','11:50:00',2.75),('15128','2013-10-27','11:55:00',2.78),('15128','2013-10-27','12:00:00',2.8),('15128','2013-10-27','12:05:00',3),('15128','2013-10-27','12:10:00',2.04),('15128','2013-10-27','12:15:00',2.27),('15128','2013-10-27','12:20:00',3.17),('15128','2013-10-27','12:25:00',2.88),('15128','2013-10-27','12:30:00',2.62),('15128','2013-10-27','12:35:00',3.08),('15128','2013-10-27','12:40:00',2.99),('15128','2013-10-27','12:45:00',2.86),('15128','2013-10-27','12:50:00',2.86),('15128','2013-10-27','12:55:00',2.87),('15128','2013-10-27','13:00:00',2.85),('15128','2013-10-27','13:05:00',2.84),('15128','2013-10-27','13:10:00',2.84),('15128','2013-10-27','13:15:00',2.82),('15128','2013-10-27','13:20:00',2.79),('15128','2013-10-27','13:25:00',2.77),('15128','2013-10-27','13:30:00',2.75),('15128','2013-10-27','13:35:00',2.74),('15128','2013-10-27','13:40:00',2.72),('15128','2013-10-27','13:45:00',2.66),('15128','2013-10-27','13:50:00',2.72),('15128','2013-10-27','13:55:00',2.68),('15128','2013-10-27','14:00:00',2.59),('15128','2013-10-27','14:05:00',2.1),('15128','2013-10-27','14:10:00',2.56),('15128','2013-10-27','14:15:00',2.5),('15128','2013-10-27','14:20:00',2.44),('15128','2013-10-27','14:25:00',2.32),('15128','2013-10-27','14:30:00',2.23),('15128','2013-10-27','14:35:00',2.23),('15128','2013-10-27','14:40:00',2.1),('15128','2013-10-27','14:45:00',2.15),('15128','2013-10-27','14:50:00',2.06),('15128','2013-10-27','14:55:00',1.95),('15128','2013-10-27','15:00:00',1.93),('15128','2013-10-27','15:05:00',1.84),('15128','2013-10-27','15:10:00',1.8),('15128','2013-10-27','15:15:00',1.71),('15128','2013-10-27','15:20:00',1.55),('15128','2013-10-27','15:25:00',1.31),('15128','2013-10-27','15:30:00',1.78),('15128','2013-10-27','15:35:00',1.08),('15128','2013-10-27','15:40:00',1.3),('15128','2013-10-27','15:45:00',1.2),('15128','2013-10-27','15:50:00',1.07),('15128','2013-10-26','09:55:00',1.03),('15128','2013-10-26','10:00:00',1.05),('15128','2013-10-26','10:05:00',1.04),('15128','2013-10-26','10:10:00',1.03),('15128','2013-10-26','10:15:00',1.15),('15128','2013-10-26','10:20:00',1.26),('15128','2013-10-26','10:25:00',1.34),('15128','2013-10-26','10:30:00',1.63),('15128','2013-10-26','10:35:00',1.47),('15128','2013-10-26','10:40:00',1.36),('15128','2013-10-26','10:45:00',1.24),('15128','2013-10-26','10:50:00',1.12),('15128','2013-10-26','10:55:00',1.11),('15128','2013-10-26','11:00:00',1.34),('15128','2013-10-26','11:05:00',1.46),('15128','2013-10-26','11:10:00',1.44),('15128','2013-10-26','11:15:00',1.42),('15128','2013-10-26','11:20:00',1.51),('15128','2013-10-26','11:25:00',1.51),('15128','2013-10-26','11:30:00',1.51),('15128','2013-10-26','11:35:00',1.6),('15128','2013-10-26','11:40:00',1.76),('15128','2013-10-26','11:45:00',2),('15128','2013-10-26','11:50:00',2.28),('15128','2013-10-26','11:55:00',1.89),('15128','2013-10-26','12:00:00',2.42),('15128','2013-10-26','12:05:00',2.15),('15128','2013-10-26','12:10:00',2.69),('15128','2013-10-26','12:15:00',3.5),('15128','2013-10-26','12:20:00',2.3),('15128','2013-10-26','12:25:00',3.22),('15128','2013-10-26','12:30:00',1.55),('15128','2013-10-26','12:35:00',1.68),('15128','2013-10-26','12:40:00',1.01),('15128','2013-10-26','12:45:00',2.38),('15128','2013-10-26','12:50:00',3.19),('15128','2013-10-26','12:55:00',2.05),('15128','2013-10-26','13:00:00',1.9),('15128','2013-10-26','13:05:00',2.88),('15128','2013-10-26','13:10:00',1.76),('15128','2013-10-26','13:15:00',2.34),('15128','2013-10-26','13:20:00',1.79),('15128','2013-10-26','13:25:00',1.06),('15128','2013-10-26','14:00:00',1.21),('15128','2013-10-26','14:15:00',1.99),('15128','2013-10-26','14:20:00',2.31),('15128','2013-10-26','14:25:00',2.27),('15128','2013-10-26','14:30:00',2.01),('15128','2013-10-26','14:35:00',2.21),('15128','2013-10-26','14:40:00',1.72),('15128','2013-10-26','14:45:00',1.64),('15128','2013-10-26','14:50:00',1.64),('15128','2013-10-26','14:55:00',1.91),('15128','2013-10-26','15:00:00',1.88),('15128','2013-10-26','15:05:00',1.95),('15128','2013-10-26','15:10:00',1.85),('15128','2013-10-26','15:15:00',1.85),('15128','2013-10-26','15:20:00',1.78),('15128','2013-10-26','15:25:00',1.53),('15128','2013-10-26','15:30:00',1.14),('15128','2013-10-26','15:40:00',1),('15128','2013-10-26','15:45:00',1.11),('15128','2013-10-26','15:50:00',1.03),('15128','2013-10-25','09:50:00',1.04),('15128','2013-10-25','09:55:00',1.11),('15128','2013-10-25','10:00:00',1.17),('15128','2013-10-25','10:05:00',1.22),('15128','2013-10-25','10:11:00',1.27),('15128','2013-10-25','10:15:00',1.35),('15128','2013-10-25','10:20:00',1.38),('15128','2013-10-25','10:25:00',1.42),('15128','2013-10-25','10:30:00',1.49),('15128','2013-10-25','10:35:00',1.52),('15128','2013-10-25','10:40:00',1.55),('15128','2013-10-25','10:45:00',1.61),('15128','2013-10-25','10:50:00',1.67),('15128','2013-10-25','10:55:00',1.75),('15128','2013-10-25','11:00:00',1.76),('15128','2013-10-25','11:05:00',1.81),('15128','2013-10-25','11:10:00',1.87),('15128','2013-10-25','11:15:00',1.92),('15128','2013-10-25','11:20:00',1.98),('15128','2013-10-25','11:25:00',2.03),('15128','2013-10-25','11:30:00',2.02),('15128','2013-10-25','11:35:00',2.07),('15128','2013-10-25','11:40:00',2.15),('15128','2013-10-25','11:45:00',2.19),('15128','2013-10-25','11:50:00',2.23),('15128','2013-10-25','11:55:00',2.35),('15128','2013-10-25','12:00:00',2.44),('15128','2013-10-25','12:05:00',2.48),('15128','2013-10-25','12:10:00',2.5),('15128','2013-10-25','12:15:00',2.51),('15128','2013-10-25','12:20:00',2.51),('15128','2013-10-25','12:25:00',2.59),('15128','2013-10-25','12:30:00',2.63),('15128','2013-10-25','12:35:00',2.66),('15128','2013-10-25','12:40:00',2.69),('15128','2013-10-25','12:45:00',2.7),('15128','2013-10-25','12:50:00',2.69),('15128','2013-10-25','12:55:00',2.72),('15128','2013-10-25','13:00:00',2.74),('15128','2013-10-25','13:05:00',2.74),('15128','2013-10-25','13:10:00',2.68),('15128','2013-10-25','13:15:00',2.77),('15128','2013-10-25','13:20:00',2.79),('15128','2013-10-25','13:25:00',2.75),('15128','2013-10-25','13:30:00',2.77),('15128','2013-10-25','13:35:00',2.77),('15128','2013-10-25','13:40:00',2.8),('15128','2013-10-25','13:45:00',2.71),('15128','2013-10-25','13:50:00',2.75),('15128','2013-10-25','13:55:00',2.71),('15128','2013-10-25','14:00:00',2.7),('15128','2013-10-25','14:05:00',2.69),('15128','2013-10-25','14:10:00',2.65),('15128','2013-10-25','14:15:00',2.67),('15128','2013-10-25','14:20:00',2.6),('15128','2013-10-25','14:25:00',2.55),('15128','2013-10-25','14:30:00',2.6),('15128','2013-10-25','14:35:00',2.5),('15128','2013-10-25','14:42:00',2.5),('15128','2013-10-25','14:45:00',2.47),('15128','2013-10-25','14:50:00',2.34),('15128','2013-10-25','14:55:00',2.45),('15128','2013-10-25','15:00:00',2.38),('15128','2013-10-25','15:05:00',2.3),('15128','2013-10-25','15:10:00',1.49),('15128','2013-10-25','15:15:00',2.18),('15128','2013-10-25','15:20:00',1.92),('15128','2013-10-25','15:25:00',2.12),('15128','2013-10-25','15:30:00',1.89),('15128','2013-10-25','15:35:00',1.96),('15128','2013-10-25','15:40:00',1.98),('15128','2013-10-25','15:45:00',1.9),('15128','2013-10-25','15:50:00',1.85),('15128','2013-10-25','15:55:00',1.79),('15128','2013-10-25','16:00:00',1.73),('15128','2013-10-25','16:05:00',1.64),('15128','2013-10-25','16:10:00',1.5),('15128','2013-10-25','16:15:00',1.47),('15128','2013-10-25','16:20:00',1.42),('15128','2013-10-25','16:25:00',1.34),('15128','2013-10-25','16:30:00',1.27),('15128','2013-10-25','16:35:00',1.16),('15128','2013-10-25','16:40:00',1.08),('15128','2013-10-25','16:45:00',1.03),('15128','2013-10-24','09:45:00',1),('15128','2013-10-24','09:50:00',1.07),('15128','2013-10-24','09:55:00',1.12),('15128','2013-10-24','10:00:00',1.18),('15128','2013-10-24','10:05:00',1.25),('15128','2013-10-24','10:10:00',1.31),('15128','2013-10-24','10:15:00',1.36),('15128','2013-10-24','10:20:00',1.41),('15128','2013-10-24','10:25:00',1.44),('15128','2013-10-24','10:30:00',1.51),('15128','2013-10-24','10:35:00',1.54),('15128','2013-10-24','10:40:00',1.57),('15128','2013-10-24','10:45:00',1.63),('15128','2013-10-24','10:50:00',1.67),('15128','2013-10-24','10:55:00',1.76),('15128','2013-10-24','11:00:00',1.82),('15128','2013-10-24','11:05:00',1.83),('15128','2013-10-24','11:10:00',1.91),('15128','2013-10-24','11:15:00',1.92),('15128','2013-10-24','11:20:00',2.02),('15128','2013-10-24','11:25:00',2.04),('15128','2013-10-24','11:30:00',2.09),('15128','2013-10-24','11:35:00',2.12),('15128','2013-10-24','11:40:00',2.15),('15128','2013-10-24','11:45:00',2.23),('15128','2013-10-24','11:50:00',2.27),('15128','2013-10-24','11:55:00',2.45),('15128','2013-10-24','12:00:00',2.52),('15128','2013-10-24','12:05:00',2.6),('15128','2013-10-24','12:10:00',2.6),('15128','2013-10-24','12:15:00',2.63),('15128','2013-10-24','12:20:00',2.64),('15128','2013-10-24','12:25:00',2.68),('15128','2013-10-24','12:30:00',2.72),('15128','2013-10-24','12:35:00',2.79),('15128','2013-10-24','12:40:00',2.8),('15128','2013-10-24','12:45:00',2.82),('15128','2013-10-24','12:50:00',2.85),('15128','2013-10-24','12:55:00',2.85),('15128','2013-10-24','13:00:00',2.87),('15128','2013-10-24','13:05:00',2.89),('15128','2013-10-24','13:10:00',2.88),('15128','2013-10-24','13:15:00',2.88),('15128','2013-10-24','13:20:00',2.89),('15128','2013-10-24','13:25:00',2.88),('15128','2013-10-24','13:30:00',2.88),('15128','2013-10-24','13:35:00',2.87),('15128','2013-10-24','13:40:00',2.85),('15128','2013-10-24','13:45:00',2.85),('15128','2013-10-24','13:50:00',2.83),('15128','2013-10-24','13:55:00',2.78),('15128','2013-10-24','14:00:00',2.78),('15128','2013-10-24','14:05:00',2.8),('15128','2013-10-24','14:10:00',2.83),('15128','2013-10-24','14:15:00',2.78),('15128','2013-10-24','14:20:00',2.74),('15128','2013-10-24','14:25:00',2.75),('15128','2013-10-24','14:30:00',2.74),('15128','2013-10-24','14:35:00',2.71),('15128','2013-10-24','14:40:00',2.63),('15128','2013-10-24','14:45:00',2.59),('15128','2013-10-24','14:50:00',2.58),('15128','2013-10-24','14:55:00',2.56),('15128','2013-10-24','15:00:00',2.51),('15128','2013-10-24','15:05:00',2.47),('15128','2013-10-24','15:10:00',2.41),('15128','2013-10-24','15:15:00',2.37),('15128','2013-10-24','15:20:00',2.36),('15128','2013-10-24','15:25:00',2.22),('15128','2013-10-24','15:30:00',2.19),('15128','2013-10-24','15:35:00',2.2),('15128','2013-10-24','15:40:00',2.14),('15128','2013-10-24','15:45:00',2.08),('15128','2013-10-24','15:50:00',2.02),('15128','2013-10-24','15:55:00',1.96),('15128','2013-10-24','16:00:00',1.91),('15128','2013-10-24','16:05:00',1.83),('15128','2013-10-24','16:10:00',1.76),('15128','2013-10-24','16:15:00',1.71),('15128','2013-10-24','16:20:00',1.63),('15128','2013-10-24','16:25:00',1.57),('15128','2013-10-24','16:30:00',1.49),('15128','2013-10-24','16:35:00',1.39),('15128','2013-10-24','16:40:00',1.3),('15128','2013-10-24','16:45:00',1.22),('15128','2013-10-24','16:50:00',1.11),('15128','2013-10-24','16:55:00',1.02),('15128','2013-10-23','09:45:00',1),('15128','2013-10-23','10:25:00',1.17),('15128','2013-10-23','10:30:00',1.73),('15128','2013-10-23','10:35:00',2.62),('15128','2013-10-23','10:40:00',2.33),('15128','2013-10-23','10:45:00',2.54),('15128','2013-10-23','10:50:00',2.12),('15128','2013-10-23','10:55:00',1.53),('15128','2013-10-23','11:00:00',1.34),('15128','2013-10-23','11:05:00',1.47),('15128','2013-10-23','11:10:00',1.26),('15128','2013-10-23','11:15:00',1.33),('15128','2013-10-23','11:20:00',1.21),('15128','2013-10-23','11:25:00',1.1),('15128','2013-10-23','11:30:00',1.65),('15128','2013-10-23','11:35:00',2.69),('15128','2013-10-23','11:40:00',3.07),('15128','2013-10-23','11:45:00',2.69),('15128','2013-10-23','11:50:00',2.62),('15128','2013-10-23','11:55:00',1.51),('15128','2013-10-23','12:00:00',1.32),('15128','2013-10-23','12:05:00',1.38),('15128','2013-10-23','12:10:00',1.49),('15128','2013-10-23','12:15:00',1.66),('15128','2013-10-23','12:20:00',1.89),('15128','2013-10-23','12:25:00',1.9),('15128','2013-10-23','12:30:00',1.89),('15128','2013-10-23','12:35:00',1.62),('15128','2013-10-23','12:40:00',1.63),('15128','2013-10-23','12:45:00',1.67),('15128','2013-10-23','12:50:00',1.5),('15128','2013-10-23','12:55:00',1.42),('15128','2013-10-23','13:00:00',1.35),('15128','2013-10-23','13:05:00',1.28),('15128','2013-10-23','13:10:00',1.25),('15128','2013-10-23','13:15:00',1.25),('15128','2013-10-23','13:20:00',1.23),('15128','2013-10-23','13:25:00',1.24),('15128','2013-10-23','13:30:00',1.26),('15128','2013-10-23','13:35:00',1.28),('15128','2013-10-23','13:40:00',1.28),('15128','2013-10-23','13:45:00',1.67),('15128','2013-10-23','13:50:00',2.07),('15128','2013-10-23','13:55:00',1.26),('15128','2013-10-23','14:00:00',1.32),('15128','2013-10-23','14:05:00',1.45),('15128','2013-10-23','14:10:00',1.35),('15128','2013-10-23','14:15:00',1.36),('15128','2013-10-23','14:20:00',1.42),('15128','2013-10-23','14:25:00',1.52),('15128','2013-10-23','14:30:00',2.12),('15128','2013-10-23','14:35:00',2.56),('15128','2013-10-23','14:40:00',2.22),('15128','2013-10-23','14:45:00',1.05),('15128','2013-10-23','14:55:00',1.39),('15128','2013-10-23','15:00:00',1.8),('15128','2013-10-23','15:05:00',1.38),('15128','2013-10-23','15:10:00',1.09),('15128','2013-10-23','15:15:00',1.05),('15128','2013-10-23','15:20:00',1.26),('15128','2013-10-23','15:25:00',1.3),('15128','2013-10-23','15:30:00',1.87),('15128','2013-10-23','15:35:00',2.82),('15128','2013-10-23','15:40:00',2.41),('15128','2013-10-23','15:45:00',2.25),('15128','2013-10-23','15:50:00',1.05),('15128','2013-10-22','10:30:00',1.13),('15128','2013-10-22','10:35:00',1.12),('15128','2013-10-22','10:40:00',1.23),('15128','2013-10-22','10:45:00',1.1),('15128','2013-10-22','10:50:00',1.25),('15128','2013-10-22','10:55:00',2.18),('15128','2013-10-22','11:00:00',2.13),('15128','2013-10-22','11:05:00',2.14),('15128','2013-10-22','11:10:00',2.03),('15128','2013-10-22','11:15:00',2.12),('15128','2013-10-22','11:20:00',2.23),('15128','2013-10-22','11:25:00',2.13),('15128','2013-10-22','11:30:00',2.2),('15128','2013-10-22','11:35:00',2),('15128','2013-10-22','11:40:00',1.99),('15128','2013-10-22','11:45:00',2.27),('15128','2013-10-22','11:50:00',2.91),('15128','2013-10-22','11:55:00',2.06),('15128','2013-10-22','12:00:00',2.82),('15128','2013-10-22','12:05:00',2.77),('15128','2013-10-22','12:10:00',1.96),('15128','2013-10-22','12:15:00',2.46),('15128','2013-10-22','12:20:00',2.65),('15128','2013-10-22','12:25:00',2.57),('15128','2013-10-22','12:30:00',2.4),('15128','2013-10-22','12:35:00',2.57),('15128','2013-10-22','12:40:00',2.73),('15128','2013-10-22','12:45:00',2.75),('15128','2013-10-22','12:50:00',2.78),('15128','2013-10-22','12:55:00',2.7),('15128','2013-10-22','13:00:00',2.75),('15128','2013-10-22','13:05:00',2.8),('15128','2013-10-22','13:10:00',2.78),('15128','2013-10-22','13:15:00',2.8),('15128','2013-10-22','13:20:00',2.79),('15128','2013-10-22','13:25:00',2.79),('15128','2013-10-22','13:30:00',2.77),('15128','2013-10-22','13:35:00',2.75),('15128','2013-10-22','13:40:00',2.79),('15128','2013-10-22','13:45:00',2.79),('15128','2013-10-22','13:50:00',2.74),('15128','2013-10-22','13:55:00',2.71),('15128','2013-10-22','14:00:00',2.77),('15128','2013-10-22','14:05:00',2.72),('15128','2013-10-22','14:10:00',2.66),('15128','2013-10-22','14:15:00',2.68),('15128','2013-10-22','14:20:00',2.49),('15128','2013-10-22','14:25:00',2.53),('15128','2013-10-22','14:30:00',2.5),('15128','2013-10-22','14:35:00',2.54),('15128','2013-10-22','14:40:00',2.5),('15128','2013-10-22','14:45:00',2.43),('15128','2013-10-22','14:50:00',2.42),('15128','2013-10-22','14:55:00',2.31),('15128','2013-10-22','15:00:00',2.26),('15128','2013-10-22','15:05:00',2.18),('15128','2013-10-22','15:10:00',1.94),('15128','2013-10-22','15:15:00',1.49),('15128','2013-10-22','15:20:00',1.47),('15128','2013-10-22','15:25:00',1.31),('15128','2013-10-22','15:30:00',1.2),('15128','2013-10-22','15:35:00',1.56),('15128','2013-10-22','15:40:00',1.65),('15128','2013-10-22','15:45:00',1.28),('15128','2013-10-22','16:10:00',1.07),('15128','2013-10-22','16:15:00',1.16),('15128','2013-10-22','16:20:00',1.29),('15128','2013-10-22','16:25:00',1.27),('15128','2013-10-22','16:30:00',1.39),('15128','2013-10-22','16:35:00',1.41),('15128','2013-10-22','16:40:00',1.25),('15128','2013-10-21','09:45:00',1.05),('15128','2013-10-21','09:50:00',1.11),('15128','2013-10-21','09:55:00',1.16),('15128','2013-10-21','10:00:00',1.23),('15128','2013-10-21','10:05:00',1.29),('15128','2013-10-21','10:10:00',1.35),('15128','2013-10-21','10:15:00',1.4),('15128','2013-10-21','10:20:00',1.46),('15128','2013-10-21','10:25:00',1.51),('15128','2013-10-21','10:30:00',1.56),('15128','2013-10-21','10:35:00',1.62),('15128','2013-10-21','10:40:00',1.64),('15128','2013-10-21','10:45:00',1.67),('15128','2013-10-21','10:50:00',1.72),('15128','2013-10-21','10:55:00',1.78),('15128','2013-10-21','11:00:00',1.81),('15128','2013-10-21','11:05:00',1.86),('15128','2013-10-21','11:10:00',1.87),('15128','2013-10-21','11:15:00',1.93),('15128','2013-10-21','11:20:00',2.02),('15128','2013-10-21','11:25:00',2.04),('15128','2013-10-21','11:30:00',2.05),('15128','2013-10-21','11:35:00',2.09),('15128','2013-10-21','11:40:00',2.14),('15128','2013-10-21','11:45:00',2.26),('15128','2013-10-21','11:50:00',2.3),('15128','2013-10-21','11:55:00',2.4),('15128','2013-10-21','12:00:00',2.5),('15128','2013-10-21','12:05:00',2.53),('15128','2013-10-21','12:10:00',2.54),('15128','2013-10-21','12:15:00',2.56),('15128','2013-10-21','12:20:00',2.6),('15128','2013-10-21','12:25:00',2.61),('15128','2013-10-21','12:30:00',2.5),('15128','2013-10-21','12:35:00',2.67),('15128','2013-10-21','12:40:00',2.77),('15128','2013-10-21','12:45:00',2.76),('15128','2013-10-21','12:50:00',2.8),('15128','2013-10-21','12:55:00',2.77),('15128','2013-10-21','13:00:00',2.68),('15128','2013-10-21','13:05:00',2.65),('15128','2013-10-21','13:10:00',2.74),('15128','2013-10-21','13:15:00',2.68),('15128','2013-10-21','13:20:00',2.71),('15128','2013-10-21','13:25:00',2.78),('15128','2013-10-21','13:30:00',2.75),('15128','2013-10-21','13:35:00',2.85),('15128','2013-10-21','13:40:00',2.93),('15128','2013-10-21','13:45:00',2.94),('15128','2013-10-21','13:50:00',3.05),('15128','2013-10-21','13:55:00',3.03),('15128','2013-10-21','14:00:00',3.04),('15128','2013-10-21','14:05:00',3.08),('15128','2013-10-21','14:10:00',2.96),('15128','2013-10-21','14:15:00',2.71),('15128','2013-10-21','14:20:00',2.72),('15128','2013-10-21','14:25:00',2.25),('15128','2013-10-21','14:30:00',2.53),('15128','2013-10-21','14:35:00',2.12),('15128','2013-10-21','14:40:00',2.56),('15128','2013-10-21','14:45:00',2.52),('15128','2013-10-21','14:50:00',2.57),('15128','2013-10-21','14:55:00',2.53),('15128','2013-10-21','15:00:00',2.46),('15128','2013-10-21','15:05:00',2.42),('15128','2013-10-21','15:10:00',2.33),('15128','2013-10-21','15:15:00',2.18),('15128','2013-10-21','15:20:00',2.25),('15128','2013-10-21','15:25:00',2.25),('15128','2013-10-21','15:30:00',2.08),('15128','2013-10-21','15:35:00',2.09),('15128','2013-10-21','15:40:00',2.05),('15128','2013-10-21','15:45:00',1.98),('15128','2013-10-21','15:50:00',1.9),('15128','2013-10-21','15:55:00',1.86),('15128','2013-10-21','16:00:00',1.83),('15128','2013-10-21','16:05:00',1.72),('15128','2013-10-21','16:10:00',1.66),('15128','2013-10-21','16:15:00',1.55),('15128','2013-10-21','16:20:00',1.48),('15128','2013-10-21','16:25:00',1.42),('15128','2013-10-21','16:30:00',1.35),('15128','2013-10-21','16:35:00',1.3),('15128','2013-10-21','16:40:00',1.23),('15128','2013-10-21','16:45:00',1.14),('15128','2013-10-21','16:50:00',1.06),('15128','2013-10-20','09:45:00',1.04),('15128','2013-10-20','09:50:00',1.15),('15128','2013-10-20','09:55:00',1.26),('15128','2013-10-20','10:00:00',1.34),('15128','2013-10-20','10:05:00',1.3),('15128','2013-10-20','10:10:00',1.36),('15128','2013-10-20','10:15:00',1.29),('15128','2013-10-20','10:20:00',1.61),('15128','2013-10-20','10:25:00',1.65),('15128','2013-10-20','10:30:00',1.64),('15128','2013-10-20','10:35:00',1.69),('15128','2013-10-20','10:40:00',1.75),('15128','2013-10-20','10:45:00',1.79),('15128','2013-10-20','10:50:00',1.85),('15128','2013-10-20','10:55:00',1.74),('15128','2013-10-20','11:00:00',1.88),('15128','2013-10-20','11:05:00',2.02),('15128','2013-10-20','11:10:00',2.06),('15128','2013-10-20','11:15:00',2.04),('15128','2013-10-20','11:20:00',2.09),('15128','2013-10-20','11:25:00',2.15),('15128','2013-10-20','11:30:00',2.18),('15128','2013-10-20','11:35:00',2.15),('15128','2013-10-20','11:40:00',2.23),('15128','2013-10-20','11:45:00',2.35),('15128','2013-10-20','11:50:00',2.43),('15128','2013-10-20','11:55:00',2.52),('15128','2013-10-20','12:00:00',2.64),('15128','2013-10-20','12:05:00',2.65),('15128','2013-10-20','12:10:00',2.66),('15128','2013-10-20','12:15:00',2.66),('15128','2013-10-20','12:20:00',2.68),('15128','2013-10-20','12:25:00',2.65),('15128','2013-10-20','12:30:00',2.74),('15128','2013-10-20','12:35:00',2.75),('15128','2013-10-20','12:40:00',2.81),('15128','2013-10-20','12:45:00',2.85),('15128','2013-10-20','12:50:00',2.84),('15128','2013-10-20','12:55:00',2.81),('15128','2013-10-20','13:00:00',2.77),('15128','2013-10-20','13:05:00',2.69),('15128','2013-10-20','13:10:00',2.84),('15128','2013-10-20','13:15:00',2.74),('15128','2013-10-20','13:20:00',2.72),('15128','2013-10-20','13:25:00',2.81),('15128','2013-10-20','13:30:00',2.85),('15128','2013-10-20','13:35:00',2.88),('15128','2013-10-20','13:40:00',2.84),('15128','2013-10-20','13:45:00',2.78),('15128','2013-10-20','13:50:00',2.78),('15128','2013-10-20','13:55:00',2.64),('15128','2013-10-20','14:00:00',2.83),('15128','2013-10-20','14:05:00',2.88),('15128','2013-10-20','14:10:00',2.87),('15128','2013-10-20','14:15:00',2.84),('15128','2013-10-20','14:20:00',2.79),('15128','2013-10-20','14:25:00',2.77),('15128','2013-10-20','14:30:00',2.74),('15128','2013-10-20','14:35:00',2.7),('15128','2013-10-20','14:40:00',2.65),('15128','2013-10-20','14:45:00',2.6),('15128','2013-10-20','14:50:00',2.6),('15128','2013-10-20','14:55:00',2.51),('15128','2013-10-20','15:00:00',2.48),('15128','2013-10-20','15:05:00',2.41),('15128','2013-10-20','15:10:00',2.3),('15128','2013-10-20','15:15:00',2.35),('15128','2013-10-20','15:20:00',2.37),('15128','2013-10-20','15:25:00',2.35),('15128','2013-10-20','15:30:00',2.31),('15128','2013-10-20','15:35:00',2.24),('15128','2013-10-20','15:40:00',2.17),('15128','2013-10-20','15:45:00',2.11),('15128','2013-10-20','15:50:00',2.05),('15128','2013-10-20','15:55:00',1.96),('15128','2013-10-20','16:00:00',1.92),('15128','2013-10-20','16:05:00',1.85),('15128','2013-10-20','16:10:00',1.81),('15128','2013-10-20','16:15:00',1.7),('15128','2013-10-20','16:20:00',1.57),('15128','2013-10-20','16:25:00',1.45),('15128','2013-10-20','16:30:00',1.42),('15128','2013-10-20','16:35:00',1.38),('15128','2013-10-20','16:40:00',1.37),('15128','2013-10-20','16:45:00',1.27),('15128','2013-10-20','16:50:00',1.04),('15128','2013-10-19','09:40:00',1.05),('15128','2013-10-19','09:45:00',1.11),('15128','2013-10-19','09:50:00',1.17),('15128','2013-10-19','09:55:00',1.25),('15128','2013-10-19','10:00:00',1.3),('15128','2013-10-19','10:05:00',1.37),('15128','2013-10-19','10:10:00',1.42),('15128','2013-10-19','10:15:00',1.42),('15128','2013-10-19','10:20:00',1.49),('15128','2013-10-19','10:25:00',1.56),('15128','2013-10-19','10:30:00',1.59),('15128','2013-10-19','10:35:00',1.64),('15128','2013-10-19','10:40:00',1.71),('15128','2013-10-19','10:45:00',1.77),('15128','2013-10-19','10:50:00',1.82),('15128','2013-10-19','10:55:00',1.88),('15128','2013-10-19','11:00:00',1.92),('15128','2013-10-19','11:05:00',1.98),('15128','2013-10-19','11:10:00',2),('15128','2013-10-19','11:15:00',2.05),('15128','2013-10-19','11:20:00',2.13),('15128','2013-10-19','11:25:00',2.2),('15128','2013-10-19','11:30:00',2.22),('15128','2013-10-19','11:35:00',2.29),('15128','2013-10-19','11:40:00',2.29),('15128','2013-10-19','11:45:00',2.37),('15128','2013-10-19','11:50:00',2.43),('15128','2013-10-19','11:55:00',2.56),('15128','2013-10-19','12:00:00',2.62),('15128','2013-10-19','12:05:00',2.53),('15128','2013-10-19','12:10:00',2.69),('15128','2013-10-19','12:15:00',2.66),('15128','2013-10-19','12:20:00',2.86),('15128','2013-10-19','12:25:00',2.91),('15128','2013-10-19','12:30:00',2.88),('15128','2013-10-19','12:35:00',2.88),('15128','2013-10-19','12:40:00',2),('15128','2013-10-19','12:45:00',2.21),('15128','2013-10-19','12:50:00',3),('15128','2013-10-19','12:55:00',1.39),('15128','2013-10-19','13:00:00',1.31),('15128','2013-10-19','13:05:00',1.89),('15128','2013-10-19','13:10:00',3.65),('15128','2013-10-19','13:15:00',3.65),('15128','2013-10-19','13:20:00',3.27),('15128','2013-10-19','13:25:00',2.71),('15128','2013-10-19','13:30:00',3.24),('15128','2013-10-19','13:35:00',3.21),('15128','2013-10-19','13:40:00',3.19),('15128','2013-10-19','13:45:00',3.33),('15128','2013-10-19','13:50:00',3.07),('15128','2013-10-19','13:55:00',3.26),('15128','2013-10-19','14:00:00',3.39),('15128','2013-10-19','14:05:00',3.34),('15128','2013-10-19','14:10:00',3.29),('15128','2013-10-19','14:15:00',3.3),('15128','2013-10-19','14:20:00',3.41),('15128','2013-10-19','14:25:00',3.27),('15128','2013-10-19','14:30:00',3.1),('15128','2013-10-19','14:35:00',3.03),('15128','2013-10-19','14:40:00',2.97),('15128','2013-10-19','14:45:00',2.9),('15128','2013-10-19','14:50:00',2.85),('15128','2013-10-19','14:55:00',2.81),('15128','2013-10-19','15:00:00',2.2),('15128','2013-10-19','15:05:00',2.73),('15128','2013-10-19','15:10:00',2.7),('15128','2013-10-19','15:15:00',2.62),('15128','2013-10-19','15:20:00',2.63),('15128','2013-10-19','15:25:00',2.64),('15128','2013-10-19','15:30:00',2.61),('15128','2013-10-19','15:35:00',2.61),('15128','2013-10-19','15:40:00',2.63),('15128','2013-10-19','15:45:00',2.2),('15128','2013-10-19','15:50:00',2.65),('15128','2013-10-19','15:55:00',2.16),('15128','2013-10-19','16:00:00',1.34),('15128','2013-10-19','16:05:00',2.19),('15128','2013-10-19','16:10:00',2.43),('15128','2013-10-19','16:15:00',2.24),('15128','2013-10-19','16:20:00',2.05),('15128','2013-10-19','16:25:00',1.85),('15128','2013-10-19','16:30:00',1.83),('15128','2013-10-19','16:35:00',1.67),('15128','2013-10-19','16:40:00',1.55),('15128','2013-10-19','16:45:00',1.42),('15128','2013-10-19','16:50:00',1.35),('15128','2013-10-19','16:55:00',1.23),('15128','2013-10-19','17:00:00',1.11),('15128','2013-10-18','09:30:00',1.13),('15128','2013-10-18','09:35:00',1.34),('15128','2013-10-18','09:40:00',1.44),('15128','2013-10-18','09:45:00',1.37),('15128','2013-10-18','09:50:00',1.5),('15128','2013-10-18','09:55:00',1.53),('15128','2013-10-18','10:00:00',1.52),('15128','2013-10-18','10:05:00',1.55),('15128','2013-10-18','10:10:00',1.56),('15128','2013-10-18','10:15:00',1.64),('15128','2013-10-18','10:20:00',1.68),('15128','2013-10-18','10:25:00',1.79),('15128','2013-10-18','10:30:00',1.81),('15128','2013-10-18','10:35:00',1.83),('15128','2013-10-18','10:40:00',1.86),('15128','2013-10-18','10:45:00',1.87),('15128','2013-10-18','10:50:00',1.84),('15128','2013-10-18','10:55:00',1.85),('15128','2013-10-18','11:00:00',1.7),('15128','2013-10-18','11:05:00',1.71),('15128','2013-10-18','11:10:00',1.9),('15128','2013-10-18','11:15:00',2.23),('15128','2013-10-18','11:20:00',2.31),('15128','2013-10-18','11:25:00',2.38),('15128','2013-10-18','11:30:00',2.36),('15128','2013-10-18','11:35:00',2.35),('15128','2013-10-18','11:40:00',2.47),('15128','2013-10-18','11:45:00',2.42),('15128','2013-10-18','11:50:00',2.51),('15128','2013-10-18','11:55:00',2.8),('15128','2013-10-18','12:00:00',2.93),('15128','2013-10-18','12:05:00',2.97),('15128','2013-10-18','12:10:00',3.03),('15128','2013-10-18','12:15:00',2.79),('15128','2013-10-18','12:20:00',2.98),('15128','2013-10-18','12:25:00',3.2),('15128','2013-10-18','12:30:00',3.21),('15128','2013-10-18','12:35:00',2.71),('15128','2013-10-18','12:40:00',3.72),('15128','2013-10-18','12:45:00',3.72),('15128','2013-10-18','12:50:00',3.74),('15128','2013-10-18','12:55:00',2.89),('15128','2013-10-18','13:00:00',3.48),('15128','2013-10-18','13:05:00',3.11),('15128','2013-10-18','13:10:00',2.81),('15128','2013-10-18','13:15:00',2.71),('15128','2013-10-18','13:20:00',2.74),('15128','2013-10-18','13:25:00',2.31),('15128','2013-10-18','13:30:00',2.58),('15128','2013-10-18','13:35:00',2.73),('15128','2013-10-18','13:40:00',3.21),('15128','2013-10-18','13:45:00',3.66),('15128','2013-10-18','13:50:00',3.11),('15128','2013-10-18','13:55:00',2.59),('15128','2013-10-18','14:00:00',2.7),('15128','2013-10-18','14:05:00',2.67),('15128','2013-10-18','14:10:00',2.69),('15128','2013-10-18','14:15:00',2.33),('15128','2013-10-18','14:20:00',3.23),('15128','2013-10-18','14:25:00',3.01),('15128','2013-10-18','14:30:00',3.05),('15128','2013-10-18','14:35:00',3.05),('15128','2013-10-18','14:40:00',2.97),('15128','2013-10-18','14:45:00',2.89),('15128','2013-10-18','14:50:00',2.88),('15128','2013-10-18','14:55:00',2.77),('15128','2013-10-18','15:00:00',2.78),('15128','2013-10-18','15:05:00',2.72),('15128','2013-10-18','15:10:00',2.57),('15128','2013-10-18','15:15:00',2.59),('15128','2013-10-18','15:20:00',2.65),('15128','2013-10-18','15:25:00',2.45),('15128','2013-10-18','15:30:00',2.38),('15128','2013-10-18','15:35:00',1.95),('15128','2013-10-18','15:40:00',2.33),('15128','2013-10-18','15:45:00',2.47),('15128','2013-10-18','15:50:00',2.49),('15128','2013-10-18','15:55:00',2.25),('15128','2013-10-18','16:00:00',2.14),('15128','2013-10-18','16:05:00',2.32),('15128','2013-10-18','16:10:00',1.62),('15128','2013-10-18','16:15:00',1.31),('15128','2013-10-18','16:20:00',1.71),('15128','2013-10-18','16:25:00',1.94),('15128','2013-10-18','16:30:00',1.62),('15128','2013-10-18','16:35:00',1.46),('15128','2013-10-18','16:40:00',1.79),('15128','2013-10-18','16:45:00',1.41),('15128','2013-10-18','16:50:00',1.3),('15128','2013-10-18','17:10:00',1.08),('15128','2013-10-18','17:15:00',1.08),('15128','2014-05-03','08:15:00',1.13),('15128','2014-05-03','08:20:00',1.19),('15128','2014-05-03','08:30:00',1.26),('15128','2014-05-03','09:05:00',1.02),('15128','2014-05-03','09:10:00',1.28),('15128','2014-05-03','09:15:00',1.34),('15128','2014-05-03','09:20:00',1.23),('15128','2014-05-03','09:25:00',1.78),('15128','2014-05-03','09:30:00',2.5),('15128','2014-05-03','09:35:00',2.23),('15128','2014-05-03','09:40:00',2.68),('15128','2014-05-03','09:45:00',1.43),('15128','2014-05-03','09:50:00',2.96),('15128','2014-05-03','09:55:00',2.43),('15128','2014-05-03','10:00:00',3.01),('15128','2014-05-03','10:05:00',2.56),('15128','2014-05-03','10:10:00',2.2),('15128','2014-05-03','10:15:00',1.75),('15128','2014-05-03','10:20:00',1.93),('15128','2014-05-03','10:25:00',1.85),('15128','2014-05-03','10:30:00',1.73),('15128','2014-05-03','10:35:00',1.92),('15128','2014-05-03','10:40:00',2.07),('15128','2014-05-03','10:45:00',1.9),('15128','2014-05-03','10:50:00',2.49),('15128','2014-05-03','10:55:00',3.29),('15128','2014-05-03','11:00:00',2.06),('15128','2014-05-03','11:05:00',3.65),('15128','2014-05-03','11:10:00',3.56),('15128','2014-05-03','11:15:00',3.55),('15128','2014-05-03','11:20:00',3.53),('15128','2014-05-03','11:25:00',3.57),('15128','2014-05-03','11:30:00',3.49),('15128','2014-05-03','11:35:00',2.47),('15128','2014-05-03','11:40:00',1.9),('15128','2014-05-03','11:45:00',2.22),('15128','2014-05-03','11:50:00',1.66),('15128','2014-05-03','11:55:00',2.04),('15128','2014-05-03','12:00:00',1.23),('15128','2014-05-03','12:05:00',2.74),('15128','2014-05-03','12:10:00',3.46),('15128','2014-05-03','12:15:00',4.58),('15128','2014-05-03','12:20:00',3.54),('15128','2014-05-03','12:25:00',1.97),('15128','2014-05-03','12:30:00',1.24),('15128','2014-05-03','12:35:00',1.26),('15128','2014-05-03','12:40:00',1.81),('15128','2014-05-03','12:45:00',2.27),('15128','2014-05-03','12:50:00',1.96),('15128','2014-05-03','12:55:00',1.55),('15128','2014-05-03','13:00:00',1.38),('15128','2014-05-03','13:05:00',1.35),('15128','2014-05-03','13:10:00',1.36),('15128','2014-05-03','13:15:00',1.32),('15128','2014-05-03','13:20:00',1.33),('15128','2014-05-03','13:25:00',1.39),('15128','2014-05-03','13:30:00',1.38),('15128','2014-05-03','13:35:00',1.44),('15128','2014-05-03','13:40:00',1.59),('15128','2014-05-03','13:45:00',2.7),('15128','2014-05-03','13:50:00',2.77),('15128','2014-05-03','13:55:00',1.35),('15128','2014-05-03','14:20:00',1.23),('15128','2014-05-03','14:25:00',1.3),('15128','2014-05-03','14:30:00',1.21),('15128','2014-05-03','14:35:00',1.44),('15128','2014-05-03','14:40:00',1.88),('15128','2014-05-03','14:45:00',2.31),('15128','2014-05-03','14:50:00',3.02),('15128','2014-05-03','14:55:00',2.08),('15128','2014-05-03','15:00:00',2.89),('15128','2014-05-03','15:05:00',2.62),('15128','2014-05-03','15:10:00',3.62),('15128','2014-05-03','15:15:00',4.06),('15128','2014-05-03','15:20:00',2.28),('15128','2014-05-03','15:25:00',1.47),('15128','2014-05-03','15:30:00',1.18),('15128','2014-05-03','15:35:00',1.16),('15128','2014-05-03','15:40:00',1.02),('15128','2014-05-03','17:35:00',1.19),('15128','2014-04-15','08:40:00',1.05),('15128','2014-04-15','08:45:00',1.17),('15128','2014-04-15','08:50:00',1.24),('15128','2014-04-15','08:55:00',1.32),('15128','2014-04-15','09:00:00',1.43),('15128','2014-04-15','09:05:00',1.49),('15128','2014-04-15','09:10:00',1.56),('15128','2014-04-15','09:15:00',1.61),('15128','2014-04-15','09:20:00',1.68),('15128','2014-04-15','09:25:00',1.78),('15128','2014-04-15','09:30:00',1.82),('15128','2014-04-15','09:35:00',1.57),('15128','2014-04-15','09:40:00',1.28),('15128','2014-04-15','09:45:00',1.52),('15128','2014-04-15','09:50:00',2.12),('15128','2014-04-15','09:55:00',2.28),('15128','2014-04-15','10:00:00',2.29),('15128','2014-04-15','10:05:00',2.31),('15128','2014-04-15','10:10:00',2.15),('15128','2014-04-15','10:15:00',2.41),('15128','2014-04-15','10:20:00',2.48),('15128','2014-04-15','10:25:00',2.63),('15128','2014-04-15','10:30:00',2.7),('15128','2014-04-15','10:35:00',2.84),('15128','2014-04-15','10:40:00',2.95),('15128','2014-04-15','10:55:00',2.36),('15128','2014-04-15','11:00:00',3.03),('15128','2014-04-15','11:05:00',2.02),('15128','2014-04-15','11:10:00',1.47),('15128','2014-04-15','11:15:00',2.25),('15128','2014-04-15','11:20:00',4.26),('15128','2014-04-15','11:25:00',4.15),('15128','2014-04-15','11:30:00',3.82),('15128','2014-04-15','11:35:00',1.43),('15128','2014-04-15','11:40:00',2.48),('15128','2014-04-15','11:45:00',1.66),('15128','2014-04-15','11:50:00',2.76),('15128','2014-04-15','11:55:00',1.74),('15128','2014-04-15','12:00:00',4.24),('15128','2014-04-15','12:05:00',4.71),('15128','2014-04-15','12:10:00',3.08),('15128','2014-04-15','12:15:00',2.27),('15128','2014-04-15','12:20:00',4.01),('15128','2014-04-15','12:25:00',4.99),('15128','2014-04-15','12:30:00',4.84),('15128','2014-04-15','12:35:00',4.43),('15128','2014-04-15','12:40:00',2.85),('15128','2014-04-15','12:45:00',5.04),('15128','2014-04-15','12:50:00',4.65),('15128','2014-04-15','12:55:00',2.9),('15128','2014-04-15','13:00:00',5.43),('15128','2014-04-15','13:05:00',2.25),('15128','2014-04-15','13:10:00',1.5),('15128','2014-04-15','13:15:00',1.4),('15128','2014-04-15','13:20:00',2.51),('15128','2014-04-15','13:25:00',2.05),('15128','2014-04-15','13:30:00',1.73),('15128','2014-04-15','13:35:00',1.95),('15128','2014-04-15','13:40:00',2.19),('15128','2014-04-15','13:45:00',4.77),('15128','2014-04-15','13:50:00',4.85),('15128','2014-04-15','13:55:00',3.45),('15128','2014-04-15','14:00:00',4.33),('15128','2014-04-15','14:05:00',5.03),('15128','2014-04-15','14:10:00',4.48),('15128','2014-04-15','14:15:00',2.61),('15128','2014-04-15','14:20:00',4.06),('15128','2014-04-15','14:25:00',4.59),('15128','2014-04-15','14:30:00',4.14),('15128','2014-04-15','14:35:00',4.06),('15128','2014-04-15','14:40:00',3.78),('15128','2014-04-15','14:45:00',4.6),('15128','2014-04-15','14:50:00',3.52),('15128','2014-04-15','14:55:00',4.43),('15128','2014-04-15','15:00:00',2.76),('15128','2014-04-15','15:05:00',2.02),('15128','2014-04-15','15:10:00',1.44),('15128','2014-04-15','15:15:00',1),('15128','2014-04-15','15:20:00',1.07),('15128','2014-04-15','15:25:00',1.11),('15128','2014-04-15','15:30:00',1.58),('15128','2014-04-15','15:35:00',1.45),('15128','2014-04-15','15:40:00',1.56),('15128','2014-04-15','15:45:00',1.61),('15128','2014-04-15','15:50:00',2.61),('15128','2014-04-15','16:00:00',3.47),('15128','2014-04-15','16:05:00',3.9),('15128','2014-04-15','16:10:00',3.78),('15128','2014-04-15','16:15:00',3.7),('15128','2014-04-15','16:20:00',3.54),('15128','2014-04-15','16:25:00',3.48),('15128','2014-04-15','16:30:00',3.55),('15128','2014-04-15','16:35:00',3.44),('15128','2014-04-15','16:40:00',3.37),('15128','2014-04-15','16:45:00',3.3),('15128','2014-04-15','16:50:00',3.22),('15128','2014-04-15','16:55:00',3.15),('15128','2014-04-15','17:00:00',3.08),('15128','2014-04-15','17:05:00',3),('15128','2014-04-15','17:10:00',2.92),('15128','2014-04-15','17:15:00',2.79),('15128','2014-04-15','17:20:00',2.65),('15128','2014-04-15','17:25:00',2.52),('15128','2014-04-15','17:30:00',2.4),('15128','2014-04-15','17:35:00',2.28),('15128','2014-04-15','17:40:00',2.2),('15128','2014-04-15','17:45:00',2.06),('15128','2014-04-15','17:50:00',1.99),('15128','2014-04-15','17:55:00',1.92),('15128','2014-04-15','18:00:00',1.89),('15128','2014-04-15','18:05:00',1.91),('15128','2014-04-15','18:10:00',1.73),('15128','2014-04-15','18:15:00',1.66),('15128','2014-04-15','18:20:00',1.55),('15128','2014-04-15','18:30:00',1.27),('15128','2014-04-15','18:35:00',1.34),('15128','2013-10-17','09:35:00',1.07),('15128','2013-10-17','09:40:00',1.17),('15128','2013-10-17','09:45:00',1.24),('15128','2013-10-17','09:50:00',1.3),('15128','2013-10-17','09:55:00',1.38),('15128','2013-10-17','10:00:00',1.42),('15128','2013-10-17','10:05:00',1.52),('15128','2013-10-17','10:10:00',1.56),('15128','2013-10-17','10:15:00',1.62),('15128','2013-10-17','10:20:00',1.63),('15128','2013-10-17','10:25:00',1.69),('15128','2013-10-17','10:30:00',1.76),('15128','2013-10-17','10:35:00',1.82),('15128','2013-10-17','10:40:00',1.85),('15128','2013-10-17','10:45:00',1.9),('15128','2013-10-17','10:50:00',1.98),('15128','2013-10-17','10:55:00',2.04),('15128','2013-10-17','11:00:00',2.05),('15128','2013-10-17','11:05:00',2.12),('15128','2013-10-17','11:10:00',1.86),('15128','2013-10-17','11:15:00',2.11),('15128','2013-10-17','11:20:00',1.92),('15128','2013-10-17','11:25:00',2.33),('15128','2013-10-17','11:30:00',2.35),('15128','2013-10-17','11:35:00',2.46),('15128','2013-10-17','11:40:00',2.37),('15128','2013-10-17','11:45:00',2.52),('15128','2013-10-17','11:50:00',2.55),('15128','2013-10-17','11:55:00',2.72),('15128','2013-10-17','12:00:00',2.8),('15128','2013-10-17','12:05:00',2.82),('15128','2013-10-17','12:10:00',2.85),('15128','2013-10-17','12:15:00',2.81),('15128','2013-10-17','12:20:00',2.9),('15128','2013-10-17','12:25:00',3.01),('15128','2013-10-17','12:30:00',2.98),('15128','2013-10-17','12:35:00',3),('15128','2013-10-17','12:40:00',3.06),('15128','2013-10-17','12:45:00',2.99),('15128','2013-10-17','12:50:00',2.98),('15128','2013-10-17','12:55:00',2.96),('15128','2013-10-17','13:00:00',2.95),('15128','2013-10-17','13:05:00',3.05),('15128','2013-10-17','13:10:00',3.12),('15128','2013-10-17','13:15:00',3.13),('15128','2013-10-17','13:20:00',3.15),('15128','2013-10-17','13:25:00',3.18),('15128','2013-10-17','13:30:00',3.19),('15128','2013-10-17','13:35:00',3.19),('15128','2013-10-17','13:40:00',3.16),('15128','2013-10-17','13:45:00',3.07),('15128','2013-10-17','13:50:00',3.12),('15128','2013-10-17','13:55:00',2.96),('15128','2013-10-17','14:00:00',3),('15128','2013-10-17','14:05:00',3.08),('15128','2013-10-17','14:10:00',3.07),('15128','2013-10-17','14:15:00',3.12),('15128','2013-10-17','14:20:00',3.13),('15128','2013-10-17','14:25:00',3.11),('15128','2013-10-17','14:30:00',3.02),('15128','2013-10-17','14:35:00',3),('15128','2013-10-17','14:40:00',2.96),('15128','2013-10-17','14:45:00',2.94),('15128','2013-10-17','14:50:00',2.94),('15128','2013-10-17','14:55:00',2.81),('15128','2013-10-17','15:00:00',2.57),('15128','2013-10-17','15:05:00',2.55),('15128','2013-10-17','15:10:00',2.59),('15128','2013-10-17','15:15:00',2.74),('15128','2013-10-17','15:20:00',2.63),('15128','2013-10-17','15:25:00',2.64),('15128','2013-10-17','15:30:00',2.62),('15128','2013-10-17','15:35:00',2.44),('15128','2013-10-17','15:40:00',2.29),('15128','2013-10-17','15:45:00',2.29),('15128','2013-10-17','15:50:00',2.24),('15128','2013-10-17','15:55:00',2.23),('15128','2013-10-17','16:00:00',2.16),('15128','2013-10-17','16:05:00',2.07),('15128','2013-10-17','16:10:00',1.93),('15128','2013-10-17','16:15:00',1.86),('15128','2013-10-17','16:20:00',1.42),('15128','2013-10-17','16:25:00',1.42),('15128','2013-10-17','16:30:00',1.27),('15128','2013-10-17','16:35:00',1.02),('15128','2013-10-17','16:50:00',1.16),('15128','2013-10-16','09:35:00',1.11),('15128','2013-10-16','09:40:00',1.18),('15128','2013-10-16','09:45:00',1.24),('15128','2013-10-16','09:50:00',1.3),('15128','2013-10-16','09:55:00',1.38),('15128','2013-10-16','10:00:00',1.42),('15128','2013-10-16','10:05:00',1.5),('15128','2013-10-16','10:10:00',1.53),('15128','2013-10-16','10:15:00',1.59),('15128','2013-10-16','10:20:00',1.63),('15128','2013-10-16','10:25:00',1.68),('15128','2013-10-16','10:30:00',1.77),('15128','2013-10-16','10:35:00',1.79),('15128','2013-10-16','10:40:00',1.86),('15128','2013-10-16','10:45:00',1.92),('15128','2013-10-16','10:50:00',1.97),('15128','2013-10-16','10:55:00',2.06),('15128','2013-10-16','11:00:00',2.07),('15128','2013-10-16','11:05:00',2.09),('15128','2013-10-16','11:10:00',2.11),('15128','2013-10-16','11:15:00',2.23),('15128','2013-10-16','11:20:00',2.31),('15128','2013-10-16','11:25:00',2.28),('15128','2013-10-16','11:30:00',2.41),('15128','2013-10-16','11:35:00',2.45),('15128','2013-10-16','11:40:00',2.41),('15128','2013-10-16','11:45:00',2.58),('15128','2013-10-16','11:50:00',2.66),('15128','2013-10-16','11:55:00',2.85),('15128','2013-10-16','12:00:00',2.92),('15128','2013-10-16','12:05:00',2.96),('15128','2013-10-16','12:10:00',2.99),('15128','2013-10-16','12:15:00',3.04),('15128','2013-10-16','12:20:00',3.08),('15128','2013-10-16','12:25:00',3.1),('15128','2013-10-16','12:30:00',3.14),('15128','2013-10-16','12:35:00',3.17),('15128','2013-10-16','12:40:00',3.2),('15128','2013-10-16','12:45:00',3.2),('15128','2013-10-16','12:50:00',3.23),('15128','2013-10-16','12:55:00',3.25),('15128','2013-10-16','13:00:00',3.29),('15128','2013-10-16','13:05:00',3.29),('15128','2013-10-16','13:10:00',3.3),('15128','2013-10-16','13:15:00',3.29),('15128','2013-10-16','13:20:00',3.29),('15128','2013-10-16','13:25:00',3.29),('15128','2013-10-16','13:30:00',3.28),('15128','2013-10-16','13:35:00',3.31),('15128','2013-10-16','13:40:00',3.3),('15128','2013-10-16','13:45:00',3.29),('15128','2013-10-16','13:50:00',3.29),('15128','2013-10-16','13:55:00',3.3),('15128','2013-10-16','14:00:00',3.29),('15128','2013-10-16','14:05:00',3.27),('15128','2013-10-16','14:10:00',3.24),('15128','2013-10-16','14:15:00',3.23),('15128','2013-10-16','14:20:00',3.22),('15128','2013-10-16','14:25:00',3.2),('15128','2013-10-16','14:30:00',3.17),('15128','2013-10-16','14:35:00',3.14),('15128','2013-10-16','14:40:00',3.11),('15128','2013-10-16','14:45:00',3.07),('15128','2013-10-16','14:50:00',3.04),('15128','2013-10-16','14:55:00',3.01),('15128','2013-10-16','15:00:00',2.98),('15128','2013-10-16','15:05:00',2.94),('15128','2013-10-16','15:10:00',2.88),('15128','2013-10-16','15:15:00',2.85),('15128','2013-10-16','15:20:00',2.81),('15128','2013-10-16','15:25:00',2.76),('15128','2013-10-16','15:30:00',2.71),('15128','2013-10-16','15:35:00',2.65),('15128','2013-10-16','15:40:00',2.58),('15128','2013-10-16','15:45:00',2.52),('15128','2013-10-16','15:50:00',2.46),('15128','2013-10-16','15:55:00',2.4),('15128','2013-10-16','16:00:00',2.35),('15128','2013-10-16','16:05:00',2.26),('15128','2013-10-16','16:10:00',2.2),('15128','2013-10-16','16:15:00',2.08),('15128','2013-10-16','16:20:00',2),('15128','2013-10-16','16:25:00',1.93),('15128','2013-10-16','16:30:00',1.82),('15128','2013-10-16','16:35:00',1.76),('15128','2013-10-16','16:40:00',1.69),('15128','2013-10-16','16:45:00',1.57),('15128','2013-10-16','16:50:00',1.53),('15128','2013-10-16','16:55:00',1.47),('15128','2013-10-16','17:00:00',1.41),('15128','2013-10-16','17:05:00',1.29),('15128','2013-10-16','17:10:00',1.18),('15128','2013-10-16','17:15:00',1.08),('15128','2013-10-15','09:40:00',1.44),('15128','2013-10-15','11:05:00',1.14),('15128','2013-10-15','11:40:00',1.01),('15128','2013-10-15','11:45:00',1.26),('15128','2013-10-15','12:05:00',1.21),('15128','2013-10-15','12:10:00',1.29),('15128','2013-10-15','12:15:00',1.53),('15128','2013-10-15','12:25:00',1.06),('15128','2013-10-15','12:30:00',1.43),('15128','2013-10-15','12:35:00',1.2),('15128','2013-10-15','12:40:00',1.11),('15128','2013-10-15','12:45:00',1.36),('15128','2013-10-15','12:50:00',1.32),('15128','2013-10-15','12:55:00',1.51),('15128','2013-10-15','13:00:00',1.5),('15128','2013-10-15','13:10:00',1.18),('15128','2013-10-15','13:15:00',2.33),('15128','2013-10-15','13:20:00',3.48),('15128','2013-10-15','13:25:00',3.41),('15128','2013-10-15','13:30:00',3.21),('15128','2013-10-15','13:35:00',1.53),('15128','2013-10-15','13:40:00',1.38),('15128','2013-10-15','13:45:00',3.08),('15128','2013-10-15','13:50:00',3.16),('15128','2013-10-15','13:55:00',1.06),('15128','2013-10-15','14:00:00',3.35),('15128','2013-10-15','14:05:00',3.34),('15128','2013-10-15','14:10:00',3.29),('15128','2013-10-15','14:15:00',3.07),('15128','2013-10-15','14:20:00',3.22),('15128','2013-10-15','14:25:00',2.67),('15128','2013-10-15','14:35:00',2.44),('15128','2013-10-15','14:40:00',3.16),('15128','2013-10-15','14:45:00',3.13),('15128','2013-10-15','14:50:00',3.18),('15128','2013-10-15','14:55:00',3.04),('15128','2013-10-15','15:00:00',3.05),('15128','2013-10-15','15:05:00',2.92),('15128','2013-10-15','15:10:00',2.91),('15128','2013-10-15','15:15:00',2.88),('15128','2013-10-15','15:20:00',2.8),('15128','2013-10-15','15:25:00',2.76),('15128','2013-10-15','15:30:00',2.76),('15128','2013-10-15','15:35:00',2.61),('15128','2013-10-15','15:40:00',2.54),('15128','2013-10-15','15:45:00',2.49),('15128','2013-10-15','15:50:00',2.43),('15128','2013-10-15','15:55:00',2.4),('15128','2013-10-15','16:00:00',2.13),('15128','2013-10-15','16:05:00',2.26),('15128','2013-10-15','16:10:00',2.15),('15128','2013-10-15','16:15:00',2.07),('15128','2013-10-15','16:20:00',1.98),('15128','2013-10-15','16:25:00',1.85),('15128','2013-10-15','16:30:00',1.67),('15128','2013-10-15','16:35:00',1.73),('15128','2013-10-15','16:40:00',1.65),('15128','2013-10-15','16:45:00',1.56),('15128','2013-10-15','16:50:00',1.46),('15128','2013-10-15','16:55:00',1.39),('15128','2013-10-15','17:00:00',1.36),('15128','2013-10-15','17:05:00',1.26),('15128','2013-10-15','17:10:00',1.13),('15128','2013-10-15','17:15:00',1.01),('15128','2013-10-14','09:45:00',1.08),('15128','2013-10-14','09:50:00',1.72),('15128','2013-10-14','09:55:00',1.8),('15128','2013-10-14','10:00:00',1.65),('15128','2013-10-14','10:05:00',1.66),('15128','2013-10-14','10:10:00',1.17),('15128','2013-10-14','10:15:00',1.21),('15128','2013-10-14','10:20:00',1.7),('15128','2013-10-14','10:25:00',1.97),('15128','2013-10-14','10:30:00',1.88),('15128','2013-10-14','10:35:00',2.2),('15128','2013-10-14','10:40:00',2.19),('15128','2013-10-14','10:45:00',1.74),('15128','2013-10-14','10:50:00',1.69),('15128','2013-10-14','10:55:00',1.71),('15128','2013-10-14','11:00:00',1.91),('15128','2013-10-14','11:05:00',2.49),('15128','2013-10-14','11:10:00',2.6),('15128','2013-10-14','11:15:00',2.33),('15128','2013-10-14','11:20:00',2.26),('15128','2013-10-14','11:25:00',2.35),('15128','2013-10-14','11:30:00',2.06),('15128','2013-10-14','11:35:00',1.6),('15128','2013-10-14','11:40:00',1.6),('15128','2013-10-14','11:45:00',1.68),('15128','2013-10-14','11:50:00',1.68),('15128','2013-10-14','11:55:00',1.56),('15128','2013-10-14','12:00:00',1.55),('15128','2013-10-14','12:05:00',1.53),('15128','2013-10-14','12:10:00',1.51),('15128','2013-10-14','12:15:00',1.54),('15128','2013-10-14','12:20:00',1.48),('15128','2013-10-14','12:25:00',1.39),('15128','2013-10-14','12:30:00',1.43),('15128','2013-10-14','12:35:00',1.46),('15128','2013-10-14','12:40:00',1.54),('15128','2013-10-14','12:45:00',1.39),('15128','2013-10-14','12:50:00',1.3),('15128','2013-10-14','12:55:00',1.3),('15128','2013-10-14','13:00:00',1.45),('15128','2013-10-14','13:05:00',1.7),('15128','2013-10-14','13:10:00',1.76),('15128','2013-10-14','13:15:00',2.56),('15128','2013-10-14','13:20:00',3.06),('15128','2013-10-14','13:25:00',1.86),('15128','2013-10-14','13:30:00',1.77),('15128','2013-10-14','13:35:00',1.72),('15128','2013-10-14','13:40:00',1.75),('15128','2013-10-14','13:45:00',1.51),('15128','2013-10-14','13:50:00',1.31),('15128','2013-10-14','13:55:00',1.22),('15128','2013-10-14','14:00:00',1.23),('15128','2013-10-14','14:05:00',1.36),('15128','2013-10-14','14:10:00',1.82),('15128','2013-10-14','14:15:00',2.08),('15128','2013-10-14','14:20:00',2.65),('15128','2013-10-14','14:25:00',2.05),('15128','2013-10-14','14:30:00',1.56),('15128','2013-10-14','14:35:00',2.21),('15128','2013-10-14','14:40:00',2.54),('15128','2013-10-14','14:45:00',2.56),('15128','2013-10-14','14:50:00',2.19),('15128','2013-10-14','14:55:00',1.55),('15128','2013-10-14','15:00:00',1.8),('15128','2013-10-14','15:05:00',1.52),('15128','2013-10-14','15:10:00',1.35),('15128','2013-10-14','15:15:00',1.11),('15128','2013-10-14','15:20:00',1.06),('15128','2013-10-14','15:25:00',1.07),('15128','2013-10-14','15:30:00',1.11),('15128','2013-10-14','15:35:00',1.21),('15128','2013-10-14','15:40:00',1.17),('15128','2013-10-14','15:45:00',1.04),('15128','2013-10-14','16:20:00',1.1),('15128','2013-10-14','16:25:00',1.33),('15128','2013-10-14','16:30:00',1.46),('15128','2013-10-14','16:35:00',1.17),('15128','2013-10-14','16:40:00',1.01),('15128','2013-10-14','16:50:00',1.01),('15128','2013-10-13','09:30:00',1.08),('15128','2013-10-13','09:45:00',1.05),('15128','2013-10-13','09:50:00',1.27),('15128','2013-10-13','09:55:00',1.29),('15128','2013-10-13','10:00:00',1.47),('15128','2013-10-13','10:05:00',1.5),('15128','2013-10-13','10:10:00',1.57),('15128','2013-10-13','10:15:00',1.61),('15128','2013-10-13','10:20:00',1.66),('15128','2013-10-13','10:25:00',1.73),('15128','2013-10-13','10:30:00',1.77),('15128','2013-10-13','10:35:00',1.79),('15128','2013-10-13','10:40:00',1.81),('15128','2013-10-13','10:45:00',1.85),('15128','2013-10-13','10:50:00',1.94),('15128','2013-10-13','10:55:00',2.02),('15128','2013-10-13','11:00:00',2.03),('15128','2013-10-13','11:05:00',2.04),('15128','2013-10-13','11:10:00',2.18),('15128','2013-10-13','11:15:00',2.14),('15128','2013-10-13','11:20:00',2.23),('15128','2013-10-13','11:25:00',2.3),('15128','2013-10-13','11:30:00',2.33),('15128','2013-10-13','11:35:00',2.36),('15128','2013-10-13','11:40:00',2.45),('15128','2013-10-13','11:45:00',2.41),('15128','2013-10-13','11:50:00',2.48),('15128','2013-10-13','11:55:00',2.64),('15128','2013-10-13','12:00:00',2.76),('15128','2013-10-13','12:05:00',2.8),('15128','2013-10-13','12:10:00',2.82),('15128','2013-10-13','12:15:00',2.71),('15128','2013-10-13','12:20:00',2.8),('15128','2013-10-13','12:25:00',2.92),('15128','2013-10-13','12:30:00',2.97),('15128','2013-10-13','12:35:00',3),('15128','2013-10-13','12:40:00',3.01),('15128','2013-10-13','12:45:00',3.02),('15128','2013-10-13','12:50:00',3.04),('15128','2013-10-13','12:55:00',3.04),('15128','2013-10-13','13:00:00',3.05),('15128','2013-10-13','13:05:00',3.06),('15128','2013-10-13','13:10:00',3.06),('15128','2013-10-13','13:15:00',3.05),('15128','2013-10-13','13:20:00',3.07),('15128','2013-10-13','13:25:00',3.07),('15128','2013-10-13','13:30:00',3.06),('15128','2013-10-13','13:35:00',3.07),('15128','2013-10-13','13:40:00',3.06),('15128','2013-10-13','13:45:00',3.06),('15128','2013-10-13','13:50:00',3.05),('15128','2013-10-13','13:55:00',3.04),('15128','2013-10-13','14:00:00',3.03),('15128','2013-10-13','14:05:00',3.03),('15128','2013-10-13','14:10:00',3.03),('15128','2013-10-13','14:15:00',3),('15128','2013-10-13','14:20:00',2.98),('15128','2013-10-13','14:25:00',2.97),('15128','2013-10-13','14:30:00',2.96),('15128','2013-10-13','14:35:00',2.94),('15128','2013-10-13','14:40:00',2.9),('15128','2013-10-13','14:45:00',2.87),('15128','2013-10-13','14:50:00',2.85),('15128','2013-10-13','14:55:00',2.81),('15128','2013-10-13','15:00:00',2.77),('15128','2013-10-13','15:05:00',2.74),('15128','2013-10-13','15:10:00',2.69),('15128','2013-10-13','15:15:00',2.64),('15128','2013-10-13','15:20:00',2.61),('15128','2013-10-13','15:25:00',2.57),('15128','2013-10-13','15:30:00',2.51),('15128','2013-10-13','15:35:00',2.46),('15128','2013-10-13','15:40:00',2.36),('15128','2013-10-13','15:45:00',2.03),('15128','2013-10-13','15:50:00',1.32),('15128','2013-10-13','15:55:00',1.71),('15128','2013-10-13','16:05:00',1.1),('15128','2013-10-13','16:10:00',1.5),('15128','2013-10-13','16:15:00',1.02),('15128','2013-10-13','16:20:00',1.06),('15128','2013-10-13','16:35:00',1.06),('15128','2013-10-13','16:40:00',1.63),('15128','2013-10-13','16:45:00',1.15),('15128','2013-10-12','09:35:00',1.04),('15128','2013-10-12','09:40:00',1.39),('15128','2013-10-12','09:45:00',1.54),('15128','2013-10-12','09:50:00',1.87),('15128','2013-10-12','09:55:00',1.46),('15128','2013-10-12','10:00:00',1.47),('15128','2013-10-12','10:05:00',1.47),('15128','2013-10-12','10:10:00',1.65),('15128','2013-10-12','10:15:00',1.39),('15128','2013-10-12','10:20:00',1.23),('15128','2013-10-12','10:25:00',1.44),('15128','2013-10-12','10:30:00',2.14),('15128','2013-10-12','10:35:00',2.74),('15128','2013-10-12','10:40:00',2.44),('15128','2013-10-12','10:45:00',2.64),('15128','2013-10-12','10:50:00',1.94),('15128','2013-10-12','10:55:00',1.91),('15128','2013-10-12','11:00:00',1.79),('15128','2013-10-12','11:05:00',1.88),('15128','2013-10-12','11:10:00',2.21),('15128','2013-10-12','11:15:00',2.32),('15128','2013-10-12','11:20:00',2.39),('15128','2013-10-12','11:25:00',2.27),('15128','2013-10-12','11:30:00',2.25),('15128','2013-10-12','11:35:00',2.49),('15128','2013-10-12','11:40:00',2.5),('15128','2013-10-12','11:45:00',2.52),('15128','2013-10-12','11:50:00',2.47),('15128','2013-10-12','11:55:00',2.74),('15128','2013-10-12','12:00:00',2.85),('15128','2013-10-12','12:05:00',2.89),('15128','2013-10-12','12:10:00',2.91),('15128','2013-10-12','12:15:00',2.95),('15128','2013-10-12','12:20:00',3),('15128','2013-10-12','12:25:00',2.95),('15128','2013-10-12','12:30:00',2.89),('15128','2013-10-12','12:35:00',3.12),('15128','2013-10-12','12:40:00',3.08),('15128','2013-10-12','12:45:00',3.07),('15128','2013-10-12','12:50:00',3.09),('15128','2013-10-12','12:55:00',3.11),('15128','2013-10-12','13:00:00',3.1),('15128','2013-10-12','13:05:00',3.16),('15128','2013-10-12','13:10:00',3.23),('15128','2013-10-12','13:15:00',3.26),('15128','2013-10-12','13:20:00',3.13),('15128','2013-10-12','13:25:00',3.16),('15128','2013-10-12','13:30:00',3.19),('15128','2013-10-12','13:35:00',3.27),('15128','2013-10-12','13:40:00',3.33),('15128','2013-10-12','13:45:00',3.17),('15128','2013-10-12','13:50:00',3.23),('15128','2013-10-12','13:55:00',3.3),('15128','2013-10-12','14:00:00',2.44),('15128','2013-10-12','14:05:00',3.56),('15128','2013-10-12','14:10:00',3.1),('15128','2013-10-12','14:15:00',3.44),('15128','2013-10-12','14:20:00',3.44),('15128','2013-10-12','14:25:00',3.33),('15128','2013-10-12','14:30:00',2.99),('15128','2013-10-12','14:35:00',2.11),('15128','2013-10-12','14:40:00',2.44),('15128','2013-10-12','14:45:00',2.81),('15128','2013-10-12','14:50:00',2.72),('15128','2013-10-12','14:55:00',2.7),('15128','2013-10-12','15:00:00',2.5),('15128','2013-10-12','15:05:00',2.99),('15128','2013-10-12','15:10:00',2.82),('15128','2013-10-12','15:15:00',2.85),('15128','2013-10-12','15:20:00',2.5),('15128','2013-10-12','15:25:00',2.29),('15128','2013-10-12','15:30:00',1.97),('15128','2013-10-12','15:35:00',1.77),('15128','2013-10-12','15:40:00',1.46),('15128','2013-10-12','15:45:00',1.81),('15128','2013-10-12','15:50:00',1.81),('15128','2013-10-12','15:55:00',2.19),('15128','2013-10-12','16:00:00',2.16),('15128','2013-10-12','16:05:00',2.45),('15128','2013-10-12','16:10:00',2.24),('15128','2013-10-12','16:15:00',2.21),('15128','2013-10-12','16:20:00',1.99),('15128','2013-10-12','16:25:00',1.65),('15128','2013-10-12','16:30:00',1.38),('15128','2013-10-12','16:35:00',1.64),('15128','2013-10-12','16:40:00',1.13),('15128','2013-10-12','16:45:00',1.1),('15128','2013-10-12','17:20:00',1.09),('15128','2013-10-11','11:15:00',1.11),('15128','2013-10-11','11:20:00',1.35),('15128','2013-10-11','11:25:00',1.4),('15128','2013-10-11','11:30:00',1.87),('15128','2013-10-11','11:35:00',1.92),('15128','2013-10-11','11:40:00',1.55),('15128','2013-10-11','11:45:00',1.34),('15128','2013-10-11','11:50:00',1.13),('15128','2013-10-11','12:10:00',1.2),('15128','2013-10-11','12:15:00',1.5),('15128','2013-10-11','12:20:00',2.93),('15128','2013-10-11','12:25:00',2.91),('15128','2013-10-11','12:30:00',2.76),('15128','2013-10-11','12:35:00',3.26),('15128','2013-10-11','12:40:00',3.07),('15128','2013-10-11','12:45:00',3.11),('15128','2013-10-11','12:50:00',2.9),('15128','2013-10-11','12:55:00',2.79),('15128','2013-10-11','13:00:00',2.62),('15128','2013-10-11','13:15:00',1.1),('15128','2013-10-11','13:20:00',1.41),('15128','2013-10-11','13:25:00',1.49),('15128','2013-10-11','15:50:00',1),('15128','2013-10-11','16:15:00',1.44),('15128','2013-10-11','16:20:00',1.64),('15128','2013-10-11','16:25:00',1.6),('15128','2013-10-11','16:30:00',1.3),('15128','2013-10-11','16:35:00',1.44),('15128','2013-10-11','16:40:00',1.52),('15128','2013-10-11','17:00:00',1.02),('15128','2013-10-10','09:25:00',1.13),('15128','2013-10-10','09:30:00',1.2),('15128','2013-10-10','09:35:00',1.31),('15128','2013-10-10','09:40:00',1.39),('15128','2013-10-10','09:45:00',1.44),('15128','2013-10-10','09:50:00',1.48),('15128','2013-10-10','09:55:00',1.54),('15128','2013-10-10','10:00:00',1.59),('15128','2013-10-10','10:05:00',1.69),('15128','2013-10-10','10:10:00',1.79),('15128','2013-10-10','10:15:00',1.52),('15128','2013-10-10','10:20:00',1.22),('15128','2013-10-10','10:25:00',1.6),('15128','2013-10-10','10:30:00',1.32),('15128','2013-10-10','10:35:00',1.79),('15128','2013-10-10','10:40:00',1.07),('15128','2013-10-10','10:45:00',1.89),('15128','2013-10-10','10:50:00',1.32),('15128','2013-10-10','10:55:00',1.26),('15128','2013-10-10','11:00:00',2.25),('15128','2013-10-10','11:05:00',2.64),('15128','2013-10-10','11:10:00',1.4),('15128','2013-10-10','11:15:00',1.48),('15128','2013-10-10','11:20:00',1.38),('15128','2013-10-10','11:25:00',1.22),('15128','2013-10-10','11:30:00',1.19),('15128','2013-10-10','11:35:00',1.43),('15128','2013-10-10','11:40:00',1.27),('15128','2013-10-10','11:45:00',1.21),('15128','2013-10-10','12:10:00',3.07),('15128','2013-10-10','12:15:00',3.54),('15128','2013-10-10','12:20:00',3.95),('15128','2013-10-10','12:25:00',1.49),('15128','2013-10-10','12:30:00',1.33),('15128','2013-10-10','12:50:00',1.96),('15128','2013-10-10','12:55:00',3.05),('15128','2013-10-10','13:00:00',1.92),('15128','2013-10-10','13:05:00',1.84),('15128','2013-10-10','13:20:00',1.08),('15128','2013-10-10','13:25:00',1.14),('15128','2013-10-10','13:30:00',3.87),('15128','2013-10-10','13:35:00',2.54),('15128','2013-10-10','13:45:00',1.06),('15128','2013-10-10','13:50:00',2.49),('15128','2013-10-10','13:55:00',1.17),('15128','2013-10-10','14:35:00',1.2),('15128','2013-10-10','14:40:00',1.78),('15128','2013-10-10','14:45:00',1.18),('15128','2013-10-10','14:50:00',1.12),('15128','2013-10-10','14:55:00',1.09),('15128','2013-10-10','16:50:00',1.14),('15128','2013-10-10','16:55:00',1.07),('15128','2013-10-10','17:10:00',1.32),('15128','2013-10-10','17:15:00',1.35),('15128','2013-10-10','17:20:00',1.08),('15128','2013-10-09','09:25:00',1.01),('15128','2013-10-09','09:30:00',1.11),('15128','2013-10-09','09:35:00',1.2),('15128','2013-10-09','09:40:00',1.28),('15128','2013-10-09','09:45:00',1.36),('15128','2013-10-09','09:50:00',1.38),('15128','2013-10-09','09:55:00',1.41),('15128','2013-10-09','10:00:00',1.5),('15128','2013-10-09','10:05:00',1.57),('15128','2013-10-09','10:10:00',1.72),('15128','2013-10-09','10:15:00',1.84),('15128','2013-10-09','10:20:00',1.64),('15128','2013-10-09','10:25:00',2.11),('15128','2013-10-09','10:30:00',2.04),('15128','2013-10-09','10:35:00',1.65),('15128','2013-10-09','10:45:00',2.26),('15128','2013-10-09','10:50:00',2.3),('15128','2013-10-09','10:55:00',2.45),('15128','2013-10-09','11:00:00',2.77),('15128','2013-10-09','11:05:00',1.45),('15128','2013-10-09','11:10:00',2.25),('15128','2013-10-09','11:20:00',2.92),('15128','2013-10-09','11:25:00',2.73),('15128','2013-10-09','11:30:00',2.06),('15128','2013-10-09','11:35:00',2.05),('15128','2013-10-09','11:40:00',3.07),('15128','2013-10-09','11:45:00',3.91),('15128','2013-10-09','11:50:00',2.1),('15128','2013-10-09','11:55:00',2.39),('15128','2013-10-09','12:00:00',2.79),('15128','2013-10-09','12:05:00',4.29),('15128','2013-10-09','12:10:00',4.01),('15128','2013-10-09','12:15:00',3.71),('15128','2013-10-09','12:20:00',2.43),('15128','2013-10-09','12:25:00',3.13),('15128','2013-10-09','12:30:00',1.06),('15128','2013-10-09','12:35:00',3.75),('15128','2013-10-09','12:40:00',3.88),('15128','2013-10-09','12:45:00',3.18),('15128','2013-10-09','12:50:00',3.65),('15128','2013-10-09','12:55:00',3.98),('15128','2013-10-09','13:00:00',2.51),('15128','2013-10-09','13:05:00',3.98),('15128','2013-10-09','13:10:00',2.17),('15128','2013-10-09','13:15:00',3.82),('15128','2013-10-09','13:20:00',3.71),('15128','2013-10-09','13:25:00',3.76),('15128','2013-10-09','13:30:00',3.78),('15128','2013-10-09','13:35:00',3.81),('15128','2013-10-09','13:40:00',3.84),('15128','2013-10-09','13:45:00',3.88),('15128','2013-10-09','13:50:00',3.65),('15128','2013-10-09','13:55:00',3),('15128','2013-10-09','14:00:00',1.03),('15128','2013-10-09','14:05:00',2.8),('15128','2013-10-09','14:10:00',2.24),('15128','2013-10-09','14:15:00',1.56),('15128','2013-10-09','14:20:00',2.26),('15128','2013-10-09','14:25:00',2.94),('15128','2013-10-09','14:30:00',3.69),('15128','2013-10-09','14:35:00',1.15),('15128','2013-10-09','14:40:00',2.56),('15128','2013-10-09','14:45:00',1.1),('15128','2013-10-09','14:50:00',2.33),('15128','2013-10-09','14:55:00',3.66),('15128','2013-10-09','15:00:00',2.51),('15128','2013-10-09','15:05:00',2.86),('15128','2013-10-09','15:10:00',3),('15128','2013-10-09','15:15:00',1.45),('15128','2013-10-09','15:25:00',2.68),('15128','2013-10-09','15:35:00',1.79),('15128','2013-10-09','15:40:00',1.54),('15128','2013-10-09','15:45:00',1.73),('15128','2013-10-09','15:50:00',1.05),('15128','2013-10-09','15:55:00',1.58),('15128','2013-10-09','16:00:00',3.07),('15128','2013-10-09','16:05:00',2),('15128','2013-10-09','16:10:00',2.51),('15128','2013-10-09','16:15:00',2.09),('15128','2013-10-09','16:20:00',2.37),('15128','2013-10-09','16:25:00',2.25),('15128','2013-10-09','16:30:00',2.17),('15128','2013-10-09','16:35:00',2.11),('15128','2013-10-09','16:45:00',1.68),('15128','2013-10-09','16:50:00',2),('15128','2013-10-09','16:55:00',1.9),('15128','2013-10-09','17:00:00',1.47),('15128','2013-10-09','17:05:00',1.02),('15128','2013-10-09','17:10:00',1.51),('15128','2013-10-09','17:15:00',1.34),('15128','2013-10-09','17:20:00',1.02),('15128','2013-10-08','09:20:00',1.09),('15128','2013-10-08','09:25:00',1.2),('15128','2013-10-08','09:30:00',1.39),('15128','2013-10-08','09:35:00',1.58),('15128','2013-10-08','09:40:00',1.86),('15128','2013-10-08','09:45:00',1.96),('15128','2013-10-08','09:50:00',1.93),('15128','2013-10-08','09:55:00',2.03),('15128','2013-10-08','10:00:00',1.75),('15128','2013-10-08','10:05:00',1.53),('15128','2013-10-08','10:15:00',1.18),('15128','2013-10-08','10:20:00',1.58),('15128','2013-10-08','10:25:00',1.57),('15128','2013-10-08','10:30:00',1.94),('15128','2013-10-08','10:35:00',1.87),('15128','2013-10-08','11:00:00',1.51),('15128','2013-10-08','11:15:00',1.05),('15128','2013-10-08','11:20:00',2.16),('15128','2013-10-08','11:25:00',1.1),('15128','2013-10-08','11:30:00',1.72),('15128','2013-10-08','11:40:00',1.49),('15128','2013-10-08','11:45:00',1.73),('15128','2013-10-08','11:50:00',1.3),('15128','2013-10-08','11:55:00',1.52),('15128','2013-10-08','12:00:00',1.99),('15128','2013-10-08','12:05:00',1.33),('15128','2013-10-08','12:25:00',1.66),('15128','2013-10-08','12:30:00',3.12),('15128','2013-10-08','12:35:00',2.96),('15128','2013-10-08','12:40:00',2.15),('15128','2013-10-08','12:45:00',1.36),('15128','2013-10-08','12:50:00',1.05),('15128','2013-10-08','12:55:00',1.12),('15128','2013-10-08','13:00:00',1.85),('15128','2013-10-08','13:05:00',2.86),('15128','2013-10-08','13:10:00',2.93),('15128','2013-10-08','13:15:00',3.94),('15128','2013-10-08','13:20:00',3.67),('15128','2013-10-08','13:25:00',2.43),('15128','2013-10-08','13:30:00',3.34),('15128','2013-10-08','13:35:00',3.83),('15128','2013-10-08','13:40:00',3.82),('15128','2013-10-08','13:45:00',3.81),('15128','2013-10-08','13:50:00',3.78),('15128','2013-10-08','13:55:00',3.73),('15128','2013-10-08','14:00:00',3.55),('15128','2013-10-08','14:05:00',3.71),('15128','2013-10-08','14:10:00',2.21),('15128','2013-10-08','14:15:00',2.33),('15128','2013-10-08','14:20:00',2.95),('15128','2013-10-08','14:25:00',1.61),('15128','2013-10-08','14:30:00',2.86),('15128','2013-10-08','14:35:00',3.83),('15128','2013-10-08','14:40:00',3.64),('15128','2013-10-08','14:45:00',1.5),('15128','2013-10-08','14:50:00',2.43),('15128','2013-10-08','14:55:00',2.31),('15128','2013-10-08','15:00:00',3.7),('15128','2013-10-08','15:05:00',3.42),('15128','2013-10-08','15:10:00',2.09),('15128','2013-10-08','15:15:00',1.55),('15128','2013-10-08','15:20:00',1.61),('15128','2013-10-08','15:25:00',2.87),('15128','2013-10-08','15:30:00',1.33),('15128','2013-10-08','15:45:00',1.74),('15128','2013-10-08','15:50:00',2.16),('15128','2013-10-08','15:55:00',2.58),('15128','2013-10-08','16:00:00',1.13),('15128','2013-10-08','16:05:00',1.03),('15128','2013-10-08','16:10:00',1.35),('15128','2013-10-08','16:15:00',1.96),('15128','2013-10-08','16:20:00',2.5),('15128','2013-10-08','16:25:00',1.22),('15128','2013-10-08','16:40:00',1.99),('15128','2014-04-14','08:55:00',1.33),('15128','2014-04-14','09:05:00',1.5),('15128','2014-04-14','09:10:00',1.49),('15128','2014-04-14','09:15:00',1.66),('15128','2014-04-14','09:20:00',1.22),('15128','2014-04-14','09:25:00',1.11),('15128','2014-04-14','09:30:00',1.3),('15128','2014-04-14','09:35:00',1.36),('15128','2014-04-14','09:40:00',1.15),('15128','2014-04-14','09:45:00',1.76),('15128','2014-04-14','09:50:00',1.41),('15128','2014-04-14','10:05:00',1.88),('15128','2014-04-14','10:10:00',1.16),('15128','2014-04-14','10:15:00',1.59),('15128','2014-04-14','10:20:00',2.14),('15128','2014-04-14','10:25:00',1.47),('15128','2014-04-14','10:30:00',2.1),('15128','2014-04-14','10:35:00',2.74),('15128','2014-04-14','10:40:00',1.83),('15128','2014-04-14','10:45:00',1.85),('15128','2014-04-14','10:50:00',3.16),('15128','2014-04-14','10:55:00',1.95),('15128','2014-04-14','11:00:00',1.85),('15128','2014-04-14','11:05:00',2.94),('15128','2014-04-14','11:10:00',2.11),('15128','2014-04-14','11:15:00',2.21),('15128','2014-04-14','11:20:00',1.02),('15128','2014-04-14','11:25:00',1.35),('15128','2014-04-14','11:30:00',1.38),('15128','2014-04-14','11:35:00',1.22),('15128','2014-04-14','11:40:00',1.32),('15128','2014-04-14','11:45:00',1.31),('15128','2014-04-14','11:50:00',1.4),('15128','2014-04-14','11:55:00',2),('15128','2014-04-14','12:00:00',1.05),('15128','2014-04-14','12:10:00',1.4),('15128','2014-04-14','12:15:00',3.24),('15128','2014-04-14','12:20:00',2.74),('15128','2014-04-14','12:25:00',1.05),('15128','2014-04-14','12:45:00',1.07),('15128','2014-04-14','13:05:00',1.57),('15128','2014-04-14','13:10:00',1.6),('15128','2014-04-14','13:15:00',1.62),('15128','2014-04-14','13:20:00',1.83),('15128','2014-04-14','13:30:00',1.09),('15128','2014-04-14','13:35:00',1.67),('15128','2014-04-14','13:45:00',2.82),('15128','2014-04-14','13:50:00',4.34),('15128','2014-04-14','13:55:00',3.83),('15128','2014-04-14','14:00:00',2.6),('15128','2014-04-14','14:05:00',2.6),('15128','2014-04-14','14:10:00',2.55),('15128','2014-04-14','14:15:00',2.69),('15128','2014-04-14','14:20:00',2.7),('15128','2014-04-14','14:25:00',3.74),('15128','2014-04-14','14:30:00',1.76),('15128','2014-04-14','14:35:00',1.3),('15128','2014-04-14','14:40:00',2.27),('15128','2014-04-14','14:45:00',1.87),('15128','2014-04-14','14:50:00',2.22),('15128','2014-04-14','14:55:00',2.63),('15128','2014-04-14','15:00:00',2.85),('15128','2014-04-14','15:05:00',2.38),('15128','2014-04-14','15:10:00',2.67),('15128','2014-04-14','15:15:00',3.91),('15128','2014-04-14','15:20:00',4.42),('15128','2014-04-14','15:25:00',2.71),('15128','2014-04-14','15:30:00',2.47),('15128','2014-04-14','15:35:00',1.92),('15128','2014-04-14','15:40:00',1.7),('15128','2014-04-14','15:45:00',1.9),('15128','2014-04-14','15:50:00',1.43),('15128','2014-04-14','15:55:00',1.25),('15128','2014-04-14','16:00:00',1.19),('15128','2014-04-14','16:05:00',1.18),('15128','2014-04-14','16:10:00',1.15),('15128','2013-10-07','09:50:00',1.45),('15128','2013-10-07','09:55:00',1.38),('15128','2013-10-07','10:00:00',2.24),('15128','2013-10-07','10:05:00',2.27),('15128','2013-10-07','10:10:00',1.32),('15128','2013-10-07','10:55:00',1.11),('15128','2013-10-07','11:00:00',1.13),('15128','2013-10-07','11:05:00',1.07),('15128','2013-10-07','11:25:00',1.16),('15128','2013-10-07','12:35:00',1.5),('15128','2013-10-07','12:40:00',1.54),('15128','2013-10-07','12:45:00',1.06),('15128','2013-10-07','12:50:00',1.08),('15128','2013-10-07','12:55:00',1.28),('15128','2013-10-07','13:00:00',1.18),('15128','2013-10-07','13:05:00',2.06),('15128','2013-10-07','13:10:00',3.9),('15128','2013-10-07','13:15:00',1.78),('15128','2013-10-07','13:20:00',1.56),('15128','2013-10-07','13:25:00',2.5),('15128','2013-10-07','13:30:00',1.35),('15128','2013-10-07','13:45:00',1.1),('15128','2013-10-07','13:50:00',1.16),('15128','2013-10-07','13:55:00',1.16),('15128','2013-10-07','14:25:00',1.23),('15128','2013-10-07','14:30:00',2.26),('15128','2013-10-07','14:35:00',4.26),('15128','2013-10-07','14:40:00',3.69),('15128','2013-10-07','14:45:00',3.36),('15128','2013-10-07','14:50:00',3.43),('15128','2013-10-07','14:55:00',3.39),('15128','2013-10-07','15:00:00',3.31),('15128','2013-10-07','15:05:00',3.3),('15128','2013-10-07','15:10:00',1.76),('15128','2013-10-07','15:15:00',2.17),('15128','2013-10-06','09:20:00',1.13),('15128','2013-10-06','09:25:00',1.11),('15128','2013-10-06','09:30:00',1.21),('15128','2013-10-06','09:35:00',1.32),('15128','2013-10-06','09:40:00',1.37),('15128','2013-10-06','09:45:00',1.41),('15128','2013-10-06','09:50:00',1.35),('15128','2013-10-06','09:55:00',1.54),('15128','2013-10-06','10:00:00',1.58),('15128','2013-10-06','10:05:00',1.63),('15128','2013-10-06','10:10:00',1.67),('15128','2013-10-06','10:15:00',1.71),('15128','2013-10-06','10:20:00',1.76),('15128','2013-10-06','10:25:00',1.81),('15128','2013-10-06','10:30:00',1.84),('15128','2013-10-06','10:35:00',1.93),('15128','2013-10-06','10:40:00',1.99),('15128','2013-10-06','10:45:00',2.07),('15128','2013-10-06','10:50:00',2.1),('15128','2013-10-06','10:55:00',2.11),('15128','2013-10-06','11:00:00',2.29),('15128','2013-10-06','11:05:00',2.26),('15128','2013-10-06','11:10:00',2.13),('15128','2013-10-06','11:15:00',2.38),('15128','2013-10-06','11:20:00',2.43),('15128','2013-10-06','11:25:00',2.51),('15128','2013-10-06','11:30:00',2.57),('15128','2013-10-06','11:35:00',2.59),('15128','2013-10-06','11:40:00',2.76),('15128','2013-10-06','11:45:00',2.92),('15128','2013-10-06','11:50:00',3.02),('15128','2013-10-06','11:55:00',2.28),('15128','2013-10-06','12:00:00',2.94),('15128','2013-10-06','12:05:00',3.55),('15128','2013-10-06','12:10:00',3.66),('15128','2013-10-06','12:15:00',3.85),('15128','2013-10-06','12:20:00',3.68),('15128','2013-10-06','12:25:00',1.73),('15128','2013-10-06','12:30:00',1.26),('15128','2013-10-06','12:35:00',1.65),('15128','2013-10-06','12:40:00',1.07),('15128','2013-10-06','12:55:00',1.76),('15128','2013-10-06','13:00:00',4.34),('15128','2013-10-06','13:05:00',3.48),('15128','2013-10-06','13:10:00',2.5),('15128','2013-10-06','13:15:00',3.87),('15128','2013-10-06','13:20:00',3.19),('15128','2013-10-06','13:25:00',1.12),('15128','2013-10-06','13:30:00',2.7),('15128','2013-10-06','13:40:00',1.49),('15128','2013-10-06','13:45:00',2.59),('15128','2013-10-06','14:00:00',3.63),('15128','2013-10-06','14:05:00',1.51),('15128','2013-10-06','14:10:00',4.23),('15128','2013-10-06','14:15:00',3.7),('15128','2013-10-06','14:20:00',4.22),('15128','2013-10-06','14:25:00',1.88),('15128','2013-10-06','14:30:00',3.57),('15128','2013-10-06','14:35:00',3.05),('15128','2013-10-06','14:40:00',1.24),('15128','2013-10-06','14:45:00',2.31),('15128','2013-10-06','14:50:00',2.18),('15128','2013-10-06','14:55:00',2.33),('15128','2013-10-06','15:00:00',2.27),('15128','2013-10-06','15:05:00',1.11),('15128','2013-10-06','15:10:00',2.35),('15128','2013-10-06','15:15:00',1.72),('15128','2013-10-06','15:20:00',1.73),('15128','2013-10-06','15:25:00',3.47),('15128','2013-10-06','15:30:00',2.51),('15128','2013-10-06','15:35:00',2.84),('15128','2013-10-06','15:40:00',2.49),('15128','2013-10-06','15:45:00',2.33),('15128','2013-10-06','15:50:00',2.37),('15128','2013-10-06','15:55:00',2.94),('15128','2013-10-06','16:00:00',1.48),('15128','2013-10-06','16:05:00',2.62),('15128','2013-10-06','16:10:00',2.52),('15128','2013-10-06','16:15:00',2.55),('15128','2013-10-06','16:20:00',2.35),('15128','2013-10-06','16:25:00',2.25),('15128','2013-10-06','16:30:00',2.19),('15128','2013-10-06','16:35:00',1.99),('15128','2013-10-06','16:40:00',1.96),('15128','2013-10-06','16:45:00',1.84),('15128','2013-10-06','16:50:00',1.76),('15128','2013-10-06','16:55:00',1.68),('15128','2013-10-06','17:00:00',1.63),('15128','2013-10-06','17:05:00',1.56),('15128','2013-10-06','17:10:00',1.5),('15128','2013-10-06','17:15:00',1.44),('15128','2013-10-06','17:20:00',1.32),('15128','2013-10-06','17:25:00',1.23),('15128','2013-10-06','17:30:00',1.12),('15128','2013-10-06','17:35:00',1.01),('15128','2013-10-05','09:25:00',1.14),('15128','2013-10-05','09:30:00',1.56),('15128','2013-10-05','09:35:00',1.43),('15128','2013-10-05','09:40:00',1.57),('15128','2013-10-05','09:45:00',1.5),('15128','2013-10-05','09:50:00',1.8),('15128','2013-10-05','09:55:00',1.54),('15128','2013-10-05','10:00:00',1.99),('15128','2013-10-05','10:05:00',1.87),('15128','2013-10-05','10:10:00',1.87),('15128','2013-10-05','10:15:00',1.77),('15128','2013-10-05','10:20:00',1.96),('15128','2013-10-05','10:25:00',2.03),('15128','2013-10-05','10:30:00',2.03),('15128','2013-10-05','10:35:00',2),('15128','2013-10-05','10:40:00',1.63),('15128','2013-10-05','10:45:00',1.89),('15128','2013-10-05','10:50:00',2.03),('15128','2013-10-05','10:55:00',2.21),('15128','2013-10-05','11:00:00',2.39),('15128','2013-10-05','11:05:00',2.13),('15128','2013-10-05','11:10:00',2.41),('15128','2013-10-05','11:15:00',2.3),('15128','2013-10-05','11:20:00',2.38),('15128','2013-10-05','11:25:00',2.26),('15128','2013-10-05','11:30:00',2.15),('15128','2013-10-05','11:35:00',1.92),('15128','2013-10-05','11:40:00',2.22),('15128','2013-10-05','11:45:00',2.07),('15128','2013-10-05','11:50:00',2.3),('15128','2013-10-05','11:55:00',1.34),('15128','2013-10-05','12:00:00',2.99),('15128','2013-10-05','12:05:00',3.07),('15128','2013-10-05','12:10:00',3.13),('15128','2013-10-05','12:15:00',2.72),('15128','2013-10-05','12:20:00',2.08),('15128','2013-10-05','12:25:00',1.4),('15128','2013-10-05','12:30:00',2.84),('15128','2013-10-05','12:35:00',2.79),('15128','2013-10-05','12:40:00',2.98),('15128','2013-10-05','12:45:00',3.13),('15128','2013-10-05','12:50:00',3.26),('15128','2013-10-05','12:55:00',2.98),('15128','2013-10-05','13:00:00',3.29),('15128','2013-10-05','13:05:00',2.14),('15128','2013-10-05','13:10:00',2.56),('15128','2013-10-05','13:15:00',1.65),('15128','2013-10-05','13:20:00',1.56),('15128','2013-10-05','13:25:00',1.83),('15128','2013-10-05','13:30:00',1.29),('15128','2013-10-05','13:35:00',1.09),('15128','2013-10-05','13:55:00',2.37),('15128','2013-10-05','14:00:00',2.34),('15128','2013-10-05','14:05:00',1.4),('15128','2013-10-05','14:10:00',1.36),('15128','2013-10-05','14:15:00',1.9),('15128','2013-10-05','14:20:00',1.79),('15128','2013-10-05','14:25:00',2.58),('15128','2013-10-05','14:30:00',2.68),('15128','2013-10-05','14:35:00',2.66),('15128','2013-10-05','14:40:00',2.44),('15128','2013-10-05','14:45:00',1.52),('15128','2013-10-05','14:50:00',1.56),('15128','2013-10-05','14:55:00',1.93),('15128','2013-10-05','15:00:00',2.27),('15128','2013-10-05','15:05:00',2.15),('15128','2013-10-05','15:10:00',2),('15128','2013-10-05','15:15:00',1.88),('15128','2013-10-05','15:20:00',1.27),('15128','2013-10-05','15:25:00',1.15),('15128','2013-10-05','15:30:00',1.08),('15128','2013-10-05','15:35:00',1.01),('15128','2013-10-05','15:55:00',1.13),('15128','2013-10-05','16:00:00',1.09),('15128','2013-10-05','17:10:00',1.42),('15128','2013-10-05','17:15:00',1.1),('15128','2013-10-04','15:55:00',1.1),('15128','2013-10-04','16:00:00',1.41),('15128','2013-10-04','16:05:00',1.35),('15128','2013-10-04','16:10:00',1.25),('15128','2013-10-04','16:15:00',1.24),('15128','2013-10-04','16:20:00',1.09),('15128','2013-10-04','16:45:00',1.22),('15128','2013-10-04','16:50:00',1.17),('15128','2013-10-04','16:55:00',1.34),('15128','2013-10-04','17:00:00',1.03),('15128','2013-10-03','09:30:00',1.01),('15128','2013-10-03','09:35:00',1),('15128','2013-10-03','09:40:00',1.08),('15128','2013-10-03','09:45:00',1.2),('15128','2013-10-03','09:50:00',1.45),('15128','2013-10-03','09:55:00',1.33),('15128','2013-10-03','10:00:00',1.25),('15128','2013-10-03','10:05:00',1.29),('15128','2013-10-03','10:10:00',1.34),('15128','2013-10-03','10:15:00',1.27),('15128','2013-10-03','10:20:00',1.4),('15128','2013-10-03','10:25:00',1.65),('15128','2013-10-03','10:30:00',1.88),('15128','2013-10-03','10:35:00',1.58),('15128','2013-10-03','10:40:00',2.83),('15128','2013-10-03','10:45:00',2.18),('15128','2013-10-03','10:50:00',1.94),('15128','2013-10-03','10:55:00',1.88),('15128','2013-10-03','11:00:00',1.58),('15128','2013-10-03','11:05:00',1.56),('15128','2013-10-03','11:10:00',1.71),('15128','2013-10-03','11:15:00',1.96),('15128','2013-10-03','11:20:00',2.36),('15128','2013-10-03','11:25:00',2.43),('15128','2013-10-03','11:30:00',2.04),('15128','2013-10-03','11:35:00',2.75),('15128','2013-10-03','11:40:00',2.88),('15128','2013-10-03','11:45:00',2.92),('15128','2013-10-03','11:50:00',2.98),('15128','2013-10-03','11:55:00',3.08),('15128','2013-10-03','12:00:00',3.21),('15128','2013-10-03','12:05:00',3.21),('15128','2013-10-03','12:10:00',3.11),('15128','2013-10-03','12:15:00',3.21),('15128','2013-10-03','12:20:00',3.27),('15128','2013-10-03','12:25:00',3.38),('15128','2013-10-03','12:30:00',3.39),('15128','2013-10-03','12:35:00',3.33),('15128','2013-10-03','12:40:00',3.35),('15128','2013-10-03','12:45:00',3.38),('15128','2013-10-03','12:50:00',3.3),('15128','2013-10-03','12:55:00',3.38),('15128','2013-10-03','13:00:00',3.44),('15128','2013-10-03','13:05:00',3.42),('15128','2013-10-03','13:10:00',3.53),('15128','2013-10-03','13:15:00',3.55),('15128','2013-10-03','13:20:00',3.31),('15128','2013-10-03','13:25:00',3.46),('15128','2013-10-03','13:30:00',3.52),('15128','2013-10-03','13:35:00',3.47),('15128','2013-10-03','13:40:00',3.44),('15128','2013-10-03','13:45:00',3.42),('15128','2013-10-03','13:50:00',3.46),('15128','2013-10-03','13:55:00',3.47),('15128','2013-10-03','14:00:00',3.49),('15128','2013-10-03','14:05:00',3.21),('15128','2013-10-03','14:10:00',2.62),('15128','2013-10-03','14:15:00',3.21),('15128','2013-10-03','14:20:00',3.46),('15128','2013-10-03','14:25:00',2.97),('15128','2013-10-03','14:30:00',2.35),('15128','2013-10-03','14:35:00',1.86),('15128','2013-10-03','14:40:00',2.02),('15128','2013-10-03','14:45:00',2.66),('15128','2013-10-03','14:50:00',2.44),('15128','2013-10-03','14:55:00',2.24),('15128','2013-10-03','15:00:00',2.73),('15128','2013-10-03','15:05:00',2.35),('15128','2013-10-03','15:10:00',1.82),('15128','2013-10-03','15:15:00',1.59),('15128','2013-10-03','15:20:00',2.42),('15128','2013-10-03','15:25:00',1.5),('15128','2013-10-03','15:30:00',1.48),('15128','2013-10-03','15:35:00',1.26),('15128','2013-10-03','15:40:00',1.01),('15128','2013-10-03','15:55:00',1.16),('15128','2013-10-03','16:00:00',1.31),('15128','2013-10-03','16:05:00',1.14),('15128','2013-10-02','09:15:00',1.02),('15128','2013-10-02','09:20:00',1.11),('15128','2013-10-02','09:25:00',1.23),('15128','2013-10-02','09:30:00',1.31),('15128','2013-10-02','09:35:00',1.38),('15128','2013-10-02','09:40:00',1.45),('15128','2013-10-02','09:45:00',1.49),('15128','2013-10-02','09:50:00',1.54),('15128','2013-10-02','09:55:00',1.64),('15128','2013-10-02','10:00:00',1.72),('15128','2013-10-02','10:05:00',1.77),('15128','2013-10-02','10:10:00',1.81),('15128','2013-10-02','10:15:00',1.87),('15128','2013-10-02','10:20:00',1.93),('15128','2013-10-02','10:25:00',1.98),('15128','2013-10-02','10:30:00',2.03),('15128','2013-10-02','10:35:00',2.1),('15128','2013-10-02','10:40:00',2.16),('15128','2013-10-02','10:45:00',2.21),('15128','2013-10-02','10:50:00',2.28),('15128','2013-10-02','10:55:00',2.36),('15128','2013-10-02','11:00:00',2.41),('15128','2013-10-02','11:05:00',2.47),('15128','2013-10-02','11:10:00',2.53),('15128','2013-10-02','11:15:00',2.61),('15128','2013-10-02','11:20:00',2.68),('15128','2013-10-02','11:25:00',2.74),('15128','2013-10-02','11:30:00',2.8),('15128','2013-10-02','11:35:00',2.84),('15128','2013-10-02','11:40:00',2.91),('15128','2013-10-02','11:45:00',2.91),('15128','2013-10-02','11:50:00',3.09),('15128','2013-10-02','11:55:00',3.18),('15128','2013-10-02','12:00:00',3.25),('15128','2013-10-02','12:05:00',3.3),('15128','2013-10-02','12:10:00',3.34),('15128','2013-10-02','12:15:00',3.37),('15128','2013-10-02','12:20:00',3.41),('15128','2013-10-02','12:25:00',3.45),('15128','2013-10-02','12:30:00',3.47),('15128','2013-10-02','12:35:00',3.51),('15128','2013-10-02','12:40:00',3.54),('15128','2013-10-02','12:45:00',3.56),('15128','2013-10-02','12:50:00',3.59),('15128','2013-10-02','12:55:00',3.62),('15128','2013-10-02','13:00:00',3.61),('15128','2013-10-02','13:05:00',3.63),('15128','2013-10-02','13:10:00',3.66),('15128','2013-10-02','13:15:00',3.64),('15128','2013-10-02','13:20:00',3.64),('15128','2013-10-02','13:25:00',3.67),('15128','2013-10-02','13:30:00',3.68),('15128','2013-10-02','13:35:00',3.68),('15128','2013-10-02','13:40:00',3.65),('15128','2013-10-02','13:45:00',3.66),('15128','2013-10-02','13:50:00',3.65),('15128','2013-10-02','13:55:00',3.64),('15128','2013-10-02','14:00:00',3.64),('15128','2013-10-02','14:05:00',3.61),('15128','2013-10-02','14:10:00',3.61),('15128','2013-10-02','14:15:00',3.61),('15128','2013-10-02','14:20:00',3.57),('15128','2013-10-02','14:25:00',3.53),('15128','2013-10-02','14:30:00',3.52),('15128','2013-10-02','14:35:00',3.5),('15128','2013-10-02','14:40:00',3.46),('15128','2013-10-02','14:45:00',3.42),('15128','2013-10-02','14:50:00',3.38),('15128','2013-10-02','14:55:00',3.35),('15128','2013-10-02','15:00:00',3.33),('15128','2013-10-02','15:05:00',3.29),('15128','2013-10-02','15:10:00',3.24),('15128','2013-10-02','15:15:00',3.21),('15128','2013-10-02','15:20:00',3.17),('15128','2013-10-02','15:25:00',3.14),('15128','2013-10-02','15:30:00',3.09),('15128','2013-10-02','15:35:00',3.04),('15128','2013-10-02','15:40:00',2.97),('15128','2013-10-02','15:45:00',2.93),('15128','2013-10-02','15:50:00',2.9),('15128','2013-10-02','15:55:00',2.85),('15128','2013-10-02','16:00:00',2.76),('15128','2013-10-02','16:05:00',2.71),('15128','2013-10-02','16:10:00',2.67),('15128','2013-10-02','16:15:00',2.59),('15128','2013-10-02','16:20:00',2.52),('15128','2013-10-02','16:25:00',2.42),('15128','2013-10-02','16:30:00',2.32),('15128','2013-10-02','16:35:00',2.2),('15128','2013-10-02','16:40:00',2.02),('15128','2013-10-02','16:45:00',1.92),('15128','2013-10-02','16:50:00',1.87),('15128','2013-10-02','16:55:00',1.82),('15128','2013-10-02','17:00:00',1.74),('15128','2013-10-02','17:05:00',1.66),('15128','2013-10-02','17:10:00',1.59),('15128','2013-10-02','17:15:00',1.52),('15128','2013-10-02','17:20:00',1.45),('15128','2013-10-02','17:25:00',1.35),('15128','2013-10-02','17:30:00',1.23),('15128','2013-10-02','17:35:00',1.13),('15128','2013-10-02','17:40:00',1.02),('15128','2013-10-01','09:15:00',1),('15128','2013-10-01','09:20:00',1.09),('15128','2013-10-01','09:25:00',1.19),('15128','2013-10-01','09:30:00',1.27),('15128','2013-10-01','09:35:00',1.34),('15128','2013-10-01','09:40:00',1.4),('15128','2013-10-01','09:45:00',1.44),('15128','2013-10-01','09:50:00',1.49),('15128','2013-10-01','09:55:00',1.57),('15128','2013-10-01','10:00:00',1.64),('15128','2013-10-01','10:05:00',1.7),('15128','2013-10-01','10:10:00',1.73),('15128','2013-10-01','10:15:00',1.77),('15128','2013-10-01','10:20:00',1.84),('15128','2013-10-01','10:25:00',1.89),('15128','2013-10-01','10:30:00',1.92),('15128','2013-10-01','10:35:00',1.99),('15128','2013-10-01','10:40:00',2.04),('15128','2013-10-01','10:45:00',2.09),('15128','2013-10-01','10:50:00',2.14),('15128','2013-10-01','10:55:00',2.26),('15128','2013-10-01','11:00:00',2.31),('15128','2013-10-01','11:05:00',2.39),('15128','2013-10-01','11:10:00',2.42),('15128','2013-10-01','11:15:00',2.45),('15128','2013-10-01','11:20:00',2.48),('15128','2013-10-01','11:25:00',2.57),('15128','2013-10-01','11:30:00',2.68),('15128','2013-10-01','11:35:00',2.69),('15128','2013-10-01','11:40:00',2.79),('15128','2013-10-01','11:45:00',2.81),('15128','2013-10-01','11:50:00',2.95),('15128','2013-10-01','11:55:00',3.07),('15128','2013-10-01','12:00:00',3.14),('15128','2013-10-01','12:05:00',3.17),('15128','2013-10-01','12:10:00',3.22),('15128','2013-10-01','12:15:00',3.25),('15128','2013-10-01','12:20:00',3.29),('15128','2013-10-01','12:25:00',3.32),('15128','2013-10-01','12:30:00',3.37),('15128','2013-10-01','12:35:00',3.41),('15128','2013-10-01','12:40:00',3.44),('15128','2013-10-01','12:45:00',3.46),('15128','2013-10-01','12:50:00',3.46),('15128','2013-10-01','12:55:00',3.48),('15128','2013-10-01','13:00:00',3.52),('15128','2013-10-01','13:05:00',3.52),('15128','2013-10-01','13:10:00',3.52),('15128','2013-10-01','13:15:00',3.52),('15128','2013-10-01','13:20:00',3.52),('15128','2013-10-01','13:25:00',3.51),('15128','2013-10-01','13:30:00',3.51),('15128','2013-10-01','13:35:00',3.52),('15128','2013-10-01','13:40:00',3.54),('15128','2013-10-01','13:45:00',3.51),('15128','2013-10-01','13:50:00',3.54),('15128','2013-10-01','13:55:00',3.67),('15128','2013-10-01','14:00:00',3.61),('15128','2013-10-01','14:05:00',3.5),('15128','2013-10-01','14:10:00',3.59),('15128','2013-10-01','14:15:00',3.56),('15128','2013-10-01','14:20:00',3.49),('15128','2013-10-01','14:25:00',3.49),('15128','2013-10-01','14:30:00',3.48),('15128','2013-10-01','14:35:00',3.4),('15128','2013-10-01','14:40:00',3.4),('15128','2013-10-01','14:45:00',3.36),('15128','2013-10-01','14:50:00',3.3),('15128','2013-10-01','14:55:00',3.3),('15128','2013-10-01','15:00:00',3.29),('15128','2013-10-01','15:05:00',3.23),('15128','2013-10-01','15:10:00',3.18),('15128','2013-10-01','15:15:00',3.15),('15128','2013-10-01','15:20:00',3.1),('15128','2013-10-01','15:25:00',3.07),('15128','2013-10-01','15:30:00',3.03),('15128','2013-10-01','15:35:00',2.98),('15128','2013-10-01','15:40:00',2.93),('15128','2013-10-01','15:45:00',2.86),('15128','2013-10-01','15:50:00',2.78),('15128','2013-10-01','15:55:00',2.74),('15128','2013-10-01','16:00:00',2.71),('15128','2013-10-01','16:05:00',2.66),('15128','2013-10-01','16:10:00',2.6),('15128','2013-10-01','16:15:00',2.52),('15128','2013-10-01','16:20:00',2.42),('15128','2013-10-01','16:25:00',2.31),('15128','2013-10-01','16:30:00',2.24),('15128','2013-10-01','16:35:00',2.13),('15128','2013-10-01','16:40:00',2.01),('15128','2013-10-01','16:45:00',1.88),('15128','2013-10-01','16:50:00',1.81),('15128','2013-10-01','16:55:00',1.69),('15128','2013-10-01','17:00:00',1.64),('15128','2013-10-01','17:05:00',1.59),('15128','2013-10-01','17:10:00',1.53),('15128','2013-10-01','17:15:00',1.43),('15128','2013-10-01','17:20:00',1.38),('15128','2013-10-01','17:25:00',1.29),('15128','2013-10-01','17:30:00',1.18),('15128','2013-10-01','17:35:00',1.08),('15128','2013-09-30','09:20:00',1.12),('15128','2013-09-30','09:25:00',1.21),('15128','2013-09-30','09:30:00',1.27),('15128','2013-09-30','09:35:00',1.33),('15128','2013-09-30','09:40:00',1.39),('15128','2013-09-30','09:45:00',1.45),('15128','2013-09-30','09:50:00',1.48),('15128','2013-09-30','09:55:00',1.56),('15128','2013-09-30','10:00:00',1.62),('15128','2013-09-30','10:05:00',1.7),('15128','2013-09-30','10:10:00',1.72),('15128','2013-09-30','10:15:00',1.74),('15128','2013-09-30','10:20:00',1.81),('15128','2013-09-30','10:25:00',1.86),('15128','2013-09-30','10:30:00',1.87),('15128','2013-09-30','10:35:00',1.98),('15128','2013-09-30','10:40:00',2.03),('15128','2013-09-30','10:45:00',2.11),('15128','2013-09-30','10:50:00',2.17),('15128','2013-09-30','10:55:00',2.23),('15128','2013-09-30','11:00:00',2.23),('15128','2013-09-30','11:05:00',2.37),('15128','2013-09-30','11:10:00',2.47),('15128','2013-09-30','11:15:00',2.53),('15128','2013-09-30','11:20:00',2.69),('15128','2013-09-30','11:25:00',2.8),('15128','2013-09-30','11:30:00',2.85),('15128','2013-09-30','11:35:00',2.79),('15128','2013-09-30','11:40:00',2.9),('15128','2013-09-30','11:45:00',2.71),('15128','2013-09-30','11:50:00',2.19),('15128','2013-09-30','11:55:00',2.16),('15128','2013-09-30','12:00:00',3.6),('15128','2013-09-30','12:05:00',2.46),('15128','2013-09-30','12:10:00',1.99),('15128','2013-09-30','12:15:00',1.96),('15128','2013-09-30','12:20:00',2.4),('15128','2013-09-30','12:25:00',2.2),('15128','2013-09-30','12:30:00',1.02),('15128','2013-09-30','12:35:00',3.09),('15128','2013-09-30','12:40:00',3.81),('15128','2013-09-30','12:45:00',3.78),('15128','2013-09-30','12:50:00',2.01),('15128','2013-09-30','12:55:00',1),('15128','2013-09-30','13:00:00',1.24),('15128','2013-09-30','13:05:00',1.98),('15128','2013-09-30','13:10:00',1.62),('15128','2013-09-30','13:15:00',3.19),('15128','2013-09-30','13:20:00',1.5),('15128','2013-09-30','13:30:00',1.59),('15128','2013-09-30','13:35:00',3.98),('15128','2013-09-30','13:40:00',3.88),('15128','2013-09-30','13:45:00',3.76),('15128','2013-09-30','13:50:00',3.61),('15128','2013-09-30','13:55:00',3.58),('15128','2013-09-30','14:00:00',3.59),('15128','2013-09-30','14:05:00',3.56),('15128','2013-09-30','14:10:00',3.54),('15128','2013-09-30','14:15:00',3.51),('15128','2013-09-30','14:20:00',3.5),('15128','2013-09-30','14:25:00',3.44),('15128','2013-09-30','14:30:00',3.44),('15128','2013-09-30','14:35:00',3.44),('15128','2013-09-30','14:40:00',3.41),('15128','2013-09-30','14:45:00',3.39),('15128','2013-09-30','14:50:00',3.39),('15128','2013-09-30','14:55:00',3.34),('15128','2013-09-30','15:00:00',3.3),('15128','2013-09-30','15:05:00',3.28),('15128','2013-09-30','15:10:00',3.22),('15128','2013-09-30','15:15:00',3.19),('15128','2013-09-30','15:20:00',3.17),('15128','2013-09-30','15:25:00',3.11),('15128','2013-09-30','15:30:00',3.08),('15128','2013-09-30','15:35:00',3.02),('15128','2013-09-30','15:40:00',2.95),('15128','2013-09-30','15:45:00',2.91),('15128','2013-09-30','15:50:00',2.88),('15128','2013-09-30','15:55:00',2.83),('15128','2013-09-30','16:00:00',2.76),('15128','2013-09-30','16:05:00',2.71),('15128','2013-09-30','16:10:00',2.66),('15128','2013-09-30','16:15:00',2.59),('15128','2013-09-30','16:20:00',2.52),('15128','2013-09-30','16:25:00',2.37),('15128','2013-09-30','16:30:00',2.18),('15128','2013-09-30','16:35:00',2.1),('15128','2013-09-30','16:40:00',2.03),('15128','2013-09-30','16:45:00',1.96),('15128','2013-09-30','16:50:00',1.86),('15128','2013-09-30','16:55:00',1.79),('15128','2013-09-30','17:00:00',1.71),('15128','2013-09-30','17:05:00',1.62),('15128','2013-09-30','17:10:00',1.61),('15128','2013-09-30','17:15:00',1.54),('15128','2013-09-30','17:20:00',1.44),('15128','2013-09-30','17:25:00',1.37),('15128','2013-09-30','17:30:00',1.26),('15128','2013-09-30','17:35:00',1.18),('15128','2013-09-30','17:40:00',1.08),('15128','2013-09-29','09:40:00',1.19),('15128','2013-09-29','09:45:00',1.66),('15128','2013-09-29','09:50:00',1.05),('15128','2013-09-29','10:10:00',1.11),('15128','2013-09-29','10:15:00',1.12),('15128','2013-09-29','10:20:00',1.13),('15128','2013-09-29','10:25:00',1.25),('15128','2013-09-29','10:30:00',1.27),('15128','2013-09-29','10:35:00',1.46),('15128','2013-09-29','10:40:00',1.87),('15128','2013-09-29','10:45:00',2.33),('15128','2013-09-29','10:50:00',2.19),('15128','2013-09-29','10:55:00',1.91),('15128','2013-09-29','11:00:00',2.21),('15128','2013-09-29','11:05:00',2.52),('15128','2013-09-29','11:10:00',2.57),('15128','2013-09-29','11:15:00',2.51),('15128','2013-09-29','11:20:00',2.38),('15128','2013-09-29','11:25:00',2.77),('15128','2013-09-29','11:30:00',2.66),('15128','2013-09-29','11:35:00',2.95),('15128','2013-09-29','11:40:00',2.55),('15128','2013-09-29','11:45:00',2.25),('15128','2013-09-29','11:50:00',1.54),('15128','2013-09-29','11:55:00',1.38),('15128','2013-09-29','12:00:00',3.45),('15128','2013-09-29','12:05:00',3.44),('15128','2013-09-29','12:10:00',3.43),('15128','2013-09-29','12:15:00',3.43),('15128','2013-09-29','12:20:00',3.44),('15128','2013-09-29','12:25:00',3.49),('15128','2013-09-29','12:30:00',3.49),('15128','2013-09-29','12:35:00',3.53),('15128','2013-09-29','12:40:00',3.64),('15128','2013-09-29','12:45:00',3.28),('15128','2013-09-29','12:50:00',3.92),('15128','2013-09-29','12:55:00',4.09),('15128','2013-09-29','13:00:00',3.17),('15128','2013-09-29','13:05:00',2.39),('15128','2013-09-29','13:10:00',3.45),('15128','2013-09-29','13:15:00',3.92),('15128','2013-09-29','13:20:00',3.9),('15128','2013-09-29','13:25:00',3.99),('15128','2013-09-29','13:30:00',4.2),('15128','2013-09-29','13:35:00',4.26),('15128','2013-09-29','13:40:00',2.16),('15128','2013-09-29','13:55:00',1.05),('15128','2013-09-29','14:00:00',1.2),('15128','2013-09-29','14:05:00',1.32),('15128','2013-09-29','14:10:00',1.18),('15128','2013-09-29','14:25:00',1.7),('15128','2013-09-29','14:30:00',3.96),('15128','2013-09-29','14:35:00',4.77),('15128','2013-09-29','14:40:00',4.8),('15128','2013-09-29','14:45:00',4.07),('15128','2013-09-29','14:50:00',4.11),('15128','2013-09-29','14:55:00',3.64),('15128','2013-09-29','15:00:00',3.09),('15128','2013-09-29','15:05:00',2.07),('15128','2013-09-29','15:10:00',2.13),('15128','2013-09-29','15:15:00',3.07),('15128','2013-09-29','15:20:00',1.01),('15128','2013-09-29','15:25:00',1.24),('15128','2013-09-29','15:50:00',2.49),('15128','2013-09-29','15:55:00',3.52),('15128','2013-09-29','16:00:00',3.41),('15128','2013-09-29','16:05:00',2.42),('15128','2013-09-29','16:10:00',1.48),('15128','2013-09-29','16:15:00',1.45),('15128','2013-09-29','16:20:00',1.13),('15128','2013-09-29','16:25:00',2.26),('15128','2013-09-29','16:30:00',2.29),('15128','2013-09-29','16:35:00',1.81),('15128','2013-09-29','16:40:00',2.24),('15128','2013-09-29','16:45:00',1.66),('15128','2013-09-29','16:50:00',2),('15128','2013-09-29','16:55:00',1.2),('15128','2013-09-29','17:15:00',1.32),('15128','2013-09-29','17:35:00',1.08),('15128','2013-09-28','09:50:00',1.04),('15128','2013-09-28','09:55:00',1.44),('15128','2013-09-28','10:00:00',1.8),('15128','2013-09-28','10:05:00',1.76),('15128','2013-09-28','10:10:00',2),('15128','2013-09-28','10:15:00',1.73),('15128','2013-09-28','10:20:00',1.86),('15128','2013-09-28','10:25:00',1.93),('15128','2013-09-28','10:30:00',1.86),('15128','2013-09-28','10:35:00',1.97),('15128','2013-09-28','10:40:00',2),('15128','2013-09-28','10:45:00',2.12),('15128','2013-09-28','10:50:00',2.17),('15128','2013-09-28','10:55:00',2.25),('15128','2013-09-28','11:00:00',2.26),('15128','2013-09-28','11:05:00',2.1),('15128','2013-09-28','11:10:00',2.22),('15128','2013-09-28','11:15:00',2.35),('15128','2013-09-28','11:20:00',2.24),('15128','2013-09-28','11:25:00',2.35),('15128','2013-09-28','11:30:00',2.53),('15128','2013-09-28','11:35:00',2.47),('15128','2013-09-28','11:40:00',2.69),('15128','2013-09-28','11:45:00',2.66),('15128','2013-09-28','11:50:00',2.96),('15128','2013-09-28','11:55:00',2.87),('15128','2013-09-28','12:00:00',2.98),('15128','2013-09-28','12:05:00',3.17),('15128','2013-09-28','12:10:00',2.98),('15128','2013-09-28','12:15:00',2.4),('15128','2013-09-28','12:20:00',1.37),('15128','2013-09-28','12:25:00',1.13),('15128','2013-09-28','12:30:00',1.23),('15128','2013-09-28','12:35:00',1.54),('15128','2013-09-28','12:40:00',1.48),('15128','2013-09-28','12:45:00',1.34),('15128','2013-09-28','12:50:00',1.46),('15128','2013-09-28','12:55:00',1.06),('15128','2013-09-28','13:20:00',1.03),('15128','2013-09-28','13:25:00',1.76),('15128','2013-09-28','13:30:00',2.22),('15128','2013-09-28','13:35:00',2.33),('15128','2013-09-28','13:40:00',2.1),('15128','2013-09-28','13:45:00',1.87),('15128','2013-09-28','13:50:00',1.84),('15128','2013-09-28','13:55:00',1.69),('15128','2013-09-28','14:00:00',1.45),('15128','2013-09-28','14:05:00',1.44),('15128','2013-09-28','14:10:00',1.2),('15128','2013-09-28','14:15:00',1.25),('15128','2013-09-28','14:20:00',1.21),('15128','2013-09-28','14:25:00',1.42),('15128','2013-09-28','14:50:00',1.76),('15128','2013-09-28','15:15:00',1.29),('15128','2013-09-28','15:20:00',1.15),('15128','2013-09-28','15:25:00',1.51),('15128','2013-09-28','15:55:00',1.21),('15128','2013-09-28','16:00:00',1.11),('15128','2013-09-28','16:25:00',1.63),('15128','2013-09-28','16:30:00',1.59),('15128','2013-09-28','16:35:00',1.17),('15128','2014-04-13','08:40:00',1.01),('15128','2014-04-13','08:45:00',1.09),('15128','2014-04-13','08:50:00',1.16),('15128','2014-04-13','08:55:00',1.22),('15128','2014-04-13','09:00:00',1.3),('15128','2014-04-13','09:05:00',1.36),('15128','2014-04-13','09:10:00',1.45),('15128','2014-04-13','09:15:00',1.52),('15128','2014-04-13','09:20:00',1.58),('15128','2014-04-13','09:25:00',1.64),('15128','2014-04-13','09:30:00',1.72),('15128','2014-04-13','09:35:00',1.79),('15128','2014-04-13','09:40:00',1.87),('15128','2014-04-13','09:45:00',1.94),('15128','2014-04-13','09:50:00',1.92),('15128','2014-04-13','09:55:00',1.97),('15128','2014-04-13','10:00:00',2.03),('15128','2014-04-13','10:05:00',2.11),('15128','2014-04-13','10:10:00',2.18),('15128','2014-04-13','10:15:00',2.25),('15128','2014-04-13','10:20:00',2.32),('15128','2014-04-13','10:25:00',2.41),('15128','2014-04-13','10:30:00',2.38),('15128','2014-04-13','10:35:00',2.52),('15128','2014-04-13','10:40:00',2.58),('15128','2014-04-13','10:45:00',2.67),('15128','2014-04-13','10:50:00',2.65),('15128','2014-04-13','10:55:00',2.73),('15128','2014-04-13','11:00:00',2.77),('15128','2014-04-13','11:05:00',2.84),('15128','2014-04-13','11:10:00',2.9),('15128','2014-04-13','11:15:00',2.94),('15128','2014-04-13','11:20:00',3),('15128','2014-04-13','11:25:00',3.02),('15128','2014-04-13','11:30:00',3.11),('15128','2014-04-13','11:35:00',3.06),('15128','2014-04-13','11:40:00',3.22),('15128','2014-04-13','11:45:00',3.22),('15128','2014-04-13','11:50:00',3.39),('15128','2014-04-13','11:55:00',3.57),('15128','2014-04-13','12:00:00',3.65),('15128','2014-04-13','12:05:00',3.67),('15128','2014-04-13','12:10:00',3.71),('15128','2014-04-13','12:15:00',3.76),('15128','2014-04-13','12:20:00',3.81),('15128','2014-04-13','12:25:00',3.84),('15128','2014-04-13','12:30:00',3.87),('15128','2014-04-13','12:35:00',3.89),('15128','2014-04-13','12:40:00',3.93),('15128','2014-04-13','12:45:00',3.97),('15128','2014-04-13','12:50:00',4.01),('15128','2014-04-13','12:55:00',4.02),('15128','2014-04-13','13:00:00',4.05),('15128','2014-04-13','13:05:00',4.08),('15128','2014-04-13','13:10:00',4.09),('15128','2014-04-13','13:15:00',4.09),('15128','2014-04-13','13:20:00',4.1),('15128','2014-04-13','13:25:00',4.13),('15128','2014-04-13','13:30:00',4.15),('15128','2014-04-13','13:35:00',4.14),('15128','2014-04-13','13:40:00',4.15),('15128','2014-04-13','13:45:00',4.15),('15128','2014-04-13','13:50:00',4.16),('15128','2014-04-13','13:55:00',4.16),('15128','2014-04-13','14:00:00',4.15),('15128','2014-04-13','14:05:00',4.15),('15128','2014-04-13','14:10:00',4.19),('15128','2014-04-13','14:15:00',4.14),('15128','2014-04-13','14:20:00',4.13),('15128','2014-04-13','14:25:00',4.12),('15128','2014-04-13','14:30:00',4.11),('15128','2014-04-13','14:35:00',4.09),('15128','2014-04-13','14:40:00',4.09),('15128','2014-04-13','14:45:00',4.05),('15128','2014-04-13','14:50:00',4.04),('15128','2014-04-13','14:55:00',4.03),('15128','2014-04-13','15:00:00',3.99),('15128','2014-04-13','15:05:00',3.98),('15128','2014-04-13','15:10:00',3.94),('15128','2014-04-13','15:15:00',3.89),('15128','2014-04-13','15:20:00',3.87),('15128','2014-04-13','15:25:00',3.85),('15128','2014-04-13','15:30:00',3.81),('15128','2014-04-13','15:35:00',3.77),('15128','2014-04-13','15:40:00',3.73),('15128','2014-04-13','15:45:00',3.68),('15128','2014-04-13','15:50:00',3.63),('15128','2014-04-13','15:55:00',3.58),('15128','2014-04-13','16:00:00',3.54),('15128','2014-04-13','16:05:00',3.48),('15128','2014-04-13','16:10:00',3.43),('15128','2014-04-13','16:15:00',3.38),('15128','2014-04-13','16:20:00',3.33),('15128','2014-04-13','16:25:00',3.26),('15128','2014-04-13','16:30:00',3.2),('15128','2014-04-13','16:35:00',3.15),('15128','2014-04-13','16:40:00',3.08),('15128','2014-04-13','16:45:00',3),('15128','2014-04-13','16:50:00',2.92),('15128','2014-04-13','16:55:00',2.87),('15128','2014-04-13','17:00:00',2.81),('15128','2014-04-13','17:05:00',2.73),('15128','2014-04-13','17:10:00',2.64),('15128','2014-04-13','17:15:00',2.55),('15128','2014-04-13','17:20:00',2.42),('15128','2014-04-13','17:25:00',2.29),('15128','2014-04-13','17:30:00',2.15),('15128','2014-04-13','17:35:00',2.05),('15128','2014-04-13','17:40:00',1.94),('15128','2014-04-13','17:45:00',1.88),('15128','2014-04-13','17:50:00',1.79),('15128','2014-04-13','17:55:00',1.7),('15128','2014-04-13','18:00:00',1.63),('15128','2014-04-13','18:05:00',1.57),('15128','2014-04-13','18:10:00',1.5),('15128','2014-04-13','18:15:00',1.43),('15128','2014-04-13','18:20:00',1.3),('15128','2014-04-13','18:25:00',1.2),('15128','2014-04-13','18:30:00',1.08),('15128','2014-04-13','18:35:00',1),('15128','2013-09-27','09:15:00',1.04),('15128','2013-09-27','09:20:00',1.1),('15128','2013-09-27','09:25:00',1.18),('15128','2013-09-27','09:30:00',1.27),('15128','2013-09-27','09:35:00',1.3),('15128','2013-09-27','09:40:00',1.32),('15128','2013-09-27','09:45:00',1.42),('15128','2013-09-27','09:50:00',1.5),('15128','2013-09-27','09:55:00',1.64),('15128','2013-09-27','10:00:00',1.44),('15128','2013-09-27','10:05:00',1.12),('15128','2013-09-27','10:10:00',1.15),('15128','2013-09-27','10:15:00',2.23),('15128','2013-09-27','10:20:00',2.2),('15128','2013-09-27','10:25:00',1.75),('15128','2013-09-27','10:30:00',1.79),('15128','2013-09-27','10:45:00',1.41),('15128','2013-09-27','10:50:00',2.27),('15128','2013-09-27','10:55:00',1.4),('15128','2013-09-27','11:00:00',1.26),('15128','2013-09-27','11:05:00',1.13),('15128','2013-09-27','11:10:00',1.04),('15128','2013-09-27','11:15:00',2.84),('15128','2013-09-27','11:20:00',2.67),('15128','2013-09-27','11:25:00',2.93),('15128','2013-09-27','11:30:00',2.38),('15128','2013-09-27','11:35:00',2.84),('15128','2013-09-27','11:40:00',3.13),('15128','2013-09-27','11:45:00',1.84),('15128','2013-09-27','11:50:00',2.81),('15128','2013-09-27','11:55:00',3.15),('15128','2013-09-27','12:00:00',3.26),('15128','2013-09-27','12:05:00',2.3),('15128','2013-09-27','12:10:00',3.66),('15128','2013-09-27','12:15:00',3.76),('15128','2013-09-27','12:20:00',3.71),('15128','2013-09-27','12:25:00',3.55),('15128','2013-09-27','12:30:00',3.51),('15128','2013-09-27','12:35:00',3.6),('15128','2013-09-27','12:40:00',3.66),('15128','2013-09-27','12:45:00',3.61),('15128','2013-09-27','12:50:00',3.22),('15128','2013-09-27','12:55:00',3.21),('15128','2013-09-27','13:05:00',3.2),('15128','2013-09-27','13:10:00',3.53),('15128','2013-09-27','13:15:00',3.2),('15128','2013-09-27','13:20:00',3.56),('15128','2013-09-27','13:25:00',3.57),('15128','2013-09-27','13:30:00',3.51),('15128','2013-09-27','13:35:00',2.82),('15128','2013-09-27','13:40:00',3.48),('15128','2013-09-27','13:45:00',2.81),('15128','2013-09-27','13:50:00',3.63),('15128','2013-09-27','13:55:00',3.53),('15128','2013-09-27','14:00:00',3.48),('15128','2013-09-27','14:05:00',3.53),('15128','2013-09-27','14:10:00',3.68),('15128','2013-09-27','14:15:00',3.47),('15128','2013-09-27','14:20:00',3.47),('15128','2013-09-27','14:25:00',3.43),('15128','2013-09-27','14:30:00',3.6),('15128','2013-09-27','14:35:00',1.79),('15128','2013-09-27','14:40:00',3.18),('15128','2013-09-27','14:45:00',3.66),('15128','2013-09-27','14:50:00',3.47),('15128','2013-09-27','14:55:00',2.4),('15128','2013-09-27','15:00:00',2.97),('15128','2013-09-27','15:05:00',3.28),('15128','2013-09-27','15:10:00',3.09),('15128','2013-09-27','15:15:00',2.98),('15128','2013-09-27','15:20:00',3.2),('15128','2013-09-27','15:25:00',2.76),('15128','2013-09-27','15:30:00',2.65),('15128','2013-09-27','15:35:00',2.19),('15128','2013-09-27','15:40:00',3.16),('15128','2013-09-27','15:45:00',2.85),('15128','2013-09-27','15:50:00',2.76),('15128','2013-09-27','15:55:00',2.69),('15128','2013-09-27','16:00:00',2.43),('15128','2013-09-27','16:05:00',2.03),('15128','2013-09-27','16:10:00',2.51),('15128','2013-09-27','16:15:00',2.53),('15128','2013-09-27','16:20:00',2.36),('15128','2013-09-27','16:25:00',1.99),('15128','2013-09-27','16:30:00',2.22),('15128','2013-09-27','16:35:00',2.21),('15128','2013-09-27','16:40:00',2.06),('15128','2013-09-27','16:45:00',1.88),('15128','2013-09-27','16:50:00',1.8),('15128','2013-09-27','16:55:00',1.72),('15128','2013-09-27','17:00:00',1.63),('15128','2013-09-27','17:05:00',1.57),('15128','2013-09-27','17:10:00',1.51),('15128','2013-09-27','17:15:00',1.43),('15128','2013-09-27','17:20:00',1.37),('15128','2013-09-27','17:25:00',1.34),('15128','2013-09-27','17:30:00',1.22),('15128','2013-09-27','17:35:00',1.09),('15128','2013-09-26','09:15:00',1.27),('15128','2013-09-26','09:20:00',1.4),('15128','2013-09-26','09:25:00',1),('15128','2013-09-26','10:05:00',1.8),('15128','2013-09-26','10:10:00',1.93),('15128','2013-09-26','10:15:00',1.95),('15128','2013-09-26','10:20:00',1.57),('15128','2013-09-26','10:25:00',1.83),('15128','2013-09-26','10:30:00',1.91),('15128','2013-09-26','10:35:00',2.04),('15128','2013-09-26','10:40:00',2.17),('15128','2013-09-26','10:45:00',2.17),('15128','2013-09-26','10:50:00',2.24),('15128','2013-09-26','10:55:00',2.26),('15128','2013-09-26','11:00:00',2.32),('15128','2013-09-26','11:05:00',2.37),('15128','2013-09-26','11:10:00',2.42),('15128','2013-09-26','11:15:00',2.51),('15128','2013-09-26','11:20:00',2.55),('15128','2013-09-26','11:25:00',2.73),('15128','2013-09-26','11:30:00',3.15),('15128','2013-09-26','11:35:00',2.69),('15128','2013-09-26','11:40:00',2.44),('15128','2013-09-26','11:45:00',1.35),('15128','2013-09-26','11:50:00',1.95),('15128','2013-09-26','11:55:00',3.47),('15128','2013-09-26','12:00:00',3.83),('15128','2013-09-26','12:05:00',3.35),('15128','2013-09-26','12:10:00',2.49),('15128','2013-09-26','12:15:00',3.04),('15128','2013-09-26','12:20:00',3.75),('15128','2013-09-26','12:25:00',3.83),('15128','2013-09-26','12:30:00',3.78),('15128','2013-09-26','12:35:00',2.23),('15128','2013-09-26','12:50:00',2.49),('15128','2013-09-26','12:55:00',2.12),('15128','2013-09-26','13:00:00',1.89),('15128','2013-09-26','13:05:00',2.35),('15128','2013-09-26','13:10:00',4.13),('15128','2013-09-26','13:15:00',4.11),('15128','2013-09-26','13:20:00',4.1),('15128','2013-09-26','13:25:00',3.99),('15128','2013-09-26','13:30:00',3.95),('15128','2013-09-26','13:35:00',3.37),('15128','2013-09-26','13:41:00',3.9),('15128','2013-09-26','13:45:00',3.83),('15128','2013-09-26','13:50:00',2.94),('15128','2013-09-26','13:55:00',2.94),('15128','2013-09-26','14:00:00',3.88),('15128','2013-09-26','14:05:00',3.67),('15128','2013-09-26','14:10:00',3.54),('15128','2013-09-26','14:15:00',3.51),('15128','2013-09-26','14:20:00',3.09),('15128','2013-09-26','14:25:00',2.98),('15128','2013-09-26','14:30:00',3.56),('15128','2013-09-26','14:35:00',2.43),('15128','2013-09-26','14:40:00',3.46),('15128','2013-09-26','14:45:00',3.63),('15128','2013-09-26','14:50:00',3.46),('15128','2013-09-26','14:55:00',3.22),('15128','2013-09-26','15:00:00',3.41),('15128','2013-09-26','15:05:00',3.22),('15128','2013-09-26','15:10:00',3.25),('15128','2013-09-26','15:15:00',3.24),('15128','2013-09-26','15:20:00',3.21),('15128','2013-09-26','15:25:00',3.12),('15128','2013-09-26','15:30:00',3),('15128','2013-09-26','15:35:00',2.94),('15128','2013-09-26','15:40:00',3.02),('15128','2013-09-26','15:45:00',3.08),('15128','2013-09-26','15:50:00',2.94),('15128','2013-09-26','15:55:00',2.83),('15128','2013-09-26','16:00:00',2.59),('15128','2013-09-26','16:05:00',2.64),('15128','2013-09-26','16:10:00',2.63),('15128','2013-09-26','16:15:00',2.51),('15128','2013-09-26','16:20:00',2.55),('15128','2013-09-26','16:25:00',2.46),('15128','2013-09-26','16:30:00',2.39),('15128','2013-09-26','16:35:00',2.28),('15128','2013-09-26','16:40:00',2.11),('15128','2013-09-26','16:45:00',2.01),('15128','2013-09-26','16:50:00',1.83),('15128','2013-09-26','16:55:00',1.23),('15128','2013-09-26','17:00:00',1.75),('15128','2013-09-26','17:05:00',1.55),('15128','2013-09-26','17:10:00',1.63),('15128','2013-09-26','17:15:00',1.49),('15128','2013-09-26','17:25:00',1.2),('15128','2013-09-26','17:30:00',1.34),('15128','2013-09-25','09:10:00',1.04),('15128','2013-09-25','09:15:00',1.12),('15128','2013-09-25','09:20:00',1.2),('15128','2013-09-25','09:25:00',1.28),('15128','2013-09-25','09:30:00',1.32),('15128','2013-09-25','09:35:00',1.38),('15128','2013-09-25','09:40:00',1.44),('15128','2013-09-25','09:45:00',1.51),('15128','2013-09-25','09:50:00',1.59),('15128','2013-09-25','09:55:00',1.63),('15128','2013-09-25','10:00:00',1.69),('15128','2013-09-25','10:05:00',1.71),('15128','2013-09-25','10:10:00',1.79),('15128','2013-09-25','10:15:00',1.84),('15128','2013-09-25','10:20:00',1.86),('15128','2013-09-25','10:25:00',1.99),('15128','2013-09-25','10:30:00',2.02),('15128','2013-09-25','10:35:00',2.02),('15128','2013-09-25','10:40:00',2.12),('15128','2013-09-25','10:45:00',2.17),('15128','2013-09-25','10:50:00',2.21),('15128','2013-09-25','10:55:00',2.27),('15128','2013-09-25','11:00:00',2.26),('15128','2013-09-25','11:05:00',2.35),('15128','2013-09-25','11:10:00',2.64),('15128','2013-09-25','11:15:00',2.18),('15128','2013-09-25','11:20:00',2.7),('15128','2013-09-25','11:25:00',2.21),('15128','2013-09-25','11:30:00',1.99),('15128','2013-09-25','11:40:00',1.15),('15128','2013-09-25','11:45:00',2.9),('15128','2013-09-25','11:50:00',2.99),('15128','2013-09-25','11:55:00',2.43),('15128','2013-09-25','12:00:00',1.88),('15128','2013-09-25','12:05:00',3.34),('15128','2013-09-25','12:10:00',3.39),('15128','2013-09-25','12:15:00',3.59),('15128','2013-09-25','12:20:00',3.35),('15128','2013-09-25','12:25:00',2.84),('15128','2013-09-25','12:30:00',1.16),('15128','2013-09-25','12:35:00',1.6),('15128','2013-09-25','12:40:00',3.26),('15128','2013-09-25','12:45:00',3.71),('15128','2013-09-25','12:50:00',3.24),('15128','2013-09-25','12:55:00',3.79),('15128','2013-09-25','13:00:00',3.58),('15128','2013-09-25','13:05:00',3.6),('15128','2013-09-25','13:10:00',3.66),('15128','2013-09-25','13:15:00',3.64),('15128','2013-09-25','13:20:00',2.87),('15128','2013-09-25','13:25:00',1.31),('15128','2013-09-25','13:30:00',1.81),('15128','2013-09-25','13:35:00',1.16),('15128','2013-09-25','13:40:00',1.36),('15128','2013-09-25','13:45:00',1.68),('15128','2013-09-25','13:50:00',1.93),('15128','2013-09-25','13:55:00',3.11),('15128','2013-09-25','14:00:00',2.41),('15128','2013-09-25','14:05:00',3.53),('15128','2013-09-25','14:10:00',3.78),('15128','2013-09-25','14:15:00',3.71),('15128','2013-09-25','14:20:00',2.21),('15128','2013-09-25','14:25:00',3.43),('15128','2013-09-25','14:30:00',3.66),('15128','2013-09-25','14:35:00',3.28),('15128','2013-09-25','14:40:00',2.66),('15128','2013-09-25','14:45:00',3.53),('15128','2013-09-25','14:50:00',3.45),('15128','2013-09-25','14:55:00',3.17),('15128','2013-09-25','15:00:00',2.13),('15128','2013-09-25','15:05:00',1.43),('15128','2013-09-25','15:10:00',3.17),('15128','2013-09-25','15:15:00',3.43),('15128','2013-09-25','15:20:00',3.29),('15128','2013-09-25','15:25:00',3.14),('15128','2013-09-25','15:30:00',3.04),('15128','2013-09-25','15:35:00',3.06),('15128','2013-09-25','15:40:00',3.04),('15128','2013-09-25','15:45:00',3.11),('15128','2013-09-25','15:50:00',2.93),('15128','2013-09-25','15:55:00',2.82),('15128','2013-09-25','16:00:00',2.7),('15128','2013-09-25','16:05:00',2.71),('15128','2013-09-25','16:10:00',2.67),('15128','2013-09-25','16:15:00',2.59),('15128','2013-09-25','16:20:00',2.56),('15128','2013-09-25','16:25:00',2.49),('15128','2013-09-25','16:30:00',2.08),('15128','2013-09-25','16:35:00',2.3),('15128','2013-09-25','16:40:00',2.09),('15128','2013-09-25','16:45:00',2.04),('15128','2013-09-25','16:50:00',1.91),('15128','2013-09-25','16:55:00',1.8),('15128','2013-09-25','17:00:00',1.59),('15128','2013-09-25','17:05:00',1.31),('15128','2013-09-25','17:10:00',1.41),('15128','2013-09-25','17:15:00',1.67),('15128','2013-09-25','17:20:00',1.74),('15128','2013-09-25','17:25:00',1.61),('15128','2013-09-25','17:30:00',1.38),('15128','2013-09-25','17:35:00',1.27),('15128','2013-09-25','17:40:00',1.12),('15128','2013-09-25','17:45:00',1.03),('15128','2013-09-24','10:05:00',1.08),('15128','2013-09-24','10:10:00',1.48),('15128','2013-09-24','10:15:00',1.89),('15128','2013-09-24','10:20:00',1.73),('15128','2013-09-24','10:25:00',1.96),('15128','2013-09-24','10:30:00',1.81),('15128','2013-09-24','10:35:00',2.1),('15128','2013-09-24','10:40:00',2.39),('15128','2013-09-24','10:45:00',2.65),('15128','2013-09-24','10:50:00',2.88),('15128','2013-09-24','10:55:00',2.26),('15128','2013-09-24','11:00:00',1.82),('15128','2013-09-24','11:20:00',1.75),('15128','2013-09-24','11:25:00',2.97),('15128','2013-09-24','11:30:00',2.98),('15128','2013-09-24','11:35:00',3.23),('15128','2013-09-24','11:40:00',2.93),('15128','2013-09-24','11:45:00',3.22),('15128','2013-09-24','11:50:00',2.37),('15128','2013-09-24','12:05:00',1.96),('15128','2013-09-24','12:10:00',3.75),('15128','2013-09-24','12:15:00',2.5),('15128','2013-09-24','12:20:00',3.87),('15128','2013-09-24','12:25:00',3.33),('15128','2013-09-24','12:30:00',1.5),('15128','2013-09-24','12:35:00',1.49),('15128','2013-09-24','12:40:00',4.08),('15128','2013-09-24','12:45:00',4.08),('15128','2013-09-24','12:50:00',4.12),('15128','2013-09-24','12:55:00',4.15),('15128','2013-09-24','13:00:00',4.4),('15128','2013-09-24','13:05:00',4.23),('15128','2013-09-24','13:10:00',1.78),('15128','2013-09-24','13:15:00',4.02),('15128','2013-09-24','13:20:00',4.03),('15128','2013-09-24','13:25:00',4.04),('15128','2013-09-24','13:30:00',4.17),('15128','2013-09-24','13:35:00',4.21),('15128','2013-09-24','13:40:00',3.99),('15128','2013-09-24','13:45:00',3.92),('15128','2013-09-24','13:50:00',4.17),('15128','2013-09-24','13:55:00',4.16),('15128','2013-09-24','14:00:00',3.91),('15128','2013-09-24','14:05:00',3.93),('15128','2013-09-24','14:10:00',3.92),('15128','2013-09-24','14:15:00',3.87),('15128','2013-09-24','14:20:00',3.39),('15128','2013-09-24','14:25:00',2.84),('15128','2013-09-24','14:30:00',3.83),('15128','2013-09-24','14:35:00',3.87),('15128','2013-09-24','14:40:00',3.99),('15128','2013-09-24','14:45:00',3.12),('15128','2013-09-24','14:50:00',2.91),('15128','2013-09-24','14:55:00',2.74),('15128','2013-09-24','15:00:00',2.14),('15128','2013-09-24','15:05:00',3.47),('15128','2013-09-24','15:10:00',2.82),('15128','2013-09-24','15:15:00',3.21),('15128','2013-09-24','15:20:00',3.53),('15128','2013-09-24','15:25:00',3.14),('15128','2013-09-24','15:30:00',3.45),('15128','2013-09-24','15:35:00',3.2),('15128','2013-09-24','15:40:00',3.09),('15128','2013-09-24','15:45:00',3.07),('15128','2013-09-24','15:50:00',3.2),('15128','2013-09-24','15:55:00',3.15),('15128','2013-09-24','16:00:00',3.13),('15128','2013-09-24','16:05:00',3.04),('15128','2013-09-24','16:10:00',2.9),('15128','2013-09-24','16:15:00',2.84),('15128','2013-09-24','16:20:00',2.75),('15128','2013-09-24','16:25:00',2.67),('15128','2013-09-24','16:30:00',2.56),('15128','2013-09-24','16:35:00',2.47),('15128','2013-09-24','16:40:00',2.36),('15128','2013-09-24','16:45:00',2.24),('15128','2013-09-24','16:50:00',2.1),('15128','2013-09-24','16:55:00',1.99),('15128','2013-09-24','17:00:00',1.87),('15128','2013-09-24','17:05:00',1.75),('15128','2013-09-24','17:10:00',1.68),('15128','2013-09-24','17:15:00',1.65),('15128','2013-09-24','17:20:00',1.62),('15128','2013-09-24','17:25:00',1.56),('15128','2013-09-24','17:30:00',1.5),('15128','2013-09-24','17:35:00',1.42),('15128','2013-09-24','17:40:00',1.31),('15128','2013-09-24','17:45:00',1.17),('15128','2013-09-24','17:50:00',1.06),('15128','2013-09-23','09:10:00',1.1),('15128','2013-09-23','09:15:00',1.18),('15128','2013-09-23','09:20:00',1.26),('15128','2013-09-23','09:25:00',1.34),('15128','2013-09-23','09:30:00',1.39),('15128','2013-09-23','09:35:00',1.44),('15128','2013-09-23','09:40:00',1.48),('15128','2013-09-23','09:45:00',1.57),('15128','2013-09-23','09:50:00',1.66),('15128','2013-09-23','09:55:00',1.72),('15128','2013-09-23','10:00:00',1.76),('15128','2013-09-23','10:05:00',1.78),('15128','2013-09-23','10:10:00',1.84),('15128','2013-09-23','10:15:00',1.88),('15128','2013-09-23','10:20:00',1.99),('15128','2013-09-23','10:25:00',2.05),('15128','2013-09-23','10:30:00',2.07),('15128','2013-09-23','10:35:00',2.12),('15128','2013-09-23','10:40:00',2.19),('15128','2013-09-23','10:45:00',2.26),('15128','2013-09-23','10:50:00',2.32),('15128','2013-09-23','10:55:00',2.41),('15128','2013-09-23','11:00:00',2.45),('15128','2013-09-23','11:05:00',2.46),('15128','2013-09-23','11:10:00',2.54),('15128','2013-09-23','11:15:00',2.62),('15128','2013-09-23','11:20:00',2.71),('15128','2013-09-23','11:25:00',2.71),('15128','2013-09-23','11:30:00',2.69),('15128','2013-09-23','11:35:00',2.77),('15128','2013-09-23','11:40:00',2.89),('15128','2013-09-23','11:45:00',2.95),('15128','2013-09-23','11:50:00',3.06),('15128','2013-09-23','11:55:00',3.12),('15128','2013-09-23','12:00:00',3.26),('15128','2013-09-23','12:05:00',3.3),('15128','2013-09-23','12:10:00',3.35),('15128','2013-09-23','12:15:00',3.4),('15128','2013-09-23','12:20:00',3.43),('15128','2013-09-23','12:25:00',3.46),('15128','2013-09-23','12:30:00',3.48),('15128','2013-09-23','12:35:00',3.51),('15128','2013-09-23','12:40:00',3.55),('15128','2013-09-23','12:45:00',3.58),('15128','2013-09-23','12:50:00',3.59),('15128','2013-09-23','12:55:00',3.6),('15128','2013-09-23','13:00:00',3.64),('15128','2013-09-23','13:05:00',3.65),('15128','2013-09-23','13:10:00',3.66),('15128','2013-09-23','13:15:00',3.64),('15128','2013-09-23','13:20:00',3.67),('15128','2013-09-23','13:25:00',3.65),('15128','2013-09-23','13:30:00',3.64),('15128','2013-09-23','13:35:00',3.66),('15128','2013-09-23','13:40:00',3.68),('15128','2013-09-23','13:45:00',3.67),('15128','2013-09-23','13:50:00',3.68),('15128','2013-09-23','13:55:00',3.7),('15128','2013-09-23','14:00:00',3.7),('15128','2013-09-23','14:05:00',3.71),('15128','2013-09-23','14:10:00',3.7),('15128','2013-09-23','14:15:00',3.68),('15128','2013-09-23','14:20:00',3.67),('15128','2013-09-23','14:25:00',3.66),('15128','2013-09-23','14:30:00',3.63),('15128','2013-09-23','14:35:00',3.64),('15128','2013-09-23','14:40:00',3.61),('15128','2013-09-23','14:45:00',3.58),('15128','2013-09-23','14:50:00',3.56),('15128','2013-09-23','14:55:00',3.51),('15128','2013-09-23','15:00:00',3.47),('15128','2013-09-23','15:05:00',3.45),('15128','2013-09-23','15:10:00',3.41),('15128','2013-09-23','15:15:00',3.37),('15128','2013-09-23','15:20:00',3.34),('15128','2013-09-23','15:25:00',3.32),('15128','2013-09-23','15:30:00',3.28),('15128','2013-09-23','15:35:00',3.25),('15128','2013-09-23','15:40:00',3.2),('15128','2013-09-23','15:45:00',3.16),('15128','2013-09-23','15:50:00',3.11),('15128','2013-09-23','15:55:00',3.06),('15128','2013-09-23','16:00:00',2.99),('15128','2013-09-23','16:05:00',2.94),('15128','2013-09-23','16:10:00',2.9),('15128','2013-09-23','16:15:00',2.81),('15128','2013-09-23','16:20:00',2.74),('15128','2013-09-23','16:25:00',2.69),('15128','2013-09-23','16:30:00',2.63),('15128','2013-09-23','16:35:00',2.52),('15128','2013-09-23','16:40:00',2.4),('15128','2013-09-23','16:45:00',2.29),('15128','2013-09-23','16:50:00',2.14),('15128','2013-09-23','16:55:00',2.02),('15128','2013-09-23','17:00:00',1.94),('15128','2013-09-23','17:05:00',1.86),('15128','2013-09-23','17:10:00',1.81),('15128','2013-09-23','17:15:00',1.73),('15128','2013-09-23','17:20:00',1.69),('15128','2013-09-23','17:25:00',1.63),('15128','2013-09-23','17:30:00',1.56),('15128','2013-09-23','17:35:00',1.49),('15128','2013-09-23','17:40:00',1.38),('15128','2013-09-23','17:45:00',1.25),('15128','2013-09-23','17:50:00',1.11),('15128','2013-09-23','17:55:00',1.05),('15128','2013-09-22','09:05:00',1.02),('15128','2013-09-22','09:10:00',1.13),('15128','2013-09-22','09:15:00',1.21),('15128','2013-09-22','09:20:00',1.3),('15128','2013-09-22','09:25:00',1.37),('15128','2013-09-22','09:30:00',1.43),('15128','2013-09-22','09:35:00',1.48),('15128','2013-09-22','09:40:00',1.52),('15128','2013-09-22','09:45:00',1.61),('15128','2013-09-22','09:50:00',1.69),('15128','2013-09-22','09:55:00',1.75),('15128','2013-09-22','10:00:00',1.75),('15128','2013-09-22','10:05:00',1.8),('15128','2013-09-22','10:10:00',1.87),('15128','2013-09-22','10:15:00',1.9),('15128','2013-09-22','10:20:00',2.01),('15128','2013-09-22','10:25:00',2.05),('15128','2013-09-22','10:30:00',2.09),('15128','2013-09-22','10:35:00',2.18),('15128','2013-09-22','10:40:00',2.25),('15128','2013-09-22','10:45:00',2.32),('15128','2013-09-22','10:50:00',2.35),('15128','2013-09-22','10:55:00',2.47),('15128','2013-09-22','11:00:00',2.49),('15128','2013-09-22','11:05:00',2.52),('15128','2013-09-22','11:10:00',2.61),('15128','2013-09-22','11:15:00',2.69),('15128','2013-09-22','11:20:00',2.7),('15128','2013-09-22','11:25:00',2.8),('15128','2013-09-22','11:30:00',2.77),('15128','2013-09-22','11:35:00',2.89),('15128','2013-09-22','11:40:00',3),('15128','2013-09-22','11:45:00',3.08),('15128','2013-09-22','11:50:00',3.11),('15128','2013-09-22','11:55:00',3.16),('15128','2013-09-22','12:00:00',3.35),('15128','2013-09-22','12:05:00',3.38),('15128','2013-09-22','12:10:00',3.42),('15128','2013-09-22','12:15:00',3.44),('15128','2013-09-22','12:20:00',3.44),('15128','2013-09-22','12:25:00',3.52),('15128','2013-09-22','12:30:00',3.55),('15128','2013-09-22','12:35:00',3.56),('15128','2013-09-22','12:40:00',3.59),('15128','2013-09-22','12:45:00',3.64),('15128','2013-09-22','12:50:00',3.65),('15128','2013-09-22','12:55:00',3.67),('15128','2013-09-22','13:00:00',3.67),('15128','2013-09-22','13:05:00',3.67),('15128','2013-09-22','13:10:00',3.68),('15128','2013-09-22','13:15:00',3.68),('15128','2013-09-22','13:20:00',3.67),('15128','2013-09-22','13:25:00',3.67),('15128','2013-09-22','13:30:00',3.68),('15128','2013-09-22','13:35:00',3.68),('15128','2013-09-22','13:40:00',3.68),('15128','2013-09-22','13:45:00',3.68),('15128','2013-09-22','13:50:00',3.67),('15128','2013-09-22','13:55:00',3.66),('15128','2013-09-22','14:00:00',3.64),('15128','2013-09-22','14:05:00',3.63),('15128','2013-09-22','14:10:00',3.63),('15128','2013-09-22','14:15:00',3.71),('15128','2013-09-22','14:20:00',3.76),('15128','2013-09-22','14:25:00',3.14),('15128','2013-09-22','14:30:00',3.57),('15128','2013-09-22','14:35:00',3.52),('15128','2013-09-22','14:40:00',3.59),('15128','2013-09-22','14:45:00',3.07),('15128','2013-09-22','14:50:00',2.87),('15128','2013-09-22','14:55:00',3.43),('15128','2013-09-22','15:00:00',3.33),('15128','2013-09-22','15:05:00',3.36),('15128','2013-09-22','15:10:00',3.33),('15128','2013-09-22','15:15:00',3.3),('15128','2013-09-22','15:20:00',3.25),('15128','2013-09-22','15:25:00',3.22),('15128','2013-09-22','15:30:00',3.24),('15128','2013-09-22','15:35:00',3.21),('15128','2013-09-22','15:40:00',3.12),('15128','2013-09-22','15:45:00',3.06),('15128','2013-09-22','15:50:00',3.08),('15128','2013-09-22','15:55:00',2.97),('15128','2013-09-22','16:00:00',2.9),('15128','2013-09-22','16:05:00',2.82),('15128','2013-09-22','16:10:00',2.79),('15128','2013-09-22','16:15:00',2.73),('15128','2013-09-22','16:20:00',2.73),('15128','2013-09-22','16:25:00',2.66),('15128','2013-09-22','16:30:00',2.56),('15128','2013-09-22','16:35:00',2.47),('15128','2013-09-22','16:40:00',2.4),('15128','2013-09-22','16:45:00',2.24),('15128','2013-09-22','16:50:00',2.13),('15128','2013-09-22','16:55:00',2.06),('15128','2013-09-22','17:00:00',1.97),('15128','2013-09-22','17:05:00',1.86),('15128','2013-09-22','17:10:00',1.79),('15128','2013-09-22','17:15:00',1.69),('15128','2013-09-22','17:20:00',1.64),('15128','2013-09-22','17:25:00',1.59),('15128','2013-09-22','17:30:00',1.51),('15128','2013-09-22','17:35:00',1.45),('15128','2013-09-22','17:40:00',1.33),('15128','2013-09-22','17:45:00',1.19),('15128','2013-09-22','17:50:00',1.06),('15128','2013-09-21','09:05:00',1.03),('15128','2013-09-21','09:10:00',1.13),('15128','2013-09-21','09:15:00',1.2),('15128','2013-09-21','09:20:00',1.29),('15128','2013-09-21','09:25:00',1.36),('15128','2013-09-21','09:30:00',1.43),('15128','2013-09-21','09:35:00',1.49),('15128','2013-09-21','09:40:00',1.53),('15128','2013-09-21','09:45:00',1.64),('15128','2013-09-21','09:50:00',1.72),('15128','2013-09-21','09:55:00',1.79),('15128','2013-09-21','10:00:00',1.81),('15128','2013-09-21','10:05:00',1.85),('15128','2013-09-21','10:10:00',1.91),('15128','2013-09-21','10:15:00',1.99),('15128','2013-09-21','10:20:00',2.06),('15128','2013-09-21','10:25:00',2.1),('15128','2013-09-21','10:30:00',2.15),('15128','2013-09-21','10:35:00',2.23),('15128','2013-09-21','10:40:00',2.28),('15128','2013-09-21','10:45:00',2.37),('15128','2013-09-21','10:50:00',2.42),('15128','2013-09-21','10:55:00',2.49),('15128','2013-09-21','11:00:00',2.54),('15128','2013-09-21','11:05:00',2.63),('15128','2013-09-21','11:10:00',2.67),('15128','2013-09-21','11:15:00',2.75),('15128','2013-09-21','11:20:00',2.75),('15128','2013-09-21','11:25:00',2.84),('15128','2013-09-21','11:30:00',2.91),('15128','2013-09-21','11:35:00',2.96),('15128','2013-09-21','11:40:00',3.03),('15128','2013-09-21','11:45:00',3.05),('15128','2013-09-21','11:50:00',3.15),('15128','2013-09-21','11:55:00',3.26),('15128','2013-09-21','12:00:00',3.37),('15128','2013-09-21','12:05:00',3.42),('15128','2013-09-21','12:10:00',3.47),('15128','2013-09-21','12:15:00',3.5),('15128','2013-09-21','12:20:00',3.51),('15128','2013-09-21','12:25:00',3.54),('15128','2013-09-21','12:30:00',3.62),('15128','2013-09-21','12:35:00',3.66),('15128','2013-09-21','12:40:00',3.68),('15128','2013-09-21','12:45:00',3.71),('15128','2013-09-21','12:50:00',3.72),('15128','2013-09-21','12:55:00',3.74),('15128','2013-09-21','13:00:00',3.76),('15128','2013-09-21','13:05:00',3.79),('15128','2013-09-21','13:10:00',3.78),('15128','2013-09-21','13:15:00',3.81),('15128','2013-09-21','13:20:00',3.83),('15128','2013-09-21','13:25:00',3.86),('15128','2013-09-21','13:30:00',3.97),('15128','2013-09-21','13:35:00',4.14),('15128','2013-09-21','13:40:00',3.38),('15128','2013-09-21','13:45:00',3.68),('15128','2013-09-21','13:50:00',2.6),('15128','2013-09-21','13:55:00',2.53),('15128','2013-09-21','14:00:00',3.6),('15128','2013-09-21','14:05:00',3.49),('15128','2013-09-21','14:10:00',4.14),('15128','2013-09-21','14:15:00',3.92),('15128','2013-09-21','14:20:00',4.08),('15128','2013-09-21','14:25:00',3.32),('15128','2013-09-21','14:30:00',1.43),('15128','2013-09-21','14:35:00',3.95),('15128','2013-09-21','14:40:00',3.15),('15128','2013-09-21','14:45:00',3.79),('15128','2013-09-21','14:50:00',3.8),('15128','2013-09-21','14:55:00',3.89),('15128','2013-09-21','15:00:00',1.59),('15128','2013-09-21','15:05:00',1.46),('15128','2013-09-21','15:10:00',2.27),('15128','2013-09-21','15:15:00',2.22),('15128','2013-09-21','15:20:00',1.78),('15128','2013-09-21','15:25:00',1.49),('15128','2013-09-21','15:30:00',3.75),('15128','2013-09-21','15:35:00',3.98),('15128','2013-09-21','15:40:00',3.47),('15128','2013-09-21','15:45:00',3.4),('15128','2013-09-21','15:50:00',3.49),('15128','2013-09-21','15:55:00',3.54),('15128','2013-09-21','16:00:00',3.5),('15128','2013-09-21','16:05:00',3.35),('15128','2013-09-21','16:10:00',2.16),('15128','2013-09-21','16:15:00',1.87),('15128','2013-09-21','16:20:00',2.06),('15128','2013-09-21','16:25:00',1.22),('15128','2013-09-21','16:30:00',1.11),('15128','2013-09-21','16:35:00',1.14),('15128','2013-09-21','16:40:00',1.23),('15128','2013-09-21','16:45:00',1.27),('15128','2013-09-21','16:50:00',2.13),('15128','2013-09-21','16:55:00',2.52),('15128','2013-09-21','17:00:00',2.33),('15128','2013-09-21','17:05:00',2.07),('15128','2013-09-21','17:10:00',1.97),('15128','2013-09-21','17:15:00',1.86),('15128','2013-09-21','17:20:00',1.81),('15128','2013-09-21','17:25:00',1.74),('15128','2013-09-21','17:30:00',1.58),('15128','2013-09-20','09:05:00',1.05),('15128','2013-09-20','09:10:00',1.15),('15128','2013-09-20','09:15:00',1.22),('15128','2013-09-20','09:20:00',1.31),('15128','2013-09-20','09:25:00',1.38),('15128','2013-09-20','09:30:00',1.44),('15128','2013-09-20','09:35:00',1.49),('15128','2013-09-20','09:40:00',1.52),('15128','2013-09-20','09:45:00',1.63),('15128','2013-09-20','09:50:00',1.64),('15128','2013-09-20','09:55:00',1.74),('15128','2013-09-20','10:00:00',1.78),('15128','2013-09-20','10:05:00',1.82),('15128','2013-09-20','10:10:00',1.85),('15128','2013-09-20','10:15:00',1.92),('15128','2013-09-20','10:20:00',1.99),('15128','2013-09-20','10:25:00',2.04),('15128','2013-09-20','10:30:00',2.08),('15128','2013-09-20','10:35:00',2.14),('15128','2013-09-20','10:40:00',2.24),('15128','2013-09-20','10:45:00',2.31),('15128','2013-09-20','10:50:00',2.34),('15128','2013-09-20','10:55:00',2.39),('15128','2013-09-20','11:00:00',2.43),('15128','2013-09-20','11:05:00',2.51),('15128','2013-09-20','11:10:00',2.57),('15128','2013-09-20','11:15:00',2.65),('15128','2013-09-20','11:20:00',2.67),('15128','2013-09-20','11:25:00',2.78),('15128','2013-09-20','11:30:00',2.73),('15128','2013-09-20','11:35:00',2.84),('15128','2013-09-20','11:40:00',2.9),('15128','2013-09-20','11:45:00',2.79),('15128','2013-09-20','11:50:00',3.11),('15128','2013-09-20','11:55:00',3.27),('15128','2013-09-20','12:00:00',3.37),('15128','2013-09-20','12:05:00',3.41),('15128','2013-09-20','12:10:00',3.45),('15128','2013-09-20','12:15:00',3.21),('15128','2013-09-20','12:20:00',3.03),('15128','2013-09-20','12:25:00',3.28),('15128','2013-09-20','12:30:00',3.06),('15128','2013-09-20','12:35:00',3.53),('15128','2013-09-20','12:40:00',3.03),('15128','2013-09-20','12:45:00',3.38),('15128','2013-09-20','12:50:00',3.68),('15128','2013-09-20','12:55:00',2.59),('15128','2013-09-20','13:00:00',3.56),('15128','2013-09-20','13:05:00',3.65),('15128','2013-09-20','13:10:00',3.8),('15128','2013-09-20','13:15:00',3.52),('15128','2013-09-20','13:20:00',2.4),('15128','2013-09-20','13:25:00',3.38),('15128','2013-09-20','13:30:00',3.15),('15128','2013-09-20','13:35:00',3.68),('15128','2013-09-20','13:40:00',3.78),('15128','2013-09-20','13:45:00',3.73),('15128','2013-09-20','13:50:00',3.71),('15128','2013-09-20','13:55:00',3.71),('15128','2013-09-20','14:00:00',3.49),('15128','2013-09-20','14:05:00',3.67),('15128','2013-09-20','14:10:00',3.65),('15128','2013-09-20','14:15:00',3.49),('15128','2013-09-20','14:20:00',3.65),('15128','2013-09-20','14:25:00',3.61),('15128','2013-09-20','14:30:00',3.56),('15128','2013-09-20','14:35:00',3.53),('15128','2013-09-20','14:40:00',3.52),('15128','2013-09-20','14:45:00',3.5),('15128','2013-09-20','14:50:00',3.47),('15128','2013-09-20','14:55:00',3.44),('15128','2013-09-20','15:00:00',3.27),('15128','2013-09-20','15:05:00',3.36),('15128','2013-09-20','15:10:00',3.34),('15128','2013-09-20','15:15:00',3.31),('15128','2013-09-20','15:20:00',3.27),('15128','2013-09-20','15:25:00',3.24),('15128','2013-09-20','15:30:00',3.2),('15128','2013-09-20','15:35:00',3.18),('15128','2013-09-20','15:40:00',3.16),('15128','2013-09-20','15:45:00',3.14),('15128','2013-09-20','15:50:00',3.14),('15128','2013-09-20','15:55:00',2.37),('15128','2013-09-20','16:00:00',2.54),('15128','2013-09-20','16:05:00',1.83),('15128','2013-09-20','16:10:00',2.21),('15128','2013-09-20','16:15:00',2.11),('15128','2013-09-20','16:20:00',1.25),('15128','2013-09-20','16:25:00',2.05),('15128','2013-09-20','16:30:00',2.26),('15128','2013-09-20','16:35:00',1.02),('15128','2013-09-20','16:40:00',1.28),('15128','2013-09-20','16:45:00',1.36),('15128','2013-09-20','16:55:00',1.22),('15128','2013-09-20','17:00:00',1.49),('15128','2013-09-20','17:05:00',1.16),('15128','2013-09-20','17:10:00',1.73),('15128','2013-09-20','17:15:00',1.05),('15128','2013-09-20','17:30:00',1.36),('15128','2013-09-20','17:35:00',1.31),('15128','2013-09-20','17:40:00',1.37),('15128','2013-09-20','17:45:00',1.18),('15128','2013-09-20','17:50:00',1.03),('15128','2013-09-19','09:25:00',1),('15128','2013-09-19','09:35:00',1.09),('15128','2013-09-19','09:40:00',1.2),('15128','2013-09-19','09:45:00',1.3),('15128','2013-09-19','09:50:00',1.31),('15128','2013-09-19','09:55:00',1.34),('15128','2013-09-19','10:00:00',1.41),('15128','2013-09-19','10:05:00',1.54),('15128','2013-09-19','10:10:00',1.67),('15128','2013-09-19','10:15:00',1.94),('15128','2013-09-19','10:20:00',2.5),('15128','2013-09-19','10:25:00',2.78),('15128','2013-09-19','10:30:00',2.62),('15128','2013-09-19','10:35:00',2.19),('15128','2013-09-19','10:40:00',2.2),('15128','2013-09-19','10:45:00',2.17),('15128','2013-09-19','10:50:00',2.02),('15128','2013-09-19','10:55:00',2.51),('15128','2013-09-19','11:00:00',2.59),('15128','2013-09-19','11:05:00',2.57),('15128','2013-09-19','11:10:00',2.45),('15128','2013-09-19','11:15:00',2.62),('15128','2013-09-19','11:20:00',2.35),('15128','2013-09-19','11:25:00',2.15),('15128','2013-09-19','11:30:00',2.31),('15128','2013-09-19','11:35:00',2.27),('15128','2013-09-19','11:40:00',2.36),('15128','2013-09-19','11:45:00',3.28),('15128','2013-09-19','11:50:00',2.06),('15128','2013-09-19','11:55:00',3.16),('15128','2013-09-19','12:00:00',3.63),('15128','2013-09-19','12:05:00',3.85),('15128','2013-09-19','12:10:00',3.64),('15128','2013-09-19','12:15:00',3.56),('15128','2013-09-19','12:20:00',3.58),('15128','2013-09-19','12:25:00',3.68),('15128','2013-09-19','12:30:00',3.7),('15128','2013-09-19','12:35:00',3.57),('15128','2013-09-19','12:40:00',1.89),('15128','2013-09-19','12:45:00',3.38),('15128','2013-09-19','12:50:00',3.79),('15128','2013-09-19','12:55:00',3.7),('15128','2013-09-19','13:00:00',3.67),('15128','2013-09-19','13:05:00',3.67),('15128','2013-09-19','13:10:00',3.67),('15128','2013-09-19','13:15:00',3.67),('15128','2013-09-19','13:20:00',3.73),('15128','2013-09-19','13:25:00',3.74),('15128','2013-09-19','13:30:00',3.75),('15128','2013-09-19','13:35:00',3.79),('15128','2013-09-19','13:40:00',3.77),('15128','2013-09-19','13:45:00',3.63),('15128','2013-09-19','13:50:00',3.67),('15128','2013-09-19','13:55:00',3.22),('15128','2013-09-19','14:00:00',3.39),('15128','2013-09-19','14:05:00',2.57),('15128','2013-09-19','14:10:00',2.63),('15128','2013-09-19','14:15:00',3.77),('15128','2013-09-19','14:20:00',3.82),('15128','2013-09-19','14:25:00',3.83),('15128','2013-09-19','14:30:00',3.16),('15128','2013-09-19','14:35:00',3.53),('15128','2013-09-19','14:40:00',3.77),('15128','2013-09-19','14:45:00',3.81),('15128','2013-09-19','14:50:00',3.61),('15128','2013-09-19','14:55:00',3.37),('15128','2013-09-19','15:00:00',3.35),('15128','2013-09-19','15:05:00',3.38),('15128','2013-09-19','15:10:00',1.48),('15128','2013-09-19','15:15:00',2.05),('15128','2013-09-19','15:20:00',3.47),('15128','2013-09-19','15:25:00',3.14),('15128','2013-09-19','15:30:00',3.11),('15128','2013-09-19','15:35:00',3.2),('15128','2013-09-19','15:40:00',3.4),('15128','2013-09-19','15:45:00',3.34),('15128','2013-09-19','15:50:00',2.74),('15128','2013-09-19','15:55:00',3.03),('15128','2013-09-19','16:00:00',3.18),('15128','2013-09-19','16:05:00',3.18),('15128','2013-09-19','16:10:00',3.22),('15128','2013-09-19','16:15:00',3.2),('15128','2013-09-19','16:20:00',3.17),('15128','2013-09-19','16:25:00',1.6),('15128','2013-09-19','16:30:00',1.21),('15128','2013-09-19','16:45:00',1.37),('15128','2013-09-19','16:50:00',2.07),('15128','2013-09-19','16:55:00',2.4),('15128','2013-09-19','17:00:00',2.4),('15128','2013-09-19','17:05:00',2.38),('15128','2013-09-19','17:10:00',2.38),('15128','2013-09-19','17:15:00',2.41),('15128','2013-09-19','17:20:00',2.33),('15128','2013-09-19','17:25:00',2.23),('15128','2013-09-19','17:30:00',2.3),('15128','2013-09-19','17:35:00',2.1),('15128','2013-09-19','17:40:00',2.11),('15128','2013-09-19','17:45:00',1.7),('15128','2013-09-19','17:50:00',1.05),('15128','2013-09-19','17:55:00',1.01),('15128','2013-09-18','09:05:00',1.16),('15128','2013-09-18','09:10:00',1),('15128','2013-09-18','09:25:00',1.26),('15128','2013-09-18','09:30:00',1.15),('15128','2013-09-18','09:35:00',1.52),('15128','2013-09-18','09:40:00',1.66),('15128','2013-09-18','09:45:00',1.76),('15128','2013-09-18','09:50:00',1.79),('15128','2013-09-18','09:55:00',1.42),('15128','2013-09-18','10:50:00',1.09),('15128','2013-09-18','10:55:00',2.03),('15128','2013-09-18','11:00:00',2.74),('15128','2013-09-18','11:05:00',2.56),('15128','2013-09-18','11:15:00',1.64),('15128','2013-09-18','11:20:00',2.93),('15128','2013-09-18','11:25:00',2.56),('15128','2013-09-18','11:30:00',2.29),('15128','2013-09-18','11:35:00',2.79),('15128','2013-09-18','11:40:00',2.13),('15128','2013-09-18','11:45:00',2.53),('15128','2013-09-18','11:50:00',1.51),('15128','2013-09-18','11:55:00',3.8),('15128','2013-09-18','12:00:00',2.43),('15128','2013-09-18','12:05:00',3.76),('15128','2013-09-18','12:10:00',2.72),('15128','2013-09-18','12:15:00',1.59),('15128','2013-09-18','12:20:00',2.21),('15128','2013-09-18','12:25:00',3.07),('15128','2013-09-18','12:30:00',3.06),('15128','2013-09-18','12:35:00',4.08),('15128','2013-09-18','12:40:00',3.1),('15128','2013-09-18','12:45:00',2.07),('15128','2013-09-18','12:50:00',4.19),('15128','2013-09-18','12:55:00',4.17),('15128','2013-09-18','13:00:00',4.28),('15128','2013-09-18','13:05:00',3.02),('15128','2013-09-18','13:10:00',3.98),('15128','2013-09-18','13:15:00',4.22),('15128','2013-09-18','13:20:00',4.15),('15128','2013-09-18','13:25:00',4.23),('15128','2013-09-18','13:30:00',4.28),('15128','2013-09-18','13:35:00',2.3),('15128','2013-09-18','13:40:00',1.59),('15128','2013-09-18','13:45:00',3.05),('15128','2013-09-18','13:50:00',4.33),('15128','2013-09-18','13:55:00',3.18),('15128','2013-09-18','14:00:00',4.12),('15128','2013-09-18','14:05:00',3.95),('15128','2013-09-18','14:10:00',3.91),('15128','2013-09-18','14:15:00',3.85),('15128','2013-09-18','14:20:00',3.85),('15128','2013-09-18','14:25:00',3.84),('15128','2013-09-18','14:30:00',3.82),('15128','2013-09-18','14:35:00',3.04),('15128','2013-09-18','14:40:00',3.75),('15128','2013-09-18','14:45:00',3.75),('15128','2013-09-18','14:50:00',3.24),('15128','2013-09-18','14:55:00',3.59),('15128','2013-09-18','15:00:00',3.6),('15128','2013-09-18','15:05:00',3.67),('15128','2013-09-18','15:10:00',3.88),('15128','2013-09-18','15:15:00',3.65),('15128','2013-09-18','15:20:00',3.44),('15128','2013-09-18','15:25:00',3.71),('15128','2013-09-18','15:30:00',3.42),('15128','2013-09-18','15:35:00',3.25),('15128','2013-09-18','15:40:00',3.1),('15128','2013-09-18','15:45:00',2.22),('15128','2013-09-18','15:50:00',1.67),('15128','2013-09-18','15:55:00',1.43),('15128','2013-09-18','16:00:00',1.72),('15128','2013-09-18','16:05:00',1.88),('15128','2013-09-18','16:10:00',2.99),('15128','2013-09-18','16:15:00',2.98),('15128','2013-09-18','16:20:00',2.55),('15128','2013-09-18','16:25:00',2.67),('15128','2013-09-18','16:30:00',2.38),('15128','2013-09-18','16:35:00',2.62),('15128','2013-09-18','16:40:00',1.87),('15128','2013-09-18','16:45:00',2.63),('15128','2013-09-18','16:50:00',2.18),('15128','2013-09-18','16:55:00',2.12),('15128','2013-09-18','17:00:00',2.09),('15128','2013-09-18','17:05:00',1.87),('15128','2013-09-18','17:10:00',1.9),('15128','2013-09-18','17:15:00',1.71),('15128','2013-09-18','17:20:00',1.6),('15128','2013-09-18','17:25:00',1.59),('15128','2013-09-18','17:30:00',1.16),('15128','2013-09-18','17:35:00',1.11),('15128','2013-09-17','09:20:00',1.04),('15128','2013-09-17','09:30:00',1.34),('15128','2013-09-17','09:50:00',1.86),('15128','2013-09-17','09:55:00',1.64),('15128','2013-09-17','10:00:00',1.83),('15128','2013-09-17','10:05:00',1.94),('15128','2013-09-17','10:10:00',1.97),('15128','2013-09-17','10:15:00',2.03),('15128','2013-09-17','10:20:00',2.06),('15128','2013-09-17','10:25:00',2.11),('15128','2013-09-17','10:30:00',2.17),('15128','2013-09-17','10:35:00',2.24),('15128','2013-09-17','10:40:00',2.26),('15128','2013-09-17','10:45:00',2.29),('15128','2013-09-17','10:50:00',2.34),('15128','2013-09-17','10:55:00',2.4),('15128','2013-09-17','11:00:00',2.51),('15128','2013-09-17','11:05:00',2.57),('15128','2013-09-17','11:10:00',2.63),('15128','2013-09-17','11:15:00',3.03),('15128','2013-09-17','11:20:00',3.13),('15128','2013-09-17','11:25:00',3.13),('15128','2013-09-17','11:30:00',2.83),('15128','2013-09-17','11:35:00',3.1),('15128','2013-09-17','11:40:00',3.19),('15128','2013-09-17','11:45:00',3.22),('15128','2013-09-17','11:50:00',3.35),('15128','2013-09-17','11:55:00',3.53),('15128','2013-09-17','12:00:00',3.53),('15128','2013-09-17','12:05:00',3.56),('15128','2013-09-17','12:10:00',3.84),('15128','2013-09-17','12:15:00',3.09),('15128','2013-09-17','12:20:00',3.66),('15128','2013-09-17','12:25:00',2.46),('15128','2013-09-17','12:30:00',3.02),('15128','2013-09-17','12:35:00',3.3),('15128','2013-09-17','12:40:00',1.14),('15128','2013-09-17','12:45:00',1.58),('15128','2013-09-17','12:50:00',2),('15128','2013-09-17','12:55:00',4.33),('15128','2013-09-17','13:00:00',3.65),('15128','2013-09-17','13:05:00',3.59),('15128','2013-09-17','13:10:00',1.71),('15128','2013-09-17','13:15:00',2.34),('15128','2013-09-17','13:20:00',4.22),('15128','2013-09-17','13:25:00',2.44),('15128','2013-09-17','13:30:00',4.38),('15128','2013-09-17','13:35:00',2.17),('15128','2013-09-17','13:40:00',3),('15128','2013-09-17','13:45:00',1.79),('15128','2013-09-17','13:50:00',1.29),('15128','2013-09-17','13:55:00',3.87),('15128','2013-09-17','14:00:00',4.58),('15128','2013-09-17','14:05:00',3.84),('15128','2013-09-17','14:10:00',3.47),('15128','2013-09-17','14:15:00',2.03),('15128','2013-09-17','14:20:00',3.72),('15128','2013-09-17','14:25:00',4.01),('15128','2013-09-17','14:30:00',3.91),('15128','2013-09-17','14:35:00',3.92),('15128','2013-09-17','14:40:00',3.95),('15128','2013-09-17','14:45:00',3.47),('15128','2013-09-17','14:50:00',3.2),('15128','2013-09-17','14:55:00',2.25),('15128','2013-09-17','15:00:00',2.09),('15128','2013-09-17','15:05:00',3.31),('15128','2013-09-17','15:10:00',2.38),('15128','2013-09-17','15:15:00',1.54),('15128','2013-09-17','15:20:00',1.32),('15128','2013-09-17','15:25:00',3.57),('15128','2013-09-17','15:30:00',3.21),('15128','2013-09-17','15:35:00',1.55),('15128','2013-09-17','15:40:00',2.68),('15128','2013-09-17','15:45:00',3.52),('15128','2013-09-17','15:50:00',3.37),('15128','2013-09-17','15:55:00',3.24),('15128','2013-09-17','16:00:00',2.8),('15128','2013-09-17','16:05:00',1.97),('15128','2013-09-17','16:10:00',1.65),('15128','2013-09-17','16:15:00',2.29);
INSERT INTO `solarlogmod` VALUES ('15128','2013-09-17','16:20:00',2.94),('15128','2013-09-17','16:25:00',2.78),('15128','2013-09-17','16:30:00',2.7),('15128','2013-09-17','16:35:00',2.46),('15128','2013-09-17','16:40:00',2.25),('15128','2013-09-17','16:45:00',2.21),('15128','2013-09-17','16:50:00',2.34),('15128','2013-09-17','16:55:00',2.24),('15128','2013-09-17','17:00:00',1.56),('15128','2013-09-17','17:05:00',2.11),('15128','2013-09-17','17:10:00',1.99),('15128','2013-09-17','17:15:00',2.05),('15128','2013-09-17','17:20:00',1.73),('15128','2013-09-17','17:25:00',1.87),('15128','2013-09-17','17:30:00',1.76),('15128','2013-09-17','17:35:00',1.6),('15128','2013-09-17','17:40:00',1.53),('15128','2013-09-17','17:45:00',1.39),('15128','2013-09-17','17:50:00',1.33),('15128','2013-09-17','17:55:00',1.16),('15128','2013-09-16','09:25:00',1.01),('15128','2013-09-16','09:40:00',2.18),('15128','2013-09-16','09:45:00',1.29),('15128','2013-09-16','09:50:00',1.59),('15128','2013-09-16','09:55:00',1.66),('15128','2013-09-16','10:00:00',1.83),('15128','2013-09-16','10:05:00',2),('15128','2013-09-16','10:10:00',1.04),('15128','2013-09-16','10:15:00',1.34),('15128','2013-09-16','10:20:00',2.9),('15128','2013-09-16','10:25:00',1.36),('15128','2013-09-16','10:30:00',1.5),('15128','2013-09-16','10:35:00',1.84),('15128','2013-09-16','10:40:00',2.7),('15128','2013-09-16','10:45:00',2.33),('15128','2013-09-16','10:50:00',2),('15128','2013-09-16','10:55:00',1.96),('15128','2013-09-16','11:00:00',1.85),('15128','2013-09-16','11:05:00',3.18),('15128','2013-09-16','11:10:00',2.21),('15128','2013-09-16','11:15:00',1.26),('15128','2013-09-16','11:20:00',1.55),('15128','2013-09-16','11:25:00',2.16),('15128','2013-09-16','11:30:00',1.53),('15128','2013-09-16','11:35:00',2.91),('15128','2013-09-16','11:40:00',3.13),('15128','2013-09-16','11:45:00',3.07),('15128','2013-09-16','11:50:00',1.79),('15128','2013-09-16','11:55:00',3.87),('15128','2013-09-16','12:00:00',2.24),('15128','2013-09-16','12:05:00',1.02),('15128','2013-09-16','12:10:00',1.43),('15128','2013-09-16','12:15:00',1.76),('15128','2013-09-16','12:20:00',1.81),('15128','2013-09-16','12:25:00',1.08),('15128','2013-09-16','12:30:00',1.48),('15128','2013-09-16','12:35:00',1.67),('15128','2013-09-16','12:40:00',2.93),('15128','2013-09-16','12:45:00',3.05),('15128','2013-09-16','12:50:00',3.61),('15128','2013-09-16','12:55:00',2.77),('15128','2013-09-16','13:00:00',3.63),('15128','2013-09-16','13:05:00',3.14),('15128','2013-09-16','13:10:00',2.91),('15128','2013-09-16','13:15:00',2.24),('15128','2013-09-16','13:20:00',1.71),('15128','2013-09-16','13:25:00',1.64),('15128','2013-09-16','13:30:00',1.09),('15128','2013-09-16','13:35:00',1.32),('15128','2013-09-16','13:40:00',2.38),('15128','2013-09-16','13:45:00',1.16),('15128','2013-09-16','13:50:00',1.79),('15128','2013-09-16','13:55:00',1.98),('15128','2013-09-16','14:00:00',1.21),('15128','2013-09-16','14:05:00',1.51),('15128','2013-09-16','14:10:00',1.61),('15128','2013-09-16','14:15:00',1.32),('15128','2013-09-16','14:20:00',1.04),('15128','2013-09-16','14:30:00',1.89),('15128','2013-09-16','14:35:00',1.11),('15128','2013-09-16','14:40:00',1.16),('15128','2013-09-16','14:45:00',1.28),('15128','2013-09-16','14:50:00',2.84),('15128','2013-09-16','14:55:00',4.02),('15128','2013-09-16','15:00:00',3.52),('15128','2013-09-16','15:05:00',2.95),('15128','2013-09-16','15:10:00',3.03),('15128','2013-09-16','15:15:00',1.26),('15128','2013-09-16','15:30:00',1.08),('15128','2013-09-16','15:35:00',1.42),('15128','2013-09-16','15:40:00',1.76),('15128','2013-09-16','15:45:00',2.67),('15128','2013-09-16','15:50:00',2.38),('15128','2013-09-16','15:55:00',2.63),('15128','2013-09-16','16:00:00',2.84),('15128','2013-09-16','16:05:00',2.13),('15128','2013-09-16','16:10:00',2.51),('15128','2013-09-16','16:15:00',1.58),('15128','2013-09-16','16:30:00',1.01),('15128','2013-09-16','16:35:00',1.23),('15128','2013-09-16','16:40:00',1.7),('15128','2013-09-16','16:45:00',1.81),('15128','2013-09-16','16:50:00',1.15),('15128','2013-09-16','16:55:00',1.49),('15128','2013-09-16','17:00:00',1.91),('15128','2013-09-16','17:05:00',1.84),('15128','2013-09-16','17:10:00',2.03),('15128','2013-09-16','17:15:00',1.77),('15128','2013-09-16','17:20:00',1.65),('15128','2013-09-16','17:25:00',1.64),('15128','2013-09-16','17:30:00',1.6),('15128','2013-09-16','17:35:00',1.53),('15128','2013-09-16','17:40:00',1.27),('15128','2013-09-15','08:50:00',1.08),('15128','2013-09-15','09:15:00',1.28),('15128','2013-09-15','09:20:00',1.44),('15128','2013-09-15','09:25:00',1.48),('15128','2013-09-15','09:30:00',1.49),('15128','2013-09-15','09:35:00',1.52),('15128','2013-09-15','09:40:00',1.58),('15128','2013-09-15','09:45:00',1.7),('15128','2013-09-15','09:50:00',1.8),('15128','2013-09-15','09:55:00',1.86),('15128','2013-09-15','10:00:00',1.75),('15128','2013-09-15','10:05:00',1.93),('15128','2013-09-15','10:10:00',2.31),('15128','2013-09-15','10:15:00',2.3),('15128','2013-09-15','10:20:00',1.68),('15128','2013-09-15','10:25:00',1.87),('15128','2013-09-15','10:40:00',2.84),('15128','2013-09-15','10:45:00',1.77),('15128','2013-09-15','10:50:00',2.24),('15128','2013-09-15','10:55:00',1.88),('15128','2013-09-15','11:00:00',1.99),('15128','2013-09-15','11:05:00',3.4),('15128','2013-09-15','11:10:00',3.14),('15128','2013-09-15','11:15:00',3.06),('15128','2013-09-15','11:20:00',3.38),('15128','2013-09-15','11:25:00',3.31),('15128','2013-09-15','11:30:00',3.13),('15128','2013-09-15','11:35:00',3.27),('15128','2013-09-15','11:40:00',1.84),('15128','2013-09-15','11:45:00',3.59),('15128','2013-09-15','11:50:00',3.7),('15128','2013-09-15','11:55:00',3.84),('15128','2013-09-15','12:00:00',4.02),('15128','2013-09-15','12:05:00',3.79),('15128','2013-09-15','12:10:00',3.43),('15128','2013-09-15','12:15:00',3.17),('15128','2013-09-15','12:20:00',2.01),('15128','2013-09-15','12:25:00',3.87),('15128','2013-09-15','12:30:00',3.95),('15128','2013-09-15','12:35:00',4.1),('15128','2013-09-15','12:40:00',1.22),('15128','2013-09-15','12:45:00',1.25),('15128','2013-09-15','12:55:00',2.23),('15128','2013-09-15','13:00:00',4.69),('15128','2013-09-15','13:05:00',2.1),('15128','2013-09-15','13:10:00',4.19),('15128','2013-09-15','13:15:00',3.47),('15128','2013-09-15','13:20:00',3.89),('15128','2013-09-15','13:25:00',4.08),('15128','2013-09-15','13:30:00',3.89),('15128','2013-09-15','13:35:00',4.06),('15128','2013-09-15','13:40:00',2.72),('15128','2013-09-15','13:45:00',4.13),('15128','2013-09-15','13:50:00',4.15),('15128','2013-09-15','13:55:00',4.15),('15128','2013-09-15','14:00:00',3.86),('15128','2013-09-15','14:05:00',3.98),('15128','2013-09-15','14:10:00',3.91),('15128','2013-09-15','14:15:00',3.88),('15128','2013-09-15','14:20:00',3.88),('15128','2013-09-15','14:25:00',3.87),('15128','2013-09-15','14:30:00',3.83),('15128','2013-09-15','14:35:00',3.81),('15128','2013-09-15','14:40:00',3.79),('15128','2013-09-15','14:45:00',3.79),('15128','2013-09-15','14:50:00',3.79),('15128','2013-09-15','14:55:00',3.78),('15128','2013-09-15','15:00:00',3.74),('15128','2013-09-15','15:05:00',3.71),('15128','2013-09-15','15:10:00',3.68),('15128','2013-09-15','15:15:00',3.66),('15128','2013-09-15','15:20:00',3.6),('15128','2013-09-15','15:25:00',3.57),('15128','2013-09-15','15:30:00',3.54),('15128','2013-09-15','15:35:00',3.5),('15128','2013-09-15','15:40:00',3.44),('15128','2013-09-15','15:45:00',3.41),('15128','2013-09-15','15:50:00',3.15),('15128','2013-09-15','15:55:00',3.42),('15128','2013-09-15','16:00:00',3.42),('15128','2013-09-15','16:05:00',3.23),('15128','2013-09-15','16:10:00',3.15),('15128','2013-09-15','16:15:00',3.09),('15128','2013-09-15','16:20:00',3.05),('15128','2013-09-15','16:25:00',2.99),('15128','2013-09-15','16:30:00',2.92),('15128','2013-09-15','16:35:00',2.85),('15128','2013-09-15','16:40:00',2.79),('15128','2013-09-15','16:45:00',2.71),('15128','2013-09-15','16:50:00',2.59),('15128','2013-09-15','16:55:00',2.47),('15128','2013-09-15','17:00:00',2.37),('15128','2013-09-15','17:05:00',2.26),('15128','2013-09-15','17:10:00',2.17),('15128','2013-09-15','17:15:00',2.04),('15128','2013-09-15','17:20:00',1.73),('15128','2013-09-15','17:25:00',1.33),('15128','2013-09-15','17:30:00',1.71),('15128','2013-09-15','17:35:00',1.62),('15128','2013-09-15','17:40:00',1.68),('15128','2013-09-15','17:45:00',1.59),('15128','2013-09-15','17:50:00',1.46),('15128','2013-09-15','17:55:00',1.33),('15128','2013-09-15','18:00:00',1.2),('15128','2013-09-15','18:05:00',1.1),('15128','2013-09-15','18:10:00',1.02),('15128','2013-09-14','08:55:00',1.04),('15128','2013-09-14','09:00:00',1.1),('15128','2013-09-14','09:05:00',1.18),('15128','2013-09-14','09:10:00',1.26),('15128','2013-09-14','09:15:00',1.39),('15128','2013-09-14','09:20:00',1.4),('15128','2013-09-14','09:25:00',1.44),('15128','2013-09-14','09:30:00',1.47),('15128','2013-09-14','09:35:00',1.54),('15128','2013-09-14','09:40:00',1.6),('15128','2013-09-14','09:45:00',1.72),('15128','2013-09-14','09:50:00',1.76),('15128','2013-09-14','09:55:00',1.87),('15128','2013-09-14','10:00:00',1.94),('15128','2013-09-14','10:05:00',1.91),('15128','2013-09-14','10:10:00',1.85),('15128','2013-09-14','10:15:00',1.97),('15128','2013-09-14','10:20:00',2.04),('15128','2013-09-14','10:25:00',2.04),('15128','2013-09-14','10:30:00',2.08),('15128','2013-09-14','10:35:00',2.29),('15128','2013-09-14','10:40:00',2.41),('15128','2013-09-14','10:45:00',2.25),('15128','2013-09-14','10:50:00',2.47),('15128','2013-09-14','10:55:00',2.62),('15128','2013-09-14','11:00:00',2.93),('15128','2013-09-14','11:05:00',2.16),('15128','2013-09-14','11:10:00',1.67),('15128','2013-09-14','11:20:00',1.02),('15128','2013-09-14','11:25:00',2.77),('15128','2013-09-14','11:30:00',1.63),('15128','2013-09-14','11:35:00',1.17),('15128','2013-09-14','11:45:00',1.63),('15128','2013-09-14','11:50:00',1.92),('15128','2013-09-14','11:55:00',1.54),('15128','2013-09-14','12:00:00',1.73),('15128','2013-09-14','12:05:00',2.22),('15128','2013-09-14','12:10:00',1.7),('15128','2013-09-14','12:15:00',1.72),('15128','2013-09-14','12:20:00',2.22),('15128','2013-09-14','12:25:00',1.86),('15128','2013-09-14','12:30:00',1.41),('15128','2013-09-14','12:35:00',1.36),('15128','2013-09-14','12:40:00',1.32),('15128','2013-09-14','12:45:00',1.31),('15128','2013-09-14','12:50:00',1.23),('15128','2013-09-14','12:55:00',1.3),('15128','2013-09-14','13:00:00',1.86),('15128','2013-09-14','13:05:00',1.83),('15128','2013-09-14','13:10:00',1.97),('15128','2013-09-14','13:15:00',1.15),('15128','2013-09-14','13:20:00',1.18),('15128','2013-09-14','13:25:00',1.48),('15128','2013-09-14','13:30:00',1.57),('15128','2013-09-14','13:35:00',1.99),('15128','2013-09-14','13:40:00',3.7),('15128','2013-09-14','13:45:00',4.09),('15128','2013-09-14','13:50:00',1.83),('15128','2013-09-14','13:55:00',2.65),('15128','2013-09-14','14:00:00',2.61),('15128','2013-09-14','14:05:00',1.55),('15128','2013-09-14','14:10:00',1.77),('15128','2013-09-14','14:15:00',1.81),('15128','2013-09-14','14:20:00',1.56),('15128','2013-09-14','14:25:00',1.42),('15128','2013-09-14','14:30:00',1.27),('15128','2013-09-14','14:35:00',1.17),('15128','2013-09-14','14:40:00',1.21),('15128','2013-09-14','14:45:00',1.32),('15128','2013-09-14','14:50:00',1.36),('15128','2013-09-14','14:55:00',1.3),('15128','2013-09-14','15:00:00',1.32),('15128','2013-09-14','15:05:00',1.31),('15128','2013-09-14','15:10:00',1.66),('15128','2013-09-14','15:15:00',2.09),('15128','2013-09-14','15:20:00',1.92),('15128','2013-09-14','15:25:00',1.18),('15128','2013-09-14','15:35:00',1.03),('15128','2013-09-14','16:05:00',1.01),('15128','2013-09-14','16:40:00',1.08),('15128','2013-09-13','08:55:00',1.04),('15128','2013-09-13','09:00:00',1.11),('15128','2013-09-13','09:05:00',1.17),('15128','2013-09-13','09:10:00',1.24),('15128','2013-09-13','09:15:00',1.34),('15128','2013-09-13','09:20:00',1.39),('15128','2013-09-13','09:25:00',1.45),('15128','2013-09-13','09:30:00',1.51),('15128','2013-09-13','09:35:00',1.54),('15128','2013-09-13','09:40:00',1.61),('15128','2013-09-13','09:45:00',1.7),('15128','2013-09-13','09:50:00',1.78),('15128','2013-09-13','09:55:00',1.83),('15128','2013-09-13','10:00:00',1.88),('15128','2013-09-13','10:05:00',1.96),('15128','2013-09-13','10:10:00',2),('15128','2013-09-13','10:15:00',1.96),('15128','2013-09-13','10:20:00',2.1),('15128','2013-09-13','10:25:00',2.1),('15128','2013-09-13','10:30:00',2.26),('15128','2013-09-13','10:35:00',2.33),('15128','2013-09-13','10:40:00',2.08),('15128','2013-09-13','10:45:00',1.12),('15128','2013-09-13','10:50:00',1.3),('15128','2013-09-13','10:55:00',1.19),('15128','2013-09-13','11:10:00',1.91),('15128','2013-09-13','11:15:00',3),('15128','2013-09-13','11:20:00',3.01),('15128','2013-09-13','11:25:00',2.89),('15128','2013-09-13','11:30:00',2.98),('15128','2013-09-13','11:35:00',2.91),('15128','2013-09-13','11:40:00',3.08),('15128','2013-09-13','11:45:00',3.14),('15128','2013-09-13','11:50:00',3.33),('15128','2013-09-13','11:55:00',3.38),('15128','2013-09-13','12:00:00',3.49),('15128','2013-09-13','12:05:00',3.55),('15128','2013-09-13','12:10:00',3.58),('15128','2013-09-13','12:15:00',3.71),('15128','2013-09-13','12:20:00',3.82),('15128','2013-09-13','12:25:00',3.87),('15128','2013-09-13','12:30:00',3.81),('15128','2013-09-13','12:35:00',3.86),('15128','2013-09-13','12:40:00',3.99),('15128','2013-09-13','12:45:00',4.05),('15128','2013-09-13','12:50:00',4),('15128','2013-09-13','12:55:00',4.07),('15128','2013-09-13','13:00:00',4.05),('15128','2013-09-13','13:05:00',4.14),('15128','2013-09-13','13:10:00',4.16),('15128','2013-09-13','13:15:00',3.94),('15128','2013-09-13','13:20:00',3.89),('15128','2013-09-13','13:25:00',3.9),('15128','2013-09-13','13:30:00',3.89),('15128','2013-09-13','13:35:00',3.82),('15128','2013-09-13','13:40:00',4.15),('15128','2013-09-13','13:45:00',2.31),('15128','2013-09-13','13:50:00',2.32),('15128','2013-09-13','13:55:00',3.76),('15128','2013-09-13','14:00:00',2.98),('15128','2013-09-13','14:05:00',3.53),('15128','2013-09-13','14:10:00',4.28),('15128','2013-09-13','14:15:00',4.07),('15128','2013-09-13','14:20:00',3.88),('15128','2013-09-13','14:25:00',3.85),('15128','2013-09-13','14:30:00',3.8),('15128','2013-09-13','14:35:00',3.75),('15128','2013-09-13','14:40:00',3.76),('15128','2013-09-13','14:45:00',3.75),('15128','2013-09-13','14:50:00',3.71),('15128','2013-09-13','14:55:00',3.69),('15128','2013-09-13','15:00:00',3.68),('15128','2013-09-13','15:05:00',3.64),('15128','2013-09-13','15:10:00',3.62),('15128','2013-09-13','15:15:00',3.59),('15128','2013-09-13','15:20:00',3.57),('15128','2013-09-13','15:25:00',3.51),('15128','2013-09-13','15:30:00',3.45),('15128','2013-09-13','15:35:00',3.44),('15128','2013-09-13','15:40:00',3.4),('15128','2013-09-13','15:45:00',3.37),('15128','2013-09-13','15:50:00',3.28),('15128','2013-09-13','15:55:00',3.24),('15128','2013-09-13','16:00:00',3.22),('15128','2013-09-13','16:05:00',3.14),('15128','2013-09-13','16:10:00',3.1),('15128','2013-09-13','16:15:00',3.04),('15128','2013-09-13','16:20:00',2.95),('15128','2013-09-13','16:25:00',2.93),('15128','2013-09-13','16:30:00',2.86),('15128','2013-09-13','16:35:00',2.77),('15128','2013-09-13','16:40:00',2.73),('15128','2013-09-13','16:45:00',2.66),('15128','2013-09-13','16:50:00',2.51),('15128','2013-09-13','16:55:00',2.46),('15128','2013-09-13','17:00:00',2.37),('15128','2013-09-13','17:05:00',2.28),('15128','2013-09-13','17:10:00',2.13),('15128','2013-09-13','17:15:00',2.04),('15128','2013-09-13','17:20:00',1.98),('15128','2013-09-13','17:25:00',1.88),('15128','2013-09-13','17:30:00',1.79),('15128','2013-09-13','17:35:00',1.73),('15128','2013-09-13','17:40:00',1.65),('15128','2013-09-13','17:45:00',1.58),('15128','2013-09-13','17:50:00',1.48),('15128','2013-09-13','17:55:00',1.4),('15128','2013-09-13','18:00:00',1.24),('15128','2013-09-13','18:05:00',1.11),('15128','2013-09-13','18:10:00',1.05),('15128','2013-09-12','09:30:00',1),('15128','2013-09-12','09:35:00',1.1),('15128','2013-09-12','09:40:00',1.15),('15128','2013-09-12','09:45:00',1.2),('15128','2013-09-12','09:50:00',1.51),('15128','2013-09-12','09:55:00',1.32),('15128','2013-09-12','10:00:00',2.71),('15128','2013-09-12','10:05:00',1.95),('15128','2013-09-12','10:10:00',2.34),('15128','2013-09-12','10:15:00',1.2),('15128','2013-09-12','10:20:00',1.36),('15128','2013-09-12','10:25:00',1.24),('15128','2013-09-12','10:30:00',2.26),('15128','2013-09-12','10:35:00',2.4),('15128','2013-09-12','10:40:00',2.43),('15128','2013-09-12','10:45:00',2.45),('15128','2013-09-12','10:50:00',2.47),('15128','2013-09-12','10:55:00',2.52),('15128','2013-09-12','11:00:00',2.56),('15128','2013-09-12','11:05:00',2.59),('15128','2013-09-12','11:10:00',2.66),('15128','2013-09-12','11:15:00',2.77),('15128','2013-09-12','11:20:00',2.85),('15128','2013-09-12','11:25:00',2.83),('15128','2013-09-12','11:30:00',2.96),('15128','2013-09-12','11:35:00',2.9),('15128','2013-09-12','11:40:00',3.06),('15128','2013-09-12','11:45:00',3.1),('15128','2013-09-12','11:50:00',3.27),('15128','2013-09-12','11:55:00',3.39),('15128','2013-09-12','12:00:00',3.47),('15128','2013-09-12','12:05:00',3.52),('15128','2013-09-12','12:10:00',3.57),('15128','2013-09-12','12:15:00',3.64),('15128','2013-09-12','12:20:00',3.67),('15128','2013-09-12','12:25:00',3.76),('15128','2013-09-12','12:30:00',3.87),('15128','2013-09-12','12:35:00',3.89),('15128','2013-09-12','12:40:00',3.86),('15128','2013-09-12','12:45:00',3.87),('15128','2013-09-12','12:50:00',3.91),('15128','2013-09-12','12:55:00',3.9),('15128','2013-09-12','13:00:00',3.91),('15128','2013-09-12','13:05:00',3.92),('15128','2013-09-12','13:10:00',3.92),('15128','2013-09-12','13:15:00',3.9),('15128','2013-09-12','13:20:00',3.89),('15128','2013-09-12','13:25:00',3.87),('15128','2013-09-12','13:30:00',3.86),('15128','2013-09-12','13:35:00',3.84),('15128','2013-09-12','13:40:00',3.83),('15128','2013-09-12','13:45:00',3.85),('15128','2013-09-12','13:50:00',3.88),('15128','2013-09-12','13:55:00',3.9),('15128','2013-09-12','14:00:00',3.97),('15128','2013-09-12','14:05:00',3.97),('15128','2013-09-12','14:10:00',3.89),('15128','2013-09-12','14:15:00',2.86),('15128','2013-09-12','14:20:00',3.89),('15128','2013-09-12','14:25:00',3.93),('15128','2013-09-12','14:30:00',3.9),('15128','2013-09-12','14:35:00',3.86),('15128','2013-09-12','14:40:00',3.81),('15128','2013-09-12','14:45:00',3.85),('15128','2013-09-12','14:50:00',3.82),('15128','2013-09-12','14:55:00',3.82),('15128','2013-09-12','15:00:00',3.76),('15128','2013-09-12','15:05:00',3.74),('15128','2013-09-12','15:10:00',3.71),('15128','2013-09-12','15:15:00',3.68),('15128','2013-09-12','15:20:00',3.63),('15128','2013-09-12','15:25:00',3.58),('15128','2013-09-12','15:30:00',3.57),('15128','2013-09-12','15:35:00',3.53),('15128','2013-09-12','15:40:00',3.48),('15128','2013-09-12','15:45:00',3.44),('15128','2013-09-12','15:50:00',3.41),('15128','2013-09-12','15:55:00',3.34),('15128','2013-09-12','16:00:00',3.3),('15128','2013-09-12','16:05:00',3.23),('15128','2013-09-12','16:10:00',3.16),('15128','2013-09-12','16:15:00',3.13),('15128','2013-09-12','16:20:00',3.06),('15128','2013-09-12','16:25:00',2.98),('15128','2013-09-12','16:30:00',2.93),('15128','2013-09-12','16:35:00',2.87),('15128','2013-09-12','16:40:00',2.8),('15128','2013-09-12','16:45:00',2.73),('15128','2013-09-12','16:50:00',2.63),('15128','2013-09-12','16:55:00',2.49),('15128','2013-09-12','17:00:00',2.41),('15128','2013-09-12','17:05:00',2.31),('15128','2013-09-12','17:10:00',2.19),('15128','2013-09-12','17:15:00',2.12),('15128','2013-09-12','17:20:00',2),('15128','2013-09-12','17:25:00',1.88),('15128','2013-09-12','17:30:00',1.82),('15128','2013-09-12','17:35:00',1.75),('15128','2013-09-12','17:40:00',1.68),('15128','2013-09-12','17:45:00',1.59),('15128','2013-09-12','17:50:00',1.52),('15128','2013-09-12','17:55:00',1.41),('15128','2013-09-12','18:00:00',1.28),('15128','2013-09-12','18:05:00',1.15),('15128','2013-09-12','18:10:00',1.05),('15128','2013-09-11','09:00:00',1.07),('15128','2013-09-11','09:05:00',1.08),('15128','2013-09-11','09:20:00',1.46),('15128','2013-09-11','09:25:00',1.53),('15128','2013-09-11','09:30:00',1.62),('15128','2013-09-11','09:35:00',1.21),('15128','2013-09-11','09:40:00',1.07),('15128','2013-09-11','09:50:00',1.89),('15128','2013-09-11','09:55:00',1.58),('15128','2013-09-11','10:00:00',2.09),('15128','2013-09-11','10:05:00',2.11),('15128','2013-09-11','10:10:00',1.43),('15128','2013-09-11','10:25:00',2.03),('15128','2013-09-11','10:30:00',1.87),('15128','2013-09-11','10:35:00',1.98),('15128','2013-09-11','10:40:00',2),('15128','2013-09-11','10:45:00',2.05),('15128','2013-09-11','10:50:00',2.48),('15128','2013-09-11','10:55:00',3.65),('15128','2013-09-11','11:00:00',3.53),('15128','2013-09-11','11:40:00',1.75),('15128','2013-09-11','11:45:00',2.27),('15128','2013-09-11','11:50:00',2.33),('15128','2013-09-11','11:55:00',3.48),('15128','2013-09-11','12:00:00',3.8),('15128','2013-09-11','12:05:00',3.84),('15128','2013-09-11','12:10:00',3.65),('15128','2013-09-11','12:15:00',3.35),('15128','2013-09-11','12:20:00',2.74),('15128','2013-09-11','12:25:00',4.07),('15128','2013-09-11','12:30:00',4.22),('15128','2013-09-11','12:35:00',2.39),('15128','2013-09-11','12:40:00',3.58),('15128','2013-09-11','12:45:00',3.56),('15128','2013-09-11','12:50:00',3.94),('15128','2013-09-11','12:55:00',3.68),('15128','2013-09-11','13:00:00',3.94),('15128','2013-09-11','13:05:00',4.05),('15128','2013-09-11','13:10:00',3.99),('15128','2013-09-11','13:15:00',2.87),('15128','2013-09-11','13:20:00',2.36),('15128','2013-09-11','13:25:00',2.92),('15128','2013-09-11','13:30:00',4.34),('15128','2013-09-11','13:35:00',3.15),('15128','2013-09-11','13:40:00',4.14),('15128','2013-09-11','13:45:00',3.57),('15128','2013-09-11','13:50:00',4.11),('15128','2013-09-11','13:55:00',3.63),('15128','2013-09-11','14:00:00',3.45),('15128','2013-09-11','14:20:00',4.1),('15128','2013-09-11','14:25:00',2.79),('15128','2013-09-11','14:30:00',3.07),('15128','2013-09-11','14:35:00',3.86),('15128','2013-09-11','14:40:00',4.28),('15128','2013-09-11','14:45:00',4.14),('15128','2013-09-11','14:50:00',3.97),('15128','2013-09-11','14:55:00',3.46),('15128','2013-09-11','15:00:00',3.92),('15128','2013-09-11','15:05:00',3.86),('15128','2013-09-11','15:10:00',3.83),('15128','2013-09-11','15:15:00',3.8),('15128','2013-09-11','15:20:00',3.72),('15128','2013-09-11','15:25:00',3.73),('15128','2013-09-11','15:30:00',3.69),('15128','2013-09-11','15:35:00',3.64),('15128','2013-09-11','15:40:00',3.59),('15128','2013-09-11','15:45:00',3.58),('15128','2013-09-11','15:50:00',3.59),('15128','2013-09-11','15:55:00',3.43),('15128','2013-09-11','16:00:00',3.54),('15128','2013-09-11','16:05:00',3.35),('15128','2013-09-11','16:10:00',3.36),('15128','2013-09-11','16:15:00',2.94),('15128','2013-09-11','16:20:00',3.04),('15128','2013-09-11','16:25:00',3.26),('15128','2013-09-11','16:30:00',3.02),('15128','2013-09-11','16:35:00',2.82),('15128','2013-09-11','16:40:00',3.19),('15128','2013-09-11','16:45:00',2.54),('15128','2013-09-11','16:50:00',2.88),('15128','2013-09-11','16:55:00',2.79),('15128','2013-09-11','17:00:00',2.68),('15128','2013-09-11','17:05:00',2.47),('15128','2013-09-11','17:10:00',2.35),('15128','2013-09-11','17:15:00',2.23),('15128','2013-09-11','17:20:00',2.14),('15128','2013-09-11','17:25:00',2.01),('15128','2013-09-11','17:30:00',1.93),('15128','2013-09-11','17:35:00',1.84),('15128','2013-09-11','17:40:00',1.8),('15128','2013-09-11','17:45:00',1.7),('15128','2013-09-11','17:50:00',1.45),('15128','2013-09-11','18:05:00',1.13),('15128','2013-09-11','18:20:00',1.05),('15128','2013-09-10','09:50:00',1.18),('15128','2013-09-10','09:55:00',1.31),('15128','2013-09-10','10:05:00',2.04),('15128','2013-09-10','10:10:00',2.02),('15128','2013-09-10','10:15:00',2.01),('15128','2013-09-10','10:20:00',2.09),('15128','2013-09-10','10:25:00',2.19),('15128','2013-09-10','10:30:00',1.66),('15128','2013-09-10','10:35:00',2.28),('15128','2013-09-10','10:40:00',1.76),('15128','2013-09-10','10:45:00',1.27),('15128','2013-09-10','10:50:00',1.66),('15128','2013-09-10','10:55:00',2.34),('15128','2013-09-10','11:00:00',1.3),('15128','2013-09-10','11:05:00',3.43),('15128','2013-09-10','11:10:00',3.07),('15128','2013-09-10','11:15:00',2.35),('15128','2013-09-10','11:20:00',2.35),('15128','2013-09-10','11:25:00',3.23),('15128','2013-09-10','11:30:00',1.18),('15128','2013-09-10','11:35:00',3.18),('15128','2013-09-10','11:40:00',3.06),('15128','2013-09-10','11:45:00',3.41),('15128','2013-09-10','11:50:00',3.6),('15128','2013-09-10','11:55:00',3.61),('15128','2013-09-10','12:00:00',1.79),('15128','2013-09-10','12:05:00',3.13),('15128','2013-09-10','12:10:00',3.41),('15128','2013-09-10','12:15:00',2.37),('15128','2013-09-10','12:20:00',2.7),('15128','2013-09-10','12:25:00',4.16),('15128','2013-09-10','12:30:00',4.39),('15128','2013-09-10','12:35:00',2.5),('15128','2013-09-10','12:40:00',3.7),('15128','2013-09-10','12:45:00',3.14),('15128','2013-09-10','12:50:00',3.74),('15128','2013-09-10','12:55:00',4.22),('15128','2013-09-10','13:00:00',3.17),('15128','2013-09-10','13:05:00',2.67),('15128','2013-09-10','13:10:00',4.68),('15128','2013-09-10','13:15:00',4.16),('15128','2013-09-10','13:20:00',3.46),('15128','2013-09-10','13:25:00',3.62),('15128','2013-09-10','13:30:00',2.2),('15128','2013-09-10','13:35:00',2.26),('15128','2013-09-10','13:40:00',1.5),('15128','2013-09-10','13:45:00',4.12),('15128','2013-09-10','13:50:00',3.22),('15128','2013-09-10','13:55:00',3.94),('15128','2013-09-10','14:00:00',4.2),('15128','2013-09-10','14:05:00',4.02),('15128','2013-09-10','14:10:00',4.14),('15128','2013-09-10','14:15:00',4.07),('15128','2013-09-10','14:20:00',4.06),('15128','2013-09-10','14:25:00',3.51),('15128','2013-09-10','14:30:00',1.75),('15128','2013-09-10','14:35:00',2.54),('15128','2013-09-10','14:40:00',2.23),('15128','2013-09-10','14:45:00',2.24),('15128','2013-09-10','14:50:00',1.29),('15128','2013-09-10','14:55:00',1.32),('15128','2013-09-10','15:00:00',2.7),('15128','2013-09-10','15:05:00',3.13),('15128','2013-09-10','15:10:00',1.9),('15128','2013-09-10','15:15:00',1.81),('15128','2013-09-10','15:20:00',2.92),('15128','2013-09-10','15:25:00',2.47),('15128','2013-09-10','15:30:00',2.97),('15128','2013-09-10','15:35:00',3.76),('15128','2013-09-10','15:40:00',2.07),('15128','2013-09-10','15:45:00',2.53),('15128','2013-09-10','15:50:00',1.64),('15128','2013-09-10','15:55:00',1.03),('15128','2013-09-10','16:00:00',2.03),('15128','2013-09-10','16:05:00',3.66),('15128','2013-09-10','16:10:00',3.44),('15128','2013-09-10','16:15:00',3.48),('15128','2013-09-10','16:20:00',1.87),('15128','2013-09-10','16:25:00',1.3),('15128','2013-09-10','16:30:00',3.52),('15128','2013-09-10','16:35:00',2.62),('15128','2013-09-10','16:40:00',2.69),('15128','2013-09-10','16:45:00',1.56),('15128','2013-09-10','16:50:00',1.73),('15128','2013-09-10','16:55:00',2.17),('15128','2013-09-10','17:00:00',2.55),('15128','2013-09-10','17:05:00',2.42),('15128','2013-09-10','17:10:00',2.24),('15128','2013-09-10','17:15:00',1.73),('15128','2013-09-10','17:20:00',1.65),('15128','2013-09-10','17:25:00',2.05),('15128','2013-09-10','17:30:00',1.42),('15128','2013-09-10','17:35:00',1.82),('15128','2013-09-10','17:40:00',1.75),('15128','2013-09-10','17:45:00',1.66),('15128','2013-09-10','17:50:00',1.59),('15128','2013-09-10','17:55:00',1.53),('15128','2013-09-10','18:00:00',1.4),('15128','2013-09-10','18:05:00',1.25),('15128','2013-09-10','18:10:00',1.12),('15128','2013-09-09','09:00:00',1.37),('15128','2013-09-09','09:05:00',1.09),('15128','2013-09-09','09:10:00',1.36),('15128','2013-09-09','09:15:00',1.28),('15128','2013-09-09','09:20:00',1.45),('15128','2013-09-09','09:25:00',1.41),('15128','2013-09-09','09:30:00',1.08),('15128','2013-09-09','09:35:00',1.24),('15128','2013-09-09','09:40:00',1.18),('15128','2013-09-09','09:45:00',1.24),('15128','2013-09-09','09:50:00',1.29),('15128','2013-09-09','09:55:00',1.11),('15128','2013-09-09','10:30:00',1.02),('15128','2013-09-09','10:35:00',1.24),('15128','2013-09-09','10:40:00',1.47),('15128','2013-09-09','10:45:00',1.56),('15128','2013-09-09','10:50:00',1.39),('15128','2013-09-09','10:55:00',1.68),('15128','2013-09-09','11:00:00',2.8),('15128','2013-09-09','11:05:00',1.74),('15128','2013-09-09','11:10:00',1.21),('15128','2013-09-09','11:20:00',1.29),('15128','2013-09-09','11:25:00',1.63),('15128','2013-09-09','11:30:00',1.01),('15128','2013-09-09','11:40:00',1.13),('15128','2013-09-09','11:45:00',1.61),('15128','2013-09-09','11:50:00',1.16),('15128','2013-09-09','11:55:00',1.12),('15128','2013-09-09','12:05:00',1.07),('15128','2013-09-09','12:10:00',1.01),('15128','2013-09-09','12:15:00',1.41),('15128','2013-09-09','12:20:00',1.19),('15128','2013-09-09','12:25:00',1.02),('15128','2013-09-09','12:55:00',1.06),('15128','2013-09-09','13:00:00',1.19),('15128','2013-09-09','13:05:00',1.06),('15128','2013-09-09','13:10:00',1.01),('15128','2013-09-09','13:15:00',1.26),('15128','2013-09-09','13:20:00',1.29),('15128','2013-09-09','13:25:00',1.32),('15128','2013-09-09','13:30:00',1.25),('15128','2013-09-09','13:35:00',1.66),('15128','2013-09-09','13:40:00',1.97),('15128','2013-09-09','13:45:00',2.44),('15128','2013-09-09','13:50:00',2.58),('15128','2013-09-09','13:55:00',2.39),('15128','2013-09-09','14:00:00',1.84),('15128','2013-09-09','14:05:00',1.54),('15128','2013-09-09','14:10:00',1.66),('15128','2013-09-09','14:15:00',1.94),('15128','2013-09-09','14:20:00',2.06),('15128','2013-09-09','14:25:00',2.42),('15128','2013-09-09','14:30:00',2.24),('15128','2013-09-09','14:35:00',1.54),('15128','2013-09-09','14:40:00',1.85),('15128','2013-09-09','14:45:00',2.2),('15128','2013-09-09','14:50:00',2.16),('15128','2013-09-09','14:55:00',2.32),('15128','2013-09-09','15:00:00',2.58),('15128','2013-09-09','15:05:00',2.72),('15128','2013-09-09','15:10:00',2.7),('15128','2013-09-09','15:15:00',2.45),('15128','2013-09-09','15:20:00',1.57),('15128','2013-09-09','15:25:00',1.5),('15128','2013-09-09','15:30:00',1.77),('15128','2013-09-09','15:35:00',1.46),('15128','2013-09-09','15:40:00',1.39),('15128','2013-09-09','15:45:00',1.38),('15128','2013-09-09','15:50:00',1.28),('15128','2013-09-09','15:55:00',1.1),('15128','2013-09-09','16:05:00',1.01),('15128','2013-09-09','16:15:00',1.01),('15128','2013-09-09','16:45:00',1.39),('15128','2013-09-09','16:55:00',1.1),('15128','2013-09-08','08:50:00',1.05),('15128','2013-09-08','08:55:00',1.11),('15128','2013-09-08','09:00:00',1.17),('15128','2013-09-08','09:05:00',1.07),('15128','2013-09-08','09:10:00',1.03),('15128','2013-09-08','09:15:00',1.09),('15128','2013-09-08','09:35:00',1.04),('15128','2013-09-08','09:40:00',1.44),('15128','2013-09-08','09:45:00',1.45),('15128','2013-09-08','09:50:00',1.28),('15128','2013-09-08','09:55:00',1.35),('15128','2013-09-08','10:00:00',1.43),('15128','2013-09-08','10:05:00',1.22),('15128','2013-09-08','10:15:00',1.11),('15128','2013-09-08','10:30:00',1.21),('15128','2013-09-08','10:35:00',1.64),('15128','2013-09-08','10:40:00',1.94),('15128','2013-09-08','10:45:00',2.31),('15128','2013-09-08','10:50:00',2.54),('15128','2013-09-08','10:55:00',2.63),('15128','2013-09-08','11:00:00',2.45),('15128','2013-09-08','11:05:00',2.01),('15128','2013-09-08','11:10:00',1.89),('15128','2013-09-08','11:15:00',1.96),('15128','2013-09-08','11:20:00',2.72),('15128','2013-09-08','11:25:00',2.38),('15128','2013-09-08','11:30:00',2.28),('15128','2013-09-08','11:35:00',2.01),('15128','2013-09-08','11:40:00',1.98),('15128','2013-09-08','11:45:00',2.15),('15128','2013-09-08','11:50:00',1.89),('15128','2013-09-08','11:55:00',1.68),('15128','2013-09-08','12:00:00',2.48),('15128','2013-09-08','12:05:00',2.4),('15128','2013-09-08','12:10:00',1.7),('15128','2013-09-08','12:15:00',2.09),('15128','2013-09-08','12:20:00',1.8),('15128','2013-09-08','12:25:00',2.23),('15128','2013-09-08','12:30:00',2.1),('15128','2013-09-08','12:35:00',1.61),('15128','2013-09-08','12:40:00',1.69),('15128','2013-09-08','12:45:00',1.69),('15128','2013-09-08','12:50:00',2.28),('15128','2013-09-08','12:55:00',2.01),('15128','2013-09-08','13:00:00',2.2),('15128','2013-09-08','13:05:00',3.2),('15128','2013-09-08','13:10:00',3.17),('15128','2013-09-08','13:15:00',3.31),('15128','2013-09-08','13:20:00',2.87),('15128','2013-09-08','13:25:00',2.55),('15128','2013-09-08','13:30:00',3.62),('15128','2013-09-08','13:35:00',3.8),('15128','2013-09-08','13:40:00',3.63),('15128','2013-09-08','13:45:00',4.02),('15128','2013-09-08','13:50:00',3.52),('15128','2013-09-08','13:55:00',2.42),('15128','2013-09-08','14:00:00',2.13),('15128','2013-09-08','14:05:00',2.56),('15128','2013-09-08','14:10:00',3.45),('15128','2013-09-08','14:15:00',2.22),('15128','2013-09-08','14:20:00',3.91),('15128','2013-09-08','14:25:00',3.15),('15128','2013-09-08','14:30:00',2.49),('15128','2013-09-08','14:35:00',2.62),('15128','2013-09-08','14:40:00',1.81),('15128','2013-09-08','14:45:00',2.99),('15128','2013-09-08','14:50:00',2.38),('15128','2013-09-08','14:55:00',3.43),('15128','2013-09-08','15:00:00',3.29),('15128','2013-09-08','15:05:00',2.78),('15128','2013-09-08','15:10:00',3.68),('15128','2013-09-08','15:15:00',3.02),('15128','2013-09-08','15:20:00',2.82),('15128','2013-09-08','15:25:00',3.44),('15128','2013-09-08','15:30:00',2.66),('15128','2013-09-08','15:35:00',2.97),('15128','2013-09-08','15:40:00',1.82),('15128','2013-09-08','15:45:00',1.41),('15128','2013-09-08','15:50:00',2.22),('15128','2013-09-08','15:55:00',1.76),('15128','2013-09-08','16:00:00',1.65),('15128','2013-09-08','16:05:00',1.76),('15128','2013-09-08','16:10:00',1.66),('15128','2013-09-08','16:15:00',1.36),('15128','2013-09-08','16:20:00',1.47),('15128','2013-09-08','16:35:00',1.08),('15128','2013-09-08','16:40:00',1.45),('15128','2013-09-08','16:45:00',1.37),('15128','2013-09-08','16:50:00',1.64),('15128','2013-09-08','18:00:00',1.15),('15128','2013-09-08','18:05:00',1.13),('15128','2013-09-08','18:20:00',1.08),('15128','2013-09-07','09:15:00',1.28),('15128','2013-09-07','09:20:00',1.33),('15128','2013-09-07','09:25:00',1.41),('15128','2013-09-07','09:30:00',1.45),('15128','2013-09-07','09:35:00',1.5),('15128','2013-09-07','09:40:00',1.58),('15128','2013-09-07','09:45:00',1.63),('15128','2013-09-07','09:50:00',1.67),('15128','2013-09-07','09:55:00',1.73),('15128','2013-09-07','10:00:00',1.77),('15128','2013-09-07','10:05:00',1.86),('15128','2013-09-07','10:10:00',1.9),('15128','2013-09-07','10:15:00',1.99),('15128','2013-09-07','10:20:00',2.06),('15128','2013-09-07','10:25:00',2.1),('15128','2013-09-07','10:30:00',2.17),('15128','2013-09-07','10:35:00',2.2),('15128','2013-09-07','10:40:00',2.3),('15128','2013-09-07','10:45:00',2.38),('15128','2013-09-07','10:50:00',2.38),('15128','2013-09-07','10:55:00',2.47),('15128','2013-09-07','11:00:00',2.48),('15128','2013-09-07','11:05:00',2.49),('15128','2013-09-07','11:10:00',2.57),('15128','2013-09-07','11:15:00',2.66),('15128','2013-09-07','11:20:00',2.72),('15128','2013-09-07','11:25:00',2.75),('15128','2013-09-07','11:30:00',2.73),('15128','2013-09-07','11:35:00',2.79),('15128','2013-09-07','11:40:00',2.91),('15128','2013-09-07','11:45:00',2.96),('15128','2013-09-07','11:50:00',2.97),('15128','2013-09-07','11:55:00',3.05),('15128','2013-09-07','12:00:00',3.12),('15128','2013-09-07','12:05:00',3.11),('15128','2013-09-07','12:10:00',3.33),('15128','2013-09-07','12:15:00',3.43),('15128','2013-09-07','12:20:00',3.4),('15128','2013-09-07','12:25:00',3.42),('15128','2013-09-07','12:30:00',3.47),('15128','2013-09-07','12:35:00',3.41),('15128','2013-09-07','12:40:00',3.54),('15128','2013-09-07','12:45:00',3.59),('15128','2013-09-07','12:50:00',3.6),('15128','2013-09-07','12:55:00',3.5),('15128','2013-09-07','13:00:00',3.47),('15128','2013-09-07','13:05:00',3.62),('15128','2013-09-07','13:10:00',3.53),('15128','2013-09-07','13:15:00',3.43),('15128','2013-09-07','13:20:00',3.43),('15128','2013-09-07','13:25:00',3.16),('15128','2013-09-07','13:30:00',3.23),('15128','2013-09-07','13:35:00',2.63),('15128','2013-09-07','13:40:00',2.29),('15128','2013-09-07','13:45:00',2.54),('15128','2013-09-07','13:50:00',3.17),('15128','2013-09-07','13:55:00',3.29),('15128','2013-09-07','14:00:00',3.12),('15128','2013-09-07','14:05:00',3.18),('15128','2013-09-07','14:10:00',2.73),('15128','2013-09-07','14:15:00',3.17),('15128','2013-09-07','14:20:00',3.53),('15128','2013-09-07','14:25:00',3.43),('15128','2013-09-07','14:30:00',3.85),('15128','2013-09-07','14:35:00',3.74),('15128','2013-09-07','14:40:00',3.84),('15128','2013-09-07','14:45:00',3.75),('15128','2013-09-07','14:50:00',3.24),('15128','2013-09-07','14:55:00',3.78),('15128','2013-09-07','15:00:00',3.59),('15128','2013-09-07','15:05:00',2.22),('15128','2013-09-07','15:10:00',2.79),('15128','2013-09-07','15:15:00',3.68),('15128','2013-09-07','15:20:00',3.76),('15128','2013-09-07','15:25:00',3.66),('15128','2013-09-07','15:30:00',3.56),('15128','2013-09-07','15:35:00',3.2),('15128','2013-09-07','15:40:00',3.4),('15128','2013-09-07','15:45:00',3.42),('15128','2013-09-07','15:50:00',2.69),('15128','2013-09-07','15:55:00',2.93),('15128','2013-09-07','16:00:00',2.64),('15128','2013-09-07','16:05:00',2.41),('15128','2013-09-07','16:10:00',3.04),('15128','2013-09-07','16:15:00',2.83),('15128','2013-09-07','16:20:00',2.82),('15128','2013-09-07','16:25:00',2.23),('15128','2013-09-07','16:30:00',2.71),('15128','2013-09-07','16:35:00',2.07),('15128','2013-09-07','16:40:00',2.32),('15128','2013-09-07','16:45:00',1.36),('15128','2013-09-07','16:50:00',1.14),('15128','2013-09-07','16:55:00',1.79),('15128','2013-09-07','17:00:00',2.59),('15128','2013-09-07','17:05:00',2.37),('15128','2013-09-07','17:10:00',2.16),('15128','2013-09-07','17:15:00',1.96),('15128','2013-09-07','17:20:00',1.89),('15128','2013-09-07','17:25:00',1.52),('15128','2013-09-07','17:35:00',1.25),('15128','2013-09-07','17:40:00',1.56),('15128','2013-09-07','17:45:00',1.44),('15128','2013-09-07','17:50:00',1.37),('15128','2013-09-07','17:55:00',1.28),('15128','2013-09-07','18:00:00',1.13),('15128','2013-09-06','09:15:00',1.31),('15128','2013-09-06','09:20:00',1.36),('15128','2013-09-06','09:25:00',1.41),('15128','2013-09-06','09:30:00',1.45),('15128','2013-09-06','09:35:00',1.5),('15128','2013-09-06','09:40:00',1.57),('15128','2013-09-06','09:45:00',1.67),('15128','2013-09-06','09:55:00',1.76),('15128','2013-09-06','10:00:00',1.81),('15128','2013-09-06','10:05:00',1.86),('15128','2013-09-06','10:10:00',1.85),('15128','2013-09-06','10:15:00',1.97),('15128','2013-09-06','10:20:00',2.03),('15128','2013-09-06','10:25:00',2.05),('15128','2013-09-06','10:30:00',2.11),('15128','2013-09-06','10:35:00',2.11),('15128','2013-09-06','10:40:00',2.25),('15128','2013-09-06','10:45:00',2.34),('15128','2013-09-06','10:50:00',2.39),('15128','2013-09-06','10:55:00',2.33),('15128','2013-09-06','11:00:00',2.41),('15128','2013-09-06','11:05:00',2.57),('15128','2013-09-06','11:10:00',2.62),('15128','2013-09-06','11:15:00',2.7),('15128','2013-09-06','11:20:00',2.76),('15128','2013-09-06','11:25:00',2.76),('15128','2013-09-06','11:30:00',2.79),('15128','2013-09-06','11:35:00',2.84),('15128','2013-09-06','11:40:00',2.93),('15128','2013-09-06','11:45:00',2.98),('15128','2013-09-06','11:50:00',3.07),('15128','2013-09-06','11:55:00',3.24),('15128','2013-09-06','12:00:00',3.32),('15128','2013-09-06','12:05:00',3.35),('15128','2013-09-06','12:10:00',3.4),('15128','2013-09-06','12:15:00',3.45),('15128','2013-09-06','12:20:00',3.48),('15128','2013-09-06','12:25:00',3.51),('15128','2013-09-06','12:30:00',3.57),('15128','2013-09-06','12:35:00',3.59),('15128','2013-09-06','12:40:00',3.57),('15128','2013-09-06','12:45:00',3.58),('15128','2013-09-06','12:50:00',3.59),('15128','2013-09-06','12:55:00',3.63),('15128','2013-09-06','13:00:00',3.78),('15128','2013-09-06','13:05:00',3.76),('15128','2013-09-06','13:10:00',3.7),('15128','2013-09-06','13:15:00',3.67),('15128','2013-09-06','13:20:00',3.58),('15128','2013-09-06','13:25:00',3.73),('15128','2013-09-06','13:30:00',3.77),('15128','2013-09-06','13:35:00',3.79),('15128','2013-09-06','13:40:00',3.82),('15128','2013-09-06','13:45:00',3.82),('15128','2013-09-06','13:50:00',3.82),('15128','2013-09-06','13:55:00',3.76),('15128','2013-09-06','14:00:00',3.78),('15128','2013-09-06','14:05:00',3.78),('15128','2013-09-06','14:10:00',3.83),('15128','2013-09-06','14:15:00',3.82),('15128','2013-09-06','14:20:00',3.82),('15128','2013-09-06','14:25:00',3.82),('15128','2013-09-06','14:30:00',3.79),('15128','2013-09-06','14:35:00',3.8),('15128','2013-09-06','14:40:00',3.77),('15128','2013-09-06','14:45:00',3.75),('15128','2013-09-06','14:50:00',3.71),('15128','2013-09-06','14:55:00',3.69),('15128','2013-09-06','15:00:00',3.66),('15128','2013-09-06','15:05:00',3.62),('15128','2013-09-06','15:10:00',3.6),('15128','2013-09-06','15:15:00',3.57),('15128','2013-09-06','15:20:00',3.55),('15128','2013-09-06','15:25:00',3.52),('15128','2013-09-06','15:30:00',3.48),('15128','2013-09-06','15:35:00',3.44),('15128','2013-09-06','15:40:00',3.4),('15128','2013-09-06','15:45:00',3.37),('15128','2013-09-06','15:50:00',3.33),('15128','2013-09-06','15:55:00',3.26),('15128','2013-09-06','16:00:00',3.22),('15128','2013-09-06','16:05:00',3.16),('15128','2013-09-06','16:10:00',3.1),('15128','2013-09-06','16:15:00',3.03),('15128','2013-09-06','16:20:00',2.96),('15128','2013-09-06','16:25:00',2.91),('15128','2013-09-06','16:30:00',2.86),('15128','2013-09-06','16:35:00',2.81),('15128','2013-09-06','16:40:00',2.74),('15128','2013-09-06','16:45:00',2.67),('15128','2013-09-06','16:50:00',2.59),('15128','2013-09-06','16:55:00',2.51),('15128','2013-09-06','17:00:00',2.41),('15128','2013-09-06','17:05:00',2.31),('15128','2013-09-06','17:10:00',2.21),('15128','2013-09-06','17:15:00',2.05),('15128','2013-09-06','17:20:00',1.95),('15128','2013-09-06','17:25:00',1.83),('15128','2013-09-06','17:30:00',1.75),('15128','2013-09-06','17:35:00',1.68),('15128','2013-09-06','17:40:00',1.59),('15128','2013-09-06','17:45:00',1.56),('15128','2013-09-06','17:50:00',1.52),('15128','2013-09-06','17:55:00',1.42),('15128','2013-09-06','18:00:00',1.35),('15128','2013-09-06','18:05:00',1.24),('15128','2013-09-06','18:10:00',1.13),('15128','2013-09-06','18:15:00',1.01),('15128','2013-09-05','08:50:00',1.02),('15128','2013-09-05','08:55:00',1.07),('15128','2013-09-05','09:00:00',1.12),('15128','2013-09-05','09:05:00',1.18),('15128','2013-09-05','09:10:00',1.27),('15128','2013-09-05','09:15:00',1.34),('15128','2013-09-05','09:20:00',1.41),('15128','2013-09-05','09:25:00',1.46),('15128','2013-09-05','09:30:00',1.49),('15128','2013-09-05','09:35:00',1.55),('15128','2013-09-05','09:40:00',1.7),('15128','2013-09-05','09:45:00',1.76),('15128','2013-09-05','09:50:00',1.81),('15128','2013-09-05','09:55:00',1.78),('15128','2013-09-05','10:00:00',1.84),('15128','2013-09-05','10:05:00',1.89),('15128','2013-09-05','10:10:00',1.91),('15128','2013-09-05','10:15:00',2.04),('15128','2013-09-05','10:20:00',2.06),('15128','2013-09-05','10:25:00',2.1),('15128','2013-09-05','10:30:00',2.14),('15128','2013-09-05','10:35:00',2.2),('15128','2013-09-05','10:40:00',2.29),('15128','2013-09-05','10:45:00',2.4),('15128','2013-09-05','10:50:00',2.46),('15128','2013-09-05','10:55:00',2.42),('15128','2013-09-05','11:00:00',2.5),('15128','2013-09-05','11:05:00',2.62),('15128','2013-09-05','11:10:00',2.66),('15128','2013-09-05','11:15:00',2.75),('15128','2013-09-05','11:20:00',2.76),('15128','2013-09-05','11:25:00',2.81),('15128','2013-09-05','11:30:00',2.82),('15128','2013-09-05','11:35:00',2.87),('15128','2013-09-05','11:40:00',2.96),('15128','2013-09-05','11:45:00',2.97),('15128','2013-09-05','11:50:00',3.09),('15128','2013-09-05','11:55:00',3.23),('15128','2013-09-05','12:00:00',3.34),('15128','2013-09-05','12:05:00',3.4),('15128','2013-09-05','12:10:00',3.44),('15128','2013-09-05','12:15:00',3.49),('15128','2013-09-05','12:20:00',3.53),('15128','2013-09-05','12:25:00',3.57),('15128','2013-09-05','12:30:00',3.57),('15128','2013-09-05','12:35:00',3.57),('15128','2013-09-05','12:40:00',3.61),('15128','2013-09-05','12:45:00',3.64),('15128','2013-09-05','12:50:00',3.65),('15128','2013-09-05','12:55:00',3.67),('15128','2013-09-05','13:00:00',3.71),('15128','2013-09-05','13:05:00',3.72),('15128','2013-09-05','13:10:00',3.72),('15128','2013-09-05','13:15:00',3.72),('15128','2013-09-05','13:20:00',3.72),('15128','2013-09-05','13:25:00',3.7),('15128','2013-09-05','13:30:00',3.7),('15128','2013-09-05','13:35:00',3.71),('15128','2013-09-05','13:40:00',3.71),('15128','2013-09-05','13:45:00',3.72),('15128','2013-09-05','13:50:00',3.73),('15128','2013-09-05','13:55:00',3.75),('15128','2013-09-05','14:00:00',3.69),('15128','2013-09-05','14:05:00',3.65),('15128','2013-09-05','14:10:00',3.69),('15128','2013-09-05','14:15:00',3.61),('15128','2013-09-05','14:20:00',3.52),('15128','2013-09-05','14:25:00',3.58),('15128','2013-09-05','14:30:00',3.6),('15128','2013-09-05','14:35:00',3.66),('15128','2013-09-05','14:40:00',3.66),('15128','2013-09-05','14:45:00',3.6),('15128','2013-09-05','14:50:00',3.61),('15128','2013-09-05','14:55:00',3.58),('15128','2013-09-05','15:00:00',3.57),('15128','2013-09-05','15:05:00',3.53),('15128','2013-09-05','15:10:00',3.52),('15128','2013-09-05','15:15:00',3.5),('15128','2013-09-05','15:20:00',3.52),('15128','2013-09-05','15:25:00',3.5),('15128','2013-09-05','15:30:00',3.44),('15128','2013-09-05','15:35:00',3.4),('15128','2013-09-05','15:40:00',3.37),('15128','2013-09-05','15:45:00',3.34),('15128','2013-09-05','15:50:00',3.3),('15128','2013-09-05','15:55:00',3.27),('15128','2013-09-05','16:00:00',3.23),('15128','2013-09-05','16:05:00',3.18),('15128','2013-09-05','16:10:00',3.14),('15128','2013-09-05','16:15:00',3.11),('15128','2013-09-05','16:20:00',3.04),('15128','2013-09-05','16:25:00',2.96),('15128','2013-09-05','16:30:00',2.94),('15128','2013-09-05','16:35:00',2.85),('15128','2013-09-05','16:40:00',2.75),('15128','2013-09-05','16:45:00',2.7),('15128','2013-09-05','16:50:00',2.62),('15128','2013-09-05','16:55:00',2.53),('15128','2013-09-05','17:00:00',2.41),('15128','2013-09-05','17:05:00',2.3),('15128','2013-09-05','17:10:00',2.14),('15128','2013-09-05','17:15:00',2.04),('15128','2013-09-05','17:20:00',1.97),('15128','2013-09-05','17:25:00',1.88),('15128','2013-09-05','17:30:00',1.76),('15128','2013-09-05','17:35:00',1.67),('15128','2013-09-05','17:40:00',1.59),('15128','2013-09-05','17:45:00',1.51),('15128','2013-09-05','17:50:00',1.48),('15128','2013-09-05','17:55:00',1.44),('15128','2013-09-05','18:00:00',1.38),('15128','2013-09-05','18:05:00',1.26),('15128','2013-09-05','18:10:00',1.09),('15128','2013-09-05','18:15:00',1.02),('15128','2013-09-04','08:50:00',1.08),('15128','2013-09-04','08:55:00',1.12),('15128','2013-09-04','09:00:00',1.18),('15128','2013-09-04','09:05:00',1.27),('15128','2013-09-04','09:10:00',1.34),('15128','2013-09-04','09:15:00',1.37),('15128','2013-09-04','09:20:00',1.45),('15128','2013-09-04','09:25:00',1.53),('15128','2013-09-04','09:30:00',1.6),('15128','2013-09-04','09:35:00',1.69),('15128','2013-09-04','09:40:00',1.76),('15128','2013-09-04','09:45:00',1.81),('15128','2013-09-04','09:50:00',1.86),('15128','2013-09-04','09:55:00',1.84),('15128','2013-09-04','10:00:00',1.89),('15128','2013-09-04','10:05:00',1.94),('15128','2013-09-04','10:10:00',2.01),('15128','2013-09-04','10:15:00',2.08),('15128','2013-09-04','10:20:00',2.08),('15128','2013-09-04','10:25:00',2.16),('15128','2013-09-04','10:30:00',2.2),('15128','2013-09-04','10:35:00',2.21),('15128','2013-09-04','10:40:00',2.29),('15128','2013-09-04','10:45:00',2.42),('15128','2013-09-04','10:50:00',2.47),('15128','2013-09-04','10:55:00',2.5),('15128','2013-09-04','11:00:00',2.55),('15128','2013-09-04','11:05:00',2.7),('15128','2013-09-04','11:10:00',2.74),('15128','2013-09-04','11:15:00',2.79),('15128','2013-09-04','11:20:00',2.85),('15128','2013-09-04','11:25:00',2.82),('15128','2013-09-04','11:30:00',2.91),('15128','2013-09-04','11:35:00',2.92),('15128','2013-09-04','11:40:00',3.03),('15128','2013-09-04','11:45:00',3.06),('15128','2013-09-04','11:50:00',3.22),('15128','2013-09-04','11:55:00',3.35),('15128','2013-09-04','12:00:00',3.46),('15128','2013-09-04','12:05:00',3.51),('15128','2013-09-04','12:10:00',3.57),('15128','2013-09-04','12:15:00',3.6),('15128','2013-09-04','12:20:00',3.64),('15128','2013-09-04','12:25:00',3.66),('15128','2013-09-04','12:30:00',3.71),('15128','2013-09-04','12:35:00',3.72),('15128','2013-09-04','12:40:00',3.73),('15128','2013-09-04','12:45:00',3.73),('15128','2013-09-04','12:50:00',3.76),('15128','2013-09-04','12:55:00',3.78),('15128','2013-09-04','13:00:00',3.82),('15128','2013-09-04','13:05:00',3.84),('15128','2013-09-04','13:10:00',3.83),('15128','2013-09-04','13:15:00',3.85),('15128','2013-09-04','13:20:00',3.87),('15128','2013-09-04','13:25:00',3.89),('15128','2013-09-04','13:30:00',3.88),('15128','2013-09-04','13:35:00',3.88),('15128','2013-09-04','13:40:00',3.88),('15128','2013-09-04','13:45:00',3.88),('15128','2013-09-04','13:50:00',3.84),('15128','2013-09-04','13:55:00',3.82),('15128','2013-09-04','14:00:00',3.81),('15128','2013-09-04','14:05:00',3.81),('15128','2013-09-04','14:10:00',3.81),('15128','2013-09-04','14:15:00',3.8),('15128','2013-09-04','14:20:00',3.83),('15128','2013-09-04','14:25:00',3.84),('15128','2013-09-04','14:30:00',3.82),('15128','2013-09-04','14:35:00',3.8),('15128','2013-09-04','14:40:00',3.77),('15128','2013-09-04','14:45:00',3.76),('15128','2013-09-04','14:50:00',3.77),('15128','2013-09-04','14:55:00',3.75),('15128','2013-09-04','15:00:00',3.72),('15128','2013-09-04','15:05:00',3.7),('15128','2013-09-04','15:10:00',3.71),('15128','2013-09-04','15:15:00',3.67),('15128','2013-09-04','15:20:00',3.62),('15128','2013-09-04','15:25:00',3.58),('15128','2013-09-04','15:30:00',3.57),('15128','2013-09-04','15:35:00',3.53),('15128','2013-09-04','15:40:00',3.48),('15128','2013-09-04','15:45:00',3.43),('15128','2013-09-04','15:50:00',3.39),('15128','2013-09-04','15:55:00',3.33),('15128','2013-09-04','16:00:00',3.29),('15128','2013-09-04','16:05:00',3.24),('15128','2013-09-04','16:10:00',3.19),('15128','2013-09-04','16:15:00',3.15),('15128','2013-09-04','16:20:00',3.12),('15128','2013-09-04','16:25:00',3.08),('15128','2013-09-04','16:30:00',3.02),('15128','2013-09-04','16:35:00',2.97),('15128','2013-09-04','16:40:00',2.94),('15128','2013-09-04','16:45:00',2.88),('15128','2013-09-04','16:50:00',2.85),('15128','2013-09-04','16:55:00',2.68),('15128','2013-09-04','17:00:00',1.95),('15128','2013-09-04','17:05:00',1.53),('15128','2013-09-04','17:10:00',1.71),('15128','2013-09-04','17:15:00',1.57),('15128','2013-09-04','17:20:00',1.49),('15128','2013-09-04','17:25:00',1.61),('15128','2013-09-04','17:30:00',1.55),('15128','2013-09-04','17:35:00',1.7),('15128','2013-09-04','17:40:00',1.86),('15128','2013-09-04','17:45:00',1.85),('15128','2013-09-04','17:50:00',1.68),('15128','2013-09-04','17:55:00',1.76),('15128','2013-09-04','18:00:00',1.43),('15128','2013-09-04','18:05:00',1.34),('15128','2013-09-04','18:10:00',1.23),('15128','2013-09-04','18:15:00',1.12),('15128','2013-09-04','18:20:00',1.04),('15128','2013-09-03','08:50:00',1.08),('15128','2013-09-03','08:55:00',1.14),('15128','2013-09-03','09:00:00',1.19),('15128','2013-09-03','09:05:00',1.29),('15128','2013-09-03','09:10:00',1.37),('15128','2013-09-03','09:15:00',1.42),('15128','2013-09-03','09:20:00',1.5),('15128','2013-09-03','09:25:00',1.56),('15128','2013-09-03','09:30:00',1.63),('15128','2013-09-03','09:35:00',1.73),('15128','2013-09-03','09:40:00',1.8),('15128','2013-09-03','09:45:00',1.85),('15128','2013-09-03','09:50:00',1.89),('15128','2013-09-03','09:55:00',1.87),('15128','2013-09-03','10:00:00',1.96),('15128','2013-09-03','10:05:00',2.01),('15128','2013-09-03','10:10:00',2.08),('15128','2013-09-03','10:15:00',2.15),('15128','2013-09-03','10:20:00',2.2),('15128','2013-09-03','10:25:00',2.26),('15128','2013-09-03','10:30:00',2.34),('15128','2013-09-03','10:35:00',2.34),('15128','2013-09-03','10:40:00',2.37),('15128','2013-09-03','10:45:00',2.44),('15128','2013-09-03','10:50:00',2.51),('15128','2013-09-03','10:55:00',2.56),('15128','2013-09-03','11:00:00',2.61),('15128','2013-09-03','11:05:00',2.72),('15128','2013-09-03','11:10:00',2.76),('15128','2013-09-03','11:15:00',2.79),('15128','2013-09-03','11:20:00',2.88),('15128','2013-09-03','11:25:00',2.87),('15128','2013-09-03','11:30:00',2.99),('15128','2013-09-03','11:35:00',2.96),('15128','2013-09-03','11:40:00',3.1),('15128','2013-09-03','11:45:00',3.14),('15128','2013-09-03','11:50:00',3.34),('15128','2013-09-03','11:55:00',3.44),('15128','2013-09-03','12:00:00',3.53),('15128','2013-09-03','12:05:00',3.57),('15128','2013-09-03','12:10:00',3.6),('15128','2013-09-03','12:15:00',3.64),('15128','2013-09-03','12:20:00',3.68),('15128','2013-09-03','12:25:00',3.72),('15128','2013-09-03','12:30:00',3.77),('15128','2013-09-03','12:35:00',3.79),('15128','2013-09-03','12:40:00',3.79),('15128','2013-09-03','12:45:00',3.79),('15128','2013-09-03','12:50:00',3.82),('15128','2013-09-03','12:55:00',3.85),('15128','2013-09-03','13:00:00',3.86),('15128','2013-09-03','13:05:00',3.86),('15128','2013-09-03','13:10:00',3.94),('15128','2013-09-03','13:15:00',3.95),('15128','2013-09-03','13:20:00',3.95),('15128','2013-09-03','13:25:00',3.94),('15128','2013-09-03','13:30:00',3.93),('15128','2013-09-03','13:35:00',3.93),('15128','2013-09-03','13:40:00',3.92),('15128','2013-09-03','13:45:00',3.94),('15128','2013-09-03','13:50:00',3.95),('15128','2013-09-03','13:55:00',3.94),('15128','2013-09-03','14:00:00',3.96),('15128','2013-09-03','14:05:00',3.95),('15128','2013-09-03','14:10:00',3.92),('15128','2013-09-03','14:15:00',3.89),('15128','2013-09-03','14:20:00',3.88),('15128','2013-09-03','14:25:00',3.86),('15128','2013-09-03','14:30:00',3.87),('15128','2013-09-03','14:35:00',3.86),('15128','2013-09-03','14:40:00',3.86),('15128','2013-09-03','14:45:00',3.83),('15128','2013-09-03','14:50:00',3.81),('15128','2013-09-03','14:55:00',3.79),('15128','2013-09-03','15:00:00',3.76),('15128','2013-09-03','15:05:00',3.76),('15128','2013-09-03','15:10:00',3.71),('15128','2013-09-03','15:15:00',3.67),('15128','2013-09-03','15:20:00',3.63),('15128','2013-09-03','15:25:00',3.58),('15128','2013-09-03','15:30:00',3.55),('15128','2013-09-03','15:35:00',3.5),('15128','2013-09-03','15:40:00',3.48),('15128','2013-09-03','15:45:00',3.13),('15128','2013-09-03','15:50:00',3.43),('15128','2013-09-03','15:55:00',3.39),('15128','2013-09-03','16:00:00',3.34),('15128','2013-09-03','16:05:00',3.28),('15128','2013-09-03','16:10:00',3.25),('15128','2013-09-03','16:15:00',3.21),('15128','2013-09-03','16:20:00',3.14),('15128','2013-09-03','16:25:00',3.05),('15128','2013-09-03','16:30:00',2.95),('15128','2013-09-03','16:35:00',2.91),('15128','2013-09-03','16:40:00',2.83),('15128','2013-09-03','16:45:00',2.8),('15128','2013-09-03','16:50:00',2.74),('15128','2013-09-03','16:55:00',2.67),('15128','2013-09-03','17:00:00',2.56),('15128','2013-09-03','17:05:00',2.42),('15128','2013-09-03','17:10:00',2.29),('15128','2013-09-03','17:15:00',2.23),('15128','2013-09-03','17:20:00',2.09),('15128','2013-09-03','17:25:00',1.95),('15128','2013-09-03','17:30:00',1.84),('15128','2013-09-03','17:35:00',1.8),('15128','2013-09-03','17:40:00',1.72),('15128','2013-09-03','17:45:00',1.68),('15128','2013-09-03','17:50:00',1.62),('15128','2013-09-03','17:55:00',1.6),('15128','2013-09-03','18:00:00',1.52),('15128','2013-09-03','18:05:00',1.45),('15128','2013-09-03','18:10:00',1.33),('15128','2013-09-03','18:15:00',1.21),('15128','2013-09-03','18:20:00',1.09),('15128','2013-09-03','18:25:00',1.01),('15128','2013-09-02','08:50:00',1.05),('15128','2013-09-02','08:55:00',1.1),('15128','2013-09-02','09:00:00',1.15),('15128','2013-09-02','09:05:00',1.24),('15128','2013-09-02','09:10:00',1.32),('15128','2013-09-02','09:15:00',1.37),('15128','2013-09-02','09:20:00',1.43),('15128','2013-09-02','09:25:00',1.5),('15128','2013-09-02','09:30:00',1.56),('15128','2013-09-02','09:35:00',1.63),('15128','2013-09-02','09:40:00',1.72),('15128','2013-09-02','09:45:00',1.79),('15128','2013-09-02','09:50:00',1.84),('15128','2013-09-02','09:55:00',1.85),('15128','2013-09-02','10:00:00',1.92),('15128','2013-09-02','10:05:00',1.96),('15128','2013-09-02','10:10:00',2.02),('15128','2013-09-02','10:15:00',2.07),('15128','2013-09-02','10:20:00',2.11),('15128','2013-09-02','10:25:00',2.18),('15128','2013-09-02','10:30:00',2.29),('15128','2013-09-02','10:35:00',2.33),('15128','2013-09-02','10:40:00',2.39),('15128','2013-09-02','10:45:00',2.43),('15128','2013-09-02','10:50:00',2.38),('15128','2013-09-02','10:55:00',2.46),('15128','2013-09-02','11:00:00',2.53),('15128','2013-09-02','11:05:00',2.66),('15128','2013-09-02','11:10:00',2.72),('15128','2013-09-02','11:15:00',2.73),('15128','2013-09-02','11:20:00',2.86),('15128','2013-09-02','11:25:00',2.85),('15128','2013-09-02','11:30:00',2.97),('15128','2013-09-02','11:35:00',2.96),('15128','2013-09-02','11:40:00',3.04),('15128','2013-09-02','11:45:00',3.14),('15128','2013-09-02','11:50:00',3.21),('15128','2013-09-02','11:55:00',3.36),('15128','2013-09-02','12:00:00',3.42),('15128','2013-09-02','12:05:00',3.49),('15128','2013-09-02','12:10:00',3.54),('15128','2013-09-02','12:15:00',3.55),('15128','2013-09-02','12:20:00',3.62),('15128','2013-09-02','12:25:00',3.65),('15128','2013-09-02','12:30:00',3.69),('15128','2013-09-02','12:35:00',3.74),('15128','2013-09-02','12:40:00',3.79),('15128','2013-09-02','12:45:00',3.78),('15128','2013-09-02','12:50:00',3.84),('15128','2013-09-02','12:55:00',3.9),('15128','2013-09-02','13:00:00',3.9),('15128','2013-09-02','13:05:00',3.9),('15128','2013-09-02','13:10:00',3.91),('15128','2013-09-02','13:15:00',3.86),('15128','2013-09-02','13:20:00',3.87),('15128','2013-09-02','13:25:00',3.86),('15128','2013-09-02','13:30:00',3.89),('15128','2013-09-02','13:35:00',3.94),('15128','2013-09-02','13:40:00',3.95),('15128','2013-09-02','13:45:00',3.92),('15128','2013-09-02','13:50:00',3.94),('15128','2013-09-02','13:55:00',3.99),('15128','2013-09-02','14:00:00',4.02),('15128','2013-09-02','14:05:00',4.01),('15128','2013-09-02','14:10:00',3.96),('15128','2013-09-02','14:15:00',3.92),('15128','2013-09-02','14:20:00',3.91),('15128','2013-09-02','14:25:00',3.89),('15128','2013-09-02','14:30:00',3.87),('15128','2013-09-02','14:35:00',3.86),('15128','2013-09-02','14:40:00',3.85),('15128','2013-09-02','14:45:00',3.82),('15128','2013-09-02','14:50:00',3.8),('15128','2013-09-02','14:55:00',3.76),('15128','2013-09-02','15:00:00',3.76),('15128','2013-09-02','15:05:00',3.72),('15128','2013-09-02','15:10:00',3.67),('15128','2013-09-02','15:15:00',3.63),('15128','2013-09-02','15:20:00',3.59),('15128','2013-09-02','15:25:00',3.57),('15128','2013-09-02','15:30:00',3.53),('15128','2013-09-02','15:35:00',3.48),('15128','2013-09-02','15:40:00',3.45),('15128','2013-09-02','15:45:00',3.41),('15128','2013-09-02','15:50:00',3.37),('15128','2013-09-02','15:55:00',3.32),('15128','2013-09-02','16:00:00',3.27),('15128','2013-09-02','16:05:00',3.21),('15128','2013-09-02','16:10:00',3.18),('15128','2013-09-02','16:15:00',3.12),('15128','2013-09-02','16:20:00',3.07),('15128','2013-09-02','16:25:00',3.02),('15128','2013-09-02','16:30:00',2.96),('15128','2013-09-02','16:35:00',2.92),('15128','2013-09-02','16:40:00',2.85),('15128','2013-09-02','16:45:00',2.77),('15128','2013-09-02','16:50:00',2.72),('15128','2013-09-02','16:55:00',2.67),('15128','2013-09-02','17:00:00',2.6),('15128','2013-09-02','17:05:00',2.49),('15128','2013-09-02','17:10:00',2.37),('15128','2013-09-02','17:15:00',2.26),('15128','2013-09-02','17:20:00',2.11),('15128','2013-09-02','17:25:00',1.89),('15128','2013-09-02','17:30:00',1.79),('15128','2013-09-02','17:35:00',1.7),('15128','2013-09-02','17:40:00',1.59),('15128','2013-09-02','17:45:00',1.52),('15128','2013-09-02','17:50:00',1.45),('15128','2013-09-02','17:55:00',1.49),('15128','2013-09-02','18:00:00',1.41),('15128','2013-09-02','18:05:00',1.37),('15128','2013-09-02','18:10:00',1.28),('15128','2013-09-02','18:15:00',1.19),('15128','2013-09-02','18:20:00',1.07),('15128','2013-09-01','08:45:00',1.03),('15128','2013-09-01','08:50:00',1.1),('15128','2013-09-01','08:55:00',1.15),('15128','2013-09-01','09:00:00',1.2),('15128','2013-09-01','09:05:00',1.3),('15128','2013-09-01','09:10:00',1.36),('15128','2013-09-01','09:15:00',1.41),('15128','2013-09-01','09:20:00',1.5),('15128','2013-09-01','09:25:00',1.58),('15128','2013-09-01','09:30:00',1.62),('15128','2013-09-01','09:35:00',1.69),('15128','2013-09-01','09:40:00',1.72),('15128','2013-09-01','09:45:00',1.78),('15128','2013-09-01','09:50:00',1.83),('15128','2013-09-01','09:55:00',1.89),('15128','2013-09-01','10:00:00',1.95),('15128','2013-09-01','10:05:00',2),('15128','2013-09-01','10:10:00',2.08),('15128','2013-09-01','10:15:00',2.13),('15128','2013-09-01','10:20:00',2.17),('15128','2013-09-01','10:25:00',2.24),('15128','2013-09-01','10:30:00',2.3),('15128','2013-09-01','10:35:00',2.39),('15128','2013-09-01','10:40:00',2.44),('15128','2013-09-01','10:45:00',2.49),('15128','2013-09-01','10:50:00',2.57),('15128','2013-09-01','10:55:00',2.6),('15128','2013-09-01','11:00:00',2.62),('15128','2013-09-01','11:05:00',2.71),('15128','2013-09-01','11:10:00',2.81),('15128','2013-09-01','11:15:00',2.82),('15128','2013-09-01','11:20:00',2.91),('15128','2013-09-01','11:25:00',2.92),('15128','2013-09-01','11:30:00',3.02),('15128','2013-09-01','11:35:00',3.07),('15128','2013-09-01','11:40:00',3.13),('15128','2013-09-01','11:45:00',3.17),('15128','2013-09-01','11:50:00',3.28),('15128','2013-09-01','11:55:00',3.38),('15128','2013-09-01','12:00:00',3.49),('15128','2013-09-01','12:05:00',3.55),('15128','2013-09-01','12:10:00',3.59),('15128','2013-09-01','12:15:00',3.62),('15128','2013-09-01','12:20:00',3.65),('15128','2013-09-01','12:25:00',3.68),('15128','2013-09-01','12:30:00',3.7),('15128','2013-09-01','12:35:00',3.72),('15128','2013-09-01','12:40:00',3.74),('15128','2013-09-01','12:45:00',3.76),('15128','2013-09-01','12:50:00',3.8),('15128','2013-09-01','12:55:00',3.81),('15128','2013-09-01','13:00:00',3.82),('15128','2013-09-01','13:05:00',3.84),('15128','2013-09-01','13:10:00',3.88),('15128','2013-09-01','13:15:00',3.88),('15128','2013-09-01','13:20:00',3.87),('15128','2013-09-01','13:25:00',3.9),('15128','2013-09-01','13:30:00',3.9),('15128','2013-09-01','13:35:00',3.89),('15128','2013-09-01','13:40:00',3.87),('15128','2013-09-01','13:45:00',3.89),('15128','2013-09-01','13:50:00',3.89),('15128','2013-09-01','13:55:00',3.86),('15128','2013-09-01','14:00:00',3.83),('15128','2013-09-01','14:05:00',3.85),('15128','2013-09-01','14:10:00',3.8),('15128','2013-09-01','14:15:00',3.9),('15128','2013-09-01','14:20:00',3.87),('15128','2013-09-01','14:25:00',3.89),('15128','2013-09-01','14:30:00',3.85),('15128','2013-09-01','14:35:00',3.87),('15128','2013-09-01','14:40:00',3.87),('15128','2013-09-01','14:45:00',3.84),('15128','2013-09-01','14:50:00',3.79),('15128','2013-09-01','14:55:00',3.74),('15128','2013-09-01','15:00:00',3.73),('15128','2013-09-01','15:05:00',3.71),('15128','2013-09-01','15:10:00',3.7),('15128','2013-09-01','15:15:00',3.66),('15128','2013-09-01','15:20:00',3.63),('15128','2013-09-01','15:25:00',3.58),('15128','2013-09-01','15:30:00',3.59),('15128','2013-09-01','15:35:00',3.54),('15128','2013-09-01','15:40:00',3.54),('15128','2013-09-01','15:45:00',3.53),('15128','2013-09-01','15:50:00',3.47),('15128','2013-09-01','15:55:00',3.36),('15128','2013-09-01','16:00:00',3.36),('15128','2013-09-01','16:05:00',3.32),('15128','2013-09-01','16:10:00',3.22),('15128','2013-09-01','16:15:00',3.15),('15128','2013-09-01','16:20:00',3.11),('15128','2013-09-01','16:25:00',3.05),('15128','2013-09-01','16:30:00',3.01),('15128','2013-09-01','16:35:00',2.96),('15128','2013-09-01','16:40:00',2.88),('15128','2013-09-01','16:45:00',2.8),('15128','2013-09-01','16:50:00',2.73),('15128','2013-09-01','16:55:00',2.67),('15128','2013-09-01','17:00:00',2.57),('15128','2013-09-01','17:05:00',2.46),('15128','2013-09-01','17:10:00',2.35),('15128','2013-09-01','17:15:00',2.24),('15128','2013-09-01','17:20:00',2.16),('15128','2013-09-01','17:25:00',2.03),('15128','2013-09-01','17:30:00',1.88),('15128','2013-09-01','17:35:00',1.83),('15128','2013-09-01','17:40:00',1.74),('15128','2013-09-01','17:45:00',1.65),('15128','2013-09-01','17:50:00',1.56),('15128','2013-09-01','17:55:00',1.54),('15128','2013-09-01','18:00:00',1.47),('15128','2013-09-01','18:05:00',1.4),('15128','2013-09-01','18:10:00',1.3),('15128','2013-09-01','18:15:00',1.18),('15128','2013-09-01','18:20:00',1.05),('15128','2013-08-31','08:45:00',1.05),('15128','2013-08-31','08:50:00',1.11),('15128','2013-08-31','08:55:00',1.16),('15128','2013-08-31','09:00:00',1.21),('15128','2013-08-31','09:05:00',1.31),('15128','2013-08-31','09:10:00',1.38),('15128','2013-08-31','09:15:00',1.44),('15128','2013-08-31','09:20:00',1.52),('15128','2013-08-31','09:25:00',1.61),('15128','2013-08-31','09:30:00',1.66),('15128','2013-08-31','09:35:00',1.72),('15128','2013-08-31','09:40:00',1.76),('15128','2013-08-31','09:45:00',1.83),('15128','2013-08-31','09:50:00',1.89),('15128','2013-08-31','09:55:00',1.93),('15128','2013-08-31','10:00:00',1.99),('15128','2013-08-31','10:05:00',2.04),('15128','2013-08-31','10:10:00',2.08),('15128','2013-08-31','10:15:00',2.12),('15128','2013-08-31','10:20:00',2.19),('15128','2013-08-31','10:25:00',2.27),('15128','2013-08-31','10:30:00',2.37),('15128','2013-08-31','10:35:00',2.44),('15128','2013-08-31','10:40:00',2.51),('15128','2013-08-31','10:45:00',2.57),('15128','2013-08-31','10:50:00',2.58),('15128','2013-08-31','10:55:00',2.65),('15128','2013-08-31','11:00:00',2.63),('15128','2013-08-31','11:05:00',2.71),('15128','2013-08-31','11:10:00',2.85),('15128','2013-08-31','11:15:00',2.88),('15128','2013-08-31','11:20:00',2.95),('15128','2013-08-31','11:25:00',3),('15128','2013-08-31','11:30:00',3.08),('15128','2013-08-31','11:35:00',3.14),('15128','2013-08-31','11:40:00',3.19),('15128','2013-08-31','11:45:00',3.19),('15128','2013-08-31','11:50:00',3.3),('15128','2013-08-31','11:55:00',3.41),('15128','2013-08-31','12:00:00',3.54),('15128','2013-08-31','12:05:00',3.61),('15128','2013-08-31','12:10:00',3.63),('15128','2013-08-31','12:15:00',3.68),('15128','2013-08-31','12:20:00',3.71),('15128','2013-08-31','12:25:00',3.73),('15128','2013-08-31','12:30:00',3.76),('15128','2013-08-31','12:35:00',3.8),('15128','2013-08-31','12:40:00',3.81),('15128','2013-08-31','12:45:00',3.8),('15128','2013-08-31','12:50:00',3.86),('15128','2013-08-31','12:55:00',3.8),('15128','2013-08-31','13:00:00',3.93),('15128','2013-08-31','13:05:00',3.49),('15128','2013-08-31','13:10:00',3.57),('15128','2013-08-31','13:15:00',3.82),('15128','2013-08-31','13:20:00',3.72),('15128','2013-08-31','13:25:00',3.43),('15128','2013-08-31','13:30:00',3.53),('15128','2013-08-31','13:35:00',3.84),('15128','2013-08-31','13:40:00',4.1),('15128','2013-08-31','13:45:00',4.06),('15128','2013-08-31','13:50:00',4.06),('15128','2013-08-31','13:55:00',3.88),('15128','2013-08-31','14:00:00',3.87),('15128','2013-08-31','14:05:00',3.8),('15128','2013-08-31','14:10:00',3.61),('15128','2013-08-31','14:15:00',3.76),('15128','2013-08-31','14:20:00',3.59),('15128','2013-08-31','14:25:00',3.51),('15128','2013-08-31','14:30:00',3.21),('15128','2013-08-31','14:35:00',3.07),('15128','2013-08-31','14:40:00',3.44),('15128','2013-08-31','14:45:00',3.84),('15128','2013-08-31','14:50:00',3.65),('15128','2013-08-31','14:55:00',3.7),('15128','2013-08-31','15:00:00',3.71),('15128','2013-08-31','15:05:00',3.67),('15128','2013-08-31','15:10:00',3.57),('15128','2013-08-31','15:15:00',3.47),('15128','2013-08-31','15:20:00',3.45),('15128','2013-08-31','15:25:00',3.33),('15128','2013-08-31','15:30:00',3),('15128','2013-08-31','15:35:00',2.94),('15128','2013-08-31','15:40:00',2.91),('15128','2013-08-31','15:45:00',2.91),('15128','2013-08-31','15:50:00',2.76),('15128','2013-08-31','15:55:00',2.3),('15128','2013-08-31','16:00:00',2.55),('15128','2013-08-31','16:05:00',2.8),('15128','2013-08-31','16:10:00',3.18),('15128','2013-08-31','16:15:00',3.17),('15128','2013-08-31','16:20:00',2.99),('15128','2013-08-31','16:25:00',3.02),('15128','2013-08-31','16:30:00',2.78),('15128','2013-08-31','16:35:00',2.94),('15128','2013-08-31','16:40:00',2.68),('15128','2013-08-31','16:45:00',2.52),('15128','2013-08-31','16:50:00',2.43),('15128','2013-08-31','16:55:00',2.4),('15128','2013-08-31','17:00:00',2.43),('15128','2013-08-31','17:05:00',2.44),('15128','2013-08-31','17:10:00',2.37),('15128','2013-08-31','17:15:00',2.31),('15128','2013-08-31','17:20:00',2.12),('15128','2013-08-31','17:25:00',1.9),('15128','2013-08-31','17:30:00',1.94),('15128','2013-08-31','17:35:00',1.84),('15128','2013-08-31','17:40:00',1.55),('15128','2013-08-31','17:45:00',1.8),('15128','2013-08-31','17:50:00',1.76),('15128','2013-08-31','17:55:00',1.67),('15128','2013-08-31','18:00:00',1.51),('15128','2013-08-31','18:05:00',1.36),('15128','2013-08-31','18:10:00',1.42),('15128','2013-08-31','18:15:00',1.12),('15128','2013-08-31','18:20:00',1.18),('15128','2013-08-31','18:25:00',1.22),('15128','2013-08-31','18:30:00',1.01),('15128','2013-08-31','18:35:00',1.04),('15128','2013-08-31','18:40:00',1.03),('15128','2013-08-30','08:45:00',1.15),('15128','2013-08-30','08:50:00',1.3),('15128','2013-08-30','08:55:00',1.41),('15128','2013-08-30','09:00:00',1.16),('15128','2013-08-30','09:10:00',1.17),('15128','2013-08-30','09:15:00',1.56),('15128','2013-08-30','09:20:00',1.59),('15128','2013-08-30','09:25:00',1.72),('15128','2013-08-30','09:30:00',1.79),('15128','2013-08-30','09:35:00',1.8),('15128','2013-08-30','09:40:00',1.76),('15128','2013-08-30','09:45:00',1.86),('15128','2013-08-30','09:50:00',2.06),('15128','2013-08-30','09:55:00',1.98),('15128','2013-08-30','10:00:00',2.11),('15128','2013-08-30','10:05:00',2.16),('15128','2013-08-30','10:10:00',2.15),('15128','2013-08-30','10:15:00',2.15),('15128','2013-08-30','10:20:00',2.22),('15128','2013-08-30','10:25:00',2.35),('15128','2013-08-30','10:30:00',2.46),('15128','2013-08-30','10:35:00',2.49),('15128','2013-08-30','10:40:00',2.57),('15128','2013-08-30','10:45:00',2.59),('15128','2013-08-30','10:50:00',2.69),('15128','2013-08-30','10:55:00',2.78),('15128','2013-08-30','11:00:00',2.79),('15128','2013-08-30','11:05:00',2.84),('15128','2013-08-30','11:10:00',2.92),('15128','2013-08-30','11:15:00',2.99),('15128','2013-08-30','11:20:00',3.03),('15128','2013-08-30','11:25:00',3.12),('15128','2013-08-30','11:30:00',3.15),('15128','2013-08-30','11:35:00',3.12),('15128','2013-08-30','11:40:00',3.24),('15128','2013-08-30','11:45:00',3.21),('15128','2013-08-30','11:50:00',3.34),('15128','2013-08-30','11:55:00',3.47),('15128','2013-08-30','12:00:00',3.63),('15128','2013-08-30','12:05:00',3.68),('15128','2013-08-30','12:10:00',3.7),('15128','2013-08-30','12:15:00',3.75),('15128','2013-08-30','12:20:00',3.76),('15128','2013-08-30','12:25:00',3.76),('15128','2013-08-30','12:30:00',3.79),('15128','2013-08-30','12:35:00',3.85),('15128','2013-08-30','12:40:00',3.87),('15128','2013-08-30','12:45:00',3.86),('15128','2013-08-30','12:50:00',3.93),('15128','2013-08-30','12:55:00',3.94),('15128','2013-08-30','13:00:00',3.95),('15128','2013-08-30','13:05:00',3.95),('15128','2013-08-30','13:10:00',3.97),('15128','2013-08-30','13:15:00',3.98),('15128','2013-08-30','13:20:00',3.96),('15128','2013-08-30','13:25:00',3.94),('15128','2013-08-30','13:30:00',3.91),('15128','2013-08-30','13:35:00',3.96),('15128','2013-08-30','13:40:00',3.99),('15128','2013-08-30','13:45:00',3.97),('15128','2013-08-30','13:50:00',3.94),('15128','2013-08-30','13:55:00',3.91),('15128','2013-08-30','14:00:00',3.92),('15128','2013-08-30','14:05:00',3.91),('15128','2013-08-30','14:10:00',3.92),('15128','2013-08-30','14:15:00',3.88),('15128','2013-08-30','14:20:00',3.91),('15128','2013-08-30','14:25:00',3.89),('15128','2013-08-30','14:30:00',3.8),('15128','2013-08-30','14:35:00',3.82),('15128','2013-08-30','14:40:00',3.78),('15128','2013-08-30','14:45:00',3.7),('15128','2013-08-30','14:50:00',3.67),('15128','2013-08-30','14:55:00',3.67),('15128','2013-08-30','15:00:00',3.71),('15128','2013-08-30','15:05:00',3.64),('15128','2013-08-30','15:10:00',3.61),('15128','2013-08-30','15:15:00',3.58),('15128','2013-08-30','15:20:00',3.55),('15128','2013-08-30','15:25:00',3.54),('15128','2013-08-30','15:30:00',3.5),('15128','2013-08-30','15:35:00',3.49),('15128','2013-08-30','15:40:00',3.39),('15128','2013-08-30','15:45:00',3.35),('15128','2013-08-30','15:50:00',3.34),('15128','2013-08-30','15:55:00',3.35),('15128','2013-08-30','16:00:00',3.34),('15128','2013-08-30','16:05:00',3.25),('15128','2013-08-30','16:10:00',3.18),('15128','2013-08-30','16:15:00',3.08),('15128','2013-08-30','16:20:00',3.01),('15128','2013-08-30','16:25:00',2.94),('15128','2013-08-30','16:30:00',2.99),('15128','2013-08-30','16:35:00',2.86),('15128','2013-08-30','16:40:00',2.72),('15128','2013-08-30','16:45:00',2.68),('15128','2013-08-30','16:50:00',2.73),('15128','2013-08-30','16:55:00',2.72),('15128','2013-08-30','17:00:00',2.64),('15128','2013-08-30','17:05:00',2.57),('15128','2013-08-30','17:10:00',2.46),('15128','2013-08-30','17:15:00',2.34),('15128','2013-08-30','17:20:00',2.17),('15128','2013-08-30','17:25:00',1.99),('15128','2013-08-30','17:30:00',1.95),('15128','2013-08-30','17:35:00',1.88),('15128','2013-08-30','17:40:00',1.77),('15128','2013-08-30','17:45:00',1.7),('15128','2013-08-30','17:50:00',1.32),('15128','2013-08-30','17:55:00',1.15),('15128','2013-08-30','18:00:00',1.01),('15128','2013-08-30','18:05:00',1.17),('15128','2013-08-30','18:10:00',1.09),('15128','2013-08-29','08:50:00',1.02),('15128','2013-08-29','08:55:00',1.21),('15128','2013-08-29','09:00:00',1.36),('15128','2013-08-29','09:05:00',1.34),('15128','2013-08-29','09:10:00',1.19),('15128','2013-08-29','09:15:00',1.06),('15128','2013-08-29','09:20:00',1.09),('15128','2013-08-29','09:25:00',1.37),('15128','2013-08-29','09:30:00',1.45),('15128','2013-08-29','09:35:00',1.45),('15128','2013-08-29','09:40:00',1.48),('15128','2013-08-29','09:45:00',1.55),('15128','2013-08-29','09:50:00',1.72),('15128','2013-08-29','09:55:00',1.76),('15128','2013-08-29','10:00:00',1.66),('15128','2013-08-29','10:05:00',1.71),('15128','2013-08-29','10:10:00',1.87),('15128','2013-08-29','10:15:00',1.88),('15128','2013-08-29','10:20:00',1.78),('15128','2013-08-29','10:25:00',1.99),('15128','2013-08-29','10:30:00',2.01),('15128','2013-08-29','10:35:00',1.97),('15128','2013-08-29','10:40:00',1.93),('15128','2013-08-29','10:45:00',2.05),('15128','2013-08-29','10:50:00',2.01),('15128','2013-08-29','10:55:00',1.97),('15128','2013-08-29','11:00:00',2.05),('15128','2013-08-29','11:05:00',2.19),('15128','2013-08-29','11:10:00',2.37),('15128','2013-08-29','11:15:00',2.3),('15128','2013-08-29','11:20:00',2.4),('15128','2013-08-29','11:25:00',2.42),('15128','2013-08-29','11:30:00',2.55),('15128','2013-08-29','11:35:00',2.47),('15128','2013-08-29','11:40:00',2.69),('15128','2013-08-29','11:45:00',2.79),('15128','2013-08-29','11:50:00',2.75),('15128','2013-08-29','11:55:00',2.7),('15128','2013-08-29','12:00:00',2.34),('15128','2013-08-29','12:05:00',2.57),('15128','2013-08-29','12:10:00',2.57),('15128','2013-08-29','12:15:00',2.43),('15128','2013-08-29','12:20:00',2.83),('15128','2013-08-29','12:25:00',3.1),('15128','2013-08-29','12:30:00',3.31),('15128','2013-08-29','12:35:00',3.12),('15128','2013-08-29','12:40:00',3.25),('15128','2013-08-29','12:45:00',3.15),('15128','2013-08-29','12:50:00',3),('15128','2013-08-29','12:55:00',2.89),('15128','2013-08-29','13:00:00',2.83),('15128','2013-08-29','13:05:00',2.61),('15128','2013-08-29','13:10:00',2.73),('15128','2013-08-29','13:15:00',2.93),('15128','2013-08-29','13:20:00',3.16),('15128','2013-08-29','13:25:00',4.2),('15128','2013-08-29','13:30:00',4.09),('15128','2013-08-29','13:35:00',3.78),('15128','2013-08-29','13:40:00',4.08),('15128','2013-08-29','13:45:00',3.98),('15128','2013-08-29','13:50:00',3.83),('15128','2013-08-29','13:55:00',3.91),('15128','2013-08-29','14:00:00',3.99),('15128','2013-08-29','14:05:00',4.05),('15128','2013-08-29','14:10:00',4.05),('15128','2013-08-29','14:15:00',3.79),('15128','2013-08-29','14:20:00',3.76),('15128','2013-08-29','14:25:00',3.71),('15128','2013-08-29','14:30:00',3.98),('15128','2013-08-29','14:35:00',3.84),('15128','2013-08-29','14:40:00',3.58),('15128','2013-08-29','14:45:00',3.33),('15128','2013-08-29','14:50:00',2.83),('15128','2013-08-29','14:55:00',3.47),('15128','2013-08-29','15:00:00',2.9),('15128','2013-08-29','15:05:00',3),('15128','2013-08-29','15:10:00',2.94),('15128','2013-08-29','15:15:00',3.06),('15128','2013-08-29','15:20:00',3.01),('15128','2013-08-29','15:25:00',2.86),('15128','2013-08-29','15:30:00',2.72),('15128','2013-08-29','15:35:00',2.71),('15128','2013-08-29','15:40:00',3.06),('15128','2013-08-29','15:45:00',2.8),('15128','2013-08-29','15:50:00',2.5),('15128','2013-08-29','15:55:00',2.32),('15128','2013-08-29','16:00:00',2.11),('15128','2013-08-29','16:05:00',2.12),('15128','2013-08-29','16:10:00',2.5),('15128','2013-08-29','16:15:00',2.45),('15128','2013-08-29','16:20:00',2.36),('15128','2013-08-29','16:25:00',2.19),('15128','2013-08-29','16:30:00',2.32),('15128','2013-08-29','16:35:00',2.47),('15128','2013-08-29','16:40:00',2.49),('15128','2013-08-29','16:45:00',2.59),('15128','2013-08-29','16:50:00',2.56),('15128','2013-08-29','16:55:00',2.11),('15128','2013-08-29','17:00:00',1.84),('15128','2013-08-29','17:05:00',1.22),('15128','2013-08-29','17:10:00',1.23),('15128','2013-08-29','17:15:00',1.99),('15128','2013-08-29','17:20:00',2.05),('15128','2013-08-29','17:25:00',1.71),('15128','2013-08-29','17:30:00',1.6),('15128','2013-08-29','17:35:00',1.47),('15128','2013-08-29','17:40:00',1.71),('15128','2013-08-29','17:45:00',1.84),('15128','2013-08-29','17:50:00',1.82),('15128','2013-08-29','17:55:00',1.55),('15128','2013-08-29','18:00:00',1.3),('15128','2014-04-10','08:40:00',1.02),('15128','2014-04-10','08:45:00',1.08),('15128','2013-08-28','08:40:00',1),('15128','2013-08-28','08:45:00',1.04),('15128','2013-08-28','08:50:00',1.13),('15128','2013-08-28','08:55:00',1.3),('15128','2013-08-28','09:00:00',1.28),('15128','2013-08-28','09:05:00',1.24),('15128','2013-08-28','09:10:00',1.29),('15128','2013-08-28','09:15:00',1.3),('15128','2013-08-28','09:20:00',1.4),('15128','2013-08-28','09:25:00',1.51),('15128','2013-08-28','09:30:00',1.54),('15128','2013-08-28','09:35:00',1.69),('15128','2013-08-28','09:40:00',1.57),('15128','2013-08-28','09:45:00',1.4),('15128','2013-08-28','09:50:00',1.41),('15128','2013-08-28','09:55:00',1.43),('15128','2013-08-28','10:00:00',1.47),('15128','2013-08-28','10:05:00',1.46),('15128','2013-08-28','10:10:00',1.43),('15128','2013-08-28','10:15:00',1.45),('15128','2013-08-28','10:20:00',1.5),('15128','2013-08-28','10:25:00',1.53),('15128','2013-08-28','10:30:00',1.52),('15128','2013-08-28','10:35:00',1.38),('15128','2013-08-28','10:40:00',1.29),('15128','2013-08-28','10:45:00',1.3),('15128','2013-08-28','10:50:00',1.44),('15128','2013-08-28','10:55:00',1.65),('15128','2013-08-28','11:00:00',1.64),('15128','2013-08-28','11:05:00',1.9),('15128','2013-08-28','11:10:00',2.09),('15128','2013-08-28','11:15:00',1.93),('15128','2013-08-28','11:20:00',1.6),('15128','2013-08-28','11:25:00',1.38),('15128','2013-08-28','11:30:00',1.36),('15128','2013-08-28','11:35:00',1.56),('15128','2013-08-28','11:40:00',1.77),('15128','2013-08-28','11:45:00',1.87),('15128','2013-08-28','11:50:00',1.93),('15128','2013-08-28','11:55:00',1.93),('15128','2013-08-28','12:00:00',2),('15128','2013-08-28','12:05:00',2.48),('15128','2013-08-28','12:10:00',3.48),('15128','2013-08-28','12:15:00',2.9),('15128','2013-08-28','12:20:00',3.05),('15128','2013-08-28','12:25:00',2.72),('15128','2013-08-28','12:30:00',2.42),('15128','2013-08-28','12:35:00',3.79),('15128','2013-08-28','12:40:00',4.52),('15128','2013-08-28','12:45:00',4.68),('15128','2013-08-28','12:50:00',2.96),('15128','2013-08-28','12:55:00',2.84),('15128','2013-08-28','13:00:00',2.95),('15128','2013-08-28','13:05:00',2.32),('15128','2013-08-28','13:10:00',2.23),('15128','2013-08-28','13:15:00',2.34),('15128','2013-08-28','13:20:00',2.21),('15128','2013-08-28','13:25:00',1.9),('15128','2013-08-28','13:30:00',1.82),('15128','2013-08-28','13:35:00',2.02),('15128','2013-08-28','13:40:00',1.82),('15128','2013-08-28','13:45:00',1.8),('15128','2013-08-28','13:50:00',2.39),('15128','2013-08-28','13:55:00',2.71),('15128','2013-08-28','14:00:00',2.1),('15128','2013-08-28','14:05:00',1.58),('15128','2013-08-28','14:10:00',1.4),('15128','2013-08-28','14:15:00',1.2),('15128','2013-08-28','14:20:00',1.15),('15128','2013-08-28','14:25:00',1.15),('15128','2013-08-28','14:30:00',1.18),('15128','2013-08-28','14:35:00',1.31),('15128','2013-08-28','14:40:00',1.45),('15128','2013-08-28','14:45:00',1.52),('15128','2013-08-28','14:50:00',1.62),('15128','2013-08-28','14:55:00',2.58),('15128','2013-08-28','15:00:00',2.65),('15128','2013-08-28','15:05:00',2.23),('15128','2013-08-28','15:10:00',1.42),('15128','2013-08-28','15:15:00',1.61),('15128','2013-08-28','15:20:00',2.16),('15128','2013-08-28','15:25:00',2.7),('15128','2013-08-28','15:30:00',2.52),('15128','2013-08-28','15:35:00',2.3),('15128','2013-08-28','15:40:00',2.14),('15128','2013-08-28','15:45:00',2.19),('15128','2013-08-28','15:50:00',2.5),('15128','2013-08-28','15:55:00',3.11),('15128','2013-08-28','16:00:00',4.3),('15128','2013-08-28','16:05:00',3.82),('15128','2013-08-28','16:10:00',3.48),('15128','2013-08-28','16:15:00',3.34),('15128','2013-08-28','16:20:00',3.11),('15128','2013-08-28','16:25:00',3.1),('15128','2013-08-28','16:30:00',3.21),('15128','2013-08-28','16:35:00',3.14),('15128','2013-08-28','16:40:00',3.07),('15128','2013-08-28','16:45:00',3),('15128','2013-08-28','16:50:00',2.94),('15128','2013-08-28','16:55:00',2.86),('15128','2013-08-28','17:00:00',2.8),('15128','2013-08-28','17:05:00',2.71),('15128','2013-08-28','17:10:00',2.59),('15128','2013-08-28','17:15:00',2.48),('15128','2013-08-28','17:20:00',2.31),('15128','2013-08-28','17:25:00',2.24),('15128','2013-08-28','17:30:00',2.11),('15128','2013-08-28','17:35:00',1.97),('15128','2013-08-28','17:40:00',1.94),('15128','2013-08-28','17:45:00',1.85),('15128','2013-08-28','17:50:00',1.8),('15128','2013-08-28','17:55:00',1.7),('15128','2013-08-28','18:00:00',1.67),('15128','2013-08-28','18:05:00',1.6),('15128','2013-08-28','18:10:00',1.52),('15128','2013-08-28','18:15:00',1.43),('15128','2013-08-28','18:20:00',1.32),('15128','2013-08-28','18:25:00',1.19),('15128','2013-08-28','18:30:00',1.1),('15128','2013-08-28','18:35:00',1.01),('15128','2013-08-27','08:50:00',1.18),('15128','2013-08-27','08:55:00',1.23),('15128','2013-08-27','09:00:00',1.3),('15128','2013-08-27','09:05:00',1.38),('15128','2013-08-27','09:10:00',1.23),('15128','2013-08-27','09:20:00',1.17),('15128','2013-08-27','09:30:00',1.46),('15128','2013-08-27','09:35:00',2.23),('15128','2013-08-27','09:40:00',1.92),('15128','2013-08-27','09:45:00',2.08),('15128','2013-08-27','09:50:00',1.98),('15128','2013-08-27','09:55:00',1.95),('15128','2013-08-27','10:00:00',2.03),('15128','2013-08-27','10:05:00',2.09),('15128','2013-08-27','10:10:00',2.17),('15128','2013-08-27','10:15:00',2.26),('15128','2013-08-27','10:20:00',2.33),('15128','2013-08-27','10:25:00',2.36),('15128','2013-08-27','10:30:00',2.49),('15128','2013-08-27','10:35:00',2.43),('15128','2013-08-27','10:40:00',2.22),('15128','2013-08-27','10:45:00',2.37),('15128','2013-08-27','10:50:00',2.98),('15128','2013-08-27','10:55:00',2.9),('15128','2013-08-27','11:00:00',2.96),('15128','2013-08-27','11:05:00',3.05),('15128','2013-08-27','11:10:00',2.95),('15128','2013-08-27','11:15:00',2.83),('15128','2013-08-27','11:20:00',2.58),('15128','2013-08-27','11:25:00',2.81),('15128','2013-08-27','11:30:00',1.16),('15128','2013-08-27','11:35:00',1.28),('15128','2013-08-27','11:40:00',2.3),('15128','2013-08-27','11:45:00',2.32),('15128','2013-08-27','11:50:00',2.3),('15128','2013-08-27','11:55:00',4.34),('15128','2013-08-27','12:00:00',4.19),('15128','2013-08-27','12:05:00',3.6),('15128','2013-08-27','12:10:00',4.04),('15128','2013-08-27','12:15:00',4.07),('15128','2013-08-27','12:20:00',3.43),('15128','2013-08-27','12:25:00',3.33),('15128','2013-08-27','12:30:00',3.92),('15128','2013-08-27','12:35:00',4.23),('15128','2013-08-27','12:40:00',3.68),('15128','2013-08-27','12:45:00',4.14),('15128','2013-08-27','12:50:00',3.57),('15128','2013-08-27','12:55:00',4.03),('15128','2013-08-27','13:00:00',4.24),('15128','2013-08-27','13:05:00',4.22),('15128','2013-08-27','13:10:00',4.19),('15128','2013-08-27','13:15:00',4.2),('15128','2013-08-27','13:20:00',4.08),('15128','2013-08-27','13:25:00',4.21),('15128','2013-08-27','13:30:00',4.28),('15128','2013-08-27','13:35:00',4.32),('15128','2013-08-27','13:40:00',4.4),('15128','2013-08-27','13:45:00',4.33),('15128','2013-08-27','13:50:00',4.45),('15128','2013-08-27','13:55:00',4.28),('15128','2013-08-27','14:00:00',4.32),('15128','2013-08-27','14:05:00',4.24),('15128','2013-08-27','14:10:00',4.26),('15128','2013-08-27','14:15:00',4.25),('15128','2013-08-27','14:20:00',4.27),('15128','2013-08-27','14:25:00',4.28),('15128','2013-08-27','14:30:00',4.26),('15128','2013-08-27','14:35:00',4.23),('15128','2013-08-27','14:40:00',4.19),('15128','2013-08-27','14:45:00',4),('15128','2013-08-27','14:50:00',4.19),('15128','2013-08-27','14:55:00',4.06),('15128','2013-08-27','15:00:00',4.23),('15128','2013-08-27','15:05:00',4.08),('15128','2013-08-27','15:10:00',4.02),('15128','2013-08-27','15:15:00',3.93),('15128','2013-08-27','15:20:00',3.7),('15128','2013-08-27','15:25:00',3.4),('15128','2013-08-27','15:30:00',2.72),('15128','2013-08-27','15:35:00',3.08),('15128','2013-08-27','15:40:00',4.04),('15128','2013-08-27','15:45:00',3.56),('15128','2013-08-27','15:50:00',3.83),('15128','2013-08-27','15:55:00',3.74),('15128','2013-08-27','16:00:00',3.69),('15128','2013-08-27','16:05:00',3.62),('15128','2013-08-27','16:10:00',3.57),('15128','2013-08-27','16:15:00',3.53),('15128','2013-08-27','16:20:00',3.49),('15128','2013-08-27','16:25:00',3.42),('15128','2013-08-27','16:30:00',3.35),('15128','2013-08-27','16:35:00',3.27),('15128','2013-08-27','16:40:00',3.18),('15128','2013-08-27','16:45:00',3.1),('15128','2013-08-27','16:50:00',3.09),('15128','2013-08-27','16:55:00',2.98),('15128','2013-08-27','17:00:00',2.91),('15128','2013-08-27','17:05:00',1.44),('15128','2013-08-27','17:10:00',1.6),('15128','2013-08-27','17:15:00',2.82),('15128','2013-08-27','17:20:00',2.5),('15128','2013-08-27','17:25:00',2.2),('15128','2013-08-27','17:35:00',1.62),('15128','2013-08-27','17:40:00',1.47),('15128','2013-08-27','17:50:00',1.51),('15128','2013-08-27','17:55:00',1.8),('15128','2013-08-27','18:00:00',1.35),('15128','2013-08-27','18:05:00',1.2),('15128','2013-08-27','18:10:00',1.3),('15128','2013-08-27','18:15:00',1.19),('15128','2013-08-27','18:20:00',1.31),('15128','2013-08-27','18:35:00',1.11),('15128','2013-08-27','18:40:00',1.22),('15128','2013-08-26','09:10:00',1.32),('15128','2013-08-26','09:15:00',1.28),('15128','2013-08-26','09:20:00',1.4),('15128','2013-08-26','09:25:00',1.61),('15128','2013-08-26','09:30:00',1.74),('15128','2013-08-26','09:35:00',1.4),('15128','2013-08-26','09:40:00',1.04),('15128','2013-08-26','09:45:00',1.16),('15128','2013-08-26','09:50:00',1.44),('15128','2013-08-26','09:55:00',1.25),('15128','2013-08-26','10:00:00',1.57),('15128','2013-08-26','10:05:00',1.97),('15128','2013-08-26','10:10:00',2.22),('15128','2013-08-26','10:15:00',2.26),('15128','2013-08-26','10:20:00',2.24),('15128','2013-08-26','10:25:00',2.31),('15128','2013-08-26','10:30:00',2.31),('15128','2013-08-26','10:35:00',2.4),('15128','2013-08-26','10:40:00',2.38),('15128','2013-08-26','10:45:00',2.59),('15128','2013-08-26','10:50:00',2.68),('15128','2013-08-26','10:55:00',2.64),('15128','2013-08-26','11:00:00',2.69),('15128','2013-08-26','11:05:00',2.82),('15128','2013-08-26','11:10:00',2.74),('15128','2013-08-26','11:15:00',2.91),('15128','2013-08-26','11:20:00',3.04),('15128','2013-08-26','11:25:00',2.51),('15128','2013-08-26','11:30:00',3.12),('15128','2013-08-26','11:35:00',3.14),('15128','2013-08-26','11:40:00',3.28),('15128','2013-08-26','11:55:00',3.45),('15128','2013-08-26','12:00:00',1.69),('15128','2013-08-26','12:05:00',2.51),('15128','2013-08-26','12:10:00',2.62),('15128','2013-08-26','12:15:00',2.9),('15128','2013-08-26','12:20:00',3.91),('15128','2013-08-26','12:25:00',4.09),('15128','2013-08-26','12:30:00',3.59),('15128','2013-08-26','12:35:00',1.98),('15128','2013-08-26','12:40:00',3.72),('15128','2013-08-26','12:45:00',3.16),('15128','2013-08-26','12:50:00',3.04),('15128','2013-08-26','12:55:00',1.56),('15128','2013-08-26','13:00:00',1.67),('15128','2013-08-26','13:05:00',1.96),('15128','2013-08-26','13:10:00',2.52),('15128','2013-08-26','13:15:00',1.99),('15128','2013-08-26','13:20:00',2.83),('15128','2013-08-26','13:25:00',2.93),('15128','2013-08-26','13:30:00',2.23),('15128','2013-08-26','13:35:00',2.26),('15128','2013-08-26','13:40:00',2.23),('15128','2013-08-26','13:45:00',3.14),('15128','2013-08-26','13:50:00',3.14),('15128','2013-08-26','13:55:00',2.78),('15128','2013-08-26','14:00:00',2.29),('15128','2013-08-26','14:05:00',3.16),('15128','2013-08-26','14:10:00',3.92),('15128','2013-08-26','14:15:00',3.32),('15128','2013-08-26','14:20:00',2.55),('15128','2013-08-26','14:25:00',1.66),('15128','2013-08-26','14:30:00',1.52),('15128','2013-08-26','14:35:00',1.51),('15128','2013-08-26','14:40:00',1.45),('15128','2013-08-26','14:45:00',1.22),('15128','2013-08-26','14:50:00',1.03),('15128','2013-08-26','15:00:00',1.03),('15128','2013-08-26','15:05:00',1.06),('15128','2013-08-26','15:50:00',1.71),('15128','2013-08-26','15:55:00',2.23),('15128','2013-08-26','16:00:00',1.07),('15128','2013-08-26','16:05:00',2.04),('15128','2013-08-26','16:10:00',2.25),('15128','2013-08-26','16:15:00',1.33),('15128','2013-08-26','16:30:00',1.27),('15128','2013-08-26','16:40:00',1.61),('15128','2013-08-26','16:45:00',1.5),('15128','2013-08-26','16:50:00',1.89),('15128','2013-08-26','16:55:00',2.44),('15128','2013-08-26','17:00:00',2.04),('15128','2013-08-26','17:05:00',1.97),('15128','2013-08-26','17:35:00',1.29),('15128','2013-08-25','08:40:00',1.04),('15128','2013-08-25','08:45:00',1.04),('15128','2013-08-25','08:50:00',1.1),('15128','2013-08-25','08:55:00',1.21),('15128','2013-08-25','09:00:00',1.3),('15128','2013-08-25','09:05:00',1.36),('15128','2013-08-25','09:10:00',1.42),('15128','2013-08-25','09:15:00',1.48),('15128','2013-08-25','09:20:00',1.52),('15128','2013-08-25','09:25:00',1.58),('15128','2013-08-25','09:30:00',1.66),('15128','2013-08-25','09:35:00',1.73),('15128','2013-08-25','09:40:00',1.81),('15128','2013-08-25','09:45:00',1.88),('15128','2013-08-25','09:50:00',1.9),('15128','2013-08-25','09:55:00',1.98),('15128','2013-08-25','10:00:00',2.04),('15128','2013-08-25','10:05:00',2.11),('15128','2013-08-25','10:10:00',2.18),('15128','2013-08-25','10:15:00',2.23),('15128','2013-08-25','10:20:00',2.3),('15128','2013-08-25','10:25:00',2.22),('15128','2013-08-25','10:30:00',2.45),('15128','2013-08-25','10:35:00',2.49),('15128','2013-08-25','10:40:00',2.55),('15128','2013-08-25','10:45:00',2.61),('15128','2013-08-25','10:50:00',2.65),('15128','2013-08-25','10:55:00',2.68),('15128','2013-08-25','11:00:00',2.76),('15128','2013-08-25','11:05:00',2.76),('15128','2013-08-25','11:10:00',2.82),('15128','2013-08-25','11:15:00',2.87),('15128','2013-08-25','11:20:00',2.99),('15128','2013-08-25','11:25:00',2.97),('15128','2013-08-25','11:30:00',3.1),('15128','2013-08-25','11:35:00',3.08),('15128','2013-08-25','11:40:00',3.19),('15128','2013-08-25','11:45:00',3.24),('15128','2013-08-25','11:50:00',3.3),('15128','2013-08-25','11:55:00',3.5),('15128','2013-08-25','12:00:00',3.59),('15128','2013-08-25','12:05:00',3.62),('15128','2013-08-25','12:10:00',3.64),('15128','2013-08-25','12:15:00',3.65),('15128','2013-08-25','12:20:00',3.68),('15128','2013-08-25','12:25:00',3.74),('15128','2013-08-25','12:30:00',3.84),('15128','2013-08-25','12:35:00',3.65),('15128','2013-08-25','12:40:00',3.28),('15128','2013-08-25','12:45:00',3.56),('15128','2013-08-25','12:50:00',3.84),('15128','2013-08-25','12:55:00',4.44),('15128','2013-08-25','13:00:00',2.89),('15128','2013-08-25','13:05:00',2.69),('15128','2013-08-25','13:10:00',3.51),('15128','2013-08-25','13:15:00',2.39),('15128','2013-08-25','13:20:00',3.86),('15128','2013-08-25','13:25:00',2.6),('15128','2013-08-25','13:30:00',2.71),('15128','2013-08-25','13:35:00',3.57),('15128','2013-08-25','13:40:00',4.12),('15128','2013-08-25','13:45:00',4.11),('15128','2013-08-25','13:50:00',3.4),('15128','2013-08-25','13:55:00',3.15),('15128','2013-08-25','14:00:00',3.55),('15128','2013-08-25','14:05:00',3.61),('15128','2013-08-25','14:10:00',3.67),('15128','2013-08-25','14:15:00',3.87),('15128','2013-08-25','14:20:00',3.88),('15128','2013-08-25','14:25:00',3.93),('15128','2013-08-25','14:30:00',3.98),('15128','2013-08-25','14:35:00',3.98),('15128','2013-08-25','14:40:00',3.96),('15128','2013-08-25','14:45:00',3.1),('15128','2013-08-25','14:50:00',3.21),('15128','2013-08-25','14:55:00',2.12),('15128','2013-08-25','15:00:00',2.15),('15128','2013-08-25','15:05:00',1.25),('15128','2013-08-25','15:10:00',1.13),('15128','2013-08-25','15:30:00',1.07),('15128','2013-08-25','15:35:00',1.26),('15128','2013-08-25','15:40:00',2.31),('15128','2013-08-25','15:45:00',1.48),('15128','2013-08-25','15:50:00',1.5),('15128','2013-08-25','15:55:00',2.1),('15128','2013-08-25','16:00:00',2.92),('15128','2013-08-25','16:05:00',3.8),('15128','2013-08-25','16:10:00',3.41),('15128','2013-08-25','16:15:00',3.25),('15128','2013-08-25','16:20:00',3.19),('15128','2013-08-25','16:25:00',3.1),('15128','2013-08-25','16:30:00',3.05),('15128','2013-08-25','16:35:00',3.01),('15128','2013-08-25','16:40:00',2.9),('15128','2013-08-25','16:45:00',2.79),('15128','2013-08-25','16:50:00',2.76),('15128','2013-08-25','16:55:00',2.68),('15128','2013-08-25','17:00:00',2.43),('15128','2013-08-25','17:05:00',2.49),('15128','2013-08-25','17:10:00',2.44),('15128','2013-08-25','17:15:00',2.33),('15128','2013-08-25','17:20:00',1.68),('15128','2013-08-25','17:25:00',1.51),('15128','2013-08-25','17:30:00',1.47),('15128','2013-08-25','17:35:00',1.09),('15128','2013-08-25','17:40:00',1.09),('15128','2013-08-25','17:45:00',1.9),('15128','2013-08-25','17:50:00',1.89),('15128','2013-08-25','17:55:00',1.67),('15128','2013-08-25','18:00:00',1.48),('15128','2013-08-25','18:05:00',1.39),('15128','2013-08-25','18:10:00',1.3),('15128','2013-08-25','18:15:00',1.2),('15128','2013-08-25','18:20:00',1.12),('15128','2013-08-25','18:25:00',1.02),('15128','2013-08-24','08:35:00',1.07),('15128','2013-08-24','08:40:00',1.31),('15128','2013-08-24','09:05:00',1.43),('15128','2013-08-24','09:10:00',1.44),('15128','2013-08-24','09:15:00',1.61),('15128','2013-08-24','09:20:00',1.76),('15128','2013-08-24','09:25:00',1.75),('15128','2013-08-24','09:30:00',1.65),('15128','2013-08-24','09:35:00',2.17),('15128','2013-08-24','09:40:00',2.45),('15128','2013-08-24','09:45:00',2.49),('15128','2013-08-24','09:50:00',2.65),('15128','2013-08-24','09:55:00',1.88),('15128','2013-08-24','10:00:00',1.2),('15128','2013-08-23','08:45:00',1.03),('15128','2013-08-23','08:50:00',1.09),('15128','2013-08-23','08:55:00',1.15),('15128','2013-08-23','09:00:00',1.24),('15128','2013-08-23','09:05:00',1.3),('15128','2013-08-23','09:10:00',1.36),('15128','2013-08-23','09:15:00',1.4),('15128','2013-08-23','09:20:00',1.44),('15128','2013-08-23','09:25:00',1.5),('15128','2013-08-23','09:30:00',1.6),('15128','2013-08-23','09:35:00',1.67),('15128','2013-08-23','09:40:00',1.76),('15128','2013-08-23','09:45:00',1.81),('15128','2013-08-23','09:50:00',1.85),('15128','2013-08-23','09:55:00',1.91),('15128','2013-08-23','10:00:00',1.94),('15128','2013-08-23','10:05:00',2.03),('15128','2013-08-23','10:10:00',2.1),('15128','2013-08-23','10:15:00',2.1),('15128','2013-08-23','10:20:00',2.13),('15128','2013-08-23','10:25:00',2.18),('15128','2013-08-23','10:30:00',2.36),('15128','2013-08-23','10:35:00',2.37),('15128','2013-08-23','10:40:00',2.44),('15128','2013-08-23','10:45:00',2.48),('15128','2013-08-23','10:50:00',2.5),('15128','2013-08-23','10:55:00',2.36),('15128','2013-08-23','11:00:00',2.67),('15128','2013-08-23','11:05:00',2.65),('15128','2013-08-23','11:10:00',2.6),('15128','2013-08-23','11:15:00',2.64),('15128','2013-08-23','11:20:00',2.57),('15128','2013-08-23','11:25:00',2.66),('15128','2013-08-23','11:30:00',3.07),('15128','2013-08-23','11:35:00',3.12),('15128','2013-08-23','11:40:00',3.27),('15128','2013-08-23','11:45:00',3.31),('15128','2013-08-23','11:50:00',3.39),('15128','2013-08-23','11:55:00',3.42),('15128','2013-08-23','12:00:00',3.53),('15128','2013-08-23','12:05:00',3.6),('15128','2013-08-23','12:10:00',3.62),('15128','2013-08-23','12:15:00',3.66),('15128','2013-08-23','12:20:00',3.66),('15128','2013-08-23','12:25:00',3.73),('15128','2013-08-23','12:30:00',3.73),('15128','2013-08-23','12:35:00',3.76),('15128','2013-08-23','12:40:00',3.82),('15128','2013-08-23','12:45:00',3.84),('15128','2013-08-23','12:50:00',3.87),('15128','2013-08-23','12:55:00',3.86),('15128','2013-08-23','13:00:00',3.87),('15128','2013-08-23','13:05:00',3.88),('15128','2013-08-23','13:10:00',3.93),('15128','2013-08-23','13:15:00',3.94),('15128','2013-08-23','13:20:00',3.93),('15128','2013-08-23','13:25:00',3.92),('15128','2013-08-23','13:30:00',3.93),('15128','2013-08-23','13:35:00',3.95),('15128','2013-08-23','13:40:00',3.97),('15128','2013-08-23','13:45:00',3.98),('15128','2013-08-23','13:50:00',3.99),('15128','2013-08-23','13:55:00',3.97),('15128','2013-08-23','14:00:00',3.96),('15128','2013-08-23','14:05:00',3.96),('15128','2013-08-23','14:10:00',3.98),('15128','2013-08-23','14:15:00',3.96),('15128','2013-08-23','14:20:00',3.94),('15128','2013-08-23','14:25:00',3.94),('15128','2013-08-23','14:30:00',3.93),('15128','2013-08-23','14:35:00',3.9),('15128','2013-08-23','14:40:00',3.9),('15128','2013-08-23','14:45:00',3.88),('15128','2013-08-23','14:50:00',3.85),('15128','2013-08-23','14:55:00',3.84),('15128','2013-08-23','15:00:00',3.81),('15128','2013-08-23','15:05:00',3.8),('15128','2013-08-23','15:10:00',3.78),('15128','2013-08-23','15:15:00',3.76),('15128','2013-08-23','15:20:00',3.71),('15128','2013-08-23','15:25:00',3.65),('15128','2013-08-23','15:30:00',3.63),('15128','2013-08-23','15:35:00',3.57),('15128','2013-08-23','15:40:00',3.55),('15128','2013-08-23','15:45:00',3.5),('15128','2013-08-23','15:50:00',3.47),('15128','2013-08-23','15:55:00',3.44),('15128','2013-08-23','16:00:00',3.39),('15128','2013-08-23','16:05:00',3.35),('15128','2013-08-23','16:10:00',3.28),('15128','2013-08-23','16:15:00',3.27),('15128','2013-08-23','16:20:00',3.22),('15128','2013-08-23','16:25:00',3.14),('15128','2013-08-23','16:30:00',3.09),('15128','2013-08-23','16:35:00',3.03),('15128','2013-08-23','16:40:00',2.99),('15128','2013-08-23','16:45:00',2.93),('15128','2013-08-23','16:50:00',2.87),('15128','2013-08-23','16:55:00',2.8),('15128','2013-08-23','17:00:00',2.74),('15128','2013-08-23','17:05:00',2.66),('15128','2013-08-23','17:10:00',2.59),('15128','2013-08-23','17:15:00',2.52),('15128','2013-08-23','17:20:00',2.43),('15128','2013-08-23','17:25:00',2.33),('15128','2013-08-23','17:30:00',2.21),('15128','2013-08-23','17:35:00',2.12),('15128','2013-08-23','17:40:00',2.02),('15128','2013-08-23','17:45:00',1.91),('15128','2013-08-23','17:50:00',1.78),('15128','2013-08-23','17:55:00',1.71),('15128','2013-08-23','18:00:00',1.65),('15128','2013-08-23','18:05:00',1.59),('15128','2013-08-23','18:10:00',1.54),('15128','2013-08-23','18:15:00',1.46),('15128','2013-08-23','18:20:00',1.38),('15128','2013-08-23','18:25:00',1.29),('15128','2013-08-23','18:30:00',1.17),('15128','2013-08-23','18:35:00',1.07),('15128','2013-08-22','08:45:00',1.07),('15128','2013-08-22','08:50:00',1.17),('15128','2013-08-22','08:55:00',1.17),('15128','2013-08-22','09:00:00',1.2),('15128','2013-08-22','09:05:00',1.26),('15128','2013-08-22','09:10:00',1.33),('15128','2013-08-22','09:15:00',1.4),('15128','2013-08-22','09:20:00',1.46),('15128','2013-08-22','09:25:00',1.48),('15128','2013-08-22','09:30:00',1.57),('15128','2013-08-22','09:35:00',1.63),('15128','2013-08-22','09:40:00',1.67),('15128','2013-08-22','09:45:00',1.75),('15128','2013-08-22','09:50:00',1.81),('15128','2013-08-22','09:55:00',1.85),('15128','2013-08-22','10:00:00',1.89),('15128','2013-08-22','10:05:00',1.96),('15128','2013-08-22','10:10:00',2.02),('15128','2013-08-22','10:15:00',2.09),('15128','2013-08-22','10:20:00',2.13),('15128','2013-08-22','10:25:00',2.2),('15128','2013-08-22','10:30:00',2.27),('15128','2013-08-22','10:35:00',2.3),('15128','2013-08-22','10:50:00',2.33),('15128','2013-08-22','10:55:00',2.47),('15128','2013-08-22','11:00:00',2.65),('15128','2013-08-22','11:05:00',2.52),('15128','2013-08-22','11:10:00',2.3),('15128','2013-08-22','11:15:00',2.31),('15128','2013-08-22','11:20:00',1.21),('15128','2013-08-22','11:25:00',1.14),('15128','2013-08-22','11:30:00',2.04),('15128','2013-08-22','11:35:00',3.2),('15128','2013-08-22','11:40:00',3.1),('15128','2013-08-22','11:45:00',3.49),('15128','2013-08-22','11:50:00',2.43),('15128','2013-08-22','11:55:00',3.44),('15128','2013-08-22','12:00:00',1.55),('15128','2013-08-22','12:05:00',1.53),('15128','2013-08-22','12:10:00',2.36),('15128','2013-08-22','12:15:00',3.44),('15128','2013-08-22','12:20:00',1.12),('15128','2013-08-22','12:25:00',1.27),('15128','2013-08-22','12:30:00',1.03),('15128','2013-08-22','12:35:00',2.78),('15128','2013-08-22','12:40:00',2.7),('15128','2013-08-22','12:45:00',3.16),('15128','2013-08-22','12:50:00',3.93),('15128','2013-08-22','12:55:00',3.9),('15128','2013-08-22','13:00:00',3.89),('15128','2013-08-22','13:05:00',3.88),('15128','2013-08-22','13:10:00',3.89),('15128','2013-08-22','13:15:00',3.9),('15128','2013-08-22','13:20:00',3.94),('15128','2013-08-22','13:25:00',3.93),('15128','2013-08-22','13:30:00',3.92),('15128','2013-08-22','13:35:00',3.94),('15128','2013-08-22','13:40:00',3.94),('15128','2013-08-22','13:45:00',3.95),('15128','2013-08-22','13:50:00',3.95),('15128','2013-08-22','13:55:00',3.94),('15128','2013-08-22','14:00:00',3.96),('15128','2013-08-22','14:05:00',3.98),('15128','2013-08-22','14:10:00',3.98),('15128','2013-08-22','14:15:00',3.98),('15128','2013-08-22','14:20:00',3.96),('15128','2013-08-22','14:25:00',3.96),('15128','2013-08-22','14:30:00',3.94),('15128','2013-08-22','14:35:00',3.92),('15128','2013-08-22','14:40:00',3.9),('15128','2013-08-22','14:45:00',3.89),('15128','2013-08-22','14:50:00',3.84),('15128','2013-08-22','14:55:00',3.7),('15128','2013-08-22','15:00:00',3.78),('15128','2013-08-22','15:05:00',3.79),('15128','2013-08-22','15:10:00',3.4),('15128','2013-08-22','15:15:00',3.07),('15128','2013-08-22','15:20:00',3.18),('15128','2013-08-22','15:25:00',3.5),('15128','2013-08-22','15:30:00',3.56),('15128','2013-08-22','15:35:00',3.67),('15128','2013-08-22','15:40:00',3.32),('15128','2013-08-22','15:45:00',3.33),('15128','2013-08-22','15:50:00',3.1),('15128','2013-08-22','15:55:00',3.03),('15128','2013-08-22','16:00:00',3.11),('15128','2013-08-22','16:05:00',3.02),('15128','2013-08-22','16:10:00',2.89),('15128','2013-08-22','16:15:00',2.95),('15128','2013-08-22','16:20:00',2.98),('15128','2013-08-22','16:25:00',2.9),('15128','2013-08-22','16:30:00',2.86),('15128','2013-08-22','16:35:00',2.92),('15128','2013-08-22','16:40:00',3.12),('15128','2013-08-22','16:45:00',3.02),('15128','2013-08-22','16:50:00',2.88),('15128','2013-08-22','16:55:00',2.85),('15128','2013-08-22','17:00:00',2.71),('15128','2013-08-22','17:05:00',2.61),('15128','2013-08-22','17:10:00',2.51),('15128','2013-08-22','17:15:00',2.45),('15128','2013-08-22','17:20:00',2.39),('15128','2013-08-22','17:25:00',2.3),('15128','2013-08-22','17:30:00',2.19),('15128','2013-08-22','17:35:00',2.06),('15128','2013-08-22','17:40:00',1.97),('15128','2013-08-22','17:45:00',1.9),('15128','2013-08-22','17:50:00',1.78),('15128','2013-08-22','17:55:00',1.14),('15128','2013-08-22','18:00:00',1.04),('15128','2013-08-22','18:05:00',1.48),('15128','2013-08-22','18:10:00',1.46),('15128','2013-08-22','18:15:00',1.42),('15128','2013-08-22','18:20:00',1.4),('15128','2013-08-22','18:25:00',1.32),('15128','2013-08-22','18:30:00',1.2),('15128','2013-08-22','18:35:00',1.1),('15128','2013-08-21','08:40:00',1.01),('15128','2013-08-21','08:45:00',1.1),('15128','2013-08-21','08:50:00',1.16),('15128','2013-08-21','08:55:00',1.26),('15128','2013-08-21','09:00:00',1.28),('15128','2013-08-21','09:05:00',1.39),('15128','2013-08-21','09:10:00',1.43),('15128','2013-08-21','09:15:00',1.28),('15128','2013-08-21','09:20:00',1.53),('15128','2013-08-21','09:25:00',1.66),('15128','2013-08-21','09:30:00',1.72),('15128','2013-08-21','09:35:00',1.73),('15128','2013-08-21','09:40:00',1.8),('15128','2013-08-21','09:45:00',1.84),('15128','2013-08-21','09:50:00',1.99),('15128','2013-08-21','09:55:00',1.92),('15128','2013-08-21','10:00:00',1.84),('15128','2013-08-21','10:05:00',2.04),('15128','2013-08-21','10:10:00',2.4),('15128','2013-08-21','10:15:00',2.38),('15128','2013-08-21','10:20:00',2.39),('15128','2013-08-21','10:25:00',1.93),('15128','2013-08-21','10:30:00',1.89),('15128','2013-08-21','10:35:00',2.15),('15128','2013-08-21','10:40:00',2.54),('15128','2013-08-21','10:45:00',2.58),('15128','2013-08-21','10:50:00',2.59),('15128','2013-08-21','10:55:00',2.63),('15128','2013-08-21','11:00:00',2.69),('15128','2013-08-21','11:05:00',2.73),('15128','2013-08-21','11:10:00',2.8),('15128','2013-08-21','11:15:00',2.86),('15128','2013-08-21','11:20:00',2.95),('15128','2013-08-21','11:25:00',2.98),('15128','2013-08-21','11:30:00',3.04),('15128','2013-08-21','11:35:00',3.07),('15128','2013-08-21','11:40:00',3.13),('15128','2013-08-21','11:45:00',3.17),('15128','2013-08-21','11:50:00',3.27),('15128','2013-08-21','11:55:00',3.32),('15128','2013-08-21','12:00:00',3.42),('15128','2013-08-21','12:05:00',3.47),('15128','2013-08-21','12:10:00',3.5),('15128','2013-08-21','12:15:00',3.55),('15128','2013-08-21','12:20:00',3.58),('15128','2013-08-21','12:25:00',3.61),('15128','2013-08-21','12:30:00',3.63),('15128','2013-08-21','12:35:00',3.63),('15128','2013-08-21','12:40:00',3.64),('15128','2013-08-21','12:45:00',3.65),('15128','2013-08-21','12:50:00',3.68),('15128','2013-08-21','12:55:00',3.68),('15128','2013-08-21','13:00:00',3.7),('15128','2013-08-21','13:05:00',3.7),('15128','2013-08-21','13:10:00',3.72),('15128','2013-08-21','13:15:00',3.72),('15128','2013-08-21','13:20:00',3.75),('15128','2013-08-21','13:25:00',3.8),('15128','2013-08-21','13:30:00',3.75),('15128','2013-08-21','13:35:00',3.79),('15128','2013-08-21','13:40:00',3.48),('15128','2013-08-21','13:45:00',3.68),('15128','2013-08-21','13:50:00',3.84),('15128','2013-08-21','13:55:00',3.84),('15128','2013-08-21','14:00:00',3.81),('15128','2013-08-21','14:05:00',3.79),('15128','2013-08-21','14:10:00',3.83),('15128','2013-08-21','14:15:00',2.75),('15128','2013-08-21','14:20:00',2.14),('15128','2013-08-21','14:25:00',3.92),('15128','2013-08-21','14:30:00',3.86),('15128','2013-08-21','14:35:00',3.76),('15128','2013-08-21','14:40:00',3.73),('15128','2013-08-21','14:45:00',3.72),('15128','2013-08-21','14:50:00',3.55),('15128','2013-08-21','14:55:00',3.54),('15128','2013-08-21','15:00:00',3.58),('15128','2013-08-21','15:05:00',3.56),('15128','2013-08-21','15:10:00',3.64),('15128','2013-08-21','15:15:00',3.58),('15128','2013-08-21','15:20:00',3.57),('15128','2013-08-21','15:25:00',3.57),('15128','2013-08-21','15:30:00',3.55),('15128','2013-08-21','15:35:00',3.5),('15128','2013-08-21','15:40:00',3.46),('15128','2013-08-21','15:45:00',3.44),('15128','2013-08-21','15:50:00',3.39),('15128','2013-08-21','15:55:00',3.37),('15128','2013-08-21','16:00:00',3.31),('15128','2013-08-21','16:05:00',3.24),('15128','2013-08-21','16:10:00',3.19),('15128','2013-08-21','16:15:00',3.11),('15128','2013-08-21','16:20:00',3.08),('15128','2013-08-21','16:25:00',3.05),('15128','2013-08-21','16:30:00',2.97),('15128','2013-08-21','16:35:00',2.9),('15128','2013-08-21','16:40:00',2.81),('15128','2013-08-21','16:45:00',2.73),('15128','2013-08-21','16:50:00',2.61),('15128','2013-08-21','16:55:00',2.61),('15128','2013-08-21','17:00:00',2.55),('15128','2013-08-21','17:05:00',2.49),('15128','2013-08-21','17:10:00',2.41),('15128','2013-08-21','17:15:00',2.32),('15128','2013-08-21','17:20:00',2.25),('15128','2013-08-21','17:25:00',2.12),('15128','2013-08-21','17:30:00',2.03),('15128','2013-08-21','17:35:00',1.96),('15128','2013-08-21','17:40:00',1.84),('15128','2013-08-21','17:45:00',1.75),('15128','2013-08-21','17:50:00',1.66),('15128','2013-08-21','17:55:00',1.59),('15128','2013-08-21','18:00:00',1.5),('15128','2013-08-21','18:05:00',1.45),('15128','2013-08-21','18:10:00',1.42),('15128','2013-08-21','18:15:00',1.36),('15128','2013-08-21','18:20:00',1.25),('15128','2013-08-21','18:25:00',1.11),('15128','2013-08-20','09:15:00',1.18),('15128','2013-08-20','09:20:00',1.27),('15128','2013-08-20','09:25:00',1.96),('15128','2013-08-20','09:30:00',1.53),('15128','2013-08-20','09:55:00',1.02),('15128','2013-08-20','10:00:00',1.27),('15128','2013-08-20','10:05:00',2.14),('15128','2013-08-20','10:10:00',2.27),('15128','2013-08-20','10:15:00',2.25),('15128','2013-08-20','10:20:00',2.15),('15128','2013-08-20','10:25:00',2.37),('15128','2013-08-20','10:30:00',2.39),('15128','2013-08-20','10:35:00',2.45),('15128','2013-08-20','10:40:00',2.44),('15128','2013-08-20','10:45:00',2.72),('15128','2013-08-20','10:50:00',2.64),('15128','2013-08-20','10:55:00',2.78),('15128','2013-08-20','11:00:00',2.94),('15128','2013-08-20','11:05:00',2.34),('15128','2013-08-20','11:10:00',2.82),('15128','2013-08-20','11:15:00',1.78),('15128','2013-08-20','11:20:00',1.57),('15128','2013-08-20','11:25:00',1.89),('15128','2013-08-20','11:30:00',3.68),('15128','2013-08-20','11:35:00',3.14),('15128','2013-08-20','11:40:00',3.48),('15128','2013-08-20','11:45:00',3.65),('15128','2013-08-20','11:50:00',3.6),('15128','2013-08-20','11:55:00',3.63),('15128','2013-08-20','12:00:00',3.59),('15128','2013-08-20','12:05:00',3.69),('15128','2013-08-20','12:10:00',3.8),('15128','2013-08-20','12:15:00',3.82),('15128','2013-08-20','12:20:00',3.71),('15128','2013-08-20','12:25:00',3.76),('15128','2013-08-20','12:30:00',3.88),('15128','2013-08-20','12:35:00',3.75),('15128','2013-08-20','12:40:00',3.6),('15128','2013-08-20','12:45:00',3.55),('15128','2013-08-20','12:50:00',3.66),('15128','2013-08-20','12:55:00',3.67),('15128','2013-08-20','13:00:00',3.51),('15128','2013-08-20','13:05:00',3.64),('15128','2013-08-20','13:10:00',3.75),('15128','2013-08-20','13:15:00',3.85),('15128','2013-08-20','13:20:00',3.86),('15128','2013-08-20','13:25:00',3.74),('15128','2013-08-20','13:30:00',3.79),('15128','2013-08-20','13:35:00',3.87),('15128','2013-08-20','13:40:00',3.88),('15128','2013-08-20','13:45:00',3.91),('15128','2013-08-20','13:50:00',3.93),('15128','2013-08-20','13:55:00',4),('15128','2013-08-20','14:00:00',4.03),('15128','2013-08-20','14:05:00',3.95),('15128','2013-08-20','14:10:00',3.99),('15128','2013-08-20','14:15:00',3.88),('15128','2013-08-20','14:20:00',3.8),('15128','2013-08-20','14:25:00',3.67),('15128','2013-08-20','14:30:00',3.32),('15128','2013-08-20','14:35:00',3.11),('15128','2013-08-20','14:40:00',3.68),('15128','2013-08-20','14:45:00',2.88),('15128','2013-08-20','14:50:00',3.55),('15128','2013-08-20','14:55:00',3.63),('15128','2013-08-20','15:00:00',3.66),('15128','2013-08-20','15:05:00',3.68),('15128','2013-08-20','15:10:00',3.68),('15128','2013-08-20','15:15:00',3.67),('15128','2013-08-20','15:20:00',3.53),('15128','2013-08-20','15:25:00',3.39),('15128','2013-08-20','15:30:00',3.2),('15128','2013-08-20','15:35:00',3.14),('15128','2013-08-20','15:40:00',3.01),('15128','2013-08-20','15:45:00',3.03),('15128','2013-08-20','15:50:00',3.08),('15128','2013-08-20','15:55:00',3.04),('15128','2013-08-20','16:00:00',3),('15128','2013-08-20','16:05:00',3.04),('15128','2013-08-20','16:10:00',3.18),('15128','2013-08-20','16:15:00',3.17),('15128','2013-08-20','16:20:00',3.16),('15128','2013-08-20','16:25:00',3.07),('15128','2013-08-20','16:30:00',3.06),('15128','2013-08-20','16:35:00',3.06),('15128','2013-08-20','16:40:00',2.98),('15128','2013-08-20','16:45:00',2.93),('15128','2013-08-20','16:50:00',2.87),('15128','2013-08-20','16:55:00',2.85),('15128','2013-08-20','17:00:00',2.78),('15128','2013-08-20','17:05:00',2.73),('15128','2013-08-20','17:10:00',2.67),('15128','2013-08-20','17:15:00',2.62),('15128','2013-08-20','17:20:00',2.52),('15128','2013-08-20','17:25:00',2.45),('15128','2013-08-20','17:30:00',2.38),('15128','2013-08-20','17:35:00',2.25),('15128','2013-08-20','17:40:00',2.19),('15128','2013-08-20','17:45:00',2.06),('15128','2013-08-20','17:50:00',1.99),('15128','2013-08-20','17:55:00',1.9),('15128','2013-08-20','18:00:00',1.8),('15128','2013-08-20','18:05:00',1.72),('15128','2013-08-20','18:10:00',1.64),('15128','2013-08-20','18:15:00',1.57),('15128','2013-08-20','18:20:00',1.4),('15128','2013-08-20','18:25:00',1.2),('15128','2013-08-20','18:30:00',1.16),('15128','2013-08-20','18:35:00',1.12),('15128','2013-08-19','08:55:00',1.11),('15128','2013-08-19','09:25:00',1.32),('15128','2013-08-19','09:30:00',2.01),('15128','2013-08-19','09:35:00',1.84),('15128','2013-08-19','09:40:00',1.08),('15128','2013-08-19','09:55:00',1.08),('15128','2013-08-19','10:00:00',1.54),('15128','2013-08-19','10:05:00',2.52),('15128','2013-08-19','10:10:00',2.55),('15128','2013-08-19','10:15:00',1.34),('15128','2013-08-19','10:20:00',1.38),('15128','2013-08-19','10:25:00',1.28),('15128','2013-08-19','10:30:00',1.7),('15128','2013-08-19','10:35:00',3.27),('15128','2013-08-19','10:40:00',2.43),('15128','2013-08-19','10:45:00',1.08),('15128','2013-08-19','11:00:00',2.95),('15128','2013-08-19','11:05:00',1.99),('15128','2013-08-19','11:10:00',1.37),('15128','2013-08-19','11:15:00',2.03),('15128','2013-08-19','11:20:00',3.19),('15128','2013-08-19','11:25:00',1.93),('15128','2013-08-19','11:30:00',1.2),('15128','2013-08-19','11:35:00',1.87),('15128','2013-08-19','11:40:00',3.78),('15128','2013-08-19','11:45:00',2.77),('15128','2013-08-19','11:50:00',2.36),('15128','2013-08-19','11:55:00',2.67),('15128','2013-08-19','12:00:00',1.87),('15128','2013-08-19','12:05:00',1.84),('15128','2013-08-19','12:10:00',1.59),('15128','2013-08-19','12:15:00',1.4),('15128','2013-08-19','12:20:00',1.44),('15128','2013-08-19','12:25:00',1.93),('15128','2013-08-19','12:30:00',2.2),('15128','2013-08-19','12:35:00',2.63),('15128','2013-08-19','12:40:00',2.86),('15128','2013-08-19','12:45:00',1.96),('15128','2013-08-19','12:50:00',2.58),('15128','2013-08-19','12:55:00',3.18),('15128','2013-08-19','13:00:00',1.98),('15128','2013-08-19','13:05:00',1.63),('15128','2013-08-19','13:10:00',1.88),('15128','2013-08-19','13:15:00',2.81),('15128','2013-08-19','13:20:00',2.03),('15128','2013-08-19','13:25:00',2),('15128','2013-08-19','13:30:00',2.3),('15128','2013-08-19','13:35:00',2.27),('15128','2013-08-19','13:40:00',4.62),('15128','2013-08-19','13:45:00',3.51),('15128','2013-08-19','13:50:00',4.34),('15128','2013-08-19','13:55:00',4.21),('15128','2013-08-19','14:00:00',4.12),('15128','2013-08-19','14:05:00',3.59),('15128','2013-08-19','14:10:00',3.98),('15128','2013-08-19','14:15:00',3.31),('15128','2013-08-19','14:20:00',4.04),('15128','2013-08-19','14:25:00',3.19),('15128','2013-08-19','14:30:00',3.39),('15128','2013-08-19','14:35:00',3.21),('15128','2013-08-19','14:40:00',4.45),('15128','2013-08-19','14:45:00',3.65),('15128','2013-08-19','14:50:00',4.18),('15128','2013-08-19','14:55:00',3.95),('15128','2013-08-19','15:00:00',3.75),('15128','2013-08-19','15:05:00',4.08),('15128','2013-08-19','15:10:00',3.35),('15128','2013-08-19','15:15:00',1.88),('15128','2013-08-19','15:20:00',3.5),('15128','2013-08-19','15:25:00',4.23),('15128','2013-08-19','15:30:00',3.62),('15128','2013-08-19','15:35:00',1.56),('15128','2013-08-19','15:40:00',1.45),('15128','2013-08-19','15:45:00',2.39),('15128','2013-08-19','15:50:00',4.43),('15128','2013-08-19','15:55:00',4.15),('15128','2013-08-19','16:00:00',3.91),('15128','2013-08-19','16:05:00',3.95),('15128','2013-08-19','16:10:00',4.11),('15128','2013-08-19','16:15:00',4.15),('15128','2013-08-19','16:20:00',4.13),('15128','2013-08-19','16:25:00',3.9),('15128','2013-08-19','16:30:00',3.74),('15128','2013-08-19','16:35:00',2.49),('15128','2013-08-19','16:40:00',2.73),('15128','2013-08-19','16:45:00',3.36),('15128','2013-08-19','16:50:00',2.93),('15128','2013-08-19','16:55:00',2.57),('15128','2013-08-19','17:00:00',2.99),('15128','2013-08-19','17:05:00',2.92),('15128','2013-08-19','17:10:00',2.81),('15128','2013-08-19','17:15:00',2.75),('15128','2013-08-19','17:20:00',2.67),('15128','2013-08-19','17:25:00',2.55),('15128','2013-08-19','17:30:00',2.44),('15128','2013-08-19','17:35:00',2.38),('15128','2013-08-19','17:40:00',2.25),('15128','2013-08-19','17:45:00',2.09),('15128','2013-08-19','17:50:00',1.89),('15128','2013-08-19','17:55:00',1.79),('15128','2013-08-19','18:00:00',1.73),('15128','2013-08-19','18:05:00',1.64),('15128','2013-08-19','18:10:00',1.6),('15128','2013-08-19','18:15:00',1.56),('15128','2013-08-19','18:20:00',1.51),('15128','2013-08-19','18:25:00',1.47),('15128','2013-08-19','18:30:00',1.31),('15128','2013-08-19','18:35:00',1.31),('15128','2013-08-19','18:40:00',1.23),('15128','2013-08-19','18:45:00',1.13),('15128','2013-08-19','18:50:00',1.03),('15128','2014-04-09','08:45:00',1.03),('15128','2014-04-09','08:50:00',1.1),('15128','2014-04-09','08:55:00',1.14),('15128','2014-04-09','09:00:00',1.22),('15128','2014-04-09','09:05:00',1.31),('15128','2014-04-09','09:10:00',1.37),('15128','2014-04-09','09:15:00',1.39),('15128','2014-04-09','09:20:00',1.49),('15128','2014-04-09','09:25:00',1.59),('15128','2014-04-09','09:30:00',1.67),('15128','2014-04-09','09:35:00',1.75),('15128','2014-04-09','09:40:00',1.76),('15128','2014-04-09','09:45:00',1.87),('15128','2014-04-09','09:50:00',1.94),('15128','2014-04-09','09:55:00',1.94),('15128','2014-04-09','10:00:00',2),('15128','2014-04-09','10:05:00',2.06),('15128','2014-04-09','10:10:00',2.13),('15128','2014-04-09','10:15:00',2.16),('15128','2014-04-09','10:20:00',2.23),('15128','2014-04-09','10:25:00',2.27),('15128','2014-04-09','10:30:00',2.4),('15128','2014-04-09','10:35:00',2.56),('15128','2014-04-09','10:40:00',2.56),('15128','2014-04-09','10:45:00',2.63),('15128','2014-04-09','10:50:00',2.64),('15128','2014-04-09','10:55:00',2.73),('15128','2014-04-09','11:00:00',2.83),('15128','2014-04-09','11:05:00',2.76),('15128','2014-04-09','11:10:00',2.87),('15128','2014-04-09','11:15:00',2.93),('15128','2014-04-09','11:20:00',3.05),('15128','2014-04-09','11:25:00',3.16),('15128','2014-04-09','11:30:00',3.23),('15128','2014-04-09','11:35:00',3.18),('15128','2014-04-09','11:40:00',3.32),('15128','2014-04-09','11:45:00',3.24),('15128','2014-04-09','11:50:00',3.35),('15128','2014-04-09','11:55:00',3.45),('15128','2014-04-09','12:00:00',3.41),('15128','2014-04-09','12:05:00',3.42),('15128','2014-04-09','12:10:00',3.69),('15128','2014-04-09','12:15:00',3.72),('15128','2014-04-09','12:20:00',3.63),('15128','2014-04-09','12:25:00',3.55),('15128','2014-04-09','12:30:00',3.72),('15128','2014-04-09','12:35:00',3.7),('15128','2014-04-09','12:40:00',3.68),('15128','2014-04-09','12:45:00',3.74),('15128','2014-04-09','12:50:00',3.83),('15128','2014-04-09','12:55:00',3.91),('15128','2014-04-09','13:00:00',3.65),('15128','2014-04-09','13:05:00',3.81),('15128','2014-04-09','13:10:00',4.04),('15128','2014-04-09','13:15:00',3.87),('15128','2014-04-09','13:20:00',3.68),('15128','2014-04-09','13:25:00',3.91),('15128','2014-04-09','13:30:00',4.01),('15128','2014-04-09','13:35:00',4.04),('15128','2014-04-09','13:40:00',3.96),('15128','2014-04-09','13:45:00',4.06),('15128','2014-04-09','13:50:00',4.04),('15128','2014-04-09','13:55:00',4.02),('15128','2014-04-09','14:00:00',3.99),('15128','2014-04-09','14:05:00',3.86),('15128','2014-04-09','14:10:00',3.94),('15128','2014-04-09','14:15:00',4.05),('15128','2014-04-09','14:20:00',4.03),('15128','2014-04-09','14:25:00',3.99),('15128','2014-04-09','14:30:00',3.98),('15128','2014-04-09','14:35:00',3.95),('15128','2014-04-09','14:40:00',3.93),('15128','2014-04-09','14:45:00',3.58),('15128','2014-04-09','14:50:00',3.96),('15128','2014-04-09','14:55:00',3.87),('15128','2014-04-09','15:00:00',3.84),('15128','2014-04-09','15:05:00',3.85),('15128','2014-04-09','15:10:00',3.75),('15128','2014-04-09','15:15:00',3.76),('15128','2014-04-09','15:20:00',3.67),('15128','2014-04-09','15:25:00',3.65),('15128','2014-04-09','15:30:00',3.35),('15128','2014-04-09','15:35:00',3.27),('15128','2014-04-09','15:40:00',3.46),('15128','2014-04-09','15:45:00',3.39),('15128','2014-04-09','15:50:00',3.33),('15128','2014-04-09','15:55:00',3.53),('15128','2014-04-09','16:00:00',3.54),('15128','2014-04-09','16:05:00',3.5),('15128','2014-04-09','16:10:00',3.58),('15128','2014-04-09','16:15:00',3.52),('15128','2014-04-09','16:20:00',3.2),('15128','2014-04-09','16:25:00',3.32),('15128','2014-04-09','16:30:00',3.33),('15128','2014-04-09','16:35:00',3.21),('15128','2014-04-09','16:40:00',3.19),('15128','2014-04-09','16:45:00',3.02),('15128','2014-04-09','16:50:00',3.02),('15128','2014-04-09','16:55:00',2.92),('15128','2014-04-09','17:00:00',2.81),('15128','2014-04-09','17:05:00',2.78),('15128','2014-04-09','17:10:00',2.64),('15128','2014-04-09','17:15:00',2.54),('15128','2014-04-09','17:20:00',2.41),('15128','2014-04-09','17:25:00',2.25),('15128','2014-04-09','17:30:00',2.13),('15128','2014-04-09','17:35:00',2.01),('15128','2014-04-09','17:40:00',1.91),('15128','2014-04-09','17:45:00',1.84),('15128','2014-04-09','17:50:00',1.77),('15128','2014-04-09','17:55:00',1.71),('15128','2014-04-09','18:00:00',1.66),('15128','2014-04-09','18:05:00',1.57),('15128','2014-04-09','18:10:00',1.48),('15128','2014-04-09','18:15:00',1.38),('15128','2014-04-09','18:20:00',1.25),('15128','2014-04-09','18:25:00',1.1),('15128','2014-04-09','18:30:00',1.01),('15128','2013-08-18','08:40:00',1.07),('15128','2013-08-18','08:45:00',1.12),('15128','2013-08-18','08:50:00',1.16),('15128','2013-08-18','08:55:00',1.23),('15128','2013-08-18','09:00:00',1.3),('15128','2013-08-18','09:05:00',1.38),('15128','2013-08-18','09:10:00',1.43),('15128','2013-08-18','09:15:00',1.48),('15128','2013-08-18','09:20:00',1.54),('15128','2013-08-18','09:25:00',1.59),('15128','2013-08-18','09:30:00',1.66),('15128','2013-08-18','09:35:00',1.7),('15128','2013-08-18','09:40:00',1.77),('15128','2013-08-18','09:45:00',1.78),('15128','2013-08-18','09:50:00',1.84),('15128','2013-08-18','09:55:00',1.96),('15128','2013-08-18','10:00:00',2),('15128','2013-08-18','10:05:00',2.05),('15128','2013-08-18','10:10:00',2.11),('15128','2013-08-18','10:15:00',2.16),('15128','2013-08-18','10:20:00',2.21),('15128','2013-08-18','10:25:00',2.28),('15128','2013-08-18','10:30:00',2.37),('15128','2013-08-18','10:35:00',2.46),('15128','2013-08-18','10:40:00',2.55),('15128','2013-08-18','10:45:00',2.6),('15128','2013-08-18','10:50:00',2.64),('15128','2013-08-18','10:55:00',2.7),('15128','2013-08-18','11:00:00',2.76),('15128','2013-08-18','11:05:00',2.79),('15128','2013-08-18','11:10:00',2.82),('15128','2013-08-18','11:15:00',2.94),('15128','2013-08-18','11:20:00',2.95),('15128','2013-08-18','11:25:00',2.97),('15128','2013-08-18','11:30:00',3.03),('15128','2013-08-18','11:35:00',2.98),('15128','2013-08-18','11:40:00',3.07),('15128','2013-08-18','11:45:00',3.14),('15128','2013-08-18','11:50:00',3.28),('15128','2013-08-18','11:55:00',3.4),('15128','2013-08-18','12:00:00',3.52),('15128','2013-08-18','12:05:00',3.6),('15128','2013-08-18','12:10:00',3.68),('15128','2013-08-18','12:15:00',3.67),('15128','2013-08-18','12:20:00',3.68),('15128','2013-08-18','12:25:00',3.72),('15128','2013-08-18','12:30:00',3.78),('15128','2013-08-18','12:35:00',3.83),('15128','2013-08-18','12:40:00',3.87),('15128','2013-08-18','12:45:00',3.87),('15128','2013-08-18','12:50:00',3.88),('15128','2013-08-18','12:55:00',3.91),('15128','2013-08-18','13:00:00',3.96),('15128','2013-08-18','13:05:00',3.96),('15128','2013-08-18','13:10:00',4),('15128','2013-08-18','13:15:00',4.01),('15128','2013-08-18','13:20:00',4.01),('15128','2013-08-18','13:25:00',4.02),('15128','2013-08-18','13:30:00',4.03),('15128','2013-08-18','13:35:00',4.04),('15128','2013-08-18','13:40:00',4.07),('15128','2013-08-18','13:45:00',4.09),('15128','2013-08-18','13:50:00',4.09),('15128','2013-08-18','13:55:00',4.1),('15128','2013-08-18','14:00:00',4.1),('15128','2013-08-18','14:05:00',4.11),('15128','2013-08-18','14:10:00',4.09),('15128','2013-08-18','14:15:00',4.07),('15128','2013-08-18','14:20:00',4.06),('15128','2013-08-18','14:25:00',4.06),('15128','2013-08-18','14:30:00',4.05),('15128','2013-08-18','14:35:00',4.04),('15128','2013-08-18','14:40:00',4.04),('15128','2013-08-18','14:45:00',4.03),('15128','2013-08-18','14:50:00',4.02),('15128','2013-08-18','14:55:00',3.99),('15128','2013-08-18','15:00:00',3.97),('15128','2013-08-18','15:05:00',3.95),('15128','2013-08-18','15:10:00',3.93),('15128','2013-08-18','15:15:00',3.9),('15128','2013-08-18','15:20:00',3.87),('15128','2013-08-18','15:25:00',3.84),('15128','2013-08-18','15:30:00',3.8),('15128','2013-08-18','15:35:00',3.75),('15128','2013-08-18','15:40:00',3.73),('15128','2013-08-18','15:45:00',3.71),('15128','2013-08-18','15:50:00',3.63),('15128','2013-08-18','15:55:00',3.62),('15128','2013-08-18','16:00:00',3.57),('15128','2013-08-18','16:05:00',3.52),('15128','2013-08-18','16:10:00',3.48),('15128','2013-08-18','16:15:00',3.41),('15128','2013-08-18','16:20:00',3.35),('15128','2013-08-18','16:25:00',3.31),('15128','2013-08-18','16:30:00',3.25),('15128','2013-08-18','16:35:00',3.2),('15128','2013-08-18','16:40:00',3.14),('15128','2013-08-18','16:45:00',3.09),('15128','2013-08-18','16:50:00',3.01),('15128','2013-08-18','16:55:00',2.96),('15128','2013-08-18','17:00:00',2.89),('15128','2013-08-18','17:05:00',2.81),('15128','2013-08-18','17:10:00',2.74),('15128','2013-08-18','17:15:00',2.67),('15128','2013-08-18','17:20:00',2.6),('15128','2013-08-18','17:25:00',2.51),('15128','2013-08-18','17:30:00',2.4),('15128','2013-08-18','17:35:00',2.32),('15128','2013-08-18','17:40:00',2.18),('15128','2013-08-18','17:45:00',2.04),('15128','2013-08-18','17:50:00',1.99),('15128','2013-08-18','17:55:00',1.88),('15128','2013-08-18','18:00:00',1.81),('15128','2013-08-18','18:05:00',1.72),('15128','2013-08-18','18:10:00',1.67),('15128','2013-08-18','18:15:00',1.6),('15128','2013-08-18','18:20:00',1.51),('15128','2013-08-18','18:25:00',1.44),('15128','2013-08-18','18:30:00',1.35),('15128','2013-08-18','18:35:00',1.25),('15128','2013-08-18','18:40:00',1.14),('15128','2013-08-18','18:45:00',1.06),('15128','2013-08-17','08:35:00',1.04),('15128','2013-08-17','08:40:00',1.1),('15128','2013-08-17','08:45:00',1.14),('15128','2013-08-17','08:50:00',1.17),('15128','2013-08-17','08:55:00',1.24),('15128','2013-08-17','09:00:00',1.32),('15128','2013-08-17','09:05:00',1.4),('15128','2013-08-17','09:10:00',1.48),('15128','2013-08-17','09:15:00',1.53),('15128','2013-08-17','09:20:00',1.57),('15128','2013-08-17','09:25:00',1.63),('15128','2013-08-17','09:30:00',1.68),('15128','2013-08-17','09:35:00',1.72),('15128','2013-08-17','09:40:00',1.74),('15128','2013-08-17','09:45:00',1.76),('15128','2013-08-17','09:50:00',1.88),('15128','2013-08-17','09:55:00',1.94),('15128','2013-08-17','10:00:00',2.06),('15128','2013-08-17','10:05:00',2.11),('15128','2013-08-17','10:10:00',2.16),('15128','2013-08-17','10:15:00',2.22),('15128','2013-08-17','10:20:00',2.23),('15128','2013-08-17','10:25:00',2.32),('15128','2013-08-17','10:30:00',2.39),('15128','2013-08-17','10:35:00',2.46),('15128','2013-08-17','10:40:00',2.55),('15128','2013-08-17','10:45:00',2.62),('15128','2013-08-17','10:50:00',2.7),('15128','2013-08-17','10:55:00',2.72),('15128','2013-08-17','11:00:00',2.78),('15128','2013-08-17','11:05:00',2.83),('15128','2013-08-17','11:10:00',2.87),('15128','2013-08-17','11:15:00',2.94),('15128','2013-08-17','11:20:00',2.97),('15128','2013-08-17','11:25:00',3),('15128','2013-08-17','11:30:00',3.1),('15128','2013-08-17','11:35:00',3.03),('15128','2013-08-17','11:40:00',3.15),('15128','2013-08-17','11:45:00',3.18),('15128','2013-08-17','11:50:00',3.3),('15128','2013-08-17','11:55:00',3.41),('15128','2013-08-17','12:00:00',3.52),('15128','2013-08-17','12:05:00',3.57),('15128','2013-08-17','12:10:00',3.62),('15128','2013-08-17','12:15:00',3.62),('15128','2013-08-17','12:20:00',3.68),('15128','2013-08-17','12:25:00',3.7),('15128','2013-08-17','12:30:00',3.87),('15128','2013-08-17','12:35:00',3.15),('15128','2013-08-17','12:40:00',2.35),('15128','2013-08-17','12:45:00',3.9),('15128','2013-08-17','12:50:00',3.9),('15128','2013-08-17','12:55:00',3.95),('15128','2013-08-17','13:00:00',3.93),('15128','2013-08-17','13:05:00',3.93),('15128','2013-08-17','13:10:00',3.97),('15128','2013-08-17','13:15:00',3.97),('15128','2013-08-17','13:20:00',3.99),('15128','2013-08-17','13:25:00',3.99),('15128','2013-08-17','13:30:00',4.04),('15128','2013-08-17','13:35:00',4.01),('15128','2013-08-17','13:40:00',4),('15128','2013-08-17','13:45:00',4.04),('15128','2013-08-17','13:50:00',4.04),('15128','2013-08-17','13:55:00',4.02),('15128','2013-08-17','14:00:00',4.06),('15128','2013-08-17','14:05:00',4.06),('15128','2013-08-17','14:10:00',4.06),('15128','2013-08-17','14:15:00',4.06),('15128','2013-08-17','14:20:00',4.03),('15128','2013-08-17','14:25:00',4.04),('15128','2013-08-17','14:30:00',4.03),('15128','2013-08-17','14:35:00',4.03),('15128','2013-08-17','14:40:00',4.02),('15128','2013-08-17','14:45:00',4.02),('15128','2013-08-17','14:50:00',4.01),('15128','2013-08-17','14:55:00',3.97),('15128','2013-08-17','15:00:00',3.94),('15128','2013-08-17','15:05:00',3.93),('15128','2013-08-17','15:10:00',3.89),('15128','2013-08-17','15:15:00',3.88),('15128','2013-08-17','15:20:00',3.84),('15128','2013-08-17','15:25:00',3.79),('15128','2013-08-17','15:30:00',3.74),('15128','2013-08-17','15:35:00',3.71),('15128','2013-08-17','15:40:00',3.67),('15128','2013-08-17','15:45:00',3.65),('15128','2013-08-17','15:50:00',3.62),('15128','2013-08-17','15:55:00',3.58),('15128','2013-08-17','16:00:00',3.54),('15128','2013-08-17','16:05:00',3.51),('15128','2013-08-17','16:10:00',3.47),('15128','2013-08-17','16:15:00',3.42),('15128','2013-08-17','16:20:00',3.38),('15128','2013-08-17','16:25:00',3.32),('15128','2013-08-17','16:30:00',3.26),('15128','2013-08-17','16:35:00',3.2),('15128','2013-08-17','16:40:00',3.16),('15128','2013-08-17','16:45:00',3.1),('15128','2013-08-17','16:50:00',3.04),('15128','2013-08-17','16:55:00',2.98),('15128','2013-08-17','17:00:00',2.9),('15128','2013-08-17','17:05:00',2.84),('15128','2013-08-17','17:10:00',2.77),('15128','2013-08-17','17:15:00',2.7),('15128','2013-08-17','17:20:00',2.62),('15128','2013-08-17','17:25:00',2.53),('15128','2013-08-17','17:30:00',2.42),('15128','2013-08-17','17:35:00',2.33),('15128','2013-08-17','17:40:00',2.22),('15128','2013-08-17','17:45:00',2.12),('15128','2013-08-17','17:50:00',2.02),('15128','2013-08-17','17:55:00',1.89),('15128','2013-08-17','18:00:00',1.81),('15128','2013-08-17','18:05:00',1.7),('15128','2013-08-17','18:10:00',1.66),('15128','2013-08-17','18:15:00',1.61),('15128','2013-08-17','18:20:00',1.53),('15128','2013-08-17','18:25:00',1.45),('15128','2013-08-17','18:30:00',1.37),('15128','2013-08-17','18:35:00',1.27),('15128','2013-08-17','18:40:00',1.16),('15128','2013-08-17','18:45:00',1.06),('15128','2013-08-16','08:40:00',1.05),('15128','2013-08-16','08:45:00',1.1),('15128','2013-08-16','08:50:00',1.16),('15128','2013-08-16','08:55:00',1.29),('15128','2013-08-16','09:00:00',1.36),('15128','2013-08-16','09:05:00',1.42),('15128','2013-08-16','09:10:00',1.48),('15128','2013-08-16','09:15:00',1.53),('15128','2013-08-16','09:20:00',1.57),('15128','2013-08-16','09:25:00',1.62),('15128','2013-08-16','09:30:00',1.68),('15128','2013-08-16','09:35:00',1.86),('15128','2013-08-16','09:40:00',1.93),('15128','2013-08-16','09:45:00',1.93),('15128','2013-08-16','09:50:00',1.92),('15128','2013-08-16','09:55:00',1.97),('15128','2013-08-16','10:00:00',2.04),('15128','2013-08-16','10:05:00',2.12),('15128','2013-08-16','10:10:00',2.13),('15128','2013-08-16','10:15:00',2.19),('15128','2013-08-16','10:20:00',2.23),('15128','2013-08-16','10:25:00',2.33),('15128','2013-08-16','10:30:00',2.46),('15128','2013-08-16','10:35:00',2.56),('15128','2013-08-16','10:40:00',2.59),('15128','2013-08-16','10:45:00',2.64),('15128','2013-08-16','10:50:00',2.69),('15128','2013-08-16','10:55:00',2.7),('15128','2013-08-16','11:00:00',2.75),('15128','2013-08-16','11:05:00',2.78),('15128','2013-08-16','11:10:00',2.85),('15128','2013-08-16','11:15:00',2.9),('15128','2013-08-16','11:20:00',2.97),('15128','2013-08-16','11:25:00',3.01),('15128','2013-08-16','11:30:00',3.08),('15128','2013-08-16','11:35:00',3.1),('15128','2013-08-16','11:40:00',3.21),('15128','2013-08-16','11:45:00',3.25),('15128','2013-08-16','11:50:00',3.32),('15128','2013-08-16','11:55:00',3.5),('15128','2013-08-16','12:00:00',3.54),('15128','2013-08-16','12:05:00',3.6),('15128','2013-08-16','12:10:00',3.64),('15128','2013-08-16','12:15:00',3.62),('15128','2013-08-16','12:20:00',3.63),('15128','2013-08-16','12:25:00',3.66),('15128','2013-08-16','12:30:00',3.79),('15128','2013-08-16','12:35:00',3.81),('15128','2013-08-16','12:40:00',3.78),('15128','2013-08-16','12:45:00',3.7),('15128','2013-08-16','12:50:00',3.76),('15128','2013-08-16','12:55:00',3.91),('15128','2013-08-16','13:00:00',3.96),('15128','2013-08-16','13:05:00',3.93),('15128','2013-08-16','13:10:00',3.95),('15128','2013-08-16','13:15:00',3.99),('15128','2013-08-16','13:20:00',3.96),('15128','2013-08-16','13:25:00',3.98),('15128','2013-08-16','13:30:00',3.95),('15128','2013-08-16','13:35:00',4.04),('15128','2013-08-16','13:40:00',3.91),('15128','2013-08-16','13:45:00',3.98),('15128','2013-08-16','13:50:00',4.1),('15128','2013-08-16','13:55:00',4.03),('15128','2013-08-16','14:00:00',3.99),('15128','2013-08-16','14:05:00',4.06),('15128','2013-08-16','14:10:00',4.04),('15128','2013-08-16','14:15:00',4.03),('15128','2013-08-16','14:20:00',4.05),('15128','2013-08-16','14:25:00',4.04),('15128','2013-08-16','14:30:00',4.05),('15128','2013-08-16','14:35:00',4.05),('15128','2013-08-16','14:40:00',4.03),('15128','2013-08-16','14:45:00',3.99),('15128','2013-08-16','14:50:00',3.97),('15128','2013-08-16','14:55:00',3.97),('15128','2013-08-16','15:00:00',3.94),('15128','2013-08-16','15:05:00',3.94),('15128','2013-08-16','15:10:00',3.93),('15128','2013-08-16','15:15:00',3.91),('15128','2013-08-16','15:20:00',3.87),('15128','2013-08-16','15:25:00',3.86),('15128','2013-08-16','15:30:00',3.83),('15128','2013-08-16','15:35:00',3.78),('15128','2013-08-16','15:40:00',3.73),('15128','2013-08-16','15:45:00',3.7),('15128','2013-08-16','15:50:00',3.7),('15128','2013-08-16','15:55:00',3.63),('15128','2013-08-16','16:00:00',3.57),('15128','2013-08-16','16:05:00',3.54),('15128','2013-08-16','16:10:00',3.52),('15128','2013-08-16','16:15:00',3.46),('15128','2013-08-16','16:20:00',3.42),('15128','2013-08-16','16:25:00',3.38),('15128','2013-08-16','16:30:00',3.33),('15128','2013-08-16','16:35:00',3.26),('15128','2013-08-16','16:40:00',3.22),('15128','2013-08-16','16:45:00',3.15),('15128','2013-08-16','16:50:00',3.08),('15128','2013-08-16','16:55:00',3.02),('15128','2013-08-16','17:00:00',2.94),('15128','2013-08-16','17:05:00',2.85),('15128','2013-08-16','17:10:00',2.81),('15128','2013-08-16','17:15:00',2.68),('15128','2013-08-16','17:20:00',2.72),('15128','2013-08-16','17:25:00',2.61),('15128','2013-08-16','17:30:00',2.5),('15128','2013-08-16','17:35:00',2.4),('15128','2013-08-16','17:40:00',2.31),('15128','2013-08-16','17:45:00',2.2),('15128','2013-08-16','17:50:00',2.11),('15128','2013-08-16','17:55:00',1.96),('15128','2013-08-16','18:00:00',1.9),('15128','2013-08-16','18:05:00',1.82),('15128','2013-08-16','18:10:00',1.67),('15128','2013-08-16','18:15:00',1.63),('15128','2013-08-16','18:20:00',1.58),('15128','2013-08-16','18:25:00',1.5),('15128','2013-08-16','18:30:00',1.42),('15128','2013-08-16','18:35:00',1.32),('15128','2013-08-16','18:40:00',1.22),('15128','2013-08-16','18:45:00',1.13),('15128','2013-08-16','18:50:00',1.01),('15128','2013-08-15','08:35:00',1.03),('15128','2013-08-15','08:40:00',1.08),('15128','2013-08-15','08:45:00',1.13),('15128','2013-08-15','08:50:00',1.18),('15128','2013-08-15','08:55:00',1.31),('15128','2013-08-15','09:00:00',1.38),('15128','2013-08-15','09:05:00',1.45),('15128','2013-08-15','09:10:00',1.52),('15128','2013-08-15','09:15:00',1.58),('15128','2013-08-15','09:20:00',1.61),('15128','2013-08-15','09:25:00',1.65),('15128','2013-08-15','09:30:00',1.76),('15128','2013-08-15','09:35:00',1.9),('15128','2013-08-15','09:40:00',1.97),('15128','2013-08-15','09:45:00',1.96),('15128','2013-08-15','09:50:00',1.99),('15128','2013-08-15','09:55:00',2.01),('15128','2013-08-15','10:00:00',2.11),('15128','2013-08-15','10:05:00',2.17),('15128','2013-08-15','10:10:00',2.21),('15128','2013-08-15','10:15:00',2.29),('15128','2013-08-15','10:20:00',2.36),('15128','2013-08-15','10:25:00',2.45),('15128','2013-08-15','10:30:00',2.57),('15128','2013-08-15','10:35:00',2.63),('15128','2013-08-15','10:40:00',2.67),('15128','2013-08-15','10:45:00',2.75),('15128','2013-08-15','10:50:00',2.84),('15128','2013-08-15','10:55:00',2.89),('15128','2013-08-15','11:00:00',2.92),('15128','2013-08-15','11:05:00',2.96),('15128','2013-08-15','11:10:00',2.99),('15128','2013-08-15','11:15:00',3.05),('15128','2013-08-15','11:20:00',3.1),('15128','2013-08-15','11:25:00',3.15),('15128','2013-08-15','11:30:00',3.16),('15128','2013-08-15','11:35:00',3.24),('15128','2013-08-15','11:40:00',3.29),('15128','2013-08-15','11:45:00',3.37),('15128','2013-08-15','11:50:00',3.47),('15128','2013-08-15','11:55:00',3.58),('15128','2013-08-15','12:00:00',3.64),('15128','2013-08-15','12:05:00',3.72),('15128','2013-08-15','12:10:00',3.75),('15128','2013-08-15','12:15:00',3.78),('15128','2013-08-15','12:20:00',3.79),('15128','2013-08-15','12:25:00',3.82),('15128','2013-08-15','12:30:00',3.85),('15128','2013-08-15','12:35:00',3.9),('15128','2013-08-15','12:40:00',3.93),('15128','2013-08-15','12:45:00',3.96),('15128','2013-08-15','12:50:00',3.98),('15128','2013-08-15','12:55:00',4),('15128','2013-08-15','13:00:00',3.99),('15128','2013-08-15','13:05:00',4),('15128','2013-08-15','13:10:00',4),('15128','2013-08-15','13:15:00',4.01),('15128','2013-08-15','13:20:00',4.05),('15128','2013-08-15','13:25:00',4.06),('15128','2013-08-15','13:30:00',4.03),('15128','2013-08-15','13:35:00',4.03),('15128','2013-08-15','13:40:00',4.03),('15128','2013-08-15','13:45:00',4.05),('15128','2013-08-15','13:50:00',4.06),('15128','2013-08-15','13:55:00',4.06),('15128','2013-08-15','14:00:00',4.06),('15128','2013-08-15','14:05:00',4.05),('15128','2013-08-15','14:10:00',4.04),('15128','2013-08-15','14:15:00',4.02),('15128','2013-08-15','14:20:00',4.03),('15128','2013-08-15','14:25:00',4.02),('15128','2013-08-15','14:30:00',3.98),('15128','2013-08-15','14:35:00',3.95),('15128','2013-08-15','14:40:00',3.95),('15128','2013-08-15','14:45:00',3.93),('15128','2013-08-15','14:50:00',3.9),('15128','2013-08-15','14:55:00',3.88),('15128','2013-08-15','15:00:00',3.89),('15128','2013-08-15','15:05:00',3.95),('15128','2013-08-15','15:10:00',3.94),('15128','2013-08-15','15:15:00',3.92),('15128','2013-08-15','15:20:00',3.88),('15128','2013-08-15','15:25:00',3.85),('15128','2013-08-15','15:30:00',3.8),('15128','2013-08-15','15:35:00',3.77),('15128','2013-08-15','15:40:00',3.74),('15128','2013-08-15','15:45:00',3.7),('15128','2013-08-15','15:50:00',3.67),('15128','2013-08-15','15:55:00',3.62),('15128','2013-08-15','16:00:00',3.57),('15128','2013-08-15','16:05:00',3.51),('15128','2013-08-15','16:10:00',3.47),('15128','2013-08-15','16:15:00',3.44),('15128','2013-08-15','16:20:00',3.4),('15128','2013-08-15','16:25:00',3.36),('15128','2013-08-15','16:30:00',3.3),('15128','2013-08-15','16:35:00',3.23),('15128','2013-08-15','16:40:00',3.18),('15128','2013-08-15','16:45:00',3.13),('15128','2013-08-15','16:50:00',3.06),('15128','2013-08-15','16:55:00',2.99),('15128','2013-08-15','17:00:00',2.92),('15128','2013-08-15','17:05:00',2.86),('15128','2013-08-15','17:10:00',2.78),('15128','2013-08-15','17:15:00',2.72),('15128','2013-08-15','17:20:00',2.65),('15128','2013-08-15','17:25:00',2.53),('15128','2013-08-15','17:30:00',2.47),('15128','2013-08-15','17:35:00',2.36),('15128','2013-08-15','17:40:00',2.26),('15128','2013-08-15','17:45:00',2.1),('15128','2013-08-15','17:50:00',2.04),('15128','2013-08-15','17:55:00',1.96),('15128','2013-08-15','18:00:00',1.86),('15128','2013-08-15','18:05:00',1.8),('15128','2013-08-15','18:10:00',1.69),('15128','2013-08-15','18:15:00',1.62),('15128','2013-08-15','18:20:00',1.51),('15128','2013-08-15','18:25:00',1.11),('15128','2013-08-15','18:40:00',1.06),('15128','2013-08-15','18:45:00',1.14),('15128','2013-08-15','18:50:00',1.04),('15128','2013-08-14','08:20:00',1.02),('15128','2013-08-14','08:25:00',1.05),('15128','2013-08-14','08:40:00',1.14),('15128','2013-08-14','08:45:00',1.18),('15128','2013-08-14','08:50:00',1.22),('15128','2013-08-14','08:55:00',1.33),('15128','2013-08-14','09:00:00',1.4),('15128','2013-08-14','09:05:00',1.48),('15128','2013-08-14','09:10:00',1.56),('15128','2013-08-14','09:15:00',1.62),('15128','2013-08-14','09:20:00',1.66),('15128','2013-08-14','09:25:00',1.69),('15128','2013-08-14','09:30:00',1.78),('15128','2013-08-14','09:35:00',1.94),('15128','2013-08-14','09:40:00',2.02),('15128','2013-08-14','09:45:00',1.98),('15128','2013-08-14','09:50:00',1.99),('15128','2013-08-14','09:55:00',2.04),('15128','2013-08-14','10:00:00',2.13),('15128','2013-08-14','10:05:00',2.19),('15128','2013-08-14','10:10:00',2.25),('15128','2013-08-14','10:15:00',2.28),('15128','2013-08-14','10:20:00',2.3),('15128','2013-08-14','10:25:00',2.38),('15128','2013-08-14','10:30:00',2.48),('15128','2013-08-14','10:35:00',2.62),('15128','2013-08-14','10:40:00',2.68),('15128','2013-08-14','10:45:00',2.75),('15128','2013-08-14','10:50:00',2.82),('15128','2013-08-14','10:55:00',2.88),('15128','2013-08-14','11:00:00',2.89),('15128','2013-08-14','11:05:00',2.92),('15128','2013-08-14','11:10:00',3.03),('15128','2013-08-14','11:15:00',3.1),('15128','2013-08-14','11:20:00',3.06),('15128','2013-08-14','11:25:00',2.96),('15128','2013-08-14','11:30:00',3.03),('15128','2013-08-14','11:35:00',3.03),('15128','2013-08-14','11:40:00',3.3),('15128','2013-08-14','11:45:00',3.28),('15128','2013-08-14','11:50:00',2.45),('15128','2013-08-14','11:55:00',2.39),('15128','2013-08-14','12:00:00',2.71),('15128','2013-08-14','12:05:00',3.22),('15128','2013-08-14','12:10:00',3.58),('15128','2013-08-14','12:15:00',3.76),('15128','2013-08-14','12:20:00',3.78),('15128','2013-08-14','12:25:00',3.73),('15128','2013-08-14','12:30:00',3.89),('15128','2013-08-14','12:35:00',4.03),('15128','2013-08-14','12:40:00',4.07),('15128','2013-08-14','12:45:00',4.05),('15128','2013-08-14','12:50:00',4.06),('15128','2013-08-14','12:55:00',3.92),('15128','2013-08-14','13:00:00',3.84),('15128','2013-08-14','13:05:00',3.76),('15128','2013-08-14','13:10:00',3.74),('15128','2013-08-14','13:15:00',3.86),('15128','2013-08-14','13:20:00',3.85),('15128','2013-08-14','13:25:00',3.78),('15128','2013-08-14','13:30:00',3.73),('15128','2013-08-14','13:35:00',3.75),('15128','2013-08-14','13:40:00',4.06),('15128','2013-08-14','13:45:00',4.13),('15128','2013-08-14','13:50:00',4.08),('15128','2013-08-14','13:55:00',3.89),('15128','2013-08-14','14:00:00',3.99),('15128','2013-08-14','14:05:00',3.97),('15128','2013-08-14','14:10:00',3.76),('15128','2013-08-14','14:15:00',3.16),('15128','2013-08-14','14:20:00',3.96),('15128','2013-08-14','14:25:00',3.99),('15128','2013-08-14','14:30:00',3.9),('15128','2013-08-14','14:35:00',3.98),('15128','2013-08-14','14:40:00',3.94),('15128','2013-08-14','14:45:00',3.88),('15128','2013-08-14','14:50:00',3.69),('15128','2013-08-14','14:55:00',3.8),('15128','2013-08-14','15:00:00',3.8),('15128','2013-08-14','15:05:00',3.77),('15128','2013-08-14','15:10:00',3.63),('15128','2013-08-14','15:15:00',3.74),('15128','2013-08-14','15:20:00',3.68),('15128','2013-08-14','15:25:00',3.77),('15128','2013-08-14','15:30:00',3.69),('15128','2013-08-14','15:35:00',2.43),('15128','2013-08-14','15:40:00',3.65),('15128','2013-08-14','15:45:00',3.57),('15128','2013-08-14','15:50:00',3.55),('15128','2013-08-14','15:55:00',3.49),('15128','2013-08-14','16:00:00',3.4),('15128','2013-08-14','16:05:00',3.37),('15128','2013-08-14','16:10:00',3.38),('15128','2013-08-14','16:15:00',3.35),('15128','2013-08-14','16:20:00',3.3),('15128','2013-08-14','16:25:00',3.23),('15128','2013-08-14','16:30:00',3.17),('15128','2013-08-14','16:35:00',3.2),('15128','2013-08-14','16:40:00',3.11),('15128','2013-08-14','16:45:00',3.04),('15128','2013-08-14','16:50:00',2.95),('15128','2013-08-14','16:55:00',2.88),('15128','2013-08-14','17:00:00',2.86),('15128','2013-08-14','17:05:00',2.75),('15128','2013-08-14','17:10:00',2.68),('15128','2013-08-14','17:15:00',2.62),('15128','2013-08-14','17:20:00',2.55),('15128','2013-08-14','17:25:00',2.48),('15128','2013-08-14','17:30:00',2.38),('15128','2013-08-14','17:35:00',2.23),('15128','2013-08-14','17:40:00',2.14),('15128','2013-08-14','17:45:00',2.06),('15128','2013-08-14','17:50:00',1.95),('15128','2013-08-14','17:55:00',1.82),('15128','2013-08-14','18:00:00',1.71),('15128','2013-08-14','18:05:00',1.67),('15128','2013-08-14','18:10:00',1.58),('15128','2013-08-14','18:15:00',1.51),('15128','2013-08-14','18:20:00',1.46),('15128','2013-08-14','18:25:00',1.4),('15128','2013-08-14','18:30:00',1.32),('15128','2013-08-14','18:35:00',1.12),('15128','2013-08-13','08:35:00',1.01),('15128','2013-08-13','08:40:00',1.12),('15128','2013-08-13','08:45:00',1.05),('15128','2013-08-13','08:50:00',1.14),('15128','2013-08-13','08:55:00',1.29),('15128','2013-08-13','09:00:00',1.37),('15128','2013-08-13','09:05:00',1.43),('15128','2013-08-13','09:10:00',1.57),('15128','2013-08-13','09:15:00',1.76),('15128','2013-08-13','09:20:00',2.01),('15128','2013-08-13','09:25:00',2.07),('15128','2013-08-13','09:30:00',1.99),('15128','2013-08-13','09:35:00',1.71),('15128','2013-08-13','09:40:00',1.07),('15128','2013-08-13','09:45:00',1.21),('15128','2013-08-13','09:50:00',1.99),('15128','2013-08-13','09:55:00',2.59),('15128','2013-08-13','10:00:00',2.71),('15128','2013-08-13','10:05:00',1.77),('15128','2013-08-13','10:10:00',2.03),('15128','2013-08-13','10:15:00',2.32),('15128','2013-08-13','10:20:00',1.63),('15128','2013-08-13','10:25:00',2.29),('15128','2013-08-13','10:30:00',2.84),('15128','2013-08-13','10:35:00',3.1),('15128','2013-08-13','10:40:00',2.72),('15128','2013-08-13','10:45:00',1.26),('15128','2013-08-13','10:50:00',1.08),('15128','2013-08-13','10:55:00',1.04),('15128','2013-08-13','11:00:00',1.67),('15128','2013-08-13','11:05:00',3.26),('15128','2013-08-13','11:10:00',3.28),('15128','2013-08-13','11:15:00',3.33),('15128','2013-08-13','11:20:00',3.39),('15128','2013-08-13','11:25:00',2.19),('15128','2013-08-13','11:30:00',1.09),('15128','2013-08-13','11:35:00',1.04),('15128','2013-08-13','11:40:00',1.1),('15128','2013-08-13','11:45:00',1.25),('15128','2013-08-13','11:50:00',2.07),('15128','2013-08-13','11:55:00',2.47),('15128','2013-08-13','12:00:00',1.75),('15128','2013-08-13','12:05:00',2.31),('15128','2013-08-13','12:10:00',1.61),('15128','2013-08-13','12:15:00',1.8),('15128','2013-08-13','12:20:00',2.63),('15128','2013-08-13','12:25:00',4.41),('15128','2013-08-13','12:30:00',4.26),('15128','2013-08-13','12:35:00',4.11),('15128','2013-08-13','12:40:00',3.83),('15128','2013-08-13','12:45:00',2.27),('15128','2013-08-13','12:50:00',1.58),('15128','2013-08-13','12:55:00',2.9),('15128','2013-08-13','13:00:00',3.54),('15128','2013-08-13','13:05:00',3.47),('15128','2013-08-13','13:10:00',3.69),('15128','2013-08-13','13:15:00',3.99),('15128','2013-08-13','13:20:00',3.99),('15128','2013-08-13','13:25:00',2.44),('15128','2013-08-13','13:30:00',4.48),('15128','2013-08-13','13:35:00',4.14),('15128','2013-08-13','13:40:00',4.11),('15128','2013-08-13','13:45:00',3.58),('15128','2013-08-13','13:50:00',4.14),('15128','2013-08-13','13:55:00',3.26),('15128','2013-08-13','14:00:00',2.64),('15128','2013-08-13','14:05:00',3.73),('15128','2013-08-13','14:10:00',3.2),('15128','2013-08-13','14:15:00',4.29),('15128','2013-08-13','14:20:00',4.19),('15128','2013-08-13','14:25:00',4.16),('15128','2013-08-13','14:30:00',4.08),('15128','2013-08-13','14:35:00',4.09),('15128','2013-08-13','14:40:00',4.08),('15128','2013-08-13','14:45:00',4.01),('15128','2013-08-13','14:50:00',4),('15128','2013-08-13','14:55:00',4),('15128','2013-08-13','15:00:00',3.95),('15128','2013-08-13','15:05:00',3.94),('15128','2013-08-13','15:10:00',3.91),('15128','2013-08-13','15:15:00',3.88),('15128','2013-08-13','15:20:00',3.86),('15128','2013-08-13','15:25:00',3.86),('15128','2013-08-13','15:30:00',3.8),('15128','2013-08-13','15:35:00',3.76),('15128','2013-08-13','15:40:00',3.72),('15128','2013-08-13','15:45:00',3.68),('15128','2013-08-13','15:50:00',3.66),('15128','2013-08-13','15:55:00',3.63),('15128','2013-08-13','16:00:00',3.61),('15128','2013-08-13','16:05:00',3.54),('15128','2013-08-13','16:10:00',3.5),('15128','2013-08-13','16:15:00',3.49),('15128','2013-08-13','16:20:00',3.44),('15128','2013-08-13','16:25:00',3.41),('15128','2013-08-13','16:30:00',3.34),('15128','2013-08-13','16:35:00',3.28),('15128','2013-08-13','16:40:00',3.21),('15128','2013-08-13','16:45:00',3.17),('15128','2013-08-13','16:50:00',3.12),('15128','2013-08-13','16:55:00',3.03),('15128','2013-08-13','17:00:00',2.97),('15128','2013-08-13','17:05:00',2.86),('15128','2013-08-13','17:10:00',2.83),('15128','2013-08-13','17:15:00',2.74),('15128','2013-08-13','17:20:00',2.67),('15128','2013-08-13','17:25:00',2.62),('15128','2013-08-13','17:30:00',2.5),('15128','2013-08-13','17:35:00',2.41),('15128','2013-08-13','17:40:00',2.32),('15128','2013-08-13','17:45:00',2.2),('15128','2013-08-13','17:50:00',2.02),('15128','2013-08-13','17:55:00',2.01),('15128','2013-08-13','18:00:00',1.88),('15128','2013-08-13','18:05:00',1.77),('15128','2013-08-13','18:10:00',1.69),('15128','2013-08-13','18:15:00',1.63),('15128','2013-08-13','18:20:00',1.58),('15128','2013-08-13','18:25:00',1.53),('15128','2013-08-13','18:30:00',1.49),('15128','2013-08-13','18:35:00',1.4),('15128','2013-08-13','18:40:00',1.25),('15128','2013-08-13','18:45:00',1.18),('15128','2013-08-13','18:50:00',1.16),('15128','2013-08-13','18:55:00',1.12),('15128','2013-08-13','19:00:00',1.1),('15128','2013-08-13','19:05:00',1.04),('15128','2013-08-12','08:30:00',1.04),('15128','2013-08-12','08:35:00',1.1),('15128','2013-08-12','08:40:00',1.15),('15128','2013-08-12','08:45:00',1.2),('15128','2013-08-12','08:50:00',1.28),('15128','2013-08-12','08:55:00',1.35),('15128','2013-08-12','09:00:00',1.42),('15128','2013-08-12','09:05:00',1.49),('15128','2013-08-12','09:10:00',1.56),('15128','2013-08-12','09:15:00',1.63),('15128','2013-08-12','09:20:00',1.7),('15128','2013-08-12','09:25:00',1.74),('15128','2013-08-12','09:30:00',1.78),('15128','2013-08-12','09:35:00',1.87),('15128','2013-08-12','09:40:00',1.92),('15128','2013-08-12','09:45:00',1.92),('15128','2013-08-12','09:50:00',1.99),('15128','2013-08-12','09:55:00',2.05),('15128','2013-08-12','10:00:00',2.27),('15128','2013-08-12','10:05:00',2.37),('15128','2013-08-12','10:10:00',2.43),('15128','2013-08-12','10:15:00',2.35),('15128','2013-08-12','10:20:00',2.5),('15128','2013-08-12','10:25:00',2.49),('15128','2013-08-12','10:30:00',2.81),('15128','2013-08-12','10:35:00',2.79),('15128','2013-08-12','10:40:00',1.64),('15128','2013-08-12','10:45:00',1.65),('15128','2013-08-12','10:50:00',2.28),('15128','2013-08-12','10:55:00',2.74),('15128','2013-08-12','11:00:00',2.84),('15128','2013-08-12','11:05:00',3.08),('15128','2013-08-12','11:10:00',1.69),('15128','2013-08-12','11:15:00',2.39),('15128','2013-08-12','11:20:00',3.01),('15128','2013-08-12','11:25:00',3.16),('15128','2013-08-12','11:30:00',3.11),('15128','2013-08-12','11:35:00',3.19),('15128','2013-08-12','11:40:00',3.26),('15128','2013-08-12','11:45:00',3.41),('15128','2013-08-12','11:50:00',3.53),('15128','2013-08-12','11:55:00',3.1),('15128','2013-08-12','12:00:00',2.93),('15128','2013-08-12','12:05:00',2.95),('15128','2013-08-12','12:10:00',3.18),('15128','2013-08-12','12:15:00',4.03),('15128','2013-08-12','12:20:00',1.4),('15128','2013-08-12','12:25:00',2.04),('15128','2013-08-12','12:30:00',4.3),('15128','2013-08-12','12:35:00',4.33),('15128','2013-08-12','12:40:00',4.38),('15128','2013-08-12','12:45:00',3.16),('15128','2013-08-12','12:50:00',2.94),('15128','2013-08-12','12:55:00',4.67),('15128','2013-08-12','13:00:00',4.48),('15128','2013-08-12','13:05:00',4.35),('15128','2013-08-12','13:10:00',4.09),('15128','2013-08-12','13:15:00',4.02),('15128','2013-08-12','13:20:00',4.05),('15128','2013-08-12','13:25:00',3.99),('15128','2013-08-12','13:30:00',4.06),('15128','2013-08-12','13:35:00',4.05),('15128','2013-08-12','13:40:00',3.98),('15128','2013-08-12','13:45:00',3.98),('15128','2013-08-12','13:50:00',3.92),('15128','2013-08-12','13:55:00',3.95),('15128','2013-08-12','14:00:00',4.02),('15128','2013-08-12','14:05:00',3.93),('15128','2013-08-12','14:10:00',4.05),('15128','2013-08-12','14:15:00',4.07),('15128','2013-08-12','14:20:00',4.04),('15128','2013-08-12','14:25:00',4.01),('15128','2013-08-12','14:30:00',4.09),('15128','2013-08-12','14:35:00',4.05),('15128','2013-08-12','14:40:00',4.07),('15128','2013-08-12','14:45:00',4.03),('15128','2013-08-12','14:50:00',4.01),('15128','2013-08-12','14:55:00',4.02),('15128','2013-08-12','15:00:00',3.98),('15128','2013-08-12','15:05:00',3.96),('15128','2013-08-12','15:10:00',3.96),('15128','2013-08-12','15:15:00',3.94),('15128','2013-08-12','15:20:00',3.88),('15128','2013-08-12','15:25:00',3.86),('15128','2013-08-12','15:30:00',3.86),('15128','2013-08-12','15:35:00',3.8),('15128','2013-08-12','15:40:00',3.79),('15128','2013-08-12','15:45:00',3.76),('15128','2013-08-12','15:50:00',3.73),('15128','2013-08-12','15:55:00',3.64),('15128','2013-08-12','16:00:00',3.6),('15128','2013-08-12','16:05:00',3.61),('15128','2013-08-12','16:10:00',3.54),('15128','2013-08-12','16:15:00',3.48),('15128','2013-08-12','16:20:00',3.43),('15128','2013-08-12','16:25:00',3.38),('15128','2013-08-12','16:30:00',3.32),('15128','2013-08-12','16:35:00',3.24),('15128','2013-08-12','16:40:00',3.19),('15128','2013-08-12','16:45:00',3.16),('15128','2013-08-12','16:50:00',3.11),('15128','2013-08-12','16:55:00',3.06),('15128','2013-08-12','17:00:00',3),('15128','2013-08-12','17:05:00',2.92),('15128','2013-08-12','17:10:00',2.84),('15128','2013-08-12','17:15:00',2.78),('15128','2013-08-12','17:20:00',2.7),('15128','2013-08-12','17:25:00',2.6),('15128','2013-08-12','17:30:00',2.49),('15128','2013-08-12','17:35:00',2.45),('15128','2013-08-12','17:40:00',2.34),('15128','2013-08-12','17:45:00',2.23),('15128','2013-08-12','17:50:00',2.07),('15128','2013-08-12','17:55:00',2.02),('15128','2013-08-12','18:00:00',1.91),('15128','2013-08-12','18:05:00',1.77),('15128','2013-08-12','18:10:00',1.69),('15128','2013-08-12','18:15:00',1.63),('15128','2013-08-12','18:20:00',1.59),('15128','2013-08-12','18:25:00',1.52),('15128','2013-08-12','18:30:00',1.43),('15128','2013-08-12','18:35:00',1.34),('15128','2013-08-12','18:40:00',1.24),('15128','2013-08-12','18:45:00',1.17),('15128','2013-08-12','18:50:00',1.08),('15128','2013-08-11','08:30:00',1.02),('15128','2013-08-11','08:35:00',1.07),('15128','2013-08-11','08:40:00',1.12),('15128','2013-08-11','08:45:00',1.18),('15128','2013-08-11','08:50:00',1.26),('15128','2013-08-11','08:55:00',1.33),('15128','2013-08-11','09:00:00',1.41),('15128','2013-08-11','09:05:00',1.48),('15128','2013-08-11','09:10:00',1.55),('15128','2013-08-11','09:15:00',1.62),('15128','2013-08-11','09:20:00',1.7),('15128','2013-08-11','09:25:00',1.75),('15128','2013-08-11','09:30:00',1.82),('15128','2013-08-11','09:35:00',1.9),('15128','2013-08-11','09:40:00',1.92),('15128','2013-08-11','09:45:00',1.92),('15128','2013-08-11','09:50:00',1.95),('15128','2013-08-11','09:55:00',1.99),('15128','2013-08-11','10:00:00',2.09),('15128','2013-08-11','10:05:00',2.14),('15128','2013-08-11','10:10:00',2.22),('15128','2013-08-11','10:15:00',2.28),('15128','2013-08-11','10:20:00',2.32),('15128','2013-08-11','10:25:00',2.36),('15128','2013-08-11','10:30:00',2.47),('15128','2013-08-11','10:35:00',2.47),('15128','2013-08-11','10:40:00',2.52),('15128','2013-08-11','10:45:00',2.54),('15128','2013-08-11','10:50:00',2.65),('15128','2013-08-11','10:55:00',2.77),('15128','2013-08-11','11:00:00',2.81),('15128','2013-08-11','11:05:00',2.9),('15128','2013-08-11','11:10:00',2.93),('15128','2013-08-11','11:15:00',2.98),('15128','2013-08-11','11:20:00',3.03),('15128','2013-08-11','11:25:00',3.09),('15128','2013-08-11','11:30:00',3.24),('15128','2013-08-11','11:35:00',3.29),('15128','2013-08-11','11:40:00',3.36),('15128','2013-08-11','11:45:00',3.21),('15128','2013-08-11','11:50:00',3.34),('15128','2013-08-11','11:55:00',2.19),('15128','2013-08-11','12:00:00',1.55),('15128','2013-08-11','12:05:00',1.21),('15128','2013-08-11','12:10:00',1.26),('15128','2013-08-11','12:15:00',1.73),('15128','2013-08-11','12:20:00',3.64),('15128','2013-08-11','12:25:00',4.07),('15128','2013-08-11','12:30:00',4.13),('15128','2013-08-11','12:35:00',4.24),('15128','2013-08-11','12:40:00',4.02),('15128','2013-08-11','12:45:00',4.12),('15128','2013-08-11','12:50:00',4.11),('15128','2013-08-11','12:55:00',2.26),('15128','2013-08-11','13:00:00',2.06),('15128','2013-08-11','13:05:00',1.95),('15128','2013-08-11','13:10:00',1.83),('15128','2013-08-11','13:15:00',1.89),('15128','2013-08-11','13:20:00',2.44),('15128','2013-08-11','13:25:00',1.62),('15128','2013-08-11','13:30:00',2.69),('15128','2013-08-11','13:35:00',3.09),('15128','2013-08-11','13:40:00',2.58),('15128','2013-08-11','13:45:00',2.13),('15128','2013-08-11','13:50:00',3.52),('15128','2013-08-11','13:55:00',4.41),('15128','2013-08-11','14:00:00',2.64),('15128','2013-08-11','14:05:00',3.59),('15128','2013-08-11','14:10:00',4.64),('15128','2013-08-11','14:15:00',3.39),('15128','2013-08-11','14:20:00',3.13),('15128','2013-08-11','14:25:00',3.59),('15128','2013-08-11','14:30:00',4.64),('15128','2013-08-11','14:35:00',4.58),('15128','2013-08-11','14:40:00',4.13),('15128','2013-08-11','14:45:00',4.12),('15128','2013-08-11','14:50:00',4.07),('15128','2013-08-11','14:55:00',4.06),('15128','2013-08-11','15:00:00',4.06),('15128','2013-08-11','15:05:00',3.95),('15128','2013-08-11','15:10:00',3.98),('15128','2013-08-11','15:15:00',3.89),('15128','2013-08-11','15:20:00',3.78),('15128','2013-08-11','15:25:00',3.91),('15128','2013-08-11','15:30:00',3.78),('15128','2013-08-11','15:35:00',3.81),('15128','2013-08-11','15:40:00',3.73),('15128','2013-08-11','15:45:00',3.19),('15128','2013-08-11','15:50:00',3.69),('15128','2013-08-11','15:55:00',3.58),('15128','2013-08-11','16:00:00',3.56),('15128','2013-08-11','16:05:00',3.53),('15128','2013-08-11','16:10:00',3.52),('15128','2013-08-11','16:15:00',3.47),('15128','2013-08-11','16:20:00',3.41),('15128','2013-08-11','16:25:00',3.38),('15128','2013-08-11','16:30:00',3.28),('15128','2013-08-11','16:35:00',3.2),('15128','2013-08-11','16:40:00',3.2),('15128','2013-08-11','16:45:00',3.18),('15128','2013-08-11','16:50:00',3.12),('15128','2013-08-11','16:55:00',3.05),('15128','2013-08-11','17:00:00',2.96),('15128','2013-08-11','17:05:00',2.86),('15128','2013-08-11','17:10:00',2.81),('15128','2013-08-11','17:15:00',2.75),('15128','2013-08-11','17:20:00',2.66),('15128','2013-08-11','17:25:00',2.57),('15128','2013-08-11','17:30:00',2.49),('15128','2013-08-11','17:35:00',2.38),('15128','2013-08-11','17:40:00',2.31),('15128','2013-08-11','17:45:00',2.21),('15128','2013-08-11','17:50:00',2.08),('15128','2013-08-11','17:55:00',1.96),('15128','2013-08-11','18:00:00',1.89),('15128','2013-08-11','18:05:00',1.78),('15128','2013-08-11','18:10:00',1.73),('15128','2013-08-11','18:15:00',1.65),('15128','2013-08-11','18:20:00',1.6),('15128','2013-08-11','18:25:00',1.55),('15128','2013-08-11','18:30:00',1.47),('15128','2013-08-11','18:35:00',1.4),('15128','2013-08-11','18:40:00',1.3),('15128','2013-08-11','18:45:00',1.22),('15128','2013-08-11','18:50:00',1.12),('15128','2013-08-11','18:55:00',1.01),('15128','2013-08-10','08:30:00',1.05),('15128','2013-08-10','08:35:00',1.1),('15128','2013-08-10','08:40:00',1.16),('15128','2013-08-10','08:45:00',1.23),('15128','2013-08-10','08:50:00',1.31),('15128','2013-08-10','08:55:00',1.39),('15128','2013-08-10','09:00:00',1.45),('15128','2013-08-10','09:05:00',1.52),('15128','2013-08-10','09:10:00',1.6),('15128','2013-08-10','09:15:00',1.66),('15128','2013-08-10','09:20:00',1.76),('15128','2013-08-10','09:25:00',1.82),('15128','2013-08-10','09:30:00',1.88),('15128','2013-08-10','09:35:00',1.92),('15128','2013-08-10','09:40:00',1.93),('15128','2013-08-10','09:45:00',1.96),('15128','2013-08-10','09:50:00',2.01),('15128','2013-08-10','09:55:00',2.07),('15128','2013-08-10','10:00:00',2.16),('15128','2013-08-10','10:05:00',2.22),('15128','2013-08-10','10:10:00',2.29),('15128','2013-08-10','10:15:00',2.34),('15128','2013-08-10','10:20:00',2.38),('15128','2013-08-10','10:25:00',2.51),('15128','2013-08-10','10:30:00',2.59),('15128','2013-08-10','10:35:00',2.65),('15128','2013-08-10','10:40:00',2.72),('15128','2013-08-10','10:45:00',2.73),('15128','2013-08-10','10:50:00',2.77),('15128','2013-08-10','10:55:00',2.74),('15128','2013-08-10','11:00:00',2.87),('15128','2013-08-10','11:05:00',2.97),('15128','2013-08-10','11:10:00',3.03),('15128','2013-08-10','11:15:00',3.07),('15128','2013-08-10','11:20:00',3.16),('15128','2013-08-10','11:25:00',3.2),('15128','2013-08-10','11:30:00',3.21),('15128','2013-08-10','11:35:00',3.27),('15128','2013-08-10','11:40:00',3.24),('15128','2013-08-10','11:45:00',3.27),('15128','2013-08-10','11:50:00',3.45),('15128','2013-08-10','11:55:00',3.54),('15128','2013-08-10','12:00:00',3.68),('15128','2013-08-10','12:05:00',3.72),('15128','2013-08-10','12:10:00',3.74),('15128','2013-08-10','12:15:00',3.77),('15128','2013-08-10','12:20:00',3.8),('15128','2013-08-10','12:25:00',3.81),('15128','2013-08-10','12:30:00',3.85),('15128','2013-08-10','12:35:00',3.88),('15128','2013-08-10','12:40:00',3.94),('15128','2013-08-10','12:45:00',3.95),('15128','2013-08-10','12:50:00',3.95),('15128','2013-08-10','12:55:00',3.97),('15128','2013-08-10','13:00:00',4),('15128','2013-08-10','13:05:00',4.02),('15128','2013-08-10','13:10:00',3.98),('15128','2013-08-10','13:15:00',3.99),('15128','2013-08-10','13:20:00',3.99),('15128','2013-08-10','13:25:00',3.98),('15128','2013-08-10','13:30:00',4.03),('15128','2013-08-10','13:35:00',4.08),('15128','2013-08-10','13:40:00',4.06),('15128','2013-08-10','13:45:00',4.06),('15128','2013-08-10','13:50:00',4.02),('15128','2013-08-10','13:55:00',4.03),('15128','2013-08-10','14:00:00',4.04),('15128','2013-08-10','14:05:00',4.04),('15128','2013-08-10','14:10:00',4.04),('15128','2013-08-10','14:15:00',4.06),('15128','2013-08-10','14:20:00',4.05),('15128','2013-08-10','14:25:00',4.02),('15128','2013-08-10','14:30:00',4),('15128','2013-08-10','14:35:00',4),('15128','2013-08-10','14:40:00',4),('15128','2013-08-10','14:45:00',3.97),('15128','2013-08-10','14:50:00',3.93),('15128','2013-08-10','14:55:00',3.89),('15128','2013-08-10','15:00:00',3.88),('15128','2013-08-10','15:05:00',3.88),('15128','2013-08-10','15:10:00',3.88),('15128','2013-08-10','15:15:00',3.85),('15128','2013-08-10','15:20:00',3.8),('15128','2013-08-10','15:25:00',3.71),('15128','2013-08-10','15:30:00',3.76),('15128','2013-08-10','15:35:00',3.76),('15128','2013-08-10','15:40:00',3.75),('15128','2013-08-10','15:45:00',3.72),('15128','2013-08-10','15:50:00',3.67),('15128','2013-08-10','15:55:00',3.66),('15128','2013-08-10','16:00:00',3.63),('15128','2013-08-10','16:05:00',3.57),('15128','2013-08-10','16:10:00',3.53),('15128','2013-08-10','16:15:00',3.48),('15128','2013-08-10','16:20:00',3.42),('15128','2013-08-10','16:25:00',3.36),('15128','2013-08-10','16:30:00',3.24),('15128','2013-08-10','16:35:00',3.21),('15128','2013-08-10','16:40:00',3.16),('15128','2013-08-10','16:45:00',3.1),('15128','2013-08-10','16:50:00',3.01),('15128','2013-08-10','16:55:00',2.98),('15128','2013-08-10','17:00:00',2.91),('15128','2013-08-10','17:05:00',2.87),('15128','2013-08-10','17:10:00',2.8),('15128','2013-08-10','17:15:00',2.73),('15128','2013-08-10','17:20:00',2.66),('15128','2013-08-10','17:25:00',2.59),('15128','2013-08-10','17:30:00',2.51),('15128','2013-08-10','17:35:00',2.43),('15128','2013-08-10','17:40:00',2.32),('15128','2013-08-10','17:45:00',2.21),('15128','2013-08-10','17:50:00',2.12),('15128','2013-08-10','17:55:00',1.99),('15128','2013-08-10','18:00:00',1.88),('15128','2013-08-10','18:05:00',1.77),('15128','2013-08-10','18:10:00',1.7),('15128','2013-08-10','18:15:00',1.61),('15128','2013-08-10','18:20:00',1.54),('15128','2013-08-10','18:25:00',1.49),('15128','2013-08-10','18:30:00',1.43),('15128','2013-08-10','18:35:00',1.36),('15128','2013-08-10','18:40:00',1.26),('15128','2013-08-10','18:45:00',1.16),('15128','2013-08-10','18:50:00',1.05),('15128','2013-08-09','08:25:00',1.01),('15128','2013-08-09','08:30:00',1.08),('15128','2013-08-09','08:35:00',1.14),('15128','2013-08-09','08:40:00',1.2),('15128','2013-08-09','08:45:00',1.27),('15128','2013-08-09','08:50:00',1.35),('15128','2013-08-09','08:55:00',1.42),('15128','2013-08-09','09:00:00',1.47),('15128','2013-08-09','09:05:00',1.53),('15128','2013-08-09','09:10:00',1.62),('15128','2013-08-09','09:15:00',1.69),('15128','2013-08-09','09:20:00',1.77),('15128','2013-08-09','09:25:00',1.85),('15128','2013-08-09','09:30:00',1.92),('15128','2013-08-09','09:35:00',1.95),('15128','2013-08-09','09:40:00',1.94),('15128','2013-08-09','09:45:00',2),('15128','2013-08-09','09:50:00',2),('15128','2013-08-09','09:55:00',2.06),('15128','2013-08-09','10:00:00',2.18),('15128','2013-08-09','10:05:00',2.23),('15128','2013-08-09','10:10:00',2.29),('15128','2013-08-09','10:15:00',2.36),('15128','2013-08-09','10:20:00',2.47),('15128','2013-08-09','10:25:00',2.55),('15128','2013-08-09','10:30:00',2.63),('15128','2013-08-09','10:35:00',2.66),('15128','2013-08-09','10:40:00',2.71),('15128','2013-08-09','10:45:00',2.74),('15128','2013-08-09','10:50:00',2.82),('15128','2013-08-09','10:55:00',2.87),('15128','2013-08-09','11:00:00',3.01),('15128','2013-08-09','11:05:00',3.05),('15128','2013-08-09','11:10:00',3.11),('15128','2013-08-09','11:15:00',3.14),('15128','2013-08-09','11:20:00',3.16),('15128','2013-08-09','11:25:00',3.2),('15128','2013-08-09','11:30:00',3.17),('15128','2013-08-09','11:35:00',3.21),('15128','2013-08-09','11:40:00',3.31),('15128','2013-08-09','11:45:00',3.3),('15128','2013-08-09','11:50:00',3.45),('15128','2013-08-09','11:55:00',3.61),('15128','2013-08-09','12:00:00',3.8),('15128','2013-08-09','12:05:00',3.77),('15128','2013-08-09','12:10:00',3.79),('15128','2013-08-09','12:15:00',3.82),('15128','2013-08-09','12:20:00',3.87),('15128','2013-08-09','12:25:00',3.84),('15128','2013-08-09','12:30:00',3.94),('15128','2013-08-09','12:35:00',4.06),('15128','2013-08-09','12:40:00',4.08),('15128','2013-08-09','12:45:00',4.4),('15128','2013-08-09','12:50:00',4.22),('15128','2013-08-09','12:55:00',3.85),('15128','2013-08-09','13:00:00',4.05),('15128','2013-08-09','13:05:00',4.03),('15128','2013-08-09','13:10:00',2.72),('15128','2013-08-09','13:15:00',3.82),('15128','2013-08-09','13:20:00',2.18),('15128','2013-08-09','13:30:00',4.41),('15128','2013-08-09','13:35:00',4.71),('15128','2013-08-09','13:40:00',2.49),('15128','2013-08-09','13:45:00',1.01),('15128','2013-08-09','13:50:00',2.07),('15128','2013-08-09','13:55:00',4.73),('15128','2013-08-09','14:00:00',4.08),('15128','2013-08-09','14:05:00',4.71),('15128','2013-08-09','14:10:00',3.13),('15128','2013-08-09','14:55:00',1.07),('15128','2013-08-09','15:15:00',1.08),('15128','2013-08-09','15:25:00',1.05),('15128','2013-08-09','15:30:00',1.2),('15128','2013-08-09','15:35:00',1.34),('15128','2013-08-09','15:40:00',1.73),('15128','2013-08-09','15:45:00',2.21),('15128','2013-08-09','15:50:00',2),('15128','2013-08-09','15:55:00',2.53),('15128','2013-08-09','16:00:00',1.86),('15128','2013-08-09','16:05:00',1.19),('15128','2013-08-09','16:10:00',1.07),('15128','2013-08-09','16:15:00',1.06),('15128','2013-08-09','16:20:00',1.73),('15128','2013-08-09','16:25:00',1.59),('15128','2013-08-09','16:30:00',1.52),('15128','2013-08-09','16:35:00',1.38),('15128','2013-08-09','16:40:00',1.09),('15128','2013-08-09','16:45:00',1.53),('15128','2013-08-09','16:50:00',2.76),('15128','2013-08-09','16:55:00',3.49),('15128','2013-08-09','17:00:00',2.45),('15128','2013-08-09','17:05:00',2.08),('15128','2013-08-09','17:10:00',1.16),('15128','2013-08-09','17:15:00',1.17),('15128','2013-08-09','17:20:00',1.18),('15128','2013-08-09','17:25:00',1.55),('15128','2013-08-09','17:30:00',1.07),('15128','2014-04-08','10:25:00',1.3),('15128','2014-04-08','10:40:00',1.66),('15128','2014-04-08','10:45:00',2.72),('15128','2014-04-08','10:50:00',2.92),('15128','2014-04-08','10:55:00',3.1),('15128','2014-04-08','11:00:00',3.26),('15128','2014-04-08','11:05:00',2.12),('15128','2014-04-08','11:10:00',2.01),('15128','2014-04-08','11:15:00',1.45),('15128','2014-04-08','11:20:00',1.38),('15128','2014-04-08','11:25:00',1.35),('15128','2014-04-08','11:30:00',2.48),('15128','2014-04-08','11:35:00',3.54),('15128','2014-04-08','11:40:00',2.06),('15128','2014-04-08','11:45:00',1.05),('15128','2014-04-08','11:50:00',1.11),('15128','2014-04-08','11:55:00',1.21),('15128','2014-04-08','12:00:00',1.52),('15128','2014-04-08','12:05:00',1.4),('15128','2014-04-08','12:10:00',1.17),('15128','2014-04-08','12:25:00',1.21),('15128','2014-04-08','12:30:00',1.08),('15128','2014-04-08','12:35:00',1.2),('15128','2014-04-08','12:40:00',1.23),('15128','2014-04-08','12:45:00',1.12),('15128','2014-04-08','13:10:00',1.03),('15128','2014-04-08','13:15:00',1.05),('15128','2014-04-08','13:20:00',1.19),('15128','2014-04-08','13:25:00',1.22),('15128','2014-04-08','13:30:00',1.28),('15128','2014-04-08','13:35:00',1.37),('15128','2014-04-08','13:40:00',1.66),('15128','2014-04-08','13:45:00',1.55),('15128','2014-04-08','13:50:00',1.43),('15128','2014-04-08','13:55:00',1.92),('15128','2014-04-08','14:00:00',1.62),('15128','2014-04-08','14:05:00',1.51),('15128','2014-04-08','14:10:00',1.82),('15128','2014-04-08','14:15:00',3.56),('15128','2014-04-08','14:20:00',2.97),('15128','2014-04-08','14:25:00',3.06),('15128','2014-04-08','14:30:00',2.18),('15128','2014-04-08','14:35:00',3.13),('15128','2014-04-08','14:40:00',4.19),('15128','2014-04-08','14:45:00',1.31),('15128','2014-04-08','14:50:00',1.25),('15128','2014-04-08','15:05:00',1.25),('15128','2014-04-08','15:30:00',1.08),('15128','2014-04-08','15:35:00',1.64),('15128','2014-04-08','15:40:00',3.71),('15128','2014-04-08','15:45:00',3.31),('15128','2014-04-08','15:50:00',3.51),('15128','2014-04-08','15:55:00',3.47),('15128','2014-04-08','16:00:00',3.39),('15128','2014-04-08','16:05:00',3.33),('15128','2014-04-08','16:10:00',3.3),('15128','2014-04-08','16:15:00',3.21),('15128','2014-04-08','16:20:00',3.1),('15128','2014-04-08','16:25:00',3.07),('15128','2014-04-08','16:30:00',2.94),('15128','2014-04-08','16:35:00',3),('15128','2014-04-08','16:40:00',2.95),('15128','2014-04-08','16:45:00',2.84),('15128','2014-04-08','16:50:00',2.86),('15128','2014-04-08','16:55:00',2.86),('15128','2014-04-08','17:00:00',1.65),('15128','2014-04-08','17:05:00',2.17),('15128','2014-04-08','17:10:00',2.37),('15128','2014-04-08','17:15:00',2.22),('15128','2014-04-08','17:20:00',1.97),('15128','2014-04-08','17:25:00',1.06),('15128','2014-04-08','17:30:00',1.81),('15128','2014-04-08','17:35:00',2.16),('15128','2014-04-08','17:40:00',1.74),('15128','2014-04-08','17:45:00',1.5),('15128','2014-04-08','17:50:00',1.52),('15128','2014-04-08','17:55:00',1.36),('15128','2014-04-08','18:00:00',1.29),('15128','2014-04-08','18:05:00',1.12),('15128','2014-04-08','18:10:00',1.09),('15128','2013-08-07','08:30:00',1),('15128','2013-08-07','08:35:00',1.06),('15128','2013-08-07','08:40:00',1.09),('15128','2013-08-07','08:45:00',1.15),('15128','2013-08-07','08:50:00',1.24),('15128','2013-08-07','08:55:00',1.3),('15128','2013-08-07','09:00:00',1.35),('15128','2013-08-07','09:05:00',1.41),('15128','2013-08-07','09:10:00',1.48),('15128','2013-08-07','09:15:00',1.55),('15128','2013-08-07','09:20:00',1.62),('15128','2013-08-07','09:25:00',1.69),('15128','2013-08-07','09:30:00',1.77),('15128','2013-08-07','09:35:00',1.79),('15128','2013-08-07','09:40:00',1.76),('15128','2013-08-07','09:45:00',1.78),('15128','2013-08-07','09:50:00',1.83),('15128','2013-08-07','09:55:00',1.9),('15128','2013-08-07','10:00:00',2.02),('15128','2013-08-07','10:05:00',2.06),('15128','2013-08-07','10:10:00',2.13),('15128','2013-08-07','10:15:00',2.21),('15128','2013-08-07','10:20:00',2.29),('15128','2013-08-07','10:25:00',2.35),('15128','2013-08-07','10:30:00',2.37),('15128','2013-08-07','10:35:00',2.41),('15128','2013-08-07','10:40:00',2.48),('15128','2013-08-07','10:45:00',2.53),('15128','2013-08-07','10:50:00',2.55),('15128','2013-08-07','11:05:00',1.05),('15128','2013-08-07','11:10:00',2.72),('15128','2013-08-07','11:15:00',2.87),('15128','2013-08-07','11:20:00',2.84),('15128','2013-08-07','11:25:00',2.22),('15128','2013-08-07','11:30:00',2.94),('15128','2013-08-07','11:35:00',3),('15128','2013-08-07','11:40:00',3.07),('15128','2013-08-06','08:30:00',1.03),('15128','2013-08-06','08:35:00',1.09),('15128','2013-08-06','08:40:00',1.12),('15128','2013-08-06','08:45:00',1.2),('15128','2013-08-06','08:50:00',1.29),('15128','2013-08-06','08:55:00',1.34),('15128','2013-08-06','09:00:00',1.39),('15128','2013-08-06','09:05:00',1.43),('15128','2013-08-06','09:10:00',1.49),('15128','2013-08-06','09:15:00',1.57),('15128','2013-08-06','09:20:00',1.65),('15128','2013-08-06','09:25:00',1.73),('15128','2013-08-06','09:30:00',1.81),('15128','2013-08-06','09:35:00',1.84),('15128','2013-08-06','09:40:00',1.77),('15128','2013-08-06','09:45:00',1.81),('15128','2013-08-06','09:50:00',1.84),('15128','2013-08-06','09:55:00',1.92),('15128','2013-08-06','10:00:00',2.03),('15128','2013-08-06','10:05:00',2.1),('15128','2013-08-06','10:10:00',2.16),('15128','2013-08-06','10:15:00',2.25),('15128','2013-08-06','10:20:00',2.3),('15128','2013-08-06','10:25:00',2.4),('15128','2013-08-06','10:30:00',2.42),('15128','2013-08-06','10:35:00',2.43),('15128','2013-08-06','10:40:00',2.51),('15128','2013-08-06','10:45:00',2.53),('15128','2013-08-06','10:50:00',2.58),('15128','2013-08-06','10:55:00',2.67),('15128','2013-08-06','11:00:00',2.69),('15128','2013-08-06','11:05:00',2.81),('15128','2013-08-06','11:10:00',2.8),('15128','2013-08-06','11:15:00',2.94),('15128','2013-08-06','11:20:00',2.89),('15128','2013-08-06','11:25:00',3.01),('15128','2013-08-06','11:30:00',3.04),('15128','2013-08-06','11:35:00',3.02),('15128','2013-08-06','11:40:00',3.09),('15128','2013-08-06','11:45:00',3.14),('15128','2013-08-06','11:50:00',3.27),('15128','2013-08-06','11:55:00',3.36),('15128','2013-08-06','12:00:00',3.5),('15128','2013-08-06','12:05:00',3.54),('15128','2013-08-06','12:10:00',3.57),('15128','2013-08-06','12:15:00',3.57),('15128','2013-08-06','12:20:00',3.61),('15128','2013-08-06','12:25:00',3.59),('15128','2013-08-06','12:30:00',3.5),('15128','2013-08-06','12:35:00',3.73),('15128','2013-08-06','12:40:00',3.81),('15128','2013-08-06','12:45:00',3.81),('15128','2013-08-06','12:50:00',3.8),('15128','2013-08-06','12:55:00',3.84),('15128','2013-08-06','13:00:00',3.89),('15128','2013-08-06','13:05:00',3.9),('15128','2013-08-06','13:10:00',3.9),('15128','2013-08-06','13:15:00',3.9),('15128','2013-08-06','13:20:00',3.93),('15128','2013-08-06','13:25:00',4),('15128','2013-08-06','13:30:00',3.95),('15128','2013-08-06','13:35:00',3.99),('15128','2013-08-06','13:40:00',4),('15128','2013-08-06','13:45:00',4.01),('15128','2013-08-06','13:50:00',3.94),('15128','2013-08-06','13:55:00',3.96),('15128','2013-08-06','14:00:00',3.96),('15128','2013-08-06','14:05:00',3.96),('15128','2013-08-06','14:10:00',3.96),('15128','2013-08-06','14:15:00',4),('15128','2013-08-06','14:20:00',3.99),('15128','2013-08-06','14:25:00',3.99),('15128','2013-08-06','14:30:00',4),('15128','2013-08-06','14:35:00',4.01),('15128','2013-08-06','14:40:00',3.99),('15128','2013-08-06','14:45:00',3.96),('15128','2013-08-06','14:50:00',3.95),('15128','2013-08-06','14:55:00',3.92),('15128','2013-08-06','15:00:00',3.91),('15128','2013-08-06','15:05:00',3.89),('15128','2013-08-06','15:10:00',3.87),('15128','2013-08-06','15:15:00',3.86),('15128','2013-08-06','15:20:00',3.81),('15128','2013-08-06','15:25:00',3.77),('15128','2013-08-06','15:30:00',3.74),('15128','2013-08-06','15:35:00',3.71),('15128','2013-08-06','15:40:00',3.68),('15128','2013-08-06','15:45:00',3.64),('15128','2013-08-06','15:50:00',3.6),('15128','2013-08-06','15:55:00',3.56),('15128','2013-08-06','16:00:00',3.53),('15128','2013-08-06','16:05:00',3.49),('15128','2013-08-06','16:10:00',3.45),('15128','2013-08-06','16:15:00',3.4),('15128','2013-08-06','16:20:00',3.34),('15128','2013-08-06','16:25:00',3.28),('15128','2013-08-06','16:30:00',3.23),('15128','2013-08-06','16:35:00',3.17),('15128','2013-08-06','16:40:00',3.12),('15128','2013-08-06','16:45:00',3.08),('15128','2013-08-06','16:50:00',3.03),('15128','2013-08-06','16:55:00',2.97),('15128','2013-08-06','17:00:00',2.91),('15128','2013-08-06','17:05:00',2.84),('15128','2013-08-06','17:10:00',2.76),('15128','2013-08-06','17:15:00',2.7),('15128','2013-08-06','17:20:00',2.62),('15128','2013-08-06','17:25:00',2.54),('15128','2013-08-06','17:30:00',2.46),('15128','2013-08-06','17:35:00',2.38),('15128','2013-08-06','17:40:00',2.26),('15128','2013-08-06','17:45:00',2.21),('15128','2013-08-06','17:50:00',2.12),('15128','2013-08-06','17:55:00',2),('15128','2013-08-06','18:00:00',1.85),('15128','2013-08-06','18:05:00',1.77),('15128','2013-08-06','18:10:00',1.67),('15128','2013-08-06','18:15:00',1.58),('15128','2013-08-06','18:20:00',1.51),('15128','2013-08-06','18:25:00',1.45),('15128','2013-08-06','18:30:00',1.41),('15128','2013-08-06','18:35:00',1.32),('15128','2013-08-05','08:30:00',1.02),('15128','2013-08-05','08:35:00',1.07),('15128','2013-08-05','08:40:00',1.1),('15128','2013-08-05','08:45:00',1.18),('15128','2013-08-05','08:50:00',1.24),('15128','2013-08-05','08:55:00',1.31),('15128','2013-08-05','09:00:00',1.36),('15128','2013-08-05','09:05:00',1.43),('15128','2013-08-05','09:10:00',1.49),('15128','2013-08-05','09:15:00',1.58),('15128','2013-08-05','09:20:00',1.67),('15128','2013-08-05','09:25:00',1.74),('15128','2013-08-05','09:30:00',1.81),('15128','2013-08-05','09:35:00',1.82),('15128','2013-08-05','09:40:00',1.77),('15128','2013-08-05','09:45:00',1.81),('15128','2013-08-05','09:50:00',1.91),('15128','2013-08-05','09:55:00',1.93),('15128','2013-08-05','10:00:00',2.05),('15128','2013-08-05','10:05:00',2.11),('15128','2013-08-05','10:10:00',2.19),('15128','2013-08-05','10:15:00',2.25),('15128','2013-08-05','10:20:00',2.31),('15128','2013-08-05','10:25:00',2.38),('15128','2013-08-05','10:30:00',2.41),('15128','2013-08-05','10:35:00',2.46),('15128','2013-08-05','10:40:00',2.54),('15128','2013-08-05','10:45:00',2.58),('15128','2013-08-05','10:50:00',2.62),('15128','2013-08-05','10:55:00',2.73),('15128','2013-08-05','11:00:00',2.76),('15128','2013-08-05','11:05:00',2.88),('15128','2013-08-05','11:10:00',2.85),('15128','2013-08-05','11:15:00',2.95),('15128','2013-08-05','11:20:00',2.92),('15128','2013-08-05','11:25:00',3.03),('15128','2013-08-05','11:30:00',3.04),('15128','2013-08-05','11:35:00',3.05),('15128','2013-08-05','11:40:00',3.16),('15128','2013-08-05','11:45:00',3.2),('15128','2013-08-05','11:50:00',3.33),('15128','2013-08-05','11:55:00',3.48),('15128','2013-08-05','12:00:00',3.54),('15128','2013-08-05','12:05:00',3.58),('15128','2013-08-05','12:10:00',3.53),('15128','2013-08-05','12:15:00',3.6),('15128','2013-08-05','12:20:00',3.62),('15128','2013-08-05','12:25:00',3.62),('15128','2013-08-05','12:30:00',3.64),('15128','2013-08-05','12:35:00',3.7),('15128','2013-08-05','12:40:00',3.7),('15128','2013-08-05','12:45:00',3.76),('15128','2013-08-05','12:50:00',3.8),('15128','2013-08-05','12:55:00',3.86),('15128','2013-08-05','13:00:00',3.86),('15128','2013-08-05','13:05:00',3.86),('15128','2013-08-05','13:10:00',3.9),('15128','2013-08-05','13:15:00',3.94),('15128','2013-08-05','13:20:00',3.95),('15128','2013-08-05','13:25:00',3.99),('15128','2013-08-05','13:30:00',4),('15128','2013-08-05','13:35:00',4.03),('15128','2013-08-05','13:40:00',4.03),('15128','2013-08-05','13:45:00',4.04),('15128','2013-08-05','13:50:00',4.04),('15128','2013-08-05','13:55:00',4.06),('15128','2013-08-05','14:00:00',4.08),('15128','2013-08-05','14:05:00',4.07),('15128','2013-08-05','14:10:00',4.07),('15128','2013-08-05','14:15:00',4.07),('15128','2013-08-05','14:20:00',4.07),('15128','2013-08-05','14:25:00',4.06),('15128','2013-08-05','14:30:00',4.04),('15128','2013-08-05','14:35:00',4.03),('15128','2013-08-05','14:40:00',4.03),('15128','2013-08-05','14:45:00',4.01),('15128','2013-08-05','14:50:00',4.01),('15128','2013-08-05','14:55:00',3.98),('15128','2013-08-05','15:00:00',3.95),('15128','2013-08-05','15:05:00',3.95),('15128','2013-08-05','15:10:00',3.92),('15128','2013-08-05','15:15:00',3.9),('15128','2013-08-05','15:20:00',3.87),('15128','2013-08-05','15:25:00',3.83),('15128','2013-08-05','15:30:00',3.8),('15128','2013-08-05','15:35:00',3.77),('15128','2013-08-05','15:40:00',3.72),('15128','2013-08-05','15:45:00',3.68),('15128','2013-08-05','15:50:00',3.64),('15128','2013-08-05','15:55:00',3.61),('15128','2013-08-05','16:00:00',3.57),('15128','2013-08-05','16:05:00',3.52),('15128','2013-08-05','16:10:00',3.48),('15128','2013-08-05','16:15:00',3.41),('15128','2013-08-05','16:20:00',3.39),('15128','2013-08-05','16:25:00',3.33),('15128','2013-08-05','16:30:00',3.27),('15128','2013-08-05','16:35:00',3.22),('15128','2013-08-05','16:40:00',3.16),('15128','2013-08-05','16:45:00',3.12),('15128','2013-08-05','16:50:00',3.09),('15128','2013-08-05','16:55:00',3.02),('15128','2013-08-05','17:00:00',2.97),('15128','2013-08-05','17:05:00',2.89),('15128','2013-08-05','17:10:00',2.82),('15128','2013-08-05','17:15:00',2.74),('15128','2013-08-05','17:20:00',2.66),('15128','2013-08-05','17:25:00',2.58),('15128','2013-08-05','17:30:00',2.5),('15128','2013-08-05','17:35:00',2.42),('15128','2013-08-05','17:40:00',2.26),('15128','2013-08-05','17:45:00',2.22),('15128','2013-08-05','17:50:00',2.13),('15128','2013-08-05','17:55:00',2.01),('15128','2013-08-05','18:00:00',1.87),('15128','2013-08-05','18:05:00',1.77),('15128','2013-08-05','18:10:00',1.69),('15128','2013-08-05','18:15:00',1.62),('15128','2013-08-05','18:20:00',1.57),('15128','2013-08-05','18:25:00',1.49),('15128','2013-08-05','18:30:00',1.44),('15128','2013-08-05','18:35:00',1.36),('15128','2013-08-05','18:40:00',1.3),('15128','2013-08-05','18:45:00',1.19),('15128','2013-08-05','18:50:00',1.08),('15128','2013-08-04','08:30:00',1.04),('15128','2013-08-04','08:35:00',1.08),('15128','2013-08-04','08:40:00',1.14),('15128','2013-08-04','08:45:00',1.22),('15128','2013-08-04','08:50:00',1.29),('15128','2013-08-04','08:55:00',1.33),('15128','2013-08-04','09:00:00',1.4),('15128','2013-08-04','09:05:00',1.46),('15128','2013-08-04','09:10:00',1.54),('15128','2013-08-04','09:15:00',1.64),('15128','2013-08-04','09:20:00',1.7),('15128','2013-08-04','09:25:00',1.79),('15128','2013-08-04','09:30:00',1.85),('15128','2013-08-04','09:35:00',1.87),('15128','2013-08-04','09:40:00',1.89),('15128','2013-08-04','09:45:00',1.94),('15128','2013-08-04','09:50:00',1.95),('15128','2013-08-04','09:55:00',1.94),('15128','2013-08-04','10:00:00',2.05),('15128','2013-08-04','10:05:00',2.12),('15128','2013-08-04','10:10:00',2.21),('15128','2013-08-04','10:15:00',2.3),('15128','2013-08-04','10:20:00',2.38),('15128','2013-08-04','10:25:00',2.49),('15128','2013-08-04','10:30:00',2.55),('15128','2013-08-04','10:35:00',2.6),('15128','2013-08-04','10:40:00',2.63),('15128','2013-08-04','10:45:00',2.69),('15128','2013-08-04','10:50:00',2.73),('15128','2013-08-04','10:55:00',2.8),('15128','2013-08-04','11:00:00',2.83),('15128','2013-08-04','11:05:00',2.91),('15128','2013-08-04','11:10:00',2.9),('15128','2013-08-04','11:15:00',3.02),('15128','2013-08-04','11:20:00',3.01),('15128','2013-08-04','11:25:00',3.13),('15128','2013-08-04','11:30:00',3.11),('15128','2013-08-04','11:35:00',3.2),('15128','2013-08-04','11:40:00',3.27),('15128','2013-08-04','11:45:00',3.27),('15128','2013-08-04','11:50:00',3.41),('15128','2013-08-04','11:55:00',3.56),('15128','2013-08-04','12:00:00',3.58),('15128','2013-08-04','12:05:00',3.66),('15128','2013-08-04','12:10:00',3.67),('15128','2013-08-04','12:15:00',3.71),('15128','2013-08-04','12:20:00',3.72),('15128','2013-08-04','12:25:00',3.73),('15128','2013-08-04','12:30:00',3.78),('15128','2013-08-04','12:35:00',3.82),('15128','2013-08-04','12:40:00',3.81),('15128','2013-08-04','12:45:00',3.84),('15128','2013-08-04','12:50:00',3.87),('15128','2013-08-04','12:55:00',3.87),('15128','2013-08-04','13:00:00',3.89),('15128','2013-08-04','13:05:00',3.91),('15128','2013-08-04','13:10:00',3.96),('15128','2013-08-04','13:15:00',3.97),('15128','2013-08-04','13:20:00',3.98),('15128','2013-08-04','13:25:00',3.97),('15128','2013-08-04','13:30:00',3.96),('15128','2013-08-04','13:35:00',3.97),('15128','2013-08-04','13:40:00',3.99),('15128','2013-08-04','13:45:00',3.97),('15128','2013-08-04','13:50:00',3.96),('15128','2013-08-04','13:55:00',3.98),('15128','2013-08-04','14:00:00',4),('15128','2013-08-04','14:05:00',4),('15128','2013-08-04','14:10:00',3.99),('15128','2013-08-04','14:15:00',3.97),('15128','2013-08-04','14:20:00',3.98),('15128','2013-08-04','14:25:00',3.99),('15128','2013-08-04','14:30:00',4),('15128','2013-08-04','14:35:00',3.97),('15128','2013-08-04','14:40:00',3.96),('15128','2013-08-04','14:45:00',3.95),('15128','2013-08-04','14:50:00',3.93),('15128','2013-08-04','14:55:00',3.9),('15128','2013-08-04','15:00:00',3.89),('15128','2013-08-04','15:05:00',3.86),('15128','2013-08-04','15:10:00',3.85),('15128','2013-08-04','15:15:00',3.8),('15128','2013-08-04','15:20:00',3.79),('15128','2013-08-04','15:25:00',3.78),('15128','2013-08-04','15:30:00',3.78),('15128','2013-08-04','15:35:00',3.73),('15128','2013-08-04','15:40:00',3.71),('15128','2013-08-04','15:45:00',3.67),('15128','2013-08-04','15:50:00',3.63),('15128','2013-08-04','15:55:00',3.59),('15128','2013-08-04','16:00:00',3.55),('15128','2013-08-04','16:05:00',3.5),('15128','2013-08-04','16:10:00',3.47),('15128','2013-08-04','16:15:00',3.43),('15128','2013-08-04','16:20:00',3.38),('15128','2013-08-04','16:25:00',3.32),('15128','2013-08-04','16:30:00',3.26),('15128','2013-08-04','16:35:00',3.19),('15128','2013-08-04','16:40:00',3.16),('15128','2013-08-04','16:45:00',3.11),('15128','2013-08-04','16:50:00',3.06),('15128','2013-08-04','16:55:00',3),('15128','2013-08-04','17:00:00',2.92),('15128','2013-08-04','17:05:00',2.84),('15128','2013-08-04','17:10:00',2.76),('15128','2013-08-04','17:15:00',2.71),('15128','2013-08-04','17:20:00',2.65),('15128','2013-08-04','17:25:00',2.56),('15128','2013-08-04','17:30:00',2.45),('15128','2013-08-04','17:35:00',2.38),('15128','2013-08-04','17:40:00',2.27),('15128','2013-08-04','17:45:00',2.18),('15128','2013-08-04','17:50:00',2.1),('15128','2013-08-04','17:55:00',1.96),('15128','2013-08-04','18:00:00',1.84),('15128','2013-08-04','18:05:00',1.76),('15128','2013-08-04','18:10:00',1.67),('15128','2013-08-04','18:15:00',1.57),('15128','2013-08-04','18:20:00',1.52),('15128','2013-08-04','18:25:00',1.49),('15128','2013-08-04','18:30:00',1.44),('15128','2013-08-04','18:35:00',1.36),('15128','2013-08-04','18:40:00',1.29),('15128','2013-08-04','18:45:00',1.2),('15128','2013-08-04','18:50:00',1.1),('15128','2013-08-03','08:25:00',1),('15128','2013-08-03','08:30:00',1.08),('15128','2013-08-03','08:35:00',1.13),('15128','2013-08-03','08:40:00',1.19),('15128','2013-08-03','08:45:00',1.28),('15128','2013-08-03','08:50:00',1.36),('15128','2013-08-03','08:55:00',1.42),('15128','2013-08-03','09:00:00',1.47),('15128','2013-08-03','09:05:00',1.55),('15128','2013-08-03','09:10:00',1.6),('15128','2013-08-03','09:15:00',1.72),('15128','2013-08-03','09:20:00',1.8),('15128','2013-08-03','09:25:00',1.86),('15128','2013-08-03','09:30:00',1.95),('15128','2013-08-03','09:35:00',1.94),('15128','2013-08-03','09:40:00',1.95),('15128','2013-08-03','09:45:00',1.98),('15128','2013-08-03','09:50:00',1.97),('15128','2013-08-03','09:55:00',1.95),('15128','2013-08-03','10:00:00',2.1),('15128','2013-08-03','10:05:00',2.16),('15128','2013-08-03','10:10:00',2.24),('15128','2013-08-03','10:15:00',2.33),('15128','2013-08-03','10:20:00',2.44),('15128','2013-08-03','10:25:00',2.51),('15128','2013-08-03','10:30:00',2.49),('15128','2013-08-03','10:35:00',2.54),('15128','2013-08-03','10:40:00',2.63),('15128','2013-08-03','10:45:00',2.65),('15128','2013-08-03','10:50:00',2.71),('15128','2013-08-03','10:55:00',2.78),('15128','2013-08-03','11:00:00',2.82),('15128','2013-08-03','11:05:00',2.97),('15128','2013-08-03','11:10:00',2.97),('15128','2013-08-03','11:15:00',3.09),('15128','2013-08-03','11:20:00',3.08),('15128','2013-08-03','11:25:00',3.17),('15128','2013-08-03','11:30:00',3.17),('15128','2013-08-03','11:35:00',3.21),('15128','2013-08-03','11:40:00',3.32),('15128','2013-08-03','11:45:00',3.34),('15128','2013-08-03','11:50:00',3.55),('15128','2013-08-03','11:55:00',3.64),('15128','2013-08-03','12:00:00',3.71),('15128','2013-08-03','12:05:00',3.71),('15128','2013-08-03','12:10:00',3.7),('15128','2013-08-03','12:15:00',3.7),('15128','2013-08-03','12:20:00',3.74),('15128','2013-08-03','12:25:00',3.81),('15128','2013-08-03','12:30:00',3.82),('15128','2013-08-03','12:35:00',3.87),('15128','2013-08-03','12:40:00',3.89),('15128','2013-08-03','12:45:00',3.93),('15128','2013-08-03','12:50:00',3.93),('15128','2013-08-03','12:55:00',3.95),('15128','2013-08-03','13:00:00',4),('15128','2013-08-03','13:05:00',4.01),('15128','2013-08-03','13:10:00',4.04),('15128','2013-08-03','13:15:00',4.05),('15128','2013-08-03','13:20:00',4.08),('15128','2013-08-03','13:25:00',4.07),('15128','2013-08-03','13:30:00',4.09),('15128','2013-08-03','13:35:00',4.11),('15128','2013-08-03','13:40:00',4.12),('15128','2013-08-03','13:45:00',4.14),('15128','2013-08-03','13:50:00',4.12),('15128','2013-08-03','13:55:00',4.14),('15128','2013-08-03','14:00:00',4.14),('15128','2013-08-03','14:05:00',4.14),('15128','2013-08-03','14:10:00',4.12),('15128','2013-08-03','14:15:00',4.1),('15128','2013-08-03','14:20:00',4.11),('15128','2013-08-03','14:25:00',4.11),('15128','2013-08-03','14:30:00',4.12),('15128','2013-08-03','14:35:00',4.1),('15128','2013-08-03','14:40:00',4.04),('15128','2013-08-03','14:45:00',4.02),('15128','2013-08-03','14:50:00',3.95),('15128','2013-08-03','14:55:00',4),('15128','2013-08-03','15:00:00',4.03),('15128','2013-08-03','15:05:00',4.03),('15128','2013-08-03','15:10:00',3.99),('15128','2013-08-03','15:15:00',3.94),('15128','2013-08-03','15:20:00',3.95),('15128','2013-08-03','15:25:00',3.93),('15128','2013-08-03','15:30:00',3.91),('15128','2013-08-03','15:35:00',3.92),('15128','2013-08-03','15:40:00',3.83),('15128','2013-08-03','15:45:00',3.82),('15128','2013-08-03','15:50:00',3.79),('15128','2013-08-03','15:55:00',3.75),('15128','2013-08-03','16:00:00',3.71),('15128','2013-08-03','16:05:00',3.67),('15128','2013-08-03','16:10:00',3.63),('15128','2013-08-03','16:15:00',3.56),('15128','2013-08-03','16:20:00',3.5),('15128','2013-08-03','16:25:00',3.45),('15128','2013-08-03','16:30:00',3.42),('15128','2013-08-03','16:35:00',3.35),('15128','2013-08-03','16:40:00',3.31),('15128','2013-08-03','16:45:00',3.24),('15128','2013-08-03','16:50:00',3.16),('15128','2013-08-03','16:55:00',3.1),('15128','2013-08-03','17:00:00',3.04),('15128','2013-08-03','17:05:00',2.95),('15128','2013-08-03','17:10:00',2.88),('15128','2013-08-03','17:15:00',2.78),('15128','2013-08-03','17:20:00',2.69),('15128','2013-08-03','17:25:00',2.65),('15128','2013-08-03','17:30:00',2.46),('15128','2013-08-03','17:35:00',2.42),('15128','2013-08-03','17:40:00',2.34),('15128','2013-08-03','17:45:00',2.21),('15128','2013-08-03','17:50:00',2.12),('15128','2013-08-03','17:55:00',1.97),('15128','2013-08-03','18:00:00',1.89),('15128','2013-08-03','18:05:00',1.83),('15128','2013-08-03','18:10:00',1.72),('15128','2013-08-03','18:15:00',1.65),('15128','2013-08-03','18:20:00',1.54),('15128','2013-08-03','18:25:00',1.52),('15128','2013-08-03','18:30:00',1.45),('15128','2013-08-03','18:35:00',1.4),('15128','2013-08-03','18:40:00',1.3),('15128','2013-08-03','18:45:00',1.19),('15128','2013-08-03','18:50:00',1.09),('15128','2013-08-02','08:30:00',1.07),('15128','2013-08-02','08:35:00',1.12),('15128','2013-08-02','08:40:00',1.2),('15128','2013-08-02','08:45:00',1.28),('15128','2013-08-02','08:50:00',1.34),('15128','2013-08-02','08:55:00',1.42),('15128','2013-08-02','09:00:00',1.49),('15128','2013-08-02','09:05:00',1.55),('15128','2013-08-02','09:10:00',1.62),('15128','2013-08-02','09:15:00',1.72),('15128','2013-08-02','09:20:00',1.8),('15128','2013-08-02','09:25:00',1.86),('15128','2013-08-02','09:30:00',1.94),('15128','2013-08-02','09:35:00',1.97),('15128','2013-08-02','09:40:00',1.99),('15128','2013-08-02','09:45:00',2),('15128','2013-08-02','09:50:00',2.08),('15128','2013-08-02','09:55:00',2.11),('15128','2013-08-02','10:00:00',2.13),('15128','2013-08-02','10:05:00',2.19),('15128','2013-08-02','10:10:00',2.26),('15128','2013-08-02','10:15:00',2.37),('15128','2013-08-02','10:20:00',2.46),('15128','2013-08-02','10:25:00',2.51),('15128','2013-08-02','10:30:00',2.54),('15128','2013-08-02','10:35:00',2.56),('15128','2013-08-02','10:40:00',2.67),('15128','2013-08-02','10:45:00',2.7),('15128','2013-08-02','10:50:00',2.74),('15128','2013-08-02','10:55:00',2.84),('15128','2013-08-02','11:00:00',2.88),('15128','2013-08-02','11:05:00',2.98),('15128','2013-08-02','11:10:00',3),('15128','2013-08-02','11:15:00',3.11),('15128','2013-08-02','11:20:00',3.11),('15128','2013-08-02','11:25:00',3.21),('15128','2013-08-02','11:30:00',3.15),('15128','2013-08-02','11:35:00',3.2),('15128','2013-08-02','11:40:00',3.3),('15128','2013-08-02','11:45:00',3.33),('15128','2013-08-02','11:50:00',3.44),('15128','2013-08-02','11:55:00',3.57),('15128','2013-08-02','12:00:00',3.64),('15128','2013-08-02','12:05:00',3.66),('15128','2013-08-02','12:10:00',3.7),('15128','2013-08-02','12:15:00',3.75),('15128','2013-08-02','12:20:00',3.76),('15128','2013-08-02','12:25:00',3.76),('15128','2013-08-02','12:30:00',3.81),('15128','2013-08-02','12:35:00',3.87),('15128','2013-08-02','12:40:00',3.91),('15128','2013-08-02','12:45:00',3.93),('15128','2013-08-02','12:50:00',3.93),('15128','2013-08-02','12:55:00',3.96),('15128','2013-08-02','13:00:00',3.98),('15128','2013-08-02','13:05:00',3.99),('15128','2013-08-02','13:10:00',4.01),('15128','2013-08-02','13:15:00',4),('15128','2013-08-02','13:20:00',4.03),('15128','2013-08-02','13:25:00',4.03),('15128','2013-08-02','13:30:00',4.04),('15128','2013-08-02','13:35:00',4.04),('15128','2013-08-02','13:40:00',4.04),('15128','2013-08-02','13:45:00',4.03),('15128','2013-08-02','13:50:00',4.04),('15128','2013-08-02','13:55:00',4.02),('15128','2013-08-02','14:00:00',4.01),('15128','2013-08-02','14:05:00',4.09),('15128','2013-08-02','14:10:00',4.14),('15128','2013-08-02','14:15:00',4.15),('15128','2013-08-02','14:20:00',4.13),('15128','2013-08-02','14:25:00',4.11),('15128','2013-08-02','14:30:00',4.11),('15128','2013-08-02','14:35:00',4.1),('15128','2013-08-02','14:40:00',4.11),('15128','2013-08-02','14:45:00',4.1),('15128','2013-08-02','14:50:00',4.06),('15128','2013-08-02','14:55:00',4.04),('15128','2013-08-02','15:00:00',4.01),('15128','2013-08-02','15:05:00',4),('15128','2013-08-02','15:10:00',3.99),('15128','2013-08-02','15:15:00',3.99),('15128','2013-08-02','15:20:00',3.92),('15128','2013-08-02','15:25:00',3.9),('15128','2013-08-02','15:30:00',3.87),('15128','2013-08-02','15:35:00',3.84),('15128','2013-08-02','15:40:00',3.82),('15128','2013-08-02','15:45:00',3.79),('15128','2013-08-02','15:50:00',3.76),('15128','2013-08-02','15:55:00',3.74),('15128','2013-08-02','16:00:00',3.69),('15128','2013-08-02','16:05:00',3.66),('15128','2013-08-02','16:10:00',3.62),('15128','2013-08-02','16:15:00',3.56),('15128','2013-08-02','16:20:00',3.48),('15128','2013-08-02','16:25:00',3.44),('15128','2013-08-02','16:30:00',3.39),('15128','2013-08-02','16:35:00',3.33),('15128','2013-08-02','16:40:00',3.29),('15128','2013-08-02','16:45:00',3.23),('15128','2013-08-02','16:50:00',3.16),('15128','2013-08-02','16:55:00',3.11),('15128','2013-08-02','17:00:00',3.05),('15128','2013-08-02','17:05:00',2.99),('15128','2013-08-02','17:10:00',2.94),('15128','2013-08-02','17:15:00',2.86),('15128','2013-08-02','17:20:00',2.78),('15128','2013-08-02','17:25:00',2.72),('15128','2013-08-02','17:30:00',2.65),('15128','2013-08-02','17:35:00',2.57),('15128','2013-08-02','17:40:00',2.49),('15128','2013-08-02','17:45:00',2.38),('15128','2013-08-02','17:50:00',2.26),('15128','2013-08-02','17:55:00',2.13),('15128','2013-08-02','18:00:00',1.97),('15128','2013-08-02','18:05:00',1.93),('15128','2013-08-02','18:10:00',1.86),('15128','2013-08-02','18:15:00',1.75),('15128','2013-08-02','18:20:00',1.67),('15128','2013-08-02','18:25:00',1.63),('15128','2013-08-02','18:30:00',1.57),('15128','2013-08-02','18:35:00',1.51),('15128','2013-08-02','18:40:00',1.42),('15128','2013-08-02','18:45:00',1.34),('15128','2013-08-02','18:50:00',1.23),('15128','2013-08-02','18:55:00',1.13),('15128','2013-08-02','19:00:00',1.04),('15128','2013-08-01','08:25:00',1.05),('15128','2013-08-01','08:30:00',1.11),('15128','2013-08-01','08:35:00',1.17),('15128','2013-08-01','08:40:00',1.25),('15128','2013-08-01','08:45:00',1.34),('15128','2013-08-01','08:50:00',1.41),('15128','2013-08-01','08:55:00',1.47),('15128','2013-08-01','09:00:00',1.54),('15128','2013-08-01','09:05:00',1.61),('15128','2013-08-01','09:10:00',1.69),('15128','2013-08-01','09:15:00',1.8),('15128','2013-08-01','09:20:00',1.88),('15128','2013-08-01','09:25:00',1.95),('15128','2013-08-01','09:30:00',2.02),('15128','2013-08-01','09:35:00',2.02),('15128','2013-08-01','09:40:00',2.1),('15128','2013-08-01','09:45:00',2.09),('15128','2013-08-01','09:50:00',2.1),('15128','2013-08-01','09:55:00',2.15),('15128','2013-08-01','10:00:00',2.22),('15128','2013-08-01','10:05:00',2.26),('15128','2013-08-01','10:10:00',2.31),('15128','2013-08-01','10:15:00',2.43),('15128','2013-08-01','10:20:00',2.52),('15128','2013-08-01','10:25:00',2.59),('15128','2013-08-01','10:30:00',2.58),('15128','2013-08-01','10:35:00',2.65),('15128','2013-08-01','10:40:00',2.72),('15128','2013-08-01','10:45:00',2.74),('15128','2013-08-01','10:50:00',2.8),('15128','2013-08-01','10:55:00',2.89),('15128','2013-08-01','11:00:00',2.9),('15128','2013-08-01','11:05:00',2.99),('15128','2013-08-01','11:10:00',3.01),('15128','2013-08-01','11:15:00',3.13),('15128','2013-08-01','11:20:00',3.16),('15128','2013-08-01','11:25:00',3.24),('15128','2013-08-01','11:30:00',3.22),('15128','2013-08-01','11:35:00',3.28),('15128','2013-08-01','11:40:00',3.35),('15128','2013-08-01','11:45:00',3.38),('15128','2013-08-01','11:50:00',3.49),('15128','2013-08-01','11:55:00',3.58),('15128','2013-08-01','12:00:00',3.7),('15128','2013-08-01','12:05:00',3.75),('15128','2013-08-01','12:10:00',3.79),('15128','2013-08-01','12:15:00',3.79),('15128','2013-08-01','12:20:00',3.85),('15128','2013-08-01','12:25:00',3.89),('15128','2013-08-01','12:30:00',3.91),('15128','2013-08-01','12:35:00',3.96),('15128','2013-08-01','12:40:00',3.99),('15128','2013-08-01','12:45:00',4),('15128','2013-08-01','12:50:00',4.01),('15128','2013-08-01','12:55:00',4.02),('15128','2013-08-01','13:00:00',4.01),('15128','2013-08-01','13:05:00',4.01),('15128','2013-08-01','13:10:00',4.02),('15128','2013-08-01','13:15:00',4.05),('15128','2013-08-01','13:20:00',4.06),('15128','2013-08-01','13:25:00',4.09),('15128','2013-08-01','13:30:00',4.08),('15128','2013-08-01','13:35:00',4.1),('15128','2013-08-01','13:40:00',4.11),('15128','2013-08-01','13:45:00',4.13),('15128','2013-08-01','13:50:00',4.16),('15128','2013-08-01','13:55:00',4.15),('15128','2013-08-01','14:00:00',4.06),('15128','2013-08-01','14:05:00',3.53),('15128','2013-08-01','14:10:00',4.17),('15128','2013-08-01','14:15:00',4.13),('15128','2013-08-01','14:20:00',4.07),('15128','2013-08-01','14:25:00',4.07),('15128','2013-08-01','14:30:00',4.1),('15128','2013-08-01','14:35:00',4.1),('15128','2013-08-01','14:40:00',4.08),('15128','2013-08-01','14:45:00',4.04),('15128','2013-08-01','14:50:00',4.04),('15128','2013-08-01','14:55:00',4.03),('15128','2013-08-01','15:00:00',3.97),('15128','2013-08-01','15:05:00',3.96),('15128','2013-08-01','15:10:00',3.98),('15128','2013-08-01','15:15:00',3.97),('15128','2013-08-01','15:20:00',3.96),('15128','2013-08-01','15:25:00',3.95),('15128','2013-08-01','15:30:00',3.9),('15128','2013-08-01','15:35:00',3.87),('15128','2013-08-01','15:40:00',3.82),('15128','2013-08-01','15:45:00',3.81),('15128','2013-08-01','15:50:00',3.81),('15128','2013-08-01','15:55:00',3.78),('15128','2013-08-01','16:00:00',3.76),('15128','2013-08-01','16:05:00',3.74),('15128','2013-08-01','16:10:00',3.65),('15128','2013-08-01','16:15:00',3.58),('15128','2013-08-01','16:20:00',3.54),('15128','2013-08-01','16:25:00',3.49),('15128','2013-08-01','16:30:00',3.42),('15128','2013-08-01','16:35:00',3.37),('15128','2013-08-01','16:40:00',3.31),('15128','2013-08-01','16:45:00',3.25),('15128','2013-08-01','16:50:00',3.24),('15128','2013-08-01','16:55:00',3.21),('15128','2013-08-01','17:00:00',3.13),('15128','2013-08-01','17:05:00',3.04),('15128','2013-08-01','17:10:00',2.97),('15128','2013-08-01','17:15:00',2.91),('15128','2013-08-01','17:20:00',2.83),('15128','2013-08-01','17:25:00',2.78),('15128','2013-08-01','17:30:00',2.72),('15128','2013-08-01','17:35:00',2.64),('15128','2013-08-01','17:40:00',2.51),('15128','2013-08-01','17:45:00',2.43),('15128','2013-08-01','17:50:00',2.28),('15128','2013-08-01','17:55:00',2.19),('15128','2013-08-01','18:00:00',2.07),('15128','2013-08-01','18:05:00',2.01),('15128','2013-08-01','18:10:00',1.88),('15128','2013-08-01','18:15:00',1.77),('15128','2013-08-01','18:20:00',1.72),('15128','2013-08-01','18:25:00',1.68),('15128','2013-08-01','18:30:00',1.62),('15128','2013-08-01','18:35:00',1.55),('15128','2013-08-01','18:40:00',1.47),('15128','2013-08-01','18:45:00',1.41),('15128','2013-08-01','18:50:00',1.31),('15128','2013-08-01','18:55:00',1.21),('15128','2013-08-01','19:00:00',1.11),('15128','2013-08-01','19:05:00',1.02),('15128','2013-07-31','08:25:00',1.05),('15128','2013-07-31','08:30:00',1.13),('15128','2013-07-31','08:35:00',1.19),('15128','2013-07-31','08:40:00',1.29),('15128','2013-07-31','08:45:00',1.37),('15128','2013-07-31','08:50:00',1.43),('15128','2013-07-31','08:55:00',1.5),('15128','2013-07-31','09:00:00',1.57),('15128','2013-07-31','09:05:00',1.64),('15128','2013-07-31','09:10:00',1.71),('15128','2013-07-31','09:15:00',1.81),('15128','2013-07-31','09:20:00',1.9),('15128','2013-07-31','09:25:00',1.99),('15128','2013-07-31','09:30:00',2.07),('15128','2013-07-31','09:35:00',2.13),('15128','2013-07-31','09:40:00',2.17),('15128','2013-07-31','09:45:00',2.21),('15128','2013-07-31','09:50:00',2.29),('15128','2013-07-31','09:55:00',2.35),('15128','2013-07-31','10:00:00',2.43),('15128','2013-07-31','10:05:00',2.49),('15128','2013-07-31','10:10:00',2.56),('15128','2013-07-31','10:15:00',2.62),('15128','2013-07-31','10:20:00',2.67),('15128','2013-07-31','10:25:00',2.72),('15128','2013-07-31','10:30:00',2.8),('15128','2013-07-31','10:35:00',2.83),('15128','2013-07-31','10:40:00',2.89),('15128','2013-07-31','10:45:00',2.97),('15128','2013-07-31','10:50:00',3.02),('15128','2013-07-31','10:55:00',3.08),('15128','2013-07-31','11:00:00',3.11),('15128','2013-07-31','11:05:00',3.18),('15128','2013-07-31','11:10:00',3.24),('15128','2013-07-31','11:15:00',3.33),('15128','2013-07-31','11:20:00',3.36),('15128','2013-07-31','11:25:00',3.41),('15128','2013-07-31','11:30:00',3.44),('15128','2013-07-31','11:35:00',3.5),('15128','2013-07-31','11:40:00',3.53),('15128','2013-07-31','11:45:00',3.65),('15128','2013-07-31','11:50:00',3.76),('15128','2013-07-31','11:55:00',3.84),('15128','2013-07-31','12:00:00',3.93),('15128','2013-07-31','12:05:00',3.99),('15128','2013-07-31','12:10:00',4.03),('15128','2013-07-31','12:15:00',4.08),('15128','2013-07-31','12:20:00',4.08),('15128','2013-07-31','12:25:00',4.1),('15128','2013-07-31','12:30:00',4.15),('15128','2013-07-31','12:35:00',4.2),('15128','2013-07-31','12:40:00',4.23),('15128','2013-07-31','12:45:00',4.26),('15128','2013-07-31','12:50:00',4.27),('15128','2013-07-31','12:55:00',4.27),('15128','2013-07-31','13:00:00',4.29),('15128','2013-07-31','13:05:00',4.26),('15128','2013-07-31','13:10:00',4.32),('15128','2013-07-31','13:15:00',4.34),('15128','2013-07-31','13:20:00',4.35),('15128','2013-07-31','13:25:00',4.34),('15128','2013-07-31','13:30:00',4.37),('15128','2013-07-31','13:35:00',4.36),('15128','2013-07-31','13:40:00',4.37),('15128','2013-07-31','13:45:00',4.38),('15128','2013-07-31','13:50:00',4.38),('15128','2013-07-31','13:55:00',4.35),('15128','2013-07-31','14:00:00',4.35),('15128','2013-07-31','14:05:00',4.36),('15128','2013-07-31','14:10:00',4.33),('15128','2013-07-31','14:15:00',4.32),('15128','2013-07-31','14:20:00',4.3),('15128','2013-07-31','14:25:00',4.33),('15128','2013-07-31','14:30:00',4.3),('15128','2013-07-31','14:35:00',4.27),('15128','2013-07-31','14:40:00',4.22),('15128','2013-07-31','14:45:00',4.18),('15128','2013-07-31','14:50:00',4.2),('15128','2013-07-31','14:55:00',4.2),('15128','2013-07-31','15:00:00',4.2),('15128','2013-07-31','15:05:00',4.18),('15128','2013-07-31','15:10:00',4.15),('15128','2013-07-31','15:15:00',4.13),('15128','2013-07-31','15:20:00',4.1),('15128','2013-07-31','15:25:00',4.07),('15128','2013-07-31','15:30:00',4.02),('15128','2013-07-31','15:35:00',4),('15128','2013-07-31','15:40:00',3.98),('15128','2013-07-31','15:45:00',3.91),('15128','2013-07-31','15:50:00',3.88),('15128','2013-07-31','15:55:00',3.83),('15128','2013-07-31','16:00:00',3.77),('15128','2013-07-31','16:05:00',3.73),('15128','2013-07-31','16:10:00',3.68),('15128','2013-07-31','16:15:00',3.62),('15128','2013-07-31','16:20:00',3.57),('15128','2013-07-31','16:25:00',3.52),('15128','2013-07-31','16:30:00',3.45),('15128','2013-07-31','16:35:00',3.41),('15128','2013-07-31','16:40:00',3.35),('15128','2013-07-31','16:45:00',3.28),('15128','2013-07-31','16:50:00',3.23),('15128','2013-07-31','16:55:00',3.18),('15128','2013-07-31','17:00:00',3.11),('15128','2013-07-31','17:05:00',3.07),('15128','2013-07-31','17:10:00',3),('15128','2013-07-31','17:15:00',2.92),('15128','2013-07-31','17:20:00',2.86),('15128','2013-07-31','17:25:00',2.8),('15128','2013-07-31','17:30:00',2.7),('15128','2013-07-31','17:35:00',2.62),('15128','2013-07-31','17:40:00',2.53),('15128','2013-07-31','17:45:00',2.42),('15128','2013-07-31','17:50:00',2.32),('15128','2013-07-31','17:55:00',2.23),('15128','2013-07-31','18:00:00',2.11),('15128','2013-07-31','18:05:00',1.99),('15128','2013-07-31','18:10:00',1.91),('15128','2013-07-31','18:15:00',1.8),('15128','2013-07-31','18:20:00',1.75),('15128','2013-07-31','18:25:00',1.68),('15128','2013-07-31','18:30:00',1.63),('15128','2013-07-31','18:35:00',1.59),('15128','2013-07-31','18:40:00',1.52),('15128','2013-07-31','18:45:00',1.44),('15128','2013-07-31','18:50:00',1.37),('15128','2013-07-31','18:55:00',1.26),('15128','2013-07-31','19:00:00',1.17),('15128','2013-07-31','19:05:00',1.06),('15128','2013-07-30','08:20:00',1.01),('15128','2013-07-30','08:25:00',1.06),('15128','2013-07-30','08:30:00',1.13),('15128','2013-07-30','08:35:00',1.2),('15128','2013-07-30','08:40:00',1.29),('15128','2013-07-30','08:45:00',1.38),('15128','2013-07-30','08:50:00',1.44),('15128','2013-07-30','08:55:00',1.51),('15128','2013-07-30','09:00:00',1.56),('15128','2013-07-30','09:05:00',1.63),('15128','2013-07-30','09:10:00',1.72),('15128','2013-07-30','09:15:00',1.81),('15128','2013-07-30','09:20:00',1.88),('15128','2013-07-30','09:25:00',1.98),('15128','2013-07-30','09:30:00',2.05),('15128','2013-07-30','09:35:00',2.08),('15128','2013-07-30','09:40:00',2.17),('15128','2013-07-30','09:45:00',2.18),('15128','2013-07-30','09:50:00',2.18),('15128','2013-07-30','09:55:00',2.21),('15128','2013-07-30','10:00:00',2.32),('15128','2013-07-30','10:05:00',2.44),('15128','2013-07-30','10:10:00',2.49),('15128','2013-07-30','10:15:00',2.57),('15128','2013-07-30','10:20:00',2.61),('15128','2013-07-30','10:25:00',2.66),('15128','2013-07-30','10:30:00',2.74),('15128','2013-07-30','10:35:00',2.8),('15128','2013-07-30','10:40:00',2.86),('15128','2013-07-30','10:45:00',2.94),('15128','2013-07-30','10:50:00',3),('15128','2013-07-30','10:55:00',3.07),('15128','2013-07-30','11:00:00',3.1),('15128','2013-07-30','11:05:00',3.18),('15128','2013-07-30','11:10:00',3.26),('15128','2013-07-30','11:15:00',3.31),('15128','2013-07-30','11:20:00',3.35),('15128','2013-07-30','11:25:00',3.42),('15128','2013-07-30','11:30:00',3.46),('15128','2013-07-30','11:35:00',3.52),('15128','2013-07-30','11:40:00',3.58),('15128','2013-07-30','11:45:00',3.62),('15128','2013-07-30','11:50:00',3.7),('15128','2013-07-30','11:55:00',3.86),('15128','2013-07-30','12:00:00',3.93),('15128','2013-07-30','12:05:00',3.97),('15128','2013-07-30','12:10:00',4),('15128','2013-07-30','12:15:00',4.02),('15128','2013-07-30','12:20:00',4.07),('15128','2013-07-30','12:25:00',4.09),('15128','2013-07-30','12:30:00',4.12),('15128','2013-07-30','12:35:00',4.14),('15128','2013-07-30','12:40:00',4.15),('15128','2013-07-30','12:45:00',4.2),('15128','2013-07-30','12:50:00',4.21),('15128','2013-07-30','12:55:00',4.21),('15128','2013-07-30','13:00:00',4.23),('15128','2013-07-30','13:05:00',4.28),('15128','2013-07-30','13:10:00',4.35),('15128','2013-07-30','13:15:00',4.34),('15128','2013-07-30','13:20:00',4.36),('15128','2013-07-30','13:25:00',4.34),('15128','2013-07-30','13:30:00',4.36),('15128','2013-07-30','13:35:00',4.39),('15128','2013-07-30','13:40:00',4.39),('15128','2013-07-30','13:45:00',4.37),('15128','2013-07-30','13:50:00',4.4),('15128','2013-07-30','13:55:00',4.43),('15128','2013-07-30','14:00:00',4.41),('15128','2013-07-30','14:05:00',4.42),('15128','2013-07-30','14:10:00',4.37),('15128','2013-07-30','14:15:00',4.42),('15128','2013-07-30','14:20:00',4.36),('15128','2013-07-30','14:25:00',4.3),('15128','2013-07-30','14:30:00',4.3),('15128','2013-07-30','14:35:00',4.26),('15128','2013-07-30','14:40:00',4.26),('15128','2013-07-30','14:45:00',4.21),('15128','2013-07-30','14:50:00',4.18),('15128','2013-07-30','14:55:00',4.19),('15128','2013-07-30','15:00:00',3.82),('15128','2013-07-30','15:05:00',4.18),('15128','2013-07-30','15:10:00',3.12),('15128','2013-07-30','15:15:00',4.16),('15128','2013-07-30','15:20:00',4.07),('15128','2013-07-30','15:25:00',4),('15128','2013-07-30','15:30:00',3.92),('15128','2013-07-30','15:35:00',3.91),('15128','2013-07-30','15:40:00',3.87),('15128','2013-07-30','15:45:00',3.89),('15128','2013-07-30','15:50:00',3.86),('15128','2013-07-30','15:55:00',3.58),('15128','2013-07-30','16:00:00',2.05),('15128','2013-07-30','16:05:00',3.79),('15128','2013-07-30','16:10:00',3.72),('15128','2013-07-30','16:15:00',3.67),('15128','2013-07-30','16:20:00',3.57),('15128','2013-07-30','16:25:00',3.53),('15128','2013-07-30','16:30:00',3.5),('15128','2013-07-30','16:35:00',3.47),('15128','2013-07-30','16:40:00',3.42),('15128','2013-07-30','16:45:00',3.4),('15128','2013-07-30','16:50:00',3.4),('15128','2013-07-30','16:55:00',3.34),('15128','2013-07-30','17:00:00',3.2),('15128','2013-07-30','17:05:00',3.13),('15128','2013-07-30','17:10:00',3.04),('15128','2013-07-30','17:15:00',2.85),('15128','2013-07-30','17:20:00',2.81),('15128','2013-07-30','17:25:00',2.8),('15128','2013-07-30','17:30:00',2.67),('15128','2013-07-30','17:35:00',2.61),('15128','2013-07-30','17:40:00',2.55),('15128','2013-07-30','17:45:00',2.44),('15128','2013-07-30','17:50:00',2.36),('15128','2013-07-30','17:55:00',2.22),('15128','2013-07-30','18:00:00',2.13),('15128','2013-07-30','18:05:00',1.99),('15128','2013-07-30','18:10:00',1.96),('15128','2013-07-30','18:15:00',1.87),('15128','2013-07-30','18:20:00',1.82),('15128','2013-07-30','18:25:00',1.77),('15128','2013-07-30','18:30:00',1.72),('15128','2013-07-30','18:35:00',1.65),('15128','2013-07-30','18:40:00',1.56),('15128','2013-07-30','18:45:00',1.47),('15128','2013-07-30','18:50:00',1.39),('15128','2013-07-30','18:55:00',1.29),('15128','2013-07-30','19:00:00',1.2),('15128','2013-07-30','19:05:00',1.09),('15128','2013-07-30','19:10:00',1.01),('15128','2014-04-07','08:50:00',1.01),('15128','2014-04-07','08:55:00',1.09),('15128','2014-04-07','09:00:00',1.15),('15128','2014-04-07','09:05:00',1.21),('15128','2014-04-07','09:10:00',1.29),('15128','2014-04-07','09:15:00',1.34),('15128','2014-04-07','09:20:00',1.42),('15128','2014-04-07','09:25:00',1.46),('15128','2014-04-07','09:30:00',1.48),('15128','2014-04-07','09:35:00',1.52),('15128','2014-04-07','09:40:00',1.62),('15128','2014-04-07','09:45:00',1.7),('15128','2014-04-07','09:50:00',1.71),('15128','2014-04-07','09:55:00',1.73),('15128','2014-04-07','10:00:00',1.89),('15128','2014-04-07','10:05:00',1.93),('15128','2014-04-07','10:10:00',1.96),('15128','2014-04-07','10:15:00',2.03),('15128','2014-04-07','10:20:00',2.12),('15128','2014-04-07','10:25:00',2.17),('15128','2014-04-07','10:30:00',2.22),('15128','2014-04-07','10:35:00',2.27),('15128','2014-04-07','10:40:00',2.3),('15128','2014-04-07','10:45:00',2.39),('15128','2014-04-07','10:50:00',2.51),('15128','2014-04-07','10:55:00',2.59),('15128','2014-04-07','11:00:00',2.67),('15128','2014-04-07','11:05:00',2.73),('15128','2014-04-07','11:10:00',2.76),('15128','2014-04-07','11:15:00',2.79),('15128','2014-04-07','11:20:00',2.8),('15128','2014-04-07','11:25:00',2.89),('15128','2014-04-07','11:30:00',2.92),('15128','2014-04-07','11:35:00',3.06),('15128','2014-04-07','11:40:00',3.09),('15128','2014-04-07','11:45:00',3.09),('15128','2014-04-07','11:50:00',3.19),('15128','2014-04-07','11:55:00',3.24),('15128','2014-04-07','12:00:00',3.25),('15128','2014-04-07','12:05:00',3.21),('15128','2014-04-07','12:10:00',3.06),('15128','2014-04-07','12:15:00',2.86),('15128','2014-04-07','12:20:00',3.54),('15128','2014-04-07','12:25:00',3.14),('15128','2014-04-07','12:30:00',3.05),('15128','2014-04-07','12:35:00',3.48),('15128','2014-04-07','12:40:00',3.38),('15128','2014-04-07','12:45:00',3.47),('15128','2014-04-07','12:50:00',3.62),('15128','2014-04-07','12:55:00',3.62),('15128','2014-04-07','13:00:00',3.86),('15128','2014-04-07','13:05:00',3.84),('15128','2014-04-07','13:10:00',3.83),('15128','2014-04-07','13:15:00',3.93),('15128','2014-04-07','13:20:00',3.97),('15128','2014-04-07','13:25:00',3.92),('15128','2014-04-07','13:30:00',3.92),('15128','2014-04-07','13:35:00',3.94),('15128','2014-04-07','13:40:00',3.97),('15128','2014-04-07','13:45:00',3.94),('15128','2014-04-07','13:50:00',3.91),('15128','2014-04-07','13:55:00',3.9),('15128','2014-04-07','14:00:00',3.92),('15128','2014-04-07','14:05:00',3.97),('15128','2014-04-07','14:10:00',4.02),('15128','2014-04-07','14:15:00',3.9),('15128','2014-04-07','14:20:00',3.23),('15128','2014-04-07','14:25:00',3.58),('15128','2014-04-07','14:30:00',3.98),('15128','2014-04-07','14:35:00',3.14),('15128','2014-04-07','14:40:00',3.59),('15128','2014-04-07','14:45:00',3.84),('15128','2014-04-07','14:50:00',3.89),('15128','2014-04-07','14:55:00',3.82),('15128','2014-04-07','15:00:00',3.77),('15128','2014-04-07','15:05:00',3.75),('15128','2014-04-07','15:10:00',3.6),('15128','2014-04-07','15:15:00',3.66),('15128','2014-04-07','15:20:00',3.65),('15128','2014-04-07','15:25:00',3.56),('15128','2014-04-07','15:30:00',3.54),('15128','2014-04-07','15:35:00',3.39),('15128','2014-04-07','15:40:00',3.41),('15128','2014-04-07','15:45:00',3.46),('15128','2014-04-07','15:50:00',3.37),('15128','2014-04-07','15:55:00',3.31),('15128','2014-04-07','16:00:00',3.35),('15128','2014-04-07','16:05:00',3.25),('15128','2014-04-07','16:10:00',3.07),('15128','2014-04-07','16:15:00',3),('15128','2014-04-07','16:20:00',2.9),('15128','2014-04-07','16:25:00',3.06),('15128','2014-04-07','16:30:00',2.95),('15128','2014-04-07','16:35:00',2.87),('15128','2014-04-07','16:40:00',2.77),('15128','2014-04-07','16:45:00',2.71),('15128','2014-04-07','16:50:00',2.59),('15128','2014-04-07','16:55:00',2.47),('15128','2014-04-07','17:00:00',2.56),('15128','2014-04-07','17:05:00',2.42),('15128','2014-04-07','17:10:00',2.34),('15128','2014-04-07','17:15:00',2.18),('15128','2014-04-07','17:20:00',1.98),('15128','2014-04-07','17:25:00',1.86),('15128','2014-04-07','17:30:00',1.72),('15128','2014-04-07','17:35:00',1.72),('15128','2014-04-07','17:40:00',1.62),('15128','2014-04-07','17:45:00',1.55),('15128','2014-04-07','17:50:00',1.45),('15128','2014-04-07','17:55:00',1.39),('15128','2014-04-07','18:00:00',1.46),('15128','2014-04-07','18:05:00',1.32),('15128','2014-04-07','18:10:00',1.29),('15128','2014-04-07','18:15:00',1.16),('15128','2013-07-29','08:20:00',1.03),('15128','2013-07-29','08:25:00',1.08),('15128','2013-07-29','08:30:00',1.13),('15128','2013-07-29','08:35:00',1.19),('15128','2013-07-29','08:40:00',1.3),('15128','2013-07-29','08:45:00',1.38),('15128','2013-07-29','08:50:00',1.47),('15128','2013-07-29','08:55:00',1.57),('15128','2013-07-29','09:00:00',1.68),('15128','2013-07-29','09:05:00',1.8),('15128','2013-07-29','09:10:00',1.86),('15128','2013-07-29','09:15:00',1.86),('15128','2013-07-29','09:20:00',2.02),('15128','2013-07-29','09:25:00',2.19),('15128','2013-07-29','09:30:00',2.19),('15128','2013-07-29','09:35:00',2.21),('15128','2013-07-29','09:40:00',2.34),('15128','2013-07-29','09:45:00',2.32),('15128','2013-07-29','09:50:00',2.43),('15128','2013-07-29','09:55:00',2.42),('15128','2013-07-29','10:00:00',2.45),('15128','2013-07-29','10:05:00',2.62),('15128','2013-07-29','10:10:00',2.66),('15128','2013-07-29','10:15:00',2.73),('15128','2013-07-29','10:20:00',2.89),('15128','2013-07-29','10:25:00',2.9),('15128','2013-07-29','10:30:00',2.89),('15128','2013-07-29','10:35:00',2.58),('15128','2013-07-29','10:40:00',2.73),('15128','2013-07-29','10:45:00',3.03),('15128','2013-07-29','10:50:00',2.93),('15128','2013-07-29','10:55:00',3.02),('15128','2013-07-29','11:00:00',3.01),('15128','2013-07-29','11:05:00',3.04),('15128','2013-07-29','11:10:00',2.76),('15128','2013-07-29','11:15:00',1.79),('15128','2013-07-29','11:20:00',3.36),('15128','2013-07-29','11:25:00',3.48),('15128','2013-07-29','11:30:00',3.48),('15128','2013-07-29','11:35:00',3.54),('15128','2013-07-29','11:40:00',3.62),('15128','2013-07-29','11:45:00',3.64),('15128','2013-07-29','11:50:00',3.8),('15128','2013-07-29','11:55:00',3.96),('15128','2013-07-29','12:00:00',3.56),('15128','2013-07-29','12:05:00',3.48),('15128','2013-07-29','12:10:00',2.67),('15128','2013-07-29','12:15:00',2.87),('15128','2013-07-29','12:20:00',3.49),('15128','2013-07-29','12:30:00',2.26),('15128','2013-07-29','12:35:00',4.44),('15128','2013-07-29','12:40:00',4.38),('15128','2013-07-29','12:45:00',4.38),('15128','2013-07-29','12:50:00',4.37),('15128','2013-07-29','12:55:00',4.49),('15128','2013-07-29','13:00:00',2.41),('15128','2013-07-29','13:15:00',1.2),('15128','2013-07-29','13:20:00',2.14),('15128','2013-07-29','13:25:00',4.51),('15128','2013-07-29','13:30:00',4.4),('15128','2013-07-29','13:35:00',4.48),('15128','2013-07-29','13:40:00',4.42),('15128','2013-07-29','13:45:00',4.1),('15128','2013-07-29','13:50:00',3.13),('15128','2013-07-29','13:55:00',4.59),('15128','2013-07-29','14:00:00',4.59),('15128','2013-07-29','14:05:00',4.45),('15128','2013-07-29','14:10:00',4.38),('15128','2013-07-29','14:15:00',4.27),('15128','2013-07-29','14:20:00',4.26),('15128','2013-07-29','14:25:00',4.23),('15128','2013-07-29','14:30:00',4.21),('15128','2013-07-29','14:35:00',4.2),('15128','2013-07-29','14:40:00',4.24),('15128','2013-07-29','14:45:00',4.24),('15128','2013-07-29','14:50:00',4.17),('15128','2013-07-29','14:55:00',4.1),('15128','2013-07-29','15:00:00',4.06),('15128','2013-07-29','15:05:00',4.09),('15128','2013-07-29','15:10:00',4.04),('15128','2013-07-29','15:15:00',4),('15128','2013-07-29','15:20:00',4.02),('15128','2013-07-29','15:25:00',4),('15128','2013-07-29','15:30:00',3.98),('15128','2013-07-29','15:35:00',3.94),('15128','2013-07-29','15:40:00',3.9),('15128','2013-07-29','15:45:00',3.87),('15128','2013-07-29','15:50:00',3.83),('15128','2013-07-29','15:55:00',3.79),('15128','2013-07-29','16:00:00',3.74),('15128','2013-07-29','16:05:00',3.66),('15128','2013-07-29','16:10:00',3.59),('15128','2013-07-29','16:15:00',3.53),('15128','2013-07-29','16:20:00',3.48),('15128','2013-07-29','16:25:00',3.44),('15128','2013-07-29','16:30:00',3.37),('15128','2013-07-29','16:35:00',3.37),('15128','2013-07-29','16:40:00',3.29),('15128','2013-07-29','16:45:00',3.22),('15128','2013-07-29','16:50:00',3.18),('15128','2013-07-29','16:55:00',3.11),('15128','2013-07-29','17:00:00',3.07),('15128','2013-07-29','17:05:00',2.99),('15128','2013-07-29','17:10:00',2.91),('15128','2013-07-29','17:15:00',2.89),('15128','2013-07-29','17:20:00',2.81),('15128','2013-07-29','17:25:00',2.7),('15128','2013-07-29','17:30:00',2.63),('15128','2013-07-29','17:35:00',2.59),('15128','2013-07-29','17:40:00',2.51),('15128','2013-07-29','17:45:00',2.39),('15128','2013-07-29','17:50:00',2.29),('15128','2013-07-29','17:55:00',2.18),('15128','2013-07-29','18:00:00',2.05),('15128','2013-07-29','18:05:00',1.93),('15128','2013-07-29','18:10:00',1.84),('15128','2013-07-29','18:15:00',1.76),('15128','2013-07-29','18:20:00',1.7),('15128','2013-07-29','18:25:00',1.61),('15128','2013-07-29','18:30:00',1.54),('15128','2013-07-29','18:35:00',1.51),('15128','2013-07-29','18:40:00',1.43),('15128','2013-07-29','18:45:00',1.33),('15128','2013-07-29','18:50:00',1.26),('15128','2013-07-29','18:55:00',1.17),('15128','2013-07-29','19:00:00',1.06),('15128','2013-07-28','08:25:00',1.05),('15128','2013-07-28','08:30:00',1.1),('15128','2013-07-28','08:35:00',1.16),('15128','2013-07-28','08:40:00',1.24),('15128','2013-07-28','08:45:00',1.32),('15128','2013-07-28','08:50:00',1.36),('15128','2013-07-28','08:55:00',1.42),('15128','2013-07-28','09:00:00',1.49),('15128','2013-07-28','09:05:00',1.54),('15128','2013-07-28','09:10:00',1.59),('15128','2013-07-28','09:15:00',1.65),('15128','2013-07-28','09:20:00',1.77),('15128','2013-07-28','09:25:00',1.85),('15128','2013-07-28','09:30:00',1.92),('15128','2013-07-28','09:35:00',1.97),('15128','2013-07-28','09:40:00',2.03),('15128','2013-07-28','09:45:00',2.07),('15128','2013-07-28','09:50:00',2.09),('15128','2013-07-28','09:55:00',2.12),('15128','2013-07-28','10:00:00',2.14),('15128','2013-07-28','10:05:00',2.2),('15128','2013-07-28','10:10:00',2.24),('15128','2013-07-28','10:15:00',2.32),('15128','2013-07-28','10:20:00',2.41),('15128','2013-07-28','10:25:00',2.52),('15128','2013-07-28','10:30:00',2.58),('15128','2013-07-28','10:35:00',2.63),('15128','2013-07-28','10:40:00',2.72),('15128','2013-07-28','10:45:00',2.75),('15128','2013-07-28','10:50:00',2.8),('15128','2013-07-28','10:55:00',2.81),('15128','2013-07-28','11:00:00',2.89),('15128','2013-07-28','11:05:00',2.98),('15128','2013-07-28','11:10:00',3.09),('15128','2013-07-28','11:15:00',3.09),('15128','2013-07-28','11:20:00',3.15),('15128','2013-07-28','11:25:00',3.15),('15128','2013-07-28','11:30:00',3.19),('15128','2013-07-28','11:35:00',3.25),('15128','2013-07-28','11:40:00',3.23),('15128','2013-07-28','11:45:00',3.36),('15128','2013-07-28','11:50:00',3.5),('15128','2013-07-28','11:55:00',3.55),('15128','2013-07-28','12:00:00',3.66),('15128','2013-07-28','12:05:00',3.68),('15128','2013-07-28','12:10:00',3.71),('15128','2013-07-28','12:15:00',3.75),('15128','2013-07-28','12:20:00',3.78),('15128','2013-07-28','12:25:00',3.8),('15128','2013-07-28','12:30:00',3.84),('15128','2013-07-28','12:35:00',3.85),('15128','2013-07-28','12:40:00',3.85),('15128','2013-07-28','12:45:00',3.89),('15128','2013-07-28','12:50:00',3.92),('15128','2013-07-28','12:55:00',3.98),('15128','2013-07-28','13:00:00',4.03),('15128','2013-07-28','13:05:00',4.03),('15128','2013-07-28','13:10:00',4.05),('15128','2013-07-28','13:15:00',4.12),('15128','2013-07-28','13:20:00',4.13),('15128','2013-07-28','13:25:00',4.15),('15128','2013-07-28','13:30:00',4.2),('15128','2013-07-28','13:35:00',4.21),('15128','2013-07-28','13:40:00',4.22),('15128','2013-07-28','13:45:00',4.21),('15128','2013-07-28','13:50:00',4.21),('15128','2013-07-28','13:55:00',4.2),('15128','2013-07-28','14:00:00',4.21),('15128','2013-07-28','14:05:00',4.2),('15128','2013-07-28','14:10:00',4.19),('15128','2013-07-28','14:15:00',4.17),('15128','2013-07-28','14:20:00',4.18),('15128','2013-07-28','14:25:00',4.16),('15128','2013-07-28','14:30:00',4.14),('15128','2013-07-28','14:35:00',4.13),('15128','2013-07-28','14:40:00',4.11),('15128','2013-07-28','14:45:00',4.09),('15128','2013-07-28','14:50:00',4.07),('15128','2013-07-28','14:55:00',4.05),('15128','2013-07-28','15:00:00',4.04),('15128','2013-07-28','15:05:00',4.02),('15128','2013-07-28','15:10:00',3.97),('15128','2013-07-28','15:15:00',3.96),('15128','2013-07-28','15:20:00',3.94),('15128','2013-07-28','15:25:00',3.98),('15128','2013-07-28','15:30:00',4),('15128','2013-07-28','15:35:00',4.07),('15128','2013-07-28','15:40:00',3.25),('15128','2013-07-28','15:45:00',3.27),('15128','2013-07-28','15:50:00',2.56),('15128','2013-07-28','15:55:00',2.52),('15128','2013-07-28','16:00:00',2.72),('15128','2013-07-28','16:05:00',3.74),('15128','2013-07-28','16:10:00',2.97),('15128','2013-07-28','16:15:00',3.45),('15128','2013-07-28','16:20:00',2.55),('15128','2013-07-28','16:25:00',3.37),('15128','2013-07-28','16:30:00',3.67),('15128','2013-07-28','16:35:00',3.54),('15128','2013-07-28','16:40:00',3.26),('15128','2013-07-28','16:45:00',2.7),('15128','2013-07-28','16:50:00',1.92),('15128','2013-07-28','16:55:00',1.71),('15128','2013-07-28','17:00:00',1.75),('15128','2013-07-28','17:05:00',2.24),('15128','2013-07-28','17:10:00',3.05),('15128','2013-07-28','17:15:00',2.97),('15128','2013-07-28','17:20:00',2.2),('15128','2013-07-28','17:25:00',2.55),('15128','2013-07-28','17:35:00',1.49),('15128','2013-07-28','17:40:00',2.91),('15128','2013-07-28','17:45:00',2.52),('15128','2013-07-28','17:50:00',2.21),('15128','2013-07-28','17:55:00',1.32),('15128','2013-07-28','18:00:00',1.94),('15128','2013-07-28','18:05:00',1.8),('15128','2013-07-28','18:10:00',1.68),('15128','2013-07-28','18:15:00',1.86),('15128','2013-07-28','18:20:00',1.75),('15128','2013-07-28','18:25:00',1.64),('15128','2013-07-28','18:30:00',1.52),('15128','2013-07-28','18:35:00',1.08),('15128','2013-07-28','18:40:00',1.04),('15128','2013-07-28','18:45:00',1.23),('15128','2013-07-28','18:50:00',1.15),('15128','2013-07-28','18:55:00',1.39),('15128','2013-07-28','19:00:00',1.25),('15128','2013-07-27','08:25:00',1.05),('15128','2013-07-27','08:30:00',1.09),('15128','2013-07-27','08:35:00',1.15),('15128','2013-07-27','08:40:00',1.26),('15128','2013-07-27','08:45:00',1.33),('15128','2013-07-27','08:50:00',1.4),('15128','2013-07-27','08:55:00',1.46),('15128','2013-07-27','09:00:00',1.53),('15128','2013-07-27','09:05:00',1.59),('15128','2013-07-27','09:10:00',1.67),('15128','2013-07-27','09:15:00',1.75),('15128','2013-07-27','09:20:00',1.81),('15128','2013-07-27','09:25:00',1.9),('15128','2013-07-27','09:30:00',1.91),('15128','2013-07-27','09:35:00',1.93),('15128','2013-07-27','09:40:00',1.98),('15128','2013-07-27','09:45:00',2.04),('15128','2013-07-27','09:50:00',2.1),('15128','2013-07-27','09:55:00',2.12),('15128','2013-07-27','10:00:00',2.2),('15128','2013-07-27','10:05:00',2.23),('15128','2013-07-27','10:10:00',2.31),('15128','2013-07-27','10:15:00',2.34),('15128','2013-07-27','10:20:00',2.45),('15128','2013-07-27','10:25:00',2.53),('15128','2013-07-27','10:30:00',2.54),('15128','2013-07-27','10:35:00',2.57),('15128','2013-07-27','10:40:00',2.63),('15128','2013-07-27','10:45:00',2.69),('15128','2013-07-27','10:50:00',2.73),('15128','2013-07-27','10:55:00',2.79),('15128','2013-07-27','11:00:00',2.88),('15128','2013-07-27','11:05:00',2.93),('15128','2013-07-27','11:10:00',2.99),('15128','2013-07-27','11:15:00',2.88),('15128','2013-07-27','11:20:00',3),('15128','2013-07-27','11:25:00',3.05),('15128','2013-07-27','11:30:00',3.13),('15128','2013-07-27','11:35:00',3.2),('15128','2013-07-27','11:40:00',3.24),('15128','2013-07-27','11:45:00',3.31),('15128','2013-07-27','11:50:00',3.45),('15128','2013-07-27','11:55:00',3.44),('15128','2013-07-27','12:00:00',3.62),('15128','2013-07-27','12:05:00',3.59),('15128','2013-07-27','12:10:00',3.75),('15128','2013-07-27','12:15:00',3.77),('15128','2013-07-27','12:20:00',3.82),('15128','2013-07-27','12:25:00',3.82),('15128','2013-07-27','12:30:00',3.57),('15128','2013-07-27','12:35:00',3.9),('15128','2013-07-27','12:40:00',3.97),('15128','2013-07-27','12:45:00',3.96),('15128','2013-07-27','12:50:00',4.01),('15128','2013-07-27','12:55:00',4.02),('15128','2013-07-27','13:00:00',4.03),('15128','2013-07-27','13:05:00',4.03),('15128','2013-07-27','13:10:00',4.06),('15128','2013-07-27','13:15:00',4.07),('15128','2013-07-27','13:20:00',4.08),('15128','2013-07-27','13:25:00',4.1),('15128','2013-07-27','13:30:00',4.09),('15128','2013-07-27','13:35:00',4.14),('15128','2013-07-27','13:40:00',4.12),('15128','2013-07-27','13:45:00',4.14),('15128','2013-07-27','13:50:00',4.15),('15128','2013-07-27','13:55:00',4.14),('15128','2013-07-27','14:00:00',4.15),('15128','2013-07-27','14:05:00',4.14),('15128','2013-07-27','14:10:00',4.15),('15128','2013-07-27','14:15:00',4.14),('15128','2013-07-27','14:20:00',4.12),('15128','2013-07-27','14:25:00',4.12),('15128','2013-07-27','14:30:00',4.11),('15128','2013-07-27','14:35:00',4.09),('15128','2013-07-27','14:40:00',4.09),('15128','2013-07-27','14:45:00',4.06),('15128','2013-07-27','14:50:00',4.03),('15128','2013-07-27','14:55:00',4.03),('15128','2013-07-27','15:00:00',4.02),('15128','2013-07-27','15:05:00',3.98),('15128','2013-07-27','15:10:00',3.92),('15128','2013-07-27','15:15:00',3.92),('15128','2013-07-27','15:20:00',3.9),('15128','2013-07-27','15:25:00',3.88),('15128','2013-07-27','15:30:00',3.86),('15128','2013-07-27','15:35:00',3.84),('15128','2013-07-27','15:40:00',3.84),('15128','2013-07-27','15:45:00',3.82),('15128','2013-07-27','15:50:00',3.79),('15128','2013-07-27','15:55:00',3.76),('15128','2013-07-27','16:00:00',3.73),('15128','2013-07-27','16:05:00',3.68),('15128','2013-07-27','16:10:00',3.66),('15128','2013-07-27','16:15:00',3.62),('15128','2013-07-27','16:20:00',3.56),('15128','2013-07-27','16:25:00',3.51),('15128','2013-07-27','16:30:00',3.46),('15128','2013-07-27','16:35:00',3.39),('15128','2013-07-27','16:40:00',3.35),('15128','2013-07-27','16:45:00',3.28),('15128','2013-07-27','16:50:00',3.24),('15128','2013-07-27','16:55:00',3.17),('15128','2013-07-27','17:00:00',3.12),('15128','2013-07-27','17:05:00',3.07),('15128','2013-07-27','17:10:00',3.01),('15128','2013-07-27','17:15:00',2.95),('15128','2013-07-27','17:20:00',2.88),('15128','2013-07-27','17:25:00',2.8),('15128','2013-07-27','17:30:00',2.74),('15128','2013-07-27','17:35:00',2.66),('15128','2013-07-27','17:40:00',2.57),('15128','2013-07-27','17:45:00',2.45),('15128','2013-07-27','17:50:00',2.35),('15128','2013-07-27','17:55:00',2.23),('15128','2013-07-27','18:00:00',2.12),('15128','2013-07-27','18:05:00',2.02),('15128','2013-07-27','18:10:00',1.89),('15128','2013-07-27','18:15:00',1.84),('15128','2013-07-27','18:20:00',1.74),('15128','2013-07-27','18:25:00',1.67),('15128','2013-07-27','18:30:00',1.59),('15128','2013-07-27','18:35:00',1.52),('15128','2013-07-27','18:40:00',1.47),('15128','2013-07-27','18:45:00',1.39),('15128','2013-07-27','18:50:00',1.32),('15128','2013-07-27','18:55:00',1.22),('15128','2013-07-27','19:00:00',1.12),('15128','2013-07-27','19:05:00',1.01),('15128','2013-07-26','08:25:00',1.08),('15128','2013-07-26','08:30:00',1.12),('15128','2013-07-26','08:35:00',1.19),('15128','2013-07-26','08:40:00',1.29),('15128','2013-07-26','08:45:00',1.36),('15128','2013-07-26','08:50:00',1.43),('15128','2013-07-26','08:55:00',1.49),('15128','2013-07-26','09:00:00',1.56),('15128','2013-07-26','09:05:00',1.62),('15128','2013-07-26','09:10:00',1.71),('15128','2013-07-26','09:15:00',1.78),('15128','2013-07-26','09:20:00',1.85),('15128','2013-07-26','09:25:00',1.97),('15128','2013-07-26','09:30:00',1.93),('15128','2013-07-26','09:35:00',1.95),('15128','2013-07-26','09:40:00',2.01),('15128','2013-07-26','09:45:00',2.06),('15128','2013-07-26','09:50:00',2.12),('15128','2013-07-26','09:55:00',2.17),('15128','2013-07-26','10:00:00',2.23),('15128','2013-07-26','10:05:00',2.28),('15128','2013-07-26','10:10:00',2.35),('15128','2013-07-26','10:20:00',2.56),('15128','2013-07-26','10:25:00',2.62),('15128','2013-07-26','10:30:00',2.61),('15128','2013-07-26','10:35:00',2.66),('15128','2013-07-26','10:50:00',2.86),('15128','2013-07-26','10:55:00',2.91),('15128','2013-07-26','11:00:00',2.97),('15128','2013-07-26','11:05:00',3.02),('15128','2013-07-26','11:10:00',3.09),('15128','2013-07-26','11:15:00',3.08),('15128','2013-07-26','11:20:00',3.14),('15128','2013-07-26','11:25:00',3.15),('15128','2013-07-26','11:30:00',3.2),('15128','2013-07-26','11:35:00',3.31),('15128','2013-07-26','11:40:00',3.18),('15128','2013-07-26','11:45:00',3.27),('15128','2013-07-26','11:50:00',3.48),('15128','2013-07-26','11:55:00',3.6),('15128','2013-07-26','12:00:00',3.64),('15128','2013-07-26','12:05:00',3.83),('15128','2013-07-26','12:10:00',3.79),('15128','2013-07-26','12:15:00',3.82),('15128','2013-07-26','12:20:00',3.84),('15128','2013-07-26','12:25:00',3.91),('15128','2013-07-26','12:30:00',3.87),('15128','2013-07-26','12:35:00',3.74),('15128','2013-07-26','12:40:00',3.94),('15128','2013-07-26','12:45:00',3.96),('15128','2013-07-26','12:50:00',3.91),('15128','2013-07-26','12:55:00',3.98),('15128','2013-07-26','13:00:00',4.04),('15128','2013-07-26','13:05:00',4.06),('15128','2013-07-26','13:10:00',4.05),('15128','2013-07-26','13:15:00',4.05),('15128','2013-07-26','13:20:00',4.09),('15128','2013-07-26','13:25:00',4.14),('15128','2013-07-26','13:30:00',4.14),('15128','2013-07-26','13:35:00',4.16),('15128','2013-07-26','13:40:00',4.15),('15128','2013-07-26','13:45:00',4.17),('15128','2013-07-26','13:50:00',4.17),('15128','2013-07-26','13:55:00',4.2),('15128','2013-07-26','14:00:00',4.19),('15128','2013-07-26','14:05:00',4.18),('15128','2013-07-26','14:10:00',4.16),('15128','2013-07-26','14:15:00',4.17),('15128','2013-07-26','14:20:00',4.15),('15128','2013-07-26','14:25:00',4.13),('15128','2013-07-26','14:30:00',4.14),('15128','2013-07-26','14:35:00',4.15),('15128','2013-07-26','14:40:00',4.11),('15128','2013-07-26','14:45:00',4.07),('15128','2013-07-26','14:50:00',4.07),('15128','2013-07-26','14:55:00',4.07),('15128','2013-07-26','15:00:00',4.06),('15128','2013-07-26','15:05:00',4.04),('15128','2013-07-26','15:10:00',4),('15128','2013-07-26','15:15:00',3.98),('15128','2013-07-26','15:20:00',3.94),('15128','2013-07-26','15:25:00',3.9),('15128','2013-07-26','15:30:00',3.87),('15128','2013-07-26','15:35:00',3.86),('15128','2013-07-26','15:40:00',3.84),('15128','2013-07-26','15:45:00',3.81),('15128','2013-07-26','15:50:00',3.76),('15128','2013-07-26','15:55:00',3.73),('15128','2013-07-26','16:00:00',3.69),('15128','2013-07-26','16:05:00',3.65),('15128','2013-07-26','16:10:00',3.61),('15128','2013-07-26','16:15:00',3.56),('15128','2013-07-26','16:20:00',3.54),('15128','2013-07-26','16:25:00',3.5),('15128','2013-07-26','16:30:00',3.46),('15128','2013-07-26','16:35:00',3.42),('15128','2013-07-26','16:40:00',3.36),('15128','2013-07-26','16:45:00',3.3),('15128','2013-07-26','16:50:00',3.25),('15128','2013-07-26','16:55:00',3.18),('15128','2013-07-26','17:00:00',3.14),('15128','2013-07-26','17:05:00',3.06),('15128','2013-07-26','17:10:00',2.99),('15128','2013-07-26','17:15:00',2.95),('15128','2013-07-26','17:20:00',2.89),('15128','2013-07-26','17:25:00',2.8),('15128','2013-07-26','17:30:00',2.72),('15128','2013-07-26','17:35:00',2.65),('15128','2013-07-26','17:40:00',2.56),('15128','2013-07-26','17:45:00',2.44),('15128','2013-07-26','17:50:00',2.36),('15128','2013-07-26','17:55:00',2.26),('15128','2013-07-26','18:00:00',2.15),('15128','2013-07-26','18:05:00',2.02),('15128','2013-07-26','18:10:00',1.94),('15128','2013-07-26','18:15:00',1.84),('15128','2013-07-26','18:20:00',1.79),('15128','2013-07-26','18:25:00',1.71),('15128','2013-07-26','18:30:00',1.63),('15128','2013-07-26','18:35:00',1.56),('15128','2013-07-26','18:40:00',1.49),('15128','2013-07-26','18:45:00',1.44),('15128','2013-07-26','18:50:00',1.38),('15128','2013-07-26','18:55:00',1.29),('15128','2013-07-26','19:00:00',1.2),('15128','2013-07-26','19:05:00',1.1),('15128','2013-07-25','08:25:00',1.07),('15128','2013-07-25','08:30:00',1.13),('15128','2013-07-25','08:35:00',1.21),('15128','2013-07-25','08:40:00',1.34),('15128','2013-07-25','08:45:00',1.37),('15128','2013-07-25','08:50:00',1.37),('15128','2013-07-25','08:55:00',1.43),('15128','2013-07-25','09:00:00',1.54),('15128','2013-07-25','09:05:00',1.62),('15128','2013-07-25','09:10:00',1.73),('15128','2013-07-25','09:15:00',1.79),('15128','2013-07-25','09:20:00',1.83),('15128','2013-07-25','09:25:00',1.93),('15128','2013-07-25','09:30:00',1.92),('15128','2013-07-25','09:35:00',2),('15128','2013-07-25','09:40:00',2.05),('15128','2013-07-25','09:45:00',2.07),('15128','2013-07-25','09:50:00',2.14),('15128','2013-07-25','09:55:00',2.19),('15128','2013-07-25','10:00:00',2.25),('15128','2013-07-25','10:05:00',2.33),('15128','2013-07-25','10:10:00',2.37),('15128','2013-07-25','10:15:00',2.43),('15128','2013-07-25','10:20:00',2.51),('15128','2013-07-25','10:25:00',2.51),('15128','2013-07-25','10:30:00',2.56),('15128','2013-07-25','10:35:00',2.62),('15128','2013-07-25','10:40:00',2.73),('15128','2013-07-25','10:45:00',2.78),('15128','2013-07-25','10:50:00',2.84),('15128','2013-07-25','10:55:00',2.91),('15128','2013-07-25','11:00:00',3.02),('15128','2013-07-25','11:05:00',3.01),('15128','2013-07-25','11:10:00',3.11),('15128','2013-07-25','11:15:00',3.14),('15128','2013-07-25','11:20:00',3.19),('15128','2013-07-25','11:25:00',3.24),('15128','2013-07-25','11:30:00',3.31),('15128','2013-07-25','11:35:00',3.32),('15128','2013-07-25','11:40:00',3.46),('15128','2013-07-25','11:45:00',3.49),('15128','2013-07-25','11:50:00',3.38),('15128','2013-07-25','11:55:00',2.86),('15128','2013-07-25','12:00:00',3.72),('15128','2013-07-25','12:05:00',3.87),('15128','2013-07-25','12:10:00',3.83),('15128','2013-07-25','12:15:00',2.47),('15128','2013-07-25','12:20:00',3.38),('15128','2013-07-25','12:25:00',3.22),('15128','2013-07-25','12:30:00',4.36),('15128','2013-07-25','12:35:00',3.1),('15128','2013-07-25','12:40:00',1.51),('15128','2013-07-25','12:45:00',2.05),('15128','2013-07-25','12:50:00',4.27),('15128','2013-07-25','12:55:00',3.05),('15128','2013-07-25','13:00:00',2.74),('15128','2013-07-25','13:05:00',4.23),('15128','2013-07-25','13:10:00',4.64),('15128','2013-07-25','13:15:00',2.72),('15128','2013-07-25','13:20:00',4.33),('15128','2013-07-25','13:25:00',3.68),('15128','2013-07-25','13:30:00',4.57),('15128','2013-07-25','13:35:00',4.29),('15128','2013-07-25','13:40:00',4.15),('15128','2013-07-25','13:45:00',4.2),('15128','2013-07-25','13:50:00',4.29),('15128','2013-07-25','13:55:00',4.24),('15128','2013-07-25','14:00:00',4.25),('15128','2013-07-25','14:05:00',4.26),('15128','2013-07-25','14:10:00',4.18),('15128','2013-07-25','14:15:00',4.24),('15128','2013-07-25','14:20:00',4.14),('15128','2013-07-25','14:25:00',4.21),('15128','2013-07-25','14:30:00',4.16),('15128','2013-07-25','14:35:00',4.2),('15128','2013-07-25','14:40:00',4.18),('15128','2013-07-25','14:45:00',4.15),('15128','2013-07-25','14:50:00',4.12),('15128','2013-07-25','14:55:00',4.13),('15128','2013-07-25','15:00:00',4.11),('15128','2013-07-25','15:05:00',4.06),('15128','2013-07-25','15:10:00',4.06),('15128','2013-07-25','15:15:00',4.04),('15128','2013-07-25','15:20:00',3.99),('15128','2013-07-25','15:25:00',3.95),('15128','2013-07-25','15:30:00',3.91),('15128','2013-07-25','15:35:00',3.9),('15128','2013-07-25','15:40:00',3.86),('15128','2013-07-25','15:45:00',3.88),('15128','2013-07-25','15:50:00',3.85),('15128','2013-07-25','15:55:00',3.8),('15128','2013-07-25','16:00:00',3.74),('15128','2013-07-25','16:05:00',3.72),('15128','2013-07-25','16:10:00',3.69),('15128','2013-07-25','16:15:00',3.61),('15128','2013-07-25','16:20:00',3.52),('15128','2013-07-25','16:25:00',3.51),('15128','2013-07-25','16:30:00',3.45),('15128','2013-07-25','16:35:00',3.43),('15128','2013-07-25','16:40:00',3.35),('15128','2013-07-25','16:45:00',3.25),('15128','2013-07-25','16:50:00',3.2),('15128','2013-07-25','16:55:00',3.13),('15128','2013-07-25','17:00:00',3.08),('15128','2013-07-25','17:05:00',3.01),('15128','2013-07-25','17:10:00',2.99),('15128','2013-07-25','17:15:00',2.92),('15128','2013-07-25','17:20:00',2.85),('15128','2013-07-25','17:25:00',2.77),('15128','2013-07-25','17:30:00',2.7),('15128','2013-07-25','17:35:00',2.6),('15128','2013-07-25','17:40:00',2.51),('15128','2013-07-25','17:45:00',2.41),('15128','2013-07-25','17:50:00',2.3),('15128','2013-07-25','17:55:00',2.19),('15128','2013-07-25','18:00:00',2.06),('15128','2013-07-25','18:05:00',1.95),('15128','2013-07-25','18:10:00',1.84),('15128','2013-07-25','18:15:00',1.78),('15128','2013-07-25','18:20:00',1.73),('15128','2013-07-25','18:25:00',1.65),('15128','2013-07-25','18:30:00',1.55),('15128','2013-07-25','18:35:00',1.46),('15128','2013-07-25','18:40:00',1.39),('15128','2013-07-25','18:45:00',1.33),('15128','2013-07-25','18:50:00',1.25),('15128','2013-07-25','18:55:00',1.16),('15128','2013-07-25','19:00:00',1.07),('15128','2013-07-24','08:25:00',1.07),('15128','2013-07-24','08:30:00',1.14),('15128','2013-07-24','08:35:00',1.2),('15128','2013-07-24','08:40:00',1.27),('15128','2013-07-24','08:45:00',1.35),('15128','2013-07-24','08:50:00',1.39),('15128','2013-07-24','08:55:00',1.43),('15128','2013-07-24','09:00:00',1.53),('15128','2013-07-24','09:05:00',1.61),('15128','2013-07-24','09:10:00',1.75),('15128','2013-07-24','09:15:00',1.75),('15128','2013-07-24','09:20:00',2.03),('15128','2013-07-24','09:25:00',2.19),('15128','2013-07-24','09:30:00',2.16),('15128','2013-07-24','09:35:00',1.47),('15128','2013-07-24','09:40:00',1.97),('15128','2013-07-24','09:45:00',2.07),('15128','2013-07-24','09:50:00',2.19),('15128','2013-07-24','09:55:00',2.4),('15128','2013-07-24','10:00:00',2.48),('15128','2013-07-24','10:05:00',2.6),('15128','2013-07-24','10:10:00',2.64),('15128','2013-07-24','10:15:00',1.56),('15128','2013-07-24','10:20:00',1.28),('15128','2013-07-24','10:30:00',2.39),('15128','2013-07-24','10:35:00',2.87),('15128','2013-07-24','10:40:00',2.9),('15128','2013-07-24','10:45:00',3),('15128','2013-07-24','10:50:00',2.99),('15128','2013-07-24','10:55:00',3.09),('15128','2013-07-24','11:00:00',3.01),('15128','2013-07-24','11:05:00',3.21),('15128','2013-07-24','11:10:00',3.17),('15128','2013-07-24','11:15:00',3.21),('15128','2013-07-24','11:20:00',3.01),('15128','2013-07-24','11:25:00',3.35),('15128','2013-07-24','11:30:00',3.36),('15128','2013-07-24','11:35:00',3.31),('15128','2013-07-24','11:40:00',3.44),('15128','2013-07-24','11:45:00',3.55),('15128','2013-07-24','11:50:00',2.71),('15128','2013-07-24','11:55:00',2),('15128','2013-07-24','12:00:00',3.75),('15128','2013-07-24','12:05:00',4.01),('15128','2013-07-24','12:10:00',4.05),('15128','2013-07-24','12:15:00',4.2),('15128','2013-07-24','12:20:00',4),('15128','2013-07-24','12:25:00',4.08),('15128','2013-07-24','12:30:00',3.95),('15128','2013-07-24','12:35:00',4.08),('15128','2013-07-24','12:40:00',4.03),('15128','2013-07-24','12:45:00',3.97),('15128','2013-07-24','12:50:00',3.93),('15128','2013-07-24','12:55:00',4.24),('15128','2013-07-24','13:00:00',2.92),('15128','2013-07-24','13:05:00',3.96),('15128','2013-07-24','13:10:00',4.26),('15128','2013-07-24','13:15:00',4.23),('15128','2013-07-24','13:20:00',4.15),('15128','2013-07-24','13:25:00',4.31),('15128','2013-07-24','13:30:00',4.32),('15128','2013-07-24','13:35:00',4.28),('15128','2013-07-24','13:40:00',4.35),('15128','2013-07-24','13:45:00',4.36),('15128','2013-07-24','13:50:00',4.36),('15128','2013-07-24','13:55:00',4.39),('15128','2013-07-24','14:00:00',4.36),('15128','2013-07-24','14:05:00',4.38),('15128','2013-07-24','14:10:00',4.36),('15128','2013-07-24','14:15:00',4.36),('15128','2013-07-24','14:20:00',4.37),('15128','2013-07-24','14:25:00',4.36),('15128','2013-07-24','14:30:00',4.36),('15128','2013-07-24','14:35:00',4.36),('15128','2013-07-24','14:40:00',4.33),('15128','2013-07-24','14:45:00',4.34),('15128','2013-07-24','14:50:00',4.3),('15128','2013-07-24','14:55:00',4.27),('15128','2013-07-24','15:00:00',4.22),('15128','2013-07-24','15:05:00',4.24),('15128','2013-07-24','15:10:00',4.21),('15128','2013-07-24','15:15:00',4.2),('15128','2013-07-24','15:20:00',4.2),('15128','2013-07-24','15:25:00',4.18),('15128','2013-07-24','15:30:00',4.12),('15128','2013-07-24','15:35:00',4.1),('15128','2013-07-24','15:40:00',4.09),('15128','2013-07-24','15:45:00',4.04),('15128','2013-07-24','15:50:00',4),('15128','2013-07-24','15:55:00',3.97),('15128','2013-07-24','16:00:00',3.91),('15128','2013-07-24','16:05:00',3.89),('15128','2013-07-24','16:10:00',3.85),('15128','2013-07-24','16:15:00',3.83),('15128','2013-07-24','16:20:00',3.76),('15128','2013-07-24','16:25:00',3.72),('15128','2013-07-24','16:30:00',3.62),('15128','2013-07-24','16:35:00',3.57),('15128','2013-07-24','16:40:00',3.54),('15128','2013-07-24','16:45:00',3.49),('15128','2013-07-24','16:50:00',3.42),('15128','2013-07-24','16:55:00',3.32),('15128','2013-07-24','17:00:00',3.31),('15128','2013-07-24','17:05:00',3.27),('15128','2013-07-24','17:10:00',3.18),('15128','2013-07-24','17:15:00',3.08),('15128','2013-07-24','17:20:00',3.02),('15128','2013-07-24','17:25:00',2.94),('15128','2013-07-24','17:30:00',2.87),('15128','2013-07-24','17:35:00',2.81),('15128','2013-07-24','17:40:00',2.73),('15128','2013-07-24','17:45:00',2.6),('15128','2013-07-24','17:50:00',2.48),('15128','2013-07-24','17:55:00',2.37),('15128','2013-07-24','18:00:00',2.23),('15128','2013-07-24','18:05:00',2.13),('15128','2013-07-24','18:10:00',2.01),('15128','2013-07-24','18:15:00',1.89),('15128','2013-07-24','18:20:00',1.84),('15128','2013-07-24','18:25:00',1.76),('15128','2013-07-24','18:30:00',1.69),('15128','2013-07-24','18:35:00',1.63),('15128','2013-07-24','18:40:00',1.57),('15128','2013-07-24','18:45:00',1.44),('15128','2013-07-24','18:50:00',1.39),('15128','2013-07-24','18:55:00',1.31),('15128','2013-07-24','19:00:00',1.17),('15128','2013-07-24','19:05:00',1.06),('15128','2013-07-23','08:15:00',1.22),('15128','2013-07-23','08:20:00',1.15),('15128','2013-07-23','08:25:00',1.08),('15128','2013-07-23','08:30:00',1.21),('15128','2013-07-23','08:45:00',1.03),('15128','2013-07-23','08:50:00',1.1),('15128','2013-07-23','08:55:00',1.14),('15128','2013-07-23','09:00:00',1.17),('15128','2013-07-23','09:05:00',1.52),('15128','2013-07-23','09:10:00',1.84),('15128','2013-07-23','09:15:00',2.09),('15128','2013-07-23','09:20:00',1.64),('15128','2013-07-23','09:25:00',1.8),('15128','2013-07-23','09:30:00',1.73),('15128','2013-07-23','09:50:00',1.69),('15128','2013-07-23','09:55:00',2.55),('15128','2013-07-23','10:00:00',2.56),('15128','2013-07-23','10:05:00',2.82),('15128','2013-07-23','10:10:00',1.93),('15128','2013-07-23','10:15:00',1.27),('15128','2013-07-23','10:30:00',1.28),('15128','2013-07-23','10:35:00',3.06),('15128','2013-07-23','10:40:00',3.11),('15128','2013-07-23','10:45:00',3.3),('15128','2013-07-23','10:50:00',2.6),('15128','2013-07-23','10:55:00',1.5),('15128','2013-07-23','11:00:00',1.2),('15128','2013-07-23','11:05:00',2.92),('15128','2013-07-23','11:10:00',3.43),('15128','2013-07-23','11:15:00',3.47),('15128','2013-07-23','11:20:00',2.39),('15128','2013-07-23','11:25:00',3.43),('15128','2013-07-23','11:30:00',3.57),('15128','2013-07-23','11:35:00',3.55),('15128','2013-07-23','11:40:00',3.09),('15128','2013-07-23','11:45:00',3.81),('15128','2013-07-23','11:50:00',3.89),('15128','2013-07-23','11:55:00',3.95),('15128','2013-07-23','12:00:00',4.12),('15128','2013-07-23','12:05:00',4.16),('15128','2013-07-23','12:10:00',4.08),('15128','2013-07-23','12:15:00',4.18),('15128','2013-07-23','12:20:00',4.19),('15128','2013-07-23','12:25:00',2.47),('15128','2013-07-23','12:30:00',3.87),('15128','2013-07-23','12:35:00',3.98),('15128','2013-07-23','12:40:00',4.21),('15128','2013-07-23','12:45:00',4.2),('15128','2013-07-23','12:50:00',4.19),('15128','2013-07-23','12:55:00',4.17),('15128','2013-07-23','13:00:00',4.08),('15128','2013-07-23','13:05:00',4.14),('15128','2013-07-23','13:10:00',4.11),('15128','2013-07-23','13:15:00',4.17),('15128','2013-07-23','13:20:00',4.23),('15128','2013-07-23','13:25:00',4.25),('15128','2013-07-23','13:30:00',4.27),('15128','2013-07-23','13:35:00',4.32),('15128','2013-07-23','13:40:00',4.22),('15128','2013-07-23','13:45:00',4.36),('15128','2013-07-23','13:50:00',4.25),('15128','2013-07-23','13:55:00',4.32),('15128','2013-07-23','14:00:00',4.34),('15128','2013-07-23','14:05:00',4.35),('15128','2013-07-23','14:10:00',4.34),('15128','2013-07-23','14:15:00',4.33),('15128','2013-07-23','14:20:00',4.36),('15128','2013-07-23','14:25:00',4.33),('15128','2013-07-23','14:30:00',4.35),('15128','2013-07-23','14:35:00',4.34),('15128','2013-07-23','14:40:00',4.31),('15128','2013-07-23','14:45:00',4.33),('15128','2013-07-23','14:50:00',4.33),('15128','2013-07-23','14:55:00',4.32),('15128','2013-07-23','15:00:00',4.32),('15128','2013-07-23','15:05:00',4.28),('15128','2013-07-23','15:10:00',4.27),('15128','2013-07-23','15:15:00',4.24),('15128','2013-07-23','15:20:00',3.89),('15128','2013-07-23','15:25:00',4.18),('15128','2013-07-23','15:30:00',4.18),('15128','2013-07-23','15:35:00',4.05),('15128','2013-07-23','15:40:00',3.96),('15128','2013-07-23','15:45:00',3.94),('15128','2013-07-23','15:50:00',3.74),('15128','2013-07-23','15:55:00',3.58),('15128','2013-07-23','16:00:00',3.89),('15128','2013-07-23','16:05:00',3.96),('15128','2013-07-23','16:10:00',3.85),('15128','2013-07-23','16:15:00',3.76),('15128','2013-07-23','16:20:00',3.74),('15128','2013-07-23','16:25:00',3.79),('15128','2013-07-23','16:30:00',3.45),('15128','2013-07-23','16:35:00',3.58),('15128','2013-07-23','16:40:00',3.92),('15128','2013-07-23','16:45:00',3.86),('15128','2013-07-23','16:50:00',3.56),('15128','2013-07-23','16:55:00',2.81),('15128','2013-07-23','17:00:00',3.62),('15128','2013-07-23','17:05:00',3.43),('15128','2013-07-23','17:10:00',3.3),('15128','2013-07-23','17:15:00',3.17),('15128','2013-07-23','17:20:00',3.04),('15128','2013-07-23','17:25:00',2.9),('15128','2013-07-23','17:30:00',2.8),('15128','2013-07-23','17:35:00',2.79),('15128','2013-07-23','17:40:00',2.6),('15128','2013-07-23','17:45:00',2.58),('15128','2013-07-23','17:50:00',2.45),('15128','2013-07-23','17:55:00',2.31),('15128','2013-07-23','18:00:00',2.23),('15128','2013-07-23','18:05:00',2.13),('15128','2013-07-23','18:10:00',1.83),('15128','2013-07-23','18:15:00',1.19),('15128','2013-07-23','18:20:00',1.52),('15128','2013-07-23','18:25:00',1.27),('15128','2013-07-23','18:30:00',1.63),('15128','2013-07-23','18:35:00',1.6),('15128','2013-07-23','18:40:00',1.55),('15128','2013-07-23','18:45:00',1.41),('15128','2013-07-23','18:50:00',1.19),('15128','2013-07-23','18:55:00',1.28),('15128','2013-07-22','08:30:00',1.2),('15128','2013-07-22','08:35:00',1.29),('15128','2013-07-22','08:40:00',1.37),('15128','2013-07-22','08:45:00',1.24),('15128','2013-07-22','08:50:00',1.5),('15128','2013-07-22','08:55:00',1.57),('15128','2013-07-22','09:00:00',1.64),('15128','2013-07-22','09:05:00',1.46),('15128','2013-07-22','09:10:00',1.81),('15128','2013-07-22','09:15:00',1.89),('15128','2013-07-22','09:20:00',1.99),('15128','2013-07-22','09:25:00',1.88),('15128','2013-07-22','09:30:00',1.88),('15128','2013-07-22','09:35:00',2.1),('15128','2013-07-22','09:40:00',2.15),('15128','2013-07-22','09:45:00',2.2),('15128','2013-07-22','09:50:00',1.8),('15128','2013-07-22','09:55:00',2.24),('15128','2013-07-22','10:00:00',2.34),('15128','2013-07-22','10:05:00',2.41),('15128','2013-07-22','10:10:00',2.49),('15128','2013-07-22','10:15:00',2.54),('15128','2013-07-22','10:20:00',2.61),('15128','2013-07-22','10:25:00',2.69),('15128','2013-07-22','10:30:00',2.7),('15128','2013-07-22','10:35:00',2.74),('15128','2013-07-22','10:40:00',2.79),('15128','2013-07-22','10:45:00',2.81),('15128','2013-07-22','10:50:00',2.88),('15128','2013-07-22','10:55:00',2.91),('15128','2013-07-22','11:00:00',3),('15128','2013-07-22','11:05:00',3.04),('15128','2013-07-22','11:10:00',3.15),('15128','2013-07-22','11:15:00',2.99),('15128','2013-07-22','11:20:00',3.1),('15128','2013-07-22','11:25:00',3.34),('15128','2013-07-22','11:30:00',3.47),('15128','2013-07-22','11:35:00',3.55),('15128','2013-07-22','11:40:00',3.3),('15128','2013-07-22','11:45:00',3.33),('15128','2013-07-22','11:50:00',1.39),('15128','2013-07-22','11:55:00',1.24),('15128','2013-07-22','12:00:00',1.28),('15128','2013-07-22','12:05:00',2.91),('15128','2013-07-22','12:10:00',2.76),('15128','2013-07-22','12:15:00',1.6),('15128','2013-07-22','12:20:00',4.28),('15128','2013-07-22','12:25:00',4.22),('15128','2013-07-22','12:30:00',2.56),('15128','2013-07-22','12:35:00',3.51),('15128','2013-07-22','12:40:00',4.26),('15128','2013-07-22','12:45:00',4),('15128','2013-07-22','12:50:00',3.97),('15128','2013-07-22','12:55:00',3.87),('15128','2013-07-22','13:00:00',4.31),('15128','2013-07-22','13:05:00',3.96),('15128','2013-07-22','13:10:00',4.3),('15128','2013-07-22','13:15:00',4.34),('15128','2013-07-22','13:20:00',4.26),('15128','2013-07-22','13:25:00',4.4),('15128','2013-07-22','13:30:00',4.39),('15128','2013-07-22','13:35:00',1.84),('15128','2013-07-22','13:40:00',3.55),('15128','2013-07-22','13:45:00',4.32),('15128','2013-07-22','13:50:00',1.19),('15128','2013-07-22','13:55:00',1.32),('15128','2013-07-22','14:00:00',1.38),('15128','2013-07-22','14:05:00',3.27),('15128','2013-07-22','14:10:00',1.77),('15128','2013-07-22','14:15:00',4.76),('15128','2013-07-22','14:20:00',4.66),('15128','2013-07-22','14:25:00',4.51),('15128','2013-07-22','14:30:00',4.49),('15128','2013-07-22','14:35:00',4.36),('15128','2013-07-22','14:40:00',4.3),('15128','2013-07-22','14:45:00',4.32),('15128','2013-07-22','14:50:00',4.26),('15128','2013-07-22','14:55:00',4.28),('15128','2013-07-22','15:00:00',4.26),('15128','2013-07-22','15:05:00',4.22),('15128','2013-07-22','15:10:00',4.19),('15128','2013-07-22','15:15:00',4.15),('15128','2013-07-22','15:20:00',4.09),('15128','2013-07-22','15:25:00',4.03),('15128','2013-07-22','15:30:00',4.01),('15128','2013-07-22','15:35:00',3.97),('15128','2013-07-22','15:40:00',3.98),('15128','2013-07-22','15:45:00',3.91),('15128','2013-07-22','15:50:00',3.92),('15128','2013-07-22','15:55:00',3.86),('15128','2013-07-22','16:00:00',3.83),('15128','2013-07-22','16:05:00',3.8),('15128','2013-07-22','16:10:00',3.76),('15128','2013-07-22','16:15:00',3.73),('15128','2013-07-22','16:20:00',3.7),('15128','2013-07-22','16:25:00',3.65),('15128','2013-07-22','16:30:00',3.57),('15128','2013-07-22','16:35:00',3.52),('15128','2013-07-22','16:40:00',3.46),('15128','2013-07-22','16:45:00',3.39),('15128','2013-07-22','16:50:00',3.32),('15128','2013-07-22','16:55:00',3.28),('15128','2013-07-22','17:00:00',3.23),('15128','2013-07-22','17:05:00',3.16),('15128','2013-07-22','17:10:00',3.11),('15128','2013-07-22','17:15:00',3.02),('15128','2013-07-22','17:20:00',2.94),('15128','2013-07-22','17:25:00',2.86),('15128','2013-07-22','17:30:00',2.81),('15128','2013-07-22','17:35:00',2.74),('15128','2013-07-22','17:40:00',2.64),('15128','2013-07-22','17:45:00',2.55),('15128','2013-07-22','17:50:00',2.46),('15128','2013-07-22','17:55:00',2.32),('15128','2013-07-22','18:00:00',2.25),('15128','2013-07-22','18:05:00',2.12),('15128','2013-07-22','18:10:00',1.99),('15128','2013-07-22','18:15:00',1.91),('15128','2013-07-22','18:20:00',1.86),('15128','2013-07-22','18:25:00',1.79),('15128','2013-07-22','18:30:00',1.7),('15128','2013-07-22','18:35:00',1.44),('15128','2013-07-22','18:40:00',1.09),('15128','2013-07-22','18:45:00',1.2),('15128','2013-07-22','18:50:00',1.38),('15128','2013-07-22','18:55:00',1.36),('15128','2013-07-22','19:00:00',1.24),('15128','2013-07-22','19:05:00',1.15),('15128','2013-07-22','19:10:00',1.03),('15128','2013-07-21','08:15:00',1.04),('15128','2013-07-21','08:20:00',1.12),('15128','2013-07-21','08:25:00',1.16),('15128','2013-07-21','08:30:00',1.2),('15128','2013-07-21','08:35:00',1.28),('15128','2013-07-21','08:40:00',1.38),('15128','2013-07-21','08:45:00',1.45),('15128','2013-07-21','08:50:00',1.52),('15128','2013-07-21','08:55:00',1.58),('15128','2013-07-21','09:00:00',1.65),('15128','2013-07-21','09:05:00',1.72),('15128','2013-07-21','09:10:00',1.81),('15128','2013-07-21','09:15:00',1.88),('15128','2013-07-21','09:20:00',1.98),('15128','2013-07-21','09:25:00',2.06),('15128','2013-07-21','09:30:00',2.01),('15128','2013-07-21','09:35:00',2.11),('15128','2013-07-21','09:40:00',2.15),('15128','2013-07-21','09:45:00',2.21),('15128','2013-07-21','09:50:00',2.31),('15128','2013-07-21','09:55:00',2.33),('15128','2013-07-21','10:00:00',2.41),('15128','2013-07-21','10:05:00',2.47),('15128','2013-07-21','10:10:00',2.53),('15128','2013-07-21','10:15:00',2.54),('15128','2013-07-21','10:20:00',2.6),('15128','2013-07-21','10:25:00',2.67),('15128','2013-07-21','10:30:00',2.71),('15128','2013-07-21','10:35:00',2.78),('15128','2013-07-21','10:40:00',2.79),('15128','2013-07-21','10:45:00',2.87),('15128','2013-07-21','10:50:00',2.98),('15128','2013-07-21','10:55:00',3.01),('15128','2013-07-21','11:00:00',3.1),('15128','2013-07-21','11:05:00',3.12),('15128','2013-07-21','11:10:00',3.19),('15128','2013-07-21','11:15:00',3.22),('15128','2013-07-21','11:20:00',3.28),('15128','2013-07-21','11:25:00',3.32),('15128','2013-07-21','11:30:00',3.33),('15128','2013-07-21','11:35:00',3.4),('15128','2013-07-21','11:40:00',3.42),('15128','2013-07-21','11:45:00',3.48),('15128','2013-07-21','11:50:00',3.68),('15128','2013-07-21','11:55:00',3.76),('15128','2013-07-21','12:00:00',3.78),('15128','2013-07-21','12:05:00',3.84),('15128','2013-07-21','12:10:00',3.89),('15128','2013-07-21','12:15:00',3.92),('15128','2013-07-21','12:20:00',3.94),('15128','2013-07-21','12:25:00',3.97),('15128','2013-07-21','12:30:00',3.98),('15128','2013-07-21','12:35:00',4),('15128','2013-07-21','12:40:00',4.02),('15128','2013-07-21','12:45:00',4.05),('15128','2013-07-21','12:50:00',4.08),('15128','2013-07-21','12:55:00',4.08),('15128','2013-07-21','13:00:00',4.06),('15128','2013-07-21','13:05:00',4.1),('15128','2013-07-21','13:10:00',4.16),('15128','2013-07-21','13:15:00',4.2),('15128','2013-07-21','13:20:00',4.17),('15128','2013-07-21','13:25:00',4.16),('15128','2013-07-21','13:30:00',4.12),('15128','2013-07-21','13:35:00',4.17),('15128','2013-07-21','13:40:00',4.14),('15128','2013-07-21','13:45:00',4.16),('15128','2013-07-21','13:50:00',4.23),('15128','2013-07-21','13:55:00',4.2),('15128','2013-07-21','14:00:00',4.18),('15128','2013-07-21','14:05:00',4.17),('15128','2013-07-21','14:10:00',4.17),('15128','2013-07-21','14:15:00',4.17),('15128','2013-07-21','14:20:00',4.15),('15128','2013-07-21','14:25:00',4.18),('15128','2013-07-21','14:30:00',4.13),('15128','2013-07-21','14:35:00',4.12),('15128','2013-07-21','14:40:00',3.01),('15128','2013-07-21','14:45:00',3.88),('15128','2013-07-21','14:50:00',3.92),('15128','2013-07-21','14:55:00',2.88),('15128','2013-07-21','15:00:00',4.01),('15128','2013-07-21','15:05:00',3.68),('15128','2013-07-21','15:10:00',4.17),('15128','2013-07-21','15:15:00',4.22),('15128','2013-07-21','15:20:00',4.22),('15128','2013-07-21','15:25:00',4.16),('15128','2013-07-21','15:30:00',2.33),('15128','2013-07-21','15:35:00',1.16),('15128','2013-07-21','15:40:00',1.01),('15128','2013-07-21','15:45:00',1.06),('15128','2013-07-21','15:50:00',1.2),('15128','2013-07-21','15:55:00',1.24),('15128','2013-07-21','16:00:00',1.39),('15128','2013-07-21','16:05:00',3.85),('15128','2013-07-21','16:10:00',3.94),('15128','2013-07-21','16:15:00',3.81),('15128','2013-07-21','16:20:00',3.73),('15128','2013-07-21','16:25:00',3.61),('15128','2013-07-21','16:30:00',3.43),('15128','2013-07-21','16:35:00',3.38),('15128','2013-07-21','16:40:00',3.25),('15128','2013-07-21','16:45:00',2.73),('15128','2013-07-21','16:50:00',3.14),('15128','2013-07-21','16:55:00',3.22),('15128','2013-07-21','17:00:00',3.12),('15128','2013-07-21','17:05:00',3.01),('15128','2013-07-21','17:10:00',2.94),('15128','2013-07-21','17:15:00',2.87),('15128','2013-07-21','17:20:00',2.88),('15128','2013-07-21','17:25:00',2.84),('15128','2013-07-21','17:30:00',2.8),('15128','2013-07-21','17:35:00',2.79),('15128','2013-07-21','17:40:00',2.83),('15128','2013-07-21','17:45:00',2.7),('15128','2013-07-21','17:50:00',2.52),('15128','2013-07-21','17:55:00',2.44),('15128','2013-07-21','18:00:00',2.31),('15128','2013-07-21','18:05:00',2.09),('15128','2013-07-21','18:10:00',1.95),('15128','2013-07-21','18:15:00',1.77),('15128','2013-07-21','18:20:00',1.72),('15128','2013-07-21','18:25:00',1.73),('15128','2013-07-21','18:30:00',1.63),('15128','2013-07-21','18:35:00',1.61),('15128','2013-07-21','18:40:00',1.43),('15128','2013-07-21','18:45:00',1.27),('15128','2013-07-21','18:50:00',1.07),('15128','2013-07-21','18:55:00',1.23),('15128','2013-07-21','19:00:00',1.15),('15128','2013-07-21','19:05:00',1.06),('15128','2013-07-20','08:15:00',1.01),('15128','2013-07-20','08:20:00',1.06),('15128','2013-07-20','08:25:00',1.13),('15128','2013-07-20','08:30:00',1.17),('15128','2013-07-20','08:35:00',1.26),('15128','2013-07-20','08:40:00',1.34),('15128','2013-07-20','08:45:00',1.41),('15128','2013-07-20','08:50:00',1.47),('15128','2013-07-20','08:55:00',1.54),('15128','2013-07-20','09:00:00',1.61),('15128','2013-07-20','09:05:00',1.69),('15128','2013-07-20','09:10:00',1.78),('15128','2013-07-20','09:15:00',1.86),('15128','2013-07-20','09:20:00',1.97),('15128','2013-07-20','09:25:00',2.02),('15128','2013-07-20','09:30:00',2.04),('15128','2013-07-20','09:35:00',2.09),('15128','2013-07-20','09:40:00',2.13),('15128','2013-07-20','09:45:00',2.18),('15128','2013-07-20','09:50:00',2.21),('15128','2013-07-20','09:55:00',2.26),('15128','2013-07-20','10:00:00',2.35),('15128','2013-07-20','10:05:00',2.39),('15128','2013-07-20','10:10:00',2.49),('15128','2013-07-20','10:15:00',2.49),('15128','2013-07-20','10:20:00',2.56),('15128','2013-07-20','10:25:00',2.64),('15128','2013-07-20','10:30:00',2.68),('15128','2013-07-20','10:35:00',2.74),('15128','2013-07-20','10:40:00',2.74),('15128','2013-07-20','10:45:00',2.82),('15128','2013-07-20','10:50:00',2.93),('15128','2013-07-20','10:55:00',2.98),('15128','2013-07-20','11:00:00',3.06),('15128','2013-07-20','11:05:00',3.09),('15128','2013-07-20','11:10:00',3.14),('15128','2013-07-20','11:15:00',3.18),('15128','2013-07-20','11:20:00',3.23),('15128','2013-07-20','11:25:00',3.24),('15128','2013-07-20','11:30:00',3.26),('15128','2013-07-20','11:35:00',3.33),('15128','2013-07-20','11:40:00',3.41),('15128','2013-07-20','11:45:00',3.48),('15128','2013-07-20','11:50:00',3.64),('15128','2013-07-20','11:55:00',3.75),('15128','2013-07-20','12:00:00',3.83),('15128','2013-07-20','12:05:00',3.87),('15128','2013-07-20','12:10:00',3.85),('15128','2013-07-20','12:15:00',3.81),('15128','2013-07-20','12:20:00',3.62),('15128','2013-07-20','12:25:00',3.04),('15128','2013-07-20','12:30:00',2.25),('15128','2013-07-20','12:35:00',2.18),('15128','2013-07-20','12:40:00',1.97),('15128','2013-07-20','12:45:00',1.99),('15128','2013-07-20','12:50:00',2.81),('15128','2013-07-20','12:55:00',2.34),('15128','2013-07-20','13:00:00',1.87),('15128','2013-07-20','13:05:00',1.96),('15128','2013-07-20','13:10:00',2.12),('15128','2013-07-20','13:15:00',3.05),('15128','2013-07-20','13:20:00',2.93),('15128','2013-07-20','13:25:00',2.04),('15128','2013-07-20','13:30:00',1.87),('15128','2013-07-20','13:35:00',1.87),('15128','2013-07-20','13:40:00',2.12),('15128','2013-07-20','13:45:00',2.5),('15128','2013-07-20','13:50:00',3.02),('15128','2013-07-20','13:55:00',3.27),('15128','2013-07-20','14:00:00',2.69),('15128','2013-07-20','14:05:00',2.92),('15128','2013-07-20','14:10:00',2.46),('15128','2013-07-20','14:15:00',2.43),('15128','2013-07-20','14:20:00',1.91),('15128','2013-07-20','14:25:00',1.81),('15128','2013-07-20','14:30:00',1.54),('15128','2013-07-20','14:35:00',1.42),('15128','2013-07-20','14:40:00',1.43),('15128','2013-07-20','14:45:00',1.5),('15128','2013-07-20','14:50:00',1.96),('15128','2013-07-20','14:55:00',1.74),('15128','2013-07-20','15:00:00',1.4),('15128','2013-07-20','15:05:00',1.37),('15128','2013-07-20','15:10:00',1.37),('15128','2013-07-20','15:15:00',1.44),('15128','2013-07-20','15:20:00',1.67),('15128','2013-07-20','15:25:00',1.65),('15128','2013-07-20','15:30:00',1.79),('15128','2013-07-20','15:35:00',2.24),('15128','2013-07-20','15:40:00',2.65),('15128','2013-07-20','15:45:00',2.28),('15128','2013-07-20','15:50:00',2.57),('15128','2013-07-20','15:55:00',2.02),('15128','2013-07-20','16:00:00',1.41),('15128','2013-07-20','16:05:00',1.03),('15128','2013-07-20','16:35:00',1.16),('15128','2013-07-20','16:40:00',1.2),('15128','2013-07-20','16:45:00',1.19),('15128','2013-07-20','16:50:00',1.15),('15128','2013-07-20','16:55:00',1.13),('15128','2013-07-20','17:00:00',1.33),('15128','2013-07-20','17:05:00',1.88),('15128','2013-07-20','17:10:00',1.43),('15128','2014-04-06','09:30:00',1.03),('15128','2014-04-06','09:35:00',1.07),('15128','2014-04-06','09:40:00',1.11),('15128','2014-04-06','09:45:00',1.12),('15128','2014-04-06','09:50:00',1.13),('15128','2014-04-06','09:55:00',1.15),('15128','2014-04-06','10:00:00',1.16),('15128','2014-04-06','10:05:00',1.18),('15128','2014-04-06','10:10:00',1.19),('15128','2014-04-06','10:15:00',1.22),('15128','2014-04-06','10:20:00',1.21),('15128','2014-04-06','10:25:00',1.2),('15128','2014-04-06','10:30:00',1.23),('15128','2014-04-06','10:35:00',1.28),('15128','2014-04-06','10:40:00',1.36),('15128','2014-04-06','10:45:00',1.43),('15128','2014-04-06','10:50:00',1.44),('15128','2014-04-06','10:55:00',1.48),('15128','2014-04-06','11:00:00',1.5),('15128','2014-04-06','11:05:00',1.51),('15128','2014-04-06','11:10:00',1.55),('15128','2014-04-06','11:15:00',1.59),('15128','2014-04-06','11:20:00',1.6),('15128','2014-04-06','11:25:00',1.58),('15128','2014-04-06','11:30:00',1.52),('15128','2014-04-06','11:35:00',1.49),('15128','2014-04-06','11:40:00',1.48),('15128','2014-04-06','11:45:00',1.49),('15128','2014-04-06','11:50:00',1.55),('15128','2014-04-06','11:55:00',1.79),('15128','2014-04-06','12:00:00',2.2),('15128','2014-04-06','12:05:00',2.96),('15128','2014-04-06','12:10:00',3.54),('15128','2014-04-06','12:15:00',3.44),('15128','2014-04-06','12:20:00',2.76),('15128','2014-04-06','12:25:00',1.53),('15128','2014-04-06','12:30:00',2.24),('15128','2014-04-06','12:35:00',3.85),('15128','2014-04-06','12:40:00',3.8),('15128','2014-04-06','12:45:00',3.7),('15128','2014-04-06','12:50:00',3.64),('15128','2014-04-06','12:55:00',3.66),('15128','2014-04-06','13:00:00',3.67),('15128','2014-04-06','13:05:00',3.68),('15128','2014-04-06','13:10:00',3.69),('15128','2014-04-06','13:15:00',3.68),('15128','2014-04-06','13:20:00',3.69),('15128','2014-04-06','13:25:00',3.68),('15128','2014-04-06','13:30:00',3.71),('15128','2014-04-06','13:35:00',3.77),('15128','2014-04-06','13:40:00',3.73),('15128','2014-04-06','13:45:00',3.72),('15128','2014-04-06','13:50:00',3.69),('15128','2014-04-06','13:55:00',3.71),('15128','2014-04-06','14:00:00',3.74),('15128','2014-04-06','14:05:00',3.74),('15128','2014-04-06','14:10:00',3.76),('15128','2014-04-06','14:15:00',3.73),('15128','2014-04-06','14:20:00',3.68),('15128','2014-04-06','14:25:00',3.67),('15128','2014-04-06','14:30:00',3.72),('15128','2014-04-06','14:35:00',3.74),('15128','2014-04-06','14:40:00',3.76),('15128','2014-04-06','14:45:00',3.66),('15128','2014-04-06','14:50:00',2.36),('15128','2014-04-06','14:55:00',3.7),('15128','2014-04-06','15:00:00',3.69),('15128','2014-04-06','15:05:00',3.6),('15128','2014-04-06','15:10:00',3.57),('15128','2014-04-06','15:15:00',3.58),('15128','2014-04-06','15:20:00',3.58),('15128','2014-04-06','15:25:00',3.5),('15128','2014-04-06','15:30:00',3.48),('15128','2014-04-06','15:35:00',3.45),('15128','2014-04-06','15:40:00',3.44),('15128','2014-04-06','15:45:00',3.38),('15128','2014-04-06','15:50:00',3.37),('15128','2014-04-06','15:55:00',3.38),('15128','2014-04-06','16:00:00',3.3),('15128','2014-04-06','16:05:00',3.37),('15128','2014-04-06','16:10:00',3.06),('15128','2014-04-06','16:30:00',1.01),('15128','2014-04-06','16:35:00',1.15),('15128','2014-04-06','16:45:00',2.22),('15128','2014-04-06','16:50:00',2.59),('15128','2014-04-06','16:55:00',3.03),('15128','2014-04-06','17:00:00',3.02),('15128','2014-04-06','17:05:00',2.95),('15128','2014-04-06','17:10:00',2.76),('15128','2014-04-06','17:15:00',2.52),('15128','2014-04-06','17:20:00',2.16),('15128','2014-04-06','17:25:00',2.22),('15128','2014-04-06','17:30:00',2.03),('15128','2014-04-06','17:35:00',2.09),('15128','2014-04-06','17:40:00',2.05),('15128','2014-04-06','17:45:00',1.74),('15128','2014-04-06','17:50:00',1.43),('15128','2014-04-06','17:55:00',1.33),('15128','2014-04-06','18:00:00',1.26),('15128','2014-04-06','18:05:00',1.3),('15128','2014-04-06','18:10:00',1.26),('15128','2014-04-06','18:15:00',1.23),('15128','2014-04-06','18:20:00',1.03),('15128','2013-07-19','08:15:00',1.06),('15128','2013-07-19','08:20:00',1.13),('15128','2013-07-19','08:25:00',1.18),('15128','2013-07-19','08:30:00',1.24),('15128','2013-07-19','08:35:00',1.34),('15128','2013-07-19','08:40:00',1.43),('15128','2013-07-19','08:45:00',1.51),('15128','2013-07-19','08:50:00',1.58),('15128','2013-07-19','08:55:00',1.66),('15128','2013-07-19','09:00:00',1.72),('15128','2013-07-19','09:05:00',1.85),('15128','2013-07-19','09:10:00',1.97),('15128','2013-07-19','09:15:00',2.04),('15128','2013-07-19','09:20:00',2.08),('15128','2013-07-19','09:25:00',2.1),('15128','2013-07-19','09:30:00',2.12),('15128','2013-07-19','09:35:00',2.14),('15128','2013-07-19','09:40:00',2.07),('15128','2013-07-19','09:45:00',2.14),('15128','2013-07-19','09:50:00',2.1),('15128','2013-07-19','09:55:00',2.33),('15128','2013-07-19','10:00:00',2.4),('15128','2013-07-19','10:05:00',2.45),('15128','2013-07-19','10:10:00',2.53),('15128','2013-07-19','10:15:00',2.55),('15128','2013-07-19','10:20:00',2.6),('15128','2013-07-19','10:25:00',2.67),('15128','2013-07-19','10:30:00',2.72),('15128','2013-07-19','10:35:00',2.75),('15128','2013-07-19','10:40:00',2.81),('15128','2013-07-19','10:45:00',2.86),('15128','2013-07-19','10:50:00',2.97),('15128','2013-07-19','10:55:00',3.05),('15128','2013-07-19','11:00:00',3.15),('15128','2013-07-19','11:05:00',3.18),('15128','2013-07-19','11:10:00',3.21),('15128','2013-07-19','11:15:00',3.25),('15128','2013-07-19','11:20:00',3.32),('15128','2013-07-19','11:25:00',3.37),('15128','2013-07-19','11:30:00',3.37),('15128','2013-07-19','11:35:00',3.42),('15128','2013-07-19','11:40:00',3.48),('15128','2013-07-19','11:45:00',3.62),('15128','2013-07-19','11:50:00',3.71),('15128','2013-07-19','11:55:00',3.78),('15128','2013-07-19','12:00:00',3.83),('15128','2013-07-19','12:05:00',3.83),('15128','2013-07-19','12:10:00',3.9),('15128','2013-07-19','12:15:00',3.92),('15128','2013-07-19','12:20:00',3.97),('15128','2013-07-19','12:25:00',4),('15128','2013-07-19','12:30:00',4.04),('15128','2013-07-19','12:35:00',4.09),('15128','2013-07-19','12:40:00',4.12),('15128','2013-07-19','12:45:00',4.07),('15128','2013-07-19','12:50:00',4.09),('15128','2013-07-19','12:55:00',4.12),('15128','2013-07-19','13:00:00',4.24),('15128','2013-07-19','13:05:00',4.24),('15128','2013-07-19','13:10:00',4.28),('15128','2013-07-19','13:15:00',4.12),('15128','2013-07-19','13:20:00',4.09),('15128','2013-07-19','13:25:00',4.31),('15128','2013-07-19','13:30:00',3.78),('15128','2013-07-19','13:35:00',3.11),('15128','2013-07-19','13:40:00',1.84),('15128','2013-07-19','13:45:00',4.65),('15128','2013-07-19','13:50:00',4.43),('15128','2013-07-19','13:55:00',4.33),('15128','2013-07-19','14:00:00',4.39),('15128','2013-07-19','14:05:00',4.29),('15128','2013-07-19','14:10:00',4.33),('15128','2013-07-19','14:15:00',4.27),('15128','2013-07-19','14:20:00',4.22),('15128','2013-07-19','14:25:00',3.55),('15128','2013-07-19','14:30:00',4.15),('15128','2013-07-19','14:35:00',4.25),('15128','2013-07-19','14:40:00',4.22),('15128','2013-07-19','14:45:00',4.22),('15128','2013-07-19','14:50:00',4.19),('15128','2013-07-19','14:55:00',4.15),('15128','2013-07-19','15:00:00',4.14),('15128','2013-07-19','15:05:00',4.12),('15128','2013-07-19','15:10:00',4.12),('15128','2013-07-19','15:15:00',4.11),('15128','2013-07-19','15:20:00',4.08),('15128','2013-07-19','15:25:00',4.06),('15128','2013-07-19','15:30:00',4.06),('15128','2013-07-19','15:35:00',4.03),('15128','2013-07-19','15:40:00',4.02),('15128','2013-07-19','15:45:00',3.98),('15128','2013-07-19','15:50:00',3.93),('15128','2013-07-19','15:55:00',3.89),('15128','2013-07-19','16:00:00',3.86),('15128','2013-07-19','16:05:00',3.8),('15128','2013-07-19','16:10:00',3.74),('15128','2013-07-19','16:15:00',3.7),('15128','2013-07-19','16:20:00',3.64),('15128','2013-07-19','16:25:00',3.59),('15128','2013-07-19','16:30:00',3.54),('15128','2013-07-19','16:35:00',3.48),('15128','2013-07-19','16:40:00',3.45),('15128','2013-07-19','16:45:00',3.4),('15128','2013-07-19','16:50:00',3.35),('15128','2013-07-19','16:55:00',3.29),('15128','2013-07-19','17:00:00',3.24),('15128','2013-07-19','17:05:00',3.17),('15128','2013-07-19','17:10:00',3.1),('15128','2013-07-19','17:15:00',3.04),('15128','2013-07-19','17:20:00',2.97),('15128','2013-07-19','17:25:00',2.88),('15128','2013-07-19','17:30:00',2.82),('15128','2013-07-19','17:35:00',2.75),('15128','2013-07-19','17:40:00',2.66),('15128','2013-07-19','17:45:00',2.59),('15128','2013-07-19','17:50:00',2.49),('15128','2013-07-19','17:55:00',2.4),('15128','2013-07-19','18:00:00',2.27),('15128','2013-07-19','18:05:00',2.15),('15128','2013-07-19','18:10:00',2),('15128','2013-07-19','18:15:00',1.92),('15128','2013-07-19','18:20:00',1.82),('15128','2013-07-19','18:25:00',1.78),('15128','2013-07-19','18:30:00',1.67),('15128','2013-07-19','18:35:00',1.57),('15128','2013-07-19','18:40:00',1.5),('15128','2013-07-19','18:45:00',1.42),('15128','2013-07-19','18:50:00',1.34),('15128','2013-07-19','18:55:00',1.25),('15128','2013-07-19','19:00:00',1.14),('15128','2013-07-19','19:05:00',1.04),('15128','2013-07-18','08:15:00',1.01),('15128','2013-07-18','08:20:00',1.07),('15128','2013-07-18','08:25:00',1.12),('15128','2013-07-18','08:30:00',1.19),('15128','2013-07-18','08:35:00',1.27),('15128','2013-07-18','08:40:00',1.33),('15128','2013-07-18','08:45:00',1.43),('15128','2013-07-18','08:50:00',1.5),('15128','2013-07-18','08:55:00',1.55),('15128','2013-07-18','09:00:00',1.62),('15128','2013-07-18','09:05:00',1.68),('15128','2013-07-18','09:10:00',1.78),('15128','2013-07-18','09:15:00',1.87),('15128','2013-07-18','09:20:00',1.94),('15128','2013-07-18','09:25:00',2.01),('15128','2013-07-18','09:30:00',1.99),('15128','2013-07-18','09:35:00',2.06),('15128','2013-07-18','09:40:00',2.11),('15128','2013-07-18','09:45:00',2.16),('15128','2013-07-18','09:50:00',2.22),('15128','2013-07-18','09:55:00',2.23),('15128','2013-07-18','10:00:00',2.29),('15128','2013-07-18','10:05:00',2.42),('15128','2013-07-18','10:10:00',2.52),('15128','2013-07-18','10:15:00',2.48),('15128','2013-07-18','10:20:00',2.52),('15128','2013-07-18','10:25:00',2.62),('15128','2013-07-18','10:30:00',2.67),('15128','2013-07-18','10:35:00',2.69),('15128','2013-07-18','10:40:00',2.81),('15128','2013-07-18','10:45:00',2.84),('15128','2013-07-18','10:50:00',2.91),('15128','2013-07-18','10:55:00',2.97),('15128','2013-07-18','11:00:00',3.02),('15128','2013-07-18','11:05:00',3.06),('15128','2013-07-18','11:10:00',3.12),('15128','2013-07-18','11:15:00',3.16),('15128','2013-07-18','11:20:00',3.2),('15128','2013-07-18','11:25:00',3.25),('15128','2013-07-18','11:30:00',3.34),('15128','2013-07-18','11:35:00',3.38),('15128','2013-07-18','11:40:00',3.38),('15128','2013-07-18','11:45:00',3.34),('15128','2013-07-18','11:50:00',3.54),('15128','2013-07-18','11:55:00',3.62),('15128','2013-07-18','12:00:00',3.81),('15128','2013-07-18','12:05:00',3.54),('15128','2013-07-18','12:10:00',2.37),('15128','2013-07-18','12:15:00',3.93),('15128','2013-07-18','12:20:00',3.88),('15128','2013-07-18','12:25:00',3.92),('15128','2013-07-18','12:30:00',3.94),('15128','2013-07-18','12:35:00',3.83),('15128','2013-07-18','12:40:00',4),('15128','2013-07-18','12:45:00',4.04),('15128','2013-07-18','12:50:00',4.08),('15128','2013-07-18','12:55:00',4.11),('15128','2013-07-18','13:00:00',4.09),('15128','2013-07-18','13:05:00',4.17),('15128','2013-07-18','13:10:00',4.26),('15128','2013-07-18','13:15:00',4.2),('15128','2013-07-18','13:20:00',4.28),('15128','2013-07-18','13:25:00',4.26),('15128','2013-07-18','13:30:00',4.3),('15128','2013-07-18','13:35:00',4.34),('15128','2013-07-18','13:40:00',4.34),('15128','2013-07-18','13:45:00',4.34),('15128','2013-07-18','13:50:00',4.39),('15128','2013-07-18','13:55:00',4.25),('15128','2013-07-18','14:00:00',4.3),('15128','2013-07-18','14:05:00',4.33),('15128','2013-07-18','14:10:00',4.33),('15128','2013-07-18','14:15:00',4.35),('15128','2013-07-18','14:20:00',4.36),('15128','2013-07-18','14:25:00',4.38),('15128','2013-07-18','14:30:00',4.34),('15128','2013-07-18','14:35:00',4.28),('15128','2013-07-18','14:40:00',4.37),('15128','2013-07-18','14:45:00',3.76),('15128','2013-07-18','14:50:00',4.04),('15128','2013-07-18','14:55:00',4.19),('15128','2013-07-18','15:00:00',3.99),('15128','2013-07-18','15:05:00',4.38),('15128','2013-07-18','15:10:00',3.33),('15128','2013-07-18','15:15:00',1.73),('15128','2013-07-18','15:20:00',2.55),('15128','2013-07-18','15:25:00',2.78),('15128','2013-07-18','15:30:00',4.07),('15128','2013-07-18','15:35:00',4.22),('15128','2013-07-18','15:40:00',4.19),('15128','2013-07-18','15:45:00',4.03),('15128','2013-07-18','15:50:00',3.98),('15128','2013-07-18','15:55:00',3.91),('15128','2013-07-18','16:00:00',3.75),('15128','2013-07-18','16:05:00',3.79),('15128','2013-07-18','16:10:00',3.76),('15128','2013-07-18','16:15:00',3.7),('15128','2013-07-18','16:20:00',3.65),('15128','2013-07-18','16:25:00',3.65),('15128','2013-07-18','16:30:00',3.61),('15128','2013-07-18','16:35:00',3.42),('15128','2013-07-18','16:40:00',3.32),('15128','2013-07-18','16:45:00',3.56),('15128','2013-07-18','16:50:00',3.53),('15128','2013-07-18','16:55:00',3.48),('15128','2013-07-18','17:00:00',3.41),('15128','2013-07-18','17:05:00',2.61),('15128','2013-07-18','17:10:00',2.12),('15128','2013-07-18','17:15:00',1.78),('15128','2013-07-18','17:20:00',2.26),('15128','2013-07-18','17:25:00',2.91),('15128','2013-07-18','17:30:00',2.27),('15128','2013-07-18','17:35:00',1.71),('15128','2013-07-18','17:40:00',2.06),('15128','2013-07-18','17:45:00',1.54),('15128','2013-07-18','17:50:00',1.2),('15128','2013-07-17','08:15:00',1.05),('15128','2013-07-17','08:20:00',1.12),('15128','2013-07-17','08:25:00',1.17),('15128','2013-07-17','08:30:00',1.24),('15128','2013-07-17','08:35:00',1.3),('15128','2013-07-17','08:40:00',1.37),('15128','2013-07-17','08:45:00',1.48),('15128','2013-07-17','08:50:00',1.55),('15128','2013-07-17','08:55:00',1.63),('15128','2013-07-17','09:00:00',1.7),('15128','2013-07-17','09:05:00',1.79),('15128','2013-07-17','09:10:00',1.86),('15128','2013-07-17','09:15:00',1.95),('15128','2013-07-17','09:20:00',2.05),('15128','2013-07-17','09:25:00',2.1),('15128','2013-07-17','09:30:00',2.07),('15128','2013-07-17','09:35:00',2.19),('15128','2013-07-17','09:40:00',2.26),('15128','2013-07-17','09:45:00',2.3),('15128','2013-07-17','09:50:00',2.35),('15128','2013-07-17','09:55:00',2.35),('15128','2013-07-17','10:00:00',2.4),('15128','2013-07-17','10:05:00',2.51),('15128','2013-07-17','10:10:00',2.57),('15128','2013-07-17','10:15:00',2.58),('15128','2013-07-17','10:20:00',2.62),('15128','2013-07-17','10:25:00',2.69),('15128','2013-07-17','10:30:00',2.76),('15128','2013-07-17','10:35:00',2.78),('15128','2013-07-17','10:40:00',2.87),('15128','2013-07-17','10:45:00',2.82),('15128','2013-07-17','10:50:00',2.98),('15128','2013-07-17','10:55:00',3.03),('15128','2013-07-17','11:00:00',3.09),('15128','2013-07-17','11:05:00',3.15),('15128','2013-07-17','11:10:00',3.17),('15128','2013-07-17','11:15:00',3.2),('15128','2013-07-17','11:20:00',3.28),('15128','2013-07-17','11:25:00',3.32),('15128','2013-07-17','11:30:00',3.36),('15128','2013-07-17','11:35:00',3.36),('15128','2013-07-17','11:40:00',3.48),('15128','2013-07-17','11:45:00',3.61),('15128','2013-07-17','11:50:00',3.68),('15128','2013-07-17','11:55:00',3.75),('15128','2013-07-17','12:00:00',3.81),('15128','2013-07-17','12:05:00',3.84),('15128','2013-07-17','12:10:00',3.87),('15128','2013-07-17','12:15:00',3.95),('15128','2013-07-17','12:20:00',3.97),('15128','2013-07-17','12:25:00',3.99),('15128','2013-07-17','12:30:00',4),('15128','2013-07-17','12:35:00',4.05),('15128','2013-07-17','12:40:00',4.09),('15128','2013-07-17','12:45:00',4.09),('15128','2013-07-17','12:50:00',4.12),('15128','2013-07-17','12:55:00',4.13),('15128','2013-07-17','13:00:00',4.14),('15128','2013-07-17','13:05:00',4.17),('15128','2013-07-17','13:10:00',4.17),('15128','2013-07-17','13:15:00',4.15),('15128','2013-07-17','13:20:00',4.2),('15128','2013-07-17','13:25:00',4.22),('15128','2013-07-17','13:30:00',4.22),('15128','2013-07-17','13:35:00',4.24),('15128','2013-07-17','13:40:00',4.25),('15128','2013-07-17','13:45:00',4.31),('15128','2013-07-17','13:50:00',4.32),('15128','2013-07-17','13:55:00',4.3),('15128','2013-07-17','14:00:00',4.33),('15128','2013-07-17','14:05:00',4.35),('15128','2013-07-17','14:10:00',4.36),('15128','2013-07-17','14:15:00',4.33),('15128','2013-07-17','14:20:00',4.29),('15128','2013-07-17','14:25:00',4.31),('15128','2013-07-17','14:30:00',4.29),('15128','2013-07-17','14:35:00',4.29),('15128','2013-07-17','14:40:00',4.26),('15128','2013-07-17','14:45:00',4.23),('15128','2013-07-17','14:50:00',4.24),('15128','2013-07-17','14:55:00',4.18),('15128','2013-07-17','15:00:00',4.15),('15128','2013-07-17','15:05:00',4.14),('15128','2013-07-17','15:10:00',4.14),('15128','2013-07-17','15:15:00',4.12),('15128','2013-07-17','15:20:00',4.07),('15128','2013-07-17','15:25:00',4.05),('15128','2013-07-17','15:30:00',4.04),('15128','2013-07-17','15:35:00',4),('15128','2013-07-17','15:40:00',3.97),('15128','2013-07-17','15:45:00',3.95),('15128','2013-07-17','15:50:00',3.89),('15128','2013-07-17','15:55:00',3.87),('15128','2013-07-17','16:00:00',3.84),('15128','2013-07-17','16:05:00',3.77),('15128','2013-07-17','16:10:00',3.72),('15128','2013-07-17','16:15:00',3.66),('15128','2013-07-17','16:20:00',3.62),('15128','2013-07-17','16:25:00',3.57),('15128','2013-07-17','16:30:00',3.51),('15128','2013-07-17','16:35:00',3.46),('15128','2013-07-17','16:40:00',3.39),('15128','2013-07-17','16:45:00',3.34),('15128','2013-07-17','16:50:00',3.28),('15128','2013-07-17','16:55:00',3.25),('15128','2013-07-17','17:00:00',3.17),('15128','2013-07-17','17:05:00',3.12),('15128','2013-07-17','17:10:00',3.06),('15128','2013-07-17','17:15:00',3.01),('15128','2013-07-17','17:20:00',2.93),('15128','2013-07-17','17:25:00',2.83),('15128','2013-07-17','17:30:00',2.64),('15128','2013-07-17','17:35:00',2.55),('15128','2013-07-17','17:40:00',2.49),('15128','2013-07-17','17:45:00',2.39),('15128','2013-07-17','17:50:00',1.99),('15128','2013-07-17','17:55:00',2.08),('15128','2013-07-17','18:00:00',2.04),('15128','2013-07-17','18:10:00',1.25),('15128','2013-07-17','18:15:00',1.12),('15128','2013-07-17','18:40:00',1.25),('15128','2013-07-17','18:45:00',1.54),('15128','2013-07-17','18:50:00',1.51),('15128','2013-07-17','18:55:00',1.41),('15128','2013-07-17','19:00:00',1.15),('15128','2013-07-17','19:05:00',1.07),('15128','2013-07-17','19:10:00',1.07),('15128','2013-07-17','19:15:00',1.02),('15128','2013-07-16','08:10:00',1.04),('15128','2013-07-16','08:15:00',1.1),('15128','2013-07-16','08:20:00',1.17),('15128','2013-07-16','08:25:00',1.23),('15128','2013-07-16','08:30:00',1.29),('15128','2013-07-16','08:35:00',1.38),('15128','2013-07-16','08:40:00',1.44),('15128','2013-07-16','08:45:00',1.53),('15128','2013-07-16','08:50:00',1.61),('15128','2013-07-16','08:55:00',1.68),('15128','2013-07-16','09:00:00',1.73),('15128','2013-07-16','09:05:00',1.8),('15128','2013-07-16','09:10:00',1.88),('15128','2013-07-16','09:15:00',2),('15128','2013-07-16','09:20:00',2.09),('15128','2013-07-16','09:25:00',2.1),('15128','2013-07-16','09:30:00',2.16),('15128','2013-07-16','09:35:00',2.23),('15128','2013-07-16','09:40:00',2.29),('15128','2013-07-16','09:45:00',2.36),('15128','2013-07-16','09:50:00',2.42),('15128','2013-07-16','09:55:00',2.38),('15128','2013-07-16','10:00:00',2.45),('15128','2013-07-16','10:05:00',2.56),('15128','2013-07-16','10:10:00',2.63),('15128','2013-07-16','10:15:00',2.66),('15128','2013-07-16','10:20:00',2.74),('15128','2013-07-16','10:25:00',2.77),('15128','2013-07-16','10:30:00',2.86),('15128','2013-07-16','10:35:00',2.84),('15128','2013-07-16','10:40:00',2.96),('15128','2013-07-16','10:45:00',2.98),('15128','2013-07-16','10:50:00',3.06),('15128','2013-07-16','10:55:00',3.16),('15128','2013-07-16','11:00:00',3.14),('15128','2013-07-16','11:05:00',3.24),('15128','2013-07-16','11:10:00',3.25),('15128','2013-07-16','11:15:00',3.33),('15128','2013-07-16','11:20:00',3.44),('15128','2013-07-16','11:25:00',3.47),('15128','2013-07-16','11:30:00',3.51),('15128','2013-07-16','11:35:00',3.47),('15128','2013-07-16','11:40:00',3.56),('15128','2013-07-16','11:45:00',3.65),('15128','2013-07-16','11:50:00',3.77),('15128','2013-07-16','11:55:00',3.9),('15128','2013-07-16','12:00:00',3.95),('15128','2013-07-16','12:05:00',3.99),('15128','2013-07-16','12:10:00',4.04),('15128','2013-07-16','12:15:00',4.04),('15128','2013-07-16','12:20:00',4.11),('15128','2013-07-16','12:25:00',4.15),('15128','2013-07-16','12:30:00',4.18),('15128','2013-07-16','12:35:00',4.22),('15128','2013-07-16','12:40:00',4.25),('15128','2013-07-16','12:45:00',4.23),('15128','2013-07-16','12:50:00',4.23),('15128','2013-07-16','12:55:00',4.24),('15128','2013-07-16','13:00:00',4.22),('15128','2013-07-16','13:05:00',4.23),('15128','2013-07-16','13:10:00',4.32),('15128','2013-07-16','13:15:00',4.28),('15128','2013-07-16','13:20:00',4.25),('15128','2013-07-16','13:25:00',4.26),('15128','2013-07-16','13:30:00',4.29),('15128','2013-07-16','13:35:00',4.31),('15128','2013-07-16','13:40:00',4.3),('15128','2013-07-16','13:45:00',4.3),('15128','2013-07-16','13:50:00',4.29),('15128','2013-07-16','13:55:00',4.32),('15128','2013-07-16','14:00:00',4.32),('15128','2013-07-16','14:05:00',4.32),('15128','2013-07-16','14:10:00',4.32),('15128','2013-07-16','14:15:00',4.31),('15128','2013-07-16','14:20:00',4.3),('15128','2013-07-16','14:25:00',4.28),('15128','2013-07-16','14:30:00',4.26),('15128','2013-07-16','14:35:00',4.27),('15128','2013-07-16','14:40:00',4.27),('15128','2013-07-16','14:45:00',4.29),('15128','2013-07-16','14:50:00',4.26),('15128','2013-07-16','14:55:00',4.24),('15128','2013-07-16','15:00:00',4.24),('15128','2013-07-16','15:05:00',4.23),('15128','2013-07-16','15:10:00',4.19),('15128','2013-07-16','15:15:00',4.2),('15128','2013-07-16','15:20:00',4.18),('15128','2013-07-16','15:25:00',4.04),('15128','2013-07-16','15:30:00',4.07),('15128','2013-07-16','15:35:00',4.16),('15128','2013-07-16','15:40:00',4.15),('15128','2013-07-16','15:45:00',4.1),('15128','2013-07-16','15:50:00',4.11),('15128','2013-07-16','15:55:00',3.92),('15128','2013-07-16','16:00:00',4.02),('15128','2013-07-16','16:05:00',4.07),('15128','2013-07-16','16:10:00',3.95),('15128','2013-07-16','16:15:00',3.67),('15128','2013-07-16','16:20:00',3.6),('15128','2013-07-16','16:25:00',3.61),('15128','2013-07-16','16:30:00',3.59),('15128','2013-07-16','16:35:00',3.47),('15128','2013-07-16','16:40:00',3.43),('15128','2013-07-16','16:45:00',3.36),('15128','2013-07-16','16:50:00',3.29),('15128','2013-07-16','16:55:00',3.25),('15128','2013-07-16','17:00:00',3.19),('15128','2013-07-16','17:05:00',3.16),('15128','2013-07-16','17:10:00',3.09),('15128','2013-07-16','17:15:00',3.03),('15128','2013-07-16','17:20:00',2.95),('15128','2013-07-16','17:25:00',2.91),('15128','2013-07-16','17:30:00',2.86),('15128','2013-07-16','17:35:00',2.76),('15128','2013-07-16','17:40:00',2.66),('15128','2013-07-16','17:45:00',2.63),('15128','2013-07-16','17:50:00',2.52),('15128','2013-07-16','17:55:00',2.44),('15128','2013-07-16','18:00:00',2.33),('15128','2013-07-16','18:05:00',2.25),('15128','2013-07-16','18:10:00',2.13),('15128','2013-07-16','18:15:00',2.02),('15128','2013-07-16','18:20:00',1.88),('15128','2013-07-16','18:25:00',1.8),('15128','2013-07-16','18:30:00',1.71),('15128','2013-07-16','18:35:00',1.66),('15128','2013-07-16','18:40:00',1.56),('15128','2013-07-16','18:45:00',1.51),('15128','2013-07-16','18:50:00',1.42),('15128','2013-07-16','18:55:00',1.33),('15128','2013-07-16','19:00:00',1.27),('15128','2013-07-16','19:05:00',1.18),('15128','2013-07-16','19:10:00',1.08),('15128','2013-07-15','08:10:00',1.04),('15128','2013-07-15','08:15:00',1.12),('15128','2013-07-15','08:20:00',1.18),('15128','2013-07-15','08:25:00',1.23),('15128','2013-07-15','08:30:00',1.3),('15128','2013-07-15','08:35:00',1.37),('15128','2013-07-15','08:40:00',1.41),('15128','2013-07-15','08:45:00',1.48),('15128','2013-07-15','08:50:00',1.6),('15128','2013-07-15','08:55:00',1.68),('15128','2013-07-15','09:00:00',1.74),('15128','2013-07-15','09:05:00',1.81),('15128','2013-07-15','09:10:00',1.88),('15128','2013-07-15','09:15:00',1.99),('15128','2013-07-15','09:20:00',2.07),('15128','2013-07-15','09:25:00',2.09),('15128','2013-07-15','09:30:00',2.1),('15128','2013-07-15','09:35:00',2.16),('15128','2013-07-15','09:40:00',2.24),('15128','2013-07-15','09:45:00',2.29),('15128','2013-07-15','09:50:00',2.32),('15128','2013-07-15','09:55:00',2.37),('15128','2013-07-15','10:00:00',2.44),('15128','2013-07-15','10:05:00',2.55),('15128','2013-07-15','10:10:00',2.57),('15128','2013-07-15','10:15:00',2.6),('15128','2013-07-15','10:20:00',2.63),('15128','2013-07-15','10:25:00',2.68),('15128','2013-07-15','10:30:00',2.76),('15128','2013-07-15','10:35:00',2.77),('15128','2013-07-15','10:40:00',2.88),('15128','2013-07-15','10:45:00',2.93),('15128','2013-07-15','10:50:00',2.99),('15128','2013-07-15','10:55:00',3.11),('15128','2013-07-15','11:00:00',3.09),('15128','2013-07-15','11:05:00',3.18),('15128','2013-07-15','11:10:00',3.19),('15128','2013-07-15','11:15:00',3.26),('15128','2013-07-15','11:20:00',3.37),('15128','2013-07-15','11:25:00',3.38),('15128','2013-07-15','11:30:00',3.42),('15128','2013-07-15','11:35:00',3.39),('15128','2013-07-15','11:40:00',3.5),('15128','2013-07-15','11:45:00',3.58),('15128','2013-07-15','11:50:00',3.64),('15128','2013-07-15','11:55:00',3.79),('15128','2013-07-15','12:00:00',3.9),('15128','2013-07-15','12:05:00',3.93),('15128','2013-07-15','12:10:00',3.97),('15128','2013-07-15','12:15:00',4.03),('15128','2013-07-15','12:20:00',4.09),('15128','2013-07-15','12:25:00',4.12),('15128','2013-07-15','12:30:00',4.13),('15128','2013-07-15','12:35:00',4.17),('15128','2013-07-15','12:40:00',4.2),('15128','2013-07-15','12:45:00',4.25),('15128','2013-07-15','12:50:00',4.25),('15128','2013-07-15','12:55:00',4.26),('15128','2013-07-15','13:00:00',4.27),('15128','2013-07-15','13:05:00',4.29),('15128','2013-07-15','13:10:00',4.27),('15128','2013-07-15','13:15:00',4.27),('15128','2013-07-15','13:20:00',4.25),('15128','2013-07-15','13:25:00',4.23),('15128','2013-07-15','13:30:00',4.17),('15128','2013-07-15','13:35:00',4.33),('15128','2013-07-15','13:40:00',4.3),('15128','2013-07-15','13:45:00',4.31),('15128','2013-07-15','13:50:00',4.3),('15128','2013-07-15','13:55:00',4.31),('15128','2013-07-15','14:00:00',4.29),('15128','2013-07-15','14:05:00',4.29),('15128','2013-07-15','14:10:00',4.27),('15128','2013-07-15','14:15:00',4.32),('15128','2013-07-15','14:20:00',4.32),('15128','2013-07-15','14:25:00',4.25),('15128','2013-07-15','14:30:00',4.21),('15128','2013-07-15','14:35:00',4.19),('15128','2013-07-15','14:40:00',3.99),('15128','2013-07-15','14:45:00',4.21),('15128','2013-07-15','14:50:00',4.17),('15128','2013-07-15','14:55:00',4.1),('15128','2013-07-15','15:00:00',4.11),('15128','2013-07-15','15:05:00',4.09),('15128','2013-07-15','15:10:00',4.06),('15128','2013-07-15','15:15:00',4.02),('15128','2013-07-15','15:20:00',3.97),('15128','2013-07-15','15:25:00',3.95),('15128','2013-07-15','15:30:00',3.89),('15128','2013-07-15','15:35:00',3.92),('15128','2013-07-15','15:40:00',3.94),('15128','2013-07-15','15:45:00',3.94),('15128','2013-07-15','15:50:00',3.89),('15128','2013-07-15','15:55:00',3.86),('15128','2013-07-15','16:00:00',3.81),('15128','2013-07-15','16:05:00',3.75),('15128','2013-07-15','16:10:00',3.78),('15128','2013-07-15','16:15:00',3.8),('15128','2013-07-15','16:20:00',3.74),('15128','2013-07-15','16:25:00',3.62),('15128','2013-07-15','16:30:00',3.65),('15128','2013-07-15','16:35:00',3.72),('15128','2013-07-15','16:40:00',3.74),('15128','2013-07-15','16:45:00',3.6),('15128','2013-07-15','16:50:00',3.47),('15128','2013-07-15','16:55:00',3.57),('15128','2013-07-15','17:00:00',3.37),('15128','2013-07-15','17:05:00',2.91),('15128','2013-07-15','17:10:00',3.13),('15128','2013-07-15','17:15:00',3.12),('15128','2013-07-15','17:20:00',3.11),('15128','2013-07-15','17:25:00',3.07),('15128','2013-07-15','17:30:00',2.91),('15128','2013-07-15','17:35:00',2.8),('15128','2013-07-15','17:40:00',2.62),('15128','2013-07-15','17:45:00',2.62),('15128','2013-07-15','17:50:00',2.3),('15128','2013-07-15','17:55:00',1.65),('15128','2013-07-15','18:05:00',1.75),('15128','2013-07-15','18:30:00',1.29),('15128','2013-07-15','18:40:00',1.28),('15128','2013-07-15','18:45:00',1.51),('15128','2013-07-15','18:50:00',1.36),('15128','2013-07-15','18:55:00',1.32),('15128','2013-07-15','19:00:00',1.28),('15128','2013-07-15','19:05:00',1.03),('15128','2013-07-14','08:10:00',1.08),('15128','2013-07-14','08:15:00',1.14),('15128','2013-07-14','08:20:00',1.21),('15128','2013-07-14','08:25:00',1.26),('15128','2013-07-14','08:30:00',1.34),('15128','2013-07-14','08:35:00',1.4),('15128','2013-07-14','08:40:00',1.45),('15128','2013-07-14','08:45:00',1.57),('15128','2013-07-14','08:50:00',1.65),('15128','2013-07-14','08:55:00',1.72),('15128','2013-07-14','09:00:00',1.79),('15128','2013-07-14','09:05:00',1.89),('15128','2013-07-14','09:10:00',1.97),('15128','2013-07-14','09:15:00',2.07),('15128','2013-07-14','09:20:00',2.14),('15128','2013-07-14','09:25:00',2.18),('15128','2013-07-14','09:30:00',2.15),('15128','2013-07-14','09:35:00',2.2),('15128','2013-07-14','09:40:00',2.29),('15128','2013-07-14','09:45:00',2.32),('15128','2013-07-14','09:50:00',2.39),('15128','2013-07-14','09:55:00',2.44),('15128','2013-07-14','10:00:00',2.48),('15128','2013-07-14','10:05:00',2.6),('15128','2013-07-14','10:10:00',2.67),('15128','2013-07-14','10:15:00',2.68),('15128','2013-07-14','10:20:00',2.72),('15128','2013-07-14','10:25:00',2.72),('15128','2013-07-14','10:30:00',2.81),('15128','2013-07-14','10:35:00',2.83),('15128','2013-07-14','10:40:00',2.92),('15128','2013-07-14','10:45:00',3.01),('15128','2013-07-14','10:50:00',3.09),('15128','2013-07-14','10:55:00',3.2),('15128','2013-07-14','11:00:00',3.16),('15128','2013-07-14','11:05:00',3.29),('15128','2013-07-14','11:10:00',3.26),('15128','2013-07-14','11:15:00',3.38),('15128','2013-07-14','11:20:00',3.47),('15128','2013-07-14','11:25:00',3.5),('15128','2013-07-14','11:30:00',3.57),('15128','2013-07-14','11:35:00',3.48),('15128','2013-07-14','11:40:00',3.58),('15128','2013-07-14','11:45:00',3.69),('15128','2013-07-14','11:50:00',3.79),('15128','2013-07-14','11:55:00',3.92),('15128','2013-07-14','12:00:00',3.97),('15128','2013-07-14','12:05:00',4),('15128','2013-07-14','12:10:00',4.02),('15128','2013-07-14','12:15:00',4.05),('15128','2013-07-14','12:20:00',4.04),('15128','2013-07-14','12:25:00',4.07),('15128','2013-07-14','12:30:00',4.07),('15128','2013-07-14','12:35:00',4.11),('15128','2013-07-14','12:40:00',4.18),('15128','2013-07-14','12:45:00',4.22),('15128','2013-07-14','12:50:00',4.19),('15128','2013-07-14','12:55:00',4.23),('15128','2013-07-14','13:00:00',4.29),('15128','2013-07-14','13:05:00',4.3),('15128','2013-07-14','13:10:00',4.26),('15128','2013-07-14','13:15:00',4.31),('15128','2013-07-14','13:20:00',4.34),('15128','2013-07-14','13:25:00',4.36),('15128','2013-07-14','13:30:00',4.4),('15128','2013-07-14','13:35:00',4.2),('15128','2013-07-14','13:40:00',4.38),('15128','2013-07-14','13:45:00',4.34),('15128','2013-07-14','13:50:00',4.39),('15128','2013-07-14','13:55:00',4.39),('15128','2013-07-14','14:00:00',3.5),('15128','2013-07-14','14:05:00',4.51),('15128','2013-07-14','14:10:00',2.58),('15128','2013-07-14','14:15:00',3.67),('15128','2013-07-14','14:20:00',4.52),('15128','2013-07-14','14:25:00',4.41),('15128','2013-07-14','14:30:00',4.32),('15128','2013-07-14','14:35:00',4.34),('15128','2013-07-14','14:40:00',4.29),('15128','2013-07-14','14:45:00',4.22),('15128','2013-07-14','14:50:00',4.18),('15128','2013-07-14','14:55:00',3.89),('15128','2013-07-14','15:00:00',4.21),('15128','2013-07-14','15:05:00',2.72),('15128','2013-07-14','15:10:00',3.34),('15128','2013-07-14','15:15:00',4.18),('15128','2013-07-14','15:20:00',4.07),('15128','2013-07-14','15:25:00',4.06),('15128','2013-07-14','15:30:00',3.63),('15128','2013-07-14','15:40:00',3),('15128','2013-07-14','15:45:00',4),('15128','2013-07-14','15:50:00',3.93),('15128','2013-07-14','15:55:00',3.9),('15128','2013-07-14','16:00:00',3.84),('15128','2013-07-14','16:05:00',3.83),('15128','2013-07-14','16:10:00',3.79),('15128','2013-07-14','16:15:00',3.73),('15128','2013-07-14','16:20:00',3.66),('15128','2013-07-14','16:25:00',3.63),('15128','2013-07-14','16:30:00',3.57),('15128','2013-07-14','16:35:00',3.49),('15128','2013-07-14','16:40:00',3.45),('15128','2013-07-14','16:45:00',3.32),('15128','2013-07-14','16:50:00',3.25),('15128','2013-07-14','16:55:00',3.19),('15128','2013-07-14','17:00:00',3.19),('15128','2013-07-14','17:05:00',3.13),('15128','2013-07-14','17:10:00',3.08),('15128','2013-07-14','17:15:00',2.99),('15128','2013-07-14','17:20:00',2.93),('15128','2013-07-14','17:25:00',2.87),('15128','2013-07-14','17:30:00',2.79),('15128','2013-07-14','17:35:00',2.69),('15128','2013-07-14','17:40:00',2.61),('15128','2013-07-14','17:45:00',2.55),('15128','2013-07-14','17:50:00',2.45),('15128','2013-07-14','17:55:00',2.29),('15128','2013-07-14','18:00:00',2.22),('15128','2013-07-14','18:05:00',2.13),('15128','2013-07-14','18:10:00',2.01),('15128','2013-07-14','18:15:00',1.95),('15128','2013-07-14','18:20:00',1.83),('15128','2013-07-14','18:25:00',1.73),('15128','2013-07-14','18:30:00',1.69),('15128','2013-07-14','18:35:00',1.6),('15128','2013-07-14','18:40:00',1.51),('15128','2013-07-14','18:45:00',1.42),('15128','2013-07-14','18:50:00',1.37),('15128','2013-07-14','18:55:00',1.32),('15128','2013-07-14','19:00:00',1.23),('15128','2013-07-14','19:05:00',1.12),('15128','2013-07-14','19:10:00',1.01),('15128','2013-07-13','07:50:00',1.16),('15128','2013-07-13','07:55:00',1.17),('15128','2013-07-13','08:00:00',1.05),('15128','2013-07-13','08:05:00',1.05),('15128','2013-07-13','08:30:00',1.17),('15128','2013-07-13','08:35:00',1.26),('15128','2013-07-13','08:50:00',1.22),('15128','2013-07-13','08:55:00',1.09),('15128','2013-07-13','09:15:00',1.62),('15128','2013-07-13','09:20:00',2.35),('15128','2013-07-13','09:25:00',1.54),('15128','2013-07-13','09:30:00',1.43),('15128','2013-07-13','09:35:00',1.45),('15128','2013-07-13','09:40:00',1.53),('15128','2013-07-13','09:45:00',1.75),('15128','2013-07-13','09:50:00',1.74),('15128','2013-07-13','09:55:00',1.73),('15128','2013-07-13','10:00:00',1.57),('15128','2013-07-13','10:05:00',1.36),('15128','2013-07-13','10:10:00',1.41),('15128','2013-07-13','10:15:00',2.11),('15128','2013-07-13','10:20:00',3.2),('15128','2013-07-13','10:25:00',3.13),('15128','2013-07-13','10:30:00',2.58),('15128','2013-07-13','10:35:00',2.36),('15128','2013-07-13','10:40:00',2.37),('15128','2013-07-13','10:45:00',2.58),('15128','2013-07-13','10:50:00',2.77),('15128','2013-07-13','10:55:00',3.07),('15128','2013-07-13','11:00:00',3.35),('15128','2013-07-13','11:05:00',3.33),('15128','2013-07-13','11:10:00',3.62),('15128','2013-07-13','11:15:00',3.36),('15128','2013-07-13','11:20:00',2.5),('15128','2013-07-13','11:25:00',3.77),('15128','2013-07-13','11:30:00',3.33),('15128','2013-07-13','11:35:00',3.26),('15128','2013-07-13','11:40:00',3.11),('15128','2013-07-13','11:45:00',3.85),('15128','2013-07-13','11:50:00',3.86),('15128','2013-07-13','11:55:00',4.01),('15128','2013-07-13','12:00:00',4.05),('15128','2013-07-13','12:05:00',3.82),('15128','2013-07-13','12:10:00',1.74),('15128','2013-07-13','12:15:00',2.87),('15128','2013-07-13','12:20:00',3.09),('15128','2013-07-13','12:25:00',4.09),('15128','2013-07-13','12:30:00',4.56),('15128','2013-07-13','12:35:00',4.51),('15128','2013-07-13','12:40:00',3.11),('15128','2013-07-13','12:45:00',3.89),('15128','2013-07-13','12:50:00',3.73),('15128','2013-07-13','12:55:00',4.64),('15128','2013-07-13','13:00:00',2.97),('15128','2013-07-13','13:05:00',3.23),('15128','2013-07-13','13:10:00',4.54),('15128','2013-07-13','13:15:00',4.35),('15128','2013-07-13','13:20:00',4.35),('15128','2013-07-13','13:25:00',4.3),('15128','2013-07-13','13:30:00',4.37),('15128','2013-07-13','13:35:00',4.42),('15128','2013-07-13','13:40:00',4.47),('15128','2013-07-13','13:45:00',4.52),('15128','2013-07-13','13:50:00',4.52),('15128','2013-07-13','13:55:00',4.55),('15128','2013-07-13','14:00:00',4.52),('15128','2013-07-13','14:05:00',4.52),('15128','2013-07-13','14:10:00',4.56),('15128','2013-07-13','14:15:00',4.51),('15128','2013-07-13','14:20:00',4.51),('15128','2013-07-13','14:25:00',4.48),('15128','2013-07-13','14:30:00',4.46),('15128','2013-07-13','14:35:00',4.4),('15128','2013-07-13','14:40:00',4.4),('15128','2013-07-13','14:45:00',4.4),('15128','2013-07-13','14:50:00',4.39),('15128','2013-07-13','14:55:00',4.31),('15128','2013-07-13','15:00:00',4.3),('15128','2013-07-13','15:05:00',4.33),('15128','2013-07-13','15:10:00',4.26),('15128','2013-07-13','15:15:00',4.22),('15128','2013-07-13','15:20:00',4.2),('15128','2013-07-13','15:25:00',4.21),('15128','2013-07-13','15:30:00',4.2),('15128','2013-07-13','15:35:00',4.16),('15128','2013-07-13','15:40:00',4.17),('15128','2013-07-13','15:45:00',4.1),('15128','2013-07-13','15:50:00',4.01),('15128','2013-07-13','15:55:00',4),('15128','2013-07-13','16:00:00',3.99),('15128','2013-07-13','16:05:00',3.95),('15128','2013-07-13','16:10:00',3.92),('15128','2013-07-13','16:15:00',2.28),('15128','2013-07-13','16:20:00',3.34),('15128','2013-07-13','16:25:00',3.91),('15128','2013-07-13','16:30:00',2.4),('15128','2013-07-13','16:35:00',2.59),('15128','2013-07-13','16:40:00',2.94),('15128','2013-07-13','16:45:00',3.73),('15128','2013-07-13','16:50:00',2.57),('15128','2013-07-13','16:55:00',3.32),('15128','2013-07-13','17:00:00',2.2),('15128','2013-07-13','17:05:00',1.82),('15128','2013-07-13','17:10:00',1.79),('15128','2013-07-13','17:15:00',1.82),('15128','2013-07-13','17:20:00',1.63),('15128','2013-07-13','17:25:00',2.69),('15128','2013-07-13','17:30:00',2.56),('15128','2013-07-13','17:35:00',2.49),('15128','2013-07-13','17:40:00',2.67),('15128','2013-07-13','17:45:00',1.54),('15128','2013-07-13','17:50:00',2.39),('15128','2013-07-13','17:55:00',1.01),('15128','2013-07-13','19:00:00',1.11),('15128','2013-07-13','19:05:00',1.21),('15128','2013-07-13','19:10:00',1.41),('15128','2013-07-13','19:15:00',1.09),('15128','2013-07-12','08:10:00',1.03),('15128','2013-07-12','08:15:00',1.1),('15128','2013-07-12','08:20:00',1.16),('15128','2013-07-12','08:25:00',1.19),('15128','2013-07-12','08:30:00',1.3),('15128','2013-07-12','08:35:00',1.36),('15128','2013-07-12','08:40:00',1.39),('15128','2013-07-12','08:45:00',1.46),('15128','2013-07-12','08:50:00',1.59),('15128','2013-07-12','08:55:00',1.66),('15128','2013-07-12','09:00:00',1.74),('15128','2013-07-12','09:05:00',1.82),('15128','2013-07-12','09:10:00',1.91),('15128','2013-07-12','09:15:00',1.98),('15128','2013-07-12','09:20:00',2.02),('15128','2013-07-12','09:25:00',2.09),('15128','2013-07-12','09:30:00',2.11),('15128','2013-07-12','09:35:00',2.24),('15128','2013-07-12','09:40:00',2.31),('15128','2013-07-12','09:45:00',2.36),('15128','2013-07-12','09:50:00',2.41),('15128','2013-07-12','09:55:00',2.4),('15128','2013-07-12','10:00:00',2.45),('15128','2013-07-12','10:05:00',2.44),('15128','2013-07-12','10:10:00',2.18),('15128','2013-07-12','10:15:00',2.06),('15128','2013-07-12','10:20:00',2.21),('15128','2013-07-12','10:25:00',2.76),('15128','2013-07-12','10:30:00',2.84),('15128','2013-07-12','10:35:00',2.14),('15128','2013-07-12','10:40:00',3.08),('15128','2013-07-12','10:45:00',3.04),('15128','2013-07-12','10:50:00',3.18),('15128','2013-07-12','10:55:00',3.39),('15128','2013-07-12','11:00:00',3.41),('15128','2013-07-12','11:05:00',1.79),('15128','2013-07-12','11:10:00',2.49),('15128','2013-07-12','11:15:00',2.06),('15128','2013-07-12','11:20:00',2.88),('15128','2013-07-12','11:25:00',3.84),('15128','2013-07-12','11:30:00',3.75),('15128','2013-07-12','11:35:00',3.67),('15128','2013-07-12','11:40:00',3.71),('15128','2013-07-12','11:45:00',3.82),('15128','2013-07-12','11:50:00',3.78),('15128','2013-07-12','11:55:00',4.03),('15128','2013-07-12','12:00:00',3.66),('15128','2013-07-12','12:05:00',3.36),('15128','2013-07-12','12:10:00',2.2),('15128','2013-07-12','12:15:00',3.73),('15128','2013-07-12','12:20:00',3.03),('15128','2013-07-12','12:25:00',2.5),('15128','2013-07-12','12:30:00',3.68),('15128','2013-07-12','12:35:00',3.56),('15128','2013-07-12','12:40:00',4.42),('15128','2013-07-12','12:45:00',2.02),('15128','2013-07-12','12:50:00',4.25),('15128','2013-07-12','12:55:00',4.41),('15128','2013-07-12','13:00:00',4.33),('15128','2013-07-12','13:05:00',4.33),('15128','2013-07-12','13:10:00',4.36),('15128','2013-07-12','13:15:00',4.34),('15128','2013-07-12','13:20:00',4.42),('15128','2013-07-12','13:25:00',4.39),('15128','2013-07-12','13:30:00',4.4),('15128','2013-07-12','13:35:00',4.43),('15128','2013-07-12','13:40:00',4.47),('15128','2013-07-12','13:45:00',4.44),('15128','2013-07-12','13:50:00',4.47),('15128','2013-07-12','13:55:00',4.5),('15128','2013-07-12','14:00:00',4.44),('15128','2013-07-12','14:05:00',4.49),('15128','2013-07-12','14:10:00',4.48),('15128','2013-07-12','14:15:00',4.48),('15128','2013-07-12','14:20:00',4.45),('15128','2013-07-12','14:25:00',4.45),('15128','2013-07-12','14:30:00',4.47),('15128','2013-07-12','14:35:00',4.45),('15128','2013-07-12','14:40:00',4.45),('15128','2013-07-12','14:45:00',4.41),('15128','2013-07-12','14:50:00',4.39),('15128','2013-07-12','14:55:00',4.41),('15128','2013-07-12','15:00:00',4.38),('15128','2013-07-12','15:05:00',4.4),('15128','2013-07-12','15:10:00',4.39),('15128','2013-07-12','15:15:00',4.33),('15128','2013-07-12','15:20:00',4.21),('15128','2013-07-12','15:25:00',4.34),('15128','2013-07-12','15:30:00',4.24),('15128','2013-07-12','15:35:00',4.25),('15128','2013-07-12','15:40:00',4.22),('15128','2013-07-12','15:45:00',4.2),('15128','2013-07-12','15:50:00',4.15),('15128','2013-07-12','15:55:00',4.1),('15128','2013-07-12','16:00:00',4.07),('15128','2013-07-12','16:05:00',4.03),('15128','2013-07-12','16:10:00',4),('15128','2013-07-12','16:15:00',3.92),('15128','2013-07-12','16:20:00',3.89),('15128','2013-07-12','16:25:00',3.84),('15128','2013-07-12','16:30:00',3.75),('15128','2013-07-12','16:35:00',3.74),('15128','2013-07-12','16:40:00',3.7),('15128','2013-07-12','16:45:00',3.64),('15128','2013-07-12','16:50:00',3.57),('15128','2013-07-12','16:55:00',3.47),('15128','2013-07-12','17:00:00',3.42),('15128','2013-07-12','17:05:00',3.29),('15128','2013-07-12','17:10:00',3.24),('15128','2013-07-12','17:15:00',3.22),('15128','2013-07-12','17:20:00',3.12),('15128','2013-07-12','17:25:00',3.12),('15128','2013-07-12','17:30:00',2.97),('15128','2013-07-12','17:35:00',2.89),('15128','2013-07-12','17:40:00',2.77),('15128','2013-07-12','17:45:00',2.74),('15128','2013-07-12','17:50:00',2.63),('15128','2013-07-12','17:55:00',2.59),('15128','2013-07-12','18:00:00',2.49),('15128','2013-07-12','18:05:00',2.37),('15128','2013-07-12','18:10:00',2.22),('15128','2013-07-12','18:15:00',2.06),('15128','2013-07-12','18:20:00',2.09),('15128','2013-07-12','18:25:00',1.95),('15128','2013-07-12','18:30:00',1.79),('15128','2013-07-12','18:35:00',1.14),('15128','2013-07-12','18:40:00',1.13),('15128','2013-07-12','18:45:00',1.55),('15128','2013-07-12','18:50:00',1.73),('15128','2013-07-12','18:55:00',1.58),('15128','2013-07-12','19:00:00',1.37),('15128','2013-07-12','19:05:00',1.28),('15128','2013-07-11','08:55:00',1.1),('15128','2013-07-11','09:00:00',1.66),('15128','2013-07-11','09:05:00',1.5),('15128','2013-07-11','09:15:00',1.12),('15128','2013-07-11','09:20:00',1.73),('15128','2013-07-11','09:25:00',1.59),('15128','2013-07-11','09:30:00',2.06),('15128','2013-07-11','09:35:00',2.23),('15128','2013-07-11','09:40:00',2.37),('15128','2013-07-11','09:45:00',2.37),('15128','2013-07-11','09:50:00',2.44),('15128','2013-07-11','09:55:00',2.54),('15128','2013-07-11','10:00:00',2.67),('15128','2013-07-11','10:05:00',2.65),('15128','2013-07-11','10:10:00',1.91),('15128','2013-07-11','10:15:00',1.13),('15128','2013-07-11','10:20:00',2.46),('15128','2013-07-11','10:25:00',2.34),('15128','2013-07-11','10:30:00',3.02),('15128','2013-07-11','10:35:00',2.26),('15128','2013-07-11','10:40:00',2.4),('15128','2013-07-11','10:45:00',1.41),('15128','2013-07-11','10:50:00',1.09),('15128','2013-07-11','10:55:00',1.98),('15128','2013-07-11','11:00:00',3.95),('15128','2013-07-11','11:05:00',3.95),('15128','2013-07-11','11:10:00',2.04),('15128','2013-07-11','11:15:00',3.64),('15128','2013-07-11','11:20:00',3.13),('15128','2013-07-11','11:25:00',3.96),('15128','2013-07-11','11:30:00',3.68),('15128','2013-07-11','11:35:00',3.32),('15128','2013-07-11','11:40:00',3.09),('15128','2013-07-11','11:45:00',2.34),('15128','2013-07-11','11:50:00',2.9),('15128','2013-07-11','11:55:00',4.34),('15128','2013-07-11','12:00:00',2.46),('15128','2013-07-11','12:05:00',4.08),('15128','2013-07-11','12:10:00',2.7),('15128','2013-07-11','12:15:00',4.45),('15128','2013-07-11','12:20:00',4.19),('15128','2013-07-11','12:25:00',4.46),('15128','2013-07-11','12:30:00',4.4),('15128','2013-07-11','12:35:00',4.45),('15128','2013-07-11','12:40:00',3.79),('15128','2013-07-11','12:45:00',3.78),('15128','2013-07-11','12:50:00',4.54),('15128','2013-07-11','12:55:00',4.31),('15128','2013-07-11','13:00:00',4.48),('15128','2013-07-11','13:05:00',4.31),('15128','2013-07-11','13:10:00',4.54),('15128','2013-07-11','13:15:00',4.22),('15128','2013-07-11','13:20:00',4.41),('15128','2013-07-11','13:25:00',4.46),('15128','2013-07-11','13:30:00',4.51),('15128','2013-07-11','13:35:00',4.38),('15128','2013-07-11','13:40:00',4.39),('15128','2013-07-11','13:45:00',4.29),('15128','2013-07-11','13:50:00',3.39),('15128','2013-07-11','13:55:00',2.7),('15128','2013-07-11','14:00:00',2.72),('15128','2013-07-11','14:05:00',4.28),('15128','2013-07-11','14:10:00',4.8),('15128','2013-07-11','14:15:00',4.57),('15128','2013-07-11','14:20:00',4.67),('15128','2013-07-11','14:25:00',2.61),('15128','2013-07-11','14:30:00',4.39),('15128','2013-07-11','14:35:00',4.2),('15128','2013-07-11','14:40:00',4.4),('15128','2013-07-11','14:45:00',4.33),('15128','2013-07-11','14:50:00',4.29),('15128','2013-07-11','14:55:00',4.29),('15128','2013-07-11','15:00:00',4.09),('15128','2013-07-11','15:05:00',4.25),('15128','2013-07-11','15:10:00',4.2),('15128','2013-07-11','15:15:00',4.16),('15128','2013-07-11','15:20:00',4.14),('15128','2013-07-11','15:25:00',4.18),('15128','2013-07-11','15:30:00',4.19),('15128','2013-07-11','15:35:00',4.15),('15128','2013-07-11','15:40:00',4.08),('15128','2013-07-11','15:45:00',3.93),('15128','2013-07-11','15:50:00',3.97),('15128','2013-07-11','15:55:00',3.93),('15128','2013-07-11','16:00:00',3.85),('15128','2013-07-11','16:05:00',3.86),('15128','2013-07-11','16:10:00',3.75),('15128','2013-07-11','16:15:00',3.73),('15128','2013-07-11','16:20:00',3.73),('15128','2013-07-11','16:25:00',3.66),('15128','2013-07-11','16:30:00',3.64),('15128','2013-07-11','16:35:00',3.61),('15128','2013-07-11','16:40:00',3.54),('15128','2013-07-11','16:45:00',3.47),('15128','2013-07-11','16:50:00',3.42),('15128','2013-07-11','16:55:00',3.31),('15128','2013-07-11','17:00:00',3.24),('15128','2013-07-11','17:05:00',3.16),('15128','2013-07-11','17:10:00',3.09),('15128','2013-07-11','17:15:00',3.06),('15128','2013-07-11','17:20:00',2.99),('15128','2013-07-11','17:25:00',2.85),('15128','2013-07-11','17:30:00',2.84),('15128','2013-07-11','17:35:00',2.78),('15128','2013-07-11','17:40:00',2.73),('15128','2013-07-11','17:45:00',2.68),('15128','2013-07-11','17:50:00',2.3),('15128','2013-07-11','17:55:00',2.06),('15128','2013-07-11','18:00:00',2.41),('15128','2013-07-11','18:05:00',1.57),('15128','2013-07-11','18:10:00',2.12),('15128','2013-07-11','18:15:00',2.04),('15128','2013-07-11','18:20:00',1.96),('15128','2013-07-11','18:25:00',1.85),('15128','2013-07-11','18:30:00',1.74),('15128','2013-07-11','18:35:00',1.64),('15128','2013-07-11','18:40:00',1.55),('15128','2013-07-11','18:45:00',1.51),('15128','2013-07-11','18:50:00',1.44),('15128','2013-07-11','18:55:00',1.35),('15128','2013-07-11','19:00:00',1.18),('15128','2013-07-11','19:05:00',1.12),('15128','2013-07-10','08:05:00',1.01),('15128','2013-07-10','08:10:00',1.05),('15128','2013-07-10','08:15:00',1.11),('15128','2013-07-10','08:20:00',1.16),('15128','2013-07-10','08:25:00',1.24),('15128','2013-07-10','08:30:00',1.31),('15128','2013-07-10','08:35:00',1.37),('15128','2013-07-10','08:40:00',1.43),('15128','2013-07-10','08:45:00',1.52),('15128','2013-07-10','08:50:00',1.61),('15128','2013-07-10','08:55:00',1.69),('15128','2013-07-10','09:00:00',1.8),('15128','2013-07-10','09:05:00',1.87),('15128','2013-07-10','09:10:00',1.97),('15128','2013-07-10','09:15:00',2.05),('15128','2013-07-10','09:20:00',2.16),('15128','2013-07-10','09:25:00',2.17),('15128','2013-07-10','09:30:00',2.15),('15128','2013-07-10','09:35:00',2.28),('15128','2013-07-10','09:40:00',1.64),('15128','2013-07-10','09:45:00',1.22),('15128','2013-07-10','09:50:00',1.35),('15128','2013-07-10','09:55:00',1.76),('15128','2013-07-10','10:00:00',1.76),('15128','2013-07-10','10:05:00',2.47),('15128','2013-07-10','10:10:00',2.28),('15128','2013-07-10','10:15:00',1.9),('15128','2013-07-10','10:20:00',1.64),('15128','2013-07-10','10:25:00',3.08),('15128','2013-07-10','10:30:00',1.7),('15128','2013-07-10','10:35:00',1.18),('15128','2013-07-10','10:40:00',3.1),('15128','2013-07-10','10:45:00',3.17),('15128','2013-07-10','10:50:00',3.54),('15128','2013-07-10','10:55:00',3.84),('15128','2013-07-10','11:00:00',3.57),('15128','2013-07-10','11:05:00',3.65),('15128','2013-07-10','11:10:00',1.28),('15128','2013-07-10','11:15:00',1.22),('15128','2013-07-10','11:20:00',3.26),('15128','2013-07-10','11:25:00',1.21),('15128','2013-07-10','11:30:00',1.33),('15128','2013-07-10','11:35:00',3.04),('15128','2013-07-10','11:40:00',1.27),('15128','2013-07-10','11:45:00',1.29),('15128','2013-07-10','11:50:00',3.71),('15128','2013-07-10','11:55:00',4.51),('15128','2013-07-10','12:00:00',4.01),('15128','2013-07-10','12:05:00',3.22),('15128','2013-07-10','12:10:00',3.72),('15128','2013-07-10','12:15:00',1.86),('15128','2013-07-10','12:20:00',2.94),('15128','2013-07-10','12:25:00',2.21),('15128','2013-07-10','12:30:00',3.87),('15128','2013-07-10','12:35:00',3.78),('15128','2013-07-10','12:40:00',4.4),('15128','2013-07-10','12:45:00',4.39),('15128','2013-07-10','12:50:00',4.35),('15128','2013-07-10','12:55:00',4.35),('15128','2013-07-10','13:00:00',4.32),('15128','2013-07-10','13:05:00',4.34),('15128','2013-07-10','13:10:00',4.38),('15128','2013-07-10','13:15:00',4.37),('15128','2013-07-10','13:20:00',4.41),('15128','2013-07-10','13:25:00',4.43),('15128','2013-07-10','13:30:00',4.42),('15128','2013-07-10','13:35:00',4.45),('15128','2013-07-10','13:40:00',4.46),('15128','2013-07-10','13:45:00',4.48),('15128','2013-07-10','13:50:00',4.48),('15128','2013-07-10','13:55:00',4.47),('15128','2013-07-10','14:00:00',4.48),('15128','2013-07-10','14:05:00',4.09),('15128','2013-07-10','14:10:00',4.62),('15128','2013-07-10','14:15:00',4.58),('15128','2013-07-10','14:20:00',4.38),('15128','2013-07-10','14:25:00',4.01),('15128','2013-07-10','14:30:00',4.35),('15128','2013-07-10','14:35:00',4.56),('15128','2013-07-10','14:40:00',4.57),('15128','2013-07-10','14:45:00',4.43),('15128','2013-07-10','14:50:00',3.19),('15128','2013-07-10','14:55:00',4.03),('15128','2013-07-10','15:00:00',3.35),('15128','2013-07-10','15:05:00',4.42),('15128','2013-07-10','15:10:00',4.45),('15128','2013-07-10','15:15:00',4.33),('15128','2013-07-10','15:20:00',4.28),('15128','2013-07-10','15:25:00',4.22),('15128','2013-07-10','15:30:00',4.23),('15128','2013-07-10','15:35:00',4.18),('15128','2013-07-10','15:40:00',3.2),('15128','2013-07-10','15:45:00',2.87),('15128','2013-07-10','15:50:00',3.91),('15128','2013-07-10','15:55:00',3.89),('15128','2013-07-10','16:00:00',3.42),('15128','2013-07-10','16:05:00',4.03),('15128','2013-07-10','16:10:00',3.78),('15128','2013-07-10','16:15:00',3.64),('15128','2013-07-10','16:20:00',3.89),('15128','2013-07-10','16:25:00',3.74),('15128','2013-07-10','16:30:00',3.72),('15128','2013-07-10','16:35:00',3.08),('15128','2013-07-10','16:40:00',3.69),('15128','2013-07-10','16:45:00',3.61),('15128','2013-07-10','16:50:00',3.48),('15128','2013-07-10','16:55:00',3.29),('15128','2013-07-10','17:00:00',2.54),('15128','2013-07-10','17:05:00',2.66),('15128','2013-07-10','17:10:00',2.92),('15128','2013-07-10','17:15:00',2.72),('15128','2013-07-10','17:20:00',1.92),('15128','2013-07-10','17:25:00',1.84),('15128','2013-07-10','17:30:00',1.74),('15128','2013-07-10','17:35:00',1.97),('15128','2013-07-10','17:40:00',1.47),('15128','2013-07-10','17:45:00',3.08),('15128','2013-07-10','17:50:00',2.61),('15128','2013-07-10','17:55:00',2.48),('15128','2013-07-10','18:00:00',2.5),('15128','2013-07-10','18:05:00',2.01),('15128','2013-07-10','18:10:00',1.53),('15128','2013-07-10','18:15:00',2.3),('15128','2013-07-10','18:30:00',1.28),('15128','2013-07-10','19:05:00',1.04),('15128','2013-07-10','19:10:00',1.04),('15128','2014-05-02','08:15:00',1.06),('15128','2014-05-02','08:20:00',1.17),('15128','2014-05-02','08:25:00',1.22),('15128','2014-05-02','08:30:00',1.35),('15128','2014-05-02','08:35:00',1.52),('15128','2014-05-02','08:40:00',1.43),('15128','2014-05-02','08:45:00',1.69),('15128','2014-05-02','08:55:00',1.29),('15128','2014-05-02','09:00:00',1.86),('15128','2014-05-02','09:05:00',1.85),('15128','2014-05-02','09:10:00',2.4),('15128','2014-05-02','09:15:00',1.74),('15128','2014-05-02','09:20:00',1.4),('15128','2014-05-02','09:25:00',1.41),('15128','2014-05-02','09:30:00',2.55),('15128','2014-05-02','09:35:00',1.95),('15128','2014-05-02','09:40:00',3.27),('15128','2014-05-02','09:45:00',2.13),('15128','2014-05-02','09:50:00',1.28),('15128','2014-05-02','09:55:00',1.27),('15128','2014-05-02','10:00:00',1.19),('15128','2014-05-02','10:05:00',1.4),('15128','2014-05-02','10:10:00',3.33),('15128','2014-05-02','10:15:00',4.01),('15128','2014-05-02','10:20:00',3.15),('15128','2014-05-02','10:25:00',1.97),('15128','2014-05-02','10:30:00',1.89),('15128','2014-05-02','10:35:00',3.76),('15128','2014-05-02','10:40:00',2.5),('15128','2014-05-02','10:45:00',1.42),('15128','2014-05-02','10:50:00',2.13),('15128','2014-05-02','10:55:00',1.3),('15128','2014-05-02','11:00:00',1.09),('15128','2014-05-02','11:05:00',1.31),('15128','2014-05-02','11:10:00',1.33),('15128','2014-05-02','11:15:00',1.05),('15128','2014-05-02','11:45:00',3.97),('15128','2014-05-02','11:50:00',3.66),('15128','2014-05-02','11:55:00',2.59),('15128','2014-05-02','12:00:00',2.22),('15128','2014-05-02','12:05:00',2.77),('15128','2014-05-02','12:10:00',2.57),('15128','2014-05-02','12:15:00',2.02),('15128','2014-05-02','12:20:00',1.89),('15128','2014-05-02','12:25:00',1.92),('15128','2014-05-02','12:30:00',1.61),('15128','2014-05-02','12:35:00',1.48),('15128','2014-05-02','12:40:00',1.67),('15128','2014-05-02','12:45:00',1.91),('15128','2014-05-02','12:50:00',2.18),('15128','2014-05-02','12:55:00',2.23),('15128','2014-05-02','13:00:00',2.84),('15128','2014-05-02','13:05:00',3.49),('15128','2014-05-02','13:10:00',3.28),('15128','2014-05-02','13:15:00',3.07),('15128','2014-05-02','13:20:00',2.73),('15128','2014-05-02','13:25:00',3.17),('15128','2014-05-02','13:30:00',2.72),('15128','2014-05-02','13:35:00',1.19),('15128','2014-05-02','13:40:00',1.09),('15128','2014-05-02','13:45:00',1.56),('15128','2014-05-02','13:50:00',2.24),('15128','2014-05-02','13:55:00',2.16),('15128','2014-05-02','14:00:00',1.58),('15128','2014-05-02','14:05:00',2.14),('15128','2014-05-02','14:10:00',3.15),('15128','2014-05-02','14:15:00',3.47),('15128','2014-05-02','14:20:00',3.45),('15128','2014-05-02','14:25:00',3.14),('15128','2014-05-02','14:30:00',2.77),('15128','2014-05-02','14:35:00',2.63),('15128','2014-05-02','14:40:00',2.33),('15128','2014-05-02','14:45:00',1.51),('15128','2014-05-02','17:15:00',1.02),('15128','2014-05-02','17:20:00',1.28),('15128','2014-05-02','17:25:00',1.55),('15128','2014-05-02','17:30:00',1.3),('15128','2014-05-02','17:35:00',1.57),('15128','2014-05-02','17:40:00',1.3),('15128','2014-05-02','17:45:00',1.22),('15128','2014-05-02','17:50:00',1.21),('15128','2014-05-02','17:55:00',1.26),('15128','2014-05-02','18:00:00',1.45),('15128','2014-05-02','18:05:00',1.43),('15128','2014-05-02','18:30:00',1.21),('15128','2014-05-02','18:35:00',1.41),('15128','2014-05-02','18:40:00',1.26),('15128','2014-04-05','08:55:00',1.06),('15128','2014-04-05','09:00:00',1.12),('15128','2014-04-05','09:05:00',1.2),('15128','2014-04-05','09:10:00',1.28),('15128','2014-04-05','09:15:00',1.38),('15128','2014-04-05','09:20:00',1.44),('15128','2014-04-05','09:25:00',1.27),('15128','2014-04-05','09:30:00',1.35),('15128','2014-04-05','09:35:00',1.22),('15128','2014-04-05','09:40:00',1.52),('15128','2014-04-05','09:45:00',1.39),('15128','2014-04-05','09:50:00',1.67),('15128','2014-04-05','09:55:00',2.37),('15128','2014-04-05','10:00:00',2.36),('15128','2014-04-05','10:05:00',2.25),('15128','2014-04-05','10:10:00',1.8),('15128','2014-04-05','10:15:00',1.98),('15128','2014-04-05','10:20:00',2.11),('15128','2014-04-05','10:25:00',3.2),('15128','2014-04-05','10:30:00',3.25),('15128','2014-04-05','10:35:00',3.31),('15128','2014-04-05','10:40:00',3.14),('15128','2014-04-05','10:45:00',3.3),('15128','2014-04-05','10:50:00',3.34),('15128','2014-04-05','10:55:00',2.85),('15128','2014-04-05','11:00:00',3.31),('15128','2014-04-05','11:05:00',3.24),('15128','2014-04-05','11:10:00',3.3),('15128','2014-04-05','11:15:00',2.89),('15128','2014-04-05','11:20:00',1.34),('15128','2014-04-05','11:25:00',2.73),('15128','2014-04-05','11:30:00',2.61),('15128','2014-04-05','11:35:00',3.52),('15128','2014-04-05','11:40:00',3.26),('15128','2014-04-05','11:45:00',3.42),('15128','2014-04-05','11:50:00',3.39),('15128','2014-04-05','11:55:00',3.54),('15128','2014-04-05','12:00:00',3.68),('15128','2014-04-05','12:05:00',3.68),('15128','2014-04-05','12:10:00',3.36),('15128','2014-04-05','12:15:00',3.7),('15128','2014-04-05','12:20:00',3.77),('15128','2014-04-05','12:25:00',3.52),('15128','2014-04-05','12:30:00',3.82),('15128','2014-04-05','12:35:00',3.82),('15128','2014-04-05','12:40:00',3.89),('15128','2014-04-05','12:45:00',3.95),('15128','2014-04-05','12:50:00',2.63),('15128','2014-04-05','12:55:00',4.06),('15128','2014-04-05','13:00:00',4),('15128','2014-04-05','13:05:00',4.21),('15128','2014-04-05','13:10:00',4.39),('15128','2014-04-05','13:15:00',4.42),('15128','2014-04-05','13:20:00',3.94),('15128','2014-04-05','13:25:00',4.34),('15128','2014-04-05','13:30:00',3.54),('15128','2014-04-05','13:35:00',3.6),('15128','2014-04-05','13:40:00',4.03),('15128','2014-04-05','13:45:00',4.04),('15128','2014-04-05','13:50:00',4.17),('15128','2014-04-05','13:55:00',4.1),('15128','2014-04-05','14:00:00',3.58),('15128','2014-04-05','14:05:00',3.97),('15128','2014-04-05','14:10:00',3.44),('15128','2014-04-05','14:15:00',4.17),('15128','2014-04-05','14:20:00',3.92),('15128','2014-04-05','14:25:00',4.02),('15128','2014-04-05','14:30:00',4.06),('15128','2014-04-05','14:35:00',3.83),('15128','2014-04-05','14:40:00',3.16),('15128','2014-04-05','14:45:00',4.06),('15128','2014-04-05','14:50:00',3.44),('15128','2014-04-05','14:55:00',1.84),('15128','2014-04-05','15:00:00',1.26),('15128','2014-04-05','15:20:00',2.06),('15128','2014-04-05','15:25:00',1.04),('15128','2014-04-05','16:00:00',1.72),('15128','2014-04-05','16:05:00',3.74),('15128','2014-04-05','16:10:00',2.17),('15128','2014-04-05','16:45:00',2.64),('15128','2014-04-05','16:50:00',2.05),('15128','2014-04-05','16:55:00',2.7),('15128','2014-04-05','17:00:00',1.15),('15128','2014-04-05','17:20:00',1.43),('15128','2014-04-05','17:25:00',2.29),('15128','2014-04-05','17:30:00',2.16),('15128','2014-04-05','17:35:00',2.04),('15128','2014-04-05','17:40:00',1.94),('15128','2014-04-05','17:45:00',1.8),('15128','2014-04-05','17:50:00',1.75),('15128','2014-04-05','17:55:00',1.67),('15128','2014-04-05','18:00:00',1.62),('15128','2014-04-05','18:05:00',1.53),('15128','2014-04-05','18:10:00',1.46),('15128','2014-04-05','18:15:00',1.35),('15128','2014-04-05','18:20:00',1.29),('15128','2014-04-05','18:25:00',1.19),('15128','2014-04-05','18:30:00',1.08),('15128','2013-07-09','08:30:00',1.1),('15128','2013-07-09','08:35:00',1.39),('15128','2013-07-09','08:40:00',1.64),('15128','2013-07-09','08:45:00',1.81),('15128','2013-07-09','08:50:00',1.8),('15128','2013-07-09','08:55:00',1.8),('15128','2013-07-09','09:00:00',1.88),('15128','2013-07-09','09:05:00',1.95),('15128','2013-07-09','09:10:00',2.01),('15128','2013-07-09','09:15:00',2.08),('15128','2013-07-09','09:20:00',2.15),('15128','2013-07-09','09:25:00',2.14),('15128','2013-07-09','09:30:00',2.19),('15128','2013-07-09','09:35:00',2.33),('15128','2013-07-09','09:40:00',2.37),('15128','2013-07-09','09:45:00',2.41),('15128','2013-07-09','09:50:00',2.47),('15128','2013-07-09','09:55:00',2.52),('15128','2013-07-09','10:00:00',2.59),('15128','2013-07-09','10:05:00',2.66),('15128','2013-07-09','10:10:00',2.69),('15128','2013-07-09','10:15:00',2.74),('15128','2013-07-09','10:20:00',2.76),('15128','2013-07-09','10:25:00',2.77),('15128','2013-07-09','10:30:00',2.83),('15128','2013-07-09','10:35:00',2.89),('15128','2013-07-09','10:40:00',2.89),('15128','2013-07-09','10:45:00',3.01),('15128','2013-07-09','10:50:00',3.07),('15128','2013-07-09','10:55:00',3.15),('15128','2013-07-09','11:00:00',3.16),('15128','2013-07-09','11:05:00',3.27),('15128','2013-07-09','11:10:00',3.19),('15128','2013-07-09','11:15:00',3.33),('15128','2013-07-09','11:20:00',3.39),('15128','2013-07-09','11:25:00',3.45),('15128','2013-07-09','11:30:00',3.47),('15128','2013-07-09','11:35:00',3.41),('15128','2013-07-09','11:40:00',3.55),('15128','2013-07-09','11:45:00',3.65),('15128','2013-07-09','11:50:00',3.72),('15128','2013-07-09','11:55:00',3.8),('15128','2013-07-09','12:00:00',3.87),('15128','2013-07-09','12:05:00',3.92),('15128','2013-07-09','12:10:00',3.98),('15128','2013-07-09','12:15:00',4.03),('15128','2013-07-09','12:20:00',4.06),('15128','2013-07-09','12:25:00',4.15),('15128','2013-07-09','12:30:00',4.16),('15128','2013-07-09','12:35:00',4.15),('15128','2013-07-09','12:40:00',4.17),('15128','2013-07-09','12:45:00',4.19),('15128','2013-07-09','12:50:00',4.26),('15128','2013-07-09','12:55:00',4.25),('15128','2013-07-09','13:00:00',4.27),('15128','2013-07-09','13:05:00',4.27),('15128','2013-07-09','13:10:00',4.33),('15128','2013-07-09','13:15:00',4.33),('15128','2013-07-09','13:20:00',4.38),('15128','2013-07-09','13:25:00',4.41),('15128','2013-07-09','13:30:00',4.41),('15128','2013-07-09','13:35:00',4.44),('15128','2013-07-09','13:40:00',4.47),('15128','2013-07-09','13:45:00',4.47),('15128','2013-07-09','13:50:00',4.48),('15128','2013-07-09','13:55:00',4.5),('15128','2013-07-09','14:00:00',4.51),('15128','2013-07-09','14:05:00',4.54),('15128','2013-07-09','14:10:00',4.52),('15128','2013-07-09','14:15:00',4.49),('15128','2013-07-09','14:20:00',4.5),('15128','2013-07-09','14:25:00',4.45),('15128','2013-07-09','14:30:00',4.43),('15128','2013-07-09','14:35:00',4.41),('15128','2013-07-09','14:40:00',4.4),('15128','2013-07-09','14:45:00',4.37),('15128','2013-07-09','14:50:00',4.34),('15128','2013-07-09','14:55:00',4.37),('15128','2013-07-09','15:00:00',4.4),('15128','2013-07-09','15:05:00',4.38),('15128','2013-07-09','15:10:00',4.37),('15128','2013-07-09','15:15:00',4.34),('15128','2013-07-09','15:20:00',4.32),('15128','2013-07-09','15:25:00',4.3),('15128','2013-07-09','15:30:00',4.22),('15128','2013-07-09','15:35:00',4.22),('15128','2013-07-09','15:40:00',4.2),('15128','2013-07-09','15:45:00',4.14),('15128','2013-07-09','15:50:00',4.09),('15128','2013-07-09','15:55:00',4.05),('15128','2013-07-09','16:00:00',4.02),('15128','2013-07-09','16:05:00',3.97),('15128','2013-07-09','16:10:00',3.9),('15128','2013-07-09','16:15:00',3.87),('15128','2013-07-09','16:20:00',3.78),('15128','2013-07-09','16:25:00',3.73),('15128','2013-07-09','16:30:00',3.68),('15128','2013-07-09','16:35:00',3.66),('15128','2013-07-09','16:40:00',3.63),('15128','2013-07-09','16:45:00',3.61),('15128','2013-07-09','16:50:00',3.68),('15128','2013-07-09','16:55:00',3.82),('15128','2013-07-09','17:00:00',3.75),('15128','2013-07-09','17:05:00',2.71),('15128','2013-07-09','17:10:00',2.14),('15128','2013-07-09','17:15:00',1.72),('15128','2013-07-09','17:20:00',2.12),('15128','2013-07-09','17:25:00',2.28),('15128','2013-07-09','17:30:00',2.6),('15128','2013-07-09','17:35:00',3.47),('15128','2013-07-09','17:40:00',3.23),('15128','2013-07-09','17:45:00',2.97),('15128','2013-07-09','17:50:00',2.17),('15128','2013-07-09','17:55:00',1.11),('15128','2013-07-09','18:00:00',1.47),('15128','2013-07-09','18:55:00',1.73),('15128','2013-07-09','19:00:00',1.16),('15128','2013-07-09','19:05:00',1.33),('15128','2013-07-09','19:10:00',1.16),('15128','2013-07-09','19:15:00',1.22),('15128','2013-07-09','19:20:00',1.07),('15128','2013-07-08','08:05:00',1.08),('15128','2013-07-08','08:10:00',1.13),('15128','2013-07-08','08:15:00',1.17),('15128','2013-07-08','08:20:00',1.23),('15128','2013-07-08','08:25:00',1.29),('15128','2013-07-08','08:30:00',1.38),('15128','2013-07-08','08:35:00',1.43),('15128','2013-07-08','08:40:00',1.46),('15128','2013-07-08','08:45:00',1.54),('15128','2013-07-08','08:50:00',1.65),('15128','2013-07-08','08:55:00',1.72),('15128','2013-07-08','09:00:00',1.84),('15128','2013-07-08','09:05:00',1.9),('15128','2013-07-08','09:10:00',1.97),('15128','2013-07-08','09:15:00',2.06),('15128','2013-07-08','09:20:00',2.13),('15128','2013-07-08','09:25:00',2.13),('15128','2013-07-08','09:30:00',2.2),('15128','2013-07-08','09:35:00',2.31),('15128','2013-07-08','09:40:00',2.35),('15128','2013-07-08','09:45:00',2.43),('15128','2013-07-08','09:50:00',2.48),('15128','2013-07-08','09:55:00',2.51),('15128','2013-07-08','10:00:00',2.56),('15128','2013-07-08','10:05:00',2.66),('15128','2013-07-08','10:10:00',2.68),('15128','2013-07-08','10:15:00',2.74),('15128','2013-07-08','10:20:00',2.78),('15128','2013-07-08','10:25:00',2.79),('15128','2013-07-08','10:30:00',2.84),('15128','2013-07-08','10:35:00',2.9),('15128','2013-07-08','10:40:00',2.87),('15128','2013-07-08','10:45:00',3),('15128','2013-07-08','10:50:00',3.05),('15128','2013-07-08','10:55:00',3.15),('15128','2013-07-08','11:00:00',3.1),('15128','2013-07-08','11:05:00',3.22),('15128','2013-07-08','11:10:00',3.17),('15128','2013-07-08','11:15:00',3.34),('15128','2013-07-08','11:20:00',3.47),('15128','2013-07-08','11:25:00',3.58),('15128','2013-07-08','11:30:00',3.61),('15128','2013-07-08','11:35:00',3.56),('15128','2013-07-08','11:40:00',3.72),('15128','2013-07-08','11:45:00',3.83),('15128','2013-07-08','11:50:00',3.86),('15128','2013-07-08','11:55:00',3.98),('15128','2013-07-08','12:00:00',4.01),('15128','2013-07-08','12:05:00',4.02),('15128','2013-07-08','12:10:00',4.06),('15128','2013-07-08','12:15:00',3.75),('15128','2013-07-08','12:20:00',3.61),('15128','2013-07-08','12:25:00',4.2),('15128','2013-07-08','12:30:00',4.15),('15128','2013-07-08','12:35:00',4.14),('15128','2013-07-08','12:40:00',4.18),('15128','2013-07-08','12:45:00',4.18),('15128','2013-07-08','12:50:00',3.79),('15128','2013-07-08','12:55:00',4.32),('15128','2013-07-08','13:00:00',4.46),('15128','2013-07-08','13:05:00',2.46),('15128','2013-07-08','13:10:00',2.45),('15128','2013-07-08','13:15:00',4),('15128','2013-07-08','13:20:00',4.59),('15128','2013-07-08','13:25:00',4.51),('15128','2013-07-08','13:30:00',4.53),('15128','2013-07-08','13:35:00',4.53),('15128','2013-07-08','13:40:00',4.42),('15128','2013-07-08','13:45:00',3.86),('15128','2013-07-08','13:50:00',4.18),('15128','2013-07-08','13:55:00',4.32),('15128','2013-07-08','14:00:00',3.89),('15128','2013-07-08','14:05:00',4.08),('15128','2013-07-08','14:10:00',4.4),('15128','2013-07-08','14:15:00',4.9),('15128','2013-07-08','14:20:00',3.57),('15128','2013-07-08','14:25:00',2.96),('15128','2013-07-08','14:30:00',1.11),('15128','2013-07-07','08:00:00',1.06),('15128','2013-07-07','08:05:00',1.14),('15128','2013-07-07','08:10:00',1.16),('15128','2013-07-07','08:15:00',1.2),('15128','2013-07-07','08:20:00',1.25),('15128','2013-07-07','08:25:00',1.3),('15128','2013-07-07','08:30:00',1.38),('15128','2013-07-07','08:35:00',1.41),('15128','2013-07-07','08:40:00',1.46),('15128','2013-07-07','08:45:00',1.55),('15128','2013-07-07','08:50:00',1.65),('15128','2013-07-07','08:55:00',1.72),('15128','2013-07-07','09:00:00',1.81),('15128','2013-07-07','09:05:00',1.88),('15128','2013-07-07','09:10:00',1.97),('15128','2013-07-07','09:15:00',2.07),('15128','2013-07-07','09:20:00',2.1),('15128','2013-07-07','09:25:00',2.08),('15128','2013-07-07','09:30:00',2.18),('15128','2013-07-07','09:35:00',2.29),('15128','2013-07-07','09:40:00',2.36),('15128','2013-07-07','09:45:00',2.4),('15128','2013-07-07','09:50:00',2.44),('15128','2013-07-07','09:55:00',2.5),('15128','2013-07-07','10:00:00',2.58),('15128','2013-07-07','10:05:00',2.64),('15128','2013-07-07','10:10:00',2.68),('15128','2013-07-07','10:15:00',2.74),('15128','2013-07-07','10:20:00',2.78),('15128','2013-07-07','10:25:00',2.81),('15128','2013-07-07','10:30:00',2.86),('15128','2013-07-07','10:35:00',2.6),('15128','2013-07-07','10:40:00',2.94),('15128','2013-07-07','10:45:00',3.04),('15128','2013-07-07','10:50:00',3),('15128','2013-07-07','10:55:00',3.15),('15128','2013-07-07','11:00:00',3.11),('15128','2013-07-07','11:05:00',3.26),('15128','2013-07-07','11:10:00',3.23),('15128','2013-07-07','11:15:00',3.41),('15128','2013-07-07','11:20:00',3.44),('15128','2013-07-07','11:25:00',3.29),('15128','2013-07-07','11:30:00',3.5),('15128','2013-07-07','11:35:00',3.02),('15128','2013-07-07','11:40:00',3.35),('15128','2013-07-07','11:45:00',3.92),('15128','2013-07-07','11:50:00',3.91),('15128','2013-07-07','11:55:00',3.87),('15128','2013-07-07','12:00:00',3.95),('15128','2013-07-07','12:05:00',4.12),('15128','2013-07-07','12:10:00',3.58),('15128','2013-07-07','12:15:00',3.92),('15128','2013-07-07','12:20:00',3.28),('15128','2013-07-07','12:25:00',3.41),('15128','2013-07-07','12:30:00',4.33),('15128','2013-07-07','12:35:00',4.28),('15128','2013-07-07','12:40:00',4.28),('15128','2013-07-07','12:45:00',4.43),('15128','2013-07-07','12:50:00',4.46),('15128','2013-07-07','12:55:00',4.22),('15128','2013-07-07','13:00:00',3.1),('15128','2013-07-07','13:05:00',4.46),('15128','2013-07-07','13:10:00',3.97),('15128','2013-07-07','13:15:00',1.6),('15128','2013-07-07','14:00:00',1.02),('15128','2013-07-07','14:05:00',1.28),('15128','2013-07-07','14:10:00',1.54),('15128','2013-07-07','14:15:00',1.67),('15128','2013-07-07','14:20:00',1.46),('15128','2013-07-07','14:25:00',1.45),('15128','2013-07-07','14:30:00',1.4),('15128','2013-07-07','14:35:00',1.81),('15128','2013-07-07','14:40:00',2.39),('15128','2013-07-07','14:45:00',2.5),('15128','2013-07-07','14:50:00',2.11),('15128','2013-07-07','14:55:00',1.65),('15128','2013-07-07','15:00:00',1.57),('15128','2013-07-07','15:05:00',1.71),('15128','2013-07-07','15:10:00',1.57),('15128','2013-07-07','15:15:00',1.32),('15128','2013-07-07','18:30:00',1.4),('15128','2013-07-07','18:35:00',1.46),('15128','2013-07-07','18:40:00',1.3),('15128','2013-07-07','18:45:00',1.25),('15128','2013-07-06','08:05:00',1.06),('15128','2013-07-06','08:10:00',1.13),('15128','2013-07-06','08:15:00',1.19),('15128','2013-07-06','08:20:00',1.25),('15128','2013-07-06','08:25:00',1.36),('15128','2013-07-06','08:30:00',1.35),('15128','2013-07-06','08:40:00',1.18),('15128','2013-07-06','08:45:00',1.71),('15128','2013-07-06','08:50:00',1.8),('15128','2013-07-06','08:55:00',1.89),('15128','2013-07-06','09:00:00',1.8),('15128','2013-07-06','09:05:00',1.53),('15128','2013-07-06','09:10:00',1.65),('15128','2013-07-06','09:15:00',1.24),('15128','2013-07-06','09:20:00',1.23),('15128','2013-07-06','09:25:00',1.29),('15128','2013-07-06','09:30:00',2.05),('15128','2013-07-06','09:35:00',2.47),('15128','2013-07-06','09:40:00',2.13),('15128','2013-07-06','09:45:00',2.56),('15128','2013-07-06','09:50:00',2.7),('15128','2013-07-06','09:55:00',2.68),('15128','2013-07-06','10:00:00',2.72),('15128','2013-07-06','10:05:00',2.65),('15128','2013-07-06','10:10:00',2.63),('15128','2013-07-06','10:15:00',2.34),('15128','2013-07-06','10:20:00',2.9),('15128','2013-07-06','10:25:00',2.98),('15128','2013-07-06','10:30:00',2.69),('15128','2013-07-06','10:35:00',2.88),('15128','2013-07-06','10:40:00',2.9),('15128','2013-07-06','10:45:00',3.12),('15128','2013-07-06','10:50:00',3.19),('15128','2013-07-06','10:55:00',3.27),('15128','2013-07-06','11:00:00',3.23),('15128','2013-07-06','11:05:00',3.34),('15128','2013-07-06','11:10:00',3.3),('15128','2013-07-06','11:15:00',3.45),('15128','2013-07-06','11:20:00',2.95),('15128','2013-07-06','11:25:00',2.99),('15128','2013-07-06','11:30:00',3.48),('15128','2013-07-06','11:35:00',3.19),('15128','2013-07-06','11:40:00',3.33),('15128','2013-07-06','11:45:00',3.51),('15128','2013-07-06','11:50:00',3.76),('15128','2013-07-06','11:55:00',3.63),('15128','2013-07-06','12:00:00',3.03),('15128','2013-07-06','12:05:00',3.13),('15128','2013-07-06','12:10:00',3.37),('15128','2013-07-06','12:15:00',3.08),('15128','2013-07-06','12:20:00',3.33),('15128','2013-07-06','12:25:00',3.96),('15128','2013-07-06','12:30:00',4.03),('15128','2013-07-06','12:35:00',4.07),('15128','2013-07-06','12:40:00',4.11),('15128','2013-07-06','12:45:00',4.12),('15128','2013-07-06','12:50:00',4.17),('15128','2013-07-06','12:55:00',4.33),('15128','2013-07-06','13:00:00',4.29),('15128','2013-07-06','13:05:00',4.12),('15128','2013-07-06','13:10:00',4.3),('15128','2013-07-06','13:15:00',4.39),('15128','2013-07-06','13:20:00',4.37),('15128','2013-07-06','13:25:00',4.42),('15128','2013-07-06','13:30:00',4.53),('15128','2013-07-06','13:35:00',3.4),('15128','2013-07-06','13:40:00',1.35),('15128','2013-07-06','13:45:00',1.24),('15128','2013-07-06','13:50:00',1.69),('15128','2013-07-06','13:55:00',1.27),('15128','2013-07-06','14:00:00',1.05),('15128','2013-07-06','14:10:00',1.18),('15128','2013-07-06','14:15:00',1.67),('15128','2013-07-06','14:20:00',3.47),('15128','2013-07-06','14:25:00',3.44),('15128','2013-07-06','14:30:00',3.06),('15128','2013-07-06','14:35:00',1.68),('15128','2013-07-06','14:40:00',1.32),('15128','2013-07-06','14:45:00',1.31),('15128','2013-07-06','14:50:00',1.31),('15128','2013-07-06','14:55:00',1.37),('15128','2013-07-06','15:00:00',1.57),('15128','2013-07-06','15:05:00',1.88),('15128','2013-07-06','15:10:00',2.15),('15128','2013-07-06','15:15:00',1.37),('15128','2013-07-06','17:00:00',1.12),('15128','2013-07-06','17:05:00',1.22),('15128','2013-07-06','17:10:00',1.31),('15128','2013-07-06','17:15:00',1.4),('15128','2013-07-06','17:20:00',1.46),('15128','2013-07-06','17:25:00',1.48),('15128','2013-07-06','17:30:00',1.54),('15128','2013-07-06','17:35:00',1.7),('15128','2013-07-06','17:40:00',1.77),('15128','2013-07-06','17:45:00',1.97),('15128','2013-07-06','17:50:00',1.91),('15128','2013-07-06','17:55:00',1.83),('15128','2013-07-06','18:00:00',1.58),('15128','2013-07-06','18:05:00',1.55),('15128','2013-07-06','18:10:00',1.17),('15128','2013-07-06','18:15:00',1.16),('15128','2013-07-06','18:20:00',1.17),('15128','2013-07-06','18:25:00',1.29),('15128','2013-07-06','18:30:00',1.13),('15128','2013-07-05','08:10:00',1.01),('15128','2013-07-05','08:15:00',1.06),('15128','2013-07-05','08:20:00',1.13),('15128','2013-07-05','08:25:00',1.21),('15128','2013-07-05','08:30:00',1.28),('15128','2013-07-05','08:35:00',1.32),('15128','2013-07-05','08:40:00',1.4),('15128','2013-07-05','08:45:00',1.48),('15128','2013-07-05','08:50:00',1.55),('15128','2013-07-05','08:55:00',1.63),('15128','2013-07-05','09:00:00',1.75),('15128','2013-07-05','09:05:00',1.81),('15128','2013-07-05','09:10:00',1.88),('15128','2013-07-05','09:15:00',1.95),('15128','2013-07-05','09:20:00',2),('15128','2013-07-05','09:25:00',1.98),('15128','2013-07-05','09:30:00',2.11),('15128','2013-07-05','09:35:00',2.21),('15128','2013-07-05','09:40:00',2.27),('15128','2013-07-05','09:45:00',2.33),('15128','2013-07-05','09:50:00',2.37),('15128','2013-07-05','09:55:00',2.43),('15128','2013-07-05','10:00:00',2.47),('15128','2013-07-05','10:05:00',2.56),('15128','2013-07-05','10:10:00',2.59),('15128','2013-07-05','10:15:00',2.65),('15128','2013-07-05','10:20:00',2.7),('15128','2013-07-05','10:25:00',2.72),('15128','2013-07-05','10:30:00',2.77),('15128','2013-07-05','10:35:00',2.84),('15128','2013-07-05','10:40:00',2.84),('15128','2013-07-05','10:45:00',2.93),('15128','2013-07-05','10:50:00',2.95),('15128','2013-07-05','10:55:00',3.04),('15128','2013-07-05','11:00:00',3.06),('15128','2013-07-05','11:05:00',3.17),('15128','2013-07-05','11:10:00',3.11),('15128','2013-07-05','11:15:00',3.28),('15128','2013-07-05','11:20:00',3.34),('15128','2013-07-05','11:25:00',3.41),('15128','2013-07-05','11:30:00',3.39),('15128','2013-07-05','11:35:00',3.32),('15128','2013-07-05','11:40:00',3.46),('15128','2013-07-05','11:45:00',3.64),('15128','2013-07-05','11:50:00',3.71),('15128','2013-07-05','11:55:00',3.81),('15128','2013-07-05','12:00:00',3.83),('15128','2013-07-05','12:05:00',3.86),('15128','2013-07-05','12:10:00',3.92),('15128','2013-07-05','12:15:00',3.96),('15128','2013-07-05','12:20:00',3.97),('15128','2013-07-05','12:25:00',4.02),('15128','2013-07-05','12:30:00',4.07),('15128','2013-07-05','12:35:00',4.12),('15128','2013-07-05','12:40:00',4.13),('15128','2013-07-05','12:45:00',4.15),('15128','2013-07-05','12:50:00',4.15),('15128','2013-07-05','12:55:00',4.17),('15128','2013-07-05','13:00:00',4.18),('15128','2013-07-05','13:05:00',4.19),('15128','2013-07-05','13:10:00',4.19),('15128','2013-07-05','13:15:00',4.2),('15128','2013-07-05','13:20:00',4.24),('15128','2013-07-05','13:25:00',4.25),('15128','2013-07-05','13:30:00',4.24),('15128','2013-07-05','13:35:00',4.28),('15128','2013-07-05','13:40:00',4.3),('15128','2013-07-05','13:45:00',4.28),('15128','2013-07-05','13:50:00',4.24),('15128','2013-07-05','13:55:00',4.26),('15128','2013-07-05','14:00:00',4.28),('15128','2013-07-05','14:05:00',4.25),('15128','2013-07-05','14:10:00',4.22),('15128','2013-07-05','14:15:00',4.21),('15128','2013-07-05','14:20:00',3.87),('15128','2013-07-05','14:25:00',4.21),('15128','2013-07-05','14:30:00',4.17),('15128','2013-07-05','14:35:00',4.15),('15128','2013-07-05','14:40:00',4.32),('15128','2013-07-05','14:45:00',4.34),('15128','2013-07-05','14:50:00',3.69),('15128','2013-07-05','14:55:00',1.18),('15128','2013-07-05','15:00:00',2.56),('15128','2013-07-05','15:05:00',1.4),('15128','2013-07-05','15:10:00',1.62),('15128','2013-07-05','15:15:00',2.37),('15128','2013-07-05','15:20:00',4.2),('15128','2013-07-05','15:25:00',1.1),('15128','2013-07-05','16:15:00',1.03),('15128','2013-07-05','16:20:00',1.08),('15128','2013-07-05','16:25:00',1.07),('15128','2013-07-05','16:30:00',1.29),('15128','2013-07-05','16:35:00',1.7),('15128','2013-07-05','16:40:00',1.49),('15128','2013-07-05','16:45:00',1.45),('15128','2013-07-05','16:50:00',3.37),('15128','2013-07-05','16:55:00',3.69),('15128','2013-07-05','17:00:00',3),('15128','2013-07-05','17:05:00',3.21),('15128','2013-07-05','17:10:00',2.63),('15128','2013-07-05','17:15:00',1.72),('15128','2013-07-05','17:20:00',1.3),('15128','2013-07-05','17:25:00',1.07),('15128','2013-07-05','19:10:00',1.29),('15128','2013-07-04','08:05:00',1.03),('15128','2013-07-04','08:10:00',1.09),('15128','2013-07-04','08:15:00',1.14),('15128','2013-07-04','08:20:00',1.21),('15128','2013-07-04','08:25:00',1.3),('15128','2013-07-04','08:30:00',1.36),('15128','2013-07-04','08:35:00',1.38),('15128','2013-07-04','08:40:00',1.42),('15128','2013-07-04','08:45:00',1.51),('15128','2013-07-04','08:50:00',1.59),('15128','2013-07-04','08:55:00',1.67),('15128','2013-07-04','09:00:00',1.78),('15128','2013-07-04','09:05:00',1.84),('15128','2013-07-04','09:10:00',1.91),('15128','2013-07-04','09:15:00',1.98),('15128','2013-07-04','09:20:00',2.03),('15128','2013-07-04','09:25:00',1.99),('15128','2013-07-04','09:30:00',2.11),('15128','2013-07-04','09:35:00',2.2),('15128','2013-07-04','09:40:00',2.27),('15128','2013-07-04','09:45:00',2.31),('15128','2013-07-04','09:50:00',2.35),('15128','2013-07-04','09:55:00',2.4),('15128','2013-07-04','10:00:00',2.45),('15128','2013-07-04','10:05:00',2.53),('15128','2013-07-04','10:10:00',2.57),('15128','2013-07-04','10:15:00',2.62),('15128','2013-07-04','10:20:00',2.66),('15128','2013-07-04','10:25:00',2.7),('15128','2013-07-04','10:30:00',2.77),('15128','2013-07-04','10:35:00',2.85),('15128','2013-07-04','10:40:00',2.83),('15128','2013-07-04','10:45:00',2.97),('15128','2013-07-04','10:50:00',2.99),('15128','2013-07-04','10:55:00',3.05),('15128','2013-07-04','11:00:00',3.04),('15128','2013-07-04','11:05:00',3.14),('15128','2013-07-04','11:10:00',3.11),('15128','2013-07-04','11:15:00',3.25),('15128','2013-07-04','11:20:00',3.32),('15128','2013-07-04','11:25:00',3.41),('15128','2013-07-04','11:30:00',3.4),('15128','2013-07-04','11:35:00',3.36),('15128','2013-07-04','11:40:00',3.47),('15128','2013-07-04','11:45:00',3.62),('15128','2013-07-04','11:50:00',3.68),('15128','2013-07-04','11:55:00',3.81),('15128','2013-07-04','12:00:00',3.89),('15128','2013-07-04','12:05:00',3.91),('15128','2013-07-04','12:10:00',3.97),('15128','2013-07-04','12:15:00',3.97),('15128','2013-07-04','12:20:00',3.71),('15128','2013-07-04','12:25:00',2.47),('15128','2013-07-04','12:30:00',3.12),('15128','2013-07-04','12:35:00',4.36),('15128','2013-07-04','12:40:00',2.99),('15128','2013-07-04','12:45:00',2.58),('15128','2013-07-04','12:50:00',1.95),('15128','2013-07-04','12:55:00',1.27),('15128','2013-07-04','13:00:00',2.72),('15128','2013-07-04','13:05:00',4.45),('15128','2013-07-04','13:10:00',4.51),('15128','2013-07-04','13:15:00',4.34),('15128','2013-07-04','13:20:00',4.5),('15128','2013-07-04','13:25:00',4.51),('15128','2013-07-04','13:30:00',4.65),('15128','2013-07-04','13:35:00',4.5),('15128','2013-07-04','13:40:00',3.88),('15128','2013-07-04','13:45:00',4.37),('15128','2013-07-04','13:50:00',4.36),('15128','2013-07-04','13:55:00',4.34),('15128','2013-07-04','14:00:00',4.46),('15128','2013-07-04','14:05:00',4.45),('15128','2013-07-04','14:10:00',4.23),('15128','2013-07-04','14:15:00',4.1),('15128','2013-07-04','14:20:00',4.27),('15128','2013-07-04','14:25:00',4.38),('15128','2013-07-04','14:30:00',4.33),('15128','2013-07-04','14:35:00',4.33),('15128','2013-07-04','14:40:00',4.32),('15128','2013-07-04','14:45:00',4.29),('15128','2013-07-04','14:50:00',4.33),('15128','2013-07-04','14:55:00',4.15),('15128','2013-07-04','15:00:00',1.63),('15128','2013-07-04','15:05:00',4.01),('15128','2013-07-04','15:10:00',3.35),('15128','2013-07-04','15:15:00',1.5),('15128','2013-07-04','15:20:00',3.28),('15128','2013-07-04','15:25:00',2.33),('15128','2013-07-04','15:30:00',2.26),('15128','2013-07-04','15:35:00',2.52),('15128','2013-07-04','15:40:00',4.12),('15128','2013-07-04','15:45:00',4.05),('15128','2013-07-04','15:50:00',3.89),('15128','2013-07-04','15:55:00',3.88),('15128','2013-07-04','16:00:00',3.83),('15128','2013-07-04','16:05:00',3.32),('15128','2013-07-04','16:10:00',3.45),('15128','2013-07-04','16:15:00',3.74),('15128','2013-07-04','16:20:00',3.69),('15128','2013-07-04','16:25:00',3.61),('15128','2013-07-04','16:30:00',3.51),('15128','2013-07-04','16:35:00',3.38),('15128','2013-07-04','16:40:00',3.44),('15128','2013-07-04','16:45:00',3.34),('15128','2013-07-04','16:50:00',2.28),('15128','2013-07-04','16:55:00',2.1),('15128','2013-07-04','17:00:00',2.06),('15128','2013-07-04','17:05:00',3.2),('15128','2013-07-04','17:10:00',2.43),('15128','2013-07-04','17:15:00',1.11),('15128','2013-07-04','17:20:00',2.56),('15128','2013-07-04','17:25:00',2.9),('15128','2013-07-04','17:30:00',2.82),('15128','2013-07-04','17:35:00',2.73),('15128','2013-07-04','17:40:00',2.65),('15128','2013-07-04','17:45:00',2.57),('15128','2013-07-04','17:50:00',2.54),('15128','2013-07-04','17:55:00',2.51),('15128','2013-07-04','18:00:00',2.49),('15128','2013-07-04','18:05:00',2.52),('15128','2013-07-04','18:10:00',2.45),('15128','2013-07-04','18:15:00',2.32),('15128','2013-07-04','18:20:00',2.13),('15128','2013-07-04','18:25:00',1.96),('15128','2013-07-04','18:30:00',1.82),('15128','2013-07-04','18:35:00',1.7),('15128','2013-07-04','18:40:00',1.6),('15128','2013-07-04','18:45:00',1.5),('15128','2013-07-04','18:50:00',1.45),('15128','2013-07-04','18:55:00',1.39),('15128','2013-07-04','19:00:00',1.28),('15128','2013-07-04','19:05:00',1.19),('15128','2013-07-04','19:10:00',1.1),('15128','2013-07-04','19:15:00',1.01),('15128','2013-07-03','11:00:00',1.07),('15128','2013-07-03','11:05:00',1.24),('15128','2013-07-03','11:10:00',1.19),('15128','2013-07-03','11:15:00',1.14),('15128','2013-07-03','11:20:00',1.14),('15128','2013-07-03','11:25:00',1.19),('15128','2013-07-03','11:30:00',1.34),('15128','2013-07-03','11:35:00',1.49),('15128','2013-07-03','11:40:00',1.75),('15128','2013-07-03','11:45:00',2.07),('15128','2013-07-03','11:50:00',1.93),('15128','2013-07-03','11:55:00',1.65),('15128','2013-07-03','12:00:00',1.7),('15128','2013-07-03','12:05:00',2),('15128','2013-07-03','12:10:00',2.58),('15128','2013-07-03','12:15:00',2.49),('15128','2013-07-03','12:20:00',1.93),('15128','2013-07-03','12:25:00',1.42),('15128','2013-07-03','12:55:00',1.06),('15128','2013-07-03','13:00:00',1.17),('15128','2013-07-03','13:05:00',1.72),('15128','2013-07-03','13:10:00',1.26),('15128','2013-07-03','13:15:00',1.71),('15128','2013-07-03','13:20:00',1.51),('15128','2013-07-03','13:25:00',1.81),('15128','2013-07-03','13:30:00',2.09),('15128','2013-07-03','13:35:00',2.08),('15128','2013-07-03','13:40:00',2.29),('15128','2013-07-03','13:45:00',2.92),('15128','2013-07-03','13:50:00',2.14),('15128','2013-07-03','13:55:00',1.94),('15128','2013-07-03','14:00:00',1.98),('15128','2013-07-03','14:05:00',2.02),('15128','2013-07-03','14:10:00',2.19),('15128','2013-07-03','14:15:00',3.5),('15128','2013-07-03','14:20:00',3),('15128','2013-07-03','14:25:00',3.07),('15128','2013-07-03','14:30:00',2.7),('15128','2013-07-03','14:35:00',1.82),('15128','2013-07-03','14:40:00',1.71),('15128','2013-07-03','14:45:00',1.66),('15128','2013-07-03','14:50:00',2.06),('15128','2013-07-03','14:55:00',4.71),('15128','2013-07-03','15:00:00',4.03),('15128','2013-07-03','15:05:00',3.33),('15128','2013-07-03','15:10:00',2.02),('15128','2013-07-03','15:15:00',4.35),('15128','2013-07-03','15:20:00',2.96),('15128','2013-07-03','15:25:00',1.81),('15128','2013-07-03','15:30:00',2.23),('15128','2013-07-03','15:35:00',3.3),('15128','2013-07-03','15:40:00',2.99),('15128','2013-07-03','15:45:00',3.55),('15128','2013-07-03','15:50:00',4.58),('15128','2013-07-03','15:55:00',3.59),('15128','2013-07-03','16:00:00',2.49),('15128','2013-07-03','16:05:00',2.43),('15128','2013-07-03','16:10:00',2.84),('15128','2013-07-03','16:15:00',2.94),('15128','2013-07-03','16:20:00',3.31),('15128','2013-07-03','16:25:00',2.31),('15128','2013-07-03','16:30:00',1.98),('15128','2013-07-03','16:35:00',1.73),('15128','2013-07-03','16:40:00',1.6),('15128','2013-07-03','16:45:00',1.57),('15128','2013-07-03','16:50:00',1.46),('15128','2013-07-03','16:55:00',1.9),('15128','2013-07-03','17:00:00',3.1),('15128','2013-07-03','17:05:00',2.25),('15128','2013-07-03','17:10:00',2.26),('15128','2013-07-03','17:15:00',2.99),('15128','2013-07-03','17:20:00',2.31),('15128','2013-07-03','17:25:00',3.35),('15128','2013-07-03','17:30:00',2.18),('15128','2013-07-03','17:35:00',2.65),('15128','2013-07-03','17:40:00',2.38),('15128','2013-07-03','17:45:00',2.73),('15128','2013-07-03','17:50:00',2.71),('15128','2013-07-03','17:55:00',2.66),('15128','2013-07-03','18:00:00',2.4),('15128','2013-07-03','18:05:00',2.08),('15128','2013-07-03','18:10:00',1.81),('15128','2013-07-03','18:15:00',1.77),('15128','2013-07-03','18:20:00',1.82),('15128','2013-07-03','18:25:00',1.25),('15128','2013-07-03','18:30:00',1),('15128','2013-07-02','08:05:00',1.03),('15128','2013-07-02','08:10:00',1.1),('15128','2013-07-02','08:15:00',1.15),('15128','2013-07-02','08:20:00',1.21),('15128','2013-07-02','08:25:00',1.29),('15128','2013-07-02','08:30:00',1.37),('15128','2013-07-02','08:35:00',1.41),('15128','2013-07-02','08:40:00',1.49),('15128','2013-07-02','08:45:00',1.57),('15128','2013-07-02','08:50:00',1.65),('15128','2013-07-02','08:55:00',1.74),('15128','2013-07-02','09:00:00',1.83),('15128','2013-07-02','09:05:00',1.9),('15128','2013-07-02','09:10:00',1.96),('15128','2013-07-02','09:15:00',2.05),('15128','2013-07-02','09:20:00',2.08),('15128','2013-07-02','09:25:00',2.06),('15128','2013-07-02','09:30:00',2.21),('15128','2013-07-02','09:35:00',2.28),('15128','2013-07-02','09:40:00',2.29),('15128','2013-07-02','09:45:00',2.33),('15128','2013-07-02','09:50:00',2.39),('15128','2013-07-02','09:55:00',2.51),('15128','2013-07-02','10:00:00',2.53),('15128','2013-07-02','10:05:00',2.62),('15128','2013-07-02','10:10:00',2.67),('15128','2013-07-02','10:15:00',2.56),('15128','2013-07-02','10:20:00',2.68),('15128','2013-07-02','10:25:00',2.77),('15128','2013-07-02','10:30:00',2.76),('15128','2013-07-02','10:35:00',2.77),('15128','2013-07-02','10:40:00',2.82),('15128','2013-07-02','10:45:00',3.02),('15128','2013-07-02','10:50:00',3.09),('15128','2013-07-02','10:55:00',3.17),('15128','2013-07-02','11:00:00',3.17),('15128','2013-07-02','11:05:00',3.23),('15128','2013-07-02','11:10:00',3.17),('15128','2013-07-02','11:15:00',3.42),('15128','2013-07-02','11:20:00',3.48),('15128','2013-07-02','11:25:00',3.54),('15128','2013-07-02','11:30:00',3.54),('15128','2013-07-02','11:35:00',3.66),('15128','2013-07-02','11:40:00',3.77),('15128','2013-07-02','11:45:00',3.85),('15128','2013-07-02','11:50:00',3.92),('15128','2013-07-02','11:55:00',4.03),('15128','2013-07-02','12:00:00',4.06),('15128','2013-07-02','12:05:00',4.08),('15128','2013-07-02','12:10:00',4.12),('15128','2013-07-02','12:15:00',4.17),('15128','2013-07-02','12:20:00',4.2),('15128','2013-07-02','12:25:00',4.2),('15128','2013-07-02','12:30:00',4.23),('15128','2013-07-02','12:35:00',4.25),('15128','2013-07-02','12:40:00',4.26),('15128','2013-07-02','12:45:00',4.29),('15128','2013-07-02','12:50:00',4.32),('15128','2013-07-02','12:55:00',4.33),('15128','2013-07-02','13:00:00',4.34),('15128','2013-07-02','13:05:00',4.35),('15128','2013-07-02','13:10:00',4.39),('15128','2013-07-02','13:15:00',4.39),('15128','2013-07-02','13:20:00',4.39),('15128','2013-07-02','13:25:00',4.4),('15128','2013-07-02','13:30:00',4.43),('15128','2013-07-02','13:35:00',4.44),('15128','2013-07-02','13:40:00',4.44),('15128','2013-07-02','13:45:00',4.45),('15128','2013-07-02','13:50:00',4.47),('15128','2013-07-02','13:55:00',4.47),('15128','2013-07-02','14:00:00',4.48),('15128','2013-07-02','14:05:00',4.47),('15128','2013-07-02','14:10:00',4.48),('15128','2013-07-02','14:15:00',4.49),('15128','2013-07-02','14:20:00',4.48),('15128','2013-07-02','14:25:00',4.48),('15128','2013-07-02','14:30:00',4.45),('15128','2013-07-02','14:35:00',4.42),('15128','2013-07-02','14:40:00',4.43),('15128','2013-07-02','14:45:00',4.46),('15128','2013-07-02','14:50:00',4.45),('15128','2013-07-02','14:55:00',4.41),('15128','2013-07-02','15:00:00',4.39),('15128','2013-07-02','15:05:00',4.36),('15128','2013-07-02','15:10:00',4.33),('15128','2013-07-02','15:15:00',4.31),('15128','2013-07-02','15:20:00',4.27),('15128','2013-07-02','15:25:00',4.26),('15128','2013-07-02','15:30:00',4.23),('15128','2013-07-02','15:35:00',4.19),('15128','2013-07-02','15:40:00',4.15),('15128','2013-07-02','15:45:00',4.11),('15128','2013-07-02','15:50:00',4.08),('15128','2013-07-02','15:55:00',4.03),('15128','2013-07-02','16:00:00',4),('15128','2013-07-02','16:05:00',3.97),('15128','2013-07-02','16:10:00',3.9),('15128','2013-07-02','16:15:00',3.85),('15128','2013-07-02','16:20:00',3.82),('15128','2013-07-02','16:25:00',3.79),('15128','2013-07-02','16:30:00',3.75),('15128','2013-07-02','16:35:00',3.7),('15128','2013-07-02','16:40:00',3.64),('15128','2013-07-02','16:45:00',3.59),('15128','2013-07-02','16:50:00',3.55),('15128','2013-07-02','16:55:00',3.48),('15128','2013-07-02','17:00:00',3.43),('15128','2013-07-02','17:05:00',3.39),('15128','2013-07-02','17:10:00',3.32),('15128','2013-07-02','17:15:00',3.26),('15128','2013-07-02','17:20:00',3.18),('15128','2013-07-02','17:25:00',3.11),('15128','2013-07-02','17:30:00',3.02),('15128','2013-07-02','17:35:00',2.97),('15128','2013-07-02','17:40:00',2.89),('15128','2013-07-02','17:45:00',2.81),('15128','2013-07-02','17:50:00',2.74),('15128','2013-07-02','17:55:00',2.69),('15128','2013-07-02','18:00:00',2.59),('15128','2013-07-02','18:05:00',2.49),('15128','2013-07-02','18:10:00',2.39),('15128','2013-07-02','18:15:00',2.28),('15128','2013-07-02','18:20:00',2.18),('15128','2013-07-02','18:25:00',2.08),('15128','2013-07-02','18:30:00',2.01),('15128','2013-07-02','18:35:00',1.91),('15128','2013-07-02','18:40:00',1.83),('15128','2013-07-02','18:45:00',1.75),('15128','2013-07-02','18:50:00',1.71),('15128','2013-07-02','18:55:00',1.65),('15128','2013-07-02','19:00:00',1.55),('15128','2013-07-02','19:05:00',1.45),('15128','2013-07-02','19:10:00',1.35),('15128','2013-07-02','19:15:00',1.27),('15128','2013-07-02','19:20:00',1.11),('15128','2013-07-01','08:05:00',1.03),('15128','2013-07-01','08:10:00',1.09),('15128','2013-07-01','08:15:00',1.13),('15128','2013-07-01','08:20:00',1.19),('15128','2013-07-01','08:25:00',1.28),('15128','2013-07-01','08:30:00',1.35),('15128','2013-07-01','08:35:00',1.4),('15128','2013-07-01','08:40:00',1.47),('15128','2013-07-01','08:45:00',1.53),('15128','2013-07-01','08:50:00',1.62),('15128','2013-07-01','08:55:00',1.72),('15128','2013-07-01','09:00:00',1.8),('15128','2013-07-01','09:05:00',1.88),('15128','2013-07-01','09:10:00',1.96),('15128','2013-07-01','09:15:00',2.03),('15128','2013-07-01','09:20:00',2.06),('15128','2013-07-01','09:25:00',2.05),('15128','2013-07-01','09:30:00',2.21),('15128','2013-07-01','09:35:00',2.29),('15128','2013-07-01','09:40:00',2.36),('15128','2013-07-01','09:45:00',2.41),('15128','2013-07-01','09:50:00',2.46),('15128','2013-07-01','09:55:00',2.5),('15128','2013-07-01','10:00:00',2.56),('15128','2013-07-01','10:05:00',2.61),('15128','2013-07-01','10:10:00',2.65),('15128','2013-07-01','10:15:00',2.68),('15128','2013-07-01','10:20:00',2.72),('15128','2013-07-01','10:25:00',2.75),('15128','2013-07-01','10:30:00',2.8),('15128','2013-07-01','10:35:00',2.88),('15128','2013-07-01','10:40:00',2.88),('15128','2013-07-01','10:45:00',2.97),('15128','2013-07-01','10:50:00',2.99),('15128','2013-07-01','10:55:00',3.07),('15128','2013-07-01','11:00:00',3.06),('15128','2013-07-01','11:05:00',3.14),('15128','2013-07-01','11:10:00',3.11),('15128','2013-07-01','11:15:00',3.26),('15128','2013-07-01','11:20:00',3.32),('15128','2013-07-01','11:25:00',3.39),('15128','2013-07-01','11:30:00',3.31),('15128','2013-07-01','11:35:00',3.32),('15128','2013-07-01','11:40:00',3.43),('15128','2013-07-01','11:45:00',3.62),('15128','2013-07-01','11:50:00',3.74),('15128','2013-07-01','11:55:00',3.78),('15128','2013-07-01','12:00:00',3.73),('15128','2013-07-01','12:05:00',3.62),('15128','2013-07-01','12:10:00',3.82),('15128','2013-07-01','12:15:00',4.07),('15128','2013-07-01','12:20:00',4.13),('15128','2013-07-01','12:25:00',3.88),('15128','2013-07-01','12:30:00',3.87),('15128','2013-07-01','12:35:00',4.17),('15128','2013-07-01','12:40:00',4.15),('15128','2013-07-01','12:45:00',4.15),('15128','2013-07-01','12:50:00',3.86),('15128','2013-07-01','12:55:00',3.99),('15128','2013-07-01','13:00:00',4.06),('15128','2013-07-01','13:05:00',4.19),('15128','2013-07-01','13:10:00',4.22),('15128','2013-07-01','13:15:00',4.2),('15128','2013-07-01','13:20:00',4.2),('15128','2013-07-01','13:25:00',4.17),('15128','2013-07-01','13:30:00',4.23),('15128','2013-07-01','13:35:00',4.24),('15128','2013-07-01','13:40:00',4.16),('15128','2013-07-01','13:45:00',4.22),('15128','2013-07-01','13:50:00',4.31),('15128','2013-07-01','13:55:00',4.31),('15128','2013-07-01','14:00:00',4.32),('15128','2013-07-01','14:05:00',4.33),('15128','2013-07-01','14:10:00',4.3),('15128','2013-07-01','14:15:00',4.27),('15128','2013-07-01','14:20:00',4.3),('15128','2013-07-01','14:25:00',4.3),('15128','2013-07-01','14:30:00',4.29),('15128','2013-07-01','14:35:00',4.29),('15128','2013-07-01','14:40:00',4.28),('15128','2013-07-01','14:45:00',4.28),('15128','2013-07-01','14:50:00',4.27),('15128','2013-07-01','14:55:00',4.26),('15128','2013-07-01','15:00:00',4.23),('15128','2013-07-01','15:05:00',4.2),('15128','2013-07-01','15:10:00',4.18),('15128','2013-07-01','15:15:00',4.19),('15128','2013-07-01','15:20:00',4.13),('15128','2013-07-01','15:25:00',4.15),('15128','2013-07-01','15:30:00',4.12),('15128','2013-07-01','15:35:00',4.09),('15128','2013-07-01','15:40:00',4.08),('15128','2013-07-01','15:45:00',4.05),('15128','2013-07-01','15:50:00',4),('15128','2013-07-01','15:55:00',3.96),('15128','2013-07-01','16:00:00',3.9),('15128','2013-07-01','16:05:00',3.86),('15128','2013-07-01','16:10:00',3.83),('15128','2013-07-01','16:15:00',3.76),('15128','2013-07-01','16:20:00',3.71),('15128','2013-07-01','16:25:00',3.67),('15128','2013-07-01','16:30:00',3.64),('15128','2013-07-01','16:35:00',3.58),('15128','2013-07-01','16:40:00',3.52),('15128','2013-07-01','16:45:00',3.45),('15128','2013-07-01','16:50:00',3.4),('15128','2013-07-01','16:55:00',3.34),('15128','2013-07-01','17:00:00',3.26),('15128','2013-07-01','17:05:00',3.22),('15128','2013-07-01','17:10:00',3.16),('15128','2013-07-01','17:15:00',3.09),('15128','2013-07-01','17:20:00',3.04),('15128','2013-07-01','17:25:00',2.98),('15128','2013-07-01','17:30:00',2.91),('15128','2013-07-01','17:35:00',2.84),('15128','2013-07-01','17:40:00',2.77),('15128','2013-07-01','17:45:00',2.7),('15128','2013-07-01','17:50:00',2.62),('15128','2013-07-01','17:55:00',2.55),('15128','2013-07-01','18:00:00',2.41),('15128','2013-07-01','18:05:00',2.32),('15128','2013-07-01','18:10:00',2.23),('15128','2013-07-01','18:15:00',2.12),('15128','2013-07-01','18:20:00',2),('15128','2013-07-01','18:25:00',1.91),('15128','2013-07-01','18:30:00',1.84),('15128','2013-07-01','18:35:00',1.74),('15128','2013-07-01','18:40:00',1.67),('15128','2013-07-01','18:45:00',1.59),('15128','2013-07-01','18:50:00',1.51),('15128','2013-07-01','18:55:00',1.46),('15128','2013-07-01','19:00:00',1.37),('15128','2013-07-01','19:05:00',1.28),('15128','2013-07-01','19:10:00',1.2),('15128','2013-07-01','19:15:00',1.1),('15128','2013-06-30','08:05:00',1.07),('15128','2013-06-30','08:10:00',1.13),('15128','2013-06-30','08:15:00',1.17),('15128','2013-06-30','08:20:00',1.25),('15128','2013-06-30','08:25:00',1.34),('15128','2013-06-30','08:30:00',1.41),('15128','2013-06-30','08:35:00',1.45),('15128','2013-06-30','08:40:00',1.52),('15128','2013-06-30','08:45:00',1.58),('15128','2013-06-30','08:50:00',1.65),('15128','2013-06-30','08:55:00',1.75),('15128','2013-06-30','09:00:00',1.86),('15128','2013-06-30','09:05:00',1.93),('15128','2013-06-30','09:10:00',2.01),('15128','2013-06-30','09:15:00',2.08),('15128','2013-06-30','09:20:00',2.1),('15128','2013-06-30','09:25:00',2.12),('15128','2013-06-30','09:30:00',2.29),('15128','2013-06-30','09:35:00',2.36),('15128','2013-06-30','09:40:00',2.42),('15128','2013-06-30','09:45:00',2.46),('15128','2013-06-30','09:50:00',2.52),('15128','2013-06-30','09:55:00',2.57),('15128','2013-06-30','10:00:00',2.61),('15128','2013-06-30','10:05:00',2.66),('15128','2013-06-30','10:10:00',2.7),('15128','2013-06-30','10:15:00',2.75),('15128','2013-06-30','10:20:00',2.78),('15128','2013-06-30','10:25:00',2.81),('15128','2013-06-30','10:30:00',2.85),('15128','2013-06-30','10:35:00',2.94),('15128','2013-06-30','10:40:00',2.95),('15128','2013-06-30','10:45:00',3.02),('15128','2013-06-30','10:50:00',3.07),('15128','2013-06-30','10:55:00',3.16),('15128','2013-06-30','11:00:00',3.16),('15128','2013-06-30','11:05:00',3.23),('15128','2013-06-30','11:10:00',3.21),('15128','2013-06-30','11:15:00',3.37),('15128','2013-06-30','11:20:00',3.44),('15128','2013-06-30','11:25:00',3.56),('15128','2013-06-30','11:30:00',3.49),('15128','2013-06-30','11:35:00',3.48),('15128','2013-06-30','11:40:00',3.62),('15128','2013-06-30','11:45:00',3.79),('15128','2013-06-30','11:50:00',3.84),('15128','2013-06-30','11:55:00',3.93),('15128','2013-06-30','12:00:00',3.94),('15128','2013-06-30','12:05:00',3.94),('15128','2013-06-30','12:10:00',3.97),('15128','2013-06-30','12:15:00',4.02),('15128','2013-06-30','12:20:00',4.07),('15128','2013-06-30','12:25:00',4.12),('15128','2013-06-30','12:30:00',4.14),('15128','2013-06-30','12:35:00',4.16),('15128','2013-06-30','12:40:00',4.13),('15128','2013-06-30','12:45:00',4.23),('15128','2013-06-30','12:50:00',4.25),('15128','2013-06-30','12:55:00',4.15),('15128','2013-06-30','13:00:00',4.22),('15128','2013-06-30','13:05:00',4.28),('15128','2013-06-30','13:10:00',4.39),('15128','2013-06-30','13:15:00',4.51),('15128','2013-06-30','13:20:00',4.44),('15128','2013-06-30','13:25:00',4.38),('15128','2013-06-30','13:30:00',4.35),('15128','2013-06-30','13:35:00',4.37),('15128','2013-06-30','13:40:00',4.32),('15128','2013-06-30','13:45:00',4.39),('15128','2013-06-30','13:50:00',4.43),('15128','2013-06-30','13:55:00',4.5),('15128','2013-06-30','14:00:00',4.46),('15128','2013-06-30','14:05:00',4.39),('15128','2013-06-30','14:10:00',4.36),('15128','2013-06-30','14:15:00',4.37),('15128','2013-06-30','14:20:00',4.35),('15128','2013-06-30','14:25:00',4.31),('15128','2013-06-30','14:30:00',4.32),('15128','2013-06-30','14:35:00',4.32),('15128','2013-06-30','14:40:00',4.33),('15128','2013-06-30','14:45:00',4.31),('15128','2013-06-30','14:50:00',4.32),('15128','2013-06-30','14:55:00',4.32),('15128','2013-06-30','15:00:00',4.29),('15128','2013-06-30','15:05:00',4.26),('15128','2013-06-30','15:10:00',4.25),('15128','2013-06-30','15:15:00',4.2),('15128','2013-06-30','15:20:00',4.16),('15128','2013-06-30','15:25:00',4.1),('15128','2013-06-30','15:30:00',4.07),('15128','2013-06-30','15:35:00',4.02),('15128','2013-06-30','15:40:00',4.01),('15128','2013-06-30','15:45:00',3.99),('15128','2013-06-30','15:50:00',3.96),('15128','2013-06-30','15:55:00',3.91),('15128','2013-06-30','16:00:00',3.87),('15128','2013-06-30','16:05:00',3.76),('15128','2013-06-30','16:10:00',3.72),('15128','2013-06-30','16:15:00',3.72),('15128','2013-06-30','16:20:00',3.67),('15128','2013-06-30','16:25:00',3.65),('15128','2013-06-30','16:30:00',3.61),('15128','2013-06-30','16:35:00',3.53),('15128','2013-06-30','16:40:00',3.48),('15128','2013-06-30','16:45:00',3.45),('15128','2013-06-30','16:50:00',3.37),('15128','2013-06-30','16:55:00',3.32),('15128','2013-06-30','17:00:00',3.26),('15128','2013-06-30','17:05:00',3.21),('15128','2013-06-30','17:10:00',3.14),('15128','2013-06-30','17:15:00',3.07),('15128','2013-06-30','17:20:00',2.99),('15128','2013-06-30','17:25:00',2.93),('15128','2013-06-30','17:30:00',2.86),('15128','2013-06-30','17:35:00',2.81),('15128','2013-06-30','17:40:00',2.72),('15128','2013-06-30','17:45:00',2.65),('15128','2013-06-30','17:50:00',2.57),('15128','2013-06-30','17:55:00',2.49),('15128','2013-06-30','18:00:00',2.43),('15128','2013-06-30','18:05:00',2.23),('15128','2013-06-30','18:10:00',2.07),('15128','2013-06-30','18:15:00',2.1),('15128','2013-06-30','18:20:00',2.06),('15128','2013-06-30','18:25:00',1.97),('15128','2013-06-30','18:30:00',1.79),('15128','2013-06-30','18:35:00',1.53),('15128','2013-06-30','18:40:00',1.64),('15128','2013-06-30','18:45:00',1.49),('15128','2013-06-30','18:50:00',1.37),('15128','2013-06-30','18:55:00',1.32),('15128','2013-06-30','19:00:00',1.33),('15128','2013-06-30','19:05:00',1.16),('15128','2013-06-30','19:10:00',1.09),('15128','2013-06-30','19:15:00',1.04),('15128','2014-04-04','08:35:00',1.1),('15128','2014-04-04','08:45:00',1.08),('15128','2014-04-04','09:20:00',1.06),('15128','2014-04-04','09:25:00',1.25),('15128','2014-04-04','09:30:00',1.56),('15128','2014-04-04','09:35:00',1.58),('15128','2014-04-04','09:40:00',1.55),('15128','2014-04-04','09:45:00',2.03),('15128','2014-04-04','09:50:00',2.17),('15128','2014-04-04','09:55:00',1.84),('15128','2014-04-04','10:00:00',2.07),('15128','2014-04-04','10:05:00',1.85),('15128','2014-04-04','10:10:00',1.84),('15128','2014-04-04','10:15:00',1.57),('15128','2014-04-04','10:20:00',1.33),('15128','2014-04-04','10:25:00',1.59),('15128','2014-04-04','10:30:00',2.81),('15128','2014-04-04','10:35:00',1.91),('15128','2014-04-04','10:40:00',2.43),('15128','2014-04-04','10:45:00',3.06),('15128','2014-04-04','10:50:00',2.62),('15128','2014-04-04','10:55:00',2.95),('15128','2014-04-04','11:00:00',2.52),('15128','2014-04-04','11:05:00',2.69),('15128','2014-04-04','11:10:00',2.63),('15128','2014-04-04','11:15:00',2.46),('15128','2014-04-04','11:20:00',2.2),('15128','2014-04-04','11:25:00',2.67),('15128','2014-04-04','11:30:00',3.11),('15128','2014-04-04','11:35:00',3.43),('15128','2014-04-04','11:40:00',3.51),('15128','2014-04-04','11:45:00',3.22),('15128','2014-04-04','11:50:00',3.33),('15128','2014-04-04','11:55:00',2.97),('15128','2014-04-04','12:00:00',2.69),('15128','2014-04-04','12:05:00',2.58),('15128','2014-04-04','12:10:00',2.49),('15128','2014-04-04','12:15:00',2.2),('15128','2014-04-04','12:20:00',2.05),('15128','2014-04-04','12:25:00',1.85),('15128','2014-04-04','12:30:00',1.64),('15128','2014-04-04','12:35:00',1.95),('15128','2014-04-04','12:40:00',2.91),('15128','2014-04-04','12:45:00',2.97),('15128','2014-04-04','12:50:00',3.6),('15128','2014-04-04','12:55:00',2.77),('15128','2014-04-04','13:00:00',2.21),('15128','2014-04-04','13:05:00',2.6),('15128','2014-04-04','13:10:00',3.56),('15128','2014-04-04','13:15:00',3.48),('15128','2014-04-04','13:20:00',4),('15128','2014-04-04','13:25:00',3.39),('15128','2014-04-04','13:30:00',3.19),('15128','2014-04-04','13:35:00',2.74),('15128','2014-04-04','13:40:00',1.8),('15128','2014-04-04','13:45:00',2.77),('15128','2014-04-04','13:50:00',3.97),('15128','2014-04-04','13:55:00',4.54),('15128','2014-04-04','14:00:00',2.43),('15128','2014-04-04','14:05:00',1.3),('15128','2014-04-04','14:10:00',4.4),('15128','2014-04-04','14:15:00',2.02),('15128','2014-04-04','14:55:00',4.35),('15128','2014-04-04','15:00:00',4.39),('15128','2014-04-04','15:05:00',1.8),('15128','2014-04-04','15:10:00',3.58),('15128','2014-04-04','15:15:00',2.96),('15128','2014-04-04','15:20:00',2.16),('15128','2014-04-04','15:25:00',1.95),('15128','2014-04-04','15:30:00',1.89),('15128','2014-04-04','15:35:00',2.83),('15128','2014-04-04','15:40:00',2.7),('15128','2014-04-04','15:45:00',1.84),('15128','2014-04-04','15:50:00',1.07),('15128','2014-04-04','15:55:00',1.08),('15128','2014-04-04','16:00:00',1.26),('15128','2014-04-04','16:05:00',1.4),('15128','2014-04-04','16:10:00',1.97),('15128','2014-04-04','16:15:00',1.27),('15128','2014-04-04','16:20:00',1.02),('15128','2014-04-04','16:25:00',1.86),('15128','2014-04-04','16:30:00',3.76),('15128','2014-04-04','16:35:00',3.23),('15128','2014-04-04','16:50:00',3.11),('15128','2014-04-04','16:55:00',3.1),('15128','2014-04-04','17:00:00',3.04),('15128','2014-04-04','17:05:00',2.24),('15128','2014-04-04','17:10:00',2.31),('15128','2014-04-04','17:15:00',2.26),('15128','2014-04-04','17:20:00',2.4),('15128','2014-04-04','17:25:00',2.02),('15128','2014-04-04','17:30:00',1.03),('15128','2014-04-04','18:00:00',1.29),('15128','2014-04-04','18:05:00',1.1),('15128','2014-04-04','18:15:00',1.09),('15128','2013-06-29','08:00:00',1.04),('15128','2013-06-29','08:05:00',1.12),('15128','2013-06-29','08:10:00',1.18),('15128','2013-06-29','08:15:00',1.23),('15128','2013-06-29','08:20:00',1.3),('15128','2013-06-29','08:25:00',1.39),('15128','2013-06-29','08:30:00',1.46),('15128','2013-06-29','08:35:00',1.52),('15128','2013-06-29','08:40:00',1.59),('15128','2013-06-29','08:45:00',1.65),('15128','2013-06-29','08:50:00',1.73),('15128','2013-06-29','08:55:00',1.83),('15128','2013-06-29','09:00:00',1.9),('15128','2013-06-29','09:05:00',1.98),('15128','2013-06-29','09:10:00',2.07),('15128','2013-06-29','09:15:00',2.13),('15128','2013-06-29','09:20:00',2.17),('15128','2013-06-29','09:25:00',2.24),('15128','2013-06-29','09:30:00',2.32),('15128','2013-06-29','09:35:00',2.39),('15128','2013-06-29','09:40:00',2.45),('15128','2013-06-29','09:45:00',2.5),('15128','2013-06-29','09:50:00',2.56),('15128','2013-06-29','09:55:00',2.62),('15128','2013-06-29','10:00:00',2.67),('15128','2013-06-29','10:05:00',2.73),('15128','2013-06-29','10:10:00',2.76),('15128','2013-06-29','10:15:00',2.78),('15128','2013-06-29','10:20:00',2.84),('15128','2013-06-29','10:25:00',2.89),('15128','2013-06-29','10:30:00',2.96),('15128','2013-06-29','10:35:00',3.04),('15128','2013-06-29','10:40:00',3.05),('15128','2013-06-29','10:45:00',3.13),('15128','2013-06-29','10:50:00',3.17),('15128','2013-06-29','10:55:00',3.24),('15128','2013-06-29','11:00:00',3.24),('15128','2013-06-29','11:05:00',3.29),('15128','2013-06-29','11:10:00',3.29),('15128','2013-06-29','11:15:00',3.47),('15128','2013-06-29','11:20:00',3.51),('15128','2013-06-29','11:25:00',3.57),('15128','2013-06-29','11:30:00',3.5),('15128','2013-06-29','11:35:00',3.49),('15128','2013-06-29','11:40:00',3.65),('15128','2013-06-29','11:45:00',3.86),('15128','2013-06-29','11:50:00',3.95),('15128','2013-06-29','11:55:00',4.02),('15128','2013-06-29','12:00:00',3.65),('15128','2013-06-29','12:05:00',4.1),('15128','2013-06-29','12:10:00',4.09),('15128','2013-06-29','12:15:00',4.13),('15128','2013-06-29','12:20:00',4.14),('15128','2013-06-29','12:25:00',4.22),('15128','2013-06-29','12:30:00',4.24),('15128','2013-06-29','12:35:00',4.29),('15128','2013-06-29','12:40:00',4.31),('15128','2013-06-29','12:45:00',4.37),('15128','2013-06-29','12:50:00',4.45),('15128','2013-06-29','12:55:00',4.55),('15128','2013-06-29','13:00:00',4.26),('15128','2013-06-29','13:05:00',3.33),('15128','2013-06-29','13:10:00',2.99),('15128','2013-06-29','13:15:00',2.25),('15128','2013-06-29','13:20:00',4.63),('15128','2013-06-29','13:25:00',2.53),('15128','2013-06-29','13:30:00',1.19),('15128','2013-06-29','13:35:00',3.75),('15128','2013-06-29','13:40:00',3.87),('15128','2013-06-29','13:45:00',3.91),('15128','2013-06-29','13:50:00',3.01),('15128','2013-06-29','13:55:00',4.18),('15128','2013-06-29','14:00:00',4.73),('15128','2013-06-29','14:05:00',4.73),('15128','2013-06-29','14:10:00',4.62),('15128','2013-06-29','14:15:00',4.5),('15128','2013-06-29','14:20:00',4.49),('15128','2013-06-29','14:25:00',4.49),('15128','2013-06-29','14:30:00',4.43),('15128','2013-06-29','14:35:00',4.43),('15128','2013-06-29','14:40:00',4.42),('15128','2013-06-29','14:45:00',4.4),('15128','2013-06-29','14:50:00',4.4),('15128','2013-06-29','14:55:00',4.35),('15128','2013-06-29','15:00:00',4.33),('15128','2013-06-29','15:05:00',4.31),('15128','2013-06-29','15:10:00',4.31),('15128','2013-06-29','15:15:00',4.3),('15128','2013-06-29','15:20:00',4.26),('15128','2013-06-29','15:25:00',4.28),('15128','2013-06-29','15:30:00',4.22),('15128','2013-06-29','15:35:00',3.41),('15128','2013-06-29','15:40:00',2.9),('15128','2013-06-29','15:45:00',3.96),('15128','2013-06-29','15:50:00',4.16),('15128','2013-06-29','15:55:00',4.16),('15128','2013-06-29','16:00:00',4.09),('15128','2013-06-29','16:05:00',4.08),('15128','2013-06-29','16:10:00',4.11),('15128','2013-06-29','16:15:00',3.69),('15128','2013-06-29','16:20:00',3.91),('15128','2013-06-29','16:25:00',3.81),('15128','2013-06-29','16:30:00',3.6),('15128','2013-06-29','16:35:00',3.49),('15128','2013-06-29','16:40:00',3.61),('15128','2013-06-29','16:45:00',3.54),('15128','2013-06-29','16:50:00',3.52),('15128','2013-06-29','16:55:00',3.39),('15128','2013-06-29','17:00:00',3.31),('15128','2013-06-29','17:05:00',3.22),('15128','2013-06-29','17:10:00',3.18),('15128','2013-06-29','17:15:00',3.04),('15128','2013-06-29','17:20:00',3.01),('15128','2013-06-29','17:25:00',2.94),('15128','2013-06-29','17:30:00',2.87),('15128','2013-06-29','17:35:00',2.82),('15128','2013-06-29','17:40:00',2.7),('15128','2013-06-29','17:45:00',2.75),('15128','2013-06-29','17:50:00',2.69),('15128','2013-06-29','17:55:00',2.5),('15128','2013-06-29','18:00:00',2.39),('15128','2013-06-29','18:05:00',2.29),('15128','2013-06-29','18:10:00',2.19),('15128','2013-06-29','18:15:00',2.1),('15128','2013-06-29','18:20:00',1.98),('15128','2013-06-29','18:25:00',1.87),('15128','2013-06-29','18:30:00',1.77),('15128','2013-06-29','18:35:00',1.73),('15128','2013-06-29','18:40:00',1.62),('15128','2013-06-29','18:45:00',1.56),('15128','2013-06-29','18:50:00',1.52),('15128','2013-06-29','18:55:00',1.46),('15128','2013-06-29','19:00:00',1.38),('15128','2013-06-29','19:05:00',1.31),('15128','2013-06-29','19:10:00',1.22),('15128','2013-06-29','19:15:00',1.11),('15128','2013-06-28','08:20:00',1.3),('15128','2013-06-28','08:25:00',1.36),('15128','2013-06-28','08:30:00',1.42),('15128','2013-06-28','08:35:00',1.46),('15128','2013-06-28','08:40:00',1.53),('15128','2013-06-28','08:45:00',1.62),('15128','2013-06-28','08:50:00',1.67),('15128','2013-06-28','08:55:00',1.81),('15128','2013-06-28','09:00:00',1.88),('15128','2013-06-28','09:05:00',1.96),('15128','2013-06-28','09:10:00',2.03),('15128','2013-06-28','09:15:00',2.09),('15128','2013-06-28','09:20:00',2.15),('15128','2013-06-28','09:25:00',2.23),('15128','2013-06-28','09:30:00',2.3),('15128','2013-06-28','09:35:00',2.37),('15128','2013-06-28','09:40:00',2.43),('15128','2013-06-28','09:45:00',2.51),('15128','2013-06-28','09:50:00',2.56),('15128','2013-06-28','09:55:00',2.6),('15128','2013-06-28','10:00:00',2.66),('15128','2013-06-28','10:05:00',2.71),('15128','2013-06-28','10:10:00',2.78),('15128','2013-06-28','10:15:00',2.79),('15128','2013-06-28','10:20:00',2.86),('15128','2013-06-28','10:25:00',2.93),('15128','2013-06-28','10:30:00',3),('15128','2013-06-28','10:35:00',3.06),('15128','2013-06-28','10:40:00',3.11),('15128','2013-06-28','10:45:00',3.18),('15128','2013-06-28','10:50:00',3.22),('15128','2013-06-28','10:55:00',3.36),('15128','2013-06-28','11:00:00',3.49),('15128','2013-06-28','11:05:00',3.55),('15128','2013-06-28','11:10:00',3.52),('15128','2013-06-28','11:15:00',3.81),('15128','2013-06-28','11:20:00',2.53),('15128','2013-06-28','11:25:00',1.58),('15128','2013-06-28','11:30:00',4.02),('15128','2013-06-28','11:35:00',3.96),('15128','2013-06-28','11:40:00',4.05),('15128','2013-06-28','11:45:00',4.13),('15128','2013-06-28','11:50:00',2.14),('15128','2013-06-28','11:55:00',4.23),('15128','2013-06-28','12:00:00',4.22),('15128','2013-06-28','12:05:00',4.23),('15128','2013-06-28','12:10:00',4.33),('15128','2013-06-28','12:15:00',4.42),('15128','2013-06-28','12:20:00',4.49),('15128','2013-06-28','12:25:00',3.38),('15128','2013-06-28','12:30:00',1.57),('15128','2013-06-28','12:35:00',3.24),('15128','2013-06-28','12:40:00',3.91),('15128','2013-06-28','12:45:00',2.78),('15128','2013-06-28','12:50:00',4.14),('15128','2013-06-28','12:55:00',1.55),('15128','2013-06-28','13:00:00',2.28),('15128','2013-06-28','13:05:00',3.92),('15128','2013-06-28','13:10:00',1.44),('15128','2013-06-28','13:15:00',1.64),('15128','2013-06-28','13:20:00',3.55),('15128','2013-06-28','13:25:00',2.84),('15128','2013-06-28','13:30:00',2.25),('15128','2013-06-28','13:35:00',4.97),('15128','2013-06-28','13:40:00',3.47),('15128','2013-06-28','13:45:00',4.93),('15128','2013-06-28','13:50:00',4.83),('15128','2013-06-28','13:55:00',4.8),('15128','2013-06-28','14:00:00',4.72),('15128','2013-06-28','14:05:00',4.72),('15128','2013-06-28','14:10:00',4.84),('15128','2013-06-28','14:15:00',3.05),('15128','2013-06-28','14:20:00',3.93),('15128','2013-06-28','14:25:00',4.81),('15128','2013-06-28','14:30:00',4.82),('15128','2013-06-28','14:35:00',4.83),('15128','2013-06-28','14:40:00',4.82),('15128','2013-06-28','14:45:00',4.72),('15128','2013-06-28','14:50:00',4.79),('15128','2013-06-28','14:55:00',4.89),('15128','2013-06-28','15:00:00',5.02),('15128','2013-06-28','15:05:00',4.86),('15128','2013-06-28','15:10:00',3.64),('15128','2013-06-28','15:15:00',2.86),('15128','2013-06-28','15:20:00',2.09),('15128','2013-06-28','15:25:00',1.54),('15128','2013-06-28','15:30:00',1.39),('15128','2013-06-28','15:35:00',1.01),('15128','2013-06-28','16:15:00',1.01),('15128','2013-06-28','16:20:00',1.33),('15128','2013-06-28','16:25:00',2.39),('15128','2013-06-28','16:30:00',3.53),('15128','2013-06-28','16:35:00',4.91),('15128','2013-06-28','16:40:00',4.81),('15128','2013-06-28','16:45:00',3.19),('15128','2013-06-28','16:50:00',2.21),('15128','2013-06-28','16:55:00',1.84),('15128','2013-06-28','17:00:00',2.65),('15128','2013-06-28','17:05:00',2.12),('15128','2013-06-28','17:10:00',1.8),('15128','2013-06-28','17:15:00',1.66),('15128','2013-06-28','17:20:00',1.78),('15128','2013-06-28','17:25:00',3.21),('15128','2013-06-28','17:30:00',3.19),('15128','2013-06-28','17:35:00',3.15),('15128','2013-06-28','17:40:00',2.92),('15128','2013-06-28','17:45:00',2.71),('15128','2013-06-28','18:05:00',1.06),('15128','2013-06-28','18:10:00',1.12),('15128','2013-06-28','18:15:00',2.16),('15128','2013-06-28','18:20:00',1.24),('15128','2013-06-28','18:25:00',1.49),('15128','2013-06-28','18:35:00',1.43),('15128','2013-06-28','18:40:00',1.18),('15128','2013-06-28','18:50:00',1.55),('15128','2013-06-28','18:55:00',1.66),('15128','2013-06-28','19:00:00',1.41),('15128','2013-06-28','19:05:00',1.35),('15128','2013-06-28','19:10:00',1.09),('15128','2013-06-27','07:55:00',1),('15128','2013-06-27','08:05:00',1.04),('15128','2013-06-27','08:10:00',1),('15128','2013-06-27','08:15:00',1.1),('15128','2013-06-27','08:20:00',1.2),('15128','2013-06-27','08:25:00',1.38),('15128','2013-06-27','08:30:00',1.45),('15128','2013-06-27','08:35:00',1.48),('15128','2013-06-27','08:40:00',1.55),('15128','2013-06-27','08:45:00',1.6),('15128','2013-06-27','08:50:00',1.69),('15128','2013-06-27','08:55:00',1.83),('15128','2013-06-27','09:00:00',1.38),('15128','2013-06-27','09:05:00',2.09),('15128','2013-06-27','09:10:00',2.22),('15128','2013-06-27','09:15:00',2.21),('15128','2013-06-27','09:20:00',2.25),('15128','2013-06-27','09:25:00',1.4),('15128','2013-06-27','09:35:00',2.67),('15128','2013-06-27','09:40:00',2.65),('15128','2013-06-27','09:45:00',2.93),('15128','2013-06-27','09:50:00',2.47),('15128','2013-06-27','09:55:00',1.15),('15128','2013-06-27','10:10:00',1.59),('15128','2013-06-27','10:15:00',2.15),('15128','2013-06-27','10:20:00',1.66),('15128','2013-06-27','10:30:00',2.63),('15128','2013-06-27','10:35:00',3.72),('15128','2013-06-27','10:40:00',3.71),('15128','2013-06-27','10:45:00',2.54),('15128','2013-06-27','10:50:00',2.54),('15128','2013-06-27','10:55:00',3.2),('15128','2013-06-27','11:00:00',3.26),('15128','2013-06-27','11:05:00',3.9),('15128','2013-06-27','11:10:00',3.87),('15128','2013-06-27','11:15:00',3.64),('15128','2013-06-27','11:20:00',3.69),('15128','2013-06-27','11:25:00',3.4),('15128','2013-06-27','11:30:00',3.96),('15128','2013-06-27','11:35:00',3.66),('15128','2013-06-27','11:40:00',4.44),('15128','2013-06-27','11:45:00',4.13),('15128','2013-06-27','11:50:00',3.44),('15128','2013-06-27','11:55:00',3.6),('15128','2013-06-27','12:00:00',1.44),('15128','2013-06-27','12:05:00',3.9),('15128','2013-06-27','12:10:00',3.92),('15128','2013-06-27','12:15:00',4.38),('15128','2013-06-27','12:20:00',4.08),('15128','2013-06-27','12:25:00',4.25),('15128','2013-06-27','12:30:00',4.12),('15128','2013-06-27','12:35:00',4.41),('15128','2013-06-27','12:40:00',3.08),('15128','2013-06-27','12:45:00',3.21),('15128','2013-06-27','12:50:00',2.86),('15128','2013-06-27','12:55:00',4.75),('15128','2013-06-27','13:00:00',4.73),('15128','2013-06-27','13:05:00',4.69),('15128','2013-06-27','13:10:00',4.74),('15128','2013-06-27','13:15:00',4.61),('15128','2013-06-27','13:20:00',4.47),('15128','2013-06-27','13:25:00',4.73),('15128','2013-06-27','13:30:00',4.77),('15128','2013-06-27','13:35:00',3.96),('15128','2013-06-27','13:40:00',3.41),('15128','2013-06-27','13:45:00',3.82),('15128','2013-06-27','13:50:00',4.52),('15128','2013-06-27','13:55:00',3.61),('15128','2013-06-27','14:00:00',4.35),('15128','2013-06-27','14:05:00',4.91),('15128','2013-06-27','14:10:00',4.63),('15128','2013-06-27','14:15:00',3.1),('15128','2013-06-27','14:20:00',4.93),('15128','2013-06-27','14:25:00',4.89),('15128','2013-06-27','14:30:00',4.35),('15128','2013-06-27','14:35:00',3.14),('15128','2013-06-27','14:40:00',4.85),('15128','2013-06-27','14:45:00',4.65),('15128','2013-06-27','14:50:00',4.76),('15128','2013-06-27','14:55:00',4.33),('15128','2013-06-27','15:00:00',4.83),('15128','2013-06-27','15:05:00',3.47),('15128','2013-06-27','15:10:00',4.05),('15128','2013-06-27','15:15:00',2.95),('15128','2013-06-27','15:20:00',2.66),('15128','2013-06-27','15:25:00',2.55),('15128','2013-06-27','15:30:00',2.91),('15128','2013-06-27','15:35:00',4.4),('15128','2013-06-27','15:40:00',3.53),('15128','2013-06-27','15:45:00',4.72),('15128','2013-06-27','15:50:00',3.52),('15128','2013-06-27','15:55:00',4.06),('15128','2013-06-27','16:00:00',1.17),('15128','2013-06-27','16:05:00',2.24),('15128','2013-06-27','16:10:00',2.24),('15128','2013-06-27','16:15:00',2.36),('15128','2013-06-27','16:20:00',2.57),('15128','2013-06-27','16:25:00',2.63),('15128','2013-06-27','16:30:00',3.36),('15128','2013-06-27','16:35:00',3.87),('15128','2013-06-27','16:40:00',2.43),('15128','2013-06-27','16:45:00',2.12),('15128','2013-06-27','16:50:00',1.69),('15128','2013-06-27','16:55:00',1.31),('15128','2013-06-27','17:00:00',2.49),('15128','2013-06-27','17:05:00',3.42),('15128','2013-06-27','17:10:00',2.87),('15128','2013-06-27','17:15:00',2.96),('15128','2013-06-27','17:20:00',3.13),('15128','2013-06-27','17:25:00',3.11),('15128','2013-06-27','17:30:00',3),('15128','2013-06-27','17:35:00',2.92),('15128','2013-06-27','17:40:00',2.86),('15128','2013-06-27','17:45:00',2.78),('15128','2013-06-27','17:50:00',2.7),('15128','2013-06-27','17:55:00',2.64),('15128','2013-06-27','18:00:00',2.52),('15128','2013-06-27','18:05:00',2.44),('15128','2013-06-27','18:10:00',2.33),('15128','2013-06-27','18:15:00',2.22),('15128','2013-06-27','18:20:00',2.03),('15128','2013-06-27','18:25:00',1.99),('15128','2013-06-27','18:30:00',1.68),('15128','2013-06-27','18:35:00',1.84),('15128','2013-06-27','18:40:00',1.74),('15128','2013-06-27','18:45:00',1.68),('15128','2013-06-27','18:50:00',1.6),('15128','2013-06-27','18:55:00',1.52),('15128','2013-06-27','19:00:00',1.41),('15128','2013-06-27','19:05:00',1.24),('15128','2013-06-27','19:20:00',1.01),('15128','2013-06-26','08:10:00',1.14),('15128','2013-06-26','08:15:00',1.23),('15128','2013-06-26','08:20:00',1.31),('15128','2013-06-26','08:25:00',1.4),('15128','2013-06-26','08:30:00',1.44),('15128','2013-06-26','08:35:00',1.49),('15128','2013-06-26','08:40:00',1.57),('15128','2013-06-26','08:45:00',1.63),('15128','2013-06-26','08:50:00',1.72),('15128','2013-06-26','08:55:00',1.87),('15128','2013-06-26','09:00:00',1.94),('15128','2013-06-26','09:05:00',2.01),('15128','2013-06-26','09:10:00',2.11),('15128','2013-06-26','09:15:00',2.16),('15128','2013-06-26','09:20:00',2.17),('15128','2013-06-26','09:25:00',2.3),('15128','2013-06-26','09:30:00',2.39),('15128','2013-06-26','09:35:00',2.44),('15128','2013-06-26','09:40:00',2.51),('15128','2013-06-26','09:45:00',2.61),('15128','2013-06-26','09:50:00',2.64),('15128','2013-06-26','09:55:00',2.69),('15128','2013-06-26','10:00:00',2.72),('15128','2013-06-26','10:05:00',2.73),('15128','2013-06-26','10:10:00',2.81),('15128','2013-06-26','10:15:00',2.82),('15128','2013-06-26','10:20:00',2.91),('15128','2013-06-26','10:25:00',2.99),('15128','2013-06-26','10:30:00',3.11),('15128','2013-06-26','10:35:00',3.2),('15128','2013-06-26','10:40:00',2.17),('15128','2013-06-26','10:45:00',3.06),('15128','2013-06-26','10:50:00',3.47),('15128','2013-06-26','10:55:00',3.49),('15128','2013-06-26','11:00:00',3.43),('15128','2013-06-26','11:05:00',3.75),('15128','2013-06-26','11:10:00',3.23),('15128','2013-06-26','11:15:00',2.8),('15128','2013-06-26','11:20:00',3.98),('15128','2013-06-26','11:25:00',4),('15128','2013-06-26','11:30:00',3.96),('15128','2013-06-26','11:35:00',3.96),('15128','2013-06-26','11:40:00',4.1),('15128','2013-06-26','11:45:00',3.7),('15128','2013-06-26','11:50:00',3.77),('15128','2013-06-26','11:55:00',2.61),('15128','2013-06-26','12:00:00',1.28),('15128','2013-06-26','12:05:00',1.1),('15128','2013-06-26','12:10:00',1.07),('15128','2013-06-26','12:15:00',1.12),('15128','2013-06-26','12:20:00',1.03),('15128','2013-06-26','12:25:00',1.04),('15128','2013-06-26','12:30:00',1.19),('15128','2013-06-26','12:35:00',1.3),('15128','2013-06-26','12:40:00',1.41),('15128','2013-06-26','12:45:00',2.17),('15128','2013-06-26','12:50:00',2.78),('15128','2013-06-26','12:55:00',2.27),('15128','2013-06-26','13:00:00',2.82),('15128','2013-06-26','13:05:00',3.44),('15128','2013-06-26','13:10:00',4.89),('15128','2013-06-26','13:15:00',4.82),('15128','2013-06-26','13:20:00',2.23),('15128','2013-06-26','13:25:00',3.44),('15128','2013-06-26','13:30:00',2.03),('15128','2013-06-26','13:35:00',1.76),('15128','2013-06-26','13:40:00',2.04),('15128','2013-06-26','13:45:00',4.55),('15128','2013-06-26','13:50:00',4.24),('15128','2013-06-26','13:55:00',4.77),('15128','2013-06-26','14:00:00',4.53),('15128','2013-06-26','14:05:00',4.49),('15128','2013-06-26','14:10:00',4.46),('15128','2013-06-26','14:15:00',4.44),('15128','2013-06-26','14:20:00',4.48),('15128','2013-06-26','14:25:00',4.54),('15128','2013-06-26','14:30:00',4.77),('15128','2013-06-26','14:35:00',4.63),('15128','2013-06-26','14:40:00',4.46),('15128','2013-06-26','14:45:00',4.34),('15128','2013-06-26','14:50:00',4.33),('15128','2013-06-26','14:55:00',4.28),('15128','2013-06-26','15:00:00',4.28),('15128','2013-06-26','15:05:00',4.3),('15128','2013-06-26','15:10:00',4.27),('15128','2013-06-26','15:15:00',4.27),('15128','2013-06-26','15:20:00',4.28),('15128','2013-06-26','15:25:00',4.27),('15128','2013-06-26','15:30:00',4.22),('15128','2013-06-26','15:35:00',4.17),('15128','2013-06-26','15:40:00',4.08),('15128','2013-06-26','15:45:00',4.06),('15128','2013-06-26','15:50:00',3.98),('15128','2013-06-26','15:55:00',3.91),('15128','2013-06-26','16:00:00',3.89),('15128','2013-06-26','16:05:00',3.85),('15128','2013-06-26','16:10:00',3.87),('15128','2013-06-26','16:15:00',3.83),('15128','2013-06-26','16:20:00',3.79),('15128','2013-06-26','16:25:00',3.73),('15128','2013-06-26','16:30:00',3.66),('15128','2013-06-26','16:35:00',3.54),('15128','2013-06-26','16:40:00',3.51),('15128','2013-06-26','16:45:00',3.44),('15128','2013-06-26','16:50:00',3.38),('15128','2013-06-26','16:55:00',3.36),('15128','2013-06-26','17:00:00',3.24),('15128','2013-06-26','17:05:00',3.17),('15128','2013-06-26','17:10:00',3),('15128','2013-06-26','17:15:00',3.1),('15128','2013-06-26','17:20:00',3.06),('15128','2013-06-26','17:25:00',3.09),('15128','2013-06-26','17:30:00',3.07),('15128','2013-06-26','17:35:00',2.81),('15128','2013-06-26','17:40:00',2.65),('15128','2013-06-26','17:45:00',2.75),('15128','2013-06-26','17:50:00',2.68),('15128','2013-06-26','17:55:00',2.62),('15128','2013-06-26','18:00:00',2.48),('15128','2013-06-26','18:05:00',2.39),('15128','2013-06-26','18:10:00',2.27),('15128','2013-06-26','18:15:00',2.03),('15128','2013-06-26','18:20:00',1.91),('15128','2013-06-26','18:25:00',1.73),('15128','2013-06-26','18:30:00',1.67),('15128','2013-06-26','18:35:00',1.59),('15128','2013-06-26','18:40:00',1.55),('15128','2013-06-26','18:45:00',1.5),('15128','2013-06-26','18:50:00',1.5),('15128','2013-06-26','18:55:00',1.44),('15128','2013-06-26','19:00:00',1.33),('15128','2013-06-26','19:05:00',1.22),('15128','2013-06-26','19:10:00',1.12),('15128','2013-06-26','19:15:00',1),('15128','2013-06-25','08:00:00',1.05),('15128','2013-06-25','08:05:00',1.11),('15128','2013-06-25','08:10:00',1.16),('15128','2013-06-25','08:15:00',1.23),('15128','2013-06-25','08:20:00',1.31),('15128','2013-06-25','08:25:00',1.4),('15128','2013-06-25','08:30:00',1.46),('15128','2013-06-25','08:35:00',1.53),('15128','2013-06-25','08:40:00',1.61),('15128','2013-06-25','08:45:00',1.67),('15128','2013-06-25','08:50:00',1.76),('15128','2013-06-25','08:55:00',1.89),('15128','2013-06-25','09:00:00',1.97),('15128','2013-06-25','09:05:00',2.03),('15128','2013-06-25','09:10:00',2.1),('15128','2013-06-25','09:15:00',2.16),('15128','2013-06-25','09:20:00',2.19),('15128','2013-06-25','09:25:00',2.3),('15128','2013-06-25','09:30:00',2.36),('15128','2013-06-25','09:35:00',2.41),('15128','2013-06-25','09:40:00',2.48),('15128','2013-06-25','09:45:00',2.54),('15128','2013-06-25','09:50:00',2.59),('15128','2013-06-25','09:55:00',2.64),('15128','2013-06-25','10:00:00',2.68),('15128','2013-06-25','10:05:00',2.74),('15128','2013-06-25','10:10:00',2.82),('15128','2013-06-25','10:15:00',2.82),('15128','2013-06-25','10:20:00',2.87),('15128','2013-06-25','10:25:00',2.96),('15128','2013-06-25','10:30:00',2.99),('15128','2013-06-25','10:35:00',3.04),('15128','2013-06-25','10:40:00',3.07),('15128','2013-06-25','10:45:00',3.14),('15128','2013-06-25','10:50:00',3.21),('15128','2013-06-25','10:55:00',3.25),('15128','2013-06-25','11:00:00',3.3),('15128','2013-06-25','11:05:00',3.34),('15128','2013-06-25','11:10:00',3.35),('15128','2013-06-25','11:15:00',3.48),('15128','2013-06-25','11:20:00',3.53),('15128','2013-06-25','11:25:00',3.62),('15128','2013-06-25','11:30:00',3.52),('15128','2013-06-25','11:35:00',3.57),('15128','2013-06-25','11:40:00',3.78),('15128','2013-06-25','11:45:00',3.83),('15128','2013-06-25','11:50:00',3.93),('15128','2013-06-25','11:55:00',3.98),('15128','2013-06-25','12:00:00',4.01),('15128','2013-06-25','12:05:00',4.04),('15128','2013-06-25','12:10:00',4.11),('15128','2013-06-25','12:15:00',4.16),('15128','2013-06-25','12:20:00',4.21),('15128','2013-06-25','12:25:00',4.26),('15128','2013-06-25','12:30:00',4.3),('15128','2013-06-25','12:35:00',3.69),('15128','2013-06-25','12:40:00',3.26),('15128','2013-06-25','12:45:00',1.12),('15128','2013-06-25','12:50:00',2.03),('15128','2013-06-25','12:55:00',5.06),('15128','2013-06-25','13:00:00',3.76),('15128','2013-06-25','13:05:00',3.03),('15128','2013-06-25','13:10:00',4.89),('15128','2013-06-25','13:15:00',4.8),('15128','2013-06-25','13:20:00',4.76),('15128','2013-06-25','13:25:00',4.76),('15128','2013-06-25','13:30:00',2.21),('15128','2013-06-25','13:35:00',1.71),('15128','2013-06-25','13:40:00',1.07),('15128','2013-06-25','13:45:00',2.81),('15128','2013-06-25','13:50:00',4.77),('15128','2013-06-25','13:55:00',4.64),('15128','2013-06-25','14:00:00',4.49),('15128','2013-06-25','14:05:00',4.48),('15128','2013-06-25','14:10:00',4.47),('15128','2013-06-25','14:15:00',4.45),('15128','2013-06-25','14:20:00',4.43),('15128','2013-06-25','14:25:00',4.44),('15128','2013-06-25','14:30:00',4.43),('15128','2013-06-25','14:35:00',4.42),('15128','2013-06-25','14:40:00',4.46),('15128','2013-06-25','14:45:00',4.46),('15128','2013-06-25','14:50:00',4.42),('15128','2013-06-25','14:55:00',4.39),('15128','2013-06-25','15:00:00',4.37),('15128','2013-06-25','15:05:00',4.34),('15128','2013-06-25','15:10:00',4.32),('15128','2013-06-25','15:15:00',4.28),('15128','2013-06-25','15:20:00',4.25),('15128','2013-06-25','15:25:00',4.24),('15128','2013-06-25','15:30:00',4.21),('15128','2013-06-25','15:35:00',4.17),('15128','2013-06-25','15:40:00',4.16),('15128','2013-06-25','15:45:00',4.1),('15128','2013-06-25','15:50:00',4.08),('15128','2013-06-25','15:55:00',4.03),('15128','2013-06-25','16:00:00',3.99),('15128','2013-06-25','16:05:00',3.94),('15128','2013-06-25','16:10:00',3.91),('15128','2013-06-25','16:15:00',3.87),('15128','2013-06-25','16:20:00',3.85),('15128','2013-06-25','16:25:00',3.78),('15128','2013-06-25','16:30:00',3.7),('15128','2013-06-25','16:35:00',3.67),('15128','2013-06-25','16:40:00',3.6),('15128','2013-06-25','16:45:00',3.54),('15128','2013-06-25','16:50:00',3.49),('15128','2013-06-25','16:55:00',3.43),('15128','2013-06-25','17:00:00',3.36),('15128','2013-06-25','17:05:00',3.3),('15128','2013-06-25','17:10:00',3.23),('15128','2013-06-25','17:15:00',3.16),('15128','2013-06-25','17:20:00',3.08),('15128','2013-06-25','17:25:00',3.04),('15128','2013-06-25','17:30:00',3),('15128','2013-06-25','17:35:00',2.9),('15128','2013-06-25','17:40:00',2.83),('15128','2013-06-25','17:45:00',2.75),('15128','2013-06-25','17:50:00',2.63),('15128','2013-06-25','17:55:00',2.53),('15128','2013-06-25','18:00:00',2.35),('15128','2013-06-25','18:05:00',2.31),('15128','2013-06-25','18:10:00',2.21),('15128','2013-06-25','18:15:00',1.76),('15128','2013-06-25','18:20:00',1.24),('15128','2013-06-25','18:25:00',1.3),('15128','2013-06-25','18:30:00',1.21),('15128','2013-06-25','18:35:00',1.57),('15128','2013-06-25','19:05:00',1.1),('15128','2013-06-25','19:10:00',1.13),('15128','2013-06-25','19:15:00',1),('15128','2013-06-24','08:05:00',1.09),('15128','2013-06-24','08:10:00',1.19),('15128','2013-06-24','08:15:00',1.25),('15128','2013-06-24','08:20:00',1.34),('15128','2013-06-24','08:25:00',1.43),('15128','2013-06-24','08:30:00',1.51),('15128','2013-06-24','08:35:00',1.55),('15128','2013-06-24','08:40:00',1.59),('15128','2013-06-24','08:45:00',1.68),('15128','2013-06-24','08:50:00',1.74),('15128','2013-06-24','08:55:00',1.07),('15128','2013-06-24','09:00:00',1.19),('15128','2013-06-24','09:05:00',2.1),('15128','2013-06-24','09:10:00',2.11),('15128','2013-06-24','09:15:00',2.15),('15128','2013-06-24','09:20:00',2.2),('15128','2013-06-24','09:25:00',2.35),('15128','2013-06-24','09:30:00',2.4),('15128','2013-06-24','09:35:00',2.53),('15128','2013-06-24','09:40:00',2.63),('15128','2013-06-24','09:45:00',2.65),('15128','2013-06-24','09:50:00',2.74),('15128','2013-06-24','09:55:00',2.86),('15128','2013-06-24','10:00:00',2.96),('15128','2013-06-24','10:05:00',2.48),('15128','2013-06-24','10:10:00',1.29),('15128','2013-06-24','10:30:00',1.65),('15128','2013-06-24','10:35:00',3.44),('15128','2013-06-24','10:40:00',3.32),('15128','2013-06-24','10:45:00',3.37),('15128','2013-06-24','10:50:00',3.43),('15128','2013-06-24','10:55:00',3.42),('15128','2013-06-24','11:00:00',3.48),('15128','2013-06-24','11:05:00',3.54),('15128','2013-06-24','11:10:00',3.64),('15128','2013-06-24','11:15:00',3.82),('15128','2013-06-24','11:20:00',3.93),('15128','2013-06-24','11:25:00',3.63),('15128','2013-06-24','11:30:00',2.18),('15128','2013-06-24','11:35:00',1.61),('15128','2013-06-24','11:40:00',1.51),('15128','2013-06-24','11:45:00',2.2),('15128','2013-06-24','11:50:00',1.37),('15128','2013-06-24','11:55:00',1.32),('15128','2013-06-24','12:00:00',1.42),('15128','2013-06-24','12:05:00',1.4),('15128','2013-06-24','12:10:00',3.99),('15128','2013-06-24','12:15:00',5.05),('15128','2013-06-24','12:20:00',4.77),('15128','2013-06-24','12:25:00',4.54),('15128','2013-06-24','12:30:00',4.43),('15128','2013-06-24','12:35:00',4.47),('15128','2013-06-24','12:40:00',4.65),('15128','2013-06-24','12:45:00',4.69),('15128','2013-06-24','12:50:00',4.8),('15128','2013-06-24','12:55:00',2.79),('15128','2013-06-24','13:00:00',4.67),('15128','2013-06-24','13:05:00',4.65),('15128','2013-06-24','13:10:00',4.53),('15128','2013-06-24','13:15:00',4.54),('15128','2013-06-24','13:20:00',4.55),('15128','2013-06-24','13:25:00',4.53),('15128','2013-06-24','13:30:00',4.52),('15128','2013-06-24','13:35:00',4.53),('15128','2013-06-24','13:40:00',4.55),('15128','2013-06-24','13:45:00',4.54),('15128','2013-06-24','13:50:00',4.56),('15128','2013-06-24','13:55:00',4.53),('15128','2013-06-24','14:00:00',4.49),('15128','2013-06-24','14:05:00',4.49),('15128','2013-06-24','14:10:00',4.5),('15128','2013-06-24','14:15:00',4.53),('15128','2013-06-24','14:20:00',4.54),('15128','2013-06-24','14:25:00',4.52),('15128','2013-06-24','14:30:00',4.48),('15128','2013-06-24','14:35:00',4.45),('15128','2013-06-24','14:40:00',4.46),('15128','2013-06-24','14:45:00',4.48),('15128','2013-06-24','14:50:00',4.41),('15128','2013-06-24','14:55:00',4.39),('15128','2013-06-24','15:00:00',4.37),('15128','2013-06-24','15:05:00',4.38),('15128','2013-06-24','15:10:00',4.36),('15128','2013-06-24','15:15:00',4.31),('15128','2013-06-24','15:20:00',4.3),('15128','2013-06-24','15:25:00',4.26),('15128','2013-06-24','15:30:00',4.23),('15128','2013-06-24','15:35:00',4.16),('15128','2013-06-24','15:40:00',4.14),('15128','2013-06-24','15:45:00',4.11),('15128','2013-06-24','15:50:00',4.04),('15128','2013-06-24','15:55:00',4.01),('15128','2013-06-24','16:00:00',3.97),('15128','2013-06-24','16:05:00',3.94),('15128','2013-06-24','16:10:00',3.89),('15128','2013-06-24','16:15:00',3.85),('15128','2013-06-24','16:20:00',3.82),('15128','2013-06-24','16:25:00',3.76),('15128','2013-06-24','16:30:00',3.72),('15128','2013-06-24','16:35:00',3.66),('15128','2013-06-24','16:40:00',3.6),('15128','2013-06-24','16:45:00',3.53),('15128','2013-06-24','16:50:00',3.48),('15128','2013-06-24','16:55:00',3.42),('15128','2013-06-24','17:00:00',3.36),('15128','2013-06-24','17:05:00',3.29),('15128','2013-06-24','17:10:00',3.22),('15128','2013-06-24','17:15:00',3.16),('15128','2013-06-24','17:20:00',3.1),('15128','2013-06-24','17:25:00',3.02),('15128','2013-06-24','17:30:00',2.93),('15128','2013-06-24','17:35:00',2.86),('15128','2013-06-24','17:40:00',2.81),('15128','2013-06-24','17:45:00',2.73),('15128','2013-06-24','17:50:00',2.64),('15128','2013-06-24','17:55:00',2.55),('15128','2013-06-24','18:00:00',2.39),('15128','2013-06-24','18:05:00',2.34),('15128','2013-06-24','18:10:00',2.2),('15128','2013-06-24','18:15:00',2.12),('15128','2013-06-24','18:20:00',2.03),('15128','2013-06-24','18:25:00',1.95),('15128','2013-06-24','18:30:00',1.86),('15128','2013-06-24','18:35:00',1.75),('15128','2013-06-24','18:40:00',1.67),('15128','2013-06-24','18:45:00',1.6),('15128','2013-06-24','18:50:00',1.56),('15128','2013-06-24','18:55:00',1.5),('15128','2013-06-24','19:00:00',1.39),('15128','2013-06-24','19:05:00',1.31),('15128','2013-06-24','19:10:00',1.22),('15128','2013-06-24','19:15:00',1.12),('15128','2013-06-23','08:40:00',1.46),('15128','2013-06-23','08:45:00',1.97),('15128','2013-06-23','09:00:00',2.03),('15128','2013-06-23','09:05:00',2.36),('15128','2013-06-23','09:10:00',2.48),('15128','2013-06-23','09:15:00',2.28),('15128','2013-06-23','09:20:00',1.64),('15128','2013-06-23','09:25:00',1.61),('15128','2013-06-23','09:35:00',2.04),('15128','2013-06-23','09:40:00',2.86),('15128','2013-06-23','09:45:00',2.85),('15128','2013-06-23','09:50:00',2.15),('15128','2013-06-23','09:55:00',2.05),('15128','2013-06-23','10:00:00',2.95),('15128','2013-06-23','10:05:00',3.41),('15128','2013-06-23','10:10:00',2.38),('15128','2013-06-23','10:15:00',3.2),('15128','2013-06-23','10:20:00',3),('15128','2013-06-23','10:25:00',3.76),('15128','2013-06-23','10:30:00',2.77),('15128','2013-06-23','10:35:00',3.54),('15128','2013-06-23','10:40:00',2.85),('15128','2013-06-23','10:45:00',3.16),('15128','2013-06-23','10:50:00',3.81),('15128','2013-06-23','10:55:00',1.79),('15128','2013-06-23','11:00:00',1.58),('15128','2013-06-23','11:05:00',1.91),('15128','2013-06-23','11:10:00',3.46),('15128','2013-06-23','11:15:00',3.27),('15128','2013-06-23','11:20:00',1.12),('15128','2013-06-23','11:25:00',2.5),('15128','2013-06-23','11:30:00',1.38),('15128','2013-06-23','11:35:00',1.61),('15128','2013-06-23','11:40:00',3.82),('15128','2013-06-23','11:45:00',1.52),('15128','2013-06-23','11:50:00',2.28),('15128','2013-06-23','11:55:00',2.23),('15128','2013-06-23','12:00:00',3.76),('15128','2013-06-23','12:05:00',2.73),('15128','2013-06-23','12:10:00',5.21),('15128','2013-06-23','12:15:00',4.23),('15128','2013-06-23','12:20:00',2.83),('15128','2013-06-23','12:25:00',3.29),('15128','2013-06-23','12:30:00',3.67),('15128','2013-06-23','12:35:00',3.31),('15128','2013-06-23','12:40:00',3.9),('15128','2013-06-23','12:45:00',4.16),('15128','2013-06-23','12:50:00',4.32),('15128','2013-06-23','12:55:00',3.97),('15128','2013-06-23','13:00:00',4.96),('15128','2013-06-23','13:05:00',3.8),('15128','2013-06-23','13:10:00',3.12),('15128','2013-06-23','13:15:00',5.26),('15128','2013-06-23','13:20:00',4.24),('15128','2013-06-23','13:25:00',4.32),('15128','2013-06-23','13:30:00',2.58),('15128','2013-06-23','13:35:00',5.05),('15128','2013-06-23','13:40:00',4.92),('15128','2013-06-23','13:45:00',4.94),('15128','2013-06-23','13:50:00',4.79),('15128','2013-06-23','13:55:00',4.91),('15128','2013-06-23','14:00:00',4.58),('15128','2013-06-23','14:05:00',4.8),('15128','2013-06-23','14:10:00',4.62),('15128','2013-06-23','14:15:00',3.68),('15128','2013-06-23','14:20:00',4.85),('15128','2013-06-23','14:25:00',4.98),('15128','2013-06-23','14:30:00',5.1),('15128','2013-06-23','14:35:00',3.74),('15128','2013-06-23','14:40:00',3.66),('15128','2013-06-23','14:45:00',2.61),('15128','2013-06-23','14:50:00',4.77),('15128','2013-06-23','14:55:00',2.07),('15128','2013-06-23','15:00:00',2.35),('15128','2013-06-23','15:05:00',2.36),('15128','2013-06-23','15:10:00',4.01),('15128','2013-06-23','15:15:00',4.17),('15128','2013-06-23','15:20:00',3.92),('15128','2013-06-23','15:25:00',3.56),('15128','2013-06-23','15:30:00',3.91),('15128','2013-06-23','15:35:00',4.66),('15128','2013-06-23','15:40:00',4.2),('15128','2013-06-23','15:45:00',3.17),('15128','2013-06-23','15:50:00',4.27),('15128','2013-06-23','15:55:00',3.12),('15128','2013-06-23','16:00:00',3.74),('15128','2013-06-23','16:05:00',2.88),('15128','2013-06-23','16:10:00',2.97),('15128','2013-06-23','16:15:00',4.42),('15128','2013-06-23','16:20:00',1.91),('15128','2013-06-23','16:25:00',3.85),('15128','2013-06-23','16:30:00',1.68),('15128','2013-06-23','16:35:00',3.04),('15128','2013-06-23','16:40:00',2.49),('15128','2013-06-23','16:45:00',2.53),('15128','2013-06-23','16:50:00',1.74),('15128','2013-06-23','16:55:00',1.41),('15128','2013-06-23','17:00:00',2.26),('15128','2013-06-23','17:05:00',2.14),('15128','2013-06-23','17:10:00',3.35),('15128','2013-06-23','17:15:00',3.47),('15128','2013-06-23','17:20:00',2.76),('15128','2013-06-23','17:25:00',1.37),('15128','2013-06-23','17:30:00',2.07),('15128','2013-06-23','17:35:00',1.71),('15128','2013-06-23','17:45:00',2.06),('15128','2013-06-23','17:50:00',2.79),('15128','2013-06-23','17:55:00',2.59),('15128','2013-06-23','18:00:00',1.82),('15128','2013-06-23','18:05:00',2.51),('15128','2013-06-23','18:10:00',2.41),('15128','2013-06-23','18:15:00',1.16),('15128','2013-06-23','18:20:00',1.64),('15128','2013-06-23','18:40:00',1.8),('15128','2013-06-23','18:45:00',1.66),('15128','2013-06-23','18:50:00',1.65),('15128','2013-06-23','18:55:00',1.54),('15128','2013-06-23','19:00:00',1.49),('15128','2013-06-23','19:05:00',1.38),('15128','2013-06-23','19:10:00',1.27),('15128','2013-06-23','19:15:00',1.17),('15128','2013-06-22','08:50:00',1.19),('15128','2013-06-22','08:55:00',1.04),('15128','2013-06-22','09:10:00',1.57),('15128','2013-06-22','09:15:00',2.08),('15128','2013-06-22','09:20:00',2.32),('15128','2013-06-22','09:25:00',2.36),('15128','2013-06-22','09:30:00',2.38),('15128','2013-06-22','09:35:00',2.57),('15128','2013-06-22','09:40:00',1.59),('15128','2013-06-22','09:45:00',2.28),('15128','2013-06-22','09:50:00',2.61),('15128','2013-06-22','09:55:00',2.7),('15128','2013-06-22','10:00:00',2.74),('15128','2013-06-22','10:05:00',2.82),('15128','2013-06-22','10:10:00',2.58),('15128','2013-06-22','10:15:00',2.31),('15128','2013-06-22','10:20:00',2.55),('15128','2013-06-22','10:25:00',2.58),('15128','2013-06-22','10:30:00',3.12),('15128','2013-06-22','10:35:00',2.92),('15128','2013-06-22','10:40:00',2.98),('15128','2013-06-22','10:45:00',3.16),('15128','2013-06-22','10:50:00',3.19),('15128','2013-06-22','10:55:00',3.22),('15128','2013-06-22','11:00:00',3.34),('15128','2013-06-22','11:05:00',3.27),('15128','2013-06-22','11:10:00',3.37),('15128','2013-06-22','11:15:00',3.41),('15128','2013-06-22','11:20:00',3.44),('15128','2013-06-22','11:25:00',3.52),('15128','2013-06-22','11:30:00',3.5),('15128','2013-06-22','11:35:00',3.54),('15128','2013-06-22','11:40:00',3.64),('15128','2013-06-22','11:45:00',3.76),('15128','2013-06-22','11:50:00',3.83),('15128','2013-06-22','11:55:00',4.01),('15128','2013-06-22','12:00:00',4.02),('15128','2013-06-22','12:05:00',4.06),('15128','2013-06-22','12:10:00',4.13),('15128','2013-06-22','12:15:00',4.19),('15128','2013-06-22','12:20:00',4.25),('15128','2013-06-22','12:25:00',4.26),('15128','2013-06-22','12:30:00',4.29),('15128','2013-06-22','12:35:00',4.33),('15128','2013-06-22','12:40:00',4.35),('15128','2013-06-22','12:45:00',4.38),('15128','2013-06-22','12:50:00',4.39),('15128','2013-06-22','12:55:00',4.44),('15128','2013-06-22','13:00:00',4.44),('15128','2013-06-22','13:05:00',4.45),('15128','2013-06-22','13:10:00',4.46),('15128','2013-06-22','13:15:00',4.47),('15128','2013-06-22','13:20:00',4.53),('15128','2013-06-22','13:25:00',4.54),('15128','2013-06-22','13:30:00',4.56),('15128','2013-06-22','13:35:00',4.58),('15128','2013-06-22','13:40:00',4.58),('15128','2013-06-22','13:45:00',4.59),('15128','2013-06-22','13:50:00',4.61),('15128','2013-06-22','13:55:00',4.59),('15128','2013-06-22','14:00:00',4.59),('15128','2013-06-22','14:05:00',4.6),('15128','2013-06-22','14:10:00',4.61),('15128','2013-06-22','14:15:00',4.64),('15128','2013-06-22','14:20:00',4.62),('15128','2013-06-22','14:25:00',4.61),('15128','2013-06-22','14:30:00',4.62),('15128','2013-06-22','14:35:00',4.59),('15128','2013-06-22','14:40:00',4.55),('15128','2013-06-22','14:45:00',4.55),('15128','2013-06-22','14:50:00',4.51),('15128','2013-06-22','14:55:00',4.5),('15128','2013-06-22','15:00:00',2.92),('15128','2013-06-22','15:10:00',3.69),('15128','2013-06-22','15:15:00',4.38),('15128','2013-06-22','15:20:00',1.31),('15128','2013-06-22','15:30:00',4.19),('15128','2013-06-22','15:35:00',4.25),('15128','2013-06-22','15:45:00',1.36),('15128','2013-06-22','15:50:00',4.12),('15128','2013-06-22','15:55:00',3.52),('15128','2013-06-22','16:05:00',2.81),('15128','2013-06-22','16:10:00',3.95),('15128','2013-06-22','16:15:00',3.94),('15128','2013-06-22','16:20:00',3.89),('15128','2013-06-22','16:25:00',2.48),('15128','2013-06-22','16:30:00',3.8),('15128','2013-06-22','16:35:00',3.75),('15128','2013-06-22','16:40:00',3.71),('15128','2013-06-22','16:45:00',2.48),('15128','2013-06-22','16:50:00',3.56),('15128','2013-06-22','16:55:00',3.53),('15128','2013-06-22','17:00:00',3.51),('15128','2013-06-22','17:05:00',2.68),('15128','2013-06-22','17:10:00',2.69),('15128','2013-06-22','17:15:00',3.3),('15128','2013-06-22','17:20:00',3.01),('15128','2013-06-22','17:25:00',2.77),('15128','2013-06-22','17:30:00',2.64),('15128','2013-06-22','17:35:00',3.03),('15128','2013-06-22','17:40:00',2.96),('15128','2013-06-22','17:45:00',2.21),('15128','2013-06-22','17:50:00',1.58),('15128','2013-06-22','17:55:00',2.25),('15128','2013-06-22','18:00:00',2.7),('15128','2013-06-22','18:05:00',2.49),('15128','2013-06-22','18:10:00',2.39),('15128','2013-06-22','18:15:00',2.29),('15128','2013-06-22','18:20:00',2.15),('15128','2013-06-22','18:25:00',2.05),('15128','2013-06-22','18:30:00',1.94),('15128','2013-06-22','18:35:00',1.87),('15128','2013-06-22','18:40:00',1.81),('15128','2013-06-22','18:45:00',1.69),('15128','2013-06-22','18:50:00',1.6),('15128','2013-06-22','18:55:00',1.19),('15128','2013-06-22','19:10:00',1.08),('15128','2013-06-22','19:15:00',1.34),('15128','2013-06-22','19:20:00',1.1),('15128','2013-06-21','08:00:00',1.02),('15128','2013-06-21','08:05:00',1.07),('15128','2013-06-21','08:10:00',1.11),('15128','2013-06-21','08:15:00',1.16),('15128','2013-06-21','08:20:00',1.25),('15128','2013-06-21','08:25:00',1.34),('15128','2013-06-21','08:30:00',1.4),('15128','2013-06-21','08:35:00',1.48),('15128','2013-06-21','08:40:00',1.56),('15128','2013-06-21','08:45:00',1.6),('15128','2013-06-21','08:50:00',1.7),('15128','2013-06-21','08:55:00',1.8),('15128','2013-06-21','09:00:00',1.86),('15128','2013-06-21','09:05:00',1.96),('15128','2013-06-21','09:10:00',2.03),('15128','2013-06-21','09:15:00',2.09),('15128','2013-06-21','09:20:00',2.1),('15128','2013-06-21','09:25:00',2.15),('15128','2013-06-21','09:30:00',2.28),('15128','2013-06-21','09:35:00',2.34),('15128','2013-06-21','09:40:00',2.42),('15128','2013-06-21','09:45:00',2.49),('15128','2013-06-21','09:50:00',2.54),('15128','2013-06-21','09:55:00',2.6),('15128','2013-06-21','10:00:00',2.67),('15128','2013-06-21','10:05:00',2.74),('15128','2013-06-21','10:10:00',2.79),('15128','2013-06-21','10:15:00',2.84),('15128','2013-06-21','10:20:00',2.88),('15128','2013-06-21','10:25:00',2.94),('15128','2013-06-21','10:30:00',2.99),('15128','2013-06-21','10:35:00',3.04),('15128','2013-06-21','10:40:00',3.1),('15128','2013-06-21','10:45:00',3.13),('15128','2013-06-21','10:50:00',3.22),('15128','2013-06-21','10:55:00',3.22),('15128','2013-06-21','11:00:00',3.3),('15128','2013-06-21','11:05:00',3.33),('15128','2013-06-21','11:10:00',3.36),('15128','2013-06-21','11:15:00',3.45),('15128','2013-06-21','11:20:00',3.52),('15128','2013-06-21','11:25:00',3.57),('15128','2013-06-21','11:30:00',3.51),('15128','2013-06-21','11:35:00',3.61),('15128','2013-06-21','11:40:00',3.79),('15128','2013-06-21','11:45:00',3.85),('15128','2013-06-21','11:50:00',3.94),('15128','2013-06-21','11:55:00',3.95),('15128','2013-06-21','12:00:00',4.05),('15128','2013-06-21','12:05:00',4.06),('15128','2013-06-21','12:10:00',4.12),('15128','2013-06-21','12:15:00',4.1),('15128','2013-06-21','12:20:00',4.14),('15128','2013-06-21','12:25:00',4.15),('15128','2013-06-21','12:30:00',4.1),('15128','2013-06-21','12:35:00',4.14),('15128','2013-06-21','12:40:00',4.17),('15128','2013-06-21','12:45:00',4.17),('15128','2013-06-21','12:50:00',4.17),('15128','2013-06-21','12:55:00',4.17),('15128','2013-06-21','13:00:00',4.14),('15128','2013-06-21','13:05:00',4.12),('15128','2013-06-21','13:10:00',4.21),('15128','2013-06-21','13:15:00',4.52),('15128','2013-06-21','13:20:00',4.32),('15128','2013-06-21','13:25:00',4.56),('15128','2013-06-21','13:30:00',4.54),('15128','2013-06-21','13:35:00',4.46),('15128','2013-06-21','13:40:00',4.23),('15128','2013-06-21','13:45:00',4.13),('15128','2013-06-21','13:50:00',3.54),('15128','2013-06-21','13:55:00',4.16),('15128','2013-06-21','14:00:00',4.9),('15128','2013-06-21','14:05:00',4.84),('15128','2013-06-21','14:10:00',4.71),('15128','2013-06-21','14:15:00',3.42),('15128','2013-06-21','14:20:00',2.29),('15128','2013-06-21','14:25:00',4.17),('15128','2013-06-21','14:30:00',2.51),('15128','2013-06-21','14:35:00',2.24),('15128','2013-06-21','14:40:00',3.39),('15128','2013-06-21','14:45:00',3.79),('15128','2013-06-21','14:50:00',4.86),('15128','2013-06-21','14:55:00',4.39),('15128','2013-06-21','15:00:00',4.66),('15128','2013-06-21','15:05:00',4.3),('15128','2013-06-21','15:10:00',4.39),('15128','2013-06-21','15:15:00',4.26),('15128','2013-06-21','15:20:00',4.46),('15128','2013-06-21','15:25:00',4.09),('15128','2013-06-21','15:30:00',3.82),('15128','2013-06-21','15:35:00',2.8),('15128','2013-06-21','15:40:00',2.05),('15128','2013-06-21','15:45:00',1.5),('15128','2013-06-21','15:50:00',1.67),('15128','2013-06-21','15:55:00',1.93),('15128','2013-06-21','16:00:00',1.57),('15128','2013-06-21','16:05:00',1.49),('15128','2013-06-21','16:10:00',1.7),('15128','2013-06-21','16:15:00',1.77),('15128','2013-06-21','16:20:00',1.58),('15128','2013-06-21','16:25:00',1.58),('15128','2013-06-21','16:30:00',1.42),('15128','2013-06-21','16:35:00',1.37),('15128','2013-06-21','16:40:00',1.24),('15128','2013-06-21','16:45:00',1.21),('15128','2013-06-21','16:50:00',1.41),('15128','2013-06-21','16:55:00',2.35),('15128','2013-06-21','17:00:00',3.36),('15128','2013-06-21','17:05:00',3.48),('15128','2013-06-21','17:10:00',3.7),('15128','2013-06-21','17:15:00',2.43),('15128','2013-06-21','17:20:00',3.03),('15128','2013-06-21','17:25:00',3.23),('15128','2013-06-21','17:30:00',2.91),('15128','2013-06-21','17:35:00',2.73),('15128','2013-06-21','17:40:00',2.69),('15128','2013-06-21','17:45:00',2.62),('15128','2013-06-21','17:50:00',2.48),('15128','2013-06-21','17:55:00',2.17),('15128','2013-06-21','18:00:00',2.03),('15128','2013-06-21','18:05:00',1.65),('15128','2013-06-21','18:10:00',1.28),('15128','2013-06-21','18:15:00',1.03),('15128','2013-06-21','18:20:00',1.01),('15128','2013-06-21','19:10:00',1.14),('15128','2013-06-21','19:15:00',1.23),('15128','2013-06-21','19:20:00',1.12),('15128','2013-06-20','08:00:00',1.01),('15128','2013-06-20','08:05:00',1.06),('15128','2013-06-20','08:10:00',1.11),('15128','2013-06-20','08:15:00',1.15),('15128','2013-06-20','08:20:00',1.24),('15128','2013-06-20','08:25:00',1.32),('15128','2013-06-20','08:30:00',1.38),('15128','2013-06-20','08:35:00',1.42),('15128','2013-06-20','08:40:00',1.5),('15128','2013-06-20','08:45:00',1.57),('15128','2013-06-20','08:50:00',1.65),('15128','2013-06-20','08:55:00',1.76),('15128','2013-06-20','09:00:00',1.83),('15128','2013-06-20','09:05:00',1.9),('15128','2013-06-20','09:10:00',1.98),('15128','2013-06-20','09:15:00',2.02),('15128','2013-06-20','09:20:00',2.02),('15128','2013-06-20','09:25:00',2.09),('15128','2013-06-20','09:30:00',2.19),('15128','2013-06-20','09:35:00',2.27),('15128','2013-06-20','09:40:00',2.32),('15128','2013-06-20','09:45:00',2.35),('15128','2013-06-20','09:50:00',2.41),('15128','2013-06-20','09:55:00',2.46),('15128','2013-06-20','10:00:00',2.55),('15128','2013-06-20','10:05:00',2.57),('15128','2013-06-20','10:10:00',2.65),('15128','2013-06-20','10:15:00',2.67),('15128','2013-06-20','10:20:00',2.69),('15128','2013-06-20','10:25:00',2.76),('15128','2013-06-20','10:30:00',2.74),('15128','2013-06-20','10:35:00',2.77),('15128','2013-06-20','10:40:00',2.96),('15128','2013-06-20','10:45:00',2.97),('15128','2013-06-20','10:50:00',3.05),('15128','2013-06-20','10:55:00',3.11),('15128','2013-06-20','11:00:00',3.13),('15128','2013-06-20','11:05:00',3.1),('15128','2013-06-20','11:10:00',3.22),('15128','2013-06-20','11:15:00',3.33),('15128','2013-06-20','11:20:00',3.39),('15128','2013-06-20','11:25:00',3.43),('15128','2013-06-20','11:30:00',3.4),('15128','2013-06-20','11:35:00',3.48),('15128','2013-06-20','11:40:00',3.62),('15128','2013-06-20','11:45:00',3.75),('15128','2013-06-20','11:50:00',3.78),('15128','2013-06-20','11:55:00',3.79),('15128','2013-06-20','12:00:00',3.81),('15128','2013-06-20','12:05:00',3.88),('15128','2013-06-20','12:10:00',3.9),('15128','2013-06-20','12:15:00',3.93),('15128','2013-06-20','12:20:00',3.96),('15128','2013-06-20','12:25:00',3.97),('15128','2013-06-20','12:30:00',4.02),('15128','2013-06-20','12:35:00',4.06),('15128','2013-06-20','12:40:00',4.13),('15128','2013-06-20','12:45:00',4.13),('15128','2013-06-20','12:50:00',4.16),('15128','2013-06-20','12:55:00',4.13),('15128','2013-06-20','13:00:00',4.14),('15128','2013-06-20','13:05:00',4.18),('15128','2013-06-20','13:10:00',4.23),('15128','2013-06-20','13:15:00',4.23),('15128','2013-06-20','13:20:00',4.27),('15128','2013-06-20','13:25:00',4.3),('15128','2013-06-20','13:30:00',4.31),('15128','2013-06-20','13:35:00',4.34),('15128','2013-06-20','13:40:00',4.37),('15128','2013-06-20','13:45:00',4.35),('15128','2013-06-20','13:50:00',4.36),('15128','2013-06-20','13:55:00',4.38),('15128','2013-06-20','14:00:00',4.4),('15128','2013-06-20','14:05:00',4.39),('15128','2013-06-20','14:10:00',4.37),('15128','2013-06-20','14:15:00',4.39),('15128','2013-06-20','14:20:00',4.37),('15128','2013-06-20','14:25:00',4.38),('15128','2013-06-20','14:30:00',4.38),('15128','2013-06-20','14:35:00',4.38),('15128','2013-06-20','14:40:00',4.37),('15128','2013-06-20','14:45:00',4.35),('15128','2013-06-20','14:50:00',4.33),('15128','2013-06-20','14:55:00',4.29),('15128','2013-06-20','15:00:00',4.27),('15128','2013-06-20','15:05:00',4.28),('15128','2013-06-20','15:10:00',4.25),('15128','2013-06-20','15:15:00',4.23),('15128','2013-06-20','15:20:00',4.21),('15128','2013-06-20','15:25:00',4.18),('15128','2013-06-20','15:30:00',4.15),('15128','2013-06-20','15:35:00',4.1),('15128','2013-06-20','15:40:00',4.07),('15128','2013-06-20','15:45:00',4.05),('15128','2013-06-20','15:50:00',4),('15128','2013-06-20','15:55:00',3.98),('15128','2013-06-20','16:00:00',3.92),('15128','2013-06-20','16:05:00',3.88),('15128','2013-06-20','16:10:00',3.83),('15128','2013-06-20','16:15:00',3.77),('15128','2013-06-20','16:20:00',3.72),('15128','2013-06-20','16:25:00',3.67),('15128','2013-06-20','16:30:00',3.64),('15128','2013-06-20','16:35:00',3.59),('15128','2013-06-20','16:40:00',3.54),('15128','2013-06-20','16:45:00',3.49),('15128','2013-06-20','16:50:00',3.43),('15128','2013-06-20','16:55:00',3.38),('15128','2013-06-20','17:00:00',3.32),('15128','2013-06-20','17:05:00',3.26),('15128','2013-06-20','17:10:00',3.2),('15128','2013-06-20','17:15:00',3.12),('15128','2013-06-20','17:20:00',3.06),('15128','2013-06-20','17:25:00',3),('15128','2013-06-20','17:30:00',2.93),('15128','2013-06-20','17:35:00',2.84),('15128','2013-06-20','17:40:00',2.76),('15128','2013-06-20','17:45:00',2.69),('15128','2013-06-20','17:50:00',2.61),('15128','2013-06-20','17:55:00',2.51),('15128','2013-06-20','18:00:00',2.42),('15128','2013-06-20','18:05:00',2.3),('15128','2013-06-20','18:10:00',2.17),('15128','2013-06-20','18:15:00',2.1),('15128','2013-06-20','18:20:00',2.01),('15128','2013-06-20','18:25:00',1.91),('15128','2013-06-20','18:30:00',1.81),('15128','2013-06-20','18:35:00',1.7),('15128','2013-06-20','18:40:00',1.62),('15128','2013-06-20','18:45:00',1.58),('15128','2013-06-20','18:50:00',1.53),('15128','2013-06-20','18:55:00',1.46),('15128','2013-06-20','19:00:00',1.36),('15128','2013-06-20','19:05:00',1.24),('15128','2013-06-20','19:10:00',1.15),('15128','2013-06-20','19:15:00',1.06),('15128','2014-04-03','11:05:00',1.23),('15128','2014-04-03','11:10:00',1.13),('15128','2014-04-03','12:35:00',1.1),('15128','2014-04-03','12:55:00',1.14),('15128','2014-04-03','13:00:00',1.42),('15128','2014-04-03','13:05:00',2.79),('15128','2014-04-03','13:10:00',1.73),('15128','2014-04-03','13:15:00',2.12),('15128','2014-04-03','13:20:00',2.92),('15128','2014-04-03','13:25:00',2.01),('15128','2014-04-03','13:30:00',2.5),('15128','2014-04-03','13:35:00',3.88),('15128','2014-04-03','13:40:00',2.14),('15128','2014-04-03','13:45:00',1.76),('15128','2014-04-03','13:50:00',2.39),('15128','2014-04-03','13:55:00',2.51),('15128','2014-04-03','14:00:00',4),('15128','2014-04-03','14:05:00',2.08),('15128','2014-04-03','14:10:00',2.51),('15128','2014-04-03','14:15:00',2.15),('15128','2014-04-03','14:20:00',2.41),('15128','2014-04-03','14:25:00',1.47),('15128','2014-04-03','14:30:00',1.39),('15128','2014-04-03','14:35:00',1.45),('15128','2014-04-03','14:40:00',2.2),('15128','2014-04-03','14:45:00',2.47),('15128','2014-04-03','14:50:00',1.97),('15128','2014-04-03','14:55:00',4.02),('15128','2014-04-03','15:00:00',2.35),('15128','2014-04-03','15:05:00',1.85),('15128','2014-04-03','15:10:00',2.33),('15128','2014-04-03','15:15:00',1.58),('15128','2014-04-03','15:20:00',3.44),('15128','2014-04-03','15:25:00',2),('15128','2014-04-03','15:30:00',1.78),('15128','2014-04-03','15:35:00',1.18),('15128','2014-04-03','15:40:00',1.19),('15128','2014-04-03','15:45:00',1.61),('15128','2014-04-03','15:50:00',2.35),('15128','2014-04-03','15:55:00',4.13),('15128','2014-04-03','16:00:00',3.92),('15128','2014-04-03','16:05:00',3),('15128','2014-04-03','16:10:00',1.55),('15128','2014-04-03','16:15:00',3.09),('15128','2014-04-03','16:20:00',1.32),('15128','2014-04-03','16:25:00',1.19),('15128','2014-04-03','16:30:00',1.63),('15128','2014-04-03','16:35:00',1.62),('15128','2014-04-03','16:40:00',1.58),('15128','2014-04-03','16:45:00',2.28),('15128','2014-04-03','16:50:00',1.33),('15128','2014-04-03','16:55:00',2.46),('15128','2014-04-03','17:00:00',1.48),('15128','2014-04-03','17:05:00',1.35),('15128','2014-04-03','17:15:00',2.1),('15128','2014-04-03','17:20:00',2.58),('15128','2014-04-03','17:25:00',2.25),('15128','2014-04-03','17:30:00',1.91),('15128','2014-04-03','17:35:00',2.16),('15128','2014-04-03','17:40:00',1.34),('15128','2014-04-03','17:45:00',1.07),('15128','2014-04-03','17:55:00',1.23),('15128','2013-06-19','08:00:00',1.01),('15128','2013-06-19','08:05:00',1.06),('15128','2013-06-19','08:10:00',1.1),('15128','2013-06-19','08:15:00',1.16),('15128','2013-06-19','08:20:00',1.25),('15128','2013-06-19','08:25:00',1.32),('15128','2013-06-19','08:30:00',1.39),('15128','2013-06-19','08:35:00',1.45),('15128','2013-06-19','08:40:00',1.53),('15128','2013-06-19','08:45:00',1.59),('15128','2013-06-19','08:50:00',1.67),('15128','2013-06-19','08:55:00',1.78),('15128','2013-06-19','09:00:00',1.87),('15128','2013-06-19','09:05:00',1.94),('15128','2013-06-19','09:10:00',2.02),('15128','2013-06-19','09:15:00',2.05),('15128','2013-06-19','09:20:00',2.09),('15128','2013-06-19','09:25:00',2.2),('15128','2013-06-19','09:30:00',2.26),('15128','2013-06-19','09:35:00',2.34),('15128','2013-06-19','09:40:00',2.4),('15128','2013-06-19','09:45:00',2.46),('15128','2013-06-19','09:50:00',2.51),('15128','2013-06-19','09:55:00',2.55),('15128','2013-06-19','10:00:00',2.6),('15128','2013-06-19','10:05:00',2.63),('15128','2013-06-19','10:10:00',2.72),('15128','2013-06-19','10:15:00',2.73),('15128','2013-06-19','10:20:00',2.77),('15128','2013-06-19','10:25:00',2.87),('15128','2013-06-19','10:30:00',2.9),('15128','2013-06-19','10:35:00',2.92),('15128','2013-06-19','10:40:00',2.96),('15128','2013-06-19','10:45:00',2.99),('15128','2013-06-19','10:50:00',3.09),('15128','2013-06-19','10:55:00',3.07),('15128','2013-06-19','11:00:00',3.15),('15128','2013-06-19','11:05:00',3.18),('15128','2013-06-19','11:10:00',3.27),('15128','2013-06-19','11:15:00',3.33),('15128','2013-06-19','11:20:00',3.38),('15128','2013-06-19','11:25:00',3.42),('15128','2013-06-19','11:30:00',3.33),('15128','2013-06-19','11:35:00',3.38),('15128','2013-06-19','11:40:00',3.6),('15128','2013-06-19','11:45:00',3.63),('15128','2013-06-19','11:50:00',3.74),('15128','2013-06-19','11:55:00',3.74),('15128','2013-06-19','12:00:00',3.91),('15128','2013-06-19','12:05:00',3.94),('15128','2013-06-19','12:10:00',3.95),('15128','2013-06-19','12:15:00',3.93),('15128','2013-06-19','12:20:00',3.88),('15128','2013-06-19','12:25:00',3.87),('15128','2013-06-19','12:30:00',3.9),('15128','2013-06-19','12:35:00',3.95),('15128','2013-06-19','12:40:00',4),('15128','2013-06-19','12:45:00',4.03),('15128','2013-06-19','12:50:00',4.03),('15128','2013-06-19','12:55:00',4.04),('15128','2013-06-19','13:00:00',4.1),('15128','2013-06-19','13:05:00',4.09),('15128','2013-06-19','13:10:00',4.11),('15128','2013-06-19','13:15:00',4.2),('15128','2013-06-19','13:20:00',4.22),('15128','2013-06-19','13:25:00',4.24),('15128','2013-06-19','13:30:00',4.31),('15128','2013-06-19','13:35:00',4.33),('15128','2013-06-19','13:40:00',4.37),('15128','2013-06-19','13:45:00',4.45),('15128','2013-06-19','13:50:00',4.47),('15128','2013-06-19','13:55:00',4.47),('15128','2013-06-19','14:00:00',4.45),('15128','2013-06-19','14:05:00',4.47),('15128','2013-06-19','14:10:00',4.51),('15128','2013-06-19','14:15:00',4.5),('15128','2013-06-19','14:20:00',4.5),('15128','2013-06-19','14:25:00',4.49),('15128','2013-06-19','14:30:00',4.49),('15128','2013-06-19','14:35:00',4.49),('15128','2013-06-19','14:40:00',4.49),('15128','2013-06-19','14:45:00',4.46),('15128','2013-06-19','14:50:00',4.45),('15128','2013-06-19','14:55:00',4.44),('15128','2013-06-19','15:00:00',4.41),('15128','2013-06-19','15:05:00',4.38),('15128','2013-06-19','15:10:00',4.33),('15128','2013-06-19','15:15:00',4.31),('15128','2013-06-19','15:20:00',4.27),('15128','2013-06-19','15:25:00',4.26),('15128','2013-06-19','15:30:00',4.21),('15128','2013-06-19','15:35:00',4.16),('15128','2013-06-19','15:40:00',4.1),('15128','2013-06-19','15:45:00',4.09),('15128','2013-06-19','15:50:00',4.03),('15128','2013-06-19','15:55:00',3.99),('15128','2013-06-19','16:00:00',3.94),('15128','2013-06-19','16:05:00',3.9),('15128','2013-06-19','16:10:00',3.88),('15128','2013-06-19','16:15:00',3.83),('15128','2013-06-19','16:20:00',3.79),('15128','2013-06-19','16:25:00',3.74),('15128','2013-06-19','16:30:00',3.68),('15128','2013-06-19','16:35:00',3.64),('15128','2013-06-19','16:40:00',3.56),('15128','2013-06-19','16:45:00',3.49),('15128','2013-06-19','16:50:00',3.44),('15128','2013-06-19','16:55:00',3.39),('15128','2013-06-19','17:00:00',3.34),('15128','2013-06-19','17:05:00',3.28),('15128','2013-06-19','17:10:00',3.23),('15128','2013-06-19','17:15:00',3.17),('15128','2013-06-19','17:20:00',3.11),('15128','2013-06-19','17:25:00',3.06),('15128','2013-06-19','17:30:00',2.99),('15128','2013-06-19','17:35:00',2.91),('15128','2013-06-19','17:40:00',2.85),('15128','2013-06-19','17:45:00',2.78),('15128','2013-06-19','17:50:00',2.7),('15128','2013-06-19','17:55:00',2.56),('15128','2013-06-19','18:00:00',2.43),('15128','2013-06-19','18:05:00',2.41),('15128','2013-06-19','18:10:00',2.27),('15128','2013-06-19','18:15:00',2.18),('15128','2013-06-19','18:20:00',2.09),('15128','2013-06-19','18:25:00',2),('15128','2013-06-19','18:30:00',1.9),('15128','2013-06-19','18:35:00',1.79),('15128','2013-06-19','18:40:00',1.72),('15128','2013-06-19','18:45:00',1.64),('15128','2013-06-19','18:50:00',1.59),('15128','2013-06-19','18:55:00',1.52),('15128','2013-06-19','19:00:00',1.41),('15128','2013-06-19','19:05:00',1.31),('15128','2013-06-19','19:10:00',1.21),('15128','2013-06-19','19:15:00',1.1),('15128','2013-06-18','08:05:00',1.05),('15128','2013-06-18','08:10:00',1.1),('15128','2013-06-18','08:15:00',1.16),('15128','2013-06-18','08:20:00',1.25),('15128','2013-06-18','08:25:00',1.32),('15128','2013-06-18','08:30:00',1.37),('15128','2013-06-18','08:35:00',1.44),('15128','2013-06-18','08:40:00',1.51),('15128','2013-06-18','08:45:00',1.58),('15128','2013-06-18','08:50:00',1.67),('15128','2013-06-18','08:55:00',1.77),('15128','2013-06-18','09:00:00',1.84),('15128','2013-06-18','09:05:00',1.92),('15128','2013-06-18','09:10:00',1.97),('15128','2013-06-18','09:15:00',2.01),('15128','2013-06-18','09:20:00',2.01),('15128','2013-06-18','09:25:00',2.07),('15128','2013-06-18','09:30:00',2.2),('15128','2013-06-18','09:35:00',2.26),('15128','2013-06-18','09:40:00',2.32),('15128','2013-06-18','09:45:00',2.38),('15128','2013-06-18','09:50:00',2.44),('15128','2013-06-18','09:55:00',2.49),('15128','2013-06-18','10:00:00',2.52),('15128','2013-06-18','10:05:00',2.56),('15128','2013-06-18','10:10:00',2.65),('15128','2013-06-18','10:15:00',2.65),('15128','2013-06-18','10:20:00',2.69),('15128','2013-06-18','10:25:00',2.78),('15128','2013-06-18','10:30:00',2.81),('15128','2013-06-18','10:35:00',2.86),('15128','2013-06-18','10:40:00',2.9),('15128','2013-06-18','10:45:00',2.94),('15128','2013-06-18','10:50:00',3.03),('15128','2013-06-18','10:55:00',3),('15128','2013-06-18','11:00:00',3.06),('15128','2013-06-18','11:05:00',3.03),('15128','2013-06-18','11:10:00',3.13),('15128','2013-06-18','11:15:00',3.23),('15128','2013-06-18','11:20:00',3.29),('15128','2013-06-18','11:25:00',3.37),('15128','2013-06-18','11:30:00',3.25),('15128','2013-06-18','11:35:00',3.37),('15128','2013-06-18','11:40:00',3.55),('15128','2013-06-18','11:45:00',3.61),('15128','2013-06-18','11:50:00',3.74),('15128','2013-06-18','11:55:00',3.77),('15128','2013-06-18','12:00:00',3.82),('15128','2013-06-18','12:05:00',3.9),('15128','2013-06-18','12:10:00',3.93),('15128','2013-06-18','12:15:00',3.98),('15128','2013-06-18','12:20:00',4),('15128','2013-06-18','12:25:00',4.02),('15128','2013-06-18','12:30:00',4.05),('15128','2013-06-18','12:35:00',4.1),('15128','2013-06-18','12:40:00',4.08),('15128','2013-06-18','12:45:00',4.11),('15128','2013-06-18','12:50:00',4.12),('15128','2013-06-18','12:55:00',4.11),('15128','2013-06-18','13:00:00',4.19),('15128','2013-06-18','13:05:00',4.2),('15128','2013-06-18','13:10:00',4.24),('15128','2013-06-18','13:15:00',4.26),('15128','2013-06-18','13:20:00',4.28),('15128','2013-06-18','13:25:00',4.28),('15128','2013-06-18','13:30:00',4.29),('15128','2013-06-18','13:35:00',4.29),('15128','2013-06-18','13:40:00',4.31),('15128','2013-06-18','13:45:00',4.35),('15128','2013-06-18','13:50:00',4.35),('15128','2013-06-18','13:55:00',4.34),('15128','2013-06-18','14:00:00',4.34),('15128','2013-06-18','14:05:00',4.35),('15128','2013-06-18','14:10:00',4.32),('15128','2013-06-18','14:15:00',4.31),('15128','2013-06-18','14:20:00',4.3),('15128','2013-06-18','14:25:00',4.26),('15128','2013-06-18','14:30:00',4.26),('15128','2013-06-18','14:35:00',4.27),('15128','2013-06-18','14:40:00',4.26),('15128','2013-06-18','14:45:00',4.25),('15128','2013-06-18','14:50:00',4.22),('15128','2013-06-18','14:55:00',4.21),('15128','2013-06-18','15:00:00',4.19),('15128','2013-06-18','15:05:00',4.17),('15128','2013-06-18','15:10:00',4.12),('15128','2013-06-18','15:15:00',4.09),('15128','2013-06-18','15:20:00',4.06),('15128','2013-06-18','15:25:00',4.02),('15128','2013-06-18','15:30:00',4.01),('15128','2013-06-18','15:35:00',3.97),('15128','2013-06-18','15:40:00',3.95),('15128','2013-06-18','15:45:00',3.92),('15128','2013-06-18','15:50:00',3.87),('15128','2013-06-18','15:55:00',3.83),('15128','2013-06-18','16:00:00',3.79),('15128','2013-06-18','16:05:00',3.75),('15128','2013-06-18','16:10:00',3.73),('15128','2013-06-18','16:15:00',3.68),('15128','2013-06-18','16:20:00',3.65),('15128','2013-06-18','16:25:00',3.6),('15128','2013-06-18','16:30:00',3.56),('15128','2013-06-18','16:35:00',3.53),('15128','2013-06-18','16:40:00',3.47),('15128','2013-06-18','16:45:00',3.42),('15128','2013-06-18','16:50:00',3.37),('15128','2013-06-18','16:55:00',3.33),('15128','2013-06-18','17:00:00',3.27),('15128','2013-06-18','17:05:00',3.2),('15128','2013-06-18','17:10:00',3.15),('15128','2013-06-18','17:15:00',3.08),('15128','2013-06-18','17:20:00',3),('15128','2013-06-18','17:25:00',2.94),('15128','2013-06-18','17:30:00',2.88),('15128','2013-06-18','17:35:00',2.81),('15128','2013-06-18','17:40:00',2.75),('15128','2013-06-18','17:45:00',2.67),('15128','2013-06-18','17:50:00',2.59),('15128','2013-06-18','17:55:00',2.47),('15128','2013-06-18','18:00:00',2.38),('15128','2013-06-18','18:05:00',2.27),('15128','2013-06-18','18:10:00',2.16),('15128','2013-06-18','18:15:00',2.04),('15128','2013-06-18','18:20:00',1.94),('15128','2013-06-18','18:25:00',1.88),('15128','2013-06-18','18:30:00',1.78),('15128','2013-06-18','18:35:00',1.7),('15128','2013-06-18','18:40:00',1.63),('15128','2013-06-18','18:45:00',1.59),('15128','2013-06-18','18:50:00',1.55),('15128','2013-06-18','18:55:00',1.45),('15128','2013-06-18','19:00:00',1.36),('15128','2013-06-18','19:05:00',1.26),('15128','2013-06-18','19:10:00',1.18),('15128','2013-06-18','19:15:00',1.09),('15128','2013-06-17','08:05:00',1.03),('15128','2013-06-17','08:10:00',1.07),('15128','2013-06-17','08:15:00',1.13),('15128','2013-06-17','08:20:00',1.2),('15128','2013-06-17','08:25:00',1.29),('15128','2013-06-17','08:30:00',1.36),('15128','2013-06-17','08:35:00',1.41),('15128','2013-06-17','08:40:00',1.48),('15128','2013-06-17','08:45:00',1.53),('15128','2013-06-17','08:50:00',1.64),('15128','2013-06-17','08:55:00',1.75),('15128','2013-06-17','09:00:00',1.81),('15128','2013-06-17','09:05:00',1.9),('15128','2013-06-17','09:10:00',1.95),('15128','2013-06-17','09:15:00',1.99),('15128','2013-06-17','09:20:00',2.01),('15128','2013-06-17','09:25:00',2.09),('15128','2013-06-17','09:30:00',2.21),('15128','2013-06-17','09:35:00',2.27),('15128','2013-06-17','09:40:00',2.33),('15128','2013-06-17','09:45:00',2.39),('15128','2013-06-17','09:50:00',2.45),('15128','2013-06-17','09:55:00',2.5),('15128','2013-06-17','10:00:00',2.54),('15128','2013-06-17','10:05:00',2.57),('15128','2013-06-17','10:10:00',2.63),('15128','2013-06-17','10:15:00',2.68),('15128','2013-06-17','10:20:00',2.71),('15128','2013-06-17','10:25:00',2.8),('15128','2013-06-17','10:30:00',2.83),('15128','2013-06-17','10:35:00',2.88),('15128','2013-06-17','10:40:00',2.97),('15128','2013-06-17','10:45:00',3),('15128','2013-06-17','10:50:00',3.09),('15128','2013-06-17','10:55:00',3.07),('15128','2013-06-17','11:00:00',3.13),('15128','2013-06-17','11:05:00',3.1),('15128','2013-06-17','11:10:00',3.21),('15128','2013-06-17','11:15:00',3.29),('15128','2013-06-17','11:20:00',3.35),('15128','2013-06-17','11:25:00',3.42),('15128','2013-06-17','11:30:00',3.37),('15128','2013-06-17','11:35:00',3.42),('15128','2013-06-17','11:40:00',3.61),('15128','2013-06-17','11:45:00',3.7),('15128','2013-06-17','11:50:00',3.73),('15128','2013-06-17','11:55:00',3.73),('15128','2013-06-17','12:00:00',3.74),('15128','2013-06-17','12:05:00',3.8),('15128','2013-06-17','12:10:00',3.82),('15128','2013-06-17','12:15:00',3.85),('15128','2013-06-17','12:20:00',3.89),('15128','2013-06-17','12:25:00',3.89),('15128','2013-06-17','12:30:00',3.89),('15128','2013-06-17','12:35:00',3.84),('15128','2013-06-17','12:40:00',3.91),('15128','2013-06-17','12:45:00',3.87),('15128','2013-06-17','12:50:00',3.84),('15128','2013-06-17','12:55:00',4),('15128','2013-06-17','13:00:00',3.95),('15128','2013-06-17','13:05:00',3.73),('15128','2013-06-17','13:10:00',3.67),('15128','2013-06-17','13:15:00',3.98),('15128','2013-06-17','13:20:00',4.2),('15128','2013-06-17','13:25:00',4.22),('15128','2013-06-17','13:30:00',4.2),('15128','2013-06-17','13:35:00',4.2),('15128','2013-06-17','13:40:00',4.14),('15128','2013-06-17','13:45:00',4.17),('15128','2013-06-17','13:50:00',4.22),('15128','2013-06-17','13:55:00',4.16),('15128','2013-06-17','14:00:00',4.29),('15128','2013-06-17','14:05:00',4.4),('15128','2013-06-17','14:10:00',4.46),('15128','2013-06-17','14:15:00',4.48),('15128','2013-06-17','14:20:00',4.41),('15128','2013-06-17','14:25:00',4.39),('15128','2013-06-17','14:30:00',4.47),('15128','2013-06-17','14:35:00',4.42),('15128','2013-06-17','14:40:00',3.31),('15128','2013-06-17','14:45:00',3.77),('15128','2013-06-17','14:50:00',4.43),('15128','2013-06-17','14:55:00',4.43),('15128','2013-06-17','15:00:00',4.39),('15128','2013-06-17','15:05:00',4.33),('15128','2013-06-17','15:10:00',4.29),('15128','2013-06-17','15:15:00',4.18),('15128','2013-06-17','15:20:00',4.13),('15128','2013-06-17','15:25:00',4.06),('15128','2013-06-17','15:30:00',4.03),('15128','2013-06-17','15:35:00',4.01),('15128','2013-06-17','15:40:00',3.96),('15128','2013-06-17','15:45:00',3.95),('15128','2013-06-17','15:50:00',3.91),('15128','2013-06-17','15:55:00',3.88),('15128','2013-06-17','16:00:00',3.91),('15128','2013-06-17','16:05:00',3.88),('15128','2013-06-17','16:10:00',3.84),('15128','2013-06-17','16:15:00',3.83),('15128','2013-06-17','16:20:00',3.81),('15128','2013-06-17','16:25:00',3.81),('15128','2013-06-17','16:30:00',3.67),('15128','2013-06-17','16:35:00',3.42),('15128','2013-06-17','16:40:00',3.35),('15128','2013-06-17','16:45:00',3.32),('15128','2013-06-17','16:50:00',3.45),('15128','2013-06-17','16:55:00',3.34),('15128','2013-06-17','17:00:00',3.29),('15128','2013-06-17','17:05:00',3.24),('15128','2013-06-17','17:10:00',3.04),('15128','2013-06-17','17:15:00',3.09),('15128','2013-06-17','17:20:00',3),('15128','2013-06-17','17:25:00',2.91),('15128','2013-06-17','17:30:00',2.87),('15128','2013-06-17','17:35:00',2.79),('15128','2013-06-17','17:40:00',2.71),('15128','2013-06-17','17:45:00',2.63),('15128','2013-06-17','17:50:00',2.56),('15128','2013-06-17','17:55:00',2.42),('15128','2013-06-17','18:00:00',2.32),('15128','2013-06-17','18:05:00',2.29),('15128','2013-06-17','18:10:00',2.14),('15128','2013-06-17','18:15:00',2.06),('15128','2013-06-17','18:20:00',1.99),('15128','2013-06-17','18:25:00',1.93),('15128','2013-06-17','18:30:00',1.83),('15128','2013-06-17','18:35:00',1.73),('15128','2013-06-17','18:40:00',1.64),('15128','2013-06-17','18:45:00',1.6),('15128','2013-06-17','18:50:00',1.54),('15128','2013-06-17','18:55:00',1.45),('15128','2013-06-17','19:00:00',1.39),('15128','2013-06-17','19:05:00',1.3),('15128','2013-06-17','19:10:00',1.22),('15128','2013-06-17','19:15:00',1.12),('15128','2013-06-16','08:00:00',1.03),('15128','2013-06-16','08:05:00',1.09),('15128','2013-06-16','08:10:00',1.13),('15128','2013-06-16','08:15:00',1.21),('15128','2013-06-16','08:20:00',1.31),('15128','2013-06-16','08:25:00',1.39),('15128','2013-06-16','08:30:00',1.46),('15128','2013-06-16','08:35:00',1.51),('15128','2013-06-16','08:40:00',1.59),('15128','2013-06-16','08:45:00',1.65),('15128','2013-06-16','08:50:00',1.73),('15128','2013-06-16','08:55:00',1.84),('15128','2013-06-16','09:00:00',1.9),('15128','2013-06-16','09:05:00',1.98),('15128','2013-06-16','09:10:00',2.06),('15128','2013-06-16','09:15:00',2.1),('15128','2013-06-16','09:20:00',2.1),('15128','2013-06-16','09:25:00',2.24),('15128','2013-06-16','09:30:00',2.32),('15128','2013-06-16','09:35:00',2.38),('15128','2013-06-16','09:40:00',2.43),('15128','2013-06-16','09:45:00',2.49),('15128','2013-06-16','09:50:00',2.55),('15128','2013-06-16','09:55:00',2.61),('15128','2013-06-16','10:00:00',2.66),('15128','2013-06-16','10:05:00',2.67),('15128','2013-06-16','10:10:00',2.73),('15128','2013-06-16','10:15:00',2.77),('15128','2013-06-16','10:20:00',2.81),('15128','2013-06-16','10:25:00',2.88),('15128','2013-06-16','10:30:00',2.96),('15128','2013-06-16','10:35:00',2.97),('15128','2013-06-16','10:40:00',3.04),('15128','2013-06-16','10:45:00',3.08),('15128','2013-06-16','10:50:00',3.16),('15128','2013-06-16','10:55:00',3.15),('15128','2013-06-16','11:00:00',3.25),('15128','2013-06-16','11:05:00',3.21),('15128','2013-06-16','11:10:00',3.3),('15128','2013-06-16','11:15:00',3.4),('15128','2013-06-16','11:20:00',3.44),('15128','2013-06-16','11:25:00',3.5),('15128','2013-06-16','11:30:00',3.4),('15128','2013-06-16','11:35:00',3.47),('15128','2013-06-16','11:40:00',3.63),('15128','2013-06-16','11:45:00',3.73),('15128','2013-06-16','11:50:00',3.83),('15128','2013-06-16','11:55:00',3.91),('15128','2013-06-16','12:00:00',3.97),('15128','2013-06-16','12:05:00',4.01),('15128','2013-06-16','12:10:00',4.08),('15128','2013-06-16','12:15:00',4.09),('15128','2013-06-16','12:20:00',4.11),('15128','2013-06-16','12:25:00',4.14),('15128','2013-06-16','12:30:00',4.17),('15128','2013-06-16','12:35:00',4.17),('15128','2013-06-16','12:40:00',4.19),('15128','2013-06-16','12:45:00',4.22),('15128','2013-06-16','12:50:00',4.25),('15128','2013-06-16','12:55:00',4.25),('15128','2013-06-16','13:00:00',4.28),('15128','2013-06-16','13:05:00',4.29),('15128','2013-06-16','13:10:00',4.32),('15128','2013-06-16','13:15:00',4.3),('15128','2013-06-16','13:20:00',4.28),('15128','2013-06-16','13:25:00',4.32),('15128','2013-06-16','13:30:00',4.3),('15128','2013-06-16','13:35:00',4.31),('15128','2013-06-16','13:40:00',4.32),('15128','2013-06-16','13:45:00',4.34),('15128','2013-06-16','13:50:00',4.34),('15128','2013-06-16','13:55:00',4.32),('15128','2013-06-16','14:00:00',4.33),('15128','2013-06-16','14:05:00',4.32),('15128','2013-06-16','14:10:00',4.32),('15128','2013-06-16','14:15:00',4.31),('15128','2013-06-16','14:20:00',4.31),('15128','2013-06-16','14:25:00',4.28),('15128','2013-06-16','14:30:00',4.29),('15128','2013-06-16','14:35:00',4.28),('15128','2013-06-16','14:40:00',4.27),('15128','2013-06-16','14:45:00',4.25),('15128','2013-06-16','14:50:00',4.22),('15128','2013-06-16','14:55:00',4.22),('15128','2013-06-16','15:00:00',4.22),('15128','2013-06-16','15:05:00',4.2),('15128','2013-06-16','15:10:00',4.18),('15128','2013-06-16','15:15:00',4.15),('15128','2013-06-16','15:20:00',4.15),('15128','2013-06-16','15:25:00',4.11),('15128','2013-06-16','15:30:00',4.09),('15128','2013-06-16','15:35:00',4.06),('15128','2013-06-16','15:40:00',4.02),('15128','2013-06-16','15:45:00',4.01),('15128','2013-06-16','15:50:00',3.98),('15128','2013-06-16','15:55:00',3.95),('15128','2013-06-16','16:00:00',3.9),('15128','2013-06-16','16:05:00',3.86),('15128','2013-06-16','16:10:00',3.8),('15128','2013-06-16','16:15:00',3.77),('15128','2013-06-16','16:20:00',3.72),('15128','2013-06-16','16:25:00',3.67),('15128','2013-06-16','16:30:00',3.65),('15128','2013-06-16','16:35:00',3.6),('15128','2013-06-16','16:40:00',3.55),('15128','2013-06-16','16:45:00',3.5),('15128','2013-06-16','16:50:00',3.45),('15128','2013-06-16','16:55:00',3.39),('15128','2013-06-16','17:00:00',3.33),('15128','2013-06-16','17:05:00',3.26),('15128','2013-06-16','17:10:00',3.19),('15128','2013-06-16','17:15:00',3.13),('15128','2013-06-16','17:20:00',3.06),('15128','2013-06-16','17:25:00',3.01),('15128','2013-06-16','17:30:00',2.96),('15128','2013-06-16','17:35:00',2.9),('15128','2013-06-16','17:40:00',2.85),('15128','2013-06-16','17:45:00',2.78),('15128','2013-06-16','17:50:00',2.72),('15128','2013-06-16','17:55:00',2.58),('15128','2013-06-16','18:00:00',2.48),('15128','2013-06-16','18:05:00',2.42),('15128','2013-06-16','18:10:00',2.29),('15128','2013-06-16','18:15:00',2.19),('15128','2013-06-16','18:20:00',2.11),('15128','2013-06-16','18:25:00',2.02),('15128','2013-06-16','18:30:00',1.92),('15128','2013-06-16','18:35:00',1.8),('15128','2013-06-16','18:40:00',1.66),('15128','2013-06-16','18:45:00',1.7),('15128','2013-06-16','18:50:00',1.63),('15128','2013-06-16','18:55:00',1.63),('15128','2013-06-16','19:00:00',1.54),('15128','2013-06-16','19:05:00',1.45),('15128','2013-06-16','19:10:00',1.36),('15128','2013-06-16','19:15:00',1.23),('15128','2013-06-16','19:20:00',1.04),('15128','2013-06-15','08:00:00',1.06),('15128','2013-06-15','08:05:00',1.11),('15128','2013-06-15','08:10:00',1.15),('15128','2013-06-15','08:15:00',1.23),('15128','2013-06-15','08:20:00',1.33),('15128','2013-06-15','08:25:00',1.41),('15128','2013-06-15','08:30:00',1.46),('15128','2013-06-15','08:35:00',1.52),('15128','2013-06-15','08:40:00',1.6),('15128','2013-06-15','08:45:00',1.67),('15128','2013-06-15','08:50:00',1.77),('15128','2013-06-15','08:55:00',1.89),('15128','2013-06-15','09:00:00',1.96),('15128','2013-06-15','09:05:00',2.04),('15128','2013-06-15','09:10:00',2.12),('15128','2013-06-15','09:15:00',2.13),('15128','2013-06-15','09:20:00',2.16),('15128','2013-06-15','09:25:00',2.3),('15128','2013-06-15','09:30:00',2.37),('15128','2013-06-15','09:35:00',2.43),('15128','2013-06-15','09:40:00',2.46),('15128','2013-06-15','09:45:00',2.5),('15128','2013-06-15','09:50:00',2.56),('15128','2013-06-15','09:55:00',2.6),('15128','2013-06-15','10:00:00',2.64),('15128','2013-06-15','10:05:00',2.72),('15128','2013-06-15','10:10:00',2.77),('15128','2013-06-15','10:15:00',2.79),('15128','2013-06-15','10:20:00',2.83),('15128','2013-06-15','10:25:00',2.92),('15128','2013-06-15','10:30:00',3.01),('15128','2013-06-15','10:35:00',3.02),('15128','2013-06-15','10:40:00',3.09),('15128','2013-06-15','10:45:00',3.13),('15128','2013-06-15','10:50:00',3.25),('15128','2013-06-15','10:55:00',3.22),('15128','2013-06-15','11:00:00',3.37),('15128','2013-06-15','11:05:00',3.3),('15128','2013-06-15','11:10:00',3.41),('15128','2013-06-15','11:15:00',3.47),('15128','2013-06-15','11:20:00',3.53),('15128','2013-06-15','11:25:00',3.55),('15128','2013-06-15','11:30:00',3.49),('15128','2013-06-15','11:35:00',3.58),('15128','2013-06-15','11:40:00',3.76),('15128','2013-06-15','11:45:00',3.83),('15128','2013-06-15','11:50:00',3.91),('15128','2013-06-15','11:55:00',3.95),('15128','2013-06-15','12:00:00',4),('15128','2013-06-15','12:05:00',4.06),('15128','2013-06-15','12:10:00',4.11),('15128','2013-06-15','12:15:00',4.14),('15128','2013-06-15','12:20:00',4.18),('15128','2013-06-15','12:25:00',4.19),('15128','2013-06-15','12:30:00',4.26),('15128','2013-06-15','12:35:00',4.29),('15128','2013-06-15','12:40:00',4.34),('15128','2013-06-15','12:45:00',4.37),('15128','2013-06-15','12:50:00',4.37),('15128','2013-06-15','12:55:00',4.39),('15128','2013-06-15','13:00:00',4.39),('15128','2013-06-15','13:05:00',4.42),('15128','2013-06-15','13:10:00',4.43),('15128','2013-06-15','13:15:00',4.46),('15128','2013-06-15','13:20:00',4.45),('15128','2013-06-15','13:25:00',4.46),('15128','2013-06-15','13:30:00',4.49),('15128','2013-06-15','13:35:00',4.49),('15128','2013-06-15','13:40:00',4.48),('15128','2013-06-15','13:45:00',4.47),('15128','2013-06-15','13:50:00',4.49),('15128','2013-06-15','13:55:00',4.49),('15128','2013-06-15','14:00:00',4.5),('15128','2013-06-15','14:05:00',4.52),('15128','2013-06-15','14:10:00',4.51),('15128','2013-06-15','14:15:00',4.47),('15128','2013-06-15','14:20:00',4.45),('15128','2013-06-15','14:25:00',4.44),('15128','2013-06-15','14:30:00',4.45),('15128','2013-06-15','14:35:00',4.45),('15128','2013-06-15','14:40:00',4.44),('15128','2013-06-15','14:45:00',4.43),('15128','2013-06-15','14:50:00',4.39),('15128','2013-06-15','14:55:00',4.38),('15128','2013-06-15','15:00:00',4.37),('15128','2013-06-15','15:05:00',4.34),('15128','2013-06-15','15:10:00',4.3),('15128','2013-06-15','15:15:00',4.28),('15128','2013-06-15','15:20:00',4.26),('15128','2013-06-15','15:25:00',4.22),('15128','2013-06-15','15:30:00',4.18),('15128','2013-06-15','15:35:00',4.16),('15128','2013-06-15','15:40:00',4.12),('15128','2013-06-15','15:45:00',4.09),('15128','2013-06-15','15:50:00',4.05),('15128','2013-06-15','15:55:00',4.02),('15128','2013-06-15','16:00:00',3.98),('15128','2013-06-15','16:05:00',3.92),('15128','2013-06-15','16:10:00',3.88),('15128','2013-06-15','16:15:00',3.83),('15128','2013-06-15','16:20:00',3.79),('15128','2013-06-15','16:25:00',3.74),('15128','2013-06-15','16:30:00',3.69),('15128','2013-06-15','16:35:00',3.64),('15128','2013-06-15','16:40:00',3.59),('15128','2013-06-15','16:45:00',3.54),('15128','2013-06-15','16:50:00',3.47),('15128','2013-06-15','16:55:00',3.41),('15128','2013-06-15','17:00:00',3.34),('15128','2013-06-15','17:05:00',3.29),('15128','2013-06-15','17:10:00',3.22),('15128','2013-06-15','17:15:00',3.15),('15128','2013-06-15','17:20:00',3.08),('15128','2013-06-15','17:25:00',3.02),('15128','2013-06-15','17:30:00',2.94),('15128','2013-06-15','17:35:00',2.86),('15128','2013-06-15','17:40:00',2.8),('15128','2013-06-15','17:45:00',2.72),('15128','2013-06-15','17:50:00',2.64),('15128','2013-06-15','17:55:00',2.54),('15128','2013-06-15','18:00:00',2.41),('15128','2013-06-15','18:05:00',2.33),('15128','2013-06-15','18:10:00',2.18),('15128','2013-06-15','18:15:00',2.08),('15128','2013-06-15','18:20:00',2.01),('15128','2013-06-15','18:25:00',1.93),('15128','2013-06-15','18:30:00',1.83),('15128','2013-06-15','18:35:00',1.75),('15128','2013-06-15','18:40:00',1.66),('15128','2013-06-15','18:45:00',1.61),('15128','2013-06-15','18:50:00',1.56),('15128','2013-06-15','18:55:00',1.46),('15128','2013-06-15','19:00:00',1.38),('15128','2013-06-15','19:05:00',1.29),('15128','2013-06-15','19:10:00',1.21),('15128','2013-06-15','19:15:00',1.09),('15128','2013-06-14','08:00:00',1.05),('15128','2013-06-14','08:05:00',1.13),('15128','2013-06-14','08:10:00',1.17),('15128','2013-06-14','08:15:00',1.23),('15128','2013-06-14','08:20:00',1.31),('15128','2013-06-14','08:25:00',1.37),('15128','2013-06-14','08:30:00',1.5),('15128','2013-06-14','08:35:00',1.62),('15128','2013-06-14','08:40:00',1.81),('15128','2013-06-14','08:45:00',1.74),('15128','2013-06-14','08:50:00',2.03),('15128','2013-06-14','08:55:00',2.02),('15128','2013-06-14','09:00:00',1.75),('15128','2013-06-14','09:05:00',1.93),('15128','2013-06-14','09:10:00',1.57),('15128','2013-06-14','09:15:00',2.13),('15128','2013-06-14','09:20:00',2.1),('15128','2013-06-14','09:25:00',2.03),('15128','2013-06-14','09:30:00',2.26),('15128','2013-06-14','09:35:00',2.34),('15128','2013-06-14','09:40:00',2.39),('15128','2013-06-14','09:45:00',2.51),('15128','2013-06-14','09:50:00',2.62),('15128','2013-06-14','09:55:00',2.5),('15128','2013-06-14','10:00:00',2.01),('15128','2013-06-14','10:05:00',2.74),('15128','2013-06-14','10:10:00',2.86),('15128','2013-06-14','10:15:00',2.82),('15128','2013-06-14','10:20:00',2.84),('15128','2013-06-14','10:25:00',2.84),('15128','2013-06-14','10:30:00',3.05),('15128','2013-06-14','10:35:00',3),('15128','2013-06-14','10:40:00',3.07),('15128','2013-06-14','10:45:00',2.99),('15128','2013-06-14','10:50:00',3.08),('15128','2013-06-14','10:55:00',3.29),('15128','2013-06-14','11:00:00',3.43),('15128','2013-06-14','11:05:00',3.4),('15128','2013-06-14','11:10:00',3.6),('15128','2013-06-14','11:15:00',3.57),('15128','2013-06-14','11:20:00',3.79),('15128','2013-06-14','11:25:00',3.8),('15128','2013-06-14','11:30:00',3.7),('15128','2013-06-14','11:35:00',3.76),('15128','2013-06-14','11:40:00',3.83),('15128','2013-06-14','11:45:00',3.97),('15128','2013-06-14','11:50:00',4),('15128','2013-06-14','11:55:00',4.06),('15128','2013-06-14','12:00:00',4.11),('15128','2013-06-14','12:05:00',4.14),('15128','2013-06-14','12:10:00',4.15),('15128','2013-06-14','12:15:00',4.22),('15128','2013-06-14','12:20:00',4.24),('15128','2013-06-14','12:25:00',4.28),('15128','2013-06-14','12:30:00',4.3),('15128','2013-06-14','12:35:00',4.3),('15128','2013-06-14','12:40:00',4.36),('15128','2013-06-14','12:45:00',4.35),('15128','2013-06-14','12:50:00',4.37),('15128','2013-06-14','12:55:00',4.36),('15128','2013-06-14','13:00:00',4.34),('15128','2013-06-14','13:05:00',4.42),('15128','2013-06-14','13:10:00',4.4),('15128','2013-06-14','13:15:00',4.34),('15128','2013-06-14','13:20:00',4.31),('15128','2013-06-14','13:25:00',4.41),('15128','2013-06-14','13:30:00',4.43),('15128','2013-06-14','13:35:00',4.46),('15128','2013-06-14','13:40:00',4.46),('15128','2013-06-14','13:45:00',4.48),('15128','2013-06-14','13:50:00',4.49),('15128','2013-06-14','13:55:00',4.48),('15128','2013-06-14','14:00:00',4.47),('15128','2013-06-14','14:05:00',4.5),('15128','2013-06-14','14:10:00',4.46),('15128','2013-06-14','14:15:00',4.49),('15128','2013-06-14','14:20:00',4.49),('15128','2013-06-14','14:25:00',4.48),('15128','2013-06-14','14:30:00',4.46),('15128','2013-06-14','14:35:00',4.46),('15128','2013-06-14','14:40:00',4.45),('15128','2013-06-14','14:45:00',4.41),('15128','2013-06-14','14:50:00',4.4),('15128','2013-06-14','14:55:00',4.38),('15128','2013-06-14','15:00:00',4.34),('15128','2013-06-14','15:05:00',4.32),('15128','2013-06-14','15:10:00',4.31),('15128','2013-06-14','15:15:00',4.29),('15128','2013-06-14','15:20:00',4.25),('15128','2013-06-14','15:25:00',4.21),('15128','2013-06-14','15:30:00',4.19),('15128','2013-06-14','15:35:00',4.16),('15128','2013-06-14','15:40:00',4.14),('15128','2013-06-14','15:45:00',4.08),('15128','2013-06-14','15:50:00',4.01),('15128','2013-06-14','15:55:00',3.98),('15128','2013-06-14','16:00:00',3.95),('15128','2013-06-14','16:05:00',3.92),('15128','2013-06-14','16:10:00',3.87),('15128','2013-06-14','16:15:00',3.83),('15128','2013-06-14','16:20:00',3.78),('15128','2013-06-14','16:25:00',3.73),('15128','2013-06-14','16:30:00',3.67),('15128','2013-06-14','16:35:00',3.61),('15128','2013-06-14','16:40:00',3.55),('15128','2013-06-14','16:45:00',3.47),('15128','2013-06-14','16:50:00',3.45),('15128','2013-06-14','16:55:00',3.37),('15128','2013-06-14','17:00:00',3.33),('15128','2013-06-14','17:05:00',3.25),('15128','2013-06-14','17:10:00',3.21),('15128','2013-06-14','17:15:00',3.07),('15128','2013-06-14','17:20:00',3.02),('15128','2013-06-14','17:25:00',2.95),('15128','2013-06-14','17:30:00',2.88),('15128','2013-06-14','17:35:00',2.81),('15128','2013-06-14','17:40:00',2.75),('15128','2013-06-14','17:45:00',2.65),('15128','2013-06-14','17:50:00',2.59),('15128','2013-06-14','17:55:00',2.43),('15128','2013-06-14','18:00:00',2.33),('15128','2013-06-14','18:05:00',2.29),('15128','2013-06-14','18:10:00',2.14),('15128','2013-06-14','18:15:00',2.04),('15128','2013-06-14','18:20:00',1.96),('15128','2013-06-14','18:25:00',1.87),('15128','2013-06-14','18:30:00',1.77),('15128','2013-06-14','18:35:00',1.71),('15128','2013-06-14','18:40:00',1.64),('15128','2013-06-14','18:45:00',1.58),('15128','2013-06-14','18:50:00',1.55),('15128','2013-06-14','18:55:00',1.45),('15128','2013-06-14','19:00:00',1.38),('15128','2013-06-14','19:05:00',1.28),('15128','2013-06-14','19:10:00',1.18),('15128','2013-06-14','19:15:00',1.04),('15128','2013-06-13','07:55:00',1.03),('15128','2013-06-13','08:00:00',1.11),('15128','2013-06-13','08:05:00',1.18),('15128','2013-06-13','08:10:00',1.23),('15128','2013-06-13','08:15:00',1.3),('15128','2013-06-13','08:20:00',1.4),('15128','2013-06-13','08:25:00',1.49),('15128','2013-06-13','08:30:00',1.57),('15128','2013-06-13','08:35:00',1.64),('15128','2013-06-13','08:40:00',1.71),('15128','2013-06-13','08:45:00',1.78),('15128','2013-06-13','08:50:00',1.88),('15128','2013-06-13','08:55:00',2),('15128','2013-06-13','09:00:00',2.07),('15128','2013-06-13','09:05:00',2.13),('15128','2013-06-13','09:10:00',2.19),('15128','2013-06-13','09:15:00',2.22),('15128','2013-06-13','09:20:00',2.2),('15128','2013-06-13','09:25:00',2.36),('15128','2013-06-13','09:30:00',2.46),('15128','2013-06-13','09:35:00',2.53),('15128','2013-06-13','09:40:00',2.6),('15128','2013-06-13','09:45:00',2.66),('15128','2013-06-13','09:50:00',2.71),('15128','2013-06-13','09:55:00',2.74),('15128','2013-06-13','10:00:00',2.75),('15128','2013-06-13','10:05:00',2.79),('15128','2013-06-13','10:10:00',2.88),('15128','2013-06-13','10:15:00',2.94),('15128','2013-06-13','10:20:00',2.96),('15128','2013-06-13','10:25:00',3.01),('15128','2013-06-13','10:30:00',2.97),('15128','2013-06-13','10:35:00',3.12),('15128','2013-06-13','10:40:00',3.19),('15128','2013-06-13','10:45:00',3.2),('15128','2013-06-13','10:50:00',3.31),('15128','2013-06-13','10:55:00',3.31),('15128','2013-06-13','11:00:00',3.41),('15128','2013-06-13','11:05:00',3.36),('15128','2013-06-13','11:10:00',3.41),('15128','2013-06-13','11:15:00',3.52),('15128','2013-06-13','11:20:00',3.65),('15128','2013-06-13','11:25:00',3.65),('15128','2013-06-13','11:30:00',3.57),('15128','2013-06-13','11:35:00',3.65),('15128','2013-06-13','11:40:00',3.85),('15128','2013-06-13','11:45:00',3.93),('15128','2013-06-13','11:50:00',4.02),('15128','2013-06-13','11:55:00',4.04),('15128','2013-06-13','12:00:00',4.03),('15128','2013-06-13','12:05:00',4.11),('15128','2013-06-13','12:10:00',4.16),('15128','2013-06-13','12:15:00',4.19),('15128','2013-06-13','12:20:00',4.28),('15128','2013-06-13','12:25:00',4.35),('15128','2013-06-13','12:30:00',4.34),('15128','2013-06-13','12:35:00',4.39),('15128','2013-06-13','12:40:00',4.38),('15128','2013-06-13','12:45:00',4.42),('15128','2013-06-13','12:50:00',4.42),('15128','2013-06-13','12:55:00',4.4),('15128','2013-06-13','13:00:00',4.35),('15128','2013-06-13','13:05:00',4.38),('15128','2013-06-13','13:10:00',4.41),('15128','2013-06-13','13:15:00',4.43),('15128','2013-06-13','13:20:00',4.47),('15128','2013-06-13','13:25:00',4.53),('15128','2013-06-13','13:30:00',4.5),('15128','2013-06-13','13:35:00',4.5),('15128','2013-06-13','13:40:00',4.53),('15128','2013-06-13','13:45:00',4.55),('15128','2013-06-13','13:50:00',4.53),('15128','2013-06-13','13:55:00',4.51),('15128','2013-06-13','14:00:00',4.46),('15128','2013-06-13','14:05:00',4.46),('15128','2013-06-13','14:10:00',4.5),('15128','2013-06-13','14:15:00',4.5),('15128','2013-06-13','14:20:00',4.46),('15128','2013-06-13','14:25:00',4.44),('15128','2013-06-13','14:30:00',4.47),('15128','2013-06-13','14:35:00',4.51),('15128','2013-06-13','14:40:00',4.52),('15128','2013-06-13','14:45:00',4.47),('15128','2013-06-13','14:50:00',4.46),('15128','2013-06-13','14:55:00',4.38),('15128','2013-06-13','15:00:00',4.36),('15128','2013-06-13','15:05:00',4.36),('15128','2013-06-13','15:10:00',4.36),('15128','2013-06-13','15:15:00',4.36),('15128','2013-06-13','15:20:00',4.33),('15128','2013-06-13','15:25:00',4.34),('15128','2013-06-13','15:30:00',4.32),('15128','2013-06-13','15:35:00',4.3),('15128','2013-06-13','15:40:00',4.25),('15128','2013-06-13','15:45:00',4.22),('15128','2013-06-13','15:50:00',4.19),('15128','2013-06-13','15:55:00',4.14),('15128','2013-06-13','16:00:00',4.06),('15128','2013-06-13','16:05:00',4.03),('15128','2013-06-13','16:10:00',4),('15128','2013-06-13','16:15:00',3.95),('15128','2013-06-13','16:20:00',3.9),('15128','2013-06-13','16:25:00',3.85),('15128','2013-06-13','16:30:00',3.8),('15128','2013-06-13','16:35:00',3.75),('15128','2013-06-13','16:40:00',3.68),('15128','2013-06-13','16:45:00',3.63),('15128','2013-06-13','16:50:00',3.56),('15128','2013-06-13','16:55:00',3.48),('15128','2013-06-13','17:00:00',3.43),('15128','2013-06-13','17:05:00',3.18),('15128','2013-06-13','17:10:00',3.24),('15128','2013-06-13','17:15:00',3.18),('15128','2013-06-13','17:20:00',3.11),('15128','2013-06-13','17:25:00',2.98),('15128','2013-06-13','17:30:00',3),('15128','2013-06-13','17:35:00',2.97),('15128','2013-06-13','17:40:00',2.91),('15128','2013-06-13','17:45:00',2.8),('15128','2013-06-13','17:50:00',2.73),('15128','2013-06-13','17:55:00',2.56),('15128','2013-06-13','18:00:00',2.44),('15128','2013-06-13','18:05:00',2.46),('15128','2013-06-13','18:10:00',2.32),('15128','2013-06-13','18:15:00',2.19),('15128','2013-06-13','18:20:00',2.08),('15128','2013-06-13','18:25:00',2.03),('15128','2013-06-13','18:30:00',1.96),('15128','2013-06-13','18:35:00',1.86),('15128','2013-06-13','18:40:00',1.76),('15128','2013-06-13','18:45:00',1.71),('15128','2013-06-13','18:50:00',1.66),('15128','2013-06-13','18:55:00',1.55),('15128','2013-06-13','19:00:00',1.46),('15128','2013-06-13','19:05:00',1.36),('15128','2013-06-13','19:10:00',1.28),('15128','2013-06-13','19:15:00',1.15),('15128','2013-06-12','07:55:00',1.05),('15128','2013-06-12','08:00:00',1.13),('15128','2013-06-12','08:05:00',1.2),('15128','2013-06-12','08:10:00',1.25),('15128','2013-06-12','08:15:00',1.32),('15128','2013-06-12','08:20:00',1.43),('15128','2013-06-12','08:25:00',1.51),('15128','2013-06-12','08:30:00',1.57),('15128','2013-06-12','08:35:00',1.64),('15128','2013-06-12','08:40:00',1.72),('15128','2013-06-12','08:45:00',1.79),('15128','2013-06-12','08:50:00',1.9),('15128','2013-06-12','08:55:00',2.02),('15128','2013-06-12','09:00:00',2.1),('15128','2013-06-12','09:05:00',2.18),('15128','2013-06-12','09:10:00',2.26),('15128','2013-06-12','09:15:00',2.29),('15128','2013-06-12','09:20:00',2.26),('15128','2013-06-12','09:25:00',2.44),('15128','2013-06-12','09:30:00',2.52),('15128','2013-06-12','09:35:00',2.58),('15128','2013-06-12','09:40:00',2.63),('15128','2013-06-12','09:45:00',2.68),('15128','2013-06-12','09:50:00',2.74),('15128','2013-06-12','09:55:00',2.8),('15128','2013-06-12','10:00:00',2.84),('15128','2013-06-12','10:05:00',2.88),('15128','2013-06-12','10:10:00',2.92),('15128','2013-06-12','10:15:00',2.97),('15128','2013-06-12','10:20:00',3.01),('15128','2013-06-12','10:25:00',3.12),('15128','2013-06-12','10:30:00',3.21),('15128','2013-06-12','10:35:00',3.22),('15128','2013-06-12','10:40:00',3.31),('15128','2013-06-12','10:45:00',3.33),('15128','2013-06-12','10:50:00',3.42),('15128','2013-06-12','10:55:00',3.37),('15128','2013-06-12','11:00:00',3.53),('15128','2013-06-12','11:05:00',3.58),('15128','2013-06-12','11:10:00',3.66),('15128','2013-06-12','11:15:00',3.68),('15128','2013-06-12','11:20:00',3.78),('15128','2013-06-12','11:25:00',3.77),('15128','2013-06-12','11:30:00',3.72),('15128','2013-06-12','11:35:00',3.81),('15128','2013-06-12','11:40:00',4),('15128','2013-06-12','11:45:00',4.07),('15128','2013-06-12','11:50:00',4.17),('15128','2013-06-12','11:55:00',4.27),('15128','2013-06-12','12:00:00',4.3),('15128','2013-06-12','12:05:00',4.37),('15128','2013-06-12','12:10:00',4.39),('15128','2013-06-12','12:15:00',4.38),('15128','2013-06-12','12:20:00',4.43),('15128','2013-06-12','12:25:00',4.48),('15128','2013-06-12','12:30:00',4.51),('15128','2013-06-12','12:35:00',4.5),('15128','2013-06-12','12:40:00',4.51),('15128','2013-06-12','12:45:00',4.51),('15128','2013-06-12','12:50:00',4.5),('15128','2013-06-12','12:55:00',4.51),('15128','2013-06-12','13:00:00',4.51),('15128','2013-06-12','13:05:00',4.5),('15128','2013-06-12','13:10:00',4.51),('15128','2013-06-12','13:15:00',4.54),('15128','2013-06-12','13:20:00',4.55),('15128','2013-06-12','13:25:00',4.54),('15128','2013-06-12','13:30:00',4.5),('15128','2013-06-12','13:35:00',4.53),('15128','2013-06-12','13:40:00',4.52),('15128','2013-06-12','13:45:00',4.5),('15128','2013-06-12','13:50:00',4.52),('15128','2013-06-12','13:55:00',4.56),('15128','2013-06-12','14:00:00',4.56),('15128','2013-06-12','14:05:00',4.54),('15128','2013-06-12','14:10:00',4.5),('15128','2013-06-12','14:15:00',4.46),('15128','2013-06-12','14:20:00',4.58),('15128','2013-06-12','14:25:00',2.61),('15128','2013-06-12','14:30:00',4.6),('15128','2013-06-12','14:35:00',4.53),('15128','2013-06-12','14:40:00',4.56),('15128','2013-06-12','14:45:00',4.74),('15128','2013-06-12','14:50:00',3.13),('15128','2013-06-12','14:55:00',4.64),('15128','2013-06-12','15:00:00',2.7),('15128','2013-06-12','15:05:00',2.91),('15128','2013-06-12','15:10:00',4.57),('15128','2013-06-12','15:15:00',4.34),('15128','2013-06-12','15:20:00',4.24),('15128','2013-06-12','15:25:00',4.18),('15128','2013-06-12','15:30:00',4.16),('15128','2013-06-12','15:35:00',4.15),('15128','2013-06-12','15:40:00',4.13),('15128','2013-06-12','15:45:00',4.11),('15128','2013-06-12','15:50:00',4.07),('15128','2013-06-12','15:55:00',3.9),('15128','2013-06-12','16:00:00',3.81),('15128','2013-06-12','16:05:00',3.85),('15128','2013-06-12','16:10:00',3.82),('15128','2013-06-12','16:15:00',3.8),('15128','2013-06-12','16:20:00',3.86),('15128','2013-06-12','16:25:00',3.77),('15128','2013-06-12','16:30:00',3.84),('15128','2013-06-12','16:35:00',3.68),('15128','2013-06-12','16:40:00',3.58),('15128','2013-06-12','16:45:00',3.51),('15128','2013-06-12','16:50:00',3.44),('15128','2013-06-12','16:55:00',3.44),('15128','2013-06-12','17:00:00',3.38),('15128','2013-06-12','17:05:00',3.34),('15128','2013-06-12','17:10:00',3.26),('15128','2013-06-12','17:15:00',3.17),('15128','2013-06-12','17:20:00',3.1),('15128','2013-06-12','17:25:00',3.01),('15128','2013-06-12','17:30:00',2.97),('15128','2013-06-12','17:35:00',2.9),('15128','2013-06-12','17:40:00',2.81),('15128','2013-06-12','17:45:00',2.73),('15128','2013-06-12','17:50:00',2.67),('15128','2013-06-12','17:55:00',2.49),('15128','2013-06-12','18:00:00',2.44),('15128','2013-06-12','18:05:00',2.39),('15128','2013-06-12','18:10:00',2.27),('15128','2013-06-12','18:15:00',2.12),('15128','2013-06-12','18:20:00',2.06),('15128','2013-06-12','18:25:00',1.96),('15128','2013-06-12','18:30:00',1.89),('15128','2013-06-12','18:35:00',1.81),('15128','2013-06-12','18:40:00',1.68),('15128','2013-06-12','18:45:00',1.66),('15128','2013-06-12','18:50:00',1.63),('15128','2013-06-12','18:55:00',1.53),('15128','2013-06-12','19:00:00',1.45),('15128','2013-06-12','19:05:00',1.34),('15128','2013-06-12','19:10:00',1.26),('15128','2013-06-12','19:15:00',1.11),('15128','2013-06-11','07:55:00',1.05),('15128','2013-06-11','08:00:00',1.13),('15128','2013-06-11','08:05:00',1.2),('15128','2013-06-11','08:10:00',1.26),('15128','2013-06-11','08:15:00',1.33),('15128','2013-06-11','08:20:00',1.44),('15128','2013-06-11','08:25:00',1.53),('15128','2013-06-11','08:30:00',1.59),('15128','2013-06-11','08:35:00',1.66),('15128','2013-06-11','08:40:00',1.72),('15128','2013-06-11','08:45:00',1.78),('15128','2013-06-11','08:50:00',1.91),('15128','2013-06-11','08:55:00',2.02),('15128','2013-06-11','09:00:00',2.1),('15128','2013-06-11','09:05:00',2.16),('15128','2013-06-11','09:10:00',2.25),('15128','2013-06-11','09:15:00',2.27),('15128','2013-06-11','09:20:00',2.23),('15128','2013-06-11','09:25:00',2.41),('15128','2013-06-11','09:30:00',2.49),('15128','2013-06-11','09:35:00',2.56),('15128','2013-06-11','09:40:00',2.62),('15128','2013-06-11','09:45:00',2.67),('15128','2013-06-11','09:50:00',2.73),('15128','2013-06-11','09:55:00',2.8),('15128','2013-06-11','10:00:00',2.84),('15128','2013-06-11','10:05:00',2.88),('15128','2013-06-11','10:10:00',2.93),('15128','2013-06-11','10:15:00',2.96),('15128','2013-06-11','10:20:00',2.96),('15128','2013-06-11','10:25:00',3.04),('15128','2013-06-11','10:30:00',3.11),('15128','2013-06-11','10:35:00',3.12),('15128','2013-06-11','10:40:00',3.25),('15128','2013-06-11','10:45:00',3.27),('15128','2013-06-11','10:50:00',3.4),('15128','2013-06-11','10:55:00',3.34),('15128','2013-06-11','11:00:00',3.43),('15128','2013-06-11','11:05:00',3.46),('15128','2013-06-11','11:10:00',3.59),('15128','2013-06-11','11:15:00',3.63),('15128','2013-06-11','11:20:00',3.68),('15128','2013-06-11','11:25:00',3.7),('15128','2013-06-11','11:30:00',3.82),('15128','2013-06-11','11:35:00',3.9),('15128','2013-06-11','11:40:00',3.99),('15128','2013-06-11','11:45:00',4.08),('15128','2013-06-11','11:50:00',4.19),('15128','2013-06-11','11:55:00',4.23),('15128','2013-06-11','12:00:00',4.25),('15128','2013-06-11','12:05:00',4.25),('15128','2013-06-11','12:10:00',4.28),('15128','2013-06-11','12:15:00',4.29),('15128','2013-06-11','12:20:00',4.32),('15128','2013-06-11','12:25:00',4.4),('15128','2013-06-11','12:30:00',4.42),('15128','2013-06-11','12:35:00',4.47),('15128','2013-06-11','12:40:00',4.43),('15128','2013-06-11','12:45:00',4.43),('15128','2013-06-11','12:50:00',4.15),('15128','2013-06-11','12:55:00',4.7),('15128','2013-06-11','13:00:00',4.62),('15128','2013-06-11','13:05:00',4.59),('15128','2013-06-11','13:10:00',4.6),('15128','2013-06-11','13:15:00',4.62),('15128','2013-06-11','13:20:00',4.64),('15128','2013-06-11','13:25:00',4.53),('15128','2013-06-11','13:30:00',4.01),('15128','2013-06-11','13:35:00',4.69),('15128','2013-06-11','13:40:00',3.85),('15128','2013-06-11','13:45:00',4.67),('15128','2013-06-11','13:50:00',4.55),('15128','2013-06-11','13:55:00',4.88),('15128','2013-06-11','14:00:00',4.02),('15128','2013-06-11','14:05:00',4.48),('15128','2013-06-11','14:10:00',4.7),('15128','2013-06-11','14:15:00',4.68),('15128','2013-06-11','14:20:00',4.61),('15128','2013-06-11','14:25:00',4.6),('15128','2013-06-11','14:30:00',4.59),('15128','2013-06-11','14:35:00',4.61),('15128','2013-06-11','14:40:00',4.52),('15128','2013-06-11','14:45:00',4.59),('15128','2013-06-11','14:50:00',4.54),('15128','2013-06-11','14:55:00',4.52),('15128','2013-06-11','15:00:00',4.51),('15128','2013-06-11','15:05:00',4.53),('15128','2013-06-11','15:10:00',4.53),('15128','2013-06-11','15:15:00',4.51),('15128','2013-06-11','15:20:00',4.49),('15128','2013-06-11','15:25:00',4.41),('15128','2013-06-11','15:30:00',4.37),('15128','2013-06-11','15:35:00',4.38),('15128','2013-06-11','15:40:00',4.35),('15128','2013-06-11','15:45:00',4.3),('15128','2013-06-11','15:50:00',4.23),('15128','2013-06-11','15:55:00',4.21),('15128','2013-06-11','16:00:00',4.18),('15128','2013-06-11','16:05:00',4.1),('15128','2013-06-11','16:10:00',4.06),('15128','2013-06-11','16:15:00',4.06),('15128','2013-06-11','16:20:00',3.95),('15128','2013-06-11','16:25:00',4),('15128','2013-06-11','16:30:00',3.95),('15128','2013-06-11','16:35:00',3.9),('15128','2013-06-11','16:40:00',3.98),('15128','2013-06-11','16:45:00',3.85),('15128','2013-06-11','16:50:00',3.72),('15128','2013-06-11','16:55:00',3.6),('15128','2013-06-11','17:00:00',3.57),('15128','2013-06-11','17:05:00',3.53),('15128','2013-06-11','17:10:00',3.42),('15128','2013-06-11','17:15:00',3.36),('15128','2013-06-11','17:20:00',3.26),('15128','2013-06-11','17:25:00',3.25),('15128','2013-06-11','17:30:00',3.32),('15128','2013-06-11','17:35:00',3.2),('15128','2013-06-11','17:40:00',3.29),('15128','2013-06-11','17:45:00',3.09),('15128','2013-06-11','17:50:00',2.99),('15128','2013-06-11','17:55:00',2.92),('15128','2013-06-11','18:00:00',2.44),('15128','2013-06-11','18:05:00',1.74),('15128','2013-06-11','18:10:00',2.41),('15128','2013-06-11','18:15:00',2.24),('15128','2013-06-11','18:20:00',2.15),('15128','2013-06-11','18:25:00',2.07),('15128','2013-06-11','18:30:00',1.98),('15128','2013-06-11','18:35:00',1.87),('15128','2013-06-11','18:40:00',1.73),('15128','2013-06-11','18:45:00',1.67),('15128','2013-06-11','18:50:00',1.62),('15128','2013-06-11','18:55:00',1.51),('15128','2013-06-11','19:00:00',1.4),('15128','2013-06-11','19:05:00',1.31),('15128','2013-06-11','19:10:00',1.21),('15128','2013-06-11','19:15:00',1.06),('15128','2013-06-10','07:55:00',1.03),('15128','2013-06-10','08:00:00',1.1),('15128','2013-06-10','08:05:00',1.18),('15128','2013-06-10','08:10:00',1.23),('15128','2013-06-10','08:15:00',1.3),('15128','2013-06-10','08:20:00',1.41),('15128','2013-06-10','08:25:00',1.49),('15128','2013-06-10','08:30:00',1.55),('15128','2013-06-10','08:35:00',1.62),('15128','2013-06-10','08:40:00',1.69),('15128','2013-06-10','08:45:00',1.79),('15128','2013-06-10','08:50:00',1.9),('15128','2013-06-10','08:55:00',2.01),('15128','2013-06-10','09:00:00',2.09),('15128','2013-06-10','09:05:00',2.18),('15128','2013-06-10','09:10:00',2.27),('15128','2013-06-10','09:15:00',2.25),('15128','2013-06-10','09:20:00',2.29),('15128','2013-06-10','09:25:00',2.41),('15128','2013-06-10','09:30:00',2.49),('15128','2013-06-10','09:35:00',2.53),('15128','2013-06-10','09:40:00',2.6),('15128','2013-06-10','09:45:00',2.71),('15128','2013-06-10','09:50:00',2.16),('15128','2013-06-10','09:55:00',2.58),('15128','2013-06-10','10:00:00',2.89),('15128','2013-06-10','10:05:00',2.97),('15128','2013-06-10','10:10:00',3.01),('15128','2013-06-10','10:15:00',2.3),('15128','2013-06-10','10:20:00',3.24),('15128','2013-06-10','10:25:00',2.35),('15128','2013-06-10','10:30:00',3.43),('15128','2013-06-10','10:35:00',3.43),('15128','2013-06-10','10:40:00',3.41),('15128','2013-06-10','10:45:00',3.6),('15128','2013-06-10','10:50:00',3.79),('15128','2013-06-10','10:55:00',1.5),('15128','2013-06-10','11:00:00',2.82),('15128','2013-06-10','11:05:00',2.8),('15128','2013-06-10','11:10:00',3.78),('15128','2013-06-10','11:15:00',3.77),('15128','2013-06-10','11:20:00',3.85),('15128','2013-06-10','11:25:00',3.8),('15128','2013-06-10','11:30:00',3.73),('15128','2013-06-10','11:35:00',3.85),('15128','2013-06-10','11:40:00',4.07),('15128','2013-06-10','11:45:00',4.13),('15128','2013-06-10','11:50:00',3.36),('15128','2013-06-10','11:55:00',4.38),('15128','2013-06-10','12:00:00',4.38),('15128','2013-06-10','12:05:00',4.4),('15128','2013-06-10','12:10:00',4.5),('15128','2013-06-10','12:15:00',4.54),('15128','2013-06-10','12:20:00',4.48),('15128','2013-06-10','12:25:00',4.51),('15128','2013-06-10','12:30:00',4.52),('15128','2013-06-10','12:35:00',4.59),('15128','2013-06-10','12:40:00',4.6),('15128','2013-06-10','12:45:00',4.64),('15128','2013-06-10','12:50:00',4.64),('15128','2013-06-10','12:55:00',4.66),('15128','2013-06-10','13:00:00',4.8),('15128','2013-06-10','13:05:00',4.82),('15128','2013-06-10','13:10:00',4.82),('15128','2013-06-10','13:15:00',4.75),('15128','2013-06-10','13:20:00',4.76),('15128','2013-06-10','13:25:00',4.75),('15128','2013-06-10','13:30:00',4.75),('15128','2013-06-10','13:35:00',4.83),('15128','2013-06-10','13:40:00',4.84),('15128','2013-06-10','13:45:00',4.84),('15128','2013-06-10','13:50:00',4.52),('15128','2013-06-10','13:55:00',4.76),('15128','2013-06-10','14:00:00',4.75),('15128','2013-06-10','14:05:00',4.74),('15128','2013-06-10','14:10:00',4.75),('15128','2013-06-10','14:15:00',4.73),('15128','2013-06-10','14:20:00',4.71),('15128','2013-06-10','14:25:00',4.7),('15128','2013-06-10','14:30:00',4.66),('15128','2013-06-10','14:35:00',4.71),('15128','2013-06-10','14:40:00',4.65),('15128','2013-06-10','14:45:00',4.64),('15128','2013-06-10','14:50:00',4.49),('15128','2013-06-10','14:55:00',4.54),('15128','2013-06-10','15:00:00',4.59),('15128','2013-06-10','15:05:00',4.58),('15128','2013-06-10','15:10:00',4.51),('15128','2013-06-10','15:15:00',4.5),('15128','2013-06-10','15:20:00',4.46),('15128','2013-06-10','15:25:00',4.29),('15128','2013-06-10','15:30:00',4.45),('15128','2013-06-10','15:35:00',4.57),('15128','2013-06-10','15:40:00',4.44),('15128','2013-06-10','15:45:00',4.34),('15128','2013-06-10','15:50:00',4.25),('15128','2013-06-10','15:55:00',4.28),('15128','2013-06-10','16:00:00',4.23),('15128','2013-06-10','16:05:00',4.15),('15128','2013-06-10','16:10:00',4.09),('15128','2013-06-10','16:15:00',4.04),('15128','2013-06-10','16:20:00',3.98),('15128','2013-06-10','16:25:00',3.93),('15128','2013-06-10','16:30:00',3.91),('15128','2013-06-10','16:35:00',3.95),('15128','2013-06-10','16:40:00',4.04),('15128','2013-06-10','16:45:00',4.08),('15128','2013-06-10','16:50:00',4),('15128','2013-06-10','16:55:00',2.64),('15128','2013-06-10','17:00:00',1.83),('15128','2013-06-10','17:05:00',1.21),('15128','2013-06-10','19:25:00',1.31),('15128','2014-04-02','09:00:00',1.06),('15128','2014-04-02','09:05:00',1.14),('15128','2014-04-02','09:10:00',1.07),('15128','2014-04-02','09:15:00',1.02),('15128','2014-04-02','09:20:00',1.12),('15128','2014-04-02','09:25:00',1.2),('15128','2014-04-02','09:30:00',1.27),('15128','2014-04-02','09:35:00',1.39),('15128','2014-04-02','09:40:00',1.42),('15128','2014-04-02','09:45:00',1.44),('15128','2014-04-02','09:50:00',1.46),('15128','2014-04-02','09:55:00',1.6),('15128','2014-04-02','10:00:00',1.82),('15128','2014-04-02','10:05:00',1.88),('15128','2014-04-02','10:10:00',2.01),('15128','2014-04-02','10:15:00',2.32),('15128','2014-04-02','10:20:00',2.16),('15128','2014-04-02','10:25:00',1.91),('15128','2014-04-02','10:30:00',2.34),('15128','2014-04-02','10:35:00',2.08),('15128','2014-04-02','10:40:00',2.13),('15128','2014-04-02','10:45:00',2.35),('15128','2014-04-02','10:50:00',2.06),('15128','2014-04-02','10:55:00',1.75),('15128','2014-04-02','11:00:00',1.77),('15128','2014-04-02','11:05:00',1.84),('15128','2014-04-02','11:10:00',1.67),('15128','2014-04-02','11:15:00',1.58),('15128','2014-04-02','11:20:00',1.44),('15128','2014-04-02','11:25:00',1.33),('15128','2014-04-02','11:30:00',1.33),('15128','2014-04-02','11:35:00',1.48),('15128','2014-04-02','11:40:00',1.58),('15128','2014-04-02','11:45:00',1.61),('15128','2014-04-02','11:50:00',1.82),('15128','2014-04-02','11:55:00',2.05),('15128','2014-04-02','12:00:00',2.37),('15128','2014-04-02','12:05:00',2.33),('15128','2014-04-02','12:10:00',2.13),('15128','2014-04-02','12:15:00',2.22),('15128','2014-04-02','12:20:00',2.33),('15128','2014-04-02','12:25:00',2.93),('15128','2014-04-02','12:30:00',3.83),('15128','2014-04-02','12:35:00',3.79),('15128','2014-04-02','12:40:00',2.58),('15128','2014-04-02','12:45:00',2.21),('15128','2014-04-02','12:50:00',2.28),('15128','2014-04-02','12:55:00',2.53),('15128','2014-04-02','13:00:00',2.11),('15128','2014-04-02','13:05:00',2.04),('15128','2014-04-02','13:10:00',2.61),('15128','2014-04-02','13:15:00',3.7),('15128','2014-04-02','13:20:00',2.26),('15128','2014-04-02','13:25:00',3.26),('15128','2014-04-02','13:30:00',3.54),('15128','2014-04-02','13:35:00',3.54),('15128','2014-04-02','13:40:00',2.8),('15128','2014-04-02','13:45:00',1.65),('15128','2014-04-02','13:50:00',2.37),('15128','2014-04-02','13:55:00',2.79),('15128','2014-04-02','14:00:00',2.24),('15128','2014-04-02','14:05:00',3.79),('15128','2014-04-02','14:10:00',3.38),('15128','2014-04-02','14:15:00',3.54),('15128','2014-04-02','14:20:00',3.51),('15128','2014-04-02','14:25:00',2.97),('15128','2014-04-02','14:30:00',3.71),('15128','2014-04-02','14:35:00',3.87),('15128','2014-04-02','14:40:00',3.73),('15128','2014-04-02','14:45:00',3.68),('15128','2014-04-02','14:50:00',3.65),('15128','2014-04-02','14:55:00',3.59),('15128','2014-04-02','15:00:00',3.56),('15128','2014-04-02','15:05:00',3.53),('15128','2014-04-02','15:10:00',3.53),('15128','2014-04-02','15:15:00',3.45),('15128','2014-04-02','15:20:00',3.51),('15128','2014-04-02','15:25:00',3.49),('15128','2014-04-02','15:30:00',3.45),('15128','2014-04-02','15:35:00',3.36),('15128','2014-04-02','15:40:00',3.35),('15128','2014-04-02','15:45:00',3.34),('15128','2014-04-02','15:50:00',3.34),('15128','2014-04-02','15:55:00',3.37),('15128','2014-04-02','16:00:00',3.37),('15128','2014-04-02','16:05:00',3.26),('15128','2014-04-02','16:10:00',3.23),('15128','2014-04-02','16:15:00',3.16),('15128','2014-04-02','16:20:00',3.12),('15128','2014-04-02','16:25:00',3.05),('15128','2014-04-02','16:30:00',2.96),('15128','2014-04-02','16:35:00',2.9),('15128','2014-04-02','16:40:00',2.84),('15128','2014-04-02','16:45:00',2.77),('15128','2014-04-02','16:50:00',2.74),('15128','2014-04-02','16:55:00',2.36),('15128','2014-04-02','17:00:00',2.02),('15128','2014-04-02','17:05:00',1.46),('15128','2014-04-02','17:10:00',1.57),('15128','2014-04-02','17:15:00',1.66),('15128','2014-04-02','17:20:00',1.29),('15128','2014-04-02','17:25:00',1.35),('15128','2014-04-02','17:30:00',1.16),('15128','2014-04-02','17:45:00',1.13),('15128','2014-04-02','17:50:00',1.76),('15128','2014-04-02','17:55:00',1.64),('15128','2014-04-02','18:00:00',1.51),('15128','2014-04-02','18:05:00',1.39),('15128','2014-04-02','18:10:00',1.29),('15128','2014-04-02','18:15:00',1.14),('15128','2014-04-02','18:20:00',1.03),('15128','2013-06-09','08:10:00',1.06),('15128','2013-06-09','08:15:00',1.03),('15128','2013-06-09','08:20:00',1.45),('15128','2013-06-09','08:25:00',1.2),('15128','2013-06-09','08:45:00',1.26),('15128','2013-06-09','08:50:00',1.93),('15128','2013-06-09','08:55:00',2),('15128','2013-06-09','09:05:00',1.31),('15128','2013-06-09','09:10:00',1.09),('15128','2013-06-09','09:15:00',2.35),('15128','2013-06-09','09:20:00',2.11),('15128','2013-06-09','09:25:00',2.26),('15128','2013-06-09','09:30:00',1.52),('15128','2013-06-09','09:35:00',1.84),('15128','2013-06-09','09:40:00',2.13),('15128','2013-06-09','09:45:00',1.99),('15128','2013-06-09','09:50:00',1.97),('15128','2013-06-09','09:55:00',1.83),('15128','2013-06-09','10:00:00',1.81),('15128','2013-06-09','10:05:00',2.03),('15128','2013-06-09','10:10:00',2.34),('15128','2013-06-09','10:15:00',2.07),('15128','2013-06-09','10:20:00',1.67),('15128','2013-06-09','10:25:00',2.69),('15128','2013-06-09','10:30:00',2.13),('15128','2013-06-09','10:35:00',2.65),('15128','2013-06-09','10:40:00',3.58),('15128','2013-06-09','10:45:00',3.23),('15128','2013-06-09','10:50:00',1.51),('15128','2013-06-09','10:55:00',3.22),('15128','2013-06-09','11:00:00',3.43),('15128','2013-06-09','11:05:00',2.81),('15128','2013-06-09','11:10:00',3.97),('15128','2013-06-09','11:15:00',3.89),('15128','2013-06-09','11:20:00',4.6),('15128','2013-06-09','11:25:00',2.9),('15128','2013-06-09','11:30:00',1.44),('15128','2013-06-09','11:35:00',1.43),('15128','2013-06-09','11:40:00',3.46),('15128','2013-06-09','11:45:00',3.58),('15128','2013-06-09','11:50:00',2.59),('15128','2013-06-09','11:55:00',4.58),('15128','2013-06-09','12:00:00',2.85),('15128','2013-06-09','12:05:00',4.38),('15128','2013-06-09','12:10:00',3.64),('15128','2013-06-09','12:15:00',4.72),('15128','2013-06-09','12:20:00',4.59),('15128','2013-06-09','12:25:00',2.81),('15128','2013-06-09','12:30:00',2.44),('15128','2013-06-09','12:35:00',3.79),('15128','2013-06-09','12:40:00',2.14),('15128','2013-06-09','12:45:00',4.93),('15128','2013-06-09','12:50:00',5.03),('15128','2013-06-09','12:55:00',4.8),('15128','2013-06-09','13:00:00',2.32),('15128','2013-06-09','13:05:00',2.3),('15128','2013-06-09','13:10:00',2.96),('15128','2013-06-09','13:15:00',3.17),('15128','2013-06-09','13:20:00',4.66),('15128','2013-06-09','13:25:00',1.58),('15128','2013-06-09','13:30:00',1.35),('15128','2013-06-09','13:35:00',1.24),('15128','2013-06-09','13:40:00',2.3),('15128','2013-06-09','13:45:00',2.02),('15128','2013-06-09','13:50:00',3.84),('15128','2013-06-09','13:55:00',4.21),('15128','2013-06-09','14:00:00',5.08),('15128','2013-06-09','14:05:00',3.45),('15128','2013-06-09','14:10:00',3.23),('15128','2013-06-09','14:15:00',4.97),('15128','2013-06-09','14:20:00',4.94),('15128','2013-06-09','14:25:00',4.73),('15128','2013-06-09','14:30:00',4.75),('15128','2013-06-09','14:35:00',4.74),('15128','2013-06-09','14:40:00',4.71),('15128','2013-06-09','14:45:00',4.69),('15128','2013-06-09','14:50:00',4.67),('15128','2013-06-09','14:55:00',4.64),('15128','2013-06-09','15:00:00',4.62),('15128','2013-06-09','15:05:00',4.59),('15128','2013-06-09','15:10:00',4.58),('15128','2013-06-09','15:15:00',4.57),('15128','2013-06-09','15:20:00',4.57),('15128','2013-06-09','15:25:00',4.52),('15128','2013-06-09','15:30:00',4.49),('15128','2013-06-09','15:35:00',4.47),('15128','2013-06-09','15:40:00',4.45),('15128','2013-06-09','15:45:00',4.4),('15128','2013-06-09','15:50:00',4.33),('15128','2013-06-09','15:55:00',4.29),('15128','2013-06-09','16:00:00',4.24),('15128','2013-06-09','16:05:00',4.21),('15128','2013-06-09','16:10:00',4.16),('15128','2013-06-09','16:15:00',4.12),('15128','2013-06-09','16:20:00',4.08),('15128','2013-06-09','16:25:00',4.05),('15128','2013-06-09','16:30:00',3.98),('15128','2013-06-09','16:35:00',3.94),('15128','2013-06-09','16:40:00',3.85),('15128','2013-06-09','16:45:00',3.79),('15128','2013-06-09','16:50:00',3.74),('15128','2013-06-09','16:55:00',3.7),('15128','2013-06-09','17:00:00',3.63),('15128','2013-06-09','17:05:00',3.56),('15128','2013-06-09','17:10:00',3.5),('15128','2013-06-09','17:15:00',3.45),('15128','2013-06-09','17:20:00',3.37),('15128','2013-06-09','17:25:00',3.29),('15128','2013-06-09','17:30:00',3.24),('15128','2013-06-09','17:35:00',3.1),('15128','2013-06-09','17:40:00',3.06),('15128','2013-06-09','17:45:00',2.99),('15128','2013-06-09','17:50:00',2.92),('15128','2013-06-09','17:55:00',2.75),('15128','2013-06-09','18:00:00',2.66),('15128','2013-06-09','18:05:00',2.56),('15128','2013-06-09','18:10:00',2.45),('15128','2013-06-09','18:15:00',2.35),('15128','2013-06-09','18:20:00',2.24),('15128','2013-06-09','18:25:00',2.13),('15128','2013-06-09','18:30:00',2.02),('15128','2013-06-09','18:35:00',1.94),('15128','2013-06-09','18:40:00',1.84),('15128','2013-06-09','18:45:00',1.77),('15128','2013-06-09','18:50:00',1.73),('15128','2013-06-09','18:55:00',1.63),('15128','2013-06-09','19:00:00',1.54),('15128','2013-06-09','19:05:00',1.43),('15128','2013-06-09','19:10:00',1.35),('15128','2013-06-09','19:15:00',1.17),('15128','2013-06-08','08:10:00',1.13),('15128','2013-06-08','08:15:00',1.29),('15128','2013-06-08','08:20:00',1.43),('15128','2013-06-08','08:25:00',1.49),('15128','2013-06-08','08:30:00',1.51),('15128','2013-06-08','08:35:00',1.6),('15128','2013-06-08','08:40:00',1.68),('15128','2013-06-08','08:45:00',1.67),('15128','2013-06-08','08:50:00',1.84),('15128','2013-06-08','08:55:00',1.93),('15128','2013-06-08','09:00:00',1.98),('15128','2013-06-08','09:05:00',2.11),('15128','2013-06-08','09:10:00',2.16),('15128','2013-06-08','09:15:00',2.11),('15128','2013-06-08','09:20:00',2.16),('15128','2013-06-08','09:25:00',2.31),('15128','2013-06-08','09:30:00',2.39),('15128','2013-06-08','09:35:00',2.46),('15128','2013-06-08','09:40:00',2.55),('15128','2013-06-08','09:45:00',2.59),('15128','2013-06-08','09:50:00',2.67),('15128','2013-06-08','09:55:00',2.7),('15128','2013-06-08','10:00:00',2.74),('15128','2013-06-08','10:05:00',2.81),('15128','2013-06-08','10:10:00',2.87),('15128','2013-06-08','10:15:00',2.93),('15128','2013-06-08','10:20:00',2.97),('15128','2013-06-08','10:25:00',3.01),('15128','2013-06-08','10:30:00',3.06),('15128','2013-06-08','10:35:00',3.06),('15128','2013-06-08','10:40:00',3.18),('15128','2013-06-08','10:45:00',3.25),('15128','2013-06-08','10:50:00',3.27),('15128','2013-06-08','10:55:00',3.26),('15128','2013-06-08','11:00:00',3.34),('15128','2013-06-08','11:05:00',3.34),('15128','2013-06-08','11:10:00',3.5),('15128','2013-06-08','11:15:00',3.53),('15128','2013-06-08','11:20:00',3.63),('15128','2013-06-08','11:25:00',3.58),('15128','2013-06-08','11:30:00',3.57),('15128','2013-06-08','11:35:00',3.7),('15128','2013-06-08','11:40:00',3.86),('15128','2013-06-08','11:45:00',3.89),('15128','2013-06-08','11:50:00',3.96),('15128','2013-06-08','11:55:00',4.02),('15128','2013-06-08','12:00:00',4.03),('15128','2013-06-08','12:05:00',3.92),('15128','2013-06-08','12:10:00',4.09),('15128','2013-06-08','12:15:00',4),('15128','2013-06-08','12:20:00',3.89),('15128','2013-06-08','12:25:00',4.15),('15128','2013-06-08','12:30:00',4.24),('15128','2013-06-08','12:35:00',4.23),('15128','2013-06-08','12:40:00',4.37),('15128','2013-06-08','12:45:00',4.18),('15128','2013-06-08','12:50:00',4.45),('15128','2013-06-08','12:55:00',4.42),('15128','2013-06-08','13:00:00',4.3),('15128','2013-06-08','13:05:00',4.31),('15128','2013-06-08','13:10:00',4.21),('15128','2013-06-08','13:15:00',4.56),('15128','2013-06-08','13:20:00',4.6),('15128','2013-06-08','13:25:00',4.53),('15128','2013-06-08','13:30:00',4.79),('15128','2013-06-08','13:35:00',2.63),('15128','2013-06-08','13:40:00',3.96),('15128','2013-06-08','13:45:00',4.12),('15128','2013-06-08','13:50:00',4.33),('15128','2013-06-08','13:55:00',4.88),('15128','2013-06-08','14:00:00',4.75),('15128','2013-06-08','14:05:00',4.88),('15128','2013-06-08','14:10:00',4.9),('15128','2013-06-08','14:15:00',3.94),('15128','2013-06-08','14:20:00',1.76),('15128','2013-06-08','14:25:00',1.31),('15128','2013-06-08','14:30:00',1.56),('15128','2013-06-08','14:35:00',3.5),('15128','2013-06-08','14:40:00',5.41),('15128','2013-06-08','14:45:00',4.12),('15128','2013-06-08','14:50:00',4.03),('15128','2013-06-08','14:55:00',4.78),('15128','2013-06-08','15:00:00',4.6),('15128','2013-06-08','15:05:00',4.62),('15128','2013-06-08','15:10:00',4.59),('15128','2013-06-08','15:15:00',4.39),('15128','2013-06-08','15:20:00',4.37),('15128','2013-06-08','15:25:00',4.32),('15128','2013-06-08','15:30:00',4.39),('15128','2013-06-08','15:35:00',4.44),('15128','2013-06-08','15:40:00',3.92),('15128','2013-06-08','15:45:00',3.27),('15128','2013-06-08','15:50:00',4.07),('15128','2013-06-08','15:55:00',4.46),('15128','2013-06-08','16:00:00',4.06),('15128','2013-06-08','16:05:00',3.96),('15128','2013-06-08','16:10:00',3.23),('15128','2013-06-08','16:15:00',3.46),('15128','2013-06-08','16:20:00',2.13),('15128','2013-06-08','16:25:00',2.85),('15128','2013-06-08','16:30:00',1.24),('15128','2013-06-08','16:35:00',1.24),('15128','2013-06-08','16:40:00',1.1),('15128','2013-06-08','16:45:00',1.14),('15128','2013-06-08','16:50:00',1.12),('15128','2013-06-08','16:55:00',1.13),('15128','2013-06-08','17:00:00',1.25),('15128','2013-06-08','17:05:00',1.11),('15128','2013-06-08','17:10:00',1.15),('15128','2013-06-08','18:00:00',1.29),('15128','2013-06-08','18:05:00',2.42),('15128','2013-06-08','18:10:00',1.75),('15128','2013-06-07','07:55:00',1.01),('15128','2013-06-07','08:00:00',1.09),('15128','2013-06-07','08:05:00',1.16),('15128','2013-06-07','08:10:00',1.22),('15128','2013-06-07','08:15:00',1.29),('15128','2013-06-07','08:20:00',1.4),('15128','2013-06-07','08:25:00',1.47),('15128','2013-06-07','08:30:00',1.51),('15128','2013-06-07','08:35:00',1.6),('15128','2013-06-07','08:40:00',1.68),('15128','2013-06-07','08:45:00',1.75),('15128','2013-06-07','08:50:00',1.85),('15128','2013-06-07','08:55:00',1.96),('15128','2013-06-07','09:00:00',2.04),('15128','2013-06-07','09:05:00',2.11),('15128','2013-06-07','09:10:00',2.16),('15128','2013-06-07','09:15:00',2.24),('15128','2013-06-07','09:20:00',2.3),('15128','2013-06-07','09:25:00',2.35),('15128','2013-06-07','09:30:00',2.41),('15128','2013-06-07','09:35:00',2.48),('15128','2013-06-07','09:40:00',2.52),('15128','2013-06-07','09:45:00',2.62),('15128','2013-06-07','09:50:00',2.43),('15128','2013-06-07','09:55:00',2.86),('15128','2013-06-07','10:00:00',3.16),('15128','2013-06-07','10:05:00',1.65),('15128','2013-06-07','10:10:00',3.09),('15128','2013-06-07','10:15:00',2.87),('15128','2013-06-07','10:25:00',2.6),('15128','2013-06-07','10:30:00',3.33),('15128','2013-06-07','10:35:00',3.35),('15128','2013-06-07','10:40:00',3.35),('15128','2013-06-07','10:45:00',3.41),('15128','2013-06-07','10:50:00',3.58),('15128','2013-06-07','10:55:00',2.21),('15128','2013-06-07','11:00:00',3.52),('15128','2013-06-07','11:05:00',3.94),('15128','2013-06-07','11:10:00',4.1),('15128','2013-06-07','11:15:00',4.15),('15128','2013-06-07','11:20:00',2.4),('15128','2013-06-07','11:25:00',2.87),('15128','2013-06-07','11:30:00',4),('15128','2013-06-07','11:35:00',4.18),('15128','2013-06-07','11:40:00',4.22),('15128','2013-06-07','11:45:00',4.25),('15128','2013-06-07','11:50:00',4.32),('15128','2013-06-07','11:55:00',4.05),('15128','2013-06-07','12:00:00',4.56),('15128','2013-06-07','12:05:00',4.58),('15128','2013-06-07','12:10:00',3.33),('15128','2013-06-07','12:15:00',4.52),('15128','2013-06-07','12:20:00',4.21),('15128','2013-06-07','12:25:00',4.34),('15128','2013-06-07','12:30:00',4.33),('15128','2013-06-07','12:35:00',4.27),('15128','2013-06-07','12:40:00',4.24),('15128','2013-06-07','12:45:00',4.42),('15128','2013-06-07','12:50:00',4.56),('15128','2013-06-07','12:55:00',4.56),('15128','2013-06-07','13:00:00',4.54),('15128','2013-06-07','13:05:00',4.52),('15128','2013-06-07','13:10:00',4.52),('15128','2013-06-07','13:15:00',4.52),('15128','2013-06-07','13:20:00',4.59),('15128','2013-06-07','13:25:00',4.67),('15128','2013-06-07','13:30:00',4.6),('15128','2013-06-07','13:35:00',4.61),('15128','2013-06-07','13:40:00',4.61),('15128','2013-06-07','13:45:00',4.55),('15128','2013-06-07','13:50:00',4.61),('15128','2013-06-07','13:55:00',4.64),('15128','2013-06-07','14:00:00',4.71),('15128','2013-06-07','14:05:00',4.65),('15128','2013-06-07','14:10:00',4.68),('15128','2013-06-07','14:15:00',4.66),('15128','2013-06-07','14:20:00',4.67),('15128','2013-06-07','14:25:00',4.68),('15128','2013-06-07','14:30:00',4.63),('15128','2013-06-07','14:35:00',4.63),('15128','2013-06-07','14:40:00',4.62),('15128','2013-06-07','14:45:00',4.64),('15128','2013-06-07','14:50:00',4.59),('15128','2013-06-07','14:55:00',4.6),('15128','2013-06-07','15:00:00',4.5),('15128','2013-06-07','15:05:00',4.41),('15128','2013-06-07','15:10:00',4.54),('15128','2013-06-07','15:15:00',4.56),('15128','2013-06-07','15:20:00',4.43),('15128','2013-06-07','15:25:00',4.51),('15128','2013-06-07','15:30:00',4.52),('15128','2013-06-07','15:35:00',4.52),('15128','2013-06-07','15:40:00',4.4),('15128','2013-06-07','15:45:00',4.5),('15128','2013-06-07','15:50:00',4.4),('15128','2013-06-07','15:55:00',4.3),('15128','2013-06-07','16:00:00',4.24),('15128','2013-06-07','16:05:00',3.78),('15128','2013-06-07','16:10:00',4.35),('15128','2013-06-07','16:15:00',4.14),('15128','2013-06-07','16:20:00',3.91),('15128','2013-06-07','16:25:00',3.97),('15128','2013-06-07','16:30:00',3.88),('15128','2013-06-07','16:35:00',3.83),('15128','2013-06-07','16:40:00',3.78),('15128','2013-06-07','16:45:00',3.44),('15128','2013-06-07','16:50:00',3.39),('15128','2013-06-07','16:55:00',3.28),('15128','2013-06-07','17:00:00',1.65),('15128','2013-06-07','17:05:00',3.74),('15128','2013-06-07','17:10:00',3.92),('15128','2013-06-07','17:15:00',3.72),('15128','2013-06-07','17:20:00',3.36),('15128','2013-06-07','17:25:00',1.25),('15128','2013-06-07','17:30:00',1),('15128','2013-06-07','17:35:00',1.96),('15128','2013-06-07','17:40:00',2.94),('15128','2013-06-07','17:45:00',2.67),('15128','2013-06-07','17:50:00',2.9),('15128','2013-06-07','17:55:00',2.31),('15128','2013-06-07','18:00:00',2.06),('15128','2013-06-07','18:05:00',1.6),('15128','2013-06-07','18:10:00',1.52),('15128','2013-06-07','18:15:00',1.56),('15128','2013-06-07','18:20:00',1.21),('15128','2013-06-06','07:55:00',1.07),('15128','2013-06-06','08:00:00',1.14),('15128','2013-06-06','08:05:00',1.22),('15128','2013-06-06','08:10:00',1.28),('15128','2013-06-06','08:15:00',1.35),('15128','2013-06-06','08:20:00',1.46),('15128','2013-06-06','08:25:00',1.54),('15128','2013-06-06','08:30:00',1.57),('15128','2013-06-06','08:35:00',1.68),('15128','2013-06-06','08:40:00',1.76),('15128','2013-06-06','08:45:00',1.85),('15128','2013-06-06','08:50:00',1.96),('15128','2013-06-06','08:55:00',2.07),('15128','2013-06-06','09:00:00',2.14),('15128','2013-06-06','09:05:00',2.22),('15128','2013-06-06','09:10:00',2.3),('15128','2013-06-06','09:15:00',2.33),('15128','2013-06-06','09:20:00',2.3),('15128','2013-06-06','09:25:00',2.48),('15128','2013-06-06','09:30:00',2.56),('15128','2013-06-06','09:35:00',2.62),('15128','2013-06-06','09:40:00',2.68),('15128','2013-06-06','09:45:00',2.71),('15128','2013-06-06','09:50:00',2.78),('15128','2013-06-06','09:55:00',2.84),('15128','2013-06-06','10:00:00',2.9),('15128','2013-06-06','10:05:00',2.97),('15128','2013-06-06','10:10:00',2.99),('15128','2013-06-06','10:15:00',3.03),('15128','2013-06-06','10:20:00',3.06),('15128','2013-06-06','10:25:00',3.1),('15128','2013-06-06','10:30:00',3.2),('15128','2013-06-06','10:35:00',3.23),('15128','2013-06-06','10:40:00',3.32),('15128','2013-06-06','10:45:00',3.35),('15128','2013-06-06','10:50:00',3.41),('15128','2013-06-06','10:55:00',3.42),('15128','2013-06-06','11:00:00',3.53),('15128','2013-06-06','11:05:00',3.5),('15128','2013-06-06','11:10:00',3.65),('15128','2013-06-06','11:15:00',3.71),('15128','2013-06-06','11:20:00',3.81),('15128','2013-06-06','11:25:00',3.74),('15128','2013-06-06','11:30:00',3.68),('15128','2013-06-06','11:35:00',3.82),('15128','2013-06-06','11:40:00',4.02),('15128','2013-06-06','11:45:00',4.08),('15128','2013-06-06','11:50:00',4.24),('15128','2013-06-06','11:55:00',4.28),('15128','2013-06-06','12:00:00',4.32),('15128','2013-06-06','12:05:00',4.38),('15128','2013-06-06','12:10:00',4.38),('15128','2013-06-06','12:15:00',4.38),('15128','2013-06-06','12:20:00',4.38),('15128','2013-06-06','12:25:00',4.41),('15128','2013-06-06','12:30:00',4.41),('15128','2013-06-06','12:35:00',4.43),('15128','2013-06-06','12:40:00',4.46),('15128','2013-06-06','12:45:00',4.49),('15128','2013-06-06','12:50:00',4.5),('15128','2013-06-06','12:55:00',4.5),('15128','2013-06-06','13:00:00',4.54),('15128','2013-06-06','13:05:00',4.56),('15128','2013-06-06','13:10:00',4.57),('15128','2013-06-06','13:15:00',4.54),('15128','2013-06-06','13:20:00',4.52),('15128','2013-06-06','13:25:00',4.53),('15128','2013-06-06','13:30:00',4.58),('15128','2013-06-06','13:35:00',4.57),('15128','2013-06-06','13:40:00',4.56),('15128','2013-06-06','13:45:00',4.55),('15128','2013-06-06','13:50:00',4.52),('15128','2013-06-06','13:55:00',4.5),('15128','2013-06-06','14:00:00',4.51),('15128','2013-06-06','14:05:00',4.53),('15128','2013-06-06','14:10:00',4.51),('15128','2013-06-06','14:15:00',4.5),('15128','2013-06-06','14:20:00',4.52),('15128','2013-06-06','14:25:00',4.51),('15128','2013-06-06','14:30:00',4.5),('15128','2013-06-06','14:35:00',4.49),('15128','2013-06-06','14:40:00',4.47),('15128','2013-06-06','14:45:00',4.44),('15128','2013-06-06','14:50:00',4.46),('15128','2013-06-06','14:55:00',4.49),('15128','2013-06-06','15:00:00',4.43),('15128','2013-06-06','15:05:00',4.44),('15128','2013-06-06','15:10:00',4.44),('15128','2013-06-06','15:15:00',4.43),('15128','2013-06-06','15:20:00',4.42),('15128','2013-06-06','15:25:00',4.39),('15128','2013-06-06','15:30:00',4.37),('15128','2013-06-06','15:35:00',4.36),('15128','2013-06-06','15:40:00',4.32),('15128','2013-06-06','15:45:00',4.28),('15128','2013-06-06','15:50:00',4.25),('15128','2013-06-06','15:55:00',4.23),('15128','2013-06-06','16:00:00',4.21),('15128','2013-06-06','16:05:00',4.17),('15128','2013-06-06','16:10:00',4.11),('15128','2013-06-06','16:15:00',4.03),('15128','2013-06-06','16:20:00',3.98),('15128','2013-06-06','16:25:00',3.94),('15128','2013-06-06','16:30:00',3.9),('15128','2013-06-06','16:35:00',3.83),('15128','2013-06-06','16:40:00',3.77),('15128','2013-06-06','16:45:00',3.72),('15128','2013-06-06','16:50:00',3.67),('15128','2013-06-06','16:55:00',3.6),('15128','2013-06-06','17:00:00',3.55),('15128','2013-06-06','17:05:00',3.48),('15128','2013-06-06','17:10:00',3.41),('15128','2013-06-06','17:15:00',3.34),('15128','2013-06-06','17:20:00',3.25),('15128','2013-06-06','17:25:00',3.21),('15128','2013-06-06','17:30:00',3.16),('15128','2013-06-06','17:35:00',3.17),('15128','2013-06-06','17:40:00',3.19),('15128','2013-06-06','17:45:00',3.21),('15128','2013-06-06','17:50:00',2.94),('15128','2013-06-06','17:55:00',2.18),('15128','2013-06-06','18:00:00',2.64),('15128','2013-06-06','18:05:00',2.56),('15128','2013-06-06','18:10:00',1.55),('15128','2013-06-06','18:15:00',2.16),('15128','2013-06-06','18:20:00',2.07),('15128','2013-06-06','18:25:00',1.88),('15128','2013-06-06','18:30:00',1.81),('15128','2013-06-06','18:35:00',1.76),('15128','2013-06-06','18:40:00',1.68),('15128','2013-06-06','18:45:00',1.63),('15128','2013-06-06','18:50:00',1.63),('15128','2013-06-06','18:55:00',1.57),('15128','2013-06-06','19:00:00',1.5),('15128','2013-06-06','19:05:00',1.17),('15128','2013-06-06','19:15:00',1.02),('15128','2013-06-05','07:50:00',1.08),('15128','2013-06-05','07:55:00',1.06),('15128','2013-06-05','08:00:00',1.17),('15128','2013-06-05','08:10:00',1.12),('15128','2013-06-05','08:15:00',1.28),('15128','2013-06-05','08:20:00',1.43),('15128','2013-06-05','08:25:00',1.51),('15128','2013-06-05','08:30:00',1.54),('15128','2013-06-05','08:35:00',1.61),('15128','2013-06-05','08:40:00',1.72),('15128','2013-06-05','08:45:00',1.8),('15128','2013-06-05','08:50:00',1.85),('15128','2013-06-05','08:55:00',2.04),('15128','2013-06-05','09:00:00',2.06),('15128','2013-06-05','09:05:00',2.16),('15128','2013-06-05','09:10:00',2.14),('15128','2013-06-05','09:15:00',2.29),('15128','2013-06-05','09:20:00',2.23),('15128','2013-06-05','09:25:00',2.46),('15128','2013-06-05','09:30:00',2.52),('15128','2013-06-05','09:35:00',2.57),('15128','2013-06-05','09:40:00',2.66),('15128','2013-06-05','09:45:00',2.73),('15128','2013-06-05','09:50:00',2.75),('15128','2013-06-05','09:55:00',2.77),('15128','2013-06-05','10:00:00',2.81),('15128','2013-06-05','10:05:00',2.75),('15128','2013-06-05','10:10:00',2.84),('15128','2013-06-05','10:15:00',2.93),('15128','2013-06-05','10:20:00',3.02),('15128','2013-06-05','10:25:00',3.11),('15128','2013-06-05','10:30:00',3.2),('15128','2013-06-05','10:35:00',3.18),('15128','2013-06-05','10:40:00',3.25),('15128','2013-06-05','10:45:00',3.34),('15128','2013-06-05','10:50:00',3.38),('15128','2013-06-05','10:55:00',3.44),('15128','2013-06-05','11:00:00',3.57),('15128','2013-06-05','11:05:00',3.58),('15128','2013-06-05','11:10:00',3.67),('15128','2013-06-05','11:15:00',3.33),('15128','2013-06-05','11:20:00',3.76),('15128','2013-06-05','11:25:00',3.74),('15128','2013-06-05','11:30:00',3.7),('15128','2013-06-05','11:35:00',3.82),('15128','2013-06-05','11:40:00',4),('15128','2013-06-05','11:45:00',4.06),('15128','2013-06-05','11:50:00',4.14),('15128','2013-06-05','11:55:00',4.06),('15128','2013-06-05','12:00:00',4.24),('15128','2013-06-05','12:05:00',4.25),('15128','2013-06-05','12:10:00',4.33),('15128','2013-06-05','12:15:00',4.35),('15128','2013-06-05','12:20:00',4.35),('15128','2013-06-05','12:25:00',4.35),('15128','2013-06-05','12:30:00',4.38),('15128','2013-06-05','12:35:00',4.36),('15128','2013-06-05','12:40:00',4.38),('15128','2013-06-05','12:45:00',4.4),('15128','2013-06-05','12:50:00',4.49),('15128','2013-06-05','12:55:00',4.52),('15128','2013-06-05','13:00:00',4.52),('15128','2013-06-05','13:05:00',4.63),('15128','2013-06-05','13:10:00',4.58),('15128','2013-06-05','13:15:00',4.62),('15128','2013-06-05','13:20:00',3.67),('15128','2013-06-05','13:25:00',4.58),('15128','2013-06-05','13:30:00',4.45),('15128','2013-06-05','13:35:00',4.75),('15128','2013-06-05','13:40:00',4.61),('15128','2013-06-05','13:45:00',4.65),('15128','2013-06-05','13:50:00',4.6),('15128','2013-06-05','13:55:00',4.57),('15128','2013-06-05','14:00:00',4.55),('15128','2013-06-05','14:05:00',4.63),('15128','2013-06-05','14:10:00',4.68),('15128','2013-06-05','14:15:00',4.64),('15128','2013-06-05','14:20:00',4.63),('15128','2013-06-05','14:25:00',4.61),('15128','2013-06-05','14:30:00',4.57),('15128','2013-06-05','14:35:00',4.51),('15128','2013-06-05','14:40:00',4.49),('15128','2013-06-05','14:45:00',4.48),('15128','2013-06-05','14:50:00',4.45),('15128','2013-06-05','14:55:00',4.47),('15128','2013-06-05','15:00:00',4.42),('15128','2013-06-05','15:05:00',4.42),('15128','2013-06-05','15:10:00',4.37),('15128','2013-06-05','15:15:00',4.29),('15128','2013-06-05','15:20:00',4.29),('15128','2013-06-05','15:25:00',4.31),('15128','2013-06-05','15:30:00',4.26),('15128','2013-06-05','15:40:00',4.1),('15128','2013-06-05','15:45:00',4.1),('15128','2013-06-05','15:50:00',4.03),('15128','2013-06-05','15:55:00',4.02),('15128','2013-06-05','16:00:00',4.01),('15128','2013-06-05','16:05:00',3.94),('15128','2013-06-05','16:10:00',3.9),('15128','2013-06-05','16:15:00',3.89),('15128','2013-06-05','16:20:00',3.82),('15128','2013-06-05','16:25:00',3.82),('15128','2013-06-05','16:30:00',3.74),('15128','2013-06-05','16:35:00',3.69),('15128','2013-06-05','16:40:00',3.62),('15128','2013-06-05','16:45:00',3.57),('15128','2013-06-05','16:50:00',3.5),('15128','2013-06-05','16:55:00',3.42),('15128','2013-06-05','17:00:00',3.36),('15128','2013-06-05','17:05:00',3.29),('15128','2013-06-05','17:10:00',3.2),('15128','2013-06-05','17:15:00',3.15),('15128','2013-06-05','17:20:00',3.1),('15128','2013-06-05','17:25:00',2.95),('15128','2013-06-05','17:30:00',2.86),('15128','2013-06-05','17:35:00',2.81),('15128','2013-06-05','17:40:00',2.77),('15128','2013-06-05','17:45:00',2.72),('15128','2013-06-05','17:50:00',2.66),('15128','2013-06-05','17:55:00',2.53),('15128','2013-06-05','18:00:00',2.38),('15128','2013-06-05','18:05:00',2.23),('15128','2013-06-05','18:10:00',2.16),('15128','2013-06-05','18:15:00',2.05),('15128','2013-06-05','18:20:00',1.98),('15128','2013-06-05','18:25:00',1.85),('15128','2013-06-05','18:30:00',1.77),('15128','2013-06-05','18:35:00',1.7),('15128','2013-06-05','18:40:00',1.62),('15128','2013-06-05','18:45:00',1.58),('15128','2013-06-05','18:50:00',1.52),('15128','2013-06-05','18:55:00',1.41),('15128','2013-06-05','19:00:00',1.29),('15128','2013-06-05','19:05:00',1.16),('15128','2013-06-05','19:10:00',1.07),('15128','2013-06-04','07:55:00',1.05),('15128','2013-06-04','08:00:00',1.11),('15128','2013-06-04','08:05:00',1.15),('15128','2013-06-04','08:10:00',1.26),('15128','2013-06-04','08:15:00',1.33),('15128','2013-06-04','08:20:00',1.43),('15128','2013-06-04','08:25:00',1.5),('15128','2013-06-04','08:30:00',1.53),('15128','2013-06-04','08:35:00',1.59),('15128','2013-06-04','08:40:00',1.71),('15128','2013-06-04','08:45:00',1.79),('15128','2013-06-04','08:50:00',1.88),('15128','2013-06-04','08:55:00',1.98),('15128','2013-06-04','09:00:00',2.04),('15128','2013-06-04','09:05:00',2.3),('15128','2013-06-04','09:10:00',2.04),('15128','2013-06-04','09:15:00',2.28),('15128','2013-06-04','09:20:00',1.99),('15128','2013-06-04','09:25:00',1.78),('15128','2013-06-04','09:30:00',1.63),('15128','2013-06-04','09:35:00',1.33),('15128','2013-06-04','09:40:00',1.24),('15128','2013-06-04','09:45:00',2.06),('15128','2013-06-04','09:50:00',3.34),('15128','2013-06-04','09:55:00',3.27),('15128','2013-06-04','10:00:00',2.38),('15128','2013-06-04','10:05:00',1.14),('15128','2013-06-04','10:10:00',1.04),('15128','2013-06-04','10:25:00',2.49),('15128','2013-06-04','10:30:00',3.61),('15128','2013-06-04','10:35:00',3.59),('15128','2013-06-04','10:40:00',3.72),('15128','2013-06-04','10:45:00',3.48),('15128','2013-06-04','10:50:00',2.87),('15128','2013-06-04','10:55:00',3),('15128','2013-06-04','11:00:00',4.49),('15128','2013-06-04','11:05:00',3.66),('15128','2013-06-04','11:10:00',4.61),('15128','2013-06-04','11:15:00',2.26),('15128','2013-06-04','11:20:00',4.41),('15128','2013-06-04','11:25:00',3.19),('15128','2013-06-04','11:30:00',2.3),('15128','2013-06-04','11:35:00',1.22),('15128','2013-06-04','11:40:00',2.12),('15128','2013-06-04','11:45:00',4.06),('15128','2013-06-04','11:50:00',4.68),('15128','2013-06-04','11:55:00',1.47),('15128','2013-06-04','12:00:00',2.87),('15128','2013-06-04','12:05:00',4.98),('15128','2013-06-04','12:10:00',3.98),('15128','2013-06-04','12:15:00',2.41),('15128','2013-06-04','12:20:00',1.64),('15128','2013-06-04','12:25:00',2.39),('15128','2013-06-04','12:30:00',5.52),('15128','2013-06-04','12:35:00',3.8),('15128','2013-06-04','12:40:00',2.55),('15128','2013-06-04','12:45:00',4.38),('15128','2013-06-04','12:50:00',4.81),('15128','2013-06-04','12:55:00',4.5),('15128','2013-06-04','13:00:00',5.09),('15128','2013-06-04','13:05:00',4.38),('15128','2013-06-04','13:10:00',5.05),('15128','2013-06-04','13:15:00',5.01),('15128','2013-06-04','13:20:00',4.98),('15128','2013-06-04','13:25:00',4.91),('15128','2013-06-04','13:30:00',4.95),('15128','2013-06-04','13:35:00',4.9),('15128','2013-06-04','13:40:00',3.95),('15128','2013-06-04','13:45:00',4.8),('15128','2013-06-04','13:50:00',4.54),('15128','2013-06-04','13:55:00',4.82),('15128','2013-06-04','14:00:00',4.78),('15128','2013-06-04','14:05:00',4.76),('15128','2013-06-04','14:10:00',4.76),('15128','2013-06-04','14:15:00',4.78),('15128','2013-06-04','14:20:00',4.99),('15128','2013-06-04','14:25:00',4.78),('15128','2013-06-04','14:30:00',1.91),('15128','2013-06-04','14:40:00',4.19),('15128','2013-06-04','14:45:00',4.59),('15128','2013-06-04','14:50:00',4.78),('15128','2013-06-04','14:55:00',3.71),('15128','2013-06-04','15:00:00',3.9),('15128','2013-06-04','15:05:00',4.76),('15128','2013-06-04','15:10:00',3.83),('15128','2013-06-04','15:15:00',2.48),('15128','2013-06-04','15:35:00',3.76),('15128','2013-06-04','15:40:00',3.89),('15128','2013-06-04','15:45:00',3.96),('15128','2013-06-04','15:50:00',3.65),('15128','2013-06-04','15:55:00',2.14),('15128','2013-06-04','16:00:00',3.72),('15128','2013-06-04','16:05:00',4.44),('15128','2013-06-04','16:10:00',3.27),('15128','2013-06-04','16:15:00',1.71),('15128','2013-06-04','16:30:00',1.67),('15128','2013-06-04','16:35:00',4.21),('15128','2013-06-04','16:40:00',4.02),('15128','2013-06-04','16:45:00',3.44),('15128','2013-06-04','16:50:00',2.14),('15128','2013-06-04','16:55:00',1.87),('15128','2013-06-04','17:00:00',2.78),('15128','2013-06-04','17:05:00',1.64),('15128','2013-06-04','17:10:00',1.85),('15128','2013-06-04','17:15:00',1.52),('15128','2013-06-04','17:20:00',1.69),('15128','2013-06-04','17:25:00',3.46),('15128','2013-06-04','17:30:00',1.81),('15128','2013-06-04','17:35:00',2.87),('15128','2013-06-04','17:40:00',2.66),('15128','2013-06-04','17:45:00',2.72),('15128','2013-06-04','17:50:00',2.18),('15128','2013-06-04','18:00:00',2.18),('15128','2013-06-04','18:05:00',1.6),('15128','2013-06-04','18:10:00',1.62),('15128','2013-06-04','18:15:00',1.37),('15128','2013-06-04','18:20:00',2.04),('15128','2013-06-04','18:25:00',1.98),('15128','2013-06-04','18:30:00',1.15),('15128','2013-06-04','18:50:00',1.67),('15128','2013-06-04','19:00:00',1.11),('15128','2013-06-03','07:50:00',1.03),('15128','2013-06-03','07:55:00',1.07),('15128','2013-06-03','08:00:00',1.13),('15128','2013-06-03','08:05:00',1.42),('15128','2013-06-03','08:10:00',1.78),('15128','2013-06-03','08:15:00',1.82),('15128','2013-06-03','08:20:00',1.76),('15128','2013-06-03','08:25:00',1.99),('15128','2013-06-03','08:30:00',1.7),('15128','2013-06-03','08:35:00',1.74),('15128','2013-06-03','08:40:00',1.49),('15128','2013-06-03','08:45:00',1.43),('15128','2013-06-03','08:50:00',1.66),('15128','2013-06-03','08:55:00',1.79),('15128','2013-06-03','09:00:00',2.05),('15128','2013-06-03','09:05:00',1.79),('15128','2013-06-03','09:10:00',2.04),('15128','2013-06-03','09:15:00',1.92),('15128','2013-06-03','09:20:00',1.71),('15128','2013-06-03','09:25:00',1.55),('15128','2013-06-03','09:30:00',1.47),('15128','2013-06-03','09:35:00',1.5),('15128','2013-06-03','09:40:00',1.58),('15128','2013-06-03','09:45:00',1.79),('15128','2013-06-03','09:50:00',2.73),('15128','2013-06-03','09:55:00',3.39),('15128','2013-06-03','10:00:00',2.02),('15128','2013-06-03','10:05:00',1.87),('15128','2013-06-03','10:10:00',2.34),('15128','2013-06-03','10:15:00',2.11),('15128','2013-06-03','10:20:00',1.72),('15128','2013-06-03','10:25:00',1.73),('15128','2013-06-03','10:30:00',1.82),('15128','2013-06-03','10:35:00',2.15),('15128','2013-06-03','10:40:00',2.6),('15128','2013-06-03','10:45:00',2.93),('15128','2013-06-03','10:50:00',2.14),('15128','2013-06-03','10:55:00',2.22),('15128','2013-06-03','11:00:00',2.29),('15128','2013-06-03','11:05:00',2.89),('15128','2013-06-03','11:10:00',2.15),('15128','2013-06-03','11:15:00',2.21),('15128','2013-06-03','11:20:00',2.51),('15128','2013-06-03','11:25:00',2.74),('15128','2013-06-03','11:30:00',2.87),('15128','2013-06-03','11:35:00',3.42),('15128','2013-06-03','11:40:00',4.16),('15128','2013-06-03','11:45:00',4.57),('15128','2013-06-03','11:50:00',2.86),('15128','2013-06-03','11:55:00',4.89),('15128','2013-06-03','12:00:00',3.08),('15128','2013-06-03','12:05:00',3.02),('15128','2013-06-03','12:10:00',2.24),('15128','2013-06-03','12:15:00',2.51),('15128','2013-06-03','12:20:00',2.13),('15128','2013-06-03','12:25:00',3.75),('15128','2013-06-03','12:30:00',3.25),('15128','2013-06-03','12:35:00',2.38),('15128','2013-06-03','12:40:00',2.64),('15128','2013-06-03','12:45:00',1.91),('15128','2013-06-03','12:50:00',1.78),('15128','2013-06-03','12:55:00',1.69),('15128','2013-06-03','13:00:00',1.14),('15128','2013-06-03','13:10:00',1.18),('15128','2013-06-03','13:15:00',1.68),('15128','2013-06-03','13:20:00',3.4),('15128','2013-06-03','13:25:00',5.45),('15128','2013-06-03','13:30:00',4.25),('15128','2013-06-03','13:35:00',3.07),('15128','2013-06-03','13:40:00',2.98),('15128','2013-06-03','13:45:00',4.39),('15128','2013-06-03','13:50:00',3.96),('15128','2013-06-03','13:55:00',2.85),('15128','2013-06-03','14:00:00',3.21),('15128','2013-06-03','14:05:00',5.81),('15128','2013-06-03','14:10:00',4.43),('15128','2013-06-03','14:15:00',2.68),('15128','2013-06-03','14:30:00',1.43),('15128','2013-06-03','14:35:00',2.11),('15128','2013-06-03','14:40:00',2.8),('15128','2013-06-03','14:45:00',4.19),('15128','2013-06-03','14:50:00',5.87),('15128','2013-06-03','14:55:00',5.6),('15128','2013-06-03','15:00:00',4.92),('15128','2013-06-03','15:05:00',1.84),('15128','2013-06-03','15:10:00',1.95),('15128','2013-06-03','15:15:00',1.74),('15128','2013-06-03','15:20:00',1.44),('15128','2013-06-03','15:25:00',1.32),('15128','2013-06-03','15:50:00',1.09),('15128','2013-06-03','18:35:00',1.13),('15128','2013-06-03','18:40:00',1.45),('15128','2013-06-03','18:45:00',1.58),('15128','2013-06-02','07:50:00',1.01),('15128','2013-06-02','08:05:00',1.2),('15128','2013-06-02','08:10:00',1.27),('15128','2013-06-02','08:15:00',1.34),('15128','2013-06-02','08:20:00',1.44),('15128','2013-06-02','08:25:00',1.51),('15128','2013-06-02','08:30:00',1.53),('15128','2013-06-02','08:35:00',1.62),('15128','2013-06-02','08:40:00',1.6),('15128','2013-06-02','08:45:00',2.08),('15128','2013-06-02','08:50:00',1.51),('15128','2013-06-02','08:55:00',1.5),('15128','2013-06-02','09:00:00',2.06),('15128','2013-06-02','09:05:00',1.91),('15128','2013-06-02','09:10:00',1.4),('15128','2013-06-02','09:15:00',1.81),('15128','2013-06-02','09:20:00',1.57),('15128','2013-06-02','09:25:00',2.36),('15128','2013-06-02','09:30:00',3.25),('15128','2013-06-02','09:35:00',1.69),('15128','2013-06-02','09:40:00',1.34),('15128','2013-06-02','09:45:00',1.44),('15128','2013-06-02','09:50:00',1.41),('15128','2013-06-02','09:55:00',1.56),('15128','2013-06-02','10:00:00',1.54),('15128','2013-06-02','10:05:00',1.06),('15128','2013-06-02','10:25:00',1.04),('15128','2013-06-02','10:30:00',1.58),('15128','2013-06-02','10:35:00',2.27),('15128','2013-06-02','10:40:00',2.67),('15128','2013-06-02','10:45:00',1.84),('15128','2013-06-02','10:50:00',1.72),('15128','2013-06-02','10:55:00',1.65),('15128','2013-06-02','11:00:00',1.83),('15128','2013-06-02','11:05:00',2.6),('15128','2013-06-02','11:10:00',2.81),('15128','2013-06-02','11:15:00',2.5),('15128','2013-06-02','11:20:00',2.29),('15128','2013-06-02','11:25:00',2.33),('15128','2013-06-02','11:30:00',2.66),('15128','2013-06-02','11:35:00',4.15),('15128','2013-06-02','11:40:00',3.63),('15128','2013-06-02','11:45:00',5.49),('15128','2013-06-02','11:50:00',4.23),('15128','2013-06-02','11:55:00',3.11),('15128','2013-06-02','12:00:00',3.14),('15128','2013-06-02','12:05:00',1.61),('15128','2013-06-02','12:10:00',1.62),('15128','2013-06-02','12:15:00',2.91),('15128','2013-06-02','12:20:00',4.35),('15128','2013-06-02','12:25:00',3.58),('15128','2013-06-02','12:30:00',1.62),('15128','2013-06-02','12:35:00',1.5),('15128','2013-06-02','12:40:00',1.4),('15128','2013-06-02','12:45:00',1.54),('15128','2013-06-02','12:50:00',1.32),('15128','2013-06-02','12:55:00',1.16),('15128','2013-06-02','13:00:00',1.42),('15128','2013-06-02','13:05:00',1.9),('15128','2013-06-02','13:10:00',2.48),('15128','2013-06-02','13:15:00',4.18),('15128','2013-06-02','13:20:00',3.9),('15128','2013-06-02','13:25:00',1.71),('15128','2013-06-02','13:30:00',1.54),('15128','2013-06-02','13:35:00',1.93),('15128','2013-06-02','13:40:00',2.77),('15128','2013-06-02','13:45:00',3.76),('15128','2013-06-02','13:50:00',2.01),('15128','2013-06-02','13:55:00',1.46),('15128','2013-06-02','14:00:00',1.28),('15128','2013-06-02','14:05:00',1.34),('15128','2013-06-02','14:10:00',4.66),('15128','2013-06-02','14:15:00',5.62),('15128','2013-06-02','14:20:00',5.58),('15128','2013-06-02','14:25:00',5.12),('15128','2013-06-02','14:30:00',4.93),('15128','2013-06-02','14:35:00',4.88),('15128','2013-06-02','14:40:00',4.92),('15128','2013-06-02','14:45:00',4.67),('15128','2013-06-02','14:50:00',4.66),('15128','2013-06-02','14:55:00',4.56),('15128','2013-06-02','15:00:00',4.33),('15128','2013-06-02','15:05:00',4.66),('15128','2013-06-02','15:10:00',4.51),('15128','2013-06-02','15:15:00',4.62),('15128','2013-06-02','15:20:00',4.62),('15128','2013-06-02','15:25:00',4.63),('15128','2013-06-02','15:30:00',4.29),('15128','2013-06-02','15:35:00',4.52),('15128','2013-06-02','15:40:00',4.42),('15128','2013-06-02','15:45:00',4.32),('15128','2013-06-02','15:50:00',4.33),('15128','2013-06-02','15:55:00',4.28),('15128','2013-06-02','16:00:00',4.18),('15128','2013-06-02','16:05:00',4.15),('15128','2013-06-02','16:10:00',3.87),('15128','2013-06-02','16:15:00',3.67),('15128','2013-06-02','16:20:00',3.87),('15128','2013-06-02','16:25:00',3.84),('15128','2013-06-02','16:30:00',3.08),('15128','2013-06-02','16:35:00',2.98),('15128','2013-06-02','16:40:00',2.51),('15128','2013-06-02','16:45:00',2.27),('15128','2013-06-02','16:50:00',3.89),('15128','2013-06-02','16:55:00',3.7),('15128','2013-06-02','17:00:00',3.35),('15128','2013-06-02','17:05:00',2.92),('15128','2013-06-02','17:10:00',2.34),('15128','2013-06-02','17:15:00',2.62),('15128','2013-06-02','17:20:00',2.67),('15128','2013-06-02','17:25:00',2.24),('15128','2013-06-02','17:30:00',1.42),('15128','2013-06-02','17:45:00',1.18),('15128','2013-06-02','17:50:00',1.17),('15128','2013-06-01','08:40:00',1.2),('15128','2013-06-01','08:45:00',1.13),('15128','2013-06-01','08:50:00',1.01),('15128','2013-06-01','09:10:00',1.19),('15128','2013-06-01','09:15:00',1.9),('15128','2013-06-01','09:20:00',2.62),('15128','2013-06-01','09:25:00',2.62),('15128','2013-06-01','09:30:00',2.65),('15128','2013-06-01','09:35:00',2.7),('15128','2013-06-01','09:40:00',2.74),('15128','2013-06-01','09:45:00',2.76),('15128','2013-06-01','09:50:00',2.82),('15128','2013-06-01','09:55:00',2.88),('15128','2013-06-01','10:00:00',2.93),('15128','2013-06-01','10:05:00',2.98),('15128','2013-06-01','10:10:00',2.96),('15128','2013-06-01','10:15:00',3.03),('15128','2013-06-01','10:20:00',3.11),('15128','2013-06-01','10:25:00',3.08),('15128','2013-06-01','10:30:00',3.3),('15128','2013-06-01','10:35:00',3.37),('15128','2013-06-01','10:40:00',2.05),('15128','2013-06-01','10:45:00',3.55),('15128','2013-06-01','10:50:00',3.22),('15128','2013-06-01','10:55:00',4.22),('15128','2013-06-01','11:00:00',2.61),('15128','2013-06-01','11:05:00',2.95),('15128','2013-06-01','11:10:00',2.73),('15128','2013-06-01','11:15:00',1.67),('15128','2013-06-01','11:20:00',3.04),('15128','2013-06-01','11:25:00',3.67),('15128','2013-06-01','11:30:00',1.48),('15128','2013-06-01','11:35:00',3.9),('15128','2013-06-01','11:40:00',5.05),('15128','2013-06-01','11:45:00',3.48),('15128','2013-06-01','11:50:00',1.34),('15128','2013-06-01','11:55:00',2.99),('15128','2013-06-01','12:00:00',2.4),('15128','2013-06-01','12:05:00',4.88),('15128','2013-06-01','12:10:00',4.93),('15128','2013-06-01','12:15:00',4.72),('15128','2013-06-01','12:20:00',4.29),('15128','2013-06-01','12:25:00',4.7),('15128','2013-06-01','12:30:00',3.5),('15128','2013-06-01','12:35:00',4.76),('15128','2013-06-01','12:40:00',4.73),('15128','2013-06-01','12:45:00',4.69),('15128','2013-06-01','12:50:00',4.69),('15128','2013-06-01','12:55:00',4.98),('15128','2013-06-01','13:00:00',4.85),('15128','2013-06-01','13:05:00',3.82),('15128','2013-06-01','13:10:00',3.64),('15128','2013-06-01','13:15:00',4.81),('15128','2013-06-01','13:20:00',4.81),('15128','2013-06-01','13:25:00',4.8),('15128','2013-06-01','13:30:00',4.75),('15128','2013-06-01','13:35:00',4.73),('15128','2013-06-01','13:40:00',4.75),('15128','2013-06-01','13:45:00',4.76),('15128','2013-06-01','13:50:00',4.74),('15128','2013-06-01','13:55:00',4.79),('15128','2013-06-01','14:00:00',4.84),('15128','2013-06-01','14:05:00',4.82),('15128','2013-06-01','14:10:00',4.82),('15128','2013-06-01','14:15:00',4.88),('15128','2013-06-01','14:20:00',4.89),('15128','2013-06-01','14:25:00',4.86),('15128','2013-06-01','14:30:00',4.66),('15128','2013-06-01','14:35:00',4.8),('15128','2013-06-01','14:40:00',4.74),('15128','2013-06-01','14:45:00',4.65),('15128','2013-06-01','14:50:00',4.77),('15128','2013-06-01','14:55:00',4.73),('15128','2013-06-01','15:00:00',4.43),('15128','2013-06-01','15:05:00',4.66),('15128','2013-06-01','15:10:00',4.57),('15128','2013-06-01','15:15:00',4.69),('15128','2013-06-01','15:20:00',4.58),('15128','2013-06-01','15:25:00',3.72),('15128','2013-06-01','15:30:00',2.84),('15128','2013-06-01','15:35:00',4.49),('15128','2013-06-01','15:40:00',4.99),('15128','2013-06-01','15:45:00',2.75),('15128','2013-06-01','15:50:00',4.26),('15128','2013-06-01','15:55:00',3.2),('15128','2013-06-01','16:00:00',3.05),('15128','2013-06-01','16:05:00',3.05),('15128','2013-06-01','16:10:00',3.59),('15128','2013-06-01','16:15:00',4.47),('15128','2013-06-01','16:20:00',3.93),('15128','2013-06-01','16:25:00',4.18),('15128','2013-06-01','16:30:00',3.9),('15128','2013-06-01','16:35:00',4),('15128','2013-06-01','16:40:00',3.86),('15128','2013-06-01','16:45:00',3.28),('15128','2013-06-01','16:50:00',3.58),('15128','2013-06-01','16:55:00',3.38),('15128','2013-06-01','17:00:00',3.6),('15128','2013-06-01','17:05:00',3.37),('15128','2013-06-01','17:10:00',3.49),('15128','2013-06-01','17:15:00',3.35),('15128','2013-06-01','17:20:00',2.96),('15128','2013-06-01','17:25:00',2.94),('15128','2013-06-01','17:30:00',2.5),('15128','2013-06-01','17:35:00',1.69),('15128','2013-06-01','17:40:00',1.69),('15128','2013-06-01','17:45:00',1.31),('15128','2013-06-01','17:50:00',1.96),('15128','2013-06-01','17:55:00',1.58),('15128','2013-06-01','18:05:00',1.11),('15128','2013-06-01','18:10:00',1.26),('15128','2013-06-01','18:15:00',1.09),('15128','2013-06-01','18:20:00',1.12),('15128','2013-06-01','18:40:00',1.02),('15128','2013-05-31','07:45:00',1.14),('15128','2013-05-31','07:50:00',1.5),('15128','2013-05-31','08:10:00',1.2),('15128','2013-05-31','08:15:00',1.81),('15128','2013-05-31','08:25:00',1.12),('15128','2013-05-31','08:30:00',1.14),('15128','2013-05-31','08:45:00',1.4),('15128','2013-05-31','10:35:00',1.14),('15128','2013-05-31','10:45:00',1.4),('15128','2013-05-31','10:50:00',2.73),('15128','2013-05-31','10:55:00',4.28),('15128','2013-05-31','11:00:00',1.85),('15128','2013-05-31','11:05:00',1.87),('15128','2013-05-31','11:10:00',1.56),('15128','2013-05-31','11:15:00',1.45),('15128','2013-05-31','11:20:00',1.98),('15128','2013-05-31','11:25:00',1.98),('15128','2013-05-31','11:30:00',1.9),('15128','2013-05-31','11:35:00',2.04),('15128','2013-05-31','11:40:00',2.2),('15128','2013-05-31','11:45:00',1.87),('15128','2013-05-31','11:50:00',3.41),('15128','2013-05-31','11:55:00',1.29),('15128','2013-05-31','12:10:00',1.87),('15128','2013-05-31','12:15:00',1.94),('15128','2013-05-31','12:20:00',2.3),('15128','2013-05-31','12:25:00',5.36),('15128','2013-05-31','12:30:00',2.16),('15128','2013-05-31','12:35:00',2.03),('15128','2013-05-31','12:40:00',2.41),('15128','2013-05-31','12:45:00',2.18),('15128','2013-05-31','12:50:00',2.19),('15128','2013-05-31','12:55:00',2.38),('15128','2013-05-31','13:00:00',2.46),('15128','2013-05-31','13:05:00',2.46),('15128','2013-05-31','13:10:00',2.62),('15128','2013-05-31','13:15:00',2.79),('15128','2013-05-31','13:20:00',2.67),('15128','2013-05-31','13:25:00',2.63),('15128','2013-05-31','13:30:00',2.35),('15128','2013-05-31','13:35:00',2.03),('15128','2013-05-31','13:40:00',2.35),('15128','2013-05-31','13:45:00',1.62),('15128','2013-05-31','13:50:00',1.61),('15128','2013-05-31','13:55:00',1.79),('15128','2013-05-31','14:00:00',2.61),('15128','2013-05-31','14:05:00',3.02),('15128','2013-05-31','14:10:00',2.75),('15128','2013-05-31','14:15:00',2.46),('15128','2013-05-31','14:20:00',3.25),('15128','2013-05-31','14:25:00',2.16),('15128','2013-05-31','14:30:00',1.95),('15128','2013-05-31','14:35:00',1.54),('15128','2013-05-31','14:40:00',1.45),('15128','2013-05-31','14:45:00',1.45),('15128','2013-05-31','14:50:00',1.54),('15128','2013-05-31','14:55:00',1.41),('15128','2013-05-31','15:00:00',1.03),('15128','2013-05-31','15:05:00',1.13),('15128','2013-05-31','15:45:00',1.4),('15128','2013-05-31','15:50:00',1.78),('15128','2013-05-31','15:55:00',1.71),('15128','2013-05-31','16:00:00',1.36),('15128','2013-05-31','16:05:00',1.05),('15128','2013-05-31','16:15:00',1.35),('15128','2013-05-31','16:20:00',1.37),('15128','2013-05-31','16:25:00',1.29),('15128','2013-05-31','16:30:00',1.16),('15128','2013-05-31','16:35:00',1.08),('15128','2013-05-31','16:40:00',1.12),('15128','2013-05-31','18:30:00',1.06),('15128','2013-05-31','18:35:00',1),('15128','2013-05-31','18:40:00',1.15),('15128','2013-05-31','18:45:00',1.78),('15128','2013-05-31','18:50:00',1.45),('15128','2013-05-31','18:55:00',1.85),('15128','2013-05-31','19:00:00',1.09),('15128','2014-04-01','09:10:00',1.4),('15128','2014-04-01','09:15:00',1.49),('15128','2014-04-01','09:20:00',1.81),('15128','2014-04-01','09:25:00',1.15),('15128','2014-04-01','10:00:00',1.38),('15128','2014-04-01','10:05:00',2.2),('15128','2014-04-01','10:10:00',2.58),('15128','2014-04-01','10:15:00',2.06),('15128','2014-04-01','10:20:00',1.14),('15128','2014-04-01','10:40:00',1.13),('15128','2014-04-01','10:45:00',1.88),('15128','2014-04-01','10:50:00',2.03),('15128','2014-04-01','10:55:00',2.24),('15128','2014-04-01','11:00:00',1.21),('15128','2014-04-01','11:05:00',1.25),('15128','2014-04-01','11:10:00',1.38),('15128','2014-04-01','11:15:00',2.23),('15128','2014-04-01','11:20:00',2.16),('15128','2014-04-01','11:25:00',1.57),('15128','2014-04-01','11:35:00',1.05),('15128','2014-04-01','11:40:00',1.44),('15128','2014-04-01','11:45:00',3.25),('15128','2014-04-01','11:50:00',3.68),('15128','2014-04-01','11:55:00',4.1),('15128','2014-04-01','12:00:00',2.13),('15128','2014-04-01','12:05:00',1.37),('15128','2014-04-01','12:10:00',2.93),('15128','2014-04-01','12:15:00',3.4),('15128','2014-04-01','12:20:00',2.17),('15128','2014-04-01','12:25:00',1.85),('15128','2014-04-01','12:30:00',2.29),('15128','2014-04-01','12:35:00',2.41),('15128','2014-04-01','12:40:00',3.96),('15128','2014-04-01','12:45:00',1.93),('15128','2014-04-01','12:50:00',2.23),('15128','2014-04-01','12:55:00',2.19),('15128','2014-04-01','13:00:00',1.34),('15128','2014-04-01','13:05:00',3.54),('15128','2014-04-01','13:10:00',3.16),('15128','2014-04-01','13:15:00',2.47),('15128','2014-04-01','13:20:00',4.02),('15128','2014-04-01','13:25:00',3.87),('15128','2014-04-01','13:30:00',3.59),('15128','2014-04-01','13:35:00',3.9),('15128','2014-04-01','13:40:00',4.05),('15128','2014-04-01','13:45:00',3.68),('15128','2014-04-01','13:50:00',3.89),('15128','2014-04-01','13:55:00',3.09),('15128','2014-04-01','14:00:00',3.12),('15128','2014-04-01','14:05:00',4.15),('15128','2014-04-01','14:10:00',3.18),('15128','2014-04-01','14:15:00',4.16),('15128','2014-04-01','14:20:00',3.99),('15128','2014-04-01','14:25:00',4.02),('15128','2014-04-01','14:30:00',3.66),('15128','2014-04-01','14:35:00',3.96),('15128','2014-04-01','14:40:00',3.95),('15128','2014-04-01','14:45:00',3.78),('15128','2014-04-01','14:50:00',3.47),('15128','2014-04-01','14:55:00',3.77),('15128','2014-04-01','15:00:00',3.75),('15128','2014-04-01','15:05:00',3.77),('15128','2014-04-01','15:10:00',3.4),('15128','2014-04-01','15:15:00',3.52),('15128','2014-04-01','15:20:00',3.63),('15128','2014-04-01','15:25:00',3.38),('15128','2014-04-01','15:30:00',3.33),('15128','2014-04-01','15:35:00',3.6),('15128','2014-04-01','15:40:00',3.6),('15128','2014-04-01','15:45:00',3.47),('15128','2014-04-01','15:50:00',3.19),('15128','2014-04-01','15:55:00',3.22),('15128','2014-04-01','16:00:00',3.28),('15128','2014-04-01','16:05:00',3.21),('15128','2014-04-01','16:10:00',3.2),('15128','2014-04-01','16:15:00',3.13),('15128','2014-04-01','16:20:00',3),('15128','2014-04-01','16:25:00',2.95),('15128','2014-04-01','16:30:00',2.95),('15128','2014-04-01','16:35:00',2.83),('15128','2014-04-01','16:40:00',2.83),('15128','2014-04-01','16:45:00',2.62),('15128','2014-04-01','16:50:00',2.56),('15128','2014-04-01','16:55:00',2.66),('15128','2014-04-01','17:00:00',2.53),('15128','2014-04-01','17:05:00',2.39),('15128','2014-04-01','17:10:00',2.31),('15128','2014-04-01','17:15:00',2.13),('15128','2014-04-01','17:20:00',2.04),('15128','2014-04-01','17:25:00',1.92),('15128','2014-04-01','17:30:00',1.76),('15128','2014-04-01','17:35:00',1.6),('15128','2014-04-01','17:40:00',1.39),('15128','2014-04-01','17:45:00',1.52),('15128','2014-04-01','17:50:00',1.56),('15128','2014-04-01','17:55:00',1.36),('15128','2013-05-30','07:50:00',1.02),('15128','2013-05-30','07:55:00',1.22),('15128','2013-05-30','08:10:00',1.06),('15128','2013-05-30','08:15:00',1.35),('15128','2013-05-30','08:20:00',1.45),('15128','2013-05-30','08:25:00',1.52),('15128','2013-05-30','08:30:00',1.62),('15128','2013-05-30','08:35:00',1.66),('15128','2013-05-30','08:40:00',1.71),('15128','2013-05-30','08:45:00',1.3),('15128','2013-05-30','08:50:00',1.18),('15128','2013-05-30','08:55:00',1.44),('15128','2013-05-30','09:00:00',1.87),('15128','2013-05-30','09:05:00',1.27),('15128','2013-05-30','09:10:00',2.41),('15128','2013-05-30','09:15:00',1.85),('15128','2013-05-30','09:20:00',1.57),('15128','2013-05-30','09:25:00',2.43),('15128','2013-05-30','09:30:00',2.83),('15128','2013-05-30','09:35:00',2.76),('15128','2013-05-30','09:40:00',2.73),('15128','2013-05-30','09:45:00',2.94),('15128','2013-05-30','09:50:00',2.98),('15128','2013-05-30','09:55:00',3.36),('15128','2013-05-30','10:00:00',3.13),('15128','2013-05-30','10:05:00',2.92),('15128','2013-05-30','10:10:00',2.25),('15128','2013-05-30','10:15:00',2.32),('15128','2013-05-30','10:20:00',1.98),('15128','2013-05-30','10:25:00',1.93),('15128','2013-05-30','10:30:00',3.12),('15128','2013-05-30','10:35:00',3.67),('15128','2013-05-30','10:40:00',3.78),('15128','2013-05-30','10:45:00',4.15),('15128','2013-05-30','10:50:00',3.33),('15128','2013-05-30','10:55:00',2.97),('15128','2013-05-30','11:00:00',1.67),('15128','2013-05-30','11:05:00',2.02),('15128','2013-05-30','11:10:00',1.89),('15128','2013-05-30','11:15:00',1.89),('15128','2013-05-30','11:20:00',3.34),('15128','2013-05-30','11:25:00',3.13),('15128','2013-05-30','11:30:00',1.89),('15128','2013-05-30','11:35:00',2.41),('15128','2013-05-30','11:40:00',3.39),('15128','2013-05-30','11:45:00',2.81),('15128','2013-05-30','11:50:00',3.22),('15128','2013-05-30','11:55:00',2.48),('15128','2013-05-30','12:00:00',4.58),('15128','2013-05-30','12:05:00',4.03),('15128','2013-05-30','12:10:00',2.92),('15128','2013-05-30','12:15:00',3.27),('15128','2013-05-30','12:20:00',3.64),('15128','2013-05-30','12:25:00',2.77),('15128','2013-05-30','12:30:00',2.12),('15128','2013-05-30','12:35:00',1.63),('15128','2013-05-30','12:50:00',4.31),('15128','2013-05-30','12:55:00',5.18),('15128','2013-05-30','13:00:00',1.9),('15128','2013-05-30','13:05:00',1.48),('15128','2013-05-30','13:10:00',1.85),('15128','2013-05-30','13:15:00',3.6),('15128','2013-05-30','13:20:00',3.02),('15128','2013-05-30','13:25:00',5.12),('15128','2013-05-30','13:30:00',1.9),('15128','2013-05-30','13:35:00',1.42),('15128','2013-05-30','13:40:00',2),('15128','2013-05-30','13:45:00',4.11),('15128','2013-05-30','13:50:00',4.2),('15128','2013-05-30','13:55:00',2.09),('15128','2013-05-30','14:25:00',1.72),('15128','2013-05-30','14:30:00',2.43),('15128','2013-05-30','14:35:00',1.4),('15128','2013-05-30','14:55:00',1.63),('15128','2013-05-30','15:00:00',1.34),('15128','2013-05-30','15:05:00',1.6),('15128','2013-05-30','15:10:00',3.14),('15128','2013-05-30','15:15:00',3.3),('15128','2013-05-30','15:20:00',2.5),('15128','2013-05-30','15:25:00',2.83),('15128','2013-05-30','15:30:00',2.34),('15128','2013-05-30','15:35:00',2.25),('15128','2013-05-30','15:40:00',1.98),('15128','2013-05-30','15:45:00',3.1),('15128','2013-05-30','15:50:00',2.51),('15128','2013-05-30','15:55:00',2.68),('15128','2013-05-30','16:00:00',1.62),('15128','2013-05-30','16:05:00',1.12),('15128','2013-05-30','16:20:00',1.53),('15128','2013-05-30','16:25:00',1.38),('15128','2013-05-30','16:30:00',1.09),('15128','2013-05-30','16:40:00',1.2),('15128','2013-05-29','07:45:00',1.2),('15128','2013-05-29','07:50:00',1.08),('15128','2013-05-29','08:30:00',1.72),('15128','2013-05-29','08:35:00',1.77),('15128','2013-05-29','08:40:00',1.86),('15128','2013-05-29','08:45:00',1.92),('15128','2013-05-29','08:50:00',2.01),('15128','2013-05-29','08:55:00',2.15),('15128','2013-05-29','09:00:00',2.24),('15128','2013-05-29','09:05:00',2.32),('15128','2013-05-29','09:10:00',2.49),('15128','2013-05-29','09:15:00',2.65),('15128','2013-05-29','09:20:00',1.35),('15128','2013-05-29','09:25:00',2.4),('15128','2013-05-29','09:30:00',1.25),('15128','2013-05-29','09:40:00',1.66),('15128','2013-05-29','09:45:00',1.17),('15128','2013-05-29','09:50:00',1.8),('15128','2013-05-29','09:55:00',2.86),('15128','2013-05-29','10:00:00',2.31),('15128','2013-05-29','10:05:00',3.26),('15128','2013-05-29','10:10:00',3.63),('15128','2013-05-29','10:15:00',1.95),('15128','2013-05-29','10:20:00',2.66),('15128','2013-05-29','10:25:00',2.86),('15128','2013-05-29','10:30:00',1.3),('15128','2013-05-29','10:35:00',3.03),('15128','2013-05-29','10:40:00',2.3),('15128','2013-05-29','10:45:00',3.99),('15128','2013-05-29','10:50:00',4.03),('15128','2013-05-29','10:55:00',3.32),('15128','2013-05-29','11:00:00',2.03),('15128','2013-05-29','11:05:00',2.82),('15128','2013-05-29','11:10:00',2.88),('15128','2013-05-29','11:15:00',2.62),('15128','2013-05-29','11:20:00',3.04),('15128','2013-05-29','11:25:00',3.79),('15128','2013-05-29','11:30:00',1.43),('15128','2013-05-29','11:35:00',2.96),('15128','2013-05-29','11:40:00',3.59),('15128','2013-05-29','11:45:00',3.6),('15128','2013-05-29','11:50:00',4.35),('15128','2013-05-29','11:55:00',5.54),('15128','2013-05-29','12:00:00',1.9),('15128','2013-05-29','12:05:00',1.76),('15128','2013-05-29','12:10:00',5.78),('15128','2013-05-29','12:15:00',3.88),('15128','2013-05-29','12:20:00',2.26),('15128','2013-05-29','12:25:00',4.51),('15128','2013-05-29','12:30:00',3.9),('15128','2013-05-29','12:35:00',5.41),('15128','2013-05-29','12:40:00',2.63),('15128','2013-05-29','12:45:00',3.97),('15128','2013-05-29','12:50:00',2.68),('15128','2013-05-29','12:55:00',5.04),('15128','2013-05-29','13:00:00',5.2),('15128','2013-05-29','13:05:00',5.22),('15128','2013-05-29','13:10:00',2.05),('15128','2013-05-29','13:15:00',2.11),('15128','2013-05-29','13:20:00',2.66),('15128','2013-05-29','13:25:00',5.88),('15128','2013-05-29','13:30:00',4.85),('15128','2013-05-29','13:35:00',4.92),('15128','2013-05-29','13:40:00',3.71),('15128','2013-05-29','13:45:00',5.32),('15128','2013-05-29','13:50:00',5.14),('15128','2013-05-29','13:55:00',1.73),('15128','2013-05-29','14:00:00',1),('15128','2013-05-29','14:05:00',3.59),('15128','2013-05-29','14:10:00',2.63),('15128','2013-05-29','14:15:00',1.74),('15128','2013-05-29','14:20:00',1.54),('15128','2013-05-29','14:25:00',2.86),('15128','2013-05-29','14:30:00',1.81),('15128','2013-05-29','14:35:00',2.52),('15128','2013-05-29','14:40:00',3.95),('15128','2013-05-29','14:45:00',2.11),('15128','2013-05-29','14:50:00',1.73),('15128','2013-05-29','14:55:00',3.16),('15128','2013-05-29','15:00:00',1.55),('15128','2013-05-29','15:05:00',2.24),('15128','2013-05-29','15:10:00',3.83),('15128','2013-05-29','15:15:00',4.08),('15128','2013-05-29','15:20:00',2.86),('15128','2013-05-29','15:25:00',1.92),('15128','2013-05-29','15:30:00',2.87),('15128','2013-05-29','15:35:00',4.59),('15128','2013-05-29','15:40:00',3.17),('15128','2013-05-29','15:45:00',3.25),('15128','2013-05-29','15:50:00',3.11),('15128','2013-05-29','15:55:00',1.86),('15128','2013-05-29','16:00:00',4.89),('15128','2013-05-29','16:05:00',4.9),('15128','2013-05-29','16:10:00',3.92),('15128','2013-05-29','16:15:00',1.93),('15128','2013-05-29','16:20:00',1.57),('15128','2013-05-29','16:25:00',1.63),('15128','2013-05-29','16:30:00',1.61),('15128','2013-05-29','16:35:00',1.74),('15128','2013-05-29','16:40:00',2.53),('15128','2013-05-29','16:45:00',1.49),('15128','2013-05-29','16:50:00',1.37),('15128','2013-05-29','16:55:00',4.47),('15128','2013-05-29','17:00:00',3.54),('15128','2013-05-29','17:50:00',1.63),('15128','2013-05-29','17:55:00',1.42),('15128','2013-05-29','18:00:00',1.86),('15128','2013-05-29','18:05:00',2.33),('15128','2013-05-29','18:10:00',1.53),('15128','2013-05-29','18:20:00',1.27),('15128','2013-05-29','18:25:00',2.52),('15128','2013-05-29','18:30:00',2.56),('15128','2013-05-29','18:35:00',2.37),('15128','2013-05-29','18:40:00',1.52),('15128','2013-05-29','18:45:00',1.08),('15128','2013-05-28','07:55:00',1.02),('15128','2013-05-28','08:00:00',1.12),('15128','2013-05-28','08:05:00',1.19),('15128','2013-05-28','08:10:00',1.26),('15128','2013-05-28','08:15:00',1.33),('15128','2013-05-28','08:20:00',1.43),('15128','2013-05-28','08:25:00',1.51),('15128','2013-05-28','08:30:00',1.59),('15128','2013-05-28','08:35:00',1.66),('15128','2013-05-28','08:40:00',1.78),('15128','2013-05-28','08:45:00',1.85),('15128','2013-05-28','08:50:00',1.93),('15128','2013-05-28','08:55:00',2.05),('15128','2013-05-28','09:00:00',2.12),('15128','2013-05-28','09:05:00',2.21),('15128','2013-05-28','09:10:00',2.3),('15128','2013-05-28','09:15:00',2.38),('15128','2013-05-28','09:20:00',2.43),('15128','2013-05-28','09:25:00',2.48),('15128','2013-05-28','09:30:00',2.55),('15128','2013-05-28','09:35:00',2.62),('15128','2013-05-28','09:40:00',2.69),('15128','2013-05-28','09:45:00',2.74),('15128','2013-05-28','09:50:00',2.8),('15128','2013-05-28','09:55:00',2.86),('15128','2013-05-28','10:00:00',2.92),('15128','2013-05-28','10:05:00',2.99),('15128','2013-05-28','10:10:00',2.99),('15128','2013-05-28','10:15:00',3.02),('15128','2013-05-28','10:20:00',3.12),('15128','2013-05-28','10:25:00',3.23),('15128','2013-05-28','10:30:00',3.29),('15128','2013-05-28','10:35:00',3.36),('15128','2013-05-28','10:40:00',3.47),('15128','2013-05-28','10:45:00',3.48),('15128','2013-05-28','10:50:00',3.71),('15128','2013-05-28','10:55:00',2.74),('15128','2013-05-28','11:00:00',3.7),('15128','2013-05-28','11:05:00',4.26),('15128','2013-05-28','11:10:00',3.32),('15128','2013-05-28','11:15:00',2.64),('15128','2013-05-28','11:20:00',3.08),('15128','2013-05-28','11:25:00',2.82),('15128','2013-05-28','11:30:00',2.81),('15128','2013-05-28','11:35:00',2.2),('15128','2013-05-28','11:40:00',4.49),('15128','2013-05-28','11:45:00',3.7),('15128','2013-05-28','11:50:00',4.1),('15128','2013-05-28','11:55:00',3.64),('15128','2013-05-28','12:00:00',4.43),('15128','2013-05-28','12:05:00',4.74),('15128','2013-05-28','12:10:00',4.54),('15128','2013-05-28','12:15:00',3.4),('15128','2013-05-28','12:20:00',4.72),('15128','2013-05-28','12:25:00',4.5),('15128','2013-05-28','12:30:00',4.3),('15128','2013-05-28','12:35:00',4.49),('15128','2013-05-28','12:40:00',4.88),('15128','2013-05-28','12:45:00',4.78),('15128','2013-05-28','12:50:00',4.83),('15128','2013-05-28','12:55:00',4.91),('15128','2013-05-28','13:00:00',4.99),('15128','2013-05-28','13:05:00',4.88),('15128','2013-05-28','13:10:00',4.79),('15128','2013-05-28','13:15:00',3.46),('15128','2013-05-28','13:20:00',3.32),('15128','2013-05-28','13:25:00',5.19),('15128','2013-05-28','13:30:00',2.33),('15128','2013-05-28','13:35:00',2.82),('15128','2013-05-28','13:40:00',3.63),('15128','2013-05-28','13:45:00',3.51),('15128','2013-05-28','13:50:00',3.6),('15128','2013-05-28','13:55:00',5.18),('15128','2013-05-28','14:00:00',5.16),('15128','2013-05-28','14:05:00',4.83),('15128','2013-05-28','14:10:00',4.82),('15128','2013-05-28','14:15:00',4.46),('15128','2013-05-28','14:20:00',4.43),('15128','2013-05-28','14:25:00',4),('15128','2013-05-28','14:30:00',3.82),('15128','2013-05-28','14:35:00',4.01),('15128','2013-05-28','14:40:00',3.76),('15128','2013-05-28','14:45:00',4.7),('15128','2013-05-28','14:50:00',5.2),('15128','2013-05-28','14:55:00',5.13),('15128','2013-05-28','15:00:00',4.49),('15128','2013-05-28','15:05:00',4.95),('15128','2013-05-28','15:10:00',3.75),('15128','2013-05-28','15:15:00',3.76),('15128','2013-05-28','15:20:00',3.56),('15128','2013-05-28','15:25:00',4.04),('15128','2013-05-28','15:30:00',4.57),('15128','2013-05-28','15:35:00',4.07),('15128','2013-05-28','15:40:00',4.01),('15128','2013-05-28','15:45:00',3.66),('15128','2013-05-28','15:50:00',3.27),('15128','2013-05-28','15:55:00',3.01),('15128','2013-05-28','16:00:00',2.56),('15128','2013-05-28','16:05:00',2.73),('15128','2013-05-28','16:10:00',2.9),('15128','2013-05-28','16:15:00',3.06),('15128','2013-05-28','16:20:00',3.52),('15128','2013-05-28','16:25:00',3.24),('15128','2013-05-28','16:30:00',2.77),('15128','2013-05-28','16:35:00',2.4),('15128','2013-05-28','16:40:00',2.17),('15128','2013-05-28','16:45:00',1.72),('15128','2013-05-28','16:50:00',1.21),('15128','2013-05-28','17:25:00',1.06),('15128','2013-05-28','17:30:00',1.74),('15128','2013-05-28','17:35:00',2.14),('15128','2013-05-28','17:40:00',1.95),('15128','2013-05-28','17:45:00',1.2),('15128','2013-05-28','17:50:00',1.06),('15128','2013-05-28','17:55:00',1.35),('15128','2013-05-28','18:00:00',1.51),('15128','2013-05-28','18:05:00',1.44),('15128','2013-05-28','18:10:00',2.22),('15128','2013-05-28','18:15:00',2.15),('15128','2013-05-27','08:05:00',1.06),('15128','2013-05-27','08:10:00',1.23),('15128','2013-05-27','08:15:00',1.46),('15128','2013-05-27','08:20:00',1.53),('15128','2013-05-27','08:25:00',1.3),('15128','2013-05-27','08:30:00',1.56),('15128','2013-05-27','08:35:00',1.66),('15128','2013-05-27','08:40:00',1.57),('15128','2013-05-27','08:45:00',1.43),('15128','2013-05-27','08:50:00',1.49),('15128','2013-05-27','08:55:00',1.77),('15128','2013-05-27','09:00:00',1.67),('15128','2013-05-27','09:05:00',1.69),('15128','2013-05-27','09:10:00',1.81),('15128','2013-05-27','09:15:00',1.89),('15128','2013-05-27','09:20:00',1.92),('15128','2013-05-27','09:25:00',2),('15128','2013-05-27','09:30:00',2.15),('15128','2013-05-27','09:35:00',2.36),('15128','2013-05-27','09:40:00',2.24),('15128','2013-05-27','09:45:00',2.39),('15128','2013-05-27','09:50:00',2.35),('15128','2013-05-27','09:55:00',2.5),('15128','2013-05-27','10:00:00',2.13),('15128','2013-05-27','10:05:00',2.16),('15128','2013-05-27','10:10:00',2.31),('15128','2013-05-27','10:15:00',2.48),('15128','2013-05-27','10:20:00',2.44),('15128','2013-05-27','10:25:00',2.43),('15128','2013-05-27','10:30:00',2.69),('15128','2013-05-27','10:35:00',2.93),('15128','2013-05-27','10:40:00',3.08),('15128','2013-05-27','10:45:00',2.83),('15128','2013-05-27','10:50:00',2.72),('15128','2013-05-27','10:55:00',2.77),('15128','2013-05-27','11:00:00',2.93),('15128','2013-05-27','11:05:00',3.23),('15128','2013-05-27','11:10:00',3.19),('15128','2013-05-27','11:15:00',2.83),('15128','2013-05-27','11:20:00',2.08),('15128','2013-05-27','11:25:00',2.98),('15128','2013-05-27','11:30:00',3.5),('15128','2013-05-27','11:35:00',3.36),('15128','2013-05-27','11:40:00',4.11),('15128','2013-05-27','11:45:00',1.94),('15128','2013-05-27','11:50:00',1.21),('15128','2013-05-27','11:55:00',1.21),('15128','2013-05-27','12:00:00',1.95),('15128','2013-05-27','12:05:00',2.54),('15128','2013-05-27','12:10:00',2.81),('15128','2013-05-27','12:15:00',2.86),('15128','2013-05-27','12:20:00',2.65),('15128','2013-05-27','12:25:00',2.93),('15128','2013-05-27','12:30:00',3.24),('15128','2013-05-27','12:35:00',2.24),('15128','2013-05-27','12:40:00',2.4),('15128','2013-05-27','12:45:00',2.36),('15128','2013-05-27','12:50:00',2.37),('15128','2013-05-27','12:55:00',2.66),('15128','2013-05-27','13:00:00',2.97),('15128','2013-05-27','13:05:00',2.89),('15128','2013-05-27','13:10:00',2.79),('15128','2013-05-27','13:15:00',1.77),('15128','2013-05-27','13:20:00',2.19),('15128','2013-05-27','13:25:00',4.01),('15128','2013-05-27','13:30:00',4),('15128','2013-05-27','13:35:00',4.1),('15128','2013-05-27','13:40:00',2.56),('15128','2013-05-27','13:45:00',2.64),('15128','2013-05-27','13:50:00',2.13),('15128','2013-05-27','13:55:00',2.6),('15128','2013-05-27','14:00:00',1.99),('15128','2013-05-27','14:05:00',2.65),('15128','2013-05-27','14:10:00',2.69),('15128','2013-05-27','14:15:00',3.17),('15128','2013-05-27','14:20:00',4.2),('15128','2013-05-27','14:25:00',3.75),('15128','2013-05-27','14:30:00',3.56),('15128','2013-05-27','14:35:00',3.88),('15128','2013-05-27','14:40:00',3.15),('15128','2013-05-27','14:45:00',2.98),('15128','2013-05-27','14:50:00',3.77),('15128','2013-05-27','14:55:00',3.95),('15128','2013-05-27','15:00:00',4.27),('15128','2013-05-27','15:05:00',3.08),('15128','2013-05-27','15:10:00',2.14),('15128','2013-05-27','15:15:00',2.36),('15128','2013-05-27','15:20:00',2.56),('15128','2013-05-27','15:25:00',2.01),('15128','2013-05-27','15:30:00',2),('15128','2013-05-27','15:35:00',2.38),('15128','2013-05-27','15:40:00',2.1),('15128','2013-05-27','15:45:00',2.09),('15128','2013-05-27','15:50:00',2.41),('15128','2013-05-27','15:55:00',3.99),('15128','2013-05-27','16:00:00',2.92),('15128','2013-05-27','16:05:00',3.78),('15128','2013-05-27','16:10:00',2.42),('15128','2013-05-27','16:15:00',2.13),('15128','2013-05-27','16:20:00',2.46),('15128','2013-05-27','16:25:00',1.73),('15128','2013-05-27','16:30:00',1.52),('15128','2013-05-27','16:35:00',1.56),('15128','2013-05-27','16:40:00',2.06),('15128','2013-05-27','16:45:00',3.76),('15128','2013-05-27','16:50:00',3.5),('15128','2013-05-27','16:55:00',3.39),('15128','2013-05-27','17:00:00',3.33),('15128','2013-05-27','17:05:00',3.26),('15128','2013-05-27','17:10:00',3.2),('15128','2013-05-27','17:15:00',3.13),('15128','2013-05-27','17:20:00',3.07),('15128','2013-05-27','17:25:00',2.98),('15128','2013-05-27','17:30:00',2.93),('15128','2013-05-27','17:35:00',2.86),('15128','2013-05-27','17:40:00',2.73),('15128','2013-05-27','17:45:00',2.61),('15128','2013-05-27','17:50:00',2.48),('15128','2013-05-27','17:55:00',1.86),('15128','2013-05-27','18:00:00',1.38),('15128','2013-05-27','18:05:00',1.06),('15128','2013-05-27','18:10:00',1.27),('15128','2013-05-27','18:15:00',1.39),('15128','2013-05-27','18:20:00',2.13),('15128','2013-05-27','18:25:00',1.93),('15128','2013-05-27','18:30:00',1.77),('15128','2013-05-27','18:35:00',1.64),('15128','2013-05-27','18:40:00',1.59),('15128','2013-05-27','18:45:00',1.53),('15128','2013-05-27','18:50:00',1.46),('15128','2013-05-27','18:55:00',1.36),('15128','2013-05-27','19:00:00',1.23),('15128','2013-05-27','19:05:00',1.12),('15128','2013-05-26','08:00:00',1.12),('15128','2013-05-26','08:05:00',1.29),('15128','2013-05-26','08:10:00',1.46),('15128','2013-05-26','08:15:00',1.04),('15128','2013-05-26','08:25:00',1.69),('15128','2013-05-26','08:30:00',1.8),('15128','2013-05-26','08:35:00',1.97),('15128','2013-05-26','08:40:00',2),('15128','2013-05-26','08:45:00',1.57),('15128','2013-05-26','08:50:00',2.16),('15128','2013-05-26','08:55:00',2.15),('15128','2013-05-26','09:00:00',2.19),('15128','2013-05-26','09:05:00',2.6),('15128','2013-05-26','09:10:00',1.56),('15128','2013-05-26','09:15:00',2.5),('15128','2013-05-26','09:20:00',2.93),('15128','2013-05-26','09:25:00',1.87),('15128','2013-05-26','09:30:00',1.21),('15128','2013-05-26','09:35:00',2.81),('15128','2013-05-26','09:40:00',2.84),('15128','2013-05-26','09:45:00',2.87),('15128','2013-05-26','09:50:00',2.99),('15128','2013-05-26','09:55:00',3.05),('15128','2013-05-26','10:00:00',3.07),('15128','2013-05-26','10:05:00',2.04),('15128','2013-05-26','10:10:00',1.83),('15128','2013-05-26','10:15:00',3.49),('15128','2013-05-26','10:20:00',2.58),('15128','2013-05-26','10:25:00',3.55),('15128','2013-05-26','10:30:00',3.81),('15128','2013-05-26','10:35:00',2.72),('15128','2013-05-26','10:40:00',2.39),('15128','2013-05-26','10:45:00',1.66),('15128','2013-05-26','10:50:00',2.2),('15128','2013-05-26','10:55:00',2.96),('15128','2013-05-26','11:00:00',4.12),('15128','2013-05-26','11:05:00',3.56),('15128','2013-05-26','11:10:00',3.53),('15128','2013-05-26','11:15:00',3.45),('15128','2013-05-26','11:20:00',4.83),('15128','2013-05-26','11:25:00',2.83),('15128','2013-05-26','11:30:00',1.7),('15128','2013-05-26','11:35:00',2.95),('15128','2013-05-26','11:40:00',2.41),('15128','2013-05-26','11:45:00',2.84),('15128','2013-05-26','11:50:00',2.03),('15128','2013-05-26','11:55:00',4.61),('15128','2013-05-26','12:00:00',4.89),('15128','2013-05-26','12:05:00',4.55),('15128','2013-05-26','12:10:00',4.31),('15128','2013-05-26','12:15:00',5.12),('15128','2013-05-26','12:20:00',4.87),('15128','2013-05-26','12:25:00',4.81),('15128','2013-05-26','12:30:00',3.95),('15128','2013-05-26','12:35:00',4.56),('15128','2013-05-26','12:40:00',4.92),('15128','2013-05-26','12:45:00',4.59),('15128','2013-05-26','12:50:00',4.9),('15128','2013-05-26','12:55:00',4.97),('15128','2013-05-26','13:00:00',4.28),('15128','2013-05-26','13:05:00',4.85),('15128','2013-05-26','13:10:00',4.82),('15128','2013-05-26','13:15:00',4.58),('15128','2013-05-26','13:20:00',4.19),('15128','2013-05-26','13:25:00',4.7),('15128','2013-05-26','13:30:00',4.7),('15128','2013-05-26','13:35:00',4.79),('15128','2013-05-26','13:40:00',5.06),('15128','2013-05-26','13:50:00',2.21),('15128','2013-05-26','13:55:00',4.87),('15128','2013-05-26','14:00:00',4.78),('15128','2013-05-26','14:05:00',4.9),('15128','2013-05-26','14:10:00',2.93),('15128','2013-05-26','14:15:00',4.67),('15128','2013-05-26','14:20:00',4.88),('15128','2013-05-26','14:25:00',4.78),('15128','2013-05-26','14:30:00',3.4),('15128','2013-05-26','14:35:00',4.31),('15128','2013-05-26','14:40:00',4.48),('15128','2013-05-26','14:45:00',4.83),('15128','2013-05-26','14:50:00',3.85),('15128','2013-05-26','14:55:00',3.1),('15128','2013-05-26','15:00:00',2.26),('15128','2013-05-26','15:05:00',4.97),('15128','2013-05-26','15:10:00',4.54),('15128','2013-05-26','15:15:00',2.38),('15128','2013-05-26','15:20:00',3.77),('15128','2013-05-26','15:25:00',4.52),('15128','2013-05-26','15:30:00',4.59),('15128','2013-05-26','15:35:00',4.21),('15128','2013-05-26','15:40:00',2.8),('15128','2013-05-26','15:45:00',4.38),('15128','2013-05-26','15:50:00',4.15),('15128','2013-05-26','15:55:00',3.88),('15128','2013-05-26','16:00:00',3.94),('15128','2013-05-26','16:05:00',3.35),('15128','2013-05-26','16:10:00',2.53),('15128','2013-05-26','16:15:00',3.11),('15128','2013-05-26','16:20:00',4.61),('15128','2013-05-26','16:25:00',4.05),('15128','2013-05-26','16:30:00',3.82),('15128','2013-05-26','16:35:00',3.82),('15128','2013-05-26','16:40:00',1.99),('15128','2013-05-26','16:45:00',1.47),('15128','2013-05-26','16:50:00',1.51),('15128','2013-05-26','16:55:00',1.6),('15128','2013-05-26','17:00:00',1.68),('15128','2013-05-26','17:05:00',1.92),('15128','2013-05-26','17:10:00',1.96),('15128','2013-05-26','17:15:00',1.49),('15128','2013-05-26','17:20:00',1.36),('15128','2013-05-26','17:25:00',1.35),('15128','2013-05-26','17:30:00',1.28),('15128','2013-05-26','17:35:00',1.18),('15128','2013-05-26','17:40:00',1.11),('15128','2013-05-26','17:45:00',1.07),('15128','2013-05-26','17:50:00',1.05),('15128','2013-05-26','17:55:00',1.03),('15128','2013-05-26','18:10:00',1.12),('15128','2013-05-26','18:15:00',1.19),('15128','2013-05-26','18:20:00',1.94),('15128','2013-05-26','18:25:00',2.53),('15128','2013-05-26','18:30:00',2.37),('15128','2013-05-26','18:35:00',1.32),('15128','2013-05-26','18:50:00',1.02),('15128','2013-05-26','18:55:00',1.43),('15128','2013-05-26','19:00:00',1.75),('15128','2013-05-26','19:05:00',1.63),('15128','2013-05-26','19:10:00',1.36),('15128','2013-05-26','19:15:00',1.09),('15128','2013-05-26','19:20:00',1.12),('15128','2013-05-26','19:25:00',1.06),('15128','2013-05-25','07:45:00',1.14),('15128','2013-05-25','08:00:00',1.02),('15128','2013-05-25','08:10:00',1.02),('15128','2013-05-25','08:15:00',1.82),('15128','2013-05-25','08:20:00',1.5),('15128','2013-05-25','08:25:00',1.17),('15128','2013-05-25','08:35:00',1.24),('15128','2013-05-25','08:40:00',1.98),('15128','2013-05-25','08:45:00',1.84),('15128','2013-05-25','08:55:00',1.72),('15128','2013-05-25','09:00:00',1.57),('15128','2013-05-25','09:05:00',1.67),('15128','2013-05-25','09:10:00',1.74),('15128','2013-05-25','09:15:00',1.41),('15128','2013-05-25','09:20:00',1.18),('15128','2013-05-25','09:25:00',1.92),('15128','2013-05-25','09:30:00',1.85),('15128','2013-05-25','09:35:00',1.01),('15128','2013-05-25','09:40:00',2.22),('15128','2013-05-25','09:50:00',2.21),('15128','2013-05-25','09:55:00',3.4),('15128','2013-05-25','10:00:00',3.07),('15128','2013-05-25','10:05:00',3.5),('15128','2013-05-25','10:10:00',2.92),('15128','2013-05-25','10:15:00',2.54),('15128','2013-05-25','10:20:00',3.39),('15128','2013-05-25','10:25:00',3.35),('15128','2013-05-25','10:30:00',3.46),('15128','2013-05-25','10:35:00',3.47),('15128','2013-05-25','10:40:00',3.51),('15128','2013-05-25','10:45:00',3.6),('15128','2013-05-25','10:50:00',3.69),('15128','2013-05-25','10:55:00',3.73),('15128','2013-05-25','11:00:00',3.7),('15128','2013-05-25','11:05:00',3.61),('15128','2013-05-25','11:10:00',3.94),('15128','2013-05-25','11:15:00',3.96),('15128','2013-05-25','11:20:00',4.05),('15128','2013-05-25','11:25:00',4.11),('15128','2013-05-25','11:30:00',4.22),('15128','2013-05-25','11:35:00',4.22),('15128','2013-05-25','11:40:00',4.34),('15128','2013-05-25','11:45:00',4.52),('15128','2013-05-25','11:50:00',4.61),('15128','2013-05-25','11:55:00',4.66),('15128','2013-05-25','12:00:00',4.71),('15128','2013-05-25','12:05:00',4.41),('15128','2013-05-25','12:10:00',4.74),('15128','2013-05-25','12:15:00',4.89),('15128','2013-05-25','12:20:00',4.46),('15128','2013-05-25','12:25:00',4.72),('15128','2013-05-25','12:30:00',5.11),('15128','2013-05-25','12:35:00',4.87),('15128','2013-05-25','12:40:00',5.01),('15128','2013-05-25','12:45:00',5),('15128','2013-05-25','12:50:00',5.34),('15128','2013-05-25','12:55:00',5.08),('15128','2013-05-25','13:00:00',3.53),('15128','2013-05-25','13:05:00',4.43),('15128','2013-05-25','13:10:00',4.54),('15128','2013-05-25','13:15:00',5.15),('15128','2013-05-25','13:20:00',5.14),('15128','2013-05-25','13:25:00',5.13),('15128','2013-05-25','13:30:00',5.16),('15128','2013-05-25','13:35:00',5.17),('15128','2013-05-25','13:40:00',5.12),('15128','2013-05-25','13:45:00',5.1),('15128','2013-05-25','13:50:00',5.12),('15128','2013-05-25','13:55:00',5.03),('15128','2013-05-25','14:00:00',5.1),('15128','2013-05-25','14:05:00',5.09),('15128','2013-05-25','14:10:00',5.08),('15128','2013-05-25','14:15:00',5.03),('15128','2013-05-25','14:20:00',5.04),('15128','2013-05-25','14:25:00',5.04),('15128','2013-05-25','14:30:00',5.05),('15128','2013-05-25','14:35:00',5.02),('15128','2013-05-25','14:40:00',4.99),('15128','2013-05-25','14:45:00',4.98),('15128','2013-05-25','14:50:00',4.94),('15128','2013-05-25','14:55:00',4.9),('15128','2013-05-25','15:00:00',4.86),('15128','2013-05-25','15:05:00',4.85),('15128','2013-05-25','15:10:00',4.81),('15128','2013-05-25','15:15:00',4.79),('15128','2013-05-25','15:20:00',4.74),('15128','2013-05-25','15:25:00',4.23),('15128','2013-05-25','15:35:00',2.69),('15128','2013-05-25','15:40:00',4.56),('15128','2013-05-25','15:45:00',4.54),('15128','2013-05-25','15:50:00',4.49),('15128','2013-05-25','15:55:00',2.76),('15128','2013-05-25','16:00:00',4.39),('15128','2013-05-25','16:05:00',4.36),('15128','2013-05-25','16:10:00',4.3),('15128','2013-05-25','16:15:00',2.93),('15128','2013-05-25','16:20:00',4.09),('15128','2013-05-25','16:25:00',4.15),('15128','2013-05-25','16:30:00',4.09),('15128','2013-05-25','16:35:00',3.09),('15128','2013-05-25','16:40:00',3.51),('15128','2013-05-25','16:45:00',3.9),('15128','2013-05-25','16:50:00',3.82),('15128','2013-05-25','16:55:00',3.61),('15128','2013-05-25','17:00:00',2.73),('15128','2013-05-25','17:05:00',3.62),('15128','2013-05-25','17:10:00',3.54),('15128','2013-05-25','17:15:00',3.48),('15128','2013-05-25','17:20:00',3.41),('15128','2013-05-25','17:25:00',3.33),('15128','2013-05-25','17:30:00',3.27),('15128','2013-05-25','17:35:00',3.16),('15128','2013-05-25','17:40:00',3.06),('15128','2013-05-25','17:45:00',2.97),('15128','2013-05-25','17:50:00',2.83),('15128','2013-05-25','17:55:00',2.74),('15128','2013-05-25','18:00:00',2.61),('15128','2013-05-25','18:05:00',2.49),('15128','2013-05-25','18:10:00',2.4),('15128','2013-05-25','18:15:00',2.3),('15128','2013-05-25','18:20:00',2.18),('15128','2013-05-25','18:25:00',2.09),('15128','2013-05-25','18:30:00',2.01),('15128','2013-05-25','18:35:00',1.95),('15128','2013-05-25','18:40:00',1.87),('15128','2013-05-25','18:45:00',1.8),('15128','2013-05-25','18:50:00',1.7),('15128','2013-05-25','18:55:00',1.6),('15128','2013-05-25','19:00:00',1.49),('15128','2013-05-25','19:05:00',1.37),('15128','2013-05-25','19:10:00',1.24),('15128','2013-05-25','19:15:00',1.03),('15128','2013-05-24','07:45:00',1.1),('15128','2013-05-24','08:15:00',1.29),('15128','2013-05-24','08:20:00',2.26),('15128','2013-05-24','08:25:00',1.12),('15128','2013-05-24','08:30:00',1.06),('15128','2013-05-24','08:35:00',2.01),('15128','2013-05-24','08:40:00',1.87),('15128','2013-05-24','08:45:00',1.5),('15128','2013-05-24','08:50:00',1.23),('15128','2013-05-24','08:55:00',2.32),('15128','2013-05-24','09:00:00',2.61),('15128','2013-05-24','09:05:00',3.18),('15128','2013-05-24','09:10:00',1.11),('15128','2013-05-24','09:15:00',1.14),('15128','2013-05-24','09:20:00',1.22),('15128','2013-05-24','09:25:00',2.85),('15128','2013-05-24','09:30:00',1.7),('15128','2013-05-24','09:35:00',1.19),('15128','2013-05-24','09:40:00',2.94),('15128','2013-05-24','09:45:00',1.78),('15128','2013-05-24','09:50:00',1.57),('15128','2013-05-24','10:05:00',1.31),('15128','2013-05-24','10:10:00',1.31),('15128','2013-05-24','10:15:00',1.31),('15128','2013-05-24','10:20:00',1.07),('15128','2013-05-24','10:30:00',1.69),('15128','2013-05-24','10:35:00',1.61),('15128','2013-05-24','10:50:00',1.35),('15128','2013-05-24','10:55:00',1.16),('15128','2013-05-24','11:00:00',2.55),('15128','2013-05-24','11:05:00',3.36),('15128','2013-05-24','11:10:00',1.44),('15128','2013-05-24','11:15:00',1.02),('15128','2013-05-24','11:25:00',1.74),('15128','2013-05-24','11:30:00',1.72),('15128','2013-05-24','11:35:00',1.46),('15128','2013-05-24','11:40:00',2.68),('15128','2013-05-24','11:45:00',3.49),('15128','2013-05-24','11:50:00',1.81),('15128','2013-05-24','11:55:00',2.22),('15128','2013-05-24','12:00:00',4.67),('15128','2013-05-24','12:05:00',3.54),('15128','2013-05-24','12:10:00',2.07),('15128','2013-05-24','12:15:00',1.78),('15128','2013-05-24','12:20:00',1.18),('15128','2013-05-24','12:30:00',1.05),('15128','2013-05-24','12:35:00',1.24),('15128','2013-05-24','12:40:00',2.38),('15128','2013-05-24','12:45:00',2.44),('15128','2013-05-24','12:50:00',2.85),('15128','2013-05-24','12:55:00',4.21),('15128','2013-05-24','13:00:00',3.64),('15128','2013-05-24','13:05:00',1.56),('15128','2013-05-24','13:10:00',2.33),('15128','2013-05-24','13:15:00',3.43),('15128','2013-05-24','13:20:00',2.08),('15128','2013-05-24','13:25:00',2.38),('15128','2013-05-24','13:30:00',4.4),('15128','2013-05-24','13:35:00',2.81),('15128','2013-05-24','13:40:00',3.26),('15128','2013-05-24','13:45:00',3.11),('15128','2013-05-24','13:50:00',3.5),('15128','2013-05-24','13:55:00',4.12),('15128','2013-05-24','14:00:00',3.97),('15128','2013-05-24','14:05:00',5.54),('15128','2013-05-24','14:10:00',5.56),('15128','2013-05-24','14:15:00',4.27),('15128','2013-05-24','14:20:00',3.16),('15128','2013-05-24','14:25:00',5.03),('15128','2013-05-24','14:30:00',4.57),('15128','2013-05-24','14:35:00',4.68),('15128','2013-05-24','14:40:00',5.45),('15128','2013-05-24','14:45:00',4.3),('15128','2013-05-24','14:50:00',4.4),('15128','2013-05-24','14:55:00',2.34),('15128','2013-05-24','15:00:00',3.13),('15128','2013-05-24','15:05:00',2.15),('15128','2013-05-24','15:10:00',5.37),('15128','2013-05-24','15:15:00',4.49),('15128','2013-05-24','15:20:00',3.08),('15128','2013-05-24','15:25:00',4.59),('15128','2013-05-24','15:30:00',4.68),('15128','2013-05-24','15:35:00',1.35),('15128','2013-05-24','15:40:00',2.15),('15128','2013-05-24','15:45:00',2.93),('15128','2013-05-24','15:50:00',3.61),('15128','2013-05-24','15:55:00',4.2),('15128','2013-05-24','16:00:00',3.01),('15128','2013-05-24','16:05:00',1.37),('15128','2013-05-24','16:10:00',1.38),('15128','2013-05-24','16:15:00',2.36),('15128','2013-05-24','16:20:00',4.47),('15128','2013-05-24','16:25:00',2.13),('15128','2013-05-24','16:30:00',2.48),('15128','2013-05-24','16:35:00',3.84),('15128','2013-05-24','16:40:00',2.19),('15128','2013-05-24','16:45:00',2.67),('15128','2013-05-24','16:50:00',2.86),('15128','2013-05-24','16:55:00',1.23),('15128','2013-05-24','17:00:00',3.03),('15128','2013-05-24','17:05:00',2.64),('15128','2013-05-24','17:10:00',2.12),('15128','2013-05-24','17:15:00',3.16),('15128','2013-05-24','17:20:00',2.83),('15128','2013-05-24','17:25:00',2.38),('15128','2013-05-24','17:30:00',1.92),('15128','2013-05-24','17:35:00',2.9),('15128','2013-05-24','17:40:00',2.36),('15128','2013-05-24','17:45:00',2.42),('15128','2013-05-24','17:50:00',2.1),('15128','2013-05-24','17:55:00',2.46),('15128','2013-05-24','18:00:00',1.6),('15128','2013-05-23','08:10:00',1.08),('15128','2013-05-23','08:20:00',1.35),('15128','2013-05-23','08:25:00',1.3),('15128','2013-05-23','08:30:00',1.05),('15128','2013-05-23','08:35:00',1.04),('15128','2013-05-23','08:40:00',1.69),('15128','2013-05-23','08:45:00',1.72),('15128','2013-05-23','08:50:00',1.95),('15128','2013-05-23','08:55:00',2.12),('15128','2013-05-23','09:00:00',2.16),('15128','2013-05-23','09:05:00',1.14),('15128','2013-05-23','09:10:00',2.51),('15128','2013-05-23','09:15:00',2.88),('15128','2013-05-23','09:20:00',1.1),('15128','2013-05-23','09:30:00',2.33),('15128','2013-05-23','09:35:00',2.71),('15128','2013-05-23','09:50:00',1.2),('15128','2013-05-23','09:55:00',3.2),('15128','2013-05-23','10:00:00',3.36),('15128','2013-05-23','10:05:00',1.98),('15128','2013-05-23','10:15:00',1.07),('15128','2013-05-23','10:20:00',1.07),('15128','2013-05-23','10:25:00',1.48),('15128','2013-05-23','10:30:00',3.79),('15128','2013-05-23','10:35:00',4.02),('15128','2013-05-23','10:40:00',3.85),('15128','2013-05-23','10:45:00',4.09),('15128','2013-05-23','10:50:00',3.91),('15128','2013-05-23','10:55:00',2.89),('15128','2013-05-23','11:00:00',2.11),('15128','2013-05-23','11:05:00',3.43),('15128','2013-05-23','11:10:00',1.8),('15128','2013-05-23','11:15:00',4.31),('15128','2013-05-23','11:20:00',3.82),('15128','2013-05-23','11:25:00',4.4),('15128','2013-05-23','11:30:00',3.53),('15128','2013-05-23','11:35:00',4.46),('15128','2013-05-23','11:40:00',3.07),('15128','2013-05-23','11:50:00',2.67),('15128','2013-05-23','11:55:00',1.81),('15128','2013-05-23','12:00:00',3.37),('15128','2013-05-23','12:05:00',4.11),('15128','2013-05-23','12:10:00',3.81),('15128','2013-05-23','12:15:00',2.42),('15128','2013-05-23','12:20:00',1.79),('15128','2013-05-23','12:25:00',2.88),('15128','2013-05-23','12:30:00',2.42),('15128','2013-05-23','12:35:00',2.42),('15128','2013-05-23','12:40:00',2.89),('15128','2013-05-23','12:45:00',3.12),('15128','2013-05-23','12:50:00',2.83),('15128','2013-05-23','12:55:00',2.78),('15128','2013-05-23','13:00:00',2.34),('15128','2013-05-23','13:05:00',4.17),('15128','2013-05-23','13:10:00',4.67),('15128','2013-05-23','13:15:00',4.35),('15128','2013-05-23','13:20:00',2.47),('15128','2013-05-23','13:25:00',2.73),('15128','2013-05-23','13:30:00',3.15),('15128','2013-05-23','13:35:00',3.51),('15128','2013-05-23','13:40:00',1.71),('15128','2013-05-23','13:45:00',1.34),('15128','2013-05-23','13:50:00',2.5),('15128','2013-05-23','13:55:00',2.55),('15128','2013-05-23','14:00:00',4.85),('15128','2013-05-23','14:05:00',4.44),('15128','2013-05-23','14:10:00',2.53),('15128','2013-05-23','14:15:00',2),('15128','2013-05-23','14:20:00',3.65),('15128','2013-05-23','14:25:00',5.17),('15128','2013-05-23','14:30:00',5.25),('15128','2013-05-23','14:35:00',4.6),('15128','2013-05-23','14:40:00',3.03),('15128','2013-05-23','14:45:00',3.29),('15128','2013-05-23','14:50:00',2.22),('15128','2013-05-23','14:55:00',2.11),('15128','2013-05-23','15:00:00',1.82),('15128','2013-05-23','15:05:00',2.22),('15128','2013-05-23','15:10:00',2.32),('15128','2013-05-23','15:15:00',5.27),('15128','2013-05-23','15:20:00',4.75),('15128','2013-05-23','15:25:00',4.34),('15128','2013-05-23','15:30:00',3.36),('15128','2013-05-23','15:35:00',3.03),('15128','2013-05-23','15:40:00',3.73),('15128','2013-05-23','15:45:00',3.93),('15128','2013-05-23','15:50:00',2.87),('15128','2013-05-23','15:55:00',2.11),('15128','2013-05-23','16:00:00',2.05),('15128','2013-05-23','16:05:00',2.03),('15128','2013-05-23','16:10:00',2.04),('15128','2013-05-23','16:15:00',1.69),('15128','2013-05-23','16:20:00',1.75),('15128','2013-05-23','16:25:00',1.65),('15128','2013-05-23','16:30:00',1.41),('15128','2013-05-23','16:35:00',1.41),('15128','2013-05-23','16:40:00',1.33),('15128','2013-05-23','16:45:00',1.55),('15128','2013-05-23','16:50:00',1.52),('15128','2013-05-23','16:55:00',1.22),('15128','2013-05-23','17:00:00',1.34),('15128','2013-05-23','17:05:00',1.41),('15128','2013-05-23','17:10:00',1.77),('15128','2013-05-23','17:15:00',1.87),('15128','2013-05-23','17:20:00',1.16),('15128','2013-05-23','17:25:00',1.41),('15128','2013-05-23','17:30:00',1.51),('15128','2013-05-23','17:35:00',1.46),('15128','2013-05-23','17:40:00',1.2),('15128','2013-05-22','07:00:00',1.11),('15128','2013-05-22','07:05:00',1.03),('15128','2013-05-22','07:45:00',1.17),('15128','2013-05-22','07:50:00',1.15),('15128','2013-05-22','08:05:00',1.05),('15128','2013-05-22','08:30:00',1.46),('15128','2013-05-22','08:35:00',2.23),('15128','2013-05-22','08:45:00',1.23),('15128','2013-05-22','08:50:00',1.53),('15128','2013-05-22','09:10:00',1.06),('15128','2013-05-22','09:15:00',1.62),('15128','2013-05-22','09:20:00',1.46),('15128','2013-05-22','09:25:00',2.72),('15128','2013-05-22','09:30:00',2.86),('15128','2013-05-22','09:35:00',2.09),('15128','2013-05-22','09:40:00',1.43),('15128','2013-05-22','09:45:00',1.34),('15128','2013-05-22','09:50:00',1.97),('15128','2013-05-22','09:55:00',1.11),('15128','2013-05-22','10:00:00',3.81),('15128','2013-05-22','10:05:00',1.24),('15128','2013-05-22','10:10:00',3.09),('15128','2013-05-22','10:15:00',3.29),('15128','2013-05-22','10:20:00',3.08),('15128','2013-05-22','10:25:00',3.12),('15128','2013-05-22','10:30:00',2.22),('15128','2013-05-22','10:35:00',2.61),('15128','2013-05-22','10:40:00',2.76),('15128','2013-05-22','10:45:00',3.15),('15128','2013-05-22','10:50:00',2.57),('15128','2013-05-22','10:55:00',2.54),('15128','2013-05-22','11:00:00',2.63),('15128','2013-05-22','11:05:00',3.27),('15128','2013-05-22','11:10:00',3.13),('15128','2013-05-22','11:15:00',2.45),('15128','2013-05-22','11:20:00',2.88),('15128','2013-05-22','11:25:00',1.41),('15128','2013-05-22','11:30:00',2.36),('15128','2013-05-22','11:35:00',1.68),('15128','2013-05-22','11:40:00',3.05),('15128','2013-05-22','11:45:00',2.25),('15128','2013-05-22','11:50:00',1.02),('15128','2013-05-22','11:55:00',1.44),('15128','2013-05-22','12:00:00',2.31),('15128','2013-05-22','12:05:00',2.37),('15128','2013-05-22','12:10:00',3.21),('15128','2013-05-22','12:15:00',4.81),('15128','2013-05-22','12:20:00',4.58),('15128','2013-05-22','12:25:00',4.41),('15128','2013-05-22','12:35:00',1.85),('15128','2013-05-22','12:40:00',5.69),('15128','2013-05-22','12:45:00',5.35),('15128','2013-05-22','12:50:00',4.91),('15128','2013-05-22','12:55:00',3.64),('15128','2013-05-22','13:00:00',2.36),('15128','2013-05-22','13:05:00',5.42),('15128','2013-05-22','13:10:00',4.43),('15128','2013-05-22','13:15:00',5.32),('15128','2013-05-22','13:20:00',4.28),('15128','2013-05-22','13:25:00',4.39),('15128','2013-05-22','13:30:00',5.02),('15128','2013-05-22','13:35:00',3.43),('15128','2013-05-22','13:40:00',4.65),('15128','2013-05-22','13:45:00',5.38),('15128','2013-05-22','13:50:00',4.73),('15128','2013-05-22','13:55:00',4.12),('15128','2013-05-22','14:00:00',3.42),('15128','2013-05-22','14:05:00',3.22),('15128','2013-05-22','14:10:00',5.53),('15128','2013-05-22','14:15:00',4.03),('15128','2013-05-22','14:20:00',4.69),('15128','2013-05-22','14:25:00',3.68),('15128','2013-05-22','14:30:00',5.18),('15128','2013-05-22','14:35:00',4.95),('15128','2013-05-22','14:45:00',2.7),('15128','2013-05-22','14:50:00',3.39),('15128','2013-05-22','14:55:00',4.31),('15128','2013-05-22','15:00:00',5.18),('15128','2013-05-22','15:05:00',2.16),('15128','2013-05-22','15:10:00',3.25),('15128','2013-05-22','15:15:00',2.63),('15128','2013-05-22','15:20:00',3.44),('15128','2013-05-22','15:25:00',2.67),('15128','2013-05-22','15:30:00',2),('15128','2013-05-22','15:35:00',3.93),('15128','2013-05-22','15:40:00',1.42),('15128','2013-05-22','15:45:00',3.22),('15128','2013-05-22','15:50:00',4),('15128','2013-05-22','15:55:00',4.44),('15128','2013-05-22','16:00:00',2.73),('15128','2013-05-22','16:05:00',3.03),('15128','2013-05-22','16:10:00',2.81),('15128','2013-05-22','16:15:00',2.65),('15128','2013-05-22','16:20:00',2.65),('15128','2013-05-22','16:25:00',1.46),('15128','2013-05-22','16:30:00',2.42),('15128','2013-05-22','16:35:00',2.05),('15128','2013-05-22','16:40:00',1.08),('15128','2013-05-22','16:45:00',1.85),('15128','2013-05-22','16:50:00',1.85),('15128','2013-05-22','16:55:00',2.1),('15128','2013-05-22','17:00:00',3.41),('15128','2013-05-22','17:05:00',1.15),('15128','2013-05-22','17:15:00',1.22),('15128','2013-05-22','17:30:00',1.67),('15128','2013-05-22','17:35:00',1.57),('15128','2013-05-22','17:40:00',1.56),('15128','2013-05-22','17:45:00',1.68),('15128','2013-05-22','17:50:00',3.28),('15128','2013-05-22','17:55:00',2.78),('15128','2013-05-22','18:00:00',1.01),('15128','2013-05-22','18:40:00',1.22),('15128','2013-05-22','18:45:00',1.38),('15128','2013-05-21','08:05:00',1.1),('15128','2013-05-21','08:10:00',1.29),('15128','2013-05-21','08:25:00',1.92),('15128','2013-05-21','08:30:00',2.16),('15128','2013-05-21','08:35:00',1.01),('15128','2013-05-21','09:25:00',1.62),('15128','2013-05-21','09:30:00',2.21),('15128','2013-05-21','09:35:00',2.62),('15128','2013-05-21','09:40:00',2.56),('15128','2013-05-21','09:45:00',2.54),('15128','2013-05-21','09:50:00',2.59),('15128','2013-05-21','09:55:00',2.65),('15128','2013-05-21','10:00:00',2.77),('15128','2013-05-21','10:05:00',2.81),('15128','2013-05-21','10:10:00',2.89),('15128','2013-05-21','10:15:00',2.93),('15128','2013-05-21','10:20:00',2.98),('15128','2013-05-21','10:25:00',3.05),('15128','2013-05-21','10:30:00',3.08),('15128','2013-05-21','10:35:00',2.52),('15128','2013-05-21','10:40:00',2),('15128','2013-05-21','10:45:00',3.05),('15128','2013-05-21','10:50:00',3.62),('15128','2013-05-21','10:55:00',3.51),('15128','2013-05-21','11:00:00',3.57),('15128','2013-05-21','11:05:00',3.57),('15128','2013-05-21','11:10:00',3.55),('15128','2013-05-21','11:15:00',3.62),('15128','2013-05-21','11:20:00',3.66),('15128','2013-05-21','11:25:00',3.82),('15128','2013-05-21','11:30:00',3.71),('15128','2013-05-21','11:35:00',3.93),('15128','2013-05-21','11:40:00',3.14),('15128','2013-05-21','11:45:00',3.26),('15128','2013-05-21','11:50:00',4.24),('15128','2013-05-21','11:55:00',3.43),('15128','2013-05-21','12:00:00',2.26),('15128','2013-05-21','12:05:00',2.57),('15128','2013-05-21','12:10:00',2.27),('15128','2013-05-21','12:15:00',2.29),('15128','2013-05-21','12:20:00',4.94),('15128','2013-05-21','12:25:00',5.01),('15128','2013-05-21','12:30:00',3.06),('15128','2013-05-21','12:35:00',1.62),('15128','2013-05-21','12:40:00',1.5),('15128','2013-05-21','12:45:00',1.12),('15128','2013-05-21','13:10:00',1.92),('15128','2013-05-21','13:15:00',2.52),('15128','2013-05-21','13:20:00',2.67),('15128','2013-05-21','13:25:00',1.59),('15128','2013-05-21','13:30:00',2.56),('15128','2013-05-21','13:35:00',2.52),('15128','2013-05-21','13:40:00',4.48),('15128','2013-05-21','13:45:00',3.73),('15128','2013-05-21','13:50:00',5.05),('15128','2013-05-21','13:55:00',4.17),('15128','2013-05-21','14:00:00',4.25),('15128','2013-05-21','14:05:00',3.69),('15128','2013-05-21','14:10:00',4.27),('15128','2013-05-21','14:15:00',4.46),('15128','2013-05-21','14:20:00',4.41),('15128','2013-05-21','14:25:00',4.42),('15128','2013-05-21','14:30:00',4.4),('15128','2013-05-21','14:35:00',4.38),('15128','2013-05-21','14:40:00',4.38),('15128','2013-05-21','14:45:00',4.35),('15128','2013-05-21','14:50:00',4.33),('15128','2013-05-21','14:55:00',4.29),('15128','2013-05-21','15:00:00',4.28),('15128','2013-05-21','15:05:00',4.14),('15128','2013-05-21','15:10:00',3.68),('15128','2013-05-21','15:15:00',3.95),('15128','2013-05-21','15:20:00',4.15),('15128','2013-05-21','15:25:00',3.52),('15128','2013-05-21','15:30:00',4.28),('15128','2013-05-21','15:35:00',4.21),('15128','2013-05-21','15:40:00',3.63),('15128','2013-05-21','15:45:00',4.18),('15128','2013-05-21','15:50:00',3.97),('15128','2013-05-21','15:55:00',3.84),('15128','2013-05-21','16:00:00',3.83),('15128','2013-05-21','16:05:00',3.75),('15128','2013-05-21','16:10:00',3.69),('15128','2013-05-21','16:15:00',3.67),('15128','2013-05-21','16:20:00',3.59),('15128','2013-05-21','16:25:00',3.55),('15128','2013-05-21','16:30:00',3.5),('15128','2013-05-21','16:35:00',2.41),('15128','2013-05-21','16:40:00',1.81),('15128','2013-05-21','16:45:00',3.26),('15128','2013-05-21','16:50:00',2.98),('15128','2013-05-21','16:55:00',1.01),('15128','2013-05-21','17:20:00',1.02),('15128','2013-05-21','17:25:00',1.32),('15128','2013-05-21','17:30:00',1.66),('15128','2013-05-21','17:35:00',1.48),('15128','2013-05-21','17:40:00',1.52),('15128','2013-05-21','17:45:00',1.12),('15128','2013-05-21','18:00:00',1.12),('15128','2013-05-21','18:05:00',1.95),('15128','2013-05-21','18:10:00',1.64),('15128','2013-05-21','18:15:00',1.16),('15128','2013-05-21','18:20:00',1.24),('15128','2013-05-21','18:35:00',1.36),('15128','2013-05-21','18:40:00',1.5),('15128','2013-05-21','18:45:00',1.57),('15128','2013-05-21','18:50:00',1.26),('15128','2014-03-31','09:00:00',1.03),('15128','2014-03-31','09:05:00',1.08),('15128','2014-03-31','09:10:00',1.16),('15128','2014-03-31','09:15:00',1.23),('15128','2014-03-31','09:20:00',1.33),('15128','2014-03-31','09:25:00',1.38),('15128','2014-03-31','09:30:00',1.43),('15128','2014-03-31','09:35:00',1.48),('15128','2014-03-31','09:40:00',1.52),('15128','2014-03-31','09:45:00',1.58),('15128','2014-03-31','09:50:00',1.64),('15128','2014-03-31','09:55:00',1.72),('15128','2014-03-31','10:00:00',1.79),('15128','2014-03-31','10:05:00',1.85),('15128','2014-03-31','10:10:00',1.93),('15128','2014-03-31','10:15:00',1.97),('15128','2014-03-31','10:20:00',2.01),('15128','2014-03-31','10:25:00',2.13),('15128','2014-03-31','10:30:00',2.12),('15128','2014-03-31','10:35:00',2.3),('15128','2014-03-31','10:40:00',2.39),('15128','2014-03-31','10:45:00',2.21),('15128','2014-03-31','10:50:00',2.64),('15128','2014-03-31','10:55:00',2.49),('15128','2014-03-31','11:00:00',2.41),('15128','2014-03-31','11:05:00',2.42),('15128','2014-03-31','11:10:00',2.62),('15128','2014-03-31','11:15:00',2.75),('15128','2014-03-31','11:20:00',2.84),('15128','2014-03-31','11:25:00',2.93),('15128','2014-03-31','11:30:00',2.97),('15128','2014-03-31','11:35:00',2.93),('15128','2014-03-31','11:40:00',3.01),('15128','2014-03-31','11:45:00',3.11),('15128','2014-03-31','11:50:00',3.23),('15128','2014-03-31','11:55:00',3.39),('15128','2014-03-31','12:00:00',2.9),('15128','2014-03-31','12:05:00',3.52),('15128','2014-03-31','12:10:00',3.5),('15128','2014-03-31','12:15:00',3.61),('15128','2014-03-31','12:20:00',3.69),('15128','2014-03-31','12:25:00',3.75),('15128','2014-03-31','12:30:00',3.8),('15128','2014-03-31','12:35:00',3.84),('15128','2014-03-31','12:40:00',3.87),('15128','2014-03-31','12:45:00',3.61),('15128','2014-03-31','12:50:00',3.96),('15128','2014-03-31','12:55:00',4.02),('15128','2014-03-31','13:00:00',3.97),('15128','2014-03-31','13:05:00',3.99),('15128','2014-03-31','13:10:00',4.01),('15128','2014-03-31','13:15:00',4.01),('15128','2014-03-31','13:20:00',3.97),('15128','2014-03-31','13:25:00',3.9),('15128','2014-03-31','13:30:00',3.66),('15128','2014-03-31','13:35:00',3.41),('15128','2014-03-31','13:40:00',4.13),('15128','2014-03-31','13:45:00',4.43),('15128','2014-03-31','13:50:00',3.81),('15128','2014-03-31','13:55:00',3.96),('15128','2014-03-31','14:00:00',3.37),('15128','2014-03-31','14:05:00',4.26),('15128','2014-03-31','14:10:00',4.22),('15128','2014-03-31','14:15:00',3.99),('15128','2014-03-31','14:20:00',4.11),('15128','2014-03-31','14:25:00',4.16),('15128','2014-03-31','14:30:00',3.86),('15128','2014-03-31','14:35:00',3.4),('15128','2014-03-31','14:40:00',4.31),('15128','2014-03-31','14:45:00',4.28),('15128','2014-03-31','14:50:00',4.11),('15128','2014-03-31','14:55:00',3.91),('15128','2014-03-31','15:00:00',4.02),('15128','2014-03-31','15:05:00',3.77),('15128','2014-03-31','15:10:00',3.29),('15128','2014-03-31','15:15:00',2.92),('15128','2014-03-31','15:20:00',3.32),('15128','2014-03-31','15:25:00',3.81),('15128','2014-03-31','15:30:00',3.91),('15128','2014-03-31','15:35:00',3.86),('15128','2014-03-31','15:40:00',3.52),('15128','2014-03-31','15:45:00',2.46),('15128','2014-03-31','15:50:00',3.83),('15128','2014-03-31','15:55:00',3.85),('15128','2014-03-31','16:00:00',2.02),('15128','2014-03-31','16:05:00',2.41),('15128','2014-03-31','16:10:00',2.28),('15128','2014-03-31','16:15:00',3.49),('15128','2014-03-31','16:20:00',3.36),('15128','2014-03-31','16:25:00',2.63),('15128','2014-03-31','16:30:00',2.95),('15128','2014-03-31','16:35:00',2.92),('15128','2014-03-31','16:40:00',2.4),('15128','2014-03-31','16:45:00',2.22),('15128','2014-03-31','16:50:00',1.57),('15128','2014-03-31','16:55:00',2.53),('15128','2014-03-31','17:00:00',2.79),('15128','2014-03-31','17:05:00',2.39),('15128','2014-03-31','17:10:00',2.09),('15128','2014-03-31','17:15:00',1.66),('15128','2014-03-31','17:20:00',1.01),('15128','2014-03-31','17:25:00',2.01),('15128','2014-03-31','17:30:00',2.07),('15128','2014-03-31','17:35:00',1.74),('15128','2014-03-31','17:40:00',1.78),('15128','2014-03-31','17:45:00',1.61),('15128','2014-03-31','17:50:00',1.53),('15128','2014-03-31','17:55:00',1.61),('15128','2014-03-31','18:00:00',1.49),('15128','2014-03-31','18:10:00',1.22),('15128','2014-03-31','18:20:00',1.03),('15128','2013-05-20','08:05:00',1.35),('15128','2013-05-20','08:10:00',1.68),('15128','2013-05-20','08:15:00',1.34),('15128','2013-05-20','08:20:00',1.38),('15128','2013-05-20','08:25:00',1.47),('15128','2013-05-20','08:30:00',1.27),('15128','2013-05-20','08:35:00',1.46),('15128','2013-05-20','08:40:00',1.49),('15128','2013-05-20','08:45:00',1.29),('15128','2013-05-20','08:50:00',1.29),('15128','2013-05-20','08:55:00',1.49),('15128','2013-05-20','09:00:00',1.51),('15128','2013-05-20','09:05:00',1.35),('15128','2013-05-20','09:10:00',1.55),('15128','2013-05-20','09:15:00',1.92),('15128','2013-05-20','09:20:00',2.26),('15128','2013-05-20','09:25:00',1.96),('15128','2013-05-20','09:30:00',2.03),('15128','2013-05-20','09:35:00',2.08),('15128','2013-05-20','09:40:00',1.89),('15128','2013-05-20','09:45:00',1.77),('15128','2013-05-20','09:50:00',1.87),('15128','2013-05-20','09:55:00',1.78),('15128','2013-05-20','10:00:00',2.17),('15128','2013-05-20','10:05:00',2.11),('15128','2013-05-20','10:10:00',1.94),('15128','2013-05-20','10:15:00',1.87),('15128','2013-05-20','10:20:00',1.91),('15128','2013-05-20','10:25:00',2.42),('15128','2013-05-20','10:30:00',2.03),('15128','2013-05-20','10:35:00',1.93),('15128','2013-05-20','10:40:00',2.62),('15128','2013-05-20','10:45:00',2.95),('15128','2013-05-20','10:50:00',2.55),('15128','2013-05-20','10:55:00',1.94),('15128','2013-05-20','11:00:00',1.54),('15128','2013-05-20','11:05:00',1.69),('15128','2013-05-20','11:10:00',2.83),('15128','2013-05-20','11:15:00',3.33),('15128','2013-05-20','11:20:00',3.49),('15128','2013-05-20','11:25:00',4.22),('15128','2013-05-20','11:30:00',2.68),('15128','2013-05-20','11:35:00',2.66),('15128','2013-05-20','11:40:00',2.46),('15128','2013-05-20','11:45:00',3.21),('15128','2013-05-20','11:50:00',3.15),('15128','2013-05-20','11:55:00',2.89),('15128','2013-05-20','12:00:00',2.36),('15128','2013-05-20','12:05:00',3.72),('15128','2013-05-20','12:10:00',3.74),('15128','2013-05-20','12:15:00',3.26),('15128','2013-05-20','12:20:00',2.54),('15128','2013-05-20','12:25:00',2.66),('15128','2013-05-20','12:30:00',2.73),('15128','2013-05-20','12:35:00',3.01),('15128','2013-05-20','12:40:00',3.06),('15128','2013-05-20','12:45:00',2.5),('15128','2013-05-20','12:50:00',4.65),('15128','2013-05-20','12:55:00',2.86),('15128','2013-05-20','13:00:00',3.12),('15128','2013-05-20','13:05:00',3.19),('15128','2013-05-20','13:10:00',3.6),('15128','2013-05-20','13:15:00',3.97),('15128','2013-05-20','13:20:00',3.73),('15128','2013-05-20','13:25:00',2.52),('15128','2013-05-20','13:30:00',1.75),('15128','2013-05-20','13:35:00',1.53),('15128','2013-05-20','13:40:00',1.38),('15128','2013-05-20','13:45:00',1),('15128','2013-05-20','14:10:00',1.69),('15128','2013-05-20','14:15:00',2.2),('15128','2013-05-20','14:20:00',2.33),('15128','2013-05-20','14:25:00',3.63),('15128','2013-05-20','14:30:00',4),('15128','2013-05-20','14:35:00',3.33),('15128','2013-05-20','14:40:00',2.4),('15128','2013-05-20','14:45:00',1.42),('15128','2013-05-20','15:15:00',1.26),('15128','2013-05-20','15:20:00',1.77),('15128','2013-05-20','15:25:00',2.86),('15128','2013-05-20','15:30:00',3.32),('15128','2013-05-20','15:35:00',3.67),('15128','2013-05-20','15:40:00',2.34),('15128','2013-05-20','15:45:00',2.31),('15128','2013-05-20','15:50:00',1.49),('15128','2013-05-20','15:55:00',1.11),('15128','2013-05-20','16:05:00',1.26),('15128','2013-05-20','16:10:00',1.25),('15128','2013-05-20','16:25:00',1.27),('15128','2013-05-20','16:30:00',1.71),('15128','2013-05-20','16:35:00',1.73),('15128','2013-05-20','16:40:00',1.52),('15128','2013-05-20','16:45:00',1.25),('15128','2013-05-19','08:10:00',1.26),('15128','2013-05-19','08:15:00',1.36),('15128','2013-05-19','08:20:00',1.6),('15128','2013-05-19','08:25:00',1.21),('15128','2013-05-19','08:30:00',1.39),('15128','2013-05-19','08:35:00',1.86),('15128','2013-05-19','08:40:00',1.67),('15128','2013-05-19','08:45:00',1.2),('15128','2013-05-19','09:40:00',1.6),('15128','2013-05-19','09:45:00',2.51),('15128','2013-05-19','09:55:00',1.08),('15128','2013-05-19','10:00:00',3.32),('15128','2013-05-19','10:05:00',3.25),('15128','2013-05-19','10:10:00',3.33),('15128','2013-05-19','10:15:00',3.21),('15128','2013-05-19','10:20:00',3.33),('15128','2013-05-19','10:25:00',3.42),('15128','2013-05-19','10:30:00',3.6),('15128','2013-05-19','10:35:00',1.62),('15128','2013-05-19','10:40:00',2.8),('15128','2013-05-19','10:45:00',3.23),('15128','2013-05-19','10:50:00',3.45),('15128','2013-05-19','10:55:00',3.91),('15128','2013-05-19','11:00:00',4.11),('15128','2013-05-19','11:05:00',3.62),('15128','2013-05-19','11:10:00',3.82),('15128','2013-05-19','11:15:00',2.34),('15128','2013-05-19','11:20:00',3.38),('15128','2013-05-19','11:25:00',2.29),('15128','2013-05-19','11:30:00',2.44),('15128','2013-05-19','11:35:00',2.93),('15128','2013-05-19','11:40:00',2.6),('15128','2013-05-19','11:45:00',3.96),('15128','2013-05-19','11:50:00',4.67),('15128','2013-05-19','11:55:00',3.65),('15128','2013-05-19','12:00:00',4.54),('15128','2013-05-19','12:05:00',4.56),('15128','2013-05-19','12:10:00',4.46),('15128','2013-05-19','12:15:00',4.03),('15128','2013-05-19','12:20:00',4.65),('15128','2013-05-19','12:25:00',4.64),('15128','2013-05-19','12:30:00',4.65),('15128','2013-05-19','12:35:00',4.66),('15128','2013-05-19','12:40:00',4.69),('15128','2013-05-19','12:45:00',4.7),('15128','2013-05-19','12:50:00',4.75),('15128','2013-05-19','12:55:00',4.79),('15128','2013-05-19','13:00:00',4.79),('15128','2013-05-19','13:05:00',4.71),('15128','2013-05-19','13:10:00',4.84),('15128','2013-05-19','13:15:00',4.87),('15128','2013-05-19','13:20:00',4.86),('15128','2013-05-19','13:25:00',4.84),('15128','2013-05-19','13:30:00',4.86),('15128','2013-05-19','13:35:00',4.85),('15128','2013-05-19','13:40:00',4.87),('15128','2013-05-19','13:45:00',4.86),('15128','2013-05-19','13:55:00',1.92),('15128','2013-05-19','14:00:00',4.79),('15128','2013-05-19','14:05:00',4.82),('15128','2013-05-19','14:10:00',4.81),('15128','2013-05-19','14:15:00',2.9),('15128','2013-05-19','14:20:00',4.61),('15128','2013-05-19','14:25:00',4.74),('15128','2013-05-19','14:30:00',4.72),('15128','2013-05-19','14:35:00',3.41),('15128','2013-05-19','14:40:00',4.07),('15128','2013-05-19','14:45:00',4.66),('15128','2013-05-19','14:50:00',4.64),('15128','2013-05-19','14:55:00',4.02),('15128','2013-05-19','15:00:00',3.29),('15128','2013-05-19','15:05:00',4.58),('15128','2013-05-19','15:10:00',4.56),('15128','2013-05-19','15:15:00',4.56),('15128','2013-05-19','15:20:00',2.74),('15128','2013-05-19','15:25:00',4.46),('15128','2013-05-19','15:30:00',4.45),('15128','2013-05-19','15:35:00',4.42),('15128','2013-05-19','15:40:00',4.35),('15128','2013-05-19','15:45:00',4.3),('15128','2013-05-19','15:50:00',4.27),('15128','2013-05-19','15:55:00',4.24),('15128','2013-05-19','16:00:00',4.17),('15128','2013-05-19','16:05:00',4.12),('15128','2013-05-19','16:10:00',4.1),('15128','2013-05-19','16:15:00',4.05),('15128','2013-05-19','16:20:00',4),('15128','2013-05-19','16:25:00',3.98),('15128','2013-05-19','16:30:00',3.92),('15128','2013-05-19','16:35:00',3.81),('15128','2013-05-19','16:40:00',3.61),('15128','2013-05-19','16:45:00',3.51),('15128','2013-05-19','16:50:00',3.72),('15128','2013-05-19','16:55:00',3.33),('15128','2013-05-19','17:00:00',2.05),('15128','2013-05-19','17:05:00',3.37),('15128','2013-05-19','17:10:00',2.84),('15128','2013-05-19','17:15:00',1.99),('15128','2013-05-19','17:20:00',3.78),('15128','2013-05-19','17:25:00',3.27),('15128','2013-05-19','17:30:00',3.06),('15128','2013-05-19','17:35:00',2.85),('15128','2013-05-19','17:40:00',2.79),('15128','2013-05-19','17:45:00',2.65),('15128','2013-05-19','17:50:00',2.51),('15128','2013-05-19','17:55:00',2.45),('15128','2013-05-19','18:00:00',1.97),('15128','2013-05-19','18:05:00',1.81),('15128','2013-05-19','18:10:00',2.17),('15128','2013-05-19','18:15:00',2.09),('15128','2013-05-19','18:20:00',1.94),('15128','2013-05-19','18:25:00',1.86),('15128','2013-05-19','18:30:00',1.77),('15128','2013-05-19','18:35:00',1.6),('15128','2013-05-19','18:45:00',1.13),('15128','2013-05-19','18:50:00',1.45),('15128','2013-05-19','18:55:00',1.33),('15128','2013-05-19','19:00:00',1.22),('15128','2013-05-19','19:05:00',1.12),('15128','2013-05-19','19:10:00',1.02),('15128','2013-05-18','08:30:00',1.13),('15128','2013-05-18','08:35:00',1.28),('15128','2013-05-18','08:40:00',1.11),('15128','2013-05-18','08:45:00',1.09),('15128','2013-05-18','08:50:00',1.12),('15128','2013-05-18','08:55:00',1.32),('15128','2013-05-18','09:30:00',1.53),('15128','2013-05-18','09:35:00',1.41),('15128','2013-05-18','09:40:00',1.13),('15128','2013-05-18','09:45:00',1.57),('15128','2013-05-18','09:50:00',1.55),('15128','2013-05-18','09:55:00',1.72),('15128','2013-05-18','10:00:00',1.86),('15128','2013-05-18','10:05:00',2.18),('15128','2013-05-18','10:10:00',2.19),('15128','2013-05-18','10:15:00',2.85),('15128','2013-05-18','10:20:00',2.91),('15128','2013-05-18','10:25:00',2.46),('15128','2013-05-18','10:30:00',3.22),('15128','2013-05-18','10:35:00',3.36),('15128','2013-05-18','10:40:00',2.73),('15128','2013-05-18','10:45:00',2.61),('15128','2013-05-18','10:50:00',2.01),('15128','2013-05-18','10:55:00',2.26),('15128','2013-05-18','11:00:00',2.36),('15128','2013-05-18','11:05:00',2.46),('15128','2013-05-18','11:10:00',2.93),('15128','2013-05-18','11:15:00',4.05),('15128','2013-05-18','11:20:00',4.3),('15128','2013-05-18','11:25:00',4.3),('15128','2013-05-18','11:30:00',4.15),('15128','2013-05-18','11:35:00',4.18),('15128','2013-05-18','11:40:00',4.25),('15128','2013-05-18','11:45:00',4.31),('15128','2013-05-18','11:50:00',4.52),('15128','2013-05-18','11:55:00',4.54),('15128','2013-05-18','12:00:00',4.57),('15128','2013-05-18','12:05:00',4.64),('15128','2013-05-18','12:10:00',4.68),('15128','2013-05-18','12:15:00',4.7),('15128','2013-05-18','12:20:00',4.73),('15128','2013-05-18','12:25:00',4.75),('15128','2013-05-18','12:30:00',4.78),('15128','2013-05-18','12:35:00',4.83),('15128','2013-05-18','12:40:00',4.92),('15128','2013-05-18','12:45:00',4.33),('15128','2013-05-18','12:50:00',4.95),('15128','2013-05-18','12:55:00',4.91),('15128','2013-05-18','13:00:00',4.93),('15128','2013-05-18','13:05:00',4.89),('15128','2013-05-18','13:10:00',4.9),('15128','2013-05-18','13:15:00',4.91),('15128','2013-05-18','13:20:00',4.91),('15128','2013-05-18','13:25:00',4.93),('15128','2013-05-18','13:30:00',4.96),('15128','2013-05-18','13:35:00',4.96),('15128','2013-05-18','13:40:00',4.94),('15128','2013-05-18','13:45:00',4.9),('15128','2013-05-18','13:50:00',4.93),('15128','2013-05-18','13:55:00',4.91),('15128','2013-05-18','14:00:00',4.94),('15128','2013-05-18','14:05:00',4.94),('15128','2013-05-18','14:10:00',4.93),('15128','2013-05-18','14:15:00',4.94),('15128','2013-05-18','14:20:00',4.92),('15128','2013-05-18','14:25:00',4.91),('15128','2013-05-18','14:30:00',4.87),('15128','2013-05-18','14:35:00',4.82),('15128','2013-05-18','14:40:00',4.79),('15128','2013-05-18','14:45:00',4.78),('15128','2013-05-18','14:50:00',4.83),('15128','2013-05-18','14:55:00',4.77),('15128','2013-05-18','15:00:00',4.75),('15128','2013-05-18','15:05:00',4.78),('15128','2013-05-18','15:10:00',4.78),('15128','2013-05-18','15:15:00',4.71),('15128','2013-05-18','15:20:00',4.68),('15128','2013-05-18','15:25:00',4.61),('15128','2013-05-18','15:30:00',4.58),('15128','2013-05-18','15:35:00',4.53),('15128','2013-05-18','15:40:00',4.5),('15128','2013-05-18','15:45:00',4.45),('15128','2013-05-18','15:50:00',4.43),('15128','2013-05-18','15:55:00',4.36),('15128','2013-05-18','16:00:00',4.33),('15128','2013-05-18','16:05:00',4.26),('15128','2013-05-18','16:10:00',4.19),('15128','2013-05-18','16:15:00',4.15),('15128','2013-05-18','16:20:00',4.1),('15128','2013-05-18','16:25:00',4.06),('15128','2013-05-18','16:30:00',4),('15128','2013-05-18','16:35:00',3.95),('15128','2013-05-18','16:40:00',3.88),('15128','2013-05-18','16:45:00',3.83),('15128','2013-05-18','16:50:00',3.73),('15128','2013-05-18','16:55:00',3.68),('15128','2013-05-18','17:00:00',3.63),('15128','2013-05-18','17:05:00',3.54),('15128','2013-05-18','17:10:00',3.46),('15128','2013-05-18','17:15:00',3.39),('15128','2013-05-18','17:20:00',3.33),('15128','2013-05-18','17:25:00',3.28),('15128','2013-05-18','17:30:00',3.2),('15128','2013-05-18','17:35:00',3.12),('15128','2013-05-18','17:40:00',3.02),('15128','2013-05-18','17:45:00',2.88),('15128','2013-05-18','17:50:00',2.75),('15128','2013-05-18','17:55:00',2.63),('15128','2013-05-18','18:00:00',2.5),('15128','2013-05-18','18:05:00',2.4),('15128','2013-05-18','18:10:00',2.31),('15128','2013-05-18','18:15:00',2.21),('15128','2013-05-18','18:20:00',2.1),('15128','2013-05-18','18:25:00',2.03),('15128','2013-05-18','18:30:00',1.96),('15128','2013-05-18','18:35:00',1.89),('15128','2013-05-18','18:40:00',1.81),('15128','2013-05-18','18:45:00',1.73),('15128','2013-05-18','18:50:00',1.61),('15128','2013-05-18','18:55:00',1.51),('15128','2013-05-18','19:00:00',1.38),('15128','2013-05-18','19:05:00',1.27),('15128','2013-05-18','19:10:00',1.12),('15128','2013-05-17','07:50:00',1.02),('15128','2013-05-17','08:00:00',1.32),('15128','2013-05-17','08:05:00',1.13),('15128','2013-05-17','08:15:00',1.01),('15128','2013-05-17','08:20:00',1.21),('15128','2013-05-17','08:25:00',1.24),('15128','2013-05-17','08:30:00',1),('15128','2013-05-17','08:40:00',1.28),('15128','2013-05-17','08:45:00',1.7),('15128','2013-05-17','08:50:00',1.92),('15128','2013-05-17','08:55:00',1.9),('15128','2013-05-17','09:00:00',1.89),('15128','2013-05-17','09:05:00',2.11),('15128','2013-05-17','09:10:00',2.22),('15128','2013-05-17','09:15:00',2.29),('15128','2013-05-17','09:20:00',2.3),('15128','2013-05-17','09:25:00',2.35),('15128','2013-05-17','09:30:00',2.41),('15128','2013-05-17','09:35:00',2.49),('15128','2013-05-17','09:40:00',2.55),('15128','2013-05-17','09:45:00',2.54),('15128','2013-05-17','09:50:00',2.57),('15128','2013-05-17','09:55:00',2.65),('15128','2013-05-17','10:00:00',2.73),('15128','2013-05-17','10:05:00',2.81),('15128','2013-05-17','10:10:00',2.88),('15128','2013-05-17','10:15:00',2.95),('15128','2013-05-17','10:20:00',2.92),('15128','2013-05-17','10:25:00',2.99),('15128','2013-05-17','10:30:00',3.02),('15128','2013-05-17','10:35:00',3.08),('15128','2013-05-17','10:40:00',3.16),('15128','2013-05-17','10:45:00',3.26),('15128','2013-05-17','10:50:00',3.36),('15128','2013-05-17','10:55:00',3.45),('15128','2013-05-17','11:00:00',3.62),('15128','2013-05-17','11:05:00',3.9),('15128','2013-05-17','11:10:00',3.15),('15128','2013-05-17','11:15:00',3.31),('15128','2013-05-17','11:20:00',3.08),('15128','2013-05-17','11:25:00',3.42),('15128','2013-05-17','11:30:00',3.95),('15128','2013-05-17','11:35:00',3.99),('15128','2013-05-17','11:40:00',3.91),('15128','2013-05-17','11:45:00',3.97),('15128','2013-05-17','11:50:00',4.06),('15128','2013-05-17','11:55:00',4.14),('15128','2013-05-17','12:00:00',4.14),('15128','2013-05-17','12:05:00',4.14),('15128','2013-05-17','12:10:00',4.16),('15128','2013-05-17','12:15:00',4.19),('15128','2013-05-17','12:20:00',4.25),('15128','2013-05-17','12:25:00',4.31),('15128','2013-05-17','12:30:00',4.28),('15128','2013-05-17','12:35:00',4.31),('15128','2013-05-17','12:40:00',4.34),('15128','2013-05-17','12:45:00',4.31),('15128','2013-05-17','12:50:00',4.2),('15128','2013-05-17','12:55:00',4.39),('15128','2013-05-17','13:00:00',4.39),('15128','2013-05-17','13:05:00',4.39),('15128','2013-05-17','13:10:00',4.41),('15128','2013-05-17','13:15:00',4.43),('15128','2013-05-17','13:20:00',4.43),('15128','2013-05-17','13:25:00',4.47),('15128','2013-05-17','13:30:00',4.47),('15128','2013-05-17','13:35:00',4.47),('15128','2013-05-17','13:40:00',4.49),('15128','2013-05-17','13:45:00',4.52),('15128','2013-05-17','13:50:00',4.44),('15128','2013-05-17','13:55:00',4.24),('15128','2013-05-17','14:00:00',3.83),('15128','2013-05-17','14:05:00',4.43),('15128','2013-05-17','14:10:00',3.31),('15128','2013-05-17','14:15:00',3.34),('15128','2013-05-17','14:20:00',3.74),('15128','2013-05-17','14:25:00',4.55),('15128','2013-05-17','14:30:00',4.59),('15128','2013-05-17','14:35:00',4.65),('15128','2013-05-17','14:40:00',4.66),('15128','2013-05-17','14:45:00',3.63),('15128','2013-05-17','14:50:00',4.09),('15128','2013-05-17','14:55:00',4.21),('15128','2013-05-17','15:00:00',4.09),('15128','2013-05-17','15:05:00',4.07),('15128','2013-05-17','15:10:00',4.04),('15128','2013-05-17','15:15:00',4),('15128','2013-05-17','15:20:00',3.98),('15128','2013-05-17','15:25:00',3.93),('15128','2013-05-17','15:30:00',3.9),('15128','2013-05-17','15:35:00',3.63),('15128','2013-05-17','15:40:00',3.89),('15128','2013-05-17','15:45:00',3.73),('15128','2013-05-17','15:50:00',3.69),('15128','2013-05-17','15:55:00',3.67),('15128','2013-05-17','16:00:00',3.6),('15128','2013-05-17','16:05:00',3.53),('15128','2013-05-17','16:10:00',3.47),('15128','2013-05-17','16:15:00',3.42),('15128','2013-05-17','16:20:00',3.37),('15128','2013-05-17','16:25:00',3.3),('15128','2013-05-17','16:30:00',3.29),('15128','2013-05-17','16:35:00',3.23),('15128','2013-05-17','16:40:00',3.14),('15128','2013-05-17','16:45:00',3.09),('15128','2013-05-17','16:50:00',2.98),('15128','2013-05-17','16:55:00',2.92),('15128','2013-05-17','17:00:00',2.84),('15128','2013-05-17','17:05:00',2.78),('15128','2013-05-17','17:10:00',2.72),('15128','2013-05-17','17:15:00',2.66),('15128','2013-05-17','17:20:00',2.59),('15128','2013-05-17','17:25:00',2.53),('15128','2013-05-17','17:30:00',2.45),('15128','2013-05-17','17:35:00',2.36),('15128','2013-05-17','17:40:00',2.26),('15128','2013-05-17','17:45:00',2.16),('15128','2013-05-17','17:50:00',2),('15128','2013-05-17','17:55:00',1.91),('15128','2013-05-17','18:00:00',1.85),('15128','2013-05-17','18:05:00',1.79),('15128','2013-05-17','18:10:00',1.71),('15128','2013-05-17','18:15:00',1.61),('15128','2013-05-17','18:20:00',1.52),('15128','2013-05-17','18:25:00',1.45),('15128','2013-05-17','18:30:00',1.35),('15128','2013-05-17','18:35:00',1.28),('15128','2013-05-17','18:40:00',1.17),('15128','2013-05-17','18:45:00',1.05),('15128','2013-05-16','07:50:00',1.17),('15128','2013-05-16','07:55:00',1.15),('15128','2013-05-16','08:00:00',1.03),('15128','2013-05-16','08:05:00',1.65),('15128','2013-05-16','08:10:00',1.45),('15128','2013-05-16','08:15:00',1.89),('15128','2013-05-16','08:20:00',2.06),('15128','2013-05-16','08:25:00',1.14),('15128','2013-05-16','09:15:00',1.29),('15128','2013-05-16','09:20:00',1.09),('15128','2013-05-16','10:15:00',1.07),('15128','2013-05-16','10:20:00',1.29),('15128','2013-05-16','10:25:00',1.26),('15128','2013-05-16','10:30:00',1.42),('15128','2013-05-16','10:35:00',1.36),('15128','2013-05-16','10:40:00',1.37),('15128','2013-05-16','10:45:00',2.35),('15128','2013-05-16','10:50:00',3.64),('15128','2013-05-16','10:55:00',2.69),('15128','2013-05-16','11:00:00',2.03),('15128','2013-05-16','11:05:00',1.83),('15128','2013-05-16','11:10:00',2.56),('15128','2013-05-16','11:15:00',2.98),('15128','2013-05-16','11:20:00',2.65),('15128','2013-05-16','11:25:00',3.55),('15128','2013-05-16','11:30:00',2.31),('15128','2013-05-16','11:35:00',2.8),('15128','2013-05-16','11:40:00',1.98),('15128','2013-05-16','11:45:00',2.18),('15128','2013-05-16','11:50:00',3.52),('15128','2013-05-16','11:55:00',4.09),('15128','2013-05-16','12:00:00',3.87),('15128','2013-05-16','12:05:00',4.16),('15128','2013-05-16','12:10:00',4.61),('15128','2013-05-16','12:15:00',4.84),('15128','2013-05-16','12:20:00',5.03),('15128','2013-05-16','12:25:00',5.14),('15128','2013-05-16','12:30:00',4.59),('15128','2013-05-16','12:35:00',4.28),('15128','2013-05-16','12:40:00',3.34),('15128','2013-05-16','12:45:00',4.15),('15128','2013-05-16','12:50:00',3.39),('15128','2013-05-16','12:55:00',4.6),('15128','2013-05-16','13:00:00',3.43),('15128','2013-05-16','13:05:00',1.28),('15128','2013-05-16','13:10:00',1.3),('15128','2013-05-16','13:20:00',1.06),('15128','2013-05-16','13:25:00',1.19),('15128','2013-05-16','13:30:00',2.52),('15128','2013-05-16','13:35:00',4.36),('15128','2013-05-16','13:40:00',3.14),('15128','2013-05-16','13:45:00',3.26),('15128','2013-05-16','13:50:00',3.33),('15128','2013-05-16','13:55:00',4.26),('15128','2013-05-16','14:00:00',4.76),('15128','2013-05-16','14:05:00',4.35),('15128','2013-05-16','14:10:00',4.66),('15128','2013-05-16','14:15:00',4.78),('15128','2013-05-16','14:20:00',4.32),('15128','2013-05-16','14:25:00',3.93),('15128','2013-05-16','14:30:00',4.51),('15128','2013-05-16','14:35:00',4.73),('15128','2013-05-16','14:40:00',4.28),('15128','2013-05-16','14:45:00',3.74),('15128','2013-05-16','14:50:00',4.27),('15128','2013-05-16','14:55:00',4.59),('15128','2013-05-16','15:00:00',3.84),('15128','2013-05-16','15:05:00',4.3),('15128','2013-05-16','15:10:00',4.72),('15128','2013-05-16','15:15:00',4.53),('15128','2013-05-16','15:20:00',4.19),('15128','2013-05-16','15:25:00',3.62),('15128','2013-05-16','15:30:00',4.46),('15128','2013-05-16','15:35:00',3.78),('15128','2013-05-16','15:40:00',4.35),('15128','2013-05-16','15:45:00',4.68),('15128','2013-05-16','15:50:00',4.42),('15128','2013-05-16','15:55:00',4.28),('15128','2013-05-16','16:00:00',4.33),('15128','2013-05-16','16:05:00',4.19),('15128','2013-05-16','16:10:00',3.53),('15128','2013-05-16','16:15:00',4.05),('15128','2013-05-16','16:20:00',4.01),('15128','2013-05-16','16:25:00',3.8),('15128','2013-05-16','16:30:00',3.56),('15128','2013-05-16','16:35:00',3.96),('15128','2013-05-16','16:40:00',3.8),('15128','2013-05-16','16:45:00',3.77),('15128','2013-05-16','16:50:00',3.71),('15128','2013-05-16','16:55:00',3.67),('15128','2013-05-16','17:00:00',3.62),('15128','2013-05-16','17:05:00',3.86),('15128','2013-05-16','17:10:00',3.69),('15128','2013-05-16','17:15:00',3.67),('15128','2013-05-16','17:20:00',3.48),('15128','2013-05-16','17:25:00',3.22),('15128','2013-05-16','17:30:00',3.1),('15128','2013-05-16','17:35:00',3.07),('15128','2013-05-16','17:40:00',3.05),('15128','2013-05-16','17:45:00',2.85),('15128','2013-05-16','17:50:00',2.6),('15128','2013-05-16','17:55:00',2.46),('15128','2013-05-16','18:00:00',2.34),('15128','2013-05-16','18:05:00',2.22),('15128','2013-05-16','18:10:00',2.18),('15128','2013-05-16','18:15:00',2.1),('15128','2013-05-16','18:20:00',2.02),('15128','2013-05-16','18:25:00',1.95),('15128','2013-05-16','18:30:00',1.92),('15128','2013-05-16','18:35:00',1.87),('15128','2013-05-16','18:40:00',1.81),('15128','2013-05-16','18:45:00',1.79),('15128','2013-05-16','18:50:00',1.72),('15128','2013-05-16','18:55:00',1.48),('15128','2013-05-16','19:00:00',1.34),('15128','2013-05-16','19:05:00',1.34),('15128','2013-05-16','19:10:00',1.34),('15128','2013-05-16','19:15:00',1.29),('15128','2013-05-16','19:20:00',1.25),('15128','2013-05-16','19:25:00',1.06),('15128','2013-05-15','09:20:00',1.14),('15128','2013-05-15','09:25:00',1.63),('15128','2013-05-15','09:30:00',1.46),('15128','2013-05-15','09:35:00',1.51),('15128','2013-05-15','09:40:00',1.74),('15128','2013-05-15','09:45:00',2.56),('15128','2013-05-15','09:50:00',2.42),('15128','2013-05-15','09:55:00',1.13),('15128','2013-05-15','10:00:00',1.93),('15128','2013-05-15','10:05:00',1.37),('15128','2013-05-15','10:10:00',1.16),('15128','2013-05-15','10:15:00',1.31),('15128','2013-05-15','10:20:00',1.96),('15128','2013-05-15','10:25:00',1.47),('15128','2013-05-15','10:30:00',1.69),('15128','2013-05-15','10:35:00',1.64),('15128','2013-05-15','10:40:00',2.19),('15128','2013-05-15','10:45:00',2.88),('15128','2013-05-15','10:50:00',1.8),('15128','2013-05-15','10:55:00',1.7),('15128','2013-05-15','11:00:00',2.6),('15128','2013-05-15','11:05:00',4.05),('15128','2013-05-15','11:10:00',2.87),('15128','2013-05-15','11:15:00',2.63),('15128','2013-05-15','11:20:00',2.15),('15128','2013-05-15','11:25:00',1.59),('15128','2013-05-15','11:30:00',1.88),('15128','2013-05-15','11:35:00',2.37),('15128','2013-05-15','11:40:00',3.68),('15128','2013-05-15','11:45:00',3.96),('15128','2013-05-15','11:50:00',4.07),('15128','2013-05-15','11:55:00',2.76),('15128','2013-05-15','12:00:00',1.55),('15128','2013-05-15','12:05:00',1.19),('15128','2013-05-15','12:10:00',1.28),('15128','2013-05-15','12:15:00',1.38),('15128','2013-05-15','12:20:00',1.77),('15128','2013-05-15','12:25:00',2.4),('15128','2013-05-15','12:30:00',3.31),('15128','2013-05-15','12:35:00',4.44),('15128','2013-05-15','12:40:00',3.94),('15128','2013-05-15','12:45:00',3.49),('15128','2013-05-15','12:50:00',3.73),('15128','2013-05-15','12:55:00',4.25),('15128','2013-05-15','13:00:00',4.14),('15128','2013-05-15','13:05:00',4.15),('15128','2013-05-15','13:10:00',4.19),('15128','2013-05-15','13:15:00',4.18),('15128','2013-05-15','13:20:00',4.14),('15128','2013-05-15','13:25:00',4.17),('15128','2013-05-15','13:30:00',4.17),('15128','2013-05-15','13:35:00',4.14),('15128','2013-05-15','13:40:00',4.15),('15128','2013-05-15','13:45:00',4.15),('15128','2013-05-15','13:50:00',4.14),('15128','2013-05-15','13:55:00',4.16),('15128','2013-05-15','14:00:00',4.15),('15128','2013-05-15','14:05:00',4.1),('15128','2013-05-15','14:10:00',4.08),('15128','2013-05-15','14:15:00',4.05),('15128','2013-05-15','14:20:00',4.02),('15128','2013-05-15','14:25:00',4.02),('15128','2013-05-15','14:30:00',4.01),('15128','2013-05-15','14:35:00',3.92),('15128','2013-05-15','14:40:00',3.98),('15128','2013-05-15','14:45:00',3.95),('15128','2013-05-15','14:50:00',3.91),('15128','2013-05-15','14:55:00',3.87),('15128','2013-05-15','15:00:00',3.52),('15128','2013-05-15','15:05:00',3.81),('15128','2013-05-15','15:10:00',3.84),('15128','2013-05-15','15:15:00',3.85),('15128','2013-05-15','15:20:00',3.81),('15128','2013-05-15','15:25:00',3.57),('15128','2013-05-15','15:30:00',3.61),('15128','2013-05-15','15:35:00',3.53),('15128','2013-05-15','15:40:00',3.53),('15128','2013-05-15','15:45:00',3.48),('15128','2013-05-15','15:50:00',3.46),('15128','2013-05-15','15:55:00',3.37),('15128','2013-05-15','16:00:00',3.31),('15128','2013-05-15','16:05:00',3.12),('15128','2013-05-15','16:10:00',3.29),('15128','2013-05-15','16:15:00',2.77),('15128','2013-05-15','16:20:00',3.05),('15128','2013-05-15','16:25:00',3.01),('15128','2013-05-15','16:30:00',2.92),('15128','2013-05-15','16:35:00',2.93),('15128','2013-05-15','16:40:00',3.07),('15128','2013-05-15','16:45:00',2.25),('15128','2013-05-15','16:50:00',2.49),('15128','2013-05-15','16:55:00',1.91),('15128','2013-05-15','17:00:00',1.79),('15128','2013-05-15','17:05:00',1.31),('15128','2013-05-15','17:10:00',1.51),('15128','2013-05-15','17:15:00',1.29),('15128','2013-05-15','17:20:00',1.5),('15128','2013-05-15','17:25:00',2.1),('15128','2013-05-15','17:30:00',2.37),('15128','2013-05-15','17:35:00',1.5),('15128','2013-05-15','18:20:00',1.14),('15128','2013-05-15','18:25:00',1.24),('15128','2013-05-15','18:30:00',1.32),('15128','2013-05-15','18:35:00',1.43),('15128','2013-05-15','18:40:00',1.41),('15128','2013-05-15','18:45:00',1.4),('15128','2013-05-15','18:50:00',1.33),('15128','2013-05-15','18:55:00',1.2),('15128','2013-05-15','19:00:00',1.01),('15128','2013-05-14','08:10:00',1.08),('15128','2013-05-14','08:15:00',1.17),('15128','2013-05-14','08:20:00',1.22),('15128','2013-05-14','08:25:00',1.23),('15128','2013-05-14','08:30:00',1.36),('15128','2013-05-14','08:35:00',1.48),('15128','2013-05-14','08:40:00',1.57),('15128','2013-05-14','08:45:00',1.62),('15128','2013-05-14','08:50:00',1.69),('15128','2013-05-14','08:55:00',1.7),('15128','2013-05-14','09:00:00',1.75),('15128','2013-05-14','09:05:00',1.79),('15128','2013-05-14','09:10:00',1.9),('15128','2013-05-14','09:15:00',1.99),('15128','2013-05-14','09:20:00',1.96),('15128','2013-05-14','09:25:00',1.96),('15128','2013-05-14','09:30:00',2.2),('15128','2013-05-14','09:35:00',2.21),('15128','2013-05-14','09:40:00',2.2),('15128','2013-05-14','09:45:00',2.26),('15128','2013-05-14','09:50:00',2.32),('15128','2013-05-14','09:55:00',2.36),('15128','2013-05-14','10:00:00',2.38),('15128','2013-05-14','10:05:00',2.5),('15128','2013-05-14','10:10:00',2.55),('15128','2013-05-14','10:15:00',2.69),('15128','2013-05-14','10:20:00',2.77),('15128','2013-05-14','10:25:00',2.84),('15128','2013-05-14','10:30:00',2.82),('15128','2013-05-14','10:35:00',2.84),('15128','2013-05-14','10:40:00',2.87),('15128','2013-05-14','10:45:00',2.95),('15128','2013-05-14','10:50:00',3.09),('15128','2013-05-14','10:55:00',3.18),('15128','2013-05-14','11:00:00',3.17),('15128','2013-05-14','11:05:00',3.24),('15128','2013-05-14','11:10:00',3.28),('15128','2013-05-14','11:15:00',3.23),('15128','2013-05-14','11:20:00',3.19),('15128','2013-05-14','11:25:00',3.5),('15128','2013-05-14','11:30:00',3.5),('15128','2013-05-14','11:35:00',3.68),('15128','2013-05-14','11:40:00',3.78),('15128','2013-05-14','11:45:00',3.99),('15128','2013-05-14','11:50:00',2.21),('15128','2013-05-14','11:55:00',2.48),('15128','2013-05-14','12:00:00',3.82),('15128','2013-05-14','12:05:00',3.73),('15128','2013-05-14','12:10:00',4.76),('15128','2013-05-14','12:15:00',3.3),('15128','2013-05-14','12:20:00',3.61),('15128','2013-05-14','12:25:00',3.55),('15128','2013-05-14','12:30:00',4.11),('15128','2013-05-14','12:35:00',3.36),('15128','2013-05-14','12:40:00',2.94),('15128','2013-05-14','12:45:00',2.53),('15128','2013-05-14','12:50:00',2.47),('15128','2013-05-14','12:55:00',2.47),('15128','2013-05-14','13:00:00',2.41),('15128','2013-05-14','13:05:00',2.59),('15128','2013-05-14','13:10:00',2.65),('15128','2013-05-14','13:15:00',2.61),('15128','2013-05-14','13:20:00',2.5),('15128','2013-05-14','13:25:00',2.55),('15128','2013-05-14','13:30:00',2.67),('15128','2013-05-14','13:35:00',2.64),('15128','2013-05-14','13:40:00',2.59),('15128','2013-05-14','13:45:00',2.13),('15128','2013-05-14','13:50:00',2.58),('15128','2013-05-14','13:55:00',2.44),('15128','2013-05-14','14:00:00',2.25),('15128','2013-05-14','14:05:00',2.61),('15128','2013-05-14','14:10:00',2.62),('15128','2013-05-14','14:15:00',2.69),('15128','2013-05-14','14:20:00',2.43),('15128','2013-05-14','14:25:00',2.22),('15128','2013-05-14','14:30:00',1.73),('15128','2013-05-14','14:35:00',1.49),('15128','2013-05-14','14:40:00',1.31),('15128','2013-05-14','14:45:00',1.24),('15128','2013-05-14','14:50:00',1.24),('15128','2013-05-14','14:55:00',1.37),('15128','2013-05-14','15:00:00',1.32),('15128','2013-05-14','15:05:00',1.12),('15128','2013-05-14','15:35:00',1.02),('15128','2013-05-14','15:40:00',1.08),('15128','2013-05-14','15:45:00',1.27),('15128','2013-05-14','15:50:00',1.72),('15128','2013-05-14','15:55:00',1.92),('15128','2013-05-14','16:00:00',1.89),('15128','2013-05-14','16:05:00',1.9),('15128','2013-05-14','16:10:00',1.77),('15128','2013-05-14','16:15:00',1.82),('15128','2013-05-14','16:20:00',1.88),('15128','2013-05-14','16:25:00',2),('15128','2013-05-14','16:30:00',1.64),('15128','2013-05-14','16:35:00',1.69),('15128','2013-05-14','16:40:00',1.54),('15128','2013-05-14','16:45:00',1.38),('15128','2013-05-14','16:50:00',1.32),('15128','2013-05-14','16:55:00',1.41),('15128','2013-05-14','17:00:00',1.75),('15128','2013-05-14','17:05:00',2.89),('15128','2013-05-14','17:10:00',3),('15128','2013-05-14','17:15:00',2.39),('15128','2013-05-14','17:20:00',2.3),('15128','2013-05-14','17:25:00',1.64),('15128','2013-05-14','17:30:00',1.26),('15128','2013-05-14','17:35:00',1.02),('15128','2013-05-13','08:05:00',1.03),('15128','2013-05-13','08:10:00',1.1),('15128','2013-05-13','08:15:00',1.15),('15128','2013-05-13','08:20:00',1.22),('15128','2013-05-13','08:25:00',1.3),('15128','2013-05-13','08:30:00',1.4),('15128','2013-05-13','08:35:00',1.49),('15128','2013-05-13','08:40:00',1.57),('15128','2013-05-13','08:45:00',1.63),('15128','2013-05-13','08:50:00',1.7),('15128','2013-05-13','08:55:00',1.76),('15128','2013-05-13','09:00:00',1.86),('15128','2013-05-13','09:05:00',1.96),('15128','2013-05-13','09:10:00',2.04),('15128','2013-05-13','09:15:00',2.12),('15128','2013-05-13','09:20:00',2.18),('15128','2013-05-13','09:25:00',2.1),('15128','2013-05-13','09:30:00',2.27),('15128','2013-05-13','09:35:00',2.36),('15128','2013-05-13','09:40:00',2.36),('15128','2013-05-13','09:45:00',2.32),('15128','2013-05-13','09:50:00',2.45),('15128','2013-05-13','09:55:00',2.46),('15128','2013-05-13','10:00:00',2.5),('15128','2013-05-13','10:05:00',2.68),('15128','2013-05-13','10:10:00',2.74),('15128','2013-05-13','10:15:00',2.83),('15128','2013-05-13','10:20:00',2.9),('15128','2013-05-13','10:25:00',2.95),('15128','2013-05-13','10:30:00',2.97),('15128','2013-05-13','10:35:00',3.08),('15128','2013-05-13','10:40:00',3.12),('15128','2013-05-13','10:45:00',3.17),('15128','2013-05-13','10:50:00',3.23),('15128','2013-05-13','10:55:00',3.28),('15128','2013-05-13','11:00:00',3.39),('15128','2013-05-13','11:05:00',3.39),('15128','2013-05-13','11:10:00',3.45),('15128','2013-05-13','11:15:00',3.47),('15128','2013-05-13','11:20:00',3.55),('15128','2013-05-13','11:25:00',3.63),('15128','2013-05-13','11:30:00',3.64),('15128','2013-05-13','11:35:00',3.77),('15128','2013-05-13','11:40:00',3.83),('15128','2013-05-13','11:45:00',3.88),('15128','2013-05-13','11:50:00',4.04),('15128','2013-05-13','11:55:00',4.08),('15128','2013-05-13','12:00:00',4.11),('15128','2013-05-13','12:05:00',4.14),('15128','2013-05-13','12:10:00',4.18),('15128','2013-05-13','12:15:00',4.19),('15128','2013-05-13','12:20:00',4.22),('15128','2013-05-13','12:25:00',4.26),('15128','2013-05-13','12:30:00',4.28),('15128','2013-05-13','12:35:00',4.31),('15128','2013-05-13','12:40:00',4.34),('15128','2013-05-13','12:45:00',4.38),('15128','2013-05-13','12:50:00',4.41),('15128','2013-05-13','12:55:00',4.43),('15128','2013-05-13','13:00:00',4.43),('15128','2013-05-13','13:05:00',4.42),('15128','2013-05-13','13:10:00',4.42),('15128','2013-05-13','13:15:00',4.22),('15128','2013-05-13','13:25:00',2.52),('15128','2013-05-13','13:30:00',4.46),('15128','2013-05-13','13:35:00',4.46),('15128','2013-05-13','13:45:00',2.3),('15128','2013-05-13','13:50:00',4.42),('15128','2013-05-13','13:55:00',4.42),('15128','2013-05-13','14:00:00',4.41),('15128','2013-05-13','14:05:00',2.84),('15128','2013-05-13','14:10:00',4.38),('15128','2013-05-13','14:15:00',4.43),('15128','2013-05-13','14:20:00',4.47),('15128','2013-05-13','14:25:00',3.02),('15128','2013-05-13','14:30:00',4.12),('15128','2013-05-13','14:35:00',4.44),('15128','2013-05-13','14:40:00',4.46),('15128','2013-05-13','14:45:00',3.71),('15128','2013-05-13','14:50:00',3.54),('15128','2013-05-13','14:55:00',4.4),('15128','2013-05-13','15:00:00',4.4),('15128','2013-05-13','15:05:00',4.37),('15128','2013-05-13','15:10:00',2.64),('15128','2013-05-13','15:15:00',4.31),('15128','2013-05-13','15:20:00',4.31),('15128','2013-05-13','15:25:00',4.31),('15128','2013-05-13','15:30:00',4.29),('15128','2013-05-13','15:35:00',4.27),('15128','2013-05-13','15:40:00',4.21),('15128','2013-05-13','15:45:00',4.15),('15128','2013-05-13','15:50:00',4.11),('15128','2013-05-13','15:55:00',4.08),('15128','2013-05-13','16:00:00',3.99),('15128','2013-05-13','16:05:00',3.95),('15128','2013-05-13','16:10:00',3.92),('15128','2013-05-13','16:15:00',3.88),('15128','2013-05-13','16:20:00',3.82),('15128','2013-05-13','16:25:00',3.76),('15128','2013-05-13','16:30:00',3.69),('15128','2013-05-13','16:35:00',3.65),('15128','2013-05-13','16:40:00',3.57),('15128','2013-05-13','16:45:00',3.48),('15128','2013-05-13','16:50:00',3.43),('15128','2013-05-13','16:55:00',3.37),('15128','2013-05-13','17:00:00',3.3),('15128','2013-05-13','17:05:00',3.23),('15128','2013-05-13','17:10:00',3.16),('15128','2013-05-13','17:15:00',3.09),('15128','2013-05-13','17:20:00',3.01),('15128','2013-05-13','17:25:00',2.93),('15128','2013-05-13','17:30:00',2.85),('15128','2013-05-13','17:35:00',2.74),('15128','2013-05-13','17:40:00',2.67),('15128','2013-05-13','17:45:00',2.54),('15128','2013-05-13','17:50:00',2.42),('15128','2013-05-13','17:55:00',2.31),('15128','2013-05-13','18:00:00',2.2),('15128','2013-05-13','18:05:00',2.1),('15128','2013-05-13','18:10:00',2.04),('15128','2013-05-13','18:15:00',1.98),('15128','2013-05-13','18:20:00',1.9),('15128','2013-05-13','18:25:00',1.83),('15128','2013-05-13','18:30:00',1.77),('15128','2013-05-13','18:35:00',1.68),('15128','2013-05-13','18:40:00',1.61),('15128','2013-05-13','18:45:00',1.5),('15128','2013-05-13','18:50:00',1.34),('15128','2013-05-13','18:55:00',1.25),('15128','2013-05-13','19:00:00',1.13),('15128','2013-05-13','19:05:00',1.08),('15128','2013-05-12','08:10:00',1.08),('15128','2013-05-12','08:15:00',1.13),('15128','2013-05-12','08:20:00',1.19),('15128','2013-05-12','08:25:00',1.26),('15128','2013-05-12','08:30:00',1.35),('15128','2013-05-12','08:35:00',1.43),('15128','2013-05-12','08:40:00',1.5),('15128','2013-05-12','08:45:00',1.56),('15128','2013-05-12','08:50:00',1.62),('15128','2013-05-12','08:55:00',1.66),('15128','2013-05-12','09:00:00',1.74),('15128','2013-05-12','09:05:00',1.84),('15128','2013-05-12','09:10:00',1.9),('15128','2013-05-12','09:15:00',2.01),('15128','2013-05-12','09:20:00',2.07),('15128','2013-05-12','09:25:00',1.64),('15128','2013-05-12','09:30:00',1.73),('15128','2013-05-12','09:35:00',2.28),('15128','2013-05-12','09:40:00',2.09),('15128','2013-05-12','09:45:00',1.48),('15128','2013-05-12','09:50:00',2.89),('15128','2013-05-12','09:55:00',2.14),('15128','2013-05-12','10:00:00',2.05),('15128','2013-05-12','10:05:00',2.5),('15128','2013-05-12','10:10:00',3.04),('15128','2013-05-12','10:15:00',3.06),('15128','2013-05-12','10:20:00',3.3),('15128','2013-05-12','10:25:00',3.46),('15128','2013-05-12','10:30:00',3.26),('15128','2013-05-12','10:35:00',3.23),('15128','2013-05-12','10:40:00',3.23),('15128','2013-05-12','10:45:00',3.36),('15128','2013-05-12','10:50:00',2.22),('15128','2013-05-12','10:55:00',2.93),('15128','2013-05-12','11:00:00',2.94),('15128','2013-05-12','11:05:00',1.53),('15128','2013-05-12','11:10:00',1.87),('15128','2013-05-12','11:15:00',1.06),('15128','2013-05-12','11:20:00',1.17),('15128','2013-05-12','11:25:00',1.61),('15128','2013-05-12','11:30:00',4.05),('15128','2013-05-12','11:35:00',4.19),('15128','2013-05-12','11:40:00',4.36),('15128','2013-05-12','11:45:00',4.62),('15128','2013-05-12','11:50:00',2.69),('15128','2013-05-12','11:55:00',1.79),('15128','2013-05-12','12:00:00',1.53),('15128','2013-05-12','12:05:00',4.11),('15128','2013-05-12','12:10:00',2.34),('15128','2013-05-12','12:15:00',3.47),('15128','2013-05-12','12:20:00',1.6),('15128','2013-05-12','12:25:00',1.48),('15128','2013-05-12','12:30:00',1.56),('15128','2013-05-12','12:35:00',2.35),('15128','2013-05-12','12:40:00',5.2),('15128','2013-05-12','12:45:00',4.87),('15128','2013-05-12','12:50:00',3.78),('15128','2013-05-12','12:55:00',1.23),('15128','2013-05-12','13:00:00',4.59),('15128','2013-05-12','13:05:00',2.54),('15128','2013-05-12','13:10:00',1.38),('15128','2013-05-12','13:15:00',1.19),('15128','2013-05-12','13:20:00',1.33),('15128','2013-05-12','13:25:00',4.36),('15128','2013-05-12','13:30:00',1.15),('15128','2013-05-12','13:35:00',2.46),('15128','2013-05-12','13:40:00',5.2),('15128','2013-05-12','13:45:00',1.69),('15128','2013-05-12','13:50:00',1.23),('15128','2013-05-12','13:55:00',3.2),('15128','2013-05-12','14:00:00',4.27),('15128','2013-05-12','14:05:00',4.71),('15128','2013-05-12','14:10:00',4.43),('15128','2013-05-12','14:15:00',5.22),('15128','2013-05-12','14:20:00',1.86),('15128','2013-05-12','14:40:00',2.53),('15128','2013-05-12','14:45:00',1.52),('15128','2013-05-12','14:50:00',3.85),('15128','2013-05-12','15:35:00',1.19),('15128','2013-05-12','15:40:00',3.35),('15128','2013-05-12','15:45:00',1.56),('15128','2013-05-12','15:50:00',1.12),('15128','2013-05-12','15:55:00',1.25),('15128','2013-05-12','16:00:00',1.3),('15128','2013-05-12','16:05:00',1.42),('15128','2013-05-12','16:10:00',1.51),('15128','2013-05-12','16:15:00',1.25),('15128','2013-05-12','16:25:00',1.03),('15128','2013-05-12','16:40:00',1.04),('15128','2013-05-12','16:50:00',1.8),('15128','2013-05-12','16:55:00',3.53),('15128','2013-05-12','17:00:00',3.14),('15128','2013-05-12','17:05:00',1.06),('15128','2013-05-12','17:10:00',1.06),('15128','2013-05-12','17:15:00',1.51),('15128','2013-05-12','17:20:00',1.34),('15128','2013-05-12','17:25:00',2.17),('15128','2013-05-12','17:30:00',1.27),('15128','2013-05-12','17:35:00',2.84),('15128','2013-05-12','17:40:00',2.73),('15128','2013-05-12','17:45:00',2.61),('15128','2013-05-12','17:50:00',2.46),('15128','2013-05-12','17:55:00',1.53),('15128','2013-05-12','18:05:00',1.07),('15128','2013-05-12','18:10:00',1.32),('15128','2013-05-12','18:15:00',1.73),('15128','2013-05-12','18:20:00',2.51),('15128','2013-05-12','18:25:00',2.35),('15128','2013-05-12','18:30:00',2.27),('15128','2013-05-12','18:35:00',1.88),('15128','2013-05-12','18:50:00',1.2),('15128','2013-05-11','07:55:00',1.09),('15128','2013-05-11','08:15:00',1.39),('15128','2013-05-11','08:20:00',1.65),('15128','2013-05-11','08:25:00',1.7),('15128','2013-05-11','08:30:00',1.99),('15128','2013-05-11','08:35:00',1.7),('15128','2013-05-11','08:40:00',1.71),('15128','2013-05-11','08:45:00',1.6),('15128','2013-05-11','08:50:00',1.08),('15128','2013-05-11','08:55:00',1.01),('15128','2013-05-11','09:05:00',1.41),('15128','2013-05-11','09:10:00',1.45),('15128','2013-05-11','09:15:00',1.71),('15128','2013-05-11','09:20:00',1.81),('15128','2013-05-11','09:25:00',1.71),('15128','2013-05-11','09:30:00',2.2),('15128','2013-05-11','09:35:00',2.67),('15128','2013-05-11','09:40:00',2.67),('15128','2013-05-11','09:45:00',2.79),('15128','2013-05-11','09:50:00',3.09),('15128','2013-05-11','09:55:00',3.18),('15128','2013-05-11','10:00:00',3.2),('15128','2013-05-11','10:05:00',3.23),('15128','2013-05-11','10:10:00',2.76),('15128','2013-05-11','10:15:00',2.71),('15128','2013-05-11','10:20:00',1.93),('15128','2013-05-11','10:25:00',1.28),('15128','2013-05-11','10:30:00',2.46),('15128','2013-05-11','10:35:00',3.34),('15128','2013-05-11','10:40:00',2.07),('15128','2013-05-11','10:45:00',2.95),('15128','2013-05-11','10:50:00',2.01),('15128','2013-05-11','10:55:00',1.2),('15128','2013-05-11','11:00:00',1.17),('15128','2013-05-11','11:05:00',2.13),('15128','2013-05-11','11:10:00',1.19),('15128','2013-05-11','11:15:00',1.29),('15128','2013-05-11','11:20:00',1.8),('15128','2013-05-11','11:25:00',2.37),('15128','2013-05-11','11:30:00',2.53),('15128','2013-05-11','11:35:00',3.66),('15128','2013-05-11','11:40:00',3.44),('15128','2013-05-11','11:45:00',1.93),('15128','2013-05-11','11:50:00',2.01),('15128','2013-05-11','11:55:00',4.73),('15128','2013-05-11','12:00:00',2.73),('15128','2013-05-11','12:05:00',4.07),('15128','2013-05-11','12:10:00',1.11),('15128','2013-05-11','12:15:00',1.11),('15128','2013-05-11','12:20:00',1.39),('15128','2013-05-11','12:25:00',1.44),('15128','2013-05-11','12:30:00',1.34),('15128','2013-05-11','12:35:00',2.4),('15128','2013-05-11','12:40:00',1.9),('15128','2013-05-11','12:45:00',4.06),('15128','2013-05-11','12:50:00',4.29),('15128','2013-05-11','12:55:00',4.63),('15128','2013-05-11','13:00:00',4.6),('15128','2013-05-11','13:05:00',4.57),('15128','2013-05-11','13:10:00',4.55),('15128','2013-05-11','13:15:00',4.58),('15128','2013-05-11','13:20:00',4.56),('15128','2013-05-11','13:25:00',4.61),('15128','2013-05-11','13:30:00',4.69),('15128','2013-05-11','13:35:00',3.88),('15128','2013-05-11','13:40:00',4.55),('15128','2013-05-11','13:45:00',4.61),('15128','2013-05-11','13:50:00',4.28),('15128','2013-05-11','13:55:00',4.45),('15128','2013-05-11','14:00:00',4.87),('15128','2013-05-11','14:05:00',4.86),('15128','2013-05-11','14:10:00',4.78),('15128','2013-05-11','14:15:00',4.79),('15128','2013-05-11','14:20:00',4.83),('15128','2013-05-11','14:25:00',4.32),('15128','2013-05-11','14:30:00',4.28),('15128','2013-05-11','14:35:00',4.51),('15128','2013-05-11','14:40:00',4.93),('15128','2013-05-11','14:45:00',4.07),('15128','2013-05-11','14:50:00',4.37),('15128','2013-05-11','14:55:00',2.44),('15128','2013-05-11','15:00:00',1.8),('15128','2013-05-11','15:05:00',4.12),('15128','2013-05-11','15:10:00',4.75),('15128','2013-05-11','15:15:00',3.78),('15128','2013-05-11','15:20:00',4.15),('15128','2013-05-11','15:25:00',4.35),('15128','2013-05-11','15:30:00',4.25),('15128','2013-05-11','15:35:00',4.21),('15128','2013-05-11','15:40:00',4.12),('15128','2013-05-11','15:45:00',4.06),('15128','2013-05-11','15:50:00',4.02),('15128','2013-05-11','15:55:00',4.04),('15128','2013-05-11','16:00:00',3.95),('15128','2013-05-11','16:05:00',3.89),('15128','2013-05-11','16:10:00',3.83),('15128','2013-05-11','16:15:00',3.72),('15128','2013-05-11','16:20:00',3.68),('15128','2013-05-11','16:25:00',2.55),('15128','2013-05-11','16:30:00',3.44),('15128','2013-05-11','16:35:00',3.33),('15128','2013-05-11','16:40:00',3.15),('15128','2013-05-11','16:45:00',2.96),('15128','2013-05-11','16:50:00',4.32),('15128','2013-05-11','16:55:00',3.25),('15128','2013-05-11','17:00:00',2.05),('15128','2013-05-11','17:05:00',3.77),('15128','2013-05-11','17:10:00',1.91),('15128','2013-05-11','17:15:00',3.21),('15128','2013-05-11','17:20:00',1.79),('15128','2013-05-11','17:25:00',1.98),('15128','2013-05-11','17:30:00',1.69),('15128','2013-05-11','17:35:00',2.2),('15128','2013-05-11','17:40:00',1.48),('15128','2013-05-11','17:45:00',1.4),('15128','2013-05-11','17:50:00',2.78),('15128','2013-05-11','17:55:00',2.98),('15128','2013-05-11','18:00:00',1.79),('15128','2013-05-11','18:05:00',2.01),('15128','2013-05-11','18:10:00',1.54),('15128','2013-05-11','18:15:00',1.6),('15128','2013-05-11','18:20:00',1.23),('15128','2013-05-11','18:25:00',1.16),('15128','2013-05-11','18:30:00',1.61),('15128','2013-05-11','18:35:00',1.38),('15128','2013-05-11','18:40:00',1.05),('15128','2013-05-11','19:05:00',1.04),('15128','2013-05-11','19:10:00',1.18),('15128','2014-03-30','09:00:00',1.02),('15128','2014-03-30','09:05:00',1.08),('15128','2014-03-30','09:50:00',1.72),('15128','2014-03-30','09:55:00',1.75),('15128','2014-03-30','10:00:00',1.8),('15128','2014-03-30','10:05:00',1.83),('15128','2014-03-30','10:10:00',1.89),('15128','2014-03-30','10:15:00',1.94),('15128','2014-03-30','10:20:00',1.94),('15128','2014-03-30','10:25:00',2.01),('15128','2014-03-30','10:30:00',2.11),('15128','2014-03-30','10:35:00',2.17),('15128','2014-03-30','10:40:00',2.2),('15128','2014-03-30','10:45:00',2.27),('15128','2014-03-30','10:50:00',2.35),('15128','2014-03-30','10:55:00',2.37),('15128','2014-03-30','11:00:00',2.33),('15128','2014-03-30','11:05:00',2.49),('15128','2014-03-30','11:10:00',2.55),('15128','2014-03-30','11:15:00',2.61),('15128','2014-03-30','11:20:00',2.72),('15128','2014-03-30','11:25:00',2.79),('15128','2014-03-30','11:30:00',2.82),('15128','2014-03-30','11:35:00',2.78),('15128','2014-03-30','11:40:00',2.93),('15128','2014-03-30','11:45:00',2.96),('15128','2014-03-30','11:50:00',3.12),('15128','2014-03-30','11:55:00',3.21),('15128','2014-03-30','12:00:00',3.34),('15128','2014-03-30','12:05:00',3.4),('15128','2014-03-30','12:10:00',3.43),('15128','2014-03-30','12:15:00',3.44),('15128','2014-03-30','12:20:00',3.51),('15128','2014-03-30','12:25:00',3.55),('15128','2014-03-30','12:30:00',3.58),('15128','2014-03-30','12:35:00',3.66),('15128','2014-03-30','12:40:00',3.68),('15128','2014-03-30','12:45:00',3.71),('15128','2014-03-30','12:50:00',3.74),('15128','2014-03-30','12:55:00',3.77),('15128','2014-03-30','13:00:00',3.77),('15128','2014-03-30','13:05:00',3.77),('15128','2014-03-30','13:10:00',3.79),('15128','2014-03-30','13:15:00',3.83),('15128','2014-03-30','13:20:00',3.84),('15128','2014-03-30','13:25:00',3.84),('15128','2014-03-30','13:30:00',3.85),('15128','2014-03-30','13:35:00',3.88),('15128','2014-03-30','13:40:00',3.87),('15128','2014-03-30','13:45:00',3.89),('15128','2014-03-30','13:50:00',3.9),('15128','2014-03-30','13:55:00',3.9),('15128','2014-03-30','14:00:00',3.91),('15128','2014-03-30','14:05:00',3.9),('15128','2014-03-30','14:10:00',3.89),('15128','2014-03-30','14:15:00',3.9),('15128','2014-03-30','14:20:00',3.91),('15128','2014-03-30','14:25:00',3.88),('15128','2014-03-30','14:30:00',3.88),('15128','2014-03-30','14:35:00',3.88),('15128','2014-03-30','14:40:00',3.85),('15128','2014-03-30','14:45:00',3.83),('15128','2014-03-30','14:50:00',3.82),('15128','2014-03-30','14:55:00',3.8),('15128','2014-03-30','15:00:00',3.78),('15128','2014-03-30','15:05:00',3.74),('15128','2014-03-30','15:10:00',3.7),('15128','2014-03-30','15:15:00',3.67),('15128','2014-03-30','15:20:00',3.66),('15128','2014-03-30','15:25:00',3.63),('15128','2014-03-30','15:30:00',3.58),('15128','2014-03-30','15:35:00',3.57),('15128','2014-03-30','15:40:00',3.52),('15128','2014-03-30','15:45:00',3.44),('15128','2014-03-30','15:50:00',3.36),('15128','2014-03-30','15:55:00',3.32),('15128','2014-03-30','16:00:00',3.29),('15128','2014-03-30','16:05:00',3.21),('15128','2014-03-30','16:10:00',3.15),('15128','2014-03-30','16:15:00',3.12),('15128','2014-03-30','16:20:00',3.05),('15128','2014-03-30','16:25:00',3),('15128','2014-03-30','16:30:00',2.94),('15128','2014-03-30','16:35:00',2.85),('15128','2014-03-30','16:40:00',2.78),('15128','2014-03-30','16:45:00',2.74),('15128','2014-03-30','16:50:00',2.64),('15128','2014-03-30','16:55:00',2.58),('15128','2014-03-30','17:00:00',2.47),('15128','2014-03-30','17:05:00',2.41),('15128','2014-03-30','17:10:00',2.29),('15128','2014-03-30','17:15:00',2.16),('15128','2014-03-30','17:20:00',2.02),('15128','2014-03-30','17:25:00',1.95),('15128','2014-03-30','17:30:00',1.87),('15128','2014-03-30','17:35:00',1.78),('15128','2014-03-30','17:40:00',1.65),('15128','2014-03-30','17:45:00',1.58),('15128','2014-03-30','17:50:00',1.53),('15128','2014-03-30','17:55:00',1.47),('15128','2014-03-30','18:00:00',1.41),('15128','2014-03-30','18:05:00',1.3),('15128','2014-03-30','18:10:00',1.17),('15128','2014-03-30','18:15:00',1.07),('15128','2013-05-10','08:00:00',1.14),('15128','2013-05-10','08:05:00',1.04),('15128','2013-05-10','08:35:00',1.05),('15128','2013-05-10','08:40:00',1.18),('15128','2013-05-10','08:45:00',1.3),('15128','2013-05-10','08:50:00',1.93),('15128','2013-05-10','08:55:00',1.46),('15128','2013-05-10','09:00:00',1.6),('15128','2013-05-10','09:05:00',1.22),('15128','2013-05-10','09:10:00',1.83),('15128','2013-05-10','09:15:00',1.47),('15128','2013-05-10','09:20:00',2.43),('15128','2013-05-10','09:25:00',1.36),('15128','2013-05-10','09:30:00',1.62),('15128','2013-05-10','09:35:00',1.25),('15128','2013-05-10','09:40:00',1.61),('15128','2013-05-10','09:45:00',1.81),('15128','2013-05-10','09:50:00',3.09),('15128','2013-05-10','09:55:00',3.29),('15128','2013-05-10','10:00:00',2.27),('15128','2013-05-10','10:15:00',2.16),('15128','2013-05-10','10:20:00',3.05),('15128','2013-05-10','10:25:00',3.19),('15128','2013-05-10','10:30:00',1.57),('15128','2013-05-10','10:40:00',2.35),('15128','2013-05-10','10:45:00',3.3),('15128','2013-05-10','10:50:00',3.29),('15128','2013-05-10','10:55:00',2.62),('15128','2013-05-10','11:00:00',3.76),('15128','2013-05-10','11:05:00',3.7),('15128','2013-05-10','11:10:00',3.84),('15128','2013-05-10','11:15:00',1.58),('15128','2013-05-10','11:20:00',3.94),('15128','2013-05-10','11:25:00',2.9),('15128','2013-05-10','11:30:00',1.77),('15128','2013-05-10','11:35:00',3.55),('15128','2013-05-10','11:40:00',4.23),('15128','2013-05-10','11:45:00',3.39),('15128','2013-05-10','11:50:00',2.39),('15128','2013-05-10','11:55:00',2.78),('15128','2013-05-10','12:00:00',3.8),('15128','2013-05-10','12:05:00',3.29),('15128','2013-05-10','12:10:00',3.61),('15128','2013-05-10','12:15:00',3.33),('15128','2013-05-10','12:20:00',3.66),('15128','2013-05-10','12:25:00',2.78),('15128','2013-05-10','12:30:00',3.23),('15128','2013-05-10','12:35:00',3.54),('15128','2013-05-10','12:40:00',3.55),('15128','2013-05-10','12:45:00',2.91),('15128','2013-05-10','12:50:00',2.09),('15128','2013-05-10','12:55:00',4),('15128','2013-05-10','13:00:00',3.65),('15128','2013-05-10','13:05:00',4.85),('15128','2013-05-10','13:10:00',3.61),('15128','2013-05-10','13:15:00',3.8),('15128','2013-05-10','13:20:00',3.43),('15128','2013-05-10','13:25:00',4.75),('15128','2013-05-10','13:30:00',2.14),('15128','2013-05-10','13:35:00',2.67),('15128','2013-05-10','13:40:00',4.01),('15128','2013-05-10','13:45:00',2.32),('15128','2013-05-10','13:50:00',3.6),('15128','2013-05-10','13:55:00',4.58),('15128','2013-05-10','14:00:00',4.84),('15128','2013-05-10','14:05:00',4.99),('15128','2013-05-10','14:10:00',3.72),('15128','2013-05-10','14:15:00',3.42),('15128','2013-05-10','14:20:00',3.01),('15128','2013-05-10','14:25:00',2.37),('15128','2013-05-10','14:30:00',2.98),('15128','2013-05-10','14:35:00',3.06),('15128','2013-05-10','14:40:00',3.14),('15128','2013-05-10','14:45:00',3.6),('15128','2013-05-10','14:50:00',4.53),('15128','2013-05-10','14:55:00',2.82),('15128','2013-05-10','15:00:00',1.86),('15128','2013-05-10','15:05:00',2.89),('15128','2013-05-10','15:10:00',2.25),('15128','2013-05-10','15:15:00',3.88),('15128','2013-05-10','15:20:00',2.74),('15128','2013-05-10','15:25:00',3.12),('15128','2013-05-10','15:30:00',2.43),('15128','2013-05-10','15:35:00',2.86),('15128','2013-05-10','15:40:00',2.75),('15128','2013-05-10','15:45:00',2.2),('15128','2013-05-10','15:50:00',4.18),('15128','2013-05-10','15:55:00',3.36),('15128','2013-05-10','16:00:00',2.69),('15128','2013-05-10','16:05:00',2.78),('15128','2013-05-10','16:10:00',4.14),('15128','2013-05-10','16:15:00',3.56),('15128','2013-05-10','16:20:00',3.79),('15128','2013-05-10','16:25:00',3.95),('15128','2013-05-10','16:30:00',3.61),('15128','2013-05-10','16:35:00',3.55),('15128','2013-05-10','16:40:00',2.96),('15128','2013-05-10','16:45:00',2.02),('15128','2013-05-10','16:50:00',2.2),('15128','2013-05-10','16:55:00',3.27),('15128','2013-05-10','17:00:00',2.18),('15128','2013-05-10','17:05:00',1.98),('15128','2013-05-10','17:10:00',1.6),('15128','2013-05-10','17:15:00',2.25),('15128','2013-05-10','17:20:00',1.78),('15128','2013-05-10','17:25:00',2.37),('15128','2013-05-10','17:30:00',2.73),('15128','2013-05-10','17:35:00',2.03),('15128','2013-05-10','17:40:00',2.22),('15128','2013-05-10','17:45:00',2.69),('15128','2013-05-10','17:50:00',2.07),('15128','2013-05-10','17:55:00',2.02),('15128','2013-05-10','18:00:00',2.11),('15128','2013-05-10','18:05:00',2.03),('15128','2013-05-10','18:10:00',1.87),('15128','2013-05-10','18:15:00',1.51),('15128','2013-05-10','18:20:00',2.08),('15128','2013-05-10','18:25:00',1.84),('15128','2013-05-10','18:40:00',1.14),('15128','2013-05-10','19:00:00',1.01),('15128','2013-05-09','07:50:00',1),('15128','2013-05-09','07:55:00',1.45),('15128','2013-05-09','08:00:00',1.49),('15128','2013-05-09','08:05:00',1.4),('15128','2013-05-09','08:10:00',1.05),('15128','2013-05-09','08:15:00',1.12),('15128','2013-05-09','08:20:00',1.3),('15128','2013-05-09','08:25:00',1.02),('15128','2013-05-09','08:50:00',1.49),('15128','2013-05-09','08:55:00',1.69),('15128','2013-05-09','09:00:00',1.77),('15128','2013-05-09','09:05:00',1.79),('15128','2013-05-09','09:10:00',1.93),('15128','2013-05-09','09:15:00',1.89),('15128','2013-05-09','09:20:00',1.66),('15128','2013-05-09','09:25:00',2),('15128','2013-05-09','09:30:00',2.1),('15128','2013-05-09','09:35:00',2.13),('15128','2013-05-09','09:40:00',2.31),('15128','2013-05-09','09:45:00',1.95),('15128','2013-05-09','09:50:00',1.44),('15128','2013-05-09','09:55:00',2.44),('15128','2013-05-09','10:00:00',2.69),('15128','2013-05-09','10:05:00',2.85),('15128','2013-05-09','10:10:00',3.1),('15128','2013-05-09','10:15:00',2.87),('15128','2013-05-09','10:20:00',2.99),('15128','2013-05-09','10:25:00',2.8),('15128','2013-05-09','10:30:00',2.93),('15128','2013-05-09','10:35:00',2.97),('15128','2013-05-09','10:40:00',3.03),('15128','2013-05-09','10:45:00',3.11),('15128','2013-05-09','10:50:00',3.43),('15128','2013-05-09','10:55:00',3.69),('15128','2013-05-09','11:00:00',3.5),('15128','2013-05-09','11:05:00',3.22),('15128','2013-05-09','11:10:00',3.44),('15128','2013-05-09','11:15:00',3.93),('15128','2013-05-09','11:20:00',2.92),('15128','2013-05-09','11:25:00',2.4),('15128','2013-05-09','11:30:00',4.18),('15128','2013-05-09','11:35:00',3.23),('15128','2013-05-09','11:40:00',2.17),('15128','2013-05-09','11:45:00',4.08),('15128','2013-05-09','11:50:00',2.53),('15128','2013-05-09','11:55:00',2.53),('15128','2013-05-09','12:00:00',3.29),('15128','2013-05-09','12:05:00',3.1),('15128','2013-05-09','12:10:00',2.98),('15128','2013-05-09','12:15:00',3.01),('15128','2013-05-09','12:20:00',2.94),('15128','2013-05-09','12:25:00',3.55),('15128','2013-05-09','12:30:00',4.68),('15128','2013-05-09','12:35:00',4.76),('15128','2013-05-09','12:40:00',4.42),('15128','2013-05-09','12:45:00',3.97),('15128','2013-05-09','12:50:00',5.01),('15128','2013-05-09','12:55:00',4.03),('15128','2013-05-09','13:00:00',2.95),('15128','2013-05-09','13:05:00',3.88),('15128','2013-05-09','13:10:00',4.92),('15128','2013-05-09','13:15:00',3.04),('15128','2013-05-09','13:20:00',3.1),('15128','2013-05-09','13:25:00',4.77),('15128','2013-05-09','13:30:00',4.55),('15128','2013-05-09','13:35:00',4.94),('15128','2013-05-09','13:40:00',2.87),('15128','2013-05-09','13:45:00',2.2),('15128','2013-05-09','13:50:00',2.05),('15128','2013-05-09','13:55:00',2.31),('15128','2013-05-09','14:00:00',2.84),('15128','2013-05-09','14:05:00',3.12),('15128','2013-05-09','14:10:00',3.28),('15128','2013-05-09','14:15:00',2.83),('15128','2013-05-09','14:20:00',2.71),('15128','2013-05-09','14:25:00',2.81),('15128','2013-05-09','14:30:00',2.64),('15128','2013-05-09','14:35:00',2.18),('15128','2013-05-09','14:40:00',1.79),('15128','2013-05-09','14:45:00',1.58),('15128','2013-05-09','14:50:00',1.82),('15128','2013-05-09','14:55:00',2.56),('15128','2013-05-09','15:00:00',4.78),('15128','2013-05-09','15:05:00',3.69),('15128','2013-05-09','15:10:00',2.78),('15128','2013-05-09','15:15:00',2.24),('15128','2013-05-09','15:20:00',2.32),('15128','2013-05-09','15:25:00',2.71),('15128','2013-05-09','15:30:00',2.94),('15128','2013-05-09','15:35:00',2.38),('15128','2013-05-09','15:40:00',2.25),('15128','2013-05-09','15:45:00',2.08),('15128','2013-05-09','15:50:00',1.98),('15128','2013-05-09','15:55:00',1.94),('15128','2013-05-09','16:00:00',1.84),('15128','2013-05-09','16:05:00',1.63),('15128','2013-05-09','16:10:00',1.64),('15128','2013-05-09','16:15:00',1.69),('15128','2013-05-09','16:20:00',1.66),('15128','2013-05-09','16:25:00',1.88),('15128','2013-05-09','16:30:00',1.8),('15128','2013-05-09','16:35:00',1.74),('15128','2013-05-09','16:40:00',1.64),('15128','2013-05-09','16:45:00',1.35),('15128','2013-05-09','16:50:00',1.38),('15128','2013-05-09','16:55:00',1.52),('15128','2013-05-09','17:00:00',2),('15128','2013-05-09','17:05:00',1.92),('15128','2013-05-09','17:10:00',2.18),('15128','2013-05-09','17:15:00',2.46),('15128','2013-05-09','17:20:00',3.82),('15128','2013-05-09','17:25:00',3.33),('15128','2013-05-09','17:30:00',1.94),('15128','2013-05-09','17:35:00',1.59),('15128','2013-05-09','17:40:00',1.48),('15128','2013-05-09','17:45:00',1.11),('15128','2013-05-08','08:10:00',1.03),('15128','2013-05-08','08:15:00',1.11),('15128','2013-05-08','08:20:00',1.19),('15128','2013-05-08','08:25:00',1.25),('15128','2013-05-08','08:30:00',1.33),('15128','2013-05-08','08:35:00',1.44),('15128','2013-05-08','08:40:00',1.5),('15128','2013-05-08','08:45:00',1.58),('15128','2013-05-08','08:50:00',1.64),('15128','2013-05-08','08:55:00',1.71),('15128','2013-05-08','09:00:00',1.77),('15128','2013-05-08','09:05:00',1.87),('15128','2013-05-08','09:10:00',1.95),('15128','2013-05-08','09:15:00',2.01),('15128','2013-05-08','09:20:00',2.1),('15128','2013-05-08','09:25:00',2.14),('15128','2013-05-08','09:30:00',2.15),('15128','2013-05-08','09:35:00',2.13),('15128','2013-05-08','09:40:00',2.12),('15128','2013-05-08','09:45:00',2.14),('15128','2013-05-08','09:50:00',2.27),('15128','2013-05-08','09:55:00',2.34),('15128','2013-05-08','10:00:00',2.41),('15128','2013-05-08','10:05:00',2.53),('15128','2013-05-08','10:10:00',2.64),('15128','2013-05-08','10:15:00',2.7),('15128','2013-05-08','10:20:00',2.68),('15128','2013-05-08','10:25:00',2.76),('15128','2013-05-08','10:30:00',2.84),('15128','2013-05-08','10:35:00',2.86),('15128','2013-05-08','10:40:00',2.93),('15128','2013-05-08','10:45:00',3.03),('15128','2013-05-08','10:50:00',3.07),('15128','2013-05-08','10:55:00',3.18),('15128','2013-05-08','11:00:00',3.21),('15128','2013-05-08','11:05:00',3.33),('15128','2013-05-08','11:10:00',3.28),('15128','2013-05-08','11:15:00',3.37),('15128','2013-05-08','11:20:00',3.37),('15128','2013-05-08','11:25:00',3.44),('15128','2013-05-08','11:30:00',3.52),('15128','2013-05-08','11:35:00',3.51),('15128','2013-05-08','11:40:00',3.63),('15128','2013-05-08','11:45:00',3.85),('15128','2013-05-08','11:50:00',3.96),('15128','2013-05-08','11:55:00',4.01),('15128','2013-05-08','12:00:00',4.04),('15128','2013-05-08','12:05:00',4.07),('15128','2013-05-08','12:10:00',4.09),('15128','2013-05-08','12:15:00',4.24),('15128','2013-05-08','12:20:00',4.24),('15128','2013-05-08','12:25:00',4.3),('15128','2013-05-08','12:30:00',4.35),('15128','2013-05-08','12:35:00',4.32),('15128','2013-05-08','12:40:00',4.44),('15128','2013-05-08','12:45:00',4.52),('15128','2013-05-08','12:50:00',4.46),('15128','2013-05-08','12:55:00',4.37),('15128','2013-05-08','13:00:00',4.31),('15128','2013-05-08','13:05:00',4.34),('15128','2013-05-08','13:10:00',4.37),('15128','2013-05-08','13:15:00',4.45),('15128','2013-05-08','13:20:00',4.43),('15128','2013-05-08','13:25:00',4.44),('15128','2013-05-08','13:30:00',4.49),('15128','2013-05-08','13:35:00',4.58),('15128','2013-05-08','13:40:00',1.8),('15128','2013-05-08','13:50:00',1.95),('15128','2013-05-08','13:55:00',1.33),('15128','2013-05-08','14:00:00',5.02),('15128','2013-05-08','14:05:00',4.66),('15128','2013-05-08','14:10:00',4.4),('15128','2013-05-08','14:15:00',2.17),('15128','2013-05-08','14:20:00',4.49),('15128','2013-05-08','14:25:00',4.78),('15128','2013-05-08','14:30:00',4.7),('15128','2013-05-08','14:35:00',3.99),('15128','2013-05-08','14:40:00',3.86),('15128','2013-05-08','14:45:00',4.45),('15128','2013-05-08','14:50:00',4.34),('15128','2013-05-08','14:55:00',4.31),('15128','2013-05-08','15:00:00',4.31),('15128','2013-05-08','15:05:00',4.25),('15128','2013-05-08','15:10:00',4.23),('15128','2013-05-08','15:15:00',4.21),('15128','2013-05-08','15:20:00',4.16),('15128','2013-05-08','15:25:00',4.11),('15128','2013-05-08','15:30:00',4.12),('15128','2013-05-08','15:35:00',4.09),('15128','2013-05-08','15:40:00',4.05),('15128','2013-05-08','15:45:00',4.01),('15128','2013-05-08','15:50:00',3.96),('15128','2013-05-08','15:55:00',3.89),('15128','2013-05-08','16:00:00',3.87),('15128','2013-05-08','16:05:00',3.82),('15128','2013-05-08','16:10:00',3.75),('15128','2013-05-08','16:15:00',3.7),('15128','2013-05-08','16:20:00',3.66),('15128','2013-05-08','16:25:00',3.63),('15128','2013-05-08','16:30:00',3.56),('15128','2013-05-08','16:35:00',3.48),('15128','2013-05-08','16:40:00',3.44),('15128','2013-05-08','16:45:00',3.4),('15128','2013-05-08','16:50:00',3.34),('15128','2013-05-08','16:55:00',3.26),('15128','2013-05-08','17:00:00',3.18),('15128','2013-05-08','17:05:00',3.1),('15128','2013-05-08','17:10:00',3.02),('15128','2013-05-08','17:15:00',2.96),('15128','2013-05-08','17:20:00',2.9),('15128','2013-05-08','17:25:00',2.82),('15128','2013-05-08','17:30:00',2.73),('15128','2013-05-08','17:35:00',2.64),('15128','2013-05-08','17:40:00',2.54),('15128','2013-05-08','17:45:00',2.42),('15128','2013-05-08','17:50:00',2.29),('15128','2013-05-08','17:55:00',2.18),('15128','2013-05-08','18:00:00',2.04),('15128','2013-05-08','18:05:00',1.94),('15128','2013-05-08','18:10:00',1.89),('15128','2013-05-08','18:15:00',1.83),('15128','2013-05-08','18:20:00',1.79),('15128','2013-05-08','18:25:00',1.72),('15128','2013-05-08','18:30:00',1.63),('15128','2013-05-08','18:35:00',1.54),('15128','2013-05-08','18:40:00',1.47),('15128','2013-05-08','18:45:00',1.35),('15128','2013-05-08','18:50:00',1.24),('15128','2013-05-08','18:55:00',1.13),('15128','2013-05-08','19:00:00',1.01),('15128','2013-05-07','08:10:00',1.02),('15128','2013-05-07','08:15:00',1.1),('15128','2013-05-07','08:20:00',1.18),('15128','2013-05-07','08:25:00',1.26),('15128','2013-05-07','08:30:00',1.41),('15128','2013-05-07','08:35:00',1.63),('15128','2013-05-07','08:40:00',1.48),('15128','2013-05-07','08:45:00',1.1),('15128','2013-05-07','08:50:00',1.11),('15128','2013-05-07','08:55:00',1.39),('15128','2013-05-07','09:00:00',1.35),('15128','2013-05-07','09:05:00',1.09),('15128','2013-05-07','09:10:00',1.07),('15128','2013-05-07','09:15:00',1.12),('15128','2013-05-07','09:55:00',2.2),('15128','2013-05-07','10:00:00',2.71),('15128','2013-05-07','10:05:00',2.87),('15128','2013-05-07','10:10:00',3.18),('15128','2013-05-07','10:15:00',3.45),('15128','2013-05-07','10:20:00',2.31),('15128','2013-05-07','10:25:00',1.92),('15128','2013-05-07','10:30:00',2.72),('15128','2013-05-07','10:35:00',1.71),('15128','2013-05-07','10:40:00',3.03),('15128','2013-05-07','10:45:00',3.51),('15128','2013-05-07','10:50:00',1.94),('15128','2013-05-07','10:55:00',2.26),('15128','2013-05-07','11:00:00',4.25),('15128','2013-05-07','11:05:00',2.16),('15128','2013-05-07','11:10:00',1.25),('15128','2013-05-07','11:30:00',2.3),('15128','2013-05-07','11:35:00',4.19),('15128','2013-05-07','11:40:00',4.28),('15128','2013-05-07','11:45:00',4.53),('15128','2013-05-07','11:50:00',4.43),('15128','2013-05-07','11:55:00',1.49),('15128','2013-05-07','12:00:00',1.45),('15128','2013-05-07','12:05:00',4.91),('15128','2013-05-07','12:10:00',4.94),('15128','2013-05-07','12:15:00',3.41),('15128','2013-05-07','12:20:00',2.32),('15128','2013-05-07','12:25:00',4.21),('15128','2013-05-07','12:30:00',4.84),('15128','2013-05-07','12:35:00',4.51),('15128','2013-05-07','12:40:00',1.39),('15128','2013-05-07','12:45:00',1.68),('15128','2013-05-07','12:50:00',5.33),('15128','2013-05-07','12:55:00',2.16),('15128','2013-05-07','13:00:00',1.17),('15128','2013-05-07','13:05:00',1.42),('15128','2013-05-07','13:10:00',2.1),('15128','2013-05-07','13:15:00',2.24),('15128','2013-05-07','13:20:00',4.05),('15128','2013-05-07','13:25:00',1.05),('15128','2013-05-07','13:30:00',1.12),('15128','2013-05-07','13:35:00',3.29),('15128','2013-05-07','13:40:00',5.57),('15128','2013-05-07','13:45:00',4.76),('15128','2013-05-07','13:50:00',5.26),('15128','2013-05-07','13:55:00',3.63),('15128','2013-05-07','14:00:00',3.69),('15128','2013-05-07','14:05:00',2.77),('15128','2013-05-07','14:10:00',4.72),('15128','2013-05-07','14:15:00',4.41),('15128','2013-05-07','14:20:00',3.75),('15128','2013-05-07','14:25:00',2.58),('15128','2013-05-07','14:30:00',1.32),('15128','2013-05-07','14:35:00',2.67),('15128','2013-05-07','14:40:00',3.29),('15128','2013-05-07','14:45:00',1.64),('15128','2013-05-07','14:50:00',1.71),('15128','2013-05-07','14:55:00',3.16),('15128','2013-05-07','15:00:00',4.69),('15128','2013-05-07','15:05:00',1.74),('15128','2013-05-07','15:10:00',3.69),('15128','2013-05-07','15:15:00',4.22),('15128','2013-05-07','15:20:00',3.93),('15128','2013-05-07','15:25:00',4.32),('15128','2013-05-07','15:30:00',4.28),('15128','2013-05-07','15:35:00',4.17),('15128','2013-05-07','15:40:00',4.11),('15128','2013-05-07','15:45:00',4.07),('15128','2013-05-07','15:50:00',3.98),('15128','2013-05-07','15:55:00',3.95),('15128','2013-05-07','16:00:00',3.9),('15128','2013-05-07','16:05:00',3.73),('15128','2013-05-07','16:10:00',3.82),('15128','2013-05-07','16:15:00',3.73),('15128','2013-05-07','16:20:00',3.68),('15128','2013-05-07','16:25:00',3.65),('15128','2013-05-07','16:30:00',3.65),('15128','2013-05-07','16:35:00',3.64),('15128','2013-05-07','16:40:00',3.59),('15128','2013-05-07','16:45:00',2.72),('15128','2013-05-07','16:50:00',3.26),('15128','2013-05-07','16:55:00',2.73),('15128','2013-05-07','17:00:00',2.27),('15128','2013-05-07','17:05:00',2.48),('15128','2013-05-07','17:10:00',1.69),('15128','2013-05-07','17:15:00',1.39),('15128','2013-05-07','17:20:00',1.57),('15128','2013-05-07','17:25:00',2.42),('15128','2013-05-07','17:30:00',2.95),('15128','2013-05-07','17:35:00',2.86),('15128','2013-05-07','17:40:00',2.91),('15128','2013-05-07','17:45:00',2.93),('15128','2013-05-07','17:50:00',2.9),('15128','2013-05-07','17:55:00',2.8),('15128','2013-05-07','18:00:00',2.61),('15128','2013-05-07','18:05:00',2.54),('15128','2013-05-07','18:10:00',2.32),('15128','2013-05-07','18:15:00',2.16),('15128','2013-05-07','18:20:00',2.02),('15128','2013-05-07','18:25:00',1.87),('15128','2013-05-07','18:45:00',1.35),('15128','2013-05-07','18:50:00',1.27),('15128','2013-05-07','18:55:00',1.18),('15128','2013-05-06','08:15:00',1.09),('15128','2013-05-06','08:20:00',1.16),('15128','2013-05-06','08:25:00',1.23),('15128','2013-05-06','08:30:00',1.3),('15128','2013-05-06','08:35:00',1.38),('15128','2013-05-06','08:40:00',1.42),('15128','2013-05-06','08:45:00',1.07),('15128','2013-05-06','08:50:00',1.42),('15128','2013-05-06','09:00:00',2.22),('15128','2013-05-06','09:05:00',1.04),('15128','2013-05-06','09:10:00',1.48),('15128','2013-05-06','09:15:00',2.22),('15128','2013-05-06','09:20:00',1.81),('15128','2013-05-06','09:35:00',1.36),('15128','2013-05-06','10:15:00',2.31),('15128','2013-05-06','10:20:00',3.12),('15128','2013-05-06','10:25:00',2.88),('15128','2013-05-06','10:30:00',3.53),('15128','2013-05-06','10:35:00',2.35),('15128','2013-05-06','10:40:00',1.25),('15128','2013-05-06','11:10:00',1.39),('15128','2013-05-06','11:15:00',2.91),('15128','2013-05-06','11:20:00',4.2),('15128','2013-05-06','11:25:00',4.22),('15128','2013-05-06','11:30:00',3.57),('15128','2013-05-06','11:35:00',4.68),('15128','2013-05-06','11:40:00',4.27),('15128','2013-05-06','11:45:00',2.66),('15128','2013-05-06','11:50:00',4.4),('15128','2013-05-06','11:55:00',2.1),('15128','2013-05-06','12:00:00',1.35),('15128','2013-05-06','12:05:00',1.14),('15128','2013-05-06','12:15:00',1),('15128','2013-05-06','12:40:00',1.13),('15128','2013-05-06','12:45:00',1.66),('15128','2013-05-06','12:50:00',2.18),('15128','2013-05-06','12:55:00',2.36),('15128','2013-05-06','13:00:00',2.49),('15128','2013-05-06','13:05:00',2.83),('15128','2013-05-06','13:10:00',1.54),('15128','2013-05-06','13:15:00',3.43),('15128','2013-05-06','13:20:00',5.56),('15128','2013-05-06','13:25:00',2.76),('15128','2013-05-06','13:30:00',4.26),('15128','2013-05-06','13:35:00',4.61),('15128','2013-05-06','13:40:00',2.91),('15128','2013-05-06','13:45:00',4.8),('15128','2013-05-06','13:50:00',4.89),('15128','2013-05-06','13:55:00',2.91),('15128','2013-05-06','14:00:00',2.78),('15128','2013-05-06','14:05:00',3.28),('15128','2013-05-06','14:10:00',3.36),('15128','2013-05-06','14:15:00',2.83),('15128','2013-05-06','14:20:00',4.86),('15128','2013-05-06','14:25:00',5.28),('15128','2013-05-06','14:30:00',4.66),('15128','2013-05-06','14:35:00',2.96),('15128','2013-05-06','14:40:00',5.1),('15128','2013-05-06','14:45:00',5.12),('15128','2013-05-06','14:50:00',4.34),('15128','2013-05-06','14:55:00',4.27),('15128','2013-05-06','15:00:00',3.37),('15128','2013-05-06','15:05:00',4.65),('15128','2013-05-06','15:10:00',2.78),('15128','2013-05-06','15:15:00',1.45),('15128','2013-05-06','15:20:00',2.51),('15128','2013-05-06','15:25:00',3.99),('15128','2013-05-06','15:30:00',3.72),('15128','2013-05-06','15:35:00',4.26),('15128','2013-05-06','15:40:00',5.46),('15128','2013-05-06','15:45:00',3.79),('15128','2013-05-06','15:50:00',2.58),('15128','2013-05-06','15:55:00',3.06),('15128','2013-05-06','16:00:00',4.69),('15128','2013-05-06','16:05:00',4.26),('15128','2013-05-06','16:10:00',3.69),('15128','2013-05-06','16:15:00',4.47),('15128','2013-05-06','16:20:00',3.22),('15128','2013-05-06','16:25:00',4.46),('15128','2013-05-06','16:30:00',4.11),('15128','2013-05-06','16:35:00',3.55),('15128','2013-05-06','16:40:00',2.09),('15128','2013-05-06','16:45:00',1.84),('15128','2013-05-06','16:50:00',2.19),('15128','2013-05-06','16:55:00',1.98),('15128','2013-05-06','17:00:00',2),('15128','2013-05-06','17:05:00',1.74),('15128','2013-05-06','17:10:00',1.46),('15128','2013-05-06','17:15:00',1.37),('15128','2013-05-06','17:20:00',1.8),('15128','2013-05-06','17:25:00',1.59),('15128','2013-05-06','17:30:00',1.26),('15128','2013-05-05','08:20:00',1.1),('15128','2013-05-05','08:25:00',1.44),('15128','2013-05-05','08:30:00',1.12),('15128','2013-05-05','08:35:00',1.09),('15128','2013-05-05','08:40:00',1.29),('15128','2013-05-05','08:45:00',1.45),('15128','2013-05-05','08:50:00',1.57),('15128','2013-05-05','08:55:00',1.32),('15128','2013-05-05','09:00:00',1.2),('15128','2013-05-05','09:05:00',1.29),('15128','2013-05-05','09:10:00',1.84),('15128','2013-05-05','09:15:00',2.15),('15128','2013-05-05','09:20:00',1.59),('15128','2013-05-05','09:25:00',1.2),('15128','2013-05-05','09:45:00',1.32),('15128','2013-05-05','10:00:00',1.17),('15128','2013-05-05','10:05:00',1.32),('15128','2013-05-05','10:10:00',1.48),('15128','2013-05-05','10:15:00',2.09),('15128','2013-05-05','10:20:00',2.13),('15128','2013-05-05','10:25:00',1.75),('15128','2013-05-05','10:30:00',1.84),('15128','2013-05-05','10:35:00',1.85),('15128','2013-05-05','10:40:00',2.53),('15128','2013-05-05','10:45:00',1.99),('15128','2013-05-05','10:50:00',1.99),('15128','2013-05-05','10:55:00',1.68),('15128','2013-05-05','11:00:00',1.08),('15128','2013-05-05','11:05:00',1.13),('15128','2013-05-05','11:10:00',1.47),('15128','2013-05-05','11:15:00',1.68),('15128','2013-05-05','11:20:00',1.16),('15128','2013-05-05','11:25:00',1.12),('15128','2013-05-05','11:30:00',2.45),('15128','2013-05-05','11:35:00',2.77),('15128','2013-05-05','11:40:00',1.91),('15128','2013-05-05','11:45:00',2.34),('15128','2013-05-05','11:50:00',2.15),('15128','2013-05-05','11:55:00',1.8),('15128','2013-05-05','12:00:00',2.47),('15128','2013-05-05','12:05:00',2.4),('15128','2013-05-05','12:10:00',2.32),('15128','2013-05-05','12:15:00',1.84),('15128','2013-05-05','12:20:00',3.97),('15128','2013-05-05','12:25:00',3.31),('15128','2013-05-05','12:30:00',2.54),('15128','2013-05-05','12:35:00',3.46),('15128','2013-05-05','12:40:00',4.39),('15128','2013-05-05','12:45:00',3.31),('15128','2013-05-05','12:50:00',3.73),('15128','2013-05-05','12:55:00',2.13),('15128','2013-05-05','13:00:00',4.46),('15128','2013-05-05','13:05:00',4.94),('15128','2013-05-05','13:10:00',4.69),('15128','2013-05-05','13:15:00',4.13),('15128','2013-05-05','13:20:00',4.14),('15128','2013-05-05','13:25:00',2.58),('15128','2013-05-05','13:30:00',3.1),('15128','2013-05-05','13:35:00',4.06),('15128','2013-05-05','13:40:00',3.62),('15128','2013-05-05','13:45:00',5.41),('15128','2013-05-05','13:50:00',2.88),('15128','2013-05-05','13:55:00',3.07),('15128','2013-05-05','14:00:00',2.48),('15128','2013-05-05','14:05:00',4.81),('15128','2013-05-05','14:10:00',3.54),('15128','2013-05-05','14:15:00',4.59),('15128','2013-05-05','14:20:00',3.27),('15128','2013-05-05','14:25:00',4.18),('15128','2013-05-05','14:30:00',4.41),('15128','2013-05-05','14:35:00',3.88),('15128','2013-05-05','14:40:00',1.83),('15128','2013-05-05','14:45:00',3.29),('15128','2013-05-05','14:50:00',2.42),('15128','2013-05-05','14:55:00',2.5),('15128','2013-05-05','15:00:00',2.17),('15128','2013-05-05','15:05:00',3.75),('15128','2013-05-05','15:10:00',4.4),('15128','2013-05-05','15:15:00',2.38),('15128','2013-05-05','15:20:00',1.71),('15128','2013-05-05','15:25:00',3.42),('15128','2013-05-05','15:30:00',2.42),('15128','2013-05-05','15:35:00',2.14),('15128','2013-05-05','15:40:00',3.4),('15128','2013-05-05','15:45:00',4.09),('15128','2013-05-05','15:50:00',3.93),('15128','2013-05-05','15:55:00',2.21),('15128','2013-05-05','16:00:00',2.11),('15128','2013-05-05','16:05:00',2.8),('15128','2013-05-05','16:10:00',2.82),('15128','2013-05-05','16:15:00',2.54),('15128','2013-05-05','16:20:00',2.1),('15128','2013-05-05','16:25:00',1.81),('15128','2013-05-05','16:30:00',1.99),('15128','2013-05-05','16:35:00',1.31),('15128','2013-05-05','16:40:00',2.33),('15128','2013-05-05','16:45:00',1.21),('15128','2013-05-05','17:05:00',2.9),('15128','2013-05-05','17:10:00',3.88),('15128','2013-05-05','17:15:00',1.21),('15128','2013-05-05','17:20:00',1.16),('15128','2013-05-05','17:25:00',1.69),('15128','2013-05-05','17:30:00',2.96),('15128','2013-05-05','17:35:00',3.33),('15128','2013-05-05','17:40:00',2.9),('15128','2013-05-05','17:45:00',2.68),('15128','2013-05-05','17:50:00',1.01),('15128','2013-05-05','17:55:00',2.31),('15128','2013-05-05','18:00:00',2.26),('15128','2013-05-05','18:05:00',2.05),('15128','2013-05-05','18:10:00',1.96),('15128','2013-05-05','18:15:00',2.19),('15128','2013-05-05','18:20:00',2.08),('15128','2013-05-05','18:25:00',1.07),('15128','2013-05-05','18:30:00',1.24),('15128','2013-05-04','08:15:00',1.01),('15128','2013-05-04','08:20:00',1.15),('15128','2013-05-04','08:25:00',1.03),('15128','2013-05-04','08:35:00',1.06),('15128','2013-05-04','08:40:00',1.47),('15128','2013-05-04','08:45:00',1.41),('15128','2013-05-04','08:50:00',1.37),('15128','2013-05-04','08:55:00',1.29),('15128','2013-05-04','09:00:00',1.51),('15128','2013-05-04','09:05:00',1.32),('15128','2013-05-04','09:10:00',1.33),('15128','2013-05-04','09:15:00',1.37),('15128','2013-05-04','09:20:00',1.75),('15128','2013-05-04','09:25:00',2.47),('15128','2013-05-04','09:30:00',2.25),('15128','2013-05-04','09:35:00',2.53),('15128','2013-05-04','09:40:00',2.36),('15128','2013-05-04','09:45:00',2.18),('15128','2013-05-04','09:50:00',2.71),('15128','2013-05-04','09:55:00',1.69),('15128','2013-05-04','10:00:00',1.29),('15128','2013-05-04','10:05:00',1.33),('15128','2013-05-04','10:10:00',1.32),('15128','2013-05-04','10:15:00',1.4),('15128','2013-05-04','10:20:00',1.36),('15128','2013-05-04','10:25:00',1.85),('15128','2013-05-04','10:30:00',1.8),('15128','2013-05-04','10:35:00',1.79),('15128','2013-05-04','10:40:00',1.19),('15128','2013-05-04','10:45:00',1.01),('15128','2013-05-04','10:55:00',1),('15128','2013-05-04','11:00:00',1.32),('15128','2013-05-04','11:05:00',1.3),('15128','2013-05-04','11:10:00',2.59),('15128','2013-05-04','11:15:00',3.51),('15128','2013-05-04','11:20:00',2.64),('15128','2013-05-04','11:25:00',3.29),('15128','2013-05-04','11:30:00',3.45),('15128','2013-05-04','11:35:00',2.7),('15128','2013-05-04','11:40:00',2.83),('15128','2013-05-04','11:45:00',2.4),('15128','2013-05-04','11:50:00',3.05),('15128','2013-05-04','11:55:00',4.1),('15128','2013-05-04','12:00:00',3.92),('15128','2013-05-04','12:05:00',3.66),('15128','2013-05-04','12:10:00',4.22),('15128','2013-05-04','12:15:00',4.32),('15128','2013-05-04','12:20:00',4.15),('15128','2013-05-04','12:25:00',3.96),('15128','2013-05-04','12:30:00',4.17),('15128','2013-05-04','12:35:00',4.37),('15128','2013-05-04','12:40:00',4.27),('15128','2013-05-04','12:45:00',3.57),('15128','2013-05-04','12:50:00',3.45),('15128','2013-05-04','12:55:00',4.17),('15128','2013-05-04','13:00:00',1.75),('15128','2013-05-04','13:05:00',1.25),('15128','2013-05-04','13:10:00',1.92),('15128','2013-05-04','13:15:00',3.77),('15128','2013-05-04','13:20:00',3.68),('15128','2013-05-04','13:25:00',3.59),('15128','2013-05-04','13:30:00',3.67),('15128','2013-05-04','13:35:00',2.77),('15128','2013-05-04','13:40:00',2.81),('15128','2013-05-04','13:45:00',3.88),('15128','2013-05-04','13:50:00',2.91),('15128','2013-05-04','13:55:00',3.64),('15128','2013-05-04','14:00:00',3.86),('15128','2013-05-04','14:05:00',4.41),('15128','2013-05-04','14:10:00',4.21),('15128','2013-05-04','14:15:00',4.14),('15128','2013-05-04','14:20:00',4.09),('15128','2013-05-04','14:25:00',3.96),('15128','2013-05-04','14:30:00',3.94),('15128','2013-05-04','14:35:00',3.93),('15128','2013-05-04','14:40:00',3.93),('15128','2013-05-04','14:45:00',3.88),('15128','2013-05-04','14:50:00',3.86),('15128','2013-05-04','14:55:00',3.85),('15128','2013-05-04','15:00:00',3.83),('15128','2013-05-04','15:05:00',3.8),('15128','2013-05-04','15:10:00',3.77),('15128','2013-05-04','15:15:00',3.73),('15128','2013-05-04','15:20:00',3.67),('15128','2013-05-04','15:25:00',3.63),('15128','2013-05-04','15:30:00',3.6),('15128','2013-05-04','15:35:00',3.56),('15128','2013-05-04','15:40:00',3.54),('15128','2013-05-04','15:45:00',3.5),('15128','2013-05-04','15:50:00',3.45),('15128','2013-05-04','15:55:00',3.41),('15128','2013-05-04','16:00:00',3.4),('15128','2013-05-04','16:05:00',3.38),('15128','2013-05-04','16:10:00',3.33),('15128','2013-05-04','16:15:00',3.29),('15128','2013-05-04','16:20:00',3.24),('15128','2013-05-04','16:25:00',3.21),('15128','2013-05-04','16:30:00',3.13),('15128','2013-05-04','16:35:00',3.08),('15128','2013-05-04','16:40:00',3.02),('15128','2013-05-04','16:45:00',2.98),('15128','2013-05-04','16:50:00',2.92),('15128','2013-05-04','16:55:00',2.85),('15128','2013-05-04','17:00:00',2.78),('15128','2013-05-04','17:05:00',2.7),('15128','2013-05-04','17:10:00',2.64),('15128','2013-05-04','17:15:00',2.58),('15128','2013-05-04','17:20:00',2.49),('15128','2013-05-04','17:25:00',2.42),('15128','2013-05-04','17:30:00',2.34),('15128','2013-05-04','17:35:00',2.26),('15128','2013-05-04','17:40:00',2.17),('15128','2013-05-04','17:45:00',2.06),('15128','2013-05-04','17:50:00',1.97),('15128','2013-05-04','17:55:00',1.86),('15128','2013-05-04','18:00:00',1.8),('15128','2013-05-04','18:05:00',1.69),('15128','2013-05-04','18:10:00',1.64),('15128','2013-05-04','18:15:00',1.58),('15128','2013-05-04','18:20:00',1.51),('15128','2013-05-04','18:25:00',1.44),('15128','2013-05-04','18:30:00',1.33),('15128','2013-05-04','18:35:00',1.25),('15128','2013-05-04','18:40:00',1.16),('15128','2013-05-04','18:45:00',1.08),('15128','2013-05-03','08:20:00',1.05),('15128','2013-05-03','08:25:00',1.1),('15128','2013-05-03','08:30:00',1.12),('15128','2013-05-03','08:35:00',1.16),('15128','2013-05-03','08:40:00',1.26),('15128','2013-05-03','08:45:00',1.33),('15128','2013-05-03','08:50:00',1.37),('15128','2013-05-03','08:55:00',1.43),('15128','2013-05-03','09:00:00',1.5),('15128','2013-05-03','09:05:00',1.59),('15128','2013-05-03','09:10:00',1.61),('15128','2013-05-03','09:15:00',1.63),('15128','2013-05-03','09:20:00',1.7),('15128','2013-05-03','09:25:00',1.81),('15128','2013-05-03','09:30:00',1.78),('15128','2013-05-03','09:35:00',1.76),('15128','2013-05-03','09:40:00',1.84),('15128','2013-05-03','09:45:00',1.97),('15128','2013-05-03','09:50:00',2.08),('15128','2013-05-03','09:55:00',2.15),('15128','2013-05-03','10:00:00',2.29),('15128','2013-05-03','10:05:00',2.13),('15128','2013-05-03','10:10:00',2.35),('15128','2013-05-03','10:15:00',2.39),('15128','2013-05-03','10:20:00',2.47),('15128','2013-05-03','10:25:00',2.53),('15128','2013-05-03','10:30:00',2.53),('15128','2013-05-03','10:35:00',2.52),('15128','2013-05-03','10:40:00',2.56),('15128','2013-05-03','10:45:00',2.56),('15128','2013-05-03','10:50:00',2.6),('15128','2013-05-03','10:55:00',2.81),('15128','2013-05-03','11:00:00',2.86),('15128','2013-05-03','11:05:00',2.99),('15128','2013-05-03','11:10:00',2.98),('15128','2013-05-03','11:15:00',2.88),('15128','2013-05-03','11:20:00',2.75),('15128','2013-05-03','11:25:00',3.08),('15128','2013-05-03','11:30:00',3),('15128','2013-05-03','11:35:00',2.97),('15128','2013-05-03','11:40:00',3.07),('15128','2013-05-03','11:45:00',3.14),('15128','2013-05-03','11:50:00',3.06),('15128','2013-05-03','11:55:00',3.15),('15128','2013-05-03','12:00:00',3.29),('15128','2013-05-03','12:05:00',3.25),('15128','2013-05-03','12:10:00',3.24),('15128','2013-05-03','12:15:00',3.51),('15128','2013-05-03','12:20:00',3.63),('15128','2013-05-03','12:25:00',3.71),('15128','2013-05-03','12:30:00',3.86),('15128','2013-05-03','12:35:00',3.82),('15128','2013-05-03','12:40:00',3.8),('15128','2013-05-03','12:45:00',3.79),('15128','2013-05-03','12:50:00',3.84),('15128','2013-05-03','12:55:00',3.74),('15128','2013-05-03','13:00:00',3.75),('15128','2013-05-03','13:05:00',3.82),('15128','2013-05-03','13:10:00',3.85),('15128','2013-05-03','13:15:00',3.81),('15128','2013-05-03','13:20:00',3.9),('15128','2013-05-03','13:25:00',3.94),('15128','2013-05-03','13:30:00',3.87),('15128','2013-05-03','13:35:00',3.61),('15128','2013-05-03','13:40:00',3.89),('15128','2013-05-03','13:45:00',3.72),('15128','2013-05-03','13:50:00',3.31),('15128','2013-05-03','13:55:00',3.37),('15128','2013-05-03','14:00:00',3.74),('15128','2013-05-03','14:05:00',3.73),('15128','2013-05-03','14:10:00',3.59),('15128','2013-05-03','14:15:00',3.85),('15128','2013-05-03','14:20:00',3.59),('15128','2013-05-03','14:25:00',3.72),('15128','2013-05-03','14:30:00',3.66),('15128','2013-05-03','14:35:00',3.6),('15128','2013-05-03','14:40:00',3.59),('15128','2013-05-03','14:45:00',3.53),('15128','2013-05-03','14:50:00',3.28),('15128','2013-05-03','14:55:00',3.44),('15128','2013-05-03','15:00:00',3.59),('15128','2013-05-03','15:05:00',3.35),('15128','2013-05-03','15:10:00',3.44),('15128','2013-05-03','15:15:00',3.64),('15128','2013-05-03','15:20:00',3.59),('15128','2013-05-03','15:25:00',3.65),('15128','2013-05-03','15:30:00',3.67),('15128','2013-05-03','15:35:00',3.5),('15128','2013-05-03','15:40:00',3.57),('15128','2013-05-03','15:45:00',3.58),('15128','2013-05-03','15:50:00',3.51),('15128','2013-05-03','15:55:00',3.46),('15128','2013-05-03','16:00:00',3.4),('15128','2013-05-03','16:05:00',3.36),('15128','2013-05-03','16:10:00',3.3),('15128','2013-05-03','16:15:00',3.25),('15128','2013-05-03','16:20:00',3.19),('15128','2013-05-03','16:25:00',3.13),('15128','2013-05-03','16:30:00',3.08),('15128','2013-05-03','16:35:00',3.02),('15128','2013-05-03','16:40:00',2.98),('15128','2013-05-03','16:45:00',2.9),('15128','2013-05-03','16:50:00',2.87),('15128','2013-05-03','16:55:00',2.81),('15128','2013-05-03','17:00:00',2.75),('15128','2013-05-03','17:05:00',2.7),('15128','2013-05-03','17:10:00',2.5),('15128','2013-05-03','17:15:00',2.19),('15128','2013-05-03','17:20:00',2.36),('15128','2013-05-03','17:25:00',2.43),('15128','2013-05-03','17:30:00',2.34),('15128','2013-05-03','17:35:00',2.23),('15128','2013-05-03','17:40:00',2.04),('15128','2013-05-03','17:45:00',1.75),('15128','2013-05-03','17:50:00',2),('15128','2013-05-03','17:55:00',1.9),('15128','2013-05-03','18:00:00',1.81),('15128','2013-05-03','18:05:00',1.69),('15128','2013-05-03','18:10:00',1.59),('15128','2013-05-03','18:15:00',1.16),('15128','2013-05-02','08:25:00',1.05),('15128','2013-05-02','08:50:00',1.06),('15128','2013-05-02','08:55:00',1.31),('15128','2013-05-02','09:00:00',1.44),('15128','2013-05-02','09:05:00',1.45),('15128','2013-05-02','09:10:00',1.56),('15128','2013-05-02','09:15:00',1.69),('15128','2013-05-02','09:20:00',1.86),('15128','2013-05-02','09:25:00',1.89),('15128','2013-05-02','09:30:00',1.85),('15128','2013-05-02','09:35:00',1.87),('15128','2013-05-02','09:40:00',1.94),('15128','2013-05-02','09:45:00',2.06),('15128','2013-05-02','09:50:00',2.11),('15128','2013-05-02','09:55:00',2.18),('15128','2013-05-02','10:00:00',2.24),('15128','2013-05-02','10:05:00',2.3),('15128','2013-05-02','10:10:00',2.4),('15128','2013-05-02','10:15:00',2.42),('15128','2013-05-02','10:20:00',2.42),('15128','2013-05-02','10:25:00',2.51),('15128','2013-05-02','10:30:00',2.47),('15128','2013-05-02','10:35:00',2.5),('15128','2013-05-02','10:40:00',2.61),('15128','2013-05-02','10:45:00',2.75),('15128','2013-05-02','10:50:00',2.79),('15128','2013-05-02','10:55:00',2.9),('15128','2013-05-02','11:00:00',2.83),('15128','2013-05-02','11:05:00',2.97),('15128','2013-05-02','11:10:00',2.99),('15128','2013-05-02','11:15:00',3.05),('15128','2013-05-02','11:20:00',3.1),('15128','2013-05-02','11:25:00',3.07),('15128','2013-05-02','11:30:00',3.21),('15128','2013-05-02','11:35:00',3.19),('15128','2013-05-02','11:40:00',3.31),('15128','2013-05-02','11:45:00',3.51),('15128','2013-05-02','11:50:00',3.58),('15128','2013-05-02','11:55:00',3.64),('15128','2013-05-02','12:00:00',3.66),('15128','2013-05-02','12:05:00',3.72),('15128','2013-05-02','12:10:00',3.78),('15128','2013-05-02','12:15:00',3.83),('15128','2013-05-02','12:20:00',3.87),('15128','2013-05-02','12:25:00',3.92),('15128','2013-05-02','12:30:00',3.9),('15128','2013-05-02','12:35:00',3.91),('15128','2013-05-02','12:40:00',3.92),('15128','2013-05-02','12:45:00',3.92),('15128','2013-05-02','12:50:00',3.95),('15128','2013-05-02','12:55:00',3.99),('15128','2013-05-02','13:00:00',4),('15128','2013-05-02','13:05:00',4.01),('15128','2013-05-02','13:10:00',4.04),('15128','2013-05-02','13:15:00',4.05),('15128','2013-05-02','13:20:00',4.05),('15128','2013-05-02','13:25:00',4.01),('15128','2013-05-02','13:30:00',3.92),('15128','2013-05-02','13:35:00',4.03),('15128','2013-05-02','13:40:00',4.05),('15128','2013-05-02','13:45:00',4.07),('15128','2013-05-02','13:50:00',4.03),('15128','2013-05-02','13:55:00',3.9),('15128','2013-05-02','14:00:00',3.9),('15128','2013-05-02','14:05:00',3.98),('15128','2013-05-02','14:10:00',3.92),('15128','2013-05-02','14:15:00',4.06),('15128','2013-05-02','14:20:00',4.06),('15128','2013-05-02','14:25:00',4.03),('15128','2013-05-02','14:30:00',4.05),('15128','2013-05-02','14:35:00',4.07),('15128','2013-05-02','14:40:00',4.04),('15128','2013-05-02','14:45:00',4.02),('15128','2013-05-02','14:50:00',3.97),('15128','2013-05-02','14:55:00',3.95),('15128','2013-05-02','15:00:00',3.9),('15128','2013-05-02','15:05:00',3.89),('15128','2013-05-02','15:10:00',3.89),('15128','2013-05-02','15:15:00',3.83),('15128','2013-05-02','15:20:00',3.79),('15128','2013-05-02','15:25:00',3.77),('15128','2013-05-02','15:30:00',3.71),('15128','2013-05-02','15:35:00',3.64),('15128','2013-05-02','15:40:00',3.62),('15128','2013-05-02','15:45:00',3.6),('15128','2013-05-02','15:50:00',3.57),('15128','2013-05-02','15:55:00',3.54),('15128','2013-05-02','16:00:00',3.5),('15128','2013-05-02','16:05:00',3.46),('15128','2013-05-02','16:10:00',3.41),('15128','2013-05-02','16:15:00',3.35),('15128','2013-05-02','16:20:00',3.3),('15128','2013-05-02','16:25:00',3.24),('15128','2013-05-02','16:30:00',3.19),('15128','2013-05-02','16:35:00',3.11),('15128','2013-05-02','16:40:00',3.04),('15128','2013-05-02','16:45:00',2.98),('15128','2013-05-02','16:50:00',2.93),('15128','2013-05-02','16:55:00',2.85),('15128','2013-05-02','17:00:00',2.79),('15128','2013-05-02','17:05:00',2.71),('15128','2013-05-02','17:10:00',2.64),('15128','2013-05-02','17:15:00',2.56),('15128','2013-05-02','17:20:00',2.48),('15128','2013-05-02','17:25:00',2.42),('15128','2013-05-02','17:30:00',2.35),('15128','2013-05-02','17:35:00',2.25),('15128','2013-05-02','17:40:00',2.14),('15128','2013-05-02','17:45:00',2),('15128','2013-05-02','17:50:00',1.92),('15128','2013-05-02','17:55:00',1.86),('15128','2013-05-02','18:00:00',1.77),('15128','2013-05-02','18:05:00',1.64),('15128','2013-05-02','18:10:00',1.56),('15128','2013-05-02','18:15:00',1.5),('15128','2013-05-02','18:20:00',1.44),('15128','2013-05-02','18:25:00',1.38),('15128','2013-05-02','18:30:00',1.31),('15128','2013-05-02','18:35:00',1.23),('15128','2013-05-02','18:40:00',1.11),('15128','2013-05-02','18:45:00',1.02),('15128','2013-05-01','08:50:00',1.4),('15128','2013-05-01','08:55:00',1.13),('15128','2013-05-01','09:00:00',1.17),('15128','2013-05-01','09:30:00',2.51),('15128','2013-05-01','09:35:00',1.76),('15128','2013-05-01','09:40:00',1.16),('15128','2013-05-01','09:45:00',1.1),('15128','2013-05-01','09:50:00',1.88),('15128','2013-05-01','09:55:00',1.44),('15128','2013-05-01','10:15:00',1.35),('15128','2013-05-01','10:20:00',2.17),('15128','2013-05-01','10:25:00',1.62),('15128','2013-05-01','10:30:00',1.63),('15128','2013-05-01','10:35:00',3.23),('15128','2013-05-01','10:40:00',3.5),('15128','2013-05-01','10:45:00',2.83),('15128','2013-05-01','10:50:00',2.64),('15128','2013-05-01','10:55:00',2.5),('15128','2013-05-01','11:00:00',3.38),('15128','2013-05-01','11:05:00',3.24),('15128','2013-05-01','11:10:00',2.15),('15128','2013-05-01','11:15:00',2.81),('15128','2013-05-01','11:20:00',3.07),('15128','2013-05-01','11:25:00',3.26),('15128','2013-05-01','11:30:00',2.82),('15128','2013-05-01','11:35:00',3.73),('15128','2013-05-01','11:40:00',3.69),('15128','2013-05-01','11:45:00',3.52),('15128','2013-05-01','11:50:00',3.54),('15128','2013-05-01','11:55:00',3.57),('15128','2013-05-01','12:00:00',3.63),('15128','2013-05-01','12:05:00',3.68),('15128','2013-05-01','12:10:00',3.67),('15128','2013-05-01','12:15:00',3.7),('15128','2013-05-01','12:20:00',3.74),('15128','2013-05-01','12:25:00',3.73),('15128','2013-05-01','12:30:00',3.77),('15128','2013-05-01','12:35:00',3.8),('15128','2013-05-01','12:40:00',2.99),('15128','2013-05-01','12:45:00',3.27),('15128','2013-05-01','12:50:00',4.03),('15128','2013-05-01','12:55:00',3.9),('15128','2013-05-01','13:00:00',3.91),('15128','2013-05-01','13:05:00',4.05),('15128','2013-05-01','13:10:00',4.04),('15128','2013-05-01','13:15:00',4.04),('15128','2013-05-01','13:20:00',4.03),('15128','2013-05-01','13:25:00',4.03),('15128','2013-05-01','13:30:00',4.05),('15128','2013-05-01','13:35:00',4.03),('15128','2013-05-01','13:40:00',4.01),('15128','2013-05-01','13:45:00',4),('15128','2013-05-01','13:50:00',4.01),('15128','2013-05-01','13:55:00',4.01),('15128','2013-05-01','14:00:00',4),('15128','2013-05-01','14:05:00',4.02),('15128','2013-05-01','14:10:00',3.99),('15128','2013-05-01','14:15:00',4.01),('15128','2013-05-01','14:20:00',4.04),('15128','2013-05-01','14:25:00',4.03),('15128','2013-05-01','14:30:00',3.98),('15128','2013-05-01','14:35:00',3.94),('15128','2013-05-01','14:40:00',3.93),('15128','2013-05-01','14:45:00',3.92),('15128','2013-05-01','14:50:00',3.9),('15128','2013-05-01','14:55:00',3.92),('15128','2013-05-01','15:00:00',3.89),('15128','2013-05-01','15:05:00',3.85),('15128','2013-05-01','15:10:00',3.8),('15128','2013-05-01','15:15:00',3.79),('15128','2013-05-01','15:20:00',3.77),('15128','2013-05-01','15:25:00',3.75),('15128','2013-05-01','15:30:00',3.73),('15128','2013-05-01','15:35:00',3.73),('15128','2013-05-01','15:40:00',3.69),('15128','2013-05-01','15:45:00',3.66),('15128','2013-05-01','15:50:00',3.6),('15128','2013-05-01','15:55:00',3.56),('15128','2013-05-01','16:00:00',3.51),('15128','2013-05-01','16:05:00',3.48),('15128','2013-05-01','16:10:00',3.42),('15128','2013-05-01','16:15:00',3.35),('15128','2013-05-01','16:20:00',3.32),('15128','2013-05-01','16:25:00',3.27),('15128','2013-05-01','16:30:00',3.22),('15128','2013-05-01','16:35:00',3.15),('15128','2013-05-01','16:40:00',3.1),('15128','2013-05-01','16:45:00',3.04),('15128','2013-05-01','16:50:00',2.97),('15128','2013-05-01','16:55:00',2.89),('15128','2013-05-01','17:00:00',2.82),('15128','2013-05-01','17:05:00',2.76),('15128','2013-05-01','17:10:00',2.68),('15128','2013-05-01','17:15:00',2.61),('15128','2013-05-01','17:20:00',2.55),('15128','2013-05-01','17:25:00',2.46),('15128','2013-05-01','17:30:00',2.38),('15128','2013-05-01','17:35:00',2.3),('15128','2013-05-01','17:40:00',2.21),('15128','2013-05-01','17:45:00',2.11),('15128','2013-05-01','17:50:00',2.03),('15128','2013-05-01','17:55:00',1.95),('15128','2013-05-01','18:00:00',1.84),('15128','2013-05-01','18:05:00',1.75),('15128','2013-05-01','18:10:00',1.68),('15128','2013-05-01','18:15:00',1.61),('15128','2013-05-01','18:20:00',1.56),('15128','2013-05-01','18:25:00',1.48),('15128','2013-05-01','18:30:00',1.39),('15128','2013-05-01','18:35:00',1.3),('15128','2013-05-01','18:40:00',1.2),('15128','2013-05-01','18:45:00',1.1),('15128','2014-03-29','09:15:00',1.14),('15128','2014-03-29','09:20:00',1.35),('15128','2014-03-29','09:25:00',1.41),('15128','2014-03-29','09:30:00',1.45),('15128','2014-03-29','09:35:00',1.55),('15128','2014-03-29','09:40:00',1.64),('15128','2014-03-29','09:45:00',1.72),('15128','2014-03-29','09:50:00',1.7),('15128','2014-03-29','09:55:00',1.74),('15128','2014-03-29','10:00:00',1.84),('15128','2014-03-29','10:05:00',1.92),('15128','2014-03-29','10:10:00',2),('15128','2014-03-29','10:15:00',2.1),('15128','2014-03-29','10:20:00',2.18),('15128','2014-03-29','10:25:00',2.23),('15128','2014-03-29','10:30:00',2.28),('15128','2014-03-29','10:35:00',2.3),('15128','2014-03-29','10:40:00',2.31),('15128','2014-03-29','10:45:00',2.36),('15128','2014-03-29','10:50:00',2.38),('15128','2014-03-29','10:55:00',2.47),('15128','2014-03-29','11:00:00',2.49),('15128','2014-03-29','11:05:00',2.52),('15128','2014-03-29','11:10:00',2.68),('15128','2014-03-29','11:15:00',2.7),('15128','2014-03-29','11:20:00',2.64),('15128','2014-03-29','11:25:00',2.63),('15128','2014-03-29','11:30:00',2.67),('15128','2014-03-29','11:35:00',2.83),('15128','2014-03-29','11:40:00',2.96),('15128','2014-03-29','11:45:00',3.04),('15128','2014-03-29','11:50:00',3.2),('15128','2014-03-29','11:55:00',3.2),('15128','2014-03-29','12:00:00',3.35),('15128','2014-03-29','12:05:00',3.38),('15128','2014-03-29','12:10:00',3.39),('15128','2014-03-29','12:15:00',3.5),('15128','2014-03-29','12:20:00',3.57),('15128','2014-03-29','12:25:00',3.65),('15128','2014-03-29','12:30:00',3.51),('15128','2014-03-29','12:35:00',3.67),('15128','2014-03-29','12:40:00',3.78),('15128','2014-03-29','12:45:00',3.83),('15128','2014-03-29','12:50:00',3.86),('15128','2014-03-29','12:55:00',3.85),('15128','2014-03-29','13:00:00',3.85),('15128','2014-03-29','13:05:00',3.87),('15128','2014-03-29','13:10:00',3.81),('15128','2014-03-29','13:15:00',3.79),('15128','2014-03-29','13:20:00',3.84),('15128','2014-03-29','13:25:00',3.95),('15128','2014-03-29','13:30:00',3.99),('15128','2014-03-29','13:35:00',4.03),('15128','2014-03-29','13:40:00',4.02),('15128','2014-03-29','13:45:00',4.04),('15128','2014-03-29','13:50:00',4.04),('15128','2014-03-29','13:55:00',4.08),('15128','2014-03-29','14:00:00',4.08),('15128','2014-03-29','14:05:00',4.05),('15128','2014-03-29','14:10:00',4.11),('15128','2014-03-29','14:15:00',3.62),('15128','2014-03-29','14:20:00',3.38),('15128','2014-03-29','14:25:00',3.08),('15128','2014-03-29','14:30:00',3.08),('15128','2014-03-29','14:35:00',2.87),('15128','2014-03-29','14:40:00',2.01),('15128','2014-03-29','14:45:00',1.99),('15128','2014-03-29','14:50:00',2.03),('15128','2014-03-29','14:55:00',2.1),('15128','2014-03-29','15:00:00',2.47),('15128','2014-03-29','15:05:00',2.94),('15128','2014-03-29','15:10:00',3.09),('15128','2014-03-29','15:15:00',3.12),('15128','2014-03-29','15:20:00',2.89),('15128','2014-03-29','15:25:00',2.95),('15128','2014-03-29','15:30:00',2.96),('15128','2014-03-29','15:35:00',3.05),('15128','2014-03-29','15:40:00',3.03),('15128','2014-03-29','15:45:00',3.09),('15128','2014-03-29','15:50:00',3.13),('15128','2014-03-29','15:55:00',3.18),('15128','2014-03-29','16:00:00',3.3),('15128','2014-03-29','16:05:00',3.28),('15128','2014-03-29','16:10:00',3.32),('15128','2014-03-29','16:15:00',3.34),('15128','2014-03-29','16:20:00',3.18),('15128','2014-03-29','16:25:00',2.89),('15128','2014-03-29','16:30:00',2.8),('15128','2014-03-29','16:35:00',2.75),('15128','2014-03-29','16:40:00',2.73),('15128','2014-03-29','16:45:00',2.89),('15128','2014-03-29','16:50:00',2.88),('15128','2014-03-29','16:55:00',2.76),('15128','2014-03-29','17:00:00',2.64),('15128','2014-03-29','17:05:00',2.47),('15128','2014-03-29','17:10:00',2.32),('15128','2014-03-29','17:15:00',2.26),('15128','2014-03-29','17:20:00',2.19),('15128','2014-03-29','17:25:00',2.09),('15128','2014-03-29','17:30:00',1.99),('15128','2014-03-29','17:35:00',1.89),('15128','2014-03-29','17:40:00',1.82),('15128','2014-03-29','17:45:00',1.79),('15128','2014-03-29','17:50:00',1.65),('15128','2014-03-29','17:55:00',1.6),('15128','2014-03-29','18:00:00',1.55),('15128','2014-03-29','18:05:00',1.17),('15128','2014-03-29','18:10:00',1.3),('15128','2014-03-29','18:15:00',1.15),('15128','2014-03-29','18:20:00',1.14),('15128','2014-03-29','18:25:00',1.06),('15128','2013-04-30','08:20:00',1.01),('15128','2013-04-30','08:25:00',1.07),('15128','2013-04-30','08:30:00',1.14),('15128','2013-04-30','08:35:00',1.2),('15128','2013-04-30','08:40:00',1.26),('15128','2013-04-30','08:45:00',1.33),('15128','2013-04-30','08:50:00',1.38),('15128','2013-04-30','08:55:00',1.47),('15128','2013-04-30','09:00:00',1.55),('15128','2013-04-30','09:05:00',1.61),('15128','2013-04-30','09:10:00',1.67),('15128','2013-04-30','09:15:00',1.72),('15128','2013-04-30','09:20:00',1.8),('15128','2013-04-30','09:25:00',1.83),('15128','2013-04-30','09:30:00',1.87),('15128','2013-04-30','09:35:00',1.92),('15128','2013-04-30','09:40:00',1.97),('15128','2013-04-30','09:45:00',2.02),('15128','2013-04-30','09:50:00',2.09),('15128','2013-04-30','09:55:00',2.14),('15128','2013-04-30','10:00:00',2.22),('15128','2013-04-30','10:05:00',2.28),('15128','2013-04-30','10:10:00',2.37),('15128','2013-04-30','10:15:00',2.44),('15128','2013-04-30','10:20:00',2.5),('15128','2013-04-30','10:25:00',2.53),('15128','2013-04-30','10:30:00',2.62),('15128','2013-04-30','10:35:00',2.69),('15128','2013-04-30','10:40:00',2.79),('15128','2013-04-30','10:45:00',2.86),('15128','2013-04-30','10:50:00',2.92),('15128','2013-04-30','10:55:00',3.02),('15128','2013-04-30','11:00:00',3.02),('15128','2013-04-30','11:05:00',3.07),('15128','2013-04-30','11:10:00',3.21),('15128','2013-04-30','11:15:00',3.28),('15128','2013-04-30','11:20:00',3.25),('15128','2013-04-30','11:25:00',3.43),('15128','2013-04-30','11:30:00',3.3),('15128','2013-04-30','11:35:00',3.37),('15128','2013-04-30','11:40:00',2.83),('15128','2013-04-30','11:45:00',3.52),('15128','2013-04-30','11:50:00',3.71),('15128','2013-04-30','11:55:00',3.74),('15128','2013-04-30','12:00:00',3.73),('15128','2013-04-30','12:05:00',3.74),('15128','2013-04-30','12:10:00',3.76),('15128','2013-04-30','12:15:00',3.77),('15128','2013-04-30','12:20:00',3.81),('15128','2013-04-30','12:25:00',3.83),('15128','2013-04-30','12:30:00',3.89),('15128','2013-04-30','12:35:00',3.98),('15128','2013-04-30','12:40:00',4.12),('15128','2013-04-30','12:45:00',2.79),('15128','2013-04-30','12:50:00',1.7),('15128','2013-04-30','12:55:00',1.49),('15128','2013-04-30','13:00:00',1.54),('15128','2013-04-30','13:05:00',1.62),('15128','2013-04-30','13:10:00',1.94),('15128','2013-04-30','13:15:00',3.25),('15128','2013-04-30','13:20:00',4.6),('15128','2013-04-30','13:25:00',4.93),('15128','2013-04-30','13:30:00',4.64),('15128','2013-04-30','13:35:00',3.82),('15128','2013-04-30','13:40:00',3.24),('15128','2013-04-30','13:45:00',4.44),('15128','2013-04-30','13:50:00',4.4),('15128','2013-04-30','13:55:00',4.21),('15128','2013-04-30','14:00:00',4.18),('15128','2013-04-30','14:05:00',4.3),('15128','2013-04-30','14:10:00',4.03),('15128','2013-04-30','14:15:00',4.28),('15128','2013-04-30','14:20:00',3.95),('15128','2013-04-30','14:25:00',4.36),('15128','2013-04-30','14:30:00',4.23),('15128','2013-04-30','14:35:00',4.3),('15128','2013-04-30','14:40:00',3.68),('15128','2013-04-30','14:45:00',2.98),('15128','2013-04-30','14:50:00',3.27),('15128','2013-04-30','14:55:00',3.25),('15128','2013-04-30','15:00:00',2.86),('15128','2013-04-30','15:05:00',2.84),('15128','2013-04-30','15:10:00',4.01),('15128','2013-04-30','15:15:00',3.39),('15128','2013-04-30','15:20:00',3.12),('15128','2013-04-30','15:25:00',2.97),('15128','2013-04-30','15:30:00',2.63),('15128','2013-04-30','15:35:00',2.51),('15128','2013-04-30','15:40:00',2.38),('15128','2013-04-30','15:45:00',2.2),('15128','2013-04-30','15:50:00',1.92),('15128','2013-04-30','15:55:00',1.92),('15128','2013-04-30','16:00:00',2.14),('15128','2013-04-30','16:05:00',2.35),('15128','2013-04-30','16:10:00',2.14),('15128','2013-04-30','16:15:00',2.08),('15128','2013-04-30','16:20:00',1.96),('15128','2013-04-30','16:25:00',1.55),('15128','2013-04-30','16:30:00',1.27),('15128','2013-04-30','16:35:00',1.24),('15128','2013-04-30','16:40:00',1.29),('15128','2013-04-30','16:45:00',1.22),('15128','2013-04-30','16:50:00',1.09),('15128','2013-04-29','08:40:00',1.03),('15128','2013-04-29','08:45:00',1.02),('15128','2013-04-29','08:50:00',1.32),('15128','2013-04-29','08:55:00',1.73),('15128','2013-04-29','09:00:00',1.81),('15128','2013-04-29','09:05:00',1.57),('15128','2013-04-29','09:10:00',1.55),('15128','2013-04-29','09:15:00',2.07),('15128','2013-04-29','09:20:00',2.29),('15128','2013-04-29','09:25:00',1.73),('15128','2013-04-29','09:30:00',1.86),('15128','2013-04-29','09:35:00',1.99),('15128','2013-04-29','09:40:00',1.83),('15128','2013-04-29','09:45:00',1.94),('15128','2013-04-29','09:50:00',2.15),('15128','2013-04-29','09:55:00',2.52),('15128','2013-04-29','10:00:00',2.8),('15128','2013-04-29','10:05:00',2.54),('15128','2013-04-29','10:10:00',2.66),('15128','2013-04-29','10:15:00',2),('15128','2013-04-29','10:20:00',2.17),('15128','2013-04-29','10:25:00',1.86),('15128','2013-04-29','10:30:00',2.04),('15128','2013-04-29','10:35:00',1.71),('15128','2013-04-29','10:40:00',1.62),('15128','2013-04-29','10:45:00',1.96),('15128','2013-04-29','10:50:00',1.73),('15128','2013-04-29','10:55:00',1.77),('15128','2013-04-29','11:00:00',2.21),('15128','2013-04-29','11:05:00',2.33),('15128','2013-04-29','11:10:00',2.34),('15128','2013-04-29','11:15:00',2.28),('15128','2013-04-29','11:20:00',2.24),('15128','2013-04-29','11:25:00',2.16),('15128','2013-04-29','11:30:00',2.13),('15128','2013-04-29','11:35:00',2.22),('15128','2013-04-29','11:40:00',2.3),('15128','2013-04-29','11:45:00',1.67),('15128','2013-04-29','11:50:00',1.48),('15128','2013-04-29','11:55:00',1.57),('15128','2013-04-29','12:00:00',2.03),('15128','2013-04-29','12:05:00',2.16),('15128','2013-04-29','12:10:00',1.92),('15128','2013-04-29','12:15:00',2.7),('15128','2013-04-29','12:20:00',2.94),('15128','2013-04-29','12:25:00',1.97),('15128','2013-04-29','12:30:00',1.57),('15128','2013-04-29','12:35:00',2.69),('15128','2013-04-29','12:40:00',4.44),('15128','2013-04-29','12:45:00',4.44),('15128','2013-04-29','12:50:00',3.56),('15128','2013-04-29','12:55:00',3.78),('15128','2013-04-29','13:00:00',4.07),('15128','2013-04-29','13:05:00',4.16),('15128','2013-04-29','13:10:00',4.1),('15128','2013-04-29','13:15:00',4.03),('15128','2013-04-29','13:20:00',4.01),('15128','2013-04-29','13:25:00',4.02),('15128','2013-04-29','13:30:00',4),('15128','2013-04-29','13:35:00',3.98),('15128','2013-04-29','13:40:00',3.98),('15128','2013-04-29','13:45:00',3.94),('15128','2013-04-29','13:50:00',3.94),('15128','2013-04-29','13:55:00',3.96),('15128','2013-04-29','14:00:00',3.99),('15128','2013-04-29','14:05:00',3.96),('15128','2013-04-29','14:10:00',3.93),('15128','2013-04-29','14:15:00',3.9),('15128','2013-04-29','14:20:00',3.89),('15128','2013-04-29','14:25:00',3.87),('15128','2013-04-29','14:30:00',3.84),('15128','2013-04-29','14:35:00',3.81),('15128','2013-04-29','14:40:00',3.78),('15128','2013-04-29','14:45:00',3.76),('15128','2013-04-29','14:50:00',3.74),('15128','2013-04-29','14:55:00',3.71),('15128','2013-04-29','15:00:00',3.68),('15128','2013-04-29','15:05:00',3.64),('15128','2013-04-29','15:10:00',3.65),('15128','2013-04-29','15:15:00',3.66),('15128','2013-04-29','15:20:00',3.64),('15128','2013-04-29','15:25:00',3.61),('15128','2013-04-29','15:30:00',3.58),('15128','2013-04-29','15:35:00',3.55),('15128','2013-04-29','15:40:00',3.51),('15128','2013-04-29','15:45:00',3.46),('15128','2013-04-29','15:50:00',3.44),('15128','2013-04-29','15:55:00',3.39),('15128','2013-04-29','16:00:00',3.33),('15128','2013-04-29','16:05:00',3.27),('15128','2013-04-29','16:10:00',3.22),('15128','2013-04-29','16:15:00',3.15),('15128','2013-04-29','16:20:00',3.07),('15128','2013-04-29','16:25:00',3.02),('15128','2013-04-29','16:30:00',2.96),('15128','2013-04-29','16:35:00',2.83),('15128','2013-04-29','16:40:00',2.5),('15128','2013-04-29','16:45:00',1.66),('15128','2013-04-29','16:50:00',1.39),('15128','2013-04-29','16:55:00',1.85),('15128','2013-04-29','17:00:00',2.02),('15128','2013-04-29','17:05:00',1.76),('15128','2013-04-29','17:10:00',1.16),('15128','2013-04-29','17:15:00',1.46),('15128','2013-04-29','17:20:00',1.55),('15128','2013-04-29','17:25:00',1.85),('15128','2013-04-29','17:30:00',1.97),('15128','2013-04-29','17:35:00',1.91),('15128','2013-04-29','17:40:00',1.84),('15128','2013-04-29','17:45:00',1.75),('15128','2013-04-29','17:50:00',1.65),('15128','2013-04-29','17:55:00',1.56),('15128','2013-04-29','18:00:00',1.49),('15128','2013-04-29','18:05:00',1.38),('15128','2013-04-29','18:10:00',1.31),('15128','2013-04-29','18:15:00',1.26),('15128','2013-04-29','18:20:00',1.19),('15128','2013-04-29','18:25:00',1.09),('15128','2013-04-29','18:30:00',1.01),('15128','2013-04-28','08:15:00',1.03),('15128','2013-04-28','08:20:00',1.22),('15128','2013-04-28','08:25:00',1.35),('15128','2013-04-28','08:30:00',1.54),('15128','2013-04-28','08:35:00',1.64),('15128','2013-04-28','08:40:00',1.51),('15128','2013-04-28','08:45:00',1.53),('15128','2013-04-28','08:50:00',1.56),('15128','2013-04-28','08:55:00',1.58),('15128','2013-04-28','09:00:00',1.62),('15128','2013-04-28','09:05:00',1.78),('15128','2013-04-28','09:10:00',1.54),('15128','2013-04-28','09:15:00',1.57),('15128','2013-04-28','09:20:00',1.77),('15128','2013-04-28','09:25:00',1.82),('15128','2013-04-28','09:30:00',1.86),('15128','2013-04-28','09:35:00',1.83),('15128','2013-04-28','09:40:00',1.95),('15128','2013-04-28','09:45:00',2.02),('15128','2013-04-28','09:50:00',1.94),('15128','2013-04-28','09:55:00',2.05),('15128','2013-04-28','10:00:00',2.25),('15128','2013-04-28','10:05:00',2.34),('15128','2013-04-28','10:10:00',2.14),('15128','2013-04-28','10:15:00',2.06),('15128','2013-04-28','10:20:00',2.57),('15128','2013-04-28','10:25:00',2.79),('15128','2013-04-28','10:30:00',2.82),('15128','2013-04-28','10:35:00',2.45),('15128','2013-04-28','10:40:00',2.49),('15128','2013-04-28','10:45:00',2.58),('15128','2013-04-28','10:50:00',2.84),('15128','2013-04-28','10:55:00',2.79),('15128','2013-04-28','11:00:00',2.63),('15128','2013-04-28','11:05:00',2.93),('15128','2013-04-28','11:10:00',3.1),('15128','2013-04-28','11:15:00',3.17),('15128','2013-04-28','11:20:00',3.45),('15128','2013-04-28','11:25:00',3.12),('15128','2013-04-28','11:30:00',3.01),('15128','2013-04-28','11:35:00',3.09),('15128','2013-04-28','11:40:00',3.05),('15128','2013-04-28','11:45:00',3.63),('15128','2013-04-28','11:50:00',3.37),('15128','2013-04-28','11:55:00',3.79),('15128','2013-04-28','12:00:00',3.76),('15128','2013-04-28','12:05:00',3.77),('15128','2013-04-28','12:10:00',3.82),('15128','2013-04-28','12:15:00',3.89),('15128','2013-04-28','12:20:00',3.95),('15128','2013-04-28','12:25:00',3.93),('15128','2013-04-28','12:30:00',3.94),('15128','2013-04-28','12:35:00',3.94),('15128','2013-04-28','12:40:00',3.98),('15128','2013-04-28','12:45:00',3.85),('15128','2013-04-28','12:50:00',3.7),('15128','2013-04-28','12:55:00',3.78),('15128','2013-04-28','13:00:00',3.77),('15128','2013-04-28','13:05:00',3.67),('15128','2013-04-28','13:10:00',3.77),('15128','2013-04-28','13:15:00',3.41),('15128','2013-04-28','13:20:00',4.13),('15128','2013-04-28','13:25:00',4.05),('15128','2013-04-28','13:30:00',4.05),('15128','2013-04-28','13:35:00',4.08),('15128','2013-04-28','13:40:00',4.05),('15128','2013-04-28','13:45:00',3.81),('15128','2013-04-28','13:50:00',3.83),('15128','2013-04-28','13:55:00',3.99),('15128','2013-04-28','14:00:00',3.94),('15128','2013-04-28','14:05:00',3.97),('15128','2013-04-28','14:10:00',4.06),('15128','2013-04-28','14:15:00',4.15),('15128','2013-04-28','14:20:00',4.05),('15128','2013-04-28','14:25:00',3.95),('15128','2013-04-28','14:30:00',3.68),('15128','2013-04-28','14:35:00',3.41),('15128','2013-04-28','14:40:00',3.42),('15128','2013-04-28','14:45:00',3.56),('15128','2013-04-28','14:50:00',3.39),('15128','2013-04-28','14:55:00',3.41),('15128','2013-04-28','15:00:00',3.14),('15128','2013-04-28','15:05:00',2.95),('15128','2013-04-28','15:10:00',3.64),('15128','2013-04-28','15:15:00',3.85),('15128','2013-04-28','15:20:00',3.82),('15128','2013-04-28','15:25:00',3.57),('15128','2013-04-28','15:30:00',3.19),('15128','2013-04-28','15:35:00',3.1),('15128','2013-04-28','15:40:00',3.04),('15128','2013-04-28','15:45:00',2.88),('15128','2013-04-28','15:50:00',2.94),('15128','2013-04-28','15:55:00',3.21),('15128','2013-04-28','16:00:00',3.19),('15128','2013-04-28','16:05:00',3.54),('15128','2013-04-28','16:10:00',3.5),('15128','2013-04-28','16:15:00',3.46),('15128','2013-04-28','16:20:00',2.82),('15128','2013-04-28','16:25:00',3.02),('15128','2013-04-28','16:30:00',2.96),('15128','2013-04-28','16:35:00',3.27),('15128','2013-04-28','16:40:00',3.16),('15128','2013-04-28','16:45:00',3.27),('15128','2013-04-28','16:50:00',3.31),('15128','2013-04-28','16:55:00',3.27),('15128','2013-04-28','17:00:00',3.12),('15128','2013-04-28','17:05:00',3.02),('15128','2013-04-28','17:10:00',2.69),('15128','2013-04-28','17:15:00',2.39),('15128','2013-04-28','17:20:00',2.44),('15128','2013-04-28','17:25:00',2.29),('15128','2013-04-28','17:30:00',2.21),('15128','2013-04-28','17:35:00',2.32),('15128','2013-04-28','17:40:00',1.68),('15128','2013-04-28','17:45:00',1.43),('15128','2013-04-28','17:50:00',1.77),('15128','2013-04-28','17:55:00',2.1),('15128','2013-04-28','18:00:00',1.91),('15128','2013-04-28','18:05:00',2.25),('15128','2013-04-28','18:10:00',1.97),('15128','2013-04-28','18:15:00',1.9),('15128','2013-04-28','18:20:00',1.84),('15128','2013-04-28','18:25:00',1.78),('15128','2013-04-28','18:30:00',1.44),('15128','2013-04-28','18:35:00',1.29),('15128','2013-04-28','18:40:00',1.03),('15128','2013-04-27','08:20:00',1.06),('15128','2013-04-27','08:25:00',1.16),('15128','2013-04-27','08:30:00',1.21),('15128','2013-04-27','08:35:00',1.26),('15128','2013-04-27','08:40:00',1.29),('15128','2013-04-27','08:45:00',1.41),('15128','2013-04-27','08:50:00',1.5),('15128','2013-04-27','08:55:00',1.58),('15128','2013-04-27','09:00:00',1.66),('15128','2013-04-27','09:05:00',1.72),('15128','2013-04-27','09:10:00',1.79),('15128','2013-04-27','09:15:00',1.82),('15128','2013-04-27','09:20:00',1.86),('15128','2013-04-27','09:25:00',2.02),('15128','2013-04-27','09:30:00',2.12),('15128','2013-04-27','09:35:00',2.16),('15128','2013-04-27','09:40:00',2.1),('15128','2013-04-27','09:45:00',2.13),('15128','2013-04-27','09:50:00',2.22),('15128','2013-04-27','09:55:00',2.34),('15128','2013-04-27','10:00:00',2.35),('15128','2013-04-27','10:05:00',2.41),('15128','2013-04-27','10:10:00',2.43),('15128','2013-04-27','10:15:00',2.5),('15128','2013-04-27','10:20:00',2.59),('15128','2013-04-27','10:25:00',2.68),('15128','2013-04-27','10:30:00',2.59),('15128','2013-04-27','10:35:00',2.66),('15128','2013-04-27','10:40:00',2.65),('15128','2013-04-27','10:45:00',2.78),('15128','2013-04-27','10:50:00',2.88),('15128','2013-04-27','10:55:00',3.03),('15128','2013-04-27','11:00:00',3.14),('15128','2013-04-27','11:05:00',3.06),('15128','2013-04-27','11:10:00',3.19),('15128','2013-04-27','11:15:00',3.33),('15128','2013-04-27','11:20:00',3.33),('15128','2013-04-27','11:25:00',3.41),('15128','2013-04-27','11:30:00',3.48),('15128','2013-04-27','11:35:00',3.46),('15128','2013-04-27','11:40:00',3.51),('15128','2013-04-27','11:45:00',3.49),('15128','2013-04-27','11:50:00',3.59),('15128','2013-04-27','11:55:00',3.25),('15128','2013-04-27','12:00:00',3.15),('15128','2013-04-27','12:05:00',3.23),('15128','2013-04-27','12:10:00',3.67),('15128','2013-04-27','12:15:00',3.49),('15128','2013-04-27','12:20:00',3.66),('15128','2013-04-27','12:25:00',3.89),('15128','2013-04-27','12:30:00',3.63),('15128','2013-04-27','12:35:00',3.58),('15128','2013-04-27','12:40:00',2.84),('15128','2013-04-27','12:45:00',3),('15128','2013-04-27','12:50:00',4.14),('15128','2013-04-27','12:55:00',4.01),('15128','2013-04-27','13:00:00',4.09),('15128','2013-04-27','13:05:00',4.25),('15128','2013-04-27','13:10:00',4.11),('15128','2013-04-27','13:15:00',3.86),('15128','2013-04-27','13:20:00',4.23),('15128','2013-04-27','13:25:00',3.88),('15128','2013-04-27','13:30:00',3.96),('15128','2013-04-27','13:35:00',4.2),('15128','2013-04-27','13:40:00',4.37),('15128','2013-04-27','13:45:00',3.96),('15128','2013-04-27','13:50:00',4.22),('15128','2013-04-27','13:55:00',4.21),('15128','2013-04-27','14:00:00',4.24),('15128','2013-04-27','14:05:00',3.97),('15128','2013-04-27','14:10:00',4.02),('15128','2013-04-27','14:15:00',4.33),('15128','2013-04-27','14:20:00',3.65),('15128','2013-04-27','14:25:00',3.96),('15128','2013-04-27','14:30:00',4.09),('15128','2013-04-27','14:35:00',4.26),('15128','2013-04-27','14:40:00',4.15),('15128','2013-04-27','14:45:00',3.31),('15128','2013-04-27','14:50:00',4.11),('15128','2013-04-27','14:55:00',3.77),('15128','2013-04-27','15:00:00',2.34),('15128','2013-04-27','15:05:00',3.83),('15128','2013-04-27','15:10:00',3.23),('15128','2013-04-27','15:15:00',3.32),('15128','2013-04-27','15:20:00',3.78),('15128','2013-04-27','15:25:00',3.59),('15128','2013-04-27','15:30:00',3.85),('15128','2013-04-27','15:35:00',3.8),('15128','2013-04-27','15:40:00',3.75),('15128','2013-04-27','15:45:00',3.71),('15128','2013-04-27','15:50:00',3.64),('15128','2013-04-27','15:55:00',3.56),('15128','2013-04-27','16:00:00',3.53),('15128','2013-04-27','16:05:00',3.48),('15128','2013-04-27','16:10:00',3.45),('15128','2013-04-27','16:15:00',3.41),('15128','2013-04-27','16:20:00',3.34),('15128','2013-04-27','16:25:00',3.3),('15128','2013-04-27','16:30:00',3.25),('15128','2013-04-27','16:35:00',3.21),('15128','2013-04-27','16:40:00',3.15),('15128','2013-04-27','16:45:00',3.04),('15128','2013-04-27','16:50:00',2.97),('15128','2013-04-27','16:55:00',2.93),('15128','2013-04-27','17:00:00',2.73),('15128','2013-04-27','17:05:00',2.66),('15128','2013-04-27','17:10:00',2.65),('15128','2013-04-27','17:15:00',2.55),('15128','2013-04-27','17:20:00',2.63),('15128','2013-04-27','17:25:00',2.56),('15128','2013-04-27','17:30:00',2.17),('15128','2013-04-27','17:35:00',2.13),('15128','2013-04-27','17:40:00',2.12),('15128','2013-04-27','17:45:00',2.05),('15128','2013-04-27','17:50:00',1.91),('15128','2013-04-27','17:55:00',1.7),('15128','2013-04-27','18:00:00',1.65),('15128','2013-04-27','18:05:00',1.64),('15128','2013-04-27','18:15:00',1.56),('15128','2013-04-27','18:20:00',1.54),('15128','2013-04-27','18:25:00',1.41),('15128','2013-04-27','18:30:00',1.02),('15128','2013-04-27','18:35:00',1.05),('15128','2013-04-27','18:40:00',1.06),('15128','2013-04-26','12:40:00',1.03),('15128','2013-04-26','12:45:00',1.1),('15128','2013-04-26','12:50:00',1.26),('15128','2013-04-26','12:55:00',1.43),('15128','2013-04-26','13:00:00',1.39),('15128','2013-04-26','13:05:00',1.27),('15128','2013-04-26','13:10:00',1.29),('15128','2013-04-26','13:15:00',1.9),('15128','2013-04-26','13:20:00',2.48),('15128','2013-04-26','13:25:00',1.63),('15128','2013-04-26','13:30:00',1.08),('15128','2013-04-26','14:30:00',1.21),('15128','2013-04-26','14:35:00',1.15),('15128','2013-04-26','14:40:00',1.58),('15128','2013-04-26','14:45:00',1.01),('15128','2013-04-26','16:55:00',1.14),('15128','2013-04-26','17:00:00',2.3),('15128','2013-04-26','17:05:00',1.32),('15128','2013-04-26','17:10:00',1.88),('15128','2013-04-26','17:15:00',1.3),('15128','2013-04-26','17:20:00',1.2),('15128','2013-04-26','17:40:00',2.59),('15128','2013-04-26','17:45:00',1.95),('15128','2013-04-25','08:25:00',1.02),('15128','2013-04-25','08:30:00',1.08),('15128','2013-04-25','08:35:00',1.14),('15128','2013-04-25','08:40:00',1.15),('15128','2013-04-25','08:45:00',1.31),('15128','2013-04-25','08:50:00',1.46),('15128','2013-04-25','08:55:00',1.72),('15128','2013-04-25','09:00:00',1.72),('15128','2013-04-25','09:05:00',1.79),('15128','2013-04-25','09:10:00',1.54),('15128','2013-04-25','09:15:00',1.26),('15128','2013-04-25','09:20:00',1.31),('15128','2013-04-25','09:25:00',1.28),('15128','2013-04-25','09:30:00',1.72),('15128','2013-04-25','09:35:00',1.89),('15128','2013-04-25','09:40:00',2.03),('15128','2013-04-25','09:45:00',1.91),('15128','2013-04-25','09:50:00',1.3),('15128','2013-04-25','09:55:00',1.76),('15128','2013-04-25','10:00:00',1.42),('15128','2013-04-25','10:05:00',1.91),('15128','2013-04-25','10:10:00',2.48),('15128','2013-04-25','10:15:00',2.49),('15128','2013-04-25','10:20:00',2.63),('15128','2013-04-25','10:25:00',2.55),('15128','2013-04-25','10:30:00',2.81),('15128','2013-04-25','10:35:00',2.73),('15128','2013-04-25','10:40:00',2.81),('15128','2013-04-25','10:45:00',2.75),('15128','2013-04-25','10:50:00',2.53),('15128','2013-04-25','10:55:00',3.17),('15128','2013-04-25','11:00:00',3.16),('15128','2013-04-25','11:05:00',3.17),('15128','2013-04-25','11:10:00',3.22),('15128','2013-04-25','11:15:00',3.26),('15128','2013-04-25','11:20:00',3.35),('15128','2013-04-25','11:25:00',3.06),('15128','2013-04-25','11:30:00',2.64),('15128','2013-04-25','11:35:00',3.19),('15128','2013-04-25','11:40:00',2.46),('15128','2013-04-25','11:45:00',2.68),('15128','2013-04-25','11:50:00',3.16),('15128','2013-04-25','11:55:00',2.94),('15128','2013-04-25','12:00:00',3.23),('15128','2013-04-25','12:05:00',2.47),('15128','2013-04-25','12:10:00',2.52),('15128','2013-04-25','12:15:00',2.69),('15128','2013-04-25','12:20:00',3.25),('15128','2013-04-25','12:25:00',2.84),('15128','2013-04-25','12:30:00',2.3),('15128','2013-04-25','12:35:00',2.67),('15128','2013-04-25','12:40:00',2.91),('15128','2013-04-25','12:45:00',2.81),('15128','2013-04-25','12:50:00',2.91),('15128','2013-04-25','12:55:00',1.63),('15128','2013-04-25','13:00:00',1.33),('15128','2013-04-25','13:05:00',1.4),('15128','2013-04-25','13:10:00',1.66),('15128','2013-04-25','13:15:00',3.76),('15128','2013-04-25','13:20:00',3.25),('15128','2013-04-25','13:25:00',3.84),('15128','2013-04-25','13:30:00',3.37),('15128','2013-04-25','13:35:00',2.77),('15128','2013-04-25','13:40:00',2.37),('15128','2013-04-25','13:45:00',2.64),('15128','2013-04-25','13:50:00',3.64),('15128','2013-04-25','13:55:00',2.94),('15128','2013-04-25','14:00:00',3.03),('15128','2013-04-25','14:05:00',2.99),('15128','2013-04-25','14:10:00',2.8),('15128','2013-04-25','14:15:00',3.16),('15128','2013-04-25','14:20:00',2.75),('15128','2013-04-25','14:25:00',3.65),('15128','2013-04-25','14:30:00',3.12),('15128','2013-04-25','14:35:00',2.23),('15128','2013-04-25','14:40:00',1.97),('15128','2013-04-25','14:45:00',1.94),('15128','2013-04-25','14:50:00',1.49),('15128','2013-04-25','14:55:00',1.47),('15128','2013-04-25','15:00:00',2.66),('15128','2013-04-25','15:05:00',3.26),('15128','2013-04-25','15:10:00',2.88),('15128','2013-04-25','15:15:00',4.37),('15128','2013-04-25','15:20:00',2.02),('15128','2013-04-25','15:25:00',1.84),('15128','2013-04-25','15:30:00',3.37),('15128','2013-04-25','15:35:00',4.36),('15128','2013-04-25','15:40:00',2.72),('15128','2013-04-25','15:45:00',2.93),('15128','2013-04-25','15:50:00',2.45),('15128','2013-04-25','15:55:00',1.08),('15128','2013-04-24','08:35:00',1.13),('15128','2013-04-24','08:40:00',1.31),('15128','2013-04-24','08:45:00',1.48),('15128','2013-04-24','08:50:00',1.23),('15128','2013-04-24','08:55:00',1.11),('15128','2013-04-24','09:00:00',1.14),('15128','2013-04-24','09:05:00',1.16),('15128','2013-04-24','09:10:00',1.17),('15128','2013-04-24','09:15:00',1.25),('15128','2013-04-24','09:20:00',1.33),('15128','2013-04-24','09:25:00',1.29),('15128','2013-04-24','09:30:00',1.72),('15128','2013-04-24','09:35:00',1.83),('15128','2013-04-24','09:40:00',2.02),('15128','2013-04-24','09:45:00',2.13),('15128','2013-04-24','09:50:00',2.14),('15128','2013-04-24','09:55:00',2.09),('15128','2013-04-24','10:00:00',1.94),('15128','2013-04-24','10:05:00',2.08),('15128','2013-04-24','10:10:00',2.37),('15128','2013-04-24','10:15:00',2.43),('15128','2013-04-24','10:20:00',2.58),('15128','2013-04-24','10:25:00',2.72),('15128','2013-04-24','10:30:00',2.71),('15128','2013-04-24','10:35:00',2.75),('15128','2013-04-24','10:40:00',2.78),('15128','2013-04-24','10:45:00',2.83),('15128','2013-04-24','10:50:00',2.85),('15128','2013-04-24','10:55:00',2.88),('15128','2013-04-24','11:00:00',2.94),('15128','2013-04-24','11:05:00',3.04),('15128','2013-04-24','11:10:00',3.1),('15128','2013-04-24','11:15:00',3.14),('15128','2013-04-24','11:20:00',3.21),('15128','2013-04-24','11:25:00',3.24),('15128','2013-04-24','11:30:00',3.34),('15128','2013-04-24','11:35:00',3.42),('15128','2013-04-24','11:40:00',3.49),('15128','2013-04-24','11:45:00',3.58),('15128','2013-04-24','11:50:00',3.74),('15128','2013-04-24','11:55:00',3.79),('15128','2013-04-24','12:00:00',3.74),('15128','2013-04-24','12:05:00',3.77),('15128','2013-04-24','12:10:00',3.82),('15128','2013-04-24','12:15:00',3.9),('15128','2013-04-24','12:20:00',3.9),('15128','2013-04-24','12:25:00',3.89),('15128','2013-04-24','12:30:00',3.91),('15128','2013-04-24','12:35:00',3.98),('15128','2013-04-24','12:40:00',3.99),('15128','2013-04-24','12:45:00',4.04),('15128','2013-04-24','12:50:00',4.09),('15128','2013-04-24','12:55:00',4.12),('15128','2013-04-24','13:00:00',4.2),('15128','2013-04-24','13:05:00',4.29),('15128','2013-04-24','13:10:00',4.3),('15128','2013-04-24','13:15:00',4.25),('15128','2013-04-24','13:20:00',4.13),('15128','2013-04-24','13:25:00',3.51),('15128','2013-04-24','13:30:00',2.72),('15128','2013-04-24','13:35:00',2.32),('15128','2013-04-24','13:40:00',2.22),('15128','2013-04-24','13:45:00',2.13),('15128','2013-04-24','13:50:00',2.02),('15128','2013-04-24','13:55:00',2.14),('15128','2013-04-24','14:00:00',2.12),('15128','2013-04-24','14:05:00',2.32),('15128','2013-04-24','14:10:00',2.42),('15128','2013-04-24','14:15:00',2.59),('15128','2013-04-24','14:20:00',3.14),('15128','2013-04-24','14:25:00',3.8),('15128','2013-04-24','14:30:00',4.09),('15128','2013-04-24','14:35:00',4.06),('15128','2013-04-24','14:40:00',3.86),('15128','2013-04-24','14:45:00',3.9),('15128','2013-04-24','14:50:00',3.67),('15128','2013-04-24','14:55:00',3.1),('15128','2013-04-24','15:00:00',3.54),('15128','2013-04-24','15:05:00',3.36),('15128','2013-04-24','15:10:00',3.15),('15128','2013-04-24','15:15:00',2.69),('15128','2013-04-24','15:20:00',3.32),('15128','2013-04-24','15:25:00',3.63),('15128','2013-04-24','15:30:00',3.4),('15128','2013-04-24','15:35:00',3.02),('15128','2013-04-24','15:40:00',2.71),('15128','2013-04-24','15:45:00',2.89),('15128','2013-04-24','15:50:00',2.36),('15128','2013-04-24','15:55:00',2.55),('15128','2013-04-24','16:00:00',2.65),('15128','2013-04-24','16:05:00',2.66),('15128','2013-04-24','16:10:00',2.92),('15128','2013-04-24','16:15:00',3.3),('15128','2013-04-24','16:20:00',2.92),('15128','2013-04-24','16:25:00',2.53),('15128','2013-04-24','16:30:00',2.61),('15128','2013-04-24','16:35:00',1.81),('15128','2013-04-24','16:40:00',1.99),('15128','2013-04-24','16:45:00',2.27),('15128','2013-04-24','16:50:00',2.13),('15128','2013-04-24','16:55:00',2.34),('15128','2013-04-24','17:00:00',1.98),('15128','2013-04-24','17:05:00',2.53),('15128','2013-04-24','17:10:00',2.18),('15128','2013-04-24','17:15:00',2.25),('15128','2013-04-24','17:20:00',2.33),('15128','2013-04-24','17:25:00',1.95),('15128','2013-04-24','17:30:00',1.85),('15128','2013-04-24','17:35:00',1.6),('15128','2013-04-24','17:40:00',1.53),('15128','2013-04-24','17:45:00',1.53),('15128','2013-04-24','17:50:00',1.59),('15128','2013-04-24','17:55:00',1.24),('15128','2013-04-24','18:00:00',1.21),('15128','2013-04-24','18:05:00',1.37),('15128','2013-04-24','18:10:00',1.04),('15128','2013-04-23','08:20:00',1.02),('15128','2013-04-23','08:25:00',1.09),('15128','2013-04-23','08:30:00',1.08),('15128','2013-04-23','08:35:00',1.06),('15128','2013-04-23','08:40:00',1.09),('15128','2013-04-23','08:45:00',1.17),('15128','2013-04-23','08:50:00',1.27),('15128','2013-04-23','08:55:00',1.37),('15128','2013-04-23','09:00:00',1.48),('15128','2013-04-23','09:05:00',1.62),('15128','2013-04-23','09:10:00',1.85),('15128','2013-04-23','09:15:00',1.83),('15128','2013-04-23','09:20:00',1.52),('15128','2013-04-23','09:25:00',1.51),('15128','2013-04-23','09:30:00',1.6),('15128','2013-04-23','09:35:00',1.7),('15128','2013-04-23','09:40:00',1.74),('15128','2013-04-23','09:45:00',1.86),('15128','2013-04-23','09:50:00',2.06),('15128','2013-04-23','09:55:00',2.15),('15128','2013-04-23','10:00:00',2.45),('15128','2013-04-23','10:05:00',2.55),('15128','2013-04-23','10:10:00',2.52),('15128','2013-04-23','10:15:00',2.48),('15128','2013-04-23','10:20:00',2.56),('15128','2013-04-23','10:25:00',2.66),('15128','2013-04-23','10:30:00',2.75),('15128','2013-04-23','10:35:00',2.67),('15128','2013-04-23','10:40:00',2.56),('15128','2013-04-23','10:45:00',2.68),('15128','2013-04-23','10:50:00',2.9),('15128','2013-04-23','10:55:00',2.98),('15128','2013-04-23','11:00:00',2.98),('15128','2013-04-23','11:05:00',3.02),('15128','2013-04-23','11:10:00',3.3),('15128','2013-04-23','11:15:00',3.4),('15128','2013-04-23','11:20:00',3.48),('15128','2013-04-23','11:25:00',3.52),('15128','2013-04-23','11:30:00',3.2),('15128','2013-04-23','11:35:00',3),('15128','2013-04-23','11:40:00',3.31),('15128','2013-04-23','11:45:00',4.09),('15128','2013-04-23','11:50:00',3.59),('15128','2013-04-23','11:55:00',2.9),('15128','2013-04-23','12:00:00',2.48),('15128','2013-04-23','12:05:00',3.12),('15128','2013-04-23','12:10:00',2.72),('15128','2013-04-23','12:15:00',2.88),('15128','2013-04-23','12:20:00',4.41),('15128','2013-04-23','12:25:00',2.81),('15128','2013-04-23','12:30:00',3.25),('15128','2013-04-23','12:35:00',2.78),('15128','2013-04-23','12:40:00',3.44),('15128','2013-04-23','12:45:00',3.23),('15128','2013-04-23','12:50:00',3.86),('15128','2013-04-23','12:55:00',4.17),('15128','2013-04-23','13:00:00',4.03),('15128','2013-04-23','13:05:00',4.43),('15128','2013-04-23','13:10:00',4.55),('15128','2013-04-23','13:15:00',4.15),('15128','2013-04-23','13:20:00',3.79),('15128','2013-04-23','13:25:00',4.32),('15128','2013-04-23','13:30:00',3.52),('15128','2013-04-23','13:35:00',3.74),('15128','2013-04-23','13:40:00',3.29),('15128','2013-04-23','13:45:00',2.75),('15128','2013-04-23','13:50:00',2.78),('15128','2013-04-23','13:55:00',3.54),('15128','2013-04-23','14:00:00',3.33),('15128','2013-04-23','14:05:00',3.09),('15128','2013-04-23','14:10:00',3.05),('15128','2013-04-23','14:15:00',2.67),('15128','2013-04-23','14:20:00',2.97),('15128','2013-04-23','14:25:00',3.13),('15128','2013-04-23','14:30:00',2.77),('15128','2013-04-23','14:35:00',3.17),('15128','2013-04-23','14:40:00',3.59),('15128','2013-04-23','14:45:00',2.64),('15128','2013-04-23','14:50:00',2.41),('15128','2013-04-23','14:55:00',2.5),('15128','2013-04-23','15:00:00',2.52),('15128','2013-04-23','15:05:00',2.35),('15128','2013-04-23','15:10:00',2.41),('15128','2013-04-23','15:15:00',2.25),('15128','2013-04-23','15:20:00',2.22),('15128','2013-04-23','15:25:00',2.2),('15128','2013-04-23','15:30:00',2.03),('15128','2013-04-23','15:35:00',2.07),('15128','2013-04-23','15:40:00',2.25),('15128','2013-04-23','15:45:00',1.96),('15128','2013-04-23','15:50:00',1.95),('15128','2013-04-23','15:55:00',2.2),('15128','2013-04-23','16:00:00',2.26),('15128','2013-04-23','16:05:00',2.18),('15128','2013-04-23','16:10:00',2.28),('15128','2013-04-23','16:15:00',2.99),('15128','2013-04-23','16:20:00',3.02),('15128','2013-04-23','16:25:00',2.31),('15128','2013-04-23','16:30:00',2.35),('15128','2013-04-23','16:35:00',2.26),('15128','2013-04-23','16:40:00',2.46),('15128','2013-04-23','16:45:00',2.71),('15128','2013-04-23','16:50:00',2.9),('15128','2013-04-23','16:55:00',2.93),('15128','2013-04-23','17:00:00',2.98),('15128','2013-04-23','17:05:00',3.03),('15128','2013-04-23','17:10:00',2.67),('15128','2013-04-23','17:15:00',2.62),('15128','2013-04-23','17:20:00',2.22),('15128','2013-04-23','17:25:00',1.14),('15128','2013-04-23','17:30:00',1.21),('15128','2013-04-23','17:35:00',1.35),('15128','2013-04-23','17:40:00',1.87),('15128','2013-04-23','17:45:00',1.82),('15128','2013-04-23','17:50:00',1.86),('15128','2013-04-23','17:55:00',1.42),('15128','2013-04-23','18:00:00',1.71),('15128','2013-04-23','18:05:00',1.31),('15128','2013-04-23','18:20:00',1.25),('15128','2013-04-23','18:25:00',1.3),('15128','2013-04-22','08:25:00',1.06),('15128','2013-04-22','08:30:00',1.16),('15128','2013-04-22','08:35:00',1.22),('15128','2013-04-22','08:40:00',1.28),('15128','2013-04-22','08:45:00',1.36),('15128','2013-04-22','08:50:00',1.47),('15128','2013-04-22','08:55:00',1.57),('15128','2013-04-22','09:00:00',1.65),('15128','2013-04-22','09:05:00',1.69),('15128','2013-04-22','09:10:00',1.74),('15128','2013-04-22','09:15:00',1.78),('15128','2013-04-22','09:20:00',1.84),('15128','2013-04-22','09:25:00',2),('15128','2013-04-22','09:30:00',2.08),('15128','2013-04-22','09:35:00',2.16),('15128','2013-04-22','09:40:00',2.15),('15128','2013-04-22','09:45:00',2.08),('15128','2013-04-22','09:50:00',2.14),('15128','2013-04-22','09:55:00',2.25),('15128','2013-04-22','10:00:00',2.36),('15128','2013-04-22','10:05:00',2.4),('15128','2013-04-22','10:10:00',2.43),('15128','2013-04-22','10:15:00',2.5),('15128','2013-04-22','10:20:00',2.57),('15128','2013-04-22','10:25:00',2.66),('15128','2013-04-22','10:30:00',2.74),('15128','2013-04-22','10:35:00',2.78),('15128','2013-04-22','10:40:00',2.9),('15128','2013-04-22','10:45:00',2.92),('15128','2013-04-22','10:50:00',3.06),('15128','2013-04-22','10:55:00',3.13),('15128','2013-04-22','11:00:00',3.13),('15128','2013-04-22','11:05:00',3.15),('15128','2013-04-22','11:10:00',3.24),('15128','2013-04-22','11:15:00',3.25),('15128','2013-04-22','11:20:00',3.3),('15128','2013-04-22','11:25:00',3.36),('15128','2013-04-22','11:30:00',3.23),('15128','2013-04-22','11:35:00',3.38),('15128','2013-04-22','11:40:00',3.42),('15128','2013-04-22','11:45:00',3.65),('15128','2013-04-22','11:50:00',3.76),('15128','2013-04-22','11:55:00',3.86),('15128','2013-04-22','12:00:00',3.95),('15128','2013-04-22','12:05:00',3.99),('15128','2013-04-22','12:10:00',4.02),('15128','2013-04-22','12:15:00',4.06),('15128','2013-04-22','12:20:00',4.06),('15128','2013-04-22','12:25:00',4.08),('15128','2013-04-22','12:30:00',4.11),('15128','2013-04-22','12:35:00',4.18),('15128','2013-04-22','12:40:00',4.29),('15128','2013-04-22','12:45:00',4.18),('15128','2013-04-22','12:50:00',3.81),('15128','2013-04-22','12:55:00',4.33),('15128','2013-04-22','13:00:00',4.43),('15128','2013-04-22','13:05:00',4.41),('15128','2013-04-22','13:10:00',4.5),('15128','2013-04-22','13:15:00',4.4),('15128','2013-04-22','13:20:00',4.6),('15128','2013-04-22','13:25:00',4.47),('15128','2013-04-22','13:30:00',4),('15128','2013-04-22','13:35:00',4.18),('15128','2013-04-22','13:40:00',4.22),('15128','2013-04-22','13:45:00',4.34),('15128','2013-04-22','13:50:00',3.83),('15128','2013-04-22','13:55:00',4.34),('15128','2013-04-22','14:00:00',4.61),('15128','2013-04-22','14:05:00',4.63),('15128','2013-04-22','14:10:00',2.71),('15128','2013-04-22','14:15:00',3.21),('15128','2013-04-22','14:20:00',3.56),('15128','2013-04-22','14:25:00',2.57),('15128','2013-04-22','14:30:00',3.53),('15128','2013-04-22','14:35:00',3.64),('15128','2013-04-22','14:40:00',2.87),('15128','2013-04-22','14:45:00',2.25),('15128','2013-04-22','14:50:00',2.75),('15128','2013-04-22','14:55:00',1.71),('15128','2013-04-22','15:00:00',1.45),('15128','2013-04-22','15:05:00',1.59),('15128','2013-04-22','15:10:00',2.69),('15128','2013-04-22','15:15:00',3.52),('15128','2013-04-22','15:20:00',3.29),('15128','2013-04-22','15:25:00',2.51),('15128','2013-04-22','15:30:00',2.17),('15128','2013-04-22','15:35:00',2.59),('15128','2013-04-22','15:40:00',3.19),('15128','2013-04-22','15:45:00',2.53),('15128','2013-04-22','15:50:00',2.33),('15128','2013-04-22','15:55:00',2.51),('15128','2013-04-22','16:00:00',3.01),('15128','2013-04-22','16:05:00',2.67),('15128','2013-04-22','16:10:00',2.64),('15128','2013-04-22','16:15:00',2.85),('15128','2013-04-22','16:20:00',2.01),('15128','2013-04-22','16:25:00',1.7),('15128','2013-04-22','16:30:00',1.46),('15128','2013-04-22','16:35:00',1.29),('15128','2013-04-22','16:40:00',1.33),('15128','2013-04-22','16:45:00',1.26),('15128','2013-04-22','16:50:00',1.72),('15128','2013-04-22','16:55:00',1.89),('15128','2013-04-22','17:00:00',1.9),('15128','2013-04-22','17:05:00',2.36),('15128','2013-04-22','17:10:00',2.47),('15128','2013-04-22','17:15:00',2.7),('15128','2013-04-22','17:20:00',2.61),('15128','2013-04-22','17:25:00',2.29),('15128','2013-04-22','17:30:00',2.31),('15128','2013-04-22','17:35:00',2.1),('15128','2013-04-22','17:40:00',2.35),('15128','2013-04-22','17:45:00',2.19),('15128','2013-04-22','17:50:00',1.88),('15128','2013-04-22','17:55:00',1.95),('15128','2013-04-22','18:00:00',1.87),('15128','2013-04-22','18:05:00',1.51),('15128','2013-04-22','18:10:00',1.12),('15128','2013-04-22','18:15:00',1.25),('15128','2013-04-22','18:20:00',1.45),('15128','2013-04-22','18:25:00',1.06),('15128','2013-04-22','18:30:00',1.18),('15128','2013-04-22','18:35:00',1.16),('15128','2013-04-21','08:45:00',1.17),('15128','2013-04-21','09:20:00',1.14),('15128','2013-04-21','09:30:00',1.02),('15128','2013-04-21','10:35:00',1.38),('15128','2013-04-21','10:40:00',2.66),('15128','2013-04-21','10:45:00',2.57),('15128','2013-04-21','10:50:00',2.97),('15128','2013-04-21','10:55:00',1.22),('15128','2013-04-21','11:05:00',1.15),('15128','2013-04-21','11:10:00',1.27),('15128','2013-04-21','11:25:00',1.74),('15128','2013-04-21','11:30:00',1.51),('15128','2013-04-21','11:35:00',1.05),('15128','2013-04-21','11:45:00',1.14),('15128','2013-04-21','11:50:00',4.31),('15128','2013-04-21','11:55:00',4.17),('15128','2013-04-21','12:00:00',4.29),('15128','2013-04-21','12:05:00',4.37),('15128','2013-04-21','12:10:00',4.46),('15128','2013-04-21','12:15:00',4.27),('15128','2013-04-21','12:20:00',4.32),('15128','2013-04-21','12:25:00',4.42),('15128','2013-04-21','12:30:00',4.5),('15128','2013-04-21','12:35:00',4.49),('15128','2013-04-21','12:40:00',4.57),('15128','2013-04-21','12:45:00',4.19),('15128','2013-04-21','12:50:00',3.81),('15128','2013-04-21','12:55:00',4.61),('15128','2013-04-21','13:00:00',4.78),('15128','2013-04-21','13:05:00',4.68),('15128','2013-04-21','13:10:00',2.41),('15128','2013-04-21','13:15:00',4.98),('15128','2013-04-21','13:20:00',3.82),('15128','2013-04-21','13:25:00',3.1),('15128','2013-04-21','13:30:00',1.43),('15128','2013-04-21','13:35:00',1.63),('15128','2013-04-21','13:40:00',1.24),('15128','2013-04-21','14:05:00',1.23),('15128','2013-04-21','14:10:00',1.48),('15128','2013-04-21','14:15:00',1.34),('15128','2013-04-21','14:20:00',1.96),('15128','2013-04-21','14:25:00',4.11),('15128','2013-04-21','14:30:00',1.11),('15128','2013-04-21','14:35:00',1.48),('15128','2013-04-21','14:40:00',3.15),('15128','2013-04-21','14:45:00',2.11),('15128','2013-04-21','14:50:00',2.4),('15128','2013-04-21','14:55:00',1.94),('15128','2013-04-21','15:00:00',1.93),('15128','2013-04-21','15:05:00',1.37),('15128','2013-04-21','15:10:00',1.49),('15128','2013-04-21','15:15:00',2.83),('15128','2013-04-21','15:20:00',1.06),('15128','2013-04-21','15:25:00',1.11),('15128','2013-04-21','15:30:00',1.13),('15128','2013-04-21','15:35:00',1.62),('15128','2013-04-21','15:40:00',3.17),('15128','2013-04-21','15:45:00',2.27),('15128','2013-04-21','15:50:00',1.52),('15128','2013-04-21','15:55:00',1.51),('15128','2013-04-21','16:00:00',1.24),('15128','2013-04-21','16:05:00',1.04),('15128','2013-04-21','17:10:00',1.72),('15128','2013-04-21','17:15:00',2.17),('15128','2013-04-21','17:20:00',2.4),('15128','2013-04-21','17:25:00',3.09),('15128','2013-04-21','17:30:00',3.41),('15128','2013-04-21','17:35:00',2.71),('15128','2013-04-21','17:40:00',2.05),('15128','2013-04-21','17:45:00',2.08),('15128','2013-04-21','17:50:00',2.66),('15128','2013-04-21','17:55:00',2.51),('15128','2013-04-21','18:00:00',2.89),('15128','2013-04-21','18:05:00',1.46),('15128','2013-04-21','18:15:00',1.47),('15128','2013-04-21','18:20:00',2.1),('15128','2013-04-21','18:25:00',1.96),('15128','2013-04-21','18:30:00',1.68),('15128','2013-04-21','18:35:00',1.54),('15128','2013-04-21','18:40:00',1.39),('15128','2013-04-21','18:45:00',1.33),('15128','2013-04-21','18:50:00',1.25),('15128','2014-03-28','08:05:00',1.07),('15128','2014-03-28','08:10:00',1.14),('15128','2014-03-28','08:15:00',1.2),('15128','2014-03-28','08:20:00',1.27),('15128','2014-03-28','08:25:00',1.35),('15128','2014-03-28','08:30:00',1.43),('15128','2014-03-28','08:35:00',1.48),('15128','2014-03-28','08:40:00',1.51),('15128','2014-03-28','08:45:00',1.56),('15128','2014-03-28','08:50:00',1.63),('15128','2014-03-28','08:55:00',1.7),('15128','2014-03-28','09:00:00',1.78),('15128','2014-03-28','09:05:00',1.83),('15128','2014-03-28','09:10:00',1.89),('15128','2014-03-28','09:15:00',1.93),('15128','2014-03-28','09:20:00',1.99),('15128','2014-03-28','09:25:00',2.04),('15128','2014-03-28','09:30:00',2.05),('15128','2014-03-28','09:35:00',2.17),('15128','2014-03-28','09:40:00',2.23),('15128','2014-03-28','09:45:00',2.3),('15128','2014-03-28','09:50:00',2.34),('15128','2014-03-28','09:55:00',2.41),('15128','2014-03-28','10:00:00',2.45),('15128','2014-03-28','10:05:00',2.51),('15128','2014-03-28','10:10:00',2.57),('15128','2014-03-28','10:15:00',2.6),('15128','2014-03-28','10:20:00',2.7),('15128','2014-03-28','10:25:00',2.76),('15128','2014-03-28','10:30:00',2.8),('15128','2014-03-28','10:35:00',2.81),('15128','2014-03-28','10:40:00',2.93),('15128','2014-03-28','10:45:00',2.89),('15128','2014-03-28','10:50:00',3.06),('15128','2014-03-28','10:55:00',3.08),('15128','2014-03-28','11:00:00',3.25),('15128','2014-03-28','11:05:00',3.36),('15128','2014-03-28','11:10:00',3.39),('15128','2014-03-28','11:15:00',3.45),('15128','2014-03-28','11:20:00',3.5),('15128','2014-03-28','11:25:00',3.53),('15128','2014-03-28','11:30:00',3.54),('15128','2014-03-28','11:35:00',3.48),('15128','2014-03-28','11:40:00',3.57),('15128','2014-03-28','11:45:00',3.62),('15128','2014-03-28','11:50:00',3.63),('15128','2014-03-28','11:55:00',3.59),('15128','2014-03-28','12:00:00',3.65),('15128','2014-03-28','12:05:00',3.73),('15128','2014-03-28','12:10:00',3.75),('15128','2014-03-28','12:15:00',3.75),('15128','2014-03-28','12:20:00',3.76),('15128','2014-03-28','12:25:00',3.81),('15128','2014-03-28','12:30:00',3.85),('15128','2014-03-28','12:35:00',3.85),('15128','2014-03-28','12:40:00',3.86),('15128','2014-03-28','12:45:00',3.77),('15128','2014-03-28','12:50:00',3.1),('15128','2014-03-28','12:55:00',3.62),('15128','2014-03-28','13:00:00',3.8),('15128','2014-03-28','13:05:00',3.72),('15128','2014-03-28','13:10:00',3.93),('15128','2014-03-28','13:15:00',3.97),('15128','2014-03-28','13:20:00',2.32),('15128','2014-03-28','13:25:00',2.36),('15128','2014-03-28','13:30:00',2.61),('15128','2014-03-28','13:35:00',2.93),('15128','2014-03-28','13:40:00',2.82),('15128','2014-03-28','13:45:00',3.09),('15128','2014-03-28','13:50:00',2.92),('15128','2014-03-28','13:55:00',3.38),('15128','2014-03-28','14:00:00',3.64),('15128','2014-03-28','14:05:00',3.49),('15128','2014-03-28','14:10:00',3.52),('15128','2014-03-28','14:15:00',3.53),('15128','2014-03-28','14:20:00',3.61),('15128','2014-03-28','14:25:00',3.57),('15128','2014-03-28','14:30:00',3.5),('15128','2014-03-28','14:35:00',3.47),('15128','2014-03-28','14:40:00',3.41),('15128','2014-03-28','14:45:00',3.35),('15128','2014-03-28','14:50:00',3.29),('15128','2014-03-28','14:55:00',3.19),('15128','2014-03-28','15:00:00',3.11),('15128','2014-03-28','15:05:00',3.13),('15128','2014-03-28','15:10:00',3.03),('15128','2014-03-28','15:15:00',2.97),('15128','2014-03-28','15:20:00',2.93),('15128','2014-03-28','15:25:00',2.86),('15128','2014-03-28','15:30:00',2.78),('15128','2014-03-28','15:35:00',2.71),('15128','2014-03-28','15:40:00',2.66),('15128','2014-03-28','15:45:00',2.6),('15128','2014-03-28','15:50:00',2.54),('15128','2014-03-28','15:55:00',2.46),('15128','2014-03-28','16:00:00',2.37),('15128','2014-03-28','16:05:00',2.25),('15128','2014-03-28','16:10:00',2.1),('15128','2014-03-28','16:15:00',1.96),('15128','2014-03-28','16:20:00',1.85),('15128','2014-03-28','16:25:00',1.83),('15128','2014-03-28','16:30:00',1.74),('15128','2014-03-28','16:35:00',1.45),('15128','2014-03-28','16:40:00',1.23),('15128','2014-03-28','16:45:00',1.37),('15128','2014-03-28','16:50:00',1.43),('15128','2014-03-28','16:55:00',1.33),('15128','2014-03-28','17:00:00',1.23),('15128','2014-03-28','17:05:00',1.15),('15128','2014-03-28','17:10:00',1.05),('15128','2013-04-20','08:45:00',1.05),('15128','2013-04-20','08:50:00',1.1),('15128','2013-04-20','09:10:00',1.05),('15128','2013-04-20','09:15:00',1.19),('15128','2013-04-20','09:25:00',1.31),('15128','2013-04-20','09:30:00',1.66),('15128','2013-04-20','09:35:00',2.31),('15128','2013-04-20','09:40:00',2.42),('15128','2013-04-20','09:45:00',1.92),('15128','2013-04-20','09:50:00',1.77),('15128','2013-04-20','09:55:00',1.52),('15128','2013-04-20','10:00:00',1.33),('15128','2013-04-20','10:05:00',1.49),('15128','2013-04-20','10:10:00',1.97),('15128','2013-04-20','10:15:00',1.7),('15128','2013-04-20','10:20:00',2.64),('15128','2013-04-20','10:25:00',2.63),('15128','2013-04-20','10:30:00',2.68),('15128','2013-04-20','10:35:00',2.77),('15128','2013-04-20','10:40:00',2.84),('15128','2013-04-20','10:45:00',2.94),('15128','2013-04-20','10:50:00',2.77),('15128','2013-04-20','10:55:00',3.01),('15128','2013-04-20','11:00:00',3.06),('15128','2013-04-20','11:05:00',3.25),('15128','2013-04-20','11:10:00',2.95),('15128','2013-04-20','11:15:00',3.15),('15128','2013-04-20','11:20:00',2.68),('15128','2013-04-20','11:25:00',2.5),('15128','2013-04-20','11:30:00',2.65),('15128','2013-04-20','11:35:00',2.72),('15128','2013-04-20','11:40:00',2.72),('15128','2013-04-20','11:45:00',2.63),('15128','2013-04-20','11:50:00',2.75),('15128','2013-04-20','11:55:00',2.46),('15128','2013-04-20','12:00:00',2.71),('15128','2013-04-20','12:05:00',2.65),('15128','2013-04-20','12:10:00',2.58),('15128','2013-04-20','12:15:00',2.29),('15128','2013-04-20','12:20:00',2.13),('15128','2013-04-20','12:25:00',2.25),('15128','2013-04-20','12:30:00',2.35),('15128','2013-04-20','12:35:00',2.38),('15128','2013-04-20','12:40:00',2.49),('15128','2013-04-20','12:45:00',2.47),('15128','2013-04-20','12:50:00',2.39),('15128','2013-04-20','12:55:00',2.42),('15128','2013-04-20','13:00:00',2.47),('15128','2013-04-20','13:05:00',3.06),('15128','2013-04-20','13:10:00',3.06),('15128','2013-04-20','13:15:00',2.66),('15128','2013-04-20','13:20:00',2.68),('15128','2013-04-20','13:25:00',2.64),('15128','2013-04-20','13:30:00',2.83),('15128','2013-04-20','13:35:00',3.25),('15128','2013-04-20','13:40:00',4.57),('15128','2013-04-20','13:45:00',4.4),('15128','2013-04-20','13:50:00',4.28),('15128','2013-04-20','13:55:00',4.76),('15128','2013-04-20','14:00:00',4),('15128','2013-04-20','14:05:00',3.75),('15128','2013-04-20','14:10:00',4.06),('15128','2013-04-20','14:15:00',2.6),('15128','2013-04-20','14:20:00',3.7),('15128','2013-04-20','14:25:00',4.34),('15128','2013-04-20','14:30:00',4.73),('15128','2013-04-20','14:35:00',4.55),('15128','2013-04-20','14:40:00',4.02),('15128','2013-04-20','14:45:00',4.41),('15128','2013-04-20','14:50:00',2.5),('15128','2013-04-20','14:55:00',3.49),('15128','2013-04-20','15:00:00',4.35),('15128','2013-04-20','15:05:00',4.29),('15128','2013-04-20','15:10:00',4.39),('15128','2013-04-20','15:15:00',3.91),('15128','2013-04-20','15:20:00',3.42),('15128','2013-04-20','15:25:00',4.33),('15128','2013-04-20','15:30:00',3.93),('15128','2013-04-20','15:35:00',2.82),('15128','2013-04-20','15:40:00',2.68),('15128','2013-04-20','15:45:00',1.98),('15128','2013-04-20','15:50:00',1.33),('15128','2013-04-20','15:55:00',1.09),('15128','2013-04-19','08:25:00',1.16),('15128','2013-04-19','08:30:00',1.22),('15128','2013-04-19','08:35:00',1.33),('15128','2013-04-19','08:40:00',1.32),('15128','2013-04-19','08:45:00',1.45),('15128','2013-04-19','08:50:00',1.37),('15128','2013-04-19','08:55:00',1.57),('15128','2013-04-19','09:00:00',1.65),('15128','2013-04-19','09:05:00',1.78),('15128','2013-04-19','09:10:00',1.49),('15128','2013-04-19','09:15:00',1.2),('15128','2013-04-19','09:20:00',1.12),('15128','2013-04-19','09:25:00',1.07),('15128','2013-04-19','10:30:00',1.13),('15128','2013-04-19','10:35:00',1.4),('15128','2013-04-19','10:40:00',1.59),('15128','2013-04-19','10:45:00',1.77),('15128','2013-04-19','10:50:00',3.05),('15128','2013-04-19','10:55:00',3.38),('15128','2013-04-19','11:00:00',2.21),('15128','2013-04-19','11:05:00',1.28),('15128','2013-04-19','11:10:00',1.25),('15128','2013-04-19','11:15:00',1.29),('15128','2013-04-19','11:20:00',1.32),('15128','2013-04-19','11:25:00',1.49),('15128','2013-04-19','11:30:00',1.75),('15128','2013-04-19','11:35:00',2.28),('15128','2013-04-19','11:40:00',3.88),('15128','2013-04-19','11:45:00',3.07),('15128','2013-04-19','11:50:00',1.48),('15128','2013-04-19','11:55:00',1.48),('15128','2013-04-19','12:00:00',2.01),('15128','2013-04-19','12:05:00',4.96),('15128','2013-04-19','12:10:00',2.31),('15128','2013-04-19','12:15:00',2.14),('15128','2013-04-19','12:20:00',3.76),('15128','2013-04-19','12:25:00',4.75),('15128','2013-04-19','12:30:00',4.37),('15128','2013-04-19','12:35:00',2.55),('15128','2013-04-19','12:40:00',1.5),('15128','2013-04-19','12:45:00',1.94),('15128','2013-04-19','12:50:00',2.52),('15128','2013-04-19','12:55:00',4.9),('15128','2013-04-19','13:00:00',4.38),('15128','2013-04-19','13:05:00',4.46),('15128','2013-04-19','13:10:00',4.55),('15128','2013-04-19','13:15:00',4.55),('15128','2013-04-19','13:20:00',4.58),('15128','2013-04-19','13:25:00',4.13),('15128','2013-04-19','13:30:00',4.43),('15128','2013-04-19','13:35:00',4.76),('15128','2013-04-19','13:40:00',4.68),('15128','2013-04-19','13:45:00',3.47),('15128','2013-04-19','13:50:00',3.82),('15128','2013-04-19','13:55:00',3.05),('15128','2013-04-19','14:00:00',4.38),('15128','2013-04-19','14:05:00',4.19),('15128','2013-04-19','14:10:00',3.34),('15128','2013-04-19','14:15:00',4.06),('15128','2013-04-19','14:20:00',3.95),('15128','2013-04-19','14:25:00',4.42),('15128','2013-04-19','14:30:00',3.82),('15128','2013-04-19','14:35:00',4.29),('15128','2013-04-19','14:40:00',4.15),('15128','2013-04-19','14:45:00',4.15),('15128','2013-04-19','14:50:00',4.17),('15128','2013-04-19','14:55:00',4.16),('15128','2013-04-19','15:00:00',4.19),('15128','2013-04-19','15:05:00',4.13),('15128','2013-04-19','15:10:00',3.65),('15128','2013-04-19','15:15:00',2.56),('15128','2013-04-19','15:20:00',2.93),('15128','2013-04-19','15:25:00',2.99),('15128','2013-04-19','15:30:00',1.42),('15128','2013-04-19','15:35:00',1.11),('15128','2013-04-19','16:00:00',1.31),('15128','2013-04-19','16:05:00',1.97),('15128','2013-04-19','16:10:00',3.4),('15128','2013-04-19','16:15:00',3.78),('15128','2013-04-19','16:20:00',2.99),('15128','2013-04-19','16:25:00',3.62),('15128','2013-04-19','16:30:00',3.77),('15128','2013-04-19','16:35:00',3.61),('15128','2013-04-19','16:40:00',3.44),('15128','2013-04-19','16:45:00',3.31),('15128','2013-04-19','16:50:00',3.14),('15128','2013-04-19','16:55:00',2.97),('15128','2013-04-19','17:00:00',3.02),('15128','2013-04-19','17:05:00',2.95),('15128','2013-04-19','17:10:00',2.83),('15128','2013-04-19','17:15:00',2.61),('15128','2013-04-19','17:20:00',2.73),('15128','2013-04-19','17:25:00',2.69),('15128','2013-04-19','17:30:00',2.68),('15128','2013-04-19','17:35:00',2.58),('15128','2013-04-19','17:40:00',1.21),('15128','2013-04-19','17:45:00',1.14),('15128','2013-04-19','17:50:00',2.02),('15128','2013-04-19','17:55:00',1.81),('15128','2013-04-19','18:00:00',1.62),('15128','2013-04-19','18:05:00',1.97),('15128','2013-04-19','18:10:00',1.85),('15128','2013-04-18','08:20:00',1.06),('15128','2013-04-18','08:25:00',1.03),('15128','2013-04-18','08:50:00',1.22),('15128','2013-04-18','08:55:00',1.09),('15128','2013-04-18','09:00:00',1.19),('15128','2013-04-18','09:05:00',1.44),('15128','2013-04-18','09:10:00',1.53),('15128','2013-04-18','09:15:00',1.65),('15128','2013-04-18','09:20:00',1.63),('15128','2013-04-18','09:25:00',1.7),('15128','2013-04-18','09:30:00',1.75),('15128','2013-04-18','09:35:00',1.84),('15128','2013-04-18','09:40:00',1.86),('15128','2013-04-18','09:45:00',1.9),('15128','2013-04-18','09:50:00',1.95),('15128','2013-04-18','09:55:00',1.99),('15128','2013-04-18','10:00:00',2.08),('15128','2013-04-18','10:05:00',2.17),('15128','2013-04-18','10:10:00',2.23),('15128','2013-04-18','10:15:00',2.28),('15128','2013-04-18','10:20:00',2.33),('15128','2013-04-18','10:25:00',2.37),('15128','2013-04-18','10:30:00',2.5),('15128','2013-04-18','10:35:00',2.58),('15128','2013-04-18','10:40:00',2.42),('15128','2013-04-18','10:45:00',2.61),('15128','2013-04-18','10:50:00',2.71),('15128','2013-04-18','10:55:00',2.73),('15128','2013-04-18','11:00:00',2.77),('15128','2013-04-18','11:05:00',2.85),('15128','2013-04-18','11:10:00',2.89),('15128','2013-04-18','11:15:00',2.99),('15128','2013-04-18','11:20:00',3.01),('15128','2013-04-18','11:25:00',3.07),('15128','2013-04-18','11:30:00',3.11),('15128','2013-04-18','11:35:00',3.21),('15128','2013-04-18','11:40:00',3.3),('15128','2013-04-18','11:45:00',3.4),('15128','2013-04-18','11:50:00',3.5),('15128','2013-04-18','11:55:00',3.6),('15128','2013-04-18','12:00:00',3.68),('15128','2013-04-18','12:05:00',3.72),('15128','2013-04-18','12:10:00',3.75),('15128','2013-04-18','12:15:00',3.77),('15128','2013-04-18','12:20:00',3.74),('15128','2013-04-18','12:25:00',3.88),('15128','2013-04-18','12:30:00',3.89),('15128','2013-04-18','12:35:00',3.93),('15128','2013-04-18','12:40:00',3.77),('15128','2013-04-18','12:45:00',3.98),('15128','2013-04-18','12:50:00',4.01),('15128','2013-04-18','12:55:00',4.03),('15128','2013-04-18','13:00:00',4),('15128','2013-04-18','13:05:00',4.06),('15128','2013-04-18','13:10:00',4.17),('15128','2013-04-18','13:15:00',4.09),('15128','2013-04-18','13:20:00',4.15),('15128','2013-04-18','13:25:00',4.12),('15128','2013-04-18','13:30:00',4.15),('15128','2013-04-18','13:35:00',4.1),('15128','2013-04-18','13:40:00',4.13),('15128','2013-04-18','13:45:00',4.16),('15128','2013-04-18','13:50:00',4.17),('15128','2013-04-18','13:55:00',4.16),('15128','2013-04-18','14:00:00',4.18),('15128','2013-04-18','14:05:00',4.17),('15128','2013-04-18','14:10:00',4.17),('15128','2013-04-18','14:15:00',4.15),('15128','2013-04-18','14:20:00',4.14),('15128','2013-04-18','14:25:00',4.11),('15128','2013-04-18','14:30:00',4.09),('15128','2013-04-18','14:35:00',4.08),('15128','2013-04-18','14:40:00',4.07),('15128','2013-04-18','14:45:00',4.09),('15128','2013-04-18','14:50:00',4.05),('15128','2013-04-18','14:55:00',4.02),('15128','2013-04-18','15:00:00',3.98),('15128','2013-04-18','15:05:00',3.95),('15128','2013-04-18','15:10:00',3.92),('15128','2013-04-18','15:15:00',3.88),('15128','2013-04-18','15:20:00',3.84),('15128','2013-04-18','15:25:00',3.8),('15128','2013-04-18','15:30:00',3.8),('15128','2013-04-18','15:35:00',3.78),('15128','2013-04-18','15:40:00',3.76),('15128','2013-04-18','15:45:00',3.72),('15128','2013-04-18','15:50:00',3.68),('15128','2013-04-18','15:55:00',3.61),('15128','2013-04-18','16:00:00',3.56),('15128','2013-04-18','16:05:00',3.53),('15128','2013-04-18','16:10:00',3.45),('15128','2013-04-18','16:15:00',3.39),('15128','2013-04-18','16:20:00',3.3),('15128','2013-04-18','16:25:00',3.22),('15128','2013-04-18','16:30:00',3.16),('15128','2013-04-18','16:35:00',3.11),('15128','2013-04-18','16:40:00',3.02),('15128','2013-04-18','16:45:00',2.95),('15128','2013-04-18','16:50:00',2.87),('15128','2013-04-18','16:55:00',2.8),('15128','2013-04-18','17:00:00',2.72),('15128','2013-04-18','17:05:00',2.64),('15128','2013-04-18','17:10:00',2.57),('15128','2013-04-18','17:15:00',2.51),('15128','2013-04-18','17:20:00',2.43),('15128','2013-04-18','17:25:00',2.27),('15128','2013-04-18','17:30:00',2.16),('15128','2013-04-18','17:35:00',2.05),('15128','2013-04-18','17:40:00',1.96),('15128','2013-04-18','17:45:00',1.86),('15128','2013-04-18','17:50:00',1.72),('15128','2013-04-18','17:55:00',1.67),('15128','2013-04-18','18:00:00',1.61),('15128','2013-04-18','18:05:00',1.56),('15128','2013-04-18','18:10:00',1.47),('15128','2013-04-18','18:15:00',1.4),('15128','2013-04-18','18:20:00',1.31),('15128','2013-04-18','18:25:00',1.18),('15128','2013-04-18','18:30:00',1.04),('15128','2013-04-17','09:10:00',1.01),('15128','2013-04-17','09:15:00',1.25),('15128','2013-04-17','09:20:00',1.4),('15128','2013-04-17','09:25:00',1.33),('15128','2013-04-17','09:30:00',1.32),('15128','2013-04-17','09:35:00',1.31),('15128','2013-04-17','09:40:00',1.2),('15128','2013-04-17','09:45:00',1.48),('15128','2013-04-17','09:50:00',2.03),('15128','2013-04-17','09:55:00',1.98),('15128','2013-04-17','10:00:00',1.98),('15128','2013-04-17','10:05:00',2.11),('15128','2013-04-17','10:10:00',2.15),('15128','2013-04-17','10:15:00',2.16),('15128','2013-04-17','10:20:00',2.3),('15128','2013-04-17','10:25:00',2.38),('15128','2013-04-17','10:30:00',2.54),('15128','2013-04-17','10:35:00',2.6),('15128','2013-04-17','10:40:00',2.65),('15128','2013-04-17','10:45:00',2.65),('15128','2013-04-17','10:50:00',2.73),('15128','2013-04-17','10:55:00',2.74),('15128','2013-04-17','11:00:00',2.85),('15128','2013-04-17','11:05:00',2.85),('15128','2013-04-17','11:10:00',2.92),('15128','2013-04-17','11:15:00',3.05),('15128','2013-04-17','11:20:00',3.07),('15128','2013-04-17','11:25:00',3.16),('15128','2013-04-17','11:30:00',3.21),('15128','2013-04-17','11:35:00',3.25),('15128','2013-04-17','11:40:00',3.42),('15128','2013-04-17','11:45:00',3.5),('15128','2013-04-17','11:50:00',3.64),('15128','2013-04-17','11:55:00',3.76),('15128','2013-04-17','12:00:00',3.67),('15128','2013-04-17','12:05:00',3.89),('15128','2013-04-17','12:10:00',3.94),('15128','2013-04-17','12:15:00',3.91),('15128','2013-04-17','12:20:00',4.01),('15128','2013-04-17','12:25:00',4.05),('15128','2013-04-17','12:30:00',4.07),('15128','2013-04-17','12:35:00',4.1),('15128','2013-04-17','12:40:00',4.12),('15128','2013-04-17','12:45:00',4.12),('15128','2013-04-17','12:50:00',4.14),('15128','2013-04-17','12:55:00',4.15),('15128','2013-04-17','13:00:00',4.16),('15128','2013-04-17','13:05:00',4.17),('15128','2013-04-17','13:10:00',4.18),('15128','2013-04-17','13:15:00',4.2),('15128','2013-04-17','13:20:00',4.21),('15128','2013-04-17','13:25:00',4.22),('15128','2013-04-17','13:30:00',4.25),('15128','2013-04-17','13:35:00',4.24),('15128','2013-04-17','13:40:00',4.23),('15128','2013-04-17','13:45:00',4.24),('15128','2013-04-17','13:50:00',4.26),('15128','2013-04-17','13:55:00',4.27),('15128','2013-04-17','14:00:00',4.26),('15128','2013-04-17','14:05:00',4.28),('15128','2013-04-17','14:10:00',4.28),('15128','2013-04-17','14:15:00',4.29),('15128','2013-04-17','14:20:00',4.26),('15128','2013-04-17','14:25:00',4.26),('15128','2013-04-17','14:30:00',4.25),('15128','2013-04-17','14:35:00',4.21),('15128','2013-04-17','14:40:00',4.19),('15128','2013-04-17','14:45:00',4.17),('15128','2013-04-17','14:50:00',4.14),('15128','2013-04-17','14:55:00',4.13),('15128','2013-04-17','15:00:00',4.09),('15128','2013-04-17','15:05:00',4.08),('15128','2013-04-17','15:10:00',4.05),('15128','2013-04-17','15:15:00',4),('15128','2013-04-17','15:20:00',3.97),('15128','2013-04-17','15:25:00',3.93),('15128','2013-04-17','15:30:00',3.88),('15128','2013-04-17','15:35:00',3.83),('15128','2013-04-17','15:40:00',3.81),('15128','2013-04-17','15:45:00',3.76),('15128','2013-04-17','15:50:00',3.71),('15128','2013-04-17','15:55:00',3.66),('15128','2013-04-17','16:00:00',3.59),('15128','2013-04-17','16:05:00',3.54),('15128','2013-04-17','16:10:00',3.47),('15128','2013-04-17','16:15:00',3.41),('15128','2013-04-17','16:20:00',3.35),('15128','2013-04-17','16:25:00',3.28),('15128','2013-04-17','16:30:00',3.26),('15128','2013-04-17','16:35:00',3.18),('15128','2013-04-17','16:40:00',3.13),('15128','2013-04-17','16:45:00',3.06),('15128','2013-04-17','16:50:00',2.97),('15128','2013-04-17','16:55:00',2.86),('15128','2013-04-17','17:00:00',2.8),('15128','2013-04-17','17:05:00',2.72),('15128','2013-04-17','17:10:00',2.64),('15128','2013-04-17','17:15:00',2.57),('15128','2013-04-17','17:20:00',2.5),('15128','2013-04-17','17:25:00',2.42),('15128','2013-04-17','17:30:00',2.28),('15128','2013-04-17','17:35:00',2.2),('15128','2013-04-17','17:40:00',2.06),('15128','2013-04-17','17:45:00',1.95),('15128','2013-04-17','17:50:00',1.84),('15128','2013-04-17','17:55:00',1.77),('15128','2013-04-17','18:00:00',1.71),('15128','2013-04-17','18:05:00',1.66),('15128','2013-04-17','18:10:00',1.54),('15128','2013-04-17','18:15:00',1.45),('15128','2013-04-17','18:20:00',1.33),('15128','2013-04-17','18:25:00',1.19),('15128','2013-04-17','18:30:00',1.09),('15128','2013-04-16','08:35:00',1.07),('15128','2013-04-16','08:40:00',1.14),('15128','2013-04-16','09:25:00',1.7),('15128','2013-04-16','09:30:00',1.77),('15128','2013-04-16','09:35:00',1.83),('15128','2013-04-16','09:40:00',1.9),('15128','2013-04-16','09:45:00',1.95),('15128','2013-04-16','09:50:00',2),('15128','2013-04-16','09:55:00',2.04),('15128','2013-04-16','10:00:00',2.11),('15128','2013-04-16','10:05:00',2.2),('15128','2013-04-16','10:10:00',2.27),('15128','2013-04-16','10:15:00',2.29),('15128','2013-04-16','10:20:00',2.38),('15128','2013-04-16','10:25:00',2.48),('15128','2013-04-16','10:30:00',2.53),('15128','2013-04-16','10:35:00',2.63),('15128','2013-04-16','10:40:00',2.71),('15128','2013-04-16','10:45:00',2.73),('15128','2013-04-16','10:50:00',2.76),('15128','2013-04-16','10:55:00',2.8),('15128','2013-04-16','11:00:00',2.9),('15128','2013-04-16','11:05:00',2.87),('15128','2013-04-16','11:10:00',2.82),('15128','2013-04-16','11:15:00',2.95),('15128','2013-04-16','11:20:00',3.08),('15128','2013-04-16','11:25:00',3.18),('15128','2013-04-16','11:30:00',3.25),('15128','2013-04-16','11:35:00',3.29),('15128','2013-04-16','11:40:00',3.42),('15128','2013-04-16','11:45:00',3.52),('15128','2013-04-16','11:50:00',3.63),('15128','2013-04-16','11:55:00',3.71),('15128','2013-04-16','12:00:00',3.83),('15128','2013-04-16','12:05:00',3.88),('15128','2013-04-16','12:10:00',3.89),('15128','2013-04-16','12:15:00',3.93),('15128','2013-04-16','12:20:00',3.96),('15128','2013-04-16','12:25:00',3.99),('15128','2013-04-16','12:30:00',4.02),('15128','2013-04-16','12:35:00',4.03),('15128','2013-04-16','12:40:00',4.07),('15128','2013-04-16','12:45:00',4.12),('15128','2013-04-16','12:50:00',4.18),('15128','2013-04-16','12:55:00',4.22),('15128','2013-04-16','13:00:00',4.19),('15128','2013-04-16','13:05:00',4.21),('15128','2013-04-16','13:10:00',4.25),('15128','2013-04-16','13:15:00',4.31),('15128','2013-04-16','13:20:00',4.22),('15128','2013-04-16','13:25:00',4.32),('15128','2013-04-16','13:30:00',4.35),('15128','2013-04-16','13:35:00',4.38),('15128','2013-04-16','13:40:00',4.49),('15128','2013-04-16','13:45:00',4.2),('15128','2013-04-16','13:50:00',3.99),('15128','2013-04-16','13:55:00',3.96),('15128','2013-04-16','14:00:00',3.75),('15128','2013-04-16','14:05:00',3.98),('15128','2013-04-16','14:10:00',4.71),('15128','2013-04-16','14:15:00',4.5),('15128','2013-04-16','14:20:00',4.35),('15128','2013-04-16','14:25:00',3.52),('15128','2013-04-16','14:30:00',4.33),('15128','2013-04-16','14:35:00',4.63),('15128','2013-04-16','14:40:00',4.29),('15128','2013-04-16','14:45:00',2.07),('15128','2013-04-16','14:50:00',3.57),('15128','2013-04-16','14:55:00',3.08),('15128','2013-04-16','15:00:00',4.6),('15128','2013-04-16','15:05:00',4.69),('15128','2013-04-16','15:10:00',4.65),('15128','2013-04-16','15:15:00',4.39),('15128','2013-04-16','15:20:00',2.53),('15128','2013-04-16','15:25:00',1.8),('15128','2013-04-16','15:30:00',2.88),('15128','2013-04-16','15:35:00',3.64),('15128','2013-04-16','15:40:00',3.8),('15128','2013-04-16','15:45:00',3.19),('15128','2013-04-16','15:50:00',3.35),('15128','2013-04-16','15:55:00',2.94),('15128','2013-04-16','16:00:00',3.22),('15128','2013-04-16','16:05:00',3.37),('15128','2013-04-16','16:10:00',3.68),('15128','2013-04-16','16:15:00',3.6),('15128','2013-04-16','16:20:00',3.48),('15128','2013-04-16','16:25:00',3.43),('15128','2013-04-16','16:30:00',3.35),('15128','2013-04-16','16:35:00',2.91),('15128','2013-04-16','16:40:00',2.51),('15128','2013-04-16','16:45:00',3.03),('15128','2013-04-16','16:50:00',3.05),('15128','2013-04-16','16:55:00',2.96),('15128','2013-04-16','17:00:00',2.88),('15128','2013-04-16','17:05:00',2.82),('15128','2013-04-16','17:10:00',2.72),('15128','2013-04-16','17:15:00',2.61),('15128','2013-04-16','17:20:00',2.53),('15128','2013-04-16','17:25:00',2.44),('15128','2013-04-16','17:30:00',2.31),('15128','2013-04-16','17:35:00',2.23),('15128','2013-04-16','17:40:00',2.1),('15128','2013-04-16','17:45:00',2),('15128','2013-04-16','17:50:00',1.92),('15128','2013-04-16','17:55:00',1.85),('15128','2013-04-16','18:00:00',1.76),('15128','2013-04-16','18:05:00',1.7),('15128','2013-04-16','18:10:00',1.61),('15128','2013-04-16','18:15:00',1.53),('15128','2013-04-16','18:20:00',1.43),('15128','2013-04-16','18:25:00',1.3),('15128','2013-04-16','18:30:00',1.17),('15128','2013-04-16','18:35:00',1.09),('15128','2013-04-15','09:05:00',1.37),('15128','2013-04-15','09:10:00',1.42),('15128','2013-04-15','09:15:00',1.6),('15128','2013-04-15','09:20:00',2),('15128','2013-04-15','09:25:00',1.45),('15128','2013-04-15','09:30:00',1.3),('15128','2013-04-15','09:35:00',1.4),('15128','2013-04-15','09:40:00',1.67),('15128','2013-04-15','09:45:00',1.56),('15128','2013-04-15','09:50:00',1.5),('15128','2013-04-15','09:55:00',1.48),('15128','2013-04-15','10:00:00',1.51),('15128','2013-04-15','10:05:00',1.45),('15128','2013-04-15','10:10:00',1.42),('15128','2013-04-15','10:15:00',1.45),('15128','2013-04-15','10:20:00',1.42),('15128','2013-04-15','10:25:00',1.43),('15128','2013-04-15','10:30:00',1.46),('15128','2013-04-15','10:35:00',1.54),('15128','2013-04-15','10:40:00',1.62),('15128','2013-04-15','10:45:00',1.69),('15128','2013-04-15','10:50:00',1.71),('15128','2013-04-15','10:55:00',1.68),('15128','2013-04-15','11:00:00',1.66),('15128','2013-04-15','11:05:00',1.71),('15128','2013-04-15','11:10:00',1.8),('15128','2013-04-15','11:15:00',1.82),('15128','2013-04-15','11:20:00',1.84),('15128','2013-04-15','11:25:00',1.84),('15128','2013-04-15','11:30:00',1.7),('15128','2013-04-15','11:35:00',1.72),('15128','2013-04-15','11:40:00',2.03),('15128','2013-04-15','11:45:00',2.31),('15128','2013-04-15','11:50:00',2.47),('15128','2013-04-15','11:55:00',2.7),('15128','2013-04-15','12:00:00',3.1),('15128','2013-04-15','12:05:00',3.35),('15128','2013-04-15','12:10:00',3.01),('15128','2013-04-15','12:15:00',3.02),('15128','2013-04-15','12:20:00',3.62),('15128','2013-04-15','12:25:00',3.66),('15128','2013-04-15','12:30:00',4.12),('15128','2013-04-15','12:35:00',3.27),('15128','2013-04-15','12:40:00',2.49),('15128','2013-04-15','12:45:00',2.44),('15128','2013-04-15','12:50:00',3.56),('15128','2013-04-15','12:55:00',3.85),('15128','2013-04-15','13:00:00',3.95),('15128','2013-04-15','13:05:00',3.87),('15128','2013-04-15','13:10:00',3.99),('15128','2013-04-15','13:15:00',3.97),('15128','2013-04-15','13:20:00',4.06),('15128','2013-04-15','13:25:00',4.08),('15128','2013-04-15','13:30:00',4.15),('15128','2013-04-15','13:35:00',4.04),('15128','2013-04-15','13:40:00',4.1),('15128','2013-04-15','13:45:00',4.09),('15128','2013-04-15','13:50:00',4.09),('15128','2013-04-15','13:55:00',4.22),('15128','2013-04-15','14:00:00',4.18),('15128','2013-04-15','14:05:00',4.16),('15128','2013-04-15','14:10:00',4.27),('15128','2013-04-15','14:15:00',4.32),('15128','2013-04-15','14:20:00',4.25),('15128','2013-04-15','14:25:00',3.51),('15128','2013-04-15','14:30:00',2.87),('15128','2013-04-15','14:35:00',3.68),('15128','2013-04-15','14:40:00',4.14),('15128','2013-04-15','14:45:00',4.11),('15128','2013-04-15','14:50:00',4.15),('15128','2013-04-15','14:55:00',3.83),('15128','2013-04-15','15:00:00',4.14),('15128','2013-04-15','15:05:00',4.16),('15128','2013-04-15','15:10:00',4.07),('15128','2013-04-15','15:15:00',2.94),('15128','2013-04-15','15:20:00',3.29),('15128','2013-04-15','15:25:00',3.3),('15128','2013-04-15','15:30:00',3.52),('15128','2013-04-15','15:35:00',3.78),('15128','2013-04-15','15:40:00',3.66),('15128','2013-04-15','15:45:00',3.65),('15128','2013-04-15','15:50:00',3.66),('15128','2013-04-15','15:55:00',3.53),('15128','2013-04-15','16:00:00',3.51),('15128','2013-04-15','16:05:00',3.45),('15128','2013-04-15','16:10:00',3.46),('15128','2013-04-15','16:15:00',3.38),('15128','2013-04-15','16:20:00',3.23),('15128','2013-04-15','16:25:00',3.27),('15128','2013-04-15','16:30:00',3.19),('15128','2013-04-15','16:35:00',3.12),('15128','2013-04-15','16:40:00',3.16),('15128','2013-04-15','16:45:00',3.02),('15128','2013-04-15','16:50:00',2.71),('15128','2013-04-15','16:55:00',2.84),('15128','2013-04-15','17:00:00',2.83),('15128','2013-04-15','17:05:00',2.73),('15128','2013-04-15','17:10:00',2.67),('15128','2013-04-15','17:15:00',2.56),('15128','2013-04-15','17:20:00',2.49),('15128','2013-04-15','17:25:00',2.33),('15128','2013-04-15','17:30:00',2.22),('15128','2013-04-15','17:35:00',2.13),('15128','2013-04-15','17:40:00',2.03),('15128','2013-04-15','17:45:00',1.92),('15128','2013-04-15','17:50:00',1.84),('15128','2013-04-15','17:55:00',1.95),('15128','2013-04-15','18:00:00',1.92),('15128','2013-04-15','18:05:00',1.78),('15128','2013-04-15','18:10:00',1.33),('15128','2013-04-15','18:15:00',1.38),('15128','2013-04-15','18:20:00',1.24),('15128','2013-04-15','18:25:00',1.14),('15128','2013-04-15','18:30:00',1.02),('15128','2013-04-14','08:35:00',1.02),('15128','2013-04-14','08:40:00',1.12),('15128','2013-04-14','08:45:00',1.17),('15128','2013-04-14','08:50:00',1.23),('15128','2013-04-14','08:55:00',1.31),('15128','2013-04-14','09:00:00',1.41),('15128','2013-04-14','09:05:00',1.5),('15128','2013-04-14','09:10:00',1.55),('15128','2013-04-14','09:15:00',1.61),('15128','2013-04-14','09:20:00',1.69),('15128','2013-04-14','09:25:00',1.77),('15128','2013-04-14','09:30:00',1.84),('15128','2013-04-14','09:35:00',1.9),('15128','2013-04-14','09:40:00',1.95),('15128','2013-04-14','09:45:00',2),('15128','2013-04-14','09:50:00',1.99),('15128','2013-04-14','09:55:00',2.03),('15128','2013-04-14','10:00:00',2.1),('15128','2013-04-14','10:05:00',2.2),('15128','2013-04-14','10:10:00',2.26),('15128','2013-04-14','10:15:00',2.32),('15128','2013-04-14','10:20:00',2.36),('15128','2013-04-14','10:25:00',2.47),('15128','2013-04-14','10:30:00',2.47),('15128','2013-04-14','10:35:00',2.6),('15128','2013-04-14','10:40:00',2.7),('15128','2013-04-14','10:45:00',2.76),('15128','2013-04-14','10:50:00',2.82),('15128','2013-04-14','10:55:00',2.82),('15128','2013-04-14','11:00:00',2.88),('15128','2013-04-14','11:05:00',2.89),('15128','2013-04-14','11:10:00',2.94),('15128','2013-04-14','11:15:00',3),('15128','2013-04-14','11:20:00',3.09),('15128','2013-04-14','11:25:00',3.1),('15128','2013-04-14','11:30:00',3.2),('15128','2013-04-14','11:35:00',3.19),('15128','2013-04-14','11:40:00',3.31),('15128','2013-04-14','11:45:00',3.36),('15128','2013-04-14','11:50:00',3.59),('15128','2013-04-14','11:55:00',3.7),('15128','2013-04-14','12:00:00',3.76),('15128','2013-04-14','12:05:00',3.79),('15128','2013-04-14','12:10:00',3.84),('15128','2013-04-14','12:15:00',3.88),('15128','2013-04-14','12:20:00',3.93),('15128','2013-04-14','12:25:00',3.99),('15128','2013-04-14','12:30:00',4),('15128','2013-04-14','12:35:00',4.01),('15128','2013-04-14','12:40:00',4.01),('15128','2013-04-14','12:45:00',4.08),('15128','2013-04-14','12:50:00',4.09),('15128','2013-04-14','12:55:00',4.11),('15128','2013-04-14','13:00:00',4.13),('15128','2013-04-14','13:05:00',4.15),('15128','2013-04-14','13:10:00',4.18),('15128','2013-04-14','13:15:00',4.17),('15128','2013-04-14','13:20:00',4.17),('15128','2013-04-14','13:25:00',4.17),('15128','2013-04-14','13:30:00',4.2),('15128','2013-04-14','13:35:00',4.19),('15128','2013-04-14','13:40:00',4.21),('15128','2013-04-14','13:45:00',4.26),('15128','2013-04-14','13:50:00',4.28),('15128','2013-04-14','13:55:00',4.3),('15128','2013-04-14','14:00:00',4.32),('15128','2013-04-14','14:05:00',4.37),('15128','2013-04-14','14:10:00',4.34),('15128','2013-04-14','14:15:00',4.34),('15128','2013-04-14','14:20:00',4.31),('15128','2013-04-14','14:25:00',4.3),('15128','2013-04-14','14:30:00',4.29),('15128','2013-04-14','14:35:00',4.23),('15128','2013-04-14','14:40:00',4.21),('15128','2013-04-14','14:45:00',4.2),('15128','2013-04-14','14:50:00',4.19),('15128','2013-04-14','14:55:00',4.15),('15128','2013-04-14','15:00:00',4.11),('15128','2013-04-14','15:05:00',4.09),('15128','2013-04-14','15:10:00',4.08),('15128','2013-04-14','15:15:00',4.06),('15128','2013-04-14','15:20:00',4.01),('15128','2013-04-14','15:25:00',3.98),('15128','2013-04-14','15:30:00',3.95),('15128','2013-04-14','15:35:00',3.91),('15128','2013-04-14','15:40:00',3.86),('15128','2013-04-14','15:45:00',3.82),('15128','2013-04-14','15:50:00',3.76),('15128','2013-04-14','15:55:00',3.71),('15128','2013-04-14','16:00:00',3.64),('15128','2013-04-14','16:05:00',3.58),('15128','2013-04-14','16:10:00',3.52),('15128','2013-04-14','16:15:00',3.47),('15128','2013-04-14','16:20:00',3.42),('15128','2013-04-14','16:25:00',3.36),('15128','2013-04-14','16:30:00',3.3),('15128','2013-04-14','16:35:00',3.22),('15128','2013-04-14','16:40:00',3.16),('15128','2013-04-14','16:45:00',3.11),('15128','2013-04-14','16:50:00',3.03),('15128','2013-04-14','16:55:00',2.95),('15128','2013-04-14','17:00:00',2.88),('15128','2013-04-14','17:05:00',2.8),('15128','2013-04-14','17:10:00',2.73),('15128','2013-04-14','17:15:00',2.63),('15128','2013-04-14','17:20:00',2.51),('15128','2013-04-14','17:25:00',2.38),('15128','2013-04-14','17:30:00',2.29),('15128','2013-04-14','17:35:00',2.18),('15128','2013-04-14','17:40:00',2.08),('15128','2013-04-14','17:45:00',2.02),('15128','2013-04-14','17:50:00',1.95),('15128','2013-04-14','17:55:00',1.86),('15128','2013-04-14','18:00:00',1.77),('15128','2013-04-14','18:05:00',1.7),('15128','2013-04-14','18:10:00',1.61),('15128','2013-04-14','18:15:00',1.54),('15128','2013-04-14','18:20:00',1.44),('15128','2013-04-14','18:25:00',1.31),('15128','2013-04-14','18:30:00',1.16),('15128','2013-04-14','18:35:00',1.09),('15128','2013-04-13','08:40:00',1.07),('15128','2013-04-13','08:45:00',1.14),('15128','2013-04-13','08:50:00',1.19),('15128','2013-04-13','08:55:00',1.23),('15128','2013-04-13','09:00:00',1.31),('15128','2013-04-13','09:05:00',1.4),('15128','2013-04-13','09:10:00',1.45),('15128','2013-04-13','09:15:00',1.51),('15128','2013-04-13','09:20:00',1.52),('15128','2013-04-13','09:25:00',1.64),('15128','2013-04-13','09:30:00',1.73),('15128','2013-04-13','09:35:00',1.8),('15128','2013-04-13','09:40:00',1.88),('15128','2013-04-13','09:45:00',1.96),('15128','2013-04-13','09:50:00',1.93),('15128','2013-04-13','09:55:00',1.97),('15128','2013-04-13','10:00:00',2.02),('15128','2013-04-13','10:05:00',2.11),('15128','2013-04-13','10:10:00',2.2),('15128','2013-04-13','10:15:00',2.27),('15128','2013-04-13','10:20:00',2.32),('15128','2013-04-13','10:25:00',2.42),('15128','2013-04-13','10:30:00',2.44),('15128','2013-04-13','10:35:00',2.53),('15128','2013-04-13','10:40:00',2.61),('15128','2013-04-13','10:45:00',2.68),('15128','2013-04-13','10:50:00',2.68),('15128','2013-04-13','10:55:00',2.76),('15128','2013-04-13','11:00:00',2.8),('15128','2013-04-13','11:05:00',2.85),('15128','2013-04-13','11:10:00',2.9),('15128','2013-04-13','11:15:00',2.95),('15128','2013-04-13','11:20:00',3.03),('15128','2013-04-13','11:25:00',3.02),('15128','2013-04-13','11:30:00',3.13),('15128','2013-04-13','11:35:00',3.1),('15128','2013-04-13','11:40:00',3.25),('15128','2013-04-13','11:45:00',3.24),('15128','2013-04-13','11:50:00',3.39),('15128','2013-04-13','11:55:00',3.58),('15128','2013-04-13','12:00:00',3.64),('15128','2013-04-13','12:05:00',3.74),('15128','2013-04-13','12:10:00',3.75),('15128','2013-04-13','12:15:00',3.77),('15128','2013-04-13','12:20:00',3.82),('15128','2013-04-13','12:25:00',3.86),('15128','2013-04-13','12:30:00',3.91),('15128','2013-04-13','12:35:00',3.99),('15128','2013-04-13','12:40:00',4.01),('15128','2013-04-13','12:45:00',3.98),('15128','2013-04-13','12:50:00',4),('15128','2013-04-13','12:55:00',4.04),('15128','2013-04-13','13:00:00',4.15),('15128','2013-04-13','13:05:00',4.12),('15128','2013-04-13','13:10:00',4.11),('15128','2013-04-13','13:15:00',4.22),('15128','2013-04-13','13:20:00',4.18),('15128','2013-04-13','13:25:00',4.18),('15128','2013-04-13','13:30:00',4.15),('15128','2013-04-13','13:35:00',4.19),('15128','2013-04-13','13:40:00',3.87),('15128','2013-04-13','13:45:00',1.59),('15128','2013-04-13','13:50:00',2.6),('15128','2013-04-13','13:55:00',4.38),('15128','2013-04-13','14:00:00',4.14),('15128','2013-04-13','14:05:00',4.1),('15128','2013-04-13','14:10:00',4.1),('15128','2013-04-13','14:15:00',4.04),('15128','2013-04-13','14:20:00',4.03),('15128','2013-04-13','14:25:00',3.99),('15128','2013-04-13','14:30:00',3.98),('15128','2013-04-13','14:35:00',3.98),('15128','2013-04-13','14:40:00',3.96),('15128','2013-04-13','14:45:00',3.97),('15128','2013-04-13','14:50:00',4.01),('15128','2013-04-13','14:55:00',4.03),('15128','2013-04-13','15:00:00',4.03),('15128','2013-04-13','15:05:00',4),('15128','2013-04-13','15:10:00',4.01),('15128','2013-04-13','15:15:00',3.95),('15128','2013-04-13','15:20:00',3.85),('15128','2013-04-13','15:25:00',3.87),('15128','2013-04-13','15:30:00',3.84),('15128','2013-04-13','15:35:00',3.75),('15128','2013-04-13','15:40:00',3.73),('15128','2013-04-13','15:45:00',3.71),('15128','2013-04-13','15:50:00',3.63),('15128','2013-04-13','15:55:00',3.55),('15128','2013-04-13','16:00:00',3.47),('15128','2013-04-13','16:05:00',3.41),('15128','2013-04-13','16:10:00',3.36),('15128','2013-04-13','16:15:00',3.32),('15128','2013-04-13','16:20:00',3.27),('15128','2013-04-13','16:25:00',3.24),('15128','2013-04-13','16:30:00',3.19),('15128','2013-04-13','16:35:00',3.1),('15128','2013-04-13','16:40:00',3.05),('15128','2013-04-13','16:45:00',2.98),('15128','2013-04-13','16:50:00',2.9),('15128','2013-04-13','16:55:00',2.83),('15128','2013-04-13','17:00:00',2.76),('15128','2013-04-13','17:05:00',2.71),('15128','2013-04-13','17:10:00',2.63),('15128','2013-04-13','17:15:00',2.54),('15128','2013-04-13','17:20:00',2.41),('15128','2013-04-13','17:25:00',2.28),('15128','2013-04-13','17:30:00',2.18),('15128','2013-04-13','17:35:00',2.1),('15128','2013-04-13','17:40:00',2),('15128','2013-04-13','17:45:00',1.92),('15128','2013-04-13','17:50:00',1.83),('15128','2013-04-13','17:55:00',1.75),('15128','2013-04-13','18:00:00',1.7),('15128','2013-04-13','18:05:00',1.63),('15128','2013-04-13','18:10:00',1.54),('15128','2013-04-13','18:15:00',1.43),('15128','2013-04-13','18:20:00',1.33),('15128','2013-04-13','18:25:00',1.21),('15128','2013-04-13','18:30:00',1.09),('15128','2013-04-13','18:35:00',1),('15128','2013-04-12','08:45:00',1.11),('15128','2013-04-12','08:50:00',1.15),('15128','2013-04-12','08:55:00',1.22),('15128','2013-04-12','09:00:00',1.27),('15128','2013-04-12','09:05:00',1.38),('15128','2013-04-12','09:10:00',1.45),('15128','2013-04-12','09:15:00',1.49),('15128','2013-04-12','09:20:00',1.53),('15128','2013-04-12','09:25:00',1.62),('15128','2013-04-12','09:30:00',1.73),('15128','2013-04-12','09:35:00',1.73),('15128','2013-04-12','09:40:00',1.96),('15128','2013-04-12','09:45:00',2.05),('15128','2013-04-12','09:50:00',2.09),('15128','2013-04-12','09:55:00',2.2),('15128','2013-04-12','10:00:00',2.22),('15128','2013-04-12','10:05:00',2.35),('15128','2013-04-12','10:10:00',2.68),('15128','2013-04-12','10:15:00',2.81),('15128','2013-04-12','10:20:00',2.89),('15128','2013-04-12','10:25:00',2.99),('15128','2013-04-12','10:30:00',2.92),('15128','2013-04-12','10:35:00',2.81),('15128','2013-04-12','10:40:00',2.74),('15128','2013-04-12','10:45:00',2.07),('15128','2013-04-12','10:50:00',1.68),('15128','2013-04-12','10:55:00',2.45),('15128','2013-04-12','11:00:00',3.35),('15128','2013-04-12','11:05:00',2.11),('15128','2013-04-12','11:10:00',2.6),('15128','2013-04-12','11:15:00',3.46),('15128','2013-04-12','11:20:00',1.38),('15128','2013-04-12','11:25:00',3.29),('15128','2013-04-12','11:30:00',2.76),('15128','2013-04-12','11:35:00',2.37),('15128','2013-04-12','11:40:00',3.19),('15128','2013-04-12','11:45:00',1.5),('15128','2013-04-12','11:50:00',3.46),('15128','2013-04-12','11:55:00',4.01),('15128','2013-04-12','12:00:00',4.04),('15128','2013-04-12','12:05:00',2.62),('15128','2013-04-12','12:10:00',2.36),('15128','2013-04-12','12:15:00',4.18),('15128','2013-04-12','12:20:00',3.59),('15128','2013-04-12','12:25:00',4.32),('15128','2013-04-12','12:30:00',3.8),('15128','2013-04-12','12:35:00',4.2),('15128','2013-04-12','12:40:00',3.93),('15128','2013-04-12','12:45:00',4.11),('15128','2013-04-12','12:50:00',4.19),('15128','2013-04-12','12:55:00',4),('15128','2013-04-12','13:00:00',4.07),('15128','2013-04-12','13:05:00',3.96),('15128','2013-04-12','13:10:00',4.05),('15128','2013-04-12','13:15:00',3.99),('15128','2013-04-12','13:20:00',3.99),('15128','2013-04-12','13:25:00',4.06),('15128','2013-04-12','13:30:00',3.79),('15128','2013-04-12','13:35:00',3.85),('15128','2013-04-12','13:40:00',3.66),('15128','2013-04-12','13:45:00',3.71),('15128','2013-04-12','13:50:00',3.55),('15128','2013-04-12','13:55:00',3.52),('15128','2013-04-12','14:00:00',3.62),('15128','2013-04-12','14:05:00',3.63),('15128','2013-04-12','14:10:00',3.57),('15128','2013-04-12','14:15:00',3.58),('15128','2013-04-12','14:20:00',3.57),('15128','2013-04-12','14:25:00',3.8),('15128','2013-04-12','14:30:00',4.03),('15128','2013-04-12','14:35:00',4),('15128','2013-04-12','14:40:00',3.94),('15128','2013-04-12','14:45:00',3.84),('15128','2013-04-12','14:50:00',3.74),('15128','2013-04-12','14:55:00',3.56),('15128','2013-04-12','15:00:00',3.49),('15128','2013-04-12','15:05:00',3.55),('15128','2013-04-12','15:10:00',3.39),('15128','2013-04-12','15:15:00',3.08),('15128','2013-04-12','15:20:00',3.05),('15128','2013-04-12','15:25:00',3.11),('15128','2013-04-12','15:30:00',2.96),('15128','2013-04-12','15:35:00',3.18),('15128','2013-04-12','15:40:00',3.14),('15128','2013-04-12','15:45:00',3.22),('15128','2013-04-12','15:50:00',3.32),('15128','2013-04-12','15:55:00',2.87),('15128','2013-04-12','16:00:00',2.84),('15128','2013-04-12','16:05:00',2.84),('15128','2013-04-12','16:10:00',2.92),('15128','2013-04-12','16:15:00',2.76),('15128','2013-04-12','16:20:00',2.5),('15128','2013-04-12','16:25:00',2.27),('15128','2013-04-12','16:30:00',2.27),('15128','2013-04-12','16:35:00',1.97),('15128','2013-04-12','16:40:00',2.03),('15128','2013-04-12','16:45:00',2.14),('15128','2013-04-12','16:50:00',1.86),('15128','2013-04-12','16:55:00',1.49),('15128','2013-04-12','17:00:00',1.98),('15128','2013-04-12','17:05:00',2.73),('15128','2013-04-12','17:10:00',2.58),('15128','2013-04-12','17:15:00',2.17),('15128','2013-04-12','17:20:00',2.33),('15128','2013-04-12','17:25:00',2.24),('15128','2013-04-12','17:30:00',2.01),('15128','2013-04-12','17:35:00',2.1),('15128','2013-04-12','17:40:00',1.98),('15128','2013-04-12','17:45:00',1.73),('15128','2013-04-12','17:50:00',1.67),('15128','2013-04-12','17:55:00',1.69),('15128','2013-04-12','18:00:00',1.42),('15128','2013-04-12','18:05:00',1.54),('15128','2013-04-12','18:10:00',1.41),('15128','2013-04-12','18:15:00',1.46),('15128','2013-04-12','18:20:00',1.35),('15128','2013-04-12','18:25:00',1.27),('15128','2013-04-12','18:30:00',1.14),('15128','2013-04-12','18:35:00',1.02),('15128','2013-04-11','09:05:00',1.01),('15128','2013-04-11','09:10:00',1.58),('15128','2013-04-11','09:15:00',2.06),('15128','2013-04-11','09:20:00',1.43),('15128','2013-04-11','09:25:00',1.11),('15128','2013-04-11','09:30:00',1.35),('15128','2013-04-11','09:35:00',1.07),('15128','2013-04-11','09:50:00',1.15),('15128','2013-04-11','09:55:00',1.32),('15128','2013-04-11','10:00:00',1.09),('15128','2013-04-11','10:05:00',1.12),('15128','2013-04-11','10:10:00',1.04),('15128','2013-04-11','10:20:00',1.01),('15128','2013-04-11','10:25:00',1.57),('15128','2013-04-11','10:30:00',2),('15128','2013-04-11','10:35:00',1.83),('15128','2013-04-11','10:40:00',1.53),('15128','2013-04-11','10:45:00',1.57),('15128','2013-04-11','10:50:00',1.28),('15128','2013-04-11','10:55:00',1.65),('15128','2013-04-11','11:00:00',1.75),('15128','2013-04-11','11:05:00',2.28),('15128','2013-04-11','11:10:00',1.55),('15128','2013-04-11','11:15:00',3.73),('15128','2013-04-11','11:20:00',3.79),('15128','2013-04-11','11:25:00',3.19),('15128','2013-04-11','11:30:00',3.54),('15128','2013-04-11','11:35:00',3.41),('15128','2013-04-11','11:40:00',3.53),('15128','2013-04-11','11:45:00',3.13),('15128','2013-04-11','11:50:00',2.5),('15128','2013-04-11','11:55:00',3.76),('15128','2013-04-11','12:00:00',4.01),('15128','2013-04-11','12:05:00',3.86),('15128','2013-04-11','12:10:00',3.9),('15128','2013-04-11','12:15:00',4.04),('15128','2013-04-11','12:20:00',3.92),('15128','2013-04-11','12:25:00',4.05),('15128','2013-04-11','12:30:00',4.04),('15128','2013-04-11','12:35:00',4.01),('15128','2013-04-11','12:40:00',4.05),('15128','2013-04-11','12:45:00',3.88),('15128','2013-04-11','12:50:00',4.2),('15128','2013-04-11','12:55:00',4.28),('15128','2013-04-11','13:00:00',4.16),('15128','2013-04-11','13:05:00',4.2),('15128','2013-04-11','13:10:00',4.3),('15128','2013-04-11','13:15:00',4.25),('15128','2013-04-11','13:20:00',4.29),('15128','2013-04-11','13:25:00',4.24),('15128','2013-04-11','13:30:00',4.24),('15128','2013-04-11','13:35:00',4.27),('15128','2013-04-11','13:40:00',3.92),('15128','2013-04-11','13:45:00',4.14),('15128','2013-04-11','13:50:00',4.23),('15128','2013-04-11','13:55:00',4.25),('15128','2013-04-11','14:00:00',4.25),('15128','2013-04-11','14:05:00',4.24),('15128','2013-04-11','14:10:00',4.23),('15128','2013-04-11','14:15:00',4.24),('15128','2013-04-11','14:20:00',4.22),('15128','2013-04-11','14:25:00',4.19),('15128','2013-04-11','14:30:00',4.18),('15128','2013-04-11','14:35:00',4.13),('15128','2013-04-11','14:40:00',4.11),('15128','2013-04-11','14:45:00',4.1),('15128','2013-04-11','14:50:00',4.07),('15128','2013-04-11','14:55:00',4.04),('15128','2013-04-11','15:00:00',4.03),('15128','2013-04-11','15:05:00',4),('15128','2013-04-11','15:10:00',3.96),('15128','2013-04-11','15:15:00',3.94),('15128','2013-04-11','15:20:00',3.91),('15128','2013-04-11','15:25:00',3.86),('15128','2013-04-11','15:30:00',3.83),('15128','2013-04-11','15:35:00',3.8),('15128','2013-04-11','15:40:00',3.74),('15128','2013-04-11','15:45:00',3.69),('15128','2013-04-11','15:50:00',3.64),('15128','2013-04-11','15:55:00',3.62),('15128','2013-04-11','16:00:00',3.59),('15128','2013-04-11','16:05:00',3.57),('15128','2013-04-11','16:10:00',2.82),('15128','2013-04-11','16:15:00',3.4),('15128','2013-04-11','16:20:00',3.33),('15128','2013-04-11','16:25:00',3.28),('15128','2013-04-11','16:30:00',3.28),('15128','2013-04-11','16:35:00',2.88),('15128','2013-04-11','16:40:00',3.19),('15128','2013-04-11','16:45:00',3.08),('15128','2013-04-11','16:50:00',2.96),('15128','2013-04-11','16:55:00',2.56),('15128','2013-04-11','17:00:00',2.1),('15128','2013-04-11','17:05:00',3.17),('15128','2013-04-11','17:10:00',2.61),('15128','2013-04-11','17:15:00',2.84),('15128','2013-04-11','17:20:00',2.64),('15128','2013-04-11','17:25:00',2.65),('15128','2013-04-11','17:30:00',2.33),('15128','2013-04-11','17:35:00',2.06),('15128','2013-04-11','17:40:00',2.03),('15128','2013-04-11','17:45:00',1.91),('15128','2013-04-11','17:50:00',1.87),('15128','2013-04-11','17:55:00',1.73),('15128','2013-04-11','18:00:00',1.7),('15128','2014-03-27','08:05:00',1.04),('15128','2014-03-27','08:10:00',1.12),('15128','2014-03-27','08:15:00',1.19),('15128','2014-03-27','08:20:00',1.26),('15128','2014-03-27','08:25:00',1.36),('15128','2014-03-27','08:30:00',1.41),('15128','2014-03-27','08:35:00',1.48),('15128','2014-03-27','08:40:00',1.56),('15128','2014-03-27','08:45:00',1.56),('15128','2014-03-27','08:50:00',1.74),('15128','2014-03-27','08:55:00',1.88),('15128','2014-03-27','09:00:00',2.03),('15128','2014-03-27','09:05:00',2.02),('15128','2014-03-27','09:10:00',1.96),('15128','2014-03-27','09:15:00',2.19),('15128','2014-03-27','09:20:00',2.44),('15128','2014-03-27','09:25:00',1.87),('15128','2014-03-27','09:30:00',1.29),('15128','2014-03-27','09:35:00',1.56),('15128','2014-03-27','09:40:00',2.12),('15128','2014-03-27','09:45:00',2.56),('15128','2014-03-27','09:50:00',2.43),('15128','2014-03-27','09:55:00',2.64),('15128','2014-03-27','10:00:00',2.29),('15128','2014-03-27','10:05:00',1.54),('15128','2014-03-27','10:10:00',2.13),('15128','2014-03-27','10:15:00',2.58),('15128','2014-03-27','10:20:00',2.49),('15128','2014-03-27','10:25:00',2.23),('15128','2014-03-27','10:30:00',2.2),('15128','2014-03-27','10:35:00',2.97),('15128','2014-03-27','10:40:00',3.06),('15128','2014-03-27','10:45:00',3.05),('15128','2014-03-27','10:50:00',3.12),('15128','2014-03-27','10:55:00',3.13),('15128','2014-03-27','11:00:00',3.3),('15128','2014-03-27','11:05:00',3.42),('15128','2014-03-27','11:10:00',3.59),('15128','2014-03-27','11:15:00',3.64),('15128','2014-03-27','11:20:00',3.67),('15128','2014-03-27','11:25:00',3.68),('15128','2014-03-27','11:30:00',3.71),('15128','2014-03-27','11:35:00',3.74),('15128','2014-03-27','11:40:00',3.77),('15128','2014-03-27','11:45:00',3.79),('15128','2014-03-27','11:50:00',3.84),('15128','2014-03-27','11:55:00',3.3),('15128','2014-03-27','12:00:00',4.01),('15128','2014-03-27','12:05:00',4.04),('15128','2014-03-27','12:10:00',3.95),('15128','2014-03-27','12:15:00',4.06),('15128','2014-03-27','12:20:00',4.09),('15128','2014-03-27','12:25:00',2.55),('15128','2014-03-27','12:30:00',1.21),('15128','2014-03-27','12:35:00',2.83),('15128','2014-03-27','12:40:00',4.52),('15128','2014-03-27','12:45:00',2.19),('15128','2014-03-27','12:50:00',3.57),('15128','2014-03-27','12:55:00',3.16),('15128','2014-03-27','13:00:00',1.9),('15128','2014-03-27','13:05:00',3.07),('15128','2014-03-27','13:10:00',3.49),('15128','2014-03-27','13:15:00',2.24),('15128','2014-03-27','13:20:00',2.98),('15128','2014-03-27','13:25:00',2.38),('15128','2014-03-27','13:30:00',3.01),('15128','2014-03-27','13:35:00',3.98),('15128','2014-03-27','13:40:00',4.05),('15128','2014-03-27','13:45:00',3.98),('15128','2014-03-27','13:50:00',3.93),('15128','2014-03-27','13:55:00',3.93),('15128','2014-03-27','14:00:00',3.87),('15128','2014-03-27','14:05:00',3.83),('15128','2014-03-27','14:10:00',3.81),('15128','2014-03-27','14:15:00',3.79),('15128','2014-03-27','14:20:00',3.76),('15128','2014-03-27','14:25:00',3.72),('15128','2014-03-27','14:30:00',3.67),('15128','2014-03-27','14:35:00',3.64),('15128','2014-03-27','14:40:00',3.66),('15128','2014-03-27','14:45:00',3.61),('15128','2014-03-27','14:50:00',3.57),('15128','2014-03-27','14:55:00',3.54),('15128','2014-03-27','15:00:00',3.46),('15128','2014-03-27','15:05:00',3.4),('15128','2014-03-27','15:10:00',3.33),('15128','2014-03-27','15:15:00',3.26),('15128','2014-03-27','15:20:00',3.21),('15128','2014-03-27','15:25:00',3.15),('15128','2014-03-27','15:30:00',3.1),('15128','2014-03-27','15:35:00',3.16),('15128','2014-03-27','15:40:00',3.04),('15128','2014-03-27','15:45:00',3),('15128','2014-03-27','15:50:00',3.1),('15128','2014-03-27','15:55:00',3.21),('15128','2014-03-27','16:00:00',3.2),('15128','2014-03-27','16:05:00',2.99),('15128','2014-03-27','16:10:00',2.73),('15128','2014-03-27','16:15:00',2.52),('15128','2014-03-27','16:20:00',1.75),('15128','2014-03-27','16:30:00',1.28),('15128','2014-03-27','16:50:00',1.74),('15128','2014-03-27','16:55:00',1.75),('15128','2014-03-27','17:00:00',1.59),('15128','2014-03-27','17:05:00',1.24),('15128','2014-03-27','17:10:00',1.05),('15128','2014-03-27','17:15:00',1.03),('15128','2014-03-27','17:20:00',1.14),('15128','2014-03-27','17:25:00',1.03),('15128','2013-04-10','08:45:00',1.09),('15128','2013-04-10','08:50:00',1.15),('15128','2013-04-10','08:55:00',1.21),('15128','2013-04-10','09:00:00',1.26),('15128','2013-04-10','09:05:00',1.34),('15128','2013-04-10','09:10:00',1.43),('15128','2013-04-10','09:15:00',1.48),('15128','2013-04-10','09:20:00',1.56),('15128','2013-04-10','09:25:00',1.66),('15128','2013-04-10','09:30:00',1.71),('15128','2013-04-10','09:35:00',1.77),('15128','2013-04-10','09:40:00',1.92),('15128','2013-04-10','09:45:00',1.92),('15128','2013-04-10','09:50:00',1.56),('15128','2013-04-10','09:55:00',2.16),('15128','2013-04-10','10:00:00',1.04),('15128','2013-04-10','10:05:00',2.25),('15128','2013-04-10','10:10:00',2.61),('15128','2013-04-10','10:15:00',2.63),('15128','2013-04-10','10:20:00',2.55),('15128','2013-04-10','10:25:00',1.75),('15128','2013-04-10','10:30:00',2.89),('15128','2013-04-10','10:35:00',2.79),('15128','2013-04-10','10:40:00',2.02),('15128','2013-04-10','10:50:00',1.14),('15128','2013-04-10','10:55:00',1.33),('15128','2013-04-10','11:00:00',2.96),('15128','2013-04-10','11:05:00',3.63),('15128','2013-04-10','11:10:00',3.54),('15128','2013-04-10','11:15:00',3.58),('15128','2013-04-10','11:20:00',2.5),('15128','2013-04-10','11:25:00',1.75),('15128','2013-04-10','11:30:00',1.74),('15128','2013-04-10','11:35:00',1.6),('15128','2013-04-10','11:40:00',1.33),('15128','2013-04-10','11:45:00',1.9),('15128','2013-04-10','11:50:00',4.32),('15128','2013-04-10','11:55:00',4.47),('15128','2013-04-10','12:00:00',4.3),('15128','2013-04-10','12:05:00',4.24),('15128','2013-04-10','12:10:00',4.25),('15128','2013-04-10','12:15:00',4.31),('15128','2013-04-10','12:20:00',4.42),('15128','2013-04-10','12:25:00',2.94),('15128','2013-04-10','12:30:00',2.09),('15128','2013-04-10','12:35:00',4.06),('15128','2013-04-10','12:40:00',1.26),('15128','2013-04-10','12:45:00',4.57),('15128','2013-04-10','12:50:00',4.42),('15128','2013-04-10','12:55:00',4.33),('15128','2013-04-10','13:00:00',2.2),('15128','2013-04-10','13:05:00',4.73),('15128','2013-04-10','13:10:00',4.15),('15128','2013-04-10','13:15:00',2.99),('15128','2013-04-10','13:20:00',4.53),('15128','2013-04-10','13:25:00',3.26),('15128','2013-04-10','13:30:00',4.11),('15128','2013-04-10','13:35:00',4.43),('15128','2013-04-10','13:40:00',4.43),('15128','2013-04-10','13:45:00',4.44),('15128','2013-04-10','13:50:00',4.12),('15128','2013-04-10','13:55:00',3.77),('15128','2013-04-10','14:00:00',4.49),('15128','2013-04-10','14:05:00',4.31),('15128','2013-04-10','14:10:00',4.38),('15128','2013-04-10','14:15:00',4.39),('15128','2013-04-10','14:20:00',4.28),('15128','2013-04-10','14:25:00',4.39),('15128','2013-04-10','14:30:00',4.34),('15128','2013-04-10','14:35:00',4.33),('15128','2013-04-10','14:40:00',2.73),('15128','2013-04-10','14:45:00',2.32),('15128','2013-04-10','14:50:00',3.93),('15128','2013-04-10','14:55:00',4.24),('15128','2013-04-10','15:00:00',3.89),('15128','2013-04-10','15:05:00',3.98),('15128','2013-04-10','15:10:00',3.99),('15128','2013-04-10','15:15:00',4),('15128','2013-04-10','15:20:00',3.95),('15128','2013-04-10','15:25:00',3.92),('15128','2013-04-10','15:30:00',3.87),('15128','2013-04-10','15:35:00',3.86),('15128','2013-04-10','15:40:00',3.82),('15128','2013-04-10','15:45:00',3.77),('15128','2013-04-10','15:50:00',3.73),('15128','2013-04-10','15:55:00',3.69),('15128','2013-04-10','16:00:00',3.65),('15128','2013-04-10','16:05:00',3.58),('15128','2013-04-10','16:10:00',3.52),('15128','2013-04-10','16:15:00',3.46),('15128','2013-04-10','16:20:00',3.42),('15128','2013-04-10','16:25:00',3.36),('15128','2013-04-10','16:30:00',3.29),('15128','2013-04-10','16:35:00',3.22),('15128','2013-04-10','16:40:00',3.17),('15128','2013-04-10','16:45:00',3.1),('15128','2013-04-10','16:50:00',3.05),('15128','2013-04-10','16:55:00',2.96),('15128','2013-04-10','17:00:00',2.88),('15128','2013-04-10','17:05:00',2.81),('15128','2013-04-10','17:10:00',2.7),('15128','2013-04-10','17:15:00',2.6),('15128','2013-04-10','17:20:00',2.44),('15128','2013-04-10','17:25:00',2.36),('15128','2013-04-10','17:30:00',2.24),('15128','2013-04-10','17:35:00',2.08),('15128','2013-04-10','17:40:00',2.03),('15128','2013-04-10','17:45:00',1.98),('15128','2013-04-10','17:50:00',1.89),('15128','2013-04-10','17:55:00',1.81),('15128','2013-04-10','18:00:00',1.68),('15128','2013-04-10','18:05:00',1.6),('15128','2013-04-10','18:10:00',1.44),('15128','2013-04-10','18:15:00',1.48),('15128','2013-04-10','18:20:00',1.38),('15128','2013-04-10','18:25:00',1.24),('15128','2013-04-10','18:30:00',1.09),('15128','2013-04-10','18:35:00',1.05),('15128','2013-04-09','08:50:00',1.16),('15128','2013-04-09','08:55:00',1.25),('15128','2013-04-09','09:00:00',1.28),('15128','2013-04-09','09:05:00',1.38),('15128','2013-04-09','09:10:00',1.32),('15128','2013-04-09','09:15:00',1.2),('15128','2013-04-09','09:20:00',1.56),('15128','2013-04-09','09:25:00',1.65),('15128','2013-04-09','09:30:00',1.24),('15128','2013-04-09','09:35:00',1.39),('15128','2013-04-09','09:40:00',1.9),('15128','2013-04-09','09:45:00',2.09),('15128','2013-04-09','09:50:00',1.97),('15128','2013-04-09','09:55:00',1.7),('15128','2013-04-09','10:00:00',2.3),('15128','2013-04-09','10:05:00',2.52),('15128','2013-04-09','10:10:00',2.7),('15128','2013-04-09','10:15:00',2.65),('15128','2013-04-09','10:20:00',2.61),('15128','2013-04-09','10:25:00',2.54),('15128','2013-04-09','10:30:00',2.59),('15128','2013-04-09','10:35:00',2.93),('15128','2013-04-09','10:40:00',3.03),('15128','2013-04-09','10:45:00',2.87),('15128','2013-04-09','10:50:00',1.61),('15128','2013-04-09','10:55:00',2.66),('15128','2013-04-09','11:00:00',1.38),('15128','2013-04-09','11:05:00',1.54),('15128','2013-04-09','11:10:00',1.76),('15128','2013-04-09','11:15:00',1),('15128','2013-04-09','11:20:00',2.33),('15128','2013-04-09','11:25:00',3.14),('15128','2013-04-09','11:30:00',3.06),('15128','2013-04-09','11:35:00',2.89),('15128','2013-04-09','11:40:00',2.37),('15128','2013-04-09','11:45:00',3.18),('15128','2013-04-09','11:50:00',2.33),('15128','2013-04-09','11:55:00',3.81),('15128','2013-04-09','12:00:00',2.05),('15128','2013-04-09','12:05:00',2.43),('15128','2013-04-09','12:10:00',4.38),('15128','2013-04-09','12:15:00',4.8),('15128','2013-04-09','12:20:00',4.76),('15128','2013-04-09','12:25:00',4.34),('15128','2013-04-09','12:30:00',4.32),('15128','2013-04-09','12:35:00',3.97),('15128','2013-04-09','12:40:00',2.74),('15128','2013-04-09','12:45:00',3.98),('15128','2013-04-09','12:50:00',4.46),('15128','2013-04-09','12:55:00',4.51),('15128','2013-04-09','13:00:00',4.34),('15128','2013-04-09','13:05:00',3.58),('15128','2013-04-09','13:10:00',3.87),('15128','2013-04-09','13:15:00',3.86),('15128','2013-04-09','13:20:00',4.53),('15128','2013-04-09','13:25:00',3.67),('15128','2013-04-09','13:30:00',3.09),('15128','2013-04-09','13:35:00',4.72),('15128','2013-04-09','13:40:00',4.68),('15128','2013-04-09','13:45:00',4.6),('15128','2013-04-09','13:50:00',3.96),('15128','2013-04-09','13:55:00',3.38),('15128','2013-04-09','14:00:00',2.23),('15128','2013-04-09','14:05:00',4.93),('15128','2013-04-09','14:10:00',3.2),('15128','2013-04-09','14:15:00',4.38),('15128','2013-04-09','14:20:00',2.54),('15128','2013-04-09','14:25:00',2.08),('15128','2013-04-09','14:30:00',2.39),('15128','2013-04-09','14:35:00',4.23),('15128','2013-04-09','14:40:00',1.94),('15128','2013-04-09','14:45:00',4.7),('15128','2013-04-09','14:50:00',2.04),('15128','2013-04-09','14:55:00',4.67),('15128','2013-04-09','15:00:00',4.39),('15128','2013-04-09','15:05:00',3.46),('15128','2013-04-09','15:10:00',4.09),('15128','2013-04-09','15:15:00',4.23),('15128','2013-04-09','15:20:00',3.5),('15128','2013-04-09','15:25:00',3.25),('15128','2013-04-09','15:30:00',3.79),('15128','2013-04-09','15:35:00',3.94),('15128','2013-04-09','15:40:00',3.88),('15128','2013-04-09','15:45:00',3.9),('15128','2013-04-09','15:50:00',2.98),('15128','2013-04-09','15:55:00',3.76),('15128','2013-04-09','16:00:00',3.68),('15128','2013-04-09','16:05:00',3.72),('15128','2013-04-09','16:10:00',3.39),('15128','2013-04-09','16:15:00',3),('15128','2013-04-09','16:20:00',1.75),('15128','2013-04-09','16:25:00',1.73),('15128','2013-04-09','16:30:00',1.64),('15128','2013-04-09','16:35:00',2.31),('15128','2013-04-09','16:40:00',1.62),('15128','2013-04-09','16:45:00',1.9),('15128','2013-04-09','16:50:00',1.39),('15128','2013-04-09','16:55:00',1.88),('15128','2013-04-09','17:05:00',1.52),('15128','2013-04-09','17:10:00',1.15),('15128','2013-04-09','17:15:00',2.69),('15128','2013-04-09','17:20:00',2.94),('15128','2013-04-09','17:25:00',2.85),('15128','2013-04-09','17:30:00',2.3),('15128','2013-04-09','17:35:00',1.16),('15128','2013-04-09','17:40:00',2.08),('15128','2013-04-09','17:45:00',2.29),('15128','2013-04-09','17:50:00',2.15),('15128','2013-04-09','17:55:00',1.71),('15128','2013-04-09','18:00:00',2.03),('15128','2013-04-09','18:05:00',1.79),('15128','2013-04-09','18:10:00',1.71),('15128','2013-04-09','18:15:00',1.59),('15128','2013-04-09','18:20:00',1.38),('15128','2013-04-09','18:25:00',1.42),('15128','2013-04-09','18:30:00',1.09),('15128','2013-04-09','18:35:00',1.49),('15128','2013-04-09','18:40:00',1.24),('15128','2013-04-08','08:45:00',1.09),('15128','2013-04-08','08:50:00',1.26),('15128','2013-04-08','08:55:00',1.29),('15128','2013-04-08','09:00:00',1.44),('15128','2013-04-08','09:25:00',1.08),('15128','2013-04-08','09:30:00',2.08),('15128','2013-04-08','09:35:00',2.35),('15128','2013-04-08','09:40:00',1.33),('15128','2013-04-08','09:45:00',1.31),('15128','2013-04-08','09:50:00',2.22),('15128','2013-04-08','09:55:00',2.08),('15128','2013-04-08','10:00:00',2.36),('15128','2013-04-08','10:05:00',1.36),('15128','2013-04-08','10:10:00',2.55),('15128','2013-04-08','10:15:00',2.33),('15128','2013-04-08','10:20:00',2.26),('15128','2013-04-08','10:25:00',1.23),('15128','2013-04-08','10:30:00',2.77),('15128','2013-04-08','10:35:00',3.5),('15128','2013-04-08','10:40:00',3.13),('15128','2013-04-08','10:45:00',2.06),('15128','2013-04-08','10:50:00',3.57),('15128','2013-04-08','10:55:00',2.97),('15128','2013-04-08','11:00:00',2.82),('15128','2013-04-08','11:05:00',4.02),('15128','2013-04-08','11:10:00',2.46),('15128','2013-04-08','11:15:00',2.9),('15128','2013-04-08','11:20:00',2.95),('15128','2013-04-08','11:25:00',2.1),('15128','2013-04-08','11:30:00',3.76),('15128','2013-04-08','11:35:00',1.99),('15128','2013-04-08','11:40:00',1.21),('15128','2013-04-08','11:50:00',2.67),('15128','2013-04-08','11:55:00',3.16),('15128','2013-04-08','12:00:00',4.76),('15128','2013-04-08','12:05:00',4.05),('15128','2013-04-08','12:10:00',4.47),('15128','2013-04-08','12:15:00',4.37),('15128','2013-04-08','12:20:00',2.88),('15128','2013-04-08','12:25:00',3.09),('15128','2013-04-08','12:30:00',2.6),('15128','2013-04-08','12:35:00',1.74),('15128','2013-04-08','12:40:00',1.37),('15128','2013-04-08','12:45:00',2.75),('15128','2013-04-08','12:50:00',1.5),('15128','2013-04-08','12:55:00',3.6),('15128','2013-04-08','13:00:00',4.17),('15128','2013-04-08','13:05:00',3.03),('15128','2013-04-08','13:10:00',2.68),('15128','2013-04-08','13:15:00',3.4),('15128','2013-04-08','13:20:00',3.88),('15128','2013-04-08','13:25:00',3.24),('15128','2013-04-08','13:30:00',1.47),('15128','2013-04-08','13:35:00',2.29),('15128','2013-04-08','13:40:00',3.19),('15128','2013-04-08','13:45:00',4.1),('15128','2013-04-08','13:50:00',2.91),('15128','2013-04-08','13:55:00',4.18),('15128','2013-04-08','14:00:00',4.1),('15128','2013-04-08','14:05:00',4.51),('15128','2013-04-08','14:10:00',4.29),('15128','2013-04-08','14:15:00',3.33),('15128','2013-04-08','14:20:00',3.28),('15128','2013-04-08','14:25:00',3.71),('15128','2013-04-08','14:30:00',3.94),('15128','2013-04-08','14:35:00',4.22),('15128','2013-04-08','14:40:00',3.9),('15128','2013-04-08','14:45:00',3.63),('15128','2013-04-08','14:50:00',4.13),('15128','2013-04-08','14:55:00',4.16),('15128','2013-04-08','15:00:00',4.29),('15128','2013-04-08','15:05:00',4.09),('15128','2013-04-08','15:10:00',3.97),('15128','2013-04-08','15:15:00',3.99),('15128','2013-04-08','15:20:00',4.13),('15128','2013-04-08','15:25:00',4.15),('15128','2013-04-08','15:30:00',4.1),('15128','2013-04-08','15:35:00',3.94),('15128','2013-04-08','15:40:00',4),('15128','2013-04-08','15:45:00',3.87),('15128','2013-04-08','15:50:00',3.58),('15128','2013-04-08','15:55:00',3.22),('15128','2013-04-08','16:00:00',3.33),('15128','2013-04-08','16:05:00',3.77),('15128','2013-04-08','16:10:00',3.58),('15128','2013-04-08','16:15:00',3.35),('15128','2013-04-08','16:20:00',3.4),('15128','2013-04-08','16:25:00',3.19),('15128','2013-04-08','16:30:00',2.86),('15128','2013-04-08','16:35:00',2.99),('15128','2013-04-08','16:40:00',2.61),('15128','2013-04-08','16:45:00',3.1),('15128','2013-04-08','16:50:00',3.01),('15128','2013-04-08','16:55:00',2.68),('15128','2013-04-08','17:00:00',2.86),('15128','2013-04-08','17:05:00',3.02),('15128','2013-04-08','17:10:00',2.6),('15128','2013-04-08','17:15:00',2.67),('15128','2013-04-08','17:20:00',2.58),('15128','2013-04-08','17:25:00',2.29),('15128','2013-04-08','17:30:00',2),('15128','2013-04-08','17:35:00',1.59),('15128','2013-04-08','17:40:00',1.33),('15128','2013-04-08','17:45:00',1.09),('15128','2013-04-08','17:55:00',1.14),('15128','2013-04-08','18:00:00',1.28),('15128','2013-04-08','18:05:00',1.03),('15128','2013-04-08','18:10:00',1.14),('15128','2013-04-08','18:15:00',1.38),('15128','2013-04-07','08:55:00',1.07),('15128','2013-04-07','09:05:00',1.2),('15128','2013-04-07','09:10:00',1.24),('15128','2013-04-07','09:15:00',1.27),('15128','2013-04-07','09:20:00',1.32),('15128','2013-04-07','09:25:00',1.42),('15128','2013-04-07','09:30:00',1.79),('15128','2013-04-07','09:35:00',1.95),('15128','2013-04-07','09:40:00',2.02),('15128','2013-04-07','09:45:00',1.95),('15128','2013-04-07','09:50:00',1.03),('15128','2013-04-07','09:55:00',1.7),('15128','2013-04-07','10:00:00',2.18),('15128','2013-04-07','10:05:00',1.69),('15128','2013-04-07','10:10:00',1.99),('15128','2013-04-07','10:15:00',2.24),('15128','2013-04-07','10:20:00',2.37),('15128','2013-04-07','10:25:00',2.23),('15128','2013-04-07','10:30:00',2.4),('15128','2013-04-07','10:35:00',2.47),('15128','2013-04-07','10:40:00',2.66),('15128','2013-04-07','10:45:00',2.74),('15128','2013-04-07','10:50:00',2.84),('15128','2013-04-07','10:55:00',2.7),('15128','2013-04-07','11:00:00',2.66),('15128','2013-04-07','11:05:00',2.63),('15128','2013-04-07','11:10:00',2.74),('15128','2013-04-07','11:15:00',2.44),('15128','2013-04-07','11:20:00',2.08),('15128','2013-04-07','11:25:00',2.16),('15128','2013-04-07','11:30:00',2.41),('15128','2013-04-07','11:35:00',2.43),('15128','2013-04-07','11:40:00',2.44),('15128','2013-04-07','11:45:00',2.55),('15128','2013-04-07','11:50:00',2.5),('15128','2013-04-07','11:55:00',2.6),('15128','2013-04-07','12:00:00',2.36),('15128','2013-04-07','12:05:00',2.5),('15128','2013-04-07','12:10:00',2.94),('15128','2013-04-07','12:15:00',2.98),('15128','2013-04-07','12:20:00',2.95),('15128','2013-04-07','12:25:00',3.07),('15128','2013-04-07','12:30:00',3.12),('15128','2013-04-07','12:35:00',3.28),('15128','2013-04-07','12:40:00',3.32),('15128','2013-04-07','12:45:00',3.09),('15128','2013-04-07','12:50:00',3.28),('15128','2013-04-07','12:55:00',3.54),('15128','2013-04-07','13:00:00',3.66),('15128','2013-04-07','13:05:00',3.02),('15128','2013-04-07','13:10:00',3.68),('15128','2013-04-07','13:15:00',3.1),('15128','2013-04-07','13:20:00',3.88),('15128','2013-04-07','13:25:00',3.67),('15128','2013-04-07','13:30:00',2.47),('15128','2013-04-07','13:35:00',1.79),('15128','2013-04-07','13:40:00',3.1),('15128','2013-04-07','13:45:00',3.72),('15128','2013-04-07','13:50:00',3.21),('15128','2013-04-07','13:55:00',3.45),('15128','2013-04-07','14:00:00',3.77),('15128','2013-04-07','14:05:00',3.92),('15128','2013-04-07','14:10:00',4.21),('15128','2013-04-07','14:15:00',3.34),('15128','2013-04-07','14:20:00',3.88),('15128','2013-04-07','14:25:00',3.96),('15128','2013-04-07','14:30:00',3.54),('15128','2013-04-07','14:35:00',3.84),('15128','2013-04-07','14:40:00',3.9),('15128','2013-04-07','14:45:00',4.08),('15128','2013-04-07','14:50:00',4.11),('15128','2013-04-07','14:55:00',3.87),('15128','2013-04-07','15:00:00',3.26),('15128','2013-04-07','15:05:00',3.83),('15128','2013-04-07','15:10:00',3.5),('15128','2013-04-07','15:15:00',3.52),('15128','2013-04-07','15:20:00',3.96),('15128','2013-04-07','15:25:00',3.99),('15128','2013-04-07','15:30:00',3.89),('15128','2013-04-07','15:35:00',3.86),('15128','2013-04-07','15:40:00',3.84),('15128','2013-04-07','15:45:00',3.82),('15128','2013-04-07','15:50:00',3.74),('15128','2013-04-07','15:55:00',3.69),('15128','2013-04-07','16:00:00',3.64),('15128','2013-04-07','16:05:00',3.39),('15128','2013-04-07','16:10:00',3.46),('15128','2013-04-07','16:15:00',3.55),('15128','2013-04-07','16:20:00',3.43),('15128','2013-04-07','16:25:00',3.35),('15128','2013-04-07','16:30:00',3.32),('15128','2013-04-07','16:35:00',3.24),('15128','2013-04-07','16:40:00',3.19),('15128','2013-04-07','16:45:00',3.12),('15128','2013-04-07','16:50:00',3.05),('15128','2013-04-07','16:55:00',2.97),('15128','2013-04-07','17:00:00',2.93),('15128','2013-04-07','17:05:00',2.84),('15128','2013-04-07','17:10:00',2.73),('15128','2013-04-07','17:15:00',2.6),('15128','2013-04-07','17:20:00',2.45),('15128','2013-04-07','17:25:00',2.43),('15128','2013-04-07','17:30:00',2.21),('15128','2013-04-07','17:35:00',2.06),('15128','2013-04-07','17:40:00',1.77),('15128','2013-04-07','17:45:00',1.77),('15128','2013-04-07','17:50:00',1.36),('15128','2013-04-07','17:55:00',1.4),('15128','2013-04-07','18:00:00',1.46),('15128','2013-04-07','18:10:00',1.01),('15128','2013-04-07','18:15:00',1.65),('15128','2013-04-07','18:20:00',1.77),('15128','2013-04-07','18:25:00',1.28),('15128','2013-04-06','08:55:00',1.01),('15128','2013-04-06','09:00:00',1.07),('15128','2013-04-06','09:05:00',1.09),('15128','2013-04-06','09:10:00',1.13),('15128','2013-04-06','09:15:00',1.1),('15128','2013-04-06','09:20:00',1.12),('15128','2013-04-06','09:25:00',1.13),('15128','2013-04-06','09:30:00',1.26),('15128','2013-04-06','09:35:00',1.42),('15128','2013-04-06','09:40:00',1.51),('15128','2013-04-06','09:45:00',1.53),('15128','2013-04-06','09:50:00',1.53),('15128','2013-04-06','09:55:00',1.41),('15128','2013-04-06','10:00:00',1.33),('15128','2013-04-06','10:05:00',1.56),('15128','2013-04-06','10:10:00',1.63),('15128','2013-04-06','10:15:00',1.76),('15128','2013-04-06','10:20:00',2.11),('15128','2013-04-06','10:25:00',2.25),('15128','2013-04-06','10:30:00',2.28),('15128','2013-04-06','10:35:00',2.37),('15128','2013-04-06','10:40:00',2.47),('15128','2013-04-06','10:45:00',2.29),('15128','2013-04-06','10:50:00',2.21),('15128','2013-04-06','10:55:00',2.34),('15128','2013-04-06','11:00:00',2.19),('15128','2013-04-06','11:05:00',2.16),('15128','2013-04-06','11:10:00',2.26),('15128','2013-04-06','11:15:00',2.04),('15128','2013-04-06','11:20:00',1.92),('15128','2013-04-06','11:25:00',1.98),('15128','2013-04-06','11:30:00',2.32),('15128','2013-04-06','11:35:00',3.05),('15128','2013-04-06','11:40:00',3.6),('15128','2013-04-06','11:45:00',3.6),('15128','2013-04-06','11:50:00',3.78),('15128','2013-04-06','11:55:00',3.56),('15128','2013-04-06','12:00:00',3.11),('15128','2013-04-06','12:05:00',2.71),('15128','2013-04-06','12:10:00',2.76),('15128','2013-04-06','12:15:00',2.75),('15128','2013-04-06','12:20:00',2.78),('15128','2013-04-06','12:25:00',3.07),('15128','2013-04-06','12:30:00',3.13),('15128','2013-04-06','12:35:00',3.4),('15128','2013-04-06','12:40:00',3.36),('15128','2013-04-06','12:45:00',3.02),('15128','2013-04-06','12:50:00',3.36),('15128','2013-04-06','12:55:00',3.11),('15128','2013-04-06','13:00:00',3.13),('15128','2013-04-06','13:05:00',3.09),('15128','2013-04-06','13:10:00',2.99),('15128','2013-04-06','13:15:00',3.31),('15128','2013-04-06','13:20:00',3.27),('15128','2013-04-06','13:25:00',3.2),('15128','2013-04-06','13:30:00',2.97),('15128','2013-04-06','13:35:00',3.11),('15128','2013-04-06','13:40:00',3.52),('15128','2013-04-06','13:45:00',3.92),('15128','2013-04-06','13:50:00',3.62),('15128','2013-04-06','13:55:00',3.23),('15128','2013-04-06','14:00:00',2.76),('15128','2013-04-06','14:05:00',2.86),('15128','2013-04-06','14:10:00',2.83),('15128','2013-04-06','14:15:00',2.95),('15128','2013-04-06','14:20:00',3.12),('15128','2013-04-06','14:25:00',3.06),('15128','2013-04-06','14:30:00',3.12),('15128','2013-04-06','14:35:00',2.84),('15128','2013-04-06','14:40:00',2.75),('15128','2013-04-06','14:45:00',2.57),('15128','2013-04-06','14:50:00',2.39),('15128','2013-04-06','14:55:00',2.53),('15128','2013-04-06','15:00:00',2.56),('15128','2013-04-06','15:05:00',2.59),('15128','2013-04-06','15:10:00',2.69),('15128','2013-04-06','15:15:00',2.74),('15128','2013-04-06','15:20:00',2.86),('15128','2013-04-06','15:25:00',2.88),('15128','2013-04-06','15:30:00',2.79),('15128','2013-04-06','15:35:00',2.85),('15128','2013-04-06','15:40:00',2.85),('15128','2013-04-06','15:45:00',2.8),('15128','2013-04-06','15:50:00',2.46),('15128','2013-04-06','15:55:00',1.59),('15128','2013-04-06','16:00:00',1.35),('15128','2013-04-06','16:05:00',1.31),('15128','2013-04-06','16:10:00',1.36),('15128','2013-04-06','16:15:00',1.34),('15128','2013-04-06','16:20:00',1.72),('15128','2013-04-06','16:25:00',1.97),('15128','2013-04-06','16:30:00',1.46),('15128','2013-04-06','16:35:00',1.46),('15128','2013-04-06','16:40:00',1.36),('15128','2013-04-06','16:45:00',1.12),('15128','2013-04-06','16:50:00',1.11),('15128','2013-04-06','16:55:00',1.14),('15128','2013-04-06','17:00:00',1.19),('15128','2013-04-06','17:05:00',1.71),('15128','2013-04-06','17:10:00',1.27),('15128','2013-04-06','17:15:00',1.82),('15128','2013-04-06','17:20:00',2.09),('15128','2013-04-06','17:25:00',1.45),('15128','2013-04-06','17:30:00',1.76),('15128','2013-04-06','17:40:00',1.84),('15128','2013-04-06','17:45:00',1.76),('15128','2013-04-06','17:50:00',1.27),('15128','2013-04-05','08:50:00',1.08),('15128','2013-04-05','08:55:00',1.17),('15128','2013-04-05','09:00:00',1.23),('15128','2013-04-05','09:05:00',1.28),('15128','2013-04-05','09:10:00',1.34),('15128','2013-04-05','09:15:00',1.44),('15128','2013-04-05','09:20:00',1.52),('15128','2013-04-05','09:25:00',1.56),('15128','2013-04-05','09:30:00',1.64),('15128','2013-04-05','09:35:00',1.73),('15128','2013-04-05','09:40:00',1.79),('15128','2013-04-05','09:45:00',1.88),('15128','2013-04-05','09:50:00',1.96),('15128','2013-04-05','09:55:00',1.67),('15128','2013-04-05','10:00:00',1.64),('15128','2013-04-05','10:05:00',1.92),('15128','2013-04-05','10:15:00',1.44),('15128','2013-04-05','10:25:00',1.84),('15128','2013-04-05','10:30:00',2.41),('15128','2013-04-05','10:35:00',2.49),('15128','2013-04-05','10:40:00',2.43),('15128','2013-04-05','10:45:00',2.49),('15128','2013-04-05','10:50:00',2.55),('15128','2013-04-05','10:55:00',2.65),('15128','2013-04-05','11:00:00',2.72),('15128','2013-04-05','11:05:00',2.78),('15128','2013-04-05','11:10:00',2.92),('15128','2013-04-05','11:15:00',2.9),('15128','2013-04-05','11:20:00',2.95),('15128','2013-04-05','11:25:00',3.12),('15128','2013-04-05','11:30:00',3.18),('15128','2013-04-05','11:35:00',3.37),('15128','2013-04-05','11:40:00',3.27),('15128','2013-04-05','11:45:00',3.32),('15128','2013-04-05','11:50:00',3.35),('15128','2013-04-05','11:55:00',3.4),('15128','2013-04-05','12:00:00',3.58),('15128','2013-04-05','12:05:00',3.72),('15128','2013-04-05','12:10:00',3.84),('15128','2013-04-05','12:15:00',3.88),('15128','2013-04-05','12:20:00',3.82),('15128','2013-04-05','12:25:00',3.84),('15128','2013-04-05','12:30:00',3.93),('15128','2013-04-05','12:35:00',3.94),('15128','2013-04-05','12:40:00',4.04),('15128','2013-04-05','12:45:00',4.08),('15128','2013-04-05','12:50:00',4.14),('15128','2013-04-05','12:55:00',4.24),('15128','2013-04-05','13:00:00',1.89),('15128','2013-04-05','13:10:00',1.6),('15128','2013-04-05','13:15:00',1.15),('15128','2013-04-05','13:20:00',1.51),('15128','2013-04-05','13:25:00',1.77),('15128','2013-04-05','13:30:00',3.3),('15128','2013-04-05','13:35:00',3.77),('15128','2013-04-05','13:40:00',4.61),('15128','2013-04-05','13:45:00',4.29),('15128','2013-04-05','13:50:00',2.54),('15128','2013-04-05','13:55:00',3.36),('15128','2013-04-05','14:00:00',4.13),('15128','2013-04-05','14:05:00',3.55),('15128','2013-04-05','14:10:00',4.55),('15128','2013-04-05','14:15:00',4.41),('15128','2013-04-05','14:20:00',4.25),('15128','2013-04-05','14:25:00',4.19),('15128','2013-04-05','14:30:00',4.15),('15128','2013-04-05','14:35:00',4.14),('15128','2013-04-05','14:40:00',4.1),('15128','2013-04-05','14:45:00',4.1),('15128','2013-04-05','14:50:00',4.13),('15128','2013-04-05','14:55:00',4.07),('15128','2013-04-05','15:00:00',4.03),('15128','2013-04-05','15:05:00',3.98),('15128','2013-04-05','15:10:00',3.91),('15128','2013-04-05','15:15:00',3.87),('15128','2013-04-05','15:20:00',3.9),('15128','2013-04-05','15:25:00',3.85),('15128','2013-04-05','15:30:00',3.84),('15128','2013-04-05','15:35:00',3.71),('15128','2013-04-05','15:40:00',3.66),('15128','2013-04-05','15:45:00',3.79),('15128','2013-04-05','15:50:00',3.74),('15128','2013-04-05','15:55:00',3.7),('15128','2013-04-05','16:00:00',3.46),('15128','2013-04-05','16:05:00',2.82),('15128','2013-04-05','16:10:00',2.36),('15128','2013-04-05','16:15:00',2.36),('15128','2013-04-05','16:20:00',3.16),('15128','2013-04-05','16:25:00',2.43),('15128','2013-04-05','16:30:00',1.79),('15128','2013-04-05','16:35:00',3.25),('15128','2013-04-05','16:40:00',2.43),('15128','2013-04-05','16:45:00',2.14),('15128','2013-04-05','16:50:00',2.69),('15128','2013-04-05','16:55:00',2.38),('15128','2013-04-05','17:00:00',2.22),('15128','2013-04-05','17:05:00',2.18),('15128','2013-04-05','17:10:00',2.01),('15128','2013-04-05','17:15:00',1.76),('15128','2013-04-05','17:20:00',1.32),('15128','2013-04-05','17:25:00',1.34),('15128','2013-04-05','17:30:00',1.14),('15128','2013-04-05','17:35:00',1.06),('15128','2013-04-04','08:45:00',1.01),('15128','2013-04-04','08:55:00',1.07),('15128','2013-04-04','09:20:00',1.01),('15128','2013-04-04','09:25:00',1.11),('15128','2013-04-04','09:30:00',1.32),('15128','2013-04-04','09:35:00',1.32),('15128','2013-04-04','09:40:00',2.01),('15128','2013-04-04','09:45:00',1.67),('15128','2013-04-04','09:50:00',1.2),('15128','2013-04-04','10:05:00',1.36),('15128','2013-04-04','10:10:00',1.77),('15128','2013-04-04','10:15:00',1.73),('15128','2013-04-04','10:20:00',2.3),('15128','2013-04-04','10:25:00',2.19),('15128','2013-04-04','10:30:00',2.23),('15128','2013-04-04','10:35:00',2.01),('15128','2013-04-04','10:40:00',2.71),('15128','2013-04-04','10:45:00',3.31),('15128','2013-04-04','10:50:00',2.8),('15128','2013-04-04','10:55:00',1.66),('15128','2013-04-04','11:00:00',2.01),('15128','2013-04-04','11:05:00',2.14),('15128','2013-04-04','11:10:00',3.08),('15128','2013-04-04','11:15:00',2.52),('15128','2013-04-04','11:20:00',3.29),('15128','2013-04-04','11:25:00',3.05),('15128','2013-04-04','11:30:00',3.32),('15128','2013-04-04','11:35:00',3.13),('15128','2013-04-04','11:40:00',3.41),('15128','2013-04-04','11:45:00',3.07),('15128','2013-04-04','11:50:00',2.88),('15128','2013-04-04','11:55:00',3.62),('15128','2013-04-04','12:00:00',3.68),('15128','2013-04-04','12:05:00',3.85),('15128','2013-04-04','12:10:00',2.87),('15128','2013-04-04','12:15:00',2.1),('15128','2013-04-04','12:20:00',1.86),('15128','2013-04-04','12:25:00',1.49),('15128','2013-04-04','12:30:00',4.63),('15128','2013-04-04','12:35:00',3.19),('15128','2013-04-04','12:40:00',1.43),('15128','2013-04-04','12:45:00',1.54),('15128','2013-04-04','12:50:00',3.11),('15128','2013-04-04','12:55:00',4.78),('15128','2013-04-04','13:00:00',3.97),('15128','2013-04-04','13:05:00',4.21),('15128','2013-04-04','13:10:00',4.34),('15128','2013-04-04','13:15:00',4.65),('15128','2013-04-04','13:20:00',4.23),('15128','2013-04-04','13:25:00',4.32),('15128','2013-04-04','13:30:00',4.64),('15128','2013-04-04','13:35:00',3.4),('15128','2013-04-04','13:40:00',4.76),('15128','2013-04-04','13:45:00',4.16),('15128','2013-04-04','13:50:00',4.73),('15128','2013-04-04','13:55:00',4.51),('15128','2013-04-04','14:00:00',3.7),('15128','2013-04-04','14:05:00',1.9),('15128','2013-04-04','14:10:00',3.45),('15128','2013-04-04','14:15:00',4.97),('15128','2013-04-04','14:20:00',5.15),('15128','2013-04-04','14:25:00',3.54),('15128','2013-04-04','14:30:00',3.79),('15128','2013-04-04','14:35:00',4.49),('15128','2013-04-04','14:40:00',2.49),('15128','2013-04-04','14:45:00',3.24),('15128','2013-04-04','14:50:00',2.49),('15128','2013-04-04','14:55:00',2.54),('15128','2013-04-04','15:00:00',2.67),('15128','2013-04-04','15:05:00',1.78),('15128','2013-04-04','15:10:00',1.43),('15128','2013-04-04','15:15:00',1.41),('15128','2013-04-04','15:20:00',1.39),('15128','2013-04-04','15:25:00',1.2),('15128','2013-04-04','15:35:00',1.08),('15128','2013-04-04','15:40:00',1.11),('15128','2013-04-04','15:55:00',1.04),('15128','2013-04-04','16:00:00',1.66),('15128','2013-04-04','16:05:00',2.28),('15128','2013-04-04','16:10:00',1.89),('15128','2013-04-04','16:15:00',1.62),('15128','2013-04-04','16:20:00',1.8),('15128','2013-04-04','16:25:00',1.49),('15128','2013-04-04','16:30:00',1.92),('15128','2013-04-04','16:35:00',1.93),('15128','2013-04-04','16:40:00',2.47),('15128','2013-04-04','16:45:00',2.28),('15128','2013-04-04','16:50:00',3.2),('15128','2013-04-04','16:55:00',3.24),('15128','2013-04-04','17:00:00',1.29),('15128','2013-04-04','17:05:00',1.46),('15128','2013-04-04','17:10:00',2.42),('15128','2013-04-04','17:15:00',1.9),('15128','2013-04-04','17:20:00',2.24),('15128','2013-04-04','17:25:00',1.65),('15128','2013-04-04','17:35:00',1.39),('15128','2013-04-04','17:40:00',2.3),('15128','2013-04-04','17:45:00',1.72),('15128','2013-04-04','17:50:00',1.56),('15128','2013-04-04','17:55:00',2.02),('15128','2013-04-04','18:00:00',2),('15128','2013-04-04','18:05:00',1.1),('15128','2013-04-04','18:15:00',1.02),('15128','2013-04-04','18:25:00',1.27),('15128','2013-04-03','08:50:00',1.04),('15128','2013-04-03','08:55:00',1.32),('15128','2013-04-03','09:00:00',1.11),('15128','2013-04-03','09:10:00',1.09),('15128','2013-04-03','09:15:00',1.11),('15128','2013-04-03','09:20:00',1.08),('15128','2013-04-03','09:25:00',1.19),('15128','2013-04-03','09:30:00',1.89),('15128','2013-04-03','09:35:00',2.32),('15128','2013-04-03','09:40:00',1.58),('15128','2013-04-03','09:45:00',1.26),('15128','2013-04-03','09:50:00',1.25),('15128','2013-04-03','09:55:00',1.51),('15128','2013-04-03','10:00:00',2.14),('15128','2013-04-03','10:05:00',2.38),('15128','2013-04-03','10:10:00',1.74),('15128','2013-04-03','10:15:00',1.62),('15128','2013-04-03','10:20:00',1.89),('15128','2013-04-03','10:25:00',2.56),('15128','2013-04-03','10:30:00',2.83),('15128','2013-04-03','10:35:00',2.86),('15128','2013-04-03','10:40:00',1.99),('15128','2013-04-03','10:45:00',2.11),('15128','2013-04-03','10:50:00',2.28),('15128','2013-04-03','10:55:00',2.16),('15128','2013-04-03','11:00:00',1.36),('15128','2013-04-03','11:05:00',1.22),('15128','2013-04-03','11:10:00',1.63),('15128','2013-04-03','11:15:00',1.51),('15128','2013-04-03','11:20:00',1.3),('15128','2013-04-03','11:25:00',1.26),('15128','2013-04-03','11:30:00',1.35),('15128','2013-04-03','11:35:00',1.76),('15128','2013-04-03','11:40:00',2.28),('15128','2013-04-03','11:45:00',2.73),('15128','2013-04-03','11:50:00',3.47),('15128','2013-04-03','11:55:00',3.52),('15128','2013-04-03','12:00:00',3.96),('15128','2013-04-03','12:05:00',4.17),('15128','2013-04-03','12:10:00',3.44),('15128','2013-04-03','12:15:00',3.01),('15128','2013-04-03','12:20:00',2.92),('15128','2013-04-03','12:25:00',3.8),('15128','2013-04-03','12:30:00',3.3),('15128','2013-04-03','12:35:00',3.75),('15128','2013-04-03','12:40:00',4.14),('15128','2013-04-03','12:45:00',3.74),('15128','2013-04-03','12:50:00',3.12),('15128','2013-04-03','12:55:00',3.32),('15128','2013-04-03','13:00:00',2.46),('15128','2013-04-03','13:05:00',1.93),('15128','2013-04-03','13:10:00',1.82),('15128','2013-04-03','13:15:00',2.39),('15128','2013-04-03','13:20:00',1.81),('15128','2013-04-03','13:25:00',3.5),('15128','2013-04-03','13:30:00',4.55),('15128','2013-04-03','13:35:00',3.69),('15128','2013-04-03','13:40:00',2.9),('15128','2013-04-03','13:45:00',3.19),('15128','2013-04-03','13:50:00',2.94),('15128','2013-04-03','13:55:00',2.46),('15128','2013-04-03','14:00:00',3.04),('15128','2013-04-03','14:05:00',3.6),('15128','2013-04-03','14:10:00',4.32),('15128','2013-04-03','14:15:00',3.96),('15128','2013-04-03','14:20:00',3.24),('15128','2013-04-03','14:25:00',3.99),('15128','2013-04-03','14:30:00',3.99),('15128','2013-04-03','14:35:00',4),('15128','2013-04-03','14:40:00',3.95),('15128','2013-04-03','14:45:00',3.98),('15128','2013-04-03','14:50:00',2.85),('15128','2013-04-03','14:55:00',3.35),('15128','2013-04-03','15:00:00',3.86),('15128','2013-04-03','15:05:00',3.75),('15128','2013-04-03','15:10:00',3.65),('15128','2013-04-03','15:15:00',3.72),('15128','2013-04-03','15:20:00',3.51),('15128','2013-04-03','15:25:00',3.34),('15128','2013-04-03','15:30:00',3.61),('15128','2013-04-03','15:35:00',3.55),('15128','2013-04-03','15:40:00',3.5),('15128','2013-04-03','15:45:00',3.39),('15128','2013-04-03','15:50:00',3.35),('15128','2013-04-03','15:55:00',3.35),('15128','2013-04-03','16:00:00',3.13),('15128','2013-04-03','16:05:00',3.21),('15128','2013-04-03','16:10:00',3.04),('15128','2013-04-03','16:15:00',2.72),('15128','2013-04-03','16:20:00',2.18),('15128','2013-04-03','16:25:00',3.26),('15128','2013-04-03','16:30:00',2.95),('15128','2013-04-03','16:35:00',2.47),('15128','2013-04-03','16:40:00',2.7),('15128','2013-04-03','16:45:00',2.17),('15128','2013-04-03','16:50:00',2.21),('15128','2013-04-03','16:55:00',2.36),('15128','2013-04-03','17:00:00',1.96),('15128','2013-04-03','17:05:00',2.19),('15128','2013-04-03','17:10:00',1.85),('15128','2013-04-03','17:15:00',1.73),('15128','2013-04-03','17:20:00',1.47),('15128','2013-04-03','17:25:00',1.27),('15128','2013-04-03','17:40:00',1.13),('15128','2013-04-03','17:50:00',1.31),('15128','2013-04-03','17:55:00',1.71),('15128','2013-04-03','18:00:00',1.56),('15128','2013-04-02','08:50:00',1.06),('15128','2013-04-02','08:55:00',1.16),('15128','2013-04-02','09:00:00',1.28),('15128','2013-04-02','09:05:00',1.31),('15128','2013-04-02','09:10:00',1.47),('15128','2013-04-02','09:15:00',1.58),('15128','2013-04-02','09:20:00',1.42),('15128','2013-04-02','09:30:00',1.54),('15128','2013-04-02','09:35:00',1.78),('15128','2013-04-02','09:40:00',1.94),('15128','2013-04-02','09:45:00',2.03),('15128','2013-04-02','09:50:00',2.16),('15128','2013-04-02','09:55:00',2.03),('15128','2013-04-02','10:00:00',1.49),('15128','2013-04-02','10:05:00',2.51),('15128','2013-04-02','10:10:00',2.66),('15128','2013-04-02','10:15:00',1.61),('15128','2013-04-02','10:20:00',1.5),('15128','2013-04-02','10:25:00',2.12),('15128','2013-04-02','10:30:00',1.77),('15128','2013-04-02','10:35:00',2.09),('15128','2013-04-02','10:40:00',1.36),('15128','2013-04-02','10:45:00',1.89),('15128','2013-04-02','10:50:00',3.28),('15128','2013-04-02','10:55:00',2.05),('15128','2013-04-02','11:00:00',2.29),('15128','2013-04-02','11:05:00',2.31),('15128','2013-04-02','11:10:00',2.82),('15128','2013-04-02','11:15:00',2.4),('15128','2013-04-02','11:20:00',1.82),('15128','2013-04-02','11:25:00',1.41),('15128','2013-04-02','11:30:00',3.39),('15128','2013-04-02','11:35:00',2.51),('15128','2013-04-02','11:40:00',1.65),('15128','2013-04-02','11:45:00',2.66),('15128','2013-04-02','11:50:00',3.28),('15128','2013-04-02','11:55:00',2.12),('15128','2013-04-02','12:00:00',4.67),('15128','2013-04-02','12:05:00',3.75),('15128','2013-04-02','12:10:00',4.78),('15128','2013-04-02','12:15:00',3.8),('15128','2013-04-02','12:20:00',3.83),('15128','2013-04-02','12:25:00',3.08),('15128','2013-04-02','12:30:00',3.5),('15128','2013-04-02','12:35:00',3.7),('15128','2013-04-02','12:40:00',3.96),('15128','2013-04-02','12:45:00',4.77),('15128','2013-04-02','12:50:00',3.42),('15128','2013-04-02','12:55:00',3.62),('15128','2013-04-02','13:00:00',3.58),('15128','2013-04-02','13:05:00',2.91),('15128','2013-04-02','13:10:00',4.77),('15128','2013-04-02','13:15:00',3.08),('15128','2013-04-02','13:20:00',3.74),('15128','2013-04-02','13:25:00',4.43),('15128','2013-04-02','13:30:00',4.82),('15128','2013-04-02','13:35:00',5.92),('15128','2013-04-02','13:40:00',5.44),('15128','2013-04-02','13:45:00',5.14),('15128','2013-04-02','13:50:00',5.03),('15128','2013-04-02','13:55:00',4.74),('15128','2013-04-02','14:00:00',4.04),('15128','2013-04-02','14:05:00',4.66),('15128','2013-04-02','14:10:00',4.81),('15128','2013-04-02','14:15:00',5.52),('15128','2013-04-02','14:20:00',3.97),('15128','2013-04-02','14:25:00',4.82),('15128','2013-04-02','14:30:00',3.66),('15128','2013-04-02','14:35:00',4.04),('15128','2013-04-02','14:40:00',4.73),('15128','2013-04-02','14:45:00',4.53),('15128','2013-04-02','14:50:00',4.64),('15128','2013-04-02','14:55:00',4.53),('15128','2013-04-02','15:00:00',4.7),('15128','2013-04-02','15:05:00',4.67),('15128','2013-04-02','15:10:00',4.53),('15128','2013-04-02','15:15:00',3.41),('15128','2013-04-02','15:20:00',4.71),('15128','2013-04-02','15:25:00',4.55),('15128','2013-04-02','15:30:00',4.43),('15128','2013-04-02','15:35:00',4.21),('15128','2013-04-02','15:40:00',4.2),('15128','2013-04-02','15:45:00',3.13),('15128','2013-04-02','15:50:00',3.82),('15128','2013-04-02','15:55:00',4.02),('15128','2013-04-02','16:00:00',3.9),('15128','2013-04-02','16:05:00',3.94),('15128','2013-04-02','16:10:00',3.81),('15128','2013-04-02','16:15:00',3.74),('15128','2013-04-02','16:20:00',3.66),('15128','2013-04-02','16:25:00',3.59),('15128','2013-04-02','16:30:00',3.53),('15128','2013-04-02','16:35:00',3.46),('15128','2013-04-02','16:40:00',3.4),('15128','2013-04-02','16:45:00',3.33),('15128','2013-04-02','16:50:00',3.23),('15128','2013-04-02','16:55:00',3.16),('15128','2013-04-02','17:00:00',3.05),('15128','2013-04-02','17:05:00',2.96),('15128','2013-04-02','17:10:00',2.84),('15128','2013-04-02','17:15:00',2.73),('15128','2013-04-02','17:20:00',2.59),('15128','2013-04-02','17:25:00',2.39),('15128','2013-04-02','17:30:00',2.35),('15128','2013-04-02','17:35:00',2.16),('15128','2013-04-02','17:40:00',2.11),('15128','2013-04-02','17:45:00',2.01),('15128','2013-04-02','17:50:00',1.17),('15128','2013-04-02','17:55:00',1.65),('15128','2013-04-02','18:00:00',1.76),('15128','2013-04-02','18:05:00',1.7),('15128','2013-04-02','18:10:00',1.6),('15128','2013-04-02','18:15:00',1.45),('15128','2013-04-02','18:20:00',1.32),('15128','2013-04-02','18:25:00',1.22),('15128','2013-04-02','18:30:00',1.12),('15128','2013-04-02','18:35:00',1.03),('15128','2013-04-01','09:00:00',1.23),('15128','2013-04-01','09:05:00',1.31),('15128','2013-04-01','09:10:00',1.39),('15128','2013-04-01','09:15:00',1.35),('15128','2013-04-01','09:20:00',1.73),('15128','2013-04-01','09:25:00',1.96),('15128','2013-04-01','09:30:00',1.55),('15128','2013-04-01','09:35:00',1.97),('15128','2013-04-01','09:40:00',1.72),('15128','2013-04-01','09:45:00',1.06),('15128','2013-04-01','09:50:00',1.75),('15128','2013-04-01','09:55:00',1.81),('15128','2013-04-01','10:00:00',2.11),('15128','2013-04-01','10:05:00',3.12),('15128','2013-04-01','10:10:00',2.96),('15128','2013-04-01','10:15:00',2.21),('15128','2013-04-01','10:20:00',3.14),('15128','2013-04-01','10:25:00',2.9),('15128','2013-04-01','10:30:00',2.42),('15128','2013-04-01','10:35:00',2.52),('15128','2013-04-01','10:40:00',1.46),('15128','2013-04-01','10:45:00',2.98),('15128','2013-04-01','10:50:00',2.96),('15128','2013-04-01','10:55:00',3.17),('15128','2013-04-01','11:00:00',2.99),('15128','2013-04-01','11:05:00',3.27),('15128','2013-04-01','11:10:00',3.3),('15128','2013-04-01','11:15:00',2.2),('15128','2013-04-01','11:20:00',2.96),('15128','2013-04-01','11:25:00',2.36),('15128','2013-04-01','11:30:00',4.13),('15128','2013-04-01','11:35:00',3.76),('15128','2013-04-01','11:40:00',3.16),('15128','2013-04-01','11:45:00',3.68),('15128','2013-04-01','11:50:00',3.54),('15128','2013-04-01','11:55:00',1.23),('15128','2013-04-01','12:00:00',1.18),('15128','2013-04-01','12:05:00',1.65),('15128','2013-04-01','12:10:00',2.84),('15128','2013-04-01','12:15:00',1.44),('15128','2013-04-01','12:20:00',1.38),('15128','2013-04-01','12:25:00',1.05),('15128','2013-04-01','12:30:00',2.11),('15128','2013-04-01','12:35:00',2.65),('15128','2013-04-01','12:40:00',1.82),('15128','2013-04-01','12:45:00',2.28),('15128','2013-04-01','12:50:00',1.79),('15128','2013-04-01','12:55:00',1.61),('15128','2013-04-01','13:00:00',1.7),('15128','2013-04-01','13:05:00',2.35),('15128','2013-04-01','13:10:00',1.7),('15128','2013-04-01','13:15:00',1.07),('15128','2013-04-01','13:20:00',1.41),('15128','2013-04-01','13:25:00',1.87),('15128','2013-04-01','13:30:00',1.69),('15128','2013-04-01','13:35:00',1.62),('15128','2013-04-01','13:40:00',1.49),('15128','2013-04-01','13:45:00',1.31),('15128','2013-04-01','13:50:00',2.37),('15128','2013-04-01','13:55:00',3.52),('15128','2013-04-01','14:00:00',2.8),('15128','2013-04-01','14:05:00',3.2),('15128','2013-04-01','14:10:00',4.67),('15128','2013-04-01','14:15:00',2.25),('15128','2013-04-01','14:20:00',1.51),('15128','2013-04-01','14:25:00',4.42),('15128','2013-04-01','14:30:00',2.38),('15128','2013-04-01','14:40:00',1.05),('15128','2013-04-01','14:50:00',1.32),('15128','2013-04-01','15:00:00',1.17),('15128','2013-04-01','15:20:00',1.41),('15128','2013-04-01','15:55:00',1.44),('15128','2013-04-01','16:00:00',1.4),('15128','2013-04-01','16:05:00',1.3),('15128','2013-04-01','16:10:00',1.06),('15128','2013-04-01','16:15:00',1.06),('15128','2013-04-01','16:30:00',1.14),('15128','2013-04-01','17:45:00',1),('15128','2014-05-01','08:30:00',1.03),('15128','2014-05-01','08:35:00',1.29),('15128','2014-05-01','08:40:00',1.43),('15128','2014-05-01','09:15:00',1.55),('15128','2014-05-01','09:20:00',1.57),('15128','2014-05-01','09:25:00',1.46),('15128','2014-05-01','09:30:00',1.69),('15128','2014-05-01','09:35:00',1.76),('15128','2014-05-01','09:40:00',1.66),('15128','2014-05-01','09:45:00',1.4),('15128','2014-05-01','09:50:00',1.13),('15128','2014-05-01','11:00:00',1.03),('15128','2014-05-01','11:05:00',1.05),('15128','2014-05-01','11:10:00',1),('15128','2014-05-01','12:35:00',1.13),('15128','2014-05-01','12:40:00',1.31),('15128','2014-05-01','12:45:00',1.66),('15128','2014-05-01','12:50:00',1.8),('15128','2014-05-01','12:55:00',2.18),('15128','2014-05-01','13:00:00',2.25),('15128','2014-05-01','13:05:00',2.05),('15128','2014-05-01','13:10:00',2.94),('15128','2014-05-01','13:15:00',2.14),('15128','2014-05-01','13:20:00',2.13),('15128','2014-05-01','13:25:00',1.96),('15128','2014-05-01','13:30:00',3.38),('15128','2014-05-01','13:35:00',1.89),('15128','2014-05-01','13:40:00',2.99),('15128','2014-05-01','13:45:00',1.51),('15128','2014-05-01','13:50:00',1.8),('15128','2014-05-01','13:55:00',2.55),('15128','2014-05-01','14:00:00',2.43),('15128','2014-05-01','14:05:00',1.97),('15128','2014-05-01','14:10:00',4.08),('15128','2014-05-01','14:15:00',4),('15128','2014-05-01','14:20:00',3.92),('15128','2014-05-01','14:25:00',5.35),('15128','2014-05-01','14:30:00',1.91),('15128','2014-05-01','14:35:00',2.19),('15128','2014-05-01','14:40:00',1.5),('15128','2014-05-01','14:45:00',1.34),('15128','2014-05-01','15:15:00',1.28),('15128','2014-05-01','15:20:00',1.63),('15128','2014-05-01','15:25:00',2.81),('15128','2014-05-01','15:30:00',2.84),('15128','2014-05-01','15:35:00',2.62),('15128','2014-05-01','15:40:00',1.32),('15128','2014-05-01','15:50:00',1.41),('15128','2014-05-01','15:55:00',1.6),('15128','2014-05-01','16:00:00',1.05),('15128','2014-05-01','16:05:00',1.01),('15128','2014-05-01','16:10:00',1.58),('15128','2014-05-01','16:15:00',1.45),('15128','2014-05-01','16:20:00',1.04),('15128','2014-05-01','16:25:00',1.6),('15128','2014-05-01','16:30:00',1.35),('15128','2014-05-01','16:35:00',1.1),('15128','2014-05-01','16:40:00',1.76),('15128','2014-05-01','16:45:00',4.17),('15128','2014-05-01','16:50:00',2.62),('15128','2014-05-01','16:55:00',1.17),('15128','2014-05-01','17:00:00',1.17),('15128','2014-05-01','17:05:00',1.04),('15128','2014-05-01','17:10:00',1.05),('15128','2014-03-26','09:25:00',1.13),('15128','2014-03-26','09:30:00',1.2),('15128','2014-03-26','10:05:00',1.21),('15128','2014-03-26','10:10:00',1.39),('15128','2014-03-26','10:15:00',1.39),('15128','2014-03-26','10:20:00',1.28),('15128','2014-03-26','10:25:00',1.45),('15128','2014-03-26','10:30:00',1.41),('15128','2014-03-26','10:35:00',1.78),('15128','2014-03-26','10:40:00',1.81),('15128','2014-03-26','10:45:00',2.03),('15128','2014-03-26','10:50:00',2.15),('15128','2014-03-26','10:55:00',1.48),('15128','2014-03-26','11:00:00',1.71),('15128','2014-03-26','11:05:00',2.45),('15128','2014-03-26','11:10:00',2.78),('15128','2014-03-26','11:15:00',1.16),('15128','2014-03-26','11:20:00',1.07),('15128','2014-03-26','11:25:00',1.06),('15128','2014-03-26','11:45:00',1.04),('15128','2014-03-26','11:50:00',1.3),('15128','2014-03-26','11:55:00',1.43),('15128','2014-03-26','12:00:00',1.05),('15128','2014-03-26','12:50:00',1.09),('15128','2014-03-26','12:55:00',1.33),('15128','2014-03-26','13:00:00',1.46),('15128','2014-03-26','13:05:00',1.51),('15128','2014-03-26','13:10:00',2.04),('15128','2014-03-26','13:15:00',2.7),('15128','2014-03-26','13:20:00',2.76),('15128','2014-03-26','13:25:00',2.99),('15128','2014-03-26','13:30:00',3.09),('15128','2014-03-26','13:35:00',2.77),('15128','2014-03-26','13:40:00',2.47),('15128','2014-03-26','13:45:00',2.22),('15128','2014-03-26','13:50:00',2.17),('15128','2014-03-26','13:55:00',1.57),('15128','2014-03-26','14:00:00',1.07),('15128','2014-03-26','14:05:00',1.94),('15128','2014-03-26','14:10:00',2.2),('15128','2014-03-26','14:15:00',1.03),('15128','2014-03-26','14:20:00',1.12),('15128','2014-03-26','14:25:00',2.77),('15128','2014-03-26','14:30:00',1.56),('15128','2014-03-26','15:35:00',1.03),('15128','2014-03-26','15:40:00',1.99),('15128','2014-03-26','15:45:00',2.92),('15128','2014-03-26','15:50:00',1.6),('15128','2014-03-26','15:55:00',2.16),('15128','2014-03-26','16:25:00',1.19),('15128','2014-03-26','16:45:00',1.33),('15128','2014-03-26','16:50:00',1.01),('15128','2013-03-31','09:00:00',1.26),('15128','2013-03-31','09:05:00',1.36),('15128','2013-03-31','09:10:00',1.48),('15128','2013-03-31','09:15:00',1.48),('15128','2013-03-31','09:20:00',1.51),('15128','2013-03-31','09:25:00',1.68),('15128','2013-03-31','09:30:00',1.11),('15128','2013-03-31','09:40:00',1.35),('15128','2013-03-31','09:45:00',1.02),('15128','2013-03-31','09:50:00',2.15),('15128','2013-03-31','09:55:00',2.04),('15128','2013-03-31','10:00:00',1.98),('15128','2013-03-31','10:05:00',2.51),('15128','2013-03-31','10:10:00',2.51),('15128','2013-03-31','10:15:00',2.15),('15128','2013-03-31','10:20:00',2.62),('15128','2013-03-31','10:25:00',2.96),('15128','2013-03-31','10:30:00',2.57),('15128','2013-03-31','10:35:00',2.01),('15128','2013-03-31','10:40:00',2.12),('15128','2013-03-31','10:45:00',2.59),('15128','2013-03-31','10:50:00',2.09),('15128','2013-03-31','10:55:00',2.13),('15128','2013-03-31','11:00:00',1.65),('15128','2013-03-31','11:05:00',1.44),('15128','2013-03-31','11:10:00',1.88),('15128','2013-03-31','11:15:00',2),('15128','2013-03-31','11:20:00',1.92),('15128','2013-03-31','11:25:00',2.56),('15128','2013-03-31','11:30:00',1.95),('15128','2013-03-31','11:35:00',2.12),('15128','2013-03-31','11:40:00',3.08),('15128','2013-03-31','11:45:00',2.38),('15128','2013-03-31','11:50:00',2.68),('15128','2013-03-31','11:55:00',2.71),('15128','2013-03-31','12:00:00',2.24),('15128','2013-03-31','12:05:00',2.5),('15128','2013-03-31','12:10:00',2.62),('15128','2013-03-31','12:15:00',2.24),('15128','2013-03-31','12:20:00',2.38),('15128','2013-03-31','12:25:00',2.39),('15128','2013-03-31','12:30:00',2.6),('15128','2013-03-31','12:35:00',2.21),('15128','2013-03-31','12:40:00',2.62),('15128','2013-03-31','12:45:00',2.61),('15128','2013-03-31','12:50:00',2.83),('15128','2013-03-31','12:55:00',2.96),('15128','2013-03-31','13:00:00',2.48),('15128','2013-03-31','13:05:00',2.59),('15128','2013-03-31','13:10:00',2.46),('15128','2013-03-31','13:15:00',2.82),('15128','2013-03-31','13:20:00',2.53),('15128','2013-03-31','13:25:00',2.14),('15128','2013-03-31','13:30:00',2.06),('15128','2013-03-31','13:35:00',2.25),('15128','2013-03-31','13:40:00',2.15),('15128','2013-03-31','13:45:00',2.88),('15128','2013-03-31','13:50:00',3.54),('15128','2013-03-31','13:55:00',3.51),('15128','2013-03-31','14:00:00',2.43),('15128','2013-03-31','14:05:00',2.03),('15128','2013-03-31','14:10:00',2.1),('15128','2013-03-31','14:15:00',2.61),('15128','2013-03-31','14:20:00',3.43),('15128','2013-03-31','14:25:00',4.07),('15128','2013-03-31','14:30:00',4.44),('15128','2013-03-31','14:35:00',2.43),('15128','2013-03-31','14:40:00',1.55),('15128','2013-03-31','14:45:00',2.45),('15128','2013-03-31','14:50:00',2.75),('15128','2013-03-31','14:55:00',2.15),('15128','2013-03-31','15:00:00',2.08),('15128','2013-03-31','15:05:00',1.96),('15128','2013-03-31','15:10:00',2.25),('15128','2013-03-31','15:15:00',2.34),('15128','2013-03-31','15:20:00',2.4),('15128','2013-03-31','15:25:00',2.95),('15128','2013-03-31','15:30:00',2.5),('15128','2013-03-31','15:35:00',2.7),('15128','2013-03-31','15:40:00',2.11),('15128','2013-03-31','15:45:00',2.71),('15128','2013-03-31','15:50:00',3.34),('15128','2013-03-31','15:55:00',2.74),('15128','2013-03-31','16:00:00',2.37),('15128','2013-03-31','16:05:00',1.86),('15128','2013-03-31','16:10:00',1.52),('15128','2013-03-31','16:15:00',1.02),('15128','2013-03-30','09:00:00',1.06),('15128','2013-03-30','09:10:00',1.42),('15128','2013-03-30','09:15:00',1.14),('15128','2013-03-30','09:20:00',1.01),('15128','2013-03-30','09:25:00',1.2),('15128','2013-03-30','09:45:00',1.86),('15128','2013-03-30','09:50:00',1.13),('15128','2013-03-30','10:05:00',1.05),('15128','2013-03-30','10:10:00',1.81),('15128','2013-03-30','10:15:00',1.82),('15128','2013-03-30','10:20:00',2.17),('15128','2013-03-30','10:25:00',2.01),('15128','2013-03-30','10:30:00',1.81),('15128','2013-03-30','10:35:00',1.61),('15128','2013-03-30','10:40:00',1.16),('15128','2013-03-30','10:50:00',2.12),('15128','2013-03-30','10:55:00',1.7),('15128','2013-03-30','11:00:00',3.01),('15128','2013-03-30','11:05:00',2.74),('15128','2013-03-30','11:10:00',2.32),('15128','2013-03-30','11:15:00',1.28),('15128','2013-03-30','11:20:00',1.83),('15128','2013-03-30','11:25:00',2.59),('15128','2013-03-30','11:30:00',2.4),('15128','2013-03-30','11:35:00',2.48),('15128','2013-03-30','11:40:00',3.35),('15128','2013-03-30','11:45:00',2.03),('15128','2013-03-30','11:50:00',1.58),('15128','2013-03-30','11:55:00',2.07),('15128','2013-03-30','12:00:00',1.27),('15128','2013-03-30','12:05:00',1.09),('15128','2013-03-30','12:10:00',1.06),('15128','2013-03-30','12:25:00',1.14),('15128','2013-03-30','12:30:00',1.36),('15128','2013-03-30','12:35:00',2.55),('15128','2013-03-30','12:40:00',3.56),('15128','2013-03-30','12:45:00',2.52),('15128','2013-03-30','12:50:00',1.46),('15128','2013-03-30','12:55:00',2.49),('15128','2013-03-30','13:00:00',2.96),('15128','2013-03-30','13:05:00',2.05),('15128','2013-03-30','13:10:00',2),('15128','2013-03-30','13:15:00',5.11),('15128','2013-03-30','13:20:00',3.88),('15128','2013-03-30','13:25:00',2.95),('15128','2013-03-30','13:30:00',2.01),('15128','2013-03-30','13:35:00',2.27),('15128','2013-03-30','13:40:00',1.87),('15128','2013-03-30','13:45:00',3.12),('15128','2013-03-30','13:50:00',2.48),('15128','2013-03-30','13:55:00',3.74),('15128','2013-03-30','14:00:00',3.14),('15128','2013-03-30','14:05:00',3.52),('15128','2013-03-30','14:10:00',3.43),('15128','2013-03-30','14:15:00',4.73),('15128','2013-03-30','14:20:00',4.01),('15128','2013-03-30','14:25:00',3.93),('15128','2013-03-30','14:30:00',3.04),('15128','2013-03-30','14:35:00',3.85),('15128','2013-03-30','14:40:00',3.35),('15128','2013-03-30','14:45:00',4.82),('15128','2013-03-30','14:50:00',4.63),('15128','2013-03-30','14:55:00',2.82),('15128','2013-03-30','15:00:00',3.47),('15128','2013-03-30','15:05:00',3.47),('15128','2013-03-30','15:10:00',4.6),('15128','2013-03-30','15:15:00',5.04),('15128','2013-03-30','15:20:00',4.79),('15128','2013-03-30','15:25:00',1.58),('15128','2013-03-30','15:35:00',2.29),('15128','2013-03-30','15:40:00',3.17),('15128','2013-03-30','15:45:00',4),('15128','2013-03-30','15:50:00',1.86),('15128','2013-03-30','16:20:00',1.33),('15128','2013-03-30','16:30:00',1.18),('15128','2013-03-30','16:35:00',1.26),('15128','2013-03-30','16:40:00',1.16),('15128','2013-03-30','16:45:00',1.01),('15128','2013-03-30','16:50:00',1.22),('15128','2013-03-30','16:55:00',1.33),('15128','2013-03-30','17:00:00',1.91),('15128','2013-03-30','17:05:00',1.28),('15128','2013-03-30','17:30:00',1.27),('15128','2013-03-30','17:40:00',1.13),('15128','2013-03-30','17:45:00',2),('15128','2013-03-30','17:50:00',2.24),('15128','2013-03-30','17:55:00',1.21),('15128','2013-03-30','18:10:00',1.23),('15128','2013-03-30','18:15:00',1.62),('15128','2013-03-30','18:20:00',1.07),('15128','2013-03-29','08:25:00',1.01),('15128','2013-03-29','09:00:00',1.06),('15128','2013-03-29','09:10:00',1.37),('15128','2013-03-29','09:15:00',1.2),('15128','2013-03-29','09:20:00',1.18),('15128','2013-03-29','09:25:00',1.38),('15128','2013-03-29','09:30:00',1.46),('15128','2013-03-29','09:35:00',1.53),('15128','2013-03-29','09:40:00',1.27),('15128','2013-03-29','09:45:00',1.3),('15128','2013-03-29','09:50:00',1.4),('15128','2013-03-29','09:55:00',1.68),('15128','2013-03-29','10:00:00',2.17),('15128','2013-03-29','10:05:00',2.16),('15128','2013-03-29','10:10:00',1.79),('15128','2013-03-29','10:15:00',1.41),('15128','2013-03-29','10:20:00',1.28),('15128','2013-03-29','10:25:00',1.47),('15128','2013-03-29','10:30:00',2.07),('15128','2013-03-29','10:35:00',2.23),('15128','2013-03-29','10:40:00',2.18),('15128','2013-03-29','10:45:00',1.9),('15128','2013-03-29','10:50:00',2.12),('15128','2013-03-29','10:55:00',2.49),('15128','2013-03-29','11:00:00',2.66),('15128','2013-03-29','11:05:00',2.69),('15128','2013-03-29','11:10:00',2.28),('15128','2013-03-29','11:15:00',3.51),('15128','2013-03-29','11:20:00',3.13),('15128','2013-03-29','11:25:00',2),('15128','2013-03-29','11:30:00',3.14),('15128','2013-03-29','11:35:00',3.85),('15128','2013-03-29','11:40:00',2.98),('15128','2013-03-29','11:45:00',2.83),('15128','2013-03-29','11:50:00',2.07),('15128','2013-03-29','11:55:00',2.94),('15128','2013-03-29','12:00:00',3.93),('15128','2013-03-29','12:05:00',2.57),('15128','2013-03-29','12:10:00',2.25),('15128','2013-03-29','12:15:00',1.7),('15128','2013-03-29','12:20:00',1.57),('15128','2013-03-29','12:25:00',1.19),('15128','2013-03-29','12:30:00',1.98),('15128','2013-03-29','12:35:00',1.11),('15128','2013-03-29','13:00:00',1.34),('15128','2013-03-29','13:05:00',1.9),('15128','2013-03-29','13:10:00',2.64),('15128','2013-03-29','13:15:00',1.84),('15128','2013-03-29','13:20:00',1.67),('15128','2013-03-29','13:25:00',1.31),('15128','2013-03-29','13:40:00',1.04),('15128','2013-03-29','13:45:00',1.45),('15128','2013-03-29','13:50:00',2.69),('15128','2013-03-29','13:55:00',3.18),('15128','2013-03-29','14:00:00',2.65),('15128','2013-03-29','14:05:00',3.33),('15128','2013-03-29','14:10:00',1.54),('15128','2013-03-29','14:15:00',1.87),('15128','2013-03-29','14:20:00',1.92),('15128','2013-03-29','14:25:00',1.48),('15128','2013-03-29','14:30:00',1.08),('15128','2013-03-29','14:35:00',1.24),('15128','2013-03-29','14:45:00',1.14),('15128','2013-03-28','08:10:00',1.56),('15128','2013-03-28','08:15:00',1.65),('15128','2013-03-28','08:20:00',1.55),('15128','2013-03-28','08:25:00',1.53),('15128','2013-03-28','08:30:00',1.61),('15128','2013-03-28','08:35:00',1.66),('15128','2013-03-28','08:40:00',1.62),('15128','2013-03-28','08:45:00',1.7),('15128','2013-03-28','08:50:00',1.55),('15128','2013-03-28','08:55:00',1.88),('15128','2013-03-28','09:00:00',1.81),('15128','2013-03-28','09:05:00',1.93),('15128','2013-03-28','09:10:00',2.19),('15128','2013-03-28','09:15:00',2.28),('15128','2013-03-28','09:20:00',1.94),('15128','2013-03-28','09:25:00',2.45),('15128','2013-03-28','09:30:00',2.53),('15128','2013-03-28','09:35:00',1.83),('15128','2013-03-28','09:40:00',2),('15128','2013-03-28','09:45:00',2.67),('15128','2013-03-28','09:50:00',2.55),('15128','2013-03-28','09:55:00',2.67),('15128','2013-03-28','10:00:00',2.58),('15128','2013-03-28','10:05:00',2.23),('15128','2013-03-28','10:10:00',2.74),('15128','2013-03-28','10:15:00',2.84),('15128','2013-03-28','10:20:00',2.66),('15128','2013-03-28','10:25:00',2.85),('15128','2013-03-28','10:30:00',2.84),('15128','2013-03-28','10:35:00',3.18),('15128','2013-03-28','10:40:00',2.81),('15128','2013-03-28','10:45:00',2.56),('15128','2013-03-28','10:50:00',2.29),('15128','2013-03-28','10:55:00',2.69),('15128','2013-03-28','11:00:00',3.03),('15128','2013-03-28','11:05:00',1.53),('15128','2013-03-28','11:10:00',3.45),('15128','2013-03-28','11:15:00',4.73),('15128','2013-03-28','11:20:00',4.05),('15128','2013-03-28','11:25:00',3.7),('15128','2013-03-28','11:30:00',2.34),('15128','2013-03-28','11:35:00',4.2),('15128','2013-03-28','11:40:00',4.13),('15128','2013-03-28','11:45:00',4.19),('15128','2013-03-28','11:50:00',4.2),('15128','2013-03-28','11:55:00',4.26),('15128','2013-03-28','12:00:00',4.32),('15128','2013-03-28','12:05:00',4.34),('15128','2013-03-28','12:10:00',3.96),('15128','2013-03-28','12:15:00',4.17),('15128','2013-03-28','12:20:00',3.99),('15128','2013-03-28','12:25:00',3.4),('15128','2013-03-28','12:30:00',3.73),('15128','2013-03-28','12:35:00',3.74),('15128','2013-03-28','12:40:00',4.55),('15128','2013-03-28','12:45:00',4.15),('15128','2013-03-28','12:50:00',3.52),('15128','2013-03-28','12:55:00',3.78),('15128','2013-03-28','13:00:00',3.02),('15128','2013-03-28','13:05:00',3.83),('15128','2013-03-28','13:10:00',3.45),('15128','2013-03-28','13:15:00',3.73),('15128','2013-03-28','13:20:00',4.92),('15128','2013-03-28','13:25:00',4.18),('15128','2013-03-28','13:30:00',3.88),('15128','2013-03-28','13:35:00',3.65),('15128','2013-03-28','13:40:00',3.59),('15128','2013-03-28','13:45:00',3.83),('15128','2013-03-28','13:50:00',3.8),('15128','2013-03-28','13:55:00',3.95),('15128','2013-03-28','14:00:00',3.62),('15128','2013-03-28','14:05:00',2.9),('15128','2013-03-28','14:10:00',2.61),('15128','2013-03-28','14:15:00',2.53),('15128','2013-03-28','14:20:00',2.57),('15128','2013-03-28','14:25:00',2.34),('15128','2013-03-28','14:30:00',2.14),('15128','2013-03-28','14:35:00',2.12),('15128','2013-03-28','14:40:00',2.13),('15128','2013-03-28','14:45:00',2.03),('15128','2013-03-28','14:50:00',1.94),('15128','2013-03-28','14:55:00',1.79),('15128','2013-03-28','15:00:00',1.68),('15128','2013-03-28','15:05:00',1.71),('15128','2013-03-28','15:10:00',1.63),('15128','2013-03-28','15:15:00',1.59),('15128','2013-03-28','15:20:00',1.42),('15128','2013-03-28','15:25:00',1.3),('15128','2013-03-28','15:30:00',1.24),('15128','2013-03-28','15:35:00',1.18),('15128','2013-03-28','15:40:00',1.16),('15128','2013-03-28','15:45:00',1.24),('15128','2013-03-28','15:50:00',1.39),('15128','2013-03-28','15:55:00',1.49),('15128','2013-03-28','16:00:00',1.47),('15128','2013-03-28','16:05:00',1.35),('15128','2013-03-28','16:10:00',1.18),('15128','2013-03-28','16:15:00',1.07),('15128','2013-03-28','16:20:00',1.18),('15128','2013-03-28','16:25:00',1.49),('15128','2013-03-28','16:30:00',1.26),('15128','2013-03-28','16:35:00',2.08),('15128','2013-03-28','16:40:00',2.2),('15128','2013-03-28','16:45:00',1.71),('15128','2013-03-28','16:50:00',1.21),('15128','2013-03-28','16:55:00',1.52),('15128','2013-03-28','17:00:00',2.05),('15128','2013-03-28','17:05:00',1.22),('15128','2013-03-28','17:15:00',1.03),('15128','2013-03-28','17:20:00',1.45),('15128','2013-03-28','17:25:00',1.31),('15128','2013-03-28','17:30:00',1.3),('15128','2013-03-27','09:15:00',1.3),('15128','2013-03-27','09:20:00',1.87),('15128','2013-03-27','09:25:00',1.91),('15128','2013-03-27','09:30:00',1.5),('15128','2013-03-27','12:50:00',1.79),('15128','2013-03-27','12:55:00',1.89),('15128','2013-03-27','13:00:00',1.42),('15128','2013-03-27','13:05:00',1.35),('15128','2013-03-27','13:25:00',1.48),('15128','2013-03-27','13:30:00',2.46),('15128','2013-03-27','13:35:00',1.48),('15128','2013-03-27','13:40:00',1.61),('15128','2013-03-27','13:45:00',1.4),('15128','2013-03-27','14:00:00',1.19),('15128','2013-03-27','14:05:00',2.55),('15128','2013-03-27','14:10:00',2.34),('15128','2013-03-27','14:15:00',3.1),('15128','2013-03-27','14:20:00',1.99),('15128','2013-03-27','14:25:00',1.5),('15128','2013-03-27','14:30:00',1.71),('15128','2013-03-27','14:35:00',2.19),('15128','2013-03-27','14:40:00',1.47),('15128','2013-03-27','14:45:00',1.07),('15128','2013-03-27','15:05:00',1.18),('15128','2013-03-27','15:10:00',1.54),('15128','2013-03-27','15:15:00',1.98),('15128','2013-03-27','15:20:00',1.83),('15128','2013-03-27','15:25:00',1.81),('15128','2013-03-27','15:30:00',1.58),('15128','2013-03-27','15:40:00',1.13),('15128','2013-03-27','15:45:00',2.49),('15128','2013-03-27','15:50:00',2.07),('15128','2013-03-27','15:55:00',1.6),('15128','2013-03-27','16:00:00',1.41),('15128','2013-03-27','16:05:00',1.21),('15128','2013-03-27','16:10:00',1.51),('15128','2013-03-27','16:15:00',1.15),('15128','2013-03-27','16:35:00',1.2),('15128','2013-03-27','16:40:00',2.31),('15128','2013-03-27','16:45:00',1.61),('15128','2013-03-27','16:50:00',1.01),('15128','2013-03-27','16:55:00',1.23),('15128','2013-03-27','17:00:00',1.95),('15128','2013-03-27','17:05:00',1.87),('15128','2013-03-27','17:10:00',1.6),('15128','2013-03-27','17:15:00',1.29),('15128','2013-03-26','08:10:00',1.08),('15128','2013-03-26','08:15:00',1.14),('15128','2013-03-26','08:20:00',1.06),('15128','2013-03-26','08:25:00',1.46),('15128','2013-03-26','08:30:00',1.56),('15128','2013-03-26','08:35:00',1.98),('15128','2013-03-26','08:40:00',1.74),('15128','2013-03-26','08:45:00',2.26),('15128','2013-03-26','08:50:00',1.67),('15128','2013-03-26','08:55:00',2.39),('15128','2013-03-26','09:00:00',1.35),('15128','2013-03-26','09:05:00',1.6),('15128','2013-03-26','09:10:00',2.66),('15128','2013-03-26','09:15:00',1.88),('15128','2013-03-26','09:20:00',1.16),('15128','2013-03-26','09:25:00',1.58),('15128','2013-03-26','09:30:00',1.08),('15128','2013-03-26','09:40:00',1.03),('15128','2013-03-26','09:45:00',2.11),('15128','2013-03-26','09:50:00',3.53),('15128','2013-03-26','09:55:00',1.92),('15128','2013-03-26','10:00:00',1.14),('15128','2013-03-26','10:05:00',1.56),('15128','2013-03-26','10:10:00',2.26),('15128','2013-03-26','10:15:00',3.41),('15128','2013-03-26','10:20:00',3.87),('15128','2013-03-26','10:25:00',3.3),('15128','2013-03-26','10:30:00',2.87),('15128','2013-03-26','10:35:00',3.14),('15128','2013-03-26','10:40:00',3.06),('15128','2013-03-26','10:45:00',2.6),('15128','2013-03-26','10:50:00',2.2),('15128','2013-03-26','10:55:00',2.04),('15128','2013-03-26','11:00:00',2.01),('15128','2013-03-26','11:05:00',2.1),('15128','2013-03-26','11:10:00',1.88),('15128','2013-03-26','11:15:00',1.69),('15128','2013-03-26','11:20:00',1.28),('15128','2013-03-26','11:25:00',1.06),('15128','2013-03-26','11:30:00',2.2),('15128','2013-03-26','11:35:00',2.24),('15128','2013-03-26','11:40:00',1.64),('15128','2013-03-26','11:45:00',1.56),('15128','2013-03-26','11:50:00',2.29),('15128','2013-03-26','11:55:00',2.21),('15128','2013-03-26','12:00:00',1.84),('15128','2013-03-26','12:05:00',2.43),('15128','2013-03-26','12:10:00',1.84),('15128','2013-03-26','12:15:00',1.67),('15128','2013-03-26','12:20:00',1.49),('15128','2013-03-26','12:25:00',2.26),('15128','2013-03-26','12:30:00',1.7),('15128','2013-03-26','12:35:00',1.3),('15128','2013-03-26','12:40:00',1.47),('15128','2013-03-26','12:45:00',1.68),('15128','2013-03-26','12:50:00',2.24),('15128','2013-03-26','12:55:00',2.32),('15128','2013-03-26','13:00:00',2.56),('15128','2013-03-26','13:05:00',2.33),('15128','2013-03-26','13:10:00',2.45),('15128','2013-03-26','13:15:00',2.22),('15128','2013-03-26','13:20:00',2.05),('15128','2013-03-26','13:25:00',1.91),('15128','2013-03-26','13:30:00',2.05),('15128','2013-03-26','13:35:00',2.21),('15128','2013-03-26','13:40:00',2.14),('15128','2013-03-26','13:45:00',2.4),('15128','2013-03-26','13:50:00',1.86),('15128','2013-03-26','13:55:00',1.81),('15128','2013-03-26','14:00:00',1.71),('15128','2013-03-26','14:05:00',1.92),('15128','2013-03-26','14:10:00',2.02),('15128','2013-03-26','14:15:00',2.06),('15128','2013-03-26','14:20:00',2.03),('15128','2013-03-26','14:25:00',1.82),('15128','2013-03-26','14:30:00',1.57),('15128','2013-03-26','14:35:00',1.67),('15128','2013-03-26','14:40:00',2),('15128','2013-03-26','14:45:00',2.09),('15128','2013-03-26','14:50:00',2.61),('15128','2013-03-26','14:55:00',3.09),('15128','2013-03-26','15:00:00',1.97),('15128','2013-03-26','15:05:00',1.53),('15128','2013-03-26','15:20:00',1.35),('15128','2013-03-26','15:25:00',1.64),('15128','2013-03-26','15:30:00',1.09),('15128','2013-03-26','16:20:00',1.56),('15128','2013-03-26','16:25:00',1.37),('15128','2013-03-26','16:30:00',1.61),('15128','2013-03-26','16:35:00',1.63),('15128','2013-03-26','16:40:00',1.76),('15128','2013-03-26','16:45:00',1.08),('15128','2013-03-26','16:50:00',1.06),('15128','2013-03-26','16:55:00',1.42),('15128','2013-03-26','17:00:00',1.74),('15128','2013-03-26','17:05:00',1.44),('15128','2013-03-25','08:30:00',1),('15128','2013-03-25','08:35:00',1.14),('15128','2013-03-25','08:40:00',1.12),('15128','2013-03-25','09:10:00',1.57),('15128','2013-03-25','09:15:00',1.16),('15128','2013-03-25','10:00:00',1.9),('15128','2013-03-25','10:05:00',1.48),('15128','2013-03-25','10:30:00',1.38),('15128','2013-03-25','10:35:00',1.56),('15128','2013-03-25','10:40:00',1.52),('15128','2013-03-25','10:45:00',1.68),('15128','2013-03-25','10:50:00',2.01),('15128','2013-03-25','10:55:00',2.57),('15128','2013-03-25','11:00:00',2.34),('15128','2013-03-25','11:35:00',1.25),('15128','2013-03-25','11:40:00',3.64),('15128','2013-03-25','11:45:00',4.49),('15128','2013-03-25','11:50:00',2.96),('15128','2013-03-25','11:55:00',3.78),('15128','2013-03-25','12:00:00',1.47),('15128','2013-03-25','12:10:00',1.14),('15128','2013-03-25','12:15:00',1.55),('15128','2013-03-25','12:20:00',2.71),('15128','2013-03-25','12:25:00',3.59),('15128','2013-03-25','12:30:00',3.29),('15128','2013-03-25','12:35:00',1.91),('15128','2013-03-25','12:40:00',1.33),('15128','2013-03-25','12:45:00',1.88),('15128','2013-03-25','12:50:00',3.08),('15128','2013-03-25','12:55:00',2.61),('15128','2013-03-25','13:00:00',1.88),('15128','2013-03-25','13:05:00',2.71),('15128','2013-03-25','13:10:00',1.86),('15128','2013-03-25','13:15:00',1.7),('15128','2013-03-25','13:20:00',1.61),('15128','2013-03-25','13:25:00',1.92),('15128','2013-03-25','13:30:00',1.9),('15128','2013-03-25','13:35:00',2.45),('15128','2013-03-25','13:40:00',2.83),('15128','2013-03-25','13:45:00',2.39),('15128','2013-03-25','13:50:00',2.02),('15128','2013-03-25','13:55:00',1.58),('15128','2013-03-25','14:00:00',1.13),('15128','2013-03-25','14:05:00',1.84),('15128','2013-03-25','14:10:00',2.28),('15128','2013-03-25','14:15:00',1.74),('15128','2013-03-25','14:20:00',1.39),('15128','2013-03-25','14:25:00',1.06),('15128','2013-03-25','14:30:00',1.18),('15128','2013-03-25','14:35:00',1.35),('15128','2013-03-25','14:40:00',1.36),('15128','2013-03-25','14:45:00',1.12),('15128','2013-03-25','15:05:00',1.1),('15128','2013-03-25','15:30:00',1),('15128','2013-03-24','08:20:00',1.01),('15128','2013-03-24','08:25:00',1.31),('15128','2013-03-24','08:30:00',1.92),('15128','2013-03-24','08:35:00',1.18),('15128','2013-03-24','08:50:00',1.02),('15128','2013-03-24','08:55:00',1.14),('15128','2013-03-24','09:00:00',1.05),('15128','2013-03-24','09:20:00',1.11),('15128','2013-03-24','09:25:00',2.07),('15128','2013-03-24','09:30:00',1.1),('15128','2013-03-24','09:40:00',1.07),('15128','2013-03-24','09:45:00',1.07),('15128','2013-03-24','09:50:00',1.11),('15128','2013-03-24','09:55:00',1.22),('15128','2013-03-24','10:00:00',1.17),('15128','2013-03-24','10:05:00',1.12),('15128','2013-03-24','10:10:00',1.44),('15128','2013-03-24','10:15:00',1.92),('15128','2013-03-24','10:20:00',1.25),('15128','2013-03-24','10:25:00',1.17),('15128','2013-03-24','10:30:00',1.5),('15128','2013-03-24','10:35:00',1.71),('15128','2013-03-24','10:40:00',1.84),('15128','2013-03-24','10:45:00',2.34),('15128','2013-03-24','10:50:00',2.89),('15128','2013-03-24','10:55:00',2.43),('15128','2013-03-24','11:00:00',1.28),('15128','2013-03-24','11:05:00',1.04),('15128','2013-03-24','11:10:00',1.06),('15128','2013-03-24','11:15:00',1.05),('15128','2013-03-24','11:25:00',1.23),('15128','2013-03-24','11:40:00',2.37),('15128','2013-03-24','11:45:00',4.71),('15128','2013-03-24','11:50:00',4.66),('15128','2013-03-24','11:55:00',4.73),('15128','2013-03-24','12:00:00',3.9),('15128','2013-03-24','12:05:00',3.02),('15128','2013-03-24','12:10:00',1.48),('15128','2013-03-24','12:15:00',3.02),('15128','2013-03-24','12:20:00',5.72),('15128','2013-03-24','12:25:00',5.2),('15128','2013-03-24','12:30:00',4.09),('15128','2013-03-24','12:35:00',3.76),('15128','2013-03-24','12:40:00',3.88),('15128','2013-03-24','12:45:00',5.02),('15128','2013-03-24','12:50:00',5),('15128','2013-03-24','12:55:00',2.92),('15128','2013-03-24','13:00:00',1.9),('15128','2013-03-24','13:05:00',1.8),('15128','2013-03-24','13:10:00',1.8),('15128','2013-03-24','13:15:00',2.8),('15128','2013-03-24','13:20:00',2.21),('15128','2013-03-24','13:25:00',3.53),('15128','2013-03-24','13:30:00',2.88),('15128','2013-03-24','13:35:00',2.73),('15128','2013-03-24','13:40:00',1.61),('15128','2013-03-24','13:45:00',2.58),('15128','2013-03-24','13:50:00',5.28),('15128','2013-03-24','13:55:00',5.33),('15128','2013-03-24','14:00:00',4.37),('15128','2013-03-24','14:05:00',2.93),('15128','2013-03-24','14:10:00',3.99),('15128','2013-03-24','14:15:00',4.11),('15128','2013-03-24','14:20:00',4.04),('15128','2013-03-24','14:25:00',4.57),('15128','2013-03-24','14:30:00',4.31),('15128','2013-03-24','14:35:00',2.43),('15128','2013-03-24','14:40:00',2.03),('15128','2013-03-24','14:45:00',2.28),('15128','2013-03-24','14:50:00',2.71),('15128','2013-03-24','14:55:00',2.93),('15128','2013-03-24','15:00:00',2.21),('15128','2013-03-24','15:05:00',3.77),('15128','2013-03-24','15:10:00',3.5),('15128','2013-03-24','15:15:00',3.39),('15128','2013-03-24','15:20:00',2.37),('15128','2013-03-24','15:25:00',3.99),('15128','2013-03-24','15:30:00',2.8),('15128','2013-03-24','15:35:00',3.36),('15128','2013-03-24','15:40:00',2.67),('15128','2013-03-24','15:45:00',3.44),('15128','2013-03-24','15:50:00',3.38),('15128','2013-03-24','15:55:00',2.75),('15128','2013-03-24','16:00:00',1.37),('15128','2013-03-24','16:05:00',1.02),('15128','2013-03-24','16:20:00',1.7),('15128','2013-03-24','16:25:00',1.69),('15128','2013-03-24','16:30:00',1.98),('15128','2013-03-24','16:35:00',1.07),('15128','2013-03-24','16:40:00',1.12),('15128','2013-03-24','16:45:00',1.02),('15128','2013-03-23','08:05:00',1.01),('15128','2013-03-23','08:10:00',1.09),('15128','2013-03-23','08:15:00',1.21),('15128','2013-03-23','08:20:00',1.29),('15128','2013-03-23','08:25:00',1.34),('15128','2013-03-23','08:30:00',1.43),('15128','2013-03-23','08:35:00',1.51),('15128','2013-03-23','08:40:00',1.58),('15128','2013-03-23','08:45:00',1.66),('15128','2013-03-23','08:50:00',1.69),('15128','2013-03-23','08:55:00',1.72),('15128','2013-03-23','09:00:00',1.79),('15128','2013-03-23','09:05:00',1.84),('15128','2013-03-23','09:10:00',1.93),('15128','2013-03-23','09:15:00',1.98),('15128','2013-03-23','09:20:00',2.02),('15128','2013-03-23','09:25:00',2.06),('15128','2013-03-23','09:30:00',2.15),('15128','2013-03-23','09:35:00',2.19),('15128','2013-03-23','09:40:00',2.24),('15128','2013-03-23','09:45:00',2.33),('15128','2013-03-23','09:50:00',2.34),('15128','2013-03-23','09:55:00',2.38),('15128','2013-03-23','10:00:00',2.41),('15128','2013-03-23','10:05:00',2.48),('15128','2013-03-23','10:10:00',2.54),('15128','2013-03-23','10:15:00',2.65),('15128','2013-03-23','10:20:00',2.75),('15128','2013-03-23','10:25:00',2.77),('15128','2013-03-23','10:30:00',2.89),('15128','2013-03-23','10:35:00',2.96),('15128','2013-03-23','10:40:00',2.93),('15128','2013-03-23','10:45:00',3.03),('15128','2013-03-23','10:50:00',3.04),('15128','2013-03-23','10:55:00',3.16),('15128','2013-03-23','11:00:00',3.22),('15128','2013-03-23','11:05:00',3.35),('15128','2013-03-23','11:10:00',3.44),('15128','2013-03-23','11:15:00',3.5),('15128','2013-03-23','11:20:00',3.54),('15128','2013-03-23','11:25:00',3.59),('15128','2013-03-23','11:30:00',3.61),('15128','2013-03-23','11:35:00',3.64),('15128','2013-03-23','11:40:00',3.67),('15128','2013-03-23','11:45:00',3.71),('15128','2013-03-23','11:50:00',3.72),('15128','2013-03-23','11:55:00',3.75),('15128','2013-03-23','12:00:00',3.78),('15128','2013-03-23','12:05:00',3.8),('15128','2013-03-23','12:10:00',3.8),('15128','2013-03-23','12:15:00',3.86),('15128','2013-03-23','12:20:00',3.92),('15128','2013-03-23','12:25:00',3.99),('15128','2013-03-23','12:30:00',4.02),('15128','2013-03-23','12:35:00',4.04),('15128','2013-03-23','12:40:00',4.05),('15128','2013-03-23','12:45:00',4.09),('15128','2013-03-23','12:50:00',4.11),('15128','2013-03-23','12:55:00',4.09),('15128','2013-03-23','13:00:00',4.09),('15128','2013-03-23','13:05:00',4.12),('15128','2013-03-23','13:10:00',4.09),('15128','2013-03-23','13:15:00',4.08),('15128','2013-03-23','13:20:00',4.08),('15128','2013-03-23','13:25:00',4.05),('15128','2013-03-23','13:30:00',4.04),('15128','2013-03-23','13:35:00',4.04),('15128','2013-03-23','13:40:00',4.01),('15128','2013-03-23','13:45:00',4.01),('15128','2013-03-23','13:50:00',3.98),('15128','2013-03-23','13:55:00',3.93),('15128','2013-03-23','14:00:00',3.87),('15128','2013-03-23','14:05:00',3.88),('15128','2013-03-23','14:10:00',3.84),('15128','2013-03-23','14:15:00',3.8),('15128','2013-03-23','14:20:00',3.71),('15128','2013-03-23','14:25:00',3.62),('15128','2013-03-23','14:30:00',3.56),('15128','2013-03-23','14:35:00',3.41),('15128','2013-03-23','14:40:00',3.49),('15128','2013-03-23','14:45:00',3.47),('15128','2013-03-23','14:50:00',3.37),('15128','2013-03-23','14:55:00',3.27),('15128','2013-03-23','15:00:00',3.23),('15128','2013-03-23','15:05:00',3.18),('15128','2013-03-23','15:10:00',3.14),('15128','2013-03-23','15:15:00',3.08),('15128','2013-03-23','15:20:00',3.11),('15128','2013-03-23','15:25:00',2.95),('15128','2013-03-23','15:30:00',2.8),('15128','2013-03-23','15:35:00',2.94),('15128','2013-03-23','15:40:00',2.65),('15128','2013-03-23','15:45:00',2.29),('15128','2013-03-23','15:50:00',1.39),('15128','2013-03-23','15:55:00',1.65),('15128','2013-03-23','16:00:00',1.5),('15128','2013-03-23','16:05:00',1.4),('15128','2013-03-23','16:10:00',1.25),('15128','2013-03-23','16:15:00',1.95),('15128','2013-03-23','16:20:00',1.76),('15128','2013-03-23','16:25:00',1.35),('15128','2013-03-23','16:30:00',1.26),('15128','2013-03-23','16:35:00',1.27),('15128','2013-03-22','08:10:00',1.06),('15128','2013-03-22','08:15:00',1.14),('15128','2013-03-22','08:20:00',1.24),('15128','2013-03-22','08:25:00',1.31),('15128','2013-03-22','08:30:00',1.41),('15128','2013-03-22','08:35:00',1.46),('15128','2013-03-22','08:40:00',1.57),('15128','2013-03-22','08:45:00',1.64),('15128','2013-03-22','08:50:00',1.73),('15128','2013-03-22','08:55:00',1.74),('15128','2013-03-22','09:00:00',1.86),('15128','2013-03-22','09:05:00',1.91),('15128','2013-03-22','09:10:00',2),('15128','2013-03-22','09:15:00',2.02),('15128','2013-03-22','09:20:00',2.08),('15128','2013-03-22','09:25:00',2.13),('15128','2013-03-22','09:30:00',2.2),('15128','2013-03-22','09:35:00',2.23),('15128','2013-03-22','09:40:00',2.23),('15128','2013-03-22','09:45:00',2.33),('15128','2013-03-22','09:50:00',2.34),('15128','2013-03-22','09:55:00',2.46),('15128','2013-03-22','10:00:00',2.47),('15128','2013-03-22','10:05:00',1.61),('15128','2013-03-22','10:10:00',2.59),('15128','2013-03-22','10:15:00',2.71),('15128','2013-03-22','10:20:00',2.89),('15128','2013-03-22','10:25:00',2.95),('15128','2013-03-22','10:30:00',2.88),('15128','2013-03-22','10:35:00',3.07),('15128','2013-03-22','10:40:00',3.1),('15128','2013-03-22','10:45:00',3.2),('15128','2013-03-22','10:50:00',3),('15128','2013-03-22','10:55:00',3.15),('15128','2013-03-22','11:00:00',2.79),('15128','2013-03-22','11:05:00',2.73),('15128','2013-03-22','11:10:00',3.24),('15128','2013-03-22','11:15:00',3.39),('15128','2013-03-22','11:20:00',3.09),('15128','2013-03-22','11:25:00',3.43),('15128','2013-03-22','11:30:00',3.64),('15128','2013-03-22','11:35:00',3.62),('15128','2013-03-22','11:40:00',3.41),('15128','2013-03-22','11:45:00',3.47),('15128','2013-03-22','11:50:00',3.6),('15128','2013-03-22','11:55:00',3.72),('15128','2013-03-22','12:00:00',3.79),('15128','2013-03-22','12:05:00',3.82),('15128','2013-03-22','12:10:00',3.9),('15128','2013-03-22','12:15:00',3.66),('15128','2013-03-22','12:20:00',3.95),('15128','2013-03-22','12:25:00',3.87),('15128','2013-03-22','12:30:00',3.75),('15128','2013-03-22','12:35:00',3.69),('15128','2013-03-22','12:40:00',3.87),('15128','2013-03-22','12:45:00',3.94),('15128','2013-03-22','12:50:00',4.04),('15128','2013-03-22','12:55:00',4),('15128','2013-03-22','13:00:00',3.64),('15128','2013-03-22','13:05:00',3.87),('15128','2013-03-22','13:10:00',3.87),('15128','2013-03-22','13:15:00',4.11),('15128','2013-03-22','13:20:00',4.05),('15128','2013-03-22','13:25:00',3.84),('15128','2013-03-22','13:30:00',3.35),('15128','2013-03-22','13:35:00',3.88),('15128','2013-03-22','13:40:00',3.94),('15128','2013-03-22','13:45:00',3.98),('15128','2013-03-22','13:50:00',3.96),('15128','2013-03-22','13:55:00',3.94),('15128','2013-03-22','14:00:00',3.96),('15128','2013-03-22','14:05:00',3.86),('15128','2013-03-22','14:10:00',3.7),('15128','2013-03-22','14:15:00',3.66),('15128','2013-03-22','14:20:00',3.78),('15128','2013-03-22','14:25:00',3.65),('15128','2013-03-22','14:30:00',3.64),('15128','2013-03-22','14:35:00',3.65),('15128','2013-03-22','14:40:00',3.42),('15128','2013-03-22','14:45:00',3.28),('15128','2013-03-22','14:50:00',3.39),('15128','2013-03-22','14:55:00',3.29),('15128','2013-03-22','15:00:00',3.23),('15128','2013-03-22','15:05:00',3.34),('15128','2013-03-22','15:10:00',2.88),('15128','2013-03-22','15:15:00',2.88),('15128','2013-03-22','15:20:00',3.06),('15128','2013-03-22','15:25:00',2.98),('15128','2013-03-22','15:30:00',2.8),('15128','2013-03-22','15:35:00',2.65),('15128','2013-03-22','15:40:00',2.72),('15128','2013-03-22','15:45:00',2.29),('15128','2013-03-22','15:50:00',1.94),('15128','2013-03-22','15:55:00',2.18),('15128','2013-03-22','16:00:00',1.97),('15128','2013-03-22','16:05:00',2.1),('15128','2013-03-22','16:10:00',2.29),('15128','2013-03-22','16:15:00',2.29),('15128','2013-03-22','16:20:00',2.02),('15128','2013-03-22','16:25:00',1.96),('15128','2013-03-22','16:30:00',1.68),('15128','2013-03-22','16:35:00',1.61),('15128','2013-03-22','16:40:00',1.35),('15128','2013-03-22','16:45:00',1.29),('15128','2013-03-22','16:50:00',1.35),('15128','2013-03-22','16:55:00',1.29),('15128','2013-03-22','17:00:00',1.6),('15128','2013-03-22','17:05:00',1.54),('15128','2013-03-22','17:10:00',1.31),('15128','2013-03-22','17:15:00',1.12),('15128','2014-03-25','08:00:00',1.06),('15128','2014-03-25','08:05:00',1.11),('15128','2014-03-25','08:10:00',1.11),('15128','2014-03-25','08:15:00',1.31),('15128','2014-03-25','08:20:00',1.62),('15128','2014-03-25','08:25:00',1.05),('15128','2014-03-25','08:30:00',1.03),('15128','2014-03-25','08:45:00',1.11),('15128','2014-03-25','08:50:00',1.03),('15128','2014-03-25','08:55:00',1.06),('15128','2014-03-25','09:00:00',1.19),('15128','2014-03-25','09:05:00',1.42),('15128','2014-03-25','09:10:00',1.73),('15128','2014-03-25','09:15:00',1.25),('15128','2014-03-25','09:20:00',1.59),('15128','2014-03-25','09:25:00',2.12),('15128','2014-03-25','09:30:00',2.2),('15128','2014-03-25','09:35:00',2.2),('15128','2014-03-25','09:40:00',2.19),('15128','2014-03-25','09:45:00',2.28),('15128','2014-03-25','09:50:00',2.37),('15128','2014-03-25','09:55:00',2.4),('15128','2014-03-25','10:00:00',2.51),('15128','2014-03-25','10:05:00',2.15),('15128','2014-03-25','10:10:00',2.58),('15128','2014-03-25','10:15:00',2.74),('15128','2014-03-25','10:20:00',2.88),('15128','2014-03-25','10:25:00',2.97),('15128','2014-03-25','10:30:00',2.79),('15128','2014-03-25','10:35:00',3.06),('15128','2014-03-25','10:40:00',1.81),('15128','2014-03-25','10:45:00',2.21),('15128','2014-03-25','10:50:00',1.35),('15128','2014-03-25','10:55:00',1.04),('15128','2014-03-25','11:00:00',1.08),('15128','2014-03-25','11:15:00',1.23),('15128','2014-03-25','11:20:00',1.6),('15128','2014-03-25','11:25:00',1.7),('15128','2014-03-25','11:30:00',1.3),('15128','2014-03-25','11:35:00',1.08),('15128','2014-03-25','12:00:00',1.83),('15128','2014-03-25','12:05:00',2.94),('15128','2014-03-25','12:10:00',2.08),('15128','2014-03-25','12:15:00',1.43),('15128','2014-03-25','12:20:00',1.08),('15128','2014-03-25','12:25:00',1.34),('15128','2014-03-25','12:30:00',1.77),('15128','2014-03-25','12:35:00',2.18),('15128','2014-03-25','12:40:00',2.97),('15128','2014-03-25','12:45:00',2.88),('15128','2014-03-25','12:50:00',4.37),('15128','2014-03-25','12:55:00',3.99),('15128','2014-03-25','13:00:00',2.17),('15128','2014-03-25','13:05:00',4.09),('15128','2014-03-25','13:10:00',1.58),('15128','2014-03-25','13:15:00',1.66),('15128','2014-03-25','13:20:00',1.62),('15128','2014-03-25','13:25:00',1.23),('15128','2014-03-25','13:30:00',1.09),('15128','2014-03-25','13:35:00',1.09),('15128','2014-03-25','13:40:00',1.67),('15128','2014-03-25','13:45:00',2.03),('15128','2014-03-25','13:50:00',2.39),('15128','2014-03-25','13:55:00',2.7),('15128','2014-03-25','14:00:00',3.69),('15128','2014-03-25','14:05:00',3.92),('15128','2014-03-25','14:10:00',3.59),('15128','2014-03-25','14:15:00',1.73),('15128','2014-03-25','14:20:00',3.81),('15128','2014-03-25','14:25:00',1.66),('15128','2014-03-25','15:10:00',1.28),('15128','2014-03-25','15:15:00',2.94),('15128','2014-03-25','15:20:00',3.46),('15128','2014-03-25','15:25:00',1.94),('15128','2014-03-25','15:30:00',3.03),('15128','2014-03-25','15:35:00',3.33),('15128','2014-03-25','15:40:00',2.87),('15128','2014-03-25','15:45:00',2.27),('15128','2014-03-25','15:50:00',1.4),('15128','2014-03-25','15:55:00',1.09),('15128','2014-03-25','16:25:00',1.61),('15128','2014-03-25','16:30:00',2.01),('15128','2014-03-25','16:35:00',1.18),('15128','2013-03-21','08:15:00',1.08),('15128','2013-03-21','08:20:00',1.18),('15128','2013-03-21','08:25:00',1.29),('15128','2013-03-21','08:30:00',1.37),('15128','2013-03-21','08:35:00',1.47),('15128','2013-03-21','08:40:00',1.56),('15128','2013-03-21','08:45:00',1.62),('15128','2013-03-21','08:50:00',1.67),('15128','2013-03-21','08:55:00',1.7),('15128','2013-03-21','09:00:00',1.81),('15128','2013-03-21','09:05:00',1.91),('15128','2013-03-21','09:10:00',1.97),('15128','2013-03-21','09:15:00',1.97),('15128','2013-03-21','09:20:00',2.01),('15128','2013-03-21','09:25:00',2.03),('15128','2013-03-21','09:30:00',2.1),('15128','2013-03-21','09:35:00',2.2),('15128','2013-03-21','09:40:00',2.23),('15128','2013-03-21','09:45:00',2.29),('15128','2013-03-21','09:50:00',2.38),('15128','2013-03-21','09:55:00',2.48),('15128','2013-03-21','10:00:00',2.51),('15128','2013-03-21','10:05:00',2.61),('15128','2013-03-21','10:10:00',2.62),('15128','2013-03-21','10:15:00',2.68),('15128','2013-03-21','10:20:00',2.76),('15128','2013-03-21','10:25:00',2.79),('15128','2013-03-21','10:30:00',2.88),('15128','2013-03-21','10:35:00',2.95),('15128','2013-03-21','10:40:00',3),('15128','2013-03-21','10:45:00',3.07),('15128','2013-03-21','10:50:00',3.11),('15128','2013-03-21','10:55:00',3.2),('15128','2013-03-21','11:00:00',3.24),('15128','2013-03-21','11:05:00',3.46),('15128','2013-03-21','11:10:00',3.57),('15128','2013-03-21','11:15:00',3.64),('15128','2013-03-21','11:20:00',3.67),('15128','2013-03-21','11:25:00',3.75),('15128','2013-03-21','11:30:00',3.79),('15128','2013-03-21','11:35:00',3.85),('15128','2013-03-21','11:40:00',3.87),('15128','2013-03-21','11:45:00',3.94),('15128','2013-03-21','11:50:00',3.96),('15128','2013-03-21','11:55:00',4.02),('15128','2013-03-21','12:00:00',4.05),('15128','2013-03-21','12:05:00',4.08),('15128','2013-03-21','12:10:00',4.12),('15128','2013-03-21','12:15:00',4.14),('15128','2013-03-21','12:20:00',4.17),('15128','2013-03-21','12:25:00',4.19),('15128','2013-03-21','12:30:00',4.22),('15128','2013-03-21','12:35:00',4.22),('15128','2013-03-21','12:40:00',4.24),('15128','2013-03-21','12:45:00',4.26),('15128','2013-03-21','12:50:00',3.72),('15128','2013-03-21','12:55:00',4.13),('15128','2013-03-21','13:00:00',4.13),('15128','2013-03-21','13:05:00',4.31),('15128','2013-03-21','13:10:00',4.25),('15128','2013-03-21','13:15:00',4.25),('15128','2013-03-21','13:20:00',4.06),('15128','2013-03-21','13:25:00',3.98),('15128','2013-03-21','13:30:00',4.17),('15128','2013-03-21','13:35:00',3.66),('15128','2013-03-21','13:40:00',3.29),('15128','2013-03-21','13:45:00',4.11),('15128','2013-03-21','13:50:00',4.11),('15128','2013-03-21','13:55:00',4.08),('15128','2013-03-21','14:00:00',4.07),('15128','2013-03-21','14:05:00',4.03),('15128','2013-03-21','14:10:00',3.99),('15128','2013-03-21','14:15:00',3.99),('15128','2013-03-21','14:20:00',3.93),('15128','2013-03-21','14:25:00',3.89),('15128','2013-03-21','14:30:00',3.85),('15128','2013-03-21','14:35:00',3.8),('15128','2013-03-21','14:40:00',3.76),('15128','2013-03-21','14:45:00',3.75),('15128','2013-03-21','14:50:00',3.63),('15128','2013-03-21','14:55:00',3.41),('15128','2013-03-21','15:00:00',2.64),('15128','2013-03-21','15:05:00',2.44),('15128','2013-03-21','15:10:00',3.41),('15128','2013-03-21','15:15:00',2.68),('15128','2013-03-21','15:20:00',2.75),('15128','2013-03-21','15:25:00',2.69),('15128','2013-03-21','15:30:00',2.97),('15128','2013-03-21','15:35:00',2.97),('15128','2013-03-21','15:40:00',2.83),('15128','2013-03-21','15:45:00',2.84),('15128','2013-03-21','15:50:00',2.77),('15128','2013-03-21','15:55:00',1.85),('15128','2013-03-21','16:00:00',1.56),('15128','2013-03-21','16:05:00',1.74),('15128','2013-03-21','16:10:00',2.25),('15128','2013-03-21','16:15:00',2.14),('15128','2013-03-21','16:20:00',1.15),('15128','2013-03-21','16:25:00',1.82),('15128','2013-03-21','16:30:00',2),('15128','2013-03-21','16:35:00',1.97),('15128','2013-03-21','16:40:00',1.84),('15128','2013-03-21','16:45:00',1.98),('15128','2013-03-21','16:50:00',2.03),('15128','2013-03-21','16:55:00',1.43),('15128','2013-03-21','17:00:00',1.7),('15128','2013-03-21','17:05:00',1.52),('15128','2013-03-21','17:10:00',1.02),('15128','2013-03-21','17:15:00',1.2),('15128','2013-03-20','08:15:00',1.11),('15128','2013-03-20','08:20:00',1.26),('15128','2013-03-20','08:25:00',1.41),('15128','2013-03-20','08:30:00',1.51),('15128','2013-03-20','08:35:00',1.64),('15128','2013-03-20','08:40:00',1.72),('15128','2013-03-20','08:45:00',2.14),('15128','2013-03-20','08:55:00',1.25),('15128','2013-03-20','09:00:00',1.93),('15128','2013-03-20','09:05:00',1.96),('15128','2013-03-20','09:10:00',1.66),('15128','2013-03-20','09:15:00',2.08),('15128','2013-03-20','09:20:00',2.14),('15128','2013-03-20','09:25:00',2.18),('15128','2013-03-20','09:30:00',2.28),('15128','2013-03-20','09:35:00',2.32),('15128','2013-03-20','09:40:00',2.37),('15128','2013-03-20','09:45:00',2.49),('15128','2013-03-20','09:50:00',2.53),('15128','2013-03-20','09:55:00',2.37),('15128','2013-03-20','10:00:00',2.66),('15128','2013-03-20','10:05:00',2.71),('15128','2013-03-20','10:10:00',2.88),('15128','2013-03-20','10:15:00',2.13),('15128','2013-03-20','10:20:00',2.52),('15128','2013-03-20','10:25:00',2.87),('15128','2013-03-20','10:30:00',3),('15128','2013-03-20','10:35:00',3.06),('15128','2013-03-20','10:40:00',3.19),('15128','2013-03-20','10:45:00',3.23),('15128','2013-03-20','10:50:00',3.27),('15128','2013-03-20','10:55:00',3.33),('15128','2013-03-20','11:00:00',3.42),('15128','2013-03-20','11:05:00',3.58),('15128','2013-03-20','11:10:00',3.66),('15128','2013-03-20','11:15:00',3.79),('15128','2013-03-20','11:20:00',3.82),('15128','2013-03-20','11:25:00',3.87),('15128','2013-03-20','11:30:00',3.93),('15128','2013-03-20','11:35:00',3.98),('15128','2013-03-20','11:40:00',4.01),('15128','2013-03-20','11:45:00',4.07),('15128','2013-03-20','11:50:00',4.1),('15128','2013-03-20','11:55:00',4.14),('15128','2013-03-20','12:00:00',4.18),('15128','2013-03-20','12:05:00',4.24),('15128','2013-03-20','12:10:00',4.26),('15128','2013-03-20','12:15:00',4.28),('15128','2013-03-20','12:20:00',4.33),('15128','2013-03-20','12:25:00',4.34),('15128','2013-03-20','12:30:00',4.34),('15128','2013-03-20','12:35:00',4.35),('15128','2013-03-20','12:40:00',4.38),('15128','2013-03-20','12:45:00',4.37),('15128','2013-03-20','12:50:00',4.38),('15128','2013-03-20','12:55:00',4.38),('15128','2013-03-20','13:00:00',4.37),('15128','2013-03-20','13:05:00',4.37),('15128','2013-03-20','13:10:00',4.37),('15128','2013-03-20','13:15:00',4.35),('15128','2013-03-20','13:20:00',4.36),('15128','2013-03-20','13:25:00',4.34),('15128','2013-03-20','13:30:00',4.31),('15128','2013-03-20','13:35:00',4.27),('15128','2013-03-20','13:40:00',4.26),('15128','2013-03-20','13:45:00',4.23),('15128','2013-03-20','13:50:00',4.22),('15128','2013-03-20','13:55:00',4.19),('15128','2013-03-20','14:00:00',4.16),('15128','2013-03-20','14:05:00',4.15),('15128','2013-03-20','14:10:00',4.09),('15128','2013-03-20','14:15:00',4.05),('15128','2013-03-20','14:20:00',4.02),('15128','2013-03-20','14:25:00',3.98),('15128','2013-03-20','14:30:00',3.93),('15128','2013-03-20','14:35:00',3.87),('15128','2013-03-20','14:40:00',3.81),('15128','2013-03-20','14:45:00',3.76),('15128','2013-03-20','14:50:00',3.7),('15128','2013-03-20','14:55:00',3.66),('15128','2013-03-20','15:00:00',3.62),('15128','2013-03-20','15:05:00',3.58),('15128','2013-03-20','15:10:00',3.5),('15128','2013-03-20','15:15:00',3.44),('15128','2013-03-20','15:20:00',3.39),('15128','2013-03-20','15:25:00',3.32),('15128','2013-03-20','15:30:00',3.26),('15128','2013-03-20','15:35:00',3.19),('15128','2013-03-20','15:40:00',3.11),('15128','2013-03-20','15:45:00',3.02),('15128','2013-03-20','15:50:00',2.95),('15128','2013-03-20','15:55:00',2.82),('15128','2013-03-20','16:00:00',2.71),('15128','2013-03-20','16:05:00',2.63),('15128','2013-03-20','16:10:00',2.52),('15128','2013-03-20','16:15:00',2.42),('15128','2013-03-20','16:20:00',2.32),('15128','2013-03-20','16:25:00',2.2),('15128','2013-03-20','16:30:00',2.08),('15128','2013-03-20','16:35:00',2.01),('15128','2013-03-20','16:40:00',1.96),('15128','2013-03-20','16:45:00',1.87),('15128','2013-03-20','16:50:00',1.79),('15128','2013-03-20','16:55:00',1.69),('15128','2013-03-20','17:00:00',1.55),('15128','2013-03-20','17:05:00',1.35),('15128','2013-03-20','17:10:00',1.23),('15128','2013-03-20','17:15:00',1.14),('15128','2013-03-20','17:20:00',1.02),('15128','2013-03-19','08:15:00',1.03),('15128','2013-03-19','08:20:00',1.13),('15128','2013-03-19','08:25:00',1.23),('15128','2013-03-19','08:30:00',1.33),('15128','2013-03-19','08:35:00',1.35),('15128','2013-03-19','08:40:00',1.36),('15128','2013-03-19','08:45:00',1.52),('15128','2013-03-19','08:50:00',1.52),('15128','2013-03-19','08:55:00',1.56),('15128','2013-03-19','09:00:00',1.88),('15128','2013-03-19','09:05:00',1.71),('15128','2013-03-19','09:10:00',1.58),('15128','2013-03-19','09:15:00',2.14),('15128','2013-03-19','09:20:00',2.27),('15128','2013-03-19','09:25:00',2.15),('15128','2013-03-19','09:30:00',1.75),('15128','2013-03-19','09:35:00',2),('15128','2013-03-19','09:40:00',2.19),('15128','2013-03-19','09:45:00',2.23),('15128','2013-03-19','09:50:00',2.33),('15128','2013-03-19','09:55:00',2.52),('15128','2013-03-19','10:00:00',2.62),('15128','2013-03-19','10:05:00',2.67),('15128','2013-03-19','10:10:00',2.59),('15128','2013-03-19','10:15:00',2.27),('15128','2013-03-19','10:20:00',2.02),('15128','2013-03-19','10:25:00',2.48),('15128','2013-03-19','10:30:00',2.97),('15128','2013-03-19','10:35:00',2.53),('15128','2013-03-19','10:40:00',2.22),('15128','2013-03-19','10:45:00',2.24),('15128','2013-03-19','10:50:00',2.74),('15128','2013-03-19','10:55:00',2.75),('15128','2013-03-19','11:00:00',2.47),('15128','2013-03-19','11:05:00',2.44),('15128','2013-03-19','11:10:00',2.33),('15128','2013-03-19','11:15:00',2.26),('15128','2013-03-19','11:20:00',2.51),('15128','2013-03-19','11:25:00',2.27),('15128','2013-03-19','11:30:00',2.32),('15128','2013-03-19','11:35:00',2.68),('15128','2013-03-19','11:40:00',2.27),('15128','2013-03-19','11:45:00',2.02),('15128','2013-03-19','11:50:00',2.06),('15128','2013-03-19','11:55:00',2.07),('15128','2013-03-19','12:00:00',2.24),('15128','2013-03-19','12:05:00',2.17),('15128','2013-03-19','12:10:00',2.02),('15128','2013-03-19','12:15:00',1.62),('15128','2013-03-19','12:20:00',1.48),('15128','2013-03-19','12:25:00',1.27),('15128','2013-03-19','12:30:00',1.24),('15128','2013-03-19','12:35:00',1.28),('15128','2013-03-19','12:40:00',1.08),('15128','2013-03-19','12:50:00',1.27),('15128','2013-03-19','12:55:00',1.68),('15128','2013-03-19','13:00:00',1.3),('15128','2013-03-19','13:05:00',1.01),('15128','2013-03-19','13:10:00',1.14),('15128','2013-03-19','13:15:00',1.01),('15128','2013-03-19','13:20:00',1.09),('15128','2013-03-19','13:25:00',1.4),('15128','2013-03-19','13:30:00',1.62),('15128','2013-03-19','13:35:00',1.53),('15128','2013-03-19','13:40:00',1.94),('15128','2013-03-19','13:45:00',2.03),('15128','2013-03-19','13:50:00',1.7),('15128','2013-03-19','13:55:00',1.8),('15128','2013-03-19','14:00:00',1.63),('15128','2013-03-19','14:05:00',1.36),('15128','2013-03-19','14:10:00',1.3),('15128','2013-03-19','14:15:00',1.7),('15128','2013-03-19','14:20:00',2.04),('15128','2013-03-19','14:25:00',2.28),('15128','2013-03-19','14:30:00',2.14),('15128','2013-03-19','14:35:00',1.55),('15128','2013-03-19','14:40:00',1.23),('15128','2013-03-19','14:45:00',1.03),('15128','2013-03-18','08:25:00',1.11),('15128','2013-03-18','08:30:00',1.23),('15128','2013-03-18','08:35:00',1.3),('15128','2013-03-18','08:40:00',1.39),('15128','2013-03-18','08:45:00',1.46),('15128','2013-03-18','08:50:00',1.5),('15128','2013-03-18','08:55:00',1.56),('15128','2013-03-18','09:00:00',1.63),('15128','2013-03-18','09:05:00',1.69),('15128','2013-03-18','09:10:00',1.8),('15128','2013-03-18','09:15:00',1.82),('15128','2013-03-18','09:20:00',1.86),('15128','2013-03-18','09:25:00',1.96),('15128','2013-03-18','09:30:00',2),('15128','2013-03-18','09:35:00',2.13),('15128','2013-03-18','09:40:00',2.17),('15128','2013-03-18','09:45:00',2.19),('15128','2013-03-18','09:50:00',2.31),('15128','2013-03-18','09:55:00',2.41),('15128','2013-03-18','10:00:00',2.45),('15128','2013-03-18','10:05:00',2.51),('15128','2013-03-18','10:10:00',2.6),('15128','2013-03-18','10:15:00',2.65),('15128','2013-03-18','10:20:00',2.66),('15128','2013-03-18','10:25:00',2.75),('15128','2013-03-18','10:30:00',2.85),('15128','2013-03-18','10:35:00',2.95),('15128','2013-03-18','10:40:00',2.96),('15128','2013-03-18','10:45:00',3.01),('15128','2013-03-18','10:50:00',3.13),('15128','2013-03-18','10:55:00',3.25),('15128','2013-03-18','11:00:00',3.34),('15128','2013-03-18','11:05:00',3.45),('15128','2013-03-18','11:10:00',3.59),('15128','2013-03-18','11:15:00',3.68),('15128','2013-03-18','11:20:00',3.7),('15128','2013-03-18','11:25:00',3.81),('15128','2013-03-18','11:30:00',3.65),('15128','2013-03-18','11:35:00',3.18),('15128','2013-03-18','11:40:00',3.1),('15128','2013-03-18','11:45:00',3.43),('15128','2013-03-18','11:50:00',3.68),('15128','2013-03-18','11:55:00',4.01),('15128','2013-03-18','12:00:00',4.03),('15128','2013-03-18','12:05:00',4.11),('15128','2013-03-18','12:10:00',4.11),('15128','2013-03-18','12:15:00',4.1),('15128','2013-03-18','12:20:00',4.1),('15128','2013-03-18','12:25:00',3.99),('15128','2013-03-18','12:30:00',4.13),('15128','2013-03-18','12:35:00',4.12),('15128','2013-03-18','12:40:00',4.11),('15128','2013-03-18','12:45:00',4.12),('15128','2013-03-18','12:50:00',4.12),('15128','2013-03-18','12:55:00',4.12),('15128','2013-03-18','13:00:00',4.13),('15128','2013-03-18','13:05:00',4.1),('15128','2013-03-18','13:10:00',4.1),('15128','2013-03-18','13:15:00',4.09),('15128','2013-03-18','13:20:00',4.08),('15128','2013-03-18','13:25:00',4.11),('15128','2013-03-18','13:30:00',4.1),('15128','2013-03-18','13:35:00',4.07),('15128','2013-03-18','13:40:00',4),('15128','2013-03-18','13:45:00',3.77),('15128','2013-03-18','13:50:00',3.97),('15128','2013-03-18','13:55:00',3.91),('15128','2013-03-18','14:00:00',3.9),('15128','2013-03-18','14:05:00',3.88),('15128','2013-03-18','14:10:00',3.9),('15128','2013-03-18','14:15:00',3.86),('15128','2013-03-18','14:20:00',3.8),('15128','2013-03-18','14:25:00',3.75),('15128','2013-03-18','14:30:00',3.71),('15128','2013-03-18','14:35:00',3.67),('15128','2013-03-18','14:40:00',3.66),('15128','2013-03-18','14:45:00',3.61),('15128','2013-03-18','14:50:00',3.57),('15128','2013-03-18','14:55:00',3.52),('15128','2013-03-18','15:00:00',3.46),('15128','2013-03-18','15:05:00',3.39),('15128','2013-03-18','15:10:00',3.33),('15128','2013-03-18','15:15:00',3.28),('15128','2013-03-18','15:20:00',3.21),('15128','2013-03-18','15:25:00',3.15),('15128','2013-03-18','15:30:00',3.1),('15128','2013-03-18','15:35:00',3.03),('15128','2013-03-18','15:40:00',2.96),('15128','2013-03-18','15:45:00',2.88),('15128','2013-03-18','15:50:00',2.82),('15128','2013-03-18','15:55:00',2.7),('15128','2013-03-18','16:00:00',2.58),('15128','2013-03-18','16:05:00',2.47),('15128','2013-03-18','16:10:00',2.36),('15128','2013-03-18','16:15:00',2.25),('15128','2013-03-18','16:20:00',2.17),('15128','2013-03-18','16:25:00',2.1),('15128','2013-03-18','16:30:00',2.04),('15128','2013-03-18','16:35:00',1.76),('15128','2013-03-18','16:40:00',1.91),('15128','2013-03-18','16:45:00',1.64),('15128','2013-03-18','16:50:00',1.2),('15128','2013-03-18','16:55:00',1.56),('15128','2013-03-18','17:15:00',1.13),('15128','2013-03-18','17:20:00',1.01),('15128','2013-03-17','08:40:00',1.38),('15128','2013-03-17','08:45:00',1.22),('15128','2013-03-17','09:55:00',1.22),('15128','2013-03-17','10:00:00',1.45),('15128','2013-03-17','10:05:00',1.56),('15128','2013-03-17','10:10:00',1.58),('15128','2013-03-17','10:15:00',2.27),('15128','2013-03-17','10:20:00',2.41),('15128','2013-03-17','10:25:00',2.81),('15128','2013-03-17','10:30:00',1.92),('15128','2013-03-17','10:35:00',1.67),('15128','2013-03-17','10:40:00',1.6),('15128','2013-03-17','10:45:00',1.81),('15128','2013-03-17','10:50:00',1.01),('15128','2013-03-17','11:00:00',1.17),('15128','2013-03-17','11:05:00',1.39),('15128','2013-03-17','11:10:00',1.66),('15128','2013-03-17','11:15:00',1.92),('15128','2013-03-17','11:20:00',2.06),('15128','2013-03-17','11:25:00',2.26),('15128','2013-03-17','11:30:00',2.15),('15128','2013-03-17','11:35:00',1.82),('15128','2013-03-17','11:40:00',1.38),('15128','2013-03-17','11:45:00',1.21),('15128','2013-03-17','11:50:00',1.12),('15128','2013-03-17','11:55:00',1.24),('15128','2013-03-17','12:00:00',1.44),('15128','2013-03-17','12:05:00',1.76),('15128','2013-03-17','12:10:00',2.08),('15128','2013-03-17','12:15:00',2.96),('15128','2013-03-17','12:20:00',3.41),('15128','2013-03-17','12:25:00',4.42),('15128','2013-03-17','12:30:00',3.58),('15128','2013-03-17','12:35:00',1.75),('15128','2013-03-17','12:40:00',1.84),('15128','2013-03-17','12:45:00',2.62),('15128','2013-03-17','12:50:00',3.41),('15128','2013-03-17','12:55:00',2.16),('15128','2013-03-17','13:00:00',1.22),('15128','2013-03-17','13:05:00',1.31),('15128','2013-03-17','13:10:00',1.14),('15128','2013-03-17','13:20:00',2),('15128','2013-03-17','13:25:00',2.01),('15128','2013-03-17','13:30:00',1.1),('15128','2013-03-17','13:35:00',1.34),('15128','2013-03-17','13:40:00',1.41),('15128','2013-03-17','13:45:00',1.23),('15128','2013-03-17','13:55:00',1.14),('15128','2013-03-17','14:00:00',2.07),('15128','2013-03-17','14:05:00',1.6),('15128','2013-03-17','14:10:00',1.91),('15128','2013-03-17','14:35:00',1.08),('15128','2013-03-17','14:40:00',1.1),('15128','2013-03-16','08:20:00',1.18),('15128','2013-03-16','08:25:00',1.27),('15128','2013-03-16','08:30:00',1.27),('15128','2013-03-16','08:35:00',1.12),('15128','2013-03-16','08:40:00',1.18),('15128','2013-03-16','08:45:00',1.22),('15128','2013-03-16','08:50:00',1.15),('15128','2013-03-16','08:55:00',1.11),('15128','2013-03-16','09:00:00',1.36),('15128','2013-03-16','09:05:00',1.63),('15128','2013-03-16','09:10:00',1.64),('15128','2013-03-16','09:15:00',1.59),('15128','2013-03-16','09:20:00',1.49),('15128','2013-03-16','09:25:00',1.34),('15128','2013-03-16','09:30:00',1.59),('15128','2013-03-16','09:35:00',1.59),('15128','2013-03-16','09:40:00',1.56),('15128','2013-03-16','09:45:00',1.68),('15128','2013-03-16','09:50:00',1.76),('15128','2013-03-16','09:55:00',1.85),('15128','2013-03-16','10:00:00',1.83),('15128','2013-03-16','10:05:00',1.7),('15128','2013-03-16','10:10:00',1.79),('15128','2013-03-16','10:15:00',1.82),('15128','2013-03-16','10:20:00',1.88),('15128','2013-03-16','10:25:00',2.02),('15128','2013-03-16','10:30:00',1.93),('15128','2013-03-16','10:35:00',1.91),('15128','2013-03-16','10:40:00',1.93),('15128','2013-03-16','10:45:00',1.88),('15128','2013-03-16','10:50:00',1.5),('15128','2013-03-16','10:55:00',1.33),('15128','2013-03-16','11:00:00',1.44),('15128','2013-03-16','11:05:00',1.61),('15128','2013-03-16','11:10:00',1.69),('15128','2013-03-16','11:15:00',2.06),('15128','2013-03-16','11:20:00',2.35),('15128','2013-03-16','11:25:00',2.04),('15128','2013-03-16','11:30:00',1.87),('15128','2013-03-16','11:35:00',1.8),('15128','2013-03-16','11:40:00',1.65),('15128','2013-03-16','11:45:00',1.46),('15128','2013-03-16','11:50:00',1.35),('15128','2013-03-16','11:55:00',1.26),('15128','2013-03-16','12:00:00',1.17),('15128','2013-03-16','12:05:00',1.39),('15128','2013-03-16','12:10:00',1.78),('15128','2013-03-16','12:15:00',2.33),('15128','2013-03-16','12:20:00',2.51),('15128','2013-03-16','12:25:00',2.63),('15128','2013-03-16','12:30:00',2.31),('15128','2013-03-16','12:35:00',2.18),('15128','2013-03-16','12:40:00',2.36),('15128','2013-03-16','12:45:00',2.3),('15128','2013-03-16','12:50:00',1.88),('15128','2013-03-16','12:55:00',1.82),('15128','2013-03-16','13:00:00',1.77),('15128','2013-03-16','13:05:00',1.74),('15128','2013-03-16','13:10:00',1.8),('15128','2013-03-16','13:15:00',1.66),('15128','2013-03-16','13:20:00',1.5),('15128','2013-03-16','13:25:00',2.34),('15128','2013-03-16','13:30:00',2.69),('15128','2013-03-16','13:35:00',2.57),('15128','2013-03-16','13:40:00',1.83),('15128','2013-03-16','13:45:00',1.42),('15128','2013-03-16','13:50:00',1.71),('15128','2013-03-16','13:55:00',2.06),('15128','2013-03-16','14:00:00',2.04),('15128','2013-03-16','14:05:00',2.47),('15128','2013-03-16','14:10:00',2.77),('15128','2013-03-16','14:15:00',2.91),('15128','2013-03-16','14:20:00',2.55),('15128','2013-03-16','14:25:00',2.46),('15128','2013-03-16','14:30:00',2.59),('15128','2013-03-16','14:35:00',2.59),('15128','2013-03-16','14:40:00',1.85),('15128','2013-03-16','14:45:00',1.52),('15128','2013-03-16','14:50:00',1.34),('15128','2013-03-16','14:55:00',1.73),('15128','2013-03-16','15:00:00',1.79),('15128','2013-03-16','15:05:00',2.87),('15128','2013-03-16','15:10:00',3.49),('15128','2013-03-16','15:15:00',2.3),('15128','2013-03-16','15:20:00',2.31),('15128','2013-03-16','15:25:00',3.07),('15128','2013-03-16','15:30:00',1.75),('15128','2013-03-16','15:35:00',1.47),('15128','2013-03-16','15:40:00',1.09),('15128','2013-03-16','15:45:00',1.18),('15128','2013-03-15','08:10:00',1.01),('15128','2013-03-15','08:20:00',1.23),('15128','2013-03-15','08:25:00',1.21),('15128','2013-03-15','08:30:00',1.29),('15128','2013-03-15','08:35:00',1.52),('15128','2013-03-15','08:40:00',1.7),('15128','2013-03-15','08:45:00',1.52),('15128','2013-03-15','08:50:00',1.81),('15128','2013-03-15','08:55:00',1.39),('15128','2013-03-15','09:00:00',1.89),('15128','2013-03-15','09:05:00',1.54),('15128','2013-03-15','09:10:00',1.95),('15128','2013-03-15','09:15:00',1.99),('15128','2013-03-15','09:20:00',2.05),('15128','2013-03-15','09:25:00',2.13),('15128','2013-03-15','09:30:00',2.12),('15128','2013-03-15','09:35:00',2.24),('15128','2013-03-15','09:40:00',1.87),('15128','2013-03-15','09:45:00',1.74),('15128','2013-03-15','09:50:00',2.49),('15128','2013-03-15','09:55:00',1.5),('15128','2013-03-15','10:00:00',1.62),('15128','2013-03-15','10:05:00',1.55),('15128','2013-03-15','10:10:00',1.58),('15128','2013-03-15','10:15:00',1.6),('15128','2013-03-15','10:20:00',2.23),('15128','2013-03-15','10:25:00',2.27),('15128','2013-03-15','10:30:00',3.12),('15128','2013-03-15','10:35:00',3.11),('15128','2013-03-15','10:40:00',3.13),('15128','2013-03-15','10:45:00',3.18),('15128','2013-03-15','10:50:00',3.18),('15128','2013-03-15','10:55:00',3.23),('15128','2013-03-15','11:00:00',3.33),('15128','2013-03-15','11:05:00',3.3),('15128','2013-03-15','11:10:00',3.45),('15128','2013-03-15','11:15:00',3.67),('15128','2013-03-15','11:20:00',3.74),('15128','2013-03-15','11:25:00',3.8),('15128','2013-03-15','11:30:00',3.86),('15128','2013-03-15','11:35:00',3.89),('15128','2013-03-15','11:40:00',3.93),('15128','2013-03-15','11:45:00',3.98),('15128','2013-03-15','11:50:00',4.09),('15128','2013-03-15','11:55:00',4.16),('15128','2013-03-15','12:00:00',4.13),('15128','2013-03-15','12:05:00',4.12),('15128','2013-03-15','12:10:00',4.26),('15128','2013-03-15','12:15:00',4.41),('15128','2013-03-15','12:20:00',4.37),('15128','2013-03-15','12:25:00',4.4),('15128','2013-03-15','12:30:00',4.44),('15128','2013-03-15','12:35:00',4.39),('15128','2013-03-15','12:40:00',4.1),('15128','2013-03-15','12:45:00',4.4),('15128','2013-03-15','12:50:00',4.11),('15128','2013-03-15','12:55:00',4.29),('15128','2013-03-15','13:00:00',4.34),('15128','2013-03-15','13:05:00',4.21),('15128','2013-03-15','13:10:00',2.75),('15128','2013-03-15','13:15:00',4.22),('15128','2013-03-15','13:20:00',4.43),('15128','2013-03-15','13:25:00',3.51),('15128','2013-03-15','13:30:00',3.1),('15128','2013-03-15','13:35:00',2.99),('15128','2013-03-15','13:40:00',3.98),('15128','2013-03-15','13:45:00',1.06),('15128','2013-03-15','13:50:00',2.5),('15128','2013-03-15','13:55:00',1.85),('15128','2013-03-15','14:00:00',2.6),('15128','2013-03-15','14:05:00',3.42),('15128','2013-03-15','14:10:00',4.34),('15128','2013-03-15','14:15:00',4.22),('15128','2013-03-15','14:20:00',1.33),('15128','2013-03-15','14:25:00',1.08),('15128','2013-03-15','14:30:00',4.28),('15128','2013-03-15','14:35:00',3.99),('15128','2013-03-15','14:40:00',3.14),('15128','2013-03-15','14:45:00',1.08),('15128','2013-03-15','14:50:00',1.84),('15128','2013-03-15','14:55:00',3.78),('15128','2013-03-15','15:00:00',3.65),('15128','2013-03-15','15:05:00',3.5),('15128','2013-03-15','15:10:00',3.44),('15128','2013-03-15','15:15:00',3.42),('15128','2013-03-15','15:20:00',3.41),('15128','2013-03-15','15:25:00',3.37),('15128','2013-03-15','15:30:00',3.26),('15128','2013-03-15','15:35:00',3.06),('15128','2013-03-15','15:40:00',2.96),('15128','2013-03-15','15:45:00',2.92),('15128','2013-03-15','15:50:00',2),('15128','2013-03-15','15:55:00',2.68),('15128','2013-03-15','16:00:00',2.47),('15128','2013-03-15','16:05:00',2.26),('15128','2013-03-15','16:10:00',1.19),('15128','2013-03-15','16:15:00',2.07),('15128','2013-03-15','16:20:00',2.39),('15128','2013-03-15','16:25:00',2.34),('15128','2013-03-15','16:30:00',2.17),('15128','2013-03-15','16:35:00',2.13),('15128','2013-03-15','16:40:00',2.13),('15128','2013-03-15','16:45:00',1.53),('15128','2013-03-15','16:55:00',1.6),('15128','2013-03-15','17:00:00',1.24),('15128','2013-03-15','17:20:00',1.08),('15128','2013-03-14','10:25:00',1.16),('15128','2013-03-14','10:30:00',1.3),('15128','2013-03-14','10:35:00',1.34),('15128','2013-03-14','10:40:00',1.4),('15128','2013-03-14','10:45:00',1.23),('15128','2013-03-14','10:50:00',1.2),('15128','2013-03-14','10:55:00',1.51),('15128','2013-03-14','11:00:00',1.71),('15128','2013-03-14','11:05:00',1.35),('15128','2013-03-14','11:10:00',1.11),('15128','2013-03-14','11:15:00',1.07),('15128','2013-03-14','11:20:00',1.06),('15128','2013-03-14','11:25:00',1.11),('15128','2013-03-14','11:30:00',1.35),('15128','2013-03-14','11:35:00',1.56),('15128','2013-03-14','11:40:00',1.77),('15128','2013-03-14','11:45:00',1.6),('15128','2013-03-14','11:50:00',1.47),('15128','2013-03-14','11:55:00',1.72),('15128','2013-03-14','12:00:00',1.93),('15128','2013-03-14','12:05:00',1.79),('15128','2013-03-14','12:10:00',1.96),('15128','2013-03-14','12:15:00',2.34),('15128','2013-03-14','12:20:00',2.42),('15128','2013-03-14','12:25:00',2.19),('15128','2013-03-14','12:30:00',1.72),('15128','2013-03-14','12:35:00',1.58),('15128','2013-03-14','12:40:00',1.66),('15128','2013-03-14','12:45:00',1.72),('15128','2013-03-14','12:50:00',1.57),('15128','2013-03-14','12:55:00',1.45),('15128','2013-03-14','13:00:00',1.55),('15128','2013-03-14','13:05:00',1.78),('15128','2013-03-14','13:10:00',2.13),('15128','2013-03-14','13:15:00',2.85),('15128','2013-03-14','13:20:00',2.42),('15128','2013-03-14','13:25:00',2),('15128','2013-03-14','13:30:00',1.68),('15128','2013-03-14','13:35:00',1.63),('15128','2013-03-14','13:40:00',1.35),('15128','2013-03-14','13:45:00',1.15),('15128','2013-03-14','13:50:00',1.24),('15128','2013-03-14','13:55:00',1.18),('15128','2013-03-14','14:00:00',1),('15128','2013-03-14','14:35:00',1.2),('15128','2013-03-14','14:40:00',1.35),('15128','2013-03-14','14:45:00',1.38),('15128','2013-03-14','14:50:00',1.41),('15128','2013-03-14','14:55:00',1.35),('15128','2013-03-14','15:00:00',1.38),('15128','2013-03-14','15:05:00',1.36),('15128','2013-03-14','15:10:00',1.32),('15128','2013-03-14','15:15:00',1.42),('15128','2013-03-14','15:20:00',1.42),('15128','2013-03-14','15:25:00',1.22),('15128','2013-03-14','15:30:00',1.19),('15128','2013-03-14','15:35:00',1.18),('15128','2013-03-14','15:40:00',1.03),('15128','2013-03-14','16:55:00',1.01),('15128','2013-03-14','17:00:00',1.44),('15128','2013-03-14','17:10:00',1.09),('15128','2013-03-14','17:15:00',1.13),('15128','2013-03-13','09:55:00',1.03),('15128','2013-03-13','12:25:00',1.03),('15128','2013-03-13','12:30:00',1.16),('15128','2013-03-13','12:35:00',1.25),('15128','2013-03-13','12:40:00',1.29),('15128','2013-03-13','12:45:00',1.17),('15128','2013-03-13','12:50:00',1.16),('15128','2013-03-13','12:55:00',1.29),('15128','2013-03-13','13:00:00',1.52),('15128','2013-03-13','13:05:00',1.58),('15128','2013-03-13','13:10:00',1.6),('15128','2013-03-13','13:15:00',1.57),('15128','2013-03-13','13:20:00',1.42),('15128','2013-03-13','13:25:00',1.4),('15128','2013-03-13','13:30:00',1.62),('15128','2013-03-13','13:35:00',1.64),('15128','2013-03-13','13:40:00',1.85),('15128','2013-03-13','13:45:00',1.69),('15128','2013-03-13','13:50:00',1.25),('15128','2013-03-13','13:55:00',1.01),('15128','2013-03-13','14:00:00',1.39),('15128','2013-03-13','14:05:00',1.62),('15128','2013-03-13','14:10:00',1.65),('15128','2013-03-13','14:15:00',1.69),('15128','2013-03-13','14:20:00',1.24),('15128','2013-03-13','15:15:00',1.08),('15128','2013-03-13','15:20:00',1.08),('15128','2013-03-12','09:10:00',1.02),('15128','2013-03-12','09:15:00',1.21),('15128','2013-03-12','09:20:00',1.35),('15128','2013-03-12','09:25:00',1.32),('15128','2013-03-12','09:30:00',1.17),('15128','2013-03-12','10:35:00',1.08),('15128','2013-03-12','10:40:00',2.25),('15128','2013-03-12','10:45:00',2.45),('15128','2013-03-12','10:50:00',2.28),('15128','2013-03-12','10:55:00',1.81),('15128','2013-03-12','11:00:00',1.23),('15128','2013-03-12','11:05:00',1.41),('15128','2013-03-12','11:10:00',2.07),('15128','2013-03-12','11:15:00',1.65),('15128','2013-03-12','11:25:00',1.36),('15128','2013-03-12','11:30:00',1.4),('15128','2013-03-12','11:35:00',1.88),('15128','2013-03-12','11:40:00',1.6),('15128','2013-03-12','11:45:00',1.77),('15128','2013-03-12','11:50:00',1.7),('15128','2013-03-12','11:55:00',1.5),('15128','2013-03-12','12:40:00',1.1),('15128','2013-03-12','12:45:00',1.15),('15128','2013-03-12','12:50:00',1.25),('15128','2013-03-12','12:55:00',1.28),('15128','2013-03-12','13:00:00',1.2),('15128','2013-03-12','13:05:00',1.15),('15128','2013-03-12','13:10:00',1.14),('15128','2013-03-12','13:35:00',1.24),('15128','2013-03-12','13:40:00',1.82),('15128','2013-03-12','13:45:00',1.65),('15128','2013-03-12','13:50:00',1.29),('15128','2013-03-12','13:55:00',1.02),('15128','2014-03-24','08:10:00',1),('15128','2014-03-24','08:35:00',1.08),('15128','2014-03-24','08:40:00',1.26),('15128','2014-03-24','08:45:00',1.38),('15128','2014-03-24','08:50:00',1.44),('15128','2014-03-24','08:55:00',1.46),('15128','2014-03-24','09:00:00',1.46),('15128','2014-03-24','09:05:00',1.59),('15128','2014-03-24','09:10:00',1.66),('15128','2014-03-24','09:15:00',1.96),('15128','2014-03-24','09:20:00',2.03),('15128','2014-03-24','09:25:00',1.79),('15128','2014-03-24','09:30:00',1.67),('15128','2014-03-24','09:35:00',1.65),('15128','2014-03-24','09:40:00',1.64),('15128','2014-03-24','09:45:00',1.62),('15128','2014-03-24','09:50:00',1.76),('15128','2014-03-24','09:55:00',1.94),('15128','2014-03-24','10:00:00',2.04),('15128','2014-03-24','10:05:00',2.16),('15128','2014-03-24','10:10:00',2.31),('15128','2014-03-24','10:15:00',2.43),('15128','2014-03-24','10:20:00',2.59),('15128','2014-03-24','10:25:00',2.4),('15128','2014-03-24','10:30:00',2.2),('15128','2014-03-24','10:35:00',2.14),('15128','2014-03-24','10:40:00',1.95),('15128','2014-03-24','10:45:00',1.81),('15128','2014-03-24','10:50:00',1.98),('15128','2014-03-24','10:55:00',2.25),('15128','2014-03-24','11:00:00',2.37),('15128','2014-03-24','11:05:00',2.51),('15128','2014-03-24','11:10:00',2.57),('15128','2014-03-24','11:15:00',2.65),('15128','2014-03-24','11:20:00',2.81),('15128','2014-03-24','11:25:00',2.97),('15128','2014-03-24','11:30:00',3.05),('15128','2014-03-24','11:35:00',3.02),('15128','2014-03-24','11:40:00',2.92),('15128','2014-03-24','11:45:00',2.76),('15128','2014-03-24','11:50:00',2.24),('15128','2014-03-24','11:55:00',1.86),('15128','2014-03-24','12:00:00',1.36),('15128','2014-03-24','12:05:00',1.16),('15128','2014-03-24','12:10:00',1.1),('15128','2014-03-24','12:15:00',1.28),('15128','2014-03-24','12:20:00',1.31),('15128','2014-03-24','12:25:00',1.32),('15128','2014-03-24','12:45:00',1.15),('15128','2014-03-24','12:50:00',1.21),('15128','2014-03-24','12:55:00',1.32),('15128','2014-03-24','13:00:00',1.16),('15128','2013-03-11','08:30:00',1.13),('15128','2013-03-11','08:35:00',1.18),('15128','2013-03-11','08:40:00',1.17),('15128','2013-03-11','08:45:00',1.35),('15128','2013-03-11','08:50:00',1.41),('15128','2013-03-11','08:55:00',1.52),('15128','2013-03-11','09:00:00',1.58),('15128','2013-03-11','09:05:00',1.64),('15128','2013-03-11','09:10:00',1.71),('15128','2013-03-11','09:15:00',1.81),('15128','2013-03-11','09:20:00',1.88),('15128','2013-03-11','09:25:00',1.96),('15128','2013-03-11','09:30:00',2),('15128','2013-03-11','09:35:00',2.04),('15128','2013-03-11','09:40:00',2.14),('15128','2013-03-11','09:45:00',2.21),('15128','2013-03-11','09:50:00',2.27),('15128','2013-03-11','09:55:00',2.05),('15128','2013-03-11','10:00:00',2.64),('15128','2013-03-11','10:05:00',2.56),('15128','2013-03-11','10:10:00',1.97),('15128','2013-03-11','10:15:00',1.26),('15128','2013-03-11','10:20:00',2.62),('15128','2013-03-11','10:25:00',3.25),('15128','2013-03-11','10:30:00',2.16),('15128','2013-03-11','10:35:00',3.22),('15128','2013-03-11','10:40:00',2.55),('15128','2013-03-11','10:45:00',3.14),('15128','2013-03-11','10:50:00',2.91),('15128','2013-03-11','10:55:00',3.19),('15128','2013-03-11','11:00:00',3.5),('15128','2013-03-11','11:05:00',2.42),('15128','2013-03-11','11:10:00',1.59),('15128','2013-03-11','11:15:00',3.55),('15128','2013-03-11','11:20:00',2.56),('15128','2013-03-11','11:25:00',2.17),('15128','2013-03-11','11:30:00',1.22),('15128','2013-03-11','11:35:00',1.12),('15128','2013-03-11','11:40:00',1.43),('15128','2013-03-11','11:45:00',1.48),('15128','2013-03-11','11:50:00',2.71),('15128','2013-03-11','11:55:00',5.32),('15128','2013-03-11','12:00:00',5.21),('15128','2013-03-11','12:05:00',1.46),('15128','2013-03-11','12:20:00',1.82),('15128','2013-03-11','12:25:00',1.88),('15128','2013-03-11','12:30:00',1.6),('15128','2013-03-11','12:35:00',1.93),('15128','2013-03-11','12:40:00',1.59),('15128','2013-03-11','12:45:00',2.63),('15128','2013-03-11','12:50:00',3.57),('15128','2013-03-11','12:55:00',2.33),('15128','2013-03-11','13:00:00',1.76),('15128','2013-03-11','13:05:00',3.51),('15128','2013-03-11','13:10:00',2.31),('15128','2013-03-11','13:15:00',2.2),('15128','2013-03-11','13:20:00',1.48),('15128','2013-03-11','13:25:00',1.56),('15128','2013-03-11','13:30:00',2.79),('15128','2013-03-11','13:35:00',2.63),('15128','2013-03-11','13:40:00',2.91),('15128','2013-03-11','13:45:00',2.97),('15128','2013-03-11','13:50:00',2.88),('15128','2013-03-11','13:55:00',3.44),('15128','2013-03-11','14:00:00',3.04),('15128','2013-03-11','14:05:00',3.23),('15128','2013-03-11','14:10:00',2.12),('15128','2013-03-11','14:15:00',4.39),('15128','2013-03-11','14:20:00',3.55),('15128','2013-03-11','14:25:00',2.67),('15128','2013-03-11','14:55:00',2.65),('15128','2013-03-11','15:00:00',2.54),('15128','2013-03-11','15:05:00',1.8),('15128','2013-03-11','15:10:00',1.76),('15128','2013-03-11','15:15:00',1.9),('15128','2013-03-11','15:20:00',2.02),('15128','2013-03-11','15:25:00',1.3),('15128','2013-03-10','08:20:00',1.05),('15128','2013-03-10','08:30:00',1.04),('15128','2013-03-10','08:35:00',1.13),('15128','2013-03-10','08:40:00',1.35),('15128','2013-03-10','08:45:00',1.26),('15128','2013-03-10','08:50:00',1.75),('15128','2013-03-10','08:55:00',1.45),('15128','2013-03-10','09:00:00',1.58),('15128','2013-03-10','09:05:00',1.32),('15128','2013-03-10','09:10:00',1.7),('15128','2013-03-10','09:15:00',1.79),('15128','2013-03-10','09:20:00',2),('15128','2013-03-10','09:25:00',2.25),('15128','2013-03-10','09:30:00',2.35),('15128','2013-03-10','09:35:00',1.99),('15128','2013-03-10','09:40:00',1.75),('15128','2013-03-10','09:45:00',1.54),('15128','2013-03-10','10:00:00',1.52),('15128','2013-03-10','10:05:00',2.01),('15128','2013-03-10','10:10:00',2.04),('15128','2013-03-10','10:15:00',1.74),('15128','2013-03-10','10:20:00',1.69),('15128','2013-03-10','10:25:00',1.91),('15128','2013-03-10','10:30:00',1.93),('15128','2013-03-10','10:35:00',1.77),('15128','2013-03-10','10:40:00',1.73),('15128','2013-03-10','10:45:00',1.83),('15128','2013-03-10','10:50:00',1.82),('15128','2013-03-10','10:55:00',1.5),('15128','2013-03-10','11:00:00',1.68),('15128','2013-03-10','11:05:00',1.51),('15128','2013-03-10','11:10:00',1.56),('15128','2013-03-10','11:15:00',1.66),('15128','2013-03-10','11:20:00',1.51),('15128','2013-03-10','11:25:00',1.77),('15128','2013-03-10','11:30:00',1.42),('15128','2013-03-10','11:35:00',1.52),('15128','2013-03-10','11:40:00',1.98),('15128','2013-03-10','11:45:00',1.86),('15128','2013-03-10','11:50:00',1.33),('15128','2013-03-10','11:55:00',1.74),('15128','2013-03-10','12:00:00',2.18),('15128','2013-03-10','12:05:00',2.37),('15128','2013-03-10','12:10:00',2.92),('15128','2013-03-10','12:15:00',3.79),('15128','2013-03-10','12:20:00',2.02),('15128','2013-03-10','12:25:00',3.71),('15128','2013-03-10','12:30:00',3.01),('15128','2013-03-10','12:35:00',4.44),('15128','2013-03-10','12:40:00',4.55),('15128','2013-03-10','12:45:00',4.33),('15128','2013-03-10','12:50:00',4.18),('15128','2013-03-10','12:55:00',3.96),('15128','2013-03-10','13:00:00',4.28),('15128','2013-03-10','13:05:00',4.01),('15128','2013-03-10','13:10:00',4.2),('15128','2013-03-10','13:15:00',4.11),('15128','2013-03-10','13:20:00',3.94),('15128','2013-03-10','13:25:00',4.21),('15128','2013-03-10','13:30:00',4.19),('15128','2013-03-10','13:35:00',2.67),('15128','2013-03-10','13:40:00',1.71),('15128','2013-03-10','13:45:00',2.35),('15128','2013-03-10','13:50:00',4.52),('15128','2013-03-10','13:55:00',4.25),('15128','2013-03-10','14:00:00',4.27),('15128','2013-03-10','14:05:00',3.68),('15128','2013-03-10','14:10:00',4.19),('15128','2013-03-10','14:15:00',4.15),('15128','2013-03-10','14:20:00',3.35),('15128','2013-03-10','14:25:00',3.48),('15128','2013-03-10','14:30:00',2.97),('15128','2013-03-10','14:35:00',2.58),('15128','2013-03-10','14:40:00',3.76),('15128','2013-03-10','14:45:00',3.5),('15128','2013-03-10','14:50:00',3.65),('15128','2013-03-10','14:55:00',3.17),('15128','2013-03-10','15:00:00',3.37),('15128','2013-03-10','15:05:00',2.56),('15128','2013-03-10','15:10:00',3.34),('15128','2013-03-10','15:15:00',3.31),('15128','2013-03-10','15:20:00',3.26),('15128','2013-03-10','15:25:00',3.26),('15128','2013-03-10','15:30:00',1.58),('15128','2013-03-10','15:35:00',2.86),('15128','2013-03-10','15:40:00',2.11),('15128','2013-03-10','15:45:00',1.85),('15128','2013-03-10','15:50:00',2.59),('15128','2013-03-10','15:55:00',2.38),('15128','2013-03-10','16:00:00',2.25),('15128','2013-03-10','16:05:00',2.09),('15128','2013-03-10','16:10:00',1.85),('15128','2013-03-10','16:15:00',1.97),('15128','2013-03-10','16:20:00',1.92),('15128','2013-03-10','16:25:00',1.77),('15128','2013-03-10','16:30:00',1.74),('15128','2013-03-10','16:35:00',1.6),('15128','2013-03-10','16:40:00',1.31),('15128','2013-03-09','08:35:00',1.09),('15128','2013-03-09','08:40:00',1.19),('15128','2013-03-09','08:45:00',1.29),('15128','2013-03-09','08:50:00',1.39),('15128','2013-03-09','08:55:00',1.47),('15128','2013-03-09','09:00:00',1.54),('15128','2013-03-09','09:05:00',1.59),('15128','2013-03-09','09:10:00',1.65),('15128','2013-03-09','09:15:00',1.77),('15128','2013-03-09','09:20:00',1.85),('15128','2013-03-09','09:25:00',1.89),('15128','2013-03-09','09:30:00',1.96),('15128','2013-03-09','09:35:00',2.03),('15128','2013-03-09','09:40:00',2.17),('15128','2013-03-09','09:45:00',2.29),('15128','2013-03-09','09:50:00',2.22),('15128','2013-03-09','09:55:00',2.27),('15128','2013-03-09','10:00:00',2.27),('15128','2013-03-09','10:15:00',2.52),('15128','2013-03-09','10:20:00',2.59),('15128','2013-03-09','10:25:00',2.71),('15128','2013-03-09','10:30:00',2.87),('15128','2013-03-09','10:35:00',2.79),('15128','2013-03-09','10:40:00',2.75),('15128','2013-03-09','10:45:00',2.66),('15128','2013-03-09','10:50:00',2.91),('15128','2013-03-09','10:55:00',3.01),('15128','2013-03-09','11:00:00',3.12),('15128','2013-03-09','11:05:00',3.08),('15128','2013-03-09','11:10:00',3.17),('15128','2013-03-09','11:15:00',3.34),('15128','2013-03-09','11:20:00',3.38),('15128','2013-03-09','11:55:00',3.21),('15128','2013-03-09','12:00:00',3.89),('15128','2013-03-09','12:05:00',3.32),('15128','2013-03-09','12:10:00',3.91),('15128','2013-03-09','12:15:00',4.04),('15128','2013-03-09','12:20:00',3.8),('15128','2013-03-09','12:25:00',3.97),('15128','2013-03-09','12:30:00',4.04),('15128','2013-03-09','12:35:00',3.99),('15128','2013-03-09','12:40:00',3.97),('15128','2013-03-09','12:45:00',2.7),('15128','2013-03-09','12:50:00',4.52),('15128','2013-03-09','12:55:00',4.66),('15128','2013-03-09','13:00:00',4.14),('15128','2013-03-09','13:05:00',4.22),('15128','2013-03-09','13:10:00',4.37),('15128','2013-03-09','13:15:00',3.84),('15128','2013-03-09','13:20:00',2.42),('15128','2013-03-09','13:25:00',4.56),('15128','2013-03-09','13:30:00',3.75),('15128','2013-03-09','13:35:00',3.01),('15128','2013-03-09','13:40:00',2.56),('15128','2013-03-09','13:45:00',2.13),('15128','2013-03-09','13:50:00',1.82),('15128','2013-03-09','13:55:00',1.74),('15128','2013-03-09','14:00:00',1.59),('15128','2013-03-09','14:05:00',1.8),('15128','2013-03-09','14:10:00',1.86),('15128','2013-03-09','14:15:00',1.89),('15128','2013-03-09','14:20:00',1.96),('15128','2013-03-09','14:25:00',2.13),('15128','2013-03-09','14:30:00',1.93),('15128','2013-03-09','14:35:00',1.67),('15128','2013-03-09','14:40:00',1.88),('15128','2013-03-09','14:45:00',1.54),('15128','2013-03-09','14:50:00',1.49),('15128','2013-03-09','14:55:00',1.34),('15128','2013-03-09','15:15:00',1.13),('15128','2013-03-08','08:35:00',1.07),('15128','2013-03-08','08:40:00',1.15),('15128','2013-03-08','08:45:00',1.24),('15128','2013-03-08','08:50:00',1.34),('15128','2013-03-08','08:55:00',1.41),('15128','2013-03-08','09:00:00',1.31),('15128','2013-03-08','09:15:00',1.32),('15128','2013-03-08','09:20:00',1.6),('15128','2013-03-08','09:25:00',1.17),('15128','2013-03-08','09:40:00',1.04),('15128','2013-03-08','09:45:00',1.38),('15128','2013-03-08','09:50:00',1.59),('15128','2013-03-08','09:55:00',1.92),('15128','2013-03-08','10:00:00',2.35),('15128','2013-03-08','10:15:00',1.55),('15128','2013-03-08','10:20:00',1.07),('15128','2013-03-08','10:25:00',1.3),('15128','2013-03-08','10:30:00',2.31),('15128','2013-03-08','10:35:00',2.33),('15128','2013-03-08','10:40:00',2.25),('15128','2013-03-08','10:45:00',2.02),('15128','2013-03-08','10:50:00',2.87),('15128','2013-03-08','10:55:00',3.12),('15128','2013-03-08','11:00:00',3.12),('15128','2013-03-08','11:05:00',3.05),('15128','2013-03-08','11:10:00',3.33),('15128','2013-03-08','11:15:00',3.39),('15128','2013-03-08','11:20:00',3.62),('15128','2013-03-08','11:25:00',3.61),('15128','2013-03-08','11:30:00',3.59),('15128','2013-03-08','11:35:00',3.68),('15128','2013-03-08','11:40:00',3.71),('15128','2013-03-08','11:45:00',3.64),('15128','2013-03-08','11:50:00',3.68),('15128','2013-03-08','11:55:00',3.75),('15128','2013-03-08','12:00:00',3.76),('15128','2013-03-08','12:05:00',3.84),('15128','2013-03-08','12:10:00',3.88),('15128','2013-03-08','12:15:00',2.39),('15128','2013-03-08','12:20:00',2.59),('15128','2013-03-08','12:25:00',4.51),('15128','2013-03-08','12:30:00',3.3),('15128','2013-03-08','12:35:00',1.98),('15128','2013-03-08','12:40:00',3.18),('15128','2013-03-08','12:45:00',3.8),('15128','2013-03-08','12:50:00',4.19),('15128','2013-03-08','12:55:00',3.95),('15128','2013-03-08','13:00:00',3.91),('15128','2013-03-08','13:05:00',3.95),('15128','2013-03-08','13:10:00',3.02),('15128','2013-03-08','13:15:00',4.1),('15128','2013-03-08','13:20:00',3.63),('15128','2013-03-08','13:25:00',4.04),('15128','2013-03-08','13:30:00',3.9),('15128','2013-03-08','13:35:00',3.83),('15128','2013-03-08','13:40:00',3.81),('15128','2013-03-08','13:45:00',3.59),('15128','2013-03-08','13:50:00',3.76),('15128','2013-03-08','13:55:00',3.77),('15128','2013-03-08','14:00:00',3.79),('15128','2013-03-08','14:05:00',3.69),('15128','2013-03-08','14:10:00',3.66),('15128','2013-03-08','14:15:00',3.63),('15128','2013-03-08','14:20:00',3.6),('15128','2013-03-08','14:25:00',2.55),('15128','2013-03-08','14:30:00',2.8),('15128','2013-03-08','14:35:00',3.3),('15128','2013-03-08','14:40:00',3.52),('15128','2013-03-08','14:45:00',3.42),('15128','2013-03-08','14:50:00',3.36),('15128','2013-03-08','14:55:00',3.29),('15128','2013-03-08','15:00:00',3.23),('15128','2013-03-08','15:05:00',3.16),('15128','2013-03-08','15:10:00',3.07),('15128','2013-03-08','15:15:00',3.02),('15128','2013-03-08','15:20:00',2.96),('15128','2013-03-08','15:25:00',2.94),('15128','2013-03-08','15:30:00',2.88),('15128','2013-03-08','15:35:00',2.83),('15128','2013-03-08','15:40:00',2.74),('15128','2013-03-08','15:45:00',2.65),('15128','2013-03-08','15:50:00',2.51),('15128','2013-03-08','15:55:00',2.34),('15128','2013-03-08','16:00:00',2.01),('15128','2013-03-08','16:05:00',1.81),('15128','2013-03-08','16:10:00',1.9),('15128','2013-03-08','16:15:00',1.38),('15128','2013-03-08','16:30:00',1.21),('15128','2013-03-08','16:40:00',1.25),('15128','2013-03-08','16:45:00',1.21),('15128','2013-03-07','08:30:00',1.32),('15128','2013-03-07','09:10:00',1.77),('15128','2013-03-07','09:15:00',2.01),('15128','2013-03-07','09:20:00',1.81),('15128','2013-03-07','09:25:00',1.62),('15128','2013-03-07','09:30:00',1.69),('15128','2013-03-07','09:35:00',1.73),('15128','2013-03-07','09:40:00',1.69),('15128','2013-03-07','09:45:00',1.73),('15128','2013-03-07','09:50:00',2.47),('15128','2013-03-07','09:55:00',1.81),('15128','2013-03-07','10:00:00',2.09),('15128','2013-03-07','10:05:00',1.31),('15128','2013-03-07','10:10:00',1.43),('15128','2013-03-07','10:15:00',1.76),('15128','2013-03-07','10:20:00',1.52),('15128','2013-03-07','12:05:00',1.31),('15128','2013-03-07','12:10:00',1.28),('15128','2013-03-07','12:15:00',1.04),('15128','2013-03-07','12:20:00',1.16),('15128','2013-03-07','12:30:00',1.08),('15128','2013-03-07','12:35:00',1.5),('15128','2013-03-07','12:40:00',1.59),('15128','2013-03-07','12:45:00',1.26),('15128','2013-03-07','12:50:00',1.61),('15128','2013-03-07','12:55:00',2.3),('15128','2013-03-07','13:00:00',2.05),('15128','2013-03-07','13:05:00',1.7),('15128','2013-03-07','13:10:00',1.39),('15128','2013-03-07','13:15:00',1.21),('15128','2013-03-07','13:20:00',1.06),('15128','2013-03-07','13:30:00',1.3),('15128','2013-03-07','13:35:00',2.07),('15128','2013-03-07','13:40:00',1.15),('15128','2013-03-07','13:45:00',1.29),('15128','2013-03-06','08:50:00',1.05),('15128','2013-03-06','08:55:00',1.01),('15128','2013-03-06','10:40:00',1.28),('15128','2013-03-06','10:45:00',2.03),('15128','2013-03-06','10:50:00',1.91),('15128','2013-03-06','10:55:00',2.23),('15128','2013-03-06','11:00:00',1.34),('15128','2013-03-06','11:05:00',1.04),('15128','2013-03-06','11:40:00',2.65),('15128','2013-03-06','11:45:00',2.79),('15128','2013-03-06','11:50:00',2.19),('15128','2013-03-06','11:55:00',2.04),('15128','2013-03-06','12:00:00',1.89),('15128','2013-03-06','12:05:00',1.48),('15128','2013-03-06','12:10:00',1.33),('15128','2013-03-06','12:15:00',1.02),('15128','2013-03-06','12:20:00',1.12),('15128','2013-03-06','12:25:00',2.14),('15128','2013-03-06','12:30:00',2.01),('15128','2013-03-06','12:35:00',1.24),('15128','2013-03-06','12:55:00',1.44),('15128','2013-03-06','13:00:00',1.92),('15128','2013-03-06','13:05:00',2.52),('15128','2013-03-06','13:10:00',2.63),('15128','2013-03-06','13:15:00',3.06),('15128','2013-03-06','13:20:00',1.35),('15128','2013-03-06','13:25:00',1.04),('15128','2013-03-06','13:30:00',1.01),('15128','2013-03-06','13:35:00',1.37),('15128','2013-03-06','13:40:00',1.55),('15128','2013-03-06','14:05:00',1.28),('15128','2013-03-06','14:10:00',1.18),('15128','2013-03-06','14:20:00',1.02),('15128','2013-03-06','15:20:00',1.2),('15128','2013-03-06','15:25:00',1.12),('15128','2013-03-06','16:30:00',1.22),('15128','2013-03-06','16:35:00',1.37),('15128','2013-03-06','16:40:00',1.01),('15128','2013-03-04','08:40:00',1.1),('15128','2013-03-04','08:45:00',1.24),('15128','2013-03-04','08:50:00',1.44),('15128','2013-03-04','08:55:00',1.53),('15128','2013-03-04','09:00:00',1.4),('15128','2013-03-04','09:05:00',1.36),('15128','2013-03-04','09:10:00',1.32),('15128','2013-03-04','09:15:00',1.38),('15128','2013-03-04','09:20:00',1.43),('15128','2013-03-04','09:25:00',1.38),('15128','2013-03-04','09:30:00',1.5),('15128','2013-03-04','09:35:00',1.6),('15128','2013-03-04','09:40:00',1.62),('15128','2013-03-04','09:45:00',1.64),('15128','2013-03-04','09:50:00',1.6),('15128','2013-03-04','09:55:00',1.92),('15128','2013-03-04','10:00:00',1.73),('15128','2013-03-04','10:05:00',1.61),('15128','2013-03-04','10:10:00',1.55),('15128','2013-03-04','10:15:00',1.66),('15128','2013-03-04','10:20:00',1.88),('15128','2013-03-04','10:25:00',1.62),('15128','2013-03-04','10:30:00',1.61),('15128','2013-03-04','10:35:00',1.81),('15128','2013-03-04','10:40:00',2.06),('15128','2013-03-04','10:45:00',2.27),('15128','2013-03-04','10:50:00',2.48),('15128','2013-03-04','10:55:00',2.49),('15128','2013-03-04','11:00:00',2.47),('15128','2013-03-04','11:05:00',2.58),('15128','2013-03-04','11:10:00',2.69),('15128','2013-03-04','11:15:00',2.47),('15128','2013-03-04','11:20:00',2.47),('15128','2013-03-04','11:25:00',2.39),('15128','2013-03-04','11:30:00',2.49),('15128','2013-03-04','11:35:00',2.87),('15128','2013-03-04','11:40:00',2.93),('15128','2013-03-04','11:45:00',2.97),('15128','2013-03-04','11:50:00',3.1),('15128','2013-03-04','11:55:00',3.15),('15128','2013-03-04','12:00:00',3.13),('15128','2013-03-04','12:05:00',3.3),('15128','2013-03-04','12:10:00',3.12),('15128','2013-03-04','12:15:00',3.05),('15128','2013-03-04','12:20:00',3.32),('15128','2013-03-04','12:25:00',2.96),('15128','2013-03-04','12:30:00',2.88),('15128','2013-03-04','12:35:00',2.84),('15128','2013-03-04','12:40:00',2.64),('15128','2013-03-04','12:45:00',2.48),('15128','2013-03-04','12:50:00',2.44),('15128','2013-03-04','12:55:00',2.01),('15128','2013-03-04','13:00:00',1.77),('15128','2013-03-04','13:05:00',1.77),('15128','2013-03-04','13:10:00',1.92),('15128','2013-03-04','13:15:00',1.94),('15128','2013-03-04','13:20:00',1.84),('15128','2013-03-04','13:25:00',1.67),('15128','2013-03-04','13:30:00',1.49),('15128','2013-03-04','13:35:00',1.4),('15128','2013-03-04','13:40:00',1.31),('15128','2013-03-04','13:45:00',1.18),('15128','2013-03-04','13:50:00',1.14),('15128','2013-03-04','13:55:00',1.2),('15128','2013-03-04','14:00:00',1.26),('15128','2013-03-04','14:05:00',1.25),('15128','2013-03-04','14:10:00',1.17),('15128','2013-03-04','14:15:00',1.05),('15128','2013-03-04','14:20:00',1.07),('15128','2013-03-04','14:25:00',1.11),('15128','2013-03-04','14:30:00',1.12),('15128','2013-03-04','14:35:00',1.11),('15128','2013-03-04','14:40:00',1.1),('15128','2013-03-04','14:45:00',1.12),('15128','2013-03-04','14:50:00',1.07),('15128','2013-03-04','15:30:00',1.03),('15128','2013-03-04','15:35:00',1.13),('15128','2013-03-04','15:40:00',1.29),('15128','2013-03-04','15:45:00',1.44),('15128','2013-03-04','15:50:00',1.23),('15128','2013-03-04','15:55:00',1.06),('15128','2013-03-03','08:45:00',1.1),('15128','2013-03-03','08:50:00',1.19),('15128','2013-03-03','08:55:00',1.26),('15128','2013-03-03','09:00:00',1.34),('15128','2013-03-03','09:05:00',1.42),('15128','2013-03-03','09:10:00',1.5),('15128','2013-03-03','09:15:00',1.54),('15128','2013-03-03','09:20:00',1.62),('15128','2013-03-03','09:25:00',1.72),('15128','2013-03-03','09:30:00',1.79),('15128','2013-03-03','09:35:00',1.83),('15128','2013-03-03','09:40:00',1.89),('15128','2013-03-03','09:45:00',1.94),('15128','2013-03-03','09:50:00',1.99),('15128','2013-03-03','09:55:00',2.02),('15128','2013-03-03','10:00:00',2.09),('15128','2013-03-03','10:05:00',2.18),('15128','2013-03-03','10:10:00',2.23),('15128','2013-03-03','10:15:00',2.28),('15128','2013-03-03','10:20:00',2.31),('15128','2013-03-03','10:25:00',2.42),('15128','2013-03-03','10:30:00',2.41),('15128','2013-03-03','10:35:00',2.45),('15128','2013-03-03','10:40:00',2.55),('15128','2013-03-03','10:45:00',2.53),('15128','2013-03-03','10:50:00',2.61),('15128','2013-03-03','10:55:00',2.66),('15128','2013-03-03','11:00:00',2.76),('15128','2013-03-03','11:05:00',2.85),('15128','2013-03-03','11:10:00',2.84),('15128','2013-03-03','11:15:00',3.05),('15128','2013-03-03','11:20:00',3.17),('15128','2013-03-03','11:25:00',3.26),('15128','2013-03-03','11:30:00',3.29),('15128','2013-03-03','11:35:00',3.35),('15128','2013-03-03','11:40:00',3.39),('15128','2013-03-03','11:45:00',3.42),('15128','2013-03-03','11:50:00',3.5),('15128','2013-03-03','11:55:00',3.51),('15128','2013-03-03','12:00:00',3.52),('15128','2013-03-03','12:05:00',3.59),('15128','2013-03-03','12:10:00',3.6),('15128','2013-03-03','12:15:00',3.62),('15128','2013-03-03','12:20:00',3.64),('15128','2013-03-03','12:25:00',3.65),('15128','2013-03-03','12:30:00',3.64),('15128','2013-03-03','12:35:00',3.68),('15128','2013-03-03','12:40:00',3.72),('15128','2013-03-03','12:45:00',3.73),('15128','2013-03-03','12:50:00',3.66),('15128','2013-03-03','12:55:00',3.56),('15128','2013-03-03','13:00:00',3.58),('15128','2013-03-03','13:05:00',3.63),('15128','2013-03-03','13:10:00',3.68),('15128','2013-03-03','13:15:00',3.64),('15128','2013-03-03','13:20:00',3.68),('15128','2013-03-03','13:25:00',3.65),('15128','2013-03-03','13:30:00',3.47),('15128','2013-03-03','13:35:00',3.29),('15128','2013-03-03','13:40:00',3.58),('15128','2013-03-03','13:45:00',3.5),('15128','2013-03-03','13:50:00',3.54),('15128','2013-03-03','13:55:00',3.51),('15128','2013-03-03','14:00:00',3.48),('15128','2013-03-03','14:05:00',3.45),('15128','2013-03-03','14:10:00',3.42),('15128','2013-03-03','14:15:00',3.37),('15128','2013-03-03','14:20:00',3.36),('15128','2013-03-03','14:25:00',3.33),('15128','2013-03-03','14:30:00',3.3),('15128','2013-03-03','14:35:00',3.25),('15128','2013-03-03','14:40:00',3.16),('15128','2013-03-03','14:45:00',3.14),('15128','2013-03-03','14:50:00',3.05),('15128','2013-03-03','14:55:00',3.02),('15128','2013-03-03','15:00:00',2.98),('15128','2013-03-03','15:05:00',2.92),('15128','2013-03-03','15:10:00',2.85),('15128','2013-03-03','15:15:00',2.82),('15128','2013-03-03','15:20:00',2.72),('15128','2013-03-03','15:25:00',2.68),('15128','2013-03-03','15:30:00',2.63),('15128','2013-03-03','15:35:00',2.55),('15128','2013-03-03','15:40:00',2.38),('15128','2013-03-03','15:45:00',2.29),('15128','2013-03-03','15:50:00',2.21),('15128','2013-03-03','15:55:00',2.12),('15128','2013-03-03','16:00:00',1.99),('15128','2013-03-03','16:05:00',1.85),('15128','2013-03-03','16:10:00',1.82),('15128','2013-03-03','16:15:00',1.73),('15128','2013-03-03','16:20:00',1.71),('15128','2013-03-03','16:25:00',1.67),('15128','2013-03-03','16:30:00',1.55),('15128','2013-03-03','16:35:00',1.48),('15128','2013-03-03','16:40:00',1.36),('15128','2013-03-03','16:45:00',1.22),('15128','2013-03-03','16:50:00',1.12),('15128','2013-03-03','16:55:00',1.01),('15128','2013-03-02','08:40:00',1.01),('15128','2013-03-02','08:45:00',1.12),('15128','2013-03-02','08:50:00',1.21),('15128','2013-03-02','08:55:00',1.29),('15128','2013-03-02','09:00:00',1.38),('15128','2013-03-02','09:05:00',1.47),('15128','2013-03-02','09:10:00',1.56),('15128','2013-03-02','09:15:00',1.61),('15128','2013-03-02','09:20:00',1.67),('15128','2013-03-02','09:25:00',1.77),('15128','2013-03-02','09:30:00',1.82),('15128','2013-03-02','09:35:00',1.87),('15128','2013-03-02','09:40:00',1.91),('15128','2013-03-02','09:45:00',1.97),('15128','2013-03-02','09:50:00',2.04),('15128','2013-03-02','09:55:00',2.08),('15128','2013-03-02','10:00:00',2.17),('15128','2013-03-02','10:05:00',2.24),('15128','2013-03-02','10:10:00',2.32),('15128','2013-03-02','10:15:00',2.39),('15128','2013-03-02','10:20:00',2.44),('15128','2013-03-02','10:25:00',2.48),('15128','2013-03-02','10:30:00',2.53),('15128','2013-03-02','10:35:00',2.6),('15128','2013-03-02','10:40:00',2.69),('15128','2013-03-02','10:45:00',2.79),('15128','2013-03-02','10:50:00',2.85),('15128','2013-03-02','10:55:00',2.78),('15128','2013-03-02','11:00:00',2.94),('15128','2013-03-02','11:05:00',2.97),('15128','2013-03-02','11:10:00',3.07),('15128','2013-03-02','11:15:00',3.22),('15128','2013-03-02','11:20:00',3.31),('15128','2013-03-02','11:25:00',3.37),('15128','2013-03-02','11:30:00',3.45),('15128','2013-03-02','11:35:00',3.49),('15128','2013-03-02','11:40:00',3.51),('15128','2013-03-02','11:45:00',3.55),('15128','2013-03-02','11:50:00',3.59),('15128','2013-03-02','11:55:00',3.62),('15128','2013-03-02','12:00:00',3.66),('15128','2013-03-02','12:05:00',3.7),('15128','2013-03-02','12:10:00',3.73),('15128','2013-03-02','12:15:00',3.74),('15128','2013-03-02','12:20:00',3.78),('15128','2013-03-02','12:25:00',3.79),('15128','2013-03-02','12:30:00',3.8),('15128','2013-03-02','12:35:00',3.81),('15128','2013-03-02','12:40:00',3.81),('15128','2013-03-02','12:45:00',3.78),('15128','2013-03-02','12:50:00',3.76),('15128','2013-03-02','12:55:00',3.79),('15128','2013-03-02','13:00:00',3.82),('15128','2013-03-02','13:05:00',3.82),('15128','2013-03-02','13:10:00',3.81),('15128','2013-03-02','13:15:00',3.81),('15128','2013-03-02','13:20:00',3.79),('15128','2013-03-02','13:25:00',3.78),('15128','2013-03-02','13:30:00',3.78),('15128','2013-03-02','13:35:00',3.77),('15128','2013-03-02','13:40:00',3.74),('15128','2013-03-02','13:45:00',3.74),('15128','2013-03-02','13:50:00',3.74),('15128','2013-03-02','13:55:00',3.7),('15128','2013-03-02','14:00:00',3.67),('15128','2013-03-02','14:05:00',3.64),('15128','2013-03-02','14:10:00',3.6),('15128','2013-03-02','14:15:00',3.56),('15128','2013-03-02','14:20:00',3.5),('15128','2013-03-02','14:25:00',3.47),('15128','2013-03-02','14:30:00',3.42),('15128','2013-03-02','14:35:00',3.39),('15128','2013-03-02','14:40:00',3.37),('15128','2013-03-02','14:45:00',3.3),('15128','2013-03-02','14:50:00',3.25),('15128','2013-03-02','14:55:00',3.2),('15128','2013-03-02','15:00:00',3.16),('15128','2013-03-02','15:05:00',3.1),('15128','2013-03-02','15:10:00',3.01),('15128','2013-03-02','15:15:00',2.98),('15128','2013-03-02','15:20:00',2.91),('15128','2013-03-02','15:25:00',2.84),('15128','2013-03-02','15:30:00',2.79),('15128','2013-03-02','15:35:00',2.74),('15128','2013-03-02','15:40:00',2.65),('15128','2013-03-02','15:45:00',2.55),('15128','2013-03-02','15:50:00',2.44),('15128','2013-03-02','15:55:00',2.3),('15128','2013-03-02','16:00:00',2.17),('15128','2013-03-02','16:05:00',2.06),('15128','2013-03-02','16:10:00',2.01),('15128','2013-03-02','16:15:00',1.88),('15128','2013-03-02','16:20:00',1.85),('15128','2013-03-02','16:25:00',1.77),('15128','2013-03-02','16:30:00',1.68),('15128','2013-03-02','16:35:00',1.62),('15128','2013-03-02','16:40:00',1.5),('15128','2013-03-02','16:45:00',1.38),('15128','2013-03-02','16:50:00',1.27),('15128','2013-03-02','16:55:00',1.15),('15128','2013-03-02','17:00:00',1.01),('15128','2014-03-23','08:45:00',1.06),('15128','2014-03-23','08:50:00',1.34),('15128','2014-03-23','09:15:00',1.74),('15128','2014-03-23','09:20:00',1.36),('15128','2014-03-23','09:25:00',1.81),('15128','2014-03-23','09:30:00',1.16),('15128','2014-03-23','09:35:00',1.97),('15128','2014-03-23','09:40:00',1.47),('15128','2014-03-23','09:45:00',1.05),('15128','2014-03-23','09:55:00',1.71),('15128','2014-03-23','10:00:00',2.94),('15128','2014-03-23','10:05:00',2.2),('15128','2014-03-23','10:10:00',1.46),('15128','2014-03-23','10:20:00',1.91),('15128','2014-03-23','10:25:00',1.14),('15128','2014-03-23','10:30:00',1.83),('15128','2014-03-23','10:35:00',1.18),('15128','2014-03-23','10:40:00',1.53),('15128','2014-03-23','10:45:00',2.07),('15128','2014-03-23','10:50:00',3.59),('15128','2014-03-23','10:55:00',3.51),('15128','2014-03-23','11:00:00',2.9),('15128','2014-03-23','11:05:00',3.46),('15128','2014-03-23','11:10:00',2.52),('15128','2014-03-23','11:15:00',3.62),('15128','2014-03-23','11:20:00',4.25),('15128','2014-03-23','11:25:00',3.78),('15128','2014-03-23','11:30:00',2.07),('15128','2014-03-23','12:20:00',1.01),('15128','2014-03-23','12:25:00',1.49),('15128','2014-03-23','12:30:00',2.09),('15128','2014-03-23','12:35:00',2.04),('15128','2014-03-23','12:40:00',1.6),('15128','2014-03-23','12:45:00',1.53),('15128','2014-03-23','12:50:00',1.55),('15128','2014-03-23','12:55:00',1.54),('15128','2014-03-23','13:00:00',1.61),('15128','2014-03-23','13:05:00',1.66),('15128','2014-03-23','13:10:00',2.03),('15128','2014-03-23','13:15:00',2.71),('15128','2014-03-23','13:20:00',2.65),('15128','2014-03-23','13:25:00',2.27),('15128','2014-03-23','13:30:00',2.12),('15128','2014-03-23','13:35:00',1.5),('15128','2014-03-23','13:40:00',1.29),('15128','2014-03-23','13:45:00',1.3),('15128','2014-03-23','13:50:00',1.03),('15128','2014-03-23','13:55:00',1.08),('15128','2014-03-23','14:00:00',1.24),('15128','2014-03-23','14:05:00',1.33),('15128','2014-03-23','14:10:00',1.49),('15128','2014-03-23','14:15:00',2.02),('15128','2014-03-23','14:20:00',2.62),('15128','2014-03-23','14:25:00',2.34),('15128','2014-03-23','14:30:00',2.74),('15128','2014-03-23','14:35:00',3.14),('15128','2014-03-23','14:40:00',2.44),('15128','2014-03-23','14:45:00',2.36),('15128','2014-03-23','14:50:00',2.44),('15128','2014-03-23','14:55:00',1.87),('15128','2014-03-23','15:00:00',2.2),('15128','2014-03-23','15:05:00',2.32),('15128','2014-03-23','15:10:00',2),('15128','2014-03-23','15:15:00',1.91),('15128','2014-03-23','15:20:00',1.87),('15128','2014-03-23','15:25:00',1.64),('15128','2014-03-23','15:30:00',1.85),('15128','2014-03-23','15:35:00',1.9),('15128','2014-03-23','15:40:00',1.29),('15128','2014-03-23','15:45:00',1.61),('15128','2014-03-23','15:50:00',2.1),('15128','2014-03-23','15:55:00',1.33),('15128','2014-03-23','16:00:00',1.01),('15128','2013-03-01','09:55:00',1.06),('15128','2013-03-01','10:40:00',1.02),('15128','2013-03-01','10:45:00',1.13),('15128','2013-03-01','10:50:00',1.19),('15128','2013-03-01','10:55:00',1.28),('15128','2013-03-01','11:00:00',1.26),('15128','2013-03-01','11:05:00',1.34),('15128','2013-03-01','11:10:00',1.38),('15128','2013-03-01','11:15:00',1.29),('15128','2013-03-01','11:20:00',1.47),('15128','2013-03-01','11:25:00',1.69),('15128','2013-03-01','11:30:00',1.78),('15128','2013-03-01','11:35:00',1.84),('15128','2013-03-01','11:40:00',2.32),('15128','2013-03-01','11:45:00',2.28),('15128','2013-03-01','11:50:00',2.1),('15128','2013-03-01','11:55:00',2.44),('15128','2013-03-01','12:00:00',1.97),('15128','2013-03-01','12:05:00',1.47),('15128','2013-03-01','12:10:00',1.34),('15128','2013-03-01','12:15:00',1.26),('15128','2013-03-01','12:20:00',1.55),('15128','2013-03-01','12:25:00',2.12),('15128','2013-03-01','12:30:00',1.4),('15128','2013-03-01','12:35:00',1.39),('15128','2013-03-01','12:40:00',1.39),('15128','2013-03-01','12:45:00',1.27),('15128','2013-03-01','12:50:00',1.19),('15128','2013-03-01','12:55:00',1.16),('15128','2013-03-01','13:00:00',1.06),('15128','2013-03-01','13:05:00',1.03),('15128','2013-03-01','13:10:00',1.05),('15128','2013-03-01','13:15:00',1.02),('15128','2013-03-01','13:20:00',1.05),('15128','2013-03-01','13:25:00',1.14),('15128','2013-03-01','13:30:00',1.26),('15128','2013-03-01','13:35:00',1.39),('15128','2013-03-01','13:40:00',1.45),('15128','2013-03-01','13:45:00',1.46),('15128','2013-03-01','13:50:00',1.41),('15128','2013-03-01','13:55:00',1.45),('15128','2013-03-01','14:00:00',1.34),('15128','2013-03-01','14:05:00',1.3),('15128','2013-02-28','08:40:00',1.02),('15128','2013-02-28','08:45:00',1.09),('15128','2013-02-28','08:50:00',1.21),('15128','2013-02-28','08:55:00',1.4),('15128','2013-02-28','09:00:00',1.48),('15128','2013-02-28','09:05:00',1.61),('15128','2013-02-28','09:10:00',1.63),('15128','2013-02-28','09:15:00',1.65),('15128','2013-02-28','09:20:00',1.63),('15128','2013-02-28','09:25:00',1.64),('15128','2013-02-28','09:30:00',1.74),('15128','2013-02-28','09:35:00',1.83),('15128','2013-02-28','09:40:00',1.84),('15128','2013-02-28','09:45:00',1.89),('15128','2013-02-28','09:50:00',2.02),('15128','2013-02-28','09:55:00',2.12),('15128','2013-02-28','10:00:00',2.03),('15128','2013-02-28','10:05:00',1.86),('15128','2013-02-28','10:10:00',1.78),('15128','2013-02-28','10:15:00',1.79),('15128','2013-02-28','10:20:00',1.86),('15128','2013-02-28','10:25:00',1.91),('15128','2013-02-28','10:30:00',2.07),('15128','2013-02-28','10:35:00',2.26),('15128','2013-02-28','10:40:00',2.44),('15128','2013-02-28','10:45:00',2.22),('15128','2013-02-28','10:50:00',2.14),('15128','2013-02-28','10:55:00',2.1),('15128','2013-02-28','11:00:00',2.08),('15128','2013-02-28','11:05:00',1.99),('15128','2013-02-28','11:10:00',1.91),('15128','2013-02-28','11:15:00',1.91),('15128','2013-02-28','11:20:00',1.98),('15128','2013-02-28','11:25:00',1.92),('15128','2013-02-28','11:30:00',1.86),('15128','2013-02-28','11:35:00',1.82),('15128','2013-02-28','11:40:00',1.73),('15128','2013-02-28','11:45:00',1.66),('15128','2013-02-28','11:50:00',1.64),('15128','2013-02-28','11:55:00',1.55),('15128','2013-02-28','12:00:00',1.46),('15128','2013-02-28','12:05:00',1.38),('15128','2013-02-28','12:10:00',1.31),('15128','2013-02-28','12:15:00',1.25),('15128','2013-02-28','12:20:00',1.23),('15128','2013-02-28','12:25:00',1.23),('15128','2013-02-28','12:30:00',1.28),('15128','2013-02-28','12:35:00',1.26),('15128','2013-02-28','12:40:00',1.23),('15128','2013-02-28','12:45:00',1.28),('15128','2013-02-28','12:50:00',1.38),('15128','2013-02-28','12:55:00',1.44),('15128','2013-02-28','13:00:00',1.47),('15128','2013-02-28','13:05:00',1.49),('15128','2013-02-28','13:10:00',1.52),('15128','2013-02-28','13:15:00',1.59),('15128','2013-02-28','13:20:00',1.74),('15128','2013-02-28','13:25:00',1.82),('15128','2013-02-28','13:30:00',1.71),('15128','2013-02-28','13:35:00',1.57),('15128','2013-02-28','13:40:00',1.49),('15128','2013-02-28','13:45:00',1.49),('15128','2013-02-28','13:50:00',1.52),('15128','2013-02-28','13:55:00',1.5),('15128','2013-02-28','14:00:00',1.44),('15128','2013-02-28','14:05:00',1.37),('15128','2013-02-28','14:10:00',1.31),('15128','2013-02-28','14:15:00',1.27),('15128','2013-02-28','14:20:00',1.26),('15128','2013-02-28','14:25:00',1.25),('15128','2013-02-28','14:30:00',1.24),('15128','2013-02-28','14:35:00',1.2),('15128','2013-02-28','14:40:00',1.14),('15128','2013-02-28','14:45:00',1.1),('15128','2013-02-28','14:50:00',1.07),('15128','2013-02-28','14:55:00',1.04),('15128','2013-02-28','15:00:00',1.02),('15128','2013-02-27','08:50:00',1.06),('15128','2013-02-27','08:55:00',1.16),('15128','2013-02-27','09:00:00',1.25),('15128','2013-02-27','09:05:00',1.32),('15128','2013-02-27','09:10:00',1.38),('15128','2013-02-27','09:15:00',1.47),('15128','2013-02-27','09:20:00',1.54),('15128','2013-02-27','09:25:00',1.61),('15128','2013-02-27','09:30:00',1.68),('15128','2013-02-27','09:35:00',1.74),('15128','2013-02-27','09:40:00',1.81),('15128','2013-02-27','09:45:00',1.83),('15128','2013-02-27','09:50:00',1.89),('15128','2013-02-27','09:55:00',1.95),('15128','2013-02-27','10:00:00',2.04),('15128','2013-02-27','10:05:00',2.08),('15128','2013-02-27','10:10:00',2.13),('15128','2013-02-27','10:15:00',2.18),('15128','2013-02-27','10:20:00',2.23),('15128','2013-02-27','10:25:00',2.29),('15128','2013-02-27','10:30:00',2.35),('15128','2013-02-27','10:35:00',2.4),('15128','2013-02-27','10:40:00',2.47),('15128','2013-02-27','10:45:00',2.55),('15128','2013-02-27','10:50:00',2.52),('15128','2013-02-27','10:55:00',2.65),('15128','2013-02-27','11:00:00',2.71),('15128','2013-02-27','11:05:00',2.65),('15128','2013-02-27','11:10:00',2.78),('15128','2013-02-27','11:15:00',2.87),('15128','2013-02-27','11:20:00',3.07),('15128','2013-02-27','11:25:00',3.12),('15128','2013-02-27','11:30:00',3.15),('15128','2013-02-27','11:35:00',3.15),('15128','2013-02-27','11:40:00',3.22),('15128','2013-02-27','11:45:00',3.31),('15128','2013-02-27','11:50:00',3.34),('15128','2013-02-27','11:55:00',3.34),('15128','2013-02-27','12:00:00',3.35),('15128','2013-02-27','12:05:00',3.41),('15128','2013-02-27','12:10:00',3.49),('15128','2013-02-27','12:15:00',3.51),('15128','2013-02-27','12:20:00',3.48),('15128','2013-02-27','12:25:00',3.52),('15128','2013-02-27','12:30:00',3.51),('15128','2013-02-27','12:35:00',3.54),('15128','2013-02-27','12:40:00',3.55),('15128','2013-02-27','12:45:00',3.59),('15128','2013-02-27','12:50:00',3.6),('15128','2013-02-27','12:55:00',3.43),('15128','2013-02-27','13:00:00',3.33),('15128','2013-02-27','13:05:00',3.5),('15128','2013-02-27','13:10:00',3.55),('15128','2013-02-27','13:15:00',3.55),('15128','2013-02-27','13:20:00',2.9),('15128','2013-02-27','13:25:00',3.32),('15128','2013-02-27','13:30:00',2.32),('15128','2013-02-27','13:35:00',3.59),('15128','2013-02-27','13:40:00',1.57),('15128','2013-02-27','13:45:00',1.14),('15128','2013-02-27','13:50:00',1.57),('15128','2013-02-27','13:55:00',2.37),('15128','2013-02-27','14:00:00',3.03),('15128','2013-02-27','14:05:00',3.57),('15128','2013-02-27','14:10:00',3.38),('15128','2013-02-27','14:15:00',3.33),('15128','2013-02-27','14:20:00',3.36),('15128','2013-02-27','14:25:00',3.21),('15128','2013-02-27','14:30:00',3.18),('15128','2013-02-27','14:35:00',3.1),('15128','2013-02-27','14:40:00',3.07),('15128','2013-02-27','14:45:00',2.99),('15128','2013-02-27','14:50:00',2.82),('15128','2013-02-27','14:55:00',2.76),('15128','2013-02-27','15:00:00',2.7),('15128','2013-02-27','15:05:00',2.64),('15128','2013-02-27','15:10:00',2.59),('15128','2013-02-27','15:15:00',2.59),('15128','2013-02-27','15:20:00',2.53),('15128','2013-02-27','15:25:00',2.52),('15128','2013-02-27','15:30:00',2.45),('15128','2013-02-27','15:35:00',2.36),('15128','2013-02-27','15:40:00',2.22),('15128','2013-02-27','15:45:00',2.04),('15128','2013-02-27','15:50:00',2.01),('15128','2013-02-27','15:55:00',1.93),('15128','2013-02-27','16:00:00',1.83),('15128','2013-02-27','16:05:00',1.75),('15128','2013-02-27','16:10:00',1.69),('15128','2013-02-27','16:15:00',1.62),('15128','2013-02-27','16:20:00',1.51),('15128','2013-02-27','16:25:00',1.41),('15128','2013-02-27','16:30:00',1.37),('15128','2013-02-27','16:35:00',1.28),('15128','2013-02-27','16:40:00',1.15),('15128','2013-02-27','16:45:00',1.04),('15128','2013-02-26','08:55:00',1.11),('15128','2013-02-26','09:00:00',1.21),('15128','2013-02-26','09:05:00',1.29),('15128','2013-02-26','09:10:00',1.36),('15128','2013-02-26','09:15:00',1.44),('15128','2013-02-26','09:20:00',1.52),('15128','2013-02-26','09:25:00',1.57),('15128','2013-02-26','09:30:00',1.64),('15128','2013-02-26','09:35:00',1.69),('15128','2013-02-26','09:40:00',1.74),('15128','2013-02-26','09:45:00',1.8),('15128','2013-02-26','09:50:00',1.88),('15128','2013-02-26','09:55:00',1.92),('15128','2013-02-26','10:00:00',2.01),('15128','2013-02-26','10:05:00',2.07),('15128','2013-02-26','10:10:00',2.11),('15128','2013-02-26','10:15:00',2.16),('15128','2013-02-26','10:20:00',2.23),('15128','2013-02-26','10:25:00',2.27),('15128','2013-02-26','10:30:00',2.32),('15128','2013-02-26','10:35:00',2.37),('15128','2013-02-26','10:40:00',2.46),('15128','2013-02-26','10:45:00',2.49),('15128','2013-02-26','10:50:00',2.52),('15128','2013-02-26','10:55:00',2.58),('15128','2013-02-26','11:00:00',2.6),('15128','2013-02-26','11:05:00',2.7),('15128','2013-02-26','11:10:00',2.84),('15128','2013-02-26','11:15:00',2.74),('15128','2013-02-26','11:20:00',2.87),('15128','2013-02-26','11:25:00',3.07),('15128','2013-02-26','11:30:00',3.12),('15128','2013-02-26','11:35:00',3.19),('15128','2013-02-26','11:40:00',3.21),('15128','2013-02-26','11:45:00',3.26),('15128','2013-02-26','11:50:00',3.39),('15128','2013-02-26','11:55:00',3.34),('15128','2013-02-26','12:00:00',3.52),('15128','2013-02-26','12:05:00',3.62),('15128','2013-02-26','12:10:00',3.12),('15128','2013-02-26','12:15:00',3.59),('15128','2013-02-26','12:20:00',3.56),('15128','2013-02-26','12:25:00',3.53),('15128','2013-02-26','12:30:00',3.67),('15128','2013-02-26','12:35:00',3.67),('15128','2013-02-26','12:40:00',3.65),('15128','2013-02-26','12:45:00',3.66),('15128','2013-02-26','12:50:00',3.54),('15128','2013-02-26','12:55:00',3.63),('15128','2013-02-26','13:00:00',2.17),('15128','2013-02-26','13:05:00',2.95),('15128','2013-02-26','13:10:00',3.68),('15128','2013-02-26','13:15:00',3.57),('15128','2013-02-26','13:20:00',3.5),('15128','2013-02-26','13:25:00',3.59),('15128','2013-02-26','13:30:00',3.68),('15128','2013-02-26','13:35:00',3.43),('15128','2013-02-26','13:40:00',3.46),('15128','2013-02-26','13:45:00',3.67),('15128','2013-02-26','13:50:00',3.64),('15128','2013-02-26','13:55:00',3.49),('15128','2013-02-26','14:00:00',3.45),('15128','2013-02-26','14:05:00',3.41),('15128','2013-02-26','14:10:00',3.4),('15128','2013-02-26','14:15:00',2.57),('15128','2013-02-26','14:20:00',3.39),('15128','2013-02-26','14:25:00',1.09),('15128','2013-02-26','14:35:00',2.47),('15128','2013-02-26','14:40:00',2.1),('15128','2013-02-26','14:45:00',3.01),('15128','2013-02-26','14:50:00',3.19),('15128','2013-02-26','14:55:00',3),('15128','2013-02-26','15:00:00',2.7),('15128','2013-02-26','15:05:00',2.77),('15128','2013-02-26','15:10:00',2.76),('15128','2013-02-26','15:15:00',2.69),('15128','2013-02-26','15:20:00',2.61),('15128','2013-02-26','15:25:00',2.55),('15128','2013-02-26','15:30:00',2.51),('15128','2013-02-26','15:35:00',2.39),('15128','2013-02-26','15:40:00',2.28),('15128','2013-02-26','15:45:00',2.26),('15128','2013-02-26','15:50:00',2.13),('15128','2013-02-26','15:55:00',1.99),('15128','2013-02-26','16:00:00',1.87),('15128','2013-02-26','16:05:00',1.88),('15128','2013-02-26','16:10:00',1.81),('15128','2013-02-26','16:15:00',1.72),('15128','2013-02-26','16:20:00',1.63),('15128','2013-02-26','16:25:00',1.55),('15128','2013-02-26','16:30:00',1.48),('15128','2013-02-26','16:35:00',1.37),('15128','2013-02-26','16:40:00',1.23),('15128','2013-02-26','16:45:00',1.13),('15128','2013-02-26','16:50:00',1),('15128','2013-02-25','09:15:00',1.01),('15128','2013-02-25','09:20:00',1.1),('15128','2013-02-25','09:25:00',1.18),('15128','2013-02-25','09:30:00',1.24),('15128','2013-02-25','09:35:00',1.33),('15128','2013-02-25','09:40:00',1.44),('15128','2013-02-25','09:45:00',1.5),('15128','2013-02-25','09:50:00',1.54),('15128','2013-02-25','09:55:00',1.77),('15128','2013-02-25','10:00:00',1.94),('15128','2013-02-25','10:05:00',2.07),('15128','2013-02-25','10:10:00',1.9),('15128','2013-02-25','10:15:00',1.86),('15128','2013-02-25','10:20:00',2.23),('15128','2013-02-25','10:25:00',1.69),('15128','2013-02-25','10:30:00',1.42),('15128','2013-02-25','10:35:00',1.97),('15128','2013-02-25','10:40:00',1.53),('15128','2013-02-25','10:45:00',1.53),('15128','2013-02-25','10:50:00',1.62),('15128','2013-02-25','10:55:00',1.51),('15128','2013-02-25','11:00:00',1.52),('15128','2013-02-25','11:05:00',1.43),('15128','2013-02-25','11:10:00',1.4),('15128','2013-02-25','11:15:00',1.53),('15128','2013-02-25','11:20:00',1.84),('15128','2013-02-25','11:25:00',2.02),('15128','2013-02-25','11:30:00',2.22),('15128','2013-02-25','11:35:00',2.62),('15128','2013-02-25','11:40:00',3.51),('15128','2013-02-25','11:45:00',3.01),('15128','2013-02-25','11:50:00',3.63),('15128','2013-02-25','11:55:00',3.18),('15128','2013-02-25','12:00:00',2.67),('15128','2013-02-25','12:05:00',2.53),('15128','2013-02-25','12:10:00',1.67),('15128','2013-02-25','12:15:00',1.93),('15128','2013-02-25','12:20:00',1.65),('15128','2013-02-25','12:25:00',1.68),('15128','2013-02-25','12:30:00',1.75),('15128','2013-02-25','12:35:00',1.59),('15128','2013-02-25','12:40:00',1.62),('15128','2013-02-25','12:45:00',1.52),('15128','2013-02-25','12:50:00',1.41),('15128','2013-02-25','12:55:00',1.39),('15128','2013-02-25','13:00:00',1.36),('15128','2013-02-25','13:05:00',1.18),('15128','2013-02-25','13:10:00',1.31),('15128','2013-02-25','13:15:00',1.46),('15128','2013-02-25','13:20:00',1.4),('15128','2013-02-25','13:25:00',1.33),('15128','2013-02-25','13:30:00',1.19),('15128','2013-02-25','13:35:00',1.01),('15128','2013-02-24','10:40:00',1.18),('15128','2013-02-24','10:45:00',1.57),('15128','2013-02-24','10:50:00',1.96),('15128','2013-02-24','10:55:00',2.44),('15128','2013-02-24','11:00:00',2.28),('15128','2013-02-24','11:05:00',2.04),('15128','2013-02-24','11:10:00',3.01),('15128','2013-02-24','11:15:00',2.77),('15128','2013-02-24','11:20:00',1.91),('15128','2013-02-24','11:25:00',2.23),('15128','2013-02-24','11:30:00',2.1),('15128','2013-02-24','11:35:00',1.58),('15128','2013-02-24','11:40:00',1.34),('15128','2013-02-24','11:45:00',1.22),('15128','2013-02-24','11:50:00',1.23),('15128','2013-02-24','11:55:00',1.36),('15128','2013-02-24','12:00:00',1.6),('15128','2013-02-24','12:05:00',1.89),('15128','2013-02-24','12:10:00',1.86),('15128','2013-02-24','12:15:00',2.37),('15128','2013-02-24','12:20:00',2.31),('15128','2013-02-24','12:25:00',2.52),('15128','2013-02-24','12:30:00',3.91),('15128','2013-02-24','12:35:00',2.25),('15128','2013-02-24','12:40:00',3.96),('15128','2013-02-24','12:45:00',3.63),('15128','2013-02-24','12:50:00',3.62),('15128','2013-02-24','12:55:00',3.35),('15128','2013-02-24','13:00:00',4.29),('15128','2013-02-24','13:05:00',4.13),('15128','2013-02-24','13:10:00',4.33),('15128','2013-02-24','13:15:00',3.74),('15128','2013-02-24','13:20:00',1.68),('15128','2013-02-24','13:25:00',1.71),('15128','2013-02-24','13:30:00',1.35),('15128','2013-02-24','13:35:00',1.34),('15128','2013-02-24','13:40:00',1.24),('15128','2013-02-24','13:45:00',1.45),('15128','2013-02-24','13:50:00',1.34),('15128','2013-02-24','13:55:00',1.23),('15128','2013-02-24','14:00:00',1.32),('15128','2013-02-24','14:05:00',1.33),('15128','2013-02-24','14:10:00',1.12),('15128','2013-02-24','16:40:00',1.12),('15128','2013-02-24','16:55:00',1.1),('15128','2013-02-23','10:45:00',1.43),('15128','2013-02-23','10:50:00',2.04),('15128','2013-02-23','10:55:00',2.35),('15128','2013-02-23','11:00:00',2.02),('15128','2013-02-23','11:05:00',1.35),('15128','2013-02-23','11:35:00',1.04),('15128','2013-02-23','11:40:00',1.14),('15128','2013-02-23','11:45:00',1.22),('15128','2013-02-23','11:50:00',1.31),('15128','2013-02-23','11:55:00',1.32),('15128','2013-02-23','12:00:00',1.02),('15128','2013-02-23','12:30:00',1.14),('15128','2013-02-23','12:35:00',1.52),('15128','2013-02-23','12:40:00',1.47),('15128','2013-02-23','12:45:00',1.38),('15128','2013-02-23','12:50:00',1.95),('15128','2013-02-23','12:55:00',2.08),('15128','2013-02-23','13:00:00',2.22),('15128','2013-02-23','13:05:00',2.82),('15128','2013-02-23','13:10:00',1.63),('15128','2013-02-23','13:20:00',1.29),('15128','2013-02-23','13:25:00',1.91),('15128','2013-02-23','13:30:00',1.19),('15128','2013-02-23','13:35:00',1.51),('15128','2013-02-23','13:40:00',1.62),('15128','2013-02-23','13:45:00',2),('15128','2013-02-23','13:50:00',1.32),('15128','2013-02-23','13:55:00',1.62),('15128','2013-02-23','14:00:00',1.97),('15128','2013-02-23','14:05:00',1.86),('15128','2013-02-23','14:10:00',2.12),('15128','2013-02-23','14:15:00',1.37),('15128','2013-02-23','14:20:00',1.2),('15128','2013-02-23','14:25:00',1.47),('15128','2013-02-23','14:30:00',1.09),('15128','2013-02-23','14:50:00',1.11),('15128','2013-02-23','14:55:00',2.82),('15128','2013-02-23','15:00:00',2.46),('15128','2013-02-23','15:05:00',1.69),('15128','2013-02-23','15:10:00',2.7),('15128','2013-02-23','15:20:00',1.83),('15128','2013-02-23','15:25:00',2.59),('15128','2013-02-23','15:30:00',1.76),('15128','2013-02-23','15:35:00',2.39),('15128','2013-02-23','15:45:00',2.44),('15128','2013-02-23','15:50:00',1.18),('15128','2013-02-23','16:05:00',1.66),('15128','2013-02-23','16:10:00',1.64),('15128','2013-02-23','16:15:00',1.9),('15128','2013-02-23','16:20:00',1.68),('15128','2013-02-22','08:55:00',1.05),('15128','2013-02-22','09:00:00',1.06),('15128','2013-02-22','09:05:00',1.13),('15128','2013-02-22','09:50:00',1.17),('15128','2013-02-22','09:55:00',1.26),('15128','2013-02-22','10:10:00',1.03),('15128','2013-02-22','10:30:00',1.1),('15128','2013-02-22','10:40:00',1.02),('15128','2013-02-22','10:45:00',1.18),('15128','2013-02-22','10:50:00',1.34),('15128','2013-02-22','10:55:00',1.36),('15128','2013-02-22','11:25:00',1.06),('15128','2013-02-22','11:30:00',1.21),('15128','2013-02-22','11:35:00',1.19),('15128','2013-02-21','14:30:00',1.05),('15128','2013-02-21','14:35:00',1.28),('15128','2013-02-21','14:40:00',1.8),('15128','2013-02-21','14:45:00',1.01),('15128','2013-02-21','14:55:00',1.1),('15128','2013-02-21','15:00:00',1.46),('15128','2013-02-21','15:05:00',1.12),('15128','2013-02-21','15:35:00',1.06),('15128','2013-02-20','11:40:00',1.04),('15128','2013-02-20','11:45:00',1.07),('15128','2013-02-20','11:50:00',1.04),('15128','2013-02-20','12:00:00',1.1),('15128','2013-02-20','12:05:00',1.25),('15128','2013-02-20','12:10:00',1.23),('15128','2013-02-20','12:15:00',1.22),('15128','2013-02-20','12:20:00',1.18),('15128','2013-02-20','12:25:00',1.18),('15128','2013-02-20','12:30:00',1.2),('15128','2013-02-20','12:35:00',1.35),('15128','2013-02-20','12:40:00',1.33),('15128','2013-02-20','12:45:00',1.25),('15128','2013-02-20','12:50:00',1.17),('15128','2013-02-20','12:55:00',1.18),('15128','2013-02-20','13:00:00',1.26),('15128','2013-02-20','13:05:00',1.23),('15128','2013-02-20','13:10:00',1.17),('15128','2013-02-20','13:15:00',1.29),('15128','2013-02-20','13:20:00',1.42),('15128','2013-02-20','13:25:00',1.32),('15128','2013-02-20','13:30:00',1.21),('15128','2013-02-20','13:35:00',1.16),('15128','2013-02-20','13:40:00',1.11),('15128','2013-02-20','13:45:00',1.13),('15128','2013-02-20','13:50:00',1.07),('15128','2013-02-20','13:55:00',1.08),('15128','2013-02-20','15:25:00',1),('15128','2013-02-20','15:30:00',1.09),('15128','2013-02-20','15:35:00',1.15),('15128','2013-02-20','15:40:00',1.21),('15128','2013-02-20','15:45:00',1.28),('15128','2013-02-20','15:50:00',1.16),('15128','2013-02-20','15:55:00',1.63),('15128','2013-02-20','16:00:00',1.68),('15128','2013-02-20','16:05:00',1.39),('15128','2013-02-20','16:10:00',1.82),('15128','2013-02-20','16:15:00',1.86),('15128','2013-02-20','16:20:00',1.75),('15128','2013-02-20','16:25:00',1.56),('15128','2013-02-20','16:30:00',1.35),('15128','2013-02-20','16:35:00',1.17),('15128','2014-03-22','08:20:00',1),('15128','2014-03-22','08:25:00',1.07),('15128','2014-03-22','08:30:00',1.53),('15128','2014-03-22','08:35:00',1.06),('15128','2014-03-22','08:50:00',1.57),('15128','2014-03-22','08:55:00',1.11),('15128','2014-03-22','09:00:00',1.37),('15128','2014-03-22','09:05:00',1.98),('15128','2014-03-22','09:10:00',1.96),('15128','2014-03-22','09:15:00',1.91),('15128','2014-03-22','09:20:00',1.12),('15128','2014-03-22','09:25:00',1.05),('15128','2014-03-22','09:30:00',1.36),('15128','2014-03-22','10:20:00',1),('15128','2014-03-22','10:25:00',1.48),('15128','2014-03-22','10:40:00',1.15),('15128','2014-03-22','10:45:00',1.19),('15128','2014-03-22','10:50:00',1.2),('15128','2014-03-22','10:55:00',1.11),('15128','2014-03-22','11:05:00',1.42),('15128','2014-03-22','11:20:00',1.13),('15128','2014-03-22','11:25:00',1.27),('15128','2014-03-22','11:30:00',1.31),('15128','2014-03-22','11:35:00',1.25),('15128','2014-03-22','13:35:00',2.52),('15128','2014-03-22','13:40:00',1.97),('15128','2014-03-22','13:45:00',1.22),('15128','2014-03-22','13:50:00',1.22),('15128','2014-03-22','14:55:00',1.3),('15128','2014-03-22','15:05:00',1.23),('15128','2014-03-22','15:10:00',1.74),('15128','2014-03-22','15:15:00',1.85),('15128','2014-03-22','15:20:00',1.11),('15128','2014-03-22','15:25:00',1.03),('15128','2013-02-19','09:05:00',1.13),('15128','2013-02-19','09:10:00',1.18),('15128','2013-02-19','09:15:00',1.42),('15128','2013-02-19','09:20:00',1.57),('15128','2013-02-19','09:25:00',1.52),('15128','2013-02-19','09:30:00',1.53),('15128','2013-02-19','09:35:00',1.71),('15128','2013-02-19','09:40:00',1.78),('15128','2013-02-19','09:45:00',1.41),('15128','2013-02-19','09:55:00',1.21),('15128','2013-02-19','10:00:00',1.92),('15128','2013-02-19','10:05:00',1.32),('15128','2013-02-19','10:10:00',1.33),('15128','2013-02-19','10:15:00',2.11),('15128','2013-02-19','10:20:00',2.09),('15128','2013-02-19','10:25:00',1.22),('15128','2013-02-19','10:30:00',2.29),('15128','2013-02-19','10:35:00',1.72),('15128','2013-02-19','10:40:00',2.38),('15128','2013-02-19','10:45:00',2.35),('15128','2013-02-19','10:50:00',1.24),('15128','2013-02-19','10:55:00',1.04),('15128','2013-02-19','11:05:00',1.34),('15128','2013-02-19','11:10:00',1.94),('15128','2013-02-19','11:15:00',3.37),('15128','2013-02-19','11:20:00',1.76),('15128','2013-02-19','11:25:00',3.29),('15128','2013-02-19','11:30:00',1.41),('15128','2013-02-19','11:35:00',3.59),('15128','2013-02-19','11:40:00',3.6),('15128','2013-02-19','11:45:00',1.65),('15128','2013-02-19','11:50:00',1.14),('15128','2013-02-19','11:55:00',1.76),('15128','2013-02-19','12:00:00',1.63),('15128','2013-02-19','12:05:00',1.34),('15128','2013-02-19','12:10:00',1.37),('15128','2013-02-19','12:15:00',1.45),('15128','2013-02-19','12:20:00',3.28),('15128','2013-02-19','12:25:00',4.73),('15128','2013-02-19','12:30:00',4.4),('15128','2013-02-19','12:35:00',1.84),('15128','2013-02-19','12:40:00',1.16),('15128','2013-02-19','12:45:00',2.73),('15128','2013-02-19','12:50:00',3.68),('15128','2013-02-19','12:55:00',1.78),('15128','2013-02-19','13:00:00',1.44),('15128','2013-02-19','13:05:00',2.91),('15128','2013-02-19','13:10:00',4.26),('15128','2013-02-19','13:15:00',1.42),('15128','2013-02-19','13:20:00',1.1),('15128','2013-02-19','13:25:00',2.49),('15128','2013-02-19','13:30:00',1.49),('15128','2013-02-19','13:35:00',1.61),('15128','2013-02-19','13:40:00',4.39),('15128','2013-02-19','13:45:00',1.73),('15128','2013-02-19','13:50:00',1.67),('15128','2013-02-19','13:55:00',1.28),('15128','2013-02-19','14:00:00',2.24),('15128','2013-02-19','14:05:00',3.21),('15128','2013-02-19','14:10:00',1.19),('15128','2013-02-19','14:15:00',1.27),('15128','2013-02-19','14:20:00',2.6),('15128','2013-02-19','14:25:00',2.76),('15128','2013-02-19','14:30:00',1.34),('15128','2013-02-19','14:35:00',1.79),('15128','2013-02-19','14:40:00',2.27),('15128','2013-02-19','14:45:00',1.39),('15128','2013-02-19','14:50:00',1.54),('15128','2013-02-19','14:55:00',1.73),('15128','2013-02-19','15:00:00',2.21),('15128','2013-02-19','15:05:00',2.52),('15128','2013-02-19','15:10:00',2.17),('15128','2013-02-19','15:15:00',2.48),('15128','2013-02-19','15:20:00',2.01),('15128','2013-02-19','15:25:00',1.94),('15128','2013-02-19','15:30:00',2.16),('15128','2013-02-19','15:35:00',1.87),('15128','2013-02-19','15:40:00',1.11),('15128','2013-02-19','15:50:00',1.23),('15128','2013-02-19','15:55:00',1.28),('15128','2013-02-19','16:00:00',1.1),('15128','2013-02-19','16:05:00',1.47),('15128','2013-02-19','16:10:00',1.22),('15128','2013-02-19','16:15:00',1.25),('15128','2013-02-19','16:25:00',1.11),('15128','2013-02-19','16:30:00',1.54),('15128','2013-02-19','16:35:00',1.19),('15128','2013-02-18','09:00:00',1),('15128','2013-02-18','09:05:00',1.09),('15128','2013-02-18','09:10:00',1.18),('15128','2013-02-18','09:15:00',1.28),('15128','2013-02-18','09:20:00',1.36),('15128','2013-02-18','09:25:00',1.43),('15128','2013-02-18','09:30:00',1.51),('15128','2013-02-18','09:35:00',1.54),('15128','2013-02-18','09:40:00',1.64),('15128','2013-02-18','09:45:00',1.7),('15128','2013-02-18','09:50:00',1.77),('15128','2013-02-18','09:55:00',1.79),('15128','2013-02-18','10:00:00',1.85),('15128','2013-02-18','10:05:00',1.92),('15128','2013-02-18','10:10:00',1.96),('15128','2013-02-18','10:15:00',2.06),('15128','2013-02-18','10:20:00',2.09),('15128','2013-02-18','10:25:00',2.15),('15128','2013-02-18','10:30:00',2.19),('15128','2013-02-18','10:35:00',2.28),('15128','2013-02-18','10:40:00',2.34),('15128','2013-02-18','10:45:00',2.33),('15128','2013-02-18','10:50:00',2.43),('15128','2013-02-18','10:55:00',2.45),('15128','2013-02-18','11:00:00',2.51),('15128','2013-02-18','11:05:00',2.59),('15128','2013-02-18','11:10:00',2.58),('15128','2013-02-18','11:15:00',2.68),('15128','2013-02-18','11:20:00',2.76),('15128','2013-02-18','11:25:00',2.94),('15128','2013-02-18','11:30:00',3.02),('15128','2013-02-18','11:35:00',3.09),('15128','2013-02-18','11:40:00',3.15),('15128','2013-02-18','11:45:00',3.19),('15128','2013-02-18','11:50:00',3.18),('15128','2013-02-18','11:55:00',3.22),('15128','2013-02-18','12:00:00',3.25),('15128','2013-02-18','12:05:00',3.3),('15128','2013-02-18','12:10:00',3.32),('15128','2013-02-18','12:15:00',3.34),('15128','2013-02-18','12:20:00',3.38),('15128','2013-02-18','12:25:00',3.39),('15128','2013-02-18','12:30:00',3.42),('15128','2013-02-18','12:35:00',3.45),('15128','2013-02-18','12:40:00',3.46),('15128','2013-02-18','12:45:00',3.45),('15128','2013-02-18','12:50:00',3.49),('15128','2013-02-18','12:55:00',3.45),('15128','2013-02-18','13:00:00',3.44),('15128','2013-02-18','13:05:00',3.46),('15128','2013-02-18','13:10:00',3.46),('15128','2013-02-18','13:15:00',3.49),('15128','2013-02-18','13:20:00',3.47),('15128','2013-02-18','13:25:00',3.47),('15128','2013-02-18','13:30:00',3.47),('15128','2013-02-18','13:35:00',3.44),('15128','2013-02-18','13:40:00',3.44),('15128','2013-02-18','13:45:00',3.38),('15128','2013-02-18','13:50:00',3.38),('15128','2013-02-18','13:55:00',3.35),('15128','2013-02-18','14:00:00',3.31),('15128','2013-02-18','14:05:00',3.29),('15128','2013-02-18','14:10:00',3.26),('15128','2013-02-18','14:15:00',3.18),('15128','2013-02-18','14:20:00',3.11),('15128','2013-02-18','14:25:00',3.04),('15128','2013-02-18','14:30:00',3.03),('15128','2013-02-18','14:35:00',2.97),('15128','2013-02-18','14:40:00',2.96),('15128','2013-02-18','14:45:00',2.89),('15128','2013-02-18','14:50:00',2.75),('15128','2013-02-18','14:55:00',2.72),('15128','2013-02-18','15:00:00',2.7),('15128','2013-02-18','15:05:00',2.67),('15128','2013-02-18','15:10:00',2.59),('15128','2013-02-18','15:15:00',2.54),('15128','2013-02-18','15:20:00',2.52),('15128','2013-02-18','15:25:00',2.42),('15128','2013-02-18','15:30:00',2.38),('15128','2013-02-18','15:35:00',2.32),('15128','2013-02-18','15:40:00',2.2),('15128','2013-02-18','15:45:00',2.14),('15128','2013-02-18','15:50:00',2.06),('15128','2013-02-18','15:55:00',1.96),('15128','2013-02-18','16:00:00',1.92),('15128','2013-02-18','16:05:00',1.84),('15128','2013-02-18','16:10:00',1.73),('15128','2013-02-18','16:15:00',1.65),('15128','2013-02-18','16:20:00',1.56),('15128','2013-02-18','16:25:00',1.45),('15128','2013-02-18','16:30:00',1.3),('15128','2013-02-18','16:35:00',1.2),('15128','2013-02-18','16:40:00',1.06),('15128','2013-02-17','09:05:00',1.06),('15128','2013-02-17','09:10:00',1.14),('15128','2013-02-17','09:15:00',1.24),('15128','2013-02-17','09:20:00',1.37),('15128','2013-02-17','09:25:00',1.53),('15128','2013-02-17','09:40:00',1.84),('15128','2013-02-17','09:45:00',1.43),('15128','2013-02-17','09:50:00',1.01),('15128','2013-02-17','10:05:00',2.06),('15128','2013-02-17','10:10:00',2.1),('15128','2013-02-17','10:15:00',2.09),('15128','2013-02-17','10:20:00',2.12),('15128','2013-02-17','10:25:00',2.08),('15128','2013-02-17','10:30:00',2.06),('15128','2013-02-17','10:35:00',2.07),('15128','2013-02-17','10:40:00',2.27),('15128','2013-02-17','10:45:00',1.6),('15128','2013-02-17','10:50:00',1.78),('15128','2013-02-17','10:55:00',2.19),('15128','2013-02-17','11:00:00',1.24),('15128','2013-02-17','11:05:00',1.54),('15128','2013-02-17','11:10:00',1.48),('15128','2013-02-17','11:15:00',1.7),('15128','2013-02-17','11:20:00',1.53),('15128','2013-02-17','11:25:00',1.58),('15128','2013-02-17','11:30:00',1.78),('15128','2013-02-17','11:35:00',1.77),('15128','2013-02-17','11:40:00',1.95),('15128','2013-02-17','11:45:00',2.1),('15128','2013-02-17','11:50:00',2.47),('15128','2013-02-17','11:55:00',2.3),('15128','2013-02-17','12:00:00',1.72),('15128','2013-02-17','12:05:00',1.55),('15128','2013-02-17','12:10:00',1.51),('15128','2013-02-17','12:15:00',1.41),('15128','2013-02-17','12:20:00',1.42),('15128','2013-02-17','12:25:00',1.75),('15128','2013-02-17','12:30:00',1.55),('15128','2013-02-17','12:35:00',1.45),('15128','2013-02-17','12:40:00',1.51),('15128','2013-02-17','12:45:00',1.57),('15128','2013-02-17','12:50:00',1.7),('15128','2013-02-17','12:55:00',2.21),('15128','2013-02-17','13:00:00',2.96),('15128','2013-02-17','13:05:00',2.79),('15128','2013-02-17','13:10:00',2.29),('15128','2013-02-17','13:15:00',3.02),('15128','2013-02-17','13:20:00',1.92),('15128','2013-02-17','13:25:00',1.46),('15128','2013-02-17','13:30:00',1.18),('15128','2013-02-17','13:40:00',1.25),('15128','2013-02-17','13:45:00',1.23),('15128','2013-02-17','13:50:00',1.33),('15128','2013-02-17','13:55:00',1.73),('15128','2013-02-17','14:00:00',1.83),('15128','2013-02-17','14:05:00',2.11),('15128','2013-02-17','14:10:00',2),('15128','2013-02-17','14:15:00',2.7),('15128','2013-02-17','14:20:00',2.13),('15128','2013-02-17','14:25:00',1.24),('15128','2013-02-17','14:35:00',1.11),('15128','2013-02-17','14:40:00',1.54),('15128','2013-02-17','14:45:00',1.01),('15128','2013-02-17','14:50:00',1.13),('15128','2013-02-17','14:55:00',1.6),('15128','2013-02-17','15:00:00',1.51),('15128','2013-02-17','15:05:00',1.21),('15128','2013-02-16','09:05:00',1),('15128','2013-02-16','09:10:00',1.04),('15128','2013-02-16','09:15:00',1.22),('15128','2013-02-16','09:20:00',1.28),('15128','2013-02-16','09:25:00',1.36),('15128','2013-02-16','09:30:00',1.38),('15128','2013-02-16','09:35:00',1.5),('15128','2013-02-16','09:40:00',1.56),('15128','2013-02-16','09:45:00',1.59),('15128','2013-02-16','09:50:00',1.67),('15128','2013-02-16','09:55:00',1.71),('15128','2013-02-16','10:00:00',1.74),('15128','2013-02-16','10:05:00',1.78),('15128','2013-02-16','10:10:00',1.84),('15128','2013-02-16','10:15:00',1.87),('15128','2013-02-16','10:20:00',2.01),('15128','2013-02-16','10:25:00',2.06),('15128','2013-02-16','10:30:00',2.13),('15128','2013-02-16','10:35:00',2.18),('15128','2013-02-16','10:40:00',2.24),('15128','2013-02-16','10:45:00',2.3),('15128','2013-02-16','10:50:00',2.33),('15128','2013-02-16','10:55:00',2.38),('15128','2013-02-16','11:00:00',2.45),('15128','2013-02-16','11:05:00',2.48),('15128','2013-02-16','11:10:00',2.54),('15128','2013-02-16','11:15:00',2.63),('15128','2013-02-16','11:20:00',2.65),('15128','2013-02-16','11:25:00',2.82),('15128','2013-02-16','11:30:00',2.9),('15128','2013-02-16','11:35:00',2.97),('15128','2013-02-16','11:40:00',3.02),('15128','2013-02-16','11:45:00',3.04),('15128','2013-02-16','11:50:00',3.08),('15128','2013-02-16','11:55:00',3.15),('15128','2013-02-16','12:00:00',3.19),('15128','2013-02-16','12:05:00',3.23),('15128','2013-02-16','12:10:00',3.17),('15128','2013-02-16','12:15:00',3.22),('15128','2013-02-16','12:20:00',3.24),('15128','2013-02-16','12:25:00',3.21),('15128','2013-02-16','12:30:00',3.22),('15128','2013-02-16','12:35:00',3.19),('15128','2013-02-16','12:40:00',3.19),('15128','2013-02-16','12:45:00',3.24),('15128','2013-02-16','12:50:00',3.27),('15128','2013-02-16','12:55:00',3.27),('15128','2013-02-16','13:00:00',3.27),('15128','2013-02-16','13:05:00',3.21),('15128','2013-02-16','13:10:00',1.34),('15128','2013-02-16','13:15:00',3.04),('15128','2013-02-16','13:20:00',3.25),('15128','2013-02-16','13:25:00',3.24),('15128','2013-02-16','13:30:00',3.22),('15128','2013-02-16','13:35:00',3.24),('15128','2013-02-16','13:40:00',3.24),('15128','2013-02-16','13:45:00',3.28),('15128','2013-02-16','13:50:00',3.21),('15128','2013-02-16','13:55:00',3.21),('15128','2013-02-16','14:00:00',3.09),('15128','2013-02-16','14:05:00',2.85),('15128','2013-02-16','14:10:00',1.86),('15128','2013-02-16','14:15:00',3.07),('15128','2013-02-16','14:20:00',1.54),('15128','2013-02-16','14:25:00',2.98),('15128','2013-02-16','14:30:00',2.84),('15128','2013-02-16','14:35:00',2.9),('15128','2013-02-16','14:40:00',2.91),('15128','2013-02-16','14:45:00',2.84),('15128','2013-02-16','14:50:00',2.81),('15128','2013-02-16','14:55:00',2.7),('15128','2013-02-16','15:00:00',2.66),('15128','2013-02-16','15:05:00',2.61),('15128','2013-02-16','15:10:00',2.53),('15128','2013-02-16','15:15:00',2.5),('15128','2013-02-16','15:20:00',2.43),('15128','2013-02-16','15:25:00',2.28),('15128','2013-02-16','15:30:00',2.1),('15128','2013-02-16','15:35:00',2.14),('15128','2013-02-16','15:40:00',2.07),('15128','2013-02-16','15:45:00',1.97),('15128','2013-02-16','15:50:00',1.67),('15128','2013-02-16','15:55:00',1.69),('15128','2013-02-16','16:00:00',1.33),('15128','2013-02-16','16:15:00',1.17),('15128','2013-02-16','16:20:00',1.3),('15128','2013-02-16','16:25:00',1.25),('15128','2013-02-16','16:30:00',1.04),('15128','2013-02-15','09:10:00',1.18),('15128','2013-02-15','09:15:00',1.36),('15128','2013-02-15','09:20:00',1.55),('15128','2013-02-15','09:25:00',1.64),('15128','2013-02-15','09:30:00',1.64),('15128','2013-02-15','09:35:00',1.72),('15128','2013-02-15','09:40:00',1.71),('15128','2013-02-15','09:45:00',1.66),('15128','2013-02-15','09:50:00',1.68),('15128','2013-02-15','09:55:00',1.67),('15128','2013-02-15','10:00:00',1.73),('15128','2013-02-15','10:05:00',1.8),('15128','2013-02-15','10:10:00',1.85),('15128','2013-02-15','10:15:00',1.88),('15128','2013-02-15','10:20:00',1.97),('15128','2013-02-15','10:25:00',2.04),('15128','2013-02-15','10:30:00',2.12),('15128','2013-02-15','10:35:00',2.15),('15128','2013-02-15','10:40:00',2.23),('15128','2013-02-15','10:45:00',2.28),('15128','2013-02-15','10:50:00',2.41),('15128','2013-02-15','10:55:00',2.46),('15128','2013-02-15','11:00:00',2.45),('15128','2013-02-15','11:05:00',2.43),('15128','2013-02-15','11:10:00',2.47),('15128','2013-02-15','11:15:00',2.54),('15128','2013-02-15','11:20:00',2.62),('15128','2013-02-15','11:25:00',2.72),('15128','2013-02-15','11:30:00',2.88),('15128','2013-02-15','11:35:00',2.95),('15128','2013-02-15','11:40:00',2.96),('15128','2013-02-15','11:45:00',3.02),('15128','2013-02-15','11:50:00',3.06),('15128','2013-02-15','11:55:00',3.1),('15128','2013-02-15','12:00:00',3.1),('15128','2013-02-15','12:05:00',3.12),('15128','2013-02-15','12:10:00',3.18),('15128','2013-02-15','12:15:00',3.2),('15128','2013-02-15','12:20:00',3.24),('15128','2013-02-15','12:25:00',3.28),('15128','2013-02-15','12:30:00',3.31),('15128','2013-02-15','12:35:00',3.3),('15128','2013-02-15','12:40:00',3.33),('15128','2013-02-15','12:45:00',3.35),('15128','2013-02-15','12:50:00',3.35),('15128','2013-02-15','12:55:00',3.35),('15128','2013-02-15','13:00:00',3.31),('15128','2013-02-15','13:05:00',3.06),('15128','2013-02-15','13:10:00',3.4),('15128','2013-02-15','13:15:00',3.28),('15128','2013-02-15','13:20:00',3.27),('15128','2013-02-15','13:25:00',2.94),('15128','2013-02-15','13:30:00',3.14),('15128','2013-02-15','13:35:00',3.24),('15128','2013-02-15','13:40:00',3.17),('15128','2013-02-15','13:45:00',3.23),('15128','2013-02-15','13:50:00',3.24),('15128','2013-02-15','13:55:00',3.14),('15128','2013-02-15','14:00:00',2.21),('15128','2013-02-15','14:05:00',3.18),('15128','2013-02-15','14:10:00',3.13),('15128','2013-02-15','14:15:00',3.05),('15128','2013-02-15','14:20:00',3.03),('15128','2013-02-15','14:25:00',3.02),('15128','2013-02-15','14:30:00',3.08),('15128','2013-02-15','14:35:00',3.06),('15128','2013-02-15','14:40:00',2.94),('15128','2013-02-15','14:45:00',2.82),('15128','2013-02-15','14:50:00',2.84),('15128','2013-02-15','14:55:00',1.41),('15128','2013-02-15','15:00:00',2.55),('15128','2013-02-15','15:05:00',2.87),('15128','2013-02-15','15:10:00',2),('15128','2013-02-15','15:15:00',3.1),('15128','2013-02-15','15:20:00',3.18),('15128','2013-02-15','15:25:00',2.36),('15128','2013-02-15','15:30:00',1.4),('15128','2013-02-15','15:35:00',1.09),('15128','2013-02-15','15:40:00',1.09),('15128','2013-02-15','15:45:00',1.16),('15128','2013-02-14','09:25:00',1.29),('15128','2013-02-14','09:40:00',1.45),('15128','2013-02-14','09:45:00',1.3),('15128','2013-02-14','09:50:00',1.59),('15128','2013-02-14','09:55:00',1.67),('15128','2013-02-14','10:00:00',1.61),('15128','2013-02-14','10:05:00',2.05),('15128','2013-02-14','10:10:00',1.62),('15128','2013-02-14','10:15:00',1.65),('15128','2013-02-14','10:20:00',1.52),('15128','2013-02-14','10:25:00',1.85),('15128','2013-02-14','10:30:00',2.24),('15128','2013-02-14','10:35:00',2.37),('15128','2013-02-14','10:40:00',2.6),('15128','2013-02-14','10:45:00',2.19),('15128','2013-02-14','10:50:00',1.55),('15128','2013-02-14','10:55:00',1.66),('15128','2013-02-14','11:00:00',1.94),('15128','2013-02-14','11:05:00',1.68),('15128','2013-02-14','11:10:00',2.36),('15128','2013-02-14','11:15:00',2.71),('15128','2013-02-14','11:20:00',2.75),('15128','2013-02-14','11:25:00',2.91),('15128','2013-02-14','11:30:00',2.98),('15128','2013-02-14','11:35:00',3.14),('15128','2013-02-14','11:40:00',3.36),('15128','2013-02-14','11:45:00',2.79),('15128','2013-02-14','11:50:00',2.12),('15128','2013-02-14','11:55:00',2.92),('15128','2013-02-14','12:00:00',1.91),('15128','2013-02-14','12:05:00',1.56),('15128','2013-02-14','12:10:00',2.89),('15128','2013-02-14','12:15:00',3.66),('15128','2013-02-14','12:20:00',3.23),('15128','2013-02-14','12:25:00',3.4),('15128','2013-02-14','12:30:00',3.34),('15128','2013-02-14','12:35:00',3.3),('15128','2013-02-14','12:40:00',3.29),('15128','2013-02-14','12:45:00',3.27),('15128','2013-02-14','12:50:00',3.32),('15128','2013-02-14','12:55:00',3.39),('15128','2013-02-14','13:00:00',3.5),('15128','2013-02-14','13:05:00',3.61),('15128','2013-02-14','13:10:00',3.04),('15128','2013-02-14','13:15:00',2.13),('15128','2013-02-14','13:20:00',1.6),('15128','2013-02-14','13:25:00',1.26),('15128','2013-02-14','13:30:00',2.08),('15128','2013-02-14','13:35:00',2.05),('15128','2013-02-14','13:40:00',1.85),('15128','2013-02-14','13:45:00',2.72),('15128','2013-02-14','13:50:00',3.34),('15128','2013-02-14','13:55:00',3.36),('15128','2013-02-14','14:00:00',3.13),('15128','2013-02-14','14:05:00',3.43),('15128','2013-02-14','14:10:00',2.46),('15128','2013-02-14','14:15:00',3.17),('15128','2013-02-14','14:20:00',2.44),('15128','2013-02-14','14:25:00',2.3),('15128','2013-02-14','14:30:00',2.62),('15128','2013-02-14','14:35:00',2.9),('15128','2013-02-14','14:40:00',3.04),('15128','2013-02-14','14:45:00',2.57),('15128','2013-02-14','14:50:00',2.13),('15128','2013-02-14','14:55:00',1.78),('15128','2013-02-14','15:00:00',1.62),('15128','2013-02-14','15:05:00',2.69),('15128','2013-02-14','15:10:00',2.09),('15128','2013-02-14','15:15:00',2.5),('15128','2013-02-14','15:20:00',2.38),('15128','2013-02-14','15:25:00',1.49),('15128','2013-02-14','15:30:00',1.14),('15128','2013-02-14','15:35:00',1.33),('15128','2013-02-14','15:40:00',1.46),('15128','2013-02-14','15:45:00',1.05),('15128','2013-02-14','15:50:00',1.04),('15128','2013-02-13','09:10:00',1.07),('15128','2013-02-13','09:15:00',1.16),('15128','2013-02-13','09:20:00',1.27),('15128','2013-02-13','09:25:00',1.34),('15128','2013-02-13','09:30:00',1.38),('15128','2013-02-13','09:35:00',1.47),('15128','2013-02-13','09:40:00',1.53),('15128','2013-02-13','09:45:00',1.6),('15128','2013-02-13','09:50:00',1.67),('15128','2013-02-13','09:55:00',1.75),('15128','2013-02-13','10:00:00',1.8),('15128','2013-02-13','10:05:00',1.83),('15128','2013-02-13','10:10:00',1.88),('15128','2013-02-13','10:15:00',1.92),('15128','2013-02-13','10:20:00',2),('15128','2013-02-13','10:25:00',2.1),('15128','2013-02-13','10:30:00',2.12),('15128','2013-02-13','10:35:00',2.21),('15128','2013-02-13','10:40:00',2.23),('15128','2013-02-13','10:45:00',2.28),('15128','2013-02-13','10:50:00',2.36),('15128','2013-02-13','10:55:00',2.42),('15128','2013-02-13','11:00:00',2.49),('15128','2013-02-13','11:05:00',2.54),('15128','2013-02-13','11:10:00',2.6),('15128','2013-02-13','11:15:00',2.69),('15128','2013-02-13','11:20:00',2.69),('15128','2013-02-13','11:25:00',2.91),('15128','2013-02-13','11:30:00',2.98),('15128','2013-02-13','11:35:00',3.02),('15128','2013-02-13','11:40:00',3.07),('15128','2013-02-13','11:45:00',3.12),('15128','2013-02-13','11:50:00',3.16),('15128','2013-02-13','11:55:00',3.2),('15128','2013-02-13','12:00:00',3.24),('15128','2013-02-13','12:05:00',3.3),('15128','2013-02-13','12:10:00',3.35),('15128','2013-02-13','12:15:00',3.35),('15128','2013-02-13','12:20:00',3.37),('15128','2013-02-13','12:25:00',3.39),('15128','2013-02-13','12:30:00',3.38),('15128','2013-02-13','12:35:00',3.4),('15128','2013-02-13','12:40:00',3.43),('15128','2013-02-13','12:45:00',3.44),('15128','2013-02-13','12:50:00',3.46),('15128','2013-02-13','12:55:00',3.46),('15128','2013-02-13','13:00:00',3.46),('15128','2013-02-13','13:05:00',3.46),('15128','2013-02-13','13:10:00',3.46),('15128','2013-02-13','13:15:00',3.44),('15128','2013-02-13','13:20:00',3.43),('15128','2013-02-13','13:25:00',3.41),('15128','2013-02-13','13:30:00',3.37),('15128','2013-02-13','13:35:00',3.37),('15128','2013-02-13','13:40:00',3.34),('15128','2013-02-13','13:45:00',3.28),('15128','2013-02-13','13:50:00',3.29),('15128','2013-02-13','13:55:00',3.25),('15128','2013-02-13','14:00:00',3.23),('15128','2013-02-13','14:05:00',3.19),('15128','2013-02-13','14:10:00',3.16),('15128','2013-02-13','14:15:00',3.13),('15128','2013-02-13','14:20:00',3.1),('15128','2013-02-13','14:25:00',3.08),('15128','2013-02-13','14:30:00',3.02),('15128','2013-02-13','14:35:00',2.98),('15128','2013-02-13','14:40:00',2.91),('15128','2013-02-13','14:45:00',2.88),('15128','2013-02-13','14:50:00',2.83),('15128','2013-02-13','14:55:00',2.76),('15128','2013-02-13','15:00:00',2.69),('15128','2013-02-13','15:05:00',2.62),('15128','2013-02-13','15:10:00',2.57),('15128','2013-02-13','15:15:00',2.5),('15128','2013-02-13','15:20:00',2.44),('15128','2013-02-13','15:25:00',2.39),('15128','2013-02-13','15:30:00',2.3),('15128','2013-02-13','15:35:00',2.19),('15128','2013-02-13','15:40:00',2.1),('15128','2013-02-13','15:45:00',2.03),('15128','2013-02-13','15:50:00',1.95),('15128','2013-02-13','15:55:00',1.88),('15128','2013-02-13','16:00:00',1.74),('15128','2013-02-13','16:05:00',1.63),('15128','2013-02-13','16:10:00',1.56),('15128','2013-02-13','16:15:00',1.46),('15128','2013-02-13','16:20:00',1.33),('15128','2013-02-13','16:25:00',1.23),('15128','2013-02-13','16:30:00',1.12),('15128','2013-02-12','09:20:00',1.13),('15128','2013-02-12','09:25:00',1.3),('15128','2013-02-12','09:30:00',1.33),('15128','2013-02-12','09:35:00',1.48),('15128','2013-02-12','09:40:00',1.56),('15128','2013-02-12','09:45:00',1.63),('15128','2013-02-12','09:50:00',1.65),('15128','2013-02-12','09:55:00',1.7),('15128','2013-02-12','10:00:00',1.79),('15128','2013-02-12','10:05:00',1.84),('15128','2013-02-12','10:10:00',1.98),('15128','2013-02-12','10:15:00',2.04),('15128','2013-02-12','10:20:00',2.1),('15128','2013-02-12','10:25:00',2.08),('15128','2013-02-12','10:30:00',2.13),('15128','2013-02-12','10:35:00',2.16),('15128','2013-02-12','10:40:00',2.29),('15128','2013-02-12','10:45:00',2.36),('15128','2013-02-12','10:50:00',2.49),('15128','2013-02-12','10:55:00',2.59),('15128','2013-02-12','11:00:00',2.56),('15128','2013-02-12','11:05:00',2.64),('15128','2013-02-12','11:10:00',2.6),('15128','2013-02-12','11:15:00',2.61),('15128','2013-02-12','11:20:00',2.48),('15128','2013-02-12','11:25:00',1.9),('15128','2013-02-12','11:30:00',1.63),('15128','2013-02-12','11:35:00',2.87),('15128','2013-02-12','11:40:00',3.34),('15128','2013-02-12','11:45:00',1.67),('15128','2013-02-12','11:50:00',1.99),('15128','2013-02-12','11:55:00',3.34),('15128','2013-02-12','12:00:00',3.16),('15128','2013-02-12','12:05:00',1.35),('15128','2013-02-12','12:10:00',1.87),('15128','2013-02-12','12:15:00',3.79),('15128','2013-02-12','12:20:00',2.77),('15128','2013-02-12','12:25:00',2.06),('15128','2013-02-12','12:30:00',2.77),('15128','2013-02-12','12:35:00',2.62),('15128','2013-02-12','12:40:00',1.43),('15128','2013-02-12','12:45:00',1.34),('15128','2013-02-12','12:50:00',1.29),('15128','2013-02-12','12:55:00',1.91),('15128','2013-02-12','13:00:00',1.12),('15128','2013-02-12','13:05:00',1.07),('15128','2013-02-12','13:15:00',1.14),('15128','2013-02-12','13:20:00',1.27),('15128','2013-02-12','13:25:00',1.87),('15128','2013-02-12','13:30:00',2.5),('15128','2013-02-12','13:35:00',1.44),('15128','2013-02-12','13:40:00',3.29),('15128','2013-02-12','13:45:00',2.55),('15128','2013-02-12','13:50:00',3.81),('15128','2013-02-12','13:55:00',3.53),('15128','2013-02-12','14:00:00',3.55),('15128','2013-02-12','14:05:00',3.41),('15128','2013-02-12','14:10:00',3.22),('15128','2013-02-12','14:15:00',3),('15128','2013-02-12','14:20:00',2.62),('15128','2013-02-12','14:25:00',2.72),('15128','2013-02-12','14:30:00',2.5),('15128','2013-02-12','14:35:00',2.55),('15128','2013-02-12','14:40:00',2.52),('15128','2013-02-12','14:45:00',2.64),('15128','2013-02-12','14:50:00',2.81),('15128','2013-02-12','14:55:00',2.82),('15128','2013-02-12','15:00:00',2.61),('15128','2013-02-12','15:05:00',2.64),('15128','2013-02-12','15:10:00',2.62),('15128','2013-02-12','15:15:00',2.54),('15128','2013-02-12','15:20:00',2.48),('15128','2013-02-12','15:25:00',2.42),('15128','2013-02-12','15:30:00',2.3),('15128','2013-02-12','15:35:00',2.21),('15128','2013-02-12','15:40:00',2.15),('15128','2013-02-12','15:45:00',2.09),('15128','2013-02-12','15:50:00',2.05),('15128','2013-02-12','15:55:00',1.95),('15128','2013-02-12','16:00:00',1.84),('15128','2013-02-12','16:05:00',1.75),('15128','2013-02-12','16:10:00',1.64),('15128','2013-02-12','16:15:00',1.53),('15128','2013-02-12','16:20:00',1.43),('15128','2013-02-12','16:25:00',1.31),('15128','2013-02-12','16:30:00',1.16),('15128','2013-02-12','16:35:00',1.03),('15128','2013-02-10','10:10:00',1.01),('15128','2013-02-10','10:15:00',1.19),('15128','2013-02-10','10:20:00',1.14),('15128','2013-02-10','11:20:00',1.03),('15128','2013-02-10','14:10:00',1.15),('15128','2013-02-10','14:15:00',1.01),('15128','2013-02-10','14:35:00',1.06),('15128','2013-02-10','14:40:00',1.45),('15128','2013-02-10','14:45:00',1.29),('15128','2013-02-10','14:50:00',1.16),('15128','2013-02-10','15:05:00',1.07),('15128','2014-03-21','08:30:00',1.15),('15128','2014-03-21','08:40:00',1.04),('15128','2014-03-21','08:45:00',1.15),('15128','2014-03-21','08:50:00',1.04),('15128','2014-03-21','08:55:00',1.26),('15128','2014-03-21','09:00:00',1.13),('15128','2014-03-21','09:05:00',1.17),('15128','2014-03-21','09:10:00',1.23),('15128','2014-03-21','09:15:00',1.16),('15128','2014-03-21','09:20:00',1.2),('15128','2014-03-21','09:25:00',1.44),('15128','2014-03-21','09:30:00',1.28),('15128','2014-03-21','09:35:00',1.54),('15128','2014-03-21','09:40:00',2.27),('15128','2014-03-21','09:45:00',1.61),('15128','2014-03-21','09:50:00',1.97),('15128','2014-03-21','09:55:00',2.68),('15128','2014-03-21','10:00:00',2.62),('15128','2014-03-21','10:05:00',2.81),('15128','2014-03-21','10:10:00',1.88),('15128','2014-03-21','10:15:00',1.53),('15128','2014-03-21','10:20:00',1.28),('15128','2014-03-21','10:25:00',1.02),('15128','2014-03-21','10:35:00',1.15),('15128','2014-03-21','10:40:00',1.61),('15128','2014-03-21','10:45:00',1.77),('15128','2014-03-21','10:50:00',1.82),('15128','2014-03-21','10:55:00',2.2),('15128','2014-03-21','11:00:00',1.44),('15128','2014-03-21','11:05:00',1.29),('15128','2014-03-21','11:10:00',2.07),('15128','2014-03-21','11:15:00',2.66),('15128','2014-03-21','11:20:00',2.54),('15128','2014-03-21','11:25:00',2.87),('15128','2014-03-21','11:30:00',4.15),('15128','2014-03-21','11:35:00',2.76),('15128','2014-03-21','11:40:00',2.38),('15128','2014-03-21','11:45:00',2.13),('15128','2014-03-21','11:50:00',2.23),('15128','2014-03-21','11:55:00',1.47),('15128','2014-03-21','12:00:00',2.49),('15128','2014-03-21','12:05:00',4.3),('15128','2014-03-21','12:10:00',2.69),('15128','2014-03-21','12:15:00',1.67),('15128','2014-03-21','12:20:00',2.26),('15128','2014-03-21','12:25:00',3.22),('15128','2014-03-21','12:30:00',2.61),('15128','2014-03-21','12:35:00',3.39),('15128','2014-03-21','12:40:00',3.03),('15128','2014-03-21','12:45:00',3.16),('15128','2014-03-21','12:50:00',1.43),('15128','2014-03-21','12:55:00',1.89),('15128','2014-03-21','13:00:00',1.73),('15128','2014-03-21','13:05:00',1.76),('15128','2014-03-21','13:10:00',4.45),('15128','2014-03-21','13:15:00',4.02),('15128','2014-03-21','13:20:00',3.85),('15128','2014-03-21','13:25:00',3.63),('15128','2014-03-21','13:30:00',3.75),('15128','2014-03-21','13:35:00',3.69),('15128','2014-03-21','13:40:00',3.48),('15128','2014-03-21','13:45:00',3.77),('15128','2014-03-21','13:50:00',3.63),('15128','2014-03-21','13:55:00',3.59),('15128','2014-03-21','14:00:00',3.48),('15128','2014-03-21','14:05:00',3.48),('15128','2014-03-21','14:10:00',3.35),('15128','2014-03-21','14:15:00',3.32),('15128','2014-03-21','14:20:00',3.27),('15128','2014-03-21','14:25:00',3.14),('15128','2014-03-21','14:30:00',3.35),('15128','2014-03-21','14:35:00',3.3),('15128','2014-03-21','14:40:00',3.18),('15128','2014-03-21','14:45:00',3.16),('15128','2014-03-21','14:50:00',3.14),('15128','2014-03-21','14:55:00',3.11),('15128','2014-03-21','15:00:00',3.06),('15128','2014-03-21','15:05:00',2.99),('15128','2014-03-21','15:10:00',2.88),('15128','2014-03-21','15:15:00',2.84),('15128','2014-03-21','15:20:00',2.86),('15128','2014-03-21','15:25:00',2.13),('15128','2014-03-21','15:30:00',2.33),('15128','2014-03-21','15:35:00',2.5),('15128','2014-03-21','15:40:00',2.71),('15128','2014-03-21','15:45:00',2.22),('15128','2014-03-21','15:50:00',2.44),('15128','2014-03-21','15:55:00',2.18),('15128','2014-03-21','16:00:00',1.75),('15128','2014-03-21','16:05:00',2.1),('15128','2014-03-21','16:10:00',1.83),('15128','2014-03-21','16:15:00',1.39),('15128','2014-03-21','16:20:00',1.73),('15128','2014-03-21','16:40:00',1.08),('15128','2013-02-09','09:25:00',1.32),('15128','2013-02-09','09:30:00',1.37),('15128','2013-02-09','09:40:00',1.02),('15128','2013-02-09','09:45:00',1.5),('15128','2013-02-09','09:50:00',1.61),('15128','2013-02-09','09:55:00',1.67),('15128','2013-02-09','10:00:00',1.71),('15128','2013-02-09','10:05:00',1.76),('15128','2013-02-09','10:10:00',1.82),('15128','2013-02-09','10:15:00',1.88),('15128','2013-02-09','10:20:00',1.95),('15128','2013-02-09','10:25:00',1.99),('15128','2013-02-09','10:30:00',2.03),('15128','2013-02-09','10:35:00',2.1),('15128','2013-02-09','10:40:00',2.17),('15128','2013-02-09','10:45:00',2.19),('15128','2013-02-09','10:50:00',2.25),('15128','2013-02-09','10:55:00',2.28),('15128','2013-02-09','11:00:00',2.32),('15128','2013-02-09','11:05:00',2.35),('15128','2013-02-09','11:10:00',2.46),('15128','2013-02-09','11:15:00',2.49),('15128','2013-02-09','11:20:00',2.55),('15128','2013-02-09','11:25:00',2.73),('15128','2013-02-09','11:30:00',2.86),('15128','2013-02-09','11:35:00',2.91),('15128','2013-02-09','11:40:00',2.94),('15128','2013-02-09','11:45:00',2.96),('15128','2013-02-09','11:50:00',3.01),('15128','2013-02-09','11:55:00',2.98),('15128','2013-02-09','12:00:00',3.13),('15128','2013-02-09','12:05:00',3.19),('15128','2013-02-09','12:10:00',3.22),('15128','2013-02-09','12:15:00',3.23),('15128','2013-02-09','12:20:00',3.28),('15128','2013-02-09','12:25:00',3.22),('15128','2013-02-09','12:30:00',3.15),('15128','2013-02-09','12:35:00',3.18),('15128','2013-02-09','12:40:00',3.25),('15128','2013-02-09','12:45:00',3.26),('15128','2013-02-09','12:50:00',3.31),('15128','2013-02-09','12:55:00',3.31),('15128','2013-02-09','13:00:00',3.36),('15128','2013-02-09','13:05:00',3.35),('15128','2013-02-09','13:10:00',3.34),('15128','2013-02-09','13:15:00',3.34),('15128','2013-02-09','13:20:00',3.34),('15128','2013-02-09','13:25:00',3.31),('15128','2013-02-09','13:30:00',3.31),('15128','2013-02-09','13:35:00',3.25),('15128','2013-02-09','13:40:00',3.22),('15128','2013-02-09','13:45:00',3.2),('15128','2013-02-09','13:50:00',3.18),('15128','2013-02-09','13:55:00',3.15),('15128','2013-02-09','14:00:00',3.12),('15128','2013-02-09','14:05:00',3.09),('15128','2013-02-09','14:10:00',3.09),('15128','2013-02-09','14:15:00',3.06),('15128','2013-02-09','14:20:00',3.03),('15128','2013-02-09','14:25:00',2.98),('15128','2013-02-09','14:30:00',2.9),('15128','2013-02-09','14:35:00',2.83),('15128','2013-02-09','14:40:00',2.8),('15128','2013-02-09','14:45:00',2.73),('15128','2013-02-09','14:50:00',2.64),('15128','2013-02-09','14:55:00',2.54),('15128','2013-02-09','15:00:00',2.55),('15128','2013-02-09','15:05:00',2.59),('15128','2013-02-09','15:10:00',2.63),('15128','2013-02-09','15:15:00',1.59),('15128','2013-02-09','16:15:00',1.32),('15128','2013-02-09','16:20:00',1.35),('15128','2013-02-09','16:25:00',1.26),('15128','2013-02-09','16:30:00',1.14),('15128','2013-02-08','10:45:00',1.04),('15128','2013-02-08','10:50:00',1.18),('15128','2013-02-08','10:55:00',1.26),('15128','2013-02-08','11:00:00',1.3),('15128','2013-02-08','11:05:00',1.35),('15128','2013-02-08','11:10:00',1.41),('15128','2013-02-08','11:15:00',1.45),('15128','2013-02-08','11:20:00',1.45),('15128','2013-02-08','11:25:00',1.38),('15128','2013-02-08','11:30:00',1.37),('15128','2013-02-08','11:35:00',1.39),('15128','2013-02-08','11:40:00',1.41),('15128','2013-02-08','11:45:00',1.4),('15128','2013-02-08','11:50:00',1.36),('15128','2013-02-08','11:55:00',1.35),('15128','2013-02-08','12:00:00',1.39),('15128','2013-02-08','12:05:00',1.46),('15128','2013-02-08','12:10:00',1.36),('15128','2013-02-08','12:15:00',1.29),('15128','2013-02-08','12:20:00',1.29),('15128','2013-02-08','12:25:00',1.3),('15128','2013-02-08','12:30:00',1.34),('15128','2013-02-08','12:35:00',1.35),('15128','2013-02-08','12:40:00',1.32),('15128','2013-02-08','12:45:00',1.34),('15128','2013-02-08','12:50:00',1.51),('15128','2013-02-08','12:55:00',1.72),('15128','2013-02-08','13:00:00',1.86),('15128','2013-02-08','13:05:00',2.19),('15128','2013-02-08','13:10:00',2.25),('15128','2013-02-08','13:15:00',2.32),('15128','2013-02-08','13:20:00',2.63),('15128','2013-02-08','13:25:00',2.85),('15128','2013-02-08','13:30:00',3.05),('15128','2013-02-08','13:35:00',3.54),('15128','2013-02-08','13:40:00',3.48),('15128','2013-02-08','13:45:00',3.41),('15128','2013-02-08','13:50:00',3.43),('15128','2013-02-08','13:55:00',3.33),('15128','2013-02-08','14:00:00',3.28),('15128','2013-02-08','14:05:00',1.83),('15128','2013-02-08','14:10:00',1.62),('15128','2013-02-08','14:15:00',3.71),('15128','2013-02-08','14:20:00',3.55),('15128','2013-02-08','14:25:00',3.21),('15128','2013-02-08','14:30:00',2.9),('15128','2013-02-08','14:35:00',2.32),('15128','2013-02-08','14:40:00',2.35),('15128','2013-02-08','14:45:00',2.76),('15128','2013-02-08','14:50:00',2.65),('15128','2013-02-08','14:55:00',2.59),('15128','2013-02-08','15:00:00',2.51),('15128','2013-02-08','15:05:00',2.16),('15128','2013-02-08','15:10:00',2.28),('15128','2013-02-08','15:15:00',2.3),('15128','2013-02-08','15:20:00',2.22),('15128','2013-02-08','15:25:00',2.22),('15128','2013-02-08','15:30:00',1.89),('15128','2013-02-08','15:35:00',2.04),('15128','2013-02-08','15:40:00',2.11),('15128','2013-02-08','15:45:00',2),('15128','2013-02-08','15:50:00',1.82),('15128','2013-02-08','15:55:00',1.74),('15128','2013-02-08','16:05:00',1.68),('15128','2013-02-08','16:10:00',1.61),('15128','2013-02-08','16:20:00',1.2),('15128','2013-02-08','16:25:00',1.28),('15128','2013-02-08','16:30:00',1.14),('15128','2013-02-07','09:45:00',1.58),('15128','2013-02-07','09:50:00',1.39),('15128','2013-02-07','09:55:00',1.67),('15128','2013-02-07','10:00:00',1.27),('15128','2013-02-07','10:05:00',1.42),('15128','2013-02-07','10:10:00',1.82),('15128','2013-02-07','10:15:00',1.42),('15128','2013-02-07','10:20:00',1.92),('15128','2013-02-07','10:25:00',2.13),('15128','2013-02-07','10:30:00',2.16),('15128','2013-02-07','10:35:00',2.43),('15128','2013-02-07','10:40:00',2.29),('15128','2013-02-07','10:45:00',1.76),('15128','2013-02-07','10:50:00',1.24),('15128','2013-02-07','10:55:00',1.96),('15128','2013-02-07','11:00:00',2.64),('15128','2013-02-07','11:05:00',2.47),('15128','2013-02-07','11:10:00',2.44),('15128','2013-02-07','11:15:00',2.5),('15128','2013-02-07','11:20:00',2.61),('15128','2013-02-07','11:25:00',2.69),('15128','2013-02-07','11:30:00',2.74),('15128','2013-02-07','11:35:00',2.86),('15128','2013-02-07','11:40:00',2.88),('15128','2013-02-07','11:45:00',2.94),('15128','2013-02-07','11:50:00',2.98),('15128','2013-02-07','11:55:00',3.04),('15128','2013-02-07','12:00:00',3.1),('15128','2013-02-07','12:05:00',3.14),('15128','2013-02-07','12:10:00',3.18),('15128','2013-02-07','12:15:00',3.24),('15128','2013-02-07','12:20:00',2.96),('15128','2013-02-07','12:25:00',2.95),('15128','2013-02-07','12:30:00',2.45),('15128','2013-02-07','12:35:00',2.32),('15128','2013-02-07','12:40:00',1.92),('15128','2013-02-07','12:45:00',2.04),('15128','2013-02-07','12:50:00',2),('15128','2013-02-07','12:55:00',2.05),('15128','2013-02-07','13:00:00',1.63),('15128','2013-02-07','13:05:00',1.64),('15128','2013-02-07','13:10:00',1.76),('15128','2013-02-07','13:15:00',1.89),('15128','2013-02-07','13:20:00',1.79),('15128','2013-02-07','13:25:00',1.86),('15128','2013-02-07','13:30:00',1.73),('15128','2013-02-07','13:35:00',2.11),('15128','2013-02-07','13:40:00',1.4),('15128','2013-02-07','13:45:00',1.45),('15128','2013-02-07','13:50:00',1.43),('15128','2013-02-07','13:55:00',1.44),('15128','2013-02-07','14:00:00',1.54),('15128','2013-02-07','14:05:00',1.68),('15128','2013-02-07','14:10:00',1.73),('15128','2013-02-07','14:15:00',1.71),('15128','2013-02-07','14:20:00',2.01),('15128','2013-02-07','14:25:00',2.23),('15128','2013-02-07','14:30:00',2.17),('15128','2013-02-07','14:35:00',2.12),('15128','2013-02-07','14:40:00',2.34),('15128','2013-02-07','14:45:00',2.54),('15128','2013-02-07','14:50:00',1.97),('15128','2013-02-07','14:55:00',2.83),('15128','2013-02-07','15:00:00',2.58),('15128','2013-02-07','15:05:00',2.84),('15128','2013-02-07','15:10:00',2.63),('15128','2013-02-07','15:15:00',2.2),('15128','2013-02-07','15:20:00',2.57),('15128','2013-02-07','15:25:00',2.46),('15128','2013-02-07','15:30:00',2.43),('15128','2013-02-07','15:35:00',2.36),('15128','2013-02-07','15:40:00',2.32),('15128','2013-02-07','15:45:00',1.63),('15128','2013-02-07','15:50:00',1.32),('15128','2013-02-07','16:00:00',1.22),('15128','2013-02-07','16:05:00',1.09),('15128','2013-02-06','10:25:00',1.03),('15128','2013-02-06','10:30:00',1.17),('15128','2013-02-06','10:35:00',1.07),('15128','2013-02-06','10:40:00',1.77),('15128','2013-02-06','10:45:00',1.83),('15128','2013-02-06','10:50:00',1.54),('15128','2013-02-06','10:55:00',1.83),('15128','2013-02-06','11:00:00',2.19),('15128','2013-02-06','11:05:00',1.35),('15128','2013-02-06','11:10:00',2.47),('15128','2013-02-06','11:15:00',1.97),('15128','2013-02-06','12:20:00',2.05),('15128','2013-02-06','12:25:00',2.41),('15128','2013-02-06','12:30:00',1.45),('15128','2013-02-06','12:35:00',1.42),('15128','2013-02-06','12:40:00',1.12),('15128','2013-02-06','12:45:00',1.06),('15128','2013-02-06','12:50:00',1.05),('15128','2013-02-06','13:05:00',1.04),('15128','2013-02-06','13:10:00',2.25),('15128','2013-02-06','13:15:00',3.91),('15128','2013-02-06','13:20:00',3.52),('15128','2013-02-06','13:25:00',2.26),('15128','2013-02-06','13:30:00',1.24),('15128','2013-02-06','13:45:00',1),('15128','2013-02-06','13:50:00',1.04),('15128','2013-02-06','13:55:00',1.23),('15128','2013-02-06','14:00:00',2.05),('15128','2013-02-06','14:05:00',2.67),('15128','2013-02-06','14:10:00',3.57),('15128','2013-02-06','14:15:00',2.19),('15128','2013-02-06','14:20:00',2.47),('15128','2013-02-06','14:25:00',1.24),('15128','2013-02-06','14:45:00',1.37),('15128','2013-02-06','14:50:00',1.27),('15128','2013-02-06','14:55:00',1.06),('15128','2013-02-06','15:00:00',1.86),('15128','2013-02-06','15:05:00',3.21),('15128','2013-02-06','15:10:00',2.91),('15128','2013-02-06','15:15:00',2.84),('15128','2013-02-06','15:20:00',2.11),('15128','2013-02-06','15:30:00',1.55),('15128','2013-02-06','15:35:00',2.35),('15128','2013-02-06','15:40:00',1.9),('15128','2013-02-05','09:25:00',1.02),('15128','2013-02-05','09:30:00',1.05),('15128','2013-02-05','09:35:00',1.17),('15128','2013-02-05','09:40:00',1.14),('15128','2013-02-05','09:45:00',1.2),('15128','2013-02-05','09:50:00',1.52),('15128','2013-02-05','09:55:00',1.31),('15128','2013-02-05','10:00:00',1.42),('15128','2013-02-05','10:05:00',1.6),('15128','2013-02-05','10:10:00',1.29),('15128','2013-02-05','10:15:00',1.41),('15128','2013-02-05','10:20:00',2.61),('15128','2013-02-05','10:25:00',2),('15128','2013-02-05','10:30:00',1.25),('15128','2013-02-05','10:35:00',1.2),('15128','2013-02-05','10:40:00',1.02),('15128','2013-02-05','10:45:00',1.12),('15128','2013-02-05','10:50:00',1.39),('15128','2013-02-05','10:55:00',1.49),('15128','2013-02-05','11:00:00',1.44),('15128','2013-02-05','11:05:00',1.68),('15128','2013-02-05','11:10:00',1.57),('15128','2013-02-05','11:15:00',1.8),('15128','2013-02-05','11:20:00',2.11),('15128','2013-02-05','11:25:00',1.54),('15128','2013-02-05','11:30:00',1.64),('15128','2013-02-05','11:35:00',1.68),('15128','2013-02-05','11:40:00',1.75),('15128','2013-02-05','11:45:00',1.63),('15128','2013-02-05','11:50:00',1.55),('15128','2013-02-05','11:55:00',1.34),('15128','2013-02-05','12:00:00',1.2),('15128','2013-02-05','12:05:00',1.22),('15128','2013-02-05','12:10:00',1.39),('15128','2013-02-05','12:15:00',1.3),('15128','2013-02-05','12:20:00',1.15),('15128','2013-02-05','12:25:00',1.07),('15128','2013-02-05','12:30:00',1.03),('15128','2013-02-05','12:35:00',1.09),('15128','2013-02-05','12:40:00',1.1),('15128','2013-02-05','13:10:00',1.14),('15128','2013-02-05','13:15:00',1.25),('15128','2013-02-05','13:20:00',1.73),('15128','2013-02-05','13:25:00',2.34),('15128','2013-02-05','13:30:00',1.94),('15128','2013-02-05','13:35:00',2.22),('15128','2013-02-05','13:40:00',1.61),('15128','2013-02-05','13:45:00',2.05),('15128','2013-02-05','13:50:00',2.3),('15128','2013-02-05','13:55:00',1.37),('15128','2013-02-05','14:00:00',1),('15128','2013-02-05','14:35:00',1.18),('15128','2013-02-05','15:20:00',2.6),('15128','2013-02-05','15:25:00',1.47),('15128','2013-02-04','09:25:00',1.05),('15128','2013-02-04','09:30:00',1.07),('15128','2013-02-04','09:35:00',1.15),('15128','2013-02-04','09:40:00',1.21),('15128','2013-02-04','09:45:00',1.34),('15128','2013-02-04','09:50:00',1.43),('15128','2013-02-04','09:55:00',1.5),('15128','2013-02-04','10:00:00',1.55),('15128','2013-02-04','10:05:00',1.46),('15128','2013-02-04','10:10:00',1.58),('15128','2013-02-04','10:15:00',1.74),('15128','2013-02-04','10:20:00',1.78),('15128','2013-02-04','10:25:00',1.81),('15128','2013-02-04','10:30:00',1.86),('15128','2013-02-04','10:35:00',1.9),('15128','2013-02-04','10:40:00',1.97),('15128','2013-02-04','10:45:00',2.06),('15128','2013-02-04','10:50:00',2.08),('15128','2013-02-04','10:55:00',2.13),('15128','2013-02-04','11:00:00',2.16),('15128','2013-02-04','11:05:00',2.24),('15128','2013-02-04','11:10:00',2.25),('15128','2013-02-04','11:15:00',2.35),('15128','2013-02-04','11:20:00',2.45),('15128','2013-02-04','11:25:00',2.48),('15128','2013-02-04','11:30:00',2.07),('15128','2013-02-04','11:35:00',1.66),('15128','2013-02-04','11:40:00',2.23),('15128','2013-02-04','11:45:00',1.82),('15128','2013-02-04','11:50:00',2.05),('15128','2013-02-04','11:55:00',3.07),('15128','2013-02-04','12:00:00',3.08),('15128','2013-02-04','12:05:00',1.56),('15128','2013-02-04','12:10:00',2.1),('15128','2013-02-04','12:15:00',1.55),('15128','2013-02-04','12:20:00',1.78),('15128','2013-02-04','12:25:00',2.48),('15128','2013-02-04','12:30:00',2.21),('15128','2013-02-04','12:35:00',2.57),('15128','2013-02-04','12:40:00',1.72),('15128','2013-02-04','12:45:00',1.79),('15128','2013-02-04','12:50:00',1.46),('15128','2013-02-04','12:55:00',1.01),('15128','2013-02-04','13:00:00',1.41),('15128','2013-02-04','13:05:00',1.99),('15128','2013-02-04','13:10:00',2.64),('15128','2013-02-04','13:15:00',2.29),('15128','2013-02-04','13:20:00',1.62),('15128','2013-02-04','13:25:00',1.36),('15128','2013-02-04','13:30:00',1.5),('15128','2013-02-04','13:35:00',1.53),('15128','2013-02-04','13:40:00',1.52),('15128','2013-02-04','13:45:00',1.56),('15128','2013-02-04','13:50:00',1.75),('15128','2013-02-04','13:55:00',1.44),('15128','2013-02-04','14:00:00',1.54),('15128','2013-02-04','14:05:00',1.41),('15128','2013-02-04','14:10:00',1.45),('15128','2013-02-04','14:15:00',1.51),('15128','2013-02-04','14:20:00',1.87),('15128','2013-02-04','14:25:00',1.81),('15128','2013-02-04','14:30:00',1.53),('15128','2013-02-04','14:35:00',1.44),('15128','2013-02-04','14:40:00',1.24),('15128','2013-02-04','14:45:00',1.4),('15128','2013-02-04','14:50:00',1.18),('15128','2013-02-03','09:25:00',1.17),('15128','2013-02-03','09:30:00',1.17),('15128','2013-02-03','09:35:00',1.28),('15128','2013-02-03','09:40:00',1.34),('15128','2013-02-03','09:45:00',1.42),('15128','2013-02-03','09:50:00',1.6),('15128','2013-02-03','09:55:00',1.75),('15128','2013-02-03','10:00:00',1.78),('15128','2013-02-03','10:05:00',1.86),('15128','2013-02-03','10:10:00',1.87),('15128','2013-02-03','10:15:00',1.64),('15128','2013-02-03','10:20:00',1.74),('15128','2013-02-03','10:25:00',1.9),('15128','2013-02-03','10:30:00',1.82),('15128','2013-02-03','10:35:00',1.96),('15128','2013-02-03','10:40:00',2.08),('15128','2013-02-03','10:45:00',2.13),('15128','2013-02-03','10:50:00',2.14),('15128','2013-02-03','10:55:00',2.18),('15128','2013-02-03','11:00:00',2.26),('15128','2013-02-03','11:05:00',2.31),('15128','2013-02-03','11:10:00',2.34),('15128','2013-02-03','11:15:00',2.43),('15128','2013-02-03','11:20:00',2.56),('15128','2013-02-03','11:25:00',2.66),('15128','2013-02-03','11:30:00',2.72),('15128','2013-02-03','11:35:00',2.79),('15128','2013-02-03','11:40:00',2.85),('15128','2013-02-03','11:45:00',2.87),('15128','2013-02-03','11:50:00',2.9),('15128','2013-02-03','11:55:00',2.96),('15128','2013-02-03','12:00:00',3.03),('15128','2013-02-03','12:05:00',3.05),('15128','2013-02-03','12:10:00',3.06),('15128','2013-02-03','12:15:00',3.08),('15128','2013-02-03','12:20:00',3.08),('15128','2013-02-03','12:25:00',3.06),('15128','2013-02-03','12:30:00',3.16),('15128','2013-02-03','12:35:00',3.16),('15128','2013-02-03','12:40:00',3.15),('15128','2013-02-03','12:45:00',3.16),('15128','2013-02-03','12:50:00',3.16),('15128','2013-02-03','12:55:00',3.17),('15128','2013-02-03','13:00:00',3.19),('15128','2013-02-03','13:05:00',3.19),('15128','2013-02-03','13:10:00',3.19),('15128','2013-02-03','13:15:00',3.19),('15128','2013-02-03','13:20:00',3.17),('15128','2013-02-03','13:25:00',3.15),('15128','2013-02-03','13:30:00',3.17),('15128','2013-02-03','13:35:00',3.13),('15128','2013-02-03','13:40:00',3.1),('15128','2013-02-03','13:45:00',3.1),('15128','2013-02-03','13:50:00',3.09),('15128','2013-02-03','13:55:00',3.07),('15128','2013-02-03','14:00:00',3.03),('15128','2013-02-03','14:05:00',3.01),('15128','2013-02-03','14:10:00',2.98),('15128','2013-02-03','14:15:00',2.94),('15128','2013-02-03','14:20:00',2.91),('15128','2013-02-03','14:25:00',2.88),('15128','2013-02-03','14:30:00',2.83),('15128','2013-02-03','14:35:00',2.79),('15128','2013-02-03','14:40:00',2.74),('15128','2013-02-03','14:45:00',2.69),('15128','2013-02-03','14:50:00',2.64),('15128','2013-02-03','14:55:00',2.59),('15128','2013-02-03','15:00:00',2.53),('15128','2013-02-03','15:05:00',2.47),('15128','2013-02-03','15:10:00',2.4),('15128','2013-02-03','15:15:00',2.33),('15128','2013-02-03','15:20:00',2.27),('15128','2013-02-03','15:25:00',2.2),('15128','2013-02-03','15:30:00',2.13),('15128','2013-02-03','15:35:00',2.05),('15128','2013-02-03','15:40:00',1.93),('15128','2013-02-03','15:45:00',1.81),('15128','2013-02-03','15:50:00',1.75),('15128','2013-02-03','15:55:00',1.67),('15128','2013-02-03','16:00:00',1.59),('15128','2013-02-03','16:05:00',1.49),('15128','2013-02-03','16:10:00',1.36),('15128','2013-02-03','16:15:00',1.22),('15128','2013-02-03','16:20:00',1.07),('15128','2013-02-02','09:30:00',1.15),('15128','2013-02-02','09:35:00',1.32),('15128','2013-02-02','09:40:00',1.66),('15128','2013-02-02','09:45:00',2.37),('15128','2013-02-02','09:50:00',2.26),('15128','2013-02-02','11:00:00',1.14),('15128','2013-02-02','11:20:00',1.09),('15128','2013-02-02','11:25:00',2.64),('15128','2013-02-02','11:30:00',2.76),('15128','2013-02-02','11:35:00',1.08),('15128','2013-02-02','12:15:00',1.94),('15128','2013-02-02','12:20:00',1.5),('15128','2013-02-01','10:15:00',1.06),('15128','2013-02-01','10:20:00',1.23),('15128','2013-02-01','10:30:00',1.11),('15128','2013-02-01','10:35:00',1.35),('15128','2013-02-01','10:40:00',1.71),('15128','2013-02-01','10:45:00',1.9),('15128','2013-02-01','10:50:00',1.89),('15128','2013-02-01','10:55:00',1.74),('15128','2013-02-01','11:00:00',1.83),('15128','2013-02-01','11:05:00',1.7),('15128','2013-02-01','11:10:00',2.01),('15128','2013-02-01','11:15:00',1.79),('15128','2013-02-01','11:20:00',2.1),('15128','2013-02-01','11:25:00',2.2),('15128','2013-02-01','11:30:00',1.82),('15128','2013-02-01','11:35:00',1.68),('15128','2013-02-01','11:40:00',1.62),('15128','2013-02-01','11:45:00',1.14),('15128','2013-02-01','11:50:00',1.29),('15128','2013-02-01','12:40:00',1.37),('15128','2013-02-01','12:45:00',1.51),('15128','2013-02-01','12:50:00',2.3),('15128','2013-02-01','12:55:00',2.12),('15128','2013-02-01','13:00:00',2.11),('15128','2013-02-01','13:05:00',1.66),('15128','2013-02-01','13:10:00',2.56),('15128','2013-02-01','13:15:00',2.45),('15128','2013-02-01','13:20:00',2.06),('15128','2013-02-01','13:25:00',1.62),('15128','2013-02-01','13:30:00',2.09),('15128','2013-02-01','13:35:00',2.32),('15128','2013-02-01','13:40:00',1.75),('15128','2013-02-01','13:45:00',1.6),('15128','2013-02-01','13:50:00',1.25),('15128','2013-01-31','09:20:00',1.12),('15128','2013-01-31','09:25:00',1.18),('15128','2013-01-31','09:45:00',1.33),('15128','2013-01-31','09:50:00',1.1),('15128','2013-01-31','09:55:00',1.23),('15128','2013-01-31','10:10:00',1.63),('15128','2013-01-31','10:15:00',1.34),('15128','2013-01-31','10:30:00',1.53),('15128','2013-01-31','10:35:00',1.62),('15128','2013-01-31','10:45:00',1.02),('15128','2013-01-31','10:50:00',2.04),('15128','2013-01-31','10:55:00',1.13),('15128','2013-01-31','11:25:00',2.52),('15128','2013-01-31','11:30:00',1.57),('15128','2013-01-31','11:35:00',1.8),('15128','2013-01-31','11:40:00',1.48),('15128','2013-01-31','11:50:00',1.15),('15128','2013-01-31','11:55:00',1.18),('15128','2013-01-31','12:00:00',1.17),('15128','2013-01-31','12:05:00',1.77),('15128','2013-01-31','12:10:00',1.47),('15128','2013-01-31','12:15:00',1.33),('15128','2013-01-31','12:20:00',2.24),('15128','2013-01-31','12:25:00',1.46),('15128','2013-01-31','12:30:00',1.32),('15128','2013-01-31','12:35:00',3.7),('15128','2013-01-31','12:40:00',2.38),('15128','2013-01-31','12:45:00',3.42),('15128','2013-01-31','12:50:00',1.19),('15128','2013-01-31','12:55:00',1.54),('15128','2013-01-31','13:00:00',1.64),('15128','2013-01-31','13:05:00',3.52),('15128','2013-01-31','13:10:00',3.16),('15128','2013-01-31','13:15:00',2.06),('15128','2013-01-31','13:20:00',1.01),('15128','2013-01-31','13:25:00',1.01),('15128','2013-01-31','13:30:00',2.43),('15128','2013-01-31','13:35:00',1.52),('15128','2013-01-31','13:40:00',2.74),('15128','2013-01-31','13:45:00',2.29),('15128','2013-01-31','13:50:00',2.63),('15128','2013-01-31','13:55:00',2.66),('15128','2013-01-31','14:00:00',2.28),('15128','2013-01-31','14:05:00',2.6),('15128','2013-01-31','14:10:00',2.75),('15128','2013-01-31','14:15:00',2.79),('15128','2013-01-31','14:20:00',2.61),('15128','2013-01-31','14:25:00',2.14),('15128','2013-01-31','14:30:00',1.11),('15128','2013-01-31','14:40:00',2.9),('15128','2013-01-31','14:45:00',1.35),('15128','2013-01-31','14:50:00',1.02),('15128','2013-01-31','14:55:00',1.28),('15128','2013-01-31','15:00:00',1.72),('15128','2013-01-31','15:20:00',1.24),('15128','2013-01-31','15:25:00',2.27),('15128','2013-01-31','15:30:00',1.36),('15128','2014-03-20','08:25:00',1.07),('15128','2014-03-20','08:30:00',1.16),('15128','2014-03-20','08:35:00',1.22),('15128','2014-03-20','08:40:00',1.28),('15128','2014-03-20','08:45:00',1.34),('15128','2014-03-20','08:50:00',1.38),('15128','2014-03-20','08:55:00',1.45),('15128','2014-03-20','09:00:00',1.52),('15128','2014-03-20','09:05:00',1.58),('15128','2014-03-20','09:10:00',1.67),('15128','2014-03-20','09:15:00',1.71),('15128','2014-03-20','09:20:00',1.75),('15128','2014-03-20','09:25:00',1.78),('15128','2014-03-20','09:30:00',1.84),('15128','2014-03-20','09:35:00',1.91),('15128','2014-03-20','09:40:00',1.99),('15128','2014-03-20','09:45:00',2.03),('15128','2014-03-20','09:50:00',2.06),('15128','2014-03-20','09:55:00',2.08),('15128','2014-03-20','10:00:00',2.19),('15128','2014-03-20','10:05:00',2.23),('15128','2014-03-20','10:10:00',2.28),('15128','2014-03-20','10:15:00',2.32),('15128','2014-03-20','10:20:00',2.42),('15128','2014-03-20','10:25:00',2.47),('15128','2014-03-20','10:30:00',2.52),('15128','2014-03-20','10:35:00',2.54),('15128','2014-03-20','10:40:00',2.52),('15128','2014-03-20','10:45:00',2.58),('15128','2014-03-20','10:50:00',2.66),('15128','2014-03-20','10:55:00',2.75),('15128','2014-03-20','11:00:00',2.72),('15128','2014-03-20','11:05:00',2.91),('15128','2014-03-20','11:10:00',3.04),('15128','2014-03-20','11:15:00',3),('15128','2014-03-20','11:20:00',3.12),('15128','2014-03-20','11:25:00',3.16),('15128','2014-03-20','11:30:00',3.23),('15128','2014-03-20','11:35:00',3.17),('15128','2014-03-20','11:40:00',3.22),('15128','2014-03-20','11:45:00',3.19),('15128','2014-03-20','11:50:00',3.26),('15128','2014-03-20','11:55:00',3.35),('15128','2014-03-20','12:00:00',3.37),('15128','2014-03-20','12:05:00',3.29),('15128','2014-03-20','12:10:00',3.51),('15128','2014-03-20','12:15:00',3.54),('15128','2014-03-20','12:20:00',3.57),('15128','2014-03-20','12:25:00',3.57),('15128','2014-03-20','12:30:00',3.52),('15128','2014-03-20','12:35:00',3.57),('15128','2014-03-20','12:40:00',3.63),('15128','2014-03-20','12:45:00',3.66),('15128','2014-03-20','12:50:00',3.64),('15128','2014-03-20','12:55:00',3.62),('15128','2014-03-20','13:00:00',3.6),('15128','2014-03-20','13:05:00',3.62),('15128','2014-03-20','13:10:00',3.62),('15128','2014-03-20','13:15:00',3.63),('15128','2014-03-20','13:20:00',3.61),('15128','2014-03-20','13:25:00',3.59),('15128','2014-03-20','13:30:00',3.62),('15128','2014-03-20','13:35:00',3.58),('15128','2014-03-20','13:40:00',3.6),('15128','2014-03-20','13:45:00',3.58),('15128','2014-03-20','13:50:00',3.57),('15128','2014-03-20','13:55:00',3.59),('15128','2014-03-20','14:00:00',3.57),('15128','2014-03-20','14:05:00',3.53),('15128','2014-03-20','14:10:00',3.49),('15128','2014-03-20','14:15:00',3.46),('15128','2014-03-20','14:20:00',3.41),('15128','2014-03-20','14:25:00',3.39),('15128','2014-03-20','14:30:00',3.34),('15128','2014-03-20','14:35:00',3.27),('15128','2014-03-20','14:40:00',3.05),('15128','2014-03-20','14:45:00',2.72),('15128','2014-03-20','14:50:00',1.61),('15128','2014-03-20','14:55:00',1.21),('15128','2014-03-20','15:00:00',1.54),('15128','2014-03-20','15:05:00',2.34),('15128','2014-03-20','15:10:00',3.39),('15128','2014-03-20','15:15:00',3.41),('15128','2014-03-20','15:20:00',3.07),('15128','2014-03-20','15:25:00',1.5),('15128','2014-03-20','15:30:00',3.15),('15128','2014-03-20','15:35:00',3.01),('15128','2014-03-20','15:40:00',2.97),('15128','2014-03-20','15:45:00',2.34),('15128','2014-03-20','15:50:00',2.88),('15128','2014-03-20','15:55:00',2.79),('15128','2014-03-20','16:00:00',2.61),('15128','2014-03-20','16:05:00',2.47),('15128','2014-03-20','16:10:00',2.28),('15128','2014-03-20','16:15:00',2.08),('15128','2014-03-20','16:20:00',1.91),('15128','2014-03-20','16:25:00',1.85),('15128','2014-03-20','16:30:00',1.71),('15128','2014-03-20','16:35:00',1.61),('15128','2014-03-20','16:40:00',1.57),('15128','2014-03-20','16:45:00',1.46),('15128','2014-03-20','16:50:00',1.42),('15128','2014-03-20','16:55:00',1.3),('15128','2014-03-20','17:00:00',1.06),('15128','2013-01-30','09:35:00',1),('15128','2013-01-30','09:40:00',1.08),('15128','2013-01-30','09:45:00',1.19),('15128','2013-01-30','09:50:00',1.19),('15128','2013-01-30','09:55:00',1.22),('15128','2013-01-30','10:00:00',1.36),('15128','2013-01-30','10:05:00',1.38),('15128','2013-01-30','10:10:00',1.47),('15128','2013-01-30','10:15:00',1.56),('15128','2013-01-30','10:20:00',1.61),('15128','2013-01-30','10:25:00',1.62),('15128','2013-01-30','10:30:00',1.72),('15128','2013-01-30','10:35:00',1.8),('15128','2013-01-30','10:40:00',1.82),('15128','2013-01-30','10:45:00',1.93),('15128','2013-01-30','10:50:00',1.99),('15128','2013-01-30','10:55:00',2.06),('15128','2013-01-30','11:00:00',2.24),('15128','2013-01-30','11:05:00',2.26),('15128','2013-01-30','11:10:00',2.33),('15128','2013-01-30','11:15:00',2.04),('15128','2013-01-30','11:30:00',2.63),('15128','2013-01-30','11:35:00',2.69),('15128','2013-01-30','11:40:00',2.65),('15128','2013-01-30','11:45:00',2.64),('15128','2013-01-30','11:50:00',2.7),('15128','2013-01-30','11:55:00',2.76),('15128','2013-01-30','12:00:00',2.78),('15128','2013-01-30','12:05:00',2.74),('15128','2013-01-30','12:10:00',2.81),('15128','2013-01-30','12:15:00',2.85),('15128','2013-01-30','12:20:00',2.83),('15128','2013-01-30','12:25:00',2.92),('15128','2013-01-30','12:30:00',2.92),('15128','2013-01-30','12:35:00',2.93),('15128','2013-01-30','12:40:00',2.9),('15128','2013-01-30','12:45:00',2.89),('15128','2013-01-30','12:50:00',2.82),('15128','2013-01-30','12:55:00',2.85),('15128','2013-01-30','13:00:00',2.85),('15128','2013-01-30','13:05:00',2.84),('15128','2013-01-30','13:10:00',2.83),('15128','2013-01-30','13:15:00',2.83),('15128','2013-01-30','13:20:00',2.79),('15128','2013-01-30','13:25:00',2.79),('15128','2013-01-30','13:30:00',2.76),('15128','2013-01-30','13:35:00',2.75),('15128','2013-01-30','13:40:00',2.77),('15128','2013-01-30','13:45:00',2.73),('15128','2013-01-30','13:50:00',2.72),('15128','2013-01-30','13:55:00',2.71),('15128','2013-01-30','14:00:00',2.67),('15128','2013-01-30','14:05:00',2.62),('15128','2013-01-30','14:10:00',2.55),('15128','2013-01-30','14:15:00',2.5),('15128','2013-01-30','14:20:00',2.35),('15128','2013-01-30','14:25:00',2.37),('15128','2013-01-30','14:30:00',2.31),('15128','2013-01-30','14:35:00',2.26),('15128','2013-01-30','14:40:00',2.28),('15128','2013-01-30','14:45:00',2.43),('15128','2013-01-30','14:50:00',2.17),('15128','2013-01-30','14:55:00',2.05),('15128','2013-01-30','15:00:00',2.1),('15128','2013-01-30','15:05:00',2.04),('15128','2013-01-30','15:10:00',2.01),('15128','2013-01-30','15:15:00',1.98),('15128','2013-01-30','15:20:00',1.88),('15128','2013-01-30','15:25:00',1.76),('15128','2013-01-30','15:30:00',1.73),('15128','2013-01-30','15:35:00',1.73),('15128','2013-01-30','15:40:00',1.65),('15128','2013-01-30','15:45:00',1.45),('15128','2013-01-30','15:50:00',1.48),('15128','2013-01-30','15:55:00',1.3),('15128','2013-01-30','16:00:00',1.06),('15128','2013-01-30','16:10:00',1.04),('15128','2013-01-29','09:35:00',1.12),('15128','2013-01-29','09:40:00',1.52),('15128','2013-01-29','09:45:00',1.3),('15128','2013-01-29','09:55:00',1.17),('15128','2013-01-29','10:00:00',1.23),('15128','2013-01-29','10:05:00',1.19),('15128','2013-01-29','10:10:00',1.36),('15128','2013-01-29','10:15:00',1.3),('15128','2013-01-29','10:20:00',1.12),('15128','2013-01-29','10:25:00',1.37),('15128','2013-01-29','10:30:00',1.56),('15128','2013-01-29','10:35:00',1.58),('15128','2013-01-29','10:40:00',1.37),('15128','2013-01-29','10:45:00',1.44),('15128','2013-01-29','10:50:00',1.73),('15128','2013-01-29','10:55:00',1.95),('15128','2013-01-29','11:00:00',1.92),('15128','2013-01-29','11:05:00',1.7),('15128','2013-01-29','11:10:00',2.1),('15128','2013-01-29','11:15:00',2.12),('15128','2013-01-29','11:20:00',2.2),('15128','2013-01-29','11:25:00',2.19),('15128','2013-01-29','11:30:00',1.81),('15128','2013-01-29','11:35:00',2.02),('15128','2013-01-29','11:40:00',2.35),('15128','2013-01-29','11:45:00',1.59),('15128','2013-01-29','11:50:00',1.24),('15128','2013-01-29','11:55:00',1.37),('15128','2013-01-29','12:00:00',2.23),('15128','2013-01-29','12:05:00',3.33),('15128','2013-01-29','12:10:00',3.19),('15128','2013-01-29','12:15:00',2.99),('15128','2013-01-29','12:20:00',2.89),('15128','2013-01-29','12:25:00',3.02),('15128','2013-01-29','12:30:00',3.13),('15128','2013-01-29','12:35:00',2.38),('15128','2013-01-29','12:40:00',1.87),('15128','2013-01-29','12:45:00',3.45),('15128','2013-01-29','12:50:00',1.76),('15128','2013-01-29','13:00:00',1.71),('15128','2013-01-29','13:05:00',1.88),('15128','2013-01-29','13:10:00',1.35),('15128','2013-01-29','13:20:00',1.59),('15128','2013-01-29','13:25:00',1.27),('15128','2013-01-29','13:30:00',1.56),('15128','2013-01-29','13:40:00',1.32),('15128','2013-01-29','14:00:00',1.58),('15128','2013-01-29','14:05:00',2.66),('15128','2013-01-29','14:10:00',2.23),('15128','2013-01-29','14:15:00',1.73),('15128','2013-01-29','14:20:00',1.93),('15128','2013-01-29','14:25:00',2.39),('15128','2013-01-29','14:30:00',2.14),('15128','2013-01-29','14:35:00',2.42),('15128','2013-01-29','14:40:00',2.31),('15128','2013-01-29','14:45:00',1.8),('15128','2013-01-28','09:40:00',1.07),('15128','2013-01-28','09:45:00',1.11),('15128','2013-01-28','09:50:00',1.22),('15128','2013-01-28','09:55:00',1.31),('15128','2013-01-28','10:00:00',1.33),('15128','2013-01-28','10:05:00',1.4),('15128','2013-01-28','10:10:00',1.47),('15128','2013-01-28','10:15:00',1.51),('15128','2013-01-28','10:20:00',1.59),('15128','2013-01-28','10:25:00',1.64),('15128','2013-01-28','10:30:00',1.72),('15128','2013-01-28','10:35:00',1.79),('15128','2013-01-28','10:40:00',1.82),('15128','2013-01-28','10:45:00',1.85),('15128','2013-01-28','10:50:00',1.88),('15128','2013-01-28','10:55:00',1.94),('15128','2013-01-28','11:00:00',1.99),('15128','2013-01-28','11:05:00',2.05),('15128','2013-01-28','11:10:00',2.08),('15128','2013-01-28','11:15:00',2.12),('15128','2013-01-28','11:20:00',2.2),('15128','2013-01-28','11:25:00',2.29),('15128','2013-01-28','11:30:00',2.38),('15128','2013-01-28','11:35:00',2.48),('15128','2013-01-28','11:40:00',2.53),('15128','2013-01-28','11:45:00',2.57),('15128','2013-01-28','11:50:00',2.62),('15128','2013-01-28','11:55:00',2.66),('15128','2013-01-28','12:00:00',2.73),('15128','2013-01-28','12:05:00',2.79),('15128','2013-01-28','12:10:00',2.82),('15128','2013-01-28','12:15:00',2.78),('15128','2013-01-28','12:20:00',2.81),('15128','2013-01-28','12:25:00',2.89),('15128','2013-01-28','12:30:00',2.92),('15128','2013-01-28','12:35:00',2.92),('15128','2013-01-28','12:40:00',2.89),('15128','2013-01-28','12:45:00',2.84),('15128','2013-01-28','12:50:00',2.88),('15128','2013-01-28','12:55:00',2.91),('15128','2013-01-28','13:00:00',2.86),('15128','2013-01-28','13:05:00',2.88),('15128','2013-01-28','13:10:00',2.87),('15128','2013-01-28','13:15:00',2.89),('15128','2013-01-28','13:20:00',2.87),('15128','2013-01-28','13:25:00',2.86),('15128','2013-01-28','13:30:00',2.85),('15128','2013-01-28','13:35:00',2.82),('15128','2013-01-28','13:40:00',2.77),('15128','2013-01-28','13:45:00',2.76),('15128','2013-01-28','13:50:00',2.72),('15128','2013-01-28','13:55:00',2.74),('15128','2013-01-28','14:00:00',2.74),('15128','2013-01-28','14:05:00',2.73),('15128','2013-01-28','14:10:00',2.67),('15128','2013-01-28','14:15:00',2.62),('15128','2013-01-28','14:20:00',2.56),('15128','2013-01-28','14:25:00',2.52),('15128','2013-01-28','14:30:00',2.49),('15128','2013-01-28','14:35:00',2.46),('15128','2013-01-28','14:40:00',2.4),('15128','2013-01-28','14:45:00',2.34),('15128','2013-01-28','14:50:00',2.3),('15128','2013-01-28','14:55:00',2.24),('15128','2013-01-28','15:00:00',2.16),('15128','2013-01-28','15:05:00',2.09),('15128','2013-01-28','15:10:00',2.04),('15128','2013-01-28','15:15:00',1.96),('15128','2013-01-28','15:20:00',1.88),('15128','2013-01-28','15:25:00',1.89),('15128','2013-01-28','15:30:00',1.82),('15128','2013-01-28','15:35:00',1.78),('15128','2013-01-28','15:40:00',1.7),('15128','2013-01-28','15:45:00',1.61),('15128','2013-01-28','15:50:00',1.51),('15128','2013-01-28','15:55:00',1.42),('15128','2013-01-28','16:00:00',1.32),('15128','2013-01-28','16:05:00',1.19),('15128','2013-01-28','16:10:00',1.09),('15128','2013-01-27','12:40:00',1.18),('15128','2013-01-27','12:45:00',1.29),('15128','2013-01-27','12:50:00',1.31),('15128','2013-01-27','12:55:00',1.27),('15128','2013-01-27','13:00:00',1.35),('15128','2013-01-27','13:05:00',1.35),('15128','2013-01-27','13:10:00',1.13),('15128','2013-01-27','13:35:00',1.02),('15128','2013-01-26','09:35:00',1.01),('15128','2013-01-26','09:40:00',1.04),('15128','2013-01-26','09:45:00',1.11),('15128','2013-01-26','09:50:00',1.16),('15128','2013-01-26','09:55:00',1.25),('15128','2013-01-26','10:00:00',1.33),('15128','2013-01-26','10:05:00',1.43),('15128','2013-01-26','10:10:00',1.48),('15128','2013-01-26','10:15:00',1.52),('15128','2013-01-26','10:20:00',1.55),('15128','2013-01-26','10:25:00',1.66),('15128','2013-01-26','10:30:00',1.71),('15128','2013-01-26','10:35:00',1.75),('15128','2013-01-26','10:40:00',1.8),('15128','2013-01-26','10:45:00',1.85),('15128','2013-01-26','10:50:00',1.89),('15128','2013-01-26','10:55:00',1.97),('15128','2013-01-26','11:00:00',2.02),('15128','2013-01-26','11:05:00',2.04),('15128','2013-01-26','11:10:00',2.07),('15128','2013-01-26','11:15:00',2.14),('15128','2013-01-26','11:20:00',2.23),('15128','2013-01-26','11:25:00',2.29),('15128','2013-01-26','11:30:00',2.42),('15128','2013-01-26','11:35:00',2.47),('15128','2013-01-26','11:40:00',2.47),('15128','2013-01-26','11:45:00',2.53),('15128','2013-01-26','11:50:00',2.59),('15128','2013-01-26','11:55:00',2.53),('15128','2013-01-26','12:00:00',2.67),('15128','2013-01-26','12:05:00',2.73),('15128','2013-01-26','12:10:00',2.76),('15128','2013-01-26','12:15:00',2.72),('15128','2013-01-26','12:20:00',2.77),('15128','2013-01-26','12:25:00',2.77),('15128','2013-01-26','12:30:00',2.81),('15128','2013-01-26','12:35:00',2.82),('15128','2013-01-26','12:40:00',2.83),('15128','2013-01-26','12:45:00',2.79),('15128','2013-01-26','12:50:00',2.75),('15128','2013-01-26','12:55:00',2.8),('15128','2013-01-26','13:00:00',2.8),('15128','2013-01-26','13:05:00',2.85),('15128','2013-01-26','13:10:00',2.89),('15128','2013-01-26','13:15:00',2.87),('15128','2013-01-26','13:20:00',2.86),('15128','2013-01-26','13:25:00',2.87),('15128','2013-01-26','13:30:00',2.84),('15128','2013-01-26','13:35:00',2.8),('15128','2013-01-26','13:40:00',2.78),('15128','2013-01-26','13:45:00',2.74),('15128','2013-01-26','13:50:00',2.73),('15128','2013-01-26','13:55:00',2.7),('15128','2013-01-26','14:00:00',2.65),('15128','2013-01-26','14:05:00',2.62),('15128','2013-01-26','14:10:00',2.57),('15128','2013-01-26','14:15:00',2.51),('15128','2013-01-26','14:20:00',2.48),('15128','2013-01-26','14:25:00',2.44),('15128','2013-01-26','14:30:00',2.41),('15128','2013-01-26','14:35:00',2.36),('15128','2013-01-26','14:40:00',2.3),('15128','2013-01-26','14:45:00',2.29),('15128','2013-01-26','14:50:00',2.21),('15128','2013-01-26','14:55:00',2.21),('15128','2013-01-26','15:00:00',2.12),('15128','2013-01-26','15:05:00',2.09),('15128','2013-01-26','15:10:00',2.04),('15128','2013-01-26','15:15:00',2),('15128','2013-01-26','15:20:00',1.92),('15128','2013-01-26','15:35:00',1.63),('15128','2013-01-26','15:40:00',1.53),('15128','2013-01-26','15:45:00',1.44),('15128','2013-01-26','15:50:00',1.33),('15128','2013-01-26','15:55:00',1.23),('15128','2013-01-26','16:00:00',1.09),('15128','2013-01-25','09:40:00',1.06),('15128','2013-01-25','10:35:00',1.23),('15128','2013-01-25','11:05:00',1.02),('15128','2013-01-25','11:10:00',1.03),('15128','2013-01-25','11:15:00',1.11),('15128','2013-01-25','11:20:00',1.13),('15128','2013-01-25','11:25:00',1.06),('15128','2013-01-25','11:30:00',1.09),('15128','2013-01-25','11:35:00',1.17),('15128','2013-01-25','11:40:00',1.19),('15128','2013-01-25','12:25:00',1.03),('15128','2013-01-25','12:30:00',1.13),('15128','2013-01-24','09:40:00',1.01),('15128','2013-01-24','09:50:00',1.05),('15128','2013-01-24','09:55:00',1.3),('15128','2013-01-24','10:00:00',1.45),('15128','2013-01-24','10:05:00',1.53),('15128','2013-01-24','10:10:00',1.68),('15128','2013-01-24','10:15:00',1.76),('15128','2013-01-24','10:20:00',1.8),('15128','2013-01-24','10:25:00',1.87),('15128','2013-01-24','10:30:00',1.89),('15128','2013-01-24','10:35:00',1.88),('15128','2013-01-24','10:40:00',1.92),('15128','2013-01-24','10:45:00',2),('15128','2013-01-24','10:50:00',2.04),('15128','2013-01-24','10:55:00',2.11),('15128','2013-01-24','11:00:00',2.1),('15128','2013-01-24','11:05:00',2.05),('15128','2013-01-24','11:10:00',2.09),('15128','2013-01-24','11:15:00',2.18),('15128','2013-01-24','11:20:00',2.24),('15128','2013-01-24','11:25:00',2.3),('15128','2013-01-24','11:30:00',2.38),('15128','2013-01-24','11:35:00',2.52),('15128','2013-01-24','11:40:00',2.63),('15128','2013-01-24','11:45:00',2.68),('15128','2013-01-24','11:50:00',2.73),('15128','2013-01-24','11:55:00',2.78),('15128','2013-01-24','12:00:00',2.8),('15128','2013-01-24','12:05:00',2.79),('15128','2013-01-24','12:10:00',2.8),('15128','2013-01-24','12:15:00',2.81),('15128','2013-01-24','12:20:00',2.82),('15128','2013-01-24','12:25:00',2.87),('15128','2013-01-24','12:30:00',2.71),('15128','2013-01-24','12:35:00',2.41),('15128','2013-01-24','12:40:00',2.7),('15128','2013-01-24','12:45:00',3.05),('15128','2013-01-24','12:50:00',3.01),('15128','2013-01-24','12:55:00',2.97),('15128','2013-01-24','13:00:00',2.92),('15128','2013-01-24','13:05:00',2.92),('15128','2013-01-24','13:10:00',2.92),('15128','2013-01-24','13:15:00',2.9),('15128','2013-01-24','13:20:00',2.9),('15128','2013-01-24','13:25:00',2.88),('15128','2013-01-24','13:30:00',2.82),('15128','2013-01-24','13:35:00',2.77),('15128','2013-01-24','13:40:00',2.8),('15128','2013-01-24','13:45:00',2.8),('15128','2013-01-24','13:50:00',2.76),('15128','2013-01-24','13:55:00',2.59),('15128','2013-01-24','14:00:00',2.32),('15128','2013-01-24','14:05:00',2.37),('15128','2013-01-24','14:10:00',2.34),('15128','2013-01-24','14:15:00',2.34),('15128','2013-01-24','14:20:00',2.34),('15128','2013-01-24','14:25:00',2.26),('15128','2013-01-24','14:30:00',2.21),('15128','2013-01-24','14:35:00',2.16),('15128','2013-01-24','14:40:00',2.11),('15128','2013-01-24','14:45:00',2.02),('15128','2013-01-24','14:50:00',2),('15128','2013-01-24','14:55:00',1.97),('15128','2013-01-24','15:00:00',1.81),('15128','2013-01-24','15:05:00',1.58),('15128','2013-01-24','15:10:00',1.42),('15128','2013-01-24','15:15:00',1.4),('15128','2013-01-24','15:20:00',1.47),('15128','2013-01-24','15:25:00',1.65),('15128','2013-01-24','15:30:00',1.68),('15128','2013-01-24','15:35:00',1.69),('15128','2013-01-24','15:40:00',1.58),('15128','2013-01-24','15:45:00',1.46),('15128','2013-01-24','15:50:00',1.34),('15128','2013-01-24','15:55:00',1.02),('15128','2013-01-23','09:35:00',1.17),('15128','2013-01-23','09:40:00',1.19),('15128','2013-01-23','09:45:00',1.05),('15128','2013-01-23','09:50:00',1.18),('15128','2013-01-23','09:55:00',1.32),('15128','2013-01-23','10:00:00',1.29),('15128','2013-01-23','10:05:00',1.21),('15128','2013-01-23','10:10:00',1.68),('15128','2013-01-23','10:15:00',1.72),('15128','2013-01-23','10:20:00',1.68),('15128','2013-01-23','10:25:00',1.66),('15128','2013-01-23','10:30:00',1.78),('15128','2013-01-23','10:35:00',1.79),('15128','2013-01-23','10:40:00',1.84),('15128','2013-01-23','10:45:00',1.91),('15128','2013-01-23','10:50:00',1.95),('15128','2013-01-23','10:55:00',1.77),('15128','2013-01-23','12:35:00',1.12),('15128','2013-01-23','12:40:00',1.17),('15128','2013-01-23','12:45:00',1.17),('15128','2013-01-23','12:50:00',1.08),('15128','2013-01-23','12:55:00',1.01),('15128','2013-01-23','13:50:00',1.07),('15128','2013-01-23','13:55:00',1.15),('15128','2013-01-23','14:00:00',1.18),('15128','2013-01-23','14:05:00',1.23),('15128','2013-01-23','14:10:00',1.26),('15128','2013-01-23','14:20:00',1.28),('15128','2013-01-23','14:25:00',3.07),('15128','2013-01-23','14:30:00',3.07),('15128','2013-01-23','14:35:00',2.17),('15128','2013-01-23','14:40:00',1.97),('15128','2013-01-23','14:45:00',2.5),('15128','2013-01-23','14:50:00',2.18),('15128','2013-01-23','14:55:00',1.46),('15128','2013-01-23','15:00:00',1.8),('15128','2013-01-23','15:05:00',2.13),('15128','2013-01-23','15:10:00',1.66),('15128','2013-01-23','15:15:00',1.35),('15128','2013-01-23','15:35:00',1.32),('15128','2013-01-23','15:40:00',1.68),('15128','2013-01-23','15:45:00',1.41),('15128','2013-01-23','15:50:00',1.42),('15128','2013-01-23','15:55:00',1.08),('15128','2013-01-22','09:15:00',1.13),('15128','2013-01-22','09:20:00',1.13),('15128','2013-01-22','09:40:00',1.2),('15128','2013-01-22','09:45:00',1.58),('15128','2013-01-22','09:50:00',1.86),('15128','2013-01-22','09:55:00',1.62),('15128','2013-01-22','10:00:00',1.14),('15128','2013-01-22','10:05:00',2.02),('15128','2013-01-22','10:10:00',1.97),('15128','2013-01-22','10:15:00',2.04),('15128','2013-01-22','10:20:00',2.28),('15128','2013-01-22','10:25:00',1.45),('15128','2013-01-22','10:30:00',1.4),('15128','2013-01-21','09:30:00',1.26),('15128','2013-01-21','09:35:00',1.21),('15128','2013-01-21','09:40:00',1),('15128','2013-01-21','09:50:00',1.24),('15128','2013-01-21','09:55:00',1.27),('15128','2013-01-21','10:00:00',1.29),('15128','2013-01-21','10:05:00',1.4),('15128','2013-01-21','10:10:00',1.61),('15128','2013-01-21','10:15:00',1.88),('15128','2013-01-21','10:20:00',1.05),('15128','2013-01-21','10:25:00',1.76),('15128','2013-01-21','10:30:00',1.18),('15128','2013-01-21','10:35:00',1.41),('15128','2013-01-21','10:40:00',1.03),('15128','2013-01-21','10:45:00',1.18),('15128','2013-01-21','10:50:00',1.05),('15128','2013-01-21','11:00:00',2.12),('15128','2013-01-21','11:10:00',1.61),('15128','2013-01-21','11:15:00',2.81),('15128','2013-01-21','11:20:00',2.63),('15128','2013-01-21','11:55:00',2),('15128','2013-01-21','12:00:00',1.29),('15128','2013-01-21','12:05:00',1.36),('15128','2013-01-21','12:10:00',1.48),('15128','2013-01-21','12:15:00',2.42),('15128','2013-01-21','12:20:00',2.22),('15128','2013-01-21','12:25:00',1.05),('15128','2013-01-21','12:30:00',3.08),('15128','2013-01-21','12:35:00',2.18),('15128','2013-01-21','12:40:00',2.31),('15128','2013-01-21','12:45:00',1.44),('15128','2013-01-21','12:50:00',1.13),('15128','2013-01-21','13:00:00',2.26),('15128','2013-01-21','13:05:00',2.46),('15128','2013-01-21','13:10:00',1.56),('15128','2013-01-21','13:15:00',2.02),('15128','2013-01-21','13:20:00',1.01),('15128','2013-01-21','13:25:00',2.22),('15128','2013-01-21','13:35:00',1.6),('15128','2013-01-21','13:45:00',1.21),('15128','2013-01-21','13:55:00',2.06),('15128','2013-01-21','14:00:00',2.09),('15128','2013-01-21','14:05:00',2.13),('15128','2013-01-21','14:10:00',2.72),('15128','2013-01-21','14:15:00',1.61),('15128','2013-01-21','14:20:00',1.55),('15128','2013-01-21','14:25:00',2.62),('15128','2013-01-21','14:30:00',2.09),('15128','2013-01-21','14:35:00',1.8),('15128','2013-01-21','14:40:00',2.48),('15128','2013-01-21','14:45:00',2.19),('15128','2013-01-21','14:55:00',2.18),('15128','2014-03-19','08:25:00',1.05),('15128','2014-03-19','08:30:00',1.13),('15128','2014-03-19','08:35:00',1.22),('15128','2014-03-19','08:40:00',1.29),('15128','2014-03-19','08:45:00',1.36),('15128','2014-03-19','08:50:00',1.41),('15128','2014-03-19','08:55:00',1.48),('15128','2014-03-19','09:00:00',1.49),('15128','2014-03-19','09:05:00',1.55),('15128','2014-03-19','09:10:00',1.67),('15128','2014-03-19','09:15:00',1.69),('15128','2014-03-19','09:20:00',1.76),('15128','2014-03-19','09:25:00',1.86),('15128','2014-03-19','09:30:00',1.9),('15128','2014-03-19','09:35:00',1.97),('15128','2014-03-19','09:40:00',1.95),('15128','2014-03-19','09:45:00',2.04),('15128','2014-03-19','09:50:00',2.06),('15128','2014-03-19','09:55:00',2.11),('15128','2014-03-19','10:00:00',2.25),('15128','2014-03-19','10:05:00',2.25),('15128','2014-03-19','10:10:00',2.38),('15128','2014-03-19','10:15:00',2.4),('15128','2014-03-19','10:20:00',2.48),('15128','2014-03-19','10:25:00',2.55),('15128','2014-03-19','10:30:00',2.61),('15128','2014-03-19','10:35:00',2.57),('15128','2014-03-19','10:40:00',2.59),('15128','2014-03-19','10:45:00',2.59),('15128','2014-03-19','10:50:00',2.77),('15128','2014-03-19','10:55:00',2.86),('15128','2014-03-19','11:00:00',2.91),('15128','2014-03-19','11:05:00',2.95),('15128','2014-03-19','11:10:00',3.08),('15128','2014-03-19','11:15:00',2.95),('15128','2014-03-19','11:20:00',3.07),('15128','2014-03-19','11:25:00',3.09),('15128','2014-03-19','11:30:00',3.09),('15128','2014-03-19','11:35:00',3.24),('15128','2014-03-19','11:40:00',3.27),('15128','2014-03-19','11:45:00',3.09),('15128','2014-03-19','11:50:00',3.26),('15128','2014-03-19','11:55:00',3.25),('15128','2014-03-19','12:00:00',3.24),('15128','2014-03-19','12:05:00',3.03),('15128','2014-03-19','12:10:00',3.2),('15128','2014-03-19','12:15:00',3.48),('15128','2014-03-19','12:20:00',3.58),('15128','2014-03-19','12:25:00',3.47),('15128','2014-03-19','12:30:00',3.33),('15128','2014-03-19','12:35:00',3.5),('15128','2014-03-19','12:40:00',3.61),('15128','2014-03-19','12:45:00',3.7),('15128','2014-03-19','12:50:00',3.71),('15128','2014-03-19','12:55:00',3.72),('15128','2014-03-19','13:00:00',3.69),('15128','2014-03-19','13:05:00',3.59),('15128','2014-03-19','13:10:00',3.53),('15128','2014-03-19','13:15:00',3.53),('15128','2014-03-19','13:20:00',3.54),('15128','2014-03-19','13:25:00',3.55),('15128','2014-03-19','13:30:00',3.51),('15128','2014-03-19','13:35:00',3.39),('15128','2014-03-19','13:40:00',3.22),('15128','2014-03-19','13:45:00',3.21),('15128','2014-03-19','13:50:00',3.11),('15128','2014-03-19','13:55:00',3.09),('15128','2014-03-19','14:00:00',2.98),('15128','2014-03-19','14:05:00',2.99),('15128','2014-03-19','14:10:00',3.09),('15128','2014-03-19','14:15:00',2.8),('15128','2014-03-19','14:20:00',2.71),('15128','2014-03-19','14:25:00',2.33),('15128','2014-03-19','14:30:00',2.41),('15128','2014-03-19','14:35:00',2.65),('15128','2014-03-19','14:40:00',2.57),('15128','2014-03-19','14:45:00',2.67),('15128','2014-03-19','14:50:00',2.67),('15128','2014-03-19','14:55:00',2.62),('15128','2014-03-19','15:00:00',2.57),('15128','2014-03-19','15:05:00',2.57),('15128','2014-03-19','15:10:00',2.42),('15128','2014-03-19','15:15:00',2.46),('15128','2014-03-19','15:20:00',2.44),('15128','2014-03-19','15:25:00',2.36),('15128','2014-03-19','15:30:00',2.1),('15128','2014-03-19','15:35:00',1.89),('15128','2014-03-19','15:40:00',1.76),('15128','2014-03-19','15:45:00',1.6),('15128','2014-03-19','15:50:00',1.4),('15128','2014-03-19','15:55:00',1.24),('15128','2014-03-19','16:00:00',1.21),('15128','2014-03-19','16:05:00',1.29),('15128','2014-03-19','16:10:00',1.23),('15128','2014-03-19','16:15:00',1.08),('15128','2014-03-19','16:20:00',1.02),('15128','2014-03-19','16:25:00',1.05),('15128','2014-03-19','16:40:00',1.02),('15128','2013-01-20','10:45:00',1.06),('15128','2013-01-20','10:50:00',1.01),('15128','2013-01-20','11:10:00',1.11),('15128','2013-01-20','11:15:00',1.07),('15128','2013-01-20','11:20:00',1.13),('15128','2013-01-20','11:35:00',1.05),('15128','2013-01-20','11:50:00',1.96),('15128','2013-01-20','11:55:00',2.6),('15128','2013-01-20','12:00:00',2.6),('15128','2013-01-20','12:05:00',2.01),('15128','2013-01-20','12:10:00',1.87),('15128','2013-01-20','12:15:00',1.42),('15128','2013-01-20','12:20:00',2.45),('15128','2013-01-20','12:25:00',1.81),('15128','2013-01-20','12:35:00',2.13),('15128','2013-01-20','13:10:00',1),('15128','2013-01-20','13:20:00',1.44),('15128','2013-01-20','13:25:00',3.66),('15128','2013-01-20','13:30:00',3.55),('15128','2013-01-20','13:35:00',2.84),('15128','2013-01-20','13:40:00',2.18),('15128','2013-01-20','13:45:00',1.04),('15128','2013-01-20','13:55:00',3.29),('15128','2013-01-20','14:00:00',2.43),('15128','2013-01-20','14:05:00',2.16),('15128','2013-01-20','14:10:00',2),('15128','2013-01-20','14:15:00',1.78),('15128','2013-01-20','14:20:00',2.46),('15128','2013-01-20','15:30:00',1.81),('15128','2013-01-19','11:00:00',1.01),('15128','2013-01-19','11:05:00',1.08),('15128','2013-01-19','11:10:00',1.49),('15128','2013-01-19','11:15:00',1.67),('15128','2013-01-19','11:20:00',1.26),('15128','2013-01-19','11:25:00',1.36),('15128','2013-01-19','11:30:00',1.65),('15128','2013-01-19','11:35:00',1.17),('15128','2013-01-19','11:40:00',1.02),('15128','2013-01-18','09:50:00',1.25),('15128','2013-01-18','09:55:00',1.4),('15128','2013-01-18','10:00:00',1.13),('15128','2013-01-18','10:40:00',1.02),('15128','2013-01-18','10:45:00',1.23),('15128','2013-01-18','11:15:00',1.12),('15128','2013-01-18','11:20:00',1.23),('15128','2013-01-18','11:25:00',1.08),('15128','2013-01-17','10:10:00',1.64),('15128','2013-01-17','10:15:00',2.06),('15128','2013-01-17','10:20:00',1.2),('15128','2013-01-17','10:25:00',1.14),('15128','2013-01-17','11:20:00',1.05),('15128','2013-01-17','11:25:00',1.27),('15128','2013-01-17','11:30:00',1.37),('15128','2013-01-17','11:35:00',1.14),('15128','2013-01-17','11:50:00',1.04),('15128','2013-01-17','11:55:00',1.02),('15128','2013-01-17','12:00:00',1.09),('15128','2013-01-17','12:05:00',1.25),('15128','2013-01-17','12:10:00',1.33),('15128','2013-01-17','12:15:00',1.43),('15128','2013-01-17','12:20:00',1.33),('15128','2013-01-17','12:25:00',1.27),('15128','2013-01-17','12:30:00',1.42),('15128','2013-01-17','12:35:00',1.42),('15128','2013-01-17','12:40:00',1.44),('15128','2013-01-17','12:45:00',1.71),('15128','2013-01-17','12:50:00',1.99),('15128','2013-01-17','12:55:00',2.63),('15128','2013-01-17','13:00:00',1.8),('15128','2013-01-17','13:05:00',2),('15128','2013-01-17','13:10:00',2.42),('15128','2013-01-17','13:15:00',2.31),('15128','2013-01-17','13:20:00',2.01),('15128','2013-01-17','13:25:00',1.97),('15128','2013-01-17','13:30:00',1.81),('15128','2013-01-17','13:35:00',1.85),('15128','2013-01-17','13:40:00',3.16),('15128','2013-01-17','13:45:00',3.14),('15128','2013-01-17','13:50:00',3.1),('15128','2013-01-17','13:55:00',3.1),('15128','2013-01-17','14:00:00',1.85),('15128','2013-01-17','14:05:00',2.35),('15128','2013-01-17','14:10:00',3.34),('15128','2013-01-17','14:15:00',3.18),('15128','2013-01-17','14:20:00',1.76);
INSERT INTO `solarlogmod` VALUES ('15128','2013-01-17','14:25:00',1.63),('15128','2013-01-17','14:30:00',1.1),('15128','2013-01-17','14:45:00',1.18),('15128','2013-01-17','14:50:00',1.68),('15128','2013-01-17','14:55:00',1.35),('15128','2013-01-17','15:00:00',1.27),('15128','2013-01-17','15:05:00',1.07),('15128','2013-01-17','15:40:00',1.01),('15128','2013-01-17','15:45:00',1.24),('15128','2013-01-17','15:50:00',1.24),('15128','2013-01-17','15:55:00',1.13),('15128','2013-01-16','09:45:00',1.23),('15128','2013-01-16','09:50:00',1.35),('15128','2013-01-16','09:55:00',1.27),('15128','2013-01-16','10:00:00',1.12),('15128','2013-01-16','10:05:00',1.14),('15128','2013-01-16','10:10:00',1.29),('15128','2013-01-16','10:15:00',1.35),('15128','2013-01-16','10:20:00',1.43),('15128','2013-01-16','10:25:00',1.49),('15128','2013-01-16','10:30:00',1.63),('15128','2013-01-16','10:35:00',1.65),('15128','2013-01-16','10:40:00',1.56),('15128','2013-01-16','10:45:00',1.35),('15128','2013-01-16','10:50:00',1.35),('15128','2013-01-16','10:55:00',1.34),('15128','2013-01-16','11:00:00',1.27),('15128','2013-01-16','11:05:00',1.35),('15128','2013-01-16','11:10:00',1.71),('15128','2013-01-16','11:15:00',1.61),('15128','2013-01-16','11:20:00',1.32),('15128','2013-01-16','11:25:00',1.32),('15128','2013-01-16','11:30:00',1.21),('15128','2013-01-16','11:35:00',1.5),('15128','2013-01-16','11:40:00',1.61),('15128','2013-01-16','11:45:00',1.61),('15128','2013-01-16','11:50:00',1.55),('15128','2013-01-16','11:55:00',1.44),('15128','2013-01-16','12:00:00',1.58),('15128','2013-01-16','12:05:00',1.67),('15128','2013-01-16','12:10:00',1.65),('15128','2013-01-16','12:15:00',1.73),('15128','2013-01-16','12:20:00',1.9),('15128','2013-01-16','12:25:00',1.72),('15128','2013-01-16','12:30:00',2.05),('15128','2013-01-16','12:35:00',2.06),('15128','2013-01-16','12:40:00',1.99),('15128','2013-01-16','12:45:00',2.01),('15128','2013-01-16','12:50:00',1.76),('15128','2013-01-16','12:55:00',1.69),('15128','2013-01-16','13:00:00',1.72),('15128','2013-01-16','13:05:00',1.51),('15128','2013-01-16','13:10:00',1.64),('15128','2013-01-16','13:15:00',1.55),('15128','2013-01-16','13:20:00',1.56),('15128','2013-01-16','13:25:00',1.59),('15128','2013-01-16','13:30:00',2.04),('15128','2013-01-16','13:35:00',2.11),('15128','2013-01-16','13:40:00',2.46),('15128','2013-01-16','13:45:00',2.8),('15128','2013-01-16','13:50:00',1.95),('15128','2013-01-16','13:55:00',1.28),('15128','2013-01-16','14:10:00',1.08),('15128','2013-01-15','13:10:00',2.53),('15128','2013-01-15','13:15:00',2.07),('15128','2014-03-18','09:05:00',1.12),('15128','2014-03-18','09:10:00',1.25),('15128','2014-03-18','09:15:00',1.43),('15128','2014-03-18','09:20:00',1.39),('15128','2014-03-18','09:25:00',1.66),('15128','2014-03-18','09:30:00',1.77),('15128','2014-03-18','09:35:00',1.96),('15128','2014-03-18','09:40:00',1.87),('15128','2014-03-18','09:45:00',1.83),('15128','2014-03-18','09:50:00',1.81),('15128','2014-03-18','09:55:00',2.37),('15128','2014-03-18','10:00:00',1.33),('15128','2014-03-18','10:05:00',1.1),('15128','2014-03-18','10:10:00',1.23),('15128','2014-03-18','10:15:00',1.34),('15128','2014-03-18','10:20:00',1.28),('15128','2014-03-18','10:25:00',1.3),('15128','2014-03-18','10:30:00',1.42),('15128','2014-03-18','10:35:00',1.5),('15128','2014-03-18','10:40:00',3.11),('15128','2014-03-18','10:45:00',2.59),('15128','2014-03-18','10:50:00',1.53),('15128','2014-03-18','10:55:00',1.67),('15128','2014-03-18','11:00:00',1.64),('15128','2014-03-18','11:05:00',1.71),('15128','2014-03-18','11:10:00',1.61),('15128','2014-03-18','11:15:00',1.77),('15128','2014-03-18','11:20:00',1.99),('15128','2014-03-18','11:25:00',1.52),('15128','2014-03-18','11:30:00',2.5),('15128','2014-03-18','11:35:00',3.98),('15128','2014-03-18','11:40:00',3.82),('15128','2014-03-18','11:45:00',3.02),('15128','2014-03-18','11:50:00',1.55),('15128','2014-03-18','11:55:00',3.08),('15128','2014-03-18','12:00:00',1.77),('15128','2014-03-18','12:05:00',2.97),('15128','2014-03-18','12:10:00',4),('15128','2014-03-18','12:15:00',3.99),('15128','2014-03-18','12:20:00',3.7),('15128','2014-03-18','12:25:00',2.88),('15128','2014-03-18','12:30:00',3.76),('15128','2014-03-18','12:35:00',3.93),('15128','2014-03-18','12:40:00',3.79),('15128','2014-03-18','12:45:00',3.77),('15128','2014-03-18','12:50:00',3.66),('15128','2014-03-18','12:55:00',3.58),('15128','2014-03-18','13:00:00',3.65),('15128','2014-03-18','13:05:00',3.6),('15128','2014-03-18','13:10:00',3.49),('15128','2014-03-18','13:15:00',3.29),('15128','2014-03-18','13:20:00',2.94),('15128','2014-03-18','13:25:00',3.55),('15128','2014-03-18','13:30:00',3.55),('15128','2014-03-18','13:35:00',3.53),('15128','2014-03-18','13:40:00',3.55),('15128','2014-03-18','13:45:00',3.53),('15128','2014-03-18','13:50:00',3.46),('15128','2014-03-18','13:55:00',3.46),('15128','2014-03-18','14:00:00',3.45),('15128','2014-03-18','14:05:00',3.41),('15128','2014-03-18','14:10:00',3.34),('15128','2014-03-18','14:15:00',3.33),('15128','2014-03-18','14:20:00',3.29),('15128','2014-03-18','14:25:00',3.19),('15128','2014-03-18','14:30:00',3.17),('15128','2014-03-18','14:35:00',3.26),('15128','2014-03-18','14:40:00',3.19),('15128','2014-03-18','14:45:00',3.15),('15128','2014-03-18','14:50:00',3.09),('15128','2014-03-18','14:55:00',3.05),('15128','2014-03-18','15:00:00',2.97),('15128','2014-03-18','15:05:00',2.95),('15128','2014-03-18','15:10:00',2.92),('15128','2014-03-18','15:15:00',2.79),('15128','2014-03-18','15:20:00',2.81),('15128','2014-03-18','15:25:00',2.75),('15128','2014-03-18','15:30:00',2.65),('15128','2014-03-18','15:35:00',2.57),('15128','2014-03-18','15:40:00',2.54),('15128','2014-03-18','15:45:00',2.5),('15128','2014-03-18','15:50:00',2.39),('15128','2014-03-18','15:55:00',2.27),('15128','2014-03-18','16:00:00',2.16),('15128','2014-03-18','16:05:00',2.12),('15128','2014-03-18','16:10:00',1.98),('15128','2014-03-18','16:15:00',1.88),('15128','2014-03-18','16:20:00',1.78),('15128','2014-03-18','16:25:00',1.74),('15128','2014-03-18','16:30:00',1.55),('15128','2014-03-18','16:35:00',1.49),('15128','2014-03-18','16:40:00',1.39),('15128','2014-03-18','16:45:00',1.34),('15128','2014-03-18','16:50:00',1.2),('15128','2014-03-18','16:55:00',1.16),('15128','2014-03-17','08:40:00',1.07),('15128','2014-03-17','08:45:00',1.03),('15128','2014-03-17','08:50:00',1.19),('15128','2014-03-17','08:55:00',1.87),('15128','2014-03-17','09:00:00',1.87),('15128','2014-03-17','09:05:00',2.25),('15128','2014-03-17','09:10:00',1.76),('15128','2014-03-17','09:15:00',1.2),('15128','2014-03-17','09:20:00',1.2),('15128','2014-03-17','09:50:00',1.43),('15128','2014-03-17','09:55:00',1.81),('15128','2014-03-17','10:00:00',2.11),('15128','2014-03-17','10:05:00',1.27),('15128','2014-03-17','10:10:00',1.05),('15128','2014-03-17','10:15:00',2),('15128','2014-03-17','10:20:00',2.27),('15128','2014-03-17','10:25:00',3.21),('15128','2014-03-17','10:30:00',2.9),('15128','2014-03-17','10:35:00',1.63),('15128','2014-03-17','10:40:00',1.17),('15128','2014-03-17','10:45:00',1.12),('15128','2014-03-17','10:50:00',1.08),('15128','2014-03-17','10:55:00',1.92),('15128','2014-03-17','11:00:00',1.45),('15128','2014-03-17','11:05:00',1.36),('15128','2014-03-17','11:10:00',1.67),('15128','2014-03-17','11:15:00',3.72),('15128','2014-03-17','11:20:00',3.63),('15128','2014-03-17','11:25:00',3.46),('15128','2014-03-17','11:30:00',3.56),('15128','2014-03-17','11:35:00',3.57),('15128','2014-03-17','11:40:00',2.25),('15128','2014-03-17','11:45:00',3.02),('15128','2014-03-17','11:50:00',3.28),('15128','2014-03-17','11:55:00',3.55),('15128','2014-03-17','12:00:00',3.78),('15128','2014-03-17','12:05:00',3.33),('15128','2014-03-17','12:10:00',2.03),('15128','2014-03-17','12:15:00',3.21),('15128','2014-03-17','12:20:00',3.62),('15128','2014-03-17','12:25:00',2.93),('15128','2014-03-17','12:30:00',2.76),('15128','2014-03-17','12:35:00',3.55),('15128','2014-03-17','12:40:00',2.83),('15128','2014-03-17','12:45:00',3.69),('15128','2014-03-17','12:50:00',3.77),('15128','2014-03-17','12:55:00',2.85),('15128','2014-03-17','13:00:00',3.51),('15128','2014-03-17','13:05:00',3.33),('15128','2014-03-17','13:10:00',3.81),('15128','2014-03-17','13:15:00',3.55),('15128','2014-03-17','13:20:00',2.77),('15128','2014-03-17','13:25:00',3.11),('15128','2014-03-17','13:30:00',3.64),('15128','2014-03-17','13:35:00',3.52),('15128','2014-03-17','13:40:00',3.59),('15128','2014-03-17','13:45:00',3.61),('15128','2014-03-17','13:50:00',3.51),('15128','2014-03-17','13:55:00',3.56),('15128','2014-03-17','14:00:00',3.48),('15128','2014-03-17','14:05:00',3.52),('15128','2014-03-17','14:10:00',3.4),('15128','2014-03-17','14:15:00',3.39),('15128','2014-03-17','14:20:00',3.34),('15128','2014-03-17','14:25:00',3.28),('15128','2014-03-17','14:30:00',3.33),('15128','2014-03-17','14:35:00',3.31),('15128','2014-03-17','14:40:00',3.2),('15128','2014-03-17','14:45:00',3.12),('15128','2014-03-17','14:50:00',3.09),('15128','2014-03-17','14:55:00',3.04),('15128','2014-03-17','15:00:00',3.02),('15128','2014-03-17','15:05:00',2.93),('15128','2014-03-17','15:10:00',2.92),('15128','2014-03-17','15:15:00',2.88),('15128','2014-03-17','15:20:00',2.79),('15128','2014-03-17','15:25:00',2.7),('15128','2014-03-17','15:30:00',2.56),('15128','2014-03-17','15:35:00',2.53),('15128','2014-03-17','15:40:00',2.44),('15128','2014-03-17','15:45:00',2.43),('15128','2014-03-17','15:50:00',2.36),('15128','2014-03-17','15:55:00',2.27),('15128','2014-03-17','16:00:00',2.16),('15128','2014-03-17','16:05:00',2.03),('15128','2014-03-17','16:10:00',1.91),('15128','2014-03-17','16:15:00',1.79),('15128','2014-03-17','16:20:00',1.75),('15128','2014-03-17','16:25:00',1.64),('15128','2014-03-17','16:30:00',1.62),('15128','2014-03-17','16:35:00',1.36),('15128','2014-03-17','16:40:00',1.46),('15128','2014-03-17','16:45:00',1.33),('15128','2014-03-17','16:50:00',1.27),('15128','2014-03-17','16:55:00',1.22),('15128','2014-03-17','17:00:00',1.04),('15128','2014-04-30','08:20:00',1.04),('15128','2014-04-30','08:25:00',1.11),('15128','2014-04-30','08:30:00',1.19),('15128','2014-04-30','08:35:00',1.59),('15128','2014-04-30','08:40:00',1.38),('15128','2014-04-30','08:55:00',1.26),('15128','2014-04-30','09:00:00',1.42),('15128','2014-04-30','09:05:00',1.37),('15128','2014-04-30','09:10:00',1.86),('15128','2014-04-30','09:15:00',2.09),('15128','2014-04-30','09:20:00',1.37),('15128','2014-04-30','09:25:00',2.08),('15128','2014-04-30','09:30:00',1.67),('15128','2014-04-30','09:35:00',1.55),('15128','2014-04-30','09:40:00',1.02),('15128','2014-04-30','09:55:00',1.12),('15128','2014-04-30','10:00:00',1.59),('15128','2014-04-30','10:05:00',1.8),('15128','2014-04-30','10:10:00',2.93),('15128','2014-04-30','10:15:00',2.68),('15128','2014-04-30','10:20:00',2.72),('15128','2014-04-30','10:25:00',2.11),('15128','2014-04-30','10:30:00',2.17),('15128','2014-04-30','10:35:00',3.14),('15128','2014-04-30','10:40:00',3.32),('15128','2014-04-30','10:45:00',2.99),('15128','2014-04-30','10:50:00',1.68),('15128','2014-04-30','10:55:00',1.93),('15128','2014-04-30','11:00:00',1.42),('15128','2014-04-30','11:05:00',2.75),('15128','2014-04-30','11:10:00',3.48),('15128','2014-04-30','11:15:00',3.52),('15128','2014-04-30','11:20:00',3.49),('15128','2014-04-30','11:25:00',3.56),('15128','2014-04-30','11:30:00',3.61),('15128','2014-04-30','11:35:00',3.57),('15128','2014-04-30','11:40:00',3.74),('15128','2014-04-30','11:45:00',2.24),('15128','2014-04-30','11:50:00',2.65),('15128','2014-04-30','11:55:00',3.17),('15128','2014-04-30','12:00:00',4.37),('15128','2014-04-30','12:05:00',4.39),('15128','2014-04-30','12:10:00',2.84),('15128','2014-04-30','12:15:00',3.13),('15128','2014-04-30','12:20:00',2.8),('15128','2014-04-30','12:25:00',4.64),('15128','2014-04-30','12:30:00',3.86),('15128','2014-04-30','12:40:00',1.16),('15128','2014-04-30','12:45:00',1.34),('15128','2014-04-30','13:00:00',3.32),('15128','2014-04-30','13:05:00',3.87),('15128','2014-04-30','13:10:00',1.73),('15128','2014-04-30','13:15:00',4.73),('15128','2014-04-30','13:20:00',4.64),('15128','2014-04-30','13:25:00',4.9),('15128','2014-04-30','13:30:00',5.11),('15128','2014-04-30','13:35:00',4.77),('15128','2014-04-30','13:40:00',3.64),('15128','2014-04-30','13:45:00',1.11),('15128','2014-04-30','13:50:00',3.82),('15128','2014-04-30','13:55:00',4.5),('15128','2014-04-30','14:00:00',4.38),('15128','2014-04-30','14:05:00',4.36),('15128','2014-04-30','14:10:00',4.3),('15128','2014-04-30','14:15:00',4.25),('15128','2014-04-30','14:20:00',4.28),('15128','2014-04-30','14:25:00',4.27),('15128','2014-04-30','14:30:00',4.26),('15128','2014-04-30','14:35:00',4.27),('15128','2014-04-30','14:40:00',4.28),('15128','2014-04-30','14:45:00',4.31),('15128','2014-04-30','14:50:00',4.21),('15128','2014-04-30','14:55:00',4.2),('15128','2014-04-30','15:00:00',4.25),('15128','2014-04-30','15:05:00',4.2),('15128','2014-04-30','15:10:00',4.21),('15128','2014-04-30','15:15:00',4.18),('15128','2014-04-30','15:20:00',4.01),('15128','2014-04-30','15:25:00',4.04),('15128','2014-04-30','15:30:00',4.04),('15128','2014-04-30','15:35:00',3.93),('15128','2014-04-30','15:40:00',3.97),('15128','2014-04-30','15:45:00',3.92),('15128','2014-04-30','15:50:00',3.84),('15128','2014-04-30','15:55:00',3.76),('15128','2014-04-30','16:00:00',3.77),('15128','2014-04-30','16:05:00',3.73),('15128','2014-04-30','16:10:00',3.7),('15128','2014-04-30','16:15:00',3.56),('15128','2014-04-30','16:20:00',3.24),('15128','2014-04-30','16:25:00',3.32),('15128','2014-04-30','16:30:00',3.29),('15128','2014-04-30','16:35:00',3.17),('15128','2014-04-30','16:40:00',2.89),('15128','2014-04-30','16:45:00',3.01),('15128','2014-04-30','16:50:00',3.21),('15128','2014-04-30','16:55:00',3.06),('15128','2014-04-30','17:00:00',3.06),('15128','2014-04-30','17:05:00',2.99),('15128','2014-04-30','17:10:00',2.91),('15128','2014-04-30','17:15:00',2.83),('15128','2014-04-30','17:20:00',2.75),('15128','2014-04-30','17:25:00',2.67),('15128','2014-04-30','17:30:00',2.65),('15128','2014-04-30','17:35:00',2.58),('15128','2014-04-30','17:40:00',2.19),('15128','2014-04-30','17:45:00',2.05),('15128','2014-04-30','17:50:00',1.38),('15128','2014-04-30','17:55:00',2.05),('15128','2014-04-30','18:00:00',1.68),('15128','2014-04-30','18:05:00',1.3),('15128','2014-04-30','18:10:00',1.8),('15128','2014-04-30','18:15:00',1.21),('15128','2014-04-30','18:20:00',1.38),('15128','2014-04-30','18:25:00',1.52),('15128','2014-04-30','18:30:00',1.44),('15128','2014-04-30','18:35:00',1.41),('15128','2014-04-30','18:40:00',1.03),('15128','2014-04-30','18:45:00',1.02),('15128','2014-04-30','18:50:00',1.04),('15128','2014-03-16','09:15:00',1.03),('15128','2014-03-16','09:20:00',1.01),('15128','2014-03-16','09:35:00',1.1),('15128','2014-03-16','09:40:00',1.16),('15128','2014-03-16','09:45:00',1.16),('15128','2014-03-16','09:50:00',1.17),('15128','2014-03-16','10:05:00',1.14),('15128','2014-03-16','10:10:00',1.26),('15128','2014-03-16','10:15:00',1.3),('15128','2014-03-16','10:20:00',1.13),('15128','2014-03-16','10:25:00',1.17),('15128','2014-03-16','10:30:00',1.06),('15128','2014-03-16','10:35:00',1.12),('15128','2014-03-16','10:40:00',1.4),('15128','2014-03-16','10:45:00',1.57),('15128','2014-03-16','10:50:00',1.23),('15128','2014-03-16','10:55:00',1.72),('15128','2014-03-16','11:00:00',1.78),('15128','2014-03-16','11:05:00',2.09),('15128','2014-03-16','11:10:00',1.38),('15128','2014-03-16','11:15:00',1.33),('15128','2014-03-16','11:20:00',1.24),('15128','2014-03-16','11:25:00',1.44),('15128','2014-03-16','11:30:00',2.24),('15128','2014-03-16','11:35:00',1.08),('15128','2014-03-16','11:45:00',1.07),('15128','2014-03-16','11:50:00',2.31),('15128','2014-03-16','11:55:00',1.33),('15128','2014-03-16','12:00:00',1.34),('15128','2014-03-16','12:05:00',1.73),('15128','2014-03-16','12:10:00',2.26),('15128','2014-03-16','12:15:00',3.11),('15128','2014-03-16','12:20:00',1.99),('15128','2014-03-16','12:25:00',2.89),('15128','2014-03-16','12:30:00',3.74),('15128','2014-03-16','12:35:00',3.49),('15128','2014-03-16','12:40:00',2.15),('15128','2014-03-16','12:45:00',3.91),('15128','2014-03-16','12:50:00',4.04),('15128','2014-03-16','12:55:00',3.39),('15128','2014-03-16','13:00:00',2.45),('15128','2014-03-16','13:05:00',3.49),('15128','2014-03-16','13:10:00',3.61),('15128','2014-03-16','13:15:00',3.65),('15128','2014-03-16','13:20:00',3.64),('15128','2014-03-16','13:25:00',3.68),('15128','2014-03-16','13:30:00',3.26),('15128','2014-03-16','13:35:00',3.67),('15128','2014-03-16','13:40:00',3.61),('15128','2014-03-16','13:45:00',2.77),('15128','2014-03-16','13:50:00',2.64),('15128','2014-03-16','13:55:00',2.55),('15128','2014-03-16','14:00:00',2.49),('15128','2014-03-16','14:05:00',3.42),('15128','2014-03-16','14:10:00',3.42),('15128','2014-03-16','14:15:00',3.59),('15128','2014-03-16','14:20:00',3.5),('15128','2014-03-16','14:25:00',3.11),('15128','2014-03-16','14:30:00',2.14),('15128','2014-03-16','14:35:00',2.07),('15128','2014-03-16','14:40:00',2.84),('15128','2014-03-16','14:45:00',2.72),('15128','2014-03-16','14:50:00',3.15),('15128','2014-03-16','14:55:00',2.48),('15128','2014-03-16','15:00:00',3.09),('15128','2014-03-16','15:05:00',2.98),('15128','2014-03-16','15:10:00',2.85),('15128','2014-03-16','15:15:00',2.75),('15128','2014-03-16','15:20:00',2.62),('15128','2014-03-16','15:25:00',2.33),('15128','2014-03-16','15:30:00',1.68),('15128','2014-03-16','15:35:00',2.2),('15128','2014-03-16','15:40:00',2.35),('15128','2014-03-16','15:45:00',2.2),('15128','2014-03-16','15:50:00',1.96),('15128','2014-03-16','15:55:00',1.79),('15128','2014-03-16','16:00:00',2),('15128','2014-03-16','16:05:00',1.81),('15128','2014-03-16','16:10:00',1.72),('15128','2014-03-16','16:15:00',1.65),('15128','2014-03-16','16:20:00',1.57),('15128','2014-03-16','16:25:00',1.49),('15128','2014-03-16','16:30:00',1.32),('15128','2014-03-15','08:30:00',1.03),('15128','2014-03-15','08:35:00',1.1),('15128','2014-03-15','08:40:00',1.16),('15128','2014-03-15','08:45:00',1.24),('15128','2014-03-15','08:50:00',1.32),('15128','2014-03-15','08:55:00',1.36),('15128','2014-03-15','09:00:00',1.31),('15128','2014-03-15','09:05:00',1.41),('15128','2014-03-15','09:10:00',1.54),('15128','2014-03-15','09:15:00',1.63),('15128','2014-03-15','09:20:00',1.64),('15128','2014-03-15','09:25:00',1.67),('15128','2014-03-15','09:30:00',1.7),('15128','2014-03-15','09:35:00',1.73),('15128','2014-03-15','09:40:00',1.79),('15128','2014-03-15','09:45:00',1.92),('15128','2014-03-15','09:50:00',1.98),('15128','2014-03-15','09:55:00',1.98),('15128','2014-03-15','10:00:00',2.05),('15128','2014-03-15','10:05:00',2.12),('15128','2014-03-15','10:10:00',2.17),('15128','2014-03-15','10:15:00',2.25),('15128','2014-03-15','10:20:00',2.29),('15128','2014-03-15','10:25:00',2.34),('15128','2014-03-15','10:30:00',2.39),('15128','2014-03-15','10:35:00',2.41),('15128','2014-03-15','10:40:00',2.43),('15128','2014-03-15','10:45:00',2.5),('15128','2014-03-15','10:50:00',2.58),('15128','2014-03-15','10:55:00',2.66),('15128','2014-03-15','11:00:00',2.72),('15128','2014-03-15','11:05:00',2.75),('15128','2014-03-15','11:10:00',2.93),('15128','2014-03-15','11:15:00',3.04),('15128','2014-03-15','11:20:00',3.09),('15128','2014-03-15','11:25:00',3.01),('15128','2014-03-15','11:30:00',3.04),('15128','2014-03-15','11:35:00',3.07),('15128','2014-03-15','11:40:00',3.09),('15128','2014-03-15','11:45:00',3.1),('15128','2014-03-15','11:50:00',3.15),('15128','2014-03-15','11:55:00',3.19),('15128','2014-03-15','12:00:00',3.2),('15128','2014-03-15','12:05:00',3.25),('15128','2014-03-15','12:10:00',3.3),('15128','2014-03-15','12:15:00',3.31),('15128','2014-03-15','12:20:00',3.31),('15128','2014-03-15','12:25:00',3.33),('15128','2014-03-15','12:30:00',3.29),('15128','2014-03-15','12:35:00',3.36),('15128','2014-03-15','12:40:00',3.37),('15128','2014-03-15','12:45:00',3.34),('15128','2014-03-15','12:50:00',3.38),('15128','2014-03-15','12:55:00',3.37),('15128','2014-03-15','13:00:00',3.24),('15128','2014-03-15','13:05:00',3.3),('15128','2014-03-15','13:10:00',3.34),('15128','2014-03-15','13:15:00',3.35),('15128','2014-03-15','13:20:00',3.38),('15128','2014-03-15','13:25:00',3.43),('15128','2014-03-15','13:30:00',3.35),('15128','2014-03-15','13:35:00',3.34),('15128','2014-03-15','13:40:00',3.27),('15128','2014-03-15','13:45:00',3.29),('15128','2014-03-15','13:50:00',3.2),('15128','2014-03-15','13:55:00',3.28),('15128','2014-03-15','14:00:00',3.26),('15128','2014-03-15','14:05:00',3.22),('15128','2014-03-15','14:10:00',3.19),('15128','2014-03-15','14:15:00',3.18),('15128','2014-03-15','14:20:00',3.15),('15128','2014-03-15','14:25:00',3.13),('15128','2014-03-15','14:30:00',3.07),('15128','2014-03-15','14:35:00',3.04),('15128','2014-03-15','14:40:00',2.94),('15128','2014-03-15','14:45:00',2.73),('15128','2014-03-15','14:50:00',2.77),('15128','2014-03-15','14:55:00',2.79),('15128','2014-03-15','15:00:00',2.61),('15128','2014-03-15','15:05:00',2.44),('15128','2014-03-15','15:10:00',2.17),('15128','2014-03-15','15:15:00',1.87),('15128','2014-03-15','15:20:00',2.04),('15128','2014-03-15','15:25:00',2.04),('15128','2014-03-15','15:30:00',1.96),('15128','2014-03-15','15:35:00',1.38),('15128','2014-03-15','15:40:00',1.65),('15128','2014-03-15','15:45:00',1.88),('15128','2014-03-15','15:50:00',1.6),('15128','2014-03-15','15:55:00',1.44),('15128','2014-03-15','16:00:00',1.52),('15128','2014-03-15','16:05:00',1.67),('15128','2014-03-15','16:10:00',1.71),('15128','2014-03-15','16:15:00',1.67),('15128','2014-03-15','16:20:00',1.54),('15128','2014-03-15','16:25:00',1.49),('15128','2014-03-15','16:30:00',1.5),('15128','2014-03-15','16:35:00',1.35),('15128','2014-03-15','16:40:00',1.27),('15128','2014-03-15','16:45:00',1.18),('15128','2014-03-14','08:35:00',1.03),('15128','2014-03-14','08:40:00',1.09),('15128','2014-03-14','08:45:00',1.17),('15128','2014-03-14','08:50:00',1.24),('15128','2014-03-14','08:55:00',1.3),('15128','2014-03-14','09:00:00',1.36),('15128','2014-03-14','09:05:00',1.41),('15128','2014-03-14','09:10:00',1.46),('15128','2014-03-14','09:15:00',1.52),('15128','2014-03-14','09:20:00',1.58),('15128','2014-03-14','09:25:00',1.62),('15128','2014-03-14','09:30:00',1.68),('15128','2014-03-14','09:35:00',1.74),('15128','2014-03-14','09:40:00',1.77),('15128','2014-03-14','09:45:00',1.83),('15128','2014-03-14','09:50:00',1.88),('15128','2014-03-14','09:55:00',1.95),('15128','2014-03-14','10:00:00',2.03),('15128','2014-03-14','10:05:00',2.05),('15128','2014-03-14','10:10:00',2.15),('15128','2014-03-14','10:15:00',2.19),('15128','2014-03-14','10:20:00',2.22),('15128','2014-03-14','10:25:00',2.25),('15128','2014-03-14','10:30:00',2.31),('15128','2014-03-14','10:35:00',2.38),('15128','2014-03-14','10:40:00',2.37),('15128','2014-03-14','10:45:00',2.44),('15128','2014-03-14','10:50:00',2.46),('15128','2014-03-14','10:55:00',2.57),('15128','2014-03-14','11:00:00',2.67),('15128','2014-03-14','11:05:00',2.71),('15128','2014-03-14','11:10:00',2.74),('15128','2014-03-14','11:15:00',2.94),('15128','2014-03-14','11:20:00',2.89),('15128','2014-03-14','11:25:00',2.98),('15128','2014-03-14','11:30:00',2.92),('15128','2014-03-14','11:35:00',3.01),('15128','2014-03-14','11:40:00',3.08),('15128','2014-03-14','11:45:00',3.11),('15128','2014-03-14','11:50:00',3.15),('15128','2014-03-14','11:55:00',3.21),('15128','2014-03-14','12:00:00',3.25),('15128','2014-03-14','12:05:00',3.27),('15128','2014-03-14','12:10:00',3.27),('15128','2014-03-14','12:15:00',3.28),('15128','2014-03-14','12:20:00',3.34),('15128','2014-03-14','12:25:00',3.3),('15128','2014-03-14','12:30:00',3.34),('15128','2014-03-14','12:35:00',3.34),('15128','2014-03-14','12:40:00',3.4),('15128','2014-03-14','12:45:00',3.41),('15128','2014-03-14','12:50:00',3.41),('15128','2014-03-14','12:55:00',3.39),('15128','2014-03-14','13:00:00',3.37),('15128','2014-03-14','13:05:00',3.39),('15128','2014-03-14','13:10:00',3.39),('15128','2014-03-14','13:15:00',3.39),('15128','2014-03-14','13:20:00',3.4),('15128','2014-03-14','13:25:00',3.41),('15128','2014-03-14','13:30:00',3.42),('15128','2014-03-14','13:35:00',3.44),('15128','2014-03-14','13:40:00',3.41),('15128','2014-03-14','13:45:00',3.39),('15128','2014-03-14','13:50:00',3.39),('15128','2014-03-14','13:55:00',3.33),('15128','2014-03-14','14:00:00',3.26),('15128','2014-03-14','14:05:00',3.25),('15128','2014-03-14','14:10:00',3.22),('15128','2014-03-14','14:15:00',3.2),('15128','2014-03-14','14:20:00',3.18),('15128','2014-03-14','14:25:00',3.14),('15128','2014-03-14','14:30:00',3.1),('15128','2014-03-14','14:35:00',3.05),('15128','2014-03-14','14:40:00',2.97),('15128','2014-03-14','14:45:00',2.97),('15128','2014-03-14','14:50:00',2.93),('15128','2014-03-14','14:55:00',2.88),('15128','2014-03-14','15:00:00',2.78),('15128','2014-03-14','15:05:00',2.78),('15128','2014-03-14','15:10:00',2.72),('15128','2014-03-14','15:15:00',2.62),('15128','2014-03-14','15:20:00',2.6),('15128','2014-03-14','15:25:00',2.53),('15128','2014-03-14','15:30:00',2.44),('15128','2014-03-14','15:35:00',2.38),('15128','2014-03-14','15:40:00',2.31),('15128','2014-03-14','15:45:00',2.18),('15128','2014-03-14','15:50:00',2.01),('15128','2014-03-14','15:55:00',1.92),('15128','2014-03-14','16:00:00',1.77),('15128','2014-03-14','16:05:00',1.68),('15128','2014-03-14','16:10:00',1.59),('15128','2014-03-14','16:15:00',1.5),('15128','2014-03-14','16:20:00',1.44),('15128','2014-03-14','16:25:00',1.39),('15128','2014-03-14','16:30:00',1.3),('15128','2014-03-14','16:35:00',1.24),('15128','2014-03-14','16:40:00',1.18),('15128','2014-03-14','16:45:00',1.1),('15128','2014-03-13','09:10:00',1.1),('15128','2014-03-13','09:15:00',1.35),('15128','2014-03-13','09:20:00',1.63),('15128','2014-03-13','09:25:00',1.71),('15128','2014-03-13','09:30:00',1.57),('15128','2014-03-13','09:35:00',1.63),('15128','2014-03-13','09:40:00',1.63),('15128','2014-03-13','09:45:00',1.79),('15128','2014-03-13','09:50:00',2.02),('15128','2014-03-13','09:55:00',2.16),('15128','2014-03-13','10:00:00',2.39),('15128','2014-03-13','10:05:00',2.43),('15128','2014-03-13','10:10:00',2.55),('15128','2014-03-13','10:15:00',2.58),('15128','2014-03-13','10:20:00',2.57),('15128','2014-03-13','10:25:00',2.53),('15128','2014-03-13','10:30:00',2.59),('15128','2014-03-13','10:35:00',2.53),('15128','2014-03-13','10:40:00',2.56),('15128','2014-03-13','10:45:00',2.7),('15128','2014-03-13','10:50:00',2.7),('15128','2014-03-13','10:55:00',2.35),('15128','2014-03-13','11:00:00',1.94),('15128','2014-03-13','11:05:00',2.74),('15128','2014-03-13','11:10:00',2.85),('15128','2014-03-13','11:15:00',3.16),('15128','2014-03-13','11:20:00',3.31),('15128','2014-03-13','11:25:00',3.35),('15128','2014-03-13','11:30:00',3.24),('15128','2014-03-13','11:35:00',3.21),('15128','2014-03-13','11:40:00',3.18),('15128','2014-03-13','11:45:00',3.08),('15128','2014-03-13','11:50:00',3.04),('15128','2014-03-13','11:55:00',3.23),('15128','2014-03-13','12:00:00',3.18),('15128','2014-03-13','12:05:00',3.21),('15128','2014-03-13','12:10:00',3.32),('15128','2014-03-13','12:15:00',3.28),('15128','2014-03-13','12:20:00',3.19),('15128','2014-03-13','12:25:00',3.15),('15128','2014-03-13','12:30:00',3.06),('15128','2014-03-13','12:35:00',3.02),('15128','2014-03-13','12:40:00',2.38),('15128','2014-03-13','12:45:00',2.11),('15128','2014-03-13','12:50:00',1.82),('15128','2014-03-13','12:55:00',1.93),('15128','2014-03-13','13:00:00',2.16),('15128','2014-03-13','13:05:00',1.92),('15128','2014-03-13','13:10:00',1.54),('15128','2014-03-13','13:15:00',1.79),('15128','2014-03-13','13:20:00',2.45),('15128','2014-03-13','13:25:00',2.42),('15128','2014-03-13','13:30:00',2.35),('15128','2014-03-13','13:35:00',2.58),('15128','2014-03-13','13:40:00',2.62),('15128','2014-03-13','13:45:00',1.97),('15128','2014-03-13','13:50:00',1.97),('15128','2014-03-13','13:55:00',2.08),('15128','2014-03-13','14:00:00',2.25),('15128','2014-03-13','14:05:00',2.32),('15128','2014-03-13','14:10:00',2.19),('15128','2014-03-13','14:15:00',2.25),('15128','2014-03-13','14:20:00',2.34),('15128','2014-03-13','14:25:00',2.26),('15128','2014-03-13','14:30:00',2.65),('15128','2014-03-13','14:35:00',2.69),('15128','2014-03-13','14:40:00',2.79),('15128','2014-03-13','14:45:00',2.41),('15128','2014-03-13','14:50:00',1.87),('15128','2014-03-13','14:55:00',1.67),('15128','2014-03-13','15:00:00',1.52),('15128','2014-03-13','15:05:00',1.37),('15128','2014-03-13','15:10:00',1.28),('15128','2014-03-13','15:15:00',1.23),('15128','2014-03-13','15:20:00',1.16),('15128','2014-03-13','15:25:00',1.16),('15128','2014-03-13','15:30:00',1.22),('15128','2014-03-13','15:35:00',1.39),('15128','2014-03-13','15:40:00',1.33),('15128','2014-03-13','15:45:00',1.55),('15128','2014-03-13','15:50:00',1.6),('15128','2014-03-13','15:55:00',1.27),('15128','2014-03-13','16:00:00',1.16),('15128','2014-03-13','16:05:00',1.06),('15128','2014-03-12','08:35:00',1.06),('15128','2014-03-12','08:40:00',1.16),('15128','2014-03-12','08:45:00',1.23),('15128','2014-03-12','08:50:00',1.31),('15128','2014-03-12','08:55:00',1.37),('15128','2014-03-12','09:00:00',1.44),('15128','2014-03-12','09:05:00',1.48),('15128','2014-03-12','09:10:00',1.54),('15128','2014-03-12','09:15:00',1.61),('15128','2014-03-12','09:20:00',1.69),('15128','2014-03-12','09:25:00',1.74),('15128','2014-03-12','09:30:00',1.78),('15128','2014-03-12','09:35:00',1.82),('15128','2014-03-12','09:40:00',1.89),('15128','2014-03-12','09:45:00',1.93),('15128','2014-03-12','09:50:00',1.94),('15128','2014-03-12','09:55:00',2.03),('15128','2014-03-12','10:00:00',2.09),('15128','2014-03-12','10:05:00',2.18),('15128','2014-03-12','10:10:00',2.24),('15128','2014-03-12','10:15:00',2.29),('15128','2014-03-12','10:20:00',2.38),('15128','2014-03-12','10:25:00',2.35),('15128','2014-03-12','10:30:00',2.44),('15128','2014-03-12','10:35:00',2.5),('15128','2014-03-12','10:40:00',2.6),('15128','2014-03-12','10:45:00',2.59),('15128','2014-03-12','10:50:00',2.64),('15128','2014-03-12','10:55:00',2.71),('15128','2014-03-12','11:00:00',2.79),('15128','2014-03-12','11:05:00',2.88),('15128','2014-03-12','11:10:00',2.94),('15128','2014-03-12','11:15:00',3.02),('15128','2014-03-12','11:20:00',3.11),('15128','2014-03-12','11:25:00',3.15),('15128','2014-03-12','11:30:00',3.17),('15128','2014-03-12','11:35:00',3.22),('15128','2014-03-12','11:40:00',3.28),('15128','2014-03-12','11:45:00',3.33),('15128','2014-03-12','11:50:00',3.36),('15128','2014-03-12','11:55:00',3.4),('15128','2014-03-12','12:00:00',3.44),('15128','2014-03-12','12:05:00',3.44),('15128','2014-03-12','12:10:00',3.45),('15128','2014-03-12','12:15:00',3.47),('15128','2014-03-12','12:20:00',3.47),('15128','2014-03-12','12:25:00',3.47),('15128','2014-03-12','12:30:00',3.47),('15128','2014-03-12','12:35:00',3.47),('15128','2014-03-12','12:40:00',3.48),('15128','2014-03-12','12:45:00',3.47),('15128','2014-03-12','12:50:00',3.44),('15128','2014-03-12','12:55:00',3.47),('15128','2014-03-12','13:00:00',3.49),('15128','2014-03-12','13:05:00',3.48),('15128','2014-03-12','13:10:00',3.51),('15128','2014-03-12','13:15:00',3.53),('15128','2014-03-12','13:20:00',3.55),('15128','2014-03-12','13:25:00',3.51),('15128','2014-03-12','13:30:00',3.51),('15128','2014-03-12','13:35:00',3.49),('15128','2014-03-12','13:40:00',3.49),('15128','2014-03-12','13:45:00',3.47),('15128','2014-03-12','13:50:00',3.43),('15128','2014-03-12','13:55:00',3.4),('15128','2014-03-12','14:00:00',3.36),('15128','2014-03-12','14:05:00',3.32),('15128','2014-03-12','14:10:00',3.3),('15128','2014-03-12','14:15:00',3.27),('15128','2014-03-12','14:20:00',3.23),('15128','2014-03-12','14:25:00',3.19),('15128','2014-03-12','14:30:00',3.16),('15128','2014-03-12','14:35:00',3.12),('15128','2014-03-12','14:40:00',3.07),('15128','2014-03-12','14:45:00',3.02),('15128','2014-03-12','14:50:00',2.96),('15128','2014-03-12','14:55:00',2.9),('15128','2014-03-12','15:00:00',2.84),('15128','2014-03-12','15:05:00',2.77),('15128','2014-03-12','15:10:00',2.69),('15128','2014-03-12','15:15:00',2.62),('15128','2014-03-12','15:20:00',2.57),('15128','2014-03-12','15:25:00',2.5),('15128','2014-03-12','15:30:00',2.43),('15128','2014-03-12','15:35:00',2.37),('15128','2014-03-12','15:40:00',2.31),('15128','2014-03-12','15:45:00',2.22),('15128','2014-03-12','15:50:00',2.13),('15128','2014-03-12','15:55:00',2.02),('15128','2014-03-12','16:00:00',1.91),('15128','2014-03-12','16:05:00',1.79),('15128','2014-03-12','16:10:00',1.66),('15128','2014-03-12','16:15:00',1.51),('15128','2014-03-12','16:20:00',1.49),('15128','2014-03-12','16:25:00',1.47),('15128','2014-03-12','16:30:00',1.39),('15128','2014-03-12','16:35:00',1.36),('15128','2014-03-12','16:40:00',1.28),('15128','2014-03-12','16:45:00',1.23),('15128','2014-03-12','16:50:00',1.15),('15128','2014-03-12','16:55:00',1.03),('15128','2014-03-11','08:40:00',1.1),('15128','2014-03-11','08:45:00',1.18),('15128','2014-03-11','08:50:00',1.26),('15128','2014-03-11','08:55:00',1.33),('15128','2014-03-11','09:00:00',1.39),('15128','2014-03-11','09:05:00',1.44),('15128','2014-03-11','09:10:00',1.5),('15128','2014-03-11','09:15:00',1.58),('15128','2014-03-11','09:20:00',1.64),('15128','2014-03-11','09:25:00',1.69),('15128','2014-03-11','09:30:00',1.75),('15128','2014-03-11','09:35:00',1.8),('15128','2014-03-11','09:40:00',1.85),('15128','2014-03-11','09:45:00',1.89),('15128','2014-03-11','09:50:00',1.9),('15128','2014-03-11','09:55:00',2.02),('15128','2014-03-11','10:00:00',2.05),('15128','2014-03-11','10:05:00',2.14),('15128','2014-03-11','10:10:00',2.19),('15128','2014-03-11','10:15:00',2.25),('15128','2014-03-11','10:20:00',2.33),('15128','2014-03-11','10:25:00',2.35),('15128','2014-03-11','10:30:00',2.44),('15128','2014-03-11','10:35:00',2.49),('15128','2014-03-11','10:40:00',2.55),('15128','2014-03-11','10:45:00',2.61),('15128','2014-03-11','10:50:00',2.69),('15128','2014-03-11','10:55:00',2.72),('15128','2014-03-11','11:00:00',2.75),('15128','2014-03-11','11:05:00',2.8),('15128','2014-03-11','11:10:00',2.98),('15128','2014-03-11','11:15:00',3.07),('15128','2014-03-11','11:20:00',3.13),('15128','2014-03-11','11:25:00',3.15),('15128','2014-03-11','11:30:00',3.19),('15128','2014-03-11','11:35:00',3.21),('15128','2014-03-11','11:40:00',3.27),('15128','2014-03-11','11:45:00',3.31),('15128','2014-03-11','11:50:00',3.35),('15128','2014-03-11','11:55:00',3.38),('15128','2014-03-11','12:00:00',3.41),('15128','2014-03-11','12:05:00',3.41),('15128','2014-03-11','12:10:00',3.42),('15128','2014-03-11','12:15:00',3.46),('15128','2014-03-11','12:20:00',3.48),('15128','2014-03-11','12:25:00',3.5),('15128','2014-03-11','12:30:00',3.53),('15128','2014-03-11','12:35:00',3.52),('15128','2014-03-11','12:40:00',3.5),('15128','2014-03-11','12:45:00',3.48),('15128','2014-03-11','12:50:00',3.53),('15128','2014-03-11','12:55:00',3.49),('15128','2014-03-11','13:00:00',3.49),('15128','2014-03-11','13:05:00',3.52),('15128','2014-03-11','13:10:00',3.49),('15128','2014-03-11','13:15:00',3.47),('15128','2014-03-11','13:20:00',3.49),('15128','2014-03-11','13:25:00',3.47),('15128','2014-03-11','13:30:00',3.44),('15128','2014-03-11','13:35:00',3.44),('15128','2014-03-11','13:40:00',3.44),('15128','2014-03-11','13:45:00',3.4),('15128','2014-03-11','13:50:00',3.36),('15128','2014-03-11','13:55:00',3.36),('15128','2014-03-11','14:00:00',3.33),('15128','2014-03-11','14:05:00',3.35),('15128','2014-03-11','14:10:00',3.31),('15128','2014-03-11','14:15:00',3.23),('15128','2014-03-11','14:20:00',3.25),('15128','2014-03-11','14:25:00',3.27),('15128','2014-03-11','14:30:00',3.18),('15128','2014-03-11','14:35:00',3.19),('15128','2014-03-11','14:40:00',3.17),('15128','2014-03-11','14:45:00',3.01),('15128','2014-03-11','14:50:00',3.02),('15128','2014-03-11','14:55:00',2.99),('15128','2014-03-11','15:00:00',2.84),('15128','2014-03-11','15:05:00',2.68),('15128','2014-03-11','15:10:00',2.74),('15128','2014-03-11','15:15:00',2.7),('15128','2014-03-11','15:20:00',2.62),('15128','2014-03-11','15:25:00',2.51),('15128','2014-03-11','15:30:00',2.45),('15128','2014-03-11','15:35:00',2.39),('15128','2014-03-11','15:40:00',2.35),('15128','2014-03-11','15:45:00',2.27),('15128','2014-03-11','15:50:00',2.12),('15128','2014-03-11','15:55:00',2.03),('15128','2014-03-11','16:00:00',1.9),('15128','2014-03-11','16:05:00',1.79),('15128','2014-03-11','16:10:00',1.73),('15128','2014-03-11','16:15:00',1.65),('15128','2014-03-11','16:20:00',1.54),('15128','2014-03-11','16:25:00',1.49),('15128','2014-03-11','16:30:00',1.39),('15128','2014-03-11','16:35:00',1.33),('15128','2014-03-11','16:40:00',1.28),('15128','2014-03-11','16:45:00',1.2),('15128','2014-03-11','16:50:00',1.1),('15128','2014-03-10','11:55:00',1.2),('15128','2014-03-10','12:00:00',1.29),('15128','2014-03-10','12:05:00',1.37),('15128','2014-03-10','12:10:00',1.57),('15128','2014-03-10','12:15:00',1.84),('15128','2014-03-10','12:20:00',1.9),('15128','2014-03-10','12:25:00',1.62),('15128','2014-03-10','12:30:00',1.56),('15128','2014-03-10','12:35:00',1.5),('15128','2014-03-10','12:40:00',1.41),('15128','2014-03-10','12:45:00',1.48),('15128','2014-03-10','12:50:00',1.61),('15128','2014-03-10','12:55:00',1.72),('15128','2014-03-10','13:00:00',2.15),('15128','2014-03-10','13:05:00',1.94),('15128','2014-03-10','13:10:00',2.05),('15128','2014-03-10','13:15:00',1.61),('15128','2014-03-10','13:20:00',1.54),('15128','2014-03-10','13:25:00',1.48),('15128','2014-03-10','13:30:00',1.3),('15128','2014-03-10','13:35:00',1.34),('15128','2014-03-10','13:40:00',1.48),('15128','2014-03-10','13:45:00',1.84),('15128','2014-03-10','13:50:00',2.61),('15128','2014-03-10','13:55:00',2.4),('15128','2014-03-10','14:00:00',2.26),('15128','2014-03-10','14:05:00',2.02),('15128','2014-03-10','14:10:00',1.87),('15128','2014-03-10','14:15:00',2.12),('15128','2014-03-10','14:20:00',2.29),('15128','2014-03-10','14:25:00',2.19),('15128','2014-03-10','14:30:00',2.11),('15128','2014-03-10','14:35:00',1.83),('15128','2014-03-10','14:40:00',1.87),('15128','2014-03-10','14:45:00',1.88),('15128','2014-03-10','14:50:00',1.6),('15128','2014-03-10','14:55:00',1.63),('15128','2014-03-10','15:00:00',2.02),('15128','2014-03-10','15:05:00',1.66),('15128','2014-03-10','15:10:00',1.47),('15128','2014-03-10','15:15:00',1.43),('15128','2014-03-10','15:20:00',1.09),('15128','2014-03-09','08:55:00',1.04),('15128','2014-03-09','09:00:00',1.08),('15128','2014-03-09','09:05:00',1.08),('15128','2014-03-09','09:25:00',1.05),('15128','2014-03-09','09:30:00',1.06),('15128','2014-03-09','09:35:00',1.15),('15128','2014-03-09','09:40:00',1.34),('15128','2014-03-09','09:45:00',1.51),('15128','2014-03-09','09:50:00',1.46),('15128','2014-03-09','09:55:00',1.2),('15128','2014-03-09','13:00:00',1.02),('15128','2014-03-09','13:05:00',1.09),('15128','2014-03-09','13:10:00',1.24),('15128','2014-03-09','13:15:00',1.15),('15128','2014-03-09','14:45:00',1.02),('15128','2014-03-09','14:50:00',1.07),('15128','2014-03-09','15:00:00',1.01),('15128','2014-03-09','15:05:00',1.76),('15128','2014-03-09','15:10:00',2.96),('15128','2014-03-09','15:15:00',3.09),('15128','2014-03-09','15:20:00',2.89),('15128','2014-03-09','15:25:00',2.15),('15128','2014-03-09','15:30:00',1.97),('15128','2014-03-09','15:35:00',1.75),('15128','2014-03-09','15:40:00',1.03),('15128','2014-03-09','15:50:00',1.07),('15128','2014-03-09','16:30:00',1.36),('15128','2014-03-09','16:35:00',1.59),('15128','2014-03-09','16:40:00',1.53),('15128','2014-03-09','16:45:00',1.14),('15128','2014-03-08','08:40:00',1.04),('15128','2014-03-08','08:45:00',1.14),('15128','2014-03-08','08:50:00',1.22),('15128','2014-03-08','08:55:00',1.29),('15128','2014-03-08','09:00:00',1.36),('15128','2014-03-08','09:05:00',1.43),('15128','2014-03-08','09:10:00',1.46),('15128','2014-03-08','09:15:00',1.55),('15128','2014-03-08','09:20:00',1.63),('15128','2014-03-08','09:25:00',1.71),('15128','2014-03-08','09:30:00',1.5),('15128','2014-03-08','09:40:00',1.25),('15128','2014-03-08','09:45:00',2.13),('15128','2014-03-08','09:50:00',2.22),('15128','2014-03-08','09:55:00',2.26),('15128','2014-03-08','10:00:00',2.29),('15128','2014-03-08','10:05:00',2.32),('15128','2014-03-08','10:10:00',2.38),('15128','2014-03-08','10:15:00',2.41),('15128','2014-03-08','10:20:00',2.43),('15128','2014-03-08','10:25:00',2.49),('15128','2014-03-08','10:30:00',2.48),('15128','2014-03-08','10:35:00',2.6),('15128','2014-03-08','10:40:00',2.62),('15128','2014-03-08','10:45:00',2.71),('15128','2014-03-08','10:50:00',2.71),('15128','2014-03-08','10:55:00',2.34),('15128','2014-03-08','11:00:00',3),('15128','2014-03-08','11:05:00',3.1),('15128','2014-03-08','11:10:00',3.22),('15128','2014-03-08','11:15:00',3.34),('15128','2014-03-08','11:20:00',1.84),('15128','2014-03-08','11:35:00',1.78),('15128','2014-03-08','11:40:00',3.87),('15128','2014-03-08','11:45:00',3.85),('15128','2014-03-08','11:50:00',3.37),('15128','2014-03-08','11:55:00',1.32),('15128','2014-03-08','12:00:00',1.75),('15128','2014-03-08','12:05:00',4.24),('15128','2014-03-08','12:10:00',4.1),('15128','2014-03-08','12:15:00',3.92),('15128','2014-03-08','12:20:00',4.03),('15128','2014-03-08','12:25:00',4.01),('15128','2014-03-08','12:30:00',3.92),('15128','2014-03-08','12:35:00',3.98),('15128','2014-03-08','12:40:00',3.95),('15128','2014-03-08','12:45:00',3.82),('15128','2014-03-08','12:50:00',3.78),('15128','2014-03-08','12:55:00',3.7),('15128','2014-03-08','13:00:00',3.79),('15128','2014-03-08','13:05:00',3.88),('15128','2014-03-08','13:10:00',3.33),('15128','2014-03-08','13:15:00',2.04),('15128','2014-03-08','13:20:00',4.01),('15128','2014-03-08','13:25:00',3.58),('15128','2014-03-08','13:30:00',1.11),('15128','2014-03-08','13:40:00',1.33),('15128','2014-03-08','13:45:00',1.12),('15128','2014-03-08','13:50:00',2.61),('15128','2014-03-08','13:55:00',1.42),('15128','2014-03-08','14:00:00',1.15),('15128','2014-03-08','14:05:00',1.73),('15128','2014-03-08','14:10:00',2.41),('15128','2014-03-08','14:15:00',3.15),('15128','2014-03-08','14:20:00',3.4),('15128','2014-03-08','14:25:00',3.36),('15128','2014-03-08','14:30:00',3.3),('15128','2014-03-08','14:35:00',3.3),('15128','2014-03-08','14:40:00',3.25),('15128','2014-03-08','14:45:00',3.1),('15128','2014-03-08','14:50:00',3.12),('15128','2014-03-08','14:55:00',3.08),('15128','2014-03-08','15:00:00',3.21),('15128','2014-03-08','15:05:00',3.33),('15128','2014-03-08','15:10:00',3.31),('15128','2014-03-08','15:15:00',3.09),('15128','2014-03-08','15:20:00',2.04),('15128','2014-03-08','15:50:00',2.26),('15128','2014-03-08','15:55:00',1.51),('15128','2014-03-08','16:10:00',1.39),('15128','2014-03-08','16:20:00',1.18),('15128','2014-03-08','16:25:00',1.63),('15128','2014-03-08','16:30:00',1.57),('15128','2014-03-08','16:35:00',1.42),('15128','2014-03-08','16:40:00',1.33),('15128','2014-03-08','16:45:00',1.26),('15128','2014-03-08','16:50:00',1.14),('15128','2014-03-08','16:55:00',1.04),('15128','2014-03-07','08:45:00',1.06),('15128','2014-03-07','08:50:00',1.17),('15128','2014-03-07','08:55:00',1.26),('15128','2014-03-07','09:00:00',1.32),('15128','2014-03-07','09:05:00',1.38),('15128','2014-03-07','09:10:00',1.43),('15128','2014-03-07','09:15:00',1.49),('15128','2014-03-07','09:20:00',1.56),('15128','2014-03-07','09:25:00',1.63),('15128','2014-03-07','09:30:00',1.68),('15128','2014-03-07','09:35:00',1.73),('15128','2014-03-07','09:40:00',1.78),('15128','2014-03-07','09:45:00',1.82),('15128','2014-03-07','09:50:00',1.87),('15128','2014-03-07','09:55:00',1.96),('15128','2014-03-07','10:00:00',1.97),('15128','2014-03-07','10:05:00',1.98),('15128','2014-03-07','10:10:00',2.11),('15128','2014-03-07','10:15:00',2.2),('15128','2014-03-07','10:20:00',2.25),('15128','2014-03-07','10:25:00',2.33),('15128','2014-03-07','10:30:00',2.38),('15128','2014-03-07','10:35:00',2.48),('15128','2014-03-07','10:40:00',2.41),('15128','2014-03-07','10:45:00',2.15),('15128','2014-03-07','10:50:00',2.72),('15128','2014-03-07','10:55:00',2.77),('15128','2014-03-07','11:00:00',2.78),('15128','2014-03-07','11:05:00',2.87),('15128','2014-03-07','11:10:00',3),('15128','2014-03-07','11:15:00',3.2),('15128','2014-03-07','11:20:00',3.27),('15128','2014-03-07','11:25:00',2.71),('15128','2014-03-07','11:30:00',3.6),('15128','2014-03-07','11:35:00',3.87),('15128','2014-03-07','11:40:00',2.44),('15128','2014-03-07','11:45:00',4.02),('15128','2014-03-07','11:50:00',4.36),('15128','2014-03-07','11:55:00',4.46),('15128','2014-03-07','12:00:00',4.42),('15128','2014-03-07','12:05:00',3.4),('15128','2014-03-07','12:10:00',3.83),('15128','2014-03-07','12:15:00',3.37),('15128','2014-03-07','12:20:00',2.35),('15128','2014-03-07','12:25:00',3.05),('15128','2014-03-07','12:30:00',2.84),('15128','2014-03-07','12:35:00',1.93),('15128','2014-03-07','12:40:00',1.91),('15128','2014-03-07','12:45:00',1.85),('15128','2014-03-07','12:50:00',1.81),('15128','2014-03-07','12:55:00',1.69),('15128','2014-03-07','13:00:00',1.94),('15128','2014-03-07','13:05:00',2.63),('15128','2014-03-07','13:10:00',1.84),('15128','2014-03-07','13:15:00',1.62),('15128','2014-03-07','13:20:00',1.42),('15128','2014-03-07','13:25:00',1.14),('15128','2014-03-07','13:30:00',1.09),('15128','2014-03-07','13:35:00',1.09),('15128','2014-03-07','13:40:00',1.3),('15128','2014-03-07','13:45:00',2.28),('15128','2014-03-07','13:50:00',1.83),('15128','2014-03-07','13:55:00',2.14),('15128','2014-03-07','14:00:00',1.59),('15128','2014-03-07','14:05:00',1.38),('15128','2014-03-07','14:10:00',1.08),('15128','2014-03-07','15:05:00',1.15),('15128','2014-03-07','15:10:00',1.03),('15128','2014-03-07','15:20:00',1.02),('15128','2014-03-07','15:25:00',1.54),('15128','2014-03-07','15:30:00',1.14),('15128','2014-03-07','16:45:00',1.45),('15128','2014-03-07','16:50:00',1.28),('15128','2014-03-07','16:55:00',1.13),('15128','2014-04-29','08:20:00',1),('15128','2014-04-29','08:25:00',1.07),('15128','2014-04-29','08:30:00',1.15),('15128','2014-04-29','08:35:00',1.19),('15128','2014-04-29','08:40:00',1.27),('15128','2014-04-29','08:45:00',1.34),('15128','2014-04-29','08:50:00',1.41),('15128','2014-04-29','08:55:00',1.44),('15128','2014-04-29','09:00:00',1.54),('15128','2014-04-29','09:05:00',1.6),('15128','2014-04-29','09:10:00',1.65),('15128','2014-04-29','09:15:00',1.72),('15128','2014-04-29','09:20:00',1.8),('15128','2014-04-29','09:25:00',1.87),('15128','2014-04-29','09:30:00',1.93),('15128','2014-04-29','09:35:00',1.8),('15128','2014-04-29','09:40:00',2.06),('15128','2014-04-29','09:45:00',2.02),('15128','2014-04-29','09:50:00',1.53),('15128','2014-04-29','09:55:00',2.38),('15128','2014-04-29','10:00:00',2.16),('15128','2014-04-29','10:05:00',2.4),('15128','2014-04-29','10:10:00',2.65),('15128','2014-04-29','10:15:00',2.11),('15128','2014-04-29','10:20:00',1.82),('15128','2014-04-29','10:25:00',2.63),('15128','2014-04-29','10:30:00',1.61),('15128','2014-04-29','10:35:00',1.34),('15128','2014-04-29','10:40:00',1.35),('15128','2014-04-29','10:45:00',2.72),('15128','2014-04-29','10:50:00',1.25),('15128','2014-04-29','10:55:00',1.99),('15128','2014-04-29','11:00:00',1.82),('15128','2014-04-29','11:05:00',1.58),('15128','2014-04-29','11:10:00',1.78),('15128','2014-04-29','11:15:00',2.09),('15128','2014-04-29','11:20:00',3.41),('15128','2014-04-29','11:25:00',3.66),('15128','2014-04-29','11:30:00',3.83),('15128','2014-04-29','11:35:00',3.1),('15128','2014-04-29','11:40:00',3.13),('15128','2014-04-29','11:45:00',3.17),('15128','2014-04-29','11:50:00',3.16),('15128','2014-04-29','11:55:00',2.26),('15128','2014-04-29','12:00:00',4.29),('15128','2014-04-29','12:05:00',2.01),('15128','2014-04-29','12:10:00',2.16),('15128','2014-04-29','12:15:00',3.51),('15128','2014-04-29','12:20:00',3.97),('15128','2014-04-29','12:25:00',3.27),('15128','2014-04-29','12:30:00',2.18),('15128','2014-04-29','12:35:00',3.57),('15128','2014-04-29','12:40:00',4.67),('15128','2014-04-29','12:45:00',4.01),('15128','2014-04-29','12:50:00',2.46),('15128','2014-04-29','12:55:00',3.49),('15128','2014-04-29','13:00:00',3.69),('15128','2014-04-29','13:05:00',1.04),('15128','2014-04-29','13:10:00',4.41),('15128','2014-04-29','13:15:00',2.15),('15128','2014-04-29','13:20:00',1.82),('15128','2014-04-29','13:25:00',3.01),('15128','2014-04-29','13:30:00',1.42),('15128','2014-04-29','13:35:00',2.25),('15128','2014-04-29','13:40:00',4.64),('15128','2014-04-29','13:45:00',2.12),('15128','2014-04-29','13:50:00',1.58),('15128','2014-04-29','13:55:00',2.04),('15128','2014-04-29','14:00:00',2.1),('15128','2014-04-29','14:05:00',1.93),('15128','2014-04-29','14:10:00',1.27),('15128','2014-04-29','14:15:00',1.61),('15128','2014-04-29','14:20:00',1.51),('15128','2014-04-29','14:25:00',1.78),('15128','2014-04-29','14:30:00',1.23),('15128','2014-04-29','14:35:00',1.42),('15128','2014-04-29','14:40:00',1.46),('15128','2014-04-29','14:45:00',1.86),('15128','2014-04-29','14:50:00',1.73),('15128','2014-04-29','14:55:00',1.52),('15128','2014-04-29','15:00:00',1.5),('15128','2014-04-29','15:05:00',1.76),('15128','2014-04-29','15:10:00',2.44),('15128','2014-04-29','15:15:00',1.22),('15128','2014-04-29','15:20:00',1.49),('15128','2014-04-29','15:25:00',2.18),('15128','2014-04-29','15:30:00',2.29),('15128','2014-04-29','15:35:00',3.71),('15128','2014-04-29','15:40:00',3.97),('15128','2014-04-29','15:45:00',4.3),('15128','2014-04-29','15:50:00',4.05),('15128','2014-04-29','15:55:00',2),('15128','2014-04-29','16:00:00',1.71),('15128','2014-04-29','16:05:00',2.77),('15128','2014-04-29','16:10:00',2.36),('15128','2014-04-29','16:15:00',4.15),('15128','2014-04-29','16:20:00',2.73),('15128','2014-04-29','16:25:00',1.83),('15128','2014-04-29','16:30:00',3.42),('15128','2014-04-29','16:35:00',3.54),('15128','2014-04-29','16:40:00',3.57),('15128','2014-04-29','16:45:00',2.71),('15128','2014-04-29','16:50:00',2.34),('15128','2014-04-29','16:55:00',2.16),('15128','2014-04-29','17:00:00',2.36),('15128','2014-04-29','17:10:00',2),('15128','2014-04-29','17:15:00',1.63),('15128','2014-04-29','17:25:00',1.06),('15128','2014-04-29','17:30:00',1.38),('15128','2014-04-29','17:35:00',1.37),('15128','2014-04-29','17:40:00',1.3),('15128','2014-03-06','10:15:00',1.11),('15128','2014-03-06','10:20:00',1.46),('15128','2014-03-06','10:25:00',2.76),('15128','2014-03-06','10:30:00',2.01),('15128','2014-03-06','10:35:00',1.42),('15128','2014-03-06','10:45:00',2.22),('15128','2014-03-06','10:50:00',3.47),('15128','2014-03-06','10:55:00',3.43),('15128','2014-03-06','11:00:00',1.97),('15128','2014-03-06','11:10:00',1.08),('15128','2014-03-06','11:15:00',1.26),('15128','2014-03-06','11:20:00',3.7),('15128','2014-03-06','11:25:00',2.6),('15128','2014-03-06','11:30:00',3.64),('15128','2014-03-06','11:35:00',4.06),('15128','2014-03-06','11:40:00',4.01),('15128','2014-03-06','11:45:00',4.06),('15128','2014-03-06','11:50:00',4.07),('15128','2014-03-06','11:55:00',3.94),('15128','2014-03-06','12:00:00',3.99),('15128','2014-03-06','12:05:00',4),('15128','2014-03-06','12:10:00',3.6),('15128','2014-03-06','12:15:00',3.59),('15128','2014-03-06','12:20:00',3.32),('15128','2014-03-06','12:25:00',3.32),('15128','2014-03-06','12:30:00',3.33),('15128','2014-03-06','12:35:00',3.63),('15128','2014-03-06','12:40:00',3.5),('15128','2014-03-06','12:45:00',3.7),('15128','2014-03-06','12:50:00',3.71),('15128','2014-03-06','12:55:00',3.86),('15128','2014-03-06','13:00:00',3.88),('15128','2014-03-06','13:05:00',3.64),('15128','2014-03-06','13:10:00',2.7),('15128','2014-03-06','13:15:00',3.19),('15128','2014-03-06','13:20:00',3.38),('15128','2014-03-06','13:25:00',1.93),('15128','2014-03-06','13:30:00',2.18),('15128','2014-03-06','13:35:00',2.09),('15128','2014-03-06','13:40:00',1.87),('15128','2014-03-06','13:45:00',2.09),('15128','2014-03-06','13:50:00',1.85),('15128','2014-03-06','13:55:00',1.54),('15128','2014-03-06','14:00:00',1.39),('15128','2014-03-06','14:05:00',1.33),('15128','2014-03-06','14:10:00',1.27),('15128','2014-03-06','14:15:00',1.23),('15128','2014-03-06','14:20:00',1.26),('15128','2014-03-06','14:25:00',1.29),('15128','2014-03-06','14:30:00',1.34),('15128','2014-03-06','14:35:00',1.41),('15128','2014-03-06','14:40:00',1.47),('15128','2014-03-06','14:45:00',1.69),('15128','2014-03-06','14:50:00',2.06),('15128','2014-03-06','14:55:00',2.27),('15128','2014-03-06','15:00:00',2.54),('15128','2014-03-06','15:05:00',2.8),('15128','2014-03-06','15:10:00',2.83),('15128','2014-03-06','15:15:00',2.82),('15128','2014-03-06','15:20:00',2.01),('15128','2014-03-06','15:25:00',1.67),('15128','2014-03-06','15:30:00',2.27),('15128','2014-03-06','15:35:00',1.52),('15128','2014-03-06','15:40:00',1.69),('15128','2014-03-06','15:45:00',2.43),('15128','2014-03-06','15:50:00',1.9),('15128','2014-03-06','15:55:00',1.12),('15128','2014-03-06','16:00:00',1.89),('15128','2014-03-06','16:05:00',2.02),('15128','2014-03-06','16:10:00',1.87),('15128','2014-03-06','16:15:00',1.12),('15128','2014-03-06','16:25:00',1.26),('15128','2014-03-06','16:35:00',1.44),('15128','2014-03-06','16:40:00',1.4),('15128','2014-03-06','16:45:00',1.31),('15128','2014-03-06','16:50:00',1.2),('15128','2014-03-06','16:55:00',1.06),('15128','2014-03-05','09:05:00',1.03),('15128','2014-03-05','09:10:00',1.19),('15128','2014-03-05','09:15:00',1.4),('15128','2014-03-05','09:20:00',1.91),('15128','2014-03-05','09:25:00',1.82),('15128','2014-03-05','09:30:00',1.65),('15128','2014-03-05','09:35:00',1.44),('15128','2014-03-05','09:40:00',1.29),('15128','2014-03-05','09:45:00',1.33),('15128','2014-03-05','09:50:00',1.46),('15128','2014-03-05','09:55:00',1.56),('15128','2014-03-05','10:00:00',1.68),('15128','2014-03-05','10:05:00',1.72),('15128','2014-03-05','10:10:00',1.8),('15128','2014-03-05','10:15:00',1.9),('15128','2014-03-05','10:20:00',1.73),('15128','2014-03-05','10:25:00',2.29),('15128','2014-03-05','10:30:00',2.26),('15128','2014-03-05','10:35:00',2.69),('15128','2014-03-05','10:40:00',2.3),('15128','2014-03-05','10:45:00',2.62),('15128','2014-03-05','10:50:00',2.71),('15128','2014-03-05','10:55:00',2.89),('15128','2014-03-05','11:00:00',2.9),('15128','2014-03-05','11:05:00',3.41),('15128','2014-03-05','11:10:00',3.08),('15128','2014-03-05','11:15:00',3.26),('15128','2014-03-05','11:20:00',3.34),('15128','2014-03-05','11:25:00',3.52),('15128','2014-03-05','11:30:00',2.26),('15128','2014-03-05','11:35:00',1.42),('15128','2014-03-05','11:40:00',1.68),('15128','2014-03-05','11:45:00',1.74),('15128','2014-03-05','11:50:00',1.88),('15128','2014-03-05','11:55:00',3.34),('15128','2014-03-05','12:00:00',1.93),('15128','2014-03-05','12:05:00',1.61),('15128','2014-03-05','12:10:00',1.36),('15128','2014-03-05','12:15:00',2.28),('15128','2014-03-05','12:20:00',1.53),('15128','2014-03-05','12:25:00',1.01),('15128','2014-03-05','12:30:00',1.01),('15128','2014-03-05','12:35:00',1.09),('15128','2014-03-05','12:40:00',2.83),('15128','2014-03-05','12:45:00',4.3),('15128','2014-03-05','12:50:00',1.9),('15128','2014-03-05','12:55:00',1.64),('15128','2014-03-05','13:00:00',2.04),('15128','2014-03-05','13:05:00',1.68),('15128','2014-03-05','13:10:00',1.44),('15128','2014-03-05','13:15:00',1.48),('15128','2014-03-05','13:20:00',1.3),('15128','2014-03-05','13:25:00',1.69),('15128','2014-03-05','13:30:00',1.22),('15128','2014-03-05','13:35:00',1.14),('15128','2014-03-05','13:45:00',1.13),('15128','2014-03-05','13:50:00',1.32),('15128','2014-03-05','13:55:00',1.31),('15128','2014-03-05','14:00:00',1.34),('15128','2014-03-05','14:05:00',1.34),('15128','2014-03-05','14:10:00',1.28),('15128','2014-03-05','14:15:00',1.24),('15128','2014-03-05','14:20:00',1.33),('15128','2014-03-05','14:25:00',1.18),('15128','2014-03-05','14:30:00',1.37),('15128','2014-03-05','14:35:00',1.16),('15128','2014-03-05','14:55:00',1.09),('15128','2014-03-05','15:00:00',1.9),('15128','2014-03-05','15:05:00',1.17),('15128','2014-03-05','15:10:00',1.28),('15128','2014-03-05','15:15:00',1.29),('15128','2014-03-05','15:20:00',1.01),('15128','2014-03-05','15:25:00',1.02),('15128','2014-03-05','15:50:00',1.4),('15128','2014-03-05','17:00:00',1.01),('15128','2014-03-04','08:35:00',1),('15128','2014-03-04','08:40:00',1.33),('15128','2014-03-04','08:45:00',1.32),('15128','2014-03-04','08:50:00',1.31),('15128','2014-03-04','08:55:00',1.32),('15128','2014-03-04','09:00:00',1.38),('15128','2014-03-04','09:05:00',1.4),('15128','2014-03-04','09:10:00',1.44),('15128','2014-03-04','09:15:00',1.42),('15128','2014-03-04','09:20:00',1.34),('15128','2014-03-04','09:25:00',1.57),('15128','2014-03-04','09:30:00',1.66),('15128','2014-03-04','09:35:00',1.69),('15128','2014-03-04','09:40:00',1.76),('15128','2014-03-04','09:45:00',1.85),('15128','2014-03-04','09:50:00',1.88),('15128','2014-03-04','09:55:00',1.88),('15128','2014-03-04','10:00:00',1.97),('15128','2014-03-04','10:05:00',2.02),('15128','2014-03-04','10:10:00',2.09),('15128','2014-03-04','10:15:00',2.13),('15128','2014-03-04','10:20:00',2.21),('15128','2014-03-04','10:25:00',2.25),('15128','2014-03-04','10:30:00',2.37),('15128','2014-03-04','10:35:00',2.4),('15128','2014-03-04','10:40:00',2.48),('15128','2014-03-04','10:45:00',2.45),('15128','2014-03-04','10:50:00',2.6),('15128','2014-03-04','10:55:00',2.66),('15128','2014-03-04','11:00:00',2.67),('15128','2014-03-04','11:05:00',2.75),('15128','2014-03-04','11:10:00',2.86),('15128','2014-03-04','11:15:00',3.06),('15128','2014-03-04','11:20:00',3.14),('15128','2014-03-04','11:25:00',3.26),('15128','2014-03-04','11:30:00',3.31),('15128','2014-03-04','11:35:00',2.81),('15128','2014-03-04','11:40:00',3.66),('15128','2014-03-04','11:45:00',3.76),('15128','2014-03-04','11:50:00',3.63),('15128','2014-03-04','11:55:00',3.45),('15128','2014-03-04','12:00:00',2.93),('15128','2014-03-04','12:05:00',2.5),('15128','2014-03-04','12:10:00',1.48),('15128','2014-03-04','12:15:00',3.62),('15128','2014-03-04','12:20:00',3.73),('15128','2014-03-04','12:25:00',3.55),('15128','2014-03-04','12:30:00',3.54),('15128','2014-03-04','12:35:00',3.49),('15128','2014-03-04','12:40:00',3.82),('15128','2014-03-04','12:45:00',3.6),('15128','2014-03-04','12:50:00',1.61),('15128','2014-03-04','12:55:00',1.37),('15128','2014-03-04','13:00:00',2.44),('15128','2014-03-04','13:05:00',1.41),('15128','2014-03-04','13:10:00',2.81),('15128','2014-03-04','13:15:00',3.96),('15128','2014-03-04','13:20:00',3.63),('15128','2014-03-04','13:25:00',3.74),('15128','2014-03-04','13:30:00',4),('15128','2014-03-04','13:35:00',4.59),('15128','2014-03-04','13:40:00',4.15),('15128','2014-03-04','13:45:00',3.91),('15128','2014-03-04','13:50:00',2.66),('15128','2014-03-04','13:55:00',1.25),('15128','2014-03-04','14:00:00',1.17),('15128','2014-03-04','14:05:00',1.33),('15128','2014-03-04','14:10:00',2.95),('15128','2014-03-04','14:15:00',1.5),('15128','2014-03-04','14:20:00',1.76),('15128','2014-03-04','14:25:00',1.57),('15128','2014-03-04','14:30:00',1.58),('15128','2014-03-04','14:35:00',1.96),('15128','2014-03-04','14:40:00',2.72),('15128','2014-03-04','14:45:00',2.78),('15128','2014-03-04','14:50:00',3.47),('15128','2014-03-04','14:55:00',1.69),('15128','2014-03-04','15:00:00',1.13),('15128','2014-03-04','15:30:00',1.05),('15128','2014-03-04','15:35:00',1.45),('15128','2014-03-04','15:40:00',1.12),('15128','2014-03-04','15:45:00',1.15),('15128','2014-03-04','15:50:00',2.18),('15128','2014-03-04','15:55:00',3.12),('15128','2014-03-04','16:00:00',2.03),('15128','2014-03-04','16:05:00',1.27),('15128','2014-03-03','09:05:00',1.45),('15128','2014-03-03','09:10:00',1.31),('15128','2014-03-03','09:55:00',1.48),('15128','2014-03-03','10:00:00',1.98),('15128','2014-03-03','10:05:00',2.4),('15128','2014-03-03','10:30:00',1.16),('15128','2014-03-03','10:35:00',1.21),('15128','2014-03-03','10:40:00',1.28),('15128','2014-03-03','10:45:00',1.58),('15128','2014-03-03','10:50:00',3.5),('15128','2014-03-03','10:55:00',2.77),('15128','2014-03-03','11:00:00',1.74),('15128','2014-03-03','11:25:00',2.24),('15128','2014-03-03','11:30:00',4.23),('15128','2014-03-03','11:45:00',2.66),('15128','2014-03-03','11:50:00',3.72),('15128','2014-03-03','11:55:00',1.48),('15128','2014-03-03','12:00:00',2.98),('15128','2014-03-03','12:05:00',3.27),('15128','2014-03-03','12:10:00',3.63),('15128','2014-03-03','12:15:00',3.36),('15128','2014-03-03','12:20:00',2.56),('15128','2014-03-03','12:25:00',3.15),('15128','2014-03-03','12:30:00',3.56),('15128','2014-03-03','12:35:00',3.54),('15128','2014-03-03','12:40:00',3.54),('15128','2014-03-03','12:45:00',3.24),('15128','2014-03-03','12:50:00',3.56),('15128','2014-03-03','12:55:00',3.38),('15128','2014-03-03','13:00:00',3.69),('15128','2014-03-03','13:05:00',3.47),('15128','2014-03-03','13:10:00',3.4),('15128','2014-03-03','13:15:00',2.32),('15128','2014-03-03','13:45:00',1.18),('15128','2014-03-03','13:50:00',3.29),('15128','2014-03-03','13:55:00',2.97),('15128','2014-03-03','14:00:00',3.45),('15128','2014-03-03','14:05:00',3.09),('15128','2014-03-03','14:10:00',3.76),('15128','2014-03-03','14:15:00',3.56),('15128','2014-03-03','14:20:00',2.69),('15128','2014-03-03','14:25:00',2.82),('15128','2014-03-03','14:30:00',3.51),('15128','2014-03-03','14:35:00',3.33),('15128','2014-03-03','14:40:00',3.29),('15128','2014-03-03','14:45:00',3.12),('15128','2014-03-03','14:50:00',3.13),('15128','2014-03-03','14:55:00',2.7),('15128','2014-03-03','15:00:00',3),('15128','2014-03-03','15:05:00',2.91),('15128','2014-03-03','15:10:00',2.88),('15128','2014-03-03','15:15:00',2.82),('15128','2014-03-03','15:20:00',2.79),('15128','2014-03-03','15:25:00',2.85),('15128','2014-03-03','15:30:00',2.22),('15128','2014-03-03','15:35:00',1.4),('15128','2014-03-03','15:40:00',1.79),('15128','2014-03-03','15:45:00',1.9),('15128','2014-03-03','16:00:00',1.19),('15128','2014-03-03','16:05:00',1.05),('15128','2014-03-03','16:25:00',1.89),('15128','2014-03-03','16:30:00',1.64),('15128','2014-03-03','16:35:00',1.34),('15128','2014-03-03','16:40:00',1.33),('15128','2014-03-03','16:45:00',1.28),('15128','2014-03-03','16:50:00',1.16),('15128','2014-03-02','08:50:00',1.09),('15128','2014-03-02','08:55:00',1.08),('15128','2014-03-02','09:00:00',1.1),('15128','2014-03-02','09:05:00',1.24),('15128','2014-03-02','09:10:00',1.43),('15128','2014-03-02','09:15:00',1.47),('15128','2014-03-02','09:20:00',1.51),('15128','2014-03-02','09:25:00',1.5),('15128','2014-03-02','09:30:00',1.56),('15128','2014-03-02','09:35:00',1.64),('15128','2014-03-02','09:40:00',1.64),('15128','2014-03-02','09:45:00',1.69),('15128','2014-03-02','09:50:00',1.77),('15128','2014-03-02','09:55:00',1.86),('15128','2014-03-02','10:00:00',1.92),('15128','2014-03-02','10:05:00',1.99),('15128','2014-03-02','10:10:00',2.05),('15128','2014-03-02','10:15:00',2.08),('15128','2014-03-02','10:20:00',2.14),('15128','2014-03-02','10:25:00',2.19),('15128','2014-03-02','10:30:00',2.24),('15128','2014-03-02','10:35:00',2.34),('15128','2014-03-02','10:40:00',2.41),('15128','2014-03-02','10:45:00',2.45),('15128','2014-03-02','10:50:00',2.47),('15128','2014-03-02','10:55:00',2.43),('15128','2014-03-02','11:00:00',2.56),('15128','2014-03-02','11:05:00',2.63),('15128','2014-03-02','11:10:00',2.62),('15128','2014-03-02','11:15:00',2.77),('15128','2014-03-02','11:20:00',2.89),('15128','2014-03-02','11:25:00',3.02),('15128','2014-03-02','11:30:00',3.08),('15128','2014-03-02','11:35:00',3.16),('15128','2014-03-02','11:40:00',3.2),('15128','2014-03-02','11:45:00',3.25),('15128','2014-03-02','11:50:00',3.31),('15128','2014-03-02','11:55:00',3.33),('15128','2014-03-02','12:00:00',3.38),('15128','2014-03-02','12:05:00',3.41),('15128','2014-03-02','12:10:00',3.43),('15128','2014-03-02','12:15:00',3.47),('15128','2014-03-02','12:20:00',3.5),('15128','2014-03-02','12:25:00',3.51),('15128','2014-03-02','12:30:00',3.52),('15128','2014-03-02','12:35:00',3.54),('15128','2014-03-02','12:40:00',3.55),('15128','2014-03-02','12:45:00',3.56),('15128','2014-03-02','12:50:00',3.55),('15128','2014-03-02','12:55:00',3.53),('15128','2014-03-02','13:00:00',3.54),('15128','2014-03-02','13:05:00',3.54),('15128','2014-03-02','13:10:00',3.55),('15128','2014-03-02','13:15:00',3.55),('15128','2014-03-02','13:20:00',3.54),('15128','2014-03-02','13:25:00',3.54),('15128','2014-03-02','13:30:00',3.52),('15128','2014-03-02','13:35:00',3.22),('15128','2014-03-02','13:40:00',3.54),('15128','2014-03-02','13:45:00',2.43),('15128','2014-03-02','13:50:00',3.49),('15128','2014-03-02','13:55:00',3.05),('15128','2014-03-02','14:00:00',3.43),('15128','2014-03-02','14:05:00',3.41),('15128','2014-03-02','14:10:00',3.39),('15128','2014-03-02','14:15:00',3.36),('15128','2014-03-02','14:20:00',3.35),('15128','2014-03-02','14:25:00',3.3),('15128','2014-03-02','14:30:00',3.22),('15128','2014-03-02','14:35:00',3.2),('15128','2014-03-02','14:40:00',3.14),('15128','2014-03-02','14:45:00',3.09),('15128','2014-03-02','14:50:00',3),('15128','2014-03-02','14:55:00',2.99),('15128','2014-03-02','15:00:00',2.59),('15128','2014-03-02','15:05:00',2.92),('15128','2014-03-02','15:10:00',2.8),('15128','2014-03-02','15:15:00',2.78),('15128','2014-03-02','15:20:00',2.55),('15128','2014-03-02','15:25:00',2.26),('15128','2014-03-02','15:30:00',2.62),('15128','2014-03-02','15:35:00',2.58),('15128','2014-03-02','15:40:00',2.48),('15128','2014-03-02','15:45:00',2.24),('15128','2014-03-02','15:50:00',2.28),('15128','2014-03-02','15:55:00',2.06),('15128','2014-03-02','16:00:00',1.98),('15128','2014-03-02','16:05:00',1.9),('15128','2014-03-02','16:10:00',1.82),('15128','2014-03-02','16:15:00',1.74),('15128','2014-03-02','16:20:00',1.67),('15128','2014-03-02','16:25:00',1.58),('15128','2014-03-02','16:30:00',1.53),('15128','2014-03-02','16:35:00',1.47),('15128','2014-03-02','16:40:00',1.35),('15128','2014-03-02','16:45:00',1.22),('15128','2014-03-02','16:50:00',1.13),('15128','2014-03-02','16:55:00',1.03),('15128','2014-03-01','08:50:00',1.08),('15128','2014-03-01','08:55:00',1.18),('15128','2014-03-01','09:00:00',1.31),('15128','2014-03-01','09:05:00',1.44),('15128','2014-03-01','09:10:00',1.55),('15128','2014-03-01','09:15:00',1.46),('15128','2014-03-01','09:20:00',1.72),('15128','2014-03-01','09:25:00',1.65),('15128','2014-03-01','09:30:00',2.54),('15128','2014-03-01','09:35:00',2.36),('15128','2014-03-01','09:40:00',2.17),('15128','2014-03-01','10:15:00',1.3),('15128','2014-03-01','10:20:00',1.48),('15128','2014-03-01','10:25:00',1.68),('15128','2014-03-01','10:30:00',2.47),('15128','2014-03-01','10:35:00',3.45),('15128','2014-03-01','10:40:00',3.46),('15128','2014-03-01','10:45:00',2.3),('15128','2014-03-01','10:50:00',3.06),('15128','2014-03-01','10:55:00',1.87),('15128','2014-03-01','11:00:00',1.15),('15128','2014-03-01','11:05:00',1.33),('15128','2014-03-01','11:10:00',1.41),('15128','2014-03-01','11:15:00',1.48),('15128','2014-03-01','11:20:00',1.78),('15128','2014-03-01','11:25:00',1.63),('15128','2014-03-01','11:30:00',1.71),('15128','2014-03-01','11:35:00',2.68),('15128','2014-03-01','11:40:00',2.74),('15128','2014-03-01','11:45:00',1.99),('15128','2014-03-01','11:50:00',2.55),('15128','2014-03-01','11:55:00',3.34),('15128','2014-03-01','12:00:00',3.33),('15128','2014-03-01','12:05:00',3.37),('15128','2014-03-01','12:10:00',2.6),('15128','2014-03-01','12:15:00',2.9),('15128','2014-03-01','12:20:00',1.46),('15128','2014-03-01','12:25:00',1.01),('15128','2014-03-01','13:35:00',1.05),('15128','2014-03-01','13:45:00',1),('15128','2014-03-01','13:50:00',1.11),('15128','2014-03-01','13:55:00',1.05),('15128','2014-03-01','14:55:00',1.03),('15128','2014-03-01','15:00:00',1.14),('15128','2014-03-01','15:05:00',1.2),('15128','2014-03-01','15:10:00',1.23),('15128','2014-03-01','15:15:00',1.24),('15128','2014-03-01','15:20:00',1.26),('15128','2014-03-01','15:25:00',1.25),('15128','2014-03-01','15:30:00',1.3),('15128','2014-03-01','15:35:00',1.41),('15128','2014-03-01','15:40:00',1.48),('15128','2014-03-01','15:45:00',1.5),('15128','2014-03-01','15:50:00',1.53),('15128','2014-03-01','15:55:00',1.55),('15128','2014-03-01','16:00:00',1.39),('15128','2014-03-01','16:05:00',1.24),('15128','2014-03-01','16:10:00',1),('15128','2014-02-27','09:15:00',1.12),('15128','2014-02-27','09:20:00',1.24),('15128','2014-02-27','09:25:00',1.07),('15128','2014-02-27','09:30:00',1.69),('15128','2014-02-27','09:35:00',1.94),('15128','2014-02-27','09:40:00',1.95),('15128','2014-02-27','09:45:00',1.15),('15128','2014-02-27','09:50:00',1.86),('15128','2014-02-27','09:55:00',1.18),('15128','2014-02-27','10:00:00',1.01),('15128','2014-02-27','10:15:00',1.53),('15128','2014-02-27','10:20:00',1.58),('15128','2014-02-27','10:25:00',2.24),('15128','2014-02-27','10:30:00',2.18),('15128','2014-02-27','10:35:00',1.23),('15128','2014-02-27','10:40:00',1.36),('15128','2014-02-27','10:45:00',1.21),('15128','2014-02-27','10:50:00',1.2),('15128','2014-02-27','10:55:00',1.02),('15128','2014-02-27','11:00:00',1.14),('15128','2014-02-27','11:05:00',1.25),('15128','2014-02-27','11:10:00',1.22),('15128','2014-02-27','11:15:00',1.35),('15128','2014-02-27','11:20:00',1.17),('15128','2014-02-27','11:50:00',1.07),('15128','2014-02-27','11:55:00',1.29),('15128','2014-02-27','12:20:00',1.49),('15128','2014-02-27','12:25:00',4.23),('15128','2014-02-27','12:30:00',3.74),('15128','2014-02-27','12:35:00',4.47),('15128','2014-02-27','12:40:00',2.52),('15128','2014-02-27','12:45:00',1.55),('15128','2014-02-27','12:50:00',1.29),('15128','2014-02-27','12:55:00',1.72),('15128','2014-02-27','13:00:00',1.02),('15128','2014-02-27','13:40:00',1.2),('15128','2014-02-27','13:45:00',1.28),('15128','2014-02-27','13:50:00',1.21),('15128','2014-02-27','13:55:00',1.13),('15128','2014-02-27','14:15:00',2.69),('15128','2014-02-27','14:20:00',1.95),('15128','2014-02-27','14:25:00',1.04),('15128','2014-02-27','15:30:00',1.69),('15128','2014-02-27','15:35:00',2.87),('15128','2014-02-27','15:40:00',1.09),('15128','2014-02-26','10:30:00',1.03),('15128','2014-02-26','10:35:00',1.18),('15128','2014-02-26','10:40:00',1.34),('15128','2014-02-26','10:45:00',1.34),('15128','2014-02-26','10:50:00',1.24),('15128','2014-02-26','10:55:00',1.27),('15128','2014-02-26','11:00:00',1.29),('15128','2014-02-26','11:05:00',1.36),('15128','2014-02-26','11:10:00',1.33),('15128','2014-02-26','11:15:00',1.35),('15128','2014-02-26','11:20:00',1.37),('15128','2014-02-26','11:25:00',1.51),('15128','2014-02-26','11:30:00',1.44),('15128','2014-02-26','11:35:00',1.31),('15128','2014-02-26','11:40:00',1.25),('15128','2014-02-26','11:45:00',1.21),('15128','2014-02-26','11:50:00',1.2),('15128','2014-02-26','11:55:00',1.14),('15128','2014-02-26','12:00:00',1.3),('15128','2014-02-26','12:05:00',1.39),('15128','2014-02-26','12:10:00',1.43),('15128','2014-02-26','12:15:00',1.44),('15128','2014-02-26','12:20:00',1.41),('15128','2014-02-26','12:25:00',1.39),('15128','2014-02-26','12:30:00',1.38),('15128','2014-02-26','12:35:00',1.36),('15128','2014-02-26','12:40:00',1.37),('15128','2014-02-26','12:45:00',1.38),('15128','2014-02-26','12:50:00',1.33),('15128','2014-02-26','12:55:00',1.33),('15128','2014-02-26','13:00:00',1.34),('15128','2014-02-26','13:05:00',1.28),('15128','2014-02-26','13:10:00',1.3),('15128','2014-02-26','13:15:00',1.44),('15128','2014-02-26','13:20:00',1.55),('15128','2014-02-26','13:25:00',1.63),('15128','2014-02-26','13:30:00',1.68),('15128','2014-02-26','13:35:00',1.74),('15128','2014-02-26','13:40:00',1.66),('15128','2014-02-26','13:45:00',1.64),('15128','2014-02-26','13:50:00',1.85),('15128','2014-02-26','13:55:00',1.7),('15128','2014-02-26','14:00:00',1.5),('15128','2014-02-26','14:05:00',1.69),('15128','2014-02-26','14:10:00',1.49),('15128','2014-02-26','14:15:00',1.46),('15128','2014-02-26','14:20:00',1.44),('15128','2014-02-26','14:25:00',1.19),('15128','2014-02-26','14:30:00',1.04),('15128','2014-02-26','14:35:00',1.17),('15128','2014-02-26','14:40:00',1.55),('15128','2014-02-26','14:45:00',1.66),('15128','2014-02-26','14:50:00',1.53),('15128','2014-02-26','14:55:00',1.59),('15128','2014-02-26','15:00:00',1.4),('15128','2014-02-26','15:05:00',1.68),('15128','2014-02-26','15:10:00',2.03),('15128','2014-02-26','15:15:00',1.77),('15128','2014-02-26','15:20:00',1.43),('15128','2014-02-26','15:25:00',1.25),('15128','2014-02-26','15:30:00',1.07),('15128','2014-02-26','16:40:00',1.4),('15128','2014-02-26','16:45:00',1.19),('15128','2014-02-26','16:50:00',1.18),('15128','2014-02-25','08:55:00',1.02),('15128','2014-02-25','09:00:00',1.17),('15128','2014-02-25','09:05:00',1.19),('15128','2014-02-25','09:10:00',1.26),('15128','2014-02-25','09:15:00',1.36),('15128','2014-02-25','09:20:00',1.27),('15128','2014-02-25','09:30:00',1.52),('15128','2014-02-25','09:35:00',1.56),('15128','2014-02-25','09:40:00',1.49),('15128','2014-02-25','09:45:00',1.34),('15128','2014-02-25','09:50:00',1.51),('15128','2014-02-25','09:55:00',1.74),('15128','2014-02-25','10:00:00',1.24),('15128','2014-02-25','10:05:00',1.1),('15128','2014-02-25','12:25:00',1.82),('15128','2014-02-25','12:30:00',1.56),('15128','2014-02-25','12:35:00',1.67),('15128','2014-02-25','12:40:00',1.71),('15128','2014-02-25','12:45:00',2.14),('15128','2014-02-25','12:50:00',2.7),('15128','2014-02-25','12:55:00',1.99),('15128','2014-02-25','13:00:00',2.68),('15128','2014-02-25','13:05:00',2.03),('15128','2014-02-25','13:10:00',2.99),('15128','2014-02-25','13:15:00',2.76),('15128','2014-02-25','13:20:00',3.37),('15128','2014-02-25','13:25:00',3.59),('15128','2014-02-25','13:30:00',3.13),('15128','2014-02-25','13:35:00',1.82),('15128','2014-02-25','13:40:00',3.22),('15128','2014-02-25','13:45:00',3.79),('15128','2014-02-25','13:50:00',3.53),('15128','2014-02-25','13:55:00',3.69),('15128','2014-02-25','14:00:00',2.7),('15128','2014-02-25','14:05:00',2.41),('15128','2014-02-25','14:10:00',1.38),('15128','2014-02-25','14:15:00',1.26),('15128','2014-02-25','14:30:00',1.59),('15128','2014-02-25','14:35:00',2.15),('15128','2014-02-25','14:40:00',1.1),('15128','2014-02-25','14:45:00',1.71),('15128','2014-02-25','14:50:00',1.84),('15128','2014-02-25','14:55:00',3.23),('15128','2014-02-25','15:00:00',3.02),('15128','2014-02-25','15:05:00',2.84),('15128','2014-02-25','15:10:00',2.41),('15128','2014-02-25','15:15:00',1.95),('15128','2014-02-25','15:20:00',1.46),('15128','2014-02-25','15:25:00',1.48),('15128','2014-02-25','15:30:00',2.19),('15128','2014-02-25','15:35:00',1.85),('15128','2014-02-25','15:40:00',1.77),('15128','2014-02-25','15:45:00',1.84),('15128','2014-02-25','15:50:00',2.14),('15128','2014-02-25','15:55:00',1.8),('15128','2014-02-25','16:00:00',1.6),('15128','2014-02-25','16:05:00',1.3),('15128','2014-02-25','16:10:00',1.28),('15128','2014-02-25','16:15:00',1.38),('15128','2014-02-25','16:20:00',1.05),('15128','2014-04-28','09:50:00',1.33),('15128','2014-04-28','09:55:00',2.09),('15128','2014-04-28','10:00:00',2.56),('15128','2014-04-28','10:05:00',2.7),('15128','2014-04-28','10:10:00',2.3),('15128','2014-04-28','10:15:00',2.83),('15128','2014-04-28','10:20:00',2.92),('15128','2014-04-28','10:25:00',2.52),('15128','2014-04-28','10:30:00',2.91),('15128','2014-04-28','10:35:00',3),('15128','2014-04-28','10:40:00',3),('15128','2014-04-28','10:45:00',3.01),('15128','2014-04-28','10:50:00',3.14),('15128','2014-04-28','10:55:00',3.1),('15128','2014-04-28','11:00:00',3.15),('15128','2014-04-28','11:05:00',3.19),('15128','2014-04-28','11:10:00',3.28),('15128','2014-04-28','11:15:00',3.31),('15128','2014-04-28','11:20:00',3.43),('15128','2014-04-28','11:25:00',2.95),('15128','2014-04-28','11:30:00',2.85),('15128','2014-04-28','11:35:00',1.22),('15128','2014-04-28','11:40:00',1.11),('15128','2014-04-28','11:45:00',1.12),('15128','2014-04-28','11:50:00',1.27),('15128','2014-04-28','11:55:00',1.09),('15128','2014-04-28','12:05:00',1.26),('15128','2014-04-28','12:10:00',1.35),('15128','2014-04-28','12:15:00',2.03),('15128','2014-04-28','12:20:00',2.7),('15128','2014-04-28','12:25:00',2.57),('15128','2014-04-28','12:30:00',1.32),('15128','2014-04-28','12:35:00',1.32),('15128','2014-04-28','12:40:00',1.59),('15128','2014-04-28','12:45:00',3.74),('15128','2014-04-28','12:50:00',5.09),('15128','2014-04-28','12:55:00',5.22),('15128','2014-04-28','13:00:00',4.12),('15128','2014-04-28','13:05:00',5.1),('15128','2014-04-28','13:10:00',1.63),('15128','2014-04-28','13:15:00',4.55),('15128','2014-04-28','13:20:00',4.77),('15128','2014-04-28','13:25:00',1.43),('15128','2014-04-28','13:30:00',1.83),('15128','2014-04-28','13:35:00',1.69),('15128','2014-04-28','13:40:00',1.51),('15128','2014-04-28','13:45:00',1.75),('15128','2014-04-28','13:50:00',1.53),('15128','2014-04-28','13:55:00',1.64),('15128','2014-04-28','14:00:00',2.25),('15128','2014-04-28','14:05:00',2.36),('15128','2014-04-28','14:10:00',1.67),('15128','2014-04-28','14:15:00',1.48),('15128','2014-04-28','14:20:00',1.45),('15128','2014-04-28','14:25:00',1.36),('15128','2014-04-28','14:30:00',1.68),('15128','2014-04-28','14:35:00',2),('15128','2014-04-28','14:40:00',1.58),('15128','2014-04-28','14:45:00',1.8),('15128','2014-04-28','14:50:00',2.63),('15128','2014-04-28','14:55:00',2.71),('15128','2014-04-28','15:00:00',2.77),('15128','2014-04-28','15:05:00',1.85),('15128','2014-04-28','15:10:00',1.59),('15128','2014-04-28','15:15:00',1.81),('15128','2014-04-28','15:20:00',1.18),('15128','2014-04-28','15:25:00',1.02),('15128','2014-04-28','15:30:00',1.05),('15128','2014-04-28','15:45:00',1.03),('15128','2014-04-28','15:50:00',1.11),('15128','2014-04-28','15:55:00',1.03),('15128','2014-04-28','17:05:00',1.02),('15128','2014-04-28','17:10:00',2.81),('15128','2014-04-28','17:15:00',2.16),('15128','2014-04-28','17:20:00',1.63),('15128','2014-04-28','17:25:00',3.12),('15128','2014-04-28','17:30:00',1.44),('15128','2014-04-28','18:55:00',1.02),('15128','2014-02-24','09:00:00',1.04),('15128','2014-02-24','09:05:00',1.13),('15128','2014-02-24','09:10:00',1.19),('15128','2014-02-24','09:15:00',1.25),('15128','2014-02-24','09:20:00',1.32),('15128','2014-02-24','09:25:00',1.38),('15128','2014-02-24','09:30:00',1.43),('15128','2014-02-24','09:35:00',1.5),('15128','2014-02-24','09:40:00',1.53),('15128','2014-02-24','09:45:00',1.59),('15128','2014-02-24','09:50:00',1.63),('15128','2014-02-24','09:55:00',1.69),('15128','2014-02-24','10:00:00',1.75),('15128','2014-02-24','10:05:00',1.8),('15128','2014-02-24','10:10:00',1.87),('15128','2014-02-24','10:15:00',1.93),('15128','2014-02-24','10:20:00',1.97),('15128','2014-02-24','10:25:00',2.03),('15128','2014-02-24','10:30:00',2.08),('15128','2014-02-24','10:35:00',2.12),('15128','2014-02-24','10:40:00',2.17),('15128','2014-02-24','10:45:00',2.24),('15128','2014-02-24','10:50:00',2.31),('15128','2014-02-24','10:55:00',2.36),('15128','2014-02-24','11:00:00',2.41),('15128','2014-02-24','11:05:00',2.4),('15128','2014-02-24','11:10:00',2.46),('15128','2014-02-24','11:15:00',2.53),('15128','2014-02-24','11:20:00',2.7),('15128','2014-02-24','11:25:00',2.8),('15128','2014-02-24','11:30:00',2.84),('15128','2014-02-24','11:35:00',2.87),('15128','2014-02-24','11:40:00',2.91),('15128','2014-02-24','11:45:00',2.95),('15128','2014-02-24','11:50:00',2.96),('15128','2014-02-24','11:55:00',3),('15128','2014-02-24','12:00:00',3.11),('15128','2014-02-24','12:05:00',3.15),('15128','2014-02-24','12:10:00',3.17),('15128','2014-02-24','12:15:00',3.18),('15128','2014-02-24','12:20:00',3.2),('15128','2014-02-24','12:25:00',3.23),('15128','2014-02-24','12:30:00',3.22),('15128','2014-02-24','12:35:00',3.23),('15128','2014-02-24','12:40:00',3.24),('15128','2014-02-24','12:45:00',3.24),('15128','2014-02-24','12:50:00',3.29),('15128','2014-02-24','12:55:00',3.23),('15128','2014-02-24','13:00:00',3.21),('15128','2014-02-24','13:05:00',3.25),('15128','2014-02-24','13:10:00',3.23),('15128','2014-02-24','13:15:00',3.26),('15128','2014-02-24','13:20:00',3.25),('15128','2014-02-24','13:25:00',3.28),('15128','2014-02-24','13:30:00',3.29),('15128','2014-02-24','13:35:00',3.24),('15128','2014-02-24','13:40:00',3.1),('15128','2014-02-24','13:45:00',3.13),('15128','2014-02-24','13:50:00',2.98),('15128','2014-02-24','13:55:00',2.66),('15128','2014-02-24','14:00:00',2.73),('15128','2014-02-24','14:05:00',2.67),('15128','2014-02-24','14:10:00',2.7),('15128','2014-02-24','14:15:00',3),('15128','2014-02-24','14:20:00',2.91),('15128','2014-02-24','14:25:00',2.75),('15128','2014-02-24','14:30:00',2.41),('15128','2014-02-24','14:35:00',2.65),('15128','2014-02-24','14:40:00',2.64),('15128','2014-02-24','14:45:00',2.54),('15128','2014-02-24','14:50:00',2.52),('15128','2014-02-24','14:55:00',2.61),('15128','2014-02-24','15:00:00',2.57),('15128','2014-02-24','15:05:00',2.53),('15128','2014-02-24','15:10:00',2.48),('15128','2014-02-24','15:15:00',2.29),('15128','2014-02-24','15:20:00',2.33),('15128','2014-02-24','15:25:00',2.19),('15128','2014-02-24','15:30:00',2.19),('15128','2014-02-24','15:35:00',1.68),('15128','2014-02-24','15:45:00',1.15),('15128','2014-02-24','15:50:00',1.46),('15128','2014-02-24','15:55:00',1.35),('15128','2014-02-24','16:00:00',1.27),('15128','2014-02-24','16:05:00',1.27),('15128','2014-02-24','16:15:00',1),('15128','2014-02-24','16:20:00',1.1),('15128','2014-02-23','09:00:00',1.05),('15128','2014-02-23','09:05:00',1.11),('15128','2014-02-23','09:10:00',1.18),('15128','2014-02-23','09:15:00',1.24),('15128','2014-02-23','09:20:00',1.32),('15128','2014-02-23','09:25:00',1.38),('15128','2014-02-23','09:30:00',1.44),('15128','2014-02-23','09:35:00',1.5),('15128','2014-02-23','09:40:00',1.55),('15128','2014-02-23','09:45:00',1.6),('15128','2014-02-23','09:50:00',1.64),('15128','2014-02-23','09:55:00',1.72),('15128','2014-02-23','10:00:00',1.77),('15128','2014-02-23','10:05:00',1.82),('15128','2014-02-23','10:10:00',1.87),('15128','2014-02-23','10:15:00',1.93),('15128','2014-02-23','10:20:00',1.99),('15128','2014-02-23','10:25:00',2.07),('15128','2014-02-23','10:30:00',2.08),('15128','2014-02-23','10:35:00',2.1),('15128','2014-02-23','10:40:00',2.22),('15128','2014-02-23','10:45:00',2.3),('15128','2014-02-23','10:50:00',2.32),('15128','2014-02-23','10:55:00',2.38),('15128','2014-02-23','11:00:00',2.45),('15128','2014-02-23','11:05:00',2.43),('15128','2014-02-23','11:10:00',2.58),('15128','2014-02-23','11:15:00',2.69),('15128','2014-02-23','11:20:00',2.94),('15128','2014-02-23','11:25:00',2.12),('15128','2014-02-23','11:30:00',2.79),('15128','2014-02-23','11:35:00',2.46),('15128','2014-02-23','11:40:00',1.51),('15128','2014-02-23','11:45:00',2.35),('15128','2014-02-23','11:50:00',3.18),('15128','2014-02-23','11:55:00',3.13),('15128','2014-02-23','12:00:00',3.15),('15128','2014-02-23','12:05:00',3.16),('15128','2014-02-23','12:10:00',3.18),('15128','2014-02-23','12:15:00',3.19),('15128','2014-02-23','12:20:00',3.21),('15128','2014-02-23','12:25:00',3.21),('15128','2014-02-23','12:30:00',3.24),('15128','2014-02-23','12:35:00',3.27),('15128','2014-02-23','12:40:00',3.27),('15128','2014-02-23','12:45:00',3.36),('15128','2014-02-23','12:50:00',3.46),('15128','2014-02-23','12:55:00',3.62),('15128','2014-02-23','13:00:00',3.55),('15128','2014-02-23','13:05:00',4.06),('15128','2014-02-23','13:10:00',2.15),('15128','2014-02-23','13:15:00',1.15),('15128','2014-02-23','13:20:00',1.04),('15128','2014-02-23','13:35:00',1.1),('15128','2014-02-23','13:40:00',1.14),('15128','2014-02-23','13:45:00',1.08),('15128','2014-02-23','13:50:00',1.08),('15128','2014-02-23','13:55:00',1.17),('15128','2014-02-23','14:00:00',1.29),('15128','2014-02-23','14:05:00',1.39),('15128','2014-02-23','14:10:00',1.41),('15128','2014-02-23','14:15:00',1.47),('15128','2014-02-23','14:20:00',1.42),('15128','2014-02-23','14:50:00',1.02),('15128','2014-02-23','14:55:00',1.11),('15128','2014-02-23','15:00:00',1.29),('15128','2014-02-23','15:05:00',3.33),('15128','2014-02-23','15:10:00',2.2),('15128','2014-02-23','15:15:00',2.95),('15128','2014-02-23','15:20:00',2.68),('15128','2014-02-23','15:25:00',2.52),('15128','2014-02-23','15:30:00',2.39),('15128','2014-02-23','15:35:00',2.27),('15128','2014-02-23','15:40:00',2.03),('15128','2014-02-23','15:45:00',2.06),('15128','2014-02-23','15:50:00',1.99),('15128','2014-02-23','15:55:00',1.81),('15128','2014-02-23','16:00:00',1.73),('15128','2014-02-23','16:05:00',1.7),('15128','2014-02-23','16:10:00',1.29),('15128','2014-02-23','16:30:00',1.33),('15128','2014-02-23','16:35:00',1.08),('15128','2014-02-23','16:40:00',1.09),('15128','2014-02-22','09:05:00',1.11),('15128','2014-02-22','09:10:00',1.2),('15128','2014-02-22','09:15:00',1.26),('15128','2014-02-22','09:20:00',1.25),('15128','2014-02-22','09:25:00',1.35),('15128','2014-02-22','09:30:00',1.42),('15128','2014-02-22','09:35:00',1.48),('15128','2014-02-22','09:40:00',1.53),('15128','2014-02-22','09:45:00',1.59),('15128','2014-02-22','09:50:00',1.62),('15128','2014-02-22','09:55:00',1.69),('15128','2014-02-22','10:00:00',1.75),('15128','2014-02-22','10:05:00',1.8),('15128','2014-02-22','10:10:00',1.85),('15128','2014-02-22','10:15:00',1.89),('15128','2014-02-22','10:20:00',1.97),('15128','2014-02-22','10:25:00',2.05),('15128','2014-02-22','10:30:00',2.08),('15128','2014-02-22','10:35:00',2.12),('15128','2014-02-22','10:40:00',2.19),('15128','2014-02-22','10:45:00',2.26),('15128','2014-02-22','10:50:00',2.3),('15128','2014-02-22','10:55:00',2.34),('15128','2014-02-22','11:00:00',2.37),('15128','2014-02-22','11:05:00',2.49),('15128','2014-02-22','11:10:00',2.55),('15128','2014-02-22','11:15:00',2.64),('15128','2014-02-22','11:20:00',2.76),('15128','2014-02-22','11:25:00',2.84),('15128','2014-02-22','11:30:00',2.87),('15128','2014-02-22','11:35:00',2.91),('15128','2014-02-22','11:40:00',2.97),('15128','2014-02-22','11:45:00',3),('15128','2014-02-22','11:50:00',3.12),('15128','2014-02-22','11:55:00',3.23),('15128','2014-02-22','12:00:00',3.28),('15128','2014-02-22','12:05:00',3.32),('15128','2014-02-22','12:10:00',3.07),('15128','2014-02-22','12:15:00',2.7),('15128','2014-02-22','12:20:00',1.67),('15128','2014-02-22','12:25:00',3.62),('15128','2014-02-22','12:30:00',2.59),('15128','2014-02-22','12:35:00',2.22),('15128','2014-02-22','12:40:00',2.57),('15128','2014-02-22','12:45:00',3.63),('15128','2014-02-22','12:50:00',3.41),('15128','2014-02-22','12:55:00',3.22),('15128','2014-02-22','13:00:00',3.22),('15128','2014-02-22','13:05:00',3.32),('15128','2014-02-22','13:10:00',3.37),('15128','2014-02-22','13:15:00',3.43),('15128','2014-02-22','13:20:00',3.44),('15128','2014-02-22','13:25:00',2.83),('15128','2014-02-22','13:30:00',2.64),('15128','2014-02-22','13:35:00',3.08),('15128','2014-02-22','13:40:00',2.9),('15128','2014-02-22','13:45:00',2.19),('15128','2014-02-22','13:50:00',2.91),('15128','2014-02-22','13:55:00',2.84),('15128','2014-02-22','14:00:00',3.39),('15128','2014-02-22','14:05:00',1.96),('15128','2014-02-22','14:10:00',2.4),('15128','2014-02-22','14:15:00',2.85),('15128','2014-02-22','14:20:00',2.2),('15128','2014-02-22','14:25:00',2.58),('15128','2014-02-22','14:30:00',3.45),('15128','2014-02-22','14:35:00',3.67),('15128','2014-02-22','14:40:00',3.09),('15128','2014-02-22','14:45:00',2.23),('15128','2014-02-22','14:50:00',1.13),('15128','2014-02-22','14:55:00',1.07),('15128','2014-02-22','15:00:00',1.02),('15128','2014-02-22','15:05:00',1.11),('15128','2014-02-22','15:10:00',1.15),('15128','2014-02-22','15:15:00',2.72),('15128','2014-02-22','15:20:00',2.03),('15128','2014-02-22','15:25:00',2.9),('15128','2014-02-22','15:30:00',3.01),('15128','2014-02-22','15:35:00',2.63),('15128','2014-02-22','15:40:00',2.26),('15128','2014-02-22','15:45:00',2.68),('15128','2014-02-22','15:50:00',2.64),('15128','2014-02-22','15:55:00',1.95),('15128','2014-02-22','16:00:00',1.84),('15128','2014-02-22','16:05:00',1.15),('15128','2014-02-21','09:35:00',1.13),('15128','2014-02-21','09:40:00',1.55),('15128','2014-02-21','09:45:00',1.71),('15128','2014-02-21','09:50:00',1.89),('15128','2014-02-21','09:55:00',1.26),('15128','2014-02-21','10:00:00',1.78),('15128','2014-02-21','10:05:00',1.29),('15128','2014-02-21','10:20:00',1.3),('15128','2014-02-21','10:25:00',2.6),('15128','2014-02-21','10:30:00',1.29),('15128','2014-02-21','10:35:00',1.43),('15128','2014-02-21','10:40:00',1.89),('15128','2014-02-21','10:45:00',1.01),('15128','2014-02-21','12:00:00',1.25),('15128','2014-02-21','12:05:00',1.37),('15128','2014-02-21','12:10:00',1.52),('15128','2014-02-21','12:15:00',1.44),('15128','2014-02-21','12:20:00',1.55),('15128','2014-02-21','12:25:00',1.29),('15128','2014-02-21','12:30:00',1.79),('15128','2014-02-21','12:35:00',2.23),('15128','2014-02-21','12:40:00',3.6),('15128','2014-02-21','12:45:00',3.49),('15128','2014-02-21','12:50:00',2.78),('15128','2014-02-21','12:55:00',2.07),('15128','2014-02-21','13:00:00',4.3),('15128','2014-02-21','13:05:00',1.57),('15128','2014-02-21','13:15:00',1.01),('15128','2014-02-21','13:20:00',1.77),('15128','2014-02-21','13:25:00',3.42),('15128','2014-02-21','13:30:00',1.93),('15128','2014-02-21','13:35:00',2.68),('15128','2014-02-21','13:40:00',2.74),('15128','2014-02-21','13:45:00',1.66),('15128','2014-02-21','13:50:00',2.05),('15128','2014-02-21','13:55:00',1.31),('15128','2014-02-21','14:00:00',1.52),('15128','2014-02-21','14:05:00',1.09),('15128','2014-02-21','14:10:00',1.53),('15128','2014-02-21','14:15:00',2.21),('15128','2014-02-21','14:20:00',2.78),('15128','2014-02-21','14:25:00',2.6),('15128','2014-02-21','14:30:00',1.61),('15128','2014-02-21','14:35:00',2.21),('15128','2014-02-21','14:40:00',2.33),('15128','2014-02-21','14:45:00',1.09),('15128','2014-02-21','14:50:00',1.23),('15128','2014-02-21','14:55:00',2.64),('15128','2014-02-21','15:00:00',2.67),('15128','2014-02-21','15:05:00',1.56),('15128','2014-02-21','15:10:00',2.25),('15128','2014-02-21','15:15:00',2.51),('15128','2014-02-21','15:20:00',2.57),('15128','2014-02-21','15:25:00',1.87),('15128','2014-02-21','15:30:00',1.53),('15128','2014-02-21','15:35:00',1.09),('15128','2014-02-21','15:40:00',1.46),('15128','2014-02-21','15:45:00',2.42),('15128','2014-02-21','15:50:00',1.89),('15128','2014-02-21','15:55:00',1.97),('15128','2014-02-21','16:00:00',1.85),('15128','2014-02-21','16:05:00',1.71),('15128','2014-02-21','16:10:00',1.3),('15128','2014-02-21','16:15:00',1.41),('15128','2014-02-21','16:20:00',1.51),('15128','2014-02-21','16:25:00',1.39),('15128','2014-02-21','16:30:00',1.19),('15128','2014-02-21','16:35:00',1.17),('15128','2014-02-20','09:20:00',1),('15128','2014-02-20','09:25:00',1.04),('15128','2014-02-20','09:30:00',1.05),('15128','2014-02-20','09:35:00',1.06),('15128','2014-02-20','09:40:00',1.07),('15128','2014-02-20','09:45:00',1.08),('15128','2014-02-20','09:50:00',1.16),('15128','2014-02-20','09:55:00',1.26),('15128','2014-02-20','10:00:00',1.24),('15128','2014-02-20','10:05:00',1.23),('15128','2014-02-20','10:10:00',1.5),('15128','2014-02-20','10:15:00',1.56),('15128','2014-02-20','10:20:00',1.58),('15128','2014-02-20','10:25:00',1.71),('15128','2014-02-20','10:30:00',1.65),('15128','2014-02-20','10:35:00',1.3),('15128','2014-02-20','10:40:00',1.4),('15128','2014-02-20','10:45:00',1.5),('15128','2014-02-20','10:50:00',2.13),('15128','2014-02-20','10:55:00',2.64),('15128','2014-02-20','11:00:00',2.56),('15128','2014-02-20','11:05:00',2.83),('15128','2014-02-20','11:10:00',2.88),('15128','2014-02-20','11:15:00',2.37),('15128','2014-02-20','11:20:00',2.78),('15128','2014-02-20','11:25:00',1.77),('15128','2014-02-20','11:30:00',2.69),('15128','2014-02-20','11:35:00',1.81),('15128','2014-02-20','11:40:00',3.31),('15128','2014-02-20','11:45:00',3.14),('15128','2014-02-20','11:50:00',3.35),('15128','2014-02-20','11:55:00',3.51),('15128','2014-02-20','12:00:00',2.48),('15128','2014-02-20','12:05:00',4.04),('15128','2014-02-20','12:10:00',2.15),('15128','2014-02-20','12:15:00',1.15),('15128','2014-02-20','12:20:00',1.06),('15128','2014-02-20','13:10:00',1.23),('15128','2014-02-20','13:35:00',1.01),('15128','2014-02-20','13:40:00',1.05),('15128','2014-02-20','13:45:00',1.71),('15128','2014-02-20','13:50:00',1.04),('15128','2014-02-20','14:05:00',1.06),('15128','2014-02-20','14:10:00',1.32),('15128','2014-02-20','14:15:00',1.41),('15128','2014-02-20','14:20:00',1.09),('15128','2014-02-20','14:25:00',1.58),('15128','2014-02-20','14:30:00',2.03),('15128','2014-02-20','14:35:00',2.43),('15128','2014-02-20','14:40:00',2.2),('15128','2014-02-20','14:45:00',2.47),('15128','2014-02-20','14:50:00',1.18),('15128','2014-02-20','14:55:00',1.47),('15128','2014-02-20','15:00:00',2.28),('15128','2014-02-20','15:05:00',1.85),('15128','2014-02-20','15:10:00',2.43),('15128','2014-02-20','15:15:00',2.69),('15128','2014-02-20','15:20:00',2.31),('15128','2014-02-20','15:25:00',2.22),('15128','2014-02-20','15:30:00',2.12),('15128','2014-02-20','15:35:00',2),('15128','2014-02-20','15:40:00',1.91),('15128','2014-02-20','15:45:00',1.82),('15128','2014-02-20','15:50:00',1.73),('15128','2014-02-20','15:55:00',1.57),('15128','2014-02-20','16:00:00',1.56),('15128','2014-02-20','16:05:00',1.47),('15128','2014-02-20','16:10:00',1.45),('15128','2014-02-20','16:15:00',1.37),('15128','2014-02-20','16:20:00',1.32),('15128','2014-02-20','16:25:00',1.22),('15128','2014-02-20','16:30:00',1.1),('15128','2014-02-19','10:15:00',1.05),('15128','2014-02-19','10:20:00',1.13),('15128','2014-02-19','10:25:00',1.14),('15128','2014-02-19','10:30:00',1.08),('15128','2014-02-19','10:35:00',1.08),('15128','2014-02-19','10:40:00',1.21),('15128','2014-02-19','10:45:00',1.2),('15128','2014-02-19','10:50:00',1.13),('15128','2014-02-19','10:55:00',1.07),('15128','2014-02-19','11:00:00',1.06),('15128','2014-02-19','11:20:00',1.07),('15128','2014-02-19','11:25:00',1.39),('15128','2014-02-19','11:30:00',1.46),('15128','2014-02-19','11:35:00',1.46),('15128','2014-02-19','11:40:00',1.33),('15128','2014-02-19','11:45:00',1.16),('15128','2014-02-19','11:50:00',1),('15128','2014-02-19','11:55:00',1.11),('15128','2014-02-19','12:00:00',1.22),('15128','2014-02-19','12:05:00',1.04),('15128','2014-02-19','12:10:00',1),('15128','2014-02-19','12:15:00',1.01),('15128','2014-02-19','12:20:00',1.08),('15128','2014-02-19','13:00:00',1.07),('15128','2014-02-19','13:10:00',1.28),('15128','2014-02-19','13:15:00',1.56),('15128','2014-02-19','13:20:00',1.01),('15128','2014-02-19','13:25:00',1),('15128','2014-02-19','13:30:00',1.12),('15128','2014-02-19','13:35:00',1.22),('15128','2014-02-19','13:40:00',1.35),('15128','2014-02-19','13:45:00',1.33),('15128','2014-02-19','13:50:00',1.44),('15128','2014-02-19','13:55:00',1.26),('15128','2014-02-19','14:00:00',1.31),('15128','2014-02-19','14:05:00',1.25),('15128','2014-02-19','14:10:00',1.05),('15128','2014-02-18','09:40:00',1.04),('15128','2014-02-18','09:45:00',1.28),('15128','2014-02-18','09:50:00',1.28),('15128','2014-02-18','09:55:00',1.17),('15128','2014-02-18','10:00:00',1.24),('15128','2014-02-18','10:05:00',1.3),('15128','2014-02-18','10:10:00',1.3),('15128','2014-02-18','10:15:00',1.43),('15128','2014-02-18','10:20:00',1.38),('15128','2014-02-18','10:25:00',1.31),('15128','2014-02-18','10:30:00',1.18),('15128','2014-02-18','10:35:00',1.19),('15128','2014-02-18','10:40:00',1.28),('15128','2014-02-18','10:45:00',1.3),('15128','2014-02-18','10:50:00',1.35),('15128','2014-02-18','10:55:00',1.34),('15128','2014-02-18','11:00:00',1.19),('15128','2014-02-18','11:15:00',1.28),('15128','2014-02-18','11:20:00',1.44),('15128','2014-02-18','11:25:00',1.42),('15128','2014-02-18','11:30:00',1.09),('15128','2014-02-18','11:35:00',1.08),('15128','2014-02-18','11:40:00',1.6),('15128','2014-02-18','11:45:00',1.58),('15128','2014-02-18','11:50:00',1.54),('15128','2014-02-18','11:55:00',1.42),('15128','2014-02-18','12:00:00',1.43),('15128','2014-02-18','12:05:00',1.51),('15128','2014-02-18','12:10:00',1.56),('15128','2014-02-18','12:15:00',1.24),('15128','2014-02-18','12:50:00',1.07),('15128','2014-02-18','13:15:00',1.18),('15128','2014-02-18','13:20:00',1.34),('15128','2014-02-18','13:25:00',1.32),('15128','2014-02-18','13:30:00',1.47),('15128','2014-02-18','13:35:00',1.87),('15128','2014-02-18','13:40:00',1.75),('15128','2014-02-18','13:45:00',2.06),('15128','2014-02-18','13:50:00',2.01),('15128','2014-02-18','13:55:00',2.05),('15128','2014-02-18','14:00:00',1.74),('15128','2014-02-18','14:05:00',1.22),('15128','2014-02-18','14:10:00',1.13),('15128','2014-02-18','14:15:00',1.12),('15128','2014-02-18','14:20:00',1.18),('15128','2014-02-18','14:25:00',1.38),('15128','2014-02-18','14:30:00',1.8),('15128','2014-02-18','14:35:00',1.32),('15128','2014-02-18','14:50:00',1.07),('15128','2014-02-18','15:00:00',1.13),('15128','2014-02-18','15:05:00',1.03),('15128','2014-02-18','15:15:00',1),('15128','2014-02-17','09:10:00',1.01),('15128','2014-02-17','09:15:00',1.09),('15128','2014-02-17','09:20:00',1.16),('15128','2014-02-17','09:25:00',1.23),('15128','2014-02-17','09:30:00',1.3),('15128','2014-02-17','09:35:00',1.36),('15128','2014-02-17','09:40:00',1.41),('15128','2014-02-17','09:45:00',1.46),('15128','2014-02-17','09:50:00',1.54),('15128','2014-02-17','09:55:00',1.58),('15128','2014-02-17','10:00:00',1.63),('15128','2014-02-17','10:05:00',1.68),('15128','2014-02-17','10:10:00',1.71),('15128','2014-02-17','10:15:00',1.78),('15128','2014-02-17','10:20:00',1.86),('15128','2014-02-17','10:25:00',1.86),('15128','2014-02-17','10:30:00',1.89),('15128','2014-02-17','10:35:00',1.98),('15128','2014-02-17','10:40:00',2.03),('15128','2014-02-17','10:45:00',2.06),('15128','2014-02-17','10:50:00',2.1),('15128','2014-02-17','10:55:00',2.18),('15128','2014-02-17','11:00:00',2.25),('15128','2014-02-17','11:05:00',2.2),('15128','2014-02-17','11:10:00',2.09),('15128','2014-02-17','11:15:00',2.11),('15128','2014-02-17','11:20:00',2.43),('15128','2014-02-17','11:25:00',2.63),('15128','2014-02-17','11:30:00',1.89),('15128','2014-02-17','11:35:00',1.28),('15128','2014-02-17','11:40:00',1.48),('15128','2014-02-17','11:45:00',1.34),('15128','2014-02-17','11:50:00',1.25),('15128','2014-02-17','11:55:00',1.33),('15128','2014-02-17','12:00:00',1.43),('15128','2014-02-17','12:05:00',1.42),('15128','2014-02-17','12:10:00',1.44),('15128','2014-02-17','12:15:00',1.57),('15128','2014-02-17','12:20:00',1.76),('15128','2014-02-17','12:25:00',1.97),('15128','2014-02-17','12:30:00',1.76),('15128','2014-02-17','12:35:00',1.58),('15128','2014-02-17','12:40:00',1.51),('15128','2014-02-17','12:45:00',1.48),('15128','2014-02-17','12:50:00',1.35),('15128','2014-02-17','12:55:00',1.39),('15128','2014-02-17','13:00:00',1.39),('15128','2014-02-17','13:05:00',1.3),('15128','2014-02-17','13:10:00',1.29),('15128','2014-02-17','13:15:00',1.49),('15128','2014-02-17','13:20:00',2.16),('15128','2014-02-17','13:25:00',2.84),('15128','2014-02-17','13:30:00',1.98),('15128','2014-02-17','13:35:00',1.68),('15128','2014-02-17','13:40:00',1.91),('15128','2014-02-17','13:45:00',2.02),('15128','2014-02-17','13:50:00',1.64),('15128','2014-02-17','13:55:00',1.51),('15128','2014-02-17','14:00:00',1.55),('15128','2014-02-17','14:05:00',1.79),('15128','2014-02-17','14:10:00',1.81),('15128','2014-02-17','14:15:00',1.47),('15128','2014-02-17','14:20:00',1.24),('15128','2014-02-17','14:25:00',1.13),('15128','2014-02-17','14:30:00',1.26),('15128','2014-02-17','14:35:00',1.29),('15128','2014-02-17','14:40:00',1.17),('15128','2014-02-17','14:45:00',1.02),('15128','2014-02-17','15:35:00',1.21),('15128','2014-02-17','15:40:00',1.24),('15128','2014-02-17','15:45:00',1.07),('15128','2014-02-17','16:00:00',1.12),('15128','2014-02-17','16:05:00',1.19),('15128','2014-02-16','09:15:00',1.07),('15128','2014-02-16','09:20:00',1.13),('15128','2014-02-16','09:25:00',1.2),('15128','2014-02-16','09:30:00',1.29),('15128','2014-02-16','09:35:00',1.36),('15128','2014-02-16','09:40:00',1.39),('15128','2014-02-16','09:45:00',1.43),('15128','2014-02-16','09:50:00',1.48),('15128','2014-02-16','09:55:00',1.51),('15128','2014-02-16','10:00:00',1.55),('15128','2014-02-16','10:05:00',1.6),('15128','2014-02-16','10:10:00',1.62),('15128','2014-02-16','10:15:00',1.66),('15128','2014-02-16','10:20:00',1.74),('15128','2014-02-16','10:25:00',1.78),('15128','2014-02-16','10:30:00',1.84),('15128','2014-02-16','10:35:00',1.89),('15128','2014-02-16','10:40:00',1.94),('15128','2014-02-16','10:45:00',1.99),('15128','2014-02-16','10:50:00',2.02),('15128','2014-02-16','10:55:00',2.04),('15128','2014-02-16','11:00:00',2.1),('15128','2014-02-16','11:05:00',2.11),('15128','2014-02-16','11:10:00',2.15),('15128','2014-02-16','11:15:00',2.22),('15128','2014-02-16','11:20:00',2.25),('15128','2014-02-16','11:25:00',2.35),('15128','2014-02-16','11:30:00',2.41),('15128','2014-02-16','11:35:00',2.43),('15128','2014-02-16','11:40:00',2.46),('15128','2014-02-16','11:45:00',2.5),('15128','2014-02-16','11:50:00',2.56),('15128','2014-02-16','11:55:00',2.61),('15128','2014-02-16','12:00:00',2.66),('15128','2014-02-16','12:05:00',2.72),('15128','2014-02-16','12:10:00',2.74),('15128','2014-02-16','12:15:00',2.78),('15128','2014-02-16','12:20:00',2.8),('15128','2014-02-16','12:25:00',2.82),('15128','2014-02-16','12:30:00',2.82),('15128','2014-02-16','12:35:00',2.83),('15128','2014-02-16','12:40:00',2.84),('15128','2014-02-16','12:45:00',2.86),('15128','2014-02-16','12:50:00',2.87),('15128','2014-02-16','12:55:00',2.86),('15128','2014-02-16','13:00:00',2.84),('15128','2014-02-16','13:05:00',2.85),('15128','2014-02-16','13:10:00',2.83),('15128','2014-02-16','13:15:00',2.82),('15128','2014-02-16','13:20:00',2.81),('15128','2014-02-16','13:25:00',2.82),('15128','2014-02-16','13:30:00',2.83),('15128','2014-02-16','13:35:00',2.77),('15128','2014-02-16','13:40:00',2.76),('15128','2014-02-16','13:45:00',2.74),('15128','2014-02-16','13:50:00',2.71),('15128','2014-02-16','13:55:00',2.71),('15128','2014-02-16','14:00:00',2.66),('15128','2014-02-16','14:05:00',2.67),('15128','2014-02-16','14:10:00',2.54),('15128','2014-02-16','14:15:00',2.62),('15128','2014-02-16','14:20:00',2.58),('15128','2014-02-16','14:25:00',2.51),('15128','2014-02-16','14:30:00',2.44),('15128','2014-02-16','14:35:00',2.35),('15128','2014-02-16','14:40:00',2.35),('15128','2014-02-16','14:45:00',2.32),('15128','2014-02-16','14:50:00',2.29),('15128','2014-02-16','14:55:00',2.26),('15128','2014-02-16','15:00:00',2.22),('15128','2014-02-16','15:05:00',2.08),('15128','2014-02-16','15:10:00',1.95),('15128','2014-02-16','15:15:00',2.06),('15128','2014-02-16','15:20:00',1.97),('15128','2014-02-16','15:25:00',1.93),('15128','2014-02-16','15:30:00',1.9),('15128','2014-02-16','15:35:00',1.76),('15128','2014-02-16','15:40:00',1.7),('15128','2014-02-16','15:45:00',1.64),('15128','2014-02-16','15:50:00',1.57),('15128','2014-02-16','15:55:00',1.52),('15128','2014-02-16','16:00:00',1.4),('15128','2014-02-16','16:05:00',1.36),('15128','2014-02-16','16:10:00',1.27),('15128','2014-02-16','16:15:00',1.16),('15128','2014-02-16','16:20:00',1.08),('15128','2014-02-15','09:15:00',1.09),('15128','2014-02-15','09:20:00',1.1),('15128','2014-02-15','09:25:00',1.17),('15128','2014-02-15','09:30:00',1.01),('15128','2014-02-15','09:35:00',1.35),('15128','2014-02-15','09:40:00',1.39),('15128','2014-02-15','09:45:00',1.45),('15128','2014-02-15','09:50:00',1.46),('15128','2014-02-15','09:55:00',1.53),('15128','2014-02-15','10:00:00',1.58),('15128','2014-02-15','10:05:00',1.71),('15128','2014-02-15','10:10:00',1.69),('15128','2014-02-15','10:15:00',1.7),('15128','2014-02-15','10:20:00',1.79),('15128','2014-02-15','10:25:00',1.91),('15128','2014-02-15','10:30:00',2.03),('15128','2014-02-15','10:35:00',2.05),('15128','2014-02-15','10:40:00',2.13),('15128','2014-02-15','10:45:00',2.12),('15128','2014-02-15','10:50:00',1.91),('15128','2014-02-15','10:55:00',2.14),('15128','2014-02-15','11:00:00',2.18),('15128','2014-02-15','11:05:00',2.03),('15128','2014-02-15','11:10:00',2.16),('15128','2014-02-15','11:15:00',2.32),('15128','2014-02-15','11:20:00',1.98),('15128','2014-02-15','11:25:00',2.37),('15128','2014-02-15','11:30:00',2.61),('15128','2014-02-15','11:35:00',2.6),('15128','2014-02-15','11:40:00',2.35),('15128','2014-02-15','11:45:00',2.72),('15128','2014-02-15','11:50:00',2.43),('15128','2014-02-15','11:55:00',2.75),('15128','2014-02-15','12:00:00',2.78),('15128','2014-02-15','12:05:00',2.8),('15128','2014-02-15','12:10:00',2.87),('15128','2014-02-15','12:15:00',2.9),('15128','2014-02-15','12:20:00',2.91),('15128','2014-02-15','12:25:00',2.92),('15128','2014-02-15','12:30:00',2.93),('15128','2014-02-15','12:35:00',2.95),('15128','2014-02-15','12:40:00',2.95),('15128','2014-02-15','12:45:00',2.96),('15128','2014-02-15','12:50:00',2.95),('15128','2014-02-15','12:55:00',2.97),('15128','2014-02-15','13:00:00',2.95),('15128','2014-02-15','13:05:00',2.84),('15128','2014-02-15','13:10:00',2.97),('15128','2014-02-15','13:15:00',3.01),('15128','2014-02-15','13:20:00',2.98),('15128','2014-02-15','13:25:00',2.95),('15128','2014-02-15','13:30:00',2.96),('15128','2014-02-15','13:35:00',2.88),('15128','2014-02-15','13:40:00',2.95),('15128','2014-02-15','13:45:00',2.8),('15128','2014-02-15','13:50:00',2.88),('15128','2014-02-15','13:55:00',2.89),('15128','2014-02-15','14:00:00',2.89),('15128','2014-02-15','14:05:00',2.86),('15128','2014-02-15','14:10:00',2.85),('15128','2014-02-15','14:15:00',2.81),('15128','2014-02-15','14:20:00',2.71),('15128','2014-02-15','14:25:00',2.78),('15128','2014-02-15','14:30:00',2.72),('15128','2014-02-15','14:35:00',2.58),('15128','2014-02-15','14:40:00',2.65),('15128','2014-02-15','14:45:00',2.61),('15128','2014-02-15','14:50:00',2.35),('15128','2014-02-15','14:55:00',1.92),('15128','2014-02-15','15:00:00',2.4),('15128','2014-02-15','15:05:00',2.44),('15128','2014-02-15','15:10:00',2.36),('15128','2014-02-15','15:15:00',2.29),('15128','2014-02-15','15:20:00',2.23),('15128','2014-02-15','15:25:00',2.16),('15128','2014-02-15','15:30:00',2.02),('15128','2014-02-15','15:35:00',1.81),('15128','2014-02-15','15:40:00',1.37),('15128','2014-02-15','15:50:00',1.15),('15128','2014-02-15','16:10:00',1.39),('15128','2014-02-15','16:15:00',1.43),('15128','2014-02-15','16:20:00',1.64),('15128','2014-02-15','16:25:00',1.46),('15128','2014-02-15','16:30:00',1.07),('15128','2014-04-27','08:15:00',1.43),('15128','2014-04-27','08:20:00',1.14),('15128','2014-04-27','08:35:00',1.03),('15128','2014-04-27','08:40:00',1.07),('15128','2014-04-27','08:45:00',1.03),('15128','2014-04-27','09:05:00',1.71),('15128','2014-04-27','09:10:00',1.8),('15128','2014-04-27','09:15:00',1.67),('15128','2014-04-27','09:20:00',1.63),('15128','2014-04-27','09:25:00',1.89),('15128','2014-04-27','09:30:00',2.66),('15128','2014-04-27','09:35:00',1.9),('15128','2014-04-27','09:40:00',2.5),('15128','2014-04-27','09:45:00',1.62),('15128','2014-04-27','09:50:00',1.48),('15128','2014-04-27','09:55:00',1.62),('15128','2014-04-27','10:00:00',1.42),('15128','2014-04-27','10:05:00',1.1),('15128','2014-04-27','10:25:00',1.01),('15128','2014-04-27','10:30:00',1.2),('15128','2014-04-27','10:35:00',1.25),('15128','2014-04-27','10:40:00',1.19),('15128','2014-04-27','10:50:00',1.12),('15128','2014-04-27','10:55:00',1.33),('15128','2014-04-27','11:00:00',1.57),('15128','2014-04-27','11:05:00',1.86),('15128','2014-04-27','11:10:00',1.77),('15128','2014-04-27','11:15:00',1.4),('15128','2014-04-27','11:20:00',1.45),('15128','2014-04-27','11:25:00',1.25),('15128','2014-04-27','11:30:00',1.62),('15128','2014-04-27','11:35:00',1.91),('15128','2014-04-27','11:40:00',1.84),('15128','2014-04-27','11:45:00',1.74),('15128','2014-04-27','11:50:00',1.55),('15128','2014-04-27','11:55:00',1.85),('15128','2014-04-27','12:00:00',2.07),('15128','2014-04-27','12:05:00',2.1),('15128','2014-04-27','12:10:00',1.83),('15128','2014-04-27','12:15:00',1.53),('15128','2014-04-27','12:20:00',1.91),('15128','2014-04-27','12:25:00',2.38),('15128','2014-04-27','12:30:00',2.61),('15128','2014-04-27','12:35:00',2.62),('15128','2014-04-27','12:40:00',2.39),('15128','2014-04-27','12:45:00',2.03),('15128','2014-04-27','12:50:00',2.07),('15128','2014-04-27','12:55:00',2.63),('15128','2014-04-27','13:00:00',2.93),('15128','2014-04-27','13:05:00',3.01),('15128','2014-04-27','13:10:00',3.33),('15128','2014-04-27','13:15:00',3.25),('15128','2014-04-27','13:20:00',4.49),('15128','2014-04-27','13:25:00',3.14),('15128','2014-04-27','13:30:00',3.69),('15128','2014-04-27','13:35:00',2.66),('15128','2014-04-27','13:40:00',2.37),('15128','2014-04-27','13:45:00',2.1),('15128','2014-04-27','13:50:00',1.98),('15128','2014-04-27','13:55:00',1.82),('15128','2014-04-27','14:00:00',2.89),('15128','2014-04-27','14:05:00',3.81),('15128','2014-04-27','14:10:00',3.36),('15128','2014-04-27','14:15:00',3.51),('15128','2014-04-27','14:20:00',5.05),('15128','2014-04-27','14:25:00',3.03),('15128','2014-04-27','14:30:00',3.46),('15128','2014-04-27','14:35:00',4.07),('15128','2014-04-27','14:40:00',2.19),('15128','2014-04-27','14:45:00',3.38),('15128','2014-04-27','14:50:00',2.12),('15128','2014-04-27','14:55:00',2.33),('15128','2014-04-27','15:00:00',2.14),('15128','2014-04-27','15:05:00',1.8),('15128','2014-04-27','15:10:00',4.31),('15128','2014-04-27','15:15:00',1.67),('15128','2014-04-27','15:20:00',3.3),('15128','2014-04-27','15:25:00',1.26),('15128','2014-04-27','15:30:00',1.4),('15128','2014-04-27','15:35:00',1.92),('15128','2014-04-27','15:40:00',2.31),('15128','2014-04-27','15:45:00',1.02),('15128','2014-04-27','15:50:00',1.41),('15128','2014-04-27','15:55:00',2.36),('15128','2014-04-27','16:10:00',1.37),('15128','2014-04-27','16:15:00',1.48),('15128','2014-04-27','16:20:00',1.14),('15128','2014-04-27','16:25:00',1.68),('15128','2014-04-27','16:30:00',3.05),('15128','2014-04-27','16:35:00',1.37),('15128','2014-04-27','16:55:00',1.15),('15128','2014-04-27','17:00:00',2.13),('15128','2014-04-27','17:05:00',1.29),('15128','2014-04-27','17:50:00',1.07),('15128','2014-04-27','17:55:00',1.05),('15128','2014-02-14','09:15:00',1.02),('15128','2014-02-14','09:20:00',1.09),('15128','2014-02-14','09:25:00',1.15),('15128','2014-02-14','09:30:00',1.21),('15128','2014-02-14','09:35:00',1.27),('15128','2014-02-14','09:40:00',1.33),('15128','2014-02-14','09:45:00',1.39),('15128','2014-02-14','09:50:00',1.44),('15128','2014-02-14','09:55:00',1.47),('15128','2014-02-14','10:00:00',1.53),('15128','2014-02-14','10:05:00',1.58),('15128','2014-02-14','10:10:00',1.62),('15128','2014-02-14','10:15:00',1.65),('15128','2014-02-14','10:20:00',1.72),('15128','2014-02-14','10:25:00',1.78),('15128','2014-02-14','10:30:00',1.79),('15128','2014-02-14','10:35:00',1.85),('15128','2014-02-14','10:40:00',1.91),('15128','2014-02-14','10:45:00',1.81),('15128','2014-02-14','10:50:00',2),('15128','2014-02-14','10:55:00',2.04),('15128','2014-02-14','11:00:00',2.04),('15128','2014-02-14','11:05:00',2.12),('15128','2014-02-14','11:10:00',2.2),('15128','2014-02-14','11:15:00',2.24),('15128','2014-02-14','11:20:00',2.28),('15128','2014-02-14','11:25:00',2.42),('15128','2014-02-14','11:30:00',2.48),('15128','2014-02-14','11:35:00',2.5),('15128','2014-02-14','11:40:00',2.53),('15128','2014-02-14','11:45:00',2.61),('15128','2014-02-14','12:15:00',2.99),('15128','2014-02-14','12:20:00',3.06),('15128','2014-02-14','12:25:00',1.78),('15128','2014-02-14','12:30:00',2.74),('15128','2014-02-14','12:35:00',2.94),('15128','2014-02-14','12:40:00',3.01),('15128','2014-02-14','12:45:00',3.05),('15128','2014-02-14','12:50:00',3.04),('15128','2014-02-14','12:55:00',3.01),('15128','2014-02-14','13:00:00',3.02),('15128','2014-02-14','13:05:00',2.99),('15128','2014-02-14','13:10:00',2.98),('15128','2014-02-14','13:15:00',2.98),('15128','2014-02-14','13:20:00',2.97),('15128','2014-02-14','13:25:00',3.02),('15128','2014-02-14','13:30:00',2.31),('15128','2014-02-14','13:35:00',2.94),('15128','2014-02-14','13:40:00',2.97),('15128','2014-02-14','13:45:00',2.87),('15128','2014-02-14','13:50:00',2.86),('15128','2014-02-14','13:55:00',2.83),('15128','2014-02-14','14:00:00',2.81),('15128','2014-02-14','14:05:00',2.79),('15128','2014-02-14','14:10:00',2.76),('15128','2014-02-14','14:15:00',2.71),('15128','2014-02-14','14:20:00',2.71),('15128','2014-02-14','14:25:00',2.69),('15128','2014-02-14','14:30:00',2.65),('15128','2014-02-14','14:35:00',2.61),('15128','2014-02-14','14:40:00',2.58),('15128','2014-02-14','14:45:00',2.54),('15128','2014-02-14','14:50:00',2.5),('15128','2014-02-14','14:55:00',2.43),('15128','2014-02-14','15:00:00',2.38),('15128','2014-02-14','15:05:00',2.33),('15128','2014-02-14','15:10:00',2.28),('15128','2014-02-14','15:15:00',2.23),('15128','2014-02-14','15:20:00',2.16),('15128','2014-02-14','15:25:00',2.1),('15128','2014-02-14','15:30:00',2.03),('15128','2014-02-14','15:35:00',1.93),('15128','2014-02-14','15:40:00',1.85),('15128','2014-02-14','15:45:00',1.77),('15128','2014-02-14','15:50:00',1.7),('15128','2014-02-14','15:55:00',1.66),('15128','2014-02-14','16:00:00',1.59),('15128','2014-02-14','16:05:00',1.49),('15128','2014-02-14','16:10:00',1.38),('15128','2014-02-14','16:15:00',1.3),('15128','2014-02-14','16:20:00',1.21),('15128','2014-02-14','16:25:00',1.12),('15128','2014-02-13','09:30:00',1.18),('15128','2014-02-13','09:35:00',1.07),('15128','2014-02-13','09:40:00',1.32),('15128','2014-02-13','09:45:00',1.31),('15128','2014-02-13','09:50:00',1.44),('15128','2014-02-13','09:55:00',1.3),('15128','2014-02-13','10:00:00',1.29),('15128','2014-02-13','10:05:00',1.53),('15128','2014-02-13','10:10:00',1.56),('15128','2014-02-13','10:15:00',1.55),('15128','2014-02-13','10:20:00',1.26),('15128','2014-02-13','10:25:00',1.9),('15128','2014-02-13','10:30:00',1.85),('15128','2014-02-13','10:35:00',1.2),('15128','2014-02-13','10:40:00',1.86),('15128','2014-02-13','10:45:00',1.9),('15128','2014-02-13','10:50:00',2.15),('15128','2014-02-13','10:55:00',2.2),('15128','2014-02-13','11:00:00',2.26),('15128','2014-02-13','11:05:00',2.26),('15128','2014-02-13','11:10:00',2.29),('15128','2014-02-13','11:15:00',2.37),('15128','2014-02-13','11:20:00',2.4),('15128','2014-02-13','11:25:00',2.64),('15128','2014-02-13','11:30:00',2.81),('15128','2014-02-13','11:35:00',2.74),('15128','2014-02-13','11:40:00',2.76),('15128','2014-02-13','11:45:00',2.42),('15128','2014-02-13','11:50:00',2.84),('15128','2014-02-13','11:55:00',2.96),('15128','2014-02-13','12:00:00',2.95),('15128','2014-02-13','12:05:00',2.95),('15128','2014-02-13','12:10:00',2.95),('15128','2014-02-13','12:15:00',2.99),('15128','2014-02-13','12:20:00',3.02),('15128','2014-02-13','12:25:00',2.89),('15128','2014-02-13','12:30:00',2.96),('15128','2014-02-13','12:35:00',2.96),('15128','2014-02-13','12:40:00',3.06),('15128','2014-02-13','12:45:00',3.08),('15128','2014-02-13','12:50:00',3.1),('15128','2014-02-13','12:55:00',3.09),('15128','2014-02-13','13:00:00',3.12),('15128','2014-02-13','13:05:00',3.12),('15128','2014-02-13','13:10:00',3.13),('15128','2014-02-13','13:15:00',3.12),('15128','2014-02-13','13:20:00',3.09),('15128','2014-02-13','13:25:00',3.09),('15128','2014-02-13','13:30:00',3.08),('15128','2014-02-13','13:35:00',3.05),('15128','2014-02-13','13:40:00',3.03),('15128','2014-02-13','13:45:00',3.01),('15128','2014-02-13','13:50:00',3.01),('15128','2014-02-13','13:55:00',2.96),('15128','2014-02-13','14:00:00',2.94),('15128','2014-02-13','14:05:00',2.92),('15128','2014-02-13','14:10:00',2.89),('15128','2014-02-13','14:15:00',2.85),('15128','2014-02-13','14:20:00',2.8),('15128','2014-02-13','14:25:00',2.77),('15128','2014-02-13','14:30:00',2.74),('15128','2014-02-13','14:35:00',2.71),('15128','2014-02-13','14:40:00',2.67),('15128','2014-02-13','14:45:00',2.62),('15128','2014-02-13','14:50:00',2.56),('15128','2014-02-13','14:55:00',2.49),('15128','2014-02-13','15:00:00',2.41),('15128','2014-02-13','15:05:00',2.35),('15128','2014-02-13','15:10:00',2.31),('15128','2014-02-13','15:15:00',2.24),('15128','2014-02-13','15:20:00',2.19),('15128','2014-02-13','15:25:00',2.12),('15128','2014-02-13','15:30:00',2.05),('15128','2014-02-13','15:35:00',1.95),('15128','2014-02-13','15:40:00',1.87),('15128','2014-02-13','15:45:00',1.81),('15128','2014-02-13','15:50:00',1.74),('15128','2014-02-13','15:55:00',1.65),('15128','2014-02-13','16:00:00',1.57),('15128','2014-02-13','16:05:00',1.46),('15128','2014-02-13','16:10:00',1.36),('15128','2014-02-13','16:15:00',1.26),('15128','2014-02-13','16:20:00',1.17),('15128','2014-02-13','16:25:00',1.08),('15128','2014-02-12','09:20:00',1.08),('15128','2014-02-12','09:25:00',1.14),('15128','2014-02-12','09:30:00',1.21),('15128','2014-02-12','09:35:00',1.28),('15128','2014-02-12','09:40:00',1.34),('15128','2014-02-12','09:45:00',1.4),('15128','2014-02-12','09:50:00',1.46),('15128','2014-02-12','09:55:00',1.52),('15128','2014-02-12','10:00:00',1.57),('15128','2014-02-12','10:05:00',1.63),('15128','2014-02-12','10:10:00',1.66),('15128','2014-02-12','10:15:00',1.7),('15128','2014-02-12','10:20:00',1.74),('15128','2014-02-12','10:25:00',1.8),('15128','2014-02-12','10:30:00',1.86),('15128','2014-02-12','10:35:00',1.92),('15128','2014-02-12','10:40:00',1.95),('15128','2014-02-12','10:45:00',1.99),('15128','2014-02-12','10:50:00',2.08),('15128','2014-02-12','10:55:00',2.1),('15128','2014-02-12','11:00:00',2.12),('15128','2014-02-12','11:05:00',2.22),('15128','2014-02-12','11:10:00',2.35),('15128','2014-02-12','11:15:00',2.48),('15128','2014-02-12','11:20:00',2.57),('15128','2014-02-12','11:25:00',2.65),('15128','2014-02-12','11:30:00',2.71),('15128','2014-02-12','11:35:00',2.01),('15128','2014-02-12','11:40:00',2.31),('15128','2014-02-12','11:45:00',2.02),('15128','2014-02-12','11:50:00',1.03),('15128','2014-02-12','11:55:00',1.8),('15128','2014-02-12','12:00:00',2.47),('15128','2014-02-12','12:05:00',1.5),('15128','2014-02-12','12:15:00',1.57),('15128','2014-02-12','12:20:00',1.51),('15128','2014-02-12','12:25:00',1.38),('15128','2014-02-12','12:30:00',1.66),('15128','2014-02-12','12:35:00',3.46),('15128','2014-02-12','12:40:00',3.42),('15128','2014-02-12','12:45:00',3.31),('15128','2014-02-12','12:50:00',3.44),('15128','2014-02-12','12:55:00',3.3),('15128','2014-02-12','13:00:00',3.41),('15128','2014-02-12','13:05:00',3.42),('15128','2014-02-12','13:10:00',3.34),('15128','2014-02-12','13:15:00',3.08),('15128','2014-02-12','13:20:00',3.04),('15128','2014-02-12','13:25:00',3.06),('15128','2014-02-12','13:30:00',3.05),('15128','2014-02-12','13:35:00',3.03),('15128','2014-02-12','13:40:00',3.03),('15128','2014-02-12','13:45:00',3.02),('15128','2014-02-12','13:50:00',3.02),('15128','2014-02-12','13:55:00',3),('15128','2014-02-12','14:00:00',2.52),('15128','2014-02-12','14:05:00',2.98),('15128','2014-02-12','14:10:00',2.61),('15128','2014-02-12','14:15:00',2.9),('15128','2014-02-12','14:20:00',2.86),('15128','2014-02-12','14:25:00',2.85),('15128','2014-02-12','14:30:00',2.16),('15128','2014-02-12','14:35:00',1.84),('15128','2014-02-12','14:40:00',2.91),('15128','2014-02-12','14:45:00',1.26),('15128','2014-02-12','14:50:00',2.49),('15128','2014-02-12','14:55:00',1.99),('15128','2014-02-12','15:00:00',1.12),('15128','2014-02-12','15:05:00',1.12),('15128','2014-02-12','15:15:00',1.98),('15128','2014-02-12','15:20:00',1.4),('15128','2014-02-12','15:30:00',1.56),('15128','2014-02-12','15:35:00',1.18),('15128','2014-02-12','15:45:00',1.4),('15128','2014-02-12','15:50:00',1.92),('15128','2014-02-12','15:55:00',1.76),('15128','2014-02-12','16:00:00',1.16),('15128','2014-02-12','16:05:00',1.49),('15128','2014-02-12','16:10:00',1.34),('15128','2014-02-11','09:20:00',1.07),('15128','2014-02-11','09:25:00',1.13),('15128','2014-02-11','09:50:00',1.38),('15128','2014-02-11','09:55:00',1.47),('15128','2014-02-11','10:00:00',1.25),('15128','2014-02-11','10:05:00',1.07),('15128','2014-02-11','10:10:00',1.03),('15128','2014-02-11','10:15:00',1.04),('15128','2014-02-11','10:20:00',1.12),('15128','2014-02-11','10:25:00',1.25),('15128','2014-02-11','10:30:00',1.15),('15128','2014-02-11','10:35:00',1.59),('15128','2014-02-11','10:40:00',1.22),('15128','2014-02-11','10:45:00',1.23),('15128','2014-02-11','10:50:00',1.19),('15128','2014-02-11','10:55:00',1.03),('15128','2014-02-11','11:00:00',1.03),('15128','2014-02-11','11:05:00',1.09),('15128','2014-02-11','11:10:00',1.2),('15128','2014-02-11','11:15:00',1.91),('15128','2014-02-11','11:20:00',2.14),('15128','2014-02-11','11:25:00',2.53),('15128','2014-02-11','11:30:00',2.96),('15128','2014-02-11','11:35:00',2.46),('15128','2014-02-11','11:40:00',1.57),('15128','2014-02-11','11:45:00',2.51),('15128','2014-02-11','11:50:00',1.56),('15128','2014-02-11','11:55:00',1.41),('15128','2014-02-11','12:00:00',1.09),('15128','2014-02-11','12:05:00',1.27),('15128','2014-02-11','12:10:00',1.23),('15128','2014-02-11','12:15:00',1.04),('15128','2014-02-11','12:20:00',1.02),('15128','2014-02-11','12:25:00',1.13),('15128','2014-02-11','12:30:00',1.24),('15128','2014-02-11','12:35:00',1.33),('15128','2014-02-11','12:40:00',1.36),('15128','2014-02-11','12:45:00',1.46),('15128','2014-02-11','12:50:00',1.66),('15128','2014-02-11','12:55:00',1.72),('15128','2014-02-11','13:00:00',1.75),('15128','2014-02-11','13:05:00',1.72),('15128','2014-02-11','13:10:00',1.61),('15128','2014-02-11','13:15:00',2.2),('15128','2014-02-11','13:20:00',3.05),('15128','2014-02-11','13:25:00',2.22),('15128','2014-02-11','13:30:00',2.46),('15128','2014-02-11','13:35:00',1.91),('15128','2014-02-11','13:40:00',1.28),('15128','2014-02-11','13:45:00',1.22),('15128','2014-02-11','13:50:00',1.29),('15128','2014-02-11','13:55:00',1.3),('15128','2014-02-11','14:00:00',1.5),('15128','2014-02-11','14:05:00',1.68),('15128','2014-02-11','14:10:00',3.09),('15128','2014-02-11','14:15:00',2.98),('15128','2014-02-11','14:20:00',2.3),('15128','2014-02-11','14:25:00',3.2),('15128','2014-02-11','14:30:00',2.89),('15128','2014-02-11','14:35:00',3.01),('15128','2014-02-11','14:40:00',2.86),('15128','2014-02-11','14:45:00',2.03),('15128','2014-02-11','14:50:00',2.48),('15128','2014-02-11','14:55:00',2.53),('15128','2014-02-11','15:00:00',1.81),('15128','2014-02-11','15:10:00',2.15),('15128','2014-02-11','15:15:00',1.15),('15128','2014-02-11','15:20:00',1.91),('15128','2014-02-11','15:25:00',1.26),('15128','2014-02-11','15:30:00',1.02),('15128','2014-02-11','15:35:00',1.43),('15128','2014-02-11','15:40:00',2.38),('15128','2014-02-11','15:45:00',1.16),('15128','2014-02-11','15:50:00',1.11),('15128','2014-02-11','15:55:00',1.11),('15128','2014-02-10','09:30:00',1.01),('15128','2014-02-10','09:45:00',1.07),('15128','2014-02-10','09:50:00',1.17),('15128','2014-02-10','09:55:00',1.03),('15128','2014-02-10','10:10:00',1.02),('15128','2014-02-10','10:15:00',1.19),('15128','2014-02-10','10:20:00',1.28),('15128','2014-02-10','10:25:00',1.39),('15128','2014-02-10','10:30:00',1.5),('15128','2014-02-10','10:35:00',1.65),('15128','2014-02-10','10:40:00',1.58),('15128','2014-02-10','10:45:00',1.5),('15128','2014-02-10','10:50:00',1.77),('15128','2014-02-10','10:55:00',1.74),('15128','2014-02-10','11:00:00',1.83),('15128','2014-02-10','11:05:00',2.08),('15128','2014-02-10','11:10:00',1.89),('15128','2014-02-10','11:15:00',1.8),('15128','2014-02-10','11:20:00',2.15),('15128','2014-02-10','11:25:00',2.33),('15128','2014-02-10','11:30:00',2.29),('15128','2014-02-10','11:35:00',2.17),('15128','2014-02-10','11:40:00',2.27),('15128','2014-02-10','11:45:00',2.18),('15128','2014-02-10','11:50:00',1.98),('15128','2014-02-10','11:55:00',1.59),('15128','2014-02-10','12:00:00',1.4),('15128','2014-02-10','12:05:00',1.45),('15128','2014-02-10','12:10:00',2.03),('15128','2014-02-10','12:15:00',1.88),('15128','2014-02-10','12:20:00',1.27),('15128','2014-02-10','12:25:00',1.49),('15128','2014-02-10','12:30:00',2),('15128','2014-02-10','12:35:00',2.28),('15128','2014-02-10','12:40:00',1.71),('15128','2014-02-10','12:45:00',1.61),('15128','2014-02-10','12:50:00',2.29),('15128','2014-02-10','12:55:00',1.52),('15128','2014-02-10','13:00:00',2.43),('15128','2014-02-10','13:05:00',1.89),('15128','2014-02-10','13:10:00',2.77),('15128','2014-02-10','13:15:00',3.17),('15128','2014-02-10','13:20:00',2.97),('15128','2014-02-10','13:25:00',2.62),('15128','2014-02-10','13:30:00',2.47),('15128','2014-02-10','13:35:00',2.46),('15128','2014-02-10','13:40:00',2.64),('15128','2014-02-10','13:45:00',1.88),('15128','2014-02-10','13:50:00',2.24),('15128','2014-02-10','13:55:00',1.78),('15128','2014-02-10','14:00:00',1.25),('15128','2014-02-10','14:05:00',1.31),('15128','2014-02-10','14:10:00',1.84),('15128','2014-02-10','14:15:00',1.48),('15128','2014-02-10','14:20:00',1.54),('15128','2014-02-10','14:25:00',1.55),('15128','2014-02-10','14:30:00',1.49),('15128','2014-02-10','14:35:00',1.27),('15128','2014-02-10','14:40:00',1.07),('15128','2014-02-10','14:45:00',1.01),('15128','2014-02-10','15:10:00',1.34),('15128','2014-02-10','15:15:00',1.3),('15128','2014-02-10','15:20:00',1.51),('15128','2014-02-10','15:25:00',1.02),('15128','2014-02-10','16:15:00',1.09),('15128','2014-02-09','13:00:00',1),('15128','2014-02-08','11:25:00',1.02),('15128','2014-02-08','12:05:00',1.87),('15128','2014-02-08','12:10:00',1.17),('15128','2014-02-08','12:15:00',1.99),('15128','2014-02-08','12:40:00',1.44),('15128','2014-02-08','12:55:00',2.65),('15128','2014-02-08','13:00:00',2.94),('15128','2014-02-08','13:05:00',1.17),('15128','2014-02-08','13:10:00',1.8),('15128','2014-02-08','13:20:00',1.29),('15128','2014-02-08','13:25:00',1.91),('15128','2014-02-08','13:35:00',3.02),('15128','2014-02-08','13:40:00',1.12),('15128','2014-02-08','13:45:00',2.65),('15128','2014-02-08','13:50:00',2.18),('15128','2014-02-08','13:55:00',2.62),('15128','2014-02-08','14:00:00',2.86),('15128','2014-02-08','14:05:00',1.8),('15128','2014-02-08','14:10:00',1.15),('15128','2014-02-08','14:15:00',1.3),('15128','2014-02-08','14:20:00',2.58),('15128','2014-02-08','14:25:00',2.76),('15128','2014-02-08','14:30:00',1.72),('15128','2014-02-08','14:35:00',1.35),('15128','2014-02-08','14:40:00',1.5),('15128','2014-02-08','14:45:00',1.49),('15128','2014-02-08','14:50:00',1.2),('15128','2014-02-08','14:55:00',1.43),('15128','2014-02-08','15:05:00',1.55),('15128','2014-02-08','15:10:00',1.81),('15128','2014-02-08','15:15:00',1.54),('15128','2014-02-08','15:20:00',1.55),('15128','2014-02-08','15:25:00',1.75),('15128','2014-02-08','15:30:00',1.6),('15128','2014-02-08','15:35:00',1.67),('15128','2014-02-08','15:40:00',1.6),('15128','2014-02-08','15:45:00',1.43),('15128','2014-02-08','15:50:00',1.32),('15128','2014-02-08','15:55:00',1.23),('15128','2014-02-08','16:00:00',1.14),('15128','2014-02-08','16:05:00',1.11),('15128','2014-02-07','09:50:00',1),('15128','2014-02-07','09:55:00',1.33),('15128','2014-02-07','10:00:00',1.39),('15128','2014-02-07','10:05:00',1.42),('15128','2014-02-07','10:10:00',1.52),('15128','2014-02-07','10:15:00',1.58),('15128','2014-02-07','10:25:00',1.37),('15128','2014-02-07','10:30:00',1.24),('15128','2014-02-07','10:45:00',1.36),('15128','2014-02-07','10:55:00',1.99),('15128','2014-02-07','11:00:00',2.23),('15128','2014-02-07','11:05:00',2.89),('15128','2014-02-07','11:10:00',1.8),('15128','2014-02-07','11:20:00',1.76),('15128','2014-02-07','11:30:00',1.89),('15128','2014-02-07','11:35:00',1.13),('15128','2014-02-07','11:40:00',1.06),('15128','2014-02-07','11:50:00',1.68),('15128','2014-02-07','11:55:00',2.75),('15128','2014-02-07','12:00:00',1.63),('15128','2014-02-07','12:05:00',1.05),('15128','2014-02-07','12:10:00',2.02),('15128','2014-02-07','12:20:00',1.76),('15128','2014-02-07','12:30:00',1.52),('15128','2014-02-07','12:35:00',2.08),('15128','2014-02-07','12:40:00',2.59),('15128','2014-02-07','12:45:00',1.14),('15128','2014-02-07','12:50:00',1.54),('15128','2014-02-07','12:55:00',3.27),('15128','2014-02-07','13:00:00',3.25),('15128','2014-02-07','13:05:00',2.24),('15128','2014-02-07','13:10:00',1.79),('15128','2014-02-07','13:15:00',2.98),('15128','2014-02-07','13:20:00',2.31),('15128','2014-02-07','13:25:00',3.11),('15128','2014-02-07','13:30:00',2.55),('15128','2014-02-07','13:35:00',1.83),('15128','2014-02-07','13:40:00',1.64),('15128','2014-02-07','13:45:00',1.39),('15128','2014-02-07','13:50:00',1.41),('15128','2014-02-07','13:55:00',1.82),('15128','2014-02-07','14:00:00',2.96),('15128','2014-02-07','14:05:00',3.02),('15128','2014-02-07','14:10:00',2.88),('15128','2014-02-07','14:15:00',2.21),('15128','2014-02-07','14:20:00',1.96),('15128','2014-02-07','14:25:00',2.87),('15128','2014-02-07','14:30:00',1.16),('15128','2014-02-07','14:35:00',2.3),('15128','2014-02-07','14:40:00',2.82),('15128','2014-02-07','14:55:00',1.32),('15128','2014-02-07','15:00:00',1.7),('15128','2014-02-07','15:05:00',1.28),('15128','2014-02-07','15:10:00',1.16),('15128','2014-02-07','15:20:00',1.97),('15128','2014-02-07','15:25:00',1.27),('15128','2014-02-07','15:55:00',1.33),('15128','2014-02-06','09:35:00',1.02),('15128','2014-02-06','09:40:00',1.11),('15128','2014-02-06','09:45:00',1.15),('15128','2014-02-06','09:50:00',1.24),('15128','2014-02-06','09:55:00',1.27),('15128','2014-02-06','10:00:00',1.3),('15128','2014-02-06','10:05:00',1.35),('15128','2014-02-06','10:10:00',1.41),('15128','2014-02-06','10:15:00',1.53),('15128','2014-02-06','10:20:00',1.54),('15128','2014-02-06','10:25:00',1.61),('15128','2014-02-06','10:30:00',1.68),('15128','2014-02-06','10:35:00',1.73),('15128','2014-02-06','10:40:00',1.87),('15128','2014-02-06','10:45:00',1.92),('15128','2014-02-06','10:50:00',1.92),('15128','2014-02-06','10:55:00',1.86),('15128','2014-02-06','11:10:00',1.83),('15128','2014-02-06','11:15:00',1.44),('15128','2014-02-06','11:25:00',1.24),('15128','2014-02-06','11:30:00',2.42),('15128','2014-02-06','11:35:00',1.11),('15128','2014-02-06','11:40:00',2.3),('15128','2014-02-06','11:45:00',1.15),('15128','2014-02-06','11:50:00',1.83),('15128','2014-02-06','11:55:00',2.69),('15128','2014-02-06','12:00:00',3.02),('15128','2014-02-06','12:05:00',2),('15128','2014-02-06','12:10:00',2.99),('15128','2014-02-06','12:15:00',3.09),('15128','2014-02-06','12:20:00',2.11),('15128','2014-02-06','12:30:00',2.56),('15128','2014-02-06','12:35:00',2.19),('15128','2014-02-06','12:40:00',1.32),('15128','2014-02-06','12:45:00',3.1),('15128','2014-02-06','12:50:00',1.56),('15128','2014-02-06','12:55:00',1.15),('15128','2014-02-06','13:00:00',3.33),('15128','2014-02-06','13:05:00',1.84),('15128','2014-02-06','13:10:00',2.09),('15128','2014-02-06','13:15:00',1.93),('15128','2014-02-06','13:20:00',2.71),('15128','2014-02-06','13:25:00',1.98),('15128','2014-02-06','13:30:00',1.05),('15128','2014-02-06','13:35:00',3.06),('15128','2014-02-06','13:40:00',2.91),('15128','2014-02-06','13:45:00',2.82),('15128','2014-02-06','13:50:00',2.73),('15128','2014-02-06','13:55:00',2.72),('15128','2014-02-06','14:00:00',2.69),('15128','2014-02-06','14:05:00',2.67),('15128','2014-02-06','14:10:00',2.65),('15128','2014-02-06','14:15:00',2.6),('15128','2014-02-06','14:20:00',2.56),('15128','2014-02-06','14:25:00',2.52),('15128','2014-02-06','14:30:00',2.49),('15128','2014-02-06','14:35:00',2.38),('15128','2014-02-06','14:40:00',2.45),('15128','2014-02-06','14:45:00',2.43),('15128','2014-02-06','14:50:00',2.33),('15128','2014-02-06','15:00:00',2.26),('15128','2014-02-06','15:05:00',2.17),('15128','2014-02-06','15:10:00',2.03),('15128','2014-02-06','15:15:00',2.06),('15128','2014-02-06','15:20:00',1.97),('15128','2014-02-06','15:25:00',1.88),('15128','2014-02-06','15:30:00',1.8),('15128','2014-02-06','15:35:00',1.75),('15128','2014-02-06','15:40:00',1.65),('15128','2014-02-06','15:45:00',1.58),('15128','2014-02-06','15:50:00',1.49),('15128','2014-02-06','15:55:00',1.38),('15128','2014-02-06','16:00:00',1.3),('15128','2014-02-06','16:05:00',1.23),('15128','2014-02-06','16:10:00',1.16),('15128','2014-02-06','16:15:00',1.06),('15128','2014-02-05','09:40:00',1.07),('15128','2014-02-05','09:45:00',1.2),('15128','2014-02-05','09:50:00',1.26),('15128','2014-02-05','09:55:00',1.31),('15128','2014-02-05','10:00:00',1.37),('15128','2014-02-05','10:05:00',1.4),('15128','2014-02-05','10:10:00',1.45),('15128','2014-02-05','10:15:00',1.51),('15128','2014-02-05','10:20:00',1.55),('15128','2014-02-05','10:25:00',1.6),('15128','2014-02-05','10:30:00',1.57),('15128','2014-02-05','10:35:00',1.75),('15128','2014-02-05','10:40:00',1.88),('15128','2014-02-05','10:45:00',1.34),('15128','2014-02-05','10:50:00',2.21),('15128','2014-02-05','10:55:00',2.13),('15128','2014-02-05','11:00:00',2.11),('15128','2014-02-05','11:05:00',2.1),('15128','2014-02-05','11:10:00',2.11),('15128','2014-02-05','11:15:00',1.09),('15128','2014-02-05','11:20:00',2.29),('15128','2014-02-05','11:25:00',2.43),('15128','2014-02-05','11:30:00',2.44),('15128','2014-02-05','11:35:00',2.44),('15128','2014-02-05','11:40:00',2.48),('15128','2014-02-05','11:45:00',2.5),('15128','2014-02-05','11:50:00',2.56),('15128','2014-02-05','11:55:00',2.38),('15128','2014-02-05','12:00:00',2.62),('15128','2014-02-05','12:05:00',2.25),('15128','2014-02-05','12:10:00',2.72),('15128','2014-02-05','12:15:00',2.84),('15128','2014-02-05','12:20:00',2.78),('15128','2014-02-05','12:25:00',2.76),('15128','2014-02-05','12:30:00',2.77),('15128','2014-02-05','12:35:00',2.8),('15128','2014-02-05','12:40:00',2.8),('15128','2014-02-05','12:45:00',2.8),('15128','2014-02-05','12:50:00',2.83),('15128','2014-02-05','12:55:00',2.84),('15128','2014-02-05','13:00:00',2.82),('15128','2014-02-05','13:05:00',2.82),('15128','2014-02-05','13:10:00',2.83),('15128','2014-02-05','13:15:00',2.83),('15128','2014-02-05','13:20:00',2.82),('15128','2014-02-05','13:25:00',2.83),('15128','2014-02-05','13:30:00',2.8),('15128','2014-02-05','13:35:00',2.79),('15128','2014-02-05','13:40:00',2.78),('15128','2014-02-05','13:45:00',2.73),('15128','2014-02-05','13:50:00',2.73),('15128','2014-02-05','13:55:00',1.86),('15128','2014-02-05','14:00:00',2.69),('15128','2014-02-05','14:05:00',2.68),('15128','2014-02-05','14:10:00',2.62),('15128','2014-02-05','14:15:00',2.57),('15128','2014-02-05','14:20:00',2.54),('15128','2014-02-05','14:25:00',2.19),('15128','2014-02-05','14:30:00',2.49),('15128','2014-02-05','14:35:00',2.42),('15128','2014-02-05','14:40:00',2.21),('15128','2014-02-05','14:45:00',2.31),('15128','2014-02-05','14:50:00',2.27),('15128','2014-02-05','14:55:00',2.22),('15128','2014-02-05','15:00:00',2.17),('15128','2014-02-05','15:05:00',2.1),('15128','2014-02-05','15:10:00',2.05),('15128','2014-02-05','15:15:00',1.98),('15128','2014-02-05','15:20:00',1.91),('15128','2014-02-05','15:25:00',1.83),('15128','2014-02-05','15:30:00',1.78),('15128','2014-02-05','15:35:00',1.72),('15128','2014-02-05','15:40:00',1.65),('15128','2014-02-05','15:45:00',1.57),('15128','2014-02-05','15:50:00',1.47),('15128','2014-02-05','15:55:00',1.39),('15128','2014-02-05','16:00:00',1.3),('15128','2014-02-05','16:05:00',1.2),('15128','2014-02-05','16:10:00',1.12),('15128','2014-02-05','16:15:00',1.03),('15128','2014-04-26','08:50:00',1.02),('15128','2014-04-26','08:55:00',1.17),('15128','2014-04-26','10:05:00',1.04),('15128','2014-04-26','10:10:00',1.49),('15128','2014-04-26','10:15:00',1.5),('15128','2014-04-26','10:20:00',1.6),('15128','2014-04-26','10:25:00',1.16),('15128','2014-04-26','10:45:00',1.33),('15128','2014-04-26','10:50:00',1.19),('15128','2014-04-26','11:05:00',1.28),('15128','2014-04-26','11:10:00',1.17),('15128','2014-04-26','11:25:00',1.81),('15128','2014-04-26','11:30:00',2.23),('15128','2014-04-26','11:35:00',2.9),('15128','2014-04-26','11:40:00',2.34),('15128','2014-04-26','11:45:00',2.25),('15128','2014-04-26','11:50:00',1.68),('15128','2014-04-26','11:55:00',1.92),('15128','2014-04-26','12:00:00',1.77),('15128','2014-04-26','12:05:00',1.82),('15128','2014-04-26','12:10:00',1.98),('15128','2014-04-26','12:15:00',1.38),('15128','2014-04-26','12:20:00',1.36),('15128','2014-04-26','12:25:00',1.81),('15128','2014-04-26','12:30:00',2.31),('15128','2014-04-26','12:35:00',2.57),('15128','2014-04-26','12:40:00',2.43),('15128','2014-04-26','12:45:00',1.88),('15128','2014-04-26','12:50:00',1.93),('15128','2014-04-26','12:55:00',1.3),('15128','2014-04-26','13:00:00',1.13),('15128','2014-04-26','13:05:00',1.78),('15128','2014-04-26','13:10:00',1.6),('15128','2014-04-26','13:15:00',1.7),('15128','2014-04-26','13:20:00',2.05),('15128','2014-04-26','13:25:00',2.69),('15128','2014-04-26','13:30:00',2.35),('15128','2014-04-26','13:35:00',1.66),('15128','2014-04-26','13:40:00',1.31),('15128','2014-04-26','13:45:00',1.5),('15128','2014-04-26','13:50:00',2.35),('15128','2014-04-26','13:55:00',1.55),('15128','2014-04-26','14:00:00',1.88),('15128','2014-04-26','14:05:00',1.62),('15128','2014-04-26','14:10:00',1.39),('15128','2014-04-26','14:15:00',1.47),('15128','2014-04-26','14:20:00',1.99),('15128','2014-04-26','14:25:00',2.12),('15128','2014-04-26','14:30:00',1.75),('15128','2014-04-26','14:35:00',1.86),('15128','2014-04-26','14:40:00',1.81),('15128','2014-04-26','14:45:00',2.28),('15128','2014-04-26','14:50:00',1.77),('15128','2014-04-26','14:55:00',1.8),('15128','2014-04-26','15:00:00',2.39),('15128','2014-04-26','15:05:00',2.77),('15128','2014-04-26','15:10:00',3.02),('15128','2014-04-26','15:15:00',3.43),('15128','2014-04-26','15:20:00',1.65),('15128','2014-04-26','15:35:00',1.22),('15128','2014-04-26','15:40:00',1.22),('15128','2014-02-04','10:15:00',1.09),('15128','2014-02-04','10:20:00',1.08),('15128','2014-02-04','10:25:00',1.26),('15128','2014-02-04','10:30:00',1.88),('15128','2014-02-04','10:35:00',1.75),('15128','2014-02-04','10:40:00',1.74),('15128','2014-02-04','10:45:00',1.83),('15128','2014-02-04','10:50:00',1.81),('15128','2014-02-04','10:55:00',1.78),('15128','2014-02-04','11:00:00',1.75),('15128','2014-02-04','11:05:00',1.39),('15128','2014-02-04','11:10:00',1.62),('15128','2014-02-04','11:15:00',2.34),('15128','2014-02-04','11:20:00',1.68),('15128','2014-02-04','12:30:00',1.02),('15128','2014-02-04','12:35:00',1.05),('15128','2014-02-04','12:40:00',1.21),('15128','2014-02-04','12:45:00',1.98),('15128','2014-02-04','12:50:00',1.45),('15128','2014-02-04','12:55:00',1.81),('15128','2014-02-04','13:00:00',1.97),('15128','2014-02-04','13:05:00',1.94),('15128','2014-02-04','13:10:00',1.48),('15128','2014-02-04','13:30:00',1.09),('15128','2014-02-04','13:35:00',1.47),('15128','2014-02-04','13:40:00',1.52),('15128','2014-02-04','13:45:00',1.41),('15128','2014-02-04','14:10:00',1.07),('15128','2014-02-04','14:15:00',1.05),('15128','2014-02-04','14:20:00',2.3),('15128','2014-02-04','14:25:00',2.76),('15128','2014-02-04','14:30:00',1.89),('15128','2014-02-04','14:35:00',1.62),('15128','2014-02-04','14:40:00',1.1),('15128','2014-02-04','14:50:00',1.13),('15128','2014-02-04','14:55:00',1.07),('15128','2014-02-04','15:25:00',1.09),('15128','2014-02-03','09:40:00',1.02),('15128','2014-02-03','09:45:00',1.28),('15128','2014-02-03','09:50:00',1.3),('15128','2014-02-03','09:55:00',1.32),('15128','2014-02-03','10:00:00',1.35),('15128','2014-02-03','10:05:00',1.41),('15128','2014-02-03','10:10:00',1.36),('15128','2014-02-03','10:15:00',1.51),('15128','2014-02-03','10:20:00',1.6),('15128','2014-02-03','10:25:00',1.61),('15128','2014-02-03','10:30:00',1.67),('15128','2014-02-03','10:35:00',1.94),('15128','2014-02-03','10:40:00',1.32),('15128','2014-02-03','10:45:00',1.83),('15128','2014-02-03','10:50:00',1.9),('15128','2014-02-03','10:55:00',1.82),('15128','2014-02-03','11:00:00',1.16),('15128','2014-02-03','11:05:00',1.57),('15128','2014-02-03','11:10:00',2.03),('15128','2014-02-03','11:15:00',1.52),('15128','2014-02-03','11:20:00',2.47),('15128','2014-02-03','11:35:00',1.11),('15128','2014-02-03','11:40:00',1.32),('15128','2014-02-03','11:45:00',1.23),('15128','2014-02-03','11:50:00',1.03),('15128','2014-02-03','12:00:00',1),('15128','2014-02-03','12:05:00',1.09),('15128','2014-02-03','12:50:00',1.32),('15128','2014-02-03','12:55:00',1.26),('15128','2014-02-03','13:00:00',1.2),('15128','2014-02-03','13:05:00',1.09),('15128','2014-02-03','13:10:00',1.55),('15128','2014-02-03','13:15:00',1.61),('15128','2014-02-03','13:20:00',1.19),('15128','2014-02-02','10:25:00',1.01),('15128','2014-02-02','11:30:00',1.03),('15128','2014-02-02','11:35:00',1.08),('15128','2014-02-02','11:40:00',1.13),('15128','2014-02-02','11:45:00',1.17),('15128','2014-02-02','11:50:00',1.16),('15128','2014-02-02','11:55:00',1.12),('15128','2014-02-02','12:00:00',1.08),('15128','2014-02-02','12:05:00',1.02),('15128','2014-02-02','12:10:00',1.04),('15128','2014-02-02','12:15:00',1.05),('15128','2014-02-02','12:25:00',1.01),('15128','2014-02-02','12:35:00',1.03),('15128','2014-02-02','12:40:00',1.02),('15128','2014-01-31','11:00:00',1.09),('15128','2014-01-31','11:05:00',1.11),('15128','2014-01-31','11:10:00',1.17),('15128','2014-01-31','11:15:00',1.52),('15128','2014-01-31','11:20:00',1.77),('15128','2014-01-31','11:25:00',1.85),('15128','2014-01-31','11:30:00',1.68),('15128','2014-01-31','11:35:00',1.74),('15128','2014-01-31','11:40:00',1.88),('15128','2014-01-31','11:45:00',1.79),('15128','2014-01-31','11:50:00',1.57),('15128','2014-01-31','11:55:00',1.39),('15128','2014-01-31','12:05:00',1.58),('15128','2014-01-31','12:10:00',1.96),('15128','2014-01-31','12:15:00',1.63),('15128','2014-01-31','12:30:00',1.35),('15128','2014-01-31','12:35:00',2.01),('15128','2014-01-31','12:40:00',1.89),('15128','2014-01-31','12:45:00',2.05),('15128','2014-01-31','12:50:00',1.92),('15128','2014-01-31','12:55:00',1.87),('15128','2014-01-31','13:00:00',1.39),('15128','2014-01-30','10:35:00',1.08),('15128','2014-01-29','09:55:00',1.14),('15128','2014-01-29','10:00:00',1.29),('15128','2014-01-29','10:05:00',1.75),('15128','2014-01-29','10:10:00',1.85),('15128','2014-01-29','10:15:00',1.43),('15128','2014-01-29','10:20:00',1.22),('15128','2014-01-29','10:25:00',1.21),('15128','2014-01-29','10:30:00',1.2),('15128','2014-01-29','10:35:00',1.38),('15128','2014-01-29','10:40:00',1.16),('15128','2014-01-29','10:45:00',1.19),('15128','2014-01-29','10:50:00',1.3),('15128','2014-01-29','10:55:00',1.13),('15128','2014-01-29','11:00:00',1.37),('15128','2014-01-29','11:05:00',1.52),('15128','2014-01-29','11:10:00',1.48),('15128','2014-01-29','11:15:00',1.96),('15128','2014-01-29','11:20:00',1.59),('15128','2014-01-29','11:25:00',2.07),('15128','2014-01-29','11:30:00',2.08),('15128','2014-01-29','11:35:00',1.91),('15128','2014-01-29','11:40:00',2.38),('15128','2014-01-29','11:45:00',2.55),('15128','2014-01-29','11:50:00',2.51),('15128','2014-01-29','11:55:00',2.47),('15128','2014-01-29','12:00:00',2.01),('15128','2014-01-29','12:05:00',2.2),('15128','2014-01-29','12:10:00',1.45),('15128','2014-01-29','12:15:00',1.31),('15128','2014-01-29','12:20:00',1.87),('15128','2014-01-29','12:25:00',2.17),('15128','2014-01-29','12:30:00',2.22),('15128','2014-01-29','12:35:00',2.55),('15128','2014-01-29','12:40:00',2.57),('15128','2014-01-29','12:45:00',2.53),('15128','2014-01-29','12:50:00',2.52),('15128','2014-01-29','12:55:00',2.56),('15128','2014-01-29','13:00:00',2.58),('15128','2014-01-29','13:05:00',2.6),('15128','2014-01-29','13:10:00',2.68),('15128','2014-01-29','13:15:00',2.62),('15128','2014-01-29','13:20:00',2.6),('15128','2014-01-29','13:25:00',2.42),('15128','2014-01-29','13:30:00',1.95),('15128','2014-01-29','13:35:00',1.93),('15128','2014-01-29','13:40:00',2.09),('15128','2014-01-29','13:45:00',2.67),('15128','2014-01-29','13:50:00',2.67),('15128','2014-01-29','13:55:00',2.4),('15128','2014-01-29','14:00:00',1.98),('15128','2014-01-29','14:05:00',1.88),('15128','2014-01-29','14:10:00',2.06),('15128','2014-01-29','14:15:00',1.92),('15128','2014-01-29','14:20:00',1.52),('15128','2014-01-29','14:25:00',1.63),('15128','2014-01-29','14:30:00',1.82),('15128','2014-01-29','14:35:00',1.54),('15128','2014-01-29','14:40:00',1.87),('15128','2014-01-29','14:45:00',2.26),('15128','2014-01-29','14:50:00',2.16),('15128','2014-01-29','14:55:00',2.09),('15128','2014-01-29','15:00:00',1.9),('15128','2014-01-29','15:05:00',1.62),('15128','2014-01-29','15:10:00',1.31),('15128','2014-01-29','15:15:00',1.66),('15128','2014-01-29','15:20:00',1.7),('15128','2014-01-29','15:25:00',1.69),('15128','2014-01-29','15:30:00',1.23),('15128','2014-01-29','15:35:00',1.36),('15128','2014-01-29','15:40:00',1.16),('15128','2014-01-28','09:35:00',1.01),('15128','2014-01-28','10:05:00',1.01),('15128','2014-01-28','10:10:00',1.05),('15128','2014-01-28','10:20:00',2.04),('15128','2014-01-28','10:25:00',1.63),('15128','2014-01-28','10:30:00',1.55),('15128','2014-01-28','10:35:00',1.44),('15128','2014-01-28','10:40:00',1.41),('15128','2014-01-28','10:45:00',1.28),('15128','2014-01-28','10:50:00',1.35),('15128','2014-01-28','10:55:00',1.39),('15128','2014-01-28','11:00:00',1.6),('15128','2014-01-28','11:05:00',1.84),('15128','2014-01-28','11:10:00',1.58),('15128','2014-01-28','11:15:00',1.5),('15128','2014-01-28','11:20:00',1.53),('15128','2014-01-28','11:25:00',1.41),('15128','2014-01-28','11:30:00',1.57),('15128','2014-01-28','11:35:00',1.96),('15128','2014-01-28','11:40:00',2.16),('15128','2014-01-28','11:45:00',2.33),('15128','2014-01-28','11:50:00',1.11),('15128','2014-01-28','12:15:00',1.01),('15128','2014-01-28','12:20:00',1.23),('15128','2014-01-28','12:35:00',1.2),('15128','2014-01-28','12:40:00',1.8),('15128','2014-01-28','12:45:00',2.21),('15128','2014-01-28','12:50:00',2.96),('15128','2014-01-28','12:55:00',2.6),('15128','2014-01-28','13:00:00',2.43),('15128','2014-01-28','13:05:00',2.43),('15128','2014-01-28','13:35:00',1.69),('15128','2014-01-28','13:40:00',2.18),('15128','2014-01-28','13:45:00',2.43),('15128','2014-01-28','13:50:00',2.92),('15128','2014-01-28','13:55:00',2.88),('15128','2014-01-28','14:00:00',2.43),('15128','2014-01-28','14:05:00',1.29),('15128','2014-01-27','09:50:00',1.12),('15128','2014-01-27','09:55:00',1.14),('15128','2014-01-27','10:00:00',1.18),('15128','2014-01-27','10:05:00',1.26),('15128','2014-01-27','10:10:00',1.37),('15128','2014-01-27','10:15:00',1.47),('15128','2014-01-27','10:20:00',1.54),('15128','2014-01-27','10:25:00',1.54),('15128','2014-01-27','10:30:00',1.61),('15128','2014-01-27','10:35:00',1.82),('15128','2014-01-27','10:40:00',1),('15128','2014-01-27','10:45:00',1.24),('15128','2014-01-27','10:55:00',1.56),('15128','2014-01-27','11:00:00',1.47),('15128','2014-01-27','11:05:00',1.24),('15128','2014-01-27','11:10:00',1.25),('15128','2014-01-27','11:15:00',1.74),('15128','2014-01-27','11:20:00',2.23),('15128','2014-01-27','11:25:00',1.81),('15128','2014-01-27','11:30:00',2.36),('15128','2014-01-27','11:35:00',2.49),('15128','2014-01-27','11:40:00',2.55),('15128','2014-01-27','11:45:00',2.74),('15128','2014-01-27','11:50:00',2.45),('15128','2014-01-27','11:55:00',2.42),('15128','2014-01-27','12:00:00',2.11),('15128','2014-01-27','12:05:00',2.03),('15128','2014-01-27','12:10:00',1.88),('15128','2014-01-27','12:15:00',1.57),('15128','2014-01-27','12:20:00',1.19),('15128','2014-01-27','12:25:00',1.18),('15128','2014-01-27','12:30:00',1.22),('15128','2014-01-27','12:35:00',1.32),('15128','2014-01-27','12:40:00',1.23),('15128','2014-01-27','12:45:00',2.49),('15128','2014-01-27','12:50:00',3.31),('15128','2014-01-27','12:55:00',2.3),('15128','2014-01-27','13:00:00',3.02),('15128','2014-01-27','13:05:00',2.37),('15128','2014-01-27','13:10:00',2.57),('15128','2014-01-27','13:15:00',2.67),('15128','2014-01-27','13:20:00',2.5),('15128','2014-01-27','13:25:00',2.65),('15128','2014-01-27','13:30:00',2.54),('15128','2014-01-27','13:35:00',2.83),('15128','2014-01-27','13:40:00',2.81),('15128','2014-01-27','13:45:00',2.66),('15128','2014-01-27','13:50:00',2.61),('15128','2014-01-27','13:55:00',2.56),('15128','2014-01-27','14:00:00',2.53),('15128','2014-01-27','14:05:00',2.5),('15128','2014-01-27','14:10:00',2.45),('15128','2014-01-27','14:15:00',2.41),('15128','2014-01-27','14:20:00',2.38),('15128','2014-01-27','14:25:00',2.36),('15128','2014-01-27','14:30:00',2.32),('15128','2014-01-27','14:35:00',2.25),('15128','2014-01-27','14:40:00',2.22),('15128','2014-01-27','14:45:00',2.17),('15128','2014-01-27','14:50:00',2.11),('15128','2014-01-27','14:55:00',2.06),('15128','2014-01-27','15:00:00',2),('15128','2014-01-27','15:05:00',1.93),('15128','2014-01-27','15:10:00',1.87),('15128','2014-01-27','15:15:00',1.79),('15128','2014-01-27','15:20:00',1.73),('15128','2014-01-27','15:25:00',1.69),('15128','2014-01-27','15:30:00',1.61),('15128','2014-01-27','15:35:00',1.51),('15128','2014-01-27','15:40:00',1.42),('15128','2014-01-27','15:45:00',1.33),('15128','2014-01-27','15:50:00',1.21),('15128','2014-01-27','15:55:00',1.11),('15128','2014-01-27','16:00:00',1),('15529','2014-05-04','08:40:00',1.05),('15529','2014-05-04','08:45:00',1.1),('15529','2014-05-04','08:50:00',1.16),('15529','2014-05-04','08:55:00',1.2),('15529','2014-05-04','09:00:00',1.25),('15529','2014-05-04','09:05:00',1.29),('15529','2014-05-04','09:10:00',1.33),('15529','2014-05-04','09:15:00',1.37),('15529','2014-05-04','09:20:00',1.41),('15529','2014-05-04','09:25:00',1.46),('15529','2014-05-04','09:30:00',1.49),('15529','2014-05-04','09:35:00',1.55),('15529','2014-05-04','09:40:00',1.58),('15529','2014-05-04','09:45:00',1.63),('15529','2014-05-04','09:50:00',1.67),('15529','2014-05-04','09:55:00',1.74),('15529','2014-05-04','10:00:00',1.76),('15529','2014-05-04','10:05:00',1.78),('15529','2014-05-04','10:10:00',1.82),('15529','2014-05-04','10:15:00',1.85),('15529','2014-05-04','10:20:00',1.88),('15529','2014-05-04','10:25:00',1.92),('15529','2014-05-04','10:30:00',1.95),('15529','2014-05-04','10:35:00',2),('15529','2014-05-04','10:40:00',2.03),('15529','2014-05-04','10:45:00',2.03),('15529','2014-05-04','10:50:00',2.04),('15529','2014-05-04','10:55:00',2.07),('15529','2014-05-04','11:00:00',2.09),('15529','2014-05-04','11:05:00',2.11),('15529','2014-05-04','11:10:00',2.13),('15529','2014-05-04','11:15:00',2.07),('15529','2014-05-04','11:20:00',2.17),('15529','2014-05-04','11:25:00',2.21),('15529','2014-05-04','11:30:00',2.26),('15529','2014-05-04','11:35:00',2.26),('15529','2014-05-04','11:40:00',2.23),('15529','2014-05-04','11:45:00',2.27),('15529','2014-05-04','11:50:00',2.39),('15529','2014-05-04','11:55:00',2.48),('15529','2014-05-04','12:00:00',2.41),('15529','2014-05-04','12:05:00',1.22),('15529','2014-05-04','12:10:00',2),('15529','2014-05-04','12:15:00',1.52),('15529','2014-05-04','12:20:00',2.5),('15529','2014-05-04','12:25:00',2.64),('15529','2014-05-04','12:30:00',2.11),('15529','2014-05-04','12:35:00',2.17),('15529','2014-05-04','12:40:00',1.48),('15529','2014-05-04','12:45:00',1.3),('15529','2014-05-04','12:50:00',1.08),('15529','2014-05-04','12:55:00',2.29),('15529','2014-05-04','13:00:00',2.51),('15529','2014-05-04','13:05:00',2.54),('15529','2014-05-04','13:10:00',2.42),('15529','2014-05-04','13:15:00',2.4),('15529','2014-05-04','13:20:00',2.39),('15529','2014-05-04','13:25:00',2.1),('15529','2014-05-04','14:00:00',2.64),('15529','2014-05-04','14:05:00',2.53),('15529','2014-05-04','14:10:00',2.53),('15529','2014-05-04','14:15:00',2.49),('15529','2014-05-04','14:20:00',1.84),('15529','2014-05-04','14:25:00',2.09),('15529','2014-05-04','14:30:00',2.5),('15529','2014-05-04','14:35:00',2.09),('15529','2014-05-04','14:40:00',1.29),('15529','2014-05-04','14:45:00',1.52),('15529','2014-05-04','14:55:00',1.01),('15529','2014-05-04','15:00:00',1.94),('15529','2014-05-04','15:05:00',2.44),('15529','2014-05-04','15:10:00',1.75),('15529','2014-05-04','15:15:00',1.92),('15529','2014-05-04','15:20:00',2.21),('15529','2014-05-04','15:25:00',1.29),('15529','2014-05-04','15:30:00',2.04),('15529','2014-05-04','15:35:00',1.69),('15529','2014-05-04','15:40:00',2.12),('15529','2014-05-04','15:45:00',1.85),('15529','2014-05-04','15:50:00',1.58),('15529','2014-05-04','15:55:00',1.51),('15529','2014-05-04','16:00:00',1.98),('15529','2014-05-04','16:05:00',1.31),('15529','2014-05-04','16:10:00',1.83),('15529','2014-05-04','16:15:00',2),('15529','2014-05-04','16:20:00',1.61),('15529','2014-05-04','16:25:00',1.71),('15529','2014-05-04','16:30:00',1.7),('15529','2014-05-04','16:35:00',1.6),('15529','2014-05-04','16:40:00',1.51),('15529','2014-05-04','16:45:00',1.44),('15529','2014-05-04','16:50:00',1.37),('15529','2014-05-04','16:55:00',1.32),('15529','2014-05-04','17:00:00',1.28),('15529','2014-05-04','17:05:00',1.22),('15529','2014-05-04','17:10:00',1.19),('15529','2014-05-04','17:15:00',1.14),('15529','2014-05-04','17:20:00',1.09),('15529','2014-05-04','17:25:00',1.03),('15529','2014-04-25','10:35:00',1.01),('15529','2014-04-25','10:50:00',1.04),('15529','2014-04-25','10:55:00',1.56),('15529','2014-04-25','11:00:00',1.96),('15529','2014-04-25','11:05:00',2.03),('15529','2014-04-25','11:10:00',1.65),('15529','2014-04-25','11:15:00',1.72),('15529','2014-04-25','11:20:00',1.8),('15529','2014-04-25','11:25:00',1.66),('15529','2014-04-25','11:30:00',1.78),('15529','2014-04-25','11:35:00',1.76),('15529','2014-04-25','11:40:00',1.67),('15529','2014-04-25','11:45:00',1.69),('15529','2014-04-25','11:50:00',1.79),('15529','2014-04-25','11:55:00',1.65),('15529','2014-04-25','12:00:00',1.56),('15529','2014-04-25','12:05:00',1.46),('15529','2014-04-25','12:10:00',1.44),('15529','2014-04-25','12:15:00',1.48),('15529','2014-04-25','12:25:00',1.43),('15529','2014-04-25','12:30:00',1.24),('15529','2014-04-25','12:35:00',1.62),('15529','2014-04-25','12:40:00',1.41),('15529','2014-04-25','12:50:00',1.59),('15529','2014-04-25','12:55:00',2.27),('15529','2014-04-25','13:00:00',2.45),('15529','2014-04-25','13:05:00',2.41),('15529','2014-04-25','13:10:00',1.94),('15529','2014-04-25','13:15:00',1.98),('15529','2014-04-25','13:20:00',2.32),('15529','2014-04-25','13:25:00',2.48),('15529','2014-04-25','13:30:00',1.66),('15529','2014-04-25','13:40:00',1.38),('15529','2014-04-25','13:45:00',1.46),('15529','2014-04-25','13:50:00',1.23),('15529','2014-04-25','13:55:00',2.01),('15529','2014-01-25','09:05:00',1.09),('15529','2014-01-25','10:15:00',1.1),('15529','2014-01-25','12:25:00',1.03),('15529','2014-01-25','12:30:00',1.63),('15529','2014-01-24','10:10:00',1.82),('15529','2014-01-24','10:15:00',1.87),('15529','2014-01-24','10:20:00',1.51),('15529','2014-01-24','10:25:00',1.02),('15529','2014-01-24','10:30:00',1.22),('15529','2014-01-24','10:35:00',1.33),('15529','2014-01-24','10:40:00',1.35),('15529','2014-01-24','10:45:00',1.02),('15529','2014-01-24','10:50:00',1.4),('15529','2014-01-24','10:55:00',1.59),('15529','2014-01-24','11:00:00',1.96),('15529','2014-01-24','11:05:00',1.68),('15529','2014-01-24','11:10:00',1.39),('15529','2014-01-24','11:15:00',1.83),('15529','2014-01-24','11:20:00',2.15),('15529','2014-01-24','11:25:00',1.91),('15529','2014-01-24','11:30:00',1.83),('15529','2014-01-24','11:35:00',1.25),('15529','2014-01-24','12:05:00',1.04),('15529','2014-01-24','12:10:00',1.06),('15529','2014-01-24','12:15:00',1.13),('15529','2014-01-24','12:20:00',1.08),('15529','2014-01-24','12:25:00',1.16),('15529','2014-01-24','12:30:00',1.07),('15529','2014-01-24','12:35:00',1),('15529','2014-01-24','12:40:00',1.26),('15529','2014-01-24','12:45:00',1.43),('15529','2014-01-24','12:50:00',1.43),('15529','2014-01-24','12:55:00',1.77),('15529','2014-01-24','13:00:00',1.93),('15529','2014-01-24','13:05:00',1.98),('15529','2014-01-24','13:10:00',1.97),('15529','2014-01-24','13:15:00',1.88),('15529','2014-01-24','13:20:00',1.85),('15529','2014-01-24','13:25:00',1.89),('15529','2014-01-24','13:30:00',1.04),('15529','2014-01-24','14:05:00',1.35),('15529','2014-01-24','14:10:00',1.6),('15529','2014-01-24','14:15:00',1.25),('15529','2014-01-24','14:20:00',1.28),('15529','2014-01-24','14:25:00',1.59),('15529','2014-01-24','14:30:00',1.74),('15529','2014-01-24','14:35:00',1.74),('15529','2014-01-24','14:45:00',1.57),('15529','2014-01-24','14:50:00',1.43),('15529','2014-01-24','14:55:00',1.17),('15529','2014-01-24','15:00:00',1.5),('15529','2014-01-24','15:05:00',1.4),('15529','2014-01-24','15:10:00',1.35),('15529','2014-01-24','15:15:00',1.29),('15529','2014-01-24','15:20:00',1.23),('15529','2014-01-24','15:25:00',1.17),('15529','2014-01-24','15:30:00',1.11),('15529','2014-01-24','15:35:00',1.05),('15529','2014-01-24','15:40:00',1),('15529','2014-01-23','10:15:00',1.09),('15529','2014-01-23','10:25:00',2.03),('15529','2014-01-23','10:35:00',1.56),('15529','2014-01-23','10:40:00',1.9),('15529','2014-01-23','10:45:00',1.42),('15529','2014-01-23','11:30:00',1.29),('15529','2014-01-23','11:45:00',2.24),('15529','2014-01-23','11:50:00',2.22),('15529','2014-01-23','11:55:00',1.18),('15529','2014-01-23','12:00:00',1.82),('15529','2014-01-23','12:05:00',1.85),('15529','2014-01-23','12:25:00',1.4),('15529','2014-01-23','12:35:00',1.66),('15529','2014-01-23','12:40:00',1.55),('15529','2014-01-23','12:45:00',1.02),('15529','2014-01-23','12:55:00',1.18),('15529','2014-01-23','13:00:00',1.07),('15529','2014-01-23','13:05:00',1.2),('15529','2014-01-23','13:35:00',1.04),('15529','2014-01-23','13:40:00',1.53),('15529','2014-01-23','14:05:00',1.19),('15529','2014-01-23','14:10:00',1.26),('15529','2014-01-23','14:15:00',1.76),('15529','2014-01-23','14:20:00',1.88),('15529','2014-01-23','14:35:00',1.44),('15529','2014-01-20','12:10:00',1.06),('15529','2014-01-20','12:15:00',1),('15529','2014-01-19','11:25:00',1.31),('15529','2014-01-19','11:30:00',1.36),('15529','2014-01-19','11:35:00',1.48),('15529','2014-01-19','11:40:00',1.09),('15529','2014-01-19','11:45:00',1.11),('15529','2014-01-19','13:20:00',1.01),('15529','2014-01-19','13:25:00',2),('15529','2014-01-19','13:30:00',1.33),('15529','2014-01-19','13:35:00',1.92),('15529','2014-01-19','13:40:00',1.43),('15529','2014-01-19','14:00:00',1.22),('15529','2014-01-19','14:10:00',1.57),('15529','2014-01-18','14:25:00',1.11),('15529','2014-01-18','14:30:00',1.04),('15529','2014-01-17','10:05:00',1.52),('15529','2014-01-17','10:10:00',1.49),('15529','2014-01-17','10:15:00',1.77),('15529','2014-01-17','10:20:00',1.3),('15529','2014-01-17','10:25:00',1.1),('15529','2014-01-17','10:30:00',1),('15529','2014-01-17','11:05:00',1.51),('15529','2014-01-17','11:10:00',2.04),('15529','2014-01-17','11:15:00',1.99),('15529','2014-01-17','11:20:00',1.9),('15529','2014-01-17','11:25:00',1.87),('15529','2014-01-17','11:30:00',1.9),('15529','2014-01-17','11:35:00',1.95),('15529','2014-01-17','11:40:00',2.04),('15529','2014-01-17','11:45:00',2.16),('15529','2014-01-17','11:50:00',2.19),('15529','2014-01-17','11:55:00',2.15),('15529','2014-01-17','12:00:00',2.08),('15529','2014-01-17','12:05:00',1.79),('15529','2014-01-17','12:10:00',1.91),('15529','2014-01-17','12:15:00',1.9),('15529','2014-01-17','12:20:00',1.87),('15529','2014-01-17','12:25:00',1.87),('15529','2014-01-17','12:30:00',1.9),('15529','2014-01-17','12:35:00',1.9),('15529','2014-01-17','12:40:00',1.92),('15529','2014-01-17','12:45:00',1.86),('15529','2014-01-17','12:50:00',1.6),('15529','2014-01-17','12:55:00',1.91),('15529','2014-01-17','13:00:00',1.49),('15529','2014-01-17','13:05:00',1.28),('15529','2014-01-17','13:10:00',1.54),('15529','2014-01-17','13:15:00',1.98),('15529','2014-01-17','13:20:00',1.47),('15529','2014-01-17','13:30:00',1.68),('15529','2014-01-17','13:35:00',1.53),('15529','2014-01-17','13:40:00',1.76),('15529','2014-01-17','13:45:00',1.7),('15529','2014-01-17','13:50:00',1.65),('15529','2014-01-17','13:55:00',1.76),('15529','2014-01-17','14:00:00',1.7),('15529','2014-01-17','14:05:00',1.63),('15529','2014-01-17','14:10:00',1.47),('15529','2014-01-17','14:15:00',1.43),('15529','2014-01-17','14:20:00',1.55),('15529','2014-01-17','14:25:00',1.49),('15529','2014-01-17','14:30:00',1.45),('15529','2014-01-17','14:35:00',1.41),('15529','2014-01-17','14:40:00',1.37),('15529','2014-01-17','14:45:00',1.34),('15529','2014-01-17','14:50:00',1.27),('15529','2014-01-16','09:30:00',1.09),('15529','2014-01-16','09:35:00',1.14),('15529','2014-01-16','11:35:00',1.2),('15529','2014-04-24','08:45:00',1.01),('15529','2014-04-24','09:00:00',1.2),('15529','2014-04-24','09:05:00',1.23),('15529','2014-04-24','09:10:00',1.28),('15529','2014-04-24','09:15:00',1.33),('15529','2014-04-24','09:20:00',1.21),('15529','2014-04-24','09:25:00',1.23),('15529','2014-04-24','09:45:00',1.24),('15529','2014-04-24','09:50:00',1.29),('15529','2014-04-24','10:30:00',1.74),('15529','2014-04-24','10:35:00',1),('15529','2014-04-24','10:40:00',1.02),('15529','2014-04-24','11:00:00',1.46),('15529','2014-04-24','11:10:00',1.36),('15529','2014-04-24','11:15:00',2.23),('15529','2014-04-24','11:20:00',2.32),('15529','2014-04-24','11:25:00',1.73),('15529','2014-04-24','11:30:00',1.27),('15529','2014-04-24','11:35:00',2.15),('15529','2014-04-24','11:40:00',2.24),('15529','2014-04-24','11:45:00',2.04),('15529','2014-04-24','11:50:00',1.03),('15529','2014-04-24','11:55:00',1.2),('15529','2014-04-24','12:10:00',1.28),('15529','2014-04-24','12:15:00',2.38),('15529','2014-04-24','12:20:00',2.35),('15529','2014-04-24','12:25:00',2.39),('15529','2014-04-24','12:30:00',2.21),('15529','2014-04-24','12:35:00',2.12),('15529','2014-04-24','12:40:00',2.58),('15529','2014-04-24','12:45:00',2.57),('15529','2014-04-24','12:50:00',2.49),('15529','2014-04-24','12:55:00',2.56),('15529','2014-04-24','13:00:00',2.43),('15529','2014-04-24','13:05:00',1.46),('15529','2014-04-24','13:10:00',2.37),('15529','2014-04-24','13:15:00',2.18),('15529','2014-04-24','13:20:00',1.87),('15529','2014-04-24','13:25:00',1.78),('15529','2014-04-24','13:35:00',1.48),('15529','2014-04-24','13:45:00',1.96),('15529','2014-04-24','13:50:00',1.24),('15529','2014-04-24','13:55:00',2.43),('15529','2014-04-24','14:00:00',1.94),('15529','2014-04-24','14:05:00',2.21),('15529','2014-04-24','14:10:00',1.95),('15529','2014-04-24','14:15:00',1.87),('15529','2014-04-24','14:20:00',2.22),('15529','2014-04-24','14:25:00',2.21),('15529','2014-04-24','14:30:00',2.19),('15529','2014-04-24','14:35:00',2.14),('15529','2014-04-24','14:40:00',2.1),('15529','2014-04-24','14:45:00',2.1),('15529','2014-04-24','14:50:00',2.09),('15529','2014-04-24','14:55:00',2.05),('15529','2014-04-24','15:00:00',2.02),('15529','2014-04-24','15:05:00',1.99),('15529','2014-04-24','15:10:00',2.01),('15529','2014-04-24','15:15:00',1.98),('15529','2014-04-24','15:20:00',1.92),('15529','2014-04-24','15:25:00',1.88),('15529','2014-04-24','15:30:00',1.87),('15529','2014-04-24','15:35:00',1.83),('15529','2014-04-24','15:40:00',1.81),('15529','2014-04-24','15:45:00',1.75),('15529','2014-04-24','15:50:00',1.75),('15529','2014-04-24','15:55:00',1.74),('15529','2014-04-24','16:00:00',1.69),('15529','2014-04-24','16:05:00',1.65),('15529','2014-04-24','16:10:00',1.57),('15529','2014-04-24','16:15:00',1.46),('15529','2014-04-24','16:20:00',1.36),('15529','2014-04-24','16:25:00',1.49),('15529','2014-04-24','16:30:00',1.45),('15529','2014-04-24','16:35:00',1.45),('15529','2014-04-24','16:40:00',1.43),('15529','2014-04-24','16:45:00',1.38),('15529','2014-04-24','16:50:00',1.22),('15529','2014-04-24','17:00:00',1.13),('15529','2014-04-24','17:05:00',1.11),('15529','2014-01-15','09:20:00',1.21),('15529','2014-01-15','09:25:00',1.27),('15529','2014-01-15','09:30:00',1.24),('15529','2014-01-15','09:35:00',1.26),('15529','2014-01-15','09:40:00',1.28),('15529','2014-01-15','10:25:00',1.19),('15529','2014-01-15','10:30:00',1.62),('15529','2014-01-15','10:35:00',1.88),('15529','2014-01-15','10:40:00',1.24),('15529','2014-01-15','10:45:00',1.19),('15529','2014-01-15','10:50:00',1.37),('15529','2014-01-15','10:55:00',1.32),('15529','2014-01-15','11:00:00',1.46),('15529','2014-01-15','11:05:00',1.44),('15529','2014-01-15','11:10:00',1.46),('15529','2014-01-15','11:15:00',1.29),('15529','2014-01-15','11:20:00',1.2),('15529','2014-01-15','11:25:00',1.22),('15529','2014-01-15','11:30:00',1.12),('15529','2014-01-15','11:35:00',1.16),('15529','2014-01-15','11:40:00',1.12),('15529','2014-01-15','11:55:00',1.16),('15529','2014-01-15','12:05:00',1.11),('15529','2014-01-15','12:10:00',1.1),('15529','2014-01-15','12:30:00',1.04),('15529','2014-01-15','12:35:00',1.23),('15529','2014-01-15','12:40:00',1.17),('15529','2014-01-15','12:45:00',1.2),('15529','2014-01-15','12:50:00',1.35),('15529','2014-01-15','12:55:00',1.33),('15529','2014-01-15','13:00:00',1.39),('15529','2014-01-15','13:05:00',1.44),('15529','2014-01-15','13:10:00',1.48),('15529','2014-01-15','13:40:00',1.24),('15529','2014-01-15','13:45:00',1.61),('15529','2014-01-15','13:50:00',1.57),('15529','2014-01-15','13:55:00',1),('15529','2014-01-14','10:10:00',1.12),('15529','2014-01-14','10:15:00',1.39),('15529','2014-01-14','10:20:00',1.65),('15529','2014-01-14','10:25:00',1.44),('15529','2014-01-14','10:30:00',1.08),('15529','2014-01-14','10:35:00',1.1),('15529','2014-01-14','10:40:00',1.17),('15529','2014-01-14','10:45:00',1.29),('15529','2014-01-14','10:50:00',1.02),('15529','2014-01-14','10:55:00',1.92),('15529','2014-01-14','11:00:00',1.53),('15529','2014-01-14','11:05:00',1.93),('15529','2014-01-14','11:10:00',1.88),('15529','2014-01-14','11:15:00',1.86),('15529','2014-01-14','11:20:00',1.67),('15529','2014-01-14','11:25:00',1.39),('15529','2014-01-14','11:30:00',1.63),('15529','2014-01-14','11:35:00',1.27),('15529','2014-01-14','11:40:00',1.55),('15529','2014-01-14','11:45:00',1.5),('15529','2014-01-14','11:50:00',1.48),('15529','2014-01-14','11:55:00',1.18),('15529','2014-01-14','12:00:00',1.13),('15529','2014-01-14','12:20:00',1.16),('15529','2014-01-14','12:55:00',1.09),('15529','2014-01-14','13:00:00',1.51),('15529','2014-01-14','13:05:00',1.6),('15529','2014-01-14','13:10:00',2.01),('15529','2014-01-14','13:15:00',2.01),('15529','2014-01-14','13:20:00',1.93),('15529','2014-01-14','13:25:00',1.89),('15529','2014-01-14','13:30:00',1.56),('15529','2014-01-14','13:40:00',1.14),('15529','2014-01-14','13:50:00',1.15),('15529','2014-01-14','13:55:00',1.66),('15529','2014-01-14','14:00:00',1.64),('15529','2014-01-14','14:05:00',1.63),('15529','2014-01-14','14:10:00',1.6),('15529','2014-01-14','14:15:00',1.58),('15529','2014-01-14','14:20:00',1.56),('15529','2014-01-14','14:25:00',1.55),('15529','2014-01-14','14:30:00',1.51),('15529','2014-01-14','14:35:00',1.44),('15529','2014-01-14','14:40:00',1.4),('15529','2014-01-14','14:45:00',1.36),('15529','2014-01-14','14:50:00',1.32),('15529','2014-01-14','14:55:00',1.29),('15529','2014-01-14','15:00:00',1.25),('15529','2014-01-14','15:05:00',1.2),('15529','2014-01-14','15:10:00',1.14),('15529','2014-01-14','15:15:00',1.09),('15529','2014-01-14','15:20:00',1.05),('15529','2014-01-13','10:25:00',1.05),('15529','2014-01-13','10:30:00',1.94),('15529','2014-01-13','10:35:00',1.78),('15529','2014-01-13','10:40:00',1.09),('15529','2014-01-12','09:20:00',1.06),('15529','2014-01-12','09:25:00',1.09),('15529','2014-01-12','09:30:00',1.12),('15529','2014-01-12','09:35:00',1.16),('15529','2014-01-12','09:40:00',1.2),('15529','2014-01-12','09:45:00',1.23),('15529','2014-01-12','09:50:00',1.27),('15529','2014-01-12','09:55:00',1.32),('15529','2014-01-12','10:00:00',1.34),('15529','2014-01-12','10:05:00',1.38),('15529','2014-01-12','10:10:00',1.4),('15529','2014-01-12','10:15:00',1.43),('15529','2014-01-12','10:20:00',1.44),('15529','2014-01-12','10:25:00',1.47),('15529','2014-01-12','10:30:00',1.51),('15529','2014-01-12','10:35:00',1.52),('15529','2014-01-12','10:40:00',1.53),('15529','2014-01-12','10:45:00',1.57),('15529','2014-01-12','10:50:00',1.58),('15529','2014-01-12','10:55:00',1.6),('15529','2014-01-12','11:00:00',1.61),('15529','2014-01-12','11:05:00',1.62),('15529','2014-01-12','11:10:00',1.65),('15529','2014-01-12','11:15:00',1.67),('15529','2014-01-12','11:20:00',1.67),('15529','2014-01-12','11:25:00',1.67),('15529','2014-01-12','11:30:00',1.68),('15529','2014-01-12','11:35:00',1.69),('15529','2014-01-12','11:40:00',1.69),('15529','2014-01-12','11:45:00',1.71),('15529','2014-01-12','11:50:00',1.7),('15529','2014-01-12','11:55:00',1.7),('15529','2014-01-12','12:00:00',1.69),('15529','2014-01-12','12:05:00',1.67),('15529','2014-01-12','12:10:00',1.67),('15529','2014-01-12','12:15:00',1.68),('15529','2014-01-12','12:20:00',1.68),('15529','2014-01-12','12:25:00',1.7),('15529','2014-01-12','12:30:00',1.71),('15529','2014-01-12','12:35:00',1.69),('15529','2014-01-12','12:40:00',1.67),('15529','2014-01-12','12:45:00',1.63),('15529','2014-01-12','12:50:00',1.6),('15529','2014-01-12','13:00:00',1.43),('15529','2014-01-12','13:05:00',1.45),('15529','2014-01-12','13:10:00',1.6),('15529','2014-01-12','13:15:00',1.55),('15529','2014-01-12','13:20:00',1.53),('15529','2014-01-12','13:25:00',1.5),('15529','2014-01-12','13:30:00',1.47),('15529','2014-01-12','13:35:00',1.49),('15529','2014-01-12','13:40:00',1.48),('15529','2014-01-12','13:45:00',1.45),('15529','2014-01-12','13:50:00',1.42),('15529','2014-01-12','13:55:00',1.44),('15529','2014-01-12','14:00:00',1.38),('15529','2014-01-12','14:05:00',1.37),('15529','2014-01-12','14:10:00',1.33),('15529','2014-01-12','14:15:00',1.33),('15529','2014-01-12','14:20:00',1.28),('15529','2014-01-12','14:25:00',1.25),('15529','2014-01-12','14:30:00',1.26),('15529','2014-01-12','14:35:00',1.22),('15529','2014-01-12','14:40:00',1.19),('15529','2014-01-12','14:45:00',1.18),('15529','2014-01-12','14:50:00',1.13),('15529','2014-01-12','14:55:00',1.08),('15529','2014-01-12','15:00:00',1.04),('15529','2014-01-12','15:05:00',1.02),('15529','2014-01-11','11:05:00',1.02),('15529','2014-01-11','11:10:00',1.19),('15529','2014-01-11','11:15:00',1.05),('15529','2014-01-11','11:45:00',1.42),('15529','2014-01-11','11:50:00',1.26),('15529','2014-01-10','09:55:00',1.12),('15529','2014-01-10','10:00:00',1.03),('15529','2014-01-10','10:20:00',1.15),('15529','2014-01-10','10:25:00',1.19),('15529','2014-01-10','10:30:00',1.21),('15529','2014-01-10','10:35:00',1.36),('15529','2014-01-10','10:40:00',1.61),('15529','2014-01-10','10:45:00',1.67),('15529','2014-01-10','10:50:00',1.67),('15529','2014-01-10','10:55:00',1.63),('15529','2014-01-10','11:00:00',1.58),('15529','2014-01-10','11:05:00',1.55),('15529','2014-01-10','11:10:00',1.63),('15529','2014-01-10','11:15:00',1.39),('15529','2014-01-10','11:20:00',1.32),('15529','2014-01-10','11:25:00',1.35),('15529','2014-01-10','11:30:00',1.34),('15529','2014-01-10','11:35:00',1.17),('15529','2014-01-10','11:40:00',1.1),('15529','2014-01-10','11:45:00',1.13),('15529','2014-01-10','11:50:00',1.24),('15529','2014-01-10','11:55:00',1.21),('15529','2014-01-10','12:00:00',1.3),('15529','2014-01-10','12:05:00',1.32),('15529','2014-01-10','12:10:00',1.31),('15529','2014-01-10','12:15:00',1.35),('15529','2014-01-10','12:20:00',1.33),('15529','2014-01-10','12:25:00',1.12),('15529','2014-01-10','12:30:00',1.28),('15529','2014-01-10','12:35:00',1.06),('15529','2014-01-10','12:40:00',1.01),('15529','2014-01-10','12:45:00',1.07),('15529','2014-01-10','12:50:00',1.35),('15529','2014-01-10','12:55:00',1.4),('15529','2014-01-10','13:05:00',1.05),('15529','2014-01-10','13:15:00',1.23),('15529','2014-01-10','13:20:00',1),('15529','2014-01-08','09:50:00',1.39),('15529','2014-01-08','09:55:00',1.45),('15529','2014-01-08','10:00:00',1.45),('15529','2014-01-08','10:05:00',1.32),('15529','2014-01-08','10:10:00',1.18),('15529','2014-01-08','10:15:00',1.25),('15529','2014-01-08','10:20:00',1.38),('15529','2014-01-08','10:25:00',1.34),('15529','2014-01-08','10:30:00',1.29),('15529','2014-01-08','11:25:00',1.12),('15529','2014-01-07','09:15:00',1.02),('15529','2014-01-07','09:20:00',1.07),('15529','2014-01-07','09:25:00',1.11),('15529','2014-01-07','09:30:00',1.1),('15529','2014-01-07','09:35:00',1.13),('15529','2014-01-07','09:40:00',1.21),('15529','2014-01-07','09:45:00',1.2),('15529','2014-01-07','09:50:00',1.25),('15529','2014-01-07','09:55:00',1.31),('15529','2014-01-07','10:00:00',1.27),('15529','2014-01-07','10:05:00',1.18),('15529','2014-01-07','10:10:00',1.23),('15529','2014-01-07','10:15:00',1.37),('15529','2014-01-07','10:20:00',1.47),('15529','2014-01-07','10:25:00',1.51),('15529','2014-01-07','10:30:00',1.51),('15529','2014-01-07','10:35:00',1.45),('15529','2014-01-07','10:40:00',1.48),('15529','2014-01-07','10:45:00',1.58),('15529','2014-01-07','10:50:00',1.6),('15529','2014-01-07','10:55:00',1.62),('15529','2014-01-07','11:00:00',1.63),('15529','2014-01-07','11:05:00',1.64),('15529','2014-01-07','11:10:00',1.66),('15529','2014-01-07','11:15:00',1.67),('15529','2014-01-07','11:20:00',1.65),('15529','2014-01-07','11:25:00',1.61),('15529','2014-01-07','11:30:00',1.67),('15529','2014-01-07','11:35:00',1.73),('15529','2014-01-07','11:40:00',1.74),('15529','2014-01-07','11:45:00',1.75),('15529','2014-01-07','11:50:00',1.73),('15529','2014-01-07','11:55:00',1.68),('15529','2014-01-07','12:00:00',1.68),('15529','2014-01-07','12:05:00',1.67),('15529','2014-01-07','12:10:00',1.68),('15529','2014-01-07','12:15:00',1.71),('15529','2014-01-07','12:20:00',1.7),('15529','2014-01-07','12:25:00',1.73),('15529','2014-01-07','12:30:00',1.71),('15529','2014-01-07','12:35:00',1.7),('15529','2014-01-07','12:40:00',1.66),('15529','2014-01-07','12:45:00',1.56),('15529','2014-01-07','12:50:00',1.65),('15529','2014-01-07','12:55:00',1.67),('15529','2014-01-07','13:00:00',1.59),('15529','2014-01-07','13:05:00',1.63),('15529','2014-01-07','13:10:00',1.61),('15529','2014-01-07','13:15:00',1.63),('15529','2014-01-07','13:20:00',1.59),('15529','2014-01-07','13:25:00',1.58),('15529','2014-01-07','13:30:00',1.51),('15529','2014-01-07','13:35:00',1.52),('15529','2014-01-07','13:40:00',1.48),('15529','2014-01-07','13:45:00',1.52),('15529','2014-01-07','13:50:00',1.51),('15529','2014-01-07','13:55:00',1.5),('15529','2014-01-07','14:00:00',1.43),('15529','2014-01-07','14:05:00',1.41),('15529','2014-01-07','14:10:00',1.38),('15529','2014-01-07','14:15:00',1.38),('15529','2014-01-07','14:20:00',1.36),('15529','2014-01-07','14:25:00',1.34),('15529','2014-01-07','14:30:00',1.33),('15529','2014-01-07','14:35:00',1.27),('15529','2014-01-07','14:40:00',1.12),('15529','2014-01-07','14:45:00',1.12),('15529','2014-01-06','09:05:00',1.01),('15529','2014-01-06','09:10:00',1.06),('15529','2014-01-06','09:15:00',1.09),('15529','2014-01-06','09:20:00',1.14),('15529','2014-01-06','09:25:00',1.19),('15529','2014-01-06','09:30:00',1.22),('15529','2014-01-06','09:35:00',1.26),('15529','2014-01-06','09:40:00',1.29),('15529','2014-01-06','09:45:00',1.32),('15529','2014-01-06','09:50:00',1.36),('15529','2014-01-06','09:55:00',1.38),('15529','2014-01-06','10:00:00',1.42),('15529','2014-01-06','10:05:00',1.44),('15529','2014-01-06','10:10:00',1.46),('15529','2014-01-06','10:15:00',1.49),('15529','2014-01-06','10:20:00',1.51),('15529','2014-01-06','10:25:00',1.54),('15529','2014-01-06','10:30:00',1.57),('15529','2014-01-06','10:35:00',1.59),('15529','2014-01-06','10:40:00',1.62),('15529','2014-01-06','10:45:00',1.66),('15529','2014-01-06','10:50:00',1.68),('15529','2014-01-06','10:55:00',1.7),('15529','2014-01-06','11:00:00',1.72),('15529','2014-01-06','11:05:00',1.74),('15529','2014-01-06','11:10:00',1.74),('15529','2014-01-06','11:15:00',1.75),('15529','2014-01-06','11:20:00',1.77),('15529','2014-01-06','11:25:00',1.77),('15529','2014-01-06','11:30:00',1.78),('15529','2014-01-06','11:35:00',1.79),('15529','2014-01-06','11:40:00',1.8),('15529','2014-01-06','11:45:00',1.78),('15529','2014-01-06','11:50:00',1.81),('15529','2014-01-06','11:55:00',1.8),('15529','2014-01-06','12:00:00',1.8),('15529','2014-01-06','12:05:00',1.77),('15529','2014-01-06','12:10:00',1.75),('15529','2014-01-06','12:15:00',1.77),('15529','2014-01-06','12:20:00',1.76),('15529','2014-01-06','12:25:00',1.74),('15529','2014-01-06','12:30:00',1.76),('15529','2014-01-06','12:35:00',1.75),('15529','2014-01-06','12:40:00',1.72),('15529','2014-01-06','12:45:00',1.66),('15529','2014-01-06','12:50:00',1.64),('15529','2014-01-06','12:55:00',1.66),('15529','2014-01-06','13:00:00',1.71),('15529','2014-01-06','13:05:00',1.67),('15529','2014-01-06','13:10:00',1.73),('15529','2014-01-06','13:15:00',1.69),('15529','2014-01-06','13:20:00',1.63),('15529','2014-01-06','13:25:00',1.58),('15529','2014-01-06','13:30:00',1.57),('15529','2014-01-06','13:35:00',1.59),('15529','2014-01-06','13:40:00',1.57),('15529','2014-01-06','13:45:00',1.61),('15529','2014-01-06','13:50:00',1.6),('15529','2014-01-06','13:55:00',1.51),('15529','2014-01-06','14:00:00',1.5),('15529','2014-01-06','14:05:00',1.44),('15529','2014-01-06','14:10:00',1.42),('15529','2014-01-06','14:15:00',1.43),('15529','2014-01-06','14:20:00',1.39),('15529','2014-01-06','14:25:00',1.36),('15529','2014-01-06','14:30:00',1.31),('15529','2014-01-06','14:35:00',1.27),('15529','2014-01-06','14:40:00',1.29),('15529','2014-01-06','14:45:00',1.21),('15529','2014-01-06','14:50:00',1.14),('15529','2014-01-06','14:55:00',1.15),('15529','2014-01-06','15:00:00',1.13),('15529','2014-01-06','15:05:00',1.11),('15529','2014-01-06','15:10:00',1.07),('15529','2014-01-06','15:15:00',1.02),('15529','2014-04-23','08:50:00',1.02),('15529','2014-04-23','08:55:00',1.08),('15529','2014-04-23','09:00:00',1.13),('15529','2014-04-23','09:05:00',1.17),('15529','2014-04-23','09:10:00',1.2),('15529','2014-04-23','09:15:00',1.24),('15529','2014-04-23','09:20:00',1.28),('15529','2014-04-23','09:25:00',1.34),('15529','2014-04-23','09:30:00',1.37),('15529','2014-04-23','09:35:00',1.41),('15529','2014-04-23','09:40:00',1.46),('15529','2014-04-23','09:45:00',1.49),('15529','2014-04-23','09:50:00',1.53),('15529','2014-04-23','09:55:00',1.57),('15529','2014-04-23','10:00:00',1.6),('15529','2014-04-23','10:05:00',1.62),('15529','2014-04-23','10:10:00',1.66),('15529','2014-04-23','10:15:00',1.69),('15529','2014-04-23','10:20:00',1.72),('15529','2014-04-23','10:25:00',1.75),('15529','2014-04-23','10:30:00',1.78),('15529','2014-04-23','10:35:00',1.79),('15529','2014-04-23','10:40:00',1.79),('15529','2014-04-23','10:45:00',1.82),('15529','2014-04-23','10:50:00',1.89),('15529','2014-04-23','10:55:00',1.92),('15529','2014-04-23','11:00:00',1.98),('15529','2014-04-23','11:05:00',2),('15529','2014-04-23','11:10:00',1.99),('15529','2014-04-23','11:15:00',2.02),('15529','2014-04-23','11:20:00',2.06),('15529','2014-04-23','11:25:00',2.1),('15529','2014-04-23','11:30:00',2.11),('15529','2014-04-23','11:40:00',2.12),('15529','2014-04-23','11:45:00',2.07),('15529','2014-04-23','11:50:00',2.14),('15529','2014-04-23','11:55:00',2.22),('15529','2014-04-23','12:00:00',2.19),('15529','2014-04-23','12:05:00',2.07),('15529','2014-04-23','12:10:00',1.78),('15529','2014-04-23','12:15:00',2.3),('15529','2014-04-23','12:20:00',2.18),('15529','2014-04-23','12:25:00',2.28),('15529','2014-04-23','12:30:00',2.31),('15529','2014-04-23','12:35:00',2.34),('15529','2014-04-23','12:40:00',2.35),('15529','2014-04-23','12:45:00',1.76),('15529','2014-04-23','12:50:00',1.2),('15529','2014-04-23','13:00:00',1.66),('15529','2014-04-23','13:05:00',2.17),('15529','2014-04-23','13:10:00',1.98),('15529','2014-04-23','13:15:00',2.43),('15529','2014-04-23','13:20:00',1.56),('15529','2014-04-23','13:25:00',2.1),('15529','2014-04-23','13:30:00',2.52),('15529','2014-04-23','13:35:00',2.38),('15529','2014-04-23','13:40:00',2.39),('15529','2014-04-23','14:05:00',2.15),('15529','2014-04-23','14:10:00',2.32),('15529','2014-04-23','14:15:00',2.3),('15529','2014-04-23','14:20:00',2.3),('15529','2014-04-23','14:25:00',2.27),('15529','2014-04-23','14:30:00',2.31),('15529','2014-04-23','14:35:00',2.23),('15529','2014-04-23','14:40:00',1.42),('15529','2014-04-23','14:45:00',2.12),('15529','2014-04-23','14:50:00',2.37),('15529','2014-04-23','14:55:00',2.22),('15529','2014-04-23','15:00:00',2.13),('15529','2014-04-23','15:05:00',2.14),('15529','2014-04-23','15:10:00',1.99),('15529','2014-04-23','15:15:00',2.25),('15529','2014-04-23','15:20:00',1.54),('15529','2014-04-23','15:25:00',1.84),('15529','2014-04-23','15:30:00',2.51),('15529','2014-04-23','15:35:00',1.96),('15529','2014-04-23','15:40:00',1.96),('15529','2014-04-23','15:45:00',1.41),('15529','2014-04-23','15:50:00',1.8),('15529','2014-04-23','15:55:00',2.04),('15529','2014-04-23','16:00:00',1.86),('15529','2014-04-23','16:05:00',1.74),('15529','2014-04-23','16:10:00',1.77),('15529','2014-04-23','16:15:00',1.56),('15529','2014-04-23','16:20:00',1.44),('15529','2014-04-23','16:25:00',1.21),('15529','2014-04-23','16:30:00',1.38),('15529','2014-04-23','16:40:00',1.01),('15529','2014-04-23','16:45:00',1.27),('15529','2014-01-05','11:40:00',2.18),('15529','2014-01-05','11:45:00',1.1),('15529','2014-01-05','11:50:00',1.7),('15529','2014-01-05','11:55:00',1.89),('15529','2014-01-05','12:00:00',1.87),('15529','2014-01-05','12:05:00',1.85),('15529','2014-01-05','12:10:00',1.82),('15529','2014-01-05','12:15:00',1.82),('15529','2014-01-05','12:20:00',1.81),('15529','2014-01-05','12:25:00',1.79),('15529','2014-01-05','12:30:00',1.79),('15529','2014-01-05','12:35:00',1.79),('15529','2014-01-05','12:40:00',1.77),('15529','2014-01-05','12:45:00',1.77),('15529','2014-01-05','12:50:00',1.74),('15529','2014-01-05','12:55:00',1.71),('15529','2014-01-05','13:00:00',1.68),('15529','2014-01-05','13:05:00',1.7),('15529','2014-01-05','13:10:00',1.68),('15529','2014-01-05','13:15:00',1.68),('15529','2014-01-05','13:20:00',1.65),('15529','2014-01-05','13:25:00',1.64),('15529','2014-01-05','13:30:00',1.62),('15529','2014-01-05','13:35:00',1.58),('15529','2014-01-05','13:40:00',1.6),('15529','2014-01-05','13:45:00',1.53),('15529','2014-01-05','13:55:00',1.27),('15529','2014-01-05','14:00:00',1.5),('15529','2014-01-05','14:05:00',1.47),('15529','2014-01-05','14:10:00',1.49),('15529','2014-01-05','14:15:00',1.44),('15529','2014-01-05','14:20:00',1.18),('15529','2014-01-05','14:30:00',1.29),('15529','2014-01-05','14:35:00',1.45),('15529','2014-01-05','14:40:00',1.33),('15529','2014-01-05','14:45:00',1.29),('15529','2014-01-05','14:50:00',1.26),('15529','2014-01-05','14:55:00',1.18),('15529','2014-01-05','15:00:00',1.13),('15529','2014-01-02','09:15:00',1.03),('15529','2014-01-02','09:20:00',1.1),('15529','2014-01-02','09:25:00',1.17),('15529','2014-01-02','09:30:00',1.24),('15529','2014-01-02','09:35:00',1.36),('15529','2014-01-02','09:40:00',1.49),('15529','2014-01-02','09:45:00',1.03),('15529','2014-01-02','09:55:00',1.32),('15529','2014-01-02','10:00:00',1.45),('15529','2014-01-02','10:05:00',1.4),('15529','2014-01-02','10:10:00',1.32),('15529','2014-01-02','10:15:00',1.31),('15529','2014-01-02','12:10:00',1.37),('15529','2014-01-02','12:15:00',1.37),('15529','2014-01-02','12:20:00',1.57),('15529','2014-01-02','12:25:00',1.51),('15529','2014-01-02','12:30:00',1.42),('15529','2014-01-02','12:40:00',1.2),('15529','2014-01-02','12:45:00',1.34),('15529','2014-01-02','12:50:00',1.14),('15529','2014-01-02','13:00:00',1.22),('15529','2014-01-02','13:05:00',1.25),('15529','2014-01-02','13:15:00',1.22),('15529','2014-01-02','13:30:00',1.21),('15529','2014-01-01','09:10:00',1.03),('15529','2014-01-01','09:15:00',1.08),('15529','2014-01-01','09:20:00',1.11),('15529','2014-01-01','09:25:00',1.15),('15529','2014-01-01','09:30:00',1.19),('15529','2014-01-01','09:35:00',1.23),('15529','2014-01-01','09:40:00',1.27),('15529','2014-01-01','09:45:00',1.31),('15529','2014-01-01','09:50:00',1.34),('15529','2014-01-01','09:55:00',1.39),('15529','2014-01-01','10:00:00',1.42),('15529','2014-01-01','10:05:00',1.45),('15529','2014-01-01','10:10:00',1.47),('15529','2014-01-01','10:15:00',1.48),('15529','2014-01-01','10:20:00',1.52),('15529','2014-01-01','10:25:00',1.58),('15529','2014-01-01','10:30:00',1.61),('15529','2014-01-01','10:35:00',1.6),('15529','2014-01-01','10:40:00',1.64),('15529','2014-01-01','10:45:00',1.65),('15529','2014-01-01','10:50:00',1.63),('15529','2014-01-01','10:55:00',1.62),('15529','2014-01-01','11:00:00',1.58),('15529','2014-01-01','11:05:00',1.46),('15529','2014-01-01','11:10:00',1.4),('15529','2014-01-01','11:15:00',1.11),('15529','2014-01-01','11:30:00',1.02),('15529','2014-01-01','11:35:00',1.1),('15529','2014-01-01','12:50:00',1.47),('15529','2014-01-01','12:55:00',2.03),('15529','2014-01-01','13:00:00',1.2),('15529','2014-01-01','13:30:00',1.7),('15529','2013-12-31','08:55:00',1.04),('15529','2013-12-31','09:45:00',1.23),('15529','2013-12-31','09:50:00',1.21),('15529','2013-12-31','13:35:00',1.05),('15529','2013-12-31','13:40:00',1.91),('15529','2013-12-31','13:45:00',1.6),('15529','2013-12-31','13:50:00',1.84),('15529','2013-12-31','13:55:00',1.23),('15529','2013-12-31','15:05:00',1.19),('15529','2013-12-31','15:10:00',1.13),('15529','2013-12-30','09:15:00',1.14),('15529','2013-12-30','09:20:00',1.22),('15529','2013-12-30','09:25:00',1.27),('15529','2013-12-30','09:30:00',1.31),('15529','2013-12-30','09:35:00',1.44),('15529','2013-12-30','09:40:00',1.35),('15529','2013-12-30','09:45:00',1.18),('15529','2013-12-30','09:55:00',1.28),('15529','2013-12-30','10:00:00',1.11),('15529','2013-12-30','10:05:00',1.19),('15529','2013-12-30','11:10:00',1.03),('15529','2013-12-30','11:15:00',1.49),('15529','2013-12-30','11:20:00',1.22),('15529','2013-12-30','11:25:00',2.09),('15529','2013-12-30','11:30:00',1.78),('15529','2013-12-30','11:45:00',1.18),('15529','2013-12-30','11:55:00',1.48),('15529','2013-12-30','12:00:00',1.29),('15529','2013-12-30','12:05:00',2.01),('15529','2013-12-30','12:10:00',1.95),('15529','2013-12-30','12:15:00',1.91),('15529','2013-12-30','12:20:00',1.89),('15529','2013-12-30','12:25:00',1.88),('15529','2013-12-30','12:30:00',1.81),('15529','2013-12-30','12:35:00',1.8),('15529','2013-12-30','12:40:00',1.8),('15529','2013-12-30','12:45:00',1.79),('15529','2013-12-30','12:50:00',1.77),('15529','2013-12-30','12:55:00',1.76),('15529','2013-12-30','13:00:00',1.75),('15529','2013-12-30','13:05:00',1.74),('15529','2013-12-30','13:10:00',1.74),('15529','2013-12-30','13:15:00',1.73),('15529','2013-12-30','13:20:00',1.71),('15529','2013-12-30','13:25:00',1.69),('15529','2013-12-30','13:30:00',1.66),('15529','2013-12-30','13:35:00',1.65),('15529','2013-12-30','13:40:00',1.63),('15529','2013-12-30','13:45:00',1.61),('15529','2013-12-30','13:50:00',1.58),('15529','2013-12-30','13:55:00',1.55),('15529','2013-12-30','14:00:00',1.52),('15529','2013-12-30','14:05:00',1.49),('15529','2013-12-30','14:10:00',1.46),('15529','2013-12-30','14:15:00',1.43),('15529','2013-12-30','14:20:00',1.39),('15529','2013-12-30','14:25:00',1.35),('15529','2013-12-30','14:30:00',1.32),('15529','2013-12-30','14:35:00',1.29),('15529','2013-12-30','14:40:00',1.25),('15529','2013-12-30','14:45:00',1.21),('15529','2013-12-30','14:50:00',1.16),('15529','2013-12-30','14:55:00',1.12),('15529','2013-12-30','15:00:00',1.07),('15529','2013-12-30','15:05:00',1.02),('15529','2013-12-28','09:10:00',1.02),('15529','2013-12-28','09:15:00',1.05),('15529','2013-12-28','09:20:00',1.13),('15529','2013-12-28','09:25:00',1.17),('15529','2013-12-28','09:30:00',1.23),('15529','2013-12-28','09:35:00',1.25),('15529','2013-12-28','09:40:00',1.32),('15529','2013-12-28','09:45:00',1.33),('15529','2013-12-28','09:50:00',1.2),('15529','2013-12-28','09:55:00',1.1),('15529','2013-12-28','10:00:00',1.12),('15529','2013-12-28','10:05:00',1.38),('15529','2013-12-28','10:10:00',1.27),('15529','2013-12-28','10:15:00',1.35),('15529','2013-12-27','09:05:00',1.01),('15529','2013-12-27','09:10:00',1.07),('15529','2013-12-27','09:15:00',1.12),('15529','2013-12-27','09:20:00',1.17),('15529','2013-12-27','09:25:00',1.22),('15529','2013-12-27','09:30:00',1.26),('15529','2013-12-27','09:35:00',1.31),('15529','2013-12-27','09:40:00',1.34),('15529','2013-12-27','09:45:00',1.38),('15529','2013-12-27','09:50:00',1.41),('15529','2013-12-27','09:55:00',1.44),('15529','2013-12-27','10:00:00',1.47),('15529','2013-12-27','10:05:00',1.5),('15529','2013-12-27','10:10:00',1.52),('15529','2013-12-27','10:15:00',1.54),('15529','2013-12-27','10:20:00',1.57),('15529','2013-12-27','10:25:00',1.6),('15529','2013-12-27','10:30:00',1.62),('15529','2013-12-27','10:35:00',1.64),('15529','2013-12-27','10:40:00',1.64),('15529','2013-12-27','10:45:00',1.68),('15529','2013-12-27','10:50:00',1.69),('15529','2013-12-27','10:55:00',1.71),('15529','2013-12-27','11:00:00',1.72),('15529','2013-12-27','11:05:00',1.74),('15529','2013-12-27','11:10:00',1.75),('15529','2013-12-27','11:15:00',1.76),('15529','2013-12-27','11:20:00',1.76),('15529','2013-12-27','11:25:00',1.77),('15529','2013-12-27','11:30:00',1.78),('15529','2013-12-27','11:35:00',1.8),('15529','2013-12-27','11:40:00',1.79),('15529','2013-12-27','11:45:00',1.79),('15529','2013-12-27','11:50:00',1.81),('15529','2013-12-27','11:55:00',1.8),('15529','2013-12-27','12:00:00',1.8),('15529','2013-12-27','12:05:00',1.8),('15529','2013-12-27','12:10:00',1.81),('15529','2013-12-27','12:15:00',1.8),('15529','2013-12-27','12:20:00',1.78),('15529','2013-12-27','12:25:00',1.77),('15529','2013-12-27','12:30:00',1.77),('15529','2013-12-27','12:35:00',1.77),('15529','2013-12-27','12:40:00',1.74),('15529','2013-12-27','12:45:00',1.71),('15529','2013-12-27','12:50:00',1.71),('15529','2013-12-27','12:55:00',1.68),('15529','2013-12-27','13:00:00',1.66),('15529','2013-12-27','13:05:00',1.66),('15529','2013-12-27','13:10:00',1.63),('15529','2013-12-27','13:15:00',1.61),('15529','2013-12-27','13:20:00',1.58),('15529','2013-12-27','13:25:00',1.56),('15529','2013-12-27','13:30:00',1.53),('15529','2013-12-27','13:35:00',1.51),('15529','2013-12-27','13:40:00',1.49),('15529','2013-12-27','13:45:00',1.47),('15529','2013-12-27','13:50:00',1.42),('15529','2013-12-27','13:55:00',1.38),('15529','2013-12-27','14:00:00',1.35),('15529','2013-12-27','14:05:00',1.35),('15529','2013-12-27','14:10:00',1.32),('15529','2013-12-27','14:15:00',1.28),('15529','2013-12-27','14:20:00',1.26),('15529','2013-12-27','14:25:00',1.28),('15529','2013-12-27','14:30:00',1.24),('15529','2013-12-27','14:35:00',1.19),('15529','2013-12-27','14:40:00',1.12),('15529','2013-12-27','15:00:00',1),('15529','2013-12-27','15:05:00',1),('15529','2013-12-26','12:10:00',1.24),('15529','2013-12-26','12:15:00',1.41),('15529','2013-12-26','12:45:00',1.43),('15529','2013-12-26','12:50:00',1.66),('15529','2013-12-26','12:55:00',1.25),('15529','2013-12-26','13:00:00',1.58),('15529','2013-12-26','13:05:00',1.51),('15529','2013-12-26','13:10:00',1.23),('15529','2013-12-26','13:15:00',1.49),('15529','2013-12-26','13:20:00',1.68),('15529','2013-12-26','13:25:00',1.34),('15529','2013-12-26','13:30:00',1.02),('15529','2013-12-26','14:10:00',1.04),('15529','2013-12-24','11:20:00',1.04),('15529','2013-12-24','11:40:00',1.71),('15529','2013-12-24','11:45:00',1.66),('15529','2013-12-24','11:50:00',1.38),('15529','2013-12-24','11:55:00',1.75),('15529','2013-12-24','12:15:00',1.65),('15529','2013-12-24','12:20:00',1.62),('15529','2013-12-24','12:25:00',1.04),('15529','2013-12-24','12:35:00',1.22),('15529','2013-12-23','09:15:00',1.03),('15529','2013-12-23','09:20:00',1.07),('15529','2013-12-23','09:25:00',1.1),('15529','2013-12-23','09:30:00',1.14),('15529','2013-12-23','09:35:00',1.18),('15529','2013-12-23','09:40:00',1.21),('15529','2013-12-23','09:45:00',1.25),('15529','2013-12-23','09:50:00',1.29),('15529','2013-12-23','09:55:00',1.31),('15529','2013-12-23','10:00:00',1.34),('15529','2013-12-23','10:05:00',1.38),('15529','2013-12-23','10:10:00',1.42),('15529','2013-12-23','10:15:00',1.45),('15529','2013-12-23','10:20:00',1.47),('15529','2013-12-23','10:25:00',1.5),('15529','2013-12-23','10:30:00',1.51),('15529','2013-12-23','10:35:00',1.53),('15529','2013-12-23','10:40:00',1.54),('15529','2013-12-23','10:45:00',1.54),('15529','2013-12-23','10:50:00',1.56),('15529','2013-12-23','10:55:00',1.55),('15529','2013-12-23','11:00:00',1.61),('15529','2013-12-23','11:05:00',1.57),('15529','2013-12-23','11:10:00',1.56),('15529','2013-12-23','11:15:00',1.56),('15529','2013-12-23','11:20:00',1.59),('15529','2013-12-23','11:25:00',1.61),('15529','2013-12-23','11:30:00',1.62),('15529','2013-12-23','11:35:00',1.63),('15529','2013-12-23','11:40:00',1.64),('15529','2013-12-23','11:45:00',1.64),('15529','2013-12-23','11:50:00',1.63),('15529','2013-12-23','11:55:00',1.61),('15529','2013-12-23','12:00:00',1.6),('15529','2013-12-23','12:05:00',1.61),('15529','2013-12-23','12:10:00',1.62),('15529','2013-12-23','12:15:00',1.61),('15529','2013-12-23','12:20:00',1.58),('15529','2013-12-23','12:25:00',1.59),('15529','2013-12-23','12:30:00',1.57),('15529','2013-12-23','12:35:00',1.59),('15529','2013-12-23','12:40:00',1.54),('15529','2013-12-23','12:45:00',1.53),('15529','2013-12-23','12:50:00',1.54),('15529','2013-12-23','12:55:00',1.54),('15529','2013-12-23','13:00:00',1.48),('15529','2013-12-23','13:05:00',1.48),('15529','2013-12-23','13:10:00',1.48),('15529','2013-12-23','13:15:00',1.44),('15529','2013-12-23','13:20:00',1.44),('15529','2013-12-23','13:25:00',1.42),('15529','2013-12-23','13:30:00',1.38),('15529','2013-12-23','13:35:00',1.35),('15529','2013-12-23','13:40:00',1.3),('15529','2013-12-23','13:45:00',1.3),('15529','2013-12-23','13:50:00',1.27),('15529','2013-12-23','13:55:00',1.24),('15529','2013-12-23','14:00:00',1.21),('15529','2013-12-23','14:05:00',1.17),('15529','2013-12-23','14:10:00',1.11),('15529','2013-12-23','14:15:00',1.07),('15529','2013-12-22','09:55:00',1.07),('15529','2013-12-22','10:00:00',1.31),('15529','2013-12-22','10:05:00',1.44),('15529','2013-12-22','10:10:00',1.51),('15529','2013-12-22','10:15:00',1.52),('15529','2013-12-22','10:20:00',1.49),('15529','2013-12-22','10:25:00',1.43),('15529','2013-12-22','10:30:00',1.42),('15529','2013-12-22','10:35:00',1.39),('15529','2013-12-22','10:40:00',1.41),('15529','2013-12-22','10:45:00',1.44),('15529','2013-12-22','10:50:00',1.47),('15529','2013-12-22','10:55:00',1.58),('15529','2013-12-22','11:00:00',1.68),('15529','2013-12-22','11:05:00',1.72),('15529','2013-12-22','11:10:00',1.73),('15529','2013-12-22','11:15:00',1.67),('15529','2013-12-22','11:20:00',1.58),('15529','2013-12-22','11:25:00',1.73),('15529','2013-12-22','11:30:00',1.78),('15529','2013-12-22','11:35:00',1.63),('15529','2013-12-22','11:40:00',1.54),('15529','2013-12-22','11:45:00',1.69),('15529','2013-12-22','11:50:00',1.56),('15529','2013-12-22','11:55:00',1.59),('15529','2013-12-22','12:00:00',1.67),('15529','2013-12-22','12:05:00',1.69),('15529','2013-12-22','12:10:00',1.69),('15529','2013-12-22','12:15:00',1.68),('15529','2013-12-22','12:20:00',1.69),('15529','2013-12-22','12:25:00',1.69),('15529','2013-12-22','12:30:00',1.65),('15529','2013-12-22','12:35:00',1.7),('15529','2013-12-22','12:40:00',1.71),('15529','2013-12-22','12:45:00',1.71),('15529','2013-12-22','12:50:00',1.72),('15529','2013-12-22','12:55:00',1.69),('15529','2013-12-22','13:00:00',1.7),('15529','2013-12-22','13:05:00',1.69),('15529','2013-12-22','13:10:00',1.66),('15529','2013-12-22','13:15:00',1.48),('15529','2013-12-22','13:20:00',1.35),('15529','2013-12-22','13:25:00',1.37),('15529','2013-12-22','13:35:00',1.32),('15529','2013-12-22','13:45:00',1.06),('15529','2013-12-22','13:50:00',1.25),('15529','2013-12-22','13:55:00',1.33),('15529','2013-12-22','14:00:00',1.1),('15529','2013-12-22','14:05:00',1.1),('15529','2013-12-22','14:10:00',1.26),('15529','2013-12-22','14:15:00',1.21),('15529','2013-12-22','14:20:00',1.18),('15529','2013-12-22','14:25:00',1.1),('15529','2013-12-22','14:30:00',1.08),('15529','2013-12-22','14:35:00',1.13),('15529','2013-12-22','14:40:00',1.09),('15529','2013-12-22','14:45:00',1.05),('15529','2013-12-21','09:35:00',1.3),('15529','2013-12-21','09:40:00',1.48),('15529','2013-12-21','09:45:00',1.51),('15529','2013-12-21','09:50:00',1.58),('15529','2013-12-21','09:55:00',1.57),('15529','2013-12-21','10:00:00',1.56),('15529','2013-12-21','10:05:00',1.57),('15529','2013-12-21','10:10:00',1.58),('15529','2013-12-21','10:15:00',1.53),('15529','2013-12-21','10:20:00',1.5),('15529','2013-12-21','10:25:00',1.53),('15529','2013-12-21','10:30:00',1.57),('15529','2013-12-21','10:35:00',1.44),('15529','2013-12-21','10:40:00',1.37),('15529','2013-12-21','10:45:00',1.52),('15529','2013-12-21','10:50:00',1.54),('15529','2013-12-21','10:55:00',1.33),('15529','2013-12-21','11:00:00',1.3),('15529','2013-12-21','11:05:00',1.39),('15529','2013-12-21','11:10:00',1.69),('15529','2013-12-21','11:15:00',1.55),('15529','2013-12-21','11:20:00',1.51),('15529','2013-12-21','11:25:00',1.52),('15529','2013-12-21','11:30:00',1.44),('15529','2013-12-21','11:35:00',1.52),('15529','2013-12-21','11:40:00',1.55),('15529','2013-12-21','11:45:00',1.32),('15529','2013-12-21','11:50:00',1.01),('15529','2013-12-21','12:35:00',1.05),('15529','2013-12-21','12:50:00',1.16),('15529','2013-12-21','12:55:00',1.55),('15529','2013-12-21','13:00:00',1.4),('15529','2013-12-21','13:05:00',1.84),('15529','2013-12-21','13:10:00',1.75),('15529','2013-12-21','13:15:00',1.36),('15529','2013-12-21','13:20:00',1.36),('15529','2013-12-21','13:25:00',1.46),('15529','2013-12-21','13:30:00',1.32),('15529','2013-12-21','13:35:00',1.19),('15529','2013-12-21','13:40:00',1.17),('15529','2013-12-21','13:45:00',1.25),('15529','2013-12-21','14:05:00',1.02),('15529','2013-12-21','14:10:00',1.05),('15529','2013-12-20','09:15:00',1.04),('15529','2013-12-20','09:20:00',1.09),('15529','2013-12-20','09:25:00',1.13),('15529','2013-12-20','09:30:00',1.18),('15529','2013-12-20','09:35:00',1.22),('15529','2013-12-20','09:40:00',1.26),('15529','2013-12-20','09:45:00',1.29),('15529','2013-12-20','09:50:00',1.31),('15529','2013-12-20','09:55:00',1.35),('15529','2013-12-20','10:00:00',1.38),('15529','2013-12-20','10:05:00',1.42),('15529','2013-12-20','10:10:00',1.46),('15529','2013-12-20','10:15:00',1.48),('15529','2013-12-20','10:20:00',1.51),('15529','2013-12-20','10:25:00',1.53),('15529','2013-12-20','10:30:00',1.54),('15529','2013-12-20','10:35:00',1.58),('15529','2013-12-20','10:40:00',1.6),('15529','2013-12-20','10:45:00',1.62),('15529','2013-12-20','10:50:00',1.65),('15529','2013-12-20','10:55:00',1.66),('15529','2013-12-20','11:00:00',1.69),('15529','2013-12-20','11:05:00',1.73),('15529','2013-12-20','11:10:00',1.74),('15529','2013-12-20','11:15:00',1.75),('15529','2013-12-20','11:20:00',1.76),('15529','2013-12-20','11:25:00',1.76),('15529','2013-12-20','11:30:00',1.79),('15529','2013-12-20','11:35:00',1.79),('15529','2013-12-20','11:40:00',1.79),('15529','2013-12-20','11:45:00',1.8),('15529','2013-12-20','11:50:00',1.79),('15529','2013-12-20','11:55:00',1.8),('15529','2013-12-20','12:00:00',1.81),('15529','2013-12-20','12:05:00',1.81),('15529','2013-12-20','12:10:00',1.81),('15529','2013-12-20','12:15:00',1.8),('15529','2013-12-20','12:20:00',1.8),('15529','2013-12-20','12:25:00',1.8),('15529','2013-12-20','12:30:00',1.8),('15529','2013-12-20','12:35:00',1.79),('15529','2013-12-20','12:40:00',1.78),('15529','2013-12-20','12:45:00',1.77),('15529','2013-12-20','12:50:00',1.76),('15529','2013-12-20','12:55:00',1.75),('15529','2013-12-20','13:00:00',1.74),('15529','2013-12-20','13:05:00',1.72),('15529','2013-12-20','13:10:00',1.71),('15529','2013-12-20','13:15:00',1.69),('15529','2013-12-20','13:20:00',1.66),('15529','2013-12-20','13:25:00',1.63),('15529','2013-12-20','13:30:00',1.6),('15529','2013-12-20','13:35:00',1.59),('15529','2013-12-20','13:40:00',1.56),('15529','2013-12-20','13:45:00',1.53),('15529','2013-12-20','13:50:00',1.51),('15529','2013-12-20','13:55:00',1.49),('15529','2013-12-20','14:00:00',1.46),('15529','2013-12-20','14:05:00',1.44),('15529','2013-12-20','14:10:00',1.42),('15529','2013-12-20','14:15:00',1.38),('15529','2013-12-20','14:20:00',1.34),('15529','2013-12-20','14:25:00',1.32),('15529','2013-12-20','14:30:00',1.27),('15529','2013-12-20','14:35:00',1.23),('15529','2013-12-20','14:40:00',1.19),('15529','2013-12-20','14:45:00',1.15),('15529','2013-12-20','14:50:00',1.1),('15529','2013-12-20','14:55:00',1.06),('15529','2013-12-19','09:15:00',1.01),('15529','2013-12-19','09:20:00',1.05),('15529','2013-12-19','09:25:00',1.1),('15529','2013-12-19','09:30:00',1.13),('15529','2013-12-19','09:35:00',1.18),('15529','2013-12-19','09:40:00',1.21),('15529','2013-12-19','09:45:00',1.25),('15529','2013-12-19','09:50:00',1.26),('15529','2013-12-19','09:55:00',1.29),('15529','2013-12-19','10:00:00',1.34),('15529','2013-12-19','10:05:00',1.37),('15529','2013-12-19','10:10:00',1.39),('15529','2013-12-19','10:15:00',1.42),('15529','2013-12-19','10:20:00',1.45),('15529','2013-12-19','10:25:00',1.45),('15529','2013-12-19','10:30:00',1.47),('15529','2013-12-19','10:35:00',1.5),('15529','2013-12-19','10:40:00',1.54),('15529','2013-12-19','10:45:00',1.55),('15529','2013-12-19','10:50:00',1.57),('15529','2013-12-19','10:55:00',1.59),('15529','2013-12-19','11:00:00',1.61),('15529','2013-12-19','11:05:00',1.62),('15529','2013-12-19','11:10:00',1.64),('15529','2013-12-19','11:15:00',1.65),('15529','2013-12-19','11:20:00',1.65),('15529','2013-12-19','11:25:00',1.66),('15529','2013-12-19','11:30:00',1.66),('15529','2013-12-19','11:35:00',1.67),('15529','2013-12-19','11:40:00',1.68),('15529','2013-12-19','11:45:00',1.68),('15529','2013-12-19','11:50:00',1.68),('15529','2013-12-19','11:55:00',1.69),('15529','2013-12-19','12:00:00',1.66),('15529','2013-12-19','12:05:00',1.67),('15529','2013-12-19','12:10:00',1.68),('15529','2013-12-19','12:15:00',1.66),('15529','2013-12-19','12:20:00',1.67),('15529','2013-12-19','12:30:00',1.66),('15529','2013-12-19','12:35:00',1.65),('15529','2013-12-19','12:40:00',1.63),('15529','2013-12-19','12:45:00',1.59),('15529','2013-12-19','12:50:00',1.58),('15529','2013-12-19','12:55:00',1.58),('15529','2013-12-19','13:00:00',1.55),('15529','2013-12-19','13:05:00',1.53),('15529','2013-12-19','13:10:00',1.5),('15529','2013-12-19','13:15:00',1.47),('15529','2013-12-19','13:20:00',1.46),('15529','2013-12-19','13:25:00',1.47),('15529','2013-12-19','13:30:00',1.39),('15529','2013-12-19','13:35:00',1.3),('15529','2013-12-19','13:40:00',1.25),('15529','2013-12-19','13:45:00',1.18),('15529','2013-12-18','09:05:00',1.05),('15529','2013-12-18','09:10:00',1.06),('15529','2013-12-18','09:15:00',1.03),('15529','2013-12-18','09:55:00',1.23),('15529','2013-12-18','10:00:00',1.3),('15529','2013-12-18','10:05:00',1.61),('15529','2013-12-18','10:10:00',1.59),('15529','2013-12-18','10:15:00',1.57),('15529','2013-12-18','14:40:00',1.12),('15529','2013-12-17','09:05:00',1),('15529','2013-12-17','09:10:00',1.05),('15529','2013-12-17','09:15:00',1.1),('15529','2013-12-17','09:20:00',1.14),('15529','2013-12-17','09:25:00',1.18),('15529','2013-12-17','09:30:00',1.22),('15529','2013-12-17','09:35:00',1.26),('15529','2013-12-17','09:40:00',1.31),('15529','2013-12-17','09:45:00',1.33),('15529','2013-12-17','09:50:00',1.38),('15529','2013-12-17','09:55:00',1.41),('15529','2013-12-17','10:00:00',1.44),('15529','2013-12-17','10:05:00',1.49),('15529','2013-12-17','10:10:00',1.51),('15529','2013-12-17','10:15:00',1.52),('15529','2013-12-17','10:20:00',1.54),('15529','2013-12-17','10:25:00',1.57),('15529','2013-12-17','10:30:00',1.59),('15529','2013-12-17','10:35:00',1.61),('15529','2013-12-17','10:40:00',1.62),('15529','2013-12-17','10:45:00',1.65),('15529','2013-12-17','10:50:00',1.67),('15529','2013-12-17','10:55:00',1.68),('15529','2013-12-17','11:00:00',1.69),('15529','2013-12-17','11:05:00',1.7),('15529','2013-12-17','11:10:00',1.7),('15529','2013-12-17','11:15:00',1.7),('15529','2013-12-17','11:20:00',1.73),('15529','2013-12-17','11:25:00',1.72),('15529','2013-12-17','11:30:00',1.73),('15529','2013-12-17','11:35:00',1.72),('15529','2013-12-17','11:40:00',1.74),('15529','2013-12-17','11:45:00',1.75),('15529','2013-12-17','11:50:00',1.75),('15529','2013-12-17','11:55:00',1.75),('15529','2013-12-17','12:00:00',1.74),('15529','2013-12-17','12:05:00',1.74),('15529','2013-12-17','12:10:00',1.75),('15529','2013-12-17','12:15:00',1.75),('15529','2013-12-17','12:20:00',1.75),('15529','2013-12-17','12:25:00',1.74),('15529','2013-12-17','12:30:00',1.75),('15529','2013-12-17','12:35:00',1.75),('15529','2013-12-17','12:40:00',1.71),('15529','2013-12-17','12:45:00',1.7),('15529','2013-12-17','12:50:00',1.68),('15529','2013-12-17','12:55:00',1.66),('15529','2013-12-17','13:00:00',1.64),('15529','2013-12-17','13:05:00',1.62),('15529','2013-12-17','13:10:00',1.58),('15529','2013-12-17','13:15:00',1.54),('15529','2013-12-17','13:20:00',1.53),('15529','2013-12-17','13:25:00',1.5),('15529','2013-12-17','13:30:00',1.49),('15529','2013-12-17','13:35:00',1.45),('15529','2013-12-17','13:40:00',1.41),('15529','2013-12-17','13:45:00',1.41),('15529','2013-12-17','13:50:00',1.39),('15529','2013-12-17','13:55:00',1.35),('15529','2013-12-17','14:00:00',1.33),('15529','2013-12-17','14:05:00',1.34),('15529','2013-12-17','14:10:00',1.33),('15529','2013-12-17','14:15:00',1.31),('15529','2013-12-17','14:20:00',1.26),('15529','2013-12-17','14:25:00',1.23),('15529','2013-12-17','14:30:00',1.2),('15529','2013-12-17','14:35:00',1.17),('15529','2013-12-17','14:40:00',1.12),('15529','2013-12-17','14:45:00',1.09),('15529','2013-12-17','14:50:00',1.05),('15529','2013-12-17','14:55:00',1.01),('15529','2014-04-21','09:00:00',1.1),('15529','2014-04-21','09:05:00',1.2),('15529','2014-04-21','09:10:00',1.11),('15529','2014-04-21','09:15:00',1.11),('15529','2014-04-21','09:20:00',1.28),('15529','2014-04-21','09:25:00',1.37),('15529','2014-04-21','09:30:00',1.34),('15529','2014-04-21','09:35:00',1.45),('15529','2014-04-21','09:40:00',1.12),('15529','2014-04-21','09:45:00',1.54),('15529','2014-04-21','09:50:00',1.02),('15529','2014-04-21','10:10:00',1.08),('15529','2014-04-21','10:15:00',1.07),('15529','2014-04-21','10:20:00',1.64),('15529','2014-04-21','10:25:00',1.2),('15529','2014-04-21','10:30:00',1.84),('15529','2014-04-21','10:35:00',1.54),('15529','2014-04-21','10:40:00',1.79),('15529','2014-04-21','10:45:00',2.05),('15529','2014-04-21','10:50:00',2.03),('15529','2014-04-21','10:55:00',1.44),('15529','2014-04-21','11:00:00',1.08),('15529','2014-04-21','11:05:00',1.36),('15529','2014-04-21','13:20:00',1.01),('15529','2014-04-21','13:25:00',1.35),('15529','2014-04-21','13:30:00',1.23),('15529','2014-04-21','13:35:00',1.33),('15529','2014-04-21','13:40:00',1.41),('15529','2014-04-21','13:45:00',1.32),('15529','2014-04-21','13:50:00',1.04),('15529','2014-04-21','14:05:00',1.66),('15529','2014-04-21','14:10:00',1.87),('15529','2014-04-21','14:15:00',1.55),('15529','2014-04-21','14:20:00',1.78),('15529','2014-04-21','14:30:00',1.09),('15529','2014-04-21','14:35:00',1.4),('15529','2014-04-21','14:40:00',2.02),('15529','2014-04-21','14:45:00',1.55),('15529','2014-04-21','14:50:00',1.62),('15529','2014-04-21','14:55:00',1.22),('15529','2014-04-21','15:30:00',1.04),('15529','2014-04-21','15:35:00',1.13),('15529','2014-04-21','15:45:00',1.06),('15529','2014-04-21','15:50:00',1.04),('15529','2014-04-21','16:00:00',1.07),('15529','2013-12-16','08:55:00',1.01),('15529','2013-12-16','09:00:00',1.06),('15529','2013-12-16','09:05:00',1.11),('15529','2013-12-16','09:10:00',1.15),('15529','2013-12-16','09:15:00',1.2),('15529','2013-12-16','09:20:00',1.24),('15529','2013-12-16','09:25:00',1.25),('15529','2013-12-16','09:30:00',1.3),('15529','2013-12-16','09:35:00',1.29),('15529','2013-12-16','09:40:00',1.35),('15529','2013-12-16','09:45:00',1.39),('15529','2013-12-16','09:50:00',1.42),('15529','2013-12-16','09:55:00',1.46),('15529','2013-12-16','10:00:00',1.5),('15529','2013-12-16','10:05:00',1.54),('15529','2013-12-16','10:10:00',1.56),('15529','2013-12-16','10:15:00',1.58),('15529','2013-12-16','10:20:00',1.59),('15529','2013-12-16','10:25:00',1.62),('15529','2013-12-16','10:30:00',1.64),('15529','2013-12-16','10:35:00',1.66),('15529','2013-12-16','10:40:00',1.67),('15529','2013-12-16','10:45:00',1.68),('15529','2013-12-16','10:50:00',1.7),('15529','2013-12-16','10:55:00',1.71),('15529','2013-12-16','11:00:00',1.73),('15529','2013-12-16','11:05:00',1.75),('15529','2013-12-16','11:10:00',1.78),('15529','2013-12-16','11:15:00',1.8),('15529','2013-12-16','11:20:00',1.81),('15529','2013-12-16','11:25:00',1.82),('15529','2013-12-16','11:30:00',1.81),('15529','2013-12-16','11:35:00',1.81),('15529','2013-12-16','11:40:00',1.82),('15529','2013-12-16','11:45:00',1.83),('15529','2013-12-16','11:50:00',1.83),('15529','2013-12-16','11:55:00',1.82),('15529','2013-12-16','12:00:00',1.82),('15529','2013-12-16','12:05:00',1.83),('15529','2013-12-16','12:10:00',1.82),('15529','2013-12-16','12:15:00',1.82),('15529','2013-12-16','12:20:00',1.84),('15529','2013-12-16','12:25:00',1.83),('15529','2013-12-16','12:30:00',1.82),('15529','2013-12-16','12:35:00',1.82),('15529','2013-12-16','12:40:00',1.81),('15529','2013-12-16','12:45:00',1.8),('15529','2013-12-16','12:50:00',1.76),('15529','2013-12-16','12:55:00',1.74),('15529','2013-12-16','13:00:00',1.74),('15529','2013-12-16','13:05:00',1.72),('15529','2013-12-16','13:10:00',1.72),('15529','2013-12-16','13:15:00',1.7),('15529','2013-12-16','13:20:00',1.68),('15529','2013-12-16','13:25:00',1.67),('15529','2013-12-16','13:30:00',1.65),('15529','2013-12-16','13:35:00',1.62),('15529','2013-12-16','13:40:00',1.6),('15529','2013-12-16','13:45:00',1.58),('15529','2013-12-16','13:50:00',1.55),('15529','2013-12-16','13:55:00',1.51),('15529','2013-12-16','14:00:00',1.48),('15529','2013-12-16','14:05:00',1.45),('15529','2013-12-16','14:10:00',1.44),('15529','2013-12-16','14:15:00',1.39),('15529','2013-12-16','14:20:00',1.33),('15529','2013-12-16','14:25:00',1.29),('15529','2013-12-16','14:30:00',1.26),('15529','2013-12-16','14:35:00',1.21),('15529','2013-12-16','14:40:00',1.16),('15529','2013-12-16','14:45:00',1.1),('15529','2013-12-16','14:50:00',1.05),('15529','2013-12-16','14:55:00',1.01),('15529','2013-12-15','09:00:00',1.04),('15529','2013-12-15','09:05:00',1.1),('15529','2013-12-15','09:10:00',1.14),('15529','2013-12-15','09:15:00',1.18),('15529','2013-12-15','09:20:00',1.23),('15529','2013-12-15','09:25:00',1.26),('15529','2013-12-15','09:30:00',1.3),('15529','2013-12-15','09:35:00',1.34),('15529','2013-12-15','09:40:00',1.37),('15529','2013-12-15','09:45:00',1.4),('15529','2013-12-15','09:50:00',1.42),('15529','2013-12-15','09:55:00',1.45),('15529','2013-12-15','10:00:00',1.47),('15529','2013-12-15','10:05:00',1.5),('15529','2013-12-15','10:10:00',1.52),('15529','2013-12-15','10:15:00',1.54),('15529','2013-12-15','10:20:00',1.55),('15529','2013-12-15','10:25:00',1.57),('15529','2013-12-15','10:30:00',1.58),('15529','2013-12-15','10:35:00',1.61),('15529','2013-12-15','10:40:00',1.64),('15529','2013-12-15','10:45:00',1.65),('15529','2013-12-15','10:50:00',1.67),('15529','2013-12-15','10:55:00',1.69),('15529','2013-12-15','11:00:00',1.7),('15529','2013-12-15','11:05:00',1.72),('15529','2013-12-15','11:10:00',1.73),('15529','2013-12-15','11:15:00',1.74),('15529','2013-12-15','11:20:00',1.76),('15529','2013-12-15','11:25:00',1.76),('15529','2013-12-15','11:30:00',1.79),('15529','2013-12-15','11:35:00',1.79),('15529','2013-12-15','11:40:00',1.79),('15529','2013-12-15','11:45:00',1.81),('15529','2013-12-15','11:50:00',1.81),('15529','2013-12-15','11:55:00',1.83),('15529','2013-12-15','12:00:00',1.83),('15529','2013-12-15','12:05:00',1.84),('15529','2013-12-15','12:10:00',1.82),('15529','2013-12-15','12:15:00',1.81),('15529','2013-12-15','12:20:00',1.81),('15529','2013-12-15','12:25:00',1.81),('15529','2013-12-15','12:30:00',1.8),('15529','2013-12-15','12:35:00',1.8),('15529','2013-12-15','12:40:00',1.78),('15529','2013-12-15','12:45:00',1.76),('15529','2013-12-15','12:50:00',1.75),('15529','2013-12-15','12:55:00',1.72),('15529','2013-12-15','13:00:00',1.71),('15529','2013-12-15','13:05:00',1.71),('15529','2013-12-15','13:10:00',1.69),('15529','2013-12-15','13:15:00',1.68),('15529','2013-12-15','13:20:00',1.65),('15529','2013-12-15','13:25:00',1.63),('15529','2013-12-15','13:30:00',1.61),('15529','2013-12-15','13:35:00',1.57),('15529','2013-12-15','13:40:00',1.54),('15529','2013-12-15','13:45:00',1.52),('15529','2013-12-15','13:50:00',1.51),('15529','2013-12-15','13:55:00',1.47),('15529','2013-12-15','14:00:00',1.44),('15529','2013-12-15','14:05:00',1.41),('15529','2013-12-15','14:10:00',1.39),('15529','2013-12-15','14:15:00',1.37),('15529','2013-12-15','14:20:00',1.32),('15529','2013-12-15','14:25:00',1.27),('15529','2013-12-15','14:30:00',1.23),('15529','2013-12-15','14:35:00',1.2),('15529','2013-12-15','14:40:00',1.14),('15529','2013-12-15','14:45:00',1.11),('15529','2013-12-15','14:50:00',1.06),('15529','2013-12-15','14:55:00',1.01),('15529','2013-12-13','09:05:00',1),('15529','2013-12-13','09:10:00',1.05),('15529','2013-12-13','09:15:00',1.09),('15529','2013-12-13','09:20:00',1.13),('15529','2013-12-13','09:25:00',1.18),('15529','2013-12-13','09:30:00',1.23),('15529','2013-12-13','09:35:00',1.26),('15529','2013-12-13','09:40:00',1.3),('15529','2013-12-13','09:45:00',1.35),('15529','2013-12-13','09:50:00',1.39),('15529','2013-12-13','09:55:00',1.42),('15529','2013-12-13','10:00:00',1.44),('15529','2013-12-13','10:05:00',1.46),('15529','2013-12-13','10:10:00',1.49),('15529','2013-12-13','10:15:00',1.51),('15529','2013-12-13','10:20:00',1.53),('15529','2013-12-13','10:25:00',1.55),('15529','2013-12-13','10:30:00',1.58),('15529','2013-12-13','10:35:00',1.59),('15529','2013-12-13','10:40:00',1.61),('15529','2013-12-13','10:45:00',1.62),('15529','2013-12-13','10:50:00',1.63),('15529','2013-12-13','10:55:00',1.62),('15529','2013-12-13','11:00:00',1.64),('15529','2013-12-13','11:05:00',1.66),('15529','2013-12-13','11:10:00',1.67),('15529','2013-12-13','11:15:00',1.69),('15529','2013-12-13','11:20:00',1.7),('15529','2013-12-13','11:25:00',1.72),('15529','2013-12-13','11:30:00',1.71),('15529','2013-12-13','11:35:00',1.7),('15529','2013-12-13','11:40:00',1.72),('15529','2013-12-13','11:45:00',1.72),('15529','2013-12-13','11:50:00',1.74),('15529','2013-12-13','11:55:00',1.69),('15529','2013-12-13','12:00:00',1.72),('15529','2013-12-13','12:05:00',1.72),('15529','2013-12-13','12:10:00',1.71),('15529','2013-12-13','12:15:00',1.7),('15529','2013-12-13','12:20:00',1.73),('15529','2013-12-13','12:25:00',1.7),('15529','2013-12-13','12:30:00',1.71),('15529','2013-12-13','12:35:00',1.69),('15529','2013-12-13','12:40:00',1.66),('15529','2013-12-13','12:45:00',1.62),('15529','2013-12-13','12:50:00',1.63),('15529','2013-12-13','12:55:00',1.64),('15529','2013-12-13','13:00:00',1.61),('15529','2013-12-13','13:05:00',1.61),('15529','2013-12-13','13:10:00',1.61),('15529','2013-12-13','13:15:00',1.62),('15529','2013-12-13','13:20:00',1.6),('15529','2013-12-13','13:25:00',1.59),('15529','2013-12-13','13:30:00',1.55),('15529','2013-12-13','13:35:00',1.53),('15529','2013-12-13','13:40:00',1.52),('15529','2013-12-13','13:45:00',1.48),('15529','2013-12-13','13:50:00',1.44),('15529','2013-12-13','13:55:00',1.44),('15529','2013-12-13','14:00:00',1.41),('15529','2013-12-13','14:05:00',1.36),('15529','2013-12-13','14:10:00',1.33),('15529','2013-12-13','14:15:00',1.32),('15529','2013-12-13','14:20:00',1.25),('15529','2013-12-13','14:25:00',1.2),('15529','2013-12-13','14:30:00',1.18),('15529','2013-12-13','14:35:00',1.14),('15529','2013-12-13','14:40:00',1.1),('15529','2013-12-13','14:45:00',1.05),('15529','2013-12-13','14:50:00',1.01),('15529','2013-12-12','09:20:00',1.04),('15529','2013-12-12','09:25:00',1.06),('15529','2013-12-12','09:30:00',1.1),('15529','2013-12-12','09:35:00',1.15),('15529','2013-12-12','09:40:00',1.17),('15529','2013-12-12','09:45:00',1.21),('15529','2013-12-12','09:50:00',1.25),('15529','2013-12-12','09:55:00',1.28),('15529','2013-12-12','10:00:00',1.32),('15529','2013-12-12','10:05:00',1.35),('15529','2013-12-12','10:10:00',1.36),('15529','2013-12-12','10:15:00',1.36),('15529','2013-12-12','10:20:00',1.4),('15529','2013-12-12','10:25:00',1.41),('15529','2013-12-12','10:30:00',1.42),('15529','2013-12-12','10:35:00',1.45),('15529','2013-12-12','10:40:00',1.47),('15529','2013-12-12','10:45:00',1.5),('15529','2013-12-12','10:50:00',1.51),('15529','2013-12-12','10:55:00',1.55),('15529','2013-12-12','11:00:00',1.53),('15529','2013-12-12','11:05:00',1.57),('15529','2013-12-12','11:10:00',1.59),('15529','2013-12-12','11:15:00',1.62),('15529','2013-12-12','11:20:00',1.62),('15529','2013-12-12','11:25:00',1.64),('15529','2013-12-12','11:30:00',1.66),('15529','2013-12-12','11:35:00',1.68),('15529','2013-12-12','11:40:00',1.69),('15529','2013-12-12','11:45:00',1.7),('15529','2013-12-12','11:50:00',1.69),('15529','2013-12-12','11:55:00',1.64),('15529','2013-12-12','12:00:00',1.61),('15529','2013-12-12','12:05:00',1.64),('15529','2013-12-12','12:10:00',1.63),('15529','2013-12-12','12:15:00',1.64),('15529','2013-12-12','12:20:00',1.69),('15529','2013-12-12','12:25:00',1.6),('15529','2013-12-12','12:30:00',1.6),('15529','2013-12-12','12:35:00',1.63),('15529','2013-12-12','12:40:00',1.46),('15529','2013-12-12','12:45:00',1.61),('15529','2013-12-12','12:50:00',1.62),('15529','2013-12-12','12:55:00',1.63),('15529','2013-12-12','13:00:00',1.66),('15529','2013-12-12','13:05:00',1.64),('15529','2013-12-12','13:10:00',1.62),('15529','2013-12-12','13:15:00',1.62),('15529','2013-12-12','13:20:00',1.59),('15529','2013-12-12','13:25:00',1.59),('15529','2013-12-12','13:30:00',1.53),('15529','2013-12-12','13:35:00',1.54),('15529','2013-12-12','13:40:00',1.49),('15529','2013-12-12','13:45:00',1.48),('15529','2013-12-12','13:50:00',1.44),('15529','2013-12-12','13:55:00',1.42),('15529','2013-12-12','14:00:00',1.41),('15529','2013-12-12','14:05:00',1.38),('15529','2013-12-12','14:10:00',1.34),('15529','2013-12-12','14:15:00',1.27),('15529','2013-12-12','14:20:00',1.26),('15529','2013-12-12','14:25:00',1.24),('15529','2013-12-12','14:30:00',1.16),('15529','2013-12-12','14:35:00',1.16),('15529','2013-12-12','14:40:00',1.1),('15529','2013-12-12','14:45:00',1.04),('15529','2013-12-11','09:10:00',1.04),('15529','2013-12-11','09:15:00',1.09),('15529','2013-12-11','09:20:00',1.13),('15529','2013-12-11','09:25:00',1.18),('15529','2013-12-11','09:30:00',1.21),('15529','2013-12-11','09:35:00',1.22),('15529','2013-12-11','09:40:00',1.26),('15529','2013-12-11','09:45:00',1.31),('15529','2013-12-11','09:50:00',1.33),('15529','2013-12-11','09:55:00',1.37),('15529','2013-12-11','10:00:00',1.4),('15529','2013-12-11','10:05:00',1.45),('15529','2013-12-11','10:10:00',1.48),('15529','2013-12-11','10:15:00',1.49),('15529','2013-12-11','10:20:00',1.52),('15529','2013-12-11','10:25:00',1.53),('15529','2013-12-11','10:30:00',1.56),('15529','2013-12-11','10:35:00',1.58),('15529','2013-12-11','10:40:00',1.59),('15529','2013-12-11','10:45:00',1.6),('15529','2013-12-11','10:50:00',1.62),('15529','2013-12-11','10:55:00',1.63),('15529','2013-12-11','11:00:00',1.65),('15529','2013-12-11','11:05:00',1.66),('15529','2013-12-11','11:10:00',1.68),('15529','2013-12-11','11:15:00',1.7),('15529','2013-12-11','11:20:00',1.69),('15529','2013-12-11','11:25:00',1.69),('15529','2013-12-11','11:30:00',1.69),('15529','2013-12-11','11:35:00',1.71),('15529','2013-12-11','11:40:00',1.71),('15529','2013-12-11','11:45:00',1.7),('15529','2013-12-11','11:50:00',1.7),('15529','2013-12-11','11:55:00',1.72),('15529','2013-12-11','12:00:00',1.72),('15529','2013-12-11','12:05:00',1.73),('15529','2013-12-11','12:10:00',1.73),('15529','2013-12-11','12:15:00',1.72),('15529','2013-12-11','12:20:00',1.7),('15529','2013-12-11','12:25:00',1.69),('15529','2013-12-11','12:30:00',1.69),('15529','2013-12-11','12:35:00',1.66),('15529','2013-12-11','12:40:00',1.63),('15529','2013-12-11','12:45:00',1.63),('15529','2013-12-11','12:50:00',1.63),('15529','2013-12-11','12:55:00',1.58),('15529','2013-12-11','13:00:00',1.58),('15529','2013-12-11','13:05:00',1.58),('15529','2013-12-11','13:10:00',1.54),('15529','2013-12-11','13:15:00',1.55),('15529','2013-12-11','13:20:00',1.55),('15529','2013-12-11','13:25:00',1.5),('15529','2013-12-11','13:30:00',1.5),('15529','2013-12-11','13:35:00',1.49),('15529','2013-12-11','13:40:00',1.46),('15529','2013-12-11','13:45:00',1.43),('15529','2013-12-11','13:50:00',1.41),('15529','2013-12-11','13:55:00',1.39),('15529','2013-12-11','14:00:00',1.33),('15529','2013-12-11','14:05:00',1.3),('15529','2013-12-11','14:10:00',1.27),('15529','2013-12-11','14:15:00',1.23),('15529','2013-12-11','14:20:00',1.23),('15529','2013-12-11','14:25:00',1.18),('15529','2013-12-11','14:30:00',1.14),('15529','2013-12-11','14:35:00',1.09),('15529','2013-12-11','14:40:00',1.05),('15529','2013-12-11','14:45:00',1.01),('15529','2013-12-10','09:05:00',1.03),('15529','2013-12-10','09:10:00',1.07),('15529','2013-12-10','09:15:00',1.1),('15529','2013-12-10','09:20:00',1.15),('15529','2013-12-10','09:25:00',1.21),('15529','2013-12-10','09:30:00',1.25),('15529','2013-12-10','09:35:00',1.29),('15529','2013-12-10','09:40:00',1.33),('15529','2013-12-10','09:45:00',1.39),('15529','2013-12-10','09:50:00',1.43),('15529','2013-12-10','09:55:00',1.46),('15529','2013-12-10','10:00:00',1.49),('15529','2013-12-10','10:05:00',1.51),('15529','2013-12-10','10:10:00',1.55),('15529','2013-12-10','10:15:00',1.57),('15529','2013-12-10','10:20:00',1.6),('15529','2013-12-10','10:25:00',1.63),('15529','2013-12-10','10:30:00',1.63),('15529','2013-12-10','10:35:00',1.65),('15529','2013-12-10','10:40:00',1.67),('15529','2013-12-10','10:45:00',1.69),('15529','2013-12-10','10:50:00',1.71),('15529','2013-12-10','10:55:00',1.72),('15529','2013-12-10','11:00:00',1.74),('15529','2013-12-10','11:05:00',1.76),('15529','2013-12-10','11:10:00',1.78),('15529','2013-12-10','11:15:00',1.79),('15529','2013-12-10','11:20:00',1.8),('15529','2013-12-10','11:25:00',1.8),('15529','2013-12-10','11:30:00',1.78),('15529','2013-12-10','11:35:00',1.76),('15529','2013-12-10','11:40:00',1.77),('15529','2013-12-10','11:45:00',1.8),('15529','2013-12-10','11:50:00',1.79),('15529','2013-12-10','11:55:00',1.81),('15529','2013-12-10','12:00:00',1.8),('15529','2013-12-10','12:05:00',1.79),('15529','2013-12-10','12:10:00',1.79),('15529','2013-12-10','12:15:00',1.79),('15529','2013-12-10','12:20:00',1.79),('15529','2013-12-10','12:25:00',1.78),('15529','2013-12-10','12:30:00',1.76),('15529','2013-12-10','12:35:00',1.75),('15529','2013-12-10','12:40:00',1.76),('15529','2013-12-10','12:45:00',1.74),('15529','2013-12-10','12:50:00',1.73),('15529','2013-12-10','12:55:00',1.71),('15529','2013-12-10','13:00:00',1.69),('15529','2013-12-10','13:05:00',1.71),('15529','2013-12-10','13:10:00',1.69),('15529','2013-12-10','13:15:00',1.65),('15529','2013-12-10','13:20:00',1.62),('15529','2013-12-10','13:25:00',1.61),('15529','2013-12-10','13:30:00',1.56),('15529','2013-12-10','13:35:00',1.54),('15529','2013-12-10','13:40:00',1.53),('15529','2013-12-10','13:45:00',1.52),('15529','2013-12-10','13:50:00',1.49),('15529','2013-12-10','13:55:00',1.45),('15529','2013-12-10','14:00:00',1.41),('15529','2013-12-10','14:05:00',1.38),('15529','2013-12-10','14:10:00',1.34),('15529','2013-12-10','14:15:00',1.32),('15529','2013-12-10','14:20:00',1.29),('15529','2013-12-10','14:25:00',1.27),('15529','2013-12-10','14:30:00',1.23),('15529','2013-12-10','14:35:00',1.19),('15529','2013-12-10','14:40:00',1.13),('15529','2013-12-10','14:45:00',1.09),('15529','2013-12-10','14:50:00',1.05),('15529','2013-12-10','14:55:00',1.01),('15529','2013-12-09','09:00:00',1.04),('15529','2013-12-09','09:05:00',1.1),('15529','2013-12-09','09:10:00',1.13),('15529','2013-12-09','09:15:00',1.17),('15529','2013-12-09','09:20:00',1.21),('15529','2013-12-09','09:25:00',1.25),('15529','2013-12-09','09:30:00',1.28),('15529','2013-12-09','09:35:00',1.31),('15529','2013-12-09','09:40:00',1.33),('15529','2013-12-09','09:45:00',1.36),('15529','2013-12-09','09:50:00',1.4),('15529','2013-12-09','09:55:00',1.43),('15529','2013-12-09','10:00:00',1.47),('15529','2013-12-09','10:05:00',1.51),('15529','2013-12-09','10:10:00',1.54),('15529','2013-12-09','10:15:00',1.55),('15529','2013-12-09','10:20:00',1.57),('15529','2013-12-09','10:25:00',1.59),('15529','2013-12-09','10:30:00',1.62),('15529','2013-12-09','10:35:00',1.64),('15529','2013-12-09','10:40:00',1.66),('15529','2013-12-09','10:45:00',1.66),('15529','2013-12-09','10:50:00',1.68),('15529','2013-12-09','10:55:00',1.7),('15529','2013-12-09','11:00:00',1.7),('15529','2013-12-09','11:05:00',1.73),('15529','2013-12-09','11:10:00',1.74),('15529','2013-12-09','11:15:00',1.77),('15529','2013-12-09','11:20:00',1.77),('15529','2013-12-09','11:25:00',1.78),('15529','2013-12-09','11:30:00',1.79),('15529','2013-12-09','11:35:00',1.79),('15529','2013-12-09','11:40:00',1.79),('15529','2013-12-09','11:45:00',1.8),('15529','2013-12-09','11:50:00',1.81),('15529','2013-12-09','11:55:00',1.82),('15529','2013-12-09','12:00:00',1.81),('15529','2013-12-09','12:05:00',1.82),('15529','2013-12-09','12:10:00',1.81),('15529','2013-12-09','12:15:00',1.8),('15529','2013-12-09','12:20:00',1.79),('15529','2013-12-09','12:25:00',1.78),('15529','2013-12-09','12:30:00',1.75),('15529','2013-12-09','12:35:00',1.71),('15529','2013-12-09','12:40:00',1.66),('15529','2013-12-09','12:45:00',1.63),('15529','2013-12-09','12:50:00',1.66),('15529','2013-12-09','12:55:00',1.67),('15529','2013-12-09','13:00:00',1.67),('15529','2013-12-09','13:05:00',1.65),('15529','2013-12-09','13:10:00',1.64),('15529','2013-12-09','13:15:00',1.63),('15529','2013-12-09','13:20:00',1.6),('15529','2013-12-09','13:25:00',1.58),('15529','2013-12-09','13:30:00',1.55),('15529','2013-12-09','13:35:00',1.54),('15529','2013-12-09','13:40:00',1.51),('15529','2013-12-09','13:45:00',1.52),('15529','2013-12-09','13:50:00',1.5),('15529','2013-12-09','13:55:00',1.45),('15529','2013-12-09','14:00:00',1.43),('15529','2013-12-09','14:05:00',1.41),('15529','2013-12-09','14:10:00',1.39),('15529','2013-12-09','14:15:00',1.36),('15529','2013-12-09','14:20:00',1.32),('15529','2013-12-09','14:25:00',1.29),('15529','2013-12-09','14:30:00',1.26),('15529','2013-12-09','14:35:00',1.22),('15529','2013-12-09','14:40:00',1.19),('15529','2013-12-09','14:45:00',1.11),('15529','2013-12-09','14:50:00',1.1),('15529','2013-12-09','14:55:00',1.06),('15529','2013-12-09','15:00:00',1),('15529','2013-12-08','09:25:00',1.07),('15529','2013-12-08','09:30:00',1.23),('15529','2013-12-08','09:35:00',1.27),('15529','2013-12-08','09:40:00',1.31),('15529','2013-12-08','09:45:00',1.35),('15529','2013-12-08','09:50:00',1.4),('15529','2013-12-08','09:55:00',1.44),('15529','2013-12-08','10:00:00',1.62),('15529','2013-12-08','10:05:00',1.74),('15529','2013-12-08','10:10:00',1.85),('15529','2013-12-08','10:15:00',1.75),('15529','2013-12-08','12:50:00',1.3),('15529','2013-12-08','12:55:00',1.44),('15529','2013-12-08','13:00:00',1.63),('15529','2014-04-20','10:10:00',1.14),('15529','2014-04-20','10:15:00',1.49),('15529','2014-04-20','10:20:00',1.78),('15529','2014-04-20','10:25:00',1.77),('15529','2014-04-20','10:30:00',1.78),('15529','2014-04-20','10:35:00',1.8),('15529','2014-04-20','10:40:00',1.81),('15529','2014-04-20','10:45:00',1.85),('15529','2014-04-20','10:50:00',1.86),('15529','2014-04-20','10:55:00',1.89),('15529','2014-04-20','11:00:00',1.91),('15529','2014-04-20','11:05:00',1.93),('15529','2014-04-20','11:10:00',1.97),('15529','2014-04-20','11:15:00',2),('15529','2014-04-20','11:20:00',2.02),('15529','2014-04-20','11:25:00',2.03),('15529','2014-04-20','11:30:00',2.06),('15529','2014-04-20','11:35:00',2.08),('15529','2014-04-20','11:40:00',2.06),('15529','2014-04-20','11:45:00',2.12),('15529','2014-04-20','11:50:00',2.12),('15529','2014-04-20','11:55:00',2.14),('15529','2014-04-20','12:00:00',2.19),('15529','2014-04-20','12:05:00',2.17),('15529','2014-04-20','12:10:00',2.23),('15529','2014-04-20','12:15:00',2.23),('15529','2014-04-20','12:20:00',2.24),('15529','2014-04-20','12:25:00',2.25),('15529','2014-04-20','12:30:00',2.24),('15529','2014-04-20','12:35:00',2.24),('15529','2014-04-20','12:40:00',2.27),('15529','2014-04-20','12:45:00',2.27),('15529','2014-04-20','12:50:00',2.24),('15529','2014-04-20','12:55:00',2.25),('15529','2014-04-20','13:00:00',2.28),('15529','2014-04-20','13:05:00',2.26),('15529','2014-04-20','13:10:00',2.28),('15529','2014-04-20','13:15:00',2.28),('15529','2014-04-20','13:20:00',2.28),('15529','2014-04-20','13:25:00',2.29),('15529','2014-04-20','13:30:00',2.25),('15529','2014-04-20','13:35:00',2.25),('15529','2014-04-20','13:40:00',2.28),('15529','2014-04-20','13:45:00',2.25),('15529','2014-04-20','13:50:00',2.28),('15529','2014-04-20','13:55:00',2.27),('15529','2014-04-20','14:00:00',2.26),('15529','2014-04-20','14:05:00',2.23),('15529','2014-04-20','14:10:00',2.24),('15529','2014-04-20','14:15:00',2.19),('15529','2014-04-20','14:20:00',2.21),('15529','2014-04-20','14:25:00',2.19),('15529','2014-04-20','14:30:00',2.18),('15529','2014-04-20','14:35:00',2.15),('15529','2014-04-20','14:40:00',2.14),('15529','2014-04-20','14:45:00',2.1),('15529','2014-04-20','14:50:00',2.08),('15529','2014-04-20','14:55:00',2.05),('15529','2014-04-20','15:00:00',2.02),('15529','2014-04-20','15:05:00',2.01),('15529','2014-04-20','15:10:00',2.01),('15529','2014-04-20','15:15:00',1.98),('15529','2014-04-20','15:20:00',1.94),('15529','2014-04-20','15:25:00',1.92),('15529','2014-04-20','15:30:00',1.89),('15529','2014-04-20','15:35:00',1.85),('15529','2014-04-20','15:40:00',1.83),('15529','2014-04-20','15:45:00',1.81),('15529','2014-04-20','15:50:00',1.77),('15529','2014-04-20','15:55:00',1.74),('15529','2014-04-20','16:00:00',1.72),('15529','2014-04-20','16:05:00',1.7),('15529','2014-04-20','16:10:00',1.65),('15529','2014-04-20','16:15:00',1.66),('15529','2014-04-20','16:20:00',1.56),('15529','2014-04-20','16:25:00',1.54),('15529','2014-04-20','16:30:00',1.51),('15529','2014-04-20','16:35:00',1.45),('15529','2014-04-20','16:40:00',1.41),('15529','2014-04-20','16:45:00',1.38),('15529','2014-04-20','16:50:00',1.32),('15529','2014-04-20','16:55:00',1.28),('15529','2014-04-20','17:00:00',1.24),('15529','2014-04-20','17:05:00',1.19),('15529','2014-04-20','17:10:00',1.15),('15529','2014-04-20','17:15:00',1.1),('15529','2014-04-20','17:20:00',1.05),('15529','2014-04-20','17:25:00',1.02),('15529','2013-12-06','09:05:00',1.04),('15529','2013-12-06','09:10:00',1.09),('15529','2013-12-06','09:15:00',1.14),('15529','2013-12-06','09:20:00',1.19),('15529','2013-12-06','09:25:00',1.24),('15529','2013-12-06','09:30:00',1.28),('15529','2013-12-06','09:35:00',1.32),('15529','2013-12-06','09:40:00',1.34),('15529','2013-12-06','09:45:00',1.37),('15529','2013-12-06','09:50:00',1.41),('15529','2013-12-06','09:55:00',1.44),('15529','2013-12-06','10:00:00',1.47),('15529','2013-12-06','10:05:00',1.49),('15529','2013-12-06','10:10:00',1.52),('15529','2013-12-06','10:15:00',1.53),('15529','2013-12-06','10:20:00',1.54),('15529','2013-12-06','10:25:00',1.55),('15529','2013-12-06','10:30:00',1.58),('15529','2013-12-06','10:35:00',1.61),('15529','2013-12-06','10:40:00',1.66),('15529','2013-12-06','10:45:00',1.69),('15529','2013-12-06','10:50:00',1.7),('15529','2013-12-06','10:55:00',1.69),('15529','2013-12-06','11:00:00',1.68),('15529','2013-12-06','11:05:00',1.7),('15529','2013-12-06','11:10:00',1.7),('15529','2013-12-06','11:15:00',1.7),('15529','2013-12-06','11:20:00',1.7),('15529','2013-12-06','11:25:00',1.7),('15529','2013-12-06','11:30:00',1.71),('15529','2013-12-06','11:35:00',1.71),('15529','2013-12-06','11:40:00',1.71),('15529','2013-12-06','11:45:00',1.69),('15529','2013-12-06','11:50:00',1.69),('15529','2013-12-06','11:55:00',1.7),('15529','2013-12-06','12:00:00',1.69),('15529','2013-12-06','12:05:00',1.69),('15529','2013-12-06','12:10:00',1.68),('15529','2013-12-06','12:15:00',1.71),('15529','2013-12-06','12:20:00',1.71),('15529','2013-12-06','12:25:00',1.69),('15529','2013-12-06','12:30:00',1.68),('15529','2013-12-06','12:35:00',1.67),('15529','2013-12-06','12:40:00',1.67),('15529','2013-12-06','12:45:00',1.64),('15529','2013-12-06','12:50:00',1.63),('15529','2013-12-06','12:55:00',1.64),('15529','2013-12-06','13:00:00',1.6),('15529','2013-12-06','13:05:00',1.59),('15529','2013-12-06','13:10:00',1.59),('15529','2013-12-06','13:15:00',1.59),('15529','2013-12-06','13:20:00',1.57),('15529','2013-12-06','13:25:00',1.57),('15529','2013-12-06','13:30:00',1.54),('15529','2013-12-06','13:35:00',1.52),('15529','2013-12-06','13:40:00',1.52),('15529','2013-12-06','13:45:00',1.49),('15529','2013-12-06','13:50:00',1.46),('15529','2013-12-06','13:55:00',1.44),('15529','2013-12-06','14:00:00',1.38),('15529','2013-12-06','14:05:00',1.36),('15529','2013-12-06','14:10:00',1.34),('15529','2013-12-06','14:15:00',1.3),('15529','2013-12-06','14:20:00',1.25),('15529','2013-12-06','14:25:00',1.18),('15529','2013-12-06','14:30:00',1.15),('15529','2013-12-06','14:35:00',1.12),('15529','2013-12-06','14:40:00',1.07),('15529','2013-12-05','11:50:00',1.2),('15529','2013-12-05','11:55:00',1.42),('15529','2013-12-05','12:00:00',1.31),('15529','2013-12-05','12:05:00',1.2),('15529','2013-12-05','12:10:00',1.2),('15529','2013-12-05','12:15:00',1.29),('15529','2013-12-05','12:30:00',1.34),('15529','2013-12-05','12:35:00',1.88),('15529','2013-12-05','15:05:00',1.06),('15529','2013-12-04','08:55:00',1.03),('15529','2013-12-04','09:00:00',1.07),('15529','2013-12-04','09:05:00',1.12),('15529','2013-12-04','09:10:00',1.15),('15529','2013-12-04','09:15:00',1.22),('15529','2013-12-04','09:20:00',1.26),('15529','2013-12-04','09:25:00',1.31),('15529','2013-12-04','09:30:00',1.34),('15529','2013-12-04','09:35:00',1.37),('15529','2013-12-04','09:40:00',1.39),('15529','2013-12-04','09:45:00',1.41),('15529','2013-12-04','09:50:00',1.44),('15529','2013-12-04','09:55:00',1.47),('15529','2013-12-04','10:00:00',1.51),('15529','2013-12-04','10:05:00',1.54),('15529','2013-12-04','10:10:00',1.55),('15529','2013-12-04','10:15:00',1.58),('15529','2013-12-04','10:20:00',1.59),('15529','2013-12-04','10:25:00',1.61),('15529','2013-12-04','10:30:00',1.63),('15529','2013-12-04','10:35:00',1.63),('15529','2013-12-04','10:40:00',1.67),('15529','2013-12-04','10:45:00',1.65),('15529','2013-12-04','10:50:00',1.68),('15529','2013-12-04','10:55:00',1.69),('15529','2013-12-04','11:00:00',1.71),('15529','2013-12-04','11:05:00',1.71),('15529','2013-12-04','11:10:00',1.74),('15529','2013-12-04','11:15:00',1.76),('15529','2013-12-04','11:20:00',1.77),('15529','2013-12-04','11:25:00',1.79),('15529','2013-12-04','11:30:00',1.78),('15529','2013-12-04','11:35:00',1.77),('15529','2013-12-04','11:40:00',1.8),('15529','2013-12-04','11:45:00',1.78),('15529','2013-12-04','11:50:00',1.76),('15529','2013-12-04','11:55:00',1.76),('15529','2013-12-04','12:00:00',1.75),('15529','2013-12-04','12:05:00',1.78),('15529','2013-12-04','12:10:00',1.74),('15529','2013-12-04','12:15:00',1.73),('15529','2013-12-04','12:20:00',1.77),('15529','2013-12-04','12:25:00',1.74),('15529','2013-12-04','12:30:00',1.73),('15529','2013-12-04','12:35:00',1.75),('15529','2013-12-04','12:40:00',1.77),('15529','2013-12-04','12:45:00',1.74),('15529','2013-12-04','12:50:00',1.8),('15529','2013-12-04','12:55:00',1.73),('15529','2013-12-04','13:00:00',1.71),('15529','2013-12-04','13:05:00',1.69),('15529','2013-12-04','13:10:00',1.66),('15529','2013-12-04','13:15:00',1.64),('15529','2013-12-04','13:20:00',1.64),('15529','2013-12-04','13:25:00',1.62),('15529','2013-12-04','13:30:00',1.36),('15529','2013-12-04','13:35:00',1.46),('15529','2013-12-04','13:40:00',1.5),('15529','2013-12-04','13:45:00',1.46),('15529','2013-12-04','13:50:00',1.43),('15529','2013-12-04','13:55:00',1.39),('15529','2013-12-04','14:00:00',1.39),('15529','2013-12-04','14:05:00',1.38),('15529','2013-12-04','14:10:00',1.31),('15529','2013-12-04','14:15:00',1.28),('15529','2013-12-04','14:20:00',1.2),('15529','2013-12-04','14:25:00',1.2),('15529','2013-12-04','14:30:00',1.16),('15529','2013-12-04','14:35:00',1.17),('15529','2013-12-04','14:40:00',1.11),('15529','2013-12-04','14:45:00',1.08),('15529','2013-12-04','14:50:00',1.02),('15529','2013-12-03','08:45:00',1.04),('15529','2013-12-03','08:50:00',1.09),('15529','2013-12-03','08:55:00',1.13),('15529','2013-12-03','09:00:00',1.17),('15529','2013-12-03','09:05:00',1.22),('15529','2013-12-03','09:10:00',1.26),('15529','2013-12-03','09:15:00',1.3),('15529','2013-12-03','09:20:00',1.34),('15529','2013-12-03','09:25:00',1.38),('15529','2013-12-03','09:30:00',1.41),('15529','2013-12-03','09:35:00',1.44),('15529','2013-12-03','09:40:00',1.48),('15529','2013-12-03','09:45:00',1.52),('15529','2013-12-03','09:50:00',1.56),('15529','2013-12-03','09:55:00',1.58),('15529','2013-12-03','10:00:00',1.6),('15529','2013-12-03','10:05:00',1.64),('15529','2013-12-03','10:10:00',1.66),('15529','2013-12-03','10:15:00',1.68),('15529','2013-12-03','10:20:00',1.7),('15529','2013-12-03','10:25:00',1.72),('15529','2013-12-03','10:30:00',1.73),('15529','2013-12-03','10:35:00',1.75),('15529','2013-12-03','10:40:00',1.77),('15529','2013-12-03','10:45:00',1.78),('15529','2013-12-03','10:50:00',1.79),('15529','2013-12-03','10:55:00',1.8),('15529','2013-12-03','11:00:00',1.81),('15529','2013-12-03','11:05:00',1.83),('15529','2013-12-03','11:10:00',1.85),('15529','2013-12-03','11:15:00',1.85),('15529','2013-12-03','11:20:00',1.85),('15529','2013-12-03','11:25:00',1.88),('15529','2013-12-03','11:30:00',1.88),('15529','2013-12-03','11:35:00',1.87),('15529','2013-12-03','11:40:00',1.87),('15529','2013-12-03','11:45:00',1.87),('15529','2013-12-03','11:50:00',1.87),('15529','2013-12-03','11:55:00',1.86),('15529','2013-12-03','12:00:00',1.87),('15529','2013-12-03','12:05:00',1.86),('15529','2013-12-03','12:10:00',1.86),('15529','2013-12-03','12:15:00',1.84),('15529','2013-12-03','12:20:00',1.83),('15529','2013-12-03','12:25:00',1.83),('15529','2013-12-03','12:30:00',1.83),('15529','2013-12-03','12:35:00',1.82),('15529','2013-12-03','12:40:00',1.81),('15529','2013-12-03','12:45:00',1.8),('15529','2013-12-03','12:50:00',1.8),('15529','2013-12-03','12:55:00',1.76),('15529','2013-12-03','13:00:00',1.75),('15529','2013-12-03','13:05:00',1.74),('15529','2013-12-03','13:10:00',1.72),('15529','2013-12-03','13:15:00',1.71),('15529','2013-12-03','13:20:00',1.7),('15529','2013-12-03','13:25:00',1.66),('15529','2013-12-03','13:30:00',1.63),('15529','2013-12-03','13:35:00',1.62),('15529','2013-12-03','13:40:00',1.59),('15529','2013-12-03','13:45:00',1.57),('15529','2013-12-03','13:50:00',1.54),('15529','2013-12-03','13:55:00',1.52),('15529','2013-12-03','14:00:00',1.49),('15529','2013-12-03','14:05:00',1.46),('15529','2013-12-03','14:10:00',1.42),('15529','2013-12-03','14:15:00',1.4),('15529','2013-12-03','14:20:00',1.38),('15529','2013-12-03','14:25:00',1.34),('15529','2013-12-03','14:30:00',1.29),('15529','2013-12-03','14:35:00',1.25),('15529','2013-12-03','14:40:00',1.21),('15529','2013-12-03','14:45:00',1.17),('15529','2013-12-03','14:50:00',1.12),('15529','2013-12-03','14:55:00',1.08),('15529','2013-12-03','15:00:00',1.03),('15529','2013-12-02','09:35:00',1.11),('15529','2013-12-02','09:40:00',1.29),('15529','2013-12-02','09:45:00',1.31),('15529','2013-12-02','09:50:00',1.45),('15529','2013-12-02','09:55:00',1.37),('15529','2013-12-02','10:00:00',1.63),('15529','2013-12-02','10:05:00',1.64),('15529','2013-12-02','10:10:00',1.65),('15529','2013-12-02','10:15:00',1.66),('15529','2013-12-02','10:20:00',1.68),('15529','2013-12-02','10:25:00',1.7),('15529','2013-12-02','10:30:00',1.71),('15529','2013-12-02','10:35:00',1.74),('15529','2013-12-02','10:40:00',1.76),('15529','2013-12-02','10:45:00',1.79),('15529','2013-12-02','10:50:00',1.83),('15529','2013-12-02','10:55:00',1.84),('15529','2013-12-02','11:00:00',1.85),('15529','2013-12-02','11:05:00',1.87),('15529','2013-12-02','11:10:00',1.87),('15529','2013-12-02','11:15:00',1.88),('15529','2013-12-02','11:20:00',1.88),('15529','2013-12-02','11:25:00',1.88),('15529','2013-12-02','11:30:00',1.89),('15529','2013-12-02','11:35:00',1.88),('15529','2013-12-02','11:40:00',1.88),('15529','2013-12-02','11:45:00',1.88),('15529','2013-12-02','11:50:00',1.89),('15529','2013-12-02','11:55:00',1.89),('15529','2013-12-02','12:00:00',1.89),('15529','2013-12-02','12:05:00',1.9),('15529','2013-12-02','12:10:00',1.89),('15529','2013-12-02','12:15:00',1.89),('15529','2013-12-02','12:20:00',1.91),('15529','2013-12-02','12:25:00',1.89),('15529','2013-12-02','12:30:00',1.9),('15529','2013-12-02','12:35:00',1.92),('15529','2013-12-02','12:40:00',1.92),('15529','2013-12-02','12:45:00',1.94),('15529','2013-12-02','12:50:00',1.99),('15529','2013-12-02','12:55:00',2.02),('15529','2013-12-02','13:00:00',2.05),('15529','2013-12-02','13:05:00',2.08),('15529','2013-12-02','13:10:00',2.08),('15529','2013-12-02','13:15:00',2.08),('15529','2013-12-02','13:20:00',2),('15529','2013-12-02','13:25:00',1.97),('15529','2013-12-02','13:30:00',1.86),('15529','2013-12-02','13:35:00',1.76),('15529','2013-12-02','13:40:00',1.82),('15529','2013-12-02','13:45:00',1.74),('15529','2013-12-02','13:50:00',1.62),('15529','2013-12-02','13:55:00',1.55),('15529','2013-12-02','14:00:00',1.42),('15529','2013-12-02','14:05:00',1.22),('15529','2013-12-02','14:10:00',1.13),('15529','2013-12-02','14:15:00',1.14),('15529','2013-12-02','14:20:00',1.08),('15529','2013-12-02','14:25:00',1.08),('15529','2013-12-02','14:30:00',1.22),('15529','2013-12-02','14:35:00',1.26),('15529','2013-12-02','14:40:00',1.21),('15529','2013-12-02','14:45:00',1.16),('15529','2013-12-02','14:50:00',1.11),('15529','2013-12-02','14:55:00',1.06),('15529','2013-12-02','15:00:00',1.01),('15529','2013-11-29','09:15:00',1.08),('15529','2013-11-29','09:20:00',1.08),('15529','2013-11-29','09:25:00',1.36),('15529','2013-11-29','09:30:00',1.52),('15529','2013-11-29','09:35:00',1.34),('15529','2013-11-29','09:40:00',1.15),('15529','2013-11-29','10:40:00',1.09),('15529','2013-11-28','08:45:00',1.03),('15529','2013-11-28','08:50:00',1.08),('15529','2013-11-28','08:55:00',1.12),('15529','2013-11-28','09:00:00',1.17),('15529','2013-11-28','09:05:00',1.22),('15529','2013-11-28','09:10:00',1.26),('15529','2013-11-28','09:15:00',1.3),('15529','2013-11-28','09:20:00',1.34),('15529','2013-11-28','09:25:00',1.38),('15529','2013-11-28','09:30:00',1.42),('15529','2013-11-28','09:35:00',1.47),('15529','2013-11-28','09:40:00',1.5),('15529','2013-11-28','09:45:00',1.54),('15529','2013-11-28','09:50:00',1.57),('15529','2013-11-28','09:55:00',1.6),('15529','2013-11-28','10:00:00',1.63),('15529','2013-11-28','10:05:00',1.66),('15529','2013-11-28','10:10:00',1.68),('15529','2013-11-28','10:15:00',1.7),('15529','2013-11-28','10:20:00',1.73),('15529','2013-11-28','10:25:00',1.75),('15529','2013-11-28','10:30:00',1.77),('15529','2013-11-28','10:35:00',1.78),('15529','2013-11-28','10:40:00',1.8),('15529','2013-11-28','10:45:00',1.82),('15529','2013-11-28','10:50:00',1.83),('15529','2013-11-28','10:55:00',1.84),('15529','2013-11-28','11:00:00',1.85),('15529','2013-11-28','11:05:00',1.87),('15529','2013-11-28','11:10:00',1.88),('15529','2013-11-28','11:15:00',1.89),('15529','2013-11-28','11:20:00',1.9),('15529','2013-11-28','11:25:00',1.91),('15529','2013-11-28','11:30:00',1.92),('15529','2013-11-28','11:35:00',1.92),('15529','2013-11-28','11:40:00',1.92),('15529','2013-11-28','11:45:00',1.93),('15529','2013-11-28','11:50:00',1.92),('15529','2013-11-28','11:55:00',1.93),('15529','2013-11-28','12:00:00',1.92),('15529','2013-11-28','12:05:00',1.92),('15529','2013-11-28','12:10:00',1.91),('15529','2013-11-28','12:15:00',1.9),('15529','2013-11-28','12:20:00',1.89),('15529','2013-11-28','12:25:00',1.87),('15529','2013-11-28','12:30:00',1.88),('15529','2013-11-28','12:35:00',1.88),('15529','2013-11-28','12:40:00',1.87),('15529','2013-11-28','12:45:00',1.85),('15529','2013-11-28','12:50:00',1.84),('15529','2013-11-28','12:55:00',1.82),('15529','2013-11-28','13:00:00',1.81),('15529','2013-11-28','13:05:00',1.78),('15529','2013-11-28','13:10:00',1.77),('15529','2013-11-28','13:15:00',1.76),('15529','2013-11-28','13:20:00',1.73),('15529','2013-11-28','13:25:00',1.7),('15529','2013-11-28','13:30:00',1.68),('15529','2013-11-28','13:35:00',1.65),('15529','2013-11-28','13:40:00',1.63),('15529','2013-11-28','13:45:00',1.6),('15529','2013-11-28','13:50:00',1.57),('15529','2013-11-28','13:55:00',1.54),('15529','2013-11-28','14:00:00',1.5),('15529','2013-11-28','14:05:00',1.46),('15529','2013-11-28','14:10:00',1.42),('15529','2013-11-28','14:15:00',1.4),('15529','2013-11-28','14:20:00',1.37),('15529','2013-11-28','14:25:00',1.33),('15529','2013-11-28','14:30:00',1.28),('15529','2013-11-28','14:35:00',1.24),('15529','2013-11-28','14:40:00',1.19),('15529','2013-11-28','14:45:00',1.15),('15529','2013-11-28','14:50:00',1.1),('15529','2013-11-28','14:55:00',1.05),('15529','2013-11-28','15:00:00',1.01),('15529','2014-04-19','09:10:00',1.27),('15529','2014-04-19','09:15:00',1.39),('15529','2014-04-19','09:20:00',1.33),('15529','2014-04-19','09:30:00',1.18),('15529','2014-04-19','09:35:00',1.73),('15529','2014-04-19','09:45:00',1),('15529','2014-04-19','09:55:00',1.02),('15529','2014-04-19','10:00:00',1.2),('15529','2014-04-19','10:05:00',1.46),('15529','2014-04-19','10:10:00',1.24),('15529','2014-04-19','10:15:00',1.58),('15529','2014-04-19','10:20:00',1.69),('15529','2014-04-19','10:25:00',1.58),('15529','2014-04-19','10:30:00',1.29),('15529','2014-04-19','10:35:00',1.45),('15529','2014-04-19','10:40:00',1.32),('15529','2014-04-19','10:45:00',1.35),('15529','2014-04-19','10:50:00',1.43),('15529','2014-04-19','10:55:00',1.76),('15529','2014-04-19','11:00:00',1.87),('15529','2014-04-19','11:05:00',1.75),('15529','2014-04-19','11:10:00',1.95),('15529','2014-04-19','11:15:00',2.2),('15529','2014-04-19','11:20:00',1.92),('15529','2014-04-19','11:25:00',2.15),('15529','2014-04-19','11:30:00',2.22),('15529','2014-04-19','11:35:00',2.27),('15529','2014-04-19','11:40:00',2.29),('15529','2014-04-19','11:45:00',2.3),('15529','2014-04-19','11:50:00',1.58),('15529','2014-04-19','11:55:00',1.99),('15529','2014-04-19','12:00:00',1.38),('15529','2014-04-19','12:05:00',2.35),('15529','2014-04-19','12:10:00',2.24),('15529','2014-04-19','12:15:00',1.87),('15529','2014-04-19','12:20:00',1.96),('15529','2014-04-19','12:25:00',1.36),('15529','2014-04-19','12:30:00',2.33),('15529','2014-04-19','12:40:00',1.13),('15529','2014-04-19','12:45:00',2.48),('15529','2014-04-19','12:50:00',2.47),('15529','2014-04-19','12:55:00',2.38),('15529','2014-04-19','13:00:00',2.38),('15529','2014-04-19','13:05:00',2.37),('15529','2014-04-19','13:10:00',2.09),('15529','2014-04-19','13:15:00',2.38),('15529','2014-04-19','13:20:00',2.37),('15529','2014-04-19','13:25:00',2.34),('15529','2014-04-19','13:30:00',2.32),('15529','2014-04-19','13:35:00',2.35),('15529','2014-04-19','13:40:00',2.33),('15529','2014-04-19','13:45:00',2.31),('15529','2014-04-19','13:50:00',2.31),('15529','2014-04-19','13:55:00',2.31),('15529','2014-04-19','14:00:00',2.31),('15529','2014-04-19','14:05:00',2.29),('15529','2014-04-19','14:10:00',2.29),('15529','2014-04-19','14:15:00',2.35),('15529','2014-04-19','14:20:00',1.51),('15529','2014-04-19','14:25:00',1.54),('15529','2014-04-19','14:30:00',1.39),('15529','2014-04-19','14:35:00',1.23),('15529','2014-04-19','14:40:00',1.25),('15529','2014-04-19','14:45:00',1.34),('15529','2014-04-19','14:50:00',1.37),('15529','2014-04-19','14:55:00',1.52),('15529','2014-04-19','15:00:00',2.33),('15529','2014-04-19','15:05:00',1.9),('15529','2014-04-19','15:10:00',1.99),('15529','2014-04-19','15:15:00',2.03),('15529','2014-04-19','15:20:00',1.99),('15529','2014-04-19','15:25:00',1.97),('15529','2014-04-19','15:30:00',1.96),('15529','2014-04-19','15:35:00',1.94),('15529','2014-04-19','15:40:00',2),('15529','2014-04-19','15:45:00',1.27),('15529','2014-04-19','15:50:00',1.8),('15529','2014-04-19','15:55:00',1.81),('15529','2014-04-19','16:00:00',1.76),('15529','2014-04-19','16:05:00',1.72),('15529','2014-04-19','16:10:00',1.7),('15529','2014-04-19','16:15:00',1.67),('15529','2014-04-19','16:20:00',1.63),('15529','2014-04-19','16:25:00',1.7),('15529','2014-04-19','16:30:00',1.54),('15529','2014-04-19','16:35:00',1.52),('15529','2014-04-19','16:40:00',1.26),('15529','2014-04-19','16:45:00',1.04),('15529','2014-04-19','16:50:00',1.45),('15529','2014-04-19','16:55:00',1.38),('15529','2014-04-19','17:00:00',1.3),('15529','2014-04-19','17:05:00',1.23),('15529','2014-04-19','17:10:00',1.17),('15529','2014-04-19','17:15:00',1.11),('15529','2014-04-19','17:20:00',1.06),('15529','2014-04-19','17:25:00',1),('15529','2013-11-26','11:30:00',1.25),('15529','2013-11-26','11:35:00',1.05),('15529','2013-11-26','11:45:00',1.4),('15529','2013-11-26','11:50:00',2.24),('15529','2013-11-26','11:55:00',2.11),('15529','2013-11-26','12:00:00',1.95),('15529','2013-11-26','12:10:00',1),('15529','2013-11-26','12:15:00',1.46),('15529','2013-11-26','12:20:00',1.66),('15529','2013-11-26','12:25:00',1.98),('15529','2013-11-25','10:00:00',1.53),('15529','2013-11-25','10:10:00',1.07),('15529','2013-11-25','10:15:00',1.54),('15529','2013-11-25','10:20:00',2.11),('15529','2013-11-25','10:25:00',2.03),('15529','2013-11-25','10:30:00',1.56),('15529','2013-11-25','10:35:00',1.54),('15529','2013-11-25','10:40:00',1.98),('15529','2013-11-25','10:45:00',1.96),('15529','2013-11-25','10:50:00',1.98),('15529','2013-11-25','10:55:00',1.98),('15529','2013-11-25','11:00:00',2.03),('15529','2013-11-25','11:05:00',2.16),('15529','2013-11-25','11:10:00',2.26),('15529','2013-11-25','11:15:00',2.08),('15529','2013-11-25','11:20:00',1.08),('15529','2013-11-25','11:25:00',2.3),('15529','2013-11-25','11:30:00',2.13),('15529','2013-11-25','11:35:00',2.28),('15529','2013-11-25','11:40:00',1.66),('15529','2013-11-25','11:45:00',2.03),('15529','2013-11-25','11:50:00',1.69),('15529','2013-11-25','11:55:00',1.46),('15529','2013-11-25','12:00:00',1.3),('15529','2013-11-25','12:15:00',1.53),('15529','2013-11-25','12:20:00',2.1),('15529','2013-11-25','12:25:00',2.05),('15529','2013-11-25','12:30:00',2.02),('15529','2013-11-25','12:35:00',2),('15529','2013-11-25','12:40:00',2.03),('15529','2013-11-25','12:45:00',2),('15529','2013-11-25','12:50:00',1.99),('15529','2013-11-25','12:55:00',1.98),('15529','2013-11-25','13:00:00',1.95),('15529','2013-11-25','13:05:00',1.94),('15529','2013-11-25','13:10:00',1.92),('15529','2013-11-25','13:15:00',1.91),('15529','2013-11-25','13:20:00',1.88),('15529','2013-11-25','13:25:00',1.86),('15529','2013-11-25','13:30:00',1.84),('15529','2013-11-25','13:35:00',1.81),('15529','2013-11-25','13:40:00',1.79),('15529','2013-11-25','13:45:00',1.77),('15529','2013-11-25','13:50:00',1.75),('15529','2013-11-25','13:55:00',1.71),('15529','2013-11-25','14:00:00',1.78),('15529','2013-11-25','14:05:00',1.86),('15529','2013-11-25','14:10:00',1.8),('15529','2013-11-25','14:15:00',1.99),('15529','2013-11-25','14:20:00',1.72),('15529','2013-11-25','14:25:00',1.71),('15529','2013-11-25','14:30:00',1.21),('15529','2013-11-25','14:35:00',1.35),('15529','2013-11-25','14:40:00',1.26),('15529','2013-11-25','14:45:00',1.24),('15529','2013-11-25','14:50:00',1.23),('15529','2013-11-25','14:55:00',1.37),('15529','2013-11-25','15:00:00',1.28),('15529','2013-11-25','15:05:00',1.2),('15529','2013-11-25','15:10:00',1.12),('15529','2013-11-25','15:15:00',1.04),('15529','2013-11-24','08:35:00',1.06),('15529','2013-11-24','08:50:00',1.1),('15529','2013-11-24','08:55:00',1.45),('15529','2013-11-24','09:00:00',1.56),('15529','2013-11-24','09:05:00',1.62),('15529','2013-11-24','09:10:00',1.61),('15529','2013-11-24','09:15:00',1.57),('15529','2013-11-24','09:20:00',1.68),('15529','2013-11-24','09:25:00',1.32),('15529','2013-11-24','09:30:00',1.48),('15529','2013-11-24','09:35:00',1.22),('15529','2013-11-24','09:40:00',1.05),('15529','2013-11-24','09:50:00',1.03),('15529','2013-11-24','09:55:00',1.58),('15529','2013-11-24','10:00:00',1.1),('15529','2013-11-24','10:10:00',1.12),('15529','2013-11-24','10:30:00',1.03),('15529','2013-11-24','10:35:00',1.66),('15529','2013-11-24','10:40:00',1.58),('15529','2013-11-24','10:45:00',1.97),('15529','2013-11-24','10:50:00',1.94),('15529','2013-11-24','10:55:00',1.89),('15529','2013-11-24','11:00:00',1.88),('15529','2013-11-24','11:05:00',1.94),('15529','2013-11-24','11:10:00',2.18),('15529','2013-11-24','11:15:00',1.8),('15529','2013-11-24','11:50:00',1.59),('15529','2013-11-24','11:55:00',1.08),('15529','2013-11-24','12:05:00',1.72),('15529','2013-11-24','12:10:00',1.37),('15529','2013-11-24','12:25:00',1),('15529','2013-11-24','12:35:00',1.99),('15529','2013-11-24','12:40:00',1.85),('15529','2013-11-24','12:45:00',1.42),('15529','2013-11-24','12:50:00',1.62),('15529','2013-11-24','12:55:00',1.9),('15529','2013-11-24','13:00:00',1.72),('15529','2013-11-24','13:05:00',1.93),('15529','2013-11-24','13:10:00',2.23),('15529','2013-11-24','13:15:00',1.9),('15529','2013-11-24','13:20:00',2.21),('15529','2013-11-24','13:25:00',2.13),('15529','2013-11-23','12:50:00',1.33),('15529','2013-11-23','12:55:00',1.53),('15529','2013-11-23','13:05:00',1.05),('15529','2013-11-23','13:10:00',1.29),('15529','2013-11-22','10:25:00',1.28),('15529','2013-11-22','10:30:00',1.49),('15529','2013-11-22','10:35:00',1.29),('15529','2013-11-22','13:35:00',1.25),('15529','2013-11-20','09:45:00',1.18),('15529','2013-11-20','10:00:00',1.15),('15529','2013-11-20','10:05:00',1.1),('15529','2013-11-20','10:10:00',1.58),('15529','2013-11-20','10:15:00',1.59),('15529','2013-11-20','10:20:00',1.29),('15529','2013-11-20','10:25:00',1.35),('15529','2013-11-20','10:30:00',1.8),('15529','2013-11-20','10:35:00',1.85),('15529','2013-11-20','10:40:00',1.71),('15529','2013-11-20','11:15:00',1.04),('15529','2013-11-20','11:20:00',1.79),('15529','2013-11-20','11:25:00',1.63),('15529','2013-11-20','11:30:00',1.36),('15529','2013-11-20','11:35:00',2.03),('15529','2013-11-20','11:40:00',1.35),('15529','2013-11-20','11:45:00',2.03),('15529','2013-11-20','11:50:00',1.9),('15529','2013-11-20','12:00:00',1.92),('15529','2013-11-20','12:05:00',2.01),('15529','2013-11-20','12:10:00',1.99),('15529','2013-11-20','12:15:00',1.98),('15529','2013-11-20','12:20:00',2.01),('15529','2013-11-20','12:25:00',2.05),('15529','2013-11-20','12:30:00',2.12),('15529','2013-11-20','12:35:00',1.76),('15529','2013-11-20','12:40:00',2.14),('15529','2013-11-20','12:45:00',2.09),('15529','2013-11-20','12:50:00',2.14),('15529','2013-11-20','12:55:00',1.43),('15529','2013-11-20','13:00:00',1.88),('15529','2013-11-20','13:10:00',1.79),('15529','2013-11-20','13:15:00',1.76),('15529','2013-11-20','13:20:00',1.08),('15529','2013-11-20','13:40:00',1.92),('15529','2013-11-20','13:45:00',1.33),('15529','2013-11-20','13:50:00',1.75),('15529','2013-11-20','13:55:00',1.56),('15529','2013-11-20','14:35:00',1.37),('15529','2013-11-20','14:40:00',1.3),('15529','2013-11-20','14:45:00',1.25),('15529','2013-11-20','14:50:00',1.2),('15529','2013-11-20','14:55:00',1.14),('15529','2013-11-20','15:00:00',1.09),('15529','2013-11-20','15:05:00',1.02),('15529','2013-11-19','09:10:00',1.33),('15529','2013-11-19','09:15:00',1.3),('15529','2013-11-19','09:20:00',1.34),('15529','2013-11-19','11:40:00',1.99),('15529','2013-11-19','11:45:00',1.79),('15529','2013-11-19','11:50:00',1.49),('15529','2013-11-19','12:15:00',1.22),('15529','2013-11-19','12:20:00',1.86),('15529','2013-11-19','12:45:00',1.06),('15529','2013-11-19','12:50:00',1.43),('15529','2013-11-19','13:15:00',1.13),('15529','2013-11-19','13:25:00',1.01),('15529','2013-11-19','13:35:00',1.21),('15529','2013-11-18','09:35:00',1.34),('15529','2013-11-18','09:40:00',1.48),('15529','2013-11-18','09:45:00',1.48),('15529','2013-11-18','11:25:00',1.29),('15529','2013-11-18','11:35:00',1.97),('15529','2013-11-18','11:40:00',1.86),('15529','2013-11-18','11:45:00',1.81),('15529','2013-11-18','11:50:00',1.79),('15529','2013-11-18','11:55:00',1.78),('15529','2013-11-18','12:00:00',1.66),('15529','2013-11-18','12:05:00',1.58),('15529','2013-11-18','12:10:00',1.14),('15529','2013-11-18','12:15:00',1.62),('15529','2013-11-18','12:20:00',1.36),('15529','2013-11-18','12:40:00',2.04),('15529','2013-11-18','12:45:00',2.02),('15529','2013-11-18','12:50:00',2.04),('15529','2013-11-18','15:30:00',1.06),('15529','2013-11-17','09:20:00',1.03),('15529','2013-11-17','09:25:00',1.07),('15529','2013-11-17','09:30:00',1.12),('15529','2013-11-17','09:35:00',1.38),('15529','2013-11-17','10:10:00',1.07),('15529','2013-11-17','10:15:00',1.07),('15529','2013-11-17','12:20:00',1.06),('15529','2013-11-17','12:25:00',1.11),('15529','2014-04-18','08:25:00',1.03),('15529','2014-04-18','08:30:00',1.07),('15529','2014-04-18','09:30:00',1.06),('15529','2014-04-18','11:15:00',1.21),('15529','2014-04-18','11:20:00',1.68),('15529','2014-04-18','11:25:00',1.28),('15529','2014-04-18','11:30:00',1.09),('15529','2014-04-18','11:35:00',1.24),('15529','2014-04-18','11:40:00',1.17),('15529','2014-04-18','14:40:00',1.16),('15529','2014-04-18','14:45:00',1.04),('15529','2014-04-18','15:50:00',1.25),('15529','2014-04-18','15:55:00',1.24),('15529','2014-04-18','16:00:00',1.55),('15529','2014-04-18','16:15:00',1.19),('15529','2014-04-18','16:20:00',1.02),('15529','2014-04-18','16:30:00',1.13),('15529','2013-11-16','08:50:00',1.39),('15529','2013-11-16','08:55:00',1.38),('15529','2013-11-16','09:00:00',1.3),('15529','2013-11-16','09:05:00',1.3),('15529','2013-11-16','09:20:00',1.33),('15529','2013-11-16','09:30:00',1.5),('15529','2013-11-16','09:35:00',1.61),('15529','2013-11-16','09:40:00',1.57),('15529','2013-11-16','09:45:00',1.51),('15529','2013-11-16','09:50:00',1.56),('15529','2013-11-16','09:55:00',1.59),('15529','2013-11-16','10:00:00',1.61),('15529','2013-11-16','10:05:00',1.64),('15529','2013-11-16','10:10:00',1.67),('15529','2013-11-16','10:15:00',1.68),('15529','2013-11-16','10:20:00',1.7),('15529','2013-11-16','10:25:00',1.72),('15529','2013-11-16','10:30:00',1.75),('15529','2013-11-16','10:35:00',1.76),('15529','2013-11-16','10:40:00',1.77),('15529','2013-11-16','10:45:00',1.79),('15529','2013-11-16','10:50:00',1.79),('15529','2013-11-16','10:55:00',1.81),('15529','2013-11-16','11:00:00',1.82),('15529','2013-11-16','11:05:00',1.81),('15529','2013-11-16','11:10:00',1.82),('15529','2013-11-16','11:15:00',1.83),('15529','2013-11-16','11:20:00',1.84),('15529','2013-11-16','11:25:00',1.83),('15529','2013-11-16','11:30:00',1.83),('15529','2013-11-16','11:35:00',1.84),('15529','2013-11-16','11:40:00',1.84),('15529','2013-11-16','11:45:00',1.83),('15529','2013-11-16','11:50:00',1.83),('15529','2013-11-16','11:55:00',1.83),('15529','2013-11-16','12:00:00',1.82),('15529','2013-11-16','12:05:00',1.82),('15529','2013-11-16','12:10:00',1.79),('15529','2013-11-16','12:15:00',1.8),('15529','2013-11-16','12:20:00',1.81),('15529','2013-11-16','12:25:00',1.8),('15529','2013-11-16','12:30:00',1.78),('15529','2013-11-16','12:35:00',1.77),('15529','2013-11-16','12:40:00',1.77),('15529','2013-11-16','12:45:00',1.76),('15529','2013-11-16','12:50:00',1.76),('15529','2013-11-16','12:55:00',1.73),('15529','2013-11-16','13:00:00',1.7),('15529','2013-11-16','13:05:00',1.69),('15529','2013-11-16','13:10:00',1.69),('15529','2013-11-16','13:15:00',1.67),('15529','2013-11-16','13:20:00',1.65),('15529','2013-11-16','13:25:00',1.64),('15529','2013-11-16','14:05:00',1.05),('15529','2013-11-16','14:10:00',1.27),('15529','2013-11-16','14:15:00',1.17),('15529','2013-11-16','14:20:00',1.34),('15529','2013-11-16','14:25:00',1.29),('15529','2013-11-16','14:30:00',1.23),('15529','2013-11-16','14:35:00',1.17),('15529','2013-11-13','08:55:00',1.18),('15529','2013-11-13','09:00:00',1.28),('15529','2013-11-13','09:05:00',1.35),('15529','2013-11-13','09:10:00',1.34),('15529','2013-11-13','09:15:00',1.28),('15529','2013-11-13','09:20:00',1.33),('15529','2013-11-13','09:25:00',1.4),('15529','2013-11-13','09:30:00',1.43),('15529','2013-11-13','09:35:00',1.46),('15529','2013-11-13','09:40:00',1.47),('15529','2013-11-13','09:45:00',1.49),('15529','2013-11-13','09:50:00',1.53),('15529','2013-11-13','09:55:00',1.59),('15529','2013-11-13','10:00:00',1.6),('15529','2013-11-13','10:05:00',1.33),('15529','2013-11-13','10:10:00',1.62),('15529','2013-11-13','10:15:00',1.67),('15529','2013-11-13','10:20:00',1.67),('15529','2013-11-13','10:25:00',1.65),('15529','2013-11-13','10:30:00',1.69),('15529','2013-11-13','10:35:00',1.61),('15529','2013-11-13','10:40:00',1.63),('15529','2013-11-13','10:45:00',1.7),('15529','2013-11-13','10:50:00',1.7),('15529','2013-11-13','10:55:00',1.73),('15529','2013-11-13','11:00:00',1.78),('15529','2013-11-13','11:05:00',1.82),('15529','2013-11-13','11:10:00',1.84),('15529','2013-11-13','11:15:00',1.88),('15529','2013-11-13','11:20:00',1.89),('15529','2013-11-13','11:25:00',1.9),('15529','2013-11-13','11:30:00',1.9),('15529','2013-11-13','11:35:00',1.67),('15529','2013-11-13','11:40:00',1.64),('15529','2013-11-13','11:45:00',1.26),('15529','2013-11-13','11:50:00',1.12),('15529','2013-11-13','11:55:00',1.33),('15529','2013-11-13','12:00:00',2.28),('15529','2013-11-13','12:05:00',2.32),('15529','2013-11-13','12:10:00',1.35),('15529','2013-11-13','13:55:00',1.27),('15529','2013-11-13','14:05:00',1.09),('15529','2013-11-12','10:05:00',1.01),('15529','2013-11-12','14:00:00',1.28),('15529','2013-11-12','14:05:00',1.15),('15529','2013-11-12','14:10:00',1.2),('15529','2013-11-12','14:15:00',1.04),('15529','2013-11-12','14:20:00',1),('15529','2013-11-12','14:30:00',1.07),('15529','2013-11-11','11:40:00',1.47),('15529','2013-11-11','11:50:00',1.42),('15529','2013-11-11','12:00:00',1.2),('15529','2013-11-11','12:05:00',1.25),('15529','2013-11-11','12:30:00',2.33),('15529','2013-11-11','12:35:00',1.97),('15529','2013-11-11','12:40:00',1.32),('15529','2013-11-11','12:45:00',1.15),('15529','2013-11-11','12:55:00',1.43),('15529','2013-11-11','13:00:00',1.38),('15529','2013-11-11','13:05:00',1.01),('15529','2013-11-11','13:10:00',1.34),('15529','2013-11-11','13:15:00',1.29),('15529','2013-11-11','13:40:00',1),('15529','2013-11-11','13:45:00',1.21),('15529','2013-11-11','13:50:00',1.34),('15529','2013-11-11','13:55:00',1.28),('15529','2013-11-11','14:00:00',1.45),('15529','2013-11-11','14:05:00',1.25),('15529','2013-11-11','14:10:00',1.89),('15529','2013-11-11','14:15:00',1.82),('15529','2013-11-11','14:20:00',1.22),('15529','2013-11-11','14:35:00',1.42),('15529','2013-11-11','14:40:00',1.35),('15529','2013-11-11','14:45:00',1.16),('15529','2013-11-10','11:05:00',1.4),('15529','2013-11-10','11:10:00',1.26),('15529','2013-11-10','11:15:00',2.39),('15529','2013-11-10','11:20:00',1.81),('15529','2013-11-10','11:35:00',1.79),('15529','2013-11-10','11:40:00',1.81),('15529','2013-11-10','11:45:00',1.69),('15529','2013-11-10','11:50:00',2.19),('15529','2013-11-10','11:55:00',2.44),('15529','2013-11-10','12:00:00',2.24),('15529','2013-11-10','12:05:00',1.94),('15529','2013-11-10','12:10:00',2.07),('15529','2013-11-10','12:15:00',2.04),('15529','2013-11-10','12:20:00',2.05),('15529','2013-11-10','12:25:00',2.06),('15529','2013-11-10','12:30:00',1.47),('15529','2013-11-10','12:35:00',1.23),('15529','2013-11-10','12:45:00',1.21),('15529','2013-11-10','12:50:00',1.14),('15529','2013-11-10','13:00:00',1.29),('15529','2013-11-10','13:05:00',1.49),('15529','2013-11-10','14:00:00',1.58),('15529','2013-11-10','14:05:00',1.91),('15529','2013-11-10','14:25:00',1.68),('15529','2013-11-10','14:30:00',1.39),('15529','2013-11-10','14:35:00',1.23),('15529','2013-11-10','14:40:00',1.31),('15529','2013-11-09','09:00:00',1.05),('15529','2013-11-09','09:15:00',1.1),('15529','2013-11-09','09:20:00',1.34),('15529','2013-11-09','09:25:00',1.44),('15529','2013-11-09','09:30:00',1.3),('15529','2013-11-09','09:35:00',1.31),('15529','2013-11-09','09:40:00',1.45),('15529','2013-11-09','09:45:00',1.52),('15529','2013-11-09','09:50:00',1.65),('15529','2013-11-09','09:55:00',1.53),('15529','2013-11-09','10:00:00',1.53),('15529','2013-11-09','10:05:00',1.59),('15529','2013-11-09','10:10:00',1.78),('15529','2013-11-09','10:15:00',1.68),('15529','2013-11-09','10:20:00',1.6),('15529','2013-11-09','10:25:00',1.83),('15529','2013-11-09','10:30:00',1.75),('15529','2013-11-09','10:35:00',1.88),('15529','2013-11-09','10:40:00',1.7),('15529','2013-11-09','10:45:00',1.6),('15529','2013-11-09','10:50:00',1.6),('15529','2013-11-09','10:55:00',2.11),('15529','2013-11-09','11:00:00',1.32),('15529','2013-11-09','11:35:00',1.24),('15529','2013-11-09','11:40:00',1.22),('15529','2013-11-09','11:45:00',1.08),('15529','2013-11-09','12:10:00',2.03),('15529','2013-11-09','12:15:00',2.01),('15529','2013-11-09','12:20:00',2.04),('15529','2013-11-09','12:25:00',1.84),('15529','2013-11-09','12:30:00',1.08),('15529','2013-11-09','12:35:00',1.9),('15529','2013-11-09','12:40:00',1.74),('15529','2013-11-09','12:45:00',1.83),('15529','2013-11-09','12:50:00',1.15),('15529','2013-11-09','13:50:00',1.49),('15529','2013-11-08','09:40:00',1.75),('15529','2013-11-08','09:45:00',1.9),('15529','2013-11-08','09:50:00',1.92),('15529','2013-11-08','09:55:00',1.74),('15529','2013-11-08','10:00:00',1.78),('15529','2013-11-08','10:05:00',1.48),('15529','2013-11-08','10:10:00',1.25),('15529','2013-11-08','10:15:00',1.44),('15529','2013-11-08','10:40:00',1.23),('15529','2013-11-08','11:10:00',1.05),('15529','2013-11-08','11:15:00',1.22),('15529','2013-11-08','11:20:00',1.34),('15529','2013-11-08','11:25:00',1.74),('15529','2013-11-08','11:30:00',1.39),('15529','2013-11-08','11:55:00',1.06),('15529','2013-11-08','12:00:00',2.09),('15529','2013-11-08','12:05:00',2.07),('15529','2013-11-08','12:15:00',1.16),('15529','2013-11-08','12:30:00',1.05),('15529','2013-11-08','12:35:00',1.79),('15529','2013-11-08','12:40:00',1.35),('15529','2013-11-08','12:45:00',1.67),('15529','2013-11-08','12:55:00',1.32),('15529','2013-11-08','13:05:00',1.1),('15529','2013-11-08','13:10:00',2.01),('15529','2013-11-08','13:15:00',1.52),('15529','2013-11-08','13:25:00',1.8),('15529','2013-11-08','13:30:00',1.73),('15529','2013-11-08','13:35:00',1.74),('15529','2013-11-08','13:40:00',1.67),('15529','2013-11-08','13:45:00',1.64),('15529','2013-11-08','13:50:00',1.64),('15529','2013-11-08','13:55:00',1.61),('15529','2013-11-08','14:00:00',1.47),('15529','2013-11-08','14:05:00',1.21),('15529','2013-11-08','14:15:00',1.24),('15529','2013-11-08','14:20:00',1.25),('15529','2013-11-08','14:35:00',1.12),('15529','2013-11-08','14:40:00',1.15),('15529','2013-11-07','09:15:00',1.09),('15529','2013-11-07','09:25:00',1.68),('15529','2013-11-07','09:30:00',1.44),('15529','2013-11-07','09:35:00',1.02),('15529','2013-11-07','09:40:00',1.12),('15529','2013-11-07','09:45:00',1.55),('15529','2013-11-07','09:50:00',1.64),('15529','2013-11-07','09:55:00',1.31),('15529','2013-11-07','10:00:00',1.64),('15529','2013-11-07','10:05:00',1.43),('15529','2013-11-07','10:15:00',1.05),('15529','2013-11-07','10:20:00',1.06),('15529','2013-11-07','10:25:00',1.31),('15529','2013-11-07','10:30:00',1.29),('15529','2013-11-07','10:35:00',1.83),('15529','2013-11-07','10:40:00',1.29),('15529','2013-11-07','10:45:00',1.28),('15529','2013-11-07','10:50:00',1.62),('15529','2013-11-07','11:10:00',1.14),('15529','2013-11-07','11:15:00',2),('15529','2013-11-07','11:20:00',1.51),('15529','2013-11-07','11:35:00',1.59),('15529','2013-11-07','11:40:00',2.11),('15529','2013-11-07','11:45:00',2.03),('15529','2013-11-07','11:50:00',1.56),('15529','2013-11-07','11:55:00',1.56),('15529','2013-11-07','12:10:00',1.97),('15529','2013-11-07','12:15:00',1.84),('15529','2013-11-07','12:40:00',2),('15529','2013-11-07','12:45:00',2.02),('15529','2013-11-07','12:50:00',1.95),('15529','2013-11-07','12:55:00',2),('15529','2013-11-07','13:00:00',2.03),('15529','2013-11-07','13:05:00',1.95),('15529','2013-11-07','13:10:00',1.88),('15529','2013-11-07','13:15:00',1.85),('15529','2013-11-07','13:25:00',1.83),('15529','2013-11-07','13:30:00',1.38),('15529','2013-11-07','13:35:00',1.5),('15529','2013-11-07','13:40:00',1.67),('15529','2013-11-07','13:45:00',1.74),('15529','2013-11-07','13:50:00',1.74),('15529','2013-11-07','13:55:00',1.52),('15529','2013-11-07','14:10:00',1.12),('15529','2013-11-07','14:15:00',1.52),('15529','2013-11-07','14:20:00',1.4),('15529','2013-11-07','14:30:00',1.45),('15529','2013-11-07','14:35:00',1.02),('15529','2013-11-07','14:40:00',1.21),('15529','2014-04-17','09:05:00',1.04),('15529','2014-04-17','09:10:00',1.67),('15529','2014-04-17','09:15:00',1.59),('15529','2014-04-17','09:20:00',1.52),('15529','2014-04-17','09:30:00',1.46),('15529','2014-04-17','09:45:00',1.38),('15529','2014-04-17','09:50:00',1.39),('15529','2014-04-17','09:55:00',1.71),('15529','2014-04-17','10:00:00',1.18),('15529','2014-04-17','10:45:00',1.37),('15529','2014-04-17','10:50:00',1.59),('15529','2014-04-17','10:55:00',1.95),('15529','2014-04-17','11:00:00',1.02),('15529','2014-04-17','11:15:00',1.46),('15529','2014-04-17','11:20:00',1.11),('15529','2014-04-17','11:50:00',1.11),('15529','2014-04-17','11:55:00',1.02),('15529','2014-04-17','12:00:00',1.28),('15529','2014-04-17','12:05:00',1.4),('15529','2014-04-17','12:10:00',1.52),('15529','2014-04-17','12:15:00',2.01),('15529','2014-04-17','12:20:00',1.98),('15529','2014-04-17','12:25:00',1.71),('15529','2014-04-17','12:30:00',2.46),('15529','2014-04-17','12:35:00',2.52),('15529','2014-04-17','12:40:00',2.38),('15529','2014-04-17','12:45:00',2.06),('15529','2014-04-17','12:50:00',2.08),('15529','2014-04-17','12:55:00',2.03),('15529','2014-04-17','13:00:00',1.97),('15529','2014-04-17','13:05:00',2.08),('15529','2014-04-17','13:10:00',2.62),('15529','2014-04-17','13:15:00',1.93),('15529','2014-04-17','13:20:00',1.33),('15529','2014-04-17','13:55:00',1.06),('15529','2014-04-17','14:00:00',1.09),('15529','2014-04-17','14:25:00',1.04),('15529','2014-04-17','14:30:00',1.15),('15529','2014-04-17','14:35:00',1.38),('15529','2014-04-17','14:40:00',1.23),('15529','2014-04-17','14:45:00',1.43),('15529','2014-04-17','14:50:00',1.9),('15529','2014-04-17','14:55:00',2.23),('15529','2014-04-17','15:00:00',2.08),('15529','2014-04-17','15:05:00',2.14),('15529','2014-04-17','15:15:00',1),('15529','2014-04-17','15:20:00',1.17),('15529','2014-04-17','15:25:00',2.01),('15529','2014-04-17','15:30:00',1.59),('15529','2014-04-17','15:35:00',2.3),('15529','2014-04-17','15:40:00',1.78),('15529','2014-04-17','15:45:00',1.17),('15529','2014-04-17','15:50:00',1.78),('15529','2014-04-17','15:55:00',2.22),('15529','2014-04-17','16:00:00',1.78),('15529','2014-04-17','16:05:00',1.58),('15529','2014-04-17','16:25:00',1.48),('15529','2014-04-17','16:30:00',1.13),('15529','2014-04-17','16:35:00',1.79),('15529','2014-04-17','16:40:00',1.58),('15529','2014-04-17','16:45:00',1.5),('15529','2014-04-17','16:50:00',1.44),('15529','2014-04-17','16:55:00',1.59),('15529','2014-04-17','17:00:00',1.16),('15529','2014-04-17','17:05:00',1.36),('15529','2014-04-17','17:25:00',1.08),('15529','2013-11-06','08:25:00',1.01),('15529','2013-11-06','08:30:00',1.06),('15529','2013-11-06','08:35:00',1.1),('15529','2013-11-06','08:40:00',1.15),('15529','2013-11-06','08:45:00',1.19),('15529','2013-11-06','08:50:00',1.23),('15529','2013-11-06','08:55:00',1.27),('15529','2013-11-06','09:00:00',1.3),('15529','2013-11-06','09:05:00',1.34),('15529','2013-11-06','09:10:00',1.37),('15529','2013-11-06','09:15:00',1.4),('15529','2013-11-06','09:20:00',1.42),('15529','2013-11-06','09:25:00',1.46),('15529','2013-11-06','09:30:00',1.49),('15529','2013-11-06','09:35:00',1.52),('15529','2013-11-06','09:40:00',1.53),('15529','2013-11-06','09:45:00',1.54),('15529','2013-11-06','09:50:00',1.54),('15529','2013-11-06','09:55:00',1.59),('15529','2013-11-06','10:00:00',1.61),('15529','2013-11-06','10:05:00',1.62),('15529','2013-11-06','10:10:00',1.63),('15529','2013-11-06','10:15:00',1.65),('15529','2013-11-06','10:20:00',1.67),('15529','2013-11-06','10:25:00',1.71),('15529','2013-11-06','10:30:00',1.73),('15529','2013-11-06','10:35:00',1.73),('15529','2013-11-06','10:40:00',1.74),('15529','2013-11-06','10:45:00',1.75),('15529','2013-11-06','10:50:00',1.75),('15529','2013-11-06','10:55:00',1.76),('15529','2013-11-06','11:00:00',1.76),('15529','2013-11-06','11:05:00',1.77),('15529','2013-11-06','11:10:00',1.79),('15529','2013-11-06','11:15:00',1.79),('15529','2013-11-06','11:20:00',1.79),('15529','2013-11-06','11:25:00',1.78),('15529','2013-11-06','11:30:00',1.79),('15529','2013-11-06','11:35:00',1.8),('15529','2013-11-06','11:40:00',1.8),('15529','2013-11-06','11:45:00',1.81),('15529','2013-11-06','11:50:00',1.81),('15529','2013-11-06','11:55:00',1.8),('15529','2013-11-06','12:00:00',1.77),('15529','2013-11-06','12:05:00',1.78),('15529','2013-11-06','12:10:00',1.78),('15529','2013-11-06','12:15:00',1.82),('15529','2013-11-06','12:20:00',1.85),('15529','2013-11-06','12:25:00',1.38),('15529','2013-11-06','12:35:00',1.03),('15529','2013-11-06','12:40:00',1.42),('15529','2013-11-06','12:45:00',1.3),('15529','2013-11-06','13:05:00',2.09),('15529','2013-11-06','13:10:00',1.61),('15529','2013-11-06','13:15:00',1.94),('15529','2013-11-06','13:20:00',1.53),('15529','2013-11-06','13:25:00',1.86),('15529','2013-11-06','13:30:00',1.86),('15529','2013-11-06','13:35:00',1.76),('15529','2013-11-06','13:40:00',1.65),('15529','2013-11-06','13:45:00',1.62),('15529','2013-11-06','13:50:00',1.54),('15529','2013-11-06','14:00:00',1.6),('15529','2013-11-06','14:05:00',1.74),('15529','2013-11-06','14:20:00',1.51),('15529','2013-11-06','14:25:00',1.4),('15529','2013-11-06','14:30:00',1.37),('15529','2013-11-06','14:35:00',1.3),('15529','2013-11-06','14:40:00',1.26),('15529','2013-11-06','14:45:00',1.21),('15529','2013-11-06','14:50:00',1.19),('15529','2013-11-06','14:55:00',1.15),('15529','2013-11-06','15:00:00',1.1),('15529','2013-11-06','15:05:00',1.05),('15529','2013-11-05','08:15:00',1.01),('15529','2013-11-05','08:35:00',1.18),('15529','2013-11-05','08:40:00',1.21),('15529','2013-11-05','08:45:00',1.25),('15529','2013-11-05','08:50:00',1.32),('15529','2013-11-05','08:55:00',1.14),('15529','2013-11-05','09:05:00',1.03),('15529','2013-11-05','09:10:00',1.15),('15529','2013-11-05','09:15:00',1.22),('15529','2013-11-05','09:20:00',1.43),('15529','2013-11-05','09:25:00',1.5),('15529','2013-11-05','09:30:00',1.54),('15529','2013-11-05','09:35:00',1.57),('15529','2013-11-05','09:40:00',1.59),('15529','2013-11-05','09:45:00',1.6),('15529','2013-11-05','09:50:00',1.62),('15529','2013-11-05','09:55:00',1.65),('15529','2013-11-05','10:00:00',1.67),('15529','2013-11-05','10:05:00',1.71),('15529','2013-11-05','10:10:00',1.73),('15529','2013-11-05','10:15:00',1.75),('15529','2013-11-05','10:20:00',1.76),('15529','2013-11-05','10:25:00',1.78),('15529','2013-11-05','10:30:00',1.81),('15529','2013-11-05','10:35:00',1.81),('15529','2013-11-05','10:40:00',1.81),('15529','2013-11-05','10:45:00',1.85),('15529','2013-11-05','10:50:00',1.85),('15529','2013-11-05','10:55:00',1.87),('15529','2013-11-05','11:00:00',1.87),('15529','2013-11-05','11:05:00',1.88),('15529','2013-11-05','11:10:00',1.87),('15529','2013-11-05','11:15:00',1.91),('15529','2013-11-05','11:20:00',1.92),('15529','2013-11-05','11:25:00',1.94),('15529','2013-11-05','11:30:00',1.9),('15529','2013-11-05','11:35:00',1.92),('15529','2013-11-05','11:40:00',1.94),('15529','2013-11-05','11:45:00',1.94),('15529','2013-11-05','11:50:00',1.93),('15529','2013-11-05','11:55:00',1.91),('15529','2013-11-05','12:00:00',1.93),('15529','2013-11-05','12:05:00',1.91),('15529','2013-11-05','12:10:00',1.92),('15529','2013-11-05','12:15:00',1.91),('15529','2013-11-05','12:20:00',1.92),('15529','2013-11-05','12:25:00',1.92),('15529','2013-11-05','12:30:00',1.91),('15529','2013-11-05','12:35:00',1.89),('15529','2013-11-05','12:40:00',1.88),('15529','2013-11-05','12:45:00',1.85),('15529','2013-11-05','12:50:00',1.84),('15529','2013-11-05','12:55:00',1.83),('15529','2013-11-05','13:00:00',1.82),('15529','2013-11-05','13:05:00',1.81),('15529','2013-11-05','13:10:00',1.79),('15529','2013-11-05','13:15:00',1.77),('15529','2013-11-05','13:20:00',1.75),('15529','2013-11-05','13:25:00',1.73),('15529','2013-11-05','13:30:00',1.71),('15529','2013-11-05','13:35:00',1.68),('15529','2013-11-05','13:40:00',1.65),('15529','2013-11-05','13:45:00',1.63),('15529','2013-11-05','13:50:00',1.6),('15529','2013-11-05','13:55:00',1.57),('15529','2013-11-05','14:00:00',1.55),('15529','2013-11-05','14:05:00',1.54),('15529','2013-11-05','14:10:00',1.52),('15529','2013-11-05','14:15:00',1.48),('15529','2013-11-05','14:20:00',1.44),('15529','2013-11-05','14:25:00',1.41),('15529','2013-11-05','14:30:00',1.38),('15529','2013-11-05','14:35:00',1.33),('15529','2013-11-05','14:40:00',1.29),('15529','2013-11-05','14:45:00',1.25),('15529','2013-11-05','14:50:00',1.21),('15529','2013-11-05','14:55:00',1.17),('15529','2013-11-05','15:00:00',1.14),('15529','2013-11-05','15:05:00',1.08),('15529','2013-11-05','15:10:00',1.04),('15529','2013-11-04','08:35:00',1.21),('15529','2013-11-04','10:25:00',1.01),('15529','2013-11-04','12:25:00',1.13),('15529','2013-11-04','13:35:00',1.53),('15529','2013-11-04','13:40:00',1.53),('15529','2013-11-04','13:45:00',1.17),('15529','2013-11-04','13:50:00',1.34),('15529','2013-11-04','13:55:00',1.92),('15529','2013-11-04','14:00:00',1.19),('15529','2013-11-04','14:05:00',1.47),('15529','2013-11-04','14:25:00',1.22),('15529','2013-11-04','14:30:00',1.34),('15529','2013-11-03','09:05:00',1.37),('15529','2013-11-03','09:10:00',1.19),('15529','2013-11-03','09:55:00',1.74),('15529','2013-11-03','10:00:00',1.79),('15529','2013-11-03','10:05:00',1.83),('15529','2013-11-03','10:10:00',1.88),('15529','2013-11-03','10:15:00',1.88),('15529','2013-11-03','10:20:00',1.9),('15529','2013-11-03','10:25:00',2.15),('15529','2013-11-03','10:30:00',1.5),('15529','2013-11-03','10:35:00',1.04),('15529','2013-11-03','10:45:00',1.16),('15529','2013-11-03','11:30:00',1.17),('15529','2013-11-03','11:40:00',1.11),('15529','2013-11-03','11:45:00',1.15),('15529','2013-11-03','11:50:00',1.97),('15529','2013-11-03','11:55:00',2.18),('15529','2013-11-03','12:00:00',2.17),('15529','2013-11-03','12:05:00',1.76),('15529','2013-11-03','12:10:00',2.08),('15529','2013-11-03','12:15:00',2.05),('15529','2013-11-03','12:20:00',1.97),('15529','2013-11-03','12:25:00',1.87),('15529','2013-11-03','12:30:00',1.29),('15529','2013-11-03','12:35:00',1.76),('15529','2013-11-03','12:40:00',1.77),('15529','2013-11-03','12:45:00',1.99),('15529','2013-11-03','12:50:00',1.56),('15529','2013-11-03','12:55:00',1.93),('15529','2013-11-03','13:00:00',1.86),('15529','2013-11-03','13:05:00',1.91),('15529','2013-11-03','13:10:00',1.53),('15529','2013-11-03','13:15:00',1.79),('15529','2013-11-03','13:20:00',1.63),('15529','2013-11-03','13:25:00',1.35),('15529','2013-11-03','13:30:00',1.12),('15529','2013-11-03','13:35:00',1.43),('15529','2013-11-03','13:50:00',1.71),('15529','2013-11-03','14:00:00',1.68),('15529','2013-11-03','14:05:00',1.27),('15529','2013-11-03','14:10:00',1.2),('15529','2013-11-03','14:20:00',1.01),('15529','2013-11-03','14:25:00',1.66),('15529','2013-11-03','14:30:00',1.52),('15529','2013-11-03','14:35:00',1.28),('15529','2013-11-03','14:40:00',1.18),('15529','2013-11-03','14:45:00',1.2),('15529','2013-11-03','14:50:00',1.27),('15529','2013-11-03','14:55:00',1.16),('15529','2013-11-03','15:00:00',1.11),('15529','2013-11-03','15:05:00',1.2),('15529','2013-11-03','15:10:00',1.1),('15529','2013-11-03','15:15:00',1.03),('15529','2013-11-02','08:45:00',1.06),('15529','2013-11-02','09:35:00',1.13),('15529','2013-11-02','10:25:00',1.36),('15529','2013-11-02','10:30:00',1.72),('15529','2013-11-02','11:15:00',1.86),('15529','2013-11-02','11:20:00',1.85),('15529','2013-11-02','11:30:00',1.46),('15529','2013-11-02','11:35:00',1.84),('15529','2013-11-02','11:40:00',2.08),('15529','2013-11-02','11:45:00',1.43),('15529','2013-11-02','11:55:00',1.23),('15529','2013-11-02','12:00:00',2.38),('15529','2013-11-02','12:05:00',2.33),('15529','2013-11-02','12:10:00',2.3),('15529','2013-11-02','12:15:00',2.21),('15529','2013-11-02','12:20:00',2.04),('15529','2013-11-02','12:25:00',1.41),('15529','2013-11-02','14:10:00',1.42),('15529','2013-11-02','14:15:00',1.35),('15529','2013-11-02','14:20:00',1.48),('15529','2013-11-02','14:25:00',1.28),('15529','2013-11-02','14:40:00',1.11),('15529','2013-11-01','08:30:00',1),('15529','2013-11-01','08:35:00',1.04),('15529','2013-11-01','08:40:00',1.09),('15529','2013-11-01','08:45:00',1.13),('15529','2013-11-01','08:50:00',1.17),('15529','2013-11-01','08:55:00',1.22),('15529','2013-11-01','09:00:00',1.31),('15529','2013-11-01','09:05:00',1.4),('15529','2013-11-01','09:10:00',1.34),('15529','2013-11-01','09:20:00',1.16),('15529','2013-11-01','09:25:00',1.49),('15529','2013-11-01','09:30:00',1.35),('15529','2013-11-01','09:35:00',1.49),('15529','2013-11-01','09:40:00',1.48),('15529','2013-11-01','09:45:00',1.52),('15529','2013-11-01','10:05:00',1.31),('15529','2013-11-01','11:50:00',2.1),('15529','2013-11-01','11:55:00',1.91),('15529','2013-11-01','12:00:00',1.63),('15529','2013-11-01','12:05:00',1.72),('15529','2013-11-01','12:10:00',2.22),('15529','2013-11-01','12:15:00',2.13),('15529','2013-11-01','12:20:00',1.65),('15529','2013-11-01','12:25:00',1.38),('15529','2013-11-01','12:30:00',1.69),('15529','2013-11-01','12:35:00',2.08),('15529','2013-11-01','12:40:00',1.3),('15529','2013-11-01','12:45:00',1.9),('15529','2013-11-01','12:50:00',1.47),('15529','2013-11-01','13:10:00',1.22),('15529','2013-11-01','13:15:00',2.06),('15529','2013-11-01','13:20:00',1.2),('15529','2013-11-01','13:25:00',1.12),('15529','2013-11-01','13:30:00',1.25),('15529','2013-11-01','13:35:00',1.7),('15529','2013-11-01','13:40:00',2.1),('15529','2013-11-01','13:45:00',1.88),('15529','2013-11-01','13:50:00',1.93),('15529','2013-11-01','13:55:00',1.78),('15529','2013-11-01','14:00:00',1.68),('15529','2013-11-01','14:05:00',1.54),('15529','2013-11-01','14:10:00',1.53),('15529','2013-11-01','14:15:00',1.52),('15529','2013-11-01','14:20:00',1.49),('15529','2013-11-01','14:25:00',1.26),('15529','2013-11-01','14:30:00',1.46),('15529','2013-11-01','14:35:00',1.35),('15529','2013-11-01','14:40:00',1.29),('15529','2013-11-01','14:45:00',1.1),('15529','2013-11-01','15:00:00',1.21),('15529','2013-11-01','15:05:00',1.21),('15529','2013-10-31','08:35:00',1.03),('15529','2013-10-31','08:40:00',1.08),('15529','2013-10-31','08:50:00',1.07),('15529','2013-10-31','08:55:00',1.07),('15529','2013-10-31','09:00:00',1.21),('15529','2013-10-31','09:05:00',1.29),('15529','2013-10-31','09:10:00',1.32),('15529','2013-10-31','09:15:00',1.36),('15529','2013-10-31','09:20:00',1.4),('15529','2013-10-31','09:25:00',1.44),('15529','2013-10-31','09:30:00',1.46),('15529','2013-10-31','09:35:00',1.49),('15529','2013-10-31','09:40:00',1.52),('15529','2013-10-31','09:45:00',1.55),('15529','2013-10-31','09:50:00',1.59),('15529','2013-10-31','09:55:00',1.62),('15529','2013-10-31','10:00:00',1.64),('15529','2013-10-31','10:05:00',1.67),('15529','2013-10-31','10:10:00',1.69),('15529','2013-10-31','10:15:00',1.71),('15529','2013-10-31','10:20:00',1.73),('15529','2013-10-31','10:25:00',1.72),('15529','2013-10-31','10:30:00',1.71),('15529','2013-10-31','10:35:00',1.72),('15529','2013-10-31','10:40:00',1.72),('15529','2013-10-31','10:45:00',1.7),('15529','2013-10-31','10:50:00',1.69),('15529','2013-10-31','10:55:00',1.8),('15529','2013-10-31','11:00:00',1.76),('15529','2013-10-31','11:05:00',1.57),('15529','2013-10-31','11:10:00',1.51),('15529','2013-10-31','11:15:00',1.68),('15529','2013-10-31','11:20:00',1.85),('15529','2013-10-31','11:25:00',1.9),('15529','2013-10-31','11:30:00',1.86),('15529','2013-10-31','11:35:00',1.73),('15529','2013-10-31','11:40:00',1.83),('15529','2013-10-31','11:45:00',1.96),('15529','2013-10-31','11:50:00',1.96),('15529','2013-10-31','11:55:00',1.8),('15529','2013-10-31','12:00:00',1.87),('15529','2013-10-31','12:05:00',1.89),('15529','2013-10-31','12:10:00',1.75),('15529','2013-10-31','12:15:00',1.85),('15529','2013-10-31','12:20:00',1.82),('15529','2013-10-31','12:25:00',1.7),('15529','2013-10-31','12:30:00',1.1),('15529','2013-10-31','13:05:00',1.11),('15529','2013-10-30','08:35:00',1.03),('15529','2013-10-30','08:40:00',1.11),('15529','2013-10-30','08:45:00',1.16),('15529','2013-10-30','09:25:00',1.1),('15529','2013-10-30','09:30:00',1.25),('15529','2013-10-30','09:35:00',1.2),('15529','2013-10-30','09:40:00',1.12),('15529','2013-10-30','09:45:00',1.16),('15529','2013-10-30','09:50:00',1.28),('15529','2013-10-30','09:55:00',1.31),('15529','2013-10-30','10:00:00',1.34),('15529','2013-10-30','10:05:00',1.29),('15529','2013-10-30','10:10:00',1.33),('15529','2013-10-30','10:15:00',1.32),('15529','2013-10-30','10:20:00',1.24),('15529','2013-10-30','10:25:00',1.22),('15529','2013-10-30','10:30:00',1.19),('15529','2013-10-30','10:35:00',1.23),('15529','2013-10-30','10:40:00',1.34),('15529','2013-10-30','10:45:00',1.22),('15529','2013-10-30','10:50:00',1.13),('15529','2013-10-30','10:55:00',1.32),('15529','2013-10-30','11:00:00',1.33),('15529','2013-10-30','11:05:00',1.51),('15529','2013-10-30','11:10:00',1.28),('15529','2013-10-30','11:15:00',1.73),('15529','2013-10-30','11:20:00',1.68),('15529','2013-10-30','11:25:00',1.53),('15529','2013-10-30','11:30:00',1.57),('15529','2013-10-30','11:35:00',1.59),('15529','2013-10-30','11:40:00',1.75),('15529','2013-10-30','11:45:00',1.8),('15529','2013-10-30','11:50:00',1.79),('15529','2013-10-30','11:55:00',1.81),('15529','2013-10-30','12:00:00',1.83),('15529','2013-10-30','12:05:00',1.8),('15529','2013-10-30','12:10:00',1.76),('15529','2013-10-30','12:15:00',1.79),('15529','2013-10-30','12:20:00',1.76),('15529','2013-10-30','12:25:00',1.73),('15529','2013-10-30','12:30:00',1.68),('15529','2013-10-30','12:35:00',1.66),('15529','2013-10-30','12:40:00',1.7),('15529','2013-10-30','12:45:00',1.76),('15529','2013-10-30','12:50:00',1.8),('15529','2013-10-30','12:55:00',1.81),('15529','2013-10-30','13:00:00',1.79),('15529','2013-10-30','13:05:00',1.76),('15529','2013-10-30','13:10:00',1.73),('15529','2013-10-30','13:15:00',1.71),('15529','2013-10-30','13:20:00',1.65),('15529','2013-10-30','13:25:00',1.63),('15529','2013-10-30','13:30:00',1.63),('15529','2013-10-30','13:35:00',1.62),('15529','2013-10-30','13:40:00',1.55),('15529','2013-10-30','13:45:00',1.54),('15529','2013-10-30','13:50:00',1.5),('15529','2013-10-30','13:55:00',1.28),('15529','2013-10-30','14:00:00',1.36),('15529','2013-10-30','14:05:00',1.35),('15529','2013-10-30','14:10:00',1.26),('15529','2013-10-29','08:45:00',1.06),('15529','2013-10-29','08:50:00',1.06),('15529','2013-10-29','08:55:00',1.04),('15529','2013-10-29','09:00:00',1.13),('15529','2013-10-29','09:05:00',1.24),('15529','2013-10-29','09:10:00',1.25),('15529','2013-10-29','09:15:00',1.27),('15529','2013-10-29','09:20:00',1.32),('15529','2013-10-29','09:25:00',1.33),('15529','2013-10-29','09:30:00',1.4),('15529','2013-10-29','09:35:00',1.45),('15529','2013-10-29','09:40:00',1.47),('15529','2013-10-29','09:45:00',1.37),('15529','2013-10-29','09:50:00',1.39),('15529','2013-10-29','09:55:00',1.08),('15529','2013-10-29','10:20:00',1.14),('15529','2013-10-29','10:25:00',1.34),('15529','2013-10-29','10:40:00',1.13),('15529','2013-10-29','10:45:00',1.35),('15529','2013-10-29','10:50:00',1.62),('15529','2013-10-29','10:55:00',1.69),('15529','2013-10-29','11:00:00',1.74),('15529','2013-10-29','11:05:00',1.59),('15529','2013-10-29','11:10:00',1.36),('15529','2013-10-29','11:15:00',1.41),('15529','2013-10-29','11:35:00',1.04),('15529','2013-10-29','11:40:00',1.49),('15529','2013-10-29','11:45:00',1.09),('15529','2013-10-29','11:50:00',1.62),('15529','2013-10-29','11:55:00',1.58),('15529','2013-10-29','12:00:00',1.6),('15529','2013-10-29','12:05:00',1.55),('15529','2013-10-29','12:15:00',1.04),('15529','2013-10-29','12:20:00',1.01),('15529','2013-10-29','12:25:00',1.1),('15529','2013-10-29','12:35:00',1.01),('15529','2013-10-29','12:40:00',1.56),('15529','2013-10-29','12:45:00',1.78),('15529','2013-10-29','12:50:00',1.82),('15529','2013-10-29','12:55:00',1.96),('15529','2013-10-29','13:00:00',2.03),('15529','2013-10-29','13:05:00',1.94),('15529','2013-10-29','13:10:00',1.56),('15529','2013-10-29','13:15:00',1.29),('15529','2013-10-29','13:20:00',1.41),('15529','2013-10-29','13:25:00',1.93),('15529','2013-10-29','13:30:00',1.39),('15529','2013-10-29','13:40:00',1.04),('15529','2013-10-29','13:45:00',1.41),('15529','2013-10-29','14:25:00',1.22),('15529','2013-10-29','14:30:00',1.1),('15529','2013-10-29','14:40:00',1.18),('15529','2013-10-29','14:45:00',1.11),('15529','2013-10-29','14:50:00',1.13),('15529','2013-10-29','14:55:00',1.14),('15529','2013-10-29','15:00:00',1.08),('15529','2013-10-29','15:05:00',1),('15529','2013-10-28','08:45:00',1.09),('15529','2013-10-28','08:50:00',1.15),('15529','2013-10-28','08:55:00',1.19),('15529','2013-10-28','09:00:00',1.22),('15529','2013-10-28','09:05:00',1.27),('15529','2013-10-28','09:10:00',1.33),('15529','2013-10-28','09:15:00',1.35),('15529','2013-10-28','09:20:00',1.38),('15529','2013-10-28','09:25:00',1.42),('15529','2013-10-28','09:30:00',1.45),('15529','2013-10-28','09:35:00',1.48),('15529','2013-10-28','09:40:00',1.57),('15529','2013-10-28','09:45:00',1.52),('15529','2013-10-28','09:50:00',1),('15529','2013-10-28','09:55:00',1.64),('15529','2013-10-28','10:00:00',1.59),('15529','2013-10-28','10:05:00',1.56),('15529','2013-10-28','10:10:00',1.66),('15529','2013-10-28','10:15:00',1.23),('15529','2013-10-28','10:20:00',1.04),('15529','2013-10-28','10:25:00',1.09),('15529','2013-10-28','10:30:00',1.71),('15529','2013-10-28','10:35:00',1.27),('15529','2013-10-28','10:45:00',1.38),('15529','2013-10-28','10:50:00',1.36),('15529','2013-10-28','11:15:00',1.35),('15529','2013-10-28','11:20:00',1.95),('15529','2013-10-28','11:25:00',1.72),('15529','2013-10-28','11:30:00',1.51),('15529','2013-10-28','11:35:00',1.67),('15529','2013-10-28','11:40:00',1.76),('15529','2013-10-28','11:45:00',1.54),('15529','2013-10-28','11:55:00',1.95),('15529','2013-10-28','12:00:00',1.9),('15529','2013-10-28','12:05:00',1.88),('15529','2013-10-28','12:10:00',1.89),('15529','2013-10-28','12:15:00',1.87),('15529','2013-10-28','12:20:00',1.87),('15529','2013-10-28','12:25:00',1.83),('15529','2013-10-28','12:30:00',1.83),('15529','2013-10-28','12:35:00',1.78),('15529','2013-10-28','12:40:00',1.74),('15529','2013-10-28','12:45:00',1.79),('15529','2013-10-28','12:50:00',1.73),('15529','2013-10-28','12:55:00',1.75),('15529','2013-10-28','13:00:00',1.72),('15529','2013-10-28','13:05:00',1.74),('15529','2013-10-28','13:10:00',1.66),('15529','2013-10-28','13:15:00',1.69),('15529','2013-10-28','13:20:00',1.64),('15529','2013-10-28','13:25:00',1.5),('15529','2013-10-28','13:30:00',1.61),('15529','2013-10-28','13:35:00',1.61),('15529','2013-10-28','13:40:00',1.54),('15529','2013-10-28','13:45:00',1.55),('15529','2013-10-28','13:50:00',1.54),('15529','2013-10-28','13:55:00',1.45),('15529','2013-10-28','14:00:00',1.42),('15529','2013-10-28','14:05:00',1.39),('15529','2013-10-28','14:10:00',1.36),('15529','2013-10-28','14:15:00',1.35),('15529','2013-10-28','14:20:00',1.32),('15529','2013-10-28','14:25:00',1.26),('15529','2013-10-28','14:30:00',1.23),('15529','2013-10-28','14:35:00',1.2),('15529','2013-10-28','14:40:00',1.16),('15529','2013-10-28','14:45:00',1.1),('15529','2013-10-28','14:50:00',1.07),('15529','2013-10-28','14:55:00',1.05),('15529','2014-04-16','08:45:00',1.03),('15529','2014-04-16','08:50:00',1.09),('15529','2014-04-16','08:55:00',1.01),('15529','2014-04-16','09:00:00',1.14),('15529','2014-04-16','09:05:00',1.25),('15529','2014-04-16','09:10:00',1.3),('15529','2014-04-16','09:15:00',1.35),('15529','2014-04-16','09:20:00',1.4),('15529','2014-04-16','09:25:00',1.45),('15529','2014-04-16','09:30:00',1.49),('15529','2014-04-16','09:35:00',1.53),('15529','2014-04-16','09:40:00',1.57),('15529','2014-04-16','09:45:00',1.61),('15529','2014-04-16','09:50:00',1.67),('15529','2014-04-16','09:55:00',1.71),('15529','2014-04-16','10:00:00',1.77),('15529','2014-04-16','10:05:00',1.42),('15529','2014-04-16','10:10:00',1.28),('15529','2014-04-16','10:15:00',1.14),('15529','2014-04-16','10:20:00',1.86),('15529','2014-04-16','10:25:00',1.99),('15529','2014-04-16','10:30:00',2.01),('15529','2014-04-16','10:35:00',2.11),('15529','2014-04-16','10:40:00',1.91),('15529','2014-04-16','10:45:00',1.93),('15529','2014-04-16','10:50:00',1.41),('15529','2014-04-16','10:55:00',1.15),('15529','2014-04-16','11:00:00',1.81),('15529','2014-04-16','11:05:00',1.51),('15529','2014-04-16','11:10:00',1.7),('15529','2014-04-16','11:15:00',1.44),('15529','2014-04-16','11:20:00',1.63),('15529','2014-04-16','11:25:00',1.66),('15529','2014-04-16','11:30:00',1.27),('15529','2014-04-16','11:40:00',1.07),('15529','2014-04-16','11:45:00',2.11),('15529','2014-04-16','11:50:00',2.18),('15529','2014-04-16','11:55:00',1.98),('15529','2014-04-16','12:00:00',1.98),('15529','2014-04-16','12:05:00',1.35),('15529','2014-04-16','12:10:00',1.19),('15529','2014-04-16','12:15:00',1.12),('15529','2014-04-16','12:20:00',1.48),('15529','2014-04-16','12:25:00',1.91),('15529','2014-04-16','12:30:00',1.68),('15529','2014-04-16','12:35:00',2.14),('15529','2014-04-16','12:40:00',2.38),('15529','2014-04-16','12:45:00',2.36),('15529','2014-04-16','12:50:00',2.47),('15529','2014-04-16','12:55:00',2.46),('15529','2014-04-16','13:00:00',2.43),('15529','2014-04-16','13:05:00',2.46),('15529','2014-04-16','13:10:00',2.47),('15529','2014-04-16','13:15:00',2.51),('15529','2014-04-16','13:20:00',2.53),('15529','2014-04-16','13:25:00',2.61),('15529','2014-04-16','13:30:00',2.65),('15529','2014-04-16','13:35:00',1.61),('15529','2014-04-16','13:50:00',2.48),('15529','2014-04-16','13:55:00',1.84),('15529','2014-04-16','14:15:00',2.07),('15529','2014-04-16','14:35:00',2.04),('15529','2014-04-16','14:40:00',1.51),('15529','2014-04-16','15:35:00',1.12),('15529','2014-04-16','16:45:00',1.2),('15529','2014-04-16','16:50:00',1.17),('15529','2013-10-27','08:50:00',1.16),('15529','2013-10-27','08:55:00',1.2),('15529','2013-10-27','09:00:00',1.28),('15529','2013-10-27','09:05:00',1.34),('15529','2013-10-27','09:10:00',1.32),('15529','2013-10-27','09:15:00',1.3),('15529','2013-10-27','09:20:00',1.49),('15529','2013-10-27','09:25:00',1.29),('15529','2013-10-27','09:30:00',1.2),('15529','2013-10-27','10:45:00',1.52),('15529','2013-10-27','10:50:00',1.9),('15529','2013-10-27','10:55:00',1.88),('15529','2013-10-27','11:00:00',1.87),('15529','2013-10-27','11:05:00',1.89),('15529','2013-10-27','11:10:00',1.86),('15529','2013-10-27','11:15:00',1.9),('15529','2013-10-27','11:20:00',1.9),('15529','2013-10-27','11:25:00',1.9),('15529','2013-10-27','11:30:00',1.9),('15529','2013-10-27','11:35:00',1.91),('15529','2013-10-27','11:40:00',1.9),('15529','2013-10-27','11:45:00',1.88),('15529','2013-10-27','11:50:00',1.85),('15529','2013-10-27','11:55:00',1.9),('15529','2013-10-27','12:00:00',1.85),('15529','2013-10-27','12:05:00',1.97),('15529','2013-10-27','12:10:00',1.93),('15529','2013-10-27','12:15:00',1.62),('15529','2013-10-27','12:20:00',1.85),('15529','2013-10-27','12:25:00',2.11),('15529','2013-10-27','12:30:00',2.03),('15529','2013-10-27','12:35:00',1.9),('15529','2013-10-27','12:40:00',1.97),('15529','2013-10-27','12:45:00',1.89),('15529','2013-10-27','12:50:00',1.86),('15529','2013-10-27','12:55:00',1.83),('15529','2013-10-27','13:00:00',1.83),('15529','2013-10-27','13:05:00',1.8),('15529','2013-10-27','13:10:00',1.79),('15529','2013-10-27','13:15:00',1.8),('15529','2013-10-27','13:20:00',1.77),('15529','2013-10-27','13:25:00',1.73),('15529','2013-10-27','13:30:00',1.64),('15529','2013-10-27','13:35:00',1.57),('15529','2013-10-27','13:40:00',1.28),('15529','2013-10-27','13:45:00',1.65),('15529','2013-10-27','13:50:00',1.71),('15529','2013-10-27','13:55:00',1.67),('15529','2013-10-27','14:00:00',1.65),('15529','2013-10-27','14:05:00',1.56),('15529','2013-10-27','14:10:00',1.51),('15529','2013-10-27','14:15:00',1.53),('15529','2013-10-27','14:20:00',1.06),('15529','2013-10-27','14:25:00',1.08),('15529','2013-10-27','14:30:00',1.28),('15529','2013-10-27','14:35:00',1.37),('15529','2013-10-27','14:40:00',1.36),('15529','2013-10-27','14:45:00',1.24),('15529','2013-10-27','14:50:00',1.19),('15529','2013-10-27','14:55:00',1.21),('15529','2013-10-27','15:00:00',1.13),('15529','2013-10-27','15:05:00',1.07),('15529','2013-10-27','15:10:00',1.04),('15529','2013-10-26','11:30:00',1.01),('15529','2013-10-26','11:35:00',1.37),('15529','2013-10-26','11:40:00',1.41),('15529','2013-10-26','12:10:00',1.42),('15529','2013-10-26','12:15:00',1.75),('15529','2013-10-26','12:20:00',1.03),('15529','2013-10-26','12:25:00',1.33),('15529','2013-10-26','12:30:00',1.89),('15529','2013-10-26','12:35:00',1.26),('15529','2013-10-26','12:45:00',1.15),('15529','2013-10-26','13:15:00',1.03),('15529','2013-10-26','13:20:00',1.71),('15529','2013-10-26','13:25:00',1.5),('15529','2013-10-26','13:30:00',1.09),('15529','2013-10-26','14:10:00',1.08),('15529','2013-10-26','14:15:00',1.03),('15529','2013-10-26','14:20:00',1.57),('15529','2013-10-26','14:25:00',1.48),('15529','2013-10-26','14:40:00',1.14),('15529','2013-10-26','14:45:00',1.31),('15529','2013-10-26','14:50:00',1.25),('15529','2013-10-26','14:55:00',1.18),('15529','2013-10-26','15:00:00',1.1),('15529','2013-10-25','09:30:00',1.02),('15529','2013-10-25','09:35:00',1.05),('15529','2013-10-25','09:40:00',1.1),('15529','2013-10-25','09:45:00',1.14),('15529','2013-10-25','09:50:00',1.19),('15529','2013-10-25','09:55:00',1.22),('15529','2013-10-25','10:00:00',1.26),('15529','2013-10-25','10:05:00',1.29),('15529','2013-10-25','10:10:00',1.33),('15529','2013-10-25','10:15:00',1.37),('15529','2013-10-25','10:20:00',1.38),('15529','2013-10-25','10:25:00',1.42),('15529','2013-10-25','10:30:00',1.45),('15529','2013-10-25','10:35:00',1.47),('15529','2013-10-25','10:40:00',1.5),('15529','2013-10-25','10:45:00',1.53),('15529','2013-10-25','10:50:00',1.57),('15529','2013-10-25','10:55:00',1.59),('15529','2013-10-25','11:00:00',1.62),('15529','2013-10-25','11:05:00',1.65),('15529','2013-10-25','11:10:00',1.69),('15529','2013-10-25','11:15:00',1.69),('15529','2013-10-25','11:20:00',1.71),('15529','2013-10-25','11:25:00',1.7),('15529','2013-10-25','11:30:00',1.74),('15529','2013-10-25','11:35:00',1.78),('15529','2013-10-25','11:40:00',1.78),('15529','2013-10-25','11:45:00',1.78),('15529','2013-10-25','11:50:00',1.79),('15529','2013-10-25','11:55:00',1.8),('15529','2013-10-25','12:00:00',1.8),('15529','2013-10-25','12:05:00',1.81),('15529','2013-10-25','12:10:00',1.82),('15529','2013-10-25','12:15:00',1.81),('15529','2013-10-25','12:20:00',1.84),('15529','2013-10-25','12:25:00',1.8),('15529','2013-10-25','12:30:00',1.8),('15529','2013-10-25','12:35:00',1.86),('15529','2013-10-25','12:40:00',1.86),('15529','2013-10-25','12:45:00',1.84),('15529','2013-10-25','12:50:00',1.85),('15529','2013-10-25','12:55:00',1.05),('15529','2013-10-25','13:00:00',1.66),('15529','2013-10-25','13:05:00',1.89),('15529','2013-10-25','13:10:00',1.84),('15529','2013-10-25','13:15:00',1.82),('15529','2013-10-25','13:20:00',1.77),('15529','2013-10-25','13:25:00',1.83),('15529','2013-10-25','13:30:00',1.76),('15529','2013-10-25','13:35:00',1.71),('15529','2013-10-25','13:40:00',1.7),('15529','2013-10-25','13:45:00',1.65),('15529','2013-10-25','13:50:00',1.72),('15529','2013-10-25','13:55:00',1.57),('15529','2013-10-25','14:00:00',1.39),('15529','2013-10-25','14:05:00',1.44),('15529','2013-10-25','14:10:00',1.04),('15529','2013-10-25','14:15:00',1.12),('15529','2013-10-25','14:20:00',1.32),('15529','2013-10-25','14:25:00',1.22),('15529','2013-10-25','14:30:00',1.41),('15529','2013-10-25','14:45:00',1.25),('15529','2013-10-25','14:50:00',1.43),('15529','2013-10-25','14:55:00',1.43),('15529','2013-10-25','15:00:00',1.43),('15529','2013-10-25','15:05:00',1.39),('15529','2013-10-25','15:10:00',1.31),('15529','2013-10-25','15:15:00',1.29),('15529','2013-10-25','15:20:00',1.3),('15529','2013-10-25','15:25:00',1.26),('15529','2013-10-25','15:30:00',1.15),('15529','2013-10-25','15:35:00',1.14),('15529','2013-10-25','15:40:00',1.09),('15529','2013-10-25','15:45:00',1.01),('15529','2013-10-25','15:50:00',1.05),('15529','2013-10-25','15:55:00',1.02),('15529','2013-10-24','09:30:00',1.04),('15529','2013-10-24','09:35:00',1.08),('15529','2013-10-24','09:40:00',1.12),('15529','2013-10-24','09:45:00',1.15),('15529','2013-10-24','09:50:00',1.18),('15529','2013-10-24','09:55:00',1.22),('15529','2013-10-24','10:00:00',1.26),('15529','2013-10-24','10:05:00',1.3),('15529','2013-10-24','10:10:00',1.34),('15529','2013-10-24','10:15:00',1.38),('15529','2013-10-24','10:20:00',1.41),('15529','2013-10-24','10:25:00',1.46),('15529','2013-10-24','10:30:00',1.48),('15529','2013-10-24','10:35:00',1.5),('15529','2013-10-24','10:40:00',1.54),('15529','2013-10-24','10:45:00',1.55),('15529','2013-10-24','10:50:00',1.59),('15529','2013-10-24','10:55:00',1.62),('15529','2013-10-24','11:00:00',1.64),('15529','2013-10-24','11:05:00',1.67),('15529','2013-10-24','11:10:00',1.72),('15529','2013-10-24','11:15:00',1.73),('15529','2013-10-24','11:20:00',1.75),('15529','2013-10-24','11:25:00',1.74),('15529','2013-10-24','11:30:00',1.76),('15529','2013-10-24','11:35:00',1.8),('15529','2013-10-24','11:40:00',1.79),('15529','2013-10-24','11:45:00',1.82),('15529','2013-10-24','11:50:00',1.83),('15529','2013-10-24','11:55:00',1.86),('15529','2013-10-24','12:00:00',1.86),('15529','2013-10-24','12:05:00',1.89),('15529','2013-10-24','12:10:00',1.89),('15529','2013-10-24','12:15:00',1.9),('15529','2013-10-24','12:20:00',1.89),('15529','2013-10-24','12:25:00',1.89),('15529','2013-10-24','12:30:00',1.9),('15529','2013-10-24','12:35:00',1.91),('15529','2013-10-24','12:40:00',1.9),('15529','2013-10-24','12:45:00',1.91),('15529','2013-10-24','12:50:00',1.89),('15529','2013-10-24','12:55:00',1.89),('15529','2013-10-24','13:00:00',1.86),('15529','2013-10-24','13:05:00',1.86),('15529','2013-10-24','13:10:00',1.87),('15529','2013-10-24','13:15:00',1.86),('15529','2013-10-24','13:20:00',1.88),('15529','2013-10-24','13:25:00',1.89),('15529','2013-10-24','13:30:00',1.88),('15529','2013-10-24','13:35:00',1.86),('15529','2013-10-24','13:40:00',1.82),('15529','2013-10-24','13:45:00',1.81),('15529','2013-10-24','13:50:00',1.81),('15529','2013-10-24','13:55:00',1.81),('15529','2013-10-24','14:00:00',1.79),('15529','2013-10-24','14:05:00',1.77),('15529','2013-10-24','14:10:00',1.74),('15529','2013-10-24','14:15:00',1.74),('15529','2013-10-24','14:20:00',1.7),('15529','2013-10-24','14:25:00',1.7),('15529','2013-10-24','14:30:00',1.68),('15529','2013-10-24','14:35:00',1.64),('15529','2013-10-24','14:40:00',1.62),('15529','2013-10-24','14:45:00',1.62),('15529','2013-10-24','14:50:00',1.58),('15529','2013-10-24','14:55:00',1.55),('15529','2013-10-24','15:00:00',1.5),('15529','2013-10-24','15:05:00',1.47),('15529','2013-10-24','15:10:00',1.44),('15529','2013-10-24','15:15:00',1.4),('15529','2013-10-24','15:20:00',1.32),('15529','2013-10-24','15:25:00',1.31),('15529','2013-10-24','15:30:00',1.3),('15529','2013-10-24','15:35:00',1.27),('15529','2013-10-24','15:40:00',1.24),('15529','2013-10-24','15:45:00',1.21),('15529','2013-10-24','15:50:00',1.18),('15529','2013-10-24','15:55:00',1.13),('15529','2013-10-24','16:00:00',1.1),('15529','2013-10-24','16:05:00',1.06),('15529','2013-10-24','16:10:00',1.04),('15529','2013-10-23','10:50:00',1.32),('15529','2013-10-23','10:55:00',1.23),('15529','2013-10-23','11:00:00',1.57),('15529','2013-10-23','11:05:00',1.08),('15529','2013-10-23','11:10:00',1.06),('15529','2013-10-23','11:15:00',1.17),('15529','2013-10-23','11:50:00',1.28),('15529','2013-10-23','11:55:00',1.25),('15529','2013-10-23','12:30:00',1.02),('15529','2013-10-23','12:35:00',1.11),('15529','2013-10-23','12:40:00',1.07),('15529','2013-10-23','12:45:00',1.03),('15529','2013-10-23','12:50:00',1.47),('15529','2013-10-23','12:55:00',2.09),('15529','2013-10-23','13:00:00',1.93),('15529','2013-10-23','13:05:00',1.49),('15529','2013-10-23','13:10:00',1.01),('15529','2013-10-23','13:15:00',1.43),('15529','2013-10-23','13:20:00',1.05),('15529','2013-10-23','13:50:00',1.52),('15529','2013-10-23','13:55:00',1.31),('15529','2013-10-23','14:30:00',1.21),('15529','2013-10-23','14:35:00',1.43),('15529','2013-10-23','14:40:00',1.76),('15529','2013-10-23','14:45:00',1.8),('15529','2013-10-23','15:05:00',1.27),('15529','2013-10-23','15:30:00',1.14),('15529','2013-10-23','15:35:00',1.57),('15529','2013-10-23','15:40:00',1.29),('15529','2013-10-23','15:45:00',1.4),('15529','2013-10-22','10:50:00',1.06),('15529','2013-10-22','10:55:00',1.46),('15529','2013-10-22','11:00:00',1.51),('15529','2013-10-22','11:05:00',1.55),('15529','2013-10-22','11:10:00',1.72),('15529','2013-10-22','11:15:00',1.65),('15529','2013-10-22','11:20:00',1.57),('15529','2013-10-22','11:25:00',1.71),('15529','2013-10-22','11:30:00',1.73),('15529','2013-10-22','11:35:00',1.71),('15529','2013-10-22','11:40:00',1.78),('15529','2013-10-22','11:45:00',1.67),('15529','2013-10-22','11:50:00',1.81),('15529','2013-10-22','11:55:00',1.73),('15529','2013-10-22','12:00:00',1.7),('15529','2013-10-22','12:05:00',1.68),('15529','2013-10-22','12:10:00',1.67),('15529','2013-10-22','12:15:00',1.69),('15529','2013-10-22','12:20:00',1.75),('15529','2013-10-22','12:25:00',1.71),('15529','2013-10-22','12:30:00',1.79),('15529','2013-10-22','12:35:00',1.79),('15529','2013-10-22','12:40:00',1.49),('15529','2013-10-22','12:45:00',1.32),('15529','2013-10-22','12:50:00',1.26),('15529','2013-10-22','12:55:00',1.08),('15529','2013-10-22','13:00:00',1.02),('15529','2013-10-22','13:05:00',1.71),('15529','2013-10-22','13:10:00',1.82),('15529','2013-10-22','13:15:00',1.85),('15529','2013-10-22','13:20:00',1.67),('15529','2013-10-22','13:25:00',1.74),('15529','2013-10-22','13:30:00',1.73),('15529','2013-10-22','13:35:00',1.78),('15529','2013-10-22','13:40:00',1.78),('15529','2013-10-22','13:45:00',1.6),('15529','2013-10-22','13:50:00',1.6),('15529','2013-10-22','13:55:00',1.62),('15529','2013-10-22','14:00:00',1.67),('15529','2013-10-22','14:05:00',1.65),('15529','2013-10-22','14:10:00',1.69),('15529','2013-10-22','14:15:00',1.62),('15529','2013-10-22','14:20:00',1.6),('15529','2013-10-22','14:25:00',1.48),('15529','2013-10-22','14:30:00',1.27),('15529','2013-10-22','14:35:00',1.44),('15529','2013-10-22','14:40:00',1.35),('15529','2013-10-22','14:45:00',1.45),('15529','2013-10-22','14:50:00',1.4),('15529','2013-10-22','14:55:00',1.38),('15529','2013-10-22','15:00:00',1.35),('15529','2013-10-22','15:05:00',1.41),('15529','2013-10-22','15:10:00',1.42),('15529','2013-10-22','15:15:00',1.36),('15529','2013-10-22','15:20:00',1.43),('15529','2013-10-22','15:25:00',1.4),('15529','2013-10-22','15:30:00',1.18),('15529','2013-10-22','15:35:00',1.11),('15529','2013-10-22','15:40:00',1.27),('15529','2013-10-22','15:45:00',1.3),('15529','2013-10-22','15:50:00',1.23),('15529','2013-10-22','15:55:00',1.07),('15529','2013-10-21','09:30:00',1),('15529','2013-10-21','09:35:00',1.06),('15529','2013-10-21','09:40:00',1.09),('15529','2013-10-21','09:45:00',1.13),('15529','2013-10-21','09:50:00',1.17),('15529','2013-10-21','09:55:00',1.2),('15529','2013-10-21','10:00:00',1.23),('15529','2013-10-21','10:05:00',1.28),('15529','2013-10-21','10:10:00',1.3),('15529','2013-10-21','10:15:00',1.34),('15529','2013-10-21','10:20:00',1.38),('15529','2013-10-21','10:25:00',1.39),('15529','2013-10-21','10:30:00',1.42),('15529','2013-10-21','10:35:00',1.44),('15529','2013-10-21','10:40:00',1.46),('15529','2013-10-21','10:45:00',1.48),('15529','2013-10-21','10:50:00',1.52),('15529','2013-10-21','10:55:00',1.54),('15529','2013-10-21','11:00:00',1.54),('15529','2013-10-21','11:05:00',1.57),('15529','2013-10-21','11:10:00',1.59),('15529','2013-10-21','11:15:00',1.6),('15529','2013-10-21','11:20:00',1.61),('15529','2013-10-21','11:25:00',1.64),('15529','2013-10-21','11:30:00',1.68),('15529','2013-10-21','11:35:00',1.68),('15529','2013-10-21','11:40:00',1.71),('15529','2013-10-21','11:45:00',1.72),('15529','2013-10-21','11:50:00',1.73),('15529','2013-10-21','11:55:00',1.75),('15529','2013-10-21','12:00:00',1.76),('15529','2013-10-21','12:05:00',1.76),('15529','2013-10-21','12:10:00',1.77),('15529','2013-10-21','12:15:00',1.79),('15529','2013-10-21','12:20:00',1.81),('15529','2013-10-21','12:25:00',1.79),('15529','2013-10-21','12:30:00',1.8),('15529','2013-10-21','12:35:00',1.85),('15529','2013-10-21','12:40:00',1.85),('15529','2013-10-21','12:45:00',1.84),('15529','2013-10-21','12:50:00',1.82),('15529','2013-10-21','12:55:00',1.82),('15529','2013-10-21','13:00:00',1.78),('15529','2013-10-21','13:05:00',1.8),('15529','2013-10-21','13:10:00',1.75),('15529','2013-10-21','13:15:00',1.76),('15529','2013-10-21','13:20:00',1.82),('15529','2013-10-21','13:25:00',1.83),('15529','2013-10-21','13:30:00',1.77),('15529','2013-10-21','13:35:00',1.83),('15529','2013-10-21','13:40:00',1.82),('15529','2013-10-21','13:45:00',1.8),('15529','2013-10-21','13:50:00',1.81),('15529','2013-10-21','13:55:00',1.79),('15529','2013-10-21','14:00:00',1.72),('15529','2013-10-21','14:05:00',1.6),('15529','2013-10-21','14:10:00',1.19),('15529','2013-10-21','14:20:00',1.45),('15529','2013-10-21','14:25:00',1.72),('15529','2013-10-21','14:30:00',1.66),('15529','2013-10-21','14:35:00',1.54),('15529','2013-10-21','14:40:00',1.62),('15529','2013-10-21','14:45:00',1.63),('15529','2013-10-21','14:50:00',1.52),('15529','2013-10-21','14:55:00',1.47),('15529','2013-10-21','15:00:00',1.41),('15529','2013-10-21','15:05:00',1.4),('15529','2013-10-21','15:10:00',1.39),('15529','2013-10-21','15:15:00',1.22),('15529','2013-10-21','15:20:00',1.29),('15529','2013-10-21','15:25:00',1.26),('15529','2013-10-21','15:40:00',1.16),('15529','2013-10-21','15:45:00',1.13),('15529','2013-10-21','15:50:00',1.05),('15529','2013-10-21','15:55:00',1.05),('15529','2013-10-20','09:20:00',1.04),('15529','2013-10-20','09:35:00',1.01),('15529','2013-10-20','09:50:00',1.05),('15529','2013-10-20','09:55:00',1.09),('15529','2013-10-20','10:00:00',1.15),('15529','2013-10-20','10:05:00',1.36),('15529','2013-10-20','10:10:00',1.36),('15529','2013-10-20','10:15:00',1.39),('15529','2013-10-20','10:20:00',1.41),('15529','2013-10-20','10:25:00',1.46),('15529','2013-10-20','10:30:00',1.42),('15529','2013-10-20','10:35:00',1.4),('15529','2013-10-20','10:40:00',1.46),('15529','2013-10-20','10:45:00',1.49),('15529','2013-10-20','10:50:00',1.56),('15529','2013-10-20','10:55:00',1.63),('15529','2013-10-20','11:00:00',1.64),('15529','2013-10-20','11:05:00',1.27),('15529','2013-10-20','11:10:00',1.71),('15529','2013-10-20','11:15:00',1.73),('15529','2013-10-20','11:20:00',1.74),('15529','2013-10-20','11:25:00',1.74),('15529','2013-10-20','11:30:00',1.81),('15529','2013-10-20','11:35:00',1.77),('15529','2013-10-20','11:40:00',1.8),('15529','2013-10-20','11:45:00',1.85),('15529','2013-10-20','11:50:00',1.85),('15529','2013-10-20','11:55:00',1.88),('15529','2013-10-20','12:00:00',1.92),('15529','2013-10-20','12:05:00',1.92),('15529','2013-10-20','12:10:00',1.93),('15529','2013-10-20','12:15:00',1.9),('15529','2013-10-20','12:20:00',1.88),('15529','2013-10-20','12:25:00',1.82),('15529','2013-10-20','12:30:00',1.82),('15529','2013-10-20','12:35:00',1.91),('15529','2013-10-20','12:40:00',1.93),('15529','2013-10-20','12:45:00',1.93),('15529','2013-10-20','12:50:00',1.91),('15529','2013-10-20','12:55:00',1.89),('15529','2013-10-20','13:00:00',1.88),('15529','2013-10-20','13:05:00',1.82),('15529','2013-10-20','13:10:00',1.83),('15529','2013-10-20','13:15:00',1.87),('15529','2013-10-20','13:20:00',1.79),('15529','2013-10-20','13:25:00',1.88),('15529','2013-10-20','13:30:00',1.87),('15529','2013-10-20','13:35:00',1.85),('15529','2013-10-20','13:40:00',1.85),('15529','2013-10-20','13:45:00',1.82),('15529','2013-10-20','13:50:00',1.77),('15529','2013-10-20','13:55:00',1.7),('15529','2013-10-20','14:00:00',1.78),('15529','2013-10-20','14:05:00',1.79),('15529','2013-10-20','14:10:00',1.76),('15529','2013-10-20','14:15:00',1.73),('15529','2013-10-20','14:20:00',1.72),('15529','2013-10-20','14:25:00',1.7),('15529','2013-10-20','14:30:00',1.69),('15529','2013-10-20','14:35:00',1.61),('15529','2013-10-20','14:40:00',1.54),('15529','2013-10-20','14:45:00',1.56),('15529','2013-10-20','14:50:00',1.49),('15529','2013-10-20','14:55:00',1.47),('15529','2013-10-20','15:00:00',1.49),('15529','2013-10-20','15:05:00',1.44),('15529','2013-10-20','15:10:00',1.43),('15529','2013-10-20','15:15:00',1.41),('15529','2013-10-20','15:20:00',1.38),('15529','2013-10-20','15:25:00',1.32),('15529','2013-10-20','15:30:00',1.27),('15529','2013-10-20','15:35:00',1.29),('15529','2013-10-20','15:40:00',1.26),('15529','2013-10-20','15:45:00',1.21),('15529','2013-10-20','15:50:00',1.14),('15529','2013-10-20','15:55:00',1.14),('15529','2013-10-20','16:00:00',1.1),('15529','2013-10-20','16:05:00',1.06),('15529','2013-10-20','16:10:00',1.02),('15529','2013-10-19','09:20:00',1.01),('15529','2013-10-19','09:25:00',1.05),('15529','2013-10-19','09:30:00',1.1),('15529','2013-10-19','09:35:00',1.14),('15529','2013-10-19','09:40:00',1.16),('15529','2013-10-19','09:45:00',1.22),('15529','2013-10-19','09:50:00',1.26),('15529','2013-10-19','09:55:00',1.31),('15529','2013-10-19','10:00:00',1.34),('15529','2013-10-19','10:05:00',1.38),('15529','2013-10-19','10:10:00',1.42),('15529','2013-10-19','10:15:00',1.45),('15529','2013-10-19','10:20:00',1.49),('15529','2013-10-19','10:25:00',1.52),('15529','2013-10-19','10:30:00',1.54),('15529','2013-10-19','10:35:00',1.57),('15529','2013-10-19','10:40:00',1.6),('15529','2013-10-19','10:45:00',1.64),('15529','2013-10-19','10:50:00',1.66),('15529','2013-10-19','10:55:00',1.69),('15529','2013-10-19','11:00:00',1.71),('15529','2013-10-19','11:05:00',1.73),('15529','2013-10-19','11:10:00',1.76),('15529','2013-10-19','11:15:00',1.8),('15529','2013-10-19','11:20:00',1.81),('15529','2013-10-19','11:25:00',1.83),('15529','2013-10-19','11:30:00',1.84),('15529','2013-10-19','11:35:00',1.86),('15529','2013-10-19','11:40:00',1.87),('15529','2013-10-19','11:45:00',1.91),('15529','2013-10-19','11:50:00',1.91),('15529','2013-10-19','11:55:00',1.89),('15529','2013-10-19','12:00:00',1.94),('15529','2013-10-19','12:05:00',1.98),('15529','2013-10-19','12:10:00',1.93),('15529','2013-10-19','12:15:00',1.6),('15529','2013-10-19','12:20:00',1.09),('15529','2013-10-19','12:25:00',1.8),('15529','2013-10-19','12:30:00',2.15),('15529','2013-10-19','12:35:00',1.83),('15529','2013-10-19','12:40:00',1.14),('15529','2013-10-19','12:50:00',1.46),('15529','2013-10-19','12:55:00',2.3),('15529','2013-10-19','13:05:00',1.38),('15529','2013-10-19','13:10:00',1.12),('15529','2013-10-19','16:15:00',1.13),('15529','2013-10-19','16:20:00',1.2),('15529','2013-10-19','16:25:00',1.17),('15529','2013-10-19','16:30:00',1.11),('15529','2013-10-19','16:35:00',1.06),('15529','2013-10-19','16:40:00',1),('15529','2013-10-18','09:10:00',1.08),('15529','2013-10-18','09:15:00',1.17),('15529','2013-10-18','09:20:00',1.19),('15529','2013-10-18','09:25:00',1.21),('15529','2013-10-18','09:30:00',1.22),('15529','2013-10-18','09:35:00',1.28),('15529','2013-10-18','09:40:00',1.32),('15529','2013-10-18','09:45:00',1.33),('15529','2013-10-18','09:50:00',1.43),('15529','2013-10-18','09:55:00',1.47),('15529','2013-10-18','10:00:00',1.41),('15529','2013-10-18','10:05:00',1.49),('15529','2013-10-18','10:10:00',1.61),('15529','2013-10-18','10:15:00',1.68),('15529','2013-10-18','10:20:00',1.66),('15529','2013-10-18','10:25:00',1.7),('15529','2013-10-18','10:30:00',1.73),('15529','2013-10-18','10:35:00',1.74),('15529','2013-10-18','10:40:00',1.74),('15529','2013-10-18','10:45:00',1.76),('15529','2013-10-18','10:50:00',1.8),('15529','2013-10-18','10:55:00',1.81),('15529','2013-10-18','11:00:00',1.77),('15529','2013-10-18','11:05:00',1.34),('15529','2013-10-18','11:15:00',1.23),('15529','2013-10-18','11:20:00',1.94),('15529','2013-10-18','11:25:00',2.1),('15529','2013-10-18','11:30:00',2.07),('15529','2013-10-18','11:35:00',1.99),('15529','2013-10-18','11:40:00',1.99),('15529','2013-10-18','11:45:00',1.98),('15529','2013-10-18','11:50:00',1.67),('15529','2013-10-18','11:55:00',2.09),('15529','2013-10-18','12:00:00',2.08),('15529','2013-10-18','12:05:00',2.07),('15529','2013-10-18','12:10:00',2.04),('15529','2013-10-18','12:15:00',2.08),('15529','2013-10-18','12:20:00',1.89),('15529','2013-10-18','12:25:00',2.01),('15529','2013-10-18','12:30:00',2.09),('15529','2013-10-18','12:35:00',2.11),('15529','2013-10-18','12:40:00',2.15),('15529','2013-10-18','12:45:00',2.2),('15529','2013-10-18','12:50:00',2.12),('15529','2013-10-18','12:55:00',2.24),('15529','2013-10-18','13:00:00',2.13),('15529','2013-10-18','13:05:00',1.94),('15529','2013-10-18','13:10:00',2),('15529','2013-10-18','13:15:00',1.72),('15529','2013-10-18','13:20:00',1.75),('15529','2013-10-18','13:25:00',2.12),('15529','2013-10-18','13:30:00',1.75),('15529','2013-10-18','13:35:00',1.56),('15529','2013-10-18','13:40:00',1.39),('15529','2013-10-18','13:45:00',1.77),('15529','2013-10-18','13:50:00',2.23),('15529','2013-10-18','13:55:00',2.01),('15529','2013-10-18','14:00:00',1.96),('15529','2013-10-18','14:05:00',1.59),('15529','2013-10-18','14:10:00',1.88),('15529','2013-10-18','14:15:00',1.39),('15529','2013-10-18','14:20:00',1.02),('15529','2013-10-18','14:25:00',1.26),('15529','2013-10-18','14:30:00',2.1),('15529','2013-10-18','14:35:00',1.85),('15529','2013-10-18','14:40:00',1.05),('15529','2013-10-18','14:45:00',1.92),('15529','2013-10-18','14:50:00',1.85),('15529','2013-10-18','14:55:00',1.78),('15529','2013-10-18','15:00:00',1.73),('15529','2013-10-18','15:05:00',1.7),('15529','2013-10-18','15:10:00',1.68),('15529','2013-10-18','15:15:00',1.59),('15529','2013-10-18','15:20:00',1.54),('15529','2013-10-18','15:25:00',1.45),('15529','2013-10-18','15:30:00',1.42),('15529','2013-10-18','15:35:00',1.38),('15529','2013-10-18','15:40:00',1.24),('15529','2013-10-18','15:45:00',1.16),('15529','2013-10-18','15:50:00',1.36),('15529','2013-10-18','15:55:00',1.1),('15529','2013-10-18','16:00:00',1.19),('15529','2013-10-18','16:05:00',1.2),('15529','2013-10-18','16:10:00',1.17),('15529','2013-10-18','16:15:00',1.22),('15529','2013-10-18','16:25:00',1.01),('15529','2013-10-18','16:30:00',1.11),('15529','2013-10-18','16:35:00',1.05),('15529','2014-05-03','09:25:00',1.32),('15529','2014-05-03','09:30:00',1.28),('15529','2014-05-03','09:40:00',1.01),('15529','2014-05-03','09:55:00',1.49),('15529','2014-05-03','10:00:00',2.05),('15529','2014-05-03','10:05:00',1.95),('15529','2014-05-03','10:10:00',1.71),('15529','2014-05-03','10:15:00',1.77),('15529','2014-05-03','10:40:00',1.02),('15529','2014-05-03','10:45:00',1.18),('15529','2014-05-03','10:50:00',1.12),('15529','2014-05-03','10:55:00',1.06),('15529','2014-05-03','11:00:00',1.08),('15529','2014-05-03','11:05:00',1.34),('15529','2014-05-03','11:10:00',2.01),('15529','2014-05-03','11:15:00',2.48),('15529','2014-05-03','11:20:00',2.52),('15529','2014-05-03','11:25:00',2.47),('15529','2014-05-03','11:30:00',2.17),('15529','2014-05-03','11:35:00',1.65),('15529','2014-05-03','11:40:00',1.82),('15529','2014-05-03','11:45:00',2.27),('15529','2014-05-03','11:50:00',2.12),('15529','2014-05-03','11:55:00',2.18),('15529','2014-05-03','12:00:00',2.59),('15529','2014-05-03','12:05:00',1.02),('15529','2014-05-03','12:15:00',1.07),('15529','2014-05-03','12:20:00',1.08),('15529','2014-05-03','12:35:00',1.17),('15529','2014-05-03','12:40:00',2.72),('15529','2014-05-03','12:45:00',1.45),('15529','2014-05-03','12:50:00',2.4),('15529','2014-05-03','12:55:00',1.16),('15529','2014-05-03','13:05:00',1.64),('15529','2014-05-03','15:00:00',1.16),('15529','2014-05-03','15:05:00',1.14),('15529','2014-05-03','15:10:00',1.05),('15529','2014-05-03','15:15:00',1.61),('15529','2014-05-03','15:20:00',2.27),('15529','2014-05-03','15:25:00',2.01),('15529','2014-04-15','08:50:00',1.1),('15529','2014-04-15','08:55:00',1.16),('15529','2014-04-15','09:00:00',1.21),('15529','2014-04-15','09:05:00',1.25),('15529','2014-04-15','09:10:00',1.3),('15529','2014-04-15','09:15:00',1.34),('15529','2014-04-15','09:20:00',1.4),('15529','2014-04-15','09:25:00',1.49),('15529','2014-04-15','09:50:00',1.07),('15529','2014-04-15','09:55:00',1.28),('15529','2014-04-15','10:00:00',1.8),('15529','2014-04-15','10:05:00',1.8),('15529','2014-04-15','10:10:00',1.84),('15529','2014-04-15','10:15:00',1.87),('15529','2014-04-15','10:20:00',1.91),('15529','2014-04-15','10:25:00',1.94),('15529','2014-04-15','10:30:00',1.98),('15529','2014-04-15','10:35:00',2.03),('15529','2014-04-15','10:40:00',2.05),('15529','2014-04-15','10:45:00',2.1),('15529','2014-04-15','10:50:00',2.16),('15529','2014-04-15','10:55:00',1.96),('15529','2014-04-15','11:05:00',1.56),('15529','2014-04-15','11:10:00',1.09),('15529','2014-04-15','11:20:00',1.11),('15529','2014-04-15','11:25:00',2.68),('15529','2014-04-15','11:30:00',2.74),('15529','2014-04-15','11:35:00',2.42),('15529','2014-04-15','11:40:00',2.15),('15529','2014-04-15','11:45:00',2.81),('15529','2014-04-15','11:50:00',2.62),('15529','2014-04-15','11:55:00',2.23),('15529','2014-04-15','12:00:00',2.54),('15529','2014-04-15','12:05:00',2.31),('15529','2014-04-15','12:10:00',2.56),('15529','2014-04-15','12:15:00',2.48),('15529','2014-04-15','12:20:00',1.05),('15529','2014-04-15','12:45:00',1.53),('15529','2014-04-15','12:50:00',2.07),('15529','2014-04-15','12:55:00',2.5),('15529','2014-04-15','13:00:00',2.72),('15529','2014-04-15','13:40:00',1.76),('15529','2014-04-15','13:45:00',2.52),('15529','2014-04-15','13:50:00',2.84),('15529','2014-04-15','13:55:00',2.57),('15529','2014-04-15','14:05:00',1.58),('15529','2014-04-15','14:10:00',2.32),('15529','2014-04-15','14:15:00',2.67),('15529','2014-04-15','14:20:00',2.6),('15529','2014-04-15','14:25:00',1.92),('15529','2014-04-15','14:30:00',2.43),('15529','2014-04-15','14:35:00',2.36),('15529','2014-04-15','14:40:00',2.33),('15529','2014-04-15','14:45:00',2.03),('15529','2014-04-15','14:50:00',1.72),('15529','2014-04-15','15:00:00',1.6),('15529','2014-04-15','15:05:00',1.68),('15529','2014-04-15','15:10:00',2.09),('15529','2014-04-15','15:15:00',1.34),('15529','2014-04-15','15:30:00',1.25),('15529','2014-04-15','15:35:00',2.12),('15529','2014-04-15','15:40:00',2.16),('15529','2014-04-15','15:45:00',2.12),('15529','2014-04-15','15:50:00',1.56),('15529','2014-04-15','15:55:00',1.33),('15529','2014-04-15','16:00:00',1.94),('15529','2014-04-15','16:05:00',1.85),('15529','2014-04-15','16:10:00',1.79),('15529','2014-04-15','16:15:00',1.75),('15529','2014-04-15','16:20:00',1.73),('15529','2014-04-15','16:25:00',1.67),('15529','2014-04-15','16:30:00',1.63),('15529','2014-04-15','16:35:00',1.58),('15529','2014-04-15','16:40:00',1.53),('15529','2014-04-15','16:45:00',1.48),('15529','2014-04-15','16:50:00',1.43),('15529','2014-04-15','16:55:00',1.39),('15529','2014-04-15','17:00:00',1.34),('15529','2014-04-15','17:05:00',1.23),('15529','2014-04-15','17:10:00',1.24),('15529','2014-04-15','17:15:00',1.18),('15529','2014-04-15','17:20:00',1.13),('15529','2014-04-15','17:25:00',1.07),('15529','2014-04-15','17:30:00',1),('15529','2013-10-17','09:10:00',1.06),('15529','2013-10-17','09:15:00',1.09),('15529','2013-10-17','09:20:00',1.16),('15529','2013-10-17','09:25:00',1.21),('15529','2013-10-17','09:30:00',1.25),('15529','2013-10-17','09:35:00',1.3),('15529','2013-10-17','09:40:00',1.34),('15529','2013-10-17','09:45:00',1.38),('15529','2013-10-17','09:50:00',1.42),('15529','2013-10-17','09:55:00',1.46),('15529','2013-10-17','10:00:00',1.49),('15529','2013-10-17','10:05:00',1.53),('15529','2013-10-17','10:10:00',1.55),('15529','2013-10-17','10:15:00',1.58),('15529','2013-10-17','10:20:00',1.6),('15529','2013-10-17','10:25:00',1.66),('15529','2013-10-17','10:30:00',1.7),('15529','2013-10-17','10:35:00',1.72),('15529','2013-10-17','10:40:00',1.74),('15529','2013-10-17','10:45:00',1.75),('15529','2013-10-17','10:50:00',1.75),('15529','2013-10-17','10:55:00',1.76),('15529','2013-10-17','11:00:00',1.78),('15529','2013-10-17','11:05:00',1.75),('15529','2013-10-17','11:10:00',1.8),('15529','2013-10-17','11:15:00',1.81),('15529','2013-10-17','11:20:00',1.93),('15529','2013-10-17','11:25:00',1.9),('15529','2013-10-17','11:30:00',1.89),('15529','2013-10-17','11:35:00',1.98),('15529','2013-10-17','11:40:00',2.02),('15529','2013-10-17','11:45:00',1.88),('15529','2013-10-17','11:50:00',1.93),('15529','2013-10-17','11:55:00',2.01),('15529','2013-10-17','12:00:00',2.02),('15529','2013-10-17','12:05:00',1.99),('15529','2013-10-17','12:10:00',2),('15529','2013-10-17','12:15:00',1.96),('15529','2013-10-17','12:20:00',1.94),('15529','2013-10-17','12:25:00',2),('15529','2013-10-17','12:30:00',1.98),('15529','2013-10-17','12:35:00',2),('15529','2013-10-17','12:40:00',2),('15529','2013-10-17','12:45:00',1.98),('15529','2013-10-17','12:50:00',1.95),('15529','2013-10-17','12:55:00',2.04),('15529','2013-10-17','13:00:00',2.02),('15529','2013-10-17','13:05:00',1.99),('15529','2013-10-17','13:10:00',1.9),('15529','2013-10-17','13:15:00',1.95),('15529','2013-10-17','13:20:00',2.06),('15529','2013-10-17','13:25:00',2.01),('15529','2013-10-17','13:30:00',2.03),('15529','2013-10-17','13:35:00',2.03),('15529','2013-10-17','13:40:00',2.01),('15529','2013-10-17','13:45:00',1.95),('15529','2013-10-17','13:50:00',1.94),('15529','2013-10-17','13:55:00',1.91),('15529','2013-10-17','14:00:00',1.78),('15529','2013-10-17','14:05:00',1.83),('15529','2013-10-17','14:10:00',1.83),('15529','2013-10-17','14:15:00',1.87),('15529','2013-10-17','14:20:00',1.84),('15529','2013-10-17','14:25:00',1.81),('15529','2013-10-17','14:30:00',1.8),('15529','2013-10-17','14:35:00',1.74),('15529','2013-10-17','14:40:00',1.73),('15529','2013-10-17','14:45:00',1.65),('15529','2013-10-17','14:50:00',1.67),('15529','2013-10-17','14:55:00',1.67),('15529','2013-10-17','15:00:00',1.41),('15529','2013-10-17','15:05:00',1.39),('15529','2013-10-17','15:10:00',1.52),('15529','2013-10-17','15:15:00',1.52),('15529','2013-10-17','15:20:00',1.56),('15529','2013-10-17','15:25:00',1.44),('15529','2013-10-17','15:30:00',1.4),('15529','2013-10-17','15:35:00',1.38),('15529','2013-10-17','15:40:00',1.3),('15529','2013-10-17','15:45:00',1.17),('15529','2013-10-17','15:50:00',1.1),('15529','2013-10-17','15:55:00',1.13),('15529','2013-10-17','16:00:00',1.16),('15529','2013-10-17','16:05:00',1.09),('15529','2013-10-17','16:10:00',1.04),('15529','2013-10-16','09:10:00',1.05),('15529','2013-10-16','09:15:00',1.1),('15529','2013-10-16','09:20:00',1.14),('15529','2013-10-16','09:25:00',1.19),('15529','2013-10-16','09:30:00',1.24),('15529','2013-10-16','09:35:00',1.29),('15529','2013-10-16','09:40:00',1.33),('15529','2013-10-16','09:45:00',1.37),('15529','2013-10-16','09:50:00',1.41),('15529','2013-10-16','09:55:00',1.45),('15529','2013-10-16','10:00:00',1.48),('15529','2013-10-16','10:05:00',1.52),('15529','2013-10-16','10:10:00',1.55),('15529','2013-10-16','10:15:00',1.59),('15529','2013-10-16','10:20:00',1.62),('15529','2013-10-16','10:25:00',1.66),('15529','2013-10-16','10:30:00',1.68),('15529','2013-10-16','10:35:00',1.72),('15529','2013-10-16','10:40:00',1.75),('15529','2013-10-16','10:45:00',1.77),('15529','2013-10-16','10:50:00',1.77),('15529','2013-10-16','10:55:00',1.83),('15529','2013-10-16','11:00:00',1.84),('15529','2013-10-16','11:05:00',1.87),('15529','2013-10-16','11:10:00',1.9),('15529','2013-10-16','11:15:00',1.91),('15529','2013-10-16','11:20:00',1.94),('15529','2013-10-16','11:25:00',1.93),('15529','2013-10-16','11:30:00',2),('15529','2013-10-16','11:35:00',2.01),('15529','2013-10-16','11:40:00',2.02),('15529','2013-10-16','11:45:00',2.03),('15529','2013-10-16','11:50:00',2.04),('15529','2013-10-16','11:55:00',2.08),('15529','2013-10-16','12:00:00',2.07),('15529','2013-10-16','12:05:00',2.08),('15529','2013-10-16','12:10:00',2.06),('15529','2013-10-16','12:15:00',2.07),('15529','2013-10-16','12:20:00',2.07),('15529','2013-10-16','12:25:00',2.06),('15529','2013-10-16','12:30:00',2.07),('15529','2013-10-16','12:35:00',2.07),('15529','2013-10-16','12:40:00',2.09),('15529','2013-10-16','12:45:00',2.11),('15529','2013-10-16','12:50:00',2.11),('15529','2013-10-16','12:55:00',2.11),('15529','2013-10-16','13:00:00',2.08),('15529','2013-10-16','13:05:00',2.1),('15529','2013-10-16','13:10:00',2.06),('15529','2013-10-16','13:15:00',2.07),('15529','2013-10-16','13:20:00',2.07),('15529','2013-10-16','13:25:00',2.08),('15529','2013-10-16','13:30:00',2.07),('15529','2013-10-16','13:35:00',2.06),('15529','2013-10-16','13:40:00',2.04),('15529','2013-10-16','13:45:00',2),('15529','2013-10-16','13:50:00',1.99),('15529','2013-10-16','13:55:00',1.98),('15529','2013-10-16','14:00:00',1.98),('15529','2013-10-16','14:05:00',1.95),('15529','2013-10-16','14:10:00',1.93),('15529','2013-10-16','14:15:00',1.89),('15529','2013-10-16','14:20:00',1.9),('15529','2013-10-16','14:25:00',1.9),('15529','2013-10-16','14:30:00',1.89),('15529','2013-10-16','14:35:00',1.85),('15529','2013-10-16','14:40:00',1.83),('15529','2013-10-16','14:45:00',1.81),('15529','2013-10-16','14:50:00',1.78),('15529','2013-10-16','14:55:00',1.74),('15529','2013-10-16','15:00:00',1.71),('15529','2013-10-16','15:05:00',1.68),('15529','2013-10-16','15:10:00',1.66),('15529','2013-10-16','15:15:00',1.62),('15529','2013-10-16','15:20:00',1.6),('15529','2013-10-16','15:25:00',1.57),('15529','2013-10-16','15:30:00',1.53),('15529','2013-10-16','15:35:00',1.51),('15529','2013-10-16','15:40:00',1.46),('15529','2013-10-16','15:45:00',1.42),('15529','2013-10-16','15:50:00',1.36),('15529','2013-10-16','15:55:00',1.33),('15529','2013-10-16','16:00:00',1.3),('15529','2013-10-16','16:05:00',1.25),('15529','2013-10-16','16:10:00',1.22),('15529','2013-10-16','16:15:00',1.18),('15529','2013-10-16','16:20:00',1.13),('15529','2013-10-16','16:25:00',1.08),('15529','2013-10-16','16:30:00',1.03),('15529','2013-10-15','09:45:00',1.23),('15529','2013-10-15','12:10:00',1.5),('15529','2013-10-15','12:30:00',1.51),('15529','2013-10-15','12:35:00',1.66),('15529','2013-10-15','13:00:00',1.47),('15529','2013-10-15','13:05:00',1.28),('15529','2013-10-15','13:10:00',1.5),('15529','2013-10-15','13:15:00',2.3),('15529','2013-10-15','13:20:00',2.25),('15529','2013-10-15','13:25:00',2.17),('15529','2013-10-15','13:30:00',2.1),('15529','2013-10-15','13:35:00',2.13),('15529','2013-10-15','13:40:00',2.16),('15529','2013-10-15','13:45:00',2.07),('15529','2013-10-15','13:50:00',2.11),('15529','2013-10-15','13:55:00',2.18),('15529','2013-10-15','14:00:00',1.16),('15529','2013-10-15','14:05:00',1.86),('15529','2013-10-15','14:10:00',2.05),('15529','2013-10-15','14:15:00',1.95),('15529','2013-10-15','14:20:00',2.02),('15529','2013-10-15','14:25:00',1.96),('15529','2013-10-15','14:30:00',1.94),('15529','2013-10-15','14:35:00',1.94),('15529','2013-10-15','14:40:00',1.56),('15529','2013-10-15','14:45:00',1.57),('15529','2013-10-15','14:50:00',1.54),('15529','2013-10-15','14:55:00',1.81),('15529','2013-10-15','15:00:00',1.39),('15529','2013-10-15','15:05:00',1.6),('15529','2013-10-15','15:10:00',1.63),('15529','2013-10-15','15:15:00',1.67),('15529','2013-10-15','15:20:00',1.55),('15529','2013-10-15','15:25:00',1.25),('15529','2013-10-15','15:35:00',1.31),('15529','2013-10-15','15:40:00',1.48),('15529','2013-10-15','15:45:00',1.43),('15529','2013-10-15','15:50:00',1.38),('15529','2013-10-15','15:55:00',1.34),('15529','2013-10-15','16:00:00',1.3),('15529','2013-10-15','16:05:00',1.25),('15529','2013-10-15','16:10:00',1.19),('15529','2013-10-15','16:15:00',1.15),('15529','2013-10-15','16:20:00',1.11),('15529','2013-10-15','16:25:00',1.05),('15529','2013-10-15','16:30:00',1),('15529','2013-10-14','09:45:00',1.27),('15529','2013-10-14','09:50:00',1.36),('15529','2013-10-14','09:55:00',1.35),('15529','2013-10-14','10:00:00',1.35),('15529','2013-10-14','10:05:00',1.4),('15529','2013-10-14','10:10:00',1),('15529','2013-10-14','10:25:00',1.07),('15529','2013-10-14','10:30:00',1.12),('15529','2013-10-14','10:40:00',1.21),('15529','2013-10-14','10:45:00',1.34),('15529','2013-10-14','10:50:00',1.15),('15529','2013-10-14','10:55:00',1.09),('15529','2013-10-14','11:00:00',1.04),('15529','2013-10-14','11:05:00',1.28),('15529','2013-10-14','11:10:00',1.57),('15529','2013-10-14','11:15:00',1.65),('15529','2013-10-14','11:20:00',1.65),('15529','2013-10-14','11:25:00',1.54),('15529','2013-10-14','11:30:00',1.58),('15529','2013-10-14','11:35:00',1.23),('15529','2013-10-14','13:15:00',1.2),('15529','2013-10-14','13:20:00',1.83),('15529','2013-10-14','13:25:00',1.62),('15529','2013-10-14','13:30:00',1.08),('15529','2013-10-14','14:15:00',1.06),('15529','2013-10-14','14:20:00',1.08),('15529','2013-10-14','14:25:00',1.43),('15529','2013-10-14','14:30:00',1.01),('15529','2013-10-14','14:40:00',1.34),('15529','2013-10-14','14:45:00',1.37),('15529','2013-10-14','14:50:00',1.55),('15529','2013-10-13','09:25:00',1.11),('15529','2013-10-13','09:30:00',1.13),('15529','2013-10-13','09:35:00',1.01),('15529','2013-10-13','09:50:00',1.1),('15529','2013-10-13','09:55:00',1.24),('15529','2013-10-13','10:00:00',1.32),('15529','2013-10-13','10:05:00',1.32),('15529','2013-10-13','10:10:00',1.45),('15529','2013-10-13','10:15:00',1.49),('15529','2013-10-13','10:20:00',1.52),('15529','2013-10-13','10:25:00',1.56),('15529','2013-10-13','10:30:00',1.58),('15529','2013-10-13','10:35:00',1.58),('15529','2013-10-13','10:40:00',1.57),('15529','2013-10-13','10:45:00',1.62),('15529','2013-10-13','10:50:00',1.68),('15529','2013-10-13','10:55:00',1.68),('15529','2013-10-13','11:00:00',1.7),('15529','2013-10-13','11:05:00',1.7),('15529','2013-10-13','11:10:00',1.79),('15529','2013-10-13','11:15:00',1.75),('15529','2013-10-13','11:20:00',1.8),('15529','2013-10-13','11:25:00',1.84),('15529','2013-10-13','11:30:00',1.88),('15529','2013-10-13','11:35:00',1.85),('15529','2013-10-13','11:40:00',1.85),('15529','2013-10-13','11:45:00',1.83),('15529','2013-10-13','11:50:00',1.88),('15529','2013-10-13','11:55:00',1.88),('15529','2013-10-13','12:00:00',1.89),('15529','2013-10-13','12:05:00',1.91),('15529','2013-10-13','12:10:00',1.91),('15529','2013-10-13','12:15:00',1.88),('15529','2013-10-13','12:20:00',1.78),('15529','2013-10-13','12:25:00',1.95),('15529','2013-10-13','12:30:00',2),('15529','2013-10-13','12:35:00',1.96),('15529','2013-10-13','12:40:00',1.95),('15529','2013-10-13','12:45:00',1.95),('15529','2013-10-13','12:50:00',1.96),('15529','2013-10-13','12:55:00',1.95),('15529','2013-10-13','13:00:00',1.92),('15529','2013-10-13','13:05:00',1.98),('15529','2013-10-13','13:10:00',1.98),('15529','2013-10-13','13:15:00',1.98),('15529','2013-10-13','13:20:00',1.97),('15529','2013-10-13','13:25:00',1.93),('15529','2013-10-13','13:30:00',1.94),('15529','2013-10-13','13:35:00',1.94),('15529','2013-10-13','13:40:00',1.94),('15529','2013-10-13','13:45:00',1.92),('15529','2013-10-13','13:50:00',1.89),('15529','2013-10-13','13:55:00',1.89),('15529','2013-10-13','14:00:00',1.87),('15529','2013-10-13','14:05:00',1.86),('15529','2013-10-13','14:10:00',1.85),('15529','2013-10-13','14:15:00',1.83),('15529','2013-10-13','14:20:00',1.8),('15529','2013-10-13','14:25:00',1.78),('15529','2013-10-13','14:30:00',1.76),('15529','2013-10-13','14:35:00',1.72),('15529','2013-10-13','14:40:00',1.7),('15529','2013-10-13','14:45:00',1.68),('15529','2013-10-13','14:50:00',1.63),('15529','2013-10-13','14:55:00',1.6),('15529','2013-10-13','15:00:00',1.58),('15529','2013-10-13','15:05:00',1.56),('15529','2013-10-13','15:10:00',1.51),('15529','2013-10-13','15:15:00',1.49),('15529','2013-10-13','15:20:00',1.47),('15529','2013-10-13','15:25:00',1.43),('15529','2013-10-13','15:30:00',1.39),('15529','2013-10-13','15:35:00',1.35),('15529','2013-10-13','15:40:00',1.13),('15529','2013-10-12','09:15:00',1.08),('15529','2013-10-12','09:20:00',1.09),('15529','2013-10-12','09:40:00',1.3),('15529','2013-10-12','09:45:00',1.61),('15529','2013-10-12','09:50:00',1.57),('15529','2013-10-12','09:55:00',1.43),('15529','2013-10-12','10:10:00',1.39),('15529','2013-10-12','10:15:00',1.24),('15529','2013-10-12','10:25:00',1.17),('15529','2013-10-12','10:30:00',1.69),('15529','2013-10-12','10:35:00',1.87),('15529','2013-10-12','10:40:00',1.9),('15529','2013-10-12','10:45:00',1.92),('15529','2013-10-12','10:50:00',1.73),('15529','2013-10-12','10:55:00',1.44),('15529','2013-10-12','11:00:00',1.91),('15529','2013-10-12','11:05:00',1.59),('15529','2013-10-12','11:10:00',1.86),('15529','2013-10-12','11:15:00',1.86),('15529','2013-10-12','11:20:00',1.83),('15529','2013-10-12','11:25:00',1.83),('15529','2013-10-12','11:30:00',1.85),('15529','2013-10-12','11:35:00',1.87),('15529','2013-10-12','11:40:00',1.87),('15529','2013-10-12','11:45:00',1.91),('15529','2013-10-12','11:50:00',1.89),('15529','2013-10-12','11:55:00',1.9),('15529','2013-10-12','12:00:00',1.93),('15529','2013-10-12','12:05:00',1.96),('15529','2013-10-12','12:10:00',1.93),('15529','2013-10-12','12:15:00',1.96),('15529','2013-10-12','12:20:00',1.94),('15529','2013-10-12','12:25:00',1.91),('15529','2013-10-12','12:30:00',1.94),('15529','2013-10-12','12:35:00',1.96),('15529','2013-10-12','12:40:00',1.98),('15529','2013-10-12','12:45:00',1.96),('15529','2013-10-12','12:50:00',1.95),('15529','2013-10-12','12:55:00',1.94),('15529','2013-10-12','13:00:00',1.95),('15529','2013-10-12','13:05:00',1.96),('15529','2013-10-12','13:10:00',1.98),('15529','2013-10-12','13:15:00',2),('15529','2013-10-12','13:20:00',1.99),('15529','2013-10-12','13:25:00',1.75),('15529','2013-10-12','13:30:00',1.62),('15529','2013-10-12','13:35:00',1.54),('15529','2013-10-12','13:40:00',1.34),('15529','2013-10-12','13:45:00',1.69),('15529','2013-10-12','13:50:00',1.7),('15529','2013-10-12','13:55:00',1.59),('15529','2013-10-12','14:00:00',1.9),('15529','2013-10-12','14:05:00',1.85),('15529','2013-10-12','14:10:00',1.93),('15529','2013-10-12','14:15:00',1.73),('15529','2013-10-12','14:20:00',1.81),('15529','2013-10-12','14:25:00',1.96),('15529','2013-10-12','14:30:00',1.45),('15529','2013-10-12','14:35:00',1.52),('15529','2013-10-12','14:40:00',1.61),('15529','2013-10-12','14:45:00',1.19),('15529','2013-10-12','14:50:00',1.02),('15529','2013-10-12','14:55:00',1.33),('15529','2013-10-12','15:00:00',1.6),('15529','2013-10-12','15:05:00',1.26),('15529','2013-10-12','15:15:00',1.16),('15529','2013-10-12','15:20:00',1.27),('15529','2013-10-12','15:25:00',1.15),('15529','2013-10-12','16:05:00',1.03),('15529','2013-10-12','16:25:00',1.11),('15529','2013-10-12','16:30:00',1.04),('15529','2013-10-11','11:35:00',1.38),('15529','2013-10-11','11:40:00',1.3),('15529','2013-10-11','12:20:00',1.62),('15529','2013-10-11','12:25:00',1.75),('15529','2013-10-11','12:30:00',1.48),('15529','2013-10-11','12:35:00',1.74),('15529','2013-10-11','12:40:00',1.88),('15529','2013-10-11','12:45:00',1.37),('15529','2013-10-11','12:50:00',1.85),('15529','2013-10-11','12:55:00',1.41),('15529','2013-10-11','13:25:00',1.01),('15529','2013-10-11','13:30:00',1.95),('15529','2013-10-10','09:20:00',1.13),('15529','2013-10-10','09:25:00',1.17),('15529','2013-10-10','09:30:00',1.23),('15529','2013-10-10','09:35:00',1.18),('15529','2013-10-10','09:40:00',1.32),('15529','2013-10-10','09:45:00',1.36),('15529','2013-10-10','09:50:00',1.4),('15529','2013-10-10','09:55:00',1.44),('15529','2013-10-10','10:00:00',1.49),('15529','2013-10-10','10:05:00',1.55),('15529','2013-10-10','10:10:00',1.46),('15529','2013-10-10','10:15:00',1.66),('15529','2013-10-10','10:20:00',1.55),('15529','2013-10-10','10:25:00',1.61),('15529','2013-10-10','10:30:00',1.49),('15529','2013-10-10','10:35:00',1.81),('15529','2013-10-10','10:40:00',1.73),('15529','2013-10-10','11:55:00',1.44),('15529','2013-10-10','12:00:00',1.5),('15529','2013-10-10','12:05:00',2.59),('15529','2013-10-10','12:10:00',1.75),('15529','2013-10-10','12:25:00',1.41),('15529','2013-10-10','13:10:00',1.45),('15529','2013-10-10','13:15:00',1.1),('15529','2013-10-10','13:25:00',1.12),('15529','2013-10-10','13:30:00',1.02),('15529','2013-10-10','13:40:00',2.09),('15529','2013-10-10','13:45:00',2.47),('15529','2013-10-10','15:30:00',1.36),('15529','2013-10-09','09:05:00',1.03),('15529','2013-10-09','09:10:00',1.07),('15529','2013-10-09','09:15:00',1.1),('15529','2013-10-09','09:20:00',1.16),('15529','2013-10-09','09:25:00',1.21),('15529','2013-10-09','09:30:00',1.22),('15529','2013-10-09','09:35:00',1.19),('15529','2013-10-09','09:40:00',1.34),('15529','2013-10-09','09:45:00',1.35),('15529','2013-10-09','09:50:00',1.41),('15529','2013-10-09','09:55:00',1.43),('15529','2013-10-09','10:00:00',1.23),('15529','2013-10-09','10:05:00',1.51),('15529','2013-10-09','10:15:00',1.6),('15529','2013-10-09','10:20:00',1.51),('15529','2013-10-09','10:25:00',1.35),('15529','2013-10-09','10:30:00',1.45),('15529','2013-10-09','10:35:00',1.77),('15529','2013-10-09','10:40:00',1.81),('15529','2013-10-09','10:45:00',2.01),('15529','2013-10-09','10:50:00',2.04),('15529','2013-10-09','10:55:00',1.95),('15529','2013-10-09','11:00:00',1.52),('15529','2013-10-09','11:10:00',1.58),('15529','2013-10-09','11:15:00',1.2),('15529','2013-10-09','11:25:00',1.78),('15529','2013-10-09','11:30:00',2.22),('15529','2013-10-09','11:35:00',2.13),('15529','2013-10-09','11:40:00',2),('15529','2013-10-09','11:45:00',2.09),('15529','2013-10-09','11:50:00',2.3),('15529','2013-10-09','11:55:00',2.25),('15529','2013-10-09','12:00:00',2.25),('15529','2013-10-09','12:05:00',1.69),('15529','2013-10-09','12:10:00',2.12),('15529','2013-10-09','12:15:00',2.31),('15529','2013-10-09','12:20:00',2.37),('15529','2013-10-09','12:25:00',2.38),('15529','2013-10-09','12:30:00',2.11),('15529','2013-10-09','12:35:00',1.52),('15529','2013-10-09','12:40:00',1.21),('15529','2013-10-09','12:45:00',1.28),('15529','2013-10-09','12:50:00',1.27),('15529','2013-10-09','13:05:00',1.12),('15529','2013-10-09','13:35:00',1.48),('15529','2013-10-09','13:40:00',1.56),('15529','2013-10-09','13:45:00',1.69),('15529','2013-10-09','13:50:00',1.91),('15529','2013-10-09','13:55:00',1.28),('15529','2013-10-09','14:00:00',1.36),('15529','2013-10-09','14:20:00',1.3),('15529','2013-10-09','14:30:00',1.01),('15529','2013-10-09','14:35:00',1.82),('15529','2013-10-09','14:45:00',1.67),('15529','2013-10-09','14:50:00',1.9),('15529','2013-10-09','14:55:00',1.36),('15529','2013-10-09','15:10:00',1.14),('15529','2013-10-09','15:30:00',1.12),('15529','2013-10-09','15:40:00',1.32),('15529','2013-10-09','15:45:00',1.46),('15529','2013-10-09','16:00:00',1.71),('15529','2013-10-09','16:05:00',1.51),('15529','2013-10-09','16:10:00',1.59),('15529','2013-10-09','16:30:00',1.05),('15529','2013-10-08','09:05:00',1.03),('15529','2013-10-08','09:10:00',1.09),('15529','2013-10-08','09:20:00',1.18),('15529','2013-10-08','09:25:00',1.26),('15529','2013-10-08','09:30:00',1.31),('15529','2013-10-08','09:35:00',1.34),('15529','2013-10-08','09:40:00',1.39),('15529','2013-10-08','09:45:00',1.45),('15529','2013-10-08','09:50:00',1.5),('15529','2013-10-08','09:55:00',1.56),('15529','2013-10-08','10:00:00',1.63),('15529','2013-10-08','10:05:00',1.34),('15529','2013-10-08','10:45:00',1.43),('15529','2013-10-08','10:50:00',1.49),('15529','2013-10-08','10:55:00',1.46),('15529','2013-10-08','11:00:00',1.35),('15529','2013-10-08','11:05:00',1.71),('15529','2013-10-08','11:10:00',2.31),('15529','2013-10-08','11:15:00',1.99),('15529','2013-10-08','11:20:00',1.96),('15529','2013-10-08','11:25:00',2.1),('15529','2013-10-08','11:40:00',1.02),('15529','2013-10-08','11:50:00',2.03),('15529','2013-10-08','11:55:00',2.19),('15529','2013-10-08','12:00:00',2.21),('15529','2013-10-08','12:05:00',1.14),('15529','2013-10-08','12:10:00',1.15),('15529','2013-10-08','12:15:00',2.09),('15529','2013-10-08','12:20:00',1.22),('15529','2013-10-08','12:25:00',1.52),('15529','2013-10-08','12:30:00',1.44),('15529','2013-10-08','12:35:00',1.77),('15529','2013-10-08','13:15:00',1.03),('15529','2013-10-08','13:20:00',1.81),('15529','2013-10-08','13:25:00',2.21),('15529','2013-10-08','13:30:00',1.04),('15529','2013-10-08','13:35:00',1.04),('15529','2013-10-08','14:10:00',1.59),('15529','2013-10-08','14:50:00',1.99),('15529','2013-10-08','15:00:00',1.92),('15529','2013-10-08','15:05:00',1.92),('15529','2013-10-08','15:10:00',1.88),('15529','2013-10-08','15:15:00',1.52),('15529','2013-10-08','15:20:00',1.8),('15529','2013-10-08','15:25:00',1.79),('15529','2013-10-08','15:45:00',1.09),('15529','2013-10-08','16:00:00',1.16),('15529','2013-10-08','16:20:00',1.07),('15529','2013-10-08','16:25:00',1.08),('15529','2014-04-14','09:05:00',1.21),('15529','2014-04-14','09:10:00',1.23),('15529','2014-04-14','09:15:00',1.27),('15529','2014-04-14','09:20:00',1.31),('15529','2014-04-14','09:25:00',1.43),('15529','2014-04-14','10:00:00',1.8),('15529','2014-04-14','10:05:00',1.33),('15529','2014-04-14','10:10:00',1.17),('15529','2014-04-14','10:15:00',1.67),('15529','2014-04-14','10:20:00',1.31),('15529','2014-04-14','10:25:00',1.39),('15529','2014-04-14','10:30:00',1.89),('15529','2014-04-14','10:35:00',1.15),('15529','2014-04-14','10:40:00',1.81),('15529','2014-04-14','10:45:00',1.51),('15529','2014-04-14','10:50:00',1.23),('15529','2014-04-14','10:55:00',1),('15529','2014-04-14','11:00:00',1.38),('15529','2014-04-14','11:05:00',1.8),('15529','2014-04-14','11:10:00',1.36),('15529','2014-04-14','11:20:00',1.12),('15529','2014-04-14','12:15:00',1.02),('15529','2014-04-14','13:15:00',1.56),('15529','2014-04-14','13:30:00',1.41),('15529','2014-04-14','13:35:00',1.62),('15529','2014-04-14','13:55:00',1.13),('15529','2014-04-14','14:00:00',2),('15529','2014-04-14','14:05:00',1.13),('15529','2014-04-14','14:15:00',1.93),('15529','2014-04-14','14:20:00',2.25),('15529','2014-04-14','14:25:00',1.62),('15529','2014-04-14','14:30:00',1.19),('15529','2014-04-14','14:35:00',1.55),('15529','2014-04-14','14:40:00',1.4),('15529','2014-04-14','14:45:00',1.61),('15529','2014-04-14','14:50:00',1.9),('15529','2014-04-14','14:55:00',1.65),('15529','2014-04-14','15:00:00',2.25),('15529','2014-04-14','15:05:00',1.28),('15529','2014-04-14','15:10:00',1.31),('15529','2014-04-14','15:15:00',1.83),('15529','2014-04-14','15:20:00',2.02),('15529','2014-04-14','15:25:00',1.73),('15529','2014-04-14','15:30:00',1.09),('15529','2013-10-07','11:15:00',1.25),('15529','2013-10-07','11:20:00',1.78),('15529','2013-10-07','11:25:00',1.58),('15529','2013-10-07','12:30:00',1.3),('15529','2013-10-07','12:35:00',1.07),('15529','2013-10-07','12:45:00',1.46),('15529','2013-10-07','12:50:00',2.32),('15529','2013-10-07','12:55:00',2.41),('15529','2013-10-07','13:00:00',1.72),('15529','2013-10-07','13:05:00',1.04),('15529','2013-10-07','13:30:00',2.56),('15529','2013-10-07','13:35:00',1.51),('15529','2013-10-07','14:15:00',1.1),('15529','2013-10-07','14:20:00',1.21),('15529','2013-10-07','14:25:00',1.45),('15529','2013-10-07','14:30:00',1.11),('15529','2013-10-07','14:40:00',1.16),('15529','2013-10-07','14:45:00',1.67),('15529','2013-10-07','14:50:00',1.98),('15529','2013-10-07','14:55:00',1.9),('15529','2013-10-07','15:00:00',1.87),('15529','2013-10-07','15:05:00',1.69),('15529','2013-10-07','15:10:00',1.44),('15529','2013-10-07','15:15:00',1.79),('15529','2013-10-07','15:20:00',1.28),('15529','2013-10-07','15:30:00',1.2),('15529','2013-10-07','15:40:00',1.19),('15529','2013-10-07','15:50:00',1.09),('15529','2013-10-06','09:00:00',1.01),('15529','2013-10-06','09:05:00',1.12),('15529','2013-10-06','09:10:00',1.12),('15529','2013-10-06','09:15:00',1.12),('15529','2013-10-06','09:20:00',1.17),('15529','2013-10-06','09:25:00',1.22),('15529','2013-10-06','09:30:00',1.25),('15529','2013-10-06','09:35:00',1.3),('15529','2013-10-06','09:40:00',1.34),('15529','2013-10-06','09:45:00',1.37),('15529','2013-10-06','09:50:00',1.41),('15529','2013-10-06','09:55:00',1.44),('15529','2013-10-06','10:00:00',1.47),('15529','2013-10-06','10:05:00',1.5),('15529','2013-10-06','10:10:00',1.54),('15529','2013-10-06','10:15:00',1.57),('15529','2013-10-06','10:20:00',1.63),('15529','2013-10-06','10:25:00',1.67),('15529','2013-10-06','10:30:00',1.55),('15529','2013-10-06','10:35:00',1.11),('15529','2013-10-06','10:40:00',1.83),('15529','2013-10-06','10:45:00',1.8),('15529','2013-10-06','10:50:00',1.8),('15529','2013-10-06','10:55:00',1.68),('15529','2013-10-06','11:05:00',1.91),('15529','2013-10-06','11:10:00',1.85),('15529','2013-10-06','11:15:00',1.9),('15529','2013-10-06','11:20:00',1.93),('15529','2013-10-06','11:25:00',1.97),('15529','2013-10-06','11:30:00',1.98),('15529','2013-10-06','11:35:00',1.99),('15529','2013-10-06','11:40:00',1.97),('15529','2013-10-06','11:45:00',2.1),('15529','2013-10-06','11:50:00',2.05),('15529','2013-10-06','11:55:00',2.08),('15529','2013-10-06','12:00:00',2.13),('15529','2013-10-06','12:05:00',2.22),('15529','2013-10-06','12:10:00',1.77),('15529','2013-10-06','12:15:00',2.35),('15529','2013-10-06','12:20:00',1.29),('15529','2013-10-06','12:25:00',2.27),('15529','2013-10-06','12:30:00',1.99),('15529','2013-10-06','12:35:00',1.74),('15529','2013-10-06','12:40:00',2.28),('15529','2013-10-06','12:45:00',1.88),('15529','2013-10-06','12:50:00',1.95),('15529','2013-10-06','12:55:00',2.31),('15529','2013-10-06','13:00:00',1.81),('15529','2013-10-06','13:10:00',1.19),('15529','2013-10-06','13:25:00',1.33),('15529','2013-10-06','14:00:00',1.7),('15529','2013-10-06','14:05:00',1.16),('15529','2013-10-06','14:10:00',1.35),('15529','2013-10-06','14:15:00',2.36),('15529','2013-10-06','14:20:00',2.24),('15529','2013-10-06','14:25:00',2.23),('15529','2013-10-06','14:30:00',1.68),('15529','2013-10-06','14:35:00',2.13),('15529','2013-10-06','14:40:00',1.83),('15529','2013-10-06','14:45:00',1.12),('15529','2013-10-06','14:50:00',1.89),('15529','2013-10-06','14:55:00',1.99),('15529','2013-10-06','15:00:00',1.96),('15529','2013-10-06','15:05:00',1.35),('15529','2013-10-06','15:10:00',1.69),('15529','2013-10-06','15:15:00',1.78),('15529','2013-10-06','15:20:00',1.82),('15529','2013-10-06','15:25:00',1.8),('15529','2013-10-06','15:30:00',1.81),('15529','2013-10-06','15:35:00',1.8),('15529','2013-10-06','15:40:00',1.71),('15529','2013-10-06','15:45:00',1.56),('15529','2013-10-06','15:50:00',1.6),('15529','2013-10-06','15:55:00',1.56),('15529','2013-10-06','16:00:00',1.48),('15529','2013-10-06','16:05:00',1.47),('15529','2013-10-06','16:10:00',1.38),('15529','2013-10-06','16:25:00',1.24),('15529','2013-10-06','16:30:00',1.23),('15529','2013-10-06','16:35:00',1.17),('15529','2013-10-06','16:40:00',1.1),('15529','2013-10-06','16:45:00',1.03),('15529','2013-10-05','09:35:00',1.07),('15529','2013-10-05','09:50:00',1.3),('15529','2013-10-05','09:55:00',1.48),('15529','2013-10-05','10:00:00',1.66),('15529','2013-10-05','10:05:00',1.61),('15529','2013-10-05','10:10:00',1.54),('15529','2013-10-05','10:15:00',1.42),('15529','2013-10-05','10:20:00',1.53),('15529','2013-10-05','10:25:00',1.7),('15529','2013-10-05','10:30:00',1.64),('15529','2013-10-05','10:35:00',1.51),('15529','2013-10-05','10:40:00',1.29),('15529','2013-10-05','10:50:00',1.29),('15529','2013-10-05','10:55:00',1.29),('15529','2013-10-05','11:00:00',1.39),('15529','2013-10-05','11:05:00',1.61),('15529','2013-10-05','11:10:00',1.74),('15529','2013-10-05','11:15:00',1.68),('15529','2013-10-05','11:20:00',1.45),('15529','2013-10-05','11:25:00',1.65),('15529','2013-10-05','11:30:00',1.68),('15529','2013-10-05','11:35:00',1.32),('15529','2013-10-05','11:50:00',1.06),('15529','2013-10-05','11:55:00',1.55),('15529','2013-10-05','12:00:00',1.61),('15529','2013-10-05','12:05:00',1.75),('15529','2013-10-05','12:10:00',1.95),('15529','2013-10-05','12:15:00',1.34),('15529','2013-10-05','12:20:00',1.39),('15529','2013-10-05','12:25:00',1.34),('15529','2013-10-05','12:35:00',1.13),('15529','2013-10-05','12:40:00',1.3),('15529','2013-10-05','12:45:00',1.77),('15529','2013-10-05','12:50:00',1.87),('15529','2013-10-05','12:55:00',1.99),('15529','2013-10-05','13:00:00',2.01),('15529','2013-10-05','13:05:00',2.05),('15529','2013-10-05','13:10:00',1.27),('15529','2013-10-05','13:20:00',1.72),('15529','2013-10-05','13:40:00',1.58),('15529','2013-10-05','13:45:00',1.98),('15529','2013-10-05','13:50:00',2.04),('15529','2013-10-05','13:55:00',1.84),('15529','2013-10-05','14:00:00',1.85),('15529','2013-10-05','14:05:00',1.3),('15529','2013-10-05','14:20:00',1.2),('15529','2013-10-05','14:25:00',1.33),('15529','2013-10-05','14:30:00',1.18),('15529','2013-10-05','14:35:00',1.02),('15529','2013-10-05','14:40:00',1.4),('15529','2013-10-05','14:45:00',1.01),('15529','2013-10-05','14:50:00',1.09),('15529','2013-10-05','14:55:00',1.35),('15529','2013-10-05','15:05:00',1.2),('15529','2013-10-03','09:50:00',1.1),('15529','2013-10-03','10:25:00',1.22),('15529','2013-10-03','10:30:00',1.57),('15529','2013-10-03','10:35:00',1.26),('15529','2013-10-03','10:40:00',1.75),('15529','2013-10-03','10:45:00',2.04),('15529','2013-10-03','10:50:00',1.24),('15529','2013-10-03','11:00:00',1.2),('15529','2013-10-03','11:10:00',1.03),('15529','2013-10-03','11:15:00',1.91),('15529','2013-10-03','11:20:00',1.56),('15529','2013-10-03','11:25:00',1.68),('15529','2013-10-03','11:30:00',2.16),('15529','2013-10-03','11:35:00',1.79),('15529','2013-10-03','11:40:00',1.91),('15529','2013-10-03','11:45:00',2.12),('15529','2013-10-03','11:50:00',2.07),('15529','2013-10-03','11:55:00',2.01),('15529','2013-10-03','12:00:00',2.06),('15529','2013-10-03','12:05:00',2.09),('15529','2013-10-03','12:10:00',2.06),('15529','2013-10-03','12:15:00',1.74),('15529','2013-10-03','12:20:00',2.15),('15529','2013-10-03','12:25:00',2.14),('15529','2013-10-03','12:30:00',2.18),('15529','2013-10-03','12:35:00',2.11),('15529','2013-10-03','12:40:00',2.06),('15529','2013-10-03','12:45:00',2.09),('15529','2013-10-03','12:50:00',2.04),('15529','2013-10-03','12:55:00',2.04),('15529','2013-10-03','13:00:00',2.09),('15529','2013-10-03','13:05:00',2.11),('15529','2013-10-03','13:10:00',2.11),('15529','2013-10-03','13:15:00',2.16),('15529','2013-10-03','13:20:00',2.06),('15529','2013-10-03','13:25:00',2.06),('15529','2013-10-03','13:30:00',2.12),('15529','2013-10-03','13:35:00',2.12),('15529','2013-10-03','13:40:00',2.07),('15529','2013-10-03','13:45:00',2.05),('15529','2013-10-03','13:50:00',2.02),('15529','2013-10-03','13:55:00',2.03),('15529','2013-10-03','14:00:00',2.01),('15529','2013-10-03','14:05:00',1.99),('15529','2013-10-03','14:10:00',1.69),('15529','2013-10-03','14:15:00',1.64),('15529','2013-10-03','14:20:00',1.92),('15529','2013-10-03','14:25:00',1.81),('15529','2013-10-03','14:30:00',1.58),('15529','2013-10-03','14:35:00',1.01),('15529','2013-10-03','14:45:00',1.25),('15529','2013-10-03','14:50:00',1.52),('15529','2013-10-03','14:55:00',1.27),('15529','2013-10-03','15:00:00',1.15),('15529','2013-10-03','15:05:00',1.36),('15529','2013-10-03','15:10:00',1.23),('15529','2013-10-03','15:25:00',1.29),('15529','2013-10-02','09:00:00',1.05),('15529','2013-10-02','09:05:00',1.1),('15529','2013-10-02','09:10:00',1.15),('15529','2013-10-02','09:15:00',1.21),('15529','2013-10-02','09:20:00',1.26),('15529','2013-10-02','09:25:00',1.31),('15529','2013-10-02','09:30:00',1.35),('15529','2013-10-02','09:35:00',1.4),('15529','2013-10-02','09:40:00',1.44),('15529','2013-10-02','09:45:00',1.48),('15529','2013-10-02','09:50:00',1.52),('15529','2013-10-02','09:55:00',1.57),('15529','2013-10-02','10:00:00',1.61),('15529','2013-10-02','10:05:00',1.66),('15529','2013-10-02','10:10:00',1.69),('15529','2013-10-02','10:15:00',1.73),('15529','2013-10-02','10:20:00',1.77),('15529','2013-10-02','10:25:00',1.79),('15529','2013-10-02','10:30:00',1.82),('15529','2013-10-02','10:35:00',1.85),('15529','2013-10-02','10:40:00',1.88),('15529','2013-10-02','10:45:00',1.9),('15529','2013-10-02','10:50:00',1.92),('15529','2013-10-02','10:55:00',1.95),('15529','2013-10-02','11:00:00',1.98),('15529','2013-10-02','11:05:00',2),('15529','2013-10-02','11:10:00',2.03),('15529','2013-10-02','11:15:00',2.06),('15529','2013-10-02','11:20:00',2.07),('15529','2013-10-02','11:25:00',2.1),('15529','2013-10-02','11:30:00',2.12),('15529','2013-10-02','11:35:00',2.13),('15529','2013-10-02','11:40:00',2.16),('15529','2013-10-02','11:45:00',2.17),('15529','2013-10-02','11:50:00',2.18),('15529','2013-10-02','11:55:00',2.19),('15529','2013-10-02','12:00:00',2.2),('15529','2013-10-02','12:05:00',2.21),('15529','2013-10-02','12:10:00',2.23),('15529','2013-10-02','12:15:00',2.23),('15529','2013-10-02','12:20:00',2.25),('15529','2013-10-02','12:25:00',2.23),('15529','2013-10-02','12:30:00',2.24),('15529','2013-10-02','12:35:00',2.26),('15529','2013-10-02','12:40:00',2.26),('15529','2013-10-02','12:45:00',2.22),('15529','2013-10-02','12:50:00',2.24),('15529','2013-10-02','12:55:00',2.26),('15529','2013-10-02','13:00:00',2.23),('15529','2013-10-02','13:05:00',2.24),('15529','2013-10-02','13:10:00',2.24),('15529','2013-10-02','13:15:00',2.22),('15529','2013-10-02','13:20:00',2.24),('15529','2013-10-02','13:25:00',2.23),('15529','2013-10-02','13:30:00',2.24),('15529','2013-10-02','13:35:00',2.25),('15529','2013-10-02','13:40:00',2.21),('15529','2013-10-02','13:45:00',2.21),('15529','2013-10-02','13:50:00',2.19),('15529','2013-10-02','13:55:00',2.15),('15529','2013-10-02','14:00:00',2.16),('15529','2013-10-02','14:05:00',2.13),('15529','2013-10-02','14:10:00',2.11),('15529','2013-10-02','14:15:00',2.1),('15529','2013-10-02','14:20:00',2.09),('15529','2013-10-02','14:25:00',2.06),('15529','2013-10-02','14:30:00',2.06),('15529','2013-10-02','14:35:00',2.03),('15529','2013-10-02','14:40:00',2),('15529','2013-10-02','14:45:00',1.97),('15529','2013-10-02','14:50:00',1.95),('15529','2013-10-02','14:55:00',1.9),('15529','2013-10-02','15:00:00',1.87),('15529','2013-10-02','15:05:00',1.85),('15529','2013-10-02','15:10:00',1.82),('15529','2013-10-02','15:15:00',1.79),('15529','2013-10-02','15:20:00',1.78),('15529','2013-10-02','15:25:00',1.73),('15529','2013-10-02','15:30:00',1.72),('15529','2013-10-02','15:35:00',1.68),('15529','2013-10-02','15:40:00',1.64),('15529','2013-10-02','15:45:00',1.59),('15529','2013-10-02','15:50:00',1.55),('15529','2013-10-02','15:55:00',1.52),('15529','2013-10-02','16:00:00',1.47),('15529','2013-10-02','16:05:00',1.43),('15529','2013-10-02','16:10:00',1.39),('15529','2013-10-02','16:15:00',1.34),('15529','2013-10-02','16:20:00',1.3),('15529','2013-10-02','16:25:00',1.24),('15529','2013-10-02','16:30:00',1.2),('15529','2013-10-02','16:35:00',1.15),('15529','2013-10-02','16:40:00',1.11),('15529','2013-10-02','16:45:00',1.05),('15529','2013-10-01','09:05:00',1.04),('15529','2013-10-01','09:10:00',1.08),('15529','2013-10-01','09:15:00',1.13),('15529','2013-10-01','09:20:00',1.19),('15529','2013-10-01','09:25:00',1.23),('15529','2013-10-01','09:30:00',1.28),('15529','2013-10-01','09:35:00',1.32),('15529','2013-10-01','09:40:00',1.36),('15529','2013-10-01','09:45:00',1.4),('15529','2013-10-01','09:50:00',1.43),('15529','2013-10-01','09:55:00',1.46),('15529','2013-10-01','10:00:00',1.49),('15529','2013-10-01','10:05:00',1.54),('15529','2013-10-01','10:10:00',1.56),('15529','2013-10-01','10:15:00',1.61),('15529','2013-10-01','10:20:00',1.64),('15529','2013-10-01','10:25:00',1.68),('15529','2013-10-01','10:30:00',1.71),('15529','2013-10-01','10:35:00',1.74),('15529','2013-10-01','10:40:00',1.79),('15529','2013-10-01','10:45:00',1.81),('15529','2013-10-01','10:50:00',1.84),('15529','2013-10-01','10:55:00',1.86),('15529','2013-10-01','11:00:00',1.88),('15529','2013-10-01','11:05:00',1.91),('15529','2013-10-01','11:10:00',1.94),('15529','2013-10-01','11:15:00',1.94),('15529','2013-10-01','11:20:00',1.96),('15529','2013-10-01','11:25:00',1.97),('15529','2013-10-01','11:30:00',2.01),('15529','2013-10-01','11:35:00',2.02),('15529','2013-10-01','11:40:00',2.05),('15529','2013-10-01','11:45:00',2.07),('15529','2013-10-01','11:50:00',2.07),('15529','2013-10-01','11:55:00',2.09),('15529','2013-10-01','12:00:00',2.11),('15529','2013-10-01','12:05:00',2.1),('15529','2013-10-01','12:10:00',2.1),('15529','2013-10-01','12:15:00',2.12),('15529','2013-10-01','12:20:00',2.15),('15529','2013-10-01','12:25:00',2.14),('15529','2013-10-01','12:30:00',2.12),('15529','2013-10-01','12:35:00',2.15),('15529','2013-10-01','12:40:00',2.14),('15529','2013-10-01','12:45:00',2.14),('15529','2013-10-01','12:50:00',2.14),('15529','2013-10-01','12:55:00',2.16),('15529','2013-10-01','13:00:00',2.18),('15529','2013-10-01','13:05:00',2.17),('15529','2013-10-01','13:10:00',2.16),('15529','2013-10-01','13:15:00',2.16),('15529','2013-10-01','13:20:00',2.16),('15529','2013-10-01','13:25:00',2.15),('15529','2013-10-01','13:30:00',2.15),('15529','2013-10-01','13:35:00',2.12),('15529','2013-10-01','13:40:00',2.08),('15529','2013-10-01','13:45:00',2.11),('15529','2013-10-01','13:50:00',2.1),('15529','2013-10-01','13:55:00',2.1),('15529','2013-10-01','14:00:00',2.06),('15529','2013-10-01','14:05:00',2.06),('15529','2013-10-01','14:10:00',2.06),('15529','2013-10-01','14:15:00',2.04),('15529','2013-10-01','14:20:00',1.99),('15529','2013-10-01','14:25:00',1.99),('15529','2013-10-01','14:30:00',1.97),('15529','2013-10-01','14:35:00',1.93),('15529','2013-10-01','14:40:00',1.91),('15529','2013-10-01','14:45:00',1.89),('15529','2013-10-01','14:50:00',1.88),('15529','2013-10-01','14:55:00',1.85),('15529','2013-10-01','15:00:00',1.83),('15529','2013-10-01','15:05:00',1.8),('15529','2013-10-01','15:10:00',1.76),('15529','2013-10-01','15:15:00',1.73),('15529','2013-10-01','15:20:00',1.7),('15529','2013-10-01','15:25:00',1.67),('15529','2013-10-01','15:30:00',1.64),('15529','2013-10-01','15:35:00',1.61),('15529','2013-10-01','15:40:00',1.57),('15529','2013-10-01','15:45:00',1.53),('15529','2013-10-01','15:50:00',1.49),('15529','2013-10-01','15:55:00',1.47),('15529','2013-10-01','16:00:00',1.44),('15529','2013-10-01','16:05:00',1.39),('15529','2013-10-01','16:10:00',1.35),('15529','2013-10-01','16:15:00',1.29),('15529','2013-10-01','16:20:00',1.26),('15529','2013-10-01','16:25:00',1.21),('15529','2013-10-01','16:30:00',1.17),('15529','2013-10-01','16:35:00',1.13),('15529','2013-10-01','16:40:00',1.08),('15529','2013-10-01','16:45:00',1.02),('15529','2013-09-30','09:05:00',1.02),('15529','2013-09-30','09:10:00',1.07),('15529','2013-09-30','09:15:00',1.11),('15529','2013-09-30','09:20:00',1.16),('15529','2013-09-30','09:25:00',1.2),('15529','2013-09-30','09:30:00',1.24),('15529','2013-09-30','09:35:00',1.28),('15529','2013-09-30','09:40:00',1.32),('15529','2013-09-30','09:45:00',1.36),('15529','2013-09-30','09:50:00',1.4),('15529','2013-09-30','09:55:00',1.43),('15529','2013-09-30','10:00:00',1.47),('15529','2013-09-30','10:05:00',1.52),('15529','2013-09-30','10:10:00',1.55),('15529','2013-09-30','10:15:00',1.57),('15529','2013-09-30','10:30:00',1.76),('15529','2013-09-30','10:35:00',1.8),('15529','2013-09-30','10:40:00',1.86),('15529','2013-09-30','10:45:00',1.9),('15529','2013-09-30','10:50:00',1.91),('15529','2013-09-30','10:55:00',1.44),('15529','2013-09-30','11:15:00',1.51),('15529','2013-09-30','11:20:00',2.02),('15529','2013-09-30','11:25:00',2.16),('15529','2013-09-30','11:30:00',1.44),('15529','2013-09-30','11:50:00',2.23),('15529','2013-09-30','11:55:00',1.3),('15529','2013-09-30','12:05:00',1.32),('15529','2013-09-30','12:10:00',2.26),('15529','2013-09-30','12:15:00',2.34),('15529','2013-09-30','12:20:00',1.54),('15529','2013-09-30','12:25:00',2.07),('15529','2013-09-30','12:30:00',1.46),('15529','2013-09-30','12:35:00',1.37),('15529','2013-09-30','12:45:00',1.59),('15529','2013-09-30','12:50:00',2.42),('15529','2013-09-30','12:55:00',2.37),('15529','2013-09-30','13:00:00',2.08),('15529','2013-09-30','13:05:00',1.13),('15529','2013-09-30','13:10:00',1.56),('15529','2013-09-30','13:15:00',1.32),('15529','2013-09-30','13:20:00',1.59),('15529','2013-09-30','13:25:00',2.21),('15529','2013-09-30','13:30:00',2.2),('15529','2013-09-30','13:35:00',2.15),('15529','2013-09-30','13:40:00',2.13),('15529','2013-09-30','13:45:00',2.1),('15529','2013-09-30','13:50:00',2.06),('15529','2013-09-30','13:55:00',2.07),('15529','2013-09-30','14:00:00',2.04),('15529','2013-09-30','14:05:00',2.01),('15529','2013-09-30','14:10:00',2.03),('15529','2013-09-30','14:15:00',2.02),('15529','2013-09-30','14:20:00',1.97),('15529','2013-09-30','14:25:00',1.96),('15529','2013-09-30','14:30:00',1.9),('15529','2013-09-30','14:35:00',1.96),('15529','2013-09-30','14:40:00',1.95),('15529','2013-09-30','14:45:00',1.93),('15529','2013-09-30','14:50:00',1.94),('15529','2013-09-30','14:55:00',1.87),('15529','2013-09-30','15:00:00',1.83),('15529','2013-09-30','15:05:00',1.81),('15529','2013-09-30','15:10:00',1.78),('15529','2013-09-30','15:15:00',1.75),('15529','2013-09-30','15:20:00',1.72),('15529','2013-09-30','15:25:00',1.69),('15529','2013-09-30','15:30:00',1.67),('15529','2013-09-30','15:35:00',1.63),('15529','2013-09-30','15:40:00',1.59),('15529','2013-09-30','15:45:00',1.54),('15529','2013-09-30','15:50:00',1.5),('15529','2013-09-30','15:55:00',1.45),('15529','2013-09-30','16:00:00',1.41),('15529','2013-09-30','16:05:00',1.37),('15529','2013-09-30','16:10:00',1.33),('15529','2013-09-30','16:15:00',1.3),('15529','2013-09-30','16:20:00',1.26),('15529','2013-09-30','16:25:00',1.22),('15529','2013-09-30','16:30:00',1.17),('15529','2013-09-30','16:35:00',1.13),('15529','2013-09-30','16:40:00',1.08),('15529','2013-09-30','16:45:00',1.03),('15529','2013-09-29','10:35:00',1.05),('15529','2013-09-29','10:40:00',1.43),('15529','2013-09-29','10:45:00',1.96),('15529','2013-09-29','10:50:00',1.87),('15529','2013-09-29','10:55:00',1.55),('15529','2013-09-29','11:00:00',1.59),('15529','2013-09-29','11:05:00',1.93),('15529','2013-09-29','11:10:00',1.63),('15529','2013-09-29','11:15:00',1.55),('15529','2013-09-29','11:20:00',1.79),('15529','2013-09-29','11:25:00',1.54),('15529','2013-09-29','11:30:00',1.71),('15529','2013-09-29','11:35:00',2.08),('15529','2013-09-29','11:40:00',2.08),('15529','2013-09-29','11:50:00',1.07),('15529','2013-09-29','11:55:00',1.83),('15529','2013-09-29','12:00:00',1.01),('15529','2013-09-29','12:05:00',1.8),('15529','2013-09-29','12:10:00',2.23),('15529','2013-09-29','12:15:00',2.23),('15529','2013-09-29','12:20:00',2.24),('15529','2013-09-29','12:25:00',2.22),('15529','2013-09-29','12:30:00',2.22),('15529','2013-09-29','12:35:00',1.45),('15529','2013-09-29','12:40:00',2.04),('15529','2013-09-29','12:45:00',2.34),('15529','2013-09-29','12:50:00',2.27),('15529','2013-09-29','12:55:00',2.28),('15529','2013-09-29','13:00:00',2.29),('15529','2013-09-29','13:05:00',2.34),('15529','2013-09-29','13:10:00',2.13),('15529','2013-09-29','13:15:00',1.88),('15529','2013-09-29','13:20:00',2.12),('15529','2013-09-29','13:25:00',2.43),('15529','2013-09-29','13:30:00',1.68),('15529','2013-09-29','13:35:00',1.54),('15529','2013-09-29','13:45:00',1.43),('15529','2013-09-29','13:50:00',1.47),('15529','2013-09-29','13:55:00',1.01),('15529','2013-09-29','14:30:00',1.92),('15529','2013-09-29','14:35:00',1.69),('15529','2013-09-29','14:40:00',1.68),('15529','2013-09-29','14:45:00',2.12),('15529','2013-09-29','14:50:00',1.41),('15529','2013-09-29','14:55:00',2.08),('15529','2013-09-29','15:00:00',1.42),('15529','2013-09-29','15:05:00',2.16),('15529','2013-09-29','15:10:00',1.52),('15529','2013-09-29','15:20:00',1.53),('15529','2013-09-29','15:25:00',1.37),('15529','2013-09-29','15:30:00',1.91),('15529','2013-09-29','15:35:00',1.95),('15529','2013-09-29','15:40:00',1.24),('15529','2013-09-29','16:10:00',1.6),('15529','2013-09-29','16:55:00',1.14),('15529','2013-09-29','17:00:00',1.01),('15529','2013-09-28','10:10:00',1.23),('15529','2013-09-28','10:15:00',1.46),('15529','2013-09-28','10:20:00',1.07),('15529','2013-09-28','10:25:00',1.16),('15529','2013-09-28','10:30:00',1.43),('15529','2013-09-28','10:35:00',1.52),('15529','2013-09-28','10:40:00',1.46),('15529','2013-09-28','10:45:00',1.63),('15529','2013-09-28','10:50:00',1.62),('15529','2013-09-28','10:55:00',1.65),('15529','2013-09-28','11:00:00',1.68),('15529','2013-09-28','11:05:00',1.57),('15529','2013-09-28','11:10:00',1.61),('15529','2013-09-28','11:15:00',1.73),('15529','2013-09-28','11:20:00',1.65),('15529','2013-09-28','11:25:00',1.65),('15529','2013-09-28','11:30:00',1.71),('15529','2013-09-28','11:35:00',1.71),('15529','2013-09-28','11:40:00',1.74),('15529','2013-09-28','11:45:00',1.89),('15529','2013-09-28','11:50:00',1.98),('15529','2013-09-28','11:55:00',1.84),('15529','2013-09-28','12:00:00',1.41),('15529','2013-09-28','12:05:00',1.96),('15529','2013-09-28','12:10:00',2.03),('15529','2013-09-28','12:15:00',1.58),('15529','2013-09-28','13:35:00',1.28),('15529','2013-09-28','13:40:00',1.03),('15529','2013-09-28','13:45:00',1.02),('15529','2013-09-28','13:50:00',1.04),('15529','2013-09-28','14:00:00',1.27),('15529','2013-09-28','14:05:00',1),('15529','2013-09-28','14:20:00',1.23),('15529','2014-04-13','08:50:00',1.03),('15529','2014-04-13','08:55:00',1.08),('15529','2014-04-13','09:00:00',1.12),('15529','2014-04-13','09:05:00',1.18),('15529','2014-04-13','09:10:00',1.22),('15529','2014-04-13','09:15:00',1.27),('15529','2014-04-13','09:20:00',1.32),('15529','2014-04-13','09:25:00',1.35),('15529','2014-04-13','09:30:00',1.39),('15529','2014-04-13','09:35:00',1.43),('15529','2014-04-13','09:40:00',1.48),('15529','2014-04-13','09:45:00',1.52),('15529','2014-04-13','09:50:00',1.56),('15529','2014-04-13','09:55:00',1.6),('15529','2014-04-13','10:00:00',1.63),('15529','2014-04-13','10:05:00',1.67),('15529','2014-04-13','10:10:00',1.71),('15529','2014-04-13','10:15:00',1.73),('15529','2014-04-13','10:20:00',1.77),('15529','2014-04-13','10:25:00',1.79),('15529','2014-04-13','10:30:00',1.83),('15529','2014-04-13','10:35:00',1.87),('15529','2014-04-13','10:40:00',1.89),('15529','2014-04-13','10:45:00',1.91),('15529','2014-04-13','10:50:00',1.96),('15529','2014-04-13','10:55:00',1.97),('15529','2014-04-13','11:00:00',2),('15529','2014-04-13','11:05:00',2.04),('15529','2014-04-13','11:10:00',2.06),('15529','2014-04-13','11:15:00',2.06),('15529','2014-04-13','11:20:00',2.1),('15529','2014-04-13','11:25:00',2.13),('15529','2014-04-13','11:30:00',2.16),('15529','2014-04-13','11:35:00',2.19),('15529','2014-04-13','11:40:00',2.2),('15529','2014-04-13','11:45:00',2.24),('15529','2014-04-13','11:50:00',2.2),('15529','2014-04-13','11:55:00',2.24),('15529','2014-04-13','12:00:00',2.23),('15529','2014-04-13','12:05:00',2.21),('15529','2014-04-13','12:10:00',2.28),('15529','2014-04-13','12:15:00',2.27),('15529','2014-04-13','12:20:00',2.28),('15529','2014-04-13','12:25:00',2.26),('15529','2014-04-13','12:30:00',2.31),('15529','2014-04-13','12:35:00',2.33),('15529','2014-04-13','12:40:00',2.34),('15529','2014-04-13','12:45:00',2.34),('15529','2014-04-13','12:50:00',2.32),('15529','2014-04-13','12:55:00',2.33),('15529','2014-04-13','13:00:00',2.33),('15529','2014-04-13','13:05:00',2.37),('15529','2014-04-13','13:10:00',2.36),('15529','2014-04-13','13:15:00',2.37),('15529','2014-04-13','13:20:00',2.37),('15529','2014-04-13','13:25:00',2.34),('15529','2014-04-13','13:30:00',2.36),('15529','2014-04-13','13:35:00',2.35),('15529','2014-04-13','13:40:00',2.35),('15529','2014-04-13','13:45:00',2.33),('15529','2014-04-13','13:50:00',2.32),('15529','2014-04-13','13:55:00',2.3),('15529','2014-04-13','14:00:00',2.29),('15529','2014-04-13','14:05:00',2.25),('15529','2014-04-13','14:10:00',2.28),('15529','2014-04-13','14:15:00',2.29),('15529','2014-04-13','14:20:00',2.28),('15529','2014-04-13','14:25:00',2.27),('15529','2014-04-13','14:30:00',2.23),('15529','2014-04-13','14:35:00',2.21),('15529','2014-04-13','14:40:00',2.21),('15529','2014-04-13','14:45:00',2.17),('15529','2014-04-13','14:50:00',2.17),('15529','2014-04-13','14:55:00',2.12),('15529','2014-04-13','15:00:00',2.12),('15529','2014-04-13','15:05:00',2.09),('15529','2014-04-13','15:10:00',2.07),('15529','2014-04-13','15:15:00',2.05),('15529','2014-04-13','15:20:00',2.02),('15529','2014-04-13','15:25:00',1.98),('15529','2014-04-13','15:30:00',1.95),('15529','2014-04-13','15:35:00',1.92),('15529','2014-04-13','15:40:00',1.9),('15529','2014-04-13','15:45:00',1.86),('15529','2014-04-13','15:50:00',1.83),('15529','2014-04-13','15:55:00',1.8),('15529','2014-04-13','16:00:00',1.77),('15529','2014-04-13','16:05:00',1.74),('15529','2014-04-13','16:10:00',1.69),('15529','2014-04-13','16:15:00',1.65),('15529','2014-04-13','16:20:00',1.61),('15529','2014-04-13','16:25:00',1.57),('15529','2014-04-13','16:30:00',1.53),('15529','2014-04-13','16:35:00',1.48),('15529','2014-04-13','16:40:00',1.43),('15529','2014-04-13','16:45:00',1.4),('15529','2014-04-13','16:50:00',1.34),('15529','2014-04-13','16:55:00',1.29),('15529','2014-04-13','17:00:00',1.24),('15529','2014-04-13','17:05:00',1.19),('15529','2014-04-13','17:10:00',1.15),('15529','2014-04-13','17:15:00',1.1),('15529','2014-04-13','17:20:00',1.05),('15529','2013-09-27','09:15:00',1.04),('15529','2013-09-27','09:20:00',1.09),('15529','2013-09-27','09:25:00',1.14),('15529','2013-09-27','09:30:00',1.18),('15529','2013-09-27','09:35:00',1.06),('15529','2013-09-27','09:40:00',1.23),('15529','2013-09-27','09:45:00',1.27),('15529','2013-09-27','09:50:00',1.35),('15529','2013-09-27','10:00:00',1.45),('15529','2013-09-27','10:05:00',1),('15529','2013-09-27','10:10:00',1.65),('15529','2013-09-27','10:15:00',1.69),('15529','2013-09-27','10:20:00',1.8),('15529','2013-09-27','10:25:00',1.84),('15529','2013-09-27','10:30:00',1.52),('15529','2013-09-27','10:50:00',1.06),('15529','2013-09-27','10:55:00',1.4),('15529','2013-09-27','11:00:00',2.01),('15529','2013-09-27','11:05:00',1.49),('15529','2013-09-27','11:25:00',1.9),('15529','2013-09-27','11:30:00',2.09),('15529','2013-09-27','11:35:00',2.16),('15529','2013-09-27','11:40:00',2.21),('15529','2013-09-27','11:45:00',1.04),('15529','2013-09-27','11:50:00',1.85),('15529','2013-09-27','11:55:00',1.48),('15529','2013-09-27','12:00:00',2.17),('15529','2013-09-27','12:05:00',2.13),('15529','2013-09-27','12:10:00',1.99),('15529','2013-09-27','12:15:00',1.68),('15529','2013-09-27','12:30:00',1.2),('15529','2013-09-27','12:45:00',2.28),('15529','2013-09-27','12:50:00',1.4),('15529','2013-09-27','12:55:00',2.26),('15529','2013-09-27','13:00:00',2.17),('15529','2013-09-27','13:05:00',2.21),('15529','2013-09-27','13:10:00',2.03),('15529','2013-09-27','13:15:00',1.84),('15529','2013-09-27','13:20:00',2.08),('15529','2013-09-27','13:25:00',1.74),('15529','2013-09-27','13:30:00',1.42),('15529','2013-09-27','13:35:00',2.12),('15529','2013-09-27','13:40:00',2.32),('15529','2013-09-27','13:45:00',1.34),('15529','2013-09-27','13:50:00',1),('15529','2013-09-27','13:55:00',2.26),('15529','2013-09-27','14:00:00',2.25),('15529','2013-09-27','14:05:00',2.16),('15529','2013-09-27','14:10:00',2.15),('15529','2013-09-27','14:15:00',2.04),('15529','2013-09-27','14:20:00',2.07),('15529','2013-09-27','14:25:00',2.05),('15529','2013-09-27','14:30:00',2.05),('15529','2013-09-27','14:35:00',2.07),('15529','2013-09-27','14:40:00',2.02),('15529','2013-09-27','14:45:00',1.92),('15529','2013-09-27','14:50:00',1.87),('15529','2013-09-27','14:55:00',1.8),('15529','2013-09-27','15:00:00',1.78),('15529','2013-09-27','15:05:00',1.69),('15529','2013-09-27','15:10:00',1.71),('15529','2013-09-27','15:15:00',1.72),('15529','2013-09-27','15:20:00',1.66),('15529','2013-09-27','15:25:00',1.59),('15529','2013-09-27','15:30:00',1.58),('15529','2013-09-27','15:35:00',1.58),('15529','2013-09-27','15:40:00',1),('15529','2013-09-27','15:45:00',1.43),('15529','2013-09-27','15:50:00',1.45),('15529','2013-09-27','16:00:00',1.31),('15529','2013-09-27','16:05:00',1.11),('15529','2013-09-27','16:10:00',1.13),('15529','2013-09-27','16:15:00',1.11),('15529','2013-09-27','16:20:00',1.18),('15529','2013-09-27','16:25:00',1.11),('15529','2013-09-27','16:30:00',1.14),('15529','2013-09-27','16:35:00',1.08),('15529','2013-09-27','16:40:00',1.05),('15529','2013-09-26','09:55:00',1.11),('15529','2013-09-26','10:05:00',1.01),('15529','2013-09-26','10:10:00',1.12),('15529','2013-09-26','10:15:00',1.05),('15529','2013-09-26','10:40:00',1.07),('15529','2013-09-26','10:45:00',1.15),('15529','2013-09-26','10:50:00',1.82),('15529','2013-09-26','10:55:00',1.51),('15529','2013-09-26','11:00:00',1.77),('15529','2013-09-26','11:05:00',1.19),('15529','2013-09-26','11:10:00',1.9),('15529','2013-09-26','11:15:00',1.94),('15529','2013-09-26','11:30:00',1.06),('15529','2013-09-26','11:40:00',1.21),('15529','2013-09-26','11:45:00',1.62),('15529','2013-09-26','11:50:00',2.05),('15529','2013-09-26','12:40:00',1.21),('15529','2013-09-26','12:45:00',2.09),('15529','2013-09-26','12:50:00',2.08),('15529','2013-09-26','12:55:00',1.37),('15529','2013-09-26','13:00:00',2.05),('15529','2013-09-26','13:05:00',1.06),('15529','2013-09-26','13:15:00',1.26),('15529','2013-09-26','13:30:00',2.01),('15529','2013-09-26','13:35:00',2.28),('15529','2013-09-26','13:40:00',1.77),('15529','2013-09-26','13:50:00',2.39),('15529','2013-09-26','13:55:00',2.26),('15529','2013-09-26','14:00:00',2.11),('15529','2013-09-26','14:05:00',2.14),('15529','2013-09-26','14:10:00',2.13),('15529','2013-09-26','14:15:00',1.72),('15529','2013-09-26','14:20:00',1.75),('15529','2013-09-26','14:25:00',2.02),('15529','2013-09-26','14:30:00',1.91),('15529','2013-09-26','14:35:00',1.97),('15529','2013-09-26','14:40:00',1.99),('15529','2013-09-26','14:45:00',1.53),('15529','2013-09-26','14:50:00',1.09),('15529','2013-09-26','14:55:00',1.51),('15529','2013-09-26','15:00:00',1.92),('15529','2013-09-26','15:05:00',1.94),('15529','2013-09-26','15:10:00',1.65),('15529','2013-09-26','15:25:00',1.09),('15529','2013-09-26','15:45:00',1.56),('15529','2013-09-26','15:50:00',1.33),('15529','2013-09-26','16:10:00',1.44),('15529','2013-09-26','16:15:00',1.3),('15529','2013-09-26','16:20:00',1.28),('15529','2013-09-26','16:25:00',1.24),('15529','2013-09-26','16:30:00',1.17),('15529','2013-09-26','16:35:00',1.14),('15529','2013-09-26','16:45:00',1.03),('15529','2013-09-26','16:50:00',1),('15529','2013-09-25','09:00:00',1.03),('15529','2013-09-25','09:05:00',1.04),('15529','2013-09-25','09:10:00',1.06),('15529','2013-09-25','09:15:00',1.1),('15529','2013-09-25','09:20:00',1.13),('15529','2013-09-25','09:25:00',1.18),('15529','2013-09-25','09:30:00',1.24),('15529','2013-09-25','09:35:00',1.29),('15529','2013-09-25','09:40:00',1.33),('15529','2013-09-25','09:45:00',1.36),('15529','2013-09-25','09:50:00',1.4),('15529','2013-09-25','09:55:00',1.45),('15529','2013-09-25','10:00:00',1.48),('15529','2013-09-25','10:05:00',1.51),('15529','2013-09-25','10:10:00',1.52),('15529','2013-09-25','10:15:00',1.54),('15529','2013-09-25','10:20:00',1.59),('15529','2013-09-25','10:25:00',1.61),('15529','2013-09-25','10:30:00',1.64),('15529','2013-09-25','10:35:00',1.65),('15529','2013-09-25','10:40:00',1.69),('15529','2013-09-25','10:45:00',1.73),('15529','2013-09-25','10:50:00',1.76),('15529','2013-09-25','10:55:00',1.79),('15529','2013-09-25','11:00:00',1.8),('15529','2013-09-25','11:05:00',1.85),('15529','2013-09-25','11:10:00',1.85),('15529','2013-09-25','11:15:00',1.85),('15529','2013-09-25','11:20:00',1.79),('15529','2013-09-25','11:25:00',1.85),('15529','2013-09-25','11:30:00',1.72),('15529','2013-09-25','11:35:00',1.76),('15529','2013-09-25','11:40:00',2.05),('15529','2013-09-25','11:45:00',1.96),('15529','2013-09-25','11:50:00',1.69),('15529','2013-09-25','11:55:00',2.09),('15529','2013-09-25','12:00:00',1.81),('15529','2013-09-25','12:05:00',1.21),('15529','2013-09-25','12:20:00',1.02),('15529','2013-09-25','12:40:00',1.35),('15529','2013-09-25','12:45:00',1.29),('15529','2013-09-25','12:50:00',1.95),('15529','2013-09-25','12:55:00',2.27),('15529','2013-09-25','13:00:00',1.33),('15529','2013-09-25','13:05:00',1.47),('15529','2013-09-25','13:10:00',1.45),('15529','2013-09-25','13:15:00',1.99),('15529','2013-09-25','13:25:00',1.37),('15529','2013-09-25','13:30:00',1.69),('15529','2013-09-25','13:40:00',1.19),('15529','2013-09-25','13:45:00',1.19),('15529','2013-09-25','14:00:00',2.08),('15529','2013-09-25','14:05:00',1.53),('15529','2013-09-25','14:10:00',1.56),('15529','2013-09-25','14:25:00',1.56),('15529','2013-09-25','14:30:00',1.22),('15529','2013-09-25','14:35:00',1.61),('15529','2013-09-25','14:40:00',2.04),('15529','2013-09-25','14:45:00',2.02),('15529','2013-09-25','14:50:00',1.49),('15529','2013-09-25','14:55:00',1.7),('15529','2013-09-25','15:00:00',1.44),('15529','2013-09-25','15:15:00',1.89),('15529','2013-09-25','15:25:00',1.02),('15529','2013-09-25','15:30:00',1.14),('15529','2013-09-25','15:50:00',1.66),('15529','2013-09-25','15:55:00',1.14),('15529','2013-09-25','16:15:00',1.28),('15529','2013-09-25','16:20:00',1.17),('15529','2013-09-25','16:25:00',1.23),('15529','2013-09-25','16:30:00',1.19),('15529','2013-09-25','16:35:00',1.14),('15529','2013-09-25','16:40:00',1.07),('15529','2013-09-25','16:45:00',1.04),('15529','2013-09-24','09:30:00',1.26),('15529','2013-09-24','09:35:00',1.13),('15529','2013-09-24','10:00:00',1.63),('15529','2013-09-24','10:20:00',1.62),('15529','2013-09-24','10:25:00',1.9),('15529','2013-09-24','10:30:00',1.93),('15529','2013-09-24','10:35:00',1.89),('15529','2013-09-24','10:40:00',1.88),('15529','2013-09-24','11:00:00',1.8),('15529','2013-09-24','11:05:00',1.98),('15529','2013-09-24','11:10:00',1.93),('15529','2013-09-24','11:15:00',1.97),('15529','2013-09-24','11:20:00',2.04),('15529','2013-09-24','11:25:00',2.04),('15529','2013-09-24','11:30:00',1.79),('15529','2013-09-24','11:55:00',1.08),('15529','2013-09-24','12:00:00',2.11),('15529','2013-09-24','12:10:00',1.11),('15529','2013-09-24','12:15:00',1.86),('15529','2013-09-24','12:20:00',2.37),('15529','2013-09-24','12:25:00',1.58),('15529','2013-09-24','12:40:00',2.17),('15529','2013-09-24','12:45:00',1.03),('15529','2013-09-24','12:50:00',1.65),('15529','2013-09-24','12:55:00',1.91),('15529','2013-09-24','13:00:00',1.2),('15529','2013-09-24','13:10:00',1.1),('15529','2013-09-24','13:15:00',2.56),('15529','2013-09-24','13:20:00',2.49),('15529','2013-09-24','13:25:00',2.47),('15529','2013-09-24','13:30:00',2.36),('15529','2013-09-24','13:35:00',2.29),('15529','2013-09-24','13:40:00',2.23),('15529','2013-09-24','13:45:00',1.93),('15529','2013-09-24','13:50:00',1.2),('15529','2013-09-24','13:55:00',1.15),('15529','2013-09-24','14:00:00',1.1),('15529','2013-09-24','14:20:00',1.06),('15529','2013-09-24','14:30:00',2.27),('15529','2013-09-24','14:35:00',2.19),('15529','2013-09-24','14:40:00',1.19),('15529','2013-09-24','14:45:00',2.03),('15529','2013-09-24','14:50:00',2.23),('15529','2013-09-24','14:55:00',2.08),('15529','2013-09-24','15:00:00',1.99),('15529','2013-09-24','15:05:00',1.14),('15529','2013-09-24','15:10:00',1.72),('15529','2013-09-24','15:15:00',1.88),('15529','2013-09-24','15:20:00',1.77),('15529','2013-09-24','15:25:00',1.32),('15529','2013-09-24','15:35:00',1.7),('15529','2013-09-24','15:40:00',1.75),('15529','2013-09-24','15:50:00',1.59),('15529','2013-09-24','15:55:00',1.64),('15529','2013-09-24','16:00:00',1.56),('15529','2013-09-24','16:05:00',1.38),('15529','2013-09-24','16:10:00',1.46),('15529','2013-09-24','16:15:00',1.41),('15529','2013-09-24','16:20:00',1.37),('15529','2013-09-24','16:25:00',1.34),('15529','2013-09-24','16:30:00',1.27),('15529','2013-09-24','16:35:00',1.15),('15529','2013-09-24','16:40:00',1.17),('15529','2013-09-24','16:45:00',1.11),('15529','2013-09-24','16:50:00',1.05),('15529','2013-09-24','16:55:00',1.02),('15529','2013-09-23','09:00:00',1.03),('15529','2013-09-23','09:05:00',1.08),('15529','2013-09-23','09:10:00',1.12),('15529','2013-09-23','09:15:00',1.17),('15529','2013-09-23','09:20:00',1.22),('15529','2013-09-23','09:25:00',1.28),('15529','2013-09-23','09:30:00',1.31),('15529','2013-09-23','09:35:00',1.36),('15529','2013-09-23','09:40:00',1.4),('15529','2013-09-23','09:45:00',1.43),('15529','2013-09-23','09:50:00',1.47),('15529','2013-09-23','09:55:00',1.51),('15529','2013-09-23','10:00:00',1.54),('15529','2013-09-23','10:05:00',1.58),('15529','2013-09-23','10:10:00',1.61),('15529','2013-09-23','10:15:00',1.64),('15529','2013-09-23','10:20:00',1.68),('15529','2013-09-23','10:25:00',1.7),('15529','2013-09-23','10:30:00',1.73),('15529','2013-09-23','10:35:00',1.77),('15529','2013-09-23','10:40:00',1.8),('15529','2013-09-23','10:45:00',1.81),('15529','2013-09-23','10:50:00',1.83),('15529','2013-09-23','10:55:00',1.89),('15529','2013-09-23','11:00:00',1.88),('15529','2013-09-23','11:05:00',1.89),('15529','2013-09-23','11:10:00',1.93),('15529','2013-09-23','11:15:00',1.93),('15529','2013-09-23','11:20:00',1.98),('15529','2013-09-23','11:25:00',2),('15529','2013-09-23','11:30:00',2),('15529','2013-09-23','11:35:00',2.01),('15529','2013-09-23','11:40:00',2.06),('15529','2013-09-23','11:45:00',2.02),('15529','2013-09-23','11:50:00',2.03),('15529','2013-09-23','11:55:00',2.04),('15529','2013-09-23','12:00:00',2.07),('15529','2013-09-23','12:05:00',2.1),('15529','2013-09-23','12:10:00',2.13),('15529','2013-09-23','12:15:00',2.11),('15529','2013-09-23','12:20:00',2.13),('15529','2013-09-23','12:25:00',2.11),('15529','2013-09-23','12:30:00',2.14),('15529','2013-09-23','12:35:00',2.15),('15529','2013-09-23','12:40:00',2.15),('15529','2013-09-23','12:45:00',2.18),('15529','2013-09-23','12:50:00',2.2),('15529','2013-09-23','12:55:00',2.17),('15529','2013-09-23','13:00:00',2.19),('15529','2013-09-23','13:05:00',2.19),('15529','2013-09-23','13:10:00',2.18),('15529','2013-09-23','13:15:00',2.17),('15529','2013-09-23','13:20:00',2.15),('15529','2013-09-23','13:25:00',2.19),('15529','2013-09-23','13:30:00',2.17),('15529','2013-09-23','13:35:00',2.17),('15529','2013-09-23','13:40:00',2.13),('15529','2013-09-23','13:45:00',2.15),('15529','2013-09-23','13:50:00',2.13),('15529','2013-09-23','13:55:00',2.12),('15529','2013-09-23','14:00:00',2.12),('15529','2013-09-23','14:05:00',2.07),('15529','2013-09-23','14:10:00',2.07),('15529','2013-09-23','14:15:00',2.06),('15529','2013-09-23','14:20:00',2.02),('15529','2013-09-23','14:25:00',2.03),('15529','2013-09-23','14:30:00',2.01),('15529','2013-09-23','14:35:00',1.96),('15529','2013-09-23','14:40:00',1.95),('15529','2013-09-23','14:45:00',1.93),('15529','2013-09-23','14:50:00',1.93),('15529','2013-09-23','14:55:00',1.91),('15529','2013-09-23','15:00:00',1.87),('15529','2013-09-23','15:05:00',1.84),('15529','2013-09-23','15:10:00',1.82),('15529','2013-09-23','15:15:00',1.81),('15529','2013-09-23','15:20:00',1.8),('15529','2013-09-23','15:25:00',1.75),('15529','2013-09-23','15:30:00',1.72),('15529','2013-09-23','15:35:00',1.7),('15529','2013-09-23','15:40:00',1.66),('15529','2013-09-23','15:45:00',1.63),('15529','2013-09-23','15:50:00',1.59),('15529','2013-09-23','15:55:00',1.56),('15529','2013-09-23','16:00:00',1.52),('15529','2013-09-23','16:05:00',1.48),('15529','2013-09-23','16:10:00',1.45),('15529','2013-09-23','16:15:00',1.41),('15529','2013-09-23','16:20:00',1.37),('15529','2013-09-23','16:25:00',1.35),('15529','2013-09-23','16:30:00',1.29),('15529','2013-09-23','16:35:00',1.25),('15529','2013-09-23','16:40:00',1.19),('15529','2013-09-23','16:45:00',1.16),('15529','2013-09-23','16:50:00',1.09),('15529','2013-09-23','16:55:00',1.04),('15529','2013-09-22','09:00:00',1.05),('15529','2013-09-22','09:05:00',1.1),('15529','2013-09-22','09:10:00',1.14),('15529','2013-09-22','09:15:00',1.19),('15529','2013-09-22','09:20:00',1.24),('15529','2013-09-22','09:25:00',1.28),('15529','2013-09-22','09:30:00',1.32),('15529','2013-09-22','09:35:00',1.37),('15529','2013-09-22','09:40:00',1.4),('15529','2013-09-22','09:45:00',1.44),('15529','2013-09-22','09:50:00',1.48),('15529','2013-09-22','09:55:00',1.52),('15529','2013-09-22','10:00:00',1.56),('15529','2013-09-22','10:05:00',1.6),('15529','2013-09-22','10:10:00',1.63),('15529','2013-09-22','10:15:00',1.66),('15529','2013-09-22','10:20:00',1.7),('15529','2013-09-22','10:25:00',1.74),('15529','2013-09-22','10:30:00',1.75),('15529','2013-09-22','10:35:00',1.79),('15529','2013-09-22','10:40:00',1.83),('15529','2013-09-22','10:45:00',1.86),('15529','2013-09-22','10:50:00',1.87),('15529','2013-09-22','10:55:00',1.9),('15529','2013-09-22','11:00:00',1.92),('15529','2013-09-22','11:05:00',1.95),('15529','2013-09-22','11:10:00',1.98),('15529','2013-09-22','11:15:00',2),('15529','2013-09-22','11:20:00',2),('15529','2013-09-22','11:25:00',2.04),('15529','2013-09-22','11:30:00',2.05),('15529','2013-09-22','11:35:00',2.07),('15529','2013-09-22','11:40:00',2.08),('15529','2013-09-22','11:45:00',2.13),('15529','2013-09-22','11:50:00',2.13),('15529','2013-09-22','11:55:00',2.15),('15529','2013-09-22','12:00:00',2.17),('15529','2013-09-22','12:05:00',2.18),('15529','2013-09-22','12:10:00',2.17),('15529','2013-09-22','12:15:00',2.18),('15529','2013-09-22','12:20:00',2.2),('15529','2013-09-22','12:25:00',2.19),('15529','2013-09-22','12:30:00',2.22),('15529','2013-09-22','12:35:00',2.23),('15529','2013-09-22','12:40:00',2.23),('15529','2013-09-22','12:45:00',2.22),('15529','2013-09-22','12:50:00',2.22),('15529','2013-09-22','12:55:00',2.22),('15529','2013-09-22','13:00:00',2.22),('15529','2013-09-22','13:05:00',2.19),('15529','2013-09-22','13:10:00',2.18),('15529','2013-09-22','13:15:00',2.19),('15529','2013-09-22','13:20:00',2.17),('15529','2013-09-22','13:25:00',2.18),('15529','2013-09-22','13:30:00',2.18),('15529','2013-09-22','13:35:00',2.15),('15529','2013-09-22','13:40:00',2.13),('15529','2013-09-22','13:45:00',2.12),('15529','2013-09-22','13:50:00',2.14),('15529','2013-09-22','13:55:00',2.1),('15529','2013-09-22','14:00:00',2.08),('15529','2013-09-22','14:05:00',2.08),('15529','2013-09-22','14:10:00',2.07),('15529','2013-09-22','14:15:00',2.07),('15529','2013-09-22','14:20:00',2.07),('15529','2013-09-22','14:25:00',2.02),('15529','2013-09-22','14:30:00',1.68),('15529','2013-09-22','14:35:00',2),('15529','2013-09-22','14:40:00',1.98),('15529','2013-09-22','14:45:00',1.94),('15529','2013-09-22','14:50:00',1.91),('15529','2013-09-22','14:55:00',1.9),('15529','2013-09-22','15:00:00',1.88),('15529','2013-09-22','15:05:00',1.87),('15529','2013-09-22','15:10:00',1.85),('15529','2013-09-22','15:15:00',1.81),('15529','2013-09-22','15:20:00',1.77),('15529','2013-09-22','15:25:00',1.73),('15529','2013-09-22','15:30:00',1.7),('15529','2013-09-22','15:35:00',1.66),('15529','2013-09-22','15:40:00',1.65),('15529','2013-09-22','15:45:00',1.62),('15529','2013-09-22','15:50:00',1.56),('15529','2013-09-22','15:55:00',1.52),('15529','2013-09-22','16:00:00',1.49),('15529','2013-09-22','16:05:00',1.43),('15529','2013-09-22','16:10:00',1.2),('15529','2013-09-22','16:20:00',1.28),('15529','2013-09-22','16:25:00',1.28),('15529','2013-09-22','16:30:00',1.23),('15529','2013-09-22','16:35:00',1.2),('15529','2013-09-22','16:40:00',1.14),('15529','2013-09-22','16:45:00',1.09),('15529','2013-09-22','16:50:00',1.05),('15529','2013-09-22','16:55:00',1.01),('15529','2013-09-21','09:00:00',1.03),('15529','2013-09-21','09:05:00',1.08),('15529','2013-09-21','09:10:00',1.12),('15529','2013-09-21','09:15:00',1.18),('15529','2013-09-21','09:20:00',1.23),('15529','2013-09-21','09:25:00',1.27),('15529','2013-09-21','09:30:00',1.31),('15529','2013-09-21','09:35:00',1.37),('15529','2013-09-21','09:40:00',1.4),('15529','2013-09-21','09:45:00',1.44),('15529','2013-09-21','09:50:00',1.47),('15529','2013-09-21','09:55:00',1.51),('15529','2013-09-21','10:00:00',1.55),('15529','2013-09-21','10:05:00',1.6),('15529','2013-09-21','10:10:00',1.65),('15529','2013-09-21','10:15:00',1.68),('15529','2013-09-21','10:20:00',1.72),('15529','2013-09-21','10:25:00',1.75),('15529','2013-09-21','10:30:00',1.76),('15529','2013-09-21','10:35:00',1.81),('15529','2013-09-21','10:40:00',1.83),('15529','2013-09-21','10:45:00',1.85),('15529','2013-09-21','10:50:00',1.89),('15529','2013-09-21','10:55:00',1.9),('15529','2013-09-21','11:00:00',1.95),('15529','2013-09-21','11:05:00',1.95),('15529','2013-09-21','11:10:00',1.97),('15529','2013-09-21','11:15:00',2.01),('15529','2013-09-21','11:20:00',2),('15529','2013-09-21','11:25:00',2.04),('15529','2013-09-21','11:30:00',2.07),('15529','2013-09-21','11:35:00',2.07),('15529','2013-09-21','11:40:00',2.11),('15529','2013-09-21','11:45:00',2.12),('15529','2013-09-21','11:50:00',2.12),('15529','2013-09-21','11:55:00',2.14),('15529','2013-09-21','12:00:00',2.13),('15529','2013-09-21','12:05:00',2.17),('15529','2013-09-21','12:10:00',2.19),('15529','2013-09-21','12:15:00',2.19),('15529','2013-09-21','12:20:00',2.21),('15529','2013-09-21','12:25:00',2.21),('15529','2013-09-21','12:30:00',2.21),('15529','2013-09-21','12:35:00',2.21),('15529','2013-09-21','12:40:00',2.25),('15529','2013-09-21','12:45:00',2.26),('15529','2013-09-21','12:50:00',2.25),('15529','2013-09-21','12:55:00',2.24),('15529','2013-09-21','13:00:00',2.22),('15529','2013-09-21','13:05:00',2.23),('15529','2013-09-21','13:10:00',2.21),('15529','2013-09-21','13:15:00',2.24),('15529','2013-09-21','13:20:00',2.21),('15529','2013-09-21','13:25:00',2.21),('15529','2013-09-21','13:30:00',2.22),('15529','2013-09-21','13:35:00',2.17),('15529','2013-09-21','13:40:00',2.18),('15529','2013-09-21','13:45:00',2.15),('15529','2013-09-21','13:50:00',2.16),('15529','2013-09-21','13:55:00',2.16),('15529','2013-09-21','14:00:00',2.18),('15529','2013-09-21','14:05:00',2.18),('15529','2013-09-21','14:10:00',2.15),('15529','2013-09-21','14:15:00',1.92),('15529','2013-09-21','14:20:00',1.66),('15529','2013-09-21','14:25:00',1.44),('15529','2013-09-21','14:35:00',1.07),('15529','2013-09-21','14:40:00',2.14),('15529','2013-09-21','14:45:00',2.03),('15529','2013-09-21','14:50:00',1.97),('15529','2013-09-21','14:55:00',1.99),('15529','2013-09-21','15:00:00',2),('15529','2013-09-21','15:05:00',2.01),('15529','2013-09-21','15:10:00',1.97),('15529','2013-09-21','15:15:00',1.35),('15529','2013-09-21','15:20:00',1.91),('15529','2013-09-21','15:25:00',2.02),('15529','2013-09-21','15:35:00',1.59),('15529','2013-09-21','15:40:00',1.87),('15529','2013-09-21','15:45:00',1.7),('15529','2013-09-21','15:50:00',1.61),('15529','2013-09-21','15:55:00',1.6),('15529','2013-09-21','16:00:00',1.63),('15529','2013-09-21','16:05:00',1.66),('15529','2013-09-21','16:10:00',1.57),('15529','2013-09-21','16:15:00',1.62),('15529','2013-09-21','16:20:00',1.32),('15529','2013-09-21','16:55:00',1.07),('15529','2013-09-21','17:00:00',1.15),('15529','2013-09-21','17:05:00',1.06),('15529','2013-09-20','09:00:00',1.01),('15529','2013-09-20','09:05:00',1.06),('15529','2013-09-20','09:10:00',1.11),('15529','2013-09-20','09:15:00',1.16),('15529','2013-09-20','09:20:00',1.21),('15529','2013-09-20','09:25:00',1.25),('15529','2013-09-20','09:30:00',1.29),('15529','2013-09-20','09:35:00',1.33),('15529','2013-09-20','09:40:00',1.36),('15529','2013-09-20','09:45:00',1.42),('15529','2013-09-20','09:50:00',1.45),('15529','2013-09-20','09:55:00',1.49),('15529','2013-09-20','10:00:00',1.53),('15529','2013-09-20','10:05:00',1.57),('15529','2013-09-20','10:10:00',1.6),('15529','2013-09-20','10:15:00',1.62),('15529','2013-09-20','10:20:00',1.66),('15529','2013-09-20','10:25:00',1.7),('15529','2013-09-20','10:30:00',1.72),('15529','2013-09-20','10:35:00',1.75),('15529','2013-09-20','10:40:00',1.78),('15529','2013-09-20','10:45:00',1.77),('15529','2013-09-20','10:50:00',1.83),('15529','2013-09-20','10:55:00',1.87),('15529','2013-09-20','11:00:00',1.88),('15529','2013-09-20','11:05:00',1.91),('15529','2013-09-20','11:10:00',1.93),('15529','2013-09-20','11:15:00',1.96),('15529','2013-09-20','11:20:00',1.98),('15529','2013-09-20','11:25:00',2),('15529','2013-09-20','11:30:00',2.04),('15529','2013-09-20','11:35:00',2.04),('15529','2013-09-20','11:40:00',2.05),('15529','2013-09-20','11:45:00',2.09),('15529','2013-09-20','11:50:00',2.08),('15529','2013-09-20','11:55:00',2.08),('15529','2013-09-20','12:00:00',2.13),('15529','2013-09-20','12:05:00',2.12),('15529','2013-09-20','12:10:00',2.16),('15529','2013-09-20','12:15:00',2.17),('15529','2013-09-20','12:20:00',1.98),('15529','2013-09-20','12:25:00',2.15),('15529','2013-09-20','12:30:00',2.24),('15529','2013-09-20','12:35:00',2.16),('15529','2013-09-20','12:40:00',2.14),('15529','2013-09-20','12:45:00',2.16),('15529','2013-09-20','12:50:00',2.16),('15529','2013-09-20','12:55:00',2.22),('15529','2013-09-20','13:00:00',2.18),('15529','2013-09-20','13:05:00',2.14),('15529','2013-09-20','13:10:00',2.19),('15529','2013-09-20','13:15:00',2.19),('15529','2013-09-20','13:20:00',1.92),('15529','2013-09-20','13:25:00',2.09),('15529','2013-09-20','13:30:00',2.1),('15529','2013-09-20','13:35:00',2.08),('15529','2013-09-20','13:40:00',1.9),('15529','2013-09-20','13:45:00',1.88),('15529','2013-09-20','13:50:00',1.96),('15529','2013-09-20','13:55:00',1.79),('15529','2013-09-20','14:00:00',2.13),('15529','2013-09-20','14:05:00',2.02),('15529','2013-09-20','14:10:00',2.04),('15529','2013-09-20','14:15:00',2.11),('15529','2013-09-20','14:20:00',2.08),('15529','2013-09-20','14:25:00',2.03),('15529','2013-09-20','14:30:00',2.02),('15529','2013-09-20','14:35:00',2.01),('15529','2013-09-20','14:40:00',1.97),('15529','2013-09-20','14:45:00',1.97),('15529','2013-09-20','14:50:00',1.92),('15529','2013-09-20','14:55:00',1.92),('15529','2013-09-20','15:00:00',1.89),('15529','2013-09-20','15:05:00',1.87),('15529','2013-09-20','15:10:00',1.79),('15529','2013-09-20','15:15:00',1.8),('15529','2013-09-20','15:20:00',1.78),('15529','2013-09-20','15:25:00',1.75),('15529','2013-09-20','15:30:00',1.73),('15529','2013-09-20','15:35:00',1.68),('15529','2013-09-20','15:40:00',1.48),('15529','2013-09-20','15:45:00',1.35),('15529','2013-09-20','15:50:00',1.56),('15529','2013-09-20','15:55:00',1.37),('15529','2013-09-19','10:05:00',1.04),('15529','2013-09-19','10:10:00',1.2),('15529','2013-09-19','10:15:00',1.35),('15529','2013-09-19','10:20:00',1.07),('15529','2013-09-19','10:30:00',1.02),('15529','2013-09-19','10:35:00',1.18),('15529','2013-09-19','10:40:00',1.19),('15529','2013-09-19','10:45:00',1.12),('15529','2013-09-19','10:50:00',1.01),('15529','2013-09-19','10:55:00',1.02),('15529','2013-09-19','11:00:00',1.11),('15529','2013-09-19','11:05:00',1.03),('15529','2013-09-19','11:10:00',1.07),('15529','2013-09-19','11:15:00',1.51),('15529','2013-09-19','11:20:00',1.68),('15529','2013-09-19','11:25:00',2.4),('15529','2013-09-19','11:30:00',2.01),('15529','2013-09-19','11:35:00',1.59),('15529','2013-09-19','11:40:00',2.3),('15529','2013-09-19','11:45:00',2.32),('15529','2013-09-19','11:50:00',2.26),('15529','2013-09-19','11:55:00',2.15),('15529','2013-09-19','12:00:00',2.1),('15529','2013-09-19','12:05:00',2.11),('15529','2013-09-19','12:10:00',2.21),('15529','2013-09-19','12:15:00',2.3),('15529','2013-09-19','12:20:00',1.63),('15529','2013-09-19','12:25:00',2.11),('15529','2013-09-19','12:30:00',1.89),('15529','2013-09-19','12:35:00',1.95),('15529','2013-09-19','12:40:00',2.1),('15529','2013-09-19','12:45:00',2.33),('15529','2013-09-19','12:50:00',2.04),('15529','2013-09-19','12:55:00',1.4),('15529','2013-09-19','13:00:00',2.27),('15529','2013-09-19','13:05:00',2.16),('15529','2013-09-19','13:10:00',2.24),('15529','2013-09-19','13:15:00',2.29),('15529','2013-09-19','13:20:00',2.24),('15529','2013-09-19','13:25:00',2.18),('15529','2013-09-19','13:30:00',1.96),('15529','2013-09-19','13:35:00',2.18),('15529','2013-09-19','13:40:00',2.25),('15529','2013-09-19','13:45:00',2.19),('15529','2013-09-19','13:50:00',1.8),('15529','2013-09-19','13:55:00',2.08),('15529','2013-09-19','14:00:00',2.16),('15529','2013-09-19','14:05:00',2.22),('15529','2013-09-19','14:10:00',2.06),('15529','2013-09-19','14:15:00',1.06),('15529','2013-09-19','14:20:00',1.3),('15529','2013-09-19','14:45:00',1.48),('15529','2013-09-19','14:50:00',1.94),('15529','2013-09-19','14:55:00',1.92),('15529','2013-09-19','15:00:00',1.98),('15529','2013-09-19','15:05:00',1.52),('15529','2013-09-19','15:10:00',1.56),('15529','2013-09-19','15:15:00',2.05),('15529','2013-09-19','15:20:00',1.78),('15529','2013-09-19','15:30:00',1.03),('15529','2013-09-19','15:35:00',1.2),('15529','2013-09-19','15:40:00',1.88),('15529','2013-09-19','15:45:00',1.76),('15529','2013-09-19','15:50:00',1.4),('15529','2013-09-19','15:55:00',1.48),('15529','2013-09-19','16:00:00',1.72),('15529','2013-09-19','16:05:00',1.55),('15529','2013-09-19','16:15:00',1.39),('15529','2013-09-19','16:20:00',1.53),('15529','2013-09-19','16:25:00',1.04),('15529','2013-09-19','16:45:00',1.29),('15529','2013-09-19','16:50:00',1.35),('15529','2013-09-19','16:55:00',1.21),('15529','2013-09-19','17:00:00',1.12),('15529','2013-09-18','09:10:00',1.1),('15529','2013-09-18','09:15:00',1.09),('15529','2013-09-18','10:05:00',1.15),('15529','2013-09-18','10:25:00',1.16),('15529','2013-09-18','10:30:00',1.19),('15529','2013-09-18','10:40:00',1.44),('15529','2013-09-18','10:50:00',2.04),('15529','2013-09-18','10:55:00',1.72),('15529','2013-09-18','11:00:00',1.14),('15529','2013-09-18','11:10:00',1.31),('15529','2013-09-18','11:15:00',2.16),('15529','2013-09-18','11:20:00',2.23),('15529','2013-09-18','11:25:00',1.75),('15529','2013-09-18','11:30:00',1.93),('15529','2013-09-18','11:35:00',1.23),('15529','2013-09-18','11:40:00',1.21),('15529','2013-09-18','11:45:00',2.26),('15529','2013-09-18','11:50:00',1.68),('15529','2013-09-18','11:55:00',1.93),('15529','2013-09-18','12:00:00',1.35),('15529','2013-09-18','12:05:00',1.73),('15529','2013-09-18','12:10:00',1.56),('15529','2013-09-18','12:15:00',2.46),('15529','2013-09-18','12:20:00',2.38),('15529','2013-09-18','12:25:00',2.33),('15529','2013-09-18','12:30:00',2.09),('15529','2013-09-18','12:35:00',1.67),('15529','2013-09-18','12:40:00',1.53),('15529','2013-09-18','12:45:00',2.43),('15529','2013-09-18','12:50:00',2.37),('15529','2013-09-18','12:55:00',2.41),('15529','2013-09-18','13:00:00',2.43),('15529','2013-09-18','13:05:00',2.54),('15529','2013-09-18','13:10:00',1.95),('15529','2013-09-18','13:15:00',1.46),('15529','2013-09-18','13:20:00',1.04),('15529','2013-09-18','13:25:00',2.35),('15529','2013-09-18','13:30:00',2.36),('15529','2013-09-18','13:35:00',2.41),('15529','2013-09-18','13:40:00',2.53),('15529','2013-09-18','13:45:00',2.39),('15529','2013-09-18','14:00:00',1.78),('15529','2013-09-18','14:05:00',2.11),('15529','2013-09-18','14:10:00',2.02),('15529','2013-09-18','14:15:00',2.06),('15529','2013-09-18','14:20:00',2.05),('15529','2013-09-18','14:25:00',2.12),('15529','2013-09-18','14:30:00',2.08),('15529','2013-09-18','14:35:00',2.07),('15529','2013-09-18','14:40:00',1.91),('15529','2013-09-18','14:45:00',2.03),('15529','2013-09-18','14:50:00',2.03),('15529','2013-09-18','14:55:00',1.86),('15529','2013-09-18','15:00:00',1.46),('15529','2013-09-18','15:05:00',1.66),('15529','2013-09-18','15:10:00',1.98),('15529','2013-09-18','15:15:00',1.79),('15529','2013-09-18','15:20:00',1.81),('15529','2013-09-18','15:25:00',1.29),('15529','2013-09-18','15:30:00',1.16),('15529','2013-09-18','15:35:00',1.84),('15529','2013-09-18','15:40:00',1.56),('15529','2013-09-18','15:45:00',1.78),('15529','2013-09-18','15:50:00',1.64),('15529','2013-09-18','15:55:00',1.37),('15529','2013-09-18','16:00:00',1.6),('15529','2013-09-18','16:10:00',1.47),('15529','2013-09-18','16:15:00',1.41),('15529','2013-09-18','16:25:00',1.22),('15529','2013-09-18','16:40:00',1.19),('15529','2013-09-18','16:50:00',1.1),('15529','2013-09-18','16:55:00',1.03),('15529','2014-04-12','09:55:00',1.03),('15529','2014-04-12','10:00:00',1.35),('15529','2014-04-12','10:05:00',1.39),('15529','2014-04-12','10:10:00',1.23),('15529','2014-04-12','10:15:00',1.47),('15529','2014-04-12','10:20:00',1.27),('15529','2014-04-12','10:25:00',1.08),('15529','2014-04-12','10:30:00',1.52),('15529','2014-04-12','10:35:00',1.95),('15529','2014-04-12','10:40:00',1.94),('15529','2014-04-12','10:45:00',1.92),('15529','2014-04-12','10:50:00',2.04),('15529','2014-04-12','10:55:00',2.07),('15529','2014-04-12','11:00:00',2.11),('15529','2014-04-12','11:05:00',2.18),('15529','2014-04-12','11:10:00',2.16),('15529','2014-04-12','11:15:00',2.21),('15529','2014-04-12','11:20:00',1.92),('15529','2014-04-12','11:25:00',1.69),('15529','2014-04-12','11:30:00',2.24),('15529','2014-04-12','11:35:00',1.74),('15529','2014-04-12','11:40:00',2.27),('15529','2014-04-12','11:45:00',2.11),('15529','2014-04-12','11:50:00',1.72),('15529','2014-04-12','11:55:00',1.06),('15529','2014-04-12','12:00:00',1.48),('15529','2014-04-12','13:10:00',1.08),('15529','2014-04-12','13:15:00',1.58),('15529','2014-04-12','13:20:00',2.25),('15529','2014-04-12','13:25:00',2.39),('15529','2014-04-12','13:30:00',2.26),('15529','2014-04-12','13:35:00',2.26),('15529','2014-04-12','13:40:00',1.98),('15529','2014-04-12','13:45:00',1.07),('15529','2014-04-12','13:50:00',2.06),('15529','2014-04-12','13:55:00',2.07),('15529','2014-04-12','14:00:00',2.13),('15529','2014-04-12','14:05:00',2.31),('15529','2014-04-12','14:10:00',2.09),('15529','2014-04-12','14:15:00',1.46),('15529','2014-04-12','14:45:00',1.25),('15529','2014-04-12','14:50:00',2.27),('15529','2014-04-12','14:55:00',2.02),('15529','2014-04-12','15:00:00',1.6),('15529','2014-04-12','15:05:00',2.15),('15529','2014-04-12','15:10:00',2.04),('15529','2014-04-12','15:15:00',1.68),('15529','2014-04-12','15:20:00',1.85),('15529','2014-04-12','15:25:00',2),('15529','2014-04-12','15:30:00',1.61),('15529','2014-04-12','15:40:00',1.18),('15529','2014-04-12','15:45:00',1.01),('15529','2014-04-12','15:55:00',1.27),('15529','2014-04-12','16:00:00',1.72),('15529','2014-04-12','16:25:00',1.06),('15529','2014-04-12','16:40:00',1.41),('15529','2014-04-12','16:45:00',1.15),('15529','2014-04-12','16:55:00',1.18),('15529','2013-09-17','09:35:00',1.15),('15529','2013-09-17','09:45:00',1.45),('15529','2013-09-17','10:05:00',1.2),('15529','2013-09-17','10:10:00',1.61),('15529','2013-09-17','10:15:00',1.65),('15529','2013-09-17','10:20:00',1.67),('15529','2013-09-17','10:25:00',1.7),('15529','2013-09-17','10:30:00',1.71),('15529','2013-09-17','10:35:00',1.74),('15529','2013-09-17','10:40:00',1.79),('15529','2013-09-17','10:45:00',1.81),('15529','2013-09-17','10:50:00',1.86),('15529','2013-09-17','10:55:00',1.9),('15529','2013-09-17','11:00:00',1.99),('15529','2013-09-17','11:05:00',1.98),('15529','2013-09-17','11:10:00',2.06),('15529','2013-09-17','11:15:00',2.05),('15529','2013-09-17','11:20:00',1.95),('15529','2013-09-17','11:25:00',1.99),('15529','2013-09-17','11:30:00',1.72),('15529','2013-09-17','11:35:00',1.82),('15529','2013-09-17','11:40:00',2.14),('15529','2013-09-17','11:45:00',2.12),('15529','2013-09-17','11:50:00',2.11),('15529','2013-09-17','11:55:00',2.12),('15529','2013-09-17','12:00:00',2.16),('15529','2013-09-17','12:05:00',2.27),('15529','2013-09-17','12:10:00',1.47),('15529','2013-09-17','12:25:00',1.95),('15529','2013-09-17','12:35:00',1.52),('15529','2013-09-17','12:40:00',1.02),('15529','2013-09-17','12:45:00',2.23),('15529','2013-09-17','12:50:00',1.39),('15529','2013-09-17','12:55:00',1.96),('15529','2013-09-17','13:00:00',2.48),('15529','2013-09-17','13:05:00',2.39),('15529','2013-09-17','13:10:00',2.35),('15529','2013-09-17','13:15:00',2.3),('15529','2013-09-17','13:20:00',2.3),('15529','2013-09-17','13:25:00',2.39),('15529','2013-09-17','13:30:00',2.39),('15529','2013-09-17','13:35:00',1.9),('15529','2013-09-17','13:40:00',2.16),('15529','2013-09-17','13:45:00',1.98),('15529','2013-09-17','13:50:00',1.27),('15529','2013-09-17','13:55:00',1.73),('15529','2013-09-17','14:00:00',2.08),('15529','2013-09-17','14:05:00',2.14),('15529','2013-09-17','14:10:00',2.28),('15529','2013-09-17','14:15:00',2.08),('15529','2013-09-17','14:20:00',2.15),('15529','2013-09-17','14:25:00',2.15),('15529','2013-09-17','14:30:00',1.85),('15529','2013-09-17','14:35:00',2.11),('15529','2013-09-17','14:40:00',2.11),('15529','2013-09-17','14:45:00',1.25),('15529','2013-09-17','14:50:00',2.11),('15529','2013-09-17','14:55:00',2.07),('15529','2013-09-17','15:00:00',2.03),('15529','2013-09-17','15:05:00',1.12),('15529','2013-09-17','15:10:00',2.02),('15529','2013-09-17','15:15:00',1.36),('15529','2013-09-17','15:20:00',1.99),('15529','2013-09-17','15:25:00',1.96),('15529','2013-09-17','15:30:00',1.69),('15529','2013-09-17','15:35:00',1.64),('15529','2013-09-17','15:40:00',1.39),('15529','2013-09-17','15:45:00',1.67),('15529','2013-09-17','15:50:00',1.63),('15529','2013-09-17','15:55:00',1.68),('15529','2013-09-17','16:00:00',1.45),('15529','2013-09-17','16:05:00',1.6),('15529','2013-09-17','16:10:00',1.4),('15529','2013-09-17','16:15:00',1.41),('15529','2013-09-17','16:20:00',1.39),('15529','2013-09-17','16:25:00',1.28),('15529','2013-09-17','16:30:00',1.19),('15529','2013-09-17','16:35:00',1.11),('15529','2013-09-17','16:40:00',1.21),('15529','2013-09-17','16:45:00',1.15),('15529','2013-09-17','16:50:00',1),('15529','2013-09-17','17:00:00',1.05),('15529','2013-09-16','09:45:00',1.11),('15529','2013-09-16','09:55:00',1.17),('15529','2013-09-16','10:05:00',1.42),('15529','2013-09-16','10:45:00',2.07),('15529','2013-09-16','10:50:00',2.11),('15529','2013-09-16','10:55:00',1.59),('15529','2013-09-16','11:00:00',1.15),('15529','2013-09-16','11:05:00',1.27),('15529','2013-09-16','11:10:00',2.01),('15529','2013-09-16','11:15:00',1.42),('15529','2013-09-16','11:20:00',1.26),('15529','2013-09-16','11:30:00',1.12),('15529','2013-09-16','11:35:00',1.74),('15529','2013-09-16','11:40:00',1.66),('15529','2013-09-16','11:45:00',1.4),('15529','2013-09-16','11:50:00',1.46),('15529','2013-09-16','11:55:00',2.05),('15529','2013-09-16','12:00:00',1.98),('15529','2013-09-16','12:05:00',2.13),('15529','2013-09-16','12:10:00',1.1),('15529','2013-09-16','12:15:00',1.48),('15529','2013-09-16','12:20:00',1.91),('15529','2013-09-16','12:25:00',2.01),('15529','2013-09-16','12:30:00',1.03),('15529','2013-09-16','12:35:00',1.25),('15529','2013-09-16','12:40:00',2.02),('15529','2013-09-16','12:45:00',2),('15529','2013-09-16','12:50:00',1.11),('15529','2013-09-16','12:55:00',2.04),('15529','2013-09-16','13:00:00',1),('15529','2013-09-16','13:10:00',2.13),('15529','2013-09-16','13:15:00',1.25),('15529','2013-09-16','13:20:00',1.14),('15529','2013-09-16','13:25:00',1.23),('15529','2013-09-16','13:30:00',1.05),('15529','2013-09-16','13:35:00',1.33),('15529','2013-09-16','14:50:00',1.09),('15529','2013-09-16','14:55:00',2.01),('15529','2013-09-16','15:00:00',1.81),('15529','2013-09-16','15:05:00',1.36),('15529','2013-09-16','15:10:00',1.45),('15529','2013-09-16','15:15:00',1.67),('15529','2013-09-16','15:20:00',1.66),('15529','2013-09-16','15:25:00',1.47),('15529','2013-09-16','15:50:00',1.07),('15529','2013-09-16','17:05:00',1.03),('15529','2013-09-15','09:15:00',1.16),('15529','2013-09-15','09:20:00',1.08),('15529','2013-09-15','09:30:00',1.32),('15529','2013-09-15','09:35:00',1.36),('15529','2013-09-15','09:40:00',1.39),('15529','2013-09-15','09:45:00',1.44),('15529','2013-09-15','09:50:00',1.49),('15529','2013-09-15','09:55:00',1.56),('15529','2013-09-15','10:00:00',1.61),('15529','2013-09-15','10:10:00',1.05),('15529','2013-09-15','10:15:00',1.4),('15529','2013-09-15','10:20:00',1.4),('15529','2013-09-15','10:25:00',1.82),('15529','2013-09-15','10:30:00',1.85),('15529','2013-09-15','10:35:00',1.98),('15529','2013-09-15','10:40:00',2.06),('15529','2013-09-15','10:45:00',2.17),('15529','2013-09-15','10:55:00',1.48),('15529','2013-09-15','11:15:00',1.76),('15529','2013-09-15','11:20:00',2.11),('15529','2013-09-15','11:25:00',2.25),('15529','2013-09-15','11:30:00',2.33),('15529','2013-09-15','11:35:00',2.18),('15529','2013-09-15','11:40:00',2.05),('15529','2013-09-15','11:45:00',2.22),('15529','2013-09-15','11:50:00',2.23),('15529','2013-09-15','11:55:00',2.27),('15529','2013-09-15','12:00:00',2.15),('15529','2013-09-15','12:05:00',1.87),('15529','2013-09-15','12:10:00',2.5),('15529','2013-09-15','12:15:00',2.3),('15529','2013-09-15','12:20:00',2.11),('15529','2013-09-15','12:25:00',2.32),('15529','2013-09-15','12:30:00',2.32),('15529','2013-09-15','12:35:00',2.29),('15529','2013-09-15','12:40:00',2.44),('15529','2013-09-15','12:45:00',2.47),('15529','2013-09-15','12:50:00',2.53),('15529','2013-09-15','12:55:00',1.83),('15529','2013-09-15','13:00:00',2.68),('15529','2013-09-15','13:05:00',2.44),('15529','2013-09-15','13:10:00',2.33),('15529','2013-09-15','13:15:00',2.3),('15529','2013-09-15','13:20:00',2.28),('15529','2013-09-15','13:25:00',2.28),('15529','2013-09-15','13:30:00',2.26),('15529','2013-09-15','13:35:00',2.27),('15529','2013-09-15','13:40:00',2.29),('15529','2013-09-15','13:45:00',2.3),('15529','2013-09-15','13:50:00',2.33),('15529','2013-09-15','13:55:00',2.26),('15529','2013-09-15','14:00:00',2.13),('15529','2013-09-15','14:05:00',2.16),('15529','2013-09-15','14:10:00',2.2),('15529','2013-09-15','14:15:00',2.2),('15529','2013-09-15','14:20:00',2.15),('15529','2013-09-15','14:25:00',2.12),('15529','2013-09-15','14:30:00',2.12),('15529','2013-09-15','14:35:00',2.1),('15529','2013-09-15','14:40:00',2.07),('15529','2013-09-15','14:45:00',2.05),('15529','2013-09-15','14:50:00',2),('15529','2013-09-15','14:55:00',2),('15529','2013-09-15','15:00:00',1.98),('15529','2013-09-15','15:05:00',1.97),('15529','2013-09-15','15:10:00',1.94),('15529','2013-09-15','15:15:00',1.92),('15529','2013-09-15','15:20:00',1.87),('15529','2013-09-15','15:25:00',1.85),('15529','2013-09-15','15:30:00',1.82),('15529','2013-09-15','15:35:00',1.78),('15529','2013-09-15','15:40:00',1.76),('15529','2013-09-15','15:45:00',1.72),('15529','2013-09-15','15:50:00',1.68),('15529','2013-09-15','15:55:00',1.41),('15529','2013-09-15','16:00:00',1.09),('15529','2013-09-15','16:05:00',1.64),('15529','2013-09-15','16:10:00',1.54),('15529','2013-09-15','16:15:00',1.49),('15529','2013-09-15','16:20:00',1.46),('15529','2013-09-15','16:25:00',1.42),('15529','2013-09-15','16:30:00',1.37),('15529','2013-09-15','16:35:00',1.33),('15529','2013-09-15','16:40:00',1.29),('15529','2013-09-15','16:45:00',1.25),('15529','2013-09-15','16:50:00',1.19),('15529','2013-09-15','16:55:00',1.15),('15529','2013-09-15','17:00:00',1.09),('15529','2013-09-15','17:05:00',1.04),('15529','2013-09-14','09:05:00',1.03),('15529','2013-09-14','09:10:00',1.13),('15529','2013-09-14','09:15:00',1.22),('15529','2013-09-14','09:20:00',1.19),('15529','2013-09-14','09:25:00',1.27),('15529','2013-09-14','09:30:00',1.27),('15529','2013-09-14','09:35:00',1.35),('15529','2013-09-14','09:40:00',1.39),('15529','2013-09-14','09:45:00',1.43),('15529','2013-09-14','09:50:00',1.43),('15529','2013-09-14','09:55:00',1.53),('15529','2013-09-14','10:00:00',1.54),('15529','2013-09-14','10:05:00',1.6),('15529','2013-09-14','10:10:00',1.58),('15529','2013-09-14','10:15:00',1.62),('15529','2013-09-14','10:20:00',1.66),('15529','2013-09-14','10:25:00',1.67),('15529','2013-09-14','10:30:00',1.43),('15529','2013-09-14','10:35:00',1.64),('15529','2013-09-14','10:40:00',1.91),('15529','2013-09-14','10:45:00',1.89),('15529','2013-09-14','10:50:00',2.08),('15529','2013-09-14','10:55:00',1.9),('15529','2013-09-14','11:00:00',1.43),('15529','2013-09-14','11:05:00',1.17),('15529','2013-09-14','11:10:00',1.87),('15529','2013-09-14','11:15:00',2.03),('15529','2013-09-14','11:20:00',2.16),('15529','2013-09-14','11:25:00',1.64),('15529','2013-09-14','11:35:00',1.96),('15529','2013-09-14','11:40:00',2.44),('15529','2013-09-14','11:45:00',2.39),('15529','2013-09-14','12:25:00',1.11),('15529','2013-09-14','13:20:00',1.21),('15529','2013-09-14','13:45:00',1.02),('15529','2013-09-14','13:50:00',1.07),('15529','2013-09-14','14:00:00',1.16),('15529','2013-09-14','15:15:00',1.33),('15529','2013-09-13','09:00:00',1.02),('15529','2013-09-13','09:05:00',1.07),('15529','2013-09-13','09:10:00',1.11),('15529','2013-09-13','09:15:00',1.17),('15529','2013-09-13','09:20:00',1.21),('15529','2013-09-13','09:25:00',1.26),('15529','2013-09-13','09:30:00',1.31),('15529','2013-09-13','09:35:00',1.35),('15529','2013-09-13','09:40:00',1.38),('15529','2013-09-13','09:45:00',1.43),('15529','2013-09-13','09:50:00',1.45),('15529','2013-09-13','09:55:00',1.5),('15529','2013-09-13','10:00:00',1.52),('15529','2013-09-13','10:05:00',1.51),('15529','2013-09-13','10:10:00',1.48),('15529','2013-09-13','10:15:00',1.52),('15529','2013-09-13','10:20:00',1.58),('15529','2013-09-13','10:25:00',1.7),('15529','2013-09-13','10:30:00',1.5),('15529','2013-09-13','10:35:00',1.1),('15529','2013-09-13','10:40:00',1.82),('15529','2013-09-13','11:00:00',2.01),('15529','2013-09-13','11:05:00',1.85),('15529','2013-09-13','11:10:00',1.89),('15529','2013-09-13','11:15:00',2),('15529','2013-09-13','11:20:00',1.82),('15529','2013-09-13','11:25:00',2.1),('15529','2013-09-13','11:30:00',2.1),('15529','2013-09-13','11:35:00',1.92),('15529','2013-09-13','11:40:00',2.2),('15529','2013-09-13','11:45:00',1.71),('15529','2013-09-13','12:00:00',1.15),('15529','2013-09-13','12:05:00',1.44),('15529','2013-09-13','12:10:00',1.71),('15529','2013-09-13','12:15:00',1.51),('15529','2013-09-13','12:25:00',2.17),('15529','2013-09-13','12:30:00',1.42),('15529','2013-09-13','12:40:00',2.24),('15529','2013-09-13','12:45:00',1.16),('15529','2013-09-13','12:50:00',2.38),('15529','2013-09-13','12:55:00',2.4),('15529','2013-09-13','13:00:00',1.37),('15529','2013-09-13','13:05:00',2.39),('15529','2013-09-13','13:10:00',2.39),('15529','2013-09-13','13:15:00',2.36),('15529','2013-09-13','13:20:00',2.19),('15529','2013-09-13','13:25:00',2.26),('15529','2013-09-13','13:30:00',2.07),('15529','2013-09-13','13:35:00',1.21),('15529','2013-09-13','13:40:00',1.09),('15529','2013-09-13','13:45:00',1.64),('15529','2013-09-13','13:50:00',2.41),('15529','2013-09-13','13:55:00',2.38),('15529','2013-09-13','14:00:00',2.29),('15529','2013-09-13','14:05:00',2.18),('15529','2013-09-13','14:10:00',2.14),('15529','2013-09-13','14:15:00',2.12),('15529','2013-09-13','14:20:00',2.12),('15529','2013-09-13','14:25:00',2.1),('15529','2013-09-13','14:30:00',2.09),('15529','2013-09-13','14:35:00',2.07),('15529','2013-09-13','14:40:00',2.05),('15529','2013-09-13','14:45:00',2.03),('15529','2013-09-13','14:50:00',2.02),('15529','2013-09-13','14:55:00',1.99),('15529','2013-09-13','15:00:00',1.98),('15529','2013-09-13','15:05:00',1.93),('15529','2013-09-13','15:10:00',1.9),('15529','2013-09-13','15:15:00',1.89),('15529','2013-09-13','15:20:00',1.87),('15529','2013-09-13','15:25:00',1.83),('15529','2013-09-13','15:30:00',1.8),('15529','2013-09-13','15:35:00',1.77),('15529','2013-09-13','15:40:00',1.72),('15529','2013-09-13','15:45:00',1.7),('15529','2013-09-13','15:50:00',1.68),('15529','2013-09-13','15:55:00',1.64),('15529','2013-09-13','16:00:00',1.59),('15529','2013-09-13','16:05:00',1.54),('15529','2013-09-13','16:10:00',1.52),('15529','2013-09-13','16:15:00',1.46),('15529','2013-09-13','16:20:00',1.44),('15529','2013-09-13','16:25:00',1.39),('15529','2013-09-13','16:30:00',1.36),('15529','2013-09-13','16:35:00',1.32),('15529','2013-09-13','16:40:00',1.26),('15529','2013-09-13','16:45:00',1.21),('15529','2013-09-13','16:50:00',1.04),('15529','2013-09-13','17:00:00',1.09),('15529','2013-09-13','17:05:00',1.03),('15529','2013-09-12','09:55:00',1.2),('15529','2013-09-12','10:05:00',1.18),('15529','2013-09-12','10:10:00',1.93),('15529','2013-09-12','10:15:00',1.21),('15529','2013-09-12','10:25:00',1.77),('15529','2013-09-12','10:30:00',1.68),('15529','2013-09-12','10:35:00',1.48),('15529','2013-09-12','10:40:00',1.84),('15529','2013-09-12','10:45:00',1.85),('15529','2013-09-12','10:50:00',1.88),('15529','2013-09-12','10:55:00',1.91),('15529','2013-09-12','11:00:00',1.95),('15529','2013-09-12','11:05:00',1.96),('15529','2013-09-12','11:10:00',1.97),('15529','2013-09-12','11:15:00',2.03),('15529','2013-09-12','11:20:00',2.05),('15529','2013-09-12','11:25:00',2.01),('15529','2013-09-12','11:30:00',2.06),('15529','2013-09-12','11:35:00',2.12),('15529','2013-09-12','11:40:00',2.12),('15529','2013-09-12','11:45:00',2.12),('15529','2013-09-12','11:50:00',2.12),('15529','2013-09-12','11:55:00',2.19),('15529','2013-09-12','12:00:00',2.16),('15529','2013-09-12','12:05:00',2.2),('15529','2013-09-12','12:10:00',2.2),('15529','2013-09-12','12:20:00',1.84),('15529','2013-09-12','12:25:00',2.35),('15529','2013-09-12','12:30:00',2.38),('15529','2013-09-12','12:35:00',2.33),('15529','2013-09-12','12:40:00',2.36),('15529','2013-09-12','12:45:00',2.3),('15529','2013-09-12','12:50:00',2.03),('15529','2013-09-12','13:00:00',1.73),('15529','2013-09-12','13:05:00',1.55),('15529','2013-09-12','13:10:00',2.33),('15529','2013-09-12','13:15:00',2.25),('15529','2013-09-12','13:20:00',2.23),('15529','2013-09-12','13:25:00',2.23),('15529','2013-09-12','13:30:00',2.2),('15529','2013-09-12','13:35:00',2.16),('15529','2013-09-12','13:40:00',2.23),('15529','2013-09-12','13:45:00',2.18),('15529','2013-09-12','13:50:00',2.21),('15529','2013-09-12','13:55:00',2.06),('15529','2013-09-12','14:00:00',2.15),('15529','2013-09-12','14:05:00',1.29),('15529','2013-09-12','14:10:00',2.14),('15529','2013-09-12','14:15:00',1.64),('15529','2013-09-12','14:20:00',1.86),('15529','2013-09-12','14:25:00',1.99),('15529','2013-09-12','14:30:00',2.12),('15529','2013-09-12','14:35:00',2.1),('15529','2013-09-12','14:40:00',2.04),('15529','2013-09-12','14:45:00',2.07),('15529','2013-09-12','14:50:00',2.03),('15529','2013-09-12','14:55:00',1.98),('15529','2013-09-12','15:00:00',1.97),('15529','2013-09-12','15:05:00',1.94),('15529','2013-09-12','15:10:00',1.93),('15529','2013-09-12','15:15:00',1.9),('15529','2013-09-12','15:20:00',1.86),('15529','2013-09-12','15:25:00',1.84),('15529','2013-09-12','15:30:00',1.81),('15529','2013-09-12','15:35:00',1.8),('15529','2013-09-12','15:40:00',1.75),('15529','2013-09-12','15:45:00',1.71),('15529','2013-09-12','15:50:00',1.69),('15529','2013-09-12','15:55:00',1.65),('15529','2013-09-12','16:00:00',1.61),('15529','2013-09-12','16:05:00',1.58),('15529','2013-09-12','16:10:00',1.53),('15529','2013-09-12','16:15:00',1.5),('15529','2013-09-12','16:20:00',1.45),('15529','2013-09-12','16:25:00',1.41),('15529','2013-09-12','16:30:00',1.37),('15529','2013-09-12','16:35:00',1.32),('15529','2013-09-12','16:40:00',1.28),('15529','2013-09-12','16:45:00',1.23),('15529','2013-09-12','16:50:00',1.17),('15529','2013-09-12','16:55:00',1.13),('15529','2013-09-12','17:00:00',1.07),('15529','2013-09-12','17:05:00',1.03),('15529','2013-09-11','09:00:00',1.03),('15529','2013-09-11','09:15:00',1.08),('15529','2013-09-11','09:20:00',1.1),('15529','2013-09-11','09:25:00',1.22),('15529','2013-09-11','09:30:00',1.33),('15529','2013-09-11','09:35:00',1.06),('15529','2013-09-11','09:45:00',1.06),('15529','2013-09-11','10:10:00',1.25),('15529','2013-09-11','10:15:00',1.04),('15529','2013-09-11','10:30:00',1.42),('15529','2013-09-11','10:55:00',1.09),('15529','2013-09-11','11:00:00',1.59),('15529','2013-09-11','11:05:00',1.86),('15529','2013-09-11','11:10:00',1.81),('15529','2013-09-11','11:15:00',1.6),('15529','2013-09-11','11:50:00',1.37),('15529','2013-09-11','11:55:00',1.75),('15529','2013-09-11','12:00:00',1.6),('15529','2013-09-11','12:05:00',2.17),('15529','2013-09-11','12:10:00',2.37),('15529','2013-09-11','12:15:00',1.53),('15529','2013-09-11','12:35:00',2.19),('15529','2013-09-11','12:40:00',1.13),('15529','2013-09-11','12:50:00',1.62),('15529','2013-09-11','12:55:00',2.45),('15529','2013-09-11','13:00:00',1.7),('15529','2013-09-11','13:05:00',1.96),('15529','2013-09-11','13:10:00',2.05),('15529','2013-09-11','13:15:00',2.48),('15529','2013-09-11','13:20:00',2.41),('15529','2013-09-11','13:25:00',1.42),('15529','2013-09-11','13:30:00',1.74),('15529','2013-09-11','13:35:00',1.7),('15529','2013-09-11','13:40:00',1.13),('15529','2013-09-11','13:45:00',1.89),('15529','2013-09-11','13:50:00',2.28),('15529','2013-09-11','13:55:00',2.28),('15529','2013-09-11','14:00:00',1.98),('15529','2013-09-11','14:05:00',2.09),('15529','2013-09-11','14:10:00',2.22),('15529','2013-09-11','14:15:00',2.26),('15529','2013-09-11','14:20:00',2.24),('15529','2013-09-11','14:25:00',2.14),('15529','2013-09-11','14:30:00',1.83),('15529','2013-09-11','14:35:00',1.32),('15529','2013-09-11','14:40:00',2.26),('15529','2013-09-11','14:45:00',1.14),('15529','2013-09-11','14:55:00',1.61),('15529','2013-09-11','15:00:00',1.36),('15529','2013-09-11','15:05:00',1.06),('15529','2013-09-11','15:10:00',1.83),('15529','2013-09-11','15:15:00',1.93),('15529','2013-09-11','15:20:00',1.71),('15529','2013-09-11','15:25:00',1.91),('15529','2013-09-11','15:30:00',1.87),('15529','2013-09-11','15:35:00',1.81),('15529','2013-09-11','15:40:00',1.81),('15529','2013-09-11','15:45:00',1.75),('15529','2013-09-11','15:50:00',1.77),('15529','2013-09-11','15:55:00',1.67),('15529','2013-09-11','16:05:00',1.75),('15529','2013-09-11','16:10:00',1.48),('15529','2013-09-11','16:15:00',1.23),('15529','2013-09-11','16:20:00',1.38),('15529','2013-09-11','16:25:00',1.05),('15529','2013-09-11','16:35:00',1.28),('15529','2013-09-11','16:40:00',1.42),('15529','2013-09-11','16:50:00',1.01),('15529','2013-09-11','16:55:00',1.01),('15529','2013-09-11','17:00:00',1.29),('15529','2013-09-10','09:05:00',1.05),('15529','2013-09-10','09:10:00',1.32),('15529','2013-09-10','09:15:00',1.29),('15529','2013-09-10','09:20:00',1.02),('15529','2013-09-10','10:10:00',1.01),('15529','2013-09-10','10:15:00',1.5),('15529','2013-09-10','10:20:00',1.72),('15529','2013-09-10','10:25:00',1.76),('15529','2013-09-10','10:30:00',1.8),('15529','2013-09-10','10:35:00',1.24),('15529','2013-09-10','10:40:00',1.82),('15529','2013-09-10','10:45:00',1.67),('15529','2013-09-10','10:50:00',1.42),('15529','2013-09-10','11:00:00',1),('15529','2013-09-10','11:05:00',1.88),('15529','2013-09-10','11:15:00',1.82),('15529','2013-09-10','11:20:00',1.65),('15529','2013-09-10','11:25:00',1.1),('15529','2013-09-10','11:30:00',1.32),('15529','2013-09-10','11:35:00',2.23),('15529','2013-09-10','11:40:00',2.17),('15529','2013-09-10','11:45:00',2.13),('15529','2013-09-10','11:50:00',1.72),('15529','2013-09-10','11:55:00',2.32),('15529','2013-09-10','12:00:00',1.45),('15529','2013-09-10','12:05:00',1.84),('15529','2013-09-10','12:15:00',1.47),('15529','2013-09-10','12:20:00',1.4),('15529','2013-09-10','12:25:00',1.59),('15529','2013-09-10','12:30:00',1.82),('15529','2013-09-10','12:35:00',1.42),('15529','2013-09-10','12:40:00',1.01),('15529','2013-09-10','12:45:00',2.04),('15529','2013-09-10','12:55:00',1.84),('15529','2013-09-10','13:00:00',2.25),('15529','2013-09-10','13:05:00',2.25),('15529','2013-09-10','13:10:00',2.5),('15529','2013-09-10','13:15:00',2.47),('15529','2013-09-10','13:20:00',2.44),('15529','2013-09-10','13:25:00',1.58),('15529','2013-09-10','13:30:00',1.63),('15529','2013-09-10','13:35:00',2.03),('15529','2013-09-10','13:40:00',1.67),('15529','2013-09-10','13:45:00',1.93),('15529','2013-09-10','13:50:00',1.66),('15529','2013-09-10','13:55:00',1.87),('15529','2013-09-10','14:00:00',2.24),('15529','2013-09-10','14:05:00',1.97),('15529','2013-09-10','14:10:00',2.24),('15529','2013-09-10','14:15:00',2.08),('15529','2013-09-10','14:20:00',2.14),('15529','2013-09-10','14:30:00',1.93),('15529','2013-09-10','14:35:00',1.27),('15529','2013-09-10','14:40:00',1.62),('15529','2013-09-10','14:45:00',2.33),('15529','2013-09-10','14:50:00',2.21),('15529','2013-09-10','14:55:00',1.56),('15529','2013-09-10','15:00:00',1.64),('15529','2013-09-10','15:05:00',1.77),('15529','2013-09-10','15:10:00',1.75),('15529','2013-09-10','15:15:00',1.14),('15529','2013-09-10','15:20:00',1.77),('15529','2013-09-10','15:25:00',1.57),('15529','2013-09-10','15:30:00',1.03),('15529','2013-09-10','15:35:00',1.15),('15529','2013-09-10','15:40:00',1.22),('15529','2013-09-10','15:45:00',1.97),('15529','2013-09-10','15:50:00',1.03),('15529','2013-09-10','15:55:00',1.3),('15529','2013-09-10','16:00:00',1.1),('15529','2013-09-10','16:05:00',1.27),('15529','2013-09-10','16:10:00',1.65),('15529','2013-09-10','16:15:00',1.56),('15529','2013-09-10','16:20:00',1.13),('15529','2013-09-10','16:30:00',1.16),('15529','2013-09-10','16:40:00',1.41),('15529','2013-09-10','16:50:00',1.18),('15529','2013-09-10','16:55:00',1.08),('15529','2013-09-10','17:00:00',1.16),('15529','2013-09-10','17:05:00',1.08),('15529','2013-09-10','17:10:00',1.01),('15529','2013-09-09','09:05:00',1.15),('15529','2013-09-09','09:10:00',1.26),('15529','2013-09-09','09:30:00',1.55),('15529','2013-09-09','09:35:00',1.21),('15529','2013-09-09','13:45:00',1.31),('15529','2013-09-09','14:25:00',1.25),('15529','2013-09-09','14:45:00',1.02),('15529','2013-09-09','14:50:00',1.25),('15529','2013-09-09','14:55:00',1.1),('15529','2013-09-09','15:00:00',1.4),('15529','2013-09-09','15:05:00',1.09),('15529','2013-09-09','15:20:00',1.06),('15529','2013-09-09','15:30:00',1.2),('15529','2013-09-08','10:45:00',1.05),('15529','2013-09-08','10:50:00',1.21),('15529','2013-09-08','10:55:00',1.04),('15529','2013-09-08','11:00:00',1.35),('15529','2013-09-08','11:05:00',1.09),('15529','2013-09-08','11:25:00',1.23),('15529','2013-09-08','11:30:00',1.08),('15529','2013-09-08','11:35:00',1.24),('15529','2013-09-08','11:55:00',1.24),('15529','2013-09-08','12:00:00',1.09),('15529','2013-09-08','12:05:00',1.15),('15529','2013-09-08','13:05:00',1.04),('15529','2013-09-08','13:10:00',1.83),('15529','2013-09-08','13:15:00',1.76),('15529','2013-09-08','13:20:00',1.59),('15529','2013-09-08','13:25:00',1.74),('15529','2013-09-08','13:30:00',2.07),('15529','2013-09-08','13:35:00',2.17),('15529','2013-09-08','13:40:00',2.04),('15529','2013-09-08','13:45:00',1.89),('15529','2013-09-08','13:50:00',2.18),('15529','2013-09-08','13:55:00',2.14),('15529','2013-09-08','14:00:00',2.01),('15529','2013-09-08','14:05:00',1.65),('15529','2013-09-08','14:10:00',1.02),('15529','2013-09-08','14:15:00',1.19),('15529','2013-09-08','14:30:00',1.87),('15529','2013-09-08','14:35:00',1.44),('15529','2013-09-08','14:40:00',2.06),('15529','2013-09-08','14:45:00',1.66),('15529','2013-09-08','14:50:00',1.09),('15529','2013-09-08','14:55:00',1.56),('15529','2013-09-08','15:00:00',1.63),('15529','2013-09-08','15:05:00',1.89),('15529','2013-09-08','15:10:00',1.75),('15529','2013-09-08','15:15:00',1.76),('15529','2013-09-08','15:20:00',1.78),('15529','2013-09-08','15:30:00',1.34),('15529','2013-09-08','15:35:00',1.35),('15529','2013-09-08','15:40:00',1.02),('15529','2013-09-08','15:45:00',1.01),('15529','2013-09-08','16:10:00',1.07),('15529','2013-09-08','16:15:00',1.31),('15529','2013-09-08','16:20:00',1.04),('15529','2014-04-11','09:30:00',1.1),('15529','2014-04-11','10:30:00',1.1),('15529','2014-04-11','10:35:00',1.08),('15529','2014-04-11','10:40:00',1.11),('15529','2014-04-11','10:45:00',1.16),('15529','2014-04-11','10:50:00',1.19),('15529','2014-04-11','10:55:00',1.28),('15529','2014-04-11','11:00:00',1.4),('15529','2014-04-11','11:05:00',1.93),('15529','2014-04-11','11:10:00',1.93),('15529','2014-04-11','11:15:00',1.91),('15529','2014-04-11','11:20:00',1.89),('15529','2014-04-11','11:25:00',2.06),('15529','2014-04-11','11:30:00',2.02),('15529','2014-04-11','11:35:00',2.11),('15529','2014-04-11','11:40:00',1.82),('15529','2014-04-11','11:45:00',1.61),('15529','2014-04-11','11:55:00',1.23),('15529','2014-04-11','12:10:00',1.4),('15529','2014-04-11','12:15:00',2.34),('15529','2014-04-11','12:20:00',1.98),('15529','2014-04-11','12:25:00',1.51),('15529','2014-04-11','12:30:00',1.29),('15529','2014-04-11','12:45:00',1.5),('15529','2014-04-11','12:50:00',2.1),('15529','2014-04-11','12:55:00',1.45),('15529','2014-04-11','13:00:00',1.03),('15529','2014-04-11','13:05:00',1.88),('15529','2014-04-11','13:10:00',1.8),('15529','2014-04-11','13:15:00',1.45),('15529','2014-04-11','13:20:00',1.12),('15529','2014-04-11','13:25:00',2.13),('15529','2014-04-11','13:30:00',2.58),('15529','2014-04-11','13:35:00',2.2),('15529','2014-04-11','13:40:00',1.96),('15529','2014-04-11','13:45:00',2.42),('15529','2014-04-11','13:50:00',2.07),('15529','2014-04-11','13:55:00',1.85),('15529','2014-04-11','14:00:00',2.19),('15529','2014-04-11','14:05:00',2.27),('15529','2014-04-11','14:10:00',1.28),('15529','2014-04-11','14:30:00',1.45),('15529','2014-04-11','14:35:00',1.02),('15529','2014-04-11','14:40:00',1.21),('15529','2014-04-11','14:45:00',2.12),('15529','2014-04-11','14:50:00',1.51),('15529','2014-04-11','14:55:00',1.92),('15529','2014-04-11','15:00:00',1.85),('15529','2014-04-11','15:05:00',2.01),('15529','2014-04-11','15:10:00',2.05),('15529','2014-04-11','15:15:00',1.8),('15529','2014-04-11','15:20:00',1.45),('15529','2014-04-11','15:25:00',1.55),('15529','2014-04-11','15:30:00',1.5),('15529','2014-04-11','15:35:00',1.15),('15529','2014-04-11','15:40:00',1.28),('15529','2014-04-11','15:45:00',1.74),('15529','2014-04-11','15:50:00',1.88),('15529','2014-04-11','15:55:00',1.87),('15529','2014-04-11','16:00:00',1.83),('15529','2014-04-11','16:05:00',1.8),('15529','2014-04-11','16:10:00',1.68),('15529','2014-04-11','16:15:00',1.55),('15529','2014-04-11','16:20:00',1.36),('15529','2014-04-11','16:25:00',1.37),('15529','2014-04-11','16:30:00',1.07),('15529','2014-04-11','16:35:00',1.42),('15529','2014-04-11','16:40:00',1.26),('15529','2014-04-11','16:45:00',1.26),('15529','2014-04-11','16:50:00',1.52),('15529','2014-04-11','16:55:00',1.16),('15529','2014-04-11','17:00:00',1.22),('15529','2014-04-11','17:05:00',1.14),('15529','2014-04-11','17:10:00',1.15),('15529','2014-04-11','17:30:00',1.05),('15529','2014-04-11','17:35:00',1.02),('15529','2013-09-07','09:30:00',1.1),('15529','2013-09-07','09:35:00',1.23),('15529','2013-09-07','09:40:00',1.27),('15529','2013-09-07','09:45:00',1.29),('15529','2013-09-07','09:50:00',1.32),('15529','2013-09-07','09:55:00',1.35),('15529','2013-09-07','10:00:00',1.41),('15529','2013-09-07','10:05:00',1.41),('15529','2013-09-07','10:10:00',1.47),('15529','2013-09-07','10:15:00',1.5),('15529','2013-09-07','10:20:00',1.58),('15529','2013-09-07','10:25:00',1.59),('15529','2013-09-07','10:30:00',1.63),('15529','2013-09-07','10:35:00',1.62),('15529','2013-09-07','10:40:00',1.66),('15529','2013-09-07','10:45:00',1.7),('15529','2013-09-07','10:50:00',1.73),('15529','2013-09-07','10:55:00',1.68),('15529','2013-09-07','11:00:00',1.76),('15529','2013-09-07','11:05:00',1.8),('15529','2013-09-07','11:10:00',1.78),('15529','2013-09-07','11:15:00',1.77),('15529','2013-09-07','11:20:00',1.79),('15529','2013-09-07','11:25:00',1.79),('15529','2013-09-07','11:30:00',1.87),('15529','2013-09-07','11:35:00',1.87),('15529','2013-09-07','11:40:00',1.87),('15529','2013-09-07','11:45:00',1.9),('15529','2013-09-07','11:50:00',1.86),('15529','2013-09-07','11:55:00',1.87),('15529','2013-09-07','12:00:00',1.75),('15529','2013-09-07','12:05:00',1.79),('15529','2013-09-07','12:10:00',1.94),('15529','2013-09-07','12:15:00',1.98),('15529','2013-09-07','12:20:00',1.98),('15529','2013-09-07','12:25:00',2.01),('15529','2013-09-07','12:30:00',2),('15529','2013-09-07','12:35:00',1.97),('15529','2013-09-07','12:40:00',1.97),('15529','2013-09-07','12:45:00',2.01),('15529','2013-09-07','12:50:00',2),('15529','2013-09-07','12:55:00',2.07),('15529','2013-09-07','13:00:00',1.98),('15529','2013-09-07','13:05:00',2.09),('15529','2013-09-07','13:10:00',2.06),('15529','2013-09-07','13:15:00',1.95),('15529','2013-09-07','13:20:00',2),('15529','2013-09-07','13:25:00',1.77),('15529','2013-09-07','13:30:00',1.83),('15529','2013-09-07','13:35:00',1.57),('15529','2013-09-07','13:40:00',1.06),('15529','2013-09-07','13:45:00',1.32),('15529','2013-09-07','13:50:00',1.82),('15529','2013-09-07','13:55:00',1.76),('15529','2013-09-07','14:00:00',1.88),('15529','2013-09-07','14:05:00',1.88),('15529','2013-09-07','14:10:00',1.91),('15529','2013-09-07','14:15:00',1.95),('15529','2013-09-07','14:20:00',2.18),('15529','2013-09-07','14:25:00',2.07),('15529','2013-09-07','14:30:00',1.99),('15529','2013-09-07','14:35:00',2.05),('15529','2013-09-07','14:40:00',1.97),('15529','2013-09-07','14:45:00',1.98),('15529','2013-09-07','14:50:00',1.96),('15529','2013-09-07','14:55:00',1.9),('15529','2013-09-07','15:00:00',1.9),('15529','2013-09-07','15:05:00',1.24),('15529','2013-09-07','15:15:00',1.64),('15529','2013-09-07','15:20:00',1.75),('15529','2013-09-07','15:25:00',1.84),('15529','2013-09-07','15:30:00',1.8),('15529','2013-09-07','15:35:00',1.72),('15529','2013-09-07','15:40:00',1.61),('15529','2013-09-07','15:45:00',1.67),('15529','2013-09-07','15:50:00',1.45),('15529','2013-09-07','15:55:00',1.36),('15529','2013-09-07','16:00:00',1.37),('15529','2013-09-07','16:05:00',1.3),('15529','2013-09-07','16:10:00',1.17),('15529','2013-09-07','16:15:00',1.36),('15529','2013-09-07','16:20:00',1.27),('15529','2013-09-07','16:25:00',1.15),('15529','2013-09-07','16:30:00',1.27),('15529','2013-09-07','16:35:00',1.12),('15529','2013-09-07','17:00:00',1.04),('15529','2013-09-07','17:05:00',1.08),('15529','2013-09-06','09:05:00',1),('15529','2013-09-06','09:10:00',1.05),('15529','2013-09-06','09:15:00',1.1),('15529','2013-09-06','09:20:00',1.16),('15529','2013-09-06','09:25:00',1.2),('15529','2013-09-06','09:30:00',1.23),('15529','2013-09-06','09:35:00',1.27),('15529','2013-09-06','09:40:00',1.3),('15529','2013-09-06','09:45:00',1.33),('15529','2013-09-06','09:50:00',1.37),('15529','2013-09-06','09:55:00',1.4),('15529','2013-09-06','10:00:00',1.44),('15529','2013-09-06','10:05:00',1.48),('15529','2013-09-06','10:10:00',1.5),('15529','2013-09-06','10:15:00',1.54),('15529','2013-09-06','10:20:00',1.58),('15529','2013-09-06','10:25:00',1.61),('15529','2013-09-06','10:30:00',1.62),('15529','2013-09-06','10:35:00',1.66),('15529','2013-09-06','10:40:00',1.69),('15529','2013-09-06','10:45:00',1.73),('15529','2013-09-06','10:50:00',1.75),('15529','2013-09-06','10:55:00',1.79),('15529','2013-09-06','11:00:00',1.8),('15529','2013-09-06','11:05:00',1.84),('15529','2013-09-06','11:10:00',1.81),('15529','2013-09-06','11:15:00',1.85),('15529','2013-09-06','11:20:00',1.88),('15529','2013-09-06','11:25:00',1.89),('15529','2013-09-06','11:30:00',1.94),('15529','2013-09-06','11:35:00',1.93),('15529','2013-09-06','11:40:00',1.93),('15529','2013-09-06','11:45:00',1.92),('15529','2013-09-06','11:50:00',1.94),('15529','2013-09-06','11:55:00',1.99),('15529','2013-09-06','12:00:00',1.97),('15529','2013-09-06','12:05:00',1.96),('15529','2013-09-06','12:10:00',1.94),('15529','2013-09-06','12:15:00',2.05),('15529','2013-09-06','12:20:00',2.02),('15529','2013-09-06','12:25:00',2.03),('15529','2013-09-06','12:30:00',2.01),('15529','2013-09-06','12:35:00',1.97),('15529','2013-09-06','12:40:00',2.05),('15529','2013-09-06','12:45:00',2.01),('15529','2013-09-06','12:50:00',2.05),('15529','2013-09-06','12:55:00',2.05),('15529','2013-09-06','13:00:00',2.05),('15529','2013-09-06','13:05:00',2.05),('15529','2013-09-06','13:10:00',2.05),('15529','2013-09-06','13:15:00',2.03),('15529','2013-09-06','13:20:00',2.04),('15529','2013-09-06','13:25:00',2.04),('15529','2013-09-06','13:30:00',2.06),('15529','2013-09-06','13:35:00',2.06),('15529','2013-09-06','13:40:00',2.07),('15529','2013-09-06','13:45:00',2.1),('15529','2013-09-06','13:50:00',2.09),('15529','2013-09-06','13:55:00',2.05),('15529','2013-09-06','14:00:00',2.06),('15529','2013-09-06','14:05:00',2.01),('15529','2013-09-06','14:10:00',2.01),('15529','2013-09-06','14:15:00',1.99),('15529','2013-09-06','14:20:00',1.97),('15529','2013-09-06','14:25:00',2.01),('15529','2013-09-06','14:30:00',1.99),('15529','2013-09-06','14:35:00',1.99),('15529','2013-09-06','14:40:00',2.01),('15529','2013-09-06','14:45:00',1.98),('15529','2013-09-06','14:50:00',1.93),('15529','2013-09-06','14:55:00',1.93),('15529','2013-09-06','15:00:00',1.91),('15529','2013-09-06','15:05:00',1.9),('15529','2013-09-06','15:10:00',1.84),('15529','2013-09-06','15:15:00',1.84),('15529','2013-09-06','15:20:00',1.82),('15529','2013-09-06','15:25:00',1.8),('15529','2013-09-06','15:30:00',1.78),('15529','2013-09-06','15:35:00',1.73),('15529','2013-09-06','15:40:00',1.69),('15529','2013-09-06','15:45:00',1.66),('15529','2013-09-06','15:50:00',1.61),('15529','2013-09-06','15:55:00',1.57),('15529','2013-09-06','16:00:00',1.53),('15529','2013-09-06','16:05:00',1.5),('15529','2013-09-06','16:10:00',1.45),('15529','2013-09-06','16:15:00',1.42),('15529','2013-09-06','16:20:00',1.37),('15529','2013-09-06','16:25:00',1.32),('15529','2013-09-06','16:30:00',1.28),('15529','2013-09-06','16:35:00',1.25),('15529','2013-09-06','16:40:00',1.21),('15529','2013-09-06','16:45:00',1.16),('15529','2013-09-06','16:50:00',1.11),('15529','2013-09-06','16:55:00',1.07),('15529','2013-09-06','17:00:00',1.03),('15529','2013-09-05','09:05:00',1.03),('15529','2013-09-05','09:10:00',1.07),('15529','2013-09-05','09:15:00',1.13),('15529','2013-09-05','09:20:00',1.17),('15529','2013-09-05','09:25:00',1.21),('15529','2013-09-05','09:30:00',1.24),('15529','2013-09-05','09:35:00',1.28),('15529','2013-09-05','09:40:00',1.33),('15529','2013-09-05','09:45:00',1.37),('15529','2013-09-05','09:50:00',1.4),('15529','2013-09-05','09:55:00',1.43),('15529','2013-09-05','10:00:00',1.48),('15529','2013-09-05','10:05:00',1.5),('15529','2013-09-05','10:10:00',1.55),('15529','2013-09-05','10:15:00',1.58),('15529','2013-09-05','10:20:00',1.6),('15529','2013-09-05','10:25:00',1.63),('15529','2013-09-05','10:30:00',1.68),('15529','2013-09-05','10:35:00',1.7),('15529','2013-09-05','10:40:00',1.75),('15529','2013-09-05','10:45:00',1.77),('15529','2013-09-05','10:50:00',1.81),('15529','2013-09-05','10:55:00',1.83),('15529','2013-09-05','11:00:00',1.83),('15529','2013-09-05','11:05:00',1.85),('15529','2013-09-05','11:10:00',1.88),('15529','2013-09-05','11:15:00',1.91),('15529','2013-09-05','11:20:00',1.92),('15529','2013-09-05','11:25:00',1.97),('15529','2013-09-05','11:30:00',1.94),('15529','2013-09-05','11:35:00',1.97),('15529','2013-09-05','11:40:00',1.96),('15529','2013-09-05','11:45:00',2.02),('15529','2013-09-05','11:50:00',2.01),('15529','2013-09-05','11:55:00',2.05),('15529','2013-09-05','12:00:00',2.05),('15529','2013-09-05','12:05:00',2.07),('15529','2013-09-05','12:10:00',2.1),('15529','2013-09-05','12:15:00',2.11),('15529','2013-09-05','12:20:00',2.07),('15529','2013-09-05','12:25:00',2.1),('15529','2013-09-05','12:30:00',2.09),('15529','2013-09-05','12:35:00',2.09),('15529','2013-09-05','12:40:00',2.12),('15529','2013-09-05','12:45:00',2.1),('15529','2013-09-05','12:50:00',2.11),('15529','2013-09-05','12:55:00',2.11),('15529','2013-09-05','13:00:00',2.11),('15529','2013-09-05','13:05:00',2.12),('15529','2013-09-05','13:10:00',2.15),('15529','2013-09-05','13:15:00',2.14),('15529','2013-09-05','13:20:00',2.08),('15529','2013-09-05','13:25:00',2.08),('15529','2013-09-05','13:30:00',2.08),('15529','2013-09-05','13:35:00',2.06),('15529','2013-09-05','13:40:00',2.07),('15529','2013-09-05','13:45:00',2.08),('15529','2013-09-05','13:50:00',2.09),('15529','2013-09-05','13:55:00',2.04),('15529','2013-09-05','14:00:00',2.02),('15529','2013-09-05','14:05:00',2.03),('15529','2013-09-05','14:10:00',2.02),('15529','2013-09-05','14:15:00',1.98),('15529','2013-09-05','14:20:00',1.83),('15529','2013-09-05','14:25:00',1.89),('15529','2013-09-05','14:30:00',1.93),('15529','2013-09-05','14:35:00',1.93),('15529','2013-09-05','14:40:00',1.91),('15529','2013-09-05','14:45:00',1.9),('15529','2013-09-05','14:50:00',1.89),('15529','2013-09-05','14:55:00',1.9),('15529','2013-09-05','15:00:00',1.88),('15529','2013-09-05','15:05:00',1.85),('15529','2013-09-05','15:10:00',1.83),('15529','2013-09-05','15:15:00',1.82),('15529','2013-09-05','15:20:00',1.81),('15529','2013-09-05','15:25:00',1.77),('15529','2013-09-05','15:30:00',1.72),('15529','2013-09-05','15:35:00',1.69),('15529','2013-09-05','15:40:00',1.65),('15529','2013-09-05','15:45:00',1.62),('15529','2013-09-05','15:50:00',1.59),('15529','2013-09-05','15:55:00',1.56),('15529','2013-09-05','16:00:00',1.53),('15529','2013-09-05','16:05:00',1.5),('15529','2013-09-05','16:10:00',1.46),('15529','2013-09-05','16:15:00',1.42),('15529','2013-09-05','16:20:00',1.38),('15529','2013-09-05','16:25:00',1.35),('15529','2013-09-05','16:30:00',1.3),('15529','2013-09-05','16:35:00',1.26),('15529','2013-09-05','16:40:00',1.23),('15529','2013-09-05','16:45:00',1.17),('15529','2013-09-05','16:50:00',1.13),('15529','2013-09-05','16:55:00',1.09),('15529','2013-09-05','17:00:00',1.04),('15529','2013-09-05','17:05:00',1),('15529','2013-09-04','08:55:00',1.01),('15529','2013-09-04','09:00:00',1.06),('15529','2013-09-04','09:05:00',1.1),('15529','2013-09-04','09:10:00',1.15),('15529','2013-09-04','09:15:00',1.19),('15529','2013-09-04','09:20:00',1.23),('15529','2013-09-04','09:25:00',1.28),('15529','2013-09-04','09:30:00',1.31),('15529','2013-09-04','09:35:00',1.35),('15529','2013-09-04','09:40:00',1.38),('15529','2013-09-04','09:45:00',1.42),('15529','2013-09-04','09:50:00',1.46),('15529','2013-09-04','09:55:00',1.49),('15529','2013-09-04','10:00:00',1.53),('15529','2013-09-04','10:05:00',1.56),('15529','2013-09-04','10:10:00',1.6),('15529','2013-09-04','10:15:00',1.63),('15529','2013-09-04','10:20:00',1.68),('15529','2013-09-04','10:25:00',1.7),('15529','2013-09-04','10:30:00',1.73),('15529','2013-09-04','10:35:00',1.76),('15529','2013-09-04','10:40:00',1.78),('15529','2013-09-04','10:45:00',1.8),('15529','2013-09-04','10:50:00',1.84),('15529','2013-09-04','10:55:00',1.85),('15529','2013-09-04','11:00:00',1.87),('15529','2013-09-04','11:05:00',1.89),('15529','2013-09-04','11:10:00',1.91),('15529','2013-09-04','11:15:00',1.95),('15529','2013-09-04','11:20:00',1.97),('15529','2013-09-04','11:25:00',1.96),('15529','2013-09-04','11:30:00',1.98),('15529','2013-09-04','11:35:00',2.01),('15529','2013-09-04','11:40:00',2.02),('15529','2013-09-04','11:45:00',1.99),('15529','2013-09-04','11:50:00',2.01),('15529','2013-09-04','11:55:00',2.06),('15529','2013-09-04','12:00:00',2.07),('15529','2013-09-04','12:05:00',2.08),('15529','2013-09-04','12:10:00',2.08),('15529','2013-09-04','12:15:00',2.09),('15529','2013-09-04','12:20:00',2.11),('15529','2013-09-04','12:25:00',2.11),('15529','2013-09-04','12:30:00',2.11),('15529','2013-09-04','12:35:00',2.14),('15529','2013-09-04','12:40:00',2.12),('15529','2013-09-04','12:45:00',2.1),('15529','2013-09-04','12:50:00',2.15),('15529','2013-09-04','12:55:00',2.12),('15529','2013-09-04','13:00:00',2.12),('15529','2013-09-04','13:05:00',2.15),('15529','2013-09-04','13:10:00',2.14),('15529','2013-09-04','13:15:00',2.17),('15529','2013-09-04','13:20:00',2.16),('15529','2013-09-04','13:25:00',2.15),('15529','2013-09-04','13:30:00',2.15),('15529','2013-09-04','13:35:00',2.13),('15529','2013-09-04','13:40:00',2.16),('15529','2013-09-04','13:45:00',2.17),('15529','2013-09-04','13:50:00',2.15),('15529','2013-09-04','13:55:00',2.13),('15529','2013-09-04','14:00:00',2.09),('15529','2013-09-04','14:05:00',2.1),('15529','2013-09-04','14:10:00',2.11),('15529','2013-09-04','14:15:00',2.1),('15529','2013-09-04','14:20:00',2.05),('15529','2013-09-04','14:25:00',2.03),('15529','2013-09-04','14:30:00',2.02),('15529','2013-09-04','14:35:00',1.97),('15529','2013-09-04','14:40:00',1.95),('15529','2013-09-04','14:45:00',1.97),('15529','2013-09-04','14:50:00',1.97),('15529','2013-09-04','14:55:00',1.94),('15529','2013-09-04','15:00:00',1.93),('15529','2013-09-04','15:05:00',1.9),('15529','2013-09-04','15:10:00',1.9),('15529','2013-09-04','15:15:00',1.86),('15529','2013-09-04','15:20:00',1.82),('15529','2013-09-04','15:25:00',1.79),('15529','2013-09-04','15:30:00',1.77),('15529','2013-09-04','15:35:00',1.73),('15529','2013-09-04','15:40:00',1.71),('15529','2013-09-04','15:45:00',1.69),('15529','2013-09-04','15:50:00',1.66),('15529','2013-09-04','15:55:00',1.64),('15529','2013-09-04','16:00:00',1.6),('15529','2013-09-04','16:05:00',1.57),('15529','2013-09-04','16:10:00',1.54),('15529','2013-09-04','16:15:00',1.5),('15529','2013-09-04','16:20:00',1.46),('15529','2013-09-04','16:25:00',1.43),('15529','2013-09-04','16:30:00',1.4),('15529','2013-09-04','16:35:00',1.38),('15529','2013-09-04','16:40:00',1.35),('15529','2013-09-04','16:45:00',1.33),('15529','2013-09-04','16:50:00',1.05),('15529','2013-09-03','09:00:00',1.05),('15529','2013-09-03','09:05:00',1.1),('15529','2013-09-03','09:10:00',1.14),('15529','2013-09-03','09:15:00',1.19),('15529','2013-09-03','09:20:00',1.23),('15529','2013-09-03','09:25:00',1.28),('15529','2013-09-03','09:30:00',1.33),('15529','2013-09-03','09:35:00',1.38),('15529','2013-09-03','09:40:00',1.42),('15529','2013-09-03','09:45:00',1.46),('15529','2013-09-03','09:50:00',1.5),('15529','2013-09-03','09:55:00',1.54),('15529','2013-09-03','10:00:00',1.57),('15529','2013-09-03','10:05:00',1.61),('15529','2013-09-03','10:10:00',1.64),('15529','2013-09-03','10:15:00',1.67),('15529','2013-09-03','10:20:00',1.7),('15529','2013-09-03','10:25:00',1.73),('15529','2013-09-03','10:30:00',1.75),('15529','2013-09-03','10:35:00',1.79),('15529','2013-09-03','10:40:00',1.82),('15529','2013-09-03','10:45:00',1.85),('15529','2013-09-03','10:50:00',1.89),('15529','2013-09-03','10:55:00',1.93),('15529','2013-09-03','11:00:00',1.92),('15529','2013-09-03','11:05:00',2),('15529','2013-09-03','11:10:00',2.02),('15529','2013-09-03','11:15:00',2.04),('15529','2013-09-03','11:20:00',2.05),('15529','2013-09-03','11:25:00',2.06),('15529','2013-09-03','11:30:00',2.06),('15529','2013-09-03','11:35:00',2.11),('15529','2013-09-03','11:40:00',2.08),('15529','2013-09-03','11:45:00',2.11),('15529','2013-09-03','11:50:00',2.12),('15529','2013-09-03','11:55:00',2.14),('15529','2013-09-03','12:00:00',2.12),('15529','2013-09-03','12:05:00',2.18),('15529','2013-09-03','12:10:00',2.15),('15529','2013-09-03','12:15:00',2.15),('15529','2013-09-03','12:20:00',2.18),('15529','2013-09-03','12:25:00',2.15),('15529','2013-09-03','12:30:00',2.16),('15529','2013-09-03','12:35:00',2.19),('15529','2013-09-03','12:40:00',2.19),('15529','2013-09-03','12:45:00',2.19),('15529','2013-09-03','12:50:00',2.2),('15529','2013-09-03','12:55:00',2.13),('15529','2013-09-03','13:00:00',2.23),('15529','2013-09-03','13:05:00',2.23),('15529','2013-09-03','13:10:00',2.21),('15529','2013-09-03','13:15:00',2.18),('15529','2013-09-03','13:20:00',2.19),('15529','2013-09-03','13:25:00',2.22),('15529','2013-09-03','13:30:00',2.15),('15529','2013-09-03','13:35:00',2.2),('15529','2013-09-03','13:40:00',2.16),('15529','2013-09-03','13:45:00',2.15),('15529','2013-09-03','13:50:00',2.2),('15529','2013-09-03','13:55:00',2.2),('15529','2013-09-03','14:00:00',2.17),('15529','2013-09-03','14:05:00',2.17),('15529','2013-09-03','14:10:00',2.14),('15529','2013-09-03','14:15:00',2.15),('15529','2013-09-03','14:20:00',2.09),('15529','2013-09-03','14:25:00',2.11),('15529','2013-09-03','14:30:00',2.08),('15529','2013-09-03','14:35:00',2.11),('15529','2013-09-03','14:40:00',2.06),('15529','2013-09-03','14:45:00',2.03),('15529','2013-09-03','14:50:00',1.99),('15529','2013-09-03','14:55:00',1.99),('15529','2013-09-03','15:00:00',1.97),('15529','2013-09-03','15:05:00',1.94),('15529','2013-09-03','15:10:00',1.92),('15529','2013-09-03','15:15:00',1.9),('15529','2013-09-03','15:20:00',1.87),('15529','2013-09-03','15:25:00',1.85),('15529','2013-09-03','15:30:00',1.8),('15529','2013-09-03','15:35:00',1.78),('15529','2013-09-03','15:40:00',1.76),('15529','2013-09-03','15:45:00',1.73),('15529','2013-09-03','15:50:00',1.69),('15529','2013-09-03','15:55:00',1.67),('15529','2013-09-03','16:00:00',1.61),('15529','2013-09-03','16:05:00',1.57),('15529','2013-09-03','16:10:00',1.52),('15529','2013-09-03','16:15:00',1.49),('15529','2013-09-03','16:20:00',1.46),('15529','2013-09-03','16:25:00',1.41),('15529','2013-09-03','16:30:00',1.36),('15529','2013-09-03','16:35:00',1.33),('15529','2013-09-03','16:40:00',1.29),('15529','2013-09-03','16:45:00',1.25),('15529','2013-09-03','16:50:00',1.2),('15529','2013-09-03','16:55:00',1.15),('15529','2013-09-03','17:00:00',1.11),('15529','2013-09-03','17:05:00',1.06),('15529','2013-09-03','17:10:00',1.01),('15529','2013-09-02','09:05:00',1),('15529','2013-09-02','09:10:00',1.05),('15529','2013-09-02','09:15:00',1.1),('15529','2013-09-02','09:20:00',1.15),('15529','2013-09-02','09:25:00',1.2),('15529','2013-09-02','09:30:00',1.24),('15529','2013-09-02','09:35:00',1.28),('15529','2013-09-02','09:40:00',1.33),('15529','2013-09-02','09:45:00',1.36),('15529','2013-09-02','09:50:00',1.39),('15529','2013-09-02','09:55:00',1.43),('15529','2013-09-02','10:00:00',1.46),('15529','2013-09-02','10:05:00',1.5),('15529','2013-09-02','10:10:00',1.53),('15529','2013-09-02','10:15:00',1.57),('15529','2013-09-02','10:20:00',1.62),('15529','2013-09-02','10:25:00',1.66),('15529','2013-09-02','10:30:00',1.67),('15529','2013-09-02','10:35:00',1.72),('15529','2013-09-02','10:40:00',1.75),('15529','2013-09-02','10:45:00',1.8),('15529','2013-09-02','10:50:00',1.8),('15529','2013-09-02','10:55:00',1.83),('15529','2013-09-02','11:00:00',1.86),('15529','2013-09-02','11:05:00',1.85),('15529','2013-09-02','11:10:00',1.86),('15529','2013-09-02','11:15:00',1.88),('15529','2013-09-02','11:20:00',1.91),('15529','2013-09-02','11:25:00',1.93),('15529','2013-09-02','11:30:00',1.96),('15529','2013-09-02','11:35:00',1.98),('15529','2013-09-02','11:40:00',1.99),('15529','2013-09-02','11:45:00',2.01),('15529','2013-09-02','11:50:00',2.05),('15529','2013-09-02','11:55:00',2.05),('15529','2013-09-02','12:00:00',2.06),('15529','2013-09-02','12:05:00',2.1),('15529','2013-09-02','12:10:00',2.1),('15529','2013-09-02','12:15:00',2.1),('15529','2013-09-02','12:20:00',2.14),('15529','2013-09-02','12:25:00',2.13),('15529','2013-09-02','12:30:00',2.16),('15529','2013-09-02','12:35:00',2.15),('15529','2013-09-02','12:40:00',2.15),('15529','2013-09-02','12:45:00',2.16),('15529','2013-09-02','12:50:00',2.15),('15529','2013-09-02','12:55:00',2.14),('15529','2013-09-02','13:00:00',2.15),('15529','2013-09-02','13:05:00',2.19),('15529','2013-09-02','13:10:00',2.15),('15529','2013-09-02','13:15:00',2.15),('15529','2013-09-02','13:20:00',2.19),('15529','2013-09-02','13:25:00',2.2),('15529','2013-09-02','13:30:00',2.18),('15529','2013-09-02','13:35:00',2.16),('15529','2013-09-02','13:40:00',2.16),('15529','2013-09-02','13:45:00',2.17),('15529','2013-09-02','13:50:00',2.16),('15529','2013-09-02','13:55:00',2.14),('15529','2013-09-02','14:00:00',2.11),('15529','2013-09-02','14:05:00',2.11),('15529','2013-09-02','14:10:00',2.06),('15529','2013-09-02','14:15:00',2.08),('15529','2013-09-02','14:20:00',2.05),('15529','2013-09-02','14:25:00',2.04),('15529','2013-09-02','14:30:00',2.03),('15529','2013-09-02','14:35:00',2.03),('15529','2013-09-02','14:40:00',2.04),('15529','2013-09-02','14:45:00',2.02),('15529','2013-09-02','14:50:00',2),('15529','2013-09-02','14:55:00',1.98),('15529','2013-09-02','15:00:00',1.94),('15529','2013-09-02','15:05:00',1.93),('15529','2013-09-02','15:10:00',1.92),('15529','2013-09-02','15:15:00',1.84),('15529','2013-09-02','15:20:00',1.84),('15529','2013-09-02','15:25:00',1.82),('15529','2013-09-02','15:30:00',1.8),('15529','2013-09-02','15:35:00',1.76),('15529','2013-09-02','15:40:00',1.74),('15529','2013-09-02','15:45:00',1.71),('15529','2013-09-02','15:50:00',1.66),('15529','2013-09-02','15:55:00',1.62),('15529','2013-09-02','16:00:00',1.59),('15529','2013-09-02','16:05:00',1.56),('15529','2013-09-02','16:10:00',1.52),('15529','2013-09-02','16:15:00',1.49),('15529','2013-09-02','16:20:00',1.45),('15529','2013-09-02','16:25:00',1.4),('15529','2013-09-02','16:30:00',1.36),('15529','2013-09-02','16:35:00',1.32),('15529','2013-09-02','16:40:00',1.29),('15529','2013-09-02','16:45:00',1.25),('15529','2013-09-02','16:50:00',1.19),('15529','2013-09-02','16:55:00',1.15),('15529','2013-09-02','17:00:00',1.1),('15529','2013-09-02','17:05:00',1.06),('15529','2013-09-02','17:10:00',1.01),('15529','2013-09-01','09:05:00',1.04),('15529','2013-09-01','09:10:00',1.08),('15529','2013-09-01','09:15:00',1.13),('15529','2013-09-01','09:20:00',1.18),('15529','2013-09-01','09:25:00',1.22),('15529','2013-09-01','09:30:00',1.26),('15529','2013-09-01','09:35:00',1.3),('15529','2013-09-01','09:40:00',1.34),('15529','2013-09-01','09:45:00',1.39),('15529','2013-09-01','09:50:00',1.43),('15529','2013-09-01','09:55:00',1.47),('15529','2013-09-01','10:00:00',1.49),('15529','2013-09-01','10:05:00',1.52),('15529','2013-09-01','10:10:00',1.56),('15529','2013-09-01','10:15:00',1.59),('15529','2013-09-01','10:20:00',1.62),('15529','2013-09-01','10:25:00',1.67),('15529','2013-09-01','10:30:00',1.69),('15529','2013-09-01','10:35:00',1.71),('15529','2013-09-01','10:40:00',1.74),('15529','2013-09-01','10:45:00',1.78),('15529','2013-09-01','10:50:00',1.8),('15529','2013-09-01','10:55:00',1.84),('15529','2013-09-01','11:00:00',1.85),('15529','2013-09-01','11:05:00',1.88),('15529','2013-09-01','11:10:00',1.92),('15529','2013-09-01','11:15:00',1.92),('15529','2013-09-01','11:20:00',1.94),('15529','2013-09-01','11:25:00',1.97),('15529','2013-09-01','11:30:00',1.98),('15529','2013-09-01','11:35:00',2),('15529','2013-09-01','11:40:00',2.02),('15529','2013-09-01','11:45:00',2.01),('15529','2013-09-01','11:50:00',2.01),('15529','2013-09-01','11:55:00',2.01),('15529','2013-09-01','12:00:00',2.06),('15529','2013-09-01','12:05:00',2.1),('15529','2013-09-01','12:10:00',2.08),('15529','2013-09-01','12:15:00',2.14),('15529','2013-09-01','12:20:00',2.12),('15529','2013-09-01','12:25:00',2.14),('15529','2013-09-01','12:30:00',2.15),('15529','2013-09-01','12:35:00',2.11),('15529','2013-09-01','12:40:00',2.15),('15529','2013-09-01','12:45:00',2.12),('15529','2013-09-01','12:50:00',2.11),('15529','2013-09-01','12:55:00',2.11),('15529','2013-09-01','13:00:00',2.14),('15529','2013-09-01','13:05:00',2.16),('15529','2013-09-01','13:10:00',2.15),('15529','2013-09-01','13:15:00',2.14),('15529','2013-09-01','13:20:00',2.15),('15529','2013-09-01','13:25:00',2.14),('15529','2013-09-01','13:30:00',2.17),('15529','2013-09-01','13:35:00',2.14),('15529','2013-09-01','13:40:00',2.2),('15529','2013-09-01','13:45:00',2.16),('15529','2013-09-01','13:50:00',2.17),('15529','2013-09-01','13:55:00',2.13),('15529','2013-09-01','14:00:00',2.09),('15529','2013-09-01','14:05:00',2.11),('15529','2013-09-01','14:10:00',2.1),('15529','2013-09-01','14:15:00',2.1),('15529','2013-09-01','14:20:00',2.1),('15529','2013-09-01','14:25:00',2.09),('15529','2013-09-01','14:30:00',2.12),('15529','2013-09-01','14:35:00',2.12),('15529','2013-09-01','14:40:00',2.04),('15529','2013-09-01','14:45:00',2.06),('15529','2013-09-01','14:50:00',2.02),('15529','2013-09-01','14:55:00',1.98),('15529','2013-09-01','15:10:00',1.23),('15529','2013-09-01','15:15:00',1.96),('15529','2013-09-01','15:20:00',1.91),('15529','2013-09-01','15:25:00',1.87),('15529','2013-09-01','15:30:00',1.86),('15529','2013-09-01','15:35:00',1.81),('15529','2013-09-01','15:40:00',1.73),('15529','2013-09-01','15:45:00',1.69),('15529','2013-09-01','15:50:00',1.65),('15529','2013-09-01','15:55:00',1.62),('15529','2013-09-01','16:00:00',1.61),('15529','2013-09-01','16:05:00',1.58),('15529','2013-09-01','16:10:00',1.52),('15529','2013-09-01','16:15:00',1.48),('15529','2013-09-01','16:20:00',1.44),('15529','2013-09-01','16:25:00',1.41),('15529','2013-09-01','16:30:00',1.35),('15529','2013-09-01','16:35:00',1.29),('15529','2013-09-01','16:40:00',1.27),('15529','2013-09-01','16:45:00',1.23),('15529','2013-09-01','16:50:00',1.18),('15529','2013-09-01','16:55:00',1.11),('15529','2013-09-01','17:00:00',1.06),('15529','2013-09-01','17:05:00',1.03),('15529','2013-08-31','09:00:00',1.01),('15529','2013-08-31','09:05:00',1.05),('15529','2013-08-31','09:10:00',1.11),('15529','2013-08-31','09:15:00',1.16),('15529','2013-08-31','09:20:00',1.2),('15529','2013-08-31','09:25:00',1.24),('15529','2013-08-31','09:30:00',1.29),('15529','2013-08-31','09:35:00',1.33),('15529','2013-08-31','09:40:00',1.38),('15529','2013-08-31','09:45:00',1.41),('15529','2013-08-31','09:50:00',1.46),('15529','2013-08-31','09:55:00',1.49),('15529','2013-08-31','10:00:00',1.53),('15529','2013-08-31','10:05:00',1.55),('15529','2013-08-31','10:10:00',1.59),('15529','2013-08-31','10:15:00',1.61),('15529','2013-08-31','10:20:00',1.64),('15529','2013-08-31','10:25:00',1.68),('15529','2013-08-31','10:30:00',1.71),('15529','2013-08-31','10:35:00',1.75),('15529','2013-08-31','10:40:00',1.78),('15529','2013-08-31','10:45:00',1.81),('15529','2013-08-31','10:50:00',1.83),('15529','2013-08-31','10:55:00',1.86),('15529','2013-08-31','11:00:00',1.88),('15529','2013-08-31','11:05:00',1.93),('15529','2013-08-31','11:10:00',1.93),('15529','2013-08-31','11:15:00',1.98),('15529','2013-08-31','11:20:00',1.98),('15529','2013-08-31','11:25:00',1.99),('15529','2013-08-31','11:30:00',2.01),('15529','2013-08-31','11:35:00',2.06),('15529','2013-08-31','11:40:00',2.06),('15529','2013-08-31','11:45:00',2.09),('15529','2013-08-31','11:50:00',2.08),('15529','2013-08-31','11:55:00',2.08),('15529','2013-08-31','12:00:00',2.08),('15529','2013-08-31','12:05:00',2.08),('15529','2013-08-31','12:10:00',2.07),('15529','2013-08-31','12:15:00',2.12),('15529','2013-08-31','12:20:00',2.07),('15529','2013-08-31','12:25:00',2.06),('15529','2013-08-31','12:30:00',2.16),('15529','2013-08-31','12:35:00',2.15),('15529','2013-08-31','12:40:00',2.17),('15529','2013-08-31','12:45:00',2.15),('15529','2013-08-31','12:50:00',2.15),('15529','2013-08-31','12:55:00',2.17),('15529','2013-08-31','13:00:00',2.18),('15529','2013-08-31','13:05:00',1.95),('15529','2013-08-31','13:10:00',2.16),('15529','2013-08-31','13:15:00',2.22),('15529','2013-08-31','13:20:00',1.87),('15529','2013-08-31','13:25:00',2.16),('15529','2013-08-31','13:30:00',2.21),('15529','2013-08-31','13:35:00',2.19),('15529','2013-08-31','13:40:00',2.2),('15529','2013-08-31','13:45:00',1.99),('15529','2013-08-31','13:50:00',1.9),('15529','2013-08-31','13:55:00',1.96),('15529','2013-08-31','14:00:00',1.79),('15529','2013-08-31','14:05:00',1.96),('15529','2013-08-31','14:10:00',1.94),('15529','2013-08-31','14:15:00',1.72),('15529','2013-08-31','14:20:00',1.81),('15529','2013-08-31','14:25:00',1.92),('15529','2013-08-31','14:30:00',1.73),('15529','2013-08-31','14:35:00',1.79),('15529','2013-08-31','14:40:00',1.84),('15529','2013-08-31','14:45:00',1.74),('15529','2013-08-31','14:50:00',1.08),('15529','2013-08-31','14:55:00',1.61),('15529','2013-08-31','15:00:00',1.73),('15529','2013-08-31','15:05:00',1.78),('15529','2013-08-31','15:10:00',1.73),('15529','2013-08-31','15:15:00',1.68),('15529','2013-08-31','15:20:00',1.68),('15529','2013-08-31','15:25:00',1.49),('15529','2013-08-31','15:30:00',1.35),('15529','2013-08-31','15:35:00',1.41),('15529','2013-08-31','15:40:00',1.51),('15529','2013-08-31','15:45:00',1.42),('15529','2013-08-31','15:50:00',1.24),('15529','2013-08-31','15:55:00',1.16),('15529','2013-08-31','16:00:00',1.34),('15529','2013-08-31','16:05:00',1.45),('15529','2013-08-31','16:10:00',1.38),('15529','2013-08-31','16:15:00',1.42),('15529','2013-08-31','16:20:00',1.43),('15529','2013-08-31','16:25:00',1.32),('15529','2013-08-31','16:30:00',1.43),('15529','2013-08-31','16:35:00',1.45),('15529','2013-08-31','16:40:00',1.31),('15529','2013-08-31','16:45:00',1.19),('15529','2013-08-31','16:50:00',1.14),('15529','2013-08-30','08:50:00',1.01),('15529','2013-08-30','08:55:00',1.09),('15529','2013-08-30','09:00:00',1.14),('15529','2013-08-30','09:05:00',1.03),('15529','2013-08-30','09:15:00',1.14),('15529','2013-08-30','09:20:00',1.24),('15529','2013-08-30','09:25:00',1.33),('15529','2013-08-30','09:30:00',1.36),('15529','2013-08-30','09:35:00',1.43),('15529','2013-08-30','09:40:00',1.41),('15529','2013-08-30','09:45:00',1.38),('15529','2013-08-30','09:50:00',1.42),('15529','2013-08-30','09:55:00',1.5),('15529','2013-08-30','10:00:00',1.6),('15529','2013-08-30','10:05:00',1.56),('15529','2013-08-30','10:10:00',1.62),('15529','2013-08-30','10:15:00',1.66),('15529','2013-08-30','10:20:00',1.67),('15529','2013-08-30','10:25:00',1.7),('15529','2013-08-30','10:30:00',1.73),('15529','2013-08-30','10:35:00',1.77),('15529','2013-08-30','10:40:00',1.81),('15529','2013-08-30','10:45:00',1.85),('15529','2013-08-30','10:50:00',1.9),('15529','2013-08-30','10:55:00',1.9),('15529','2013-08-30','11:00:00',1.95),('15529','2013-08-30','11:05:00',1.97),('15529','2013-08-30','11:10:00',1.99),('15529','2013-08-30','11:15:00',1.99),('15529','2013-08-30','11:20:00',2.05),('15529','2013-08-30','11:25:00',2.04),('15529','2013-08-30','11:30:00',2.07),('15529','2013-08-30','11:35:00',2.1),('15529','2013-08-30','11:40:00',2.09),('15529','2013-08-30','11:45:00',2.12),('15529','2013-08-30','11:50:00',2.13),('15529','2013-08-30','11:55:00',2.14),('15529','2013-08-30','12:00:00',2.17),('15529','2013-08-30','12:05:00',2.16),('15529','2013-08-30','12:10:00',2.2),('15529','2013-08-30','12:15:00',1.99),('15529','2013-08-30','12:20:00',2.21),('15529','2013-08-30','12:25:00',2.19),('15529','2013-08-30','12:30:00',2.18),('15529','2013-08-30','12:35:00',2.2),('15529','2013-08-30','12:40:00',2.22),('15529','2013-08-30','12:45:00',2.18),('15529','2013-08-30','12:50:00',2.21),('15529','2013-08-30','12:55:00',2.21),('15529','2013-08-30','13:00:00',2.21),('15529','2013-08-30','13:05:00',2.2),('15529','2013-08-30','13:10:00',2.18),('15529','2013-08-30','13:15:00',2.16),('15529','2013-08-30','13:20:00',2.16),('15529','2013-08-30','13:25:00',2.18),('15529','2013-08-30','13:30:00',2.2),('15529','2013-08-30','13:35:00',2.17),('15529','2013-08-30','13:40:00',2.2),('15529','2013-08-30','13:45:00',2.17),('15529','2013-08-30','13:50:00',2.18),('15529','2013-08-30','13:55:00',2.17),('15529','2013-08-30','14:00:00',2.18),('15529','2013-08-30','14:05:00',2.15),('15529','2013-08-30','14:10:00',2.08),('15529','2013-08-30','14:15:00',2.1),('15529','2013-08-30','14:20:00',2.07),('15529','2013-08-30','14:25:00',2.05),('15529','2013-08-30','14:30:00',2),('15529','2013-08-30','14:35:00',1.97),('15529','2013-08-30','14:40:00',2.01),('15529','2013-08-30','14:45:00',1.96),('15529','2013-08-30','14:50:00',1.91),('15529','2013-08-30','14:55:00',1.88),('15529','2013-08-30','15:00:00',1.89),('15529','2013-08-30','15:05:00',1.88),('15529','2013-08-30','15:10:00',1.84),('15529','2013-08-30','15:15:00',1.8),('15529','2013-08-30','15:20:00',1.8),('15529','2013-08-30','15:25:00',1.77),('15529','2013-08-30','15:30:00',1.75),('15529','2013-08-30','15:35:00',1.71),('15529','2013-08-30','15:40:00',1.7),('15529','2013-08-30','15:45:00',1.64),('15529','2013-08-30','15:50:00',1.59),('15529','2013-08-30','15:55:00',1.56),('15529','2013-08-30','16:00:00',1.54),('15529','2013-08-30','16:05:00',1.51),('15529','2013-08-30','16:10:00',1.47),('15529','2013-08-30','16:15:00',1.43),('15529','2013-08-30','16:20:00',1.43),('15529','2013-08-30','16:25:00',1.34),('15529','2013-08-30','16:30:00',1.33),('15529','2013-08-30','16:35:00',1.32),('15529','2013-08-30','16:40:00',1.25),('15529','2013-08-30','16:45:00',1.18),('15529','2013-08-30','16:50:00',1.15),('15529','2013-08-30','16:55:00',1.1),('15529','2013-08-30','17:00:00',1.05),('15529','2013-08-30','17:05:00',1.05),('15529','2013-08-30','17:10:00',1),('15529','2013-08-29','10:15:00',1.07),('15529','2013-08-29','10:20:00',1.09),('15529','2013-08-29','10:25:00',1.05),('15529','2013-08-29','10:30:00',1.14),('15529','2013-08-29','10:35:00',1.08),('15529','2013-08-29','10:45:00',1),('15529','2013-08-29','10:50:00',1.06),('15529','2013-08-29','11:00:00',1.07),('15529','2013-08-29','11:05:00',1.14),('15529','2013-08-29','11:10:00',1.23),('15529','2013-08-29','11:15:00',1.2),('15529','2013-08-29','11:20:00',1.22),('15529','2013-08-29','11:25:00',1.27),('15529','2013-08-29','11:30:00',1.34),('15529','2013-08-29','11:35:00',1.28),('15529','2013-08-29','11:40:00',1.4),('15529','2013-08-29','11:45:00',1.42),('15529','2013-08-29','11:50:00',1.61),('15529','2013-08-29','11:55:00',1.36),('15529','2013-08-29','12:00:00',1.17),('15529','2013-08-29','12:05:00',1.05),('15529','2013-08-29','12:10:00',1.2),('15529','2013-08-29','12:15:00',1.28),('15529','2013-08-29','12:20:00',1.41),('15529','2013-08-29','12:25:00',1.64),('15529','2013-08-29','12:30:00',1.75),('15529','2013-08-29','12:35:00',1.64),('15529','2013-08-29','12:40:00',1.65),('15529','2013-08-29','12:45:00',1.68),('15529','2013-08-29','12:50:00',1.62),('15529','2013-08-29','12:55:00',1.46),('15529','2013-08-29','13:00:00',1.48),('15529','2013-08-29','13:05:00',1.43),('15529','2013-08-29','13:10:00',1.39),('15529','2013-08-29','13:15:00',1.37),('15529','2013-08-29','13:20:00',1.85),('15529','2013-08-29','13:25:00',1.92),('15529','2013-08-29','13:30:00',2.13),('15529','2013-08-29','13:35:00',2.07),('15529','2013-08-29','13:40:00',2.19),('15529','2013-08-29','13:45:00',1.9),('15529','2013-08-29','13:50:00',1.98),('15529','2013-08-29','13:55:00',2.08),('15529','2013-08-29','14:00:00',2.07),('15529','2013-08-29','14:05:00',2.03),('15529','2013-08-29','14:10:00',2.1),('15529','2013-08-29','14:15:00',2.03),('15529','2013-08-29','14:20:00',2.15),('15529','2013-08-29','14:25:00',2.05),('15529','2013-08-29','14:30:00',1.98),('15529','2013-08-29','14:35:00',2.12),('15529','2013-08-29','14:40:00',1.87),('15529','2013-08-29','14:45:00',1.56),('15529','2013-08-29','14:50:00',1.54),('15529','2013-08-29','14:55:00',1.46),('15529','2013-08-29','15:00:00',1.28),('15529','2013-08-29','15:05:00',1.2),('15529','2013-08-29','15:10:00',1.32),('15529','2013-08-29','15:15:00',1.4),('15529','2013-08-29','15:20:00',1.27),('15529','2013-08-29','15:25:00',1.14),('15529','2013-08-29','15:30:00',1.08),('15529','2013-08-29','15:40:00',1.06),('15529','2013-08-29','15:45:00',1.23),('15529','2013-08-29','15:50:00',1.24),('15529','2013-08-29','15:55:00',1.17),('15529','2013-08-29','16:00:00',1.08),('15529','2013-08-29','16:35:00',1.24),('15529','2013-08-29','16:50:00',1.23),('15529','2013-08-29','16:55:00',1.21),('15529','2013-08-29','17:00:00',1.17),('15529','2014-04-10','08:50:00',1.01),('15529','2014-04-10','08:55:00',1.08),('15529','2014-04-10','09:00:00',1.12),('15529','2014-04-10','09:05:00',1.17),('15529','2014-04-10','09:10:00',1.21),('15529','2014-04-10','09:15:00',1.25),('15529','2014-04-10','09:20:00',1.29),('15529','2014-04-10','09:25:00',1.32),('15529','2014-04-10','09:30:00',1.36),('15529','2014-04-10','09:35:00',1.41),('15529','2014-04-10','09:40:00',1.46),('15529','2014-04-10','09:45:00',1.5),('15529','2014-04-10','09:50:00',1.53),('15529','2014-04-10','09:55:00',1.58),('15529','2014-04-10','10:00:00',1.64),('15529','2014-04-10','10:05:00',1.68),('15529','2014-04-10','10:10:00',1.71),('15529','2014-04-10','10:15:00',1.74),('15529','2014-04-10','10:20:00',1.78),('15529','2014-04-10','10:25:00',1.81),('15529','2014-04-10','10:30:00',1.83),('15529','2014-04-10','10:35:00',1.88),('15529','2014-04-10','10:40:00',1.89),('15529','2014-04-10','10:45:00',1.94),('15529','2014-04-10','10:50:00',1.99),('15529','2014-04-10','10:55:00',2.01),('15529','2014-04-10','11:00:00',2.02),('15529','2014-04-10','11:05:00',2),('15529','2014-04-10','11:10:00',2.09),('15529','2014-04-10','11:15:00',2.1),('15529','2014-04-10','11:20:00',2.14),('15529','2014-04-10','11:25:00',2.18),('15529','2014-04-10','11:30:00',2.19),('15529','2014-04-10','11:35:00',2.18),('15529','2014-04-10','11:40:00',2.24),('15529','2014-04-10','11:45:00',2),('15529','2014-04-10','11:50:00',2.35),('15529','2014-04-10','11:55:00',2.28),('15529','2014-04-10','12:00:00',2.29),('15529','2014-04-10','12:05:00',2.33),('15529','2014-04-10','12:10:00',2.37),('15529','2014-04-10','12:15:00',2.36),('15529','2014-04-10','12:20:00',2.44),('15529','2014-04-10','12:25:00',2.28),('15529','2014-04-10','12:30:00',2.11),('15529','2014-04-10','12:35:00',2.55),('15529','2014-04-10','12:40:00',2.08),('15529','2014-04-10','12:45:00',2.67),('15529','2014-04-10','12:50:00',2.43),('15529','2014-04-10','12:55:00',2.27),('15529','2014-04-10','13:00:00',1.84),('15529','2014-04-10','13:05:00',2.37),('15529','2014-04-10','13:10:00',2.47),('15529','2014-04-10','13:15:00',2.49),('15529','2014-04-10','13:20:00',2.03),('15529','2014-04-10','13:25:00',1.87),('15529','2014-04-10','13:30:00',2.01),('15529','2014-04-10','13:35:00',2.14),('15529','2014-04-10','13:40:00',2.48),('15529','2014-04-10','13:45:00',2.4),('15529','2014-04-10','13:50:00',2.26),('15529','2014-04-10','13:55:00',1.66),('15529','2014-04-10','14:00:00',2.51),('15529','2014-04-10','14:05:00',1.74),('15529','2014-04-10','14:10:00',2.06),('15529','2014-04-10','14:15:00',1.68),('15529','2014-04-10','14:20:00',2.56),('15529','2014-04-10','14:25:00',1.83),('15529','2014-04-10','14:30:00',1.57),('15529','2014-04-10','14:35:00',2.18),('15529','2014-04-10','14:40:00',2.33),('15529','2014-04-10','14:45:00',2.11),('15529','2014-04-10','14:50:00',2.28),('15529','2014-04-10','14:55:00',2.17),('15529','2014-04-10','15:00:00',2.18),('15529','2014-04-10','15:05:00',2.17),('15529','2014-04-10','15:10:00',2.06),('15529','2014-04-10','15:15:00',2.01),('15529','2014-04-10','15:20:00',1.88),('15529','2014-04-10','15:25:00',1.99),('15529','2014-04-10','15:30:00',1.95),('15529','2014-04-10','15:35:00',1.89),('15529','2014-04-10','15:40:00',1.88),('15529','2014-04-10','15:45:00',1.84),('15529','2014-04-10','15:50:00',1.82),('15529','2014-04-10','15:55:00',1.77),('15529','2014-04-10','16:00:00',1.74),('15529','2014-04-10','16:05:00',1.68),('15529','2014-04-10','16:10:00',1.64),('15529','2014-04-10','16:15:00',1.61),('15529','2014-04-10','16:20:00',1.56),('15529','2014-04-10','16:25:00',1.54),('15529','2014-04-10','16:30:00',1.42),('15529','2014-04-10','16:35:00',1.28),('15529','2014-04-10','16:40:00',1.46),('15529','2014-04-10','16:45:00',1.38),('15529','2014-04-10','16:50:00',1.36),('15529','2014-04-10','16:55:00',1.03),('15529','2014-04-10','17:00:00',1.32),('15529','2014-04-10','17:05:00',1.16),('15529','2014-04-10','17:10:00',1.19),('15529','2014-04-10','17:20:00',1.02),('15529','2013-08-28','11:10:00',1.05),('15529','2013-08-28','11:15:00',1.02),('15529','2013-08-28','12:05:00',1.12),('15529','2013-08-28','12:10:00',1.43),('15529','2013-08-28','12:15:00',1.4),('15529','2013-08-28','12:20:00',1.69),('15529','2013-08-28','12:25:00',1.42),('15529','2013-08-28','12:30:00',1.5),('15529','2013-08-28','12:35:00',1.81),('15529','2013-08-28','12:40:00',2.47),('15529','2013-08-28','12:45:00',2.26),('15529','2013-08-28','12:50:00',1.52),('15529','2013-08-28','12:55:00',1.65),('15529','2013-08-28','13:00:00',1.27),('15529','2013-08-28','13:05:00',1.31),('15529','2013-08-28','13:10:00',1.18),('15529','2013-08-28','13:15:00',1.18),('15529','2013-08-28','13:20:00',1.1),('15529','2013-08-28','14:00:00',1.05),('15529','2013-08-28','15:30:00',1.41),('15529','2013-08-28','15:35:00',1),('15529','2013-08-28','15:40:00',1.2),('15529','2013-08-28','15:45:00',1.15),('15529','2013-08-28','15:50:00',1.42),('15529','2013-08-28','15:55:00',1.83),('15529','2013-08-28','16:00:00',1.37),('15529','2013-08-28','16:05:00',1.78),('15529','2013-08-28','16:10:00',1.71),('15529','2013-08-28','16:15:00',1.62),('15529','2013-08-28','16:20:00',1.56),('15529','2013-08-28','16:25:00',1.49),('15529','2013-08-28','16:30:00',1.41),('15529','2013-08-28','16:35:00',1.4),('15529','2013-08-28','16:40:00',1.36),('15529','2013-08-28','16:45:00',1.31),('15529','2013-08-28','16:50:00',1.26),('15529','2013-08-28','16:55:00',1.21),('15529','2013-08-28','17:00:00',1.16),('15529','2013-08-28','17:05:00',1.11),('15529','2013-08-28','17:10:00',1.07),('15529','2013-08-28','17:15:00',1.03),('15529','2013-08-27','09:35:00',1.39),('15529','2013-08-27','09:40:00',1.38),('15529','2013-08-27','09:45:00',1.43),('15529','2013-08-27','09:50:00',1.47),('15529','2013-08-27','09:55:00',1.46),('15529','2013-08-27','10:00:00',1.51),('15529','2013-08-27','10:05:00',1.6),('15529','2013-08-27','10:10:00',1.74),('15529','2013-08-27','10:15:00',1.87),('15529','2013-08-27','10:25:00',1.1),('15529','2013-08-27','10:30:00',1.14),('15529','2013-08-27','10:40:00',1.71),('15529','2013-08-27','10:50:00',1.9),('15529','2013-08-27','10:55:00',1.99),('15529','2013-08-27','11:15:00',1.9),('15529','2013-08-27','11:20:00',2.01),('15529','2013-08-27','11:25:00',1.68),('15529','2013-08-27','11:30:00',2.24),('15529','2013-08-27','11:35:00',1.5),('15529','2013-08-27','11:40:00',2.28),('15529','2013-08-27','11:45:00',2.29),('15529','2013-08-27','11:50:00',1.02),('15529','2013-08-27','11:55:00',1.2),('15529','2013-08-27','12:05:00',2.37),('15529','2013-08-27','12:10:00',2.32),('15529','2013-08-27','12:15:00',2.3),('15529','2013-08-27','12:20:00',1.68),('15529','2013-08-27','12:25:00',2.03),('15529','2013-08-27','12:30:00',2.13),('15529','2013-08-27','12:35:00',2.31),('15529','2013-08-27','12:40:00',2.34),('15529','2013-08-27','12:45:00',2.1),('15529','2013-08-27','12:50:00',2.24),('15529','2013-08-27','12:55:00',1.96),('15529','2013-08-27','13:00:00',1.85),('15529','2013-08-27','13:05:00',2.35),('15529','2013-08-27','13:10:00',2.31),('15529','2013-08-27','13:15:00',2.31),('15529','2013-08-27','13:20:00',2.23),('15529','2013-08-27','13:25:00',1.97),('15529','2013-08-27','13:30:00',2.08),('15529','2013-08-27','13:35:00',2.34),('15529','2013-08-27','13:40:00',1.55),('15529','2013-08-27','13:45:00',2.39),('15529','2013-08-27','13:50:00',2.35),('15529','2013-08-27','13:55:00',2.33),('15529','2013-08-27','14:00:00',2.26),('15529','2013-08-27','14:05:00',2.27),('15529','2013-08-27','14:10:00',2.27),('15529','2013-08-27','14:15:00',2.2),('15529','2013-08-27','14:20:00',2.24),('15529','2013-08-27','14:25:00',2.24),('15529','2013-08-27','14:30:00',2.1),('15529','2013-08-27','14:35:00',2.17),('15529','2013-08-27','14:40:00',2.13),('15529','2013-08-27','14:45:00',2.09),('15529','2013-08-27','14:50:00',2.09),('15529','2013-08-27','14:55:00',2.04),('15529','2013-08-27','15:00:00',2.03),('15529','2013-08-27','15:05:00',2.06),('15529','2013-08-27','15:10:00',2),('15529','2013-08-27','15:15:00',1.96),('15529','2013-08-27','15:20:00',1.86),('15529','2013-08-27','15:25:00',1.8),('15529','2013-08-27','15:30:00',1.09),('15529','2013-08-27','15:35:00',1),('15529','2013-08-27','15:40:00',1.35),('15529','2013-08-27','15:45:00',1.18),('15529','2013-08-27','15:50:00',1.88),('15529','2013-08-27','15:55:00',1.84),('15529','2013-08-27','16:00:00',1.79),('15529','2013-08-27','16:05:00',1.76),('15529','2013-08-27','16:10:00',1.59),('15529','2013-08-27','16:15:00',1.35),('15529','2013-08-27','16:20:00',1.66),('15529','2013-08-27','16:25:00',1.49),('15529','2013-08-27','16:30:00',1.35),('15529','2013-08-27','16:35:00',1.41),('15529','2013-08-27','16:40:00',1.41),('15529','2013-08-27','16:45:00',1.34),('15529','2013-08-27','16:50:00',1.29),('15529','2013-08-27','16:55:00',1.26),('15529','2013-08-27','17:00:00',1.22),('15529','2013-08-27','17:15:00',1.07),('15529','2013-08-26','09:25:00',1.12),('15529','2013-08-26','09:30:00',1.17),('15529','2013-08-26','10:00:00',1.12),('15529','2013-08-26','10:05:00',1.32),('15529','2013-08-26','10:10:00',1.54),('15529','2013-08-26','10:15:00',1.6),('15529','2013-08-26','10:20:00',1.64),('15529','2013-08-26','10:25:00',1.67),('15529','2013-08-26','10:30:00',1.7),('15529','2013-08-26','10:35:00',1.72),('15529','2013-08-26','10:40:00',1.69),('15529','2013-08-26','10:45:00',1.75),('15529','2013-08-26','10:50:00',1.79),('15529','2013-08-26','10:55:00',1.82),('15529','2013-08-26','11:00:00',1.82),('15529','2013-08-26','11:05:00',1.82),('15529','2013-08-26','11:10:00',1.85),('15529','2013-08-26','11:15:00',1.9),('15529','2013-08-26','11:20:00',1.88),('15529','2013-08-26','11:25:00',1.89),('15529','2013-08-26','11:30:00',1.94),('15529','2013-08-26','11:35:00',1.9),('15529','2013-08-26','11:40:00',1.73),('15529','2013-08-26','11:45:00',1.61),('15529','2013-08-26','11:50:00',1.44),('15529','2013-08-26','11:55:00',2.05),('15529','2013-08-26','12:00:00',1.94),('15529','2013-08-26','12:05:00',1.81),('15529','2013-08-26','12:10:00',1.57),('15529','2013-08-26','12:15:00',2.01),('15529','2013-08-26','12:20:00',2.16),('15529','2013-08-26','12:35:00',1.11),('15529','2013-08-26','12:40:00',1.65),('15529','2013-08-26','12:45:00',1.04),('15529','2013-08-26','13:15:00',1.15),('15529','2013-08-26','13:45:00',1.32),('15529','2013-08-26','13:50:00',1.27),('15529','2013-08-26','13:55:00',1.88),('15529','2013-08-26','14:00:00',2.17),('15529','2013-08-26','14:05:00',1.08),('15529','2013-08-26','14:10:00',1.26),('15529','2013-08-26','14:15:00',1.46),('15529','2013-08-26','16:05:00',1.5),('15529','2013-08-26','16:10:00',1.88),('15529','2013-08-26','16:15:00',1.53),('15529','2013-08-26','16:35:00',1.02),('15529','2013-08-26','16:45:00',1.21),('15529','2013-08-26','16:50:00',1.43),('15529','2013-08-26','16:55:00',1.23),('15529','2013-08-26','17:05:00',1.22),('15529','2013-08-26','17:10:00',1.12),('15529','2013-08-25','09:00:00',1.02),('15529','2013-08-25','09:05:00',1.06),('15529','2013-08-25','09:10:00',1.11),('15529','2013-08-25','09:15:00',1.14),('15529','2013-08-25','09:20:00',1.19),('15529','2013-08-25','09:25:00',1.22),('15529','2013-08-25','09:30:00',1.26),('15529','2013-08-25','09:35:00',1.31),('15529','2013-08-25','09:40:00',1.35),('15529','2013-08-25','09:45:00',1.39),('15529','2013-08-25','09:50:00',1.42),('15529','2013-08-25','09:55:00',1.46),('15529','2013-08-25','10:00:00',1.48),('15529','2013-08-25','10:05:00',1.53),('15529','2013-08-25','10:10:00',1.58),('15529','2013-08-25','10:15:00',1.59),('15529','2013-08-25','10:20:00',1.64),('15529','2013-08-25','10:25:00',1.68),('15529','2013-08-25','10:30:00',1.71),('15529','2013-08-25','10:35:00',1.73),('15529','2013-08-25','10:40:00',1.78),('15529','2013-08-25','10:45:00',1.78),('15529','2013-08-25','10:50:00',1.82),('15529','2013-08-25','10:55:00',1.86),('15529','2013-08-25','11:00:00',1.89),('15529','2013-08-25','11:05:00',1.9),('15529','2013-08-25','11:10:00',1.89),('15529','2013-08-25','11:15:00',1.97),('15529','2013-08-25','11:20:00',1.96),('15529','2013-08-25','11:25:00',1.95),('15529','2013-08-25','11:30:00',1.99),('15529','2013-08-25','11:35:00',2.04),('15529','2013-08-25','11:40:00',2.05),('15529','2013-08-25','11:45:00',2.05),('15529','2013-08-25','11:50:00',2.06),('15529','2013-08-25','11:55:00',2.06),('15529','2013-08-25','12:00:00',2.01),('15529','2013-08-25','12:05:00',2.07),('15529','2013-08-25','12:10:00',2.09),('15529','2013-08-25','12:15:00',2.1),('15529','2013-08-25','12:20:00',2.09),('15529','2013-08-25','12:25:00',2.11),('15529','2013-08-25','12:30:00',2.08),('15529','2013-08-25','12:35:00',2.11),('15529','2013-08-25','12:40:00',2.03),('15529','2013-08-25','12:45:00',2.11),('15529','2013-08-25','12:50:00',2.15),('15529','2013-08-25','12:55:00',2.16),('15529','2013-08-25','13:00:00',1.96),('15529','2013-08-25','13:05:00',2),('15529','2013-08-25','13:10:00',1.8),('15529','2013-08-25','13:15:00',2.25),('15529','2013-08-25','13:20:00',1.97),('15529','2013-08-25','13:25:00',1.86),('15529','2013-08-25','13:30:00',1.45),('15529','2013-08-25','13:35:00',2.17),('15529','2013-08-25','13:40:00',2.14),('15529','2013-08-25','13:45:00',2.22),('15529','2013-08-25','13:50:00',2),('15529','2013-08-25','13:55:00',1.65),('15529','2013-08-25','14:00:00',1.72),('15529','2013-08-25','14:05:00',1.87),('15529','2013-08-25','14:10:00',1.75),('15529','2013-08-25','14:15:00',1.86),('15529','2013-08-25','14:20:00',2.08),('15529','2013-08-25','14:25:00',2.11),('15529','2013-08-25','14:30:00',2.08),('15529','2013-08-25','14:35:00',1.96),('15529','2013-08-25','14:40:00',1.79),('15529','2013-08-25','14:45:00',1.24),('15529','2013-08-25','14:50:00',1.05),('15529','2013-08-25','16:00:00',1.51),('15529','2013-08-25','16:05:00',1.69),('15529','2013-08-25','16:10:00',1.52),('15529','2013-08-25','16:15:00',1.49),('15529','2013-08-25','16:20:00',1.44),('15529','2013-08-25','16:25:00',1.39),('15529','2013-08-25','16:30:00',1.36),('15529','2013-08-25','16:35:00',1.34),('15529','2013-08-25','16:40:00',1.31),('15529','2013-08-25','16:45:00',1.25),('15529','2013-08-25','16:50:00',1.16),('15529','2013-08-25','16:55:00',1.15),('15529','2013-08-25','17:00:00',1.11),('15529','2013-08-25','17:05:00',1.01),('15529','2013-08-25','17:10:00',1.01),('15529','2013-08-24','09:15:00',1.03),('15529','2013-08-24','09:20:00',1.18),('15529','2013-08-24','09:25:00',1.24),('15529','2013-08-24','09:30:00',1.27),('15529','2013-08-24','09:50:00',1.39),('15529','2013-08-24','09:55:00',1.54),('15529','2013-08-24','10:00:00',1.11),('15529','2013-08-24','15:30:00',1.29),('15529','2013-08-24','15:35:00',1.87),('15529','2013-08-24','15:40:00',1.33),('15529','2013-08-24','15:50:00',1.3),('15529','2013-08-24','15:55:00',1.7),('15529','2013-08-24','16:00:00',1.88),('15529','2013-08-24','16:05:00',1.72),('15529','2013-08-24','16:10:00',1.65),('15529','2013-08-24','16:15:00',1.6),('15529','2013-08-24','16:20:00',1.56),('15529','2013-08-24','16:25:00',1.52),('15529','2013-08-24','16:30:00',1.46),('15529','2013-08-24','16:35:00',1.37),('15529','2013-08-24','16:50:00',1.16),('15529','2013-08-24','16:55:00',1.39),('15529','2013-08-24','17:00:00',1.26),('15529','2013-08-24','17:05:00',1.19),('15529','2013-08-24','17:10:00',1.11),('15529','2013-08-24','17:15:00',1.03),('15529','2013-08-23','09:10:00',1.08),('15529','2013-08-23','09:15:00',1.12),('15529','2013-08-23','09:20:00',1.05),('15529','2013-08-23','09:35:00',1.31),('15529','2013-08-23','09:40:00',1.33),('15529','2013-08-23','09:45:00',1.39),('15529','2013-08-23','09:50:00',1.4),('15529','2013-08-23','09:55:00',1.46),('15529','2013-08-23','10:00:00',1.48),('15529','2013-08-23','10:05:00',1.51),('15529','2013-08-23','10:10:00',1.31),('15529','2013-08-23','10:15:00',1.61),('15529','2013-08-23','10:20:00',1.62),('15529','2013-08-23','10:25:00',1.64),('15529','2013-08-23','10:30:00',1.68),('15529','2013-08-23','10:35:00',1.72),('15529','2013-08-23','10:40:00',1.74),('15529','2013-08-23','10:45:00',1.82),('15529','2013-08-23','10:50:00',1.82),('15529','2013-08-23','10:55:00',1.85),('15529','2013-08-23','11:00:00',1.88),('15529','2013-08-23','11:05:00',1.87),('15529','2013-08-23','11:10:00',1.89),('15529','2013-08-23','11:15:00',1.92),('15529','2013-08-23','11:20:00',1.94),('15529','2013-08-23','11:25:00',1.94),('15529','2013-08-23','11:30:00',1.95),('15529','2013-08-23','11:35:00',1.95),('15529','2013-08-23','11:40:00',2.01),('15529','2013-08-23','11:45:00',2.01),('15529','2013-08-23','11:50:00',2),('15529','2013-08-23','11:55:00',2),('15529','2013-08-23','12:00:00',2.02),('15529','2013-08-23','12:05:00',2.06),('15529','2013-08-23','12:10:00',2.09),('15529','2013-08-23','12:15:00',2.11),('15529','2013-08-23','12:20:00',2.1),('15529','2013-08-23','12:25:00',2.13),('15529','2013-08-23','12:30:00',2.11),('15529','2013-08-23','12:35:00',2.13),('15529','2013-08-23','12:40:00',2.14),('15529','2013-08-23','12:45:00',2.15),('15529','2013-08-23','12:50:00',2.14),('15529','2013-08-23','12:55:00',2.14),('15529','2013-08-23','13:00:00',2.2),('15529','2013-08-23','13:05:00',2.14),('15529','2013-08-23','13:10:00',2.16),('15529','2013-08-23','13:15:00',2.13),('15529','2013-08-23','13:20:00',2.11),('15529','2013-08-23','13:25:00',2.18),('15529','2013-08-23','13:30:00',2.12),('15529','2013-08-23','13:35:00',2.05),('15529','2013-08-23','13:40:00',2.15),('15529','2013-08-23','13:45:00',2.18),('15529','2013-08-23','13:50:00',2.1),('15529','2013-08-23','13:55:00',2.13),('15529','2013-08-23','14:00:00',2.12),('15529','2013-08-23','14:05:00',2.1),('15529','2013-08-23','14:10:00',2.1),('15529','2013-08-23','14:15:00',2.1),('15529','2013-08-23','14:20:00',2.08),('15529','2013-08-23','14:25:00',2.06),('15529','2013-08-23','14:30:00',2.05),('15529','2013-08-23','14:35:00',2.05),('15529','2013-08-23','14:40:00',2.05),('15529','2013-08-23','14:45:00',2.01),('15529','2013-08-23','14:50:00',1.99),('15529','2013-08-23','14:55:00',1.95),('15529','2013-08-23','15:00:00',1.93),('15529','2013-08-23','15:05:00',1.91),('15529','2013-08-23','15:10:00',1.89),('15529','2013-08-23','15:15:00',1.87),('15529','2013-08-23','15:20:00',1.84),('15529','2013-08-23','15:25:00',1.83),('15529','2013-08-23','15:30:00',1.78),('15529','2013-08-23','15:35:00',1.76),('15529','2013-08-23','15:40:00',1.73),('15529','2013-08-23','15:45:00',1.7),('15529','2013-08-23','15:50:00',1.68),('15529','2013-08-23','15:55:00',1.65),('15529','2013-08-23','16:00:00',1.61),('15529','2013-08-23','16:05:00',1.56),('15529','2013-08-23','16:10:00',1.55),('15529','2013-08-23','16:15:00',1.51),('15529','2013-08-23','16:20:00',1.46),('15529','2013-08-23','16:25:00',1.42),('15529','2013-08-23','16:30:00',1.39),('15529','2013-08-23','16:35:00',1.36),('15529','2013-08-23','16:40:00',1.31),('15529','2013-08-23','16:45:00',1.27),('15529','2013-08-23','16:50:00',1.22),('15529','2013-08-23','16:55:00',1.19),('15529','2013-08-23','17:00:00',1.14),('15529','2013-08-23','17:05:00',1.1),('15529','2013-08-23','17:10:00',1.05),('15529','2013-08-23','17:15:00',1.01),('15529','2013-08-22','09:15:00',1.03),('15529','2013-08-22','09:20:00',1.06),('15529','2013-08-22','09:25:00',1.1),('15529','2013-08-22','09:30:00',1.13),('15529','2013-08-22','09:35:00',1.17),('15529','2013-08-22','09:40:00',1.2),('15529','2013-08-22','09:45:00',1.23),('15529','2013-08-22','09:50:00',1.28),('15529','2013-08-22','09:55:00',1.31),('15529','2013-08-22','10:00:00',1.34),('15529','2013-08-22','10:05:00',1.38),('15529','2013-08-22','10:10:00',1.43),('15529','2013-08-22','10:15:00',1.42),('15529','2013-08-22','10:20:00',1.48),('15529','2013-08-22','10:25:00',1.48),('15529','2013-08-22','10:30:00',1.53),('15529','2013-08-22','10:35:00',1.57),('15529','2013-08-22','10:40:00',1.59),('15529','2013-08-22','10:45:00',1.65),('15529','2013-08-22','10:50:00',1.74),('15529','2013-08-22','10:55:00',1.74),('15529','2013-08-22','11:00:00',1.7),('15529','2013-08-22','11:05:00',1.76),('15529','2013-08-22','11:10:00',1.7),('15529','2013-08-22','11:15:00',1.6),('15529','2013-08-22','11:20:00',1.92),('15529','2013-08-22','11:25:00',1.92),('15529','2013-08-22','11:30:00',1.72),('15529','2013-08-22','11:50:00',1.82),('15529','2013-08-22','12:05:00',1.93),('15529','2013-08-22','12:10:00',2.13),('15529','2013-08-22','12:15:00',2.03),('15529','2013-08-22','12:20:00',2.11),('15529','2013-08-22','12:25:00',2.17),('15529','2013-08-22','12:40:00',1.16),('15529','2013-08-22','12:50:00',1.93),('15529','2013-08-22','12:55:00',2.2),('15529','2013-08-22','13:00:00',1.05),('15529','2013-08-22','13:05:00',2.32),('15529','2013-08-22','13:10:00',1.38),('15529','2013-08-22','13:15:00',2.09),('15529','2013-08-22','13:20:00',2.15),('15529','2013-08-22','13:25:00',1.91),('15529','2013-08-22','13:30:00',2.09),('15529','2013-08-22','13:35:00',2.1),('15529','2013-08-22','13:40:00',1.47),('15529','2013-08-22','13:45:00',1.96),('15529','2013-08-22','13:50:00',1.98),('15529','2013-08-22','13:55:00',2.17),('15529','2013-08-22','14:00:00',1.95),('15529','2013-08-22','14:05:00',2.13),('15529','2013-08-22','14:10:00',1.84),('15529','2013-08-22','14:15:00',2.06),('15529','2013-08-22','14:20:00',2.03),('15529','2013-08-22','14:25:00',2.04),('15529','2013-08-22','14:30:00',2),('15529','2013-08-22','14:35:00',2.03),('15529','2013-08-22','14:40:00',1.98),('15529','2013-08-22','14:45:00',1.97),('15529','2013-08-22','14:50:00',1.95),('15529','2013-08-22','14:55:00',1.97),('15529','2013-08-22','15:00:00',1.92),('15529','2013-08-22','15:05:00',1.87),('15529','2013-08-22','15:10:00',1.88),('15529','2013-08-22','15:15:00',1.82),('15529','2013-08-22','15:20:00',1.84),('15529','2013-08-22','15:25:00',1.81),('15529','2013-08-22','15:30:00',1.84),('15529','2013-08-22','15:35:00',1.66),('15529','2013-08-22','15:40:00',1.7),('15529','2013-08-22','15:45:00',1.64),('15529','2013-08-22','15:50:00',1.52),('15529','2013-08-22','15:55:00',1.62),('15529','2013-08-22','16:00:00',1.53),('15529','2013-08-22','16:05:00',1.44),('15529','2013-08-22','16:10:00',1.33),('15529','2013-08-22','16:15:00',1.51),('15529','2013-08-22','16:20:00',1.51),('15529','2013-08-22','16:25:00',1.48),('15529','2013-08-22','16:30:00',1.44),('15529','2013-08-22','16:35:00',1.41),('15529','2013-08-22','16:40:00',1.35),('15529','2013-08-22','16:45:00',1.28),('15529','2013-08-22','16:50:00',1.23),('15529','2013-08-22','16:55:00',1.19),('15529','2013-08-22','17:00:00',1.13),('15529','2013-08-22','17:05:00',1.08),('15529','2013-08-22','17:10:00',1.03),('15529','2013-08-21','09:00:00',1),('15529','2013-08-21','09:05:00',1.11),('15529','2013-08-21','09:10:00',1.15),('15529','2013-08-21','09:15:00',1.02),('15529','2013-08-21','09:20:00',1.27),('15529','2013-08-21','09:25:00',1.32),('15529','2013-08-21','09:30:00',1.4),('15529','2013-08-21','09:35:00',1.17),('15529','2013-08-21','09:40:00',1.39),('15529','2013-08-21','09:45:00',1.4),('15529','2013-08-21','09:50:00',1.39),('15529','2013-08-21','09:55:00',1.46),('15529','2013-08-21','10:00:00',1.52),('15529','2013-08-21','10:05:00',1.55),('15529','2013-08-21','10:10:00',1.56),('15529','2013-08-21','10:15:00',1.55),('15529','2013-08-21','10:20:00',1.58),('15529','2013-08-21','10:25:00',1.63),('15529','2013-08-21','10:30:00',1.66),('15529','2013-08-21','10:35:00',1.68),('15529','2013-08-21','10:40:00',1.69),('15529','2013-08-21','10:45:00',1.72),('15529','2013-08-21','10:50:00',1.75),('15529','2013-08-21','10:55:00',1.78),('15529','2013-08-21','11:00:00',1.79),('15529','2013-08-21','11:05:00',1.82),('15529','2013-08-21','11:10:00',1.82),('15529','2013-08-21','11:15:00',1.87),('15529','2013-08-21','11:20:00',1.88),('15529','2013-08-21','11:25:00',1.91),('15529','2013-08-21','11:30:00',1.9),('15529','2013-08-21','11:35:00',1.9),('15529','2013-08-21','11:40:00',1.95),('15529','2013-08-21','11:45:00',1.95),('15529','2013-08-21','11:50:00',1.94),('15529','2013-08-21','11:55:00',1.95),('15529','2013-08-21','12:00:00',1.94),('15529','2013-08-21','12:05:00',1.94),('15529','2013-08-21','12:10:00',1.99),('15529','2013-08-21','12:15:00',1.99),('15529','2013-08-21','12:20:00',2.01),('15529','2013-08-21','12:25:00',2),('15529','2013-08-21','12:30:00',1.94),('15529','2013-08-21','12:35:00',2),('15529','2013-08-21','12:40:00',2.02),('15529','2013-08-21','12:45:00',2.04),('15529','2013-08-21','12:50:00',2.04),('15529','2013-08-21','12:55:00',2.06),('15529','2013-08-21','13:00:00',2.06),('15529','2013-08-21','13:05:00',2.07),('15529','2013-08-21','13:10:00',2.03),('15529','2013-08-21','13:15:00',2.05),('15529','2013-08-21','13:20:00',2.03),('15529','2013-08-21','13:25:00',1.99),('15529','2013-08-21','13:30:00',2.01),('15529','2013-08-21','13:35:00',2.01),('15529','2013-08-21','13:40:00',2.03),('15529','2013-08-21','13:45:00',2),('15529','2013-08-21','13:50:00',1.95),('15529','2013-08-21','13:55:00',1.93),('15529','2013-08-21','14:00:00',1.95),('15529','2013-08-21','14:05:00',1.97),('15529','2013-08-21','14:10:00',1.97),('15529','2013-08-21','14:15:00',1.96),('15529','2013-08-21','14:20:00',1.96),('15529','2013-08-21','14:25:00',1.9),('15529','2013-08-21','14:30:00',1.78),('15529','2013-08-21','14:35:00',1.08),('15529','2013-08-21','14:50:00',1.96),('15529','2013-08-21','14:55:00',1.86),('15529','2013-08-21','15:00:00',1.86),('15529','2013-08-21','15:05:00',1.84),('15529','2013-08-21','15:10:00',1.82),('15529','2013-08-21','15:15:00',1.79),('15529','2013-08-21','15:20:00',1.75),('15529','2013-08-21','15:25:00',1.74),('15529','2013-08-21','15:30:00',1.71),('15529','2013-08-21','15:35:00',1.68),('15529','2013-08-21','15:40:00',1.64),('15529','2013-08-21','15:45:00',1.63),('15529','2013-08-21','15:50:00',1.58),('15529','2013-08-21','15:55:00',1.56),('15529','2013-08-21','16:00:00',1.54),('15529','2013-08-21','16:05:00',1.51),('15529','2013-08-21','16:10:00',1.48),('15529','2013-08-21','16:15:00',1.44),('15529','2013-08-21','16:20:00',1.4),('15529','2013-08-21','16:25:00',1.36),('15529','2013-08-21','16:30:00',1.33),('15529','2013-08-21','16:35:00',1.29),('15529','2013-08-21','16:40:00',1.24),('15529','2013-08-21','16:45:00',1.2),('15529','2013-08-21','16:50:00',1.16),('15529','2013-08-21','16:55:00',1.1),('15529','2013-08-21','17:00:00',1.08),('15529','2013-08-21','17:05:00',1.02),('15529','2013-08-20','09:55:00',1.31),('15529','2013-08-20','10:00:00',1.71),('15529','2013-08-20','10:05:00',1.67),('15529','2013-08-20','10:10:00',1.53),('15529','2013-08-20','10:15:00',1.45),('15529','2013-08-20','10:20:00',1.48),('15529','2013-08-20','10:25:00',1.54),('15529','2013-08-20','10:30:00',1.45),('15529','2013-08-20','10:35:00',1.74),('15529','2013-08-20','10:40:00',1.43),('15529','2013-08-20','10:45:00',1.54),('15529','2013-08-20','10:50:00',1.6),('15529','2013-08-20','10:55:00',1.23),('15529','2013-08-20','11:00:00',1.35),('15529','2013-08-20','11:15:00',1.01),('15529','2013-08-20','11:20:00',1.6),('15529','2013-08-20','11:25:00',2.16),('15529','2013-08-20','11:30:00',2.27),('15529','2013-08-20','11:35:00',2.22),('15529','2013-08-20','11:40:00',2.14),('15529','2013-08-20','11:45:00',2.13),('15529','2013-08-20','11:50:00',2.04),('15529','2013-08-20','11:55:00',2.11),('15529','2013-08-20','12:00:00',2.13),('15529','2013-08-20','12:05:00',2.12),('15529','2013-08-20','12:10:00',2.09),('15529','2013-08-20','12:15:00',2.09),('15529','2013-08-20','12:20:00',2.15),('15529','2013-08-20','12:25:00',2.12),('15529','2013-08-20','12:30:00',1.97),('15529','2013-08-20','12:35:00',1.75),('15529','2013-08-20','12:40:00',1.9),('15529','2013-08-20','12:45:00',2.06),('15529','2013-08-20','12:50:00',1.91),('15529','2013-08-20','12:55:00',2.02),('15529','2013-08-20','13:00:00',2.01),('15529','2013-08-20','13:05:00',1.99),('15529','2013-08-20','13:10:00',2.07),('15529','2013-08-20','13:15:00',2.08),('15529','2013-08-20','13:20:00',2.12),('15529','2013-08-20','13:25:00',2.07),('15529','2013-08-20','13:30:00',2.08),('15529','2013-08-20','13:35:00',2),('15529','2013-08-20','13:40:00',1.95),('15529','2013-08-20','13:45:00',1.92),('15529','2013-08-20','13:50:00',1.97),('15529','2013-08-20','13:55:00',2.07),('15529','2013-08-20','14:00:00',2.06),('15529','2013-08-20','14:05:00',1.92),('15529','2013-08-20','14:10:00',2.06),('15529','2013-08-20','14:15:00',1.92),('15529','2013-08-20','14:20:00',1.32),('15529','2013-08-20','14:25:00',1.35),('15529','2013-08-20','14:30:00',1.94),('15529','2013-08-20','14:35:00',1.89),('15529','2013-08-20','14:40:00',1.82),('15529','2013-08-20','14:45:00',1.8),('15529','2013-08-20','14:50:00',1.81),('15529','2013-08-20','14:55:00',1.83),('15529','2013-08-20','15:00:00',1.84),('15529','2013-08-20','15:05:00',1.74),('15529','2013-08-20','15:10:00',1.73),('15529','2013-08-20','15:15:00',1.6),('15529','2013-08-20','15:20:00',1.58),('15529','2013-08-20','15:25:00',1.51),('15529','2013-08-20','15:30:00',1.46),('15529','2013-08-20','15:35:00',1.37),('15529','2013-08-20','15:40:00',1.38),('15529','2013-08-20','15:45:00',1.42),('15529','2013-08-20','15:50:00',1.41),('15529','2013-08-20','15:55:00',1.42),('15529','2013-08-20','16:00:00',1.32),('15529','2013-08-20','16:05:00',1.26),('15529','2013-08-20','16:10:00',1.21),('15529','2013-08-20','16:15:00',1.24),('15529','2013-08-20','16:20:00',1.3),('15529','2013-08-20','16:25:00',1.33),('15529','2013-08-20','16:30:00',1.39),('15529','2013-08-20','16:35:00',1.36),('15529','2013-08-20','16:40:00',1.28),('15529','2013-08-20','16:45:00',1.25),('15529','2013-08-20','16:50:00',1.21),('15529','2013-08-20','16:55:00',1.17),('15529','2013-08-20','17:00:00',1.14),('15529','2013-08-20','17:05:00',1.11),('15529','2013-08-20','17:10:00',1.07),('15529','2013-08-20','17:15:00',1.03),('15529','2013-08-20','17:20:00',1.01),('15529','2013-08-19','09:25:00',1.38),('15529','2013-08-19','09:30:00',1.22),('15529','2013-08-19','09:35:00',1.22),('15529','2013-08-19','10:35:00',1.22),('15529','2013-08-19','10:45:00',1.24),('15529','2013-08-19','10:55:00',1.91),('15529','2013-08-19','11:10:00',1.78),('15529','2013-08-19','11:15:00',2.13),('15529','2013-08-19','11:20:00',2.11),('15529','2013-08-19','11:25:00',1.49),('15529','2013-08-19','11:30:00',2.26),('15529','2013-08-19','11:35:00',2.14),('15529','2013-08-19','11:40:00',1.17),('15529','2013-08-19','11:45:00',1.43),('15529','2013-08-19','11:50:00',1.55),('15529','2013-08-19','13:30:00',1.03),('15529','2013-08-19','13:35:00',1.23),('15529','2013-08-19','13:40:00',1.34),('15529','2013-08-19','13:45:00',1.87),('15529','2013-08-19','13:50:00',2.33),('15529','2013-08-19','13:55:00',2.2),('15529','2013-08-19','14:00:00',2.19),('15529','2013-08-19','14:05:00',2.17),('15529','2013-08-19','14:10:00',2.19),('15529','2013-08-19','14:15:00',2.08),('15529','2013-08-19','14:20:00',2.15),('15529','2013-08-19','14:25:00',2.19),('15529','2013-08-19','14:30:00',2.05),('15529','2013-08-19','14:35:00',1.6),('15529','2013-08-19','14:40:00',1.4),('15529','2013-08-19','14:45:00',1.93),('15529','2013-08-19','14:50:00',1.5),('15529','2013-08-19','14:55:00',1.43),('15529','2013-08-19','15:00:00',1.93),('15529','2013-08-19','15:05:00',2.04),('15529','2013-08-19','15:10:00',1.98),('15529','2013-08-19','15:15:00',1.96),('15529','2013-08-19','15:20:00',1.95),('15529','2013-08-19','15:25:00',1.91),('15529','2013-08-19','15:30:00',1.91),('15529','2013-08-19','15:35:00',1.92),('15529','2013-08-19','15:40:00',1.92),('15529','2013-08-19','15:45:00',1.9),('15529','2013-08-19','15:50:00',1.95),('15529','2013-08-19','15:55:00',1.94),('15529','2013-08-19','16:00:00',1.87),('15529','2013-08-19','16:05:00',1.85),('15529','2013-08-19','16:10:00',1.81),('15529','2013-08-19','16:15:00',1.79),('15529','2013-08-19','16:20:00',1.77),('15529','2013-08-19','16:25:00',1.72),('15529','2013-08-19','16:30:00',1.62),('15529','2013-08-19','16:35:00',1.53),('15529','2013-08-19','16:40:00',1.51),('15529','2013-08-19','16:45:00',1.46),('15529','2013-08-19','16:50:00',1.37),('15529','2013-08-19','16:55:00',1.35),('15529','2013-08-19','17:00:00',1.22),('15529','2013-08-19','17:05:00',1.14),('15529','2013-08-19','17:10:00',1.11),('15529','2013-08-19','17:15:00',1.06),('15529','2013-08-19','17:20:00',1.01),('15529','2014-04-09','08:50:00',1.04),('15529','2014-04-09','08:55:00',1.09),('15529','2014-04-09','09:00:00',1.14),('15529','2014-04-09','09:05:00',1.2),('15529','2014-04-09','09:10:00',1.24),('15529','2014-04-09','09:15:00',1.27),('15529','2014-04-09','09:20:00',1.31),('15529','2014-04-09','09:25:00',1.38),('15529','2014-04-09','09:30:00',1.43),('15529','2014-04-09','09:35:00',1.48),('15529','2014-04-09','09:40:00',1.5),('15529','2014-04-09','09:45:00',1.54),('15529','2014-04-09','09:50:00',1.6),('15529','2014-04-09','09:55:00',1.63),('15529','2014-04-09','10:00:00',1.67),('15529','2014-04-09','10:05:00',1.71),('15529','2014-04-09','10:10:00',1.75),('15529','2014-04-09','10:15:00',1.75),('15529','2014-04-09','10:20:00',1.78),('15529','2014-04-09','10:25:00',1.82),('15529','2014-04-09','10:30:00',1.86),('15529','2014-04-09','10:35:00',1.92),('15529','2014-04-09','10:40:00',1.95),('15529','2014-04-09','10:45:00',1.94),('15529','2014-04-09','10:50:00',1.93),('15529','2014-04-09','10:55:00',1.97),('15529','2014-04-09','11:00:00',1.99),('15529','2014-04-09','11:05:00',2.08),('15529','2014-04-09','11:10:00',2.02),('15529','2014-04-09','11:15:00',2.08),('15529','2014-04-09','11:20:00',2.13),('15529','2014-04-09','11:25:00',2.16),('15529','2014-04-09','11:30:00',2.18),('15529','2014-04-09','11:35:00',2.2),('15529','2014-04-09','11:40:00',2.14),('15529','2014-04-09','11:45:00',2.2),('15529','2014-04-09','11:50:00',2.15),('15529','2014-04-09','11:55:00',2.24),('15529','2014-04-09','12:00:00',2.18),('15529','2014-04-09','12:05:00',2.06),('15529','2014-04-09','12:10:00',2.22),('15529','2014-04-09','12:15:00',2.25),('15529','2014-04-09','12:20:00',2.21),('15529','2014-04-09','12:25:00',2.13),('15529','2014-04-09','12:30:00',2.17),('15529','2014-04-09','12:35:00',2.29),('15529','2014-04-09','12:40:00',2.11),('15529','2014-04-09','12:45:00',2.18),('15529','2014-04-09','12:50:00',2.22),('15529','2014-04-09','12:55:00',2.25),('15529','2014-04-09','13:00:00',2.21),('15529','2014-04-09','13:05:00',2.19),('15529','2014-04-09','13:10:00',2.32),('15529','2014-04-09','13:15:00',2.27),('15529','2014-04-09','13:20:00',2.16),('15529','2014-04-09','13:25:00',2.28),('15529','2014-04-09','13:30:00',2.32),('15529','2014-04-09','13:35:00',2.37),('15529','2014-04-09','13:40:00',2.29),('15529','2014-04-09','13:45:00',2.37),('15529','2014-04-09','13:50:00',2.37),('15529','2014-04-09','13:55:00',2.34),('15529','2014-04-09','14:00:00',2.32),('15529','2014-04-09','14:05:00',2.27),('15529','2014-04-09','14:10:00',2.21),('15529','2014-04-09','14:15:00',2.29),('15529','2014-04-09','14:20:00',2.27),('15529','2014-04-09','14:25:00',2.22),('15529','2014-04-09','14:30:00',2.19),('15529','2014-04-09','14:35:00',2.2),('15529','2014-04-09','14:40:00',2.18),('15529','2014-04-09','14:45:00',1.95),('15529','2014-04-09','14:50:00',2.14),('15529','2014-04-09','14:55:00',2.12),('15529','2014-04-09','15:00:00',2.1),('15529','2014-04-09','15:05:00',2.07),('15529','2014-04-09','15:10:00',2.02),('15529','2014-04-09','15:15:00',2),('15529','2014-04-09','15:20:00',2.01),('15529','2014-04-09','15:25:00',1.91),('15529','2014-04-09','15:30:00',1.8),('15529','2014-04-09','15:35:00',1.7),('15529','2014-04-09','15:40:00',1.74),('15529','2014-04-09','15:45:00',1.74),('15529','2014-04-09','15:50:00',1.69),('15529','2014-04-09','15:55:00',1.74),('15529','2014-04-09','16:00:00',1.73),('15529','2014-04-09','16:05:00',1.74),('15529','2014-04-09','16:10:00',1.77),('15529','2014-04-09','16:15:00',1.73),('15529','2014-04-09','16:20:00',1.63),('15529','2014-04-09','16:25:00',1.58),('15529','2014-04-09','16:30:00',1.58),('15529','2014-04-09','16:35:00',1.53),('15529','2014-04-09','16:40:00',1.49),('15529','2014-04-09','16:45:00',1.47),('15529','2014-04-09','16:50:00',1.38),('15529','2014-04-09','16:55:00',1.35),('15529','2014-04-09','17:00:00',1.29),('15529','2014-04-09','17:05:00',1.24),('15529','2014-04-09','17:10:00',1.2),('15529','2014-04-09','17:15:00',1.12),('15529','2014-04-09','17:20:00',1.08),('15529','2014-04-09','17:25:00',1.02),('15529','2013-08-18','09:05:00',1.04),('15529','2013-08-18','09:10:00',1.08),('15529','2013-08-18','09:15:00',1.13),('15529','2013-08-18','09:20:00',1.17),('15529','2013-08-18','09:25:00',1.21),('15529','2013-08-18','09:30:00',1.26),('15529','2013-08-18','09:35:00',1.28),('15529','2013-08-18','09:40:00',1.32),('15529','2013-08-18','09:45:00',1.36),('15529','2013-08-18','09:50:00',1.39),('15529','2013-08-18','09:55:00',1.4),('15529','2013-08-18','10:00:00',1.44),('15529','2013-08-18','10:05:00',1.48),('15529','2013-08-18','10:10:00',1.49),('15529','2013-08-18','10:15:00',1.52),('15529','2013-08-18','10:20:00',1.57),('15529','2013-08-18','10:25:00',1.62),('15529','2013-08-18','10:30:00',1.64),('15529','2013-08-18','10:35:00',1.67),('15529','2013-08-18','10:40:00',1.71),('15529','2013-08-18','10:45:00',1.72),('15529','2013-08-18','10:50:00',1.75),('15529','2013-08-18','10:55:00',1.76),('15529','2013-08-18','11:00:00',1.74),('15529','2013-08-18','11:05:00',1.79),('15529','2013-08-18','11:10:00',1.79),('15529','2013-08-18','11:15:00',1.82),('15529','2013-08-18','11:20:00',1.85),('15529','2013-08-18','11:25:00',1.87),('15529','2013-08-18','11:30:00',1.91),('15529','2013-08-18','11:35:00',1.93),('15529','2013-08-18','11:40:00',1.94),('15529','2013-08-18','11:45:00',1.96),('15529','2013-08-18','11:50:00',1.98),('15529','2013-08-18','11:55:00',1.99),('15529','2013-08-18','12:00:00',1.99),('15529','2013-08-18','12:05:00',1.98),('15529','2013-08-18','12:10:00',2),('15529','2013-08-18','12:15:00',2),('15529','2013-08-18','12:20:00',2.03),('15529','2013-08-18','12:25:00',2),('15529','2013-08-18','12:30:00',1.99),('15529','2013-08-18','12:35:00',2.04),('15529','2013-08-18','12:40:00',2.06),('15529','2013-08-18','12:45:00',2.07),('15529','2013-08-18','12:50:00',2.09),('15529','2013-08-18','12:55:00',2.1),('15529','2013-08-18','13:00:00',2.1),('15529','2013-08-18','13:05:00',2.1),('15529','2013-08-18','13:10:00',2.11),('15529','2013-08-18','13:15:00',2.14),('15529','2013-08-18','13:20:00',2.11),('15529','2013-08-18','13:25:00',2.08),('15529','2013-08-18','13:30:00',2.1),('15529','2013-08-18','13:35:00',2.07),('15529','2013-08-18','13:40:00',2.11),('15529','2013-08-18','13:45:00',2.08),('15529','2013-08-18','13:50:00',2.08),('15529','2013-08-18','13:55:00',2.05),('15529','2013-08-18','14:00:00',2.08),('15529','2013-08-18','14:05:00',2.06),('15529','2013-08-18','14:10:00',2.04),('15529','2013-08-18','14:15:00',2.05),('15529','2013-08-18','14:20:00',2.01),('15529','2013-08-18','14:25:00',2.04),('15529','2013-08-18','14:30:00',2.03),('15529','2013-08-18','14:35:00',2),('15529','2013-08-18','14:40:00',2),('15529','2013-08-18','14:45:00',1.98),('15529','2013-08-18','14:50:00',1.97),('15529','2013-08-18','14:55:00',1.95),('15529','2013-08-18','15:00:00',1.92),('15529','2013-08-18','15:05:00',1.92),('15529','2013-08-18','15:10:00',1.9),('15529','2013-08-18','15:15:00',1.87),('15529','2013-08-18','15:20:00',1.85),('15529','2013-08-18','15:25:00',1.85),('15529','2013-08-18','15:30:00',1.81),('15529','2013-08-18','15:35:00',1.79),('15529','2013-08-18','15:40:00',1.76),('15529','2013-08-18','15:45:00',1.74),('15529','2013-08-18','15:50:00',1.72),('15529','2013-08-18','15:55:00',1.68),('15529','2013-08-18','16:00:00',1.64),('15529','2013-08-18','16:05:00',1.6),('15529','2013-08-18','16:10:00',1.57),('15529','2013-08-18','16:15:00',1.53),('15529','2013-08-18','16:20:00',1.5),('15529','2013-08-18','16:25:00',1.46),('15529','2013-08-18','16:30:00',1.43),('15529','2013-08-18','16:35:00',1.39),('15529','2013-08-18','16:40:00',1.35),('15529','2013-08-18','16:45:00',1.32),('15529','2013-08-18','16:50:00',1.28),('15529','2013-08-18','16:55:00',1.24),('15529','2013-08-18','17:00:00',1.19),('15529','2013-08-18','17:05:00',1.14),('15529','2013-08-18','17:10:00',1.09),('15529','2013-08-18','17:15:00',1.05),('15529','2013-08-18','17:20:00',1.01),('15529','2013-08-17','09:00:00',1.01),('15529','2013-08-17','09:05:00',1.06),('15529','2013-08-17','09:10:00',1.1),('15529','2013-08-17','09:15:00',1.14),('15529','2013-08-17','09:20:00',1.19),('15529','2013-08-17','09:25:00',1.22),('15529','2013-08-17','09:30:00',1.26),('15529','2013-08-17','09:35:00',1.32),('15529','2013-08-17','09:40:00',1.26),('15529','2013-08-17','09:45:00',1.31),('15529','2013-08-17','09:50:00',1.24),('15529','2013-08-17','09:55:00',1.44),('15529','2013-08-17','10:00:00',1.16),('15529','2013-08-17','10:05:00',1.45),('15529','2013-08-17','10:10:00',1.55),('15529','2013-08-17','10:15:00',1.57),('15529','2013-08-17','10:20:00',1.6),('15529','2013-08-17','10:25:00',1.62),('15529','2013-08-17','10:30:00',1.63),('15529','2013-08-17','10:35:00',1.67),('15529','2013-08-17','10:40:00',1.69),('15529','2013-08-17','10:45:00',1.7),('15529','2013-08-17','10:50:00',1.65),('15529','2013-08-17','10:55:00',1.74),('15529','2013-08-17','11:00:00',1.78),('15529','2013-08-17','11:05:00',1.81),('15529','2013-08-17','11:10:00',1.83),('15529','2013-08-17','11:15:00',1.87),('15529','2013-08-17','11:20:00',1.86),('15529','2013-08-17','11:25:00',1.88),('15529','2013-08-17','11:30:00',1.9),('15529','2013-08-17','11:35:00',1.89),('15529','2013-08-17','11:40:00',1.92),('15529','2013-08-17','11:45:00',1.95),('15529','2013-08-17','11:50:00',1.99),('15529','2013-08-17','11:55:00',2),('15529','2013-08-17','12:00:00',2.04),('15529','2013-08-17','12:05:00',2.04),('15529','2013-08-17','12:10:00',1.92),('15529','2013-08-17','12:20:00',1.44),('15529','2013-08-17','12:30:00',1.47),('15529','2013-08-17','12:35:00',2.05),('15529','2013-08-17','12:40:00',1.03),('15529','2013-08-17','12:45:00',2.14),('15529','2013-08-17','12:50:00',2.2),('15529','2013-08-17','12:55:00',2.21),('15529','2013-08-17','13:00:00',2.15),('15529','2013-08-17','13:05:00',2.1),('15529','2013-08-17','13:10:00',2.17),('15529','2013-08-17','13:15:00',2.1),('15529','2013-08-17','13:20:00',2.13),('15529','2013-08-17','13:25:00',2.11),('15529','2013-08-17','13:30:00',2.15),('15529','2013-08-17','13:35:00',2.1),('15529','2013-08-17','13:40:00',2.11),('15529','2013-08-17','13:45:00',2.11),('15529','2013-08-17','13:50:00',2.12),('15529','2013-08-17','13:55:00',2.1),('15529','2013-08-17','14:00:00',2.13),('15529','2013-08-17','14:05:00',2.13),('15529','2013-08-17','14:10:00',2.07),('15529','2013-08-17','14:15:00',2.06),('15529','2013-08-17','14:20:00',2.07),('15529','2013-08-17','14:25:00',2.06),('15529','2013-08-17','14:30:00',2.04),('15529','2013-08-17','14:35:00',2.04),('15529','2013-08-17','14:40:00',2.03),('15529','2013-08-17','14:45:00',2),('15529','2013-08-17','14:50:00',1.98),('15529','2013-08-17','14:55:00',1.95),('15529','2013-08-17','15:00:00',1.95),('15529','2013-08-17','15:05:00',1.94),('15529','2013-08-17','15:10:00',1.92),('15529','2013-08-17','15:15:00',1.88),('15529','2013-08-17','15:20:00',1.86),('15529','2013-08-17','15:25:00',1.83),('15529','2013-08-17','15:30:00',1.8),('15529','2013-08-17','15:35:00',1.79),('15529','2013-08-17','15:40:00',1.76),('15529','2013-08-17','15:45:00',1.72),('15529','2013-08-17','15:50:00',1.7),('15529','2013-08-17','15:55:00',1.67),('15529','2013-08-17','16:00:00',1.63),('15529','2013-08-17','16:05:00',1.59),('15529','2013-08-17','16:10:00',1.57),('15529','2013-08-17','16:15:00',1.54),('15529','2013-08-17','16:20:00',1.49),('15529','2013-08-17','16:25:00',1.47),('15529','2013-08-17','16:30:00',1.43),('15529','2013-08-17','16:35:00',1.38),('15529','2013-08-17','16:40:00',1.35),('15529','2013-08-17','16:45:00',1.31),('15529','2013-08-17','16:50:00',1.27),('15529','2013-08-17','16:55:00',1.24),('15529','2013-08-17','17:00:00',1.19),('15529','2013-08-17','17:05:00',1.15),('15529','2013-08-17','17:10:00',1.11),('15529','2013-08-17','17:15:00',1.07),('15529','2013-08-17','17:20:00',1.02),('15529','2013-08-16','09:00:00',1.01),('15529','2013-08-16','09:05:00',1.05),('15529','2013-08-16','09:10:00',1.1),('15529','2013-08-16','09:15:00',1.14),('15529','2013-08-16','09:20:00',1.19),('15529','2013-08-16','09:25:00',1.23),('15529','2013-08-16','09:30:00',1.26),('15529','2013-08-16','09:35:00',1.3),('15529','2013-08-16','09:40:00',1.34),('15529','2013-08-16','09:45:00',1.38),('15529','2013-08-16','09:50:00',1.41),('15529','2013-08-16','09:55:00',1.44),('15529','2013-08-16','10:00:00',1.49),('15529','2013-08-16','10:05:00',1.52),('15529','2013-08-16','10:10:00',1.55),('15529','2013-08-16','10:15:00',1.58),('15529','2013-08-16','10:20:00',1.61),('15529','2013-08-16','10:25:00',1.63),('15529','2013-08-16','10:30:00',1.66),('15529','2013-08-16','10:35:00',1.68),('15529','2013-08-16','10:40:00',1.71),('15529','2013-08-16','10:45:00',1.72),('15529','2013-08-16','10:50:00',1.74),('15529','2013-08-16','10:55:00',1.77),('15529','2013-08-16','11:00:00',1.8),('15529','2013-08-16','11:05:00',1.81),('15529','2013-08-16','11:10:00',1.84),('15529','2013-08-16','11:15:00',1.87),('15529','2013-08-16','11:20:00',1.88),('15529','2013-08-16','11:25:00',1.89),('15529','2013-08-16','11:30:00',1.91),('15529','2013-08-16','11:35:00',1.93),('15529','2013-08-16','11:40:00',1.92),('15529','2013-08-16','11:45:00',1.9),('15529','2013-08-16','11:50:00',1.97),('15529','2013-08-16','11:55:00',1.92),('15529','2013-08-16','12:00:00',2),('15529','2013-08-16','12:05:00',2.05),('15529','2013-08-16','12:10:00',2.08),('15529','2013-08-16','12:15:00',2.03),('15529','2013-08-16','12:20:00',2.02),('15529','2013-08-16','12:25:00',2.09),('15529','2013-08-16','12:30:00',2.07),('15529','2013-08-16','12:35:00',2.1),('15529','2013-08-16','12:40:00',2.07),('15529','2013-08-16','12:45:00',2.09),('15529','2013-08-16','12:50:00',2.12),('15529','2013-08-16','12:55:00',2.1),('15529','2013-08-16','13:00:00',1.33),('15529','2013-08-16','13:10:00',2.17),('15529','2013-08-16','13:15:00',2.12),('15529','2013-08-16','13:20:00',2.08),('15529','2013-08-16','13:25:00',2.03),('15529','2013-08-16','13:30:00',1.24),('15529','2013-08-16','13:35:00',2.12),('15529','2013-08-16','13:40:00',2.1),('15529','2013-08-16','13:45:00',1.7),('15529','2013-08-16','14:00:00',1.99),('15529','2013-08-16','14:05:00',2.09),('15529','2013-08-16','14:10:00',2.04),('15529','2013-08-16','14:15:00',2.04),('15529','2013-08-16','14:20:00',2.04),('15529','2013-08-16','14:25:00',2.02),('15529','2013-08-16','14:30:00',2.02),('15529','2013-08-16','14:35:00',2.02),('15529','2013-08-16','14:40:00',1.99),('15529','2013-08-16','14:45:00',1.99),('15529','2013-08-16','14:50:00',1.99),('15529','2013-08-16','14:55:00',1.93),('15529','2013-08-16','15:00:00',1.93),('15529','2013-08-16','15:05:00',1.94),('15529','2013-08-16','15:10:00',1.89),('15529','2013-08-16','15:15:00',1.87),('15529','2013-08-16','15:20:00',1.86),('15529','2013-08-16','15:25:00',1.85),('15529','2013-08-16','15:30:00',1.81),('15529','2013-08-16','15:35:00',1.8),('15529','2013-08-16','15:40:00',1.75),('15529','2013-08-16','15:45:00',1.74),('15529','2013-08-16','15:50:00',1.7),('15529','2013-08-16','15:55:00',1.68),('15529','2013-08-16','16:00:00',1.65),('15529','2013-08-16','16:05:00',1.63),('15529','2013-08-16','16:10:00',1.6),('15529','2013-08-16','16:15:00',1.57),('15529','2013-08-16','16:20:00',1.53),('15529','2013-08-16','16:25:00',1.49),('15529','2013-08-16','16:30:00',1.46),('15529','2013-08-16','16:35:00',1.42),('15529','2013-08-16','16:40:00',1.38),('15529','2013-08-16','16:45:00',1.3),('15529','2013-08-16','16:50:00',1.3),('15529','2013-08-16','16:55:00',1.26),('15529','2013-08-16','17:00:00',1.22),('15529','2013-08-16','17:05:00',1.17),('15529','2013-08-16','17:10:00',1.02),('15529','2013-08-16','17:15:00',1.08),('15529','2013-08-16','17:20:00',1.01),('15529','2013-08-16','17:25:00',1.04),('15529','2013-08-15','09:00:00',1.02),('15529','2013-08-15','09:05:00',1.07),('15529','2013-08-15','09:10:00',1.12),('15529','2013-08-15','09:15:00',1.17),('15529','2013-08-15','09:20:00',1.21),('15529','2013-08-15','09:25:00',1.26),('15529','2013-08-15','09:30:00',1.3),('15529','2013-08-15','09:35:00',1.34),('15529','2013-08-15','09:40:00',1.37),('15529','2013-08-15','09:45:00',1.41),('15529','2013-08-15','09:50:00',1.45),('15529','2013-08-15','09:55:00',1.49),('15529','2013-08-15','10:00:00',1.53),('15529','2013-08-15','10:05:00',1.56),('15529','2013-08-15','10:10:00',1.59),('15529','2013-08-15','10:15:00',1.62),('15529','2013-08-15','10:20:00',1.65),('15529','2013-08-15','10:25:00',1.69),('15529','2013-08-15','10:30:00',1.71),('15529','2013-08-15','10:35:00',1.74),('15529','2013-08-15','10:40:00',1.77),('15529','2013-08-15','10:45:00',1.79),('15529','2013-08-15','10:50:00',1.81),('15529','2013-08-15','10:55:00',1.85),('15529','2013-08-15','11:00:00',1.87),('15529','2013-08-15','11:05:00',1.9),('15529','2013-08-15','11:10:00',1.92),('15529','2013-08-15','11:15:00',1.9),('15529','2013-08-15','11:20:00',1.97),('15529','2013-08-15','11:25:00',1.96),('15529','2013-08-15','11:30:00',1.94),('15529','2013-08-15','11:35:00',1.99),('15529','2013-08-15','11:40:00',2.02),('15529','2013-08-15','11:45:00',2),('15529','2013-08-15','11:50:00',2.01),('15529','2013-08-15','11:55:00',2.05),('15529','2013-08-15','12:00:00',2.07),('15529','2013-08-15','12:05:00',2.07),('15529','2013-08-15','12:10:00',2.09),('15529','2013-08-15','12:15:00',2.11),('15529','2013-08-15','12:20:00',2.1),('15529','2013-08-15','12:25:00',2.12),('15529','2013-08-15','12:30:00',2.04),('15529','2013-08-15','12:35:00',2.1),('15529','2013-08-15','12:40:00',2.09),('15529','2013-08-15','12:45:00',2.11),('15529','2013-08-15','12:50:00',2.11),('15529','2013-08-15','12:55:00',2.1),('15529','2013-08-15','13:00:00',2.08),('15529','2013-08-15','13:05:00',2.09),('15529','2013-08-15','13:10:00',2.09),('15529','2013-08-15','13:15:00',2.06),('15529','2013-08-15','13:20:00',2.08),('15529','2013-08-15','13:25:00',2.09),('15529','2013-08-15','13:30:00',2.1),('15529','2013-08-15','13:35:00',2.1),('15529','2013-08-15','13:40:00',2.05),('15529','2013-08-15','13:45:00',2.02),('15529','2013-08-15','13:50:00',2.07),('15529','2013-08-15','13:55:00',2.06),('15529','2013-08-15','14:00:00',2.04),('15529','2013-08-15','14:05:00',2.01),('15529','2013-08-15','14:10:00',2.02),('15529','2013-08-15','14:15:00',2.01),('15529','2013-08-15','14:20:00',2),('15529','2013-08-15','14:25:00',1.98),('15529','2013-08-15','14:30:00',1.96),('15529','2013-08-15','14:35:00',1.93),('15529','2013-08-15','14:40:00',1.95),('15529','2013-08-15','14:45:00',1.92),('15529','2013-08-15','14:50:00',1.89),('15529','2013-08-15','14:55:00',1.9),('15529','2013-08-15','15:00:00',1.91),('15529','2013-08-15','15:05:00',1.88),('15529','2013-08-15','15:10:00',1.87),('15529','2013-08-15','15:15:00',1.87),('15529','2013-08-15','15:20:00',1.85),('15529','2013-08-15','15:25:00',1.82),('15529','2013-08-15','15:30:00',1.79),('15529','2013-08-15','15:35:00',1.77),('15529','2013-08-15','15:40:00',1.74),('15529','2013-08-15','15:45:00',1.72),('15529','2013-08-15','15:50:00',1.7),('15529','2013-08-15','15:55:00',1.66),('15529','2013-08-15','16:00:00',1.63),('15529','2013-08-15','16:05:00',1.6),('15529','2013-08-15','16:10:00',1.57),('15529','2013-08-15','16:15:00',1.54),('15529','2013-08-15','16:20:00',1.51),('15529','2013-08-15','16:25:00',1.47),('15529','2013-08-15','16:30:00',1.44),('15529','2013-08-15','16:35:00',1.4),('15529','2013-08-15','16:40:00',1.36),('15529','2013-08-15','16:45:00',1.31),('15529','2013-08-15','16:50:00',1.28),('15529','2013-08-15','16:55:00',1.24),('15529','2013-08-15','17:00:00',1.19),('15529','2013-08-15','17:05:00',1.15),('15529','2013-08-15','17:10:00',1.1),('15529','2013-08-15','17:15:00',1.06),('15529','2013-08-15','17:20:00',1.02),('15529','2013-08-14','09:15:00',1.2),('15529','2013-08-14','09:25:00',1.18),('15529','2013-08-14','09:30:00',1.3),('15529','2013-08-14','09:35:00',1.33),('15529','2013-08-14','09:40:00',1.38),('15529','2013-08-14','09:45:00',1.41),('15529','2013-08-14','09:50:00',1.45),('15529','2013-08-14','09:55:00',1.49),('15529','2013-08-14','10:00:00',1.52),('15529','2013-08-14','10:05:00',1.55),('15529','2013-08-14','10:10:00',1.59),('15529','2013-08-14','10:15:00',1.62),('15529','2013-08-14','10:20:00',1.66),('15529','2013-08-14','10:25:00',1.69),('15529','2013-08-14','10:30:00',1.72),('15529','2013-08-14','10:35:00',1.73),('15529','2013-08-14','10:40:00',1.78),('15529','2013-08-14','10:45:00',1.83),('15529','2013-08-14','10:50:00',1.86),('15529','2013-08-14','10:55:00',1.89),('15529','2013-08-14','11:00:00',1.93),('15529','2013-08-14','11:05:00',1.91),('15529','2013-08-14','11:10:00',1.73),('15529','2013-08-14','11:15:00',1.35),('15529','2013-08-14','11:20:00',1.36),('15529','2013-08-14','11:25:00',1.14),('15529','2013-08-14','11:30:00',1.34),('15529','2013-08-14','11:35:00',1.56),('15529','2013-08-14','11:40:00',1.81),('15529','2013-08-14','11:45:00',2.04),('15529','2013-08-14','11:50:00',2.12),('15529','2013-08-14','11:55:00',2.12),('15529','2013-08-14','12:00:00',2.14),('15529','2013-08-14','12:05:00',2.12),('15529','2013-08-14','12:10:00',2.12),('15529','2013-08-14','12:15:00',2.1),('15529','2013-08-14','12:20:00',2.11),('15529','2013-08-14','12:25:00',2.08),('15529','2013-08-14','12:30:00',2.13),('15529','2013-08-14','12:35:00',2.15),('15529','2013-08-14','12:40:00',2.14),('15529','2013-08-14','12:45:00',2.16),('15529','2013-08-14','12:50:00',2.13),('15529','2013-08-14','12:55:00',2.15),('15529','2013-08-14','13:00:00',2.17),('15529','2013-08-14','13:05:00',2.13),('15529','2013-08-14','13:10:00',2.07),('15529','2013-08-14','13:15:00',2.08),('15529','2013-08-14','13:20:00',2.07),('15529','2013-08-14','13:25:00',2.13),('15529','2013-08-14','13:30:00',2.16),('15529','2013-08-14','13:35:00',2.16),('15529','2013-08-14','13:40:00',2.1),('15529','2013-08-14','13:45:00',2.07),('15529','2013-08-14','13:50:00',2.09),('15529','2013-08-14','13:55:00',2.04),('15529','2013-08-14','14:00:00',2.05),('15529','2013-08-14','14:05:00',2.03),('15529','2013-08-14','14:10:00',2.06),('15529','2013-08-14','14:15:00',2.05),('15529','2013-08-14','14:20:00',2.04),('15529','2013-08-14','14:25:00',2.02),('15529','2013-08-14','14:30:00',1.96),('15529','2013-08-14','14:35:00',1.98),('15529','2013-08-14','14:40:00',1.97),('15529','2013-08-14','14:45:00',1.98),('15529','2013-08-14','14:50:00',1.91),('15529','2013-08-14','14:55:00',1.84),('15529','2013-08-14','15:00:00',1.87),('15529','2013-08-14','15:05:00',1.88),('15529','2013-08-14','15:10:00',1.87),('15529','2013-08-14','15:15:00',1.84),('15529','2013-08-14','15:20:00',1.8),('15529','2013-08-14','15:25:00',1.79),('15529','2013-08-14','15:30:00',1.78),('15529','2013-08-14','15:35:00',1.75),('15529','2013-08-14','15:40:00',1.73),('15529','2013-08-14','15:45:00',1.71),('15529','2013-08-14','15:50:00',1.68),('15529','2013-08-14','15:55:00',1.65),('15529','2013-08-14','16:00:00',1.57),('15529','2013-08-14','16:05:00',1.57),('15529','2013-08-14','16:10:00',1.54),('15529','2013-08-14','16:15:00',1.51),('15529','2013-08-14','16:20:00',1.48),('15529','2013-08-14','16:25:00',1.42),('15529','2013-08-14','16:30:00',1.36),('15529','2013-08-14','16:35:00',1.3),('15529','2013-08-14','16:40:00',1.31),('15529','2013-08-14','16:45:00',1.28),('15529','2013-08-14','16:50:00',1.21),('15529','2013-08-14','16:55:00',1.19),('15529','2013-08-14','17:00:00',1.17),('15529','2013-08-14','17:05:00',1.1),('15529','2013-08-14','17:10:00',1.04),('15529','2013-08-13','09:00:00',1.03),('15529','2013-08-13','09:05:00',1.13),('15529','2013-08-13','09:10:00',1.22),('15529','2013-08-13','09:15:00',1.31),('15529','2013-08-13','09:20:00',1.27),('15529','2013-08-13','09:25:00',1.18),('15529','2013-08-13','09:30:00',1.24),('15529','2013-08-13','09:50:00',1.26),('15529','2013-08-13','09:55:00',1.53),('15529','2013-08-13','10:00:00',1.56),('15529','2013-08-13','10:30:00',1.07),('15529','2013-08-13','10:35:00',1.82),('15529','2013-08-13','10:40:00',1.79),('15529','2013-08-13','10:45:00',1.8),('15529','2013-08-13','10:50:00',1.9),('15529','2013-08-13','10:55:00',1.9),('15529','2013-08-13','11:00:00',1.61),('15529','2013-08-13','11:30:00',1.6),('15529','2013-08-13','11:35:00',2.05),('15529','2013-08-13','11:40:00',1.56),('15529','2013-08-13','11:45:00',1.3),('15529','2013-08-13','12:15:00',1.17),('15529','2013-08-13','12:20:00',1.36),('15529','2013-08-13','12:30:00',1.06),('15529','2013-08-13','12:35:00',1.92),('15529','2013-08-13','12:45:00',1.39),('15529','2013-08-13','12:50:00',1.79),('15529','2013-08-13','12:55:00',1.74),('15529','2013-08-13','13:00:00',1.13),('15529','2013-08-13','13:05:00',1.88),('15529','2013-08-13','13:10:00',1.73),('15529','2013-08-13','13:15:00',1.76),('15529','2013-08-13','13:20:00',2.15),('15529','2013-08-13','13:25:00',1.78),('15529','2013-08-13','13:45:00',1.05),('15529','2013-08-13','13:50:00',2.42),('15529','2013-08-13','13:55:00',2.31),('15529','2013-08-13','14:00:00',2.15),('15529','2013-08-13','14:05:00',2.21),('15529','2013-08-13','14:10:00',2.18),('15529','2013-08-13','14:15:00',2.17),('15529','2013-08-13','14:20:00',1.62),('15529','2013-08-13','14:25:00',2.11),('15529','2013-08-13','14:30:00',2.13),('15529','2013-08-13','14:35:00',2.08),('15529','2013-08-13','14:40:00',2.06),('15529','2013-08-13','14:45:00',1.98),('15529','2013-08-13','14:50:00',1.92),('15529','2013-08-13','14:55:00',1.98),('15529','2013-08-13','15:00:00',1.94),('15529','2013-08-13','15:05:00',1.89),('15529','2013-08-13','15:10:00',1.87),('15529','2013-08-13','15:15:00',1.87),('15529','2013-08-13','15:20:00',1.85),('15529','2013-08-13','15:25:00',1.79),('15529','2013-08-13','15:30:00',1.79),('15529','2013-08-13','15:35:00',1.78),('15529','2013-08-13','15:40:00',1.76),('15529','2013-08-13','15:45:00',1.75),('15529','2013-08-13','15:50:00',1.72),('15529','2013-08-13','15:55:00',1.68),('15529','2013-08-13','16:00:00',1.65),('15529','2013-08-13','16:05:00',1.62),('15529','2013-08-13','16:10:00',1.59),('15529','2013-08-13','16:15:00',1.56),('15529','2013-08-13','16:20:00',1.54),('15529','2013-08-13','16:25:00',1.51),('15529','2013-08-13','16:30:00',1.47),('15529','2013-08-13','16:35:00',1.43),('15529','2013-08-13','16:40:00',1.39),('15529','2013-08-13','16:45:00',1.36),('15529','2013-08-13','16:50:00',1.31),('15529','2013-08-13','16:55:00',1.26),('15529','2013-08-13','17:00:00',1.2),('15529','2013-08-13','17:05:00',1.17),('15529','2013-08-13','17:10:00',1.12),('15529','2013-08-13','17:15:00',1.09),('15529','2013-08-13','17:20:00',1.02),('15529','2013-08-12','09:00:00',1.03),('15529','2013-08-12','09:05:00',1.06),('15529','2013-08-12','09:10:00',1.1),('15529','2013-08-12','09:15:00',1.15),('15529','2013-08-12','09:20:00',1.19),('15529','2013-08-12','09:25:00',1.24),('15529','2013-08-12','09:30:00',1.27),('15529','2013-08-12','09:35:00',1.33),('15529','2013-08-12','09:40:00',1.35),('15529','2013-08-12','09:45:00',1.39),('15529','2013-08-12','09:50:00',1.38),('15529','2013-08-12','09:55:00',1.45),('15529','2013-08-12','10:00:00',1.51),('15529','2013-08-12','10:05:00',1.54),('15529','2013-08-12','10:10:00',1.56),('15529','2013-08-12','10:15:00',1.59),('15529','2013-08-12','10:20:00',1.62),('15529','2013-08-12','10:25:00',1.63),('15529','2013-08-12','10:30:00',1.68),('15529','2013-08-12','10:35:00',1.7),('15529','2013-08-12','10:40:00',1.74),('15529','2013-08-12','10:45:00',1.77),('15529','2013-08-12','10:50:00',1.78),('15529','2013-08-12','10:55:00',1.8),('15529','2013-08-12','11:00:00',1.82),('15529','2013-08-12','11:05:00',1.86),('15529','2013-08-12','11:10:00',1.84),('15529','2013-08-12','11:15:00',1.91),('15529','2013-08-12','11:20:00',1.94),('15529','2013-08-12','11:25:00',1.92),('15529','2013-08-12','11:30:00',1.93),('15529','2013-08-12','11:35:00',1.91),('15529','2013-08-12','11:40:00',1.95),('15529','2013-08-12','11:45:00',1.95),('15529','2013-08-12','11:50:00',1.89),('15529','2013-08-12','11:55:00',1.22),('15529','2013-08-12','12:00:00',2.04),('15529','2013-08-12','12:05:00',2.07),('15529','2013-08-12','12:10:00',2.07),('15529','2013-08-12','12:15:00',1.53),('15529','2013-08-12','12:20:00',2.23),('15529','2013-08-12','12:25:00',2.17),('15529','2013-08-12','12:30:00',2.18),('15529','2013-08-12','12:35:00',2.18),('15529','2013-08-12','12:40:00',2.21),('15529','2013-08-12','12:45:00',2.2),('15529','2013-08-12','12:50:00',2.26),('15529','2013-08-12','12:55:00',2.26),('15529','2013-08-12','13:00:00',2.24),('15529','2013-08-12','13:05:00',1.4),('15529','2013-08-12','13:20:00',2.32),('15529','2013-08-12','13:25:00',2.33),('15529','2013-08-12','13:30:00',2.24),('15529','2013-08-12','13:35:00',2.09),('15529','2013-08-12','13:45:00',2.37),('15529','2013-08-12','13:50:00',2.22),('15529','2013-08-12','13:55:00',2.16),('15529','2013-08-12','14:00:00',1.84),('15529','2013-08-12','14:05:00',2.15),('15529','2013-08-12','14:10:00',2.1),('15529','2013-08-12','14:15:00',2.07),('15529','2013-08-12','14:20:00',2.14),('15529','2013-08-12','14:25:00',2.11),('15529','2013-08-12','14:30:00',2.17),('15529','2013-08-12','14:35:00',2.14),('15529','2013-08-12','14:40:00',2.08),('15529','2013-08-12','14:45:00',2.03),('15529','2013-08-12','14:50:00',2.02),('15529','2013-08-12','14:55:00',1.97),('15529','2013-08-12','15:00:00',1.95),('15529','2013-08-12','15:05:00',1.93),('15529','2013-08-12','15:10:00',1.9),('15529','2013-08-12','15:15:00',1.88),('15529','2013-08-12','15:20:00',1.88),('15529','2013-08-12','15:25:00',1.82),('15529','2013-08-12','15:30:00',1.81),('15529','2013-08-12','15:35:00',1.78),('15529','2013-08-12','15:40:00',1.75),('15529','2013-08-12','15:45:00',1.71),('15529','2013-08-12','15:50:00',1.7),('15529','2013-08-12','15:55:00',1.68),('15529','2013-08-12','16:00:00',1.64),('15529','2013-08-12','16:05:00',1.62),('15529','2013-08-12','16:10:00',1.58),('15529','2013-08-12','16:15:00',1.55),('15529','2013-08-12','16:20:00',1.51),('15529','2013-08-12','16:25:00',1.49),('15529','2013-08-12','16:30:00',1.45),('15529','2013-08-12','16:35:00',1.42),('15529','2013-08-12','16:40:00',1.38),('15529','2013-08-12','16:45:00',1.35),('15529','2013-08-12','16:50:00',1.3),('15529','2013-08-12','16:55:00',1.25),('15529','2013-08-12','17:00:00',1.22),('15529','2013-08-12','17:05:00',1.18),('15529','2013-08-12','17:10:00',1.13),('15529','2013-08-12','17:15:00',1.09),('15529','2013-08-12','17:20:00',1.04),('15529','2013-08-11','09:05:00',1.04),('15529','2013-08-11','09:10:00',1.08),('15529','2013-08-11','09:15:00',1.13),('15529','2013-08-11','09:20:00',1.18),('15529','2013-08-11','09:25:00',1.21),('15529','2013-08-11','09:30:00',1.24),('15529','2013-08-11','09:35:00',1.28),('15529','2013-08-11','09:40:00',1.32),('15529','2013-08-11','09:45:00',1.36),('15529','2013-08-11','09:50:00',1.39),('15529','2013-08-11','09:55:00',1.43),('15529','2013-08-11','10:00:00',1.45),('15529','2013-08-11','10:05:00',1.49),('15529','2013-08-11','10:10:00',1.52),('15529','2013-08-11','10:15:00',1.56),('15529','2013-08-11','10:20:00',1.59),('15529','2013-08-11','10:25:00',1.63),('15529','2013-08-11','10:30:00',1.67),('15529','2013-08-11','10:35:00',1.68),('15529','2013-08-11','10:40:00',1.73),('15529','2013-08-11','10:45:00',1.72),('15529','2013-08-11','10:50:00',1.72),('15529','2013-08-11','10:55:00',1.78),('15529','2013-08-11','11:00:00',1.79),('15529','2013-08-11','11:05:00',1.81),('15529','2013-08-11','11:10:00',1.81),('15529','2013-08-11','11:15:00',1.84),('15529','2013-08-11','11:20:00',1.86),('15529','2013-08-11','11:25:00',1.85),('15529','2013-08-11','11:30:00',1.87),('15529','2013-08-11','11:35:00',1.92),('15529','2013-08-11','11:40:00',1.56),('15529','2013-08-11','11:45:00',1.96),('15529','2013-08-11','11:50:00',1.97),('15529','2013-08-11','11:55:00',2.05),('15529','2013-08-11','12:00:00',2.05),('15529','2013-08-11','12:05:00',1.76),('15529','2013-08-11','12:10:00',1.82),('15529','2013-08-11','12:15:00',2.1),('15529','2013-08-11','12:20:00',1.99),('15529','2013-08-11','12:25:00',2.04),('15529','2013-08-11','12:30:00',1.49),('15529','2013-08-11','12:35:00',1.11),('15529','2013-08-11','12:50:00',1.01),('15529','2013-08-11','13:15:00',1.2),('15529','2013-08-11','13:25:00',1.25),('15529','2013-08-11','13:30:00',1.99),('15529','2013-08-11','13:35:00',1.06),('15529','2013-08-11','13:45:00',1.21),('15529','2013-08-11','14:35:00',2.12),('15529','2013-08-11','14:40:00',1.01),('15529','2013-08-11','14:45:00',1.92),('15529','2013-08-11','14:50:00',1.76),('15529','2013-08-11','14:55:00',2.17),('15529','2013-08-11','15:00:00',1.95),('15529','2013-08-11','15:05:00',1.8),('15529','2013-08-11','15:10:00',2),('15529','2013-08-11','15:15:00',1.92),('15529','2013-08-11','15:20:00',1.87),('15529','2013-08-11','15:25:00',1.82),('15529','2013-08-11','15:30:00',1.5),('15529','2013-08-11','15:35:00',1.28),('15529','2013-08-11','15:40:00',1.57),('15529','2013-08-11','15:45:00',1.7),('15529','2013-08-11','15:50:00',1.68),('15529','2013-08-11','15:55:00',1.68),('15529','2013-08-11','16:00:00',1.65),('15529','2013-08-11','16:05:00',1.66),('15529','2013-08-11','16:10:00',1.59),('15529','2013-08-11','16:15:00',1.52),('15529','2013-08-11','16:20:00',1.52),('15529','2013-08-11','16:25:00',1.34),('15529','2013-08-11','16:30:00',1.42),('15529','2013-08-11','16:35:00',1.38),('15529','2013-08-11','16:40:00',1.34),('15529','2013-08-11','16:45:00',1.31),('15529','2013-08-11','16:50:00',1.27),('15529','2013-08-11','16:55:00',1.24),('15529','2013-08-11','17:00:00',1.2),('15529','2013-08-11','17:05:00',1.15),('15529','2013-08-11','17:10:00',1.12),('15529','2013-08-11','17:15:00',1.07),('15529','2013-08-11','17:20:00',1.03),('15529','2013-08-10','09:00:00',1.02),('15529','2013-08-10','09:05:00',1.07),('15529','2013-08-10','09:10:00',1.11),('15529','2013-08-10','09:15:00',1.16),('15529','2013-08-10','09:20:00',1.2),('15529','2013-08-10','09:25:00',1.24),('15529','2013-08-10','09:30:00',1.27),('15529','2013-08-10','09:35:00',1.32),('15529','2013-08-10','09:40:00',1.35),('15529','2013-08-10','09:45:00',1.39),('15529','2013-08-10','09:50:00',1.42),('15529','2013-08-10','09:55:00',1.46),('15529','2013-08-10','10:00:00',1.5),('15529','2013-08-10','10:05:00',1.53),('15529','2013-08-10','10:10:00',1.56),('15529','2013-08-10','10:15:00',1.6),('15529','2013-08-10','10:20:00',1.62),('15529','2013-08-10','10:25:00',1.66),('15529','2013-08-10','10:30:00',1.69),('15529','2013-08-10','10:35:00',1.72),('15529','2013-08-10','10:40:00',1.75),('15529','2013-08-10','10:45:00',1.77),('15529','2013-08-10','10:50:00',1.79),('15529','2013-08-10','10:55:00',1.82),('15529','2013-08-10','11:00:00',1.84),('15529','2013-08-10','11:05:00',1.87),('15529','2013-08-10','11:10:00',1.89),('15529','2013-08-10','11:15:00',1.92),('15529','2013-08-10','11:20:00',1.93),('15529','2013-08-10','11:25:00',1.94),('15529','2013-08-10','11:30:00',1.96),('15529','2013-08-10','11:35:00',1.96),('15529','2013-08-10','11:40:00',1.97),('15529','2013-08-10','11:45:00',2),('15529','2013-08-10','11:50:00',2.01),('15529','2013-08-10','11:55:00',2.02),('15529','2013-08-10','12:00:00',2.03),('15529','2013-08-10','12:05:00',2.04),('15529','2013-08-10','12:10:00',2.05),('15529','2013-08-10','12:15:00',2.07),('15529','2013-08-10','12:20:00',2.06),('15529','2013-08-10','12:25:00',2.07),('15529','2013-08-10','12:30:00',2.08),('15529','2013-08-10','12:35:00',2.09),('15529','2013-08-10','12:40:00',2.08),('15529','2013-08-10','12:45:00',2.11),('15529','2013-08-10','12:50:00',2.09),('15529','2013-08-10','12:55:00',2.11),('15529','2013-08-10','13:00:00',2.1),('15529','2013-08-10','13:05:00',2.11),('15529','2013-08-10','13:10:00',2.11),('15529','2013-08-10','13:15:00',2.08),('15529','2013-08-10','13:20:00',2.08),('15529','2013-08-10','13:25:00',2.13),('15529','2013-08-10','13:30:00',2.11),('15529','2013-08-10','13:35:00',2.08),('15529','2013-08-10','13:40:00',2.08),('15529','2013-08-10','13:45:00',2.01),('15529','2013-08-10','13:50:00',2.07),('15529','2013-08-10','13:55:00',2.06),('15529','2013-08-10','14:00:00',2.03),('15529','2013-08-10','14:05:00',2.05),('15529','2013-08-10','14:10:00',2.07),('15529','2013-08-10','14:15:00',2.01),('15529','2013-08-10','14:20:00',2.03),('15529','2013-08-10','14:25:00',2.01),('15529','2013-08-10','14:30:00',1.99),('15529','2013-08-10','14:35:00',1.98),('15529','2013-08-10','14:40:00',1.97),('15529','2013-08-10','14:45:00',1.94),('15529','2013-08-10','14:50:00',1.93),('15529','2013-08-10','14:55:00',1.93),('15529','2013-08-10','15:00:00',1.91),('15529','2013-08-10','15:05:00',1.93),('15529','2013-08-10','15:10:00',1.84),('15529','2013-08-10','15:15:00',1.84),('15529','2013-08-10','15:20:00',1.81),('15529','2013-08-10','15:25:00',1.8),('15529','2013-08-10','15:30:00',1.8),('15529','2013-08-10','15:35:00',1.77),('15529','2013-08-10','15:40:00',1.73),('15529','2013-08-10','15:45:00',1.72),('15529','2013-08-10','15:50:00',1.7),('15529','2013-08-10','15:55:00',1.65),('15529','2013-08-10','16:00:00',1.64),('15529','2013-08-10','16:05:00',1.6),('15529','2013-08-10','16:10:00',1.56),('15529','2013-08-10','16:15:00',1.53),('15529','2013-08-10','16:20:00',1.5),('15529','2013-08-10','16:25:00',1.46),('15529','2013-08-10','16:30:00',1.42),('15529','2013-08-10','16:35:00',1.39),('15529','2013-08-10','16:40:00',1.35),('15529','2013-08-10','16:45:00',1.31),('15529','2013-08-10','16:50:00',1.27),('15529','2013-08-10','16:55:00',1.22),('15529','2013-08-10','17:00:00',1.18),('15529','2013-08-10','17:05:00',1.14),('15529','2013-08-10','17:10:00',1.1),('15529','2013-08-10','17:15:00',1.07),('15529','2013-08-10','17:20:00',1.03),('15529','2013-08-09','08:55:00',1),('15529','2013-08-09','09:00:00',1.05),('15529','2013-08-09','09:05:00',1.08),('15529','2013-08-09','09:10:00',1.13),('15529','2013-08-09','09:15:00',1.17),('15529','2013-08-09','09:20:00',1.21),('15529','2013-08-09','09:25:00',1.26),('15529','2013-08-09','09:30:00',1.3),('15529','2013-08-09','09:35:00',1.34),('15529','2013-08-09','09:40:00',1.37),('15529','2013-08-09','09:45:00',1.4),('15529','2013-08-09','09:50:00',1.44),('15529','2013-08-09','09:55:00',1.47),('15529','2013-08-09','10:00:00',1.5),('15529','2013-08-09','10:05:00',1.54),('15529','2013-08-09','10:10:00',1.57),('15529','2013-08-09','10:15:00',1.6),('15529','2013-08-09','10:20:00',1.62),('15529','2013-08-09','10:25:00',1.66),('15529','2013-08-09','10:30:00',1.69),('15529','2013-08-09','10:35:00',1.72),('15529','2013-08-09','10:40:00',1.73),('15529','2013-08-09','10:45:00',1.76),('15529','2013-08-09','10:50:00',1.8),('15529','2013-08-09','10:55:00',1.83),('15529','2013-08-09','11:00:00',1.85),('15529','2013-08-09','11:05:00',1.87),('15529','2013-08-09','11:10:00',1.88),('15529','2013-08-09','11:15:00',1.98),('15529','2013-08-09','11:20:00',1.98),('15529','2013-08-09','11:25:00',2.02),('15529','2013-08-09','11:30:00',2.03),('15529','2013-08-09','11:35:00',2.01),('15529','2013-08-09','11:40:00',2.01),('15529','2013-08-09','11:45:00',2.01),('15529','2013-08-09','11:50:00',2.04),('15529','2013-08-09','11:55:00',2.06),('15529','2013-08-09','12:00:00',2.09),('15529','2013-08-09','12:05:00',2.1),('15529','2013-08-09','12:10:00',2.08),('15529','2013-08-09','12:15:00',2.1),('15529','2013-08-09','12:20:00',2.11),('15529','2013-08-09','12:25:00',2.1),('15529','2013-08-09','12:30:00',2.12),('15529','2013-08-09','12:35:00',2.12),('15529','2013-08-09','12:40:00',2.14),('15529','2013-08-09','12:45:00',2.19),('15529','2013-08-09','12:50:00',2.27),('15529','2013-08-09','12:55:00',2.26),('15529','2013-08-09','13:00:00',1.92),('15529','2013-08-09','13:05:00',2.08),('15529','2013-08-09','13:10:00',2.2),('15529','2013-08-09','13:15:00',2.05),('15529','2013-08-09','13:20:00',2.29),('15529','2013-08-09','13:25:00',2.13),('15529','2013-08-09','13:30:00',1.92),('15529','2013-08-09','14:00:00',2.31),('15529','2013-08-09','14:05:00',2.31),('15529','2013-08-09','14:10:00',2.34),('15529','2013-08-09','14:15:00',1.57),('15529','2013-08-09','15:50:00',1.05),('15529','2013-08-09','15:55:00',1.02),('15529','2013-08-09','16:05:00',1.39),('15529','2013-08-09','16:25:00',1.03),('15529','2013-08-09','16:30:00',1.54),('15529','2013-08-09','16:35:00',1.39),('15529','2013-08-09','16:40:00',1.29),('15529','2013-08-09','16:50:00',1.33),('15529','2013-08-09','16:55:00',1.09),('15529','2014-04-08','09:50:00',1.58),('15529','2014-04-08','09:55:00',1.55),('15529','2014-04-08','10:00:00',1.56),('15529','2014-04-08','10:05:00',1.61),('15529','2014-04-08','10:10:00',1.67),('15529','2014-04-08','10:15:00',1.73),('15529','2014-04-08','10:20:00',1.6),('15529','2014-04-08','10:25:00',1.75),('15529','2014-04-08','10:35:00',1.22),('15529','2014-04-08','10:40:00',1.05),('15529','2014-04-08','10:45:00',2.13),('15529','2014-04-08','10:50:00',2.12),('15529','2014-04-08','10:55:00',2.11),('15529','2014-04-08','11:00:00',2.11),('15529','2014-04-08','11:05:00',2.1),('15529','2014-04-08','11:10:00',1.73),('15529','2014-04-08','11:15:00',2.02),('15529','2014-04-08','11:20:00',2.25),('15529','2014-04-08','11:25:00',2.26),('15529','2014-04-08','11:30:00',2.27),('15529','2014-04-08','11:35:00',2.31),('15529','2014-04-08','11:40:00',2.38),('15529','2014-04-08','11:45:00',1.93),('15529','2014-04-08','11:50:00',2.24),('15529','2014-04-08','11:55:00',1.74),('15529','2014-04-08','12:00:00',2.19),('15529','2014-04-08','12:05:00',1.46),('15529','2014-04-08','12:10:00',1.23),('15529','2014-04-08','14:50:00',1.92),('15529','2014-04-08','15:00:00',1.95),('15529','2014-04-08','15:05:00',1.65),('15529','2014-04-08','15:10:00',1.06),('15529','2014-04-08','15:15:00',1.02),('15529','2014-04-08','15:20:00',1.93),('15529','2014-04-08','16:10:00',1.78),('15529','2014-04-08','16:15:00',1.64),('15529','2014-04-08','16:20:00',1.51),('15529','2014-04-08','16:25:00',1.35),('15529','2014-04-08','16:30:00',1.14),('15529','2014-04-08','16:35:00',1.45),('15529','2014-04-08','16:50:00',1.1),('15529','2014-04-08','17:05:00',1.24),('15529','2014-04-08','17:10:00',1.11),('15529','2014-04-08','17:15:00',1.02),('15529','2013-08-08','09:05:00',1.03),('15529','2013-08-08','09:10:00',1.12),('15529','2013-08-08','09:25:00',1.09),('15529','2013-08-08','09:30:00',1.07),('15529','2013-08-08','09:35:00',1.07),('15529','2013-08-08','09:50:00',1.2),('15529','2013-08-08','10:05:00',1.21),('15529','2013-08-08','10:10:00',1.39),('15529','2013-08-08','10:15:00',1.43),('15529','2013-08-08','10:20:00',1.48),('15529','2013-08-08','10:25:00',1.48),('15529','2013-08-08','10:30:00',1.49),('15529','2013-08-08','10:35:00',1.44),('15529','2013-08-08','10:40:00',1.05),('15529','2013-08-08','10:45:00',1.24),('15529','2013-08-08','10:50:00',1.65),('15529','2013-08-08','10:55:00',1.66),('15529','2013-08-08','11:00:00',1.69),('15529','2013-08-08','11:05:00',1.69),('15529','2013-08-08','11:10:00',1.68),('15529','2013-08-08','11:15:00',1.73),('15529','2013-08-08','11:20:00',1.74),('15529','2013-08-08','11:25:00',1.77),('15529','2013-08-08','11:30:00',1.77),('15529','2013-08-08','11:35:00',1.8),('15529','2013-08-08','11:40:00',1.81),('15529','2013-08-08','11:45:00',1.82),('15529','2013-08-08','11:50:00',1.84),('15529','2013-08-08','11:55:00',1.87),('15529','2013-08-08','12:00:00',1.85),('15529','2013-08-08','12:05:00',1.91),('15529','2013-08-08','12:10:00',1.92),('15529','2013-08-08','12:15:00',1.94),('15529','2013-08-08','12:20:00',1.71),('15529','2013-08-08','12:25:00',2.04),('15529','2013-08-08','12:30:00',1.67),('15529','2013-08-08','12:35:00',1.19),('15529','2013-08-08','12:40:00',1.79),('15529','2013-08-08','12:45:00',2),('15529','2013-08-08','12:50:00',1.75),('15529','2013-08-08','12:55:00',1.17),('15529','2013-08-08','13:20:00',1.2),('15529','2013-08-08','15:10:00',1.37),('15529','2013-08-08','15:15:00',1.58),('15529','2013-08-08','15:35:00',1.05),('15529','2013-08-08','15:40:00',1.18),('15529','2013-08-08','15:45:00',1.11),('15529','2013-08-07','09:10:00',1.01),('15529','2013-08-07','09:15:00',1.05),('15529','2013-08-07','09:20:00',1.1),('15529','2013-08-07','09:25:00',1.13),('15529','2013-08-07','09:30:00',1.17),('15529','2013-08-07','09:35:00',1.2),('15529','2013-08-07','09:40:00',1.24),('15529','2013-08-07','09:45:00',1.27),('15529','2013-08-07','09:50:00',1.31),('15529','2013-08-07','09:55:00',1.34),('15529','2013-08-07','10:00:00',1.37),('15529','2013-08-07','10:05:00',1.41),('15529','2013-08-07','10:10:00',1.43),('15529','2013-08-07','10:15:00',1.46),('15529','2013-08-07','10:20:00',1.49),('15529','2013-08-07','10:25:00',1.52),('15529','2013-08-07','10:30:00',1.54),('15529','2013-08-07','10:35:00',1.56),('15529','2013-08-07','10:40:00',1.58),('15529','2013-08-07','10:45:00',1.6),('15529','2013-08-07','10:50:00',1.63),('15529','2013-08-07','10:55:00',1.65),('15529','2013-08-07','11:00:00',1.67),('15529','2013-08-07','11:05:00',1.69),('15529','2013-08-07','11:10:00',1.72),('15529','2013-08-07','11:15:00',1.73),('15529','2013-08-07','11:20:00',1.75),('15529','2013-08-07','11:25:00',1.75),('15529','2013-08-07','11:30:00',1.77),('15529','2013-08-07','11:35:00',1.78),('15529','2013-08-07','11:40:00',1.78),('15529','2013-08-07','11:45:00',1.82),('15529','2013-08-07','11:50:00',1.83),('15529','2013-08-07','11:55:00',1.86),('15529','2013-08-07','12:00:00',1.89),('15529','2013-08-07','12:05:00',1.86),('15529','2013-08-07','12:10:00',1.86),('15529','2013-08-07','12:15:00',1.84),('15529','2013-08-07','12:20:00',1.86),('15529','2013-08-07','12:25:00',1.92),('15529','2013-08-07','12:30:00',1.94),('15529','2013-08-07','12:35:00',1.96),('15529','2013-08-07','12:40:00',1.97),('15529','2013-08-07','12:45:00',1.97),('15529','2013-08-07','12:50:00',2),('15529','2013-08-07','12:55:00',1.96),('15529','2013-08-07','13:00:00',2),('15529','2013-08-07','13:05:00',1.99),('15529','2013-08-07','13:10:00',1.99),('15529','2013-08-07','13:15:00',1.99),('15529','2013-08-07','13:20:00',2),('15529','2013-08-07','13:25:00',1.99),('15529','2013-08-07','13:30:00',2),('15529','2013-08-07','13:35:00',1.97),('15529','2013-08-07','13:40:00',1.98),('15529','2013-08-07','13:45:00',1.95),('15529','2013-08-07','13:50:00',1.96),('15529','2013-08-07','13:55:00',1.95),('15529','2013-08-07','14:00:00',1.9),('15529','2013-08-07','14:05:00',1.93),('15529','2013-08-07','14:10:00',1.93),('15529','2013-08-07','14:15:00',1.91),('15529','2013-08-07','14:20:00',1.88),('15529','2013-08-07','14:25:00',1.9),('15529','2013-08-07','14:30:00',1.9),('15529','2013-08-07','14:35:00',1.87),('15529','2013-08-07','14:40:00',1.85),('15529','2013-08-07','14:45:00',1.84),('15529','2013-08-07','14:50:00',1.8),('15529','2013-08-07','14:55:00',1.81),('15529','2013-08-07','15:00:00',1.79),('15529','2013-08-07','15:05:00',1.77),('15529','2013-08-07','15:10:00',1.76),('15529','2013-08-07','15:15:00',1.74),('15529','2013-08-07','15:20:00',1.7),('15529','2013-08-07','15:25:00',1.68),('15529','2013-08-07','15:30:00',1.65),('15529','2013-08-07','15:35:00',1.63),('15529','2013-08-07','15:40:00',1.61),('15529','2013-08-07','15:45:00',1.58),('15529','2013-08-07','15:50:00',1.55),('15529','2013-08-07','15:55:00',1.54),('15529','2013-08-07','16:00:00',1.52),('15529','2013-08-07','16:05:00',1.49),('15529','2013-08-07','16:10:00',1.47),('15529','2013-08-07','16:15:00',1.45),('15529','2013-08-07','16:20:00',1.42),('15529','2013-08-07','16:25:00',1.38),('15529','2013-08-07','16:30:00',1.34),('15529','2013-08-07','16:35:00',1.31),('15529','2013-08-07','16:40:00',1.27),('15529','2013-08-07','16:45:00',1.22),('15529','2013-08-07','17:10:00',1),('15529','2013-08-06','09:10:00',1.02),('15529','2013-08-06','09:15:00',1.06),('15529','2013-08-06','09:20:00',1.1),('15529','2013-08-06','09:25:00',1.15),('15529','2013-08-06','09:30:00',1.18),('15529','2013-08-06','09:35:00',1.22),('15529','2013-08-06','09:40:00',1.25),('15529','2013-08-06','09:45:00',1.29),('15529','2013-08-06','09:50:00',1.32),('15529','2013-08-06','09:55:00',1.36),('15529','2013-08-06','10:00:00',1.39),('15529','2013-08-06','10:05:00',1.41),('15529','2013-08-06','10:10:00',1.43),('15529','2013-08-06','10:15:00',1.46),('15529','2013-08-06','10:20:00',1.51),('15529','2013-08-06','10:25:00',1.53),('15529','2013-08-06','10:30:00',1.56),('15529','2013-08-06','10:35:00',1.6),('15529','2013-08-06','10:40:00',1.63),('15529','2013-08-06','10:45:00',1.63),('15529','2013-08-06','10:50:00',1.67),('15529','2013-08-06','10:55:00',1.68),('15529','2013-08-06','11:00:00',1.7),('15529','2013-08-06','11:05:00',1.72),('15529','2013-08-06','11:10:00',1.74),('15529','2013-08-06','11:15:00',1.77),('15529','2013-08-06','11:20:00',1.74),('15529','2013-08-06','11:25:00',1.77),('15529','2013-08-06','11:30:00',1.78),('15529','2013-08-06','11:35:00',1.81),('15529','2013-08-06','11:40:00',1.85),('15529','2013-08-06','11:45:00',1.85),('15529','2013-08-06','11:50:00',1.83),('15529','2013-08-06','11:55:00',1.86),('15529','2013-08-06','12:00:00',1.89),('15529','2013-08-06','12:05:00',1.87),('15529','2013-08-06','12:10:00',1.87),('15529','2013-08-06','12:15:00',1.93),('15529','2013-08-06','12:20:00',1.92),('15529','2013-08-06','12:25:00',1.93),('15529','2013-08-06','12:30:00',1.89),('15529','2013-08-06','12:35:00',1.97),('15529','2013-08-06','12:40:00',1.93),('15529','2013-08-06','12:45:00',1.9),('15529','2013-08-06','12:50:00',1.93),('15529','2013-08-06','12:55:00',1.89),('15529','2013-08-06','13:00:00',1.92),('15529','2013-08-06','13:05:00',1.96),('15529','2013-08-06','13:10:00',2.04),('15529','2013-08-06','13:15:00',1.98),('15529','2013-08-06','13:20:00',1.97),('15529','2013-08-06','13:25:00',1.97),('15529','2013-08-06','13:30:00',2.01),('15529','2013-08-06','13:35:00',1.94),('15529','2013-08-06','13:40:00',2),('15529','2013-08-06','13:45:00',1.97),('15529','2013-08-06','13:50:00',2.01),('15529','2013-08-06','13:55:00',2),('15529','2013-08-06','14:00:00',1.96),('15529','2013-08-06','14:05:00',1.94),('15529','2013-08-06','14:10:00',1.9),('15529','2013-08-06','14:15:00',1.88),('15529','2013-08-06','14:20:00',1.83),('15529','2013-08-06','14:25:00',1.87),('15529','2013-08-06','14:30:00',1.85),('15529','2013-08-06','14:35:00',1.87),('15529','2013-08-06','14:40:00',1.89),('15529','2013-08-06','14:45:00',1.87),('15529','2013-08-06','14:50:00',1.84),('15529','2013-08-06','14:55:00',1.83),('15529','2013-08-06','15:00:00',1.82),('15529','2013-08-06','15:05:00',1.8),('15529','2013-08-06','15:10:00',1.78),('15529','2013-08-06','15:15:00',1.76),('15529','2013-08-06','15:20:00',1.73),('15529','2013-08-06','15:25:00',1.72),('15529','2013-08-06','15:30:00',1.69),('15529','2013-08-06','15:35:00',1.66),('15529','2013-08-06','15:40:00',1.64),('15529','2013-08-06','15:45:00',1.59),('15529','2013-08-06','15:50:00',1.56),('15529','2013-08-06','15:55:00',1.56),('15529','2013-08-06','16:00:00',1.5),('15529','2013-08-06','16:05:00',1.49),('15529','2013-08-06','16:10:00',1.47),('15529','2013-08-06','16:15:00',1.45),('15529','2013-08-06','16:20:00',1.42),('15529','2013-08-06','16:25:00',1.38),('15529','2013-08-06','16:30:00',1.34),('15529','2013-08-06','16:35:00',1.31),('15529','2013-08-06','16:40:00',1.28),('15529','2013-08-06','16:45:00',1.25),('15529','2013-08-06','16:50:00',1.21),('15529','2013-08-06','16:55:00',1.16),('15529','2013-08-06','17:00:00',1.1),('15529','2013-08-06','17:05:00',1.06),('15529','2013-08-06','17:10:00',1.04),('15529','2013-08-05','09:10:00',1.02),('15529','2013-08-05','09:15:00',1.06),('15529','2013-08-05','09:20:00',1.1),('15529','2013-08-05','09:25:00',1.13),('15529','2013-08-05','09:30:00',1.16),('15529','2013-08-05','09:35:00',1.2),('15529','2013-08-05','09:40:00',1.24),('15529','2013-08-05','09:45:00',1.27),('15529','2013-08-05','09:50:00',1.3),('15529','2013-08-05','09:55:00',1.35),('15529','2013-08-05','10:00:00',1.37),('15529','2013-08-05','10:05:00',1.41),('15529','2013-08-05','10:10:00',1.45),('15529','2013-08-05','10:15:00',1.46),('15529','2013-08-05','10:20:00',1.49),('15529','2013-08-05','10:25:00',1.51),('15529','2013-08-05','10:30:00',1.55),('15529','2013-08-05','10:35:00',1.58),('15529','2013-08-05','10:40:00',1.62),('15529','2013-08-05','10:45:00',1.61),('15529','2013-08-05','10:50:00',1.64),('15529','2013-08-05','10:55:00',1.66),('15529','2013-08-05','11:00:00',1.69),('15529','2013-08-05','11:05:00',1.71),('15529','2013-08-05','11:10:00',1.73),('15529','2013-08-05','11:15:00',1.75),('15529','2013-08-05','11:20:00',1.75),('15529','2013-08-05','11:25:00',1.8),('15529','2013-08-05','11:30:00',1.81),('15529','2013-08-05','11:35:00',1.82),('15529','2013-08-05','11:40:00',1.81),('15529','2013-08-05','11:45:00',1.81),('15529','2013-08-05','11:50:00',1.81),('15529','2013-08-05','11:55:00',1.85),('15529','2013-08-05','12:00:00',1.87),('15529','2013-08-05','12:05:00',1.89),('15529','2013-08-05','12:10:00',1.86),('15529','2013-08-05','12:15:00',1.87),('15529','2013-08-05','12:20:00',1.89),('15529','2013-08-05','12:25:00',1.92),('15529','2013-08-05','12:30:00',1.94),('15529','2013-08-05','12:35:00',1.89),('15529','2013-08-05','12:40:00',1.93),('15529','2013-08-05','12:45:00',1.94),('15529','2013-08-05','12:50:00',1.91),('15529','2013-08-05','12:55:00',1.96),('15529','2013-08-05','13:00:00',1.96),('15529','2013-08-05','13:05:00',1.99),('15529','2013-08-05','13:10:00',1.98),('15529','2013-08-05','13:15:00',1.95),('15529','2013-08-05','13:20:00',1.95),('15529','2013-08-05','13:25:00',1.94),('15529','2013-08-05','13:30:00',1.99),('15529','2013-08-05','13:35:00',2),('15529','2013-08-05','13:40:00',2.01),('15529','2013-08-05','13:45:00',2.02),('15529','2013-08-05','13:50:00',2.01),('15529','2013-08-05','13:55:00',1.98),('15529','2013-08-05','14:00:00',2),('15529','2013-08-05','14:05:00',2),('15529','2013-08-05','14:10:00',2.01),('15529','2013-08-05','14:15:00',2),('15529','2013-08-05','14:20:00',1.99),('15529','2013-08-05','14:25:00',1.96),('15529','2013-08-05','14:30:00',1.95),('15529','2013-08-05','14:35:00',1.93),('15529','2013-08-05','14:40:00',1.92),('15529','2013-08-05','14:45:00',1.92),('15529','2013-08-05','14:50:00',1.9),('15529','2013-08-05','14:55:00',1.89),('15529','2013-08-05','15:00:00',1.86),('15529','2013-08-05','15:05:00',1.85),('15529','2013-08-05','15:10:00',1.84),('15529','2013-08-05','15:15:00',1.83),('15529','2013-08-05','15:20:00',1.8),('15529','2013-08-05','15:25:00',1.78),('15529','2013-08-05','15:30:00',1.76),('15529','2013-08-05','15:35:00',1.72),('15529','2013-08-05','15:40:00',1.69),('15529','2013-08-05','15:45:00',1.66),('15529','2013-08-05','15:50:00',1.63),('15529','2013-08-05','15:55:00',1.61),('15529','2013-08-05','16:00:00',1.58),('15529','2013-08-05','16:05:00',1.55),('15529','2013-08-05','16:10:00',1.52),('15529','2013-08-05','16:15:00',1.48),('15529','2013-08-05','16:20:00',1.45),('15529','2013-08-05','16:25:00',1.42),('15529','2013-08-05','16:30:00',1.39),('15529','2013-08-05','16:35:00',1.35),('15529','2013-08-05','16:40:00',1.32),('15529','2013-08-05','16:45:00',1.28),('15529','2013-08-05','16:50:00',1.25),('15529','2013-08-05','16:55:00',1.21),('15529','2013-08-05','17:00:00',1.17),('15529','2013-08-05','17:05:00',1.12),('15529','2013-08-05','17:10:00',1.08),('15529','2013-08-05','17:15:00',1.03),('15529','2013-08-04','09:10:00',1.04),('15529','2013-08-04','09:15:00',1.07),('15529','2013-08-04','09:20:00',1.12),('15529','2013-08-04','09:25:00',1.15),('15529','2013-08-04','09:30:00',1.2),('15529','2013-08-04','09:35:00',1.22),('15529','2013-08-04','09:40:00',1.27),('15529','2013-08-04','09:45:00',1.3),('15529','2013-08-04','09:50:00',1.33),('15529','2013-08-04','09:55:00',1.37),('15529','2013-08-04','10:00:00',1.4),('15529','2013-08-04','10:05:00',1.42),('15529','2013-08-04','10:10:00',1.45),('15529','2013-08-04','10:15:00',1.48),('15529','2013-08-04','10:20:00',1.51),('15529','2013-08-04','10:25:00',1.55),('15529','2013-08-04','10:30:00',1.59),('15529','2013-08-04','10:35:00',1.62),('15529','2013-08-04','10:40:00',1.65),('15529','2013-08-04','10:45:00',1.69),('15529','2013-08-04','10:50:00',1.71),('15529','2013-08-04','10:55:00',1.7),('15529','2013-08-04','11:00:00',1.73),('15529','2013-08-04','11:05:00',1.75),('15529','2013-08-04','11:10:00',1.78),('15529','2013-08-04','11:15:00',1.78),('15529','2013-08-04','11:20:00',1.81),('15529','2013-08-04','11:25:00',1.83),('15529','2013-08-04','11:30:00',1.84),('15529','2013-08-04','11:35:00',1.88),('15529','2013-08-04','11:40:00',1.9),('15529','2013-08-04','11:45:00',1.91),('15529','2013-08-04','11:50:00',1.93),('15529','2013-08-04','11:55:00',1.96),('15529','2013-08-04','12:00:00',1.93),('15529','2013-08-04','12:05:00',1.94),('15529','2013-08-04','12:10:00',1.95),('15529','2013-08-04','12:15:00',1.95),('15529','2013-08-04','12:20:00',1.96),('15529','2013-08-04','12:25:00',1.98),('15529','2013-08-04','12:30:00',1.99),('15529','2013-08-04','12:35:00',1.98),('15529','2013-08-04','12:40:00',2.03),('15529','2013-08-04','12:45:00',2.02),('15529','2013-08-04','12:50:00',2),('15529','2013-08-04','12:55:00',1.99),('15529','2013-08-04','13:00:00',1.99),('15529','2013-08-04','13:05:00',1.99),('15529','2013-08-04','13:10:00',2.02),('15529','2013-08-04','13:15:00',2.02),('15529','2013-08-04','13:20:00',1.98),('15529','2013-08-04','13:25:00',1.99),('15529','2013-08-04','13:30:00',1.96),('15529','2013-08-04','13:35:00',1.95),('15529','2013-08-04','13:40:00',2),('15529','2013-08-04','13:45:00',1.98),('15529','2013-08-04','13:50:00',1.96),('15529','2013-08-04','13:55:00',1.94),('15529','2013-08-04','14:00:00',1.96),('15529','2013-08-04','14:05:00',1.96),('15529','2013-08-04','14:10:00',1.97),('15529','2013-08-04','14:15:00',1.95),('15529','2013-08-04','14:20:00',1.92),('15529','2013-08-04','14:25:00',1.89),('15529','2013-08-04','14:30:00',1.89),('15529','2013-08-04','14:35:00',1.93),('15529','2013-08-04','14:40:00',1.92),('15529','2013-08-04','14:45:00',1.92),('15529','2013-08-04','14:50:00',1.85),('15529','2013-08-04','14:55:00',1.82),('15529','2013-08-04','15:00:00',1.83),('15529','2013-08-04','15:05:00',1.82),('15529','2013-08-04','15:10:00',1.78),('15529','2013-08-04','15:15:00',1.79),('15529','2013-08-04','15:20:00',1.79),('15529','2013-08-04','15:25:00',1.79),('15529','2013-08-04','15:30:00',1.76),('15529','2013-08-04','15:35:00',1.76),('15529','2013-08-04','15:40:00',1.73),('15529','2013-08-04','15:45:00',1.68),('15529','2013-08-04','15:50:00',1.66),('15529','2013-08-04','15:55:00',1.61),('15529','2013-08-04','16:00:00',1.59),('15529','2013-08-04','16:05:00',1.58),('15529','2013-08-04','16:10:00',1.54),('15529','2013-08-04','16:15:00',1.5),('15529','2013-08-04','16:20:00',1.44),('15529','2013-08-04','16:25:00',1.41),('15529','2013-08-04','16:30:00',1.37),('15529','2013-08-04','16:35:00',1.35),('15529','2013-08-04','16:40:00',1.31),('15529','2013-08-04','16:45:00',1.28),('15529','2013-08-04','16:50:00',1.24),('15529','2013-08-04','16:55:00',1.19),('15529','2013-08-04','17:00:00',1.14),('15529','2013-08-04','17:05:00',1.1),('15529','2013-08-04','17:10:00',1.07),('15529','2013-08-04','17:15:00',1.03),('15529','2013-08-03','09:00:00',1),('15529','2013-08-03','09:05:00',1.05),('15529','2013-08-03','09:10:00',1.09),('15529','2013-08-03','09:15:00',1.13),('15529','2013-08-03','09:20:00',1.17),('15529','2013-08-03','09:25:00',1.21),('15529','2013-08-03','09:30:00',1.25),('15529','2013-08-03','09:35:00',1.29),('15529','2013-08-03','09:40:00',1.32),('15529','2013-08-03','09:45:00',1.36),('15529','2013-08-03','09:50:00',1.4),('15529','2013-08-03','09:55:00',1.44),('15529','2013-08-03','10:00:00',1.46),('15529','2013-08-03','10:05:00',1.5),('15529','2013-08-03','10:10:00',1.54),('15529','2013-08-03','10:15:00',1.57),('15529','2013-08-03','10:20:00',1.58),('15529','2013-08-03','10:25:00',1.62),('15529','2013-08-03','10:30:00',1.65),('15529','2013-08-03','10:35:00',1.67),('15529','2013-08-03','10:40:00',1.68),('15529','2013-08-03','10:45:00',1.71),('15529','2013-08-03','10:50:00',1.73),('15529','2013-08-03','10:55:00',1.77),('15529','2013-08-03','11:00:00',1.77),('15529','2013-08-03','11:05:00',1.78),('15529','2013-08-03','11:10:00',1.82),('15529','2013-08-03','11:15:00',1.86),('15529','2013-08-03','11:20:00',1.87),('15529','2013-08-03','11:25:00',1.87),('15529','2013-08-03','11:30:00',1.86),('15529','2013-08-03','11:35:00',1.96),('15529','2013-08-03','11:40:00',1.96),('15529','2013-08-03','11:45:00',1.97),('15529','2013-08-03','11:50:00',1.98),('15529','2013-08-03','11:55:00',2),('15529','2013-08-03','12:00:00',2.05),('15529','2013-08-03','12:05:00',2.04),('15529','2013-08-03','12:10:00',2.07),('15529','2013-08-03','12:15:00',2.01),('15529','2013-08-03','12:20:00',2.04),('15529','2013-08-03','12:25:00',2.07),('15529','2013-08-03','12:30:00',2.09),('15529','2013-08-03','12:35:00',2.12),('15529','2013-08-03','12:40:00',2.1),('15529','2013-08-03','12:45:00',2.11),('15529','2013-08-03','12:50:00',2.1),('15529','2013-08-03','12:55:00',2.08),('15529','2013-08-03','13:00:00',2.05),('15529','2013-08-03','13:05:00',2.07),('15529','2013-08-03','13:10:00',2.04),('15529','2013-08-03','13:15:00',2.04),('15529','2013-08-03','13:20:00',2.11),('15529','2013-08-03','13:25:00',2.1),('15529','2013-08-03','13:30:00',2.08),('15529','2013-08-03','13:35:00',2.1),('15529','2013-08-03','13:40:00',2.12),('15529','2013-08-03','13:45:00',2.13),('15529','2013-08-03','13:50:00',2.15),('15529','2013-08-03','13:55:00',2.13),('15529','2013-08-03','14:00:00',2.05),('15529','2013-08-03','14:05:00',2.04),('15529','2013-08-03','14:10:00',2.02),('15529','2013-08-03','14:15:00',1.99),('15529','2013-08-03','14:20:00',2.07),('15529','2013-08-03','14:25:00',2.02),('15529','2013-08-03','14:30:00',2.04),('15529','2013-08-03','14:35:00',2),('15529','2013-08-03','14:40:00',1.99),('15529','2013-08-03','14:45:00',1.95),('15529','2013-08-03','14:50:00',1.96),('15529','2013-08-03','14:55:00',1.95),('15529','2013-08-03','15:00:00',1.96),('15529','2013-08-03','15:05:00',1.91),('15529','2013-08-03','15:10:00',1.87),('15529','2013-08-03','15:15:00',1.86),('15529','2013-08-03','15:20:00',1.84),('15529','2013-08-03','15:25:00',1.79),('15529','2013-08-03','15:30:00',1.77),('15529','2013-08-03','15:35:00',1.76),('15529','2013-08-03','15:40:00',1.73),('15529','2013-08-03','15:45:00',1.72),('15529','2013-08-03','15:50:00',1.68),('15529','2013-08-03','15:55:00',1.63),('15529','2013-08-03','16:00:00',1.64),('15529','2013-08-03','16:05:00',1.6),('15529','2013-08-03','16:10:00',1.57),('15529','2013-08-03','16:15:00',1.55),('15529','2013-08-03','16:20:00',1.51),('15529','2013-08-03','16:25:00',1.48),('15529','2013-08-03','16:30:00',1.43),('15529','2013-08-03','16:35:00',1.39),('15529','2013-08-03','16:40:00',1.35),('15529','2013-08-03','16:45:00',1.31),('15529','2013-08-03','16:50:00',1.28),('15529','2013-08-03','16:55:00',1.23),('15529','2013-08-03','17:00:00',1.19),('15529','2013-08-03','17:05:00',1.15),('15529','2013-08-03','17:10:00',1.1),('15529','2013-08-03','17:15:00',1.07),('15529','2013-08-03','17:20:00',1.02),('15529','2013-08-02','09:00:00',1),('15529','2013-08-02','09:05:00',1.04),('15529','2013-08-02','09:10:00',1.08),('15529','2013-08-02','09:15:00',1.12),('15529','2013-08-02','09:20:00',1.16),('15529','2013-08-02','09:25:00',1.2),('15529','2013-08-02','09:30:00',1.24),('15529','2013-08-02','09:35:00',1.27),('15529','2013-08-02','09:40:00',1.31),('15529','2013-08-02','09:45:00',1.35),('15529','2013-08-02','09:50:00',1.38),('15529','2013-08-02','09:55:00',1.41),('15529','2013-08-02','10:00:00',1.44),('15529','2013-08-02','10:05:00',1.47),('15529','2013-08-02','10:10:00',1.51),('15529','2013-08-02','10:15:00',1.56),('15529','2013-08-02','10:20:00',1.59),('15529','2013-08-02','10:25:00',1.63),('15529','2013-08-02','10:30:00',1.66),('15529','2013-08-02','10:35:00',1.69),('15529','2013-08-02','10:40:00',1.69),('15529','2013-08-02','10:45:00',1.69),('15529','2013-08-02','10:50:00',1.73),('15529','2013-08-02','10:55:00',1.79),('15529','2013-08-02','11:00:00',1.79),('15529','2013-08-02','11:05:00',1.79),('15529','2013-08-02','11:10:00',1.79),('15529','2013-08-02','11:15:00',1.83),('15529','2013-08-02','11:20:00',1.83),('15529','2013-08-02','11:25:00',1.86),('15529','2013-08-02','11:30:00',1.86),('15529','2013-08-02','11:35:00',1.91),('15529','2013-08-02','11:40:00',1.92),('15529','2013-08-02','11:45:00',1.93),('15529','2013-08-02','11:50:00',1.91),('15529','2013-08-02','11:55:00',1.93),('15529','2013-08-02','12:00:00',1.93),('15529','2013-08-02','12:05:00',1.94),('15529','2013-08-02','12:10:00',1.93),('15529','2013-08-02','12:15:00',1.93),('15529','2013-08-02','12:20:00',1.97),('15529','2013-08-02','12:25:00',1.98),('15529','2013-08-02','12:30:00',1.99),('15529','2013-08-02','12:35:00',2.04),('15529','2013-08-02','12:40:00',2.03),('15529','2013-08-02','12:45:00',2),('15529','2013-08-02','12:50:00',1.99),('15529','2013-08-02','12:55:00',1.95),('15529','2013-08-02','13:00:00',1.97),('15529','2013-08-02','13:05:00',1.99),('15529','2013-08-02','13:10:00',1.95),('15529','2013-08-02','13:15:00',1.98),('15529','2013-08-02','13:20:00',2.03),('15529','2013-08-02','13:25:00',1.97),('15529','2013-08-02','13:30:00',1.95),('15529','2013-08-02','13:35:00',2.02),('15529','2013-08-02','13:40:00',2),('15529','2013-08-02','13:45:00',1.98),('15529','2013-08-02','13:50:00',1.96),('15529','2013-08-02','13:55:00',1.99),('15529','2013-08-02','14:00:00',2),('15529','2013-08-02','14:05:00',1.97),('15529','2013-08-02','14:10:00',1.95),('15529','2013-08-02','14:15:00',1.94),('15529','2013-08-02','14:20:00',1.97),('15529','2013-08-02','14:25:00',2),('15529','2013-08-02','14:30:00',1.99),('15529','2013-08-02','14:35:00',1.98),('15529','2013-08-02','14:40:00',1.96),('15529','2013-08-02','14:45:00',1.93),('15529','2013-08-02','14:50:00',1.92),('15529','2013-08-02','14:55:00',1.92),('15529','2013-08-02','15:00:00',1.91),('15529','2013-08-02','15:05:00',1.86),('15529','2013-08-02','15:10:00',1.84),('15529','2013-08-02','15:15:00',1.85),('15529','2013-08-02','15:20:00',1.82),('15529','2013-08-02','15:25:00',1.82),('15529','2013-08-02','15:30:00',1.77),('15529','2013-08-02','15:35:00',1.75),('15529','2013-08-02','15:40:00',1.73),('15529','2013-08-02','15:45:00',1.71),('15529','2013-08-02','15:50:00',1.68),('15529','2013-08-02','15:55:00',1.64),('15529','2013-08-02','16:00:00',1.64),('15529','2013-08-02','16:05:00',1.59),('15529','2013-08-02','16:10:00',1.54),('15529','2013-08-02','16:15:00',1.51),('15529','2013-08-02','16:20:00',1.47),('15529','2013-08-02','16:25:00',1.44),('15529','2013-08-02','16:30:00',1.41),('15529','2013-08-02','16:35:00',1.37),('15529','2013-08-02','16:40:00',1.33),('15529','2013-08-02','16:45:00',1.29),('15529','2013-08-02','16:50:00',1.25),('15529','2013-08-02','16:55:00',1.21),('15529','2013-08-02','17:00:00',1.17),('15529','2013-08-02','17:05:00',1.14),('15529','2013-08-02','17:10:00',1.11),('15529','2013-08-02','17:15:00',1.06),('15529','2013-08-02','17:20:00',1.01),('15529','2013-08-01','09:00:00',1.04),('15529','2013-08-01','09:05:00',1.08),('15529','2013-08-01','09:10:00',1.12),('15529','2013-08-01','09:15:00',1.17),('15529','2013-08-01','09:20:00',1.21),('15529','2013-08-01','09:25:00',1.24),('15529','2013-08-01','09:30:00',1.28),('15529','2013-08-01','09:35:00',1.32),('15529','2013-08-01','09:40:00',1.35),('15529','2013-08-01','09:45:00',1.38),('15529','2013-08-01','09:50:00',1.41),('15529','2013-08-01','09:55:00',1.45),('15529','2013-08-01','10:00:00',1.48),('15529','2013-08-01','10:05:00',1.53),('15529','2013-08-01','10:10:00',1.57),('15529','2013-08-01','10:15:00',1.59),('15529','2013-08-01','10:20:00',1.62),('15529','2013-08-01','10:25:00',1.65),('15529','2013-08-01','10:30:00',1.67),('15529','2013-08-01','10:35:00',1.72),('15529','2013-08-01','10:40:00',1.74),('15529','2013-08-01','10:45:00',1.76),('15529','2013-08-01','10:50:00',1.78),('15529','2013-08-01','10:55:00',1.81),('15529','2013-08-01','11:00:00',1.84),('15529','2013-08-01','11:05:00',1.84),('15529','2013-08-01','11:10:00',1.87),('15529','2013-08-01','11:15:00',1.89),('15529','2013-08-01','11:20:00',1.92),('15529','2013-08-01','11:25:00',1.92),('15529','2013-08-01','11:30:00',1.92),('15529','2013-08-01','11:35:00',1.93),('15529','2013-08-01','11:40:00',1.97),('15529','2013-08-01','11:45:00',1.97),('15529','2013-08-01','11:50:00',2),('15529','2013-08-01','11:55:00',2.02),('15529','2013-08-01','12:00:00',2.03),('15529','2013-08-01','12:05:00',2.03),('15529','2013-08-01','12:10:00',2.05),('15529','2013-08-01','12:15:00',2.05),('15529','2013-08-01','12:20:00',2.02),('15529','2013-08-01','12:25:00',2.02),('15529','2013-08-01','12:30:00',2.03),('15529','2013-08-01','12:35:00',2.08),('15529','2013-08-01','12:40:00',2.06),('15529','2013-08-01','12:45:00',2.06),('15529','2013-08-01','12:50:00',2.08),('15529','2013-08-01','12:55:00',2.11),('15529','2013-08-01','13:00:00',2.06),('15529','2013-08-01','13:05:00',2.09),('15529','2013-08-01','13:10:00',2.1),('15529','2013-08-01','13:15:00',2.09),('15529','2013-08-01','13:20:00',2.08),('15529','2013-08-01','13:25:00',2.06),('15529','2013-08-01','13:30:00',2.05),('15529','2013-08-01','13:35:00',2.05),('15529','2013-08-01','13:40:00',2.07),('15529','2013-08-01','13:45:00',2.01),('15529','2013-08-01','13:50:00',2.03),('15529','2013-08-01','13:55:00',2.06),('15529','2013-08-01','14:00:00',2.02),('15529','2013-08-01','14:05:00',2.06),('15529','2013-08-01','14:10:00',2.07),('15529','2013-08-01','14:15:00',2.1),('15529','2013-08-01','14:20:00',2.06),('15529','2013-08-01','14:25:00',2.03),('15529','2013-08-01','14:30:00',2.02),('15529','2013-08-01','14:35:00',1.99),('15529','2013-08-01','14:40:00',1.98),('15529','2013-08-01','14:45:00',1.98),('15529','2013-08-01','14:50:00',1.96),('15529','2013-08-01','14:55:00',1.93),('15529','2013-08-01','15:00:00',1.92),('15529','2013-08-01','15:05:00',1.88),('15529','2013-08-01','15:10:00',1.87),('15529','2013-08-01','15:15:00',1.86),('15529','2013-08-01','15:20:00',1.84),('15529','2013-08-01','15:25:00',1.83),('15529','2013-08-01','15:30:00',1.79),('15529','2013-08-01','15:35:00',1.78),('15529','2013-08-01','15:40:00',1.77),('15529','2013-08-01','15:45:00',1.73),('15529','2013-08-01','15:50:00',1.71),('15529','2013-08-01','15:55:00',1.68),('15529','2013-08-01','16:00:00',1.65),('15529','2013-08-01','16:05:00',1.6),('15529','2013-08-01','16:10:00',1.59),('15529','2013-08-01','16:15:00',1.55),('15529','2013-08-01','16:20:00',1.52),('15529','2013-08-01','16:25:00',1.48),('15529','2013-08-01','16:30:00',1.42),('15529','2013-08-01','16:35:00',1.39),('15529','2013-08-01','16:40:00',1.36),('15529','2013-08-01','16:45:00',1.34),('15529','2013-08-01','16:50:00',1.29),('15529','2013-08-01','16:55:00',1.25),('15529','2013-08-01','17:00:00',1.21),('15529','2013-08-01','17:05:00',1.16),('15529','2013-08-01','17:10:00',1.12),('15529','2013-08-01','17:15:00',1.08),('15529','2013-08-01','17:20:00',1.05),('15529','2013-08-01','17:25:00',1.01),('15529','2013-07-31','09:00:00',1.05),('15529','2013-07-31','09:05:00',1.09),('15529','2013-07-31','09:10:00',1.14),('15529','2013-07-31','09:15:00',1.18),('15529','2013-07-31','09:20:00',1.24),('15529','2013-07-31','09:25:00',1.28),('15529','2013-07-31','09:30:00',1.31),('15529','2013-07-31','09:35:00',1.35),('15529','2013-07-31','09:40:00',1.38),('15529','2013-07-31','09:45:00',1.42),('15529','2013-07-31','09:50:00',1.47),('15529','2013-07-31','09:55:00',1.51),('15529','2013-07-31','10:00:00',1.55),('15529','2013-07-31','10:05:00',1.59),('15529','2013-07-31','10:10:00',1.62),('15529','2013-07-31','10:15:00',1.66),('15529','2013-07-31','10:20:00',1.69),('15529','2013-07-31','10:25:00',1.71),('15529','2013-07-31','10:30:00',1.75),('15529','2013-07-31','10:35:00',1.76),('15529','2013-07-31','10:40:00',1.8),('15529','2013-07-31','10:45:00',1.83),('15529','2013-07-31','10:50:00',1.86),('15529','2013-07-31','10:55:00',1.87),('15529','2013-07-31','11:00:00',1.91),('15529','2013-07-31','11:05:00',1.91),('15529','2013-07-31','11:10:00',1.93),('15529','2013-07-31','11:15:00',1.96),('15529','2013-07-31','11:20:00',1.99),('15529','2013-07-31','11:25:00',2),('15529','2013-07-31','11:30:00',2.04),('15529','2013-07-31','11:35:00',2.06),('15529','2013-07-31','11:40:00',2.07),('15529','2013-07-31','11:45:00',2.11),('15529','2013-07-31','11:50:00',2.1),('15529','2013-07-31','11:55:00',2.09),('15529','2013-07-31','12:00:00',2.09),('15529','2013-07-31','12:05:00',2.11),('15529','2013-07-31','12:10:00',2.07),('15529','2013-07-31','12:15:00',2.11),('15529','2013-07-31','12:20:00',2.17),('15529','2013-07-31','12:25:00',2.18),('15529','2013-07-31','12:30:00',2.17),('15529','2013-07-31','12:35:00',2.15),('15529','2013-07-31','12:40:00',2.19),('15529','2013-07-31','12:45:00',2.16),('15529','2013-07-31','12:50:00',2.18),('15529','2013-07-31','12:55:00',2.19),('15529','2013-07-31','13:00:00',2.21),('15529','2013-07-31','13:05:00',2.18),('15529','2013-07-31','13:10:00',1.79),('15529','2013-07-31','13:15:00',2.1),('15529','2013-07-31','13:20:00',2.07),('15529','2013-07-31','13:25:00',2.23),('15529','2013-07-31','13:30:00',2.24),('15529','2013-07-31','13:35:00',2.22),('15529','2013-07-31','13:40:00',2.22),('15529','2013-07-31','13:45:00',2.22),('15529','2013-07-31','13:50:00',2.24),('15529','2013-07-31','13:55:00',2.2),('15529','2013-07-31','14:00:00',2.19),('15529','2013-07-31','14:05:00',2.17),('15529','2013-07-31','14:10:00',2.13),('15529','2013-07-31','14:15:00',2.17),('15529','2013-07-31','14:20:00',2.15),('15529','2013-07-31','14:25:00',2.12),('15529','2013-07-31','14:30:00',2.07),('15529','2013-07-31','14:35:00',2.07),('15529','2013-07-31','14:40:00',2.07),('15529','2013-07-31','14:45:00',2.05),('15529','2013-07-31','14:50:00',1.84),('15529','2013-07-31','14:55:00',1.98),('15529','2013-07-31','15:00:00',1.95),('15529','2013-07-31','15:05:00',1.93),('15529','2013-07-31','15:10:00',1.94),('15529','2013-07-31','15:15:00',1.92),('15529','2013-07-31','15:20:00',1.89),('15529','2013-07-31','15:25:00',1.87),('15529','2013-07-31','15:30:00',1.88),('15529','2013-07-31','15:35:00',1.83),('15529','2013-07-31','15:40:00',1.88),('15529','2013-07-31','15:45:00',1.76),('15529','2013-07-31','15:50:00',1.76),('15529','2013-07-31','15:55:00',1.74),('15529','2013-07-31','16:00:00',1.7),('15529','2013-07-31','16:05:00',1.7),('15529','2013-07-31','16:10:00',1.66),('15529','2013-07-31','16:15:00',1.59),('15529','2013-07-31','16:20:00',1.55),('15529','2013-07-31','16:25:00',1.52),('15529','2013-07-31','16:30:00',1.48),('15529','2013-07-31','16:35:00',1.45),('15529','2013-07-31','16:40:00',1.4),('15529','2013-07-31','16:45:00',1.36),('15529','2013-07-31','16:50:00',1.32),('15529','2013-07-31','16:55:00',1.28),('15529','2013-07-31','17:00:00',1.23),('15529','2013-07-31','17:05:00',1.19),('15529','2013-07-31','17:10:00',1.13),('15529','2013-07-31','17:15:00',1.1),('15529','2013-07-31','17:20:00',1.06),('15529','2013-07-31','17:25:00',1.02),('15529','2013-07-30','08:55:00',1.03),('15529','2013-07-30','09:00:00',1.07),('15529','2013-07-30','09:05:00',1.11),('15529','2013-07-30','09:10:00',1.15),('15529','2013-07-30','09:15:00',1.2),('15529','2013-07-30','09:20:00',1.24),('15529','2013-07-30','09:25:00',1.28),('15529','2013-07-30','09:30:00',1.31),('15529','2013-07-30','09:35:00',1.36),('15529','2013-07-30','09:40:00',1.39),('15529','2013-07-30','09:45:00',1.43),('15529','2013-07-30','09:50:00',1.45),('15529','2013-07-30','09:55:00',1.49),('15529','2013-07-30','10:00:00',1.52),('15529','2013-07-30','10:05:00',1.56),('15529','2013-07-30','10:10:00',1.57),('15529','2013-07-30','10:15:00',1.59),('15529','2013-07-30','10:20:00',1.66),('15529','2013-07-30','10:25:00',1.69),('15529','2013-07-30','10:30:00',1.71),('15529','2013-07-30','10:35:00',1.75),('15529','2013-07-30','10:40:00',1.79),('15529','2013-07-30','10:45:00',1.81),('15529','2013-07-30','10:50:00',1.84),('15529','2013-07-30','10:55:00',1.89),('15529','2013-07-30','11:00:00',1.92),('15529','2013-07-30','11:05:00',1.96),('15529','2013-07-30','11:10:00',1.96),('15529','2013-07-30','11:15:00',1.96),('15529','2013-07-30','11:20:00',2),('15529','2013-07-30','11:25:00',1.98),('15529','2013-07-30','11:30:00',2.01),('15529','2013-07-30','11:35:00',2.03),('15529','2013-07-30','11:40:00',2.05),('15529','2013-07-30','11:45:00',2.06),('15529','2013-07-30','11:50:00',2.08),('15529','2013-07-30','11:55:00',1.86),('15529','2013-07-30','12:00:00',2.06),('15529','2013-07-30','12:05:00',2.05),('15529','2013-07-30','12:10:00',2.14),('15529','2013-07-30','12:15:00',1.95),('15529','2013-07-30','12:20:00',2.16),('15529','2013-07-30','12:25:00',2.12),('15529','2013-07-30','12:30:00',1.05),('15529','2013-07-30','12:35:00',2.09),('15529','2013-07-30','12:40:00',2.16),('15529','2013-07-30','12:45:00',2.15),('15529','2013-07-30','12:55:00',1.63),('15529','2013-07-30','13:00:00',1.86),('15529','2013-07-30','13:05:00',1.86),('15529','2013-07-30','13:10:00',1.9),('15529','2013-07-30','13:15:00',2.25),('15529','2013-07-30','13:20:00',1.23),('15529','2013-07-30','13:35:00',2.1),('15529','2013-07-30','13:40:00',2.12),('15529','2013-07-30','13:45:00',2.08),('15529','2013-07-30','13:50:00',2.1),('15529','2013-07-30','13:55:00',2.12),('15529','2013-07-30','14:00:00',2.02),('15529','2013-07-30','14:05:00',1.86),('15529','2013-07-30','14:10:00',2.07),('15529','2013-07-30','14:15:00',2.06),('15529','2013-07-30','14:20:00',2.05),('15529','2013-07-30','14:25:00',1.79),('15529','2013-07-30','14:45:00',1.61),('15529','2013-07-30','14:50:00',2.05),('15529','2013-07-30','14:55:00',2.06),('15529','2013-07-30','15:00:00',2.03),('15529','2013-07-30','15:05:00',2.01),('15529','2013-07-30','15:10:00',1.95),('15529','2013-07-30','15:15:00',1.92),('15529','2013-07-30','15:20:00',1.92),('15529','2013-07-30','15:25:00',1.9),('15529','2013-07-30','15:30:00',1.85),('15529','2013-07-30','15:35:00',1.84),('15529','2013-07-30','15:40:00',1.82),('15529','2013-07-30','15:45:00',1.66),('15529','2013-07-30','15:50:00',1.69),('15529','2013-07-30','15:55:00',1.69),('15529','2013-07-30','16:00:00',1.67),('15529','2013-07-30','16:05:00',1.64),('15529','2013-07-30','16:10:00',1.62),('15529','2013-07-30','16:15:00',1.58),('15529','2013-07-30','16:20:00',1.56),('15529','2013-07-30','16:25:00',1.56),('15529','2013-07-30','16:30:00',1.52),('15529','2013-07-30','16:35:00',1.45),('15529','2013-07-30','16:40:00',1.4),('15529','2013-07-30','16:45:00',1.36),('15529','2013-07-30','16:50:00',1.27),('15529','2013-07-30','16:55:00',1.28),('15529','2013-07-30','17:00:00',1.27),('15529','2013-07-30','17:20:00',1.12),('15529','2014-04-07','09:05:00',1.05),('15529','2014-04-07','09:10:00',1.1),('15529','2014-04-07','09:15:00',1.14),('15529','2014-04-07','09:20:00',1.19),('15529','2014-04-07','09:25:00',1.24),('15529','2014-04-07','09:30:00',1.26),('15529','2014-04-07','09:35:00',1.28),('15529','2014-04-07','09:40:00',1.3),('15529','2014-04-07','09:45:00',1.36),('15529','2014-04-07','09:50:00',1.39),('15529','2014-04-07','09:55:00',1.43),('15529','2014-04-07','10:00:00',1.43),('15529','2014-04-07','10:05:00',1.49),('15529','2014-04-07','10:10:00',1.59),('15529','2014-04-07','10:15:00',1.61),('15529','2014-04-07','10:20:00',1.64),('15529','2014-04-07','10:25:00',1.67),('15529','2014-04-07','10:30:00',1.7),('15529','2014-04-07','10:35:00',1.76),('15529','2014-04-07','10:40:00',1.77),('15529','2014-04-07','10:45:00',1.82),('15529','2014-04-07','10:50:00',1.85),('15529','2014-04-07','10:55:00',1.87),('15529','2014-04-07','11:00:00',1.89),('15529','2014-04-07','11:05:00',1.91),('15529','2014-04-07','11:10:00',1.91),('15529','2014-04-07','11:15:00',1.94),('15529','2014-04-07','11:20:00',1.96),('15529','2014-04-07','11:25:00',2),('15529','2014-04-07','11:30:00',1.96),('15529','2014-04-07','11:35:00',2.03),('15529','2014-04-07','11:40:00',2.04),('15529','2014-04-07','11:45:00',2.07),('15529','2014-04-07','11:50:00',2.1),('15529','2014-04-07','11:55:00',2.14),('15529','2014-04-07','12:00:00',2.13),('15529','2014-04-07','12:05:00',2.07),('15529','2014-04-07','12:10:00',2),('15529','2014-04-07','12:15:00',1.85),('15529','2014-04-07','12:20:00',1.9),('15529','2014-04-07','12:25:00',1.96),('15529','2014-04-07','12:30:00',1.92),('15529','2014-04-07','12:35:00',2.09),('15529','2014-04-07','12:40:00',1.84),('15529','2014-04-07','12:45:00',1.99),('15529','2014-04-07','12:50:00',1.88),('15529','2014-04-07','12:55:00',2.22),('15529','2014-04-07','13:00:00',2.15),('15529','2014-04-07','13:05:00',2.27),('15529','2014-04-07','13:10:00',2.23),('15529','2014-04-07','13:15:00',2.31),('15529','2014-04-07','13:20:00',2.31),('15529','2014-04-07','13:25:00',2.3),('15529','2014-04-07','13:30:00',2.32),('15529','2014-04-07','13:35:00',2.3),('15529','2014-04-07','13:40:00',2.32),('15529','2014-04-07','13:45:00',2.28),('15529','2014-04-07','13:50:00',2.26),('15529','2014-04-07','13:55:00',2.27),('15529','2014-04-07','14:00:00',2.22),('15529','2014-04-07','14:05:00',2.21),('15529','2014-04-07','14:10:00',2.22),('15529','2014-04-07','14:15:00',2.21),('15529','2014-04-07','14:20:00',2.05),('15529','2014-04-07','14:25:00',1.95),('15529','2014-04-07','14:30:00',2.17),('15529','2014-04-07','14:35:00',2.13),('15529','2014-04-07','14:40:00',1.75),('15529','2014-04-07','14:45:00',2.02),('15529','2014-04-07','14:50:00',2.07),('15529','2014-04-07','14:55:00',2.09),('15529','2014-04-07','15:00:00',2.06),('15529','2014-04-07','15:05:00',2.02),('15529','2014-04-07','15:10:00',1.99),('15529','2014-04-07','15:15:00',1.92),('15529','2014-04-07','15:20:00',1.93),('15529','2014-04-07','15:25:00',1.92),('15529','2014-04-07','15:30:00',1.88),('15529','2014-04-07','15:35:00',1.84),('15529','2014-04-07','15:40:00',1.76),('15529','2014-04-07','15:45:00',1.75),('15529','2014-04-07','15:50:00',1.76),('15529','2014-04-07','15:55:00',1.71),('15529','2014-04-07','16:00:00',1.63),('15529','2014-04-07','16:05:00',1.66),('15529','2014-04-07','16:10:00',1.57),('15529','2014-04-07','16:15:00',1.49),('15529','2014-04-07','16:20:00',1.4),('15529','2014-04-07','16:25:00',1.4),('15529','2014-04-07','16:30:00',1.48),('15529','2014-04-07','16:35:00',1.39),('15529','2014-04-07','16:40:00',1.36),('15529','2014-04-07','16:45:00',1.31),('15529','2014-04-07','16:50:00',1.28),('15529','2014-04-07','16:55:00',1.18),('15529','2014-04-07','17:00:00',1.13),('15529','2014-04-07','17:05:00',1.13),('15529','2014-04-07','17:10:00',1.07),('15529','2014-04-07','17:15:00',1.02),('15529','2013-07-29','09:05:00',1.15),('15529','2013-07-29','09:10:00',1.22),('15529','2013-07-29','09:25:00',1.33),('15529','2013-07-29','09:30:00',1.07),('15529','2013-07-29','09:35:00',1.34),('15529','2013-07-29','09:40:00',1.42),('15529','2013-07-29','09:45:00',1.5),('15529','2013-07-29','09:50:00',1.57),('15529','2013-07-29','09:55:00',1.58),('15529','2013-07-29','10:00:00',1.59),('15529','2013-07-29','10:05:00',1.66),('15529','2013-07-29','10:10:00',1.7),('15529','2013-07-29','10:15:00',1.73),('15529','2013-07-29','10:20:00',1.76),('15529','2013-07-29','10:25:00',1.81),('15529','2013-07-29','10:30:00',1.83),('15529','2013-07-29','10:35:00',1.79),('15529','2013-07-29','10:40:00',1.83),('15529','2013-07-29','10:45:00',1.42),('15529','2013-07-29','10:50:00',1.35),('15529','2013-07-29','10:55:00',1.74),('15529','2013-07-29','11:00:00',1.82),('15529','2013-07-29','11:05:00',1.86),('15529','2013-07-29','11:10:00',1.82),('15529','2013-07-29','11:15:00',1.86),('15529','2013-07-29','11:20:00',1.88),('15529','2013-07-29','11:25:00',1.89),('15529','2013-07-29','11:30:00',1.91),('15529','2013-07-29','11:35:00',1.9),('15529','2013-07-29','11:40:00',1.9),('15529','2013-07-29','11:45:00',1.71),('15529','2013-07-29','11:50:00',1.75),('15529','2013-07-29','11:55:00',1.7),('15529','2013-07-29','12:00:00',1.7),('15529','2013-07-29','12:05:00',1.18),('15529','2013-07-29','12:10:00',1.15),('15529','2013-07-29','12:15:00',1.14),('15529','2013-07-29','12:20:00',1.14),('15529','2013-07-29','12:40:00',1.82),('15529','2013-07-29','12:45:00',2.19),('15529','2013-07-29','12:50:00',2.14),('15529','2013-07-29','12:55:00',1.5),('15529','2013-07-29','13:15:00',1.52),('15529','2013-07-29','13:20:00',2.3),('15529','2013-07-29','13:25:00',2.21),('15529','2013-07-29','13:30:00',2.19),('15529','2013-07-29','13:35:00',1.48),('15529','2013-07-29','13:40:00',2.25),('15529','2013-07-29','13:45:00',2.17),('15529','2013-07-29','13:50:00',2.17),('15529','2013-07-29','13:55:00',2.17),('15529','2013-07-29','14:00:00',2.12),('15529','2013-07-29','14:05:00',2.12),('15529','2013-07-29','14:10:00',2.19),('15529','2013-07-29','14:15:00',1.52),('15529','2013-07-29','14:20:00',2.06),('15529','2013-07-29','14:25:00',2.12),('15529','2013-07-29','14:35:00',1.5),('15529','2013-07-29','14:40:00',2.05),('15529','2013-07-29','14:45:00',1.99),('15529','2013-07-29','14:50:00',1.96),('15529','2013-07-29','14:55:00',1.98),('15529','2013-07-29','15:00:00',1.84),('15529','2013-07-29','15:05:00',1.84),('15529','2013-07-29','15:10:00',1.86),('15529','2013-07-29','15:15:00',1.87),('15529','2013-07-29','15:20:00',1.86),('15529','2013-07-29','15:25:00',1.83),('15529','2013-07-29','15:30:00',1.81),('15529','2013-07-29','15:35:00',1.78),('15529','2013-07-29','15:40:00',1.77),('15529','2013-07-29','15:45:00',1.74),('15529','2013-07-29','15:50:00',1.7),('15529','2013-07-29','15:55:00',1.66),('15529','2013-07-29','16:00:00',1.64),('15529','2013-07-29','16:05:00',1.6),('15529','2013-07-29','16:10:00',1.57),('15529','2013-07-29','16:15:00',1.54),('15529','2013-07-29','16:20:00',1.5),('15529','2013-07-29','16:25:00',1.46),('15529','2013-07-29','16:30:00',1.42),('15529','2013-07-29','16:35:00',1.38),('15529','2013-07-29','16:40:00',1.35),('15529','2013-07-29','16:45:00',1.33),('15529','2013-07-29','16:50:00',1.29),('15529','2013-07-29','16:55:00',1.24),('15529','2013-07-29','17:00:00',1.2),('15529','2013-07-29','17:05:00',1.17),('15529','2013-07-29','17:10:00',1.12),('15529','2013-07-29','17:15:00',1.07),('15529','2013-07-29','17:20:00',1.02),('15529','2013-07-28','09:10:00',1.03),('15529','2013-07-28','09:15:00',1.06),('15529','2013-07-28','09:20:00',1.12),('15529','2013-07-28','09:25:00',1.16),('15529','2013-07-28','09:30:00',1.19),('15529','2013-07-28','09:35:00',1.22),('15529','2013-07-28','09:40:00',1.28),('15529','2013-07-28','09:45:00',1.32),('15529','2013-07-28','09:50:00',1.35),('15529','2013-07-28','09:55:00',1.37),('15529','2013-07-28','10:00:00',1.41),('15529','2013-07-28','10:05:00',1.43),('15529','2013-07-28','10:10:00',1.46),('15529','2013-07-28','10:15:00',1.52),('15529','2013-07-28','10:20:00',1.56),('15529','2013-07-28','10:25:00',1.58),('15529','2013-07-28','10:30:00',1.63),('15529','2013-07-28','10:35:00',1.64),('15529','2013-07-28','10:40:00',1.64),('15529','2013-07-28','10:45:00',1.69),('15529','2013-07-28','10:50:00',1.73),('15529','2013-07-28','10:55:00',1.73),('15529','2013-07-28','11:00:00',1.79),('15529','2013-07-28','11:05:00',1.81),('15529','2013-07-28','11:10:00',1.79),('15529','2013-07-28','11:15:00',1.85),('15529','2013-07-28','11:20:00',1.88),('15529','2013-07-28','11:25:00',1.9),('15529','2013-07-28','11:30:00',1.94),('15529','2013-07-28','11:35:00',1.88),('15529','2013-07-28','11:40:00',1.95),('15529','2013-07-28','11:45:00',1.95),('15529','2013-07-28','11:50:00',1.97),('15529','2013-07-28','11:55:00',1.9),('15529','2013-07-28','12:00:00',1.94),('15529','2013-07-28','12:05:00',2.03),('15529','2013-07-28','12:10:00',2.02),('15529','2013-07-28','12:15:00',1.95),('15529','2013-07-28','12:20:00',1.99),('15529','2013-07-28','12:25:00',1.96),('15529','2013-07-28','12:30:00',1.92),('15529','2013-07-28','12:35:00',1.97),('15529','2013-07-28','12:40:00',2.03),('15529','2013-07-28','12:45:00',2),('15529','2013-07-28','12:50:00',1.99),('15529','2013-07-28','12:55:00',2.04),('15529','2013-07-28','13:00:00',1.58),('15529','2013-07-28','13:05:00',2.08),('15529','2013-07-28','13:10:00',2.1),('15529','2013-07-28','13:15:00',2.07),('15529','2013-07-28','13:20:00',2.08),('15529','2013-07-28','13:25:00',2.14),('15529','2013-07-28','13:30:00',2.13),('15529','2013-07-28','13:35:00',2.07),('15529','2013-07-28','13:40:00',2.11),('15529','2013-07-28','13:45:00',2.11),('15529','2013-07-28','13:50:00',2.08),('15529','2013-07-28','13:55:00',2.04),('15529','2013-07-28','14:00:00',2.04),('15529','2013-07-28','14:05:00',2.03),('15529','2013-07-28','14:10:00',2.01),('15529','2013-07-28','14:15:00',2.01),('15529','2013-07-28','14:20:00',2.03),('15529','2013-07-28','14:25:00',2.01),('15529','2013-07-28','14:30:00',1.99),('15529','2013-07-28','14:35:00',1.99),('15529','2013-07-28','14:40:00',1.94),('15529','2013-07-28','14:45:00',1.92),('15529','2013-07-28','14:50:00',1.9),('15529','2013-07-28','14:55:00',1.9),('15529','2013-07-28','15:00:00',1.88),('15529','2013-07-28','15:05:00',1.88),('15529','2013-07-28','15:10:00',1.85),('15529','2013-07-28','15:15:00',1.81),('15529','2013-07-28','15:20:00',1.79),('15529','2013-07-28','15:25:00',1.79),('15529','2013-07-28','15:30:00',1.78),('15529','2013-07-28','15:35:00',1.78),('15529','2013-07-28','15:40:00',1.81),('15529','2013-07-28','15:45:00',1.51),('15529','2013-07-28','15:50:00',1.24),('15529','2013-07-28','16:00:00',1.05),('15529','2013-07-28','16:05:00',1.56),('15529','2013-07-28','16:10:00',1.34),('15529','2013-07-28','16:15:00',1.19),('15529','2013-07-28','16:20:00',1.11),('15529','2013-07-28','16:25:00',1.51),('15529','2013-07-28','16:30:00',1.45),('15529','2013-07-28','16:35:00',1.07),('15529','2013-07-28','16:40:00',1.48),('15529','2013-07-28','16:45:00',1.42),('15529','2013-07-28','17:05:00',1.04),('15529','2013-07-28','17:20:00',1.12),('15529','2013-07-27','09:05:00',1.02),('15529','2013-07-27','09:10:00',1.07),('15529','2013-07-27','09:15:00',1.1),('15529','2013-07-27','09:20:00',1.13),('15529','2013-07-27','09:25:00',1.17),('15529','2013-07-27','09:30:00',1.21),('15529','2013-07-27','09:35:00',1.24),('15529','2013-07-27','09:40:00',1.28),('15529','2013-07-27','09:45:00',1.33),('15529','2013-07-27','09:50:00',1.36),('15529','2013-07-27','09:55:00',1.39),('15529','2013-07-27','10:00:00',1.42),('15529','2013-07-27','10:05:00',1.46),('15529','2013-07-27','10:10:00',1.49),('15529','2013-07-27','10:15:00',1.53),('15529','2013-07-27','10:20:00',1.56),('15529','2013-07-27','10:25:00',1.6),('15529','2013-07-27','10:30:00',1.6),('15529','2013-07-27','10:35:00',1.65),('15529','2013-07-27','10:40:00',1.66),('15529','2013-07-27','10:45:00',1.66),('15529','2013-07-27','10:50:00',1.71),('15529','2013-07-27','10:55:00',1.7),('15529','2013-07-27','11:00:00',1.74),('15529','2013-07-27','11:05:00',1.76),('15529','2013-07-27','11:10:00',1.78),('15529','2013-07-27','11:15:00',1.78),('15529','2013-07-27','11:20:00',1.82),('15529','2013-07-27','11:25:00',1.84),('15529','2013-07-27','11:30:00',1.84),('15529','2013-07-27','11:35:00',1.89),('15529','2013-07-27','11:40:00',1.86),('15529','2013-07-27','11:45:00',1.93),('15529','2013-07-27','11:50:00',1.91),('15529','2013-07-27','11:55:00',1.88),('15529','2013-07-27','12:00:00',1.91),('15529','2013-07-27','12:05:00',1.92),('15529','2013-07-27','12:10:00',1.88),('15529','2013-07-27','12:15:00',1.94),('15529','2013-07-27','12:20:00',1.96),('15529','2013-07-27','12:25:00',1.92),('15529','2013-07-27','12:30:00',1.96),('15529','2013-07-27','12:35:00',2),('15529','2013-07-27','12:40:00',2.02),('15529','2013-07-27','12:45:00',1.99),('15529','2013-07-27','12:50:00',2.05),('15529','2013-07-27','12:55:00',2.04),('15529','2013-07-27','13:00:00',2.05),('15529','2013-07-27','13:05:00',2.04),('15529','2013-07-27','13:10:00',2.02),('15529','2013-07-27','13:15:00',1.97),('15529','2013-07-27','13:20:00',1.97),('15529','2013-07-27','13:25:00',2),('15529','2013-07-27','13:30:00',2.05),('15529','2013-07-27','13:35:00',2.08),('15529','2013-07-27','13:40:00',2.07),('15529','2013-07-27','13:45:00',2.08),('15529','2013-07-27','13:50:00',2.13),('15529','2013-07-27','13:55:00',2.04),('15529','2013-07-27','14:00:00',2.08),('15529','2013-07-27','14:05:00',2.06),('15529','2013-07-27','14:10:00',2.07),('15529','2013-07-27','14:15:00',2.02),('15529','2013-07-27','14:20:00',2),('15529','2013-07-27','14:25:00',2.02),('15529','2013-07-27','14:30:00',1.99),('15529','2013-07-27','14:35:00',1.98),('15529','2013-07-27','14:40:00',1.96),('15529','2013-07-27','14:45:00',1.94),('15529','2013-07-27','14:50:00',1.91),('15529','2013-07-27','14:55:00',1.88),('15529','2013-07-27','15:00:00',1.91),('15529','2013-07-27','15:05:00',1.86),('15529','2013-07-27','15:10:00',1.81),('15529','2013-07-27','15:15:00',1.8),('15529','2013-07-27','15:20:00',1.81),('15529','2013-07-27','15:25:00',1.75),('15529','2013-07-27','15:30:00',1.76),('15529','2013-07-27','15:35:00',1.73),('15529','2013-07-27','15:40:00',1.69),('15529','2013-07-27','15:45:00',1.68),('15529','2013-07-27','15:50:00',1.66),('15529','2013-07-27','15:55:00',1.63),('15529','2013-07-27','16:00:00',1.62),('15529','2013-07-27','16:05:00',1.6),('15529','2013-07-27','16:10:00',1.59),('15529','2013-07-27','16:15:00',1.54),('15529','2013-07-27','16:20:00',1.51),('15529','2013-07-27','16:25:00',1.49),('15529','2013-07-27','16:30:00',1.45),('15529','2013-07-27','16:35:00',1.4),('15529','2013-07-27','16:40:00',1.36),('15529','2013-07-27','16:45:00',1.33),('15529','2013-07-27','16:50:00',1.3),('15529','2013-07-27','16:55:00',1.26),('15529','2013-07-27','17:00:00',1.22),('15529','2013-07-27','17:05:00',1.18),('15529','2013-07-27','17:10:00',1.14),('15529','2013-07-27','17:15:00',1.1),('15529','2013-07-27','17:20:00',1.05),('15529','2013-07-27','17:25:00',1.01),('15529','2013-07-26','09:05:00',1.03),('15529','2013-07-26','09:10:00',1.08),('15529','2013-07-26','09:15:00',1.12),('15529','2013-07-26','09:20:00',1.17),('15529','2013-07-26','09:25:00',1.21),('15529','2013-07-26','09:30:00',1.24),('15529','2013-07-26','09:35:00',1.28),('15529','2013-07-26','09:40:00',1.31),('15529','2013-07-26','09:45:00',1.34),('15529','2013-07-26','09:50:00',1.39),('15529','2013-07-26','09:55:00',1.43),('15529','2013-07-26','10:00:00',1.46),('15529','2013-07-26','10:05:00',1.5),('15529','2013-07-26','10:10:00',1.53),('15529','2013-07-26','10:15:00',1.58),('15529','2013-07-26','10:20:00',1.59),('15529','2013-07-26','10:25:00',1.64),('15529','2013-07-26','10:30:00',1.66),('15529','2013-07-26','10:35:00',1.64),('15529','2013-07-26','10:40:00',1.72),('15529','2013-07-26','10:45:00',1.76),('15529','2013-07-26','10:50:00',1.74),('15529','2013-07-26','10:55:00',1.78),('15529','2013-07-26','11:00:00',1.8),('15529','2013-07-26','11:05:00',1.8),('15529','2013-07-26','11:10:00',1.8),('15529','2013-07-26','11:15:00',1.83),('15529','2013-07-26','11:20:00',1.89),('15529','2013-07-26','11:25:00',1.84),('15529','2013-07-26','11:30:00',1.89),('15529','2013-07-26','11:35:00',1.9),('15529','2013-07-26','11:40:00',1.9),('15529','2013-07-26','11:45:00',1.93),('15529','2013-07-26','11:50:00',1.96),('15529','2013-07-26','11:55:00',1.9),('15529','2013-07-26','12:00:00',1.85),('15529','2013-07-26','12:05:00',1.94),('15529','2013-07-26','12:10:00',1.98),('15529','2013-07-26','12:15:00',1.97),('15529','2013-07-26','12:20:00',2.02),('15529','2013-07-26','12:25:00',2),('15529','2013-07-26','12:30:00',1.99),('15529','2013-07-26','12:35:00',2.01),('15529','2013-07-26','12:40:00',2.05),('15529','2013-07-26','12:45:00',2.07),('15529','2013-07-26','12:50:00',1.94),('15529','2013-07-26','12:55:00',1.97),('15529','2013-07-26','13:00:00',2.12),('15529','2013-07-26','13:05:00',2.15),('15529','2013-07-26','13:10:00',1.98),('15529','2013-07-26','13:15:00',2),('15529','2013-07-26','13:20:00',2.07),('15529','2013-07-26','13:25:00',2.1),('15529','2013-07-26','13:30:00',2),('15529','2013-07-26','13:35:00',2.08),('15529','2013-07-26','13:40:00',2.04),('15529','2013-07-26','13:45:00',2.04),('15529','2013-07-26','13:50:00',2.07),('15529','2013-07-26','13:55:00',2.04),('15529','2013-07-26','14:00:00',2.04),('15529','2013-07-26','14:05:00',2.01),('15529','2013-07-26','14:10:00',2.03),('15529','2013-07-26','14:15:00',2.02),('15529','2013-07-26','14:20:00',2.01),('15529','2013-07-26','14:25:00',1.98),('15529','2013-07-26','14:30:00',1.96),('15529','2013-07-26','14:35:00',1.96),('15529','2013-07-26','14:40:00',1.99),('15529','2013-07-26','14:45:00',1.95),('15529','2013-07-26','14:50:00',1.91),('15529','2013-07-26','14:55:00',1.9),('15529','2013-07-26','15:00:00',1.87),('15529','2013-07-26','15:05:00',1.91),('15529','2013-07-26','15:10:00',1.88),('15529','2013-07-26','15:15:00',1.85),('15529','2013-07-26','15:20:00',1.83),('15529','2013-07-26','15:25:00',1.8),('15529','2013-07-26','15:30:00',1.78),('15529','2013-07-26','15:35:00',1.77),('15529','2013-07-26','15:40:00',1.75),('15529','2013-07-26','15:45:00',1.72),('15529','2013-07-26','15:50:00',1.7),('15529','2013-07-26','15:55:00',1.66),('15529','2013-07-26','16:00:00',1.63),('15529','2013-07-26','16:05:00',1.59),('15529','2013-07-26','16:10:00',1.56),('15529','2013-07-26','16:15:00',1.55),('15529','2013-07-26','16:20:00',1.51),('15529','2013-07-26','16:25:00',1.48),('15529','2013-07-26','16:30:00',1.45),('15529','2013-07-26','16:35:00',1.42),('15529','2013-07-26','16:40:00',1.37),('15529','2013-07-26','16:45:00',1.34),('15529','2013-07-26','16:50:00',1.3),('15529','2013-07-26','16:55:00',1.25),('15529','2013-07-26','17:00:00',1.22),('15529','2013-07-26','17:05:00',1.18),('15529','2013-07-26','17:10:00',1.14),('15529','2013-07-26','17:15:00',1.09),('15529','2013-07-26','17:20:00',1.06),('15529','2013-07-26','17:25:00',1.01),('15529','2013-07-25','09:10:00',1.04),('15529','2013-07-25','09:15:00',1.1),('15529','2013-07-25','09:20:00',1.14),('15529','2013-07-25','09:25:00',1.17),('15529','2013-07-25','09:30:00',1.19),('15529','2013-07-25','09:35:00',1.23),('15529','2013-07-25','09:40:00',1.25),('15529','2013-07-25','09:45:00',1.34),('15529','2013-07-25','09:50:00',1.38),('15529','2013-07-25','09:55:00',1.42),('15529','2013-07-25','10:00:00',1.42),('15529','2013-07-25','10:05:00',1.5),('15529','2013-07-25','10:10:00',1.52),('15529','2013-07-25','10:15:00',1.49),('15529','2013-07-25','10:20:00',1.56),('15529','2013-07-25','10:25:00',1.61),('15529','2013-07-25','10:30:00',1.61),('15529','2013-07-25','10:35:00',1.65),('15529','2013-07-25','10:40:00',1.67),('15529','2013-07-25','10:45:00',1.74),('15529','2013-07-25','10:50:00',1.73),('15529','2013-07-25','10:55:00',1.74),('15529','2013-07-25','11:00:00',1.8),('15529','2013-07-25','11:05:00',1.75),('15529','2013-07-25','11:10:00',1.81),('15529','2013-07-25','11:15:00',1.86),('15529','2013-07-25','11:20:00',1.87),('15529','2013-07-25','11:25:00',1.9),('15529','2013-07-25','11:30:00',1.93),('15529','2013-07-25','11:35:00',1.91),('15529','2013-07-25','11:40:00',1.82),('15529','2013-07-25','11:45:00',1.91),('15529','2013-07-25','11:50:00',1.99),('15529','2013-07-25','11:55:00',2.05),('15529','2013-07-25','12:00:00',2.08),('15529','2013-07-25','12:05:00',1.57),('15529','2013-07-25','12:10:00',1.67),('15529','2013-07-25','12:15:00',2.09),('15529','2013-07-25','12:20:00',2.12),('15529','2013-07-25','12:25:00',2.12),('15529','2013-07-25','12:30:00',2.15),('15529','2013-07-25','12:35:00',1.56),('15529','2013-07-25','12:40:00',2.2),('15529','2013-07-25','12:45:00',2.21),('15529','2013-07-25','12:50:00',2),('15529','2013-07-25','12:55:00',1.91),('15529','2013-07-25','13:00:00',1.7),('15529','2013-07-25','13:05:00',1.44),('15529','2013-07-25','13:15:00',2.21),('15529','2013-07-25','13:20:00',1.88),('15529','2013-07-25','13:25:00',1.05),('15529','2013-07-25','13:35:00',2.17),('15529','2013-07-25','13:40:00',2.18),('15529','2013-07-25','13:45:00',2.19),('15529','2013-07-25','13:50:00',2.13),('15529','2013-07-25','13:55:00',1.99),('15529','2013-07-25','14:00:00',2.06),('15529','2013-07-25','14:05:00',2.08),('15529','2013-07-25','14:10:00',2.07),('15529','2013-07-25','14:15:00',2.11),('15529','2013-07-25','14:20:00',2.02),('15529','2013-07-25','14:25:00',2.03),('15529','2013-07-25','14:30:00',1.99),('15529','2013-07-25','14:35:00',2.02),('15529','2013-07-25','14:40:00',2.01),('15529','2013-07-25','14:45:00',1.97),('15529','2013-07-25','14:50:00',1.93),('15529','2013-07-25','14:55:00',1.88),('15529','2013-07-25','15:00:00',1.92),('15529','2013-07-25','15:05:00',1.93),('15529','2013-07-25','15:10:00',1.87),('15529','2013-07-25','15:15:00',1.89),('15529','2013-07-25','15:20:00',1.86),('15529','2013-07-25','15:25:00',1.85),('15529','2013-07-25','15:30:00',1.8),('15529','2013-07-25','15:35:00',1.74),('15529','2013-07-25','15:40:00',1.73),('15529','2013-07-25','15:45:00',1.72),('15529','2013-07-25','15:50:00',1.69),('15529','2013-07-25','15:55:00',1.66),('15529','2013-07-25','16:00:00',1.62),('15529','2013-07-25','16:05:00',1.58),('15529','2013-07-25','16:10:00',1.58),('15529','2013-07-25','16:15:00',1.54),('15529','2013-07-25','16:20:00',1.51),('15529','2013-07-25','16:25:00',1.49),('15529','2013-07-25','16:30:00',1.47),('15529','2013-07-25','16:35:00',1.42),('15529','2013-07-25','16:40:00',1.38),('15529','2013-07-25','16:45:00',1.35),('15529','2013-07-25','16:50:00',1.3),('15529','2013-07-25','16:55:00',1.25),('15529','2013-07-25','17:00:00',1.22),('15529','2013-07-25','17:05:00',1.19),('15529','2013-07-25','17:10:00',1.14),('15529','2013-07-25','17:15:00',1.1),('15529','2013-07-25','17:20:00',1.05),('15529','2013-07-25','17:25:00',1),('15529','2013-07-24','09:00:00',1.02),('15529','2013-07-24','09:05:00',1.09),('15529','2013-07-24','09:10:00',1.16),('15529','2013-07-24','09:15:00',1),('15529','2013-07-24','09:45:00',1.4),('15529','2013-07-24','09:50:00',1.35),('15529','2013-07-24','09:55:00',1.39),('15529','2013-07-24','10:00:00',1.43),('15529','2013-07-24','10:05:00',1.53),('15529','2013-07-24','10:10:00',1.57),('15529','2013-07-24','10:15:00',1.66),('15529','2013-07-24','10:20:00',1.61),('15529','2013-07-24','10:25:00',1.66),('15529','2013-07-24','10:30:00',1.32),('15529','2013-07-24','10:35:00',1.13),('15529','2013-07-24','10:40:00',1.39),('15529','2013-07-24','10:45:00',1.8),('15529','2013-07-24','10:50:00',1.8),('15529','2013-07-24','10:55:00',1.83),('15529','2013-07-24','11:00:00',1.82),('15529','2013-07-24','11:05:00',1.81),('15529','2013-07-24','11:10:00',1.89),('15529','2013-07-24','11:15:00',1.84),('15529','2013-07-24','11:20:00',1.56),('15529','2013-07-24','11:25:00',1.86),('15529','2013-07-24','11:30:00',1.98),('15529','2013-07-24','11:35:00',1.95),('15529','2013-07-24','11:40:00',2.04),('15529','2013-07-24','11:45:00',2.14),('15529','2013-07-24','11:55:00',1.57),('15529','2013-07-24','12:00:00',1.24),('15529','2013-07-24','12:05:00',2.13),('15529','2013-07-24','12:10:00',2.21),('15529','2013-07-24','12:15:00',2.24),('15529','2013-07-24','12:20:00',2.19),('15529','2013-07-24','12:25:00',1.51),('15529','2013-07-24','12:35:00',1.49),('15529','2013-07-24','12:40:00',2.25),('15529','2013-07-24','12:45:00',2.09),('15529','2013-07-24','12:50:00',2.16),('15529','2013-07-24','12:55:00',2.14),('15529','2013-07-24','13:00:00',2.13),('15529','2013-07-24','13:05:00',2.18),('15529','2013-07-24','13:10:00',2.09),('15529','2013-07-24','13:15:00',2.19),('15529','2013-07-24','13:20:00',2.17),('15529','2013-07-24','13:25:00',2.19),('15529','2013-07-24','13:30:00',2.15),('15529','2013-07-24','13:35:00',2.14),('15529','2013-07-24','13:40:00',2.11),('15529','2013-07-24','13:45:00',2.13),('15529','2013-07-24','13:50:00',2.22),('15529','2013-07-24','13:55:00',2.17),('15529','2013-07-24','14:00:00',2.13),('15529','2013-07-24','14:05:00',2.13),('15529','2013-07-24','14:10:00',2.17),('15529','2013-07-24','14:15:00',2.15),('15529','2013-07-24','14:20:00',2.11),('15529','2013-07-24','14:25:00',2.1),('15529','2013-07-24','14:30:00',2.09),('15529','2013-07-24','14:35:00',2.06),('15529','2013-07-24','14:40:00',2.05),('15529','2013-07-24','14:45:00',2.04),('15529','2013-07-24','14:50:00',2.02),('15529','2013-07-24','14:55:00',2.02),('15529','2013-07-24','15:00:00',2),('15529','2013-07-24','15:05:00',1.96),('15529','2013-07-24','15:10:00',1.97),('15529','2013-07-24','15:15:00',1.92),('15529','2013-07-24','15:20:00',1.89),('15529','2013-07-24','15:25:00',1.9),('15529','2013-07-24','15:30:00',1.88),('15529','2013-07-24','15:35:00',1.83),('15529','2013-07-24','15:40:00',1.8),('15529','2013-07-24','15:45:00',1.8),('15529','2013-07-24','15:50:00',1.78),('15529','2013-07-24','15:55:00',1.73),('15529','2013-07-24','16:00:00',1.68),('15529','2013-07-24','16:05:00',1.66),('15529','2013-07-24','16:10:00',1.62),('15529','2013-07-24','16:15:00',1.59),('15529','2013-07-24','16:20:00',1.56),('15529','2013-07-24','16:25:00',1.53),('15529','2013-07-24','16:30:00',1.51),('15529','2013-07-24','16:35:00',1.47),('15529','2013-07-24','16:40:00',1.43),('15529','2013-07-24','16:45:00',1.4),('15529','2013-07-24','16:50:00',1.36),('15529','2013-07-24','16:55:00',1.33),('15529','2013-07-24','17:00:00',1.27),('15529','2013-07-24','17:05:00',1.23),('15529','2013-07-24','17:10:00',1.18),('15529','2013-07-24','17:15:00',1.15),('15529','2013-07-24','17:20:00',1.11),('15529','2013-07-24','17:25:00',1.07),('15529','2013-07-24','17:30:00',1.01),('15529','2013-07-23','08:55:00',1.01),('15529','2013-07-23','09:00:00',1.09),('15529','2013-07-23','09:05:00',1.18),('15529','2013-07-23','09:30:00',1.11),('15529','2013-07-23','10:05:00',1.7),('15529','2013-07-23','10:10:00',1.72),('15529','2013-07-23','10:15:00',1.4),('15529','2013-07-23','10:20:00',1.36),('15529','2013-07-23','10:25:00',1.19),('15529','2013-07-23','10:45:00',1.32),('15529','2013-07-23','10:50:00',1.91),('15529','2013-07-23','10:55:00',1.87),('15529','2013-07-23','11:00:00',1.88),('15529','2013-07-23','11:05:00',1.86),('15529','2013-07-23','11:10:00',1.93),('15529','2013-07-23','11:15:00',1.93),('15529','2013-07-23','11:20:00',1.93),('15529','2013-07-23','11:25:00',1.96),('15529','2013-07-23','11:35:00',1.75),('15529','2013-07-23','11:40:00',2.11),('15529','2013-07-23','11:45:00',2.08),('15529','2013-07-23','11:50:00',2.08),('15529','2013-07-23','11:55:00',1.9),('15529','2013-07-23','12:00:00',1.58),('15529','2013-07-23','12:05:00',1.46),('15529','2013-07-23','12:10:00',1.43),('15529','2013-07-23','12:15:00',1.61),('15529','2013-07-23','12:20:00',2.19),('15529','2013-07-23','12:25:00',2.16),('15529','2013-07-23','12:30:00',2.18),('15529','2013-07-23','12:35:00',2.18),('15529','2013-07-23','12:40:00',2.18),('15529','2013-07-23','12:45:00',2.22),('15529','2013-07-23','12:50:00',2.15),('15529','2013-07-23','12:55:00',2.17),('15529','2013-07-23','13:00:00',2.15),('15529','2013-07-23','13:05:00',2.16),('15529','2013-07-23','13:10:00',2.2),('15529','2013-07-23','13:15:00',1.96),('15529','2013-07-23','13:20:00',2.24),('15529','2013-07-23','13:25:00',2.26),('15529','2013-07-23','13:30:00',2.18),('15529','2013-07-23','13:35:00',2.19),('15529','2013-07-23','13:40:00',2.18),('15529','2013-07-23','13:45:00',2.21),('15529','2013-07-23','13:50:00',2.22),('15529','2013-07-23','13:55:00',2.1),('15529','2013-07-23','14:00:00',2.24),('15529','2013-07-23','14:05:00',2.05),('15529','2013-07-23','14:10:00',2.16),('15529','2013-07-23','14:15:00',2.06),('15529','2013-07-23','14:20:00',1.85),('15529','2013-07-23','14:25:00',2.1),('15529','2013-07-23','14:30:00',2.18),('15529','2013-07-23','14:35:00',2.12),('15529','2013-07-23','14:40:00',2.07),('15529','2013-07-23','14:45:00',2.08),('15529','2013-07-23','14:50:00',2.06),('15529','2013-07-23','14:55:00',2.06),('15529','2013-07-23','15:00:00',2),('15529','2013-07-23','15:05:00',1.97),('15529','2013-07-23','15:10:00',1.96),('15529','2013-07-23','15:15:00',1.95),('15529','2013-07-23','15:20:00',1.95),('15529','2013-07-23','15:25:00',1.9),('15529','2013-07-23','15:30:00',1.81),('15529','2013-07-23','15:35:00',1.83),('15529','2013-07-23','15:40:00',1.85),('15529','2013-07-23','15:45:00',1.74),('15529','2013-07-23','15:50:00',1.7),('15529','2013-07-23','15:55:00',1.69),('15529','2013-07-23','16:00:00',1.71),('15529','2013-07-23','16:05:00',1.67),('15529','2013-07-23','16:10:00',1.55),('15529','2013-07-23','16:15:00',1.65),('15529','2013-07-23','16:20:00',1.62),('15529','2013-07-23','16:25:00',1.59),('15529','2013-07-23','16:30:00',1.52),('15529','2013-07-23','16:35:00',1.51),('15529','2013-07-23','16:40:00',1.47),('15529','2013-07-23','16:45:00',1.42),('15529','2013-07-23','16:50:00',1.44),('15529','2013-07-23','16:55:00',1.38),('15529','2013-07-23','17:00:00',1.37),('15529','2013-07-23','17:05:00',1.31),('15529','2013-07-23','17:10:00',1.24),('15529','2013-07-23','17:15:00',1.18),('15529','2013-07-23','17:20:00',1.1),('15529','2013-07-23','17:25:00',1.07),('15529','2013-07-23','17:30:00',1.01),('15529','2013-07-22','08:55:00',1.01),('15529','2013-07-22','09:00:00',1.05),('15529','2013-07-22','09:05:00',1.08),('15529','2013-07-22','09:10:00',1.11),('15529','2013-07-22','09:15:00',1.16),('15529','2013-07-22','09:20:00',1.19),('15529','2013-07-22','09:25:00',1.23),('15529','2013-07-22','09:30:00',1.26),('15529','2013-07-22','09:35:00',1.3),('15529','2013-07-22','09:40:00',1.34),('15529','2013-07-22','09:45:00',1.37),('15529','2013-07-22','09:50:00',1.4),('15529','2013-07-22','09:55:00',1.43),('15529','2013-07-22','10:00:00',1.45),('15529','2013-07-22','10:05:00',1.49),('15529','2013-07-22','10:10:00',1.52),('15529','2013-07-22','10:15:00',1.56),('15529','2013-07-22','10:20:00',1.6),('15529','2013-07-22','10:25:00',1.64),('15529','2013-07-22','10:30:00',1.68),('15529','2013-07-22','10:35:00',1.7),('15529','2013-07-22','10:40:00',1.72),('15529','2013-07-22','10:45:00',1.75),('15529','2013-07-22','10:50:00',1.78),('15529','2013-07-22','10:55:00',1.79),('15529','2013-07-22','11:00:00',1.83),('15529','2013-07-22','11:05:00',1.9),('15529','2013-07-22','11:10:00',1.94),('15529','2013-07-22','11:15:00',1.96),('15529','2013-07-22','11:20:00',1.99),('15529','2013-07-22','11:25:00',2.02),('15529','2013-07-22','11:30:00',2.06),('15529','2013-07-22','11:35:00',2.09),('15529','2013-07-22','11:40:00',2.1),('15529','2013-07-22','11:45:00',2.06),('15529','2013-07-22','11:50:00',2.05),('15529','2013-07-22','11:55:00',2.16),('15529','2013-07-22','12:00:00',1.97),('15529','2013-07-22','12:05:00',1.37),('15529','2013-07-22','12:10:00',1.14),('15529','2013-07-22','12:15:00',1.4),('15529','2013-07-22','13:25:00',2.01),('15529','2013-07-22','13:30:00',1.65),('15529','2013-07-22','14:05:00',1.22),('15529','2013-07-22','14:30:00',1.56),('15529','2013-07-22','14:35:00',1.69),('15529','2013-07-22','14:40:00',1.19),('15529','2013-07-22','14:45:00',2.19),('15529','2013-07-22','14:50:00',2.25),('15529','2013-07-22','14:55:00',2.15),('15529','2013-07-22','15:00:00',2.1),('15529','2013-07-22','15:05:00',2.02),('15529','2013-07-22','15:10:00',1.98),('15529','2013-07-22','15:15:00',1.93),('15529','2013-07-22','15:20:00',1.91),('15529','2013-07-22','15:25:00',1.89),('15529','2013-07-22','15:30:00',1.87),('15529','2013-07-22','15:35:00',1.82),('15529','2013-07-22','15:40:00',1.82),('15529','2013-07-22','15:45:00',1.78),('15529','2013-07-22','15:50:00',1.74),('15529','2013-07-22','15:55:00',1.67),('15529','2013-07-22','16:00:00',1.69),('15529','2013-07-22','16:05:00',1.66),('15529','2013-07-22','16:10:00',1.64),('15529','2013-07-22','16:15:00',1.6),('15529','2013-07-22','16:20:00',1.56),('15529','2013-07-22','16:25:00',1.52),('15529','2013-07-22','16:30:00',1.49),('15529','2013-07-22','16:35:00',1.47),('15529','2013-07-22','16:40:00',1.42),('15529','2013-07-22','16:45:00',1.37),('15529','2013-07-22','16:50:00',1.33),('15529','2013-07-22','16:55:00',1.29),('15529','2013-07-22','17:00:00',1.25),('15529','2013-07-22','17:05:00',1.21),('15529','2013-07-22','17:10:00',1.18),('15529','2013-07-22','17:15:00',1.13),('15529','2013-07-22','17:20:00',1.09),('15529','2013-07-22','17:25:00',1.05),('15529','2013-07-22','17:30:00',1.01),('15529','2013-07-21','09:00:00',1.05),('15529','2013-07-21','09:05:00',1.09),('15529','2013-07-21','09:10:00',1.12),('15529','2013-07-21','09:15:00',1.16),('15529','2013-07-21','09:20:00',1.2),('15529','2013-07-21','09:25:00',1.24),('15529','2013-07-21','09:30:00',1.28),('15529','2013-07-21','09:35:00',1.31),('15529','2013-07-21','09:40:00',1.34),('15529','2013-07-21','09:45:00',1.37),('15529','2013-07-21','09:50:00',1.42),('15529','2013-07-21','09:55:00',1.45),('15529','2013-07-21','10:00:00',1.49),('15529','2013-07-21','10:05:00',1.51),('15529','2013-07-21','10:10:00',1.55),('15529','2013-07-21','10:15:00',1.59),('15529','2013-07-21','10:20:00',1.62),('15529','2013-07-21','10:25:00',1.65),('15529','2013-07-21','10:30:00',1.68),('15529','2013-07-21','10:35:00',1.72),('15529','2013-07-21','10:40:00',1.74),('15529','2013-07-21','10:45:00',1.75),('15529','2013-07-21','10:50:00',1.8),('15529','2013-07-21','10:55:00',1.85),('15529','2013-07-21','11:00:00',1.86),('15529','2013-07-21','11:05:00',1.9),('15529','2013-07-21','11:10:00',1.91),('15529','2013-07-21','11:15:00',1.9),('15529','2013-07-21','11:20:00',1.94),('15529','2013-07-21','11:25:00',1.96),('15529','2013-07-21','11:30:00',1.96),('15529','2013-07-21','11:35:00',1.96),('15529','2013-07-21','11:40:00',2.01),('15529','2013-07-21','11:45:00',2.02),('15529','2013-07-21','11:50:00',2.01),('15529','2013-07-21','11:55:00',2.04),('15529','2013-07-21','12:00:00',2.03),('15529','2013-07-21','12:05:00',2.06),('15529','2013-07-21','12:10:00',2.09),('15529','2013-07-21','12:15:00',2.07),('15529','2013-07-21','12:20:00',2.08),('15529','2013-07-21','12:25:00',2.03),('15529','2013-07-21','12:30:00',2.09),('15529','2013-07-21','12:35:00',2.1),('15529','2013-07-21','12:40:00',2.1),('15529','2013-07-21','12:45:00',2.07),('15529','2013-07-21','12:50:00',2.13),('15529','2013-07-21','12:55:00',2.14),('15529','2013-07-21','13:00:00',2.15),('15529','2013-07-21','13:05:00',2.13),('15529','2013-07-21','13:10:00',2.12),('15529','2013-07-21','13:15:00',2.11),('15529','2013-07-21','13:20:00',2.16),('15529','2013-07-21','13:25:00',2.15),('15529','2013-07-21','13:30:00',2.14),('15529','2013-07-21','13:35:00',2.14),('15529','2013-07-21','13:40:00',2.13),('15529','2013-07-21','13:45:00',2.07),('15529','2013-07-21','13:50:00',2.09),('15529','2013-07-21','13:55:00',2.09),('15529','2013-07-21','14:00:00',2.09),('15529','2013-07-21','14:05:00',2.08),('15529','2013-07-21','14:10:00',2.06),('15529','2013-07-21','14:15:00',2.08),('15529','2013-07-21','14:20:00',2.07),('15529','2013-07-21','14:25:00',2.02),('15529','2013-07-21','14:30:00',2.04),('15529','2013-07-21','14:35:00',1.98),('15529','2013-07-21','14:40:00',1.98),('15529','2013-07-21','14:45:00',1.98),('15529','2013-07-21','14:50:00',1.99),('15529','2013-07-21','14:55:00',1.99),('15529','2013-07-21','15:00:00',1.91),('15529','2013-07-21','15:05:00',1.92),('15529','2013-07-21','15:10:00',1.91),('15529','2013-07-21','15:15:00',1.91),('15529','2013-07-21','15:20:00',1.91),('15529','2013-07-21','15:25:00',1.49),('15529','2013-07-21','15:30:00',1.88),('15529','2013-07-21','15:35:00',1.3),('15529','2013-07-21','16:00:00',1.61),('15529','2013-07-21','16:05:00',1.78),('15529','2013-07-21','16:10:00',1.79),('15529','2013-07-21','16:15:00',1.67),('15529','2013-07-21','16:20:00',1.59),('15529','2013-07-21','16:25:00',1.52),('15529','2013-07-21','16:30:00',1.47),('15529','2013-07-21','16:35:00',1.44),('15529','2013-07-21','16:40:00',1.38),('15529','2013-07-21','16:45:00',1.3),('15529','2013-07-21','16:50:00',1.28),('15529','2013-07-21','16:55:00',1.26),('15529','2013-07-21','17:00:00',1.23),('15529','2013-07-21','17:05:00',1.17),('15529','2013-07-21','17:10:00',1.15),('15529','2013-07-21','17:15:00',1.1),('15529','2013-07-21','17:20:00',1.08),('15529','2013-07-21','17:25:00',1.05),('15529','2013-07-20','09:00:00',1.01),('15529','2013-07-20','09:05:00',1.05),('15529','2013-07-20','09:10:00',1.1),('15529','2013-07-20','09:15:00',1.14),('15529','2013-07-20','09:20:00',1.17),('15529','2013-07-20','09:25:00',1.21),('15529','2013-07-20','09:30:00',1.24),('15529','2013-07-20','09:35:00',1.28),('15529','2013-07-20','09:40:00',1.32),('15529','2013-07-20','09:45:00',1.35),('15529','2013-07-20','09:50:00',1.38),('15529','2013-07-20','09:55:00',1.43),('15529','2013-07-20','10:00:00',1.46),('15529','2013-07-20','10:05:00',1.5),('15529','2013-07-20','10:10:00',1.51),('15529','2013-07-20','10:15:00',1.55),('15529','2013-07-20','10:20:00',1.58),('15529','2013-07-20','10:25:00',1.62),('15529','2013-07-20','10:30:00',1.64),('15529','2013-07-20','10:35:00',1.67),('15529','2013-07-20','10:40:00',1.69),('15529','2013-07-20','10:45:00',1.72),('15529','2013-07-20','10:50:00',1.76),('15529','2013-07-20','10:55:00',1.76),('15529','2013-07-20','11:00:00',1.79),('15529','2013-07-20','11:05:00',1.84),('15529','2013-07-20','11:10:00',1.86),('15529','2013-07-20','11:15:00',1.87),('15529','2013-07-20','11:20:00',1.9),('15529','2013-07-20','11:25:00',1.91),('15529','2013-07-20','11:30:00',1.92),('15529','2013-07-20','11:35:00',1.95),('15529','2013-07-20','11:40:00',1.95),('15529','2013-07-20','11:45:00',1.99),('15529','2013-07-20','11:50:00',1.98),('15529','2013-07-20','11:55:00',2),('15529','2013-07-20','12:00:00',1.97),('15529','2013-07-20','12:05:00',1.92),('15529','2013-07-20','12:10:00',2),('15529','2013-07-20','12:15:00',1.92),('15529','2013-07-20','12:20:00',1.81),('15529','2013-07-20','12:25:00',1.74),('15529','2013-07-20','12:30:00',2),('15529','2013-07-20','12:35:00',1.13),('15529','2013-07-20','12:40:00',1.11),('15529','2013-07-20','12:45:00',1.3),('15529','2013-07-20','12:50:00',1.24),('15529','2013-07-20','12:55:00',1.31),('15529','2013-07-20','13:05:00',1.72),('15529','2013-07-20','13:10:00',1.13),('15529','2013-07-20','13:20:00',2.17),('15529','2013-07-20','13:25:00',2.32),('15529','2013-07-20','13:30:00',2.31),('15529','2013-07-20','13:35:00',2.32),('15529','2013-07-20','13:40:00',1.95),('15529','2013-07-20','13:45:00',2.08),('15529','2013-07-20','13:50:00',1.96),('15529','2013-07-20','14:25:00',1.51),('15529','2014-04-06','11:35:00',1.01),('15529','2014-04-06','12:05:00',1.08),('15529','2014-04-06','12:10:00',1.28),('15529','2014-04-06','12:15:00',1.55),('15529','2014-04-06','12:20:00',1.76),('15529','2014-04-06','12:25:00',1.74),('15529','2014-04-06','12:30:00',1.34),('15529','2014-04-06','12:35:00',1.19),('15529','2014-04-06','12:40:00',1.91),('15529','2014-04-06','12:45:00',2.32),('15529','2014-04-06','12:50:00',2.25),('15529','2014-04-06','12:55:00',2.21),('15529','2014-04-06','13:00:00',2.21),('15529','2014-04-06','13:05:00',2.25),('15529','2014-04-06','13:10:00',2.22),('15529','2014-04-06','13:15:00',2.23),('15529','2014-04-06','13:20:00',2.22),('15529','2014-04-06','13:25:00',2.23),('15529','2014-04-06','13:30:00',2.24),('15529','2014-04-06','13:35:00',2.18),('15529','2014-04-06','13:40:00',2.21),('15529','2014-04-06','13:45:00',2.22),('15529','2014-04-06','13:50:00',2.2),('15529','2014-04-06','13:55:00',2.16),('15529','2014-04-06','14:00:00',2.14),('15529','2014-04-06','14:05:00',2.13),('15529','2014-04-06','14:10:00',2.16),('15529','2014-04-06','14:15:00',2.13),('15529','2014-04-06','14:20:00',2.11),('15529','2014-04-06','14:25:00',2.11),('15529','2014-04-06','14:30:00',2.09),('15529','2014-04-06','14:35:00',2.06),('15529','2014-04-06','14:40:00',2.03),('15529','2014-04-06','14:45:00',2.02),('15529','2014-04-06','14:50:00',2.02),('15529','2014-04-06','14:55:00',2.03),('15529','2014-04-06','15:00:00',2.02),('15529','2014-04-06','15:05:00',1.95),('15529','2014-04-06','15:10:00',1.98),('15529','2014-04-06','15:15:00',1.96),('15529','2014-04-06','15:20:00',1.94),('15529','2014-04-06','15:25:00',1.91),('15529','2014-04-06','15:30:00',1.86),('15529','2014-04-06','15:35:00',1.84),('15529','2014-04-06','15:40:00',1.81),('15529','2014-04-06','15:45:00',1.79),('15529','2014-04-06','15:50:00',1.81),('15529','2014-04-06','15:55:00',1.84),('15529','2014-04-06','16:00:00',1.87),('15529','2014-04-06','16:05:00',1.79),('15529','2014-04-06','16:10:00',1.57),('15529','2014-04-06','16:15:00',1.57),('15529','2014-04-06','16:20:00',1.49),('15529','2014-04-06','16:25:00',1.41),('15529','2014-04-06','16:30:00',1.29),('15529','2014-04-06','16:35:00',1.01),('15529','2014-04-06','16:55:00',1.28),('15529','2014-04-06','17:00:00',1.25),('15529','2014-04-06','17:05:00',1.23),('15529','2014-04-06','17:10:00',1.19),('15529','2014-04-06','17:15:00',1.11),('15529','2013-07-19','08:55:00',1.06),('15529','2013-07-19','09:00:00',1.08),('15529','2013-07-19','09:05:00',1.16),('15529','2013-07-19','09:10:00',1.22),('15529','2013-07-19','09:15:00',1.26),('15529','2013-07-19','09:20:00',1.26),('15529','2013-07-19','09:25:00',1.23),('15529','2013-07-19','09:30:00',1.18),('15529','2013-07-19','09:35:00',1.25),('15529','2013-07-19','09:40:00',1.27),('15529','2013-07-19','09:45:00',1.43),('15529','2013-07-19','09:50:00',1.33),('15529','2013-07-19','09:55:00',1.34),('15529','2013-07-19','10:00:00',1.48),('15529','2013-07-19','10:05:00',1.54),('15529','2013-07-19','10:10:00',1.55),('15529','2013-07-19','10:15:00',1.58),('15529','2013-07-19','10:20:00',1.61),('15529','2013-07-19','10:25:00',1.63),('15529','2013-07-19','10:30:00',1.65),('15529','2013-07-19','10:35:00',1.68),('15529','2013-07-19','10:40:00',1.72),('15529','2013-07-19','10:45:00',1.75),('15529','2013-07-19','10:50:00',1.76),('15529','2013-07-19','10:55:00',1.79),('15529','2013-07-19','11:00:00',1.83),('15529','2013-07-19','11:05:00',1.86),('15529','2013-07-19','11:10:00',1.86),('15529','2013-07-19','11:15:00',1.9),('15529','2013-07-19','11:20:00',1.93),('15529','2013-07-19','11:25:00',1.94),('15529','2013-07-19','11:30:00',1.98),('15529','2013-07-19','11:35:00',1.98),('15529','2013-07-19','11:40:00',2.02),('15529','2013-07-19','11:45:00',2.01),('15529','2013-07-19','11:50:00',2.02),('15529','2013-07-19','11:55:00',2.08),('15529','2013-07-19','12:00:00',1.63),('15529','2013-07-19','12:05:00',1.31),('15529','2013-07-19','12:15:00',2.18),('15529','2013-07-19','12:20:00',2.15),('15529','2013-07-19','12:25:00',1.73),('15529','2013-07-19','12:30:00',1.8),('15529','2013-07-19','12:45:00',2.21),('15529','2013-07-19','12:50:00',2.05),('15529','2013-07-19','13:00:00',1.12),('15529','2013-07-19','13:05:00',2.11),('15529','2013-07-19','13:10:00',2.35),('15529','2013-07-19','13:15:00',1.74),('15529','2013-07-19','13:20:00',2.07),('15529','2013-07-19','13:25:00',2.23),('15529','2013-07-19','13:30:00',2.28),('15529','2013-07-19','13:35:00',2.09),('15529','2013-07-19','13:40:00',2.27),('15529','2013-07-19','13:45:00',2.29),('15529','2013-07-19','13:50:00',2.21),('15529','2013-07-19','13:55:00',2.18),('15529','2013-07-19','14:00:00',2.17),('15529','2013-07-19','14:05:00',2.16),('15529','2013-07-19','14:10:00',2.14),('15529','2013-07-19','14:15:00',2.1),('15529','2013-07-19','14:20:00',2.15),('15529','2013-07-19','14:25:00',2.13),('15529','2013-07-19','14:30:00',2.09),('15529','2013-07-19','14:35:00',2.08),('15529','2013-07-19','14:40:00',2.06),('15529','2013-07-19','14:45:00',2.04),('15529','2013-07-19','14:50:00',2.05),('15529','2013-07-19','14:55:00',2.05),('15529','2013-07-19','15:00:00',2.02),('15529','2013-07-19','15:05:00',2.01),('15529','2013-07-19','15:10:00',1.96),('15529','2013-07-19','15:15:00',1.93),('15529','2013-07-19','15:20:00',1.89),('15529','2013-07-19','15:25:00',1.9),('15529','2013-07-19','15:30:00',1.89),('15529','2013-07-19','15:35:00',1.84),('15529','2013-07-19','15:40:00',1.81),('15529','2013-07-19','15:45:00',1.8),('15529','2013-07-19','15:50:00',1.78),('15529','2013-07-19','15:55:00',1.73),('15529','2013-07-19','16:00:00',1.69),('15529','2013-07-19','16:05:00',1.66),('15529','2013-07-19','16:10:00',1.63),('15529','2013-07-19','16:15:00',1.6),('15529','2013-07-19','16:20:00',1.57),('15529','2013-07-19','16:25:00',1.53),('15529','2013-07-19','16:30:00',1.5),('15529','2013-07-19','16:35:00',1.47),('15529','2013-07-19','16:40:00',1.43),('15529','2013-07-19','16:45:00',1.38),('15529','2013-07-19','16:50:00',1.35),('15529','2013-07-19','16:55:00',1.31),('15529','2013-07-19','17:00:00',1.25),('15529','2013-07-19','17:05:00',1.22),('15529','2013-07-19','17:10:00',1.18),('15529','2013-07-19','17:15:00',1.13),('15529','2013-07-19','17:20:00',1.09),('15529','2013-07-19','17:25:00',1.04),('15529','2013-07-19','17:30:00',1),('15529','2013-07-18','09:00:00',1.01),('15529','2013-07-18','09:05:00',1.05),('15529','2013-07-18','09:10:00',1.09),('15529','2013-07-18','09:15:00',1.11),('15529','2013-07-18','09:20:00',1.18),('15529','2013-07-18','09:25:00',1.2),('15529','2013-07-18','09:30:00',1.23),('15529','2013-07-18','09:35:00',1.26),('15529','2013-07-18','09:40:00',1.3),('15529','2013-07-18','09:45:00',1.33),('15529','2013-07-18','09:50:00',1.37),('15529','2013-07-18','09:55:00',1.4),('15529','2013-07-18','10:00:00',1.43),('15529','2013-07-18','10:05:00',1.44),('15529','2013-07-18','10:10:00',1.47),('15529','2013-07-18','10:15:00',1.49),('15529','2013-07-18','10:20:00',1.55),('15529','2013-07-18','10:25:00',1.55),('15529','2013-07-18','10:30:00',1.59),('15529','2013-07-18','10:35:00',1.61),('15529','2013-07-18','10:40:00',1.67),('15529','2013-07-18','10:45:00',1.67),('15529','2013-07-18','10:50:00',1.7),('15529','2013-07-18','10:55:00',1.73),('15529','2013-07-18','11:00:00',1.73),('15529','2013-07-18','11:05:00',1.74),('15529','2013-07-18','11:10:00',1.75),('15529','2013-07-18','11:15:00',1.8),('15529','2013-07-18','11:20:00',1.81),('15529','2013-07-18','11:25:00',1.84),('15529','2013-07-18','11:30:00',1.86),('15529','2013-07-18','11:35:00',1.83),('15529','2013-07-18','11:40:00',1.84),('15529','2013-07-18','11:45:00',1.96),('15529','2013-07-18','11:50:00',1.93),('15529','2013-07-18','11:55:00',1.89),('15529','2013-07-18','12:00:00',2.03),('15529','2013-07-18','12:05:00',2.11),('15529','2013-07-18','12:10:00',2.06),('15529','2013-07-18','12:15:00',2.03),('15529','2013-07-18','12:20:00',2.07),('15529','2013-07-18','12:25:00',2.05),('15529','2013-07-18','12:30:00',2.05),('15529','2013-07-18','12:35:00',2.11),('15529','2013-07-18','12:40:00',2.04),('15529','2013-07-18','12:45:00',2.08),('15529','2013-07-18','12:50:00',1.74),('15529','2013-07-18','12:55:00',2.24),('15529','2013-07-18','13:00:00',2.2),('15529','2013-07-18','13:05:00',2.14),('15529','2013-07-18','13:10:00',2.22),('15529','2013-07-18','13:15:00',2.24),('15529','2013-07-18','13:20:00',2.25),('15529','2013-07-18','13:25:00',2.19),('15529','2013-07-18','13:30:00',2.22),('15529','2013-07-18','13:35:00',1.66),('15529','2013-07-18','13:40:00',2.15),('15529','2013-07-18','13:45:00',2.15),('15529','2013-07-18','13:50:00',2.18),('15529','2013-07-18','13:55:00',2.13),('15529','2013-07-18','14:00:00',2.15),('15529','2013-07-18','14:05:00',2.14),('15529','2013-07-18','14:10:00',2.15),('15529','2013-07-18','14:15:00',2.11),('15529','2013-07-18','14:20:00',2.15),('15529','2013-07-18','14:25:00',2.09),('15529','2013-07-18','14:30:00',2.08),('15529','2013-07-18','14:35:00',1.64),('15529','2013-07-18','14:40:00',2.14),('15529','2013-07-18','14:45:00',1.79),('15529','2013-07-18','14:50:00',2.05),('15529','2013-07-18','14:55:00',1.89),('15529','2013-07-18','15:00:00',2.03),('15529','2013-07-18','15:05:00',1.93),('15529','2013-07-18','15:10:00',1.92),('15529','2013-07-18','15:15:00',1.26),('15529','2013-07-18','15:20:00',1.63),('15529','2013-07-18','15:25:00',2.01),('15529','2013-07-18','15:30:00',1.97),('15529','2013-07-18','15:35:00',1.93),('15529','2013-07-18','15:40:00',1.89),('15529','2013-07-18','15:45:00',1.83),('15529','2013-07-18','15:50:00',1.79),('15529','2013-07-18','15:55:00',1.72),('15529','2013-07-18','16:00:00',1.7),('15529','2013-07-18','16:05:00',1.67),('15529','2013-07-18','16:10:00',1.62),('15529','2013-07-18','16:15:00',1.63),('15529','2013-07-18','16:20:00',1.58),('15529','2013-07-18','16:25:00',1.56),('15529','2013-07-18','16:30:00',1.53),('15529','2013-07-18','16:35:00',1.51),('15529','2013-07-18','16:40:00',1.48),('15529','2013-07-18','16:45:00',1.43),('15529','2013-07-18','16:50:00',1.42),('15529','2013-07-18','16:55:00',1.24),('15529','2013-07-18','17:00:00',1.36),('15529','2013-07-18','17:05:00',1.31),('15529','2013-07-18','17:10:00',1.03),('15529','2013-07-18','17:15:00',1.07),('15529','2013-07-18','17:30:00',1.04),('15529','2013-07-17','08:55:00',1.01),('15529','2013-07-17','09:00:00',1.05),('15529','2013-07-17','09:05:00',1.09),('15529','2013-07-17','09:10:00',1.13),('15529','2013-07-17','09:15:00',1.17),('15529','2013-07-17','09:20:00',1.21),('15529','2013-07-17','09:25:00',1.26),('15529','2013-07-17','09:30:00',1.3),('15529','2013-07-17','09:35:00',1.33),('15529','2013-07-17','09:40:00',1.36),('15529','2013-07-17','09:45:00',1.39),('15529','2013-07-17','09:50:00',1.42),('15529','2013-07-17','09:55:00',1.47),('15529','2013-07-17','10:00:00',1.5),('15529','2013-07-17','10:05:00',1.54),('15529','2013-07-17','10:10:00',1.57),('15529','2013-07-17','10:15:00',1.59),('15529','2013-07-17','10:20:00',1.62),('15529','2013-07-17','10:25:00',1.65),('15529','2013-07-17','10:30:00',1.67),('15529','2013-07-17','10:35:00',1.7),('15529','2013-07-17','10:40:00',1.71),('15529','2013-07-17','10:45:00',1.75),('15529','2013-07-17','10:50:00',1.78),('15529','2013-07-17','10:55:00',1.76),('15529','2013-07-17','11:00:00',1.81),('15529','2013-07-17','11:05:00',1.82),('15529','2013-07-17','11:10:00',1.87),('15529','2013-07-17','11:15:00',1.91),('15529','2013-07-17','11:20:00',1.88),('15529','2013-07-17','11:25:00',1.91),('15529','2013-07-17','11:30:00',1.93),('15529','2013-07-17','11:35:00',1.92),('15529','2013-07-17','11:40:00',1.97),('15529','2013-07-17','11:45:00',1.99),('15529','2013-07-17','11:50:00',2),('15529','2013-07-17','11:55:00',2.03),('15529','2013-07-17','12:00:00',2),('15529','2013-07-17','12:05:00',2.04),('15529','2013-07-17','12:10:00',2.04),('15529','2013-07-17','12:15:00',2.04),('15529','2013-07-17','12:20:00',2.07),('15529','2013-07-17','12:25:00',2.06),('15529','2013-07-17','12:30:00',2.15),('15529','2013-07-17','12:35:00',2.13),('15529','2013-07-17','12:40:00',2.13),('15529','2013-07-17','12:45:00',2.17),('15529','2013-07-17','12:50:00',2.18),('15529','2013-07-17','12:55:00',2.14),('15529','2013-07-17','13:00:00',2.18),('15529','2013-07-17','13:05:00',2.1),('15529','2013-07-17','13:10:00',2.16),('15529','2013-07-17','13:15:00',2.16),('15529','2013-07-17','13:20:00',2.17),('15529','2013-07-17','13:25:00',2.11),('15529','2013-07-17','13:30:00',2.11),('15529','2013-07-17','13:35:00',2.16),('15529','2013-07-17','13:40:00',2.26),('15529','2013-07-17','13:45:00',2.17),('15529','2013-07-17','13:50:00',2.15),('15529','2013-07-17','13:55:00',2.21),('15529','2013-07-17','14:00:00',1.95),('15529','2013-07-17','14:10:00',2.1),('15529','2013-07-17','14:15:00',2.13),('15529','2013-07-17','14:20:00',2.11),('15529','2013-07-17','14:25:00',2.1),('15529','2013-07-17','14:30:00',2.09),('15529','2013-07-17','14:35:00',2.07),('15529','2013-07-17','14:40:00',2.05),('15529','2013-07-17','14:45:00',1.97),('15529','2013-07-17','14:50:00',1.93),('15529','2013-07-17','14:55:00',1.99),('15529','2013-07-17','15:00:00',1.99),('15529','2013-07-17','15:05:00',1.95),('15529','2013-07-17','15:10:00',1.96),('15529','2013-07-17','15:15:00',1.91),('15529','2013-07-17','15:20:00',1.9),('15529','2013-07-17','15:25:00',1.9),('15529','2013-07-17','15:30:00',1.83),('15529','2013-07-17','15:35:00',1.83),('15529','2013-07-17','15:40:00',1.8),('15529','2013-07-17','15:45:00',1.78),('15529','2013-07-17','15:50:00',1.71),('15529','2013-07-17','15:55:00',1.72),('15529','2013-07-17','16:00:00',1.7),('15529','2013-07-17','16:05:00',1.65),('15529','2013-07-17','16:10:00',1.62),('15529','2013-07-17','16:15:00',1.6),('15529','2013-07-17','16:20:00',1.54),('15529','2013-07-17','16:25:00',1.51),('15529','2013-07-17','16:30:00',1.47),('15529','2013-07-17','16:35:00',1.42),('15529','2013-07-17','16:40:00',1.4),('15529','2013-07-17','16:45:00',1.36),('15529','2013-07-17','16:50:00',1.32),('15529','2013-07-17','16:55:00',1.27),('15529','2013-07-17','17:00:00',1.23),('15529','2013-07-17','17:05:00',1.16),('15529','2013-07-17','17:10:00',1.07),('15529','2013-07-17','17:15:00',1.09),('15529','2013-07-17','17:20:00',1.06),('15529','2013-07-17','17:25:00',1.02),('15529','2013-07-16','08:50:00',1.02),('15529','2013-07-16','08:55:00',1.07),('15529','2013-07-16','09:00:00',1.1),('15529','2013-07-16','09:05:00',1.14),('15529','2013-07-16','09:10:00',1.19),('15529','2013-07-16','09:15:00',1.23),('15529','2013-07-16','09:20:00',1.27),('15529','2013-07-16','09:25:00',1.31),('15529','2013-07-16','09:30:00',1.35),('15529','2013-07-16','09:35:00',1.37),('15529','2013-07-16','09:40:00',1.42),('15529','2013-07-16','09:45:00',1.45),('15529','2013-07-16','09:50:00',1.49),('15529','2013-07-16','09:55:00',1.52),('15529','2013-07-16','10:00:00',1.55),('15529','2013-07-16','10:05:00',1.58),('15529','2013-07-16','10:10:00',1.61),('15529','2013-07-16','10:15:00',1.63),('15529','2013-07-16','10:20:00',1.67),('15529','2013-07-16','10:25:00',1.68),('15529','2013-07-16','10:30:00',1.71),('15529','2013-07-16','10:35:00',1.75),('15529','2013-07-16','10:40:00',1.78),('15529','2013-07-16','10:45:00',1.79),('15529','2013-07-16','10:50:00',1.82),('15529','2013-07-16','10:55:00',1.89),('15529','2013-07-16','11:00:00',1.89),('15529','2013-07-16','11:05:00',1.94),('15529','2013-07-16','11:10:00',1.96),('15529','2013-07-16','11:15:00',1.96),('15529','2013-07-16','11:20:00',2),('15529','2013-07-16','11:25:00',2.04),('15529','2013-07-16','11:30:00',2.06),('15529','2013-07-16','11:35:00',1.99),('15529','2013-07-16','11:40:00',2.08),('15529','2013-07-16','11:45:00',2.08),('15529','2013-07-16','11:50:00',2.03),('15529','2013-07-16','11:55:00',2.05),('15529','2013-07-16','12:00:00',2.07),('15529','2013-07-16','12:05:00',2.09),('15529','2013-07-16','12:10:00',2.1),('15529','2013-07-16','12:15:00',2.13),('15529','2013-07-16','12:20:00',2.15),('15529','2013-07-16','12:25:00',2.15),('15529','2013-07-16','12:30:00',2.16),('15529','2013-07-16','12:35:00',2.16),('15529','2013-07-16','12:40:00',2.06),('15529','2013-07-16','12:45:00',2.11),('15529','2013-07-16','12:50:00',2.11),('15529','2013-07-16','12:55:00',2.16),('15529','2013-07-16','13:00:00',2.17),('15529','2013-07-16','13:05:00',2.16),('15529','2013-07-16','13:10:00',2.12),('15529','2013-07-16','13:15:00',2.2),('15529','2013-07-16','13:20:00',2.12),('15529','2013-07-16','13:25:00',2.07),('15529','2013-07-16','13:30:00',2.12),('15529','2013-07-16','13:35:00',2.12),('15529','2013-07-16','13:40:00',2.06),('15529','2013-07-16','13:45:00',2.09),('15529','2013-07-16','13:50:00',2.1),('15529','2013-07-16','13:55:00',2.12),('15529','2013-07-16','14:00:00',2.15),('15529','2013-07-16','14:05:00',2.08),('15529','2013-07-16','14:10:00',2.08),('15529','2013-07-16','14:15:00',2.14),('15529','2013-07-16','14:20:00',2.05),('15529','2013-07-16','14:25:00',1.36),('15529','2013-07-16','14:30:00',2.02),('15529','2013-07-16','14:35:00',2.06),('15529','2013-07-16','14:40:00',2.04),('15529','2013-07-16','14:45:00',2.01),('15529','2013-07-16','14:50:00',2.01),('15529','2013-07-16','14:55:00',1.99),('15529','2013-07-16','15:00:00',1.99),('15529','2013-07-16','15:05:00',1.9),('15529','2013-07-16','15:10:00',1.89),('15529','2013-07-16','15:15:00',1.92),('15529','2013-07-16','15:20:00',1.92),('15529','2013-07-16','15:25:00',1.89),('15529','2013-07-16','15:30:00',1.81),('15529','2013-07-16','15:35:00',1.4),('15529','2013-07-16','15:45:00',1.09),('15529','2013-07-16','15:50:00',1.54),('15529','2013-07-16','16:10:00',1.6),('15529','2013-07-16','16:15:00',1.53),('15529','2013-07-16','16:20:00',1.51),('15529','2013-07-16','16:25:00',1.45),('15529','2013-07-16','16:30:00',1.43),('15529','2013-07-16','16:35:00',1.43),('15529','2013-07-16','16:40:00',1.41),('15529','2013-07-16','16:45:00',1.35),('15529','2013-07-16','16:50:00',1.33),('15529','2013-07-16','16:55:00',1.29),('15529','2013-07-16','17:00:00',1.27),('15529','2013-07-16','17:05:00',1.14),('15529','2013-07-16','17:20:00',1.11),('15529','2013-07-16','17:25:00',1.08),('15529','2013-07-16','17:30:00',1.02),('15529','2013-07-15','08:55:00',1.02),('15529','2013-07-15','09:00:00',1.07),('15529','2013-07-15','09:05:00',1.12),('15529','2013-07-15','09:10:00',1.16),('15529','2013-07-15','09:15:00',1.19),('15529','2013-07-15','09:20:00',1.22),('15529','2013-07-15','09:25:00',1.25),('15529','2013-07-15','09:30:00',1.29),('15529','2013-07-15','09:35:00',1.33),('15529','2013-07-15','09:40:00',1.37),('15529','2013-07-15','09:45:00',1.41),('15529','2013-07-15','09:50:00',1.45),('15529','2013-07-15','09:55:00',1.49),('15529','2013-07-15','10:00:00',1.52),('15529','2013-07-15','10:05:00',1.55),('15529','2013-07-15','10:10:00',1.58),('15529','2013-07-15','10:15:00',1.61),('15529','2013-07-15','10:20:00',1.65),('15529','2013-07-15','10:25:00',1.66),('15529','2013-07-15','10:30:00',1.69),('15529','2013-07-15','10:35:00',1.71),('15529','2013-07-15','10:40:00',1.75),('15529','2013-07-15','10:45:00',1.78),('15529','2013-07-15','10:50:00',1.81),('15529','2013-07-15','10:55:00',1.83),('15529','2013-07-15','11:00:00',1.87),('15529','2013-07-15','11:05:00',1.91),('15529','2013-07-15','11:10:00',1.91),('15529','2013-07-15','11:15:00',1.93),('15529','2013-07-15','11:20:00',1.93),('15529','2013-07-15','11:25:00',1.96),('15529','2013-07-15','11:30:00',1.97),('15529','2013-07-15','11:35:00',1.97),('15529','2013-07-15','11:40:00',2.01),('15529','2013-07-15','11:45:00',2.02),('15529','2013-07-15','11:50:00',2.04),('15529','2013-07-15','11:55:00',2.04),('15529','2013-07-15','12:00:00',2.08),('15529','2013-07-15','12:05:00',2.06),('15529','2013-07-15','12:10:00',2.12),('15529','2013-07-15','12:15:00',2.12),('15529','2013-07-15','12:20:00',2.14),('15529','2013-07-15','12:25:00',2.1),('15529','2013-07-15','12:30:00',2.16),('15529','2013-07-15','12:35:00',2.14),('15529','2013-07-15','12:40:00',2.15),('15529','2013-07-15','12:45:00',2.15),('15529','2013-07-15','12:50:00',2.17),('15529','2013-07-15','12:55:00',2.19),('15529','2013-07-15','13:00:00',2.17),('15529','2013-07-15','13:05:00',2.17),('15529','2013-07-15','13:10:00',2.17),('15529','2013-07-15','13:15:00',2.19),('15529','2013-07-15','13:20:00',2.19),('15529','2013-07-15','13:25:00',2.19),('15529','2013-07-15','13:30:00',2.14),('15529','2013-07-15','13:35:00',2.16),('15529','2013-07-15','13:40:00',2.16),('15529','2013-07-15','13:45:00',2.2),('15529','2013-07-15','13:50:00',2.17),('15529','2013-07-15','13:55:00',2.18),('15529','2013-07-15','14:00:00',2.14),('15529','2013-07-15','14:05:00',1.96),('15529','2013-07-15','14:10:00',2.04),('15529','2013-07-15','14:15:00',2.07),('15529','2013-07-15','14:20:00',2.08),('15529','2013-07-15','14:25:00',2.13),('15529','2013-07-15','14:30:00',2.1),('15529','2013-07-15','14:35:00',2.05),('15529','2013-07-15','14:40:00',2.02),('15529','2013-07-15','14:45:00',2.03),('15529','2013-07-15','14:50:00',1.99),('15529','2013-07-15','14:55:00',2.01),('15529','2013-07-15','15:00:00',1.98),('15529','2013-07-15','15:05:00',1.96),('15529','2013-07-15','15:10:00',1.92),('15529','2013-07-15','15:15:00',1.91),('15529','2013-07-15','15:20:00',1.9),('15529','2013-07-15','15:25:00',1.87),('15529','2013-07-15','15:30:00',1.89),('15529','2013-07-15','15:45:00',1.33),('15529','2013-07-15','15:50:00',1.29),('15529','2013-07-15','15:55:00',1.58),('15529','2013-07-15','16:00:00',1.53),('15529','2013-07-15','16:05:00',1.55),('15529','2013-07-15','16:10:00',1.68),('15529','2013-07-15','16:15:00',1.41),('15529','2013-07-15','16:20:00',1.03),('15529','2013-07-15','16:25:00',1.25),('15529','2013-07-15','16:30:00',1.05),('15529','2013-07-15','16:50:00',1.5),('15529','2013-07-15','16:55:00',1.33),('15529','2013-07-15','17:10:00',1.2),('15529','2013-07-15','17:15:00',1.16),('15529','2013-07-15','17:20:00',1.14),('15529','2013-07-15','17:25:00',1.18),('15529','2013-07-15','17:30:00',1.09),('15529','2013-07-15','17:40:00',1.03),('15529','2013-07-14','08:50:00',1.02),('15529','2013-07-14','08:55:00',1.06),('15529','2013-07-14','09:00:00',1.1),('15529','2013-07-14','09:05:00',1.14),('15529','2013-07-14','09:10:00',1.18),('15529','2013-07-14','09:15:00',1.22),('15529','2013-07-14','09:20:00',1.26),('15529','2013-07-14','09:25:00',1.31),('15529','2013-07-14','09:30:00',1.34),('15529','2013-07-14','09:35:00',1.38),('15529','2013-07-14','09:40:00',1.42),('15529','2013-07-14','09:45:00',1.45),('15529','2013-07-14','09:50:00',1.48),('15529','2013-07-14','09:55:00',1.52),('15529','2013-07-14','10:00:00',1.56),('15529','2013-07-14','10:05:00',1.58),('15529','2013-07-14','10:10:00',1.62),('15529','2013-07-14','10:15:00',1.64),('15529','2013-07-14','10:20:00',1.67),('15529','2013-07-14','10:25:00',1.7),('15529','2013-07-14','10:30:00',1.73),('15529','2013-07-14','10:35:00',1.75),('15529','2013-07-14','10:40:00',1.79),('15529','2013-07-14','10:45:00',1.8),('15529','2013-07-14','10:50:00',1.83),('15529','2013-07-14','10:55:00',1.86),('15529','2013-07-14','11:00:00',1.88),('15529','2013-07-14','11:05:00',1.91),('15529','2013-07-14','11:10:00',1.93),('15529','2013-07-14','11:15:00',1.97),('15529','2013-07-14','11:20:00',1.97),('15529','2013-07-14','11:25:00',2),('15529','2013-07-14','11:30:00',2.02),('15529','2013-07-14','11:35:00',2.04),('15529','2013-07-14','11:40:00',2.03),('15529','2013-07-14','11:45:00',2.05),('15529','2013-07-14','11:50:00',2.05),('15529','2013-07-14','11:55:00',2.06),('15529','2013-07-14','12:00:00',2.09),('15529','2013-07-14','12:05:00',2.1),('15529','2013-07-14','12:10:00',2.08),('15529','2013-07-14','12:15:00',2.08),('15529','2013-07-14','12:20:00',2.11),('15529','2013-07-14','12:25:00',2.12),('15529','2013-07-14','12:30:00',2.09),('15529','2013-07-14','12:35:00',2.1),('15529','2013-07-14','12:40:00',2.1),('15529','2013-07-14','12:45:00',2.15),('15529','2013-07-14','12:50:00',2.11),('15529','2013-07-14','12:55:00',2.16),('15529','2013-07-14','13:00:00',2.18),('15529','2013-07-14','13:05:00',2.17),('15529','2013-07-14','13:10:00',2.12),('15529','2013-07-14','13:15:00',2.14),('15529','2013-07-14','13:20:00',2.23),('15529','2013-07-14','13:25:00',2.19),('15529','2013-07-14','13:30:00',2.23),('15529','2013-07-14','13:35:00',2.27),('15529','2013-07-14','13:40:00',2.28),('15529','2013-07-14','13:45:00',2.05),('15529','2013-07-14','13:50:00',1.85),('15529','2013-07-14','13:55:00',2.26),('15529','2013-07-14','14:00:00',2.26),('15529','2013-07-14','14:05:00',1.47),('15529','2013-07-14','14:10:00',1.62),('15529','2013-07-14','14:15:00',2.27),('15529','2013-07-14','14:20:00',1.96),('15529','2013-07-14','14:25:00',2.17),('15529','2013-07-14','14:30:00',1.96),('15529','2013-07-14','14:40:00',1.11),('15529','2013-07-14','14:45:00',1.62),('15529','2013-07-14','14:50:00',2.11),('15529','2013-07-14','14:55:00',2.04),('15529','2013-07-14','15:00:00',1.99),('15529','2013-07-14','15:05:00',1.96),('15529','2013-07-14','15:10:00',1.96),('15529','2013-07-14','15:15:00',1.94),('15529','2013-07-14','15:20:00',1.95),('15529','2013-07-14','15:25:00',1.81),('15529','2013-07-14','15:40:00',1.72),('15529','2013-07-14','15:45:00',1.82),('15529','2013-07-14','15:50:00',1.79),('15529','2013-07-14','15:55:00',1.75),('15529','2013-07-14','16:00:00',1.71),('15529','2013-07-14','16:05:00',1.67),('15529','2013-07-14','16:10:00',1.59),('15529','2013-07-14','16:15:00',1.57),('15529','2013-07-14','16:20:00',1.57),('15529','2013-07-14','16:25:00',1.52),('15529','2013-07-14','16:30:00',1.48),('15529','2013-07-14','16:35:00',1.43),('15529','2013-07-14','16:40:00',1.41),('15529','2013-07-14','16:45:00',1.38),('15529','2013-07-14','16:50:00',1.34),('15529','2013-07-14','16:55:00',1.3),('15529','2013-07-14','17:00:00',1.27),('15529','2013-07-14','17:05:00',1.23),('15529','2013-07-14','17:10:00',1.18),('15529','2013-07-14','17:15:00',1.13),('15529','2013-07-14','17:20:00',1.09),('15529','2013-07-14','17:25:00',1.06),('15529','2013-07-14','17:30:00',1.01),('15529','2013-07-13','09:25:00',1.22),('15529','2013-07-13','09:30:00',1.07),('15529','2013-07-13','09:35:00',1.12),('15529','2013-07-13','10:20:00',1.2),('15529','2013-07-13','10:25:00',1.88),('15529','2013-07-13','10:30:00',1.73),('15529','2013-07-13','10:35:00',1.75),('15529','2013-07-13','10:40:00',1.18),('15529','2013-07-13','10:45:00',1.6),('15529','2013-07-13','10:50:00',1.99),('15529','2013-07-13','10:55:00',1.97),('15529','2013-07-13','11:00:00',2.15),('15529','2013-07-13','11:05:00',2.03),('15529','2013-07-13','11:10:00',1.51),('15529','2013-07-13','11:15:00',1.92),('15529','2013-07-13','11:20:00',2.2),('15529','2013-07-13','11:25:00',1.78),('15529','2013-07-13','11:30:00',1.91),('15529','2013-07-13','11:35:00',2.07),('15529','2013-07-13','11:40:00',2.17),('15529','2013-07-13','11:45:00',2.23),('15529','2013-07-13','11:50:00',2.19),('15529','2013-07-13','11:55:00',2.19),('15529','2013-07-13','12:00:00',1.55),('15529','2013-07-13','12:05:00',2.07),('15529','2013-07-13','12:10:00',1.31),('15529','2013-07-13','12:15:00',2.17),('15529','2013-07-13','12:20:00',2.19),('15529','2013-07-13','12:25:00',1.19),('15529','2013-07-13','12:35:00',1.55),('15529','2013-07-13','12:40:00',1.28),('15529','2013-07-13','13:00:00',2.39),('15529','2013-07-13','13:05:00',2.36),('15529','2013-07-13','13:10:00',2.21),('15529','2013-07-13','13:15:00',2.18),('15529','2013-07-13','13:20:00',2.2),('15529','2013-07-13','13:25:00',2.23),('15529','2013-07-13','13:30:00',2.18),('15529','2013-07-13','13:35:00',2.11),('15529','2013-07-13','13:40:00',2.2),('15529','2013-07-13','13:45:00',2.19),('15529','2013-07-13','13:50:00',2.19),('15529','2013-07-13','13:55:00',2.17),('15529','2013-07-13','14:00:00',2.23),('15529','2013-07-13','14:05:00',2.23),('15529','2013-07-13','14:10:00',2.13),('15529','2013-07-13','14:15:00',2.18),('15529','2013-07-13','14:20:00',2.14),('15529','2013-07-13','14:25:00',2.13),('15529','2013-07-13','14:30:00',2.09),('15529','2013-07-13','14:35:00',2.1),('15529','2013-07-13','14:40:00',2.1),('15529','2013-07-13','14:45:00',2.08),('15529','2013-07-13','14:50:00',2.02),('15529','2013-07-13','14:55:00',2.04),('15529','2013-07-13','15:00:00',1.99),('15529','2013-07-13','15:05:00',1.97),('15529','2013-07-13','15:10:00',1.96),('15529','2013-07-13','15:15:00',1.93),('15529','2013-07-13','15:20:00',1.93),('15529','2013-07-13','15:25:00',1.92),('15529','2013-07-13','15:30:00',1.87),('15529','2013-07-13','15:35:00',1.85),('15529','2013-07-13','15:40:00',1.82),('15529','2013-07-13','15:45:00',1.79),('15529','2013-07-13','15:50:00',1.78),('15529','2013-07-13','15:55:00',1.76),('15529','2013-07-13','16:00:00',1.71),('15529','2013-07-13','16:05:00',1.68),('15529','2013-07-13','16:10:00',1.65),('15529','2013-07-13','16:15:00',1.6),('15529','2013-07-13','16:20:00',1.17),('15529','2013-07-13','16:25:00',1.29),('15529','2013-07-13','16:30:00',1.54),('15529','2013-07-13','16:35:00',1.49),('15529','2013-07-13','16:40:00',1.5),('15529','2013-07-13','16:45:00',1.47),('15529','2013-07-13','16:50:00',1.44),('15529','2013-07-13','16:55:00',1.38),('15529','2013-07-13','17:00:00',1.01),('15529','2013-07-13','17:05:00',1.37),('15529','2013-07-13','17:10:00',1.24),('15529','2013-07-13','17:25:00',1.13),('15529','2013-07-12','09:00:00',1.04),('15529','2013-07-12','09:05:00',1.09),('15529','2013-07-12','09:10:00',1.14),('15529','2013-07-12','09:15:00',1.19),('15529','2013-07-12','09:20:00',1.22),('15529','2013-07-12','09:25:00',1.26),('15529','2013-07-12','09:30:00',1.29),('15529','2013-07-12','09:35:00',1.33),('15529','2013-07-12','09:40:00',1.33),('15529','2013-07-12','09:45:00',1.35),('15529','2013-07-12','09:50:00',1.39),('15529','2013-07-12','09:55:00',1.48),('15529','2013-07-12','10:00:00',1.51),('15529','2013-07-12','10:05:00',1.5),('15529','2013-07-12','10:10:00',1.49),('15529','2013-07-12','10:15:00',1.63),('15529','2013-07-12','10:20:00',1.66),('15529','2013-07-12','10:25:00',1.64),('15529','2013-07-12','10:30:00',1.69),('15529','2013-07-12','10:35:00',1.57),('15529','2013-07-12','10:40:00',1.8),('15529','2013-07-12','10:45:00',1.86),('15529','2013-07-12','10:50:00',1.18),('15529','2013-07-12','10:55:00',1.74),('15529','2013-07-12','11:00:00',2.07),('15529','2013-07-12','11:05:00',1.09),('15529','2013-07-12','11:20:00',1.33),('15529','2013-07-12','11:25:00',1.46),('15529','2013-07-12','11:30:00',1.3),('15529','2013-07-12','11:35:00',2.1),('15529','2013-07-12','11:40:00',2.12),('15529','2013-07-12','11:45:00',2.05),('15529','2013-07-12','11:50:00',1.79),('15529','2013-07-12','12:00:00',1.58),('15529','2013-07-12','12:05:00',1.32),('15529','2013-07-12','12:15:00',1.94),('15529','2013-07-12','12:20:00',1.57),('15529','2013-07-12','12:25:00',1.85),('15529','2013-07-12','12:30:00',2.03),('15529','2013-07-12','12:35:00',2.08),('15529','2013-07-12','12:40:00',1.85),('15529','2013-07-12','12:45:00',1.47),('15529','2013-07-12','12:50:00',2.2),('15529','2013-07-12','12:55:00',2.34),('15529','2013-07-12','13:00:00',1.06),('15529','2013-07-12','13:05:00',2.14),('15529','2013-07-12','13:10:00',2.08),('15529','2013-07-12','13:15:00',2.11),('15529','2013-07-12','13:20:00',2.15),('15529','2013-07-12','13:25:00',2.13),('15529','2013-07-12','13:30:00',2.12),('15529','2013-07-12','13:35:00',2.12),('15529','2013-07-12','13:40:00',2.1),('15529','2013-07-12','13:45:00',2.09),('15529','2013-07-12','13:50:00',2.09),('15529','2013-07-12','13:55:00',2.09),('15529','2013-07-12','14:00:00',2.09),('15529','2013-07-12','14:05:00',2.09),('15529','2013-07-12','14:10:00',2.06),('15529','2013-07-12','14:15:00',2.05),('15529','2013-07-12','14:20:00',2.06),('15529','2013-07-12','14:25:00',1.74),('15529','2013-07-12','14:30:00',1.17),('15529','2013-07-12','14:35:00',1.17),('15529','2013-07-12','14:40:00',1.17),('15529','2013-07-12','14:45:00',1.18),('15529','2013-07-12','14:50:00',1.17),('15529','2013-07-12','14:55:00',1.18),('15529','2013-07-12','15:00:00',1.02),('15529','2013-07-12','15:05:00',2.03),('15529','2013-07-12','15:10:00',2.03),('15529','2013-07-12','15:15:00',2.03),('15529','2013-07-12','15:20:00',1.9),('15529','2013-07-12','15:25:00',1.97),('15529','2013-07-12','15:30:00',1.86),('15529','2013-07-12','15:35:00',1.91),('15529','2013-07-12','15:40:00',1.89),('15529','2013-07-12','15:45:00',1.85),('15529','2013-07-12','15:50:00',1.82),('15529','2013-07-12','15:55:00',1.8),('15529','2013-07-12','16:00:00',1.77),('15529','2013-07-12','16:05:00',1.74),('15529','2013-07-12','16:10:00',1.71),('15529','2013-07-12','16:15:00',1.64),('15529','2013-07-12','16:20:00',1.63),('15529','2013-07-12','16:25:00',1.6),('15529','2013-07-12','16:30:00',1.56),('15529','2013-07-12','16:35:00',1.52),('15529','2013-07-12','16:40:00',1.47),('15529','2013-07-12','16:45:00',1.44),('15529','2013-07-12','16:50:00',1.4),('15529','2013-07-12','16:55:00',1.35),('15529','2013-07-12','17:00:00',1.31),('15529','2013-07-12','17:05:00',1.24),('15529','2013-07-12','17:10:00',1.24),('15529','2013-07-12','17:15:00',1.2),('15529','2013-07-12','17:20:00',1.11),('15529','2013-07-12','17:25:00',1.14),('15529','2013-07-12','17:30:00',1.04),('15529','2013-07-12','17:35:00',1.01),('15529','2013-07-11','09:10:00',1.15),('15529','2013-07-11','09:40:00',1.06),('15529','2013-07-11','09:45:00',1.45),('15529','2013-07-11','09:50:00',1.5),('15529','2013-07-11','09:55:00',1.53),('15529','2013-07-11','10:00:00',1.43),('15529','2013-07-11','10:05:00',1.77),('15529','2013-07-11','10:10:00',1.28),('15529','2013-07-11','10:20:00',1.33),('15529','2013-07-11','10:25:00',1.73),('15529','2013-07-11','10:30:00',1.43),('15529','2013-07-11','10:40:00',1.7),('15529','2013-07-11','11:10:00',1.52),('15529','2013-07-11','11:15:00',1.11),('15529','2013-07-11','11:30:00',1.46),('15529','2013-07-11','11:35:00',1.54),('15529','2013-07-11','11:45:00',2.34),('15529','2013-07-11','11:50:00',2.32),('15529','2013-07-11','11:55:00',1.73),('15529','2013-07-11','12:00:00',1.55),('15529','2013-07-11','12:05:00',1.41),('15529','2013-07-11','12:10:00',1.46),('15529','2013-07-11','12:15:00',1.11),('15529','2013-07-11','12:20:00',2.06),('15529','2013-07-11','12:25:00',2.34),('15529','2013-07-11','12:30:00',2.23),('15529','2013-07-11','12:35:00',2.05),('15529','2013-07-11','12:40:00',1.3),('15529','2013-07-11','12:45:00',1.09),('15529','2013-07-11','12:50:00',1.32),('15529','2013-07-11','12:55:00',2.12),('15529','2013-07-11','13:00:00',2.3),('15529','2013-07-11','13:05:00',2.15),('15529','2013-07-11','13:10:00',2.31),('15529','2013-07-11','13:15:00',2.31),('15529','2013-07-11','13:20:00',2.29),('15529','2013-07-11','13:25:00',2.19),('15529','2013-07-11','13:30:00',2.08),('15529','2013-07-11','13:35:00',1.89),('15529','2013-07-11','13:40:00',2.21),('15529','2013-07-11','13:45:00',2.28),('15529','2013-07-11','13:50:00',1.81),('15529','2013-07-11','13:55:00',2.28),('15529','2013-07-11','14:00:00',1.77),('15529','2013-07-11','14:05:00',2.4),('15529','2013-07-11','14:10:00',2.3),('15529','2013-07-11','14:15:00',2.22),('15529','2013-07-11','14:20:00',2.13),('15529','2013-07-11','14:25:00',1.94),('15529','2013-07-11','14:30:00',2.18),('15529','2013-07-11','14:35:00',2.1),('15529','2013-07-11','14:40:00',2.09),('15529','2013-07-11','14:45:00',2.03),('15529','2013-07-11','14:50:00',2.03),('15529','2013-07-11','14:55:00',2.02),('15529','2013-07-11','15:00:00',1.96),('15529','2013-07-11','15:05:00',2.01),('15529','2013-07-11','15:10:00',1.96),('15529','2013-07-11','15:15:00',1.95),('15529','2013-07-11','15:20:00',1.93),('15529','2013-07-11','15:25:00',1.88),('15529','2013-07-11','15:30:00',1.88),('15529','2013-07-11','15:35:00',1.78),('15529','2013-07-11','15:40:00',1.81),('15529','2013-07-11','15:45:00',1.8),('15529','2013-07-11','15:50:00',1.71),('15529','2013-07-11','15:55:00',1.72),('15529','2013-07-11','16:00:00',1.69),('15529','2013-07-11','16:05:00',1.65),('15529','2013-07-11','16:10:00',1.63),('15529','2013-07-11','16:15:00',1.58),('15529','2013-07-11','16:20:00',1.56),('15529','2013-07-11','16:25:00',1.53),('15529','2013-07-11','16:30:00',1.48),('15529','2013-07-11','16:35:00',1.46),('15529','2013-07-11','16:40:00',1.43),('15529','2013-07-11','16:45:00',1.39),('15529','2013-07-11','16:50:00',1.35),('15529','2013-07-11','16:55:00',1.3),('15529','2013-07-11','17:00:00',1.26),('15529','2013-07-11','17:05:00',1.23),('15529','2013-07-11','17:10:00',1.18),('15529','2013-07-11','17:15:00',1.14),('15529','2013-07-11','17:20:00',1.09),('15529','2013-07-11','17:25:00',1.06),('15529','2013-07-11','17:30:00',1.02),('15529','2013-07-10','08:55:00',1),('15529','2013-07-10','09:00:00',1.01),('15529','2013-07-10','09:05:00',1.08),('15529','2013-07-10','09:10:00',1.16),('15529','2013-07-10','09:15:00',1.18),('15529','2013-07-10','09:20:00',1.27),('15529','2013-07-10','09:25:00',1.28),('15529','2013-07-10','09:30:00',1.36),('15529','2013-07-10','09:35:00',1.12),('15529','2013-07-10','09:45:00',1.28),('15529','2013-07-10','09:50:00',1.32),('15529','2013-07-10','09:55:00',1.16),('15529','2013-07-10','10:00:00',1.29),('15529','2013-07-10','10:05:00',1.82),('15529','2013-07-10','10:10:00',1.64),('15529','2013-07-10','10:15:00',1.07),('15529','2013-07-10','10:35:00',1.93),('15529','2013-07-10','10:40:00',1.95),('15529','2013-07-10','10:45:00',1.99),('15529','2013-07-10','10:50:00',1.66),('15529','2013-07-10','10:55:00',1.19),('15529','2013-07-10','11:00:00',1.82),('15529','2013-07-10','11:05:00',1.55),('15529','2013-07-10','11:20:00',2.16),('15529','2013-07-10','11:25:00',1.55),('15529','2013-07-10','11:30:00',1.84),('15529','2013-07-10','11:35:00',1.14),('15529','2013-07-10','11:40:00',1.83),('15529','2013-07-10','11:45:00',2.31),('15529','2013-07-10','11:50:00',1.11),('15529','2013-07-10','12:00:00',1.8),('15529','2013-07-10','12:05:00',2.29),('15529','2013-07-10','12:10:00',2.29),('15529','2013-07-10','12:15:00',2.26),('15529','2013-07-10','12:20:00',2.28),('15529','2013-07-10','12:25:00',2.21),('15529','2013-07-10','12:30:00',2.24),('15529','2013-07-10','12:35:00',1.7),('15529','2013-07-10','12:40:00',2.24),('15529','2013-07-10','12:45:00',2.29),('15529','2013-07-10','12:50:00',2.12),('15529','2013-07-10','12:55:00',2.27),('15529','2013-07-10','13:00:00',1.88),('15529','2013-07-10','13:05:00',2.21),('15529','2013-07-10','13:10:00',2.09),('15529','2013-07-10','13:15:00',2.38),('15529','2013-07-10','13:20:00',2.08),('15529','2013-07-10','13:25:00',1.83),('15529','2013-07-10','13:30:00',2.02),('15529','2013-07-10','13:35:00',2.35),('15529','2013-07-10','13:40:00',2.3),('15529','2013-07-10','13:45:00',2.3),('15529','2013-07-10','13:50:00',2.25),('15529','2013-07-10','13:55:00',2.25),('15529','2013-07-10','14:00:00',1.92),('15529','2013-07-10','14:05:00',2.2),('15529','2013-07-10','14:10:00',1.98),('15529','2013-07-10','14:15:00',2.12),('15529','2013-07-10','14:20:00',2.14),('15529','2013-07-10','14:25:00',2.13),('15529','2013-07-10','14:30:00',2.15),('15529','2013-07-10','14:35:00',2.09),('15529','2013-07-10','14:40:00',2.11),('15529','2013-07-10','14:45:00',2.1),('15529','2013-07-10','14:50:00',2.09),('15529','2013-07-10','14:55:00',2.08),('15529','2013-07-10','15:00:00',2.1),('15529','2013-07-10','15:05:00',2.07),('15529','2013-07-10','15:10:00',2.05),('15529','2013-07-10','15:15:00',2.06),('15529','2013-07-10','15:20:00',1.98),('15529','2013-07-10','15:25:00',1.95),('15529','2013-07-10','15:30:00',1.91),('15529','2013-07-10','15:35:00',1.91),('15529','2013-07-10','15:40:00',1.88),('15529','2013-07-10','15:45:00',1.92),('15529','2013-07-10','15:50:00',1.91),('15529','2013-07-10','15:55:00',1.51),('15529','2013-07-10','16:05:00',1.49),('15529','2013-07-10','16:10:00',1.07),('15529','2013-07-10','16:20:00',1.2),('15529','2013-07-10','16:30:00',1),('15529','2013-07-10','16:35:00',1.7),('15529','2013-07-10','16:40:00',1.22),('15529','2013-07-10','16:45:00',1.53),('15529','2013-07-10','16:50:00',1.36),('15529','2013-07-10','16:55:00',1.37),('15529','2013-07-10','17:00:00',1.27),('15529','2013-07-10','17:15:00',1.27),('15529','2013-07-10','17:25:00',1.09),('15529','2013-07-10','17:30:00',1.13),('15529','2014-05-02','08:40:00',1.03),('15529','2014-05-02','08:45:00',1.25),('15529','2014-05-02','09:10:00',1.39),('15529','2014-05-02','09:20:00',1.55),('15529','2014-05-02','09:25:00',1.27),('15529','2014-05-02','09:30:00',1.34),('15529','2014-05-02','09:35:00',1.47),('15529','2014-05-02','09:40:00',1.9),('15529','2014-05-02','09:45:00',2.02),('15529','2014-05-02','09:50:00',1.73),('15529','2014-05-02','09:55:00',1.89),('15529','2014-05-02','10:00:00',1.89),('15529','2014-05-02','10:10:00',1.12),('15529','2014-05-02','10:25:00',1.89),('15529','2014-05-02','10:30:00',1.09),('15529','2014-05-02','10:35:00',1.92),('15529','2014-05-02','10:40:00',1.56),('15529','2014-05-02','10:45:00',2.48),('15529','2014-05-02','10:50:00',2.63),('15529','2014-05-02','10:55:00',2.21),('15529','2014-05-02','11:00:00',1.78),('15529','2014-05-02','11:05:00',1.47),('15529','2014-05-02','11:10:00',1.77),('15529','2014-05-02','11:15:00',2.04),('15529','2014-05-02','11:20:00',2.11),('15529','2014-05-02','11:25:00',1.97),('15529','2014-05-02','11:30:00',1.27),('15529','2014-05-02','11:35:00',1.31),('15529','2014-05-02','11:40:00',1.41),('15529','2014-05-02','11:45:00',1.35),('15529','2014-05-02','11:50:00',1.22),('15529','2014-05-02','11:55:00',1.01),('15529','2014-05-02','12:35:00',1.12),('15529','2014-05-02','12:40:00',1.22),('15529','2014-05-02','13:00:00',1.24),('15529','2014-05-02','13:05:00',1.96),('15529','2014-05-02','13:10:00',1.82),('15529','2014-05-02','13:15:00',1.45),('15529','2014-05-02','13:20:00',1.4),('15529','2014-05-02','13:25:00',1.37),('15529','2014-05-02','13:30:00',1.55),('15529','2014-05-02','13:35:00',1.3),('15529','2014-05-02','13:40:00',1.34),('15529','2014-05-02','13:45:00',1.27),('15529','2014-05-02','13:50:00',1.09),('15529','2014-05-02','13:55:00',1.04),('15529','2014-05-02','14:00:00',1.04),('15529','2014-05-02','14:05:00',1.18),('15529','2014-05-02','14:10:00',1.42),('15529','2014-05-02','14:15:00',1.53),('15529','2014-05-02','14:20:00',1.54),('15529','2014-05-02','14:25:00',2.03),('15529','2014-05-02','14:30:00',1.75),('15529','2014-05-02','15:00:00',1.03),('15529','2014-04-05','09:05:00',1.1),('15529','2014-04-05','09:10:00',1.24),('15529','2014-04-05','09:15:00',1.2),('15529','2014-04-05','09:40:00',1.16),('15529','2014-04-05','09:50:00',1.66),('15529','2014-04-05','09:55:00',1.89),('15529','2014-04-05','10:00:00',1.97),('15529','2014-04-05','10:05:00',1.97),('15529','2014-04-05','10:10:00',1.64),('15529','2014-04-05','10:45:00',1),('15529','2014-04-05','10:50:00',1.53),('15529','2014-04-05','10:55:00',1.06),('15529','2014-04-05','11:10:00',1.09),('15529','2014-04-05','11:15:00',2.36),('15529','2014-04-05','11:20:00',2.28),('15529','2014-04-05','11:25:00',2.25),('15529','2014-04-05','11:30:00',2.27),('15529','2014-04-05','11:35:00',1.07),('15529','2014-04-05','11:55:00',1),('15529','2014-04-05','12:10:00',1.51),('15529','2014-04-05','12:30:00',1.29),('15529','2014-04-05','12:40:00',1.22),('15529','2014-04-05','12:50:00',1.55),('15529','2014-04-05','12:55:00',1.72),('15529','2014-04-05','13:00:00',1.87),('15529','2014-04-05','13:05:00',2.51),('15529','2014-04-05','13:10:00',2.08),('15529','2014-04-05','13:20:00',1.54),('15529','2014-04-05','13:25:00',2.07),('15529','2014-04-05','13:30:00',2.57),('15529','2014-04-05','13:35:00',1.45),('15529','2014-04-05','13:40:00',1.43),('15529','2014-04-05','13:45:00',1.91),('15529','2014-04-05','13:50:00',1.27),('15529','2014-04-05','13:55:00',1.46),('15529','2014-04-05','14:25:00',1.54),('15529','2014-04-05','14:40:00',1.03),('15529','2014-04-05','14:45:00',1.92),('15529','2014-04-05','14:50:00',1.2),('15529','2014-04-05','15:05:00',1.05),('15529','2014-04-05','15:10:00',1.2),('15529','2014-04-05','15:55:00',1.45),('15529','2014-04-05','16:00:00',1.78),('15529','2014-04-05','16:05:00',2.03),('15529','2014-04-05','16:10:00',2),('15529','2014-04-05','16:40:00',1),('15529','2014-04-05','16:45:00',1.33),('15529','2014-04-05','16:50:00',1.6),('15529','2014-04-05','16:55:00',1.57),('15529','2014-04-05','17:30:00',1),('15529','2013-07-09','08:30:00',1.13),('15529','2013-07-09','08:35:00',1.08),('15529','2013-07-09','08:40:00',1.04),('15529','2013-07-09','08:45:00',1.1),('15529','2013-07-09','08:50:00',1.15),('15529','2013-07-09','08:55:00',1.11),('15529','2013-07-09','09:00:00',1.08),('15529','2013-07-09','09:05:00',1.05),('15529','2013-07-09','09:10:00',1.03),('15529','2013-07-09','09:20:00',1.09),('15529','2013-07-09','09:25:00',1.31),('15529','2013-07-09','09:30:00',1.34),('15529','2013-07-09','09:35:00',1.37),('15529','2013-07-09','09:40:00',1.39),('15529','2013-07-09','09:45:00',1.42),('15529','2013-07-09','09:50:00',1.45),('15529','2013-07-09','09:55:00',1.5),('15529','2013-07-09','10:00:00',1.52),('15529','2013-07-09','10:05:00',1.54),('15529','2013-07-09','10:10:00',1.58),('15529','2013-07-09','10:15:00',1.62),('15529','2013-07-09','10:20:00',1.66),('15529','2013-07-09','10:25:00',1.7),('15529','2013-07-09','10:30:00',1.72),('15529','2013-07-09','10:35:00',1.74),('15529','2013-07-09','10:40:00',1.77),('15529','2013-07-09','10:45:00',1.79),('15529','2013-07-09','10:50:00',1.81),('15529','2013-07-09','10:55:00',1.82),('15529','2013-07-09','11:00:00',1.86),('15529','2013-07-09','11:05:00',1.87),('15529','2013-07-09','11:10:00',1.88),('15529','2013-07-09','11:15:00',1.88),('15529','2013-07-09','11:20:00',1.9),('15529','2013-07-09','11:25:00',1.94),('15529','2013-07-09','11:30:00',1.96),('15529','2013-07-09','11:35:00',2),('15529','2013-07-09','11:40:00',2.02),('15529','2013-07-09','11:45:00',2.02),('15529','2013-07-09','11:50:00',2.02),('15529','2013-07-09','11:55:00',2.05),('15529','2013-07-09','12:00:00',2.05),('15529','2013-07-09','12:05:00',2.08),('15529','2013-07-09','12:10:00',2.08),('15529','2013-07-09','12:15:00',2.12),('15529','2013-07-09','12:20:00',2.12),('15529','2013-07-09','12:25:00',2.15),('15529','2013-07-09','12:30:00',2.18),('15529','2013-07-09','12:35:00',2.15),('15529','2013-07-09','12:40:00',2.16),('15529','2013-07-09','12:45:00',2.16),('15529','2013-07-09','12:50:00',2.2),('15529','2013-07-09','12:55:00',2.17),('15529','2013-07-09','13:00:00',2.19),('15529','2013-07-09','13:05:00',2.19),('15529','2013-07-09','13:10:00',2.22),('15529','2013-07-09','13:15:00',2.24),('15529','2013-07-09','13:20:00',2.22),('15529','2013-07-09','13:25:00',2.22),('15529','2013-07-09','13:30:00',2.21),('15529','2013-07-09','13:35:00',2.23),('15529','2013-07-09','13:40:00',2.24),('15529','2013-07-09','13:45:00',2.22),('15529','2013-07-09','13:50:00',2.2),('15529','2013-07-09','13:55:00',2.21),('15529','2013-07-09','14:00:00',2.21),('15529','2013-07-09','14:05:00',2.17),('15529','2013-07-09','14:10:00',2.16),('15529','2013-07-09','14:15:00',2.15),('15529','2013-07-09','14:20:00',2.17),('15529','2013-07-09','14:25:00',2.14),('15529','2013-07-09','14:30:00',2.09),('15529','2013-07-09','14:35:00',2.1),('15529','2013-07-09','14:40:00',2.11),('15529','2013-07-09','14:45:00',2.1),('15529','2013-07-09','14:50:00',2.08),('15529','2013-07-09','14:55:00',2.05),('15529','2013-07-09','15:00:00',2.04),('15529','2013-07-09','15:05:00',2.02),('15529','2013-07-09','15:10:00',2),('15529','2013-07-09','15:15:00',1.99),('15529','2013-07-09','15:20:00',1.96),('15529','2013-07-09','15:25:00',1.93),('15529','2013-07-09','15:30:00',1.91),('15529','2013-07-09','15:35:00',1.89),('15529','2013-07-09','15:40:00',1.85),('15529','2013-07-09','15:45:00',1.82),('15529','2013-07-09','15:50:00',1.78),('15529','2013-07-09','15:55:00',1.75),('15529','2013-07-09','16:00:00',1.72),('15529','2013-07-09','16:05:00',1.67),('15529','2013-07-09','16:10:00',1.64),('15529','2013-07-09','16:15:00',1.6),('15529','2013-07-09','16:20:00',1.57),('15529','2013-07-09','16:25:00',1.54),('15529','2013-07-09','16:30:00',1.5),('15529','2013-07-09','16:35:00',1.46),('15529','2013-07-09','16:40:00',1.43),('15529','2013-07-09','16:45:00',1.4),('15529','2013-07-09','16:50:00',1.37),('15529','2013-07-09','16:55:00',1.34),('15529','2013-07-09','17:00:00',1.33),('15529','2013-07-09','17:05:00',1.08),('15529','2013-07-08','08:55:00',1.03),('15529','2013-07-08','09:00:00',1.07),('15529','2013-07-08','09:05:00',1.11),('15529','2013-07-08','09:10:00',1.15),('15529','2013-07-08','09:15:00',1.2),('15529','2013-07-08','09:20:00',1.23),('15529','2013-07-08','09:25:00',1.26),('15529','2013-07-08','09:30:00',1.3),('15529','2013-07-08','09:35:00',1.34),('15529','2013-07-08','09:40:00',1.38),('15529','2013-07-08','09:45:00',1.42),('15529','2013-07-08','09:50:00',1.45),('15529','2013-07-08','09:55:00',1.48),('15529','2013-07-08','10:00:00',1.51),('15529','2013-07-08','10:05:00',1.54),('15529','2013-07-08','10:10:00',1.57),('15529','2013-07-08','10:15:00',1.6),('15529','2013-07-08','10:20:00',1.64),('15529','2013-07-08','10:25:00',1.67),('15529','2013-07-08','10:30:00',1.7),('15529','2013-07-08','10:35:00',1.73),('15529','2013-07-08','10:40:00',1.77),('15529','2013-07-08','10:45:00',1.76),('15529','2013-07-08','10:50:00',1.81),('15529','2013-07-08','10:55:00',1.82),('15529','2013-07-08','11:00:00',1.81),('15529','2013-07-08','11:05:00',1.83),('15529','2013-07-08','11:10:00',1.89),('15529','2013-07-08','11:15:00',1.92),('15529','2013-07-08','11:20:00',1.97),('15529','2013-07-08','11:25:00',1.82),('15529','2013-07-08','11:30:00',1.51),('15529','2013-07-08','11:35:00',1.75),('15529','2013-07-08','11:40:00',1.9),('15529','2013-07-08','11:45:00',1.43),('15529','2013-07-08','11:50:00',2.01),('15529','2013-07-08','11:55:00',2.13),('15529','2013-07-08','12:00:00',2.19),('15529','2013-07-08','12:05:00',2.17),('15529','2013-07-08','12:10:00',2.1),('15529','2013-07-08','12:15:00',2.15),('15529','2013-07-08','12:20:00',2.1),('15529','2013-07-08','12:25:00',2.15),('15529','2013-07-08','12:30:00',2.17),('15529','2013-07-08','12:35:00',2.17),('15529','2013-07-08','12:40:00',2.21),('15529','2013-07-08','12:45:00',2.15),('15529','2013-07-08','12:50:00',2.14),('15529','2013-07-08','12:55:00',2.18),('15529','2013-07-08','13:00:00',2.21),('15529','2013-07-08','13:05:00',2.21),('15529','2013-07-08','13:10:00',2.24),('15529','2013-07-08','13:15:00',2.2),('15529','2013-07-08','13:20:00',2.23),('15529','2013-07-08','13:25:00',2.22),('15529','2013-07-08','13:30:00',2.24),('15529','2013-07-08','13:35:00',2.27),('15529','2013-07-08','13:40:00',2.23),('15529','2013-07-08','13:45:00',2.14),('15529','2013-07-08','13:50:00',1.83),('15529','2013-07-08','13:55:00',2),('15529','2013-07-08','14:00:00',1.95),('15529','2013-07-08','14:05:00',1.8),('15529','2013-07-08','14:10:00',1.81),('15529','2013-07-08','14:15:00',1.88),('15529','2013-07-08','14:20:00',1.96),('15529','2013-07-08','14:25:00',1.85),('15529','2013-07-07','08:55:00',1.03),('15529','2013-07-07','09:00:00',1.07),('15529','2013-07-07','09:05:00',1.11),('15529','2013-07-07','09:10:00',1.14),('15529','2013-07-07','09:15:00',1.18),('15529','2013-07-07','09:20:00',1.21),('15529','2013-07-07','09:25:00',1.21),('15529','2013-07-07','09:30:00',1.28),('15529','2013-07-07','09:35:00',1.31),('15529','2013-07-07','09:40:00',1.37),('15529','2013-07-07','09:45:00',1.4),('15529','2013-07-07','09:50:00',1.44),('15529','2013-07-07','09:55:00',1.46),('15529','2013-07-07','10:00:00',1.49),('15529','2013-07-07','10:05:00',1.55),('15529','2013-07-07','10:10:00',1.58),('15529','2013-07-07','10:15:00',1.59),('15529','2013-07-07','10:20:00',1.65),('15529','2013-07-07','10:25:00',1.66),('15529','2013-07-07','10:30:00',1.55),('15529','2013-07-07','10:35:00',1.51),('15529','2013-07-07','10:40:00',1.75),('15529','2013-07-07','10:45:00',1.81),('15529','2013-07-07','10:50:00',1.8),('15529','2013-07-07','10:55:00',1.83),('15529','2013-07-07','11:00:00',1.84),('15529','2013-07-07','11:05:00',1.86),('15529','2013-07-07','11:10:00',1.88),('15529','2013-07-07','11:15:00',1.9),('15529','2013-07-07','11:20:00',1.93),('15529','2013-07-07','11:25:00',1.93),('15529','2013-07-07','11:30:00',2.01),('15529','2013-07-07','11:35:00',2.03),('15529','2013-07-07','11:40:00',1.99),('15529','2013-07-07','11:45:00',1.89),('15529','2013-07-07','11:50:00',2.1),('15529','2013-07-07','11:55:00',2.13),('15529','2013-07-07','12:00:00',2.02),('15529','2013-07-07','12:05:00',1.86),('15529','2013-07-07','12:10:00',1.89),('15529','2013-07-07','12:15:00',2.23),('15529','2013-07-07','12:20:00',1.25),('15529','2013-07-07','12:25:00',1.85),('15529','2013-07-07','12:30:00',2.07),('15529','2013-07-07','12:35:00',2.09),('15529','2013-07-07','12:40:00',2.18),('15529','2013-07-07','12:45:00',2.2),('15529','2013-07-07','12:50:00',2.15),('15529','2013-07-07','12:55:00',2.12),('15529','2013-07-07','13:00:00',2.17),('15529','2013-07-07','13:05:00',2.2),('15529','2013-07-07','13:10:00',2.24),('15529','2013-07-07','13:15:00',1.58),('15529','2013-07-07','13:20:00',2),('15529','2013-07-06','08:55:00',1.02),('15529','2013-07-06','09:00:00',1.19),('15529','2013-07-06','09:05:00',1.25),('15529','2013-07-06','09:10:00',1.23),('15529','2013-07-06','09:15:00',1.05),('15529','2013-07-06','09:20:00',1.09),('15529','2013-07-06','09:25:00',1.09),('15529','2013-07-06','09:30:00',1.1),('15529','2013-07-06','09:35:00',1.4),('15529','2013-07-06','09:40:00',1.41),('15529','2013-07-06','09:45:00',1.37),('15529','2013-07-06','09:50:00',1.55),('15529','2013-07-06','09:55:00',1.66),('15529','2013-07-06','10:00:00',1.66),('15529','2013-07-06','10:05:00',1.62),('15529','2013-07-06','10:10:00',1.47),('15529','2013-07-06','10:15:00',1.62),('15529','2013-07-06','10:20:00',1.54),('15529','2013-07-06','10:25:00',1.76),('15529','2013-07-06','10:30:00',1.68),('15529','2013-07-06','10:35:00',1.57),('15529','2013-07-06','10:40:00',1.84),('15529','2013-07-06','10:45:00',1.8),('15529','2013-07-06','10:50:00',1.9),('15529','2013-07-06','10:55:00',1.93),('15529','2013-07-06','11:00:00',1.93),('15529','2013-07-06','11:05:00',1.93),('15529','2013-07-06','11:10:00',1.97),('15529','2013-07-06','11:15:00',1.98),('15529','2013-07-06','11:20:00',1.83),('15529','2013-07-06','11:25:00',1.87),('15529','2013-07-06','11:30:00',1.8),('15529','2013-07-06','11:35:00',1.81),('15529','2013-07-06','11:40:00',1.8),('15529','2013-07-06','11:45:00',1.55),('15529','2013-07-06','11:50:00',1.79),('15529','2013-07-06','11:55:00',1.42),('15529','2013-07-06','12:00:00',1.28),('15529','2013-07-06','12:05:00',1.67),('15529','2013-07-06','12:10:00',2.01),('15529','2013-07-06','12:15:00',2.12),('15529','2013-07-06','12:20:00',2.12),('15529','2013-07-06','12:25:00',1.91),('15529','2013-07-06','12:30:00',1.93),('15529','2013-07-06','12:35:00',2.05),('15529','2013-07-06','12:40:00',2.18),('15529','2013-07-06','12:45:00',2.26),('15529','2013-07-06','12:50:00',2.23),('15529','2013-07-06','12:55:00',2.17),('15529','2013-07-06','13:00:00',2.27),('15529','2013-07-06','13:05:00',2.1),('15529','2013-07-06','13:10:00',2.22),('15529','2013-07-06','13:15:00',2.28),('15529','2013-07-06','13:20:00',2.24),('15529','2013-07-06','13:25:00',2.25),('15529','2013-07-06','13:30:00',2.15),('15529','2013-07-06','13:50:00',1.19),('15529','2013-07-06','13:55:00',2.15),('15529','2013-07-06','14:00:00',2.26),('15529','2013-07-05','08:55:00',1.04),('15529','2013-07-05','09:00:00',1.08),('15529','2013-07-05','09:05:00',1.12),('15529','2013-07-05','09:10:00',1.17),('15529','2013-07-05','09:15:00',1.2),('15529','2013-07-05','09:20:00',1.24),('15529','2013-07-05','09:25:00',1.28),('15529','2013-07-05','09:30:00',1.32),('15529','2013-07-05','09:35:00',1.35),('15529','2013-07-05','09:40:00',1.39),('15529','2013-07-05','09:45:00',1.44),('15529','2013-07-05','09:50:00',1.46),('15529','2013-07-05','09:55:00',1.49),('15529','2013-07-05','10:00:00',1.53),('15529','2013-07-05','10:05:00',1.57),('15529','2013-07-05','10:10:00',1.6),('15529','2013-07-05','10:15:00',1.64),('15529','2013-07-05','10:20:00',1.67),('15529','2013-07-05','10:25:00',1.67),('15529','2013-07-05','10:30:00',1.71),('15529','2013-07-05','10:35:00',1.74),('15529','2013-07-05','10:40:00',1.76),('15529','2013-07-05','10:45:00',1.79),('15529','2013-07-05','10:50:00',1.83),('15529','2013-07-05','10:55:00',1.85),('15529','2013-07-05','11:00:00',1.88),('15529','2013-07-05','11:05:00',1.92),('15529','2013-07-05','11:10:00',1.9),('15529','2013-07-05','11:15:00',1.96),('15529','2013-07-05','11:20:00',1.93),('15529','2013-07-05','11:25:00',1.94),('15529','2013-07-05','11:30:00',2),('15529','2013-07-05','11:35:00',1.96),('15529','2013-07-05','11:40:00',2.02),('15529','2013-07-05','11:45:00',2.01),('15529','2013-07-05','11:50:00',2.02),('15529','2013-07-05','11:55:00',2.06),('15529','2013-07-05','12:00:00',2.06),('15529','2013-07-05','12:05:00',2.05),('15529','2013-07-05','12:10:00',2.09),('15529','2013-07-05','12:15:00',2.11),('15529','2013-07-05','12:20:00',2.08),('15529','2013-07-05','12:25:00',2.16),('15529','2013-07-05','12:30:00',2.16),('15529','2013-07-05','12:35:00',2.2),('15529','2013-07-05','12:40:00',2.13),('15529','2013-07-05','12:45:00',2.15),('15529','2013-07-05','12:50:00',2.14),('15529','2013-07-05','12:55:00',2.16),('15529','2013-07-05','13:00:00',2.14),('15529','2013-07-05','13:05:00',2.15),('15529','2013-07-05','13:10:00',2.18),('15529','2013-07-05','13:15:00',2.17),('15529','2013-07-05','13:20:00',2.01),('15529','2013-07-05','13:25:00',2.18),('15529','2013-07-05','13:30:00',2.2),('15529','2013-07-05','13:35:00',2.18),('15529','2013-07-05','13:40:00',2.21),('15529','2013-07-05','13:45:00',2.19),('15529','2013-07-05','13:50:00',2.2),('15529','2013-07-05','13:55:00',2.2),('15529','2013-07-05','14:00:00',2.15),('15529','2013-07-05','14:05:00',2.11),('15529','2013-07-05','14:10:00',2.09),('15529','2013-07-05','14:15:00',2.15),('15529','2013-07-05','14:20:00',2.18),('15529','2013-07-05','14:25:00',2.1),('15529','2013-07-05','14:30:00',2.1),('15529','2013-07-05','14:35:00',2.04),('15529','2013-07-05','14:40:00',1.97),('15529','2013-07-05','14:45:00',1.94),('15529','2013-07-05','14:50:00',1.61),('15529','2013-07-05','14:55:00',2.12),('15529','2013-07-05','15:00:00',1.94),('15529','2013-07-05','15:05:00',2.1),('15529','2013-07-05','15:10:00',2.03),('15529','2013-07-05','15:15:00',1.95),('15529','2013-07-05','15:20:00',1.96),('15529','2013-07-05','15:25:00',1.95),('15529','2013-07-05','15:30:00',1.68),('15529','2013-07-05','17:15:00',1.31),('15529','2013-07-05','17:20:00',1.12),('15529','2013-07-04','08:50:00',1.01),('15529','2013-07-04','08:55:00',1.05),('15529','2013-07-04','09:00:00',1.09),('15529','2013-07-04','09:05:00',1.14),('15529','2013-07-04','09:10:00',1.2),('15529','2013-07-04','09:15:00',1.24),('15529','2013-07-04','09:20:00',1.28),('15529','2013-07-04','09:25:00',1.31),('15529','2013-07-04','09:30:00',1.34),('15529','2013-07-04','09:35:00',1.37),('15529','2013-07-04','09:40:00',1.4),('15529','2013-07-04','09:45:00',1.45),('15529','2013-07-04','09:50:00',1.48),('15529','2013-07-04','09:55:00',1.51),('15529','2013-07-04','10:00:00',1.54),('15529','2013-07-04','10:05:00',1.58),('15529','2013-07-04','10:10:00',1.62),('15529','2013-07-04','10:15:00',1.64),('15529','2013-07-04','10:20:00',1.66),('15529','2013-07-04','10:25:00',1.69),('15529','2013-07-04','10:30:00',1.72),('15529','2013-07-04','10:35:00',1.74),('15529','2013-07-04','10:40:00',1.76),('15529','2013-07-04','10:45:00',1.8),('15529','2013-07-04','10:50:00',1.81),('15529','2013-07-04','10:55:00',1.83),('15529','2013-07-04','11:00:00',1.87),('15529','2013-07-04','11:05:00',1.89),('15529','2013-07-04','11:10:00',1.88),('15529','2013-07-04','11:15:00',1.92),('15529','2013-07-04','11:20:00',1.98),('15529','2013-07-04','11:25:00',1.96),('15529','2013-07-04','11:30:00',1.97),('15529','2013-07-04','11:35:00',1.97),('15529','2013-07-04','11:40:00',2),('15529','2013-07-04','11:45:00',2),('15529','2013-07-04','11:50:00',1.99),('15529','2013-07-04','11:55:00',2),('15529','2013-07-04','12:00:00',2.03),('15529','2013-07-04','12:05:00',2.03),('15529','2013-07-04','12:10:00',2.05),('15529','2013-07-04','12:15:00',2.1),('15529','2013-07-04','12:20:00',2.1),('15529','2013-07-04','12:25:00',2.19),('15529','2013-07-04','12:30:00',2.21),('15529','2013-07-04','12:35:00',2.12),('15529','2013-07-04','12:40:00',2.08),('15529','2013-07-04','12:45:00',2.2),('15529','2013-07-04','12:50:00',2.18),('15529','2013-07-04','12:55:00',2.18),('15529','2013-07-04','13:00:00',2.29),('15529','2013-07-04','13:05:00',2.28),('15529','2013-07-04','13:10:00',2.33),('15529','2013-07-04','13:15:00',2.26),('15529','2013-07-04','13:20:00',1.15),('15529','2013-07-04','13:25:00',1.39),('15529','2013-07-04','13:30:00',1.61),('15529','2013-07-04','13:35:00',2.14),('15529','2013-07-04','13:40:00',2.13),('15529','2013-07-04','13:45:00',2.12),('15529','2013-07-04','13:50:00',2.11),('15529','2013-07-04','13:55:00',2.1),('15529','2013-07-04','14:00:00',2.09),('15529','2013-07-04','14:05:00',2.08),('15529','2013-07-04','14:10:00',1.74),('15529','2013-07-04','14:15:00',2.06),('15529','2013-07-04','14:20:00',2.06),('15529','2013-07-04','14:25:00',2.02),('15529','2013-07-04','14:30:00',2.02),('15529','2013-07-04','14:35:00',2.02),('15529','2013-07-04','14:40:00',1.85),('15529','2013-07-04','14:45:00',1.98),('15529','2013-07-04','14:50:00',1.98),('15529','2013-07-04','14:55:00',1.95),('15529','2013-07-04','15:00:00',1.93),('15529','2013-07-04','15:05:00',1.97),('15529','2013-07-04','15:10:00',1.92),('15529','2013-07-04','15:15:00',1.91),('15529','2013-07-04','15:20:00',1.89),('15529','2013-07-04','15:25:00',1.86),('15529','2013-07-04','15:30:00',1.86),('15529','2013-07-04','15:35:00',1.81),('15529','2013-07-04','15:40:00',1.77),('15529','2013-07-04','15:45:00',1.69),('15529','2013-07-04','15:50:00',1.74),('15529','2013-07-04','15:55:00',1.7),('15529','2013-07-04','16:00:00',1.65),('15529','2013-07-04','16:05:00',1.62),('15529','2013-07-04','16:10:00',1.6),('15529','2013-07-04','16:15:00',1.57),('15529','2013-07-04','16:20:00',1.54),('15529','2013-07-04','16:25:00',1.51),('15529','2013-07-04','16:30:00',1.48),('15529','2013-07-04','16:35:00',1.45),('15529','2013-07-04','16:40:00',1.4),('15529','2013-07-04','16:45:00',1.36),('15529','2013-07-04','16:50:00',1.33),('15529','2013-07-04','16:55:00',1.27),('15529','2013-07-04','17:00:00',1.21),('15529','2013-07-04','17:05:00',1.19),('15529','2013-07-04','17:10:00',1.16),('15529','2013-07-04','17:15:00',1.08),('15529','2013-07-03','12:05:00',1.08),('15529','2013-07-03','12:10:00',1.29),('15529','2013-07-03','12:15:00',1.01),('15529','2013-07-03','13:10:00',1.33),('15529','2013-07-03','13:15:00',2.08),('15529','2013-07-03','13:20:00',1.23),('15529','2013-07-03','13:25:00',1.54),('15529','2013-07-03','13:30:00',1.43),('15529','2013-07-03','13:35:00',1.69),('15529','2013-07-03','13:40:00',2.52),('15529','2013-07-03','13:45:00',2.49),('15529','2013-07-03','13:50:00',2.4),('15529','2013-07-03','13:55:00',1.63),('15529','2013-07-03','14:00:00',1.53),('15529','2013-07-03','14:05:00',1.27),('15529','2013-07-03','14:10:00',1.24),('15529','2013-07-03','14:15:00',1.05),('15529','2013-07-03','14:25:00',1),('15529','2013-07-03','14:35:00',1.02),('15529','2013-07-03','14:40:00',1.05),('15529','2013-07-03','14:45:00',1.18),('15529','2013-07-03','14:50:00',1.12),('15529','2013-07-03','14:55:00',1.67),('15529','2013-07-03','15:00:00',1.22),('15529','2013-07-03','15:05:00',1.01),('15529','2013-07-03','15:10:00',1.47),('15529','2013-07-03','15:15:00',1.44),('15529','2013-07-03','15:20:00',1.81),('15529','2013-07-03','15:25:00',1.18),('15529','2013-07-03','15:30:00',1.01),('15529','2013-07-03','15:35:00',1.41),('15529','2013-07-03','15:40:00',1.23),('15529','2013-07-03','15:45:00',1.31),('15529','2013-07-03','15:50:00',1.24),('15529','2013-07-03','15:55:00',1.09),('15529','2013-07-03','16:00:00',1.11),('15529','2013-07-03','16:05:00',1.16),('15529','2013-07-03','16:20:00',1.01),('15529','2013-07-03','16:25:00',1.11),('15529','2013-07-03','17:30:00',1.09),('15529','2013-07-03','17:35:00',1.17),('15529','2013-07-03','17:40:00',1.07),('15529','2013-07-03','17:45:00',1.01),('15529','2013-07-02','08:45:00',1),('15529','2013-07-02','08:50:00',1.05),('15529','2013-07-02','08:55:00',1.1),('15529','2013-07-02','09:00:00',1.14),('15529','2013-07-02','09:05:00',1.18),('15529','2013-07-02','09:10:00',1.21),('15529','2013-07-02','09:15:00',1.25),('15529','2013-07-02','09:20:00',1.29),('15529','2013-07-02','09:25:00',1.33),('15529','2013-07-02','09:30:00',1.36),('15529','2013-07-02','09:35:00',1.4),('15529','2013-07-02','09:40:00',1.42),('15529','2013-07-02','09:45:00',1.44),('15529','2013-07-02','09:50:00',1.48),('15529','2013-07-02','09:55:00',1.53),('15529','2013-07-02','10:00:00',1.53),('15529','2013-07-02','10:05:00',1.57),('15529','2013-07-02','10:10:00',1.61),('15529','2013-07-02','10:15:00',1.65),('15529','2013-07-02','10:20:00',1.65),('15529','2013-07-02','10:25:00',1.68),('15529','2013-07-02','10:30:00',1.77),('15529','2013-07-02','10:35:00',1.8),('15529','2013-07-02','10:40:00',1.82),('15529','2013-07-02','10:45:00',1.85),('15529','2013-07-02','10:50:00',1.86),('15529','2013-07-02','10:55:00',1.87),('15529','2013-07-02','11:00:00',1.89),('15529','2013-07-02','11:05:00',1.9),('15529','2013-07-02','11:10:00',1.9),('15529','2013-07-02','11:15:00',1.92),('15529','2013-07-02','11:20:00',1.96),('15529','2013-07-02','11:25:00',2),('15529','2013-07-02','11:30:00',2.02),('15529','2013-07-02','11:35:00',2.04),('15529','2013-07-02','11:40:00',2.06),('15529','2013-07-02','11:45:00',2.09),('15529','2013-07-02','11:50:00',2.11),('15529','2013-07-02','11:55:00',2.13),('15529','2013-07-02','12:00:00',2.13),('15529','2013-07-02','12:05:00',2.15),('15529','2013-07-02','12:10:00',2.17),('15529','2013-07-02','12:15:00',2.16),('15529','2013-07-02','12:20:00',2.21),('15529','2013-07-02','12:25:00',2.19),('15529','2013-07-02','12:30:00',2.2),('15529','2013-07-02','12:35:00',2.18),('15529','2013-07-02','12:40:00',2.22),('15529','2013-07-02','12:45:00',2.22),('15529','2013-07-02','12:50:00',2.24),('15529','2013-07-02','12:55:00',2.26),('15529','2013-07-02','13:00:00',2.25),('15529','2013-07-02','13:05:00',2.21),('15529','2013-07-02','13:10:00',2.24),('15529','2013-07-02','13:15:00',2.27),('15529','2013-07-02','13:20:00',2.28),('15529','2013-07-02','13:25:00',2.26),('15529','2013-07-02','13:30:00',2.26),('15529','2013-07-02','13:35:00',2.26),('15529','2013-07-02','13:40:00',2.27),('15529','2013-07-02','13:45:00',2.22),('15529','2013-07-02','13:50:00',2.21),('15529','2013-07-02','13:55:00',2.26),('15529','2013-07-02','14:00:00',2.19),('15529','2013-07-02','14:05:00',2.22),('15529','2013-07-02','14:10:00',2.23),('15529','2013-07-02','14:15:00',2.2),('15529','2013-07-02','14:20:00',2.18),('15529','2013-07-02','14:25:00',2.19),('15529','2013-07-02','14:30:00',2.16),('15529','2013-07-02','14:35:00',2.16),('15529','2013-07-02','14:40:00',2.13),('15529','2013-07-02','14:45:00',2.05),('15529','2013-07-02','14:50:00',2.09),('15529','2013-07-02','14:55:00',2.09),('15529','2013-07-02','15:00:00',2.05),('15529','2013-07-02','15:05:00',2.03),('15529','2013-07-02','15:10:00',2.02),('15529','2013-07-02','15:15:00',2.01),('15529','2013-07-02','15:20:00',1.99),('15529','2013-07-02','15:25:00',1.96),('15529','2013-07-02','15:30:00',1.93),('15529','2013-07-02','15:35:00',1.9),('15529','2013-07-02','15:40:00',1.89),('15529','2013-07-02','15:45:00',1.86),('15529','2013-07-02','15:50:00',1.82),('15529','2013-07-02','15:55:00',1.79),('15529','2013-07-02','16:00:00',1.74),('15529','2013-07-02','16:05:00',1.72),('15529','2013-07-02','16:10:00',1.69),('15529','2013-07-02','16:15:00',1.66),('15529','2013-07-02','16:20:00',1.63),('15529','2013-07-02','16:25:00',1.59),('15529','2013-07-02','16:30:00',1.56),('15529','2013-07-02','16:35:00',1.53),('15529','2013-07-02','16:40:00',1.51),('15529','2013-07-02','16:45:00',1.47),('15529','2013-07-02','16:50:00',1.41),('15529','2013-07-02','16:55:00',1.38),('15529','2013-07-02','17:00:00',1.34),('15529','2013-07-02','17:05:00',1.29),('15529','2013-07-02','17:10:00',1.25),('15529','2013-07-02','17:15:00',1.21),('15529','2013-07-02','17:20:00',1.17),('15529','2013-07-02','17:25:00',1.12),('15529','2013-07-02','17:30:00',1.08),('15529','2013-07-02','17:35:00',1.04),('15529','2013-07-01','08:50:00',1.04),('15529','2013-07-01','08:55:00',1.08),('15529','2013-07-01','09:00:00',1.12),('15529','2013-07-01','09:05:00',1.15),('15529','2013-07-01','09:10:00',1.19),('15529','2013-07-01','09:15:00',1.24),('15529','2013-07-01','09:20:00',1.27),('15529','2013-07-01','09:25:00',1.3),('15529','2013-07-01','09:30:00',1.34),('15529','2013-07-01','09:35:00',1.38),('15529','2013-07-01','09:40:00',1.41),('15529','2013-07-01','09:45:00',1.44),('15529','2013-07-01','09:50:00',1.46),('15529','2013-07-01','09:55:00',1.5),('15529','2013-07-01','10:00:00',1.53),('15529','2013-07-01','10:05:00',1.57),('15529','2013-07-01','10:10:00',1.62),('15529','2013-07-01','10:15:00',1.64),('15529','2013-07-01','10:20:00',1.67),('15529','2013-07-01','10:25:00',1.7),('15529','2013-07-01','10:30:00',1.71),('15529','2013-07-01','10:35:00',1.73),('15529','2013-07-01','10:40:00',1.75),('15529','2013-07-01','10:45:00',1.78),('15529','2013-07-01','10:50:00',1.79),('15529','2013-07-01','10:55:00',1.82),('15529','2013-07-01','11:00:00',1.83),('15529','2013-07-01','11:05:00',1.86),('15529','2013-07-01','11:10:00',1.9),('15529','2013-07-01','11:15:00',1.9),('15529','2013-07-01','11:20:00',1.94),('15529','2013-07-01','11:25:00',1.96),('15529','2013-07-01','11:30:00',1.95),('15529','2013-07-01','11:35:00',2),('15529','2013-07-01','11:40:00',2.01),('15529','2013-07-01','11:45:00',2.05),('15529','2013-07-01','11:50:00',2.04),('15529','2013-07-01','11:55:00',2.03),('15529','2013-07-01','12:00:00',2.01),('15529','2013-07-01','12:05:00',2.06),('15529','2013-07-01','12:10:00',2.11),('15529','2013-07-01','12:15:00',2.15),('15529','2013-07-01','12:20:00',2.13),('15529','2013-07-01','12:25:00',2.16),('15529','2013-07-01','12:30:00',2.26),('15529','2013-07-01','12:35:00',2.28),('15529','2013-07-01','12:40:00',2.27),('15529','2013-07-01','12:50:00',1.31),('15529','2013-07-01','12:55:00',1.97),('15529','2013-07-01','13:00:00',2.31),('15529','2013-07-01','13:05:00',2.26),('15529','2013-07-01','13:10:00',2.23),('15529','2013-07-01','13:15:00',2.22),('15529','2013-07-01','13:20:00',2.19),('15529','2013-07-01','13:25:00',2.17),('15529','2013-07-01','13:30:00',2.21),('15529','2013-07-01','13:35:00',2.15),('15529','2013-07-01','13:40:00',2.19),('15529','2013-07-01','13:45:00',2.18),('15529','2013-07-01','13:50:00',2.19),('15529','2013-07-01','13:55:00',2.19),('15529','2013-07-01','14:00:00',2.17),('15529','2013-07-01','14:05:00',2.15),('15529','2013-07-01','14:10:00',2.12),('15529','2013-07-01','14:15:00',2.14),('15529','2013-07-01','14:20:00',2.12),('15529','2013-07-01','14:25:00',2.12),('15529','2013-07-01','14:30:00',2.11),('15529','2013-07-01','14:35:00',2.07),('15529','2013-07-01','14:40:00',2.05),('15529','2013-07-01','14:45:00',2.05),('15529','2013-07-01','14:50:00',2.05),('15529','2013-07-01','14:55:00',2.03),('15529','2013-07-01','15:00:00',2),('15529','2013-07-01','15:05:00',1.99),('15529','2013-07-01','15:10:00',1.97),('15529','2013-07-01','15:15:00',1.95),('15529','2013-07-01','15:20:00',1.92),('15529','2013-07-01','15:25:00',1.89),('15529','2013-07-01','15:30:00',1.87),('15529','2013-07-01','15:35:00',1.84),('15529','2013-07-01','15:40:00',1.82),('15529','2013-07-01','15:45:00',1.8),('15529','2013-07-01','15:50:00',1.78),('15529','2013-07-01','15:55:00',1.75),('15529','2013-07-01','16:00:00',1.72),('15529','2013-07-01','16:05:00',1.69),('15529','2013-07-01','16:10:00',1.64),('15529','2013-07-01','16:15:00',1.58),('15529','2013-07-01','16:20:00',1.57),('15529','2013-07-01','16:25:00',1.56),('15529','2013-07-01','16:30:00',1.53),('15529','2013-07-01','16:35:00',1.48),('15529','2013-07-01','16:40:00',1.44),('15529','2013-07-01','16:45:00',1.4),('15529','2013-07-01','16:50:00',1.35),('15529','2013-07-01','16:55:00',1.33),('15529','2013-07-01','17:00:00',1.29),('15529','2013-07-01','17:05:00',1.25),('15529','2013-07-01','17:10:00',1.2),('15529','2013-07-01','17:15:00',1.17),('15529','2013-07-01','17:20:00',1.12),('15529','2013-07-01','17:25:00',1.08),('15529','2013-07-01','17:30:00',1.03),('15529','2013-06-30','08:45:00',1.01),('15529','2013-06-30','08:50:00',1.05),('15529','2013-06-30','08:55:00',1.1),('15529','2013-06-30','09:00:00',1.15),('15529','2013-06-30','09:05:00',1.19),('15529','2013-06-30','09:10:00',1.23),('15529','2013-06-30','09:15:00',1.27),('15529','2013-06-30','09:20:00',1.31),('15529','2013-06-30','09:25:00',1.36),('15529','2013-06-30','09:30:00',1.4),('15529','2013-06-30','09:35:00',1.44),('15529','2013-06-30','09:40:00',1.46),('15529','2013-06-30','09:45:00',1.49),('15529','2013-06-30','09:50:00',1.54),('15529','2013-06-30','09:55:00',1.55),('15529','2013-06-30','10:00:00',1.6),('15529','2013-06-30','10:05:00',1.61),('15529','2013-06-30','10:10:00',1.66),('15529','2013-06-30','10:15:00',1.69),('15529','2013-06-30','10:20:00',1.72),('15529','2013-06-30','10:25:00',1.76),('15529','2013-06-30','10:30:00',1.8),('15529','2013-06-30','10:35:00',1.83),('15529','2013-06-30','10:40:00',1.85),('15529','2013-06-30','10:45:00',1.88),('15529','2013-06-30','10:50:00',1.9),('15529','2013-06-30','10:55:00',1.91),('15529','2013-06-30','11:00:00',1.93),('15529','2013-06-30','11:05:00',1.95),('15529','2013-06-30','11:10:00',2.01),('15529','2013-06-30','11:15:00',2.01),('15529','2013-06-30','11:20:00',2.03),('15529','2013-06-30','11:25:00',2.07),('15529','2013-06-30','11:30:00',2.07),('15529','2013-06-30','11:35:00',2.09),('15529','2013-06-30','11:40:00',2.13),('15529','2013-06-30','11:45:00',2.1),('15529','2013-06-30','11:50:00',2.12),('15529','2013-06-30','11:55:00',2.15),('15529','2013-06-30','12:00:00',2.17),('15529','2013-06-30','12:05:00',2.17),('15529','2013-06-30','12:10:00',2.16),('15529','2013-06-30','12:15:00',2.18),('15529','2013-06-30','12:20:00',2.16),('15529','2013-06-30','12:25:00',2.2),('15529','2013-06-30','12:30:00',2.18),('15529','2013-06-30','12:35:00',2.18),('15529','2013-06-30','12:40:00',2.21),('15529','2013-06-30','12:45:00',2.23),('15529','2013-06-30','12:50:00',2.24),('15529','2013-06-30','12:55:00',2.22),('15529','2013-06-30','13:00:00',2.23),('15529','2013-06-30','13:05:00',2.21),('15529','2013-06-30','13:10:00',2.25),('15529','2013-06-30','13:15:00',2.24),('15529','2013-06-30','13:20:00',2.26),('15529','2013-06-30','13:25:00',2.24),('15529','2013-06-30','13:30:00',2.21),('15529','2013-06-30','13:35:00',2.23),('15529','2013-06-30','13:40:00',2.2),('15529','2013-06-30','13:45:00',2.21),('15529','2013-06-30','13:50:00',2.23),('15529','2013-06-30','13:55:00',2.22),('15529','2013-06-30','14:00:00',2.23),('15529','2013-06-30','14:05:00',2.21),('15529','2013-06-30','14:10:00',2.17),('15529','2013-06-30','14:15:00',2.18),('15529','2013-06-30','14:20:00',2.18),('15529','2013-06-30','14:25:00',2.15),('15529','2013-06-30','14:30:00',2.13),('15529','2013-06-30','14:35:00',2.12),('15529','2013-06-30','14:40:00',2.12),('15529','2013-06-30','14:45:00',2.11),('15529','2013-06-30','14:50:00',2.07),('15529','2013-06-30','14:55:00',2.03),('15529','2013-06-30','15:00:00',1.99),('15529','2013-06-30','15:05:00',2),('15529','2013-06-30','15:10:00',1.97),('15529','2013-06-30','15:15:00',1.94),('15529','2013-06-30','15:20:00',1.92),('15529','2013-06-30','15:25:00',1.89),('15529','2013-06-30','15:30:00',1.87),('15529','2013-06-30','15:35:00',1.84),('15529','2013-06-30','15:40:00',1.83),('15529','2013-06-30','15:45:00',1.79),('15529','2013-06-30','15:50:00',1.77),('15529','2013-06-30','15:55:00',1.73),('15529','2013-06-30','16:00:00',1.69),('15529','2013-06-30','16:05:00',1.67),('15529','2013-06-30','16:10:00',1.63),('15529','2013-06-30','16:15:00',1.59),('15529','2013-06-30','16:20:00',1.54),('15529','2013-06-30','16:25:00',1.51),('15529','2013-06-30','16:30:00',1.48),('15529','2013-06-30','16:35:00',1.45),('15529','2013-06-30','16:40:00',1.4),('15529','2013-06-30','16:45:00',1.37),('15529','2013-06-30','16:50:00',1.34),('15529','2013-06-30','16:55:00',1.32),('15529','2013-06-30','17:00:00',1.29),('15529','2013-06-30','17:05:00',1.25),('15529','2013-06-30','17:10:00',1.21),('15529','2013-06-30','17:15:00',1.16),('15529','2013-06-30','17:20:00',1.11),('15529','2013-06-30','17:25:00',1.06),('15529','2013-06-30','17:30:00',1.03),('15529','2014-04-04','09:40:00',1.33),('15529','2014-04-04','09:45:00',1.8),('15529','2014-04-04','09:50:00',1.15),('15529','2014-04-04','09:55:00',1.12),('15529','2014-04-04','10:00:00',1.04),('15529','2014-04-04','10:20:00',1.12),('15529','2014-04-04','10:25:00',1.76),('15529','2014-04-04','10:30:00',1.66),('15529','2014-04-04','10:35:00',1.57),('15529','2014-04-04','10:40:00',1.53),('15529','2014-04-04','10:45:00',1.52),('15529','2014-04-04','10:50:00',1.63),('15529','2014-04-04','10:55:00',1.88),('15529','2014-04-04','11:00:00',1.43),('15529','2014-04-04','11:05:00',1.48),('15529','2014-04-04','11:10:00',1.85),('15529','2014-04-04','11:15:00',1.96),('15529','2014-04-04','11:20:00',1.97),('15529','2014-04-04','11:25:00',2.26),('15529','2014-04-04','11:30:00',2.16),('15529','2014-04-04','11:35:00',1.77),('15529','2014-04-04','11:40:00',1.49),('15529','2014-04-04','11:45:00',1.12),('15529','2014-04-04','11:50:00',1.43),('15529','2014-04-04','11:55:00',1.93),('15529','2014-04-04','12:00:00',2.01),('15529','2014-04-04','12:05:00',2.13),('15529','2014-04-04','12:10:00',2.23),('15529','2014-04-04','12:15:00',1.71),('15529','2014-04-04','12:20:00',1.81),('15529','2014-04-04','12:25:00',2.04),('15529','2014-04-04','12:30:00',1.77),('15529','2014-04-04','12:35:00',1.82),('15529','2014-04-04','12:40:00',1.63),('15529','2014-04-04','12:45:00',1.87),('15529','2014-04-04','12:50:00',2.27),('15529','2014-04-04','12:55:00',2.25),('15529','2014-04-04','13:00:00',1.1),('15529','2014-04-04','13:05:00',1.46),('15529','2014-04-04','13:10:00',1.3),('15529','2014-04-04','13:15:00',1.01),('15529','2014-04-04','13:20:00',1.18),('15529','2014-04-04','13:25:00',1.84),('15529','2014-04-04','13:30:00',1.57),('15529','2014-04-04','13:35:00',2.04),('15529','2014-04-04','13:40:00',2.16),('15529','2014-04-04','13:45:00',2.59),('15529','2014-04-04','13:50:00',2.56),('15529','2014-04-04','13:55:00',2.48),('15529','2014-04-04','14:00:00',2.56),('15529','2014-04-04','14:05:00',2.08),('15529','2014-04-04','14:10:00',1.69),('15529','2014-04-04','15:00:00',2.23),('15529','2014-04-04','15:05:00',2.25),('15529','2014-04-04','15:10:00',2.29),('15529','2014-04-04','15:15:00',2.28),('15529','2014-04-04','15:20:00',1.64),('15529','2014-04-04','15:25:00',1.96),('15529','2014-04-04','15:50:00',1.25),('15529','2014-04-04','16:20:00',1.7),('15529','2014-04-04','16:25:00',2.02),('15529','2014-04-04','16:30:00',1.66),('15529','2014-04-04','16:45:00',1.25),('15529','2014-04-04','16:50:00',1.74),('15529','2014-04-04','16:55:00',1.23),('15529','2014-04-04','17:05:00',1.26),('15529','2013-06-29','08:40:00',1),('15529','2013-06-29','08:45:00',1.05),('15529','2013-06-29','08:50:00',1.1),('15529','2013-06-29','08:55:00',1.14),('15529','2013-06-29','09:00:00',1.18),('15529','2013-06-29','09:05:00',1.23),('15529','2013-06-29','09:10:00',1.26),('15529','2013-06-29','09:15:00',1.3),('15529','2013-06-29','09:20:00',1.35),('15529','2013-06-29','09:25:00',1.38),('15529','2013-06-29','09:30:00',1.42),('15529','2013-06-29','09:35:00',1.46),('15529','2013-06-29','09:40:00',1.5),('15529','2013-06-29','09:45:00',1.53),('15529','2013-06-29','09:50:00',1.57),('15529','2013-06-29','09:55:00',1.61),('15529','2013-06-29','10:00:00',1.64),('15529','2013-06-29','10:05:00',1.67),('15529','2013-06-29','10:10:00',1.7),('15529','2013-06-29','10:15:00',1.74),('15529','2013-06-29','10:20:00',1.76),('15529','2013-06-29','10:25:00',1.79),('15529','2013-06-29','10:30:00',1.84),('15529','2013-06-29','10:35:00',1.85),('15529','2013-06-29','10:40:00',1.86),('15529','2013-06-29','10:45:00',1.89),('15529','2013-06-29','10:50:00',1.94),('15529','2013-06-29','10:55:00',1.96),('15529','2013-06-29','11:00:00',1.99),('15529','2013-06-29','11:05:00',2.01),('15529','2013-06-29','11:10:00',2.03),('15529','2013-06-29','11:15:00',2.05),('15529','2013-06-29','11:20:00',2.06),('15529','2013-06-29','11:25:00',2.09),('15529','2013-06-29','11:30:00',2.11),('15529','2013-06-29','11:35:00',2.13),('15529','2013-06-29','11:40:00',2.15),('15529','2013-06-29','11:45:00',2.17),('15529','2013-06-29','11:50:00',2.17),('15529','2013-06-29','11:55:00',2.16),('15529','2013-06-29','12:00:00',2.19),('15529','2013-06-29','12:05:00',2.24),('15529','2013-06-29','12:10:00',2.26),('15529','2013-06-29','12:15:00',2.23),('15529','2013-06-29','12:20:00',2.21),('15529','2013-06-29','12:25:00',2.23),('15529','2013-06-29','12:30:00',2.27),('15529','2013-06-29','12:35:00',2.24),('15529','2013-06-29','12:40:00',2.26),('15529','2013-06-29','12:45:00',2.26),('15529','2013-06-29','12:50:00',2.26),('15529','2013-06-29','12:55:00',2.26),('15529','2013-06-29','13:00:00',2.27),('15529','2013-06-29','13:05:00',2.34),('15529','2013-06-29','13:10:00',2.3),('15529','2013-06-29','13:15:00',2.31),('15529','2013-06-29','13:20:00',2.31),('15529','2013-06-29','13:25:00',2.31),('15529','2013-06-29','13:30:00',2.3),('15529','2013-06-29','13:35:00',2.28),('15529','2013-06-29','13:40:00',2.27),('15529','2013-06-29','13:45:00',2.27),('15529','2013-06-29','13:50:00',2.26),('15529','2013-06-29','13:55:00',2.27),('15529','2013-06-29','14:00:00',2.1),('15529','2013-06-29','14:05:00',2.22),('15529','2013-06-29','14:10:00',2.1),('15529','2013-06-29','14:15:00',2.2),('15529','2013-06-29','14:20:00',2.16),('15529','2013-06-29','14:25:00',2.16),('15529','2013-06-29','14:30:00',2.13),('15529','2013-06-29','14:35:00',2.11),('15529','2013-06-29','14:40:00',2.13),('15529','2013-06-29','14:45:00',2.1),('15529','2013-06-29','14:50:00',2.06),('15529','2013-06-29','14:55:00',2.05),('15529','2013-06-29','15:00:00',2.04),('15529','2013-06-29','15:05:00',2.05),('15529','2013-06-29','15:10:00',2.03),('15529','2013-06-29','15:15:00',2),('15529','2013-06-29','15:20:00',1.99),('15529','2013-06-29','15:25:00',1.96),('15529','2013-06-29','15:30:00',1.93),('15529','2013-06-29','15:35:00',1.89),('15529','2013-06-29','15:40:00',1.88),('15529','2013-06-29','15:45:00',1.86),('15529','2013-06-29','15:50:00',1.83),('15529','2013-06-29','15:55:00',1.8),('15529','2013-06-29','16:00:00',1.78),('15529','2013-06-29','16:05:00',1.75),('15529','2013-06-29','16:10:00',1.72),('15529','2013-06-29','16:15:00',1.68),('15529','2013-06-29','16:20:00',1.65),('15529','2013-06-29','16:25:00',1.6),('15529','2013-06-29','16:30:00',1.58),('15529','2013-06-29','16:35:00',1.51),('15529','2013-06-29','16:40:00',1.5),('15529','2013-06-29','16:45:00',1.45),('15529','2013-06-29','16:50:00',1.4),('15529','2013-06-29','16:55:00',1.35),('15529','2013-06-29','17:00:00',1.29),('15529','2013-06-29','17:05:00',1.25),('15529','2013-06-29','17:10:00',1.22),('15529','2013-06-29','17:15:00',1.18),('15529','2013-06-29','17:20:00',1.14),('15529','2013-06-29','17:25:00',1.09),('15529','2013-06-29','17:30:00',1.03),('15529','2013-06-28','08:45:00',1.07),('15529','2013-06-28','08:50:00',1.09),('15529','2013-06-28','08:55:00',1.13),('15529','2013-06-28','09:00:00',1.17),('15529','2013-06-28','09:05:00',1.21),('15529','2013-06-28','09:10:00',1.24),('15529','2013-06-28','09:15:00',1.28),('15529','2013-06-28','09:20:00',1.32),('15529','2013-06-28','09:25:00',1.37),('15529','2013-06-28','09:30:00',1.41),('15529','2013-06-28','09:35:00',1.44),('15529','2013-06-28','09:40:00',1.48),('15529','2013-06-28','09:45:00',1.52),('15529','2013-06-28','09:50:00',1.55),('15529','2013-06-28','09:55:00',1.58),('15529','2013-06-28','10:00:00',1.6),('15529','2013-06-28','10:05:00',1.63),('15529','2013-06-28','10:10:00',1.67),('15529','2013-06-28','10:15:00',1.7),('15529','2013-06-28','10:20:00',1.71),('15529','2013-06-28','10:25:00',1.77),('15529','2013-06-28','10:30:00',1.81),('15529','2013-06-28','10:35:00',1.81),('15529','2013-06-28','10:40:00',1.82),('15529','2013-06-28','10:45:00',1.89),('15529','2013-06-28','10:50:00',1.94),('15529','2013-06-28','10:55:00',2),('15529','2013-06-28','11:00:00',2.06),('15529','2013-06-28','11:05:00',2.14),('15529','2013-06-28','11:10:00',1.53),('15529','2013-06-28','11:15:00',2.19),('15529','2013-06-28','11:20:00',1.41),('15529','2013-06-28','11:25:00',1.22),('15529','2013-06-28','11:30:00',1.1),('15529','2013-06-28','11:45:00',1.96),('15529','2013-06-28','11:50:00',2.23),('15529','2013-06-28','11:55:00',1.15),('15529','2013-06-28','12:00:00',1.31),('15529','2013-06-28','12:05:00',1.22),('15529','2013-06-28','12:10:00',2.45),('15529','2013-06-28','12:15:00',1.5),('15529','2013-06-28','12:25:00',1.17),('15529','2013-06-28','12:30:00',2.04),('15529','2013-06-28','12:35:00',2.41),('15529','2013-06-28','12:40:00',1.91),('15529','2013-06-28','12:45:00',1.77),('15529','2013-06-28','13:00:00',2.42),('15529','2013-06-28','13:05:00',1.31),('15529','2013-06-28','13:15:00',2.59),('15529','2013-06-28','13:20:00',1.26),('15529','2013-06-28','13:40:00',1.11),('15529','2013-06-28','13:45:00',2.07),('15529','2013-06-28','13:55:00',2.33),('15529','2013-06-28','14:00:00',2.36),('15529','2013-06-28','14:05:00',2.34),('15529','2013-06-28','14:10:00',2.31),('15529','2013-06-28','14:15:00',2.38),('15529','2013-06-28','14:20:00',2.18),('15529','2013-06-28','14:25:00',2.18),('15529','2013-06-28','14:30:00',2.29),('15529','2013-06-28','14:35:00',2.27),('15529','2013-06-28','14:40:00',2.32),('15529','2013-06-28','14:45:00',2.27),('15529','2013-06-28','14:50:00',2.31),('15529','2013-06-28','14:55:00',2.44),('15529','2013-06-28','15:00:00',2.48),('15529','2013-06-28','15:05:00',2.31),('15529','2013-06-28','15:10:00',1.19),('15529','2013-06-28','15:15:00',1.52),('15529','2013-06-28','15:20:00',1.18),('15529','2013-06-28','17:20:00',1.38),('15529','2013-06-28','17:25:00',1.04),('15529','2013-06-28','17:30:00',1.23),('15529','2013-06-27','08:45:00',1.03),('15529','2013-06-27','08:50:00',1.09),('15529','2013-06-27','08:55:00',1.09),('15529','2013-06-27','09:00:00',1.19),('15529','2013-06-27','09:05:00',1.22),('15529','2013-06-27','09:10:00',1.29),('15529','2013-06-27','09:20:00',1.16),('15529','2013-06-27','09:25:00',1.25),('15529','2013-06-27','09:30:00',1.5),('15529','2013-06-27','09:35:00',1.56),('15529','2013-06-27','09:40:00',1),('15529','2013-06-27','09:45:00',1.08),('15529','2013-06-27','09:50:00',1.01),('15529','2013-06-27','09:55:00',1.73),('15529','2013-06-27','10:00:00',1.78),('15529','2013-06-27','10:05:00',1.82),('15529','2013-06-27','10:10:00',1.9),('15529','2013-06-27','10:15:00',2),('15529','2013-06-27','10:20:00',1.97),('15529','2013-06-27','10:55:00',1.14),('15529','2013-06-27','11:00:00',1.91),('15529','2013-06-27','11:05:00',1.15),('15529','2013-06-27','11:15:00',1.12),('15529','2013-06-27','11:20:00',1.03),('15529','2013-06-27','11:25:00',1.95),('15529','2013-06-27','11:30:00',1.56),('15529','2013-06-27','11:35:00',1.03),('15529','2013-06-27','11:40:00',2.21),('15529','2013-06-27','11:45:00',2.35),('15529','2013-06-27','11:50:00',1.87),('15529','2013-06-27','11:55:00',2.44),('15529','2013-06-27','12:00:00',1.98),('15529','2013-06-27','12:05:00',1.3),('15529','2013-06-27','12:10:00',2.15),('15529','2013-06-27','12:15:00',2.03),('15529','2013-06-27','12:20:00',2.25),('15529','2013-06-27','12:25:00',2.16),('15529','2013-06-27','12:30:00',2.11),('15529','2013-06-27','12:35:00',2.19),('15529','2013-06-27','12:40:00',2.33),('15529','2013-06-27','12:45:00',2.33),('15529','2013-06-27','12:50:00',2.31),('15529','2013-06-27','12:55:00',2.26),('15529','2013-06-27','13:00:00',2.35),('15529','2013-06-27','13:05:00',2.38),('15529','2013-06-27','13:10:00',2.36),('15529','2013-06-27','13:15:00',2.23),('15529','2013-06-27','13:20:00',2.33),('15529','2013-06-27','13:25:00',2.32),('15529','2013-06-27','13:30:00',2.32),('15529','2013-06-27','13:35:00',2.35),('15529','2013-06-27','13:40:00',2.09),('15529','2013-06-27','13:45:00',1.78),('15529','2013-06-27','13:50:00',1.77),('15529','2013-06-27','13:55:00',1.78),('15529','2013-06-27','14:00:00',1.83),('15529','2013-06-27','14:05:00',2.05),('15529','2013-06-27','14:10:00',1.64),('15529','2013-06-27','14:15:00',1.99),('15529','2013-06-27','14:20:00',2.28),('15529','2013-06-27','14:25:00',2.38),('15529','2013-06-27','14:30:00',2.3),('15529','2013-06-27','14:35:00',2.17),('15529','2013-06-27','14:45:00',1.37),('15529','2013-06-27','14:50:00',2.02),('15529','2013-06-27','14:55:00',1.53),('15529','2013-06-27','15:00:00',2.06),('15529','2013-06-27','15:05:00',1.89),('15529','2013-06-27','15:10:00',1.16),('15529','2013-06-27','15:15:00',1.5),('15529','2013-06-27','15:20:00',1.59),('15529','2013-06-27','15:25:00',1.31),('15529','2013-06-27','15:30:00',1.23),('15529','2013-06-27','15:35:00',1.47),('15529','2013-06-27','15:40:00',1.26),('15529','2013-06-27','15:45:00',2.04),('15529','2013-06-27','15:50:00',1.49),('15529','2013-06-27','15:55:00',1.62),('15529','2013-06-27','16:00:00',1.05),('15529','2013-06-27','16:05:00',1.7),('15529','2013-06-27','16:10:00',1.58),('15529','2013-06-27','16:15:00',1.26),('15529','2013-06-27','16:20:00',1.7),('15529','2013-06-27','16:25:00',1),('15529','2013-06-27','16:30:00',1.14),('15529','2013-06-27','16:35:00',1.22),('15529','2013-06-27','16:40:00',1.17),('15529','2013-06-27','16:55:00',1.48),('15529','2013-06-27','17:00:00',1.42),('15529','2013-06-27','17:05:00',1.03),('15529','2013-06-27','17:10:00',1.29),('15529','2013-06-27','17:15:00',1.2),('15529','2013-06-27','17:20:00',1.15),('15529','2013-06-27','17:25:00',1.11),('15529','2013-06-27','17:30:00',1.07),('15529','2013-06-27','17:35:00',1.02),('15529','2013-06-26','08:45:00',1.01),('15529','2013-06-26','08:50:00',1.11),('15529','2013-06-26','08:55:00',1.24),('15529','2013-06-26','09:00:00',1.18),('15529','2013-06-26','09:05:00',1.23),('15529','2013-06-26','09:10:00',1.19),('15529','2013-06-26','09:15:00',1.31),('15529','2013-06-26','09:20:00',1.38),('15529','2013-06-26','09:25:00',1.44),('15529','2013-06-26','09:30:00',1.49),('15529','2013-06-26','09:35:00',1.53),('15529','2013-06-26','09:40:00',1.53),('15529','2013-06-26','09:45:00',1.56),('15529','2013-06-26','09:50:00',1.58),('15529','2013-06-26','09:55:00',1.55),('15529','2013-06-26','10:00:00',1.61),('15529','2013-06-26','10:10:00',1.69),('15529','2013-06-26','10:15:00',1.78),('15529','2013-06-26','10:20:00',1.76),('15529','2013-06-26','10:25:00',1.79),('15529','2013-06-26','10:30:00',1.9),('15529','2013-06-26','10:35:00',2.05),('15529','2013-06-26','10:40:00',2.02),('15529','2013-06-26','10:45:00',1.38),('15529','2013-06-26','10:50:00',2.11),('15529','2013-06-26','10:55:00',2.12),('15529','2013-06-26','11:00:00',1.64),('15529','2013-06-26','11:10:00',1.49),('15529','2013-06-26','11:15:00',2.13),('15529','2013-06-26','11:20:00',2.2),('15529','2013-06-26','11:25:00',1.83),('15529','2013-06-26','11:30:00',1.5),('15529','2013-06-26','11:35:00',2.36),('15529','2013-06-26','11:40:00',1.54),('15529','2013-06-26','12:00:00',2.09),('15529','2013-06-26','12:15:00',1.35),('15529','2013-06-26','12:20:00',1.13),('15529','2013-06-26','13:45:00',1.21),('15529','2013-06-26','13:50:00',1.03),('15529','2013-06-26','14:00:00',2.02),('15529','2013-06-26','14:05:00',1.68),('15529','2013-06-26','14:10:00',2.29),('15529','2013-06-26','14:15:00',2.27),('15529','2013-06-26','14:20:00',2.22),('15529','2013-06-26','14:25:00',1.8),('15529','2013-06-26','14:30:00',2.38),('15529','2013-06-26','14:35:00',2.25),('15529','2013-06-26','14:40:00',2.2),('15529','2013-06-26','14:45:00',2.12),('15529','2013-06-26','14:50:00',2.08),('15529','2013-06-26','14:55:00',2.04),('15529','2013-06-26','15:00:00',1.99),('15529','2013-06-26','15:05:00',1.97),('15529','2013-06-26','15:10:00',1.96),('15529','2013-06-26','15:15:00',1.94),('15529','2013-06-26','15:20:00',1.93),('15529','2013-06-26','15:25:00',1.89),('15529','2013-06-26','15:30:00',1.87),('15529','2013-06-26','15:35:00',1.84),('15529','2013-06-26','15:40:00',1.8),('15529','2013-06-26','15:45:00',1.78),('15529','2013-06-26','15:50:00',1.78),('15529','2013-06-26','15:55:00',1.72),('15529','2013-06-26','16:00:00',1.68),('15529','2013-06-26','16:05:00',1.65),('15529','2013-06-26','16:10:00',1.62),('15529','2013-06-26','16:15:00',1.62),('15529','2013-06-26','16:20:00',1.59),('15529','2013-06-26','16:25:00',1.55),('15529','2013-06-26','16:30:00',1.51),('15529','2013-06-26','16:35:00',1.38),('15529','2013-06-26','16:40:00',1.42),('15529','2013-06-26','16:45:00',1.41),('15529','2013-06-26','16:50:00',1.34),('15529','2013-06-26','16:55:00',1.31),('15529','2013-06-26','17:00:00',1.27),('15529','2013-06-26','17:05:00',1.21),('15529','2013-06-26','17:10:00',1.15),('15529','2013-06-26','17:15:00',1.14),('15529','2013-06-26','17:20:00',1.15),('15529','2013-06-26','17:25:00',1.09),('15529','2013-06-26','17:30:00',1.05),('15529','2013-06-25','08:45:00',1.03),('15529','2013-06-25','08:50:00',1.07),('15529','2013-06-25','08:55:00',1.11),('15529','2013-06-25','09:00:00',1.16),('15529','2013-06-25','09:05:00',1.19),('15529','2013-06-25','09:10:00',1.24),('15529','2013-06-25','09:15:00',1.27),('15529','2013-06-25','09:20:00',1.31),('15529','2013-06-25','09:25:00',1.35),('15529','2013-06-25','09:30:00',1.38),('15529','2013-06-25','09:35:00',1.4),('15529','2013-06-25','09:40:00',1.44),('15529','2013-06-25','09:45:00',1.48),('15529','2013-06-25','09:50:00',1.51),('15529','2013-06-25','09:55:00',1.54),('15529','2013-06-25','10:00:00',1.57),('15529','2013-06-25','10:05:00',1.61),('15529','2013-06-25','10:10:00',1.66),('15529','2013-06-25','10:15:00',1.7),('15529','2013-06-25','10:20:00',1.73),('15529','2013-06-25','10:25:00',1.76),('15529','2013-06-25','10:30:00',1.76),('15529','2013-06-25','10:35:00',1.8),('15529','2013-06-25','10:40:00',1.82),('15529','2013-06-25','10:45:00',1.84),('15529','2013-06-25','10:50:00',1.86),('15529','2013-06-25','10:55:00',1.9),('15529','2013-06-25','11:00:00',1.91),('15529','2013-06-25','11:05:00',1.93),('15529','2013-06-25','11:10:00',1.97),('15529','2013-06-25','11:15:00',1.98),('15529','2013-06-25','11:20:00',2.02),('15529','2013-06-25','11:25:00',2.03),('15529','2013-06-25','11:30:00',2.05),('15529','2013-06-25','11:35:00',2.06),('15529','2013-06-25','11:40:00',2.09),('15529','2013-06-25','11:45:00',2.13),('15529','2013-06-25','11:50:00',2.15),('15529','2013-06-25','11:55:00',2.15),('15529','2013-06-25','12:00:00',2.15),('15529','2013-06-25','12:05:00',2.18),('15529','2013-06-25','12:10:00',2.2),('15529','2013-06-25','12:15:00',2.18),('15529','2013-06-25','12:20:00',2.16),('15529','2013-06-25','12:25:00',2.19),('15529','2013-06-25','12:30:00',2.19),('15529','2013-06-25','12:35:00',2.24),('15529','2013-06-25','12:40:00',2.26),('15529','2013-06-25','12:45:00',2.25),('15529','2013-06-25','12:50:00',2.34),('15529','2013-06-25','12:55:00',2.31),('15529','2013-06-25','13:00:00',2.25),('15529','2013-06-25','13:05:00',2.14),('15529','2013-06-25','13:10:00',1.39),('15529','2013-06-25','13:35:00',1.01),('15529','2013-06-25','13:40:00',2.45),('15529','2013-06-25','13:45:00',2.43),('15529','2013-06-25','13:50:00',2.33),('15529','2013-06-25','13:55:00',2.31),('15529','2013-06-25','14:00:00',2.26),('15529','2013-06-25','14:05:00',2.24),('15529','2013-06-25','14:10:00',2.22),('15529','2013-06-25','14:15:00',2.19),('15529','2013-06-25','14:20:00',2.18),('15529','2013-06-25','14:25:00',2.22),('15529','2013-06-25','14:30:00',2.24),('15529','2013-06-25','14:35:00',2.18),('15529','2013-06-25','14:40:00',2.18),('15529','2013-06-25','14:45:00',2.14),('15529','2013-06-25','14:50:00',2.11),('15529','2013-06-25','14:55:00',2.08),('15529','2013-06-25','15:00:00',2.02),('15529','2013-06-25','15:05:00',2.02),('15529','2013-06-25','15:10:00',1.98),('15529','2013-06-25','15:15:00',1.95),('15529','2013-06-25','15:20:00',1.93),('15529','2013-06-25','15:25:00',1.9),('15529','2013-06-25','15:30:00',1.9),('15529','2013-06-25','15:35:00',1.9),('15529','2013-06-25','15:40:00',1.9),('15529','2013-06-25','15:45:00',1.83),('15529','2013-06-25','15:50:00',1.79),('15529','2013-06-25','15:55:00',1.74),('15529','2013-06-25','16:00:00',1.71),('15529','2013-06-25','16:05:00',1.68),('15529','2013-06-25','16:10:00',1.66),('15529','2013-06-25','16:15:00',1.64),('15529','2013-06-25','16:20:00',1.6),('15529','2013-06-25','16:25:00',1.57),('15529','2013-06-25','16:30:00',1.53),('15529','2013-06-25','16:35:00',1.48),('15529','2013-06-25','16:40:00',1.45),('15529','2013-06-25','16:45:00',1.42),('15529','2013-06-25','16:50:00',1.38),('15529','2013-06-25','16:55:00',1.34),('15529','2013-06-25','17:00:00',1.31),('15529','2013-06-25','17:05:00',1.27),('15529','2013-06-25','17:10:00',1.22),('15529','2013-06-25','17:15:00',1.18),('15529','2013-06-25','17:20:00',1.13),('15529','2013-06-25','17:25:00',1.09),('15529','2013-06-25','17:30:00',1.03),('15529','2013-06-24','08:45:00',1.05),('15529','2013-06-24','08:50:00',1.08),('15529','2013-06-24','08:55:00',1.13),('15529','2013-06-24','09:00:00',1.18),('15529','2013-06-24','09:05:00',1.21),('15529','2013-06-24','09:10:00',1.24),('15529','2013-06-24','09:15:00',1.3),('15529','2013-06-24','09:20:00',1.34),('15529','2013-06-24','09:25:00',1.38),('15529','2013-06-24','09:30:00',1.44),('15529','2013-06-24','09:45:00',1.36),('15529','2013-06-24','10:05:00',1.19),('15529','2013-06-24','10:10:00',1.36),('15529','2013-06-24','10:20:00',1.27),('15529','2013-06-24','10:25:00',1.54),('15529','2013-06-24','10:35:00',1.51),('15529','2013-06-24','10:40:00',2.07),('15529','2013-06-24','10:45:00',2.05),('15529','2013-06-24','10:50:00',2.09),('15529','2013-06-24','10:55:00',2.09),('15529','2013-06-24','11:00:00',2.07),('15529','2013-06-24','11:05:00',2.07),('15529','2013-06-24','11:10:00',2.19),('15529','2013-06-24','11:15:00',2.22),('15529','2013-06-24','11:20:00',2.23),('15529','2013-06-24','11:40:00',1.11),('15529','2013-06-24','11:45:00',2.36),('15529','2013-06-24','11:50:00',2),('15529','2013-06-24','12:30:00',2.54),('15529','2013-06-24','12:35:00',1.25),('15529','2013-06-24','12:40:00',1.91),('15529','2013-06-24','12:45:00',1.26),('15529','2013-06-24','12:50:00',2.34),('15529','2013-06-24','12:55:00',2.42),('15529','2013-06-24','13:00:00',2.41),('15529','2013-06-24','13:05:00',2.41),('15529','2013-06-24','13:10:00',2.02),('15529','2013-06-24','13:15:00',2.49),('15529','2013-06-24','13:20:00',2.37),('15529','2013-06-24','13:25:00',2.45),('15529','2013-06-24','13:30:00',1.94),('15529','2013-06-24','13:35:00',2.33),('15529','2013-06-24','13:40:00',2.3),('15529','2013-06-24','13:45:00',2.3),('15529','2013-06-24','13:50:00',2.3),('15529','2013-06-24','13:55:00',2.26),('15529','2013-06-24','14:00:00',2.23),('15529','2013-06-24','14:05:00',2.23),('15529','2013-06-24','14:10:00',2.22),('15529','2013-06-24','14:15:00',2.2),('15529','2013-06-24','14:20:00',2.17),('15529','2013-06-24','14:25:00',2.17),('15529','2013-06-24','14:30:00',2.16),('15529','2013-06-24','14:35:00',2.16),('15529','2013-06-24','14:40:00',2.13),('15529','2013-06-24','14:45:00',2.09),('15529','2013-06-24','14:50:00',2.11),('15529','2013-06-24','14:55:00',2.05),('15529','2013-06-24','15:00:00',2.05),('15529','2013-06-24','15:05:00',2),('15529','2013-06-24','15:10:00',1.99),('15529','2013-06-24','15:15:00',1.99),('15529','2013-06-24','15:20:00',1.96),('15529','2013-06-24','15:25:00',1.92),('15529','2013-06-24','15:30:00',1.9),('15529','2013-06-24','15:35:00',1.86),('15529','2013-06-24','15:40:00',1.83),('15529','2013-06-24','15:45:00',1.81),('15529','2013-06-24','15:50:00',1.77),('15529','2013-06-24','15:55:00',1.74),('15529','2013-06-24','16:00:00',1.72),('15529','2013-06-24','16:05:00',1.68),('15529','2013-06-24','16:10:00',1.65),('15529','2013-06-24','16:15:00',1.62),('15529','2013-06-24','16:20:00',1.61),('15529','2013-06-24','16:25:00',1.55),('15529','2013-06-24','16:30:00',1.52),('15529','2013-06-24','16:35:00',1.49),('15529','2013-06-24','16:40:00',1.43),('15529','2013-06-24','16:45:00',1.41),('15529','2013-06-24','16:50:00',1.36),('15529','2013-06-24','16:55:00',1.32),('15529','2013-06-24','17:00:00',1.29),('15529','2013-06-24','17:05:00',1.24),('15529','2013-06-24','17:10:00',1.21),('15529','2013-06-24','17:15:00',1.17),('15529','2013-06-24','17:20:00',1.13),('15529','2013-06-24','17:25:00',1.07),('15529','2013-06-24','17:30:00',1.03),('15529','2013-06-23','08:45:00',1.08),('15529','2013-06-23','08:50:00',1.15),('15529','2013-06-23','09:00:00',1.2),('15529','2013-06-23','09:10:00',1.17),('15529','2013-06-23','09:15:00',1.48),('15529','2013-06-23','09:20:00',1.06),('15529','2013-06-23','09:35:00',1.49),('15529','2013-06-23','09:40:00',1.07),('15529','2013-06-23','09:50:00',1.5),('15529','2013-06-23','09:55:00',1.69),('15529','2013-06-23','10:00:00',1.73),('15529','2013-06-23','10:05:00',1.81),('15529','2013-06-23','10:10:00',1.17),('15529','2013-06-23','10:15:00',1.95),('15529','2013-06-23','10:20:00',2),('15529','2013-06-23','10:25:00',1.67),('15529','2013-06-23','10:30:00',1.33),('15529','2013-06-23','10:35:00',1),('15529','2013-06-23','10:45:00',2.34),('15529','2013-06-23','10:50:00',1.36),('15529','2013-06-23','10:55:00',1.41),('15529','2013-06-23','11:00:00',2.24),('15529','2013-06-23','11:05:00',1.68),('15529','2013-06-23','11:10:00',1.52),('15529','2013-06-23','11:15:00',1.47),('15529','2013-06-23','11:20:00',1.04),('15529','2013-06-23','11:25:00',1.56),('15529','2013-06-23','11:45:00',1.13),('15529','2013-06-23','11:50:00',1.78),('15529','2013-06-23','11:55:00',1.54),('15529','2013-06-23','12:00:00',1.52),('15529','2013-06-23','12:05:00',2.4),('15529','2013-06-23','12:10:00',1.88),('15529','2013-06-23','12:15:00',2.13),('15529','2013-06-23','12:20:00',1.14),('15529','2013-06-23','12:25:00',1.29),('15529','2013-06-23','12:30:00',2.35),('15529','2013-06-23','12:35:00',2.37),('15529','2013-06-23','12:40:00',2.04),('15529','2013-06-23','12:45:00',2.63),('15529','2013-06-23','12:50:00',2.64),('15529','2013-06-23','12:55:00',2.01),('15529','2013-06-23','13:00:00',2.39),('15529','2013-06-23','13:05:00',2.01),('15529','2013-06-23','13:10:00',2.12),('15529','2013-06-23','13:15:00',1.99),('15529','2013-06-23','13:20:00',2.39),('15529','2013-06-23','13:25:00',1.94),('15529','2013-06-23','13:30:00',2.32),('15529','2013-06-23','13:35:00',2.39),('15529','2013-06-23','13:40:00',2.41),('15529','2013-06-23','13:45:00',2.39),('15529','2013-06-23','13:50:00',2.09),('15529','2013-06-23','13:55:00',2.27),('15529','2013-06-23','14:00:00',2.33),('15529','2013-06-23','14:05:00',2.29),('15529','2013-06-23','14:10:00',2.27),('15529','2013-06-23','14:15:00',2.29),('15529','2013-06-23','14:20:00',2.31),('15529','2013-06-23','14:25:00',2.34),('15529','2013-06-23','14:30:00',2.29),('15529','2013-06-23','14:35:00',2.31),('15529','2013-06-23','14:40:00',2.34),('15529','2013-06-23','14:45:00',2.32),('15529','2013-06-23','14:50:00',2.13),('15529','2013-06-23','14:55:00',1.77),('15529','2013-06-23','15:00:00',1.87),('15529','2013-06-23','15:05:00',1.4),('15529','2013-06-23','15:10:00',2.28),('15529','2013-06-23','15:15:00',2.11),('15529','2013-06-23','15:20:00',1.45),('15529','2013-06-23','15:25:00',1.68),('15529','2013-06-23','15:40:00',1.25),('15529','2013-06-23','15:45:00',1.31),('15529','2013-06-23','15:50:00',1.26),('15529','2013-06-23','15:55:00',1.33),('15529','2013-06-23','16:00:00',1.39),('15529','2013-06-23','16:05:00',1.17),('15529','2013-06-23','16:10:00',2.06),('15529','2013-06-23','16:15:00',1.49),('15529','2013-06-23','16:20:00',1.62),('15529','2013-06-23','16:25:00',1.68),('15529','2013-06-23','16:30:00',1.15),('15529','2013-06-23','16:35:00',1.06),('15529','2013-06-23','16:40:00',1.31),('15529','2013-06-23','16:45:00',1.22),('15529','2013-06-23','17:00:00',1.17),('15529','2013-06-23','17:05:00',1.22),('15529','2013-06-23','17:25:00',1.05),('15529','2013-06-22','09:25:00',1.39),('15529','2013-06-22','09:30:00',1.43),('15529','2013-06-22','09:35:00',1.54),('15529','2013-06-22','09:40:00',1.3),('15529','2013-06-22','10:00:00',1.42),('15529','2013-06-22','10:05:00',1.17),('15529','2013-06-22','10:10:00',1.42),('15529','2013-06-22','10:15:00',1.66),('15529','2013-06-22','10:20:00',1.76),('15529','2013-06-22','10:25:00',1.77),('15529','2013-06-22','10:30:00',1.82),('15529','2013-06-22','10:35:00',1.81),('15529','2013-06-22','10:40:00',1.84),('15529','2013-06-22','10:45:00',1.85),('15529','2013-06-22','10:50:00',1.86),('15529','2013-06-22','10:55:00',1.87),('15529','2013-06-22','11:00:00',1.91),('15529','2013-06-22','11:05:00',1.93),('15529','2013-06-22','11:10:00',1.96),('15529','2013-06-22','11:15:00',1.93),('15529','2013-06-22','11:20:00',1.83),('15529','2013-06-22','11:25:00',1.99),('15529','2013-06-22','11:30:00',2.01),('15529','2013-06-22','11:35:00',2.05),('15529','2013-06-22','11:40:00',2.06),('15529','2013-06-22','11:45:00',2.09),('15529','2013-06-22','11:50:00',2.11),('15529','2013-06-22','11:55:00',2.1),('15529','2013-06-22','12:00:00',2.09),('15529','2013-06-22','12:05:00',2.09),('15529','2013-06-22','12:10:00',2.12),('15529','2013-06-22','12:15:00',2.09),('15529','2013-06-22','12:20:00',2.17),('15529','2013-06-22','12:25:00',2.18),('15529','2013-06-22','12:30:00',2.17),('15529','2013-06-22','12:35:00',2.25),('15529','2013-06-22','12:40:00',2.28),('15529','2013-06-22','12:45:00',2.17),('15529','2013-06-22','12:50:00',2.22),('15529','2013-06-22','12:55:00',2.27),('15529','2013-06-22','13:00:00',2.19),('15529','2013-06-22','13:05:00',2.21),('15529','2013-06-22','13:10:00',2.21),('15529','2013-06-22','13:15:00',2.22),('15529','2013-06-22','13:20:00',2.15),('15529','2013-06-22','13:25:00',2.23),('15529','2013-06-22','13:30:00',2.22),('15529','2013-06-22','13:35:00',2.23),('15529','2013-06-22','13:40:00',2.21),('15529','2013-06-22','13:45:00',2.23),('15529','2013-06-22','13:50:00',2.15),('15529','2013-06-22','13:55:00',2.24),('15529','2013-06-22','14:00:00',2.25),('15529','2013-06-22','14:05:00',2.21),('15529','2013-06-22','14:10:00',2.19),('15529','2013-06-22','14:15:00',2.23),('15529','2013-06-22','14:20:00',2.2),('15529','2013-06-22','14:25:00',2.2),('15529','2013-06-22','14:30:00',2.2),('15529','2013-06-22','14:35:00',2.2),('15529','2013-06-22','14:40:00',2.17),('15529','2013-06-22','14:45:00',2.15),('15529','2013-06-22','14:50:00',2.12),('15529','2013-06-22','14:55:00',2.1),('15529','2013-06-22','15:00:00',2.06),('15529','2013-06-22','15:05:00',2.08),('15529','2013-06-22','15:10:00',2.02),('15529','2013-06-22','15:15:00',2.01),('15529','2013-06-22','15:20:00',1.98),('15529','2013-06-22','15:25:00',1.98),('15529','2013-06-22','15:30:00',1.96),('15529','2013-06-22','15:35:00',1.92),('15529','2013-06-22','15:40:00',1.87),('15529','2013-06-22','15:45:00',1.83),('15529','2013-06-22','15:50:00',1.8),('15529','2013-06-22','15:55:00',1.8),('15529','2013-06-22','16:00:00',1.76),('15529','2013-06-22','16:05:00',1.73),('15529','2013-06-22','16:10:00',1.68),('15529','2013-06-22','16:15:00',1.66),('15529','2013-06-22','16:20:00',1.63),('15529','2013-06-22','16:25:00',1.59),('15529','2013-06-22','16:30:00',1.53),('15529','2013-06-22','16:35:00',1.5),('15529','2013-06-22','16:40:00',1.47),('15529','2013-06-22','16:45:00',1.44),('15529','2013-06-22','16:50:00',1.41),('15529','2013-06-22','16:55:00',1.38),('15529','2013-06-22','17:00:00',1.34),('15529','2013-06-22','17:05:00',1.27),('15529','2013-06-22','17:10:00',1.24),('15529','2013-06-22','17:15:00',1.2),('15529','2013-06-22','17:20:00',1.16),('15529','2013-06-22','17:25:00',1.11),('15529','2013-06-22','17:30:00',1.07),('15529','2013-06-22','17:35:00',1.03),('15529','2013-06-21','08:50:00',1.03),('15529','2013-06-21','08:55:00',1.06),('15529','2013-06-21','09:00:00',1.09),('15529','2013-06-21','09:05:00',1.14),('15529','2013-06-21','09:10:00',1.18),('15529','2013-06-21','09:15:00',1.22),('15529','2013-06-21','09:20:00',1.25),('15529','2013-06-21','09:25:00',1.28),('15529','2013-06-21','09:30:00',1.33),('15529','2013-06-21','09:35:00',1.37),('15529','2013-06-21','09:40:00',1.41),('15529','2013-06-21','09:45:00',1.44),('15529','2013-06-21','09:50:00',1.48),('15529','2013-06-21','09:55:00',1.51),('15529','2013-06-21','10:00:00',1.54),('15529','2013-06-21','10:05:00',1.57),('15529','2013-06-21','10:10:00',1.6),('15529','2013-06-21','10:15:00',1.64),('15529','2013-06-21','10:20:00',1.67),('15529','2013-06-21','10:25:00',1.69),('15529','2013-06-21','10:30:00',1.71),('15529','2013-06-21','10:35:00',1.77),('15529','2013-06-21','10:40:00',1.77),('15529','2013-06-21','10:45:00',1.82),('15529','2013-06-21','10:50:00',1.83),('15529','2013-06-21','10:55:00',1.85),('15529','2013-06-21','11:00:00',1.9),('15529','2013-06-21','11:05:00',1.92),('15529','2013-06-21','11:10:00',1.95),('15529','2013-06-21','11:15:00',1.96),('15529','2013-06-21','11:20:00',1.98),('15529','2013-06-21','11:25:00',2),('15529','2013-06-21','11:30:00',2),('15529','2013-06-21','11:35:00',2.03),('15529','2013-06-21','11:40:00',2.04),('15529','2013-06-21','11:45:00',2.07),('15529','2013-06-21','11:50:00',2.04),('15529','2013-06-21','11:55:00',2.07),('15529','2013-06-21','12:00:00',2.12),('15529','2013-06-21','12:05:00',2.04),('15529','2013-06-21','12:10:00',2.1),('15529','2013-06-21','12:15:00',2.12),('15529','2013-06-21','12:20:00',2.1),('15529','2013-06-21','12:25:00',2.14),('15529','2013-06-21','12:30:00',2.15),('15529','2013-06-21','12:35:00',2.19),('15529','2013-06-21','12:40:00',2.17),('15529','2013-06-21','12:45:00',2.13),('15529','2013-06-21','12:50:00',2.13),('15529','2013-06-21','12:55:00',2.11),('15529','2013-06-21','13:00:00',2.09),('15529','2013-06-21','13:05:00',2.11),('15529','2013-06-21','13:10:00',2.06),('15529','2013-06-21','13:15:00',2.08),('15529','2013-06-21','13:20:00',2.21),('15529','2013-06-21','13:25:00',2.28),('15529','2013-06-21','13:30:00',2.25),('15529','2013-06-21','13:35:00',2.26),('15529','2013-06-21','13:40:00',1.96),('15529','2013-06-21','13:45:00',2.3),('15529','2013-06-21','13:50:00',2.08),('15529','2013-06-21','13:55:00',1.02),('15529','2013-06-21','14:00:00',2.04),('15529','2013-06-21','14:05:00',2.38),('15529','2013-06-21','14:10:00',2.32),('15529','2013-06-21','14:15:00',2.05),('15529','2013-06-21','14:20:00',1.94),('15529','2013-06-21','14:25:00',1.9),('15529','2013-06-21','14:30:00',1.2),('15529','2013-06-21','14:35:00',1.02),('15529','2013-06-21','14:45:00',1.4),('15529','2013-06-21','14:50:00',1.96),('15529','2013-06-21','14:55:00',2),('15529','2013-06-21','15:00:00',2),('15529','2013-06-21','15:05:00',1.56),('15529','2013-06-21','15:10:00',2.16),('15529','2013-06-21','15:15:00',2.08),('15529','2013-06-21','15:20:00',1.85),('15529','2013-06-21','15:25:00',1.59),('15529','2013-06-21','15:30:00',1.44),('15529','2013-06-21','15:35:00',1.25),('15529','2013-06-21','15:40:00',1.8),('15529','2013-06-21','15:45:00',1.53),('15529','2013-06-21','15:50:00',1.21),('15529','2013-06-21','15:55:00',1.2),('15529','2013-06-21','17:10:00',1.16),('15529','2013-06-21','17:15:00',1.32),('15529','2013-06-21','17:20:00',1.35),('15529','2013-06-21','17:25:00',1.3),('15529','2013-06-21','17:30:00',1.16),('15529','2013-06-21','17:40:00',1),('15529','2013-06-20','08:55:00',1.03),('15529','2013-06-20','09:00:00',1.06),('15529','2013-06-20','09:05:00',1.1),('15529','2013-06-20','09:10:00',1.14),('15529','2013-06-20','09:15:00',1.18),('15529','2013-06-20','09:20:00',1.21),('15529','2013-06-20','09:25:00',1.24),('15529','2013-06-20','09:30:00',1.27),('15529','2013-06-20','09:35:00',1.29),('15529','2013-06-20','09:40:00',1.33),('15529','2013-06-20','09:45:00',1.37),('15529','2013-06-20','09:50:00',1.4),('15529','2013-06-20','09:55:00',1.43),('15529','2013-06-20','10:00:00',1.45),('15529','2013-06-20','10:05:00',1.47),('15529','2013-06-20','10:10:00',1.51),('15529','2013-06-20','10:15:00',1.55),('15529','2013-06-20','10:20:00',1.55),('15529','2013-06-20','10:25:00',1.59),('15529','2013-06-20','10:30:00',1.59),('15529','2013-06-20','10:35:00',1.66),('15529','2013-06-20','10:40:00',1.67),('15529','2013-06-20','10:45:00',1.69),('15529','2013-06-20','10:50:00',1.73),('15529','2013-06-20','10:55:00',1.76),('15529','2013-06-20','11:00:00',1.81),('15529','2013-06-20','11:05:00',1.83),('15529','2013-06-20','11:10:00',1.82),('15529','2013-06-20','11:15:00',1.81),('15529','2013-06-20','11:20:00',1.83),('15529','2013-06-20','11:25:00',1.81),('15529','2013-06-20','11:30:00',1.8),('15529','2013-06-20','11:35:00',1.81),('15529','2013-06-20','11:40:00',1.85),('15529','2013-06-20','11:45:00',1.96),('15529','2013-06-20','11:50:00',1.95),('15529','2013-06-20','11:55:00',1.99),('15529','2013-06-20','12:00:00',1.99),('15529','2013-06-20','12:05:00',2.01),('15529','2013-06-20','12:10:00',1.99),('15529','2013-06-20','12:15:00',1.93),('15529','2013-06-20','12:20:00',1.95),('15529','2013-06-20','12:25:00',2.02),('15529','2013-06-20','12:30:00',2.04),('15529','2013-06-20','12:35:00',1.97),('15529','2013-06-20','12:40:00',1.91),('15529','2013-06-20','12:45:00',1.99),('15529','2013-06-20','12:50:00',1.98),('15529','2013-06-20','12:55:00',2.02),('15529','2013-06-20','13:00:00',2.08),('15529','2013-06-20','13:05:00',2.05),('15529','2013-06-20','13:10:00',1.93),('15529','2013-06-20','13:15:00',1.98),('15529','2013-06-20','13:20:00',2.01),('15529','2013-06-20','13:25:00',2.04),('15529','2013-06-20','13:30:00',2.08),('15529','2013-06-20','13:35:00',2.08),('15529','2013-06-20','13:40:00',2.1),('15529','2013-06-20','13:45:00',2.1),('15529','2013-06-20','13:50:00',2.06),('15529','2013-06-20','13:55:00',2.06),('15529','2013-06-20','14:00:00',1.99),('15529','2013-06-20','14:05:00',2.09),('15529','2013-06-20','14:10:00',2.08),('15529','2013-06-20','14:15:00',2.08),('15529','2013-06-20','14:20:00',2.04),('15529','2013-06-20','14:25:00',2.07),('15529','2013-06-20','14:30:00',2.08),('15529','2013-06-20','14:35:00',2.05),('15529','2013-06-20','14:40:00',2.04),('15529','2013-06-20','14:45:00',2),('15529','2013-06-20','14:50:00',2),('15529','2013-06-20','14:55:00',1.97),('15529','2013-06-20','15:00:00',1.95),('15529','2013-06-20','15:05:00',1.93),('15529','2013-06-20','15:10:00',1.9),('15529','2013-06-20','15:15:00',1.9),('15529','2013-06-20','15:20:00',1.87),('15529','2013-06-20','15:25:00',1.87),('15529','2013-06-20','15:30:00',1.84),('15529','2013-06-20','15:35:00',1.81),('15529','2013-06-20','15:40:00',1.78),('15529','2013-06-20','15:45:00',1.77),('15529','2013-06-20','15:50:00',1.73),('15529','2013-06-20','15:55:00',1.68),('15529','2013-06-20','16:00:00',1.66),('15529','2013-06-20','16:05:00',1.62),('15529','2013-06-20','16:10:00',1.6),('15529','2013-06-20','16:15:00',1.59),('15529','2013-06-20','16:20:00',1.55),('15529','2013-06-20','16:25:00',1.51),('15529','2013-06-20','16:30:00',1.48),('15529','2013-06-20','16:35:00',1.45),('15529','2013-06-20','16:40:00',1.41),('15529','2013-06-20','16:45:00',1.37),('15529','2013-06-20','16:50:00',1.33),('15529','2013-06-20','16:55:00',1.29),('15529','2013-06-20','17:00:00',1.25),('15529','2013-06-20','17:05:00',1.21),('15529','2013-06-20','17:10:00',1.17),('15529','2013-06-20','17:15:00',1.13),('15529','2013-06-20','17:20:00',1.09),('15529','2013-06-20','17:25:00',1.04),('15529','2014-04-03','09:05:00',1.04),('15529','2014-04-03','09:10:00',1.09),('15529','2014-04-03','09:15:00',1.01),('15529','2014-04-03','13:20:00',1.06),('15529','2014-04-03','13:25:00',1.29),('15529','2014-04-03','13:30:00',1.04),('15529','2014-04-03','13:35:00',1.99),('15529','2014-04-03','13:40:00',1.82),('15529','2014-04-03','13:45:00',1.96),('15529','2014-04-03','13:50:00',1.51),('15529','2014-04-03','13:55:00',1.62),('15529','2014-04-03','14:00:00',1.96),('15529','2014-04-03','14:05:00',2.67),('15529','2014-04-03','14:10:00',2.43),('15529','2014-04-03','14:15:00',1.8),('15529','2014-04-03','14:20:00',1.15),('15529','2014-04-03','14:30:00',1.29),('15529','2014-04-03','14:45:00',1.23),('15529','2014-04-03','14:50:00',1.38),('15529','2014-04-03','15:00:00',1.71),('15529','2014-04-03','15:05:00',1.16),('15529','2014-04-03','15:10:00',1.37),('15529','2014-04-03','15:15:00',2.2),('15529','2014-04-03','15:20:00',1.96),('15529','2014-04-03','15:50:00',1.19),('15529','2014-04-03','15:55:00',1.64),('15529','2014-04-03','16:00:00',2),('15529','2014-04-03','16:05:00',1.86),('15529','2014-04-03','16:10:00',1.21),('15529','2014-04-03','16:20:00',1.37),('15529','2014-04-03','16:35:00',1.12),('15529','2014-04-03','16:40:00',1.09),('15529','2014-04-03','16:45:00',1.69),('15529','2014-04-03','16:50:00',1.78),('15529','2014-04-03','16:55:00',1.09),('15529','2014-04-03','17:00:00',1.09),('15529','2014-04-03','17:15:00',1.15),('15529','2014-04-03','17:30:00',1.06),('15529','2014-04-03','17:35:00',1.06),('15529','2013-06-19','08:50:00',1.01),('15529','2013-06-19','08:55:00',1.05),('15529','2013-06-19','09:00:00',1.09),('15529','2013-06-19','09:05:00',1.13),('15529','2013-06-19','09:10:00',1.17),('15529','2013-06-19','09:15:00',1.21),('15529','2013-06-19','09:20:00',1.24),('15529','2013-06-19','09:25:00',1.28),('15529','2013-06-19','09:30:00',1.31),('15529','2013-06-19','09:35:00',1.36),('15529','2013-06-19','09:40:00',1.39),('15529','2013-06-19','09:45:00',1.42),('15529','2013-06-19','09:50:00',1.47),('15529','2013-06-19','09:55:00',1.5),('15529','2013-06-19','10:00:00',1.53),('15529','2013-06-19','10:05:00',1.55),('15529','2013-06-19','10:10:00',1.58),('15529','2013-06-19','10:15:00',1.61),('15529','2013-06-19','10:20:00',1.64),('15529','2013-06-19','10:25:00',1.65),('15529','2013-06-19','10:30:00',1.67),('15529','2013-06-19','10:35:00',1.72),('15529','2013-06-19','10:40:00',1.74),('15529','2013-06-19','10:45:00',1.76),('15529','2013-06-19','10:50:00',1.78),('15529','2013-06-19','10:55:00',1.8),('15529','2013-06-19','11:00:00',1.82),('15529','2013-06-19','11:05:00',1.84),('15529','2013-06-19','11:10:00',1.83),('15529','2013-06-19','11:15:00',1.85),('15529','2013-06-19','11:20:00',1.87),('15529','2013-06-19','11:25:00',1.89),('15529','2013-06-19','11:30:00',1.91),('15529','2013-06-19','11:35:00',1.9),('15529','2013-06-19','11:40:00',1.91),('15529','2013-06-19','11:45:00',1.9),('15529','2013-06-19','11:50:00',1.9),('15529','2013-06-19','11:55:00',1.88),('15529','2013-06-19','12:00:00',1.93),('15529','2013-06-19','12:05:00',1.97),('15529','2013-06-19','12:10:00',1.99),('15529','2013-06-19','12:15:00',1.95),('15529','2013-06-19','12:20:00',1.98),('15529','2013-06-19','12:25:00',1.98),('15529','2013-06-19','12:30:00',1.99),('15529','2013-06-19','12:35:00',2.03),('15529','2013-06-19','12:40:00',2.04),('15529','2013-06-19','12:45:00',2.04),('15529','2013-06-19','12:50:00',2.04),('15529','2013-06-19','12:55:00',2.03),('15529','2013-06-19','13:00:00',2.04),('15529','2013-06-19','13:05:00',2.03),('15529','2013-06-19','13:10:00',2.06),('15529','2013-06-19','13:15:00',2.09),('15529','2013-06-19','13:20:00',2.03),('15529','2013-06-19','13:25:00',2.11),('15529','2013-06-19','13:30:00',2.11),('15529','2013-06-19','13:35:00',2.13),('15529','2013-06-19','13:40:00',2.16),('15529','2013-06-19','13:45:00',2.1),('15529','2013-06-19','13:50:00',2.14),('15529','2013-06-19','13:55:00',2.16),('15529','2013-06-19','14:00:00',2.16),('15529','2013-06-19','14:05:00',2.18),('15529','2013-06-19','14:10:00',2.13),('15529','2013-06-19','14:15:00',2.12),('15529','2013-06-19','14:20:00',2.11),('15529','2013-06-19','14:25:00',2.1),('15529','2013-06-19','14:30:00',2.11),('15529','2013-06-19','14:35:00',2.05),('15529','2013-06-19','14:40:00',2.08),('15529','2013-06-19','14:45:00',2.05),('15529','2013-06-19','14:50:00',2.03),('15529','2013-06-19','14:55:00',2.02),('15529','2013-06-19','15:00:00',1.99),('15529','2013-06-19','15:05:00',1.96),('15529','2013-06-19','15:10:00',1.95),('15529','2013-06-19','15:15:00',1.94),('15529','2013-06-19','15:20:00',1.9),('15529','2013-06-19','15:25:00',1.87),('15529','2013-06-19','15:30:00',1.86),('15529','2013-06-19','15:35:00',1.84),('15529','2013-06-19','15:40:00',1.81),('15529','2013-06-19','15:45:00',1.81),('15529','2013-06-19','15:50:00',1.75),('15529','2013-06-19','15:55:00',1.72),('15529','2013-06-19','16:00:00',1.71),('15529','2013-06-19','16:05:00',1.65),('15529','2013-06-19','16:10:00',1.63),('15529','2013-06-19','16:15:00',1.6),('15529','2013-06-19','16:20:00',1.56),('15529','2013-06-19','16:25:00',1.54),('15529','2013-06-19','16:30:00',1.51),('15529','2013-06-19','16:35:00',1.46),('15529','2013-06-19','16:40:00',1.41),('15529','2013-06-19','16:45:00',1.39),('15529','2013-06-19','16:50:00',1.34),('15529','2013-06-19','16:55:00',1.32),('15529','2013-06-19','17:00:00',1.27),('15529','2013-06-19','17:05:00',1.22),('15529','2013-06-19','17:10:00',1.18),('15529','2013-06-19','17:15:00',1.14),('15529','2013-06-19','17:20:00',1.1),('15529','2013-06-19','17:25:00',1.05),('15529','2013-06-19','17:30:00',1.01),('15529','2013-06-18','08:55:00',1.02),('15529','2013-06-18','09:00:00',1.06),('15529','2013-06-18','09:05:00',1.1),('15529','2013-06-18','09:10:00',1.13),('15529','2013-06-18','09:15:00',1.17),('15529','2013-06-18','09:20:00',1.21),('15529','2013-06-18','09:25:00',1.25),('15529','2013-06-18','09:30:00',1.28),('15529','2013-06-18','09:35:00',1.32),('15529','2013-06-18','09:40:00',1.35),('15529','2013-06-18','09:45:00',1.38),('15529','2013-06-18','09:50:00',1.42),('15529','2013-06-18','09:55:00',1.44),('15529','2013-06-18','10:00:00',1.47),('15529','2013-06-18','10:05:00',1.49),('15529','2013-06-18','10:10:00',1.53),('15529','2013-06-18','10:15:00',1.56),('15529','2013-06-18','10:20:00',1.59),('15529','2013-06-18','10:25:00',1.6),('15529','2013-06-18','10:30:00',1.63),('15529','2013-06-18','10:35:00',1.63),('15529','2013-06-18','10:40:00',1.68),('15529','2013-06-18','10:45:00',1.69),('15529','2013-06-18','10:50:00',1.71),('15529','2013-06-18','10:55:00',1.75),('15529','2013-06-18','11:00:00',1.78),('15529','2013-06-18','11:05:00',1.76),('15529','2013-06-18','11:10:00',1.79),('15529','2013-06-18','11:15:00',1.8),('15529','2013-06-18','11:20:00',1.8),('15529','2013-06-18','11:25:00',1.83),('15529','2013-06-18','11:30:00',1.86),('15529','2013-06-18','11:35:00',1.86),('15529','2013-06-18','11:40:00',1.88),('15529','2013-06-18','11:45:00',1.9),('15529','2013-06-18','11:50:00',1.88),('15529','2013-06-18','11:55:00',1.91),('15529','2013-06-18','12:00:00',1.89),('15529','2013-06-18','12:05:00',1.93),('15529','2013-06-18','12:10:00',1.93),('15529','2013-06-18','12:15:00',1.95),('15529','2013-06-18','12:20:00',1.97),('15529','2013-06-18','12:25:00',2.01),('15529','2013-06-18','12:30:00',2.04),('15529','2013-06-18','12:35:00',2.02),('15529','2013-06-18','12:40:00',2.02),('15529','2013-06-18','12:45:00',2.03),('15529','2013-06-18','12:50:00',2),('15529','2013-06-18','12:55:00',2.1),('15529','2013-06-18','13:00:00',2.04),('15529','2013-06-18','13:05:00',2.04),('15529','2013-06-18','13:10:00',2.08),('15529','2013-06-18','13:15:00',2.06),('15529','2013-06-18','13:20:00',2.06),('15529','2013-06-18','13:25:00',2.09),('15529','2013-06-18','13:30:00',2.07),('15529','2013-06-18','13:35:00',2.07),('15529','2013-06-18','13:40:00',2.08),('15529','2013-06-18','13:45:00',2.05),('15529','2013-06-18','13:50:00',2.06),('15529','2013-06-18','13:55:00',2.03),('15529','2013-06-18','14:00:00',2.05),('15529','2013-06-18','14:05:00',2.07),('15529','2013-06-18','14:10:00',2.05),('15529','2013-06-18','14:15:00',2.01),('15529','2013-06-18','14:20:00',2.03),('15529','2013-06-18','14:25:00',2),('15529','2013-06-18','14:30:00',1.99),('15529','2013-06-18','14:35:00',1.97),('15529','2013-06-18','14:40:00',2),('15529','2013-06-18','14:45:00',1.97),('15529','2013-06-18','14:50:00',1.95),('15529','2013-06-18','14:55:00',1.94),('15529','2013-06-18','15:00:00',1.91),('15529','2013-06-18','15:05:00',1.89),('15529','2013-06-18','15:10:00',1.87),('15529','2013-06-18','15:15:00',1.87),('15529','2013-06-18','15:20:00',1.84),('15529','2013-06-18','15:25:00',1.82),('15529','2013-06-18','15:30:00',1.79),('15529','2013-06-18','15:35:00',1.75),('15529','2013-06-18','15:40:00',1.72),('15529','2013-06-18','15:45:00',1.7),('15529','2013-06-18','15:50:00',1.67),('15529','2013-06-18','15:55:00',1.63),('15529','2013-06-18','16:00:00',1.6),('15529','2013-06-18','16:05:00',1.59),('15529','2013-06-18','16:10:00',1.54),('15529','2013-06-18','16:15:00',1.51),('15529','2013-06-18','16:20:00',1.49),('15529','2013-06-18','16:25:00',1.45),('15529','2013-06-18','16:30:00',1.42),('15529','2013-06-18','16:35:00',1.39),('15529','2013-06-18','16:40:00',1.35),('15529','2013-06-18','16:45:00',1.32),('15529','2013-06-18','16:50:00',1.27),('15529','2013-06-18','16:55:00',1.24),('15529','2013-06-18','17:00:00',1.2),('15529','2013-06-18','17:05:00',1.17),('15529','2013-06-18','17:10:00',1.12),('15529','2013-06-18','17:15:00',1.08),('15529','2013-06-18','17:20:00',1.06),('15529','2013-06-18','17:25:00',1.01),('15529','2013-06-17','08:55:00',1.02),('15529','2013-06-17','09:00:00',1.06),('15529','2013-06-17','09:05:00',1.1),('15529','2013-06-17','09:10:00',1.13),('15529','2013-06-17','09:15:00',1.17),('15529','2013-06-17','09:20:00',1.2),('15529','2013-06-17','09:25:00',1.24),('15529','2013-06-17','09:30:00',1.27),('15529','2013-06-17','09:35:00',1.31),('15529','2013-06-17','09:40:00',1.34),('15529','2013-06-17','09:45:00',1.37),('15529','2013-06-17','09:50:00',1.4),('15529','2013-06-17','09:55:00',1.43),('15529','2013-06-17','10:00:00',1.46),('15529','2013-06-17','10:05:00',1.51),('15529','2013-06-17','10:10:00',1.54),('15529','2013-06-17','10:15:00',1.55),('15529','2013-06-17','10:20:00',1.59),('15529','2013-06-17','10:25:00',1.63),('15529','2013-06-17','10:30:00',1.64),('15529','2013-06-17','10:35:00',1.68),('15529','2013-06-17','10:40:00',1.69),('15529','2013-06-17','10:45:00',1.72),('15529','2013-06-17','10:50:00',1.74),('15529','2013-06-17','10:55:00',1.72),('15529','2013-06-17','11:00:00',1.78),('15529','2013-06-17','11:05:00',1.78),('15529','2013-06-17','11:10:00',1.84),('15529','2013-06-17','11:15:00',1.86),('15529','2013-06-17','11:20:00',1.86),('15529','2013-06-17','11:25:00',1.84),('15529','2013-06-17','11:30:00',1.86),('15529','2013-06-17','11:35:00',1.89),('15529','2013-06-17','11:40:00',1.91),('15529','2013-06-17','11:45:00',1.9),('15529','2013-06-17','11:50:00',1.91),('15529','2013-06-17','11:55:00',1.95),('15529','2013-06-17','12:00:00',1.94),('15529','2013-06-17','12:05:00',1.92),('15529','2013-06-17','12:10:00',1.94),('15529','2013-06-17','12:15:00',1.93),('15529','2013-06-17','12:20:00',1.94),('15529','2013-06-17','12:25:00',1.89),('15529','2013-06-17','12:30:00',1.93),('15529','2013-06-17','12:35:00',1.97),('15529','2013-06-17','12:40:00',1.96),('15529','2013-06-17','12:45:00',1.91),('15529','2013-06-17','12:50:00',1.92),('15529','2013-06-17','12:55:00',2.03),('15529','2013-06-17','13:00:00',2.01),('15529','2013-06-17','13:05:00',2.01),('15529','2013-06-17','13:10:00',2.02),('15529','2013-06-17','13:15:00',2.05),('15529','2013-06-17','13:20:00',2.04),('15529','2013-06-17','13:25:00',2.12),('15529','2013-06-17','13:30:00',2.02),('15529','2013-06-17','13:35:00',2.06),('15529','2013-06-17','13:40:00',2.08),('15529','2013-06-17','13:45:00',2.04),('15529','2013-06-17','13:50:00',2.08),('15529','2013-06-17','13:55:00',2.06),('15529','2013-06-17','14:00:00',2.06),('15529','2013-06-17','14:05:00',2.04),('15529','2013-06-17','14:10:00',2.05),('15529','2013-06-17','14:15:00',2.03),('15529','2013-06-17','14:20:00',2.01),('15529','2013-06-17','14:25:00',2.01),('15529','2013-06-17','14:30:00',2.06),('15529','2013-06-17','14:35:00',2.1),('15529','2013-06-17','14:40:00',2.07),('15529','2013-06-17','14:45:00',2.04),('15529','2013-06-17','14:50:00',1.97),('15529','2013-06-17','14:55:00',1.95),('15529','2013-06-17','15:00:00',1.96),('15529','2013-06-17','15:05:00',1.9),('15529','2013-06-17','15:10:00',1.87),('15529','2013-06-17','15:15:00',1.84),('15529','2013-06-17','15:20:00',1.86),('15529','2013-06-17','15:25:00',1.82),('15529','2013-06-17','15:30:00',1.81),('15529','2013-06-17','15:35:00',1.79),('15529','2013-06-17','15:40:00',1.73),('15529','2013-06-17','15:45:00',1.72),('15529','2013-06-17','15:50:00',1.69),('15529','2013-06-17','15:55:00',1.68),('15529','2013-06-17','16:00:00',1.65),('15529','2013-06-17','16:05:00',1.64),('15529','2013-06-17','16:10:00',1.61),('15529','2013-06-17','16:15:00',1.57),('15529','2013-06-17','16:20:00',1.55),('15529','2013-06-17','16:25:00',1.52),('15529','2013-06-17','16:30:00',1.47),('15529','2013-06-17','16:35:00',1.42),('15529','2013-06-17','16:40:00',1.36),('15529','2013-06-17','16:45:00',1.34),('15529','2013-06-17','16:50:00',1.3),('15529','2013-06-17','16:55:00',1.26),('15529','2013-06-17','17:00:00',1.22),('15529','2013-06-17','17:05:00',1.18),('15529','2013-06-17','17:10:00',1.14),('15529','2013-06-17','17:15:00',1.11),('15529','2013-06-17','17:20:00',1.07),('15529','2013-06-17','17:25:00',1.02),('15529','2013-06-16','08:50:00',1.03),('15529','2013-06-16','08:55:00',1.07),('15529','2013-06-16','09:00:00',1.11),('15529','2013-06-16','09:05:00',1.15),('15529','2013-06-16','09:10:00',1.19),('15529','2013-06-16','09:15:00',1.23),('15529','2013-06-16','09:20:00',1.27),('15529','2013-06-16','09:25:00',1.31),('15529','2013-06-16','09:30:00',1.34),('15529','2013-06-16','09:35:00',1.38),('15529','2013-06-16','09:40:00',1.4),('15529','2013-06-16','09:45:00',1.44),('15529','2013-06-16','09:50:00',1.48),('15529','2013-06-16','09:55:00',1.51),('15529','2013-06-16','10:00:00',1.53),('15529','2013-06-16','10:05:00',1.55),('15529','2013-06-16','10:10:00',1.59),('15529','2013-06-16','10:15:00',1.62),('15529','2013-06-16','10:20:00',1.64),('15529','2013-06-16','10:25:00',1.67),('15529','2013-06-16','10:30:00',1.68),('15529','2013-06-16','10:35:00',1.74),('15529','2013-06-16','10:40:00',1.73),('15529','2013-06-16','10:45:00',1.78),('15529','2013-06-16','10:50:00',1.77),('15529','2013-06-16','10:55:00',1.81),('15529','2013-06-16','11:00:00',1.81),('15529','2013-06-16','11:05:00',1.85),('15529','2013-06-16','11:10:00',1.89),('15529','2013-06-16','11:15:00',1.9),('15529','2013-06-16','11:20:00',1.88),('15529','2013-06-16','11:25:00',1.9),('15529','2013-06-16','11:30:00',1.91),('15529','2013-06-16','11:35:00',1.97),('15529','2013-06-16','11:40:00',1.97),('15529','2013-06-16','11:45:00',1.93),('15529','2013-06-16','11:50:00',1.96),('15529','2013-06-16','11:55:00',1.99),('15529','2013-06-16','12:00:00',2),('15529','2013-06-16','12:05:00',2.03),('15529','2013-06-16','12:10:00',2.01),('15529','2013-06-16','12:15:00',2.04),('15529','2013-06-16','12:20:00',1.99),('15529','2013-06-16','12:25:00',2.08),('15529','2013-06-16','12:30:00',2.05),('15529','2013-06-16','12:35:00',2.07),('15529','2013-06-16','12:40:00',2.09),('15529','2013-06-16','12:45:00',2.09),('15529','2013-06-16','12:50:00',2.09),('15529','2013-06-16','12:55:00',2.14),('15529','2013-06-16','13:00:00',2.09),('15529','2013-06-16','13:05:00',2.13),('15529','2013-06-16','13:10:00',2.14),('15529','2013-06-16','13:15:00',2.16),('15529','2013-06-16','13:20:00',2.15),('15529','2013-06-16','13:25:00',2.15),('15529','2013-06-16','13:30:00',2.14),('15529','2013-06-16','13:35:00',2.12),('15529','2013-06-16','13:40:00',2.07),('15529','2013-06-16','13:45:00',2.07),('15529','2013-06-16','13:50:00',2.07),('15529','2013-06-16','13:55:00',2.09),('15529','2013-06-16','14:00:00',2.05),('15529','2013-06-16','14:05:00',2.04),('15529','2013-06-16','14:10:00',2.04),('15529','2013-06-16','14:15:00',2.02),('15529','2013-06-16','14:20:00',2.04),('15529','2013-06-16','14:25:00',2.03),('15529','2013-06-16','14:30:00',1.99),('15529','2013-06-16','14:35:00',2),('15529','2013-06-16','14:40:00',2),('15529','2013-06-16','14:45:00',2.01),('15529','2013-06-16','14:50:00',1.94),('15529','2013-06-16','14:55:00',1.91),('15529','2013-06-16','15:00:00',1.91),('15529','2013-06-16','15:05:00',1.9),('15529','2013-06-16','15:10:00',1.89),('15529','2013-06-16','15:15:00',1.88),('15529','2013-06-16','15:20:00',1.85),('15529','2013-06-16','15:25:00',1.82),('15529','2013-06-16','15:30:00',1.82),('15529','2013-06-16','15:35:00',1.78),('15529','2013-06-16','15:40:00',1.78),('15529','2013-06-16','15:45:00',1.73),('15529','2013-06-16','15:50:00',1.69),('15529','2013-06-16','15:55:00',1.68),('15529','2013-06-16','16:00:00',1.66),('15529','2013-06-16','16:05:00',1.63),('15529','2013-06-16','16:10:00',1.58),('15529','2013-06-16','16:15:00',1.56),('15529','2013-06-16','16:20:00',1.52),('15529','2013-06-16','16:25:00',1.5),('15529','2013-06-16','16:30:00',1.47),('15529','2013-06-16','16:35:00',1.43),('15529','2013-06-16','16:40:00',1.38),('15529','2013-06-16','16:45:00',1.34),('15529','2013-06-16','16:50:00',1.32),('15529','2013-06-16','16:55:00',1.28),('15529','2013-06-16','17:00:00',1.23),('15529','2013-06-16','17:05:00',1.2),('15529','2013-06-16','17:10:00',1.15),('15529','2013-06-16','17:15:00',1.11),('15529','2013-06-16','17:20:00',1.07),('15529','2013-06-16','17:25:00',1.03),('15529','2013-06-15','08:45:00',1),('15529','2013-06-15','08:50:00',1.05),('15529','2013-06-15','08:55:00',1.1),('15529','2013-06-15','09:00:00',1.13),('15529','2013-06-15','09:05:00',1.16),('15529','2013-06-15','09:10:00',1.2),('15529','2013-06-15','09:15:00',1.26),('15529','2013-06-15','09:20:00',1.28),('15529','2013-06-15','09:25:00',1.31),('15529','2013-06-15','09:30:00',1.35),('15529','2013-06-15','09:35:00',1.4),('15529','2013-06-15','09:40:00',1.43),('15529','2013-06-15','09:45:00',1.45),('15529','2013-06-15','09:50:00',1.49),('15529','2013-06-15','09:55:00',1.52),('15529','2013-06-15','10:00:00',1.55),('15529','2013-06-15','10:05:00',1.56),('15529','2013-06-15','10:10:00',1.61),('15529','2013-06-15','10:15:00',1.64),('15529','2013-06-15','10:20:00',1.66),('15529','2013-06-15','10:25:00',1.7),('15529','2013-06-15','10:30:00',1.71),('15529','2013-06-15','10:35:00',1.77),('15529','2013-06-15','10:40:00',1.79),('15529','2013-06-15','10:45:00',1.81),('15529','2013-06-15','10:50:00',1.82),('15529','2013-06-15','10:55:00',1.83),('15529','2013-06-15','11:00:00',1.87),('15529','2013-06-15','11:05:00',1.89),('15529','2013-06-15','11:10:00',1.92),('15529','2013-06-15','11:15:00',1.94),('15529','2013-06-15','11:20:00',1.95),('15529','2013-06-15','11:25:00',1.98),('15529','2013-06-15','11:30:00',2.03),('15529','2013-06-15','11:35:00',2.01),('15529','2013-06-15','11:40:00',2.02),('15529','2013-06-15','11:45:00',2.04),('15529','2013-06-15','11:50:00',2.04),('15529','2013-06-15','11:55:00',2.07),('15529','2013-06-15','12:00:00',2.11),('15529','2013-06-15','12:05:00',2.11),('15529','2013-06-15','12:10:00',2.1),('15529','2013-06-15','12:15:00',2.12),('15529','2013-06-15','12:20:00',2.11),('15529','2013-06-15','12:25:00',2.12),('15529','2013-06-15','12:30:00',2.14),('15529','2013-06-15','12:35:00',2.14),('15529','2013-06-15','12:40:00',2.17),('15529','2013-06-15','12:45:00',2.16),('15529','2013-06-15','12:50:00',2.18),('15529','2013-06-15','12:55:00',2.18),('15529','2013-06-15','13:00:00',2.21),('15529','2013-06-15','13:05:00',2.21),('15529','2013-06-15','13:10:00',2.22),('15529','2013-06-15','13:15:00',2.2),('15529','2013-06-15','13:20:00',2.21),('15529','2013-06-15','13:25:00',2.17),('15529','2013-06-15','13:30:00',2.22),('15529','2013-06-15','13:35:00',2.2),('15529','2013-06-15','13:40:00',2.19),('15529','2013-06-15','13:45:00',1.3),('15529','2013-06-15','13:50:00',2.17),('15529','2013-06-15','13:55:00',2.13),('15529','2013-06-15','14:00:00',2.17),('15529','2013-06-15','14:05:00',1.3),('15529','2013-06-15','14:10:00',2.16),('15529','2013-06-15','14:15:00',1.1),('15529','2013-06-15','14:20:00',2.01),('15529','2013-06-15','14:25:00',2.01),('15529','2013-06-15','14:30:00',2),('15529','2013-06-15','14:35:00',1.97),('15529','2013-06-15','14:40:00',1.96),('15529','2013-06-15','14:45:00',1.95),('15529','2013-06-15','14:50:00',1.93),('15529','2013-06-15','14:55:00',1.93),('15529','2013-06-15','15:00:00',1.9),('15529','2013-06-15','15:05:00',1.89),('15529','2013-06-15','15:10:00',1.87),('15529','2013-06-15','15:15:00',1.44),('15529','2013-06-15','15:20:00',1.14),('15529','2013-06-15','15:25:00',1.13),('15529','2013-06-15','15:30:00',1.13),('15529','2013-06-15','15:35:00',1.6),('15529','2013-06-15','15:40:00',1.84),('15529','2013-06-15','15:45:00',1.77),('15529','2013-06-15','15:50:00',1.74),('15529','2013-06-15','15:55:00',1.72),('15529','2013-06-15','16:00:00',1.66),('15529','2013-06-15','16:05:00',1.64),('15529','2013-06-15','16:10:00',1.62),('15529','2013-06-15','16:15:00',1.58),('15529','2013-06-15','16:20:00',1.56),('15529','2013-06-15','16:25:00',1.51),('15529','2013-06-15','16:30:00',1.47),('15529','2013-06-15','16:35:00',1.44),('15529','2013-06-15','16:40:00',1.4),('15529','2013-06-15','16:45:00',1.37),('15529','2013-06-15','16:50:00',1.33),('15529','2013-06-15','16:55:00',1.29),('15529','2013-06-15','17:00:00',1.24),('15529','2013-06-15','17:05:00',1.2),('15529','2013-06-15','17:10:00',1.17),('15529','2013-06-15','17:15:00',1.13),('15529','2013-06-15','17:20:00',1.08),('15529','2013-06-15','17:25:00',1.04),('15529','2013-06-14','08:45:00',1.01),('15529','2013-06-14','08:50:00',1.09),('15529','2013-06-14','08:55:00',1.16),('15529','2013-06-14','09:00:00',1.22),('15529','2013-06-14','09:05:00',1.23),('15529','2013-06-14','09:10:00',1.01),('15529','2013-06-14','09:15:00',1.26),('15529','2013-06-14','09:25:00',1.06),('15529','2013-06-14','09:35:00',1.45),('15529','2013-06-14','09:40:00',1.42),('15529','2013-06-14','09:45:00',1.46),('15529','2013-06-14','09:50:00',1.5),('15529','2013-06-14','09:55:00',1.53),('15529','2013-06-14','10:00:00',1.59),('15529','2013-06-14','10:05:00',1.6),('15529','2013-06-14','10:10:00',1.15),('15529','2013-06-14','10:15:00',1.55),('15529','2013-06-14','10:20:00',1.7),('15529','2013-06-14','10:25:00',1.74),('15529','2013-06-14','10:30:00',1.73),('15529','2013-06-14','10:35:00',1.8),('15529','2013-06-14','10:40:00',1.82),('15529','2013-06-14','10:45:00',1.75),('15529','2013-06-14','10:50:00',1.81),('15529','2013-06-14','10:55:00',1.88),('15529','2013-06-14','11:00:00',1.93),('15529','2013-06-14','11:05:00',1.91),('15529','2013-06-14','11:10:00',1.94),('15529','2013-06-14','11:15:00',1.96),('15529','2013-06-14','11:20:00',1.99),('15529','2013-06-14','11:25:00',1.93),('15529','2013-06-14','11:30:00',2.01),('15529','2013-06-14','11:35:00',2.06),('15529','2013-06-14','11:40:00',2.08),('15529','2013-06-14','11:45:00',2.09),('15529','2013-06-14','11:50:00',2.09),('15529','2013-06-14','11:55:00',2.11),('15529','2013-06-14','12:00:00',2.11),('15529','2013-06-14','12:05:00',2.13),('15529','2013-06-14','12:10:00',2.12),('15529','2013-06-14','12:15:00',2.12),('15529','2013-06-14','12:20:00',2.15),('15529','2013-06-14','12:25:00',2.14),('15529','2013-06-14','12:30:00',2.18),('15529','2013-06-14','12:35:00',2.17),('15529','2013-06-14','12:40:00',2.17),('15529','2013-06-14','12:45:00',2.18),('15529','2013-06-14','12:50:00',2.19),('15529','2013-06-14','12:55:00',2.16),('15529','2013-06-14','13:00:00',2.12),('15529','2013-06-14','13:05:00',2.22),('15529','2013-06-14','13:10:00',2.21),('15529','2013-06-14','13:15:00',2.15),('15529','2013-06-14','13:20:00',2.18),('15529','2013-06-14','13:25:00',2.17),('15529','2013-06-14','13:30:00',2.23),('15529','2013-06-14','13:35:00',1.1),('15529','2013-06-14','13:40:00',2.07),('15529','2013-06-14','13:45:00',2.07),('15529','2013-06-14','13:50:00',2.07),('15529','2013-06-14','13:55:00',2.06),('15529','2013-06-14','14:00:00',2.07),('15529','2013-06-14','14:05:00',2.07),('15529','2013-06-14','14:10:00',2.03),('15529','2013-06-14','14:15:00',2),('15529','2013-06-14','14:20:00',2.02),('15529','2013-06-14','14:25:00',2.01),('15529','2013-06-14','14:30:00',1.96),('15529','2013-06-14','14:35:00',1.83),('15529','2013-06-14','14:40:00',1.45),('15529','2013-06-14','14:45:00',1.41),('15529','2013-06-14','14:50:00',1.41),('15529','2013-06-14','14:55:00',1.41),('15529','2013-06-14','15:00:00',1.41),('15529','2013-06-14','15:05:00',1.4),('15529','2013-06-14','15:10:00',1.41),('15529','2013-06-14','15:15:00',1.41),('15529','2013-06-14','15:20:00',1.41),('15529','2013-06-14','15:30:00',1.86),('15529','2013-06-14','15:35:00',1.83),('15529','2013-06-14','15:40:00',1.79),('15529','2013-06-14','15:45:00',1.76),('15529','2013-06-14','15:50:00',1.73),('15529','2013-06-14','15:55:00',1.71),('15529','2013-06-14','16:00:00',1.68),('15529','2013-06-14','16:05:00',1.64),('15529','2013-06-14','16:10:00',1.6),('15529','2013-06-14','16:15:00',1.57),('15529','2013-06-14','16:20:00',1.53),('15529','2013-06-14','16:25:00',1.51),('15529','2013-06-14','16:30:00',1.47),('15529','2013-06-14','16:35:00',1.44),('15529','2013-06-14','16:40:00',1.41),('15529','2013-06-14','16:45:00',1.37),('15529','2013-06-14','16:50:00',1.32),('15529','2013-06-14','16:55:00',1.28),('15529','2013-06-14','17:00:00',1.24),('15529','2013-06-14','17:05:00',1.2),('15529','2013-06-14','17:10:00',1.16),('15529','2013-06-14','17:15:00',1.11),('15529','2013-06-14','17:20:00',1.07),('15529','2013-06-14','17:25:00',1.02),('15529','2013-06-13','08:40:00',1.02),('15529','2013-06-13','08:45:00',1.07),('15529','2013-06-13','08:50:00',1.09),('15529','2013-06-13','08:55:00',1.14),('15529','2013-06-13','09:00:00',1.19),('15529','2013-06-13','09:05:00',1.23),('15529','2013-06-13','09:10:00',1.26),('15529','2013-06-13','09:15:00',1.3),('15529','2013-06-13','09:20:00',1.33),('15529','2013-06-13','09:25:00',1.37),('15529','2013-06-13','09:30:00',1.39),('15529','2013-06-13','09:35:00',1.46),('15529','2013-06-13','09:40:00',1.49),('15529','2013-06-13','09:45:00',1.53),('15529','2013-06-13','09:50:00',1.57),('15529','2013-06-13','09:55:00',1.61),('15529','2013-06-13','10:00:00',1.64),('15529','2013-06-13','10:05:00',1.64),('15529','2013-06-13','10:10:00',1.68),('15529','2013-06-13','10:15:00',1.72),('15529','2013-06-13','10:20:00',1.77),('15529','2013-06-13','10:25:00',1.76),('15529','2013-06-13','10:30:00',1.73),('15529','2013-06-13','10:35:00',1.84),('15529','2013-06-13','10:40:00',1.87),('15529','2013-06-13','10:45:00',1.89),('15529','2013-06-13','10:50:00',1.89),('15529','2013-06-13','10:55:00',1.92),('15529','2013-06-13','11:00:00',1.96),('15529','2013-06-13','11:05:00',1.97),('15529','2013-06-13','11:10:00',1.99),('15529','2013-06-13','11:15:00',2),('15529','2013-06-13','11:20:00',1.97),('15529','2013-06-13','11:25:00',2.04),('15529','2013-06-13','11:30:00',2.08),('15529','2013-06-13','11:35:00',2.05),('15529','2013-06-13','11:40:00',2.08),('15529','2013-06-13','11:45:00',2.09),('15529','2013-06-13','11:50:00',2.08),('15529','2013-06-13','11:55:00',2.06),('15529','2013-06-13','12:00:00',2.13),('15529','2013-06-13','12:05:00',2.13),('15529','2013-06-13','12:10:00',2.15),('15529','2013-06-13','12:15:00',2.18),('15529','2013-06-13','12:20:00',2.22),('15529','2013-06-13','12:25:00',2.21),('15529','2013-06-13','12:30:00',2.19),('15529','2013-06-13','12:35:00',2.18),('15529','2013-06-13','12:40:00',2.23),('15529','2013-06-13','12:45:00',2.2),('15529','2013-06-13','12:50:00',2.22),('15529','2013-06-13','12:55:00',2.21),('15529','2013-06-13','13:00:00',2.23),('15529','2013-06-13','13:05:00',2.17),('15529','2013-06-13','13:10:00',2.23),('15529','2013-06-13','13:15:00',2.2),('15529','2013-06-13','13:20:00',2.2),('15529','2013-06-13','13:25:00',2.23),('15529','2013-06-13','13:30:00',2.19),('15529','2013-06-13','13:35:00',2.23),('15529','2013-06-13','13:40:00',2.23),('15529','2013-06-13','13:45:00',2.19),('15529','2013-06-13','13:50:00',2.2),('15529','2013-06-13','13:55:00',2.18),('15529','2013-06-13','14:00:00',2.13),('15529','2013-06-13','14:05:00',2.15),('15529','2013-06-13','14:10:00',2.12),('15529','2013-06-13','14:15:00',2.14),('15529','2013-06-13','14:20:00',2.14),('15529','2013-06-13','14:25:00',2.12),('15529','2013-06-13','14:30:00',2.13),('15529','2013-06-13','14:35:00',2.09),('15529','2013-06-13','14:40:00',2.1),('15529','2013-06-13','14:45:00',2.08),('15529','2013-06-13','14:50:00',2.04),('15529','2013-06-13','14:55:00',2.02),('15529','2013-06-13','15:00:00',2.02),('15529','2013-06-13','15:05:00',2),('15529','2013-06-13','15:10:00',1.98),('15529','2013-06-13','15:15:00',1.94),('15529','2013-06-13','15:20:00',1.92),('15529','2013-06-13','15:25:00',1.9),('15529','2013-06-13','15:30:00',1.89),('15529','2013-06-13','15:35:00',1.85),('15529','2013-06-13','15:40:00',1.84),('15529','2013-06-13','15:45:00',1.82),('15529','2013-06-13','15:50:00',1.77),('15529','2013-06-13','15:55:00',1.75),('15529','2013-06-13','16:00:00',1.71),('15529','2013-06-13','16:05:00',1.69),('15529','2013-06-13','16:10:00',1.66),('15529','2013-06-13','16:15:00',1.6),('15529','2013-06-13','16:20:00',1.56),('15529','2013-06-13','16:25:00',1.54),('15529','2013-06-13','16:30:00',1.51),('15529','2013-06-13','16:35:00',1.49),('15529','2013-06-13','16:40:00',1.43),('15529','2013-06-13','16:45:00',1.4),('15529','2013-06-13','16:50:00',1.36),('15529','2013-06-13','16:55:00',1.31),('15529','2013-06-13','17:00:00',1.27),('15529','2013-06-13','17:05:00',1.22),('15529','2013-06-13','17:10:00',1.17),('15529','2013-06-13','17:15:00',1.14),('15529','2013-06-13','17:20:00',1.1),('15529','2013-06-13','17:25:00',1.04),('15529','2013-06-12','08:40:00',1.03),('15529','2013-06-12','08:45:00',1.07),('15529','2013-06-12','08:50:00',1.12),('15529','2013-06-12','08:55:00',1.16),('15529','2013-06-12','09:00:00',1.2),('15529','2013-06-12','09:05:00',1.25),('15529','2013-06-12','09:10:00',1.29),('15529','2013-06-12','09:15:00',1.32),('15529','2013-06-12','09:20:00',1.37),('15529','2013-06-12','09:25:00',1.42),('15529','2013-06-12','09:30:00',1.45),('15529','2013-06-12','09:35:00',1.49),('15529','2013-06-12','09:40:00',1.54),('15529','2013-06-12','09:45:00',1.57),('15529','2013-06-12','09:50:00',1.6),('15529','2013-06-12','09:55:00',1.63),('15529','2013-06-12','10:00:00',1.66),('15529','2013-06-12','10:05:00',1.7),('15529','2013-06-12','10:10:00',1.73),('15529','2013-06-12','10:15:00',1.75),('15529','2013-06-12','10:20:00',1.76),('15529','2013-06-12','10:25:00',1.8),('15529','2013-06-12','10:30:00',1.83),('15529','2013-06-12','10:35:00',1.86),('15529','2013-06-12','10:40:00',1.89),('15529','2013-06-12','10:45:00',1.91),('15529','2013-06-12','10:50:00',1.93),('15529','2013-06-12','10:55:00',1.96),('15529','2013-06-12','11:00:00',1.96),('15529','2013-06-12','11:05:00',2),('15529','2013-06-12','11:10:00',2.03),('15529','2013-06-12','11:15:00',2.05),('15529','2013-06-12','11:20:00',2.06),('15529','2013-06-12','11:25:00',2.08),('15529','2013-06-12','11:30:00',2.11),('15529','2013-06-12','11:35:00',2.12),('15529','2013-06-12','11:40:00',2.14),('15529','2013-06-12','11:45:00',2.16),('15529','2013-06-12','11:50:00',2.17),('15529','2013-06-12','11:55:00',2.18),('15529','2013-06-12','12:00:00',2.15),('15529','2013-06-12','12:05:00',2.18),('15529','2013-06-12','12:10:00',2.19),('15529','2013-06-12','12:15:00',2.21),('15529','2013-06-12','12:20:00',2.2),('15529','2013-06-12','12:25:00',2.24),('15529','2013-06-12','12:30:00',2.24),('15529','2013-06-12','12:35:00',2.25),('15529','2013-06-12','12:40:00',2.24),('15529','2013-06-12','12:45:00',2.21),('15529','2013-06-12','12:50:00',2.25),('15529','2013-06-12','12:55:00',2.24),('15529','2013-06-12','13:00:00',2.2),('15529','2013-06-12','13:05:00',2.26),('15529','2013-06-12','13:10:00',2.24),('15529','2013-06-12','13:15:00',2.23),('15529','2013-06-12','13:20:00',2.24),('15529','2013-06-12','13:25:00',2.28),('15529','2013-06-12','13:30:00',2.26),('15529','2013-06-12','13:35:00',2.25),('15529','2013-06-12','13:40:00',2.25),('15529','2013-06-12','13:45:00',2.19),('15529','2013-06-12','13:50:00',2.26),('15529','2013-06-12','13:55:00',2.27),('15529','2013-06-12','14:00:00',2.18),('15529','2013-06-12','14:05:00',2.17),('15529','2013-06-12','14:10:00',2.16),('15529','2013-06-12','14:15:00',2.16),('15529','2013-06-12','14:20:00',2.15),('15529','2013-06-12','14:25:00',2.13),('15529','2013-06-12','14:30:00',2.15),('15529','2013-06-12','14:35:00',2.23),('15529','2013-06-12','14:40:00',2.17),('15529','2013-06-12','14:45:00',2.11),('15529','2013-06-12','14:50:00',2.08),('15529','2013-06-12','14:55:00',2.05),('15529','2013-06-12','15:00:00',2.03),('15529','2013-06-12','15:05:00',2.01),('15529','2013-06-12','15:10:00',1.98),('15529','2013-06-12','15:15:00',1.94),('15529','2013-06-12','15:20:00',1.93),('15529','2013-06-12','15:25:00',1.9),('15529','2013-06-12','15:30:00',1.89),('15529','2013-06-12','15:35:00',1.86),('15529','2013-06-12','15:40:00',1.81),('15529','2013-06-12','15:45:00',1.81),('15529','2013-06-12','15:50:00',1.77),('15529','2013-06-12','15:55:00',1.74),('15529','2013-06-12','16:00:00',1.7),('15529','2013-06-12','16:05:00',1.68),('15529','2013-06-12','16:10:00',1.65),('15529','2013-06-12','16:15:00',1.6),('15529','2013-06-12','16:20:00',1.56),('15529','2013-06-12','16:25:00',1.53),('15529','2013-06-12','16:30:00',1.48),('15529','2013-06-12','16:35:00',1.43),('15529','2013-06-12','16:40:00',1.39),('15529','2013-06-12','16:45:00',1.37),('15529','2013-06-12','16:50:00',1.35),('15529','2013-06-12','16:55:00',1.31),('15529','2013-06-12','17:00:00',1.26),('15529','2013-06-12','17:05:00',1.23),('15529','2013-06-12','17:10:00',1.18),('15529','2013-06-12','17:15:00',1.14),('15529','2013-06-12','17:20:00',1.1),('15529','2013-06-12','17:25:00',1.05),('15529','2013-06-12','17:30:00',1.01),('15529','2013-06-11','08:40:00',1.05),('15529','2013-06-11','08:45:00',1.09),('15529','2013-06-11','08:50:00',1.14),('15529','2013-06-11','08:55:00',1.18),('15529','2013-06-11','09:00:00',1.22),('15529','2013-06-11','09:05:00',1.26),('15529','2013-06-11','09:10:00',1.32),('15529','2013-06-11','09:15:00',1.36),('15529','2013-06-11','09:20:00',1.4),('15529','2013-06-11','09:25:00',1.43),('15529','2013-06-11','09:30:00',1.47),('15529','2013-06-11','09:35:00',1.5),('15529','2013-06-11','09:40:00',1.55),('15529','2013-06-11','09:45:00',1.58),('15529','2013-06-11','09:50:00',1.62),('15529','2013-06-11','09:55:00',1.66),('15529','2013-06-11','10:00:00',1.68),('15529','2013-06-11','10:05:00',1.73),('15529','2013-06-11','10:10:00',1.75),('15529','2013-06-11','10:15:00',1.77),('15529','2013-06-11','10:20:00',1.8),('15529','2013-06-11','10:25:00',1.82),('15529','2013-06-11','10:30:00',1.82),('15529','2013-06-11','10:35:00',1.87),('15529','2013-06-11','10:40:00',1.9),('15529','2013-06-11','10:45:00',1.91),('15529','2013-06-11','10:50:00',1.93),('15529','2013-06-11','10:55:00',1.95),('15529','2013-06-11','11:00:00',1.99),('15529','2013-06-11','11:05:00',2.01),('15529','2013-06-11','11:10:00',2.03),('15529','2013-06-11','11:15:00',2.04),('15529','2013-06-11','11:20:00',2.05),('15529','2013-06-11','11:25:00',2.08),('15529','2013-06-11','11:30:00',2.11),('15529','2013-06-11','11:35:00',2.15),('15529','2013-06-11','11:40:00',2.19),('15529','2013-06-11','11:45:00',2.19),('15529','2013-06-11','11:50:00',2.18),('15529','2013-06-11','11:55:00',2.18),('15529','2013-06-11','12:00:00',2.22),('15529','2013-06-11','12:05:00',2.22),('15529','2013-06-11','12:10:00',2.22),('15529','2013-06-11','12:15:00',2.22),('15529','2013-06-11','12:20:00',2.1),('15529','2013-06-11','12:25:00',2.23),('15529','2013-06-11','12:30:00',2.3),('15529','2013-06-11','12:35:00',2.28),('15529','2013-06-11','12:40:00',2.32),('15529','2013-06-11','12:45:00',2.33),('15529','2013-06-11','12:50:00',2.37),('15529','2013-06-11','12:55:00',2.37),('15529','2013-06-11','13:00:00',2.34),('15529','2013-06-11','13:05:00',2.3),('15529','2013-06-11','13:10:00',2.28),('15529','2013-06-11','13:15:00',2.29),('15529','2013-06-11','13:20:00',2.26),('15529','2013-06-11','13:25:00',2.26),('15529','2013-06-11','13:30:00',2.22),('15529','2013-06-11','13:35:00',2.28),('15529','2013-06-11','13:40:00',2.25),('15529','2013-06-11','13:45:00',2.09),('15529','2013-06-11','13:50:00',2.32),('15529','2013-06-11','13:55:00',2.41),('15529','2013-06-11','14:00:00',2.26),('15529','2013-06-11','14:10:00',1.11),('15529','2013-06-11','14:15:00',1.65),('15529','2013-06-11','14:20:00',2.43),('15529','2013-06-11','14:25:00',2.13),('15529','2013-06-11','14:30:00',2.21),('15529','2013-06-11','14:35:00',2.13),('15529','2013-06-11','14:40:00',2.13),('15529','2013-06-11','14:45:00',2.14),('15529','2013-06-11','14:50:00',2.15),('15529','2013-06-11','14:55:00',2.09),('15529','2013-06-11','15:00:00',2.09),('15529','2013-06-11','15:05:00',2.06),('15529','2013-06-11','15:10:00',2.06),('15529','2013-06-11','15:15:00',2.03),('15529','2013-06-11','15:20:00',1.94),('15529','2013-06-11','15:25:00',1.97),('15529','2013-06-11','15:30:00',1.83),('15529','2013-06-11','15:35:00',1.86),('15529','2013-06-11','15:40:00',1.88),('15529','2013-06-11','15:45:00',1.83),('15529','2013-06-11','15:50:00',1.82),('15529','2013-06-11','15:55:00',1.82),('15529','2013-06-11','16:05:00',1.39),('15529','2013-06-11','16:10:00',1.71),('15529','2013-06-11','16:15:00',1.64),('15529','2013-06-11','16:20:00',1.6),('15529','2013-06-11','16:25:00',1.6),('15529','2013-06-11','16:30:00',1.61),('15529','2013-06-11','16:35:00',1.05),('15529','2013-06-11','16:40:00',1.5),('15529','2013-06-11','16:45:00',1.37),('15529','2013-06-11','16:50:00',1.36),('15529','2013-06-11','16:55:00',1.31),('15529','2013-06-11','17:00:00',1.31),('15529','2013-06-11','17:05:00',1.28),('15529','2013-06-11','17:10:00',1.23),('15529','2013-06-11','17:15:00',1.18),('15529','2013-06-11','17:20:00',1.14),('15529','2013-06-11','17:25:00',1.08),('15529','2013-06-11','17:30:00',1.04),('15529','2013-06-11','17:35:00',1.01),('15529','2013-06-10','08:30:00',1.11),('15529','2013-06-10','08:45:00',1.06),('15529','2013-06-10','08:50:00',1),('15529','2013-06-10','08:55:00',1.2),('15529','2013-06-10','09:00:00',1.06),('15529','2013-06-10','09:10:00',1.34),('15529','2013-06-10','09:15:00',1.47),('15529','2013-06-10','09:20:00',1.4),('15529','2013-06-10','09:25:00',1.35),('15529','2013-06-10','09:30:00',1.34),('15529','2013-06-10','09:35:00',1.56),('15529','2013-06-10','09:40:00',1.64),('15529','2013-06-10','09:45:00',1.67),('15529','2013-06-10','09:50:00',1.68),('15529','2013-06-10','09:55:00',1.68),('15529','2013-06-10','10:00:00',1.72),('15529','2013-06-10','10:05:00',1.73),('15529','2013-06-10','10:10:00',1.75),('15529','2013-06-10','10:15:00',1.29),('15529','2013-06-10','10:20:00',1.9),('15529','2013-06-10','10:25:00',1.86),('15529','2013-06-10','10:40:00',2.08),('15529','2013-06-10','10:45:00',1.85),('15529','2013-06-10','10:50:00',2.05),('15529','2013-06-10','10:55:00',2.17),('15529','2013-06-10','11:05:00',1.56),('15529','2013-06-10','11:10:00',2.13),('15529','2013-06-10','11:15:00',2.1),('15529','2013-06-10','11:20:00',2.15),('15529','2013-06-10','11:25:00',2.15),('15529','2013-06-10','11:30:00',2.17),('15529','2013-06-10','11:35:00',2.16),('15529','2013-06-10','11:40:00',2.15),('15529','2013-06-10','11:45:00',2.18),('15529','2013-06-10','11:50:00',2.2),('15529','2013-06-10','11:55:00',2.23),('15529','2013-06-10','12:00:00',2.29),('15529','2013-06-10','12:05:00',2.23),('15529','2013-06-10','12:10:00',2.25),('15529','2013-06-10','12:15:00',2.28),('15529','2013-06-10','12:20:00',2.3),('15529','2013-06-10','12:25:00',2.25),('15529','2013-06-10','12:30:00',2.29),('15529','2013-06-10','12:35:00',2.18),('15529','2013-06-10','12:40:00',2.05),('15529','2013-06-10','12:45:00',2.27),('15529','2013-06-10','12:50:00',2.31),('15529','2013-06-10','12:55:00',2.33),('15529','2013-06-10','13:00:00',2.3),('15529','2013-06-10','13:05:00',2.35),('15529','2013-06-10','13:10:00',2.31),('15529','2013-06-10','13:15:00',2.3),('15529','2013-06-10','13:20:00',2.33),('15529','2013-06-10','13:25:00',2.37),('15529','2013-06-10','13:30:00',2.34),('15529','2013-06-10','13:35:00',2.3),('15529','2013-06-10','13:40:00',1.71),('15529','2013-06-10','13:45:00',2.18),('15529','2013-06-10','13:50:00',2.27),('15529','2013-06-10','13:55:00',2.3),('15529','2013-06-10','14:00:00',2.25),('15529','2013-06-10','14:05:00',2.23),('15529','2013-06-10','14:10:00',2.24),('15529','2013-06-10','14:15:00',2.26),('15529','2013-06-10','14:20:00',2.21),('15529','2013-06-10','14:25:00',2.19),('15529','2013-06-10','14:30:00',2.2),('15529','2013-06-10','14:35:00',2.19),('15529','2013-06-10','14:40:00',2.14),('15529','2013-06-10','14:45:00',2.15),('15529','2013-06-10','14:50:00',2.13),('15529','2013-06-10','14:55:00',2.11),('15529','2013-06-10','15:00:00',2.05),('15529','2013-06-10','15:05:00',2.05),('15529','2013-06-10','15:10:00',2.04),('15529','2013-06-10','15:15:00',1.99),('15529','2013-06-10','15:20:00',1.96),('15529','2013-06-10','15:25:00',1.88),('15529','2013-06-10','15:30:00',1.54),('15529','2013-06-10','15:35:00',1.94),('15529','2013-06-10','15:40:00',1.67),('15529','2013-06-10','15:45:00',1.76),('15529','2013-06-10','15:50:00',1.76),('15529','2013-06-10','15:55:00',1.61),('15529','2013-06-10','16:00:00',1.81),('15529','2013-06-10','16:05:00',1.76),('15529','2013-06-10','16:10:00',1.71),('15529','2013-06-10','16:15:00',1.67),('15529','2013-06-10','16:20:00',1.64),('15529','2013-06-10','16:25:00',1.6),('15529','2013-06-10','16:30:00',1.57),('15529','2013-06-10','16:35:00',1.53),('15529','2013-06-10','16:40:00',1.51),('15529','2013-06-10','16:45:00',1.53),('15529','2013-06-10','16:50:00',1.52),('15529','2013-06-10','16:55:00',1.46),('15529','2014-04-02','09:55:00',1.01),('15529','2014-04-02','10:00:00',1.24),('15529','2014-04-02','10:05:00',1.41),('15529','2014-04-02','10:10:00',1.52),('15529','2014-04-02','10:15:00',1.77),('15529','2014-04-02','10:20:00',1.67),('15529','2014-04-02','10:25:00',1.59),('15529','2014-04-02','10:30:00',1.53),('15529','2014-04-02','10:35:00',1.53),('15529','2014-04-02','10:40:00',1.22),('15529','2014-04-02','10:45:00',1.3),('15529','2014-04-02','10:50:00',1.06),('15529','2014-04-02','10:55:00',1.14),('15529','2014-04-02','11:50:00',1.15),('15529','2014-04-02','11:55:00',1.19),('15529','2014-04-02','12:00:00',1.15),('15529','2014-04-02','12:05:00',1.14),('15529','2014-04-02','12:10:00',1.09),('15529','2014-04-02','12:15:00',1.09),('15529','2014-04-02','12:20:00',1.32),('15529','2014-04-02','12:25:00',1.67),('15529','2014-04-02','12:30:00',2.15),('15529','2014-04-02','12:35:00',2.01),('15529','2014-04-02','12:40:00',1.91),('15529','2014-04-02','12:45:00',1.19),('15529','2014-04-02','12:50:00',1.5),('15529','2014-04-02','12:55:00',1.42),('15529','2014-04-02','13:00:00',1.22),('15529','2014-04-02','13:05:00',1.65),('15529','2014-04-02','13:10:00',1.61),('15529','2014-04-02','13:15:00',2.1),('15529','2014-04-02','13:20:00',1.14),('15529','2014-04-02','13:25:00',1.31),('15529','2014-04-02','13:30:00',1.8),('15529','2014-04-02','13:35:00',2.38),('15529','2014-04-02','13:40:00',1.95),('15529','2014-04-02','13:45:00',1.04),('15529','2014-04-02','13:50:00',1.12),('15529','2014-04-02','13:55:00',1.64),('15529','2014-04-02','14:00:00',1.91),('15529','2014-04-02','14:05:00',1.86),('15529','2014-04-02','14:10:00',1.54),('15529','2014-04-02','14:15:00',2.06),('15529','2014-04-02','14:20:00',1.99),('15529','2014-04-02','14:25:00',2.04),('15529','2014-04-02','14:30:00',2.22),('15529','2014-04-02','14:35:00',2.21),('15529','2014-04-02','14:40:00',2.07),('15529','2014-04-02','14:45:00',2.09),('15529','2014-04-02','14:50:00',2.05),('15529','2014-04-02','14:55:00',1.98),('15529','2014-04-02','15:00:00',1.99),('15529','2014-04-02','15:05:00',1.97),('15529','2014-04-02','15:10:00',1.94),('15529','2014-04-02','15:15:00',1.91),('15529','2014-04-02','15:20:00',1.93),('15529','2014-04-02','15:25:00',1.9),('15529','2014-04-02','15:30:00',1.85),('15529','2014-04-02','15:35:00',1.85),('15529','2014-04-02','15:40:00',1.83),('15529','2014-04-02','15:45:00',1.81),('15529','2014-04-02','15:50:00',1.81),('15529','2014-04-02','15:55:00',1.79),('15529','2014-04-02','16:00:00',1.76),('15529','2014-04-02','16:05:00',1.71),('15529','2014-04-02','16:10:00',1.71),('15529','2014-04-02','16:15:00',1.65),('15529','2014-04-02','16:20:00',1.56),('15529','2014-04-02','16:25:00',1.51),('15529','2014-04-02','16:30:00',1.49),('15529','2014-04-02','16:35:00',1.43),('15529','2014-04-02','16:40:00',1.39),('15529','2014-04-02','16:45:00',1.3),('15529','2014-04-02','16:50:00',1.04),('15529','2013-06-09','09:15:00',1.07),('15529','2013-06-09','09:20:00',1.45),('15529','2013-06-09','09:25:00',1.5),('15529','2013-06-09','09:45:00',1.28),('15529','2013-06-09','09:50:00',1.4),('15529','2013-06-09','10:00:00',1.15),('15529','2013-06-09','10:05:00',1.6),('15529','2013-06-09','10:10:00',1.57),('15529','2013-06-09','10:15:00',1.67),('15529','2013-06-09','10:20:00',1.08),('15529','2013-06-09','10:30:00',1.08),('15529','2013-06-09','10:50:00',1.39),('15529','2013-06-09','10:55:00',1.01),('15529','2013-06-09','11:05:00',1.47),('15529','2013-06-09','11:10:00',1.94),('15529','2013-06-09','11:15:00',2.26),('15529','2013-06-09','11:20:00',2.09),('15529','2013-06-09','11:25:00',2.11),('15529','2013-06-09','11:35:00',1.58),('15529','2013-06-09','11:40:00',2.09),('15529','2013-06-09','11:45:00',1.8),('15529','2013-06-09','11:50:00',2.2),('15529','2013-06-09','11:55:00',1.61),('15529','2013-06-09','12:05:00',1.13),('15529','2013-06-09','12:10:00',1.26),('15529','2013-06-09','12:15:00',1.81),('15529','2013-06-09','12:20:00',2.59),('15529','2013-06-09','12:25:00',1.65),('15529','2013-06-09','12:30:00',1.68),('15529','2013-06-09','12:35:00',1.6),('15529','2013-06-09','12:40:00',2.41),('15529','2013-06-09','12:45:00',2.04),('15529','2013-06-09','12:50:00',2.09),('15529','2013-06-09','12:55:00',2.41),('15529','2013-06-09','13:00:00',1.43),('15529','2013-06-09','13:05:00',1.2),('15529','2013-06-09','13:10:00',2.56),('15529','2013-06-09','13:15:00',2.02),('15529','2013-06-09','13:20:00',1.47),('15529','2013-06-09','13:25:00',1.73),('15529','2013-06-09','13:30:00',2.5),('15529','2013-06-09','13:35:00',2.57),('15529','2013-06-09','13:40:00',2.2),('15529','2013-06-09','13:45:00',1.46),('15529','2013-06-09','13:50:00',1.8),('15529','2013-06-09','13:55:00',2.31),('15529','2013-06-09','14:00:00',1.59),('15529','2013-06-09','14:05:00',1.18),('15529','2013-06-09','14:10:00',1.72),('15529','2013-06-09','14:15:00',2.36),('15529','2013-06-09','14:20:00',2.3),('15529','2013-06-09','14:25:00',2.25),('15529','2013-06-09','14:30:00',2.26),('15529','2013-06-09','14:35:00',1.14),('15529','2013-06-09','14:40:00',2.18),('15529','2013-06-09','14:45:00',2.14),('15529','2013-06-09','14:50:00',2.15),('15529','2013-06-09','14:55:00',2.11),('15529','2013-06-09','15:00:00',2.11),('15529','2013-06-09','15:05:00',2.06),('15529','2013-06-09','15:10:00',2.07),('15529','2013-06-09','15:15:00',2.04),('15529','2013-06-09','15:20:00',2.01),('15529','2013-06-09','15:25:00',1.98),('15529','2013-06-09','15:30:00',1.98),('15529','2013-06-09','15:35:00',1.95),('15529','2013-06-09','15:40:00',1.93),('15529','2013-06-09','15:45:00',1.89),('15529','2013-06-09','15:50:00',1.86),('15529','2013-06-09','15:55:00',1.85),('15529','2013-06-09','16:00:00',1.81),('15529','2013-06-09','16:05:00',1.76),('15529','2013-06-09','16:10:00',1.73),('15529','2013-06-09','16:15:00',1.69),('15529','2013-06-09','16:20:00',1.66),('15529','2013-06-09','16:25:00',1.62),('15529','2013-06-09','16:30:00',1.59),('15529','2013-06-09','16:35:00',1.55),('15529','2013-06-09','16:40:00',1.51),('15529','2013-06-09','16:45:00',1.48),('15529','2013-06-09','16:50:00',1.44),('15529','2013-06-09','16:55:00',1.39),('15529','2013-06-09','17:00:00',1.34),('15529','2013-06-09','17:05:00',1.3),('15529','2013-06-09','17:10:00',1.26),('15529','2013-06-09','17:15:00',1.22),('15529','2013-06-09','17:20:00',1.18),('15529','2013-06-09','17:25:00',1.12),('15529','2013-06-09','17:30:00',1.08),('15529','2013-06-09','17:35:00',1.02),('15529','2013-06-08','08:40:00',1.03),('15529','2013-06-08','08:45:00',1.03),('15529','2013-06-08','08:50:00',1.07),('15529','2013-06-08','08:55:00',1.09),('15529','2013-06-08','09:00:00',1.14),('15529','2013-06-08','09:05:00',1.18),('15529','2013-06-08','09:10:00',1.24),('15529','2013-06-08','09:15:00',1.28),('15529','2013-06-08','09:20:00',1.3),('15529','2013-06-08','09:25:00',1.34),('15529','2013-06-08','09:30:00',1.37),('15529','2013-06-08','09:35:00',1.42),('15529','2013-06-08','09:40:00',1.45),('15529','2013-06-08','09:45:00',1.5),('15529','2013-06-08','09:50:00',1.53),('15529','2013-06-08','09:55:00',1.58),('15529','2013-06-08','10:00:00',1.6),('15529','2013-06-08','10:05:00',1.64),('15529','2013-06-08','10:10:00',1.65),('15529','2013-06-08','10:15:00',1.66),('15529','2013-06-08','10:20:00',1.73),('15529','2013-06-08','10:25:00',1.74),('15529','2013-06-08','10:30:00',1.76),('15529','2013-06-08','10:35:00',1.81),('15529','2013-06-08','10:40:00',1.82),('15529','2013-06-08','10:45:00',1.82),('15529','2013-06-08','10:50:00',1.84),('15529','2013-06-08','10:55:00',1.9),('15529','2013-06-08','11:00:00',1.92),('15529','2013-06-08','11:05:00',1.94),('15529','2013-06-08','11:10:00',1.96),('15529','2013-06-08','11:15:00',1.96),('15529','2013-06-08','11:20:00',1.93),('15529','2013-06-08','11:25:00',1.97),('15529','2013-06-08','11:30:00',1.95),('15529','2013-06-08','11:35:00',1.96),('15529','2013-06-08','11:40:00',1.96),('15529','2013-06-08','11:45:00',1.97),('15529','2013-06-08','11:50:00',2.04),('15529','2013-06-08','11:55:00',2.05),('15529','2013-06-08','12:00:00',2.08),('15529','2013-06-08','12:05:00',2.09),('15529','2013-06-08','12:10:00',2),('15529','2013-06-08','12:15:00',2.17),('15529','2013-06-08','12:20:00',2.16),('15529','2013-06-08','12:25:00',2.17),('15529','2013-06-08','12:30:00',2.19),('15529','2013-06-08','12:35:00',2.19),('15529','2013-06-08','12:40:00',2.12),('15529','2013-06-08','12:45:00',2.05),('15529','2013-06-08','12:50:00',1.99),('15529','2013-06-08','12:55:00',2.28),('15529','2013-06-08','13:00:00',1.9),('15529','2013-06-08','13:05:00',1.72),('15529','2013-06-08','13:10:00',2.06),('15529','2013-06-08','13:15:00',2.22),('15529','2013-06-08','13:20:00',1.89),('15529','2013-06-08','13:25:00',1.76),('15529','2013-06-08','13:30:00',2.21),('15529','2013-06-08','13:35:00',2.29),('15529','2013-06-08','13:40:00',1.81),('15529','2013-06-08','13:45:00',2.43),('15529','2013-06-08','13:50:00',1.94),('15529','2013-06-08','13:55:00',2.32),('15529','2013-06-08','14:00:00',2.39),('15529','2013-06-08','14:05:00',1.95),('15529','2013-06-08','14:10:00',2.4),('15529','2013-06-08','14:15:00',1.95),('15529','2013-06-08','14:30:00',1.01),('15529','2013-06-08','14:35:00',2.23),('15529','2013-06-08','14:40:00',1.69),('15529','2013-06-08','14:45:00',2.02),('15529','2013-06-08','14:50:00',2.13),('15529','2013-06-08','14:55:00',2.1),('15529','2013-06-08','15:00:00',2.1),('15529','2013-06-08','15:05:00',2.04),('15529','2013-06-08','15:10:00',2.01),('15529','2013-06-08','15:15:00',1.94),('15529','2013-06-08','15:20:00',1.98),('15529','2013-06-08','15:25:00',1.98),('15529','2013-06-08','15:30:00',1.89),('15529','2013-06-08','15:35:00',1.94),('15529','2013-06-08','15:40:00',1.35),('15529','2013-06-08','15:45:00',1.6),('15529','2013-06-08','15:50:00',1.73),('15529','2013-06-08','15:55:00',1.81),('15529','2013-06-08','16:00:00',1.64),('15529','2013-06-08','16:05:00',1.61),('15529','2013-06-08','16:10:00',1.63),('15529','2013-06-08','16:15:00',1.11),('15529','2013-06-08','16:20:00',1.2),('15529','2013-06-07','08:40:00',1.01),('15529','2013-06-07','08:45:00',1.05),('15529','2013-06-07','08:50:00',1.1),('15529','2013-06-07','08:55:00',1.13),('15529','2013-06-07','09:00:00',1.16),('15529','2013-06-07','09:05:00',1.22),('15529','2013-06-07','09:10:00',1.25),('15529','2013-06-07','09:15:00',1.3),('15529','2013-06-07','09:20:00',1.35),('15529','2013-06-07','09:25:00',1.36),('15529','2013-06-07','09:30:00',1.39),('15529','2013-06-07','09:35:00',1.39),('15529','2013-06-07','09:40:00',1.45),('15529','2013-06-07','09:45:00',1.5),('15529','2013-06-07','09:50:00',1.57),('15529','2013-06-07','09:55:00',1.53),('15529','2013-06-07','10:00:00',1.1),('15529','2013-06-07','10:05:00',1.71),('15529','2013-06-07','10:10:00',1.73),('15529','2013-06-07','10:15:00',1.85),('15529','2013-06-07','10:20:00',1.85),('15529','2013-06-07','10:25:00',1.82),('15529','2013-06-07','10:30:00',1.23),('15529','2013-06-07','10:35:00',1.42),('15529','2013-06-07','10:40:00',1.39),('15529','2013-06-07','10:45:00',1.69),('15529','2013-06-07','10:50:00',2.13),('15529','2013-06-07','10:55:00',1.19),('15529','2013-06-07','11:25:00',1.06),('15529','2013-06-07','11:30:00',2.24),('15529','2013-06-07','11:35:00',2.28),('15529','2013-06-07','11:40:00',2.22),('15529','2013-06-07','11:45:00',1.48),('15529','2013-06-07','11:50:00',2.25),('15529','2013-06-07','11:55:00',2.36),('15529','2013-06-07','12:00:00',2.09),('15529','2013-06-07','12:10:00',2.26),('15529','2013-06-07','12:15:00',2.37),('15529','2013-06-07','12:20:00',2.36),('15529','2013-06-07','12:25:00',2.23),('15529','2013-06-07','12:30:00',2.18),('15529','2013-06-07','12:35:00',2.26),('15529','2013-06-07','12:40:00',2.19),('15529','2013-06-07','12:45:00',2.22),('15529','2013-06-07','12:50:00',2.32),('15529','2013-06-07','12:55:00',2.21),('15529','2013-06-07','13:00:00',2.34),('15529','2013-06-07','13:05:00',2.29),('15529','2013-06-07','13:10:00',2.27),('15529','2013-06-07','13:15:00',2.31),('15529','2013-06-07','13:20:00',2.34),('15529','2013-06-07','13:25:00',2.31),('15529','2013-06-07','13:30:00',2.32),('15529','2013-06-07','13:35:00',2.29),('15529','2013-06-07','13:40:00',2.27),('15529','2013-06-07','13:45:00',2.29),('15529','2013-06-07','13:50:00',2.28),('15529','2013-06-07','13:55:00',2.25),('15529','2013-06-07','14:00:00',2.23),('15529','2013-06-07','14:05:00',2.27),('15529','2013-06-07','14:10:00',2.25),('15529','2013-06-07','14:15:00',2.2),('15529','2013-06-07','14:20:00',2.2),('15529','2013-06-07','14:25:00',2.22),('15529','2013-06-07','14:30:00',2.17),('15529','2013-06-07','14:35:00',2.17),('15529','2013-06-07','14:40:00',2.15),('15529','2013-06-07','14:45:00',2.12),('15529','2013-06-07','14:50:00',2.11),('15529','2013-06-07','14:55:00',2.12),('15529','2013-06-07','15:00:00',2.09),('15529','2013-06-07','15:05:00',2),('15529','2013-06-07','15:10:00',1.84),('15529','2013-06-07','15:15:00',2.01),('15529','2013-06-07','15:20:00',2.02),('15529','2013-06-07','15:25:00',1.84),('15529','2013-06-07','15:30:00',1.88),('15529','2013-06-07','15:35:00',1.79),('15529','2013-06-07','15:40:00',1.83),('15529','2013-06-07','15:45:00',2.02),('15529','2013-06-07','15:50:00',1.95),('15529','2013-06-07','15:55:00',1.79),('15529','2013-06-07','16:00:00',1.8),('15529','2013-06-07','16:05:00',1.75),('15529','2013-06-07','16:10:00',1.74),('15529','2013-06-07','16:15:00',1.71),('15529','2013-06-07','16:20:00',1.68),('15529','2013-06-07','16:25:00',1.6),('15529','2013-06-07','16:30:00',1.54),('15529','2013-06-07','16:35:00',1.5),('15529','2013-06-07','16:40:00',1.46),('15529','2013-06-07','16:45:00',1.39),('15529','2013-06-07','16:50:00',1.17),('15529','2013-06-07','16:55:00',1.32),('15529','2013-06-07','17:00:00',1.31),('15529','2013-06-07','17:05:00',1.29),('15529','2013-06-07','17:10:00',1.32),('15529','2013-06-07','17:15:00',1.26),('15529','2013-06-07','17:20:00',1.18),('15529','2013-06-07','17:25:00',1.08),('15529','2013-06-07','17:40:00',1.05),('15529','2013-06-06','08:40:00',1.04),('15529','2013-06-06','08:45:00',1.09),('15529','2013-06-06','08:50:00',1.13),('15529','2013-06-06','08:55:00',1.18),('15529','2013-06-06','09:00:00',1.22),('15529','2013-06-06','09:05:00',1.26),('15529','2013-06-06','09:10:00',1.31),('15529','2013-06-06','09:15:00',1.34),('15529','2013-06-06','09:20:00',1.38),('15529','2013-06-06','09:25:00',1.42),('15529','2013-06-06','09:30:00',1.46),('15529','2013-06-06','09:35:00',1.5),('15529','2013-06-06','09:40:00',1.53),('15529','2013-06-06','09:45:00',1.57),('15529','2013-06-06','09:50:00',1.61),('15529','2013-06-06','09:55:00',1.65),('15529','2013-06-06','10:00:00',1.7),('15529','2013-06-06','10:05:00',1.72),('15529','2013-06-06','10:10:00',1.76),('15529','2013-06-06','10:15:00',1.78),('15529','2013-06-06','10:20:00',1.82),('15529','2013-06-06','10:25:00',1.85),('15529','2013-06-06','10:30:00',1.88),('15529','2013-06-06','10:35:00',1.91),('15529','2013-06-06','10:40:00',1.93),('15529','2013-06-06','10:45:00',1.95),('15529','2013-06-06','10:50:00',1.98),('15529','2013-06-06','10:55:00',2.01),('15529','2013-06-06','11:00:00',2.04),('15529','2013-06-06','11:05:00',2.06),('15529','2013-06-06','11:10:00',2.08),('15529','2013-06-06','11:15:00',2.09),('15529','2013-06-06','11:20:00',2.11),('15529','2013-06-06','11:25:00',2.14),('15529','2013-06-06','11:30:00',2.11),('15529','2013-06-06','11:35:00',2.16),('15529','2013-06-06','11:40:00',2.19),('15529','2013-06-06','11:45:00',2.22),('15529','2013-06-06','11:50:00',2.21),('15529','2013-06-06','11:55:00',2.22),('15529','2013-06-06','12:00:00',2.24),('15529','2013-06-06','12:05:00',2.2),('15529','2013-06-06','12:10:00',2.26),('15529','2013-06-06','12:15:00',2.27),('15529','2013-06-06','12:20:00',2.25),('15529','2013-06-06','12:25:00',2.26),('15529','2013-06-06','12:30:00',2.29),('15529','2013-06-06','12:35:00',2.28),('15529','2013-06-06','12:40:00',2.3),('15529','2013-06-06','12:45:00',2.3),('15529','2013-06-06','12:50:00',2.24),('15529','2013-06-06','12:55:00',2.25),('15529','2013-06-06','13:00:00',2.28),('15529','2013-06-06','13:05:00',2.3),('15529','2013-06-06','13:10:00',2.31),('15529','2013-06-06','13:15:00',2.28),('15529','2013-06-06','13:20:00',2.28),('15529','2013-06-06','13:25:00',2.26),('15529','2013-06-06','13:30:00',2.28),('15529','2013-06-06','13:35:00',2.25),('15529','2013-06-06','13:40:00',2.25),('15529','2013-06-06','13:45:00',2.22),('15529','2013-06-06','13:50:00',2.22),('15529','2013-06-06','13:55:00',2.23),('15529','2013-06-06','14:00:00',2.2),('15529','2013-06-06','14:05:00',2.19),('15529','2013-06-06','14:10:00',2.16),('15529','2013-06-06','14:15:00',2.18),('15529','2013-06-06','14:20:00',2.14),('15529','2013-06-06','14:25:00',2.1),('15529','2013-06-06','14:30:00',2.1),('15529','2013-06-06','14:35:00',2.05),('15529','2013-06-06','14:40:00',2.09),('15529','2013-06-06','14:45:00',2.04),('15529','2013-06-06','14:50:00',2.03),('15529','2013-06-06','14:55:00',2.02),('15529','2013-06-06','15:00:00',1.41),('15529','2013-06-06','15:05:00',2.09),('15529','2013-06-06','15:10:00',1.99),('15529','2013-06-06','15:15:00',2),('15529','2013-06-06','15:20:00',1.97),('15529','2013-06-06','15:25:00',1.95),('15529','2013-06-06','15:30:00',1.9),('15529','2013-06-06','15:35:00',1.86),('15529','2013-06-06','15:40:00',1.86),('15529','2013-06-06','15:45:00',1.83),('15529','2013-06-06','15:50:00',1.79),('15529','2013-06-06','15:55:00',1.76),('15529','2013-06-06','16:00:00',1.72),('15529','2013-06-06','16:05:00',1.66),('15529','2013-06-06','16:10:00',1.59),('15529','2013-06-06','16:15:00',1.55),('15529','2013-06-06','16:20:00',1.58),('15529','2013-06-06','16:25:00',1.57),('15529','2013-06-06','16:30:00',1.53),('15529','2013-06-06','16:35:00',1.5),('15529','2013-06-06','16:40:00',1.46),('15529','2013-06-06','16:45:00',1.42),('15529','2013-06-06','16:50:00',1.37),('15529','2013-06-06','16:55:00',1.33),('15529','2013-06-06','17:00:00',1.29),('15529','2013-06-06','17:05:00',1.25),('15529','2013-06-06','17:10:00',1.2),('15529','2013-06-06','17:15:00',1.16),('15529','2013-06-06','17:20:00',1.11),('15529','2013-06-06','17:25:00',1.08),('15529','2013-06-06','17:30:00',1.03),('15529','2013-06-05','08:45:00',1.07),('15529','2013-06-05','08:50:00',1.11),('15529','2013-06-05','08:55:00',1.17),('15529','2013-06-05','09:00:00',1.2),('15529','2013-06-05','09:05:00',1.24),('15529','2013-06-05','09:10:00',1.28),('15529','2013-06-05','09:15:00',1.34),('15529','2013-06-05','09:20:00',1.39),('15529','2013-06-05','09:25:00',1.41),('15529','2013-06-05','09:30:00',1.45),('15529','2013-06-05','09:35:00',1.47),('15529','2013-06-05','09:40:00',1.52),('15529','2013-06-05','09:45:00',1.57),('15529','2013-06-05','09:50:00',1.61),('15529','2013-06-05','09:55:00',1.61),('15529','2013-06-05','10:00:00',1.63),('15529','2013-06-05','10:05:00',1.7),('15529','2013-06-05','10:10:00',1.73),('15529','2013-06-05','10:15:00',1.72),('15529','2013-06-05','10:20:00',1.76),('15529','2013-06-05','10:25:00',1.8),('15529','2013-06-05','10:30:00',1.82),('15529','2013-06-05','10:35:00',1.87),('15529','2013-06-05','10:40:00',1.9),('15529','2013-06-05','10:45:00',1.9),('15529','2013-06-05','10:50:00',1.95),('15529','2013-06-05','10:55:00',1.99),('15529','2013-06-05','11:00:00',1.98),('15529','2013-06-05','11:05:00',2.01),('15529','2013-06-05','11:10:00',2.04),('15529','2013-06-05','11:15:00',2.03),('15529','2013-06-05','11:20:00',2.06),('15529','2013-06-05','11:25:00',2.07),('15529','2013-06-05','11:30:00',2.1),('15529','2013-06-05','11:35:00',2.07),('15529','2013-06-05','11:40:00',2.13),('15529','2013-06-05','11:45:00',2.15),('15529','2013-06-05','11:50:00',2.14),('15529','2013-06-05','11:55:00',2.17),('15529','2013-06-05','12:00:00',2.18),('15529','2013-06-05','12:05:00',2.16),('15529','2013-06-05','12:10:00',2.23),('15529','2013-06-05','12:15:00',2.22),('15529','2013-06-05','12:20:00',2.2),('15529','2013-06-05','12:25:00',2.21),('15529','2013-06-05','12:30:00',2.18),('15529','2013-06-05','12:35:00',1.93),('15529','2013-06-05','12:40:00',2.15),('15529','2013-06-05','12:45:00',2.24),('15529','2013-06-05','12:50:00',1.89),('15529','2013-06-05','12:55:00',1.96),('15529','2013-06-05','13:00:00',2.35),('15529','2013-06-05','13:05:00',2.33),('15529','2013-06-05','13:10:00',2.37),('15529','2013-06-05','13:15:00',2.3),('15529','2013-06-05','13:20:00',2.3),('15529','2013-06-05','13:25:00',2.28),('15529','2013-06-05','13:30:00',2.31),('15529','2013-06-05','13:35:00',2.32),('15529','2013-06-05','13:40:00',2.34),('15529','2013-06-05','13:45:00',2.33),('15529','2013-06-05','13:50:00',2.25),('15529','2013-06-05','13:55:00',2.19),('15529','2013-06-05','14:00:00',2.21),('15529','2013-06-05','14:05:00',2.17),('15529','2013-06-05','14:10:00',2.15),('15529','2013-06-05','14:15:00',2.14),('15529','2013-06-05','14:20:00',2.05),('15529','2013-06-05','14:25:00',2.12),('15529','2013-06-05','14:30:00',2.09),('15529','2013-06-05','14:35:00',2.08),('15529','2013-06-05','14:40:00',2.12),('15529','2013-06-05','14:45:00',2.13),('15529','2013-06-05','14:50:00',2.08),('15529','2013-06-05','14:55:00',2.08),('15529','2013-06-05','15:00:00',2.05),('15529','2013-06-05','15:05:00',2.01),('15529','2013-06-05','15:10:00',2.02),('15529','2013-06-05','15:15:00',1.98),('15529','2013-06-05','15:20:00',1.96),('15529','2013-06-05','15:25:00',1.87),('15529','2013-06-05','15:30:00',1.85),('15529','2013-06-05','15:35:00',1.81),('15529','2013-06-05','15:40:00',1.73),('15529','2013-06-05','15:45:00',1.78),('15529','2013-06-05','15:50:00',1.77),('15529','2013-06-05','15:55:00',1.72),('15529','2013-06-05','16:00:00',1.75),('15529','2013-06-05','16:05:00',1.72),('15529','2013-06-05','16:10:00',1.64),('15529','2013-06-05','16:15:00',1.61),('15529','2013-06-05','16:20:00',1.55),('15529','2013-06-05','16:25:00',1.53),('15529','2013-06-05','16:30:00',1.51),('15529','2013-06-05','16:35:00',1.46),('15529','2013-06-05','16:40:00',1.43),('15529','2013-06-05','16:45:00',1.39),('15529','2013-06-05','16:50:00',1.35),('15529','2013-06-05','16:55:00',1.31),('15529','2013-06-05','17:00:00',1.26),('15529','2013-06-05','17:05:00',1.21),('15529','2013-06-05','17:10:00',1.17),('15529','2013-06-05','17:15:00',1.14),('15529','2013-06-05','17:20:00',1.09),('15529','2013-06-05','17:25:00',1.04),('15529','2013-06-05','17:30:00',1.01),('15529','2013-06-04','08:40:00',1.04),('15529','2013-06-04','08:45:00',1.08),('15529','2013-06-04','08:50:00',1.13),('15529','2013-06-04','08:55:00',1.2),('15529','2013-06-04','09:00:00',1.23),('15529','2013-06-04','09:05:00',1.37),('15529','2013-06-04','09:10:00',1.48),('15529','2013-06-04','09:25:00',1),('15529','2013-06-04','09:35:00',1.53),('15529','2013-06-04','09:40:00',1.46),('15529','2013-06-04','09:45:00',1.1),('15529','2013-06-04','09:50:00',1.02),('15529','2013-06-04','10:05:00',1.53),('15529','2013-06-04','10:10:00',1.93),('15529','2013-06-04','10:15:00',1.17),('15529','2013-06-04','10:40:00',1.25),('15529','2013-06-04','10:45:00',1.97),('15529','2013-06-04','10:50:00',2.18),('15529','2013-06-04','10:55:00',2.19),('15529','2013-06-04','11:00:00',2.17),('15529','2013-06-04','11:05:00',1.94),('15529','2013-06-04','11:10:00',2.14),('15529','2013-06-04','11:15:00',2.23),('15529','2013-06-04','11:20:00',2.37),('15529','2013-06-04','11:25:00',2.42),('15529','2013-06-04','11:30:00',2.42),('15529','2013-06-04','11:35:00',2.43),('15529','2013-06-04','11:40:00',2.41),('15529','2013-06-04','11:45:00',1.76),('15529','2013-06-04','11:50:00',2.38),('15529','2013-06-04','11:55:00',2.4),('15529','2013-06-04','12:00:00',2.43),('15529','2013-06-04','12:05:00',2.42),('15529','2013-06-04','12:10:00',2.51),('15529','2013-06-04','12:15:00',2.13),('15529','2013-06-04','12:35:00',1.29),('15529','2013-06-04','12:40:00',2.38),('15529','2013-06-04','12:45:00',2.15),('15529','2013-06-04','12:50:00',2.24),('15529','2013-06-04','12:55:00',1.86),('15529','2013-06-04','13:00:00',1.9),('15529','2013-06-04','13:05:00',2.15),('15529','2013-06-04','13:10:00',1.6),('15529','2013-06-04','13:15:00',2.59),('15529','2013-06-04','13:20:00',1.97),('15529','2013-06-04','13:25:00',2.59),('15529','2013-06-04','13:30:00',2.15),('15529','2013-06-04','13:35:00',2.39),('15529','2013-06-04','13:40:00',2.26),('15529','2013-06-04','13:45:00',2.38),('15529','2013-06-04','13:50:00',2.35),('15529','2013-06-04','13:55:00',2.36),('15529','2013-06-04','14:00:00',2.31),('15529','2013-06-04','14:05:00',2.32),('15529','2013-06-04','14:10:00',2.28),('15529','2013-06-04','14:15:00',2.26),('15529','2013-06-04','14:20:00',2.27),('15529','2013-06-04','14:25:00',2.22),('15529','2013-06-04','14:30:00',2.22),('15529','2013-06-04','14:35:00',2.21),('15529','2013-06-04','14:40:00',2.19),('15529','2013-06-04','14:45:00',2.14),('15529','2013-06-04','14:50:00',2.17),('15529','2013-06-04','14:55:00',2.14),('15529','2013-06-04','15:00:00',2.09),('15529','2013-06-04','15:05:00',2.06),('15529','2013-06-04','15:10:00',2.05),('15529','2013-06-04','15:15:00',2.04),('15529','2013-06-04','15:20:00',2.04),('15529','2013-06-04','15:25:00',1.97),('15529','2013-06-04','15:30:00',1.5),('15529','2013-06-04','15:35:00',1.99),('15529','2013-06-04','15:40:00',1.42),('15529','2013-06-04','15:45:00',1.95),('15529','2013-06-04','15:50:00',1.89),('15529','2013-06-04','15:55:00',1.86),('15529','2013-06-04','16:00:00',1.59),('15529','2013-06-04','16:05:00',1.86),('15529','2013-06-04','16:10:00',1.7),('15529','2013-06-04','16:15:00',1.7),('15529','2013-06-04','16:20:00',1.67),('15529','2013-06-04','16:25:00',1.64),('15529','2013-06-04','16:30:00',1.58),('15529','2013-06-04','16:35:00',1.18),('15529','2013-06-04','16:40:00',1.2),('15529','2013-06-04','16:45:00',1.59),('15529','2013-06-04','16:50:00',1.28),('15529','2013-06-04','16:55:00',1.37),('15529','2013-06-04','17:05:00',1.1),('15529','2013-06-04','17:15:00',1.4),('15529','2013-06-04','17:20:00',1.26),('15529','2013-06-04','17:25:00',1.16),('15529','2013-06-04','17:35:00',1.02),('15529','2013-06-03','08:10:00',1.07),('15529','2013-06-03','08:15:00',1.11),('15529','2013-06-03','08:20:00',1.15),('15529','2013-06-03','08:25:00',1.09),('15529','2013-06-03','08:30:00',1.03),('15529','2013-06-03','09:15:00',1.53),('15529','2013-06-03','09:20:00',1.53),('15529','2013-06-03','09:25:00',1.61),('15529','2013-06-03','09:30:00',1.18),('15529','2013-06-03','09:40:00',1.21),('15529','2013-06-03','09:45:00',1.13),('15529','2013-06-03','09:50:00',1.11),('15529','2013-06-03','10:20:00',1.09),('15529','2013-06-03','10:40:00',1.06),('15529','2013-06-03','10:45:00',1.22),('15529','2013-06-03','10:50:00',1.27),('15529','2013-06-03','10:55:00',1.36),('15529','2013-06-03','11:00:00',1.23),('15529','2013-06-03','11:05:00',1.76),('15529','2013-06-03','11:10:00',1.82),('15529','2013-06-03','11:15:00',1.46),('15529','2013-06-03','11:20:00',1.21),('15529','2013-06-03','11:25:00',1.34),('15529','2013-06-03','11:30:00',1.48),('15529','2013-06-03','11:35:00',1.51),('15529','2013-06-03','11:40:00',1.69),('15529','2013-06-03','11:45:00',1.78),('15529','2013-06-03','11:50:00',2.33),('15529','2013-06-03','11:55:00',2.33),('15529','2013-06-03','12:00:00',1.24),('15529','2013-06-03','12:05:00',1.69),('15529','2013-06-03','12:10:00',1.48),('15529','2013-06-03','12:15:00',1.32),('15529','2013-06-03','12:20:00',1.68),('15529','2013-06-03','12:25:00',1.08),('15529','2013-06-03','12:55:00',1.26),('15529','2013-06-03','13:00:00',1.85),('15529','2013-06-03','13:30:00',2.1),('15529','2013-06-03','13:35:00',2.72),('15529','2013-06-03','13:40:00',2.76),('15529','2013-06-03','13:45:00',2.77),('15529','2013-06-03','13:50:00',1.59),('15529','2013-06-03','13:55:00',1.22),('15529','2013-06-03','14:00:00',2.35),('15529','2013-06-03','14:05:00',2.36),('15529','2013-06-03','14:10:00',1.22),('15529','2013-06-03','14:40:00',1.3),('15529','2013-06-03','14:45:00',1.07),('15529','2013-06-03','14:50:00',1.33),('15529','2013-06-03','14:55:00',2.61),('15529','2013-06-03','15:00:00',1.75),('15529','2013-06-03','15:10:00',2.45),('15529','2013-06-03','15:25:00',1.11),('15529','2013-06-03','15:30:00',1.14),('15529','2013-06-02','08:35:00',1),('15529','2013-06-02','08:40:00',1.05),('15529','2013-06-02','08:45:00',1.1),('15529','2013-06-02','08:50:00',1.15),('15529','2013-06-02','08:55:00',1.18),('15529','2013-06-02','09:00:00',1.2),('15529','2013-06-02','09:05:00',1.12),('15529','2013-06-02','09:15:00',1.19),('15529','2013-06-02','10:50:00',1.42),('15529','2013-06-02','10:55:00',2.07),('15529','2013-06-02','11:00:00',2.21),('15529','2013-06-02','11:05:00',2.03),('15529','2013-06-02','11:10:00',1.16),('15529','2013-06-02','11:15:00',1.28),('15529','2013-06-02','11:20:00',2.2),('15529','2013-06-02','11:25:00',1.77),('15529','2013-06-02','11:30:00',2.16),('15529','2013-06-02','11:35:00',2.49),('15529','2013-06-02','11:40:00',2.16),('15529','2013-06-02','11:45:00',2.51),('15529','2013-06-02','11:50:00',2.33),('15529','2013-06-02','11:55:00',2.15),('15529','2013-06-02','12:00:00',2.66),('15529','2013-06-02','12:05:00',2.17),('15529','2013-06-02','12:45:00',1.43),('15529','2013-06-02','12:50:00',2.78),('15529','2013-06-02','12:55:00',1.77),('15529','2013-06-02','13:00:00',1.32),('15529','2013-06-02','13:05:00',1.68),('15529','2013-06-02','13:10:00',2.12),('15529','2013-06-02','13:15:00',2.29),('15529','2013-06-02','13:20:00',2.5),('15529','2013-06-02','13:25:00',2.01),('15529','2013-06-02','13:30:00',2.49),('15529','2013-06-02','13:35:00',2.41),('15529','2013-06-02','13:40:00',2.37),('15529','2013-06-02','13:45:00',1.74),('15529','2013-06-02','13:50:00',1.73),('15529','2013-06-02','13:55:00',1.58),('15529','2013-06-02','14:00:00',1.3),('15529','2013-06-02','14:05:00',1.1),('15529','2013-06-02','14:10:00',1.95),('15529','2013-06-02','14:15:00',1.5),('15529','2013-06-02','14:20:00',1.96),('15529','2013-06-02','14:25:00',1.64),('15529','2013-06-02','14:30:00',2.14),('15529','2013-06-02','14:35:00',2.45),('15529','2013-06-02','14:40:00',2.39),('15529','2013-06-02','14:45:00',1.29),('15529','2013-06-02','14:50:00',2.11),('15529','2013-06-02','14:55:00',1.74),('15529','2013-06-02','15:00:00',1.27),('15529','2013-06-02','15:05:00',1.97),('15529','2013-06-02','15:10:00',1.94),('15529','2013-06-02','15:15:00',1.81),('15529','2013-06-02','15:20:00',1.9),('15529','2013-06-02','15:25:00',1.54),('15529','2013-06-02','15:30:00',1.9),('15529','2013-06-02','15:35:00',2.01),('15529','2013-06-02','15:40:00',1.98),('15529','2013-06-02','15:45:00',1.93),('15529','2013-06-02','15:50:00',1.86),('15529','2013-06-02','15:55:00',1.86),('15529','2013-06-02','16:00:00',1.84),('15529','2013-06-02','16:05:00',1.79),('15529','2013-06-02','16:10:00',1.75),('15529','2013-06-02','16:15:00',1.71),('15529','2013-06-02','16:20:00',1.57),('15529','2013-06-02','16:25:00',1.58),('15529','2013-06-02','16:30:00',1.5),('15529','2013-06-02','16:35:00',1.5),('15529','2013-06-02','16:40:00',1.3),('15529','2013-06-02','16:45:00',1.28),('15529','2013-06-02','16:50:00',1.11),('15529','2013-06-02','17:00:00',1.38),('15529','2013-06-02','17:05:00',1.3),('15529','2013-06-02','17:10:00',1.2),('15529','2013-06-02','17:15:00',1.06),('15529','2013-06-02','17:20:00',1.07),('15529','2013-06-01','10:45:00',1.44),('15529','2013-06-01','10:50:00',1.27),('15529','2013-06-01','10:55:00',1.21),('15529','2013-06-01','11:00:00',1.01),('15529','2013-06-01','11:05:00',2.29),('15529','2013-06-01','11:10:00',2.15),('15529','2013-06-01','11:15:00',1.49),('15529','2013-06-01','11:20:00',1.08),('15529','2013-06-01','11:25:00',1.23),('15529','2013-06-01','11:35:00',1.2),('15529','2013-06-01','11:40:00',1.56),('15529','2013-06-01','11:45:00',1.55),('15529','2013-06-01','11:50:00',2.48),('15529','2013-06-01','12:05:00',2.24),('15529','2013-06-01','12:20:00',2.52),('15529','2013-06-01','12:25:00',2.19),('15529','2013-06-01','12:30:00',2.36),('15529','2013-06-01','12:35:00',1.86),('15529','2013-06-01','12:40:00',1.58),('15529','2013-06-01','12:45:00',2.25),('15529','2013-06-01','12:50:00',1.51),('15529','2013-06-01','12:55:00',2.48),('15529','2013-06-01','13:00:00',1.97),('15529','2013-06-01','13:05:00',2.49),('15529','2013-06-01','13:10:00',2.28),('15529','2013-06-01','13:15:00',2.43),('15529','2013-06-01','13:20:00',2.23),('15529','2013-06-01','13:25:00',2.39),('15529','2013-06-01','13:30:00',2.37),('15529','2013-06-01','13:35:00',2.34),('15529','2013-06-01','13:40:00',2),('15529','2013-06-01','13:45:00',1.86),('15529','2013-06-01','13:50:00',2.37),('15529','2013-06-01','13:55:00',2.1),('15529','2013-06-01','14:00:00',2.3),('15529','2013-06-01','14:05:00',2.27),('15529','2013-06-01','14:10:00',2.31),('15529','2013-06-01','14:15:00',2.31),('15529','2013-06-01','14:20:00',2.26),('15529','2013-06-01','14:25:00',2.26),('15529','2013-06-01','14:30:00',2.25),('15529','2013-06-01','14:35:00',2.23),('15529','2013-06-01','14:40:00',2.19),('15529','2013-06-01','14:45:00',2.17),('15529','2013-06-01','14:50:00',2.17),('15529','2013-06-01','14:55:00',2.14),('15529','2013-06-01','15:00:00',2.16),('15529','2013-06-01','15:05:00',2.17),('15529','2013-06-01','15:10:00',2.11),('15529','2013-06-01','15:15:00',2.09),('15529','2013-06-01','15:20:00',2.13),('15529','2013-06-01','15:25:00',2.07),('15529','2013-06-01','15:30:00',1.98),('15529','2013-06-01','15:35:00',2.02),('15529','2013-06-01','15:40:00',1.91),('15529','2013-06-01','15:45:00',1.75),('15529','2013-06-01','15:50:00',1.92),('15529','2013-06-01','15:55:00',1.85),('15529','2013-06-01','16:00:00',1.36),('15529','2013-06-01','16:05:00',1.45),('15529','2013-06-01','16:10:00',1.24),('15529','2013-06-01','16:15:00',1.26),('15529','2013-06-01','16:20:00',1.16),('15529','2013-06-01','16:25:00',1.35),('15529','2013-06-01','16:30:00',1.65),('15529','2013-06-01','16:35:00',1.58),('15529','2013-06-01','16:40:00',1.56),('15529','2013-06-01','16:45:00',1.5),('15529','2013-06-01','16:50:00',1),('15529','2013-06-01','16:55:00',1.11),('15529','2013-06-01','17:00:00',1.17),('15529','2013-06-01','17:05:00',1.33),('15529','2013-06-01','17:10:00',1.27),('15529','2013-06-01','17:15:00',1.25),('15529','2013-06-01','17:20:00',1.19),('15529','2013-06-01','17:30:00',1.18),('15529','2013-05-31','10:50:00',1.74),('15529','2013-05-31','12:00:00',2.7),('15529','2013-05-31','12:05:00',2.31),('15529','2013-05-31','12:10:00',1.87),('15529','2013-05-31','12:50:00',1.03),('15529','2013-05-31','12:55:00',1.12),('15529','2013-05-31','13:00:00',1.17),('15529','2013-05-31','13:05:00',1.17),('15529','2013-05-31','13:10:00',1.2),('15529','2013-05-31','14:00:00',1.1),('15529','2013-05-31','14:05:00',1.21),('15529','2013-05-31','14:10:00',1.05),('15529','2013-05-31','14:15:00',1.07),('15529','2013-05-31','14:20:00',1.05),('15529','2014-04-01','09:45:00',1.53),('15529','2014-04-01','09:50:00',1.29),('15529','2014-04-01','09:55:00',1.3),('15529','2014-04-01','10:00:00',1.49),('15529','2014-04-01','10:15:00',1.06),('15529','2014-04-01','10:20:00',1.34),('15529','2014-04-01','10:25:00',1.59),('15529','2014-04-01','10:30:00',1.25),('15529','2014-04-01','11:05:00',1.81),('15529','2014-04-01','11:10:00',1.93),('15529','2014-04-01','11:15:00',1.47),('15529','2014-04-01','11:35:00',1.12),('15529','2014-04-01','11:40:00',2.33),('15529','2014-04-01','11:45:00',2.32),('15529','2014-04-01','11:50:00',1.91),('15529','2014-04-01','12:05:00',2.52),('15529','2014-04-01','12:10:00',2.4),('15529','2014-04-01','12:20:00',2.09),('15529','2014-04-01','12:30:00',2.03),('15529','2014-04-01','12:35:00',2.59),('15529','2014-04-01','12:40:00',2.32),('15529','2014-04-01','12:55:00',2.32),('15529','2014-04-01','13:00:00',2.6),('15529','2014-04-01','13:05:00',1.72),('15529','2014-04-01','13:10:00',1.93),('15529','2014-04-01','13:15:00',2.56),('15529','2014-04-01','13:20:00',1.84),('15529','2014-04-01','13:30:00',2.01),('15529','2014-04-01','13:35:00',2.45),('15529','2014-04-01','13:40:00',2.39),('15529','2014-04-01','13:45:00',2.39),('15529','2014-04-01','13:50:00',2.39),('15529','2014-04-01','13:55:00',2.38),('15529','2014-04-01','14:00:00',2.33),('15529','2014-04-01','14:05:00',2.32),('15529','2014-04-01','14:10:00',2.31),('15529','2014-04-01','14:15:00',2.26),('15529','2014-04-01','14:20:00',2.24),('15529','2014-04-01','14:25:00',2.19),('15529','2014-04-01','14:30:00',2.24),('15529','2014-04-01','14:35:00',2.23),('15529','2014-04-01','14:40:00',2.23),('15529','2014-04-01','14:45:00',2.2),('15529','2014-04-01','14:50:00',2.07),('15529','2014-04-01','14:55:00',1.66),('15529','2014-04-01','15:00:00',2.04),('15529','2014-04-01','15:05:00',2.01),('15529','2014-04-01','15:10:00',1.92),('15529','2014-04-01','15:15:00',1.93),('15529','2014-04-01','15:20:00',1.93),('15529','2014-04-01','15:25:00',1.92),('15529','2014-04-01','15:30:00',1.82),('15529','2014-04-01','15:35:00',1.78),('15529','2014-04-01','15:40:00',1.77),('15529','2014-04-01','15:45:00',1.82),('15529','2014-04-01','15:50:00',1.8),('15529','2014-04-01','15:55:00',1.61),('15529','2014-04-01','16:00:00',1.68),('15529','2014-04-01','16:05:00',1.64),('15529','2014-04-01','16:10:00',1.6),('15529','2014-04-01','16:15:00',1.53),('15529','2014-04-01','16:20:00',1.51),('15529','2014-04-01','16:25:00',1.45),('15529','2014-04-01','16:30:00',1.49),('15529','2014-04-01','16:35:00',1.43),('15529','2014-04-01','16:40:00',1.36),('15529','2014-04-01','16:45:00',1.3),('15529','2014-04-01','16:50:00',1.21),('15529','2014-04-01','16:55:00',1.22),('15529','2014-04-01','17:00:00',1.21),('15529','2014-04-01','17:05:00',1.08),('15529','2014-04-01','17:10:00',1.03),('15529','2013-05-30','08:30:00',1.01),('15529','2013-05-30','08:35:00',1.08),('15529','2013-05-30','08:40:00',1.2),('15529','2013-05-30','09:35:00',1.13),('15529','2013-05-30','09:40:00',1.77),('15529','2013-05-30','09:45:00',1.85),('15529','2013-05-30','09:50:00',1.19),('15529','2013-05-30','09:55:00',1.95),('15529','2013-05-30','10:00:00',2),('15529','2013-05-30','10:05:00',1.73),('15529','2013-05-30','10:10:00',1.92),('15529','2013-05-30','10:15:00',1.86),('15529','2013-05-30','10:20:00',1.18),('15529','2013-05-30','10:30:00',1.13),('15529','2013-05-30','10:35:00',1.51),('15529','2013-05-30','10:40:00',2.45),('15529','2013-05-30','10:45:00',1.22),('15529','2013-05-30','10:50:00',1.79),('15529','2013-05-30','10:55:00',1.11),('15529','2013-05-30','11:05:00',2.04),('15529','2013-05-30','11:10:00',2.34),('15529','2013-05-30','11:15:00',1.6),('15529','2013-05-30','11:20:00',2.22),('15529','2013-05-30','11:25:00',1.96),('15529','2013-05-30','11:30:00',1.08),('15529','2013-05-30','11:40:00',2.02),('15529','2013-05-30','11:45:00',2.09),('15529','2013-05-30','11:50:00',1.1),('15529','2013-05-30','11:55:00',1.17),('15529','2013-05-30','12:00:00',1.85),('15529','2013-05-30','12:05:00',2.79),('15529','2013-05-30','12:10:00',1.15),('15529','2013-05-30','12:20:00',1.92),('15529','2013-05-30','12:25:00',1.84),('15529','2013-05-30','12:35:00',2.05),('15529','2013-05-30','12:40:00',1.73),('15529','2013-05-30','12:55:00',1.59),('15529','2013-05-30','13:00:00',2.11),('15529','2013-05-30','13:30:00',1.82),('15529','2013-05-30','13:35:00',1.96),('15529','2013-05-30','13:40:00',1.27),('15529','2013-05-30','13:55:00',1),('15529','2013-05-30','15:15:00',1.91),('15529','2013-05-30','15:20:00',1.62),('15529','2013-05-30','15:25:00',1.69),('15529','2013-05-30','15:50:00',1.36),('15529','2013-05-29','08:40:00',1.14),('15529','2013-05-29','08:45:00',1.18),('15529','2013-05-29','08:50:00',1.23),('15529','2013-05-29','08:55:00',1.27),('15529','2013-05-29','09:00:00',1.31),('15529','2013-05-29','09:05:00',1.37),('15529','2013-05-29','09:10:00',1.34),('15529','2013-05-29','09:15:00',1.46),('15529','2013-05-29','09:20:00',1.56),('15529','2013-05-29','09:25:00',1.45),('15529','2013-05-29','09:30:00',1.62),('15529','2013-05-29','09:35:00',1.68),('15529','2013-05-29','09:40:00',1.28),('15529','2013-05-29','09:45:00',1.84),('15529','2013-05-29','09:50:00',1.18),('15529','2013-05-29','09:55:00',1.53),('15529','2013-05-29','10:05:00',1.4),('15529','2013-05-29','10:15:00',2.01),('15529','2013-05-29','10:25:00',1.65),('15529','2013-05-29','10:35:00',1.86),('15529','2013-05-29','10:40:00',2.35),('15529','2013-05-29','10:45:00',1.76),('15529','2013-05-29','10:50:00',2.34),('15529','2013-05-29','10:55:00',2.28),('15529','2013-05-29','11:00:00',2.5),('15529','2013-05-29','11:15:00',2.2),('15529','2013-05-29','11:20:00',1.02),('15529','2013-05-29','11:25:00',1.37),('15529','2013-05-29','11:30:00',2.4),('15529','2013-05-29','11:35:00',2.51),('15529','2013-05-29','11:40:00',1.19),('15529','2013-05-29','11:45:00',2.63),('15529','2013-05-29','11:50:00',1.09),('15529','2013-05-29','11:55:00',2.32),('15529','2013-05-29','12:00:00',2.58),('15529','2013-05-29','12:05:00',1.52),('15529','2013-05-29','12:10:00',1.7),('15529','2013-05-29','12:15:00',2.16),('15529','2013-05-29','12:20:00',2.56),('15529','2013-05-29','12:25:00',1.94),('15529','2013-05-29','12:30:00',1.2),('15529','2013-05-29','12:35:00',2.64),('15529','2013-05-29','12:40:00',1.47),('15529','2013-05-29','12:45:00',1.77),('15529','2013-05-29','12:50:00',2.65),('15529','2013-05-29','12:55:00',1.62),('15529','2013-05-29','13:00:00',1.57),('15529','2013-05-29','13:05:00',1.07),('15529','2013-05-29','13:10:00',1.71),('15529','2013-05-29','13:15:00',1.11),('15529','2013-05-29','13:20:00',1.04),('15529','2013-05-29','13:25:00',1.02),('15529','2013-05-29','13:35:00',2.06),('15529','2013-05-29','13:40:00',2.74),('15529','2013-05-29','13:45:00',1.02),('15529','2013-05-29','13:55:00',2.13),('15529','2013-05-29','14:00:00',2.06),('15529','2013-05-29','14:05:00',2.63),('15529','2013-05-29','14:10:00',1.37),('15529','2013-05-29','14:15:00',2.21),('15529','2013-05-29','14:20:00',2.5),('15529','2013-05-29','14:25:00',2.53),('15529','2013-05-29','14:30:00',1.52),('15529','2013-05-29','14:35:00',2.7),('15529','2013-05-29','14:40:00',1.31),('15529','2013-05-29','14:45:00',1.74),('15529','2013-05-29','14:50:00',1.89),('15529','2013-05-29','14:55:00',1.73),('15529','2013-05-29','15:00:00',2.12),('15529','2013-05-29','15:10:00',1.95),('15529','2013-05-29','15:15:00',2.29),('15529','2013-05-29','15:20:00',2.1),('15529','2013-05-29','15:25:00',2),('15529','2013-05-29','15:30:00',2.37),('15529','2013-05-29','15:35:00',2.15),('15529','2013-05-29','15:40:00',1.96),('15529','2013-05-29','15:45:00',2.33),('15529','2013-05-29','15:50:00',2.38),('15529','2013-05-29','15:55:00',2.22),('15529','2013-05-29','16:00:00',2.16),('15529','2013-05-29','16:05:00',2.03),('15529','2013-05-29','16:10:00',1.93),('15529','2013-05-29','16:15:00',1.82),('15529','2013-05-29','16:20:00',1.52),('15529','2013-05-29','16:45:00',1.49),('15529','2013-05-29','16:50:00',1.34),('15529','2013-05-28','08:35:00',1.04),('15529','2013-05-28','08:40:00',1.09),('15529','2013-05-28','08:45:00',1.14),('15529','2013-05-28','08:50:00',1.19),('15529','2013-05-28','08:55:00',1.23),('15529','2013-05-28','09:00:00',1.28),('15529','2013-05-28','09:05:00',1.32),('15529','2013-05-28','09:10:00',1.37),('15529','2013-05-28','09:15:00',1.41),('15529','2013-05-28','09:20:00',1.45),('15529','2013-05-28','09:25:00',1.49),('15529','2013-05-28','09:30:00',1.54),('15529','2013-05-28','09:35:00',1.58),('15529','2013-05-28','09:40:00',1.62),('15529','2013-05-28','09:45:00',1.65),('15529','2013-05-28','09:50:00',1.68),('15529','2013-05-28','09:55:00',1.72),('15529','2013-05-28','10:00:00',1.77),('15529','2013-05-28','10:05:00',1.79),('15529','2013-05-28','10:10:00',1.82),('15529','2013-05-28','10:15:00',1.86),('15529','2013-05-28','10:20:00',1.91),('15529','2013-05-28','10:25:00',1.94),('15529','2013-05-28','10:30:00',1.98),('15529','2013-05-28','10:35:00',2.01),('15529','2013-05-28','10:40:00',2.03),('15529','2013-05-28','10:45:00',2.06),('15529','2013-05-28','10:50:00',2.1),('15529','2013-05-28','10:55:00',2.12),('15529','2013-05-28','11:00:00',2.2),('15529','2013-05-28','11:05:00',2.28),('15529','2013-05-28','11:10:00',2.19),('15529','2013-05-28','11:15:00',2.31),('15529','2013-05-28','11:20:00',1.72),('15529','2013-05-28','11:25:00',2.17),('15529','2013-05-28','11:30:00',2.05),('15529','2013-05-28','11:35:00',2.39),('15529','2013-05-28','11:40:00',1.79),('15529','2013-05-28','11:45:00',1.74),('15529','2013-05-28','11:50:00',2.07),('15529','2013-05-28','11:55:00',2.55),('15529','2013-05-28','12:00:00',2.19),('15529','2013-05-28','12:05:00',2.22),('15529','2013-05-28','12:10:00',2.51),('15529','2013-05-28','12:15:00',2.46),('15529','2013-05-28','12:20:00',2.45),('15529','2013-05-28','12:25:00',2.49),('15529','2013-05-28','12:30:00',2.25),('15529','2013-05-28','12:35:00',2),('15529','2013-05-28','12:40:00',2.51),('15529','2013-05-28','12:45:00',2.48),('15529','2013-05-28','12:50:00',2.39),('15529','2013-05-28','12:55:00',2.38),('15529','2013-05-28','13:00:00',2.36),('15529','2013-05-28','13:05:00',2.55),('15529','2013-05-28','13:10:00',2.55),('15529','2013-05-28','13:15:00',2.29),('15529','2013-05-28','13:20:00',2.7),('15529','2013-05-28','13:25:00',2.1),('15529','2013-05-28','13:30:00',1.92),('15529','2013-05-28','13:35:00',1.6),('15529','2013-05-28','13:40:00',1.68),('15529','2013-05-28','13:45:00',2.41),('15529','2013-05-28','13:50:00',2.49),('15529','2013-05-28','13:55:00',2.34),('15529','2013-05-28','14:00:00',2.4),('15529','2013-05-28','14:05:00',2.28),('15529','2013-05-28','14:10:00',2.33),('15529','2013-05-28','14:15:00',2.36),('15529','2013-05-28','14:20:00',2.35),('15529','2013-05-28','14:25:00',2.2),('15529','2013-05-28','14:30:00',2.08),('15529','2013-05-28','14:35:00',2.3),('15529','2013-05-28','14:40:00',2.22),('15529','2013-05-28','14:45:00',2.33),('15529','2013-05-28','14:50:00',2.32),('15529','2013-05-28','14:55:00',2.15),('15529','2013-05-28','15:00:00',2.21),('15529','2013-05-28','15:05:00',1.87),('15529','2013-05-28','15:10:00',1.42),('15529','2013-05-28','15:15:00',1.86),('15529','2013-05-28','15:20:00',1.28),('15529','2013-05-28','15:25:00',1.46),('15529','2013-05-28','15:30:00',1.38),('15529','2013-05-28','15:35:00',1.76),('15529','2013-05-28','15:40:00',1.53),('15529','2013-05-28','15:45:00',1.37),('15529','2013-05-28','15:50:00',1.47),('15529','2013-05-28','15:55:00',1.28),('15529','2013-05-28','16:00:00',1.35),('15529','2013-05-28','16:05:00',1.31),('15529','2013-05-28','16:10:00',1.17),('15529','2013-05-28','16:15:00',1.24),('15529','2013-05-28','16:20:00',1.07),('15529','2013-05-28','16:25:00',1.23),('15529','2013-05-28','16:30:00',1.01),('15529','2013-05-28','16:35:00',1.11),('15529','2013-05-28','16:40:00',1.23),('15529','2013-05-28','16:45:00',1.07),('15529','2013-05-27','09:25:00',1.07),('15529','2013-05-27','09:30:00',1.21),('15529','2013-05-27','09:35:00',1.26),('15529','2013-05-27','09:40:00',1.09),('15529','2013-05-27','09:45:00',1.1),('15529','2013-05-27','09:50:00',1.1),('15529','2013-05-27','09:55:00',1.14),('15529','2013-05-27','10:00:00',1.06),('15529','2013-05-27','10:05:00',1.14),('15529','2013-05-27','10:10:00',1.28),('15529','2013-05-27','10:15:00',1.34),('15529','2013-05-27','10:20:00',1.36),('15529','2013-05-27','10:25:00',1.32),('15529','2013-05-27','10:30:00',1.5),('15529','2013-05-27','10:35:00',1.55),('15529','2013-05-27','10:40:00',1.48),('15529','2013-05-27','10:45:00',1.37),('15529','2013-05-27','10:50:00',1.32),('15529','2013-05-27','10:55:00',1.38),('15529','2013-05-27','11:00:00',1.36),('15529','2013-05-27','11:05:00',1.56),('15529','2013-05-27','11:10:00',1.15),('15529','2013-05-27','11:15:00',1.49),('15529','2013-05-27','11:20:00',1.11),('15529','2013-05-27','11:25:00',1.57),('15529','2013-05-27','11:30:00',1.78),('15529','2013-05-27','11:35:00',2.13),('15529','2013-05-27','11:40:00',2.07),('15529','2013-05-27','11:45:00',1.35),('15529','2013-05-27','12:05:00',1.05),('15529','2013-05-27','12:10:00',1.24),('15529','2013-05-27','12:15:00',1.2),('15529','2013-05-27','12:20:00',1.15),('15529','2013-05-27','12:25:00',1.31),('15529','2013-05-27','12:30:00',1.37),('15529','2013-05-27','12:35:00',1.29),('15529','2013-05-27','12:40:00',1.36),('15529','2013-05-27','12:45:00',1.31),('15529','2013-05-27','12:50:00',1.29),('15529','2013-05-27','12:55:00',1.36),('15529','2013-05-27','13:00:00',1.4),('15529','2013-05-27','13:05:00',1.58),('15529','2013-05-27','13:10:00',1.71),('15529','2013-05-27','13:15:00',1.26),('15529','2013-05-27','13:20:00',1.11),('15529','2013-05-27','13:30:00',1.28),('15529','2013-05-27','13:35:00',1.25),('15529','2013-05-27','13:40:00',1.2),('15529','2013-05-27','13:45:00',1.12),('15529','2013-05-27','13:50:00',1.02),('15529','2013-05-27','13:55:00',1.03),('15529','2013-05-27','14:00:00',1.18),('15529','2013-05-27','14:05:00',1.37),('15529','2013-05-27','14:10:00',1.46),('15529','2013-05-27','14:15:00',1.65),('15529','2013-05-27','14:20:00',1.34),('15529','2013-05-27','14:25:00',1.2),('15529','2013-05-27','14:30:00',1.58),('15529','2013-05-27','14:35:00',1.39),('15529','2013-05-27','14:40:00',1.68),('15529','2013-05-27','14:45:00',1.85),('15529','2013-05-27','14:50:00',1.95),('15529','2013-05-27','14:55:00',1.91),('15529','2013-05-27','15:00:00',1.35),('15529','2013-05-27','15:05:00',1.29),('15529','2013-05-27','15:15:00',1.33),('15529','2013-05-27','15:20:00',1.54),('15529','2013-05-27','15:40:00',1.32),('15529','2013-05-27','15:45:00',1.8),('15529','2013-05-27','15:50:00',1.35),('15529','2013-05-27','16:20:00',1.16),('15529','2013-05-27','16:25:00',1.15),('15529','2013-05-27','16:30:00',1.73),('15529','2013-05-27','16:35:00',1.5),('15529','2013-05-27','16:40:00',1.42),('15529','2013-05-27','16:45:00',1.37),('15529','2013-05-27','16:50:00',1.33),('15529','2013-05-27','16:55:00',1.29),('15529','2013-05-27','17:00:00',1.23),('15529','2013-05-27','17:05:00',1.19),('15529','2013-05-27','17:10:00',1.14),('15529','2013-05-27','17:15:00',1.11),('15529','2013-05-27','17:20:00',1.07),('15529','2013-05-27','17:25:00',1),('15529','2013-05-26','08:35:00',1.06),('15529','2013-05-26','08:40:00',1.15),('15529','2013-05-26','08:55:00',1.37),('15529','2013-05-26','09:00:00',1.42),('15529','2013-05-26','09:05:00',1.66),('15529','2013-05-26','09:25:00',1.57),('15529','2013-05-26','09:30:00',1.63),('15529','2013-05-26','09:35:00',1.65),('15529','2013-05-26','09:40:00',1.68),('15529','2013-05-26','09:45:00',1.75),('15529','2013-05-26','09:50:00',1.84),('15529','2013-05-26','09:55:00',1.87),('15529','2013-05-26','10:00:00',1.49),('15529','2013-05-26','10:05:00',1.9),('15529','2013-05-26','10:10:00',1.9),('15529','2013-05-26','10:15:00',1.98),('15529','2013-05-26','10:20:00',2.02),('15529','2013-05-26','10:30:00',1.18),('15529','2013-05-26','10:35:00',1.88),('15529','2013-05-26','10:40:00',1.53),('15529','2013-05-26','10:45:00',2.29),('15529','2013-05-26','10:50:00',2.33),('15529','2013-05-26','10:55:00',1.72),('15529','2013-05-26','11:00:00',1.58),('15529','2013-05-26','11:05:00',1.51),('15529','2013-05-26','11:10:00',1.34),('15529','2013-05-26','11:15:00',2.54),('15529','2013-05-26','11:20:00',2.33),('15529','2013-05-26','11:25:00',2.21),('15529','2013-05-26','11:35:00',1.68),('15529','2013-05-26','11:45:00',1.37),('15529','2013-05-26','11:50:00',1.68),('15529','2013-05-26','11:55:00',1.69),('15529','2013-05-26','12:05:00',2.06),('15529','2013-05-26','12:10:00',2.58),('15529','2013-05-26','12:15:00',1.26),('15529','2013-05-26','12:25:00',2.08),('15529','2013-05-26','12:30:00',1.31),('15529','2013-05-26','12:35:00',2.34),('15529','2013-05-26','12:45:00',2.35),('15529','2013-05-26','12:55:00',1.06),('15529','2013-05-26','13:00:00',2.25),('15529','2013-05-26','13:05:00',2.12),('15529','2013-05-26','13:10:00',1.14),('15529','2013-05-26','13:15:00',1.34),('15529','2013-05-26','13:20:00',1.43),('15529','2013-05-26','13:25:00',2.51),('15529','2013-05-26','13:30:00',2.41),('15529','2013-05-26','13:35:00',1.96),('15529','2013-05-26','13:40:00',2.56),('15529','2013-05-26','13:45:00',2.51),('15529','2013-05-26','13:50:00',2.48),('15529','2013-05-26','13:55:00',2.42),('15529','2013-05-26','14:00:00',2.33),('15529','2013-05-26','14:05:00',2.41),('15529','2013-05-26','14:10:00',2.3),('15529','2013-05-26','14:15:00',2.25),('15529','2013-05-26','14:20:00',2.37),('15529','2013-05-26','14:25:00',2.35),('15529','2013-05-26','14:30:00',1.86),('15529','2013-05-26','14:35:00',2.11),('15529','2013-05-26','14:40:00',2.35),('15529','2013-05-26','14:45:00',2.27),('15529','2013-05-26','14:50:00',2.3),('15529','2013-05-26','14:55:00',1.89),('15529','2013-05-26','15:00:00',1.39),('15529','2013-05-26','15:05:00',1.58),('15529','2013-05-26','15:10:00',2.29),('15529','2013-05-26','15:15:00',1.53),('15529','2013-05-26','15:20:00',1.93),('15529','2013-05-26','15:25:00',1.78),('15529','2013-05-26','15:30:00',1.99),('15529','2013-05-26','15:35:00',2.04),('15529','2013-05-26','15:40:00',1.8),('15529','2013-05-26','15:45:00',1.63),('15529','2013-05-26','15:50:00',1.91),('15529','2013-05-26','15:55:00',1.28),('15529','2013-05-26','16:00:00',1.54),('15529','2013-05-26','16:05:00',1.23),('15529','2013-05-26','16:10:00',1.18),('15529','2013-05-26','16:15:00',1.32),('15529','2013-05-26','16:20:00',1.99),('15529','2013-05-26','16:25:00',1.82),('15529','2013-05-26','16:30:00',1.71),('15529','2013-05-26','16:35:00',1.25),('15529','2013-05-25','08:05:00',1.08),('15529','2013-05-25','08:30:00',1.07),('15529','2013-05-25','08:40:00',1.19),('15529','2013-05-25','08:45:00',1.41),('15529','2013-05-25','08:55:00',1.35),('15529','2013-05-25','09:10:00',1.67),('15529','2013-05-25','09:40:00',1.27),('15529','2013-05-25','10:05:00',1.96),('15529','2013-05-25','10:10:00',1.24),('15529','2013-05-25','10:20:00',1.66),('15529','2013-05-25','10:25:00',1.96),('15529','2013-05-25','10:30:00',2.04),('15529','2013-05-25','10:35:00',2.16),('15529','2013-05-25','10:40:00',2.15),('15529','2013-05-25','10:45:00',2.21),('15529','2013-05-25','10:50:00',2.27),('15529','2013-05-25','10:55:00',1.96),('15529','2013-05-25','11:00:00',2.16),('15529','2013-05-25','11:05:00',2.27),('15529','2013-05-25','11:10:00',2.3),('15529','2013-05-25','11:15:00',2.31),('15529','2013-05-25','11:20:00',2.29),('15529','2013-05-25','11:25:00',2.37),('15529','2013-05-25','11:30:00',2.25),('15529','2013-05-25','11:35:00',2.28),('15529','2013-05-25','11:40:00',2.05),('15529','2013-05-25','11:45:00',2.45),('15529','2013-05-25','11:50:00',2.44),('15529','2013-05-25','11:55:00',2.41),('15529','2013-05-25','12:00:00',2.47),('15529','2013-05-25','12:05:00',2.52),('15529','2013-05-25','12:10:00',2.49),('15529','2013-05-25','12:15:00',1.6),('15529','2013-05-25','12:20:00',2.5),('15529','2013-05-25','12:25:00',2.54),('15529','2013-05-25','12:30:00',2.53),('15529','2013-05-25','12:35:00',2.33),('15529','2013-05-25','12:40:00',2.71),('15529','2013-05-25','12:45:00',2.59),('15529','2013-05-25','12:50:00',2.55),('15529','2013-05-25','12:55:00',2.52),('15529','2013-05-25','13:00:00',2.32),('15529','2013-05-25','13:05:00',2.6),('15529','2013-05-25','13:10:00',2.4),('15529','2013-05-25','13:15:00',2.44),('15529','2013-05-25','13:20:00',2.56),('15529','2013-05-25','13:25:00',2.55),('15529','2013-05-25','13:30:00',2.57),('15529','2013-05-25','13:35:00',2.51),('15529','2013-05-25','13:40:00',2.49),('15529','2013-05-25','13:45:00',2.51),('15529','2013-05-25','13:50:00',2.36),('15529','2013-05-25','13:55:00',2.46),('15529','2013-05-25','14:00:00',2.46),('15529','2013-05-25','14:05:00',2.42),('15529','2013-05-25','14:10:00',2.43),('15529','2013-05-25','14:15:00',2.4),('15529','2013-05-25','14:20:00',2.38),('15529','2013-05-25','14:25:00',2.36),('15529','2013-05-25','14:30:00',2.34),('15529','2013-05-25','14:35:00',2.33),('15529','2013-05-25','14:40:00',2.31),('15529','2013-05-25','14:45:00',2.31),('15529','2013-05-25','14:50:00',2.27),('15529','2013-05-25','14:55:00',2.24),('15529','2013-05-25','15:00:00',2.24),('15529','2013-05-25','15:05:00',2.21),('15529','2013-05-25','15:10:00',2.19),('15529','2013-05-25','15:15:00',2.14),('15529','2013-05-25','15:20:00',2.13),('15529','2013-05-25','15:25:00',2.11),('15529','2013-05-25','15:30:00',2.07),('15529','2013-05-25','15:35:00',2.06),('15529','2013-05-25','15:40:00',2.03),('15529','2013-05-25','15:45:00',1.99),('15529','2013-05-25','15:50:00',1.94),('15529','2013-05-25','15:55:00',1.92),('15529','2013-05-25','16:00:00',1.89),('15529','2013-05-25','16:05:00',1.87),('15529','2013-05-25','16:10:00',1.82),('15529','2013-05-25','16:15:00',1.79),('15529','2013-05-25','16:20:00',1.75),('15529','2013-05-25','16:25:00',1.71),('15529','2013-05-25','16:30:00',1.66),('15529','2013-05-25','16:35:00',1.62),('15529','2013-05-25','16:40:00',1.58),('15529','2013-05-25','16:45:00',1.53),('15529','2013-05-25','16:50:00',1.49),('15529','2013-05-25','16:55:00',1.44),('15529','2013-05-25','17:00:00',1.39),('15529','2013-05-25','17:05:00',1.35),('15529','2013-05-25','17:10:00',1.3),('15529','2013-05-25','17:15:00',1.25),('15529','2013-05-25','17:20:00',1.2),('15529','2013-05-25','17:25:00',1.15),('15529','2013-05-25','17:30:00',1.05),('15529','2013-05-25','17:35:00',1.04),('15529','2013-05-24','08:25:00',1.38),('15529','2013-05-24','08:50:00',1.14),('15529','2013-05-24','08:55:00',1.5),('15529','2013-05-24','09:00:00',1.5),('15529','2013-05-24','09:05:00',1.13),('15529','2013-05-24','09:10:00',1.24),('15529','2013-05-24','09:25:00',1.19),('15529','2013-05-24','09:35:00',1.53),('15529','2013-05-24','09:40:00',1.7),('15529','2013-05-24','09:45:00',1.53),('15529','2013-05-24','09:50:00',1.73),('15529','2013-05-24','11:05:00',1.65),('15529','2013-05-24','11:10:00',2.04),('15529','2013-05-24','11:15:00',1.74),('15529','2013-05-24','11:35:00',1.52),('15529','2013-05-24','11:45:00',1.07),('15529','2013-05-24','12:00:00',1.52),('15529','2013-05-24','12:05:00',1.02),('15529','2013-05-24','12:20:00',2.38),('15529','2013-05-24','12:25:00',1.29),('15529','2013-05-24','12:35:00',1.53),('15529','2013-05-24','12:40:00',1.41),('15529','2013-05-24','13:15:00',1.13),('15529','2013-05-24','13:25:00',1.45),('15529','2013-05-24','13:40:00',1.22),('15529','2013-05-24','13:45:00',1.47),('15529','2013-05-24','13:50:00',1.68),('15529','2013-05-24','13:55:00',2.29),('15529','2013-05-24','14:00:00',1.58),('15529','2013-05-24','14:05:00',2.23),('15529','2013-05-24','14:10:00',2.6),('15529','2013-05-24','14:15:00',2.38),('15529','2013-05-24','14:25:00',1),('15529','2013-05-24','14:30:00',1.11),('15529','2013-05-24','14:35:00',1.45),('15529','2013-05-24','14:40:00',1.35),('15529','2013-05-24','14:45:00',1.72),('15529','2013-05-24','14:50:00',1.45),('15529','2013-05-24','14:55:00',1.87),('15529','2013-05-24','15:00:00',1.93),('15529','2013-05-24','15:10:00',1.14),('15529','2013-05-24','15:15:00',1.77),('15529','2013-05-24','15:20:00',1.17),('15529','2013-05-24','15:25:00',1.44),('15529','2013-05-24','15:30:00',2.24),('15529','2013-05-24','15:35:00',2.33),('15529','2013-05-24','15:40:00',2.06),('15529','2013-05-24','15:45:00',1.75),('15529','2013-05-24','15:50:00',1.37),('15529','2013-05-24','15:55:00',1.59),('15529','2013-05-24','16:00:00',1.58),('15529','2013-05-24','16:20:00',1.23),('15529','2013-05-24','16:25:00',1.66),('15529','2013-05-24','16:35:00',1.38),('15529','2013-05-24','16:40:00',1.09),('15529','2013-05-24','17:10:00',1.17),('15529','2013-05-24','17:35:00',1.32),('15529','2013-05-23','08:40:00',1.14),('15529','2013-05-23','08:45:00',1.17),('15529','2013-05-23','08:50:00',1.24),('15529','2013-05-23','08:55:00',1.29),('15529','2013-05-23','09:00:00',1.54),('15529','2013-05-23','09:25:00',1.15),('15529','2013-05-23','09:55:00',1.76),('15529','2013-05-23','10:20:00',1.03),('15529','2013-05-23','10:25:00',1.64),('15529','2013-05-23','10:30:00',2.09),('15529','2013-05-23','10:35:00',2.18),('15529','2013-05-23','10:40:00',1.94),('15529','2013-05-23','10:45:00',1.61),('15529','2013-05-23','10:50:00',2.06),('15529','2013-05-23','10:55:00',2.4),('15529','2013-05-23','11:00:00',1.6),('15529','2013-05-23','11:05:00',2.25),('15529','2013-05-23','11:10:00',2.22),('15529','2013-05-23','11:15:00',1.98),('15529','2013-05-23','11:20:00',2.37),('15529','2013-05-23','11:25:00',2.5),('15529','2013-05-23','11:30:00',1.1),('15529','2013-05-23','11:45:00',2.33),('15529','2013-05-23','11:50:00',1.66),('15529','2013-05-23','11:55:00',2.02),('15529','2013-05-23','12:00:00',1.75),('15529','2013-05-23','12:05:00',1.07),('15529','2013-05-23','12:10:00',1.7),('15529','2013-05-23','12:15:00',2.33),('15529','2013-05-23','12:20:00',1.38),('15529','2013-05-23','12:25:00',1.39),('15529','2013-05-23','12:30:00',1.57),('15529','2013-05-23','12:35:00',1.5),('15529','2013-05-23','12:40:00',1.14),('15529','2013-05-23','12:45:00',1.49),('15529','2013-05-23','12:50:00',2.07),('15529','2013-05-23','12:55:00',2.03),('15529','2013-05-23','13:00:00',1.81),('15529','2013-05-23','13:05:00',1.48),('15529','2013-05-23','13:10:00',1.44),('15529','2013-05-23','13:15:00',1.4),('15529','2013-05-23','13:20:00',1.43),('15529','2013-05-23','13:30:00',1.36),('15529','2013-05-23','13:35:00',1.12),('15529','2013-05-23','13:55:00',1.28),('15529','2013-05-23','14:00:00',1.18),('15529','2013-05-23','14:10:00',1.73),('15529','2013-05-23','14:15:00',1.9),('15529','2013-05-23','14:20:00',1.01),('15529','2013-05-23','14:25:00',1.15),('15529','2013-05-23','14:30:00',1.26),('15529','2013-05-23','14:35:00',2.18),('15529','2013-05-23','14:40:00',2.22),('15529','2013-05-23','14:45:00',1.11),('15529','2013-05-23','14:50:00',1.33),('15529','2013-05-23','15:05:00',1.51),('15529','2013-05-23','15:10:00',1.04),('15529','2013-05-23','15:15:00',2.15),('15529','2013-05-23','15:20:00',2.55),('15529','2013-05-23','15:25:00',2.46),('15529','2013-05-23','15:30:00',2.34),('15529','2013-05-23','15:35:00',1.68),('15529','2013-05-23','15:40:00',1.82),('15529','2013-05-23','15:45:00',1.7),('15529','2013-05-23','15:50:00',1.61),('15529','2013-05-23','15:55:00',1.09),('15529','2013-05-23','16:00:00',1.13),('15529','2013-05-23','16:05:00',1.08),('15529','2013-05-23','16:10:00',1.12),('15529','2013-05-23','16:15:00',1.23),('15529','2013-05-23','16:20:00',1.14),('15529','2013-05-23','16:25:00',1.74),('15529','2013-05-22','08:30:00',1.13),('15529','2013-05-22','08:40:00',1.08),('15529','2013-05-22','09:20:00',1.65),('15529','2013-05-22','09:25:00',1.74),('15529','2013-05-22','09:35:00',1.44),('15529','2013-05-22','09:45:00',1.62),('15529','2013-05-22','10:00:00',1.97),('15529','2013-05-22','10:10:00',1.53),('15529','2013-05-22','10:15:00',1.03),('15529','2013-05-22','10:20:00',2),('15529','2013-05-22','10:25:00',1),('15529','2013-05-22','10:30:00',2.2),('15529','2013-05-22','10:35:00',2),('15529','2013-05-22','10:40:00',1.42),('15529','2013-05-22','10:45:00',2.02),('15529','2013-05-22','10:50:00',1.2),('15529','2013-05-22','11:05:00',1.23),('15529','2013-05-22','11:10:00',1.63),('15529','2013-05-22','11:15:00',1.78),('15529','2013-05-22','11:25:00',1.41),('15529','2013-05-22','11:30:00',1.12),('15529','2013-05-22','11:35:00',1.54),('15529','2013-05-22','11:40:00',1.74),('15529','2013-05-22','11:50:00',1.25),('15529','2013-05-22','11:55:00',2.06),('15529','2013-05-22','12:00:00',2.58),('15529','2013-05-22','12:05:00',2.43),('15529','2013-05-22','12:10:00',2.57),('15529','2013-05-22','12:15:00',1.44),('15529','2013-05-22','12:35:00',1.5),('15529','2013-05-22','12:40:00',2.34),('15529','2013-05-22','12:45:00',2.58),('15529','2013-05-22','12:50:00',2.68),('15529','2013-05-22','12:55:00',2.1),('15529','2013-05-22','13:00:00',1.71),('15529','2013-05-22','13:05:00',2.45),('15529','2013-05-22','13:10:00',2.63),('15529','2013-05-22','13:15:00',2.01),('15529','2013-05-22','13:20:00',2.49),('15529','2013-05-22','13:25:00',2.13),('15529','2013-05-22','13:30:00',1.88),('15529','2013-05-22','13:35:00',2.08),('15529','2013-05-22','13:40:00',1.61),('15529','2013-05-22','13:45:00',1.35),('15529','2013-05-22','13:50:00',1.63),('15529','2013-05-22','13:55:00',2.09),('15529','2013-05-22','14:00:00',2.16),('15529','2013-05-22','14:05:00',1.29),('15529','2013-05-22','14:10:00',2.17),('15529','2013-05-22','14:15:00',2.25),('15529','2013-05-22','14:30:00',1.96),('15529','2013-05-22','14:35:00',1.26),('15529','2013-05-22','14:40:00',1.04),('15529','2013-05-22','14:45:00',1.77),('15529','2013-05-22','14:50:00',2.52),('15529','2013-05-22','14:55:00',2.31),('15529','2013-05-22','15:00:00',1.62),('15529','2013-05-22','15:05:00',1.8),('15529','2013-05-22','15:15:00',1.56),('15529','2013-05-22','15:20:00',1.73),('15529','2013-05-22','15:25:00',1.76),('15529','2013-05-22','15:30:00',2.08),('15529','2013-05-22','15:35:00',1.42),('15529','2013-05-22','15:40:00',1.57),('15529','2013-05-22','15:45:00',1.04),('15529','2013-05-22','15:55:00',1.91),('15529','2013-05-22','16:00:00',1.91),('15529','2013-05-22','16:05:00',1.36),('15529','2013-05-22','16:10:00',1.34),('15529','2013-05-22','16:15:00',1.96),('15529','2013-05-22','16:25:00',1.23),('15529','2013-05-22','16:35:00',1.05),('15529','2013-05-22','16:40:00',1.05),('15529','2013-05-22','17:05:00',1.09),('15529','2013-05-22','17:10:00',1.13),('15529','2013-05-22','18:00:00',1.07),('15529','2013-05-21','08:30:00',1.16),('15529','2013-05-21','08:35:00',1.16),('15529','2013-05-21','09:25:00',1.06),('15529','2013-05-21','09:30:00',1.5),('15529','2013-05-21','09:35:00',1.49),('15529','2013-05-21','09:40:00',1.5),('15529','2013-05-21','09:45:00',1.51),('15529','2013-05-21','09:50:00',1.55),('15529','2013-05-21','09:55:00',1.59),('15529','2013-05-21','10:00:00',1.63),('15529','2013-05-21','10:05:00',1.66),('15529','2013-05-21','10:10:00',1.69),('15529','2013-05-21','10:15:00',1.71),('15529','2013-05-21','10:20:00',1.68),('15529','2013-05-21','10:25:00',1.46),('15529','2013-05-21','10:30:00',1.72),('15529','2013-05-21','10:35:00',1.89),('15529','2013-05-21','10:40:00',1.96),('15529','2013-05-21','10:45:00',1.89),('15529','2013-05-21','10:50:00',1.89),('15529','2013-05-21','10:55:00',1.91),('15529','2013-05-21','11:00:00',1.97),('15529','2013-05-21','11:05:00',1.97),('15529','2013-05-21','11:10:00',2.05),('15529','2013-05-21','11:15:00',2.05),('15529','2013-05-21','11:20:00',2.08),('15529','2013-05-21','11:25:00',1.83),('15529','2013-05-21','11:30:00',1.43),('15529','2013-05-21','11:35:00',1.96),('15529','2013-05-21','11:40:00',2.25),('15529','2013-05-21','11:45:00',1.97),('15529','2013-05-21','11:50:00',1.78),('15529','2013-05-21','11:55:00',1.2),('15529','2013-05-21','12:00:00',1.37),('15529','2013-05-21','12:05:00',1.18),('15529','2013-05-21','12:10:00',1.17),('15529','2013-05-21','12:15:00',1.62),('15529','2013-05-21','12:20:00',1.75),('15529','2013-05-21','12:25:00',1.59),('15529','2013-05-21','12:30:00',1.05),('15529','2013-05-21','13:05:00',1.9),('15529','2013-05-21','13:10:00',1.33),('15529','2013-05-21','13:15:00',1.38),('15529','2013-05-21','13:30:00',1.8),('15529','2013-05-21','13:35:00',2.04),('15529','2013-05-21','13:40:00',1.88),('15529','2013-05-21','13:45:00',1.56),('15529','2013-05-21','13:50:00',2.07),('15529','2013-05-21','13:55:00',2.28),('15529','2013-05-21','14:00:00',1.73),('15529','2013-05-21','14:05:00',1.38),('15529','2013-05-21','14:10:00',2.24),('15529','2013-05-21','14:15:00',2.2),('15529','2013-05-21','14:20:00',2.13),('15529','2013-05-21','14:25:00',2.12),('15529','2013-05-21','14:30:00',2.11),('15529','2013-05-21','14:35:00',2.08),('15529','2013-05-21','14:40:00',2.09),('15529','2013-05-21','14:45:00',2.06),('15529','2013-05-21','14:50:00',2.03),('15529','2013-05-21','14:55:00',2.01),('15529','2013-05-21','15:00:00',2),('15529','2013-05-21','15:05:00',1.97),('15529','2013-05-21','15:10:00',1.86),('15529','2013-05-21','15:15:00',1.93),('15529','2013-05-21','15:20:00',1.85),('15529','2013-05-21','15:25:00',1.9),('15529','2013-05-21','15:30:00',1.6),('15529','2013-05-21','15:35:00',1.3),('15529','2013-05-21','15:40:00',1.97),('15529','2013-05-21','15:45:00',1.81),('15529','2013-05-21','15:50:00',1.57),('15529','2013-05-21','15:55:00',1.7),('15529','2013-05-21','16:00:00',1.66),('15529','2013-05-21','16:05:00',1.59),('15529','2013-05-21','16:10:00',1.58),('15529','2013-05-21','16:15:00',1.57),('15529','2013-05-21','16:20:00',1.53),('15529','2013-05-21','16:25:00',1.44),('15529','2013-05-21','16:30:00',1.01),('15529','2013-05-21','16:35:00',1.09),('15529','2013-05-21','16:40:00',1.35),('15529','2014-03-31','09:00:00',1.02),('15529','2014-03-31','09:05:00',1.07),('15529','2014-03-31','09:10:00',1.11),('15529','2014-03-31','09:15:00',1.15),('15529','2014-03-31','09:20:00',1.2),('15529','2014-03-31','09:25:00',1.25),('15529','2014-03-31','09:30:00',1.31),('15529','2014-03-31','09:35:00',1.35),('15529','2014-03-31','09:40:00',1.36),('15529','2014-03-31','09:45:00',1.44),('15529','2014-03-31','09:50:00',1.49),('15529','2014-03-31','09:55:00',1.49),('15529','2014-03-31','10:00:00',1.5),('15529','2014-03-31','10:05:00',1.67),('15529','2014-03-31','10:25:00',1.21),('15529','2014-03-31','10:30:00',1.85),('15529','2014-03-31','10:35:00',1.84),('15529','2014-03-31','10:40:00',1.88),('15529','2014-03-31','10:45:00',1.91),('15529','2014-03-31','10:50:00',1.89),('15529','2014-03-31','10:55:00',1.92),('15529','2014-03-31','11:00:00',1.99),('15529','2014-03-31','11:05:00',2.01),('15529','2014-03-31','11:10:00',2.01),('15529','2014-03-31','11:15:00',2.04),('15529','2014-03-31','11:20:00',2.09),('15529','2014-03-31','11:25:00',2.11),('15529','2014-03-31','11:30:00',2.16),('15529','2014-03-31','11:35:00',2.18),('15529','2014-03-31','11:40:00',2.15),('15529','2014-03-31','11:45:00',2.21),('15529','2014-03-31','11:50:00',2.15),('15529','2014-03-31','11:55:00',2.21),('15529','2014-03-31','12:00:00',2.23),('15529','2014-03-31','12:05:00',2.26),('15529','2014-03-31','12:10:00',2.3),('15529','2014-03-31','12:15:00',2.32),('15529','2014-03-31','12:20:00',2.32),('15529','2014-03-31','12:25:00',2.35),('15529','2014-03-31','12:30:00',2.36),('15529','2014-03-31','12:35:00',2.35),('15529','2014-03-31','12:40:00',2.4),('15529','2014-03-31','12:45:00',2.4),('15529','2014-03-31','12:50:00',2.36),('15529','2014-03-31','12:55:00',2.36),('15529','2014-03-31','13:00:00',2.33),('15529','2014-03-31','13:05:00',2.4),('15529','2014-03-31','13:10:00',2.4),('15529','2014-03-31','13:15:00',2.39),('15529','2014-03-31','13:20:00',2.37),('15529','2014-03-31','13:25:00',2.39),('15529','2014-03-31','13:30:00',2.31),('15529','2014-03-31','13:35:00',2.22),('15529','2014-03-31','13:40:00',2.41),('15529','2014-03-31','13:45:00',2.35),('15529','2014-03-31','13:50:00',2.37),('15529','2014-03-31','13:55:00',2.35),('15529','2014-03-31','14:00:00',2.31),('15529','2014-03-31','14:05:00',2.34),('15529','2014-03-31','14:10:00',2.32),('15529','2014-03-31','14:15:00',1.93),('15529','2014-03-31','14:20:00',2.26),('15529','2014-03-31','14:25:00',1.99),('15529','2014-03-31','14:30:00',2.23),('15529','2014-03-31','14:35:00',2.27),('15529','2014-03-31','14:40:00',1.93),('15529','2014-03-31','14:45:00',1.95),('15529','2014-03-31','14:50:00',2.29),('15529','2014-03-31','14:55:00',1.96),('15529','2014-03-31','15:00:00',2.23),('15529','2014-03-31','15:05:00',2.04),('15529','2014-03-31','15:10:00',1.17),('15529','2014-03-31','15:15:00',1.53),('15529','2014-03-31','15:20:00',2.22),('15529','2014-03-31','15:25:00',1.53),('15529','2014-03-31','15:30:00',1.83),('15529','2014-03-31','15:35:00',1.87),('15529','2014-03-31','15:40:00',1.54),('15529','2014-03-31','15:45:00',1.43),('15529','2014-03-31','15:50:00',1.31),('15529','2014-03-31','15:55:00',1.35),('15529','2014-03-31','16:00:00',1.35),('15529','2014-03-31','16:05:00',1.44),('15529','2014-03-31','16:10:00',1.21),('15529','2014-03-31','16:15:00',1.39),('15529','2014-03-31','16:20:00',1.33),('15529','2014-03-31','16:25:00',1.57),('15529','2014-03-31','16:30:00',1.24),('15529','2014-03-31','16:35:00',1.19),('15529','2014-03-31','16:40:00',1.34),('15529','2014-03-31','16:55:00',1.27),('15529','2014-03-31','17:00:00',1.27),('15529','2014-03-31','17:10:00',1.1),('15529','2014-03-31','17:15:00',1.13),('15529','2013-05-20','09:20:00',1.11),('15529','2013-05-20','09:25:00',1.23),('15529','2013-05-20','09:35:00',1.06),('15529','2013-05-20','10:00:00',1.06),('15529','2013-05-20','10:05:00',1.07),('15529','2013-05-20','10:10:00',1.06),('15529','2013-05-20','10:15:00',1.12),('15529','2013-05-20','10:35:00',1.02),('15529','2013-05-20','10:40:00',1.2),('15529','2013-05-20','10:45:00',1.51),('15529','2013-05-20','11:05:00',1.04),('15529','2013-05-20','11:10:00',1.5),('15529','2013-05-20','11:15:00',1.81),('15529','2013-05-20','11:20:00',2),('15529','2013-05-20','11:25:00',2.31),('15529','2013-05-20','11:30:00',1.77),('15529','2013-05-20','11:35:00',1.24),('15529','2013-05-20','11:40:00',1.46),('15529','2013-05-20','11:45:00',1.59),('15529','2013-05-20','11:50:00',1.4),('15529','2013-05-20','11:55:00',1.68),('15529','2013-05-20','12:00:00',1.42),('15529','2013-05-20','12:05:00',1.84),('15529','2013-05-20','12:10:00',1.57),('15529','2013-05-20','12:15:00',1.47),('15529','2013-05-20','12:20:00',1.31),('15529','2013-05-20','12:25:00',1.75),('15529','2013-05-20','12:30:00',1.76),('15529','2013-05-20','12:35:00',1.32),('15529','2013-05-20','12:40:00',1.74),('15529','2013-05-20','12:45:00',2.03),('15529','2013-05-20','12:50:00',1.77),('15529','2013-05-20','12:55:00',2.18),('15529','2013-05-20','13:00:00',2.11),('15529','2013-05-20','13:05:00',1.83),('15529','2013-05-20','13:10:00',1.73),('15529','2013-05-20','13:15:00',1.75),('15529','2013-05-20','13:20:00',1.82),('15529','2013-05-20','13:25:00',1.61),('15529','2013-05-20','13:30:00',1.27),('15529','2013-05-20','14:25:00',1.24),('15529','2013-05-20','14:30:00',1.27),('15529','2013-05-20','14:35:00',1.1),('15529','2013-05-20','15:30:00',1.21),('15529','2013-05-19','08:30:00',1.03),('15529','2013-05-19','08:55:00',1.26),('15529','2013-05-19','09:00:00',1.37),('15529','2013-05-19','09:05:00',1.14),('15529','2013-05-19','09:20:00',1.1),('15529','2013-05-19','09:25:00',1.61),('15529','2013-05-19','09:30:00',1.74),('15529','2013-05-19','09:35:00',1.76),('15529','2013-05-19','09:40:00',1.75),('15529','2013-05-19','09:45:00',1.78),('15529','2013-05-19','09:50:00',1.85),('15529','2013-05-19','09:55:00',2.05),('15529','2013-05-19','10:00:00',2),('15529','2013-05-19','10:05:00',1.94),('15529','2013-05-19','10:10:00',1.17),('15529','2013-05-19','10:15:00',1.19),('15529','2013-05-19','10:20:00',1.62),('15529','2013-05-19','10:30:00',1.82),('15529','2013-05-19','10:35:00',1.76),('15529','2013-05-19','10:40:00',1.57),('15529','2013-05-19','10:45:00',1.85),('15529','2013-05-19','10:55:00',2.21),('15529','2013-05-19','11:00:00',1.76),('15529','2013-05-19','11:05:00',1.74),('15529','2013-05-19','11:10:00',1.53),('15529','2013-05-19','11:15:00',2.53),('15529','2013-05-19','11:20:00',1.45),('15529','2013-05-19','11:25:00',2.49),('15529','2013-05-19','11:30:00',1.82),('15529','2013-05-19','11:35:00',2.64),('15529','2013-05-19','11:40:00',1.5),('15529','2013-05-19','11:45:00',2.53),('15529','2013-05-19','11:50:00',1.9),('15529','2013-05-19','11:55:00',1.76),('15529','2013-05-19','12:00:00',1.17),('15529','2013-05-19','12:10:00',1.78),('15529','2013-05-19','12:25:00',2.03),('15529','2013-05-19','12:30:00',1.9),('15529','2013-05-19','12:35:00',1.37),('15529','2013-05-19','12:40:00',1.81),('15529','2013-05-19','12:45:00',1.34),('15529','2013-05-19','12:55:00',1.92),('15529','2013-05-19','13:00:00',1.93),('15529','2013-05-19','13:05:00',2.35),('15529','2013-05-19','13:10:00',2.55),('15529','2013-05-19','13:15:00',2.19),('15529','2013-05-19','13:20:00',1.56),('15529','2013-05-19','13:25:00',1.41),('15529','2013-05-19','13:30:00',1.63),('15529','2013-05-19','13:35:00',2.31),('15529','2013-05-19','13:40:00',2.63),('15529','2013-05-19','13:45:00',2.5),('15529','2013-05-19','13:50:00',2.53),('15529','2013-05-19','13:55:00',1.01),('15529','2013-05-19','14:00:00',2.05),('15529','2013-05-19','14:05:00',2.34),('15529','2013-05-19','14:10:00',2.46),('15529','2013-05-19','14:15:00',2.43),('15529','2013-05-19','14:20:00',2.42),('15529','2013-05-19','14:25:00',2.36),('15529','2013-05-19','14:30:00',2.32),('15529','2013-05-19','14:35:00',2.4),('15529','2013-05-19','14:40:00',2.41),('15529','2013-05-19','14:45:00',2.29),('15529','2013-05-19','14:50:00',2.08),('15529','2013-05-19','14:55:00',2.33),('15529','2013-05-19','15:00:00',2.31),('15529','2013-05-19','15:05:00',1.79),('15529','2013-05-19','15:10:00',1.62),('15529','2013-05-19','15:15:00',2.34),('15529','2013-05-19','15:20:00',1.48),('15529','2013-05-19','15:25:00',1.14),('15529','2013-05-19','15:30:00',2.16),('15529','2013-05-19','15:40:00',1.63),('15529','2013-05-19','15:45:00',1.57),('15529','2013-05-19','15:50:00',2.11),('15529','2013-05-19','15:55:00',2.04),('15529','2013-05-19','16:00:00',1.94),('15529','2013-05-19','16:05:00',1.88),('15529','2013-05-19','16:10:00',1.73),('15529','2013-05-19','16:15:00',1.75),('15529','2013-05-19','16:20:00',1.7),('15529','2013-05-19','16:25:00',1.66),('15529','2013-05-19','16:30:00',1.62),('15529','2013-05-19','16:35:00',1.56),('15529','2013-05-19','16:40:00',1.49),('15529','2013-05-19','16:45:00',1.37),('15529','2013-05-19','16:50:00',1.4),('15529','2013-05-19','16:55:00',1.33),('15529','2013-05-19','17:00:00',1.15),('15529','2013-05-19','17:05:00',1.17),('15529','2013-05-19','17:10:00',1.18),('15529','2013-05-19','17:20:00',1.37),('15529','2013-05-19','17:25:00',1.36),('15529','2013-05-19','17:30:00',1.15),('15529','2013-05-18','10:10:00',1.05),('15529','2013-05-18','10:20:00',1.24),('15529','2013-05-18','10:25:00',1.44),('15529','2013-05-18','10:30:00',1.25),('15529','2013-05-18','10:35:00',1.78),('15529','2013-05-18','10:40:00',1.72),('15529','2013-05-18','10:45:00',1.84),('15529','2013-05-18','10:50:00',2.09),('15529','2013-05-18','10:55:00',2.18),('15529','2013-05-18','11:00:00',2.23),('15529','2013-05-18','11:05:00',2.51),('15529','2013-05-18','11:10:00',2.44),('15529','2013-05-18','11:15:00',2.51),('15529','2013-05-18','11:20:00',2.34),('15529','2013-05-18','11:25:00',2.25),('15529','2013-05-18','11:30:00',2.32),('15529','2013-05-18','11:35:00',2.28),('15529','2013-05-18','11:40:00',2.34),('15529','2013-05-18','11:45:00',2.27),('15529','2013-05-18','11:50:00',2.36),('15529','2013-05-18','11:55:00',2.42),('15529','2013-05-18','12:00:00',2.44),('15529','2013-05-18','12:05:00',2.38),('15529','2013-05-18','12:10:00',2.44),('15529','2013-05-18','12:15:00',2.52),('15529','2013-05-18','12:20:00',1.37),('15529','2013-05-18','12:25:00',1.28),('15529','2013-05-18','12:30:00',1.16),('15529','2013-05-18','12:35:00',1.75),('15529','2013-05-18','12:40:00',1.62),('15529','2013-05-18','12:45:00',1.76),('15529','2013-05-18','12:50:00',1.85),('15529','2013-05-18','12:55:00',1.44),('15529','2013-05-18','13:00:00',2.2),('15529','2013-05-18','13:05:00',2.24),('15529','2013-05-18','13:10:00',2.31),('15529','2013-05-18','13:15:00',2.41),('15529','2013-05-18','13:20:00',2.53),('15529','2013-05-18','13:25:00',2.43),('15529','2013-05-18','13:30:00',2.38),('15529','2013-05-18','13:35:00',2.36),('15529','2013-05-18','13:40:00',2.35),('15529','2013-05-18','13:45:00',2.39),('15529','2013-05-18','13:50:00',2.39),('15529','2013-05-18','13:55:00',2.38),('15529','2013-05-18','14:00:00',2.34),('15529','2013-05-18','14:05:00',2.35),('15529','2013-05-18','14:10:00',2.34),('15529','2013-05-18','14:15:00',2.32),('15529','2013-05-18','14:20:00',2.32),('15529','2013-05-18','14:25:00',2.27),('15529','2013-05-18','14:30:00',2.29),('15529','2013-05-18','14:35:00',2.28),('15529','2013-05-18','14:40:00',2.25),('15529','2013-05-18','14:45:00',2.25),('15529','2013-05-18','14:50:00',2.22),('15529','2013-05-18','14:55:00',2.24),('15529','2013-05-18','15:00:00',2.21),('15529','2013-05-18','15:05:00',2.17),('15529','2013-05-18','15:10:00',2.16),('15529','2013-05-18','15:15:00',2.12),('15529','2013-05-18','15:20:00',2.09),('15529','2013-05-18','15:25:00',2.07),('15529','2013-05-18','15:30:00',2.05),('15529','2013-05-18','15:35:00',1.98),('15529','2013-05-18','15:40:00',1.97),('15529','2013-05-18','15:45:00',1.93),('15529','2013-05-18','15:50:00',1.93),('15529','2013-05-18','15:55:00',1.88),('15529','2013-05-18','16:00:00',1.83),('15529','2013-05-18','16:05:00',1.81),('15529','2013-05-18','16:10:00',1.77),('15529','2013-05-18','16:15:00',1.74),('15529','2013-05-18','16:20:00',1.7),('15529','2013-05-18','16:25:00',1.66),('15529','2013-05-18','16:30:00',1.63),('15529','2013-05-18','16:35:00',1.59),('15529','2013-05-18','16:40:00',1.55),('15529','2013-05-18','16:45:00',1.51),('15529','2013-05-18','16:50:00',1.46),('15529','2013-05-18','16:55:00',1.42),('15529','2013-05-18','17:00:00',1.37),('15529','2013-05-18','17:05:00',1.33),('15529','2013-05-18','17:10:00',1.28),('15529','2013-05-18','17:15:00',1.23),('15529','2013-05-18','17:20:00',1.17),('15529','2013-05-18','17:25:00',1.11),('15529','2013-05-18','17:30:00',1.07),('15529','2013-05-18','17:35:00',1.03),('15529','2013-05-17','08:25:00',1.19),('15529','2013-05-17','08:40:00',1.08),('15529','2013-05-17','08:45:00',1.11),('15529','2013-05-17','08:50:00',1.17),('15529','2013-05-17','08:55:00',1.22),('15529','2013-05-17','09:00:00',1.25),('15529','2013-05-17','09:05:00',1.29),('15529','2013-05-17','09:10:00',1.35),('15529','2013-05-17','09:15:00',1.38),('15529','2013-05-17','09:20:00',1.41),('15529','2013-05-17','09:25:00',1.46),('15529','2013-05-17','09:30:00',1.49),('15529','2013-05-17','09:35:00',1.54),('15529','2013-05-17','09:40:00',1.57),('15529','2013-05-17','09:45:00',1.6),('15529','2013-05-17','09:50:00',1.63),('15529','2013-05-17','09:55:00',1.67),('15529','2013-05-17','10:00:00',1.69),('15529','2013-05-17','10:05:00',1.73),('15529','2013-05-17','10:10:00',1.77),('15529','2013-05-17','10:15:00',1.8),('15529','2013-05-17','10:20:00',1.82),('15529','2013-05-17','10:25:00',1.85),('15529','2013-05-17','10:30:00',1.87),('15529','2013-05-17','10:35:00',1.88),('15529','2013-05-17','10:40:00',1.92),('15529','2013-05-17','10:45:00',1.94),('15529','2013-05-17','10:50:00',1.99),('15529','2013-05-17','10:55:00',2.07),('15529','2013-05-17','11:00:00',2.12),('15529','2013-05-17','11:05:00',1.91),('15529','2013-05-17','11:10:00',1.8),('15529','2013-05-17','11:15:00',2.17),('15529','2013-05-17','11:20:00',2.31),('15529','2013-05-17','11:25:00',2.25),('15529','2013-05-17','11:30:00',2.23),('15529','2013-05-17','11:35:00',2.21),('15529','2013-05-17','11:40:00',2.2),('15529','2013-05-17','11:45:00',2.15),('15529','2013-05-17','11:50:00',2.24),('15529','2013-05-17','11:55:00',1.48),('15529','2013-05-17','12:00:00',2.12),('15529','2013-05-17','12:05:00',2.23),('15529','2013-05-17','12:10:00',2.22),('15529','2013-05-17','12:15:00',2.23),('15529','2013-05-17','12:20:00',2.24),('15529','2013-05-17','12:25:00',2.3),('15529','2013-05-17','12:30:00',1.74),('15529','2013-05-17','12:35:00',2.25),('15529','2013-05-17','12:40:00',2.27),('15529','2013-05-17','12:45:00',2.27),('15529','2013-05-17','12:50:00',2.29),('15529','2013-05-17','12:55:00',2.24),('15529','2013-05-17','13:00:00',2.25),('15529','2013-05-17','13:05:00',2.24),('15529','2013-05-17','13:10:00',2.24),('15529','2013-05-17','13:15:00',2.22),('15529','2013-05-17','13:20:00',2.25),('15529','2013-05-17','13:25:00',2.25),('15529','2013-05-17','13:30:00',2.28),('15529','2013-05-17','13:35:00',2.3),('15529','2013-05-17','13:40:00',2.24),('15529','2013-05-17','13:45:00',2.12),('15529','2013-05-17','13:50:00',1.82),('15529','2013-05-17','13:55:00',1.42),('15529','2013-05-17','14:00:00',1.52),('15529','2013-05-17','14:05:00',2.13),('15529','2013-05-17','14:10:00',2.18),('15529','2013-05-17','14:15:00',1.86),('15529','2013-05-17','14:20:00',2.33),('15529','2013-05-17','14:25:00',2.24),('15529','2013-05-17','14:30:00',2.2),('15529','2013-05-17','14:35:00',2.04),('15529','2013-05-17','14:40:00',1.84),('15529','2013-05-17','14:45:00',1.24),('15529','2013-05-17','14:50:00',1.91),('15529','2013-05-17','14:55:00',2.07),('15529','2013-05-17','15:00:00',1.98),('15529','2013-05-17','15:05:00',1.91),('15529','2013-05-17','15:10:00',1.89),('15529','2013-05-17','15:15:00',1.86),('15529','2013-05-17','15:20:00',1.81),('15529','2013-05-17','15:25:00',1.79),('15529','2013-05-17','15:30:00',1.74),('15529','2013-05-17','15:35:00',1.74),('15529','2013-05-17','15:40:00',1.7),('15529','2013-05-17','15:45:00',1.67),('15529','2013-05-17','15:50:00',1.64),('15529','2013-05-17','15:55:00',1.63),('15529','2013-05-17','16:00:00',1.6),('15529','2013-05-17','16:05:00',1.56),('15529','2013-05-17','16:10:00',1.51),('15529','2013-05-17','16:15:00',1.48),('15529','2013-05-17','16:20:00',1.44),('15529','2013-05-17','16:25:00',1.4),('15529','2013-05-17','16:30:00',1.37),('15529','2013-05-17','16:35:00',1.33),('15529','2013-05-17','16:40:00',1.28),('15529','2013-05-17','16:45:00',1.25),('15529','2013-05-17','16:50:00',1.2),('15529','2013-05-17','16:55:00',1.14),('15529','2013-05-17','17:00:00',1.11),('15529','2013-05-17','17:05:00',1.08),('15529','2013-05-17','17:10:00',1.04),('15529','2013-05-17','17:15:00',1.01),('15529','2013-05-16','08:15:00',1.07),('15529','2013-05-16','10:50:00',1.94),('15529','2013-05-16','10:55:00',1.14),('15529','2013-05-16','11:00:00',1.01),('15529','2013-05-16','11:15:00',1.84),('15529','2013-05-16','11:20:00',1.05),('15529','2013-05-16','11:30:00',1.56),('15529','2013-05-16','11:35:00',1.7),('15529','2013-05-16','11:40:00',2.04),('15529','2013-05-16','11:45:00',2.19),('15529','2013-05-16','11:50:00',1.88),('15529','2013-05-16','11:55:00',2.47),('15529','2013-05-16','12:00:00',2.62),('15529','2013-05-16','12:05:00',2.01),('15529','2013-05-16','12:10:00',1.99),('15529','2013-05-16','12:15:00',1.56),('15529','2013-05-16','12:20:00',2.29),('15529','2013-05-16','12:25:00',1.97),('15529','2013-05-16','12:30:00',1.86),('15529','2013-05-16','12:35:00',2.23),('15529','2013-05-16','12:40:00',2.62),('15529','2013-05-16','12:45:00',2.5),('15529','2013-05-16','12:50:00',2.19),('15529','2013-05-16','12:55:00',2.39),('15529','2013-05-16','13:00:00',2.39),('15529','2013-05-16','13:05:00',2.57),('15529','2013-05-16','13:10:00',2.39),('15529','2013-05-16','13:15:00',2.47),('15529','2013-05-16','13:20:00',2.34),('15529','2013-05-16','13:25:00',2.41),('15529','2013-05-16','13:30:00',2.05),('15529','2013-05-16','13:35:00',2.48),('15529','2013-05-16','13:40:00',2.3),('15529','2013-05-16','13:45:00',2.21),('15529','2013-05-16','13:50:00',2.11),('15529','2013-05-16','13:55:00',2.56),('15529','2013-05-16','14:00:00',2.14),('15529','2013-05-16','14:05:00',2.22),('15529','2013-05-16','14:10:00',2.14),('15529','2013-05-16','14:15:00',2.41),('15529','2013-05-16','14:20:00',2.35),('15529','2013-05-16','14:25:00',1.85),('15529','2013-05-16','14:30:00',1.71),('15529','2013-05-16','14:35:00',1.9),('15529','2013-05-16','14:40:00',1.04),('15529','2013-05-16','14:45:00',1.31),('15529','2013-05-16','15:10:00',1.02),('15529','2013-05-16','15:15:00',1.03),('15529','2013-05-16','15:20:00',1.39),('15529','2013-05-16','15:25:00',1.63),('15529','2013-05-16','15:30:00',1.87),('15529','2013-05-16','15:35:00',1.21),('15529','2013-05-16','15:40:00',1.5),('15529','2013-05-16','15:45:00',2.01),('15529','2013-05-16','15:50:00',1.32),('15529','2013-05-16','15:55:00',1.19),('15529','2013-05-16','16:10:00',1.93),('15529','2013-05-16','16:15:00',1.8),('15529','2013-05-16','16:20:00',1.46),('15529','2013-05-16','16:25:00',1.7),('15529','2013-05-16','16:30:00',1.38),('15529','2013-05-16','16:35:00',1.01),('15529','2013-05-16','16:40:00',1.39),('15529','2013-05-16','16:45:00',1.52),('15529','2013-05-16','16:50:00',1.44),('15529','2013-05-16','16:55:00',1.39),('15529','2013-05-16','17:00:00',1.33),('15529','2013-05-16','17:05:00',1.27),('15529','2013-05-16','17:10:00',1.23),('15529','2013-05-16','17:15:00',1.17),('15529','2013-05-16','17:20:00',1.12),('15529','2013-05-16','17:25:00',1.08),('15529','2013-05-16','17:30:00',1.04),('15529','2013-05-15','09:40:00',1),('15529','2013-05-15','09:45:00',1.45),('15529','2013-05-15','09:50:00',1.03),('15529','2013-05-15','10:20:00',1.14),('15529','2013-05-15','11:00:00',1.78),('15529','2013-05-15','11:05:00',1.88),('15529','2013-05-15','11:10:00',2.1),('15529','2013-05-15','11:15:00',1.76),('15529','2013-05-15','11:55:00',1.81),('15529','2013-05-15','12:00:00',1.09),('15529','2013-05-15','12:05:00',1.1),('15529','2013-05-15','12:15:00',1.46),('15529','2013-05-15','12:30:00',1.35),('15529','2013-05-15','12:35:00',1.93),('15529','2013-05-15','12:40:00',2.24),('15529','2013-05-15','12:45:00',1.72),('15529','2013-05-15','12:50:00',1.56),('15529','2013-05-15','12:55:00',1.59),('15529','2013-05-15','13:00:00',2.19),('15529','2013-05-15','13:05:00',2.2),('15529','2013-05-15','13:10:00',2.15),('15529','2013-05-15','13:15:00',2.17),('15529','2013-05-15','13:20:00',2.14),('15529','2013-05-15','13:25:00',2.14),('15529','2013-05-15','13:30:00',2.16),('15529','2013-05-15','13:35:00',2.18),('15529','2013-05-15','13:40:00',2.1),('15529','2013-05-15','13:45:00',2.15),('15529','2013-05-15','13:50:00',2.13),('15529','2013-05-15','13:55:00',2.12),('15529','2013-05-15','14:00:00',2.16),('15529','2013-05-15','14:05:00',2.08),('15529','2013-05-15','14:10:00',2.01),('15529','2013-05-15','14:15:00',2.03),('15529','2013-05-15','14:20:00',2.01),('15529','2013-05-15','14:25:00',2.01),('15529','2013-05-15','14:30:00',1.91),('15529','2013-05-15','14:35:00',1.93),('15529','2013-05-15','14:40:00',1.91),('15529','2013-05-15','14:45:00',1.94),('15529','2013-05-15','14:50:00',1.97),('15529','2013-05-15','14:55:00',1.9),('15529','2013-05-15','15:00:00',1.82),('15529','2013-05-15','15:05:00',1.6),('15529','2013-05-15','15:10:00',1.47),('15529','2013-05-15','15:15:00',1.62),('15529','2013-05-15','15:20:00',1.77),('15529','2013-05-15','15:25:00',1.71),('15529','2013-05-15','15:30:00',1.71),('15529','2013-05-15','15:35:00',1.66),('15529','2013-05-15','15:40:00',1.66),('15529','2013-05-15','15:45:00',1.63),('15529','2013-05-15','15:50:00',1.62),('15529','2013-05-15','15:55:00',1.59),('15529','2013-05-15','16:00:00',1.56),('15529','2013-05-15','16:05:00',1.48),('15529','2013-05-15','16:10:00',1.51),('15529','2013-05-15','16:15:00',1.34),('15529','2013-05-15','16:20:00',1.44),('15529','2013-05-15','16:25:00',1.39),('15529','2013-05-15','16:30:00',1.35),('15529','2013-05-15','16:35:00',1.31),('15529','2013-05-15','16:50:00',1.02),('15529','2013-05-14','08:40:00',1.05),('15529','2013-05-14','08:45:00',1.09),('15529','2013-05-14','08:50:00',1.13),('15529','2013-05-14','08:55:00',1.17),('15529','2013-05-14','09:00:00',1.17),('15529','2013-05-14','09:05:00',1.24),('15529','2013-05-14','09:10:00',1.24),('15529','2013-05-14','09:15:00',1.28),('15529','2013-05-14','09:20:00',1.29),('15529','2013-05-14','09:25:00',1.37),('15529','2013-05-14','09:30:00',1.45),('15529','2013-05-14','09:35:00',1.46),('15529','2013-05-14','09:40:00',1.48),('15529','2013-05-14','09:45:00',1.56),('15529','2013-05-14','09:50:00',1.59),('15529','2013-05-14','09:55:00',1.62),('15529','2013-05-14','10:00:00',1.66),('15529','2013-05-14','10:05:00',1.7),('15529','2013-05-14','10:10:00',1.72),('15529','2013-05-14','10:15:00',1.73),('15529','2013-05-14','10:20:00',1.81),('15529','2013-05-14','10:25:00',1.83),('15529','2013-05-14','10:30:00',1.81),('15529','2013-05-14','10:35:00',1.88),('15529','2013-05-14','10:40:00',1.93),('15529','2013-05-14','10:45:00',1.94),('15529','2013-05-14','10:50:00',1.93),('15529','2013-05-14','10:55:00',1.87),('15529','2013-05-14','11:00:00',1.87),('15529','2013-05-14','11:05:00',2.02),('15529','2013-05-14','11:10:00',2.03),('15529','2013-05-14','11:15:00',2.05),('15529','2013-05-14','11:20:00',1.99),('15529','2013-05-14','11:25:00',2.1),('15529','2013-05-14','11:30:00',2.11),('15529','2013-05-14','11:35:00',1.97),('15529','2013-05-14','11:40:00',1.61),('15529','2013-05-14','11:45:00',1.63),('15529','2013-05-14','11:50:00',1.32),('15529','2013-05-14','12:00:00',1.29),('15529','2013-05-14','12:05:00',1.62),('15529','2013-05-14','12:10:00',2.64),('15529','2013-05-14','12:15:00',2.68),('15529','2013-05-14','12:20:00',2.54),('15529','2013-05-14','12:25:00',1.72),('15529','2013-05-14','12:30:00',1.63),('15529','2013-05-14','12:35:00',2.22),('15529','2013-05-14','12:40:00',1.97),('15529','2013-05-14','12:45:00',1.31),('15529','2013-05-14','12:50:00',1.27),('15529','2013-05-14','12:55:00',1.39),('15529','2013-05-14','13:00:00',1.33),('15529','2013-05-14','13:05:00',1.74),('15529','2013-05-14','13:10:00',1.18),('15529','2013-05-14','13:15:00',1.42),('15529','2013-05-14','13:20:00',1.37),('15529','2013-05-14','13:25:00',1.54),('15529','2013-05-14','13:30:00',1.35),('15529','2013-05-14','13:35:00',1.24),('15529','2013-05-14','13:40:00',1.6),('15529','2013-05-14','13:45:00',1.28),('15529','2013-05-14','13:50:00',1.07),('15529','2013-05-14','13:55:00',1.05),('15529','2013-05-14','14:20:00',1.05),('15529','2013-05-14','15:55:00',1.11),('15529','2013-05-14','17:10:00',1.59),('15529','2013-05-14','17:15:00',1.15),('15529','2013-05-13','08:35:00',1.05),('15529','2013-05-13','08:40:00',1.09),('15529','2013-05-13','08:45:00',1.14),('15529','2013-05-13','08:50:00',1.19),('15529','2013-05-13','08:55:00',1.24),('15529','2013-05-13','09:00:00',1.29),('15529','2013-05-13','09:05:00',1.32),('15529','2013-05-13','09:10:00',1.37),('15529','2013-05-13','09:15:00',1.41),('15529','2013-05-13','09:20:00',1.45),('15529','2013-05-13','09:25:00',1.5),('15529','2013-05-13','09:30:00',1.54),('15529','2013-05-13','09:35:00',1.58),('15529','2013-05-13','09:40:00',1.62),('15529','2013-05-13','09:45:00',1.65),('15529','2013-05-13','09:50:00',1.68),('15529','2013-05-13','09:55:00',1.71),('15529','2013-05-13','10:00:00',1.74),('15529','2013-05-13','10:05:00',1.79),('15529','2013-05-13','10:10:00',1.81),('15529','2013-05-13','10:15:00',1.85),('15529','2013-05-13','10:20:00',1.86),('15529','2013-05-13','10:25:00',1.92),('15529','2013-05-13','10:30:00',1.92),('15529','2013-05-13','10:35:00',1.96),('15529','2013-05-13','10:40:00',2),('15529','2013-05-13','10:45:00',2.03),('15529','2013-05-13','10:50:00',2.02),('15529','2013-05-13','10:55:00',2.08),('15529','2013-05-13','11:00:00',2.05),('15529','2013-05-13','11:05:00',2.11),('15529','2013-05-13','11:10:00',2.12),('15529','2013-05-13','11:15:00',2.15),('15529','2013-05-13','11:20:00',2.15),('15529','2013-05-13','11:25:00',2.17),('15529','2013-05-13','11:30:00',2.16),('15529','2013-05-13','11:35:00',2.19),('15529','2013-05-13','11:40:00',2.21),('15529','2013-05-13','11:45:00',2.2),('15529','2013-05-13','11:50:00',2.21),('15529','2013-05-13','11:55:00',2.23),('15529','2013-05-13','12:00:00',2.23),('15529','2013-05-13','12:05:00',2.24),('15529','2013-05-13','12:10:00',2.24),('15529','2013-05-13','12:15:00',2.29),('15529','2013-05-13','12:20:00',2.32),('15529','2013-05-13','12:25:00',2.3),('15529','2013-05-13','12:30:00',2.32),('15529','2013-05-13','12:35:00',2.33),('15529','2013-05-13','12:40:00',2.33),('15529','2013-05-13','12:45:00',2.31),('15529','2013-05-13','12:50:00',2.33),('15529','2013-05-13','12:55:00',2.31),('15529','2013-05-13','13:00:00',2.34),('15529','2013-05-13','13:05:00',2.3),('15529','2013-05-13','13:10:00',2.33),('15529','2013-05-13','13:15:00',2.33),('15529','2013-05-13','13:20:00',2.33),('15529','2013-05-13','13:25:00',2.35),('15529','2013-05-13','13:30:00',2.31),('15529','2013-05-13','13:35:00',2.31),('15529','2013-05-13','13:40:00',2.29),('15529','2013-05-13','13:45:00',2.27),('15529','2013-05-13','13:50:00',2.24),('15529','2013-05-13','13:55:00',2.25),('15529','2013-05-13','14:00:00',2.26),('15529','2013-05-13','14:05:00',2.22),('15529','2013-05-13','14:10:00',2.21),('15529','2013-05-13','14:15:00',2.19),('15529','2013-05-13','14:20:00',2.19),('15529','2013-05-13','14:25:00',2.17),('15529','2013-05-13','14:30:00',2.17),('15529','2013-05-13','14:35:00',2.16),('15529','2013-05-13','14:40:00',2.2),('15529','2013-05-13','14:45:00',2.19),('15529','2013-05-13','14:50:00',2.15),('15529','2013-05-13','14:55:00',2.14),('15529','2013-05-13','15:00:00',2.12),('15529','2013-05-13','15:05:00',2.09),('15529','2013-05-13','15:10:00',2.07),('15529','2013-05-13','15:15:00',2.05),('15529','2013-05-13','15:20:00',2.01),('15529','2013-05-13','15:25:00',2),('15529','2013-05-13','15:30:00',1.96),('15529','2013-05-13','15:35:00',1.94),('15529','2013-05-13','15:40:00',1.91),('15529','2013-05-13','15:45:00',1.89),('15529','2013-05-13','15:50:00',1.86),('15529','2013-05-13','15:55:00',1.83),('15529','2013-05-13','16:00:00',1.79),('15529','2013-05-13','16:05:00',1.76),('15529','2013-05-13','16:10:00',1.71),('15529','2013-05-13','16:15:00',1.68),('15529','2013-05-13','16:20:00',1.64),('15529','2013-05-13','16:25:00',1.6),('15529','2013-05-13','16:30:00',1.56),('15529','2013-05-13','16:35:00',1.52),('15529','2013-05-13','16:40:00',1.47),('15529','2013-05-13','16:45:00',1.43),('15529','2013-05-13','16:50:00',1.39),('15529','2013-05-13','16:55:00',1.35),('15529','2013-05-13','17:00:00',1.3),('15529','2013-05-13','17:05:00',1.26),('15529','2013-05-13','17:10:00',1.2),('15529','2013-05-13','17:15:00',1.16),('15529','2013-05-13','17:20:00',1.12),('15529','2013-05-13','17:25:00',1.06),('15529','2013-05-13','17:30:00',1.01),('15529','2013-05-12','08:40:00',1.02),('15529','2013-05-12','08:45:00',1.08),('15529','2013-05-12','08:50:00',1.13),('15529','2013-05-12','08:55:00',1.17),('15529','2013-05-12','09:00:00',1.21),('15529','2013-05-12','09:05:00',1.25),('15529','2013-05-12','09:10:00',1.3),('15529','2013-05-12','09:15:00',1.32),('15529','2013-05-12','09:20:00',1.37),('15529','2013-05-12','09:25:00',1.27),('15529','2013-05-12','09:30:00',1.44),('15529','2013-05-12','09:35:00',1.56),('15529','2013-05-12','09:40:00',1.59),('15529','2013-05-12','09:45:00',1.69),('15529','2013-05-12','09:55:00',1.9),('15529','2013-05-12','10:00:00',1.43),('15529','2013-05-12','10:05:00',1.89),('15529','2013-05-12','10:10:00',1.85),('15529','2013-05-12','10:15:00',1.85),('15529','2013-05-12','10:20:00',1.92),('15529','2013-05-12','10:25:00',1.91),('15529','2013-05-12','10:30:00',1.96),('15529','2013-05-12','10:35:00',2.01),('15529','2013-05-12','10:40:00',2.14),('15529','2013-05-12','10:45:00',1.49),('15529','2013-05-12','10:50:00',2.08),('15529','2013-05-12','10:55:00',1.35),('15529','2013-05-12','11:00:00',2.03),('15529','2013-05-12','11:05:00',1.39),('15529','2013-05-12','11:10:00',1.65),('15529','2013-05-12','11:40:00',2.58),('15529','2013-05-12','11:45:00',2.43),('15529','2013-05-12','11:50:00',1.92),('15529','2013-05-12','11:55:00',1.82),('15529','2013-05-12','12:00:00',1.16),('15529','2013-05-12','12:30:00',1.15),('15529','2013-05-12','12:35:00',2.71),('15529','2013-05-12','12:40:00',2.58),('15529','2013-05-12','12:45:00',2.52),('15529','2013-05-12','12:50:00',2.58),('15529','2013-05-12','12:55:00',1.49),('15529','2013-05-12','13:00:00',1.73),('15529','2013-05-12','13:05:00',2.48),('15529','2013-05-12','13:10:00',2.52),('15529','2013-05-12','13:15:00',2.3),('15529','2013-05-12','13:20:00',1.89),('15529','2013-05-12','13:30:00',1.26),('15529','2013-05-12','13:35:00',2.35),('15529','2013-05-12','13:40:00',2.51),('15529','2013-05-12','13:45:00',2.55),('15529','2013-05-12','13:50:00',2.49),('15529','2013-05-12','13:55:00',2.54),('15529','2013-05-12','14:00:00',2.38),('15529','2013-05-12','14:05:00',2.44),('15529','2013-05-12','14:10:00',2.39),('15529','2013-05-12','14:15:00',2.38),('15529','2013-05-12','14:20:00',2.44),('15529','2013-05-12','14:25:00',2.28),('15529','2013-05-12','14:30:00',1.54),('15529','2013-05-12','14:50:00',1.11),('15529','2013-05-12','14:55:00',2.38),('15529','2013-05-12','15:00:00',2.23),('15529','2013-05-12','15:45:00',1.18),('15529','2013-05-12','16:55:00',1.42),('15529','2013-05-12','17:00:00',1.41),('15529','2013-05-12','17:20:00',1.02),('15529','2013-05-12','17:25:00',1.02),('15529','2013-05-12','17:30:00',1.17),('15529','2013-05-12','17:35:00',1.14),('15529','2013-05-12','17:40:00',1.1),('15529','2013-05-12','17:45:00',1.03),('15529','2013-05-12','17:50:00',1.08),('15529','2013-05-12','17:55:00',1.12),('15529','2013-05-11','08:35:00',1.19),('15529','2013-05-11','09:00:00',1.5),('15529','2013-05-11','09:05:00',1.07),('15529','2013-05-11','09:10:00',1.47),('15529','2013-05-11','09:40:00',1.07),('15529','2013-05-11','09:55:00',1.31),('15529','2013-05-11','10:00:00',1.84),('15529','2013-05-11','10:05:00',1.85),('15529','2013-05-11','10:10:00',1.92),('15529','2013-05-11','10:15:00',2.02),('15529','2013-05-11','10:20:00',1.94),('15529','2013-05-11','10:25:00',2.15),('15529','2013-05-11','10:30:00',2.1),('15529','2013-05-11','10:35:00',2.22),('15529','2013-05-11','10:40:00',2.07),('15529','2013-05-11','10:45:00',2.31),('15529','2013-05-11','10:50:00',2.24),('15529','2013-05-11','10:55:00',1.59),('15529','2013-05-11','11:00:00',1.13),('15529','2013-05-11','11:05:00',2.44),('15529','2013-05-11','11:10:00',2.47),('15529','2013-05-11','11:15:00',2.4),('15529','2013-05-11','11:20:00',2.39),('15529','2013-05-11','11:50:00',1.33),('15529','2013-05-11','11:55:00',2.47),('15529','2013-05-11','12:00:00',1.61),('15529','2013-05-11','12:05:00',1.2),('15529','2013-05-11','12:25:00',1.23),('15529','2013-05-11','12:45:00',1.26),('15529','2013-05-11','12:55:00',1.39),('15529','2013-05-11','13:00:00',2.73),('15529','2013-05-11','13:05:00',1.59),('15529','2013-05-11','13:10:00',1.19),('15529','2013-05-11','13:15:00',2.44),('15529','2013-05-11','13:20:00',2.58),('15529','2013-05-11','13:25:00',2.37),('15529','2013-05-11','13:30:00',2.14),('15529','2013-05-11','13:35:00',2.46),('15529','2013-05-11','13:40:00',2.32),('15529','2013-05-11','13:45:00',1.97),('15529','2013-05-11','13:50:00',2.55),('15529','2013-05-11','13:55:00',1.31),('15529','2013-05-11','14:00:00',2.11),('15529','2013-05-11','14:05:00',1.91),('15529','2013-05-11','14:10:00',1.72),('15529','2013-05-11','14:15:00',1.67),('15529','2013-05-11','14:20:00',2.28),('15529','2013-05-11','14:25:00',2.1),('15529','2013-05-11','14:30:00',2.17),('15529','2013-05-11','14:35:00',2.38),('15529','2013-05-11','14:40:00',2.34),('15529','2013-05-11','14:45:00',1.78),('15529','2013-05-11','14:50:00',1.85),('15529','2013-05-11','14:55:00',2.33),('15529','2013-05-11','15:00:00',1.57),('15529','2013-05-11','15:05:00',1.71),('15529','2013-05-11','15:10:00',1.55),('15529','2013-05-11','15:15:00',2.12),('15529','2013-05-11','15:20:00',2.15),('15529','2013-05-11','15:25:00',2.03),('15529','2013-05-11','15:30:00',1.99),('15529','2013-05-11','15:35:00',1.97),('15529','2013-05-11','15:40:00',1.94),('15529','2013-05-11','15:45:00',1.85),('15529','2013-05-11','15:50:00',1.82),('15529','2013-05-11','15:55:00',1.79),('15529','2013-05-11','16:00:00',1.76),('15529','2013-05-11','16:05:00',1.71),('15529','2013-05-11','16:10:00',1.69),('15529','2013-05-11','16:15:00',1.65),('15529','2013-05-11','16:20:00',1.61),('15529','2013-05-11','16:25:00',1.57),('15529','2013-05-11','16:30:00',1.54),('15529','2013-05-11','16:35:00',1.53),('15529','2013-05-11','16:40:00',1.44),('15529','2013-05-11','16:45:00',1.46),('15529','2013-05-11','16:50:00',1.48),('15529','2013-05-11','16:55:00',1.55),('15529','2013-05-11','17:00:00',1.6),('15529','2013-05-11','17:05:00',1.44),('15529','2013-05-11','17:10:00',1.26),('15529','2013-05-11','17:15:00',1.44),('15529','2013-05-11','17:20:00',1.01),('15529','2013-05-11','17:25:00',1.02),('15529','2013-05-11','17:30:00',1.21),('15529','2013-05-11','17:40:00',1.16),('15529','2014-03-30','09:00:00',1.01),('15529','2014-03-30','09:05:00',1.07),('15529','2014-03-30','09:10:00',1.11),('15529','2014-03-30','09:15:00',1.16),('15529','2014-03-30','09:20:00',1.22),('15529','2014-03-30','09:25:00',1.26),('15529','2014-03-30','09:30:00',1.3),('15529','2014-03-30','09:35:00',1.35),('15529','2014-03-30','09:40:00',1.4),('15529','2014-03-30','09:45:00',1.43),('15529','2014-03-30','09:50:00',1.46),('15529','2014-03-30','09:55:00',1.5),('15529','2014-03-30','10:00:00',1.54),('15529','2014-03-30','10:05:00',1.59),('15529','2014-03-30','10:10:00',1.63),('15529','2014-03-30','10:15:00',1.67),('15529','2014-03-30','10:20:00',1.71),('15529','2014-03-30','10:25:00',1.72),('15529','2014-03-30','10:30:00',1.76),('15529','2014-03-30','10:35:00',1.79),('15529','2014-03-30','10:40:00',1.81),('15529','2014-03-30','10:45:00',1.83),('15529','2014-03-30','10:50:00',1.86),('15529','2014-03-30','10:55:00',1.9),('15529','2014-03-30','11:00:00',1.92),('15529','2014-03-30','11:05:00',1.92),('15529','2014-03-30','11:10:00',1.97),('15529','2014-03-30','11:15:00',2),('15529','2014-03-30','11:20:00',2.02),('15529','2014-03-30','11:25:00',2.04),('15529','2014-03-30','11:30:00',2.05),('15529','2014-03-30','11:35:00',2.07),('15529','2014-03-30','11:40:00',2.07),('15529','2014-03-30','11:45:00',2.1),('15529','2014-03-30','11:50:00',2.11),('15529','2014-03-30','11:55:00',2.13),('15529','2014-03-30','12:00:00',2.12),('15529','2014-03-30','12:05:00',2.14),('15529','2014-03-30','12:10:00',2.18),('15529','2014-03-30','12:15:00',2.21),('15529','2014-03-30','12:20:00',2.23),('15529','2014-03-30','12:25:00',2.21),('15529','2014-03-30','12:30:00',2.26),('15529','2014-03-30','12:35:00',2.22),('15529','2014-03-30','12:40:00',2.23),('15529','2014-03-30','12:45:00',2.22),('15529','2014-03-30','12:50:00',2.24),('15529','2014-03-30','12:55:00',2.28),('15529','2014-03-30','13:00:00',2.31),('15529','2014-03-30','13:05:00',2.32),('15529','2014-03-30','13:10:00',2.32),('15529','2014-03-30','13:15:00',2.3),('15529','2014-03-30','13:20:00',2.3),('15529','2014-03-30','13:25:00',2.29),('15529','2014-03-30','13:30:00',2.27),('15529','2014-03-30','13:35:00',2.24),('15529','2014-03-30','13:40:00',2.28),('15529','2014-03-30','13:45:00',2.29),('15529','2014-03-30','13:50:00',2.29),('15529','2014-03-30','13:55:00',2.28),('15529','2014-03-30','14:00:00',2.29),('15529','2014-03-30','14:05:00',2.27),('15529','2014-03-30','14:10:00',2.24),('15529','2014-03-30','14:15:00',2.21),('15529','2014-03-30','14:20:00',2.23),('15529','2014-03-30','14:25:00',2.19),('15529','2014-03-30','14:30:00',2.18),('15529','2014-03-30','14:35:00',2.16),('15529','2014-03-30','14:40:00',2.16),('15529','2014-03-30','14:45:00',2.13),('15529','2014-03-30','14:50:00',2.13),('15529','2014-03-30','14:55:00',2.09),('15529','2014-03-30','15:00:00',2.06),('15529','2014-03-30','15:05:00',2.05),('15529','2014-03-30','15:10:00',2.04),('15529','2014-03-30','15:15:00',1.99),('15529','2014-03-30','15:20:00',1.96),('15529','2014-03-30','15:25:00',1.94),('15529','2014-03-30','15:30:00',1.9),('15529','2014-03-30','15:35:00',1.87),('15529','2014-03-30','15:40:00',1.85),('15529','2014-03-30','15:45:00',1.82),('15529','2014-03-30','15:50:00',1.79),('15529','2014-03-30','15:55:00',1.74),('15529','2014-03-30','16:00:00',1.7),('15529','2014-03-30','16:05:00',1.65),('15529','2014-03-30','16:10:00',1.61),('15529','2014-03-30','16:15:00',1.57),('15529','2014-03-30','16:20:00',1.53),('15529','2014-03-30','16:25:00',1.48),('15529','2014-03-30','16:30:00',1.45),('15529','2014-03-30','16:35:00',1.41),('15529','2014-03-30','16:40:00',1.36),('15529','2014-03-30','16:45:00',1.33),('15529','2014-03-30','16:50:00',1.27),('15529','2014-03-30','16:55:00',1.23),('15529','2014-03-30','17:00:00',1.18),('15529','2014-03-30','17:05:00',1.14),('15529','2014-03-30','17:10:00',1.08),('15529','2014-03-30','17:15:00',1.03),('15529','2013-05-10','09:00:00',1.21),('15529','2013-05-10','09:05:00',1.47),('15529','2013-05-10','09:15:00',1.16),('15529','2013-05-10','09:25:00',1.01),('15529','2013-05-10','09:30:00',1.01),('15529','2013-05-10','09:40:00',1.15),('15529','2013-05-10','09:45:00',1.11),('15529','2013-05-10','09:50:00',1.62),('15529','2013-05-10','10:40:00',1.32),('15529','2013-05-10','10:50:00',1.48),('15529','2013-05-10','10:55:00',2.21),('15529','2013-05-10','11:00:00',1.94),('15529','2013-05-10','11:25:00',1.85),('15529','2013-05-10','11:35:00',1.71),('15529','2013-05-10','11:40:00',2.39),('15529','2013-05-10','12:15:00',1.52),('15529','2013-05-10','12:20:00',2.23),('15529','2013-05-10','12:25:00',1.1),('15529','2013-05-10','12:35:00',1.3),('15529','2013-05-10','13:55:00',1.04),('15529','2013-05-10','14:00:00',2.46),('15529','2013-05-10','14:05:00',1.79),('15529','2013-05-10','14:10:00',2.2),('15529','2013-05-10','14:15:00',2.33),('15529','2013-05-10','14:20:00',2.13),('15529','2013-05-10','14:35:00',1.89),('15529','2013-05-10','14:40:00',1.45),('15529','2013-05-10','14:45:00',2),('15529','2013-05-10','14:50:00',1.55),('15529','2013-05-10','14:55:00',1.93),('15529','2013-05-10','15:00:00',1.35),('15529','2013-05-10','15:05:00',1.36),('15529','2013-05-10','15:10:00',1.84),('15529','2013-05-10','15:15:00',1.95),('15529','2013-05-10','15:20:00',1.14),('15529','2013-05-10','15:25:00',1.22),('15529','2013-05-10','15:30:00',1.36),('15529','2013-05-10','15:35:00',1.77),('15529','2013-05-10','15:40:00',1.67),('15529','2013-05-10','15:45:00',1.75),('15529','2013-05-10','15:50:00',1.39),('15529','2013-05-10','15:55:00',1.74),('15529','2013-05-10','16:00:00',1.55),('15529','2013-05-10','16:05:00',1.47),('15529','2013-05-10','16:10:00',1.5),('15529','2013-05-10','16:15:00',1.31),('15529','2013-05-10','16:20:00',1.75),('15529','2013-05-10','16:25:00',1.71),('15529','2013-05-10','16:30:00',1.66),('15529','2013-05-10','16:35:00',1.62),('15529','2013-05-10','16:40:00',1.23),('15529','2013-05-10','16:45:00',1.48),('15529','2013-05-10','16:50:00',1.48),('15529','2013-05-10','16:55:00',1.25),('15529','2013-05-10','17:15:00',1.1),('15529','2013-05-10','17:20:00',1.21),('15529','2013-05-09','09:00:00',1.03),('15529','2013-05-09','09:05:00',1.3),('15529','2013-05-09','09:10:00',1.34),('15529','2013-05-09','09:15:00',1.35),('15529','2013-05-09','09:20:00',1.31),('15529','2013-05-09','09:25:00',1.25),('15529','2013-05-09','09:30:00',1.54),('15529','2013-05-09','09:35:00',1.44),('15529','2013-05-09','09:40:00',1.33),('15529','2013-05-09','09:45:00',1.38),('15529','2013-05-09','09:50:00',1.41),('15529','2013-05-09','09:55:00',1.45),('15529','2013-05-09','10:00:00',1.27),('15529','2013-05-09','10:05:00',1.27),('15529','2013-05-09','10:10:00',1.7),('15529','2013-05-09','10:15:00',1.47),('15529','2013-05-09','10:20:00',1.07),('15529','2013-05-09','10:25:00',1.22),('15529','2013-05-09','10:45:00',1.7),('15529','2013-05-09','10:50:00',2.08),('15529','2013-05-09','10:55:00',2.11),('15529','2013-05-09','11:00:00',2.07),('15529','2013-05-09','11:05:00',2.22),('15529','2013-05-09','11:10:00',2.2),('15529','2013-05-09','11:15:00',2.33),('15529','2013-05-09','11:20:00',2.04),('15529','2013-05-09','11:25:00',1.58),('15529','2013-05-09','11:30:00',2.24),('15529','2013-05-09','11:35:00',1.94),('15529','2013-05-09','11:40:00',2.29),('15529','2013-05-09','11:45:00',1.78),('15529','2013-05-09','11:55:00',1.06),('15529','2013-05-09','12:00:00',1.38),('15529','2013-05-09','12:05:00',1.33),('15529','2013-05-09','12:10:00',1.8),('15529','2013-05-09','12:15:00',1.56),('15529','2013-05-09','12:20:00',1.47),('15529','2013-05-09','12:25:00',1.31),('15529','2013-05-09','12:30:00',1.57),('15529','2013-05-09','12:35:00',2),('15529','2013-05-09','12:40:00',2.13),('15529','2013-05-09','12:45:00',2.13),('15529','2013-05-09','12:50:00',2.2),('15529','2013-05-09','12:55:00',2.26),('15529','2013-05-09','13:00:00',2.51),('15529','2013-05-09','13:05:00',2.34),('15529','2013-05-09','13:10:00',2.47),('15529','2013-05-09','13:15:00',2.36),('15529','2013-05-09','13:20:00',1.55),('15529','2013-05-09','13:25:00',1.58),('15529','2013-05-09','13:30:00',2.13),('15529','2013-05-09','13:35:00',2.05),('15529','2013-05-09','13:40:00',2.07),('15529','2013-05-09','13:45:00',1.15),('15529','2013-05-09','13:50:00',1.04),('15529','2013-05-09','13:55:00',1),('15529','2013-05-09','14:00:00',1.05),('15529','2013-05-09','14:05:00',1.26),('15529','2013-05-09','14:10:00',1.47),('15529','2013-05-09','14:15:00',1.36),('15529','2013-05-09','14:20:00',1.26),('15529','2013-05-09','14:25:00',1.2),('15529','2013-05-09','14:30:00',1.33),('15529','2013-05-09','14:35:00',1.56),('15529','2013-05-09','14:40:00',1.01),('15529','2013-05-09','15:10:00',1.53),('15529','2013-05-09','15:15:00',1.27),('15529','2013-05-09','15:20:00',1.06),('15529','2013-05-09','15:30:00',1.04),('15529','2013-05-09','15:35:00',1.12),('15529','2013-05-09','15:40:00',1.08),('15529','2013-05-09','17:15:00',1.13),('15529','2013-05-09','17:20:00',1.35),('15529','2013-05-09','17:25:00',1.35),('15529','2013-05-09','17:30:00',1.42),('15529','2013-05-08','08:40:00',1.03),('15529','2013-05-08','08:45:00',1.08),('15529','2013-05-08','08:50:00',1.13),('15529','2013-05-08','08:55:00',1.18),('15529','2013-05-08','09:00:00',1.22),('15529','2013-05-08','09:05:00',1.27),('15529','2013-05-08','09:10:00',1.31),('15529','2013-05-08','09:15:00',1.36),('15529','2013-05-08','09:20:00',1.4),('15529','2013-05-08','09:25:00',1.44),('15529','2013-05-08','09:30:00',1.48),('15529','2013-05-08','09:35:00',1.53),('15529','2013-05-08','09:40:00',1.56),('15529','2013-05-08','09:45:00',1.59),('15529','2013-05-08','09:50:00',1.63),('15529','2013-05-08','09:55:00',1.68),('15529','2013-05-08','10:00:00',1.71),('15529','2013-05-08','10:05:00',1.74),('15529','2013-05-08','10:10:00',1.77),('15529','2013-05-08','10:15:00',1.8),('15529','2013-05-08','10:20:00',1.82),('15529','2013-05-08','10:25:00',1.86),('15529','2013-05-08','10:30:00',1.9),('15529','2013-05-08','10:35:00',1.93),('15529','2013-05-08','10:40:00',1.93),('15529','2013-05-08','10:45:00',1.96),('15529','2013-05-08','10:50:00',1.99),('15529','2013-05-08','10:55:00',1.99),('15529','2013-05-08','11:00:00',2.03),('15529','2013-05-08','11:05:00',2.04),('15529','2013-05-08','11:10:00',2.06),('15529','2013-05-08','11:15:00',2.09),('15529','2013-05-08','11:20:00',2.14),('15529','2013-05-08','11:25:00',2.14),('15529','2013-05-08','11:30:00',2.13),('15529','2013-05-08','11:35:00',2.12),('15529','2013-05-08','11:40:00',2.16),('15529','2013-05-08','11:45:00',2.2),('15529','2013-05-08','11:50:00',2.2),('15529','2013-05-08','11:55:00',2.25),('15529','2013-05-08','12:00:00',2.23),('15529','2013-05-08','12:05:00',2.25),('15529','2013-05-08','12:10:00',2.25),('15529','2013-05-08','12:15:00',2.25),('15529','2013-05-08','12:20:00',2.31),('15529','2013-05-08','12:25:00',2.27),('15529','2013-05-08','12:30:00',2.31),('15529','2013-05-08','12:35:00',2.3),('15529','2013-05-08','12:40:00',2.29),('15529','2013-05-08','12:45:00',2.29),('15529','2013-05-08','12:50:00',2.28),('15529','2013-05-08','12:55:00',2.33),('15529','2013-05-08','13:00:00',2.35),('15529','2013-05-08','13:05:00',2.32),('15529','2013-05-08','13:10:00',2.28),('15529','2013-05-08','13:15:00',2.19),('15529','2013-05-08','13:20:00',2.35),('15529','2013-05-08','13:25:00',2.36),('15529','2013-05-08','13:30:00',2.36),('15529','2013-05-08','13:35:00',2.38),('15529','2013-05-08','13:40:00',2.33),('15529','2013-05-08','13:45:00',2.41),('15529','2013-05-08','13:50:00',1.56),('15529','2013-05-08','14:00:00',1.17),('15529','2013-05-08','14:05:00',1.67),('15529','2013-05-08','14:10:00',2.1),('15529','2013-05-08','14:15:00',2.42),('15529','2013-05-08','14:20:00',1.21),('15529','2013-05-08','14:25:00',2.05),('15529','2013-05-08','14:30:00',2.23),('15529','2013-05-08','14:35:00',2.19),('15529','2013-05-08','14:40:00',2.16),('15529','2013-05-08','14:45:00',2.17),('15529','2013-05-08','14:50:00',2.15),('15529','2013-05-08','14:55:00',2.11),('15529','2013-05-08','15:00:00',2.07),('15529','2013-05-08','15:05:00',2.07),('15529','2013-05-08','15:10:00',2.04),('15529','2013-05-08','15:15:00',2.01),('15529','2013-05-08','15:20:00',1.95),('15529','2013-05-08','15:25:00',1.94),('15529','2013-05-08','15:30:00',1.92),('15529','2013-05-08','15:35:00',1.91),('15529','2013-05-08','15:40:00',1.87),('15529','2013-05-08','15:45:00',1.85),('15529','2013-05-08','15:50:00',1.81),('15529','2013-05-08','15:55:00',1.78),('15529','2013-05-08','16:00:00',1.76),('15529','2013-05-08','16:05:00',1.73),('15529','2013-05-08','16:10:00',1.67),('15529','2013-05-08','16:15:00',1.63),('15529','2013-05-08','16:20:00',1.59),('15529','2013-05-08','16:25:00',1.56),('15529','2013-05-08','16:30:00',1.53),('15529','2013-05-08','16:35:00',1.48),('15529','2013-05-08','16:40:00',1.44),('15529','2013-05-08','16:45:00',1.39),('15529','2013-05-08','16:50:00',1.34),('15529','2013-05-08','16:55:00',1.3),('15529','2013-05-08','17:00:00',1.25),('15529','2013-05-08','17:05:00',1.21),('15529','2013-05-08','17:10:00',1.15),('15529','2013-05-08','17:15:00',1.11),('15529','2013-05-08','17:20:00',1.07),('15529','2013-05-08','17:25:00',1.03),('15529','2013-05-07','08:40:00',1.03),('15529','2013-05-07','09:10:00',1.07),('15529','2013-05-07','09:15:00',1.44),('15529','2013-05-07','09:20:00',1.54),('15529','2013-05-07','09:25:00',1.68),('15529','2013-05-07','09:30:00',1.78),('15529','2013-05-07','09:35:00',1.47),('15529','2013-05-07','09:40:00',1.5),('15529','2013-05-07','09:45:00',1.53),('15529','2013-05-07','09:50:00',1.7),('15529','2013-05-07','09:55:00',1.93),('15529','2013-05-07','10:00:00',1.93),('15529','2013-05-07','10:05:00',1.84),('15529','2013-05-07','10:10:00',1.1),('15529','2013-05-07','10:40:00',1.44),('15529','2013-05-07','10:55:00',1.86),('15529','2013-05-07','11:10:00',1.09),('15529','2013-05-07','11:15:00',2.36),('15529','2013-05-07','11:20:00',2.28),('15529','2013-05-07','11:25:00',2.32),('15529','2013-05-07','11:30:00',2.05),('15529','2013-05-07','11:35:00',1.27),('15529','2013-05-07','11:40:00',1.61),('15529','2013-05-07','11:45:00',1.02),('15529','2013-05-07','12:10:00',2.63),('15529','2013-05-07','12:15:00',1.01),('15529','2013-05-07','13:20:00',1.02),('15529','2013-05-07','13:25:00',1.72),('15529','2013-05-07','13:30:00',2.86),('15529','2013-05-07','13:35:00',2.43),('15529','2013-05-07','13:40:00',1.39),('15529','2013-05-07','13:55:00',2.2),('15529','2013-05-07','14:00:00',2.01),('15529','2013-05-07','14:05:00',2.14),('15529','2013-05-07','14:10:00',2.18),('15529','2013-05-07','14:15:00',1.53),('15529','2013-05-07','14:20:00',1.51),('15529','2013-05-07','14:25:00',2.11),('15529','2013-05-07','14:30:00',2.36),('15529','2013-05-07','14:35:00',2.34),('15529','2013-05-07','14:40:00',1.85),('15529','2013-05-07','14:45:00',2.2),('15529','2013-05-07','14:50:00',2.19),('15529','2013-05-07','14:55:00',2.11),('15529','2013-05-07','15:00:00',2.1),('15529','2013-05-07','15:05:00',2.06),('15529','2013-05-07','15:10:00',2.04),('15529','2013-05-07','15:15:00',2.01),('15529','2013-05-07','15:20:00',1.98),('15529','2013-05-07','15:25:00',1.95),('15529','2013-05-07','15:30:00',1.94),('15529','2013-05-07','15:35:00',1.89),('15529','2013-05-07','15:40:00',1.85),('15529','2013-05-07','15:45:00',1.83),('15529','2013-05-07','15:50:00',1.82),('15529','2013-05-07','15:55:00',1.8),('15529','2013-05-07','16:00:00',1.78),('15529','2013-05-07','16:05:00',1.34),('15529','2013-05-07','16:10:00',1.71),('15529','2013-05-07','16:15:00',1.64),('15529','2013-05-07','16:25:00',1.41),('15529','2013-05-07','16:35:00',1.62),('15529','2013-05-07','16:40:00',1.6),('15529','2013-05-07','16:45:00',1.51),('15529','2013-05-07','16:50:00',1.42),('15529','2013-05-07','16:55:00',1.32),('15529','2013-05-07','17:00:00',1.23),('15529','2013-05-07','17:05:00',1.19),('15529','2013-05-07','17:10:00',1.2),('15529','2013-05-07','17:35:00',1.02),('15529','2013-05-06','08:35:00',1.01),('15529','2013-05-06','08:40:00',1.06),('15529','2013-05-06','08:45:00',1.1),('15529','2013-05-06','08:50:00',1.18),('15529','2013-05-06','08:55:00',1.02),('15529','2013-05-06','09:00:00',1.36),('15529','2013-05-06','09:05:00',1.47),('15529','2013-05-06','09:10:00',1.58),('15529','2013-05-06','09:35:00',1.69),('15529','2013-05-06','09:40:00',1.6),('15529','2013-05-06','10:45:00',1.02),('15529','2013-05-06','10:50:00',1.11),('15529','2013-05-06','11:50:00',1.05),('15529','2013-05-06','11:55:00',2.64),('15529','2013-05-06','12:00:00',2.62),('15529','2013-05-06','12:05:00',2.66),('15529','2013-05-06','12:10:00',1.69),('15529','2013-05-06','13:30:00',1.34),('15529','2013-05-06','13:35:00',1.93),('15529','2013-05-06','13:40:00',2.53),('15529','2013-05-06','13:45:00',2.55),('15529','2013-05-06','13:50:00',2.54),('15529','2013-05-06','13:55:00',2.36),('15529','2013-05-06','14:00:00',2.7),('15529','2013-05-06','14:05:00',1.42),('15529','2013-05-06','14:10:00',1.97),('15529','2013-05-06','14:15:00',1.34),('15529','2013-05-06','14:25:00',2.16),('15529','2013-05-06','14:30:00',2.52),('15529','2013-05-06','14:35:00',2.38),('15529','2013-05-06','14:40:00',2.22),('15529','2013-05-06','14:45:00',2.29),('15529','2013-05-06','14:50:00',2.24),('15529','2013-05-06','14:55:00',2.34),('15529','2013-05-06','15:00:00',2.19),('15529','2013-05-06','15:05:00',2.13),('15529','2013-05-06','15:10:00',2.15),('15529','2013-05-06','15:15:00',2.15),('15529','2013-05-06','15:20:00',1.97),('15529','2013-05-06','15:25:00',2.26),('15529','2013-05-06','15:30:00',2.26),('15529','2013-05-06','15:35:00',1.92),('15529','2013-05-06','15:40:00',1.7),('15529','2013-05-06','15:55:00',1.69),('15529','2013-05-06','16:00:00',1.12),('15529','2013-05-06','16:10:00',2.25),('15529','2013-05-06','16:15:00',1.28),('15529','2013-05-06','16:20:00',1.8),('15529','2013-05-06','16:25:00',1.31),('15529','2013-05-06','16:30:00',1.83),('15529','2013-05-06','16:35:00',1.8),('15529','2013-05-06','16:40:00',1.55),('15529','2013-05-06','16:45:00',1.51),('15529','2013-05-06','16:50:00',1.28),('15529','2013-05-06','16:55:00',1.25),('15529','2013-05-06','17:00:00',1.54),('15529','2013-05-05','09:15:00',1.1),('15529','2013-05-05','09:20:00',1.2),('15529','2013-05-05','09:25:00',1.21),('15529','2013-05-05','10:25:00',1.06),('15529','2013-05-05','11:20:00',1.02),('15529','2013-05-05','11:35:00',1.02),('15529','2013-05-05','11:40:00',1.87),('15529','2013-05-05','11:45:00',1.06),('15529','2013-05-05','11:55:00',1.09),('15529','2013-05-05','12:05:00',1.07),('15529','2013-05-05','12:10:00',1.06),('15529','2013-05-05','12:20:00',1.5),('15529','2013-05-05','12:25:00',2.52),('15529','2013-05-05','12:30:00',1.71),('15529','2013-05-05','12:35:00',1.54),('15529','2013-05-05','12:40:00',2.03),('15529','2013-05-05','12:45:00',1.58),('15529','2013-05-05','12:55:00',1.5),('15529','2013-05-05','13:00:00',2.82),('15529','2013-05-05','13:05:00',1.97),('15529','2013-05-05','13:10:00',2.51),('15529','2013-05-05','13:15:00',2.33),('15529','2013-05-05','13:20:00',2.19),('15529','2013-05-05','13:25:00',1.58),('15529','2013-05-05','13:30:00',2.29),('15529','2013-05-05','13:35:00',1.94),('15529','2013-05-05','13:40:00',2.45),('15529','2013-05-05','13:45:00',1.81),('15529','2013-05-05','13:50:00',1.89),('15529','2013-05-05','13:55:00',2.04),('15529','2013-05-05','14:00:00',2.52),('15529','2013-05-05','14:05:00',1.28),('15529','2013-05-05','14:10:00',1.7),('15529','2013-05-05','14:15:00',1.39),('15529','2013-05-05','14:20:00',1.73),('15529','2013-05-05','14:25:00',2.03),('15529','2013-05-05','14:30:00',1.44),('15529','2013-05-05','14:40:00',1.86),('15529','2013-05-05','14:45:00',1.39),('15529','2013-05-05','14:50:00',1.32),('15529','2013-05-05','14:55:00',1.13),('15529','2013-05-05','15:00:00',1.4),('15529','2013-05-05','15:05:00',1.14),('15529','2013-05-05','15:10:00',1.19),('15529','2013-05-05','15:15:00',1.14),('15529','2013-05-05','15:20:00',1.04),('15529','2013-05-05','15:30:00',1.7),('15529','2013-05-05','15:45:00',2.11),('15529','2013-05-05','15:50:00',1.66),('15529','2013-05-05','16:00:00',1.39),('15529','2013-05-05','16:15:00',1.17),('15529','2013-05-05','16:20:00',1.74),('15529','2013-05-05','16:30:00',1.11),('15529','2013-05-05','16:35:00',1.31),('15529','2013-05-05','16:45:00',1.31),('15529','2013-05-05','16:50:00',1.13),('15529','2013-05-05','17:10:00',1.15),('15529','2013-05-05','17:35:00',1.01),('15529','2013-05-05','17:40:00',1.05),('15529','2013-05-04','08:30:00',1.04),('15529','2013-05-04','09:25:00',1.16),('15529','2013-05-04','09:30:00',1.47),('15529','2013-05-04','09:35:00',1.37),('15529','2013-05-04','09:40:00',1.74),('15529','2013-05-04','09:45:00',1.75),('15529','2013-05-04','09:50:00',1.68),('15529','2013-05-04','09:55:00',1.88),('15529','2013-05-04','10:00:00',1.98),('15529','2013-05-04','10:05:00',2.01),('15529','2013-05-04','10:10:00',1.89),('15529','2013-05-04','10:15:00',1.48),('15529','2013-05-04','10:20:00',1.81),('15529','2013-05-04','10:25:00',1.7),('15529','2013-05-04','10:30:00',1.46),('15529','2013-05-04','10:35:00',1.02),('15529','2013-05-04','11:15:00',1),('15529','2013-05-04','11:20:00',1.48),('15529','2013-05-04','11:25:00',1.09),('15529','2013-05-04','11:30:00',1.52),('15529','2013-05-04','11:35:00',1.56),('15529','2013-05-04','11:40:00',1.42),('15529','2013-05-04','11:45:00',1.77),('15529','2013-05-04','11:50:00',2.68),('15529','2013-05-04','11:55:00',2.07),('15529','2013-05-04','12:00:00',1.51),('15529','2013-05-04','12:05:00',1.95),('15529','2013-05-04','12:10:00',2.1),('15529','2013-05-04','12:15:00',1.41),('15529','2013-05-04','12:20:00',1.92),('15529','2013-05-04','12:25:00',2.01),('15529','2013-05-04','12:30:00',1.89),('15529','2013-05-04','12:35:00',2.42),('15529','2013-05-04','12:40:00',2.23),('15529','2013-05-04','12:45:00',2.31),('15529','2013-05-04','12:50:00',2.48),('15529','2013-05-04','12:55:00',2.03),('15529','2013-05-04','13:00:00',2.48),('15529','2013-05-04','13:05:00',1.94),('15529','2013-05-04','13:25:00',2.15),('15529','2013-05-04','13:30:00',2.43),('15529','2013-05-04','13:35:00',2.05),('15529','2013-05-04','13:40:00',1.95),('15529','2013-05-04','13:45:00',2.34),('15529','2013-05-04','13:50:00',1.48),('15529','2013-05-04','13:55:00',1.38),('15529','2013-05-04','14:00:00',1.65),('15529','2013-05-04','14:05:00',2.23),('15529','2013-05-04','14:10:00',2.27),('15529','2013-05-04','14:15:00',2.31),('15529','2013-05-04','14:20:00',2.2),('15529','2013-05-04','14:25:00',2.13),('15529','2013-05-04','14:30:00',2.12),('15529','2013-05-04','14:35:00',2.08),('15529','2013-05-04','14:40:00',2.07),('15529','2013-05-04','14:45:00',2.06),('15529','2013-05-04','14:50:00',2.03),('15529','2013-05-04','14:55:00',2),('15529','2013-05-04','15:00:00',2.01),('15529','2013-05-04','15:05:00',1.97),('15529','2013-05-04','15:10:00',1.93),('15529','2013-05-04','15:15:00',1.93),('15529','2013-05-04','15:20:00',1.9),('15529','2013-05-04','15:25:00',1.88),('15529','2013-05-04','15:30:00',1.83),('15529','2013-05-04','15:35:00',1.82),('15529','2013-05-04','15:40:00',1.8),('15529','2013-05-04','15:45:00',1.77),('15529','2013-05-04','15:50:00',1.76),('15529','2013-05-04','15:55:00',1.72),('15529','2013-05-04','16:00:00',1.67),('15529','2013-05-04','16:05:00',1.64),('15529','2013-05-04','16:10:00',1.6),('15529','2013-05-04','16:15:00',1.58),('15529','2013-05-04','16:20:00',1.54),('15529','2013-05-04','16:25:00',1.49),('15529','2013-05-04','16:30:00',1.46),('15529','2013-05-04','16:35:00',1.42),('15529','2013-05-04','16:40:00',1.38),('15529','2013-05-04','16:45:00',1.33),('15529','2013-05-04','16:50:00',1.29),('15529','2013-05-04','16:55:00',1.25),('15529','2013-05-04','17:00:00',1.2),('15529','2013-05-04','17:05:00',1.15),('15529','2013-05-04','17:10:00',1.11),('15529','2013-05-04','17:15:00',1.06),('15529','2013-05-04','17:20:00',1.01),('15529','2013-05-03','08:50:00',1.03),('15529','2013-05-03','08:55:00',1.08),('15529','2013-05-03','09:00:00',1.12),('15529','2013-05-03','09:05:00',1.17),('15529','2013-05-03','09:10:00',1.2),('15529','2013-05-03','09:15:00',1.24),('15529','2013-05-03','09:20:00',1.28),('15529','2013-05-03','09:25:00',1.32),('15529','2013-05-03','09:30:00',1.36),('15529','2013-05-03','09:35:00',1.4),('15529','2013-05-03','09:40:00',1.46),('15529','2013-05-03','09:45:00',1.5),('15529','2013-05-03','09:50:00',1.55),('15529','2013-05-03','09:55:00',1.59),('15529','2013-05-03','10:00:00',1.63),('15529','2013-05-03','10:05:00',1.64),('15529','2013-05-03','10:10:00',1.7),('15529','2013-05-03','10:15:00',1.71),('15529','2013-05-03','10:20:00',1.76),('15529','2013-05-03','10:25:00',1.78),('15529','2013-05-03','10:30:00',1.82),('15529','2013-05-03','10:35:00',1.82),('15529','2013-05-03','10:40:00',1.8),('15529','2013-05-03','10:45:00',1.8),('15529','2013-05-03','10:50:00',1.81),('15529','2013-05-03','10:55:00',1.86),('15529','2013-05-03','11:00:00',1.85),('15529','2013-05-03','11:05:00',1.84),('15529','2013-05-03','11:10:00',1.74),('15529','2013-05-03','11:15:00',1.7),('15529','2013-05-03','11:20:00',1.85),('15529','2013-05-03','11:25:00',1.87),('15529','2013-05-03','11:30:00',1.81),('15529','2013-05-03','11:35:00',1.81),('15529','2013-05-03','11:40:00',1.8),('15529','2013-05-03','11:45:00',1.84),('15529','2013-05-03','11:50:00',1.85),('15529','2013-05-03','11:55:00',1.91),('15529','2013-05-03','12:00:00',1.88),('15529','2013-05-03','12:05:00',1.91),('15529','2013-05-03','12:10:00',1.98),('15529','2013-05-03','12:15:00',2.03),('15529','2013-05-03','12:20:00',2.06),('15529','2013-05-03','12:25:00',2.05),('15529','2013-05-03','12:30:00',2.09),('15529','2013-05-03','12:35:00',2.12),('15529','2013-05-03','12:40:00',2.12),('15529','2013-05-03','12:45:00',2.12),('15529','2013-05-03','12:50:00',2.09),('15529','2013-05-03','12:55:00',2.07),('15529','2013-05-03','13:00:00',1.99),('15529','2013-05-03','13:05:00',1.85),('15529','2013-05-03','13:10:00',1.99),('15529','2013-05-03','13:15:00',2.21),('15529','2013-05-03','13:20:00',2.19),('15529','2013-05-03','13:25:00',2.08),('15529','2013-05-03','13:30:00',2.07),('15529','2013-05-03','13:35:00',2.05),('15529','2013-05-03','13:40:00',2.06),('15529','2013-05-03','13:45:00',1.98),('15529','2013-05-03','13:50:00',1.88),('15529','2013-05-03','13:55:00',1.98),('15529','2013-05-03','14:00:00',1.81),('15529','2013-05-03','14:05:00',1.06),('15529','2013-05-03','14:10:00',1.91),('15529','2013-05-03','14:15:00',2.05),('15529','2013-05-03','14:20:00',1.91),('15529','2013-05-03','14:25:00',1.82),('15529','2013-05-03','14:30:00',1.84),('15529','2013-05-03','14:35:00',1.74),('15529','2013-05-03','14:40:00',1.85),('15529','2013-05-03','14:45:00',1.78),('15529','2013-05-03','14:50:00',1.75),('15529','2013-05-03','14:55:00',1.81),('15529','2013-05-03','15:00:00',1.8),('15529','2013-05-03','15:05:00',1.81),('15529','2013-05-03','15:10:00',1.73),('15529','2013-05-03','15:15:00',1.79),('15529','2013-05-03','15:20:00',1.78),('15529','2013-05-03','15:25:00',1.79),('15529','2013-05-03','15:30:00',1.8),('15529','2013-05-03','15:35:00',1.67),('15529','2013-05-03','15:40:00',1.77),('15529','2013-05-03','15:45:00',1.71),('15529','2013-05-03','15:50:00',1.68),('15529','2013-05-03','15:55:00',1.64),('15529','2013-05-03','16:00:00',1.61),('15529','2013-05-03','16:05:00',1.57),('15529','2013-05-03','16:10:00',1.52),('15529','2013-05-03','16:15:00',1.5),('15529','2013-05-03','16:20:00',1.45),('15529','2013-05-03','16:25:00',1.43),('15529','2013-05-03','16:30:00',1.39),('15529','2013-05-03','16:35:00',1.36),('15529','2013-05-03','16:40:00',1.31),('15529','2013-05-03','16:45:00',1.27),('15529','2013-05-03','16:50:00',1.23),('15529','2013-05-03','16:55:00',1.18),('15529','2013-05-03','17:00:00',1.14),('15529','2013-05-03','17:05:00',1.1),('15529','2013-05-02','08:50:00',1.04),('15529','2013-05-02','08:55:00',1.1),('15529','2013-05-02','09:00:00',1.17),('15529','2013-05-02','09:05:00',1.19),('15529','2013-05-02','09:10:00',1.24),('15529','2013-05-02','09:15:00',1.29),('15529','2013-05-02','09:20:00',1.34),('15529','2013-05-02','09:25:00',1.39),('15529','2013-05-02','09:30:00',1.42),('15529','2013-05-02','09:35:00',1.47),('15529','2013-05-02','09:40:00',1.51),('15529','2013-05-02','09:45:00',1.54),('15529','2013-05-02','09:50:00',1.58),('15529','2013-05-02','09:55:00',1.61),('15529','2013-05-02','10:00:00',1.65),('15529','2013-05-02','10:05:00',1.69),('15529','2013-05-02','10:10:00',1.71),('15529','2013-05-02','10:15:00',1.76),('15529','2013-05-02','10:20:00',1.79),('15529','2013-05-02','10:25:00',1.79),('15529','2013-05-02','10:30:00',1.84),('15529','2013-05-02','10:35:00',1.87),('15529','2013-05-02','10:40:00',1.89),('15529','2013-05-02','10:45:00',1.93),('15529','2013-05-02','10:50:00',1.97),('15529','2013-05-02','10:55:00',1.97),('15529','2013-05-02','11:00:00',2.02),('15529','2013-05-02','11:05:00',2.04),('15529','2013-05-02','11:10:00',2.04),('15529','2013-05-02','11:15:00',2.06),('15529','2013-05-02','11:20:00',2.09),('15529','2013-05-02','11:25:00',2.09),('15529','2013-05-02','11:30:00',2.13),('15529','2013-05-02','11:35:00',2.15),('15529','2013-05-02','11:40:00',2.11),('15529','2013-05-02','11:45:00',2.13),('15529','2013-05-02','11:50:00',2.19),('15529','2013-05-02','11:55:00',2.18),('15529','2013-05-02','12:00:00',2.18),('15529','2013-05-02','12:05:00',2.22),('15529','2013-05-02','12:10:00',2.2),('15529','2013-05-02','12:15:00',2.22),('15529','2013-05-02','12:20:00',2.2),('15529','2013-05-02','12:25:00',2.22),('15529','2013-05-02','12:30:00',2.2),('15529','2013-05-02','12:35:00',2.21),('15529','2013-05-02','12:40:00',2.24),('15529','2013-05-02','12:45:00',2.17),('15529','2013-05-02','12:50:00',2.24),('15529','2013-05-02','12:55:00',2.28),('15529','2013-05-02','13:00:00',2.29),('15529','2013-05-02','13:05:00',2.32),('15529','2013-05-02','13:10:00',2.3),('15529','2013-05-02','13:15:00',2.33),('15529','2013-05-02','13:20:00',2.29),('15529','2013-05-02','13:25:00',2.29),('15529','2013-05-02','13:30:00',2.27),('15529','2013-05-02','13:35:00',2.17),('15529','2013-05-02','13:40:00',2.13),('15529','2013-05-02','13:45:00',2.19),('15529','2013-05-02','13:50:00',2.19),('15529','2013-05-02','13:55:00',2.18),('15529','2013-05-02','14:00:00',2.09),('15529','2013-05-02','14:05:00',2.07),('15529','2013-05-02','14:10:00',2.05),('15529','2013-05-02','14:15:00',2.13),('15529','2013-05-02','14:20:00',2.1),('15529','2013-05-02','14:25:00',2.05),('15529','2013-05-02','14:30:00',2.04),('15529','2013-05-02','14:35:00',2.03),('15529','2013-05-02','14:40:00',2.02),('15529','2013-05-02','14:45:00',1.99),('15529','2013-05-02','14:50:00',2),('15529','2013-05-02','14:55:00',1.93),('15529','2013-05-02','15:00:00',1.93),('15529','2013-05-02','15:05:00',1.93),('15529','2013-05-02','15:10:00',1.92),('15529','2013-05-02','15:15:00',1.92),('15529','2013-05-02','15:20:00',1.92),('15529','2013-05-02','15:25:00',1.88),('15529','2013-05-02','15:30:00',1.85),('15529','2013-05-02','15:35:00',1.82),('15529','2013-05-02','15:40:00',1.79),('15529','2013-05-02','15:45:00',1.76),('15529','2013-05-02','15:50:00',1.7),('15529','2013-05-02','15:55:00',1.7),('15529','2013-05-02','16:00:00',1.67),('15529','2013-05-02','16:05:00',1.64),('15529','2013-05-02','16:10:00',1.6),('15529','2013-05-02','16:15:00',1.54),('15529','2013-05-02','16:20:00',1.47),('15529','2013-05-02','16:25:00',1.47),('15529','2013-05-02','16:30:00',1.46),('15529','2013-05-02','16:35:00',1.41),('15529','2013-05-02','16:40:00',1.37),('15529','2013-05-02','16:45:00',1.32),('15529','2013-05-02','16:50:00',1.27),('15529','2013-05-02','16:55:00',1.23),('15529','2013-05-02','17:00:00',1.18),('15529','2013-05-02','17:05:00',1.13),('15529','2013-05-02','17:10:00',1.08),('15529','2013-05-02','17:15:00',1.03),('15529','2013-05-01','09:25:00',1.04),('15529','2013-05-01','09:30:00',1.1),('15529','2013-05-01','09:40:00',1.07),('15529','2013-05-01','09:45:00',1.22),('15529','2013-05-01','10:30:00',1.37),('15529','2013-05-01','10:35:00',1.93),('15529','2013-05-01','10:40:00',1.67),('15529','2013-05-01','10:45:00',1.64),('15529','2013-05-01','10:50:00',1.96),('15529','2013-05-01','10:55:00',1.84),('15529','2013-05-01','11:00:00',1.6),('15529','2013-05-01','11:05:00',1.82),('15529','2013-05-01','11:10:00',1.91),('15529','2013-05-01','11:15:00',1.24),('15529','2013-05-01','11:20:00',1.77),('15529','2013-05-01','11:25:00',1.78),('15529','2013-05-01','11:30:00',1.92),('15529','2013-05-01','11:35:00',2.11),('15529','2013-05-01','11:40:00',2.13),('15529','2013-05-01','11:45:00',2.15),('15529','2013-05-01','11:50:00',2.17),('15529','2013-05-01','11:55:00',2.17),('15529','2013-05-01','12:00:00',2.21),('15529','2013-05-01','12:05:00',2.15),('15529','2013-05-01','12:10:00',2.09),('15529','2013-05-01','12:15:00',2.11),('15529','2013-05-01','12:20:00',2.13),('15529','2013-05-01','12:25:00',2.13),('15529','2013-05-01','12:30:00',2.12),('15529','2013-05-01','12:35:00',2.1),('15529','2013-05-01','12:40:00',2.22),('15529','2013-05-01','12:45:00',2.27),('15529','2013-05-01','12:50:00',2.27),('15529','2013-05-01','12:55:00',2.26),('15529','2013-05-01','13:00:00',2.25),('15529','2013-05-01','13:05:00',2.26),('15529','2013-05-01','13:10:00',2.29),('15529','2013-05-01','13:15:00',2.32),('15529','2013-05-01','13:20:00',2.31),('15529','2013-05-01','13:25:00',2.27),('15529','2013-05-01','13:30:00',2.22),('15529','2013-05-01','13:35:00',2.26),('15529','2013-05-01','13:40:00',2.29),('15529','2013-05-01','13:45:00',2.3),('15529','2013-05-01','13:50:00',2.26),('15529','2013-05-01','13:55:00',2.23),('15529','2013-05-01','14:00:00',2.23),('15529','2013-05-01','14:05:00',2.22),('15529','2013-05-01','14:10:00',2.08),('15529','2013-05-01','14:15:00',2.12),('15529','2013-05-01','14:20:00',2.13),('15529','2013-05-01','14:25:00',2.08),('15529','2013-05-01','14:30:00',2.09),('15529','2013-05-01','14:35:00',2.11),('15529','2013-05-01','14:40:00',2.04),('15529','2013-05-01','14:45:00',2.06),('15529','2013-05-01','14:50:00',2.01),('15529','2013-05-01','14:55:00',1.99),('15529','2013-05-01','15:00:00',2.02),('15529','2013-05-01','15:05:00',1.97),('15529','2013-05-01','15:10:00',1.94),('15529','2013-05-01','15:15:00',1.91),('15529','2013-05-01','15:20:00',1.89),('15529','2013-05-01','15:25:00',1.89),('15529','2013-05-01','15:30:00',1.86),('15529','2013-05-01','15:35:00',1.83),('15529','2013-05-01','15:40:00',1.8),('15529','2013-05-01','15:45:00',1.76),('15529','2013-05-01','15:50:00',1.75),('15529','2013-05-01','15:55:00',1.7),('15529','2013-05-01','16:00:00',1.66),('15529','2013-05-01','16:05:00',1.63),('15529','2013-05-01','16:10:00',1.59),('15529','2013-05-01','16:15:00',1.55),('15529','2013-05-01','16:20:00',1.52),('15529','2013-05-01','16:25:00',1.48),('15529','2013-05-01','16:30:00',1.43),('15529','2013-05-01','16:35:00',1.4),('15529','2013-05-01','16:40:00',1.36),('15529','2013-05-01','16:45:00',1.32),('15529','2013-05-01','16:50:00',1.28),('15529','2013-05-01','16:55:00',1.23),('15529','2013-05-01','17:00:00',1.2),('15529','2013-05-01','17:05:00',1.15),('15529','2013-05-01','17:10:00',1.11),('15529','2013-05-01','17:15:00',1.06),('15529','2013-05-01','17:20:00',1.01),('15529','2014-03-29','09:25:00',1.09),('15529','2014-03-29','09:30:00',1.12),('15529','2014-03-29','09:35:00',1.2),('15529','2014-03-29','09:40:00',1.28),('15529','2014-03-29','09:45:00',1.3),('15529','2014-03-29','09:50:00',1.27),('15529','2014-03-29','09:55:00',1.32),('15529','2014-03-29','10:00:00',1.46),('15529','2014-03-29','10:05:00',1.45),('15529','2014-03-29','10:10:00',1.4),('15529','2014-03-29','10:15:00',1.58),('15529','2014-03-29','10:20:00',1.64),('15529','2014-03-29','10:25:00',1.65),('15529','2014-03-29','10:30:00',1.67),('15529','2014-03-29','10:35:00',1.72),('15529','2014-03-29','10:40:00',1.72),('15529','2014-03-29','10:45:00',1.71),('15529','2014-03-29','10:50:00',1.73),('15529','2014-03-29','10:55:00',1.72),('15529','2014-03-29','11:00:00',1.75),('15529','2014-03-29','11:05:00',1.72),('15529','2014-03-29','11:10:00',1.71),('15529','2014-03-29','11:15:00',1.69),('15529','2014-03-29','11:20:00',1.77),('15529','2014-03-29','11:25:00',1.88),('15529','2014-03-29','11:30:00',1.91),('15529','2014-03-29','11:35:00',1.99),('15529','2014-03-29','11:40:00',2.05),('15529','2014-03-29','11:45:00',2.08),('15529','2014-03-29','11:50:00',2.08),('15529','2014-03-29','11:55:00',2.16),('15529','2014-03-29','12:00:00',2.19),('15529','2014-03-29','12:05:00',2.21),('15529','2014-03-29','12:10:00',2.31),('15529','2014-03-29','12:15:00',2.17),('15529','2014-03-29','12:20:00',2.15),('15529','2014-03-29','12:25:00',2.28),('15529','2014-03-29','12:30:00',2.14),('15529','2014-03-29','12:35:00',2.15),('15529','2014-03-29','12:40:00',2.19),('15529','2014-03-29','12:45:00',2.14),('15529','2014-03-29','12:50:00',2.24),('15529','2014-03-29','12:55:00',2.25),('15529','2014-03-29','13:00:00',2.33),('15529','2014-03-29','13:05:00',2.32),('15529','2014-03-29','13:10:00',2.32),('15529','2014-03-29','13:15:00',2.33),('15529','2014-03-29','13:20:00',2.32),('15529','2014-03-29','13:25:00',2.35),('15529','2014-03-29','13:30:00',2.36),('15529','2014-03-29','13:35:00',2.35),('15529','2014-03-29','13:40:00',2.39),('15529','2014-03-29','13:45:00',2.3),('15529','2014-03-29','13:50:00',2.27),('15529','2014-03-29','13:55:00',2.27),('15529','2014-03-29','14:00:00',2.19),('15529','2014-03-29','14:05:00',2.09),('15529','2014-03-29','14:10:00',1.94),('15529','2014-03-29','14:15:00',1.86),('15529','2014-03-29','14:20:00',1.67),('15529','2014-03-29','14:25:00',1.53),('15529','2014-03-29','14:30:00',1.42),('15529','2014-03-29','14:35:00',1.42),('15529','2014-03-29','14:40:00',1.27),('15529','2014-03-29','14:50:00',1.35),('15529','2014-03-29','14:55:00',1.75),('15529','2014-03-29','15:00:00',1.87),('15529','2014-03-29','15:05:00',1.95),('15529','2014-03-29','15:10:00',1.9),('15529','2014-03-29','15:15:00',1.85),('15529','2014-03-29','15:20:00',1.83),('15529','2014-03-29','15:25:00',1.74),('15529','2014-03-29','15:30:00',1.79),('15529','2014-03-29','15:35:00',1.82),('15529','2014-03-29','15:40:00',1.82),('15529','2014-03-29','15:45:00',1.81),('15529','2014-03-29','15:50:00',1.59),('15529','2014-03-29','15:55:00',1.32),('15529','2014-03-29','16:00:00',1.36),('15529','2014-03-29','16:05:00',1.28),('15529','2014-03-29','16:10:00',1.28),('15529','2014-03-29','16:15:00',1.28),('15529','2014-03-29','16:20:00',1.42),('15529','2014-03-29','16:25:00',1.41),('15529','2014-03-29','16:30:00',1.35),('15529','2014-03-29','16:35:00',1.42),('15529','2014-03-29','16:40:00',1.25),('15529','2014-03-29','16:45:00',1.19),('15529','2014-03-29','16:50:00',1.16),('15529','2014-03-29','16:55:00',1.18),('15529','2014-03-29','17:00:00',1.17),('15529','2014-03-29','17:05:00',1.2),('15529','2014-03-29','17:10:00',1.19),('15529','2014-03-29','17:15:00',1.14),('15529','2014-03-29','17:20:00',1.07),('15529','2013-04-30','08:55:00',1.04),('15529','2013-04-30','09:00:00',1.08),('15529','2013-04-30','09:05:00',1.12),('15529','2013-04-30','09:10:00',1.15),('15529','2013-04-30','09:15:00',1.18),('15529','2013-04-30','09:20:00',1.22),('15529','2013-04-30','09:25:00',1.24),('15529','2013-04-30','09:30:00',1.26),('15529','2013-04-30','09:35:00',1.32),('15529','2013-04-30','09:40:00',1.35),('15529','2013-04-30','09:45:00',1.4),('15529','2013-04-30','09:50:00',1.42),('15529','2013-04-30','09:55:00',1.46),('15529','2013-04-30','10:00:00',1.47),('15529','2013-04-30','10:05:00',1.52),('15529','2013-04-30','10:10:00',1.6),('15529','2013-04-30','10:15:00',1.61),('15529','2013-04-30','10:20:00',1.64),('15529','2013-04-30','10:25:00',1.68),('15529','2013-04-30','10:30:00',1.72),('15529','2013-04-30','10:35:00',1.78),('15529','2013-04-30','10:40:00',1.81),('15529','2013-04-30','10:45:00',1.85),('15529','2013-04-30','10:50:00',1.86),('15529','2013-04-30','10:55:00',1.89),('15529','2013-04-30','11:00:00',1.89),('15529','2013-04-30','11:05:00',1.92),('15529','2013-04-30','11:10:00',1.94),('15529','2013-04-30','11:15:00',1.83),('15529','2013-04-30','11:20:00',2),('15529','2013-04-30','11:25:00',1.82),('15529','2013-04-30','11:30:00',1.89),('15529','2013-04-30','11:35:00',1.63),('15529','2013-04-30','11:40:00',1.16),('15529','2013-04-30','11:45:00',1.27),('15529','2013-04-30','11:50:00',2.09),('15529','2013-04-30','11:55:00',2.11),('15529','2013-04-30','12:00:00',2.07),('15529','2013-04-30','12:05:00',2.07),('15529','2013-04-30','12:10:00',2.07),('15529','2013-04-30','12:15:00',2.06),('15529','2013-04-30','12:20:00',2.09),('15529','2013-04-30','12:25:00',2.11),('15529','2013-04-30','12:30:00',2.1),('15529','2013-04-30','12:35:00',2.16),('15529','2013-04-30','12:40:00',2.15),('15529','2013-04-30','12:45:00',1.82),('15529','2013-04-30','13:05:00',1.44),('15529','2013-04-30','13:10:00',1.84),('15529','2013-04-30','13:15:00',2.22),('15529','2013-04-30','13:20:00',2.39),('15529','2013-04-30','13:25:00',2.18),('15529','2013-04-30','13:30:00',1.97),('15529','2013-04-30','13:35:00',2.08),('15529','2013-04-30','13:40:00',2.31),('15529','2013-04-30','13:45:00',2.2),('15529','2013-04-30','13:50:00',2.12),('15529','2013-04-30','13:55:00',2.1),('15529','2013-04-30','14:00:00',2.13),('15529','2013-04-30','14:05:00',2.07),('15529','2013-04-30','14:10:00',2.07),('15529','2013-04-30','14:15:00',1.81),('15529','2013-04-30','14:20:00',2.18),('15529','2013-04-30','14:25:00',2.13),('15529','2013-04-30','14:30:00',2.14),('15529','2013-04-30','14:35:00',1.98),('15529','2013-04-30','14:40:00',2.02),('15529','2013-04-30','14:45:00',1.79),('15529','2013-04-30','14:50:00',1.8),('15529','2013-04-30','14:55:00',1.44),('15529','2013-04-30','15:00:00',1.61),('15529','2013-04-30','15:05:00',1.9),('15529','2013-04-30','15:10:00',1.85),('15529','2013-04-30','15:15:00',1.78),('15529','2013-04-30','15:20:00',1.84),('15529','2013-04-30','15:25:00',1.6),('15529','2013-04-30','15:30:00',1.25),('15529','2013-04-30','15:35:00',1.19),('15529','2013-04-30','15:40:00',1.19),('15529','2013-04-30','15:45:00',1.12),('15529','2013-04-29','08:55:00',1.14),('15529','2013-04-29','09:10:00',1.06),('15529','2013-04-29','09:15:00',1.29),('15529','2013-04-29','09:20:00',1.3),('15529','2013-04-29','09:25:00',1.29),('15529','2013-04-29','09:30:00',1.4),('15529','2013-04-29','09:35:00',1.14),('15529','2013-04-29','09:45:00',1.09),('15529','2013-04-29','09:50:00',1.43),('15529','2013-04-29','09:55:00',1.63),('15529','2013-04-29','10:00:00',1.74),('15529','2013-04-29','10:05:00',1.35),('15529','2013-04-29','10:10:00',1.27),('15529','2013-04-29','10:15:00',1.02),('15529','2013-04-29','10:20:00',1.02),('15529','2013-04-29','10:25:00',1.46),('15529','2013-04-29','10:30:00',1.05),('15529','2013-04-29','11:05:00',1.02),('15529','2013-04-29','11:15:00',1.14),('15529','2013-04-29','11:20:00',1.16),('15529','2013-04-29','11:25:00',1.1),('15529','2013-04-29','11:30:00',1.13),('15529','2013-04-29','11:35:00',1.2),('15529','2013-04-29','12:35:00',1.84),('15529','2013-04-29','12:40:00',2.39),('15529','2013-04-29','12:45:00',2.28),('15529','2013-04-29','12:50:00',2.25),('15529','2013-04-29','13:10:00',1.23),('15529','2013-04-29','13:15:00',2.04),('15529','2013-04-29','13:20:00',2.03),('15529','2013-04-29','13:25:00',2.02),('15529','2013-04-29','13:30:00',2.04),('15529','2013-04-29','13:35:00',2.03),('15529','2013-04-29','13:40:00',2.03),('15529','2013-04-29','13:45:00',2.01),('15529','2013-04-29','13:50:00',2),('15529','2013-04-29','13:55:00',1.98),('15529','2013-04-29','14:00:00',1.95),('15529','2013-04-29','14:05:00',1.94),('15529','2013-04-29','14:10:00',1.93),('15529','2013-04-29','14:15:00',1.92),('15529','2013-04-29','14:20:00',1.89),('15529','2013-04-29','14:25:00',1.87),('15529','2013-04-29','14:30:00',1.79),('15529','2013-04-29','14:35:00',1.65),('15529','2013-04-29','14:40:00',1.09),('15529','2013-04-29','15:05:00',1.15),('15529','2013-04-29','15:10:00',1.78),('15529','2013-04-29','15:15:00',1.76),('15529','2013-04-29','15:20:00',1.75),('15529','2013-04-29','15:25:00',1.69),('15529','2013-04-29','15:30:00',1.66),('15529','2013-04-29','15:35:00',1.65),('15529','2013-04-29','15:40:00',1.63),('15529','2013-04-29','15:45:00',1.59),('15529','2013-04-29','15:50:00',1.56),('15529','2013-04-29','15:55:00',1.54),('15529','2013-04-29','16:00:00',1.49),('15529','2013-04-29','16:05:00',1.46),('15529','2013-04-29','16:10:00',1.42),('15529','2013-04-29','16:15:00',1.38),('15529','2013-04-29','16:20:00',1.34),('15529','2013-04-29','16:25:00',1.32),('15529','2013-04-29','16:30:00',1.27),('15529','2013-04-29','16:35:00',1.15),('15529','2013-04-29','16:40:00',1.07),('15529','2013-04-29','16:55:00',1.03),('15529','2013-04-29','17:00:00',1.02),('15529','2013-04-28','08:35:00',1.02),('15529','2013-04-28','08:45:00',1.02),('15529','2013-04-28','08:55:00',1.02),('15529','2013-04-28','09:05:00',1.21),('15529','2013-04-28','09:10:00',1.29),('15529','2013-04-28','09:15:00',1.32),('15529','2013-04-28','09:20:00',1.23),('15529','2013-04-28','09:25:00',1.27),('15529','2013-04-28','09:30:00',1.29),('15529','2013-04-28','09:35:00',1.33),('15529','2013-04-28','09:40:00',1.37),('15529','2013-04-28','09:45:00',1.39),('15529','2013-04-28','09:50:00',1.42),('15529','2013-04-28','09:55:00',1.37),('15529','2013-04-28','10:00:00',1.48),('15529','2013-04-28','10:05:00',1.44),('15529','2013-04-28','10:10:00',1.34),('15529','2013-04-28','10:15:00',1.13),('15529','2013-04-28','10:20:00',1.49),('15529','2013-04-28','10:25:00',1.54),('15529','2013-04-28','10:30:00',1.71),('15529','2013-04-28','10:35:00',1.73),('15529','2013-04-28','10:40:00',1.74),('15529','2013-04-28','10:45:00',1.67),('15529','2013-04-28','10:50:00',1.66),('15529','2013-04-28','10:55:00',1.64),('15529','2013-04-28','11:00:00',1.75),('15529','2013-04-28','11:05:00',1.62),('15529','2013-04-28','11:10:00',1.5),('15529','2013-04-28','11:15:00',1.74),('15529','2013-04-28','11:20:00',1.98),('15529','2013-04-28','11:25:00',1.85),('15529','2013-04-28','11:30:00',1.91),('15529','2013-04-28','11:35:00',2),('15529','2013-04-28','11:40:00',2.07),('15529','2013-04-28','11:45:00',2),('15529','2013-04-28','11:50:00',2.11),('15529','2013-04-28','11:55:00',2.12),('15529','2013-04-28','12:00:00',2.16),('15529','2013-04-28','12:05:00',2.05),('15529','2013-04-28','12:10:00',2.09),('15529','2013-04-28','12:15:00',2.15),('15529','2013-04-28','12:20:00',2.15),('15529','2013-04-28','12:25:00',2.19),('15529','2013-04-28','12:30:00',2.18),('15529','2013-04-28','12:35:00',2.17),('15529','2013-04-28','12:40:00',2.14),('15529','2013-04-28','12:45:00',2.14),('15529','2013-04-28','12:50:00',2.14),('15529','2013-04-28','12:55:00',2.14),('15529','2013-04-28','13:00:00',2.15),('15529','2013-04-28','13:05:00',2.18),('15529','2013-04-28','13:10:00',2.06),('15529','2013-04-28','13:15:00',2),('15529','2013-04-28','13:20:00',2.17),('15529','2013-04-28','13:25:00',2.27),('15529','2013-04-28','13:30:00',2.15),('15529','2013-04-28','13:35:00',2.15),('15529','2013-04-28','13:40:00',2.07),('15529','2013-04-28','13:45:00',2.12),('15529','2013-04-28','13:50:00',1.99),('15529','2013-04-28','13:55:00',2.16),('15529','2013-04-28','14:00:00',2.04),('15529','2013-04-28','14:05:00',2.01),('15529','2013-04-28','14:10:00',2.11),('15529','2013-04-28','14:15:00',2.18),('15529','2013-04-28','14:20:00',2.12),('15529','2013-04-28','14:25:00',1.95),('15529','2013-04-28','14:30:00',1.94),('15529','2013-04-28','14:35:00',1.95),('15529','2013-04-28','14:40:00',1.84),('15529','2013-04-28','14:45:00',1.94),('15529','2013-04-28','14:50:00',2.01),('15529','2013-04-28','14:55:00',1.9),('15529','2013-04-28','15:00:00',1.81),('15529','2013-04-28','15:05:00',1.7),('15529','2013-04-28','15:10:00',1.64),('15529','2013-04-28','15:15:00',1.76),('15529','2013-04-28','15:20:00',1.82),('15529','2013-04-28','15:25:00',1.81),('15529','2013-04-28','15:30:00',1.67),('15529','2013-04-28','15:35:00',1.51),('15529','2013-04-28','15:40:00',1.44),('15529','2013-04-28','15:45:00',1.4),('15529','2013-04-28','15:50:00',1.46),('15529','2013-04-28','16:45:00',1.12),('15529','2013-04-28','16:50:00',1.44),('15529','2013-04-28','16:55:00',1.42),('15529','2013-04-28','17:00:00',1.32),('15529','2013-04-28','17:05:00',1.19),('15529','2013-04-28','17:10:00',1.15),('15529','2013-04-27','08:45:00',1.02),('15529','2013-04-27','08:50:00',1.07),('15529','2013-04-27','08:55:00',1.12),('15529','2013-04-27','09:00:00',1.16),('15529','2013-04-27','09:05:00',1.2),('15529','2013-04-27','09:10:00',1.25),('15529','2013-04-27','09:15:00',1.3),('15529','2013-04-27','09:20:00',1.34),('15529','2013-04-27','09:25:00',1.39),('15529','2013-04-27','09:30:00',1.43),('15529','2013-04-27','09:35:00',1.47),('15529','2013-04-27','09:40:00',1.51),('15529','2013-04-27','09:45:00',1.55),('15529','2013-04-27','09:50:00',1.59),('15529','2013-04-27','09:55:00',1.62),('15529','2013-04-27','10:00:00',1.65),('15529','2013-04-27','10:05:00',1.67),('15529','2013-04-27','10:10:00',1.68),('15529','2013-04-27','10:15:00',1.76),('15529','2013-04-27','10:20:00',1.77),('15529','2013-04-27','10:25:00',1.8),('15529','2013-04-27','10:30:00',1.71),('15529','2013-04-27','10:35:00',1.84),('15529','2013-04-27','10:40:00',1.7),('15529','2013-04-27','10:45:00',1.9),('15529','2013-04-27','10:50:00',1.91),('15529','2013-04-27','10:55:00',1.96),('15529','2013-04-27','11:00:00',1.98),('15529','2013-04-27','11:05:00',2),('15529','2013-04-27','11:10:00',1.97),('15529','2013-04-27','11:15:00',2.05),('15529','2013-04-27','11:20:00',2.04),('15529','2013-04-27','11:25:00',2.1),('15529','2013-04-27','11:30:00',2.12),('15529','2013-04-27','11:35:00',2.06),('15529','2013-04-27','11:40:00',2.09),('15529','2013-04-27','11:45:00',2.01),('15529','2013-04-27','11:50:00',2.07),('15529','2013-04-27','11:55:00',2.08),('15529','2013-04-27','12:00:00',1.78),('15529','2013-04-27','12:05:00',1.83),('15529','2013-04-27','12:10:00',2.02),('15529','2013-04-27','12:15:00',1.94),('15529','2013-04-27','12:20:00',2.04),('15529','2013-04-27','12:25:00',1.83),('15529','2013-04-27','12:30:00',1.87),('15529','2013-04-27','12:35:00',1.81),('15529','2013-04-27','12:40:00',1.65),('15529','2013-04-27','12:45:00',2.14),('15529','2013-04-27','12:50:00',2.14),('15529','2013-04-27','12:55:00',2.1),('15529','2013-04-27','13:00:00',2.04),('15529','2013-04-27','13:05:00',1.45),('15529','2013-04-27','13:10:00',2.16),('15529','2013-04-27','13:15:00',1.24),('15529','2013-04-27','13:20:00',2.21),('15529','2013-04-27','13:25:00',2.03),('15529','2013-04-27','13:30:00',2.21),('15529','2013-04-27','13:35:00',2.35),('15529','2013-04-27','13:40:00',2.34),('15529','2013-04-27','13:45:00',2.36),('15529','2013-04-27','13:50:00',2),('15529','2013-04-27','13:55:00',2.11),('15529','2013-04-27','14:00:00',1.93),('15529','2013-04-27','14:05:00',2.22),('15529','2013-04-27','14:10:00',2.16),('15529','2013-04-27','14:15:00',2.19),('15529','2013-04-27','14:20:00',2.15),('15529','2013-04-27','14:25:00',2.13),('15529','2013-04-27','14:30:00',2.09),('15529','2013-04-27','14:35:00',2.09),('15529','2013-04-27','14:40:00',2.08),('15529','2013-04-27','14:45:00',2.06),('15529','2013-04-27','14:50:00',2.01),('15529','2013-04-27','14:55:00',2.05),('15529','2013-04-27','15:00:00',2),('15529','2013-04-27','15:05:00',1.97),('15529','2013-04-27','15:10:00',1.94),('15529','2013-04-27','15:15:00',1.87),('15529','2013-04-27','15:20:00',1.88),('15529','2013-04-27','15:25:00',1.84),('15529','2013-04-27','15:30:00',1.81),('15529','2013-04-27','15:35:00',1.81),('15529','2013-04-27','15:40:00',1.78),('15529','2013-04-27','15:45:00',1.74),('15529','2013-04-27','15:50:00',1.72),('15529','2013-04-27','15:55:00',1.7),('15529','2013-04-27','16:00:00',1.65),('15529','2013-04-27','16:05:00',1.61),('15529','2013-04-27','16:10:00',1.59),('15529','2013-04-27','16:15:00',1.55),('15529','2013-04-27','16:20:00',1.51),('15529','2013-04-27','16:25:00',1.46),('15529','2013-04-27','16:30:00',1.42),('15529','2013-04-27','16:35:00',1.39),('15529','2013-04-27','16:40:00',1.34),('15529','2013-04-27','16:45:00',1.31),('15529','2013-04-27','16:50:00',1.27),('15529','2013-04-27','16:55:00',1.22),('15529','2013-04-27','17:00:00',1.17),('15529','2013-04-27','17:05:00',1.05),('15529','2013-04-27','17:10:00',1.05),('15529','2013-04-27','17:15:00',1.06),('15529','2013-04-26','14:30:00',1.14),('15529','2013-04-26','16:50:00',1.11),('15529','2013-04-25','09:25:00',1.1),('15529','2013-04-25','09:35:00',1.08),('15529','2013-04-25','09:40:00',1.18),('15529','2013-04-25','09:45:00',1.22),('15529','2013-04-25','09:50:00',1.36),('15529','2013-04-25','10:00:00',1.23),('15529','2013-04-25','10:05:00',1.51),('15529','2013-04-25','10:10:00',1.65),('15529','2013-04-25','10:15:00',1.63),('15529','2013-04-25','10:20:00',1.68),('15529','2013-04-25','10:25:00',1.62),('15529','2013-04-25','10:30:00',1.63),('15529','2013-04-25','10:35:00',1.88),('15529','2013-04-25','10:40:00',1.51),('15529','2013-04-25','10:50:00',1.37),('15529','2013-04-25','10:55:00',1.93),('15529','2013-04-25','11:00:00',1.93),('15529','2013-04-25','11:05:00',1.9),('15529','2013-04-25','11:10:00',1.91),('15529','2013-04-25','11:15:00',1.65),('15529','2013-04-25','11:20:00',1.55),('15529','2013-04-25','11:25:00',1.74),('15529','2013-04-25','11:30:00',1.96),('15529','2013-04-25','11:35:00',2.28),('15529','2013-04-25','11:40:00',1.91),('15529','2013-04-25','11:45:00',1.77),('15529','2013-04-25','11:50:00',1.64),('15529','2013-04-25','11:55:00',1.49),('15529','2013-04-25','12:00:00',1.39),('15529','2013-04-25','12:05:00',1.3),('15529','2013-04-25','12:10:00',1.35),('15529','2013-04-25','12:15:00',1.43),('15529','2013-04-25','12:20:00',1.01),('15529','2013-04-25','12:35:00',1.04),('15529','2013-04-25','12:40:00',1.19),('15529','2013-04-25','12:45:00',1.12),('15529','2013-04-25','13:10:00',1.05),('15529','2013-04-25','13:15:00',1.08),('15529','2013-04-25','13:20:00',1.4),('15529','2013-04-25','13:25:00',1.51),('15529','2013-04-25','13:30:00',1.36),('15529','2013-04-25','13:35:00',2),('15529','2013-04-25','13:40:00',1.08),('15529','2013-04-25','13:45:00',1.81),('15529','2013-04-25','13:50:00',1.58),('15529','2013-04-25','13:55:00',1.22),('15529','2013-04-25','14:00:00',1.29),('15529','2013-04-25','14:05:00',1.61),('15529','2013-04-25','14:10:00',1.42),('15529','2013-04-25','14:15:00',1.59),('15529','2013-04-25','14:20:00',2.3),('15529','2013-04-25','14:25:00',2.04),('15529','2013-04-25','14:30:00',1.59),('15529','2013-04-25','14:35:00',1.08),('15529','2013-04-25','14:50:00',1.49),('15529','2013-04-25','14:55:00',2.19),('15529','2013-04-25','15:00:00',1.87),('15529','2013-04-25','15:05:00',1),('15529','2013-04-25','15:10:00',1.48),('15529','2013-04-25','15:15:00',1.17),('15529','2013-04-25','15:25:00',1.12),('15529','2013-04-25','15:30:00',1.17),('15529','2013-04-25','15:40:00',1.22),('15529','2013-04-25','15:45:00',1.08),('15529','2013-04-24','08:50:00',1.14),('15529','2013-04-24','08:55:00',1.04),('15529','2013-04-24','09:40:00',1.18),('15529','2013-04-24','09:45:00',1.55),('15529','2013-04-24','09:50:00',1.62),('15529','2013-04-24','09:55:00',1.62),('15529','2013-04-24','10:00:00',1.57),('15529','2013-04-24','10:05:00',1.5),('15529','2013-04-24','10:10:00',1.5),('15529','2013-04-24','10:15:00',1.62),('15529','2013-04-24','10:20:00',1.71),('15529','2013-04-24','10:25:00',1.78),('15529','2013-04-24','10:30:00',1.79),('15529','2013-04-24','10:35:00',1.81),('15529','2013-04-24','10:40:00',1.83),('15529','2013-04-24','10:45:00',1.84),('15529','2013-04-24','10:50:00',1.87),('15529','2013-04-24','10:55:00',1.94),('15529','2013-04-24','11:00:00',1.96),('15529','2013-04-24','11:05:00',1.98),('15529','2013-04-24','11:10:00',1.98),('15529','2013-04-24','11:15:00',2),('15529','2013-04-24','11:20:00',2.04),('15529','2013-04-24','11:25:00',2.08),('15529','2013-04-24','11:30:00',2.08),('15529','2013-04-24','11:35:00',2.11),('15529','2013-04-24','11:40:00',2.11),('15529','2013-04-24','11:45:00',2.16),('15529','2013-04-24','11:50:00',2.16),('15529','2013-04-24','11:55:00',2.16),('15529','2013-04-24','12:00:00',2.11),('15529','2013-04-24','12:05:00',2.14),('15529','2013-04-24','12:10:00',2.18),('15529','2013-04-24','12:15:00',2.2),('15529','2013-04-24','12:20:00',2.18),('15529','2013-04-24','12:25:00',2.17),('15529','2013-04-24','12:30:00',2.15),('15529','2013-04-24','12:35:00',2.19),('15529','2013-04-24','12:40:00',2.21),('15529','2013-04-24','12:45:00',2.22),('15529','2013-04-24','12:50:00',2.19),('15529','2013-04-24','12:55:00',2.19),('15529','2013-04-24','13:00:00',2.21),('15529','2013-04-24','13:05:00',2.24),('15529','2013-04-24','13:10:00',2.27),('15529','2013-04-24','13:15:00',2.02),('15529','2013-04-24','13:20:00',1.99),('15529','2013-04-24','13:25:00',1.55),('15529','2013-04-24','13:30:00',1.37),('15529','2013-04-24','13:35:00',1.29),('15529','2013-04-24','13:40:00',1.18),('15529','2013-04-24','13:45:00',1.1),('15529','2013-04-24','13:50:00',1.12),('15529','2013-04-24','13:55:00',1.25),('15529','2013-04-24','14:00:00',1.22),('15529','2013-04-24','14:05:00',1.13),('15529','2013-04-24','14:10:00',1.16),('15529','2013-04-24','14:15:00',1.21),('15529','2013-04-24','14:20:00',1.43),('15529','2013-04-24','14:25:00',1.5),('15529','2013-04-24','14:30:00',1.85),('15529','2013-04-24','14:35:00',1.88),('15529','2013-04-24','14:40:00',1.82),('15529','2013-04-24','14:45:00',1.81),('15529','2013-04-24','14:50:00',1.77),('15529','2013-04-24','14:55:00',1.73),('15529','2013-04-24','15:00:00',1.63),('15529','2013-04-24','15:05:00',1.44),('15529','2013-04-24','15:10:00',1.6),('15529','2013-04-24','15:15:00',1.79),('15529','2013-04-24','15:20:00',1.81),('15529','2013-04-24','15:25:00',1.79),('15529','2013-04-24','15:30:00',1.74),('15529','2013-04-24','15:35:00',1.67),('15529','2013-04-24','15:40:00',1.52),('15529','2013-04-24','15:45:00',1.61),('15529','2013-04-24','15:50:00',1.33),('15529','2013-04-24','15:55:00',1.5),('15529','2013-04-24','16:00:00',1.31),('15529','2013-04-24','16:05:00',1.3),('15529','2013-04-24','16:10:00',1.14),('15529','2013-04-24','16:15:00',1.1),('15529','2013-04-24','16:20:00',1.35),('15529','2013-04-24','16:25:00',1.06),('15529','2013-04-24','16:30:00',1.25),('15529','2013-04-24','16:35:00',1.23),('15529','2013-04-24','16:40:00',1.22),('15529','2013-04-24','16:45:00',1.07),('15529','2013-04-24','17:00:00',1.08),('15529','2013-04-24','17:05:00',1.09),('15529','2013-04-24','17:15:00',1.07),('15529','2013-04-24','17:20:00',1.02),('15529','2013-04-23','08:55:00',1.02),('15529','2013-04-23','09:00:00',1.16),('15529','2013-04-23','09:05:00',1.29),('15529','2013-04-23','09:10:00',1.37),('15529','2013-04-23','09:25:00',1.25),('15529','2013-04-23','09:30:00',1.12),('15529','2013-04-23','09:35:00',1.35),('15529','2013-04-23','09:40:00',1.37),('15529','2013-04-23','09:45:00',1.31),('15529','2013-04-23','09:50:00',1.56),('15529','2013-04-23','09:55:00',1.55),('15529','2013-04-23','10:00:00',1.72),('15529','2013-04-23','10:05:00',1.76),('15529','2013-04-23','10:10:00',1.7),('15529','2013-04-23','10:15:00',1.79),('15529','2013-04-23','10:20:00',1.74),('15529','2013-04-23','10:25:00',1.74),('15529','2013-04-23','10:30:00',1.71),('15529','2013-04-23','10:35:00',1.75),('15529','2013-04-23','10:40:00',1.92),('15529','2013-04-23','10:45:00',1.9),('15529','2013-04-23','10:50:00',1.96),('15529','2013-04-23','10:55:00',2.03),('15529','2013-04-23','11:00:00',1.99),('15529','2013-04-23','11:05:00',2.04),('15529','2013-04-23','11:10:00',2.17),('15529','2013-04-23','11:15:00',2.17),('15529','2013-04-23','11:20:00',2.25),('15529','2013-04-23','11:25:00',2.15),('15529','2013-04-23','11:30:00',1.88),('15529','2013-04-23','11:35:00',1.4),('15529','2013-04-23','11:40:00',1.45),('15529','2013-04-23','11:45:00',1.17),('15529','2013-04-23','11:50:00',1.1),('15529','2013-04-23','11:55:00',2),('15529','2013-04-23','12:00:00',1.58),('15529','2013-04-23','12:05:00',1.44),('15529','2013-04-23','12:10:00',1.68),('15529','2013-04-23','12:15:00',2.19),('15529','2013-04-23','12:20:00',2.29),('15529','2013-04-23','12:25:00',1.96),('15529','2013-04-23','12:30:00',2.06),('15529','2013-04-23','12:35:00',2.11),('15529','2013-04-23','12:40:00',1.97),('15529','2013-04-23','12:45:00',2.1),('15529','2013-04-23','12:50:00',2.2),('15529','2013-04-23','12:55:00',2.16),('15529','2013-04-23','13:00:00',1.96),('15529','2013-04-23','13:05:00',1.96),('15529','2013-04-23','13:10:00',2.38),('15529','2013-04-23','13:15:00',2.13),('15529','2013-04-23','13:20:00',2.13),('15529','2013-04-23','13:25:00',2.25),('15529','2013-04-23','13:30:00',1.88),('15529','2013-04-23','13:35:00',2.23),('15529','2013-04-23','13:40:00',2.35),('15529','2013-04-23','13:45:00',1.69),('15529','2013-04-23','13:50:00',1.71),('15529','2013-04-23','13:55:00',2.32),('15529','2013-04-23','14:00:00',1.93),('15529','2013-04-23','14:05:00',1.48),('15529','2013-04-23','14:10:00',1.85),('15529','2013-04-23','14:15:00',2.12),('15529','2013-04-23','14:20:00',1.99),('15529','2013-04-23','14:25:00',2.03),('15529','2013-04-23','14:30:00',1.82),('15529','2013-04-23','14:35:00',1.79),('15529','2013-04-23','14:40:00',1.59),('15529','2013-04-23','14:45:00',1.57),('15529','2013-04-23','14:50:00',1.38),('15529','2013-04-23','14:55:00',1.28),('15529','2013-04-23','15:00:00',1.29),('15529','2013-04-23','15:05:00',1.22),('15529','2013-04-23','15:10:00',1.12),('15529','2013-04-23','15:15:00',1.18),('15529','2013-04-23','15:20:00',1.27),('15529','2013-04-23','15:55:00',1.32),('15529','2013-04-23','16:00:00',1.36),('15529','2013-04-23','16:05:00',1.48),('15529','2013-04-23','16:10:00',1.34),('15529','2013-04-23','16:15:00',1.45),('15529','2013-04-23','16:20:00',1.62),('15529','2013-04-23','16:25:00',1.26),('15529','2013-04-23','16:35:00',1.12),('15529','2013-04-23','16:40:00',1.26),('15529','2013-04-23','16:45:00',1.26),('15529','2013-04-23','16:50:00',1.23),('15529','2013-04-23','16:55:00',1.45),('15529','2013-04-23','17:00:00',1.38),('15529','2013-04-23','17:05:00',1.28),('15529','2013-04-23','17:10:00',1.18),('15529','2013-04-22','08:40:00',1.02),('15529','2013-04-22','08:45:00',1.08),('15529','2013-04-22','08:50:00',1.13),('15529','2013-04-22','08:55:00',1.18),('15529','2013-04-22','09:00:00',1.23),('15529','2013-04-22','09:05:00',1.27),('15529','2013-04-22','09:10:00',1.32),('15529','2013-04-22','09:15:00',1.37),('15529','2013-04-22','09:20:00',1.41),('15529','2013-04-22','09:25:00',1.45),('15529','2013-04-22','09:30:00',1.49),('15529','2013-04-22','09:35:00',1.55),('15529','2013-04-22','09:40:00',1.43),('15529','2013-04-22','09:45:00',1.33),('15529','2013-04-22','09:50:00',1.53),('15529','2013-04-22','09:55:00',1.73),('15529','2013-04-22','10:00:00',1.76),('15529','2013-04-22','10:05:00',1.78),('15529','2013-04-22','10:10:00',1.82),('15529','2013-04-22','10:15:00',1.84),('15529','2013-04-22','10:20:00',1.88),('15529','2013-04-22','10:25:00',1.9),('15529','2013-04-22','10:30:00',1.92),('15529','2013-04-22','10:35:00',1.95),('15529','2013-04-22','10:40:00',1.99),('15529','2013-04-22','10:45:00',1.92),('15529','2013-04-22','10:50:00',2.02),('15529','2013-04-22','10:55:00',2.07),('15529','2013-04-22','11:00:00',2.07),('15529','2013-04-22','11:05:00',2.11),('15529','2013-04-22','11:10:00',2.12),('15529','2013-04-22','11:15:00',2.14),('15529','2013-04-22','11:20:00',2.15),('15529','2013-04-22','11:25:00',2.18),('15529','2013-04-22','11:30:00',2.2),('15529','2013-04-22','11:35:00',2.2),('15529','2013-04-22','11:40:00',2.24),('15529','2013-04-22','11:45:00',2.23),('15529','2013-04-22','11:50:00',2.21),('15529','2013-04-22','11:55:00',2.23),('15529','2013-04-22','12:00:00',2.25),('15529','2013-04-22','12:05:00',2.28),('15529','2013-04-22','12:10:00',2.29),('15529','2013-04-22','12:15:00',2.31),('15529','2013-04-22','12:20:00',2.29),('15529','2013-04-22','12:25:00',2.35),('15529','2013-04-22','12:30:00',1.33),('15529','2013-04-22','12:35:00',1.78),('15529','2013-04-22','12:50:00',1.98),('15529','2013-04-22','12:55:00',2.47),('15529','2013-04-22','13:00:00',2.11),('15529','2013-04-22','13:05:00',1.37),('15529','2013-04-22','13:15:00',2.07),('15529','2013-04-22','13:20:00',2.61),('15529','2013-04-22','13:25:00',2.43),('15529','2013-04-22','13:30:00',2.42),('15529','2013-04-22','13:35:00',2.4),('15529','2013-04-22','13:40:00',2.44),('15529','2013-04-22','13:45:00',1.9),('15529','2013-04-22','13:50:00',2.25),('15529','2013-04-22','13:55:00',2.51),('15529','2013-04-22','14:00:00',2.36),('15529','2013-04-22','14:05:00',2.49),('15529','2013-04-22','14:10:00',2.27),('15529','2013-04-22','14:15:00',2.2),('15529','2013-04-22','14:20:00',1.6),('15529','2013-04-22','14:25:00',1.68),('15529','2013-04-22','14:30:00',2.31),('15529','2013-04-22','14:35:00',2.12),('15529','2013-04-22','14:40:00',2.22),('15529','2013-04-22','14:45:00',1.75),('15529','2013-04-22','14:50:00',1.15),('15529','2013-04-22','14:55:00',1.11),('15529','2013-04-22','15:00:00',1.28),('15529','2013-04-22','15:05:00',1.42),('15529','2013-04-22','15:10:00',1.59),('15529','2013-04-22','15:15:00',1.56),('15529','2013-04-22','15:20:00',1.5),('15529','2013-04-22','15:25:00',1.29),('15529','2013-04-22','15:30:00',1.31),('15529','2013-04-22','15:35:00',1.31),('15529','2013-04-22','15:40:00',1.13),('15529','2013-04-22','15:45:00',1.13),('15529','2013-04-22','15:50:00',1.05),('15529','2013-04-22','15:55:00',1.33),('15529','2013-04-22','16:00:00',1.52),('15529','2013-04-22','16:05:00',1.42),('15529','2013-04-22','16:10:00',1.47),('15529','2013-04-22','16:15:00',1.27),('15529','2013-04-22','16:20:00',1.24),('15529','2013-04-21','10:35:00',2.12),('15529','2013-04-21','10:40:00',1.86),('15529','2013-04-21','10:45:00',1.91),('15529','2013-04-21','10:50:00',1.11),('15529','2013-04-21','11:30:00',2.11),('15529','2013-04-21','11:35:00',2.49),('15529','2013-04-21','11:40:00',1.61),('15529','2013-04-21','11:45:00',1.43),('15529','2013-04-21','11:50:00',2.65),('15529','2013-04-21','11:55:00',1.53),('15529','2013-04-21','12:00:00',1.03),('15529','2013-04-21','12:05:00',2.37),('15529','2013-04-21','12:10:00',2.23),('15529','2013-04-21','12:15:00',2.75),('15529','2013-04-21','12:20:00',1.45),('15529','2013-04-21','12:25:00',2.32),('15529','2013-04-21','12:30:00',1.99),('15529','2013-04-21','12:35:00',1.64),('15529','2013-04-21','12:40:00',2.8),('15529','2013-04-21','12:45:00',2.13),('15529','2013-04-21','12:50:00',2.05),('15529','2013-04-21','12:55:00',2.63),('15529','2013-04-21','13:00:00',1.96),('15529','2013-04-21','13:05:00',1.98),('15529','2013-04-21','13:10:00',1.49),('15529','2013-04-21','13:20:00',1.15),('15529','2013-04-21','13:25:00',2.75),('15529','2013-04-21','13:30:00',2.28),('15529','2013-04-21','13:35:00',1.83),('15529','2013-04-21','13:40:00',1.21),('15529','2013-04-21','14:15:00',2.48),('15529','2013-04-21','14:20:00',2.57),('15529','2013-04-21','14:25:00',2.5),('15529','2013-04-21','14:30:00',2.46),('15529','2013-04-21','14:35:00',2.08),('15529','2013-04-21','14:40:00',1.67),('15529','2013-04-21','14:45:00',2.36),('15529','2013-04-21','14:50:00',2.4),('15529','2013-04-21','14:55:00',2.39),('15529','2013-04-21','15:00:00',2.45),('15529','2013-04-21','15:05:00',1.44),('15529','2013-04-21','15:10:00',2.09),('15529','2013-04-21','15:15:00',2.44),('15529','2013-04-21','15:20:00',1.99),('15529','2013-04-21','15:25:00',1.29),('15529','2013-04-21','15:35:00',1.74),('15529','2013-04-21','15:40:00',2),('15529','2013-04-21','15:45:00',2.15),('15529','2013-04-21','15:50:00',1.9),('15529','2014-03-28','08:05:00',1.03),('15529','2014-03-28','08:10:00',1.08),('15529','2014-03-28','08:15:00',1.13),('15529','2014-03-28','08:20:00',1.19),('15529','2014-03-28','08:25:00',1.24),('15529','2014-03-28','08:30:00',1.29),('15529','2014-03-28','08:35:00',1.33),('15529','2014-03-28','08:40:00',1.37),('15529','2014-03-28','08:45:00',1.4),('15529','2014-03-28','08:50:00',1.44),('15529','2014-03-28','08:55:00',1.46),('15529','2014-03-28','09:00:00',1.5),('15529','2014-03-28','09:05:00',1.53),('15529','2014-03-28','09:10:00',1.57),('15529','2014-03-28','09:15:00',1.61),('15529','2014-03-28','09:20:00',1.66),('15529','2014-03-28','09:25:00',1.71),('15529','2014-03-28','09:30:00',1.76),('15529','2014-03-28','09:35:00',1.78),('15529','2014-03-28','09:40:00',1.8),('15529','2014-03-28','09:45:00',1.84),('15529','2014-03-28','09:50:00',1.87),('15529','2014-03-28','09:55:00',1.9),('15529','2014-03-28','10:00:00',1.93),('15529','2014-03-28','10:05:00',1.96),('15529','2014-03-28','10:10:00',1.97),('15529','2014-03-28','10:15:00',2.03),('15529','2014-03-28','10:20:00',2.06),('15529','2014-03-28','10:25:00',2.07),('15529','2014-03-28','10:30:00',2.08),('15529','2014-03-28','10:35:00',2.08),('15529','2014-03-28','10:40:00',2.1),('15529','2014-03-28','10:45:00',2.15),('15529','2014-03-28','10:50:00',2.18),('15529','2014-03-28','10:55:00',2.16),('15529','2014-03-28','11:00:00',2.19),('15529','2014-03-28','11:05:00',2.19),('15529','2014-03-28','11:10:00',2.21),('15529','2014-03-28','11:15:00',2.25),('15529','2014-03-28','11:20:00',2.23),('15529','2014-03-28','11:25:00',2.23),('15529','2014-03-28','11:30:00',2.24),('15529','2014-03-28','11:35:00',2.24),('15529','2014-03-28','11:40:00',2.21),('15529','2014-03-28','11:45:00',2.26),('15529','2014-03-28','11:50:00',2.3),('15529','2014-03-28','11:55:00',2.29),('15529','2014-03-28','12:00:00',2.25),('15529','2014-03-28','12:05:00',2.27),('15529','2014-03-28','12:10:00',2.3),('15529','2014-03-28','12:15:00',2.29),('15529','2014-03-28','12:20:00',2.28),('15529','2014-03-28','12:25:00',2.27),('15529','2014-03-28','12:30:00',2.3),('15529','2014-03-28','12:35:00',2.26),('15529','2014-03-28','12:40:00',2.29),('15529','2014-03-28','12:45:00',2.29),('15529','2014-03-28','12:50:00',2.24),('15529','2014-03-28','12:55:00',2.22),('15529','2014-03-28','13:00:00',2.21),('15529','2014-03-28','13:05:00',2.21),('15529','2014-03-28','13:10:00',2.2),('15529','2014-03-28','13:15:00',2.19),('15529','2014-03-28','13:20:00',2.2),('15529','2014-03-28','13:25:00',2.14),('15529','2014-03-28','13:30:00',2.12),('15529','2014-03-28','13:35:00',2.09),('15529','2014-03-28','13:40:00',2.08),('15529','2014-03-28','13:45:00',2.06),('15529','2014-03-28','13:50:00',2.05),('15529','2014-03-28','13:55:00',2.04),('15529','2014-03-28','14:00:00',2.01),('15529','2014-03-28','14:05:00',1.96),('15529','2014-03-28','14:10:00',1.93),('15529','2014-03-28','14:15:00',1.88),('15529','2014-03-28','14:20:00',1.86),('15529','2014-03-28','14:25:00',1.85),('15529','2014-03-28','14:30:00',1.78),('15529','2014-03-28','14:35:00',1.75),('15529','2014-03-28','14:40:00',1.81),('15529','2014-03-28','14:45:00',1.55),('15529','2014-03-28','14:50:00',1.47),('15529','2014-03-28','14:55:00',1.72),('15529','2014-03-28','15:00:00',1.68),('15529','2014-03-28','15:05:00',1.65),('15529','2014-03-28','15:10:00',1.6),('15529','2014-03-28','15:15:00',1.52),('15529','2014-03-28','15:20:00',1.48),('15529','2014-03-28','15:25:00',1.44),('15529','2014-03-28','15:30:00',1.41),('15529','2014-03-28','15:35:00',1.37),('15529','2014-03-28','15:40:00',1.32),('15529','2014-03-28','15:45:00',1.27),('15529','2014-03-28','15:50:00',1.23),('15529','2014-03-28','15:55:00',1.18),('15529','2014-03-28','16:00:00',1.13),('15529','2014-03-28','16:05:00',1.08),('15529','2014-03-28','16:10:00',1.03),('15529','2013-04-20','09:00:00',1.43),('15529','2013-04-20','09:15:00',1.2),('15529','2013-04-20','09:20:00',1.61),('15529','2013-04-20','09:25:00',1.51),('15529','2013-04-20','09:30:00',1.77),('15529','2013-04-20','09:35:00',1.62),('15529','2013-04-20','09:40:00',1.83),('15529','2013-04-20','09:45:00',1.77),('15529','2013-04-20','09:50:00',1.24),('15529','2013-04-20','09:55:00',1.24),('15529','2013-04-20','10:30:00',1.1),('15529','2013-04-20','10:40:00',1.1),('15529','2013-04-20','10:45:00',1.35),('15529','2013-04-20','10:50:00',1.54),('15529','2013-04-20','10:55:00',2.12),('15529','2013-04-20','11:00:00',1.59),('15529','2013-04-20','11:05:00',1.56),('15529','2013-04-20','11:10:00',1.57),('15529','2013-04-20','11:15:00',1.67),('15529','2013-04-20','11:20:00',1.58),('15529','2013-04-20','11:25:00',1.39),('15529','2013-04-20','11:30:00',1.44),('15529','2013-04-20','11:35:00',1.62),('15529','2013-04-20','11:40:00',1.9),('15529','2013-04-20','11:45:00',1.79),('15529','2013-04-20','11:50:00',1.34),('15529','2013-04-20','11:55:00',1.44),('15529','2013-04-20','12:00:00',1.36),('15529','2013-04-20','12:05:00',1.24),('15529','2013-04-20','12:10:00',1.2),('15529','2013-04-20','12:15:00',1.01),('15529','2013-04-20','12:25:00',1),('15529','2013-04-20','12:30:00',1.03),('15529','2013-04-20','12:35:00',1.14),('15529','2013-04-20','12:40:00',1.13),('15529','2013-04-20','12:45:00',1.08),('15529','2013-04-20','12:50:00',1.09),('15529','2013-04-20','12:55:00',1.07),('15529','2013-04-20','13:00:00',1.22),('15529','2013-04-20','13:05:00',1.92),('15529','2013-04-20','13:10:00',1.42),('15529','2013-04-20','13:15:00',1.21),('15529','2013-04-20','13:20:00',1.21),('15529','2013-04-20','13:25:00',1.27),('15529','2013-04-20','13:30:00',2.04),('15529','2013-04-20','13:35:00',2.4),('15529','2013-04-20','13:40:00',2.56),('15529','2013-04-20','13:45:00',2.65),('15529','2013-04-20','13:50:00',1.96),('15529','2013-04-20','13:55:00',1.86),('15529','2013-04-20','14:00:00',1.94),('15529','2013-04-20','14:05:00',2.4),('15529','2013-04-20','14:10:00',2.5),('15529','2013-04-20','14:15:00',2.06),('15529','2013-04-20','14:20:00',2.38),('15529','2013-04-20','14:25:00',1.74),('15529','2013-04-20','14:30:00',2.27),('15529','2013-04-20','14:35:00',2.32),('15529','2013-04-20','14:40:00',1.74),('15529','2013-04-20','14:45:00',2),('15529','2013-04-20','14:50:00',1.46),('15529','2013-04-20','14:55:00',2.23),('15529','2013-04-20','15:00:00',1.35),('15529','2013-04-20','15:05:00',1.97),('15529','2013-04-20','15:10:00',1.53),('15529','2013-04-20','15:15:00',1.18),('15529','2013-04-19','08:40:00',1.02),('15529','2013-04-19','08:45:00',1.05),('15529','2013-04-19','08:50:00',1.15),('15529','2013-04-19','08:55:00',1.26),('15529','2013-04-19','09:00:00',1.22),('15529','2013-04-19','09:05:00',1.06),('15529','2013-04-19','09:15:00',1.13),('15529','2013-04-19','09:20:00',1.05),('15529','2013-04-19','10:40:00',1.69),('15529','2013-04-19','10:45:00',2.03),('15529','2013-04-19','10:50:00',1.89),('15529','2013-04-19','10:55:00',1.3),('15529','2013-04-19','11:00:00',2.13),('15529','2013-04-19','11:05:00',2.22),('15529','2013-04-19','11:10:00',1.98),('15529','2013-04-19','11:15:00',1.54),('15529','2013-04-19','11:20:00',1.56),('15529','2013-04-19','11:25:00',1.14),('15529','2013-04-19','11:30:00',1.97),('15529','2013-04-19','11:35:00',1.64),('15529','2013-04-19','11:40:00',2.03),('15529','2013-04-19','11:45:00',1.28),('15529','2013-04-19','11:55:00',1.98),('15529','2013-04-19','12:05:00',1.88),('15529','2013-04-19','12:10:00',1.86),('15529','2013-04-19','12:15:00',2.03),('15529','2013-04-19','12:20:00',1.06),('15529','2013-04-19','12:25:00',2.03),('15529','2013-04-19','12:30:00',1.18),('15529','2013-04-19','12:35:00',1.89),('15529','2013-04-19','12:40:00',2.5),('15529','2013-04-19','12:45:00',2.4),('15529','2013-04-19','12:50:00',2.36),('15529','2013-04-19','12:55:00',2.33),('15529','2013-04-19','13:00:00',2.35),('15529','2013-04-19','13:05:00',2.35),('15529','2013-04-19','13:10:00',2.41),('15529','2013-04-19','13:15:00',1.34),('15529','2013-04-19','13:20:00',1.04),('15529','2013-04-19','13:25:00',2.08),('15529','2013-04-19','13:30:00',2.16),('15529','2013-04-19','13:35:00',1.5),('15529','2013-04-19','13:40:00',1.84),('15529','2013-04-19','13:45:00',1.32),('15529','2013-04-19','13:50:00',1.28),('15529','2013-04-19','13:55:00',1.95),('15529','2013-04-19','14:00:00',1.89),('15529','2013-04-19','14:05:00',2),('15529','2013-04-19','14:10:00',1.86),('15529','2013-04-19','14:15:00',2.35),('15529','2013-04-19','14:20:00',2.23),('15529','2013-04-19','14:25:00',2.18),('15529','2013-04-19','14:30:00',2.17),('15529','2013-04-19','14:35:00',2.15),('15529','2013-04-19','14:40:00',2.13),('15529','2013-04-19','14:45:00',2.12),('15529','2013-04-19','14:50:00',2.14),('15529','2013-04-19','14:55:00',2.14),('15529','2013-04-19','15:00:00',2.14),('15529','2013-04-19','15:05:00',2.11),('15529','2013-04-19','15:10:00',1.86),('15529','2013-04-19','15:15:00',2.01),('15529','2013-04-19','15:20:00',1.57),('15529','2013-04-19','15:25:00',1.29),('15529','2013-04-19','16:05:00',1.05),('15529','2013-04-19','16:10:00',1.62),('15529','2013-04-19','16:15:00',1.53),('15529','2013-04-19','16:20:00',1.42),('15529','2013-04-19','16:25:00',1.35),('15529','2013-04-19','16:30:00',1.4),('15529','2013-04-19','16:35:00',1.63),('15529','2013-04-19','16:40:00',1.63),('15529','2013-04-19','16:45:00',1.49),('15529','2013-04-19','16:50:00',1.39),('15529','2013-04-19','16:55:00',1.31),('15529','2013-04-19','17:00:00',1.23),('15529','2013-04-19','17:05:00',1.17),('15529','2013-04-19','17:10:00',1.12),('15529','2013-04-19','17:15:00',1.08),('15529','2013-04-19','17:20:00',1.03),('15529','2013-04-19','17:25:00',1.02),('15529','2013-04-19','17:30:00',1.01),('15529','2013-04-18','08:50:00',1.03),('15529','2013-04-18','08:55:00',1.02),('15529','2013-04-18','09:05:00',1.15),('15529','2013-04-18','09:10:00',1.2),('15529','2013-04-18','09:15:00',1.22),('15529','2013-04-18','09:20:00',1.28),('15529','2013-04-18','09:25:00',1.31),('15529','2013-04-18','09:30:00',1.36),('15529','2013-04-18','09:35:00',1.37),('15529','2013-04-18','09:40:00',1.29),('15529','2013-04-18','09:45:00',1.42),('15529','2013-04-18','09:50:00',1.46),('15529','2013-04-18','09:55:00',1.51),('15529','2013-04-18','10:00:00',1.55),('15529','2013-04-18','10:05:00',1.59),('15529','2013-04-18','10:10:00',1.61),('15529','2013-04-18','10:15:00',1.66),('15529','2013-04-18','10:20:00',1.7),('15529','2013-04-18','10:25:00',1.73),('15529','2013-04-18','10:30:00',1.74),('15529','2013-04-18','10:35:00',1.77),('15529','2013-04-18','10:40:00',1.72),('15529','2013-04-18','10:45:00',1.83),('15529','2013-04-18','10:50:00',1.83),('15529','2013-04-18','10:55:00',1.81),('15529','2013-04-18','11:00:00',1.9),('15529','2013-04-18','11:05:00',1.92),('15529','2013-04-18','11:10:00',1.95),('15529','2013-04-18','11:15:00',1.97),('15529','2013-04-18','11:20:00',1.97),('15529','2013-04-18','11:25:00',2.01),('15529','2013-04-18','11:30:00',1.98),('15529','2013-04-18','11:35:00',2.03),('15529','2013-04-18','11:40:00',2.01),('15529','2013-04-18','11:45:00',2.05),('15529','2013-04-18','11:50:00',2.07),('15529','2013-04-18','11:55:00',2.07),('15529','2013-04-18','12:00:00',2.11),('15529','2013-04-18','12:05:00',2.11),('15529','2013-04-18','12:10:00',2.18),('15529','2013-04-18','12:15:00',2.14),('15529','2013-04-18','12:20:00',2.18),('15529','2013-04-18','12:25:00',2.19),('15529','2013-04-18','12:30:00',2.19),('15529','2013-04-18','12:35:00',2.18),('15529','2013-04-18','12:40:00',2.2),('15529','2013-04-18','12:45:00',2.24),('15529','2013-04-18','12:50:00',2.21),('15529','2013-04-18','12:55:00',2.16),('15529','2013-04-18','13:00:00',2.15),('15529','2013-04-18','13:05:00',2.28),('15529','2013-04-18','13:10:00',2.28),('15529','2013-04-18','13:15:00',2.23),('15529','2013-04-18','13:20:00',2.21),('15529','2013-04-18','13:25:00',2.27),('15529','2013-04-18','13:30:00',2.24),('15529','2013-04-18','13:35:00',2.19),('15529','2013-04-18','13:40:00',2.19),('15529','2013-04-18','13:45:00',2.17),('15529','2013-04-18','13:50:00',2.17),('15529','2013-04-18','13:55:00',2.2),('15529','2013-04-18','14:00:00',2.13),('15529','2013-04-18','14:05:00',2.17),('15529','2013-04-18','14:10:00',2.13),('15529','2013-04-18','14:15:00',2.11),('15529','2013-04-18','14:20:00',2.11),('15529','2013-04-18','14:25:00',2.09),('15529','2013-04-18','14:30:00',2.07),('15529','2013-04-18','14:35:00',2.05),('15529','2013-04-18','14:40:00',2.02),('15529','2013-04-18','14:45:00',2),('15529','2013-04-18','14:50:00',1.96),('15529','2013-04-18','14:55:00',1.95),('15529','2013-04-18','15:00:00',1.91),('15529','2013-04-18','15:05:00',1.88),('15529','2013-04-18','15:10:00',1.9),('15529','2013-04-18','15:15:00',1.88),('15529','2013-04-18','15:20:00',1.87),('15529','2013-04-18','15:25:00',1.82),('15529','2013-04-18','15:30:00',1.81),('15529','2013-04-18','15:35:00',1.79),('15529','2013-04-18','15:40:00',1.75),('15529','2013-04-18','15:45:00',1.71),('15529','2013-04-18','15:50:00',1.67),('15529','2013-04-18','15:55:00',1.64),('15529','2013-04-18','16:00:00',1.61),('15529','2013-04-18','16:05:00',1.57),('15529','2013-04-18','16:10:00',1.56),('15529','2013-04-18','16:15:00',1.51),('15529','2013-04-18','16:20:00',1.45),('15529','2013-04-18','16:25:00',1.42),('15529','2013-04-18','16:30:00',1.39),('15529','2013-04-18','16:35:00',1.35),('15529','2013-04-18','16:40:00',1.29),('15529','2013-04-18','16:45:00',1.24),('15529','2013-04-18','16:50:00',1.21),('15529','2013-04-18','16:55:00',1.16),('15529','2013-04-18','17:00:00',1.11),('15529','2013-04-18','17:05:00',1.06),('15529','2013-04-18','17:10:00',1.01),('15529','2013-04-17','09:10:00',1.11),('15529','2013-04-17','09:15:00',1.1),('15529','2013-04-17','09:20:00',1.05),('15529','2013-04-17','09:25:00',1.02),('15529','2013-04-17','09:30:00',1.06),('15529','2013-04-17','09:35:00',1.12),('15529','2013-04-17','09:40:00',1.24),('15529','2013-04-17','09:45:00',1.35),('15529','2013-04-17','09:50:00',1.41),('15529','2013-04-17','09:55:00',1.5),('15529','2013-04-17','10:00:00',1.42),('15529','2013-04-17','10:05:00',1.51),('15529','2013-04-17','10:10:00',1.57),('15529','2013-04-17','10:15:00',1.74),('15529','2013-04-17','10:20:00',1.8),('15529','2013-04-17','10:25:00',1.77),('15529','2013-04-17','10:30:00',1.81),('15529','2013-04-17','10:35:00',1.85),('15529','2013-04-17','10:40:00',1.85),('15529','2013-04-17','10:45:00',1.88),('15529','2013-04-17','10:50:00',1.91),('15529','2013-04-17','10:55:00',1.94),('15529','2013-04-17','11:00:00',1.97),('15529','2013-04-17','11:05:00',2),('15529','2013-04-17','11:10:00',2.02),('15529','2013-04-17','11:15:00',2.04),('15529','2013-04-17','11:20:00',2.06),('15529','2013-04-17','11:25:00',2.08),('15529','2013-04-17','11:30:00',2.06),('15529','2013-04-17','11:35:00',2.07),('15529','2013-04-17','11:40:00',2.14),('15529','2013-04-17','11:45:00',2.12),('15529','2013-04-17','11:50:00',2.17),('15529','2013-04-17','11:55:00',2.18),('15529','2013-04-17','12:00:00',2.16),('15529','2013-04-17','12:05:00',2.23),('15529','2013-04-17','12:10:00',2.21),('15529','2013-04-17','12:15:00',2.23),('15529','2013-04-17','12:20:00',2.23),('15529','2013-04-17','12:25:00',2.25),('15529','2013-04-17','12:30:00',2.26),('15529','2013-04-17','12:35:00',2.28),('15529','2013-04-17','12:40:00',2.27),('15529','2013-04-17','12:45:00',2.31),('15529','2013-04-17','12:50:00',2.33),('15529','2013-04-17','12:55:00',2.32),('15529','2013-04-17','13:00:00',2.31),('15529','2013-04-17','13:05:00',2.31),('15529','2013-04-17','13:10:00',2.34),('15529','2013-04-17','13:15:00',2.31),('15529','2013-04-17','13:20:00',2.32),('15529','2013-04-17','13:25:00',2.31),('15529','2013-04-17','13:30:00',2.34),('15529','2013-04-17','13:35:00',2.31),('15529','2013-04-17','13:40:00',2.3),('15529','2013-04-17','13:45:00',2.3),('15529','2013-04-17','13:50:00',2.33),('15529','2013-04-17','13:55:00',2.26),('15529','2013-04-17','14:00:00',2.23),('15529','2013-04-17','14:05:00',2.26),('15529','2013-04-17','14:10:00',2.23),('15529','2013-04-17','14:15:00',2.26),('15529','2013-04-17','14:20:00',2.22),('15529','2013-04-17','14:25:00',2.19),('15529','2013-04-17','14:30:00',2.18),('15529','2013-04-17','14:35:00',2.15),('15529','2013-04-17','14:40:00',2.13),('15529','2013-04-17','14:45:00',2.14),('15529','2013-04-17','14:50:00',2.09),('15529','2013-04-17','14:55:00',2.07),('15529','2013-04-17','15:00:00',2.05),('15529','2013-04-17','15:05:00',2.02),('15529','2013-04-17','15:10:00',1.99),('15529','2013-04-17','15:15:00',1.96),('15529','2013-04-17','15:20:00',1.93),('15529','2013-04-17','15:25:00',1.91),('15529','2013-04-17','15:30:00',1.87),('15529','2013-04-17','15:35:00',1.84),('15529','2013-04-17','15:40:00',1.82),('15529','2013-04-17','15:45:00',1.8),('15529','2013-04-17','15:50:00',1.76),('15529','2013-04-17','15:55:00',1.73),('15529','2013-04-17','16:00:00',1.7),('15529','2013-04-17','16:05:00',1.65),('15529','2013-04-17','16:10:00',1.6),('15529','2013-04-17','16:15:00',1.58),('15529','2013-04-17','16:20:00',1.54),('15529','2013-04-17','16:25:00',1.49),('15529','2013-04-17','16:30:00',1.44),('15529','2013-04-17','16:35:00',1.4),('15529','2013-04-17','16:40:00',1.36),('15529','2013-04-17','16:45:00',1.32),('15529','2013-04-17','16:50:00',1.27),('15529','2013-04-17','16:55:00',1.22),('15529','2013-04-17','17:00:00',1.17),('15529','2013-04-17','17:05:00',1.12),('15529','2013-04-17','17:10:00',1.07),('15529','2013-04-17','17:15:00',1.03),('15529','2013-04-16','08:50:00',1.03),('15529','2013-04-16','08:55:00',1.08),('15529','2013-04-16','09:00:00',1.13),('15529','2013-04-16','09:05:00',1.19),('15529','2013-04-16','09:10:00',1.24),('15529','2013-04-16','09:15:00',1.28),('15529','2013-04-16','09:20:00',1.33),('15529','2013-04-16','09:25:00',1.37),('15529','2013-04-16','09:30:00',1.4),('15529','2013-04-16','09:35:00',1.45),('15529','2013-04-16','09:40:00',1.49),('15529','2013-04-16','09:45:00',1.53),('15529','2013-04-16','09:50:00',1.57),('15529','2013-04-16','09:55:00',1.6),('15529','2013-04-16','10:00:00',1.64),('15529','2013-04-16','10:05:00',1.67),('15529','2013-04-16','10:10:00',1.7),('15529','2013-04-16','10:15:00',1.73),('15529','2013-04-16','10:20:00',1.77),('15529','2013-04-16','10:25:00',1.81),('15529','2013-04-16','10:30:00',1.81),('15529','2013-04-16','10:35:00',1.84),('15529','2013-04-16','10:40:00',1.89),('15529','2013-04-16','10:45:00',1.92),('15529','2013-04-16','10:50:00',1.97),('15529','2013-04-16','10:55:00',2),('15529','2013-04-16','11:00:00',2.02),('15529','2013-04-16','11:05:00',2.02),('15529','2013-04-16','11:10:00',2.05),('15529','2013-04-16','11:15:00',2.01),('15529','2013-04-16','11:20:00',2.06),('15529','2013-04-16','11:25:00',2.09),('15529','2013-04-16','11:30:00',2.11),('15529','2013-04-16','11:35:00',2.15),('15529','2013-04-16','11:40:00',2.12),('15529','2013-04-16','11:45:00',2.18),('15529','2013-04-16','11:50:00',2.18),('15529','2013-04-16','11:55:00',2.21),('15529','2013-04-16','12:00:00',2.24),('15529','2013-04-16','12:05:00',2.2),('15529','2013-04-16','12:10:00',2.24),('15529','2013-04-16','12:15:00',2.26),('15529','2013-04-16','12:20:00',2.25),('15529','2013-04-16','12:25:00',2.26),('15529','2013-04-16','12:30:00',2.27),('15529','2013-04-16','12:35:00',2.26),('15529','2013-04-16','12:40:00',2.29),('15529','2013-04-16','12:45:00',2.31),('15529','2013-04-16','12:50:00',2.32),('15529','2013-04-16','12:55:00',2.32),('15529','2013-04-16','13:00:00',2.29),('15529','2013-04-16','13:05:00',2.31),('15529','2013-04-16','13:10:00',2.32),('15529','2013-04-16','13:15:00',2.31),('15529','2013-04-16','13:20:00',2.29),('15529','2013-04-16','13:25:00',2.3),('15529','2013-04-16','13:30:00',2.26),('15529','2013-04-16','13:35:00',2.31),('15529','2013-04-16','13:40:00',2.28),('15529','2013-04-16','13:45:00',2.23),('15529','2013-04-16','13:50:00',2.29),('15529','2013-04-16','13:55:00',2.14),('15529','2013-04-16','14:00:00',2.07),('15529','2013-04-16','14:05:00',2.31),('15529','2013-04-16','14:10:00',2.43),('15529','2013-04-16','14:15:00',2.43),('15529','2013-04-16','14:20:00',2.31),('15529','2013-04-16','14:25:00',2.38),('15529','2013-04-16','14:30:00',1.74),('15529','2013-04-16','14:35:00',2.2),('15529','2013-04-16','14:40:00',2.02),('15529','2013-04-16','14:45:00',2.04),('15529','2013-04-16','14:50:00',2.04),('15529','2013-04-16','14:55:00',2.27),('15529','2013-04-16','15:00:00',2.25),('15529','2013-04-16','15:05:00',2.27),('15529','2013-04-16','15:10:00',2.29),('15529','2013-04-16','15:15:00',2.09),('15529','2013-04-16','15:20:00',1.38),('15529','2013-04-16','15:30:00',1.59),('15529','2013-04-16','15:35:00',1.77),('15529','2013-04-16','15:40:00',1.93),('15529','2013-04-16','15:45:00',1.92),('15529','2013-04-16','15:50:00',1.92),('15529','2013-04-16','15:55:00',1.88),('15529','2013-04-16','16:00:00',1.89),('15529','2013-04-16','16:05:00',1.56),('15529','2013-04-16','16:10:00',1.64),('15529','2013-04-16','16:15:00',1.72),('15529','2013-04-16','16:20:00',1.63),('15529','2013-04-16','16:25:00',1.58),('15529','2013-04-16','16:30:00',1.53),('15529','2013-04-16','16:35:00',1.48),('15529','2013-04-16','16:40:00',1.28),('15529','2013-04-16','16:45:00',1.36),('15529','2013-04-16','16:50:00',1.36),('15529','2013-04-16','16:55:00',1.29),('15529','2013-04-16','17:00:00',1.22),('15529','2013-04-16','17:05:00',1.17),('15529','2013-04-16','17:10:00',1.11),('15529','2013-04-16','17:15:00',1.06),('15529','2013-04-16','17:20:00',1.01),('15529','2013-04-15','09:15:00',1.34),('15529','2013-04-15','09:20:00',1.46),('15529','2013-04-15','09:25:00',1.65),('15529','2013-04-15','09:30:00',1.47),('15529','2013-04-15','09:35:00',1.01),('15529','2013-04-15','09:40:00',1.11),('15529','2013-04-15','09:45:00',1.02),('15529','2013-04-15','11:45:00',1.06),('15529','2013-04-15','11:50:00',1.21),('15529','2013-04-15','11:55:00',1.29),('15529','2013-04-15','12:00:00',1.41),('15529','2013-04-15','12:05:00',1.83),('15529','2013-04-15','12:10:00',1.69),('15529','2013-04-15','12:15:00',1.64),('15529','2013-04-15','12:20:00',1.65),('15529','2013-04-15','12:25:00',1.66),('15529','2013-04-15','12:30:00',1.64),('15529','2013-04-15','12:35:00',1.48),('15529','2013-04-15','12:40:00',1.38),('15529','2013-04-15','12:45:00',1.55),('15529','2013-04-15','12:50:00',1.63),('15529','2013-04-15','12:55:00',2.21),('15529','2013-04-15','13:00:00',2.27),('15529','2013-04-15','13:05:00',2.26),('15529','2013-04-15','13:10:00',2.2),('15529','2013-04-15','13:15:00',2.23),('15529','2013-04-15','13:20:00',2.28),('15529','2013-04-15','13:25:00',2.28),('15529','2013-04-15','13:30:00',2.25),('15529','2013-04-15','13:35:00',2.24),('15529','2013-04-15','13:40:00',2.23),('15529','2013-04-15','13:45:00',2.26),('15529','2013-04-15','13:50:00',2.2),('15529','2013-04-15','13:55:00',2.19),('15529','2013-04-15','14:00:00',2.24),('15529','2013-04-15','14:05:00',2.2),('15529','2013-04-15','14:10:00',2.16),('15529','2013-04-15','14:15:00',2.23),('15529','2013-04-15','14:20:00',2.25),('15529','2013-04-15','14:25:00',2.19),('15529','2013-04-15','14:30:00',1.98),('15529','2013-04-15','14:35:00',1.6),('15529','2013-04-15','14:40:00',1.86),('15529','2013-04-15','14:45:00',2.11),('15529','2013-04-15','14:50:00',2.06),('15529','2013-04-15','14:55:00',2.06),('15529','2013-04-15','15:00:00',1.94),('15529','2013-04-15','15:05:00',2),('15529','2013-04-15','15:10:00',2.01),('15529','2013-04-15','15:15:00',2),('15529','2013-04-15','15:20:00',1.65),('15529','2013-04-15','15:25:00',1.59),('15529','2013-04-15','15:30:00',1.66),('15529','2013-04-15','15:35:00',1.75),('15529','2013-04-15','15:40:00',1.8),('15529','2013-04-15','15:45:00',1.77),('15529','2013-04-15','15:50:00',1.72),('15529','2013-04-15','15:55:00',1.72),('15529','2013-04-15','16:00:00',1.65),('15529','2013-04-15','16:05:00',1.62),('15529','2013-04-15','16:10:00',1.52),('15529','2013-04-15','16:15:00',1.54),('15529','2013-04-15','16:20:00',1.52),('15529','2013-04-15','16:25:00',1.45),('15529','2013-04-15','16:30:00',1.44),('15529','2013-04-15','16:35:00',1.4),('15529','2013-04-15','16:40:00',1.38),('15529','2013-04-15','16:45:00',1.39),('15529','2013-04-15','16:50:00',1.32),('15529','2013-04-15','16:55:00',1.1),('15529','2013-04-15','17:00:00',1.16),('15529','2013-04-15','17:05:00',1.15),('15529','2013-04-15','17:10:00',1.11),('15529','2013-04-15','17:15:00',1.07),('15529','2013-04-14','08:50:00',1.04),('15529','2013-04-14','08:55:00',1.09),('15529','2013-04-14','09:00:00',1.14),('15529','2013-04-14','09:05:00',1.18),('15529','2013-04-14','09:10:00',1.23),('15529','2013-04-14','09:15:00',1.28),('15529','2013-04-14','09:20:00',1.33),('15529','2013-04-14','09:25:00',1.38),('15529','2013-04-14','09:30:00',1.42),('15529','2013-04-14','09:35:00',1.45),('15529','2013-04-14','09:40:00',1.49),('15529','2013-04-14','09:45:00',1.53),('15529','2013-04-14','09:50:00',1.57),('15529','2013-04-14','09:55:00',1.6),('15529','2013-04-14','10:00:00',1.62),('15529','2013-04-14','10:05:00',1.66),('15529','2013-04-14','10:10:00',1.69),('15529','2013-04-14','10:15:00',1.73),('15529','2013-04-14','10:20:00',1.76),('15529','2013-04-14','10:25:00',1.8),('15529','2013-04-14','10:30:00',1.83),('15529','2013-04-14','10:35:00',1.87),('15529','2013-04-14','10:40:00',1.89),('15529','2013-04-14','10:45:00',1.91),('15529','2013-04-14','10:50:00',1.95),('15529','2013-04-14','10:55:00',1.98),('15529','2013-04-14','11:00:00',1.98),('15529','2013-04-14','11:05:00',2.02),('15529','2013-04-14','11:10:00',2.07),('15529','2013-04-14','11:15:00',2.07),('15529','2013-04-14','11:20:00',2.1),('15529','2013-04-14','11:25:00',2.11),('15529','2013-04-14','11:30:00',2.14),('15529','2013-04-14','11:35:00',2.14),('15529','2013-04-14','11:40:00',2.17),('15529','2013-04-14','11:45:00',2.21),('15529','2013-04-14','11:50:00',2.2),('15529','2013-04-14','11:55:00',2.19),('15529','2013-04-14','12:00:00',2.23),('15529','2013-04-14','12:05:00',2.23),('15529','2013-04-14','12:10:00',2.19),('15529','2013-04-14','12:15:00',2.23),('15529','2013-04-14','12:20:00',2.3),('15529','2013-04-14','12:25:00',2.29),('15529','2013-04-14','12:30:00',2.29),('15529','2013-04-14','12:35:00',2.26),('15529','2013-04-14','12:40:00',2.29),('15529','2013-04-14','12:45:00',2.28),('15529','2013-04-14','12:50:00',2.28),('15529','2013-04-14','12:55:00',2.27),('15529','2013-04-14','13:00:00',2.29),('15529','2013-04-14','13:05:00',2.28),('15529','2013-04-14','13:10:00',2.3),('15529','2013-04-14','13:15:00',2.33),('15529','2013-04-14','13:20:00',2.33),('15529','2013-04-14','13:25:00',2.3),('15529','2013-04-14','13:30:00',2.31),('15529','2013-04-14','13:35:00',2.3),('15529','2013-04-14','13:40:00',2.3),('15529','2013-04-14','13:45:00',2.32),('15529','2013-04-14','13:50:00',2.3),('15529','2013-04-14','13:55:00',2.28),('15529','2013-04-14','14:00:00',2.3),('15529','2013-04-14','14:05:00',2.3),('15529','2013-04-14','14:10:00',2.27),('15529','2013-04-14','14:15:00',2.25),('15529','2013-04-14','14:20:00',2.24),('15529','2013-04-14','14:25:00',2.24),('15529','2013-04-14','14:30:00',2.22),('15529','2013-04-14','14:35:00',2.2),('15529','2013-04-14','14:40:00',2.17),('15529','2013-04-14','14:45:00',2.14),('15529','2013-04-14','14:50:00',2.14),('15529','2013-04-14','14:55:00',2.11),('15529','2013-04-14','15:00:00',2.08),('15529','2013-04-14','15:05:00',2.07),('15529','2013-04-14','15:10:00',2.05),('15529','2013-04-14','15:15:00',2.02),('15529','2013-04-14','15:20:00',2),('15529','2013-04-14','15:25:00',1.96),('15529','2013-04-14','15:30:00',1.93),('15529','2013-04-14','15:35:00',1.89),('15529','2013-04-14','15:40:00',1.86),('15529','2013-04-14','15:45:00',1.82),('15529','2013-04-14','15:50:00',1.8),('15529','2013-04-14','15:55:00',1.77),('15529','2013-04-14','16:00:00',1.73),('15529','2013-04-14','16:05:00',1.69),('15529','2013-04-14','16:10:00',1.64),('15529','2013-04-14','16:15:00',1.61),('15529','2013-04-14','16:20:00',1.57),('15529','2013-04-14','16:25:00',1.53),('15529','2013-04-14','16:30:00',1.49),('15529','2013-04-14','16:35:00',1.45),('15529','2013-04-14','16:40:00',1.4),('15529','2013-04-14','16:45:00',1.35),('15529','2013-04-14','16:50:00',1.3),('15529','2013-04-14','16:55:00',1.26),('15529','2013-04-14','17:00:00',1.21),('15529','2013-04-14','17:05:00',1.16),('15529','2013-04-14','17:10:00',1.11),('15529','2013-04-14','17:15:00',1.06),('15529','2013-04-14','17:20:00',1.01),('15529','2013-04-13','08:55:00',1.04),('15529','2013-04-13','09:00:00',1.09),('15529','2013-04-13','09:05:00',1.12),('15529','2013-04-13','09:10:00',1.17),('15529','2013-04-13','09:15:00',1.21),('15529','2013-04-13','09:20:00',1.25),('15529','2013-04-13','09:25:00',1.3),('15529','2013-04-13','09:30:00',1.34),('15529','2013-04-13','09:35:00',1.38),('15529','2013-04-13','09:40:00',1.43),('15529','2013-04-13','09:45:00',1.47),('15529','2013-04-13','09:50:00',1.51),('15529','2013-04-13','09:55:00',1.54),('15529','2013-04-13','10:00:00',1.58),('15529','2013-04-13','10:05:00',1.62),('15529','2013-04-13','10:10:00',1.66),('15529','2013-04-13','10:15:00',1.69),('15529','2013-04-13','10:20:00',1.71),('15529','2013-04-13','10:25:00',1.76),('15529','2013-04-13','10:30:00',1.8),('15529','2013-04-13','10:35:00',1.83),('15529','2013-04-13','10:40:00',1.86),('15529','2013-04-13','10:45:00',1.88),('15529','2013-04-13','10:50:00',1.91),('15529','2013-04-13','10:55:00',1.97),('15529','2013-04-13','11:00:00',1.98),('15529','2013-04-13','11:05:00',2),('15529','2013-04-13','11:10:00',1.99),('15529','2013-04-13','11:15:00',2.05),('15529','2013-04-13','11:20:00',2.06),('15529','2013-04-13','11:25:00',2.08),('15529','2013-04-13','11:30:00',2.1),('15529','2013-04-13','11:35:00',2.11),('15529','2013-04-13','11:40:00',2.12),('15529','2013-04-13','11:45:00',2.1),('15529','2013-04-13','11:50:00',2.13),('15529','2013-04-13','11:55:00',2.16),('15529','2013-04-13','12:00:00',2.16),('15529','2013-04-13','12:05:00',2.19),('15529','2013-04-13','12:10:00',2.2),('15529','2013-04-13','12:15:00',2.23),('15529','2013-04-13','12:20:00',2.15),('15529','2013-04-13','12:25:00',2.19),('15529','2013-04-13','12:30:00',2.22),('15529','2013-04-13','12:35:00',2.29),('15529','2013-04-13','12:40:00',2.32),('15529','2013-04-13','12:45:00',2.26),('15529','2013-04-13','12:50:00',2.33),('15529','2013-04-13','12:55:00',2.31),('15529','2013-04-13','13:00:00',2.28),('15529','2013-04-13','13:05:00',2.31),('15529','2013-04-13','13:10:00',2.32),('15529','2013-04-13','13:15:00',1.96),('15529','2013-04-13','13:20:00',1.88),('15529','2013-04-13','13:25:00',2.29),('15529','2013-04-13','13:30:00',2.34),('15529','2013-04-13','13:35:00',2.22),('15529','2013-04-13','13:40:00',2.26),('15529','2013-04-13','13:45:00',2.31),('15529','2013-04-13','13:50:00',2.25),('15529','2013-04-13','13:55:00',2.25),('15529','2013-04-13','14:00:00',2.26),('15529','2013-04-13','14:05:00',2.23),('15529','2013-04-13','14:10:00',2.23),('15529','2013-04-13','14:15:00',2.18),('15529','2013-04-13','14:20:00',2.16),('15529','2013-04-13','14:25:00',2.16),('15529','2013-04-13','14:30:00',2.13),('15529','2013-04-13','14:35:00',2.14),('15529','2013-04-13','14:40:00',2.15),('15529','2013-04-13','14:45:00',2.13),('15529','2013-04-13','14:50:00',1.87),('15529','2013-04-13','14:55:00',1.87),('15529','2013-04-13','15:00:00',2.1),('15529','2013-04-13','15:05:00',2.08),('15529','2013-04-13','15:10:00',1.97),('15529','2013-04-13','15:15:00',1.98),('15529','2013-04-13','15:20:00',1.96),('15529','2013-04-13','15:25:00',1.93),('15529','2013-04-13','15:30:00',1.89),('15529','2013-04-13','15:35:00',1.85),('15529','2013-04-13','15:40:00',1.83),('15529','2013-04-13','15:45:00',1.81),('15529','2013-04-13','15:50:00',1.78),('15529','2013-04-13','15:55:00',1.75),('15529','2013-04-13','16:00:00',1.7),('15529','2013-04-13','16:05:00',1.65),('15529','2013-04-13','16:10:00',1.61),('15529','2013-04-13','16:15:00',1.56),('15529','2013-04-13','16:20:00',1.53),('15529','2013-04-13','16:25:00',1.49),('15529','2013-04-13','16:30:00',1.44),('15529','2013-04-13','16:35:00',1.38),('15529','2013-04-13','16:40:00',1.34),('15529','2013-04-13','16:45:00',1.32),('15529','2013-04-13','16:50:00',1.25),('15529','2013-04-13','16:55:00',1.22),('15529','2013-04-13','17:00:00',1.17),('15529','2013-04-13','17:05:00',1.12),('15529','2013-04-13','17:10:00',1.07),('15529','2013-04-13','17:15:00',1.03),('15529','2013-04-12','09:25:00',1.4),('15529','2013-04-12','09:30:00',1.41),('15529','2013-04-12','09:35:00',1.31),('15529','2013-04-12','09:40:00',1.32),('15529','2013-04-12','09:45:00',1.48),('15529','2013-04-12','09:50:00',1.52),('15529','2013-04-12','09:55:00',1.59),('15529','2013-04-12','10:00:00',1.65),('15529','2013-04-12','10:05:00',1.78),('15529','2013-04-12','10:15:00',1.93),('15529','2013-04-12','10:20:00',1.74),('15529','2013-04-12','10:25:00',1.76),('15529','2013-04-12','10:30:00',1.91),('15529','2013-04-12','10:35:00',1.95),('15529','2013-04-12','10:40:00',1.97),('15529','2013-04-12','10:45:00',1.61),('15529','2013-04-12','10:55:00',1.33),('15529','2013-04-12','11:05:00',1.49),('15529','2013-04-12','11:10:00',1.45),('15529','2013-04-12','11:15:00',2.08),('15529','2013-04-12','11:20:00',2.27),('15529','2013-04-12','11:25:00',2.2),('15529','2013-04-12','11:30:00',1.99),('15529','2013-04-12','11:35:00',1.91),('15529','2013-04-12','11:40:00',2.16),('15529','2013-04-12','11:45:00',2.26),('15529','2013-04-12','11:50:00',2.37),('15529','2013-04-12','11:55:00',1.97),('15529','2013-04-12','12:00:00',2.25),('15529','2013-04-12','12:10:00',2.17),('15529','2013-04-12','12:15:00',1.96),('15529','2013-04-12','12:20:00',2.39),('15529','2013-04-12','12:25:00',2.44),('15529','2013-04-12','12:30:00',2.05),('15529','2013-04-12','12:35:00',2.4),('15529','2013-04-12','12:40:00',2.42),('15529','2013-04-12','12:45:00',2.23),('15529','2013-04-12','12:50:00',2.24),('15529','2013-04-12','12:55:00',2.18),('15529','2013-04-12','13:00:00',2.34),('15529','2013-04-12','13:05:00',2.38),('15529','2013-04-12','13:10:00',2.37),('15529','2013-04-12','13:15:00',2.27),('15529','2013-04-12','13:20:00',2.3),('15529','2013-04-12','13:25:00',2.33),('15529','2013-04-12','13:30:00',2.22),('15529','2013-04-12','13:35:00',1.99),('15529','2013-04-12','13:40:00',1.99),('15529','2013-04-12','13:45:00',1.69),('15529','2013-04-12','13:50:00',1.96),('15529','2013-04-12','13:55:00',1.95),('15529','2013-04-12','14:00:00',1.87),('15529','2013-04-12','14:05:00',1.92),('15529','2013-04-12','14:10:00',1.68),('15529','2013-04-12','14:15:00',1.76),('15529','2013-04-12','14:20:00',1.46),('15529','2013-04-12','14:25:00',1.8),('15529','2013-04-12','14:30:00',2.03),('15529','2013-04-12','14:35:00',2.06),('15529','2013-04-12','14:40:00',2.05),('15529','2013-04-12','14:45:00',2.06),('15529','2013-04-12','14:50:00',1.97),('15529','2013-04-12','14:55:00',1.87),('15529','2013-04-12','15:00:00',1.76),('15529','2013-04-12','15:05:00',1.59),('15529','2013-04-12','15:10:00',1.67),('15529','2013-04-12','15:15:00',1.58),('15529','2013-04-12','15:20:00',1.55),('15529','2013-04-12','15:25:00',1.44),('15529','2013-04-12','15:30:00',1.46),('15529','2013-04-12','15:35:00',1.44),('15529','2013-04-12','15:40:00',1.51),('15529','2013-04-12','15:45:00',1.53),('15529','2013-04-12','15:50:00',1.46),('15529','2013-04-12','15:55:00',1.48),('15529','2013-04-12','16:00:00',1.45),('15529','2013-04-12','16:05:00',1.34),('15529','2013-04-12','16:10:00',1.32),('15529','2013-04-12','16:15:00',1.29),('15529','2013-04-12','16:20:00',1.24),('15529','2013-04-12','16:25:00',1.14),('15529','2013-04-12','16:30:00',1.08),('15529','2013-04-12','16:35:00',1.03),('15529','2013-04-12','17:10:00',1.02),('15529','2013-04-12','17:15:00',1.06),('15529','2013-04-12','17:25:00',1.01),('15529','2013-04-11','09:50:00',1.39),('15529','2013-04-11','09:55:00',1.18),('15529','2013-04-11','10:00:00',1.32),('15529','2013-04-11','10:55:00',1.11),('15529','2013-04-11','11:00:00',1.65),('15529','2013-04-11','11:05:00',1.09),('15529','2013-04-11','11:15:00',1.35),('15529','2013-04-11','11:20:00',1.12),('15529','2013-04-11','11:30:00',1.41),('15529','2013-04-11','11:35:00',2.25),('15529','2013-04-11','11:40:00',2.35),('15529','2013-04-11','11:45:00',2.27),('15529','2013-04-11','11:50:00',2.25),('15529','2013-04-11','11:55:00',2.26),('15529','2013-04-11','12:00:00',2.19),('15529','2013-04-11','12:05:00',2.2),('15529','2013-04-11','12:10:00',2.22),('15529','2013-04-11','12:15:00',2.34),('15529','2013-04-11','12:20:00',2.38),('15529','2013-04-11','12:25:00',2.39),('15529','2013-04-11','12:30:00',2.37),('15529','2013-04-11','12:35:00',2.35),('15529','2013-04-11','12:40:00',2.32),('15529','2013-04-11','12:45:00',2.32),('15529','2013-04-11','12:50:00',2.2),('15529','2013-04-11','12:55:00',2.27),('15529','2013-04-11','13:00:00',2.42),('15529','2013-04-11','13:05:00',2.19),('15529','2013-04-11','13:10:00',2.39),('15529','2013-04-11','13:15:00',2.4),('15529','2013-04-11','13:20:00',2.37),('15529','2013-04-11','13:25:00',2.37),('15529','2013-04-11','13:30:00',2.34),('15529','2013-04-11','13:35:00',2.35),('15529','2013-04-11','13:40:00',2.31),('15529','2013-04-11','13:45:00',2.26),('15529','2013-04-11','13:50:00',2.3),('15529','2013-04-11','13:55:00',2.27),('15529','2013-04-11','14:00:00',2.29),('15529','2013-04-11','14:05:00',2.23),('15529','2013-04-11','14:10:00',2.22),('15529','2013-04-11','14:15:00',2.23),('15529','2013-04-11','14:20:00',2.23),('15529','2013-04-11','14:25:00',2.22),('15529','2013-04-11','14:30:00',2.19),('15529','2013-04-11','14:35:00',2.15),('15529','2013-04-11','14:40:00',2.14),('15529','2013-04-11','14:45:00',2.1),('15529','2013-04-11','14:50:00',2.09),('15529','2013-04-11','14:55:00',2.06),('15529','2013-04-11','15:00:00',2.03),('15529','2013-04-11','15:05:00',2),('15529','2013-04-11','15:10:00',2),('15529','2013-04-11','15:15:00',1.97),('15529','2013-04-11','15:20:00',1.94),('15529','2013-04-11','15:25:00',1.93),('15529','2013-04-11','15:30:00',1.89),('15529','2013-04-11','15:35:00',1.87),('15529','2013-04-11','15:40:00',1.84),('15529','2013-04-11','15:45:00',1.81),('15529','2013-04-11','15:50:00',1.77),('15529','2013-04-11','15:55:00',1.75),('15529','2013-04-11','16:00:00',1.72),('15529','2013-04-11','16:05:00',1.69),('15529','2013-04-11','16:10:00',1.57),('15529','2013-04-11','16:15:00',1.52),('15529','2013-04-11','16:20:00',1.55),('15529','2013-04-11','16:25:00',1.51),('15529','2013-04-11','16:40:00',1.3),('15529','2013-04-11','16:45:00',1.37),('15529','2013-04-11','16:50:00',1.29),('15529','2013-04-11','16:55:00',1.24),('15529','2013-04-11','17:00:00',1.18),('15529','2013-04-11','17:05:00',1.15),('15529','2013-04-11','17:10:00',1.09),('15529','2013-04-11','17:15:00',1.01),('15529','2014-03-27','08:00:00',1.01),('15529','2014-03-27','08:05:00',1.07),('15529','2014-03-27','08:10:00',1.13),('15529','2014-03-27','08:15:00',1.18),('15529','2014-03-27','08:20:00',1.22),('15529','2014-03-27','08:25:00',1.27),('15529','2014-03-27','08:30:00',1.31),('15529','2014-03-27','08:35:00',1.36),('15529','2014-03-27','08:40:00',1.41),('15529','2014-03-27','08:45:00',1.44),('15529','2014-03-27','08:50:00',1.5),('15529','2014-03-27','08:55:00',1.55),('15529','2014-03-27','09:00:00',1.6),('15529','2014-03-27','09:05:00',1.68),('15529','2014-03-27','09:10:00',1.76),('15529','2014-03-27','09:15:00',1.72),('15529','2014-03-27','09:20:00',1.74),('15529','2014-03-27','09:25:00',1.84),('15529','2014-03-27','09:30:00',2),('15529','2014-03-27','09:35:00',1.58),('15529','2014-03-27','09:40:00',1.29),('15529','2014-03-27','09:45:00',1.08),('15529','2014-03-27','09:50:00',1.88),('15529','2014-03-27','09:55:00',1.94),('15529','2014-03-27','10:00:00',2.01),('15529','2014-03-27','10:05:00',2.09),('15529','2014-03-27','10:10:00',2.07),('15529','2014-03-27','10:15:00',1.62),('15529','2014-03-27','10:20:00',1.82),('15529','2014-03-27','10:25:00',1.84),('15529','2014-03-27','10:30:00',1.97),('15529','2014-03-27','10:35:00',1.6),('15529','2014-03-27','10:40:00',1.93),('15529','2014-03-27','10:45:00',2.23),('15529','2014-03-27','10:50:00',2.22),('15529','2014-03-27','10:55:00',2.11),('15529','2014-03-27','11:00:00',2.22),('15529','2014-03-27','11:05:00',2.32),('15529','2014-03-27','11:10:00',1.82),('15529','2014-03-27','11:15:00',2.42),('15529','2014-03-27','11:20:00',1.83),('15529','2014-03-27','11:25:00',1.39),('15529','2014-03-27','11:30:00',2.33),('15529','2014-03-27','11:35:00',1.66),('15529','2014-03-27','11:40:00',1.79),('15529','2014-03-27','11:45:00',1.77),('15529','2014-03-27','11:50:00',2.63),('15529','2014-03-27','11:55:00',1.7),('15529','2014-03-27','12:00:00',1.06),('15529','2014-03-27','12:05:00',1.8),('15529','2014-03-27','12:10:00',1.04),('15529','2014-03-27','12:20:00',2.13),('15529','2014-03-27','12:25:00',2.17),('15529','2014-03-27','12:40:00',1.64),('15529','2014-03-27','12:45:00',2.45),('15529','2014-03-27','12:50:00',2.32),('15529','2014-03-27','12:55:00',2.61),('15529','2014-03-27','13:15:00',1.17),('15529','2014-03-27','13:20:00',1.56),('15529','2014-03-27','13:25:00',1.51),('15529','2014-03-27','13:30:00',1.82),('15529','2014-03-27','13:35:00',1.55),('15529','2014-03-27','13:40:00',2.01),('15529','2014-03-27','13:45:00',2.31),('15529','2014-03-27','13:50:00',2.21),('15529','2014-03-27','13:55:00',2.11),('15529','2014-03-27','14:00:00',2.15),('15529','2014-03-27','14:05:00',2.13),('15529','2014-03-27','14:10:00',2.11),('15529','2014-03-27','14:15:00',2.08),('15529','2014-03-27','14:20:00',2.04),('15529','2014-03-27','14:25:00',2.01),('15529','2014-03-27','14:30:00',1.97),('15529','2014-03-27','14:35:00',1.94),('15529','2014-03-27','14:40:00',1.91),('15529','2014-03-27','14:45:00',1.9),('15529','2014-03-27','14:50:00',1.86),('15529','2014-03-27','14:55:00',1.83),('15529','2014-03-27','15:00:00',1.79),('15529','2014-03-27','15:05:00',1.76),('15529','2014-03-27','15:10:00',1.71),('15529','2014-03-27','15:15:00',1.68),('15529','2014-03-27','15:20:00',1.63),('15529','2014-03-27','15:25:00',1.58),('15529','2014-03-27','15:30:00',1.54),('15529','2014-03-27','15:35:00',1.5),('15529','2014-03-27','15:40:00',1.45),('15529','2014-03-27','15:45:00',1.43),('15529','2014-03-27','15:50:00',1.38),('15529','2014-03-27','15:55:00',1.33),('15529','2014-03-27','16:00:00',1.31),('15529','2014-03-27','16:05:00',1.3),('15529','2014-03-27','16:10:00',1.25),('15529','2014-03-27','16:15:00',1.2),('15529','2014-03-27','16:20:00',1.07),('15529','2013-04-10','08:55:00',1.03),('15529','2013-04-10','09:00:00',1.09),('15529','2013-04-10','09:05:00',1.13),('15529','2013-04-10','09:10:00',1.18),('15529','2013-04-10','09:15:00',1.22),('15529','2013-04-10','09:20:00',1.26),('15529','2013-04-10','09:25:00',1.31),('15529','2013-04-10','09:30:00',1.34),('15529','2013-04-10','09:35:00',1.46),('15529','2013-04-10','09:40:00',1.48),('15529','2013-04-10','09:45:00',1.5),('15529','2013-04-10','09:50:00',1.54),('15529','2013-04-10','09:55:00',1.62),('15529','2013-04-10','10:00:00',1.67),('15529','2013-04-10','10:05:00',1.77),('15529','2013-04-10','10:10:00',1.81),('15529','2013-04-10','10:15:00',1.29),('15529','2013-04-10','10:20:00',1.07),('15529','2013-04-10','10:25:00',1.36),('15529','2013-04-10','10:30:00',1.09),('15529','2013-04-10','10:45:00',2),('15529','2013-04-10','10:50:00',2.12),('15529','2013-04-10','10:55:00',2.24),('15529','2013-04-10','11:00:00',1.81),('15529','2013-04-10','11:05:00',1.02),('15529','2013-04-10','11:10:00',1.6),('15529','2013-04-10','11:15:00',2.24),('15529','2013-04-10','11:20:00',2.29),('15529','2013-04-10','11:25:00',1.6),('15529','2013-04-10','11:35:00',1.06),('15529','2013-04-10','11:40:00',2.33),('15529','2013-04-10','11:50:00',1.07),('15529','2013-04-10','11:55:00',2.52),('15529','2013-04-10','12:00:00',2.26),('15529','2013-04-10','12:05:00',2.03),('15529','2013-04-10','12:10:00',2.39),('15529','2013-04-10','12:15:00',2.38),('15529','2013-04-10','12:20:00',2.33),('15529','2013-04-10','12:25:00',2.13),('15529','2013-04-10','12:30:00',1.28),('15529','2013-04-10','12:35:00',2.49),('15529','2013-04-10','12:40:00',2.43),('15529','2013-04-10','12:45:00',2.48),('15529','2013-04-10','12:50:00',2.47),('15529','2013-04-10','13:00:00',2.51),('15529','2013-04-10','13:05:00',2.56),('15529','2013-04-10','13:10:00',1.75),('15529','2013-04-10','13:15:00',2.1),('15529','2013-04-10','13:20:00',2.02),('15529','2013-04-10','13:25:00',2.5),('15529','2013-04-10','13:30:00',2.47),('15529','2013-04-10','13:35:00',2.44),('15529','2013-04-10','13:40:00',1.98),('15529','2013-04-10','13:45:00',2.4),('15529','2013-04-10','13:50:00',2.35),('15529','2013-04-10','13:55:00',2.35),('15529','2013-04-10','14:00:00',2.02),('15529','2013-04-10','14:05:00',2.34),('15529','2013-04-10','14:10:00',2.33),('15529','2013-04-10','14:15:00',2.34),('15529','2013-04-10','14:20:00',2.27),('15529','2013-04-10','14:25:00',2.26),('15529','2013-04-10','14:30:00',2.26),('15529','2013-04-10','14:35:00',2.25),('15529','2013-04-10','14:40:00',2.19),('15529','2013-04-10','14:45:00',2.24),('15529','2013-04-10','14:50:00',2.14),('15529','2013-04-10','14:55:00',1.98),('15529','2013-04-10','15:00:00',2.11),('15529','2013-04-10','15:05:00',2.07),('15529','2013-04-10','15:10:00',2.05),('15529','2013-04-10','15:15:00',2.02),('15529','2013-04-10','15:20:00',2),('15529','2013-04-10','15:25:00',1.94),('15529','2013-04-10','15:30:00',1.93),('15529','2013-04-10','15:35:00',1.9),('15529','2013-04-10','15:40:00',1.86),('15529','2013-04-10','15:45:00',1.83),('15529','2013-04-10','15:50:00',1.8),('15529','2013-04-10','15:55:00',1.76),('15529','2013-04-10','16:00:00',1.74),('15529','2013-04-10','16:05:00',1.7),('15529','2013-04-10','16:10:00',1.67),('15529','2013-04-10','16:15:00',1.63),('15529','2013-04-10','16:20:00',1.59),('15529','2013-04-10','16:25:00',1.55),('15529','2013-04-10','16:30:00',1.5),('15529','2013-04-10','16:35:00',1.46),('15529','2013-04-10','16:40:00',1.41),('15529','2013-04-10','16:45:00',1.37),('15529','2013-04-10','16:50:00',1.33),('15529','2013-04-10','16:55:00',1.27),('15529','2013-04-10','17:00:00',1.23),('15529','2013-04-10','17:05:00',1.19),('15529','2013-04-10','17:10:00',1.13),('15529','2013-04-10','17:15:00',1.08),('15529','2013-04-10','17:20:00',1.03),('15529','2013-04-09','08:50:00',1.08),('15529','2013-04-09','08:55:00',1.15),('15529','2013-04-09','09:00:00',1.23),('15529','2013-04-09','09:05:00',1.35),('15529','2013-04-09','09:10:00',1.35),('15529','2013-04-09','09:15:00',1.19),('15529','2013-04-09','09:20:00',1.08),('15529','2013-04-09','09:25:00',1.34),('15529','2013-04-09','09:30:00',1.4),('15529','2013-04-09','09:35:00',1.44),('15529','2013-04-09','09:40:00',1.5),('15529','2013-04-09','09:45:00',1.55),('15529','2013-04-09','09:50:00',1.59),('15529','2013-04-09','09:55:00',1.65),('15529','2013-04-09','10:00:00',1.7),('15529','2013-04-09','10:05:00',1.77),('15529','2013-04-09','10:10:00',1.87),('15529','2013-04-09','10:15:00',1.91),('15529','2013-04-09','10:20:00',1.94),('15529','2013-04-09','10:25:00',1.95),('15529','2013-04-09','10:30:00',1.95),('15529','2013-04-09','10:35:00',1.97),('15529','2013-04-09','10:40:00',1.99),('15529','2013-04-09','10:45:00',2.02),('15529','2013-04-09','10:50:00',1.81),('15529','2013-04-09','10:55:00',1.98),('15529','2013-04-09','11:00:00',1.96),('15529','2013-04-09','11:05:00',1.93),('15529','2013-04-09','11:10:00',2.02),('15529','2013-04-09','11:15:00',2.02),('15529','2013-04-09','11:20:00',2.13),('15529','2013-04-09','11:25:00',2.22),('15529','2013-04-09','11:30:00',1.62),('15529','2013-04-09','11:35:00',2.34),('15529','2013-04-09','11:40:00',2.27),('15529','2013-04-09','11:45:00',2.28),('15529','2013-04-09','11:50:00',2.31),('15529','2013-04-09','11:55:00',2.1),('15529','2013-04-09','12:00:00',2.19),('15529','2013-04-09','12:05:00',2.21),('15529','2013-04-09','12:10:00',2.48),('15529','2013-04-09','12:15:00',2.54),('15529','2013-04-09','12:20:00',2.02),('15529','2013-04-09','12:25:00',2.62),('15529','2013-04-09','12:30:00',2.25),('15529','2013-04-09','12:35:00',2.46),('15529','2013-04-09','12:40:00',1.88),('15529','2013-04-09','12:45:00',1.85),('15529','2013-04-09','12:50:00',1.26),('15529','2013-04-09','12:55:00',2.02),('15529','2013-04-09','13:00:00',1.55),('15529','2013-04-09','13:05:00',2.6),('15529','2013-04-09','13:10:00',2.31),('15529','2013-04-09','13:15:00',2.26),('15529','2013-04-09','13:20:00',1.81),('15529','2013-04-09','13:25:00',1.79),('15529','2013-04-09','13:30:00',2.42),('15529','2013-04-09','13:35:00',2.09),('15529','2013-04-09','13:40:00',2.02),('15529','2013-04-09','13:45:00',1.53),('15529','2013-04-09','13:50:00',1.53),('15529','2013-04-09','13:55:00',2.39),('15529','2013-04-09','14:00:00',2.32),('15529','2013-04-09','14:05:00',1.99),('15529','2013-04-09','14:10:00',2.27),('15529','2013-04-09','14:15:00',2.03),('15529','2013-04-09','14:20:00',1.13),('15529','2013-04-09','14:25:00',1.65),('15529','2013-04-09','14:30:00',1.55),('15529','2013-04-09','14:35:00',1.39),('15529','2013-04-09','14:40:00',1.54),('15529','2013-04-09','14:45:00',1.98),('15529','2013-04-09','14:50:00',1.87),('15529','2013-04-09','14:55:00',1.91),('15529','2013-04-09','15:00:00',2.2),('15529','2013-04-09','15:05:00',2.14),('15529','2013-04-09','15:10:00',2.1),('15529','2013-04-09','15:15:00',2.07),('15529','2013-04-09','15:20:00',1.65),('15529','2013-04-09','15:25:00',2.01),('15529','2013-04-09','15:30:00',1.94),('15529','2013-04-09','15:35:00',1.94),('15529','2013-04-09','15:40:00',1.89),('15529','2013-04-09','15:45:00',1.84),('15529','2013-04-09','15:50:00',1.41),('15529','2013-04-09','15:55:00',1.75),('15529','2013-04-09','16:00:00',1.81),('15529','2013-04-09','16:05:00',1.76),('15529','2013-04-09','16:10:00',1.58),('15529','2013-04-09','16:15:00',1.69),('15529','2013-04-09','16:20:00',1.63),('15529','2013-04-09','16:25:00',1.59),('15529','2013-04-09','16:30:00',1.59),('15529','2013-04-09','16:35:00',1.56),('15529','2013-04-09','16:40:00',1.47),('15529','2013-04-09','16:45:00',1.32),('15529','2013-04-09','16:50:00',1.34),('15529','2013-04-09','16:55:00',1.15),('15529','2013-04-09','17:00:00',1.16),('15529','2013-04-09','17:05:00',1.06),('15529','2013-04-09','17:15:00',1.11),('15529','2013-04-08','09:40:00',1.05),('15529','2013-04-08','09:45:00',1.28),('15529','2013-04-08','09:50:00',1.57),('15529','2013-04-08','09:55:00',1.24),('15529','2013-04-08','10:30:00',1.4),('15529','2013-04-08','10:35:00',2.06),('15529','2013-04-08','10:40:00',1.56),('15529','2013-04-08','10:45:00',2.13),('15529','2013-04-08','10:50:00',2.22),('15529','2013-04-08','10:55:00',1.11),('15529','2013-04-08','11:00:00',1.14),('15529','2013-04-08','11:05:00',2.15),('15529','2013-04-08','11:15:00',1.28),('15529','2013-04-08','11:20:00',2.02),('15529','2013-04-08','11:40:00',1.66),('15529','2013-04-08','11:45:00',2.66),('15529','2013-04-08','11:50:00',1.37),('15529','2013-04-08','11:55:00',2.59),('15529','2013-04-08','12:00:00',2.52),('15529','2013-04-08','12:05:00',1.35),('15529','2013-04-08','12:10:00',2.15),('15529','2013-04-08','12:15:00',2.09),('15529','2013-04-08','12:20:00',2.17),('15529','2013-04-08','12:25:00',2.07),('15529','2013-04-08','12:30:00',2.07),('15529','2013-04-08','12:35:00',2.11),('15529','2013-04-08','12:40:00',2.03),('15529','2013-04-08','12:45:00',2.53),('15529','2013-04-08','12:50:00',2.53),('15529','2013-04-08','12:55:00',2.51),('15529','2013-04-08','13:00:00',1.89),('15529','2013-04-08','13:05:00',2.15),('15529','2013-04-08','13:10:00',2.81),('15529','2013-04-08','13:15:00',2.69),('15529','2013-04-08','13:20:00',2.19),('15529','2013-04-08','13:25:00',1.84),('15529','2013-04-08','13:30:00',1.65),('15529','2013-04-08','13:35:00',1.71),('15529','2013-04-08','13:40:00',1.32),('15529','2013-04-08','13:45:00',1.66),('15529','2013-04-08','13:50:00',2.34),('15529','2013-04-08','13:55:00',1.67),('15529','2013-04-08','14:00:00',2.34),('15529','2013-04-08','14:05:00',2.09),('15529','2013-04-08','14:10:00',1.25),('15529','2013-04-08','14:15:00',2.14),('15529','2013-04-08','14:20:00',1.9),('15529','2013-04-08','14:25:00',1.82),('15529','2013-04-08','14:30:00',2.19),('15529','2013-04-08','14:35:00',2.11),('15529','2013-04-08','14:40:00',2.12),('15529','2013-04-08','14:45:00',1.96),('15529','2013-04-08','14:50:00',2.04),('15529','2013-04-08','14:55:00',2.22),('15529','2013-04-08','15:00:00',2.24),('15529','2013-04-08','15:05:00',2.15),('15529','2013-04-08','15:10:00',2.1),('15529','2013-04-08','15:15:00',2.15),('15529','2013-04-08','15:20:00',2.15),('15529','2013-04-08','15:25:00',2.11),('15529','2013-04-08','15:30:00',1.79),('15529','2013-04-08','15:35:00',1.44),('15529','2013-04-08','15:40:00',1.99),('15529','2013-04-08','15:45:00',2.01),('15529','2013-04-08','15:50:00',1.95),('15529','2013-04-08','15:55:00',1.46),('15529','2013-04-08','16:00:00',1.47),('15529','2013-04-08','16:05:00',1.87),('15529','2013-04-08','16:10:00',1.82),('15529','2013-04-08','16:15:00',1.65),('15529','2013-04-08','16:30:00',1.51),('15529','2013-04-08','16:45:00',1.03),('15529','2013-04-08','16:50:00',1.35),('15529','2013-04-07','09:15:00',1.33),('15529','2013-04-07','09:20:00',1.31),('15529','2013-04-07','09:25:00',1.43),('15529','2013-04-07','09:30:00',1.48),('15529','2013-04-07','09:35:00',1.59),('15529','2013-04-07','09:40:00',1.51),('15529','2013-04-07','09:45:00',1.39),('15529','2013-04-07','09:55:00',1.34),('15529','2013-04-07','10:00:00',1.72),('15529','2013-04-07','10:05:00',1.56),('15529','2013-04-07','10:10:00',1.76),('15529','2013-04-07','10:15:00',1.77),('15529','2013-04-07','10:20:00',1.81),('15529','2013-04-07','10:25:00',1.78),('15529','2013-04-07','10:30:00',1.82),('15529','2013-04-07','10:35:00',1.73),('15529','2013-04-07','10:40:00',1.98),('15529','2013-04-07','10:45:00',2.02),('15529','2013-04-07','10:50:00',2.03),('15529','2013-04-07','10:55:00',1.92),('15529','2013-04-07','11:00:00',1.88),('15529','2013-04-07','11:05:00',1.75),('15529','2013-04-07','11:10:00',1.62),('15529','2013-04-07','11:15:00',1.32),('15529','2013-04-07','11:20:00',1.13),('15529','2013-04-07','11:25:00',1.09),('15529','2013-04-07','11:30:00',1.46),('15529','2013-04-07','11:35:00',1.73),('15529','2013-04-07','11:40:00',1.62),('15529','2013-04-07','11:45:00',1.47),('15529','2013-04-07','11:50:00',1.26),('15529','2013-04-07','11:55:00',1.21),('15529','2013-04-07','12:00:00',1.08),('15529','2013-04-07','12:05:00',1.12),('15529','2013-04-07','12:10:00',1.36),('15529','2013-04-07','12:15:00',1.52),('15529','2013-04-07','12:20:00',1.49),('15529','2013-04-07','12:25:00',1.51),('15529','2013-04-07','12:30:00',1.7),('15529','2013-04-07','12:35:00',1.54),('15529','2013-04-07','12:40:00',1.91),('15529','2013-04-07','12:45:00',1.56),('15529','2013-04-07','12:50:00',1.15),('15529','2013-04-07','12:55:00',1.84),('15529','2013-04-07','13:00:00',1.47),('15529','2013-04-07','13:05:00',1.21),('15529','2013-04-07','13:10:00',1.44),('15529','2013-04-07','13:15:00',1.81),('15529','2013-04-07','13:20:00',1.93),('15529','2013-04-07','13:25:00',1.63),('15529','2013-04-07','13:30:00',1.51),('15529','2013-04-07','13:35:00',1.93),('15529','2013-04-07','13:40:00',1.91),('15529','2013-04-07','13:45:00',1.54),('15529','2013-04-07','13:50:00',2.04),('15529','2013-04-07','13:55:00',2.26),('15529','2013-04-07','14:00:00',1.81),('15529','2013-04-07','14:05:00',1.67),('15529','2013-04-07','14:10:00',1.78),('15529','2013-04-07','14:15:00',2.17),('15529','2013-04-07','14:20:00',1.91),('15529','2013-04-07','14:25:00',2.2),('15529','2013-04-07','14:30:00',2.1),('15529','2013-04-07','14:35:00',1.89),('15529','2013-04-07','14:40:00',2.04),('15529','2013-04-07','14:45:00',2.08),('15529','2013-04-07','14:50:00',2.1),('15529','2013-04-07','14:55:00',1.9),('15529','2013-04-07','15:00:00',1.53),('15529','2013-04-07','15:05:00',1.9),('15529','2013-04-07','15:10:00',1.74),('15529','2013-04-07','15:15:00',1.44),('15529','2013-04-07','15:20:00',1.87),('15529','2013-04-07','15:25:00',2.1),('15529','2013-04-07','15:30:00',2.01),('15529','2013-04-07','15:35:00',1.94),('15529','2013-04-07','15:40:00',1.91),('15529','2013-04-07','15:45:00',1.86),('15529','2013-04-07','15:50:00',1.82),('15529','2013-04-07','15:55:00',1.79),('15529','2013-04-07','16:00:00',1.77),('15529','2013-04-07','16:05:00',1.62),('15529','2013-04-07','16:10:00',1.61),('15529','2013-04-07','16:15:00',1.66),('15529','2013-04-07','16:20:00',1.62),('15529','2013-04-07','16:25:00',1.55),('15529','2013-04-07','16:30:00',1.53),('15529','2013-04-07','16:35:00',1.47),('15529','2013-04-07','16:40:00',1.46),('15529','2013-04-07','16:45:00',1.41),('15529','2013-04-07','16:50:00',1.36),('15529','2013-04-07','16:55:00',1.32),('15529','2013-04-07','17:00:00',1.28),('15529','2013-04-07','17:05:00',1.21),('15529','2013-04-07','17:10:00',1.13),('15529','2013-04-07','17:15:00',1.07),('15529','2013-04-07','17:20:00',1.03),('15529','2013-04-07','17:25:00',1.04),('15529','2013-04-06','09:40:00',1.02),('15529','2013-04-06','09:55:00',1.02),('15529','2013-04-06','10:00:00',1.2),('15529','2013-04-06','10:05:00',1.28),('15529','2013-04-06','10:10:00',1.46),('15529','2013-04-06','10:15:00',1.54),('15529','2013-04-06','10:20:00',1.54),('15529','2013-04-06','10:25:00',1.67),('15529','2013-04-06','10:30:00',1.67),('15529','2013-04-06','10:35:00',1.5),('15529','2013-04-06','10:40:00',1.44),('15529','2013-04-06','10:45:00',1.53),('15529','2013-04-06','10:50:00',1.54),('15529','2013-04-06','11:00:00',1.26),('15529','2013-04-06','11:05:00',1.15),('15529','2013-04-06','11:10:00',1.09),('15529','2013-04-06','11:15:00',1.07),('15529','2013-04-06','11:20:00',1.46),('15529','2013-04-06','11:25:00',1.98),('15529','2013-04-06','11:30:00',2.07),('15529','2013-04-06','11:35:00',2.12),('15529','2013-04-06','11:40:00',1.97),('15529','2013-04-06','11:45:00',1.85),('15529','2013-04-06','11:50:00',1.42),('15529','2013-04-06','11:55:00',1.27),('15529','2013-04-06','12:00:00',1.38),('15529','2013-04-06','12:05:00',1.33),('15529','2013-04-06','12:10:00',1.36),('15529','2013-04-06','12:15:00',1.44),('15529','2013-04-06','12:20:00',1.46),('15529','2013-04-06','12:25:00',1.6),('15529','2013-04-06','12:30:00',1.68),('15529','2013-04-06','12:35:00',1.48),('15529','2013-04-06','12:40:00',1.79),('15529','2013-04-06','12:45:00',1.51),('15529','2013-04-06','12:50:00',1.49),('15529','2013-04-06','12:55:00',1.39),('15529','2013-04-06','13:00:00',1.51),('15529','2013-04-06','13:05:00',1.65),('15529','2013-04-06','13:10:00',1.65),('15529','2013-04-06','13:15:00',1.62),('15529','2013-04-06','13:20:00',1.54),('15529','2013-04-06','13:25:00',1.6),('15529','2013-04-06','13:30:00',1.71),('15529','2013-04-06','13:35:00',1.85),('15529','2013-04-06','13:40:00',1.75),('15529','2013-04-06','13:45:00',1.52),('15529','2013-04-06','13:50:00',1.3),('15529','2013-04-06','13:55:00',1.49),('15529','2013-04-06','14:00:00',1.67),('15529','2013-04-06','14:05:00',1.98),('15529','2013-04-06','14:10:00',1.84),('15529','2013-04-06','14:15:00',1.71),('15529','2013-04-06','14:20:00',1.2),('15529','2013-04-06','15:20:00',1.27),('15529','2013-04-06','15:25:00',1.33),('15529','2013-04-06','15:30:00',1.37),('15529','2013-04-06','15:35:00',1.38),('15529','2013-04-06','15:40:00',1.4),('15529','2013-04-06','15:45:00',1.42),('15529','2013-04-06','15:50:00',1.41),('15529','2013-04-06','15:55:00',1.29),('15529','2013-04-06','16:00:00',1.12),('15529','2013-04-06','16:40:00',1.06),('15529','2013-04-06','16:45:00',1.23),('15529','2013-04-06','17:05:00',1.18),('15529','2013-04-06','17:25:00',1.07),('15529','2013-04-05','08:55:00',1.03),('15529','2013-04-05','09:00:00',1.09),('15529','2013-04-05','09:05:00',1.14),('15529','2013-04-05','09:10:00',1.19),('15529','2013-04-05','09:15:00',1.23),('15529','2013-04-05','09:20:00',1.28),('15529','2013-04-05','09:25:00',1.32),('15529','2013-04-05','09:30:00',1.36),('15529','2013-04-05','09:35:00',1.38),('15529','2013-04-05','09:40:00',1.44),('15529','2013-04-05','09:45:00',1.5),('15529','2013-04-05','09:50:00',1.54),('15529','2013-04-05','09:55:00',1.58),('15529','2013-04-05','10:00:00',1.61),('15529','2013-04-05','10:05:00',1.65),('15529','2013-04-05','10:10:00',1.69),('15529','2013-04-05','10:15:00',1.72),('15529','2013-04-05','10:20:00',1.76),('15529','2013-04-05','10:25:00',1.79),('15529','2013-04-05','10:30:00',1.79),('15529','2013-04-05','10:35:00',1.84),('15529','2013-04-05','10:40:00',1.86),('15529','2013-04-05','10:45:00',1.89),('15529','2013-04-05','10:50:00',1.93),('15529','2013-04-05','10:55:00',1.97),('15529','2013-04-05','11:00:00',1.98),('15529','2013-04-05','11:05:00',2.03),('15529','2013-04-05','11:10:00',2.06),('15529','2013-04-05','11:15:00',2.08),('15529','2013-04-05','11:20:00',2.11),('15529','2013-04-05','11:25:00',2.13),('15529','2013-04-05','11:30:00',1.94),('15529','2013-04-05','11:35:00',1.5),('15529','2013-04-05','11:40:00',2.21),('15529','2013-04-05','11:45:00',2.25),('15529','2013-04-05','11:50:00',2.18),('15529','2013-04-05','11:55:00',2.21),('15529','2013-04-05','12:00:00',2.2),('15529','2013-04-05','12:05:00',2.08),('15529','2013-04-05','12:10:00',2.29),('15529','2013-04-05','12:15:00',2.33),('15529','2013-04-05','12:20:00',2.31),('15529','2013-04-05','12:25:00',2.37),('15529','2013-04-05','12:30:00',2.36),('15529','2013-04-05','12:35:00',2.05),('15529','2013-04-05','12:40:00',2.15),('15529','2013-04-05','12:45:00',2.23),('15529','2013-04-05','12:50:00',1.87),('15529','2013-04-05','12:55:00',2.59),('15529','2013-04-05','13:00:00',2.52),('15529','2013-04-05','13:05:00',2.53),('15529','2013-04-05','13:15:00',1.31),('15529','2013-04-05','13:35:00',1.54),('15529','2013-04-05','13:40:00',1.01),('15529','2013-04-05','13:45:00',1.41),('15529','2013-04-05','13:55:00',1.34),('15529','2013-04-05','14:00:00',2.49),('15529','2013-04-05','14:05:00',2.3),('15529','2013-04-05','14:15:00',2.06),('15529','2013-04-05','14:20:00',2.03),('15529','2013-04-05','14:25:00',1.74),('15529','2013-04-05','14:35:00',2.23),('15529','2013-04-05','14:40:00',2.26),('15529','2013-04-05','14:45:00',2.27),('15529','2013-04-05','14:50:00',2.19),('15529','2013-04-05','14:55:00',1.9),('15529','2013-04-05','15:00:00',2.1),('15529','2013-04-05','15:05:00',2.05),('15529','2013-04-05','15:10:00',2),('15529','2013-04-05','15:15:00',1.98),('15529','2013-04-05','15:20:00',1.97),('15529','2013-04-05','15:25:00',1.95),('15529','2013-04-05','15:30:00',1.83),('15529','2013-04-05','15:35:00',1.81),('15529','2013-04-05','15:40:00',1.73),('15529','2013-04-05','15:45:00',1.67),('15529','2013-04-05','15:50:00',1.8),('15529','2013-04-05','15:55:00',1.72),('15529','2013-04-05','16:00:00',1.74),('15529','2013-04-05','16:05:00',1.76),('15529','2013-04-05','16:10:00',1.73),('15529','2013-04-05','16:15:00',1.6),('15529','2013-04-05','16:20:00',1.3),('15529','2013-04-05','16:25:00',1.23),('15529','2013-04-05','16:30:00',1.13),('15529','2013-04-05','16:35:00',1.13),('15529','2013-04-05','16:40:00',1.17),('15529','2013-04-05','16:45:00',1.32),('15529','2013-04-05','16:50:00',1.27),('15529','2013-04-05','16:55:00',1.18),('15529','2013-04-05','17:00:00',1.06),('15529','2013-04-04','09:15:00',1.16),('15529','2013-04-04','09:40:00',1.09),('15529','2013-04-04','10:10:00',1.52),('15529','2013-04-04','10:15:00',1.56),('15529','2013-04-04','10:20:00',1.84),('15529','2013-04-04','10:25:00',2.05),('15529','2013-04-04','10:30:00',1.94),('15529','2013-04-04','10:35:00',1.95),('15529','2013-04-04','10:40:00',1.4),('15529','2013-04-04','10:50:00',1.41),('15529','2013-04-04','10:55:00',1.95),('15529','2013-04-04','11:00:00',1.75),('15529','2013-04-04','11:05:00',1.84),('15529','2013-04-04','11:10:00',1.77),('15529','2013-04-04','11:15:00',2.03),('15529','2013-04-04','11:20:00',1.71),('15529','2013-04-04','11:25:00',1.74),('15529','2013-04-04','11:30:00',1.79),('15529','2013-04-04','11:35:00',2.36),('15529','2013-04-04','11:40:00',2.27),('15529','2013-04-04','11:45:00',2.03),('15529','2013-04-04','11:50:00',2.22),('15529','2013-04-04','11:55:00',2.12),('15529','2013-04-04','12:00:00',1.39),('15529','2013-04-04','12:05:00',1.26),('15529','2013-04-04','12:10:00',1.46),('15529','2013-04-04','12:20:00',1.21),('15529','2013-04-04','12:25:00',1.07),('15529','2013-04-04','12:40:00',1.03),('15529','2013-04-04','12:45:00',2.02),('15529','2013-04-04','12:50:00',2.49),('15529','2013-04-04','12:55:00',1.97),('15529','2013-04-04','13:00:00',1.89),('15529','2013-04-04','13:05:00',1.14),('15529','2013-04-04','13:10:00',1.51),('15529','2013-04-04','13:15:00',1.13),('15529','2013-04-04','13:20:00',1.8),('15529','2013-04-04','13:25:00',1.01),('15529','2013-04-04','13:30:00',1.23),('15529','2013-04-04','13:35:00',2.49),('15529','2013-04-04','13:40:00',2.57),('15529','2013-04-04','13:45:00',2.47),('15529','2013-04-04','13:50:00',2.03),('15529','2013-04-04','13:55:00',2.48),('15529','2013-04-04','14:00:00',1.61),('15529','2013-04-04','14:05:00',1.98),('15529','2013-04-04','14:10:00',2.2),('15529','2013-04-04','14:15:00',1.28),('15529','2013-04-04','14:20:00',1.31),('15529','2013-04-04','14:25:00',1.82),('15529','2013-04-04','14:30:00',2.45),('15529','2013-04-04','14:35:00',1.63),('15529','2013-04-04','14:40:00',2.21),('15529','2013-04-04','14:45:00',1.78),('15529','2013-04-04','14:50:00',1.29),('15529','2013-04-04','15:00:00',1.04),('15529','2013-04-04','15:05:00',1.11),('15529','2013-04-04','16:50:00',1.06),('15529','2013-04-04','17:05:00',1.69),('15529','2013-04-04','17:10:00',1.43),('15529','2013-04-04','17:20:00',1.25),('15529','2013-04-04','17:25:00',1.12),('15529','2013-04-03','09:00:00',1.01),('15529','2013-04-03','09:30:00',1),('15529','2013-04-03','09:35:00',1.38),('15529','2013-04-03','09:40:00',1.04),('15529','2013-04-03','10:00:00',1.02),('15529','2013-04-03','10:05:00',1.23),('15529','2013-04-03','10:20:00',1.17),('15529','2013-04-03','10:25:00',1.9),('15529','2013-04-03','10:30:00',1.29),('15529','2013-04-03','10:35:00',1.18),('15529','2013-04-03','10:40:00',1.79),('15529','2013-04-03','10:50:00',1.42),('15529','2013-04-03','10:55:00',2.08),('15529','2013-04-03','11:35:00',1.07),('15529','2013-04-03','11:40:00',1.72),('15529','2013-04-03','11:45:00',1.91),('15529','2013-04-03','11:50:00',2.12),('15529','2013-04-03','11:55:00',2.2),('15529','2013-04-03','12:00:00',1.65),('15529','2013-04-03','12:05:00',2.19),('15529','2013-04-03','12:10:00',2.1),('15529','2013-04-03','12:15:00',2.12),('15529','2013-04-03','12:20:00',1.63),('15529','2013-04-03','12:25:00',1.86),('15529','2013-04-03','12:30:00',2.06),('15529','2013-04-03','12:35:00',1.94),('15529','2013-04-03','12:40:00',1.63),('15529','2013-04-03','12:45:00',1.44),('15529','2013-04-03','12:50:00',2.25),('15529','2013-04-03','12:55:00',2.05),('15529','2013-04-03','13:00:00',2.09),('15529','2013-04-03','13:05:00',2.17),('15529','2013-04-03','13:10:00',2.2),('15529','2013-04-03','13:15:00',2.24),('15529','2013-04-03','13:20:00',2.18),('15529','2013-04-03','13:25:00',2.25),('15529','2013-04-03','13:30:00',2.16),('15529','2013-04-03','13:35:00',1.94),('15529','2013-04-03','13:40:00',1.75),('15529','2013-04-03','13:45:00',1.76),('15529','2013-04-03','13:50:00',1.71),('15529','2013-04-03','13:55:00',1.28),('15529','2013-04-03','14:00:00',1.51),('15529','2013-04-03','14:05:00',2),('15529','2013-04-03','14:10:00',2.13),('15529','2013-04-03','14:15:00',2.13),('15529','2013-04-03','14:20:00',2.09),('15529','2013-04-03','14:25:00',2.05),('15529','2013-04-03','14:30:00',2.07),('15529','2013-04-03','14:35:00',2.07),('15529','2013-04-03','14:40:00',2.04),('15529','2013-04-03','14:45:00',1.98),('15529','2013-04-03','14:50:00',2.03),('15529','2013-04-03','14:55:00',2),('15529','2013-04-03','15:00:00',1.94),('15529','2013-04-03','15:05:00',1.85),('15529','2013-04-03','15:10:00',1.71),('15529','2013-04-03','15:15:00',1.82),('15529','2013-04-03','15:20:00',1.79),('15529','2013-04-03','15:25:00',1.84),('15529','2013-04-03','15:30:00',1.8),('15529','2013-04-03','15:35:00',1.75),('15529','2013-04-03','15:40:00',1.69),('15529','2013-04-03','15:45:00',1.64),('15529','2013-04-03','15:50:00',1.6),('15529','2013-04-03','15:55:00',1.6),('15529','2013-04-03','16:00:00',1.56),('15529','2013-04-03','16:05:00',1.48),('15529','2013-04-03','16:10:00',1.44),('15529','2013-04-03','16:15:00',1.25),('15529','2013-04-03','16:20:00',1.32),('15529','2013-04-03','16:25:00',1.26),('15529','2013-04-03','16:30:00',1.03),('15529','2013-04-03','16:40:00',1.14),('15529','2013-04-02','08:55:00',1.05),('15529','2013-04-02','09:00:00',1.14),('15529','2013-04-02','09:05:00',1.02),('15529','2013-04-02','09:10:00',1.09),('15529','2013-04-02','09:15:00',1.17),('15529','2013-04-02','09:25:00',1.21),('15529','2013-04-02','09:30:00',1.55),('15529','2013-04-02','09:35:00',1.44),('15529','2013-04-02','09:40:00',1.55),('15529','2013-04-02','09:45:00',1.65),('15529','2013-04-02','09:50:00',1.49),('15529','2013-04-02','09:55:00',1.22),('15529','2013-04-02','10:10:00',1.43),('15529','2013-04-02','10:15:00',1.23),('15529','2013-04-02','10:20:00',1.68),('15529','2013-04-02','10:25:00',1.81),('15529','2013-04-02','10:30:00',2.09),('15529','2013-04-02','10:35:00',1.07),('15529','2013-04-02','10:50:00',1.3),('15529','2013-04-02','10:55:00',2.27),('15529','2013-04-02','11:00:00',2.35),('15529','2013-04-02','11:05:00',2.53),('15529','2013-04-02','11:10:00',2.09),('15529','2013-04-02','11:15:00',1.25),('15529','2013-04-02','11:25:00',1.12),('15529','2013-04-02','11:30:00',1.16),('15529','2013-04-02','11:40:00',1.32),('15529','2013-04-02','11:45:00',1.56),('15529','2013-04-02','11:50:00',1.18),('15529','2013-04-02','11:55:00',1.22),('15529','2013-04-02','12:00:00',2.04),('15529','2013-04-02','12:05:00',2.51),('15529','2013-04-02','12:10:00',2.49),('15529','2013-04-02','12:15:00',1.74),('15529','2013-04-02','12:20:00',2.49),('15529','2013-04-02','12:25:00',2.62),('15529','2013-04-02','12:30:00',2.31),('15529','2013-04-02','12:35:00',2.63),('15529','2013-04-02','12:40:00',2.16),('15529','2013-04-02','12:45:00',2.27),('15529','2013-04-02','12:50:00',2.11),('15529','2013-04-02','12:55:00',2.04),('15529','2013-04-02','13:00:00',2.03),('15529','2013-04-02','13:05:00',2.27),('15529','2013-04-02','13:10:00',2.43),('15529','2013-04-02','13:15:00',1.23),('15529','2013-04-02','13:20:00',1.71),('15529','2013-04-02','13:25:00',2.11),('15529','2013-04-02','13:30:00',2.12),('15529','2013-04-02','13:35:00',1.81),('15529','2013-04-02','13:40:00',2.1),('15529','2013-04-02','13:45:00',2.49),('15529','2013-04-02','13:50:00',2.02),('15529','2013-04-02','13:55:00',1.86),('15529','2013-04-02','14:00:00',2.43),('15529','2013-04-02','14:05:00',2.29),('15529','2013-04-02','14:10:00',1.19),('15529','2013-04-02','14:15:00',1.57),('15529','2013-04-02','14:20:00',2.12),('15529','2013-04-02','14:25:00',2.09),('15529','2013-04-02','14:30:00',1.55),('15529','2013-04-02','14:35:00',2.27),('15529','2013-04-02','14:40:00',1.39),('15529','2013-04-02','14:45:00',2.55),('15529','2013-04-02','14:50:00',2.51),('15529','2013-04-02','14:55:00',2.25),('15529','2013-04-02','15:00:00',2.32),('15529','2013-04-02','15:05:00',1.89),('15529','2013-04-02','15:10:00',2.37),('15529','2013-04-02','15:15:00',2.02),('15529','2013-04-02','15:20:00',2.19),('15529','2013-04-02','15:25:00',1.8),('15529','2013-04-02','15:30:00',1.46),('15529','2013-04-02','15:35:00',1.46),('15529','2013-04-02','15:40:00',1.5),('15529','2013-04-02','15:45:00',1.88),('15529','2013-04-02','15:50:00',2.13),('15529','2013-04-02','15:55:00',1.29),('15529','2013-04-02','16:00:00',1.31),('15529','2013-04-02','16:05:00',1.76),('15529','2013-04-02','16:10:00',1.85),('15529','2013-04-02','16:15:00',1.79),('15529','2013-04-02','16:20:00',1.71),('15529','2013-04-02','16:25:00',1.67),('15529','2013-04-02','16:30:00',1.65),('15529','2013-04-02','16:35:00',1.58),('15529','2013-04-02','16:40:00',1.49),('15529','2013-04-02','16:45:00',1.47),('15529','2013-04-02','16:50:00',1.43),('15529','2013-04-02','16:55:00',1.38),('15529','2013-04-02','17:00:00',1.33),('15529','2013-04-02','17:05:00',1.28),('15529','2013-04-02','17:10:00',1.2),('15529','2013-04-02','17:15:00',1.15),('15529','2013-04-02','17:20:00',1.09),('15529','2013-04-02','17:25:00',1.04),('15529','2013-04-01','09:00:00',1.1),('15529','2013-04-01','09:05:00',1.15),('15529','2013-04-01','09:10:00',1.2),('15529','2013-04-01','09:15:00',1.26),('15529','2013-04-01','09:20:00',1.29),('15529','2013-04-01','09:25:00',1.32),('15529','2013-04-01','09:30:00',1.07),('15529','2013-04-01','09:35:00',1.6),('15529','2013-04-01','09:40:00',1.57),('15529','2013-04-01','09:50:00',1.02),('15529','2013-04-01','09:55:00',1.59),('15529','2013-04-01','10:00:00',1.02),('15529','2013-04-01','10:10:00',1.27),('15529','2013-04-01','10:20:00',1.67),('15529','2013-04-01','10:35:00',2.07),('15529','2013-04-01','10:40:00',1.03),('15529','2013-04-01','10:45:00',1.29),('15529','2013-04-01','10:50:00',2.01),('15529','2013-04-01','11:00:00',1.18),('15529','2013-04-01','11:05:00',1.67),('15529','2013-04-01','11:20:00',1.89),('15529','2013-04-01','11:25:00',1.43),('15529','2013-04-01','11:30:00',2.22),('15529','2013-04-01','11:35:00',1.69),('15529','2013-04-01','12:05:00',2.02),('15529','2013-04-01','12:10:00',2.38),('15529','2013-04-01','12:35:00',1.24),('15529','2013-04-01','12:40:00',1.07),('15529','2013-04-01','12:45:00',1.65),('15529','2013-04-01','12:50:00',1.13),('15529','2013-04-01','12:55:00',1.67),('15529','2013-04-01','13:00:00',1.48),('15529','2013-04-01','13:05:00',1.41),('15529','2013-04-01','13:10:00',1.24),('15529','2013-04-01','13:15:00',1.14),('15529','2013-04-01','13:25:00',1.14),('15529','2013-04-01','13:30:00',1.04),('15529','2013-04-01','13:35:00',1.19),('15529','2013-04-01','13:40:00',1.62),('15529','2013-04-01','13:45:00',1.21),('15529','2013-04-01','14:05:00',1.48),('15529','2013-04-01','14:10:00',1.37),('15529','2013-04-01','14:15:00',1.41),('15529','2013-04-01','14:20:00',1.91),('15529','2013-04-01','14:25:00',2.45),('15529','2013-04-01','14:30:00',1.5),('15529','2013-04-01','14:35:00',1.33),('15529','2013-04-01','14:40:00',2.1),('15529','2013-04-01','14:45:00',1.53),('15529','2014-05-01','09:20:00',1.26),('15529','2014-05-01','09:25:00',1.05),('15529','2014-05-01','09:30:00',1.03),('15529','2014-05-01','09:35:00',1.23),('15529','2014-05-01','09:40:00',1.03),('15529','2014-05-01','10:00:00',1.14),('15529','2014-05-01','12:45:00',1.08),('15529','2014-05-01','12:50:00',1.01),('15529','2014-05-01','13:10:00',1.2),('15529','2014-05-01','13:15:00',2.21),('15529','2014-05-01','13:20:00',1.89),('15529','2014-05-01','13:25:00',1.85),('15529','2014-05-01','13:30:00',1.81),('15529','2014-05-01','13:35:00',1.25),('15529','2014-05-01','13:40:00',1.64),('15529','2014-05-01','13:45:00',1.44),('15529','2014-05-01','14:30:00',1.34),('15529','2014-05-01','14:35:00',1.15),('15529','2014-05-01','14:40:00',1.07),('15529','2014-05-01','14:55:00',1.31),('15529','2014-05-01','15:00:00',1.06),('15529','2014-05-01','15:05:00',1.36),('15529','2014-05-01','15:10:00',1.49),('15529','2014-05-01','15:15:00',1.19),('15529','2014-05-01','15:20:00',1.08),('15529','2014-05-01','15:55:00',1.06),('15529','2014-03-26','10:20:00',1.4),('15529','2014-03-26','10:25:00',1.41),('15529','2014-03-26','11:10:00',1.09),('15529','2014-03-26','13:10:00',1.13),('15529','2014-03-26','13:15:00',1.23),('15529','2014-03-26','13:20:00',1.2),('15529','2014-03-26','13:25:00',1.27),('15529','2014-03-26','13:35:00',1.01),('15529','2014-03-26','13:50:00',1.3),('15529','2014-03-26','13:55:00',1.51),('15529','2014-03-26','14:00:00',1.4),('15529','2014-03-26','14:15:00',1.12),('15529','2014-03-26','14:20:00',2.41),('15529','2014-03-26','14:25:00',1.02),('15529','2014-03-26','14:30:00',1.57),('15529','2014-03-26','14:35:00',1.85),('15529','2014-03-26','14:40:00',1.85),('15529','2014-03-26','14:55:00',1.73),('15529','2014-03-26','15:25:00',1.01),('15529','2014-03-26','15:30:00',1.14),('15529','2013-03-31','09:00:00',1.1),('15529','2013-03-31','09:05:00',1.14),('15529','2013-03-31','09:10:00',1.22),('15529','2013-03-31','09:15:00',1.15),('15529','2013-03-31','09:20:00',1.08),('15529','2013-03-31','09:25:00',1.24),('15529','2013-03-31','09:35:00',1.2),('15529','2013-03-31','09:40:00',1.37),('15529','2013-03-31','09:45:00',1.47),('15529','2013-03-31','09:50:00',1.52),('15529','2013-03-31','09:55:00',1.49),('15529','2013-03-31','10:00:00',1.63),('15529','2013-03-31','10:05:00',1.67),('15529','2013-03-31','10:10:00',1.45),('15529','2013-03-31','10:15:00',1.72),('15529','2013-03-31','10:20:00',1.85),('15529','2013-03-31','10:25:00',1.98),('15529','2013-03-31','10:30:00',1.86),('15529','2013-03-31','10:35:00',1.61),('15529','2013-03-31','10:40:00',1.57),('15529','2013-03-31','10:45:00',1.88),('15529','2013-03-31','10:50:00',2.11),('15529','2013-03-31','10:55:00',2.08),('15529','2013-03-31','11:00:00',1.77),('15529','2013-03-31','11:15:00',1.45),('15529','2013-03-31','11:20:00',1.22),('15529','2013-03-31','11:25:00',1.51),('15529','2013-03-31','11:30:00',1.28),('15529','2013-03-31','11:35:00',1.14),('15529','2013-03-31','11:40:00',1.27),('15529','2013-03-31','11:45:00',1.07),('15529','2013-03-31','11:50:00',1.12),('15529','2013-03-31','12:00:00',1.41),('15529','2013-03-31','12:30:00',1.39),('15529','2013-03-31','12:35:00',1.2),('15529','2013-03-31','12:40:00',1.3),('15529','2013-03-31','12:45:00',1.43),('15529','2013-03-31','12:50:00',1.58),('15529','2013-03-31','12:55:00',1.49),('15529','2013-03-31','13:00:00',1.63),('15529','2013-03-31','13:05:00',1.62),('15529','2013-03-31','13:10:00',1.48),('15529','2013-03-31','13:15:00',1.65),('15529','2013-03-31','13:20:00',1.52),('15529','2013-03-31','13:25:00',1.48),('15529','2013-03-31','13:30:00',1.54),('15529','2013-03-31','13:35:00',1.42),('15529','2013-03-31','13:40:00',2.01),('15529','2013-03-31','13:45:00',2),('15529','2013-03-31','13:50:00',2.28),('15529','2013-03-31','13:55:00',1.94),('15529','2013-03-31','14:00:00',1.01),('15529','2013-03-31','14:10:00',1.29);
INSERT INTO `solarlogmod` VALUES ('15529','2013-03-31','14:15:00',1.32),('15529','2013-03-31','14:20:00',1.62),('15529','2013-03-31','14:25:00',2.2),('15529','2013-03-31','14:30:00',1.24),('15529','2013-03-31','14:35:00',1.09),('15529','2013-03-31','14:45:00',1.02),('15529','2013-03-31','14:50:00',1.11),('15529','2013-03-31','14:55:00',1.04),('15529','2013-03-31','15:10:00',1.02),('15529','2013-03-31','15:15:00',1.09),('15529','2013-03-31','15:20:00',1.18),('15529','2013-03-31','15:25:00',1.14),('15529','2013-03-31','15:30:00',1.14),('15529','2013-03-31','15:35:00',1.3),('15529','2013-03-31','15:40:00',1.11),('15529','2013-03-31','15:45:00',1.27),('15529','2013-03-31','15:50:00',1.34),('15529','2013-03-30','09:20:00',1.36),('15529','2013-03-30','09:25:00',1.54),('15529','2013-03-30','09:30:00',1.23),('15529','2013-03-30','09:35:00',1.22),('15529','2013-03-30','09:40:00',1.47),('15529','2013-03-30','09:55:00',1.31),('15529','2013-03-30','10:20:00',1.1),('15529','2013-03-30','10:25:00',1.28),('15529','2013-03-30','10:30:00',1.2),('15529','2013-03-30','11:45:00',1.11),('15529','2013-03-30','12:30:00',1.11),('15529','2013-03-30','12:35:00',2.25),('15529','2013-03-30','12:40:00',2.24),('15529','2013-03-30','12:50:00',1.2),('15529','2013-03-30','12:55:00',1.23),('15529','2013-03-30','13:00:00',1.25),('15529','2013-03-30','13:05:00',1.05),('15529','2013-03-30','13:10:00',1.94),('15529','2013-03-30','13:15:00',2.45),('15529','2013-03-30','13:20:00',2.71),('15529','2013-03-30','13:25:00',1.09),('15529','2013-03-30','13:40:00',1.39),('15529','2013-03-30','13:50:00',1.1),('15529','2013-03-30','13:55:00',1.29),('15529','2013-03-30','14:00:00',1.74),('15529','2013-03-30','14:05:00',1.26),('15529','2013-03-30','14:10:00',1.76),('15529','2013-03-30','14:15:00',1.52),('15529','2013-03-30','14:20:00',1.09),('15529','2013-03-30','14:30:00',1.77),('15529','2013-03-30','14:35:00',2.12),('15529','2013-03-30','14:40:00',2.6),('15529','2013-03-30','14:45:00',2.37),('15529','2013-03-30','14:50:00',2.1),('15529','2013-03-30','14:55:00',2.42),('15529','2013-03-30','15:00:00',1.83),('15529','2013-03-30','15:05:00',2.1),('15529','2013-03-30','15:10:00',1.4),('15529','2013-03-30','15:15:00',2.2),('15529','2013-03-30','15:20:00',2.02),('15529','2013-03-30','15:25:00',1.47),('15529','2013-03-30','15:30:00',1.59),('15529','2013-03-30','15:35:00',2.36),('15529','2013-03-30','15:40:00',1.81),('15529','2013-03-30','15:45:00',1.06),('15529','2013-03-30','16:00:00',1.02),('15529','2013-03-30','16:10:00',1.47),('15529','2013-03-30','16:15:00',1.44),('15529','2013-03-29','09:05:00',1.42),('15529','2013-03-29','09:10:00',1.04),('15529','2013-03-29','09:15:00',1.55),('15529','2013-03-29','09:20:00',1.48),('15529','2013-03-29','10:35:00',1.03),('15529','2013-03-29','10:40:00',1.18),('15529','2013-03-29','10:45:00',1.31),('15529','2013-03-29','10:50:00',1.19),('15529','2013-03-29','10:55:00',1.49),('15529','2013-03-29','11:00:00',1.8),('15529','2013-03-29','11:05:00',1.94),('15529','2013-03-29','11:10:00',2.01),('15529','2013-03-29','11:15:00',2.61),('15529','2013-03-29','11:20:00',2.01),('15529','2013-03-29','11:30:00',1.82),('15529','2013-03-29','11:35:00',1.7),('15529','2013-03-29','11:40:00',2.02),('15529','2013-03-29','11:45:00',1.58),('15529','2013-03-29','11:50:00',1.65),('15529','2013-03-29','11:55:00',1.98),('15529','2013-03-29','12:00:00',1.84),('15529','2013-03-29','12:05:00',1.1),('15529','2013-03-29','13:40:00',1.41),('15529','2013-03-29','13:45:00',1.4),('15529','2013-03-29','13:50:00',1.15),('15529','2013-03-28','08:15:00',1.15),('15529','2013-03-28','08:20:00',1.21),('15529','2013-03-28','08:25:00',1.26),('15529','2013-03-28','08:30:00',1.33),('15529','2013-03-28','08:35:00',1.39),('15529','2013-03-28','08:40:00',1.42),('15529','2013-03-28','08:45:00',1.41),('15529','2013-03-28','08:50:00',1.38),('15529','2013-03-28','08:55:00',1.21),('15529','2013-03-28','09:00:00',1.5),('15529','2013-03-28','09:05:00',1.52),('15529','2013-03-28','09:10:00',1.44),('15529','2013-03-28','09:15:00',1.68),('15529','2013-03-28','09:20:00',1.73),('15529','2013-03-28','09:25:00',1.41),('15529','2013-03-28','09:30:00',1.77),('15529','2013-03-28','09:35:00',1.13),('15529','2013-03-28','09:40:00',1.78),('15529','2013-03-28','09:45:00',1.6),('15529','2013-03-28','09:50:00',1.52),('15529','2013-03-28','09:55:00',1.89),('15529','2013-03-28','10:00:00',1.79),('15529','2013-03-28','10:05:00',1.61),('15529','2013-03-28','10:10:00',1.57),('15529','2013-03-28','10:15:00',1.68),('15529','2013-03-28','10:20:00',1.38),('15529','2013-03-28','10:25:00',1.48),('15529','2013-03-28','10:30:00',1.71),('15529','2013-03-28','10:35:00',1.04),('15529','2013-03-28','10:40:00',1.65),('15529','2013-03-28','10:45:00',1.86),('15529','2013-03-28','10:50:00',2.08),('15529','2013-03-28','10:55:00',1.44),('15529','2013-03-28','11:00:00',2.06),('15529','2013-03-28','11:05:00',1.56),('15529','2013-03-28','11:10:00',1.97),('15529','2013-03-28','11:15:00',2.05),('15529','2013-03-28','11:20:00',2.41),('15529','2013-03-28','11:25:00',2.36),('15529','2013-03-28','11:30:00',2.32),('15529','2013-03-28','11:35:00',2.27),('15529','2013-03-28','11:40:00',2.37),('15529','2013-03-28','11:45:00',2.41),('15529','2013-03-28','11:50:00',2.41),('15529','2013-03-28','11:55:00',2.41),('15529','2013-03-28','12:00:00',2.37),('15529','2013-03-28','12:05:00',2.44),('15529','2013-03-28','12:10:00',2.37),('15529','2013-03-28','12:15:00',2.32),('15529','2013-03-28','12:20:00',2.35),('15529','2013-03-28','12:25:00',2.29),('15529','2013-03-28','12:30:00',2.3),('15529','2013-03-28','12:35:00',2.25),('15529','2013-03-28','12:40:00',2.05),('15529','2013-03-28','12:45:00',2.41),('15529','2013-03-28','12:50:00',2.33),('15529','2013-03-28','12:55:00',2.27),('15529','2013-03-28','13:00:00',2.14),('15529','2013-03-28','13:05:00',2.14),('15529','2013-03-28','13:10:00',2.19),('15529','2013-03-28','13:15:00',2.24),('15529','2013-03-28','13:20:00',2.35),('15529','2013-03-28','13:25:00',2.48),('15529','2013-03-28','13:30:00',1.94),('15529','2013-03-28','13:35:00',1.7),('15529','2013-03-28','13:40:00',1.73),('15529','2013-03-28','13:45:00',1.88),('15529','2013-03-28','13:50:00',1.86),('15529','2013-03-28','13:55:00',1.96),('15529','2013-03-28','14:00:00',1.97),('15529','2013-03-28','14:05:00',1.42),('15529','2013-03-28','14:10:00',1.31),('15529','2013-03-28','14:15:00',1.32),('15529','2013-03-28','14:20:00',1.32),('15529','2013-03-28','14:25:00',1.38),('15529','2013-03-28','14:30:00',1.11),('15529','2013-03-28','14:35:00',1.05),('15529','2013-03-28','14:40:00',1.02),('15529','2013-03-28','16:40:00',1.05),('15529','2013-03-27','09:15:00',1.07),('15529','2013-03-27','12:50:00',1.14),('15529','2013-03-27','12:55:00',1.22),('15529','2013-03-27','13:00:00',1.89),('15529','2013-03-27','13:05:00',1.42),('15529','2013-03-27','13:10:00',1.97),('15529','2013-03-27','13:15:00',1.18),('15529','2013-03-27','13:20:00',2.29),('15529','2013-03-27','13:25:00',1.53),('15529','2013-03-27','13:30:00',2.19),('15529','2013-03-27','13:45:00',1.03),('15529','2013-03-27','15:10:00',1.61),('15529','2013-03-27','15:15:00',1.58),('15529','2013-03-27','15:20:00',1.17),('15529','2013-03-26','07:55:00',1.02),('15529','2013-03-26','09:20:00',1.16),('15529','2013-03-26','09:45:00',1.16),('15529','2013-03-26','10:30:00',1.1),('15529','2013-03-26','10:35:00',1.19),('15529','2013-03-26','10:40:00',1.28),('15529','2013-03-26','10:45:00',1.17),('15529','2013-03-26','10:50:00',1.19),('15529','2013-03-26','11:30:00',1.14),('15529','2013-03-26','11:50:00',1.06),('15529','2013-03-26','11:55:00',1.5),('15529','2013-03-26','12:00:00',1.41),('15529','2013-03-26','12:05:00',1.41),('15529','2013-03-26','12:10:00',1.35),('15529','2013-03-26','12:15:00',1.25),('15529','2013-03-26','12:20:00',1.11),('15529','2013-03-26','12:25:00',1.14),('15529','2013-03-26','12:30:00',1.78),('15529','2013-03-26','12:35:00',2.47),('15529','2013-03-26','12:40:00',1.56),('15529','2013-03-26','12:45:00',1.86),('15529','2013-03-26','12:55:00',1.02),('15529','2013-03-26','14:35:00',1.06),('15529','2013-03-26','14:40:00',1.27),('15529','2013-03-25','09:10:00',1.01),('15529','2013-03-25','09:50:00',1.36),('15529','2013-03-25','12:00:00',1.26),('15529','2013-03-25','12:25:00',1.42),('15529','2013-03-25','12:30:00',1.17),('15529','2013-03-25','12:45:00',1.13),('15529','2013-03-25','13:00:00',1.36),('15529','2013-03-25','13:10:00',1.06),('15529','2013-03-25','13:20:00',1.22),('15529','2013-03-25','13:25:00',1.06),('15529','2013-03-25','13:30:00',1.31),('15529','2013-03-25','13:35:00',1.54),('15529','2013-03-25','13:40:00',1.33),('15529','2013-03-24','08:25:00',1.37),('15529','2013-03-24','09:50:00',1.42),('15529','2013-03-24','10:15:00',1.17),('15529','2013-03-24','10:20:00',1.36),('15529','2013-03-24','10:25:00',1.27),('15529','2013-03-24','10:45:00',1.65),('15529','2013-03-24','10:50:00',2.16),('15529','2013-03-24','10:55:00',2.14),('15529','2013-03-24','11:00:00',1.22),('15529','2013-03-24','11:15:00',1.61),('15529','2013-03-24','11:20:00',1.19),('15529','2013-03-24','11:25:00',2.23),('15529','2013-03-24','11:30:00',1.4),('15529','2013-03-24','11:50:00',1.13),('15529','2013-03-24','11:55:00',2.54),('15529','2013-03-24','12:00:00',1.87),('15529','2013-03-24','12:05:00',1.45),('15529','2013-03-24','12:10:00',2.57),('15529','2013-03-24','12:15:00',2.62),('15529','2013-03-24','12:20:00',2.78),('15529','2013-03-24','12:25:00',2.53),('15529','2013-03-24','12:30:00',2.02),('15529','2013-03-24','12:35:00',1.69),('15529','2013-03-24','12:40:00',1.44),('15529','2013-03-24','12:45:00',1.51),('15529','2013-03-24','12:50:00',1.54),('15529','2013-03-24','12:55:00',2.05),('15529','2013-03-24','13:00:00',2.54),('15529','2013-03-24','13:05:00',1.89),('15529','2013-03-24','13:15:00',1.62),('15529','2013-03-24','13:40:00',1.05),('15529','2013-03-24','14:05:00',1.86),('15529','2013-03-24','14:10:00',1.55),('15529','2013-03-24','14:15:00',1.78),('15529','2013-03-24','14:20:00',2.13),('15529','2013-03-24','14:25:00',1.94),('15529','2013-03-24','14:30:00',1.9),('15529','2013-03-24','14:35:00',1.53),('15529','2013-03-24','14:40:00',1.11),('15529','2013-03-24','14:45:00',1.49),('15529','2013-03-24','14:50:00',1.13),('15529','2013-03-24','14:55:00',1.25),('15529','2013-03-24','15:00:00',2.08),('15529','2013-03-24','15:05:00',1.17),('15529','2013-03-24','15:10:00',1.82),('15529','2013-03-24','15:15:00',1.93),('15529','2013-03-24','15:20:00',1.43),('15529','2013-03-24','15:25:00',1.41),('15529','2013-03-24','15:30:00',1.54),('15529','2013-03-24','15:35:00',1.45),('15529','2013-03-24','15:40:00',1.52),('15529','2013-03-24','15:50:00',1.03),('15529','2013-03-24','15:55:00',1.32),('15529','2013-03-24','16:30:00',1.08),('15529','2013-03-23','08:10:00',1.03),('15529','2013-03-23','08:15:00',1.11),('15529','2013-03-23','08:20:00',1.17),('15529','2013-03-23','08:25:00',1.22),('15529','2013-03-23','08:30:00',1.26),('15529','2013-03-23','08:35:00',1.31),('15529','2013-03-23','08:40:00',1.35),('15529','2013-03-23','08:45:00',1.38),('15529','2013-03-23','08:50:00',1.4),('15529','2013-03-23','08:55:00',1.44),('15529','2013-03-23','09:00:00',1.48),('15529','2013-03-23','09:05:00',1.52),('15529','2013-03-23','09:10:00',1.58),('15529','2013-03-23','09:15:00',1.61),('15529','2013-03-23','09:20:00',1.64),('15529','2013-03-23','09:25:00',1.69),('15529','2013-03-23','09:30:00',1.73),('15529','2013-03-23','09:35:00',1.76),('15529','2013-03-23','09:40:00',1.78),('15529','2013-03-23','09:45:00',1.82),('15529','2013-03-23','09:50:00',1.83),('15529','2013-03-23','09:55:00',1.85),('15529','2013-03-23','10:00:00',1.89),('15529','2013-03-23','10:05:00',1.93),('15529','2013-03-23','10:10:00',1.95),('15529','2013-03-23','10:15:00',1.96),('15529','2013-03-23','10:20:00',1.99),('15529','2013-03-23','10:25:00',2.02),('15529','2013-03-23','10:30:00',2.05),('15529','2013-03-23','10:35:00',2.07),('15529','2013-03-23','10:40:00',2.09),('15529','2013-03-23','10:45:00',2.11),('15529','2013-03-23','10:50:00',2.14),('15529','2013-03-23','10:55:00',2.15),('15529','2013-03-23','11:00:00',2.12),('15529','2013-03-23','11:05:00',2.15),('15529','2013-03-23','11:10:00',2.15),('15529','2013-03-23','11:15:00',2.15),('15529','2013-03-23','11:20:00',2.17),('15529','2013-03-23','11:25:00',2.2),('15529','2013-03-23','11:30:00',2.22),('15529','2013-03-23','11:35:00',2.22),('15529','2013-03-23','11:40:00',2.22),('15529','2013-03-23','11:45:00',2.21),('15529','2013-03-23','11:50:00',2.23),('15529','2013-03-23','11:55:00',2.24),('15529','2013-03-23','12:00:00',2.27),('15529','2013-03-23','12:05:00',2.27),('15529','2013-03-23','12:10:00',2.27),('15529','2013-03-23','12:15:00',2.29),('15529','2013-03-23','12:20:00',2.29),('15529','2013-03-23','12:25:00',2.34),('15529','2013-03-23','12:30:00',2.36),('15529','2013-03-23','12:35:00',2.36),('15529','2013-03-23','12:40:00',2.36),('15529','2013-03-23','12:45:00',2.34),('15529','2013-03-23','12:50:00',2.35),('15529','2013-03-23','12:55:00',2.32),('15529','2013-03-23','13:00:00',2.31),('15529','2013-03-23','13:05:00',2.3),('15529','2013-03-23','13:10:00',2.28),('15529','2013-03-23','13:15:00',2.28),('15529','2013-03-23','13:20:00',2.25),('15529','2013-03-23','13:25:00',2.22),('15529','2013-03-23','13:30:00',2.2),('15529','2013-03-23','13:35:00',2.18),('15529','2013-03-23','13:40:00',2.19),('15529','2013-03-23','13:45:00',2.18),('15529','2013-03-23','13:50:00',2.16),('15529','2013-03-23','13:55:00',2.11),('15529','2013-03-23','14:00:00',2.11),('15529','2013-03-23','14:05:00',2.05),('15529','2013-03-23','14:10:00',2.04),('15529','2013-03-23','14:15:00',2),('15529','2013-03-23','14:20:00',1.96),('15529','2013-03-23','14:25:00',1.91),('15529','2013-03-23','14:30:00',1.83),('15529','2013-03-23','14:35:00',1.82),('15529','2013-03-23','14:40:00',1.81),('15529','2013-03-23','14:45:00',1.78),('15529','2013-03-23','14:50:00',1.71),('15529','2013-03-23','14:55:00',1.72),('15529','2013-03-23','15:00:00',1.65),('15529','2013-03-23','15:05:00',1.64),('15529','2013-03-23','15:10:00',1.52),('15529','2013-03-23','15:15:00',1.61),('15529','2013-03-23','15:20:00',1.56),('15529','2013-03-23','15:25:00',1.45),('15529','2013-03-23','15:30:00',1.36),('15529','2013-03-23','15:35:00',1.28),('15529','2013-03-23','15:40:00',1.25),('15529','2013-03-22','08:05:00',1.04),('15529','2013-03-22','08:10:00',1.08),('15529','2013-03-22','08:15:00',1.14),('15529','2013-03-22','08:20:00',1.17),('15529','2013-03-22','08:25:00',1.22),('15529','2013-03-22','08:30:00',1.24),('15529','2013-03-22','08:35:00',1.29),('15529','2013-03-22','08:40:00',1.36),('15529','2013-03-22','08:45:00',1.4),('15529','2013-03-22','08:50:00',1.45),('15529','2013-03-22','08:55:00',1.53),('15529','2013-03-22','09:00:00',1.57),('15529','2013-03-22','09:05:00',1.62),('15529','2013-03-22','09:10:00',1.63),('15529','2013-03-22','09:15:00',1.7),('15529','2013-03-22','09:20:00',1.74),('15529','2013-03-22','09:25:00',1.77),('15529','2013-03-22','09:30:00',1.81),('15529','2013-03-22','09:35:00',1.84),('15529','2013-03-22','09:40:00',1.8),('15529','2013-03-22','09:45:00',1.88),('15529','2013-03-22','09:50:00',1.87),('15529','2013-03-22','09:55:00',1.91),('15529','2013-03-22','10:00:00',1.91),('15529','2013-03-22','10:05:00',1.93),('15529','2013-03-22','10:10:00',1.99),('15529','2013-03-22','10:15:00',1.98),('15529','2013-03-22','10:20:00',1.97),('15529','2013-03-22','10:25:00',2.02),('15529','2013-03-22','10:30:00',2.09),('15529','2013-03-22','10:35:00',2.11),('15529','2013-03-22','10:40:00',2.07),('15529','2013-03-22','10:45:00',2.08),('15529','2013-03-22','10:50:00',2.06),('15529','2013-03-22','10:55:00',1.99),('15529','2013-03-22','11:00:00',2.02),('15529','2013-03-22','11:05:00',1.81),('15529','2013-03-22','11:10:00',1.74),('15529','2013-03-22','11:15:00',1.68),('15529','2013-03-22','11:20:00',2.03),('15529','2013-03-22','11:25:00',2.08),('15529','2013-03-22','11:30:00',2.11),('15529','2013-03-22','11:35:00',2.19),('15529','2013-03-22','11:40:00',2.17),('15529','2013-03-22','11:45:00',2.19),('15529','2013-03-22','11:50:00',2.16),('15529','2013-03-22','11:55:00',2.22),('15529','2013-03-22','12:00:00',2.23),('15529','2013-03-22','12:05:00',2.25),('15529','2013-03-22','12:10:00',2.25),('15529','2013-03-22','12:15:00',2.25),('15529','2013-03-22','12:20:00',2.29),('15529','2013-03-22','12:25:00',2.25),('15529','2013-03-22','12:30:00',2.24),('15529','2013-03-22','12:35:00',2.25),('15529','2013-03-22','12:40:00',2.17),('15529','2013-03-22','12:45:00',2.21),('15529','2013-03-22','12:50:00',2.23),('15529','2013-03-22','12:55:00',2.12),('15529','2013-03-22','13:00:00',1.86),('15529','2013-03-22','13:05:00',2.25),('15529','2013-03-22','13:10:00',2.27),('15529','2013-03-22','13:15:00',2.11),('15529','2013-03-22','13:20:00',2.16),('15529','2013-03-22','13:25:00',2.17),('15529','2013-03-22','13:30:00',2.15),('15529','2013-03-22','13:35:00',2.17),('15529','2013-03-22','13:40:00',2.13),('15529','2013-03-22','13:45:00',2.11),('15529','2013-03-22','13:50:00',2.09),('15529','2013-03-22','13:55:00',2.09),('15529','2013-03-22','14:00:00',2.05),('15529','2013-03-22','14:05:00',2.06),('15529','2013-03-22','14:10:00',1.98),('15529','2013-03-22','14:15:00',1.93),('15529','2013-03-22','14:20:00',1.98),('15529','2013-03-22','14:25:00',1.94),('15529','2013-03-22','14:30:00',1.91),('15529','2013-03-22','14:35:00',1.88),('15529','2013-03-22','14:40:00',1.81),('15529','2013-03-22','14:45:00',1.69),('15529','2013-03-22','14:50:00',1.68),('15529','2013-03-22','14:55:00',1.69),('15529','2013-03-22','15:00:00',1.67),('15529','2013-03-22','15:05:00',1.54),('15529','2013-03-22','15:10:00',1.59),('15529','2013-03-22','15:15:00',1.45),('15529','2013-03-22','15:20:00',1.52),('15529','2013-03-22','15:25:00',1.46),('15529','2013-03-22','15:30:00',1.33),('15529','2013-03-22','15:35:00',1.33),('15529','2013-03-22','15:40:00',1.27),('15529','2013-03-22','15:45:00',1.14),('15529','2013-03-22','15:50:00',1.11),('15529','2013-03-22','15:55:00',1.05),('15529','2013-03-22','16:10:00',1.12),('15529','2014-03-25','08:00:00',1.02),('15529','2014-03-25','08:05:00',1.09),('15529','2014-03-25','08:10:00',1.17),('15529','2014-03-25','08:15:00',1.35),('15529','2014-03-25','09:20:00',1.46),('15529','2014-03-25','09:25:00',1.66),('15529','2014-03-25','09:30:00',1.85),('15529','2014-03-25','09:35:00',1.87),('15529','2014-03-25','09:40:00',1.89),('15529','2014-03-25','09:45:00',1.91),('15529','2014-03-25','09:50:00',1.95),('15529','2014-03-25','09:55:00',1.98),('15529','2014-03-25','10:00:00',2.03),('15529','2014-03-25','10:05:00',2.09),('15529','2014-03-25','10:10:00',2.14),('15529','2014-03-25','10:15:00',2.06),('15529','2014-03-25','10:20:00',1.05),('15529','2014-03-25','10:25:00',2),('15529','2014-03-25','10:30:00',1.13),('15529','2014-03-25','10:45:00',2.2),('15529','2014-03-25','10:50:00',1.28),('15529','2014-03-25','11:05:00',1.37),('15529','2014-03-25','11:10:00',1.31),('15529','2014-03-25','11:15:00',1.18),('15529','2014-03-25','11:35:00',1.39),('15529','2014-03-25','11:40:00',2.67),('15529','2014-03-25','11:45:00',2.9),('15529','2014-03-25','11:50:00',2.61),('15529','2014-03-25','11:55:00',2.81),('15529','2014-03-25','12:00:00',2.82),('15529','2014-03-25','12:05:00',2.57),('15529','2014-03-25','12:10:00',1.47),('15529','2014-03-25','12:40:00',1.14),('15529','2014-03-25','12:45:00',1.03),('15529','2014-03-25','12:50:00',1.34),('15529','2014-03-25','12:55:00',1.29),('15529','2014-03-25','13:00:00',2.41),('15529','2014-03-25','13:05:00',2.33),('15529','2014-03-25','13:10:00',2.13),('15529','2014-03-25','13:15:00',2.54),('15529','2014-03-25','13:20:00',2.4),('15529','2014-03-25','13:25:00',2.26),('15529','2014-03-25','13:30:00',1.75),('15529','2014-03-25','13:35:00',1.01),('15529','2014-03-25','13:40:00',1.92),('15529','2014-03-25','13:45:00',1.68),('15529','2014-03-25','13:50:00',2.27),('15529','2014-03-25','13:55:00',2.62),('15529','2014-03-25','14:00:00',2.56),('15529','2014-03-25','14:05:00',1.16),('15529','2014-03-25','14:45:00',1.33),('15529','2014-03-25','14:50:00',1.73),('15529','2014-03-25','14:55:00',1.91),('15529','2014-03-25','15:00:00',1.74),('15529','2014-03-25','15:05:00',1.6),('15529','2014-03-25','15:10:00',1.72),('15529','2014-03-25','15:15:00',1.72),('15529','2014-03-25','15:20:00',1.79),('15529','2014-03-25','15:25:00',1.62),('15529','2014-03-25','15:30:00',1.71),('15529','2014-03-25','15:35:00',1.62),('15529','2014-03-25','15:40:00',1.32),('15529','2014-03-25','15:45:00',1.24),('15529','2013-03-21','08:10:00',1.06),('15529','2013-03-21','08:15:00',1.12),('15529','2013-03-21','08:20:00',1.18),('15529','2013-03-21','08:25:00',1.24),('15529','2013-03-21','08:30:00',1.29),('15529','2013-03-21','08:35:00',1.34),('15529','2013-03-21','08:40:00',1.39),('15529','2013-03-21','08:45:00',1.43),('15529','2013-03-21','08:50:00',1.47),('15529','2013-03-21','08:55:00',1.5),('15529','2013-03-21','09:00:00',1.53),('15529','2013-03-21','09:05:00',1.59),('15529','2013-03-21','09:10:00',1.64),('15529','2013-03-21','09:15:00',1.68),('15529','2013-03-21','09:20:00',1.71),('15529','2013-03-21','09:25:00',1.73),('15529','2013-03-21','09:30:00',1.77),('15529','2013-03-21','09:35:00',1.81),('15529','2013-03-21','09:40:00',1.86),('15529','2013-03-21','09:45:00',1.86),('15529','2013-03-21','09:50:00',1.9),('15529','2013-03-21','09:55:00',1.95),('15529','2013-03-21','10:00:00',1.96),('15529','2013-03-21','10:05:00',1.98),('15529','2013-03-21','10:10:00',2.03),('15529','2013-03-21','10:15:00',2.05),('15529','2013-03-21','10:20:00',2.08),('15529','2013-03-21','10:25:00',2.11),('15529','2013-03-21','10:30:00',2.12),('15529','2013-03-21','10:35:00',2.14),('15529','2013-03-21','10:40:00',2.17),('15529','2013-03-21','10:45:00',2.18),('15529','2013-03-21','10:50:00',2.2),('15529','2013-03-21','10:55:00',2.23),('15529','2013-03-21','11:00:00',2.24),('15529','2013-03-21','11:05:00',2.25),('15529','2013-03-21','11:10:00',2.31),('15529','2013-03-21','11:15:00',2.31),('15529','2013-03-21','11:20:00',2.3),('15529','2013-03-21','11:25:00',2.31),('15529','2013-03-21','11:30:00',2.33),('15529','2013-03-21','11:35:00',2.36),('15529','2013-03-21','11:40:00',2.39),('15529','2013-03-21','11:45:00',2.39),('15529','2013-03-21','11:50:00',2.4),('15529','2013-03-21','11:55:00',2.39),('15529','2013-03-21','12:00:00',2.38),('15529','2013-03-21','12:05:00',2.41),('15529','2013-03-21','12:10:00',2.38),('15529','2013-03-21','12:15:00',2.42),('15529','2013-03-21','12:20:00',2.44),('15529','2013-03-21','12:25:00',2.41),('15529','2013-03-21','12:30:00',2.39),('15529','2013-03-21','12:35:00',2.42),('15529','2013-03-21','12:40:00',2.37),('15529','2013-03-21','12:45:00',2.39),('15529','2013-03-21','12:50:00',2.35),('15529','2013-03-21','12:55:00',2.36),('15529','2013-03-21','13:00:00',2.37),('15529','2013-03-21','13:05:00',2.37),('15529','2013-03-21','13:10:00',2.38),('15529','2013-03-21','13:15:00',2.36),('15529','2013-03-21','13:20:00',2.3),('15529','2013-03-21','13:25:00',2.08),('15529','2013-03-21','13:30:00',2.19),('15529','2013-03-21','13:35:00',2.29),('15529','2013-03-21','13:40:00',2.01),('15529','2013-03-21','13:45:00',2.26),('15529','2013-03-21','13:50:00',2.24),('15529','2013-03-21','13:55:00',2.2),('15529','2013-03-21','14:00:00',2.18),('15529','2013-03-21','14:05:00',2.15),('15529','2013-03-21','14:10:00',2.13),('15529','2013-03-21','14:15:00',2.1),('15529','2013-03-21','14:20:00',2.06),('15529','2013-03-21','14:25:00',2.04),('15529','2013-03-21','14:30:00',1.99),('15529','2013-03-21','14:35:00',1.97),('15529','2013-03-21','14:40:00',1.94),('15529','2013-03-21','14:45:00',1.88),('15529','2013-03-21','14:50:00',1.87),('15529','2013-03-21','14:55:00',1.85),('15529','2013-03-21','15:00:00',1.31),('15529','2013-03-21','15:05:00',1.77),('15529','2013-03-21','15:10:00',1.55),('15529','2013-03-21','15:15:00',1.3),('15529','2013-03-21','15:20:00',1.15),('15529','2013-03-21','15:25:00',1.26),('15529','2013-03-21','15:30:00',1.29),('15529','2013-03-21','15:35:00',1.38),('15529','2013-03-21','15:40:00',1.28),('15529','2013-03-21','15:45:00',1.19),('15529','2013-03-21','15:50:00',1.22),('15529','2013-03-21','15:55:00',1.05),('15529','2013-03-21','16:10:00',1.11),('15529','2013-03-21','16:15:00',1.15),('15529','2013-03-21','16:35:00',1.02),('15529','2013-03-20','07:45:00',1.08),('15529','2013-03-20','08:10:00',1.14),('15529','2013-03-20','08:15:00',1.06),('15529','2013-03-20','08:20:00',1.26),('15529','2013-03-20','08:25:00',1.23),('15529','2013-03-20','08:30:00',1.31),('15529','2013-03-20','08:35:00',1.18),('15529','2013-03-20','08:45:00',1.44),('15529','2013-03-20','08:50:00',1.54),('15529','2013-03-20','08:55:00',1.7),('15529','2013-03-20','09:00:00',1.95),('15529','2013-03-20','09:05:00',1.6),('15529','2013-03-20','09:10:00',1.41),('15529','2013-03-20','09:15:00',1.23),('15529','2013-03-20','09:25:00',1.67),('15529','2013-03-20','09:30:00',1.99),('15529','2013-03-20','09:35:00',1.81),('15529','2013-03-20','09:40:00',1.81),('15529','2013-03-20','09:45:00',2.03),('15529','2013-03-20','09:50:00',2.07),('15529','2013-03-20','09:55:00',2.09),('15529','2013-03-20','10:00:00',2.11),('15529','2013-03-20','10:05:00',2.11),('15529','2013-03-20','10:10:00',2.13),('15529','2013-03-20','10:15:00',2.14),('15529','2013-03-20','10:20:00',2.18),('15529','2013-03-20','10:25:00',2.21),('15529','2013-03-20','10:30:00',2.23),('15529','2013-03-20','10:35:00',2.24),('15529','2013-03-20','10:40:00',2.25),('15529','2013-03-20','10:45:00',2.25),('15529','2013-03-20','10:50:00',2.02),('15529','2013-03-20','10:55:00',1.37),('15529','2013-03-20','11:00:00',2.38),('15529','2013-03-20','11:05:00',2.38),('15529','2013-03-20','11:10:00',2.4),('15529','2013-03-20','11:15:00',2.41),('15529','2013-03-20','11:20:00',2.43),('15529','2013-03-20','11:25:00',2.45),('15529','2013-03-20','11:30:00',2.46),('15529','2013-03-20','11:35:00',2.48),('15529','2013-03-20','11:40:00',2.49),('15529','2013-03-20','11:45:00',2.51),('15529','2013-03-20','11:50:00',2.5),('15529','2013-03-20','11:55:00',2.52),('15529','2013-03-20','12:00:00',2.52),('15529','2013-03-20','12:05:00',2.53),('15529','2013-03-20','12:10:00',2.55),('15529','2013-03-20','12:15:00',2.53),('15529','2013-03-20','12:20:00',2.52),('15529','2013-03-20','12:25:00',2.52),('15529','2013-03-20','12:30:00',2.53),('15529','2013-03-20','12:35:00',2.52),('15529','2013-03-20','12:40:00',2.5),('15529','2013-03-20','12:45:00',2.48),('15529','2013-03-20','12:50:00',2.48),('15529','2013-03-20','12:55:00',2.46),('15529','2013-03-20','13:00:00',2.45),('15529','2013-03-20','13:05:00',2.43),('15529','2013-03-20','13:10:00',2.43),('15529','2013-03-20','13:15:00',2.41),('15529','2013-03-20','13:20:00',2.41),('15529','2013-03-20','13:25:00',2.38),('15529','2013-03-20','13:30:00',2.37),('15529','2013-03-20','13:35:00',2.36),('15529','2013-03-20','13:40:00',2.33),('15529','2013-03-20','13:45:00',2.32),('15529','2013-03-20','13:50:00',2.3),('15529','2013-03-20','13:55:00',2.27),('15529','2013-03-20','14:00:00',2.23),('15529','2013-03-20','14:05:00',2.19),('15529','2013-03-20','14:10:00',2.17),('15529','2013-03-20','14:15:00',2.14),('15529','2013-03-20','14:20:00',2.11),('15529','2013-03-20','14:25:00',2.07),('15529','2013-03-20','14:30:00',2.04),('15529','2013-03-20','14:35:00',2.02),('15529','2013-03-20','14:40:00',1.98),('15529','2013-03-20','14:45:00',1.94),('15529','2013-03-20','14:50:00',1.92),('15529','2013-03-20','14:55:00',1.88),('15529','2013-03-20','15:00:00',1.85),('15529','2013-03-20','15:05:00',1.81),('15529','2013-03-20','15:10:00',1.76),('15529','2013-03-20','15:15:00',1.72),('15529','2013-03-20','15:20:00',1.68),('15529','2013-03-20','15:25:00',1.64),('15529','2013-03-20','15:30:00',1.6),('15529','2013-03-20','15:35:00',1.55),('15529','2013-03-20','15:40:00',1.49),('15529','2013-03-20','15:45:00',1.44),('15529','2013-03-20','15:50:00',1.39),('15529','2013-03-20','15:55:00',1.34),('15529','2013-03-20','16:00:00',1.28),('15529','2013-03-20','16:05:00',1.22),('15529','2013-03-20','16:10:00',1.17),('15529','2013-03-20','16:15:00',1.12),('15529','2013-03-20','16:20:00',1.06),('15529','2013-03-19','08:05:00',1.06),('15529','2013-03-19','08:10:00',1.06),('15529','2013-03-19','08:15:00',1.12),('15529','2013-03-19','08:20:00',1.17),('15529','2013-03-19','08:25:00',1.24),('15529','2013-03-19','08:30:00',1.32),('15529','2013-03-19','08:35:00',1.35),('15529','2013-03-19','08:40:00',1.3),('15529','2013-03-19','08:45:00',1.39),('15529','2013-03-19','08:50:00',1.41),('15529','2013-03-19','08:55:00',1.35),('15529','2013-03-19','09:00:00',1.61),('15529','2013-03-19','09:05:00',1.41),('15529','2013-03-19','09:10:00',1.72),('15529','2013-03-19','09:15:00',1.65),('15529','2013-03-19','09:20:00',1.23),('15529','2013-03-19','09:25:00',1.77),('15529','2013-03-19','09:30:00',1.77),('15529','2013-03-19','09:35:00',1.76),('15529','2013-03-19','09:40:00',1.87),('15529','2013-03-19','09:45:00',1.89),('15529','2013-03-19','09:50:00',1.9),('15529','2013-03-19','09:55:00',1.89),('15529','2013-03-19','10:00:00',1.98),('15529','2013-03-19','10:05:00',1.92),('15529','2013-03-19','10:10:00',1.97),('15529','2013-03-19','10:15:00',1.96),('15529','2013-03-19','10:20:00',1.17),('15529','2013-03-19','10:25:00',1.51),('15529','2013-03-19','10:30:00',2.15),('15529','2013-03-19','10:35:00',2.26),('15529','2013-03-19','10:40:00',1.4),('15529','2013-03-19','10:45:00',1.9),('15529','2013-03-19','10:50:00',1.78),('15529','2013-03-19','10:55:00',1.51),('15529','2013-03-19','11:00:00',1.55),('15529','2013-03-19','11:05:00',1.9),('15529','2013-03-19','11:10:00',1.19),('15529','2013-03-19','11:15:00',1.31),('15529','2013-03-19','11:20:00',1.56),('15529','2013-03-19','11:25:00',1.44),('15529','2013-03-19','11:30:00',1.3),('15529','2013-03-19','11:35:00',1.49),('15529','2013-03-19','11:40:00',1.14),('15529','2013-03-19','11:45:00',1.09),('15529','2013-03-19','11:50:00',1.06),('15529','2013-03-19','11:55:00',1.11),('15529','2013-03-19','12:00:00',1.17),('15529','2013-03-19','12:05:00',1.23),('15529','2013-03-19','12:55:00',1.05),('15529','2013-03-19','14:20:00',1.07),('15529','2013-03-18','08:10:00',1.06),('15529','2013-03-18','08:15:00',1.13),('15529','2013-03-18','08:20:00',1.16),('15529','2013-03-18','08:25:00',1.22),('15529','2013-03-18','08:30:00',1.04),('15529','2013-03-18','08:35:00',1.25),('15529','2013-03-18','08:40:00',1.41),('15529','2013-03-18','08:45:00',1.46),('15529','2013-03-18','08:50:00',1.52),('15529','2013-03-18','08:55:00',1.53),('15529','2013-03-18','09:00:00',1.59),('15529','2013-03-18','09:05:00',1.65),('15529','2013-03-18','09:10:00',1.66),('15529','2013-03-18','09:15:00',1.64),('15529','2013-03-18','09:20:00',1.69),('15529','2013-03-18','09:25:00',1.83),('15529','2013-03-18','09:30:00',1.86),('15529','2013-03-18','09:35:00',1.89),('15529','2013-03-18','09:40:00',1.95),('15529','2013-03-18','09:45:00',1.68),('15529','2013-03-18','09:50:00',1.81),('15529','2013-03-18','09:55:00',2.02),('15529','2013-03-18','10:00:00',1.76),('15529','2013-03-18','10:05:00',1.99),('15529','2013-03-18','10:10:00',2.14),('15529','2013-03-18','10:15:00',2.17),('15529','2013-03-18','10:20:00',2.14),('15529','2013-03-18','10:25:00',2.21),('15529','2013-03-18','10:30:00',2.26),('15529','2013-03-18','10:35:00',2.26),('15529','2013-03-18','10:40:00',2.31),('15529','2013-03-18','10:45:00',2.31),('15529','2013-03-18','10:50:00',2.38),('15529','2013-03-18','10:55:00',2.41),('15529','2013-03-18','11:00:00',2.4),('15529','2013-03-18','11:05:00',2.41),('15529','2013-03-18','11:10:00',2.34),('15529','2013-03-18','11:15:00',2.5),('15529','2013-03-18','11:20:00',2.46),('15529','2013-03-18','11:25:00',2.47),('15529','2013-03-18','11:30:00',2.37),('15529','2013-03-18','11:35:00',1.41),('15529','2013-03-18','11:40:00',2.44),('15529','2013-03-18','11:45:00',2.27),('15529','2013-03-18','11:50:00',2.57),('15529','2013-03-18','11:55:00',2.51),('15529','2013-03-18','12:00:00',2.54),('15529','2013-03-18','12:05:00',2.5),('15529','2013-03-18','12:10:00',2.49),('15529','2013-03-18','12:15:00',2.38),('15529','2013-03-18','12:20:00',2.49),('15529','2013-03-18','12:25:00',2.46),('15529','2013-03-18','12:30:00',2.46),('15529','2013-03-18','12:35:00',2.51),('15529','2013-03-18','12:40:00',2.46),('15529','2013-03-18','12:45:00',2.47),('15529','2013-03-18','12:50:00',2.46),('15529','2013-03-18','12:55:00',2.46),('15529','2013-03-18','13:00:00',2.44),('15529','2013-03-18','13:05:00',2.44),('15529','2013-03-18','13:10:00',2.43),('15529','2013-03-18','13:15:00',2.37),('15529','2013-03-18','13:20:00',2.34),('15529','2013-03-18','13:25:00',2.34),('15529','2013-03-18','13:30:00',2.31),('15529','2013-03-18','13:35:00',2.29),('15529','2013-03-18','13:40:00',2.25),('15529','2013-03-18','13:45:00',2.28),('15529','2013-03-18','13:50:00',2.24),('15529','2013-03-18','13:55:00',2.22),('15529','2013-03-18','14:00:00',2.19),('15529','2013-03-18','14:05:00',2.18),('15529','2013-03-18','14:10:00',2.14),('15529','2013-03-18','14:15:00',2.05),('15529','2013-03-18','14:20:00',2.1),('15529','2013-03-18','14:25:00',2.07),('15529','2013-03-18','14:30:00',2.03),('15529','2013-03-18','14:35:00',2),('15529','2013-03-18','14:40:00',1.97),('15529','2013-03-18','14:45:00',1.92),('15529','2013-03-18','14:50:00',1.89),('15529','2013-03-18','14:55:00',1.85),('15529','2013-03-18','15:00:00',1.84),('15529','2013-03-18','15:05:00',1.78),('15529','2013-03-18','15:10:00',1.71),('15529','2013-03-18','15:15:00',1.71),('15529','2013-03-18','15:20:00',1.66),('15529','2013-03-18','15:25:00',1.62),('15529','2013-03-18','15:30:00',1.58),('15529','2013-03-18','15:35:00',1.54),('15529','2013-03-18','15:40:00',1.48),('15529','2013-03-18','15:45:00',1.44),('15529','2013-03-18','15:50:00',1.39),('15529','2013-03-18','15:55:00',1.32),('15529','2013-03-18','16:00:00',1.26),('15529','2013-03-18','16:05:00',1.22),('15529','2013-03-18','16:10:00',1.17),('15529','2013-03-18','16:15:00',1.12),('15529','2013-03-18','16:20:00',1.06),('15529','2013-03-18','16:25:00',1.01),('15529','2013-03-17','11:15:00',1),('15529','2013-03-17','11:20:00',1.01),('15529','2013-03-17','11:25:00',1.2),('15529','2013-03-17','11:30:00',1.54),('15529','2013-03-17','11:35:00',1.09),('15529','2013-03-17','12:05:00',1.5),('15529','2013-03-17','12:10:00',1.5),('15529','2013-03-17','12:15:00',1.99),('15529','2013-03-17','12:20:00',1.58),('15529','2013-03-17','12:25:00',1.52),('15529','2013-03-17','12:30:00',2.19),('15529','2013-03-17','12:35:00',2.05),('15529','2013-03-17','12:40:00',1.28),('15529','2013-03-17','12:45:00',1.68),('15529','2013-03-17','12:50:00',1.89),('15529','2013-03-17','12:55:00',2.1),('15529','2013-03-17','13:00:00',1.99),('15529','2013-03-17','13:05:00',1.15),('15529','2013-03-17','13:25:00',1.43),('15529','2013-03-17','13:40:00',1.24),('15529','2013-03-17','13:45:00',1.06),('15529','2013-03-17','14:05:00',1.29),('15529','2013-03-17','14:10:00',1.1),('15529','2013-03-16','10:00:00',1.06),('15529','2013-03-16','10:25:00',1.01),('15529','2013-03-16','12:15:00',1.1),('15529','2013-03-16','12:20:00',1.31),('15529','2013-03-16','12:25:00',1.46),('15529','2013-03-16','12:30:00',1.58),('15529','2013-03-16','12:35:00',1.27),('15529','2013-03-16','12:40:00',1.22),('15529','2013-03-16','12:45:00',1.2),('15529','2013-03-16','12:50:00',1.02),('15529','2013-03-16','13:00:00',1.18),('15529','2013-03-16','13:05:00',1.19),('15529','2013-03-16','13:10:00',1.36),('15529','2013-03-16','13:15:00',1.27),('15529','2013-03-16','13:20:00',1.06),('15529','2013-03-16','13:25:00',1),('15529','2013-03-16','13:30:00',1.53),('15529','2013-03-16','13:35:00',1.31),('15529','2013-03-16','13:40:00',1.09),('15529','2013-03-16','13:55:00',1.44),('15529','2013-03-16','14:00:00',1.07),('15529','2013-03-16','14:05:00',1.33),('15529','2013-03-16','14:10:00',1.54),('15529','2013-03-16','14:15:00',1.33),('15529','2013-03-16','14:20:00',1.54),('15529','2013-03-16','14:25:00',1.3),('15529','2013-03-16','14:30:00',1.12),('15529','2013-03-16','14:35:00',1.08),('15529','2013-03-16','15:05:00',1.41),('15529','2013-03-16','15:10:00',1.92),('15529','2013-03-16','15:15:00',1.84),('15529','2013-03-16','15:20:00',1.76),('15529','2013-03-16','15:25:00',1.65),('15529','2013-03-16','15:30:00',1.27),('15529','2013-03-15','08:25:00',1.28),('15529','2013-03-15','08:30:00',1.34),('15529','2013-03-15','08:35:00',1.38),('15529','2013-03-15','08:40:00',1.41),('15529','2013-03-15','08:45:00',1.47),('15529','2013-03-15','08:50:00',1.63),('15529','2013-03-15','08:55:00',1.7),('15529','2013-03-15','09:00:00',1.75),('15529','2013-03-15','09:10:00',1.82),('15529','2013-03-15','09:15:00',1.84),('15529','2013-03-15','09:20:00',1.32),('15529','2013-03-15','09:25:00',1.2),('15529','2013-03-15','09:30:00',1.66),('15529','2013-03-15','09:35:00',1.84),('15529','2013-03-15','09:40:00',1.18),('15529','2013-03-15','09:45:00',1.72),('15529','2013-03-15','09:50:00',2.09),('15529','2013-03-15','09:55:00',2.24),('15529','2013-03-15','10:00:00',1.95),('15529','2013-03-15','10:05:00',2.23),('15529','2013-03-15','10:10:00',2.12),('15529','2013-03-15','10:15:00',1.6),('15529','2013-03-15','10:20:00',1.73),('15529','2013-03-15','10:25:00',1.41),('15529','2013-03-15','10:30:00',2.24),('15529','2013-03-15','10:35:00',2.18),('15529','2013-03-15','10:40:00',2.32),('15529','2013-03-15','10:45:00',2.3),('15529','2013-03-15','10:50:00',2.29),('15529','2013-03-15','10:55:00',2.34),('15529','2013-03-15','11:00:00',2.33),('15529','2013-03-15','11:05:00',2.34),('15529','2013-03-15','11:10:00',2.36),('15529','2013-03-15','11:15:00',2.37),('15529','2013-03-15','11:20:00',2.38),('15529','2013-03-15','11:25:00',2.39),('15529','2013-03-15','11:30:00',2.4),('15529','2013-03-15','11:35:00',2.41),('15529','2013-03-15','11:40:00',2.43),('15529','2013-03-15','11:45:00',2.42),('15529','2013-03-15','11:50:00',2.4),('15529','2013-03-15','11:55:00',2.41),('15529','2013-03-15','12:00:00',2.43),('15529','2013-03-15','12:05:00',2.44),('15529','2013-03-15','12:10:00',2.43),('15529','2013-03-15','12:15:00',2.39),('15529','2013-03-15','12:20:00',2.41),('15529','2013-03-15','12:25:00',2.41),('15529','2013-03-15','12:30:00',2.38),('15529','2013-03-15','12:35:00',2.39),('15529','2013-03-15','12:40:00',2.4),('15529','2013-03-15','12:45:00',2.27),('15529','2013-03-15','12:50:00',1.79),('15529','2013-03-15','12:55:00',2.21),('15529','2013-03-15','13:00:00',2.37),('15529','2013-03-15','13:05:00',2.32),('15529','2013-03-15','13:10:00',2.36),('15529','2013-03-15','13:15:00',2.33),('15529','2013-03-15','13:20:00',2.37),('15529','2013-03-15','13:25:00',2.36),('15529','2013-03-15','13:30:00',2.32),('15529','2013-03-15','13:35:00',2.31),('15529','2013-03-15','13:40:00',2.28),('15529','2013-03-15','13:45:00',2.33),('15529','2013-03-15','13:50:00',2.29),('15529','2013-03-15','13:55:00',2.08),('15529','2013-03-15','14:00:00',2.29),('15529','2013-03-15','14:05:00',1.54),('15529','2013-03-15','14:10:00',2.34),('15529','2013-03-15','14:15:00',1.47),('15529','2013-03-15','14:20:00',2.25),('15529','2013-03-15','14:25:00',2.26),('15529','2013-03-15','14:30:00',2.17),('15529','2013-03-15','14:35:00',2.09),('15529','2013-03-15','14:40:00',2.07),('15529','2013-03-15','14:45:00',1.73),('15529','2013-03-15','14:50:00',1.57),('15529','2013-03-15','15:35:00',1.26),('15529','2013-03-15','15:40:00',1.61),('15529','2013-03-15','15:45:00',1.12),('15529','2013-03-15','15:55:00',1.28),('15529','2013-03-15','16:00:00',1.31),('15529','2013-03-15','16:05:00',1.26),('15529','2013-03-15','16:10:00',1.24),('15529','2013-03-15','16:15:00',1.08),('15529','2013-03-14','11:35:00',1.3),('15529','2013-03-14','11:40:00',1.08),('15529','2013-03-14','11:45:00',1.12),('15529','2013-03-14','11:50:00',1.07),('15529','2013-03-14','11:55:00',1.17),('15529','2013-03-14','12:00:00',1.07),('15529','2013-03-14','12:10:00',1.06),('15529','2013-03-14','12:30:00',1.14),('15529','2013-03-14','12:35:00',1.02),('15529','2013-03-12','10:10:00',1.12),('15529','2013-03-12','10:25:00',1.36),('15529','2013-03-12','10:30:00',1.8),('15529','2013-03-12','10:35:00',1.81),('15529','2013-03-12','10:40:00',1.53),('15529','2013-03-12','10:45:00',1.38),('15529','2014-03-24','08:50:00',1.03),('15529','2014-03-24','08:55:00',1.07),('15529','2014-03-24','09:15:00',1.29),('15529','2014-03-24','09:20:00',1.34),('15529','2014-03-24','09:25:00',1.12),('15529','2014-03-24','09:55:00',1.17),('15529','2014-03-24','10:00:00',1.31),('15529','2014-03-24','10:05:00',1.45),('15529','2014-03-24','10:10:00',1.58),('15529','2014-03-24','10:15:00',1.69),('15529','2014-03-24','10:20:00',1.57),('15529','2014-03-24','10:25:00',1.64),('15529','2014-03-24','10:30:00',1.59),('15529','2014-03-24','10:35:00',1.25),('15529','2014-03-24','10:40:00',1.03),('15529','2014-03-24','11:00:00',1.07),('15529','2014-03-24','11:05:00',1.2),('15529','2014-03-24','11:10:00',1.39),('15529','2014-03-24','11:15:00',1.51),('15529','2014-03-24','11:20:00',1.45),('15529','2014-03-24','11:25:00',1.65),('15529','2014-03-24','11:30:00',1.71),('15529','2014-03-24','11:35:00',1.63),('15529','2014-03-24','11:40:00',1.42),('15529','2014-03-24','11:50:00',1.18),('15529','2013-03-11','08:20:00',1.12),('15529','2013-03-11','08:25:00',1.14),('15529','2013-03-11','08:35:00',1.22),('15529','2013-03-11','08:40:00',1.08),('15529','2013-03-11','09:00:00',1.54),('15529','2013-03-11','09:05:00',1.55),('15529','2013-03-11','09:10:00',1.58),('15529','2013-03-11','09:15:00',1.6),('15529','2013-03-11','09:20:00',1.64),('15529','2013-03-11','09:25:00',1.7),('15529','2013-03-11','09:30:00',1.74),('15529','2013-03-11','09:35:00',1.79),('15529','2013-03-11','09:40:00',1.52),('15529','2013-03-11','09:45:00',1.73),('15529','2013-03-11','09:50:00',1.92),('15529','2013-03-11','09:55:00',1.99),('15529','2013-03-11','10:00:00',2.05),('15529','2013-03-11','10:05:00',2.1),('15529','2013-03-11','10:10:00',1.8),('15529','2013-03-11','10:15:00',2.19),('15529','2013-03-11','10:20:00',2.23),('15529','2013-03-11','10:25:00',2.3),('15529','2013-03-11','10:30:00',1.43),('15529','2013-03-11','10:35:00',1.5),('15529','2013-03-11','10:40:00',1.83),('15529','2013-03-11','10:45:00',2.14),('15529','2013-03-11','10:50:00',1.96),('15529','2013-03-11','10:55:00',2.14),('15529','2013-03-11','11:00:00',2.33),('15529','2013-03-11','11:05:00',2.57),('15529','2013-03-11','11:10:00',2.15),('15529','2013-03-11','11:15:00',2.39),('15529','2013-03-11','11:20:00',1.13),('15529','2013-03-11','11:25:00',1.55),('15529','2013-03-11','11:30:00',1.11),('15529','2013-03-11','11:40:00',1.05),('15529','2013-03-11','11:45:00',1.07),('15529','2013-03-11','11:50:00',2.42),('15529','2013-03-11','12:00:00',2.37),('15529','2013-03-11','12:05:00',2.6),('15529','2013-03-11','12:10:00',1.94),('15529','2013-03-11','12:20:00',1.25),('15529','2013-03-11','12:25:00',2.2),('15529','2013-03-11','12:30:00',2.23),('15529','2013-03-11','12:35:00',1.7),('15529','2013-03-11','12:40:00',2.03),('15529','2013-03-11','12:45:00',1.96),('15529','2013-03-11','12:50:00',2.07),('15529','2013-03-11','12:55:00',2.34),('15529','2013-03-11','13:00:00',2.59),('15529','2013-03-11','13:05:00',2.26),('15529','2013-03-11','13:10:00',1.93),('15529','2013-03-11','13:15:00',1.62),('15529','2013-03-11','13:20:00',1.25),('15529','2013-03-11','13:25:00',1.02),('15529','2013-03-11','13:40:00',1.68),('15529','2013-03-11','13:45:00',1.28),('15529','2013-03-11','13:50:00',1.65),('15529','2013-03-11','13:55:00',1.42),('15529','2013-03-11','14:00:00',1.38),('15529','2013-03-11','14:20:00',1.14),('15529','2013-03-11','15:15:00',1.45),('15529','2013-03-11','15:20:00',1.37),('15529','2013-03-10','08:15:00',1.01),('15529','2013-03-10','08:20:00',1.07),('15529','2013-03-10','08:25:00',1.12),('15529','2013-03-10','08:30:00',1.18),('15529','2013-03-10','08:35:00',1.24),('15529','2013-03-10','08:40:00',1.27),('15529','2013-03-10','08:45:00',1.33),('15529','2013-03-10','08:50:00',1.4),('15529','2013-03-10','08:55:00',1.43),('15529','2013-03-10','09:00:00',1.48),('15529','2013-03-10','09:05:00',1.52),('15529','2013-03-10','09:10:00',1.56),('15529','2013-03-10','09:15:00',1.62),('15529','2013-03-10','09:20:00',1.71),('15529','2013-03-10','09:25:00',1.65),('15529','2013-03-10','09:30:00',1.16),('15529','2013-03-10','09:40:00',1.36),('15529','2013-03-10','10:35:00',1),('15529','2013-03-10','10:40:00',1.16),('15529','2013-03-10','10:45:00',1.65),('15529','2013-03-10','10:50:00',1.57),('15529','2013-03-10','10:55:00',1.94),('15529','2013-03-10','11:00:00',1.03),('15529','2013-03-10','11:30:00',1.12),('15529','2013-03-10','11:45:00',2.28),('15529','2013-03-10','11:50:00',1.27),('15529','2013-03-10','11:55:00',1.1),('15529','2013-03-10','12:10:00',1.15),('15529','2013-03-10','12:15:00',1.44),('15529','2013-03-10','12:35:00',2.22),('15529','2013-03-10','12:40:00',1.32),('15529','2013-03-10','12:50:00',1.01),('15529','2013-03-10','13:05:00',1.09),('15529','2013-03-10','13:10:00',1.3),('15529','2013-03-10','13:15:00',1.62),('15529','2013-03-10','13:20:00',2.64),('15529','2013-03-10','13:25:00',2.37),('15529','2013-03-10','13:30:00',2.23),('15529','2013-03-10','14:10:00',2.12),('15529','2013-03-10','14:15:00',2.29),('15529','2013-03-10','14:20:00',1.08),('15529','2013-03-10','14:30:00',1.29),('15529','2013-03-10','14:35:00',1.16),('15529','2013-03-10','14:45:00',1.1),('15529','2013-03-10','14:50:00',1.84),('15529','2013-03-10','14:55:00',1.9),('15529','2013-03-10','15:00:00',1.64),('15529','2013-03-10','15:05:00',1.83),('15529','2013-03-10','15:10:00',1.72),('15529','2013-03-10','15:15:00',1.55),('15529','2013-03-10','15:20:00',1.46),('15529','2013-03-10','15:25:00',1.16),('15529','2013-03-10','15:30:00',1.7),('15529','2013-03-10','15:35:00',1.67),('15529','2013-03-10','15:40:00',1.49),('15529','2013-03-10','15:45:00',1.32),('15529','2013-03-10','15:50:00',1.4),('15529','2013-03-10','15:55:00',1.06),('15529','2013-03-10','16:15:00',1.07),('15529','2013-03-10','16:20:00',1.02),('15529','2013-03-09','08:15:00',1.01),('15529','2013-03-09','08:20:00',1.08),('15529','2013-03-09','08:25:00',1.13),('15529','2013-03-09','08:30:00',1.18),('15529','2013-03-09','08:35:00',1.21),('15529','2013-03-09','08:40:00',1.27),('15529','2013-03-09','08:45:00',1.32),('15529','2013-03-09','08:50:00',1.37),('15529','2013-03-09','08:55:00',1.43),('15529','2013-03-09','09:00:00',1.47),('15529','2013-03-09','09:05:00',1.52),('15529','2013-03-09','09:10:00',1.56),('15529','2013-03-09','09:15:00',1.59),('15529','2013-03-09','09:20:00',1.61),('15529','2013-03-09','09:25:00',1.68),('15529','2013-03-09','09:30:00',1.78),('15529','2013-03-09','09:35:00',1.81),('15529','2013-03-09','09:40:00',1.93),('15529','2013-03-09','09:45:00',1.97),('15529','2013-03-09','09:50:00',1.68),('15529','2013-03-09','09:55:00',1.87),('15529','2013-03-09','10:05:00',1.97),('15529','2013-03-09','10:10:00',1.86),('15529','2013-03-09','10:15:00',2.06),('15529','2013-03-09','10:20:00',2.15),('15529','2013-03-09','10:25:00',2.07),('15529','2013-03-09','10:30:00',2.16),('15529','2013-03-09','10:35:00',1.91),('15529','2013-03-09','10:40:00',2.18),('15529','2013-03-09','10:45:00',2.18),('15529','2013-03-09','10:50:00',2.19),('15529','2013-03-09','10:55:00',2.19),('15529','2013-03-09','11:00:00',2.21),('15529','2013-03-09','11:05:00',2.27),('15529','2013-03-09','11:10:00',2.28),('15529','2013-03-09','11:15:00',1.19),('15529','2013-03-09','11:20:00',2.36),('15529','2013-03-09','11:25:00',1.33),('15529','2013-03-09','11:30:00',1.72),('15529','2013-03-09','11:40:00',1.6),('15529','2013-03-09','11:45:00',1.01),('15529','2013-03-09','11:50:00',1.97),('15529','2013-03-09','11:55:00',1.67),('15529','2013-03-09','12:00:00',2.37),('15529','2013-03-09','12:05:00',2.35),('15529','2013-03-09','12:10:00',2.33),('15529','2013-03-09','12:15:00',2.33),('15529','2013-03-09','12:20:00',2.35),('15529','2013-03-09','12:25:00',2.34),('15529','2013-03-09','12:30:00',2.32),('15529','2013-03-09','12:35:00',2.3),('15529','2013-03-09','12:40:00',1.97),('15529','2013-03-09','12:45:00',2.2),('15529','2013-03-09','12:50:00',2.42),('15529','2013-03-09','12:55:00',2.33),('15529','2013-03-09','13:00:00',1.81),('15529','2013-03-09','13:05:00',1.95),('15529','2013-03-09','13:10:00',2.16),('15529','2013-03-09','13:15:00',2.33),('15529','2013-03-09','13:20:00',2.21),('15529','2013-03-09','13:25:00',2.1),('15529','2013-03-09','13:30:00',2.15),('15529','2013-03-09','13:35:00',1.78),('15529','2013-03-09','13:40:00',1.23),('15529','2013-03-09','13:45:00',1.14),('15529','2013-03-09','13:50:00',1.02),('15529','2013-03-09','13:55:00',1),('15529','2013-03-09','14:05:00',1.18),('15529','2013-03-09','14:10:00',1.15),('15529','2013-03-09','14:15:00',1.71),('15529','2013-03-09','14:20:00',1.52),('15529','2013-03-09','14:25:00',1.23),('15529','2013-03-09','14:30:00',1.26),('15529','2013-03-09','14:35:00',1.32),('15529','2013-03-09','14:40:00',1.71),('15529','2013-03-08','08:20:00',1.05),('15529','2013-03-08','08:25:00',1.09),('15529','2013-03-08','08:30:00',1.16),('15529','2013-03-08','08:35:00',1.22),('15529','2013-03-08','08:40:00',1.26),('15529','2013-03-08','08:45:00',1.21),('15529','2013-03-08','08:55:00',1.56),('15529','2013-03-08','09:00:00',1.37),('15529','2013-03-08','09:05:00',1.41),('15529','2013-03-08','09:10:00',1.31),('15529','2013-03-08','09:25:00',1.34),('15529','2013-03-08','09:45:00',1.37),('15529','2013-03-08','09:55:00',1.04),('15529','2013-03-08','10:00:00',2.24),('15529','2013-03-08','10:05:00',2.28),('15529','2013-03-08','10:10:00',2.26),('15529','2013-03-08','10:15:00',2.08),('15529','2013-03-08','10:20:00',1.59),('15529','2013-03-08','10:25:00',1.07),('15529','2013-03-08','10:35:00',1.37),('15529','2013-03-08','10:40:00',2.12),('15529','2013-03-08','10:45:00',2.41),('15529','2013-03-08','10:50:00',1.66),('15529','2013-03-08','10:55:00',2.15),('15529','2013-03-08','11:00:00',2.34),('15529','2013-03-08','11:05:00',2.24),('15529','2013-03-08','11:10:00',2.04),('15529','2013-03-08','11:15:00',1.97),('15529','2013-03-08','11:20:00',2.33),('15529','2013-03-08','11:25:00',2.39),('15529','2013-03-08','11:30:00',2.34),('15529','2013-03-08','11:35:00',2.34),('15529','2013-03-08','11:40:00',2.35),('15529','2013-03-08','11:45:00',2.34),('15529','2013-03-08','11:50:00',2.34),('15529','2013-03-08','11:55:00',2.37),('15529','2013-03-08','12:00:00',2.36),('15529','2013-03-08','12:05:00',2.41),('15529','2013-03-08','12:10:00',2.07),('15529','2013-03-08','12:15:00',1.51),('15529','2013-03-08','12:20:00',1.47),('15529','2013-03-08','12:25:00',2.06),('15529','2013-03-08','12:30:00',2.09),('15529','2013-03-08','12:35:00',1.23),('15529','2013-03-08','12:40:00',2.21),('15529','2013-03-08','12:45:00',2.58),('15529','2013-03-08','12:50:00',2.39),('15529','2013-03-08','12:55:00',2.33),('15529','2013-03-08','13:00:00',2.31),('15529','2013-03-08','13:05:00',2.29),('15529','2013-03-08','13:10:00',2.28),('15529','2013-03-08','13:15:00',2.32),('15529','2013-03-08','13:20:00',2.31),('15529','2013-03-08','13:25:00',2.18),('15529','2013-03-08','13:30:00',2.23),('15529','2013-03-08','13:35:00',2.27),('15529','2013-03-08','13:40:00',2.29),('15529','2013-03-08','13:45:00',1.98),('15529','2013-03-08','13:50:00',1.62),('15529','2013-03-08','13:55:00',1.72),('15529','2013-03-08','14:00:00',2.35),('15529','2013-03-08','14:05:00',2.18),('15529','2013-03-08','14:10:00',1.34),('15529','2013-03-08','14:15:00',1.52),('15529','2013-03-08','14:20:00',2.07),('15529','2013-03-08','14:25:00',1.99),('15529','2013-03-08','14:30:00',1.92),('15529','2013-03-08','14:35:00',1.89),('15529','2013-03-08','14:40:00',1.85),('15529','2013-03-08','14:45:00',1.83),('15529','2013-03-08','14:50:00',1.79),('15529','2013-03-08','14:55:00',1.76),('15529','2013-03-08','15:00:00',1.73),('15529','2013-03-08','15:05:00',1.69),('15529','2013-03-08','15:10:00',1.65),('15529','2013-03-08','15:15:00',1.61),('15529','2013-03-08','15:20:00',1.57),('15529','2013-03-08','15:25:00',1.52),('15529','2013-03-08','15:30:00',1.48),('15529','2013-03-08','15:35:00',1.38),('15529','2013-03-08','15:40:00',1.38),('15529','2013-03-08','15:45:00',1.33),('15529','2013-03-08','15:50:00',1.27),('15529','2013-03-08','15:55:00',1.14),('15529','2013-03-08','16:00:00',1.05),('15529','2013-03-08','16:05:00',1.12),('15529','2013-03-08','16:15:00',1.04),('15529','2013-03-07','09:35:00',1.77),('15529','2013-03-07','09:45:00',1.08),('15529','2013-03-07','09:50:00',1.7),('15529','2013-03-07','09:55:00',1.4),('15529','2013-03-07','10:10:00',1.14),('15529','2013-03-07','10:30:00',1.16),('15529','2013-03-07','11:55:00',1.64),('15529','2013-03-07','12:00:00',1.46),('15529','2013-03-07','12:20:00',1.06),('15529','2013-03-07','12:40:00',1.09),('15529','2013-03-07','12:45:00',1.54),('15529','2013-03-07','12:50:00',1.19),('15529','2013-03-07','12:55:00',1.56),('15529','2013-03-07','13:00:00',1.73),('15529','2013-03-07','13:05:00',1.18),('15529','2013-03-06','11:35:00',1.25),('15529','2013-03-06','11:40:00',1.89),('15529','2013-03-06','11:45:00',1.61),('15529','2013-03-06','11:50:00',1.25),('15529','2013-03-06','12:25:00',1.32),('15529','2013-03-06','12:30:00',1.06),('15529','2013-03-06','13:05:00',1.01),('15529','2013-03-06','13:10:00',1.28),('15529','2013-03-06','13:25:00',1.22),('15529','2013-03-04','08:30:00',1.08),('15529','2013-03-04','08:35:00',1.02),('15529','2013-03-04','10:15:00',1.04),('15529','2013-03-04','10:20:00',1.1),('15529','2013-03-04','10:30:00',1.11),('15529','2013-03-04','10:35:00',1.32),('15529','2013-03-04','10:40:00',1.32),('15529','2013-03-04','10:45:00',1.39),('15529','2013-03-04','10:50:00',1.53),('15529','2013-03-04','10:55:00',1.46),('15529','2013-03-04','11:00:00',1.38),('15529','2013-03-04','11:05:00',1.54),('15529','2013-03-04','11:10:00',1.55),('15529','2013-03-04','11:15:00',1.51),('15529','2013-03-04','11:20:00',1.44),('15529','2013-03-04','11:25:00',1.41),('15529','2013-03-04','11:30:00',1.47),('15529','2013-03-04','11:35:00',1.65),('15529','2013-03-04','11:40:00',1.74),('15529','2013-03-04','11:45:00',1.7),('15529','2013-03-04','11:50:00',1.75),('15529','2013-03-04','11:55:00',1.81),('15529','2013-03-04','12:00:00',1.88),('15529','2013-03-04','12:05:00',1.91),('15529','2013-03-04','12:10:00',2.02),('15529','2013-03-04','12:15:00',1.54),('15529','2013-03-04','12:20:00',1.88),('15529','2013-03-04','12:25:00',1.76),('15529','2013-03-04','12:30:00',1.42),('15529','2013-03-04','12:35:00',1.22),('15529','2013-03-04','12:40:00',1.42),('15529','2013-03-04','12:45:00',1.43),('15529','2013-03-04','12:50:00',1.23),('15529','2013-03-04','12:55:00',1.01),('15529','2013-03-03','08:25:00',1.03),('15529','2013-03-03','08:30:00',1.08),('15529','2013-03-03','08:35:00',1.14),('15529','2013-03-03','08:40:00',1.19),('15529','2013-03-03','08:45:00',1.24),('15529','2013-03-03','08:50:00',1.28),('15529','2013-03-03','08:55:00',1.33),('15529','2013-03-03','09:00:00',1.36),('15529','2013-03-03','09:05:00',1.41),('15529','2013-03-03','09:10:00',1.45),('15529','2013-03-03','09:15:00',1.5),('15529','2013-03-03','09:20:00',1.54),('15529','2013-03-03','09:25:00',1.58),('15529','2013-03-03','09:30:00',1.61),('15529','2013-03-03','09:35:00',1.67),('15529','2013-03-03','09:40:00',1.69),('15529','2013-03-03','09:45:00',1.73),('15529','2013-03-03','09:50:00',1.75),('15529','2013-03-03','09:55:00',1.79),('15529','2013-03-03','10:00:00',1.83),('15529','2013-03-03','10:05:00',1.84),('15529','2013-03-03','10:10:00',1.88),('15529','2013-03-03','10:15:00',1.91),('15529','2013-03-03','10:20:00',1.93),('15529','2013-03-03','10:25:00',1.94),('15529','2013-03-03','10:30:00',1.98),('15529','2013-03-03','10:35:00',2),('15529','2013-03-03','10:40:00',2.03),('15529','2013-03-03','10:45:00',2.04),('15529','2013-03-03','10:50:00',2.04),('15529','2013-03-03','10:55:00',2.07),('15529','2013-03-03','11:00:00',2.07),('15529','2013-03-03','11:05:00',2.12),('15529','2013-03-03','11:10:00',2.1),('15529','2013-03-03','11:15:00',2.13),('15529','2013-03-03','11:20:00',2.17),('15529','2013-03-03','11:25:00',2.17),('15529','2013-03-03','11:30:00',2.16),('15529','2013-03-03','11:35:00',2.16),('15529','2013-03-03','11:40:00',2.19),('15529','2013-03-03','11:45:00',2.16),('15529','2013-03-03','11:50:00',2.17),('15529','2013-03-03','11:55:00',2.16),('15529','2013-03-03','12:00:00',2.17),('15529','2013-03-03','12:05:00',2.16),('15529','2013-03-03','12:10:00',2.21),('15529','2013-03-03','12:15:00',2.23),('15529','2013-03-03','12:20:00',2.21),('15529','2013-03-03','12:25:00',2.25),('15529','2013-03-03','12:30:00',2.28),('15529','2013-03-03','12:35:00',2.23),('15529','2013-03-03','12:40:00',2.18),('15529','2013-03-03','12:45:00',2.16),('15529','2013-03-03','12:50:00',2.17),('15529','2013-03-03','12:55:00',2.16),('15529','2013-03-03','13:00:00',2.13),('15529','2013-03-03','13:05:00',2.12),('15529','2013-03-03','13:10:00',2.08),('15529','2013-03-03','13:15:00',2.05),('15529','2013-03-03','13:20:00',2.09),('15529','2013-03-03','13:25:00',2.11),('15529','2013-03-03','13:30:00',2.11),('15529','2013-03-03','13:35:00',2.17),('15529','2013-03-03','13:40:00',2.08),('15529','2013-03-03','13:45:00',1.97),('15529','2013-03-03','13:50:00',2.01),('15529','2013-03-03','13:55:00',1.96),('15529','2013-03-03','14:00:00',1.91),('15529','2013-03-03','14:05:00',1.86),('15529','2013-03-03','14:10:00',1.83),('15529','2013-03-03','14:15:00',1.82),('15529','2013-03-03','14:20:00',1.78),('15529','2013-03-03','14:25:00',1.75),('15529','2013-03-03','14:30:00',1.74),('15529','2013-03-03','14:35:00',1.71),('15529','2013-03-03','14:40:00',1.65),('15529','2013-03-03','14:45:00',1.61),('15529','2013-03-03','14:50:00',1.61),('15529','2013-03-03','14:55:00',1.55),('15529','2013-03-03','15:00:00',1.51),('15529','2013-03-03','15:05:00',1.5),('15529','2013-03-03','15:10:00',1.48),('15529','2013-03-03','15:15:00',1.42),('15529','2013-03-03','15:20:00',1.4),('15529','2013-03-03','15:25:00',1.36),('15529','2013-03-03','15:30:00',1.3),('15529','2013-03-03','15:35:00',1.27),('15529','2013-03-03','15:40:00',1.22),('15529','2013-03-03','15:45:00',1.17),('15529','2013-03-03','15:50:00',1.13),('15529','2013-03-03','15:55:00',1.09),('15529','2013-03-03','16:00:00',1.03),('15529','2013-03-02','08:20:00',1.03),('15529','2013-03-02','08:25:00',1.09),('15529','2013-03-02','08:30:00',1.14),('15529','2013-03-02','08:35:00',1.2),('15529','2013-03-02','08:40:00',1.25),('15529','2013-03-02','08:45:00',1.31),('15529','2013-03-02','08:50:00',1.36),('15529','2013-03-02','08:55:00',1.41),('15529','2013-03-02','09:00:00',1.45),('15529','2013-03-02','09:05:00',1.49),('15529','2013-03-02','09:10:00',1.54),('15529','2013-03-02','09:15:00',1.59),('15529','2013-03-02','09:20:00',1.62),('15529','2013-03-02','09:25:00',1.66),('15529','2013-03-02','09:30:00',1.7),('15529','2013-03-02','09:35:00',1.74),('15529','2013-03-02','09:40:00',1.77),('15529','2013-03-02','09:45:00',1.79),('15529','2013-03-02','09:50:00',1.83),('15529','2013-03-02','09:55:00',1.86),('15529','2013-03-02','10:00:00',1.89),('15529','2013-03-02','10:05:00',1.92),('15529','2013-03-02','10:10:00',1.97),('15529','2013-03-02','10:15:00',2.01),('15529','2013-03-02','10:20:00',2.05),('15529','2013-03-02','10:25:00',2.06),('15529','2013-03-02','10:30:00',2.07),('15529','2013-03-02','10:35:00',2.09),('15529','2013-03-02','10:40:00',2.11),('15529','2013-03-02','10:45:00',2.11),('15529','2013-03-02','10:50:00',2.13),('15529','2013-03-02','10:55:00',2.16),('15529','2013-03-02','11:00:00',2.14),('15529','2013-03-02','11:05:00',2.15),('15529','2013-03-02','11:10:00',2.17),('15529','2013-03-02','11:15:00',2.2),('15529','2013-03-02','11:20:00',2.23),('15529','2013-03-02','11:25:00',2.23),('15529','2013-03-02','11:30:00',2.24),('15529','2013-03-02','11:35:00',2.27),('15529','2013-03-02','11:40:00',2.22),('15529','2013-03-02','11:45:00',2.27),('15529','2013-03-02','11:50:00',2.26),('15529','2013-03-02','11:55:00',2.29),('15529','2013-03-02','12:00:00',2.28),('15529','2013-03-02','12:05:00',2.3),('15529','2013-03-02','12:10:00',2.27),('15529','2013-03-02','12:15:00',2.26),('15529','2013-03-02','12:20:00',2.28),('15529','2013-03-02','12:25:00',2.25),('15529','2013-03-02','12:30:00',2.26),('15529','2013-03-02','12:35:00',2.25),('15529','2013-03-02','12:40:00',2.24),('15529','2013-03-02','12:45:00',2.29),('15529','2013-03-02','12:50:00',2.23),('15529','2013-03-02','12:55:00',2.22),('15529','2013-03-02','13:00:00',2.23),('15529','2013-03-02','13:05:00',2.21),('15529','2013-03-02','13:10:00',2.22),('15529','2013-03-02','13:15:00',2.21),('15529','2013-03-02','13:20:00',2.16),('15529','2013-03-02','13:25:00',2.15),('15529','2013-03-02','13:30:00',2.15),('15529','2013-03-02','13:35:00',2.14),('15529','2013-03-02','13:40:00',2.1),('15529','2013-03-02','13:45:00',2.09),('15529','2013-03-02','13:50:00',2.08),('15529','2013-03-02','13:55:00',2.08),('15529','2013-03-02','14:00:00',2.06),('15529','2013-03-02','14:05:00',2.04),('15529','2013-03-02','14:10:00',2.01),('15529','2013-03-02','14:15:00',1.97),('15529','2013-03-02','14:20:00',1.95),('15529','2013-03-02','14:25:00',1.93),('15529','2013-03-02','14:30:00',1.88),('15529','2013-03-02','14:35:00',1.86),('15529','2013-03-02','14:40:00',1.82),('15529','2013-03-02','14:45:00',1.78),('15529','2013-03-02','14:50:00',1.75),('15529','2013-03-02','14:55:00',1.72),('15529','2013-03-02','15:00:00',1.7),('15529','2013-03-02','15:05:00',1.67),('15529','2013-03-02','15:10:00',1.64),('15529','2013-03-02','15:15:00',1.59),('15529','2013-03-02','15:20:00',1.56),('15529','2013-03-02','15:25:00',1.51),('15529','2013-03-02','15:30:00',1.47),('15529','2013-03-02','15:35:00',1.42),('15529','2013-03-02','15:40:00',1.38),('15529','2013-03-02','15:45:00',1.33),('15529','2013-03-02','15:50:00',1.28),('15529','2013-03-02','15:55:00',1.23),('15529','2013-03-02','16:00:00',1.17),('15529','2013-03-02','16:05:00',1.12),('15529','2013-03-02','16:10:00',1.07),('15529','2013-03-02','16:15:00',1.01),('15529','2014-03-23','08:55:00',1.09),('15529','2014-03-23','09:40:00',1.19),('15529','2014-03-23','10:00:00',1.49),('15529','2014-03-23','10:05:00',1.95),('15529','2014-03-23','10:10:00',2.23),('15529','2014-03-23','10:35:00',1.01),('15529','2014-03-23','10:45:00',1.68),('15529','2014-03-23','10:50:00',2.6),('15529','2014-03-23','10:55:00',1.38),('15529','2014-03-23','11:00:00',1.32),('15529','2014-03-23','11:10:00',1.69),('15529','2014-03-23','11:15:00',1.97),('15529','2014-03-23','11:20:00',1.72),('15529','2014-03-23','11:25:00',1.3),('15529','2014-03-23','11:30:00',1.43),('15529','2014-03-23','12:35:00',1.01),('15529','2014-03-23','14:20:00',1.12),('15529','2014-03-23','14:25:00',1.02),('15529','2014-03-23','14:30:00',1.2),('15529','2014-03-23','14:35:00',1.4),('15529','2014-03-23','14:40:00',1.66),('15529','2014-03-23','14:45:00',1.93),('15529','2014-03-23','14:50:00',1.71),('15529','2014-03-23','14:55:00',1.53),('15529','2014-03-23','15:00:00',1.34),('15529','2014-03-23','15:05:00',1.23),('15529','2014-03-23','15:10:00',1.02),('15529','2014-03-23','15:55:00',1.52),('15529','2013-03-01','12:30:00',1.09),('15529','2013-03-01','12:35:00',1.19),('15529','2013-03-01','12:40:00',1.76),('15529','2013-03-01','12:45:00',1.61),('15529','2013-03-01','12:50:00',1.35),('15529','2013-02-28','08:55:00',1.03),('15529','2013-02-28','09:00:00',1.15),('15529','2013-02-28','09:05:00',1.19),('15529','2013-02-28','09:10:00',1.18),('15529','2013-02-28','09:15:00',1.21),('15529','2013-02-28','09:20:00',1.24),('15529','2013-02-28','09:25:00',1.36),('15529','2013-02-28','09:30:00',1.37),('15529','2013-02-28','09:35:00',1.38),('15529','2013-02-28','09:40:00',1.5),('15529','2013-02-28','09:45:00',1.53),('15529','2013-02-28','09:50:00',1.51),('15529','2013-02-28','09:55:00',1.45),('15529','2013-02-28','10:00:00',1.44),('15529','2013-02-28','10:05:00',1.37),('15529','2013-02-28','10:10:00',1.31),('15529','2013-02-28','10:15:00',1.16),('15529','2013-02-28','10:20:00',1.18),('15529','2013-02-28','10:25:00',1.28),('15529','2013-02-28','10:30:00',1.54),('15529','2013-02-28','10:35:00',1.43),('15529','2013-02-28','10:40:00',1.28),('15529','2013-02-28','10:45:00',1.22),('15529','2013-02-28','10:50:00',1.14),('15529','2013-02-28','10:55:00',1.03),('15529','2013-02-27','08:40:00',1.03),('15529','2013-02-27','08:45:00',1.11),('15529','2013-02-27','08:50:00',1.18),('15529','2013-02-27','08:55:00',1.25),('15529','2013-02-27','09:00:00',1.3),('15529','2013-02-27','09:05:00',1.34),('15529','2013-02-27','09:10:00',1.34),('15529','2013-02-27','09:15:00',1.42),('15529','2013-02-27','09:20:00',1.46),('15529','2013-02-27','09:25:00',1.48),('15529','2013-02-27','09:30:00',1.52),('15529','2013-02-27','09:35:00',1.55),('15529','2013-02-27','09:40:00',1.61),('15529','2013-02-27','09:45:00',1.65),('15529','2013-02-27','09:50:00',1.57),('15529','2013-02-27','09:55:00',1.69),('15529','2013-02-27','10:00:00',1.71),('15529','2013-02-27','10:05:00',1.77),('15529','2013-02-27','10:10:00',1.79),('15529','2013-02-27','10:15:00',1.8),('15529','2013-02-27','10:20:00',1.81),('15529','2013-02-27','10:25:00',1.84),('15529','2013-02-27','10:30:00',1.85),('15529','2013-02-27','10:35:00',1.89),('15529','2013-02-27','10:40:00',1.9),('15529','2013-02-27','10:45:00',1.88),('15529','2013-02-27','10:50:00',1.91),('15529','2013-02-27','10:55:00',1.95),('15529','2013-02-27','11:00:00',2),('15529','2013-02-27','11:05:00',1.99),('15529','2013-02-27','11:10:00',2),('15529','2013-02-27','11:15:00',2),('15529','2013-02-27','11:20:00',2.03),('15529','2013-02-27','11:25:00',2.08),('15529','2013-02-27','11:30:00',2.13),('15529','2013-02-27','11:35:00',2.14),('15529','2013-02-27','11:40:00',2.05),('15529','2013-02-27','11:45:00',2.03),('15529','2013-02-27','11:50:00',2.11),('15529','2013-02-27','11:55:00',2.12),('15529','2013-02-27','12:00:00',2.09),('15529','2013-02-27','12:05:00',2.09),('15529','2013-02-27','12:10:00',2.08),('15529','2013-02-27','12:15:00',2.17),('15529','2013-02-27','12:20:00',2.22),('15529','2013-02-27','12:25:00',2.13),('15529','2013-02-27','12:30:00',2.17),('15529','2013-02-27','12:35:00',2.15),('15529','2013-02-27','12:40:00',2.13),('15529','2013-02-27','12:45:00',2.08),('15529','2013-02-27','12:50:00',2.08),('15529','2013-02-27','12:55:00',2.08),('15529','2013-02-27','13:00:00',1.96),('15529','2013-02-27','13:05:00',2.09),('15529','2013-02-27','13:10:00',2.03),('15529','2013-02-27','13:20:00',1.4),('15529','2013-02-27','13:25:00',1.47),('15529','2013-02-27','13:30:00',1.6),('15529','2013-02-27','13:35:00',1.86),('15529','2013-02-27','13:40:00',1.93),('15529','2013-02-27','13:45:00',1.54),('15529','2013-02-27','13:50:00',1.88),('15529','2013-02-27','13:55:00',1.87),('15529','2013-02-27','14:00:00',1.83),('15529','2013-02-27','14:05:00',1.75),('15529','2013-02-27','14:10:00',1.8),('15529','2013-02-27','14:15:00',1.82),('15529','2013-02-27','14:20:00',1.73),('15529','2013-02-27','14:25:00',1.78),('15529','2013-02-27','14:30:00',1.78),('15529','2013-02-27','14:35:00',1.62),('15529','2013-02-27','14:40:00',1.68),('15529','2013-02-27','14:45:00',1.64),('15529','2013-02-27','14:50:00',1.62),('15529','2013-02-27','14:55:00',1.56),('15529','2013-02-27','15:00:00',1.53),('15529','2013-02-27','15:05:00',1.53),('15529','2013-02-27','15:10:00',1.49),('15529','2013-02-27','15:15:00',1.41),('15529','2013-02-27','15:20:00',1.36),('15529','2013-02-27','15:25:00',1.29),('15529','2013-02-27','15:30:00',1.22),('15529','2013-02-27','15:35:00',1.18),('15529','2013-02-27','15:40:00',1.14),('15529','2013-02-27','15:45:00',1.09),('15529','2013-02-27','15:50:00',1.06),('15529','2013-02-27','15:55:00',1.02),('15529','2013-02-26','08:40:00',1.05),('15529','2013-02-26','08:45:00',1.12),('15529','2013-02-26','08:50:00',1.15),('15529','2013-02-26','08:55:00',1.19),('15529','2013-02-26','09:00:00',1.24),('15529','2013-02-26','09:05:00',1.29),('15529','2013-02-26','09:10:00',1.34),('15529','2013-02-26','09:15:00',1.39),('15529','2013-02-26','09:20:00',1.43),('15529','2013-02-26','09:25:00',1.47),('15529','2013-02-26','09:30:00',1.51),('15529','2013-02-26','09:35:00',1.56),('15529','2013-02-26','09:40:00',1.6),('15529','2013-02-26','09:45:00',1.63),('15529','2013-02-26','09:50:00',1.68),('15529','2013-02-26','09:55:00',1.71),('15529','2013-02-26','10:00:00',1.74),('15529','2013-02-26','10:05:00',1.77),('15529','2013-02-26','10:10:00',1.78),('15529','2013-02-26','10:15:00',1.81),('15529','2013-02-26','10:20:00',1.84),('15529','2013-02-26','10:25:00',1.89),('15529','2013-02-26','10:30:00',1.92),('15529','2013-02-26','10:35:00',1.93),('15529','2013-02-26','10:40:00',1.95),('15529','2013-02-26','10:45:00',2),('15529','2013-02-26','10:50:00',1.94),('15529','2013-02-26','10:55:00',1.96),('15529','2013-02-26','11:00:00',1.97),('15529','2013-02-26','11:05:00',2.04),('15529','2013-02-26','11:10:00',2.07),('15529','2013-02-26','11:15:00',1.91),('15529','2013-02-26','11:25:00',1.59),('15529','2013-02-26','11:30:00',2.17),('15529','2013-02-26','11:35:00',2.08),('15529','2013-02-26','11:40:00',2.09),('15529','2013-02-26','11:45:00',2.24),('15529','2013-02-26','11:50:00',2.2),('15529','2013-02-26','11:55:00',1.26),('15529','2013-02-26','12:00:00',2.1),('15529','2013-02-26','12:05:00',2.31),('15529','2013-02-26','12:10:00',2.27),('15529','2013-02-26','12:15:00',2.24),('15529','2013-02-26','12:20:00',2.25),('15529','2013-02-26','12:25:00',2.27),('15529','2013-02-26','12:30:00',2.25),('15529','2013-02-26','12:35:00',2.25),('15529','2013-02-26','12:40:00',2.24),('15529','2013-02-26','12:45:00',2.24),('15529','2013-02-26','12:50:00',2.23),('15529','2013-02-26','12:55:00',2.21),('15529','2013-02-26','13:00:00',2.19),('15529','2013-02-26','13:05:00',2.13),('15529','2013-02-26','13:10:00',2.17),('15529','2013-02-26','13:15:00',2.14),('15529','2013-02-26','13:20:00',2.19),('15529','2013-02-26','13:25:00',2.19),('15529','2013-02-26','13:30:00',2.24),('15529','2013-02-26','13:35:00',2.2),('15529','2013-02-26','13:40:00',2.15),('15529','2013-02-26','13:45:00',2.14),('15529','2013-02-26','13:50:00',2.05),('15529','2013-02-26','13:55:00',2.06),('15529','2013-02-26','14:00:00',2.02),('15529','2013-02-26','14:05:00',1.97),('15529','2013-02-26','14:10:00',1.28),('15529','2013-02-26','14:15:00',1.09),('15529','2013-02-26','14:20:00',1.68),('15529','2013-02-26','14:25:00',1.86),('15529','2013-02-26','14:30:00',1.83),('15529','2013-02-26','14:35:00',1.79),('15529','2013-02-26','14:40:00',1.78),('15529','2013-02-26','14:45:00',1.76),('15529','2013-02-26','14:50:00',1.65),('15529','2013-02-26','15:00:00',1.17),('15529','2013-02-26','15:05:00',1.73),('15529','2013-02-26','15:10:00',1.63),('15529','2013-02-26','15:15:00',1.47),('15529','2013-02-26','15:20:00',1.41),('15529','2013-02-26','15:25:00',1.37),('15529','2013-02-26','15:30:00',1.33),('15529','2013-02-26','15:35:00',1.3),('15529','2013-02-26','15:40:00',1.25),('15529','2013-02-26','15:45:00',1.19),('15529','2013-02-26','15:50:00',1.15),('15529','2013-02-26','15:55:00',1.1),('15529','2013-02-26','16:00:00',1.05),('15529','2013-02-26','16:05:00',1.01),('15529','2013-02-25','09:45:00',1.21),('15529','2013-02-25','09:50:00',1.31),('15529','2013-02-25','09:55:00',1.44),('15529','2013-02-25','10:00:00',1.45),('15529','2013-02-25','10:05:00',1.38),('15529','2013-02-25','10:10:00',1.45),('15529','2013-02-25','10:15:00',1.6),('15529','2013-02-25','10:20:00',1.93),('15529','2013-02-25','10:25:00',1.42),('15529','2013-02-25','10:30:00',1.83),('15529','2013-02-25','10:35:00',1.8),('15529','2013-02-25','10:40:00',1.05),('15529','2013-02-25','10:45:00',1.03),('15529','2013-02-25','10:50:00',1.08),('15529','2013-02-25','10:55:00',1.37),('15529','2013-02-25','11:00:00',1.32),('15529','2013-02-25','11:05:00',1.51),('15529','2013-02-25','11:10:00',1),('15529','2013-02-25','11:15:00',1.08),('15529','2013-02-25','11:20:00',1.04),('15529','2013-02-25','11:25:00',1.15),('15529','2013-02-25','11:30:00',1.12),('15529','2013-02-25','11:35:00',1.35),('15529','2013-02-25','11:40:00',1.02),('15529','2013-02-25','11:45:00',1.22),('15529','2013-02-25','11:50:00',1.21),('15529','2013-02-25','11:55:00',1.04),('15529','2013-02-25','12:00:00',1.03),('15529','2013-02-24','10:45:00',1.15),('15529','2013-02-24','10:50:00',2.51),('15529','2013-02-24','10:55:00',2.6),('15529','2013-02-24','11:00:00',2),('15529','2013-02-24','11:05:00',1.89),('15529','2013-02-24','11:10:00',2.38),('15529','2013-02-24','11:15:00',1.51),('15529','2013-02-24','11:20:00',1.89),('15529','2013-02-24','11:25:00',2.13),('15529','2013-02-24','11:30:00',1.39),('15529','2013-02-24','11:35:00',1.75),('15529','2013-02-24','11:40:00',1.87),('15529','2013-02-24','11:45:00',1.63),('15529','2013-02-24','11:50:00',1.36),('15529','2013-02-24','12:05:00',1.81),('15529','2013-02-24','12:10:00',1.36),('15529','2013-02-24','12:15:00',2.18),('15529','2013-02-24','12:20:00',2.26),('15529','2013-02-24','12:25:00',1.61),('15529','2013-02-24','12:30:00',2.6),('15529','2013-02-24','12:35:00',2.16),('15529','2013-02-24','12:40:00',2.33),('15529','2013-02-24','12:50:00',1.84),('15529','2013-02-24','12:55:00',2.42),('15529','2013-02-24','13:00:00',1.88),('15529','2013-02-24','13:40:00',1.09),('15529','2013-02-23','10:50:00',1.12),('15529','2013-02-23','14:05:00',1.17),('15529','2013-02-23','15:05:00',1.52),('15529','2013-02-23','15:20:00',1.33),('15529','2013-02-23','15:30:00',1.12),('15529','2013-02-23','15:35:00',1.08),('15529','2013-02-23','15:55:00',1.1),('15529','2013-02-22','08:10:00',1),('15529','2013-02-22','14:05:00',1.15),('15529','2013-02-21','16:15:00',1.07),('15529','2013-02-20','16:20:00',1.03),('15529','2014-03-22','09:05:00',1.32),('15529','2014-03-22','09:10:00',1.59),('15529','2014-03-22','09:15:00',1.28),('15529','2014-03-22','11:35:00',1.58),('15529','2014-03-22','11:40:00',1.72),('15529','2014-03-22','13:45:00',1.11),('15529','2014-03-22','15:25:00',1.09),('15529','2013-02-19','08:35:00',1.05),('15529','2013-02-19','08:40:00',1.1),('15529','2013-02-19','08:45:00',1.15),('15529','2013-02-19','08:50:00',1.21),('15529','2013-02-19','08:55:00',1.21),('15529','2013-02-19','09:20:00',1.15),('15529','2013-02-19','09:25:00',1.41),('15529','2013-02-19','09:30:00',1.69),('15529','2013-02-19','09:35:00',1.27),('15529','2013-02-19','09:45:00',1.39),('15529','2013-02-19','09:50:00',1.65),('15529','2013-02-19','10:45:00',1.39),('15529','2013-02-19','10:50:00',2.28),('15529','2013-02-19','10:55:00',1.74),('15529','2013-02-19','11:00:00',1.66),('15529','2013-02-19','11:05:00',2.38),('15529','2013-02-19','11:10:00',2.41),('15529','2013-02-19','11:15:00',2.4),('15529','2013-02-19','11:20:00',2.42),('15529','2013-02-19','11:25:00',2.42),('15529','2013-02-19','11:30:00',2.52),('15529','2013-02-19','11:35:00',2.42),('15529','2013-02-19','11:40:00',2.55),('15529','2013-02-19','11:45:00',2.46),('15529','2013-02-19','11:50:00',2.52),('15529','2013-02-19','11:55:00',1.13),('15529','2013-02-19','12:15:00',1.23),('15529','2013-02-19','12:20:00',1.16),('15529','2013-02-19','12:25:00',1.32),('15529','2013-02-19','12:30:00',2.66),('15529','2013-02-19','12:35:00',1.43),('15529','2013-02-19','12:40:00',1.97),('15529','2013-02-19','12:45:00',2.18),('15529','2013-02-19','12:50:00',1.71),('15529','2013-02-19','12:55:00',1.07),('15529','2013-02-19','13:00:00',2.08),('15529','2013-02-19','13:05:00',2.37),('15529','2013-02-19','13:10:00',2.25),('15529','2013-02-19','13:15:00',1.14),('15529','2013-02-19','13:40:00',2.32),('15529','2013-02-19','13:50:00',1.56),('15529','2013-02-19','13:55:00',1.37),('15529','2013-02-19','14:45:00',1.13),('15529','2013-02-19','14:50:00',1.44),('15529','2013-02-19','14:55:00',1.75),('15529','2013-02-19','15:00:00',1.05),('15529','2013-02-19','15:10:00',1.24),('15529','2013-02-19','15:15:00',1.13),('15529','2013-02-19','16:05:00',1.21),('15529','2013-02-18','08:35:00',1.02),('15529','2013-02-18','08:40:00',1.08),('15529','2013-02-18','08:45:00',1.13),('15529','2013-02-18','08:50:00',1.17),('15529','2013-02-18','08:55:00',1.23),('15529','2013-02-18','09:00:00',1.27),('15529','2013-02-18','09:05:00',1.32),('15529','2013-02-18','09:10:00',1.37),('15529','2013-02-18','09:15:00',1.41),('15529','2013-02-18','09:20:00',1.45),('15529','2013-02-18','09:25:00',1.48),('15529','2013-02-18','09:30:00',1.53),('15529','2013-02-18','09:35:00',1.56),('15529','2013-02-18','09:40:00',1.61),('15529','2013-02-18','09:45:00',1.65),('15529','2013-02-18','09:50:00',1.68),('15529','2013-02-18','09:55:00',1.72),('15529','2013-02-18','10:00:00',1.74),('15529','2013-02-18','10:05:00',1.78),('15529','2013-02-18','10:10:00',1.81),('15529','2013-02-18','10:15:00',1.82),('15529','2013-02-18','10:20:00',1.86),('15529','2013-02-18','10:25:00',1.89),('15529','2013-02-18','10:30:00',1.92),('15529','2013-02-18','10:35:00',1.95),('15529','2013-02-18','10:40:00',1.94),('15529','2013-02-18','10:45:00',1.94),('15529','2013-02-18','10:50:00',2),('15529','2013-02-18','10:55:00',2.02),('15529','2013-02-18','11:00:00',2.01),('15529','2013-02-18','11:05:00',2.05),('15529','2013-02-18','11:10:00',2.06),('15529','2013-02-18','11:15:00',2.06),('15529','2013-02-18','11:20:00',2.1),('15529','2013-02-18','11:25:00',2.11),('15529','2013-02-18','11:30:00',2.13),('15529','2013-02-18','11:35:00',2.14),('15529','2013-02-18','11:40:00',2.13),('15529','2013-02-18','11:45:00',2.14),('15529','2013-02-18','11:50:00',2.16),('15529','2013-02-18','11:55:00',2.17),('15529','2013-02-18','12:00:00',2.16),('15529','2013-02-18','12:05:00',2.17),('15529','2013-02-18','12:10:00',2.18),('15529','2013-02-18','12:15:00',2.15),('15529','2013-02-18','12:20:00',2.15),('15529','2013-02-18','12:25:00',2.17),('15529','2013-02-18','12:30:00',2.17),('15529','2013-02-18','12:35:00',2.17),('15529','2013-02-18','12:40:00',2.16),('15529','2013-02-18','12:45:00',2.17),('15529','2013-02-18','12:50:00',2.16),('15529','2013-02-18','12:55:00',2.15),('15529','2013-02-18','13:00:00',2.14),('15529','2013-02-18','13:05:00',2.12),('15529','2013-02-18','13:10:00',2.12),('15529','2013-02-18','13:15:00',2.1),('15529','2013-02-18','13:20:00',2.08),('15529','2013-02-18','13:25:00',2.07),('15529','2013-02-18','13:30:00',1.99),('15529','2013-02-18','13:35:00',1.94),('15529','2013-02-18','13:40:00',2),('15529','2013-02-18','13:45:00',1.98),('15529','2013-02-18','13:50:00',1.88),('15529','2013-02-18','13:55:00',1.83),('15529','2013-02-18','14:00:00',1.89),('15529','2013-02-18','14:05:00',1.73),('15529','2013-02-18','14:10:00',1.56),('15529','2013-02-18','14:15:00',1.82),('15529','2013-02-18','14:20:00',1.75),('15529','2013-02-18','14:25:00',1.74),('15529','2013-02-18','14:30:00',1.72),('15529','2013-02-18','14:35:00',1.71),('15529','2013-02-18','14:40:00',1.67),('15529','2013-02-18','14:45:00',1.66),('15529','2013-02-18','14:50:00',1.62),('15529','2013-02-18','14:55:00',1.59),('15529','2013-02-18','15:00:00',1.54),('15529','2013-02-18','15:05:00',1.5),('15529','2013-02-18','15:10:00',1.5),('15529','2013-02-18','15:15:00',1.47),('15529','2013-02-18','15:20:00',1.41),('15529','2013-02-18','15:25:00',1.34),('15529','2013-02-18','15:30:00',1.31),('15529','2013-02-18','15:35:00',1.25),('15529','2013-02-18','15:40:00',1.18),('15529','2013-02-18','15:45:00',1.15),('15529','2013-02-18','15:50:00',1.13),('15529','2013-02-18','15:55:00',1.09),('15529','2013-02-18','16:00:00',1.03),('15529','2013-02-17','08:45:00',1.04),('15529','2013-02-17','08:50:00',1.1),('15529','2013-02-17','08:55:00',1.15),('15529','2013-02-17','09:00:00',1.19),('15529','2013-02-17','09:05:00',1.25),('15529','2013-02-17','09:10:00',1.26),('15529','2013-02-17','09:15:00',1.38),('15529','2013-02-17','09:20:00',1.48),('15529','2013-02-17','09:25:00',1.13),('15529','2013-02-17','11:50:00',1.04),('15529','2013-02-17','11:55:00',1.32),('15529','2013-02-17','12:00:00',1),('15529','2013-02-16','08:40:00',1.02),('15529','2013-02-16','08:55:00',1.13),('15529','2013-02-16','09:00:00',1.07),('15529','2013-02-16','09:05:00',1.19),('15529','2013-02-16','09:10:00',1.24),('15529','2013-02-16','09:15:00',1.32),('15529','2013-02-16','09:20:00',1.35),('15529','2013-02-16','09:25:00',1.41),('15529','2013-02-16','09:30:00',1.43),('15529','2013-02-16','09:35:00',1.48),('15529','2013-02-16','09:40:00',1.51),('15529','2013-02-16','09:45:00',1.54),('15529','2013-02-16','09:50:00',1.58),('15529','2013-02-16','09:55:00',1.63),('15529','2013-02-16','10:00:00',1.64),('15529','2013-02-16','10:05:00',1.68),('15529','2013-02-16','10:10:00',1.71),('15529','2013-02-16','10:15:00',1.75),('15529','2013-02-16','10:20:00',1.76),('15529','2013-02-16','10:25:00',1.79),('15529','2013-02-16','10:30:00',1.8),('15529','2013-02-16','10:35:00',1.83),('15529','2013-02-16','10:40:00',1.85),('15529','2013-02-16','10:45:00',1.88),('15529','2013-02-16','10:50:00',1.9),('15529','2013-02-16','10:55:00',1.94),('15529','2013-02-16','11:00:00',1.95),('15529','2013-02-16','11:05:00',1.97),('15529','2013-02-16','11:10:00',1.98),('15529','2013-02-16','11:15:00',2.03),('15529','2013-02-16','11:20:00',2.03),('15529','2013-02-16','11:25:00',2.03),('15529','2013-02-16','11:30:00',2.05),('15529','2013-02-16','11:35:00',2.06),('15529','2013-02-16','11:40:00',2.07),('15529','2013-02-16','11:45:00',2.1),('15529','2013-02-16','11:50:00',2.11),('15529','2013-02-16','11:55:00',2.12),('15529','2013-02-16','12:00:00',2.1),('15529','2013-02-16','12:05:00',2.09),('15529','2013-02-16','12:10:00',2.09),('15529','2013-02-16','12:15:00',2.11),('15529','2013-02-16','12:20:00',2.09),('15529','2013-02-16','12:25:00',2.11),('15529','2013-02-16','12:30:00',2.1),('15529','2013-02-16','12:35:00',2.11),('15529','2013-02-16','12:40:00',2.08),('15529','2013-02-16','12:45:00',2.05),('15529','2013-02-16','12:50:00',2.03),('15529','2013-02-16','12:55:00',2.02),('15529','2013-02-16','13:00:00',1.96),('15529','2013-02-16','13:05:00',1.05),('15529','2013-02-16','13:25:00',1.95),('15529','2013-02-16','13:30:00',1.84),('15529','2013-02-16','13:55:00',1.5),('15529','2013-02-16','14:05:00',1.13),('15529','2013-02-16','14:10:00',1.89),('15529','2013-02-16','14:50:00',1.3),('15529','2013-02-16','14:55:00',1.65),('15529','2013-02-16','15:00:00',1.64),('15529','2013-02-16','15:05:00',1.64),('15529','2013-02-16','15:10:00',1.6),('15529','2013-02-16','15:15:00',1.49),('15529','2013-02-16','15:20:00',1.43),('15529','2013-02-16','15:25:00',1.4),('15529','2013-02-16','15:30:00',1.35),('15529','2013-02-16','15:35:00',1.29),('15529','2013-02-16','15:40:00',1.26),('15529','2013-02-16','15:45:00',1.19),('15529','2013-02-16','15:50:00',1.12),('15529','2013-02-16','15:55:00',1.06),('15529','2013-02-16','16:00:00',1),('15529','2013-02-15','09:05:00',1.31),('15529','2013-02-15','09:10:00',1.35),('15529','2013-02-15','09:15:00',1.39),('15529','2013-02-15','09:20:00',1.4),('15529','2013-02-15','09:25:00',1.4),('15529','2013-02-15','09:30:00',1.52),('15529','2013-02-15','09:35:00',1.56),('15529','2013-02-15','09:40:00',1.55),('15529','2013-02-15','09:45:00',1.58),('15529','2013-02-15','09:50:00',1.62),('15529','2013-02-15','09:55:00',1.65),('15529','2013-02-15','10:00:00',1.68),('15529','2013-02-15','10:05:00',1.72),('15529','2013-02-15','10:10:00',1.75),('15529','2013-02-15','10:15:00',1.76),('15529','2013-02-15','10:20:00',1.8),('15529','2013-02-15','10:25:00',1.85),('15529','2013-02-15','10:30:00',1.85),('15529','2013-02-15','10:35:00',1.91),('15529','2013-02-15','10:40:00',1.94),('15529','2013-02-15','10:45:00',1.96),('15529','2013-02-15','10:50:00',1.98),('15529','2013-02-15','10:55:00',1.95),('15529','2013-02-15','11:00:00',2.02),('15529','2013-02-15','11:05:00',2.02),('15529','2013-02-15','11:10:00',2.03),('15529','2013-02-15','11:15:00',2.05),('15529','2013-02-15','11:20:00',2.06),('15529','2013-02-15','11:25:00',2.08),('15529','2013-02-15','11:30:00',2.12),('15529','2013-02-15','11:35:00',2.11),('15529','2013-02-15','11:40:00',2.13),('15529','2013-02-15','11:45:00',2.14),('15529','2013-02-15','11:50:00',2.17),('15529','2013-02-15','11:55:00',2.18),('15529','2013-02-15','12:00:00',2.17),('15529','2013-02-15','12:05:00',2.19),('15529','2013-02-15','12:10:00',2.17),('15529','2013-02-15','12:15:00',2.17),('15529','2013-02-15','12:20:00',2.15),('15529','2013-02-15','12:25:00',2.14),('15529','2013-02-15','12:30:00',2.14),('15529','2013-02-15','12:35:00',2.14),('15529','2013-02-15','12:40:00',2.12),('15529','2013-02-15','12:45:00',2.14),('15529','2013-02-15','12:50:00',2.15),('15529','2013-02-15','12:55:00',2.15),('15529','2013-02-15','13:00:00',2.12),('15529','2013-02-15','13:05:00',2.12),('15529','2013-02-15','13:10:00',2.06),('15529','2013-02-15','13:15:00',2.09),('15529','2013-02-15','13:20:00',2.07),('15529','2013-02-15','13:25:00',2.05),('15529','2013-02-15','13:30:00',2.03),('15529','2013-02-15','13:35:00',2.03),('15529','2013-02-15','13:40:00',1.95),('15529','2013-02-15','13:45:00',1.95),('15529','2013-02-15','13:50:00',2),('15529','2013-02-15','13:55:00',1.39),('15529','2013-02-15','14:00:00',1.23),('15529','2013-02-15','14:05:00',1.99),('15529','2013-02-15','14:10:00',1.92),('15529','2013-02-15','14:15:00',1.89),('15529','2013-02-15','14:20:00',1.49),('15529','2013-02-15','15:20:00',1.11),('15529','2013-02-15','15:25:00',1.59),('15529','2013-02-15','15:30:00',1.25),('15529','2013-02-15','15:35:00',1.37),('15529','2013-02-14','09:55:00',1.3),('15529','2013-02-14','10:00:00',1.29),('15529','2013-02-14','10:05:00',1.13),('15529','2013-02-14','10:10:00',1.19),('15529','2013-02-14','10:15:00',1.1),('15529','2013-02-14','10:20:00',1.22),('15529','2013-02-14','10:25:00',1.15),('15529','2013-02-14','10:30:00',1.61),('15529','2013-02-14','10:35:00',1.59),('15529','2013-02-14','10:40:00',1.73),('15529','2013-02-14','10:45:00',1.7),('15529','2013-02-14','10:55:00',1.02),('15529','2013-02-14','11:00:00',1.18),('15529','2013-02-14','11:05:00',1.23),('15529','2013-02-14','11:10:00',1.4),('15529','2013-02-14','11:15:00',2.22),('15529','2013-02-14','11:20:00',2.12),('15529','2013-02-14','11:25:00',2.07),('15529','2013-02-14','11:30:00',2.19),('15529','2013-02-14','11:35:00',1.8),('15529','2013-02-14','11:40:00',2.17),('15529','2013-02-14','11:45:00',2.38),('15529','2013-02-14','11:50:00',1.72),('15529','2013-02-14','11:55:00',1.56),('15529','2013-02-14','12:00:00',1.85),('15529','2013-02-14','12:05:00',1.85),('15529','2013-02-14','12:10:00',2.29),('15529','2013-02-14','12:15:00',2.27),('15529','2013-02-14','12:20:00',2.18),('15529','2013-02-14','12:25:00',2.24),('15529','2013-02-14','12:30:00',2.19),('15529','2013-02-14','12:35:00',2.17),('15529','2013-02-14','12:40:00',2.16),('15529','2013-02-14','12:45:00',2.15),('15529','2013-02-14','12:50:00',2.13),('15529','2013-02-14','12:55:00',2.16),('15529','2013-02-14','13:00:00',2.15),('15529','2013-02-14','13:05:00',2.19),('15529','2013-02-14','13:10:00',1.9),('15529','2013-02-14','13:15:00',1.8),('15529','2013-02-14','13:20:00',1.67),('15529','2013-02-14','13:25:00',1.49),('15529','2013-02-14','13:30:00',1.46),('15529','2013-02-14','13:35:00',1.56),('15529','2013-02-14','13:40:00',1.71),('15529','2013-02-14','13:45:00',1.56),('15529','2013-02-14','13:50:00',1.73),('15529','2013-02-14','13:55:00',1.1),('15529','2013-02-14','14:00:00',1.74),('15529','2013-02-14','14:05:00',2.24),('15529','2013-02-14','14:10:00',1.53),('15529','2013-02-14','14:15:00',1.75),('15529','2013-02-14','14:20:00',1.31),('15529','2013-02-14','14:25:00',1.22),('15529','2013-02-14','14:30:00',1.18),('15529','2013-02-14','14:35:00',1.83),('15529','2013-02-14','14:40:00',1.62),('15529','2013-02-14','14:45:00',1.19),('15529','2013-02-14','15:00:00',1.12),('15529','2013-02-14','15:25:00',1.03),('15529','2013-02-13','08:35:00',1.02),('15529','2013-02-13','08:40:00',1.07),('15529','2013-02-13','08:45:00',1.12),('15529','2013-02-13','08:50:00',1.18),('15529','2013-02-13','08:55:00',1.23),('15529','2013-02-13','09:00:00',1.29),('15529','2013-02-13','09:05:00',1.33),('15529','2013-02-13','09:10:00',1.37),('15529','2013-02-13','09:15:00',1.42),('15529','2013-02-13','09:20:00',1.47),('15529','2013-02-13','09:25:00',1.52),('15529','2013-02-13','09:30:00',1.55),('15529','2013-02-13','09:35:00',1.59),('15529','2013-02-13','09:40:00',1.64),('15529','2013-02-13','09:45:00',1.67),('15529','2013-02-13','09:50:00',1.71),('15529','2013-02-13','09:55:00',1.74),('15529','2013-02-13','10:00:00',1.79),('15529','2013-02-13','10:05:00',1.82),('15529','2013-02-13','10:10:00',1.86),('15529','2013-02-13','10:15:00',1.89),('15529','2013-02-13','10:20:00',1.9),('15529','2013-02-13','10:25:00',1.93),('15529','2013-02-13','10:30:00',1.95),('15529','2013-02-13','10:35:00',1.98),('15529','2013-02-13','10:40:00',2),('15529','2013-02-13','10:45:00',2.03),('15529','2013-02-13','10:50:00',2.05),('15529','2013-02-13','10:55:00',2.07),('15529','2013-02-13','11:00:00',2.08),('15529','2013-02-13','11:05:00',2.1),('15529','2013-02-13','11:10:00',2.13),('15529','2013-02-13','11:15:00',2.13),('15529','2013-02-13','11:20:00',2.14),('15529','2013-02-13','11:25:00',2.16),('15529','2013-02-13','11:30:00',2.16),('15529','2013-02-13','11:35:00',2.17),('15529','2013-02-13','11:40:00',2.18),('15529','2013-02-13','11:45:00',2.18),('15529','2013-02-13','11:50:00',2.18),('15529','2013-02-13','11:55:00',2.18),('15529','2013-02-13','12:00:00',2.19),('15529','2013-02-13','12:05:00',2.2),('15529','2013-02-13','12:10:00',2.2),('15529','2013-02-13','12:15:00',2.19),('15529','2013-02-13','12:20:00',2.2),('15529','2013-02-13','12:25:00',2.19),('15529','2013-02-13','12:30:00',2.2),('15529','2013-02-13','12:35:00',2.2),('15529','2013-02-13','12:40:00',2.18),('15529','2013-02-13','12:45:00',2.18),('15529','2013-02-13','12:50:00',2.15),('15529','2013-02-13','12:55:00',2.15),('15529','2013-02-13','13:00:00',2.16),('15529','2013-02-13','13:05:00',2.16),('15529','2013-02-13','13:10:00',2.13),('15529','2013-02-13','13:15:00',2.12),('15529','2013-02-13','13:20:00',2.08),('15529','2013-02-13','13:25:00',2.07),('15529','2013-02-13','13:30:00',2.07),('15529','2013-02-13','13:35:00',2.06),('15529','2013-02-13','13:40:00',2.04),('15529','2013-02-13','13:45:00',2.03),('15529','2013-02-13','13:50:00',2),('15529','2013-02-13','13:55:00',1.96),('15529','2013-02-13','14:00:00',1.95),('15529','2013-02-13','14:05:00',1.93),('15529','2013-02-13','14:10:00',1.91),('15529','2013-02-13','14:15:00',1.87),('15529','2013-02-13','14:20:00',1.85),('15529','2013-02-13','14:25:00',1.83),('15529','2013-02-13','14:30:00',1.79),('15529','2013-02-13','14:35:00',1.76),('15529','2013-02-13','14:40:00',1.73),('15529','2013-02-13','14:45:00',1.69),('15529','2013-02-13','14:50:00',1.66),('15529','2013-02-13','14:55:00',1.61),('15529','2013-02-13','15:00:00',1.56),('15529','2013-02-13','15:05:00',1.52),('15529','2013-02-13','15:10:00',1.48),('15529','2013-02-13','15:15:00',1.44),('15529','2013-02-13','15:20:00',1.4),('15529','2013-02-13','15:25:00',1.36),('15529','2013-02-13','15:30:00',1.31),('15529','2013-02-13','15:35:00',1.27),('15529','2013-02-13','15:40:00',1.22),('15529','2013-02-13','15:45:00',1.16),('15529','2013-02-13','15:50:00',1.09),('15529','2013-02-13','15:55:00',1.04),('15529','2013-02-12','09:35:00',1.26),('15529','2013-02-12','09:40:00',1.38),('15529','2013-02-12','09:45:00',1.29),('15529','2013-02-12','09:50:00',1.17),('15529','2013-02-12','09:55:00',1.24),('15529','2013-02-12','10:00:00',1.49),('15529','2013-02-12','10:05:00',1.63),('15529','2013-02-12','10:10:00',1.68),('15529','2013-02-12','10:15:00',1.76),('15529','2013-02-12','10:20:00',1.84),('15529','2013-02-12','10:25:00',1.85),('15529','2013-02-12','10:30:00',1.88),('15529','2013-02-12','10:35:00',1.96),('15529','2013-02-12','10:40:00',1.99),('15529','2013-02-12','10:45:00',1.94),('15529','2013-02-12','10:50:00',1.85),('15529','2013-02-12','10:55:00',1.82),('15529','2013-02-12','11:00:00',2.04),('15529','2013-02-12','11:05:00',2.01),('15529','2013-02-12','11:10:00',1.94),('15529','2013-02-12','11:15:00',1.56),('15529','2013-02-12','11:45:00',1.1),('15529','2013-02-12','11:50:00',1.09),('15529','2013-02-12','11:55:00',1.04),('15529','2013-02-12','12:10:00',1.43),('15529','2013-02-12','12:15:00',1.51),('15529','2013-02-12','12:35:00',1.18),('15529','2013-02-12','12:40:00',1.74),('15529','2013-02-12','12:45:00',1.92),('15529','2013-02-12','12:50:00',1.59),('15529','2013-02-12','12:55:00',1.4),('15529','2013-02-12','13:00:00',1.53),('15529','2013-02-12','13:05:00',1.61),('15529','2013-02-12','13:10:00',1.67),('15529','2013-02-12','13:15:00',1.74),('15529','2013-02-12','13:20:00',1.86),('15529','2013-02-12','13:25:00',1.91),('15529','2013-02-12','13:30:00',2.09),('15529','2013-02-12','13:35:00',2.09),('15529','2013-02-12','13:40:00',2.13),('15529','2013-02-12','13:45:00',2.02),('15529','2013-02-12','13:50:00',1.82),('15529','2013-02-12','13:55:00',1.7),('15529','2013-02-12','14:00:00',1.72),('15529','2013-02-12','14:05:00',1.71),('15529','2013-02-12','14:10:00',1.87),('15529','2013-02-12','14:15:00',1.91),('15529','2013-02-12','14:20:00',1.82),('15529','2013-02-12','14:25:00',1.71),('15529','2013-02-12','14:30:00',1.59),('15529','2013-02-12','14:35:00',1.72),('15529','2013-02-12','14:40:00',1.73),('15529','2013-02-12','14:45:00',1.69),('15529','2013-02-12','14:50:00',1.62),('15529','2013-02-12','14:55:00',1.61),('15529','2013-02-12','15:00:00',1.55),('15529','2013-02-12','15:05:00',1.55),('15529','2013-02-12','15:10:00',1.51),('15529','2013-02-12','15:15:00',1.47),('15529','2013-02-12','15:20:00',1.4),('15529','2013-02-12','15:25:00',1.37),('15529','2013-02-12','15:30:00',1.35),('15529','2013-02-12','15:35:00',1.29),('15529','2013-02-12','15:40:00',1.24),('15529','2013-02-12','15:45:00',1.21),('15529','2013-02-12','15:50:00',1.15),('15529','2013-02-12','15:55:00',1.07),('15529','2013-02-12','16:00:00',1.01),('15529','2013-02-10','14:30:00',1.1),('15529','2014-03-21','08:25:00',1.03),('15529','2014-03-21','08:40:00',1.33),('15529','2014-03-21','08:45:00',1.26),('15529','2014-03-21','08:55:00',1.13),('15529','2014-03-21','09:25:00',1.34),('15529','2014-03-21','09:30:00',1.09),('15529','2014-03-21','09:35:00',1.22),('15529','2014-03-21','09:40:00',1.43),('15529','2014-03-21','09:45:00',1.6),('15529','2014-03-21','09:50:00',1.42),('15529','2014-03-21','09:55:00',1.3),('15529','2014-03-21','10:00:00',2.04),('15529','2014-03-21','10:05:00',1.83),('15529','2014-03-21','10:10:00',1.02),('15529','2014-03-21','11:15:00',2.07),('15529','2014-03-21','11:20:00',1.86),('15529','2014-03-21','11:25:00',1.2),('15529','2014-03-21','11:30:00',1.13),('15529','2014-03-21','11:35:00',1.91),('15529','2014-03-21','11:40:00',1.87),('15529','2014-03-21','11:45:00',1.69),('15529','2014-03-21','11:50:00',1.4),('15529','2014-03-21','11:55:00',1.86),('15529','2014-03-21','12:05:00',1.02),('15529','2014-03-21','12:15:00',1.27),('15529','2014-03-21','12:20:00',2.35),('15529','2014-03-21','12:25:00',2.39),('15529','2014-03-21','12:30:00',1.66),('15529','2014-03-21','12:35:00',1.71),('15529','2014-03-21','12:40:00',2.22),('15529','2014-03-21','12:45:00',1.01),('15529','2014-03-21','12:50:00',1.59),('15529','2014-03-21','12:55:00',1.24),('15529','2014-03-21','13:05:00',2),('15529','2014-03-21','13:10:00',1.78),('15529','2014-03-21','13:15:00',1.07),('15529','2014-03-21','13:20:00',1.08),('15529','2014-03-21','13:25:00',2.13),('15529','2014-03-21','13:30:00',2.18),('15529','2014-03-21','13:35:00',1.91),('15529','2014-03-21','13:40:00',1.93),('15529','2014-03-21','13:45:00',2.14),('15529','2014-03-21','13:50:00',2.09),('15529','2014-03-21','13:55:00',2.02),('15529','2014-03-21','14:00:00',1.97),('15529','2014-03-21','14:05:00',1.96),('15529','2014-03-21','14:10:00',1.93),('15529','2014-03-21','14:15:00',1.92),('15529','2014-03-21','14:20:00',1.85),('15529','2014-03-21','14:25:00',1.79),('15529','2014-03-21','14:30:00',1.65),('15529','2014-03-21','14:35:00',1.61),('15529','2014-03-21','14:40:00',1.6),('15529','2014-03-21','14:45:00',1.69),('15529','2014-03-21','14:50:00',1.67),('15529','2014-03-21','14:55:00',1.62),('15529','2014-03-21','15:00:00',1.61),('15529','2014-03-21','15:05:00',1.59),('15529','2014-03-21','15:10:00',1.52),('15529','2014-03-21','15:15:00',1.47),('15529','2014-03-21','15:20:00',1.44),('15529','2014-03-21','15:25:00',1.28),('15529','2014-03-21','15:30:00',1.62),('15529','2014-03-21','15:35:00',1.63),('15529','2014-03-21','15:40:00',1.53),('15529','2014-03-21','15:45:00',1.45),('15529','2014-03-21','15:50:00',1.35),('15529','2014-03-21','15:55:00',1.15),('15529','2014-03-21','16:00:00',1.18),('15529','2014-03-21','16:05:00',1.05),('15529','2013-02-09','09:50:00',1.3),('15529','2013-02-09','09:55:00',1.86),('15529','2013-02-09','10:00:00',1.82),('15529','2013-02-09','10:05:00',1.81),('15529','2013-02-09','10:10:00',1.83),('15529','2013-02-09','10:15:00',1.86),('15529','2013-02-09','10:20:00',1.87),('15529','2013-02-09','10:25:00',1.91),('15529','2013-02-09','10:30:00',1.94),('15529','2013-02-09','10:35:00',1.95),('15529','2013-02-09','10:40:00',1.97),('15529','2013-02-09','10:45:00',2),('15529','2013-02-09','10:50:00',2.01),('15529','2013-02-09','10:55:00',2.02),('15529','2013-02-09','11:00:00',2.05),('15529','2013-02-09','11:05:00',2.07),('15529','2013-02-09','11:10:00',2.08),('15529','2013-02-09','11:15:00',2.07),('15529','2013-02-09','11:20:00',2.09),('15529','2013-02-09','11:25:00',2.11),('15529','2013-02-09','11:30:00',2.12),('15529','2013-02-09','11:35:00',2.13),('15529','2013-02-09','11:40:00',2.14),('15529','2013-02-09','11:45:00',2.15),('15529','2013-02-09','11:50:00',2.18),('15529','2013-02-09','11:55:00',2.17),('15529','2013-02-09','12:00:00',2.18),('15529','2013-02-09','12:05:00',2.19),('15529','2013-02-09','12:10:00',2.2),('15529','2013-02-09','12:15:00',2.21),('15529','2013-02-09','12:20:00',2.2),('15529','2013-02-09','12:25:00',2.2),('15529','2013-02-09','12:30:00',2.18),('15529','2013-02-09','12:35:00',2.2),('15529','2013-02-09','12:40:00',2.19),('15529','2013-02-09','12:45:00',2.18),('15529','2013-02-09','12:50:00',2.17),('15529','2013-02-09','12:55:00',2.17),('15529','2013-02-09','13:00:00',2.15),('15529','2013-02-09','13:05:00',2.14),('15529','2013-02-09','13:10:00',2.14),('15529','2013-02-09','13:15:00',2.12),('15529','2013-02-09','13:20:00',2.1),('15529','2013-02-09','13:25:00',2.07),('15529','2013-02-09','13:30:00',2.03),('15529','2013-02-09','13:35:00',2.03),('15529','2013-02-09','13:40:00',1.99),('15529','2013-02-09','13:45:00',1.97),('15529','2013-02-09','13:50:00',1.93),('15529','2013-02-09','13:55:00',1.9),('15529','2013-02-09','14:00:00',1.9),('15529','2013-02-09','14:05:00',1.87),('15529','2013-02-09','14:10:00',1.82),('15529','2013-02-09','14:15:00',1.79),('15529','2013-02-09','14:20:00',1.79),('15529','2013-02-09','14:25:00',1.8),('15529','2013-02-09','14:30:00',1.77),('15529','2013-02-09','14:35:00',1.74),('15529','2013-02-09','14:40:00',1.67),('15529','2013-02-09','14:45:00',1.65),('15529','2013-02-09','14:50:00',1.54),('15529','2013-02-09','14:55:00',1.55),('15529','2013-02-09','15:00:00',1.47),('15529','2013-02-09','15:05:00',1.46),('15529','2013-02-09','15:10:00',1.42),('15529','2013-02-09','15:15:00',1.43),('15529','2013-02-09','15:20:00',1.47),('15529','2013-02-09','15:25:00',1.3),('15529','2013-02-09','15:30:00',1.2),('15529','2013-02-09','15:35:00',1.41),('15529','2013-02-08','13:10:00',1.09),('15529','2013-02-08','13:15:00',1.25),('15529','2013-02-08','13:20:00',1.41),('15529','2013-02-08','13:25:00',1.58),('15529','2013-02-08','13:30:00',1.68),('15529','2013-02-08','13:35:00',1.87),('15529','2013-02-08','13:40:00',1.85),('15529','2013-02-08','13:45:00',2.08),('15529','2013-02-08','13:50:00',2.13),('15529','2013-02-08','13:55:00',2.09),('15529','2013-02-08','14:00:00',1.91),('15529','2013-02-08','14:05:00',1.9),('15529','2013-02-08','14:10:00',1.51),('15529','2013-02-08','14:15:00',1.82),('15529','2013-02-08','14:20:00',2.16),('15529','2013-02-08','14:25:00',1.99),('15529','2013-02-08','14:30:00',1.86),('15529','2013-02-08','14:35:00',1.73),('15529','2013-02-08','14:40:00',1.57),('15529','2013-02-08','14:45:00',1.54),('15529','2013-02-08','14:50:00',1.62),('15529','2013-02-08','14:55:00',1.55),('15529','2013-02-08','15:00:00',1.52),('15529','2013-02-08','15:05:00',1.47),('15529','2013-02-08','15:10:00',1.43),('15529','2013-02-08','15:15:00',1.34),('15529','2013-02-08','15:20:00',1.34),('15529','2013-02-08','15:25:00',1.04),('15529','2013-02-08','15:30:00',1.22),('15529','2013-02-08','15:35:00',1.18),('15529','2013-02-08','15:40:00',1.12),('15529','2013-02-08','15:45:00',1.03),('15529','2013-02-07','09:30:00',1.05),('15529','2013-02-07','09:35:00',1.86),('15529','2013-02-07','09:40:00',1.97),('15529','2013-02-07','09:45:00',1.35),('15529','2013-02-07','09:50:00',1.97),('15529','2013-02-07','09:55:00',1.94),('15529','2013-02-07','10:00:00',1.97),('15529','2013-02-07','10:05:00',2.01),('15529','2013-02-07','10:20:00',1.4),('15529','2013-02-07','10:25:00',1.97),('15529','2013-02-07','10:35:00',1.54),('15529','2013-02-07','10:40:00',2.18),('15529','2013-02-07','10:45:00',2.19),('15529','2013-02-07','10:50:00',2.26),('15529','2013-02-07','10:55:00',2.18),('15529','2013-02-07','11:00:00',2.09),('15529','2013-02-07','11:05:00',2.08),('15529','2013-02-07','11:10:00',2.1),('15529','2013-02-07','11:15:00',2.1),('15529','2013-02-07','11:20:00',2.11),('15529','2013-02-07','11:25:00',2.11),('15529','2013-02-07','11:30:00',2.12),('15529','2013-02-07','11:35:00',2.11),('15529','2013-02-07','11:40:00',2.13),('15529','2013-02-07','11:45:00',2.15),('15529','2013-02-07','11:50:00',2.15),('15529','2013-02-07','11:55:00',2.16),('15529','2013-02-07','12:00:00',2.16),('15529','2013-02-07','12:05:00',2.16),('15529','2013-02-07','12:10:00',2.17),('15529','2013-02-07','12:15:00',2.17),('15529','2013-02-07','12:20:00',2.18),('15529','2013-02-07','12:25:00',2.19),('15529','2013-02-07','12:30:00',2.19),('15529','2013-02-07','12:35:00',2.18),('15529','2013-02-07','12:40:00',2.09),('15529','2013-02-07','12:45:00',1.27),('15529','2013-02-07','12:50:00',1.7),('15529','2013-02-07','12:55:00',1.85),('15529','2013-02-07','13:00:00',1.4),('15529','2013-02-07','13:15:00',1.02),('15529','2013-02-07','13:20:00',1.06),('15529','2013-02-07','14:25:00',1.03),('15529','2013-02-07','14:30:00',1.52),('15529','2013-02-07','14:35:00',2.14),('15529','2013-02-07','14:40:00',1.67),('15529','2013-02-07','14:45:00',1.39),('15529','2013-02-07','14:50:00',1.53),('15529','2013-02-07','14:55:00',1.99),('15529','2013-02-07','15:00:00',1.93),('15529','2013-02-07','15:05:00',1.78),('15529','2013-02-07','15:10:00',1.67),('15529','2013-02-07','15:15:00',1.6),('15529','2013-02-07','15:20:00',1.48),('15529','2013-02-07','15:25:00',1.38),('15529','2013-02-07','15:30:00',1.31),('15529','2013-02-07','15:35:00',1.27),('15529','2013-02-07','15:40:00',1.22),('15529','2013-02-07','15:45:00',1.15),('15529','2013-02-07','15:50:00',1.09),('15529','2013-02-07','15:55:00',1.04),('15529','2013-02-06','10:35:00',1),('15529','2013-02-06','10:40:00',1.09),('15529','2013-02-06','10:45:00',1.23),('15529','2013-02-06','13:15:00',1.75),('15529','2013-02-06','13:20:00',1.11),('15529','2013-02-06','14:05:00',1.51),('15529','2013-02-06','14:10:00',2.14),('15529','2013-02-06','14:15:00',1.48),('15529','2013-02-06','15:00:00',1.11),('15529','2013-02-06','15:05:00',1.25),('15529','2013-02-05','10:35:00',1.04),('15529','2013-02-05','10:50:00',1.16),('15529','2013-02-05','10:55:00',1.2),('15529','2013-02-05','11:20:00',1.34),('15529','2013-02-05','11:25:00',1.43),('15529','2013-02-05','14:30:00',1.15),('15529','2013-02-04','08:50:00',1.02),('15529','2013-02-04','08:55:00',1.07),('15529','2013-02-04','09:00:00',1.14),('15529','2013-02-04','09:05:00',1.18),('15529','2013-02-04','09:10:00',1.25),('15529','2013-02-04','09:15:00',1.3),('15529','2013-02-04','09:20:00',1.34),('15529','2013-02-04','09:25:00',1.38),('15529','2013-02-04','09:30:00',1.42),('15529','2013-02-04','09:35:00',1.46),('15529','2013-02-04','09:40:00',1.49),('15529','2013-02-04','09:45:00',1.53),('15529','2013-02-04','09:50:00',1.57),('15529','2013-02-04','09:55:00',1.6),('15529','2013-02-04','10:00:00',1.63),('15529','2013-02-04','10:05:00',1.58),('15529','2013-02-04','10:10:00',1.56),('15529','2013-02-04','10:15:00',1.55),('15529','2013-02-04','10:20:00',1.73),('15529','2013-02-04','10:25:00',1.74),('15529','2013-02-04','10:30:00',1.77),('15529','2013-02-04','10:35:00',1.78),('15529','2013-02-04','10:40:00',1.77),('15529','2013-02-04','10:45:00',1.79),('15529','2013-02-04','10:50:00',1.8),('15529','2013-02-04','10:55:00',1.83),('15529','2013-02-04','11:00:00',1.85),('15529','2013-02-04','11:05:00',1.81),('15529','2013-02-04','11:10:00',1.9),('15529','2013-02-04','11:15:00',1.91),('15529','2013-02-04','11:20:00',1.9),('15529','2013-02-04','11:25:00',1.89),('15529','2013-02-04','11:30:00',1.76),('15529','2013-02-04','11:35:00',1.42),('15529','2013-02-04','11:40:00',1.01),('15529','2013-02-04','11:45:00',1.07),('15529','2013-02-04','12:30:00',1.37),('15529','2013-02-04','12:35:00',1.21),('15529','2013-02-04','12:45:00',1.29),('15529','2013-02-03','08:45:00',1.04),('15529','2013-02-03','08:50:00',1.09),('15529','2013-02-03','08:55:00',1.06),('15529','2013-02-03','09:00:00',1.22),('15529','2013-02-03','09:05:00',1.28),('15529','2013-02-03','09:10:00',1.33),('15529','2013-02-03','09:15:00',1.37),('15529','2013-02-03','09:20:00',1.22),('15529','2013-02-03','09:25:00',1.34),('15529','2013-02-03','09:30:00',1.45),('15529','2013-02-03','09:35:00',1.49),('15529','2013-02-03','09:40:00',1.52),('15529','2013-02-03','09:45:00',1.52),('15529','2013-02-03','09:50:00',1.66),('15529','2013-02-03','09:55:00',1.71),('15529','2013-02-03','10:00:00',1.75),('15529','2013-02-03','10:05:00',1.79),('15529','2013-02-03','10:10:00',1.81),('15529','2013-02-03','10:15:00',1.83),('15529','2013-02-03','10:20:00',1.68),('15529','2013-02-03','10:25:00',1.85),('15529','2013-02-03','10:30:00',1.69),('15529','2013-02-03','10:35:00',1.69),('15529','2013-02-03','10:40:00',1.8),('15529','2013-02-03','10:45:00',1.92),('15529','2013-02-03','10:50:00',1.96),('15529','2013-02-03','10:55:00',1.99),('15529','2013-02-03','11:00:00',1.96),('15529','2013-02-03','11:05:00',2.02),('15529','2013-02-03','11:10:00',2.03),('15529','2013-02-03','11:15:00',2.04),('15529','2013-02-03','11:20:00',2.04),('15529','2013-02-03','11:25:00',2.05),('15529','2013-02-03','11:30:00',2.06),('15529','2013-02-03','11:35:00',2.07),('15529','2013-02-03','11:40:00',2.08),('15529','2013-02-03','11:45:00',2.09),('15529','2013-02-03','11:50:00',2.09),('15529','2013-02-03','11:55:00',2.11),('15529','2013-02-03','12:00:00',2.11),('15529','2013-02-03','12:05:00',2.1),('15529','2013-02-03','12:10:00',2.11),('15529','2013-02-03','12:15:00',2.12),('15529','2013-02-03','12:20:00',2.12),('15529','2013-02-03','12:25:00',2.11),('15529','2013-02-03','12:30:00',2.1),('15529','2013-02-03','12:35:00',2.1),('15529','2013-02-03','12:40:00',2.1),('15529','2013-02-03','12:45:00',2.08),('15529','2013-02-03','12:50:00',2.06),('15529','2013-02-03','12:55:00',2.05),('15529','2013-02-03','13:00:00',2.06),('15529','2013-02-03','13:05:00',2.06),('15529','2013-02-03','13:10:00',2.05),('15529','2013-02-03','13:15:00',2.03),('15529','2013-02-03','13:20:00',2.02),('15529','2013-02-03','13:25:00',2.01),('15529','2013-02-03','13:30:00',1.99),('15529','2013-02-03','13:35:00',1.97),('15529','2013-02-03','13:40:00',1.96),('15529','2013-02-03','13:45:00',1.94),('15529','2013-02-03','13:50:00',1.93),('15529','2013-02-03','13:55:00',1.9),('15529','2013-02-03','14:00:00',1.87),('15529','2013-02-03','14:05:00',1.86),('15529','2013-02-03','14:10:00',1.84),('15529','2013-02-03','14:15:00',1.81),('15529','2013-02-03','14:20:00',1.79),('15529','2013-02-03','14:25:00',1.75),('15529','2013-02-03','14:30:00',1.72),('15529','2013-02-03','14:35:00',1.69),('15529','2013-02-03','14:40:00',1.66),('15529','2013-02-03','14:45:00',1.62),('15529','2013-02-03','14:50:00',1.59),('15529','2013-02-03','14:55:00',1.56),('15529','2013-02-03','15:00:00',1.52),('15529','2013-02-03','15:05:00',1.47),('15529','2013-02-03','15:10:00',1.43),('15529','2013-02-03','15:15:00',1.38),('15529','2013-02-03','15:20:00',1.34),('15529','2013-02-03','15:25:00',1.29),('15529','2013-02-03','15:30:00',1.24),('15529','2013-02-03','15:35:00',1.2),('15529','2013-02-03','15:40:00',1.15),('15529','2013-02-03','15:45:00',1.1),('15529','2013-02-03','15:50:00',1.05),('15529','2013-02-02','09:45:00',1.03),('15529','2013-02-01','10:45:00',1.06),('15529','2013-02-01','10:50:00',1.03),('15529','2013-02-01','10:55:00',1.26),('15529','2013-02-01','11:00:00',1.22),('15529','2013-02-01','11:05:00',1.06),('15529','2013-02-01','11:10:00',1.19),('15529','2013-02-01','11:15:00',1.06),('15529','2013-02-01','11:20:00',1.1),('15529','2013-02-01','11:25:00',1.32),('15529','2013-02-01','11:30:00',1.14),('15529','2013-02-01','11:35:00',1.02),('15529','2013-02-01','12:50:00',1.07),('15529','2013-02-01','12:55:00',1.53),('15529','2013-02-01','13:00:00',1),('15529','2013-02-01','13:05:00',1.06),('15529','2013-02-01','13:10:00',1.72),('15529','2013-02-01','13:15:00',1.01),('15529','2013-02-01','13:20:00',1.3),('15529','2013-02-01','13:35:00',1.28),('15529','2013-02-01','13:40:00',1.29),('15529','2013-01-31','09:00:00',1.06),('15529','2013-01-31','09:20:00',1.08),('15529','2013-01-31','09:50:00',1.15),('15529','2013-01-31','10:55:00',1.77),('15529','2013-01-31','11:00:00',1.59),('15529','2013-01-31','11:25:00',1.25),('15529','2013-01-31','11:40:00',1.01),('15529','2013-01-31','11:45:00',1.25),('15529','2013-01-31','11:50:00',2.09),('15529','2013-01-31','11:55:00',1),('15529','2013-01-31','12:00:00',1.38),('15529','2013-01-31','12:05:00',2.29),('15529','2013-01-31','12:15:00',2.09),('15529','2013-01-31','12:20:00',2.17),('15529','2013-01-31','12:25:00',1.65),('15529','2013-01-31','12:30:00',1.13),('15529','2013-01-31','12:35:00',1.41),('15529','2013-01-31','12:40:00',2.12),('15529','2013-01-31','12:45:00',2.08),('15529','2013-01-31','12:50:00',1.31),('15529','2013-01-31','12:55:00',1.97),('15529','2013-01-31','13:00:00',2.08),('15529','2013-01-31','13:05:00',1.96),('15529','2013-01-31','13:10:00',1.96),('15529','2013-01-31','13:15:00',1.97),('15529','2013-01-31','13:20:00',2.02),('15529','2013-01-31','13:25:00',1.12),('15529','2013-01-31','13:50:00',1.63),('15529','2013-01-31','13:55:00',1.5),('15529','2013-01-31','14:00:00',1.77),('15529','2013-01-31','14:05:00',1.62),('15529','2013-01-31','14:10:00',1.36),('15529','2013-01-31','14:25:00',1.68),('15529','2013-01-31','14:30:00',1.67),('15529','2013-01-31','14:35:00',1.65),('15529','2013-01-31','15:30:00',1.15),('15529','2014-03-20','08:25:00',1.05),('15529','2014-03-20','08:30:00',1.1),('15529','2014-03-20','08:35:00',1.14),('15529','2014-03-20','08:40:00',1.19),('15529','2014-03-20','08:45:00',1.22),('15529','2014-03-20','08:50:00',1.27),('15529','2014-03-20','08:55:00',1.31),('15529','2014-03-20','09:00:00',1.36),('15529','2014-03-20','09:05:00',1.4),('15529','2014-03-20','09:10:00',1.46),('15529','2014-03-20','09:15:00',1.5),('15529','2014-03-20','09:20:00',1.56),('15529','2014-03-20','09:25:00',1.51),('15529','2014-03-20','09:30:00',1.58),('15529','2014-03-20','09:35:00',1.58),('15529','2014-03-20','09:40:00',1.65),('15529','2014-03-20','09:45:00',1.69),('15529','2014-03-20','09:50:00',1.74),('15529','2014-03-20','09:55:00',1.73),('15529','2014-03-20','10:00:00',1.76),('15529','2014-03-20','10:05:00',1.8),('15529','2014-03-20','10:10:00',1.81),('15529','2014-03-20','10:15:00',1.84),('15529','2014-03-20','10:20:00',1.86),('15529','2014-03-20','10:25:00',1.9),('15529','2014-03-20','10:30:00',1.88),('15529','2014-03-20','10:35:00',1.87),('15529','2014-03-20','10:40:00',1.86),('15529','2014-03-20','10:45:00',1.89),('15529','2014-03-20','10:50:00',1.9),('15529','2014-03-20','10:55:00',1.92),('15529','2014-03-20','11:00:00',1.92),('15529','2014-03-20','11:05:00',1.95),('15529','2014-03-20','11:10:00',2.03),('15529','2014-03-20','11:15:00',2.06),('15529','2014-03-20','11:20:00',1.76),('15529','2014-03-20','11:25:00',1.88),('15529','2014-03-20','11:30:00',1.84),('15529','2014-03-20','11:35:00',1.94),('15529','2014-03-20','11:40:00',2.08),('15529','2014-03-20','11:45:00',2.02),('15529','2014-03-20','11:50:00',1.94),('15529','2014-03-20','11:55:00',1.22),('15529','2014-03-20','12:00:00',1.89),('15529','2014-03-20','12:05:00',2.06),('15529','2014-03-20','12:10:00',2.04),('15529','2014-03-20','12:15:00',2.1),('15529','2014-03-20','12:20:00',2.12),('15529','2014-03-20','12:25:00',2.12),('15529','2014-03-20','12:30:00',2.14),('15529','2014-03-20','12:35:00',2.17),('15529','2014-03-20','12:40:00',2.16),('15529','2014-03-20','12:45:00',2.14),('15529','2014-03-20','12:50:00',2.13),('15529','2014-03-20','12:55:00',2.12),('15529','2014-03-20','13:00:00',2.13),('15529','2014-03-20','13:05:00',2.11),('15529','2014-03-20','13:10:00',2.12),('15529','2014-03-20','13:15:00',2.11),('15529','2014-03-20','13:20:00',2.11),('15529','2014-03-20','13:25:00',2.09),('15529','2014-03-20','13:30:00',2.07),('15529','2014-03-20','13:35:00',2.07),('15529','2014-03-20','13:40:00',2.04),('15529','2014-03-20','13:45:00',2.04),('15529','2014-03-20','13:50:00',2.03),('15529','2014-03-20','13:55:00',2.02),('15529','2014-03-20','14:00:00',2),('15529','2014-03-20','14:05:00',2.01),('15529','2014-03-20','14:10:00',1.98),('15529','2014-03-20','14:15:00',1.93),('15529','2014-03-20','14:20:00',1.91),('15529','2014-03-20','14:25:00',1.87),('15529','2014-03-20','14:30:00',1.82),('15529','2014-03-20','14:35:00',1.73),('15529','2014-03-20','14:40:00',1.72),('15529','2014-03-20','14:45:00',1.4),('15529','2014-03-20','15:00:00',1.04),('15529','2014-03-20','15:05:00',1.32),('15529','2014-03-20','15:10:00',1.75),('15529','2014-03-20','15:15:00',1.62),('15529','2014-03-20','15:25:00',1.64),('15529','2014-03-20','15:30:00',1.49),('15529','2014-03-20','15:35:00',1.41),('15529','2014-03-20','15:40:00',1.38),('15529','2014-03-20','15:45:00',1.45),('15529','2014-03-20','15:50:00',1.44),('15529','2014-03-20','15:55:00',1.37),('15529','2014-03-20','16:00:00',1.27),('15529','2014-03-20','16:05:00',1.17),('15529','2014-03-20','16:10:00',1.09),('15529','2014-03-20','16:15:00',1.01),('15529','2013-01-30','13:35:00',1.79),('15529','2013-01-30','13:40:00',1.78),('15529','2013-01-30','13:45:00',1.76),('15529','2013-01-30','13:50:00',1.74),('15529','2013-01-30','13:55:00',1.68),('15529','2013-01-30','14:00:00',1.7),('15529','2013-01-30','14:05:00',1.65),('15529','2013-01-30','14:10:00',1.61),('15529','2013-01-30','14:15:00',1.57),('15529','2013-01-30','14:20:00',1.54),('15529','2013-01-30','14:30:00',1.5),('15529','2013-01-30','14:35:00',1.46),('15529','2013-01-30','14:40:00',1.44),('15529','2013-01-30','14:45:00',1.43),('15529','2013-01-30','14:50:00',1.38),('15529','2013-01-30','14:55:00',1.35),('15529','2013-01-30','15:00:00',1.32),('15529','2013-01-30','15:05:00',1.26),('15529','2013-01-30','15:10:00',1.22),('15529','2013-01-30','15:15:00',1.19),('15529','2013-01-30','15:20:00',1.14),('15529','2013-01-30','15:25:00',1.03),('15529','2013-01-30','15:30:00',1.01),('15529','2013-01-30','15:35:00',1.04),('15529','2014-03-19','08:25:00',1.04),('15529','2014-03-19','08:30:00',1.1),('15529','2014-03-19','08:35:00',1.17),('15529','2014-03-19','08:40:00',1.22),('15529','2014-03-19','08:45:00',1.28),('15529','2014-03-19','08:50:00',1.3),('15529','2014-03-19','08:55:00',1.34),('15529','2014-03-19','09:00:00',1.35),('15529','2014-03-19','09:05:00',1.46),('15529','2014-03-19','09:10:00',1.48),('15529','2014-03-19','09:15:00',1.5),('15529','2014-03-19','09:20:00',1.53),('15529','2014-03-19','09:25:00',1.54),('15529','2014-03-19','09:30:00',1.59),('15529','2014-03-19','09:35:00',1.6),('15529','2014-03-19','09:40:00',1.66),('15529','2014-03-19','09:45:00',1.66),('15529','2014-03-19','09:50:00',1.66),('15529','2014-03-19','09:55:00',1.74),('15529','2014-03-19','10:00:00',1.8),('15529','2014-03-19','10:05:00',1.84),('15529','2014-03-19','10:10:00',1.84),('15529','2014-03-19','10:15:00',1.83),('15529','2014-03-19','10:20:00',1.82),('15529','2014-03-19','10:25:00',1.91),('15529','2014-03-19','10:30:00',1.9),('15529','2014-03-19','10:35:00',1.83),('15529','2014-03-19','10:40:00',1.81),('15529','2014-03-19','10:45:00',1.91),('15529','2014-03-19','10:50:00',2.03),('15529','2014-03-19','10:55:00',2.06),('15529','2014-03-19','11:00:00',2.06),('15529','2014-03-19','11:05:00',2.05),('15529','2014-03-19','11:10:00',2),('15529','2014-03-19','11:15:00',1.92),('15529','2014-03-19','11:20:00',2),('15529','2014-03-19','11:25:00',2.02),('15529','2014-03-19','11:30:00',2.08),('15529','2014-03-19','11:35:00',2.09),('15529','2014-03-19','11:40:00',2.14),('15529','2014-03-19','11:45:00',2.01),('15529','2014-03-19','11:50:00',2.01),('15529','2014-03-19','11:55:00',1.83),('15529','2014-03-19','12:00:00',1.79),('15529','2014-03-19','12:05:00',2.09),('15529','2014-03-19','12:10:00',2.1),('15529','2014-03-19','12:15:00',2.15),('15529','2014-03-19','12:20:00',2.04),('15529','2014-03-19','12:25:00',1.98),('15529','2014-03-19','12:30:00',2.06),('15529','2014-03-19','12:35:00',2.15),('15529','2014-03-19','12:40:00',2.18),('15529','2014-03-19','12:45:00',2.14),('15529','2014-03-19','12:50:00',2.13),('15529','2014-03-19','12:55:00',2.12),('15529','2014-03-19','13:00:00',2.1),('15529','2014-03-19','13:05:00',2.12),('15529','2014-03-19','13:10:00',2.09),('15529','2014-03-19','13:15:00',2.06),('15529','2014-03-19','13:20:00',2.04),('15529','2014-03-19','13:25:00',2.02),('15529','2014-03-19','13:30:00',2.02),('15529','2014-03-19','13:35:00',1.94),('15529','2014-03-19','13:40:00',1.84),('15529','2014-03-19','13:45:00',1.81),('15529','2014-03-19','13:50:00',1.71),('15529','2014-03-19','13:55:00',1.61),('15529','2014-03-19','14:00:00',1.72),('15529','2014-03-19','14:05:00',1.76),('15529','2014-03-19','14:10:00',1.69),('15529','2014-03-19','14:15:00',1.67),('15529','2014-03-19','14:20:00',1.52),('15529','2014-03-19','14:25:00',1.39),('15529','2014-03-19','14:30:00',1.33),('15529','2014-03-19','14:35:00',1.35),('15529','2014-03-19','14:40:00',1.35),('15529','2014-03-19','14:45:00',1.35),('15529','2014-03-19','14:50:00',1.3),('15529','2014-03-19','14:55:00',1.28),('15529','2014-03-19','15:00:00',1.22),('15529','2014-03-19','15:05:00',1.25),('15529','2014-03-19','15:10:00',1.26),('15529','2014-03-19','15:15:00',1.19),('15529','2014-03-19','15:20:00',1.21),('15529','2014-03-19','15:25:00',1.09),('15529','2014-03-19','15:30:00',1.02),('15529','2014-03-18','09:30:00',1.39),('15529','2014-03-18','09:40:00',1.22),('15529','2014-03-18','10:35:00',1.61),('15529','2014-03-18','10:40:00',2.03),('15529','2014-03-18','10:45:00',2.27),('15529','2014-03-18','10:50:00',1.97),('15529','2014-03-18','10:55:00',1.76),('15529','2014-03-18','11:30:00',1.41),('15529','2014-03-18','11:40:00',1.71),('15529','2014-03-18','11:45:00',1.76),('15529','2014-03-18','11:50:00',1.59),('15529','2014-03-18','11:55:00',1.79),('15529','2014-03-18','12:00:00',1.96),('15529','2014-03-18','12:05:00',1),('15529','2014-03-18','12:10:00',2.14),('15529','2014-03-18','12:15:00',2.39),('15529','2014-03-18','12:20:00',1.69),('15529','2014-03-18','12:25:00',2.16),('15529','2014-03-18','12:30:00',1.94),('15529','2014-03-18','12:35:00',2.11),('15529','2014-03-18','12:40:00',2.14),('15529','2014-03-18','12:45:00',2.17),('15529','2014-03-18','12:50:00',2.13),('15529','2014-03-18','12:55:00',1.46),('15529','2014-03-18','13:00:00',1.45),('15529','2014-03-18','13:05:00',2.1),('15529','2014-03-18','13:10:00',2.15),('15529','2014-03-18','13:15:00',2.13),('15529','2014-03-18','13:20:00',1.79),('15529','2014-03-18','13:25:00',1.87),('15529','2014-03-18','13:30:00',2.09),('15529','2014-03-18','13:35:00',2.07),('15529','2014-03-18','13:40:00',2.03),('15529','2014-03-18','13:45:00',1.99),('15529','2014-03-18','13:50:00',1.92),('15529','2014-03-18','13:55:00',1.95),('15529','2014-03-18','14:00:00',1.92),('15529','2014-03-18','14:05:00',1.92),('15529','2014-03-18','14:10:00',1.89),('15529','2014-03-18','14:15:00',1.85),('15529','2014-03-18','14:20:00',1.83),('15529','2014-03-18','14:25:00',1.8),('15529','2014-03-18','14:30:00',1.74),('15529','2014-03-18','14:35:00',1.78),('15529','2014-03-18','14:40:00',1.73),('15529','2014-03-18','14:45:00',1.71),('15529','2014-03-18','14:50:00',1.64),('15529','2014-03-18','14:55:00',1.6),('15529','2014-03-18','15:00:00',1.58),('15529','2014-03-18','15:05:00',1.56),('15529','2014-03-18','15:10:00',1.54),('15529','2014-03-18','15:15:00',1.49),('15529','2014-03-18','15:20:00',1.44),('15529','2014-03-18','15:25:00',1.43),('15529','2014-03-18','15:30:00',1.37),('15529','2014-03-18','15:35:00',1.29),('15529','2014-03-18','15:40:00',1.28),('15529','2014-03-18','15:45:00',1.26),('15529','2014-03-18','15:50:00',1.2),('15529','2014-03-18','15:55:00',1.17),('15529','2014-03-18','16:00:00',1.11),('15529','2014-03-18','16:05:00',1.07),('15529','2014-03-18','16:10:00',1.03),('15529','2014-03-17','08:30:00',1.04),('15529','2014-03-17','08:35:00',1.3),('15529','2014-03-17','08:40:00',1.36),('15529','2014-03-17','09:20:00',1.09),('15529','2014-03-17','09:25:00',1.06),('15529','2014-03-17','09:45:00',1.16),('15529','2014-03-17','09:50:00',1.71),('15529','2014-03-17','09:55:00',1.85),('15529','2014-03-17','10:00:00',2.03),('15529','2014-03-17','10:05:00',2.01),('15529','2014-03-17','10:10:00',1.67),('15529','2014-03-17','10:15:00',2.1),('15529','2014-03-17','10:20:00',1.32),('15529','2014-03-17','10:35:00',1.07),('15529','2014-03-17','10:55:00',1.62),('15529','2014-03-17','11:00:00',1.23),('15529','2014-03-17','11:10:00',1.9),('15529','2014-03-17','11:15:00',2.52),('15529','2014-03-17','11:20:00',2.47),('15529','2014-03-17','11:25:00',2.32),('15529','2014-03-17','11:30:00',2.3),('15529','2014-03-17','11:35:00',2.5),('15529','2014-03-17','11:40:00',1.91),('15529','2014-03-17','11:45:00',2.08),('15529','2014-03-17','11:50:00',1.74),('15529','2014-03-17','11:55:00',1.26),('15529','2014-03-17','12:00:00',2.45),('15529','2014-03-17','12:05:00',2.32),('15529','2014-03-17','12:10:00',1.38),('15529','2014-03-17','12:20:00',1.33),('15529','2014-03-17','12:25:00',2.45),('15529','2014-03-17','12:30:00',2.29),('15529','2014-03-17','12:35:00',2.29),('15529','2014-03-17','12:40:00',2.22),('15529','2014-03-17','12:45:00',2.21),('15529','2014-03-17','12:50:00',1.64),('15529','2014-03-17','12:55:00',1.67),('15529','2014-03-17','13:00:00',2.24),('15529','2014-03-17','13:05:00',1.41),('15529','2014-03-17','13:10:00',1.83),('15529','2014-03-17','13:15:00',2.1),('15529','2014-03-17','13:20:00',2.11),('15529','2014-03-17','13:25:00',2.09),('15529','2014-03-17','13:30:00',2.11),('15529','2014-03-17','13:35:00',2.08),('15529','2014-03-17','13:40:00',2.07),('15529','2014-03-17','13:45:00',2.04),('15529','2014-03-17','13:50:00',2.05),('15529','2014-03-17','13:55:00',1.99),('15529','2014-03-17','14:00:00',1.99),('15529','2014-03-17','14:05:00',1.96),('15529','2014-03-17','14:10:00',1.93),('15529','2014-03-17','14:15:00',1.92),('15529','2014-03-17','14:20:00',1.87),('15529','2014-03-17','14:25:00',1.83),('15529','2014-03-17','14:30:00',1.83),('15529','2014-03-17','14:35:00',1.81),('15529','2014-03-17','14:40:00',1.76),('15529','2014-03-17','14:45:00',1.72),('15529','2014-03-17','14:50:00',1.68),('15529','2014-03-17','14:55:00',1.66),('15529','2014-03-17','15:00:00',1.63),('15529','2014-03-17','15:05:00',1.6),('15529','2014-03-17','15:10:00',1.56),('15529','2014-03-17','15:15:00',1.51),('15529','2014-03-17','15:20:00',1.48),('15529','2014-03-17','15:25:00',1.45),('15529','2014-03-17','15:30:00',1.4),('15529','2014-03-17','15:35:00',1.36),('15529','2014-03-17','15:40:00',1.29),('15529','2014-03-17','15:45:00',1.24),('15529','2014-03-17','15:50:00',1.19),('15529','2014-03-17','15:55:00',1.15),('15529','2014-03-17','16:00:00',1.07),('15529','2014-03-17','16:05:00',1.05),('15529','2014-04-30','08:40:00',1.03),('15529','2014-04-30','08:45:00',1.09),('15529','2014-04-30','09:00:00',1.1),('15529','2014-04-30','09:20:00',1.38),('15529','2014-04-30','09:25:00',1.58),('15529','2014-04-30','09:30:00',1.73),('15529','2014-04-30','09:35:00',1.7),('15529','2014-04-30','10:15:00',1.04),('15529','2014-04-30','10:20:00',1.99),('15529','2014-04-30','10:25:00',1.2),('15529','2014-04-30','10:30:00',1.3),('15529','2014-04-30','10:35:00',1.84),('15529','2014-04-30','10:45:00',1.7),('15529','2014-04-30','10:50:00',2.36),('15529','2014-04-30','10:55:00',2.39),('15529','2014-04-30','11:00:00',1.71),('15529','2014-04-30','11:05:00',2.3),('15529','2014-04-30','11:10:00',2.22),('15529','2014-04-30','11:15:00',2.26),('15529','2014-04-30','11:20:00',2.4),('15529','2014-04-30','11:25:00',1.2),('15529','2014-04-30','11:40:00',2.24),('15529','2014-04-30','11:45:00',2.48),('15529','2014-04-30','11:50:00',2.53),('15529','2014-04-30','11:55:00',2.57),('15529','2014-04-30','12:00:00',2.06),('15529','2014-04-30','12:05:00',1.86),('15529','2014-04-30','12:10:00',1.95),('15529','2014-04-30','12:15:00',1.82),('15529','2014-04-30','12:20:00',1.12),('15529','2014-04-30','12:25:00',2.61),('15529','2014-04-30','12:30:00',1.39),('15529','2014-04-30','12:40:00',1.59),('15529','2014-04-30','12:45:00',2.8),('15529','2014-04-30','12:50:00',1.74),('15529','2014-04-30','13:05:00',1.91),('15529','2014-04-30','13:10:00',2.3),('15529','2014-04-30','13:15:00',2.53),('15529','2014-04-30','13:20:00',1.78),('15529','2014-04-30','13:25:00',2.67),('15529','2014-04-30','13:30:00',2.64),('15529','2014-04-30','13:35:00',2.6),('15529','2014-04-30','13:40:00',2.67),('15529','2014-04-30','13:45:00',2.57),('15529','2014-04-30','13:50:00',2.48),('15529','2014-04-30','13:55:00',2.48),('15529','2014-04-30','14:00:00',2.43),('15529','2014-04-30','14:05:00',2.34),('15529','2014-04-30','14:10:00',2.34),('15529','2014-04-30','14:15:00',2.3),('15529','2014-04-30','14:20:00',2.22),('15529','2014-04-30','14:25:00',2.25),('15529','2014-04-30','14:30:00',2.17),('15529','2014-04-30','14:35:00',2.15),('15529','2014-04-30','14:40:00',2.23),('15529','2014-04-30','14:45:00',2.25),('15529','2014-04-30','14:50:00',2.04),('15529','2014-04-30','14:55:00',2.21),('15529','2014-04-30','15:00:00',2.22),('15529','2014-04-30','15:05:00',1.43),('15529','2014-04-30','15:10:00',2.02),('15529','2014-04-30','15:15:00',2.06),('15529','2014-04-30','15:20:00',2.08),('15529','2014-04-30','15:25:00',2.05),('15529','2014-04-30','15:30:00',2),('15529','2014-04-30','15:35:00',1.97),('15529','2014-04-30','15:40:00',1.94),('15529','2014-04-30','15:45:00',1.87),('15529','2014-04-30','15:50:00',1.86),('15529','2014-04-30','15:55:00',1.79),('15529','2014-04-30','16:00:00',1.81),('15529','2014-04-30','16:05:00',1.79),('15529','2014-04-30','16:10:00',1.68),('15529','2014-04-30','16:15:00',1.67),('15529','2014-04-30','16:20:00',1.55),('15529','2014-04-30','16:25:00',1.49),('15529','2014-04-30','16:30:00',1.55),('15529','2014-04-30','16:35:00',1.54),('15529','2014-04-30','16:40:00',1.41),('15529','2014-04-30','16:45:00',1.18),('15529','2014-04-30','16:55:00',1.37),('15529','2014-04-30','17:00:00',1.19),('15529','2014-04-30','17:05:00',1.18),('15529','2014-04-30','17:10:00',1.23),('15529','2014-04-30','17:15:00',1.17),('15529','2014-04-30','17:20:00',1.11),('15529','2014-04-30','17:25:00',1.07),('15529','2014-04-30','17:30:00',1.03),('15529','2014-03-16','11:05:00',1),('15529','2014-03-16','11:10:00',1.17),('15529','2014-03-16','12:20:00',1.32),('15529','2014-03-16','12:25:00',1.81),('15529','2014-03-16','12:30:00',1.55),('15529','2014-03-16','12:35:00',2.27),('15529','2014-03-16','12:40:00',2.35),('15529','2014-03-16','12:45:00',1.4),('15529','2014-03-16','12:50:00',1.48),('15529','2014-03-16','12:55:00',2.34),('15529','2014-03-16','13:00:00',2.14),('15529','2014-03-16','13:05:00',2.09),('15529','2014-03-16','13:10:00',2.23),('15529','2014-03-16','13:15:00',1.95),('15529','2014-03-16','13:20:00',1.96),('15529','2014-03-16','13:25:00',2),('15529','2014-03-16','13:30:00',1.16),('15529','2014-03-16','13:35:00',1.3),('15529','2014-03-16','13:40:00',1.78),('15529','2014-03-16','13:45:00',2.17),('15529','2014-03-16','13:50:00',1.51),('15529','2014-03-16','13:55:00',1.54),('15529','2014-03-16','14:00:00',2.16),('15529','2014-03-16','14:05:00',1.23),('15529','2014-03-16','14:15:00',1.94),('15529','2014-03-16','14:20:00',1.92),('15529','2014-03-16','14:25:00',1.88),('15529','2014-03-16','14:30:00',1.85),('15529','2014-03-16','14:35:00',1.27),('15529','2014-03-16','14:40:00',1.75),('15529','2014-03-16','14:45:00',1.7),('15529','2014-03-16','14:50:00',1.3),('15529','2014-03-16','15:00:00',1.72),('15529','2014-03-16','15:05:00',1.68),('15529','2014-03-16','15:25:00',1.31),('15529','2014-03-16','15:30:00',1.28),('15529','2014-03-16','15:35:00',1.26),('15529','2014-03-16','15:40:00',1.08),('15529','2014-03-16','15:45:00',1.25),('15529','2014-03-16','16:05:00',1.07),('15529','2014-03-16','16:10:00',1.08),('15529','2014-03-15','08:35:00',1.01),('15529','2014-03-15','08:40:00',1.03),('15529','2014-03-15','08:45:00',1.1),('15529','2014-03-15','08:50:00',1.13),('15529','2014-03-15','08:55:00',1.17),('15529','2014-03-15','09:00:00',1.16),('15529','2014-03-15','09:05:00',1.2),('15529','2014-03-15','09:10:00',1.26),('15529','2014-03-15','09:15:00',1.37),('15529','2014-03-15','09:20:00',1.4),('15529','2014-03-15','09:25:00',1.39),('15529','2014-03-15','09:30:00',1.41),('15529','2014-03-15','09:35:00',1.42),('15529','2014-03-15','09:40:00',1.49),('15529','2014-03-15','09:45:00',1.53),('15529','2014-03-15','09:50:00',1.6),('15529','2014-03-15','09:55:00',1.62),('15529','2014-03-15','10:00:00',1.66),('15529','2014-03-15','10:05:00',1.68),('15529','2014-03-15','10:10:00',1.72),('15529','2014-03-15','10:15:00',1.78),('15529','2014-03-15','10:20:00',1.76),('15529','2014-03-15','10:25:00',1.74),('15529','2014-03-15','10:30:00',1.78),('15529','2014-03-15','10:35:00',1.85),('15529','2014-03-15','10:40:00',1.9),('15529','2014-03-15','10:45:00',1.94),('15529','2014-03-15','10:50:00',1.95),('15529','2014-03-15','10:55:00',1.96),('15529','2014-03-15','11:00:00',1.95),('15529','2014-03-15','11:05:00',1.93),('15529','2014-03-15','11:10:00',1.89),('15529','2014-03-15','11:15:00',2),('15529','2014-03-15','11:20:00',2.05),('15529','2014-03-15','11:25:00',2.01),('15529','2014-03-15','11:30:00',2.02),('15529','2014-03-15','11:35:00',2.03),('15529','2014-03-15','11:40:00',2.06),('15529','2014-03-15','11:45:00',2),('15529','2014-03-15','11:50:00',2),('15529','2014-03-15','11:55:00',2.01),('15529','2014-03-15','12:00:00',2.06),('15529','2014-03-15','12:05:00',2.08),('15529','2014-03-15','12:10:00',2.14),('15529','2014-03-15','12:15:00',2.11),('15529','2014-03-15','12:20:00',2.08),('15529','2014-03-15','12:25:00',2.08),('15529','2014-03-15','12:30:00',2.07),('15529','2014-03-15','12:35:00',2.03),('15529','2014-03-15','12:40:00',2.04),('15529','2014-03-15','12:45:00',2.07),('15529','2014-03-15','12:50:00',2.08),('15529','2014-03-15','12:55:00',1.98),('15529','2014-03-15','13:00:00',1.95),('15529','2014-03-15','13:05:00',1.96),('15529','2014-03-15','13:10:00',2),('15529','2014-03-15','13:15:00',1.96),('15529','2014-03-15','13:20:00',1.92),('15529','2014-03-15','13:25:00',1.94),('15529','2014-03-15','13:30:00',1.94),('15529','2014-03-15','13:35:00',1.94),('15529','2014-03-15','13:40:00',1.96),('15529','2014-03-15','13:45:00',1.95),('15529','2014-03-15','13:50:00',1.93),('15529','2014-03-15','13:55:00',1.9),('15529','2014-03-15','14:00:00',1.87),('15529','2014-03-15','14:05:00',1.86),('15529','2014-03-15','14:10:00',1.78),('15529','2014-03-15','14:15:00',1.75),('15529','2014-03-15','14:20:00',1.73),('15529','2014-03-15','14:25:00',1.74),('15529','2014-03-15','14:30:00',1.71),('15529','2014-03-15','14:35:00',1.66),('15529','2014-03-15','14:40:00',1.64),('15529','2014-03-15','14:45:00',1.66),('15529','2014-03-15','14:50:00',1.48),('15529','2014-03-15','14:55:00',1.51),('15529','2014-03-15','15:00:00',1.49),('15529','2014-03-15','15:05:00',1.45),('15529','2014-03-15','15:10:00',1.35),('15529','2014-03-15','15:15:00',1.2),('15529','2014-03-15','15:20:00',1.03),('15529','2014-03-15','15:25:00',1.19),('15529','2014-03-15','15:30:00',1.05),('15529','2014-03-14','08:40:00',1.01),('15529','2014-03-14','08:45:00',1.06),('15529','2014-03-14','08:50:00',1.1),('15529','2014-03-14','08:55:00',1.15),('15529','2014-03-14','09:00:00',1.2),('15529','2014-03-14','09:05:00',1.24),('15529','2014-03-14','09:10:00',1.28),('15529','2014-03-14','09:15:00',1.32),('15529','2014-03-14','09:20:00',1.36),('15529','2014-03-14','09:25:00',1.39),('15529','2014-03-14','09:30:00',1.42),('15529','2014-03-14','09:35:00',1.46),('15529','2014-03-14','09:40:00',1.5),('15529','2014-03-14','09:45:00',1.52),('15529','2014-03-14','09:50:00',1.56),('15529','2014-03-14','09:55:00',1.58),('15529','2014-03-14','10:00:00',1.62),('15529','2014-03-14','10:05:00',1.64),('15529','2014-03-14','10:10:00',1.67),('15529','2014-03-14','10:15:00',1.69),('15529','2014-03-14','10:20:00',1.72),('15529','2014-03-14','10:25:00',1.75),('15529','2014-03-14','10:30:00',1.77),('15529','2014-03-14','10:35:00',1.74),('15529','2014-03-14','10:40:00',1.81),('15529','2014-03-14','10:45:00',1.83),('15529','2014-03-14','10:50:00',1.89),('15529','2014-03-14','10:55:00',1.87),('15529','2014-03-14','11:00:00',1.93),('15529','2014-03-14','11:05:00',1.94),('15529','2014-03-14','11:10:00',2),('15529','2014-03-14','11:15:00',1.96),('15529','2014-03-14','11:20:00',1.97),('15529','2014-03-14','11:25:00',2.01),('15529','2014-03-14','11:30:00',2.02),('15529','2014-03-14','11:35:00',2.03),('15529','2014-03-14','11:40:00',1.99),('15529','2014-03-14','11:45:00',2.02),('15529','2014-03-14','11:50:00',1.99),('15529','2014-03-14','11:55:00',1.99),('15529','2014-03-14','12:00:00',2.01),('15529','2014-03-14','12:05:00',2.03),('15529','2014-03-14','12:10:00',2.02),('15529','2014-03-14','12:15:00',2.06),('15529','2014-03-14','12:20:00',2.1),('15529','2014-03-14','12:25:00',2.12),('15529','2014-03-14','12:30:00',2.08),('15529','2014-03-14','12:35:00',2.12),('15529','2014-03-14','12:40:00',2.07),('15529','2014-03-14','12:45:00',2.07),('15529','2014-03-14','12:50:00',2.04),('15529','2014-03-14','12:55:00',2.08),('15529','2014-03-14','13:00:00',2.06),('15529','2014-03-14','13:05:00',2.04),('15529','2014-03-14','13:10:00',2.04),('15529','2014-03-14','13:15:00',2.03),('15529','2014-03-14','13:20:00',2.04),('15529','2014-03-14','13:25:00',2.03),('15529','2014-03-14','13:30:00',2.02),('15529','2014-03-14','13:35:00',2.02),('15529','2014-03-14','13:40:00',2.01),('15529','2014-03-14','13:45:00',1.97),('15529','2014-03-14','13:50:00',1.97),('15529','2014-03-14','13:55:00',1.96),('15529','2014-03-14','14:00:00',1.93),('15529','2014-03-14','14:05:00',1.91),('15529','2014-03-14','14:10:00',1.89),('15529','2014-03-14','14:15:00',1.85),('15529','2014-03-14','14:20:00',1.83),('15529','2014-03-14','14:25:00',1.81),('15529','2014-03-14','14:30:00',1.77),('15529','2014-03-14','14:35:00',1.75),('15529','2014-03-14','14:40:00',1.71),('15529','2014-03-14','14:45:00',1.66),('15529','2014-03-14','14:50:00',1.63),('15529','2014-03-14','14:55:00',1.6),('15529','2014-03-14','15:00:00',1.56),('15529','2014-03-14','15:05:00',1.52),('15529','2014-03-14','15:10:00',1.47),('15529','2014-03-14','15:15:00',1.43),('15529','2014-03-14','15:20:00',1.39),('15529','2014-03-14','15:25:00',1.36),('15529','2014-03-14','15:30:00',1.3),('15529','2014-03-14','15:35:00',1.25),('15529','2014-03-14','15:40:00',1.21),('15529','2014-03-14','15:45:00',1.17),('15529','2014-03-14','15:50:00',1.12),('15529','2014-03-14','15:55:00',1.06),('15529','2014-03-13','09:40:00',1.17),('15529','2014-03-13','09:45:00',1.36),('15529','2014-03-13','09:50:00',1.63),('15529','2014-03-13','09:55:00',1.79),('15529','2014-03-13','10:00:00',1.89),('15529','2014-03-13','10:05:00',1.95),('15529','2014-03-13','10:10:00',1.99),('15529','2014-03-13','10:15:00',1.96),('15529','2014-03-13','10:20:00',1.91),('15529','2014-03-13','10:25:00',1.82),('15529','2014-03-13','10:30:00',1.8),('15529','2014-03-13','10:35:00',1.91),('15529','2014-03-13','10:40:00',1.93),('15529','2014-03-13','10:45:00',1.85),('15529','2014-03-13','10:50:00',1.17),('15529','2014-03-13','10:55:00',1.5),('15529','2014-03-13','11:00:00',1.85),('15529','2014-03-13','11:05:00',1.86),('15529','2014-03-13','11:10:00',2.01),('15529','2014-03-13','11:15:00',2.03),('15529','2014-03-13','11:20:00',1.99),('15529','2014-03-13','11:25:00',1.96),('15529','2014-03-13','11:30:00',1.96),('15529','2014-03-13','11:35:00',1.95),('15529','2014-03-13','11:40:00',1.98),('15529','2014-03-13','11:45:00',2.06),('15529','2014-03-13','11:50:00',2.19),('15529','2014-03-13','11:55:00',2.13),('15529','2014-03-13','12:00:00',2.12),('15529','2014-03-13','12:05:00',2.13),('15529','2014-03-13','12:10:00',2.06),('15529','2014-03-13','12:15:00',2),('15529','2014-03-13','12:20:00',1.81),('15529','2014-03-13','12:25:00',1.35),('15529','2014-03-13','12:30:00',1.3),('15529','2014-03-13','12:35:00',1.06),('15529','2014-03-13','12:40:00',1.1),('15529','2014-03-13','12:45:00',1.44),('15529','2014-03-13','12:50:00',1.65),('15529','2014-03-13','12:55:00',1.64),('15529','2014-03-13','13:00:00',1.3),('15529','2014-03-13','13:05:00',1.15),('15529','2014-03-13','13:10:00',1.39),('15529','2014-03-13','13:15:00',1.35),('15529','2014-03-13','13:20:00',1.48),('15529','2014-03-13','13:25:00',1.39),('15529','2014-03-13','13:30:00',1.27),('15529','2014-03-13','13:35:00',1.17),('15529','2014-03-13','13:40:00',1.07),('15529','2014-03-13','13:45:00',1.22),('15529','2014-03-13','13:50:00',1.22),('15529','2014-03-13','13:55:00',1.18),('15529','2014-03-13','14:00:00',1.26),('15529','2014-03-13','14:05:00',1.52),('15529','2014-03-13','14:10:00',1.49),('15529','2014-03-13','14:15:00',1.31),('15529','2014-03-13','14:20:00',1.51),('15529','2014-03-13','14:25:00',1.52),('15529','2014-03-13','14:30:00',1.33),('15529','2014-03-13','14:35:00',1.32),('15529','2014-03-13','14:40:00',1.07),('15529','2014-03-12','08:20:00',1.04),('15529','2014-03-12','08:25:00',1.1),('15529','2014-03-12','08:30:00',1.14),('15529','2014-03-12','08:35:00',1.2),('15529','2014-03-12','08:40:00',1.25),('15529','2014-03-12','08:45:00',1.3),('15529','2014-03-12','08:50:00',1.33),('15529','2014-03-12','08:55:00',1.38),('15529','2014-03-12','09:00:00',1.42),('15529','2014-03-12','09:05:00',1.48),('15529','2014-03-12','09:10:00',1.51),('15529','2014-03-12','09:15:00',1.54),('15529','2014-03-12','09:20:00',1.58),('15529','2014-03-12','09:25:00',1.62),('15529','2014-03-12','09:30:00',1.65),('15529','2014-03-12','09:35:00',1.69),('15529','2014-03-12','09:40:00',1.71),('15529','2014-03-12','09:45:00',1.74),('15529','2014-03-12','09:50:00',1.77),('15529','2014-03-12','09:55:00',1.8),('15529','2014-03-12','10:00:00',1.84),('15529','2014-03-12','10:05:00',1.89),('15529','2014-03-12','10:10:00',1.92),('15529','2014-03-12','10:15:00',1.94),('15529','2014-03-12','10:20:00',1.97),('15529','2014-03-12','10:25:00',1.98),('15529','2014-03-12','10:30:00',2.01),('15529','2014-03-12','10:35:00',2.03),('15529','2014-03-12','10:40:00',2.06),('15529','2014-03-12','10:45:00',2.06),('15529','2014-03-12','10:50:00',2.07),('15529','2014-03-12','10:55:00',2.09),('15529','2014-03-12','11:00:00',2.13),('15529','2014-03-12','11:05:00',2.16),('15529','2014-03-12','11:10:00',2.14),('15529','2014-03-12','11:15:00',2.16),('15529','2014-03-12','11:20:00',2.19),('15529','2014-03-12','11:25:00',2.18),('15529','2014-03-12','11:30:00',2.16),('15529','2014-03-12','11:35:00',2.19),('15529','2014-03-12','11:40:00',2.19),('15529','2014-03-12','11:45:00',2.21),('15529','2014-03-12','11:50:00',2.18),('15529','2014-03-12','11:55:00',2.21),('15529','2014-03-12','12:00:00',2.21),('15529','2014-03-12','12:05:00',2.19),('15529','2014-03-12','12:10:00',2.16),('15529','2014-03-12','12:15:00',2.21),('15529','2014-03-12','12:20:00',2.2),('15529','2014-03-12','12:25:00',2.21),('15529','2014-03-12','12:30:00',2.17),('15529','2014-03-12','12:35:00',2.18),('15529','2014-03-12','12:40:00',2.17),('15529','2014-03-12','12:45:00',2.15),('15529','2014-03-12','12:50:00',2.15),('15529','2014-03-12','12:55:00',2.14),('15529','2014-03-12','13:00:00',2.11),('15529','2014-03-12','13:05:00',2.12),('15529','2014-03-12','13:10:00',2.11),('15529','2014-03-12','13:15:00',2.1),('15529','2014-03-12','13:20:00',2.12),('15529','2014-03-12','13:25:00',2.09),('15529','2014-03-12','13:30:00',2.08),('15529','2014-03-12','13:35:00',2.05),('15529','2014-03-12','13:40:00',2.05),('15529','2014-03-12','13:45:00',2.01),('15529','2014-03-12','13:50:00',2),('15529','2014-03-12','13:55:00',1.97),('15529','2014-03-12','14:00:00',1.94),('15529','2014-03-12','14:05:00',1.92),('15529','2014-03-12','14:10:00',1.89),('15529','2014-03-12','14:15:00',1.86),('15529','2014-03-12','14:20:00',1.84),('15529','2014-03-12','14:25:00',1.8),('15529','2014-03-12','14:30:00',1.79),('15529','2014-03-12','14:35:00',1.75),('15529','2014-03-12','14:40:00',1.72),('15529','2014-03-12','14:45:00',1.69),('15529','2014-03-12','14:50:00',1.65),('15529','2014-03-12','14:55:00',1.61),('15529','2014-03-12','15:00:00',1.57),('15529','2014-03-12','15:05:00',1.54),('15529','2014-03-12','15:10:00',1.49),('15529','2014-03-12','15:15:00',1.45),('15529','2014-03-12','15:20:00',1.4),('15529','2014-03-12','15:25:00',1.36),('15529','2014-03-12','15:30:00',1.32),('15529','2014-03-12','15:35:00',1.28),('15529','2014-03-12','15:40:00',1.24),('15529','2014-03-12','15:45:00',1.2),('15529','2014-03-12','15:50:00',1.15),('15529','2014-03-12','15:55:00',1.1),('15529','2014-03-12','16:00:00',1.04),('15529','2014-03-11','08:20:00',1.03),('15529','2014-03-11','08:25:00',1.08),('15529','2014-03-11','08:30:00',1.14),('15529','2014-03-11','08:35:00',1.2),('15529','2014-03-11','08:40:00',1.25),('15529','2014-03-11','08:45:00',1.29),('15529','2014-03-11','08:50:00',1.34),('15529','2014-03-11','08:55:00',1.39),('15529','2014-03-11','09:00:00',1.43),('15529','2014-03-11','09:05:00',1.47),('15529','2014-03-11','09:10:00',1.51),('15529','2014-03-11','09:15:00',1.55),('15529','2014-03-11','09:20:00',1.59),('15529','2014-03-11','09:25:00',1.63),('15529','2014-03-11','09:30:00',1.65),('15529','2014-03-11','09:35:00',1.69),('15529','2014-03-11','09:40:00',1.72),('15529','2014-03-11','09:45:00',1.74),('15529','2014-03-11','09:50:00',1.77),('15529','2014-03-11','09:55:00',1.81),('15529','2014-03-11','10:00:00',1.84),('15529','2014-03-11','10:05:00',1.86),('15529','2014-03-11','10:10:00',1.89),('15529','2014-03-11','10:15:00',1.91),('15529','2014-03-11','10:20:00',1.93),('15529','2014-03-11','10:25:00',1.97),('15529','2014-03-11','10:30:00',1.99),('15529','2014-03-11','10:35:00',2),('15529','2014-03-11','10:40:00',2.05),('15529','2014-03-11','10:45:00',2.09),('15529','2014-03-11','10:50:00',2.1),('15529','2014-03-11','10:55:00',2.12),('15529','2014-03-11','11:00:00',2.12),('15529','2014-03-11','11:05:00',2.16),('15529','2014-03-11','11:10:00',2.18),('15529','2014-03-11','11:15:00',2.22),('15529','2014-03-11','11:20:00',2.22),('15529','2014-03-11','11:25:00',2.21),('15529','2014-03-11','11:30:00',2.22),('15529','2014-03-11','11:35:00',2.22),('15529','2014-03-11','11:40:00',2.22),('15529','2014-03-11','11:45:00',2.23),('15529','2014-03-11','11:50:00',2.26),('15529','2014-03-11','11:55:00',2.25),('15529','2014-03-11','12:00:00',2.24),('15529','2014-03-11','12:05:00',2.26),('15529','2014-03-11','12:10:00',2.24),('15529','2014-03-11','12:15:00',2.23),('15529','2014-03-11','12:20:00',2.25),('15529','2014-03-11','12:25:00',2.24),('15529','2014-03-11','12:30:00',2.24),('15529','2014-03-11','12:35:00',2.22),('15529','2014-03-11','12:40:00',2.24),('15529','2014-03-11','12:45:00',2.22),('15529','2014-03-11','12:50:00',2.22),('15529','2014-03-11','12:55:00',2.19),('15529','2014-03-11','13:00:00',2.2),('15529','2014-03-11','13:05:00',2.19),('15529','2014-03-11','13:10:00',2.19),('15529','2014-03-11','13:15:00',2.14),('15529','2014-03-11','13:20:00',2.16),('15529','2014-03-11','13:25:00',2.14),('15529','2014-03-11','13:30:00',2.12),('15529','2014-03-11','13:35:00',2.1),('15529','2014-03-11','13:40:00',2.09),('15529','2014-03-11','13:45:00',2.07),('15529','2014-03-11','13:50:00',2.01),('15529','2014-03-11','13:55:00',2.02),('15529','2014-03-11','14:00:00',2),('15529','2014-03-11','14:05:00',1.99),('15529','2014-03-11','14:10:00',1.93),('15529','2014-03-11','14:15:00',1.9),('15529','2014-03-11','14:20:00',1.89),('15529','2014-03-11','14:25:00',1.88),('15529','2014-03-11','14:30:00',1.82),('15529','2014-03-11','14:35:00',1.76),('15529','2014-03-11','14:40:00',1.68),('15529','2014-03-11','14:45:00',1.69),('15529','2014-03-11','14:50:00',1.64),('15529','2014-03-11','14:55:00',1.6),('15529','2014-03-11','15:00:00',1.58),('15529','2014-03-11','15:05:00',1.51),('15529','2014-03-11','15:10:00',1.47),('15529','2014-03-11','15:15:00',1.44),('15529','2014-03-11','15:20:00',1.38),('15529','2014-03-11','15:25:00',1.37),('15529','2014-03-11','15:30:00',1.33),('15529','2014-03-11','15:35:00',1.3),('15529','2014-03-11','15:40:00',1.26),('15529','2014-03-11','15:45:00',1.22),('15529','2014-03-11','15:50:00',1.17),('15529','2014-03-11','15:55:00',1.11),('15529','2014-03-11','16:00:00',1.07),('15529','2014-03-11','16:05:00',1.02),('15529','2014-03-10','14:05:00',1.17),('15529','2014-03-10','14:10:00',1.16),('15529','2014-03-10','14:15:00',1.33),('15529','2014-03-10','14:20:00',1.84),('15529','2014-03-10','14:25:00',1.05),('15529','2014-03-10','15:15:00',1.37),('15529','2014-03-09','14:40:00',1.06),('15529','2014-03-09','14:45:00',1.46),('15529','2014-03-09','14:50:00',1.5),('15529','2014-03-09','14:55:00',1.35),('15529','2014-03-09','15:00:00',1.65),('15529','2014-03-09','15:05:00',1.66),('15529','2014-03-09','15:10:00',1.6),('15529','2014-03-09','15:15:00',1.57),('15529','2014-03-09','15:20:00',1.61),('15529','2014-03-09','15:25:00',1.61),('15529','2014-03-09','15:30:00',1.61),('15529','2014-03-09','15:35:00',1.39),('15529','2014-03-09','15:40:00',1.11),('15529','2014-03-09','15:45:00',1.05),('15529','2014-03-08','08:25:00',1.04),('15529','2014-03-08','08:45:00',1),('15529','2014-03-08','08:50:00',1.19),('15529','2014-03-08','08:55:00',1.16),('15529','2014-03-08','09:00:00',1.42),('15529','2014-03-08','09:05:00',1.48),('15529','2014-03-08','09:10:00',1.53),('15529','2014-03-08','09:15:00',1.56),('15529','2014-03-08','09:20:00',1.61),('15529','2014-03-08','09:25:00',1.64),('15529','2014-03-08','09:30:00',1.7),('15529','2014-03-08','09:35:00',1.77),('15529','2014-03-08','09:40:00',1.79),('15529','2014-03-08','09:45:00',1.82),('15529','2014-03-08','09:50:00',1.84),('15529','2014-03-08','09:55:00',1.86),('15529','2014-03-08','10:00:00',1.89),('15529','2014-03-08','10:05:00',1.91),('15529','2014-03-08','10:10:00',1.94),('15529','2014-03-08','10:15:00',1.96),('15529','2014-03-08','10:20:00',1.99),('15529','2014-03-08','10:25:00',2.03),('15529','2014-03-08','10:30:00',2.08),('15529','2014-03-08','10:35:00',2.12),('15529','2014-03-08','10:40:00',2.12),('15529','2014-03-08','10:45:00',1.98),('15529','2014-03-08','10:50:00',2.18),('15529','2014-03-08','10:55:00',2.21),('15529','2014-03-08','11:00:00',2.26),('15529','2014-03-08','11:05:00',2.26),('15529','2014-03-08','11:10:00',2.33),('15529','2014-03-08','11:15:00',2.45),('15529','2014-03-08','11:20:00',1.9),('15529','2014-03-08','11:25:00',1.05),('15529','2014-03-08','11:35:00',1.08),('15529','2014-03-08','11:50:00',1.5),('15529','2014-03-08','11:55:00',2),('15529','2014-03-08','12:15:00',1.23),('15529','2014-03-08','12:20:00',1.53),('15529','2014-03-08','12:25:00',2.5),('15529','2014-03-08','12:30:00',1.68),('15529','2014-03-08','12:35:00',2.37),('15529','2014-03-08','12:40:00',2.09),('15529','2014-03-08','12:45:00',2.43),('15529','2014-03-08','12:50:00',2.38),('15529','2014-03-08','12:55:00',2.38),('15529','2014-03-08','13:00:00',2.04),('15529','2014-03-08','13:05:00',1.97),('15529','2014-03-08','13:10:00',1.78),('15529','2014-03-08','13:20:00',1.15),('15529','2014-03-08','13:25:00',2.41),('15529','2014-03-08','13:30:00',2.32),('15529','2014-03-08','13:35:00',2.29),('15529','2014-03-08','13:40:00',2.31),('15529','2014-03-08','13:45:00',2.31),('15529','2014-03-08','13:50:00',2.23),('15529','2014-03-08','13:55:00',1.88),('15529','2014-03-08','14:05:00',1.17),('15529','2014-03-08','14:10:00',2.07),('15529','2014-03-08','14:15:00',1.84),('15529','2014-03-08','14:20:00',2.04),('15529','2014-03-08','14:25:00',2),('15529','2014-03-08','14:30:00',2.04),('15529','2014-03-08','14:55:00',1.83),('15529','2014-03-08','15:00:00',1.75),('15529','2014-03-08','15:05:00',1.74),('15529','2014-03-08','15:10:00',1.71),('15529','2014-03-08','15:15:00',1.63),('15529','2014-03-08','15:20:00',1.57),('15529','2014-03-08','15:25:00',1.53),('15529','2014-03-08','15:30:00',1.49),('15529','2014-03-08','15:35:00',1.42),('15529','2014-03-08','15:40:00',1.37),('15529','2014-03-08','15:45:00',1.32),('15529','2014-03-08','16:05:00',1.13),('15529','2014-03-07','08:25:00',1.05),('15529','2014-03-07','08:30:00',1.1),('15529','2014-03-07','08:35:00',1.15),('15529','2014-03-07','08:40:00',1.2),('15529','2014-03-07','08:45:00',1.26),('15529','2014-03-07','08:50:00',1.3),('15529','2014-03-07','08:55:00',1.35),('15529','2014-03-07','09:00:00',1.4),('15529','2014-03-07','09:05:00',1.44),('15529','2014-03-07','09:10:00',1.48),('15529','2014-03-07','09:15:00',1.52),('15529','2014-03-07','09:20:00',1.56),('15529','2014-03-07','09:25:00',1.59),('15529','2014-03-07','09:30:00',1.64),('15529','2014-03-07','09:35:00',1.67),('15529','2014-03-07','09:40:00',1.71),('15529','2014-03-07','09:45:00',1.74),('15529','2014-03-07','09:50:00',1.78),('15529','2014-03-07','09:55:00',1.8),('15529','2014-03-07','10:00:00',1.83),('15529','2014-03-07','10:05:00',1.86),('15529','2014-03-07','10:10:00',1.88),('15529','2014-03-07','10:15:00',1.92),('15529','2014-03-07','10:20:00',1.94),('15529','2014-03-07','10:25:00',1.96),('15529','2014-03-07','10:30:00',2),('15529','2014-03-07','10:35:00',2.02),('15529','2014-03-07','10:40:00',2.05),('15529','2014-03-07','10:45:00',2.07),('15529','2014-03-07','10:50:00',2.1),('15529','2014-03-07','10:55:00',2.11),('15529','2014-03-07','11:00:00',2.13),('15529','2014-03-07','11:05:00',2.14),('15529','2014-03-07','11:10:00',2.16),('15529','2014-03-07','11:15:00',2.19),('15529','2014-03-07','11:20:00',2.21),('15529','2014-03-07','11:25:00',2.27),('15529','2014-03-07','11:30:00',2.39),('15529','2014-03-07','11:35:00',2.44),('15529','2014-03-07','11:40:00',2.49),('15529','2014-03-07','11:45:00',1.62),('15529','2014-03-07','11:50:00',1.83),('15529','2014-03-07','12:40:00',1.07),('15529','2014-03-07','13:00:00',1.18),('15529','2014-03-07','13:35:00',1.22),('15529','2014-03-07','13:40:00',1.26),('15529','2014-03-07','13:45:00',1.43),('15529','2014-03-07','13:50:00',2.01),('15529','2014-03-07','15:20:00',1.27),('15529','2014-03-07','15:25:00',1.01),('15529','2014-03-07','15:35:00',1.13),('15529','2014-04-29','08:45:00',1.05),('15529','2014-04-29','08:50:00',1.13),('15529','2014-04-29','08:55:00',1.08),('15529','2014-04-29','09:00:00',1.21),('15529','2014-04-29','09:05:00',1.24),('15529','2014-04-29','09:10:00',1.35),('15529','2014-04-29','09:20:00',1.28),('15529','2014-04-29','09:25:00',1.54),('15529','2014-04-29','09:30:00',1.53),('15529','2014-04-29','09:35:00',1.56),('15529','2014-04-29','09:40:00',1.44),('15529','2014-04-29','09:45:00',1.71),('15529','2014-04-29','09:50:00',1.85),('15529','2014-04-29','09:55:00',1.2),('15529','2014-04-29','10:00:00',1.67),('15529','2014-04-29','10:05:00',1.09),('15529','2014-04-29','10:10:00',1.14),('15529','2014-04-29','10:30:00',1.05),('15529','2014-04-29','10:35:00',1.02),('15529','2014-04-29','10:40:00',1.14),('15529','2014-04-29','10:45:00',1.41),('15529','2014-04-29','10:50:00',2.26),('15529','2014-04-29','10:55:00',2.25),('15529','2014-04-29','11:00:00',2.62),('15529','2014-04-29','11:05:00',2.02),('15529','2014-04-29','11:10:00',1.41),('15529','2014-04-29','11:15:00',1.22),('15529','2014-04-29','11:20:00',1.63),('15529','2014-04-29','11:25:00',1.49),('15529','2014-04-29','11:30:00',1.11),('15529','2014-04-29','11:35:00',2.65),('15529','2014-04-29','11:40:00',1.38),('15529','2014-04-29','11:45:00',1.33),('15529','2014-04-29','11:50:00',1.38),('15529','2014-04-29','11:55:00',1.22),('15529','2014-04-29','12:10:00',1.17),('15529','2014-04-29','12:45:00',1.85),('15529','2014-04-29','12:50:00',2.27),('15529','2014-04-29','12:55:00',2.53),('15529','2014-04-29','13:00:00',1.64),('15529','2014-04-29','13:05:00',2.54),('15529','2014-04-29','13:15:00',1.11),('15529','2014-04-29','13:20:00',2.71),('15529','2014-04-29','13:25:00',1.23),('15529','2014-04-29','13:35:00',1.74),('15529','2014-04-29','13:40:00',2.36),('15529','2014-04-29','13:45:00',1.26),('15529','2014-04-29','13:50:00',2.09),('15529','2014-04-29','13:55:00',1.04),('15529','2014-04-29','14:15:00',2.16),('15529','2014-04-29','14:20:00',1.9),('15529','2014-04-29','14:25:00',1.75),('15529','2014-04-29','14:30:00',1.93),('15529','2014-04-29','14:35:00',1.23),('15529','2014-04-29','15:30:00',1.25),('15529','2014-04-29','15:35:00',2.27),('15529','2014-04-29','15:40:00',1.33),('15529','2014-04-29','15:45:00',1.08),('15529','2014-04-29','15:55:00',1.15),('15529','2014-04-29','16:15:00',1.25),('15529','2014-04-29','16:35:00',1.02),('15529','2014-04-29','16:40:00',1.64),('15529','2014-04-29','16:45:00',1.1),('15529','2014-04-29','16:50:00',1.26),('15529','2014-04-29','16:55:00',1.01),('15529','2014-04-29','17:00:00',1.06),('15529','2014-04-29','17:05:00',1.1),('15529','2014-03-06','10:40:00',1.02),('15529','2014-03-06','11:20:00',1.03),('15529','2014-03-06','11:25:00',1.42),('15529','2014-03-06','11:35:00',1.26),('15529','2014-03-06','11:50:00',1.25),('15529','2014-03-06','11:55:00',2.32),('15529','2014-03-06','12:00:00',1.12),('15529','2014-03-06','12:05:00',1.78),('15529','2014-03-06','12:10:00',2.37),('15529','2014-03-06','12:15:00',2.41),('15529','2014-03-06','12:20:00',2.38),('15529','2014-03-06','12:55:00',2.1),('15529','2014-03-06','13:00:00',1.13),('15529','2014-03-06','13:05:00',1.32),('15529','2014-03-06','13:10:00',1.49),('15529','2014-03-06','13:15:00',1.22),('15529','2014-03-06','13:20:00',2.05),('15529','2014-03-06','13:25:00',2.15),('15529','2014-03-06','13:30:00',1.22),('15529','2014-03-06','14:50:00',1.26),('15529','2014-03-06','14:55:00',1.6),('15529','2014-03-06','15:00:00',1.85),('15529','2014-03-06','15:05:00',1.89),('15529','2014-03-06','15:10:00',1.91),('15529','2014-03-06','15:15:00',1.86),('15529','2014-03-06','15:20:00',1.81),('15529','2014-03-06','15:25:00',1.75),('15529','2014-03-06','15:30:00',1.64),('15529','2014-03-06','15:35:00',1.58),('15529','2014-03-06','15:40:00',1.44),('15529','2014-03-06','15:45:00',1.43),('15529','2014-03-06','15:50:00',1.35),('15529','2014-03-06','15:55:00',1.29),('15529','2014-03-06','16:00:00',1.21),('15529','2014-03-06','16:05:00',1.09),('15529','2014-03-06','16:10:00',1.05),('15529','2014-03-06','16:15:00',1.02),('15529','2014-03-05','08:15:00',1.2),('15529','2014-03-05','08:20:00',1),('15529','2014-03-05','09:20:00',1.21),('15529','2014-03-05','09:25:00',1.07),('15529','2014-03-05','09:40:00',1.11),('15529','2014-03-05','09:45:00',1.25),('15529','2014-03-05','09:50:00',1.5),('15529','2014-03-05','09:55:00',1.42),('15529','2014-03-05','10:00:00',1.39),('15529','2014-03-05','10:05:00',1.61),('15529','2014-03-05','10:10:00',1.76),('15529','2014-03-05','10:15:00',1.95),('15529','2014-03-05','10:20:00',1.89),('15529','2014-03-05','10:25:00',1.93),('15529','2014-03-05','10:30:00',2.1),('15529','2014-03-05','10:35:00',2.02),('15529','2014-03-05','10:40:00',2.1),('15529','2014-03-05','10:45:00',1.54),('15529','2014-03-05','10:50:00',1.95),('15529','2014-03-05','10:55:00',2.04),('15529','2014-03-05','11:00:00',2.13),('15529','2014-03-05','11:05:00',1.83),('15529','2014-03-05','11:10:00',2.47),('15529','2014-03-05','11:15:00',1.67),('15529','2014-03-05','11:20:00',1.89),('15529','2014-03-05','12:05:00',1.27),('15529','2014-03-05','12:10:00',1.15),('15529','2014-03-05','15:10:00',1.07),('15529','2014-03-04','08:20:00',1.25),('15529','2014-03-04','08:25:00',1.08),('15529','2014-03-04','08:40:00',1.04),('15529','2014-03-04','08:50:00',1.24),('15529','2014-03-04','09:05:00',1.06),('15529','2014-03-04','09:10:00',1.56),('15529','2014-03-04','09:15:00',1.61),('15529','2014-03-04','09:20:00',1.62),('15529','2014-03-04','09:25:00',1.65),('15529','2014-03-04','09:30:00',1.68),('15529','2014-03-04','09:35:00',1.72),('15529','2014-03-04','09:40:00',1.76),('15529','2014-03-04','09:45:00',1.78),('15529','2014-03-04','09:50:00',1.78),('15529','2014-03-04','09:55:00',1.85),('15529','2014-03-04','10:00:00',1.88),('15529','2014-03-04','10:05:00',1.91),('15529','2014-03-04','10:10:00',1.94),('15529','2014-03-04','10:15:00',1.95),('15529','2014-03-04','10:20:00',1.98),('15529','2014-03-04','10:25:00',2),('15529','2014-03-04','10:30:00',2.02),('15529','2014-03-04','10:35:00',2.05),('15529','2014-03-04','10:40:00',2.06),('15529','2014-03-04','10:45:00',2.07),('15529','2014-03-04','10:50:00',2.1),('15529','2014-03-04','10:55:00',2.11),('15529','2014-03-04','11:00:00',2.11),('15529','2014-03-04','11:05:00',2.14),('15529','2014-03-04','11:10:00',2.17),('15529','2014-03-04','11:15:00',2.17),('15529','2014-03-04','11:20:00',2.23),('15529','2014-03-04','11:25:00',2.31),('15529','2014-03-04','11:30:00',2.31),('15529','2014-03-04','11:35:00',2.27),('15529','2014-03-04','11:40:00',2.31),('15529','2014-03-04','11:45:00',2.18),('15529','2014-03-04','11:50:00',2.31),('15529','2014-03-04','11:55:00',2.14),('15529','2014-03-04','12:00:00',1.92),('15529','2014-03-04','12:05:00',1.77),('15529','2014-03-04','12:10:00',1.84),('15529','2014-03-04','12:15:00',1.2),('15529','2014-03-04','12:20:00',1.83),('15529','2014-03-04','12:30:00',1.06),('15529','2014-03-04','12:35:00',1.22),('15529','2014-03-04','12:40:00',1.73),('15529','2014-03-04','12:45:00',1.36),('15529','2014-03-04','13:05:00',1.2),('15529','2014-03-04','13:10:00',1.52),('15529','2014-03-04','13:15:00',1.84),('15529','2014-03-04','13:20:00',1.42),('15529','2014-03-04','13:25:00',1.38),('15529','2014-03-04','13:30:00',1.64),('15529','2014-03-04','13:40:00',1.51),('15529','2014-03-04','13:45:00',1.34),('15529','2014-03-04','14:30:00',1.32),('15529','2014-03-04','14:40:00',1.48),('15529','2014-03-04','14:45:00',1.98),('15529','2014-03-04','14:50:00',2.22),('15529','2014-03-04','14:55:00',1.42),('15529','2014-03-04','15:45:00',1.06),('15529','2014-03-04','15:50:00',1.04),('15529','2014-03-04','16:00:00',1.41),('15529','2014-03-04','16:05:00',1.55),('15529','2014-03-04','16:10:00',1.4),('15529','2014-03-04','16:15:00',1.13),('15529','2014-03-03','10:30:00',1.36),('15529','2014-03-03','10:35:00',2.44),('15529','2014-03-03','10:40:00',2.57),('15529','2014-03-03','10:45:00',2.58),('15529','2014-03-03','10:50:00',1.63),('15529','2014-03-03','10:55:00',2.47),('15529','2014-03-03','11:00:00',2.28),('15529','2014-03-03','11:05:00',2.52),('15529','2014-03-03','11:10:00',2.68),('15529','2014-03-03','11:15:00',1.87),('15529','2014-03-03','11:45:00',1.25),('15529','2014-03-03','11:50:00',2.71),('15529','2014-03-03','11:55:00',2.43),('15529','2014-03-03','12:00:00',2.38),('15529','2014-03-03','12:05:00',2.34),('15529','2014-03-03','12:10:00',2.36),('15529','2014-03-03','12:15:00',2.34),('15529','2014-03-03','12:20:00',2.13),('15529','2014-03-03','12:25:00',2.33),('15529','2014-03-03','12:30:00',2.27),('15529','2014-03-03','12:35:00',2.29),('15529','2014-03-03','12:40:00',1.73),('15529','2014-03-03','12:45:00',2.12),('15529','2014-03-03','12:50:00',2.21),('15529','2014-03-03','12:55:00',2.32),('15529','2014-03-03','13:00:00',1.17),('15529','2014-03-03','13:05:00',1.94),('15529','2014-03-03','13:10:00',1.34),('15529','2014-03-03','13:20:00',1.44),('15529','2014-03-03','13:25:00',1.19),('15529','2014-03-03','14:00:00',1.16),('15529','2014-03-03','14:05:00',2.06),('15529','2014-03-03','14:10:00',2.22),('15529','2014-03-03','14:20:00',1.32),('15529','2014-03-03','14:25:00',2.1),('15529','2014-03-03','14:30:00',1.99),('15529','2014-03-03','14:35:00',1.93),('15529','2014-03-03','14:40:00',1.92),('15529','2014-03-03','14:45:00',1.33),('15529','2014-03-03','14:50:00',2.02),('15529','2014-03-03','14:55:00',1.81),('15529','2014-03-03','15:00:00',1.76),('15529','2014-03-03','15:05:00',1.7),('15529','2014-03-03','15:10:00',1.25),('15529','2014-03-03','15:15:00',1.67),('15529','2014-03-03','15:20:00',1.64),('15529','2014-03-03','15:25:00',1.6),('15529','2014-03-03','15:30:00',1.53),('15529','2014-03-03','15:35:00',1.55),('15529','2014-03-03','15:40:00',1.46),('15529','2014-03-03','15:45:00',1.49),('15529','2014-03-03','15:50:00',1.22),('15529','2014-03-02','08:20:00',1.02),('15529','2014-03-02','08:25:00',1.06),('15529','2014-03-02','08:30:00',1.1),('15529','2014-03-02','08:35:00',1.16),('15529','2014-03-02','08:40:00',1.22),('15529','2014-03-02','08:45:00',1.27),('15529','2014-03-02','08:50:00',1.29),('15529','2014-03-02','08:55:00',1.32),('15529','2014-03-02','09:00:00',1.2),('15529','2014-03-02','09:05:00',1.09),('15529','2014-03-02','09:10:00',1.15),('15529','2014-03-02','09:15:00',1.53),('15529','2014-03-02','09:20:00',1.55),('15529','2014-03-02','09:25:00',1.61),('15529','2014-03-02','09:30:00',1.54),('15529','2014-03-02','09:35:00',1.6),('15529','2014-03-02','09:40:00',1.46),('15529','2014-03-02','09:45:00',1.63),('15529','2014-03-02','09:50:00',1.74),('15529','2014-03-02','09:55:00',1.68),('15529','2014-03-02','10:00:00',1.83),('15529','2014-03-02','10:05:00',1.85),('15529','2014-03-02','10:10:00',1.9),('15529','2014-03-02','10:15:00',1.91),('15529','2014-03-02','10:20:00',1.95),('15529','2014-03-02','10:25:00',1.97),('15529','2014-03-02','10:30:00',1.99),('15529','2014-03-02','10:35:00',2.01),('15529','2014-03-02','10:40:00',2.02),('15529','2014-03-02','10:45:00',2.04),('15529','2014-03-02','10:50:00',2.06),('15529','2014-03-02','10:55:00',2.07),('15529','2014-03-02','11:00:00',2.09),('15529','2014-03-02','11:05:00',2.1),('15529','2014-03-02','11:10:00',2.11),('15529','2014-03-02','11:15:00',2.12),('15529','2014-03-02','11:20:00',2.14),('15529','2014-03-02','11:25:00',2.21),('15529','2014-03-02','11:30:00',2.25),('15529','2014-03-02','11:35:00',2.25),('15529','2014-03-02','11:40:00',2.25),('15529','2014-03-02','11:45:00',2.3),('15529','2014-03-02','11:50:00',2.28),('15529','2014-03-02','11:55:00',2.29),('15529','2014-03-02','12:00:00',2.31),('15529','2014-03-02','12:05:00',2.29),('15529','2014-03-02','12:10:00',2.3),('15529','2014-03-02','12:15:00',2.3),('15529','2014-03-02','12:20:00',2.32),('15529','2014-03-02','12:25:00',2.31),('15529','2014-03-02','12:30:00',2.3),('15529','2014-03-02','12:35:00',2.3),('15529','2014-03-02','12:40:00',2.29),('15529','2014-03-02','12:45:00',2.28),('15529','2014-03-02','12:50:00',2.27),('15529','2014-03-02','12:55:00',2.27),('15529','2014-03-02','13:00:00',2.26),('15529','2014-03-02','13:05:00',2.26),('15529','2014-03-02','13:10:00',2.24),('15529','2014-03-02','13:15:00',2.23),('15529','2014-03-02','13:20:00',2.21),('15529','2014-03-02','13:25:00',2.22),('15529','2014-03-02','13:30:00',2.2),('15529','2014-03-02','13:35:00',2.2),('15529','2014-03-02','13:40:00',2.15),('15529','2014-03-02','13:45:00',2.19),('15529','2014-03-02','13:50:00',2.17),('15529','2014-03-02','13:55:00',2.14),('15529','2014-03-02','14:00:00',2.09),('15529','2014-03-02','14:05:00',2.08),('15529','2014-03-02','14:10:00',2.1),('15529','2014-03-02','14:15:00',1.99),('15529','2014-03-02','14:20:00',1.95),('15529','2014-03-02','14:25:00',1.98),('15529','2014-03-02','14:30:00',1.97),('15529','2014-03-02','14:35:00',1.94),('15529','2014-03-02','14:40:00',1.88),('15529','2014-03-02','14:45:00',1.83),('15529','2014-03-02','14:50:00',1.8),('15529','2014-03-02','14:55:00',1.74),('15529','2014-03-02','15:00:00',1.48),('15529','2014-03-02','15:05:00',1.64),('15529','2014-03-02','15:10:00',1.6),('15529','2014-03-02','15:20:00',1.12),('15529','2014-03-02','15:30:00',1.22),('15529','2014-03-02','15:35:00',1.13),('15529','2014-03-02','15:40:00',1.4),('15529','2014-03-02','15:45:00',1.33),('15529','2014-03-02','15:50:00',1.28),('15529','2014-03-02','15:55:00',1.22),('15529','2014-03-02','16:00:00',1.17),('15529','2014-03-02','16:05:00',1.11),('15529','2014-03-02','16:10:00',1.06),('15529','2014-03-02','16:15:00',1),('15529','2014-03-01','08:15:00',1.01),('15529','2014-03-01','08:25:00',1.1),('15529','2014-03-01','08:30:00',1.12),('15529','2014-03-01','08:35:00',1.16),('15529','2014-03-01','08:40:00',1.25),('15529','2014-03-01','08:45:00',1.3),('15529','2014-03-01','08:50:00',1.36),('15529','2014-03-01','08:55:00',1.4),('15529','2014-03-01','09:00:00',1.46),('15529','2014-03-01','09:05:00',1.53),('15529','2014-03-01','09:10:00',1.61),('15529','2014-03-01','09:15:00',1.44),('15529','2014-03-01','09:20:00',1.75),('15529','2014-03-01','09:25:00',1.78),('15529','2014-03-01','09:30:00',1.71),('15529','2014-03-01','09:35:00',1.65),('15529','2014-03-01','10:20:00',1.02),('15529','2014-03-01','10:25:00',1.1),('15529','2014-03-01','10:30:00',1.57),('15529','2014-03-01','10:35:00',2.14),('15529','2014-03-01','10:40:00',2.19),('15529','2014-03-01','10:45:00',2.26),('15529','2014-03-01','10:50:00',2.33),('15529','2014-03-01','10:55:00',2.48),('15529','2014-03-01','11:00:00',2.31),('15529','2014-03-01','11:15:00',1.07),('15529','2014-03-01','11:20:00',1.24),('15529','2014-03-01','11:25:00',2.51),('15529','2014-03-01','11:30:00',2.45),('15529','2014-03-01','11:35:00',1.34),('15529','2014-03-01','11:40:00',2.58),('15529','2014-03-01','11:45:00',2.54),('15529','2014-03-01','11:50:00',2.55),('15529','2014-03-01','11:55:00',1.86),('15529','2014-03-01','12:05:00',1.05),('15529','2014-03-01','12:10:00',1.22),('15529','2014-03-01','12:15:00',1.15),('15529','2014-02-27','09:25:00',1.24),('15529','2014-02-27','09:40:00',1.93),('15529','2014-02-27','09:45:00',2.01),('15529','2014-02-27','09:50:00',1.57),('15529','2014-02-27','10:20:00',1.97),('15529','2014-02-27','10:25:00',2.1),('15529','2014-02-27','10:30:00',1.83),('15529','2014-02-27','10:35:00',1.16),('15529','2014-02-27','12:00:00',1.06),('15529','2014-02-27','12:05:00',1.15),('15529','2014-02-27','12:25:00',1.35),('15529','2014-02-27','12:30:00',2.3),('15529','2014-02-27','12:35:00',2.26),('15529','2014-02-27','12:40:00',1.21),('15529','2014-02-27','12:45:00',1.16),('15529','2014-02-27','12:50:00',1.12),('15529','2014-02-27','12:55:00',1.44),('15529','2014-02-27','13:00:00',1.07),('15529','2014-02-27','13:45:00',1.21),('15529','2014-02-27','14:25:00',1.66),('15529','2014-02-27','14:30:00',1.08),('15529','2014-02-27','15:20:00',1.05),('15529','2014-02-27','16:15:00',1.32),('15529','2014-02-26','13:55:00',1.22),('15529','2014-02-26','14:00:00',1.12),('15529','2014-02-25','08:30:00',1.03),('15529','2014-02-25','08:35:00',1.1),('15529','2014-02-25','08:40:00',1.21),('15529','2014-02-25','08:55:00',1.27),('15529','2014-02-25','09:00:00',1.25),('15529','2014-02-25','09:05:00',1.27),('15529','2014-02-25','09:10:00',1.43),('15529','2014-02-25','09:15:00',1.25),('15529','2014-02-25','09:20:00',1.44),('15529','2014-02-25','09:25:00',1.2),('15529','2014-02-25','09:30:00',1.45),('15529','2014-02-25','09:35:00',1.16),('15529','2014-02-25','09:40:00',1.01),('15529','2014-02-25','12:15:00',1.28),('15529','2014-02-25','12:20:00',1.8),('15529','2014-02-25','12:30:00',1.32),('15529','2014-02-25','12:35:00',1.37),('15529','2014-02-25','12:40:00',1.7),('15529','2014-02-25','12:45:00',1.56),('15529','2014-02-25','12:50:00',2.03),('15529','2014-02-25','12:55:00',1.72),('15529','2014-02-25','13:05:00',1.72),('15529','2014-02-25','13:20:00',1.85),('15529','2014-02-25','13:25:00',1.63),('15529','2014-02-25','13:30:00',2.19),('15529','2014-02-25','13:35:00',1.74),('15529','2014-02-25','13:40:00',1.31),('15529','2014-02-25','13:45:00',1.75),('15529','2014-02-25','13:50:00',1.05),('15529','2014-02-25','14:00:00',1.38),('15529','2014-02-25','14:15:00',1.52),('15529','2014-02-25','14:20:00',1.23),('15529','2014-02-25','14:25:00',1.47),('15529','2014-02-25','14:30:00',1.52),('15529','2014-02-25','14:35:00',1.29),('15529','2014-02-25','14:40:00',1.73),('15529','2014-02-25','14:45:00',1.8),('15529','2014-02-25','14:50:00',1.56),('15529','2014-02-25','14:55:00',1.69),('15529','2014-02-25','15:00:00',1.69),('15529','2014-02-25','15:05:00',1.12),('15529','2014-02-25','15:10:00',1.58),('15529','2014-02-25','15:15:00',1.29),('15529','2014-02-25','15:30:00',1),('15529','2014-02-25','15:35:00',1.05),('15529','2014-02-25','15:40:00',1.07),('15529','2014-02-25','16:00:00',1.17),('15529','2014-04-28','10:05:00',1.72),('15529','2014-04-28','10:10:00',1.94),('15529','2014-04-28','10:15:00',1.94),('15529','2014-04-28','10:20:00',1.63),('15529','2014-04-28','10:25:00',2.02),('15529','2014-04-28','10:30:00',2.08),('15529','2014-04-28','10:35:00',2.09),('15529','2014-04-28','10:40:00',2.13),('15529','2014-04-28','10:45:00',2.15),('15529','2014-04-28','10:50:00',2.12),('15529','2014-04-28','10:55:00',2),('15529','2014-04-28','11:00:00',2.18),('15529','2014-04-28','11:05:00',1.98),('15529','2014-04-28','11:10:00',2.37),('15529','2014-04-28','11:15:00',1.75),('15529','2014-04-28','11:20:00',2.41),('15529','2014-04-28','11:25:00',2.29),('15529','2014-04-28','11:30:00',1.65),('15529','2014-04-28','12:15:00',1.86),('15529','2014-04-28','12:20:00',1.26),('15529','2014-04-28','12:30:00',1.22),('15529','2014-04-28','12:35:00',1.11),('15529','2014-04-28','12:45:00',1.34),('15529','2014-04-28','12:50:00',1.47),('15529','2014-04-28','12:55:00',1.1),('15529','2014-04-28','13:00:00',2.02),('15529','2014-04-28','13:05:00',1.79),('15529','2014-04-28','13:20:00',1.68),('15529','2014-04-28','13:25:00',2.73),('15529','2014-04-28','13:30:00',1.09),('15529','2014-04-28','13:35:00',1.51),('15529','2014-04-28','13:40:00',1.01),('15529','2014-04-28','17:35:00',1.13),('15529','2014-02-24','08:35:00',1.03),('15529','2014-02-24','08:40:00',1.09),('15529','2014-02-24','08:45:00',1.15),('15529','2014-02-24','08:50:00',1.2),('15529','2014-02-24','08:55:00',1.24),('15529','2014-02-24','09:00:00',1.29),('15529','2014-02-24','09:05:00',1.33),('15529','2014-02-24','09:10:00',1.37),('15529','2014-02-24','09:15:00',1.41),('15529','2014-02-24','09:20:00',1.46),('15529','2014-02-24','09:25:00',1.49),('15529','2014-02-24','09:30:00',1.53),('15529','2014-02-24','09:35:00',1.56),('15529','2014-02-24','09:40:00',1.59),('15529','2014-02-24','09:45:00',1.63),('15529','2014-02-24','09:50:00',1.65),('15529','2014-02-24','09:55:00',1.68),('15529','2014-02-24','10:00:00',1.72),('15529','2014-02-24','10:05:00',1.75),('15529','2014-02-24','10:10:00',1.78),('15529','2014-02-24','10:15:00',1.82),('15529','2014-02-24','10:20:00',1.84),('15529','2014-02-24','10:25:00',1.85),('15529','2014-02-24','10:30:00',1.88),('15529','2014-02-24','10:35:00',1.91),('15529','2014-02-24','10:40:00',1.92),('15529','2014-02-24','10:45:00',1.95),('15529','2014-02-24','10:50:00',1.96),('15529','2014-02-24','10:55:00',1.95),('15529','2014-02-24','11:00:00',1.99),('15529','2014-02-24','11:05:00',2.02),('15529','2014-02-24','11:10:00',2.04),('15529','2014-02-24','11:15:00',2.04),('15529','2014-02-24','11:20:00',2.07),('15529','2014-02-24','11:25:00',2.08),('15529','2014-02-24','11:30:00',2.08),('15529','2014-02-24','11:35:00',2.11),('15529','2014-02-24','11:40:00',2.12),('15529','2014-02-24','11:45:00',2.11),('15529','2014-02-24','11:50:00',2.12),('15529','2014-02-24','11:55:00',2.1),('15529','2014-02-24','12:00:00',2.13),('15529','2014-02-24','12:05:00',2.16),('15529','2014-02-24','12:10:00',2.14),('15529','2014-02-24','12:15:00',2.14),('15529','2014-02-24','12:20:00',2.14),('15529','2014-02-24','12:25:00',2.12),('15529','2014-02-24','12:30:00',2.15),('15529','2014-02-24','12:35:00',2.14),('15529','2014-02-24','12:40:00',2.12),('15529','2014-02-24','12:45:00',2.15),('15529','2014-02-24','12:50:00',2.11),('15529','2014-02-24','12:55:00',2.12),('15529','2014-02-24','13:00:00',2.12),('15529','2014-02-24','13:05:00',2.03),('15529','2014-02-24','13:10:00',1.2),('15529','2014-02-24','13:15:00',1.78),('15529','2014-02-24','13:20:00',2.04),('15529','2014-02-24','13:25:00',1.29),('15529','2014-02-24','13:45:00',1.78),('15529','2014-02-24','13:50:00',2.15),('15529','2014-02-24','13:55:00',2.14),('15529','2014-02-24','14:00:00',2.02),('15529','2014-02-24','14:05:00',1.99),('15529','2014-02-24','14:10:00',1.85),('15529','2014-02-24','14:15:00',1.73),('15529','2014-02-24','14:20:00',1.61),('15529','2014-02-24','14:25:00',1.6),('15529','2014-02-24','14:30:00',1.65),('15529','2014-02-24','14:35:00',1.68),('15529','2014-02-24','14:40:00',1.76),('15529','2014-02-24','14:45:00',1.72),('15529','2014-02-24','14:50:00',1.55),('15529','2014-02-24','14:55:00',1.62),('15529','2014-02-24','15:00:00',1.52),('15529','2014-02-24','15:05:00',1.52),('15529','2014-02-24','15:10:00',1.44),('15529','2014-02-24','15:15:00',1.43),('15529','2014-02-24','15:20:00',1.33),('15529','2014-02-24','15:25:00',1.16),('15529','2014-02-24','15:30:00',1.08),('15529','2014-02-24','15:35:00',1.02),('15529','2014-02-23','08:15:00',1.05),('15529','2014-02-23','08:20:00',1.09),('15529','2014-02-23','08:55:00',1.39),('15529','2014-02-23','09:00:00',1.36),('15529','2014-02-23','09:05:00',1.37),('15529','2014-02-23','09:10:00',1.4),('15529','2014-02-23','09:15:00',1.44),('15529','2014-02-23','09:20:00',1.48),('15529','2014-02-23','09:25:00',1.52),('15529','2014-02-23','09:30:00',1.54),('15529','2014-02-23','09:35:00',1.58),('15529','2014-02-23','09:40:00',1.61),('15529','2014-02-23','09:45:00',1.65),('15529','2014-02-23','09:50:00',1.69),('15529','2014-02-23','09:55:00',1.73),('15529','2014-02-23','10:00:00',1.77),('15529','2014-02-23','10:05:00',1.8),('15529','2014-02-23','10:10:00',1.83),('15529','2014-02-23','10:15:00',1.85),('15529','2014-02-23','10:20:00',1.88),('15529','2014-02-23','10:25:00',1.91),('15529','2014-02-23','10:30:00',1.94),('15529','2014-02-23','10:35:00',1.96),('15529','2014-02-23','10:40:00',1.98),('15529','2014-02-23','10:45:00',1.97),('15529','2014-02-23','10:50:00',2.01),('15529','2014-02-23','10:55:00',2.04),('15529','2014-02-23','11:00:00',2.04),('15529','2014-02-23','11:05:00',2.06),('15529','2014-02-23','11:10:00',2.06),('15529','2014-02-23','11:15:00',2.05),('15529','2014-02-23','11:20:00',2.08),('15529','2014-02-23','11:25:00',2.14),('15529','2014-02-23','11:30:00',2.2),('15529','2014-02-23','11:35:00',2.07),('15529','2014-02-23','11:40:00',1.25),('15529','2014-02-23','11:45:00',1.72),('15529','2014-02-23','11:50:00',1.54),('15529','2014-02-23','11:55:00',2.06),('15529','2014-02-23','12:00:00',1.55),('15529','2014-02-23','12:05:00',2.28),('15529','2014-02-23','12:10:00',2.21),('15529','2014-02-23','12:15:00',2.18),('15529','2014-02-23','12:20:00',2.2),('15529','2014-02-23','12:25:00',2.19),('15529','2014-02-23','12:30:00',2.22),('15529','2014-02-23','12:35:00',2.22),('15529','2014-02-23','12:40:00',2.25),('15529','2014-02-23','12:45:00',2.23),('15529','2014-02-23','12:50:00',2.21),('15529','2014-02-23','12:55:00',2.11),('15529','2014-02-23','13:00:00',1.06),('15529','2014-02-23','13:05:00',1.9),('15529','2014-02-23','15:25:00',1.32),('15529','2014-02-23','15:35:00',1.14),('15529','2014-02-23','15:40:00',1.24),('15529','2014-02-23','15:45:00',1.37),('15529','2014-02-23','15:50:00',1.36),('15529','2014-02-23','15:55:00',1.34),('15529','2014-02-23','16:00:00',1.35),('15529','2014-02-23','16:05:00',1.29),('15529','2014-02-23','16:10:00',1.22),('15529','2014-02-23','16:15:00',1.08),('15529','2014-02-22','08:35:00',1.03),('15529','2014-02-22','08:40:00',1.08),('15529','2014-02-22','08:45:00',1.13),('15529','2014-02-22','08:50:00',1.19),('15529','2014-02-22','08:55:00',1.24),('15529','2014-02-22','09:00:00',1.29),('15529','2014-02-22','09:05:00',1.34),('15529','2014-02-22','09:10:00',1.4),('15529','2014-02-22','09:15:00',1.45),('15529','2014-02-22','09:20:00',1.49),('15529','2014-02-22','09:25:00',1.38),('15529','2014-02-22','09:30:00',1.37),('15529','2014-02-22','09:35:00',1.58),('15529','2014-02-22','09:40:00',1.61),('15529','2014-02-22','09:45:00',1.63),('15529','2014-02-22','09:50:00',1.65),('15529','2014-02-22','09:55:00',1.69),('15529','2014-02-22','10:00:00',1.72),('15529','2014-02-22','10:05:00',1.74),('15529','2014-02-22','10:10:00',1.78),('15529','2014-02-22','10:15:00',1.79),('15529','2014-02-22','10:20:00',1.82),('15529','2014-02-22','10:25:00',1.85),('15529','2014-02-22','10:30:00',1.88),('15529','2014-02-22','10:35:00',1.89),('15529','2014-02-22','10:40:00',1.93),('15529','2014-02-22','10:45:00',1.94),('15529','2014-02-22','10:50:00',1.93),('15529','2014-02-22','10:55:00',2),('15529','2014-02-22','11:00:00',2.02),('15529','2014-02-22','11:05:00',2.03),('15529','2014-02-22','11:10:00',2.01),('15529','2014-02-22','11:15:00',2.09),('15529','2014-02-22','11:20:00',2.13),('15529','2014-02-22','11:25:00',2.18),('15529','2014-02-22','11:30:00',2.16),('15529','2014-02-22','11:35:00',2.11),('15529','2014-02-22','11:40:00',1.91),('15529','2014-02-22','11:45:00',1.97),('15529','2014-02-22','11:50:00',2.15),('15529','2014-02-22','11:55:00',1.78),('15529','2014-02-22','12:00:00',2.21),('15529','2014-02-22','12:05:00',2.32),('15529','2014-02-22','12:10:00',2.1),('15529','2014-02-22','12:15:00',2.4),('15529','2014-02-22','12:20:00',1.81),('15529','2014-02-22','12:30:00',2.05),('15529','2014-02-22','12:35:00',1.53),('15529','2014-02-22','12:40:00',1.54),('15529','2014-02-22','12:45:00',1.39),('15529','2014-02-22','12:50:00',1.45),('15529','2014-02-22','12:55:00',1.64),('15529','2014-02-22','13:00:00',1.99),('15529','2014-02-22','13:05:00',2.19),('15529','2014-02-22','13:10:00',2.21),('15529','2014-02-22','13:15:00',2.21),('15529','2014-02-22','13:20:00',2.2),('15529','2014-02-22','13:25:00',2.17),('15529','2014-02-22','13:30:00',1.81),('15529','2014-02-22','13:35:00',1.74),('15529','2014-02-22','13:40:00',1.85),('15529','2014-02-22','13:45:00',1.68),('15529','2014-02-22','13:50:00',1.12),('15529','2014-02-22','14:05:00',1.05),('15529','2014-02-22','14:10:00',2),('15529','2014-02-22','14:20:00',1.41),('15529','2014-02-22','14:25:00',1.87),('15529','2014-02-22','14:30:00',1.27),('15529','2014-02-22','14:35:00',1.58),('15529','2014-02-22','14:40:00',1.96),('15529','2014-02-22','14:45:00',2.05),('15529','2014-02-22','14:50:00',1.99),('15529','2014-02-22','14:55:00',1.62),('15529','2014-02-22','15:25:00',1.35),('15529','2014-02-21','10:10:00',1.31),('15529','2014-02-21','10:40:00',1.39),('15529','2014-02-21','10:45:00',2.27),('15529','2014-02-21','12:20:00',1.09),('15529','2014-02-21','12:40:00',2),('15529','2014-02-21','12:45:00',2.31),('15529','2014-02-21','12:50:00',2.35),('15529','2014-02-21','12:55:00',1.06),('15529','2014-02-21','13:05:00',2.17),('15529','2014-02-21','13:10:00',2.24),('15529','2014-02-21','13:30:00',1.78),('15529','2014-02-21','13:35:00',1.89),('15529','2014-02-21','13:40:00',1.4),('15529','2014-02-21','13:45:00',1.53),('15529','2014-02-21','13:50:00',2.31),('15529','2014-02-21','13:55:00',2.24),('15529','2014-02-21','14:00:00',1.57),('15529','2014-02-21','14:05:00',1.65),('15529','2014-02-21','14:10:00',2.04),('15529','2014-02-21','14:15:00',1.99),('15529','2014-02-21','14:20:00',1.93),('15529','2014-02-21','14:25:00',1.74),('15529','2014-02-21','14:30:00',1.91),('15529','2014-02-21','14:35:00',1.72),('15529','2014-02-21','14:40:00',1.97),('15529','2014-02-21','14:45:00',1.99),('15529','2014-02-21','15:00:00',1.02),('15529','2014-02-21','15:20:00',1.02),('15529','2014-02-21','15:45:00',1.17),('15529','2014-02-20','10:20:00',1.2),('15529','2014-02-20','10:25:00',1.31),('15529','2014-02-20','10:30:00',1.09),('15529','2014-02-20','10:50:00',1.5),('15529','2014-02-20','10:55:00',1.71),('15529','2014-02-20','11:00:00',1.62),('15529','2014-02-20','11:10:00',1.03),('15529','2014-02-20','11:55:00',1.74),('15529','2014-02-20','12:00:00',2.62),('15529','2014-02-20','12:05:00',1.89),('15529','2014-02-20','12:10:00',1.81),('15529','2014-02-20','12:15:00',1.19),('15529','2014-02-20','15:35:00',1.14),('15529','2014-02-20','15:40:00',1.19),('15529','2014-02-20','15:45:00',1.13),('15529','2014-02-18','13:45:00',1.23),('15529','2014-02-18','13:50:00',1.12),('15529','2014-02-18','13:55:00',1.08),('15529','2014-02-18','14:00:00',1.02),('15529','2014-02-18','14:20:00',1.07),('15529','2014-02-17','08:45:00',1.01),('15529','2014-02-17','08:50:00',1.04),('15529','2014-02-17','08:55:00',1.11),('15529','2014-02-17','09:00:00',1.15),('15529','2014-02-17','09:05:00',1.2),('15529','2014-02-17','09:10:00',1.24),('15529','2014-02-17','09:15:00',1.28),('15529','2014-02-17','09:20:00',1.33),('15529','2014-02-17','09:25:00',1.37),('15529','2014-02-17','09:30:00',1.41),('15529','2014-02-17','09:35:00',1.44),('15529','2014-02-17','09:40:00',1.48),('15529','2014-02-17','09:45:00',1.51),('15529','2014-02-17','09:50:00',1.55),('15529','2014-02-17','09:55:00',1.59),('15529','2014-02-17','10:00:00',1.61),('15529','2014-02-17','10:05:00',1.64),('15529','2014-02-17','10:10:00',1.67),('15529','2014-02-17','10:15:00',1.69),('15529','2014-02-17','10:20:00',1.71),('15529','2014-02-17','10:25:00',1.73),('15529','2014-02-17','10:30:00',1.76),('15529','2014-02-17','10:35:00',1.78),('15529','2014-02-17','10:40:00',1.8),('15529','2014-02-17','10:45:00',1.82),('15529','2014-02-17','10:50:00',1.85),('15529','2014-02-17','10:55:00',1.89),('15529','2014-02-17','11:00:00',1.92),('15529','2014-02-17','11:05:00',1.67),('15529','2014-02-17','11:10:00',1.66),('15529','2014-02-17','11:15:00',1.56),('15529','2014-02-17','11:20:00',1.78),('15529','2014-02-17','11:25:00',1.92),('15529','2014-02-17','11:30:00',1.82),('15529','2014-02-17','11:35:00',1.72),('15529','2014-02-17','11:40:00',1.06),('15529','2014-02-17','11:45:00',1.09),('15529','2014-02-17','12:25:00',1.14),('15529','2014-02-17','12:30:00',1.13),('15529','2014-02-17','13:15:00',1.11),('15529','2014-02-17','13:20:00',1.14),('15529','2014-02-17','13:25:00',1.5),('15529','2014-02-17','13:40:00',1.18),('15529','2014-02-17','13:45:00',1.18),('15529','2014-02-17','14:00:00',1.02),('15529','2014-02-17','14:05:00',1.46),('15529','2014-02-16','09:05:00',1.05),('15529','2014-02-16','09:10:00',1.11),('15529','2014-02-16','09:15:00',1.17),('15529','2014-02-16','09:20:00',1.21),('15529','2014-02-16','09:25:00',1.25),('15529','2014-02-16','09:30:00',1.3),('15529','2014-02-16','09:35:00',1.33),('15529','2014-02-16','09:40:00',1.37),('15529','2014-02-16','09:45:00',1.39),('15529','2014-02-16','09:50:00',1.41),('15529','2014-02-16','09:55:00',1.44),('15529','2014-02-16','10:00:00',1.46),('15529','2014-02-16','10:05:00',1.5),('15529','2014-02-16','10:10:00',1.53),('15529','2014-02-16','10:15:00',1.55),('15529','2014-02-16','10:20:00',1.56),('15529','2014-02-16','10:25:00',1.59),('15529','2014-02-16','10:30:00',1.6),('15529','2014-02-16','10:35:00',1.61),('15529','2014-02-16','10:40:00',1.6),('15529','2014-02-16','10:45:00',1.62),('15529','2014-02-16','10:50:00',1.65),('15529','2014-02-16','10:55:00',1.68),('15529','2014-02-16','11:00:00',1.69),('15529','2014-02-16','11:05:00',1.71),('15529','2014-02-16','11:10:00',1.73),('15529','2014-02-16','11:15:00',1.74),('15529','2014-02-16','11:20:00',1.74),('15529','2014-02-16','11:25:00',1.8),('15529','2014-02-16','11:30:00',1.85),('15529','2014-02-16','11:35:00',1.88),('15529','2014-02-16','11:40:00',1.87),('15529','2014-02-16','11:45:00',1.89),('15529','2014-02-16','11:50:00',1.89),('15529','2014-02-16','11:55:00',1.89),('15529','2014-02-16','12:00:00',1.88),('15529','2014-02-16','12:05:00',1.9),('15529','2014-02-16','12:10:00',1.89),('15529','2014-02-16','12:15:00',1.9),('15529','2014-02-16','12:20:00',1.9),('15529','2014-02-16','12:25:00',1.89),('15529','2014-02-16','12:30:00',1.88),('15529','2014-02-16','12:35:00',1.9),('15529','2014-02-16','12:40:00',1.89),('15529','2014-02-16','12:45:00',1.87),('15529','2014-02-16','12:50:00',1.88),('15529','2014-02-16','12:55:00',1.86),('15529','2014-02-16','13:00:00',1.86),('15529','2014-02-16','13:05:00',1.87),('15529','2014-02-16','13:10:00',1.87),('15529','2014-02-16','13:15:00',1.85),('15529','2014-02-16','13:20:00',1.83),('15529','2014-02-16','13:25:00',1.82),('15529','2014-02-16','13:30:00',1.83),('15529','2014-02-16','13:35:00',1.82),('15529','2014-02-16','13:40:00',1.8),('15529','2014-02-16','13:45:00',1.74),('15529','2014-02-16','13:50:00',1.74),('15529','2014-02-16','13:55:00',1.73),('15529','2014-02-16','14:00:00',1.7),('15529','2014-02-16','14:05:00',1.69),('15529','2014-02-16','14:10:00',1.62),('15529','2014-02-16','14:15:00',1.59),('15529','2014-02-16','14:20:00',1.63),('15529','2014-02-16','14:25:00',1.58),('15529','2014-02-16','14:30:00',1.51),('15529','2014-02-16','14:35:00',1.47),('15529','2014-02-16','14:40:00',1.46),('15529','2014-02-16','14:45:00',1.49),('15529','2014-02-16','14:50:00',1.45),('15529','2014-02-16','14:55:00',1.37),('15529','2014-02-16','15:00:00',1.3),('15529','2014-02-16','15:05:00',1.27),('15529','2014-02-16','15:10:00',1.25),('15529','2014-02-16','15:15:00',1.27),('15529','2014-02-16','15:20:00',1.21),('15529','2014-02-16','15:25:00',1.16),('15529','2014-02-16','15:30:00',1.12),('15529','2014-02-16','15:35:00',1.07),('15529','2014-02-15','08:45:00',1.01),('15529','2014-02-15','08:50:00',1.02),('15529','2014-02-15','08:55:00',1.11),('15529','2014-02-15','09:00:00',1.21),('15529','2014-02-15','09:05:00',1.24),('15529','2014-02-15','09:10:00',1.16),('15529','2014-02-15','09:15:00',1),('15529','2014-02-15','09:20:00',1.31),('15529','2014-02-15','09:25:00',1.33),('15529','2014-02-15','09:30:00',1.31),('15529','2014-02-15','09:35:00',1.1),('15529','2014-02-15','09:40:00',1.47),('15529','2014-02-15','09:45:00',1.52),('15529','2014-02-15','09:50:00',1.54),('15529','2014-02-15','09:55:00',1.44),('15529','2014-02-15','10:00:00',1.5),('15529','2014-02-15','10:05:00',1.64),('15529','2014-02-15','10:10:00',1.67),('15529','2014-02-15','10:15:00',1.69),('15529','2014-02-15','10:20:00',1.7),('15529','2014-02-15','10:25:00',1.75),('15529','2014-02-15','10:30:00',1.75),('15529','2014-02-15','10:35:00',1.8),('15529','2014-02-15','10:40:00',1.82),('15529','2014-02-15','10:45:00',1.74),('15529','2014-02-15','10:50:00',1.45),('15529','2014-02-15','10:55:00',1.72),('15529','2014-02-15','11:00:00',1.87),('15529','2014-02-15','11:05:00',1.88),('15529','2014-02-15','11:10:00',1.81),('15529','2014-02-15','11:15:00',1.87),('15529','2014-02-15','11:20:00',1.77),('15529','2014-02-15','11:25:00',1.82),('15529','2014-02-15','11:30:00',1.81),('15529','2014-02-15','11:35:00',1.93),('15529','2014-02-15','11:40:00',1.85),('15529','2014-02-15','11:45:00',1.85),('15529','2014-02-15','11:50:00',1.88),('15529','2014-02-15','11:55:00',1.76),('15529','2014-02-15','12:00:00',1.98),('15529','2014-02-15','12:05:00',1.99),('15529','2014-02-15','12:10:00',1.97),('15529','2014-02-15','12:15:00',1.99),('15529','2014-02-15','12:20:00',1.93),('15529','2014-02-15','12:25:00',1.99),('15529','2014-02-15','12:30:00',1.99),('15529','2014-02-15','12:35:00',1.97),('15529','2014-02-15','12:40:00',1.98),('15529','2014-02-15','12:45:00',1.96),('15529','2014-02-15','12:50:00',1.97),('15529','2014-02-15','12:55:00',1.95),('15529','2014-02-15','13:00:00',1.93),('15529','2014-02-15','13:05:00',1.91),('15529','2014-02-15','13:10:00',1.85),('15529','2014-02-15','13:15:00',1.93),('15529','2014-02-15','13:20:00',1.9),('15529','2014-02-15','13:25:00',1.85),('15529','2014-02-15','13:30:00',1.84),('15529','2014-02-15','13:35:00',1.83),('15529','2014-02-15','13:40:00',1.82),('15529','2014-02-15','13:45:00',1.81),('15529','2014-02-15','13:50:00',1.83),('15529','2014-02-15','13:55:00',1.81),('15529','2014-02-15','14:00:00',1.83),('15529','2014-02-15','14:05:00',1.8),('15529','2014-02-15','14:10:00',1.78),('15529','2014-02-15','14:15:00',1.75),('15529','2014-02-15','14:20:00',1.74),('15529','2014-02-15','14:25:00',1.71),('15529','2014-02-15','14:30:00',1.68),('15529','2014-02-15','14:35:00',1.63),('15529','2014-02-15','14:40:00',1.58),('15529','2014-02-15','14:45:00',1.58),('15529','2014-02-15','14:50:00',1.55),('15529','2014-02-15','14:55:00',1.48),('15529','2014-02-15','15:00:00',1.41),('15529','2014-02-15','15:05:00',1.44),('15529','2014-02-15','15:10:00',1.41),('15529','2014-02-15','15:15:00',1.36),('15529','2014-02-15','15:20:00',1.3),('15529','2014-02-15','15:25:00',1.27),('15529','2014-02-15','15:30:00',1.22),('15529','2014-02-15','15:35:00',1.18),('15529','2014-02-15','15:45:00',1.12),('15529','2014-04-27','08:20:00',1.05),('15529','2014-04-27','09:05:00',1.16),('15529','2014-04-27','09:10:00',1.46),('15529','2014-04-27','09:15:00',1.53),('15529','2014-04-27','09:20:00',1.58),('15529','2014-04-27','09:30:00',1.41),('15529','2014-04-27','09:35:00',1.44),('15529','2014-04-27','10:00:00',1.1),('15529','2014-04-27','10:05:00',1.11),('15529','2014-04-27','10:55:00',1.02),('15529','2014-04-27','11:00:00',1.36),('15529','2014-04-27','11:05:00',1.41),('15529','2014-04-27','11:10:00',1.51),('15529','2014-04-27','11:15:00',1.42),('15529','2014-04-27','11:20:00',1.04),('15529','2014-04-27','12:05:00',1.05),('15529','2014-04-27','12:10:00',1.54),('15529','2014-04-27','12:15:00',1.39),('15529','2014-04-27','12:20:00',1.31),('15529','2014-04-27','12:25:00',1.44),('15529','2014-04-27','12:30:00',1.29),('15529','2014-04-27','12:35:00',1.03),('15529','2014-04-27','12:45:00',1.02),('15529','2014-04-27','12:50:00',1.06),('15529','2014-04-27','12:55:00',1.06),('15529','2014-04-27','13:00:00',1.74),('15529','2014-04-27','13:05:00',1.27),('15529','2014-04-27','13:10:00',1.1),('15529','2014-04-27','13:15:00',1.64),('15529','2014-04-27','13:20:00',1.47),('15529','2014-04-27','13:25:00',1.24),('15529','2014-04-27','13:30:00',2.59),('15529','2014-04-27','13:35:00',2.08),('15529','2014-04-27','13:40:00',2.46),('15529','2014-04-27','13:45:00',2.54),('15529','2014-04-27','13:50:00',1.27),('15529','2014-04-27','13:55:00',1.73),('15529','2014-04-27','14:00:00',1.98),('15529','2014-04-27','14:05:00',2.55),('15529','2014-04-27','14:10:00',1.38),('15529','2014-04-27','14:15:00',1.75),('15529','2014-04-27','14:20:00',2.25),('15529','2014-04-27','14:25:00',2.11),('15529','2014-04-27','14:35:00',2.08),('15529','2014-04-27','14:40:00',2.29),('15529','2014-04-27','14:45:00',1.72),('15529','2014-04-27','14:50:00',1.81),('15529','2014-04-27','14:55:00',1.08),('15529','2014-04-27','15:00:00',1.56),('15529','2014-04-27','15:10:00',1.1),('15529','2014-04-27','15:15:00',1.49),('15529','2014-04-27','15:20:00',1.53),('15529','2014-04-27','15:30:00',1.1),('15529','2014-04-27','15:35:00',1.14),('15529','2014-04-27','15:45:00',1.76),('15529','2014-04-27','15:55:00',1.15),('15529','2014-04-27','16:00:00',1.22),('15529','2014-04-27','16:05:00',1.62),('15529','2014-04-27','16:10:00',1.5),('15529','2014-04-27','16:15:00',1.2),('15529','2014-04-27','16:20:00',1.33),('15529','2014-04-27','16:25:00',1.72),('15529','2014-04-27','16:30:00',1.48),('15529','2014-04-27','16:50:00',1.33),('15529','2014-02-14','08:55:00',1.05),('15529','2014-02-14','09:00:00',1.12),('15529','2014-02-14','09:05:00',1.16),('15529','2014-02-14','09:10:00',1.2),('15529','2014-02-14','09:15:00',1.22),('15529','2014-02-14','09:20:00',1.28),('15529','2014-02-14','09:25:00',1.31),('15529','2014-02-14','09:30:00',1.32),('15529','2014-02-14','09:35:00',1.37),('15529','2014-02-14','09:40:00',1.43),('15529','2014-02-14','09:45:00',1.44),('15529','2014-02-14','09:50:00',1.47),('15529','2014-02-14','09:55:00',1.52),('15529','2014-02-14','10:00:00',1.55),('15529','2014-02-14','10:05:00',1.57),('15529','2014-02-14','10:10:00',1.59),('15529','2014-02-14','10:15:00',1.61),('15529','2014-02-14','10:20:00',1.61),('15529','2014-02-14','10:25:00',1.64),('15529','2014-02-14','10:30:00',1.65),('15529','2014-02-14','10:35:00',1.67),('15529','2014-02-14','10:40:00',1.72),('15529','2014-02-14','10:45:00',1.76),('15529','2014-02-14','10:50:00',1.75),('15529','2014-02-14','10:55:00',1.77),('15529','2014-02-14','11:00:00',1.77),('15529','2014-02-14','11:05:00',1.82),('15529','2014-02-14','11:10:00',1.88),('15529','2014-02-14','11:15:00',1.43),('15529','2014-02-14','11:25:00',1.27),('15529','2014-02-14','11:35:00',2.07),('15529','2014-02-14','11:40:00',1.03),('15529','2014-02-14','11:45:00',2.24),('15529','2014-02-14','11:50:00',1.83),('15529','2014-02-14','11:55:00',1.33),('15529','2014-02-14','12:00:00',2.18),('15529','2014-02-14','12:05:00',2.15),('15529','2014-02-14','12:10:00',2.07),('15529','2014-02-14','12:15:00',2.07),('15529','2014-02-14','12:20:00',1.77),('15529','2014-02-14','12:25:00',2.06),('15529','2014-02-14','12:35:00',1.55),('15529','2014-02-14','12:40:00',2.11),('15529','2014-02-14','12:45:00',2.08),('15529','2014-02-14','12:50:00',2.02),('15529','2014-02-14','12:55:00',2.01),('15529','2014-02-14','13:00:00',1.96),('15529','2014-02-14','13:05:00',1.3),('15529','2014-02-14','13:10:00',1.22),('15529','2014-02-14','13:15:00',2.12),('15529','2014-02-14','13:20:00',2.09),('15529','2014-02-14','13:25:00',1.99),('15529','2014-02-14','13:30:00',1.86),('15529','2014-02-14','13:35:00',1.87),('15529','2014-02-14','13:40:00',1.97),('15529','2014-02-14','13:45:00',1.46),('15529','2014-02-14','13:50:00',1.85),('15529','2014-02-14','13:55:00',1.84),('15529','2014-02-14','14:00:00',1.54),('15529','2014-02-14','14:05:00',1.63),('15529','2014-02-14','14:10:00',1.64),('15529','2014-02-14','14:15:00',1.69),('15529','2014-02-14','14:20:00',1.71),('15529','2014-02-14','14:25:00',1.67),('15529','2014-02-14','14:30:00',1.66),('15529','2014-02-14','14:35:00',1.62),('15529','2014-02-14','14:40:00',1.59),('15529','2014-02-14','14:45:00',1.54),('15529','2014-02-14','14:50:00',1.52),('15529','2014-02-14','14:55:00',1.48),('15529','2014-02-14','15:00:00',1.46),('15529','2014-02-14','15:05:00',1.42),('15529','2014-02-14','15:10:00',1.38),('15529','2014-02-14','15:15:00',1.35),('15529','2014-02-14','15:20:00',1.3),('15529','2014-02-14','15:25:00',1.26),('15529','2014-02-14','15:30:00',1.21),('15529','2014-02-14','15:35:00',1.18),('15529','2014-02-14','15:40:00',1.13),('15529','2014-02-14','15:45:00',1.09),('15529','2014-02-14','15:50:00',1.04),('15529','2014-02-13','08:50:00',1),('15529','2014-02-13','08:55:00',1.04),('15529','2014-02-13','09:00:00',1.09),('15529','2014-02-13','09:05:00',1.15),('15529','2014-02-13','09:10:00',1.2),('15529','2014-02-13','09:20:00',1.04),('15529','2014-02-13','09:25:00',1.04),('15529','2014-02-13','09:35:00',1.06),('15529','2014-02-13','09:40:00',1.02),('15529','2014-02-13','09:45:00',1.28),('15529','2014-02-13','09:50:00',1.34),('15529','2014-02-13','09:55:00',1.55),('15529','2014-02-13','10:00:00',1.57),('15529','2014-02-13','10:05:00',1.55),('15529','2014-02-13','10:10:00',1.6),('15529','2014-02-13','10:15:00',1.79),('15529','2014-02-13','10:20:00',1.78),('15529','2014-02-13','10:25:00',1.7),('15529','2014-02-13','10:30:00',1.85),('15529','2014-02-13','10:35:00',1.83),('15529','2014-02-13','10:40:00',1.87),('15529','2014-02-13','10:45:00',1.94),('15529','2014-02-13','10:50:00',1.91),('15529','2014-02-13','10:55:00',1.92),('15529','2014-02-13','11:00:00',1.94),('15529','2014-02-13','11:05:00',1.97),('15529','2014-02-13','11:10:00',1.98),('15529','2014-02-13','11:15:00',2.01),('15529','2014-02-13','11:20:00',2.04),('15529','2014-02-13','11:25:00',2.04),('15529','2014-02-13','11:30:00',2.06),('15529','2014-02-13','11:35:00',2),('15529','2014-02-13','11:40:00',2.05),('15529','2014-02-13','11:45:00',2.08),('15529','2014-02-13','11:50:00',2.09),('15529','2014-02-13','11:55:00',2.04),('15529','2014-02-13','12:00:00',1.91),('15529','2014-02-13','12:05:00',1.96),('15529','2014-02-13','12:10:00',2.12),('15529','2014-02-13','12:15:00',2.09),('15529','2014-02-13','12:20:00',2.11),('15529','2014-02-13','12:25:00',2.1),('15529','2014-02-13','12:30:00',2.09),('15529','2014-02-13','12:35:00',2.09),('15529','2014-02-13','12:40:00',2.08),('15529','2014-02-13','12:45:00',2.05),('15529','2014-02-13','12:50:00',2.06),('15529','2014-02-13','12:55:00',2.06),('15529','2014-02-13','13:00:00',2.04),('15529','2014-02-13','13:05:00',2.06),('15529','2014-02-13','13:10:00',2.05),('15529','2014-02-13','13:15:00',2.03),('15529','2014-02-13','13:20:00',2.03),('15529','2014-02-13','13:25:00',2.01),('15529','2014-02-13','13:30:00',1.99),('15529','2014-02-13','13:35:00',1.98),('15529','2014-02-13','13:40:00',1.95),('15529','2014-02-13','13:45:00',1.95),('15529','2014-02-13','13:50:00',1.93),('15529','2014-02-13','13:55:00',1.91),('15529','2014-02-13','14:00:00',1.86),('15529','2014-02-13','14:05:00',1.85),('15529','2014-02-13','14:10:00',1.82),('15529','2014-02-13','14:15:00',1.79),('15529','2014-02-13','14:20:00',1.76),('15529','2014-02-13','14:25:00',1.74),('15529','2014-02-13','14:30:00',1.72),('15529','2014-02-13','14:35:00',1.68),('15529','2014-02-13','14:40:00',1.64),('15529','2014-02-13','14:45:00',1.61),('15529','2014-02-13','14:50:00',1.56),('15529','2014-02-13','14:55:00',1.53),('15529','2014-02-13','15:00:00',1.48),('15529','2014-02-13','15:05:00',1.44),('15529','2014-02-13','15:10:00',1.4),('15529','2014-02-13','15:15:00',1.36),('15529','2014-02-13','15:20:00',1.33),('15529','2014-02-13','15:25:00',1.28),('15529','2014-02-13','15:30:00',1.24),('15529','2014-02-13','15:35:00',1.2),('15529','2014-02-13','15:40:00',1.13),('15529','2014-02-13','15:45:00',1.07),('15529','2014-02-13','15:50:00',1.01),('15529','2014-02-12','08:55:00',1.04),('15529','2014-02-12','09:00:00',1.09),('15529','2014-02-12','09:05:00',1.14),('15529','2014-02-12','09:10:00',1.19),('15529','2014-02-12','09:15:00',1.24),('15529','2014-02-12','09:20:00',1.26),('15529','2014-02-12','09:25:00',1.32),('15529','2014-02-12','09:30:00',1.35),('15529','2014-02-12','09:35:00',1.39),('15529','2014-02-12','09:40:00',1.42),('15529','2014-02-12','09:45:00',1.46),('15529','2014-02-12','09:50:00',1.49),('15529','2014-02-12','09:55:00',1.52),('15529','2014-02-12','10:00:00',1.54),('15529','2014-02-12','10:05:00',1.58),('15529','2014-02-12','10:10:00',1.6),('15529','2014-02-12','10:15:00',1.62),('15529','2014-02-12','10:20:00',1.65),('15529','2014-02-12','10:25:00',1.7),('15529','2014-02-12','10:30:00',1.71),('15529','2014-02-12','10:35:00',1.73),('15529','2014-02-12','10:40:00',1.73),('15529','2014-02-12','10:45:00',1.75),('15529','2014-02-12','10:50:00',1.81),('15529','2014-02-12','10:55:00',1.82),('15529','2014-02-12','11:00:00',1.81),('15529','2014-02-12','11:05:00',1.86),('15529','2014-02-12','11:10:00',1.87),('15529','2014-02-12','11:15:00',1.87),('15529','2014-02-12','11:20:00',1.86),('15529','2014-02-12','11:25:00',1.15),('15529','2014-02-12','11:30:00',1.23),('15529','2014-02-12','11:40:00',1.5),('15529','2014-02-12','11:45:00',1.41),('15529','2014-02-12','11:55:00',1.06),('15529','2014-02-12','12:00:00',2.31),('15529','2014-02-12','12:05:00',1.96),('15529','2014-02-12','12:10:00',1.15),('15529','2014-02-12','12:15:00',1.73),('15529','2014-02-12','12:20:00',1.77),('15529','2014-02-12','12:25:00',2.23),('15529','2014-02-12','12:30:00',2.18),('15529','2014-02-12','12:35:00',2.18),('15529','2014-02-12','12:40:00',2.22),('15529','2014-02-12','12:45:00',2.1),('15529','2014-02-12','12:50:00',2.06),('15529','2014-02-12','12:55:00',2.05),('15529','2014-02-12','13:00:00',2.05),('15529','2014-02-12','13:05:00',2.04),('15529','2014-02-12','13:10:00',2.02),('15529','2014-02-12','13:15:00',2.01),('15529','2014-02-12','13:20:00',1.97),('15529','2014-02-12','13:25:00',1.97),('15529','2014-02-12','13:30:00',1.98),('15529','2014-02-12','13:35:00',1.97),('15529','2014-02-12','13:40:00',1.93),('15529','2014-02-12','13:45:00',1.92),('15529','2014-02-12','13:50:00',1.92),('15529','2014-02-12','13:55:00',1.89),('15529','2014-02-12','14:00:00',1.87),('15529','2014-02-12','14:05:00',1.84),('15529','2014-02-12','14:10:00',1.82),('15529','2014-02-12','14:15:00',1.8),('15529','2014-02-12','14:20:00',1.77),('15529','2014-02-12','14:25:00',1.73),('15529','2014-02-12','14:30:00',1.71),('15529','2014-02-12','14:35:00',1.71),('15529','2014-02-12','14:40:00',1.68),('15529','2014-02-12','14:45:00',1.17),('15529','2014-02-12','14:50:00',1.4),('15529','2014-02-12','15:00:00',1.56),('15529','2014-02-12','15:05:00',1.54),('15529','2014-02-12','15:15:00',1.5),('15529','2014-02-12','15:20:00',1.43),('15529','2014-02-12','15:30:00',1.45),('15529','2014-02-12','15:35:00',1.31),('15529','2014-02-12','15:40:00',1.03),('15529','2014-02-11','08:45:00',1.04),('15529','2014-02-11','08:50:00',1.05),('15529','2014-02-11','08:55:00',1.06),('15529','2014-02-11','09:00:00',1.09),('15529','2014-02-11','09:05:00',1.09),('15529','2014-02-11','09:10:00',1.31),('15529','2014-02-11','09:15:00',1.26),('15529','2014-02-11','09:20:00',1.02),('15529','2014-02-11','09:40:00',1.13),('15529','2014-02-11','09:45:00',1.36),('15529','2014-02-11','10:40:00',1.15),('15529','2014-02-11','11:30:00',1.09),('15529','2014-02-11','12:55:00',1.17),('15529','2014-02-11','13:00:00',1.26),('15529','2014-02-11','13:30:00',1.11),('15529','2014-02-11','13:35:00',1.74),('15529','2014-02-11','13:40:00',1.84),('15529','2014-02-11','13:45:00',1.39),('15529','2014-02-11','13:50:00',1.3),('15529','2014-02-11','13:55:00',1.54),('15529','2014-02-11','14:00:00',2.12),('15529','2014-02-11','14:05:00',1.79),('15529','2014-02-11','14:10:00',1.58),('15529','2014-02-11','14:15:00',2.05),('15529','2014-02-11','14:20:00',1.04),('15529','2014-02-11','14:25:00',1.01),('15529','2014-02-11','14:30:00',1.62),('15529','2014-02-11','14:40:00',1.68),('15529','2014-02-11','14:45:00',1.8),('15529','2014-02-11','14:50:00',1.69),('15529','2014-02-11','14:55:00',1.41),('15529','2014-02-11','15:00:00',1.13),('15529','2014-02-11','15:10:00',1.33),('15529','2014-02-11','15:15:00',1.4),('15529','2014-02-11','15:20:00',1.34),('15529','2014-02-11','15:35:00',1.48),('15529','2014-02-11','15:50:00',1.06),('15529','2014-02-11','15:55:00',1.13),('15529','2014-02-11','16:00:00',1.05),('15529','2014-02-10','10:20:00',1.15),('15529','2014-02-10','10:25:00',1.3),('15529','2014-02-10','10:30:00',1.38),('15529','2014-02-10','10:35:00',1.31),('15529','2014-02-10','10:40:00',1.21),('15529','2014-02-10','10:45:00',1.25),('15529','2014-02-10','10:50:00',1.37),('15529','2014-02-10','10:55:00',1.15),('15529','2014-02-10','11:00:00',1.33),('15529','2014-02-10','11:05:00',1.41),('15529','2014-02-10','11:10:00',1.25),('15529','2014-02-10','11:15:00',1.5),('15529','2014-02-10','11:20:00',1.32),('15529','2014-02-10','11:25:00',1.45),('15529','2014-02-10','11:30:00',1.08),('15529','2014-02-10','12:10:00',1.07),('15529','2014-02-10','12:15:00',1.07),('15529','2014-02-10','12:25:00',1.24),('15529','2014-02-10','12:30:00',1.26),('15529','2014-02-10','12:35:00',1.18),('15529','2014-02-10','13:05:00',1.43),('15529','2014-02-10','13:10:00',1.89),('15529','2014-02-10','13:15:00',1.89),('15529','2014-02-10','13:20:00',1.93),('15529','2014-02-10','13:25:00',1.61),('15529','2014-02-10','13:30:00',1.54),('15529','2014-02-10','13:35:00',1.58),('15529','2014-02-10','13:40:00',1.56),('15529','2014-02-10','13:45:00',1.44),('15529','2014-02-10','14:05:00',1.26),('15529','2014-02-10','14:15:00',1.23),('15529','2014-02-10','14:25:00',1.08),('15529','2014-02-08','12:55:00',1.69),('15529','2014-02-08','13:00:00',1.34),('15529','2014-02-08','13:05:00',1.95),('15529','2014-02-08','13:10:00',1.03),('15529','2014-02-08','13:40:00',1.16),('15529','2014-02-08','13:45:00',1.75),('15529','2014-02-08','13:55:00',1.48),('15529','2014-02-08','14:00:00',1.11),('15529','2014-02-08','14:05:00',1.51),('15529','2014-02-08','14:25:00',1.15),('15529','2014-02-08','14:30:00',1.41),('15529','2014-02-08','15:20:00',1.13),('15529','2014-02-07','09:45:00',1.2),('15529','2014-02-07','10:00:00',1.01),('15529','2014-02-07','10:30:00',1.33),('15529','2014-02-07','10:50:00',1.59),('15529','2014-02-07','11:00:00',1.99),('15529','2014-02-07','11:05:00',1.49),('15529','2014-02-07','11:10:00',1.53),('15529','2014-02-07','11:15:00',1.12),('15529','2014-02-07','11:25:00',1.11),('15529','2014-02-07','11:30:00',1.64),('15529','2014-02-07','11:35:00',1.34),('15529','2014-02-07','11:50:00',2.35),('15529','2014-02-07','12:10:00',1.3),('15529','2014-02-07','12:20:00',2.12),('15529','2014-02-07','12:25:00',1.89),('15529','2014-02-07','12:30:00',1.6),('15529','2014-02-07','12:40:00',1.38),('15529','2014-02-07','12:45:00',1.71),('15529','2014-02-07','12:50:00',1.45),('15529','2014-02-07','12:55:00',2.14),('15529','2014-02-07','13:05:00',1.09),('15529','2014-02-07','13:10:00',1.68),('15529','2014-02-07','13:15:00',1.58),('15529','2014-02-07','13:20:00',1.25),('15529','2014-02-07','13:25:00',2.18),('15529','2014-02-07','13:30:00',2.03),('15529','2014-02-07','13:35:00',2.16),('15529','2014-02-07','13:40:00',2.16),('15529','2014-02-07','13:45:00',1.8),('15529','2014-02-07','13:50:00',2.02),('15529','2014-02-07','13:55:00',1.98),('15529','2014-02-07','14:00:00',1.96),('15529','2014-02-07','14:05:00',1.97),('15529','2014-02-07','14:10:00',1.91),('15529','2014-02-07','14:15:00',1.38),('15529','2014-02-07','14:20:00',1.69),('15529','2014-02-07','14:35:00',1.52),('15529','2014-02-07','14:45:00',1.21),('15529','2014-02-07','14:50:00',1.6),('15529','2014-02-07','15:40:00',1.11),('15529','2014-02-06','08:50:00',1.02),('15529','2014-02-06','08:55:00',1.06),('15529','2014-02-06','09:00:00',1.11),('15529','2014-02-06','09:05:00',1.16),('15529','2014-02-06','09:10:00',1.21),('15529','2014-02-06','09:15:00',1.25),('15529','2014-02-06','09:20:00',1.29),('15529','2014-02-06','09:25:00',1.32),('15529','2014-02-06','09:30:00',1.36),('15529','2014-02-06','09:35:00',1.39),('15529','2014-02-06','09:40:00',1.41),('15529','2014-02-06','09:45:00',1.45),('15529','2014-02-06','09:50:00',1.48),('15529','2014-02-06','09:55:00',1.51),('15529','2014-02-06','10:00:00',1.59),('15529','2014-02-06','10:05:00',1.73),('15529','2014-02-06','10:10:00',1.82),('15529','2014-02-06','10:15:00',1.86),('15529','2014-02-06','10:20:00',1.9),('15529','2014-02-06','10:25:00',1.85),('15529','2014-02-06','10:30:00',2.04),('15529','2014-02-06','10:35:00',1.2),('15529','2014-02-06','10:40:00',1.66),('15529','2014-02-06','10:45:00',1),('15529','2014-02-06','10:50:00',1.66),('15529','2014-02-06','10:55:00',2.16),('15529','2014-02-06','11:00:00',1.7),('15529','2014-02-06','11:15:00',2.26),('15529','2014-02-06','11:20:00',2.2),('15529','2014-02-06','11:25:00',2.2),('15529','2014-02-06','11:30:00',2.12),('15529','2014-02-06','11:35:00',2.23),('15529','2014-02-06','11:40:00',1.75),('15529','2014-02-06','11:45:00',1.7),('15529','2014-02-06','11:55:00',2.32),('15529','2014-02-06','12:00:00',1.4),('15529','2014-02-06','12:05:00',1.1),('15529','2014-02-06','12:10:00',1.6),('15529','2014-02-06','12:55:00',1.24),('15529','2014-02-06','13:00:00',1.97),('15529','2014-02-06','13:05:00',1.16),('15529','2014-02-06','13:10:00',2.03),('15529','2014-02-06','13:15:00',2.11),('15529','2014-02-06','13:20:00',2.22),('15529','2014-02-06','13:25:00',2.29),('15529','2014-02-06','13:30:00',1.94),('15529','2014-02-06','13:35:00',1.98),('15529','2014-02-06','13:45:00',1.14),('15529','2014-02-06','13:50:00',1.63),('15529','2014-02-06','13:55:00',1.82),('15529','2014-02-06','14:00:00',1.84),('15529','2014-02-06','14:05:00',1.57),('15529','2014-02-06','14:10:00',1.91),('15529','2014-02-06','14:15:00',1.85),('15529','2014-02-06','14:20:00',1.81),('15529','2014-02-06','14:25:00',1.79),('15529','2014-02-06','14:30:00',1.77),('15529','2014-02-06','14:35:00',1.78),('15529','2014-02-06','14:40:00',1.69),('15529','2014-02-06','14:45:00',1.6),('15529','2014-02-06','14:50:00',1.08),('15529','2014-02-06','14:55:00',1.25),('15529','2014-02-06','15:10:00',1.32),('15529','2014-02-06','15:15:00',1.43),('15529','2014-02-06','15:25:00',1.21),('15529','2014-02-06','15:30:00',1.24),('15529','2014-02-06','15:35:00',1.11),('15529','2014-02-06','15:40:00',1.13),('15529','2014-02-06','15:45:00',1.1),('15529','2014-02-06','15:50:00',1.05),('15529','2014-02-06','15:55:00',1.01),('15529','2014-02-05','08:50:00',1.02),('15529','2014-02-05','08:55:00',1.12),('15529','2014-02-05','09:00:00',1.26),('15529','2014-02-05','09:05:00',1.31),('15529','2014-02-05','09:10:00',1.03),('15529','2014-02-05','09:15:00',1.12),('15529','2014-02-05','09:30:00',1.41),('15529','2014-02-05','09:35:00',1.41),('15529','2014-02-05','09:40:00',1.49),('15529','2014-02-05','09:45:00',1.49),('15529','2014-02-05','09:50:00',1.54),('15529','2014-02-05','09:55:00',1.58),('15529','2014-02-05','10:00:00',1.64),('15529','2014-02-05','10:05:00',1.65),('15529','2014-02-05','10:10:00',1.68),('15529','2014-02-05','10:15:00',1.71),('15529','2014-02-05','10:20:00',1.76),('15529','2014-02-05','10:25:00',1.77),('15529','2014-02-05','10:30:00',1.68),('15529','2014-02-05','10:35:00',1.85),('15529','2014-02-05','10:45:00',1.76),('15529','2014-02-05','10:50:00',1.73),('15529','2014-02-05','11:00:00',1.78),('15529','2014-02-05','11:05:00',1.1),('15529','2014-02-05','11:10:00',1.55),('15529','2014-02-05','11:15:00',1.78),('15529','2014-02-05','11:20:00',2.2),('15529','2014-02-05','11:25:00',2.11),('15529','2014-02-05','11:30:00',2.09),('15529','2014-02-05','11:35:00',2.07),('15529','2014-02-05','11:40:00',2.08),('15529','2014-02-05','11:45:00',2.08),('15529','2014-02-05','11:50:00',2.12),('15529','2014-02-05','11:55:00',2.13),('15529','2014-02-05','12:00:00',2.13),('15529','2014-02-05','12:05:00',2.13),('15529','2014-02-05','12:10:00',2.15),('15529','2014-02-05','12:15:00',2.15),('15529','2014-02-05','12:20:00',2.13),('15529','2014-02-05','12:25:00',2.1),('15529','2014-02-05','12:30:00',2.12),('15529','2014-02-05','12:35:00',2.12),('15529','2014-02-05','12:40:00',2.12),('15529','2014-02-05','12:45:00',2.1),('15529','2014-02-05','12:50:00',2.09),('15529','2014-02-05','12:55:00',2.1),('15529','2014-02-05','13:00:00',2.08),('15529','2014-02-05','13:05:00',2.08),('15529','2014-02-05','13:10:00',2.08),('15529','2014-02-05','13:15:00',2.06),('15529','2014-02-05','13:20:00',2.05),('15529','2014-02-05','13:25:00',2.09),('15529','2014-02-05','13:30:00',2.11),('15529','2014-02-05','13:35:00',2.1),('15529','2014-02-05','13:40:00',2),('15529','2014-02-05','13:45:00',1.96),('15529','2014-02-05','13:50:00',1.94),('15529','2014-02-05','13:55:00',1.76),('15529','2014-02-05','14:00:00',1.91),('15529','2014-02-05','14:05:00',1.89),('15529','2014-02-05','14:10:00',1.83),('15529','2014-02-05','14:15:00',1.79),('15529','2014-02-05','14:20:00',1.47),('15529','2014-02-05','14:25:00',1.83),('15529','2014-02-05','14:30:00',1.44),('15529','2014-02-05','14:35:00',1.72),('15529','2014-02-05','14:40:00',1.7),('15529','2014-02-05','14:45:00',1.66),('15529','2014-02-05','14:50:00',1.62),('15529','2014-02-05','14:55:00',1.56),('15529','2014-02-05','15:00:00',1.48),('15529','2014-02-05','15:05:00',1.45),('15529','2014-02-05','15:10:00',1.39),('15529','2014-02-05','15:15:00',1.36),('15529','2014-02-05','15:20:00',1.32),('15529','2014-02-05','15:25:00',1.28),('15529','2014-02-05','15:30:00',1.22),('15529','2014-02-05','15:35:00',1.17),('15529','2014-02-05','15:40:00',1.12),('15529','2014-02-05','15:45:00',1.07),('15529','2014-02-05','15:50:00',1.01),('15529','2014-04-26','11:40:00',1.36),('15529','2014-04-26','11:45:00',1.82),('15529','2014-04-26','11:50:00',1.68),('15529','2014-04-26','11:55:00',1.21),('15529','2014-04-26','12:00:00',1.24),('15529','2014-04-26','12:05:00',1.46),('15529','2014-04-26','12:10:00',1.41),('15529','2014-04-26','12:15:00',1.45),('15529','2014-04-26','12:20:00',1.41),('15529','2014-04-26','12:25:00',1.42),('15529','2014-04-26','12:30:00',1.49),('15529','2014-04-26','12:35:00',1.73),('15529','2014-04-26','12:40:00',1.47),('15529','2014-04-26','12:45:00',1.12),('15529','2014-04-26','12:55:00',1.25),('15529','2014-04-26','13:00:00',1.04),('15529','2014-04-26','13:15:00',1.1),('15529','2014-04-26','13:20:00',1.16),('15529','2014-04-26','13:25:00',1.03),('15529','2014-04-26','14:00:00',1.42),('15529','2014-04-26','14:20:00',1.04),('15529','2014-04-26','14:25:00',1.18),('15529','2014-04-26','14:30:00',1.17),('15529','2014-04-26','14:35:00',1.41),('15529','2014-04-26','14:40:00',1.34),('15529','2014-04-26','14:45:00',1.01),('15529','2014-04-26','14:55:00',1.01),('15529','2014-04-26','15:00:00',1.2),('15529','2014-04-26','15:05:00',1.66),('15529','2014-04-26','15:10:00',1.51),('15529','2014-04-26','15:15:00',1.08),('15529','2014-02-04','10:10:00',1.2),('15529','2014-02-04','10:15:00',2.26),('15529','2014-02-04','10:20:00',2.16),('15529','2014-02-04','10:25:00',1.12),('15529','2014-02-04','10:35:00',1),('15529','2014-02-04','10:40:00',1.35),('15529','2014-02-04','11:20:00',2.05),('15529','2014-02-04','11:25:00',1.74),('15529','2014-02-04','13:05:00',1.09),('15529','2014-02-04','13:10:00',1.14),('15529','2014-02-04','13:35:00',1.03),('15529','2014-02-04','13:40:00',1.04),('15529','2014-02-04','13:45:00',1.02),('15529','2014-02-04','14:25:00',1.74),('15529','2014-02-04','14:30:00',1.61),('15529','2014-02-04','14:35:00',1.06),('15529','2014-02-03','09:35:00',1.16),('15529','2014-02-03','09:40:00',1.68),('15529','2014-02-03','09:45:00',1.32),('15529','2014-02-03','09:50:00',1.56),('15529','2014-02-03','10:15:00',1.16),('15529','2014-02-03','10:20:00',1.21),('15529','2014-02-03','10:25:00',1.3),('15529','2014-02-03','10:50:00',1.47),('15529','2014-02-03','10:55:00',1.75),('15529','2014-02-03','11:00:00',2.08),('15529','2014-02-03','11:05:00',2.33),('15529','2014-02-03','11:10:00',2.03),('15529','2014-02-03','11:15:00',1.31),('15529','2014-02-03','11:20:00',1.51),('15529','2014-02-03','11:50:00',1.26),('15529','2014-02-03','11:55:00',1.45),('15529','2014-02-03','12:00:00',1.32),('15529','2014-02-03','12:05:00',1.64),('15529','2014-02-03','13:15:00',1.01),('15529','2014-02-03','13:20:00',1.37),('15529','2014-01-31','12:10:00',1.2),('15529','2014-01-31','12:15:00',1.54),('15529','2014-01-31','12:20:00',1.56),('15529','2014-01-31','12:25:00',1.54),('15529','2014-01-31','12:30:00',1.28),('15529','2014-01-31','12:35:00',1.3),('15529','2014-01-31','12:40:00',1.2),('15529','2014-01-31','12:45:00',1.5),('15529','2014-01-31','12:55:00',1.41),('15529','2014-01-29','10:10:00',1.2),('15529','2014-01-29','10:15:00',1.53),('15529','2014-01-29','10:20:00',1.24),('15529','2014-01-29','10:25:00',1.5),('15529','2014-01-29','10:30:00',1.62),('15529','2014-01-29','10:35:00',1.73),('15529','2014-01-29','10:40:00',1.78),('15529','2014-01-29','10:45:00',1.51),('15529','2014-01-29','10:50:00',1.84),('15529','2014-01-29','10:55:00',1.64),('15529','2014-01-29','11:00:00',1.98),('15529','2014-01-29','11:05:00',1.8),('15529','2014-01-29','11:10:00',1.54),('15529','2014-01-29','11:15:00',2.02),('15529','2014-01-29','11:20:00',1.91),('15529','2014-01-29','11:25:00',1.94),('15529','2014-01-29','11:30:00',1.67),('15529','2014-01-29','11:35:00',1.83),('15529','2014-01-29','11:40:00',1.95),('15529','2014-01-29','11:45:00',1.97),('15529','2014-01-29','11:50:00',1.97),('15529','2014-01-29','11:55:00',1.87),('15529','2014-01-29','12:00:00',1.83),('15529','2014-01-29','12:05:00',2.01),('15529','2014-01-29','12:10:00',2.1),('15529','2014-01-29','12:15:00',2.12),('15529','2014-01-29','12:20:00',1.92),('15529','2014-01-29','12:25:00',1.68),('15529','2014-01-29','12:30:00',1.72),('15529','2014-01-29','12:35:00',1.74),('15529','2014-01-29','12:40:00',1.81),('15529','2014-01-29','12:45:00',1.97),('15529','2014-01-29','12:50:00',1.99),('15529','2014-01-29','12:55:00',1.99),('15529','2014-01-29','13:00:00',1.97),('15529','2014-01-29','13:05:00',1.98),('15529','2014-01-29','13:10:00',1.97),('15529','2014-01-29','13:15:00',1.93),('15529','2014-01-29','13:20:00',1.9),('15529','2014-01-29','13:25:00',1.81),('15529','2014-01-29','13:30:00',1.39),('15529','2014-01-29','13:35:00',1.44),('15529','2014-01-29','13:40:00',1.76),('15529','2014-01-29','13:45:00',1.96),('15529','2014-01-29','13:50:00',1.81),('15529','2014-01-29','13:55:00',1.6),('15529','2014-01-29','14:00:00',1.6),('15529','2014-01-29','14:05:00',1.41),('15529','2014-01-29','14:10:00',1.54),('15529','2014-01-29','14:15:00',1.29),('15529','2014-01-29','14:20:00',1.22),('15529','2014-01-29','14:25:00',1.31),('15529','2014-01-29','14:30:00',1.23),('15529','2014-01-29','14:35:00',1.24),('15529','2014-01-29','14:40:00',1.38),('15529','2014-01-29','14:45:00',1.43),('15529','2014-01-29','14:50:00',1.51),('15529','2014-01-29','14:55:00',1.45),('15529','2014-01-29','15:00:00',1.38),('15529','2014-01-29','15:05:00',1.34),('15529','2014-01-29','15:10:00',1.29),('15529','2014-01-29','15:15:00',1.26),('15529','2014-01-29','15:20:00',1.28),('15529','2014-01-29','15:25:00',1.2),('15529','2014-01-29','15:30:00',1.11),('15529','2014-01-29','15:35:00',1.09),('15529','2014-01-28','09:20:00',1.11),('15529','2014-01-28','09:35:00',1.06),('15529','2014-01-28','10:10:00',1.61),('15529','2014-01-28','10:15:00',1.37),('15529','2014-01-28','10:20:00',1.28),('15529','2014-01-28','10:25:00',2.21),('15529','2014-01-28','10:30:00',2.1),('15529','2014-01-28','10:35:00',1.45),('15529','2014-01-28','10:40:00',1.45),('15529','2014-01-28','10:45:00',1.18),('15529','2014-01-28','10:50:00',1.16),('15529','2014-01-28','10:55:00',1.04),('15529','2014-01-28','11:00:00',1.31),('15529','2014-01-28','11:05:00',1.35),('15529','2014-01-28','11:10:00',1.14),('15529','2014-01-28','11:15:00',1.18),('15529','2014-01-28','11:20:00',1.38),('15529','2014-01-28','11:25:00',1.45),('15529','2014-01-28','11:30:00',1.28),('15529','2014-01-28','12:45:00',1.49),('15529','2014-01-28','12:50:00',1.95),('15529','2014-01-28','12:55:00',1.84),('15529','2014-01-28','13:00:00',1.12),('15529','2014-01-28','13:30:00',1.23),('15529','2014-01-28','13:35:00',1.36),('15529','2014-01-28','13:40:00',2.19),('15529','2014-01-28','13:45:00',1.97),('15529','2014-01-28','13:50:00',1.83),('15529','2014-01-28','13:55:00',1.31),('15529','2014-01-28','15:15:00',1.11),('15529','2014-01-27','09:35:00',1),('15529','2014-01-27','09:45:00',1.24),('15529','2014-01-27','09:50:00',1.38),('15529','2014-01-27','09:55:00',1.42),('15529','2014-01-27','10:00:00',1.31),('15529','2014-01-27','10:05:00',1.34),('15529','2014-01-27','10:10:00',1.5),('15529','2014-01-27','10:15:00',1.64),('15529','2014-01-27','10:20:00',1.71),('15529','2014-01-27','10:25:00',1.72),('15529','2014-01-27','10:30:00',1.76),('15529','2014-01-27','10:35:00',1.79),('15529','2014-01-27','10:40:00',1.81),('15529','2014-01-27','10:45:00',1.83),('15529','2014-01-27','10:50:00',1.74),('15529','2014-01-27','10:55:00',2.05),('15529','2014-01-27','11:00:00',1.39),('15529','2014-01-27','11:05:00',1.84),('15529','2014-01-27','11:10:00',1.2),('15529','2014-01-27','11:15:00',1.1),('15529','2014-01-27','11:20:00',1.25),('15529','2014-01-27','11:30:00',2.15),('15529','2014-01-27','11:35:00',2.12),('15529','2014-01-27','11:40:00',1.24),('15529','2014-01-27','11:45:00',1.21),('15529','2014-01-27','11:50:00',1.65),('15529','2014-01-27','11:55:00',1.73),('15529','2014-01-27','12:00:00',1.49),('15529','2014-01-27','12:05:00',1.2),('15529','2014-01-27','12:10:00',1.52),('15529','2014-01-27','12:15:00',1.33),('15529','2014-01-27','12:35:00',1.03),('15529','2014-01-27','12:40:00',1.02),('15529','2014-01-27','12:45:00',2.1),('15529','2014-01-27','12:50:00',1.21),('15529','2014-01-27','12:55:00',2.28),('15529','2014-01-27','13:00:00',2.33),('15529','2014-01-27','13:05:00',1.72),('15529','2014-01-27','13:10:00',1.69),('15529','2014-01-27','13:15:00',2.02),('15529','2014-01-27','13:20:00',2.12),('15529','2014-01-27','13:25:00',1.87),('15529','2014-01-27','13:30:00',2.05),('15529','2014-01-27','13:35:00',2.04),('15529','2014-01-27','13:40:00',1.98),('15529','2014-01-27','13:45:00',1.93),('15529','2014-01-27','13:50:00',1.9),('15529','2014-01-27','13:55:00',1.86),('15529','2014-01-27','14:00:00',1.83),('15529','2014-01-27','14:05:00',1.82),('15529','2014-01-27','14:10:00',1.8),('15529','2014-01-27','14:15:00',1.79),('15529','2014-01-27','14:20:00',1.75),('15529','2014-01-27','14:25:00',1.61),('15529','2014-01-27','14:30:00',1.66),('15529','2014-01-27','14:35:00',1.62),('15529','2014-01-27','14:40:00',1.58),('15529','2014-01-27','14:45:00',1.56),('15529','2014-01-27','14:50:00',1.53),('15529','2014-01-27','14:55:00',1.48),('15529','2014-01-27','15:00:00',1.42),('15529','2014-01-27','15:05:00',1.38),('15529','2014-01-27','15:10:00',1.29),('15529','2014-01-27','15:15:00',1.28),('15529','2014-01-27','15:20:00',1.24),('15529','2014-01-27','15:25:00',1.19),('15529','2014-01-27','15:30:00',1.13),('15529','2014-01-27','15:35:00',1.08),('15529','2014-01-27','15:40:00',1.03),('15844','2014-05-05','08:20:00',1.02),('15844','2014-05-05','08:25:00',1.14),('15844','2014-05-05','08:30:00',1.24),('15844','2014-05-05','08:35:00',1.33),('15844','2014-05-05','08:40:00',1.43),('15844','2014-05-05','08:45:00',1.53),('15844','2014-05-05','08:50:00',1.6),('15844','2014-05-05','08:55:00',1.66),('15844','2014-05-05','09:00:00',1.72),('15844','2014-05-05','09:05:00',1.81),('15844','2014-05-05','09:10:00',1.95),('15844','2014-05-05','09:15:00',2.09),('15844','2014-05-05','09:20:00',2.2),('15844','2014-05-05','09:25:00',2.3),('15844','2014-05-05','09:30:00',2.41),('15844','2014-05-05','09:35:00',2.41),('15844','2014-05-05','09:40:00',2.56),('15844','2014-05-05','09:45:00',2.62),('15844','2014-05-05','09:50:00',2.79),('15844','2014-05-05','09:55:00',2.91),('15844','2014-05-05','10:00:00',2.96),('15844','2014-05-05','10:05:00',3.12),('15844','2014-05-05','10:10:00',3.27),('15844','2014-05-05','10:15:00',3.4),('15844','2014-05-05','10:20:00',3.5),('15844','2014-05-05','10:25:00',3.56),('15844','2014-05-05','10:30:00',3.51),('15844','2014-05-05','10:35:00',3.95),('15844','2014-05-05','10:40:00',3.6),('15844','2014-05-05','10:45:00',3.87),('15844','2014-05-05','10:50:00',4.12),('15844','2014-05-05','10:55:00',4.19),('15844','2014-05-05','11:00:00',4.24),('15844','2014-05-05','11:05:00',4.27),('15844','2014-05-05','11:10:00',3.98),('15844','2014-05-05','11:15:00',4.28),('15844','2014-05-05','11:20:00',4.43),('15844','2014-05-05','11:25:00',2.87),('15844','2014-05-05','11:30:00',2.73),('15844','2014-05-05','11:35:00',3.51),('15844','2014-05-05','11:40:00',4.49),('15844','2014-05-05','11:45:00',4.72),('15844','2014-05-05','11:50:00',3.56),('15844','2014-05-05','11:55:00',3.1),('15844','2014-05-05','12:00:00',2.58),('15844','2014-05-05','12:05:00',3.83),('15844','2014-05-05','12:10:00',4.19),('15844','2014-05-05','12:15:00',4.46),('15844','2014-05-05','12:20:00',3.47),('15844','2014-05-05','12:25:00',3.79),('15844','2014-05-05','12:30:00',2.62),('15844','2014-05-05','12:35:00',1.56),('15844','2014-05-05','12:40:00',2.64),('15844','2014-05-05','12:45:00',2.96),('15844','2014-05-05','12:50:00',4.41),('15844','2014-05-05','12:55:00',3.96),('15844','2014-05-05','13:00:00',4.41),('15844','2014-05-05','13:05:00',4.24),('15844','2014-05-05','13:10:00',4.19),('15844','2014-05-05','13:15:00',4.2),('15844','2014-05-05','13:20:00',4.22),('15844','2014-05-05','13:25:00',4.21),('15844','2014-05-05','13:30:00',4.28),('15844','2014-05-05','13:35:00',3.33),('15844','2014-05-05','13:50:00',1.11),('15844','2014-05-05','13:55:00',1.78),('15844','2014-05-05','14:00:00',3.05),('15844','2014-05-05','14:05:00',1.52),('15844','2014-05-05','14:10:00',2.58),('15844','2014-05-05','14:15:00',3.88),('15844','2014-05-05','14:20:00',3.54),('15844','2014-05-05','14:25:00',3.54),('15844','2014-05-05','14:30:00',3.43),('15844','2014-05-05','14:35:00',3.39),('15844','2014-05-05','14:40:00',3.4),('15844','2014-05-05','14:45:00',3.37),('15844','2014-05-05','14:50:00',3.26),('15844','2014-05-05','14:55:00',3.09),('15844','2014-05-05','15:00:00',2.86),('15844','2014-05-05','15:05:00',2.64),('15844','2014-05-05','15:10:00',2.55),('15844','2014-05-05','15:15:00',2.5),('15844','2014-05-05','15:20:00',2.41),('15844','2014-05-05','15:25:00',2.33),('15844','2014-05-05','15:30:00',1.94),('15844','2014-05-05','15:35:00',2.03),('15844','2014-05-05','15:40:00',2.05),('15844','2014-05-05','15:45:00',2.03),('15844','2014-05-05','15:50:00',1.84),('15844','2014-05-05','15:55:00',1.81),('15844','2014-05-05','16:00:00',1.73),('15844','2014-05-05','16:05:00',1.68),('15844','2014-05-05','16:10:00',1.67),('15844','2014-05-05','16:15:00',1.56),('15844','2014-05-05','16:20:00',1.44),('15844','2014-05-05','16:25:00',1.29),('15844','2014-05-05','16:30:00',1.18),('15844','2014-05-05','16:35:00',1.06),('15844','2014-04-26','09:10:00',1.05),('15844','2014-04-26','10:00:00',1.23),('15844','2014-04-26','10:05:00',1.56),('15844','2014-04-26','10:10:00',1.36),('15844','2014-04-26','10:15:00',1.2),('15844','2014-04-26','10:20:00',1.36),('15844','2014-04-26','10:25:00',1.52),('15844','2014-04-26','10:30:00',1.43),('15844','2014-04-26','10:35:00',1.91),('15844','2014-04-26','10:40:00',1.59),('15844','2014-04-26','10:45:00',1.47),('15844','2014-04-26','10:50:00',2),('15844','2014-04-26','10:55:00',3.43),('15844','2014-04-26','11:00:00',3.18),('15844','2014-04-26','11:05:00',3.83),('15844','2014-04-26','11:10:00',4.09),('15844','2014-04-26','11:15:00',3.62),('15844','2014-04-26','11:20:00',3.74),('15844','2014-04-26','11:25:00',3.67),('15844','2014-04-26','11:30:00',2.8),('15844','2014-04-26','11:35:00',3.05),('15844','2014-04-26','11:40:00',3.14),('15844','2014-04-26','11:45:00',3.37),('15844','2014-04-26','11:50:00',3.06),('15844','2014-04-26','11:55:00',3.29),('15844','2014-04-26','12:00:00',3.19),('15844','2014-04-26','12:05:00',2.28),('15844','2014-04-26','12:10:00',2.3),('15844','2014-04-26','12:15:00',2.9),('15844','2014-04-26','12:20:00',2.28),('15844','2014-04-26','12:25:00',2.2),('15844','2014-04-26','12:30:00',2.45),('15844','2014-04-26','12:35:00',2.33),('15844','2014-04-26','12:40:00',1.28),('15844','2014-04-26','12:45:00',1.75),('15844','2014-04-26','12:50:00',1.87),('15844','2014-04-26','12:55:00',3.23),('15844','2014-04-26','13:00:00',3.76),('15844','2014-04-26','13:05:00',2.49),('15844','2014-04-26','13:10:00',3.44),('15844','2014-04-26','13:15:00',4.46),('15844','2014-04-26','13:20:00',3.77),('15844','2014-04-26','13:25:00',2.19),('15844','2014-04-26','13:30:00',1.57),('15844','2014-04-26','13:35:00',1.75),('15844','2014-04-26','13:40:00',2.08),('15844','2014-04-26','13:45:00',1.92),('15844','2014-04-26','13:50:00',1.29),('15844','2014-04-26','13:55:00',1.02),('15844','2014-04-26','14:00:00',1.09),('15844','2014-04-26','14:05:00',2.21),('15844','2014-01-26','09:05:00',1.17),('15844','2014-01-26','09:25:00',1.19),('15844','2014-01-26','09:30:00',1.12),('15844','2014-01-26','09:50:00',1.09),('15844','2014-01-26','10:10:00',1.26),('15844','2014-01-26','10:15:00',1.28),('15844','2014-01-26','11:25:00',1.22),('15844','2014-01-26','12:15:00',1.06),('15844','2014-01-26','12:20:00',1.13),('15844','2014-01-26','12:25:00',1.8),('15844','2014-01-26','12:30:00',1.42),('15844','2014-01-26','13:05:00',1.02),('15844','2014-01-26','13:15:00',1.06),('15844','2014-01-26','13:20:00',1.03),('15844','2014-01-25','09:55:00',1.54),('15844','2014-01-25','10:00:00',1.73),('15844','2014-01-25','10:05:00',2.06),('15844','2014-01-25','10:10:00',2.42),('15844','2014-01-25','10:15:00',2.34),('15844','2014-01-25','10:20:00',2.06),('15844','2014-01-25','10:25:00',1.97),('15844','2014-01-25','10:30:00',1.92),('15844','2014-01-25','10:35:00',2.14),('15844','2014-01-25','10:40:00',1.44),('15844','2014-01-25','10:45:00',1.65),('15844','2014-01-25','10:50:00',2.51),('15844','2014-01-25','10:55:00',2.68),('15844','2014-01-25','11:00:00',2.35),('15844','2014-01-25','11:05:00',2.21),('15844','2014-01-25','11:10:00',2.35),('15844','2014-01-25','11:15:00',2.65),('15844','2014-01-25','11:20:00',1.76),('15844','2014-01-25','11:25:00',1.17),('15844','2014-01-25','11:30:00',1.17),('15844','2014-01-25','11:35:00',1.34),('15844','2014-01-25','11:40:00',1.81),('15844','2014-01-25','11:45:00',1.48),('15844','2014-01-25','11:50:00',1.31),('15844','2014-01-25','11:55:00',1.21),('15844','2014-01-25','12:00:00',1.38),('15844','2014-01-25','12:05:00',1.43),('15844','2014-01-25','12:10:00',1.56),('15844','2014-01-25','12:15:00',1.48),('15844','2014-01-25','12:20:00',1.48),('15844','2014-01-25','12:25:00',1.39),('15844','2014-01-25','12:30:00',1.25),('15844','2014-01-25','12:35:00',1.31),('15844','2014-01-25','12:40:00',1.41),('15844','2014-01-25','12:45:00',1.45),('15844','2014-01-25','12:50:00',1.67),('15844','2014-01-25','12:55:00',1.76),('15844','2014-01-25','13:00:00',1.68),('15844','2014-01-25','13:05:00',1.7),('15844','2014-01-25','13:10:00',1.68),('15844','2014-01-25','13:15:00',1.5),('15844','2014-01-25','13:20:00',1.62),('15844','2014-01-25','13:25:00',1.56),('15844','2014-01-25','13:30:00',1.44),('15844','2014-01-25','13:35:00',1.2),('15844','2014-01-25','13:40:00',1.26),('15844','2014-01-25','13:50:00',1.02),('15844','2014-01-24','10:10:00',1.5),('15844','2014-01-24','10:20:00',1.83),('15844','2014-01-24','10:25:00',1.68),('15844','2014-01-24','10:30:00',2.09),('15844','2014-01-24','10:35:00',2.79),('15844','2014-01-24','10:40:00',2.53),('15844','2014-01-24','10:45:00',1.16),('15844','2014-01-24','10:50:00',1.4),('15844','2014-01-24','10:55:00',1.04),('15844','2014-01-24','11:25:00',1.04),('15844','2014-01-24','11:30:00',1.3),('15844','2014-01-24','11:40:00',2.07),('15844','2014-01-24','11:45:00',2.3),('15844','2014-01-24','11:50:00',2.66),('15844','2014-01-24','11:55:00',1.91),('15844','2014-01-24','12:00:00',2.65),('15844','2014-01-24','12:05:00',2.1),('15844','2014-01-24','12:10:00',1.39),('15844','2014-01-24','12:15:00',1.21),('15844','2014-01-24','12:20:00',1.25),('15844','2014-01-24','12:25:00',1.3),('15844','2014-01-24','12:30:00',1.21),('15844','2014-01-24','12:35:00',1.46),('15844','2014-01-24','12:40:00',2.04),('15844','2014-01-24','12:45:00',1.18),('15844','2014-01-24','12:50:00',1.58),('15844','2014-01-24','12:55:00',1.23),('15844','2014-01-24','13:00:00',1.21),('15844','2014-01-24','13:15:00',1.21),('15844','2014-01-24','13:40:00',1.44),('15844','2014-01-24','14:05:00',1.24),('15844','2014-01-23','12:25:00',1.06),('15844','2014-01-23','12:30:00',1.15),('15844','2014-01-23','12:35:00',1.03),('15844','2014-01-21','09:55:00',1.37),('15844','2014-01-21','10:55:00',1.03),('15844','2014-01-21','11:40:00',1.25),('15844','2014-01-21','11:45:00',1.15),('15844','2014-01-21','11:55:00',1.03),('15844','2014-01-21','12:00:00',1.48),('15844','2014-01-21','12:05:00',1.26),('15844','2014-01-21','12:10:00',1.41),('15844','2014-01-21','12:15:00',1.63),('15844','2014-01-21','12:20:00',1.49),('15844','2014-01-21','12:25:00',1.53),('15844','2014-01-21','12:30:00',1.36),('15844','2014-01-20','11:20:00',1.2),('15844','2014-01-20','11:25:00',1.61),('15844','2014-01-20','11:30:00',1.7),('15844','2014-01-20','11:35:00',1.61),('15844','2014-01-20','11:55:00',1.13),('15844','2014-01-20','12:00:00',1.48),('15844','2014-01-20','12:05:00',1.57),('15844','2014-01-20','12:10:00',1.41),('15844','2014-01-20','12:15:00',1.04),('15844','2014-01-20','12:30:00',1.4),('15844','2014-01-20','12:35:00',1.21),('15844','2014-01-20','12:40:00',1.4),('15844','2014-01-20','12:45:00',1.29),('15844','2014-01-20','12:55:00',1.89),('15844','2014-01-20','14:10:00',1.09),('15844','2014-01-19','14:20:00',1.06),('15844','2014-01-19','14:30:00',1.01),('15844','2014-01-18','09:55:00',1.07),('15844','2014-01-18','10:00:00',1.65),('15844','2014-01-18','10:05:00',1.22),('15844','2014-01-18','10:10:00',1.85),('15844','2014-01-18','10:15:00',2.22),('15844','2014-01-18','10:20:00',1.77),('15844','2014-01-18','10:25:00',1.78),('15844','2014-01-18','10:30:00',1.61),('15844','2014-01-18','10:35:00',1.21),('15844','2014-01-18','10:40:00',1.3),('15844','2014-01-18','10:45:00',1.08),('15844','2014-01-18','10:50:00',1),('15844','2014-01-18','11:00:00',1.03),('15844','2014-01-18','11:05:00',2.15),('15844','2014-01-18','11:10:00',2.31),('15844','2014-01-18','11:15:00',2.33),('15844','2014-01-18','11:20:00',2.2),('15844','2014-01-18','11:25:00',2.16),('15844','2014-01-18','11:30:00',2.14),('15844','2014-01-18','11:35:00',2.19),('15844','2014-01-18','11:40:00',2.02),('15844','2014-01-18','11:45:00',2.03),('15844','2014-01-18','11:50:00',1.25),('15844','2014-01-18','11:55:00',2.33),('15844','2014-01-18','12:00:00',2),('15844','2014-01-18','12:05:00',1.56),('15844','2014-01-18','12:10:00',2.02),('15844','2014-01-18','12:15:00',2.01),('15844','2014-01-18','12:20:00',1.99),('15844','2014-01-18','12:25:00',1.96),('15844','2014-01-18','12:30:00',1.93),('15844','2014-01-18','12:35:00',1.89),('15844','2014-01-18','12:40:00',1.89),('15844','2014-01-18','12:45:00',1.79),('15844','2014-01-18','12:50:00',1.49),('15844','2014-01-18','12:55:00',1.48),('15844','2014-01-18','13:00:00',1.53),('15844','2014-01-18','13:05:00',1.12),('15844','2014-01-18','13:10:00',1.44),('15844','2014-01-18','13:15:00',1.72),('15844','2014-01-18','13:20:00',1.39),('15844','2014-01-18','13:30:00',1.28),('15844','2014-01-18','13:35:00',1.33),('15844','2014-01-18','13:40:00',1.13),('15844','2014-01-18','13:45:00',1.19),('15844','2014-01-18','13:50:00',1.06),('15844','2014-01-18','14:00:00',1),('15844','2014-01-17','09:10:00',1.04),('15844','2014-01-17','09:20:00',1.15),('15844','2014-01-17','09:30:00',1.27),('15844','2014-04-25','08:35:00',1),('15844','2014-04-25','08:40:00',1.05),('15844','2014-04-25','08:45:00',1.22),('15844','2014-04-25','08:50:00',1.33),('15844','2014-04-25','08:55:00',1.09),('15844','2014-04-25','09:00:00',1.29),('15844','2014-04-25','09:05:00',1.25),('15844','2014-04-25','09:10:00',1.39),('15844','2014-04-25','09:15:00',1.11),('15844','2014-04-25','09:20:00',1.08),('15844','2014-04-25','09:25:00',2.05),('15844','2014-04-25','09:30:00',1.4),('15844','2014-04-25','09:35:00',1.29),('15844','2014-04-25','09:40:00',1.27),('15844','2014-04-25','09:45:00',1.18),('15844','2014-04-25','09:50:00',1.15),('15844','2014-04-25','09:55:00',1.68),('15844','2014-04-25','10:00:00',1.29),('15844','2014-04-25','10:05:00',1.27),('15844','2014-04-25','10:10:00',1.22),('15844','2014-04-25','10:15:00',1.17),('15844','2014-04-25','10:40:00',2.09),('15844','2014-04-25','10:45:00',2.35),('15844','2014-04-25','11:00:00',1.89),('15844','2014-04-25','11:05:00',2.63),('15844','2014-04-25','11:10:00',2.74),('15844','2014-04-25','11:15:00',1.84),('15844','2014-04-25','11:20:00',3.56),('15844','2014-04-25','11:25:00',4.68),('15844','2014-04-25','11:30:00',1.56),('15844','2014-04-25','11:35:00',1.09),('15844','2014-04-25','11:45:00',1.37),('15844','2014-04-25','11:50:00',1.79),('15844','2014-04-25','11:55:00',4.38),('15844','2014-04-25','12:00:00',4.52),('15844','2014-04-25','12:05:00',4.36),('15844','2014-04-25','12:10:00',4.37),('15844','2014-04-25','12:15:00',3.29),('15844','2014-04-25','12:20:00',4.02),('15844','2014-04-25','12:25:00',1.91),('15844','2014-04-25','12:30:00',3.02),('15844','2014-04-25','12:35:00',3.31),('15844','2014-04-25','12:40:00',4.15),('15844','2014-04-25','12:45:00',2.03),('15844','2014-04-25','12:50:00',2.18),('15844','2014-04-25','12:55:00',1.42),('15844','2014-04-25','13:00:00',2.86),('15844','2014-04-25','13:05:00',1.4),('15844','2014-04-25','13:10:00',1.33),('15844','2014-04-25','13:15:00',1.82),('15844','2014-04-25','13:20:00',3.65),('15844','2014-04-25','13:25:00',2.11),('15844','2014-04-25','13:30:00',3.59),('15844','2014-04-25','13:35:00',4.34),('15844','2014-04-25','13:40:00',4.23),('15844','2014-04-25','13:45:00',2.82),('15844','2014-04-25','13:50:00',2.78),('15844','2014-04-25','13:55:00',4.03),('15844','2014-04-25','14:00:00',3.85),('15844','2014-04-25','14:05:00',3.51),('15844','2014-04-25','14:10:00',3.43),('15844','2014-04-25','14:15:00',3.32),('15844','2014-04-25','14:20:00',3.25),('15844','2014-04-25','14:25:00',3.19),('15844','2014-04-25','14:30:00',3.07),('15844','2014-04-25','14:35:00',2.95),('15844','2014-04-25','14:40:00',2.87),('15844','2014-04-25','14:45:00',2.8),('15844','2014-04-25','14:50:00',2.71),('15844','2014-04-25','14:55:00',2.61),('15844','2014-04-25','15:00:00',2.48),('15844','2014-04-25','15:05:00',2.39),('15844','2014-04-25','15:10:00',2.34),('15844','2014-04-25','15:15:00',2.25),('15844','2014-04-25','15:20:00',2.16),('15844','2014-04-25','15:25:00',2.1),('15844','2014-04-25','15:30:00',2.01),('15844','2014-04-25','15:35:00',1.88),('15844','2014-04-25','15:40:00',1.73),('15844','2014-04-25','15:45:00',1.6),('15844','2014-04-25','15:50:00',1.54),('15844','2014-04-25','15:55:00',1.45),('15844','2014-04-25','16:00:00',1.32),('15844','2014-04-25','16:05:00',1.27),('15844','2014-04-25','16:10:00',1.14),('15844','2014-04-25','16:15:00',1.05),('15844','2014-04-25','16:20:00',1.02),('15844','2014-04-25','16:25:00',1.02),('15844','2014-01-16','09:15:00',1.18),('15844','2014-01-16','09:20:00',1.39),('15844','2014-01-16','09:25:00',1.46),('15844','2014-01-16','09:30:00',1.47),('15844','2014-01-16','09:35:00',1.54),('15844','2014-01-16','09:40:00',1.48),('15844','2014-01-16','09:45:00',1.16),('15844','2014-01-16','10:10:00',1.07),('15844','2014-01-16','10:15:00',1.14),('15844','2014-01-16','10:20:00',1.27),('15844','2014-01-16','10:25:00',1.71),('15844','2014-01-16','10:30:00',2.21),('15844','2014-01-16','10:35:00',2.03),('15844','2014-01-16','10:40:00',1.37),('15844','2014-01-16','10:45:00',1.58),('15844','2014-01-16','10:50:00',1.69),('15844','2014-01-16','10:55:00',1.64),('15844','2014-01-16','11:00:00',1.71),('15844','2014-01-16','11:05:00',1.79),('15844','2014-01-16','11:10:00',1.66),('15844','2014-01-16','11:15:00',1.46),('15844','2014-01-16','11:20:00',1.49),('15844','2014-01-16','11:25:00',1.47),('15844','2014-01-16','11:30:00',1.42),('15844','2014-01-16','11:35:00',1.46),('15844','2014-01-16','11:40:00',1.39),('15844','2014-01-16','11:45:00',1.39),('15844','2014-01-16','11:50:00',1.56),('15844','2014-01-16','11:55:00',1.54),('15844','2014-01-16','12:00:00',1.43),('15844','2014-01-16','12:05:00',1.43),('15844','2014-01-16','12:10:00',1.28),('15844','2014-01-16','12:15:00',1.2),('15844','2014-01-16','12:20:00',1.12),('15844','2014-01-16','12:25:00',1.14),('15844','2014-01-16','12:30:00',1.32),('15844','2014-01-16','12:35:00',1.43),('15844','2014-01-16','12:40:00',1.39),('15844','2014-01-16','12:45:00',1.44),('15844','2014-01-16','12:50:00',1.49),('15844','2014-01-16','12:55:00',1.53),('15844','2014-01-16','13:00:00',1.57),('15844','2014-01-16','13:05:00',1.55),('15844','2014-01-16','13:10:00',1.49),('15844','2014-01-16','13:15:00',1.42),('15844','2014-01-16','13:20:00',1.39),('15844','2014-01-16','13:25:00',1.29),('15844','2014-01-16','13:40:00',1.07),('15844','2014-01-16','13:45:00',1.03),('15844','2014-01-16','13:50:00',1.04),('15844','2014-01-15','10:00:00',1.06),('15844','2014-01-15','10:05:00',1.27),('15844','2014-01-15','10:10:00',1.51),('15844','2014-01-15','10:15:00',1.79),('15844','2014-01-15','10:20:00',1.71),('15844','2014-01-15','10:25:00',1.17),('15844','2014-01-15','10:30:00',1.96),('15844','2014-01-15','10:35:00',1.69),('15844','2014-01-15','10:40:00',1.68),('15844','2014-01-15','10:45:00',2.1),('15844','2014-01-15','10:50:00',1.74),('15844','2014-01-15','10:55:00',1.96),('15844','2014-01-15','11:00:00',2.26),('15844','2014-01-15','11:05:00',2.23),('15844','2014-01-15','11:10:00',2.12),('15844','2014-01-15','11:15:00',2.31),('15844','2014-01-15','11:20:00',2.28),('15844','2014-01-15','11:25:00',2.36),('15844','2014-01-15','11:30:00',1.5),('15844','2014-01-15','11:35:00',1.68),('15844','2014-01-15','11:40:00',1.24),('15844','2014-01-15','11:45:00',1.28),('15844','2014-01-15','11:50:00',1.22),('15844','2014-01-15','11:55:00',1.19),('15844','2014-01-15','12:00:00',1.23),('15844','2014-01-15','12:05:00',1.29),('15844','2014-01-15','12:10:00',1.23),('15844','2014-01-15','12:15:00',1.27),('15844','2014-01-15','12:20:00',1.11),('15844','2014-01-15','12:25:00',1.15),('15844','2014-01-15','12:30:00',1.18),('15844','2014-01-15','12:35:00',1.61),('15844','2014-01-15','12:40:00',1.64),('15844','2014-01-15','12:45:00',1.46),('15844','2014-01-15','12:50:00',1.67),('15844','2014-01-15','12:55:00',1.67),('15844','2014-01-15','13:00:00',1.77),('15844','2014-01-15','13:05:00',1.75),('15844','2014-01-15','13:10:00',1.67),('15844','2014-01-15','13:15:00',1.57),('15844','2014-01-15','13:20:00',1.46),('15844','2014-01-15','13:25:00',1.33),('15844','2014-01-15','13:30:00',1.24),('15844','2014-01-15','13:35:00',1.21),('15844','2014-01-15','13:40:00',1.13),('15844','2014-01-15','13:45:00',1.14),('15844','2014-01-15','13:50:00',1.13),('15844','2014-01-15','14:05:00',1.05),('15844','2014-01-15','14:10:00',1.06),('15844','2014-01-14','10:25:00',1.2),('15844','2014-01-14','10:30:00',1.95),('15844','2014-01-14','10:35:00',1.6),('15844','2014-01-13','09:05:00',1.07),('15844','2014-01-13','09:10:00',1.12),('15844','2014-01-13','09:15:00',1.13),('15844','2014-01-13','09:20:00',1.15),('15844','2014-01-13','09:25:00',1.22),('15844','2014-01-13','09:30:00',1.27),('15844','2014-01-13','09:35:00',1.3),('15844','2014-01-13','09:40:00',1.33),('15844','2014-01-13','09:45:00',1.38),('15844','2014-01-13','09:50:00',1.42),('15844','2014-01-13','09:55:00',1.46),('15844','2014-01-13','10:00:00',1.49),('15844','2014-01-13','10:05:00',1.53),('15844','2014-01-13','10:10:00',1.56),('15844','2014-01-13','10:15:00',1.59),('15844','2014-01-13','10:20:00',1.64),('15844','2014-01-13','10:25:00',1.66),('15844','2014-01-13','10:30:00',1.7),('15844','2014-01-13','10:35:00',1.73),('15844','2014-01-13','10:40:00',1.76),('15844','2014-01-13','10:45:00',1.77),('15844','2014-01-13','10:50:00',1.8),('15844','2014-01-13','10:55:00',1.82),('15844','2014-01-13','11:00:00',1.85),('15844','2014-01-13','11:05:00',1.89),('15844','2014-01-13','11:10:00',1.91),('15844','2014-01-13','11:15:00',1.92),('15844','2014-01-13','11:20:00',1.89),('15844','2014-01-13','11:25:00',1.87),('15844','2014-01-13','11:30:00',1.89),('15844','2014-01-13','11:35:00',1.89),('15844','2014-01-13','11:40:00',1.88),('15844','2014-01-13','11:45:00',1.88),('15844','2014-01-13','11:50:00',1.83),('15844','2014-01-13','11:55:00',1.76),('15844','2014-01-13','12:00:00',1.78),('15844','2014-01-13','12:05:00',1.74),('15844','2014-01-13','12:10:00',1.77),('15844','2014-01-13','12:15:00',1.7),('15844','2014-01-13','12:20:00',1.69),('15844','2014-01-13','12:25:00',1.67),('15844','2014-01-13','12:30:00',1.64),('15844','2014-01-13','12:35:00',1.6),('15844','2014-01-13','12:40:00',1.54),('15844','2014-01-13','12:45:00',1.45),('15844','2014-01-13','12:50:00',1.43),('15844','2014-01-13','12:55:00',1.21),('15844','2014-01-13','13:00:00',1.25),('15844','2014-01-13','13:05:00',1.29),('15844','2014-01-13','13:10:00',1.28),('15844','2014-01-13','13:15:00',1.23),('15844','2014-01-13','13:20:00',1.17),('15844','2014-01-13','13:25:00',1.12),('15844','2014-01-13','13:30:00',1.1),('15844','2014-01-13','13:35:00',1.04),('15844','2014-01-12','10:35:00',1.03),('15844','2014-01-12','10:40:00',1.1),('15844','2014-01-12','10:45:00',1.06),('15844','2014-01-12','10:50:00',1.22),('15844','2014-01-12','10:55:00',1.31),('15844','2014-01-12','11:00:00',1.18),('15844','2014-01-12','11:05:00',1.6),('15844','2014-01-12','11:10:00',1.81),('15844','2014-01-12','11:15:00',1.48),('15844','2014-01-12','11:20:00',1.32),('15844','2014-01-12','11:25:00',1.33),('15844','2014-01-12','11:30:00',1.17),('15844','2014-01-12','11:35:00',1.16),('15844','2014-01-12','11:40:00',1.26),('15844','2014-01-12','11:45:00',1.42),('15844','2014-01-12','11:50:00',1.19),('15844','2014-01-12','11:55:00',1.25),('15844','2014-01-12','12:00:00',1.33),('15844','2014-01-12','12:05:00',1.08),('15844','2014-01-12','12:10:00',1.02),('15844','2014-01-11','09:50:00',1.01),('15844','2014-01-11','09:55:00',1.32),('15844','2014-01-11','10:00:00',1.05),('15844','2014-01-11','10:05:00',1.03),('15844','2014-01-11','10:10:00',1.18),('15844','2014-01-11','10:15:00',1.13),('15844','2014-01-11','10:20:00',1.4),('15844','2014-01-11','10:25:00',1.3),('15844','2014-01-11','10:30:00',1.41),('15844','2014-01-11','10:35:00',1.59),('15844','2014-01-11','10:40:00',1.82),('15844','2014-01-11','10:45:00',1.87),('15844','2014-01-11','10:50:00',1.86),('15844','2014-01-11','10:55:00',1.78),('15844','2014-01-11','11:00:00',1.67),('15844','2014-01-11','11:05:00',1.69),('15844','2014-01-11','11:10:00',1.72),('15844','2014-01-11','11:15:00',1.5),('15844','2014-01-11','11:20:00',1.35),('15844','2014-01-11','11:25:00',1.29),('15844','2014-01-11','11:30:00',1.38),('15844','2014-01-11','11:35:00',1.26),('15844','2014-01-11','11:40:00',1.3),('15844','2014-01-11','11:45:00',1.38),('15844','2014-01-11','11:50:00',1.43),('15844','2014-01-11','11:55:00',1.38),('15844','2014-01-11','12:00:00',1.41),('15844','2014-01-11','12:05:00',1.31),('15844','2014-01-11','12:10:00',1.43),('15844','2014-01-11','12:15:00',1.47),('15844','2014-01-11','12:20:00',1.09),('15844','2014-01-11','12:30:00',1.21),('15844','2014-01-11','12:35:00',1.09),('15844','2014-01-11','12:45:00',1.1),('15844','2014-01-11','12:50:00',1.32),('15844','2014-01-11','12:55:00',1.37),('15844','2014-01-11','13:00:00',1.33),('15844','2014-01-11','13:05:00',1.12),('15844','2014-01-11','13:15:00',1.18),('15844','2014-01-09','09:50:00',1.15),('15844','2014-01-09','10:35:00',1.03),('15844','2014-01-09','10:40:00',1.09),('15844','2014-01-09','10:45:00',1),('15844','2014-01-09','12:00:00',1.13),('15844','2014-01-09','12:05:00',1.08),('15844','2014-01-09','12:10:00',1.08),('15844','2014-01-09','12:15:00',1.29),('15844','2014-01-09','12:25:00',1.05),('15844','2014-01-09','12:30:00',1.23),('15844','2014-01-09','12:35:00',1.45),('15844','2014-01-09','12:40:00',1.4),('15844','2014-01-09','12:45:00',1.25),('15844','2014-01-09','12:50:00',1.18),('15844','2014-01-09','12:55:00',1.07),('15844','2014-01-09','13:00:00',1.27),('15844','2014-01-09','13:05:00',1.14),('15844','2014-01-09','13:10:00',1.06),('15844','2014-01-08','09:15:00',1.04),('15844','2014-01-08','09:20:00',1.14),('15844','2014-01-08','09:25:00',1.2),('15844','2014-01-08','09:30:00',1.16),('15844','2014-01-08','09:35:00',1.25),('15844','2014-01-08','09:40:00',1.3),('15844','2014-01-08','09:45:00',1.34),('15844','2014-01-08','09:50:00',1.32),('15844','2014-01-08','09:55:00',1.36),('15844','2014-01-08','10:00:00',1.24),('15844','2014-01-08','10:05:00',1.38),('15844','2014-01-08','10:10:00',1.47),('15844','2014-01-08','10:15:00',1.58),('15844','2014-01-08','10:20:00',1.62),('15844','2014-01-08','10:25:00',1.65),('15844','2014-01-08','10:30:00',1.66),('15844','2014-01-08','10:35:00',1.64),('15844','2014-01-08','10:40:00',1.66),('15844','2014-01-08','10:45:00',1.75),('15844','2014-01-08','10:50:00',1.79),('15844','2014-01-08','10:55:00',1.79),('15844','2014-01-08','11:00:00',1.81),('15844','2014-01-08','11:05:00',1.85),('15844','2014-01-08','11:10:00',1.86),('15844','2014-01-08','11:15:00',1.85),('15844','2014-01-08','11:20:00',1.81),('15844','2014-01-08','11:25:00',1.75),('15844','2014-01-08','11:30:00',1.85),('15844','2014-01-08','11:35:00',1.88),('15844','2014-01-08','11:40:00',1.83),('15844','2014-01-08','11:45:00',1.82),('15844','2014-01-08','11:50:00',1.82),('15844','2014-01-08','11:55:00',1.75),('15844','2014-01-08','12:00:00',1.69),('15844','2014-01-08','12:05:00',1.66),('15844','2014-01-08','12:10:00',1.69),('15844','2014-01-08','12:15:00',1.66),('15844','2014-01-08','12:20:00',1.7),('15844','2014-01-08','12:25:00',1.66),('15844','2014-01-08','12:30:00',1.59),('15844','2014-01-08','12:35:00',1.55),('15844','2014-01-08','12:40:00',1.44),('15844','2014-01-08','12:45:00',1.41),('15844','2014-01-08','12:50:00',1.41),('15844','2014-01-08','12:55:00',1.38),('15844','2014-01-08','13:00:00',1.35),('15844','2014-01-08','13:05:00',1.24),('15844','2014-01-08','13:10:00',1.25),('15844','2014-01-08','13:15:00',1.17),('15844','2014-01-08','13:20:00',1.09),('15844','2014-01-08','13:25:00',1.09),('15844','2014-01-08','13:30:00',1.04),('15844','2014-01-07','09:10:00',1.06),('15844','2014-01-07','09:15:00',1.14),('15844','2014-01-07','09:20:00',1.22),('15844','2014-01-07','09:25:00',1.28),('15844','2014-01-07','09:30:00',1.34),('15844','2014-01-07','09:35:00',1.39),('15844','2014-01-07','09:40:00',1.42),('15844','2014-01-07','09:45:00',1.47),('15844','2014-01-07','09:50:00',1.51),('15844','2014-01-07','09:55:00',1.55),('15844','2014-01-07','10:00:00',1.58),('15844','2014-01-07','10:05:00',1.61),('15844','2014-01-07','10:10:00',1.65),('15844','2014-01-07','10:15:00',1.69),('15844','2014-01-07','10:20:00',1.7),('15844','2014-01-07','10:25:00',1.73),('15844','2014-01-07','10:30:00',1.73),('15844','2014-01-07','10:35:00',1.78),('15844','2014-01-07','10:40:00',1.83),('15844','2014-01-07','10:45:00',1.86),('15844','2014-01-07','10:50:00',1.89),('15844','2014-01-07','10:55:00',1.9),('15844','2014-01-07','11:00:00',1.91),('15844','2014-01-07','11:05:00',1.95),('15844','2014-01-07','11:10:00',1.96),('15844','2014-01-07','11:15:00',1.95),('15844','2014-01-07','11:20:00',1.94),('15844','2014-01-07','11:25:00',1.93),('15844','2014-01-07','11:30:00',1.93),('15844','2014-01-07','11:35:00',1.9),('15844','2014-01-07','11:40:00',1.86),('15844','2014-01-07','11:45:00',1.83),('15844','2014-01-07','11:50:00',1.83),('15844','2014-01-07','11:55:00',1.83),('15844','2014-01-07','12:00:00',1.79),('15844','2014-01-07','12:05:00',1.75),('15844','2014-01-07','12:10:00',1.75),('15844','2014-01-07','12:15:00',1.73),('15844','2014-01-07','12:20:00',1.65),('15844','2014-01-07','12:25:00',1.63),('15844','2014-01-07','12:30:00',1.59),('15844','2014-01-07','12:35:00',1.6),('15844','2014-01-07','12:40:00',1.57),('15844','2014-01-07','12:45:00',1.51),('15844','2014-01-07','12:50:00',1.51),('15844','2014-01-07','12:55:00',1.45),('15844','2014-01-07','13:00:00',1.41),('15844','2014-01-07','13:05:00',1.33),('15844','2014-01-07','13:10:00',1.29),('15844','2014-01-07','13:15:00',1.15),('15844','2014-01-07','13:20:00',1.09),('15844','2014-01-07','13:25:00',1.06),('15844','2014-04-24','08:30:00',1.1),('15844','2014-04-24','08:35:00',1.19),('15844','2014-04-24','08:40:00',1.26),('15844','2014-04-24','08:45:00',1.32),('15844','2014-04-24','08:50:00',1.41),('15844','2014-04-24','08:55:00',1.47),('15844','2014-04-24','09:00:00',1.55),('15844','2014-04-24','09:05:00',1.58),('15844','2014-04-24','09:10:00',1.69),('15844','2014-04-24','09:15:00',1.81),('15844','2014-04-24','09:20:00',1.97),('15844','2014-04-24','09:25:00',2.09),('15844','2014-04-24','09:30:00',2.19),('15844','2014-04-24','09:35:00',2.29),('15844','2014-04-24','09:40:00',2.33),('15844','2014-04-24','09:45:00',2.37),('15844','2014-04-24','09:50:00',2.44),('15844','2014-04-24','09:55:00',2.63),('15844','2014-04-24','10:00:00',2.73),('15844','2014-04-24','10:05:00',2.8),('15844','2014-04-24','10:10:00',2.89),('15844','2014-04-24','10:15:00',3.01),('15844','2014-04-24','10:20:00',3.05),('15844','2014-04-24','10:25:00',3.2),('15844','2014-04-24','10:30:00',3.33),('15844','2014-04-24','10:35:00',3.31),('15844','2014-04-24','10:40:00',3.29),('15844','2014-04-24','10:45:00',3.5),('15844','2014-04-24','10:50:00',3.63),('15844','2014-04-24','10:55:00',3.68),('15844','2014-04-24','11:00:00',3.07),('15844','2014-04-24','11:05:00',3.9),('15844','2014-04-24','11:10:00',3.96),('15844','2014-04-24','11:15:00',3.88),('15844','2014-04-24','11:20:00',3.94),('15844','2014-04-24','11:25:00',3.92),('15844','2014-04-24','11:30:00',4.07),('15844','2014-04-24','11:35:00',4.15),('15844','2014-04-24','11:40:00',4.07),('15844','2014-04-24','11:45:00',4),('15844','2014-04-24','11:50:00',3.99),('15844','2014-04-24','11:55:00',4.04),('15844','2014-04-24','12:00:00',3.97),('15844','2014-04-24','12:05:00',3.21),('15844','2014-04-24','12:10:00',3.61),('15844','2014-04-24','12:15:00',4.12),('15844','2014-04-24','12:20:00',2.77),('15844','2014-04-24','12:25:00',2.5),('15844','2014-04-24','12:30:00',1.96),('15844','2014-04-24','12:35:00',3.53),('15844','2014-04-24','12:40:00',4.16),('15844','2014-04-24','12:45:00',4.09),('15844','2014-04-24','12:50:00',3.48),('15844','2014-04-24','12:55:00',4.09),('15844','2014-04-24','13:00:00',2.5),('15844','2014-04-24','13:05:00',3.83),('15844','2014-04-24','13:10:00',4.17),('15844','2014-04-24','13:15:00',4.23),('15844','2014-04-24','13:20:00',4.18),('15844','2014-04-24','13:25:00',1.21),('15844','2014-04-24','13:30:00',2.65),('15844','2014-04-24','13:35:00',4.24),('15844','2014-04-24','13:40:00',4.1),('15844','2014-04-24','13:45:00',4.03),('15844','2014-04-24','13:50:00',3.82),('15844','2014-04-24','13:55:00',3.73),('15844','2014-04-24','14:00:00',3.64),('15844','2014-04-24','14:05:00',3.51),('15844','2014-04-24','14:10:00',3.46),('15844','2014-04-24','14:15:00',3.41),('15844','2014-04-24','14:20:00',3.4),('15844','2014-04-24','14:25:00',3.4),('15844','2014-04-24','14:30:00',3.4),('15844','2014-04-24','14:35:00',3.56),('15844','2014-04-24','14:40:00',3.43),('15844','2014-04-24','14:45:00',3.06),('15844','2014-04-24','14:50:00',2.83),('15844','2014-04-24','14:55:00',2.74),('15844','2014-04-24','15:00:00',2.67),('15844','2014-04-24','15:05:00',2.78),('15844','2014-04-24','15:10:00',2.46),('15844','2014-04-24','15:15:00',2.34),('15844','2014-04-24','15:20:00',3.11),('15844','2014-04-24','15:25:00',2.5),('15844','2014-04-24','15:30:00',2.21),('15844','2014-04-24','15:35:00',2.33),('15844','2014-04-24','15:40:00',1.54),('15844','2014-04-24','15:45:00',1.91),('15844','2014-04-24','15:50:00',2.33),('15844','2014-04-24','15:55:00',1.85),('15844','2014-04-24','16:00:00',1.48),('15844','2014-04-24','16:05:00',1.49),('15844','2014-04-24','16:10:00',1.48),('15844','2014-04-24','16:15:00',1.62),('15844','2014-04-24','16:20:00',1.98),('15844','2014-04-24','16:25:00',1.66),('15844','2014-04-24','16:30:00',1.55),('15844','2014-04-24','16:35:00',1.56),('15844','2014-04-24','16:40:00',1.45),('15844','2014-04-24','16:45:00',1.01),('15844','2014-04-24','17:00:00',1.04),('15844','2014-04-24','17:05:00',1.01),('15844','2014-04-24','17:10:00',1.03),('15844','2014-01-06','11:15:00',1.18),('15844','2014-01-06','11:30:00',1.95),('15844','2014-01-06','11:35:00',2.36),('15844','2014-01-06','11:40:00',1.95),('15844','2014-01-06','11:45:00',1.96),('15844','2014-01-06','11:50:00',1.9),('15844','2014-01-06','11:55:00',1.89),('15844','2014-01-06','12:00:00',1.88),('15844','2014-01-06','12:05:00',1.85),('15844','2014-01-06','12:10:00',1.78),('15844','2014-01-06','12:15:00',1.74),('15844','2014-01-06','12:20:00',1.75),('15844','2014-01-06','12:25:00',1.69),('15844','2014-01-06','12:30:00',1.66),('15844','2014-01-06','12:35:00',1.59),('15844','2014-01-06','12:40:00',1.57),('15844','2014-01-06','12:45:00',1.53),('15844','2014-01-06','12:50:00',1.47),('15844','2014-01-06','12:55:00',1.42),('15844','2014-01-06','13:00:00',1.39),('15844','2014-01-06','13:05:00',1.34),('15844','2014-01-06','13:10:00',1.27),('15844','2014-01-06','13:15:00',1.2),('15844','2014-01-06','13:20:00',1.12),('15844','2014-01-06','13:25:00',1.05),('15844','2014-01-03','09:10:00',1.03),('15844','2014-01-03','09:15:00',1.11),('15844','2014-01-03','09:20:00',1.17),('15844','2014-01-03','09:25:00',1.35),('15844','2014-01-03','09:30:00',1.6),('15844','2014-01-03','09:35:00',1.68),('15844','2014-01-03','09:40:00',1.26),('15844','2014-01-03','09:50:00',1.13),('15844','2014-01-03','09:55:00',1.47),('15844','2014-01-03','10:00:00',1.63),('15844','2014-01-03','10:05:00',1.77),('15844','2014-01-03','10:10:00',1.52),('15844','2014-01-03','10:15:00',1.13),('15844','2014-01-03','10:40:00',1.13),('15844','2014-01-03','10:45:00',1.01),('15844','2014-01-03','11:10:00',1.02),('15844','2014-01-03','11:15:00',1.06),('15844','2014-01-03','11:40:00',1.31),('15844','2014-01-03','11:45:00',1.73),('15844','2014-01-03','11:50:00',1.98),('15844','2014-01-03','11:55:00',1.62),('15844','2014-01-03','12:00:00',1.24),('15844','2014-01-03','12:05:00',1.55),('15844','2014-01-03','12:10:00',1.92),('15844','2014-01-03','12:15:00',2.07),('15844','2014-01-03','12:20:00',2),('15844','2014-01-03','12:25:00',1.77),('15844','2014-01-03','12:30:00',1.24),('15844','2014-01-03','12:35:00',1.08),('15844','2014-01-03','12:40:00',1.39),('15844','2014-01-03','12:45:00',1.51),('15844','2014-01-03','12:50:00',1.52),('15844','2014-01-03','12:55:00',1.41),('15844','2014-01-03','13:00:00',1.53),('15844','2014-01-03','13:05:00',1.82),('15844','2014-01-03','13:10:00',1.35),('15844','2014-01-03','13:15:00',1.13),('15844','2014-01-03','13:20:00',1.04),('15844','2014-01-02','09:05:00',1.01),('15844','2014-01-02','09:10:00',1.06),('15844','2014-01-02','09:15:00',1.12),('15844','2014-01-02','09:20:00',1.18),('15844','2014-01-02','09:25:00',1.22),('15844','2014-01-02','09:30:00',1.28),('15844','2014-01-02','09:35:00',1.33),('15844','2014-01-02','09:40:00',1.37),('15844','2014-01-02','09:45:00',1.4),('15844','2014-01-02','09:50:00',1.45),('15844','2014-01-02','09:55:00',1.47),('15844','2014-01-02','10:00:00',1.51),('15844','2014-01-02','10:05:00',1.56),('15844','2014-01-02','10:10:00',1.59),('15844','2014-01-02','10:15:00',1.64),('15844','2014-01-02','10:20:00',1.66),('15844','2014-01-02','10:25:00',1.69),('15844','2014-01-02','10:30:00',1.72),('15844','2014-01-02','10:35:00',1.72),('15844','2014-01-02','10:40:00',1.79),('15844','2014-01-02','10:45:00',1.83),('15844','2014-01-02','10:50:00',1.73),('15844','2014-01-02','10:55:00',1.44),('15844','2014-01-02','11:00:00',1.37),('15844','2014-01-02','11:05:00',1.52),('15844','2014-01-02','11:10:00',1.34),('15844','2014-01-02','11:15:00',1.02),('15844','2014-01-02','11:20:00',1.13),('15844','2014-01-02','11:25:00',1.17),('15844','2014-01-02','11:30:00',1.26),('15844','2014-01-02','11:35:00',1.32),('15844','2014-01-02','11:40:00',1.38),('15844','2014-01-02','12:45:00',1.1),('15844','2014-01-02','12:50:00',1.82),('15844','2014-01-02','13:00:00',1.27),('15844','2014-01-02','13:05:00',1.4),('15844','2014-01-02','13:15:00',1.05),('15844','2014-01-02','13:25:00',1.15),('15844','2014-01-02','13:30:00',1.42),('15844','2014-01-01','12:05:00',1.02),('15844','2014-01-01','12:10:00',1.05),('15844','2014-01-01','12:15:00',1.03),('15844','2014-01-01','12:20:00',1.04),('15844','2014-01-01','12:25:00',1.05),('15844','2014-01-01','12:30:00',1.02),('15844','2014-01-01','12:50:00',1),('15844','2014-01-01','13:00:00',1.14),('15844','2014-01-01','13:25:00',1.02),('15844','2014-01-01','13:30:00',1.52),('15844','2014-01-01','13:40:00',1.11),('15844','2014-01-01','13:45:00',1.05),('15844','2013-12-31','09:00:00',1.08),('15844','2013-12-31','09:05:00',1.14),('15844','2013-12-31','09:10:00',1.16),('15844','2013-12-31','09:15:00',1.21),('15844','2013-12-31','09:20:00',1.26),('15844','2013-12-31','09:25:00',1.38),('15844','2013-12-31','09:30:00',1.54),('15844','2013-12-31','09:35:00',1.69),('15844','2013-12-31','09:40:00',1.52),('15844','2013-12-31','10:05:00',1.45),('15844','2013-12-31','10:10:00',1.98),('15844','2013-12-31','11:00:00',1),('15844','2013-12-31','11:05:00',1.09),('15844','2013-12-31','11:10:00',1.24),('15844','2013-12-31','11:15:00',1.22),('15844','2013-12-31','11:20:00',1.83),('15844','2013-12-31','11:25:00',1.06),('15844','2013-12-31','11:35:00',1.76),('15844','2013-12-31','11:40:00',1.77),('15844','2013-12-31','11:50:00',1.5),('15844','2013-12-31','11:55:00',1.27),('15844','2013-12-31','12:00:00',1.88),('15844','2013-12-31','12:05:00',1.79),('15844','2013-12-31','12:10:00',1.8),('15844','2013-12-31','12:15:00',1.78),('15844','2013-12-31','12:20:00',1.6),('15844','2013-12-31','12:25:00',1.68),('15844','2013-12-31','12:30:00',1.64),('15844','2013-12-31','12:35:00',1.57),('15844','2013-12-31','12:40:00',1.51),('15844','2013-12-31','12:45:00',1.48),('15844','2013-12-31','12:50:00',1.43),('15844','2013-12-31','12:55:00',1.38),('15844','2013-12-31','13:00:00',1.32),('15844','2013-12-31','13:05:00',1.27),('15844','2013-12-31','13:10:00',1.21),('15844','2013-12-31','13:15:00',1.15),('15844','2013-12-31','13:20:00',1.1),('15844','2013-12-31','13:25:00',1.03),('15844','2013-12-29','09:10:00',1.02),('15844','2013-12-29','09:15:00',1.09),('15844','2013-12-29','09:20:00',1.23),('15844','2013-12-29','09:25:00',1.32),('15844','2013-12-29','09:30:00',1.35),('15844','2013-12-29','09:35:00',1.4),('15844','2013-12-29','09:40:00',1.5),('15844','2013-12-29','09:45:00',1.51),('15844','2013-12-29','09:50:00',1.32),('15844','2013-12-29','09:55:00',1.38),('15844','2013-12-29','10:00:00',1.44),('15844','2013-12-29','10:05:00',1.5),('15844','2013-12-29','10:10:00',1.57),('15844','2013-12-29','10:15:00',1.61),('15844','2013-12-29','10:20:00',1.03),('15844','2013-12-29','10:25:00',1.18),('15844','2013-12-29','10:30:00',1.18),('15844','2013-12-29','10:35:00',1.06),('15844','2013-12-29','10:40:00',1.52),('15844','2013-12-29','10:45:00',1.41),('15844','2013-12-28','09:05:00',1.04),('15844','2013-12-28','09:10:00',1.11),('15844','2013-12-28','09:15:00',1.17),('15844','2013-12-28','09:20:00',1.22),('15844','2013-12-28','09:25:00',1.29),('15844','2013-12-28','09:30:00',1.34),('15844','2013-12-28','09:35:00',1.38),('15844','2013-12-28','09:40:00',1.41),('15844','2013-12-28','09:45:00',1.45),('15844','2013-12-28','09:50:00',1.49),('15844','2013-12-28','09:55:00',1.53),('15844','2013-12-28','10:00:00',1.58),('15844','2013-12-28','10:05:00',1.6),('15844','2013-12-28','10:10:00',1.63),('15844','2013-12-28','10:15:00',1.67),('15844','2013-12-28','10:20:00',1.69),('15844','2013-12-28','10:25:00',1.72),('15844','2013-12-28','10:30:00',1.76),('15844','2013-12-28','10:35:00',1.79),('15844','2013-12-28','10:40:00',1.83),('15844','2013-12-28','10:45:00',1.86),('15844','2013-12-28','10:50:00',1.86),('15844','2013-12-28','10:55:00',1.87),('15844','2013-12-28','11:00:00',1.88),('15844','2013-12-28','11:05:00',1.91),('15844','2013-12-28','11:10:00',1.91),('15844','2013-12-28','11:15:00',1.9),('15844','2013-12-28','11:20:00',1.88),('15844','2013-12-28','11:25:00',1.87),('15844','2013-12-28','11:30:00',1.87),('15844','2013-12-28','11:35:00',1.87),('15844','2013-12-28','11:40:00',1.84),('15844','2013-12-28','11:45:00',1.83),('15844','2013-12-28','11:50:00',1.79),('15844','2013-12-28','11:55:00',1.8),('15844','2013-12-28','12:00:00',1.79),('15844','2013-12-28','12:05:00',1.74),('15844','2013-12-28','12:10:00',1.73),('15844','2013-12-28','12:15:00',1.69),('15844','2013-12-28','12:20:00',1.67),('15844','2013-12-28','12:25:00',1.63),('15844','2013-12-28','12:30:00',1.6),('15844','2013-12-28','12:35:00',1.55),('15844','2013-12-28','12:40:00',1.48),('15844','2013-12-28','12:45:00',1.42),('15844','2013-12-28','12:50:00',1.36),('15844','2013-12-28','12:55:00',1.32),('15844','2013-12-28','13:00:00',1.25),('15844','2013-12-28','13:05:00',1.18),('15844','2013-12-28','13:10:00',1.11),('15844','2013-12-28','13:15:00',1.06),('15844','2014-04-23','13:30:00',1.07),('15844','2014-04-23','13:35:00',1.19),('15844','2014-04-23','13:40:00',1.3),('15844','2014-04-23','13:45:00',1.37),('15844','2014-04-23','13:50:00',1.38),('15844','2014-04-23','13:55:00',1.4),('15844','2014-04-23','14:00:00',1.39),('15844','2014-04-23','14:05:00',1.38),('15844','2014-04-23','14:10:00',1.37),('15844','2014-04-23','14:15:00',1.31),('15844','2014-04-23','14:20:00',1.21),('15844','2014-04-23','14:25:00',1.1),('15844','2014-04-23','15:10:00',1.05),('15844','2014-04-23','15:15:00',1.17),('15844','2014-04-23','15:20:00',1.21),('15844','2014-04-23','15:25:00',1.23),('15844','2014-04-23','15:30:00',1.15),('15844','2014-04-23','15:35:00',1.03),('15844','2013-12-27','12:00:00',1.05),('15844','2013-12-27','12:05:00',1.44),('15844','2013-12-27','12:10:00',1.46),('15844','2013-12-27','12:15:00',1.27),('15844','2013-12-27','12:45:00',1.25),('15844','2013-12-27','12:50:00',1.13),('15844','2013-12-27','12:55:00',1.34),('15844','2013-12-27','13:00:00',1.12),('15844','2013-12-27','13:05:00',1.16),('15844','2013-12-27','13:10:00',1.15),('15844','2013-12-27','13:15:00',1.15),('15844','2013-12-27','13:20:00',1.15),('15844','2013-12-27','13:25:00',1.15),('15844','2013-12-27','13:30:00',1.16),('15844','2013-12-25','11:40:00',1.11),('15844','2013-12-25','11:50:00',1.35),('15844','2013-12-25','11:55:00',1.91),('15844','2013-12-25','12:00:00',1.74),('15844','2013-12-25','12:05:00',1.59),('15844','2013-12-25','12:15:00',1.81),('15844','2013-12-25','12:20:00',1.87),('15844','2013-12-25','12:25:00',2.01),('15844','2013-12-25','12:30:00',1.62),('15844','2013-12-25','12:35:00',1.11),('15844','2013-12-25','12:45:00',1.02),('15844','2013-12-24','09:15:00',1.03),('15844','2013-12-24','09:20:00',1.09),('15844','2013-12-24','09:25:00',1.13),('15844','2013-12-24','09:30:00',1.17),('15844','2013-12-24','09:35:00',1.21),('15844','2013-12-24','09:40:00',1.25),('15844','2013-12-24','09:45:00',1.27),('15844','2013-12-24','09:50:00',1.3),('15844','2013-12-24','09:55:00',1.34),('15844','2013-12-24','10:00:00',1.38),('15844','2013-12-24','10:05:00',1.41),('15844','2013-12-24','10:10:00',1.42),('15844','2013-12-24','10:15:00',1.44),('15844','2013-12-24','10:20:00',1.5),('15844','2013-12-24','10:25:00',1.54),('15844','2013-12-24','10:30:00',1.59),('15844','2013-12-24','10:35:00',1.61),('15844','2013-12-24','10:40:00',1.65),('15844','2013-12-24','10:45:00',1.66),('15844','2013-12-24','10:50:00',1.65),('15844','2013-12-24','10:55:00',1.67),('15844','2013-12-24','11:00:00',1.69),('15844','2013-12-24','11:05:00',1.64),('15844','2013-12-24','11:10:00',1.59),('15844','2013-12-24','11:15:00',1.66),('15844','2013-12-24','11:20:00',1.67),('15844','2013-12-24','11:25:00',1.66),('15844','2013-12-24','11:30:00',1.65),('15844','2013-12-24','11:35:00',1.63),('15844','2013-12-24','11:40:00',1.64),('15844','2013-12-24','11:45:00',1.61),('15844','2013-12-24','11:50:00',1.6),('15844','2013-12-24','11:55:00',1.59),('15844','2013-12-24','12:00:00',1.56),('15844','2013-12-24','12:05:00',1.54),('15844','2013-12-24','12:10:00',1.53),('15844','2013-12-24','12:15:00',1.5),('15844','2013-12-24','12:20:00',1.47),('15844','2013-12-24','12:25:00',1.44),('15844','2013-12-24','12:30:00',1.4),('15844','2013-12-24','12:35:00',1.37),('15844','2013-12-24','12:40:00',1.34),('15844','2013-12-24','12:45:00',1.29),('15844','2013-12-24','12:50:00',1.21),('15844','2013-12-24','12:55:00',1.16),('15844','2013-12-24','13:00:00',1.11),('15844','2013-12-24','13:05:00',1.06),('15844','2013-12-24','13:10:00',1.01),('15844','2013-12-23','09:55:00',1.1),('15844','2013-12-23','10:00:00',1.3),('15844','2013-12-23','10:05:00',1.39),('15844','2013-12-23','10:10:00',1.35),('15844','2013-12-23','10:15:00',1.56),('15844','2013-12-23','10:20:00',1.52),('15844','2013-12-23','10:25:00',1.59),('15844','2013-12-23','10:30:00',1.48),('15844','2013-12-23','10:35:00',1.45),('15844','2013-12-23','10:40:00',1.45),('15844','2013-12-23','10:45:00',1.48),('15844','2013-12-23','10:50:00',1.57),('15844','2013-12-23','10:55:00',1.67),('15844','2013-12-23','11:00:00',1.74),('15844','2013-12-23','11:05:00',1.72),('15844','2013-12-23','11:10:00',1.79),('15844','2013-12-23','11:15:00',1.78),('15844','2013-12-23','11:20:00',1.77),('15844','2013-12-23','11:25:00',1.81),('15844','2013-12-23','11:30:00',1.79),('15844','2013-12-23','11:35:00',1.7),('15844','2013-12-23','11:40:00',1.51),('15844','2013-12-23','11:45:00',1.55),('15844','2013-12-23','11:50:00',1.63),('15844','2013-12-23','11:55:00',1.7),('15844','2013-12-23','12:00:00',1.67),('15844','2013-12-23','12:05:00',1.66),('15844','2013-12-23','12:10:00',1.62),('15844','2013-12-23','12:15:00',1.55),('15844','2013-12-23','12:20:00',1.51),('15844','2013-12-23','12:25:00',1.44),('15844','2013-12-23','12:30:00',1.41),('15844','2013-12-23','12:35:00',1.34),('15844','2013-12-23','12:40:00',1.29),('15844','2013-12-23','12:45:00',1.26),('15844','2013-12-23','12:50:00',1.22),('15844','2013-12-23','12:55:00',1.17),('15844','2013-12-23','13:00:00',1.11),('15844','2013-12-23','13:05:00',1.09),('15844','2013-12-23','13:10:00',1),('15844','2013-12-22','09:30:00',1.13),('15844','2013-12-22','09:35:00',1.39),('15844','2013-12-22','09:40:00',1.68),('15844','2013-12-22','09:45:00',1.72),('15844','2013-12-22','09:50:00',1.81),('15844','2013-12-22','09:55:00',1.81),('15844','2013-12-22','10:00:00',1.79),('15844','2013-12-22','10:05:00',1.72),('15844','2013-12-22','10:10:00',1.75),('15844','2013-12-22','10:15:00',1.72),('15844','2013-12-22','10:20:00',1.72),('15844','2013-12-22','10:25:00',1.69),('15844','2013-12-22','10:30:00',1.71),('15844','2013-12-22','10:35:00',1.64),('15844','2013-12-22','10:40:00',1.57),('15844','2013-12-22','10:45:00',1.59),('15844','2013-12-22','10:50:00',1.7),('15844','2013-12-22','10:55:00',1.71),('15844','2013-12-22','11:00:00',1.66),('15844','2013-12-22','11:05:00',1.57),('15844','2013-12-22','11:10:00',1.68),('15844','2013-12-22','11:15:00',1.61),('15844','2013-12-22','11:20:00',1.62),('15844','2013-12-22','11:25:00',1.61),('15844','2013-12-22','11:30:00',1.53),('15844','2013-12-22','11:35:00',1.58),('15844','2013-12-22','11:40:00',1.52),('15844','2013-12-22','11:45:00',1.41),('15844','2013-12-22','11:50:00',1.11),('15844','2013-12-22','12:35:00',1.12),('15844','2013-12-22','12:40:00',1.14),('15844','2013-12-22','12:45:00',1.09),('15844','2013-12-22','12:50:00',1.23),('15844','2013-12-22','12:55:00',1.38),('15844','2013-12-22','13:00:00',1.44),('15844','2013-12-22','13:05:00',1.56),('15844','2013-12-22','13:10:00',1.52),('15844','2013-12-22','13:15:00',1.34),('15844','2013-12-22','13:20:00',1.15),('15844','2013-12-22','13:25:00',1.08),('15844','2013-12-21','09:15:00',1.04),('15844','2013-12-21','09:20:00',1.11),('15844','2013-12-21','09:25:00',1.11),('15844','2013-12-21','09:30:00',1.2),('15844','2013-12-21','09:35:00',1.24),('15844','2013-12-21','09:40:00',1.27),('15844','2013-12-21','09:45:00',1.33),('15844','2013-12-21','09:50:00',1.35),('15844','2013-12-21','09:55:00',1.4),('15844','2013-12-21','10:00:00',1.45),('15844','2013-12-21','10:05:00',1.5),('15844','2013-12-21','10:10:00',1.53),('15844','2013-12-21','10:15:00',1.57),('15844','2013-12-21','10:20:00',1.6),('15844','2013-12-21','10:25:00',1.63),('15844','2013-12-21','10:30:00',1.66),('15844','2013-12-21','10:35:00',1.7),('15844','2013-12-21','10:40:00',1.73),('15844','2013-12-21','10:45:00',1.76),('15844','2013-12-21','10:50:00',1.78),('15844','2013-12-21','10:55:00',1.8),('15844','2013-12-21','11:00:00',1.82),('15844','2013-12-21','11:05:00',1.82),('15844','2013-12-21','11:10:00',1.82),('15844','2013-12-21','11:15:00',1.82),('15844','2013-12-21','11:20:00',1.82),('15844','2013-12-21','11:25:00',1.81),('15844','2013-12-21','11:30:00',1.82),('15844','2013-12-21','11:35:00',1.8),('15844','2013-12-21','11:40:00',1.8),('15844','2013-12-21','11:45:00',1.75),('15844','2013-12-21','11:50:00',1.75),('15844','2013-12-21','11:55:00',1.75),('15844','2013-12-21','12:00:00',1.73),('15844','2013-12-21','12:05:00',1.71),('15844','2013-12-21','12:10:00',1.67),('15844','2013-12-21','12:15:00',1.64),('15844','2013-12-21','12:20:00',1.6),('15844','2013-12-21','12:25:00',1.57),('15844','2013-12-21','12:30:00',1.53),('15844','2013-12-21','12:35:00',1.46),('15844','2013-12-21','12:40:00',1.42),('15844','2013-12-21','12:45:00',1.38),('15844','2013-12-21','12:50:00',1.34),('15844','2013-12-21','12:55:00',1.28),('15844','2013-12-21','13:00:00',1.23),('15844','2013-12-21','13:05:00',1.17),('15844','2013-12-21','13:10:00',1.11),('15844','2013-12-21','13:15:00',1.05),('15844','2013-12-20','09:15:00',1.02),('15844','2013-12-20','09:20:00',1.07),('15844','2013-12-20','09:25:00',1.11),('15844','2013-12-20','09:30:00',1.17),('15844','2013-12-20','09:35:00',1.21),('15844','2013-12-20','09:40:00',1.23),('15844','2013-12-20','09:45:00',1.3),('15844','2013-12-20','09:50:00',1.33),('15844','2013-12-20','09:55:00',1.38),('15844','2013-12-20','10:00:00',1.41),('15844','2013-12-20','10:05:00',1.43),('15844','2013-12-20','10:10:00',1.46),('15844','2013-12-20','10:15:00',1.47),('15844','2013-12-20','10:20:00',1.48),('15844','2013-12-20','10:25:00',1.53),('15844','2013-12-20','10:30:00',1.56),('15844','2013-12-20','10:35:00',1.61),('15844','2013-12-20','10:40:00',1.66),('15844','2013-12-20','10:45:00',1.67),('15844','2013-12-20','10:50:00',1.68),('15844','2013-12-20','10:55:00',1.71),('15844','2013-12-20','11:00:00',1.71),('15844','2013-12-20','11:05:00',1.69),('15844','2013-12-20','11:10:00',1.71),('15844','2013-12-20','11:15:00',1.7),('15844','2013-12-20','11:20:00',1.7),('15844','2013-12-20','11:25:00',1.69),('15844','2013-12-20','11:30:00',1.68),('15844','2013-12-20','11:35:00',1.67),('15844','2013-12-20','11:40:00',1.66),('15844','2013-12-20','11:45:00',1.64),('15844','2013-12-20','11:50:00',1.61),('15844','2013-12-20','11:55:00',1.6),('15844','2013-12-20','12:00:00',1.57),('15844','2013-12-20','12:05:00',1.52),('15844','2013-12-20','12:10:00',1.52),('15844','2013-12-20','12:15:00',1.51),('15844','2013-12-20','12:20:00',1.46),('15844','2013-12-20','12:35:00',1.37),('15844','2013-12-20','12:40:00',1.35),('15844','2013-12-20','12:45:00',1.32),('15844','2013-12-20','12:50:00',1.24),('15844','2013-12-20','12:55:00',1.18),('15844','2013-12-20','13:00:00',1.13),('15844','2013-12-20','13:05:00',1.06),('15844','2013-12-19','09:50:00',1.25),('15844','2013-12-18','09:10:00',1.01),('15844','2013-12-18','09:15:00',1.08),('15844','2013-12-18','09:20:00',1.13),('15844','2013-12-18','09:25:00',1.18),('15844','2013-12-18','09:30:00',1.24),('15844','2013-12-18','09:35:00',1.28),('15844','2013-12-18','09:40:00',1.33),('15844','2013-12-18','09:45:00',1.37),('15844','2013-12-18','09:50:00',1.4),('15844','2013-12-18','09:55:00',1.45),('15844','2013-12-18','10:00:00',1.48),('15844','2013-12-18','10:05:00',1.52),('15844','2013-12-18','10:10:00',1.56),('15844','2013-12-18','10:15:00',1.59),('15844','2013-12-18','10:20:00',1.6),('15844','2013-12-18','10:25:00',1.63),('15844','2013-12-18','10:30:00',1.66),('15844','2013-12-18','10:35:00',1.71),('15844','2013-12-18','10:40:00',1.72),('15844','2013-12-18','10:45:00',1.75),('15844','2013-12-18','10:50:00',1.76),('15844','2013-12-18','10:55:00',1.76),('15844','2013-12-18','11:00:00',1.76),('15844','2013-12-18','11:05:00',1.74),('15844','2013-12-18','11:10:00',1.76),('15844','2013-12-18','11:15:00',1.72),('15844','2013-12-18','11:20:00',1.72),('15844','2013-12-18','11:25:00',1.72),('15844','2013-12-18','11:30:00',1.72),('15844','2013-12-18','11:35:00',1.69),('15844','2013-12-18','11:40:00',1.69),('15844','2013-12-18','11:45:00',1.69),('15844','2013-12-18','11:50:00',1.68),('15844','2013-12-18','11:55:00',1.67),('15844','2013-12-18','12:00:00',1.65),('15844','2013-12-18','12:05:00',1.62),('15844','2013-12-18','12:10:00',1.58),('15844','2013-12-18','12:15:00',1.56),('15844','2013-12-18','12:20:00',1.54),('15844','2013-12-18','12:25:00',1.49),('15844','2013-12-18','12:30:00',1.43),('15844','2013-12-18','12:35:00',1.41),('15844','2013-12-18','12:40:00',1.33),('15844','2013-12-18','12:45:00',1.3),('15844','2013-12-18','12:50:00',1.22),('15844','2013-12-18','12:55:00',1.19),('15844','2013-12-18','13:00:00',1.11),('15844','2013-12-18','13:05:00',1.04),('15844','2013-12-18','13:10:00',1.01),('15844','2014-04-22','08:35:00',1.06),('15844','2014-04-22','08:40:00',1.21),('15844','2014-04-22','08:45:00',1.32),('15844','2014-04-22','08:50:00',1.34),('15844','2014-04-22','08:55:00',1.43),('15844','2014-04-22','09:00:00',1.55),('15844','2014-04-22','09:05:00',1.65),('15844','2014-04-22','09:10:00',1.18),('15844','2014-04-22','09:15:00',1.01),('15844','2014-04-22','09:20:00',2.05),('15844','2014-04-22','09:25:00',2.06),('15844','2014-04-22','09:30:00',1.41),('15844','2014-04-22','09:35:00',1.76),('15844','2014-04-22','09:40:00',2.2),('15844','2014-04-22','09:45:00',2.29),('15844','2014-04-22','09:50:00',1.36),('15844','2014-04-22','09:55:00',1.16),('15844','2014-04-22','10:00:00',1.39),('15844','2014-04-22','10:05:00',1.27),('15844','2014-04-22','10:10:00',1.78),('15844','2014-04-22','10:15:00',2.08),('15844','2014-04-22','10:20:00',2.66),('15844','2014-04-22','10:25:00',1.98),('15844','2014-04-22','10:30:00',3.11),('15844','2014-04-22','10:35:00',1.88),('15844','2014-04-22','10:40:00',2.47),('15844','2014-04-22','10:45:00',4.06),('15844','2014-04-22','10:50:00',3.19),('15844','2014-04-22','10:55:00',3.21),('15844','2014-04-22','11:00:00',2.21),('15844','2014-04-22','11:05:00',2.23),('15844','2014-04-22','11:10:00',1.48),('15844','2014-04-22','11:15:00',1.32),('15844','2014-04-22','11:20:00',1.03),('15844','2014-04-22','11:25:00',1.01),('15844','2014-04-22','12:05:00',1.04),('15844','2014-04-22','12:15:00',1.03),('15844','2014-04-22','12:20:00',1.05),('15844','2014-04-22','12:25:00',1.12),('15844','2014-04-22','12:30:00',1.1),('15844','2014-04-22','13:15:00',1.26),('15844','2014-04-22','13:20:00',1.57),('15844','2014-04-22','13:25:00',1.72),('15844','2014-04-22','13:30:00',2.15),('15844','2014-04-22','13:35:00',2.49),('15844','2014-04-22','13:40:00',2.29),('15844','2014-04-22','13:45:00',2.13),('15844','2014-04-22','13:50:00',1.41),('15844','2014-04-22','13:55:00',1.24),('15844','2014-04-22','14:00:00',1.29),('15844','2014-04-22','14:05:00',3.56),('15844','2014-04-22','14:10:00',2.88),('15844','2014-04-22','14:15:00',2.56),('15844','2014-04-22','14:20:00',1.94),('15844','2014-04-22','14:25:00',1.46),('15844','2014-04-22','14:30:00',2.02),('15844','2014-04-22','14:35:00',3.14),('15844','2014-04-22','14:40:00',2.73),('15844','2014-04-22','14:45:00',2.9),('15844','2014-04-22','14:50:00',2.7),('15844','2014-04-22','14:55:00',1.41),('15844','2014-04-22','15:05:00',1.02),('15844','2014-04-22','15:10:00',1.05),('15844','2014-04-22','15:15:00',1.06),('15844','2014-04-22','15:20:00',1.04),('15844','2014-04-22','15:25:00',1.24),('15844','2014-04-22','15:30:00',1.41),('15844','2014-04-22','15:35:00',1.49),('15844','2014-04-22','15:40:00',1.44),('15844','2014-04-22','15:45:00',1.62),('15844','2014-04-22','15:50:00',1.58),('15844','2014-04-22','15:55:00',1.49),('15844','2014-04-22','16:00:00',1.68),('15844','2014-04-22','16:05:00',1.39),('15844','2014-04-22','16:10:00',1.22),('15844','2014-04-22','16:15:00',1.16),('15844','2014-04-22','16:20:00',1.36),('15844','2014-04-22','16:25:00',1.23),('15844','2014-04-22','16:30:00',1.08),('15844','2014-04-22','16:35:00',1.15),('15844','2014-04-22','16:40:00',1.13),('15844','2014-04-22','16:45:00',1.05),('15844','2014-04-22','17:00:00',1.04),('15844','2013-12-17','08:55:00',1),('15844','2013-12-17','09:00:00',1.06),('15844','2013-12-17','09:05:00',1.11),('15844','2013-12-17','09:10:00',1.16),('15844','2013-12-17','09:15:00',1.18),('15844','2013-12-17','09:20:00',1.25),('15844','2013-12-17','09:25:00',1.27),('15844','2013-12-17','09:30:00',1.32),('15844','2013-12-17','09:35:00',1.35),('15844','2013-12-17','09:40:00',1.4),('15844','2013-12-17','09:45:00',1.44),('15844','2013-12-17','09:50:00',1.48),('15844','2013-12-17','09:55:00',1.51),('15844','2013-12-17','10:00:00',1.55),('15844','2013-12-17','10:05:00',1.58),('15844','2013-12-17','10:10:00',1.62),('15844','2013-12-17','10:15:00',1.64),('15844','2013-12-17','10:20:00',1.65),('15844','2013-12-17','10:25:00',1.68),('15844','2013-12-17','10:30:00',1.71),('15844','2013-12-17','10:35:00',1.75),('15844','2013-12-17','10:40:00',1.8),('15844','2013-12-17','10:45:00',1.82),('15844','2013-12-17','10:50:00',1.83),('15844','2013-12-17','10:55:00',1.84),('15844','2013-12-17','11:00:00',1.84),('15844','2013-12-17','11:05:00',1.84),('15844','2013-12-17','11:10:00',1.83),('15844','2013-12-17','11:15:00',1.85),('15844','2013-12-17','11:20:00',1.84),('15844','2013-12-17','11:25:00',1.85),('15844','2013-12-17','11:30:00',1.84),('15844','2013-12-17','11:35:00',1.82),('15844','2013-12-17','11:40:00',1.81),('15844','2013-12-17','11:45:00',1.75),('15844','2013-12-17','11:50:00',1.75),('15844','2013-12-17','11:55:00',1.69),('15844','2013-12-17','12:00:00',1.69),('15844','2013-12-17','12:05:00',1.68),('15844','2013-12-17','12:10:00',1.65),('15844','2013-12-17','12:15:00',1.65),('15844','2013-12-17','12:20:00',1.6),('15844','2013-12-17','12:25:00',1.57),('15844','2013-12-17','12:30:00',1.53),('15844','2013-12-17','12:35:00',1.5),('15844','2013-12-17','12:40:00',1.45),('15844','2013-12-17','12:45:00',1.41),('15844','2013-12-17','12:50:00',1.36),('15844','2013-12-17','13:05:00',1.16),('15844','2013-12-17','13:10:00',1.1),('15844','2013-12-17','13:15:00',1.03),('15844','2013-12-16','09:00:00',1.01),('15844','2013-12-16','09:05:00',1.07),('15844','2013-12-16','09:10:00',1.14),('15844','2013-12-16','09:15:00',1.19),('15844','2013-12-16','09:20:00',1.27),('15844','2013-12-16','09:25:00',1.31),('15844','2013-12-16','09:30:00',1.35),('15844','2013-12-16','09:35:00',1.39),('15844','2013-12-16','09:40:00',1.43),('15844','2013-12-16','09:45:00',1.46),('15844','2013-12-16','09:50:00',1.51),('15844','2013-12-16','09:55:00',1.55),('15844','2013-12-16','10:00:00',1.58),('15844','2013-12-16','10:05:00',1.59),('15844','2013-12-16','10:10:00',1.63),('15844','2013-12-16','10:15:00',1.64),('15844','2013-12-16','10:20:00',1.65),('15844','2013-12-16','10:25:00',1.69),('15844','2013-12-16','10:30:00',1.73),('15844','2013-12-16','10:35:00',1.75),('15844','2013-12-16','10:40:00',1.77),('15844','2013-12-16','10:45:00',1.82),('15844','2013-12-16','10:50:00',1.83),('15844','2013-12-16','10:55:00',1.86),('15844','2013-12-16','11:00:00',1.86),('15844','2013-12-16','11:05:00',1.88),('15844','2013-12-16','11:10:00',1.86),('15844','2013-12-16','11:15:00',1.86),('15844','2013-12-16','11:20:00',1.86),('15844','2013-12-16','11:25:00',1.84),('15844','2013-12-16','11:30:00',1.84),('15844','2013-12-16','11:35:00',1.83),('15844','2013-12-16','11:40:00',1.83),('15844','2013-12-16','11:45:00',1.82),('15844','2013-12-16','11:50:00',1.8),('15844','2013-12-16','11:55:00',1.78),('15844','2013-12-16','12:00:00',1.77),('15844','2013-12-16','12:05:00',1.75),('15844','2013-12-16','12:10:00',1.72),('15844','2013-12-16','12:15:00',1.68),('15844','2013-12-16','12:20:00',1.62),('15844','2013-12-16','12:25:00',1.58),('15844','2013-12-16','12:30:00',1.54),('15844','2013-12-16','12:35:00',1.49),('15844','2013-12-16','12:40:00',1.44),('15844','2013-12-16','12:45:00',1.4),('15844','2013-12-16','12:50:00',1.34),('15844','2013-12-16','12:55:00',1.28),('15844','2013-12-16','13:00:00',1.23),('15844','2013-12-16','13:05:00',1.17),('15844','2013-12-16','13:10:00',1.11),('15844','2013-12-16','13:15:00',1.03),('15844','2013-12-15','10:30:00',1.03),('15844','2013-12-14','09:10:00',1.03),('15844','2013-12-14','09:15:00',1.09),('15844','2013-12-14','09:20:00',1.15),('15844','2013-12-14','09:25:00',1.19),('15844','2013-12-14','09:30:00',1.24),('15844','2013-12-14','09:35:00',1.28),('15844','2013-12-14','09:40:00',1.32),('15844','2013-12-14','09:45:00',1.36),('15844','2013-12-14','09:50:00',1.39),('15844','2013-12-14','09:55:00',1.42),('15844','2013-12-14','10:00:00',1.46),('15844','2013-12-14','10:05:00',1.51),('15844','2013-12-14','10:10:00',1.53),('15844','2013-12-14','10:15:00',1.57),('15844','2013-12-14','10:20:00',1.6),('15844','2013-12-14','10:25:00',1.65),('15844','2013-12-14','10:30:00',1.68),('15844','2013-12-14','10:35:00',1.72),('15844','2013-12-14','10:40:00',1.76),('15844','2013-12-14','10:45:00',1.78),('15844','2013-12-14','10:50:00',1.81),('15844','2013-12-14','10:55:00',1.81),('15844','2013-12-14','11:00:00',1.8),('15844','2013-12-14','11:05:00',1.78),('15844','2013-12-14','11:10:00',1.77),('15844','2013-12-14','11:15:00',1.78),('15844','2013-12-14','11:20:00',1.78),('15844','2013-12-14','11:25:00',1.77),('15844','2013-12-14','11:30:00',1.77),('15844','2013-12-14','11:35:00',1.75),('15844','2013-12-14','11:40:00',1.74),('15844','2013-12-14','11:45:00',1.71),('15844','2013-12-14','11:50:00',1.67),('15844','2013-12-14','11:55:00',1.68),('15844','2013-12-14','12:00:00',1.67),('15844','2013-12-14','12:05:00',1.61),('15844','2013-12-14','12:10:00',1.57),('15844','2013-12-14','12:15:00',1.55),('15844','2013-12-14','12:20:00',1.46),('15844','2013-12-14','12:25:00',1.38),('15844','2013-12-14','12:30:00',1.34),('15844','2013-12-14','12:35:00',1.38),('15844','2013-12-14','12:40:00',1.32),('15844','2013-12-14','12:45:00',1.32),('15844','2013-12-14','12:50:00',1.26),('15844','2013-12-14','12:55:00',1.23),('15844','2013-12-14','13:00:00',1.2),('15844','2013-12-14','13:05:00',1.16),('15844','2013-12-14','13:10:00',1.09),('15844','2013-12-14','13:15:00',1.02),('15844','2013-12-13','09:15:00',1.03),('15844','2013-12-13','09:20:00',1.06),('15844','2013-12-13','09:25:00',1.09),('15844','2013-12-13','09:30:00',1.12),('15844','2013-12-13','09:35:00',1.18),('15844','2013-12-13','09:40:00',1.21),('15844','2013-12-13','09:45:00',1.25),('15844','2013-12-13','09:50:00',1.29),('15844','2013-12-13','09:55:00',1.34),('15844','2013-12-13','10:00:00',1.37),('15844','2013-12-13','10:05:00',1.39),('15844','2013-12-13','10:10:00',1.41),('15844','2013-12-13','10:15:00',1.44),('15844','2013-12-13','10:20:00',1.46),('15844','2013-12-13','10:25:00',1.49),('15844','2013-12-13','10:30:00',1.53),('15844','2013-12-13','10:35:00',1.58),('15844','2013-12-13','10:40:00',1.61),('15844','2013-12-13','10:45:00',1.65),('15844','2013-12-13','10:50:00',1.67),('15844','2013-12-13','10:55:00',1.69),('15844','2013-12-13','11:00:00',1.71),('15844','2013-12-13','11:05:00',1.68),('15844','2013-12-13','11:10:00',1.66),('15844','2013-12-13','11:15:00',1.67),('15844','2013-12-13','11:20:00',1.69),('15844','2013-12-13','11:25:00',1.73),('15844','2013-12-13','11:30:00',1.68),('15844','2013-12-13','11:35:00',1.68),('15844','2013-12-13','11:40:00',1.69),('15844','2013-12-13','11:45:00',1.65),('15844','2013-12-13','11:50:00',1.64),('15844','2013-12-13','11:55:00',1.59),('15844','2013-12-13','12:00:00',1.57),('15844','2013-12-13','12:05:00',1.55),('15844','2013-12-13','12:10:00',1.52),('15844','2013-12-13','12:15:00',1.55),('15844','2013-12-13','12:20:00',1.48),('15844','2013-12-13','12:25:00',1.37),('15844','2013-12-13','12:30:00',1.38),('15844','2013-12-13','12:35:00',1.36),('15844','2013-12-13','12:40:00',1.35),('15844','2013-12-13','12:45:00',1.33),('15844','2013-12-13','12:50:00',1.3),('15844','2013-12-13','12:55:00',1.24),('15844','2013-12-13','13:00:00',1.21),('15844','2013-12-13','13:05:00',1.16),('15844','2013-12-13','13:10:00',1.09),('15844','2013-12-13','13:15:00',1.04),('15844','2013-12-12','09:05:00',1.02),('15844','2013-12-12','09:10:00',1.08),('15844','2013-12-12','09:15:00',1.14),('15844','2013-12-12','09:20:00',1.19),('15844','2013-12-12','09:25:00',1.23),('15844','2013-12-12','09:30:00',1.26),('15844','2013-12-12','09:35:00',1.3),('15844','2013-12-12','09:40:00',1.34),('15844','2013-12-12','09:45:00',1.38),('15844','2013-12-12','09:50:00',1.43),('15844','2013-12-12','09:55:00',1.47),('15844','2013-12-12','10:00:00',1.5),('15844','2013-12-12','10:05:00',1.54),('15844','2013-12-12','10:10:00',1.57),('15844','2013-12-12','10:15:00',1.59),('15844','2013-12-12','10:20:00',1.62),('15844','2013-12-12','10:25:00',1.67),('15844','2013-12-12','10:30:00',1.69),('15844','2013-12-12','10:35:00',1.71),('15844','2013-12-12','10:40:00',1.74),('15844','2013-12-12','10:45:00',1.74),('15844','2013-12-12','10:50:00',1.76),('15844','2013-12-12','10:55:00',1.76),('15844','2013-12-12','11:00:00',1.78),('15844','2013-12-12','11:05:00',1.77),('15844','2013-12-12','11:10:00',1.78),('15844','2013-12-12','11:15:00',1.77),('15844','2013-12-12','11:20:00',1.77),('15844','2013-12-12','11:25:00',1.77),('15844','2013-12-12','11:30:00',1.76),('15844','2013-12-12','11:35:00',1.74),('15844','2013-12-12','11:40:00',1.72),('15844','2013-12-12','11:45:00',1.7),('15844','2013-12-12','11:50:00',1.67),('15844','2013-12-12','11:55:00',1.69),('15844','2013-12-12','12:00:00',1.67),('15844','2013-12-12','12:05:00',1.61),('15844','2013-12-12','12:10:00',1.56),('15844','2013-12-12','12:15:00',1.53),('15844','2013-12-12','12:20:00',1.5),('15844','2013-12-12','12:25:00',1.46),('15844','2013-12-12','12:30:00',1.42),('15844','2013-12-12','12:35:00',1.4),('15844','2013-12-12','12:40:00',1.37),('15844','2013-12-12','12:45:00',1.3),('15844','2013-12-12','12:50:00',1.24),('15844','2013-12-12','12:55:00',1.21),('15844','2013-12-12','13:00:00',1.17),('15844','2013-12-12','13:05:00',1.1),('15844','2013-12-12','13:10:00',1.03),('15844','2013-12-11','09:00:00',1.01),('15844','2013-12-11','09:05:00',1.08),('15844','2013-12-11','09:10:00',1.12),('15844','2013-12-11','09:15:00',1.16),('15844','2013-12-11','09:20:00',1.22),('15844','2013-12-11','09:25:00',1.26),('15844','2013-12-11','09:30:00',1.3),('15844','2013-12-11','09:35:00',1.36),('15844','2013-12-11','09:40:00',1.42),('15844','2013-12-11','09:45:00',1.47),('15844','2013-12-11','09:50:00',1.52),('15844','2013-12-11','09:55:00',1.57),('15844','2013-12-11','10:00:00',1.6),('15844','2013-12-11','10:05:00',1.62),('15844','2013-12-11','10:10:00',1.65),('15844','2013-12-11','10:15:00',1.67),('15844','2013-12-11','10:20:00',1.69),('15844','2013-12-11','10:25:00',1.71),('15844','2013-12-11','10:30:00',1.77),('15844','2013-12-11','10:35:00',1.79),('15844','2013-12-11','10:40:00',1.82),('15844','2013-12-11','10:45:00',1.86),('15844','2013-12-11','10:50:00',1.86),('15844','2013-12-11','10:55:00',1.88),('15844','2013-12-11','11:00:00',1.89),('15844','2013-12-11','11:05:00',1.89),('15844','2013-12-11','11:10:00',1.86),('15844','2013-12-11','11:15:00',1.85),('15844','2013-12-11','11:20:00',1.86),('15844','2013-12-11','11:25:00',1.84),('15844','2013-12-11','11:30:00',1.85),('15844','2013-12-11','11:35:00',1.84),('15844','2013-12-11','11:40:00',1.82),('15844','2013-12-11','11:45:00',1.8),('15844','2013-12-11','11:50:00',1.79),('15844','2013-12-11','11:55:00',1.76),('15844','2013-12-11','12:00:00',1.75),('15844','2013-12-11','12:05:00',1.73),('15844','2013-12-11','12:10:00',1.67),('15844','2013-12-11','12:15:00',1.66),('15844','2013-12-11','12:20:00',1.61),('15844','2013-12-11','12:25:00',1.56),('15844','2013-12-11','12:30:00',1.52),('15844','2013-12-11','12:35:00',1.47),('15844','2013-12-11','12:40:00',1.41),('15844','2013-12-11','12:45:00',1.38),('15844','2013-12-11','12:50:00',1.34),('15844','2013-12-11','12:55:00',1.28),('15844','2013-12-11','13:00:00',1.2),('15844','2013-12-11','13:05:00',1.14),('15844','2013-12-11','13:10:00',1.07),('15844','2013-12-11','13:15:00',1.02),('15844','2013-12-10','09:00:00',1.03),('15844','2013-12-10','09:05:00',1.1),('15844','2013-12-10','09:10:00',1.15),('15844','2013-12-10','09:15:00',1.23),('15844','2013-12-10','09:20:00',1.27),('15844','2013-12-10','09:25:00',1.29),('15844','2013-12-10','09:30:00',1.33),('15844','2013-12-10','09:35:00',1.38),('15844','2013-12-10','09:40:00',1.44),('15844','2013-12-10','09:45:00',1.47),('15844','2013-12-10','09:50:00',1.53),('15844','2013-12-10','09:55:00',1.55),('15844','2013-12-10','10:00:00',1.6),('15844','2013-12-10','10:05:00',1.64),('15844','2013-12-10','10:10:00',1.66),('15844','2013-12-10','10:15:00',1.71),('15844','2013-12-10','10:20:00',1.72),('15844','2013-12-10','10:25:00',1.77),('15844','2013-12-10','10:30:00',1.78),('15844','2013-12-10','10:35:00',1.82),('15844','2013-12-10','10:40:00',1.84),('15844','2013-12-10','10:45:00',1.84),('15844','2013-12-10','10:50:00',1.86),('15844','2013-12-10','10:55:00',1.88),('15844','2013-12-10','11:00:00',1.88),('15844','2013-12-10','11:05:00',1.89),('15844','2013-12-10','11:10:00',1.91),('15844','2013-12-10','11:15:00',1.9),('15844','2013-12-10','11:20:00',1.9),('15844','2013-12-10','11:25:00',1.89),('15844','2013-12-10','11:30:00',1.9),('15844','2013-12-10','11:35:00',1.88),('15844','2013-12-10','11:40:00',1.87),('15844','2013-12-10','11:45:00',1.86),('15844','2013-12-10','11:50:00',1.83),('15844','2013-12-10','11:55:00',1.8),('15844','2013-12-10','12:00:00',1.77),('15844','2013-12-10','12:05:00',1.74),('15844','2013-12-10','12:10:00',1.72),('15844','2013-12-10','12:15:00',1.67),('15844','2013-12-10','12:20:00',1.58),('15844','2013-12-10','12:25:00',1.52),('15844','2013-12-10','12:30:00',1.48),('15844','2013-12-10','12:35:00',1.46),('15844','2013-12-10','12:40:00',1.42),('15844','2013-12-10','12:45:00',1.37),('15844','2013-12-10','12:50:00',1.33),('15844','2013-12-10','12:55:00',1.27),('15844','2013-12-10','13:00:00',1.2),('15844','2013-12-10','13:05:00',1.13),('15844','2013-12-10','13:10:00',1.07),('15844','2013-12-10','13:15:00',1),('15844','2013-12-09','09:20:00',1.24),('15844','2013-12-09','09:25:00',1.36),('15844','2013-12-09','09:30:00',1.38),('15844','2013-12-09','09:35:00',1.4),('15844','2013-12-09','09:40:00',1.43),('15844','2013-12-09','09:45:00',1.49),('15844','2013-12-09','09:50:00',1.59),('15844','2013-12-09','09:55:00',1.48),('15844','2013-12-09','10:00:00',1.53),('15844','2013-12-09','10:05:00',2.08),('15844','2013-12-09','10:10:00',1.2),('15844','2013-12-09','12:25:00',1.11),('15844','2013-12-09','12:30:00',1.87),('15844','2013-12-09','12:35:00',1.12),('15844','2013-12-09','12:45:00',1.45),('15844','2013-12-09','12:50:00',1.71),('15844','2013-12-09','12:55:00',1.29),('15844','2013-12-09','13:00:00',1.29),('15844','2013-12-09','13:10:00',1.57),('15844','2013-12-09','13:15:00',1.16),('15844','2013-12-09','13:20:00',1.12),('15844','2013-12-08','11:25:00',1.13),('15844','2013-12-08','11:30:00',1.08),('15844','2013-12-08','11:35:00',1.07),('15844','2013-12-08','11:40:00',1.07),('15844','2013-12-08','12:00:00',1.02),('15844','2014-04-21','08:45:00',1.1),('15844','2014-04-21','08:50:00',1.05),('15844','2014-04-21','08:55:00',1.34),('15844','2014-04-21','09:00:00',1.32),('15844','2014-04-21','09:05:00',1.06),('15844','2014-04-21','09:10:00',1.1),('15844','2014-04-21','09:15:00',1.16),('15844','2014-04-21','09:20:00',1.44),('15844','2014-04-21','09:25:00',1.28),('15844','2014-04-21','09:35:00',1.12),('15844','2014-04-21','09:40:00',1.39),('15844','2014-04-21','09:50:00',1),('15844','2014-04-21','09:55:00',1.03),('15844','2014-04-21','10:00:00',1.14),('15844','2014-04-21','10:05:00',2.09),('15844','2014-04-21','10:10:00',3.28),('15844','2014-04-21','10:15:00',3.32),('15844','2014-04-21','10:20:00',3.24),('15844','2014-04-21','10:25:00',3.23),('15844','2014-04-21','10:30:00',3.26),('15844','2014-04-21','10:35:00',3.35),('15844','2014-04-21','10:40:00',3.43),('15844','2014-04-21','10:45:00',3.52),('15844','2014-04-21','10:50:00',3.62),('15844','2014-04-21','10:55:00',3.72),('15844','2014-04-21','11:00:00',3.77),('15844','2014-04-21','11:05:00',3.81),('15844','2014-04-21','11:10:00',3.83),('15844','2014-04-21','11:15:00',3.84),('15844','2014-04-21','11:20:00',3.84),('15844','2014-04-21','11:25:00',3.9),('15844','2014-04-21','11:30:00',3.92),('15844','2014-04-21','11:35:00',3.94),('15844','2014-04-21','11:40:00',3.98),('15844','2014-04-21','11:45:00',3.97),('15844','2014-04-21','11:50:00',4.01),('15844','2014-04-21','11:55:00',3.99),('15844','2014-04-21','12:00:00',3.99),('15844','2014-04-21','12:05:00',4.01),('15844','2014-04-21','12:10:00',4.02),('15844','2014-04-21','12:15:00',4.03),('15844','2014-04-21','12:20:00',4.02),('15844','2014-04-21','12:25:00',4.01),('15844','2014-04-21','12:30:00',3.99),('15844','2014-04-21','12:35:00',4),('15844','2014-04-21','12:40:00',3.96),('15844','2014-04-21','12:45:00',3.94),('15844','2014-04-21','12:50:00',3.93),('15844','2014-04-21','12:55:00',3.92),('15844','2014-04-21','13:00:00',3.9),('15844','2014-04-21','13:05:00',3.88),('15844','2014-04-21','13:10:00',3.84),('15844','2014-04-21','13:15:00',3.82),('15844','2014-04-21','13:20:00',3.81),('15844','2014-04-21','13:25:00',3.78),('15844','2014-04-21','13:30:00',3.76),('15844','2014-04-21','13:35:00',3.74),('15844','2014-04-21','13:40:00',3.7),('15844','2014-04-21','13:45:00',3.66),('15844','2014-04-21','13:50:00',3.57),('15844','2014-04-21','13:55:00',3.52),('15844','2014-04-21','14:00:00',3.44),('15844','2014-04-21','14:05:00',3.37),('15844','2014-04-21','14:10:00',3.32),('15844','2014-04-21','14:15:00',3.25),('15844','2014-04-21','14:20:00',3.17),('15844','2014-04-21','14:25:00',3.08),('15844','2014-04-21','14:30:00',2.97),('15844','2014-04-21','14:35:00',2.88),('15844','2014-04-21','14:40:00',2.8),('15844','2014-04-21','14:45:00',2.73),('15844','2014-04-21','14:50:00',2.63),('15844','2014-04-21','14:55:00',2.54),('15844','2014-04-21','15:00:00',2.46),('15844','2014-04-21','15:05:00',2.37),('15844','2014-04-21','15:10:00',2.3),('15844','2014-04-21','15:15:00',2.21),('15844','2014-04-21','15:20:00',2.11),('15844','2014-04-21','15:25:00',2.03),('15844','2014-04-21','15:30:00',1.93),('15844','2014-04-21','15:35:00',1.83),('15844','2014-04-21','15:40:00',1.73),('15844','2014-04-21','15:45:00',1.62),('15844','2014-04-21','15:50:00',1.51),('15844','2014-04-21','15:55:00',1.39),('15844','2014-04-21','16:00:00',1.34),('15844','2014-04-21','16:05:00',1.28),('15844','2014-04-21','16:10:00',1.25),('15844','2014-04-21','16:15:00',1.2),('15844','2014-04-21','16:20:00',1.13),('15844','2014-04-21','16:25:00',1.05),('15844','2013-12-07','09:00:00',1.01),('15844','2013-12-07','09:05:00',1.07),('15844','2013-12-07','09:10:00',1.13),('15844','2013-12-07','09:15:00',1.17),('15844','2013-12-07','09:20:00',1.22),('15844','2013-12-07','09:25:00',1.26),('15844','2013-12-07','09:30:00',1.3),('15844','2013-12-07','09:35:00',1.35),('15844','2013-12-07','09:40:00',1.38),('15844','2013-12-07','09:45:00',1.41),('15844','2013-12-07','09:50:00',1.46),('15844','2013-12-07','09:55:00',1.5),('15844','2013-12-07','10:00:00',1.53),('15844','2013-12-07','10:05:00',1.56),('15844','2013-12-07','10:10:00',1.6),('15844','2013-12-07','10:15:00',1.64),('15844','2013-12-07','10:20:00',1.66),('15844','2013-12-07','10:25:00',1.67),('15844','2013-12-07','10:30:00',1.72),('15844','2013-12-07','10:35:00',1.75),('15844','2013-12-07','10:40:00',1.78),('15844','2013-12-07','10:45:00',1.83),('15844','2013-12-07','10:50:00',1.81),('15844','2013-12-07','10:55:00',1.82),('15844','2013-12-07','11:00:00',1.82),('15844','2013-12-07','11:05:00',1.8),('15844','2013-12-07','11:10:00',1.79),('15844','2013-12-07','11:15:00',1.81),('15844','2013-12-07','11:20:00',1.8),('15844','2013-12-07','11:25:00',1.78),('15844','2013-12-07','11:30:00',1.77),('15844','2013-12-07','11:35:00',1.75),('15844','2013-12-07','11:40:00',1.74),('15844','2013-12-07','11:45:00',1.71),('15844','2013-12-07','11:50:00',1.69),('15844','2013-12-07','11:55:00',1.63),('15844','2013-12-07','12:00:00',1.62),('15844','2013-12-07','12:05:00',1.61),('15844','2013-12-07','12:10:00',1.58),('15844','2013-12-07','12:15:00',1.55),('15844','2013-12-07','12:20:00',1.51),('15844','2013-12-07','12:25:00',1.48),('15844','2013-12-07','12:30:00',1.43),('15844','2013-12-07','12:35:00',1.39),('15844','2013-12-07','12:40:00',1.35),('15844','2013-12-07','12:45:00',1.3),('15844','2013-12-07','12:50:00',1.26),('15844','2013-12-07','12:55:00',1.23),('15844','2013-12-07','13:00:00',1.18),('15844','2013-12-07','13:05:00',1.12),('15844','2013-12-07','13:10:00',1.05),('15844','2013-12-07','13:15:00',1),('15844','2013-12-06','11:35:00',1.08),('15844','2013-12-06','11:50:00',1.25),('15844','2013-12-06','11:55:00',1.66),('15844','2013-12-06','12:00:00',1.04),('15844','2013-12-06','12:05:00',1.2),('15844','2013-12-06','12:10:00',1.55),('15844','2013-12-06','12:15:00',1.08),('15844','2013-12-06','12:20:00',1.29),('15844','2013-12-06','12:25:00',1.63),('15844','2013-12-06','12:30:00',1.29),('15844','2013-12-06','12:35:00',1.02),('15844','2013-12-05','08:55:00',1.04),('15844','2013-12-05','09:00:00',1.08),('15844','2013-12-05','09:05:00',1.15),('15844','2013-12-05','09:10:00',1.21),('15844','2013-12-05','09:15:00',1.27),('15844','2013-12-05','09:20:00',1.32),('15844','2013-12-05','09:25:00',1.37),('15844','2013-12-05','09:30:00',1.41),('15844','2013-12-05','09:35:00',1.44),('15844','2013-12-05','09:40:00',1.49),('15844','2013-12-05','09:45:00',1.51),('15844','2013-12-05','09:50:00',1.55),('15844','2013-12-05','09:55:00',1.6),('15844','2013-12-05','10:00:00',1.63),('15844','2013-12-05','10:05:00',1.67),('15844','2013-12-05','10:10:00',1.72),('15844','2013-12-05','10:15:00',1.73),('15844','2013-12-05','10:20:00',1.74),('15844','2013-12-05','10:25:00',1.79),('15844','2013-12-05','10:30:00',1.81),('15844','2013-12-05','10:35:00',1.83),('15844','2013-12-05','10:40:00',1.87),('15844','2013-12-05','10:45:00',1.87),('15844','2013-12-05','10:50:00',1.89),('15844','2013-12-05','10:55:00',1.87),('15844','2013-12-05','11:00:00',1.89),('15844','2013-12-05','11:05:00',1.93),('15844','2013-12-05','11:10:00',1.88),('15844','2013-12-05','11:15:00',1.91),('15844','2013-12-05','11:20:00',1.85),('15844','2013-12-05','11:25:00',1.88),('15844','2013-12-05','11:30:00',1.85),('15844','2013-12-05','11:35:00',1.84),('15844','2013-12-05','11:40:00',1.79),('15844','2013-12-05','11:45:00',1.76),('15844','2013-12-05','11:50:00',1.78),('15844','2013-12-05','11:55:00',1.75),('15844','2013-12-05','12:00:00',1.73),('15844','2013-12-05','12:05:00',1.68),('15844','2013-12-05','12:10:00',1.66),('15844','2013-12-05','12:15:00',1.56),('15844','2013-12-05','12:20:00',1.6),('15844','2013-12-05','12:25:00',1.46),('15844','2013-12-05','12:30:00',1.52),('15844','2013-12-05','12:35:00',1.46),('15844','2013-12-05','12:40:00',1.17),('15844','2013-12-05','12:45:00',1.3),('15844','2013-12-05','12:50:00',1.31),('15844','2013-12-05','12:55:00',1.23),('15844','2013-12-05','13:00:00',1.17),('15844','2013-12-05','13:05:00',1.11),('15844','2013-12-05','13:10:00',1.08),('15844','2013-12-04','08:45:00',1.04),('15844','2013-12-04','08:50:00',1.09),('15844','2013-12-04','08:55:00',1.15),('15844','2013-12-04','09:00:00',1.22),('15844','2013-12-04','09:05:00',1.27),('15844','2013-12-04','09:10:00',1.32),('15844','2013-12-04','09:15:00',1.38),('15844','2013-12-04','09:20:00',1.43),('15844','2013-12-04','09:25:00',1.48),('15844','2013-12-04','09:30:00',1.51),('15844','2013-12-04','09:35:00',1.56),('15844','2013-12-04','09:40:00',1.6),('15844','2013-12-04','09:45:00',1.64),('15844','2013-12-04','09:50:00',1.69),('15844','2013-12-04','09:55:00',1.74),('15844','2013-12-04','10:00:00',1.78),('15844','2013-12-04','10:05:00',1.8),('15844','2013-12-04','10:10:00',1.84),('15844','2013-12-04','10:15:00',1.86),('15844','2013-12-04','10:20:00',1.88),('15844','2013-12-04','10:25:00',1.91),('15844','2013-12-04','10:30:00',1.96),('15844','2013-12-04','10:35:00',1.97),('15844','2013-12-04','10:40:00',2.01),('15844','2013-12-04','10:45:00',2.03),('15844','2013-12-04','10:50:00',2.03),('15844','2013-12-04','10:55:00',2.04),('15844','2013-12-04','11:00:00',2.04),('15844','2013-12-04','11:05:00',2.02),('15844','2013-12-04','11:10:00',2.02),('15844','2013-12-04','11:15:00',2.02),('15844','2013-12-04','11:20:00',2.02),('15844','2013-12-04','11:25:00',1.99),('15844','2013-12-04','11:30:00',1.98),('15844','2013-12-04','11:35:00',1.96),('15844','2013-12-04','11:40:00',1.93),('15844','2013-12-04','11:45:00',1.91),('15844','2013-12-04','11:50:00',1.89),('15844','2013-12-04','11:55:00',1.86),('15844','2013-12-04','12:00:00',1.83),('15844','2013-12-04','12:05:00',1.81),('15844','2013-12-04','12:10:00',1.78),('15844','2013-12-04','12:15:00',1.75),('15844','2013-12-04','12:20:00',1.7),('15844','2013-12-04','12:25:00',1.66),('15844','2013-12-04','12:30:00',1.61),('15844','2013-12-04','12:35:00',1.55),('15844','2013-12-04','12:40:00',1.48),('15844','2013-12-04','12:45:00',1.43),('15844','2013-12-04','12:50:00',1.38),('15844','2013-12-04','12:55:00',1.3),('15844','2013-12-04','13:00:00',1.24),('15844','2013-12-04','13:05:00',1.18),('15844','2013-12-04','13:10:00',1.12),('15844','2013-12-04','13:15:00',1.05),('15844','2013-12-04','13:20:00',1.01),('15844','2013-12-03','09:30:00',1.08),('15844','2013-12-03','09:35:00',1.27),('15844','2013-12-03','09:40:00',1.37),('15844','2013-12-03','09:45:00',1.34),('15844','2013-12-03','09:50:00',1.67),('15844','2013-12-03','09:55:00',1.7),('15844','2013-12-03','10:00:00',1.73),('15844','2013-12-03','10:05:00',1.74),('15844','2013-12-03','10:10:00',1.79),('15844','2013-12-03','10:15:00',1.82),('15844','2013-12-03','10:20:00',1.85),('15844','2013-12-03','10:25:00',1.9),('15844','2013-12-03','10:30:00',1.94),('15844','2013-12-03','10:35:00',1.97),('15844','2013-12-03','10:40:00',1.98),('15844','2013-12-03','10:45:00',2.01),('15844','2013-12-03','10:50:00',2.04),('15844','2013-12-03','10:55:00',2.04),('15844','2013-12-03','11:00:00',2.04),('15844','2013-12-03','11:05:00',2.06),('15844','2013-12-03','11:10:00',2.05),('15844','2013-12-03','11:15:00',2.04),('15844','2013-12-03','11:20:00',2.02),('15844','2013-12-03','11:25:00',2.03),('15844','2013-12-03','11:30:00',2.02),('15844','2013-12-03','11:35:00',2.01),('15844','2013-12-03','11:40:00',1.99),('15844','2013-12-03','11:45:00',1.97),('15844','2013-12-03','11:50:00',1.94),('15844','2013-12-03','11:55:00',1.93),('15844','2013-12-03','12:00:00',1.91),('15844','2013-12-03','12:05:00',1.9),('15844','2013-12-03','12:10:00',1.88),('15844','2013-12-03','12:15:00',1.86),('15844','2013-12-03','12:20:00',1.83),('15844','2013-12-03','12:25:00',1.8),('15844','2013-12-03','12:30:00',1.79),('15844','2013-12-03','12:35:00',1.78),('15844','2013-12-03','12:40:00',1.78),('15844','2013-12-03','12:45:00',1.78),('15844','2013-12-03','12:50:00',1.78),('15844','2013-12-03','12:55:00',1.82),('15844','2013-12-03','13:00:00',1.83),('15844','2013-12-03','13:05:00',1.81),('15844','2013-12-03','13:10:00',1.73),('15844','2013-12-03','13:15:00',1.64),('15844','2013-12-03','13:20:00',1.53),('15844','2013-12-03','13:25:00',1.32),('15844','2013-12-03','13:30:00',1.07),('15844','2013-12-01','11:35:00',1.23),('15844','2013-12-01','11:40:00',1.39),('15844','2013-12-01','11:45:00',1.16),('15844','2013-12-01','11:50:00',1.04),('15844','2013-12-01','11:55:00',1.33),('15844','2013-12-01','12:00:00',1.36),('15844','2013-12-01','12:05:00',1.29),('15844','2013-12-01','12:10:00',1.49),('15844','2013-12-01','12:15:00',1.08),('15844','2013-12-01','12:50:00',1.08),('15844','2013-11-30','09:10:00',1.22),('15844','2013-11-30','09:15:00',1.21),('15844','2013-11-30','09:20:00',1.4),('15844','2013-11-30','09:25:00',1.34),('15844','2013-11-30','09:30:00',1.49),('15844','2013-11-30','09:35:00',1.47),('15844','2013-11-30','09:40:00',1.39),('15844','2013-11-30','09:45:00',1.11),('15844','2013-11-30','09:50:00',1.06),('15844','2013-11-30','10:25:00',1),('15844','2013-11-30','10:40:00',1.19),('15844','2013-11-30','11:10:00',1.05),('15844','2013-11-30','11:15:00',1.05),('15844','2013-11-30','11:20:00',1.03),('15844','2013-11-30','11:25:00',1.07),('15844','2013-11-29','08:40:00',1.02),('15844','2013-11-29','08:45:00',1.07),('15844','2013-11-29','08:50:00',1.14),('15844','2013-11-29','08:55:00',1.18),('15844','2013-11-29','09:00:00',1.24),('15844','2013-11-29','09:05:00',1.31),('15844','2013-11-29','09:10:00',1.36),('15844','2013-11-29','09:15:00',1.42),('15844','2013-11-29','09:20:00',1.48),('15844','2013-11-29','09:25:00',1.53),('15844','2013-11-29','09:30:00',1.58),('15844','2013-11-29','09:35:00',1.62),('15844','2013-11-29','09:40:00',1.67),('15844','2013-11-29','09:45:00',1.72),('15844','2013-11-29','09:50:00',1.76),('15844','2013-11-29','09:55:00',1.79),('15844','2013-11-29','10:00:00',1.84),('15844','2013-11-29','10:05:00',1.87),('15844','2013-11-29','10:10:00',1.9),('15844','2013-11-29','10:15:00',1.93),('15844','2013-11-29','10:20:00',1.98),('15844','2013-11-29','10:25:00',2.01),('15844','2013-11-29','10:30:00',2.05),('15844','2013-11-29','10:35:00',2.07),('15844','2013-11-29','10:40:00',2.09),('15844','2013-11-29','10:45:00',2.11),('15844','2013-11-29','10:50:00',2.12),('15844','2013-11-29','10:55:00',2.11),('15844','2013-11-29','11:00:00',2.12),('15844','2013-11-29','11:05:00',2.12),('15844','2013-11-29','11:10:00',2.1),('15844','2013-11-29','11:15:00',2.09),('15844','2013-11-29','11:20:00',2.1),('15844','2013-11-29','11:25:00',2.08),('15844','2013-11-29','11:30:00',2.06),('15844','2013-11-29','11:35:00',2.05),('15844','2013-11-29','11:40:00',2.03),('15844','2013-11-29','11:45:00',2.02),('15844','2013-11-29','11:50:00',1.99),('15844','2013-11-29','11:55:00',1.96),('15844','2013-11-29','12:00:00',1.93),('15844','2013-11-29','12:05:00',1.9),('15844','2013-11-29','12:10:00',1.87),('15844','2013-11-29','12:15:00',1.81),('15844','2013-11-29','12:20:00',1.77),('15844','2013-11-29','12:25:00',1.71),('15844','2013-11-29','12:30:00',1.65),('15844','2013-11-29','12:35:00',1.61),('15844','2013-11-29','12:40:00',1.55),('15844','2013-11-29','12:45:00',1.48),('15844','2013-11-29','12:50:00',1.41),('15844','2013-11-29','12:55:00',1.35),('15844','2013-11-29','13:00:00',1.29),('15844','2013-11-29','13:05:00',1.24),('15844','2013-11-29','13:10:00',1.18),('15844','2013-11-29','13:15:00',1.11),('15844','2013-11-29','13:20:00',1.06),('15844','2014-04-20','08:20:00',1.2),('15844','2014-04-20','08:25:00',1.35),('15844','2014-04-20','08:30:00',1.43),('15844','2014-04-20','08:50:00',1.09),('15844','2014-04-20','08:55:00',1.56),('15844','2014-04-20','09:00:00',1.18),('15844','2014-04-20','09:10:00',1.92),('15844','2014-04-20','09:15:00',1.85),('15844','2014-04-20','09:20:00',1.81),('15844','2014-04-20','09:25:00',2.26),('15844','2014-04-20','09:30:00',2.42),('15844','2014-04-20','09:35:00',2.93),('15844','2014-04-20','09:40:00',2.21),('15844','2014-04-20','09:45:00',1.78),('15844','2014-04-20','09:50:00',1.53),('15844','2014-04-20','09:55:00',1.81),('15844','2014-04-20','10:00:00',1.94),('15844','2014-04-20','10:05:00',2.3),('15844','2014-04-20','10:10:00',1.7),('15844','2014-04-20','10:15:00',2.49),('15844','2014-04-20','10:20:00',3.03),('15844','2014-04-20','10:25:00',2.61),('15844','2014-04-20','10:30:00',2.34),('15844','2014-04-20','10:35:00',2.55),('15844','2014-04-20','10:40:00',2.37),('15844','2014-04-20','10:45:00',2.43),('15844','2014-04-20','10:50:00',2.66),('15844','2014-04-20','10:55:00',3.3),('15844','2014-04-20','11:00:00',3.14),('15844','2014-04-20','11:05:00',3.37),('15844','2014-04-20','11:10:00',3.82),('15844','2014-04-20','11:15:00',4.12),('15844','2014-04-20','11:20:00',4.26),('15844','2014-04-20','11:25:00',4.15),('15844','2014-04-20','11:30:00',4.42),('15844','2014-04-20','11:35:00',4.24),('15844','2014-04-20','11:40:00',4.24),('15844','2014-04-20','11:45:00',4.26),('15844','2014-04-20','11:50:00',4.15),('15844','2014-04-20','11:55:00',4.23),('15844','2014-04-20','12:00:00',4.2),('15844','2014-04-20','12:05:00',4.23),('15844','2014-04-20','12:10:00',4.18),('15844','2014-04-20','12:15:00',4.22),('15844','2014-04-20','12:20:00',4.21),('15844','2014-04-20','12:25:00',4.28),('15844','2014-04-20','12:30:00',4.21),('15844','2014-04-20','12:35:00',4.25),('15844','2014-04-20','12:40:00',2.69),('15844','2014-04-20','12:45:00',4.21),('15844','2014-04-20','12:50:00',4.18),('15844','2014-04-20','12:55:00',3.95),('15844','2014-04-20','13:00:00',4.04),('15844','2014-04-20','13:05:00',4.06),('15844','2014-04-20','13:10:00',3.46),('15844','2014-04-20','13:15:00',3.98),('15844','2014-04-20','13:20:00',3.94),('15844','2014-04-20','13:25:00',3.88),('15844','2014-04-20','13:30:00',3.86),('15844','2014-04-20','13:35:00',3.81),('15844','2014-04-20','13:40:00',3.78),('15844','2014-04-20','13:45:00',3.7),('15844','2014-04-20','13:50:00',3.6),('15844','2014-04-20','13:55:00',3.53),('15844','2014-04-20','14:00:00',3.48),('15844','2014-04-20','14:05:00',3.47),('15844','2014-04-20','14:10:00',3.47),('15844','2014-04-20','14:15:00',3.07),('15844','2014-04-20','14:20:00',2.15),('15844','2014-04-20','14:25:00',2.27),('15844','2014-04-20','14:30:00',2.07),('15844','2014-04-20','14:35:00',1.92),('15844','2014-04-20','14:40:00',1.96),('15844','2014-04-20','14:45:00',2.08),('15844','2014-04-20','14:50:00',2.22),('15844','2014-04-20','14:55:00',2.45),('15844','2014-04-20','15:00:00',3.26),('15844','2014-04-20','15:05:00',2.69),('15844','2014-04-20','15:10:00',1.93),('15844','2014-04-20','15:15:00',2.28),('15844','2014-04-20','15:20:00',2.15),('15844','2014-04-20','15:25:00',2.05),('15844','2014-04-20','15:30:00',1.97),('15844','2014-04-20','15:35:00',1.9),('15844','2014-04-20','15:40:00',1.82),('15844','2014-04-20','15:45:00',1.09),('15844','2014-04-20','15:50:00',1.67),('15844','2014-04-20','15:55:00',1.35),('15844','2014-04-20','16:00:00',1.25),('15844','2014-04-20','16:05:00',1.18),('15844','2014-04-20','16:10:00',1.21),('15844','2014-04-20','16:15:00',1.2),('15844','2014-04-20','16:20:00',1.09),('15844','2014-04-20','16:25:00',1.1),('15844','2013-11-27','09:55:00',1.03),('15844','2013-11-27','10:05:00',1.02),('15844','2013-11-27','10:15:00',1.02),('15844','2013-11-27','10:20:00',1.01),('15844','2013-11-27','10:35:00',1),('15844','2013-11-27','10:40:00',1.01),('15844','2013-11-27','10:45:00',1.01),('15844','2013-11-27','11:00:00',1.11),('15844','2013-11-27','11:05:00',1.14),('15844','2013-11-27','11:10:00',1.12),('15844','2013-11-27','11:15:00',1.14),('15844','2013-11-27','11:20:00',1.1),('15844','2013-11-27','11:25:00',1.19),('15844','2013-11-27','11:30:00',1.29),('15844','2013-11-27','11:35:00',1.48),('15844','2013-11-27','11:40:00',1.47),('15844','2013-11-27','11:45:00',2.34),('15844','2013-11-27','11:50:00',2.13),('15844','2013-11-27','11:55:00',2.13),('15844','2013-11-27','12:00:00',1.76),('15844','2013-11-27','12:05:00',1.43),('15844','2013-11-27','12:10:00',1.36),('15844','2013-11-27','12:15:00',1.22),('15844','2013-11-27','12:20:00',1.21),('15844','2013-11-27','12:25:00',1.17),('15844','2013-11-27','12:30:00',1.13),('15844','2013-11-23','10:20:00',1.06),('15844','2013-11-23','10:25:00',1.46),('15844','2013-11-23','10:30:00',2.09),('15844','2013-11-23','10:35:00',1.98),('15844','2013-11-21','08:10:00',1.03),('15844','2013-11-21','09:45:00',1.48),('15844','2013-11-21','09:50:00',1.24),('15844','2013-11-21','09:55:00',1.87),('15844','2013-11-21','10:00:00',1.02),('15844','2013-11-21','10:05:00',2.03),('15844','2013-11-21','10:10:00',1.77),('15844','2013-11-21','10:15:00',1.5),('15844','2013-11-21','10:20:00',1.16),('15844','2013-11-21','10:25:00',2.24),('15844','2013-11-21','10:30:00',2.27),('15844','2013-11-21','10:35:00',2.3),('15844','2013-11-21','10:40:00',1.15),('15844','2013-11-21','11:00:00',1.11),('15844','2013-11-21','11:15:00',1.8),('15844','2013-11-21','11:20:00',2.22),('15844','2013-11-21','11:25:00',1.83),('15844','2013-11-21','11:30:00',1),('15844','2013-11-21','11:35:00',2.07),('15844','2013-11-21','11:40:00',2.07),('15844','2013-11-21','11:45:00',2.05),('15844','2013-11-21','11:50:00',2.03),('15844','2013-11-21','11:55:00',1.99),('15844','2013-11-21','12:00:00',2),('15844','2013-11-21','12:05:00',1.98),('15844','2013-11-21','12:10:00',1.95),('15844','2013-11-21','12:15:00',1.88),('15844','2013-11-21','12:20:00',1.66),('15844','2013-11-21','12:25:00',1.89),('15844','2013-11-21','12:30:00',2.03),('15844','2013-11-21','12:35:00',1.65),('15844','2013-11-21','12:40:00',2.24),('15844','2013-11-21','12:45:00',1.98),('15844','2013-11-21','12:50:00',1.09),('15844','2013-11-21','12:55:00',1.46),('15844','2013-11-20','08:55:00',1.22),('15844','2013-11-20','09:00:00',1.44),('15844','2013-11-20','09:05:00',1.48),('15844','2013-11-20','09:10:00',1.32),('15844','2013-11-20','09:15:00',1.69),('15844','2013-11-20','09:20:00',1.07),('15844','2013-11-20','11:20:00',1.07),('15844','2013-11-20','11:25:00',1.7),('15844','2013-11-20','11:30:00',1.6),('15844','2013-11-20','12:15:00',1.69),('15844','2013-11-20','12:20:00',1.62),('15844','2013-11-20','12:40:00',1.35),('15844','2013-11-20','12:45:00',1.16),('15844','2013-11-20','12:55:00',1.05),('15844','2013-11-20','13:00:00',1.4),('15844','2013-11-20','13:20:00',1.14),('15844','2013-11-20','13:25:00',1.02),('15844','2013-11-20','13:30:00',1.1),('15844','2013-11-19','09:35:00',1.81),('15844','2013-11-19','09:40:00',1.7),('15844','2013-11-19','09:45:00',1.83),('15844','2013-11-19','09:50:00',1.54),('15844','2013-11-19','09:55:00',1.59),('15844','2013-11-19','10:00:00',1.86),('15844','2013-11-19','10:05:00',1.93),('15844','2013-11-19','10:10:00',1.72),('15844','2013-11-19','11:15:00',1.3),('15844','2013-11-19','11:20:00',1.22),('15844','2013-11-19','11:30:00',1.93),('15844','2013-11-19','11:35:00',1.67),('15844','2013-11-19','11:40:00',1.57),('15844','2013-11-19','11:45:00',2.02),('15844','2013-11-19','11:50:00',1.95),('15844','2013-11-19','11:55:00',1.88),('15844','2013-11-19','12:00:00',1.93),('15844','2013-11-19','12:05:00',1.86),('15844','2013-11-19','12:10:00',1.81),('15844','2013-11-19','12:15:00',1.82),('15844','2013-11-19','12:20:00',1.41),('15844','2013-11-19','12:35:00',1.62),('15844','2013-11-19','12:40:00',1.69),('15844','2013-11-19','12:50:00',1.63),('15844','2013-11-19','13:30:00',1.37),('15844','2013-11-18','09:15:00',1.08),('15844','2013-11-18','09:20:00',1.45),('15844','2013-11-18','09:25:00',1.33),('15844','2013-11-18','09:30:00',1.7),('15844','2013-11-18','09:35:00',1.63),('15844','2013-11-18','10:00:00',1.02),('15844','2013-11-18','10:05:00',1.34),('15844','2013-11-18','10:10:00',1.42),('15844','2013-11-18','10:15:00',1.38),('15844','2013-11-18','10:20:00',1.1),('15844','2013-11-18','10:35:00',1.02),('15844','2013-11-18','10:40:00',1.08),('15844','2013-11-18','10:45:00',1.11),('15844','2013-11-18','11:50:00',1.05),('15844','2013-11-18','11:55:00',1.13),('15844','2013-11-18','12:00:00',1.15),('15844','2013-11-18','12:05:00',1.14),('15844','2013-11-18','12:10:00',1.13),('15844','2013-11-18','12:15:00',1.21),('15844','2013-11-18','12:20:00',1.34),('15844','2013-11-18','12:25:00',1.33),('15844','2013-11-18','12:30:00',1.23),('15844','2013-11-18','12:35:00',1.07),('15844','2014-04-19','08:15:00',1.03),('15844','2014-04-19','08:20:00',1.17),('15844','2014-04-19','08:25:00',1.19),('15844','2014-04-19','08:30:00',1.02),('15844','2014-04-19','08:35:00',1.22),('15844','2014-04-19','08:40:00',1.3),('15844','2014-04-19','09:20:00',1.17),('15844','2014-04-19','09:25:00',1.4),('15844','2014-04-19','09:30:00',1.03),('15844','2014-04-19','10:30:00',1.11),('15844','2014-04-19','10:35:00',1.39),('15844','2014-04-19','10:40:00',1.43),('15844','2014-04-19','10:45:00',1.45),('15844','2014-04-19','10:50:00',1.8),('15844','2014-04-19','10:55:00',1.88),('15844','2014-04-19','11:00:00',1.15),('15844','2014-04-19','11:05:00',1.36),('15844','2014-04-19','11:10:00',1.9),('15844','2014-04-19','11:15:00',2.61),('15844','2014-04-19','11:20:00',4.1),('15844','2014-04-19','11:25:00',4.97),('15844','2014-04-19','11:30:00',2.31),('15844','2014-04-19','11:35:00',2.71),('15844','2014-04-19','11:40:00',2.1),('15844','2014-04-19','11:45:00',1.47),('15844','2014-04-19','13:10:00',1.2),('15844','2014-04-19','13:15:00',1.19),('15844','2014-04-19','14:30:00',1.29),('15844','2014-04-19','14:35:00',1.35),('15844','2014-04-19','14:40:00',1.7),('15844','2014-04-19','14:45:00',1.3),('15844','2014-04-19','15:00:00',1.82),('15844','2014-04-19','15:25:00',1.24),('15844','2014-04-19','15:40:00',1.62),('15844','2014-04-19','15:45:00',1.69),('15844','2014-04-19','15:50:00',1.62),('15844','2014-04-19','15:55:00',1.94),('15844','2014-04-19','16:00:00',1.45),('15844','2014-04-19','16:05:00',1.22),('15844','2014-04-19','16:10:00',1.36),('15844','2014-04-19','16:15:00',1.64),('15844','2014-04-19','16:20:00',1.59),('15844','2014-04-19','16:25:00',1.83),('15844','2014-04-19','16:30:00',1.32),('15844','2014-04-19','17:05:00',1.11),('15844','2014-04-19','17:15:00',1.12),('15844','2013-11-17','08:50:00',1.01),('15844','2013-11-17','09:00:00',1.19),('15844','2013-11-17','09:05:00',1.46),('15844','2013-11-17','09:10:00',1.8),('15844','2013-11-17','09:15:00',1.67),('15844','2013-11-17','09:30:00',1.06),('15844','2013-11-17','09:35:00',1.67),('15844','2013-11-17','09:40:00',2.03),('15844','2013-11-17','09:45:00',1.93),('15844','2013-11-17','09:50:00',1.92),('15844','2013-11-17','09:55:00',1.95),('15844','2013-11-17','10:00:00',1.99),('15844','2013-11-17','10:05:00',2.01),('15844','2013-11-17','10:10:00',2.02),('15844','2013-11-17','10:15:00',2.07),('15844','2013-11-17','10:20:00',2.11),('15844','2013-11-17','10:25:00',2.13),('15844','2013-11-17','10:30:00',2.15),('15844','2013-11-17','10:35:00',2.15),('15844','2013-11-17','10:40:00',2.17),('15844','2013-11-17','10:45:00',2.18),('15844','2013-11-17','10:50:00',2.18),('15844','2013-11-17','10:55:00',2.17),('15844','2013-11-17','11:00:00',2.18),('15844','2013-11-17','11:05:00',2.15),('15844','2013-11-17','11:10:00',2.15),('15844','2013-11-17','11:15:00',2.15),('15844','2013-11-17','11:20:00',2.14),('15844','2013-11-17','11:25:00',2.13),('15844','2013-11-17','11:30:00',2.1),('15844','2013-11-17','11:35:00',2.07),('15844','2013-11-17','11:40:00',2.06),('15844','2013-11-17','11:45:00',2.04),('15844','2013-11-17','11:50:00',2.02),('15844','2013-11-17','11:55:00',1.98),('15844','2013-11-17','12:00:00',1.94),('15844','2013-11-17','12:05:00',1.91),('15844','2013-11-17','12:10:00',1.88),('15844','2013-11-17','12:15:00',1.84),('15844','2013-11-17','12:20:00',1.8),('15844','2013-11-17','12:25:00',1.74),('15844','2013-11-17','12:30:00',1.67),('15844','2013-11-17','12:35:00',1.62),('15844','2013-11-17','12:40:00',1.54),('15844','2013-11-17','12:45:00',1.5),('15844','2013-11-17','12:50:00',1.42),('15844','2013-11-17','12:55:00',1.35),('15844','2013-11-17','13:00:00',1.28),('15844','2013-11-17','13:05:00',1.21),('15844','2013-11-17','13:10:00',1.15),('15844','2013-11-17','13:15:00',1.11),('15844','2013-11-17','13:20:00',1.1),('15844','2013-11-17','13:25:00',1.08),('15844','2013-11-17','13:30:00',1.02),('15844','2013-11-16','13:05:00',1.01),('15844','2013-11-15','09:10:00',1.08),('15844','2013-11-15','09:45:00',1.06),('15844','2013-11-15','10:15:00',1.22),('15844','2013-11-15','10:20:00',1.17),('15844','2013-11-15','11:05:00',1.04),('15844','2013-11-15','11:10:00',1.11),('15844','2013-11-15','11:15:00',1.11),('15844','2013-11-15','11:30:00',1.3),('15844','2013-11-15','11:35:00',1.36),('15844','2013-11-15','11:40:00',1.33),('15844','2013-11-15','11:45:00',1.33),('15844','2013-11-15','11:50:00',1.08),('15844','2013-11-15','12:00:00',1.03),('15844','2013-11-14','08:45:00',1.26),('15844','2013-11-14','08:50:00',1.05),('15844','2013-11-14','08:55:00',1.39),('15844','2013-11-14','09:00:00',1.46),('15844','2013-11-14','09:05:00',1.3),('15844','2013-11-14','09:10:00',1.35),('15844','2013-11-14','09:15:00',1.63),('15844','2013-11-14','09:20:00',1.7),('15844','2013-11-14','09:25:00',1.7),('15844','2013-11-14','09:30:00',1.76),('15844','2013-11-14','09:35:00',1.81),('15844','2013-11-14','09:40:00',1.82),('15844','2013-11-14','09:45:00',1.86),('15844','2013-11-14','09:50:00',1.89),('15844','2013-11-14','09:55:00',1.87),('15844','2013-11-14','10:00:00',1.9),('15844','2013-11-14','10:05:00',1.96),('15844','2013-11-14','10:10:00',2.01),('15844','2013-11-14','10:15:00',1.99),('15844','2013-11-14','10:20:00',2.01),('15844','2013-11-14','10:25:00',2.01),('15844','2013-11-14','10:30:00',1.86),('15844','2013-11-14','10:35:00',2.04),('15844','2013-11-14','10:40:00',2.14),('15844','2013-11-14','10:45:00',2.17),('15844','2013-11-14','10:50:00',2.17),('15844','2013-11-14','10:55:00',2.22),('15844','2013-11-14','11:00:00',2.2),('15844','2013-11-14','11:05:00',2.23),('15844','2013-11-14','11:10:00',2.31),('15844','2013-11-14','11:15:00',2.2),('15844','2013-11-14','11:20:00',1.78),('15844','2013-11-14','11:25:00',2.03),('15844','2013-11-14','11:30:00',2.29),('15844','2013-11-14','11:35:00',1.99),('15844','2013-11-14','11:40:00',1.78),('15844','2013-11-14','11:45:00',1.79),('15844','2013-11-14','11:50:00',2.17),('15844','2013-11-14','11:55:00',2.71),('15844','2013-11-14','12:00:00',2.67),('15844','2013-11-14','12:05:00',1.12),('15844','2013-11-14','12:10:00',1.03),('15844','2013-11-14','12:15:00',1.06),('15844','2013-11-14','12:20:00',1),('15844','2013-11-14','12:35:00',1.08),('15844','2013-11-14','12:40:00',1.07),('15844','2013-11-14','12:45:00',1.03),('15844','2013-11-14','13:20:00',1.3),('15844','2013-11-14','13:25:00',1.36),('15844','2013-11-14','13:30:00',1.61),('15844','2013-11-14','13:40:00',1.17),('15844','2013-11-14','13:55:00',1.12),('15844','2013-11-13','10:05:00',1.41),('15844','2013-11-13','10:10:00',1.77),('15844','2013-11-13','10:15:00',1.15),('15844','2013-11-13','10:25:00',1.1),('15844','2013-11-13','11:10:00',2.32),('15844','2013-11-13','11:15:00',3.03),('15844','2013-11-13','11:20:00',2.37),('15844','2013-11-13','11:25:00',1.21),('15844','2013-11-13','12:00:00',1.16),('15844','2013-11-13','12:05:00',1.02),('15844','2013-11-12','11:25:00',1),('15844','2013-11-12','11:40:00',1.99),('15844','2013-11-12','11:45:00',1.38),('15844','2013-11-12','11:50:00',1.34),('15844','2013-11-12','12:00:00',1.39),('15844','2013-11-12','12:05:00',1.79),('15844','2013-11-12','12:30:00',1.69),('15844','2013-11-12','12:35:00',2.22),('15844','2013-11-12','12:40:00',1.61),('15844','2013-11-12','12:45:00',1.6),('15844','2013-11-12','12:50:00',1.38),('15844','2013-11-12','12:55:00',1.38),('15844','2013-11-12','13:00:00',1.35),('15844','2013-11-12','13:05:00',1.23),('15844','2013-11-12','13:10:00',1.14),('15844','2013-11-12','13:15:00',1.18),('15844','2013-11-12','13:20:00',1.21),('15844','2013-11-12','13:25:00',1.24),('15844','2013-11-12','13:30:00',1.46),('15844','2013-11-12','13:35:00',1.71),('15844','2013-11-12','13:40:00',1.7),('15844','2013-11-12','13:45:00',1.75),('15844','2013-11-12','13:50:00',1.39),('15844','2013-11-12','13:55:00',1.18),('15844','2013-11-12','14:00:00',1.54),('15844','2013-11-12','14:05:00',1.36),('15844','2013-11-12','14:10:00',1.23),('15844','2013-11-11','10:35:00',1.24),('15844','2013-11-11','11:10:00',2.56),('15844','2013-11-11','11:15:00',2.17),('15844','2013-11-11','11:20:00',2.35),('15844','2013-11-11','11:25:00',2.38),('15844','2013-11-11','11:30:00',1.07),('15844','2013-11-11','11:35:00',1.3),('15844','2013-11-11','11:40:00',1.93),('15844','2013-11-11','11:45:00',2.66),('15844','2013-11-11','11:50:00',1.28),('15844','2013-11-11','11:55:00',1.3),('15844','2013-11-11','12:00:00',2.7),('15844','2013-11-11','12:05:00',2.55),('15844','2013-11-11','12:10:00',2.39),('15844','2013-11-11','12:15:00',2.2),('15844','2013-11-11','12:20:00',1.98),('15844','2013-11-11','12:25:00',2.18),('15844','2013-11-11','12:30:00',2.15),('15844','2013-11-11','12:35:00',2.06),('15844','2013-11-11','12:40:00',1.4),('15844','2013-11-11','12:45:00',1.15),('15844','2013-11-11','12:50:00',1.75),('15844','2013-11-11','12:55:00',1.65),('15844','2013-11-11','13:10:00',1.15),('15844','2013-11-11','13:15:00',1.07),('15844','2013-11-10','07:55:00',1.09),('15844','2013-11-10','08:35:00',1.31),('15844','2013-11-10','08:40:00',1.01),('15844','2013-11-10','08:45:00',1.29),('15844','2013-11-10','08:50:00',1.15),('15844','2013-11-10','08:55:00',1.61),('15844','2013-11-10','09:00:00',1.53),('15844','2013-11-10','09:05:00',1.16),('15844','2013-11-10','09:10:00',1.29),('15844','2013-11-10','09:15:00',1.55),('15844','2013-11-10','09:20:00',1.76),('15844','2013-11-10','09:25:00',1.89),('15844','2013-11-10','09:30:00',1.69),('15844','2013-11-10','09:35:00',1.79),('15844','2013-11-10','09:40:00',1.86),('15844','2013-11-10','09:45:00',1.97),('15844','2013-11-10','09:50:00',2.19),('15844','2013-11-10','09:55:00',1.86),('15844','2013-11-10','10:00:00',2.16),('15844','2013-11-10','10:05:00',2.23),('15844','2013-11-10','10:10:00',1.95),('15844','2013-11-10','10:15:00',1.54),('15844','2013-11-10','10:20:00',1.32),('15844','2013-11-10','10:25:00',1.86),('15844','2013-11-10','10:30:00',2.33),('15844','2013-11-10','10:35:00',2.3),('15844','2013-11-10','10:40:00',2.09),('15844','2013-11-10','10:45:00',1.07),('15844','2013-11-10','10:50:00',1.81),('15844','2013-11-10','10:55:00',1.47),('15844','2013-11-10','11:00:00',1.15),('15844','2013-11-10','11:15:00',1.47),('15844','2013-11-10','11:20:00',1.18),('15844','2013-11-10','11:25:00',1.38),('15844','2013-11-10','11:30:00',1.05),('15844','2013-11-10','11:35:00',1.78),('15844','2013-11-10','11:40:00',1),('15844','2013-11-10','11:50:00',1.14),('15844','2013-11-10','12:00:00',2.35),('15844','2013-11-10','12:05:00',2.17),('15844','2013-11-10','12:10:00',2.11),('15844','2013-11-10','12:15:00',2.13),('15844','2013-11-10','12:20:00',2.47),('15844','2013-11-10','12:25:00',1.21),('15844','2013-11-10','12:30:00',2.22),('15844','2013-11-10','12:35:00',2),('15844','2013-11-10','12:40:00',1.74),('15844','2013-11-10','12:45:00',1.54),('15844','2013-11-10','12:55:00',1.15),('15844','2013-11-10','13:00:00',1.3),('15844','2013-11-10','13:05:00',1.09),('15844','2013-11-10','13:40:00',1.03),('15844','2013-11-10','13:50:00',1.04),('15844','2013-11-09','09:35:00',1.43),('15844','2013-11-09','09:40:00',1.46),('15844','2013-11-09','09:45:00',1.7),('15844','2013-11-09','09:50:00',2.11),('15844','2013-11-09','09:55:00',2.55),('15844','2013-11-09','10:00:00',1.87),('15844','2013-11-09','10:05:00',1.2),('15844','2013-11-09','10:10:00',1.36),('15844','2013-11-09','10:15:00',1.56),('15844','2013-11-09','10:20:00',1.91),('15844','2013-11-09','10:35:00',1.15),('15844','2013-11-09','10:40:00',1.1),('15844','2013-11-09','10:45:00',1.1),('15844','2013-11-09','10:50:00',1.65),('15844','2013-11-09','10:55:00',2.19),('15844','2013-11-09','11:00:00',1.26),('15844','2013-11-09','11:05:00',1.04),('15844','2013-11-09','11:10:00',1.5),('15844','2013-11-09','11:15:00',1.09),('15844','2013-11-09','11:25:00',2.97),('15844','2013-11-09','11:30:00',2.61),('15844','2013-11-09','11:35:00',2.28),('15844','2013-11-09','11:40:00',2.53),('15844','2013-11-09','11:45:00',2.52),('15844','2013-11-09','11:50:00',2.42),('15844','2013-11-09','11:55:00',2.86),('15844','2013-11-09','12:00:00',2.93),('15844','2013-11-09','12:05:00',1.68),('15844','2013-11-09','12:25:00',1.07),('15844','2013-11-09','12:30:00',1.11),('15844','2013-11-09','12:35:00',1.22),('15844','2013-11-09','12:40:00',2.2),('15844','2013-11-09','12:45:00',2.26),('15844','2013-11-09','12:50:00',2.07),('15844','2013-11-09','12:55:00',1.74),('15844','2013-11-09','13:00:00',1.18),('15844','2013-11-09','13:10:00',1.41),('15844','2013-11-09','13:15:00',1.56),('15844','2013-11-09','13:20:00',1.2),('15844','2013-11-08','09:00:00',1.38),('15844','2013-11-08','09:05:00',1.75),('15844','2013-11-08','09:10:00',1.03),('15844','2013-11-08','09:15:00',1.13),('15844','2013-11-08','09:35:00',1.46),('15844','2013-11-08','09:40:00',1.97),('15844','2013-11-08','09:45:00',1.49),('15844','2013-11-08','09:50:00',1.45),('15844','2013-11-08','10:00:00',1.34),('15844','2013-11-08','10:05:00',2.18),('15844','2013-11-08','10:10:00',2.27),('15844','2013-11-08','10:15:00',2.29),('15844','2013-11-08','10:20:00',2.4),('15844','2013-11-08','10:25:00',2.69),('15844','2013-11-08','10:30:00',2.72),('15844','2013-11-08','10:35:00',2.72),('15844','2013-11-08','10:40:00',2.54),('15844','2013-11-08','10:45:00',2.55),('15844','2013-11-08','10:50:00',1.88),('15844','2013-11-08','11:00:00',2.05),('15844','2013-11-08','11:05:00',2.98),('15844','2013-11-08','11:10:00',3.09),('15844','2013-11-08','11:15:00',2.63),('15844','2013-11-08','11:20:00',2.79),('15844','2013-11-08','11:40:00',2.39),('15844','2013-11-08','11:45:00',2.36),('15844','2013-11-08','11:50:00',1.57),('15844','2013-11-08','11:55:00',2.26),('15844','2013-11-08','12:00:00',1.98),('15844','2013-11-08','12:05:00',2.19),('15844','2013-11-08','12:10:00',2.2),('15844','2013-11-08','12:15:00',2.08),('15844','2013-11-08','12:20:00',2.09),('15844','2013-11-08','12:25:00',2.05),('15844','2013-11-08','12:30:00',1.97),('15844','2013-11-08','12:35:00',1.52),('15844','2013-11-08','13:05:00',1.46),('15844','2013-11-08','13:10:00',1.02),('15844','2013-11-08','13:15:00',1.08),('15844','2013-11-08','13:20:00',1.09),('15844','2013-11-08','13:25:00',1.15),('15844','2013-11-08','13:30:00',1.07),('15844','2013-11-08','13:35:00',1.03),('15844','2013-11-08','13:40:00',1.13),('15844','2013-11-08','13:45:00',1.01),('15844','2014-04-18','08:10:00',1.07),('15844','2014-04-18','08:40:00',1.14),('15844','2014-04-18','08:45:00',1.18),('15844','2014-04-18','08:50:00',1.2),('15844','2014-04-18','09:05:00',1.2),('15844','2014-04-18','09:10:00',2.14),('15844','2014-04-18','09:15:00',2.38),('15844','2014-04-18','09:20:00',2.32),('15844','2014-04-18','09:25:00',1.66),('15844','2014-04-18','09:30:00',1.98),('15844','2014-04-18','09:35:00',1.21),('15844','2014-04-18','09:40:00',1.02),('15844','2014-04-18','09:45:00',2.49),('15844','2014-04-18','09:50:00',2.22),('15844','2014-04-18','09:55:00',2.67),('15844','2014-04-18','10:00:00',1.55),('15844','2014-04-18','10:05:00',1.2),('15844','2014-04-18','10:10:00',1.19),('15844','2014-04-18','10:15:00',1.11),('15844','2014-04-18','10:20:00',1.25),('15844','2014-04-18','10:25:00',1.28),('15844','2014-04-18','10:30:00',1.06),('15844','2014-04-18','10:35:00',1.09),('15844','2014-04-18','10:40:00',1.79),('15844','2014-04-18','10:45:00',2.69),('15844','2014-04-18','10:50:00',3.21),('15844','2014-04-18','10:55:00',3.02),('15844','2014-04-18','11:00:00',2.07),('15844','2014-04-18','11:05:00',1.9),('15844','2014-04-18','11:10:00',1.53),('15844','2014-04-18','11:15:00',1.96),('15844','2014-04-18','11:20:00',1.68),('15844','2014-04-18','11:25:00',1.37),('15844','2014-04-18','11:30:00',1.7),('15844','2014-04-18','11:35:00',1.85),('15844','2014-04-18','11:40:00',1.94),('15844','2014-04-18','11:45:00',2.24),('15844','2014-04-18','11:50:00',2.58),('15844','2014-04-18','11:55:00',2.18),('15844','2014-04-18','12:00:00',2.27),('15844','2014-04-18','12:05:00',2.03),('15844','2014-04-18','12:10:00',2.79),('15844','2014-04-18','12:15:00',2.97),('15844','2014-04-18','12:20:00',3.86),('15844','2014-04-18','12:25:00',3.24),('15844','2014-04-18','12:30:00',4.39),('15844','2014-04-18','12:35:00',4.45),('15844','2014-04-18','12:40:00',3.88),('15844','2014-04-18','12:45:00',3.82),('15844','2014-04-18','12:50:00',2.77),('15844','2014-04-18','12:55:00',3.16),('15844','2014-04-18','13:00:00',3.77),('15844','2014-04-18','13:05:00',4.04),('15844','2014-04-18','13:10:00',4.19),('15844','2014-04-18','13:15:00',3),('15844','2014-04-18','13:20:00',2.16),('15844','2014-04-18','13:25:00',1.49),('15844','2014-04-18','13:30:00',1.06),('15844','2014-04-18','13:35:00',1.15),('15844','2014-04-18','13:40:00',1.29),('15844','2014-04-18','13:45:00',1.25),('15844','2014-04-18','13:50:00',1.22),('15844','2014-04-18','13:55:00',1.38),('15844','2014-04-18','14:00:00',1.6),('15844','2014-04-18','14:05:00',1.55),('15844','2014-04-18','14:10:00',1.52),('15844','2014-04-18','14:15:00',1.6),('15844','2014-04-18','14:20:00',1.5),('15844','2014-04-18','14:25:00',1.85),('15844','2014-04-18','14:30:00',1.88),('15844','2014-04-18','14:35:00',1.88),('15844','2014-04-18','14:40:00',1.6),('15844','2014-04-18','14:45:00',1.51),('15844','2014-04-18','14:50:00',1.75),('15844','2014-04-18','14:55:00',2.89),('15844','2014-04-18','15:00:00',2.67),('15844','2014-04-18','15:05:00',2.51),('15844','2014-04-18','15:10:00',1.63),('15844','2014-04-18','15:15:00',2.49),('15844','2014-04-18','15:20:00',1.57),('15844','2014-04-18','15:25:00',1.36),('15844','2014-04-18','15:30:00',1.52),('15844','2014-04-18','15:35:00',2.04),('15844','2014-04-18','15:40:00',1.81),('15844','2014-04-18','15:45:00',2.15),('15844','2014-04-18','15:50:00',1.73),('15844','2014-04-18','15:55:00',2.32),('15844','2014-04-18','16:00:00',2.12),('15844','2014-04-18','16:05:00',2.19),('15844','2014-04-18','16:10:00',1.7),('15844','2014-04-18','16:15:00',1.54),('15844','2014-04-18','16:20:00',1.62),('15844','2014-04-18','16:25:00',1.2),('15844','2013-11-07','08:10:00',1.01),('15844','2013-11-07','08:15:00',1.08),('15844','2013-11-07','08:20:00',1.14),('15844','2013-11-07','08:25:00',1.22),('15844','2013-11-07','08:30:00',1.29),('15844','2013-11-07','08:35:00',1.38),('15844','2013-11-07','08:40:00',1.46),('15844','2013-11-07','08:45:00',1.52),('15844','2013-11-07','08:50:00',1.58),('15844','2013-11-07','08:55:00',1.63),('15844','2013-11-07','09:00:00',1.68),('15844','2013-11-07','09:05:00',1.73),('15844','2013-11-07','09:10:00',1.78),('15844','2013-11-07','09:15:00',1.82),('15844','2013-11-07','09:20:00',1.86),('15844','2013-11-07','09:25:00',1.9),('15844','2013-11-07','09:30:00',1.94),('15844','2013-11-07','09:35:00',1.97),('15844','2013-11-07','09:40:00',1.98),('15844','2013-11-07','09:45:00',2.04),('15844','2013-11-07','09:50:00',2.07),('15844','2013-11-07','09:55:00',2.1),('15844','2013-11-07','10:00:00',2.13),('15844','2013-11-07','10:05:00',2.17),('15844','2013-11-07','10:10:00',2.2),('15844','2013-11-07','10:15:00',2.21),('15844','2013-11-07','10:20:00',2.22),('15844','2013-11-07','10:25:00',2.23),('15844','2013-11-07','10:30:00',2.25),('15844','2013-11-07','10:35:00',2.25),('15844','2013-11-07','10:40:00',2.26),('15844','2013-11-07','10:45:00',2.24),('15844','2013-11-07','10:50:00',2.26),('15844','2013-11-07','10:55:00',2.25),('15844','2013-11-07','11:00:00',2.23),('15844','2013-11-07','11:05:00',2.23),('15844','2013-11-07','11:10:00',2.21),('15844','2013-11-07','11:15:00',2.22),('15844','2013-11-07','11:20:00',2.11),('15844','2013-11-07','11:25:00',2.07),('15844','2013-11-07','11:30:00',2.1),('15844','2013-11-07','11:35:00',2.05),('15844','2013-11-07','11:40:00',1.98),('15844','2013-11-07','11:45:00',2.16),('15844','2013-11-07','11:50:00',2.14),('15844','2013-11-07','11:55:00',2.05),('15844','2013-11-07','12:00:00',2.06),('15844','2013-11-07','12:05:00',2.01),('15844','2013-11-07','12:10:00',1.92),('15844','2013-11-07','12:15:00',1.8),('15844','2013-11-07','12:20:00',1.75),('15844','2013-11-07','12:25:00',1.16),('15844','2013-11-07','12:35:00',1.64),('15844','2013-11-07','12:40:00',1.4),('15844','2013-11-07','12:45:00',1.02),('15844','2013-11-07','12:50:00',1.31),('15844','2013-11-07','12:55:00',1.36),('15844','2013-11-07','13:00:00',1.37),('15844','2013-11-07','13:05:00',1.22),('15844','2013-11-07','13:10:00',1.51),('15844','2013-11-07','13:15:00',1.58),('15844','2013-11-07','13:20:00',1.24),('15844','2013-11-07','13:25:00',1.08),('15844','2013-11-07','13:30:00',1.03),('15844','2013-11-06','08:10:00',1.05),('15844','2013-11-06','08:15:00',1.23),('15844','2013-11-06','08:35:00',1.45),('15844','2013-11-06','08:40:00',1.53),('15844','2013-11-06','08:45:00',1.61),('15844','2013-11-06','08:50:00',1.73),('15844','2013-11-06','08:55:00',1.42),('15844','2013-11-06','09:00:00',1.12),('15844','2013-11-06','09:05:00',1.11),('15844','2013-11-06','09:10:00',1.49),('15844','2013-11-06','09:15:00',1.59),('15844','2013-11-06','09:20:00',1.92),('15844','2013-11-06','09:25:00',2.03),('15844','2013-11-06','09:30:00',2.05),('15844','2013-11-06','09:35:00',2.09),('15844','2013-11-06','09:40:00',2.12),('15844','2013-11-06','09:45:00',2.14),('15844','2013-11-06','09:50:00',2.16),('15844','2013-11-06','09:55:00',2.21),('15844','2013-11-06','10:00:00',2.25),('15844','2013-11-06','10:05:00',2.29),('15844','2013-11-06','10:10:00',2.32),('15844','2013-11-06','10:15:00',2.35),('15844','2013-11-06','10:20:00',2.36),('15844','2013-11-06','10:25:00',2.4),('15844','2013-11-06','10:30:00',2.41),('15844','2013-11-06','10:35:00',2.43),('15844','2013-11-06','10:40:00',2.44),('15844','2013-11-06','10:45:00',2.43),('15844','2013-11-06','10:50:00',2.43),('15844','2013-11-06','10:55:00',2.41),('15844','2013-11-06','11:00:00',2.41),('15844','2013-11-06','11:05:00',2.41),('15844','2013-11-06','11:10:00',2.4),('15844','2013-11-06','11:15:00',2.39),('15844','2013-11-06','11:20:00',2.37),('15844','2013-11-06','11:25:00',2.37),('15844','2013-11-06','11:30:00',2.34),('15844','2013-11-06','11:35:00',2.34),('15844','2013-11-06','11:40:00',2.32),('15844','2013-11-06','11:45:00',2.29),('15844','2013-11-06','11:50:00',2.26),('15844','2013-11-06','11:55:00',2.24),('15844','2013-11-06','12:00:00',2.21),('15844','2013-11-06','12:05:00',2.18),('15844','2013-11-06','12:10:00',2.13),('15844','2013-11-06','12:15:00',2.08),('15844','2013-11-06','12:20:00',2.04),('15844','2013-11-06','12:25:00',1.98),('15844','2013-11-06','12:30:00',1.92),('15844','2013-11-06','12:35:00',1.85),('15844','2013-11-06','12:40:00',1.79),('15844','2013-11-06','12:45:00',1.72),('15844','2013-11-06','12:50:00',1.64),('15844','2013-11-06','12:55:00',1.56),('15844','2013-11-06','13:00:00',1.5),('15844','2013-11-06','13:05:00',1.43),('15844','2013-11-06','13:10:00',1.35),('15844','2013-11-06','13:15:00',1.25),('15844','2013-11-06','13:20:00',1.18),('15844','2013-11-06','13:25:00',1.17),('15844','2013-11-06','13:30:00',1.09),('15844','2013-11-06','13:35:00',1.03),('15844','2013-11-05','08:35:00',1.13),('15844','2013-11-05','10:20:00',1.03),('15844','2013-11-05','10:25:00',1.12),('15844','2013-11-05','10:40:00',1.23),('15844','2013-11-05','10:45:00',1.23),('15844','2013-11-05','11:35:00',1.1),('15844','2013-11-05','11:40:00',1.24),('15844','2013-11-05','11:45:00',1.11),('15844','2013-11-05','11:50:00',1),('15844','2013-11-05','12:05:00',1.21),('15844','2013-11-05','12:10:00',1.13),('15844','2013-11-05','12:15:00',1.14),('15844','2013-11-05','12:20:00',1.62),('15844','2013-11-05','12:25:00',1.91),('15844','2013-11-05','12:30:00',1.55),('15844','2013-11-05','12:35:00',1.03),('15844','2013-11-05','13:20:00',1.06),('15844','2013-11-05','13:25:00',1.12),('15844','2013-11-05','13:30:00',1.28),('15844','2013-11-05','13:35:00',1.55),('15844','2013-11-05','13:40:00',1.41),('15844','2013-11-05','13:45:00',1.22),('15844','2013-11-05','13:50:00',1.05),('15844','2013-11-05','13:55:00',1.18),('15844','2013-11-05','14:00:00',1.27),('15844','2013-11-05','14:05:00',1.08),('15844','2013-11-05','14:10:00',1.02),('15844','2013-11-05','14:20:00',1.07),('15844','2013-11-04','08:10:00',1.02),('15844','2013-11-04','08:15:00',1.1),('15844','2013-11-04','08:20:00',1.17),('15844','2013-11-04','08:25:00',1.28),('15844','2013-11-04','08:30:00',1.35),('15844','2013-11-04','08:35:00',1.49),('15844','2013-11-04','08:40:00',1.11),('15844','2013-11-04','08:55:00',1.13),('15844','2013-11-04','09:00:00',1.72),('15844','2013-11-04','09:05:00',1.79),('15844','2013-11-04','09:10:00',1.85),('15844','2013-11-04','09:15:00',1.74),('15844','2013-11-04','09:20:00',1.07),('15844','2013-11-04','09:25:00',2.03),('15844','2013-11-04','09:30:00',2.02),('15844','2013-11-04','09:35:00',2.09),('15844','2013-11-04','09:40:00',2.08),('15844','2013-11-04','09:45:00',2.03),('15844','2013-11-04','09:50:00',1.93),('15844','2013-11-04','09:55:00',2.3),('15844','2013-11-04','10:00:00',2.38),('15844','2013-11-04','10:05:00',2.03),('15844','2013-11-04','10:10:00',1.92),('15844','2013-11-04','10:15:00',2.08),('15844','2013-11-04','10:20:00',1.8),('15844','2013-11-04','10:25:00',1.55),('15844','2013-11-04','10:30:00',1.76),('15844','2013-11-04','11:50:00',1.36),('15844','2013-11-04','11:55:00',2.72),('15844','2013-11-04','12:00:00',2.69),('15844','2013-11-04','12:05:00',2.23),('15844','2013-11-04','12:10:00',2.56),('15844','2013-11-04','12:15:00',2.37),('15844','2013-11-04','12:20:00',2.29),('15844','2013-11-04','12:25:00',2.23),('15844','2013-11-04','12:30:00',2.15),('15844','2013-11-04','12:35:00',2.06),('15844','2013-11-04','12:40:00',1.95),('15844','2013-11-04','12:45:00',1.99),('15844','2013-11-04','12:50:00',1.87),('15844','2013-11-04','12:55:00',1.76),('15844','2013-11-04','13:00:00',1.7),('15844','2013-11-04','13:05:00',1.63),('15844','2013-11-04','13:20:00',1.11),('15844','2013-11-04','13:25:00',1.01),('15844','2013-11-04','13:30:00',1.28),('15844','2013-11-04','13:35:00',1.25),('15844','2013-11-04','13:40:00',1.08),('15844','2013-11-04','13:45:00',1.17),('15844','2013-11-04','14:00:00',1.09),('15844','2013-11-03','08:30:00',1.27),('15844','2013-11-03','08:35:00',1.27),('15844','2013-11-03','08:40:00',1.4),('15844','2013-11-03','08:45:00',1.67),('15844','2013-11-03','08:55:00',1.75),('15844','2013-11-03','09:00:00',1.09),('15844','2013-11-03','09:30:00',1.88),('15844','2013-11-03','09:35:00',1.21),('15844','2013-11-03','10:10:00',1.03),('15844','2013-11-03','10:20:00',1.37),('15844','2013-11-03','10:25:00',2.25),('15844','2013-11-03','10:30:00',1.87),('15844','2013-11-03','11:05:00',1.58),('15844','2013-11-03','11:10:00',1.57),('15844','2013-11-03','11:15:00',1.34),('15844','2013-11-03','11:30:00',2.71),('15844','2013-11-03','11:35:00',2.31),('15844','2013-11-03','11:40:00',1.76),('15844','2013-11-03','11:45:00',1.82),('15844','2013-11-03','11:50:00',1.78),('15844','2013-11-03','11:55:00',2.32),('15844','2013-11-03','12:00:00',1.3),('15844','2013-11-03','12:05:00',1.74),('15844','2013-11-03','12:10:00',1.07),('15844','2013-11-03','12:15:00',2.39),('15844','2013-11-03','12:20:00',2.58),('15844','2013-11-03','12:25:00',1.11),('15844','2013-11-03','12:50:00',1.09),('15844','2013-11-03','12:55:00',1.04),('15844','2013-11-03','13:20:00',1.22),('15844','2013-11-03','13:25:00',1.48),('15844','2013-11-03','13:30:00',1.12),('15844','2013-11-03','13:45:00',1.28),('15844','2013-11-03','13:55:00',1.01),('15844','2013-11-03','14:00:00',1.29),('15844','2013-11-03','14:05:00',1.19),('15844','2013-11-03','14:10:00',1.19),('15844','2013-11-03','14:15:00',1.26),('15844','2013-11-02','08:15:00',1.01),('15844','2013-11-02','08:20:00',1.12),('15844','2013-11-02','08:25:00',1.2),('15844','2013-11-02','08:30:00',1.27),('15844','2013-11-02','08:35:00',1.34),('15844','2013-11-02','08:40:00',1.41),('15844','2013-11-02','08:45:00',1.5),('15844','2013-11-02','08:50:00',1.57),('15844','2013-11-02','08:55:00',1.7),('15844','2013-11-02','09:00:00',1.79),('15844','2013-11-02','09:15:00',1.96),('15844','2013-11-02','09:20:00',1.87),('15844','2013-11-02','09:25:00',1.46),('15844','2013-11-02','09:30:00',1.95),('15844','2013-11-02','09:35:00',1.98),('15844','2013-11-02','09:40:00',2.07),('15844','2013-11-02','09:45:00',2.32),('15844','2013-11-02','09:50:00',2.36),('15844','2013-11-02','09:55:00',2.06),('15844','2013-11-02','10:00:00',1.6),('15844','2013-11-02','10:05:00',1.56),('15844','2013-11-02','10:50:00',1.01),('15844','2013-11-02','10:55:00',1.17),('15844','2013-11-02','11:00:00',2.33),('15844','2013-11-02','11:05:00',2.66),('15844','2013-11-02','11:10:00',1.03),('15844','2013-11-02','11:15:00',1.04),('15844','2013-11-02','11:40:00',2.04),('15844','2013-11-02','11:45:00',2.31),('15844','2013-11-02','11:50:00',2.08),('15844','2013-11-02','11:55:00',2.37),('15844','2013-11-02','12:05:00',1.2),('15844','2013-11-02','12:10:00',2.22),('15844','2013-11-02','12:15:00',2.63),('15844','2013-11-02','12:20:00',1.16),('15844','2013-11-02','12:25:00',1.29),('15844','2013-11-02','12:30:00',2.17),('15844','2013-11-02','12:35:00',2.68),('15844','2013-11-02','12:40:00',2.22),('15844','2013-11-02','12:45:00',1.76),('15844','2013-11-02','12:50:00',1.87),('15844','2013-11-02','12:55:00',2.21),('15844','2013-11-02','13:00:00',1.61),('15844','2013-11-02','13:05:00',2.3),('15844','2013-11-02','13:10:00',2.02),('15844','2013-11-02','13:15:00',1.81),('15844','2013-11-02','13:20:00',1.22),('15844','2013-11-02','13:25:00',1.05),('15844','2013-11-02','13:30:00',1.72),('15844','2013-11-02','13:35:00',1.58),('15844','2013-11-02','13:40:00',1.79),('15844','2013-11-02','13:45:00',1.66),('15844','2013-11-02','13:50:00',1.4),('15844','2013-11-02','13:55:00',1),('15844','2013-11-01','08:25:00',1.09),('15844','2013-11-01','08:30:00',1.21),('15844','2013-11-01','08:35:00',1.31),('15844','2013-11-01','08:40:00',1.33),('15844','2013-11-01','08:45:00',1.23),('15844','2013-11-01','08:50:00',1.34),('15844','2013-11-01','08:55:00',1.45),('15844','2013-11-01','09:00:00',1.6),('15844','2013-11-01','09:05:00',1.57),('15844','2013-11-01','09:10:00',1.55),('15844','2013-11-01','09:15:00',1.76),('15844','2013-11-01','09:20:00',1.84),('15844','2013-11-01','09:25:00',1.87),('15844','2013-11-01','09:30:00',1.9),('15844','2013-11-01','09:35:00',1.95),('15844','2013-11-01','09:40:00',1.99),('15844','2013-11-01','09:45:00',2.03),('15844','2013-11-01','09:50:00',2.08),('15844','2013-11-01','09:55:00',2.12),('15844','2013-11-01','10:00:00',2.16),('15844','2013-11-01','10:05:00',2.24),('15844','2013-11-01','10:10:00',2.29),('15844','2013-11-01','10:15:00',2.3),('15844','2013-11-01','10:20:00',2.32),('15844','2013-11-01','10:25:00',2.34),('15844','2013-11-01','10:30:00',2.33),('15844','2013-11-01','10:35:00',2.31),('15844','2013-11-01','10:40:00',2.35),('15844','2013-11-01','10:45:00',2.37),('15844','2013-11-01','10:50:00',2.37),('15844','2013-11-01','10:55:00',2.31),('15844','2013-11-01','11:00:00',2.36),('15844','2013-11-01','11:05:00',2.13),('15844','2013-11-01','11:10:00',1.94),('15844','2013-11-01','11:15:00',1.98),('15844','2013-11-01','11:20:00',2.29),('15844','2013-11-01','11:25:00',2.25),('15844','2013-11-01','11:30:00',2.27),('15844','2013-11-01','11:35:00',2.42),('15844','2013-11-01','11:40:00',2.39),('15844','2013-11-01','11:45:00',2.24),('15844','2013-11-01','11:50:00',2.25),('15844','2013-11-01','11:55:00',2.39),('15844','2013-11-01','12:00:00',2.35),('15844','2013-11-01','12:05:00',2.3),('15844','2013-11-01','12:10:00',2.27),('15844','2013-11-01','12:15:00',1.65),('15844','2013-11-01','12:25:00',1.49),('15844','2013-11-01','12:50:00',1.39),('15844','2013-11-01','12:55:00',1.51),('15844','2013-11-01','13:00:00',1.59),('15844','2013-11-01','13:05:00',1.42),('15844','2013-11-01','13:10:00',1.23),('15844','2013-11-01','13:15:00',1),('15844','2013-10-31','08:20:00',1.02),('15844','2013-10-31','08:30:00',1.14),('15844','2013-10-31','08:35:00',1.29),('15844','2013-10-31','08:40:00',1.41),('15844','2013-10-31','08:45:00',1.49),('15844','2013-10-31','08:50:00',1.16),('15844','2013-10-31','08:55:00',1.24),('15844','2013-10-31','09:00:00',1.42),('15844','2013-10-31','09:05:00',1.45),('15844','2013-10-31','09:10:00',1.59),('15844','2013-10-31','09:15:00',1.62),('15844','2013-10-31','09:20:00',1.48),('15844','2013-10-31','09:25:00',1.03),('15844','2013-10-31','09:30:00',1.52),('15844','2013-10-31','09:35:00',1.64),('15844','2013-10-31','09:40:00',1.61),('15844','2013-10-31','09:45:00',1.69),('15844','2013-10-31','09:50:00',1.79),('15844','2013-10-31','09:55:00',1.88),('15844','2013-10-31','10:00:00',1.93),('15844','2013-10-31','10:05:00',2.02),('15844','2013-10-31','10:10:00',2),('15844','2013-10-31','10:15:00',2.09),('15844','2013-10-31','10:20:00',2.04),('15844','2013-10-31','10:25:00',2),('15844','2013-10-31','10:30:00',1.96),('15844','2013-10-31','10:35:00',2.03),('15844','2013-10-31','10:40:00',2.04),('15844','2013-10-31','10:45:00',1.99),('15844','2013-10-31','10:50:00',2.03),('15844','2013-10-31','10:55:00',2.03),('15844','2013-10-31','11:00:00',2.11),('15844','2013-10-31','11:05:00',2.22),('15844','2013-10-31','11:10:00',2.19),('15844','2013-10-31','11:15:00',2.07),('15844','2013-10-31','11:20:00',2.16),('15844','2013-10-31','11:25:00',2.04),('15844','2013-10-31','11:30:00',1.89),('15844','2013-10-31','11:35:00',1.84),('15844','2013-10-31','11:40:00',2.05),('15844','2013-10-31','11:45:00',2.25),('15844','2013-10-31','11:50:00',2.31),('15844','2013-10-31','11:55:00',2.23),('15844','2013-10-31','12:00:00',2.32),('15844','2013-10-31','12:05:00',2.32),('15844','2013-10-31','12:10:00',2.25),('15844','2013-10-31','12:15:00',2.11),('15844','2013-10-31','12:20:00',2.06),('15844','2013-10-31','12:25:00',2.04),('15844','2013-10-31','12:30:00',1.93),('15844','2013-10-31','12:35:00',1.87),('15844','2013-10-31','12:40:00',1.86),('15844','2013-10-31','12:45:00',1.8),('15844','2013-10-31','12:50:00',1.76),('15844','2013-10-31','12:55:00',1.72),('15844','2013-10-31','13:00:00',1.66),('15844','2013-10-31','13:05:00',1.55),('15844','2013-10-31','13:10:00',1.46),('15844','2013-10-31','13:15:00',1.36),('15844','2013-10-31','13:20:00',1.28),('15844','2013-10-31','13:25:00',1.18),('15844','2013-10-31','13:30:00',1.13),('15844','2013-10-31','13:35:00',1.08),('15844','2013-10-30','08:25:00',1.03),('15844','2013-10-30','08:30:00',1.14),('15844','2013-10-30','08:35:00',1.25),('15844','2013-10-30','08:40:00',1.3),('15844','2013-10-30','08:45:00',1.41),('15844','2013-10-30','08:50:00',1.37),('15844','2013-10-30','08:55:00',1.47),('15844','2013-10-30','09:00:00',1.58),('15844','2013-10-30','09:05:00',1.66),('15844','2013-10-30','09:10:00',1.67),('15844','2013-10-30','09:15:00',1.67),('15844','2013-10-30','09:20:00',1.76),('15844','2013-10-30','09:25:00',1.81),('15844','2013-10-30','09:30:00',1.85),('15844','2013-10-30','09:35:00',1.85),('15844','2013-10-30','09:40:00',1.67),('15844','2013-10-30','09:45:00',1.68),('15844','2013-10-30','09:50:00',1.72),('15844','2013-10-30','09:55:00',2),('15844','2013-10-30','10:00:00',1.9),('15844','2013-10-30','10:05:00',1.97),('15844','2013-10-30','10:10:00',1.76),('15844','2013-10-30','10:15:00',1.63),('15844','2013-10-30','10:20:00',1.71),('15844','2013-10-30','10:25:00',1.42),('15844','2013-10-30','10:30:00',1.85),('15844','2013-10-30','10:35:00',1.88),('15844','2013-10-30','10:40:00',1.51),('15844','2013-10-30','10:45:00',1.66),('15844','2013-10-30','10:50:00',1.24),('15844','2013-10-30','10:55:00',2.07),('15844','2013-10-30','11:00:00',2.13),('15844','2013-10-30','11:05:00',2.11),('15844','2013-10-30','11:10:00',2.19),('15844','2013-10-30','11:15:00',2.24),('15844','2013-10-30','11:20:00',2.2),('15844','2013-10-30','11:25:00',1.19),('15844','2013-10-30','11:30:00',1.76),('15844','2013-10-30','11:35:00',1.8),('15844','2013-10-30','11:40:00',1.42),('15844','2013-10-30','11:45:00',1.01),('15844','2013-10-30','12:00:00',1.66),('15844','2013-10-30','12:05:00',1.53),('15844','2013-10-30','12:10:00',1.95),('15844','2013-10-30','12:15:00',2.4),('15844','2013-10-30','12:20:00',2.45),('15844','2013-10-30','12:25:00',1.9),('15844','2013-10-30','12:35:00',1.24),('15844','2013-10-30','12:40:00',2.02),('15844','2013-10-30','12:45:00',1.84),('15844','2013-10-30','12:50:00',1.15),('15844','2013-10-30','13:20:00',1.14),('15844','2013-10-30','13:25:00',1.5),('15844','2013-10-30','13:30:00',1.04),('15844','2013-10-29','08:30:00',1.15),('15844','2013-10-29','08:35:00',1.35),('15844','2013-10-29','08:40:00',1.43),('15844','2013-10-29','08:45:00',1.47),('15844','2013-10-29','08:50:00',1.54),('15844','2013-10-29','08:55:00',1.61),('15844','2013-10-29','09:00:00',1.69),('15844','2013-10-29','09:05:00',1.72),('15844','2013-10-29','09:10:00',1.75),('15844','2013-10-29','09:15:00',1.82),('15844','2013-10-29','09:20:00',1.88),('15844','2013-10-29','09:25:00',1.9),('15844','2013-10-29','09:30:00',1.9),('15844','2013-10-29','09:35:00',2),('15844','2013-10-29','09:40:00',1.92),('15844','2013-10-29','09:45:00',1.99),('15844','2013-10-29','09:50:00',1.82),('15844','2013-10-29','09:55:00',2.02),('15844','2013-10-29','10:00:00',2.11),('15844','2013-10-29','10:05:00',1.47),('15844','2013-10-29','10:10:00',1.13),('15844','2013-10-29','10:15:00',1.23),('15844','2013-10-29','10:20:00',1.61),('15844','2013-10-29','10:25:00',1.84),('15844','2013-10-29','10:30:00',1.79),('15844','2013-10-29','10:35:00',2.35),('15844','2013-10-29','10:40:00',2.42),('15844','2013-10-29','10:45:00',1.95),('15844','2013-10-29','10:50:00',2.18),('15844','2013-10-29','10:55:00',2.58),('15844','2013-10-29','11:00:00',2.39),('15844','2013-10-29','11:05:00',2.57),('15844','2013-10-29','11:10:00',2.31),('15844','2013-10-29','11:15:00',2.13),('15844','2013-10-29','11:20:00',2.62),('15844','2013-10-29','11:25:00',2.5),('15844','2013-10-29','11:30:00',2.36),('15844','2013-10-29','11:35:00',2.46),('15844','2013-10-29','11:40:00',2.4),('15844','2013-10-29','11:45:00',2.07),('15844','2013-10-29','11:50:00',1.78),('15844','2013-10-29','11:55:00',2.19),('15844','2013-10-29','12:00:00',2.21),('15844','2013-10-29','12:05:00',2.19),('15844','2013-10-29','12:10:00',2.2),('15844','2013-10-29','12:15:00',1.97),('15844','2013-10-29','12:20:00',2.05),('15844','2013-10-29','12:25:00',2.02),('15844','2013-10-29','12:30:00',2),('15844','2013-10-29','12:35:00',1.94),('15844','2013-10-29','12:40:00',1.83),('15844','2013-10-29','12:45:00',1.76),('15844','2013-10-29','12:50:00',1.63),('15844','2013-10-29','12:55:00',1.58),('15844','2013-10-29','13:00:00',1.42),('15844','2013-10-29','13:05:00',1.25),('15844','2013-10-29','13:15:00',1.36),('15844','2013-10-29','13:20:00',1.3),('15844','2013-10-29','13:25:00',1.29),('15844','2013-10-29','13:30:00',1.23),('15844','2013-10-29','13:35:00',1.18),('15844','2013-10-29','13:40:00',1.07),('15844','2014-04-17','08:35:00',1.11),('15844','2014-04-17','08:40:00',1.23),('15844','2014-04-17','08:45:00',1.34),('15844','2014-04-17','08:50:00',1.47),('15844','2014-04-17','08:55:00',1.55),('15844','2014-04-17','09:00:00',1.67),('15844','2014-04-17','09:05:00',1.82),('15844','2014-04-17','09:10:00',1.89),('15844','2014-04-17','09:15:00',1.99),('15844','2014-04-17','09:20:00',2.12),('15844','2014-04-17','09:25:00',2.25),('15844','2014-04-17','09:30:00',2.36),('15844','2014-04-17','09:35:00',2.46),('15844','2014-04-17','09:40:00',2.53),('15844','2014-04-17','09:45:00',2.61),('15844','2014-04-17','09:50:00',2.66),('15844','2014-04-17','09:55:00',2.79),('15844','2014-04-17','10:00:00',2.98),('15844','2014-04-17','10:05:00',2.56),('15844','2014-04-17','10:10:00',1.92),('15844','2014-04-17','10:15:00',2.07),('15844','2014-04-17','10:20:00',2.58),('15844','2014-04-17','10:25:00',2.87),('15844','2014-04-17','10:30:00',3.05),('15844','2014-04-17','10:35:00',3.21),('15844','2014-04-17','10:40:00',2.51),('15844','2014-04-17','10:45:00',2.69),('15844','2014-04-17','10:50:00',2.55),('15844','2014-04-17','10:55:00',2.64),('15844','2014-04-17','11:00:00',2.68),('15844','2014-04-17','11:05:00',2.45),('15844','2014-04-17','11:10:00',2.98),('15844','2014-04-17','11:15:00',2.88),('15844','2014-04-17','11:20:00',3.83),('15844','2014-04-17','11:25:00',2.29),('15844','2014-04-17','11:30:00',3.18),('15844','2014-04-17','11:35:00',3.38),('15844','2014-04-17','11:40:00',2.62),('15844','2014-04-17','11:45:00',3.92),('15844','2014-04-17','11:50:00',3.38),('15844','2014-04-17','11:55:00',2.58),('15844','2014-04-17','12:00:00',2.51),('15844','2014-04-17','12:05:00',1.98),('15844','2014-04-17','12:10:00',1.89),('15844','2014-04-17','12:15:00',2.26),('15844','2014-04-17','12:20:00',2.19),('15844','2014-04-17','12:25:00',2.8),('15844','2014-04-17','12:30:00',3.97),('15844','2014-04-17','12:35:00',4.02),('15844','2014-04-17','12:40:00',4.01),('15844','2014-04-17','12:45:00',4.08),('15844','2014-04-17','12:50:00',4.14),('15844','2014-04-17','12:55:00',4.15),('15844','2014-04-17','13:00:00',4.11),('15844','2014-04-17','13:05:00',4.1),('15844','2014-04-17','13:10:00',4.12),('15844','2014-04-17','13:15:00',4.11),('15844','2014-04-17','13:20:00',4.15),('15844','2014-04-17','13:25:00',4.23),('15844','2014-04-17','13:30:00',4.18),('15844','2014-04-17','13:35:00',4.32),('15844','2014-04-17','13:40:00',2.79),('15844','2014-04-17','13:45:00',3.82),('15844','2014-04-17','13:50:00',1.4),('15844','2014-04-17','13:55:00',3.68),('15844','2014-04-17','14:00:00',1.71),('15844','2014-04-17','14:05:00',2.62),('15844','2014-04-17','14:10:00',2.67),('15844','2014-04-17','14:15:00',1.45),('15844','2014-04-17','14:20:00',4.1),('15844','2014-04-17','14:25:00',3.12),('15844','2014-04-17','14:30:00',1.83),('15844','2014-04-17','14:35:00',1.6),('15844','2014-04-17','14:40:00',2.36),('15844','2014-04-17','14:45:00',2.14),('15844','2014-04-17','15:25:00',1.05),('15844','2014-04-17','15:30:00',1.25),('15844','2014-04-17','15:35:00',1.28),('15844','2014-04-17','15:40:00',1.08),('15844','2014-04-17','16:25:00',1.03),('15844','2014-04-17','16:40:00',1.05),('15844','2014-04-17','16:45:00',1.16),('15844','2014-04-17','16:50:00',1.08),('15844','2013-10-28','08:45:00',1.38),('15844','2013-10-28','08:50:00',1.58),('15844','2013-10-28','08:55:00',1.74),('15844','2013-10-28','09:00:00',1.83),('15844','2013-10-28','09:05:00',1.89),('15844','2013-10-28','09:10:00',1.96),('15844','2013-10-28','09:15:00',1.72),('15844','2013-10-28','09:20:00',1.38),('15844','2013-10-28','09:25:00',1.35),('15844','2013-10-28','09:30:00',1.68),('15844','2013-10-28','09:35:00',1.78),('15844','2013-10-28','09:40:00',1.57),('15844','2013-10-28','10:40:00',2.36),('15844','2013-10-28','10:45:00',2.6),('15844','2013-10-28','10:50:00',2.55),('15844','2013-10-28','10:55:00',2.55),('15844','2013-10-28','11:00:00',2.52),('15844','2013-10-28','11:05:00',2.53),('15844','2013-10-28','11:10:00',2.51),('15844','2013-10-28','11:15:00',2.49),('15844','2013-10-28','11:20:00',2.49),('15844','2013-10-28','11:25:00',2.51),('15844','2013-10-28','11:30:00',2.46),('15844','2013-10-28','11:35:00',2.42),('15844','2013-10-28','11:40:00',2.39),('15844','2013-10-28','11:45:00',2.38),('15844','2013-10-28','11:50:00',2.43),('15844','2013-10-28','11:55:00',2.4),('15844','2013-10-28','12:00:00',2.37),('15844','2013-10-28','12:05:00',2.38),('15844','2013-10-28','12:10:00',2.19),('15844','2013-10-28','12:15:00',1.62),('15844','2013-10-28','12:20:00',1.48),('15844','2013-10-28','12:25:00',1.54),('15844','2013-10-28','12:30:00',1.54),('15844','2013-10-28','12:35:00',2.03),('15844','2013-10-28','12:40:00',1.97),('15844','2013-10-28','12:45:00',1.88),('15844','2013-10-28','12:50:00',1.8),('15844','2013-10-28','12:55:00',1.71),('15844','2013-10-28','13:00:00',1.65),('15844','2013-10-28','13:05:00',1.59),('15844','2013-10-28','13:10:00',1.5),('15844','2013-10-28','13:15:00',1.41),('15844','2013-10-28','13:20:00',1.33),('15844','2013-10-28','13:25:00',1.25),('15844','2013-10-28','13:30:00',1.18),('15844','2013-10-28','13:35:00',1.16),('15844','2013-10-28','13:40:00',1.12),('15844','2013-10-28','13:45:00',1.09),('15844','2013-10-27','10:05:00',1.12),('15844','2013-10-27','10:10:00',1.04),('15844','2013-10-27','10:30:00',1.1),('15844','2013-10-27','10:35:00',1.53),('15844','2013-10-27','10:40:00',1.59),('15844','2013-10-27','10:45:00',1.23),('15844','2013-10-27','10:50:00',1.21),('15844','2013-10-27','10:55:00',1.14),('15844','2013-10-27','11:00:00',1.02),('15844','2013-10-27','11:10:00',1.02),('15844','2013-10-27','11:15:00',1.29),('15844','2013-10-27','11:20:00',1.26),('15844','2013-10-27','11:25:00',1.4),('15844','2013-10-27','11:30:00',1.36),('15844','2013-10-27','11:35:00',1.41),('15844','2013-10-27','11:40:00',1.14),('15844','2013-10-27','11:45:00',1),('15844','2013-10-27','11:50:00',1.01),('15844','2013-10-27','12:00:00',1.2),('15844','2013-10-27','12:05:00',2.11),('15844','2013-10-27','12:10:00',1.13),('15844','2013-10-27','12:15:00',2.02),('15844','2013-10-27','12:20:00',1.66),('15844','2013-10-27','12:25:00',1.4),('15844','2013-10-27','12:50:00',1.23),('15844','2013-10-27','12:55:00',1.75),('15844','2013-10-27','13:00:00',1.15),('15844','2013-10-27','13:05:00',1.44),('15844','2013-10-27','13:15:00',1.38),('15844','2013-10-27','13:40:00',1.54),('15844','2013-10-27','13:45:00',1.51),('15844','2013-10-27','13:50:00',1.11),('15844','2013-10-27','13:55:00',1.19),('15844','2013-10-27','14:05:00',1.24),('15844','2013-10-27','14:10:00',1.16),('15844','2013-10-27','14:15:00',1.08),('15844','2013-10-27','14:30:00',1.05),('15844','2013-10-26','09:05:00',1.01),('15844','2013-10-26','09:10:00',1.07),('15844','2013-10-26','09:15:00',1.13),('15844','2013-10-26','09:20:00',1.18),('15844','2013-10-26','09:25:00',1.27),('15844','2013-10-26','09:30:00',1.34),('15844','2013-10-26','09:35:00',1.41),('15844','2013-10-26','09:40:00',1.48),('15844','2013-10-26','09:45:00',1.55),('15844','2013-10-26','09:50:00',1.64),('15844','2013-10-26','09:55:00',1.69),('15844','2013-10-26','10:00:00',1.75),('15844','2013-10-26','10:05:00',1.78),('15844','2013-10-26','10:10:00',1.82),('15844','2013-10-26','10:15:00',1.87),('15844','2013-10-26','10:20:00',1.91),('15844','2013-10-26','10:25:00',1.92),('15844','2013-10-26','10:30:00',1.96),('15844','2013-10-26','10:35:00',2.02),('15844','2013-10-26','10:40:00',2.05),('15844','2013-10-26','10:45:00',2.12),('15844','2013-10-26','10:50:00',2.14),('15844','2013-10-26','10:55:00',2.16),('15844','2013-10-26','11:00:00',2.16),('15844','2013-10-26','11:05:00',2.28),('15844','2013-10-26','11:10:00',2.34),('15844','2013-10-26','11:15:00',2.38),('15844','2013-10-26','11:20:00',2.41),('15844','2013-10-26','11:25:00',2.42),('15844','2013-10-26','11:30:00',2.43),('15844','2013-10-26','11:35:00',2.45),('15844','2013-10-26','11:40:00',2.4),('15844','2013-10-26','11:45:00',2.43),('15844','2013-10-26','11:50:00',2.44),('15844','2013-10-26','11:55:00',2.41),('15844','2013-10-26','12:00:00',2.39),('15844','2013-10-26','12:05:00',2.38),('15844','2013-10-26','12:10:00',2.35),('15844','2013-10-26','12:15:00',2.42),('15844','2013-10-26','12:20:00',2.33),('15844','2013-10-26','12:25:00',2.33),('15844','2013-10-26','12:30:00',2.11),('15844','2013-10-26','12:35:00',2.38),('15844','2013-10-26','12:40:00',2.33),('15844','2013-10-26','12:45:00',2.14),('15844','2013-10-26','12:50:00',2.1),('15844','2013-10-26','12:55:00',2.22),('15844','2013-10-26','13:00:00',2.28),('15844','2013-10-26','13:05:00',2.21),('15844','2013-10-26','13:10:00',2.11),('15844','2013-10-26','13:15:00',2.11),('15844','2013-10-26','13:20:00',2.16),('15844','2013-10-26','13:25:00',1.93),('15844','2013-10-26','13:30:00',1.9),('15844','2013-10-26','13:35:00',2.03),('15844','2013-10-26','13:40:00',1.87),('15844','2013-10-26','13:45:00',1.73),('15844','2013-10-26','13:50:00',1.72),('15844','2013-10-26','13:55:00',1.55),('15844','2013-10-26','14:00:00',1.64),('15844','2013-10-26','14:05:00',1.52),('15844','2013-10-26','14:10:00',1.5),('15844','2013-10-26','14:15:00',1.33),('15844','2013-10-26','14:20:00',1.33),('15844','2013-10-26','14:25:00',1.29),('15844','2013-10-26','14:30:00',1.2),('15844','2013-10-26','14:35:00',1.17),('15844','2013-10-26','14:40:00',1.23),('15844','2013-10-26','14:50:00',1.03),('15844','2013-10-25','09:10:00',1.06),('15844','2013-10-25','09:15:00',1.13),('15844','2013-10-25','09:20:00',1.21),('15844','2013-10-25','09:25:00',1.32),('15844','2013-10-25','09:30:00',1.4),('15844','2013-10-25','09:35:00',1.47),('15844','2013-10-25','09:40:00',1.54),('15844','2013-10-25','09:45:00',1.61),('15844','2013-10-25','09:50:00',1.68),('15844','2013-10-25','09:55:00',1.75),('15844','2013-10-25','10:00:00',1.84),('15844','2013-10-25','10:05:00',1.86),('15844','2013-10-25','10:10:00',1.92),('15844','2013-10-25','10:15:00',1.95),('15844','2013-10-25','10:20:00',1.99),('15844','2013-10-25','10:25:00',1.99),('15844','2013-10-25','10:30:00',2.02),('15844','2013-10-25','10:35:00',2.12),('15844','2013-10-25','10:40:00',2.14),('15844','2013-10-25','10:45:00',2.18),('15844','2013-10-25','10:50:00',2.2),('15844','2013-10-25','10:55:00',2.26),('15844','2013-10-25','11:00:00',2.24),('15844','2013-10-25','11:05:00',2.38),('15844','2013-10-25','11:10:00',2.42),('15844','2013-10-25','11:15:00',2.46),('15844','2013-10-25','11:20:00',2.47),('15844','2013-10-25','11:25:00',2.51),('15844','2013-10-25','11:30:00',2.53),('15844','2013-10-25','11:35:00',2.54),('15844','2013-10-25','11:40:00',2.54),('15844','2013-10-25','11:45:00',2.6),('15844','2013-10-25','11:50:00',2.59),('15844','2013-10-25','11:55:00',2.58),('15844','2013-10-25','12:00:00',2.57),('15844','2013-10-25','12:05:00',2.57),('15844','2013-10-25','12:10:00',2.58),('15844','2013-10-25','12:15:00',2.56),('15844','2013-10-25','12:20:00',2.55),('15844','2013-10-25','12:25:00',2.53),('15844','2013-10-25','12:30:00',2.49),('15844','2013-10-25','12:35:00',2.49),('15844','2013-10-25','12:40:00',2.46),('15844','2013-10-25','12:45:00',2.46),('15844','2013-10-25','12:50:00',2.43),('15844','2013-10-25','12:55:00',2.4),('15844','2013-10-25','13:00:00',2.35),('15844','2013-10-25','13:05:00',2.33),('15844','2013-10-25','13:10:00',2.29),('15844','2013-10-25','13:15:00',2.25),('15844','2013-10-25','13:20:00',2.21),('15844','2013-10-25','13:25:00',2.14),('15844','2013-10-25','13:30:00',2.03),('15844','2013-10-25','13:35:00',1.99),('15844','2013-10-25','13:40:00',1.93),('15844','2013-10-25','13:45:00',1.87),('15844','2013-10-25','13:50:00',1.81),('15844','2013-10-25','13:55:00',1.72),('15844','2013-10-25','14:00:00',1.68),('15844','2013-10-25','14:05:00',1.61),('15844','2013-10-25','14:10:00',1.55),('15844','2013-10-25','14:15:00',1.46),('15844','2013-10-25','14:20:00',1.38),('15844','2013-10-25','14:25:00',1.27),('15844','2013-10-25','14:30:00',1.19),('15844','2013-10-25','14:35:00',1.14),('15844','2013-10-25','14:40:00',1.09),('15844','2013-10-25','14:45:00',1.01),('15844','2013-10-24','09:00:00',1),('15844','2013-10-24','09:05:00',1.08),('15844','2013-10-24','09:10:00',1.19),('15844','2013-10-24','09:50:00',1.01),('15844','2013-10-24','10:30:00',1.31),('15844','2013-10-24','10:35:00',1.67),('15844','2013-10-24','10:40:00',1.26),('15844','2013-10-24','10:45:00',1.65),('15844','2013-10-24','10:50:00',2.19),('15844','2013-10-24','10:55:00',2.12),('15844','2013-10-24','11:00:00',1.87),('15844','2013-10-24','11:05:00',1.53),('15844','2013-10-24','11:10:00',1.2),('15844','2013-10-24','11:15:00',1.27),('15844','2013-10-24','11:35:00',1.1),('15844','2013-10-24','11:40:00',1.35),('15844','2013-10-24','11:45:00',2.72),('15844','2013-10-24','11:50:00',2.47),('15844','2013-10-24','11:55:00',1.31),('15844','2013-10-24','12:00:00',1.18),('15844','2013-10-24','12:05:00',1.15),('15844','2013-10-24','12:10:00',1.18),('15844','2013-10-24','12:15:00',1.28),('15844','2013-10-24','12:20:00',1.52),('15844','2013-10-24','12:25:00',1.45),('15844','2013-10-24','12:30:00',1.55),('15844','2013-10-24','12:35:00',1.44),('15844','2013-10-24','12:40:00',1.43),('15844','2013-10-24','12:45:00',1.89),('15844','2013-10-24','12:50:00',1.86),('15844','2013-10-24','12:55:00',2.41),('15844','2013-10-24','13:00:00',1.67),('15844','2013-10-24','13:05:00',1.33),('15844','2013-10-24','13:10:00',1.28),('15844','2013-10-24','13:15:00',1.19),('15844','2013-10-24','13:20:00',1.1),('15844','2013-10-24','13:25:00',1.04),('15844','2013-10-24','13:30:00',1.02),('15844','2013-10-24','13:35:00',1.02),('15844','2013-10-24','13:40:00',1.04),('15844','2013-10-24','13:45:00',1.26),('15844','2013-10-24','13:50:00',1.82),('15844','2013-10-24','13:55:00',1.09),('15844','2013-10-24','14:00:00',1.06),('15844','2013-10-24','14:05:00',1.06),('15844','2013-10-24','14:10:00',1.1),('15844','2013-10-24','14:15:00',1.19),('15844','2013-10-24','14:20:00',1.17),('15844','2013-10-24','14:25:00',1.19),('15844','2013-10-24','14:30:00',1.27),('15844','2013-10-24','14:35:00',1.56),('15844','2013-10-24','14:40:00',1.21),('15844','2013-10-24','15:35:00',1.06),('15844','2013-10-23','10:15:00',1.03),('15844','2013-10-23','10:30:00',1.4),('15844','2013-10-23','10:35:00',1.79),('15844','2013-10-23','10:40:00',1.68),('15844','2013-10-23','10:45:00',1.44),('15844','2013-10-23','10:50:00',1.65),('15844','2013-10-23','10:55:00',1.63),('15844','2013-10-23','11:00:00',2.23),('15844','2013-10-23','11:05:00',2.48),('15844','2013-10-23','11:10:00',2.42),('15844','2013-10-23','11:15:00',2.42),('15844','2013-10-23','11:20:00',2.4),('15844','2013-10-23','11:25:00',2.42),('15844','2013-10-23','11:30:00',2.43),('15844','2013-10-23','11:35:00',2.51),('15844','2013-10-23','11:40:00',2.41),('15844','2013-10-23','11:45:00',2.34),('15844','2013-10-23','11:50:00',2.38),('15844','2013-10-23','11:55:00',2.32),('15844','2013-10-23','12:00:00',2.17),('15844','2013-10-23','12:05:00',1.96),('15844','2013-10-23','12:10:00',1.23),('15844','2013-10-23','12:15:00',1.4),('15844','2013-10-23','12:20:00',2.01),('15844','2013-10-23','12:25:00',2.24),('15844','2013-10-23','12:30:00',2.26),('15844','2013-10-23','12:35:00',1.97),('15844','2013-10-23','12:40:00',1.55),('15844','2013-10-23','12:45:00',1.23),('15844','2013-10-23','12:50:00',1.75),('15844','2013-10-23','12:55:00',2.13),('15844','2013-10-23','13:00:00',2.29),('15844','2013-10-23','13:05:00',2.31),('15844','2013-10-23','13:10:00',2.26),('15844','2013-10-23','13:15:00',2.15),('15844','2013-10-23','13:20:00',2.09),('15844','2013-10-23','13:25:00',1.97),('15844','2013-10-23','13:30:00',2.03),('15844','2013-10-23','13:35:00',1.92),('15844','2013-10-23','13:40:00',1.93),('15844','2013-10-23','13:45:00',1.94),('15844','2013-10-23','13:50:00',1.84),('15844','2013-10-23','13:55:00',1.68),('15844','2013-10-23','14:00:00',1.63),('15844','2013-10-23','14:05:00',1.58),('15844','2013-10-23','14:10:00',1.52),('15844','2013-10-23','14:15:00',1.42),('15844','2013-10-23','14:20:00',1.35),('15844','2013-10-23','14:25:00',1.33),('15844','2013-10-23','14:30:00',1.3),('15844','2013-10-23','14:35:00',1.24),('15844','2013-10-23','14:40:00',1.22),('15844','2013-10-23','14:45:00',1.14),('15844','2013-10-23','14:50:00',1.03),('15844','2013-10-22','09:05:00',1.03),('15844','2013-10-22','09:10:00',1.1),('15844','2013-10-22','09:15:00',1.17),('15844','2013-10-22','09:20:00',1.23),('15844','2013-10-22','09:25:00',1.36),('15844','2013-10-22','09:30:00',1.45),('15844','2013-10-22','09:35:00',1.51),('15844','2013-10-22','09:40:00',1.58),('15844','2013-10-22','09:45:00',1.62),('15844','2013-10-22','09:50:00',1.67),('15844','2013-10-22','09:55:00',1.69),('15844','2013-10-22','10:00:00',1.77),('15844','2013-10-22','10:05:00',1.82),('15844','2013-10-22','10:10:00',1.87),('15844','2013-10-22','10:15:00',1.93),('15844','2013-10-22','10:20:00',1.97),('15844','2013-10-22','10:25:00',1.99),('15844','2013-10-22','10:30:00',2.03),('15844','2013-10-22','10:35:00',2.03),('15844','2013-10-22','10:40:00',2.01),('15844','2013-10-22','10:45:00',2.06),('15844','2013-10-22','10:50:00',2.06),('15844','2013-10-22','10:55:00',2.18),('15844','2013-10-22','11:00:00',2.19),('15844','2013-10-22','11:05:00',2.25),('15844','2013-10-22','11:10:00',2.26),('15844','2013-10-22','11:15:00',2.22),('15844','2013-10-22','11:20:00',2.29),('15844','2013-10-22','11:25:00',2.32),('15844','2013-10-22','11:30:00',2.35),('15844','2013-10-22','11:35:00',2.39),('15844','2013-10-22','11:40:00',2.4),('15844','2013-10-22','11:45:00',2.41),('15844','2013-10-22','11:50:00',2.41),('15844','2013-10-22','11:55:00',2.36),('15844','2013-10-22','12:00:00',2.39),('15844','2013-10-22','12:05:00',2.31),('15844','2013-10-22','12:10:00',2.34),('15844','2013-10-22','12:15:00',2.37),('15844','2013-10-22','12:20:00',2.3),('15844','2013-10-22','12:25:00',2.25),('15844','2013-10-22','12:30:00',2.33),('15844','2013-10-22','12:35:00',2.31),('15844','2013-10-22','12:40:00',2.2),('15844','2013-10-22','12:45:00',2.18),('15844','2013-10-22','12:50:00',2.29),('15844','2013-10-22','12:55:00',2.36),('15844','2013-10-22','13:00:00',2.24),('15844','2013-10-22','13:05:00',2.16),('15844','2013-10-22','13:10:00',1.98),('15844','2013-10-22','13:15:00',2.06),('15844','2013-10-22','13:20:00',2.14),('15844','2013-10-22','13:25:00',2.15),('15844','2013-10-22','13:30:00',2.18),('15844','2013-10-22','13:35:00',2.15),('15844','2013-10-22','13:40:00',1.86),('15844','2013-10-22','13:45:00',1.13),('15844','2013-10-22','13:50:00',1.77),('15844','2013-10-22','13:55:00',1.05),('15844','2013-10-22','14:00:00',1.18),('15844','2013-10-22','14:05:00',1.81),('15844','2013-10-22','14:10:00',1.89),('15844','2013-10-22','14:15:00',1.73),('15844','2013-10-22','14:20:00',1.57),('15844','2013-10-22','14:25:00',1.39),('15844','2013-10-22','14:30:00',1.35),('15844','2013-10-22','14:35:00',1.28),('15844','2013-10-22','14:40:00',1.22),('15844','2013-10-22','14:45:00',1.12),('15844','2013-10-22','14:50:00',1.04),('15844','2013-10-21','09:10:00',1.13),('15844','2013-10-21','09:15:00',1.31),('15844','2013-10-21','09:20:00',1.34),('15844','2013-10-21','09:25:00',1.34),('15844','2013-10-21','09:30:00',1.33),('15844','2013-10-21','09:35:00',1.36),('15844','2013-10-21','09:40:00',1.43),('15844','2013-10-21','09:45:00',1.29),('15844','2013-10-21','09:50:00',1.45),('15844','2013-10-21','09:55:00',1.65),('15844','2013-10-21','10:00:00',1.83),('15844','2013-10-21','10:05:00',1.93),('15844','2013-10-21','10:10:00',2.04),('15844','2013-10-21','10:15:00',2.05),('15844','2013-10-21','10:20:00',2.18),('15844','2013-10-21','10:25:00',2.11),('15844','2013-10-21','10:30:00',2.12),('15844','2013-10-21','10:35:00',2.06),('15844','2013-10-21','10:40:00',2.13),('15844','2013-10-21','10:45:00',2.2),('15844','2013-10-21','10:50:00',2.34),('15844','2013-10-21','10:55:00',2.45),('15844','2013-10-21','11:00:00',2.19),('15844','2013-10-21','11:05:00',2.21),('15844','2013-10-21','11:10:00',2.5),('15844','2013-10-21','11:15:00',2.49),('15844','2013-10-21','11:20:00',2.36),('15844','2013-10-21','11:25:00',2.6),('15844','2013-10-21','11:30:00',2.58),('15844','2013-10-21','11:35:00',2.49),('15844','2013-10-21','11:40:00',2.61),('15844','2013-10-21','11:45:00',2.61),('15844','2013-10-21','11:50:00',2.54),('15844','2013-10-21','11:55:00',2.65),('15844','2013-10-21','12:00:00',2.64),('15844','2013-10-21','12:05:00',2.61),('15844','2013-10-21','12:10:00',2.57),('15844','2013-10-21','12:15:00',2.6),('15844','2013-10-21','12:20:00',2.6),('15844','2013-10-21','12:25:00',2.49),('15844','2013-10-21','12:30:00',2.48),('15844','2013-10-21','12:35:00',2.48),('15844','2013-10-21','12:40:00',2.49),('15844','2013-10-21','12:45:00',2.46),('15844','2013-10-21','12:50:00',2.42),('15844','2013-10-21','12:55:00',2.36),('15844','2013-10-21','13:00:00',2.29),('15844','2013-10-21','13:05:00',2.26),('15844','2013-10-21','13:10:00',2.19),('15844','2013-10-21','13:15:00',2.1),('15844','2013-10-21','13:20:00',2.21),('15844','2013-10-21','13:25:00',2.19),('15844','2013-10-21','13:30:00',2.21),('15844','2013-10-21','13:35:00',2.15),('15844','2013-10-21','13:40:00',2.09),('15844','2013-10-21','13:45:00',2.01),('15844','2013-10-21','13:50:00',1.89),('15844','2013-10-21','13:55:00',1.81),('15844','2013-10-21','14:00:00',1.8),('15844','2013-10-21','14:05:00',1.67),('15844','2013-10-21','14:10:00',1.61),('15844','2013-10-21','14:15:00',1.52),('15844','2013-10-21','14:20:00',1.42),('15844','2013-10-21','14:25:00',1.37),('15844','2013-10-21','14:30:00',1.29),('15844','2013-10-21','14:35:00',1.25),('15844','2013-10-21','14:40:00',1.16),('15844','2013-10-21','14:45:00',1.11),('15844','2013-10-21','14:50:00',1.03),('15844','2013-10-20','09:00:00',1.02),('15844','2013-10-20','09:05:00',1.1),('15844','2013-10-20','09:10:00',1.19),('15844','2013-10-20','09:15:00',1.24),('15844','2013-10-20','09:20:00',1.3),('15844','2013-10-20','09:25:00',1.35),('15844','2013-10-20','09:30:00',1.42),('15844','2013-10-20','09:35:00',1.58),('15844','2013-10-20','09:40:00',1.66),('15844','2013-10-20','09:45:00',1.73),('15844','2013-10-20','09:50:00',1.82),('15844','2013-10-20','09:55:00',1.87),('15844','2013-10-20','10:00:00',1.93),('15844','2013-10-20','10:05:00',1.98),('15844','2013-10-20','10:10:00',2.05),('15844','2013-10-20','10:15:00',2.13),('15844','2013-10-20','10:20:00',2.18),('15844','2013-10-20','10:25:00',2.22),('15844','2013-10-20','10:30:00',2.26),('15844','2013-10-20','10:35:00',2.28),('15844','2013-10-20','10:40:00',2.32),('15844','2013-10-20','10:45:00',2.35),('15844','2013-10-20','10:50:00',2.37),('15844','2013-10-20','10:55:00',2.39),('15844','2013-10-20','11:00:00',2.43),('15844','2013-10-20','11:05:00',2.46),('15844','2013-10-20','11:10:00',2.54),('15844','2013-10-20','11:15:00',2.59),('15844','2013-10-20','11:20:00',2.61),('15844','2013-10-20','11:25:00',2.64),('15844','2013-10-20','11:30:00',2.65),('15844','2013-10-20','11:35:00',2.66),('15844','2013-10-20','11:40:00',2.65),('15844','2013-10-20','11:45:00',2.63),('15844','2013-10-20','11:50:00',2.63),('15844','2013-10-20','11:55:00',2.69),('15844','2013-10-20','12:00:00',2.69),('15844','2013-10-20','12:05:00',2.64),('15844','2013-10-20','12:10:00',2.39),('15844','2013-10-20','12:15:00',2.25),('15844','2013-10-20','12:25:00',1.45),('15844','2013-10-20','12:30:00',1.14),('15844','2013-10-20','12:35:00',1.6),('15844','2013-10-20','12:40:00',2.39),('15844','2013-10-20','12:45:00',1.94),('15844','2013-10-20','12:50:00',2.82),('15844','2013-10-20','12:55:00',1.89),('15844','2013-10-20','13:00:00',1.33),('15844','2013-10-20','13:05:00',2.72),('15844','2013-10-20','13:10:00',3.09),('15844','2013-10-20','13:15:00',2.33),('15844','2013-10-20','13:35:00',1.51),('15844','2013-10-20','13:40:00',2),('15844','2013-10-20','13:45:00',1.81),('15844','2013-10-20','15:50:00',1),('15844','2013-10-19','08:55:00',1.1),('15844','2013-10-19','09:00:00',1.02),('15844','2013-10-19','09:05:00',1.05),('15844','2013-10-19','09:10:00',1.52),('15844','2013-10-19','09:15:00',1.58),('15844','2013-10-19','09:20:00',1.63),('15844','2013-10-19','09:25:00',1.64),('15844','2013-10-19','09:30:00',1.71),('15844','2013-10-19','09:35:00',1.86),('15844','2013-10-19','09:40:00',1.94),('15844','2013-10-19','09:45:00',1.98),('15844','2013-10-19','09:50:00',2.12),('15844','2013-10-19','09:55:00',2.14),('15844','2013-10-19','10:00:00',2.09),('15844','2013-10-19','10:05:00',2.19),('15844','2013-10-19','10:10:00',2.3),('15844','2013-10-19','10:15:00',2.36),('15844','2013-10-19','10:20:00',2.43),('15844','2013-10-19','10:25:00',2.53),('15844','2013-10-19','10:30:00',2.53),('15844','2013-10-19','10:35:00',2.53),('15844','2013-10-19','10:40:00',2.46),('15844','2013-10-19','10:45:00',2.54),('15844','2013-10-19','10:50:00',2.57),('15844','2013-10-19','10:55:00',2.54),('15844','2013-10-19','11:00:00',2.29),('15844','2013-10-19','11:05:00',1.53),('15844','2013-10-19','11:10:00',1.29),('15844','2013-10-19','11:15:00',2.53),('15844','2013-10-19','11:20:00',2.99),('15844','2013-10-19','11:25:00',2.96),('15844','2013-10-19','11:30:00',2.89),('15844','2013-10-19','11:35:00',2.82),('15844','2013-10-19','11:40:00',2.74),('15844','2013-10-19','11:45:00',2.55),('15844','2013-10-19','11:50:00',3),('15844','2013-10-19','11:55:00',2.96),('15844','2013-10-19','12:00:00',2.91),('15844','2013-10-19','12:05:00',2.86),('15844','2013-10-19','12:10:00',2.87),('15844','2013-10-19','12:15:00',2.71),('15844','2013-10-19','12:20:00',2.79),('15844','2013-10-19','12:25:00',2.5),('15844','2013-10-19','12:30:00',2.79),('15844','2013-10-19','12:35:00',2.84),('15844','2013-10-19','12:40:00',2.93),('15844','2013-10-19','12:45:00',2.85),('15844','2013-10-19','12:50:00',3.09),('15844','2013-10-19','12:55:00',3.1),('15844','2013-10-19','13:00:00',2.78),('15844','2013-10-19','13:05:00',2.78),('15844','2013-10-19','13:10:00',2.48),('15844','2013-10-19','13:15:00',2.52),('15844','2013-10-19','13:20:00',2.9),('15844','2013-10-19','13:25:00',2.07),('15844','2013-10-19','13:30:00',1.88),('15844','2013-10-19','13:35:00',1.74),('15844','2013-10-19','13:40:00',2.07),('15844','2013-10-19','13:45:00',2.4),('15844','2013-10-19','13:50:00',2.35),('15844','2013-10-19','13:55:00',2.14),('15844','2013-10-19','14:00:00',1.94),('15844','2013-10-19','14:05:00',2),('15844','2013-10-19','14:10:00',1.59),('15844','2013-10-19','14:15:00',1.36),('15844','2013-10-19','14:20:00',1.64),('15844','2013-10-19','14:25:00',1.82),('15844','2013-10-19','14:30:00',1.78),('15844','2013-10-19','14:35:00',1.31),('15844','2013-10-19','14:40:00',1.55),('15844','2013-10-19','14:45:00',1.4),('15844','2013-10-19','14:50:00',1.24),('15844','2013-10-19','14:55:00',1.11),('15844','2013-10-19','15:00:00',1.04),('15844','2014-05-04','08:20:00',1.07),('15844','2014-05-04','08:25:00',1.24),('15844','2014-05-04','08:30:00',1.22),('15844','2014-05-04','08:40:00',1.61),('15844','2014-05-04','08:45:00',1.46),('15844','2014-05-04','09:05:00',1.09),('15844','2014-05-04','09:10:00',1.31),('15844','2014-05-04','09:15:00',1.26),('15844','2014-05-04','09:20:00',1.41),('15844','2014-05-04','09:25:00',1.29),('15844','2014-05-04','09:30:00',1.94),('15844','2014-05-04','09:35:00',2.69),('15844','2014-05-04','09:40:00',2.11),('15844','2014-05-04','09:45:00',2.06),('15844','2014-05-04','09:50:00',2.47),('15844','2014-05-04','09:55:00',3.64),('15844','2014-05-04','10:00:00',3.53),('15844','2014-05-04','10:05:00',3.8),('15844','2014-05-04','10:10:00',2.65),('15844','2014-05-04','10:15:00',2.86),('15844','2014-05-04','10:20:00',1.99),('15844','2014-05-04','10:25:00',1.56),('15844','2014-05-04','10:30:00',1.5),('15844','2014-05-04','10:35:00',1.44),('15844','2014-05-04','10:40:00',1.72),('15844','2014-05-04','10:45:00',1.69),('15844','2014-05-04','10:50:00',1.64),('15844','2014-05-04','10:55:00',1.56),('15844','2014-05-04','11:00:00',1.49),('15844','2014-05-04','11:05:00',1.64),('15844','2014-05-04','11:10:00',2.69),('15844','2014-05-04','11:15:00',2.16),('15844','2014-05-04','11:20:00',3.02),('15844','2014-05-04','11:25:00',4.43),('15844','2014-05-04','11:30:00',4.2),('15844','2014-05-04','11:35:00',4.77),('15844','2014-05-04','11:40:00',4.92),('15844','2014-05-04','11:45:00',3.87),('15844','2014-05-04','11:50:00',5.02),('15844','2014-05-04','11:55:00',1.56),('15844','2014-05-04','12:00:00',1.96),('15844','2014-05-04','12:05:00',1.27),('15844','2014-05-04','12:15:00',1.1),('15844','2014-05-04','12:20:00',4.11),('15844','2014-05-04','12:25:00',4.95),('15844','2014-05-04','12:30:00',4.75),('15844','2014-05-04','12:35:00',1.42),('15844','2014-05-04','12:40:00',1.09),('15844','2014-05-04','12:45:00',1.22),('15844','2014-05-04','12:50:00',1.31),('15844','2014-05-04','12:55:00',1.06),('15844','2014-05-04','13:35:00',1.02),('15844','2014-05-04','13:40:00',1.14),('15844','2014-05-04','13:45:00',1.16),('15844','2014-05-04','13:50:00',1.22),('15844','2014-05-04','13:55:00',1.26),('15844','2014-05-04','14:00:00',1.42),('15844','2014-05-04','14:05:00',1.48),('15844','2014-05-04','14:45:00',1.13),('15844','2014-05-04','14:50:00',1.58),('15844','2014-05-04','14:55:00',2.55),('15844','2014-05-04','15:00:00',2.96),('15844','2014-05-04','15:05:00',2.05),('15844','2014-05-04','15:10:00',2.83),('15844','2014-05-04','15:15:00',2.59),('15844','2014-05-04','15:20:00',3.06),('15844','2014-05-04','15:25:00',2.13),('15844','2014-05-04','15:30:00',1.98),('15844','2014-05-04','15:35:00',1.15),('15844','2014-05-04','15:40:00',1.02),('15844','2014-05-04','15:45:00',1.01),('15844','2014-05-04','15:50:00',1),('15844','2014-05-04','17:30:00',1.03),('15844','2014-04-16','08:40:00',1.05),('15844','2014-04-16','08:45:00',1.4),('15844','2014-04-16','08:50:00',1.51),('15844','2014-04-16','08:55:00',1.56),('15844','2014-04-16','09:00:00',1.68),('15844','2014-04-16','09:05:00',1.82),('15844','2014-04-16','09:10:00',1.91),('15844','2014-04-16','09:15:00',2.02),('15844','2014-04-16','09:20:00',2.15),('15844','2014-04-16','09:25:00',2.32),('15844','2014-04-16','09:30:00',2.45),('15844','2014-04-16','09:35:00',2.27),('15844','2014-04-16','09:50:00',1.75),('15844','2014-04-16','09:55:00',2.53),('15844','2014-04-16','10:00:00',2.91),('15844','2014-04-16','10:05:00',2.93),('15844','2014-04-16','10:10:00',3.01),('15844','2014-04-16','10:15:00',3.16),('15844','2014-04-16','10:20:00',3.29),('15844','2014-04-16','10:25:00',3.41),('15844','2014-04-16','10:30:00',3.54),('15844','2014-04-16','10:35:00',3.63),('15844','2014-04-16','10:40:00',3.78),('15844','2014-04-16','10:45:00',3.91),('15844','2014-04-16','10:50:00',4.16),('15844','2014-04-16','10:55:00',4.13),('15844','2014-04-16','11:00:00',4.15),('15844','2014-04-16','11:05:00',4.02),('15844','2014-04-16','11:10:00',3.99),('15844','2014-04-16','11:15:00',2.67),('15844','2014-04-16','11:20:00',2.05),('15844','2014-04-16','11:25:00',4.53),('15844','2014-04-16','11:30:00',4.02),('15844','2014-04-16','11:35:00',3.7),('15844','2014-04-16','11:40:00',3.16),('15844','2014-04-16','11:45:00',3.66),('15844','2014-04-16','11:50:00',3.53),('15844','2014-04-16','11:55:00',3.36),('15844','2014-04-16','12:00:00',4.33),('15844','2014-04-16','12:05:00',3.02),('15844','2014-04-16','12:10:00',3.54),('15844','2014-04-16','12:15:00',3.96),('15844','2014-04-16','12:20:00',4.72),('15844','2014-04-16','12:25:00',4.73),('15844','2014-04-16','12:30:00',2.4),('15844','2014-04-16','12:35:00',4.75),('15844','2014-04-16','12:40:00',2.16),('15844','2014-04-16','12:45:00',4.68),('15844','2014-04-16','12:50:00',4.58),('15844','2014-04-16','12:55:00',4.6),('15844','2014-04-16','13:00:00',4.31),('15844','2014-04-16','13:05:00',2.37),('15844','2014-04-16','13:20:00',1.48),('15844','2014-04-16','13:25:00',4.38),('15844','2014-04-16','13:30:00',2.85),('15844','2014-04-16','13:35:00',1.94),('15844','2014-04-16','13:40:00',2.61),('15844','2014-04-16','13:45:00',3.88),('15844','2014-04-16','13:50:00',3.26),('15844','2014-04-16','13:55:00',3.81),('15844','2014-04-16','14:00:00',1.63),('15844','2014-04-16','14:05:00',1.55),('15844','2014-04-16','14:10:00',2.48),('15844','2014-04-16','14:15:00',2.58),('15844','2014-04-16','14:20:00',2.48),('15844','2014-04-16','14:25:00',3.53),('15844','2014-04-16','14:30:00',3.27),('15844','2014-04-16','14:35:00',2.93),('15844','2014-04-16','14:40:00',2.7),('15844','2014-04-16','14:45:00',2.44),('15844','2014-04-16','14:50:00',2.5),('15844','2014-04-16','14:55:00',1.53),('15844','2014-04-16','15:00:00',3.27),('15844','2014-04-16','15:05:00',1.81),('15844','2014-04-16','15:10:00',1.93),('15844','2014-04-16','15:35:00',1.23),('15844','2014-04-16','15:40:00',1.39),('15844','2014-04-16','16:05:00',1.25),('15844','2014-04-16','16:10:00',1.19),('15844','2014-04-16','16:15:00',1.15),('15844','2014-04-16','16:20:00',1.1),('15844','2013-10-18','08:55:00',1.07),('15844','2013-10-18','09:00:00',1.24),('15844','2013-10-18','09:05:00',1.33),('15844','2013-10-18','09:10:00',1.42),('15844','2013-10-18','09:15:00',1.44),('15844','2013-10-18','09:20:00',1.52),('15844','2013-10-18','09:25:00',1.6),('15844','2013-10-18','09:30:00',1.68),('15844','2013-10-18','09:35:00',1.84),('15844','2013-10-18','09:40:00',1.93),('15844','2013-10-18','09:45:00',2.01),('15844','2013-10-18','09:50:00',2.08),('15844','2013-10-18','09:55:00',2.14),('15844','2013-10-18','10:00:00',2.19),('15844','2013-10-18','10:05:00',2.27),('15844','2013-10-18','10:10:00',2.32),('15844','2013-10-18','10:15:00',2.36),('15844','2013-10-18','10:20:00',2.37),('15844','2013-10-18','10:25:00',2.47),('15844','2013-10-18','10:30:00',2.53),('15844','2013-10-18','10:35:00',2.53),('15844','2013-10-18','10:40:00',2.57),('15844','2013-10-18','10:45:00',2.58),('15844','2013-10-18','10:50:00',2.53),('15844','2013-10-18','10:55:00',2.6),('15844','2013-10-18','11:00:00',2.54),('15844','2013-10-18','11:05:00',2.56),('15844','2013-10-18','11:10:00',2.62),('15844','2013-10-18','11:15:00',2.73),('15844','2013-10-18','11:20:00',2.81),('15844','2013-10-18','11:25:00',2.75),('15844','2013-10-18','11:30:00',2.78),('15844','2013-10-18','11:35:00',2.88),('15844','2013-10-18','11:40:00',2.87),('15844','2013-10-18','11:45:00',2.66),('15844','2013-10-18','11:50:00',2.85),('15844','2013-10-18','11:55:00',2.85),('15844','2013-10-18','12:00:00',2.83),('15844','2013-10-18','12:05:00',2.81),('15844','2013-10-18','12:10:00',2.78),('15844','2013-10-18','12:15:00',2.74),('15844','2013-10-18','12:20:00',2.7),('15844','2013-10-18','12:25:00',2.72),('15844','2013-10-18','12:30:00',2.71),('15844','2013-10-18','12:35:00',2.66),('15844','2013-10-18','12:40:00',2.64),('15844','2013-10-18','12:45:00',2.58),('15844','2013-10-18','12:50:00',2.58),('15844','2013-10-18','12:55:00',2.61),('15844','2013-10-18','13:00:00',2.54),('15844','2013-10-18','13:05:00',2.48),('15844','2013-10-18','13:10:00',2.37),('15844','2013-10-18','13:15:00',2.42),('15844','2013-10-18','13:20:00',2.48),('15844','2013-10-18','13:25:00',2.43),('15844','2013-10-18','13:30:00',2.36),('15844','2013-10-18','13:35:00',2.3),('15844','2013-10-18','13:40:00',2.22),('15844','2013-10-18','13:45:00',2.14),('15844','2013-10-18','13:50:00',2.12),('15844','2013-10-18','13:55:00',1.96),('15844','2013-10-18','14:00:00',1.78),('15844','2013-10-18','14:05:00',1.77),('15844','2013-10-18','14:10:00',1.72),('15844','2013-10-18','14:15:00',1.67),('15844','2013-10-18','14:20:00',1.59),('15844','2013-10-18','14:25:00',1.52),('15844','2013-10-18','14:30:00',1.41),('15844','2013-10-18','14:35:00',1.32),('15844','2013-10-18','14:40:00',1.24),('15844','2013-10-18','14:45:00',1.12),('15844','2013-10-18','14:50:00',1.11),('15844','2013-10-18','14:55:00',1.01),('15844','2013-10-17','08:45:00',1),('15844','2013-10-17','08:50:00',1.09),('15844','2013-10-17','08:55:00',1.17),('15844','2013-10-17','09:00:00',1.27),('15844','2013-10-17','09:05:00',1.36),('15844','2013-10-17','09:10:00',1.44),('15844','2013-10-17','09:15:00',1.51),('15844','2013-10-17','09:20:00',1.6),('15844','2013-10-17','09:25:00',1.68),('15844','2013-10-17','09:30:00',1.76),('15844','2013-10-17','09:35:00',1.85),('15844','2013-10-17','09:40:00',1.95),('15844','2013-10-17','09:45:00',2.01),('15844','2013-10-17','09:50:00',2.1),('15844','2013-10-17','09:55:00',2.16),('15844','2013-10-17','10:00:00',2.21),('15844','2013-10-17','10:05:00',2.28),('15844','2013-10-17','10:10:00',2.33),('15844','2013-10-17','10:15:00',2.39),('15844','2013-10-17','10:20:00',2.44),('15844','2013-10-17','10:25:00',2.48),('15844','2013-10-17','10:30:00',2.51),('15844','2013-10-17','10:35:00',2.55),('15844','2013-10-17','10:40:00',2.6),('15844','2013-10-17','10:45:00',2.61),('15844','2013-10-17','10:50:00',2.64),('15844','2013-10-17','10:55:00',2.67),('15844','2013-10-17','11:00:00',2.7),('15844','2013-10-17','11:05:00',2.72),('15844','2013-10-17','11:10:00',2.77),('15844','2013-10-17','11:15:00',2.82),('15844','2013-10-17','11:20:00',2.88),('15844','2013-10-17','11:25:00',2.92),('15844','2013-10-17','11:30:00',2.93),('15844','2013-10-17','11:35:00',2.94),('15844','2013-10-17','11:40:00',2.95),('15844','2013-10-17','11:45:00',2.96),('15844','2013-10-17','11:50:00',2.96),('15844','2013-10-17','11:55:00',2.96),('15844','2013-10-17','12:00:00',2.97),('15844','2013-10-17','12:05:00',2.95),('15844','2013-10-17','12:10:00',2.92),('15844','2013-10-17','12:15:00',2.91),('15844','2013-10-17','12:20:00',2.88),('15844','2013-10-17','12:25:00',2.84),('15844','2013-10-17','12:30:00',2.82),('15844','2013-10-17','12:35:00',2.8),('15844','2013-10-17','12:40:00',2.83),('15844','2013-10-17','12:45:00',2.79),('15844','2013-10-17','12:50:00',2.78),('15844','2013-10-17','12:55:00',2.75),('15844','2013-10-17','13:00:00',2.73),('15844','2013-10-17','13:05:00',2.7),('15844','2013-10-17','13:10:00',2.66),('15844','2013-10-17','13:15:00',2.59),('15844','2013-10-17','13:20:00',2.57),('15844','2013-10-17','13:25:00',2.51),('15844','2013-10-17','13:30:00',2.46),('15844','2013-10-17','13:35:00',2.37),('15844','2013-10-17','13:40:00',2.35),('15844','2013-10-17','13:45:00',2.27),('15844','2013-10-17','13:50:00',2.21),('15844','2013-10-17','13:55:00',2.11),('15844','2013-10-17','14:00:00',2),('15844','2013-10-17','14:05:00',1.91),('15844','2013-10-17','14:10:00',1.8),('15844','2013-10-17','14:15:00',1.69),('15844','2013-10-17','14:20:00',1.6),('15844','2013-10-17','14:25:00',1.59),('15844','2013-10-17','14:30:00',1.49),('15844','2013-10-17','14:35:00',1.39),('15844','2013-10-17','14:40:00',1.33),('15844','2013-10-17','14:45:00',1.24),('15844','2013-10-17','14:50:00',1.15),('15844','2013-10-17','14:55:00',1.08),('15844','2013-10-16','09:40:00',1.09),('15844','2013-10-16','09:45:00',1.03),('15844','2013-10-16','11:10:00',1.16),('15844','2013-10-16','11:50:00',1.3),('15844','2013-10-16','12:05:00',1.18),('15844','2013-10-16','12:10:00',1.41),('15844','2013-10-16','12:15:00',1.07),('15844','2013-10-16','12:25:00',1.19),('15844','2013-10-16','12:30:00',1.83),('15844','2013-10-16','12:35:00',1.47),('15844','2013-10-16','12:50:00',1.07),('15844','2013-10-16','12:55:00',1.12),('15844','2013-10-16','13:20:00',2.35),('15844','2013-10-16','13:25:00',2.67),('15844','2013-10-16','13:30:00',2.24),('15844','2013-10-16','13:35:00',2),('15844','2013-10-16','13:40:00',2.59),('15844','2013-10-16','13:45:00',2.32),('15844','2013-10-16','13:50:00',2.43),('15844','2013-10-16','13:55:00',1.91),('15844','2013-10-16','14:05:00',2.06),('15844','2013-10-16','14:10:00',1.92),('15844','2013-10-16','14:15:00',1.82),('15844','2013-10-16','14:20:00',1.73),('15844','2013-10-16','14:25:00',1.15),('15844','2013-10-16','14:30:00',1.37),('15844','2013-10-16','14:35:00',1.44),('15844','2013-10-16','14:40:00',1.33),('15844','2013-10-16','14:45:00',1.2),('15844','2013-10-16','14:50:00',1.27),('15844','2013-10-16','14:55:00',1.21),('15844','2013-10-16','15:00:00',1.07),('15844','2013-10-15','09:25:00',1.28),('15844','2013-10-15','09:35:00',1.22),('15844','2013-10-15','09:40:00',1.48),('15844','2013-10-15','09:45:00',1.98),('15844','2013-10-15','09:50:00',2.08),('15844','2013-10-15','09:55:00',2.07),('15844','2013-10-15','10:00:00',2.13),('15844','2013-10-15','10:05:00',2.04),('15844','2013-10-15','10:10:00',1.27),('15844','2013-10-15','10:15:00',1.02),('15844','2013-10-15','10:20:00',1.39),('15844','2013-10-15','10:25:00',1.96),('15844','2013-10-15','10:30:00',1.66),('15844','2013-10-15','10:35:00',1.79),('15844','2013-10-15','10:40:00',2.2),('15844','2013-10-15','10:45:00',2.07),('15844','2013-10-15','10:50:00',1.57),('15844','2013-10-15','10:55:00',1.67),('15844','2013-10-15','11:00:00',1.59),('15844','2013-10-15','11:05:00',2.26),('15844','2013-10-15','11:10:00',2.54),('15844','2013-10-15','11:15:00',2.55),('15844','2013-10-15','11:20:00',2.49),('15844','2013-10-15','11:25:00',2.41),('15844','2013-10-15','11:30:00',2.21),('15844','2013-10-15','11:35:00',1.69),('15844','2013-10-15','11:40:00',1.33),('15844','2013-10-15','11:45:00',1.28),('15844','2013-10-15','11:50:00',1.25),('15844','2013-10-15','11:55:00',1.21),('15844','2013-10-15','12:00:00',1.17),('15844','2013-10-15','12:05:00',1.21),('15844','2013-10-15','12:10:00',1.22),('15844','2013-10-15','12:15:00',1.29),('15844','2013-10-15','12:20:00',1.28),('15844','2013-10-15','12:25:00',1.13),('15844','2013-10-15','12:30:00',1.14),('15844','2013-10-15','12:35:00',1.15),('15844','2013-10-15','12:40:00',1.23),('15844','2013-10-15','12:45:00',1.22),('15844','2013-10-15','12:50:00',1.08),('15844','2013-10-15','12:55:00',1.04),('15844','2013-10-15','13:00:00',1.19),('15844','2013-10-15','13:05:00',1.56),('15844','2013-10-15','13:10:00',1.5),('15844','2013-10-15','13:15:00',1.99),('15844','2013-10-15','13:20:00',2.57),('15844','2013-10-15','13:25:00',1.64),('15844','2013-10-15','13:30:00',1.48),('15844','2013-10-15','13:35:00',1.3),('15844','2013-10-15','13:40:00',1.42),('15844','2013-10-15','13:45:00',1.31),('15844','2013-10-15','13:50:00',1.16),('15844','2013-10-15','13:55:00',1.02),('15844','2013-10-15','14:05:00',1.01),('15844','2013-10-15','14:10:00',1.24),('15844','2013-10-15','14:15:00',1.58),('15844','2013-10-15','14:20:00',1.58),('15844','2013-10-15','14:25:00',1.63),('15844','2013-10-15','14:30:00',1.1),('15844','2013-10-15','14:35:00',1.23),('15844','2013-10-15','14:40:00',1.48),('15844','2013-10-15','14:45:00',1.44),('15844','2013-10-15','14:50:00',1.45),('15844','2013-10-14','09:20:00',1.35),('15844','2013-10-14','09:25:00',1.53),('15844','2013-10-14','09:30:00',1.69),('15844','2013-10-14','09:35:00',1.31),('15844','2013-10-14','09:40:00',1.58),('15844','2013-10-14','09:45:00',1.69),('15844','2013-10-14','09:50:00',1.84),('15844','2013-10-14','09:55:00',1.73),('15844','2013-10-14','10:00:00',2.05),('15844','2013-10-14','10:05:00',2.16),('15844','2013-10-14','10:10:00',2.22),('15844','2013-10-14','10:15:00',2.28),('15844','2013-10-14','10:20:00',2.31),('15844','2013-10-14','10:25:00',2.36),('15844','2013-10-14','10:30:00',2.4),('15844','2013-10-14','10:35:00',2.38),('15844','2013-10-14','10:40:00',2.37),('15844','2013-10-14','10:45:00',2.52),('15844','2013-10-14','10:50:00',2.55),('15844','2013-10-14','10:55:00',2.58),('15844','2013-10-14','11:00:00',2.62),('15844','2013-10-14','11:05:00',2.64),('15844','2013-10-14','11:10:00',2.72),('15844','2013-10-14','11:15:00',2.69),('15844','2013-10-14','11:20:00',2.74),('15844','2013-10-14','11:25:00',2.82),('15844','2013-10-14','11:30:00',2.84),('15844','2013-10-14','11:35:00',2.8),('15844','2013-10-14','11:40:00',2.75),('15844','2013-10-14','11:45:00',2.81),('15844','2013-10-14','11:50:00',2.8),('15844','2013-10-14','11:55:00',2.83),('15844','2013-10-14','12:00:00',2.84),('15844','2013-10-14','12:05:00',2.83),('15844','2013-10-14','12:10:00',2.82),('15844','2013-10-14','12:15:00',2.67),('15844','2013-10-14','12:20:00',2.54),('15844','2013-10-14','12:25:00',2.76),('15844','2013-10-14','12:30:00',2.75),('15844','2013-10-14','12:35:00',2.73),('15844','2013-10-14','12:40:00',2.73),('15844','2013-10-14','12:45:00',2.72),('15844','2013-10-14','12:50:00',2.68),('15844','2013-10-14','12:55:00',2.65),('15844','2013-10-14','13:00:00',2.64),('15844','2013-10-14','13:05:00',2.6),('15844','2013-10-14','13:10:00',2.57),('15844','2013-10-14','13:15:00',2.54),('15844','2013-10-14','13:20:00',2.51),('15844','2013-10-14','13:25:00',2.46),('15844','2013-10-14','13:30:00',2.39),('15844','2013-10-14','13:35:00',2.34),('15844','2013-10-14','13:40:00',2.27),('15844','2013-10-14','13:45:00',2.22),('15844','2013-10-14','13:50:00',2.16),('15844','2013-10-14','13:55:00',2.08),('15844','2013-10-14','14:00:00',1.96),('15844','2013-10-14','14:05:00',1.91),('15844','2013-10-14','14:10:00',1.82),('15844','2013-10-14','14:15:00',1.73),('15844','2013-10-14','14:20:00',1.63),('15844','2013-10-14','14:25:00',1.55),('15844','2013-10-14','14:30:00',1.49),('15844','2013-10-14','14:35:00',1.42),('15844','2013-10-14','14:40:00',1.34),('15844','2013-10-14','14:45:00',1.26),('15844','2013-10-14','14:50:00',1.19),('15844','2013-10-14','14:55:00',1.11),('15844','2013-10-14','15:00:00',1.02),('15844','2013-10-13','09:10:00',1.35),('15844','2013-10-13','09:15:00',1.65),('15844','2013-10-13','09:20:00',1.71),('15844','2013-10-13','09:25:00',1.09),('15844','2013-10-13','09:30:00',1.05),('15844','2013-10-13','09:35:00',1.81),('15844','2013-10-13','09:40:00',2.29),('15844','2013-10-13','09:45:00',2.09),('15844','2013-10-13','09:50:00',2.4),('15844','2013-10-13','09:55:00',1.99),('15844','2013-10-13','10:00:00',1.45),('15844','2013-10-13','10:05:00',2.16),('15844','2013-10-13','10:10:00',1.98),('15844','2013-10-13','10:15:00',1.86),('15844','2013-10-13','10:20:00',1.59),('15844','2013-10-13','10:25:00',2.02),('15844','2013-10-13','10:30:00',2.9),('15844','2013-10-13','10:35:00',3.17),('15844','2013-10-13','10:40:00',3.14),('15844','2013-10-13','10:45:00',3.01),('15844','2013-10-13','10:50:00',3.16),('15844','2013-10-13','10:55:00',3.38),('15844','2013-10-13','11:00:00',2.03),('15844','2013-10-13','11:05:00',2.45),('15844','2013-10-13','11:10:00',2.91),('15844','2013-10-13','11:15:00',2.93),('15844','2013-10-13','11:20:00',2.91),('15844','2013-10-13','11:25:00',2.88),('15844','2013-10-13','11:30:00',2.91),('15844','2013-10-13','11:35:00',2.89),('15844','2013-10-13','11:40:00',2.83),('15844','2013-10-13','11:45:00',2.89),('15844','2013-10-13','11:50:00',2.9),('15844','2013-10-13','11:55:00',2.9),('15844','2013-10-13','12:00:00',2.91),('15844','2013-10-13','12:05:00',2.92),('15844','2013-10-13','12:10:00',2.88),('15844','2013-10-13','12:15:00',2.89),('15844','2013-10-13','12:20:00',2.79),('15844','2013-10-13','12:25:00',2.78),('15844','2013-10-13','12:30:00',2.83),('15844','2013-10-13','12:35:00',2.83),('15844','2013-10-13','12:40:00',2.77),('15844','2013-10-13','12:45:00',2.72),('15844','2013-10-13','12:50:00',2.7),('15844','2013-10-13','12:55:00',2.67),('15844','2013-10-13','13:00:00',2.63),('15844','2013-10-13','13:05:00',2.63),('15844','2013-10-13','13:10:00',2.64),('15844','2013-10-13','13:15:00',2.65),('15844','2013-10-13','13:20:00',2.6),('15844','2013-10-13','13:25:00',2.09),('15844','2013-10-13','13:30:00',2.38),('15844','2013-10-13','13:35:00',2.17),('15844','2013-10-13','13:40:00',2.09),('15844','2013-10-13','13:45:00',2.21),('15844','2013-10-13','13:50:00',2.33),('15844','2013-10-13','13:55:00',1.6),('15844','2013-10-13','14:00:00',2.2),('15844','2013-10-13','14:05:00',2.15),('15844','2013-10-13','14:10:00',2.06),('15844','2013-10-13','14:15:00',1.93),('15844','2013-10-13','14:20:00',1.91),('15844','2013-10-13','14:25:00',1.82),('15844','2013-10-13','14:30:00',1.43),('15844','2013-10-13','14:35:00',1.32),('15844','2013-10-13','14:40:00',1.49),('15844','2013-10-13','14:45:00',1.25),('15844','2013-10-13','14:50:00',1.23),('15844','2013-10-13','14:55:00',1.28),('15844','2013-10-13','15:00:00',1.53),('15844','2013-10-13','15:05:00',1.37),('15844','2013-10-13','15:10:00',1.2),('15844','2013-10-13','15:15:00',1.14),('15844','2013-10-13','15:20:00',1.24),('15844','2013-10-13','15:25:00',1.08),('15844','2013-10-13','15:30:00',1.05),('15844','2013-10-12','11:20:00',1.02),('15844','2013-10-12','11:25:00',1.05),('15844','2013-10-12','11:30:00',1.55),('15844','2013-10-12','11:35:00',2.29),('15844','2013-10-12','11:40:00',1.48),('15844','2013-10-12','11:45:00',1.2),('15844','2013-10-12','11:50:00',1.11),('15844','2013-10-12','12:15:00',1.27),('15844','2013-10-12','12:20:00',2.83),('15844','2013-10-12','12:25:00',1.94),('15844','2013-10-12','12:30:00',2.06),('15844','2013-10-12','12:35:00',2.8),('15844','2013-10-12','12:40:00',2.48),('15844','2013-10-12','12:45:00',2.63),('15844','2013-10-12','12:50:00',2.28),('15844','2013-10-12','12:55:00',2.1),('15844','2013-10-12','13:00:00',1.05),('15844','2013-10-12','13:15:00',1.02),('15844','2013-10-12','13:20:00',1.2),('15844','2013-10-12','13:25:00',2.33),('15844','2013-10-12','13:30:00',1.55),('15844','2013-10-12','16:15:00',1.02),('15844','2013-10-12','16:20:00',1.11),('15844','2013-10-11','08:40:00',1.08),('15844','2013-10-11','08:55:00',1.06),('15844','2013-10-11','09:00:00',1.32),('15844','2013-10-11','09:05:00',1.45),('15844','2013-10-11','09:10:00',1.52),('15844','2013-10-11','09:15:00',1.57),('15844','2013-10-11','09:20:00',1.65),('15844','2013-10-11','09:25:00',1.79),('15844','2013-10-11','09:30:00',1.94),('15844','2013-10-11','09:35:00',2.06),('15844','2013-10-11','09:40:00',2.15),('15844','2013-10-11','09:45:00',2.23),('15844','2013-10-11','09:50:00',2.31),('15844','2013-10-11','09:55:00',2.31),('15844','2013-10-11','10:00:00',2.37),('15844','2013-10-11','10:05:00',2.42),('15844','2013-10-11','10:10:00',2.57),('15844','2013-10-11','10:15:00',2.63),('15844','2013-10-11','10:20:00',2.78),('15844','2013-10-11','10:25:00',2.92),('15844','2013-10-11','10:30:00',3.04),('15844','2013-10-11','10:35:00',3.59),('15844','2013-10-11','10:40:00',2.16),('15844','2013-10-11','10:45:00',2.89),('15844','2013-10-11','10:50:00',1.5),('15844','2013-10-11','10:55:00',2.51),('15844','2013-10-11','11:00:00',1.14),('15844','2013-10-11','11:40:00',1.86),('15844','2013-10-11','12:10:00',2.95),('15844','2013-10-11','12:15:00',3.07),('15844','2013-10-11','13:40:00',1.95),('15844','2013-10-11','13:45:00',1.8),('15844','2013-10-11','13:50:00',1.34),('15844','2013-10-10','08:40:00',1.04),('15844','2013-10-10','08:45:00',1.06),('15844','2013-10-10','08:50:00',1.2),('15844','2013-10-10','08:55:00',1.33),('15844','2013-10-10','09:00:00',1.4),('15844','2013-10-10','09:05:00',1.44),('15844','2013-10-10','09:10:00',1.49),('15844','2013-10-10','09:15:00',1.57),('15844','2013-10-10','09:20:00',1.67),('15844','2013-10-10','09:25:00',1.73),('15844','2013-10-10','09:30:00',1.77),('15844','2013-10-10','09:35:00',2),('15844','2013-10-10','09:40:00',2.06),('15844','2013-10-10','09:45:00',2.12),('15844','2013-10-10','09:50:00',2.23),('15844','2013-10-10','09:55:00',2.22),('15844','2013-10-10','10:00:00',2.23),('15844','2013-10-10','10:05:00',2.52),('15844','2013-10-10','10:10:00',1.65),('15844','2013-10-10','10:25:00',1.47),('15844','2013-10-10','10:30:00',1.79),('15844','2013-10-10','10:35:00',3.14),('15844','2013-10-10','10:40:00',3.02),('15844','2013-10-10','10:45:00',2.7),('15844','2013-10-10','10:50:00',1.11),('15844','2013-10-10','11:00:00',1.39),('15844','2013-10-10','11:05:00',2.76),('15844','2013-10-10','11:10:00',3.11),('15844','2013-10-10','11:15:00',3.36),('15844','2013-10-10','11:20:00',2.2),('15844','2013-10-10','11:25:00',2.72),('15844','2013-10-10','11:35:00',1.41),('15844','2013-10-10','11:40:00',2.55),('15844','2013-10-10','11:45:00',3.64),('15844','2013-10-10','11:50:00',3.74),('15844','2013-10-10','11:55:00',3.54),('15844','2013-10-10','12:00:00',3.13),('15844','2013-10-10','12:05:00',1.6),('15844','2013-10-10','12:10:00',3.7),('15844','2013-10-10','12:15:00',3),('15844','2013-10-10','12:20:00',2.52),('15844','2013-10-10','12:25:00',1.31),('15844','2013-10-10','12:30:00',2.53),('15844','2013-10-10','12:35:00',1.74),('15844','2013-10-10','12:40:00',3.81),('15844','2013-10-10','12:45:00',1.73),('15844','2013-10-10','12:50:00',3.16),('15844','2013-10-10','12:55:00',3.51),('15844','2013-10-10','13:00:00',3.22),('15844','2013-10-10','13:05:00',3.19),('15844','2013-10-10','13:10:00',1.53),('15844','2013-10-10','13:15:00',2.13),('15844','2013-10-10','13:20:00',3.02),('15844','2013-10-10','13:25:00',2.57),('15844','2013-10-10','13:30:00',1.43),('15844','2013-10-10','13:35:00',2.95),('15844','2013-10-10','13:40:00',2.34),('15844','2013-10-10','13:45:00',2.72),('15844','2013-10-10','13:50:00',2.24),('15844','2013-10-10','13:55:00',2.58),('15844','2013-10-10','14:00:00',1.87),('15844','2013-10-10','14:05:00',2.28),('15844','2013-10-10','14:10:00',1.22),('15844','2013-10-10','14:20:00',1.14),('15844','2013-10-10','14:25:00',2.21),('15844','2013-10-10','14:30:00',1.54),('15844','2013-10-10','14:35:00',1.8),('15844','2013-10-10','14:40:00',1.4),('15844','2013-10-10','14:45:00',1.57),('15844','2013-10-10','14:50:00',1.2),('15844','2013-10-10','14:55:00',1.38),('15844','2013-10-10','15:25:00',1.04),('15844','2013-10-10','15:30:00',1.06),('15844','2013-10-10','15:35:00',1.09),('15844','2013-10-10','15:40:00',1.02),('15844','2013-10-09','08:40:00',1.11),('15844','2013-10-09','08:45:00',1.18),('15844','2013-10-09','08:50:00',1.25),('15844','2013-10-09','08:55:00',1.32),('15844','2013-10-09','09:00:00',1.4),('15844','2013-10-09','09:05:00',1.5),('15844','2013-10-09','09:10:00',1.61),('15844','2013-10-09','09:15:00',1.36),('15844','2013-10-09','09:20:00',1.74),('15844','2013-10-09','09:25:00',1.89),('15844','2013-10-09','09:30:00',2.18),('15844','2013-10-09','09:35:00',2.37),('15844','2013-10-09','09:40:00',2.53),('15844','2013-10-09','09:45:00',2.48),('15844','2013-10-09','09:50:00',2.48),('15844','2013-10-09','09:55:00',2.58),('15844','2013-10-09','10:00:00',2.18),('15844','2013-10-09','11:15:00',1),('15844','2013-10-09','11:20:00',1.16),('15844','2013-10-09','11:25:00',1.28),('15844','2013-10-09','11:30:00',3.97),('15844','2013-10-09','11:35:00',3.09),('15844','2013-10-09','11:40:00',2.7),('15844','2013-10-09','11:45:00',1.82),('15844','2013-10-09','11:50:00',1.87),('15844','2013-10-09','11:55:00',2.54),('15844','2013-10-09','12:00:00',2.46),('15844','2013-10-09','12:05:00',2.23),('15844','2013-10-09','12:10:00',2.93),('15844','2013-10-09','12:15:00',3.2),('15844','2013-10-09','12:20:00',1.47),('15844','2013-10-09','12:25:00',1.5),('15844','2013-10-09','13:00:00',1.13),('15844','2013-10-09','13:05:00',1.59),('15844','2013-10-09','13:20:00',1.09),('15844','2013-10-09','13:25:00',2.58),('15844','2013-10-09','13:30:00',1.57),('15844','2013-10-09','13:35:00',2.8),('15844','2013-10-09','13:40:00',1.12),('15844','2013-10-09','14:00:00',2.79),('15844','2013-10-09','14:05:00',2.33),('15844','2013-10-09','14:10:00',1.76),('15844','2013-10-09','14:15:00',1.58),('15844','2013-10-09','14:20:00',1.65),('15844','2013-10-09','14:25:00',1.74),('15844','2013-10-09','14:35:00',2.13),('15844','2013-10-09','14:40:00',1.67),('15844','2013-10-09','14:45:00',1.09),('15844','2013-10-09','15:00:00',1.42),('15844','2013-10-09','15:05:00',1.16),('15844','2013-10-09','15:15:00',1.08),('15844','2013-10-09','15:30:00',1.06),('15844','2014-04-15','09:00:00',1.66),('15844','2014-04-15','09:05:00',1.45),('15844','2014-04-15','09:10:00',1.48),('15844','2014-04-15','09:15:00',1.77),('15844','2014-04-15','09:20:00',1.52),('15844','2014-04-15','09:25:00',1.54),('15844','2014-04-15','09:30:00',1.19),('15844','2014-04-15','10:00:00',1.56),('15844','2014-04-15','10:05:00',1.51),('15844','2014-04-15','10:10:00',1.59),('15844','2014-04-15','10:15:00',2.77),('15844','2014-04-15','10:20:00',1.85),('15844','2014-04-15','10:25:00',2.12),('15844','2014-04-15','10:30:00',1.31),('15844','2014-04-15','10:35:00',1.87),('15844','2014-04-15','10:40:00',3.06),('15844','2014-04-15','10:45:00',3.78),('15844','2014-04-15','10:50:00',4.25),('15844','2014-04-15','10:55:00',3.85),('15844','2014-04-15','11:00:00',4.4),('15844','2014-04-15','11:05:00',3.22),('15844','2014-04-15','11:10:00',1.7),('15844','2014-04-15','11:20:00',1.51),('15844','2014-04-15','11:25:00',1.17),('15844','2014-04-15','11:40:00',1.06),('15844','2014-04-15','11:45:00',1.16),('15844','2014-04-15','12:10:00',2.44),('15844','2014-04-15','12:15:00',1.95),('15844','2014-04-15','13:00:00',1.08),('15844','2014-04-15','13:05:00',1.34),('15844','2014-04-15','13:10:00',1.08),('15844','2014-04-15','13:15:00',1.84),('15844','2014-04-15','13:20:00',2.5),('15844','2014-04-15','13:35:00',2.62),('15844','2014-04-15','13:40:00',2.31),('15844','2014-04-15','13:45:00',1.61),('15844','2014-04-15','13:50:00',3.51),('15844','2014-04-15','13:55:00',2.11),('15844','2014-04-15','14:00:00',3.26),('15844','2014-04-15','14:05:00',1.56),('15844','2014-04-15','14:10:00',2.76),('15844','2014-04-15','14:15:00',3.8),('15844','2014-04-15','14:20:00',2.31),('15844','2014-04-15','14:25:00',2.13),('15844','2014-04-15','14:30:00',3.01),('15844','2014-04-15','14:35:00',2.36),('15844','2014-04-15','14:40:00',2.04),('15844','2014-04-15','14:45:00',1.54),('15844','2014-04-15','14:50:00',2.72),('15844','2014-04-15','14:55:00',2.58),('15844','2014-04-15','15:00:00',2.38),('15844','2014-04-15','15:05:00',2.06),('15844','2014-04-15','15:10:00',1.31),('15844','2014-04-15','15:15:00',1.54),('15844','2014-04-15','15:20:00',2.03),('15844','2014-04-15','15:25:00',2.36),('15844','2014-04-15','15:30:00',1.78),('15844','2014-04-15','15:35:00',1.59),('15844','2014-04-15','15:40:00',1.66),('15844','2014-04-15','15:45:00',1.4),('15844','2014-04-15','15:50:00',1.22),('15844','2014-04-15','15:55:00',1.17),('15844','2014-04-15','16:00:00',1.04),('15844','2013-10-08','09:45:00',2.08),('15844','2013-10-08','09:55:00',2.69),('15844','2013-10-08','10:00:00',2.41),('15844','2013-10-08','10:05:00',3.02),('15844','2013-10-08','10:10:00',2.15),('15844','2013-10-08','11:20:00',2.39),('15844','2013-10-08','11:25:00',1.14),('15844','2013-10-08','12:25:00',1.11),('15844','2013-10-08','12:30:00',1.17),('15844','2013-10-08','12:35:00',1.3),('15844','2013-10-08','12:45:00',1.04),('15844','2013-10-08','12:50:00',2.83),('15844','2013-10-08','12:55:00',1.73),('15844','2013-10-08','13:00:00',1.88),('15844','2013-10-08','13:05:00',1.92),('15844','2013-10-08','13:10:00',1.06),('15844','2013-10-08','13:15:00',1.08),('15844','2013-10-08','13:20:00',1.82),('15844','2013-10-08','13:25:00',1.03),('15844','2013-10-08','13:30:00',1.08),('15844','2013-10-08','13:45:00',1.08),('15844','2013-10-08','14:20:00',1.21),('15844','2013-10-08','14:25:00',1.39),('15844','2013-10-08','14:30:00',2.35),('15844','2013-10-08','14:35:00',1.97),('15844','2013-10-08','14:40:00',1.63),('15844','2013-10-08','14:45:00',1.86),('15844','2013-10-08','14:50:00',1.59),('15844','2013-10-08','14:55:00',1.4),('15844','2013-10-08','15:00:00',1.28),('15844','2013-10-08','15:05:00',1.07),('15844','2013-10-07','09:05:00',1.87),('15844','2013-10-07','09:10:00',2),('15844','2013-10-07','09:15:00',1.77),('15844','2013-10-07','09:20:00',1.77),('15844','2013-10-07','09:25:00',1.86),('15844','2013-10-07','09:30:00',2.05),('15844','2013-10-07','09:35:00',2.13),('15844','2013-10-07','09:40:00',2.22),('15844','2013-10-07','09:45:00',2.25),('15844','2013-10-07','09:50:00',2.3),('15844','2013-10-07','09:55:00',2.35),('15844','2013-10-07','10:00:00',2.42),('15844','2013-10-07','10:05:00',2.51),('15844','2013-10-07','10:10:00',2.55),('15844','2013-10-07','10:15:00',2.59),('15844','2013-10-07','10:20:00',2.64),('15844','2013-10-07','10:25:00',2.69),('15844','2013-10-07','10:30:00',2.74),('15844','2013-10-07','10:35:00',2.71),('15844','2013-10-07','10:40:00',2.7),('15844','2013-10-07','10:45:00',2.72),('15844','2013-10-07','10:50:00',2.68),('15844','2013-10-07','10:55:00',2.51),('15844','2013-10-07','11:00:00',3.2),('15844','2013-10-07','11:05:00',3.17),('15844','2013-10-07','11:10:00',3.02),('15844','2013-10-07','11:15:00',3.05),('15844','2013-10-07','11:20:00',3.09),('15844','2013-10-07','11:25:00',3.09),('15844','2013-10-07','11:30:00',2.63),('15844','2013-10-07','11:35:00',3.1),('15844','2013-10-07','11:40:00',3.46),('15844','2013-10-07','11:45:00',3.26),('15844','2013-10-07','11:50:00',3.26),('15844','2013-10-07','11:55:00',3.24),('15844','2013-10-07','12:00:00',3.16),('15844','2013-10-07','12:05:00',3.34),('15844','2013-10-07','12:10:00',1.21),('15844','2013-10-07','12:15:00',1.44),('15844','2013-10-07','12:25:00',1.21),('15844','2013-10-07','12:35:00',1.49),('15844','2013-10-07','12:40:00',2.76),('15844','2013-10-07','12:45:00',2.14),('15844','2013-10-07','12:50:00',2.07),('15844','2013-10-07','12:55:00',1.77),('15844','2013-10-07','13:00:00',1.6),('15844','2013-10-07','13:05:00',2.35),('15844','2013-10-07','13:10:00',2.76),('15844','2013-10-07','13:15:00',1.81),('15844','2013-10-07','13:20:00',2.81),('15844','2013-10-07','13:30:00',2.41),('15844','2013-10-07','13:40:00',1.32),('15844','2013-10-07','13:45:00',1.91),('15844','2013-10-07','13:50:00',3.04),('15844','2013-10-07','13:55:00',2.6),('15844','2013-10-07','14:00:00',3.01),('15844','2013-10-07','14:05:00',2.38),('15844','2013-10-07','14:10:00',2.24),('15844','2013-10-07','14:15:00',1.72),('15844','2013-10-07','14:20:00',2.19),('15844','2013-10-07','14:25:00',2.35),('15844','2013-10-07','14:30:00',2.22),('15844','2013-10-07','14:35:00',1.69),('15844','2013-10-07','14:40:00',1.91),('15844','2013-10-07','14:45:00',1.66),('15844','2013-10-07','14:50:00',1.18),('15844','2013-10-07','14:55:00',1.56),('15844','2013-10-07','15:00:00',1.4),('15844','2013-10-07','15:10:00',1.26),('15844','2013-10-07','15:15:00',1.13),('15844','2013-10-07','15:20:00',1.19),('15844','2013-10-07','15:30:00',1.01),('15844','2013-10-07','15:35:00',1.3),('15844','2013-10-06','09:05:00',1.28),('15844','2013-10-06','09:30:00',1.34),('15844','2013-10-06','09:35:00',1.92),('15844','2013-10-06','09:40:00',1.84),('15844','2013-10-06','09:45:00',1.72),('15844','2013-10-06','09:50:00',2.27),('15844','2013-10-06','09:55:00',2.43),('15844','2013-10-06','10:00:00',2.69),('15844','2013-10-06','10:05:00',2.41),('15844','2013-10-06','10:10:00',2.49),('15844','2013-10-06','10:15:00',2.4),('15844','2013-10-06','10:20:00',2.43),('15844','2013-10-06','10:25:00',2.77),('15844','2013-10-06','10:30:00',2.62),('15844','2013-10-06','10:35:00',2.36),('15844','2013-10-06','10:40:00',2),('15844','2013-10-06','10:45:00',2.27),('15844','2013-10-06','10:50:00',2.36),('15844','2013-10-06','10:55:00',2.52),('15844','2013-10-06','11:00:00',2.67),('15844','2013-10-06','11:05:00',2.57),('15844','2013-10-06','11:10:00',2.82),('15844','2013-10-06','11:15:00',2.74),('15844','2013-10-06','11:20:00',2.66),('15844','2013-10-06','11:25:00',2.2),('15844','2013-10-06','11:30:00',2.75),('15844','2013-10-06','11:35:00',2.21),('15844','2013-10-06','11:40:00',1.86),('15844','2013-10-06','11:45:00',2.08),('15844','2013-10-06','11:50:00',1.95),('15844','2013-10-06','11:55:00',2.52),('15844','2013-10-06','12:00:00',2.32),('15844','2013-10-06','12:05:00',2.92),('15844','2013-10-06','12:10:00',3.34),('15844','2013-10-06','12:15:00',2.49),('15844','2013-10-06','12:20:00',1.42),('15844','2013-10-06','12:25:00',2.88),('15844','2013-10-06','12:30:00',1.48),('15844','2013-10-06','12:35:00',2.75),('15844','2013-10-06','12:40:00',2.49),('15844','2013-10-06','12:45:00',2.53),('15844','2013-10-06','12:50:00',2.52),('15844','2013-10-06','12:55:00',2.68),('15844','2013-10-06','13:00:00',2.38),('15844','2013-10-06','13:05:00',3.06),('15844','2013-10-06','13:10:00',2.22),('15844','2013-10-06','13:15:00',2.22),('15844','2013-10-06','13:40:00',1.1),('15844','2013-10-06','13:45:00',2.18),('15844','2013-10-06','13:50:00',2.95),('15844','2013-10-06','13:55:00',1.92),('15844','2013-10-06','14:00:00',1.97),('15844','2013-10-06','14:05:00',1.25),('15844','2013-10-06','14:10:00',1.26),('15844','2013-10-06','14:15:00',1.47),('15844','2013-10-06','14:20:00',1.6),('15844','2013-10-06','14:25:00',1.97),('15844','2013-10-06','14:30:00',1.57),('15844','2013-10-06','14:35:00',1.25),('15844','2013-10-06','14:40:00',1.37),('15844','2013-10-06','14:45:00',1.44),('15844','2013-10-06','14:50:00',1.42),('15844','2013-10-06','14:55:00',1.29),('15844','2013-10-06','15:00:00',1.41),('15844','2013-10-06','15:05:00',1.22),('15844','2013-10-06','15:10:00',1.05),('15844','2013-10-06','15:15:00',1.04),('15844','2013-10-04','09:10:00',1.04),('15844','2013-10-04','09:25:00',1.38),('15844','2013-10-04','09:35:00',1.07),('15844','2013-10-04','09:40:00',1.16),('15844','2013-10-04','09:45:00',1.15),('15844','2013-10-04','09:50:00',1.32),('15844','2013-10-04','09:55:00',1.45),('15844','2013-10-04','10:00:00',1.31),('15844','2013-10-04','10:05:00',1.33),('15844','2013-10-04','10:10:00',1.38),('15844','2013-10-04','10:15:00',1.42),('15844','2013-10-04','10:20:00',1.59),('15844','2013-10-04','10:25:00',1.81),('15844','2013-10-04','10:30:00',2.31),('15844','2013-10-04','10:35:00',2.65),('15844','2013-10-04','10:40:00',2.97),('15844','2013-10-04','10:45:00',2.91),('15844','2013-10-04','10:50:00',1.66),('15844','2013-10-04','10:55:00',2.23),('15844','2013-10-04','11:00:00',2.45),('15844','2013-10-04','11:05:00',1.51),('15844','2013-10-04','11:10:00',1.83),('15844','2013-10-04','11:15:00',2.59),('15844','2013-10-04','11:20:00',2.63),('15844','2013-10-04','11:25:00',2.59),('15844','2013-10-04','11:30:00',3.21),('15844','2013-10-04','11:35:00',2.71),('15844','2013-10-04','11:40:00',2.39),('15844','2013-10-04','11:45:00',3.24),('15844','2013-10-04','11:50:00',3.21),('15844','2013-10-04','11:55:00',3.21),('15844','2013-10-04','12:00:00',3.23),('15844','2013-10-04','12:05:00',3.22),('15844','2013-10-04','12:10:00',2.86),('15844','2013-10-04','12:15:00',3.27),('15844','2013-10-04','12:20:00',3.2),('15844','2013-10-04','12:25:00',3.21),('15844','2013-10-04','12:30:00',3.2),('15844','2013-10-04','12:35:00',3.09),('15844','2013-10-04','12:40:00',3),('15844','2013-10-04','12:45:00',3.05),('15844','2013-10-04','12:50:00',2.88),('15844','2013-10-04','12:55:00',2.95),('15844','2013-10-04','13:00:00',2.96),('15844','2013-10-04','13:05:00',2.92),('15844','2013-10-04','13:10:00',2.98),('15844','2013-10-04','13:15:00',2.96),('15844','2013-10-04','13:20:00',2.81),('15844','2013-10-04','13:25:00',2.79),('15844','2013-10-04','13:30:00',2.87),('15844','2013-10-04','13:35:00',2.75),('15844','2013-10-04','13:40:00',2.67),('15844','2013-10-04','13:45:00',2.54),('15844','2013-10-04','13:50:00',2.49),('15844','2013-10-04','13:55:00',2.45),('15844','2013-10-04','14:00:00',2.36),('15844','2013-10-04','14:05:00',2.16),('15844','2013-10-04','14:10:00',1.91),('15844','2013-10-04','14:15:00',1.93),('15844','2013-10-04','14:20:00',2.04),('15844','2013-10-04','14:25:00',1.71),('15844','2013-10-04','14:30:00',1.46),('15844','2013-10-04','14:35:00',1.07),('15844','2013-10-04','14:40:00',1.22),('15844','2013-10-04','14:45:00',1.39),('15844','2013-10-04','14:50:00',1.67),('15844','2013-10-04','14:55:00',1.36),('15844','2013-10-04','15:00:00',1.41),('15844','2013-10-04','15:05:00',1.09),('15844','2013-10-04','15:10:00',1.08),('15844','2013-10-04','15:25:00',1.06),('15844','2013-10-04','15:30:00',1.07),('15844','2013-10-03','08:50:00',1.06),('15844','2013-10-03','08:55:00',1.18),('15844','2013-10-03','09:00:00',1.35),('15844','2013-10-03','09:05:00',1.5),('15844','2013-10-03','09:10:00',1.61),('15844','2013-10-03','09:15:00',1.72),('15844','2013-10-03','09:20:00',1.82),('15844','2013-10-03','09:25:00',1.9),('15844','2013-10-03','09:30:00',2),('15844','2013-10-03','09:35:00',2.08),('15844','2013-10-03','09:40:00',2.16),('15844','2013-10-03','09:45:00',2.26),('15844','2013-10-03','09:50:00',2.36),('15844','2013-10-03','09:55:00',2.42),('15844','2013-10-03','10:00:00',2.52),('15844','2013-10-03','10:05:00',2.59),('15844','2013-10-03','10:10:00',2.65),('15844','2013-10-03','10:15:00',2.73),('15844','2013-10-03','10:20:00',2.84),('15844','2013-10-03','10:25:00',2.88),('15844','2013-10-03','10:30:00',2.92),('15844','2013-10-03','10:35:00',2.98),('15844','2013-10-03','10:40:00',3),('15844','2013-10-03','10:45:00',3.04),('15844','2013-10-03','10:50:00',3.08),('15844','2013-10-03','10:55:00',3.11),('15844','2013-10-03','11:00:00',3.13),('15844','2013-10-03','11:05:00',3.18),('15844','2013-10-03','11:10:00',3.2),('15844','2013-10-03','11:15:00',3.24),('15844','2013-10-03','11:20:00',3.27),('15844','2013-10-03','11:25:00',3.3),('15844','2013-10-03','11:30:00',3.33),('15844','2013-10-03','11:35:00',3.33),('15844','2013-10-03','11:40:00',3.36),('15844','2013-10-03','11:45:00',3.37),('15844','2013-10-03','11:50:00',3.38),('15844','2013-10-03','11:55:00',3.38),('15844','2013-10-03','12:00:00',3.38),('15844','2013-10-03','12:05:00',3.37),('15844','2013-10-03','12:10:00',3.38),('15844','2013-10-03','12:15:00',3.37),('15844','2013-10-03','12:20:00',3.39),('15844','2013-10-03','12:25:00',3.36),('15844','2013-10-03','12:30:00',3.34),('15844','2013-10-03','12:35:00',3.31),('15844','2013-10-03','12:40:00',3.29),('15844','2013-10-03','12:45:00',3.22),('15844','2013-10-03','12:50:00',3.24),('15844','2013-10-03','12:55:00',3.22),('15844','2013-10-03','13:00:00',3.15),('15844','2013-10-03','13:05:00',3.16),('15844','2013-10-03','13:10:00',3.12),('15844','2013-10-03','13:15:00',3.08),('15844','2013-10-03','13:20:00',3.05),('15844','2013-10-03','13:25:00',3),('15844','2013-10-03','13:30:00',2.96),('15844','2013-10-03','13:35:00',2.89),('15844','2013-10-03','13:40:00',2.83),('15844','2013-10-03','13:45:00',2.77),('15844','2013-10-03','13:50:00',2.7),('15844','2013-10-03','13:55:00',2.62),('15844','2013-10-03','14:00:00',2.55),('15844','2013-10-03','14:05:00',2.45),('15844','2013-10-03','14:10:00',2.39),('15844','2013-10-03','14:15:00',2.29),('15844','2013-10-03','14:20:00',2.19),('15844','2013-10-03','14:25:00',2.1),('15844','2013-10-03','14:30:00',2),('15844','2013-10-03','14:35:00',1.9),('15844','2013-10-03','14:40:00',1.8),('15844','2013-10-03','14:45:00',1.68),('15844','2013-10-03','14:50:00',1.57),('15844','2013-10-03','14:55:00',1.45),('15844','2013-10-03','15:00:00',1.36),('15844','2013-10-03','15:05:00',1.23),('15844','2013-10-03','15:10:00',1.14),('15844','2013-10-03','15:15:00',1.09),('15844','2013-10-03','15:20:00',1.03),('15844','2013-10-02','08:55:00',1.1),('15844','2013-10-02','09:00:00',1.27),('15844','2013-10-02','09:05:00',1.43),('15844','2013-10-02','09:10:00',1.53),('15844','2013-10-02','09:15:00',1.63),('15844','2013-10-02','09:20:00',1.71),('15844','2013-10-02','09:25:00',1.83),('15844','2013-10-02','09:30:00',1.93),('15844','2013-10-02','09:35:00',2.01),('15844','2013-10-02','09:40:00',2.12),('15844','2013-10-02','09:45:00',2.22),('15844','2013-10-02','09:50:00',2.33),('15844','2013-10-02','09:55:00',2.4),('15844','2013-10-02','10:00:00',2.46),('15844','2013-10-02','10:05:00',2.52),('15844','2013-10-02','10:10:00',2.59),('15844','2013-10-02','10:15:00',2.68),('15844','2013-10-02','10:20:00',2.78),('15844','2013-10-02','10:25:00',2.84),('15844','2013-10-02','10:30:00',2.9),('15844','2013-10-02','10:35:00',2.95),('15844','2013-10-02','10:40:00',3.01),('15844','2013-10-02','10:45:00',3.03),('15844','2013-10-02','10:50:00',3.07),('15844','2013-10-02','10:55:00',3.1),('15844','2013-10-02','11:00:00',3.12),('15844','2013-10-02','11:05:00',3.15),('15844','2013-10-02','11:10:00',3.19),('15844','2013-10-02','11:15:00',3.22),('15844','2013-10-02','11:20:00',3.23),('15844','2013-10-02','11:25:00',3.27),('15844','2013-10-02','11:30:00',3.29),('15844','2013-10-02','11:35:00',3.32),('15844','2013-10-02','11:40:00',3.32),('15844','2013-10-02','11:45:00',3.34),('15844','2013-10-02','11:50:00',3.35),('15844','2013-10-02','11:55:00',3.35),('15844','2013-10-02','12:00:00',3.35),('15844','2013-10-02','12:05:00',3.32),('15844','2013-10-02','12:10:00',3.33),('15844','2013-10-02','12:15:00',3.32),('15844','2013-10-02','12:20:00',3.32),('15844','2013-10-02','12:25:00',3.31),('15844','2013-10-02','12:30:00',3.29),('15844','2013-10-02','12:35:00',3.27),('15844','2013-10-02','12:40:00',3.24),('15844','2013-10-02','12:45:00',3.23),('15844','2013-10-02','12:50:00',3.2),('15844','2013-10-02','12:55:00',3.17),('15844','2013-10-02','13:00:00',3.15),('15844','2013-10-02','13:05:00',3.13),('15844','2013-10-02','13:10:00',3.1),('15844','2013-10-02','13:15:00',3.04),('15844','2013-10-02','13:20:00',3),('15844','2013-10-02','13:25:00',2.97),('15844','2013-10-02','13:30:00',2.93),('15844','2013-10-02','13:35:00',2.86),('15844','2013-10-02','13:40:00',2.8),('15844','2013-10-02','13:45:00',2.72),('15844','2013-10-02','13:50:00',2.65),('15844','2013-10-02','13:55:00',2.62),('15844','2013-10-02','14:00:00',2.53),('15844','2013-10-02','14:05:00',2.44),('15844','2013-10-02','14:10:00',2.34),('15844','2013-10-02','14:15:00',2.26),('15844','2013-10-02','14:20:00',2.17),('15844','2013-10-02','14:25:00',2.09),('15844','2013-10-02','14:30:00',1.98),('15844','2013-10-02','14:35:00',1.89),('15844','2013-10-02','14:40:00',1.8),('15844','2013-10-02','14:45:00',1.69),('15844','2013-10-02','14:50:00',1.56),('15844','2013-10-02','14:55:00',1.45),('15844','2013-10-02','15:00:00',1.35),('15844','2013-10-02','15:05:00',1.22),('15844','2013-10-02','15:10:00',1.15),('15844','2013-10-02','15:15:00',1.09),('15844','2013-10-02','15:20:00',1.02),('15844','2013-10-01','08:50:00',1.11),('15844','2013-10-01','08:55:00',1.24),('15844','2013-10-01','09:00:00',1.39),('15844','2013-10-01','09:05:00',1.54),('15844','2013-10-01','09:10:00',1.67),('15844','2013-10-01','09:15:00',1.74),('15844','2013-10-01','09:20:00',1.84),('15844','2013-10-01','09:25:00',1.92),('15844','2013-10-01','09:30:00',2.02),('15844','2013-10-01','09:35:00',2.13),('15844','2013-10-01','09:40:00',2.19),('15844','2013-10-01','09:45:00',2.32),('15844','2013-10-01','09:50:00',2.38),('15844','2013-10-01','09:55:00',2.42),('15844','2013-10-01','10:00:00',2.45),('15844','2013-10-01','10:05:00',2.51),('15844','2013-10-01','10:10:00',2.58),('15844','2013-10-01','10:15:00',2.57),('15844','2013-10-01','10:20:00',2.66),('15844','2013-10-01','10:25:00',2.89),('15844','2013-10-01','10:30:00',2.61),('15844','2013-10-01','10:35:00',2.24),('15844','2013-10-01','10:40:00',2.03),('15844','2013-10-01','10:45:00',2.06),('15844','2013-10-01','10:50:00',3.09),('15844','2013-10-01','10:55:00',3.14),('15844','2013-10-01','11:00:00',3.07),('15844','2013-10-01','11:05:00',1.96),('15844','2013-10-01','11:10:00',3.09),('15844','2013-10-01','11:15:00',1.17),('15844','2013-10-01','11:20:00',2.34),('15844','2013-10-01','11:25:00',2.14),('15844','2013-10-01','11:35:00',1.83),('15844','2013-10-01','11:40:00',1.66),('15844','2013-10-01','11:45:00',3.66),('15844','2013-10-01','11:50:00',3.76),('15844','2013-10-01','11:55:00',3.54),('15844','2013-10-01','12:00:00',3.21),('15844','2013-10-01','12:05:00',1.64),('15844','2013-10-01','12:10:00',2.41),('15844','2013-10-01','12:15:00',2.63),('15844','2013-10-01','12:20:00',2.16),('15844','2013-10-01','12:25:00',3.61),('15844','2013-10-01','12:30:00',3.49),('15844','2013-10-01','12:35:00',3.54),('15844','2013-10-01','12:40:00',3.55),('15844','2013-10-01','12:45:00',3.4),('15844','2013-10-01','12:50:00',3.44),('15844','2013-10-01','12:55:00',3.41),('15844','2013-10-01','13:00:00',2),('15844','2013-10-01','13:05:00',1.24),('15844','2013-10-01','13:10:00',3.4),('15844','2013-10-01','13:15:00',3.27),('15844','2013-10-01','13:20:00',3.22),('15844','2013-10-01','13:25:00',3.1),('15844','2013-10-01','13:30:00',2.99),('15844','2013-10-01','13:35:00',2.92),('15844','2013-10-01','13:40:00',2.84),('15844','2013-10-01','13:45:00',1.66),('15844','2013-10-01','13:50:00',2.68),('15844','2013-10-01','13:55:00',2.67),('15844','2013-10-01','14:00:00',2.58),('15844','2013-10-01','14:05:00',2.08),('15844','2013-10-01','14:10:00',2.35),('15844','2013-10-01','14:15:00',2.24),('15844','2013-10-01','14:20:00',2.16),('15844','2013-10-01','14:25:00',2.07),('15844','2013-10-01','14:30:00',2),('15844','2013-10-01','14:35:00',1.68),('15844','2013-10-01','14:40:00',1.87),('15844','2013-10-01','14:45:00',1.8),('15844','2013-10-01','14:50:00',1.67),('15844','2013-10-01','14:55:00',1.52),('15844','2013-10-01','15:00:00',1.41),('15844','2013-10-01','15:05:00',1.27),('15844','2013-10-01','15:10:00',1.18),('15844','2013-10-01','15:15:00',1.14),('15844','2013-10-01','15:20:00',1.05),('15844','2013-10-01','15:25:00',1.01),('15844','2013-09-30','09:40:00',1.09),('15844','2013-09-30','09:45:00',1.73),('15844','2013-09-30','09:50:00',1.29),('15844','2013-09-30','10:15:00',1.01),('15844','2013-09-30','10:20:00',1.11),('15844','2013-09-30','10:25:00',1.32),('15844','2013-09-30','10:30:00',1.63),('15844','2013-09-30','10:35:00',1.8),('15844','2013-09-30','10:40:00',2.54),('15844','2013-09-30','10:45:00',3.43),('15844','2013-09-30','10:50:00',3.04),('15844','2013-09-30','10:55:00',2.51),('15844','2013-09-30','11:00:00',2.59),('15844','2013-09-30','11:05:00',3.36),('15844','2013-09-30','11:10:00',3.34),('15844','2013-09-30','11:15:00',3.21),('15844','2013-09-30','11:20:00',2.97),('15844','2013-09-30','11:25:00',3.35),('15844','2013-09-30','11:30:00',3.21),('15844','2013-09-30','11:35:00',2.42),('15844','2013-09-30','11:40:00',1.35),('15844','2013-09-30','11:55:00',3.57),('15844','2013-09-30','12:00:00',3.63),('15844','2013-09-30','12:05:00',3.68),('15844','2013-09-30','12:10:00',3.58),('15844','2013-09-30','12:15:00',3.57),('15844','2013-09-30','12:20:00',3.29),('15844','2013-09-30','12:25:00',3.38),('15844','2013-09-30','12:30:00',3.38),('15844','2013-09-30','12:35:00',3.41),('15844','2013-09-30','12:40:00',3.43),('15844','2013-09-30','12:45:00',3.4),('15844','2013-09-30','12:50:00',3.37),('15844','2013-09-30','12:55:00',3.35),('15844','2013-09-30','13:00:00',3.26),('15844','2013-09-30','13:05:00',3.4),('15844','2013-09-30','13:10:00',1.51),('15844','2013-09-30','13:15:00',1.94),('15844','2013-09-30','13:20:00',3.53),('15844','2013-09-30','13:25:00',2.54),('15844','2013-09-30','13:30:00',2.86),('15844','2013-09-30','13:35:00',3.31),('15844','2013-09-30','13:40:00',3.31),('15844','2013-09-30','13:45:00',1.86),('15844','2013-09-30','13:50:00',1.29),('15844','2013-09-30','14:05:00',1.18),('15844','2013-09-30','14:10:00',1.11),('15844','2013-09-30','14:25:00',1.43),('15844','2013-09-30','14:30:00',2.69),('15844','2013-09-30','14:35:00',3),('15844','2013-09-30','14:40:00',2.8),('15844','2013-09-30','14:45:00',1.33),('15844','2013-09-30','14:50:00',1.84),('15844','2013-09-30','15:10:00',1.28),('15844','2013-09-30','15:15:00',1.13),('15844','2013-09-30','15:20:00',1.09),('15844','2013-09-30','15:25:00',1.34),('15844','2013-09-30','15:30:00',1.03),('15844','2013-09-30','15:35:00',1.31),('15844','2013-09-29','09:55:00',1.11),('15844','2013-09-29','10:00:00',1.69),('15844','2013-09-29','10:05:00',1.63),('15844','2013-09-29','10:10:00',2.23),('15844','2013-09-29','10:15:00',2.26),('15844','2013-09-29','10:20:00',1.97),('15844','2013-09-29','10:25:00',2.07),('15844','2013-09-29','10:30:00',2.46),('15844','2013-09-29','10:35:00',2.54),('15844','2013-09-29','10:40:00',2.6),('15844','2013-09-29','10:45:00',2.71),('15844','2013-09-29','10:50:00',2.76),('15844','2013-09-29','10:55:00',2.74),('15844','2013-09-29','11:00:00',2.7),('15844','2013-09-29','11:05:00',2.58),('15844','2013-09-29','11:10:00',2.68),('15844','2013-09-29','11:15:00',2.84),('15844','2013-09-29','11:20:00',2.67),('15844','2013-09-29','11:25:00',2.6),('15844','2013-09-29','11:30:00',2.9),('15844','2013-09-29','11:35:00',2.96),('15844','2013-09-29','11:40:00',2.99),('15844','2013-09-29','11:45:00',2.92),('15844','2013-09-29','11:50:00',3.04),('15844','2013-09-29','11:55:00',2.86),('15844','2013-09-29','12:00:00',3.13),('15844','2013-09-29','12:05:00',1.87),('15844','2013-09-29','12:10:00',2.85),('15844','2013-09-29','12:15:00',2.1),('15844','2013-09-29','12:30:00',1.18),('15844','2013-09-29','12:35:00',1.16),('15844','2013-09-29','13:30:00',1.89),('15844','2013-09-29','13:35:00',1.95),('15844','2013-09-29','13:40:00',1.73),('15844','2013-09-29','13:45:00',2.3),('15844','2013-09-29','13:50:00',1.66),('15844','2013-09-29','13:55:00',1.67),('15844','2013-09-29','14:15:00',1.12),('15844','2013-09-29','14:20:00',1.33),('15844','2013-09-29','16:30:00',1.09),('15844','2014-04-14','08:35:00',1.03),('15844','2014-04-14','08:40:00',1.17),('15844','2014-04-14','08:45:00',1.25),('15844','2014-04-14','08:50:00',1.38),('15844','2014-04-14','08:55:00',1.44),('15844','2014-04-14','09:00:00',1.57),('15844','2014-04-14','09:05:00',1.67),('15844','2014-04-14','09:10:00',1.75),('15844','2014-04-14','09:15:00',1.82),('15844','2014-04-14','09:20:00',2.05),('15844','2014-04-14','09:25:00',2.18),('15844','2014-04-14','09:30:00',2.3),('15844','2014-04-14','09:35:00',2.39),('15844','2014-04-14','09:40:00',2.45),('15844','2014-04-14','09:45:00',2.52),('15844','2014-04-14','09:50:00',2.54),('15844','2014-04-14','09:55:00',2.58),('15844','2014-04-14','10:00:00',2.73),('15844','2014-04-14','10:05:00',2.83),('15844','2014-04-14','10:10:00',2.9),('15844','2014-04-14','10:15:00',2.97),('15844','2014-04-14','10:20:00',3.06),('15844','2014-04-14','10:25:00',3.09),('15844','2014-04-14','10:30:00',3.2),('15844','2014-04-14','10:35:00',3.36),('15844','2014-04-14','10:40:00',3.45),('15844','2014-04-14','10:45:00',3.53),('15844','2014-04-14','10:50:00',3.63),('15844','2014-04-14','10:55:00',3.76),('15844','2014-04-14','11:00:00',3.82),('15844','2014-04-14','11:05:00',3.87),('15844','2014-04-14','11:10:00',3.89),('15844','2014-04-14','11:15:00',3.91),('15844','2014-04-14','11:20:00',3.96),('15844','2014-04-14','11:25:00',3.98),('15844','2014-04-14','11:30:00',4),('15844','2014-04-14','11:35:00',4.03),('15844','2014-04-14','11:40:00',4.05),('15844','2014-04-14','11:45:00',4.04),('15844','2014-04-14','11:50:00',4.04),('15844','2014-04-14','11:55:00',4.05),('15844','2014-04-14','12:00:00',4.04),('15844','2014-04-14','12:05:00',4.04),('15844','2014-04-14','12:10:00',4.03),('15844','2014-04-14','12:15:00',4.04),('15844','2014-04-14','12:20:00',4.05),('15844','2014-04-14','12:25:00',4.01),('15844','2014-04-14','12:30:00',4.02),('15844','2014-04-14','12:35:00',4),('15844','2014-04-14','12:40:00',4.01),('15844','2014-04-14','12:45:00',3.99),('15844','2014-04-14','12:50:00',3.93),('15844','2014-04-14','12:55:00',3.93),('15844','2014-04-14','13:00:00',3.92),('15844','2014-04-14','13:05:00',3.9),('15844','2014-04-14','13:10:00',3.89),('15844','2014-04-14','13:15:00',3.88),('15844','2014-04-14','13:20:00',3.85),('15844','2014-04-14','13:25:00',3.82),('15844','2014-04-14','13:30:00',3.8),('15844','2014-04-14','13:35:00',3.76),('15844','2014-04-14','13:40:00',3.71),('15844','2014-04-14','13:45:00',3.67),('15844','2014-04-14','13:50:00',3.6),('15844','2014-04-14','13:55:00',3.54),('15844','2014-04-14','14:00:00',3.47),('15844','2014-04-14','14:05:00',3.41),('15844','2014-04-14','14:10:00',3.33),('15844','2014-04-14','14:15:00',3.25),('15844','2014-04-14','14:20:00',3.19),('15844','2014-04-14','14:25:00',3.09),('15844','2014-04-14','14:30:00',2.93),('15844','2014-04-14','14:35:00',2.88),('15844','2014-04-14','14:40:00',2.76),('15844','2014-04-14','14:45:00',2.71),('15844','2014-04-14','14:50:00',2.62),('15844','2014-04-14','14:55:00',2.53),('15844','2014-04-14','15:00:00',2.43),('15844','2014-04-14','15:05:00',2.33),('15844','2014-04-14','15:10:00',2.23),('15844','2014-04-14','15:15:00',2.15),('15844','2014-04-14','15:20:00',2.05),('15844','2014-04-14','15:25:00',1.98),('15844','2014-04-14','15:30:00',1.89),('15844','2014-04-14','15:35:00',1.78),('15844','2014-04-14','15:40:00',1.67),('15844','2014-04-14','15:45:00',1.56),('15844','2014-04-14','15:50:00',1.42),('15844','2014-04-14','15:55:00',1.27),('15844','2014-04-14','16:00:00',1.19),('15844','2014-04-14','16:05:00',1.14),('15844','2014-04-14','16:10:00',1.08),('15844','2014-04-14','16:15:00',1.05),('15844','2014-04-14','16:20:00',1),('15844','2013-09-28','08:50:00',1.05),('15844','2013-09-28','08:55:00',1.19),('15844','2013-09-28','09:00:00',1.35),('15844','2013-09-28','09:05:00',1.42),('15844','2013-09-28','09:10:00',1.47),('15844','2013-09-28','09:15:00',1.61),('15844','2013-09-28','09:20:00',1.72),('15844','2013-09-28','09:25:00',1.71),('15844','2013-09-28','09:30:00',1.84),('15844','2013-09-28','09:35:00',1.83),('15844','2013-09-28','09:45:00',1.3),('15844','2013-09-28','10:15:00',1.59),('15844','2013-09-28','10:20:00',2.76),('15844','2013-09-28','10:25:00',3.13),('15844','2013-09-28','10:30:00',3.26),('15844','2013-09-28','10:35:00',2.91),('15844','2013-09-28','10:55:00',2.15),('15844','2013-09-28','11:00:00',3.17),('15844','2013-09-28','11:05:00',3.27),('15844','2013-09-28','11:10:00',3.36),('15844','2013-09-28','11:15:00',3.5),('15844','2013-09-28','11:20:00',2.43),('15844','2013-09-28','11:30:00',1.52),('15844','2013-09-28','11:35:00',1.32),('15844','2013-09-28','11:40:00',2.36),('15844','2013-09-28','11:45:00',3.47),('15844','2013-09-28','11:50:00',3.39),('15844','2013-09-28','11:55:00',3.19),('15844','2013-09-28','12:00:00',3.3),('15844','2013-09-28','12:05:00',1.55),('15844','2013-09-28','12:10:00',1.6),('15844','2013-09-28','12:15:00',3.49),('15844','2013-09-28','12:20:00',2.66),('15844','2013-09-28','12:25:00',3.38),('15844','2013-09-28','12:30:00',3.2),('15844','2013-09-28','12:35:00',2.18),('15844','2013-09-28','12:40:00',2.27),('15844','2013-09-28','12:45:00',2.43),('15844','2013-09-28','12:50:00',3.28),('15844','2013-09-28','12:55:00',3.4),('15844','2013-09-28','13:00:00',3.25),('15844','2013-09-28','13:05:00',1.14),('15844','2013-09-28','13:10:00',2.14),('15844','2013-09-28','13:15:00',2.79),('15844','2013-09-28','13:20:00',2.83),('15844','2013-09-28','13:25:00',3.13),('15844','2013-09-28','13:30:00',3.03),('15844','2013-09-28','13:35:00',3.03),('15844','2013-09-28','13:40:00',2.38),('15844','2013-09-28','13:45:00',1.34),('15844','2013-09-28','13:50:00',1.65),('15844','2013-09-28','13:55:00',2.55),('15844','2013-09-28','14:00:00',2.37),('15844','2013-09-28','14:05:00',1.89),('15844','2013-09-28','14:10:00',2.49),('15844','2013-09-28','14:15:00',1.26),('15844','2013-09-28','14:30:00',1.26),('15844','2013-09-28','14:35:00',1.2),('15844','2013-09-28','14:40:00',1.85),('15844','2013-09-28','14:45:00',1.78),('15844','2013-09-28','14:50:00',1.96),('15844','2013-09-28','14:55:00',1.48),('15844','2013-09-28','15:00:00',1.54),('15844','2013-09-28','15:05:00',1.56),('15844','2013-09-28','15:10:00',1.45),('15844','2013-09-28','15:15:00',1.31),('15844','2013-09-28','15:20:00',1.22),('15844','2013-09-28','15:25:00',1.17),('15844','2013-09-28','15:30:00',1.11),('15844','2013-09-28','15:35:00',1.08),('15844','2013-09-28','15:40:00',1.01),('15844','2013-09-27','10:10:00',1.22),('15844','2013-09-27','10:20:00',1.02),('15844','2013-09-27','10:25:00',1.14),('15844','2013-09-27','10:35:00',1.83),('15844','2013-09-27','10:40:00',1.64),('15844','2013-09-27','10:45:00',1.54),('15844','2013-09-27','10:50:00',2.94),('15844','2013-09-27','10:55:00',2.58),('15844','2013-09-27','11:00:00',2.93),('15844','2013-09-27','11:05:00',3.09),('15844','2013-09-27','11:10:00',3.1),('15844','2013-09-27','11:15:00',3.13),('15844','2013-09-27','11:20:00',2.98),('15844','2013-09-27','11:25:00',3.15),('15844','2013-09-27','11:30:00',2.54),('15844','2013-09-27','11:35:00',1.52),('15844','2013-09-27','11:40:00',1.26),('15844','2013-09-27','11:45:00',1.45),('15844','2013-09-27','12:25:00',1.02),('15844','2013-09-27','12:30:00',2.06),('15844','2013-09-27','12:35:00',3.41),('15844','2013-09-27','12:40:00',3.3),('15844','2013-09-27','12:45:00',3.38),('15844','2013-09-27','12:50:00',3.43),('15844','2013-09-27','12:55:00',3.41),('15844','2013-09-27','13:00:00',1.2),('15844','2013-09-27','13:15:00',1.45),('15844','2013-09-27','13:20:00',1.73),('15844','2013-09-27','13:25:00',3.14),('15844','2013-09-27','13:30:00',3.02),('15844','2013-09-27','13:35:00',2.37),('15844','2013-09-27','13:40:00',2.47),('15844','2013-09-27','13:45:00',2.13),('15844','2013-09-27','13:50:00',1.59),('15844','2013-09-27','13:55:00',2.77),('15844','2013-09-27','14:00:00',2.81),('15844','2013-09-27','14:05:00',2.53),('15844','2013-09-27','14:10:00',2.37),('15844','2013-09-27','14:15:00',2.58),('15844','2013-09-27','14:20:00',2.01),('15844','2013-09-27','14:25:00',1.77),('15844','2013-09-27','14:30:00',1.41),('15844','2013-09-27','14:35:00',2.28),('15844','2013-09-27','14:40:00',2.08),('15844','2013-09-27','14:45:00',1.54),('15844','2013-09-27','14:50:00',1.7),('15844','2013-09-27','14:55:00',1.54),('15844','2013-09-27','15:00:00',1.18),('15844','2013-09-27','15:15:00',1.05),('15844','2013-09-27','15:25:00',1.25),('15844','2013-09-27','15:30:00',1.11),('15844','2013-09-27','15:35:00',1.06),('15844','2013-09-26','08:55:00',1.09),('15844','2013-09-26','09:05:00',1.28),('15844','2013-09-26','09:10:00',1.45),('15844','2013-09-26','09:15:00',1.52),('15844','2013-09-26','09:20:00',1.61),('15844','2013-09-26','09:25:00',1.76),('15844','2013-09-26','09:30:00',1.92),('15844','2013-09-26','09:35:00',2.06),('15844','2013-09-26','09:40:00',2.18),('15844','2013-09-26','09:45:00',2.26),('15844','2013-09-26','09:50:00',2.3),('15844','2013-09-26','09:55:00',2.38),('15844','2013-09-26','10:00:00',2.46),('15844','2013-09-26','10:05:00',2.49),('15844','2013-09-26','10:10:00',2.55),('15844','2013-09-26','10:15:00',2.58),('15844','2013-09-26','10:20:00',2.63),('15844','2013-09-26','10:25:00',2.67),('15844','2013-09-26','10:30:00',2.68),('15844','2013-09-26','10:35:00',2.73),('15844','2013-09-26','10:40:00',2.82),('15844','2013-09-26','10:45:00',2.79),('15844','2013-09-26','10:50:00',2.82),('15844','2013-09-26','10:55:00',3.03),('15844','2013-09-26','11:00:00',3.01),('15844','2013-09-26','11:05:00',3.01),('15844','2013-09-26','11:10:00',3.1),('15844','2013-09-26','11:15:00',3.11),('15844','2013-09-26','11:20:00',3.26),('15844','2013-09-26','11:25:00',3.21),('15844','2013-09-26','11:30:00',3.26),('15844','2013-09-26','11:35:00',3),('15844','2013-09-26','11:40:00',2.15),('15844','2013-09-26','11:45:00',3.32),('15844','2013-09-26','11:50:00',3.21),('15844','2013-09-26','11:55:00',3.28),('15844','2013-09-26','12:00:00',3.59),('15844','2013-09-26','12:05:00',2.29),('15844','2013-09-26','12:10:00',1.51),('15844','2013-09-26','12:15:00',1.34),('15844','2013-09-26','12:20:00',1.29),('15844','2013-09-26','12:25:00',1.43),('15844','2013-09-26','12:30:00',1.43),('15844','2013-09-26','12:35:00',1.31),('15844','2013-09-26','12:40:00',1.41),('15844','2013-09-26','12:45:00',1.7),('15844','2013-09-26','12:50:00',2.84),('15844','2013-09-26','12:55:00',2.54),('15844','2013-09-26','13:00:00',2.9),('15844','2013-09-26','13:05:00',3.31),('15844','2013-09-26','13:10:00',1.97),('15844','2013-09-26','13:15:00',2.33),('15844','2013-09-26','13:20:00',1.13),('15844','2013-09-26','13:25:00',3.27),('15844','2013-09-26','13:30:00',2.72),('15844','2013-09-26','13:35:00',2.32),('15844','2013-09-26','13:40:00',3.17),('15844','2013-09-26','13:45:00',2.2),('15844','2013-09-26','13:50:00',2.45),('15844','2013-09-26','13:55:00',2.66),('15844','2013-09-26','14:00:00',2.32),('15844','2013-09-26','14:05:00',2.48),('15844','2013-09-26','14:10:00',2.56),('15844','2013-09-26','14:15:00',1.11),('15844','2013-09-26','14:20:00',2.65),('15844','2013-09-26','14:25:00',2.28),('15844','2013-09-26','14:30:00',2.26),('15844','2013-09-26','14:35:00',1.92),('15844','2013-09-26','14:40:00',1.33),('15844','2013-09-26','14:45:00',1.54),('15844','2013-09-26','14:55:00',1.42),('15844','2013-09-26','15:00:00',1.15),('15844','2013-09-26','15:05:00',1.84),('15844','2013-09-26','15:10:00',1.63),('15844','2013-09-26','15:15:00',1.13),('15844','2013-09-26','15:30:00',1.25),('15844','2013-09-25','08:50:00',1.19),('15844','2013-09-25','08:55:00',1.32),('15844','2013-09-25','09:00:00',1.43),('15844','2013-09-25','09:20:00',1.37),('15844','2013-09-25','09:25:00',2.27),('15844','2013-09-25','09:30:00',2.04),('15844','2013-09-25','09:35:00',2.21),('15844','2013-09-25','10:00:00',1.15),('15844','2013-09-25','10:05:00',1.17),('15844','2013-09-25','10:50:00',2.75),('15844','2013-09-25','10:55:00',3.34),('15844','2013-09-25','11:00:00',3.35),('15844','2013-09-25','11:05:00',3.37),('15844','2013-09-25','11:10:00',3.55),('15844','2013-09-25','11:15:00',2.23),('15844','2013-09-25','11:20:00',1.02),('15844','2013-09-25','11:30:00',2.39),('15844','2013-09-25','11:35:00',3.48),('15844','2013-09-25','11:40:00',3.5),('15844','2013-09-25','11:45:00',3.53),('15844','2013-09-25','11:50:00',3.47),('15844','2013-09-25','11:55:00',2.29),('15844','2013-09-25','12:00:00',3.9),('15844','2013-09-25','12:05:00',3.51),('15844','2013-09-25','12:10:00',1.21),('15844','2013-09-25','12:15:00',1.08),('15844','2013-09-25','12:20:00',2.5),('15844','2013-09-25','12:25:00',2.98),('15844','2013-09-25','12:30:00',3.44),('15844','2013-09-25','12:35:00',1.28),('15844','2013-09-25','12:40:00',1.85),('15844','2013-09-25','12:45:00',1.71),('15844','2013-09-25','13:10:00',2.52),('15844','2013-09-25','13:15:00',1.18),('15844','2013-09-25','13:20:00',2.61),('15844','2013-09-25','13:25:00',3.8),('15844','2013-09-25','13:30:00',3.66),('15844','2013-09-25','13:35:00',3.39),('15844','2013-09-25','13:40:00',3.03),('15844','2013-09-25','13:50:00',3.19),('15844','2013-09-25','13:55:00',3.23),('15844','2013-09-25','14:00:00',2.94),('15844','2013-09-25','14:05:00',2.4),('15844','2013-09-25','14:10:00',1.49),('15844','2013-09-25','14:15:00',2.8),('15844','2013-09-25','14:20:00',1.09),('15844','2013-09-25','14:25:00',1.51),('15844','2013-09-25','14:30:00',2.57),('15844','2013-09-25','14:35:00',1.2),('15844','2013-09-25','14:50:00',1.67),('15844','2013-09-25','14:55:00',1.53),('15844','2013-09-25','15:10:00',1.3),('15844','2013-09-25','15:15:00',1.42),('15844','2013-09-25','15:20:00',1.5),('15844','2013-09-25','15:25:00',1.02),('15844','2013-09-25','15:30:00',1.19),('15844','2013-09-25','15:35:00',1.33),('15844','2013-09-25','15:40:00',1.22),('15844','2013-09-25','15:45:00',1.03),('15844','2013-09-25','15:50:00',1.15),('15844','2013-09-24','08:50:00',1.03),('15844','2013-09-24','08:55:00',1.12),('15844','2013-09-24','09:00:00',1.25),('15844','2013-09-24','09:05:00',1.36),('15844','2013-09-24','09:10:00',1.49),('15844','2013-09-24','09:15:00',1.59),('15844','2013-09-24','09:20:00',1.72),('15844','2013-09-24','09:25:00',1.88),('15844','2013-09-24','09:30:00',2),('15844','2013-09-24','09:35:00',2.15),('15844','2013-09-24','09:40:00',2.26),('15844','2013-09-24','09:45:00',2.35),('15844','2013-09-24','09:50:00',2.44),('15844','2013-09-24','09:55:00',2.52),('15844','2013-09-24','10:00:00',2.56),('15844','2013-09-24','10:05:00',2.64),('15844','2013-09-24','10:10:00',2.71),('15844','2013-09-24','10:15:00',2.78),('15844','2013-09-24','10:20:00',2.86),('15844','2013-09-24','10:25:00',2.88),('15844','2013-09-24','10:30:00',2.92),('15844','2013-09-24','10:35:00',2.98),('15844','2013-09-24','10:40:00',3.02),('15844','2013-09-24','10:45:00',3.04),('15844','2013-09-24','10:50:00',3.12),('15844','2013-09-24','10:55:00',3.19),('15844','2013-09-24','11:00:00',3.25),('15844','2013-09-24','11:05:00',3.22),('15844','2013-09-24','11:10:00',3.29),('15844','2013-09-24','11:15:00',3.31),('15844','2013-09-24','11:20:00',3.29),('15844','2013-09-24','11:25:00',3.34),('15844','2013-09-24','11:30:00',3.36),('15844','2013-09-24','11:35:00',3.39),('15844','2013-09-24','11:40:00',3.39),('15844','2013-09-24','11:45:00',3.43),('15844','2013-09-24','11:50:00',3.44),('15844','2013-09-24','11:55:00',3.44),('15844','2013-09-24','12:00:00',3.48),('15844','2013-09-24','12:05:00',3.46),('15844','2013-09-24','12:10:00',3.44),('15844','2013-09-24','12:15:00',3.47),('15844','2013-09-24','12:20:00',3.46),('15844','2013-09-24','12:25:00',3.44),('15844','2013-09-24','12:30:00',3.41),('15844','2013-09-24','12:35:00',3.44),('15844','2013-09-24','12:40:00',3.39),('15844','2013-09-24','12:45:00',3.4),('15844','2013-09-24','12:50:00',3.37),('15844','2013-09-24','12:55:00',3.3),('15844','2013-09-24','13:00:00',3.3),('15844','2013-09-24','13:05:00',3.32),('15844','2013-09-24','13:10:00',3.26),('15844','2013-09-24','13:15:00',3.21),('15844','2013-09-24','13:20:00',3.22),('15844','2013-09-24','13:25:00',3.15),('15844','2013-09-24','13:30:00',3.06),('15844','2013-09-24','13:35:00',3.06),('15844','2013-09-24','13:40:00',3),('15844','2013-09-24','13:45:00',2.94),('15844','2013-09-24','13:50:00',2.9),('15844','2013-09-24','13:55:00',2.81),('15844','2013-09-24','14:00:00',2.72),('15844','2013-09-24','14:05:00',2.68),('15844','2013-09-24','14:10:00',2.59),('15844','2013-09-24','14:15:00',2.46),('15844','2013-09-24','14:20:00',2.37),('15844','2013-09-24','14:25:00',2.27),('15844','2013-09-24','14:30:00',2.16),('15844','2013-09-24','14:35:00',2.06),('15844','2013-09-24','14:40:00',1.94),('15844','2013-09-24','14:45:00',1.89),('15844','2013-09-24','14:50:00',1.82),('15844','2013-09-24','14:55:00',1.7),('15844','2013-09-24','15:00:00',1.61),('15844','2013-09-24','15:05:00',1.47),('15844','2013-09-24','15:10:00',1.36),('15844','2013-09-24','15:15:00',1.23),('15844','2013-09-24','15:20:00',1.22),('15844','2013-09-24','15:25:00',1.18),('15844','2013-09-24','15:30:00',1.12),('15844','2013-09-24','15:35:00',1.07),('15844','2013-09-24','15:40:00',1.01),('15844','2013-09-23','08:45:00',1.11),('15844','2013-09-23','08:50:00',1.31),('15844','2013-09-23','08:55:00',1.41),('15844','2013-09-23','09:00:00',1.51),('15844','2013-09-23','09:05:00',1.62),('15844','2013-09-23','09:10:00',1.76),('15844','2013-09-23','09:15:00',1.88),('15844','2013-09-23','09:20:00',1.98),('15844','2013-09-23','09:25:00',2.07),('15844','2013-09-23','09:30:00',2.21),('15844','2013-09-23','09:35:00',2.36),('15844','2013-09-23','09:40:00',2.44),('15844','2013-09-23','09:45:00',2.52),('15844','2013-09-23','09:50:00',2.57),('15844','2013-09-23','09:55:00',2.62),('15844','2013-09-23','10:00:00',2.66),('15844','2013-09-23','10:05:00',2.7),('15844','2013-09-23','10:10:00',2.76),('15844','2013-09-23','10:15:00',2.87),('15844','2013-09-23','10:20:00',2.93),('15844','2013-09-23','10:25:00',2.97),('15844','2013-09-23','10:30:00',3),('15844','2013-09-23','10:35:00',3.03),('15844','2013-09-23','10:40:00',3.06),('15844','2013-09-23','10:45:00',3.1),('15844','2013-09-23','10:50:00',3.25),('15844','2013-09-23','10:55:00',3.33),('15844','2013-09-23','11:00:00',3.37),('15844','2013-09-23','11:05:00',3.4),('15844','2013-09-23','11:10:00',3.4),('15844','2013-09-23','11:15:00',3.43),('15844','2013-09-23','11:20:00',3.48),('15844','2013-09-23','11:25:00',3.49),('15844','2013-09-23','11:30:00',3.53),('15844','2013-09-23','11:35:00',3.54),('15844','2013-09-23','11:40:00',3.53),('15844','2013-09-23','11:45:00',3.57),('15844','2013-09-23','11:50:00',3.61),('15844','2013-09-23','11:55:00',3.56),('15844','2013-09-23','12:00:00',3.59),('15844','2013-09-23','12:05:00',3.58),('15844','2013-09-23','12:10:00',3.54),('15844','2013-09-23','12:15:00',3.54),('15844','2013-09-23','12:20:00',3.55),('15844','2013-09-23','12:25:00',3.53),('15844','2013-09-23','12:30:00',3.51),('15844','2013-09-23','12:35:00',3.52),('15844','2013-09-23','12:40:00',3.47),('15844','2013-09-23','12:45:00',3.44),('15844','2013-09-23','12:50:00',3.41),('15844','2013-09-23','12:55:00',3.36),('15844','2013-09-23','13:00:00',3.33),('15844','2013-09-23','13:05:00',3.32),('15844','2013-09-23','13:10:00',3.26),('15844','2013-09-23','13:15:00',3.23),('15844','2013-09-23','13:20:00',3.2),('15844','2013-09-23','13:25:00',3.18),('15844','2013-09-23','13:30:00',3.12),('15844','2013-09-23','13:35:00',3.07),('15844','2013-09-23','13:40:00',3.05),('15844','2013-09-23','13:45:00',2.96),('15844','2013-09-23','13:50:00',2.9),('15844','2013-09-23','13:55:00',2.84),('15844','2013-09-23','14:00:00',2.79),('15844','2013-09-23','14:05:00',2.69),('15844','2013-09-23','14:10:00',2.58),('15844','2013-09-23','14:15:00',2.53),('15844','2013-09-23','14:20:00',2.44),('15844','2013-09-23','14:25:00',2.33),('15844','2013-09-23','14:30:00',2.21),('15844','2013-09-23','14:35:00',2.1),('15844','2013-09-23','14:40:00',2.01),('15844','2013-09-23','14:45:00',1.92),('15844','2013-09-23','14:50:00',1.83),('15844','2013-09-23','14:55:00',1.72),('15844','2013-09-23','15:00:00',1.62),('15844','2013-09-23','15:05:00',1.51),('15844','2013-09-23','15:10:00',1.48),('15844','2013-09-23','15:15:00',1.46),('15844','2013-09-23','15:20:00',1.31),('15844','2013-09-23','15:25:00',1.24),('15844','2013-09-23','15:30:00',1.28),('15844','2013-09-23','15:35:00',1.26),('15844','2013-09-23','15:40:00',1.16),('15844','2013-09-23','15:45:00',1.04),('15844','2013-09-22','08:45:00',1),('15844','2013-09-22','08:50:00',1.05),('15844','2013-09-22','08:55:00',1.12),('15844','2013-09-22','09:00:00',1.28),('15844','2013-09-22','09:05:00',1.43),('15844','2013-09-22','09:10:00',1.54),('15844','2013-09-22','09:15:00',1.65),('15844','2013-09-22','09:20:00',1.81),('15844','2013-09-22','09:25:00',1.99),('15844','2013-09-22','09:30:00',2.15),('15844','2013-09-22','09:35:00',2.27),('15844','2013-09-22','09:40:00',2.37),('15844','2013-09-22','09:45:00',2.43),('15844','2013-09-22','09:50:00',2.53),('15844','2013-09-22','09:55:00',2.6),('15844','2013-09-22','10:00:00',2.66),('15844','2013-09-22','10:05:00',2.71),('15844','2013-09-22','10:10:00',2.79),('15844','2013-09-22','10:15:00',2.88),('15844','2013-09-22','10:20:00',2.94),('15844','2013-09-22','10:25:00',2.97),('15844','2013-09-22','10:30:00',3),('15844','2013-09-22','10:35:00',3.05),('15844','2013-09-22','10:40:00',3.11),('15844','2013-09-22','10:45:00',3.21),('15844','2013-09-22','10:50:00',3.31),('15844','2013-09-22','10:55:00',3.36),('15844','2013-09-22','11:00:00',3.4),('15844','2013-09-22','11:05:00',3.48),('15844','2013-09-22','11:10:00',3.5),('15844','2013-09-22','11:15:00',3.53),('15844','2013-09-22','11:20:00',3.57),('15844','2013-09-22','11:25:00',3.59),('15844','2013-09-22','11:30:00',3.59),('15844','2013-09-22','11:35:00',3.6),('15844','2013-09-22','11:40:00',3.6),('15844','2013-09-22','11:45:00',3.61),('15844','2013-09-22','11:50:00',3.6),('15844','2013-09-22','11:55:00',3.61),('15844','2013-09-22','12:00:00',3.6),('15844','2013-09-22','12:05:00',3.6),('15844','2013-09-22','12:10:00',3.59),('15844','2013-09-22','12:15:00',3.59),('15844','2013-09-22','12:20:00',3.61),('15844','2013-09-22','12:25:00',3.58),('15844','2013-09-22','12:30:00',3.57),('15844','2013-09-22','12:35:00',3.56),('15844','2013-09-22','12:40:00',3.53),('15844','2013-09-22','12:45:00',3.53),('15844','2013-09-22','12:50:00',3.5),('15844','2013-09-22','12:55:00',3.43),('15844','2013-09-22','13:00:00',3.42),('15844','2013-09-22','13:05:00',3.41),('15844','2013-09-22','13:10:00',3.39),('15844','2013-09-22','13:15:00',3.33),('15844','2013-09-22','13:20:00',3.32),('15844','2013-09-22','13:25:00',3.28),('15844','2013-09-22','13:30:00',3.26),('15844','2013-09-22','13:35:00',3.21),('15844','2013-09-22','13:40:00',3.17),('15844','2013-09-22','13:45:00',3.13),('15844','2013-09-22','13:50:00',3.17),('15844','2013-09-22','13:55:00',3.13),('15844','2013-09-22','14:00:00',2.78),('15844','2013-09-22','14:05:00',2.9),('15844','2013-09-22','14:10:00',2.98),('15844','2013-09-22','14:15:00',2.97),('15844','2013-09-22','14:20:00',1.87),('15844','2013-09-22','14:25:00',1.18),('15844','2013-09-22','14:30:00',1.8),('15844','2013-09-22','14:35:00',1.87),('15844','2013-09-22','14:40:00',2.13),('15844','2013-09-22','14:45:00',2.05),('15844','2013-09-22','14:50:00',1.95),('15844','2013-09-22','14:55:00',1.85),('15844','2013-09-22','15:00:00',1.79),('15844','2013-09-22','15:05:00',1.25),('15844','2013-09-22','15:15:00',1.23),('15844','2013-09-22','15:20:00',1.99),('15844','2013-09-22','15:25:00',1.74),('15844','2013-09-22','15:40:00',1.23),('15844','2013-09-22','15:45:00',1.05),('15844','2013-09-22','16:00:00',1.08),('15844','2013-09-21','08:45:00',1.05),('15844','2013-09-21','08:50:00',1.16),('15844','2013-09-21','08:55:00',1.28),('15844','2013-09-21','09:00:00',1.39),('15844','2013-09-21','09:05:00',1.5),('15844','2013-09-21','09:10:00',1.63),('15844','2013-09-21','09:15:00',1.73),('15844','2013-09-21','09:20:00',1.81),('15844','2013-09-21','09:25:00',1.93),('15844','2013-09-21','09:30:00',2.13),('15844','2013-09-21','09:35:00',2.22),('15844','2013-09-21','09:40:00',2.31),('15844','2013-09-21','09:45:00',2.41),('15844','2013-09-21','09:50:00',2.5),('15844','2013-09-21','09:55:00',2.58),('15844','2013-09-21','10:00:00',2.65),('15844','2013-09-21','10:05:00',2.7),('15844','2013-09-21','10:10:00',2.75),('15844','2013-09-21','10:15:00',2.83),('15844','2013-09-21','10:20:00',2.89),('15844','2013-09-21','10:25:00',2.93),('15844','2013-09-21','10:30:00',2.93),('15844','2013-09-21','10:35:00',2.97),('15844','2013-09-21','10:40:00',3.03),('15844','2013-09-21','10:45:00',3.09),('15844','2013-09-21','10:50:00',3.25),('15844','2013-09-21','10:55:00',3.33),('15844','2013-09-21','11:00:00',3.38),('15844','2013-09-21','11:05:00',3.42),('15844','2013-09-21','11:10:00',3.43),('15844','2013-09-21','11:15:00',3.44),('15844','2013-09-21','11:20:00',3.47),('15844','2013-09-21','11:25:00',3.46),('15844','2013-09-21','11:30:00',3.48),('15844','2013-09-21','11:35:00',3.49),('15844','2013-09-21','11:40:00',3.51),('15844','2013-09-21','11:45:00',3.54),('15844','2013-09-21','11:50:00',3.48),('15844','2013-09-21','11:55:00',3.54),('15844','2013-09-21','12:00:00',3.62),('15844','2013-09-21','12:05:00',3.57),('15844','2013-09-21','12:10:00',3.56),('15844','2013-09-21','12:15:00',3.59),('15844','2013-09-21','12:20:00',3.13),('15844','2013-09-21','12:25:00',3.6),('15844','2013-09-21','12:30:00',3.59),('15844','2013-09-21','12:35:00',3.23),('15844','2013-09-21','12:40:00',3.16),('15844','2013-09-21','12:45:00',3.48),('15844','2013-09-21','12:50:00',3.49),('15844','2013-09-21','12:55:00',3.49),('15844','2013-09-21','13:00:00',3.33),('15844','2013-09-21','13:05:00',3.41),('15844','2013-09-21','13:10:00',3.43),('15844','2013-09-21','13:15:00',2.94),('15844','2013-09-21','13:20:00',2.93),('15844','2013-09-21','13:25:00',3.12),('15844','2013-09-21','13:30:00',3.13),('15844','2013-09-21','13:35:00',2.81),('15844','2013-09-21','13:40:00',2.58),('15844','2013-09-21','13:45:00',2.69),('15844','2013-09-21','13:50:00',2.79),('15844','2013-09-21','13:55:00',2.59),('15844','2013-09-21','14:00:00',2.8),('15844','2013-09-21','14:05:00',2.61),('15844','2013-09-21','14:10:00',2.64),('15844','2013-09-21','14:15:00',2.58),('15844','2013-09-21','14:20:00',2.46),('15844','2013-09-21','14:25:00',2.31),('15844','2013-09-21','14:30:00',2.26),('15844','2013-09-21','14:35:00',2.17),('15844','2013-09-21','14:40:00',2.03),('15844','2013-09-21','14:45:00',1.99),('15844','2013-09-21','14:50:00',1.9),('15844','2013-09-21','14:55:00',1.78),('15844','2013-09-21','15:00:00',1.65),('15844','2013-09-21','15:05:00',1.52),('15844','2013-09-21','15:10:00',1.42),('15844','2013-09-21','15:15:00',1.42),('15844','2013-09-21','15:20:00',1.34),('15844','2013-09-21','15:25:00',1.24),('15844','2013-09-21','15:30:00',1.14),('15844','2013-09-21','15:35:00',1.09),('15844','2013-09-21','15:45:00',1.01),('15844','2013-09-20','08:35:00',1.19),('15844','2013-09-20','08:40:00',1.35),('15844','2013-09-20','09:40:00',1.18),('15844','2013-09-20','09:45:00',1.08),('15844','2013-09-20','09:50:00',1.16),('15844','2013-09-20','09:55:00',1.17),('15844','2013-09-20','10:00:00',1.22),('15844','2013-09-20','10:05:00',1.43),('15844','2013-09-20','10:10:00',1.44),('15844','2013-09-20','10:15:00',1.52),('15844','2013-09-20','10:20:00',1.56),('15844','2013-09-20','10:25:00',1.63),('15844','2013-09-20','10:30:00',1.97),('15844','2013-09-20','10:35:00',1.97),('15844','2013-09-20','10:40:00',2.82),('15844','2013-09-20','10:45:00',2.29),('15844','2013-09-20','10:50:00',1.83),('15844','2013-09-20','10:55:00',1.95),('15844','2013-09-20','11:00:00',1.73),('15844','2013-09-20','11:05:00',1.77),('15844','2013-09-20','11:10:00',2.19),('15844','2013-09-20','11:15:00',2.88),('15844','2013-09-20','11:20:00',3.14),('15844','2013-09-20','11:25:00',2.52),('15844','2013-09-20','11:30:00',3.13),('15844','2013-09-20','11:35:00',4.64),('15844','2013-09-20','11:40:00',4.45),('15844','2013-09-20','11:45:00',4.22),('15844','2013-09-20','11:50:00',4.04),('15844','2013-09-20','11:55:00',3.85),('15844','2013-09-20','12:00:00',3.75),('15844','2013-09-20','12:05:00',3.68),('15844','2013-09-20','12:10:00',3.7),('15844','2013-09-20','12:15:00',3.77),('15844','2013-09-20','12:20:00',2.13),('15844','2013-09-20','12:25:00',3.39),('15844','2013-09-20','12:30:00',3.96),('15844','2013-09-20','12:35:00',1.08),('15844','2013-09-20','12:40:00',3.18),('15844','2013-09-20','12:45:00',3.59),('15844','2013-09-20','12:50:00',3.49),('15844','2013-09-20','12:55:00',3.42),('15844','2013-09-20','13:00:00',3.43),('15844','2013-09-20','13:05:00',3.39),('15844','2013-09-20','13:10:00',3.31),('15844','2013-09-20','13:15:00',3.3),('15844','2013-09-20','13:20:00',3.34),('15844','2013-09-20','13:25:00',3.29),('15844','2013-09-20','13:30:00',3.26),('15844','2013-09-20','13:35:00',3.25),('15844','2013-09-20','13:40:00',3.21),('15844','2013-09-20','13:45:00',2.92),('15844','2013-09-20','13:50:00',2.82),('15844','2013-09-20','13:55:00',1.72),('15844','2013-09-20','14:20:00',1.69),('15844','2013-09-20','14:25:00',2.56),('15844','2013-09-20','14:30:00',1.33),('15844','2013-09-20','14:35:00',2.16),('15844','2013-09-20','14:40:00',1.07),('15844','2013-09-20','14:45:00',1.19),('15844','2013-09-20','14:50:00',1.96),('15844','2013-09-20','14:55:00',1.14),('15844','2013-09-20','15:00:00',1.05),('15844','2013-09-20','15:05:00',1.11),('15844','2013-09-20','15:10:00',1.29),('15844','2013-09-20','15:15:00',1.57),('15844','2013-09-20','15:20:00',1.59),('15844','2013-09-20','15:25:00',1.16),('15844','2013-09-19','08:40:00',1.02),('15844','2013-09-19','08:45:00',1.04),('15844','2013-09-19','08:50:00',1.07),('15844','2013-09-19','08:55:00',1.16),('15844','2013-09-19','09:05:00',1.5),('15844','2013-09-19','09:15:00',1.36),('15844','2013-09-19','09:20:00',1.01),('15844','2013-09-19','09:25:00',1.11),('15844','2013-09-19','09:40:00',1.99),('15844','2013-09-19','09:45:00',2.39),('15844','2013-09-19','09:50:00',2.4),('15844','2013-09-19','09:55:00',2.69),('15844','2013-09-19','10:00:00',2.91),('15844','2013-09-19','10:05:00',3.3),('15844','2013-09-19','10:10:00',2.56),('15844','2013-09-19','10:30:00',1.12),('15844','2013-09-19','10:35:00',1.23),('15844','2013-09-19','10:40:00',2.16),('15844','2013-09-19','10:45:00',3.26),('15844','2013-09-19','10:50:00',1.88),('15844','2013-09-19','10:55:00',2.07),('15844','2013-09-19','11:00:00',3.15),('15844','2013-09-19','11:05:00',2.92),('15844','2013-09-19','11:10:00',2.01),('15844','2013-09-19','11:20:00',1.07),('15844','2013-09-19','11:30:00',2.58),('15844','2013-09-19','11:35:00',2.87),('15844','2013-09-19','11:40:00',3.08),('15844','2013-09-19','11:45:00',1.73),('15844','2013-09-19','11:50:00',1.39),('15844','2013-09-19','11:55:00',2.26),('15844','2013-09-19','12:00:00',1.98),('15844','2013-09-19','12:05:00',3.9),('15844','2013-09-19','12:10:00',1.62),('15844','2013-09-19','12:15:00',2.59),('15844','2013-09-19','12:20:00',3.61),('15844','2013-09-19','12:25:00',3.83),('15844','2013-09-19','12:30:00',3.75),('15844','2013-09-19','12:35:00',3.78),('15844','2013-09-19','12:40:00',4.16),('15844','2013-09-19','12:45:00',4.32),('15844','2013-09-19','12:50:00',2.08),('15844','2013-09-19','12:55:00',3.06),('15844','2013-09-19','13:00:00',3.48),('15844','2013-09-19','13:05:00',3.59),('15844','2013-09-19','13:10:00',1.86),('15844','2013-09-19','13:15:00',3.85),('15844','2013-09-19','13:20:00',3.85),('15844','2013-09-19','13:25:00',3.76),('15844','2013-09-19','13:30:00',2.62),('15844','2013-09-19','13:40:00',3.04),('15844','2013-09-19','13:45:00',3.43),('15844','2013-09-19','13:50:00',3.42),('15844','2013-09-19','13:55:00',3.23),('15844','2013-09-19','14:00:00',2.03),('15844','2013-09-19','14:05:00',2.66),('15844','2013-09-19','14:10:00',3.04),('15844','2013-09-19','14:15:00',2.38),('15844','2013-09-19','14:20:00',2.66),('15844','2013-09-19','14:25:00',2.56),('15844','2013-09-19','14:30:00',2.46),('15844','2013-09-19','14:35:00',2.33),('15844','2013-09-19','14:40:00',2.27),('15844','2013-09-19','14:45:00',1.9),('15844','2013-09-19','14:50:00',2.23),('15844','2013-09-19','14:55:00',2.08),('15844','2013-09-19','15:00:00',1.58),('15844','2013-09-19','15:05:00',1.38),('15844','2013-09-19','15:10:00',1.53),('15844','2013-09-19','15:15:00',1.73),('15844','2013-09-19','15:20:00',1.44),('15844','2013-09-19','15:25:00',1.5),('15844','2013-09-19','15:30:00',1.2),('15844','2013-09-19','15:35:00',1.45),('15844','2013-09-19','15:40:00',1.34),('15844','2013-09-19','15:50:00',1.21),('15844','2013-09-19','15:55:00',1.03),('15844','2014-04-13','09:30:00',1.09),('15844','2014-04-13','09:35:00',1.19),('15844','2014-04-13','09:40:00',1.29),('15844','2014-04-13','09:45:00',1.42),('15844','2014-04-13','09:50:00',1.59),('15844','2014-04-13','09:55:00',1.59),('15844','2014-04-13','10:00:00',1.65),('15844','2014-04-13','10:05:00',2.89),('15844','2014-04-13','10:10:00',2.5),('15844','2014-04-13','10:15:00',2.18),('15844','2014-04-13','10:20:00',2.02),('15844','2014-04-13','10:25:00',2.38),('15844','2014-04-13','10:30:00',2.37),('15844','2014-04-13','10:35:00',3.34),('15844','2014-04-13','10:40:00',2.64),('15844','2014-04-13','10:45:00',3.58),('15844','2014-04-13','10:50:00',3.94),('15844','2014-04-13','10:55:00',2.69),('15844','2014-04-13','11:00:00',3.73),('15844','2014-04-13','11:05:00',3.59),('15844','2014-04-13','11:10:00',1.7),('15844','2014-04-13','11:15:00',2.23),('15844','2014-04-13','11:20:00',2.01),('15844','2014-04-13','11:25:00',1.98),('15844','2014-04-13','11:30:00',4.02),('15844','2014-04-13','11:35:00',3.53),('15844','2014-04-13','11:40:00',2.81),('15844','2014-04-13','11:45:00',2.16),('15844','2014-04-13','11:50:00',4.56),('15844','2014-04-13','11:55:00',3.03),('15844','2014-04-13','12:00:00',1.77),('15844','2014-04-13','12:05:00',1.49),('15844','2014-04-13','12:10:00',1.16),('15844','2014-04-13','12:15:00',1.63),('15844','2014-04-13','12:20:00',1.54),('15844','2014-04-13','12:55:00',1.06),('15844','2014-04-13','13:00:00',1.34),('15844','2014-04-13','13:05:00',1.98),('15844','2014-04-13','13:10:00',2.46),('15844','2014-04-13','13:15:00',4.36),('15844','2014-04-13','13:20:00',3.91),('15844','2014-04-13','13:25:00',2.31),('15844','2014-04-13','13:30:00',3.38),('15844','2014-04-13','13:35:00',3.65),('15844','2014-04-13','13:40:00',2.69),('15844','2014-04-13','13:45:00',2.34),('15844','2014-04-13','13:50:00',2.07),('15844','2014-04-13','13:55:00',2.15),('15844','2014-04-13','14:00:00',2.66),('15844','2014-04-13','14:05:00',3.14),('15844','2014-04-13','14:10:00',2.73),('15844','2014-04-13','14:15:00',1.85),('15844','2014-04-13','14:20:00',1.52),('15844','2014-04-13','14:25:00',1.48),('15844','2014-04-13','14:30:00',1.47),('15844','2014-04-13','14:35:00',1.45),('15844','2014-04-13','14:40:00',1.37),('15844','2014-04-13','14:45:00',2.71),('15844','2014-04-13','14:50:00',2.87),('15844','2014-04-13','14:55:00',2.67),('15844','2014-04-13','15:00:00',2.49),('15844','2014-04-13','15:05:00',2.42),('15844','2014-04-13','15:10:00',2.06),('15844','2014-04-13','15:15:00',2.04),('15844','2014-04-13','15:20:00',2.16),('15844','2014-04-13','15:25:00',2.25),('15844','2014-04-13','15:30:00',1.52),('15844','2014-04-13','15:35:00',1.17),('15844','2014-04-13','15:40:00',1.35),('15844','2014-04-13','15:45:00',1.36),('15844','2014-04-13','15:50:00',1.08),('15844','2014-04-13','15:55:00',1.51),('15844','2014-04-13','16:00:00',1.39),('15844','2014-04-13','16:05:00',1.07),('15844','2014-04-13','16:20:00',1.2),('15844','2014-04-13','16:30:00',1.07),('15844','2014-04-13','16:35:00',1.25),('15844','2014-04-13','16:40:00',1.36),('15844','2014-04-13','16:45:00',1.35),('15844','2014-04-13','16:50:00',1.12),('15844','2013-09-18','09:05:00',1.21),('15844','2013-09-18','09:10:00',1.94),('15844','2013-09-18','09:15:00',1.45),('15844','2013-09-18','09:30:00',2),('15844','2013-09-18','09:35:00',1.31),('15844','2013-09-18','09:40:00',1.2),('15844','2013-09-18','09:45:00',1.06),('15844','2013-09-18','09:50:00',2),('15844','2013-09-18','09:55:00',2.74),('15844','2013-09-18','10:00:00',2.29),('15844','2013-09-18','10:05:00',1.83),('15844','2013-09-18','10:10:00',2.77),('15844','2013-09-18','10:15:00',2.84),('15844','2013-09-18','10:20:00',2.88),('15844','2013-09-18','10:25:00',2.95),('15844','2013-09-18','10:30:00',2.99),('15844','2013-09-18','10:35:00',3.03),('15844','2013-09-18','10:40:00',3.08),('15844','2013-09-18','10:45:00',3.09),('15844','2013-09-18','10:50:00',3.24),('15844','2013-09-18','10:55:00',3.37),('15844','2013-09-18','11:00:00',3.48),('15844','2013-09-18','11:05:00',3.58),('15844','2013-09-18','11:10:00',3.5),('15844','2013-09-18','11:15:00',3.5),('15844','2013-09-18','11:20:00',3.61),('15844','2013-09-18','11:25:00',3.65),('15844','2013-09-18','11:30:00',3.42),('15844','2013-09-18','11:35:00',3.37),('15844','2013-09-18','11:40:00',3.18),('15844','2013-09-18','11:45:00',3.72),('15844','2013-09-18','11:50:00',3.75),('15844','2013-09-18','11:55:00',3.77),('15844','2013-09-18','12:00:00',3.89),('15844','2013-09-18','12:05:00',3.86),('15844','2013-09-18','12:10:00',2),('15844','2013-09-18','12:15:00',3.25),('15844','2013-09-18','12:20:00',3.23),('15844','2013-09-18','12:25:00',2.93),('15844','2013-09-18','12:30:00',1.2),('15844','2013-09-18','12:35:00',4.01),('15844','2013-09-18','12:40:00',3.95),('15844','2013-09-18','12:45:00',4),('15844','2013-09-18','12:50:00',3.96),('15844','2013-09-18','12:55:00',3.92),('15844','2013-09-18','13:00:00',3.85),('15844','2013-09-18','13:05:00',3.62),('15844','2013-09-18','13:10:00',3.32),('15844','2013-09-18','13:15:00',3.58),('15844','2013-09-18','13:20:00',2.43),('15844','2013-09-18','13:25:00',2.03),('15844','2013-09-18','13:30:00',1.8),('15844','2013-09-18','13:35:00',1.41),('15844','2013-09-18','13:40:00',3.25),('15844','2013-09-18','13:45:00',2.68),('15844','2013-09-18','13:50:00',2.29),('15844','2013-09-18','13:55:00',3.19),('15844','2013-09-18','14:00:00',1.48),('15844','2013-09-18','14:05:00',1.1),('15844','2013-09-18','14:10:00',3.25),('15844','2013-09-18','14:15:00',3.11),('15844','2013-09-18','14:20:00',2.29),('15844','2013-09-18','14:25:00',2.62),('15844','2013-09-18','14:30:00',1.97),('15844','2013-09-18','14:35:00',1.58),('15844','2013-09-18','14:40:00',2.32),('15844','2013-09-18','14:45:00',2.27),('15844','2013-09-18','14:50:00',2.19),('15844','2013-09-18','14:55:00',2.11),('15844','2013-09-18','15:00:00',2.16),('15844','2013-09-18','15:05:00',1.99),('15844','2013-09-18','15:10:00',2.03),('15844','2013-09-18','15:15:00',1.05),('15844','2013-09-18','15:20:00',1.24),('15844','2013-09-18','15:25:00',1.81),('15844','2013-09-18','15:30:00',1.34),('15844','2013-09-18','15:35:00',1.21),('15844','2013-09-18','15:40:00',1.26),('15844','2013-09-18','15:45:00',1.13),('15844','2013-09-18','15:55:00',1.07),('15844','2013-09-17','09:40:00',1.7),('15844','2013-09-17','09:45:00',2.29),('15844','2013-09-17','09:50:00',1.17),('15844','2013-09-17','09:55:00',1.74),('15844','2013-09-17','10:00:00',1.85),('15844','2013-09-17','10:05:00',1.87),('15844','2013-09-17','10:20:00',1.37),('15844','2013-09-17','10:25:00',2.29),('15844','2013-09-17','10:30:00',1.42),('15844','2013-09-17','10:40:00',1.9),('15844','2013-09-17','10:45:00',3.82),('15844','2013-09-17','10:50:00',3.72),('15844','2013-09-17','10:55:00',2.38),('15844','2013-09-17','11:00:00',2.14),('15844','2013-09-17','11:05:00',3.02),('15844','2013-09-17','11:10:00',3.42),('15844','2013-09-17','11:15:00',2.14),('15844','2013-09-17','11:20:00',1.65),('15844','2013-09-17','11:25:00',1.34),('15844','2013-09-17','11:30:00',2.17),('15844','2013-09-17','11:35:00',2.62),('15844','2013-09-17','11:40:00',2.44),('15844','2013-09-17','11:45:00',2.56),('15844','2013-09-17','11:50:00',1.47),('15844','2013-09-17','11:55:00',3.8),('15844','2013-09-17','12:00:00',3.14),('15844','2013-09-17','12:05:00',1.39),('15844','2013-09-17','12:10:00',2.11),('15844','2013-09-17','12:15:00',3.91),('15844','2013-09-17','12:20:00',4.18),('15844','2013-09-17','12:25:00',1.96),('15844','2013-09-17','12:30:00',1.81),('15844','2013-09-17','12:35:00',1.93),('15844','2013-09-17','12:40:00',1.84),('15844','2013-09-17','12:45:00',2.46),('15844','2013-09-17','12:50:00',2.15),('15844','2013-09-17','12:55:00',3.59),('15844','2013-09-17','13:00:00',1.74),('15844','2013-09-17','13:05:00',2.29),('15844','2013-09-17','13:10:00',2.28),('15844','2013-09-17','13:15:00',1.87),('15844','2013-09-17','13:20:00',1.59),('15844','2013-09-17','13:25:00',1.92),('15844','2013-09-17','13:30:00',1.67),('15844','2013-09-17','13:35:00',1.73),('15844','2013-09-17','13:40:00',1.6),('15844','2013-09-17','13:45:00',1.02),('15844','2013-09-17','13:50:00',1.15),('15844','2013-09-17','13:55:00',1.01),('15844','2013-09-17','14:30:00',1.1),('15844','2013-09-17','14:50:00',1.34),('15844','2013-09-17','14:55:00',2.12),('15844','2013-09-17','15:00:00',2),('15844','2013-09-17','15:05:00',1.78),('15844','2013-09-17','15:10:00',1.57),('15844','2013-09-17','15:15:00',1.18),('15844','2013-09-17','15:20:00',1.44),('15844','2013-09-17','15:45:00',1.32),('15844','2013-09-17','15:50:00',1.06),('15844','2013-09-17','15:55:00',1.21),('15844','2013-09-17','16:00:00',1.45),('15844','2013-09-17','16:05:00',1.25),('15844','2013-09-17','16:10:00',1.18),('15844','2013-09-16','08:40:00',1.09),('15844','2013-09-16','08:45:00',1.06),('15844','2013-09-16','08:50:00',1.29),('15844','2013-09-16','08:55:00',1.46),('15844','2013-09-16','09:00:00',1.46),('15844','2013-09-16','09:10:00',1.08),('15844','2013-09-16','09:15:00',1.75),('15844','2013-09-16','09:20:00',1.87),('15844','2013-09-16','09:25:00',2.07),('15844','2013-09-16','09:30:00',2.08),('15844','2013-09-16','09:35:00',2.15),('15844','2013-09-16','09:40:00',2.24),('15844','2013-09-16','09:45:00',2.37),('15844','2013-09-16','09:50:00',2.49),('15844','2013-09-16','09:55:00',2.55),('15844','2013-09-16','10:00:00',2.79),('15844','2013-09-16','10:05:00',2.38),('15844','2013-09-16','10:10:00',2.58),('15844','2013-09-16','10:15:00',2.6),('15844','2013-09-16','10:20:00',3.22),('15844','2013-09-16','10:25:00',3.35),('15844','2013-09-16','10:30:00',3.48),('15844','2013-09-16','10:35:00',3.25),('15844','2013-09-16','10:40:00',2.63),('15844','2013-09-16','10:45:00',1.9),('15844','2013-09-16','10:55:00',1.15),('15844','2013-09-16','11:00:00',3.22),('15844','2013-09-16','11:05:00',3.96),('15844','2013-09-16','11:10:00',3.18),('15844','2013-09-16','11:15:00',2.67),('15844','2013-09-16','11:20:00',3.96),('15844','2013-09-16','11:25:00',1.99),('15844','2013-09-16','11:35:00',2.29),('15844','2013-09-16','11:40:00',3.91),('15844','2013-09-16','11:45:00',3.21),('15844','2013-09-16','11:50:00',4.11),('15844','2013-09-16','11:55:00',4.04),('15844','2013-09-16','12:00:00',1.34),('15844','2013-09-16','12:05:00',4.3),('15844','2013-09-16','12:10:00',4.12),('15844','2013-09-16','12:15:00',3.93),('15844','2013-09-16','12:20:00',3.84),('15844','2013-09-16','12:25:00',3.78),('15844','2013-09-16','12:30:00',3.83),('15844','2013-09-16','12:35:00',2.75),('15844','2013-09-16','12:40:00',2.62),('15844','2013-09-16','12:45:00',3.44),('15844','2013-09-16','12:50:00',2.3),('15844','2013-09-16','12:55:00',1.29),('15844','2013-09-16','13:00:00',3.03),('15844','2013-09-16','13:05:00',3.8),('15844','2013-09-16','13:10:00',3.68),('15844','2013-09-16','13:15:00',3.62),('15844','2013-09-16','13:20:00',3.63),('15844','2013-09-16','13:25:00',3.66),('15844','2013-09-16','13:30:00',3.46),('15844','2013-09-16','13:35:00',3.45),('15844','2013-09-16','13:40:00',3.56),('15844','2013-09-16','13:45:00',3.5),('15844','2013-09-16','13:50:00',3.53),('15844','2013-09-16','13:55:00',3.3),('15844','2013-09-16','14:00:00',3.14),('15844','2013-09-16','14:05:00',3.07),('15844','2013-09-16','14:10:00',2.99),('15844','2013-09-16','14:15:00',2.89),('15844','2013-09-16','14:20:00',2.78),('15844','2013-09-16','14:25:00',2.65),('15844','2013-09-16','14:30:00',2.55),('15844','2013-09-16','14:35:00',2.41),('15844','2013-09-16','14:40:00',2.31),('15844','2013-09-16','14:45:00',1.22),('15844','2013-09-16','14:50:00',2.15),('15844','2013-09-16','14:55:00',2.02),('15844','2013-09-16','15:00:00',1.92),('15844','2013-09-16','15:05:00',1.79),('15844','2013-09-16','15:10:00',1.66),('15844','2013-09-16','15:15:00',1.63),('15844','2013-09-16','15:20:00',1.55),('15844','2013-09-16','15:25:00',1.44),('15844','2013-09-16','15:30:00',1.32),('15844','2013-09-16','15:35:00',1.21),('15844','2013-09-16','15:40:00',1.15),('15844','2013-09-16','15:45:00',1.12),('15844','2013-09-16','15:50:00',1.06),('15844','2013-09-16','15:55:00',1.02),('15844','2013-09-15','08:40:00',1.04),('15844','2013-09-15','08:45:00',1.14),('15844','2013-09-15','08:50:00',1.14),('15844','2013-09-15','08:55:00',1.17),('15844','2013-09-15','09:00:00',1.34),('15844','2013-09-15','09:05:00',1.49),('15844','2013-09-15','09:10:00',1.63),('15844','2013-09-15','09:15:00',1.78),('15844','2013-09-15','09:20:00',1.84),('15844','2013-09-15','09:25:00',1.98),('15844','2013-09-15','09:30:00',2),('15844','2013-09-15','09:35:00',2.11),('15844','2013-09-15','09:40:00',2.2),('15844','2013-09-15','09:45:00',2.34),('15844','2013-09-15','09:50:00',2.39),('15844','2013-09-15','09:55:00',2.59),('15844','2013-09-15','10:00:00',2.66),('15844','2013-09-15','10:05:00',2.74),('15844','2013-09-15','10:10:00',2.58),('15844','2013-09-15','10:15:00',2.75),('15844','2013-09-15','10:20:00',2.84),('15844','2013-09-15','10:25:00',2.87),('15844','2013-09-15','10:30:00',2.68),('15844','2013-09-15','10:35:00',2.88),('15844','2013-09-15','10:40:00',3.21),('15844','2013-09-15','10:45:00',3.26),('15844','2013-09-15','10:50:00',1.36),('15844','2013-09-15','10:55:00',1.52),('15844','2013-09-15','11:00:00',3.01),('15844','2013-09-15','11:05:00',3.59),('15844','2013-09-15','11:10:00',4.04),('15844','2013-09-15','11:15:00',2.67),('15844','2013-09-15','11:25:00',1.19),('15844','2013-09-15','11:30:00',1.39),('15844','2013-09-15','11:35:00',3.87),('15844','2013-09-15','11:40:00',1.34),('15844','2013-09-15','11:45:00',1.24),('15844','2013-09-15','11:50:00',1.22),('15844','2013-09-15','11:55:00',1.88),('15844','2013-09-15','12:00:00',3.43),('15844','2013-09-15','12:05:00',3.1),('15844','2013-09-15','12:10:00',2.72),('15844','2013-09-15','12:15:00',2.6),('15844','2013-09-15','12:20:00',1.96),('15844','2013-09-15','12:25:00',1.85),('15844','2013-09-15','12:30:00',1.5),('15844','2013-09-15','12:35:00',1.82),('15844','2013-09-15','12:40:00',1.67),('15844','2013-09-15','12:45:00',1.15),('15844','2013-09-15','12:50:00',1.23),('15844','2013-09-15','12:55:00',1.13),('15844','2013-09-15','13:00:00',1.22),('15844','2013-09-15','13:05:00',1.51),('15844','2013-09-15','13:10:00',1.83),('15844','2013-09-15','13:15:00',3.11),('15844','2013-09-15','13:20:00',2.13),('15844','2013-09-15','13:25:00',1.27),('15844','2013-09-15','13:30:00',1.03),('15844','2013-09-15','13:40:00',1.2),('15844','2013-09-15','13:45:00',1.76),('15844','2013-09-15','13:50:00',1.63),('15844','2013-09-15','13:55:00',1.65),('15844','2013-09-15','14:00:00',2.09),('15844','2013-09-15','14:05:00',1.63),('15844','2013-09-15','14:10:00',1.71),('15844','2013-09-15','14:15:00',1.64),('15844','2013-09-15','14:20:00',1.38),('15844','2013-09-15','14:25:00',1.27),('15844','2013-09-15','14:30:00',1.14),('15844','2013-09-15','14:35:00',1.02),('15844','2013-09-15','14:45:00',1.03),('15844','2013-09-15','14:50:00',1.01),('15844','2013-09-15','15:00:00',1.04),('15844','2013-09-15','15:10:00',1.2),('15844','2013-09-15','15:15:00',1.57),('15844','2013-09-15','15:20:00',1.41),('15844','2013-09-15','15:25:00',1.02),('15844','2013-09-14','08:45:00',1.02),('15844','2013-09-14','08:50:00',1.12),('15844','2013-09-14','08:55:00',1.2),('15844','2013-09-14','09:00:00',1.28),('15844','2013-09-14','09:05:00',1.45),('15844','2013-09-14','09:10:00',1.6),('15844','2013-09-14','09:15:00',1.7),('15844','2013-09-14','09:20:00',1.8),('15844','2013-09-14','09:25:00',1.87),('15844','2013-09-14','09:30:00',1.96),('15844','2013-09-14','09:35:00',2.02),('15844','2013-09-14','09:40:00',2.13),('15844','2013-09-14','09:45:00',2.23),('15844','2013-09-14','09:50:00',2.31),('15844','2013-09-14','09:55:00',2.46),('15844','2013-09-14','10:00:00',2.59),('15844','2013-09-14','10:05:00',2.53),('15844','2013-09-14','10:10:00',2.45),('15844','2013-09-14','10:15:00',2.76),('15844','2013-09-14','10:20:00',2.71),('15844','2013-09-14','10:25:00',2.82),('15844','2013-09-14','10:30:00',2.99),('15844','2013-09-14','10:35:00',3.06),('15844','2013-09-14','10:40:00',3.15),('15844','2013-09-14','10:45:00',2.76),('15844','2013-09-14','10:50:00',2.84),('15844','2013-09-14','10:55:00',2),('15844','2013-09-14','11:00:00',3.81),('15844','2013-09-14','11:05:00',3.19),('15844','2013-09-14','11:10:00',2.19),('15844','2013-09-14','11:15:00',3.66),('15844','2013-09-14','11:20:00',3.79),('15844','2013-09-14','11:25:00',3.75),('15844','2013-09-14','11:30:00',3.1),('15844','2013-09-14','11:35:00',3.73),('15844','2013-09-14','11:40:00',3.67),('15844','2013-09-14','11:45:00',3.93),('15844','2013-09-14','11:50:00',3.28),('15844','2013-09-14','11:55:00',3.85),('15844','2013-09-14','12:00:00',2.44),('15844','2013-09-14','12:05:00',3.85),('15844','2013-09-14','12:10:00',2.2),('15844','2013-09-14','12:15:00',3.3),('15844','2013-09-14','12:20:00',3.91),('15844','2013-09-14','12:25:00',3.89),('15844','2013-09-14','12:30:00',3.8),('15844','2013-09-14','12:35:00',3.71),('15844','2013-09-14','12:40:00',3.69),('15844','2013-09-14','12:45:00',3.64),('15844','2013-09-14','12:50:00',3.59),('15844','2013-09-14','12:55:00',1.76),('15844','2013-09-14','13:00:00',2.39),('15844','2013-09-14','13:05:00',3.73),('15844','2013-09-14','13:10:00',3.66),('15844','2013-09-14','13:15:00',3.6),('15844','2013-09-14','13:20:00',3.51),('15844','2013-09-14','13:25:00',3.54),('15844','2013-09-14','13:30:00',3.46),('15844','2013-09-14','13:35:00',2.9),('15844','2013-09-14','13:40:00',1.32),('15844','2013-09-14','13:45:00',1.77),('15844','2013-09-14','13:50:00',2.92),('15844','2013-09-14','13:55:00',3.72),('15844','2013-09-14','14:00:00',3.31),('15844','2013-09-14','14:05:00',3.11),('15844','2013-09-14','14:10:00',3.03),('15844','2013-09-14','14:15:00',2.91),('15844','2013-09-14','14:20:00',2.81),('15844','2013-09-14','14:25:00',2.68),('15844','2013-09-14','14:30:00',2.57),('15844','2013-09-14','14:35:00',2.46),('15844','2013-09-14','14:40:00',2.33),('15844','2013-09-14','14:45:00',2.23),('15844','2013-09-14','14:50:00',2.12),('15844','2013-09-14','14:55:00',2.03),('15844','2013-09-14','15:00:00',1.96),('15844','2013-09-14','15:05:00',1.84),('15844','2013-09-14','15:10:00',1.72),('15844','2013-09-14','15:15:00',1.67),('15844','2013-09-14','15:20:00',1.59),('15844','2013-09-14','15:25:00',1.5),('15844','2013-09-14','15:30:00',1.4),('15844','2013-09-14','15:35:00',1.28),('15844','2013-09-14','15:40:00',1.2),('15844','2013-09-14','15:45:00',1.15),('15844','2013-09-14','15:50:00',1.08),('15844','2013-09-13','09:30:00',1.04),('15844','2013-09-13','09:35:00',1.02),('15844','2013-09-13','09:40:00',1.13),('15844','2013-09-13','09:45:00',1.19),('15844','2013-09-13','09:50:00',1.38),('15844','2013-09-13','09:55:00',1.11),('15844','2013-09-13','10:00:00',2.37),('15844','2013-09-13','10:05:00',3.33),('15844','2013-09-13','10:10:00',1.87),('15844','2013-09-13','10:15:00',2.43),('15844','2013-09-13','10:20:00',3.57),('15844','2013-09-13','10:25:00',3.14),('15844','2013-09-13','10:30:00',2.89),('15844','2013-09-13','10:35:00',3.05),('15844','2013-09-13','10:40:00',3.2),('15844','2013-09-13','10:45:00',3.29),('15844','2013-09-13','10:50:00',3.39),('15844','2013-09-13','10:55:00',3.47),('15844','2013-09-13','11:00:00',3.5),('15844','2013-09-13','11:05:00',3.56),('15844','2013-09-13','11:10:00',3.59),('15844','2013-09-13','11:15:00',3.64),('15844','2013-09-13','11:20:00',3.66),('15844','2013-09-13','11:25:00',3.7),('15844','2013-09-13','11:30:00',3.71),('15844','2013-09-13','11:35:00',3.73),('15844','2013-09-13','11:40:00',3.74),('15844','2013-09-13','11:45:00',3.73),('15844','2013-09-13','11:50:00',3.73),('15844','2013-09-13','11:55:00',3.76),('15844','2013-09-13','12:00:00',3.77),('15844','2013-09-13','12:05:00',3.75),('15844','2013-09-13','12:10:00',3.74),('15844','2013-09-13','12:15:00',3.02),('15844','2013-09-13','12:20:00',3.67),('15844','2013-09-13','12:25:00',3.37),('15844','2013-09-13','12:30:00',4.07),('15844','2013-09-13','12:35:00',3.97),('15844','2013-09-13','12:40:00',3.91),('15844','2013-09-13','12:45:00',3.89),('15844','2013-09-13','12:50:00',3.91),('15844','2013-09-13','12:55:00',3.79),('15844','2013-09-13','13:00:00',3.79),('15844','2013-09-13','13:05:00',3.69),('15844','2013-09-13','13:10:00',3.67),('15844','2013-09-13','13:15:00',3.6),('15844','2013-09-13','13:20:00',3.59),('15844','2013-09-13','13:25:00',3.42),('15844','2013-09-13','13:30:00',1.81),('15844','2013-09-13','13:35:00',3),('15844','2013-09-13','13:40:00',3.4),('15844','2013-09-13','13:45:00',2.96),('15844','2013-09-13','13:50:00',3.25),('15844','2013-09-13','13:55:00',3.2),('15844','2013-09-13','14:00:00',3.1),('15844','2013-09-13','14:05:00',3.09),('15844','2013-09-13','14:10:00',3.04),('15844','2013-09-13','14:15:00',2.95),('15844','2013-09-13','14:20:00',2.83),('15844','2013-09-13','14:25:00',2.71),('15844','2013-09-13','14:30:00',2.6),('15844','2013-09-13','14:35:00',2.53),('15844','2013-09-13','14:40:00',2.39),('15844','2013-09-13','14:45:00',2.27),('15844','2013-09-13','14:50:00',2.21),('15844','2013-09-13','14:55:00',2.13),('15844','2013-09-13','15:00:00',2.02),('15844','2013-09-13','15:05:00',1.91),('15844','2013-09-13','15:10:00',1.78),('15844','2013-09-13','15:15:00',1.69),('15844','2013-09-13','15:20:00',1.6),('15844','2013-09-13','15:25:00',1.52),('15844','2013-09-13','15:30:00',1.42),('15844','2013-09-13','15:35:00',1.31),('15844','2013-09-13','15:40:00',1.22),('15844','2013-09-13','15:45:00',1.16),('15844','2013-09-13','15:50:00',1.1),('15844','2013-09-13','15:55:00',1.03),('15844','2013-09-12','08:50:00',1.16),('15844','2013-09-12','08:55:00',1.24),('15844','2013-09-12','09:00:00',1.41),('15844','2013-09-12','09:05:00',1.12),('15844','2013-09-12','09:10:00',1.36),('15844','2013-09-12','09:15:00',1.43),('15844','2013-09-12','09:20:00',1.73),('15844','2013-09-12','09:25:00',2.12),('15844','2013-09-12','09:30:00',2.22),('15844','2013-09-12','09:35:00',1.78),('15844','2013-09-12','10:00:00',1.36),('15844','2013-09-12','10:05:00',2.41),('15844','2013-09-12','10:10:00',1.83),('15844','2013-09-12','10:15:00',1.36),('15844','2013-09-12','10:25:00',1.98),('15844','2013-09-12','10:30:00',1.82),('15844','2013-09-12','10:45:00',1.63),('15844','2013-09-12','10:50:00',1.54),('15844','2013-09-12','10:55:00',3.27),('15844','2013-09-12','11:00:00',4.27),('15844','2013-09-12','11:05:00',4.17),('15844','2013-09-12','11:10:00',3.42),('15844','2013-09-12','11:35:00',1.16),('15844','2013-09-12','11:40:00',1.27),('15844','2013-09-12','11:45:00',1.73),('15844','2013-09-12','11:50:00',4.06),('15844','2013-09-12','11:55:00',3.78),('15844','2013-09-12','12:00:00',3.88),('15844','2013-09-12','12:05:00',3.99),('15844','2013-09-12','12:10:00',3.93),('15844','2013-09-12','12:15:00',1.67),('15844','2013-09-12','12:20:00',2.24),('15844','2013-09-12','12:25:00',2.79),('15844','2013-09-12','12:30:00',3.76),('15844','2013-09-12','12:35:00',3.76),('15844','2013-09-12','12:40:00',1.64),('15844','2013-09-12','12:45:00',3.62),('15844','2013-09-12','12:50:00',3.46),('15844','2013-09-12','12:55:00',3.84),('15844','2013-09-12','13:00:00',3.03),('15844','2013-09-12','13:05:00',3.41),('15844','2013-09-12','13:10:00',3.72),('15844','2013-09-12','13:15:00',3.62),('15844','2013-09-12','13:20:00',4.01),('15844','2013-09-12','13:25:00',3.38),('15844','2013-09-12','13:30:00',3.11),('15844','2013-09-12','13:35:00',3.41),('15844','2013-09-12','13:40:00',3.6),('15844','2013-09-12','13:45:00',3.39),('15844','2013-09-12','13:50:00',3.26),('15844','2013-09-12','13:55:00',3.08),('15844','2013-09-12','14:00:00',3.07),('15844','2013-09-12','14:05:00',3.2),('15844','2013-09-12','14:10:00',3.22),('15844','2013-09-12','14:15:00',3.14),('15844','2013-09-12','14:20:00',2.9),('15844','2013-09-12','14:25:00',2.95),('15844','2013-09-12','14:30:00',2.07),('15844','2013-09-12','14:35:00',2.56),('15844','2013-09-12','14:40:00',2.47),('15844','2013-09-12','14:45:00',2.27),('15844','2013-09-12','14:50:00',1.96),('15844','2013-09-12','14:55:00',1.84),('15844','2013-09-12','15:00:00',1.69),('15844','2013-09-12','15:05:00',1.99),('15844','2013-09-12','15:10:00',1.88),('15844','2013-09-12','15:15:00',1.77),('15844','2013-09-12','15:20:00',1.69),('15844','2013-09-12','15:25:00',1.58),('15844','2013-09-12','15:30:00',1.47),('15844','2013-09-12','15:35:00',1.36),('15844','2013-09-12','15:40:00',1.27),('15844','2013-09-12','15:45:00',1.23),('15844','2013-09-12','15:50:00',1.23),('15844','2013-09-12','15:55:00',1.2),('15844','2013-09-11','09:05:00',1.4),('15844','2013-09-11','09:10:00',1.54),('15844','2013-09-11','09:15:00',2.08),('15844','2013-09-11','09:55:00',1.25),('15844','2013-09-11','10:00:00',2.73),('15844','2013-09-11','10:05:00',2.45),('15844','2013-09-11','10:10:00',2.78),('15844','2013-09-11','10:15:00',2.82),('15844','2013-09-11','10:20:00',2.94),('15844','2013-09-11','10:25:00',1.95),('15844','2013-09-11','10:30:00',2.42),('15844','2013-09-11','10:35:00',3.49),('15844','2013-09-11','10:40:00',3.49),('15844','2013-09-11','10:45:00',2.2),('15844','2013-09-11','10:50:00',1.29),('15844','2013-09-11','10:55:00',2.62),('15844','2013-09-11','11:00:00',2.31),('15844','2013-09-11','11:05:00',3.4),('15844','2013-09-11','11:10:00',3.32),('15844','2013-09-11','11:15:00',4.1),('15844','2013-09-11','11:20:00',3.38),('15844','2013-09-11','11:25:00',2.86),('15844','2013-09-11','11:30:00',3.28),('15844','2013-09-11','11:35:00',3.98),('15844','2013-09-11','11:40:00',3.96),('15844','2013-09-11','11:45:00',3.33),('15844','2013-09-11','11:50:00',3.1),('15844','2013-09-11','11:55:00',4.06),('15844','2013-09-11','12:00:00',4.02),('15844','2013-09-11','12:05:00',1.93),('15844','2013-09-11','12:10:00',4.12),('15844','2013-09-11','12:15:00',3.74),('15844','2013-09-11','12:20:00',2.92),('15844','2013-09-11','12:25:00',3.06),('15844','2013-09-11','12:30:00',2.99),('15844','2013-09-11','12:35:00',1.18),('15844','2013-09-11','12:40:00',2.44),('15844','2013-09-11','12:45:00',1.87),('15844','2013-09-11','12:50:00',3.44),('15844','2013-09-11','12:55:00',3.06),('15844','2013-09-11','13:00:00',3.47),('15844','2013-09-11','13:05:00',2.18),('15844','2013-09-11','13:10:00',1.25),('15844','2013-09-11','13:15:00',3.17),('15844','2013-09-11','13:20:00',3.83),('15844','2013-09-11','13:25:00',2.54),('15844','2013-09-11','13:30:00',3.8),('15844','2013-09-11','13:35:00',2.65),('15844','2013-09-11','13:40:00',4),('15844','2013-09-11','13:45:00',2.88),('15844','2013-09-11','13:50:00',2.07),('15844','2013-09-11','13:55:00',3.44),('15844','2013-09-11','14:00:00',3.05),('15844','2013-09-11','14:05:00',3.11),('15844','2013-09-11','14:10:00',3.29),('15844','2013-09-11','14:15:00',3.14),('15844','2013-09-11','14:20:00',1.5),('15844','2013-09-11','14:25:00',3),('15844','2013-09-11','14:30:00',1.09),('15844','2013-09-11','14:35:00',1.3),('15844','2013-09-11','14:40:00',1.26),('15844','2013-09-11','14:45:00',1.88),('15844','2013-09-11','14:50:00',2.23),('15844','2013-09-11','15:00:00',2.42),('15844','2013-09-11','15:05:00',1.86),('15844','2013-09-11','15:10:00',1.29),('15844','2013-09-11','15:15:00',1.62),('15844','2013-09-11','15:20:00',1.97),('15844','2013-09-11','15:25:00',1.75),('15844','2013-09-11','15:30:00',1.96),('15844','2013-09-11','15:45:00',1.34),('15844','2013-09-10','08:50:00',1.08),('15844','2013-09-10','08:55:00',1.27),('15844','2013-09-10','09:00:00',1.5),('15844','2013-09-10','09:05:00',1.82),('15844','2013-09-10','09:10:00',2.29),('15844','2013-09-10','09:15:00',1.24),('15844','2013-09-10','09:20:00',1.39),('15844','2013-09-10','09:25:00',1.89),('15844','2013-09-10','09:30:00',2.57),('15844','2013-09-10','09:35:00',1.37),('15844','2013-09-10','09:40:00',1.2),('15844','2013-09-10','09:45:00',1.11),('15844','2013-09-10','09:50:00',1.08),('15844','2013-09-10','10:40:00',1.39),('15844','2013-09-10','10:45:00',1.41),('15844','2013-09-10','10:50:00',1.01),('15844','2013-09-10','10:55:00',1.37),('15844','2013-09-10','11:00:00',1.73),('15844','2013-09-10','11:05:00',1.28),('15844','2013-09-10','11:15:00',1.04),('15844','2013-09-10','11:20:00',1.4),('15844','2013-09-10','11:25:00',1.59),('15844','2013-09-10','11:55:00',1.17),('15844','2013-09-10','12:00:00',1.14),('15844','2013-09-10','12:05:00',1.01),('15844','2013-09-10','12:10:00',1.18),('15844','2013-09-10','12:15:00',1.97),('15844','2013-09-10','12:20:00',1.53),('15844','2013-09-10','12:25:00',1.29),('15844','2013-09-10','12:30:00',1.16),('15844','2013-09-10','13:25:00',1.02),('15844','2013-09-10','13:35:00',1.17),('15844','2013-09-10','13:40:00',1.79),('15844','2013-09-10','13:45:00',1.89),('15844','2013-09-10','13:50:00',1.73),('15844','2013-09-10','13:55:00',1.2),('15844','2013-09-10','14:00:00',1.17),('15844','2013-09-10','14:05:00',1.11),('15844','2013-09-10','14:10:00',1.21),('15844','2013-09-10','14:15:00',1.4),('15844','2013-09-10','14:20:00',1.59),('15844','2013-09-10','14:25:00',1.95),('15844','2013-09-10','14:30:00',1.55),('15844','2013-09-10','14:35:00',1.21),('15844','2013-09-10','14:40:00',1.27),('15844','2013-09-10','14:45:00',1.78),('15844','2013-09-10','14:50:00',1.79),('15844','2013-09-10','14:55:00',1.69),('15844','2013-09-10','15:00:00',1.6),('15844','2013-09-10','15:05:00',1.73),('15844','2013-09-10','15:10:00',1.51),('15844','2013-09-10','15:15:00',1.01),('15844','2013-09-10','15:20:00',1.27),('15844','2013-09-10','15:25:00',1.29),('15844','2013-09-10','15:30:00',1.44),('15844','2013-09-10','15:35:00',1.21),('15844','2013-09-10','15:40:00',1.03),('15844','2013-09-10','16:15:00',1.01),('15844','2013-09-09','08:55:00',1.02),('15844','2013-09-09','09:50:00',1.06),('15844','2013-09-09','09:55:00',1.03),('15844','2013-09-09','10:00:00',1.22),('15844','2013-09-09','10:05:00',1.25),('15844','2013-09-09','10:10:00',1.34),('15844','2013-09-09','10:15:00',1.5),('15844','2013-09-09','10:20:00',1.5),('15844','2013-09-09','10:25:00',1.52),('15844','2013-09-09','10:30:00',1.58),('15844','2013-09-09','10:35:00',1.7),('15844','2013-09-09','10:40:00',1.71),('15844','2013-09-09','10:45:00',2.39),('15844','2013-09-09','10:50:00',2.57),('15844','2013-09-09','10:55:00',2.6),('15844','2013-09-09','11:00:00',2.27),('15844','2013-09-09','11:05:00',1.89),('15844','2013-09-09','11:10:00',1.69),('15844','2013-09-09','11:15:00',1.9),('15844','2013-09-09','11:20:00',2.5),('15844','2013-09-09','11:25:00',2.17),('15844','2013-09-09','11:30:00',2.05),('15844','2013-09-09','11:35:00',2.49),('15844','2013-09-09','11:40:00',3.31),('15844','2013-09-09','11:45:00',3.34),('15844','2013-09-09','11:50:00',1.99),('15844','2013-09-09','11:55:00',1.44),('15844','2013-09-09','12:00:00',1.29),('15844','2013-09-09','12:05:00',1.4),('15844','2013-09-09','12:10:00',1.33),('15844','2013-09-09','12:30:00',1.04),('15844','2013-09-09','12:40:00',1.39),('15844','2013-09-09','12:45:00',1.35),('15844','2013-09-09','12:50:00',1.74),('15844','2013-09-09','12:55:00',1.85),('15844','2013-09-09','13:00:00',2.03),('15844','2013-09-09','13:05:00',2.63),('15844','2013-09-09','13:10:00',3.37),('15844','2013-09-09','13:15:00',3.01),('15844','2013-09-09','13:20:00',2.65),('15844','2013-09-09','13:25:00',3),('15844','2013-09-09','13:30:00',3.21),('15844','2013-09-09','13:35:00',3.49),('15844','2013-09-09','13:40:00',2.58),('15844','2013-09-09','13:45:00',3.45),('15844','2013-09-09','13:50:00',3.43),('15844','2013-09-09','13:55:00',3.22),('15844','2013-09-09','14:00:00',3.02),('15844','2013-09-09','14:05:00',2.73),('15844','2013-09-09','14:10:00',2.61),('15844','2013-09-09','14:15:00',2.74),('15844','2013-09-09','14:20:00',1.18),('15844','2013-09-09','14:25:00',2.87),('15844','2013-09-09','14:30:00',2.73),('15844','2013-09-09','14:35:00',2.21),('15844','2013-09-09','14:40:00',2.34),('15844','2013-09-09','14:45:00',2.42),('15844','2013-09-09','14:50:00',2.39),('15844','2013-09-09','14:55:00',1.8),('15844','2013-09-09','15:00:00',1.7),('15844','2013-09-09','15:05:00',2.19),('15844','2013-09-09','15:10:00',2.28),('15844','2013-09-09','15:15:00',1.81),('15844','2013-09-09','15:20:00',1.96),('15844','2013-09-09','15:25:00',1.39),('15844','2013-09-09','15:30:00',1.54),('15844','2013-09-09','15:35:00',2.13),('15844','2013-09-09','15:40:00',1.53),('15844','2013-09-09','15:45:00',1.33),('15844','2013-09-09','15:50:00',1.44),('15844','2013-09-09','15:55:00',1.05),('15844','2013-09-09','16:05:00',1.02),('15844','2013-09-09','16:10:00',1.51),('15844','2013-09-09','16:15:00',1.46),('15844','2013-09-09','16:20:00',1.08),('15844','2014-04-12','09:05:00',1.33),('15844','2014-04-12','09:10:00',1.79),('15844','2014-04-12','09:15:00',1.44),('15844','2014-04-12','09:20:00',1.29),('15844','2014-04-12','09:25:00',1.44),('15844','2014-04-12','09:30:00',1.62),('15844','2014-04-12','09:35:00',1.56),('15844','2014-04-12','09:40:00',1.5),('15844','2014-04-12','09:45:00',1.49),('15844','2014-04-12','09:50:00',1.45),('15844','2014-04-12','09:55:00',1.49),('15844','2014-04-12','10:00:00',1.73),('15844','2014-04-12','10:05:00',1.79),('15844','2014-04-12','10:10:00',1.8),('15844','2014-04-12','10:15:00',1.67),('15844','2014-04-12','10:20:00',1.78),('15844','2014-04-12','10:25:00',1.8),('15844','2014-04-12','10:30:00',1.68),('15844','2014-04-12','10:35:00',1.71),('15844','2014-04-12','10:40:00',1.5),('15844','2014-04-12','10:45:00',1.42),('15844','2014-04-12','10:50:00',1.38),('15844','2014-04-12','10:55:00',1.28),('15844','2014-04-12','11:00:00',1.58),('15844','2014-04-12','11:05:00',1.5),('15844','2014-04-12','11:10:00',1.69),('15844','2014-04-12','11:15:00',2.08),('15844','2014-04-12','11:20:00',1.47),('15844','2014-04-12','11:25:00',1.5),('15844','2014-04-12','11:30:00',1.74),('15844','2014-04-12','11:35:00',3.24),('15844','2014-04-12','11:40:00',3.02),('15844','2014-04-12','11:45:00',3.07),('15844','2014-04-12','11:50:00',2.38),('15844','2014-04-12','11:55:00',1.47),('15844','2014-04-12','12:00:00',1.31),('15844','2014-04-12','12:05:00',1.6),('15844','2014-04-12','12:10:00',1.5),('15844','2014-04-12','12:15:00',2.52),('15844','2014-04-12','12:20:00',3.08),('15844','2014-04-12','12:25:00',2.32),('15844','2014-04-12','12:30:00',1.88),('15844','2014-04-12','12:35:00',1.35),('15844','2014-04-12','12:40:00',2.08),('15844','2014-04-12','12:45:00',2.72),('15844','2014-04-12','12:50:00',2.74),('15844','2014-04-12','12:55:00',2.31),('15844','2014-04-12','13:00:00',3.4),('15844','2014-04-12','13:05:00',3.64),('15844','2014-04-12','13:10:00',3.76),('15844','2014-04-12','13:15:00',3.98),('15844','2014-04-12','13:20:00',4),('15844','2014-04-12','13:25:00',4.05),('15844','2014-04-12','13:30:00',3.89),('15844','2014-04-12','13:35:00',3.2),('15844','2014-04-12','13:40:00',3.85),('15844','2014-04-12','13:45:00',1.82),('15844','2014-04-12','13:50:00',1.64),('15844','2014-04-12','13:55:00',2.79),('15844','2014-04-12','14:00:00',3.36),('15844','2014-04-12','14:05:00',3.32),('15844','2014-04-12','14:10:00',3.42),('15844','2014-04-12','14:15:00',2.33),('15844','2014-04-12','14:20:00',1.89),('15844','2014-04-12','14:25:00',1.79),('15844','2014-04-12','14:30:00',2.35),('15844','2014-04-12','14:35:00',2.44),('15844','2014-04-12','14:40:00',2.53),('15844','2014-04-12','14:45:00',2.67),('15844','2014-04-12','14:50:00',2.28),('15844','2014-04-12','14:55:00',2.18),('15844','2014-04-12','15:00:00',2.12),('15844','2014-04-12','15:05:00',2.26),('15844','2014-04-12','15:10:00',2.19),('15844','2014-04-12','15:15:00',1.73),('15844','2014-04-12','15:20:00',1.59),('15844','2014-04-12','15:25:00',1.51),('15844','2014-04-12','15:30:00',1.27),('15844','2014-04-12','15:35:00',1.18),('15844','2014-04-12','15:40:00',1.51),('15844','2014-04-12','15:45:00',1.65),('15844','2014-04-12','15:50:00',1.58),('15844','2014-04-12','15:55:00',1.49),('15844','2014-04-12','16:00:00',1.4),('15844','2014-04-12','16:05:00',1.37),('15844','2014-04-12','16:10:00',1.28),('15844','2014-04-12','16:15:00',1.33),('15844','2014-04-12','16:20:00',1.28),('15844','2014-04-12','16:25:00',1.1),('15844','2013-09-08','09:10:00',1.3),('15844','2013-09-08','09:15:00',1.49),('15844','2013-09-08','09:20:00',1.61),('15844','2013-09-08','09:25:00',1.65),('15844','2013-09-08','09:30:00',1.73),('15844','2013-09-08','09:35:00',1.79),('15844','2013-09-08','09:40:00',1.89),('15844','2013-09-08','09:45:00',1.99),('15844','2013-09-08','09:50:00',2.11),('15844','2013-09-08','09:55:00',2.2),('15844','2013-09-08','10:00:00',2.26),('15844','2013-09-08','10:05:00',2.34),('15844','2013-09-08','10:10:00',2.34),('15844','2013-09-08','10:15:00',2.44),('15844','2013-09-08','10:20:00',2.61),('15844','2013-09-08','10:25:00',2.67),('15844','2013-09-08','10:30:00',2.85),('15844','2013-09-08','10:35:00',2.9),('15844','2013-09-08','10:40:00',2.84),('15844','2013-09-08','10:45:00',3.04),('15844','2013-09-08','10:50:00',3.19),('15844','2013-09-08','10:55:00',3.2),('15844','2013-09-08','11:00:00',3.23),('15844','2013-09-08','11:05:00',3.23),('15844','2013-09-08','11:10:00',3.19),('15844','2013-09-08','11:15:00',3.38),('15844','2013-09-08','11:20:00',3.4),('15844','2013-09-08','11:25:00',3.35),('15844','2013-09-08','11:30:00',3.37),('15844','2013-09-08','11:35:00',3.35),('15844','2013-09-08','11:40:00',3.26),('15844','2013-09-08','11:45:00',3.1),('15844','2013-09-08','11:50:00',3.33),('15844','2013-09-08','11:55:00',3.39),('15844','2013-09-08','12:00:00',3.34),('15844','2013-09-08','12:05:00',3.05),('15844','2013-09-08','12:10:00',3.52),('15844','2013-09-08','12:15:00',3.49),('15844','2013-09-08','12:20:00',3.41),('15844','2013-09-08','12:25:00',3.4),('15844','2013-09-08','12:30:00',3.51),('15844','2013-09-08','12:35:00',3.4),('15844','2013-09-08','12:40:00',3.4),('15844','2013-09-08','12:45:00',3.37),('15844','2013-09-08','12:50:00',3.35),('15844','2013-09-08','12:55:00',3.3),('15844','2013-09-08','13:00:00',3.35),('15844','2013-09-08','13:05:00',3.33),('15844','2013-09-08','13:10:00',3.22),('15844','2013-09-08','13:15:00',3.12),('15844','2013-09-08','13:20:00',3.03),('15844','2013-09-08','13:25:00',2.75),('15844','2013-09-08','13:30:00',2.81),('15844','2013-09-08','13:35:00',2.15),('15844','2013-09-08','13:40:00',1.7),('15844','2013-09-08','13:45:00',2.35),('15844','2013-09-08','13:50:00',2.83),('15844','2013-09-08','13:55:00',2.83),('15844','2013-09-08','14:00:00',2.78),('15844','2013-09-08','14:05:00',3.08),('15844','2013-09-08','14:10:00',2.93),('15844','2013-09-08','14:15:00',3),('15844','2013-09-08','14:20:00',3.21),('15844','2013-09-08','14:25:00',2.75),('15844','2013-09-08','14:30:00',2.79),('15844','2013-09-08','14:35:00',2.61),('15844','2013-09-08','14:40:00',2.49),('15844','2013-09-08','14:45:00',2.43),('15844','2013-09-08','14:50:00',2.17),('15844','2013-09-08','14:55:00',2.11),('15844','2013-09-08','15:00:00',1.9),('15844','2013-09-08','15:05:00',1.06),('15844','2013-09-08','15:10:00',1.34),('15844','2013-09-08','15:15:00',1.86),('15844','2013-09-08','15:20:00',1.86),('15844','2013-09-08','15:25:00',1.79),('15844','2013-09-08','15:30:00',1.63),('15844','2013-09-08','15:35:00',1.44),('15844','2013-09-08','15:40:00',1.33),('15844','2013-09-08','15:45:00',1.32),('15844','2013-09-08','15:55:00',1.05),('15844','2013-09-08','16:00:00',1.01),('15844','2013-09-07','08:45:00',1.04),('15844','2013-09-07','08:50:00',1.13),('15844','2013-09-07','08:55:00',1.2),('15844','2013-09-07','09:00:00',1.32),('15844','2013-09-07','09:05:00',1.44),('15844','2013-09-07','09:10:00',1.54),('15844','2013-09-07','09:15:00',1.6),('15844','2013-09-07','09:20:00',1.65),('15844','2013-09-07','09:25:00',1.75),('15844','2013-09-07','09:30:00',1.99),('15844','2013-09-07','09:35:00',2.09),('15844','2013-09-07','09:40:00',2.18),('15844','2013-09-07','09:45:00',2.26),('15844','2013-09-07','09:50:00',2.33),('15844','2013-09-07','09:55:00',2.37),('15844','2013-09-07','10:00:00',2.47),('15844','2013-09-07','10:05:00',2.57),('15844','2013-09-07','10:10:00',2.64),('15844','2013-09-07','10:15:00',2.68),('15844','2013-09-07','10:20:00',2.73),('15844','2013-09-07','10:25:00',2.76),('15844','2013-09-07','10:30:00',2.77),('15844','2013-09-07','10:35:00',2.95),('15844','2013-09-07','10:40:00',3.02),('15844','2013-09-07','10:45:00',3.07),('15844','2013-09-07','10:50:00',3.15),('15844','2013-09-07','10:55:00',3.28),('15844','2013-09-07','11:00:00',3.35),('15844','2013-09-07','11:05:00',3.39),('15844','2013-09-07','11:10:00',3.49),('15844','2013-09-07','11:15:00',3.46),('15844','2013-09-07','11:20:00',3.48),('15844','2013-09-07','11:25:00',3.53),('15844','2013-09-07','11:30:00',3.57),('15844','2013-09-07','11:35:00',3.59),('15844','2013-09-07','11:40:00',3.6),('15844','2013-09-07','11:45:00',3.6),('15844','2013-09-07','11:50:00',3.62),('15844','2013-09-07','11:55:00',3.6),('15844','2013-09-07','12:00:00',3.6),('15844','2013-09-07','12:05:00',3.62),('15844','2013-09-07','12:10:00',3.62),('15844','2013-09-07','12:15:00',3.61),('15844','2013-09-07','12:20:00',3.56),('15844','2013-09-07','12:25:00',3.54),('15844','2013-09-07','12:30:00',3.53),('15844','2013-09-07','12:35:00',3.54),('15844','2013-09-07','12:40:00',3.56),('15844','2013-09-07','12:45:00',3.58),('15844','2013-09-07','12:50:00',3.51),('15844','2013-09-07','12:55:00',3.41),('15844','2013-09-07','13:00:00',3.43),('15844','2013-09-07','13:05:00',3.43),('15844','2013-09-07','13:10:00',3.44),('15844','2013-09-07','13:15:00',3.35),('15844','2013-09-07','13:20:00',3.36),('15844','2013-09-07','13:25:00',3.36),('15844','2013-09-07','13:30:00',3.29),('15844','2013-09-07','13:35:00',3.26),('15844','2013-09-07','13:40:00',3.21),('15844','2013-09-07','13:45:00',3.21),('15844','2013-09-07','13:50:00',3.17),('15844','2013-09-07','13:55:00',3.12),('15844','2013-09-07','14:00:00',3.09),('15844','2013-09-07','14:05:00',3.01),('15844','2013-09-07','14:10:00',2.97),('15844','2013-09-07','14:15:00',2.92),('15844','2013-09-07','14:20:00',2.85),('15844','2013-09-07','14:25:00',2.74),('15844','2013-09-07','14:30:00',2.64),('15844','2013-09-07','14:35:00',2.55),('15844','2013-09-07','14:40:00',2.43),('15844','2013-09-07','14:45:00',2.31),('15844','2013-09-07','14:50:00',2.28),('15844','2013-09-07','14:55:00',2.19),('15844','2013-09-07','15:00:00',2.1),('15844','2013-09-07','15:05:00',1.98),('15844','2013-09-07','15:10:00',1.84),('15844','2013-09-07','15:15:00',1.76),('15844','2013-09-07','15:20:00',1.68),('15844','2013-09-07','15:25:00',1.6),('15844','2013-09-07','15:30:00',1.49),('15844','2013-09-07','15:35:00',1.4),('15844','2013-09-07','15:40:00',1.28),('15844','2013-09-07','15:45:00',1.17),('15844','2013-09-07','15:50:00',1.1),('15844','2013-09-07','15:55:00',1.03),('15844','2013-09-06','08:45:00',1.04),('15844','2013-09-06','08:50:00',1.16),('15844','2013-09-06','08:55:00',1.22),('15844','2013-09-06','09:00:00',1.35),('15844','2013-09-06','09:05:00',1.47),('15844','2013-09-06','09:10:00',1.56),('15844','2013-09-06','09:15:00',1.64),('15844','2013-09-06','09:20:00',1.77),('15844','2013-09-06','09:25:00',1.89),('15844','2013-09-06','09:30:00',2.02),('15844','2013-09-06','09:35:00',2.13),('15844','2013-09-06','09:40:00',2.21),('15844','2013-09-06','09:45:00',2.28),('15844','2013-09-06','09:50:00',2.35),('15844','2013-09-06','09:55:00',2.43),('15844','2013-09-06','10:00:00',2.5),('15844','2013-09-06','10:05:00',2.61),('15844','2013-09-06','10:10:00',2.69),('15844','2013-09-06','10:15:00',2.71),('15844','2013-09-06','10:20:00',2.76),('15844','2013-09-06','10:25:00',2.81),('15844','2013-09-06','10:30:00',2.88),('15844','2013-09-06','10:35:00',3.06),('15844','2013-09-06','10:40:00',3.15),('15844','2013-09-06','10:45:00',3.17),('15844','2013-09-06','10:50:00',3.26),('15844','2013-09-06','10:55:00',3.4),('15844','2013-09-06','11:00:00',3.49),('15844','2013-09-06','11:05:00',3.52),('15844','2013-09-06','11:10:00',3.55),('15844','2013-09-06','11:15:00',3.54),('15844','2013-09-06','11:20:00',3.58),('15844','2013-09-06','11:25:00',3.63),('15844','2013-09-06','11:30:00',3.66),('15844','2013-09-06','11:35:00',3.68),('15844','2013-09-06','11:40:00',3.69),('15844','2013-09-06','11:45:00',3.66),('15844','2013-09-06','11:50:00',3.66),('15844','2013-09-06','11:55:00',3.62),('15844','2013-09-06','12:00:00',3.6),('15844','2013-09-06','12:05:00',3.67),('15844','2013-09-06','12:10:00',3.68),('15844','2013-09-06','12:15:00',3.7),('15844','2013-09-06','12:20:00',3.69),('15844','2013-09-06','12:25:00',3.64),('15844','2013-09-06','12:30:00',3.62),('15844','2013-09-06','12:35:00',3.66),('15844','2013-09-06','12:40:00',3.7),('15844','2013-09-06','12:45:00',3.65),('15844','2013-09-06','12:50:00',3.59),('15844','2013-09-06','12:55:00',3.58),('15844','2013-09-06','13:00:00',3.53),('15844','2013-09-06','13:05:00',3.51),('15844','2013-09-06','13:10:00',3.48),('15844','2013-09-06','13:15:00',3.45),('15844','2013-09-06','13:20:00',3.41),('15844','2013-09-06','13:25:00',3.36),('15844','2013-09-06','13:30:00',3.29),('15844','2013-09-06','13:35:00',3.23),('15844','2013-09-06','13:40:00',3.15),('15844','2013-09-06','13:45:00',3.12),('15844','2013-09-06','13:50:00',3.05),('15844','2013-09-06','13:55:00',3.03),('15844','2013-09-06','14:00:00',2.95),('15844','2013-09-06','14:05:00',2.93),('15844','2013-09-06','14:10:00',2.88),('15844','2013-09-06','14:15:00',2.77),('15844','2013-09-06','14:20:00',2.71),('15844','2013-09-06','14:25:00',2.61),('15844','2013-09-06','14:30:00',2.52),('15844','2013-09-06','14:35:00',2.4),('15844','2013-09-06','14:40:00',2.29),('15844','2013-09-06','14:45:00',2.23),('15844','2013-09-06','14:50:00',2.14),('15844','2013-09-06','14:55:00',2.05),('15844','2013-09-06','15:00:00',1.92),('15844','2013-09-06','15:05:00',1.94),('15844','2013-09-06','15:10:00',1.87),('15844','2013-09-06','15:15:00',1.77),('15844','2013-09-06','15:20:00',1.7),('15844','2013-09-06','15:25:00',1.61),('15844','2013-09-06','15:30:00',1.51),('15844','2013-09-06','15:35:00',1.42),('15844','2013-09-06','15:40:00',1.31),('15844','2013-09-06','15:45:00',1.19),('15844','2013-09-06','15:50:00',1.1),('15844','2013-09-06','15:55:00',1.05),('15844','2013-09-05','08:40:00',1.02),('15844','2013-09-05','08:45:00',1.14),('15844','2013-09-05','08:50:00',1.26),('15844','2013-09-05','08:55:00',1.33),('15844','2013-09-05','09:00:00',1.45),('15844','2013-09-05','09:05:00',1.59),('15844','2013-09-05','09:10:00',1.69),('15844','2013-09-05','09:15:00',1.74),('15844','2013-09-05','09:20:00',1.88),('15844','2013-09-05','09:25:00',2.05),('15844','2013-09-05','09:30:00',2.19),('15844','2013-09-05','09:35:00',2.3),('15844','2013-09-05','09:40:00',2.4),('15844','2013-09-05','09:45:00',2.46),('15844','2013-09-05','09:50:00',2.52),('15844','2013-09-05','09:55:00',2.58),('15844','2013-09-05','10:00:00',2.66),('15844','2013-09-05','10:05:00',2.76),('15844','2013-09-05','10:10:00',2.84),('15844','2013-09-05','10:15:00',2.88),('15844','2013-09-05','10:20:00',2.93),('15844','2013-09-05','10:25:00',2.96),('15844','2013-09-05','10:30:00',3.03),('15844','2013-09-05','10:35:00',3.19),('15844','2013-09-05','10:40:00',3.26),('15844','2013-09-05','10:45:00',3.3),('15844','2013-09-05','10:50:00',3.37),('15844','2013-09-05','10:55:00',3.51),('15844','2013-09-05','11:00:00',3.57),('15844','2013-09-05','11:05:00',3.59),('15844','2013-09-05','11:10:00',3.64),('15844','2013-09-05','11:15:00',3.66),('15844','2013-09-05','11:20:00',3.69),('15844','2013-09-05','11:25:00',3.69),('15844','2013-09-05','11:30:00',3.72),('15844','2013-09-05','11:35:00',3.71),('15844','2013-09-05','11:40:00',3.77),('15844','2013-09-05','11:45:00',3.78),('15844','2013-09-05','11:50:00',3.75),('15844','2013-09-05','11:55:00',3.72),('15844','2013-09-05','12:00:00',3.76),('15844','2013-09-05','12:05:00',3.79),('15844','2013-09-05','12:10:00',3.78),('15844','2013-09-05','12:15:00',3.79),('15844','2013-09-05','12:20:00',3.78),('15844','2013-09-05','12:25:00',3.78),('15844','2013-09-05','12:30:00',3.78),('15844','2013-09-05','12:35:00',3.76),('15844','2013-09-05','12:40:00',3.73),('15844','2013-09-05','12:45:00',3.71),('15844','2013-09-05','12:50:00',3.7),('15844','2013-09-05','12:55:00',3.67),('15844','2013-09-05','13:00:00',3.66),('15844','2013-09-05','13:05:00',3.62),('15844','2013-09-05','13:10:00',3.6),('15844','2013-09-05','13:15:00',3.56),('15844','2013-09-05','13:20:00',3.56),('15844','2013-09-05','13:25:00',3.52),('15844','2013-09-05','13:30:00',3.49),('15844','2013-09-05','13:35:00',3.43),('15844','2013-09-05','13:40:00',3.38),('15844','2013-09-05','13:45:00',3.31),('15844','2013-09-05','13:50:00',3.26),('15844','2013-09-05','13:55:00',3.22),('15844','2013-09-05','14:00:00',3.17),('15844','2013-09-05','14:05:00',3.1),('15844','2013-09-05','14:10:00',3.01),('15844','2013-09-05','14:15:00',2.96),('15844','2013-09-05','14:20:00',2.9),('15844','2013-09-05','14:25:00',2.78),('15844','2013-09-05','14:30:00',2.64),('15844','2013-09-05','14:35:00',2.54),('15844','2013-09-05','14:40:00',2.42),('15844','2013-09-05','14:45:00',2.3),('15844','2013-09-05','14:50:00',2.2),('15844','2013-09-05','14:55:00',2.15),('15844','2013-09-05','15:00:00',2.14),('15844','2013-09-05','15:05:00',2.04),('15844','2013-09-05','15:10:00',1.92),('15844','2013-09-05','15:15:00',1.81),('15844','2013-09-05','15:20:00',1.74),('15844','2013-09-05','15:25:00',1.67),('15844','2013-09-05','15:30:00',1.57),('15844','2013-09-05','15:35:00',1.46),('15844','2013-09-05','15:40:00',1.35),('15844','2013-09-05','15:45:00',1.22),('15844','2013-09-05','15:50:00',1.14),('15844','2013-09-05','15:55:00',1.07),('15844','2013-09-04','08:40:00',1.01),('15844','2013-09-04','08:45:00',1.13),('15844','2013-09-04','08:50:00',1.26),('15844','2013-09-04','08:55:00',1.33),('15844','2013-09-04','09:00:00',1.46),('15844','2013-09-04','09:05:00',1.59),('15844','2013-09-04','09:10:00',1.69),('15844','2013-09-04','09:15:00',1.78),('15844','2013-09-04','09:20:00',1.91),('15844','2013-09-04','09:25:00',2.04),('15844','2013-09-04','09:30:00',2.17),('15844','2013-09-04','09:35:00',2.29),('15844','2013-09-04','09:40:00',2.4),('15844','2013-09-04','09:45:00',2.48),('15844','2013-09-04','09:50:00',2.54),('15844','2013-09-04','09:55:00',2.61),('15844','2013-09-04','10:00:00',2.68),('15844','2013-09-04','10:05:00',2.8),('15844','2013-09-04','10:10:00',2.86),('15844','2013-09-04','10:15:00',2.89),('15844','2013-09-04','10:20:00',2.94),('15844','2013-09-04','10:25:00',2.99),('15844','2013-09-04','10:30:00',3.04),('15844','2013-09-04','10:35:00',3.22),('15844','2013-09-04','10:40:00',3.32),('15844','2013-09-04','10:45:00',3.4),('15844','2013-09-04','10:50:00',3.48),('15844','2013-09-04','10:55:00',3.6),('15844','2013-09-04','11:00:00',3.68),('15844','2013-09-04','11:05:00',3.74),('15844','2013-09-04','11:10:00',3.77),('15844','2013-09-04','11:15:00',3.8),('15844','2013-09-04','11:20:00',3.83),('15844','2013-09-04','11:25:00',3.85),('15844','2013-09-04','11:30:00',3.85),('15844','2013-09-04','11:35:00',3.88),('15844','2013-09-04','11:40:00',3.9),('15844','2013-09-04','11:45:00',3.91),('15844','2013-09-04','11:50:00',3.9),('15844','2013-09-04','11:55:00',3.91),('15844','2013-09-04','12:00:00',3.9),('15844','2013-09-04','12:05:00',3.9),('15844','2013-09-04','12:10:00',3.91),('15844','2013-09-04','12:15:00',3.88),('15844','2013-09-04','12:20:00',3.88),('15844','2013-09-04','12:25:00',3.87),('15844','2013-09-04','12:30:00',3.85),('15844','2013-09-04','12:35:00',3.83),('15844','2013-09-04','12:40:00',3.84),('15844','2013-09-04','12:45:00',3.81),('15844','2013-09-04','12:50:00',3.8),('15844','2013-09-04','12:55:00',3.78),('15844','2013-09-04','13:00:00',3.75),('15844','2013-09-04','13:05:00',3.69),('15844','2013-09-04','13:10:00',3.66),('15844','2013-09-04','13:15:00',3.65),('15844','2013-09-04','13:20:00',3.61),('15844','2013-09-04','13:25:00',3.59),('15844','2013-09-04','13:30:00',3.54),('15844','2013-09-04','13:35:00',3.48),('15844','2013-09-04','13:40:00',3.44),('15844','2013-09-04','13:45:00',3.36),('15844','2013-09-04','13:50:00',3.31),('15844','2013-09-04','13:55:00',3.25),('15844','2013-09-04','14:00:00',3.16),('15844','2013-09-04','14:05:00',3.1),('15844','2013-09-04','14:10:00',3.02),('15844','2013-09-04','14:15:00',2.96),('15844','2013-09-04','14:20:00',2.9),('15844','2013-09-04','14:25:00',2.81),('15844','2013-09-04','14:30:00',2.68),('15844','2013-09-04','14:35:00',2.57),('15844','2013-09-04','14:40:00',2.45),('15844','2013-09-04','14:45:00',2.34),('15844','2013-09-04','14:50:00',2.21),('15844','2013-09-04','14:55:00',2.1),('15844','2013-09-04','15:00:00',1.98),('15844','2013-09-04','15:05:00',2.01),('15844','2013-09-04','15:10:00',1.98),('15844','2013-09-04','15:15:00',1.89),('15844','2013-09-04','15:20:00',1.81),('15844','2013-09-04','15:25:00',1.71),('15844','2013-09-04','15:30:00',1.61),('15844','2013-09-04','15:35:00',1.51),('15844','2013-09-04','15:40:00',1.38),('15844','2013-09-04','15:45:00',1.25),('15844','2013-09-04','15:50:00',1.16),('15844','2013-09-04','15:55:00',1.08),('15844','2013-09-03','08:45:00',1.06),('15844','2013-09-03','08:50:00',1.17),('15844','2013-09-03','08:55:00',1.22),('15844','2013-09-03','09:00:00',1.32),('15844','2013-09-03','09:05:00',1.44),('15844','2013-09-03','09:10:00',1.53),('15844','2013-09-03','09:15:00',1.67),('15844','2013-09-03','09:20:00',1.79),('15844','2013-09-03','09:25:00',1.9),('15844','2013-09-03','09:30:00',1.99),('15844','2013-09-03','09:35:00',2.09),('15844','2013-09-03','09:40:00',2.2),('15844','2013-09-03','09:45:00',2.27),('15844','2013-09-03','09:50:00',2.35),('15844','2013-09-03','09:55:00',2.4),('15844','2013-09-03','10:00:00',2.45),('15844','2013-09-03','10:05:00',2.56),('15844','2013-09-03','10:10:00',2.63),('15844','2013-09-03','10:15:00',2.68),('15844','2013-09-03','10:20:00',2.76),('15844','2013-09-03','10:25:00',2.82),('15844','2013-09-03','10:30:00',2.92),('15844','2013-09-03','10:35:00',3.1),('15844','2013-09-03','10:40:00',3.19),('15844','2013-09-03','10:45:00',3.24),('15844','2013-09-03','10:50:00',3.29),('15844','2013-09-03','10:55:00',3.38),('15844','2013-09-03','11:00:00',3.46),('15844','2013-09-03','11:05:00',3.52),('15844','2013-09-03','11:10:00',3.57),('15844','2013-09-03','11:15:00',3.6),('15844','2013-09-03','11:20:00',3.64),('15844','2013-09-03','11:25:00',3.65),('15844','2013-09-03','11:30:00',3.65),('15844','2013-09-03','11:35:00',3.67),('15844','2013-09-03','11:40:00',3.68),('15844','2013-09-03','11:45:00',3.69),('15844','2013-09-03','11:50:00',3.69),('15844','2013-09-03','11:55:00',3.73),('15844','2013-09-03','12:00:00',3.76),('15844','2013-09-03','12:05:00',3.75),('15844','2013-09-03','12:10:00',3.75),('15844','2013-09-03','12:15:00',3.74),('15844','2013-09-03','12:20:00',3.75),('15844','2013-09-03','12:25:00',3.73),('15844','2013-09-03','12:30:00',3.75),('15844','2013-09-03','12:35:00',3.71),('15844','2013-09-03','12:40:00',3.74),('15844','2013-09-03','12:45:00',3.72),('15844','2013-09-03','12:50:00',3.71),('15844','2013-09-03','12:55:00',3.68),('15844','2013-09-03','13:00:00',3.67),('15844','2013-09-03','13:05:00',3.68),('15844','2013-09-03','13:10:00',3.64),('15844','2013-09-03','13:15:00',3.6),('15844','2013-09-03','13:20:00',3.58),('15844','2013-09-03','13:25:00',3.53),('15844','2013-09-03','13:30:00',3.53),('15844','2013-09-03','13:35:00',3.51),('15844','2013-09-03','13:40:00',3.41),('15844','2013-09-03','13:45:00',3.34),('15844','2013-09-03','13:50:00',3.26),('15844','2013-09-03','13:55:00',3.24),('15844','2013-09-03','14:00:00',3.19),('15844','2013-09-03','14:05:00',3.14),('15844','2013-09-03','14:10:00',3.08),('15844','2013-09-03','14:15:00',3),('15844','2013-09-03','14:20:00',2.89),('15844','2013-09-03','14:25:00',2.79),('15844','2013-09-03','14:30:00',2.67),('15844','2013-09-03','14:35:00',2.55),('15844','2013-09-03','14:40:00',2.45),('15844','2013-09-03','14:45:00',2.34),('15844','2013-09-03','14:50:00',2.28),('15844','2013-09-03','14:55:00',2.28),('15844','2013-09-03','15:00:00',2.18),('15844','2013-09-03','15:05:00',2.07),('15844','2013-09-03','15:10:00',1.99),('15844','2013-09-03','15:15:00',1.89),('15844','2013-09-03','15:20:00',1.82),('15844','2013-09-03','15:25:00',1.73),('15844','2013-09-03','15:30:00',1.62),('15844','2013-09-03','15:35:00',1.52),('15844','2013-09-03','15:40:00',1.4),('15844','2013-09-03','15:45:00',1.28),('15844','2013-09-03','15:50:00',1.18),('15844','2013-09-03','15:55:00',1.1),('15844','2013-09-03','16:00:00',1.03),('15844','2013-09-02','08:45:00',1.08),('15844','2013-09-02','08:50:00',1.19),('15844','2013-09-02','08:55:00',1.24),('15844','2013-09-02','09:00:00',1.35),('15844','2013-09-02','09:05:00',1.45),('15844','2013-09-02','09:10:00',1.53),('15844','2013-09-02','09:15:00',1.62),('15844','2013-09-02','09:20:00',1.74),('15844','2013-09-02','09:25:00',1.87),('15844','2013-09-02','09:30:00',1.99),('15844','2013-09-02','09:35:00',2.08),('15844','2013-09-02','09:40:00',2.15),('15844','2013-09-02','09:45:00',2.23),('15844','2013-09-02','09:50:00',2.28),('15844','2013-09-02','09:55:00',2.36),('15844','2013-09-02','10:00:00',2.47),('15844','2013-09-02','10:05:00',2.6),('15844','2013-09-02','10:10:00',2.69),('15844','2013-09-02','10:15:00',2.75),('15844','2013-09-02','10:20:00',2.8),('15844','2013-09-02','10:25:00',2.86),('15844','2013-09-02','10:30:00',2.98),('15844','2013-09-02','10:35:00',3.13),('15844','2013-09-02','10:40:00',3.21),('15844','2013-09-02','10:45:00',3.24),('15844','2013-09-02','10:50:00',3.35),('15844','2013-09-02','10:55:00',3.45),('15844','2013-09-02','11:00:00',3.51),('15844','2013-09-02','11:05:00',3.52),('15844','2013-09-02','11:10:00',3.64),('15844','2013-09-02','11:15:00',3.65),('15844','2013-09-02','11:20:00',3.67),('15844','2013-09-02','11:25:00',3.68),('15844','2013-09-02','11:30:00',3.72),('15844','2013-09-02','11:35:00',3.72),('15844','2013-09-02','11:40:00',3.73),('15844','2013-09-02','11:45:00',3.75),('15844','2013-09-02','11:50:00',3.74),('15844','2013-09-02','11:55:00',3.76),('15844','2013-09-02','12:00:00',3.79),('15844','2013-09-02','12:05:00',3.74),('15844','2013-09-02','12:10:00',3.78),('15844','2013-09-02','12:15:00',3.78),('15844','2013-09-02','12:20:00',3.77),('15844','2013-09-02','12:25:00',3.76),('15844','2013-09-02','12:30:00',3.75),('15844','2013-09-02','12:35:00',3.73),('15844','2013-09-02','12:40:00',3.71),('15844','2013-09-02','12:45:00',3.67),('15844','2013-09-02','12:50:00',3.64),('15844','2013-09-02','12:55:00',3.64),('15844','2013-09-02','13:00:00',3.59),('15844','2013-09-02','13:05:00',3.58),('15844','2013-09-02','13:10:00',3.58),('15844','2013-09-02','13:15:00',3.6),('15844','2013-09-02','13:20:00',3.51),('15844','2013-09-02','13:25:00',3.46),('15844','2013-09-02','13:30:00',3.46),('15844','2013-09-02','13:35:00',3.38),('15844','2013-09-02','13:40:00',3.39),('15844','2013-09-02','13:45:00',3.36),('15844','2013-09-02','13:50:00',3.23),('15844','2013-09-02','13:55:00',3.19),('15844','2013-09-02','14:00:00',3.19),('15844','2013-09-02','14:05:00',3.15),('15844','2013-09-02','14:10:00',3.01),('15844','2013-09-02','14:15:00',2.98),('15844','2013-09-02','14:20:00',2.9),('15844','2013-09-02','14:25:00',2.64),('15844','2013-09-02','14:30:00',2.73),('15844','2013-09-02','14:35:00',2.59),('15844','2013-09-02','14:40:00',2.46),('15844','2013-09-02','14:45:00',2.41),('15844','2013-09-02','14:50:00',2.38),('15844','2013-09-02','14:55:00',2.21),('15844','2013-09-02','15:00:00',2.07),('15844','2013-09-02','15:05:00',1.96),('15844','2013-09-02','15:10:00',1.95),('15844','2013-09-02','15:15:00',1.92),('15844','2013-09-02','15:20:00',1.89),('15844','2013-09-02','15:25:00',1.77),('15844','2013-09-02','15:30:00',1.7),('15844','2013-09-02','15:35:00',1.59),('15844','2013-09-02','15:40:00',1.46),('15844','2013-09-02','15:45:00',1.35),('15844','2013-09-02','15:50:00',1.24),('15844','2013-09-02','15:55:00',1.18),('15844','2013-09-02','16:00:00',1.12),('15844','2013-09-02','16:05:00',1.08),('15844','2013-09-02','16:10:00',1.03),('15844','2013-09-01','08:50:00',1.07),('15844','2013-09-01','08:55:00',1.29),('15844','2013-09-01','09:00:00',1.4),('15844','2013-09-01','09:05:00',1.52),('15844','2013-09-01','09:10:00',1.62),('15844','2013-09-01','09:15:00',1.71),('15844','2013-09-01','09:20:00',1.84),('15844','2013-09-01','09:25:00',1.96),('15844','2013-09-01','09:30:00',2.06),('15844','2013-09-01','09:35:00',2.18),('15844','2013-09-01','09:40:00',2.25),('15844','2013-09-01','09:45:00',2.3),('15844','2013-09-01','09:50:00',2.36),('15844','2013-09-01','09:55:00',2.42),('15844','2013-09-01','10:00:00',2.54),('15844','2013-09-01','10:05:00',2.66),('15844','2013-09-01','10:10:00',2.76),('15844','2013-09-01','10:15:00',2.8),('15844','2013-09-01','10:20:00',2.83),('15844','2013-09-01','10:25:00',2.89),('15844','2013-09-01','10:30:00',2.95),('15844','2013-09-01','10:35:00',3.17),('15844','2013-09-01','10:40:00',3.25),('15844','2013-09-01','10:45:00',3.32),('15844','2013-09-01','10:50:00',3.39),('15844','2013-09-01','10:55:00',3.54),('15844','2013-09-01','11:00:00',3.6),('15844','2013-09-01','11:05:00',3.65),('15844','2013-09-01','11:10:00',3.67),('15844','2013-09-01','11:15:00',3.71),('15844','2013-09-01','11:20:00',3.72),('15844','2013-09-01','11:25:00',3.75),('15844','2013-09-01','11:30:00',3.77),('15844','2013-09-01','11:35:00',3.8),('15844','2013-09-01','11:40:00',3.81),('15844','2013-09-01','11:45:00',3.81),('15844','2013-09-01','11:50:00',3.82),('15844','2013-09-01','11:55:00',3.81),('15844','2013-09-01','12:00:00',3.8),('15844','2013-09-01','12:05:00',3.71),('15844','2013-09-01','12:10:00',3.83),('15844','2013-09-01','12:15:00',3.81),('15844','2013-09-01','12:20:00',3.76),('15844','2013-09-01','12:25:00',3.78),('15844','2013-09-01','12:30:00',3.78),('15844','2013-09-01','12:35:00',3.76),('15844','2013-09-01','12:40:00',3.73),('15844','2013-09-01','12:45:00',3.7),('15844','2013-09-01','12:50:00',3.71),('15844','2013-09-01','12:55:00',3.69),('15844','2013-09-01','13:00:00',3.41),('15844','2013-09-01','13:05:00',3.49),('15844','2013-09-01','13:10:00',3.54),('15844','2013-09-01','13:15:00',3.63),('15844','2013-09-01','13:20:00',3.26),('15844','2013-09-01','13:25:00',3.43),('15844','2013-09-01','13:30:00',3.58),('15844','2013-09-01','13:35:00',3.59),('15844','2013-09-01','13:40:00',3.48),('15844','2013-09-01','13:45:00',3.45),('15844','2013-09-01','13:50:00',3.39),('15844','2013-09-01','13:55:00',3.32),('15844','2013-09-01','14:00:00',3.19),('15844','2013-09-01','14:05:00',2.66),('15844','2013-09-01','14:10:00',2.71),('15844','2013-09-01','14:15:00',2.55),('15844','2013-09-01','14:20:00',2.52),('15844','2013-09-01','14:25:00',2.5),('15844','2013-09-01','14:30:00',2.36),('15844','2013-09-01','14:35:00',2.2),('15844','2013-09-01','14:40:00',2.42),('15844','2013-09-01','14:45:00',2.34),('15844','2013-09-01','14:50:00',2.24),('15844','2013-09-01','14:55:00',2.19),('15844','2013-09-01','15:00:00',2.18),('15844','2013-09-01','15:05:00',2.06),('15844','2013-09-01','15:10:00',2.02),('15844','2013-09-01','15:15:00',1.98),('15844','2013-09-01','15:20:00',1.79),('15844','2013-09-01','15:25:00',1.59),('15844','2013-09-01','15:30:00',1.35),('15844','2013-09-01','15:35:00',1.48),('15844','2013-09-01','15:40:00',1.43),('15844','2013-09-01','15:45:00',1.37),('15844','2013-09-01','15:50:00',1.29),('15844','2013-09-01','15:55:00',1.2),('15844','2013-09-01','16:00:00',1.14),('15844','2013-09-01','16:05:00',1.15),('15844','2013-09-01','16:10:00',1.27),('15844','2013-09-01','16:15:00',1.22),('15844','2013-09-01','16:20:00',1.14),('15844','2013-09-01','16:25:00',1.03),('15844','2013-08-31','08:40:00',1.04),('15844','2013-08-31','08:45:00',1.24),('15844','2013-08-31','08:50:00',1.44),('15844','2013-08-31','08:55:00',1.56),('15844','2013-08-31','09:00:00',1.54),('15844','2013-08-31','09:05:00',1.4),('15844','2013-08-31','09:10:00',1.16),('15844','2013-08-31','09:15:00',1.74),('15844','2013-08-31','09:20:00',1.93),('15844','2013-08-31','09:25:00',2.15),('15844','2013-08-31','09:30:00',2.27),('15844','2013-08-31','09:35:00',2.42),('15844','2013-08-31','09:40:00',2.24),('15844','2013-08-31','09:45:00',2.24),('15844','2013-08-31','09:50:00',2.44),('15844','2013-08-31','09:55:00',2.49),('15844','2013-08-31','10:00:00',2.6),('15844','2013-08-31','10:05:00',2.74),('15844','2013-08-31','10:10:00',2.82),('15844','2013-08-31','10:15:00',2.87),('15844','2013-08-31','10:20:00',2.9),('15844','2013-08-31','10:25:00',2.94),('15844','2013-08-31','10:30:00',3.12),('15844','2013-08-31','10:35:00',3.19),('15844','2013-08-31','10:40:00',3.29),('15844','2013-08-31','10:45:00',3.39),('15844','2013-08-31','10:50:00',3.45),('15844','2013-08-31','10:55:00',3.61),('15844','2013-08-31','11:00:00',3.73),('15844','2013-08-31','11:05:00',3.74),('15844','2013-08-31','11:10:00',3.78),('15844','2013-08-31','11:15:00',3.82),('15844','2013-08-31','11:20:00',3.86),('15844','2013-08-31','11:25:00',3.88),('15844','2013-08-31','11:30:00',3.89),('15844','2013-08-31','11:35:00',3.93),('15844','2013-08-31','11:40:00',3.92),('15844','2013-08-31','11:45:00',3.96),('15844','2013-08-31','11:50:00',3.94),('15844','2013-08-31','11:55:00',3.96),('15844','2013-08-31','12:00:00',3.95),('15844','2013-08-31','12:05:00',3.95),('15844','2013-08-31','12:10:00',3.93),('15844','2013-08-31','12:15:00',3.95),('15844','2013-08-31','12:20:00',3.93),('15844','2013-08-31','12:25:00',3.93),('15844','2013-08-31','12:30:00',3.87),('15844','2013-08-31','12:35:00',3.88),('15844','2013-08-31','12:40:00',3.86),('15844','2013-08-31','12:45:00',3.83),('15844','2013-08-31','12:50:00',3.83),('15844','2013-08-31','12:55:00',3.82),('15844','2013-08-31','13:00:00',3.81),('15844','2013-08-31','13:05:00',3.74),('15844','2013-08-31','13:10:00',3.71),('15844','2013-08-31','13:15:00',3.73),('15844','2013-08-31','13:20:00',3.7),('15844','2013-08-31','13:25:00',3.61),('15844','2013-08-31','13:30:00',3.59),('15844','2013-08-31','13:35:00',3.47),('15844','2013-08-31','13:40:00',3.43),('15844','2013-08-31','13:45:00',3.43),('15844','2013-08-31','13:50:00',3.34),('15844','2013-08-31','13:55:00',3.28),('15844','2013-08-31','14:00:00',3.23),('15844','2013-08-31','14:05:00',3.17),('15844','2013-08-31','14:10:00',3.12),('15844','2013-08-31','14:15:00',3.03),('15844','2013-08-31','14:20:00',2.94),('15844','2013-08-31','14:25:00',2.88),('15844','2013-08-31','14:30:00',2.72),('15844','2013-08-31','14:35:00',2.6),('15844','2013-08-31','14:40:00',2.5),('15844','2013-08-31','14:45:00',2.42),('15844','2013-08-31','14:50:00',2.38),('15844','2013-08-31','14:55:00',2.24),('15844','2013-08-31','15:00:00',2.2),('15844','2013-08-31','15:05:00',2.09),('15844','2013-08-31','15:10:00',2.02),('15844','2013-08-31','15:15:00',1.94),('15844','2013-08-31','15:20:00',1.86),('15844','2013-08-31','15:25:00',1.78),('15844','2013-08-31','15:30:00',1.68),('15844','2013-08-31','15:35:00',1.61),('15844','2013-08-31','15:40:00',1.49),('15844','2013-08-31','15:45:00',1.38),('15844','2013-08-31','15:50:00',1.27),('15844','2013-08-31','15:55:00',1.2),('15844','2013-08-31','16:00:00',1.13),('15844','2013-08-31','16:05:00',1.08),('15844','2013-08-31','16:10:00',1.03),('15844','2013-08-30','08:30:00',1),('15844','2013-08-30','08:35:00',1.12),('15844','2013-08-30','08:40:00',1.1),('15844','2013-08-30','08:45:00',1.02),('15844','2013-08-30','08:50:00',1),('15844','2013-08-30','08:55:00',1.09),('15844','2013-08-30','09:00:00',1.26),('15844','2013-08-30','09:05:00',1.28),('15844','2013-08-30','09:10:00',1.16),('15844','2013-08-30','09:15:00',1.04),('15844','2013-08-30','09:25:00',1.19),('15844','2013-08-30','09:30:00',1.38),('15844','2013-08-30','09:35:00',1.48),('15844','2013-08-30','09:40:00',1.48),('15844','2013-08-30','09:45:00',1.5),('15844','2013-08-30','09:50:00',1.58),('15844','2013-08-30','09:55:00',1.65),('15844','2013-08-30','10:00:00',1.62),('15844','2013-08-30','10:05:00',1.65),('15844','2013-08-30','10:10:00',1.77),('15844','2013-08-30','10:15:00',1.9),('15844','2013-08-30','10:20:00',1.8),('15844','2013-08-30','10:25:00',1.89),('15844','2013-08-30','10:30:00',1.97),('15844','2013-08-30','10:35:00',1.92),('15844','2013-08-30','10:40:00',1.75),('15844','2013-08-30','10:45:00',1.85),('15844','2013-08-30','10:50:00',1.92),('15844','2013-08-30','10:55:00',1.82),('15844','2013-08-30','11:00:00',1.96),('15844','2013-08-30','11:05:00',2.08),('15844','2013-08-30','11:10:00',2.3),('15844','2013-08-30','11:15:00',2.19),('15844','2013-08-30','11:20:00',2.31),('15844','2013-08-30','11:25:00',2.37),('15844','2013-08-30','11:30:00',2.47),('15844','2013-08-30','11:35:00',2.41),('15844','2013-08-30','11:40:00',2.5),('15844','2013-08-30','11:45:00',2.7),('15844','2013-08-30','11:50:00',2.88),('15844','2013-08-30','11:55:00',2.39),('15844','2013-08-30','12:00:00',1.96),('15844','2013-08-30','12:05:00',1.94),('15844','2013-08-30','12:10:00',2.2),('15844','2013-08-30','12:15:00',2.26),('15844','2013-08-30','12:20:00',2.51),('15844','2013-08-30','12:25:00',2.97),('15844','2013-08-30','12:30:00',3.08),('15844','2013-08-30','12:35:00',2.85),('15844','2013-08-30','12:40:00',2.98),('15844','2013-08-30','12:45:00',2.83),('15844','2013-08-30','12:50:00',2.73),('15844','2013-08-30','12:55:00',2.46),('15844','2013-08-30','13:00:00',2.5),('15844','2013-08-30','13:05:00',2.42),('15844','2013-08-30','13:10:00',2.36),('15844','2013-08-30','13:15:00',2.35),('15844','2013-08-30','13:20:00',3.3),('15844','2013-08-30','13:25:00',3.74),('15844','2013-08-30','13:30:00',3.54),('15844','2013-08-30','13:35:00',3.34),('15844','2013-08-30','13:40:00',3.54),('15844','2013-08-30','13:45:00',3.28),('15844','2013-08-30','13:50:00',3.26),('15844','2013-08-30','13:55:00',3.33),('15844','2013-08-30','14:00:00',3.35),('15844','2013-08-30','14:05:00',3.17),('15844','2013-08-30','14:10:00',3.21),('15844','2013-08-30','14:15:00',3.06),('15844','2013-08-30','14:20:00',3.04),('15844','2013-08-30','14:25:00',2.92),('15844','2013-08-30','14:30:00',2.87),('15844','2013-08-30','14:35:00',2.73),('15844','2013-08-30','14:40:00',2.47),('15844','2013-08-30','14:45:00',2.21),('15844','2013-08-30','14:50:00',2.02),('15844','2013-08-30','14:55:00',1.95),('15844','2013-08-30','15:00:00',1.68),('15844','2013-08-30','15:05:00',1.68),('15844','2013-08-30','15:10:00',1.82),('15844','2013-08-30','15:15:00',1.78),('15844','2013-08-30','15:20:00',1.61),('15844','2013-08-30','15:25:00',1.6),('15844','2013-08-30','15:30:00',1.53),('15844','2013-08-30','15:35:00',1.42),('15844','2013-08-30','15:40:00',1.59),('15844','2013-08-30','15:45:00',1.55),('15844','2013-08-30','15:50:00',1.43),('15844','2013-08-30','15:55:00',1.4),('15844','2013-08-30','16:00:00',1.3),('15844','2013-08-30','16:05:00',1.15),('15844','2013-08-30','16:10:00',1.13),('15844','2013-08-30','16:15:00',1.17),('15844','2013-08-30','16:20:00',1.15),('15844','2013-08-30','16:25:00',1.11),('15844','2013-08-30','16:30:00',1.14),('15844','2013-08-30','16:35:00',1.13),('15844','2013-08-30','16:40:00',1.02),('15844','2014-04-11','08:45:00',1.09),('15844','2014-04-11','08:50:00',1.38),('15844','2014-04-11','08:55:00',1.48),('15844','2014-04-11','09:00:00',1.54),('15844','2014-04-11','09:05:00',1.67),('15844','2014-04-11','09:10:00',1.75),('15844','2014-04-11','09:15:00',1.88),('15844','2014-04-11','09:20:00',1.99),('15844','2014-04-11','09:25:00',2.1),('15844','2014-04-11','09:30:00',2.23),('15844','2014-04-11','09:35:00',2.34),('15844','2014-04-11','09:40:00',2.39),('15844','2014-04-11','09:45:00',2.45),('15844','2014-04-11','09:50:00',2.53),('15844','2014-04-11','09:55:00',2.58),('15844','2014-04-11','10:00:00',2.71),('15844','2014-04-11','10:05:00',2.82),('15844','2014-04-11','10:10:00',2.87),('15844','2014-04-11','10:15:00',2.97),('15844','2014-04-11','10:20:00',3.05),('15844','2014-04-11','10:25:00',3.09),('15844','2014-04-11','10:30:00',3.14),('15844','2014-04-11','10:35:00',3.24),('15844','2014-04-11','10:40:00',3.39),('15844','2014-04-11','10:45:00',3.52),('15844','2014-04-11','10:50:00',3.58),('15844','2014-04-11','10:55:00',3.66),('15844','2014-04-11','11:00:00',3.76),('15844','2014-04-11','11:05:00',3.88),('15844','2014-04-11','11:10:00',3.89),('15844','2014-04-11','11:15:00',3.92),('15844','2014-04-11','11:20:00',3.98),('15844','2014-04-11','11:25:00',4.02),('15844','2014-04-11','11:30:00',4.02),('15844','2014-04-11','11:35:00',4.1),('15844','2014-04-11','11:40:00',4.23),('15844','2014-04-11','11:45:00',4.3),('15844','2014-04-11','11:50:00',2.33),('15844','2014-04-11','11:55:00',3.7),('15844','2014-04-11','12:00:00',4.31),('15844','2014-04-11','12:05:00',4.17),('15844','2014-04-11','12:10:00',3.61),('15844','2014-04-11','12:15:00',2.77),('15844','2014-04-11','12:20:00',3.48),('15844','2014-04-11','12:25:00',3.33),('15844','2014-04-11','12:30:00',3.41),('15844','2014-04-11','12:35:00',4.13),('15844','2014-04-11','12:40:00',2.55),('15844','2014-04-11','12:45:00',3.14),('15844','2014-04-11','12:50:00',3.03),('15844','2014-04-11','12:55:00',3.49),('15844','2014-04-11','13:00:00',2.28),('15844','2014-04-11','13:05:00',4.02),('15844','2014-04-11','13:10:00',3.89),('15844','2014-04-11','13:15:00',3.8),('15844','2014-04-11','13:20:00',4.15),('15844','2014-04-11','13:25:00',3.54),('15844','2014-04-11','13:30:00',3.75),('15844','2014-04-11','13:35:00',4.27),('15844','2014-04-11','13:40:00',3.93),('15844','2014-04-11','13:45:00',3.95),('15844','2014-04-11','13:50:00',3.4),('15844','2014-04-11','13:55:00',3.29),('15844','2014-04-11','14:00:00',2.59),('15844','2014-04-11','14:05:00',2.55),('15844','2014-04-11','14:10:00',4.07),('15844','2014-04-11','14:15:00',1.44),('15844','2014-04-11','14:20:00',1.62),('15844','2014-04-11','14:25:00',1.85),('15844','2014-04-11','14:30:00',3.56),('15844','2014-04-11','14:35:00',3.11),('15844','2014-04-11','14:40:00',2.94),('15844','2014-04-11','14:45:00',1.87),('15844','2014-04-11','14:50:00',2.63),('15844','2014-04-11','14:55:00',1.84),('15844','2014-04-11','15:00:00',1.91),('15844','2014-04-11','15:05:00',2.45),('15844','2014-04-11','15:10:00',2.17),('15844','2014-04-11','15:15:00',2.15),('15844','2014-04-11','15:20:00',1.83),('15844','2014-04-11','15:25:00',1.98),('15844','2014-04-11','15:30:00',1.87),('15844','2014-04-11','15:35:00',1.74),('15844','2014-04-11','15:40:00',1.64),('15844','2014-04-11','15:45:00',1.55),('15844','2014-04-11','15:50:00',1.35),('15844','2014-04-11','15:55:00',1.04),('15844','2014-04-11','16:05:00',1.34),('15844','2014-04-11','16:10:00',1.28),('15844','2014-04-11','16:15:00',1.21),('15844','2014-04-11','16:25:00',1.12),('15844','2013-08-29','08:25:00',1.01),('15844','2013-08-29','08:30:00',1.23),('15844','2013-08-29','08:35:00',1.11),('15844','2013-08-29','08:50:00',1.09),('15844','2013-08-29','08:55:00',1.24),('15844','2013-08-29','09:00:00',1.25),('15844','2013-08-29','09:05:00',1.21),('15844','2013-08-29','09:10:00',1.28),('15844','2013-08-29','09:15:00',1.27),('15844','2013-08-29','09:20:00',1.31),('15844','2013-08-29','09:25:00',1.3),('15844','2013-08-29','09:30:00',1.37),('15844','2013-08-29','09:35:00',1.54),('15844','2013-08-29','09:40:00',1.42),('15844','2013-08-29','09:45:00',1.26),('15844','2013-08-29','09:50:00',1.24),('15844','2013-08-29','09:55:00',1.28),('15844','2013-08-29','10:00:00',1.27),('15844','2013-08-29','10:05:00',1.26),('15844','2013-08-29','10:10:00',1.27),('15844','2013-08-29','10:15:00',1.29),('15844','2013-08-29','10:20:00',1.31),('15844','2013-08-29','10:25:00',1.34),('15844','2013-08-29','10:30:00',1.37),('15844','2013-08-29','10:35:00',1.22),('15844','2013-08-29','10:40:00',1.1),('15844','2013-08-29','10:45:00',1.06),('15844','2013-08-29','10:50:00',1.13),('15844','2013-08-29','10:55:00',1.33),('15844','2013-08-29','11:00:00',1.34),('15844','2013-08-29','11:05:00',1.52),('15844','2013-08-29','11:10:00',1.78),('15844','2013-08-29','11:15:00',1.77),('15844','2013-08-29','11:20:00',1.61),('15844','2013-08-29','11:25:00',1.31),('15844','2013-08-29','11:30:00',1.13),('15844','2013-08-29','11:35:00',1.22),('15844','2013-08-29','11:40:00',1.47),('15844','2013-08-29','11:45:00',1.59),('15844','2013-08-29','11:50:00',1.64),('15844','2013-08-29','11:55:00',1.55),('15844','2013-08-29','12:00:00',1.58),('15844','2013-08-29','12:05:00',1.88),('15844','2013-08-29','12:10:00',2.56),('15844','2013-08-29','12:15:00',2.81),('15844','2013-08-29','12:20:00',2.87),('15844','2013-08-29','12:25:00',2.36),('15844','2013-08-29','12:30:00',2.77),('15844','2013-08-29','12:35:00',2.93),('15844','2013-08-29','12:40:00',3.49),('15844','2013-08-29','12:45:00',2.48),('15844','2013-08-29','12:50:00',2.4),('15844','2013-08-29','12:55:00',2.45),('15844','2013-08-29','13:00:00',2.27),('15844','2013-08-29','13:05:00',2.21),('15844','2013-08-29','13:10:00',1.96),('15844','2013-08-29','13:15:00',2.05),('15844','2013-08-29','13:20:00',1.93),('15844','2013-08-29','13:25:00',1.62),('15844','2013-08-29','13:30:00',1.54),('15844','2013-08-29','13:35:00',1.52),('15844','2013-08-29','13:40:00',1.39),('15844','2013-08-29','13:45:00',1.32),('15844','2013-08-29','13:50:00',1.43),('15844','2013-08-29','13:55:00',2.06),('15844','2013-08-29','14:00:00',1.64),('15844','2013-08-29','14:05:00',1.31),('15844','2013-08-29','14:10:00',1.12),('15844','2013-08-29','14:45:00',1.04),('15844','2013-08-29','14:50:00',1.16),('15844','2013-08-29','14:55:00',1.38),('15844','2013-08-29','15:00:00',1.57),('15844','2013-08-29','15:05:00',1.36),('15844','2013-08-29','15:15:00',1.09),('15844','2013-08-29','15:20:00',1.62),('15844','2013-08-29','15:25:00',1.89),('15844','2013-08-29','15:30:00',1.69),('15844','2013-08-29','15:35:00',1.57),('15844','2013-08-29','15:40:00',1.63),('15844','2013-08-29','15:45:00',1.45),('15844','2013-08-29','15:50:00',1.73),('15844','2013-08-29','15:55:00',1.52),('15844','2013-08-29','16:00:00',1.83),('15844','2013-08-29','16:05:00',1.58),('15844','2013-08-29','16:10:00',1.23),('15844','2013-08-29','16:15:00',1.06),('15844','2013-08-28','08:35:00',1.18),('15844','2013-08-28','08:55:00',1.12),('15844','2013-08-28','09:00:00',1.52),('15844','2013-08-28','09:05:00',1.61),('15844','2013-08-28','09:10:00',1.89),('15844','2013-08-28','09:15:00',1.6),('15844','2013-08-28','09:25:00',1.19),('15844','2013-08-28','09:30:00',1.84),('15844','2013-08-28','09:35:00',1.99),('15844','2013-08-28','09:40:00',1.96),('15844','2013-08-28','09:45:00',2.28),('15844','2013-08-28','09:50:00',2.44),('15844','2013-08-28','09:55:00',2.5),('15844','2013-08-28','10:00:00',1.39),('15844','2013-08-28','10:05:00',2.23),('15844','2013-08-28','10:10:00',2.67),('15844','2013-08-28','10:15:00',2.78),('15844','2013-08-28','10:20:00',2.79),('15844','2013-08-28','10:25:00',2.88),('15844','2013-08-28','10:30:00',2.43),('15844','2013-08-28','10:35:00',3.32),('15844','2013-08-28','10:40:00',3.55),('15844','2013-08-28','10:45:00',3.72),('15844','2013-08-28','10:50:00',3.11),('15844','2013-08-28','10:55:00',1.46),('15844','2013-08-28','11:00:00',3.88),('15844','2013-08-28','11:05:00',4.07),('15844','2013-08-28','11:10:00',2.12),('15844','2013-08-28','11:15:00',3.85),('15844','2013-08-28','11:20:00',4),('15844','2013-08-28','11:25:00',3.08),('15844','2013-08-28','11:30:00',3.31),('15844','2013-08-28','11:35:00',4.29),('15844','2013-08-28','11:40:00',2.81),('15844','2013-08-28','11:45:00',3.11),('15844','2013-08-28','11:50:00',2.53),('15844','2013-08-28','11:55:00',3.63),('15844','2013-08-28','12:00:00',4.5),('15844','2013-08-28','12:05:00',4.24),('15844','2013-08-28','12:10:00',4.13),('15844','2013-08-28','12:15:00',4.3),('15844','2013-08-28','12:20:00',3.31),('15844','2013-08-28','12:25:00',3.43),('15844','2013-08-28','12:30:00',4.23),('15844','2013-08-28','12:35:00',2.27),('15844','2013-08-28','12:40:00',4.19),('15844','2013-08-28','12:45:00',4.16),('15844','2013-08-28','12:50:00',4.12),('15844','2013-08-28','12:55:00',4.04),('15844','2013-08-28','13:00:00',4.02),('15844','2013-08-28','13:05:00',4.02),('15844','2013-08-28','13:10:00',3.96),('15844','2013-08-28','13:15:00',3.93),('15844','2013-08-28','13:20:00',3.78),('15844','2013-08-28','13:25:00',3.99),('15844','2013-08-28','13:30:00',2.34),('15844','2013-08-28','13:35:00',4.05),('15844','2013-08-28','13:40:00',2.77),('15844','2013-08-28','13:45:00',3.75),('15844','2013-08-28','13:50:00',3.62),('15844','2013-08-28','13:55:00',3.54),('15844','2013-08-28','14:00:00',3.51),('15844','2013-08-28','14:05:00',3.42),('15844','2013-08-28','14:10:00',2.92),('15844','2013-08-28','14:15:00',3.19),('15844','2013-08-28','14:20:00',2.76),('15844','2013-08-28','14:25:00',1.41),('15844','2013-08-28','14:30:00',2.13),('15844','2013-08-28','14:35:00',3.06),('15844','2013-08-28','14:40:00',2.82),('15844','2013-08-28','14:45:00',2.75),('15844','2013-08-28','14:50:00',2.63),('15844','2013-08-28','14:55:00',2.54),('15844','2013-08-28','15:00:00',2.49),('15844','2013-08-28','15:05:00',2.53),('15844','2013-08-28','15:10:00',2.29),('15844','2013-08-28','15:15:00',2.24),('15844','2013-08-28','15:20:00',1.24),('15844','2013-08-28','15:25:00',1.9),('15844','2013-08-28','15:30:00',1.88),('15844','2013-08-28','15:35:00',2.07),('15844','2013-08-28','15:40:00',1.82),('15844','2013-08-28','15:45:00',1.26),('15844','2013-08-28','15:50:00',1.5),('15844','2013-08-28','15:55:00',1.31),('15844','2013-08-28','16:00:00',1.13),('15844','2013-08-28','16:10:00',1.2),('15844','2013-08-28','16:15:00',1.12),('15844','2013-08-28','16:20:00',1.12),('15844','2013-08-27','09:10:00',1.21),('15844','2013-08-27','09:15:00',1.28),('15844','2013-08-27','09:20:00',1.52),('15844','2013-08-27','09:25:00',1.84),('15844','2013-08-27','09:30:00',1.84),('15844','2013-08-27','09:35:00',1.13),('15844','2013-08-27','09:40:00',1.08),('15844','2013-08-27','09:45:00',1.09),('15844','2013-08-27','09:50:00',1.31),('15844','2013-08-27','09:55:00',1.45),('15844','2013-08-27','10:00:00',1.96),('15844','2013-08-27','10:05:00',2.3),('15844','2013-08-27','10:10:00',2.71),('15844','2013-08-27','10:15:00',2.81),('15844','2013-08-27','10:20:00',2.8),('15844','2013-08-27','10:25:00',2.89),('15844','2013-08-27','10:30:00',2.95),('15844','2013-08-27','10:35:00',3.13),('15844','2013-08-27','10:40:00',3.25),('15844','2013-08-27','10:45:00',3.23),('15844','2013-08-27','10:50:00',3.27),('15844','2013-08-27','10:55:00',3.27),('15844','2013-08-27','11:00:00',3.28),('15844','2013-08-27','11:05:00',3.58),('15844','2013-08-27','11:10:00',3.62),('15844','2013-08-27','11:15:00',3.64),('15844','2013-08-27','11:20:00',3.69),('15844','2013-08-27','11:25:00',3.78),('15844','2013-08-27','11:30:00',3.7),('15844','2013-08-27','11:35:00',3.84),('15844','2013-08-27','11:40:00',3.13),('15844','2013-08-27','11:45:00',2.31),('15844','2013-08-27','11:50:00',2.2),('15844','2013-08-27','11:55:00',2.61),('15844','2013-08-27','12:00:00',2.26),('15844','2013-08-27','12:05:00',2.81),('15844','2013-08-27','12:10:00',2.17),('15844','2013-08-27','12:15:00',4.13),('15844','2013-08-27','12:20:00',4),('15844','2013-08-27','12:25:00',3.98),('15844','2013-08-27','12:30:00',3.82),('15844','2013-08-27','12:35:00',4.17),('15844','2013-08-27','12:40:00',3.89),('15844','2013-08-27','12:45:00',2.39),('15844','2013-08-27','12:50:00',2.17),('15844','2013-08-27','12:55:00',1.4),('15844','2013-08-27','13:00:00',1.09),('15844','2013-08-27','13:05:00',1.23),('15844','2013-08-27','13:10:00',1.15),('15844','2013-08-27','13:15:00',1.4),('15844','2013-08-27','13:20:00',1.59),('15844','2013-08-27','13:25:00',1.76),('15844','2013-08-27','13:30:00',1.54),('15844','2013-08-27','13:35:00',1.56),('15844','2013-08-27','13:40:00',1.87),('15844','2013-08-27','13:45:00',2.78),('15844','2013-08-27','13:50:00',2),('15844','2013-08-27','13:55:00',2.94),('15844','2013-08-27','14:00:00',2.56),('15844','2013-08-27','14:05:00',1.87),('15844','2013-08-27','14:10:00',2.28),('15844','2013-08-27','14:15:00',2.33),('15844','2013-08-27','14:20:00',1.81),('15844','2013-08-27','14:25:00',1.27),('15844','2013-08-27','14:30:00',1.13),('15844','2013-08-27','14:35:00',1.2),('15844','2013-08-27','14:40:00',1.3),('15844','2013-08-27','14:45:00',1.13),('15844','2013-08-27','15:55:00',1.07),('15844','2013-08-27','16:00:00',1.7),('15844','2013-08-27','16:05:00',1.75),('15844','2013-08-27','16:10:00',1.65),('15844','2013-08-27','16:15:00',1.51),('15844','2013-08-27','16:30:00',1.05),('15844','2013-08-27','16:45:00',1.08),('15844','2013-08-27','16:50:00',1.07),('15844','2013-08-27','17:05:00',1.22),('15844','2013-08-26','08:40:00',1.04),('15844','2013-08-26','08:45:00',1.18),('15844','2013-08-26','08:50:00',1.29),('15844','2013-08-26','08:55:00',1.37),('15844','2013-08-26','09:00:00',1.45),('15844','2013-08-26','09:05:00',1.57),('15844','2013-08-26','09:10:00',1.67),('15844','2013-08-26','09:15:00',1.75),('15844','2013-08-26','09:20:00',1.86),('15844','2013-08-26','09:25:00',1.99),('15844','2013-08-26','09:30:00',2.08),('15844','2013-08-26','09:35:00',2.17),('15844','2013-08-26','09:40:00',2.26),('15844','2013-08-26','09:45:00',2.3),('15844','2013-08-26','09:50:00',2.38),('15844','2013-08-26','09:55:00',2.45),('15844','2013-08-26','10:00:00',2.57),('15844','2013-08-26','10:05:00',2.69),('15844','2013-08-26','10:10:00',2.79),('15844','2013-08-26','10:15:00',2.84),('15844','2013-08-26','10:20:00',2.88),('15844','2013-08-26','10:25:00',2.99),('15844','2013-08-26','10:30:00',3.01),('15844','2013-08-26','10:35:00',3.27),('15844','2013-08-26','10:40:00',3.32),('15844','2013-08-26','10:45:00',3.38),('15844','2013-08-26','10:50:00',3.46),('15844','2013-08-26','10:55:00',3.51),('15844','2013-08-26','11:00:00',3.64),('15844','2013-08-26','11:05:00',3.72),('15844','2013-08-26','11:10:00',3.78),('15844','2013-08-26','11:15:00',3.83),('15844','2013-08-26','11:20:00',3.78),('15844','2013-08-26','11:25:00',3.82),('15844','2013-08-26','11:30:00',3.84),('15844','2013-08-26','11:35:00',3.88),('15844','2013-08-26','11:40:00',3.91),('15844','2013-08-26','11:45:00',3.93),('15844','2013-08-26','11:50:00',3.92),('15844','2013-08-26','11:55:00',3.91),('15844','2013-08-26','12:00:00',3.95),('15844','2013-08-26','12:05:00',3.92),('15844','2013-08-26','12:10:00',3.93),('15844','2013-08-26','12:15:00',3.89),('15844','2013-08-26','12:20:00',3.88),('15844','2013-08-26','12:25:00',3.86),('15844','2013-08-26','12:30:00',3.84),('15844','2013-08-26','12:35:00',3.79),('15844','2013-08-26','12:40:00',3.64),('15844','2013-08-26','12:45:00',3.98),('15844','2013-08-26','12:50:00',3.93),('15844','2013-08-26','12:55:00',3.67),('15844','2013-08-26','13:00:00',2.65),('15844','2013-08-26','13:05:00',2.52),('15844','2013-08-26','13:10:00',2.17),('15844','2013-08-26','13:15:00',2.11),('15844','2013-08-26','13:20:00',1.79),('15844','2013-08-26','13:25:00',2.41),('15844','2013-08-26','13:30:00',2.93),('15844','2013-08-26','13:35:00',3.18),('15844','2013-08-26','13:40:00',3.55),('15844','2013-08-26','13:45:00',3.52),('15844','2013-08-26','13:50:00',2.96),('15844','2013-08-26','13:55:00',2.33),('15844','2013-08-26','14:00:00',2.78),('15844','2013-08-26','14:05:00',2.82),('15844','2013-08-26','14:10:00',2.97),('15844','2013-08-26','14:15:00',3.28),('15844','2013-08-26','14:20:00',3.04),('15844','2013-08-26','14:25:00',2.92),('15844','2013-08-26','14:30:00',2.87),('15844','2013-08-26','14:35:00',2.76),('15844','2013-08-26','14:40:00',2.47),('15844','2013-08-26','14:45:00',1.68),('15844','2013-08-26','14:50:00',1.19),('15844','2013-08-26','14:55:00',1.19),('15844','2013-08-26','15:00:00',1.4),('15844','2013-08-26','15:40:00',1.31),('15844','2013-08-26','15:45:00',1.2),('15844','2013-08-26','15:50:00',1.32),('15844','2013-08-26','15:55:00',1.32),('15844','2013-08-26','16:00:00',1.94),('15844','2013-08-26','16:05:00',1.53),('15844','2013-08-26','16:10:00',1.13),('15844','2013-08-26','16:15:00',1.1),('15844','2013-08-26','16:20:00',1.01),('15844','2013-08-25','08:50:00',1.23),('15844','2013-08-25','08:55:00',1.35),('15844','2013-08-25','09:00:00',1.07),('15844','2013-08-25','09:05:00',1.61),('15844','2013-08-25','09:10:00',1.63),('15844','2013-08-25','09:15:00',1.66),('15844','2013-08-25','09:20:00',1.83),('15844','2013-08-25','09:25:00',1.97),('15844','2013-08-25','09:30:00',2.1),('15844','2013-08-25','09:35:00',2.17),('15844','2013-08-25','09:40:00',2.45),('15844','2013-08-25','09:45:00',2.51),('15844','2013-08-25','09:50:00',2.76),('15844','2013-08-25','09:55:00',1.97),('15844','2013-08-25','10:00:00',1.29),('15844','2013-08-25','15:15:00',1.12),('15844','2013-08-25','15:20:00',1.33),('15844','2013-08-25','15:25:00',1.4),('15844','2013-08-25','15:30:00',2.35),('15844','2013-08-25','15:35:00',2.16),('15844','2013-08-25','15:40:00',1.33),('15844','2013-08-25','15:45:00',1.67),('15844','2013-08-25','15:55:00',1.29),('15844','2013-08-25','16:00:00',1.51),('15844','2013-08-25','16:05:00',1.16),('15844','2013-08-25','16:10:00',1.24),('15844','2013-08-25','16:15:00',1.18),('15844','2013-08-25','16:20:00',1.12),('15844','2013-08-25','16:25:00',1.05),('15844','2013-08-24','08:50:00',1.2),('15844','2013-08-24','08:55:00',1.32),('15844','2013-08-24','09:00:00',1.4),('15844','2013-08-24','09:05:00',1.52),('15844','2013-08-24','09:10:00',1.57),('15844','2013-08-24','09:15:00',1.67),('15844','2013-08-24','09:20:00',1.72),('15844','2013-08-24','09:25:00',1.85),('15844','2013-08-24','09:30:00',1.94),('15844','2013-08-24','09:35:00',2.05),('15844','2013-08-24','09:40:00',2.04),('15844','2013-08-24','09:45:00',2.15),('15844','2013-08-24','09:50:00',2.21),('15844','2013-08-24','09:55:00',2.27),('15844','2013-08-24','10:00:00',2.41),('15844','2013-08-24','10:05:00',2.55),('15844','2013-08-24','10:10:00',2.65),('15844','2013-08-24','10:15:00',2.75),('15844','2013-08-24','10:20:00',2.83),('15844','2013-08-24','10:25:00',2.88),('15844','2013-08-24','10:30:00',2.95),('15844','2013-08-24','10:35:00',3.1),('15844','2013-08-24','10:40:00',3.19),('15844','2013-08-24','10:45:00',3.32),('15844','2013-08-24','10:50:00',3.35),('15844','2013-08-24','10:55:00',3.5),('15844','2013-08-24','11:00:00',3.56),('15844','2013-08-24','11:05:00',3.6),('15844','2013-08-24','11:10:00',3.65),('15844','2013-08-24','11:15:00',3.74),('15844','2013-08-24','11:20:00',3.78),('15844','2013-08-24','11:25:00',3.75),('15844','2013-08-24','11:30:00',3.82),('15844','2013-08-24','11:35:00',3.83),('15844','2013-08-24','11:40:00',3.83),('15844','2013-08-24','11:45:00',3.87),('15844','2013-08-24','11:50:00',3.83),('15844','2013-08-24','11:55:00',3.8),('15844','2013-08-24','12:00:00',3.89),('15844','2013-08-24','12:05:00',3.91),('15844','2013-08-24','12:10:00',3.87),('15844','2013-08-24','12:15:00',3.87),('15844','2013-08-24','12:20:00',3.82),('15844','2013-08-24','12:25:00',3.85),('15844','2013-08-24','12:30:00',3.79),('15844','2013-08-24','12:35:00',3.86),('15844','2013-08-24','12:40:00',3.82),('15844','2013-08-24','12:45:00',3.8),('15844','2013-08-24','12:50:00',3.82),('15844','2013-08-24','12:55:00',3.78),('15844','2013-08-24','13:00:00',3.77),('15844','2013-08-24','13:05:00',3.75),('15844','2013-08-24','13:10:00',3.7),('15844','2013-08-24','13:15:00',3.7),('15844','2013-08-24','13:20:00',3.65),('15844','2013-08-24','13:25:00',3.62),('15844','2013-08-24','13:30:00',3.59),('15844','2013-08-24','13:35:00',3.56),('15844','2013-08-24','13:40:00',3.52),('15844','2013-08-24','13:45:00',3.49),('15844','2013-08-24','13:50:00',3.44),('15844','2013-08-24','13:55:00',3.37),('15844','2013-08-24','14:00:00',3.29),('15844','2013-08-24','14:05:00',3.23),('15844','2013-08-24','14:10:00',3.17),('15844','2013-08-24','14:15:00',3.08),('15844','2013-08-24','14:20:00',3.01),('15844','2013-08-24','14:25:00',2.94),('15844','2013-08-24','14:30:00',2.85),('15844','2013-08-24','14:35:00',2.74),('15844','2013-08-24','14:40:00',2.61),('15844','2013-08-24','14:45:00',2.49),('15844','2013-08-24','14:50:00',2.4),('15844','2013-08-24','14:55:00',2.42),('15844','2013-08-24','15:00:00',2.34),('15844','2013-08-24','15:05:00',2.26),('15844','2013-08-24','15:10:00',2.19),('15844','2013-08-24','15:15:00',2.11),('15844','2013-08-24','15:20:00',2.01),('15844','2013-08-24','15:25:00',1.93),('15844','2013-08-24','15:30:00',1.85),('15844','2013-08-24','15:35:00',1.75),('15844','2013-08-24','15:40:00',1.66),('15844','2013-08-24','15:45:00',1.56),('15844','2013-08-24','15:50:00',1.44),('15844','2013-08-24','15:55:00',1.32),('15844','2013-08-24','16:00:00',1.21),('15844','2013-08-24','16:05:00',1.14),('15844','2013-08-24','16:10:00',1.1),('15844','2013-08-24','16:15:00',1.07),('15844','2013-08-24','16:20:00',1.03),('15844','2013-08-23','08:50:00',1.1),('15844','2013-08-23','08:55:00',1.02),('15844','2013-08-23','09:00:00',1.16),('15844','2013-08-23','09:05:00',1.38),('15844','2013-08-23','09:10:00',1.45),('15844','2013-08-23','09:15:00',1.52),('15844','2013-08-23','09:20:00',1.59),('15844','2013-08-23','09:25:00',1.63),('15844','2013-08-23','09:30:00',1.72),('15844','2013-08-23','09:35:00',1.8),('15844','2013-08-23','09:40:00',1.85),('15844','2013-08-23','09:45:00',1.92),('15844','2013-08-23','09:50:00',1.99),('15844','2013-08-23','09:55:00',2.07),('15844','2013-08-23','10:00:00',2.19),('15844','2013-08-23','10:05:00',2.3),('15844','2013-08-23','10:10:00',2.37),('15844','2013-08-23','10:15:00',2.45),('15844','2013-08-23','10:20:00',2.57),('15844','2013-08-23','10:25:00',2.65),('15844','2013-08-23','10:30:00',2.74),('15844','2013-08-23','10:35:00',2.89),('15844','2013-08-23','10:40:00',2.96),('15844','2013-08-23','10:45:00',2.86),('15844','2013-08-23','10:50:00',2.19),('15844','2013-08-23','10:55:00',1.35),('15844','2013-08-23','11:00:00',3.13),('15844','2013-08-23','11:05:00',3.42),('15844','2013-08-23','11:10:00',3.51),('15844','2013-08-23','11:15:00',3.57),('15844','2013-08-23','11:20:00',3.68),('15844','2013-08-23','11:25:00',2.77),('15844','2013-08-23','11:30:00',2.72),('15844','2013-08-23','11:35:00',1.23),('15844','2013-08-23','11:40:00',1.79),('15844','2013-08-23','11:45:00',1.78),('15844','2013-08-23','11:50:00',3.04),('15844','2013-08-23','11:55:00',2.48),('15844','2013-08-23','12:00:00',3.99),('15844','2013-08-23','12:05:00',3.91),('15844','2013-08-23','12:10:00',2.71),('15844','2013-08-23','12:15:00',2.19),('15844','2013-08-23','12:20:00',1.75),('15844','2013-08-23','12:30:00',1.12),('15844','2013-08-23','12:35:00',2.4),('15844','2013-08-23','12:40:00',3.62),('15844','2013-08-23','12:45:00',3.89),('15844','2013-08-23','12:50:00',3.88),('15844','2013-08-23','12:55:00',3.88),('15844','2013-08-23','13:00:00',3.71),('15844','2013-08-23','13:05:00',3.77),('15844','2013-08-23','13:10:00',3.72),('15844','2013-08-23','13:15:00',3.69),('15844','2013-08-23','13:20:00',3.69),('15844','2013-08-23','13:25:00',3.63),('15844','2013-08-23','13:30:00',3.66),('15844','2013-08-23','13:35:00',3.59),('15844','2013-08-23','13:40:00',3.55),('15844','2013-08-23','13:45:00',3.51),('15844','2013-08-23','13:50:00',3.46),('15844','2013-08-23','13:55:00',3.36),('15844','2013-08-23','14:00:00',3.29),('15844','2013-08-23','14:05:00',3.22),('15844','2013-08-23','14:10:00',3.16),('15844','2013-08-23','14:15:00',3.09),('15844','2013-08-23','14:20:00',3.02),('15844','2013-08-23','14:25:00',2.95),('15844','2013-08-23','14:30:00',2.84),('15844','2013-08-23','14:35:00',2.76),('15844','2013-08-23','14:40:00',2.65),('15844','2013-08-23','14:45:00',2.54),('15844','2013-08-23','14:50:00',2.4),('15844','2013-08-23','14:55:00',2.27),('15844','2013-08-23','15:00:00',2.16),('15844','2013-08-23','15:05:00',2.22),('15844','2013-08-23','15:10:00',2.13),('15844','2013-08-23','15:15:00',2.02),('15844','2013-08-23','15:20:00',2.01),('15844','2013-08-23','15:25:00',2.04),('15844','2013-08-23','15:30:00',1.84),('15844','2013-08-23','15:35:00',1.72),('15844','2013-08-23','15:40:00',1.67),('15844','2013-08-23','15:45:00',1.51),('15844','2013-08-23','15:50:00',1.47),('15844','2013-08-23','15:55:00',1.36),('15844','2013-08-23','16:00:00',1.18),('15844','2013-08-23','16:05:00',1.01),('15844','2013-08-23','16:10:00',1.08),('15844','2013-08-23','16:15:00',1.21),('15844','2013-08-23','16:20:00',1.11),('15844','2013-08-23','16:25:00',1.02),('15844','2013-08-23','16:30:00',1),('15844','2013-08-22','08:45:00',1.06),('15844','2013-08-22','08:50:00',1.2),('15844','2013-08-22','08:55:00',1.3),('15844','2013-08-22','09:00:00',1.42),('15844','2013-08-22','09:05:00',1.54),('15844','2013-08-22','09:10:00',1.43),('15844','2013-08-22','09:15:00',1.67),('15844','2013-08-22','09:20:00',1.84),('15844','2013-08-22','09:25:00',1.99),('15844','2013-08-22','09:30:00',1.68),('15844','2013-08-22','09:35:00',1.98),('15844','2013-08-22','09:40:00',2.17),('15844','2013-08-22','09:45:00',2.18),('15844','2013-08-22','09:50:00',2.25),('15844','2013-08-22','09:55:00',2.36),('15844','2013-08-22','10:00:00',2.6),('15844','2013-08-22','10:05:00',2.74),('15844','2013-08-22','10:10:00',2.75),('15844','2013-08-22','10:15:00',2.81),('15844','2013-08-22','10:20:00',2.84),('15844','2013-08-22','10:25:00',2.95),('15844','2013-08-22','10:30:00',3.03),('15844','2013-08-22','10:35:00',3.1),('15844','2013-08-22','10:40:00',3.17),('15844','2013-08-22','10:45:00',3.21),('15844','2013-08-22','10:50:00',3.25),('15844','2013-08-22','10:55:00',3.42),('15844','2013-08-22','11:00:00',3.48),('15844','2013-08-22','11:05:00',3.5),('15844','2013-08-22','11:10:00',3.57),('15844','2013-08-22','11:15:00',3.6),('15844','2013-08-22','11:20:00',3.65),('15844','2013-08-22','11:25:00',3.64),('15844','2013-08-22','11:30:00',3.68),('15844','2013-08-22','11:35:00',3.7),('15844','2013-08-22','11:40:00',3.71),('15844','2013-08-22','11:45:00',3.72),('15844','2013-08-22','11:50:00',3.7),('15844','2013-08-22','11:55:00',3.72),('15844','2013-08-22','12:00:00',3.74),('15844','2013-08-22','12:05:00',3.75),('15844','2013-08-22','12:10:00',3.73),('15844','2013-08-22','12:15:00',3.72),('15844','2013-08-22','12:20:00',3.72),('15844','2013-08-22','12:25:00',3.72),('15844','2013-08-22','12:30:00',3.7),('15844','2013-08-22','12:35:00',3.7),('15844','2013-08-22','12:40:00',3.68),('15844','2013-08-22','12:45:00',3.67),('15844','2013-08-22','12:50:00',3.64),('15844','2013-08-22','12:55:00',3.62),('15844','2013-08-22','13:00:00',3.62),('15844','2013-08-22','13:05:00',3.59),('15844','2013-08-22','13:10:00',3.56),('15844','2013-08-22','13:15:00',3.55),('15844','2013-08-22','13:20:00',3.51),('15844','2013-08-22','13:25:00',3.49),('15844','2013-08-22','13:30:00',3.47),('15844','2013-08-22','13:35:00',3.46),('15844','2013-08-22','13:40:00',3.44),('15844','2013-08-22','13:45:00',3.36),('15844','2013-08-22','13:50:00',3.31),('15844','2013-08-22','13:55:00',3.25),('15844','2013-08-22','14:00:00',3.18),('15844','2013-08-22','14:05:00',3.05),('15844','2013-08-22','14:10:00',3.08),('15844','2013-08-22','14:15:00',3.01),('15844','2013-08-22','14:20:00',2.78),('15844','2013-08-22','14:25:00',2.87),('15844','2013-08-22','14:30:00',2.31),('15844','2013-08-22','14:35:00',2.69),('15844','2013-08-22','14:40:00',2.35),('15844','2013-08-22','14:45:00',2.07),('15844','2013-08-22','14:50:00',2.53),('15844','2013-08-22','14:55:00',2.42),('15844','2013-08-22','15:00:00',2.33),('15844','2013-08-22','15:05:00',2.24),('15844','2013-08-22','15:10:00',2.14),('15844','2013-08-22','15:15:00',2.06),('15844','2013-08-22','15:20:00',1.97),('15844','2013-08-22','15:25:00',1.88),('15844','2013-08-22','15:30:00',1.83),('15844','2013-08-22','15:35:00',1.76),('15844','2013-08-22','15:40:00',1.68),('15844','2013-08-22','15:45:00',1.59),('15844','2013-08-22','15:50:00',1.49),('15844','2013-08-22','15:55:00',1.4),('15844','2013-08-22','16:00:00',1.32),('15844','2013-08-22','16:05:00',1.27),('15844','2013-08-22','16:10:00',1.21),('15844','2013-08-22','16:15:00',1.14),('15844','2013-08-22','16:20:00',1.12),('15844','2013-08-22','16:25:00',1.07),('15844','2013-08-21','09:10:00',1.38),('15844','2013-08-21','09:15:00',1.27),('15844','2013-08-21','09:20:00',1.65),('15844','2013-08-21','09:25:00',1.49),('15844','2013-08-21','09:50:00',1.04),('15844','2013-08-21','09:55:00',1.14),('15844','2013-08-21','10:00:00',1.3),('15844','2013-08-21','10:05:00',2.53),('15844','2013-08-21','10:10:00',2.57),('15844','2013-08-21','10:15:00',1.92),('15844','2013-08-21','10:20:00',2.69),('15844','2013-08-21','10:25:00',3.13),('15844','2013-08-21','10:30:00',3.13),('15844','2013-08-21','10:35:00',3.22),('15844','2013-08-21','10:40:00',3.22),('15844','2013-08-21','10:45:00',3.31),('15844','2013-08-21','10:50:00',3.4),('15844','2013-08-21','10:55:00',3.15),('15844','2013-08-21','11:00:00',3.57),('15844','2013-08-21','11:05:00',3.24),('15844','2013-08-21','11:10:00',1.55),('15844','2013-08-21','11:15:00',2.57),('15844','2013-08-21','11:20:00',2.16),('15844','2013-08-21','11:25:00',2.79),('15844','2013-08-21','11:30:00',2.57),('15844','2013-08-21','11:35:00',3.56),('15844','2013-08-21','11:40:00',3.99),('15844','2013-08-21','11:45:00',3.88),('15844','2013-08-21','11:50:00',4.05),('15844','2013-08-21','11:55:00',3.9),('15844','2013-08-21','12:00:00',3.97),('15844','2013-08-21','12:05:00',3.96),('15844','2013-08-21','12:10:00',3.91),('15844','2013-08-21','12:15:00',3.95),('15844','2013-08-21','12:20:00',3.91),('15844','2013-08-21','12:25:00',3.62),('15844','2013-08-21','12:30:00',3.15),('15844','2013-08-21','12:35:00',3.02),('15844','2013-08-21','12:40:00',1.82),('15844','2013-08-21','12:45:00',2.85),('15844','2013-08-21','12:50:00',3.6),('15844','2013-08-21','12:55:00',3.49),('15844','2013-08-21','13:00:00',3.48),('15844','2013-08-21','13:05:00',3.56),('15844','2013-08-21','13:10:00',3.58),('15844','2013-08-21','13:15:00',3.54),('15844','2013-08-21','13:20:00',3.51),('15844','2013-08-21','13:25:00',3.48),('15844','2013-08-21','13:30:00',3.52),('15844','2013-08-21','13:35:00',3.44),('15844','2013-08-21','13:40:00',3.33),('15844','2013-08-21','13:45:00',3.37),('15844','2013-08-21','13:50:00',3.33),('15844','2013-08-21','13:55:00',3.31),('15844','2013-08-21','14:00:00',3.28),('15844','2013-08-21','14:05:00',3.19),('15844','2013-08-21','14:10:00',2.99),('15844','2013-08-21','14:15:00',2.97),('15844','2013-08-21','14:20:00',2.87),('15844','2013-08-21','14:25:00',2.89),('15844','2013-08-21','14:30:00',2.86),('15844','2013-08-21','14:35:00',2.61),('15844','2013-08-21','14:40:00',2.46),('15844','2013-08-21','14:45:00',2.32),('15844','2013-08-21','14:50:00',2.36),('15844','2013-08-21','14:55:00',2.33),('15844','2013-08-21','15:00:00',2.26),('15844','2013-08-21','15:05:00',2.12),('15844','2013-08-21','15:10:00',2.03),('15844','2013-08-21','15:15:00',2.03),('15844','2013-08-21','15:20:00',1.86),('15844','2013-08-21','15:25:00',1.72),('15844','2013-08-21','15:30:00',1.58),('15844','2013-08-21','15:35:00',1.64),('15844','2013-08-21','15:40:00',1.62),('15844','2013-08-21','15:45:00',1.57),('15844','2013-08-21','15:50:00',1.46),('15844','2013-08-21','15:55:00',1.33),('15844','2013-08-21','16:00:00',1.28),('15844','2013-08-21','16:05:00',1.26),('15844','2013-08-21','16:10:00',1.25),('15844','2013-08-21','16:15:00',1.21),('15844','2013-08-21','16:20:00',1.22),('15844','2013-08-21','16:25:00',1.23),('15844','2013-08-21','16:30:00',1.16),('15844','2013-08-21','16:35:00',1.1),('15844','2013-08-21','16:40:00',1),('15844','2013-08-20','08:55:00',1.01),('15844','2013-08-20','09:20:00',1.33),('15844','2013-08-20','09:25:00',1.64),('15844','2013-08-20','09:30:00',2.09),('15844','2013-08-20','09:35:00',1.6),('15844','2013-08-20','09:40:00',1.03),('15844','2013-08-20','09:55:00',1.29),('15844','2013-08-20','10:00:00',2.22),('15844','2013-08-20','10:05:00',1.98),('15844','2013-08-20','10:10:00',1.24),('15844','2013-08-20','10:20:00',1.51),('15844','2013-08-20','10:25:00',2.43),('15844','2013-08-20','10:30:00',2),('15844','2013-08-20','10:35:00',3.55),('15844','2013-08-20','10:40:00',1.53),('15844','2013-08-20','10:55:00',1.45),('15844','2013-08-20','11:00:00',2.06),('15844','2013-08-20','11:05:00',3.18),('15844','2013-08-20','11:10:00',2.62),('15844','2013-08-20','11:15:00',1.07),('15844','2013-08-20','11:20:00',3.6),('15844','2013-08-20','11:25:00',4.47),('15844','2013-08-20','11:30:00',4.34),('15844','2013-08-20','11:35:00',4.56),('15844','2013-08-20','11:40:00',3.65),('15844','2013-08-20','11:45:00',3.22),('15844','2013-08-20','11:50:00',3.31),('15844','2013-08-20','11:55:00',4.18),('15844','2013-08-20','12:00:00',2.48),('15844','2013-08-20','12:05:00',1.99),('15844','2013-08-20','12:10:00',1.96),('15844','2013-08-20','12:15:00',1.49),('15844','2013-08-20','12:20:00',1.51),('15844','2013-08-20','12:25:00',1.59),('15844','2013-08-20','12:30:00',1.56),('15844','2013-08-20','12:35:00',1.78),('15844','2013-08-20','12:40:00',1.62),('15844','2013-08-20','12:45:00',1.85),('15844','2013-08-20','12:50:00',2.94),('15844','2013-08-20','12:55:00',1.95),('15844','2013-08-20','13:00:00',1.68),('15844','2013-08-20','13:05:00',1.46),('15844','2013-08-20','13:10:00',1.49),('15844','2013-08-20','13:15:00',1.6),('15844','2013-08-20','13:20:00',1.57),('15844','2013-08-20','13:25:00',1.64),('15844','2013-08-20','13:30:00',1.83),('15844','2013-08-20','13:35:00',1.93),('15844','2013-08-20','13:40:00',2.73),('15844','2013-08-20','13:45:00',3.4),('15844','2013-08-20','13:50:00',3.82),('15844','2013-08-20','13:55:00',3.64),('15844','2013-08-20','14:00:00',3.51),('15844','2013-08-20','14:05:00',3.42),('15844','2013-08-20','14:10:00',3.44),('15844','2013-08-20','14:15:00',3.39),('15844','2013-08-20','14:20:00',3.46),('15844','2013-08-20','14:25:00',3.58),('15844','2013-08-20','14:30:00',3.46),('15844','2013-08-20','14:35:00',3.26),('15844','2013-08-20','14:40:00',2.98),('15844','2013-08-20','14:45:00',2.99),('15844','2013-08-20','14:50:00',2.78),('15844','2013-08-20','14:55:00',2.21),('15844','2013-08-20','15:00:00',2.49),('15844','2013-08-20','15:05:00',2.43),('15844','2013-08-20','15:10:00',2.44),('15844','2013-08-20','15:15:00',2.37),('15844','2013-08-20','15:20:00',2.31),('15844','2013-08-20','15:25:00',2.2),('15844','2013-08-20','15:30:00',2.01),('15844','2013-08-20','15:35:00',2.03),('15844','2013-08-20','15:40:00',1.65),('15844','2013-08-20','15:45:00',1.72),('15844','2013-08-20','15:50:00',1.93),('15844','2013-08-20','15:55:00',1.86),('15844','2013-08-20','16:00:00',1.86),('15844','2013-08-20','16:05:00',1.83),('15844','2013-08-20','16:10:00',1.77),('15844','2013-08-20','16:15:00',1.74),('15844','2013-08-20','16:20:00',1.7),('15844','2013-08-20','16:25:00',1.63),('15844','2013-08-20','16:30:00',1.49),('15844','2013-08-20','16:35:00',1.24),('15844','2013-08-20','16:40:00',1.02),('15844','2014-04-10','08:40:00',1.08),('15844','2014-04-10','08:45:00',1.21),('15844','2014-04-10','08:50:00',1.36),('15844','2014-04-10','08:55:00',1.39),('15844','2014-04-10','09:00:00',1.49),('15844','2014-04-10','09:05:00',1.65),('15844','2014-04-10','09:10:00',1.76),('15844','2014-04-10','09:15:00',1.92),('15844','2014-04-10','09:20:00',2.03),('15844','2014-04-10','09:25:00',2.21),('15844','2014-04-10','09:30:00',2.33),('15844','2014-04-10','09:35:00',2.4),('15844','2014-04-10','09:40:00',2.47),('15844','2014-04-10','09:45:00',2.55),('15844','2014-04-10','09:50:00',2.61),('15844','2014-04-10','09:55:00',2.66),('15844','2014-04-10','10:00:00',2.74),('15844','2014-04-10','10:05:00',2.87),('15844','2014-04-10','10:10:00',2.99),('15844','2014-04-10','10:15:00',2.98),('15844','2014-04-10','10:20:00',3.05),('15844','2014-04-10','10:25:00',3.09),('15844','2014-04-10','10:30:00',3.15),('15844','2014-04-10','10:35:00',3.37),('15844','2014-04-10','10:40:00',3.49),('15844','2014-04-10','10:45:00',3.48),('15844','2014-04-10','10:50:00',3.53),('15844','2014-04-10','10:55:00',3.67),('15844','2014-04-10','11:00:00',3.77),('15844','2014-04-10','11:05:00',3.85),('15844','2014-04-10','11:10:00',3.85),('15844','2014-04-10','11:15:00',3.88),('15844','2014-04-10','11:20:00',4.08),('15844','2014-04-10','11:25:00',4.1),('15844','2014-04-10','11:30:00',4.11),('15844','2014-04-10','11:35:00',4),('15844','2014-04-10','11:40:00',3.99),('15844','2014-04-10','11:45:00',4.04),('15844','2014-04-10','11:50:00',3.98),('15844','2014-04-10','11:55:00',4.02),('15844','2014-04-10','12:00:00',3.84),('15844','2014-04-10','12:05:00',3.64),('15844','2014-04-10','12:10:00',3.95),('15844','2014-04-10','12:15:00',3.96),('15844','2014-04-10','12:20:00',3.89),('15844','2014-04-10','12:25:00',3.83),('15844','2014-04-10','12:30:00',3.7),('15844','2014-04-10','12:35:00',3.96),('15844','2014-04-10','12:40:00',3.67),('15844','2014-04-10','12:45:00',3.74),('15844','2014-04-10','12:50:00',3.86),('15844','2014-04-10','12:55:00',3.93),('15844','2014-04-10','13:00:00',3.6),('15844','2014-04-10','13:05:00',3.76),('15844','2014-04-10','13:10:00',3.8),('15844','2014-04-10','13:15:00',3.86),('15844','2014-04-10','13:20:00',3.53),('15844','2014-04-10','13:25:00',3.69),('15844','2014-04-10','13:30:00',3.75),('15844','2014-04-10','13:35:00',3.72),('15844','2014-04-10','13:40:00',3.52),('15844','2014-04-10','13:45:00',3.63),('15844','2014-04-10','13:50:00',3.56),('15844','2014-04-10','13:55:00',3.47),('15844','2014-04-10','14:00:00',3.4),('15844','2014-04-10','14:05:00',3.29),('15844','2014-04-10','14:10:00',3.12),('15844','2014-04-10','14:15:00',3.24),('15844','2014-04-10','14:20:00',3.14),('15844','2014-04-10','14:25:00',3.02),('15844','2014-04-10','14:30:00',2.89),('15844','2014-04-10','14:35:00',2.77),('15844','2014-04-10','14:40:00',2.7),('15844','2014-04-10','14:45:00',2.32),('15844','2014-04-10','14:50:00',2.54),('15844','2014-04-10','14:55:00',2.45),('15844','2014-04-10','15:00:00',2.36),('15844','2014-04-10','15:05:00',2.29),('15844','2014-04-10','15:10:00',2.16),('15844','2014-04-10','15:15:00',2.03),('15844','2014-04-10','15:20:00',1.89),('15844','2014-04-10','15:25:00',1.74),('15844','2014-04-10','15:30:00',1.66),('15844','2014-04-10','15:35:00',1.54),('15844','2014-04-10','15:40:00',1.53),('15844','2014-04-10','15:45:00',1.44),('15844','2014-04-10','15:50:00',1.3),('15844','2014-04-10','15:55:00',1.31),('15844','2014-04-10','16:00:00',1.31),('15844','2014-04-10','16:05:00',1.24),('15844','2014-04-10','16:10:00',1.23),('15844','2014-04-10','16:15:00',1.18),('15844','2014-04-10','16:20:00',1.11),('15844','2013-08-19','08:45:00',1.09),('15844','2013-08-19','08:50:00',1.21),('15844','2013-08-19','08:55:00',1.28),('15844','2013-08-19','09:00:00',1.36),('15844','2013-08-19','09:05:00',1.46),('15844','2013-08-19','09:10:00',1.54),('15844','2013-08-19','09:15:00',1.59),('15844','2013-08-19','09:20:00',1.69),('15844','2013-08-19','09:25:00',1.83),('15844','2013-08-19','09:30:00',1.94),('15844','2013-08-19','09:35:00',2.05),('15844','2013-08-19','09:40:00',2.13),('15844','2013-08-19','09:45:00',2.2),('15844','2013-08-19','09:50:00',2.21),('15844','2013-08-19','09:55:00',2.29),('15844','2013-08-19','10:00:00',2.45),('15844','2013-08-19','10:05:00',2.56),('15844','2013-08-19','10:10:00',2.66),('15844','2013-08-19','10:15:00',2.74),('15844','2013-08-19','10:20:00',2.84),('15844','2013-08-19','10:25:00',2.96),('15844','2013-08-19','10:30:00',3.04),('15844','2013-08-19','10:35:00',3.12),('15844','2013-08-19','10:40:00',3.22),('15844','2013-08-19','10:45:00',3.27),('15844','2013-08-19','10:50:00',3.3),('15844','2013-08-19','10:55:00',3.54),('15844','2013-08-19','11:00:00',3.69),('15844','2013-08-19','11:05:00',3.76),('15844','2013-08-19','11:10:00',3.79),('15844','2013-08-19','11:15:00',3.81),('15844','2013-08-19','11:20:00',3.84),('15844','2013-08-19','11:25:00',3.88),('15844','2013-08-19','11:30:00',3.92),('15844','2013-08-19','11:35:00',3.93),('15844','2013-08-19','11:40:00',3.94),('15844','2013-08-19','11:45:00',3.94),('15844','2013-08-19','11:50:00',3.97),('15844','2013-08-19','11:55:00',3.97),('15844','2013-08-19','12:00:00',3.98),('15844','2013-08-19','12:05:00',3.91),('15844','2013-08-19','12:10:00',3.94),('15844','2013-08-19','12:15:00',3.93),('15844','2013-08-19','12:20:00',3.94),('15844','2013-08-19','12:25:00',3.89),('15844','2013-08-19','12:30:00',3.92),('15844','2013-08-19','12:35:00',3.91),('15844','2013-08-19','12:40:00',3.92),('15844','2013-08-19','12:45:00',3.9),('15844','2013-08-19','12:50:00',3.89),('15844','2013-08-19','12:55:00',3.88),('15844','2013-08-19','13:00:00',3.87),('15844','2013-08-19','13:05:00',3.84),('15844','2013-08-19','13:10:00',3.84),('15844','2013-08-19','13:15:00',3.82),('15844','2013-08-19','13:20:00',3.78),('15844','2013-08-19','13:25:00',3.78),('15844','2013-08-19','13:30:00',3.77),('15844','2013-08-19','13:35:00',3.71),('15844','2013-08-19','13:40:00',3.68),('15844','2013-08-19','13:45:00',3.53),('15844','2013-08-19','13:50:00',3.56),('15844','2013-08-19','13:55:00',3.5),('15844','2013-08-19','14:00:00',3.44),('15844','2013-08-19','14:05:00',3.37),('15844','2013-08-19','14:10:00',3.29),('15844','2013-08-19','14:15:00',3.22),('15844','2013-08-19','14:20:00',3.16),('15844','2013-08-19','14:25:00',3.09),('15844','2013-08-19','14:30:00',3.02),('15844','2013-08-19','14:35:00',2.93),('15844','2013-08-19','14:40:00',2.83),('15844','2013-08-19','14:45:00',2.69),('15844','2013-08-19','14:50:00',2.57),('15844','2013-08-19','14:55:00',2.54),('15844','2013-08-19','15:00:00',2.46),('15844','2013-08-19','15:05:00',2.38),('15844','2013-08-19','15:10:00',2.3),('15844','2013-08-19','15:15:00',2.22),('15844','2013-08-19','15:20:00',2.14),('15844','2013-08-19','15:25:00',2.05),('15844','2013-08-19','15:30:00',1.95),('15844','2013-08-19','15:35:00',1.86),('15844','2013-08-19','15:40:00',1.77),('15844','2013-08-19','15:45:00',1.67),('15844','2013-08-19','15:50:00',1.56),('15844','2013-08-19','15:55:00',1.45),('15844','2013-08-19','16:00:00',1.35),('15844','2013-08-19','16:05:00',1.27),('15844','2013-08-19','16:10:00',1.21),('15844','2013-08-19','16:15:00',1.16),('15844','2013-08-19','16:20:00',1.11),('15844','2013-08-19','16:25:00',1.05),('15844','2013-08-18','08:35:00',1.03),('15844','2013-08-18','08:40:00',1.12),('15844','2013-08-18','08:45:00',1.19),('15844','2013-08-18','08:50:00',1.26),('15844','2013-08-18','08:55:00',1.33),('15844','2013-08-18','09:00:00',1.4),('15844','2013-08-18','09:05:00',1.46),('15844','2013-08-18','09:10:00',1.57),('15844','2013-08-18','09:15:00',1.64),('15844','2013-08-18','09:20:00',1.75),('15844','2013-08-18','09:25:00',1.86),('15844','2013-08-18','09:30:00',1.98),('15844','2013-08-18','09:35:00',2.06),('15844','2013-08-18','09:40:00',1.54),('15844','2013-08-18','09:45:00',1.95),('15844','2013-08-18','09:50:00',2.27),('15844','2013-08-18','09:55:00',2.11),('15844','2013-08-18','10:00:00',2.44),('15844','2013-08-18','10:05:00',2.6),('15844','2013-08-18','10:10:00',2.67),('15844','2013-08-18','10:15:00',2.77),('15844','2013-08-18','10:20:00',2.86),('15844','2013-08-18','10:25:00',2.95),('15844','2013-08-18','10:30:00',3.04),('15844','2013-08-18','10:35:00',3.12),('15844','2013-08-18','10:40:00',3.21),('15844','2013-08-18','10:45:00',3.25),('15844','2013-08-18','10:50:00',3.34),('15844','2013-08-18','10:55:00',3.49),('15844','2013-08-18','11:00:00',3.52),('15844','2013-08-18','11:05:00',3.58),('15844','2013-08-18','11:10:00',3.63),('15844','2013-08-18','11:15:00',3.67),('15844','2013-08-18','11:20:00',3.67),('15844','2013-08-18','11:25:00',3.69),('15844','2013-08-18','11:30:00',3.73),('15844','2013-08-18','11:35:00',3.73),('15844','2013-08-18','11:40:00',3.76),('15844','2013-08-18','11:45:00',3.84),('15844','2013-08-18','11:50:00',3.8),('15844','2013-08-18','11:55:00',3.29),('15844','2013-08-18','12:00:00',1.87),('15844','2013-08-18','12:05:00',3.91),('15844','2013-08-18','12:10:00',3.75),('15844','2013-08-18','12:15:00',3.91),('15844','2013-08-18','12:20:00',3.92),('15844','2013-08-18','12:25:00',3.83),('15844','2013-08-18','12:30:00',3.96),('15844','2013-08-18','12:35:00',4.02),('15844','2013-08-18','12:40:00',3.99),('15844','2013-08-18','12:45:00',3.96),('15844','2013-08-18','12:50:00',3.89),('15844','2013-08-18','12:55:00',3.85),('15844','2013-08-18','13:00:00',3.85),('15844','2013-08-18','13:05:00',3.83),('15844','2013-08-18','13:10:00',3.81),('15844','2013-08-18','13:15:00',3.76),('15844','2013-08-18','13:20:00',3.76),('15844','2013-08-18','13:25:00',3.72),('15844','2013-08-18','13:30:00',3.7),('15844','2013-08-18','13:35:00',3.67),('15844','2013-08-18','13:40:00',3.63),('15844','2013-08-18','13:45:00',3.6),('15844','2013-08-18','13:50:00',3.58),('15844','2013-08-18','13:55:00',3.53),('15844','2013-08-18','14:00:00',3.47),('15844','2013-08-18','14:05:00',3.4),('15844','2013-08-18','14:10:00',3.32),('15844','2013-08-18','14:15:00',3.19),('15844','2013-08-18','14:20:00',3.21),('15844','2013-08-18','14:25:00',3.14),('15844','2013-08-18','14:30:00',3.05),('15844','2013-08-18','14:35:00',2.94),('15844','2013-08-18','14:40:00',2.85),('15844','2013-08-18','14:45:00',2.75),('15844','2013-08-18','14:50:00',2.65),('15844','2013-08-18','14:55:00',2.57),('15844','2013-08-18','15:00:00',2.48),('15844','2013-08-18','15:05:00',2.38),('15844','2013-08-18','15:10:00',2.33),('15844','2013-08-18','15:15:00',2.25),('15844','2013-08-18','15:20:00',2.18),('15844','2013-08-18','15:25:00',2.07),('15844','2013-08-18','15:30:00',1.98),('15844','2013-08-18','15:35:00',1.88),('15844','2013-08-18','15:40:00',1.77),('15844','2013-08-18','15:45:00',1.69),('15844','2013-08-18','15:50:00',1.59),('15844','2013-08-18','15:55:00',1.48),('15844','2013-08-18','16:00:00',1.37),('15844','2013-08-18','16:05:00',1.3),('15844','2013-08-18','16:10:00',1.22),('15844','2013-08-18','16:15:00',1.17),('15844','2013-08-18','16:20:00',1.12),('15844','2013-08-18','16:25:00',1.06),('15844','2013-08-17','08:35:00',1.01),('15844','2013-08-17','08:40:00',1.12),('15844','2013-08-17','08:45:00',1.19),('15844','2013-08-17','08:50:00',1.24),('15844','2013-08-17','08:55:00',1.33),('15844','2013-08-17','09:00:00',1.42),('15844','2013-08-17','09:05:00',1.48),('15844','2013-08-17','09:10:00',1.58),('15844','2013-08-17','09:15:00',1.67),('15844','2013-08-17','09:20:00',1.78),('15844','2013-08-17','09:25:00',1.88),('15844','2013-08-17','09:30:00',2.01),('15844','2013-08-17','09:35:00',2.11),('15844','2013-08-17','09:40:00',2.2),('15844','2013-08-17','09:45:00',2.24),('15844','2013-08-17','09:50:00',2.3),('15844','2013-08-17','09:55:00',2.36),('15844','2013-08-17','10:00:00',2.56),('15844','2013-08-17','10:05:00',2.68),('15844','2013-08-17','10:10:00',2.78),('15844','2013-08-17','10:15:00',2.87),('15844','2013-08-17','10:20:00',2.96),('15844','2013-08-17','10:25:00',3.06),('15844','2013-08-17','10:30:00',3.17),('15844','2013-08-17','10:35:00',3.26),('15844','2013-08-17','10:40:00',3.33),('15844','2013-08-17','10:45:00',3.4),('15844','2013-08-17','10:50:00',3.46),('15844','2013-08-17','10:55:00',3.53),('15844','2013-08-17','11:00:00',3.66),('15844','2013-08-17','11:05:00',3.67),('15844','2013-08-17','11:10:00',3.68),('15844','2013-08-17','11:15:00',3.78),('15844','2013-08-17','11:20:00',3.83),('15844','2013-08-17','11:25:00',3.88),('15844','2013-08-17','11:30:00',3.9),('15844','2013-08-17','11:35:00',3.88),('15844','2013-08-17','11:40:00',3.87),('15844','2013-08-17','11:45:00',3.86),('15844','2013-08-17','11:50:00',3.93),('15844','2013-08-17','11:55:00',3.93),('15844','2013-08-17','12:00:00',3.85),('15844','2013-08-17','12:05:00',3.87),('15844','2013-08-17','12:10:00',3.7),('15844','2013-08-17','12:15:00',3.83),('15844','2013-08-17','12:20:00',3.83),('15844','2013-08-17','12:25:00',3.86),('15844','2013-08-17','12:30:00',3.92),('15844','2013-08-17','12:35:00',3.97),('15844','2013-08-17','12:40:00',3.91),('15844','2013-08-17','12:45:00',3.81),('15844','2013-08-17','12:50:00',3.79),('15844','2013-08-17','12:55:00',3.85),('15844','2013-08-17','13:00:00',3.84),('15844','2013-08-17','13:05:00',3.65),('15844','2013-08-17','13:10:00',3.85),('15844','2013-08-17','13:15:00',3.87),('15844','2013-08-17','13:20:00',3.83),('15844','2013-08-17','13:25:00',3.78),('15844','2013-08-17','13:30:00',3.73),('15844','2013-08-17','13:35:00',3.64),('15844','2013-08-17','13:40:00',3.74),('15844','2013-08-17','13:45:00',3.6),('15844','2013-08-17','13:50:00',3.56),('15844','2013-08-17','13:55:00',3.64),('15844','2013-08-17','14:00:00',3.47),('15844','2013-08-17','14:05:00',3.13),('15844','2013-08-17','14:10:00',3.4),('15844','2013-08-17','14:15:00',3.31),('15844','2013-08-17','14:20:00',3.19),('15844','2013-08-17','14:25:00',3.2),('15844','2013-08-17','14:30:00',3.07),('15844','2013-08-17','14:35:00',2.99),('15844','2013-08-17','14:40:00',2.87),('15844','2013-08-17','14:45:00',2.79),('15844','2013-08-17','14:50:00',2.65),('15844','2013-08-17','14:55:00',2.6),('15844','2013-08-17','15:00:00',2.53),('15844','2013-08-17','15:05:00',2.41),('15844','2013-08-17','15:10:00',2.35),('15844','2013-08-17','15:15:00',2.27),('15844','2013-08-17','15:20:00',2.19),('15844','2013-08-17','15:25:00',2.1),('15844','2013-08-17','15:30:00',2.02),('15844','2013-08-17','15:35:00',1.92),('15844','2013-08-17','15:40:00',1.82),('15844','2013-08-17','15:45:00',1.72),('15844','2013-08-17','15:50:00',1.62),('15844','2013-08-17','15:55:00',1.5),('15844','2013-08-17','16:00:00',1.38),('15844','2013-08-17','16:05:00',1.31),('15844','2013-08-17','16:10:00',1.23),('15844','2013-08-17','16:15:00',1.18),('15844','2013-08-17','16:20:00',1.13),('15844','2013-08-17','16:25:00',1.07),('15844','2013-08-17','16:30:00',1.02),('15844','2013-08-16','08:35:00',1.01),('15844','2013-08-16','08:40:00',1.14),('15844','2013-08-16','08:45:00',1.22),('15844','2013-08-16','08:50:00',1.28),('15844','2013-08-16','08:55:00',1.37),('15844','2013-08-16','09:00:00',1.45),('15844','2013-08-16','09:05:00',1.52),('15844','2013-08-16','09:10:00',1.62),('15844','2013-08-16','09:15:00',1.71),('15844','2013-08-16','09:20:00',1.8),('15844','2013-08-16','09:25:00',1.92),('15844','2013-08-16','09:30:00',2.05),('15844','2013-08-16','09:35:00',2.15),('15844','2013-08-16','09:40:00',2.24),('15844','2013-08-16','09:45:00',2.3),('15844','2013-08-16','09:50:00',2.36),('15844','2013-08-16','09:55:00',2.45),('15844','2013-08-16','10:00:00',2.65),('15844','2013-08-16','10:05:00',2.76),('15844','2013-08-16','10:10:00',2.82),('15844','2013-08-16','10:15:00',2.9),('15844','2013-08-16','10:20:00',3.05),('15844','2013-08-16','10:25:00',3.16),('15844','2013-08-16','10:30:00',3.28),('15844','2013-08-16','10:35:00',3.36),('15844','2013-08-16','10:40:00',3.45),('15844','2013-08-16','10:45:00',3.52),('15844','2013-08-16','10:50:00',3.59),('15844','2013-08-16','10:55:00',3.68),('15844','2013-08-16','11:00:00',3.87),('15844','2013-08-16','11:05:00',3.93),('15844','2013-08-16','11:10:00',3.96),('15844','2013-08-16','11:15:00',3.97),('15844','2013-08-16','11:20:00',4),('15844','2013-08-16','11:25:00',4.02),('15844','2013-08-16','11:30:00',4.03),('15844','2013-08-16','11:35:00',4.06),('15844','2013-08-16','11:40:00',4.08),('15844','2013-08-16','11:45:00',4.07),('15844','2013-08-16','11:50:00',4.11),('15844','2013-08-16','11:55:00',4.08),('15844','2013-08-16','12:00:00',4.08),('15844','2013-08-16','12:05:00',4.03),('15844','2013-08-16','12:10:00',4.02),('15844','2013-08-16','12:15:00',4),('15844','2013-08-16','12:20:00',4),('15844','2013-08-16','12:25:00',4.02),('15844','2013-08-16','12:30:00',3.99),('15844','2013-08-16','12:35:00',3.96),('15844','2013-08-16','12:40:00',3.96),('15844','2013-08-16','12:45:00',3.95),('15844','2013-08-16','12:50:00',3.94),('15844','2013-08-16','12:55:00',3.89),('15844','2013-08-16','13:00:00',3.88),('15844','2013-08-16','13:05:00',3.84),('15844','2013-08-16','13:10:00',3.82),('15844','2013-08-16','13:15:00',3.82),('15844','2013-08-16','13:20:00',3.79),('15844','2013-08-16','13:25:00',3.77),('15844','2013-08-16','13:30:00',3.73),('15844','2013-08-16','13:35:00',3.67),('15844','2013-08-16','13:40:00',3.65),('15844','2013-08-16','13:45:00',3.62),('15844','2013-08-16','13:50:00',3.58),('15844','2013-08-16','13:55:00',3.55),('15844','2013-08-16','14:00:00',3.48),('15844','2013-08-16','14:05:00',3.41),('15844','2013-08-16','14:10:00',3.35),('15844','2013-08-16','14:15:00',3.3),('15844','2013-08-16','14:20:00',3.23),('15844','2013-08-16','14:25:00',3.16),('15844','2013-08-16','14:30:00',3.06),('15844','2013-08-16','14:35:00',2.95),('15844','2013-08-16','14:40:00',2.84),('15844','2013-08-16','14:45:00',2.7),('15844','2013-08-16','14:50:00',2.64),('15844','2013-08-16','14:55:00',2.59),('15844','2013-08-16','15:00:00',2.5),('15844','2013-08-16','15:05:00',2.43),('15844','2013-08-16','15:10:00',2.36),('15844','2013-08-16','15:15:00',2.29),('15844','2013-08-16','15:20:00',2.2),('15844','2013-08-16','15:25:00',2.12),('15844','2013-08-16','15:30:00',2.04),('15844','2013-08-16','15:35:00',1.94),('15844','2013-08-16','15:40:00',1.82),('15844','2013-08-16','15:45:00',1.72),('15844','2013-08-16','15:50:00',1.62),('15844','2013-08-16','15:55:00',1.51),('15844','2013-08-16','16:00:00',1.39),('15844','2013-08-16','16:05:00',1.3),('15844','2013-08-16','16:10:00',1.22),('15844','2013-08-16','16:15:00',1.17),('15844','2013-08-16','16:20:00',1.12),('15844','2013-08-16','16:25:00',1.07),('15844','2013-08-16','16:30:00',1),('15844','2013-08-15','08:50:00',1.1),('15844','2013-08-15','08:55:00',1.39),('15844','2013-08-15','09:00:00',1.51),('15844','2013-08-15','09:05:00',1.6),('15844','2013-08-15','09:10:00',1.7),('15844','2013-08-15','09:15:00',1.8),('15844','2013-08-15','09:20:00',1.89),('15844','2013-08-15','09:25:00',1.95),('15844','2013-08-15','09:30:00',2.07),('15844','2013-08-15','09:35:00',2.17),('15844','2013-08-15','09:40:00',2.24),('15844','2013-08-15','09:45:00',2.32),('15844','2013-08-15','09:50:00',2.37),('15844','2013-08-15','09:55:00',2.42),('15844','2013-08-15','10:00:00',2.61),('15844','2013-08-15','10:05:00',2.76),('15844','2013-08-15','10:10:00',2.82),('15844','2013-08-15','10:15:00',2.94),('15844','2013-08-15','10:20:00',3.08),('15844','2013-08-15','10:25:00',3.2),('15844','2013-08-15','10:30:00',3.3),('15844','2013-08-15','10:35:00',3.42),('15844','2013-08-15','10:40:00',3.5),('15844','2013-08-15','10:45:00',3.6),('15844','2013-08-15','10:50:00',3.68),('15844','2013-08-15','10:55:00',3.77),('15844','2013-08-15','11:00:00',3.89),('15844','2013-08-15','11:05:00',4.01),('15844','2013-08-15','11:10:00',4.07),('15844','2013-08-15','11:15:00',4.12),('15844','2013-08-15','11:20:00',4),('15844','2013-08-15','11:25:00',4.19),('15844','2013-08-15','11:30:00',3.85),('15844','2013-08-15','11:35:00',2.63),('15844','2013-08-15','11:40:00',2.46),('15844','2013-08-15','11:45:00',2.39),('15844','2013-08-15','11:50:00',3.21),('15844','2013-08-15','11:55:00',3.64),('15844','2013-08-15','12:00:00',3.89),('15844','2013-08-15','12:05:00',4.08),('15844','2013-08-15','12:10:00',4.12),('15844','2013-08-15','12:15:00',3.96),('15844','2013-08-15','12:20:00',3.9),('15844','2013-08-15','12:25:00',4.04),('15844','2013-08-15','12:30:00',4.13),('15844','2013-08-15','12:35:00',4.14),('15844','2013-08-15','12:40:00',4.14),('15844','2013-08-15','12:45:00',4.09),('15844','2013-08-15','12:50:00',4.03),('15844','2013-08-15','12:55:00',3.98),('15844','2013-08-15','13:00:00',3.96),('15844','2013-08-15','13:05:00',4),('15844','2013-08-15','13:10:00',3.93),('15844','2013-08-15','13:15:00',3.87),('15844','2013-08-15','13:20:00',3.89),('15844','2013-08-15','13:25:00',3.76),('15844','2013-08-15','13:30:00',3.91),('15844','2013-08-15','13:35:00',3.88),('15844','2013-08-15','13:40:00',3.78),('15844','2013-08-15','13:45:00',3.7),('15844','2013-08-15','13:50:00',3.66),('15844','2013-08-15','13:55:00',3.62),('15844','2013-08-15','14:00:00',3.51),('15844','2013-08-15','14:05:00',3.45),('15844','2013-08-15','14:10:00',3.39),('15844','2013-08-15','14:15:00',3.3),('15844','2013-08-15','14:20:00',3.2),('15844','2013-08-15','14:25:00',3.18),('15844','2013-08-15','14:30:00',3.11),('15844','2013-08-15','14:35:00',3.01),('15844','2013-08-15','14:40:00',2.88),('15844','2013-08-15','14:45:00',2.77),('15844','2013-08-15','14:50:00',2.63),('15844','2013-08-15','14:55:00',2.53),('15844','2013-08-15','15:00:00',2.46),('15844','2013-08-15','15:05:00',2.39),('15844','2013-08-15','15:10:00',2.32),('15844','2013-08-15','15:15:00',2.27),('15844','2013-08-15','15:20:00',2.16),('15844','2013-08-15','15:25:00',2.08),('15844','2013-08-15','15:30:00',2.01),('15844','2013-08-15','15:35:00',1.93),('15844','2013-08-15','15:40:00',1.84),('15844','2013-08-15','15:45:00',1.73),('15844','2013-08-15','15:50:00',1.62),('15844','2013-08-15','15:55:00',1.51),('15844','2013-08-15','16:00:00',1.43),('15844','2013-08-15','16:05:00',1.34),('15844','2013-08-15','16:10:00',1.26),('15844','2013-08-15','16:15:00',1.16),('15844','2013-08-15','16:20:00',1.16),('15844','2013-08-15','16:25:00',1.11),('15844','2013-08-15','16:30:00',1.06),('15844','2013-08-15','16:35:00',1.01),('15844','2013-08-14','08:45:00',1.02),('15844','2013-08-14','08:50:00',1.15),('15844','2013-08-14','08:55:00',1.24),('15844','2013-08-14','09:00:00',1.5),('15844','2013-08-14','09:05:00',1.76),('15844','2013-08-14','09:10:00',1.72),('15844','2013-08-14','09:15:00',1.05),('15844','2013-08-14','09:35:00',1.24),('15844','2013-08-14','09:40:00',1.37),('15844','2013-08-14','09:45:00',1.69),('15844','2013-08-14','09:50:00',2.29),('15844','2013-08-14','09:55:00',2.38),('15844','2013-08-14','10:00:00',2.75),('15844','2013-08-14','10:05:00',2.09),('15844','2013-08-14','10:10:00',1.43),('15844','2013-08-14','10:15:00',1.84),('15844','2013-08-14','10:20:00',2.46),('15844','2013-08-14','10:25:00',2.73),('15844','2013-08-14','10:30:00',1.68),('15844','2013-08-14','10:35:00',1.1),('15844','2013-08-14','10:45:00',1.05),('15844','2013-08-14','10:50:00',1.94),('15844','2013-08-14','10:55:00',2.79),('15844','2013-08-14','11:00:00',4.1),('15844','2013-08-14','11:05:00',3.27),('15844','2013-08-14','11:10:00',1.79),('15844','2013-08-14','11:15:00',2.69),('15844','2013-08-14','11:20:00',2.97),('15844','2013-08-14','11:25:00',1.56),('15844','2013-08-14','11:30:00',1.56),('15844','2013-08-14','11:35:00',3.74),('15844','2013-08-14','11:40:00',3.78),('15844','2013-08-14','11:45:00',3.85),('15844','2013-08-14','11:50:00',3.46),('15844','2013-08-14','11:55:00',3),('15844','2013-08-14','12:00:00',3.84),('15844','2013-08-14','12:05:00',4.16),('15844','2013-08-14','12:10:00',3.63),('15844','2013-08-14','12:15:00',3),('15844','2013-08-14','12:20:00',4.18),('15844','2013-08-14','12:25:00',3.67),('15844','2013-08-14','12:30:00',4.34),('15844','2013-08-14','12:35:00',3.64),('15844','2013-08-14','12:40:00',1.47),('15844','2013-08-14','12:45:00',1.03),('15844','2013-08-14','12:50:00',1.34),('15844','2013-08-14','12:55:00',3.07),('15844','2013-08-14','13:00:00',2.93),('15844','2013-08-14','13:05:00',3.57),('15844','2013-08-14','13:10:00',3.81),('15844','2013-08-14','13:15:00',3.85),('15844','2013-08-14','13:20:00',3.34),('15844','2013-08-14','13:25:00',2.61),('15844','2013-08-14','13:30:00',3.47),('15844','2013-08-14','13:35:00',3.6),('15844','2013-08-14','13:40:00',3.52),('15844','2013-08-14','13:45:00',2.79),('15844','2013-08-14','13:50:00',3.95),('15844','2013-08-14','13:55:00',3.74),('15844','2013-08-14','14:00:00',3.52),('15844','2013-08-14','14:05:00',3.63),('15844','2013-08-14','14:10:00',3.76),('15844','2013-08-14','14:15:00',3.51),('15844','2013-08-14','14:20:00',3.42),('15844','2013-08-14','14:25:00',3.47),('15844','2013-08-14','14:30:00',3.37),('15844','2013-08-14','14:35:00',3.15),('15844','2013-08-14','14:40:00',2.97),('15844','2013-08-14','14:45:00',2.89),('15844','2013-08-14','14:50:00',2.79),('15844','2013-08-14','14:55:00',2.67),('15844','2013-08-14','15:00:00',2.57),('15844','2013-08-14','15:05:00',2.42),('15844','2013-08-14','15:10:00',2.36),('15844','2013-08-14','15:15:00',2.31),('15844','2013-08-14','15:20:00',2.24),('15844','2013-08-14','15:25:00',2.17),('15844','2013-08-14','15:30:00',2.08),('15844','2013-08-14','15:35:00',1.98),('15844','2013-08-14','15:40:00',1.88),('15844','2013-08-14','15:45:00',1.79),('15844','2013-08-14','15:50:00',1.68),('15844','2013-08-14','15:55:00',1.58),('15844','2013-08-14','16:00:00',1.49),('15844','2013-08-14','16:05:00',1.37),('15844','2013-08-14','16:10:00',1.28),('15844','2013-08-14','16:15:00',1.19),('15844','2013-08-14','16:20:00',1.19),('15844','2013-08-14','16:25:00',1.12),('15844','2013-08-14','16:30:00',1.07),('15844','2013-08-13','08:35:00',1.04),('15844','2013-08-13','08:40:00',1.16),('15844','2013-08-13','08:45:00',1.24),('15844','2013-08-13','08:50:00',1.3),('15844','2013-08-13','08:55:00',1.37),('15844','2013-08-13','09:00:00',1.44),('15844','2013-08-13','09:05:00',1.49),('15844','2013-08-13','09:10:00',1.56),('15844','2013-08-13','09:15:00',1.66),('15844','2013-08-13','09:20:00',1.79),('15844','2013-08-13','09:25:00',1.9),('15844','2013-08-13','09:30:00',2.03),('15844','2013-08-13','09:35:00',2.15),('15844','2013-08-13','09:40:00',2.19),('15844','2013-08-13','09:45:00',2.25),('15844','2013-08-13','09:50:00',2.19),('15844','2013-08-13','09:55:00',2.17),('15844','2013-08-13','10:00:00',2.18),('15844','2013-08-13','10:05:00',2.43),('15844','2013-08-13','10:10:00',2.77),('15844','2013-08-13','10:15:00',3.02),('15844','2013-08-13','10:20:00',3.1),('15844','2013-08-13','10:25:00',3.19),('15844','2013-08-13','10:30:00',3.2),('15844','2013-08-13','10:35:00',3.47),('15844','2013-08-13','10:40:00',3.51),('15844','2013-08-13','10:45:00',3.5),('15844','2013-08-13','10:50:00',3.54),('15844','2013-08-13','10:55:00',3.69),('15844','2013-08-13','11:00:00',3.7),('15844','2013-08-13','11:05:00',3.81),('15844','2013-08-13','11:10:00',3.62),('15844','2013-08-13','11:15:00',3.92),('15844','2013-08-13','11:20:00',3.93),('15844','2013-08-13','11:25:00',3.96),('15844','2013-08-13','11:30:00',4.06),('15844','2013-08-13','11:35:00',4.03),('15844','2013-08-13','11:40:00',4.02),('15844','2013-08-13','11:45:00',4.16),('15844','2013-08-13','11:50:00',4.18),('15844','2013-08-13','11:55:00',3.72),('15844','2013-08-13','12:00:00',1.11),('15844','2013-08-13','12:10:00',1.79),('15844','2013-08-13','12:15:00',2.22),('15844','2013-08-13','12:20:00',4.22),('15844','2013-08-13','12:25:00',3.02),('15844','2013-08-13','12:30:00',3.72),('15844','2013-08-13','12:35:00',4.38),('15844','2013-08-13','12:40:00',4.38),('15844','2013-08-13','12:45:00',4.39),('15844','2013-08-13','12:50:00',4.18),('15844','2013-08-13','12:55:00',3.94),('15844','2013-08-13','13:00:00',3.83),('15844','2013-08-13','13:05:00',3.94),('15844','2013-08-13','13:10:00',4.03),('15844','2013-08-13','13:15:00',3.86),('15844','2013-08-13','13:20:00',3.87),('15844','2013-08-13','13:25:00',3.78),('15844','2013-08-13','13:30:00',3.97),('15844','2013-08-13','13:35:00',3.86),('15844','2013-08-13','13:40:00',3.79),('15844','2013-08-13','13:45:00',3.84),('15844','2013-08-13','13:50:00',3.67),('15844','2013-08-13','13:55:00',3.66),('15844','2013-08-13','14:00:00',3.55),('15844','2013-08-13','14:05:00',3.46),('15844','2013-08-13','14:10:00',3.4),('15844','2013-08-13','14:15:00',3.36),('15844','2013-08-13','14:20:00',3.31),('15844','2013-08-13','14:25:00',3.21),('15844','2013-08-13','14:30:00',3.16),('15844','2013-08-13','14:35:00',3.13),('15844','2013-08-13','14:40:00',2.99),('15844','2013-08-13','14:45:00',2.87),('15844','2013-08-13','14:50:00',2.77),('15844','2013-08-13','14:55:00',2.65),('15844','2013-08-13','15:00:00',2.61),('15844','2013-08-13','15:05:00',2.53),('15844','2013-08-13','15:10:00',2.42),('15844','2013-08-13','15:15:00',2.32),('15844','2013-08-13','15:20:00',2.25),('15844','2013-08-13','15:25:00',2.17),('15844','2013-08-13','15:30:00',2.09),('15844','2013-08-13','15:35:00',2.01),('15844','2013-08-13','15:40:00',1.91),('15844','2013-08-13','15:45:00',1.82),('15844','2013-08-13','15:50:00',1.71),('15844','2013-08-13','15:55:00',1.59),('15844','2013-08-13','16:00:00',1.49),('15844','2013-08-13','16:05:00',1.38),('15844','2013-08-13','16:10:00',1.27),('15844','2013-08-13','16:15:00',1.19),('15844','2013-08-13','16:20:00',1.2),('15844','2013-08-13','16:25:00',1.13),('15844','2013-08-13','16:30:00',1.07),('15844','2013-08-12','08:35:00',1.04),('15844','2013-08-12','08:40:00',1.14),('15844','2013-08-12','08:45:00',1.21),('15844','2013-08-12','08:50:00',1.27),('15844','2013-08-12','08:55:00',1.34),('15844','2013-08-12','09:00:00',1.4),('15844','2013-08-12','09:05:00',1.49),('15844','2013-08-12','09:10:00',1.58),('15844','2013-08-12','09:15:00',1.67),('15844','2013-08-12','09:20:00',1.77),('15844','2013-08-12','09:25:00',1.89),('15844','2013-08-12','09:30:00',2),('15844','2013-08-12','09:35:00',2.09),('15844','2013-08-12','09:40:00',2.16),('15844','2013-08-12','09:45:00',2.21),('15844','2013-08-12','09:50:00',2.25),('15844','2013-08-12','09:55:00',2.31),('15844','2013-08-12','10:00:00',2.51),('15844','2013-08-12','10:05:00',2.62),('15844','2013-08-12','10:10:00',2.7),('15844','2013-08-12','10:15:00',2.82),('15844','2013-08-12','10:20:00',2.95),('15844','2013-08-12','10:25:00',3.06),('15844','2013-08-12','10:30:00',3.15),('15844','2013-08-12','10:35:00',3.24),('15844','2013-08-12','10:40:00',3.34),('15844','2013-08-12','10:45:00',3.42),('15844','2013-08-12','10:50:00',3.5),('15844','2013-08-12','10:55:00',3.62),('15844','2013-08-12','11:00:00',3.66),('15844','2013-08-12','11:05:00',3.7),('15844','2013-08-12','11:10:00',3.74),('15844','2013-08-12','11:15:00',3.75),('15844','2013-08-12','11:20:00',3.83),('15844','2013-08-12','11:25:00',3.86),('15844','2013-08-12','11:30:00',3.85),('15844','2013-08-12','11:35:00',3.96),('15844','2013-08-12','11:40:00',3.83),('15844','2013-08-12','11:45:00',4.12),('15844','2013-08-12','11:50:00',4.15),('15844','2013-08-12','11:55:00',3.95),('15844','2013-08-12','12:00:00',2.9),('15844','2013-08-12','12:05:00',2.16),('15844','2013-08-12','12:10:00',1.42),('15844','2013-08-12','12:15:00',1.24),('15844','2013-08-12','12:20:00',1.41),('15844','2013-08-12','12:25:00',2.06),('15844','2013-08-12','12:30:00',2.14),('15844','2013-08-12','12:35:00',2.1),('15844','2013-08-12','12:40:00',3.34),('15844','2013-08-12','12:55:00',1.11),('15844','2013-08-12','13:00:00',2.69),('15844','2013-08-12','13:10:00',1.52),('15844','2013-08-12','13:15:00',1.48),('15844','2013-08-12','13:20:00',2.63),('15844','2013-08-12','13:25:00',1.95),('15844','2013-08-12','13:30:00',2.64),('15844','2013-08-12','13:35:00',1.19),('15844','2013-08-12','13:40:00',2.29),('15844','2013-08-12','13:45:00',4.16),('15844','2013-08-12','13:50:00',1.58),('15844','2013-08-12','13:55:00',2.27),('15844','2013-08-12','14:00:00',1.77),('15844','2013-08-12','14:05:00',1.37),('15844','2013-08-12','14:10:00',1.47),('15844','2013-08-12','14:15:00',1.44),('15844','2013-08-12','14:20:00',2.26),('15844','2013-08-12','14:25:00',2.73),('15844','2013-08-12','14:30:00',3.39),('15844','2013-08-12','14:35:00',2.39),('15844','2013-08-12','14:40:00',2.57),('15844','2013-08-12','14:45:00',2.6),('15844','2013-08-12','14:50:00',3.07),('15844','2013-08-12','14:55:00',2.85),('15844','2013-08-12','15:00:00',2.78),('15844','2013-08-12','15:05:00',2.63),('15844','2013-08-12','15:10:00',2.48),('15844','2013-08-12','15:15:00',2.34),('15844','2013-08-12','15:20:00',2.28),('15844','2013-08-12','15:25:00',2.12),('15844','2013-08-12','15:30:00',2.14),('15844','2013-08-12','15:35:00',2.12),('15844','2013-08-12','15:40:00',1.76),('15844','2013-08-12','15:45:00',1.82),('15844','2013-08-12','15:50:00',1.73),('15844','2013-08-12','15:55:00',1.63),('15844','2013-08-12','16:00:00',1.54),('15844','2013-08-12','16:05:00',1.48),('15844','2013-08-12','16:10:00',1.33),('15844','2013-08-12','16:15:00',1.23),('15844','2013-08-12','16:20:00',1.2),('15844','2013-08-12','16:25:00',1.17),('15844','2013-08-12','16:30:00',1.08),('15844','2013-08-12','16:35:00',1.02),('15844','2013-08-11','08:45:00',1.07),('15844','2013-08-11','08:50:00',1.17),('15844','2013-08-11','08:55:00',1.22),('15844','2013-08-11','09:00:00',1.26),('15844','2013-08-11','09:05:00',1.37),('15844','2013-08-11','09:10:00',1.62),('15844','2013-08-11','09:15:00',1.72),('15844','2013-08-11','09:20:00',1.81),('15844','2013-08-11','09:25:00',1.94),('15844','2013-08-11','09:30:00',2.06),('15844','2013-08-11','09:35:00',2.15),('15844','2013-08-11','09:40:00',2.24),('15844','2013-08-11','09:45:00',2.29),('15844','2013-08-11','09:50:00',2.35),('15844','2013-08-11','09:55:00',2.39),('15844','2013-08-11','10:00:00',2.54),('15844','2013-08-11','10:05:00',2.71),('15844','2013-08-11','10:10:00',2.78),('15844','2013-08-11','10:15:00',2.91),('15844','2013-08-11','10:20:00',3.01),('15844','2013-08-11','10:25:00',3.13),('15844','2013-08-11','10:30:00',3.26),('15844','2013-08-11','10:35:00',3.35),('15844','2013-08-11','10:40:00',3.42),('15844','2013-08-11','10:45:00',3.5),('15844','2013-08-11','10:50:00',3.61),('15844','2013-08-11','10:55:00',3.8),('15844','2013-08-11','11:00:00',3.88),('15844','2013-08-11','11:05:00',3.91),('15844','2013-08-11','11:10:00',3.98),('15844','2013-08-11','11:15:00',4),('15844','2013-08-11','11:20:00',4.06),('15844','2013-08-11','11:25:00',4.05),('15844','2013-08-11','11:30:00',4.06),('15844','2013-08-11','11:35:00',4.07),('15844','2013-08-11','11:40:00',4.05),('15844','2013-08-11','11:45:00',4.09),('15844','2013-08-11','11:50:00',4.09),('15844','2013-08-11','11:55:00',4.09),('15844','2013-08-11','12:00:00',4.09),('15844','2013-08-11','12:05:00',4.11),('15844','2013-08-11','12:10:00',4.08),('15844','2013-08-11','12:15:00',4.08),('15844','2013-08-11','12:20:00',4.06),('15844','2013-08-11','12:25:00',4.05),('15844','2013-08-11','12:30:00',4.07),('15844','2013-08-11','12:35:00',4.02),('15844','2013-08-11','12:40:00',4),('15844','2013-08-11','12:45:00',4),('15844','2013-08-11','12:50:00',3.97),('15844','2013-08-11','12:55:00',3.95),('15844','2013-08-11','13:00:00',3.93),('15844','2013-08-11','13:05:00',3.93),('15844','2013-08-11','13:10:00',3.95),('15844','2013-08-11','13:15:00',3.94),('15844','2013-08-11','13:20:00',3.86),('15844','2013-08-11','13:25:00',3.82),('15844','2013-08-11','13:30:00',3.79),('15844','2013-08-11','13:35:00',3.76),('15844','2013-08-11','13:40:00',3.64),('15844','2013-08-11','13:45:00',3.68),('15844','2013-08-11','13:50:00',3.62),('15844','2013-08-11','13:55:00',3.58),('15844','2013-08-11','14:00:00',3.5),('15844','2013-08-11','14:05:00',3.45),('15844','2013-08-11','14:10:00',3.36),('15844','2013-08-11','14:15:00',3.25),('15844','2013-08-11','14:20:00',3.21),('15844','2013-08-11','14:25:00',3.21),('15844','2013-08-11','14:30:00',3.11),('15844','2013-08-11','14:35:00',2.99),('15844','2013-08-11','14:40:00',2.97),('15844','2013-08-11','14:45:00',2.71),('15844','2013-08-11','14:50:00',2.73),('15844','2013-08-11','14:55:00',2.62),('15844','2013-08-11','15:00:00',2.53),('15844','2013-08-11','15:05:00',2.5),('15844','2013-08-11','15:10:00',2.42),('15844','2013-08-11','15:15:00',2.32),('15844','2013-08-11','15:20:00',2.31),('15844','2013-08-11','15:25:00',2.19),('15844','2013-08-11','15:30:00',2.09),('15844','2013-08-11','15:35:00',2.01),('15844','2013-08-11','15:40:00',1.92),('15844','2013-08-11','15:45:00',1.82),('15844','2013-08-11','15:50:00',1.72),('15844','2013-08-11','15:55:00',1.62),('15844','2013-08-11','16:00:00',1.53),('15844','2013-08-11','16:05:00',1.44),('15844','2013-08-11','16:10:00',1.33),('15844','2013-08-11','16:15:00',1.22),('15844','2013-08-11','16:20:00',1.17),('15844','2013-08-11','16:25:00',1.15),('15844','2013-08-11','16:30:00',1.12),('15844','2013-08-11','16:35:00',1.09),('15844','2013-08-11','16:40:00',1.03),('15844','2013-08-10','08:35:00',1.07),('15844','2013-08-10','08:40:00',1.21),('15844','2013-08-10','08:45:00',1.29),('15844','2013-08-10','08:50:00',1.35),('15844','2013-08-10','08:55:00',1.43),('15844','2013-08-10','09:00:00',1.5),('15844','2013-08-10','09:05:00',1.56),('15844','2013-08-10','09:10:00',1.65),('15844','2013-08-10','09:15:00',1.74),('15844','2013-08-10','09:20:00',1.87),('15844','2013-08-10','09:25:00',1.96),('15844','2013-08-10','09:30:00',2.08),('15844','2013-08-10','09:35:00',2.18),('15844','2013-08-10','09:40:00',2.28),('15844','2013-08-10','09:45:00',2.36),('15844','2013-08-10','09:50:00',2.41),('15844','2013-08-10','09:55:00',2.46),('15844','2013-08-10','10:00:00',2.64),('15844','2013-08-10','10:05:00',2.76),('15844','2013-08-10','10:10:00',2.86),('15844','2013-08-10','10:15:00',2.96),('15844','2013-08-10','10:20:00',3.04),('15844','2013-08-10','10:25:00',3.14),('15844','2013-08-10','10:30:00',3.29),('15844','2013-08-10','10:35:00',3.38),('15844','2013-08-10','10:40:00',3.51),('15844','2013-08-10','10:45:00',3.56),('15844','2013-08-10','10:50:00',3.63),('15844','2013-08-10','10:55:00',3.69),('15844','2013-08-10','11:00:00',3.94),('15844','2013-08-10','11:05:00',3.39),('15844','2013-08-10','11:10:00',4.09),('15844','2013-08-10','11:15:00',4.14),('15844','2013-08-10','11:20:00',4.1),('15844','2013-08-10','11:25:00',4.1),('15844','2013-08-10','11:30:00',4.09),('15844','2013-08-10','11:35:00',4.06),('15844','2013-08-10','11:40:00',4.12),('15844','2013-08-10','11:45:00',4.11),('15844','2013-08-10','11:50:00',4.11),('15844','2013-08-10','11:55:00',4.17),('15844','2013-08-10','12:00:00',4.25),('15844','2013-08-10','12:05:00',4.16),('15844','2013-08-10','12:10:00',4.1),('15844','2013-08-10','12:15:00',4.14),('15844','2013-08-10','12:20:00',4.18),('15844','2013-08-10','12:25:00',4.19),('15844','2013-08-10','12:30:00',4.17),('15844','2013-08-10','12:35:00',4.17),('15844','2013-08-10','12:40:00',4.21),('15844','2013-08-10','12:45:00',4.36),('15844','2013-08-10','12:50:00',3.43),('15844','2013-08-10','12:55:00',2.39),('15844','2013-08-10','13:00:00',4.3),('15844','2013-08-10','13:05:00',4.09),('15844','2013-08-10','13:10:00',4.12),('15844','2013-08-10','13:15:00',4.23),('15844','2013-08-10','13:20:00',4.25),('15844','2013-08-10','13:25:00',4.28),('15844','2013-08-10','13:30:00',3.07),('15844','2013-08-10','13:35:00',2.31),('15844','2013-08-10','13:40:00',2.8),('15844','2013-08-10','13:45:00',3.17),('15844','2013-08-10','13:50:00',1.94),('15844','2013-08-10','14:00:00',1.29),('15844','2013-08-10','14:05:00',3.56),('15844','2013-08-10','14:10:00',3.78),('15844','2013-08-10','14:15:00',2.53),('15844','2013-08-10','15:40:00',1.12),('15844','2013-08-10','15:45:00',1.46),('15844','2013-08-10','15:50:00',1.36),('15844','2013-08-10','15:55:00',1.31),('15844','2013-08-10','16:00:00',1.36),('15844','2013-08-10','16:05:00',1.25),('15844','2013-08-10','16:10:00',1.21),('15844','2013-08-10','16:20:00',1.03),('15844','2013-08-10','16:25:00',1.3),('15844','2013-08-10','16:30:00',1.14),('15844','2013-08-10','17:15:00',1),('15844','2014-04-09','09:45:00',2.23),('15844','2014-04-09','09:50:00',2.42),('15844','2014-04-09','09:55:00',2.55),('15844','2014-04-09','10:00:00',2.1),('15844','2014-04-09','10:05:00',1.31),('15844','2014-04-09','10:10:00',1.62),('15844','2014-04-09','10:15:00',2.71),('15844','2014-04-09','10:20:00',3.3),('15844','2014-04-09','10:25:00',1.46),('15844','2014-04-09','10:40:00',2.7),('15844','2014-04-09','10:45:00',1.4),('15844','2014-04-09','10:55:00',1.21),('15844','2014-04-09','11:00:00',1.83),('15844','2014-04-09','11:10:00',1.06),('15844','2014-04-09','11:15:00',3.7),('15844','2014-04-09','11:20:00',4.33),('15844','2014-04-09','11:25:00',4.23),('15844','2014-04-09','11:30:00',4),('15844','2014-04-09','11:35:00',3.61),('15844','2014-04-09','11:40:00',1.27),('15844','2014-04-09','11:45:00',2.88),('15844','2014-04-09','11:50:00',3.93),('15844','2014-04-09','11:55:00',1.64),('15844','2014-04-09','12:00:00',1.89),('15844','2014-04-09','12:05:00',1.38),('15844','2014-04-09','12:10:00',1.1),('15844','2014-04-09','13:40:00',1.01),('15844','2014-04-09','13:45:00',1.01),('15844','2014-04-09','14:30:00',1.18),('15844','2014-04-09','14:35:00',1.86),('15844','2014-04-09','14:40:00',2.34),('15844','2014-04-09','14:45:00',1.08),('15844','2014-04-09','14:55:00',1.12),('15844','2014-04-09','15:00:00',1.31),('15844','2014-04-09','15:05:00',1.06),('15844','2014-04-09','15:10:00',1.13),('15844','2014-04-09','15:15:00',1.09),('15844','2014-04-09','15:40:00',1.03),('15844','2014-04-09','16:00:00',1.43),('15844','2014-04-09','16:05:00',1.5),('15844','2014-04-09','16:10:00',1.32),('15844','2014-04-09','16:15:00',1.25),('15844','2014-04-09','16:20:00',1.06),('15844','2014-04-09','16:35:00',1.02),('15844','2014-04-09','16:40:00',1.17),('15844','2014-04-09','16:45:00',1.02),('15844','2013-08-09','08:45:00',1.09),('15844','2013-08-09','08:50:00',1.21),('15844','2013-08-09','08:55:00',1.18),('15844','2013-08-09','09:00:00',1.21),('15844','2013-08-09','09:05:00',1.51),('15844','2013-08-09','09:10:00',1.76),('15844','2013-08-09','09:15:00',1.28),('15844','2013-08-09','09:20:00',1.19),('15844','2013-08-09','09:25:00',1.98),('15844','2013-08-09','09:30:00',1.84),('15844','2013-08-09','09:35:00',1.42),('15844','2013-08-09','09:40:00',1.34),('15844','2013-08-09','09:45:00',2.13),('15844','2013-08-09','09:50:00',2.3),('15844','2013-08-09','09:55:00',2.41),('15844','2013-08-09','10:00:00',2.33),('15844','2013-08-09','10:05:00',2.24),('15844','2013-08-09','10:10:00',2.53),('15844','2013-08-09','10:15:00',2.61),('15844','2013-08-09','10:20:00',2.72),('15844','2013-08-09','10:25:00',2.76),('15844','2013-08-09','10:30:00',2.91),('15844','2013-08-09','10:35:00',2.99),('15844','2013-08-09','10:40:00',2.99),('15844','2013-08-09','10:45:00',3.05),('15844','2013-08-09','10:50:00',3.23),('15844','2013-08-09','10:55:00',3.34),('15844','2013-08-09','11:00:00',3.36),('15844','2013-08-09','11:05:00',3.39),('15844','2013-08-09','11:10:00',3.35),('15844','2013-08-09','11:15:00',3.55),('15844','2013-08-09','11:20:00',3.58),('15844','2013-08-09','11:25:00',3.59),('15844','2013-08-09','11:30:00',3.61),('15844','2013-08-09','11:35:00',3.65),('15844','2013-08-09','11:40:00',3.58),('15844','2013-08-09','11:45:00',3.65),('15844','2013-08-09','11:50:00',3.62),('15844','2013-08-09','11:55:00',3.67),('15844','2013-08-09','12:00:00',3.7),('15844','2013-08-09','12:05:00',3.68),('15844','2013-08-09','12:10:00',3.72),('15844','2013-08-09','12:15:00',3.68),('15844','2013-08-09','12:20:00',3.89),('15844','2013-08-09','12:25:00',4.08),('15844','2013-08-09','12:30:00',3.24),('15844','2013-08-09','12:35:00',2.83),('15844','2013-08-09','12:40:00',2.76),('15844','2013-08-09','12:45:00',2.32),('15844','2013-08-09','12:50:00',1.79),('15844','2013-08-09','12:55:00',1.69),('15844','2013-08-09','13:15:00',1.05),('15844','2013-08-09','13:20:00',1.51),('15844','2013-08-09','13:25:00',1.57),('15844','2013-08-09','13:30:00',1.44),('15844','2013-08-09','13:35:00',1.31),('15844','2013-08-09','13:40:00',1.1),('15844','2013-08-09','13:50:00',1.06),('15844','2013-08-09','13:55:00',1.14),('15844','2013-08-09','14:00:00',1.08),('15844','2013-08-09','15:10:00',1.44),('15844','2013-08-09','15:15:00',2.33),('15844','2013-08-09','15:20:00',1.37),('15844','2013-08-09','15:30:00',1.08),('15844','2013-08-09','15:35:00',1.67),('15844','2013-08-09','15:40:00',2.13),('15844','2013-08-09','15:45:00',1.89),('15844','2013-08-09','15:50:00',1.34),('15844','2013-08-09','16:50:00',1.16),('15844','2013-08-09','16:55:00',1.07),('15844','2013-08-08','08:40:00',1.04),('15844','2013-08-08','08:45:00',1.14),('15844','2013-08-08','08:50:00',1.21),('15844','2013-08-08','08:55:00',1.27),('15844','2013-08-08','09:00:00',1.33),('15844','2013-08-08','09:05:00',1.38),('15844','2013-08-08','09:10:00',1.44),('15844','2013-08-08','09:15:00',1.57),('15844','2013-08-08','09:20:00',1.68),('15844','2013-08-08','09:25:00',1.78),('15844','2013-08-08','09:30:00',1.88),('15844','2013-08-08','09:35:00',1.99),('15844','2013-08-08','09:40:00',2.06),('15844','2013-08-08','09:45:00',2.1),('15844','2013-08-08','09:50:00',2.16),('15844','2013-08-08','09:55:00',2.22),('15844','2013-08-08','10:00:00',2.4),('15844','2013-08-08','10:05:00',2.49),('15844','2013-08-08','10:10:00',2.56),('15844','2013-08-08','10:15:00',2.65),('15844','2013-08-08','10:20:00',2.78),('15844','2013-08-08','10:25:00',2.86),('15844','2013-08-08','10:30:00',2.95),('15844','2013-08-08','10:35:00',3.04),('15844','2013-08-08','10:40:00',3.11),('15844','2013-08-08','10:45:00',3.2),('15844','2013-08-08','10:50:00',3.29),('15844','2013-08-08','10:55:00',3.36),('15844','2013-08-08','11:00:00',3.45),('15844','2013-08-08','11:05:00',3.52),('15844','2013-08-08','11:10:00',3.54),('15844','2013-08-08','11:15:00',3.56),('15844','2013-08-08','11:20:00',3.61),('15844','2013-08-08','11:25:00',3.65),('15844','2013-08-08','11:30:00',3.68),('15844','2013-08-08','11:35:00',3.7),('15844','2013-08-08','11:40:00',3.68),('15844','2013-08-08','11:45:00',3.7),('15844','2013-08-08','11:50:00',3.71),('15844','2013-08-08','11:55:00',3.72),('15844','2013-08-08','12:00:00',3.71),('15844','2013-08-08','12:05:00',3.68),('15844','2013-08-08','12:10:00',3.69),('15844','2013-08-08','12:15:00',3.76),('15844','2013-08-08','12:20:00',3.77),('15844','2013-08-08','12:25:00',3.77),('15844','2013-08-08','12:30:00',3.8),('15844','2013-08-08','12:35:00',3.78),('15844','2013-08-08','12:40:00',3.66),('15844','2013-08-08','12:45:00',3.75),('15844','2013-08-08','12:50:00',3.76),('15844','2013-08-08','12:55:00',3.75),('15844','2013-08-08','13:00:00',3.74),('15844','2013-08-08','13:05:00',3.68),('15844','2013-08-08','13:10:00',3.71),('15844','2013-08-08','13:15:00',3.68),('15844','2013-08-08','13:20:00',3.65),('15844','2013-08-08','13:25:00',3.62),('15844','2013-08-08','13:30:00',3.6),('15844','2013-08-08','13:35:00',3.56),('15844','2013-08-08','13:40:00',3.54),('15844','2013-08-08','13:45:00',3.51),('15844','2013-08-08','13:50:00',3.46),('15844','2013-08-08','13:55:00',3.42),('15844','2013-08-08','14:00:00',3.37),('15844','2013-08-08','14:05:00',3.32),('15844','2013-08-08','14:10:00',3.27),('15844','2013-08-08','14:15:00',3.24),('15844','2013-08-08','14:20:00',3.17),('15844','2013-08-08','14:25:00',3.09),('15844','2013-08-08','14:30:00',3.03),('15844','2013-08-08','14:35:00',2.94),('15844','2013-08-08','14:40:00',2.84),('15844','2013-08-08','14:45:00',2.74),('15844','2013-08-08','14:50:00',2.63),('15844','2013-08-08','14:55:00',2.53),('15844','2013-08-08','15:00:00',2.43),('15844','2013-08-08','15:05:00',2.38),('15844','2013-08-08','15:10:00',2.29),('15844','2013-08-08','15:15:00',2.2),('15844','2013-08-08','15:20:00',2.11),('15844','2013-08-08','15:25:00',2.04),('15844','2013-08-08','15:30:00',1.95),('15844','2013-08-08','15:35:00',1.91),('15844','2013-08-08','15:40:00',1.83),('15844','2013-08-08','15:45:00',1.73),('15844','2013-08-08','15:50:00',1.65),('15844','2013-08-08','15:55:00',1.55),('15844','2013-08-08','16:00:00',1.47),('15844','2013-08-08','16:05:00',1.4),('15844','2013-08-08','16:10:00',1.32),('15844','2013-08-08','16:15:00',1.25),('15844','2013-08-08','16:20:00',1.2),('15844','2013-08-08','16:25:00',1.17),('15844','2013-08-08','16:30:00',1.12),('15844','2013-08-08','16:35:00',1.05),('15844','2013-08-07','08:40:00',1.08),('15844','2013-08-07','08:45:00',1.15),('15844','2013-08-07','08:50:00',1.25),('15844','2013-08-07','08:55:00',1.33),('15844','2013-08-07','09:00:00',1.38),('15844','2013-08-07','09:05:00',1.42),('15844','2013-08-07','09:10:00',1.45),('15844','2013-08-07','09:15:00',1.54),('15844','2013-08-07','09:20:00',1.67),('15844','2013-08-07','09:25:00',1.78),('15844','2013-08-07','09:30:00',1.89),('15844','2013-08-07','09:35:00',1.98),('15844','2013-08-07','09:40:00',2.08),('15844','2013-08-07','09:45:00',2.13),('15844','2013-08-07','09:50:00',2.18),('15844','2013-08-07','09:55:00',2.24),('15844','2013-08-07','10:00:00',2.42),('15844','2013-08-07','10:05:00',2.53),('15844','2013-08-07','10:10:00',2.6),('15844','2013-08-07','10:15:00',2.73),('15844','2013-08-07','10:20:00',2.82),('15844','2013-08-07','10:25:00',2.94),('15844','2013-08-07','10:30:00',2.99),('15844','2013-08-07','10:35:00',3.1),('15844','2013-08-07','10:40:00',3.14),('15844','2013-08-07','10:45:00',3.2),('15844','2013-08-07','10:50:00',3.3),('15844','2013-08-07','10:55:00',3.37),('15844','2013-08-07','11:00:00',3.48),('15844','2013-08-07','11:05:00',3.55),('15844','2013-08-07','11:10:00',3.59),('15844','2013-08-07','11:15:00',3.61),('15844','2013-08-07','11:20:00',3.62),('15844','2013-08-07','11:25:00',3.64),('15844','2013-08-07','11:30:00',3.66),('15844','2013-08-07','11:35:00',3.71),('15844','2013-08-07','11:40:00',3.73),('15844','2013-08-07','11:45:00',3.72),('15844','2013-08-07','11:50:00',3.69),('15844','2013-08-07','11:55:00',3.64),('15844','2013-08-07','12:00:00',3.69),('15844','2013-08-07','12:05:00',3.7),('15844','2013-08-07','12:10:00',3.74),('15844','2013-08-07','12:15:00',3.74),('15844','2013-08-07','12:20:00',3.65),('15844','2013-08-07','12:25:00',3.72),('15844','2013-08-07','12:30:00',3.71),('15844','2013-08-07','12:35:00',3.66),('15844','2013-08-07','12:40:00',3.68),('15844','2013-08-07','12:45:00',3.59),('15844','2013-08-07','12:50:00',3.72),('15844','2013-08-07','12:55:00',3.76),('15844','2013-08-07','13:00:00',3.72),('15844','2013-08-07','13:05:00',3.51),('15844','2013-08-07','13:10:00',3.74),('15844','2013-08-07','13:15:00',3.67),('15844','2013-08-07','13:20:00',3.68),('15844','2013-08-07','13:25:00',3.59),('15844','2013-08-07','13:30:00',3.56),('15844','2013-08-07','13:35:00',3.61),('15844','2013-08-07','13:40:00',3.59),('15844','2013-08-07','13:45:00',3.55),('15844','2013-08-07','13:50:00',3.52),('15844','2013-08-07','13:55:00',3.48),('15844','2013-08-07','14:00:00',3.44),('15844','2013-08-07','14:05:00',3.38),('15844','2013-08-07','14:10:00',3.29),('15844','2013-08-07','14:15:00',3.24),('15844','2013-08-07','14:20:00',3.19),('15844','2013-08-07','14:25:00',3.14),('15844','2013-08-07','14:30:00',3.07),('15844','2013-08-07','14:35:00',2.96),('15844','2013-08-07','14:40:00',2.89),('15844','2013-08-07','14:45:00',2.72),('15844','2013-08-07','14:50:00',2.66),('15844','2013-08-07','14:55:00',2.56),('15844','2013-08-07','15:00:00',2.51),('15844','2013-08-07','15:05:00',2.44),('15844','2013-08-07','15:10:00',2.33),('15844','2013-08-07','15:15:00',2.24),('15844','2013-08-07','15:20:00',2.17),('15844','2013-08-07','15:25:00',2.08),('15844','2013-08-07','15:30:00',2.02),('15844','2013-08-07','15:35:00',1.94),('15844','2013-08-07','15:40:00',1.87),('15844','2013-08-07','15:45:00',1.79),('15844','2013-08-07','15:50:00',1.69),('15844','2013-08-07','15:55:00',1.6),('15844','2013-08-07','16:00:00',1.5),('15844','2013-08-07','16:05:00',1.43),('15844','2013-08-07','16:10:00',1.35),('15844','2013-08-07','16:15:00',1.29),('15844','2013-08-07','16:20:00',1.25),('15844','2013-08-07','16:25:00',1.2),('15844','2013-08-07','16:30:00',1.13),('15844','2013-08-07','16:35:00',1.07),('15844','2013-08-07','16:40:00',1),('15844','2013-08-06','08:45:00',1.02),('15844','2013-08-06','08:50:00',1.13),('15844','2013-08-06','08:55:00',1.19),('15844','2013-08-06','09:00:00',1.22),('15844','2013-08-06','09:05:00',1.26),('15844','2013-08-06','09:10:00',1.31),('15844','2013-08-06','09:15:00',1.41),('15844','2013-08-06','09:20:00',1.67),('15844','2013-08-06','09:25:00',1.77),('15844','2013-08-06','09:30:00',1.86),('15844','2013-08-06','09:35:00',1.95),('15844','2013-08-06','09:40:00',2.06),('15844','2013-08-06','09:45:00',2.14),('15844','2013-08-06','09:50:00',2.18),('15844','2013-08-06','09:55:00',2.21),('15844','2013-08-06','10:00:00',2.42),('15844','2013-08-06','10:05:00',2.51),('15844','2013-08-06','10:10:00',2.62),('15844','2013-08-06','10:15:00',2.7),('15844','2013-08-06','10:20:00',2.82),('15844','2013-08-06','10:25:00',2.91),('15844','2013-08-06','10:30:00',3),('15844','2013-08-06','10:35:00',3.06),('15844','2013-08-06','10:40:00',3.13),('15844','2013-08-06','10:45:00',3.21),('15844','2013-08-06','10:50:00',3.32),('15844','2013-08-06','10:55:00',3.43),('15844','2013-08-06','11:00:00',3.52),('15844','2013-08-06','11:05:00',3.57),('15844','2013-08-06','11:10:00',3.6),('15844','2013-08-06','11:15:00',3.66),('15844','2013-08-06','11:20:00',3.69),('15844','2013-08-06','11:25:00',3.68),('15844','2013-08-06','11:30:00',3.73),('15844','2013-08-06','11:35:00',3.68),('15844','2013-08-06','11:40:00',3.67),('15844','2013-08-06','11:45:00',3.68),('15844','2013-08-06','11:50:00',3.66),('15844','2013-08-06','11:55:00',3.69),('15844','2013-08-06','12:00:00',3.72),('15844','2013-08-06','12:05:00',3.77),('15844','2013-08-06','12:10:00',3.77),('15844','2013-08-06','12:15:00',3.8),('15844','2013-08-06','12:20:00',3.78),('15844','2013-08-06','12:25:00',3.83),('15844','2013-08-06','12:30:00',3.8),('15844','2013-08-06','12:35:00',3.8),('15844','2013-08-06','12:40:00',3.84),('15844','2013-08-06','12:45:00',3.81),('15844','2013-08-06','12:50:00',3.79),('15844','2013-08-06','12:55:00',3.79),('15844','2013-08-06','13:00:00',3.77),('15844','2013-08-06','13:05:00',3.77),('15844','2013-08-06','13:10:00',3.73),('15844','2013-08-06','13:15:00',3.75),('15844','2013-08-06','13:20:00',3.73),('15844','2013-08-06','13:25:00',3.71),('15844','2013-08-06','13:30:00',3.69),('15844','2013-08-06','13:35:00',3.66),('15844','2013-08-06','13:40:00',3.65),('15844','2013-08-06','13:45:00',3.61),('15844','2013-08-06','13:50:00',3.56),('15844','2013-08-06','13:55:00',3.53),('15844','2013-08-06','14:00:00',3.49),('15844','2013-08-06','14:05:00',3.42),('15844','2013-08-06','14:10:00',3.36),('15844','2013-08-06','14:15:00',3.3),('15844','2013-08-06','14:20:00',3.24),('15844','2013-08-06','14:25:00',3.18),('15844','2013-08-06','14:30:00',3.13),('15844','2013-08-06','14:35:00',3.04),('15844','2013-08-06','14:40:00',2.95),('15844','2013-08-06','14:45:00',2.85),('15844','2013-08-06','14:50:00',2.76),('15844','2013-08-06','14:55:00',2.64),('15844','2013-08-06','15:00:00',2.54),('15844','2013-08-06','15:05:00',2.49),('15844','2013-08-06','15:10:00',2.43),('15844','2013-08-06','15:15:00',2.33),('15844','2013-08-06','15:20:00',2.23),('15844','2013-08-06','15:25:00',2.15),('15844','2013-08-06','15:30:00',2.07),('15844','2013-08-06','15:35:00',2),('15844','2013-08-06','15:40:00',1.92),('15844','2013-08-06','15:45:00',1.83),('15844','2013-08-06','15:50:00',1.73),('15844','2013-08-06','15:55:00',1.63),('15844','2013-08-06','16:00:00',1.56),('15844','2013-08-06','16:05:00',1.49),('15844','2013-08-06','16:10:00',1.41),('15844','2013-08-06','16:15:00',1.34),('15844','2013-08-06','16:20:00',1.29),('15844','2013-08-06','16:25:00',1.22),('15844','2013-08-06','16:30:00',1.16),('15844','2013-08-06','16:35:00',1.11),('15844','2013-08-06','16:40:00',1.03),('15844','2013-08-05','08:45:00',1.05),('15844','2013-08-05','08:50:00',1.14),('15844','2013-08-05','08:55:00',1.19),('15844','2013-08-05','09:00:00',1.23),('15844','2013-08-05','09:05:00',1.27),('15844','2013-08-05','09:10:00',1.32),('15844','2013-08-05','09:15:00',1.46),('15844','2013-08-05','09:20:00',1.69),('15844','2013-08-05','09:25:00',1.81),('15844','2013-08-05','09:30:00',1.92),('15844','2013-08-05','09:35:00',2),('15844','2013-08-05','09:40:00',2.08),('15844','2013-08-05','09:45:00',2.16),('15844','2013-08-05','09:50:00',2.24),('15844','2013-08-05','09:55:00',2.3),('15844','2013-08-05','10:00:00',2.46),('15844','2013-08-05','10:05:00',2.59),('15844','2013-08-05','10:10:00',2.68),('15844','2013-08-05','10:15:00',2.77),('15844','2013-08-05','10:20:00',2.95),('15844','2013-08-05','10:25:00',3.02),('15844','2013-08-05','10:30:00',3.1),('15844','2013-08-05','10:35:00',3.21),('15844','2013-08-05','10:40:00',3.24),('15844','2013-08-05','10:45:00',3.33),('15844','2013-08-05','10:50:00',3.45),('15844','2013-08-05','10:55:00',3.55),('15844','2013-08-05','11:00:00',3.63),('15844','2013-08-05','11:05:00',3.67),('15844','2013-08-05','11:10:00',3.72),('15844','2013-08-05','11:15:00',3.76),('15844','2013-08-05','11:20:00',3.81),('15844','2013-08-05','11:25:00',3.8),('15844','2013-08-05','11:30:00',3.86),('15844','2013-08-05','11:35:00',3.88),('15844','2013-08-05','11:40:00',3.89),('15844','2013-08-05','11:45:00',3.88),('15844','2013-08-05','11:50:00',3.91),('15844','2013-08-05','11:55:00',3.9),('15844','2013-08-05','12:00:00',3.9),('15844','2013-08-05','12:05:00',3.91),('15844','2013-08-05','12:10:00',3.9),('15844','2013-08-05','12:15:00',3.89),('15844','2013-08-05','12:20:00',3.89),('15844','2013-08-05','12:25:00',3.9),('15844','2013-08-05','12:30:00',3.8),('15844','2013-08-05','12:35:00',3.84),('15844','2013-08-05','12:40:00',3.84),('15844','2013-08-05','12:45:00',3.81),('15844','2013-08-05','12:50:00',3.81),('15844','2013-08-05','12:55:00',3.79),('15844','2013-08-05','13:00:00',3.77),('15844','2013-08-05','13:05:00',3.79),('15844','2013-08-05','13:10:00',3.71),('15844','2013-08-05','13:15:00',3.74),('15844','2013-08-05','13:20:00',3.7),('15844','2013-08-05','13:25:00',3.67),('15844','2013-08-05','13:30:00',3.64),('15844','2013-08-05','13:35:00',3.57),('15844','2013-08-05','13:40:00',3.56),('15844','2013-08-05','13:45:00',3.53),('15844','2013-08-05','13:50:00',3.53),('15844','2013-08-05','13:55:00',3.48),('15844','2013-08-05','14:00:00',3.44),('15844','2013-08-05','14:05:00',3.39),('15844','2013-08-05','14:10:00',3.31),('15844','2013-08-05','14:15:00',3.27),('15844','2013-08-05','14:20:00',3.2),('15844','2013-08-05','14:25:00',3.13),('15844','2013-08-05','14:30:00',3.06),('15844','2013-08-05','14:35:00',2.99),('15844','2013-08-05','14:40:00',2.9),('15844','2013-08-05','14:45:00',2.82),('15844','2013-08-05','14:50:00',2.69),('15844','2013-08-05','14:55:00',2.58),('15844','2013-08-05','15:00:00',2.46),('15844','2013-08-05','15:05:00',2.35),('15844','2013-08-05','15:10:00',2.23),('15844','2013-08-05','15:15:00',2.12),('15844','2013-08-05','15:20:00',2.08),('15844','2013-08-05','15:25:00',2.13),('15844','2013-08-05','15:30:00',2.08),('15844','2013-08-05','15:35:00',2.01),('15844','2013-08-05','15:40:00',1.93),('15844','2013-08-05','15:45:00',1.84),('15844','2013-08-05','15:50:00',1.74),('15844','2013-08-05','15:55:00',1.63),('15844','2013-08-05','16:00:00',1.55),('15844','2013-08-05','16:05:00',1.47),('15844','2013-08-05','16:10:00',1.4),('15844','2013-08-05','16:15:00',1.33),('15844','2013-08-05','16:20:00',1.28),('15844','2013-08-05','16:25:00',1.21),('15844','2013-08-05','16:30:00',1.14),('15844','2013-08-05','16:35:00',1.11),('15844','2013-08-05','16:40:00',1.02),('15844','2013-08-04','08:35:00',1.08),('15844','2013-08-04','08:40:00',1.16),('15844','2013-08-04','08:45:00',1.21),('15844','2013-08-04','08:50:00',1.29),('15844','2013-08-04','08:55:00',1.39),('15844','2013-08-04','09:00:00',1.46),('15844','2013-08-04','09:05:00',1.5),('15844','2013-08-04','09:10:00',1.56),('15844','2013-08-04','09:15:00',1.62),('15844','2013-08-04','09:20:00',1.72),('15844','2013-08-04','09:25:00',1.86),('15844','2013-08-04','09:30:00',2),('15844','2013-08-04','09:35:00',2.08),('15844','2013-08-04','09:40:00',2.17),('15844','2013-08-04','09:45:00',2.27),('15844','2013-08-04','09:50:00',2.35),('15844','2013-08-04','09:55:00',2.38),('15844','2013-08-04','10:00:00',2.57),('15844','2013-08-04','10:05:00',2.68),('15844','2013-08-04','10:10:00',2.8),('15844','2013-08-04','10:15:00',2.93),('15844','2013-08-04','10:20:00',3.04),('15844','2013-08-04','10:25:00',3.13),('15844','2013-08-04','10:30:00',3.2),('15844','2013-08-04','10:35:00',3.27),('15844','2013-08-04','10:40:00',3.38),('15844','2013-08-04','10:45:00',3.47),('15844','2013-08-04','10:50:00',3.58),('15844','2013-08-04','10:55:00',3.72),('15844','2013-08-04','11:00:00',3.8),('15844','2013-08-04','11:05:00',3.86),('15844','2013-08-04','11:10:00',3.95),('15844','2013-08-04','11:15:00',3.98),('15844','2013-08-04','11:20:00',4.02),('15844','2013-08-04','11:25:00',4.03),('15844','2013-08-04','11:30:00',4.04),('15844','2013-08-04','11:35:00',4.02),('15844','2013-08-04','11:40:00',4.01),('15844','2013-08-04','11:45:00',4.07),('15844','2013-08-04','11:50:00',4.07),('15844','2013-08-04','11:55:00',4.06),('15844','2013-08-04','12:00:00',4.05),('15844','2013-08-04','12:05:00',4.08),('15844','2013-08-04','12:10:00',4.05),('15844','2013-08-04','12:15:00',4.03),('15844','2013-08-04','12:20:00',4.03),('15844','2013-08-04','12:25:00',3.98),('15844','2013-08-04','12:30:00',4.02),('15844','2013-08-04','12:35:00',4.02),('15844','2013-08-04','12:40:00',4.02),('15844','2013-08-04','12:45:00',3.98),('15844','2013-08-04','12:50:00',3.99),('15844','2013-08-04','12:55:00',3.95),('15844','2013-08-04','13:00:00',3.93),('15844','2013-08-04','13:05:00',3.91),('15844','2013-08-04','13:10:00',3.86),('15844','2013-08-04','13:15:00',3.85),('15844','2013-08-04','13:20:00',3.86),('15844','2013-08-04','13:25:00',3.84),('15844','2013-08-04','13:30:00',3.81),('15844','2013-08-04','13:35:00',3.79),('15844','2013-08-04','13:40:00',3.76),('15844','2013-08-04','13:45:00',3.76),('15844','2013-08-04','13:50:00',3.72),('15844','2013-08-04','13:55:00',3.67),('15844','2013-08-04','14:00:00',3.61),('15844','2013-08-04','14:05:00',3.54),('15844','2013-08-04','14:10:00',3.48),('15844','2013-08-04','14:15:00',3.41),('15844','2013-08-04','14:20:00',3.34),('15844','2013-08-04','14:25:00',3.28),('15844','2013-08-04','14:30:00',3.18),('15844','2013-08-04','14:35:00',3.07),('15844','2013-08-04','14:40:00',3.01),('15844','2013-08-04','14:45:00',2.91),('15844','2013-08-04','14:50:00',2.78),('15844','2013-08-04','14:55:00',2.66),('15844','2013-08-04','15:00:00',2.55),('15844','2013-08-04','15:05:00',2.42),('15844','2013-08-04','15:10:00',2.3),('15844','2013-08-04','15:15:00',2.22),('15844','2013-08-04','15:20:00',2.12),('15844','2013-08-04','15:25:00',2.03),('15844','2013-08-04','15:30:00',2.14),('15844','2013-08-04','15:35:00',2.08),('15844','2013-08-04','15:40:00',2.01),('15844','2013-08-04','15:45:00',1.93),('15844','2013-08-04','15:50:00',1.8),('15844','2013-08-04','15:55:00',1.69),('15844','2013-08-04','16:00:00',1.59),('15844','2013-08-04','16:05:00',1.51),('15844','2013-08-04','16:10:00',1.42),('15844','2013-08-04','16:15:00',1.36),('15844','2013-08-04','16:20:00',1.29),('15844','2013-08-04','16:25:00',1.2),('15844','2013-08-04','16:30:00',1.15),('15844','2013-08-04','16:35:00',1.1),('15844','2013-08-04','16:40:00',1.01),('15844','2013-08-03','08:35:00',1.08),('15844','2013-08-03','08:40:00',1.17),('15844','2013-08-03','08:45:00',1.22),('15844','2013-08-03','08:50:00',1.3),('15844','2013-08-03','08:55:00',1.38),('15844','2013-08-03','09:00:00',1.47),('15844','2013-08-03','09:05:00',1.53),('15844','2013-08-03','09:10:00',1.58),('15844','2013-08-03','09:15:00',1.65),('15844','2013-08-03','09:20:00',1.73),('15844','2013-08-03','09:25:00',1.85),('15844','2013-08-03','09:30:00',2),('15844','2013-08-03','09:35:00',2.1),('15844','2013-08-03','09:40:00',2.2),('15844','2013-08-03','09:45:00',2.27),('15844','2013-08-03','09:50:00',2.34),('15844','2013-08-03','09:55:00',2.4),('15844','2013-08-03','10:00:00',2.57),('15844','2013-08-03','10:05:00',2.67),('15844','2013-08-03','10:10:00',2.79),('15844','2013-08-03','10:15:00',2.93),('15844','2013-08-03','10:20:00',3.08),('15844','2013-08-03','10:25:00',3.19),('15844','2013-08-03','10:30:00',3.3),('15844','2013-08-03','10:35:00',3.33),('15844','2013-08-03','10:40:00',3.42),('15844','2013-08-03','10:45:00',3.51),('15844','2013-08-03','10:50:00',3.59),('15844','2013-08-03','10:55:00',3.67),('15844','2013-08-03','11:00:00',3.71),('15844','2013-08-03','11:05:00',3.78),('15844','2013-08-03','11:10:00',3.81),('15844','2013-08-03','11:15:00',3.85),('15844','2013-08-03','11:20:00',3.78),('15844','2013-08-03','11:25:00',3.77),('15844','2013-08-03','11:30:00',3.69),('15844','2013-08-03','11:35:00',3.75),('15844','2013-08-03','11:40:00',3.9),('15844','2013-08-03','11:45:00',3.85),('15844','2013-08-03','11:50:00',3.91),('15844','2013-08-03','11:55:00',3.9),('15844','2013-08-03','12:00:00',3.94),('15844','2013-08-03','12:05:00',3.95),('15844','2013-08-03','12:10:00',3.95),('15844','2013-08-03','12:15:00',3.94),('15844','2013-08-03','12:20:00',3.93),('15844','2013-08-03','12:25:00',3.94),('15844','2013-08-03','12:30:00',3.96),('15844','2013-08-03','12:35:00',3.9),('15844','2013-08-03','12:40:00',3.88),('15844','2013-08-03','12:45:00',3.85),('15844','2013-08-03','12:50:00',3.84),('15844','2013-08-03','12:55:00',3.81),('15844','2013-08-03','13:00:00',3.84),('15844','2013-08-03','13:05:00',3.84),('15844','2013-08-03','13:10:00',3.81),('15844','2013-08-03','13:15:00',3.8),('15844','2013-08-03','13:20:00',3.76),('15844','2013-08-03','13:25:00',3.73),('15844','2013-08-03','13:30:00',3.68),('15844','2013-08-03','13:35:00',3.61),('15844','2013-08-03','13:40:00',3.53),('15844','2013-08-03','13:45:00',3.43),('15844','2013-08-03','13:50:00',3.41),('15844','2013-08-03','13:55:00',3.47),('15844','2013-08-03','14:00:00',3.45),('15844','2013-08-03','14:05:00',3.45),('15844','2013-08-03','14:10:00',3.41),('15844','2013-08-03','14:15:00',3.3),('15844','2013-08-03','14:20:00',3.21),('15844','2013-08-03','14:25:00',3.15),('15844','2013-08-03','14:30:00',3.1),('15844','2013-08-03','14:35:00',3.05),('15844','2013-08-03','14:40:00',2.97),('15844','2013-08-03','14:45:00',2.88),('15844','2013-08-03','14:50:00',2.75),('15844','2013-08-03','14:55:00',2.64),('15844','2013-08-03','15:00:00',2.53),('15844','2013-08-03','15:05:00',2.4),('15844','2013-08-03','15:10:00',2.29),('15844','2013-08-03','15:15:00',2.18),('15844','2013-08-03','15:20:00',2.07),('15844','2013-08-03','15:25:00',2.01),('15844','2013-08-03','15:30:00',2.09),('15844','2013-08-03','15:35:00',2.04),('15844','2013-08-03','15:40:00',1.96),('15844','2013-08-03','15:45:00',1.86),('15844','2013-08-03','15:50:00',1.78),('15844','2013-08-03','15:55:00',1.67),('15844','2013-08-03','16:00:00',1.59),('15844','2013-08-03','16:05:00',1.51),('15844','2013-08-03','16:10:00',1.4),('15844','2013-08-03','16:15:00',1.34),('15844','2013-08-03','16:20:00',1.27),('15844','2013-08-03','16:25:00',1.19),('15844','2013-08-03','16:30:00',1.13),('15844','2013-08-03','16:35:00',1.07),('15844','2013-08-02','08:35:00',1.1),('15844','2013-08-02','08:40:00',1.21),('15844','2013-08-02','08:45:00',1.27),('15844','2013-08-02','08:50:00',1.35),('15844','2013-08-02','08:55:00',1.42),('15844','2013-08-02','09:00:00',1.51),('15844','2013-08-02','09:05:00',1.58),('15844','2013-08-02','09:10:00',1.64),('15844','2013-08-02','09:15:00',1.71),('15844','2013-08-02','09:20:00',1.8),('15844','2013-08-02','09:25:00',1.91),('15844','2013-08-02','09:30:00',2.02),('15844','2013-08-02','09:35:00',2.16),('15844','2013-08-02','09:40:00',2.25),('15844','2013-08-02','09:45:00',2.32),('15844','2013-08-02','09:50:00',2.38),('15844','2013-08-02','09:55:00',2.45),('15844','2013-08-02','10:00:00',2.63),('15844','2013-08-02','10:05:00',2.76),('15844','2013-08-02','10:10:00',2.83),('15844','2013-08-02','10:15:00',2.89),('15844','2013-08-02','10:20:00',3.03),('15844','2013-08-02','10:25:00',3.21),('15844','2013-08-02','10:30:00',3.33),('15844','2013-08-02','10:35:00',3.38),('15844','2013-08-02','10:40:00',3.49),('15844','2013-08-02','10:45:00',3.56),('15844','2013-08-02','10:50:00',3.63),('15844','2013-08-02','10:55:00',3.77),('15844','2013-08-02','11:00:00',3.87),('15844','2013-08-02','11:05:00',3.9),('15844','2013-08-02','11:10:00',3.92),('15844','2013-08-02','11:15:00',3.96),('15844','2013-08-02','11:20:00',4),('15844','2013-08-02','11:25:00',4.03),('15844','2013-08-02','11:30:00',4.02),('15844','2013-08-02','11:35:00',4.04),('15844','2013-08-02','11:40:00',4.05),('15844','2013-08-02','11:45:00',4.06),('15844','2013-08-02','11:50:00',4.07),('15844','2013-08-02','11:55:00',4.09),('15844','2013-08-02','12:00:00',4.07),('15844','2013-08-02','12:05:00',4.07),('15844','2013-08-02','12:10:00',4.08),('15844','2013-08-02','12:15:00',4.11),('15844','2013-08-02','12:20:00',4.15),('15844','2013-08-02','12:25:00',4.12),('15844','2013-08-02','12:30:00',4.08),('15844','2013-08-02','12:35:00',4.03),('15844','2013-08-02','12:40:00',4),('15844','2013-08-02','12:45:00',3.99),('15844','2013-08-02','12:50:00',3.95),('15844','2013-08-02','12:55:00',3.96),('15844','2013-08-02','13:00:00',3.95),('15844','2013-08-02','13:05:00',3.93),('15844','2013-08-02','13:10:00',3.9),('15844','2013-08-02','13:15:00',3.86),('15844','2013-08-02','13:20:00',3.85),('15844','2013-08-02','13:25:00',3.81),('15844','2013-08-02','13:30:00',3.74),('15844','2013-08-02','13:35:00',3.73),('15844','2013-08-02','13:40:00',3.77),('15844','2013-08-02','13:45:00',3.76),('15844','2013-08-02','13:50:00',3.69),('15844','2013-08-02','13:55:00',3.61),('15844','2013-08-02','14:00:00',3.55),('15844','2013-08-02','14:05:00',3.52),('15844','2013-08-02','14:10:00',3.51),('15844','2013-08-02','14:15:00',3.38),('15844','2013-08-02','14:20:00',3.34),('15844','2013-08-02','14:25:00',3.21),('15844','2013-08-02','14:30:00',3.2),('15844','2013-08-02','14:35:00',3.08),('15844','2013-08-02','14:40:00',2.99),('15844','2013-08-02','14:45:00',2.88),('15844','2013-08-02','14:50:00',2.73),('15844','2013-08-02','14:55:00',2.65),('15844','2013-08-02','15:00:00',2.55),('15844','2013-08-02','15:05:00',2.45),('15844','2013-08-02','15:10:00',2.33),('15844','2013-08-02','15:15:00',2.23),('15844','2013-08-02','15:20:00',2.14),('15844','2013-08-02','15:25:00',2.06),('15844','2013-08-02','15:30:00',1.99),('15844','2013-08-02','15:35:00',1.96),('15844','2013-08-02','15:40:00',1.93),('15844','2013-08-02','15:45:00',1.88),('15844','2013-08-02','15:50:00',1.82),('15844','2013-08-02','15:55:00',1.72),('15844','2013-08-02','16:00:00',1.62),('15844','2013-08-02','16:05:00',1.51),('15844','2013-08-02','16:10:00',1.42),('15844','2013-08-02','16:15:00',1.34),('15844','2013-08-02','16:20:00',1.28),('15844','2013-08-02','16:25:00',1.22),('15844','2013-08-02','16:30:00',1.16),('15844','2013-08-02','16:35:00',1.11),('15844','2013-08-02','16:40:00',1.04),('15844','2013-08-01','08:35:00',1.13),('15844','2013-08-01','08:40:00',1.24),('15844','2013-08-01','08:45:00',1.3),('15844','2013-08-01','08:50:00',1.37),('15844','2013-08-01','08:55:00',1.43),('15844','2013-08-01','09:00:00',1.5),('15844','2013-08-01','09:05:00',1.61),('15844','2013-08-01','09:10:00',1.69),('15844','2013-08-01','09:15:00',1.77),('15844','2013-08-01','09:20:00',1.86),('15844','2013-08-01','09:25:00',1.96),('15844','2013-08-01','09:30:00',2.06),('15844','2013-08-01','09:35:00',2.21),('15844','2013-08-01','09:40:00',2.34),('15844','2013-08-01','09:45:00',2.45),('15844','2013-08-01','09:50:00',2.53),('15844','2013-08-01','09:55:00',2.6),('15844','2013-08-01','10:00:00',2.8),('15844','2013-08-01','10:05:00',2.91),('15844','2013-08-01','10:10:00',3.01),('15844','2013-08-01','10:15:00',3.09),('15844','2013-08-01','10:20:00',3.2),('15844','2013-08-01','10:25:00',3.39),('15844','2013-08-01','10:30:00',3.57),('15844','2013-08-01','10:35:00',3.63),('15844','2013-08-01','10:40:00',3.72),('15844','2013-08-01','10:45:00',3.78),('15844','2013-08-01','10:50:00',3.86),('15844','2013-08-01','10:55:00',3.99),('15844','2013-08-01','11:00:00',4.08),('15844','2013-08-01','11:05:00',4.16),('15844','2013-08-01','11:10:00',4.21),('15844','2013-08-01','11:15:00',4.25),('15844','2013-08-01','11:20:00',4.27),('15844','2013-08-01','11:25:00',4.27),('15844','2013-08-01','11:30:00',4.3),('15844','2013-08-01','11:35:00',4.29),('15844','2013-08-01','11:40:00',4.28),('15844','2013-08-01','11:45:00',4.28),('15844','2013-08-01','11:50:00',4.29),('15844','2013-08-01','11:55:00',4.31),('15844','2013-08-01','12:00:00',4.3),('15844','2013-08-01','12:05:00',4.28),('15844','2013-08-01','12:10:00',4.29),('15844','2013-08-01','12:15:00',4.28),('15844','2013-08-01','12:20:00',4.28),('15844','2013-08-01','12:25:00',4.33),('15844','2013-08-01','12:30:00',4.3),('15844','2013-08-01','12:35:00',4.26),('15844','2013-08-01','12:40:00',4.24),('15844','2013-08-01','12:45:00',4.25),('15844','2013-08-01','12:50:00',4.25),('15844','2013-08-01','12:55:00',4.23),('15844','2013-08-01','13:00:00',3.85),('15844','2013-08-01','13:05:00',4.2),('15844','2013-08-01','13:10:00',4.18),('15844','2013-08-01','13:15:00',4.2),('15844','2013-08-01','13:20:00',4.12),('15844','2013-08-01','13:25:00',4.08),('15844','2013-08-01','13:30:00',4.04),('15844','2013-08-01','13:35:00',4),('15844','2013-08-01','13:40:00',3.96),('15844','2013-08-01','13:45:00',3.96),('15844','2013-08-01','13:50:00',3.94),('15844','2013-08-01','13:55:00',3.87),('15844','2013-08-01','14:00:00',3.78),('15844','2013-08-01','14:05:00',3.74),('15844','2013-08-01','14:10:00',3.65),('15844','2013-08-01','14:15:00',3.59),('15844','2013-08-01','14:20:00',3.5),('15844','2013-08-01','14:25:00',3.44),('15844','2013-08-01','14:30:00',3.33),('15844','2013-08-01','14:35:00',3.19),('15844','2013-08-01','14:40:00',3.1),('15844','2013-08-01','14:45:00',3.01),('15844','2013-08-01','14:50:00',2.89),('15844','2013-08-01','14:55:00',2.75),('15844','2013-08-01','15:00:00',2.6),('15844','2013-08-01','15:05:00',2.52),('15844','2013-08-01','15:10:00',2.4),('15844','2013-08-01','15:15:00',2.37),('15844','2013-08-01','15:20:00',2.4),('15844','2013-08-01','15:25:00',2.34),('15844','2013-08-01','15:30:00',2.25),('15844','2013-08-01','15:35:00',2.14),('15844','2013-08-01','15:40:00',2.11),('15844','2013-08-01','15:45:00',1.99),('15844','2013-08-01','15:50:00',1.87),('15844','2013-08-01','15:55:00',1.76),('15844','2013-08-01','16:00:00',1.66),('15844','2013-08-01','16:05:00',1.56),('15844','2013-08-01','16:10:00',1.47),('15844','2013-08-01','16:15:00',1.37),('15844','2013-08-01','16:20:00',1.28),('15844','2013-08-01','16:25:00',1.24),('15844','2013-08-01','16:30:00',1.18),('15844','2013-08-01','16:35:00',1.12),('15844','2013-08-01','16:40:00',1.03),('15844','2013-08-01','16:45:00',1.01),('15844','2013-07-31','08:35:00',1.12),('15844','2013-07-31','08:40:00',1.27),('15844','2013-07-31','08:45:00',1.32),('15844','2013-07-31','08:50:00',1.41),('15844','2013-07-31','08:55:00',1.47),('15844','2013-07-31','09:00:00',1.52),('15844','2013-07-31','09:05:00',1.6),('15844','2013-07-31','09:10:00',1.68),('15844','2013-07-31','09:15:00',1.75),('15844','2013-07-31','09:20:00',1.85),('15844','2013-07-31','09:25:00',1.96),('15844','2013-07-31','09:30:00',2.07),('15844','2013-07-31','09:35:00',2.15),('15844','2013-07-31','09:40:00',2.32),('15844','2013-07-31','09:45:00',2.42),('15844','2013-07-31','09:50:00',2.5),('15844','2013-07-31','09:55:00',2.55),('15844','2013-07-31','10:00:00',2.74),('15844','2013-07-31','10:05:00',2.85),('15844','2013-07-31','10:10:00',2.96),('15844','2013-07-31','10:15:00',3.03),('15844','2013-07-31','10:20:00',3.14),('15844','2013-07-31','10:25:00',3.28),('15844','2013-07-31','10:30:00',3.46),('15844','2013-07-31','10:35:00',3.55),('15844','2013-07-31','10:40:00',3.62),('15844','2013-07-31','10:45:00',3.75),('15844','2013-07-31','10:50:00',3.85),('15844','2013-07-31','10:55:00',3.96),('15844','2013-07-31','11:00:00',4),('15844','2013-07-31','11:05:00',4.05),('15844','2013-07-31','11:10:00',4.09),('15844','2013-07-31','11:15:00',4.14),('15844','2013-07-31','11:20:00',4.17),('15844','2013-07-31','11:25:00',4.18),('15844','2013-07-31','11:30:00',4.21),('15844','2013-07-31','11:35:00',4.24),('15844','2013-07-31','11:40:00',4.26),('15844','2013-07-31','11:45:00',4.26),('15844','2013-07-31','11:50:00',4.32),('15844','2013-07-31','11:55:00',4.28),('15844','2013-07-31','12:00:00',4.28),('15844','2013-07-31','12:05:00',4.27),('15844','2013-07-31','12:10:00',4.3),('15844','2013-07-31','12:15:00',4.36),('15844','2013-07-31','12:20:00',4.42),('15844','2013-07-31','12:25:00',4.36),('15844','2013-07-31','12:30:00',4.34),('15844','2013-07-31','12:35:00',4.35),('15844','2013-07-31','12:40:00',4.34),('15844','2013-07-31','12:45:00',4.06),('15844','2013-07-31','12:50:00',4.3),('15844','2013-07-31','12:55:00',4.25),('15844','2013-07-31','13:00:00',4.2),('15844','2013-07-31','13:05:00',4.16),('15844','2013-07-31','13:10:00',4.16),('15844','2013-07-31','13:15:00',4.12),('15844','2013-07-31','13:20:00',4.15),('15844','2013-07-31','13:25:00',4.12),('15844','2013-07-31','13:30:00',4.06),('15844','2013-07-31','13:35:00',4.02),('15844','2013-07-31','13:40:00',3.99),('15844','2013-07-31','13:45:00',3.94),('15844','2013-07-31','13:50:00',3.92),('15844','2013-07-31','13:55:00',3.91),('15844','2013-07-31','14:00:00',3.74),('15844','2013-07-31','14:05:00',3.79),('15844','2013-07-31','14:10:00',3.66),('15844','2013-07-31','14:15:00',3.66),('15844','2013-07-31','14:20:00',3.5),('15844','2013-07-31','14:25:00',3.43),('15844','2013-07-31','14:30:00',3.45),('15844','2013-07-31','14:35:00',1.61),('15844','2013-07-31','14:40:00',3.28),('15844','2013-07-31','14:45:00',3.14),('15844','2013-07-31','14:50:00',3.04),('15844','2013-07-31','14:55:00',2.95),('15844','2013-07-31','15:00:00',2.87),('15844','2013-07-31','15:05:00',2.76),('15844','2013-07-31','15:10:00',2.66),('15844','2013-07-31','15:15:00',2.56),('15844','2013-07-31','15:20:00',2.46),('15844','2013-07-31','15:25:00',2.33),('15844','2013-07-31','15:30:00',2.27),('15844','2013-07-31','15:35:00',1.84),('15844','2013-07-31','15:40:00',2.03),('15844','2013-07-31','15:45:00',1.98),('15844','2013-07-31','15:50:00',1.87),('15844','2013-07-31','15:55:00',1.78),('15844','2013-07-31','16:00:00',1.69),('15844','2013-07-31','16:05:00',1.57),('15844','2013-07-31','16:10:00',1.47),('15844','2013-07-31','16:15:00',1.26),('15844','2013-07-31','16:25:00',1.16),('15844','2013-07-31','16:30:00',1.25),('15844','2013-07-31','16:35:00',1.16),('15844','2013-07-31','16:40:00',1.07),('15844','2014-04-08','08:45:00',1.06),('15844','2014-04-08','08:50:00',1.19),('15844','2014-04-08','08:55:00',1.29),('15844','2014-04-08','09:00:00',1.37),('15844','2014-04-08','09:05:00',1.48),('15844','2014-04-08','09:10:00',1.58),('15844','2014-04-08','09:15:00',1.73),('15844','2014-04-08','09:20:00',1.82),('15844','2014-04-08','09:25:00',1.92),('15844','2014-04-08','09:30:00',1.98),('15844','2014-04-08','09:35:00',2.05),('15844','2014-04-08','09:40:00',2.12),('15844','2014-04-08','09:45:00',2.23),('15844','2014-04-08','09:50:00',2.26),('15844','2014-04-08','09:55:00',2.25),('15844','2014-04-08','10:00:00',2.38),('15844','2014-04-08','10:05:00',2.55),('15844','2014-04-08','10:10:00',2.66),('15844','2014-04-08','10:15:00',2.7),('15844','2014-04-08','10:20:00',2.78),('15844','2014-04-08','10:25:00',2.83),('15844','2014-04-08','10:30:00',2.85),('15844','2014-04-08','10:35:00',2.96),('15844','2014-04-08','10:40:00',3.1),('15844','2014-04-08','10:45:00',3.16),('15844','2014-04-08','10:50:00',3.25),('15844','2014-04-08','10:55:00',3.36),('15844','2014-04-08','11:00:00',3.47),('15844','2014-04-08','11:05:00',3.48),('15844','2014-04-08','11:10:00',3.57),('15844','2014-04-08','11:15:00',3.58),('15844','2014-04-08','11:20:00',3.52),('15844','2014-04-08','11:25:00',3.6),('15844','2014-04-08','11:30:00',3.48),('15844','2014-04-08','11:35:00',3.66),('15844','2014-04-08','11:40:00',3.71),('15844','2014-04-08','11:45:00',3.67),('15844','2014-04-08','11:50:00',3.71),('15844','2014-04-08','11:55:00',3.68),('15844','2014-04-08','12:00:00',3.57),('15844','2014-04-08','12:05:00',3.57),('15844','2014-04-08','12:10:00',3.43),('15844','2014-04-08','12:15:00',3.08),('15844','2014-04-08','12:20:00',3.27),('15844','2014-04-08','12:25:00',3.68),('15844','2014-04-08','12:30:00',2.85),('15844','2014-04-08','12:35:00',3.48),('15844','2014-04-08','12:40:00',3.27),('15844','2014-04-08','12:45:00',3.57),('15844','2014-04-08','12:50:00',3.54),('15844','2014-04-08','12:55:00',3.53),('15844','2014-04-08','13:00:00',3.57),('15844','2014-04-08','13:05:00',3.86),('15844','2014-04-08','13:10:00',3.67),('15844','2014-04-08','13:15:00',3.7),('15844','2014-04-08','13:20:00',3.71),('15844','2014-04-08','13:25:00',3.7),('15844','2014-04-08','13:30:00',3.63),('15844','2014-04-08','13:35:00',3.58),('15844','2014-04-08','13:40:00',3.51),('15844','2014-04-08','13:45:00',3.5),('15844','2014-04-08','13:50:00',3.39),('15844','2014-04-08','13:55:00',3.31),('15844','2014-04-08','14:00:00',3.26),('15844','2014-04-08','14:05:00',3.26),('15844','2014-04-08','14:10:00',3.27),('15844','2014-04-08','14:15:00',3.18),('15844','2014-04-08','14:20:00',2.85),('15844','2014-04-08','14:25:00',2.31),('15844','2014-04-08','14:30:00',2.8),('15844','2014-04-08','14:35:00',2.6),('15844','2014-04-08','14:40:00',2.14),('15844','2014-04-08','14:45:00',2.55),('15844','2014-04-08','14:50:00',2.56),('15844','2014-04-08','14:55:00',2.42),('15844','2014-04-08','15:00:00',2.31),('15844','2014-04-08','15:05:00',2.24),('15844','2014-04-08','15:10:00',2.12),('15844','2014-04-08','15:15:00',1.93),('15844','2014-04-08','15:20:00',1.93),('15844','2014-04-08','15:25:00',1.87),('15844','2014-04-08','15:30:00',1.76),('15844','2014-04-08','15:35:00',1.65),('15844','2014-04-08','15:40:00',1.48),('15844','2014-04-08','15:45:00',1.46),('15844','2014-04-08','15:50:00',1.35),('15844','2014-04-08','15:55:00',1.27),('15844','2014-04-08','16:00:00',1.21),('15844','2014-04-08','16:05:00',1.21),('15844','2014-04-08','16:10:00',1.14),('15844','2014-04-08','16:15:00',1.07),('15844','2014-04-08','16:20:00',1.02),('15844','2013-07-30','08:35:00',1.06),('15844','2013-07-30','08:40:00',1.12),('15844','2013-07-30','08:45:00',1.17),('15844','2013-07-30','09:10:00',1.37),('15844','2013-07-30','09:15:00',1.83),('15844','2013-07-30','09:20:00',1.89),('15844','2013-07-30','09:25:00',1.59),('15844','2013-07-30','09:30:00',1.59),('15844','2013-07-30','09:35:00',1.97),('15844','2013-07-30','09:40:00',1.03),('15844','2013-07-30','10:00:00',1.71),('15844','2013-07-30','10:10:00',3.18),('15844','2013-07-30','10:15:00',3.36),('15844','2013-07-30','10:20:00',3.54),('15844','2013-07-30','10:25:00',3.58),('15844','2013-07-30','10:30:00',3.54),('15844','2013-07-30','10:35:00',3.62),('15844','2013-07-30','10:40:00',3.77),('15844','2013-07-30','10:45:00',3.85),('15844','2013-07-30','10:50:00',3.88),('15844','2013-07-30','10:55:00',3.94),('15844','2013-07-30','11:00:00',4),('15844','2013-07-30','11:05:00',4.11),('15844','2013-07-30','11:10:00',4.17),('15844','2013-07-30','11:15:00',3.66),('15844','2013-07-30','11:25:00',1.16),('15844','2013-07-30','11:50:00',3.98),('15844','2013-07-30','11:55:00',3.7),('15844','2013-07-30','12:00:00',2.46),('15844','2013-07-30','12:05:00',4.21),('15844','2013-07-30','12:10:00',4.39),('15844','2013-07-30','12:15:00',4.22),('15844','2013-07-30','12:20:00',3.6),('15844','2013-07-30','12:25:00',3.67),('15844','2013-07-30','12:30:00',4.27),('15844','2013-07-30','12:35:00',4.3),('15844','2013-07-30','12:40:00',4.24),('15844','2013-07-30','12:45:00',4.28),('15844','2013-07-30','12:50:00',3.31),('15844','2013-07-30','12:55:00',4.47),('15844','2013-07-30','13:00:00',4.33),('15844','2013-07-30','13:05:00',4.09),('15844','2013-07-30','13:10:00',4.23),('15844','2013-07-30','13:15:00',4.16),('15844','2013-07-30','13:20:00',4.13),('15844','2013-07-30','13:25:00',4.09),('15844','2013-07-30','13:30:00',4.01),('15844','2013-07-30','13:35:00',4.02),('15844','2013-07-30','13:40:00',4.08),('15844','2013-07-30','13:45:00',3.92),('15844','2013-07-30','13:50:00',3.85),('15844','2013-07-30','13:55:00',3.77),('15844','2013-07-30','14:00:00',3.79),('15844','2013-07-30','14:05:00',3.61),('15844','2013-07-30','14:10:00',3.54),('15844','2013-07-30','14:15:00',3.52),('15844','2013-07-30','14:20:00',3.38),('15844','2013-07-30','14:25:00',3.36),('15844','2013-07-30','14:30:00',3.25),('15844','2013-07-30','14:35:00',3.14),('15844','2013-07-30','14:40:00',2.88),('15844','2013-07-30','14:45:00',3),('15844','2013-07-30','14:50:00',2.92),('15844','2013-07-30','14:55:00',2.81),('15844','2013-07-30','15:00:00',2.67),('15844','2013-07-30','15:05:00',2.55),('15844','2013-07-30','15:10:00',2.46),('15844','2013-07-30','15:15:00',2.37),('15844','2013-07-30','15:20:00',2.28),('15844','2013-07-30','15:25:00',2.2),('15844','2013-07-30','15:30:00',2.13),('15844','2013-07-30','15:35:00',2.07),('15844','2013-07-30','15:40:00',2.05),('15844','2013-07-30','15:45:00',1.99),('15844','2013-07-30','15:50:00',1.91),('15844','2013-07-30','15:55:00',1.8),('15844','2013-07-30','16:00:00',1.68),('15844','2013-07-30','16:05:00',1.56),('15844','2013-07-30','16:10:00',1.51),('15844','2013-07-30','16:15:00',1.43),('15844','2013-07-30','16:20:00',1.35),('15844','2013-07-30','16:25:00',1.29),('15844','2013-07-30','16:30:00',1.25),('15844','2013-07-30','16:35:00',1.19),('15844','2013-07-30','16:40:00',1.11),('15844','2013-07-30','16:45:00',1.03),('15844','2013-07-29','08:40:00',1.03),('15844','2013-07-29','08:45:00',1.16),('15844','2013-07-29','08:50:00',1.26),('15844','2013-07-29','08:55:00',1.39),('15844','2013-07-29','09:00:00',1.43),('15844','2013-07-29','09:05:00',1.46),('15844','2013-07-29','09:10:00',1.55),('15844','2013-07-29','09:15:00',1.64),('15844','2013-07-29','09:20:00',1.71),('15844','2013-07-29','09:25:00',1.82),('15844','2013-07-29','09:30:00',1.88),('15844','2013-07-29','09:35:00',1.97),('15844','2013-07-29','09:40:00',2.13),('15844','2013-07-29','09:45:00',2.22),('15844','2013-07-29','09:50:00',2.26),('15844','2013-07-29','09:55:00',2.39),('15844','2013-07-29','10:00:00',2.53),('15844','2013-07-29','10:05:00',2.64),('15844','2013-07-29','10:10:00',2.73),('15844','2013-07-29','10:15:00',2.88),('15844','2013-07-29','10:20:00',2.99),('15844','2013-07-29','10:25:00',3.09),('15844','2013-07-29','10:30:00',3.2),('15844','2013-07-29','10:35:00',3.27),('15844','2013-07-29','10:40:00',3.28),('15844','2013-07-29','10:45:00',3.34),('15844','2013-07-29','10:50:00',3.49),('15844','2013-07-29','10:55:00',3.62),('15844','2013-07-29','11:00:00',3.68),('15844','2013-07-29','11:05:00',3.78),('15844','2013-07-29','11:10:00',3.81),('15844','2013-07-29','11:15:00',3.82),('15844','2013-07-29','11:20:00',3.82),('15844','2013-07-29','11:25:00',3.86),('15844','2013-07-29','11:30:00',3.88),('15844','2013-07-29','11:35:00',3.9),('15844','2013-07-29','11:40:00',3.89),('15844','2013-07-29','11:45:00',3.9),('15844','2013-07-29','11:50:00',3.93),('15844','2013-07-29','11:55:00',3.96),('15844','2013-07-29','12:00:00',3.93),('15844','2013-07-29','12:05:00',3.96),('15844','2013-07-29','12:10:00',3.95),('15844','2013-07-29','12:15:00',3.98),('15844','2013-07-29','12:20:00',3.98),('15844','2013-07-29','12:25:00',3.94),('15844','2013-07-29','12:30:00',3.94),('15844','2013-07-29','12:35:00',3.92),('15844','2013-07-29','12:40:00',3.93),('15844','2013-07-29','12:45:00',3.86),('15844','2013-07-29','12:50:00',3.8),('15844','2013-07-29','12:55:00',3.87),('15844','2013-07-29','13:00:00',3.91),('15844','2013-07-29','13:05:00',3.89),('15844','2013-07-29','13:10:00',3.88),('15844','2013-07-29','13:15:00',3.85),('15844','2013-07-29','13:20:00',3.88),('15844','2013-07-29','13:25:00',3.85),('15844','2013-07-29','13:30:00',3.82),('15844','2013-07-29','13:35:00',3.79),('15844','2013-07-29','13:40:00',3.78),('15844','2013-07-29','13:45:00',3.76),('15844','2013-07-29','13:50:00',3.73),('15844','2013-07-29','13:55:00',3.67),('15844','2013-07-29','14:00:00',3.6),('15844','2013-07-29','14:05:00',3.53),('15844','2013-07-29','14:10:00',3.48),('15844','2013-07-29','14:15:00',3.42),('15844','2013-07-29','14:20:00',3.34),('15844','2013-07-29','14:25:00',3.27),('15844','2013-07-29','14:30:00',3.18),('15844','2013-07-29','14:35:00',3.12),('15844','2013-07-29','14:40:00',3.03),('15844','2013-07-29','14:45:00',2.9),('15844','2013-07-29','14:50:00',2.83),('15844','2013-07-29','14:55:00',2.73),('15844','2013-07-29','15:00:00',2.65),('15844','2013-07-29','15:05:00',2.57),('15844','2013-07-29','15:10:00',2.41),('15844','2013-07-29','15:15:00',2.4),('15844','2013-07-29','15:20:00',2.3),('15844','2013-07-29','15:25:00',2.23),('15844','2013-07-29','15:30:00',2.18),('15844','2013-07-29','15:35:00',2.16),('15844','2013-07-29','15:40:00',1.92),('15844','2013-07-29','15:45:00',1.57),('15844','2013-07-29','15:50:00',1.61),('15844','2013-07-29','15:55:00',1.4),('15844','2013-07-29','16:00:00',1.87),('15844','2013-07-29','16:05:00',2.05),('15844','2013-07-29','16:10:00',1.62),('15844','2013-07-29','16:15:00',1.46),('15844','2013-07-29','16:20:00',1.09),('15844','2013-07-29','16:25:00',1.53),('15844','2013-07-29','16:30:00',1.41),('15844','2013-07-29','16:35:00',1.31),('15844','2013-07-29','16:40:00',1.32),('15844','2013-07-29','16:45:00',1.21),('15844','2013-07-28','08:40:00',1.01),('15844','2013-07-28','08:45:00',1.12),('15844','2013-07-28','08:50:00',1.22),('15844','2013-07-28','08:55:00',1.24),('15844','2013-07-28','09:00:00',1.27),('15844','2013-07-28','09:05:00',1.3),('15844','2013-07-28','09:10:00',1.43),('15844','2013-07-28','09:15:00',1.62),('15844','2013-07-28','09:20:00',1.71),('15844','2013-07-28','09:25:00',1.79),('15844','2013-07-28','09:30:00',1.88),('15844','2013-07-28','09:35:00',1.97),('15844','2013-07-28','09:40:00',2.05),('15844','2013-07-28','09:45:00',2.17),('15844','2013-07-28','09:50:00',2.27),('15844','2013-07-28','09:55:00',2.37),('15844','2013-07-28','10:00:00',2.54),('15844','2013-07-28','10:05:00',2.64),('15844','2013-07-28','10:10:00',2.79),('15844','2013-07-28','10:15:00',2.91),('15844','2013-07-28','10:20:00',3.01),('15844','2013-07-28','10:25:00',3.08),('15844','2013-07-28','10:30:00',3.16),('15844','2013-07-28','10:35:00',3.27),('15844','2013-07-28','10:40:00',3.36),('15844','2013-07-28','10:45:00',3.46),('15844','2013-07-28','10:50:00',3.52),('15844','2013-07-28','10:55:00',3.53),('15844','2013-07-28','11:00:00',3.66),('15844','2013-07-28','11:05:00',3.65),('15844','2013-07-28','11:10:00',3.66),('15844','2013-07-28','11:15:00',3.73),('15844','2013-07-28','11:20:00',3.8),('15844','2013-07-28','11:25:00',3.8),('15844','2013-07-28','11:30:00',3.85),('15844','2013-07-28','11:35:00',3.86),('15844','2013-07-28','11:40:00',3.81),('15844','2013-07-28','11:45:00',3.87),('15844','2013-07-28','11:50:00',3.89),('15844','2013-07-28','11:55:00',4),('15844','2013-07-28','12:00:00',4.01),('15844','2013-07-28','12:05:00',4.01),('15844','2013-07-28','12:10:00',4.07),('15844','2013-07-28','12:15:00',4.04),('15844','2013-07-28','12:20:00',4.07),('15844','2013-07-28','12:25:00',4.07),('15844','2013-07-28','12:30:00',4.02),('15844','2013-07-28','12:35:00',4.02),('15844','2013-07-28','12:40:00',3.98),('15844','2013-07-28','12:45:00',3.98),('15844','2013-07-28','12:50:00',3.93),('15844','2013-07-28','12:55:00',4.03),('15844','2013-07-28','13:00:00',3.96),('15844','2013-07-28','13:05:00',3.95),('15844','2013-07-28','13:10:00',3.96),('15844','2013-07-28','13:15:00',3.93),('15844','2013-07-28','13:20:00',3.86),('15844','2013-07-28','13:25:00',3.89),('15844','2013-07-28','13:30:00',3.8),('15844','2013-07-28','13:35:00',3.8),('15844','2013-07-28','13:40:00',3.82),('15844','2013-07-28','13:45:00',3.77),('15844','2013-07-28','13:50:00',3.76),('15844','2013-07-28','13:55:00',3.7),('15844','2013-07-28','14:00:00',3.63),('15844','2013-07-28','14:05:00',3.57),('15844','2013-07-28','14:10:00',3.51),('15844','2013-07-28','14:15:00',3.43),('15844','2013-07-28','14:20:00',3.33),('15844','2013-07-28','14:25:00',3.24),('15844','2013-07-28','14:30:00',3.22),('15844','2013-07-28','14:35:00',3.11),('15844','2013-07-28','14:40:00',3.03),('15844','2013-07-28','14:45:00',2.93),('15844','2013-07-28','14:50:00',2.86),('15844','2013-07-28','14:55:00',2.74),('15844','2013-07-28','15:00:00',2.63),('15844','2013-07-28','15:05:00',2.53),('15844','2013-07-28','15:10:00',2.4),('15844','2013-07-28','15:15:00',2.33),('15844','2013-07-28','15:20:00',2.23),('15844','2013-07-28','15:25:00',2.15),('15844','2013-07-28','15:30:00',2.14),('15844','2013-07-28','15:35:00',2.09),('15844','2013-07-28','15:40:00',2.05),('15844','2013-07-28','15:45:00',1.98),('15844','2013-07-28','15:50:00',1.89),('15844','2013-07-28','15:55:00',1.8),('15844','2013-07-28','16:00:00',1.68),('15844','2013-07-28','16:05:00',1.58),('15844','2013-07-28','16:10:00',1.52),('15844','2013-07-28','16:15:00',1.43),('15844','2013-07-28','16:20:00',1.37),('15844','2013-07-28','16:25:00',1.31),('15844','2013-07-28','16:30:00',1.25),('15844','2013-07-28','16:35:00',1.2),('15844','2013-07-28','16:40:00',1.13),('15844','2013-07-28','16:45:00',1.08),('15844','2013-07-28','16:50:00',1.03),('15844','2013-07-27','08:40:00',1.03),('15844','2013-07-27','08:45:00',1.23),('15844','2013-07-27','08:50:00',1.33),('15844','2013-07-27','08:55:00',1.4),('15844','2013-07-27','09:00:00',1.42),('15844','2013-07-27','09:05:00',1.48),('15844','2013-07-27','09:10:00',1.54),('15844','2013-07-27','09:15:00',1.66),('15844','2013-07-27','09:20:00',1.77),('15844','2013-07-27','09:25:00',1.87),('15844','2013-07-27','09:30:00',1.94),('15844','2013-07-27','09:35:00',2.04),('15844','2013-07-27','09:40:00',2.17),('15844','2013-07-27','09:45:00',2.26),('15844','2013-07-27','09:50:00',2.35),('15844','2013-07-27','09:55:00',2.45),('15844','2013-07-27','10:00:00',2.62),('15844','2013-07-27','10:05:00',2.73),('15844','2013-07-27','10:10:00',2.81),('15844','2013-07-27','10:15:00',2.91),('15844','2013-07-27','10:20:00',2.99),('15844','2013-07-27','10:25:00',3.08),('15844','2013-07-27','10:30:00',3.21),('15844','2013-07-27','10:35:00',3.46),('15844','2013-07-27','10:40:00',3.55),('15844','2013-07-27','10:45:00',3.58),('15844','2013-07-27','10:50:00',3.64),('15844','2013-07-27','10:55:00',3.79),('15844','2013-07-27','11:00:00',3.85),('15844','2013-07-27','11:05:00',3.87),('15844','2013-07-27','11:10:00',3.89),('15844','2013-07-27','11:15:00',3.92),('15844','2013-07-27','11:20:00',3.96),('15844','2013-07-27','11:25:00',3.92),('15844','2013-07-27','11:30:00',3.98),('15844','2013-07-27','11:35:00',3.86),('15844','2013-07-27','11:40:00',3.96),('15844','2013-07-27','11:45:00',3.95),('15844','2013-07-27','11:50:00',3.99),('15844','2013-07-27','11:55:00',4.02),('15844','2013-07-27','12:00:00',4.03),('15844','2013-07-27','12:05:00',4.08),('15844','2013-07-27','12:10:00',4.04),('15844','2013-07-27','12:15:00',4.03),('15844','2013-07-27','12:20:00',4.06),('15844','2013-07-27','12:25:00',4.08),('15844','2013-07-27','12:30:00',3.92),('15844','2013-07-27','12:35:00',3.87),('15844','2013-07-27','12:40:00',3.95),('15844','2013-07-27','12:45:00',3.99),('15844','2013-07-27','12:50:00',3.93),('15844','2013-07-27','12:55:00',3.66),('15844','2013-07-27','13:00:00',3.94),('15844','2013-07-27','13:05:00',4.07),('15844','2013-07-27','13:10:00',3.95),('15844','2013-07-27','13:15:00',3.83),('15844','2013-07-27','13:20:00',3.87),('15844','2013-07-27','13:25:00',3.88),('15844','2013-07-27','13:30:00',3.9),('15844','2013-07-27','13:35:00',3.85),('15844','2013-07-27','13:40:00',3.85),('15844','2013-07-27','13:45:00',3.77),('15844','2013-07-27','13:50:00',3.69),('15844','2013-07-27','13:55:00',3.65),('15844','2013-07-27','14:00:00',3.6),('15844','2013-07-27','14:05:00',3.53),('15844','2013-07-27','14:10:00',3.48),('15844','2013-07-27','14:15:00',3.39),('15844','2013-07-27','14:20:00',3.34),('15844','2013-07-27','14:25:00',3.24),('15844','2013-07-27','14:30:00',3.14),('15844','2013-07-27','14:35:00',3.09),('15844','2013-07-27','14:40:00',2.99),('15844','2013-07-27','14:45:00',2.89),('15844','2013-07-27','14:50:00',2.79),('15844','2013-07-27','14:55:00',2.72),('15844','2013-07-27','15:00:00',2.66),('15844','2013-07-27','15:05:00',2.57),('15844','2013-07-27','15:10:00',2.49),('15844','2013-07-27','15:15:00',2.4),('15844','2013-07-27','15:20:00',2.31),('15844','2013-07-27','15:25:00',2.23),('15844','2013-07-27','15:30:00',2.17),('15844','2013-07-27','15:35:00',2.12),('15844','2013-07-27','15:40:00',2.07),('15844','2013-07-27','15:45:00',1.99),('15844','2013-07-27','15:50:00',1.9),('15844','2013-07-27','15:55:00',1.81),('15844','2013-07-27','16:00:00',1.69),('15844','2013-07-27','16:05:00',1.56),('15844','2013-07-27','16:10:00',1.49),('15844','2013-07-27','16:15:00',1.44),('15844','2013-07-27','16:20:00',1.38),('15844','2013-07-27','16:25:00',1.32),('15844','2013-07-27','16:30:00',1.26),('15844','2013-07-27','16:35:00',1.2),('15844','2013-07-27','16:40:00',1.14),('15844','2013-07-27','16:45:00',1.12),('15844','2013-07-27','16:50:00',1.05),('15844','2013-07-26','08:40:00',1.09),('15844','2013-07-26','08:45:00',1.36),('15844','2013-07-26','08:50:00',1.29),('15844','2013-07-26','08:55:00',1.36),('15844','2013-07-26','09:00:00',1.41),('15844','2013-07-26','09:05:00',1.43),('15844','2013-07-26','09:10:00',1.49),('15844','2013-07-26','09:15:00',1.58),('15844','2013-07-26','09:20:00',1.68),('15844','2013-07-26','09:25:00',1.74),('15844','2013-07-26','09:30:00',1.81),('15844','2013-07-26','09:35:00',2.02),('15844','2013-07-26','09:40:00',2.12),('15844','2013-07-26','09:45:00',2.2),('15844','2013-07-26','09:50:00',2.29),('15844','2013-07-26','09:55:00',2.41),('15844','2013-07-26','10:00:00',2.61),('15844','2013-07-26','10:05:00',2.67),('15844','2013-07-26','10:10:00',2.77),('15844','2013-07-26','10:15:00',2.88),('15844','2013-07-26','10:20:00',3.12),('15844','2013-07-26','10:25:00',3.19),('15844','2013-07-26','10:30:00',3.27),('15844','2013-07-26','10:35:00',3.36),('15844','2013-07-26','10:40:00',3.46),('15844','2013-07-26','10:45:00',3.54),('15844','2013-07-26','10:50:00',3.53),('15844','2013-07-26','10:55:00',3.57),('15844','2013-07-26','11:00:00',3.71),('15844','2013-07-26','11:05:00',3.76),('15844','2013-07-26','11:10:00',3.69),('15844','2013-07-26','11:15:00',3.59),('15844','2013-07-26','11:20:00',3.93),('15844','2013-07-26','11:25:00',3.73),('15844','2013-07-26','11:30:00',3.86),('15844','2013-07-26','11:35:00',4.04),('15844','2013-07-26','11:40:00',3.91),('15844','2013-07-26','11:45:00',4.06),('15844','2013-07-26','11:50:00',3.9),('15844','2013-07-26','11:55:00',1.35),('15844','2013-07-26','12:00:00',1.63),('15844','2013-07-26','12:05:00',3.54),('15844','2013-07-26','12:10:00',1.79),('15844','2013-07-26','12:15:00',3.83),('15844','2013-07-26','12:20:00',4.25),('15844','2013-07-26','12:25:00',3.68),('15844','2013-07-26','12:30:00',1.51),('15844','2013-07-26','12:35:00',2.03),('15844','2013-07-26','12:40:00',2.78),('15844','2013-07-26','12:45:00',1.89),('15844','2013-07-26','12:50:00',2.2),('15844','2013-07-26','12:55:00',1.28),('15844','2013-07-26','13:00:00',1.57),('15844','2013-07-26','13:05:00',2.94),('15844','2013-07-26','13:10:00',3.34),('15844','2013-07-26','13:15:00',4.3),('15844','2013-07-26','13:20:00',2.48),('15844','2013-07-26','13:25:00',3.87),('15844','2013-07-26','13:30:00',3.26),('15844','2013-07-26','13:35:00',3.56),('15844','2013-07-26','13:40:00',3.38),('15844','2013-07-26','13:45:00',3.84),('15844','2013-07-26','13:50:00',3.76),('15844','2013-07-26','13:55:00',2.96),('15844','2013-07-26','14:00:00',3.65),('15844','2013-07-26','14:05:00',3.47),('15844','2013-07-26','14:10:00',3.31),('15844','2013-07-26','14:15:00',3.51),('15844','2013-07-26','14:20:00',3.41),('15844','2013-07-26','14:25:00',3.3),('15844','2013-07-26','14:30:00',3.24),('15844','2013-07-26','14:35:00',3.15),('15844','2013-07-26','14:40:00',3.08),('15844','2013-07-26','14:45:00',3.01),('15844','2013-07-26','14:50:00',2.89),('15844','2013-07-26','14:55:00',2.78),('15844','2013-07-26','15:00:00',2.68),('15844','2013-07-26','15:05:00',2.6),('15844','2013-07-26','15:10:00',2.52),('15844','2013-07-26','15:15:00',2.45),('15844','2013-07-26','15:20:00',2.36),('15844','2013-07-26','15:25:00',2.27),('15844','2013-07-26','15:30:00',2.21),('15844','2013-07-26','15:35:00',2.17),('15844','2013-07-26','15:40:00',2.1),('15844','2013-07-26','15:45:00',2.03),('15844','2013-07-26','15:50:00',1.93),('15844','2013-07-26','15:55:00',1.83),('15844','2013-07-26','16:00:00',1.7),('15844','2013-07-26','16:05:00',1.59),('15844','2013-07-26','16:10:00',1.55),('15844','2013-07-26','16:15:00',1.46),('15844','2013-07-26','16:20:00',1.4),('15844','2013-07-26','16:25:00',1.35),('15844','2013-07-26','16:30:00',1.3),('15844','2013-07-26','16:35:00',1.24),('15844','2013-07-26','16:40:00',1.18),('15844','2013-07-26','16:45:00',1.16),('15844','2013-07-26','16:50:00',1.08),('15844','2013-07-25','08:40:00',1.06),('15844','2013-07-25','08:45:00',1.17),('15844','2013-07-25','08:50:00',1.26),('15844','2013-07-25','08:55:00',1.29),('15844','2013-07-25','09:00:00',1.32),('15844','2013-07-25','09:05:00',1.45),('15844','2013-07-25','09:10:00',1.39),('15844','2013-07-25','09:15:00',1.69),('15844','2013-07-25','09:20:00',1.57),('15844','2013-07-25','09:25:00',1.66),('15844','2013-07-25','09:30:00',1.21),('15844','2013-07-25','09:40:00',1.37),('15844','2013-07-25','09:45:00',2.14),('15844','2013-07-25','09:50:00',2.48),('15844','2013-07-25','09:55:00',2.67),('15844','2013-07-25','10:00:00',2.71),('15844','2013-07-25','10:05:00',1.6),('15844','2013-07-25','10:10:00',1.47),('15844','2013-07-25','10:15:00',1.37),('15844','2013-07-25','10:20:00',3.3),('15844','2013-07-25','10:25:00',3.36),('15844','2013-07-25','10:30:00',3.38),('15844','2013-07-25','10:35:00',3.64),('15844','2013-07-25','10:40:00',3.01),('15844','2013-07-25','10:45:00',3.29),('15844','2013-07-25','10:50:00',1.86),('15844','2013-07-25','10:55:00',2.27),('15844','2013-07-25','11:00:00',4.13),('15844','2013-07-25','11:05:00',3.66),('15844','2013-07-25','11:10:00',2.79),('15844','2013-07-25','11:15:00',3.15),('15844','2013-07-25','11:20:00',4.03),('15844','2013-07-25','11:25:00',3.91),('15844','2013-07-25','11:30:00',3.74),('15844','2013-07-25','11:35:00',4.13),('15844','2013-07-25','11:40:00',3.92),('15844','2013-07-25','11:45:00',3.6),('15844','2013-07-25','11:50:00',4),('15844','2013-07-25','11:55:00',3.79),('15844','2013-07-25','12:00:00',2.86),('15844','2013-07-25','12:05:00',1.04),('15844','2013-07-25','12:10:00',2.13),('15844','2013-07-25','12:15:00',3.29),('15844','2013-07-25','12:20:00',4.14),('15844','2013-07-25','12:25:00',4.26),('15844','2013-07-25','12:30:00',4.33),('15844','2013-07-25','12:35:00',4.3),('15844','2013-07-25','12:40:00',4.12),('15844','2013-07-25','12:45:00',4.09),('15844','2013-07-25','12:50:00',4.09),('15844','2013-07-25','12:55:00',4.01),('15844','2013-07-25','13:00:00',4.11),('15844','2013-07-25','13:05:00',4.06),('15844','2013-07-25','13:10:00',3.97),('15844','2013-07-25','13:15:00',4.08),('15844','2013-07-25','13:20:00',3.97),('15844','2013-07-25','13:25:00',4.03),('15844','2013-07-25','13:30:00',3.97),('15844','2013-07-25','13:35:00',3.95),('15844','2013-07-25','13:40:00',3.87),('15844','2013-07-25','13:45:00',3.88),('15844','2013-07-25','13:50:00',3.86),('15844','2013-07-25','13:55:00',3.83),('15844','2013-07-25','14:00:00',3.77),('15844','2013-07-25','14:05:00',3.7),('15844','2013-07-25','14:10:00',3.63),('15844','2013-07-25','14:15:00',3.55),('15844','2013-07-25','14:20:00',3.49),('15844','2013-07-25','14:25:00',3.41),('15844','2013-07-25','14:30:00',3.36),('15844','2013-07-25','14:35:00',3.28),('15844','2013-07-25','14:40:00',3.18),('15844','2013-07-25','14:45:00',3.09),('15844','2013-07-25','14:50:00',2.99),('15844','2013-07-25','14:55:00',2.92),('15844','2013-07-25','15:00:00',2.8),('15844','2013-07-25','15:05:00',2.7),('15844','2013-07-25','15:10:00',2.61),('15844','2013-07-25','15:15:00',2.55),('15844','2013-07-25','15:20:00',2.48),('15844','2013-07-25','15:25:00',2.4),('15844','2013-07-25','15:30:00',2.31),('15844','2013-07-25','15:35:00',2.22),('15844','2013-07-25','15:40:00',2.17),('15844','2013-07-25','15:45:00',2.09),('15844','2013-07-25','15:50:00',1.98),('15844','2013-07-25','15:55:00',1.89),('15844','2013-07-25','16:00:00',1.76),('15844','2013-07-25','16:05:00',1.65),('15844','2013-07-25','16:10:00',1.58),('15844','2013-07-25','16:15:00',1.51),('15844','2013-07-25','16:20:00',1.42),('15844','2013-07-25','16:25:00',1.37),('15844','2013-07-25','16:30:00',1.3),('15844','2013-07-25','16:35:00',1.25),('15844','2013-07-25','16:40:00',1.22),('15844','2013-07-25','16:45:00',1.18),('15844','2013-07-25','16:50:00',1.09),('15844','2013-07-24','08:30:00',1.25),('15844','2013-07-24','08:35:00',1.35),('15844','2013-07-24','08:40:00',1.21),('15844','2013-07-24','08:50:00',1.09),('15844','2013-07-24','08:55:00',1.16),('15844','2013-07-24','09:00:00',1.41),('15844','2013-07-24','09:05:00',1.47),('15844','2013-07-24','09:10:00',1.74),('15844','2013-07-24','09:15:00',1.63),('15844','2013-07-24','09:20:00',1.42),('15844','2013-07-24','09:45:00',1.12),('15844','2013-07-24','09:50:00',2.78),('15844','2013-07-24','09:55:00',1.72),('15844','2013-07-24','10:00:00',1.12),('15844','2013-07-24','10:05:00',1.62),('15844','2013-07-24','10:10:00',2.38),('15844','2013-07-24','10:15:00',2.12),('15844','2013-07-24','10:20:00',1.51),('15844','2013-07-24','10:25:00',3.4),('15844','2013-07-24','10:30:00',3.51),('15844','2013-07-24','10:35:00',3.68),('15844','2013-07-24','10:40:00',3.16),('15844','2013-07-24','10:45:00',3.12),('15844','2013-07-24','10:50:00',4.05),('15844','2013-07-24','10:55:00',3.7),('15844','2013-07-24','11:00:00',1.26),('15844','2013-07-24','11:05:00',3.73),('15844','2013-07-24','11:10:00',4.03),('15844','2013-07-24','11:15:00',3.71),('15844','2013-07-24','11:20:00',4.11),('15844','2013-07-24','11:25:00',4.26),('15844','2013-07-24','11:30:00',2.18),('15844','2013-07-24','11:35:00',2.55),('15844','2013-07-24','11:40:00',4.47),('15844','2013-07-24','11:45:00',4.31),('15844','2013-07-24','11:50:00',4.19),('15844','2013-07-24','11:55:00',4.31),('15844','2013-07-24','12:00:00',4.1),('15844','2013-07-24','12:05:00',2.99),('15844','2013-07-24','12:10:00',4.52),('15844','2013-07-24','12:15:00',4.1),('15844','2013-07-24','12:20:00',1.02),('15844','2013-07-24','12:25:00',1.12),('15844','2013-07-24','12:30:00',1.02),('15844','2013-07-24','12:35:00',1),('15844','2013-07-24','12:40:00',1.85),('15844','2013-07-24','12:45:00',1.61),('15844','2013-07-24','12:50:00',4.08),('15844','2013-07-24','12:55:00',4.32),('15844','2013-07-24','13:00:00',4.16),('15844','2013-07-24','13:05:00',4.2),('15844','2013-07-24','13:10:00',4.05),('15844','2013-07-24','13:15:00',4.03),('15844','2013-07-24','13:20:00',3.99),('15844','2013-07-24','13:25:00',3.81),('15844','2013-07-24','13:30:00',3.77),('15844','2013-07-24','13:35:00',3.92),('15844','2013-07-24','13:40:00',3.87),('15844','2013-07-24','13:45:00',3.96),('15844','2013-07-24','13:50:00',3.87),('15844','2013-07-24','13:55:00',3.79),('15844','2013-07-24','14:00:00',3.8),('15844','2013-07-24','14:05:00',3.74),('15844','2013-07-24','14:10:00',3.18),('15844','2013-07-24','14:15:00',3.57),('15844','2013-07-24','14:20:00',3.61),('15844','2013-07-24','14:25:00',3.41),('15844','2013-07-24','14:30:00',3.45),('15844','2013-07-24','14:35:00',3.38),('15844','2013-07-24','14:40:00',3.28),('15844','2013-07-24','14:45:00',3.21),('15844','2013-07-24','14:50:00',3.13),('15844','2013-07-24','14:55:00',3.03),('15844','2013-07-24','15:00:00',2.89),('15844','2013-07-24','15:05:00',2.8),('15844','2013-07-24','15:10:00',2.75),('15844','2013-07-24','15:15:00',2.6),('15844','2013-07-24','15:20:00',2.62),('15844','2013-07-24','15:25:00',2.48),('15844','2013-07-24','15:30:00',2.34),('15844','2013-07-24','15:35:00',2.41),('15844','2013-07-24','15:40:00',2.3),('15844','2013-07-24','15:45:00',2.14),('15844','2013-07-24','15:50:00',2.08),('15844','2013-07-24','15:55:00',2.04),('15844','2013-07-24','16:00:00',1.91),('15844','2013-07-24','16:05:00',1.75),('15844','2013-07-24','16:10:00',1.74),('15844','2013-07-24','16:15:00',1.66),('15844','2013-07-24','16:20:00',1.63),('15844','2013-07-24','16:25:00',1.58),('15844','2013-07-24','16:30:00',1.53),('15844','2013-07-24','16:35:00',1.52),('15844','2013-07-24','16:40:00',1.5),('15844','2013-07-24','16:45:00',1.52),('15844','2013-07-24','16:50:00',1.48),('15844','2013-07-24','16:55:00',1.34),('15844','2013-07-24','17:00:00',1.13),('15844','2013-07-23','08:40:00',1.07),('15844','2013-07-23','08:45:00',1.17),('15844','2013-07-23','08:50:00',1.37),('15844','2013-07-23','08:55:00',1.44),('15844','2013-07-23','09:00:00',1.47),('15844','2013-07-23','09:05:00',1.5),('15844','2013-07-23','09:10:00',1.54),('15844','2013-07-23','09:15:00',1.61),('15844','2013-07-23','09:20:00',1.77),('15844','2013-07-23','09:25:00',1.91),('15844','2013-07-23','09:30:00',2.01),('15844','2013-07-23','09:35:00',2.09),('15844','2013-07-23','09:40:00',2.2),('15844','2013-07-23','09:45:00',2.29),('15844','2013-07-23','09:50:00',2.34),('15844','2013-07-23','09:55:00',2.45),('15844','2013-07-23','10:00:00',2.6),('15844','2013-07-23','10:05:00',2.69),('15844','2013-07-23','10:10:00',2.75),('15844','2013-07-23','10:15:00',2.81),('15844','2013-07-23','10:20:00',2.9),('15844','2013-07-23','10:25:00',3.13),('15844','2013-07-23','10:30:00',3.22),('15844','2013-07-23','10:35:00',3.25),('15844','2013-07-23','10:40:00',3.34),('15844','2013-07-23','10:45:00',3.48),('15844','2013-07-23','10:50:00',3.56),('15844','2013-07-23','10:55:00',3.56),('15844','2013-07-23','11:00:00',3.81),('15844','2013-07-23','11:05:00',3.07),('15844','2013-07-23','11:15:00',2.14),('15844','2013-07-23','11:20:00',1.43),('15844','2013-07-23','11:30:00',1.88),('15844','2013-07-23','11:35:00',1.14),('15844','2013-07-23','11:40:00',2.14),('15844','2013-07-23','11:45:00',4.06),('15844','2013-07-23','11:50:00',4.04),('15844','2013-07-23','11:55:00',2.37),('15844','2013-07-23','12:00:00',1.3),('15844','2013-07-23','12:05:00',3.58),('15844','2013-07-23','12:10:00',1.52),('15844','2013-07-23','12:30:00',3.24),('15844','2013-07-23','12:35:00',4.24),('15844','2013-07-23','12:40:00',3.21),('15844','2013-07-23','12:45:00',2.78),('15844','2013-07-23','12:50:00',1.99),('15844','2013-07-23','12:55:00',1.01),('15844','2013-07-23','13:25:00',3.4),('15844','2013-07-23','13:30:00',4.28),('15844','2013-07-23','13:35:00',1.06),('15844','2013-07-23','13:40:00',2.85),('15844','2013-07-23','13:45:00',2.61),('15844','2013-07-23','13:50:00',4.04),('15844','2013-07-23','13:55:00',2.67),('15844','2013-07-23','14:00:00',2.2),('15844','2013-07-23','14:10:00',3.64),('15844','2013-07-23','14:15:00',2.75),('15844','2013-07-23','14:20:00',2.06),('15844','2013-07-23','14:25:00',2.97),('15844','2013-07-23','14:30:00',3.61),('15844','2013-07-23','14:35:00',3.52),('15844','2013-07-23','14:40:00',3.54),('15844','2013-07-23','14:45:00',3.4),('15844','2013-07-23','14:50:00',3.16),('15844','2013-07-23','14:55:00',3.08),('15844','2013-07-23','15:00:00',2.96),('15844','2013-07-23','15:05:00',2.85),('15844','2013-07-23','15:10:00',2.77),('15844','2013-07-23','15:15:00',2.65),('15844','2013-07-23','15:20:00',2.55),('15844','2013-07-23','15:25:00',2.44),('15844','2013-07-23','15:30:00',2.34),('15844','2013-07-23','15:35:00',2.23),('15844','2013-07-23','15:40:00',2.13),('15844','2013-07-23','15:45:00',2.06),('15844','2013-07-23','15:50:00',1.98),('15844','2013-07-23','15:55:00',1.91),('15844','2013-07-23','16:00:00',1.77),('15844','2013-07-23','16:05:00',1.63),('15844','2013-07-23','16:10:00',1.56),('15844','2013-07-23','16:15:00',1.51),('15844','2013-07-23','16:20:00',1.42),('15844','2013-07-23','16:25:00',1.38),('15844','2013-07-23','16:30:00',1.33),('15844','2013-07-23','16:35:00',1.29),('15844','2013-07-23','16:40:00',1.26),('15844','2013-07-23','16:45:00',1.21),('15844','2013-07-23','16:50:00',1.13),('15844','2013-07-22','08:40:00',1.07),('15844','2013-07-22','08:45:00',1.15),('15844','2013-07-22','08:50:00',1.31),('15844','2013-07-22','08:55:00',1.45),('15844','2013-07-22','09:00:00',1.48),('15844','2013-07-22','09:05:00',1.51),('15844','2013-07-22','09:10:00',1.57),('15844','2013-07-22','09:15:00',1.62),('15844','2013-07-22','09:20:00',1.74),('15844','2013-07-22','09:25:00',1.9),('15844','2013-07-22','09:30:00',2),('15844','2013-07-22','09:35:00',2.11),('15844','2013-07-22','09:40:00',2.21),('15844','2013-07-22','09:45:00',2.3),('15844','2013-07-22','09:50:00',2.41),('15844','2013-07-22','09:55:00',2.52),('15844','2013-07-22','10:00:00',2.63),('15844','2013-07-22','10:05:00',2.73),('15844','2013-07-22','10:10:00',2.83),('15844','2013-07-22','10:15:00',2.94),('15844','2013-07-22','10:20:00',3.01),('15844','2013-07-22','10:25:00',3.25),('15844','2013-07-22','10:30:00',3.41),('15844','2013-07-22','10:35:00',3.51),('15844','2013-07-22','10:40:00',3.6),('15844','2013-07-22','10:45:00',3.66),('15844','2013-07-22','10:50:00',3.78),('15844','2013-07-22','10:55:00',3.86),('15844','2013-07-22','11:00:00',3.9),('15844','2013-07-22','11:05:00',3.93),('15844','2013-07-22','11:10:00',3.98),('15844','2013-07-22','11:15:00',4.01),('15844','2013-07-22','11:20:00',4),('15844','2013-07-22','11:25:00',4.03),('15844','2013-07-22','11:30:00',4.07),('15844','2013-07-22','11:35:00',4.09),('15844','2013-07-22','11:40:00',4.11),('15844','2013-07-22','11:45:00',4.12),('15844','2013-07-22','11:50:00',4.09),('15844','2013-07-22','11:55:00',4.12),('15844','2013-07-22','12:00:00',4.12),('15844','2013-07-22','12:05:00',4.12),('15844','2013-07-22','12:10:00',4.13),('15844','2013-07-22','12:15:00',4.1),('15844','2013-07-22','12:20:00',4.12),('15844','2013-07-22','12:25:00',4.13),('15844','2013-07-22','12:30:00',4.14),('15844','2013-07-22','12:35:00',4.12),('15844','2013-07-22','12:40:00',4.11),('15844','2013-07-22','12:45:00',4.09),('15844','2013-07-22','12:50:00',4.07),('15844','2013-07-22','12:55:00',4.1),('15844','2013-07-22','13:00:00',4.07),('15844','2013-07-22','13:05:00',4.03),('15844','2013-07-22','13:10:00',4.03),('15844','2013-07-22','13:15:00',4),('15844','2013-07-22','13:20:00',3.96),('15844','2013-07-22','13:25:00',3.9),('15844','2013-07-22','13:30:00',3.88),('15844','2013-07-22','13:35:00',3.89),('15844','2013-07-22','13:40:00',3.83),('15844','2013-07-22','13:45:00',3.8),('15844','2013-07-22','13:50:00',3.74),('15844','2013-07-22','13:55:00',3.65),('15844','2013-07-22','14:00:00',3.61),('15844','2013-07-22','14:05:00',3.61),('15844','2013-07-22','14:10:00',3.55),('15844','2013-07-22','14:15:00',3.46),('15844','2013-07-22','14:20:00',3.41),('15844','2013-07-22','14:25:00',3.3),('15844','2013-07-22','14:30:00',3.25),('15844','2013-07-22','14:35:00',3.18),('15844','2013-07-22','14:40:00',3.18),('15844','2013-07-22','14:45:00',3.09),('15844','2013-07-22','14:50:00',2.99),('15844','2013-07-22','14:55:00',2.95),('15844','2013-07-22','15:00:00',2.29),('15844','2013-07-22','15:10:00',1.85),('15844','2013-07-22','15:15:00',2.85),('15844','2013-07-22','15:20:00',2.49),('15844','2013-07-22','15:25:00',1.83),('15844','2013-07-22','15:30:00',2.58),('15844','2013-07-22','15:35:00',2.59),('15844','2013-07-22','15:40:00',2.45),('15844','2013-07-22','15:45:00',1.77),('15844','2013-07-22','15:50:00',1.4),('15844','2013-07-22','15:55:00',2.16),('15844','2013-07-22','16:00:00',2.03),('15844','2013-07-22','16:05:00',1.88),('15844','2013-07-22','16:10:00',1.73),('15844','2013-07-22','16:15:00',1.63),('15844','2013-07-22','16:20:00',1.6),('15844','2013-07-22','16:25:00',1.58),('15844','2013-07-22','16:30:00',1.44),('15844','2013-07-22','16:35:00',1.39),('15844','2013-07-22','16:40:00',1.33),('15844','2013-07-22','16:45:00',1.28),('15844','2013-07-22','16:50:00',1.16),('15844','2013-07-22','16:55:00',1.05),('15844','2013-07-21','08:40:00',1.04),('15844','2013-07-21','08:45:00',1.13),('15844','2013-07-21','08:50:00',1.25),('15844','2013-07-21','08:55:00',1.34),('15844','2013-07-21','09:00:00',1.36),('15844','2013-07-21','09:05:00',1.39),('15844','2013-07-21','09:10:00',1.43),('15844','2013-07-21','09:15:00',1.5),('15844','2013-07-21','09:20:00',1.61),('15844','2013-07-21','09:25:00',1.83),('15844','2013-07-21','09:30:00',1.95),('15844','2013-07-21','09:35:00',2.06),('15844','2013-07-21','09:40:00',2.17),('15844','2013-07-21','09:45:00',2.25),('15844','2013-07-21','09:50:00',2.37),('15844','2013-07-21','09:55:00',2.51),('15844','2013-07-21','10:00:00',2.61),('15844','2013-07-21','10:05:00',2.71),('15844','2013-07-21','10:10:00',2.79),('15844','2013-07-21','10:15:00',2.88),('15844','2013-07-21','10:20:00',2.96),('15844','2013-07-21','10:25:00',3.22),('15844','2013-07-21','10:30:00',3.36),('15844','2013-07-21','10:35:00',3.47),('15844','2013-07-21','10:40:00',3.53),('15844','2013-07-21','10:45:00',3.61),('15844','2013-07-21','10:50:00',3.72),('15844','2013-07-21','10:55:00',3.84),('15844','2013-07-21','11:00:00',3.9),('15844','2013-07-21','11:05:00',3.93),('15844','2013-07-21','11:10:00',3.94),('15844','2013-07-21','11:15:00',4),('15844','2013-07-21','11:20:00',4.02),('15844','2013-07-21','11:25:00',4.07),('15844','2013-07-21','11:30:00',4),('15844','2013-07-21','11:35:00',3.99),('15844','2013-07-21','11:40:00',4.07),('15844','2013-07-21','11:45:00',4.07),('15844','2013-07-21','11:50:00',4.07),('15844','2013-07-21','11:55:00',4.09),('15844','2013-07-21','12:00:00',4.15),('15844','2013-07-21','12:05:00',4.21),('15844','2013-07-21','12:10:00',4.22),('15844','2013-07-21','12:15:00',4.34),('15844','2013-07-21','12:20:00',4.36),('15844','2013-07-21','12:25:00',2.99),('15844','2013-07-21','12:30:00',1.94),('15844','2013-07-21','12:35:00',2.13),('15844','2013-07-21','12:40:00',2.77),('15844','2013-07-21','12:45:00',2.03),('15844','2013-07-21','12:50:00',2.39),('15844','2013-07-21','12:55:00',2),('15844','2013-07-21','13:00:00',1.64),('15844','2013-07-21','13:05:00',1.65),('15844','2013-07-21','13:10:00',2.6),('15844','2013-07-21','13:15:00',2.52),('15844','2013-07-21','13:20:00',2.09),('15844','2013-07-21','13:25:00',3.35),('15844','2013-07-21','13:30:00',4.44),('15844','2013-07-21','13:35:00',4.29),('15844','2013-07-21','13:40:00',4.17),('15844','2013-07-21','13:45:00',3.24),('15844','2013-07-21','13:50:00',3.97),('15844','2013-07-21','13:55:00',3.14),('15844','2013-07-21','14:00:00',1.71),('15844','2013-07-21','14:05:00',2.07),('15844','2013-07-21','14:10:00',2.16),('15844','2013-07-21','14:15:00',2.29),('15844','2013-07-21','14:20:00',1.48),('15844','2013-07-21','14:25:00',1.44),('15844','2013-07-21','14:30:00',1.23),('15844','2013-07-21','14:35:00',1.03),('15844','2013-07-21','14:40:00',1.04),('15844','2013-07-21','14:45:00',1.16),('15844','2013-07-21','14:50:00',1.39),('15844','2013-07-21','14:55:00',1.58),('15844','2013-07-21','15:00:00',1.29),('15844','2013-07-21','15:05:00',1.24),('15844','2013-07-21','15:10:00',1.22),('15844','2013-07-21','15:15:00',1.68),('15844','2013-07-21','15:20:00',1.41),('15844','2013-07-21','15:25:00',1.34),('15844','2013-07-21','15:30:00',1.2),('15844','2013-07-21','15:35:00',1.26),('15844','2013-07-21','15:40:00',1.35),('15844','2013-07-21','15:45:00',1.48),('15844','2013-07-21','15:50:00',1.56),('15844','2013-07-21','15:55:00',1.73),('15844','2013-07-21','16:00:00',1.23),('15844','2013-07-21','17:05:00',1.05),('15844','2013-07-21','17:10:00',1.03),('15844','2014-04-07','08:30:00',1.02),('15844','2014-04-07','08:40:00',1.04),('15844','2014-04-07','08:45:00',1.03),('15844','2014-04-07','09:50:00',1.01),('15844','2014-04-07','09:55:00',1.01),('15844','2014-04-07','10:00:00',1.03),('15844','2014-04-07','10:05:00',1.02),('15844','2014-04-07','10:10:00',1.02),('15844','2014-04-07','10:15:00',1.03),('15844','2014-04-07','10:20:00',1.04),('15844','2014-04-07','10:25:00',1.03),('15844','2014-04-07','10:30:00',1.01),('15844','2014-04-07','10:35:00',1.03),('15844','2014-04-07','10:40:00',1.09),('15844','2014-04-07','10:45:00',1.18),('15844','2014-04-07','10:50:00',1.28),('15844','2014-04-07','10:55:00',1.29),('15844','2014-04-07','11:00:00',1.37),('15844','2014-04-07','11:05:00',1.41),('15844','2014-04-07','11:10:00',1.37),('15844','2014-04-07','11:15:00',1.41),('15844','2014-04-07','11:20:00',1.42),('15844','2014-04-07','11:25:00',1.4),('15844','2014-04-07','11:30:00',1.38),('15844','2014-04-07','11:35:00',1.39),('15844','2014-04-07','11:40:00',1.35),('15844','2014-04-07','11:45:00',1.34),('15844','2014-04-07','11:50:00',1.32),('15844','2014-04-07','11:55:00',1.36),('15844','2014-04-07','12:00:00',1.6),('15844','2014-04-07','12:05:00',2),('15844','2014-04-07','12:10:00',3.12),('15844','2014-04-07','12:15:00',3.71),('15844','2014-04-07','12:20:00',3.76),('15844','2014-04-07','12:25:00',2.63),('15844','2014-04-07','12:30:00',1.4),('15844','2014-04-07','12:35:00',2.51),('15844','2014-04-07','12:40:00',3.86),('15844','2014-04-07','12:45:00',3.77),('15844','2014-04-07','12:50:00',3.63),('15844','2014-04-07','12:55:00',3.56),('15844','2014-04-07','13:00:00',3.55),('15844','2014-04-07','13:05:00',3.6),('15844','2014-04-07','13:10:00',3.57),('15844','2014-04-07','13:15:00',3.53),('15844','2014-04-07','13:20:00',3.48),('15844','2014-04-07','13:25:00',3.39),('15844','2014-04-07','13:30:00',3.35),('15844','2014-04-07','13:35:00',3.38),('15844','2014-04-07','13:40:00',3.37),('15844','2014-04-07','13:45:00',3.3),('15844','2014-04-07','13:50:00',3.25),('15844','2014-04-07','13:55:00',3.15),('15844','2014-04-07','14:00:00',3.12),('15844','2014-04-07','14:05:00',3.07),('15844','2014-04-07','14:10:00',2.99),('15844','2014-04-07','14:15:00',2.99),('15844','2014-04-07','14:20:00',2.98),('15844','2014-04-07','14:25:00',2.88),('15844','2014-04-07','14:30:00',2.77),('15844','2014-04-07','14:35:00',2.71),('15844','2014-04-07','14:40:00',2.59),('15844','2014-04-07','14:45:00',2.47),('15844','2014-04-07','14:50:00',2.36),('15844','2014-04-07','14:55:00',2.32),('15844','2014-04-07','15:00:00',2.27),('15844','2014-04-07','15:05:00',2.15),('15844','2014-04-07','15:10:00',2.11),('15844','2014-04-07','15:15:00',2.02),('15844','2014-04-07','15:20:00',1.94),('15844','2014-04-07','15:25:00',1.84),('15844','2014-04-07','15:30:00',1.77),('15844','2014-04-07','15:35:00',1.67),('15844','2014-04-07','15:40:00',1.59),('15844','2014-04-07','15:45:00',1.5),('15844','2014-04-07','15:50:00',1.44),('15844','2014-04-07','15:55:00',1.43),('15844','2014-04-07','16:00:00',1.42),('15844','2014-04-07','16:05:00',1.32),('15844','2014-04-07','16:10:00',1.25),('15844','2014-04-07','16:15:00',1.2),('15844','2013-07-20','08:35:00',1.04),('15844','2013-07-20','08:40:00',1.11),('15844','2013-07-20','08:45:00',1.19),('15844','2013-07-20','08:50:00',1.32),('15844','2013-07-20','08:55:00',1.5),('15844','2013-07-20','09:00:00',1.56),('15844','2013-07-20','09:05:00',1.67),('15844','2013-07-20','09:10:00',1.74),('15844','2013-07-20','09:15:00',1.77),('15844','2013-07-20','09:20:00',1.77),('15844','2013-07-20','09:25:00',1.84),('15844','2013-07-20','09:30:00',1.88),('15844','2013-07-20','09:35:00',2.06),('15844','2013-07-20','09:40:00',2.31),('15844','2013-07-20','09:45:00',2.34),('15844','2013-07-20','09:50:00',2.38),('15844','2013-07-20','09:55:00',2.57),('15844','2013-07-20','10:00:00',2.66),('15844','2013-07-20','10:05:00',2.81),('15844','2013-07-20','10:10:00',2.89),('15844','2013-07-20','10:15:00',2.99),('15844','2013-07-20','10:20:00',3.06),('15844','2013-07-20','10:25:00',3.14),('15844','2013-07-20','10:30:00',3.43),('15844','2013-07-20','10:35:00',3.54),('15844','2013-07-20','10:40:00',3.64),('15844','2013-07-20','10:45:00',3.72),('15844','2013-07-20','10:50:00',3.82),('15844','2013-07-20','10:55:00',3.96),('15844','2013-07-20','11:00:00',3.99),('15844','2013-07-20','11:05:00',4.02),('15844','2013-07-20','11:10:00',4.04),('15844','2013-07-20','11:15:00',4.06),('15844','2013-07-20','11:20:00',4.1),('15844','2013-07-20','11:25:00',4.18),('15844','2013-07-20','11:30:00',4.11),('15844','2013-07-20','11:35:00',4.17),('15844','2013-07-20','11:40:00',4.19),('15844','2013-07-20','11:45:00',4.16),('15844','2013-07-20','11:50:00',4.1),('15844','2013-07-20','11:55:00',4.14),('15844','2013-07-20','12:00:00',4.14),('15844','2013-07-20','12:05:00',4.16),('15844','2013-07-20','12:10:00',4.17),('15844','2013-07-20','12:15:00',3.92),('15844','2013-07-20','12:20:00',4.19),('15844','2013-07-20','12:25:00',4.11),('15844','2013-07-20','12:30:00',4.25),('15844','2013-07-20','12:35:00',4.25),('15844','2013-07-20','12:40:00',4.25),('15844','2013-07-20','12:45:00',4.18),('15844','2013-07-20','12:50:00',4.14),('15844','2013-07-20','12:55:00',4.19),('15844','2013-07-20','13:00:00',4.22),('15844','2013-07-20','13:05:00',4.13),('15844','2013-07-20','13:10:00',4.23),('15844','2013-07-20','13:15:00',4.22),('15844','2013-07-20','13:20:00',4.13),('15844','2013-07-20','13:25:00',4.12),('15844','2013-07-20','13:30:00',4.12),('15844','2013-07-20','13:35:00',4.06),('15844','2013-07-20','13:40:00',4.02),('15844','2013-07-20','13:45:00',4.05),('15844','2013-07-20','13:50:00',4.01),('15844','2013-07-20','13:55:00',3.88),('15844','2013-07-20','14:00:00',3.74),('15844','2013-07-20','14:05:00',3.75),('15844','2013-07-20','14:10:00',3.65),('15844','2013-07-20','14:15:00',3.67),('15844','2013-07-20','14:20:00',3.53),('15844','2013-07-20','14:25:00',3.47),('15844','2013-07-20','14:30:00',3.41),('15844','2013-07-20','14:35:00',3.33),('15844','2013-07-20','14:40:00',3.22),('15844','2013-07-20','14:45:00',3.2),('15844','2013-07-20','14:50:00',3.15),('15844','2013-07-20','14:55:00',3.08),('15844','2013-07-20','15:00:00',3),('15844','2013-07-20','15:05:00',2.8),('15844','2013-07-20','15:10:00',2.85),('15844','2013-07-20','15:15:00',2.72),('15844','2013-07-20','15:20:00',2.62),('15844','2013-07-20','15:25:00',2.51),('15844','2013-07-20','15:30:00',2.37),('15844','2013-07-20','15:35:00',2.32),('15844','2013-07-20','15:40:00',2.25),('15844','2013-07-20','15:45:00',2.19),('15844','2013-07-20','15:50:00',2.09),('15844','2013-07-20','15:55:00',2),('15844','2013-07-20','16:00:00',1.88),('15844','2013-07-20','16:05:00',1.74),('15844','2013-07-20','16:10:00',1.65),('15844','2013-07-20','16:15:00',1.58),('15844','2013-07-20','16:20:00',1.51),('15844','2013-07-20','16:25:00',1.46),('15844','2013-07-20','16:30:00',1.43),('15844','2013-07-20','16:35:00',1.39),('15844','2013-07-20','16:40:00',1.34),('15844','2013-07-20','16:45:00',1.27),('15844','2013-07-20','16:50:00',1.18),('15844','2013-07-20','16:55:00',1.06),('15844','2013-07-19','08:35:00',1),('15844','2013-07-19','08:40:00',1.1),('15844','2013-07-19','08:45:00',1.16),('15844','2013-07-19','08:50:00',1.23),('15844','2013-07-19','08:55:00',1.33),('15844','2013-07-19','09:00:00',1.38),('15844','2013-07-19','09:05:00',1.39),('15844','2013-07-19','09:10:00',1.43),('15844','2013-07-19','09:15:00',1.53),('15844','2013-07-19','09:20:00',1.62),('15844','2013-07-19','09:25:00',1.72),('15844','2013-07-19','09:30:00',1.89),('15844','2013-07-19','09:35:00',2.02),('15844','2013-07-19','09:40:00',2.1),('15844','2013-07-19','09:45:00',2.18),('15844','2013-07-19','09:50:00',2.3),('15844','2013-07-19','09:55:00',2.43),('15844','2013-07-19','10:00:00',2.52),('15844','2013-07-19','10:05:00',2.64),('15844','2013-07-19','10:10:00',2.72),('15844','2013-07-19','10:15:00',2.88),('15844','2013-07-19','10:20:00',2.88),('15844','2013-07-19','10:25:00',3.16),('15844','2013-07-19','10:30:00',3.21),('15844','2013-07-19','10:35:00',3.25),('15844','2013-07-19','10:40:00',3.35),('15844','2013-07-19','10:45:00',3.4),('15844','2013-07-19','10:50:00',3.43),('15844','2013-07-19','10:55:00',3.57),('15844','2013-07-19','11:00:00',3.63),('15844','2013-07-19','11:05:00',3.64),('15844','2013-07-19','11:10:00',3.71),('15844','2013-07-19','11:15:00',3.73),('15844','2013-07-19','11:20:00',3.8),('15844','2013-07-19','11:25:00',3.79),('15844','2013-07-19','11:30:00',3.78),('15844','2013-07-19','11:35:00',3.88),('15844','2013-07-19','11:40:00',3.95),('15844','2013-07-19','11:45:00',3.52),('15844','2013-07-19','11:50:00',3.92),('15844','2013-07-19','11:55:00',4.06),('15844','2013-07-19','12:00:00',3.73),('15844','2013-07-19','12:05:00',4.11),('15844','2013-07-19','12:10:00',4.23),('15844','2013-07-19','12:15:00',4.17),('15844','2013-07-19','12:20:00',4.17),('15844','2013-07-19','12:25:00',4.07),('15844','2013-07-19','12:30:00',4.08),('15844','2013-07-19','12:35:00',4.05),('15844','2013-07-19','12:40:00',4.14),('15844','2013-07-19','12:45:00',4.09),('15844','2013-07-19','12:50:00',4.12),('15844','2013-07-19','12:55:00',4),('15844','2013-07-19','13:00:00',4.21),('15844','2013-07-19','13:05:00',4.09),('15844','2013-07-19','13:10:00',3.86),('15844','2013-07-19','13:15:00',3.93),('15844','2013-07-19','13:20:00',3.97),('15844','2013-07-19','13:25:00',4.06),('15844','2013-07-19','13:30:00',4.04),('15844','2013-07-19','13:35:00',3.98),('15844','2013-07-19','13:40:00',3.96),('15844','2013-07-19','13:45:00',3.64),('15844','2013-07-19','13:50:00',3.88),('15844','2013-07-19','13:55:00',3.82),('15844','2013-07-19','14:00:00',3.79),('15844','2013-07-19','14:05:00',3.74),('15844','2013-07-19','14:10:00',3.4),('15844','2013-07-19','14:15:00',3.64),('15844','2013-07-19','14:20:00',3.58),('15844','2013-07-19','14:25:00',3.52),('15844','2013-07-19','14:30:00',3.46),('15844','2013-07-19','14:35:00',3.39),('15844','2013-07-19','14:40:00',3.05),('15844','2013-07-19','14:45:00',3.25),('15844','2013-07-19','14:50:00',3.16),('15844','2013-07-19','14:55:00',2.91),('15844','2013-07-19','15:00:00',2.68),('15844','2013-07-19','15:05:00',3),('15844','2013-07-19','15:10:00',1.18),('15844','2013-07-19','15:15:00',2.72),('15844','2013-07-19','15:20:00',2.44),('15844','2013-07-19','15:25:00',1.96),('15844','2013-07-19','15:30:00',2.42),('15844','2013-07-19','15:35:00',2.54),('15844','2013-07-19','15:40:00',2.56),('15844','2013-07-19','15:45:00',2.33),('15844','2013-07-19','15:50:00',2.22),('15844','2013-07-19','15:55:00',2.1),('15844','2013-07-19','16:00:00',1.98),('15844','2013-07-19','16:05:00',1.84),('15844','2013-07-19','16:10:00',1.75),('15844','2013-07-19','16:15:00',1.58),('15844','2013-07-19','16:20:00',1.62),('15844','2013-07-19','16:25:00',1.6),('15844','2013-07-19','16:30:00',1.6),('15844','2013-07-19','16:35:00',1.56),('15844','2013-07-19','16:40:00',1.51),('15844','2013-07-19','16:45:00',1.49),('15844','2013-07-19','16:50:00',1.48),('15844','2013-07-19','16:55:00',1.36),('15844','2013-07-19','17:00:00',1.2),('15844','2013-07-19','17:05:00',1.05),('15844','2013-07-19','17:35:00',1.04),('15844','2013-07-18','08:35:00',1.02),('15844','2013-07-18','08:40:00',1.09),('15844','2013-07-18','08:45:00',1.16),('15844','2013-07-18','08:50:00',1.24),('15844','2013-07-18','08:55:00',1.35),('15844','2013-07-18','09:00:00',1.52),('15844','2013-07-18','09:05:00',1.57),('15844','2013-07-18','09:10:00',1.62),('15844','2013-07-18','09:15:00',1.65),('15844','2013-07-18','09:20:00',1.7),('15844','2013-07-18','09:25:00',1.85),('15844','2013-07-18','09:30:00',2.01),('15844','2013-07-18','09:35:00',2.15),('15844','2013-07-18','09:40:00',2.26),('15844','2013-07-18','09:45:00',2.33),('15844','2013-07-18','09:50:00',2.43),('15844','2013-07-18','09:55:00',2.58),('15844','2013-07-18','10:00:00',2.68),('15844','2013-07-18','10:05:00',2.8),('15844','2013-07-18','10:10:00',2.9),('15844','2013-07-18','10:15:00',2.97),('15844','2013-07-18','10:20:00',3.04),('15844','2013-07-18','10:25:00',3.25),('15844','2013-07-18','10:30:00',3.48),('15844','2013-07-18','10:35:00',3.57),('15844','2013-07-18','10:40:00',3.63),('15844','2013-07-18','10:45:00',3.69),('15844','2013-07-18','10:50:00',3.78),('15844','2013-07-18','10:55:00',3.88),('15844','2013-07-18','11:00:00',3.94),('15844','2013-07-18','11:05:00',3.95),('15844','2013-07-18','11:10:00',3.97),('15844','2013-07-18','11:15:00',4.02),('15844','2013-07-18','11:20:00',4.02),('15844','2013-07-18','11:25:00',4),('15844','2013-07-18','11:30:00',4.09),('15844','2013-07-18','11:35:00',4.14),('15844','2013-07-18','11:40:00',4.11),('15844','2013-07-18','11:45:00',4.11),('15844','2013-07-18','11:50:00',4.13),('15844','2013-07-18','11:55:00',4.13),('15844','2013-07-18','12:00:00',4.16),('15844','2013-07-18','12:05:00',4.17),('15844','2013-07-18','12:10:00',4.17),('15844','2013-07-18','12:15:00',4.14),('15844','2013-07-18','12:20:00',4.16),('15844','2013-07-18','12:25:00',4.16),('15844','2013-07-18','12:30:00',4.12),('15844','2013-07-18','12:35:00',4.13),('15844','2013-07-18','12:40:00',4.14),('15844','2013-07-18','12:45:00',4.09),('15844','2013-07-18','12:50:00',4.07),('15844','2013-07-18','12:55:00',4.12),('15844','2013-07-18','13:00:00',4.12),('15844','2013-07-18','13:05:00',4.05),('15844','2013-07-18','13:10:00',3.94),('15844','2013-07-18','13:15:00',3.99),('15844','2013-07-18','13:20:00',4.04),('15844','2013-07-18','13:25:00',4.12),('15844','2013-07-18','13:30:00',4.01),('15844','2013-07-18','13:35:00',3.93),('15844','2013-07-18','13:40:00',3.91),('15844','2013-07-18','13:45:00',3.99),('15844','2013-07-18','13:50:00',3.94),('15844','2013-07-18','13:55:00',3.84),('15844','2013-07-18','14:00:00',3.79),('15844','2013-07-18','14:05:00',3.72),('15844','2013-07-18','14:10:00',3.65),('15844','2013-07-18','14:15:00',3.63),('15844','2013-07-18','14:20:00',3.54),('15844','2013-07-18','14:25:00',3.44),('15844','2013-07-18','14:30:00',3.43),('15844','2013-07-18','14:35:00',3.38),('15844','2013-07-18','14:40:00',3.33),('15844','2013-07-18','14:45:00',3.24),('15844','2013-07-18','14:50:00',3.15),('15844','2013-07-18','14:55:00',3.08),('15844','2013-07-18','15:00:00',3.01),('15844','2013-07-18','15:05:00',2.92),('15844','2013-07-18','15:10:00',2.81),('15844','2013-07-18','15:15:00',2.7),('15844','2013-07-18','15:20:00',2.61),('15844','2013-07-18','15:25:00',2.47),('15844','2013-07-18','15:30:00',2.34),('15844','2013-07-18','15:35:00',2.26),('15844','2013-07-18','15:40:00',2.18),('15844','2013-07-18','15:45:00',2.13),('15844','2013-07-18','15:50:00',2.05),('15844','2013-07-18','15:55:00',1.97),('15844','2013-07-18','16:00:00',1.83),('15844','2013-07-18','16:05:00',1.71),('15844','2013-07-18','16:10:00',1.61),('15844','2013-07-18','16:15:00',1.56),('15844','2013-07-18','16:20:00',1.48),('15844','2013-07-18','16:25:00',1.45),('15844','2013-07-18','16:30:00',1.4),('15844','2013-07-18','16:35:00',1.37),('15844','2013-07-18','16:40:00',1.32),('15844','2013-07-18','16:45:00',1.26),('15844','2013-07-18','16:50:00',1.18),('15844','2013-07-18','16:55:00',1.08),('15844','2013-07-17','08:30:00',1.04),('15844','2013-07-17','08:35:00',1.12),('15844','2013-07-17','08:40:00',1.19),('15844','2013-07-17','08:45:00',1.25),('15844','2013-07-17','08:50:00',1.28),('15844','2013-07-17','08:55:00',1.4),('15844','2013-07-17','09:00:00',1.55),('15844','2013-07-17','09:05:00',1.62),('15844','2013-07-17','09:10:00',1.66),('15844','2013-07-17','09:15:00',1.7),('15844','2013-07-17','09:20:00',1.76),('15844','2013-07-17','09:25:00',1.86),('15844','2013-07-17','09:30:00',2.04),('15844','2013-07-17','09:35:00',2.22),('15844','2013-07-17','09:40:00',2.33),('15844','2013-07-17','09:45:00',2.42),('15844','2013-07-17','09:50:00',2.54),('15844','2013-07-17','09:55:00',2.7),('15844','2013-07-17','10:00:00',2.78),('15844','2013-07-17','10:05:00',2.85),('15844','2013-07-17','10:10:00',2.96),('15844','2013-07-17','10:15:00',3.13),('15844','2013-07-17','10:20:00',3.28),('15844','2013-07-17','10:25:00',3.4),('15844','2013-07-17','10:30:00',3.48),('15844','2013-07-17','10:35:00',3.6),('15844','2013-07-17','10:40:00',3.7),('15844','2013-07-17','10:45:00',3.78),('15844','2013-07-17','10:50:00',3.91),('15844','2013-07-17','10:55:00',4.02),('15844','2013-07-17','11:00:00',4.09),('15844','2013-07-17','11:05:00',4.14),('15844','2013-07-17','11:10:00',4.16),('15844','2013-07-17','11:15:00',4.17),('15844','2013-07-17','11:20:00',4.24),('15844','2013-07-17','11:25:00',4.22),('15844','2013-07-17','11:30:00',4.22),('15844','2013-07-17','11:35:00',4.27),('15844','2013-07-17','11:40:00',4.26),('15844','2013-07-17','11:45:00',4.26),('15844','2013-07-17','11:50:00',4.28),('15844','2013-07-17','11:55:00',4.26),('15844','2013-07-17','12:00:00',4.27),('15844','2013-07-17','12:05:00',4.29),('15844','2013-07-17','12:10:00',4.33),('15844','2013-07-17','12:15:00',4.31),('15844','2013-07-17','12:20:00',4.28),('15844','2013-07-17','12:25:00',4.25),('15844','2013-07-17','12:30:00',4.24),('15844','2013-07-17','12:35:00',4.27),('15844','2013-07-17','12:40:00',4.23),('15844','2013-07-17','12:45:00',4.25),('15844','2013-07-17','12:50:00',4.22),('15844','2013-07-17','12:55:00',4.19),('15844','2013-07-17','13:00:00',4.14),('15844','2013-07-17','13:05:00',4.13),('15844','2013-07-17','13:10:00',4.13),('15844','2013-07-17','13:15:00',4.03),('15844','2013-07-17','13:20:00',4.03),('15844','2013-07-17','13:25:00',3.99),('15844','2013-07-17','13:30:00',4.01),('15844','2013-07-17','13:35:00',3.95),('15844','2013-07-17','13:40:00',3.86),('15844','2013-07-17','13:45:00',3.92),('15844','2013-07-17','13:50:00',3.88),('15844','2013-07-17','13:55:00',3.88),('15844','2013-07-17','14:00:00',3.84),('15844','2013-07-17','14:05:00',3.8),('15844','2013-07-17','14:10:00',3.72),('15844','2013-07-17','14:15:00',3.68),('15844','2013-07-17','14:20:00',3.62),('15844','2013-07-17','14:25:00',3.6),('15844','2013-07-17','14:30:00',3.53),('15844','2013-07-17','14:35:00',3.37),('15844','2013-07-17','14:40:00',3.41),('15844','2013-07-17','14:45:00',3.35),('15844','2013-07-17','14:50:00',3.24),('15844','2013-07-17','14:55:00',3.15),('15844','2013-07-17','15:00:00',3.15),('15844','2013-07-17','15:05:00',3.08),('15844','2013-07-17','15:10:00',2.96),('15844','2013-07-17','15:15:00',2.84),('15844','2013-07-17','15:20:00',2.75),('15844','2013-07-17','15:25:00',2.57),('15844','2013-07-17','15:30:00',2.47),('15844','2013-07-17','15:35:00',2.7),('15844','2013-07-17','15:40:00',1.62),('15844','2013-07-17','15:45:00',1.22),('15844','2013-07-17','15:50:00',1.62),('15844','2013-07-17','15:55:00',2.17),('15844','2013-07-17','16:00:00',2.13),('15844','2013-07-17','16:05:00',2.1),('15844','2013-07-17','16:10:00',1.68),('15844','2013-07-17','16:15:00',1.04),('15844','2013-07-17','16:25:00',1.46),('15844','2013-07-17','16:30:00',1.46),('15844','2013-07-17','16:35:00',1.42),('15844','2013-07-17','16:40:00',1.36),('15844','2013-07-17','16:45:00',1.28),('15844','2013-07-17','16:50:00',1.2),('15844','2013-07-17','16:55:00',1.09),('15844','2013-07-16','08:35:00',1.06),('15844','2013-07-16','08:40:00',1.12),('15844','2013-07-16','08:45:00',1.19),('15844','2013-07-16','08:50:00',1.25),('15844','2013-07-16','08:55:00',1.34),('15844','2013-07-16','09:00:00',1.39),('15844','2013-07-16','09:05:00',1.43),('15844','2013-07-16','09:10:00',1.48),('15844','2013-07-16','09:15:00',1.57),('15844','2013-07-16','09:20:00',1.68),('15844','2013-07-16','09:25:00',1.8),('15844','2013-07-16','09:30:00',1.97),('15844','2013-07-16','09:35:00',2.15),('15844','2013-07-16','09:40:00',2.25),('15844','2013-07-16','09:45:00',2.35),('15844','2013-07-16','09:50:00',2.46),('15844','2013-07-16','09:55:00',2.62),('15844','2013-07-16','10:00:00',2.71),('15844','2013-07-16','10:05:00',2.8),('15844','2013-07-16','10:10:00',2.88),('15844','2013-07-16','10:15:00',2.94),('15844','2013-07-16','10:20:00',3.05),('15844','2013-07-16','10:25:00',3.29),('15844','2013-07-16','10:30:00',3.42),('15844','2013-07-16','10:35:00',3.52),('15844','2013-07-16','10:40:00',3.6),('15844','2013-07-16','10:45:00',3.73),('15844','2013-07-16','10:50:00',3.81),('15844','2013-07-16','10:55:00',3.93),('15844','2013-07-16','11:00:00',3.99),('15844','2013-07-16','11:05:00',4.03),('15844','2013-07-16','11:10:00',4.06),('15844','2013-07-16','11:15:00',4.06),('15844','2013-07-16','11:20:00',4.08),('15844','2013-07-16','11:25:00',4.13),('15844','2013-07-16','11:30:00',4.11),('15844','2013-07-16','11:35:00',4.13),('15844','2013-07-16','11:40:00',4.15),('15844','2013-07-16','11:45:00',4.2),('15844','2013-07-16','11:50:00',4.2),('15844','2013-07-16','11:55:00',4.21),('15844','2013-07-16','12:00:00',4.22),('15844','2013-07-16','12:05:00',4.24),('15844','2013-07-16','12:10:00',4.27),('15844','2013-07-16','12:15:00',4.28),('15844','2013-07-16','12:20:00',4.26),('15844','2013-07-16','12:25:00',4.25),('15844','2013-07-16','12:30:00',4.22),('15844','2013-07-16','12:35:00',4.26),('15844','2013-07-16','12:40:00',4.24),('15844','2013-07-16','12:45:00',4.22),('15844','2013-07-16','12:50:00',4.19),('15844','2013-07-16','12:55:00',4.18),('15844','2013-07-16','13:00:00',4.15),('15844','2013-07-16','13:05:00',4.11),('15844','2013-07-16','13:10:00',4.1),('15844','2013-07-16','13:15:00',4.08),('15844','2013-07-16','13:20:00',4.07),('15844','2013-07-16','13:25:00',4),('15844','2013-07-16','13:30:00',4.03),('15844','2013-07-16','13:35:00',4),('15844','2013-07-16','13:40:00',3.97),('15844','2013-07-16','13:45:00',3.95),('15844','2013-07-16','13:50:00',3.99),('15844','2013-07-16','13:55:00',3.86),('15844','2013-07-16','14:00:00',3.78),('15844','2013-07-16','14:05:00',3.65),('15844','2013-07-16','14:10:00',3.67),('15844','2013-07-16','14:15:00',3.61),('15844','2013-07-16','14:20:00',3.59),('15844','2013-07-16','14:25:00',3.54),('15844','2013-07-16','14:30:00',3.44),('15844','2013-07-16','14:35:00',3.35),('15844','2013-07-16','14:40:00',3.12),('15844','2013-07-16','14:45:00',3.29),('15844','2013-07-16','14:50:00',3.21),('15844','2013-07-16','14:55:00',3.09),('15844','2013-07-16','15:00:00',2.98),('15844','2013-07-16','15:05:00',1.78),('15844','2013-07-16','15:10:00',2.83),('15844','2013-07-16','15:15:00',2.53),('15844','2013-07-16','15:20:00',2.66),('15844','2013-07-16','15:25:00',2.55),('15844','2013-07-16','15:30:00',2.49),('15844','2013-07-16','15:35:00',2.44),('15844','2013-07-16','15:40:00',2.38),('15844','2013-07-16','15:45:00',2.23),('15844','2013-07-16','15:50:00',2.11),('15844','2013-07-16','15:55:00',2),('15844','2013-07-16','16:00:00',1.92),('15844','2013-07-16','16:05:00',1.84),('15844','2013-07-16','16:10:00',1.56),('15844','2013-07-16','16:20:00',1.07),('15844','2013-07-16','16:25:00',1.75),('15844','2013-07-16','16:30:00',1.78),('15844','2013-07-16','16:35:00',1.83),('15844','2013-07-16','16:40:00',1.84),('15844','2013-07-16','16:45:00',1.74),('15844','2013-07-16','16:50:00',1.61),('15844','2013-07-16','16:55:00',1.46),('15844','2013-07-16','17:00:00',1.25),('15844','2013-07-16','17:05:00',1),('15844','2013-07-15','08:30:00',1.06),('15844','2013-07-15','08:35:00',1.15),('15844','2013-07-15','08:40:00',1.22),('15844','2013-07-15','08:45:00',1.26),('15844','2013-07-15','08:50:00',1.29),('15844','2013-07-15','08:55:00',1.36),('15844','2013-07-15','09:00:00',1.46),('15844','2013-07-15','09:05:00',1.56),('15844','2013-07-15','09:10:00',1.68),('15844','2013-07-15','09:15:00',1.71),('15844','2013-07-15','09:20:00',1.76),('15844','2013-07-15','09:25:00',1.85),('15844','2013-07-15','09:30:00',1.99),('15844','2013-07-15','09:35:00',2.23),('15844','2013-07-15','09:40:00',2.35),('15844','2013-07-15','09:45:00',2.44),('15844','2013-07-15','09:50:00',2.56),('15844','2013-07-15','09:55:00',2.7),('15844','2013-07-15','10:00:00',2.81),('15844','2013-07-15','10:05:00',2.86),('15844','2013-07-15','10:10:00',2.95),('15844','2013-07-15','10:15:00',3.08),('15844','2013-07-15','10:20:00',3.28),('15844','2013-07-15','10:25:00',3.4),('15844','2013-07-15','10:30:00',3.53),('15844','2013-07-15','10:35:00',3.59),('15844','2013-07-15','10:40:00',3.66),('15844','2013-07-15','10:45:00',3.72),('15844','2013-07-15','10:50:00',3.83),('15844','2013-07-15','10:55:00',3.92),('15844','2013-07-15','11:00:00',4.02),('15844','2013-07-15','11:05:00',4.07),('15844','2013-07-15','11:10:00',4.12),('15844','2013-07-15','11:15:00',4.14),('15844','2013-07-15','11:20:00',4.16),('15844','2013-07-15','11:25:00',4.16),('15844','2013-07-15','11:30:00',4.19),('15844','2013-07-15','11:35:00',4.24),('15844','2013-07-15','11:40:00',4.25),('15844','2013-07-15','11:45:00',4.23),('15844','2013-07-15','11:50:00',4.23),('15844','2013-07-15','11:55:00',4.24),('15844','2013-07-15','12:00:00',4.25),('15844','2013-07-15','12:05:00',4.24),('15844','2013-07-15','12:10:00',4.27),('15844','2013-07-15','12:15:00',4.24),('15844','2013-07-15','12:20:00',4.19),('15844','2013-07-15','12:25:00',4.17),('15844','2013-07-15','12:30:00',4.1),('15844','2013-07-15','12:35:00',4.11),('15844','2013-07-15','12:40:00',4.13),('15844','2013-07-15','12:45:00',3.78),('15844','2013-07-15','12:50:00',4.06),('15844','2013-07-15','12:55:00',4.09),('15844','2013-07-15','13:00:00',4.14),('15844','2013-07-15','13:05:00',4.06),('15844','2013-07-15','13:10:00',3.98),('15844','2013-07-15','13:15:00',4.01),('15844','2013-07-15','13:20:00',2.81),('15844','2013-07-15','13:25:00',4.24),('15844','2013-07-15','13:30:00',4.16),('15844','2013-07-15','13:35:00',3.27),('15844','2013-07-15','13:40:00',3.59),('15844','2013-07-15','13:45:00',3.78),('15844','2013-07-15','13:50:00',4.08),('15844','2013-07-15','13:55:00',2.55),('15844','2013-07-15','14:00:00',1.34),('15844','2013-07-15','14:05:00',4.28),('15844','2013-07-15','14:10:00',2.81),('15844','2013-07-15','14:15:00',3.09),('15844','2013-07-15','14:20:00',3.55),('15844','2013-07-15','14:30:00',3.28),('15844','2013-07-15','14:35:00',3.7),('15844','2013-07-15','14:40:00',3.63),('15844','2013-07-15','14:50:00',1.35),('15844','2013-07-15','15:00:00',3.01),('15844','2013-07-15','15:05:00',3.22),('15844','2013-07-15','15:10:00',3.01),('15844','2013-07-15','15:15:00',2.87),('15844','2013-07-15','15:20:00',2.66),('15844','2013-07-15','15:25:00',2.62),('15844','2013-07-15','15:30:00',2.67),('15844','2013-07-15','15:35:00',2.48),('15844','2013-07-15','15:40:00',2.24),('15844','2013-07-15','15:45:00',2.17),('15844','2013-07-15','15:50:00',2.15),('15844','2013-07-15','15:55:00',2.07),('15844','2013-07-15','16:00:00',1.92),('15844','2013-07-15','16:05:00',1.78),('15844','2013-07-15','16:10:00',1.67),('15844','2013-07-15','16:15:00',1.57),('15844','2013-07-15','16:20:00',1.54),('15844','2013-07-15','16:25:00',1.5),('15844','2013-07-15','16:30:00',1.48),('15844','2013-07-15','16:35:00',1.44),('15844','2013-07-15','16:40:00',1.37),('15844','2013-07-15','16:45:00',1.31),('15844','2013-07-15','16:50:00',1.23),('15844','2013-07-15','16:55:00',1.11),('15844','2013-07-14','08:15:00',1.01),('15844','2013-07-14','08:30:00',1.01),('15844','2013-07-14','08:55:00',1.16),('15844','2013-07-14','09:10:00',1.19),('15844','2013-07-14','09:15:00',1.02),('15844','2013-07-14','09:20:00',1.06),('15844','2013-07-14','09:25:00',1.53),('15844','2013-07-14','09:30:00',1.82),('15844','2013-07-14','09:35:00',1.72),('15844','2013-07-14','09:40:00',1.47),('15844','2013-07-14','09:45:00',1.49),('15844','2013-07-14','09:50:00',1.39),('15844','2013-07-14','09:55:00',1.42),('15844','2013-07-14','10:00:00',1.55),('15844','2013-07-14','10:05:00',1.54),('15844','2013-07-14','10:10:00',1.46),('15844','2013-07-14','10:15:00',1.65),('15844','2013-07-14','10:20:00',2.36),('15844','2013-07-14','10:25:00',3.06),('15844','2013-07-14','10:30:00',2.32),('15844','2013-07-14','10:35:00',2.59),('15844','2013-07-14','10:40:00',3.16),('15844','2013-07-14','10:45:00',4.48),('15844','2013-07-14','10:50:00',3.48),('15844','2013-07-14','10:55:00',4.14),('15844','2013-07-14','11:00:00',4.07),('15844','2013-07-14','11:05:00',3.12),('15844','2013-07-14','11:10:00',4.18),('15844','2013-07-14','11:15:00',4.36),('15844','2013-07-14','11:20:00',4.61),('15844','2013-07-14','11:25:00',3.45),('15844','2013-07-14','11:30:00',4.18),('15844','2013-07-14','11:35:00',4.14),('15844','2013-07-14','11:40:00',3.55),('15844','2013-07-14','11:45:00',4.24),('15844','2013-07-14','11:50:00',2.29),('15844','2013-07-14','11:55:00',2.02),('15844','2013-07-14','12:00:00',1.23),('15844','2013-07-14','12:05:00',1.15),('15844','2013-07-14','12:10:00',1.88),('15844','2013-07-14','12:15:00',1.88),('15844','2013-07-14','12:20:00',1.57),('15844','2013-07-14','12:25:00',1.16),('15844','2013-07-14','12:30:00',1.35),('15844','2013-07-14','12:35:00',2.43),('15844','2013-07-14','12:40:00',3.07),('15844','2013-07-14','12:45:00',4.69),('15844','2013-07-14','12:50:00',4.67),('15844','2013-07-14','12:55:00',3.08),('15844','2013-07-14','13:00:00',1.9),('15844','2013-07-14','13:05:00',3.86),('15844','2013-07-14','13:10:00',4.24),('15844','2013-07-14','13:15:00',4.01),('15844','2013-07-14','13:20:00',4.05),('15844','2013-07-14','13:25:00',4.11),('15844','2013-07-14','13:30:00',4.12),('15844','2013-07-14','13:35:00',4.11),('15844','2013-07-14','13:40:00',4.08),('15844','2013-07-14','13:45:00',4.08),('15844','2013-07-14','13:50:00',4.08),('15844','2013-07-14','13:55:00',4.02),('15844','2013-07-14','14:00:00',3.98),('15844','2013-07-14','14:05:00',3.95),('15844','2013-07-14','14:10:00',3.9),('15844','2013-07-14','14:15:00',3.8),('15844','2013-07-14','14:20:00',3.74),('15844','2013-07-14','14:25:00',3.67),('15844','2013-07-14','14:30:00',3.63),('15844','2013-07-14','14:35:00',3.53),('15844','2013-07-14','14:40:00',3.47),('15844','2013-07-14','14:45:00',3.4),('15844','2013-07-14','14:50:00',3.32),('15844','2013-07-14','14:55:00',3.23),('15844','2013-07-14','15:00:00',3.09),('15844','2013-07-14','15:05:00',3),('15844','2013-07-14','15:10:00',2.87),('15844','2013-07-14','15:15:00',2.78),('15844','2013-07-14','15:20:00',2.69),('15844','2013-07-14','15:25:00',2.58),('15844','2013-07-14','15:30:00',2.47),('15844','2013-07-14','15:35:00',2.36),('15844','2013-07-14','15:40:00',2.3),('15844','2013-07-14','15:45:00',2.24),('15844','2013-07-14','15:50:00',2.15),('15844','2013-07-14','15:55:00',1.85),('15844','2013-07-14','16:00:00',1.73),('15844','2013-07-14','16:05:00',1.87),('15844','2013-07-14','16:10:00',1.72),('15844','2013-07-14','16:15:00',1.8),('15844','2013-07-14','16:20:00',1.86),('15844','2013-07-14','16:25:00',1.54),('15844','2013-07-14','16:30:00',1.47),('15844','2013-07-14','16:35:00',1.24),('15844','2013-07-14','16:40:00',1.09),('15844','2013-07-14','16:45:00',1.24),('15844','2013-07-14','16:50:00',1.25),('15844','2013-07-13','08:35:00',1.07),('15844','2013-07-13','08:40:00',1.13),('15844','2013-07-13','08:45:00',1.21),('15844','2013-07-13','08:50:00',1.27),('15844','2013-07-13','08:55:00',1.36),('15844','2013-07-13','09:00:00',1.44),('15844','2013-07-13','09:05:00',1.58),('15844','2013-07-13','09:10:00',1.65),('15844','2013-07-13','09:15:00',1.69),('15844','2013-07-13','09:20:00',1.69),('15844','2013-07-13','09:25:00',1.82),('15844','2013-07-13','09:30:00',1.92),('15844','2013-07-13','09:35:00',2.14),('15844','2013-07-13','09:40:00',2.29),('15844','2013-07-13','09:45:00',2.37),('15844','2013-07-13','09:50:00',2.5),('15844','2013-07-13','09:55:00',2.67),('15844','2013-07-13','10:00:00',2.79),('15844','2013-07-13','10:05:00',2.85),('15844','2013-07-13','10:10:00',2.95),('15844','2013-07-13','10:15:00',3.05),('15844','2013-07-13','10:20:00',3.26),('15844','2013-07-13','10:25:00',3.27),('15844','2013-07-13','10:30:00',3.29),('15844','2013-07-13','10:35:00',3.64),('15844','2013-07-13','10:40:00',3.67),('15844','2013-07-13','10:45:00',2.88),('15844','2013-07-13','10:50:00',4.02),('15844','2013-07-13','10:55:00',4.05),('15844','2013-07-13','11:00:00',1.09),('15844','2013-07-13','11:05:00',2.19),('15844','2013-07-13','11:10:00',2.56),('15844','2013-07-13','11:15:00',1.06),('15844','2013-07-13','11:20:00',1.22),('15844','2013-07-13','11:25:00',2.19),('15844','2013-07-13','11:30:00',4.55),('15844','2013-07-13','11:35:00',4.35),('15844','2013-07-13','11:40:00',4.44),('15844','2013-07-13','11:45:00',4.36),('15844','2013-07-13','11:50:00',1.55),('15844','2013-07-13','11:55:00',2.11),('15844','2013-07-13','12:00:00',4.24),('15844','2013-07-13','12:05:00',3.69),('15844','2013-07-13','12:10:00',1.2),('15844','2013-07-13','12:15:00',1.64),('15844','2013-07-13','12:20:00',1.66),('15844','2013-07-13','12:25:00',4.38),('15844','2013-07-13','12:30:00',4.46),('15844','2013-07-13','12:35:00',4.55),('15844','2013-07-13','12:40:00',3.53),('15844','2013-07-13','12:45:00',3.82),('15844','2013-07-13','12:50:00',1.56),('15844','2013-07-13','12:55:00',3.7),('15844','2013-07-13','13:00:00',4.41),('15844','2013-07-13','13:05:00',4.39),('15844','2013-07-13','13:10:00',4.19),('15844','2013-07-13','13:15:00',4.23),('15844','2013-07-13','13:20:00',3.82),('15844','2013-07-13','13:25:00',4.14),('15844','2013-07-13','13:30:00',4.15),('15844','2013-07-13','13:35:00',4.11),('15844','2013-07-13','13:40:00',4.04),('15844','2013-07-13','13:45:00',4.05),('15844','2013-07-13','13:50:00',3.98),('15844','2013-07-13','13:55:00',3.96),('15844','2013-07-13','14:00:00',3.89),('15844','2013-07-13','14:05:00',3.83),('15844','2013-07-13','14:10:00',3.82),('15844','2013-07-13','14:15:00',3.75),('15844','2013-07-13','14:20:00',3.7),('15844','2013-07-13','14:25:00',3.63),('15844','2013-07-13','14:30:00',3.57),('15844','2013-07-13','14:35:00',3.53),('15844','2013-07-13','14:40:00',3.47),('15844','2013-07-13','14:45:00',3.42),('15844','2013-07-13','14:50:00',3.33),('15844','2013-07-13','14:55:00',3.29),('15844','2013-07-13','15:00:00',3.14),('15844','2013-07-13','15:05:00',3.07),('15844','2013-07-13','15:10:00',2.96),('15844','2013-07-13','15:15:00',2.87),('15844','2013-07-13','15:20:00',2.6),('15844','2013-07-13','15:25:00',2.64),('15844','2013-07-13','15:30:00',2.42),('15844','2013-07-13','15:35:00',2.41),('15844','2013-07-13','15:40:00',2.33),('15844','2013-07-13','15:45:00',2.25),('15844','2013-07-13','15:50:00',2.16),('15844','2013-07-13','15:55:00',2.06),('15844','2013-07-13','16:00:00',1.92),('15844','2013-07-13','16:05:00',1.79),('15844','2013-07-13','16:10:00',1.67),('15844','2013-07-13','16:15:00',1.6),('15844','2013-07-13','16:20:00',1.58),('15844','2013-07-13','16:25:00',1.52),('15844','2013-07-13','16:30:00',1.47),('15844','2013-07-13','16:35:00',1.43),('15844','2013-07-13','16:40:00',1.37),('15844','2013-07-13','16:45:00',1.31),('15844','2013-07-13','16:50:00',1.22),('15844','2013-07-13','16:55:00',1.06),('15844','2013-07-12','08:30:00',1.51),('15844','2013-07-12','09:00:00',1.67),('15844','2013-07-12','09:05:00',1.89),('15844','2013-07-12','09:10:00',1.98),('15844','2013-07-12','09:15:00',1.02),('15844','2013-07-12','09:25:00',1.65),('15844','2013-07-12','09:30:00',1.16),('15844','2013-07-12','09:35:00',1.61),('15844','2013-07-12','09:40:00',1.98),('15844','2013-07-12','09:45:00',2.53),('15844','2013-07-12','09:50:00',2.59),('15844','2013-07-12','09:55:00',2.71),('15844','2013-07-12','10:00:00',2.13),('15844','2013-07-12','10:05:00',1.97),('15844','2013-07-12','10:10:00',2.52),('15844','2013-07-12','10:15:00',1.56),('15844','2013-07-12','10:20:00',2.82),('15844','2013-07-12','10:25:00',3.43),('15844','2013-07-12','10:30:00',2.58),('15844','2013-07-12','10:35:00',1.59),('15844','2013-07-12','10:40:00',3.71),('15844','2013-07-12','10:45:00',3.82),('15844','2013-07-12','10:50:00',1.53),('15844','2013-07-12','10:55:00',1.66),('15844','2013-07-12','11:00:00',3.63),('15844','2013-07-12','11:05:00',3.47),('15844','2013-07-12','11:10:00',2.01),('15844','2013-07-12','11:15:00',2.98),('15844','2013-07-12','11:25:00',1.23),('15844','2013-07-12','11:30:00',1.22),('15844','2013-07-12','11:35:00',3.66),('15844','2013-07-12','11:40:00',3.56),('15844','2013-07-12','11:45:00',3.39),('15844','2013-07-12','11:50:00',4.37),('15844','2013-07-12','11:55:00',4.64),('15844','2013-07-12','12:00:00',4.22),('15844','2013-07-12','12:05:00',4.47),('15844','2013-07-12','12:10:00',4.47),('15844','2013-07-12','12:15:00',4.56),('15844','2013-07-12','12:20:00',2.9),('15844','2013-07-12','12:25:00',3.71),('15844','2013-07-12','12:30:00',4.64),('15844','2013-07-12','12:35:00',3.85),('15844','2013-07-12','12:40:00',4.02),('15844','2013-07-12','12:45:00',2.92),('15844','2013-07-12','12:50:00',4.41),('15844','2013-07-12','12:55:00',4.41),('15844','2013-07-12','13:00:00',4.33),('15844','2013-07-12','13:05:00',4.25),('15844','2013-07-12','13:10:00',4.35),('15844','2013-07-12','13:15:00',4.21),('15844','2013-07-12','13:20:00',4.26),('15844','2013-07-12','13:25:00',4.19),('15844','2013-07-12','13:30:00',4.39),('15844','2013-07-12','13:35:00',4.2),('15844','2013-07-12','13:40:00',4.16),('15844','2013-07-12','13:45:00',4.21),('15844','2013-07-12','13:50:00',2.72),('15844','2013-07-12','13:55:00',3.28),('15844','2013-07-12','14:00:00',3.35),('15844','2013-07-12','14:05:00',3.39),('15844','2013-07-12','14:10:00',4.17),('15844','2013-07-12','14:15:00',4.13),('15844','2013-07-12','14:20:00',2.48),('15844','2013-07-12','14:25:00',2.39),('15844','2013-07-12','14:30:00',3.82),('15844','2013-07-12','14:35:00',3.66),('15844','2013-07-12','14:40:00',3.52),('15844','2013-07-12','14:45:00',3.4),('15844','2013-07-12','14:50:00',3.34),('15844','2013-07-12','14:55:00',3.19),('15844','2013-07-12','15:00:00',3.05),('15844','2013-07-12','15:05:00',2.97),('15844','2013-07-12','15:10:00',2.84),('15844','2013-07-12','15:15:00',2.75),('15844','2013-07-12','15:20:00',2.2),('15844','2013-07-12','15:25:00',2.48),('15844','2013-07-12','15:30:00',2.41),('15844','2013-07-12','15:35:00',1.96),('15844','2013-07-12','15:40:00',2.33),('15844','2013-07-12','15:45:00',2.23),('15844','2013-07-12','15:50:00',2.12),('15844','2013-07-12','15:55:00',2.01),('15844','2013-07-12','16:00:00',1.92),('15844','2013-07-12','16:05:00',1.79),('15844','2013-07-12','16:10:00',1.68),('15844','2013-07-12','16:15:00',1.63),('15844','2013-07-12','16:20:00',1.57),('15844','2013-07-12','16:25:00',1.52),('15844','2013-07-12','16:30:00',1.46),('15844','2013-07-12','16:35:00',1.43),('15844','2013-07-12','16:40:00',1.37),('15844','2013-07-12','16:45:00',1.32),('15844','2013-07-12','16:50:00',1.23),('15844','2013-07-12','16:55:00',1.07),('15844','2013-07-11','08:35:00',1.03),('15844','2013-07-11','08:40:00',1.12),('15844','2013-07-11','08:45:00',1.2),('15844','2013-07-11','08:50:00',1.33),('15844','2013-07-11','08:55:00',1.38),('15844','2013-07-11','09:00:00',1.45),('15844','2013-07-11','09:05:00',1.6),('15844','2013-07-11','09:10:00',1.62),('15844','2013-07-11','09:15:00',1.7),('15844','2013-07-11','09:20:00',1.78),('15844','2013-07-11','09:25:00',1.85),('15844','2013-07-11','09:30:00',1.08),('15844','2013-07-11','09:35:00',2.02),('15844','2013-07-11','09:40:00',2.47),('15844','2013-07-11','09:45:00',2.2),('15844','2013-07-11','09:50:00',1.27),('15844','2013-07-11','09:55:00',2.07),('15844','2013-07-11','10:00:00',2.28),('15844','2013-07-11','10:05:00',1.89),('15844','2013-07-11','10:10:00',1.65),('15844','2013-07-11','10:20:00',1.11),('15844','2013-07-11','10:25:00',2.92),('15844','2013-07-11','10:30:00',3.41),('15844','2013-07-11','10:45:00',2.59),('15844','2013-07-11','10:50:00',4),('15844','2013-07-11','10:55:00',3.49),('15844','2013-07-11','11:00:00',3.5),('15844','2013-07-11','11:05:00',4.13),('15844','2013-07-11','11:10:00',2.16),('15844','2013-07-11','11:15:00',3.6),('15844','2013-07-11','11:20:00',3.73),('15844','2013-07-11','11:25:00',2.79),('15844','2013-07-11','11:30:00',2.3),('15844','2013-07-11','11:35:00',1.06),('15844','2013-07-11','11:40:00',1.25),('15844','2013-07-11','11:45:00',3.03),('15844','2013-07-11','11:50:00',4.48),('15844','2013-07-11','11:55:00',4.07),('15844','2013-07-11','12:00:00',3.15),('15844','2013-07-11','12:05:00',3.27),('15844','2013-07-11','12:10:00',1.72),('15844','2013-07-11','12:15:00',4.24),('15844','2013-07-11','12:20:00',4.41),('15844','2013-07-11','12:25:00',4.6),('15844','2013-07-11','12:30:00',4.52),('15844','2013-07-11','12:35:00',4.49),('15844','2013-07-11','12:40:00',4.35),('15844','2013-07-11','12:45:00',4.38),('15844','2013-07-11','12:50:00',4.21),('15844','2013-07-11','12:55:00',1.62),('15844','2013-07-11','13:00:00',4.49),('15844','2013-07-11','13:05:00',4.01),('15844','2013-07-11','13:10:00',4.38),('15844','2013-07-11','13:15:00',2.28),('15844','2013-07-11','13:20:00',4.25),('15844','2013-07-11','13:25:00',4.4),('15844','2013-07-11','13:30:00',4.35),('15844','2013-07-11','13:35:00',4.16),('15844','2013-07-11','13:40:00',4.08),('15844','2013-07-11','13:45:00',4.09),('15844','2013-07-11','13:50:00',4.04),('15844','2013-07-11','13:55:00',3.97),('15844','2013-07-11','14:00:00',3.99),('15844','2013-07-11','14:05:00',3.87),('15844','2013-07-11','14:10:00',3.99),('15844','2013-07-11','14:15:00',3.81),('15844','2013-07-11','14:20:00',3.76),('15844','2013-07-11','14:25:00',3.68),('15844','2013-07-11','14:30:00',3.64),('15844','2013-07-11','14:35:00',3.56),('15844','2013-07-11','14:40:00',3.48),('15844','2013-07-11','14:45:00',3.44),('15844','2013-07-11','14:50:00',3.35),('15844','2013-07-11','14:55:00',3.24),('15844','2013-07-11','15:00:00',3.13),('15844','2013-07-11','15:05:00',3.06),('15844','2013-07-11','15:10:00',2.96),('15844','2013-07-11','15:15:00',2.86),('15844','2013-07-11','15:20:00',2.79),('15844','2013-07-11','15:25:00',2.65),('15844','2013-07-11','15:30:00',2.21),('15844','2013-07-11','15:35:00',2.21),('15844','2013-07-11','15:40:00',2.26),('15844','2013-07-11','15:45:00',2.4),('15844','2013-07-11','15:50:00',2.34),('15844','2013-07-11','15:55:00',1.73),('15844','2013-07-11','16:00:00',2.2),('15844','2013-07-11','16:05:00',1.96),('15844','2013-07-11','16:10:00',1.72),('15844','2013-07-11','16:15:00',1.63),('15844','2013-07-11','16:20:00',2.03),('15844','2013-07-11','16:25:00',1.85),('15844','2013-07-11','16:30:00',1.78),('15844','2013-07-11','16:35:00',1.62),('15844','2013-07-11','16:40:00',1.45),('15844','2013-07-11','16:45:00',1.48),('15844','2013-07-11','16:50:00',1.27),('15844','2013-07-11','16:55:00',1.17),('15844','2013-07-11','17:00:00',1.03),('15844','2013-07-11','17:10:00',1.11),('15844','2014-05-03','08:20:00',1.12),('15844','2014-05-03','08:30:00',1.05),('15844','2014-05-03','08:35:00',1.58),('15844','2014-05-03','08:40:00',1.7),('15844','2014-05-03','08:45:00',1.64),('15844','2014-05-03','08:55:00',1.14),('15844','2014-05-03','09:00:00',1.85),('15844','2014-05-03','09:05:00',1.67),('15844','2014-05-03','09:10:00',1.24),('15844','2014-05-03','09:15:00',1.64),('15844','2014-05-03','09:20:00',1.05),('15844','2014-05-03','09:35:00',1.47),('15844','2014-05-03','09:50:00',2.73),('15844','2014-05-03','09:55:00',3.37),('15844','2014-05-03','10:00:00',3.82),('15844','2014-05-03','10:05:00',3.63),('15844','2014-05-03','10:10:00',3.99),('15844','2014-05-03','10:15:00',3.25),('15844','2014-05-03','10:20:00',2.28),('15844','2014-05-03','10:25:00',3.36),('15844','2014-05-03','10:30:00',2.29),('15844','2014-05-03','10:35:00',4.39),('15844','2014-05-03','10:40:00',4.96),('15844','2014-05-03','10:45:00',3.56),('15844','2014-05-03','10:50:00',1.03),('15844','2014-05-03','11:00:00',1.11),('15844','2014-05-03','11:05:00',4.41),('15844','2014-05-03','11:10:00',2.94),('15844','2014-05-03','11:15:00',1.24),('15844','2014-05-03','11:30:00',1.13),('15844','2014-05-03','11:35:00',2.5),('15844','2014-05-03','11:40:00',2.52),('15844','2014-05-03','11:45:00',1.85),('15844','2014-05-03','11:50:00',1.53),('15844','2014-05-03','11:55:00',1.59),('15844','2014-05-03','12:00:00',1.69),('15844','2014-05-03','12:05:00',1.3),('15844','2014-05-03','12:20:00',1.03),('15844','2014-05-03','12:35:00',1.18),('15844','2014-05-03','12:40:00',1.57),('15844','2014-05-03','12:45:00',1.98),('15844','2014-05-03','12:50:00',1.8),('15844','2014-05-03','12:55:00',1.71),('15844','2014-05-03','13:00:00',2.3),('15844','2014-05-03','13:05:00',2.96),('15844','2014-05-03','13:10:00',2.9),('15844','2014-05-03','13:15:00',2.9),('15844','2014-05-03','13:20:00',2.26),('15844','2014-05-03','13:25:00',1.85),('15844','2014-05-03','13:30:00',1.77),('15844','2014-05-03','13:35:00',1.81),('15844','2014-05-03','13:40:00',2.13),('15844','2014-05-03','13:45:00',2.36),('15844','2014-05-03','13:50:00',1.99),('15844','2014-05-03','13:55:00',2.32),('15844','2014-05-03','14:00:00',2.4),('15844','2014-05-03','14:05:00',2.45),('15844','2014-05-03','14:10:00',2.34),('15844','2014-05-03','14:15:00',2.2),('15844','2014-05-03','14:20:00',2.36),('15844','2014-05-03','14:25:00',2.39),('15844','2014-05-03','14:30:00',2.49),('15844','2014-05-03','14:35:00',1.86),('15844','2014-04-06','08:45:00',1.11),('15844','2014-04-06','08:50:00',1.26),('15844','2014-04-06','08:55:00',1.37),('15844','2014-04-06','09:00:00',1.36),('15844','2014-04-06','09:05:00',1.4),('15844','2014-04-06','09:10:00',1.64),('15844','2014-04-06','09:15:00',1.91),('15844','2014-04-06','09:20:00',1.68),('15844','2014-04-06','09:25:00',1.77),('15844','2014-04-06','09:35:00',1.34),('15844','2014-04-06','09:40:00',1.34),('15844','2014-04-06','09:45:00',1.13),('15844','2014-04-06','09:50:00',1.61),('15844','2014-04-06','09:55:00',2.96),('15844','2014-04-06','10:00:00',2.98),('15844','2014-04-06','10:05:00',3.06),('15844','2014-04-06','10:10:00',3.42),('15844','2014-04-06','10:15:00',2.74),('15844','2014-04-06','10:20:00',3.46),('15844','2014-04-06','10:25:00',1.7),('15844','2014-04-06','10:30:00',1.54),('15844','2014-04-06','10:35:00',1.26),('15844','2014-04-06','10:40:00',1.34),('15844','2014-04-06','10:45:00',1.52),('15844','2014-04-06','10:50:00',1.57),('15844','2014-04-06','10:55:00',2.41),('15844','2014-04-06','11:00:00',2.02),('15844','2014-04-06','11:05:00',2.3),('15844','2014-04-06','11:10:00',4.16),('15844','2014-04-06','11:15:00',4.23),('15844','2014-04-06','11:20:00',4.22),('15844','2014-04-06','11:25:00',4.18),('15844','2014-04-06','11:30:00',4.27),('15844','2014-04-06','11:35:00',4.13),('15844','2014-04-06','11:40:00',4.09),('15844','2014-04-06','11:45:00',4.08),('15844','2014-04-06','11:50:00',4.12),('15844','2014-04-06','11:55:00',4.08),('15844','2014-04-06','12:00:00',4.11),('15844','2014-04-06','12:05:00',3.92),('15844','2014-04-06','12:10:00',4.19),('15844','2014-04-06','12:15:00',4.17),('15844','2014-04-06','12:20:00',4.13),('15844','2014-04-06','12:25:00',4.06),('15844','2014-04-06','12:30:00',4.36),('15844','2014-04-06','12:35:00',4.04),('15844','2014-04-06','12:40:00',3.47),('15844','2014-04-06','12:45:00',4.08),('15844','2014-04-06','12:50:00',4.14),('15844','2014-04-06','12:55:00',3.97),('15844','2014-04-06','13:00:00',3.93),('15844','2014-04-06','13:05:00',3.53),('15844','2014-04-06','13:10:00',4.27),('15844','2014-04-06','13:15:00',3.41),('15844','2014-04-06','13:20:00',3.14),('15844','2014-04-06','13:25:00',4.24),('15844','2014-04-06','13:30:00',3.77),('15844','2014-04-06','13:35:00',1.51),('15844','2014-04-06','13:40:00',2.97),('15844','2014-04-06','13:45:00',3.48),('15844','2014-04-06','13:50:00',2.56),('15844','2014-04-06','13:55:00',3.68),('15844','2014-04-06','14:00:00',3.38),('15844','2014-04-06','14:05:00',3.59),('15844','2014-04-06','14:10:00',3.52),('15844','2014-04-06','14:15:00',3.63),('15844','2014-04-06','14:20:00',3.33),('15844','2014-04-06','14:25:00',3.3),('15844','2014-04-06','14:30:00',3.23),('15844','2014-04-06','14:35:00',3.29),('15844','2014-04-06','14:45:00',1.21),('15844','2014-04-06','14:50:00',2.63),('15844','2014-04-06','14:55:00',2.51),('15844','2014-04-06','15:00:00',1.27),('15844','2014-04-06','16:00:00',1.36),('15844','2014-04-06','16:10:00',1.33),('15844','2013-07-10','08:15:00',1.05),('15844','2013-07-10','08:20:00',1.28),('15844','2013-07-10','08:25:00',1.43),('15844','2013-07-10','08:30:00',1.38),('15844','2013-07-10','08:35:00',1.25),('15844','2013-07-10','08:40:00',1.23),('15844','2013-07-10','08:45:00',1.2),('15844','2013-07-10','08:55:00',1.29),('15844','2013-07-10','09:00:00',1.49),('15844','2013-07-10','09:05:00',1.12),('15844','2013-07-10','09:10:00',1.76),('15844','2013-07-10','09:15:00',1.83),('15844','2013-07-10','09:20:00',1.84),('15844','2013-07-10','09:25:00',1.9),('15844','2013-07-10','09:30:00',2.01),('15844','2013-07-10','09:35:00',2.2),('15844','2013-07-10','09:40:00',2.34),('15844','2013-07-10','09:45:00',2.45),('15844','2013-07-10','09:50:00',2.57),('15844','2013-07-10','09:55:00',2.74),('15844','2013-07-10','10:00:00',2.85),('15844','2013-07-10','10:05:00',2.93),('15844','2013-07-10','10:10:00',2.99),('15844','2013-07-10','10:15:00',3.06),('15844','2013-07-10','10:20:00',3.11),('15844','2013-07-10','10:25:00',3.19),('15844','2013-07-10','10:30:00',3.5),('15844','2013-07-10','10:35:00',3.63),('15844','2013-07-10','10:40:00',3.72),('15844','2013-07-10','10:45:00',3.8),('15844','2013-07-10','10:50:00',3.93),('15844','2013-07-10','10:55:00',3.98),('15844','2013-07-10','11:00:00',4.04),('15844','2013-07-10','11:05:00',4.06),('15844','2013-07-10','11:10:00',4.08),('15844','2013-07-10','11:15:00',4.04),('15844','2013-07-10','11:20:00',4.12),('15844','2013-07-10','11:25:00',4.15),('15844','2013-07-10','11:30:00',4.02),('15844','2013-07-10','11:35:00',4.18),('15844','2013-07-10','11:40:00',4.21),('15844','2013-07-10','11:45:00',4.21),('15844','2013-07-10','11:50:00',4.25),('15844','2013-07-10','11:55:00',4.19),('15844','2013-07-10','12:00:00',4.25),('15844','2013-07-10','12:05:00',4.26),('15844','2013-07-10','12:10:00',4.26),('15844','2013-07-10','12:15:00',4.26),('15844','2013-07-10','12:20:00',4.27),('15844','2013-07-10','12:25:00',4.28),('15844','2013-07-10','12:30:00',4.22),('15844','2013-07-10','12:35:00',4.26),('15844','2013-07-10','12:40:00',4.3),('15844','2013-07-10','12:45:00',4.25),('15844','2013-07-10','12:50:00',4.27),('15844','2013-07-10','12:55:00',4.3),('15844','2013-07-10','13:00:00',4.27),('15844','2013-07-10','13:05:00',4.27),('15844','2013-07-10','13:10:00',4.25),('15844','2013-07-10','13:15:00',4.25),('15844','2013-07-10','13:20:00',4.22),('15844','2013-07-10','13:25:00',4.19),('15844','2013-07-10','13:30:00',4.16),('15844','2013-07-10','13:35:00',4.14),('15844','2013-07-10','13:40:00',4.13),('15844','2013-07-10','13:45:00',4.09),('15844','2013-07-10','13:50:00',4.07),('15844','2013-07-10','13:55:00',4.02),('15844','2013-07-10','14:00:00',3.98),('15844','2013-07-10','14:05:00',3.92),('15844','2013-07-10','14:10:00',3.88),('15844','2013-07-10','14:15:00',3.82),('15844','2013-07-10','14:20:00',3.74),('15844','2013-07-10','14:25:00',3.69),('15844','2013-07-10','14:30:00',3.65),('15844','2013-07-10','14:35:00',3.59),('15844','2013-07-10','14:40:00',3.52),('15844','2013-07-10','14:45:00',3.46),('15844','2013-07-10','14:50:00',3.38),('15844','2013-07-10','14:55:00',3.27),('15844','2013-07-10','15:00:00',3.16),('15844','2013-07-10','15:05:00',3.06),('15844','2013-07-10','15:10:00',2.96),('15844','2013-07-10','15:15:00',2.84),('15844','2013-07-10','15:20:00',2.75),('15844','2013-07-10','15:25:00',2.64),('15844','2013-07-10','15:30:00',2.51),('15844','2013-07-10','15:35:00',2.43),('15844','2013-07-10','15:40:00',2.33),('15844','2013-07-10','15:45:00',2.25),('15844','2013-07-10','15:50:00',2.18),('15844','2013-07-10','15:55:00',2.08),('15844','2013-07-10','16:00:00',1.96),('15844','2013-07-10','16:05:00',1.86),('15844','2013-07-10','16:10:00',1.76),('15844','2013-07-10','16:15:00',1.7),('15844','2013-07-10','16:20:00',1.62),('15844','2013-07-10','16:25:00',1.55),('15844','2013-07-10','16:30:00',1.5),('15844','2013-07-10','16:35:00',1.48),('15844','2013-07-10','16:40:00',1.4),('15844','2013-07-10','16:45:00',1.36),('15844','2013-07-10','16:50:00',1.3),('15844','2013-07-10','16:55:00',1.22),('15844','2013-07-10','17:00:00',1.2),('15844','2013-07-10','17:05:00',1.33),('15844','2013-07-10','17:10:00',1.29),('15844','2013-07-10','17:15:00',1.1),('15844','2013-07-09','08:30:00',1.03),('15844','2013-07-09','08:35:00',1.13),('15844','2013-07-09','08:40:00',1.19),('15844','2013-07-09','08:45:00',1.24),('15844','2013-07-09','08:50:00',1.26),('15844','2013-07-09','08:55:00',1.32),('15844','2013-07-09','09:00:00',1.42),('15844','2013-07-09','09:05:00',1.55),('15844','2013-07-09','09:10:00',1.67),('15844','2013-07-09','09:15:00',1.72),('15844','2013-07-09','09:20:00',1.77),('15844','2013-07-09','09:25:00',1.85),('15844','2013-07-09','09:30:00',1.94),('15844','2013-07-09','09:35:00',2.13),('15844','2013-07-09','09:40:00',2.3),('15844','2013-07-09','09:45:00',2.42),('15844','2013-07-09','09:50:00',2.56),('15844','2013-07-09','09:55:00',2.67),('15844','2013-07-09','10:00:00',2.75),('15844','2013-07-09','10:05:00',2.84),('15844','2013-07-09','10:10:00',2.91),('15844','2013-07-09','10:15:00',3.01),('15844','2013-07-09','10:20:00',3.09),('15844','2013-07-09','10:25:00',3.16),('15844','2013-07-09','10:30:00',3.43),('15844','2013-07-09','10:35:00',3.59),('15844','2013-07-09','10:40:00',3.73),('15844','2013-07-09','10:45:00',3.81),('15844','2013-07-09','10:50:00',3.88),('15844','2013-07-09','10:55:00',3.96),('15844','2013-07-09','11:00:00',4.01),('15844','2013-07-09','11:05:00',4.08),('15844','2013-07-09','11:10:00',4.08),('15844','2013-07-09','11:15:00',4.17),('15844','2013-07-09','11:20:00',4.25),('15844','2013-07-09','11:25:00',4.33),('15844','2013-07-09','11:30:00',3.55),('15844','2013-07-09','11:35:00',3.59),('15844','2013-07-09','11:40:00',4.38),('15844','2013-07-09','11:45:00',4.18),('15844','2013-07-09','11:50:00',4.24),('15844','2013-07-09','11:55:00',4.43),('15844','2013-07-09','12:00:00',4.41),('15844','2013-07-09','12:05:00',4.33),('15844','2013-07-09','12:10:00',4.27),('15844','2013-07-09','12:15:00',4.34),('15844','2013-07-09','12:20:00',4.3),('15844','2013-07-09','12:25:00',4.18),('15844','2013-07-09','12:30:00',4.2),('15844','2013-07-09','12:35:00',4.2),('15844','2013-07-09','12:40:00',4.16),('15844','2013-07-09','12:45:00',3.52),('15844','2013-07-09','12:50:00',2.62),('15844','2013-07-09','12:55:00',3.03),('15844','2013-07-09','13:00:00',4.33),('15844','2013-07-09','13:05:00',4.33),('15844','2013-07-09','13:10:00',4.28),('15844','2013-07-09','13:15:00',4.15),('15844','2013-07-09','13:20:00',4.19),('15844','2013-07-09','13:25:00',4.17),('15844','2013-07-09','13:30:00',4.15),('15844','2013-07-09','13:35:00',4.23),('15844','2013-07-09','13:40:00',4.21),('15844','2013-07-09','13:45:00',4.11),('15844','2013-07-09','13:50:00',3.13),('15844','2013-07-09','13:55:00',4.4),('15844','2013-07-09','14:00:00',3.77),('15844','2013-07-09','14:05:00',3.01),('15844','2013-07-09','14:10:00',3.26),('15844','2013-07-09','14:15:00',3.43),('15844','2013-07-09','14:20:00',3.85),('15844','2013-07-09','14:25:00',3.42),('15844','2013-07-09','14:30:00',1.12),('15844','2013-07-08','08:30:00',1.08),('15844','2013-07-08','08:35:00',1.18),('15844','2013-07-08','08:40:00',1.21),('15844','2013-07-08','08:45:00',1.24),('15844','2013-07-08','08:50:00',1.26),('15844','2013-07-08','08:55:00',1.35),('15844','2013-07-08','09:00:00',1.43),('15844','2013-07-08','09:05:00',1.55),('15844','2013-07-08','09:10:00',1.66),('15844','2013-07-08','09:15:00',1.72),('15844','2013-07-08','09:20:00',1.77),('15844','2013-07-08','09:25:00',1.84),('15844','2013-07-08','09:30:00',1.97),('15844','2013-07-08','09:35:00',2.15),('15844','2013-07-08','09:40:00',2.33),('15844','2013-07-08','09:45:00',2.44),('15844','2013-07-08','09:50:00',2.58),('15844','2013-07-08','09:55:00',2.68),('15844','2013-07-08','10:00:00',2.74),('15844','2013-07-08','10:05:00',2.8),('15844','2013-07-08','10:10:00',2.93),('15844','2013-07-08','10:15:00',3.05),('15844','2013-07-08','10:20:00',3.15),('15844','2013-07-08','10:25:00',3.27),('15844','2013-07-08','10:30:00',3.42),('15844','2013-07-08','10:35:00',3.42),('15844','2013-07-08','10:40:00',3.71),('15844','2013-07-08','10:45:00',3.78),('15844','2013-07-08','10:50:00',3.88),('15844','2013-07-08','10:55:00',3.94),('15844','2013-07-08','11:00:00',4.02),('15844','2013-07-08','11:05:00',4.06),('15844','2013-07-08','11:10:00',4.14),('15844','2013-07-08','11:15:00',4.13),('15844','2013-07-08','11:20:00',4.2),('15844','2013-07-08','11:25:00',4.22),('15844','2013-07-08','11:30:00',4.28),('15844','2013-07-08','11:35:00',4.29),('15844','2013-07-08','11:40:00',4.14),('15844','2013-07-08','11:45:00',3.12),('15844','2013-07-08','11:50:00',3.2),('15844','2013-07-08','11:55:00',4.51),('15844','2013-07-08','12:00:00',4.26),('15844','2013-07-08','12:05:00',4.42),('15844','2013-07-08','12:10:00',4.44),('15844','2013-07-08','12:15:00',4.36),('15844','2013-07-08','12:20:00',4.41),('15844','2013-07-08','12:25:00',4.54),('15844','2013-07-08','12:30:00',4.45),('15844','2013-07-08','12:35:00',4.24),('15844','2013-07-08','12:40:00',4.37),('15844','2013-07-08','12:45:00',4.34),('15844','2013-07-08','12:50:00',4.31),('15844','2013-07-08','12:55:00',4.31),('15844','2013-07-08','13:00:00',4.18),('15844','2013-07-08','13:05:00',4.44),('15844','2013-07-08','13:10:00',4.59),('15844','2013-07-08','13:15:00',4.48),('15844','2013-07-08','13:20:00',1.99),('15844','2013-07-08','14:30:00',1.01),('15844','2013-07-08','14:35:00',1.22),('15844','2013-07-08','14:40:00',1.48),('15844','2013-07-08','14:45:00',1.46),('15844','2013-07-08','14:50:00',1.35),('15844','2013-07-08','14:55:00',1.22),('15844','2013-07-08','15:00:00',1.12),('15844','2013-07-08','15:05:00',1.09),('15844','2013-07-08','15:10:00',1.01),('15844','2013-07-07','08:35:00',1.21),('15844','2013-07-07','08:55:00',1.35),('15844','2013-07-07','09:00:00',1.62),('15844','2013-07-07','09:05:00',1.75),('15844','2013-07-07','09:10:00',1.47),('15844','2013-07-07','09:15:00',1.15),('15844','2013-07-07','09:20:00',1.24),('15844','2013-07-07','09:25:00',1.18),('15844','2013-07-07','09:30:00',1.48),('15844','2013-07-07','09:35:00',2.09),('15844','2013-07-07','09:40:00',2.46),('15844','2013-07-07','09:45:00',2.58),('15844','2013-07-07','09:50:00',2.96),('15844','2013-07-07','09:55:00',3.03),('15844','2013-07-07','10:00:00',3.06),('15844','2013-07-07','10:05:00',3.02),('15844','2013-07-07','10:10:00',3.02),('15844','2013-07-07','10:15:00',2.58),('15844','2013-07-07','10:20:00',3.23),('15844','2013-07-07','10:25:00',3.63),('15844','2013-07-07','10:30:00',3.78),('15844','2013-07-07','10:35:00',2.96),('15844','2013-07-07','10:40:00',3.79),('15844','2013-07-07','10:45:00',4.02),('15844','2013-07-07','10:50:00',4.06),('15844','2013-07-07','10:55:00',4.14),('15844','2013-07-07','11:00:00',4.17),('15844','2013-07-07','11:05:00',4.21),('15844','2013-07-07','11:10:00',4.29),('15844','2013-07-07','11:15:00',4.29),('15844','2013-07-07','11:20:00',4.25),('15844','2013-07-07','11:25:00',3.7),('15844','2013-07-07','11:30:00',4.14),('15844','2013-07-07','11:35:00',3.89),('15844','2013-07-07','11:40:00',3.78),('15844','2013-07-07','11:45:00',4.06),('15844','2013-07-07','11:50:00',4.18),('15844','2013-07-07','11:55:00',3.73),('15844','2013-07-07','12:00:00',3.82),('15844','2013-07-07','12:05:00',2.8),('15844','2013-07-07','12:10:00',3.04),('15844','2013-07-07','12:15:00',3.35),('15844','2013-07-07','12:20:00',2.61),('15844','2013-07-07','12:25:00',3.26),('15844','2013-07-07','12:30:00',4.2),('15844','2013-07-07','12:35:00',3.96),('15844','2013-07-07','12:40:00',4.01),('15844','2013-07-07','12:45:00',4.19),('15844','2013-07-07','12:50:00',4.24),('15844','2013-07-07','12:55:00',4.3),('15844','2013-07-07','13:00:00',4.35),('15844','2013-07-07','13:05:00',4.13),('15844','2013-07-07','13:10:00',4.25),('15844','2013-07-07','13:15:00',4.26),('15844','2013-07-07','13:20:00',4.24),('15844','2013-07-07','13:25:00',4.19),('15844','2013-07-07','13:30:00',4.33),('15844','2013-07-07','13:35:00',4.3),('15844','2013-07-07','13:40:00',4.18),('15844','2013-07-07','13:45:00',4.36),('15844','2013-07-07','13:50:00',4.54),('15844','2013-07-07','13:55:00',3.53),('15844','2013-07-07','14:00:00',1.33),('15844','2013-07-07','14:05:00',1.28),('15844','2013-07-07','14:10:00',1.1),('15844','2013-07-07','14:15:00',1.22),('15844','2013-07-07','14:20:00',1.43),('15844','2013-07-07','14:25:00',2.12),('15844','2013-07-07','14:30:00',1.95),('15844','2013-07-07','14:35:00',1.42),('15844','2013-07-07','14:40:00',1.08),('15844','2013-07-07','15:05:00',1.11),('15844','2013-07-06','08:30:00',1.04),('15844','2013-07-06','08:35:00',1.14),('15844','2013-07-06','08:40:00',1.19),('15844','2013-07-06','08:45:00',1.25),('15844','2013-07-06','08:50:00',1.27),('15844','2013-07-06','08:55:00',1.33),('15844','2013-07-06','09:00:00',1.44),('15844','2013-07-06','09:05:00',1.54),('15844','2013-07-06','09:10:00',1.65),('15844','2013-07-06','09:15:00',1.71),('15844','2013-07-06','09:20:00',1.76),('15844','2013-07-06','09:25:00',1.86),('15844','2013-07-06','09:30:00',1.99),('15844','2013-07-06','09:35:00',2.16),('15844','2013-07-06','09:40:00',2.33),('15844','2013-07-06','09:45:00',2.47),('15844','2013-07-06','09:50:00',2.61),('15844','2013-07-06','09:55:00',2.74),('15844','2013-07-06','10:00:00',2.81),('15844','2013-07-06','10:05:00',2.91),('15844','2013-07-06','10:10:00',3),('15844','2013-07-06','10:15:00',3.09),('15844','2013-07-06','10:20:00',3.16),('15844','2013-07-06','10:25:00',3.25),('15844','2013-07-06','10:30:00',3.55),('15844','2013-07-06','10:35:00',3.65),('15844','2013-07-06','10:40:00',3.73),('15844','2013-07-06','10:45:00',3.79),('15844','2013-07-06','10:50:00',3.86),('15844','2013-07-06','10:55:00',4.02),('15844','2013-07-06','11:00:00',4.1),('15844','2013-07-06','11:05:00',4.17),('15844','2013-07-06','11:10:00',4.19),('15844','2013-07-06','11:15:00',4.23),('15844','2013-07-06','11:20:00',4.23),('15844','2013-07-06','11:25:00',4.24),('15844','2013-07-06','11:30:00',4.22),('15844','2013-07-06','11:35:00',4.24),('15844','2013-07-06','11:40:00',4.23),('15844','2013-07-06','11:45:00',4.26),('15844','2013-07-06','11:50:00',4.27),('15844','2013-07-06','11:55:00',4.29),('15844','2013-07-06','12:00:00',4.29),('15844','2013-07-06','12:05:00',4.3),('15844','2013-07-06','12:10:00',4.29),('15844','2013-07-06','12:15:00',4.27),('15844','2013-07-06','12:20:00',4.29),('15844','2013-07-06','12:25:00',4.33),('15844','2013-07-06','12:30:00',4.32),('15844','2013-07-06','12:35:00',4.32),('15844','2013-07-06','12:40:00',4.29),('15844','2013-07-06','12:45:00',4.26),('15844','2013-07-06','12:50:00',4.26),('15844','2013-07-06','12:55:00',4.26),('15844','2013-07-06','13:00:00',4.23),('15844','2013-07-06','13:05:00',4.23),('15844','2013-07-06','13:10:00',4.2),('15844','2013-07-06','13:15:00',4.13),('15844','2013-07-06','13:20:00',4.14),('15844','2013-07-06','13:25:00',4.15),('15844','2013-07-06','13:30:00',4.16),('15844','2013-07-06','13:35:00',4.14),('15844','2013-07-06','13:40:00',4.04),('15844','2013-07-06','13:45:00',4.07),('15844','2013-07-06','13:50:00',3.98),('15844','2013-07-06','13:55:00',3.93),('15844','2013-07-06','14:00:00',3.93),('15844','2013-07-06','14:05:00',3.87),('15844','2013-07-06','14:10:00',3.75),('15844','2013-07-06','14:15:00',3.7),('15844','2013-07-06','14:20:00',3.67),('15844','2013-07-06','14:25:00',3.6),('15844','2013-07-06','14:30:00',3.55),('15844','2013-07-06','14:35:00',3.48),('15844','2013-07-06','14:40:00',3.43),('15844','2013-07-06','14:45:00',3.37),('15844','2013-07-06','14:50:00',3.39),('15844','2013-07-06','14:55:00',3.34),('15844','2013-07-06','15:00:00',3.37),('15844','2013-07-06','15:05:00',3.35),('15844','2013-07-06','15:10:00',1.72),('15844','2013-07-06','15:15:00',1.31),('15844','2013-07-06','16:55:00',1.08),('15844','2013-07-06','17:00:00',1.09),('15844','2013-07-06','17:05:00',1.13),('15844','2013-07-06','17:10:00',1.35),('15844','2013-07-06','17:15:00',1.46),('15844','2013-07-06','17:20:00',1.12),('15844','2013-07-05','08:30:00',1.07),('15844','2013-07-05','08:35:00',1.16),('15844','2013-07-05','08:40:00',1.22),('15844','2013-07-05','08:45:00',1.27),('15844','2013-07-05','08:50:00',1.28),('15844','2013-07-05','08:55:00',1.36),('15844','2013-07-05','09:00:00',1.46),('15844','2013-07-05','09:05:00',1.55),('15844','2013-07-05','09:10:00',1.65),('15844','2013-07-05','09:15:00',1.74),('15844','2013-07-05','09:20:00',1.77),('15844','2013-07-05','09:25:00',1.87),('15844','2013-07-05','09:30:00',1.98),('15844','2013-07-05','09:35:00',2.14),('15844','2013-07-05','09:40:00',2.31),('15844','2013-07-05','09:45:00',2.45),('15844','2013-07-05','09:50:00',2.59),('15844','2013-07-05','09:55:00',2.72),('15844','2013-07-05','10:00:00',2.78),('15844','2013-07-05','10:05:00',2.88),('15844','2013-07-05','10:10:00',2.97),('15844','2013-07-05','10:15:00',3.06),('15844','2013-07-05','10:20:00',3.17),('15844','2013-07-05','10:25:00',3.25),('15844','2013-07-05','10:30:00',3.41),('15844','2013-07-05','10:35:00',3.58),('15844','2013-07-05','10:40:00',3.68),('15844','2013-07-05','10:45:00',3.74),('15844','2013-07-05','10:50:00',3.85),('15844','2013-07-05','10:55:00',3.93),('15844','2013-07-05','11:00:00',4),('15844','2013-07-05','11:05:00',4.03),('15844','2013-07-05','11:10:00',4.07),('15844','2013-07-05','11:15:00',4.15),('15844','2013-07-05','11:20:00',4.17),('15844','2013-07-05','11:25:00',4.2),('15844','2013-07-05','11:30:00',4.22),('15844','2013-07-05','11:35:00',4.16),('15844','2013-07-05','11:40:00',4.14),('15844','2013-07-05','11:45:00',4.16),('15844','2013-07-05','11:50:00',4.14),('15844','2013-07-05','11:55:00',4.14),('15844','2013-07-05','12:00:00',3.84),('15844','2013-07-05','12:05:00',3.1),('15844','2013-07-05','12:10:00',3.56),('15844','2013-07-05','12:15:00',3.88),('15844','2013-07-05','12:20:00',4),('15844','2013-07-05','12:25:00',4.38),('15844','2013-07-05','12:30:00',3.09),('15844','2013-07-05','12:35:00',3.76),('15844','2013-07-05','12:40:00',1.8),('15844','2013-07-05','12:45:00',2.48),('15844','2013-07-05','12:50:00',4.51),('15844','2013-07-05','12:55:00',1.95),('15844','2013-07-05','13:00:00',1.26),('15844','2013-07-05','13:05:00',3.91),('15844','2013-07-05','13:10:00',2.79),('15844','2013-07-05','13:15:00',2.93),('15844','2013-07-05','13:20:00',4.31),('15844','2013-07-05','13:25:00',4.28),('15844','2013-07-05','13:30:00',3.97),('15844','2013-07-05','13:35:00',4.2),('15844','2013-07-05','13:40:00',4.14),('15844','2013-07-05','13:45:00',4.1),('15844','2013-07-05','13:50:00',3.92),('15844','2013-07-05','13:55:00',3.94),('15844','2013-07-05','14:00:00',3.88),('15844','2013-07-05','14:05:00',3.85),('15844','2013-07-05','14:10:00',3.9),('15844','2013-07-05','14:15:00',3.8),('15844','2013-07-05','14:20:00',3.68),('15844','2013-07-05','14:25:00',3.59),('15844','2013-07-05','14:30:00',3.47),('15844','2013-07-05','14:35:00',3.44),('15844','2013-07-05','14:40:00',3.46),('15844','2013-07-05','14:45:00',3.42),('15844','2013-07-05','14:50:00',3.32),('15844','2013-07-05','14:55:00',3.24),('15844','2013-07-05','15:00:00',3.13),('15844','2013-07-05','15:05:00',3.08),('15844','2013-07-05','15:10:00',2.13),('15844','2013-07-05','15:15:00',2.03),('15844','2013-07-05','15:20:00',2.29),('15844','2013-07-05','15:25:00',2.57),('15844','2013-07-05','15:30:00',2.54),('15844','2013-07-05','15:35:00',2.31),('15844','2013-07-05','15:40:00',2.32),('15844','2013-07-05','15:45:00',2.25),('15844','2013-07-05','15:50:00',2.17),('15844','2013-07-05','15:55:00',2.03),('15844','2013-07-05','16:00:00',1.91),('15844','2013-07-05','16:05:00',1.85),('15844','2013-07-05','16:10:00',1.73),('15844','2013-07-05','16:15:00',1.67),('15844','2013-07-05','16:20:00',1.56),('15844','2013-07-05','16:25:00',1.51),('15844','2013-07-05','16:30:00',1.49),('15844','2013-07-05','16:35:00',1.44),('15844','2013-07-05','16:40:00',1.38),('15844','2013-07-05','16:45:00',1.3),('15844','2013-07-05','16:50:00',1.23),('15844','2013-07-05','16:55:00',1.11),('15844','2013-07-05','17:00:00',1),('15844','2013-07-04','11:20:00',1.11),('15844','2013-07-04','11:25:00',1.19),('15844','2013-07-04','11:30:00',1.27),('15844','2013-07-04','11:35:00',1.42),('15844','2013-07-04','11:40:00',1.43),('15844','2013-07-04','11:45:00',1.5),('15844','2013-07-04','11:50:00',1.48),('15844','2013-07-04','11:55:00',1.68),('15844','2013-07-04','12:00:00',1.81),('15844','2013-07-04','12:05:00',1.6),('15844','2013-07-04','12:10:00',1.27),('15844','2013-07-04','13:15:00',1.05),('15844','2013-07-04','13:20:00',1.33),('15844','2013-07-04','13:25:00',2.04),('15844','2013-07-04','13:30:00',2.14),('15844','2013-07-04','13:35:00',2.96),('15844','2013-07-04','13:40:00',3.58),('15844','2013-07-04','13:45:00',3.34),('15844','2013-07-04','13:50:00',2.09),('15844','2013-07-04','13:55:00',1.74),('15844','2013-07-04','14:00:00',3.5),('15844','2013-07-04','14:05:00',1.77),('15844','2013-07-04','14:10:00',1.51),('15844','2013-07-04','14:15:00',1.61),('15844','2013-07-04','14:20:00',1.88),('15844','2013-07-04','14:25:00',1.53),('15844','2013-07-04','14:30:00',1.46),('15844','2013-07-04','14:35:00',1.88),('15844','2013-07-04','14:40:00',1.82),('15844','2013-07-04','14:45:00',1.98),('15844','2013-07-04','14:50:00',1.53),('15844','2013-07-04','14:55:00',1.44),('15844','2013-07-04','15:00:00',1.64),('15844','2013-07-04','15:05:00',1.67),('15844','2013-07-04','15:10:00',2.35),('15844','2013-07-04','15:15:00',2.63),('15844','2013-07-04','15:20:00',2.19),('15844','2013-07-04','15:25:00',1.68),('15844','2013-07-04','15:30:00',2.41),('15844','2013-07-04','15:35:00',2.81),('15844','2013-07-04','15:40:00',1.89),('15844','2013-07-04','15:45:00',1.79),('15844','2013-07-04','15:50:00',2.19),('15844','2013-07-04','15:55:00',2.04),('15844','2013-07-04','16:00:00',1.59),('15844','2013-07-04','16:05:00',1.5),('15844','2013-07-04','16:10:00',1.61),('15844','2013-07-04','16:15:00',1.72),('15844','2013-07-04','16:20:00',1.7),('15844','2013-07-04','16:25:00',1.75),('15844','2013-07-04','16:30:00',1.66),('15844','2013-07-04','16:35:00',1.4),('15844','2013-07-04','16:40:00',1.22),('15844','2013-07-04','16:45:00',1.21),('15844','2013-07-04','16:50:00',1.13),('15844','2013-07-04','16:55:00',1.09),('15844','2013-07-04','17:00:00',1.15),('15844','2013-07-04','17:05:00',1.2),('15844','2013-07-04','17:10:00',1.07),('15844','2013-07-04','17:15:00',1.03),('15844','2013-07-04','17:20:00',1.12),('15844','2013-07-03','08:25:00',1.01),('15844','2013-07-03','08:30:00',1.11),('15844','2013-07-03','08:35:00',1.2),('15844','2013-07-03','08:40:00',1.26),('15844','2013-07-03','08:45:00',1.3),('15844','2013-07-03','08:50:00',1.33),('15844','2013-07-03','08:55:00',1.41),('15844','2013-07-03','09:00:00',1.49),('15844','2013-07-03','09:05:00',1.58),('15844','2013-07-03','09:10:00',1.68),('15844','2013-07-03','09:15:00',1.78),('15844','2013-07-03','09:20:00',1.84),('15844','2013-07-03','09:25:00',1.93),('15844','2013-07-03','09:30:00',2.05),('15844','2013-07-03','09:35:00',2.23),('15844','2013-07-03','09:40:00',2.35),('15844','2013-07-03','09:45:00',2.48),('15844','2013-07-03','09:50:00',2.62),('15844','2013-07-03','09:55:00',2.73),('15844','2013-07-03','10:00:00',2.9),('15844','2013-07-03','10:05:00',2.99),('15844','2013-07-03','10:10:00',3.05),('15844','2013-07-03','10:15:00',3.14),('15844','2013-07-03','10:20:00',3.25),('15844','2013-07-03','10:25:00',3.43),('15844','2013-07-03','10:30:00',3.66),('15844','2013-07-03','10:35:00',3.82),('15844','2013-07-03','10:40:00',3.91),('15844','2013-07-03','10:45:00',3.97),('15844','2013-07-03','10:50:00',4.01),('15844','2013-07-03','10:55:00',4.11),('15844','2013-07-03','11:00:00',4.13),('15844','2013-07-03','11:05:00',4.23),('15844','2013-07-03','11:10:00',4.23),('15844','2013-07-03','11:15:00',4.23),('15844','2013-07-03','11:20:00',4.33),('15844','2013-07-03','11:25:00',4.35),('15844','2013-07-03','11:30:00',4.38),('15844','2013-07-03','11:35:00',4.4),('15844','2013-07-03','11:40:00',4.44),('15844','2013-07-03','11:45:00',4.46),('15844','2013-07-03','11:50:00',4.46),('15844','2013-07-03','11:55:00',4.48),('15844','2013-07-03','12:00:00',4.48),('15844','2013-07-03','12:05:00',4.45),('15844','2013-07-03','12:10:00',4.47),('15844','2013-07-03','12:15:00',4.48),('15844','2013-07-03','12:20:00',4.46),('15844','2013-07-03','12:25:00',4.46),('15844','2013-07-03','12:30:00',4.47),('15844','2013-07-03','12:35:00',4.45),('15844','2013-07-03','12:40:00',4.44),('15844','2013-07-03','12:45:00',4.42),('15844','2013-07-03','12:50:00',4.38),('15844','2013-07-03','12:55:00',4.36),('15844','2013-07-03','13:00:00',4.36),('15844','2013-07-03','13:05:00',4.33),('15844','2013-07-03','13:10:00',4.32),('15844','2013-07-03','13:15:00',4.3),('15844','2013-07-03','13:20:00',4.29),('15844','2013-07-03','13:25:00',4.25),('15844','2013-07-03','13:30:00',4.21),('15844','2013-07-03','13:35:00',4.18),('15844','2013-07-03','13:40:00',4.15),('15844','2013-07-03','13:45:00',4.1),('15844','2013-07-03','13:50:00',4.07),('15844','2013-07-03','13:55:00',4.05),('15844','2013-07-03','14:00:00',4.02),('15844','2013-07-03','14:05:00',4),('15844','2013-07-03','14:10:00',3.94),('15844','2013-07-03','14:15:00',3.89),('15844','2013-07-03','14:20:00',3.85),('15844','2013-07-03','14:25:00',3.78),('15844','2013-07-03','14:30:00',3.68),('15844','2013-07-03','14:35:00',3.6),('15844','2013-07-03','14:40:00',3.55),('15844','2013-07-03','14:45:00',3.48),('15844','2013-07-03','14:50:00',3.38),('15844','2013-07-03','14:55:00',3.29),('15844','2013-07-03','15:00:00',3.18),('15844','2013-07-03','15:05:00',3.07),('15844','2013-07-03','15:10:00',2.97),('15844','2013-07-03','15:15:00',2.86),('15844','2013-07-03','15:20:00',2.75),('15844','2013-07-03','15:25:00',2.61),('15844','2013-07-03','15:30:00',2.5),('15844','2013-07-03','15:35:00',2.39),('15844','2013-07-03','15:40:00',2.27),('15844','2013-07-03','15:45:00',2.23),('15844','2013-07-03','15:50:00',2.16),('15844','2013-07-03','15:55:00',2.07),('15844','2013-07-03','16:00:00',1.97),('15844','2013-07-03','16:05:00',1.86),('15844','2013-07-03','16:10:00',1.77),('15844','2013-07-03','16:15:00',1.68),('15844','2013-07-03','16:20:00',1.59),('15844','2013-07-03','16:25:00',1.52),('15844','2013-07-03','16:30:00',1.48),('15844','2013-07-03','16:35:00',1.43),('15844','2013-07-03','16:40:00',1.37),('15844','2013-07-03','16:45:00',1.29),('15844','2013-07-03','16:50:00',1.19),('15844','2013-07-03','16:55:00',1.08),('15844','2013-07-02','08:30:00',1.09),('15844','2013-07-02','08:35:00',1.18),('15844','2013-07-02','08:40:00',1.26),('15844','2013-07-02','08:45:00',1.29),('15844','2013-07-02','08:50:00',1.3),('15844','2013-07-02','08:55:00',1.38),('15844','2013-07-02','09:00:00',1.49),('15844','2013-07-02','09:05:00',1.58),('15844','2013-07-02','09:10:00',1.66),('15844','2013-07-02','09:15:00',1.75),('15844','2013-07-02','09:20:00',1.82),('15844','2013-07-02','09:25:00',1.92),('15844','2013-07-02','09:30:00',2.06),('15844','2013-07-02','09:35:00',2.21),('15844','2013-07-02','09:40:00',2.35),('15844','2013-07-02','09:45:00',2.49),('15844','2013-07-02','09:50:00',2.63),('15844','2013-07-02','09:55:00',2.74),('15844','2013-07-02','10:00:00',2.82),('15844','2013-07-02','10:05:00',2.9),('15844','2013-07-02','10:10:00',2.98),('15844','2013-07-02','10:15:00',3.06),('15844','2013-07-02','10:20:00',3.13),('15844','2013-07-02','10:25:00',3.31),('15844','2013-07-02','10:30:00',3.43),('15844','2013-07-02','10:35:00',3.55),('15844','2013-07-02','10:40:00',3.69),('15844','2013-07-02','10:45:00',3.76),('15844','2013-07-02','10:50:00',3.81),('15844','2013-07-02','10:55:00',3.95),('15844','2013-07-02','11:00:00',4),('15844','2013-07-02','11:05:00',4.06),('15844','2013-07-02','11:10:00',4.11),('15844','2013-07-02','11:15:00',4.14),('15844','2013-07-02','11:20:00',4.14),('15844','2013-07-02','11:25:00',4.21),('15844','2013-07-02','11:30:00',4.21),('15844','2013-07-02','11:35:00',4.17),('15844','2013-07-02','11:40:00',4.24),('15844','2013-07-02','11:45:00',4.23),('15844','2013-07-02','11:50:00',4.22),('15844','2013-07-02','11:55:00',4.23),('15844','2013-07-02','12:00:00',4.25),('15844','2013-07-02','12:05:00',4.37),('15844','2013-07-02','12:10:00',4.39),('15844','2013-07-02','12:15:00',4.31),('15844','2013-07-02','12:20:00',4.31),('15844','2013-07-02','12:25:00',4.25),('15844','2013-07-02','12:30:00',4.24),('15844','2013-07-02','12:35:00',4.14),('15844','2013-07-02','12:40:00',4.34),('15844','2013-07-02','12:45:00',4.26),('15844','2013-07-02','12:50:00',4.17),('15844','2013-07-02','12:55:00',4.18),('15844','2013-07-02','13:00:00',4.16),('15844','2013-07-02','13:05:00',4.14),('15844','2013-07-02','13:10:00',4.12),('15844','2013-07-02','13:15:00',4.17),('15844','2013-07-02','13:20:00',4.15),('15844','2013-07-02','13:25:00',4.08),('15844','2013-07-02','13:30:00',4.05),('15844','2013-07-02','13:35:00',4),('15844','2013-07-02','13:40:00',4),('15844','2013-07-02','13:45:00',3.99),('15844','2013-07-02','13:50:00',3.95),('15844','2013-07-02','13:55:00',3.9),('15844','2013-07-02','14:00:00',3.89),('15844','2013-07-02','14:05:00',3.81),('15844','2013-07-02','14:10:00',3.74),('15844','2013-07-02','14:15:00',3.68),('15844','2013-07-02','14:20:00',3.69),('15844','2013-07-02','14:25:00',3.63),('15844','2013-07-02','14:30:00',3.55),('15844','2013-07-02','14:35:00',3.51),('15844','2013-07-02','14:40:00',3.46),('15844','2013-07-02','14:45:00',3.42),('15844','2013-07-02','14:50:00',3.33),('15844','2013-07-02','14:55:00',3.2),('15844','2013-07-02','15:00:00',3.11),('15844','2013-07-02','15:05:00',3.02),('15844','2013-07-02','15:10:00',2.91),('15844','2013-07-02','15:15:00',2.78),('15844','2013-07-02','15:20:00',2.68),('15844','2013-07-02','15:25:00',2.58),('15844','2013-07-02','15:30:00',2.46),('15844','2013-07-02','15:35:00',2.35),('15844','2013-07-02','15:40:00',2.27),('15844','2013-07-02','15:45:00',2.21),('15844','2013-07-02','15:50:00',2.12),('15844','2013-07-02','15:55:00',2.04),('15844','2013-07-02','16:00:00',1.94),('15844','2013-07-02','16:05:00',1.85),('15844','2013-07-02','16:10:00',1.76),('15844','2013-07-02','16:15:00',1.68),('15844','2013-07-02','16:20:00',1.58),('15844','2013-07-02','16:25:00',1.52),('15844','2013-07-02','16:30:00',1.48),('15844','2013-07-02','16:35:00',1.44),('15844','2013-07-02','16:40:00',1.37),('15844','2013-07-02','16:45:00',1.29),('15844','2013-07-02','16:50:00',1.2),('15844','2013-07-02','16:55:00',1.08),('15844','2013-07-01','08:25:00',1.03),('15844','2013-07-01','08:30:00',1.12),('15844','2013-07-01','08:35:00',1.2),('15844','2013-07-01','08:40:00',1.26),('15844','2013-07-01','08:45:00',1.31),('15844','2013-07-01','08:50:00',1.33),('15844','2013-07-01','08:55:00',1.41),('15844','2013-07-01','09:00:00',1.52),('15844','2013-07-01','09:05:00',1.6),('15844','2013-07-01','09:10:00',1.69),('15844','2013-07-01','09:15:00',1.8),('15844','2013-07-01','09:20:00',1.87),('15844','2013-07-01','09:25:00',1.98),('15844','2013-07-01','09:30:00',2.15),('15844','2013-07-01','09:35:00',2.3),('15844','2013-07-01','09:40:00',2.44),('15844','2013-07-01','09:45:00',2.57),('15844','2013-07-01','09:50:00',2.69),('15844','2013-07-01','09:55:00',2.82),('15844','2013-07-01','10:00:00',2.92),('15844','2013-07-01','10:05:00',3.01),('15844','2013-07-01','10:10:00',3.12),('15844','2013-07-01','10:15:00',3.19),('15844','2013-07-01','10:20:00',3.27),('15844','2013-07-01','10:25:00',3.34),('15844','2013-07-01','10:30:00',3.58),('15844','2013-07-01','10:35:00',3.79),('15844','2013-07-01','10:40:00',3.95),('15844','2013-07-01','10:45:00',3.98),('15844','2013-07-01','10:50:00',4.03),('15844','2013-07-01','10:55:00',4.15),('15844','2013-07-01','11:00:00',4.24),('15844','2013-07-01','11:05:00',4.29),('15844','2013-07-01','11:10:00',4.31),('15844','2013-07-01','11:15:00',4.33),('15844','2013-07-01','11:20:00',4.35),('15844','2013-07-01','11:25:00',4.36),('15844','2013-07-01','11:30:00',4.39),('15844','2013-07-01','11:35:00',4.4),('15844','2013-07-01','11:40:00',4.36),('15844','2013-07-01','11:45:00',4.33),('15844','2013-07-01','11:50:00',4.4),('15844','2013-07-01','11:55:00',4.43),('15844','2013-07-01','12:00:00',4.43),('15844','2013-07-01','12:05:00',4.42),('15844','2013-07-01','12:10:00',4.41),('15844','2013-07-01','12:15:00',4.44),('15844','2013-07-01','12:20:00',4.41),('15844','2013-07-01','12:25:00',4.4),('15844','2013-07-01','12:30:00',4.43),('15844','2013-07-01','12:35:00',4.42),('15844','2013-07-01','12:40:00',4.25),('15844','2013-07-01','12:45:00',4.14),('15844','2013-07-01','12:50:00',4.18),('15844','2013-07-01','12:55:00',4.3),('15844','2013-07-01','13:00:00',4.15),('15844','2013-07-01','13:05:00',4.21),('15844','2013-07-01','13:10:00',4.21),('15844','2013-07-01','13:15:00',3.84),('15844','2013-07-01','13:20:00',4.33),('15844','2013-07-01','13:25:00',4.29),('15844','2013-07-01','13:30:00',4.19),('15844','2013-07-01','13:35:00',4.03),('15844','2013-07-01','13:40:00',3.95),('15844','2013-07-01','13:45:00',3.99),('15844','2013-07-01','13:50:00',3.93),('15844','2013-07-01','13:55:00',3.9),('15844','2013-07-01','14:00:00',3.85),('15844','2013-07-01','14:05:00',3.85),('15844','2013-07-01','14:10:00',3.83),('15844','2013-07-01','14:15:00',3.83),('15844','2013-07-01','14:20:00',3.75),('15844','2013-07-01','14:25:00',3.65),('15844','2013-07-01','14:30:00',3.59),('15844','2013-07-01','14:35:00',3.58),('15844','2013-07-01','14:40:00',3.5),('15844','2013-07-01','14:45:00',3.43),('15844','2013-07-01','14:50:00',3.32),('15844','2013-07-01','14:55:00',3.24),('15844','2013-07-01','15:00:00',3.15),('15844','2013-07-01','15:05:00',2.94),('15844','2013-07-01','15:10:00',2.94),('15844','2013-07-01','15:15:00',2.83),('15844','2013-07-01','15:20:00',2.71),('15844','2013-07-01','15:25:00',2.57),('15844','2013-07-01','15:30:00',2.45),('15844','2013-07-01','15:35:00',2.35),('15844','2013-07-01','15:40:00',2.29),('15844','2013-07-01','15:45:00',2.24),('15844','2013-07-01','15:50:00',2.15),('15844','2013-07-01','15:55:00',2.05),('15844','2013-07-01','16:00:00',1.98),('15844','2013-07-01','16:05:00',1.85),('15844','2013-07-01','16:10:00',1.71),('15844','2013-07-01','16:15:00',1.68),('15844','2013-07-01','16:20:00',1.62),('15844','2013-07-01','16:25:00',1.54),('15844','2013-07-01','16:30:00',1.48),('15844','2013-07-01','16:35:00',1.46),('15844','2013-07-01','16:40:00',1.39),('15844','2013-07-01','16:45:00',1.31),('15844','2013-07-01','16:50:00',1.22),('15844','2013-07-01','16:55:00',1.1),('15844','2014-04-05','09:25:00',1.34),('15844','2014-04-05','09:30:00',1.46),('15844','2014-04-05','09:35:00',1.39),('15844','2014-04-05','09:40:00',1.54),('15844','2014-04-05','09:45:00',1.87),('15844','2014-04-05','09:50:00',3.08),('15844','2014-04-05','09:55:00',2.83),('15844','2014-04-05','10:00:00',2.27),('15844','2014-04-05','10:05:00',1.69),('15844','2014-04-05','10:10:00',1.8),('15844','2014-04-05','10:15:00',1.78),('15844','2014-04-05','10:20:00',1.92),('15844','2014-04-05','10:25:00',2.6),('15844','2014-04-05','10:30:00',3.16),('15844','2014-04-05','10:35:00',3.45),('15844','2014-04-05','10:40:00',3.11),('15844','2014-04-05','10:45:00',3.26),('15844','2014-04-05','10:50:00',3.3),('15844','2014-04-05','10:55:00',3.13),('15844','2014-04-05','11:00:00',3.28),('15844','2014-04-05','11:05:00',3.09),('15844','2014-04-05','11:10:00',2.43),('15844','2014-04-05','11:15:00',2.83),('15844','2014-04-05','11:20:00',3.25),('15844','2014-04-05','11:25:00',3.64),('15844','2014-04-05','11:30:00',3.84),('15844','2014-04-05','11:35:00',3.8),('15844','2014-04-05','11:40:00',3.3),('15844','2014-04-05','11:45:00',3.45),('15844','2014-04-05','11:50:00',2.83),('15844','2014-04-05','11:55:00',2.62),('15844','2014-04-05','12:00:00',2.29),('15844','2014-04-05','12:05:00',2.36),('15844','2014-04-05','12:10:00',2.8),('15844','2014-04-05','12:15:00',2.62),('15844','2014-04-05','12:20:00',2.45),('15844','2014-04-05','12:25:00',2.43),('15844','2014-04-05','12:30:00',2.92),('15844','2014-04-05','12:35:00',3.37),('15844','2014-04-05','12:40:00',3.48),('15844','2014-04-05','12:45:00',3.34),('15844','2014-04-05','12:50:00',2.19),('15844','2014-04-05','12:55:00',2.41),('15844','2014-04-05','13:00:00',2.5),('15844','2014-04-05','13:05:00',3.89),('15844','2014-04-05','13:10:00',4.57),('15844','2014-04-05','13:15:00',1.82),('15844','2014-04-05','13:20:00',1.99),('15844','2014-04-05','13:25:00',3.38),('15844','2014-04-05','13:30:00',3.04),('15844','2014-04-05','13:35:00',2.9),('15844','2014-04-05','13:40:00',1.69),('15844','2014-04-05','13:45:00',2.38),('15844','2014-04-05','13:50:00',3.45),('15844','2014-04-05','13:55:00',3.72),('15844','2014-04-05','14:00:00',4.06),('15844','2014-04-05','14:05:00',4.25),('15844','2014-04-05','14:10:00',1.72),('15844','2014-04-05','14:55:00',2.6),('15844','2014-04-05','15:00:00',2.03),('15844','2014-04-05','15:05:00',2.7),('15844','2014-04-05','15:10:00',2.59),('15844','2014-04-05','15:15:00',2.46),('15844','2014-04-05','15:20:00',2.36),('15844','2014-04-05','15:25:00',2.43),('15844','2014-04-05','15:30:00',1.56),('15844','2014-04-05','15:35:00',1.39),('15844','2014-04-05','15:40:00',1.91),('15844','2014-04-05','15:45:00',1.25),('15844','2014-04-05','16:05:00',1.02),('15844','2014-04-05','16:10:00',1.05),('15844','2014-04-05','16:15:00',1.08),('15844','2014-04-05','16:25:00',1.34),('15844','2014-04-05','16:30:00',1.48),('15844','2014-04-05','16:35:00',1.45),('15844','2014-04-05','16:40:00',1.38),('15844','2014-04-05','16:45:00',1.14),('15844','2013-06-30','08:25:00',1.06),('15844','2013-06-30','08:30:00',1.15),('15844','2013-06-30','08:35:00',1.24),('15844','2013-06-30','08:40:00',1.32),('15844','2013-06-30','08:45:00',1.35),('15844','2013-06-30','08:50:00',1.36),('15844','2013-06-30','08:55:00',1.44),('15844','2013-06-30','09:00:00',1.57),('15844','2013-06-30','09:05:00',1.66),('15844','2013-06-30','09:10:00',1.73),('15844','2013-06-30','09:15:00',1.84),('15844','2013-06-30','09:20:00',1.92),('15844','2013-06-30','09:25:00',2.01),('15844','2013-06-30','09:30:00',2.18),('15844','2013-06-30','09:35:00',2.34),('15844','2013-06-30','09:40:00',2.5),('15844','2013-06-30','09:45:00',2.62),('15844','2013-06-30','09:50:00',2.78),('15844','2013-06-30','09:55:00',2.88),('15844','2013-06-30','10:00:00',2.97),('15844','2013-06-30','10:05:00',3.05),('15844','2013-06-30','10:10:00',3.18),('15844','2013-06-30','10:15:00',3.3),('15844','2013-06-30','10:20:00',3.43),('15844','2013-06-30','10:25:00',3.57),('15844','2013-06-30','10:30:00',3.7),('15844','2013-06-30','10:35:00',3.85),('15844','2013-06-30','10:40:00',3.94),('15844','2013-06-30','10:45:00',4.01),('15844','2013-06-30','10:50:00',4.08),('15844','2013-06-30','10:55:00',4.18),('15844','2013-06-30','11:00:00',4.24),('15844','2013-06-30','11:05:00',4.28),('15844','2013-06-30','11:10:00',4.33),('15844','2013-06-30','11:15:00',4.35),('15844','2013-06-30','11:20:00',4.38),('15844','2013-06-30','11:25:00',4.43),('15844','2013-06-30','11:30:00',4.43),('15844','2013-06-30','11:35:00',4.46),('15844','2013-06-30','11:40:00',4.45),('15844','2013-06-30','11:45:00',4.47),('15844','2013-06-30','11:50:00',4.43),('15844','2013-06-30','11:55:00',4.42),('15844','2013-06-30','12:00:00',4.39),('15844','2013-06-30','12:05:00',4.42),('15844','2013-06-30','12:10:00',4.41),('15844','2013-06-30','12:15:00',4.41),('15844','2013-06-30','12:20:00',4.44),('15844','2013-06-30','12:25:00',4.41),('15844','2013-06-30','12:30:00',4.37),('15844','2013-06-30','12:35:00',4.39),('15844','2013-06-30','12:40:00',4.38),('15844','2013-06-30','12:45:00',3.61),('15844','2013-06-30','12:50:00',4.41),('15844','2013-06-30','12:55:00',3.09),('15844','2013-06-30','13:00:00',4.08),('15844','2013-06-30','13:05:00',3.42),('15844','2013-06-30','13:10:00',2.16),('15844','2013-06-30','13:15:00',2.37),('15844','2013-06-30','13:20:00',4.12),('15844','2013-06-30','13:25:00',2.55),('15844','2013-06-30','13:30:00',1.72),('15844','2013-06-30','13:35:00',1.77),('15844','2013-06-30','13:40:00',4.55),('15844','2013-06-30','13:45:00',4.43),('15844','2013-06-30','13:50:00',4.3),('15844','2013-06-30','13:55:00',4.1),('15844','2013-06-30','14:00:00',3.41),('15844','2013-06-30','14:05:00',2.76),('15844','2013-06-30','14:10:00',4),('15844','2013-06-30','14:15:00',3.93),('15844','2013-06-30','14:20:00',3.79),('15844','2013-06-30','14:25:00',3.73),('15844','2013-06-30','14:30:00',3.62),('15844','2013-06-30','14:35:00',3.53),('15844','2013-06-30','14:40:00',3.5),('15844','2013-06-30','14:45:00',3.43),('15844','2013-06-30','14:50:00',3.34),('15844','2013-06-30','14:55:00',3.28),('15844','2013-06-30','15:00:00',3.2),('15844','2013-06-30','15:05:00',3.1),('15844','2013-06-30','15:10:00',2.96),('15844','2013-06-30','15:15:00',2.89),('15844','2013-06-30','15:20:00',2.8),('15844','2013-06-30','15:25:00',2.67),('15844','2013-06-30','15:30:00',2.57),('15844','2013-06-30','15:35:00',2.45),('15844','2013-06-30','15:40:00',2.33),('15844','2013-06-30','15:45:00',2.26),('15844','2013-06-30','15:50:00',2.18),('15844','2013-06-30','15:55:00',2.11),('15844','2013-06-30','16:00:00',2.01),('15844','2013-06-30','16:05:00',1.93),('15844','2013-06-30','16:10:00',1.84),('15844','2013-06-30','16:15:00',1.77),('15844','2013-06-30','16:20:00',1.71),('15844','2013-06-30','16:25:00',1.65),('15844','2013-06-30','16:30:00',1.59),('15844','2013-06-30','16:35:00',1.49),('15844','2013-06-30','16:40:00',1.43),('15844','2013-06-30','16:45:00',1.34),('15844','2013-06-30','16:50:00',1.22),('15844','2013-06-30','16:55:00',1.1),('15844','2013-06-30','17:00:00',1.01),('15844','2013-06-29','07:50:00',1.09),('15844','2013-06-29','07:55:00',1.14),('15844','2013-06-29','08:35:00',1.09),('15844','2013-06-29','08:40:00',1.29),('15844','2013-06-29','08:45:00',1.37),('15844','2013-06-29','08:50:00',1.36),('15844','2013-06-29','08:55:00',1.44),('15844','2013-06-29','09:00:00',1.56),('15844','2013-06-29','09:05:00',1.65),('15844','2013-06-29','09:10:00',1.73),('15844','2013-06-29','09:15:00',1.83),('15844','2013-06-29','09:20:00',1.91),('15844','2013-06-29','09:25:00',2.01),('15844','2013-06-29','09:30:00',2.17),('15844','2013-06-29','09:35:00',2.33),('15844','2013-06-29','09:40:00',2.47),('15844','2013-06-29','09:45:00',2.59),('15844','2013-06-29','09:50:00',2.76),('15844','2013-06-29','09:55:00',2.87),('15844','2013-06-29','10:00:00',2.97),('15844','2013-06-29','10:05:00',3.07),('15844','2013-06-29','10:10:00',3.13),('15844','2013-06-29','10:15:00',3.22),('15844','2013-06-29','10:20:00',3.29),('15844','2013-06-29','10:25:00',3.39),('15844','2013-06-29','10:30:00',3.63),('15844','2013-06-29','10:35:00',3.87),('15844','2013-06-29','10:40:00',4),('15844','2013-06-29','10:45:00',4.05),('15844','2013-06-29','10:50:00',1.53),('15844','2013-06-29','10:55:00',2.4),('15844','2013-06-29','11:00:00',4.34),('15844','2013-06-29','11:05:00',1.42),('15844','2013-06-29','11:15:00',3.18),('15844','2013-06-29','11:20:00',4.26),('15844','2013-06-29','11:25:00',4.88),('15844','2013-06-29','11:30:00',3.18),('15844','2013-06-29','11:40:00',4.45),('15844','2013-06-29','11:45:00',3.95),('15844','2013-06-29','11:50:00',1.91),('15844','2013-06-29','11:55:00',4.88),('15844','2013-06-29','12:00:00',3.04),('15844','2013-06-29','12:05:00',4.75),('15844','2013-06-29','12:10:00',4.72),('15844','2013-06-29','12:15:00',4.74),('15844','2013-06-29','12:20:00',4.7),('15844','2013-06-29','12:25:00',4.71),('15844','2013-06-29','12:30:00',4.75),('15844','2013-06-29','12:35:00',4.84),('15844','2013-06-29','12:40:00',4.43),('15844','2013-06-29','12:45:00',4.49),('15844','2013-06-29','12:50:00',3.75),('15844','2013-06-29','12:55:00',4.54),('15844','2013-06-29','13:00:00',4.61),('15844','2013-06-29','13:05:00',4.73),('15844','2013-06-29','13:10:00',3.8),('15844','2013-06-29','13:15:00',2.61),('15844','2013-06-29','13:20:00',1.24),('15844','2013-06-29','13:25:00',1.19),('15844','2013-06-29','13:30:00',3.39),('15844','2013-06-29','13:35:00',4.59),('15844','2013-06-29','13:40:00',4.29),('15844','2013-06-29','13:45:00',4.42),('15844','2013-06-29','13:50:00',4.32),('15844','2013-06-29','13:55:00',4.11),('15844','2013-06-29','14:00:00',4.19),('15844','2013-06-29','14:05:00',4.07),('15844','2013-06-29','14:10:00',4.13),('15844','2013-06-29','14:15:00',4.27),('15844','2013-06-29','14:20:00',4.07),('15844','2013-06-29','14:25:00',3.91),('15844','2013-06-29','14:30:00',3.87),('15844','2013-06-29','14:35:00',3.86),('15844','2013-06-29','14:40:00',3.81),('15844','2013-06-29','14:45:00',3.83),('15844','2013-06-29','14:50:00',3.84),('15844','2013-06-29','14:55:00',4.04),('15844','2013-06-29','15:00:00',3.95),('15844','2013-06-29','15:05:00',4.17),('15844','2013-06-29','15:10:00',3.87),('15844','2013-06-29','15:15:00',4.06),('15844','2013-06-29','15:20:00',2.61),('15844','2013-06-29','15:25:00',1.57),('15844','2013-06-29','15:30:00',1.36),('15844','2013-06-29','16:30:00',1.06),('15844','2013-06-29','16:35:00',1.46),('15844','2013-06-29','16:40:00',2.11),('15844','2013-06-29','16:45:00',1.9),('15844','2013-06-29','16:50:00',1.13),('15844','2013-06-29','16:55:00',1.14),('15844','2013-06-29','17:00:00',1.19),('15844','2013-06-29','17:10:00',1.02),('15844','2013-06-29','17:15:00',1.21),('15844','2013-06-29','17:20:00',1.26),('15844','2013-06-29','17:25:00',1.14),('15844','2013-06-28','08:25:00',1.05),('15844','2013-06-28','08:30:00',1.13),('15844','2013-06-28','08:35:00',1.23),('15844','2013-06-28','08:40:00',1.33),('15844','2013-06-28','08:45:00',1.38),('15844','2013-06-28','08:50:00',1.32),('15844','2013-06-28','08:55:00',1.4),('15844','2013-06-28','09:00:00',1.63),('15844','2013-06-28','09:05:00',1.7),('15844','2013-06-28','09:10:00',1.87),('15844','2013-06-28','09:15:00',1.23),('15844','2013-06-28','09:20:00',2.08),('15844','2013-06-28','09:25:00',2.35),('15844','2013-06-28','09:30:00',2.34),('15844','2013-06-28','09:35:00',2.4),('15844','2013-06-28','09:40:00',1.71),('15844','2013-06-28','09:50:00',3.11),('15844','2013-06-28','09:55:00',3.36),('15844','2013-06-28','10:00:00',2.85),('15844','2013-06-28','10:05:00',2.85),('15844','2013-06-28','10:10:00',1.27),('15844','2013-06-28','10:20:00',2.2),('15844','2013-06-28','10:25:00',1.79),('15844','2013-06-28','10:30:00',1.07),('15844','2013-06-28','10:35:00',2.63),('15844','2013-06-28','10:40:00',2.95),('15844','2013-06-28','10:45:00',2.63),('15844','2013-06-28','10:50:00',4.37),('15844','2013-06-28','10:55:00',4.69),('15844','2013-06-28','11:00:00',4.14),('15844','2013-06-28','11:05:00',1.48),('15844','2013-06-28','11:10:00',1.74),('15844','2013-06-28','11:15:00',4.46),('15844','2013-06-28','11:20:00',4.35),('15844','2013-06-28','11:25:00',4.71),('15844','2013-06-28','11:30:00',4.63),('15844','2013-06-28','11:35:00',4.23),('15844','2013-06-28','11:40:00',3.87),('15844','2013-06-28','11:45:00',4.52),('15844','2013-06-28','11:50:00',4.67),('15844','2013-06-28','11:55:00',3.75),('15844','2013-06-28','12:00:00',3.04),('15844','2013-06-28','12:05:00',3.81),('15844','2013-06-28','12:10:00',4.46),('15844','2013-06-28','12:15:00',3.87),('15844','2013-06-28','12:20:00',4.02),('15844','2013-06-28','12:25:00',3.79),('15844','2013-06-28','12:30:00',4.67),('15844','2013-06-28','12:35:00',4.6),('15844','2013-06-28','12:40:00',4.6),('15844','2013-06-28','12:45:00',4.26),('15844','2013-06-28','12:50:00',4.63),('15844','2013-06-28','12:55:00',4.6),('15844','2013-06-28','13:00:00',4.51),('15844','2013-06-28','13:05:00',4.47),('15844','2013-06-28','13:10:00',4.46),('15844','2013-06-28','13:15:00',4.38),('15844','2013-06-28','13:20:00',4.4),('15844','2013-06-28','13:25:00',4.22),('15844','2013-06-28','13:30:00',4.29),('15844','2013-06-28','13:35:00',4.27),('15844','2013-06-28','13:40:00',4.4),('15844','2013-06-28','13:45:00',4.07),('15844','2013-06-28','13:50:00',4.25),('15844','2013-06-28','13:55:00',4.15),('15844','2013-06-28','14:00:00',4.34),('15844','2013-06-28','14:05:00',3.67),('15844','2013-06-28','14:10:00',2.39),('15844','2013-06-28','14:15:00',3.57),('15844','2013-06-28','14:20:00',4.05),('15844','2013-06-28','14:25:00',3.38),('15844','2013-06-28','14:30:00',1.9),('15844','2013-06-28','14:35:00',3.49),('15844','2013-06-28','14:40:00',2.74),('15844','2013-06-28','14:45:00',3.2),('15844','2013-06-28','14:50:00',1.01),('15844','2013-06-28','14:55:00',3.14),('15844','2013-06-28','15:00:00',2.17),('15844','2013-06-28','15:05:00',3.34),('15844','2013-06-28','15:10:00',1.12),('15844','2013-06-28','15:15:00',2.4),('15844','2013-06-28','15:20:00',2.1),('15844','2013-06-28','15:25:00',1.98),('15844','2013-06-28','15:30:00',2.37),('15844','2013-06-28','15:35:00',1.87),('15844','2013-06-28','15:40:00',1.36),('15844','2013-06-28','15:45:00',1.92),('15844','2013-06-28','15:50:00',2.48),('15844','2013-06-28','15:55:00',2.26),('15844','2013-06-28','16:00:00',1.81),('15844','2013-06-28','16:05:00',1.64),('15844','2013-06-28','16:10:00',1.95),('15844','2013-06-28','16:15:00',1.08),('15844','2013-06-28','16:20:00',1.96),('15844','2013-06-28','16:25:00',1.87),('15844','2013-06-28','16:30:00',1.14),('15844','2013-06-28','16:35:00',2.12),('15844','2013-06-28','16:40:00',2.03),('15844','2013-06-28','16:45:00',1.9),('15844','2013-06-28','16:50:00',1.73),('15844','2013-06-28','16:55:00',1.37),('15844','2013-06-28','17:00:00',1.14),('15844','2013-06-27','08:25:00',1.09),('15844','2013-06-27','08:30:00',1.16),('15844','2013-06-27','08:35:00',1.22),('15844','2013-06-27','08:40:00',1.3),('15844','2013-06-27','08:45:00',1.32),('15844','2013-06-27','08:55:00',1.02),('15844','2013-06-27','09:00:00',1.44),('15844','2013-06-27','09:05:00',1.71),('15844','2013-06-27','09:10:00',1.79),('15844','2013-06-27','09:15:00',1.9),('15844','2013-06-27','09:20:00',1.95),('15844','2013-06-27','09:25:00',2.06),('15844','2013-06-27','09:30:00',2.25),('15844','2013-06-27','09:35:00',2.38),('15844','2013-06-27','09:40:00',2.5),('15844','2013-06-27','09:45:00',2.63),('15844','2013-06-27','09:50:00',2.81),('15844','2013-06-27','09:55:00',2.9),('15844','2013-06-27','10:00:00',2.98),('15844','2013-06-27','10:05:00',3.07),('15844','2013-06-27','10:10:00',3.19),('15844','2013-06-27','10:15:00',3.29),('15844','2013-06-27','10:20:00',3.49),('15844','2013-06-27','10:25:00',3.69),('15844','2013-06-27','10:30:00',3.89),('15844','2013-06-27','10:35:00',3.66),('15844','2013-06-27','10:40:00',1.89),('15844','2013-06-27','10:45:00',1.58),('15844','2013-06-27','10:50:00',2.79),('15844','2013-06-27','10:55:00',4.54),('15844','2013-06-27','11:00:00',2.7),('15844','2013-06-27','11:05:00',4.11),('15844','2013-06-27','11:10:00',1.7),('15844','2013-06-27','11:15:00',4.46),('15844','2013-06-27','11:20:00',4.03),('15844','2013-06-27','11:25:00',4.55),('15844','2013-06-27','11:30:00',3.15),('15844','2013-06-27','11:35:00',1.43),('15844','2013-06-27','11:40:00',1.09),('15844','2013-06-27','11:45:00',1.19),('15844','2013-06-27','11:50:00',1.98),('15844','2013-06-27','11:55:00',2.91),('15844','2013-06-27','12:00:00',3.51),('15844','2013-06-27','12:05:00',1.19),('15844','2013-06-27','12:10:00',1.28),('15844','2013-06-27','12:15:00',1.39),('15844','2013-06-27','12:20:00',1.55),('15844','2013-06-27','12:25:00',1.17),('15844','2013-06-27','12:30:00',1.05),('15844','2013-06-27','12:35:00',1.11),('15844','2013-06-27','12:40:00',1.27),('15844','2013-06-27','12:45:00',1.84),('15844','2013-06-27','12:50:00',4.22),('15844','2013-06-27','12:55:00',1.73),('15844','2013-06-27','13:00:00',3),('15844','2013-06-27','13:05:00',3.76),('15844','2013-06-27','13:10:00',1.54),('15844','2013-06-27','13:15:00',1.41),('15844','2013-06-27','13:20:00',2.22),('15844','2013-06-27','13:25:00',4.04),('15844','2013-06-27','13:30:00',1.72),('15844','2013-06-27','13:35:00',2.13),('15844','2013-06-27','13:40:00',3.36),('15844','2013-06-27','13:45:00',3.62),('15844','2013-06-27','13:50:00',4.31),('15844','2013-06-27','13:55:00',4.24),('15844','2013-06-27','14:00:00',4.09),('15844','2013-06-27','14:05:00',3.94),('15844','2013-06-27','14:10:00',3.82),('15844','2013-06-27','14:15:00',3.74),('15844','2013-06-27','14:20:00',3.81),('15844','2013-06-27','14:25:00',3.94),('15844','2013-06-27','14:30:00',4),('15844','2013-06-27','14:35:00',3.61),('15844','2013-06-27','14:40:00',1.54),('15844','2013-06-27','14:45:00',2.57),('15844','2013-06-27','14:50:00',3.43),('15844','2013-06-27','14:55:00',3.22),('15844','2013-06-27','15:00:00',3.13),('15844','2013-06-27','15:05:00',3.02),('15844','2013-06-27','15:10:00',2.92),('15844','2013-06-27','15:15:00',2.81),('15844','2013-06-27','15:20:00',2.73),('15844','2013-06-27','15:25:00',2.6),('15844','2013-06-27','15:30:00',2.49),('15844','2013-06-27','15:35:00',2.36),('15844','2013-06-27','15:40:00',2.28),('15844','2013-06-27','15:45:00',2.22),('15844','2013-06-27','15:50:00',2.14),('15844','2013-06-27','15:55:00',2.03),('15844','2013-06-27','16:00:00',1.93),('15844','2013-06-27','16:05:00',1.86),('15844','2013-06-27','16:10:00',1.79),('15844','2013-06-27','16:15:00',1.7),('15844','2013-06-27','16:20:00',1.63),('15844','2013-06-27','16:25:00',1.57),('15844','2013-06-27','16:30:00',1.5),('15844','2013-06-27','16:35:00',1.45),('15844','2013-06-27','16:40:00',1.43),('15844','2013-06-27','16:45:00',1.34),('15844','2013-06-27','16:50:00',1.25),('15844','2013-06-27','16:55:00',1.14),('15844','2013-06-27','17:00:00',1.02),('15844','2013-06-26','08:25:00',1.09),('15844','2013-06-26','08:30:00',1.16),('15844','2013-06-26','08:35:00',1.22),('15844','2013-06-26','08:40:00',1.31),('15844','2013-06-26','08:45:00',1.34),('15844','2013-06-26','08:50:00',1.37),('15844','2013-06-26','08:55:00',1.47),('15844','2013-06-26','09:00:00',1.57),('15844','2013-06-26','09:05:00',1.64),('15844','2013-06-26','09:10:00',1.72),('15844','2013-06-26','09:15:00',1.81),('15844','2013-06-26','09:20:00',1.91),('15844','2013-06-26','09:25:00',2.01),('15844','2013-06-26','09:30:00',2.17),('15844','2013-06-26','09:35:00',2.3),('15844','2013-06-26','09:40:00',2.41),('15844','2013-06-26','09:45:00',2.53),('15844','2013-06-26','09:50:00',2.71),('15844','2013-06-26','09:55:00',2.84),('15844','2013-06-26','10:00:00',2.92),('15844','2013-06-26','10:05:00',3.03),('15844','2013-06-26','10:10:00',3.16),('15844','2013-06-26','10:15:00',3.32),('15844','2013-06-26','10:20:00',3.38),('15844','2013-06-26','10:25:00',3.48),('15844','2013-06-26','10:30:00',3.62),('15844','2013-06-26','10:35:00',3.7),('15844','2013-06-26','10:40:00',3.85),('15844','2013-06-26','10:45:00',3.94),('15844','2013-06-26','10:50:00',4.01),('15844','2013-06-26','10:55:00',4.1),('15844','2013-06-26','11:00:00',4.16),('15844','2013-06-26','11:05:00',4.19),('15844','2013-06-26','11:10:00',4.22),('15844','2013-06-26','11:15:00',4.22),('15844','2013-06-26','11:20:00',4.26),('15844','2013-06-26','11:25:00',4.31),('15844','2013-06-26','11:30:00',4.33),('15844','2013-06-26','11:35:00',4.3),('15844','2013-06-26','11:40:00',4.35),('15844','2013-06-26','11:45:00',4.41),('15844','2013-06-26','11:50:00',4.4),('15844','2013-06-26','11:55:00',4.42),('15844','2013-06-26','12:00:00',4.45),('15844','2013-06-26','12:05:00',4.44),('15844','2013-06-26','12:10:00',4.45),('15844','2013-06-26','12:15:00',4.43),('15844','2013-06-26','12:20:00',4.45),('15844','2013-06-26','12:25:00',4.44),('15844','2013-06-26','12:30:00',4.44),('15844','2013-06-26','12:35:00',4.46),('15844','2013-06-26','12:40:00',4.49),('15844','2013-06-26','12:45:00',4.5),('15844','2013-06-26','12:50:00',4.48),('15844','2013-06-26','12:55:00',4.47),('15844','2013-06-26','13:00:00',3.99),('15844','2013-06-26','13:10:00',3.72),('15844','2013-06-26','13:15:00',4.79),('15844','2013-06-26','13:20:00',4.62),('15844','2013-06-26','13:25:00',4.59),('15844','2013-06-26','13:30:00',4.49),('15844','2013-06-26','13:35:00',3.12),('15844','2013-06-26','13:45:00',1.69),('15844','2013-06-26','13:50:00',4.26),('15844','2013-06-26','13:55:00',4.23),('15844','2013-06-26','14:00:00',3.99),('15844','2013-06-26','14:05:00',3.9),('15844','2013-06-26','14:10:00',3.85),('15844','2013-06-26','14:15:00',3.8),('15844','2013-06-26','14:20:00',3.76),('15844','2013-06-26','14:25:00',3.73),('15844','2013-06-26','14:30:00',3.65),('15844','2013-06-26','14:35:00',3.61),('15844','2013-06-26','14:40:00',3.55),('15844','2013-06-26','14:45:00',3.46),('15844','2013-06-26','14:50:00',3.34),('15844','2013-06-26','14:55:00',3.25),('15844','2013-06-26','15:00:00',3.15),('15844','2013-06-26','15:05:00',3.02),('15844','2013-06-26','15:10:00',2.92),('15844','2013-06-26','15:15:00',2.81),('15844','2013-06-26','15:20:00',2.73),('15844','2013-06-26','15:25:00',2.59),('15844','2013-06-26','15:30:00',2.47),('15844','2013-06-26','15:35:00',2.39),('15844','2013-06-26','15:40:00',2.31),('15844','2013-06-26','15:45:00',2.23),('15844','2013-06-26','15:50:00',2.14),('15844','2013-06-26','15:55:00',2.05),('15844','2013-06-26','16:00:00',1.98),('15844','2013-06-26','16:05:00',1.89),('15844','2013-06-26','16:10:00',1.79),('15844','2013-06-26','16:15:00',1.68),('15844','2013-06-26','16:20:00',1.61),('15844','2013-06-26','16:25:00',1.55),('15844','2013-06-26','16:30:00',1.52),('15844','2013-06-26','16:35:00',1.46),('15844','2013-06-26','16:40:00',1.39),('15844','2013-06-26','16:45:00',1.31),('15844','2013-06-26','16:50:00',1.21),('15844','2013-06-26','16:55:00',1.07),('15844','2013-06-25','08:20:00',1.05),('15844','2013-06-25','08:35:00',1.15),('15844','2013-06-25','08:40:00',1.3),('15844','2013-06-25','08:45:00',1.37),('15844','2013-06-25','08:50:00',1.46),('15844','2013-06-25','08:55:00',1.5),('15844','2013-06-25','09:00:00',1.54),('15844','2013-06-25','09:05:00',1.66),('15844','2013-06-25','09:10:00',1.79),('15844','2013-06-25','09:15:00',1.92),('15844','2013-06-25','09:20:00',1.99),('15844','2013-06-25','09:25:00',2.14),('15844','2013-06-25','09:30:00',2.31),('15844','2013-06-25','09:35:00',2.45),('15844','2013-06-25','09:40:00',2.67),('15844','2013-06-25','09:45:00',2.76),('15844','2013-06-25','09:50:00',3),('15844','2013-06-25','09:55:00',3.16),('15844','2013-06-25','10:00:00',3.36),('15844','2013-06-25','10:05:00',3.53),('15844','2013-06-25','10:10:00',3.72),('15844','2013-06-25','10:15:00',2.95),('15844','2013-06-25','10:20:00',1.6),('15844','2013-06-25','10:25:00',2.81),('15844','2013-06-25','10:30:00',1.12),('15844','2013-06-25','10:35:00',2.54),('15844','2013-06-25','10:40:00',4.41),('15844','2013-06-25','10:45:00',4.39),('15844','2013-06-25','10:50:00',2.79),('15844','2013-06-25','10:55:00',4.42),('15844','2013-06-25','11:00:00',4.52),('15844','2013-06-25','11:05:00',4.6),('15844','2013-06-25','11:10:00',3.47),('15844','2013-06-25','11:15:00',2.05),('15844','2013-06-25','11:20:00',3.1),('15844','2013-06-25','11:25:00',5.1),('15844','2013-06-25','11:30:00',2.55),('15844','2013-06-25','11:35:00',1.4),('15844','2013-06-25','11:40:00',2.54),('15844','2013-06-25','11:45:00',1.06),('15844','2013-06-25','11:50:00',1.93),('15844','2013-06-25','11:55:00',3.25),('15844','2013-06-25','12:00:00',3.29),('15844','2013-06-25','12:05:00',3.22),('15844','2013-06-25','12:10:00',2.18),('15844','2013-06-25','12:15:00',3.09),('15844','2013-06-25','12:20:00',1.75),('15844','2013-06-25','12:25:00',3.05),('15844','2013-06-25','12:30:00',3.98),('15844','2013-06-25','12:35:00',3.04),('15844','2013-06-25','12:40:00',4.77),('15844','2013-06-25','12:45:00',3.09),('15844','2013-06-25','12:50:00',3.79),('15844','2013-06-25','12:55:00',4.81),('15844','2013-06-25','13:00:00',3.31),('15844','2013-06-25','13:05:00',4.6),('15844','2013-06-25','13:10:00',4.48),('15844','2013-06-25','13:15:00',4.39),('15844','2013-06-25','13:20:00',4.34),('15844','2013-06-25','13:25:00',4.31),('15844','2013-06-25','13:30:00',4.26),('15844','2013-06-25','13:35:00',4.25),('15844','2013-06-25','13:40:00',4.17),('15844','2013-06-25','13:45:00',4.18),('15844','2013-06-25','13:50:00',4.14),('15844','2013-06-25','13:55:00',4.09),('15844','2013-06-25','14:00:00',4.03),('15844','2013-06-25','14:05:00',3.95),('15844','2013-06-25','14:10:00',3.88),('15844','2013-06-25','14:15:00',3.83),('15844','2013-06-25','14:20:00',3.79),('15844','2013-06-25','14:25:00',3.71),('15844','2013-06-25','14:30:00',3.68),('15844','2013-06-25','14:35:00',3.59),('15844','2013-06-25','14:40:00',3.51),('15844','2013-06-25','14:45:00',3.46),('15844','2013-06-25','14:50:00',3.39),('15844','2013-06-25','14:55:00',3.25),('15844','2013-06-25','15:00:00',3.16),('15844','2013-06-25','15:05:00',3.06),('15844','2013-06-25','15:10:00',2.93),('15844','2013-06-25','15:15:00',2.84),('15844','2013-06-25','15:20:00',2.71),('15844','2013-06-25','15:25:00',2.59),('15844','2013-06-25','15:30:00',2.5),('15844','2013-06-25','15:35:00',2.41),('15844','2013-06-25','15:40:00',2.31),('15844','2013-06-25','15:45:00',2.24),('15844','2013-06-25','15:50:00',2.16),('15844','2013-06-25','15:55:00',2.07),('15844','2013-06-25','16:00:00',1.97),('15844','2013-06-25','16:05:00',1.87),('15844','2013-06-25','16:10:00',1.76),('15844','2013-06-25','16:15:00',1.67),('15844','2013-06-25','16:20:00',1.59),('15844','2013-06-25','16:25:00',1.52),('15844','2013-06-25','16:30:00',1.49),('15844','2013-06-25','16:35:00',1.44),('15844','2013-06-25','16:40:00',1.37),('15844','2013-06-25','16:45:00',1.28),('15844','2013-06-25','16:50:00',1.18),('15844','2013-06-25','16:55:00',1.06),('15844','2013-06-24','08:30:00',1.29),('15844','2013-06-24','08:40:00',1.21),('15844','2013-06-24','08:45:00',1.48),('15844','2013-06-24','08:50:00',1.54),('15844','2013-06-24','08:55:00',1.63),('15844','2013-06-24','09:00:00',2.2),('15844','2013-06-24','09:05:00',1.23),('15844','2013-06-24','09:10:00',1.51),('15844','2013-06-24','09:15:00',2.1),('15844','2013-06-24','09:20:00',1.47),('15844','2013-06-24','09:30:00',2.28),('15844','2013-06-24','09:35:00',2.34),('15844','2013-06-24','09:40:00',2.52),('15844','2013-06-24','09:45:00',2.88),('15844','2013-06-24','09:50:00',2.97),('15844','2013-06-24','09:55:00',3.06),('15844','2013-06-24','10:00:00',3.16),('15844','2013-06-24','10:05:00',3.25),('15844','2013-06-24','10:10:00',3.44),('15844','2013-06-24','10:15:00',2.46),('15844','2013-06-24','10:20:00',2.56),('15844','2013-06-24','10:25:00',2.67),('15844','2013-06-24','10:30:00',3.56),('15844','2013-06-24','10:35:00',2.93),('15844','2013-06-24','10:40:00',2.12),('15844','2013-06-24','10:45:00',4.08),('15844','2013-06-24','10:50:00',3.77),('15844','2013-06-24','10:55:00',1.88),('15844','2013-06-24','11:00:00',1.78),('15844','2013-06-24','11:05:00',4.68),('15844','2013-06-24','11:10:00',1.98),('15844','2013-06-24','11:15:00',1.69),('15844','2013-06-24','11:20:00',2.4),('15844','2013-06-24','11:25:00',1.01),('15844','2013-06-24','11:30:00',1.11),('15844','2013-06-24','11:35:00',1.42),('15844','2013-06-24','11:40:00',1.38),('15844','2013-06-24','11:45:00',2.29),('15844','2013-06-24','11:50:00',1.47),('15844','2013-06-24','11:55:00',2.49),('15844','2013-06-24','12:00:00',4.06),('15844','2013-06-24','12:05:00',3.06),('15844','2013-06-24','12:10:00',1.97),('15844','2013-06-24','12:15:00',2.44),('15844','2013-06-24','12:20:00',2.38),('15844','2013-06-24','12:25:00',2.58),('15844','2013-06-24','12:30:00',3.92),('15844','2013-06-24','12:35:00',3.31),('15844','2013-06-24','12:40:00',2.39),('15844','2013-06-24','12:45:00',2.13),('15844','2013-06-24','12:50:00',3.71),('15844','2013-06-24','12:55:00',2.81),('15844','2013-06-24','13:00:00',3.48),('15844','2013-06-24','13:05:00',3.69),('15844','2013-06-24','13:10:00',4.7),('15844','2013-06-24','13:15:00',4.5),('15844','2013-06-24','13:20:00',4.17),('15844','2013-06-24','13:25:00',4.02),('15844','2013-06-24','13:30:00',4.06),('15844','2013-06-24','13:35:00',3.89),('15844','2013-06-24','13:40:00',3.65),('15844','2013-06-24','13:45:00',4.52),('15844','2013-06-24','13:50:00',3.52),('15844','2013-06-24','13:55:00',4.09),('15844','2013-06-24','14:00:00',3.72),('15844','2013-06-24','14:05:00',4.09),('15844','2013-06-24','14:10:00',4),('15844','2013-06-24','14:15:00',3.93),('15844','2013-06-24','14:20:00',3.98),('15844','2013-06-24','14:25:00',3.96),('15844','2013-06-24','14:30:00',2.99),('15844','2013-06-24','14:35:00',3.59),('15844','2013-06-24','14:40:00',3.98),('15844','2013-06-24','14:45:00',3.07),('15844','2013-06-24','14:50:00',3.14),('15844','2013-06-24','14:55:00',2.54),('15844','2013-06-24','15:00:00',3.31),('15844','2013-06-24','15:05:00',3),('15844','2013-06-24','15:10:00',2.92),('15844','2013-06-24','15:15:00',2.16),('15844','2013-06-24','15:20:00',1.42),('15844','2013-06-24','15:25:00',2.75),('15844','2013-06-24','15:30:00',2.84),('15844','2013-06-24','15:35:00',1.88),('15844','2013-06-24','15:40:00',2.78),('15844','2013-06-24','15:45:00',2.14),('15844','2013-06-24','15:50:00',1.39),('15844','2013-06-24','15:55:00',2.08),('15844','2013-06-24','16:00:00',1.56),('15844','2013-06-24','16:05:00',2.01),('15844','2013-06-24','16:10:00',1.39),('15844','2013-06-24','16:15:00',1.96),('15844','2013-06-24','16:20:00',1.71),('15844','2013-06-24','16:30:00',1.6),('15844','2013-06-24','16:35:00',1.12),('15844','2013-06-24','16:40:00',1.4),('15844','2013-06-24','16:45:00',1.1),('15844','2013-06-24','16:50:00',1.35),('15844','2013-06-24','16:55:00',1.56),('15844','2013-06-24','17:00:00',1.36),('15844','2013-06-24','17:35:00',1.03),('15844','2013-06-23','08:50:00',1.09),('15844','2013-06-23','08:55:00',1.07),('15844','2013-06-23','09:00:00',1.02),('15844','2013-06-23','09:15:00',1.72),('15844','2013-06-23','09:20:00',2.07),('15844','2013-06-23','09:25:00',2.16),('15844','2013-06-23','09:30:00',2.3),('15844','2013-06-23','09:35:00',2.45),('15844','2013-06-23','09:40:00',1.75),('15844','2013-06-23','09:45:00',1.01),('15844','2013-06-23','09:50:00',2.75),('15844','2013-06-23','09:55:00',3.04),('15844','2013-06-23','10:00:00',2.66),('15844','2013-06-23','10:05:00',3.06),('15844','2013-06-23','10:10:00',3.24),('15844','2013-06-23','10:15:00',3.32),('15844','2013-06-23','10:20:00',3.37),('15844','2013-06-23','10:25:00',3.55),('15844','2013-06-23','10:30:00',3.73),('15844','2013-06-23','10:35:00',3.84),('15844','2013-06-23','10:40:00',3.93),('15844','2013-06-23','10:45:00',4.02),('15844','2013-06-23','10:50:00',4.04),('15844','2013-06-23','10:55:00',4.17),('15844','2013-06-23','11:00:00',4.27),('15844','2013-06-23','11:05:00',4.28),('15844','2013-06-23','11:10:00',4.31),('15844','2013-06-23','11:15:00',4.38),('15844','2013-06-23','11:20:00',4.36),('15844','2013-06-23','11:25:00',4.4),('15844','2013-06-23','11:30:00',4.38),('15844','2013-06-23','11:35:00',4.33),('15844','2013-06-23','11:40:00',4.37),('15844','2013-06-23','11:45:00',4.33),('15844','2013-06-23','11:50:00',4.42),('15844','2013-06-23','11:55:00',4.46),('15844','2013-06-23','12:00:00',4.47),('15844','2013-06-23','12:05:00',4.42),('15844','2013-06-23','12:10:00',4.44),('15844','2013-06-23','12:15:00',4.46),('15844','2013-06-23','12:20:00',4.5),('15844','2013-06-23','12:25:00',4.47),('15844','2013-06-23','12:30:00',4.48),('15844','2013-06-23','12:35:00',4.45),('15844','2013-06-23','12:40:00',4.45),('15844','2013-06-23','12:45:00',4.43),('15844','2013-06-23','12:50:00',4.42),('15844','2013-06-23','12:55:00',4.4),('15844','2013-06-23','13:00:00',4.35),('15844','2013-06-23','13:05:00',4.36),('15844','2013-06-23','13:10:00',4.34),('15844','2013-06-23','13:15:00',4.31),('15844','2013-06-23','13:20:00',4.32),('15844','2013-06-23','13:25:00',4.26),('15844','2013-06-23','13:30:00',4.27),('15844','2013-06-23','13:35:00',4.24),('15844','2013-06-23','13:40:00',4.2),('15844','2013-06-23','13:45:00',4.17),('15844','2013-06-23','13:50:00',4.13),('15844','2013-06-23','13:55:00',4.12),('15844','2013-06-23','14:00:00',4.07),('15844','2013-06-23','14:05:00',4.02),('15844','2013-06-23','14:10:00',3.98),('15844','2013-06-23','14:15:00',3.91),('15844','2013-06-23','14:20:00',3.84),('15844','2013-06-23','14:25:00',3.78),('15844','2013-06-23','14:30:00',3.71),('15844','2013-06-23','14:35:00',3.66),('15844','2013-06-23','14:40:00',3.6),('15844','2013-06-23','14:45:00',3.52),('15844','2013-06-23','14:50:00',3.43),('15844','2013-06-23','14:55:00',3.33),('15844','2013-06-23','15:00:00',3.19),('15844','2013-06-23','15:05:00',3.11),('15844','2013-06-23','15:10:00',3.02),('15844','2013-06-23','15:15:00',2.86),('15844','2013-06-23','15:20:00',2.72),('15844','2013-06-23','15:25:00',2.59),('15844','2013-06-23','15:30:00',2.48),('15844','2013-06-23','15:35:00',2.39),('15844','2013-06-23','15:40:00',2.27),('15844','2013-06-23','15:45:00',2.22),('15844','2013-06-23','15:50:00',2.14),('15844','2013-06-23','15:55:00',2.06),('15844','2013-06-23','16:00:00',1.95),('15844','2013-06-23','16:05:00',1.84),('15844','2013-06-23','16:10:00',1.75),('15844','2013-06-23','16:15:00',1.67),('15844','2013-06-23','16:20:00',1.57),('15844','2013-06-23','16:25:00',1.52),('15844','2013-06-23','16:30:00',1.48),('15844','2013-06-23','16:35:00',1.43),('15844','2013-06-23','16:40:00',1.35),('15844','2013-06-23','16:45:00',1.27),('15844','2013-06-23','16:50:00',1.15),('15844','2013-06-23','16:55:00',1.04),('15844','2013-06-22','08:25:00',1.07),('15844','2013-06-22','08:30:00',1.15),('15844','2013-06-22','08:35:00',1.19),('15844','2013-06-22','08:40:00',1.28),('15844','2013-06-22','08:45:00',1.33),('15844','2013-06-22','08:50:00',1.38),('15844','2013-06-22','08:55:00',1.47),('15844','2013-06-22','09:00:00',1.55),('15844','2013-06-22','09:05:00',1.63),('15844','2013-06-22','09:10:00',1.7),('15844','2013-06-22','09:15:00',1.79),('15844','2013-06-22','09:20:00',1.88),('15844','2013-06-22','09:25:00',2),('15844','2013-06-22','09:30:00',2.17),('15844','2013-06-22','09:35:00',2.29),('15844','2013-06-22','09:40:00',2.4),('15844','2013-06-22','09:45:00',2.55),('15844','2013-06-22','09:50:00',2.73),('15844','2013-06-22','09:55:00',2.85),('15844','2013-06-22','10:00:00',2.92),('15844','2013-06-22','10:05:00',3.01),('15844','2013-06-22','10:10:00',3.12),('15844','2013-06-22','10:15:00',3.26),('15844','2013-06-22','10:20:00',3.35),('15844','2013-06-22','10:25:00',3.44),('15844','2013-06-22','10:30:00',3.59),('15844','2013-06-22','10:35:00',3.73),('15844','2013-06-22','10:40:00',3.81),('15844','2013-06-22','10:45:00',3.9),('15844','2013-06-22','10:50:00',3.96),('15844','2013-06-22','10:55:00',4.06),('15844','2013-06-22','11:00:00',4.15),('15844','2013-06-22','11:05:00',4.15),('15844','2013-06-22','11:10:00',4.21),('15844','2013-06-22','11:15:00',4.26),('15844','2013-06-22','11:20:00',4.31),('15844','2013-06-22','11:25:00',4.28),('15844','2013-06-22','11:30:00',4.28),('15844','2013-06-22','11:35:00',4.27),('15844','2013-06-22','11:40:00',4.25),('15844','2013-06-22','11:45:00',4.26),('15844','2013-06-22','11:50:00',4.26),('15844','2013-06-22','11:55:00',4.29),('15844','2013-06-22','12:00:00',4.36),('15844','2013-06-22','12:05:00',4.26),('15844','2013-06-22','12:10:00',4.32),('15844','2013-06-22','12:15:00',4.32),('15844','2013-06-22','12:20:00',4.3),('15844','2013-06-22','12:25:00',4.29),('15844','2013-06-22','12:30:00',4.3),('15844','2013-06-22','12:35:00',4.3),('15844','2013-06-22','12:40:00',4.26),('15844','2013-06-22','12:45:00',4.2),('15844','2013-06-22','12:50:00',4.16),('15844','2013-06-22','12:55:00',4.15),('15844','2013-06-22','13:00:00',4.01),('15844','2013-06-22','13:05:00',4.04),('15844','2013-06-22','13:10:00',4.05),('15844','2013-06-22','13:15:00',4.24),('15844','2013-06-22','13:20:00',4.22),('15844','2013-06-22','13:25:00',4.15),('15844','2013-06-22','13:30:00',4.17),('15844','2013-06-22','13:35:00',3.88),('15844','2013-06-22','13:40:00',3.6),('15844','2013-06-22','13:45:00',4.34),('15844','2013-06-22','13:50:00',2.99),('15844','2013-06-22','13:55:00',2.75),('15844','2013-06-22','14:00:00',4.2),('15844','2013-06-22','14:05:00',4.22),('15844','2013-06-22','14:10:00',3.86),('15844','2013-06-22','14:15:00',2.94),('15844','2013-06-22','14:20:00',3.15),('15844','2013-06-22','14:25:00',2.63),('15844','2013-06-22','14:30:00',1.87),('15844','2013-06-22','14:35:00',1.54),('15844','2013-06-22','14:40:00',2.43),('15844','2013-06-22','14:45:00',2.84),('15844','2013-06-22','14:50:00',3.28),('15844','2013-06-22','14:55:00',3.48),('15844','2013-06-22','15:00:00',3.15),('15844','2013-06-22','15:05:00',2.78),('15844','2013-06-22','15:10:00',3.23),('15844','2013-06-22','15:15:00',3.02),('15844','2013-06-22','15:20:00',2.84),('15844','2013-06-22','15:25:00',2.46),('15844','2013-06-22','15:30:00',2.13),('15844','2013-06-22','15:35:00',1.98),('15844','2013-06-22','15:40:00',2.31),('15844','2013-06-22','15:45:00',1.76),('15844','2013-06-22','15:50:00',1.82),('15844','2013-06-22','15:55:00',1.84),('15844','2013-06-22','16:00:00',1.18),('15844','2013-06-22','16:05:00',1.04),('15844','2013-06-22','16:10:00',1.14),('15844','2013-06-22','16:15:00',1.46),('15844','2013-06-22','16:20:00',1.23),('15844','2013-06-22','16:25:00',1.04),('15844','2013-06-22','16:55:00',1.3),('15844','2013-06-22','17:00:00',1.41),('15844','2013-06-22','17:05:00',1.36),('15844','2013-06-22','17:10:00',1.6),('15844','2013-06-22','17:15:00',1.43),('15844','2013-06-22','17:20:00',1.27),('15844','2013-06-22','17:25:00',1.03),('15844','2013-06-21','08:30:00',1.14),('15844','2013-06-21','08:35:00',1.21),('15844','2013-06-21','08:40:00',1.25),('15844','2013-06-21','08:45:00',1.28),('15844','2013-06-21','08:50:00',1.33),('15844','2013-06-21','08:55:00',1.43),('15844','2013-06-21','09:00:00',1.52),('15844','2013-06-21','09:05:00',1.59),('15844','2013-06-21','09:10:00',1.67),('15844','2013-06-21','09:15:00',1.73),('15844','2013-06-21','09:20:00',1.81),('15844','2013-06-21','09:25:00',1.9),('15844','2013-06-21','09:30:00',2.02),('15844','2013-06-21','09:35:00',2.21),('15844','2013-06-21','09:40:00',2.34),('15844','2013-06-21','09:45:00',2.46),('15844','2013-06-21','09:50:00',2.61),('15844','2013-06-21','09:55:00',2.69),('15844','2013-06-21','10:00:00',2.8),('15844','2013-06-21','10:05:00',2.9),('15844','2013-06-21','10:10:00',2.96),('15844','2013-06-21','10:15:00',3.04),('15844','2013-06-21','10:20:00',3.21),('15844','2013-06-21','10:25:00',3.33),('15844','2013-06-21','10:30:00',3.35),('15844','2013-06-21','10:35:00',3.49),('15844','2013-06-21','10:40:00',3.56),('15844','2013-06-21','10:45:00',3.64),('15844','2013-06-21','10:50:00',3.76),('15844','2013-06-21','10:55:00',3.92),('15844','2013-06-21','11:00:00',3.98),('15844','2013-06-21','11:05:00',3.96),('15844','2013-06-21','11:10:00',3.99),('15844','2013-06-21','11:15:00',4.06),('15844','2013-06-21','11:20:00',4.07),('15844','2013-06-21','11:25:00',4.09),('15844','2013-06-21','11:30:00',4.08),('15844','2013-06-21','11:35:00',4.07),('15844','2013-06-21','11:40:00',4.13),('15844','2013-06-21','11:45:00',4.13),('15844','2013-06-21','11:50:00',4.21),('15844','2013-06-21','11:55:00',4.16),('15844','2013-06-21','12:00:00',4.2),('15844','2013-06-21','12:05:00',4.2),('15844','2013-06-21','12:10:00',4.09),('15844','2013-06-21','12:15:00',4.05),('15844','2013-06-21','12:20:00',4.14),('15844','2013-06-21','12:25:00',4.23),('15844','2013-06-21','12:30:00',4.12),('15844','2013-06-21','12:35:00',4.15),('15844','2013-06-21','12:40:00',4.09),('15844','2013-06-21','12:45:00',4.09),('15844','2013-06-21','12:50:00',4.09),('15844','2013-06-21','12:55:00',4.07),('15844','2013-06-21','13:00:00',4.05),('15844','2013-06-21','13:05:00',3.96),('15844','2013-06-21','13:10:00',4.04),('15844','2013-06-21','13:15:00',4),('15844','2013-06-21','13:20:00',3.9),('15844','2013-06-21','13:25:00',3.91),('15844','2013-06-21','13:30:00',3.91),('15844','2013-06-21','13:35:00',3.96),('15844','2013-06-21','13:40:00',3.95),('15844','2013-06-21','13:45:00',3.93),('15844','2013-06-21','13:50:00',3.89),('15844','2013-06-21','13:55:00',3.86),('15844','2013-06-21','14:00:00',3.83),('15844','2013-06-21','14:05:00',3.78),('15844','2013-06-21','14:10:00',3.75),('15844','2013-06-21','14:15:00',3.73),('15844','2013-06-21','14:20:00',3.64),('15844','2013-06-21','14:25:00',3.59),('15844','2013-06-21','14:30:00',3.52),('15844','2013-06-21','14:35:00',3.46),('15844','2013-06-21','14:40:00',3.41),('15844','2013-06-21','14:45:00',3.34),('15844','2013-06-21','14:50:00',3.26),('15844','2013-06-21','14:55:00',3.17),('15844','2013-06-21','15:00:00',3.05),('15844','2013-06-21','15:05:00',2.96),('15844','2013-06-21','15:10:00',2.85),('15844','2013-06-21','15:15:00',2.73),('15844','2013-06-21','15:20:00',2.61),('15844','2013-06-21','15:25:00',2.49),('15844','2013-06-21','15:30:00',2.39),('15844','2013-06-21','15:35:00',2.32),('15844','2013-06-21','15:40:00',2.22),('15844','2013-06-21','15:45:00',2.16),('15844','2013-06-21','15:50:00',2.09),('15844','2013-06-21','15:55:00',2),('15844','2013-06-21','16:00:00',1.91),('15844','2013-06-21','16:05:00',1.82),('15844','2013-06-21','16:10:00',1.71),('15844','2013-06-21','16:15:00',1.61),('15844','2013-06-21','16:20:00',1.54),('15844','2013-06-21','16:25:00',1.48),('15844','2013-06-21','16:30:00',1.44),('15844','2013-06-21','16:35:00',1.4),('15844','2013-06-21','16:40:00',1.3),('15844','2013-06-21','16:45:00',1.24),('15844','2013-06-21','16:50:00',1.12),('15844','2013-06-21','16:55:00',1.01),('15844','2014-04-04','08:50:00',1.04),('15844','2014-04-04','08:55:00',1.17),('15844','2014-04-04','09:00:00',1.41),('15844','2014-04-04','09:05:00',1.3),('15844','2014-04-04','09:10:00',1.26),('15844','2014-04-04','09:15:00',1.21),('15844','2014-04-04','13:00:00',1.21),('15844','2014-04-04','13:05:00',1.34),('15844','2014-04-04','13:10:00',1.28),('15844','2014-04-04','13:15:00',1.83),('15844','2014-04-04','13:20:00',1.64),('15844','2014-04-04','13:25:00',2.51),('15844','2014-04-04','13:30:00',2.57),('15844','2014-04-04','13:35:00',1.51),('15844','2014-04-04','13:40:00',2.33),('15844','2014-04-04','13:45:00',3.3),('15844','2014-04-04','13:50:00',1.52),('15844','2014-04-04','13:55:00',2.13),('15844','2014-04-04','14:00:00',3.89),('15844','2014-04-04','14:05:00',1.94),('15844','2014-04-04','14:10:00',1.85),('15844','2014-04-04','14:15:00',1.61),('15844','2014-04-04','14:20:00',1.13),('15844','2014-04-04','14:25:00',2.16),('15844','2014-04-04','14:30:00',3.37),('15844','2014-04-04','14:35:00',2.93),('15844','2014-04-04','14:40:00',1.78),('15844','2014-04-04','14:45:00',1.67),('15844','2014-04-04','14:55:00',1.58),('15844','2014-04-04','15:00:00',1.46),('15844','2014-04-04','15:05:00',1.94),('15844','2014-04-04','15:10:00',2.06),('15844','2014-04-04','15:15:00',1.39),('15844','2014-04-04','15:20:00',1.79),('15844','2014-04-04','15:25:00',1.49),('15844','2014-04-04','15:45:00',1.07),('15844','2014-04-04','15:50:00',1.21),('15844','2014-04-04','15:55:00',1.51),('15844','2014-04-04','16:00:00',1.83),('15844','2014-04-04','16:05:00',1.57),('15844','2014-04-04','16:10:00',1.39),('15844','2014-04-04','16:15:00',1.36),('15844','2014-04-04','16:20:00',1.34),('15844','2014-04-04','16:25:00',1.01),('15844','2014-04-04','16:35:00',1.1),('15844','2014-04-04','16:40:00',1.26),('15844','2014-04-04','16:45:00',1.03),('15844','2014-04-04','16:50:00',1.1),('15844','2014-04-04','16:55:00',1.18),('15844','2014-04-04','17:00:00',1.23),('15844','2014-04-04','17:05:00',1.02),('15844','2013-06-20','08:25:00',1.03),('15844','2013-06-20','08:30:00',1.12),('15844','2013-06-20','08:35:00',1.19),('15844','2013-06-20','08:40:00',1.24),('15844','2013-06-20','08:45:00',1.27),('15844','2013-06-20','08:50:00',1.3),('15844','2013-06-20','08:55:00',1.41),('15844','2013-06-20','09:00:00',1.5),('15844','2013-06-20','09:05:00',1.58),('15844','2013-06-20','09:10:00',1.65),('15844','2013-06-20','09:15:00',1.75),('15844','2013-06-20','09:20:00',1.82),('15844','2013-06-20','09:25:00',1.94),('15844','2013-06-20','09:30:00',2.12),('15844','2013-06-20','09:35:00',2.25),('15844','2013-06-20','09:40:00',2.37),('15844','2013-06-20','09:45:00',2.51),('15844','2013-06-20','09:50:00',2.66),('15844','2013-06-20','09:55:00',2.76),('15844','2013-06-20','10:00:00',2.85),('15844','2013-06-20','10:05:00',2.95),('15844','2013-06-20','10:10:00',3.01),('15844','2013-06-20','10:15:00',3.08),('15844','2013-06-20','10:20:00',3.23),('15844','2013-06-20','10:25:00',3.37),('15844','2013-06-20','10:30:00',3.5),('15844','2013-06-20','10:35:00',3.57),('15844','2013-06-20','10:40:00',3.71),('15844','2013-06-20','10:45:00',3.77),('15844','2013-06-20','10:50:00',3.76),('15844','2013-06-20','10:55:00',3.89),('15844','2013-06-20','11:00:00',4.04),('15844','2013-06-20','11:05:00',4.08),('15844','2013-06-20','11:10:00',4.1),('15844','2013-06-20','11:15:00',4.12),('15844','2013-06-20','11:20:00',4.09),('15844','2013-06-20','11:25:00',4.01),('15844','2013-06-20','11:30:00',3.97),('15844','2013-06-20','11:35:00',3.9),('15844','2013-06-20','11:40:00',3.9),('15844','2013-06-20','11:45:00',4.02),('15844','2013-06-20','11:50:00',4.1),('15844','2013-06-20','11:55:00',4.15),('15844','2013-06-20','12:00:00',4.09),('15844','2013-06-20','12:05:00',4.02),('15844','2013-06-20','12:10:00',4),('15844','2013-06-20','12:15:00',4.03),('15844','2013-06-20','12:20:00',3.99),('15844','2013-06-20','12:25:00',3.93),('15844','2013-06-20','12:30:00',3.86),('15844','2013-06-20','12:35:00',3.82),('15844','2013-06-20','12:40:00',3.91),('15844','2013-06-20','12:45:00',4.09),('15844','2013-06-20','12:50:00',4.11),('15844','2013-06-20','12:55:00',4.12),('15844','2013-06-20','13:00:00',4.07),('15844','2013-06-20','13:05:00',4.18),('15844','2013-06-20','13:10:00',4.08),('15844','2013-06-20','13:15:00',4.04),('15844','2013-06-20','13:20:00',4.12),('15844','2013-06-20','13:25:00',4.14),('15844','2013-06-20','13:30:00',4.1),('15844','2013-06-20','13:35:00',4.09),('15844','2013-06-20','13:40:00',4.06),('15844','2013-06-20','13:45:00',4.04),('15844','2013-06-20','13:50:00',4.02),('15844','2013-06-20','13:55:00',3.97),('15844','2013-06-20','14:00:00',3.92),('15844','2013-06-20','14:05:00',3.88),('15844','2013-06-20','14:10:00',3.84),('15844','2013-06-20','14:15:00',3.76),('15844','2013-06-20','14:20:00',3.71),('15844','2013-06-20','14:25:00',3.66),('15844','2013-06-20','14:30:00',3.59),('15844','2013-06-20','14:35:00',3.54),('15844','2013-06-20','14:40:00',3.48),('15844','2013-06-20','14:45:00',3.39),('15844','2013-06-20','14:50:00',3.29),('15844','2013-06-20','14:55:00',3.2),('15844','2013-06-20','15:00:00',3.07),('15844','2013-06-20','15:05:00',2.97),('15844','2013-06-20','15:10:00',2.86),('15844','2013-06-20','15:15:00',2.75),('15844','2013-06-20','15:20:00',2.61),('15844','2013-06-20','15:25:00',2.52),('15844','2013-06-20','15:30:00',2.4),('15844','2013-06-20','15:35:00',2.29),('15844','2013-06-20','15:40:00',2.2),('15844','2013-06-20','15:45:00',2.15),('15844','2013-06-20','15:50:00',2.08),('15844','2013-06-20','15:55:00',1.99),('15844','2013-06-20','16:00:00',1.89),('15844','2013-06-20','16:05:00',1.79),('15844','2013-06-20','16:10:00',1.68),('15844','2013-06-20','16:15:00',1.61),('15844','2013-06-20','16:20:00',1.52),('15844','2013-06-20','16:25:00',1.47),('15844','2013-06-20','16:30:00',1.43),('15844','2013-06-20','16:35:00',1.37),('15844','2013-06-20','16:40:00',1.29),('15844','2013-06-20','16:45:00',1.23),('15844','2013-06-20','16:50:00',1.11),('15844','2013-06-19','08:25:00',1.01),('15844','2013-06-19','08:30:00',1.08),('15844','2013-06-19','08:35:00',1.14),('15844','2013-06-19','08:40:00',1.2),('15844','2013-06-19','08:45:00',1.24),('15844','2013-06-19','08:50:00',1.27),('15844','2013-06-19','08:55:00',1.38),('15844','2013-06-19','09:00:00',1.46),('15844','2013-06-19','09:05:00',1.53),('15844','2013-06-19','09:10:00',1.6),('15844','2013-06-19','09:15:00',1.69),('15844','2013-06-19','09:20:00',1.75),('15844','2013-06-19','09:25:00',1.89),('15844','2013-06-19','09:30:00',2.02),('15844','2013-06-19','09:35:00',2.15),('15844','2013-06-19','09:40:00',2.27),('15844','2013-06-19','09:45:00',2.38),('15844','2013-06-19','09:50:00',2.55),('15844','2013-06-19','09:55:00',2.63),('15844','2013-06-19','10:00:00',2.7),('15844','2013-06-19','10:05:00',2.79),('15844','2013-06-19','10:10:00',2.89),('15844','2013-06-19','10:15:00',2.93),('15844','2013-06-19','10:20:00',2.97),('15844','2013-06-19','10:25:00',3.19),('15844','2013-06-19','10:30:00',3.32),('15844','2013-06-19','10:35:00',3.38),('15844','2013-06-19','10:40:00',3.48),('15844','2013-06-19','10:45:00',3.57),('15844','2013-06-19','10:50:00',3.63),('15844','2013-06-19','10:55:00',3.74),('15844','2013-06-19','11:00:00',3.82),('15844','2013-06-19','11:05:00',3.89),('15844','2013-06-19','11:10:00',3.87),('15844','2013-06-19','11:15:00',3.91),('15844','2013-06-19','11:20:00',3.99),('15844','2013-06-19','11:25:00',4),('15844','2013-06-19','11:30:00',3.91),('15844','2013-06-19','11:35:00',3.97),('15844','2013-06-19','11:40:00',4.03),('15844','2013-06-19','11:45:00',4.07),('15844','2013-06-19','11:50:00',4.07),('15844','2013-06-19','11:55:00',4.13),('15844','2013-06-19','12:00:00',4.08),('15844','2013-06-19','12:05:00',4.15),('15844','2013-06-19','12:10:00',4.12),('15844','2013-06-19','12:15:00',4.13),('15844','2013-06-19','12:20:00',4.12),('15844','2013-06-19','12:25:00',4.13),('15844','2013-06-19','12:30:00',4.14),('15844','2013-06-19','12:35:00',4.1),('15844','2013-06-19','12:40:00',4.04),('15844','2013-06-19','12:45:00',4.08),('15844','2013-06-19','12:50:00',4.05),('15844','2013-06-19','12:55:00',4.03),('15844','2013-06-19','13:00:00',3.99),('15844','2013-06-19','13:05:00',4.03),('15844','2013-06-19','13:10:00',4),('15844','2013-06-19','13:15:00',3.99),('15844','2013-06-19','13:20:00',3.96),('15844','2013-06-19','13:25:00',3.94),('15844','2013-06-19','13:30:00',3.89),('15844','2013-06-19','13:35:00',3.88),('15844','2013-06-19','13:40:00',3.85),('15844','2013-06-19','13:45:00',3.86),('15844','2013-06-19','13:50:00',3.85),('15844','2013-06-19','13:55:00',3.8),('15844','2013-06-19','14:00:00',3.76),('15844','2013-06-19','14:05:00',3.72),('15844','2013-06-19','14:10:00',3.67),('15844','2013-06-19','14:15:00',3.62),('15844','2013-06-19','14:20:00',3.57),('15844','2013-06-19','14:25:00',3.51),('15844','2013-06-19','14:30:00',3.46),('15844','2013-06-19','14:35:00',3.41),('15844','2013-06-19','14:40:00',3.37),('15844','2013-06-19','14:45:00',3.29),('15844','2013-06-19','14:50:00',3.2),('15844','2013-06-19','14:55:00',3.11),('15844','2013-06-19','15:00:00',3),('15844','2013-06-19','15:05:00',2.9),('15844','2013-06-19','15:10:00',2.77),('15844','2013-06-19','15:15:00',2.66),('15844','2013-06-19','15:20:00',2.56),('15844','2013-06-19','15:25:00',2.45),('15844','2013-06-19','15:30:00',2.32),('15844','2013-06-19','15:35:00',2.23),('15844','2013-06-19','15:40:00',2.15),('15844','2013-06-19','15:45:00',2.1),('15844','2013-06-19','15:50:00',2.05),('15844','2013-06-19','15:55:00',1.94),('15844','2013-06-19','16:00:00',1.86),('15844','2013-06-19','16:05:00',1.76),('15844','2013-06-19','16:10:00',1.67),('15844','2013-06-19','16:15:00',1.59),('15844','2013-06-19','16:20:00',1.51),('15844','2013-06-19','16:25:00',1.45),('15844','2013-06-19','16:30:00',1.43),('15844','2013-06-19','16:35:00',1.37),('15844','2013-06-19','16:40:00',1.29),('15844','2013-06-19','16:45:00',1.22),('15844','2013-06-19','16:50:00',1.11),('15844','2013-06-18','08:25:00',1.01),('15844','2013-06-18','08:30:00',1.09),('15844','2013-06-18','08:35:00',1.16),('15844','2013-06-18','08:40:00',1.2),('15844','2013-06-18','08:45:00',1.23),('15844','2013-06-18','08:50:00',1.28),('15844','2013-06-18','08:55:00',1.38),('15844','2013-06-18','09:00:00',1.49),('15844','2013-06-18','09:05:00',1.56),('15844','2013-06-18','09:10:00',1.63),('15844','2013-06-18','09:15:00',1.71),('15844','2013-06-18','09:20:00',1.79),('15844','2013-06-18','09:25:00',1.91),('15844','2013-06-18','09:30:00',2.06),('15844','2013-06-18','09:35:00',2.19),('15844','2013-06-18','09:40:00',2.31),('15844','2013-06-18','09:45:00',2.43),('15844','2013-06-18','09:50:00',2.6),('15844','2013-06-18','09:55:00',2.66),('15844','2013-06-18','10:00:00',2.74),('15844','2013-06-18','10:05:00',2.83),('15844','2013-06-18','10:10:00',2.89),('15844','2013-06-18','10:15:00',2.94),('15844','2013-06-18','10:20:00',3.08),('15844','2013-06-18','10:25:00',3.23),('15844','2013-06-18','10:30:00',3.4),('15844','2013-06-18','10:35:00',3.53),('15844','2013-06-18','10:40:00',3.62),('15844','2013-06-18','10:45:00',3.67),('15844','2013-06-18','10:50:00',3.71),('15844','2013-06-18','10:55:00',3.76),('15844','2013-06-18','11:00:00',3.87),('15844','2013-06-18','11:05:00',3.9),('15844','2013-06-18','11:10:00',3.91),('15844','2013-06-18','11:15:00',3.85),('15844','2013-06-18','11:20:00',3.92),('15844','2013-06-18','11:25:00',3.94),('15844','2013-06-18','11:30:00',3.96),('15844','2013-06-18','11:35:00',3.96),('15844','2013-06-18','11:40:00',3.99),('15844','2013-06-18','11:45:00',3.98),('15844','2013-06-18','11:50:00',3.97),('15844','2013-06-18','11:55:00',4.04),('15844','2013-06-18','12:00:00',4.07),('15844','2013-06-18','12:05:00',3.96),('15844','2013-06-18','12:10:00',3.93),('15844','2013-06-18','12:15:00',3.87),('15844','2013-06-18','12:20:00',3.78),('15844','2013-06-18','12:25:00',3.9),('15844','2013-06-18','12:30:00',3.85),('15844','2013-06-18','12:35:00',3.88),('15844','2013-06-18','12:40:00',3.94),('15844','2013-06-18','12:45:00',3.93),('15844','2013-06-18','12:50:00',4.01),('15844','2013-06-18','12:55:00',4.04),('15844','2013-06-18','13:00:00',3.9),('15844','2013-06-18','13:05:00',3.85),('15844','2013-06-18','13:10:00',3.63),('15844','2013-06-18','13:15:00',3.82),('15844','2013-06-18','13:20:00',3.68),('15844','2013-06-18','13:25:00',3.72),('15844','2013-06-18','13:30:00',3.72),('15844','2013-06-18','13:35:00',3.77),('15844','2013-06-18','13:40:00',3.73),('15844','2013-06-18','13:45:00',3.73),('15844','2013-06-18','13:50:00',3.69),('15844','2013-06-18','13:55:00',3.78),('15844','2013-06-18','14:00:00',3.84),('15844','2013-06-18','14:05:00',3.88),('15844','2013-06-18','14:10:00',3.82),('15844','2013-06-18','14:15:00',3.81),('15844','2013-06-18','14:20:00',3.71),('15844','2013-06-18','14:25:00',3.67),('15844','2013-06-18','14:30:00',3.61),('15844','2013-06-18','14:35:00',3.67),('15844','2013-06-18','14:40:00',3.61),('15844','2013-06-18','14:45:00',3.53),('15844','2013-06-18','14:50:00',3.39),('15844','2013-06-18','14:55:00',3.23),('15844','2013-06-18','15:00:00',3.11),('15844','2013-06-18','15:05:00',2.97),('15844','2013-06-18','15:10:00',2.83),('15844','2013-06-18','15:15:00',2.7),('15844','2013-06-18','15:20:00',2.58),('15844','2013-06-18','15:25:00',2.47),('15844','2013-06-18','15:30:00',2.37),('15844','2013-06-18','15:35:00',2.28),('15844','2013-06-18','15:40:00',2.19),('15844','2013-06-18','15:45:00',2.13),('15844','2013-06-18','15:50:00',2.08),('15844','2013-06-18','15:55:00',2.01),('15844','2013-06-18','16:00:00',1.96),('15844','2013-06-18','16:05:00',1.88),('15844','2013-06-18','16:10:00',1.81),('15844','2013-06-18','16:15:00',1.72),('15844','2013-06-18','16:20:00',1.66),('15844','2013-06-18','16:25:00',1.62),('15844','2013-06-18','16:30:00',1.57),('15844','2013-06-18','16:35:00',1.47),('15844','2013-06-18','16:40:00',1.37),('15844','2013-06-18','16:45:00',1.27),('15844','2013-06-18','16:50:00',1.16),('15844','2013-06-18','16:55:00',1.02),('15844','2013-06-17','08:25:00',1.05),('15844','2013-06-17','08:30:00',1.14),('15844','2013-06-17','08:35:00',1.21),('15844','2013-06-17','08:40:00',1.26),('15844','2013-06-17','08:45:00',1.28),('15844','2013-06-17','08:50:00',1.31),('15844','2013-06-17','08:55:00',1.43),('15844','2013-06-17','09:00:00',1.53),('15844','2013-06-17','09:05:00',1.61),('15844','2013-06-17','09:10:00',1.69),('15844','2013-06-17','09:15:00',1.78),('15844','2013-06-17','09:20:00',1.87),('15844','2013-06-17','09:25:00',2),('15844','2013-06-17','09:30:00',2.15),('15844','2013-06-17','09:35:00',2.27),('15844','2013-06-17','09:40:00',2.4),('15844','2013-06-17','09:45:00',2.53),('15844','2013-06-17','09:50:00',2.7),('15844','2013-06-17','09:55:00',2.81),('15844','2013-06-17','10:00:00',2.89),('15844','2013-06-17','10:05:00',2.98),('15844','2013-06-17','10:10:00',3.05),('15844','2013-06-17','10:15:00',3.11),('15844','2013-06-17','10:20:00',3.18),('15844','2013-06-17','10:25:00',3.39),('15844','2013-06-17','10:30:00',3.54),('15844','2013-06-17','10:35:00',3.66),('15844','2013-06-17','10:40:00',3.75),('15844','2013-06-17','10:45:00',3.77),('15844','2013-06-17','10:50:00',3.87),('15844','2013-06-17','10:55:00',3.96),('15844','2013-06-17','11:00:00',4.02),('15844','2013-06-17','11:05:00',4.05),('15844','2013-06-17','11:10:00',4.08),('15844','2013-06-17','11:15:00',4.1),('15844','2013-06-17','11:20:00',4.11),('15844','2013-06-17','11:25:00',4.1),('15844','2013-06-17','11:30:00',4.14),('15844','2013-06-17','11:35:00',4.12),('15844','2013-06-17','11:40:00',4.14),('15844','2013-06-17','11:45:00',4.13),('15844','2013-06-17','11:50:00',4.19),('15844','2013-06-17','11:55:00',4.18),('15844','2013-06-17','12:00:00',4.17),('15844','2013-06-17','12:05:00',4.21),('15844','2013-06-17','12:10:00',4.2),('15844','2013-06-17','12:15:00',4.22),('15844','2013-06-17','12:20:00',4.22),('15844','2013-06-17','12:25:00',4.22),('15844','2013-06-17','12:30:00',4.16),('15844','2013-06-17','12:35:00',4.19),('15844','2013-06-17','12:40:00',4.16),('15844','2013-06-17','12:45:00',4.2),('15844','2013-06-17','12:50:00',4.18),('15844','2013-06-17','12:55:00',4.16),('15844','2013-06-17','13:00:00',4.14),('15844','2013-06-17','13:05:00',4.12),('15844','2013-06-17','13:10:00',4.08),('15844','2013-06-17','13:15:00',4.08),('15844','2013-06-17','13:20:00',4.06),('15844','2013-06-17','13:25:00',4.03),('15844','2013-06-17','13:30:00',4),('15844','2013-06-17','13:35:00',3.97),('15844','2013-06-17','13:40:00',3.93),('15844','2013-06-17','13:45:00',3.9),('15844','2013-06-17','13:50:00',3.87),('15844','2013-06-17','13:55:00',3.85),('15844','2013-06-17','14:00:00',3.82),('15844','2013-06-17','14:05:00',3.78),('15844','2013-06-17','14:10:00',3.73),('15844','2013-06-17','14:15:00',3.68),('15844','2013-06-17','14:20:00',3.62),('15844','2013-06-17','14:25:00',3.56),('15844','2013-06-17','14:30:00',3.5),('15844','2013-06-17','14:35:00',3.43),('15844','2013-06-17','14:40:00',3.37),('15844','2013-06-17','14:45:00',3.28),('15844','2013-06-17','14:50:00',3.2),('15844','2013-06-17','14:55:00',3.11),('15844','2013-06-17','15:00:00',3.01),('15844','2013-06-17','15:05:00',2.89),('15844','2013-06-17','15:10:00',2.8),('15844','2013-06-17','15:15:00',2.69),('15844','2013-06-17','15:20:00',2.56),('15844','2013-06-17','15:25:00',2.44),('15844','2013-06-17','15:30:00',2.29),('15844','2013-06-17','15:35:00',2.27),('15844','2013-06-17','15:40:00',2.2),('15844','2013-06-17','15:45:00',2.14),('15844','2013-06-17','15:50:00',2.06),('15844','2013-06-17','15:55:00',1.96),('15844','2013-06-17','16:00:00',1.88),('15844','2013-06-17','16:05:00',1.79),('15844','2013-06-17','16:10:00',1.69),('15844','2013-06-17','16:15:00',1.6),('15844','2013-06-17','16:20:00',1.53),('15844','2013-06-17','16:25:00',1.49),('15844','2013-06-17','16:30:00',1.45),('15844','2013-06-17','16:35:00',1.4),('15844','2013-06-17','16:40:00',1.31),('15844','2013-06-17','16:45:00',1.24),('15844','2013-06-17','16:50:00',1.12),('15844','2013-06-17','16:55:00',1),('15844','2013-06-16','08:25:00',1.06),('15844','2013-06-16','08:30:00',1.14),('15844','2013-06-16','08:35:00',1.21),('15844','2013-06-16','08:40:00',1.27),('15844','2013-06-16','08:45:00',1.3),('15844','2013-06-16','08:50:00',1.32),('15844','2013-06-16','08:55:00',1.45),('15844','2013-06-16','09:00:00',1.55),('15844','2013-06-16','09:05:00',1.63),('15844','2013-06-16','09:10:00',1.7),('15844','2013-06-16','09:15:00',1.79),('15844','2013-06-16','09:20:00',1.88),('15844','2013-06-16','09:25:00',1.99),('15844','2013-06-16','09:30:00',2.19),('15844','2013-06-16','09:35:00',2.33),('15844','2013-06-16','09:40:00',2.46),('15844','2013-06-16','09:45:00',2.6),('15844','2013-06-16','09:50:00',2.71),('15844','2013-06-16','09:55:00',2.81),('15844','2013-06-16','10:00:00',2.92),('15844','2013-06-16','10:05:00',3.02),('15844','2013-06-16','10:10:00',3.08),('15844','2013-06-16','10:15:00',3.14),('15844','2013-06-16','10:20:00',3.2),('15844','2013-06-16','10:25:00',3.38),('15844','2013-06-16','10:30:00',3.57),('15844','2013-06-16','10:35:00',3.73),('15844','2013-06-16','10:40:00',3.82),('15844','2013-06-16','10:45:00',3.87),('15844','2013-06-16','10:50:00',3.98),('15844','2013-06-16','10:55:00',4.12),('15844','2013-06-16','11:00:00',4.18),('15844','2013-06-16','11:05:00',4.19),('15844','2013-06-16','11:10:00',4.23),('15844','2013-06-16','11:15:00',4.23),('15844','2013-06-16','11:20:00',4.29),('15844','2013-06-16','11:25:00',4.3),('15844','2013-06-16','11:30:00',4.31),('15844','2013-06-16','11:35:00',4.33),('15844','2013-06-16','11:40:00',4.33),('15844','2013-06-16','11:45:00',4.32),('15844','2013-06-16','11:50:00',4.34),('15844','2013-06-16','11:55:00',4.34),('15844','2013-06-16','12:00:00',4.32),('15844','2013-06-16','12:05:00',4.25),('15844','2013-06-16','12:10:00',4.29),('15844','2013-06-16','12:15:00',4.3),('15844','2013-06-16','12:20:00',4.3),('15844','2013-06-16','12:25:00',4.31),('15844','2013-06-16','12:30:00',4.31),('15844','2013-06-16','12:35:00',4.24),('15844','2013-06-16','12:40:00',4.23),('15844','2013-06-16','12:45:00',4.25),('15844','2013-06-16','12:50:00',4.22),('15844','2013-06-16','12:55:00',4.23),('15844','2013-06-16','13:00:00',4.23),('15844','2013-06-16','13:05:00',4.22),('15844','2013-06-16','13:10:00',4.19),('15844','2013-06-16','13:15:00',4.18),('15844','2013-06-16','13:20:00',4.14),('15844','2013-06-16','13:25:00',4.12),('15844','2013-06-16','13:30:00',4.09),('15844','2013-06-16','13:35:00',4.06),('15844','2013-06-16','13:40:00',4.05),('15844','2013-06-16','13:45:00',4.03),('15844','2013-06-16','13:50:00',3.99),('15844','2013-06-16','13:55:00',3.97),('15844','2013-06-16','14:00:00',3.94),('15844','2013-06-16','14:05:00',3.88),('15844','2013-06-16','14:10:00',3.81),('15844','2013-06-16','14:15:00',3.74),('15844','2013-06-16','14:20:00',3.7),('15844','2013-06-16','14:25:00',3.63),('15844','2013-06-16','14:30:00',3.57),('15844','2013-06-16','14:35:00',3.52),('15844','2013-06-16','14:40:00',3.46),('15844','2013-06-16','14:45:00',3.37),('15844','2013-06-16','14:50:00',3.29),('15844','2013-06-16','14:55:00',3.19),('15844','2013-06-16','15:00:00',3.07),('15844','2013-06-16','15:05:00',2.96),('15844','2013-06-16','15:10:00',2.84),('15844','2013-06-16','15:15:00',2.75),('15844','2013-06-16','15:20:00',2.65),('15844','2013-06-16','15:25:00',2.53),('15844','2013-06-16','15:30:00',2.43),('15844','2013-06-16','15:35:00',2.32),('15844','2013-06-16','15:40:00',2.25),('15844','2013-06-16','15:45:00',2.18),('15844','2013-06-16','15:50:00',2.09),('15844','2013-06-16','15:55:00',1.99),('15844','2013-06-16','16:00:00',1.91),('15844','2013-06-16','16:05:00',1.82),('15844','2013-06-16','16:10:00',1.72),('15844','2013-06-16','16:15:00',1.62),('15844','2013-06-16','16:20:00',1.54),('15844','2013-06-16','16:25:00',1.49),('15844','2013-06-16','16:30:00',1.45),('15844','2013-06-16','16:35:00',1.4),('15844','2013-06-16','16:40:00',1.32),('15844','2013-06-16','16:45:00',1.25),('15844','2013-06-16','16:50:00',1.13),('15844','2013-06-16','16:55:00',1.01),('15844','2013-06-15','08:15:00',1.04),('15844','2013-06-15','08:20:00',1.21),('15844','2013-06-15','08:25:00',1.22),('15844','2013-06-15','08:30:00',1.33),('15844','2013-06-15','08:35:00',1.48),('15844','2013-06-15','08:40:00',1.67),('15844','2013-06-15','08:45:00',1.63),('15844','2013-06-15','08:50:00',1.65),('15844','2013-06-15','08:55:00',1.92),('15844','2013-06-15','09:00:00',1.87),('15844','2013-06-15','09:05:00',1.27),('15844','2013-06-15','09:10:00',1.12),('15844','2013-06-15','09:15:00',1.88),('15844','2013-06-15','09:20:00',1.96),('15844','2013-06-15','09:25:00',2.04),('15844','2013-06-15','09:30:00',2.18),('15844','2013-06-15','09:35:00',2.27),('15844','2013-06-15','09:40:00',2.43),('15844','2013-06-15','09:45:00',2.55),('15844','2013-06-15','09:50:00',2.71),('15844','2013-06-15','09:55:00',2.83),('15844','2013-06-15','10:00:00',2.89),('15844','2013-06-15','10:05:00',3.01),('15844','2013-06-15','10:10:00',3.07),('15844','2013-06-15','10:15:00',3.05),('15844','2013-06-15','10:20:00',3.07),('15844','2013-06-15','10:25:00',3.3),('15844','2013-06-15','10:30:00',3.65),('15844','2013-06-15','10:35:00',3.79),('15844','2013-06-15','10:40:00',3.87),('15844','2013-06-15','10:45:00',3.87),('15844','2013-06-15','10:50:00',3.96),('15844','2013-06-15','10:55:00',4.09),('15844','2013-06-15','11:00:00',4.15),('15844','2013-06-15','11:05:00',4.14),('15844','2013-06-15','11:10:00',4.19),('15844','2013-06-15','11:15:00',4.25),('15844','2013-06-15','11:20:00',4.29),('15844','2013-06-15','11:25:00',4.36),('15844','2013-06-15','11:30:00',4.4),('15844','2013-06-15','11:35:00',4.35),('15844','2013-06-15','11:40:00',4.3),('15844','2013-06-15','11:45:00',4.38),('15844','2013-06-15','11:50:00',4.31),('15844','2013-06-15','11:55:00',4.37),('15844','2013-06-15','12:00:00',4.38),('15844','2013-06-15','12:05:00',4.37),('15844','2013-06-15','12:10:00',4.35),('15844','2013-06-15','12:15:00',4.42),('15844','2013-06-15','12:20:00',4.38),('15844','2013-06-15','12:25:00',4.35),('15844','2013-06-15','12:30:00',4.36),('15844','2013-06-15','12:35:00',4.39),('15844','2013-06-15','12:40:00',4.34),('15844','2013-06-15','12:45:00',4.32),('15844','2013-06-15','12:50:00',4.33),('15844','2013-06-15','12:55:00',4.31),('15844','2013-06-15','13:00:00',4.29),('15844','2013-06-15','13:05:00',4.24),('15844','2013-06-15','13:10:00',4.2),('15844','2013-06-15','13:15:00',4.17),('15844','2013-06-15','13:20:00',4.18),('15844','2013-06-15','13:25:00',4.11),('15844','2013-06-15','13:30:00',4.1),('15844','2013-06-15','13:35:00',4.03),('15844','2013-06-15','13:40:00',4.06),('15844','2013-06-15','13:45:00',3.98),('15844','2013-06-15','13:50:00',3.89),('15844','2013-06-15','13:55:00',3.92),('15844','2013-06-15','14:00:00',3.89),('15844','2013-06-15','14:05:00',3.86),('15844','2013-06-15','14:10:00',3.78),('15844','2013-06-15','14:15:00',3.69),('15844','2013-06-15','14:20:00',3.66),('15844','2013-06-15','14:25:00',3.61),('15844','2013-06-15','14:30:00',3.55),('15844','2013-06-15','14:35:00',3.51),('15844','2013-06-15','14:40:00',3.44),('15844','2013-06-15','14:45:00',3.36),('15844','2013-06-15','14:50:00',3.27),('15844','2013-06-15','14:55:00',3.17),('15844','2013-06-15','15:00:00',3.05),('15844','2013-06-15','15:05:00',2.94),('15844','2013-06-15','15:10:00',2.83),('15844','2013-06-15','15:15:00',2.72),('15844','2013-06-15','15:20:00',2.58),('15844','2013-06-15','15:25:00',2.48),('15844','2013-06-15','15:30:00',2.38),('15844','2013-06-15','15:35:00',2.31),('15844','2013-06-15','15:40:00',2.22),('15844','2013-06-15','15:45:00',2.16),('15844','2013-06-15','15:50:00',2.07),('15844','2013-06-15','15:55:00',1.98),('15844','2013-06-15','16:00:00',1.89),('15844','2013-06-15','16:05:00',1.79),('15844','2013-06-15','16:10:00',1.69),('15844','2013-06-15','16:15:00',1.6),('15844','2013-06-15','16:20:00',1.53),('15844','2013-06-15','16:25:00',1.49),('15844','2013-06-15','16:30:00',1.43),('15844','2013-06-15','16:35:00',1.38),('15844','2013-06-15','16:40:00',1.29),('15844','2013-06-15','16:45:00',1.22),('15844','2013-06-15','16:50:00',1.11),('15844','2013-06-14','08:20:00',1),('15844','2013-06-14','08:25:00',1.11),('15844','2013-06-14','08:30:00',1.21),('15844','2013-06-14','08:35:00',1.28),('15844','2013-06-14','08:40:00',1.33),('15844','2013-06-14','08:45:00',1.34),('15844','2013-06-14','08:50:00',1.39),('15844','2013-06-14','08:55:00',1.51),('15844','2013-06-14','09:00:00',1.6),('15844','2013-06-14','09:05:00',1.68),('15844','2013-06-14','09:10:00',1.77),('15844','2013-06-14','09:15:00',1.85),('15844','2013-06-14','09:20:00',1.94),('15844','2013-06-14','09:25:00',2.06),('15844','2013-06-14','09:30:00',2.25),('15844','2013-06-14','09:35:00',2.41),('15844','2013-06-14','09:40:00',2.54),('15844','2013-06-14','09:45:00',2.7),('15844','2013-06-14','09:50:00',2.85),('15844','2013-06-14','09:55:00',2.94),('15844','2013-06-14','10:00:00',3),('15844','2013-06-14','10:05:00',3.05),('15844','2013-06-14','10:10:00',3.17),('15844','2013-06-14','10:15:00',3.25),('15844','2013-06-14','10:20:00',3.43),('15844','2013-06-14','10:25:00',3.58),('15844','2013-06-14','10:30:00',3.68),('15844','2013-06-14','10:35:00',3.78),('15844','2013-06-14','10:40:00',3.94),('15844','2013-06-14','10:45:00',3.94),('15844','2013-06-14','10:50:00',4.01),('15844','2013-06-14','10:55:00',4.12),('15844','2013-06-14','11:00:00',4.19),('15844','2013-06-14','11:05:00',4.26),('15844','2013-06-14','11:10:00',4.25),('15844','2013-06-14','11:15:00',4.14),('15844','2013-06-14','11:20:00',4.31),('15844','2013-06-14','11:25:00',4.29),('15844','2013-06-14','11:30:00',4.33),('15844','2013-06-14','11:35:00',4.36),('15844','2013-06-14','11:40:00',4.37),('15844','2013-06-14','11:45:00',4.36),('15844','2013-06-14','11:50:00',4.35),('15844','2013-06-14','11:55:00',4.36),('15844','2013-06-14','12:00:00',4.39),('15844','2013-06-14','12:05:00',4.44),('15844','2013-06-14','12:10:00',4.44),('15844','2013-06-14','12:15:00',4.45),('15844','2013-06-14','12:20:00',4.44),('15844','2013-06-14','12:25:00',4.45),('15844','2013-06-14','12:30:00',4.39),('15844','2013-06-14','12:35:00',4.37),('15844','2013-06-14','12:40:00',4.36),('15844','2013-06-14','12:45:00',4.37),('15844','2013-06-14','12:50:00',4.35),('15844','2013-06-14','12:55:00',4.34),('15844','2013-06-14','13:00:00',4.27),('15844','2013-06-14','13:05:00',4.22),('15844','2013-06-14','13:10:00',4.24),('15844','2013-06-14','13:15:00',4.25),('15844','2013-06-14','13:20:00',4.24),('15844','2013-06-14','13:25:00',4.21),('15844','2013-06-14','13:30:00',4.16),('15844','2013-06-14','13:35:00',4.16),('15844','2013-06-14','13:40:00',4.14),('15844','2013-06-14','13:45:00',4.06),('15844','2013-06-14','13:50:00',4.04),('15844','2013-06-14','13:55:00',4.02),('15844','2013-06-14','14:00:00',3.94),('15844','2013-06-14','14:05:00',3.87),('15844','2013-06-14','14:10:00',3.81),('15844','2013-06-14','14:15:00',3.78),('15844','2013-06-14','14:20:00',3.74),('15844','2013-06-14','14:25:00',3.69),('15844','2013-06-14','14:30:00',3.64),('15844','2013-06-14','14:35:00',3.59),('15844','2013-06-14','14:40:00',3.52),('15844','2013-06-14','14:45:00',3.43),('15844','2013-06-14','14:50:00',3.33),('15844','2013-06-14','14:55:00',3.21),('15844','2013-06-14','15:00:00',3.08),('15844','2013-06-14','15:05:00',2.98),('15844','2013-06-14','15:10:00',2.84),('15844','2013-06-14','15:15:00',2.72),('15844','2013-06-14','15:20:00',2.63),('15844','2013-06-14','15:25:00',2.52),('15844','2013-06-14','15:30:00',2.39),('15844','2013-06-14','15:35:00',2.33),('15844','2013-06-14','15:40:00',2.24),('15844','2013-06-14','15:45:00',2.13),('15844','2013-06-14','15:50:00',2.05),('15844','2013-06-14','15:55:00',1.96),('15844','2013-06-14','16:00:00',1.9),('15844','2013-06-14','16:05:00',1.78),('15844','2013-06-14','16:10:00',1.65),('15844','2013-06-14','16:15:00',1.59),('15844','2013-06-14','16:20:00',1.51),('15844','2013-06-14','16:25:00',1.47),('15844','2013-06-14','16:30:00',1.42),('15844','2013-06-14','16:35:00',1.38),('15844','2013-06-14','16:40:00',1.29),('15844','2013-06-14','16:45:00',1.21),('15844','2013-06-14','16:50:00',1.09),('15844','2013-06-13','08:20:00',1.02),('15844','2013-06-13','08:25:00',1.12),('15844','2013-06-13','08:30:00',1.21),('15844','2013-06-13','08:35:00',1.29),('15844','2013-06-13','08:40:00',1.34),('15844','2013-06-13','08:45:00',1.35),('15844','2013-06-13','08:50:00',1.41),('15844','2013-06-13','08:55:00',1.53),('15844','2013-06-13','09:00:00',1.63),('15844','2013-06-13','09:05:00',1.72),('15844','2013-06-13','09:10:00',1.82),('15844','2013-06-13','09:15:00',1.9),('15844','2013-06-13','09:20:00',1.99),('15844','2013-06-13','09:25:00',2.14),('15844','2013-06-13','09:30:00',2.3),('15844','2013-06-13','09:35:00',2.46),('15844','2013-06-13','09:40:00',2.59),('15844','2013-06-13','09:45:00',2.77),('15844','2013-06-13','09:50:00',2.93),('15844','2013-06-13','09:55:00',3.03),('15844','2013-06-13','10:00:00',3.13),('15844','2013-06-13','10:05:00',3.24),('15844','2013-06-13','10:10:00',3.32),('15844','2013-06-13','10:15:00',3.38),('15844','2013-06-13','10:20:00',3.49),('15844','2013-06-13','10:25:00',3.69),('15844','2013-06-13','10:30:00',3.85),('15844','2013-06-13','10:35:00',3.97),('15844','2013-06-13','10:40:00',4.07),('15844','2013-06-13','10:45:00',4.1),('15844','2013-06-13','10:50:00',4.18),('15844','2013-06-13','10:55:00',4.29),('15844','2013-06-13','11:00:00',4.33),('15844','2013-06-13','11:05:00',4.36),('15844','2013-06-13','11:10:00',4.38),('15844','2013-06-13','11:15:00',4.42),('15844','2013-06-13','11:20:00',4.46),('15844','2013-06-13','11:25:00',4.5),('15844','2013-06-13','11:30:00',4.47),('15844','2013-06-13','11:35:00',4.44),('15844','2013-06-13','11:40:00',4.45),('15844','2013-06-13','11:45:00',4.49),('15844','2013-06-13','11:50:00',4.52),('15844','2013-06-13','11:55:00',4.48),('15844','2013-06-13','12:00:00',4.51),('15844','2013-06-13','12:05:00',4.53),('15844','2013-06-13','12:10:00',4.48),('15844','2013-06-13','12:15:00',4.47),('15844','2013-06-13','12:20:00',4.48),('15844','2013-06-13','12:25:00',4.46),('15844','2013-06-13','12:30:00',4.47),('15844','2013-06-13','12:35:00',4.48),('15844','2013-06-13','12:40:00',4.48),('15844','2013-06-13','12:45:00',4.44),('15844','2013-06-13','12:50:00',4.42),('15844','2013-06-13','12:55:00',4.42),('15844','2013-06-13','13:00:00',4.39),('15844','2013-06-13','13:05:00',4.34),('15844','2013-06-13','13:10:00',4.36),('15844','2013-06-13','13:15:00',4.31),('15844','2013-06-13','13:20:00',4.26),('15844','2013-06-13','13:25:00',4.24),('15844','2013-06-13','13:30:00',4.2),('15844','2013-06-13','13:35:00',4.12),('15844','2013-06-13','13:40:00',4.17),('15844','2013-06-13','13:45:00',4.13),('15844','2013-06-13','13:50:00',4.07),('15844','2013-06-13','13:55:00',3.99),('15844','2013-06-13','14:00:00',4.01),('15844','2013-06-13','14:05:00',3.96),('15844','2013-06-13','14:10:00',3.85),('15844','2013-06-13','14:15:00',2.9),('15844','2013-06-13','14:20:00',3.79),('15844','2013-06-13','14:25:00',3.73),('15844','2013-06-13','14:30:00',3.67),('15844','2013-06-13','14:35:00',3.61),('15844','2013-06-13','14:40:00',3.56),('15844','2013-06-13','14:45:00',3.47),('15844','2013-06-13','14:50:00',3.4),('15844','2013-06-13','14:55:00',3.25),('15844','2013-06-13','15:00:00',3.04),('15844','2013-06-13','15:05:00',2.94),('15844','2013-06-13','15:10:00',2.85),('15844','2013-06-13','15:15:00',2.71),('15844','2013-06-13','15:20:00',2.58),('15844','2013-06-13','15:25:00',2.45),('15844','2013-06-13','15:30:00',2.3),('15844','2013-06-13','15:35:00',2.27),('15844','2013-06-13','15:40:00',2.21),('15844','2013-06-13','15:45:00',2.16),('15844','2013-06-13','15:50:00',2.06),('15844','2013-06-13','15:55:00',1.94),('15844','2013-06-13','16:00:00',1.85),('15844','2013-06-13','16:05:00',1.76),('15844','2013-06-13','16:10:00',1.65),('15844','2013-06-13','16:15:00',1.58),('15844','2013-06-13','16:20:00',1.51),('15844','2013-06-13','16:25:00',1.46),('15844','2013-06-13','16:30:00',1.44),('15844','2013-06-13','16:35:00',1.37),('15844','2013-06-13','16:40:00',1.28),('15844','2013-06-13','16:45:00',1.22),('15844','2013-06-13','16:50:00',1.08),('15844','2013-06-12','08:20:00',1.03),('15844','2013-06-12','08:25:00',1.14),('15844','2013-06-12','08:30:00',1.23),('15844','2013-06-12','08:35:00',1.31),('15844','2013-06-12','08:40:00',1.35),('15844','2013-06-12','08:45:00',1.37),('15844','2013-06-12','08:50:00',1.43),('15844','2013-06-12','08:55:00',1.55),('15844','2013-06-12','09:00:00',1.63),('15844','2013-06-12','09:05:00',1.72),('15844','2013-06-12','09:10:00',1.83),('15844','2013-06-12','09:15:00',1.91),('15844','2013-06-12','09:20:00',1.99),('15844','2013-06-12','09:25:00',2.14),('15844','2013-06-12','09:30:00',2.32),('15844','2013-06-12','09:35:00',2.49),('15844','2013-06-12','09:40:00',2.64),('15844','2013-06-12','09:45:00',2.76),('15844','2013-06-12','09:50:00',2.9),('15844','2013-06-12','09:55:00',2.99),('15844','2013-06-12','10:00:00',3.11),('15844','2013-06-12','10:05:00',3.18),('15844','2013-06-12','10:10:00',3.29),('15844','2013-06-12','10:15:00',3.33),('15844','2013-06-12','10:20:00',3.42),('15844','2013-06-12','10:25:00',3.65),('15844','2013-06-12','10:30:00',3.81),('15844','2013-06-12','10:35:00',3.98),('15844','2013-06-12','10:40:00',4.05),('15844','2013-06-12','10:45:00',4.08),('15844','2013-06-12','10:50:00',4.18),('15844','2013-06-12','10:55:00',4.28),('15844','2013-06-12','11:00:00',4.33),('15844','2013-06-12','11:05:00',4.39),('15844','2013-06-12','11:10:00',4.4),('15844','2013-06-12','11:15:00',4.46),('15844','2013-06-12','11:20:00',4.47),('15844','2013-06-12','11:25:00',4.45),('15844','2013-06-12','11:30:00',4.46),('15844','2013-06-12','11:35:00',4.48),('15844','2013-06-12','11:40:00',4.51),('15844','2013-06-12','11:45:00',4.49),('15844','2013-06-12','11:50:00',4.45),('15844','2013-06-12','11:55:00',4.47),('15844','2013-06-12','12:00:00',4.51),('15844','2013-06-12','12:05:00',4.49),('15844','2013-06-12','12:10:00',4.48),('15844','2013-06-12','12:15:00',4.51),('15844','2013-06-12','12:20:00',4.44),('15844','2013-06-12','12:25:00',4.48),('15844','2013-06-12','12:30:00',3.97),('15844','2013-06-12','12:35:00',4.53),('15844','2013-06-12','12:40:00',4.28),('15844','2013-06-12','12:45:00',4.57),('15844','2013-06-12','12:50:00',4.42),('15844','2013-06-12','12:55:00',4.36),('15844','2013-06-12','13:00:00',3.7),('15844','2013-06-12','13:05:00',4.2),('15844','2013-06-12','13:10:00',4.35),('15844','2013-06-12','13:15:00',4.29),('15844','2013-06-12','13:20:00',4.29),('15844','2013-06-12','13:25:00',4.3),('15844','2013-06-12','13:30:00',4.32),('15844','2013-06-12','13:35:00',4.23),('15844','2013-06-12','13:40:00',4.23),('15844','2013-06-12','13:45:00',4.23),('15844','2013-06-12','13:50:00',3.34),('15844','2013-06-12','13:55:00',2.72),('15844','2013-06-12','14:00:00',4.26),('15844','2013-06-12','14:05:00',4.19),('15844','2013-06-12','14:10:00',4.08),('15844','2013-06-12','14:15:00',3.85),('15844','2013-06-12','14:20:00',3.84),('15844','2013-06-12','14:25:00',3.81),('15844','2013-06-12','14:30:00',3.67),('15844','2013-06-12','14:35:00',3.62),('15844','2013-06-12','14:40:00',3.53),('15844','2013-06-12','14:45:00',3.4),('15844','2013-06-12','14:50:00',3.29),('15844','2013-06-12','14:55:00',3.22),('15844','2013-06-12','15:00:00',3.13),('15844','2013-06-12','15:05:00',3.04),('15844','2013-06-12','15:10:00',2.79),('15844','2013-06-12','15:15:00',2.39),('15844','2013-06-12','15:20:00',2.6),('15844','2013-06-12','15:25:00',2.44),('15844','2013-06-12','15:30:00',2.52),('15844','2013-06-12','15:35:00',2.38),('15844','2013-06-12','15:40:00',2.27),('15844','2013-06-12','15:45:00',2.21),('15844','2013-06-12','15:50:00',2.14),('15844','2013-06-12','15:55:00',2.05),('15844','2013-06-12','16:00:00',2.01),('15844','2013-06-12','16:05:00',1.84),('15844','2013-06-12','16:10:00',1.75),('15844','2013-06-12','16:15:00',1.69),('15844','2013-06-12','16:20:00',1.59),('15844','2013-06-12','16:25:00',1.63),('15844','2013-06-12','16:30:00',1.66),('15844','2013-06-12','16:35:00',1.51),('15844','2013-06-12','16:40:00',1.46),('15844','2013-06-12','16:45:00',1.43),('15844','2013-06-12','16:50:00',1.18),('15844','2013-06-12','16:55:00',1.04),('15844','2013-06-11','08:20:00',1.04),('15844','2013-06-11','08:25:00',1.14),('15844','2013-06-11','08:30:00',1.22),('15844','2013-06-11','08:35:00',1.32),('15844','2013-06-11','08:40:00',1.38),('15844','2013-06-11','08:45:00',1.38),('15844','2013-06-11','08:50:00',1.44),('15844','2013-06-11','08:55:00',1.58),('15844','2013-06-11','09:00:00',1.14),('15844','2013-06-11','09:05:00',1.72),('15844','2013-06-11','09:10:00',1.73),('15844','2013-06-11','09:20:00',1.97),('15844','2013-06-11','09:25:00',2.2),('15844','2013-06-11','09:30:00',2.41),('15844','2013-06-11','09:35:00',2.5),('15844','2013-06-11','09:40:00',2.62),('15844','2013-06-11','09:45:00',2.84),('15844','2013-06-11','09:50:00',2.94),('15844','2013-06-11','09:55:00',3.04),('15844','2013-06-11','10:00:00',2.92),('15844','2013-06-11','10:05:00',3.24),('15844','2013-06-11','10:10:00',3.03),('15844','2013-06-11','10:15:00',3.37),('15844','2013-06-11','10:20:00',3.71),('15844','2013-06-11','10:25:00',3.89),('15844','2013-06-11','10:30:00',3.96),('15844','2013-06-11','10:35:00',4.05),('15844','2013-06-11','10:40:00',4.04),('15844','2013-06-11','10:45:00',2.39),('15844','2013-06-11','10:50:00',3.52),('15844','2013-06-11','10:55:00',3.45),('15844','2013-06-11','11:00:00',3.54),('15844','2013-06-11','11:05:00',4.59),('15844','2013-06-11','11:10:00',4.52),('15844','2013-06-11','11:15:00',4.54),('15844','2013-06-11','11:20:00',4.52),('15844','2013-06-11','11:25:00',4.54),('15844','2013-06-11','11:30:00',4.53),('15844','2013-06-11','11:35:00',4.16),('15844','2013-06-11','11:40:00',4.6),('15844','2013-06-11','11:45:00',4.63),('15844','2013-06-11','11:50:00',4.63),('15844','2013-06-11','11:55:00',4.63),('15844','2013-06-11','12:00:00',4.69),('15844','2013-06-11','12:05:00',4.57),('15844','2013-06-11','12:10:00',4.56),('15844','2013-06-11','12:15:00',4.59),('15844','2013-06-11','12:20:00',4.56),('15844','2013-06-11','12:25:00',4.58),('15844','2013-06-11','12:30:00',4.48),('15844','2013-06-11','12:35:00',4.58),('15844','2013-06-11','12:40:00',4.58),('15844','2013-06-11','12:45:00',4.56),('15844','2013-06-11','12:50:00',4.58),('15844','2013-06-11','12:55:00',4.53),('15844','2013-06-11','13:00:00',4.5),('15844','2013-06-11','13:05:00',4.25),('15844','2013-06-11','13:10:00',4.36),('15844','2013-06-11','13:15:00',4.3),('15844','2013-06-11','13:20:00',4.39),('15844','2013-06-11','13:25:00',4.43),('15844','2013-06-11','13:30:00',4.31),('15844','2013-06-11','13:35:00',4.3),('15844','2013-06-11','13:40:00',4.27),('15844','2013-06-11','13:45:00',4.26),('15844','2013-06-11','13:50:00',4.13),('15844','2013-06-11','13:55:00',4.09),('15844','2013-06-11','14:00:00',4.08),('15844','2013-06-11','14:05:00',4.04),('15844','2013-06-11','14:10:00',3.9),('15844','2013-06-11','14:15:00',3.88),('15844','2013-06-11','14:20:00',3.82),('15844','2013-06-11','14:25:00',3.77),('15844','2013-06-11','14:30:00',3.7),('15844','2013-06-11','14:35:00',3.62),('15844','2013-06-11','14:40:00',3.54),('15844','2013-06-11','14:45:00',3.48),('15844','2013-06-11','14:50:00',3.17),('15844','2013-06-11','14:55:00',3.28),('15844','2013-06-11','15:00:00',3.21),('15844','2013-06-11','15:05:00',3.06),('15844','2013-06-11','15:10:00',2.99),('15844','2013-06-11','15:15:00',2.82),('15844','2013-06-11','15:20:00',2.68),('15844','2013-06-11','15:25:00',2.61),('15844','2013-06-11','15:30:00',2.22),('15844','2013-06-11','15:35:00',2.15),('15844','2013-06-11','15:40:00',2.45),('15844','2013-06-11','15:45:00',2.03),('15844','2013-06-11','15:50:00',1.85),('15844','2013-06-11','15:55:00',2.11),('15844','2013-06-11','16:00:00',2.03),('15844','2013-06-11','16:05:00',1.87),('15844','2013-06-11','16:10:00',1.77),('15844','2013-06-11','16:15:00',1.68),('15844','2013-06-11','16:20:00',1.59),('15844','2013-06-11','16:25:00',1.57),('15844','2013-06-11','16:30:00',1.54),('15844','2013-06-11','16:35:00',1.5),('15844','2013-06-11','16:40:00',1.52),('15844','2013-06-11','16:45:00',1.57),('15844','2013-06-11','16:50:00',1.46),('15844','2013-06-11','16:55:00',1.16),('15844','2014-04-03','09:00:00',1.03),('15844','2014-04-03','09:05:00',1.12),('15844','2014-04-03','09:10:00',1.02),('15844','2014-04-03','09:20:00',1.01),('15844','2014-04-03','09:25:00',1.12),('15844','2014-04-03','09:30:00',1.34),('15844','2014-04-03','09:35:00',1.49),('15844','2014-04-03','09:40:00',1.49),('15844','2014-04-03','09:45:00',1.45),('15844','2014-04-03','09:50:00',1.47),('15844','2014-04-03','09:55:00',1.67),('15844','2014-04-03','10:00:00',2.01),('15844','2014-04-03','10:05:00',2.15),('15844','2014-04-03','10:10:00',2.41),('15844','2014-04-03','10:15:00',2.69),('15844','2014-04-03','10:20:00',2.3),('15844','2014-04-03','10:25:00',1.77),('15844','2014-04-03','10:30:00',2.61),('15844','2014-04-03','10:35:00',2.48),('15844','2014-04-03','10:40:00',2.32),('15844','2014-04-03','10:45:00',2.5),('15844','2014-04-03','10:50:00',2.2),('15844','2014-04-03','10:55:00',1.98),('15844','2014-04-03','11:00:00',1.61),('15844','2014-04-03','11:05:00',1.4),('15844','2014-04-03','11:10:00',1.32),('15844','2014-04-03','11:15:00',1.24),('15844','2014-04-03','11:20:00',1.14),('15844','2014-04-03','11:25:00',1.04),('15844','2014-04-03','11:30:00',1.07),('15844','2014-04-03','11:35:00',1.19),('15844','2014-04-03','11:40:00',1.29),('15844','2014-04-03','11:45:00',1.45),('15844','2014-04-03','11:50:00',1.73),('15844','2014-04-03','11:55:00',1.86),('15844','2014-04-03','12:00:00',1.98),('15844','2014-04-03','12:05:00',1.95),('15844','2014-04-03','12:10:00',1.76),('15844','2014-04-03','12:15:00',1.85),('15844','2014-04-03','12:20:00',2.24),('15844','2014-04-03','12:25:00',2.96),('15844','2014-04-03','12:30:00',3.7),('15844','2014-04-03','12:35:00',3.04),('15844','2014-04-03','12:40:00',2.59),('15844','2014-04-03','12:45:00',1.85),('15844','2014-04-03','12:50:00',2.54),('15844','2014-04-03','12:55:00',2.24),('15844','2014-04-03','13:00:00',1.81),('15844','2014-04-03','13:05:00',2.1),('15844','2014-04-03','13:10:00',2.32),('15844','2014-04-03','13:15:00',2.75),('15844','2014-04-03','13:20:00',1.91),('15844','2014-04-03','13:25:00',2.33),('15844','2014-04-03','13:30:00',3.15),('15844','2014-04-03','13:35:00',3.77),('15844','2014-04-03','13:40:00',2.3),('15844','2014-04-03','13:45:00',1.52),('15844','2014-04-03','13:50:00',1.88),('15844','2014-04-03','13:55:00',2.04),('15844','2014-04-03','14:00:00',2.58),('15844','2014-04-03','14:05:00',2.82),('15844','2014-04-03','14:10:00',2.32),('15844','2014-04-03','14:15:00',2.92),('15844','2014-04-03','14:20:00',2.71),('15844','2014-04-03','14:25:00',2.66),('15844','2014-04-03','14:30:00',3.06),('15844','2014-04-03','14:35:00',2.91),('15844','2014-04-03','14:40:00',2.73),('15844','2014-04-03','14:45:00',2.52),('15844','2014-04-03','14:50:00',2.46),('15844','2014-04-03','14:55:00',2.37),('15844','2014-04-03','15:00:00',2.26),('15844','2014-04-03','15:05:00',2.14),('15844','2014-04-03','15:10:00',2.04),('15844','2014-04-03','15:15:00',1.94),('15844','2014-04-03','15:20:00',1.81),('15844','2014-04-03','15:25:00',1.73),('15844','2014-04-03','15:30:00',1.67),('15844','2014-04-03','15:35:00',1.57),('15844','2014-04-03','15:40:00',1.47),('15844','2014-04-03','15:45:00',1.37),('15844','2014-04-03','15:50:00',1.26),('15844','2014-04-03','15:55:00',1.13),('15844','2014-04-03','16:00:00',1.15),('15844','2014-04-03','16:05:00',1.05),('15844','2014-04-03','16:10:00',1.04),('15844','2013-06-10','08:10:00',1.11),('15844','2013-06-10','08:25:00',1.41),('15844','2013-06-10','08:50:00',1.43),('15844','2013-06-10','08:55:00',1.58),('15844','2013-06-10','09:05:00',1.09),('15844','2013-06-10','09:10:00',1.05),('15844','2013-06-10','09:15:00',2.11),('15844','2013-06-10','09:20:00',1.98),('15844','2013-06-10','09:25:00',2.69),('15844','2013-06-10','09:30:00',2.49),('15844','2013-06-10','09:35:00',1.18),('15844','2013-06-10','09:40:00',1.33),('15844','2013-06-10','09:50:00',1.13),('15844','2013-06-10','10:00:00',1.67),('15844','2013-06-10','10:05:00',2.61),('15844','2013-06-10','10:10:00',3.44),('15844','2013-06-10','10:15:00',3.52),('15844','2013-06-10','10:20:00',3.3),('15844','2013-06-10','10:25:00',2.18),('15844','2013-06-10','10:30:00',1.11),('15844','2013-06-10','10:35:00',1.36),('15844','2013-06-10','10:40:00',2.17),('15844','2013-06-10','10:45:00',4.59),('15844','2013-06-10','10:50:00',3.86),('15844','2013-06-10','10:55:00',3.34),('15844','2013-06-10','11:00:00',1.15),('15844','2013-06-10','11:05:00',3.22),('15844','2013-06-10','11:10:00',2.99),('15844','2013-06-10','11:15:00',3.79),('15844','2013-06-10','11:20:00',4.33),('15844','2013-06-10','11:25:00',4.19),('15844','2013-06-10','11:30:00',1.39),('15844','2013-06-10','11:35:00',1.89),('15844','2013-06-10','11:40:00',1.69),('15844','2013-06-10','11:45:00',1.29),('15844','2013-06-10','11:50:00',4.18),('15844','2013-06-10','11:55:00',1.77),('15844','2013-06-10','12:05:00',4.11),('15844','2013-06-10','12:10:00',4.85),('15844','2013-06-10','12:15:00',3.22),('15844','2013-06-10','12:20:00',4.84),('15844','2013-06-10','12:25:00',3.87),('15844','2013-06-10','12:30:00',2.74),('15844','2013-06-10','12:35:00',2.8),('15844','2013-06-10','12:40:00',3.8),('15844','2013-06-10','12:45:00',4.24),('15844','2013-06-10','12:50:00',4.67),('15844','2013-06-10','12:55:00',3.68),('15844','2013-06-10','13:00:00',4.14),('15844','2013-06-10','13:05:00',3.29),('15844','2013-06-10','13:10:00',1.43),('15844','2013-06-10','13:15:00',1.86),('15844','2013-06-10','13:20:00',4.7),('15844','2013-06-10','13:25:00',2.48),('15844','2013-06-10','13:30:00',4.94),('15844','2013-06-10','13:35:00',3.86),('15844','2013-06-10','13:40:00',1.59),('15844','2013-06-10','13:45:00',2.07),('15844','2013-06-10','13:50:00',1.62),('15844','2013-06-10','13:55:00',2.6),('15844','2013-06-10','14:00:00',3.19),('15844','2013-06-10','14:05:00',3.06),('15844','2013-06-10','14:10:00',4.34),('15844','2013-06-10','14:15:00',3.28),('15844','2013-06-10','14:20:00',3.63),('15844','2013-06-10','14:25:00',3.61),('15844','2013-06-10','14:30:00',3.76),('15844','2013-06-10','14:35:00',3.65),('15844','2013-06-10','14:40:00',3.6),('15844','2013-06-10','14:45:00',3.5),('15844','2013-06-10','14:50:00',3.38),('15844','2013-06-10','14:55:00',3.28),('15844','2013-06-10','15:00:00',3.17),('15844','2013-06-10','15:05:00',3.07),('15844','2013-06-10','15:10:00',2.94),('15844','2013-06-10','15:15:00',2.86),('15844','2013-06-10','15:20:00',2.72),('15844','2013-06-10','15:25:00',2.59),('15844','2013-06-10','15:30:00',2.49),('15844','2013-06-10','15:35:00',2.37),('15844','2013-06-10','15:40:00',2.31),('15844','2013-06-10','15:45:00',2.22),('15844','2013-06-10','15:50:00',2.13),('15844','2013-06-10','15:55:00',2.03),('15844','2013-06-10','16:00:00',1.93),('15844','2013-06-10','16:05:00',1.82),('15844','2013-06-10','16:10:00',1.74),('15844','2013-06-10','16:15:00',1.64),('15844','2013-06-10','16:20:00',1.57),('15844','2013-06-10','16:25:00',1.53),('15844','2013-06-10','16:30:00',1.46),('15844','2013-06-10','16:35:00',1.41),('15844','2013-06-10','16:40:00',1.32),('15844','2013-06-10','16:45:00',1.23),('15844','2013-06-10','16:50:00',1.11),('15844','2013-06-09','08:20:00',1.02),('15844','2013-06-09','08:25:00',1.06),('15844','2013-06-09','08:30:00',1.14),('15844','2013-06-09','08:35:00',1.17),('15844','2013-06-09','08:40:00',1.29),('15844','2013-06-09','08:45:00',1.37),('15844','2013-06-09','08:50:00',1.38),('15844','2013-06-09','08:55:00',1.57),('15844','2013-06-09','09:00:00',1.63),('15844','2013-06-09','09:05:00',1.65),('15844','2013-06-09','09:10:00',1.7),('15844','2013-06-09','09:15:00',1.81),('15844','2013-06-09','09:20:00',1.95),('15844','2013-06-09','09:25:00',2.11),('15844','2013-06-09','09:30:00',2.23),('15844','2013-06-09','09:35:00',2.38),('15844','2013-06-09','09:40:00',2.52),('15844','2013-06-09','09:45:00',2.67),('15844','2013-06-09','09:50:00',2.79),('15844','2013-06-09','09:55:00',2.84),('15844','2013-06-09','10:00:00',2.97),('15844','2013-06-09','10:05:00',3.04),('15844','2013-06-09','10:10:00',3.13),('15844','2013-06-09','10:15:00',3.17),('15844','2013-06-09','10:20:00',3.36),('15844','2013-06-09','10:25:00',3.47),('15844','2013-06-09','10:30:00',3.61),('15844','2013-06-09','10:35:00',3.79),('15844','2013-06-09','10:40:00',3.83),('15844','2013-06-09','10:45:00',3.93),('15844','2013-06-09','10:50:00',3.99),('15844','2013-06-09','10:55:00',3.99),('15844','2013-06-09','11:00:00',3.95),('15844','2013-06-09','11:05:00',4.11),('15844','2013-06-09','11:10:00',4.16),('15844','2013-06-09','11:15:00',4.11),('15844','2013-06-09','11:20:00',4.1),('15844','2013-06-09','11:25:00',3.96),('15844','2013-06-09','11:30:00',3.65),('15844','2013-06-09','11:35:00',4.18),('15844','2013-06-09','11:40:00',4.28),('15844','2013-06-09','11:45:00',4.22),('15844','2013-06-09','11:50:00',4.29),('15844','2013-06-09','11:55:00',4.11),('15844','2013-06-09','12:00:00',4.1),('15844','2013-06-09','12:05:00',4.21),('15844','2013-06-09','12:10:00',4.1),('15844','2013-06-09','12:15:00',4.21),('15844','2013-06-09','12:20:00',4.07),('15844','2013-06-09','12:25:00',4.16),('15844','2013-06-09','12:30:00',4.24),('15844','2013-06-09','12:35:00',3.76),('15844','2013-06-09','12:40:00',3.45),('15844','2013-06-09','12:45:00',4.17),('15844','2013-06-09','12:50:00',3.95),('15844','2013-06-09','12:55:00',3.83),('15844','2013-06-09','13:00:00',3.57),('15844','2013-06-09','13:05:00',3.91),('15844','2013-06-09','13:10:00',4.24),('15844','2013-06-09','13:15:00',4.11),('15844','2013-06-09','13:20:00',4.02),('15844','2013-06-09','13:25:00',4.02),('15844','2013-06-09','13:30:00',4.12),('15844','2013-06-09','13:35:00',4.02),('15844','2013-06-09','13:40:00',3.11),('15844','2013-06-09','13:45:00',3.04),('15844','2013-06-09','13:50:00',2.3),('15844','2013-06-09','13:55:00',2.16),('15844','2013-06-09','14:00:00',4.04),('15844','2013-06-09','14:05:00',4.01),('15844','2013-06-09','14:10:00',3.99),('15844','2013-06-09','14:15:00',2.68),('15844','2013-06-09','14:20:00',1.01),('15844','2013-06-09','14:30:00',1.6),('15844','2013-06-09','14:35:00',3.01),('15844','2013-06-09','14:40:00',3.48),('15844','2013-06-09','14:45:00',3.76),('15844','2013-06-09','14:50:00',3.46),('15844','2013-06-09','14:55:00',3.32),('15844','2013-06-09','15:00:00',3.16),('15844','2013-06-09','15:05:00',3.05),('15844','2013-06-09','15:10:00',2.93),('15844','2013-06-09','15:15:00',2.76),('15844','2013-06-09','15:20:00',2.65),('15844','2013-06-09','15:25:00',2.54),('15844','2013-06-09','15:30:00',2.31),('15844','2013-06-09','15:35:00',2.36),('15844','2013-06-09','15:40:00',1.75),('15844','2013-06-09','15:45:00',1.65),('15844','2013-06-09','15:50:00',2.11),('15844','2013-06-09','15:55:00',2.05),('15844','2013-06-09','16:00:00',2.21),('15844','2013-06-09','16:05:00',1.56),('15844','2013-06-09','16:10:00',1.78),('15844','2013-06-09','16:15:00',1.46),('15844','2013-06-09','16:20:00',1.64),('15844','2013-06-09','16:25:00',1.66),('15844','2013-06-08','08:25:00',1.08),('15844','2013-06-08','08:30:00',1.18),('15844','2013-06-08','08:35:00',1.24),('15844','2013-06-08','08:40:00',1.3),('15844','2013-06-08','08:45:00',1.31),('15844','2013-06-08','08:50:00',1.36),('15844','2013-06-08','08:55:00',1.49),('15844','2013-06-08','09:00:00',1.57),('15844','2013-06-08','09:05:00',1.68),('15844','2013-06-08','09:10:00',1.77),('15844','2013-06-08','09:15:00',1.84),('15844','2013-06-08','09:20:00',2.03),('15844','2013-06-08','09:25:00',2.29),('15844','2013-06-08','09:30:00',2.5),('15844','2013-06-08','09:35:00',2.55),('15844','2013-06-08','09:40:00',2.8),('15844','2013-06-08','09:45:00',3.05),('15844','2013-06-08','09:50:00',3.01),('15844','2013-06-08','09:55:00',1.85),('15844','2013-06-08','10:00:00',1.01),('15844','2013-06-08','10:05:00',1.11),('15844','2013-06-08','10:15:00',1.63),('15844','2013-06-08','10:20:00',3.72),('15844','2013-06-08','10:25:00',3.79),('15844','2013-06-08','10:30:00',3.85),('15844','2013-06-08','10:35:00',4.05),('15844','2013-06-08','10:40:00',4.12),('15844','2013-06-08','10:45:00',4.15),('15844','2013-06-08','10:50:00',4.02),('15844','2013-06-08','10:55:00',4.44),('15844','2013-06-08','11:00:00',2.89),('15844','2013-06-08','11:05:00',1.95),('15844','2013-06-08','11:10:00',1.91),('15844','2013-06-08','11:15:00',4.46),('15844','2013-06-08','11:20:00',3.05),('15844','2013-06-08','11:30:00',2.17),('15844','2013-06-08','11:35:00',4.36),('15844','2013-06-08','11:40:00',5.03),('15844','2013-06-08','11:45:00',4.41),('15844','2013-06-08','11:50:00',4.57),('15844','2013-06-08','11:55:00',4.63),('15844','2013-06-08','12:00:00',4.62),('15844','2013-06-08','12:05:00',4.67),('15844','2013-06-08','12:10:00',4.71),('15844','2013-06-08','12:15:00',4.72),('15844','2013-06-08','12:20:00',4.62),('15844','2013-06-08','12:25:00',4.27),('15844','2013-06-08','12:30:00',4.39),('15844','2013-06-08','12:35:00',4.37),('15844','2013-06-08','12:40:00',3.43),('15844','2013-06-08','12:45:00',4.48),('15844','2013-06-08','12:50:00',4.36),('15844','2013-06-08','12:55:00',4.37),('15844','2013-06-08','13:00:00',4.33),('15844','2013-06-08','13:05:00',4.23),('15844','2013-06-08','13:10:00',4.29),('15844','2013-06-08','13:15:00',4.33),('15844','2013-06-08','13:20:00',4.32),('15844','2013-06-08','13:25:00',4.21),('15844','2013-06-08','13:30:00',4.23),('15844','2013-06-08','13:35:00',4.19),('15844','2013-06-08','13:40:00',4.16),('15844','2013-06-08','13:45:00',4.14),('15844','2013-06-08','13:50:00',4.1),('15844','2013-06-08','13:55:00',4.08),('15844','2013-06-08','14:00:00',3.99),('15844','2013-06-08','14:05:00',3.95),('15844','2013-06-08','14:10:00',3.93),('15844','2013-06-08','14:15:00',3.87),('15844','2013-06-08','14:20:00',3.82),('15844','2013-06-08','14:25:00',3.75),('15844','2013-06-08','14:30:00',3.68),('15844','2013-06-08','14:35:00',3.61),('15844','2013-06-08','14:40:00',3.55),('15844','2013-06-08','14:45:00',3.42),('15844','2013-06-08','14:50:00',3.34),('15844','2013-06-08','14:55:00',3.25),('15844','2013-06-08','15:00:00',3.09),('15844','2013-06-08','15:05:00',2.88),('15844','2013-06-08','15:10:00',2.7),('15844','2013-06-08','15:15:00',2.79),('15844','2013-06-08','15:20:00',2.71),('15844','2013-06-08','15:25:00',2.36),('15844','2013-06-08','15:30:00',2.38),('15844','2013-06-08','15:35:00',2.31),('15844','2013-06-08','15:40:00',2.38),('15844','2013-06-08','15:45:00',2.45),('15844','2013-06-08','15:50:00',2.24),('15844','2013-06-08','15:55:00',2.07),('15844','2013-06-08','16:00:00',1.99),('15844','2013-06-08','16:05:00',1.91),('15844','2013-06-08','16:10:00',1.93),('15844','2013-06-08','16:15:00',1.85),('15844','2013-06-08','16:20:00',1.72),('15844','2013-06-08','16:25:00',1.59),('15844','2013-06-08','16:30:00',1.47),('15844','2013-06-08','16:35:00',1.4),('15844','2013-06-08','16:40:00',1.31),('15844','2013-06-08','16:45:00',1.14),('15844','2013-06-08','16:55:00',1.02),('15844','2013-06-07','08:20:00',1.01),('15844','2013-06-07','08:25:00',1.11),('15844','2013-06-07','08:30:00',1.2),('15844','2013-06-07','08:35:00',1.28),('15844','2013-06-07','08:40:00',1.31),('15844','2013-06-07','08:45:00',1.33),('15844','2013-06-07','08:50:00',1.41),('15844','2013-06-07','08:55:00',1.51),('15844','2013-06-07','09:00:00',1.63),('15844','2013-06-07','09:05:00',1.75),('15844','2013-06-07','09:10:00',1.81),('15844','2013-06-07','09:15:00',1.89),('15844','2013-06-07','09:20:00',2),('15844','2013-06-07','09:25:00',2.14),('15844','2013-06-07','09:30:00',2.3),('15844','2013-06-07','09:35:00',2.5),('15844','2013-06-07','09:40:00',2.64),('15844','2013-06-07','09:45:00',2.78),('15844','2013-06-07','09:50:00',2.9),('15844','2013-06-07','09:55:00',3),('15844','2013-06-07','10:00:00',3.11),('15844','2013-06-07','10:05:00',3.19),('15844','2013-06-07','10:10:00',3.27),('15844','2013-06-07','10:15:00',3.33),('15844','2013-06-07','10:20:00',3.42),('15844','2013-06-07','10:25:00',3.72),('15844','2013-06-07','10:30:00',3.89),('15844','2013-06-07','10:35:00',3.98),('15844','2013-06-07','10:40:00',4.04),('15844','2013-06-07','10:45:00',4.11),('15844','2013-06-07','10:50:00',4.21),('15844','2013-06-07','10:55:00',4.28),('15844','2013-06-07','11:00:00',4.33),('15844','2013-06-07','11:05:00',4.36),('15844','2013-06-07','11:10:00',4.38),('15844','2013-06-07','11:15:00',4.42),('15844','2013-06-07','11:20:00',4.45),('15844','2013-06-07','11:25:00',4.46),('15844','2013-06-07','11:30:00',4.43),('15844','2013-06-07','11:35:00',4.45),('15844','2013-06-07','11:40:00',4.49),('15844','2013-06-07','11:45:00',4.52),('15844','2013-06-07','11:50:00',4.48),('15844','2013-06-07','11:55:00',4.48),('15844','2013-06-07','12:00:00',4.49),('15844','2013-06-07','12:05:00',4.48),('15844','2013-06-07','12:10:00',4.39),('15844','2013-06-07','12:15:00',4.43),('15844','2013-06-07','12:20:00',4.47),('15844','2013-06-07','12:25:00',4.47),('15844','2013-06-07','12:30:00',4.45),('15844','2013-06-07','12:35:00',4.43),('15844','2013-06-07','12:40:00',4.42),('15844','2013-06-07','12:45:00',4.43),('15844','2013-06-07','12:50:00',4.41),('15844','2013-06-07','12:55:00',4.38),('15844','2013-06-07','13:00:00',4.34),('15844','2013-06-07','13:05:00',4.32),('15844','2013-06-07','13:10:00',4.29),('15844','2013-06-07','13:15:00',4.24),('15844','2013-06-07','13:20:00',4.23),('15844','2013-06-07','13:25:00',4.17),('15844','2013-06-07','13:30:00',4.15),('15844','2013-06-07','13:35:00',4.12),('15844','2013-06-07','13:40:00',4.08),('15844','2013-06-07','13:45:00',4.04),('15844','2013-06-07','13:50:00',4),('15844','2013-06-07','13:55:00',3.96),('15844','2013-06-07','14:00:00',3.92),('15844','2013-06-07','14:05:00',3.87),('15844','2013-06-07','14:10:00',3.85),('15844','2013-06-07','14:15:00',3.79),('15844','2013-06-07','14:20:00',3.73),('15844','2013-06-07','14:25:00',3.66),('15844','2013-06-07','14:30:00',3.57),('15844','2013-06-07','14:35:00',3.5),('15844','2013-06-07','14:40:00',3.42),('15844','2013-06-07','14:45:00',3.3),('15844','2013-06-07','14:50:00',3.25),('15844','2013-06-07','14:55:00',3.15),('15844','2013-06-07','15:00:00',3.02),('15844','2013-06-07','15:05:00',2.93),('15844','2013-06-07','15:10:00',2.84),('15844','2013-06-07','15:15:00',2.76),('15844','2013-06-07','15:20:00',2.6),('15844','2013-06-07','15:25:00',2.49),('15844','2013-06-07','15:30:00',2.39),('15844','2013-06-07','15:35:00',2.3),('15844','2013-06-07','15:40:00',2.23),('15844','2013-06-07','15:45:00',2.18),('15844','2013-06-07','15:50:00',2.07),('15844','2013-06-07','15:55:00',1.95),('15844','2013-06-07','16:00:00',1.84),('15844','2013-06-07','16:05:00',1.7),('15844','2013-06-07','16:10:00',1.68),('15844','2013-06-07','16:15:00',1.6),('15844','2013-06-07','16:20:00',1.51),('15844','2013-06-07','16:25:00',1.47),('15844','2013-06-07','16:30:00',1.44),('15844','2013-06-07','16:35:00',1.42),('15844','2013-06-07','16:40:00',1.31),('15844','2013-06-07','16:45:00',1.2),('15844','2013-06-07','16:50:00',1.1),('15844','2013-06-06','08:20:00',1.08),('15844','2013-06-06','08:25:00',1.16),('15844','2013-06-06','08:30:00',1.23),('15844','2013-06-06','08:35:00',1.31),('15844','2013-06-06','08:40:00',1.34),('15844','2013-06-06','08:45:00',1.37),('15844','2013-06-06','08:50:00',1.42),('15844','2013-06-06','08:55:00',1.56),('15844','2013-06-06','09:00:00',1.66),('15844','2013-06-06','09:05:00',1.78),('15844','2013-06-06','09:10:00',1.85),('15844','2013-06-06','09:15:00',1.94),('15844','2013-06-06','09:20:00',2.05),('15844','2013-06-06','09:25:00',2.18),('15844','2013-06-06','09:30:00',2.32),('15844','2013-06-06','09:35:00',2.21),('15844','2013-06-06','09:40:00',2.54),('15844','2013-06-06','09:45:00',2.69),('15844','2013-06-06','09:50:00',2.84),('15844','2013-06-06','09:55:00',2.92),('15844','2013-06-06','10:00:00',3.08),('15844','2013-06-06','10:05:00',3.2),('15844','2013-06-06','10:10:00',3.26),('15844','2013-06-06','10:15:00',3.26),('15844','2013-06-06','10:20:00',3.29),('15844','2013-06-06','10:25:00',3.65),('15844','2013-06-06','10:30:00',3.76),('15844','2013-06-06','10:35:00',3.78),('15844','2013-06-06','10:40:00',3.89),('15844','2013-06-06','10:45:00',4.01),('15844','2013-06-06','10:50:00',4.05),('15844','2013-06-06','10:55:00',4.05),('15844','2013-06-06','11:00:00',4.02),('15844','2013-06-06','11:05:00',4.22),('15844','2013-06-06','11:10:00',4.25),('15844','2013-06-06','11:15:00',4.27),('15844','2013-06-06','11:20:00',4.37),('15844','2013-06-06','11:25:00',4.39),('15844','2013-06-06','11:30:00',4.38),('15844','2013-06-06','11:35:00',4.41),('15844','2013-06-06','11:40:00',4.35),('15844','2013-06-06','11:45:00',4.22),('15844','2013-06-06','11:50:00',3.55),('15844','2013-06-06','11:55:00',4.41),('15844','2013-06-06','12:00:00',4.46),('15844','2013-06-06','12:05:00',3.32),('15844','2013-06-06','12:10:00',3.04),('15844','2013-06-06','12:15:00',4.45),('15844','2013-06-06','12:20:00',4.41),('15844','2013-06-06','12:25:00',4.42),('15844','2013-06-06','12:30:00',4.38),('15844','2013-06-06','12:35:00',4.35),('15844','2013-06-06','12:40:00',4.36),('15844','2013-06-06','12:45:00',4.03),('15844','2013-06-06','12:50:00',4.2),('15844','2013-06-06','12:55:00',4.06),('15844','2013-06-06','13:00:00',2.44),('15844','2013-06-06','13:05:00',1.66),('15844','2013-06-06','13:10:00',1.76),('15844','2013-06-06','13:15:00',1.19),('15844','2013-06-06','13:20:00',3.14),('15844','2013-06-06','13:25:00',1.44),('15844','2013-06-06','13:30:00',3.29),('15844','2013-06-06','13:35:00',2.03),('15844','2013-06-06','13:40:00',4.5),('15844','2013-06-06','13:45:00',4.24),('15844','2013-06-06','13:50:00',3.97),('15844','2013-06-06','13:55:00',3.92),('15844','2013-06-06','14:00:00',3.83),('15844','2013-06-06','14:05:00',3.87),('15844','2013-06-06','14:10:00',3.79),('15844','2013-06-06','14:15:00',3.75),('15844','2013-06-06','14:20:00',3.71),('15844','2013-06-06','14:25:00',3.68),('15844','2013-06-06','14:30:00',3.61),('15844','2013-06-06','14:35:00',3.46),('15844','2013-06-06','14:40:00',3.39),('15844','2013-06-06','14:45:00',3.33),('15844','2013-06-06','14:50:00',3.23),('15844','2013-06-06','14:55:00',3.16),('15844','2013-06-06','15:00:00',3.03),('15844','2013-06-06','15:05:00',2.9),('15844','2013-06-06','15:10:00',2.8),('15844','2013-06-06','15:15:00',2.68),('15844','2013-06-06','15:20:00',2.6),('15844','2013-06-06','15:25:00',2.47),('15844','2013-06-06','15:30:00',2.39),('15844','2013-06-06','15:35:00',2.27),('15844','2013-06-06','15:40:00',2.19),('15844','2013-06-06','15:45:00',2.1),('15844','2013-06-06','15:50:00',2.01),('15844','2013-06-06','15:55:00',1.93),('15844','2013-06-06','16:00:00',1.86),('15844','2013-06-06','16:05:00',1.76),('15844','2013-06-06','16:10:00',1.69),('15844','2013-06-06','16:15:00',1.6),('15844','2013-06-06','16:20:00',1.54),('15844','2013-06-06','16:25:00',1.48),('15844','2013-06-06','16:30:00',1.43),('15844','2013-06-06','16:35:00',1.39),('15844','2013-06-06','16:40:00',1.28),('15844','2013-06-06','16:45:00',1.18),('15844','2013-06-06','16:50:00',1.07),('15844','2013-06-05','08:20:00',1.03),('15844','2013-06-05','08:25:00',1.14),('15844','2013-06-05','08:30:00',1.23),('15844','2013-06-05','08:35:00',1.28),('15844','2013-06-05','08:40:00',1.34),('15844','2013-06-05','08:45:00',1.38),('15844','2013-06-05','08:50:00',1.46),('15844','2013-06-05','08:55:00',1.51),('15844','2013-06-05','09:00:00',1.81),('15844','2013-06-05','09:05:00',1.67),('15844','2013-06-05','09:10:00',1.08),('15844','2013-06-05','09:20:00',1.64),('15844','2013-06-05','09:25:00',2.05),('15844','2013-06-05','09:30:00',1.54),('15844','2013-06-05','09:35:00',2.15),('15844','2013-06-05','09:40:00',2.17),('15844','2013-06-05','09:45:00',2.02),('15844','2013-06-05','09:50:00',2.92),('15844','2013-06-05','09:55:00',2.07),('15844','2013-06-05','10:00:00',1.88),('15844','2013-06-05','10:05:00',2.38),('15844','2013-06-05','10:10:00',2.35),('15844','2013-06-05','10:20:00',1.48),('15844','2013-06-05','10:25:00',3.63),('15844','2013-06-05','10:30:00',4.41),('15844','2013-06-05','10:35:00',3.59),('15844','2013-06-05','10:40:00',2.1),('15844','2013-06-05','10:45:00',2.25),('15844','2013-06-05','10:50:00',1.65),('15844','2013-06-05','10:55:00',3.37),('15844','2013-06-05','11:00:00',4.02),('15844','2013-06-05','11:05:00',1.07),('15844','2013-06-05','11:10:00',1.11),('15844','2013-06-05','11:15:00',3.07),('15844','2013-06-05','11:20:00',2.77),('15844','2013-06-05','11:25:00',3.85),('15844','2013-06-05','11:30:00',3.38),('15844','2013-06-05','11:35:00',2.14),('15844','2013-06-05','11:40:00',1.94),('15844','2013-06-05','11:45:00',4.35),('15844','2013-06-05','11:50:00',4.91),('15844','2013-06-05','11:55:00',4.74),('15844','2013-06-05','12:00:00',4.99),('15844','2013-06-05','12:05:00',4.97),('15844','2013-06-05','12:10:00',2.75),('15844','2013-06-05','12:15:00',4.75),('15844','2013-06-05','12:20:00',3.12),('15844','2013-06-05','12:25:00',2.5),('15844','2013-06-05','12:30:00',4.54),('15844','2013-06-05','12:35:00',4.23),('15844','2013-06-05','12:40:00',1.28),('15844','2013-06-05','12:45:00',1.3),('15844','2013-06-05','12:50:00',1.66),('15844','2013-06-05','12:55:00',1.39),('15844','2013-06-05','13:00:00',4.3),('15844','2013-06-05','13:05:00',4.07),('15844','2013-06-05','13:10:00',3.88),('15844','2013-06-05','13:15:00',4.82),('15844','2013-06-05','13:20:00',3.89),('15844','2013-06-05','13:25:00',4.68),('15844','2013-06-05','13:30:00',4.49),('15844','2013-06-05','13:35:00',4.35),('15844','2013-06-05','13:40:00',3.62),('15844','2013-06-05','13:45:00',3.06),('15844','2013-06-05','13:50:00',4.27),('15844','2013-06-05','13:55:00',4.22),('15844','2013-06-05','14:00:00',3.74),('15844','2013-06-05','14:05:00',4.09),('15844','2013-06-05','14:10:00',3.98),('15844','2013-06-05','14:15:00',3.74),('15844','2013-06-05','14:20:00',3.94),('15844','2013-06-05','14:25:00',3.48),('15844','2013-06-05','14:30:00',3.74),('15844','2013-06-05','14:35:00',3.08),('15844','2013-06-05','14:40:00',3.56),('15844','2013-06-05','14:45:00',3.56),('15844','2013-06-05','14:50:00',3.31),('15844','2013-06-05','14:55:00',3.28),('15844','2013-06-05','15:00:00',3.19),('15844','2013-06-05','15:05:00',3.01),('15844','2013-06-05','15:10:00',2.78),('15844','2013-06-05','15:15:00',2.67),('15844','2013-06-05','15:20:00',2.29),('15844','2013-06-05','15:25:00',2.5),('15844','2013-06-05','15:30:00',2.11),('15844','2013-06-05','15:35:00',2.79),('15844','2013-06-05','15:40:00',2.09),('15844','2013-06-05','15:45:00',2.15),('15844','2013-06-05','15:50:00',2.26),('15844','2013-06-05','15:55:00',1.78),('15844','2013-06-05','16:00:00',1.8),('15844','2013-06-05','16:05:00',1.7),('15844','2013-06-05','16:10:00',1.4),('15844','2013-06-05','16:15:00',1.32),('15844','2013-06-05','16:20:00',1.58),('15844','2013-06-05','16:25:00',1.67),('15844','2013-06-05','16:30:00',1.27),('15844','2013-06-05','16:35:00',1.44),('15844','2013-06-05','16:45:00',1.35),('15844','2013-06-05','16:50:00',1.16),('15844','2013-06-05','17:00:00',1.13),('15844','2013-06-04','07:50:00',1.04),('15844','2013-06-04','07:55:00',1.19),('15844','2013-06-04','08:00:00',1.22),('15844','2013-06-04','08:05:00',1.31),('15844','2013-06-04','08:10:00',1.42),('15844','2013-06-04','08:15:00',1.47),('15844','2013-06-04','08:20:00',1.52),('15844','2013-06-04','08:25:00',1.6),('15844','2013-06-04','08:30:00',1.68),('15844','2013-06-04','08:35:00',1.37),('15844','2013-06-04','08:40:00',1.34),('15844','2013-06-04','08:45:00',1.28),('15844','2013-06-04','08:50:00',1.09),('15844','2013-06-04','08:55:00',1.31),('15844','2013-06-04','09:00:00',1.6),('15844','2013-06-04','09:05:00',1.47),('15844','2013-06-04','09:10:00',1.5),('15844','2013-06-04','09:15:00',1.86),('15844','2013-06-04','09:20:00',2.25),('15844','2013-06-04','09:25:00',1.93),('15844','2013-06-04','09:30:00',1.77),('15844','2013-06-04','09:35:00',2.61),('15844','2013-06-04','09:40:00',1.94),('15844','2013-06-04','09:45:00',2.04),('15844','2013-06-04','09:50:00',1.63),('15844','2013-06-04','09:55:00',1.29),('15844','2013-06-04','10:00:00',1.08),('15844','2013-06-04','10:05:00',1.18),('15844','2013-06-04','10:10:00',1.49),('15844','2013-06-04','10:15:00',2.05),('15844','2013-06-04','10:20:00',1.61),('15844','2013-06-04','10:25:00',1.48),('15844','2013-06-04','10:30:00',1.71),('15844','2013-06-04','10:35:00',1.86),('15844','2013-06-04','10:40:00',2.01),('15844','2013-06-04','10:45:00',2.16),('15844','2013-06-04','10:50:00',2.42),('15844','2013-06-04','10:55:00',2.5),('15844','2013-06-04','11:00:00',2.61),('15844','2013-06-04','11:05:00',3.15),('15844','2013-06-04','11:10:00',2.97),('15844','2013-06-04','11:15:00',2.25),('15844','2013-06-04','11:20:00',2.6),('15844','2013-06-04','11:25:00',3.12),('15844','2013-06-04','11:30:00',3.53),('15844','2013-06-04','11:35:00',3.14),('15844','2013-06-04','11:40:00',3.21),('15844','2013-06-04','11:45:00',3.94),('15844','2013-06-04','11:50:00',4.77),('15844','2013-06-04','11:55:00',4.39),('15844','2013-06-04','12:00:00',5.11),('15844','2013-06-04','12:05:00',2.67),('15844','2013-06-04','12:10:00',3.18),('15844','2013-06-04','12:15:00',2.51),('15844','2013-06-04','12:20:00',2.76),('15844','2013-06-04','12:25:00',2.47),('15844','2013-06-04','12:30:00',3.22),('15844','2013-06-04','12:35:00',1.93),('15844','2013-06-04','12:40:00',2),('15844','2013-06-04','12:45:00',1.96),('15844','2013-06-04','12:50:00',1.7),('15844','2013-06-04','12:55:00',3.24),('15844','2013-06-04','13:00:00',1.06),('15844','2013-06-04','13:05:00',1.13),('15844','2013-06-04','13:10:00',1.11),('15844','2013-06-04','13:15:00',1.71),('15844','2013-06-04','13:20:00',2.04),('15844','2013-06-04','13:25:00',5.24),('15844','2013-06-04','13:30:00',4.9),('15844','2013-06-04','13:35:00',4.21),('15844','2013-06-04','13:40:00',2.41),('15844','2013-06-04','13:45:00',1.93),('15844','2013-06-04','13:50:00',3.11),('15844','2013-06-04','13:55:00',3.88),('15844','2013-06-04','14:00:00',2.85),('15844','2013-06-04','14:05:00',3.03),('15844','2013-06-04','14:10:00',2.75),('15844','2013-06-04','14:15:00',1.53),('15844','2013-06-04','14:30:00',1.11),('15844','2013-06-04','14:35:00',1.81),('15844','2013-06-04','14:40:00',3.2),('15844','2013-06-04','14:45:00',3.67),('15844','2013-06-04','14:50:00',3.88),('15844','2013-06-04','14:55:00',2.95),('15844','2013-06-04','15:00:00',2.58),('15844','2013-06-04','15:05:00',2.56),('15844','2013-06-04','15:10:00',2.79),('15844','2013-06-04','15:15:00',2.87),('15844','2013-06-04','15:20:00',2.77),('15844','2013-06-04','15:25:00',1.97),('15844','2013-06-04','15:30:00',1.12),('15844','2013-06-03','08:20:00',1.06),('15844','2013-06-03','08:25:00',1.13),('15844','2013-06-03','08:30:00',1.24),('15844','2013-06-03','08:35:00',1.28),('15844','2013-06-03','08:40:00',1.35),('15844','2013-06-03','08:45:00',1.41),('15844','2013-06-03','08:50:00',1.52),('15844','2013-06-03','08:55:00',1.62),('15844','2013-06-03','09:00:00',1.74),('15844','2013-06-03','09:05:00',1.83),('15844','2013-06-03','09:10:00',1.97),('15844','2013-06-03','09:15:00',2.54),('15844','2013-06-03','09:20:00',2.58),('15844','2013-06-03','09:25:00',1.6),('15844','2013-06-03','09:30:00',1),('15844','2013-06-03','09:35:00',1.05),('15844','2013-06-03','09:40:00',1.35),('15844','2013-06-03','09:45:00',1.3),('15844','2013-06-03','09:50:00',1.4),('15844','2013-06-03','10:05:00',1.34),('15844','2013-06-03','10:10:00',1.27),('15844','2013-06-03','10:15:00',1.18),('15844','2013-06-03','10:20:00',1.1),('15844','2013-06-03','10:25:00',1.18),('15844','2013-06-03','10:30:00',1.23),('15844','2013-06-03','10:35:00',1.41),('15844','2013-06-03','10:40:00',1.78),('15844','2013-06-03','10:45:00',4.23),('15844','2013-06-03','10:50:00',5.37),('15844','2013-06-03','10:55:00',4.19),('15844','2013-06-03','11:00:00',3.24),('15844','2013-06-03','11:05:00',3.81),('15844','2013-06-03','11:10:00',3.98),('15844','2013-06-03','11:15:00',3.09),('15844','2013-06-03','11:20:00',4.15),('15844','2013-06-03','11:25:00',4.99),('15844','2013-06-03','11:30:00',3.64),('15844','2013-06-03','11:35:00',1.32),('15844','2013-06-03','11:40:00',3.31),('15844','2013-06-03','11:45:00',1.7),('15844','2013-06-03','11:50:00',2.64),('15844','2013-06-03','11:55:00',4.16),('15844','2013-06-03','12:00:00',1.8),('15844','2013-06-03','12:05:00',2.05),('15844','2013-06-03','12:10:00',3.8),('15844','2013-06-03','12:15:00',2.97),('15844','2013-06-03','12:20:00',1.12),('15844','2013-06-03','12:30:00',1),('15844','2013-06-03','12:35:00',1.2),('15844','2013-06-03','12:40:00',2.59),('15844','2013-06-03','12:45:00',1.02),('15844','2013-06-03','12:55:00',1.27),('15844','2013-06-03','13:00:00',2.06),('15844','2013-06-03','13:05:00',3.46),('15844','2013-06-03','13:10:00',5.13),('15844','2013-06-03','13:15:00',5.16),('15844','2013-06-03','13:20:00',2.68),('15844','2013-06-03','13:25:00',3.67),('15844','2013-06-03','13:30:00',1.77),('15844','2013-06-03','13:35:00',3.07),('15844','2013-06-03','13:40:00',4.78),('15844','2013-06-03','13:45:00',4.22),('15844','2013-06-03','13:50:00',4.29),('15844','2013-06-03','13:55:00',4.43),('15844','2013-06-03','14:00:00',3.99),('15844','2013-06-03','14:05:00',4.12),('15844','2013-06-03','14:10:00',1.77),('15844','2013-06-03','14:15:00',2.02),('15844','2013-06-03','14:20:00',3.14),('15844','2013-06-03','14:25:00',2.26),('15844','2013-06-03','14:30:00',2.83),('15844','2013-06-03','14:35:00',3.52),('15844','2013-06-03','14:40:00',3.47),('15844','2013-06-03','14:45:00',3.63),('15844','2013-06-03','14:50:00',3.58),('15844','2013-06-03','14:55:00',3.1),('15844','2013-06-03','15:00:00',3.42),('15844','2013-06-03','15:05:00',3.44),('15844','2013-06-03','15:10:00',2.4),('15844','2013-06-03','15:15:00',1.91),('15844','2013-06-03','15:20:00',2.82),('15844','2013-06-03','15:25:00',2.84),('15844','2013-06-03','15:30:00',2.01),('15844','2013-06-03','15:35:00',2.49),('15844','2013-06-03','15:40:00',2.4),('15844','2013-06-03','15:45:00',2.29),('15844','2013-06-03','15:50:00',2.2),('15844','2013-06-03','15:55:00',2.08),('15844','2013-06-03','16:00:00',1.96),('15844','2013-06-03','16:05:00',1.91),('15844','2013-06-03','16:10:00',1.87),('15844','2013-06-03','16:15:00',1.6),('15844','2013-06-03','16:20:00',1.51),('15844','2013-06-03','16:25:00',1.71),('15844','2013-06-03','16:30:00',1.7),('15844','2013-06-03','16:35:00',1.57),('15844','2013-06-03','16:40:00',1.51),('15844','2013-06-03','16:45:00',1.28),('15844','2013-06-03','16:50:00',1.29),('15844','2013-06-03','16:55:00',1.43),('15844','2013-06-03','17:00:00',1.51),('15844','2013-06-03','17:05:00',1.48),('15844','2013-06-03','17:10:00',1.39),('15844','2013-06-03','17:15:00',1.18),('15844','2013-06-03','17:20:00',1.05),('15844','2013-06-03','17:25:00',1.1),('15844','2013-06-03','17:30:00',1.01),('15844','2013-06-02','09:15:00',1.63),('15844','2013-06-02','09:20:00',2.06),('15844','2013-06-02','09:25:00',2.28),('15844','2013-06-02','09:30:00',2.42),('15844','2013-06-02','09:35:00',2.57),('15844','2013-06-02','09:40:00',2.71),('15844','2013-06-02','09:45:00',2.87),('15844','2013-06-02','09:50:00',2.98),('15844','2013-06-02','09:55:00',3.02),('15844','2013-06-02','10:00:00',3.09),('15844','2013-06-02','10:05:00',3.23),('15844','2013-06-02','10:10:00',3.36),('15844','2013-06-02','10:15:00',3.56),('15844','2013-06-02','10:20:00',3.87),('15844','2013-06-02','10:25:00',4.05),('15844','2013-06-02','10:30:00',3.77),('15844','2013-06-02','10:35:00',4.3),('15844','2013-06-02','10:40:00',1.68),('15844','2013-06-02','10:45:00',1.38),('15844','2013-06-02','10:50:00',1.38),('15844','2013-06-02','10:55:00',2.86),('15844','2013-06-02','11:00:00',2),('15844','2013-06-02','11:05:00',1.5),('15844','2013-06-02','11:10:00',2.33),('15844','2013-06-02','11:15:00',5.26),('15844','2013-06-02','11:20:00',1.94),('15844','2013-06-02','11:25:00',1.33),('15844','2013-06-02','11:30:00',3.05),('15844','2013-06-02','11:35:00',5.36),('15844','2013-06-02','11:40:00',1.55),('15844','2013-06-02','11:45:00',3.69),('15844','2013-06-02','11:50:00',3.19),('15844','2013-06-02','11:55:00',1.44),('15844','2013-06-02','12:00:00',3.88),('15844','2013-06-02','12:05:00',5.36),('15844','2013-06-02','12:10:00',3.87),('15844','2013-06-02','12:15:00',4.45),('15844','2013-06-02','12:20:00',4.88),('15844','2013-06-02','12:25:00',4.67),('15844','2013-06-02','12:30:00',4.64),('15844','2013-06-02','12:35:00',4.56),('15844','2013-06-02','12:40:00',4.69),('15844','2013-06-02','12:45:00',2.89),('15844','2013-06-02','12:50:00',3.24),('15844','2013-06-02','12:55:00',4.74),('15844','2013-06-02','13:00:00',4.6),('15844','2013-06-02','13:05:00',4.51),('15844','2013-06-02','13:10:00',4.42),('15844','2013-06-02','13:15:00',4.39),('15844','2013-06-02','13:20:00',4.37),('15844','2013-06-02','13:25:00',4.35),('15844','2013-06-02','13:30:00',4.31),('15844','2013-06-02','13:35:00',4.26),('15844','2013-06-02','13:40:00',4.21),('15844','2013-06-02','13:45:00',4.17),('15844','2013-06-02','13:50:00',4.14),('15844','2013-06-02','13:55:00',4.08),('15844','2013-06-02','14:00:00',4.05),('15844','2013-06-02','14:05:00',3.98),('15844','2013-06-02','14:10:00',3.97),('15844','2013-06-02','14:15:00',3.97),('15844','2013-06-02','14:20:00',3.88),('15844','2013-06-02','14:25:00',2.88),('15844','2013-06-02','14:30:00',3.58),('15844','2013-06-02','14:35:00',3.69),('15844','2013-06-02','14:40:00',3.56),('15844','2013-06-02','14:45:00',3.39),('15844','2013-06-02','14:50:00',3.38),('15844','2013-06-02','14:55:00',3.28),('15844','2013-06-02','15:00:00',3.18),('15844','2013-06-02','15:05:00',3.02),('15844','2013-06-02','15:10:00',2.95),('15844','2013-06-02','15:15:00',2.81),('15844','2013-06-02','15:20:00',2.43),('15844','2013-06-02','15:25:00',2.68),('15844','2013-06-02','15:30:00',2.38),('15844','2013-06-02','15:35:00',2.47),('15844','2013-06-02','15:40:00',2.39),('15844','2013-06-02','15:45:00',2.56),('15844','2013-06-02','15:50:00',2.24),('15844','2013-06-02','15:55:00',2.25),('15844','2013-06-02','16:00:00',2.1),('15844','2013-06-02','16:05:00',1.77),('15844','2013-06-02','16:10:00',2.26),('15844','2013-06-02','16:15:00',1.17),('15844','2013-06-02','16:20:00',1.88),('15844','2013-06-02','16:25:00',1.61),('15844','2013-06-02','16:30:00',1.5),('15844','2013-06-02','16:35:00',1.44),('15844','2013-06-02','16:40:00',1.41),('15844','2013-06-02','16:45:00',1.34),('15844','2013-06-02','16:50:00',1.26),('15844','2013-06-01','07:50:00',1.04),('15844','2013-06-01','08:30:00',1.05),('15844','2013-06-01','08:55:00',1.21),('15844','2013-06-01','09:40:00',1.01),('15844','2013-06-01','10:25:00',1.2),('15844','2013-06-01','10:30:00',1.28),('15844','2013-06-01','10:35:00',1.72),('15844','2013-06-01','10:40:00',1.64),('15844','2013-06-01','10:45:00',4.25),('15844','2013-06-01','10:50:00',3.75),('15844','2013-06-01','11:45:00',1.35),('15844','2013-06-01','11:50:00',2.97),('15844','2013-06-01','11:55:00',3.39),('15844','2013-06-01','12:00:00',1.85),('15844','2013-06-01','12:35:00',1.02),('15844','2013-06-01','12:40:00',1.76),('15844','2013-06-01','12:45:00',1.31),('15844','2013-06-01','12:50:00',1.31),('15844','2013-06-01','12:55:00',1.28),('15844','2013-06-01','13:00:00',1.08),('15844','2013-06-01','13:05:00',1.02),('15844','2013-06-01','13:10:00',1.56),('15844','2013-06-01','13:15:00',1.77),('15844','2013-06-01','13:20:00',1.67),('15844','2013-06-01','13:25:00',1.5),('15844','2013-06-01','13:30:00',1.17),('15844','2013-06-01','13:35:00',1.14),('15844','2013-06-01','13:40:00',1.08),('15844','2013-06-01','13:55:00',1.81),('15844','2013-06-01','14:00:00',2.66),('15844','2013-06-01','14:05:00',2.01),('15844','2013-06-01','14:10:00',1.94),('15844','2013-06-01','14:15:00',1.78),('15844','2013-06-01','14:20:00',1.49),('15844','2013-06-01','14:25:00',1.17),('15844','2013-06-01','14:30:00',1.05),('15844','2013-06-01','14:50:00',1.03),('15844','2013-06-01','15:40:00',1.5),('15844','2013-06-01','15:45:00',1.63),('15844','2013-06-01','15:50:00',1.5),('15844','2013-06-01','15:55:00',1.53),('15844','2013-06-01','16:00:00',1.18),('15844','2013-06-01','18:20:00',1.01),('15844','2014-04-02','09:30:00',1.69),('15844','2014-04-02','09:35:00',2.05),('15844','2014-04-02','09:40:00',2.49),('15844','2014-04-02','09:45:00',2.46),('15844','2014-04-02','09:50:00',2.47),('15844','2014-04-02','09:55:00',2.52),('15844','2014-04-02','10:00:00',1.35),('15844','2014-04-02','10:30:00',1.25),('15844','2014-04-02','10:35:00',2.76),('15844','2014-04-02','10:40:00',1.75),('15844','2014-04-02','10:45:00',3.51),('15844','2014-04-02','10:50:00',2.37),('15844','2014-04-02','10:55:00',1.74),('15844','2014-04-02','11:00:00',3.42),('15844','2014-04-02','11:05:00',3.11),('15844','2014-04-02','11:10:00',1.41),('15844','2014-04-02','11:15:00',1.24),('15844','2014-04-02','11:20:00',1.08),('15844','2014-04-02','11:25:00',3.13),('15844','2014-04-02','11:30:00',4.12),('15844','2014-04-02','11:35:00',2.56),('15844','2014-04-02','11:40:00',2.71),('15844','2014-04-02','11:45:00',3.29),('15844','2014-04-02','11:50:00',4.02),('15844','2014-04-02','11:55:00',3.94),('15844','2014-04-02','12:00:00',3.13),('15844','2014-04-02','12:05:00',2.55),('15844','2014-04-02','12:10:00',3.68),('15844','2014-04-02','12:15:00',1.51),('15844','2014-04-02','12:20:00',1.57),('15844','2014-04-02','12:25:00',3.28),('15844','2014-04-02','12:30:00',4.28),('15844','2014-04-02','12:35:00',4.13),('15844','2014-04-02','12:40:00',3.95),('15844','2014-04-02','12:45:00',3.39),('15844','2014-04-02','12:50:00',1.67),('15844','2014-04-02','12:55:00',4.12),('15844','2014-04-02','13:00:00',3.14),('15844','2014-04-02','13:05:00',2.8),('15844','2014-04-02','13:10:00',1.87),('15844','2014-04-02','13:15:00',2.89),('15844','2014-04-02','13:20:00',2.98),('15844','2014-04-02','13:25:00',2.66),('15844','2014-04-02','13:30:00',3.02),('15844','2014-04-02','13:35:00',2.56),('15844','2014-04-02','13:40:00',1.88),('15844','2014-04-02','13:45:00',3.75),('15844','2014-04-02','13:50:00',3.62),('15844','2014-04-02','13:55:00',2.79),('15844','2014-04-02','14:00:00',3.76),('15844','2014-04-02','14:05:00',3.36),('15844','2014-04-02','14:10:00',3.39),('15844','2014-04-02','14:15:00',3.38),('15844','2014-04-02','14:20:00',3.21),('15844','2014-04-02','14:25:00',3.12),('15844','2014-04-02','14:30:00',3.02),('15844','2014-04-02','14:35:00',2.87),('15844','2014-04-02','14:40:00',2.76),('15844','2014-04-02','14:45:00',2.64),('15844','2014-04-02','14:50:00',2.27),('15844','2014-04-02','14:55:00',2.27),('15844','2014-04-02','15:00:00',2.31),('15844','2014-04-02','15:05:00',2.12),('15844','2014-04-02','15:10:00',2.01),('15844','2014-04-02','15:15:00',1.97),('15844','2014-04-02','15:20:00',1.91),('15844','2014-04-02','15:25:00',1.82),('15844','2014-04-02','15:30:00',1.66),('15844','2014-04-02','15:35:00',1.56),('15844','2014-04-02','15:40:00',1.54),('15844','2014-04-02','15:45:00',1.47),('15844','2014-04-02','15:50:00',1.35),('15844','2014-04-02','15:55:00',1.16),('15844','2014-04-02','16:00:00',1.17),('15844','2014-04-02','16:05:00',1.08),('15844','2014-04-02','16:10:00',1.02),('15844','2013-05-31','08:20:00',1.08),('15844','2013-05-31','08:25:00',1.2),('15844','2013-05-31','08:30:00',1.32),('15844','2013-05-31','08:35:00',1.7),('15844','2013-05-31','08:40:00',1.08),('15844','2013-05-31','08:45:00',1.48),('15844','2013-05-31','08:50:00',1.02),('15844','2013-05-31','08:55:00',1.49),('15844','2013-05-31','09:00:00',1.26),('15844','2013-05-31','09:05:00',1.66),('15844','2013-05-31','09:10:00',1.01),('15844','2013-05-31','09:20:00',1.71),('15844','2013-05-31','09:30:00',1.64),('15844','2013-05-31','09:35:00',2.95),('15844','2013-05-31','09:40:00',2.47),('15844','2013-05-31','09:45:00',2.98),('15844','2013-05-31','09:50:00',2.59),('15844','2013-05-31','09:55:00',1.95),('15844','2013-05-31','10:00:00',3.49),('15844','2013-05-31','10:05:00',2.44),('15844','2013-05-31','10:10:00',4.38),('15844','2013-05-31','10:15:00',1.44),('15844','2013-05-31','10:20:00',1.39),('15844','2013-05-31','10:25:00',3.1),('15844','2013-05-31','10:30:00',3.89),('15844','2013-05-31','10:35:00',3.16),('15844','2013-05-31','10:40:00',4.49),('15844','2013-05-31','10:45:00',2.49),('15844','2013-05-31','10:50:00',1.44),('15844','2013-05-31','10:55:00',1.75),('15844','2013-05-31','11:00:00',3.05),('15844','2013-05-31','11:05:00',3.58),('15844','2013-05-31','11:10:00',1.62),('15844','2013-05-31','11:15:00',2.4),('15844','2013-05-31','11:30:00',1.08),('15844','2013-05-31','11:35:00',2.19),('15844','2013-05-31','11:40:00',3.68),('15844','2013-05-31','11:45:00',5.65),('15844','2013-05-31','11:50:00',3.21),('15844','2013-05-31','11:55:00',4.95),('15844','2013-05-31','12:00:00',4.01),('15844','2013-05-31','12:05:00',4.67),('15844','2013-05-31','12:10:00',1.85),('15844','2013-05-31','12:15:00',1.83),('15844','2013-05-31','12:20:00',3.54),('15844','2013-05-31','12:25:00',2.07),('15844','2013-05-31','12:30:00',1.54),('15844','2013-05-31','12:35:00',2.54),('15844','2013-05-31','12:40:00',2.64),('15844','2013-05-31','12:50:00',2.22),('15844','2013-05-31','12:55:00',4.46),('15844','2013-05-31','13:00:00',1.87),('15844','2013-05-31','13:15:00',1.39),('15844','2013-05-31','13:20:00',2.21),('15844','2013-05-31','13:25:00',2.02),('15844','2013-05-31','13:30:00',2.06),('15844','2013-05-31','13:35:00',1.18),('15844','2013-05-31','13:40:00',2.37),('15844','2013-05-31','13:45:00',2.4),('15844','2013-05-31','13:50:00',1.85),('15844','2013-05-31','13:55:00',1.63),('15844','2013-05-31','14:25:00',1.13),('15844','2013-05-31','14:30:00',1.09),('15844','2013-05-31','14:55:00',1.31),('15844','2013-05-31','15:00:00',1.18),('15844','2013-05-31','15:05:00',1.3),('15844','2013-05-31','15:10:00',2.1),('15844','2013-05-31','15:15:00',2.36),('15844','2013-05-31','15:20:00',2.47),('15844','2013-05-31','15:25:00',1.61),('15844','2013-05-31','15:30:00',1.61),('15844','2013-05-31','15:35:00',1.48),('15844','2013-05-31','15:40:00',1.33),('15844','2013-05-31','15:45:00',2.11),('15844','2013-05-31','15:50:00',2.04),('15844','2013-05-31','15:55:00',1.38),('15844','2013-05-31','16:00:00',1.16),('15844','2013-05-31','16:20:00',1.2),('15844','2013-05-31','16:25:00',1.11),('15844','2013-05-31','16:40:00',1.07),('15844','2013-05-30','08:35:00',1.33),('15844','2013-05-30','08:40:00',1.36),('15844','2013-05-30','08:45:00',1.44),('15844','2013-05-30','08:50:00',1.53),('15844','2013-05-30','08:55:00',1.71),('15844','2013-05-30','09:00:00',1.85),('15844','2013-05-30','09:05:00',1.86),('15844','2013-05-30','09:10:00',2.01),('15844','2013-05-30','09:15:00',2.11),('15844','2013-05-30','09:20:00',2.22),('15844','2013-05-30','09:25:00',2.46),('15844','2013-05-30','09:30:00',2.29),('15844','2013-05-30','09:35:00',1.44),('15844','2013-05-30','09:40:00',1.58),('15844','2013-05-30','09:45:00',1.39),('15844','2013-05-30','09:50:00',1.29),('15844','2013-05-30','10:00:00',2.42),('15844','2013-05-30','10:05:00',2.36),('15844','2013-05-30','10:10:00',3.05),('15844','2013-05-30','10:15:00',2.87),('15844','2013-05-30','10:25:00',1.54),('15844','2013-05-30','10:30:00',1.49),('15844','2013-05-30','10:35:00',4),('15844','2013-05-30','10:40:00',4),('15844','2013-05-30','10:45:00',2.86),('15844','2013-05-30','10:50:00',3.67),('15844','2013-05-30','10:55:00',2.52),('15844','2013-05-30','11:00:00',2.46),('15844','2013-05-30','11:05:00',4.11),('15844','2013-05-30','11:10:00',3.56),('15844','2013-05-30','11:15:00',4.93),('15844','2013-05-30','11:20:00',1.14),('15844','2013-05-30','11:25:00',4.51),('15844','2013-05-30','11:30:00',5.19),('15844','2013-05-30','11:35:00',2.96),('15844','2013-05-30','11:40:00',3.52),('15844','2013-05-30','11:45:00',5.11),('15844','2013-05-30','11:50:00',4.64),('15844','2013-05-30','11:55:00',4.61),('15844','2013-05-30','12:00:00',4.54),('15844','2013-05-30','12:05:00',1.95),('15844','2013-05-30','12:10:00',1.13),('15844','2013-05-30','12:15:00',4.39),('15844','2013-05-30','12:20:00',3.35),('15844','2013-05-30','12:25:00',3.44),('15844','2013-05-30','12:30:00',4.82),('15844','2013-05-30','12:35:00',3.09),('15844','2013-05-30','12:40:00',4.73),('15844','2013-05-30','12:45:00',4.38),('15844','2013-05-30','12:50:00',5.21),('15844','2013-05-30','12:55:00',3.64),('15844','2013-05-30','13:00:00',3.23),('15844','2013-05-30','13:05:00',3.71),('15844','2013-05-30','13:10:00',3.16),('15844','2013-05-30','13:15:00',3.89),('15844','2013-05-30','13:20:00',1.22),('15844','2013-05-30','13:25:00',1.81),('15844','2013-05-30','13:30:00',1.73),('15844','2013-05-30','13:35:00',2.98),('15844','2013-05-30','13:40:00',1.92),('15844','2013-05-30','13:45:00',1.31),('15844','2013-05-30','13:50:00',3.26),('15844','2013-05-30','13:55:00',4.02),('15844','2013-05-30','14:00:00',1.67),('15844','2013-05-30','14:05:00',2.7),('15844','2013-05-30','14:10:00',4.41),('15844','2013-05-30','14:15:00',3.58),('15844','2013-05-30','14:20:00',4.34),('15844','2013-05-30','14:25:00',4.42),('15844','2013-05-30','14:30:00',3.15),('15844','2013-05-30','14:35:00',2.75),('15844','2013-05-30','14:40:00',2.6),('15844','2013-05-30','14:45:00',2.27),('15844','2013-05-30','14:50:00',1.99),('15844','2013-05-30','14:55:00',3.02),('15844','2013-05-30','15:00:00',3.77),('15844','2013-05-30','15:05:00',2.52),('15844','2013-05-30','15:10:00',2.92),('15844','2013-05-30','15:15:00',2.82),('15844','2013-05-30','15:20:00',3.14),('15844','2013-05-30','15:25:00',2.56),('15844','2013-05-30','15:30:00',2.92),('15844','2013-05-30','15:35:00',2.74),('15844','2013-05-30','15:40:00',1.74),('15844','2013-05-30','15:45:00',1.78),('15844','2013-05-30','15:50:00',2.66),('15844','2013-05-30','15:55:00',2.15),('15844','2013-05-30','16:00:00',2.19),('15844','2013-05-30','16:05:00',1.95),('15844','2013-05-30','16:10:00',1.77),('15844','2013-05-30','16:15:00',1.47),('15844','2013-05-30','16:35:00',1.02),('15844','2013-05-30','16:45:00',1.56),('15844','2013-05-30','16:55:00',1.04),('15844','2013-05-30','17:00:00',1.12),('15844','2013-05-29','08:20:00',1.05),('15844','2013-05-29','08:25:00',1.17),('15844','2013-05-29','08:30:00',1.25),('15844','2013-05-29','08:35:00',1.29),('15844','2013-05-29','08:40:00',1.32),('15844','2013-05-29','08:45:00',1.36),('15844','2013-05-29','08:50:00',1.5),('15844','2013-05-29','08:55:00',1.68),('15844','2013-05-29','09:00:00',1.77),('15844','2013-05-29','09:05:00',1.82),('15844','2013-05-29','09:10:00',1.85),('15844','2013-05-29','09:15:00',1.95),('15844','2013-05-29','09:20:00',2.05),('15844','2013-05-29','09:25:00',2.26),('15844','2013-05-29','09:30:00',2.49),('15844','2013-05-29','09:35:00',2.59),('15844','2013-05-29','09:40:00',2.7),('15844','2013-05-29','09:45:00',2.83),('15844','2013-05-29','09:50:00',2.93),('15844','2013-05-29','09:55:00',3.08),('15844','2013-05-29','10:00:00',3.17),('15844','2013-05-29','10:05:00',3.24),('15844','2013-05-29','10:10:00',3.33),('15844','2013-05-29','10:15:00',3.44),('15844','2013-05-29','10:20:00',3.77),('15844','2013-05-29','10:25:00',3.92),('15844','2013-05-29','10:30:00',4.03),('15844','2013-05-29','10:35:00',4.13),('15844','2013-05-29','10:40:00',4.18),('15844','2013-05-29','10:45:00',4.36),('15844','2013-05-29','10:50:00',4.53),('15844','2013-05-29','10:55:00',4.62),('15844','2013-05-29','11:00:00',4.45),('15844','2013-05-29','11:05:00',4.38),('15844','2013-05-29','11:10:00',3.01),('15844','2013-05-29','11:15:00',4.54),('15844','2013-05-29','11:20:00',1.81),('15844','2013-05-29','11:25:00',2.42),('15844','2013-05-29','11:30:00',3.17),('15844','2013-05-29','11:35:00',3.82),('15844','2013-05-29','11:40:00',4.55),('15844','2013-05-29','11:45:00',4.15),('15844','2013-05-29','11:50:00',4.7),('15844','2013-05-29','11:55:00',4.65),('15844','2013-05-29','12:00:00',3.43),('15844','2013-05-29','12:05:00',4.79),('15844','2013-05-29','12:10:00',4.77),('15844','2013-05-29','12:15:00',4.8),('15844','2013-05-29','12:20:00',4.68),('15844','2013-05-29','12:25:00',4.72),('15844','2013-05-29','12:30:00',4.59),('15844','2013-05-29','12:35:00',4.65),('15844','2013-05-29','12:40:00',4.45),('15844','2013-05-29','12:45:00',4.64),('15844','2013-05-29','12:50:00',4.6),('15844','2013-05-29','12:55:00',4.59),('15844','2013-05-29','13:00:00',4.35),('15844','2013-05-29','13:05:00',4.58),('15844','2013-05-29','13:10:00',4.52),('15844','2013-05-29','13:15:00',3.84),('15844','2013-05-29','13:20:00',4.49),('15844','2013-05-29','13:25:00',3.89),('15844','2013-05-29','13:30:00',2.95),('15844','2013-05-29','13:35:00',2.27),('15844','2013-05-29','13:40:00',2.08),('15844','2013-05-29','13:45:00',2.36),('15844','2013-05-29','13:50:00',4.52),('15844','2013-05-29','13:55:00',4.6),('15844','2013-05-29','14:00:00',4.43),('15844','2013-05-29','14:05:00',3.7),('15844','2013-05-29','14:10:00',3.51),('15844','2013-05-29','14:15:00',3.94),('15844','2013-05-29','14:20:00',3.18),('15844','2013-05-29','14:25:00',2.47),('15844','2013-05-29','14:30:00',2.85),('15844','2013-05-29','14:35:00',3.14),('15844','2013-05-29','14:40:00',2.89),('15844','2013-05-29','14:45:00',2.95),('15844','2013-05-29','14:50:00',2.9),('15844','2013-05-29','14:55:00',3.41),('15844','2013-05-29','15:00:00',1.97),('15844','2013-05-29','15:05:00',2.72),('15844','2013-05-29','15:10:00',1.85),('15844','2013-05-29','15:15:00',1.74),('15844','2013-05-29','15:20:00',1.58),('15844','2013-05-29','15:25:00',1.98),('15844','2013-05-29','15:30:00',2.19),('15844','2013-05-29','15:35:00',2.11),('15844','2013-05-29','15:40:00',1.98),('15844','2013-05-29','15:45:00',2.38),('15844','2013-05-29','15:50:00',2.23),('15844','2013-05-29','15:55:00',1.7),('15844','2013-05-29','16:00:00',1.89),('15844','2013-05-29','16:05:00',1.95),('15844','2013-05-29','16:10:00',1.8),('15844','2013-05-29','16:15:00',1.75),('15844','2013-05-29','16:20:00',1.78),('15844','2013-05-29','16:25:00',1.8),('15844','2013-05-29','16:30:00',1.87),('15844','2013-05-29','16:35:00',1.83),('15844','2013-05-29','16:40:00',1.55),('15844','2013-05-29','16:45:00',1.52),('15844','2013-05-29','16:50:00',1.34),('15844','2013-05-29','16:55:00',1.09),('15844','2013-05-29','17:35:00',1.16),('15844','2013-05-29','17:40:00',1.02),('15844','2013-05-28','08:15:00',1.14),('15844','2013-05-28','08:20:00',1.08),('15844','2013-05-28','08:25:00',1.09),('15844','2013-05-28','08:30:00',1.36),('15844','2013-05-28','08:35:00',1.32),('15844','2013-05-28','08:40:00',1.2),('15844','2013-05-28','08:45:00',1.26),('15844','2013-05-28','08:50:00',1.28),('15844','2013-05-28','08:55:00',1.22),('15844','2013-05-28','09:00:00',1.32),('15844','2013-05-28','09:05:00',1.53),('15844','2013-05-28','09:10:00',1.58),('15844','2013-05-28','09:15:00',1.63),('15844','2013-05-28','09:20:00',1.65),('15844','2013-05-28','09:25:00',1.75),('15844','2013-05-28','09:30:00',1.87),('15844','2013-05-28','09:35:00',2.17),('15844','2013-05-28','09:40:00',1.98),('15844','2013-05-28','09:45:00',2.02),('15844','2013-05-28','09:50:00',2.03),('15844','2013-05-28','09:55:00',2.01),('15844','2013-05-28','10:00:00',1.85),('15844','2013-05-28','10:05:00',2),('15844','2013-05-28','10:10:00',2.3),('15844','2013-05-28','10:15:00',2.38),('15844','2013-05-28','10:20:00',2.33),('15844','2013-05-28','10:25:00',2.34),('15844','2013-05-28','10:30:00',2.78),('15844','2013-05-28','10:35:00',2.93),('15844','2013-05-28','10:40:00',2.92),('15844','2013-05-28','10:45:00',2.5),('15844','2013-05-28','10:50:00',2.28),('15844','2013-05-28','10:55:00',2.58),('15844','2013-05-28','11:00:00',2.54),('15844','2013-05-28','11:05:00',2.77),('15844','2013-05-28','11:10:00',3.15),('15844','2013-05-28','11:15:00',2.63),('15844','2013-05-28','11:20:00',1.61),('15844','2013-05-28','11:25:00',3.57),('15844','2013-05-28','11:30:00',4.48),('15844','2013-05-28','11:35:00',4.12),('15844','2013-05-28','11:40:00',4.43),('15844','2013-05-28','11:45:00',1.91),('15844','2013-05-28','11:50:00',1),('15844','2013-05-28','12:00:00',1.76),('15844','2013-05-28','12:05:00',1.82),('15844','2013-05-28','12:10:00',2.12),('15844','2013-05-28','12:15:00',2.12),('15844','2013-05-28','12:20:00',2),('15844','2013-05-28','12:25:00',2.41),('15844','2013-05-28','12:30:00',2.76),('15844','2013-05-28','12:35:00',2.15),('15844','2013-05-28','12:40:00',2.23),('15844','2013-05-28','12:45:00',2.12),('15844','2013-05-28','12:50:00',2.16),('15844','2013-05-28','12:55:00',2.41),('15844','2013-05-28','13:00:00',2.49),('15844','2013-05-28','13:05:00',2.62),('15844','2013-05-28','13:10:00',2.32),('15844','2013-05-28','13:15:00',1.73),('15844','2013-05-28','13:20:00',2.13),('15844','2013-05-28','13:25:00',2.55),('15844','2013-05-28','13:30:00',3.16),('15844','2013-05-28','13:35:00',2.99),('15844','2013-05-28','13:40:00',2.15),('15844','2013-05-28','13:45:00',1.95),('15844','2013-05-28','13:50:00',1.63),('15844','2013-05-28','13:55:00',1.55),('15844','2013-05-28','14:00:00',1.72),('15844','2013-05-28','14:05:00',2.06),('15844','2013-05-28','14:10:00',2.13),('15844','2013-05-28','14:15:00',2.41),('15844','2013-05-28','14:20:00',2.95),('15844','2013-05-28','14:25:00',2.11),('15844','2013-05-28','14:30:00',2.99),('15844','2013-05-28','14:35:00',2.58),('15844','2013-05-28','14:40:00',2.22),('15844','2013-05-28','14:45:00',2.53),('15844','2013-05-28','14:50:00',2.82),('15844','2013-05-28','14:55:00',2.84),('15844','2013-05-28','15:00:00',2.5),('15844','2013-05-28','15:05:00',1.58),('15844','2013-05-28','15:10:00',1.47),('15844','2013-05-28','15:15:00',2.08),('15844','2013-05-28','15:20:00',2.02),('15844','2013-05-28','15:25:00',1.46),('15844','2013-05-28','15:30:00',1.44),('15844','2013-05-28','15:35:00',1.44),('15844','2013-05-28','15:40:00',1.7),('15844','2013-05-28','15:45:00',2.04),('15844','2013-05-28','15:50:00',1.61),('15844','2013-05-28','15:55:00',1.88),('15844','2013-05-28','16:00:00',1.52),('15844','2013-05-28','16:05:00',1.25),('15844','2013-05-28','16:10:00',1.42),('15844','2013-05-28','16:15:00',1.68),('15844','2013-05-28','16:20:00',1.7),('15844','2013-05-28','16:25:00',1.41),('15844','2013-05-28','16:30:00',1.05),('15844','2013-05-28','16:35:00',1.45),('15844','2013-05-28','16:40:00',1.33),('15844','2013-05-28','16:45:00',1.17),('15844','2013-05-27','08:05:00',1.19),('15844','2013-05-27','08:15:00',1.02),('15844','2013-05-27','08:20:00',1.06),('15844','2013-05-27','08:25:00',1.13),('15844','2013-05-27','08:30:00',1.27),('15844','2013-05-27','08:35:00',1.13),('15844','2013-05-27','08:40:00',1.23),('15844','2013-05-27','08:45:00',1.02),('15844','2013-05-27','08:50:00',1.22),('15844','2013-05-27','08:55:00',2.27),('15844','2013-05-27','09:00:00',1.49),('15844','2013-05-27','09:10:00',1.65),('15844','2013-05-27','09:15:00',1.23),('15844','2013-05-27','09:20:00',2.01),('15844','2013-05-27','09:25:00',2.51),('15844','2013-05-27','09:30:00',2.58),('15844','2013-05-27','09:35:00',2.66),('15844','2013-05-27','09:40:00',2.84),('15844','2013-05-27','09:45:00',3.13),('15844','2013-05-27','09:50:00',1.75),('15844','2013-05-27','09:55:00',3.2),('15844','2013-05-27','10:00:00',3.3),('15844','2013-05-27','10:05:00',3.43),('15844','2013-05-27','10:10:00',3.54),('15844','2013-05-27','10:15:00',3.73),('15844','2013-05-27','10:20:00',4.09),('15844','2013-05-27','10:25:00',2.98),('15844','2013-05-27','10:30:00',3.33),('15844','2013-05-27','10:35:00',4.15),('15844','2013-05-27','10:40:00',3.48),('15844','2013-05-27','10:45:00',3.38),('15844','2013-05-27','10:50:00',3.75),('15844','2013-05-27','10:55:00',5.16),('15844','2013-05-27','11:00:00',1.75),('15844','2013-05-27','11:05:00',3.79),('15844','2013-05-27','11:10:00',3.18),('15844','2013-05-27','11:15:00',1.56),('15844','2013-05-27','11:20:00',4.22),('15844','2013-05-27','11:25:00',3.88),('15844','2013-05-27','11:30:00',5.09),('15844','2013-05-27','11:35:00',2.37),('15844','2013-05-27','11:40:00',3.61),('15844','2013-05-27','11:45:00',4.84),('15844','2013-05-27','11:50:00',3.98),('15844','2013-05-27','11:55:00',4.59),('15844','2013-05-27','12:00:00',3.55),('15844','2013-05-27','12:05:00',4.43),('15844','2013-05-27','12:10:00',3.22),('15844','2013-05-27','12:15:00',5.21),('15844','2013-05-27','12:20:00',5.04),('15844','2013-05-27','12:25:00',4.99),('15844','2013-05-27','12:30:00',2.84),('15844','2013-05-27','12:35:00',4.84),('15844','2013-05-27','12:40:00',4.81),('15844','2013-05-27','12:45:00',4.76),('15844','2013-05-27','12:50:00',3.98),('15844','2013-05-27','12:55:00',1.38),('15844','2013-05-27','13:00:00',4.52),('15844','2013-05-27','13:05:00',3.19),('15844','2013-05-27','13:10:00',2.95),('15844','2013-05-27','13:15:00',4.06),('15844','2013-05-27','13:20:00',4.29),('15844','2013-05-27','13:25:00',4.34),('15844','2013-05-27','13:30:00',4.27),('15844','2013-05-27','13:35:00',4.03),('15844','2013-05-27','13:40:00',4.42),('15844','2013-05-27','13:45:00',4.3),('15844','2013-05-27','13:50:00',4.2),('15844','2013-05-27','13:55:00',4.05),('15844','2013-05-27','14:00:00',3.97),('15844','2013-05-27','14:05:00',3.98),('15844','2013-05-27','14:10:00',3.92),('15844','2013-05-27','14:15:00',3.81),('15844','2013-05-27','14:20:00',3.8),('15844','2013-05-27','14:25:00',3.77),('15844','2013-05-27','14:30:00',3.74),('15844','2013-05-27','14:35:00',3.7),('15844','2013-05-27','14:40:00',3.65),('15844','2013-05-27','14:45:00',3.52),('15844','2013-05-27','14:50:00',3.4),('15844','2013-05-27','14:55:00',2.81),('15844','2013-05-27','15:00:00',1.69),('15844','2013-05-27','15:05:00',2.2),('15844','2013-05-27','15:10:00',2.86),('15844','2013-05-27','15:15:00',2.28),('15844','2013-05-27','15:20:00',2.23),('15844','2013-05-27','15:25:00',2.3),('15844','2013-05-27','15:30:00',2.56),('15844','2013-05-27','15:35:00',2.61),('15844','2013-05-27','15:40:00',1.97),('15844','2013-05-27','15:45:00',2.4),('15844','2013-05-27','15:50:00',2.25),('15844','2013-05-27','15:55:00',1.54),('15844','2013-05-27','16:00:00',1.84),('15844','2013-05-27','16:05:00',1.64),('15844','2013-05-27','16:10:00',1.4),('15844','2013-05-27','16:15:00',1.67),('15844','2013-05-27','16:20:00',2.1),('15844','2013-05-27','16:25:00',1.69),('15844','2013-05-27','16:30:00',1.62),('15844','2013-05-27','16:35:00',1.2),('15844','2013-05-27','16:50:00',1.04),('15844','2013-05-27','16:55:00',1.08),('15844','2013-05-27','17:00:00',1.09),('15844','2013-05-27','17:05:00',1.16),('15844','2013-05-27','17:10:00',1.23),('15844','2013-05-27','17:15:00',1.06),('15844','2013-05-26','07:45:00',1.03),('15844','2013-05-26','08:00:00',1.17),('15844','2013-05-26','08:15:00',1.41),('15844','2013-05-26','08:20:00',1.21),('15844','2013-05-26','08:25:00',1.12),('15844','2013-05-26','08:30:00',1.02),('15844','2013-05-26','08:35:00',1.33),('15844','2013-05-26','08:40:00',1.25),('15844','2013-05-26','08:45:00',1.18),('15844','2013-05-26','08:50:00',1.26),('15844','2013-05-26','08:55:00',1.86),('15844','2013-05-26','09:05:00',1.02),('15844','2013-05-26','09:10:00',1.92),('15844','2013-05-26','09:25:00',1.73),('15844','2013-05-26','09:40:00',1.91),('15844','2013-05-26','09:50:00',1.22),('15844','2013-05-26','09:55:00',1.12),('15844','2013-05-26','10:00:00',3.55),('15844','2013-05-26','10:05:00',3.92),('15844','2013-05-26','10:10:00',3.16),('15844','2013-05-26','10:15:00',2.65),('15844','2013-05-26','10:20:00',4.14),('15844','2013-05-26','10:25:00',3.45),('15844','2013-05-26','10:30:00',2.66),('15844','2013-05-26','10:35:00',4.15),('15844','2013-05-26','10:40:00',4.41),('15844','2013-05-26','10:45:00',4.09),('15844','2013-05-26','10:50:00',4.48),('15844','2013-05-26','10:55:00',4.71),('15844','2013-05-26','11:00:00',4.68),('15844','2013-05-26','11:05:00',4.7),('15844','2013-05-26','11:10:00',4.71),('15844','2013-05-26','11:15:00',4.74),('15844','2013-05-26','11:20:00',4.76),('15844','2013-05-26','11:25:00',4.4),('15844','2013-05-26','11:30:00',4.81),('15844','2013-05-26','11:35:00',4.82),('15844','2013-05-26','11:40:00',4.81),('15844','2013-05-26','11:45:00',4.82),('15844','2013-05-26','11:50:00',4.79),('15844','2013-05-26','11:55:00',4.57),('15844','2013-05-26','12:00:00',4.86),('15844','2013-05-26','12:05:00',4.85),('15844','2013-05-26','12:10:00',4.88),('15844','2013-05-26','12:15:00',4.83),('15844','2013-05-26','12:20:00',4.93),('15844','2013-05-26','12:25:00',4.19),('15844','2013-05-26','12:30:00',4.07),('15844','2013-05-26','12:35:00',4.26),('15844','2013-05-26','12:40:00',3.57),('15844','2013-05-26','12:45:00',4.52),('15844','2013-05-26','12:50:00',4.8),('15844','2013-05-26','12:55:00',4.6),('15844','2013-05-26','13:00:00',4.37),('15844','2013-05-26','13:05:00',3.66),('15844','2013-05-26','13:10:00',4.68),('15844','2013-05-26','13:15:00',4.59),('15844','2013-05-26','13:20:00',4.52),('15844','2013-05-26','13:25:00',4.51),('15844','2013-05-26','13:30:00',4.44),('15844','2013-05-26','13:35:00',4.4),('15844','2013-05-26','13:40:00',4.37),('15844','2013-05-26','13:45:00',4.4),('15844','2013-05-26','13:50:00',4.27),('15844','2013-05-26','13:55:00',4.2),('15844','2013-05-26','14:00:00',4.13),('15844','2013-05-26','14:05:00',4.07),('15844','2013-05-26','14:10:00',3.99),('15844','2013-05-26','14:15:00',3.93),('15844','2013-05-26','14:20:00',3.87),('15844','2013-05-26','14:25:00',3.81),('15844','2013-05-26','14:30:00',3.72),('15844','2013-05-26','14:35:00',3.69),('15844','2013-05-26','14:40:00',3.62),('15844','2013-05-26','14:45:00',3.51),('15844','2013-05-26','14:50:00',3.41),('15844','2013-05-26','14:55:00',3.32),('15844','2013-05-26','15:00:00',3.2),('15844','2013-05-26','15:05:00',3.09),('15844','2013-05-26','15:10:00',2.97),('15844','2013-05-26','15:15:00',2.83),('15844','2013-05-26','15:20:00',2.68),('15844','2013-05-26','15:25:00',2.58),('15844','2013-05-26','15:30:00',2.49),('15844','2013-05-26','15:35:00',2.39),('15844','2013-05-26','15:40:00',2.31),('15844','2013-05-26','15:45:00',2.2),('15844','2013-05-26','15:50:00',2.08),('15844','2013-05-26','15:55:00',1.95),('15844','2013-05-26','16:00:00',1.84),('15844','2013-05-26','16:05:00',1.74),('15844','2013-05-26','16:10:00',1.65),('15844','2013-05-26','16:15:00',1.6),('15844','2013-05-26','16:20:00',1.55),('15844','2013-05-26','16:25:00',1.51),('15844','2013-05-26','16:30:00',1.45),('15844','2013-05-26','16:35:00',1.39),('15844','2013-05-26','16:40:00',1.3),('15844','2013-05-26','16:45:00',1.17),('15844','2013-05-25','07:55:00',1.11),('15844','2013-05-25','08:20:00',1.66),('15844','2013-05-25','08:25:00',1.3),('15844','2013-05-25','08:35:00',1.82),('15844','2013-05-25','08:40:00',1.44),('15844','2013-05-25','08:45:00',1.44),('15844','2013-05-25','08:50:00',1.78),('15844','2013-05-25','08:55:00',2.06),('15844','2013-05-25','09:00:00',2.12),('15844','2013-05-25','09:05:00',2.01),('15844','2013-05-25','09:10:00',1.22),('15844','2013-05-25','09:15:00',1.01),('15844','2013-05-25','09:20:00',1.28),('15844','2013-05-25','09:25:00',1.85),('15844','2013-05-25','09:30:00',1.39),('15844','2013-05-25','09:35:00',2.31),('15844','2013-05-25','09:40:00',2.08),('15844','2013-05-25','09:45:00',2.92),('15844','2013-05-25','09:50:00',1.83),('15844','2013-05-25','10:05:00',1.18),('15844','2013-05-25','10:35:00',1.02),('15844','2013-05-25','11:00:00',2.54),('15844','2013-05-25','11:05:00',4.52),('15844','2013-05-25','11:10:00',2.74),('15844','2013-05-25','11:15:00',2.25),('15844','2013-05-25','11:30:00',2.02),('15844','2013-05-25','11:35:00',1.79),('15844','2013-05-25','11:40:00',1.96),('15844','2013-05-25','11:45:00',1.54),('15844','2013-05-25','11:50:00',2.13),('15844','2013-05-25','11:55:00',1.41),('15844','2013-05-25','12:00:00',1.64),('15844','2013-05-25','12:05:00',1.45),('15844','2013-05-25','12:10:00',1.03),('15844','2013-05-25','12:15:00',2.35),('15844','2013-05-25','12:20:00',2.8),('15844','2013-05-25','12:25:00',1.85),('15844','2013-05-25','12:30:00',3.26),('15844','2013-05-25','12:50:00',1.32),('15844','2013-05-25','12:55:00',2.02),('15844','2013-05-25','13:00:00',2.3),('15844','2013-05-25','13:05:00',1.33),('15844','2013-05-25','13:10:00',2.45),('15844','2013-05-25','13:15:00',1.84),('15844','2013-05-25','13:20:00',1.93),('15844','2013-05-25','13:25:00',2.56),('15844','2013-05-25','13:30:00',1.62),('15844','2013-05-25','13:35:00',1.83),('15844','2013-05-25','13:40:00',2.54),('15844','2013-05-25','13:45:00',2.07),('15844','2013-05-25','13:50:00',3.87),('15844','2013-05-25','13:55:00',3.14),('15844','2013-05-25','14:00:00',2.74),('15844','2013-05-25','14:05:00',3.52),('15844','2013-05-25','14:10:00',3.61),('15844','2013-05-25','14:15:00',2.95),('15844','2013-05-25','14:20:00',2.65),('15844','2013-05-25','14:25:00',2.13),('15844','2013-05-25','14:30:00',3.98),('15844','2013-05-25','14:35:00',3.24),('15844','2013-05-25','14:40:00',1.76),('15844','2013-05-25','14:45:00',2.63),('15844','2013-05-25','14:50:00',3.01),('15844','2013-05-25','14:55:00',2.07),('15844','2013-05-25','15:00:00',2.15),('15844','2013-05-25','15:05:00',2.9),('15844','2013-05-25','15:10:00',2.36),('15844','2013-05-25','15:15:00',2.14),('15844','2013-05-25','15:20:00',2.8),('15844','2013-05-25','15:25:00',1.85),('15844','2013-05-25','15:30:00',2.42),('15844','2013-05-25','15:35:00',1.87),('15844','2013-05-25','15:40:00',1.21),('15844','2013-05-25','15:45:00',1.08),('15844','2013-05-25','15:50:00',2.01),('15844','2013-05-25','15:55:00',1.59),('15844','2013-05-25','16:00:00',2.42),('15844','2013-05-25','16:05:00',1.86),('15844','2013-05-25','16:10:00',1.28),('15844','2013-05-25','16:15:00',1.34),('15844','2013-05-25','16:20:00',1.57),('15844','2013-05-25','16:25:00',1.43),('15844','2013-05-25','16:30:00',1.63),('15844','2013-05-25','16:35:00',1.09),('15844','2013-05-25','16:45:00',1.38),('15844','2013-05-25','16:50:00',1.53),('15844','2013-05-25','16:55:00',1.19),('15844','2013-05-24','08:05:00',1.1),('15844','2013-05-24','08:25:00',1.28),('15844','2013-05-24','08:30:00',1.35),('15844','2013-05-24','08:35:00',1.37),('15844','2013-05-24','08:40:00',1.43),('15844','2013-05-24','08:45:00',1.53),('15844','2013-05-24','08:50:00',1.72),('15844','2013-05-24','08:55:00',1.8),('15844','2013-05-24','09:00:00',2.11),('15844','2013-05-24','09:25:00',1.92),('15844','2013-05-24','09:35:00',1.15),('15844','2013-05-24','09:45:00',1.07),('15844','2013-05-24','09:50:00',1.68),('15844','2013-05-24','09:55:00',3.4),('15844','2013-05-24','10:00:00',1.08),('15844','2013-05-24','10:20:00',1.36),('15844','2013-05-24','10:25:00',2.71),('15844','2013-05-24','10:30:00',4.32),('15844','2013-05-24','10:35:00',4.49),('15844','2013-05-24','10:40:00',4.56),('15844','2013-05-24','10:45:00',4.55),('15844','2013-05-24','10:50:00',2.49),('15844','2013-05-24','10:55:00',3.77),('15844','2013-05-24','11:00:00',4.51),('15844','2013-05-24','11:05:00',3.92),('15844','2013-05-24','11:10:00',3.83),('15844','2013-05-24','11:15:00',2.5),('15844','2013-05-24','11:20:00',4.11),('15844','2013-05-24','11:25:00',4.84),('15844','2013-05-24','11:30:00',3.56),('15844','2013-05-24','11:35:00',1),('15844','2013-05-24','11:40:00',1.02),('15844','2013-05-24','11:45:00',1.9),('15844','2013-05-24','11:50:00',1.98),('15844','2013-05-24','11:55:00',4.03),('15844','2013-05-24','12:00:00',5.62),('15844','2013-05-24','12:05:00',3.1),('15844','2013-05-24','12:10:00',1.7),('15844','2013-05-24','12:15:00',2.6),('15844','2013-05-24','12:20:00',3.8),('15844','2013-05-24','12:25:00',2.75),('15844','2013-05-24','12:30:00',2.06),('15844','2013-05-24','12:35:00',2.5),('15844','2013-05-24','12:40:00',1.75),('15844','2013-05-24','12:45:00',1.95),('15844','2013-05-24','12:50:00',1.83),('15844','2013-05-24','12:55:00',2.78),('15844','2013-05-24','13:00:00',4.19),('15844','2013-05-24','13:05:00',5.19),('15844','2013-05-24','13:10:00',3.78),('15844','2013-05-24','13:15:00',2.91),('15844','2013-05-24','13:20:00',4.78),('15844','2013-05-24','13:25:00',5.49),('15844','2013-05-24','13:30:00',5.27),('15844','2013-05-24','13:35:00',3.95),('15844','2013-05-24','13:40:00',1.34),('15844','2013-05-24','13:45:00',1.07),('15844','2013-05-24','13:50:00',3.51),('15844','2013-05-24','13:55:00',4.61),('15844','2013-05-24','14:00:00',3.24),('15844','2013-05-24','14:05:00',1.43),('15844','2013-05-24','14:10:00',3.05),('15844','2013-05-24','14:15:00',2.24),('15844','2013-05-24','14:20:00',3.26),('15844','2013-05-24','14:25:00',2.23),('15844','2013-05-24','14:30:00',3.69),('15844','2013-05-24','14:35:00',3.03),('15844','2013-05-24','14:40:00',2.58),('15844','2013-05-24','14:45:00',1.57),('15844','2013-05-24','14:50:00',3.02),('15844','2013-05-24','14:55:00',3.85),('15844','2013-05-24','15:00:00',3.59),('15844','2013-05-24','15:05:00',4.13),('15844','2013-05-24','15:10:00',3.18),('15844','2013-05-24','15:15:00',3.29),('15844','2013-05-24','15:20:00',3.16),('15844','2013-05-24','15:25:00',3.03),('15844','2013-05-24','15:30:00',2.53),('15844','2013-05-24','15:35:00',1.98),('15844','2013-05-24','15:40:00',2.09),('15844','2013-05-24','15:45:00',2.08),('15844','2013-05-24','15:50:00',1.66),('15844','2013-05-24','15:55:00',1.68),('15844','2013-05-24','16:00:00',1.56),('15844','2013-05-24','16:05:00',1.53),('15844','2013-05-24','16:10:00',1.41),('15844','2013-05-24','16:15:00',1.14),('15844','2013-05-24','16:20:00',1.35),('15844','2013-05-24','16:25:00',1.27),('15844','2013-05-24','16:45:00',1.16),('15844','2013-05-24','16:50:00',1.31),('15844','2013-05-24','16:55:00',1.06),('15844','2013-05-24','17:00:00',1.06),('15844','2013-05-23','08:25:00',1.35),('15844','2013-05-23','08:30:00',1.45),('15844','2013-05-23','08:35:00',1.74),('15844','2013-05-23','08:40:00',1.36),('15844','2013-05-23','09:15:00',2.24),('15844','2013-05-23','09:20:00',2),('15844','2013-05-23','09:40:00',1.97),('15844','2013-05-23','09:45:00',1.63),('15844','2013-05-23','09:50:00',1.85),('15844','2013-05-23','09:55:00',3.37),('15844','2013-05-23','10:00:00',2.26),('15844','2013-05-23','10:05:00',2.74),('15844','2013-05-23','10:10:00',3.75),('15844','2013-05-23','10:15:00',2.28),('15844','2013-05-23','10:20:00',3.52),('15844','2013-05-23','10:25:00',1.15),('15844','2013-05-23','10:30:00',1.51),('15844','2013-05-23','10:35:00',3.37),('15844','2013-05-23','10:40:00',2.82),('15844','2013-05-23','10:45:00',1.67),('15844','2013-05-23','10:50:00',2.36),('15844','2013-05-23','10:55:00',4.22),('15844','2013-05-23','11:00:00',2.45),('15844','2013-05-23','11:05:00',3.35),('15844','2013-05-23','11:10:00',1.21),('15844','2013-05-23','11:15:00',1.8),('15844','2013-05-23','11:20:00',1.76),('15844','2013-05-23','11:25:00',1.61),('15844','2013-05-23','11:30:00',2.72),('15844','2013-05-23','11:35:00',3.84),('15844','2013-05-23','11:40:00',3.99),('15844','2013-05-23','11:45:00',1.05),('15844','2013-05-23','11:50:00',2.59),('15844','2013-05-23','11:55:00',5.07),('15844','2013-05-23','12:00:00',3),('15844','2013-05-23','12:05:00',4.54),('15844','2013-05-23','12:10:00',3.35),('15844','2013-05-23','12:15:00',2.06),('15844','2013-05-23','12:20:00',1.87),('15844','2013-05-23','12:25:00',1.37),('15844','2013-05-23','12:35:00',2.85),('15844','2013-05-23','12:40:00',3.33),('15844','2013-05-23','12:45:00',3.13),('15844','2013-05-23','12:50:00',2.63),('15844','2013-05-23','12:55:00',3.11),('15844','2013-05-23','13:00:00',4.85),('15844','2013-05-23','13:05:00',4.66),('15844','2013-05-23','13:10:00',3.3),('15844','2013-05-23','13:15:00',3.93),('15844','2013-05-23','13:20:00',2.97),('15844','2013-05-23','13:25:00',4.78),('15844','2013-05-23','13:30:00',2.99),('15844','2013-05-23','13:35:00',3.6),('15844','2013-05-23','13:40:00',3.97),('15844','2013-05-23','13:45:00',3.58),('15844','2013-05-23','13:50:00',4.19),('15844','2013-05-23','13:55:00',3.8),('15844','2013-05-23','14:00:00',3.83),('15844','2013-05-23','14:05:00',2.54),('15844','2013-05-23','14:10:00',4.1),('15844','2013-05-23','14:15:00',2.93),('15844','2013-05-23','14:20:00',1.48),('15844','2013-05-23','14:25:00',2.11),('15844','2013-05-23','14:30:00',2.8),('15844','2013-05-23','14:35:00',2.89),('15844','2013-05-23','14:45:00',2.64),('15844','2013-05-23','14:50:00',2.2),('15844','2013-05-23','14:55:00',3.38),('15844','2013-05-23','15:00:00',2.75),('15844','2013-05-23','15:10:00',3.17),('15844','2013-05-23','15:15:00',2.3),('15844','2013-05-23','15:20:00',2.52),('15844','2013-05-23','15:25:00',2.07),('15844','2013-05-23','15:30:00',2.34),('15844','2013-05-23','15:35:00',2.99),('15844','2013-05-23','15:40:00',1.6),('15844','2013-05-23','15:45:00',1.2),('15844','2013-05-23','15:50:00',2.6),('15844','2013-05-23','15:55:00',1.87),('15844','2013-05-23','16:00:00',2.41),('15844','2013-05-23','16:05:00',2.05),('15844','2013-05-23','16:10:00',1.31),('15844','2013-05-23','16:15:00',1.86),('15844','2013-05-23','16:20:00',1.48),('15844','2013-05-23','16:30:00',1.16),('15844','2013-05-23','16:40:00',1.13),('15844','2013-05-23','17:00:00',1.41),('15844','2013-05-23','17:05:00',1.24),('15844','2013-05-23','17:55:00',1.09),('15844','2013-05-22','08:05:00',1.04),('15844','2013-05-22','08:10:00',1.17),('15844','2013-05-22','08:25:00',1.33),('15844','2013-05-22','08:30:00',1.82),('15844','2013-05-22','08:35:00',1.16),('15844','2013-05-22','09:20:00',1.4),('15844','2013-05-22','09:25:00',2.21),('15844','2013-05-22','09:30:00',2.5),('15844','2013-05-22','09:35:00',2.45),('15844','2013-05-22','09:40:00',2.6),('15844','2013-05-22','09:45:00',2.71),('15844','2013-05-22','09:50:00',2.79),('15844','2013-05-22','09:55:00',2.9),('15844','2013-05-22','10:00:00',3.04),('15844','2013-05-22','10:05:00',3.23),('15844','2013-05-22','10:10:00',3.33),('15844','2013-05-22','10:15:00',3.43),('15844','2013-05-22','10:20:00',3.59),('15844','2013-05-22','10:25:00',3.29),('15844','2013-05-22','10:30:00',3.66),('15844','2013-05-22','10:35:00',3.76),('15844','2013-05-22','10:40:00',3.79),('15844','2013-05-22','10:45:00',4.19),('15844','2013-05-22','10:50:00',4.02),('15844','2013-05-22','10:55:00',4.04),('15844','2013-05-22','11:00:00',4.1),('15844','2013-05-22','11:05:00',4.15),('15844','2013-05-22','11:10:00',4.16),('15844','2013-05-22','11:15:00',4.1),('15844','2013-05-22','11:20:00',4.21),('15844','2013-05-22','11:25:00',3.9),('15844','2013-05-22','11:30:00',3.02),('15844','2013-05-22','11:35:00',4.19),('15844','2013-05-22','11:40:00',3.66),('15844','2013-05-22','11:45:00',4.33),('15844','2013-05-22','11:50:00',4.09),('15844','2013-05-22','11:55:00',2.5),('15844','2013-05-22','12:00:00',1.95),('15844','2013-05-22','12:05:00',2.36),('15844','2013-05-22','12:10:00',2.3),('15844','2013-05-22','12:15:00',2.77),('15844','2013-05-22','12:20:00',4.87),('15844','2013-05-22','12:25:00',3.74),('15844','2013-05-22','12:30:00',1.97),('15844','2013-05-22','12:35:00',1.4),('15844','2013-05-22','12:40:00',1.16),('15844','2013-05-22','13:05:00',1.52),('15844','2013-05-22','13:10:00',1.9),('15844','2013-05-22','13:15:00',3.15),('15844','2013-05-22','13:20:00',2.23),('15844','2013-05-22','13:30:00',1.59),('15844','2013-05-22','13:35:00',1.56),('15844','2013-05-22','13:40:00',1.62),('15844','2013-05-22','13:45:00',2.98),('15844','2013-05-22','13:50:00',3.73),('15844','2013-05-22','13:55:00',3.2),('15844','2013-05-22','14:00:00',3.02),('15844','2013-05-22','14:05:00',3.23),('15844','2013-05-22','14:10:00',3.77),('15844','2013-05-22','14:15:00',3.6),('15844','2013-05-22','14:20:00',3.49),('15844','2013-05-22','14:25:00',3.39),('15844','2013-05-22','14:30:00',3.33),('15844','2013-05-22','14:35:00',3.26),('15844','2013-05-22','14:40:00',3.2),('15844','2013-05-22','14:45:00',3.11),('15844','2013-05-22','14:50:00',3.01),('15844','2013-05-22','14:55:00',2.92),('15844','2013-05-22','15:00:00',2.85),('15844','2013-05-22','15:05:00',2.74),('15844','2013-05-22','15:10:00',2.66),('15844','2013-05-22','15:15:00',2.62),('15844','2013-05-22','15:20:00',2.53),('15844','2013-05-22','15:25:00',2.63),('15844','2013-05-22','15:30:00',2.75),('15844','2013-05-22','15:35:00',2.62),('15844','2013-05-22','15:40:00',2.54),('15844','2013-05-22','15:45:00',2.2),('15844','2013-05-22','15:50:00',2.03),('15844','2013-05-22','15:55:00',1.83),('15844','2013-05-22','16:00:00',1.72),('15844','2013-05-22','16:05:00',1.63),('15844','2013-05-22','16:10:00',1.57),('15844','2013-05-22','16:15:00',1.33),('15844','2013-05-22','16:20:00',1.41),('15844','2013-05-22','16:25:00',1),('15844','2013-05-22','16:40:00',1.15),('15844','2013-05-22','16:45:00',1.13),('15844','2013-05-22','17:35:00',1.01),('15844','2014-04-01','08:45:00',1),('15844','2014-04-01','08:50:00',1.1),('15844','2014-04-01','08:55:00',1.21),('15844','2014-04-01','09:00:00',1.31),('15844','2014-04-01','09:05:00',1.4),('15844','2014-04-01','09:10:00',1.49),('15844','2014-04-01','09:15:00',1.62),('15844','2014-04-01','09:20:00',1.72),('15844','2014-04-01','09:25:00',1.83),('15844','2014-04-01','09:30:00',1.95),('15844','2014-04-01','09:35:00',2.03),('15844','2014-04-01','09:40:00',2.12),('15844','2014-04-01','09:45:00',2.18),('15844','2014-04-01','09:50:00',2.16),('15844','2014-04-01','09:55:00',1.53),('15844','2014-04-01','10:00:00',2.54),('15844','2014-04-01','10:05:00',2.55),('15844','2014-04-01','10:10:00',2.65),('15844','2014-04-01','10:15:00',2.77),('15844','2014-04-01','10:20:00',2.83),('15844','2014-04-01','10:25:00',2.91),('15844','2014-04-01','10:30:00',2.91),('15844','2014-04-01','10:35:00',3.04),('15844','2014-04-01','10:40:00',3.17),('15844','2014-04-01','10:45:00',3.38),('15844','2014-04-01','10:50:00',3.41),('15844','2014-04-01','10:55:00',3.42),('15844','2014-04-01','11:00:00',3.59),('15844','2014-04-01','11:05:00',3.62),('15844','2014-04-01','11:10:00',3.66),('15844','2014-04-01','11:15:00',3.68),('15844','2014-04-01','11:20:00',3.73),('15844','2014-04-01','11:25:00',3.8),('15844','2014-04-01','11:30:00',3.73),('15844','2014-04-01','11:35:00',3.79),('15844','2014-04-01','11:40:00',3.79),('15844','2014-04-01','11:45:00',3.89),('15844','2014-04-01','11:50:00',3.89),('15844','2014-04-01','11:55:00',3.88),('15844','2014-04-01','12:00:00',3.91),('15844','2014-04-01','12:05:00',3.9),('15844','2014-04-01','12:10:00',3.86),('15844','2014-04-01','12:15:00',3.9),('15844','2014-04-01','12:20:00',3.89),('15844','2014-04-01','12:25:00',3.9),('15844','2014-04-01','12:30:00',3.92),('15844','2014-04-01','12:35:00',3.91),('15844','2014-04-01','12:40:00',3.8),('15844','2014-04-01','12:45:00',4.05),('15844','2014-04-01','12:50:00',3.93),('15844','2014-04-01','12:55:00',3.94),('15844','2014-04-01','13:00:00',3.6),('15844','2014-04-01','13:05:00',3.6),('15844','2014-04-01','13:10:00',3.65),('15844','2014-04-01','13:15:00',3.55),('15844','2014-04-01','13:20:00',3.72),('15844','2014-04-01','13:25:00',3.68),('15844','2014-04-01','13:30:00',3.4),('15844','2014-04-01','13:35:00',3.77),('15844','2014-04-01','13:40:00',3.62),('15844','2014-04-01','13:45:00',2.3),('15844','2014-04-01','13:50:00',2.76),('15844','2014-04-01','13:55:00',3.29),('15844','2014-04-01','14:00:00',3.47),('15844','2014-04-01','14:05:00',3.01),('15844','2014-04-01','14:10:00',3.36),('15844','2014-04-01','14:15:00',2.8),('15844','2014-04-01','14:20:00',3.34),('15844','2014-04-01','14:25:00',2.72),('15844','2014-04-01','14:30:00',2.01),('15844','2014-04-01','14:35:00',2.31),('15844','2014-04-01','14:40:00',2.77),('15844','2014-04-01','14:45:00',2.38),('15844','2014-04-01','14:50:00',2.27),('15844','2014-04-01','14:55:00',2.5),('15844','2014-04-01','15:00:00',2.46),('15844','2014-04-01','15:05:00',2.43),('15844','2014-04-01','15:10:00',1.86),('15844','2014-04-01','15:15:00',2.13),('15844','2014-04-01','15:20:00',1.88),('15844','2014-04-01','15:25:00',1.66),('15844','2014-04-01','15:30:00',1.88),('15844','2014-04-01','15:35:00',1.28),('15844','2014-04-01','15:40:00',1.19),('15844','2014-04-01','15:45:00',1.44),('15844','2014-04-01','15:50:00',1.43),('15844','2014-04-01','15:55:00',1.22),('15844','2014-04-01','16:00:00',1.18),('15844','2014-04-01','16:05:00',1.25),('15844','2014-04-01','16:10:00',1.16),('15844','2014-04-01','16:15:00',1.04),('15844','2014-04-01','16:20:00',1.09),('15844','2014-04-01','16:25:00',1.04),('15844','2013-05-21','08:10:00',1.33),('15844','2013-05-21','08:15:00',1.19),('15844','2013-05-21','08:20:00',1.41),('15844','2013-05-21','08:25:00',1.28),('15844','2013-05-21','08:30:00',1.06),('15844','2013-05-21','08:35:00',1.28),('15844','2013-05-21','08:40:00',1.31),('15844','2013-05-21','08:45:00',1.07),('15844','2013-05-21','08:50:00',1.21),('15844','2013-05-21','08:55:00',1.29),('15844','2013-05-21','09:00:00',1.17),('15844','2013-05-21','09:05:00',1.18),('15844','2013-05-21','09:10:00',1.47),('15844','2013-05-21','09:15:00',1.53),('15844','2013-05-21','09:20:00',1.89),('15844','2013-05-21','09:25:00',2),('15844','2013-05-21','09:30:00',1.65),('15844','2013-05-21','09:35:00',1.64),('15844','2013-05-21','09:40:00',1.57),('15844','2013-05-21','09:45:00',1.49),('15844','2013-05-21','09:50:00',1.64),('15844','2013-05-21','09:55:00',1.64),('15844','2013-05-21','10:00:00',1.75),('15844','2013-05-21','10:05:00',1.98),('15844','2013-05-21','10:10:00',1.87),('15844','2013-05-21','10:15:00',1.63),('15844','2013-05-21','10:20:00',1.67),('15844','2013-05-21','10:25:00',2.04),('15844','2013-05-21','10:30:00',1.53),('15844','2013-05-21','10:35:00',1.86),('15844','2013-05-21','10:40:00',2.71),('15844','2013-05-21','10:45:00',2.96),('15844','2013-05-21','10:50:00',2.2),('15844','2013-05-21','10:55:00',1.74),('15844','2013-05-21','11:00:00',1.49),('15844','2013-05-21','11:05:00',1.83),('15844','2013-05-21','11:10:00',2.84),('15844','2013-05-21','11:15:00',3.92),('15844','2013-05-21','11:20:00',4.46),('15844','2013-05-21','11:25:00',3.91),('15844','2013-05-21','11:30:00',3.2),('15844','2013-05-21','11:35:00',2),('15844','2013-05-21','11:40:00',2.05),('15844','2013-05-21','11:45:00',3.06),('15844','2013-05-21','11:50:00',2.44),('15844','2013-05-21','11:55:00',2.56),('15844','2013-05-21','12:00:00',2.88),('15844','2013-05-21','12:05:00',3.6),('15844','2013-05-21','12:10:00',2.98),('15844','2013-05-21','12:15:00',2.61),('15844','2013-05-21','12:20:00',2.31),('15844','2013-05-21','12:25:00',2.62),('15844','2013-05-21','12:30:00',2.76),('15844','2013-05-21','12:35:00',2.81),('15844','2013-05-21','12:40:00',3.4),('15844','2013-05-21','12:45:00',3.27),('15844','2013-05-21','12:50:00',2.84),('15844','2013-05-21','12:55:00',3.17),('15844','2013-05-21','13:00:00',3.59),('15844','2013-05-21','13:05:00',3.15),('15844','2013-05-21','13:10:00',2.61),('15844','2013-05-21','13:15:00',3.55),('15844','2013-05-21','13:20:00',3.42),('15844','2013-05-21','13:25:00',2.29),('15844','2013-05-21','13:30:00',1.65),('15844','2013-05-21','13:35:00',1.08),('15844','2013-05-21','14:10:00',1.36),('15844','2013-05-21','14:15:00',1.53),('15844','2013-05-21','14:20:00',1.57),('15844','2013-05-21','14:25:00',2.1),('15844','2013-05-21','14:30:00',1.73),('15844','2013-05-21','14:35:00',1.84),('15844','2013-05-21','14:40:00',1.77),('15844','2013-05-21','14:45:00',1.16),('15844','2013-05-21','15:15:00',1.27),('15844','2013-05-21','15:20:00',1.5),('15844','2013-05-21','15:25:00',1.95),('15844','2013-05-21','15:30:00',1.96),('15844','2013-05-21','15:35:00',2.29),('15844','2013-05-21','15:40:00',2.48),('15844','2013-05-21','15:45:00',1.54),('15844','2013-05-21','16:05:00',1.03),('15844','2013-05-21','16:10:00',1.02),('15844','2013-05-21','16:25:00',1),('15844','2013-05-21','16:30:00',1.35),('15844','2013-05-21','16:35:00',1.42),('15844','2013-05-21','16:40:00',1.26),('15844','2013-05-20','08:15:00',1.1),('15844','2013-05-20','08:20:00',1.15),('15844','2013-05-20','08:25:00',1.39),('15844','2013-05-20','08:35:00',1.4),('15844','2013-05-20','08:40:00',1.83),('15844','2013-05-20','08:55:00',1.57),('15844','2013-05-20','09:00:00',1.05),('15844','2013-05-20','09:05:00',1.08),('15844','2013-05-20','09:10:00',1.21),('15844','2013-05-20','09:15:00',2.13),('15844','2013-05-20','09:20:00',2.26),('15844','2013-05-20','09:25:00',2.43),('15844','2013-05-20','09:30:00',1.92),('15844','2013-05-20','09:40:00',1.04),('15844','2013-05-20','09:45:00',3.19),('15844','2013-05-20','09:50:00',2.08),('15844','2013-05-20','10:00:00',1.6),('15844','2013-05-20','10:05:00',3.6),('15844','2013-05-20','10:10:00',3.74),('15844','2013-05-20','10:15:00',4.06),('15844','2013-05-20','10:20:00',4.3),('15844','2013-05-20','10:25:00',3.68),('15844','2013-05-20','10:30:00',2.49),('15844','2013-05-20','10:35:00',3.61),('15844','2013-05-20','10:40:00',4.15),('15844','2013-05-20','10:45:00',3.9),('15844','2013-05-20','10:50:00',4.07),('15844','2013-05-20','10:55:00',4.62),('15844','2013-05-20','11:00:00',3.86),('15844','2013-05-20','11:05:00',3.28),('15844','2013-05-20','11:10:00',3.47),('15844','2013-05-20','11:15:00',1.51),('15844','2013-05-20','11:20:00',3.33),('15844','2013-05-20','11:25:00',4.51),('15844','2013-05-20','11:30:00',2.88),('15844','2013-05-20','11:35:00',1.94),('15844','2013-05-20','11:40:00',2.98),('15844','2013-05-20','11:45:00',3.42),('15844','2013-05-20','11:50:00',4.99),('15844','2013-05-20','11:55:00',4.87),('15844','2013-05-20','12:00:00',4.88),('15844','2013-05-20','12:05:00',4.77),('15844','2013-05-20','12:10:00',4.34),('15844','2013-05-20','12:15:00',4.79),('15844','2013-05-20','12:20:00',4.77),('15844','2013-05-20','12:25:00',4.68),('15844','2013-05-20','12:30:00',4.8),('15844','2013-05-20','12:35:00',4.74),('15844','2013-05-20','12:40:00',4.71),('15844','2013-05-20','12:45:00',4.6),('15844','2013-05-20','12:50:00',4.61),('15844','2013-05-20','12:55:00',4.67),('15844','2013-05-20','13:00:00',4.63),('15844','2013-05-20','13:05:00',4.65),('15844','2013-05-20','13:10:00',4.58),('15844','2013-05-20','13:15:00',4.5),('15844','2013-05-20','13:20:00',4.48),('15844','2013-05-20','13:25:00',4.36),('15844','2013-05-20','13:30:00',4.35),('15844','2013-05-20','13:35:00',4.32),('15844','2013-05-20','13:40:00',4.29),('15844','2013-05-20','13:45:00',4.25),('15844','2013-05-20','13:50:00',4.15),('15844','2013-05-20','13:55:00',4.08),('15844','2013-05-20','14:00:00',3.97),('15844','2013-05-20','14:05:00',3.91),('15844','2013-05-20','14:10:00',3.84),('15844','2013-05-20','14:15:00',3.77),('15844','2013-05-20','14:20:00',3.7),('15844','2013-05-20','14:25:00',3.6),('15844','2013-05-20','14:30:00',3.5),('15844','2013-05-20','14:35:00',3.45),('15844','2013-05-20','14:40:00',3.35),('15844','2013-05-20','14:45:00',3.27),('15844','2013-05-20','14:50:00',3.17),('15844','2013-05-20','14:55:00',3.08),('15844','2013-05-20','15:00:00',3),('15844','2013-05-20','15:05:00',2.98),('15844','2013-05-20','15:10:00',3.01),('15844','2013-05-20','15:15:00',2.85),('15844','2013-05-20','15:20:00',2.66),('15844','2013-05-20','15:25:00',2.6),('15844','2013-05-20','15:30:00',2.48),('15844','2013-05-20','15:35:00',2.36),('15844','2013-05-20','15:40:00',2.22),('15844','2013-05-20','15:45:00',2.13),('15844','2013-05-20','15:50:00',2.09),('15844','2013-05-20','15:55:00',1.93),('15844','2013-05-20','16:00:00',1.76),('15844','2013-05-20','16:05:00',1.66),('15844','2013-05-20','16:10:00',1.56),('15844','2013-05-20','16:15:00',1.51),('15844','2013-05-20','16:20:00',1.44),('15844','2013-05-20','16:25:00',1.42),('15844','2013-05-20','16:30:00',1.39),('15844','2013-05-20','16:35:00',1.3),('15844','2013-05-20','16:40:00',1.22),('15844','2013-05-20','16:45:00',1.06),('15844','2013-05-19','08:30:00',1.01),('15844','2013-05-19','08:35:00',1.27),('15844','2013-05-19','08:45:00',1.01),('15844','2013-05-19','08:50:00',1.17),('15844','2013-05-19','08:55:00',1.29),('15844','2013-05-19','09:50:00',1.08),('15844','2013-05-19','09:55:00',1.26),('15844','2013-05-19','10:00:00',1.96),('15844','2013-05-19','10:05:00',1.47),('15844','2013-05-19','10:10:00',1.48),('15844','2013-05-19','10:15:00',1.53),('15844','2013-05-19','10:20:00',2.6),('15844','2013-05-19','10:25:00',2.87),('15844','2013-05-19','10:30:00',2.2),('15844','2013-05-19','10:35:00',2.03),('15844','2013-05-19','10:40:00',1.86),('15844','2013-05-19','10:45:00',1.93),('15844','2013-05-19','10:50:00',2.44),('15844','2013-05-19','10:55:00',2.78),('15844','2013-05-19','11:00:00',2.79),('15844','2013-05-19','11:05:00',3.2),('15844','2013-05-19','11:10:00',2.33),('15844','2013-05-19','11:15:00',2.32),('15844','2013-05-19','11:20:00',4.62),('15844','2013-05-19','11:25:00',4.7),('15844','2013-05-19','11:30:00',4.78),('15844','2013-05-19','11:35:00',4.68),('15844','2013-05-19','11:40:00',4.64),('15844','2013-05-19','11:45:00',4.6),('15844','2013-05-19','11:50:00',4.65),('15844','2013-05-19','11:55:00',4.69),('15844','2013-05-19','12:00:00',4.69),('15844','2013-05-19','12:05:00',4.66),('15844','2013-05-19','12:10:00',4.66),('15844','2013-05-19','12:15:00',4.7),('15844','2013-05-19','12:20:00',4.7),('15844','2013-05-19','12:25:00',5.04),('15844','2013-05-19','12:30:00',5.05),('15844','2013-05-19','12:35:00',4.83),('15844','2013-05-19','12:40:00',4.97),('15844','2013-05-19','12:45:00',4.94),('15844','2013-05-19','12:50:00',4.9),('15844','2013-05-19','12:55:00',4.69),('15844','2013-05-19','13:00:00',4.47),('15844','2013-05-19','13:05:00',4.49),('15844','2013-05-19','13:10:00',4.44),('15844','2013-05-19','13:15:00',4.4),('15844','2013-05-19','13:20:00',4.33),('15844','2013-05-19','13:25:00',4.3),('15844','2013-05-19','13:30:00',4.3),('15844','2013-05-19','13:35:00',4.28),('15844','2013-05-19','13:40:00',4.23),('15844','2013-05-19','13:45:00',4.17),('15844','2013-05-19','13:50:00',4.11),('15844','2013-05-19','13:55:00',4.04),('15844','2013-05-19','14:00:00',3.97),('15844','2013-05-19','14:05:00',3.92),('15844','2013-05-19','14:10:00',3.82),('15844','2013-05-19','14:15:00',3.75),('15844','2013-05-19','14:20:00',3.68),('15844','2013-05-19','14:25:00',3.59),('15844','2013-05-19','14:30:00',3.51),('15844','2013-05-19','14:35:00',3.44),('15844','2013-05-19','14:40:00',3.37),('15844','2013-05-19','14:45:00',3.23),('15844','2013-05-19','14:50:00',3.13),('15844','2013-05-19','14:55:00',3.05),('15844','2013-05-19','15:00:00',2.96),('15844','2013-05-19','15:05:00',2.86),('15844','2013-05-19','15:10:00',2.76),('15844','2013-05-19','15:15:00',2.67),('15844','2013-05-19','15:20:00',2.56),('15844','2013-05-19','15:25:00',2.46),('15844','2013-05-19','15:30:00',2.35),('15844','2013-05-19','15:35:00',2.26),('15844','2013-05-19','15:40:00',2.16),('15844','2013-05-19','15:45:00',2.06),('15844','2013-05-19','15:50:00',1.92),('15844','2013-05-19','15:55:00',1.8),('15844','2013-05-19','16:00:00',1.73),('15844','2013-05-19','16:05:00',1.63),('15844','2013-05-19','16:10:00',1.54),('15844','2013-05-19','16:15:00',1.49),('15844','2013-05-19','16:20:00',1.43),('15844','2013-05-19','16:25:00',1.39),('15844','2013-05-19','16:30:00',1.36),('15844','2013-05-19','16:35:00',1.3),('15844','2013-05-19','16:40:00',1.22),('15844','2013-05-19','16:45:00',1.05),('15844','2013-05-18','08:00:00',1.07),('15844','2013-05-18','08:20:00',1.15),('15844','2013-05-18','08:25:00',1.25),('15844','2013-05-18','08:30:00',1.24),('15844','2013-05-18','08:35:00',1.12),('15844','2013-05-18','08:40:00',1.2),('15844','2013-05-18','08:45:00',1.43),('15844','2013-05-18','08:50:00',1.66),('15844','2013-05-18','08:55:00',1.69),('15844','2013-05-18','09:00:00',1.71),('15844','2013-05-18','09:05:00',1.82),('15844','2013-05-18','09:10:00',1.97),('15844','2013-05-18','09:15:00',2.07),('15844','2013-05-18','09:20:00',2.17),('15844','2013-05-18','09:25:00',2.27),('15844','2013-05-18','09:30:00',2.4),('15844','2013-05-18','09:35:00',2.5),('15844','2013-05-18','09:40:00',2.59),('15844','2013-05-18','09:45:00',2.74),('15844','2013-05-18','09:50:00',2.87),('15844','2013-05-18','09:55:00',2.96),('15844','2013-05-18','10:00:00',3.12),('15844','2013-05-18','10:05:00',3.32),('15844','2013-05-18','10:10:00',3.43),('15844','2013-05-18','10:15:00',3.53),('15844','2013-05-18','10:20:00',3.63),('15844','2013-05-18','10:25:00',3.74),('15844','2013-05-18','10:30:00',3.82),('15844','2013-05-18','10:35:00',3.87),('15844','2013-05-18','10:40:00',3.96),('15844','2013-05-18','10:45:00',4.07),('15844','2013-05-18','10:50:00',4.16),('15844','2013-05-18','10:55:00',4.23),('15844','2013-05-18','11:00:00',4.29),('15844','2013-05-18','11:05:00',4.05),('15844','2013-05-18','11:10:00',3.59),('15844','2013-05-18','11:15:00',3.73),('15844','2013-05-18','11:20:00',3.51),('15844','2013-05-18','11:25:00',2.22),('15844','2013-05-18','11:30:00',4.4),('15844','2013-05-18','11:35:00',3.7),('15844','2013-05-18','11:40:00',4.48),('15844','2013-05-18','11:45:00',4.35),('15844','2013-05-18','11:50:00',4.38),('15844','2013-05-18','11:55:00',4.46),('15844','2013-05-18','12:00:00',4.34),('15844','2013-05-18','12:05:00',4.29),('15844','2013-05-18','12:10:00',4.25),('15844','2013-05-18','12:15:00',4.24),('15844','2013-05-18','12:20:00',4.27),('15844','2013-05-18','12:25:00',4.19),('15844','2013-05-18','12:30:00',4.37),('15844','2013-05-18','12:35:00',4.26),('15844','2013-05-18','12:40:00',4.23),('15844','2013-05-18','12:45:00',4.21),('15844','2013-05-18','12:50:00',4.21),('15844','2013-05-18','12:55:00',4.16),('15844','2013-05-18','13:00:00',4.14),('15844','2013-05-18','13:05:00',4.14),('15844','2013-05-18','13:10:00',4.1),('15844','2013-05-18','13:15:00',4.07),('15844','2013-05-18','13:20:00',4.04),('15844','2013-05-18','13:25:00',4),('15844','2013-05-18','13:30:00',3.98),('15844','2013-05-18','13:35:00',3.99),('15844','2013-05-18','13:40:00',3.96),('15844','2013-05-18','13:45:00',4.02),('15844','2013-05-18','13:50:00',4.09),('15844','2013-05-18','13:55:00',2.71),('15844','2013-05-18','14:00:00',2.08),('15844','2013-05-18','14:05:00',2.3),('15844','2013-05-18','14:10:00',2.29),('15844','2013-05-18','14:15:00',3),('15844','2013-05-18','14:20:00',2.87),('15844','2013-05-18','14:25:00',3.43),('15844','2013-05-18','14:30:00',2.55),('15844','2013-05-18','14:35:00',2.29),('15844','2013-05-18','14:40:00',2.22),('15844','2013-05-18','14:45:00',2.13),('15844','2013-05-18','14:50:00',3.22),('15844','2013-05-18','14:55:00',2.28),('15844','2013-05-18','15:00:00',2.77),('15844','2013-05-18','15:05:00',2.62),('15844','2013-05-18','15:10:00',2.51),('15844','2013-05-18','15:15:00',2.44),('15844','2013-05-18','15:20:00',2.34),('15844','2013-05-18','15:25:00',2.26),('15844','2013-05-18','15:30:00',2.19),('15844','2013-05-18','15:35:00',2.11),('15844','2013-05-18','15:40:00',2.02),('15844','2013-05-18','15:45:00',1.93),('15844','2013-05-18','15:50:00',1.85),('15844','2013-05-18','15:55:00',1.73),('15844','2013-05-18','16:00:00',1.64),('15844','2013-05-18','16:05:00',1.57),('15844','2013-05-18','16:10:00',1.54),('15844','2013-05-18','16:15:00',1.49),('15844','2013-05-18','16:20:00',1.44),('15844','2013-05-18','16:25:00',1.39),('15844','2013-05-18','16:30:00',1.35),('15844','2013-05-18','16:35:00',1.29),('15844','2013-05-18','16:40:00',1.22),('15844','2013-05-18','16:45:00',1.14),('15844','2013-05-18','16:50:00',1.01),('15844','2013-05-17','08:00:00',1.01),('15844','2013-05-17','08:05:00',1.19),('15844','2013-05-17','08:10:00',1.64),('15844','2013-05-17','08:15:00',1.92),('15844','2013-05-17','08:20:00',1.6),('15844','2013-05-17','08:25:00',1.08),('15844','2013-05-17','10:25:00',1.2),('15844','2013-05-17','10:30:00',1.36),('15844','2013-05-17','10:35:00',1.16),('15844','2013-05-17','10:40:00',1.37),('15844','2013-05-17','10:45:00',2.6),('15844','2013-05-17','10:50:00',2.86),('15844','2013-05-17','10:55:00',2.03),('15844','2013-05-17','11:00:00',1.74),('15844','2013-05-17','11:05:00',1.48),('15844','2013-05-17','11:10:00',1.31),('15844','2013-05-17','11:15:00',3.45),('15844','2013-05-17','11:20:00',1.99),('15844','2013-05-17','11:25:00',1.81),('15844','2013-05-17','11:30:00',2.17),('15844','2013-05-17','11:35:00',1.91),('15844','2013-05-17','11:40:00',3.53),('15844','2013-05-17','11:45:00',4.3),('15844','2013-05-17','11:50:00',4.81),('15844','2013-05-17','11:55:00',4.15),('15844','2013-05-17','12:00:00',4.4),('15844','2013-05-17','12:05:00',5.17),('15844','2013-05-17','12:10:00',4.78),('15844','2013-05-17','12:15:00',4.15),('15844','2013-05-17','12:20:00',4.32),('15844','2013-05-17','12:25:00',4.93),('15844','2013-05-17','12:30:00',4.14),('15844','2013-05-17','12:35:00',3.68),('15844','2013-05-17','12:40:00',4.47),('15844','2013-05-17','12:45:00',4.64),('15844','2013-05-17','12:50:00',4.77),('15844','2013-05-17','12:55:00',3.52),('15844','2013-05-17','13:00:00',2.08),('15844','2013-05-17','13:05:00',2.99),('15844','2013-05-17','13:10:00',3.73),('15844','2013-05-17','13:15:00',4.32),('15844','2013-05-17','13:20:00',4.42),('15844','2013-05-17','13:25:00',3.75),('15844','2013-05-17','13:30:00',3.97),('15844','2013-05-17','13:35:00',4.06),('15844','2013-05-17','13:40:00',3.58),('15844','2013-05-17','13:45:00',3.07),('15844','2013-05-17','13:50:00',1.55),('15844','2013-05-17','13:55:00',2.31),('15844','2013-05-17','14:00:00',1.59),('15844','2013-05-17','14:05:00',3.47),('15844','2013-05-17','14:10:00',3.45),('15844','2013-05-17','14:15:00',2.64),('15844','2013-05-17','14:20:00',2.39),('15844','2013-05-17','14:25:00',2.7),('15844','2013-05-17','14:30:00',2.38),('15844','2013-05-17','14:35:00',2.31),('15844','2013-05-17','14:40:00',2.65),('15844','2013-05-17','14:45:00',3.19),('15844','2013-05-17','14:50:00',2.62),('15844','2013-05-17','14:55:00',3.02),('15844','2013-05-17','15:00:00',1.93),('15844','2013-05-17','15:05:00',3.35),('15844','2013-05-17','15:10:00',3.19),('15844','2013-05-17','15:15:00',2.85),('15844','2013-05-17','15:20:00',2.74),('15844','2013-05-17','15:25:00',2.58),('15844','2013-05-17','15:30:00',2.44),('15844','2013-05-17','15:35:00',2.41),('15844','2013-05-17','15:40:00',2.13),('15844','2013-05-17','15:45:00',1.95),('15844','2013-05-17','15:50:00',1.94),('15844','2013-05-17','15:55:00',1.64),('15844','2013-05-17','16:00:00',1.74),('15844','2013-05-17','16:05:00',1.84),('15844','2013-05-17','16:10:00',1.81),('15844','2013-05-17','16:15:00',2.02),('15844','2013-05-17','16:20:00',1.9),('15844','2013-05-17','16:25:00',1.59),('15844','2013-05-17','16:30:00',1.72),('15844','2013-05-17','16:35:00',1.46),('15844','2013-05-17','16:40:00',1.11),('15844','2013-05-17','16:45:00',1.02),('15844','2013-05-16','09:20:00',1.04),('15844','2013-05-16','09:25:00',1.51),('15844','2013-05-16','09:30:00',1.27),('15844','2013-05-16','09:35:00',1.56),('15844','2013-05-16','09:40:00',1.7),('15844','2013-05-16','09:45:00',2.69),('15844','2013-05-16','09:50:00',1.81),('15844','2013-05-16','10:00:00',2.03),('15844','2013-05-16','10:05:00',1.21),('15844','2013-05-16','10:10:00',1.1),('15844','2013-05-16','10:15:00',1.39),('15844','2013-05-16','10:20:00',1.88),('15844','2013-05-16','10:25:00',1.16),('15844','2013-05-16','10:30:00',1.39),('15844','2013-05-16','10:35:00',1.33),('15844','2013-05-16','10:40:00',1.8),('15844','2013-05-16','10:45:00',3.99),('15844','2013-05-16','10:50:00',2.9),('15844','2013-05-16','10:55:00',2.23),('15844','2013-05-16','11:00:00',3.91),('15844','2013-05-16','11:05:00',4.27),('15844','2013-05-16','11:10:00',3.48),('15844','2013-05-16','11:15:00',4.25),('15844','2013-05-16','11:20:00',2.92),('15844','2013-05-16','11:25:00',1.58),('15844','2013-05-16','11:30:00',1.47),('15844','2013-05-16','11:35:00',2.73),('15844','2013-05-16','11:40:00',3.95),('15844','2013-05-16','11:45:00',3.44),('15844','2013-05-16','11:50:00',3.23),('15844','2013-05-16','11:55:00',4.37),('15844','2013-05-16','12:00:00',2.24),('15844','2013-05-16','12:05:00',1.73),('15844','2013-05-16','12:10:00',1.34),('15844','2013-05-16','12:15:00',1.71),('15844','2013-05-16','12:20:00',1.59),('15844','2013-05-16','12:25:00',1.75),('15844','2013-05-16','12:30:00',3.56),('15844','2013-05-16','12:35:00',4.22),('15844','2013-05-16','12:40:00',4.44),('15844','2013-05-16','12:45:00',3.2),('15844','2013-05-16','12:50:00',2.31),('15844','2013-05-16','12:55:00',3.17),('15844','2013-05-16','13:00:00',4.06),('15844','2013-05-16','13:05:00',4.11),('15844','2013-05-16','13:10:00',3.93),('15844','2013-05-16','13:15:00',3.94),('15844','2013-05-16','13:20:00',3.89),('15844','2013-05-16','13:25:00',3.9),('15844','2013-05-16','13:30:00',3.84),('15844','2013-05-16','13:35:00',3.83),('15844','2013-05-16','13:40:00',3.71),('15844','2013-05-16','13:45:00',3.67),('15844','2013-05-16','13:50:00',3.65),('15844','2013-05-16','13:55:00',3.6),('15844','2013-05-16','14:00:00',3.53),('15844','2013-05-16','14:05:00',3.49),('15844','2013-05-16','14:10:00',3.39),('15844','2013-05-16','14:15:00',3.32),('15844','2013-05-16','14:20:00',3.21),('15844','2013-05-16','14:25:00',3.16),('15844','2013-05-16','14:30:00',3.08),('15844','2013-05-16','14:35:00',2.96),('15844','2013-05-16','14:40:00',2.9),('15844','2013-05-16','14:45:00',2.83),('15844','2013-05-16','14:50:00',2.78),('15844','2013-05-16','14:55:00',2.7),('15844','2013-05-16','15:00:00',2.57),('15844','2013-05-16','15:05:00',2.57),('15844','2013-05-16','15:10:00',2.1),('15844','2013-05-16','15:15:00',1.97),('15844','2013-05-16','15:20:00',2.35),('15844','2013-05-16','15:25:00',2.25),('15844','2013-05-16','15:30:00',2.2),('15844','2013-05-16','15:35:00',2.12),('15844','2013-05-16','15:40:00',2.08),('15844','2013-05-16','15:45:00',1.97),('15844','2013-05-16','15:50:00',1.91),('15844','2013-05-16','15:55:00',1.78),('15844','2013-05-16','16:00:00',1.69),('15844','2013-05-16','16:05:00',1.6),('15844','2013-05-16','16:10:00',1.67),('15844','2013-05-16','16:15:00',1.44),('15844','2013-05-16','16:20:00',1.58),('15844','2013-05-16','16:25:00',1.61),('15844','2013-05-16','16:30:00',1.51),('15844','2013-05-16','16:35:00',1.5),('15844','2013-05-16','16:40:00',1.52),('15844','2013-05-16','16:45:00',1.19),('15844','2013-05-16','16:50:00',1.45),('15844','2013-05-16','16:55:00',1.11),('15844','2013-05-16','17:20:00',1.05),('15844','2013-05-16','17:25:00',1.1),('15844','2013-05-16','17:30:00',1.02),('15844','2013-05-15','08:25:00',1.03),('15844','2013-05-15','08:30:00',1.21),('15844','2013-05-15','08:35:00',1.38),('15844','2013-05-15','08:40:00',1.47),('15844','2013-05-15','08:45:00',1.53),('15844','2013-05-15','08:50:00',1.57),('15844','2013-05-15','08:55:00',1.57),('15844','2013-05-15','09:00:00',1.62),('15844','2013-05-15','09:05:00',1.73),('15844','2013-05-15','09:10:00',1.84),('15844','2013-05-15','09:15:00',1.93),('15844','2013-05-15','09:20:00',1.98),('15844','2013-05-15','09:25:00',2.17),('15844','2013-05-15','09:30:00',2.33),('15844','2013-05-15','09:35:00',2.41),('15844','2013-05-15','09:40:00',2.44),('15844','2013-05-15','09:45:00',2.56),('15844','2013-05-15','09:50:00',2.74),('15844','2013-05-15','09:55:00',2.84),('15844','2013-05-15','10:00:00',3.05),('15844','2013-05-15','10:05:00',3.12),('15844','2013-05-15','10:10:00',3.29),('15844','2013-05-15','10:15:00',3.38),('15844','2013-05-15','10:20:00',3.53),('15844','2013-05-15','10:25:00',3.71),('15844','2013-05-15','10:30:00',3.66),('15844','2013-05-15','10:35:00',3.64),('15844','2013-05-15','10:40:00',3.82),('15844','2013-05-15','10:45:00',3.97),('15844','2013-05-15','10:50:00',4.09),('15844','2013-05-15','10:55:00',3.95),('15844','2013-05-15','11:00:00',3.96),('15844','2013-05-15','11:05:00',4.06),('15844','2013-05-15','11:10:00',4.2),('15844','2013-05-15','11:15:00',4.18),('15844','2013-05-15','11:20:00',4.13),('15844','2013-05-15','11:25:00',4.21),('15844','2013-05-15','11:30:00',4.41),('15844','2013-05-15','11:35:00',3.93),('15844','2013-05-15','11:40:00',3.8),('15844','2013-05-15','11:45:00',3.24),('15844','2013-05-15','11:50:00',2.14),('15844','2013-05-15','11:55:00',1.91),('15844','2013-05-15','12:00:00',2.46),('15844','2013-05-15','12:05:00',4.03),('15844','2013-05-15','12:10:00',3.68),('15844','2013-05-15','12:15:00',5.26),('15844','2013-05-15','12:20:00',4.36),('15844','2013-05-15','12:25:00',3.32),('15844','2013-05-15','12:30:00',2.99),('15844','2013-05-15','12:35:00',5.1),('15844','2013-05-15','12:40:00',2.95),('15844','2013-05-15','12:45:00',2.3),('15844','2013-05-15','12:50:00',2.12),('15844','2013-05-15','12:55:00',2.23),('15844','2013-05-15','13:00:00',2.29),('15844','2013-05-15','13:05:00',2.5),('15844','2013-05-15','13:10:00',2.1),('15844','2013-05-15','13:15:00',2.36),('15844','2013-05-15','13:20:00',2.29),('15844','2013-05-15','13:25:00',2.46),('15844','2013-05-15','13:30:00',2.26),('15844','2013-05-15','13:35:00',2.23),('15844','2013-05-15','13:40:00',2.37),('15844','2013-05-15','13:45:00',2.03),('15844','2013-05-15','13:50:00',1.97),('15844','2013-05-15','13:55:00',1.91),('15844','2013-05-15','14:00:00',1.63),('15844','2013-05-15','14:05:00',1.7),('15844','2013-05-15','14:10:00',1.94),('15844','2013-05-15','14:15:00',1.78),('15844','2013-05-15','14:20:00',2.14),('15844','2013-05-15','14:25:00',1.56),('15844','2013-05-15','14:30:00',1.32),('15844','2013-05-15','14:35:00',1.27),('15844','2013-05-15','14:40:00',1.26),('15844','2013-05-15','14:45:00',1.22),('15844','2013-05-15','14:50:00',1.2),('15844','2013-05-15','14:55:00',1.25),('15844','2013-05-15','15:00:00',1.17),('15844','2013-05-15','15:45:00',1.21),('15844','2013-05-15','15:50:00',1.52),('15844','2013-05-15','15:55:00',1.68),('15844','2013-05-15','16:00:00',1.64),('15844','2013-05-15','16:05:00',1.59),('15844','2013-05-15','16:10:00',1.43),('15844','2013-05-15','16:15:00',1.39),('15844','2013-05-15','16:20:00',1.36),('15844','2013-05-15','16:25:00',1.21),('15844','2013-05-15','16:30:00',1.03),('15844','2013-05-15','16:35:00',1.14),('15844','2013-05-15','16:40:00',1.12),('15844','2013-05-15','16:45:00',1.05),('15844','2013-05-15','16:50:00',1.18),('15844','2013-05-15','16:55:00',1.2),('15844','2013-05-15','17:00:00',1.37),('15844','2013-05-15','17:05:00',1.32),('15844','2013-05-15','17:10:00',1.06),('15844','2013-05-14','08:25:00',1.12),('15844','2013-05-14','08:30:00',1.35),('15844','2013-05-14','08:35:00',1.42),('15844','2013-05-14','08:40:00',1.51),('15844','2013-05-14','08:45:00',1.56),('15844','2013-05-14','08:50:00',1.62),('15844','2013-05-14','08:55:00',1.66),('15844','2013-05-14','09:00:00',1.77),('15844','2013-05-14','09:05:00',1.89),('15844','2013-05-14','09:10:00',1.99),('15844','2013-05-14','09:15:00',2.1),('15844','2013-05-14','09:20:00',2.19),('15844','2013-05-14','09:25:00',2.28),('15844','2013-05-14','09:30:00',2.42),('15844','2013-05-14','09:35:00',2.56),('15844','2013-05-14','09:40:00',2.65),('15844','2013-05-14','09:45:00',2.71),('15844','2013-05-14','09:50:00',2.92),('15844','2013-05-14','09:55:00',3.01),('15844','2013-05-14','10:00:00',3.11),('15844','2013-05-14','10:05:00',3.24),('15844','2013-05-14','10:10:00',3.39),('15844','2013-05-14','10:15:00',3.63),('15844','2013-05-14','10:20:00',3.75),('15844','2013-05-14','10:25:00',3.84),('15844','2013-05-14','10:30:00',3.91),('15844','2013-05-14','10:35:00',3.98),('15844','2013-05-14','10:40:00',4.06),('15844','2013-05-14','10:45:00',4.18),('15844','2013-05-14','10:50:00',4.23),('15844','2013-05-14','10:55:00',4.29),('15844','2013-05-14','11:00:00',4.3),('15844','2013-05-14','11:05:00',4.34),('15844','2013-05-14','11:10:00',4.37),('15844','2013-05-14','11:15:00',4.39),('15844','2013-05-14','11:20:00',4.42),('15844','2013-05-14','11:25:00',4.43),('15844','2013-05-14','11:30:00',4.44),('15844','2013-05-14','11:35:00',4.43),('15844','2013-05-14','11:40:00',4.45),('15844','2013-05-14','11:45:00',4.44),('15844','2013-05-14','11:50:00',4.42),('15844','2013-05-14','11:55:00',4.42),('15844','2013-05-14','12:00:00',4.42),('15844','2013-05-14','12:05:00',4.42),('15844','2013-05-14','12:10:00',4.42),('15844','2013-05-14','12:15:00',4.41),('15844','2013-05-14','12:20:00',4.41),('15844','2013-05-14','12:25:00',4.39),('15844','2013-05-14','12:30:00',4.38),('15844','2013-05-14','12:35:00',4.37),('15844','2013-05-14','12:40:00',4.35),('15844','2013-05-14','12:45:00',4.32),('15844','2013-05-14','12:50:00',4.32),('15844','2013-05-14','12:55:00',4.3),('15844','2013-05-14','13:00:00',4.29),('15844','2013-05-14','13:05:00',4.26),('15844','2013-05-14','13:10:00',4.23),('15844','2013-05-14','13:15:00',4.2),('15844','2013-05-14','13:20:00',4.16),('15844','2013-05-14','13:25:00',4.13),('15844','2013-05-14','13:30:00',4.11),('15844','2013-05-14','13:35:00',4.06),('15844','2013-05-14','13:40:00',4.05),('15844','2013-05-14','13:45:00',4),('15844','2013-05-14','13:50:00',3.93),('15844','2013-05-14','13:55:00',3.84),('15844','2013-05-14','14:00:00',3.78),('15844','2013-05-14','14:05:00',3.7),('15844','2013-05-14','14:10:00',3.6),('15844','2013-05-14','14:15:00',3.54),('15844','2013-05-14','14:20:00',3.45),('15844','2013-05-14','14:25:00',3.38),('15844','2013-05-14','14:30:00',3.32),('15844','2013-05-14','14:35:00',3.2),('15844','2013-05-14','14:40:00',3.06),('15844','2013-05-14','14:45:00',2.97),('15844','2013-05-14','14:50:00',2.89),('15844','2013-05-14','14:55:00',2.8),('15844','2013-05-14','15:00:00',2.78),('15844','2013-05-14','15:05:00',2.7),('15844','2013-05-14','15:10:00',2.59),('15844','2013-05-14','15:15:00',2.5),('15844','2013-05-14','15:20:00',2.41),('15844','2013-05-14','15:25:00',2.32),('15844','2013-05-14','15:30:00',2.23),('15844','2013-05-14','15:35:00',2.15),('15844','2013-05-14','15:40:00',2.05),('15844','2013-05-14','15:45:00',1.94),('15844','2013-05-14','15:50:00',1.8),('15844','2013-05-14','15:55:00',1.71),('15844','2013-05-14','16:00:00',1.63),('15844','2013-05-14','16:05:00',1.52),('15844','2013-05-14','16:10:00',1.46),('15844','2013-05-14','16:15:00',1.4),('15844','2013-05-14','16:20:00',1.33),('15844','2013-05-14','16:25:00',1.27),('15844','2013-05-14','16:30:00',1.18),('15844','2013-05-14','16:35:00',1.14),('15844','2013-05-14','16:40:00',1.04),('15844','2013-05-13','07:50:00',1.04),('15844','2013-05-13','08:30:00',1.08),('15844','2013-05-13','08:35:00',1.23),('15844','2013-05-13','08:40:00',1.31),('15844','2013-05-13','08:45:00',1.49),('15844','2013-05-13','08:50:00',1.55),('15844','2013-05-13','08:55:00',1.6),('15844','2013-05-13','09:00:00',1.69),('15844','2013-05-13','09:05:00',1.8),('15844','2013-05-13','09:10:00',1.87),('15844','2013-05-13','09:15:00',2),('15844','2013-05-13','09:20:00',2.14),('15844','2013-05-13','09:25:00',2.24),('15844','2013-05-13','09:30:00',2.37),('15844','2013-05-13','09:35:00',2.49),('15844','2013-05-13','09:40:00',1.63),('15844','2013-05-13','09:45:00',2.34),('15844','2013-05-13','09:50:00',1.09),('15844','2013-05-13','09:55:00',3.36),('15844','2013-05-13','10:00:00',3.62),('15844','2013-05-13','10:05:00',3.24),('15844','2013-05-13','10:10:00',3.7),('15844','2013-05-13','10:15:00',3.93),('15844','2013-05-13','10:20:00',3.87),('15844','2013-05-13','10:25:00',3.95),('15844','2013-05-13','10:30:00',3.91),('15844','2013-05-13','10:35:00',3.98),('15844','2013-05-13','10:40:00',4.04),('15844','2013-05-13','10:45:00',3.47),('15844','2013-05-13','10:50:00',4.3),('15844','2013-05-13','10:55:00',4.36),('15844','2013-05-13','11:00:00',4.83),('15844','2013-05-13','11:05:00',3.2),('15844','2013-05-13','11:10:00',3.21),('15844','2013-05-13','11:15:00',3.31),('15844','2013-05-13','11:20:00',4.58),('15844','2013-05-13','11:25:00',5.07),('15844','2013-05-13','11:30:00',4.11),('15844','2013-05-13','11:35:00',4.66),('15844','2013-05-13','11:40:00',4.69),('15844','2013-05-13','11:45:00',3.85),('15844','2013-05-13','11:50:00',2.45),('15844','2013-05-13','11:55:00',2.47),('15844','2013-05-13','12:00:00',2.37),('15844','2013-05-13','12:05:00',2.62),('15844','2013-05-13','12:10:00',5.37),('15844','2013-05-13','12:15:00',4.68),('15844','2013-05-13','12:20:00',2.04),('15844','2013-05-13','12:35:00',1.24),('15844','2013-05-13','12:40:00',4.09),('15844','2013-05-13','12:45:00',2.67),('15844','2013-05-13','12:50:00',3.82),('15844','2013-05-13','12:55:00',4.23),('15844','2013-05-13','13:00:00',3.5),('15844','2013-05-13','13:05:00',3.65),('15844','2013-05-13','13:10:00',1.61),('15844','2013-05-13','13:15:00',1.12),('15844','2013-05-13','13:20:00',1.17),('15844','2013-05-13','13:25:00',1.34),('15844','2013-05-13','13:30:00',1.23),('15844','2013-05-13','13:35:00',1.16),('15844','2013-05-13','13:40:00',1.93),('15844','2013-05-13','13:45:00',3.54),('15844','2013-05-13','13:50:00',4.26),('15844','2013-05-13','14:05:00',2.87),('15844','2013-05-13','14:10:00',4.15),('15844','2013-05-13','14:15:00',4.26),('15844','2013-05-13','14:20:00',1.92),('15844','2013-05-13','14:25:00',2.03),('15844','2013-05-13','14:30:00',1.83),('15844','2013-05-13','14:50:00',2.21),('15844','2013-05-13','14:55:00',2.98),('15844','2013-05-13','15:00:00',2.2),('15844','2013-05-13','15:45:00',2.05),('15844','2013-05-13','16:05:00',1.13),('15844','2013-05-13','16:10:00',1.24),('15844','2013-05-13','16:15:00',1.39),('15844','2013-05-12','08:10:00',1.03),('15844','2013-05-12','08:15:00',1.33),('15844','2013-05-12','08:20:00',1.24),('15844','2013-05-12','08:30:00',1.39),('15844','2013-05-12','08:35:00',1.33),('15844','2013-05-12','08:40:00',1.09),('15844','2013-05-12','09:00:00',1.98),('15844','2013-05-12','09:05:00',1.57),('15844','2013-05-12','09:20:00',1.16),('15844','2013-05-12','09:25:00',1.38),('15844','2013-05-12','09:30:00',1.44),('15844','2013-05-12','09:35:00',2.2),('15844','2013-05-12','09:40:00',3.1),('15844','2013-05-12','09:45:00',3.19),('15844','2013-05-12','09:50:00',3.16),('15844','2013-05-12','09:55:00',3.11),('15844','2013-05-12','10:00:00',3.28),('15844','2013-05-12','10:05:00',3.52),('15844','2013-05-12','10:10:00',3.78),('15844','2013-05-12','10:15:00',1.65),('15844','2013-05-12','10:35:00',3.02),('15844','2013-05-12','10:40:00',3.45),('15844','2013-05-12','10:45:00',4.51),('15844','2013-05-12','10:50:00',4.47),('15844','2013-05-12','10:55:00',3.46),('15844','2013-05-12','11:00:00',1.99),('15844','2013-05-12','11:05:00',1.49),('15844','2013-05-12','11:10:00',4.41),('15844','2013-05-12','11:15:00',2.21),('15844','2013-05-12','11:20:00',2.22),('15844','2013-05-12','11:25:00',1.6),('15844','2013-05-12','11:30:00',1.14),('15844','2013-05-12','11:35:00',2.32),('15844','2013-05-12','11:40:00',4.96),('15844','2013-05-12','11:45:00',2.02),('15844','2013-05-12','12:05:00',4.29),('15844','2013-05-12','12:10:00',4.21),('15844','2013-05-12','12:15:00',4.83),('15844','2013-05-12','12:20:00',1.5),('15844','2013-05-12','12:25:00',1.39),('15844','2013-05-12','12:30:00',2.07),('15844','2013-05-12','12:35:00',1.67),('15844','2013-05-12','12:40:00',1.58),('15844','2013-05-12','12:45:00',2.87),('15844','2013-05-12','12:50:00',1.34),('15844','2013-05-12','12:55:00',3.55),('15844','2013-05-12','13:00:00',4.66),('15844','2013-05-12','13:05:00',3.47),('15844','2013-05-12','13:10:00',4.46),('15844','2013-05-12','13:15:00',4.41),('15844','2013-05-12','13:20:00',4.35),('15844','2013-05-12','13:25:00',3.87),('15844','2013-05-12','13:30:00',4.09),('15844','2013-05-12','13:35:00',3.72),('15844','2013-05-12','13:40:00',4),('15844','2013-05-12','13:45:00',4.07),('15844','2013-05-12','13:50:00',4.26),('15844','2013-05-12','13:55:00',4.06),('15844','2013-05-12','14:00:00',3.89),('15844','2013-05-12','14:05:00',3.66),('15844','2013-05-12','14:10:00',3.01),('15844','2013-05-12','14:15:00',3.29),('15844','2013-05-12','14:20:00',3.33),('15844','2013-05-12','14:25:00',2.12),('15844','2013-05-12','14:30:00',3.89),('15844','2013-05-12','14:35:00',2.5),('15844','2013-05-12','14:40:00',3.42),('15844','2013-05-12','14:45:00',3.21),('15844','2013-05-12','14:50:00',2.67),('15844','2013-05-12','14:55:00',2.1),('15844','2013-05-12','15:00:00',3.08),('15844','2013-05-12','15:05:00',2.76),('15844','2013-05-12','15:10:00',2.72),('15844','2013-05-12','15:15:00',2.02),('15844','2013-05-12','15:20:00',2.29),('15844','2013-05-12','15:25:00',2.36),('15844','2013-05-12','15:30:00',2.24),('15844','2013-05-12','15:35:00',2.2),('15844','2013-05-12','15:40:00',2.04),('15844','2013-05-12','15:45:00',1.94),('15844','2013-05-12','15:50:00',1.82),('15844','2013-05-12','15:55:00',1.73),('15844','2013-05-12','16:00:00',1.63),('15844','2013-05-12','16:05:00',1.55),('15844','2013-05-12','16:10:00',1.48),('15844','2013-05-12','16:15:00',1.45),('15844','2013-05-12','16:20:00',1.39),('15844','2013-05-12','16:25:00',1.36),('15844','2013-05-12','16:30:00',1.45),('15844','2013-05-12','16:35:00',1.41),('15844','2013-05-12','16:40:00',1.33),('15844','2013-05-12','16:45:00',1.58),('15844','2013-05-12','16:50:00',1.51),('15844','2013-05-12','16:55:00',1.51),('15844','2013-05-12','17:00:00',1.37),('15844','2013-05-12','17:05:00',1.12),('15844','2013-05-12','17:10:00',1.12),('15844','2013-05-12','17:35:00',1.05),('15844','2013-05-12','17:40:00',1.05),('15844','2013-05-12','17:55:00',1.08),('15844','2013-05-12','18:05:00',1.04),('15844','2013-05-12','18:10:00',1.2),('15844','2014-03-31','08:50:00',1.06),('15844','2014-03-31','08:55:00',1.15),('15844','2014-03-31','09:00:00',1.24),('15844','2014-03-31','09:05:00',1.31),('15844','2014-03-31','09:10:00',1.47),('15844','2014-03-31','09:15:00',1.66),('15844','2014-03-31','09:20:00',1.77),('15844','2014-03-31','09:25:00',1.85),('15844','2014-03-31','09:30:00',1.95),('15844','2014-03-31','09:35:00',2.07),('15844','2014-03-31','09:40:00',2.19),('15844','2014-03-31','09:45:00',2.3),('15844','2014-03-31','09:50:00',2.37),('15844','2014-03-31','09:55:00',2.4),('15844','2014-03-31','10:00:00',2.45),('15844','2014-03-31','10:05:00',2.53),('15844','2014-03-31','10:10:00',2.62),('15844','2014-03-31','10:15:00',2.69),('15844','2014-03-31','10:20:00',2.72),('15844','2014-03-31','10:25:00',2.78),('15844','2014-03-31','10:30:00',2.87),('15844','2014-03-31','10:35:00',3.01),('15844','2014-03-31','10:40:00',3.12),('15844','2014-03-31','10:45:00',3.16),('15844','2014-03-31','10:50:00',3.2),('15844','2014-03-31','10:55:00',3.27),('15844','2014-03-31','11:00:00',3.37),('15844','2014-03-31','11:05:00',3.46),('15844','2014-03-31','11:10:00',3.52),('15844','2014-03-31','11:15:00',3.54),('15844','2014-03-31','11:20:00',3.56),('15844','2014-03-31','11:25:00',3.62),('15844','2014-03-31','11:30:00',3.62),('15844','2014-03-31','11:35:00',3.65),('15844','2014-03-31','11:40:00',3.68),('15844','2014-03-31','11:45:00',3.69),('15844','2014-03-31','11:50:00',3.66),('15844','2014-03-31','11:55:00',3.67),('15844','2014-03-31','12:00:00',3.69),('15844','2014-03-31','12:05:00',3.68),('15844','2014-03-31','12:10:00',3.68),('15844','2014-03-31','12:15:00',3.65),('15844','2014-03-31','12:20:00',3.62),('15844','2014-03-31','12:25:00',3.61),('15844','2014-03-31','12:30:00',3.63),('15844','2014-03-31','12:35:00',3.69),('15844','2014-03-31','12:40:00',3.66),('15844','2014-03-31','12:45:00',3.66),('15844','2014-03-31','12:50:00',3.62),('15844','2014-03-31','12:55:00',3.63),('15844','2014-03-31','13:00:00',3.63),('15844','2014-03-31','13:05:00',3.61),('15844','2014-03-31','13:10:00',3.58),('15844','2014-03-31','13:15:00',3.59),('15844','2014-03-31','13:20:00',3.57),('15844','2014-03-31','13:25:00',3.53),('15844','2014-03-31','13:30:00',3.49),('15844','2014-03-31','13:35:00',3.48),('15844','2014-03-31','13:40:00',3.44),('15844','2014-03-31','13:45:00',3.38),('15844','2014-03-31','13:50:00',3.35),('15844','2014-03-31','13:55:00',3.31),('15844','2014-03-31','14:00:00',3.26),('15844','2014-03-31','14:05:00',3.22),('15844','2014-03-31','14:10:00',3.16),('15844','2014-03-31','14:15:00',3.1),('15844','2014-03-31','14:20:00',3.04),('15844','2014-03-31','14:25:00',2.96),('15844','2014-03-31','14:30:00',2.9),('15844','2014-03-31','14:35:00',2.77),('15844','2014-03-31','14:40:00',2.65),('15844','2014-03-31','14:45:00',2.52),('15844','2014-03-31','14:50:00',2.4),('15844','2014-03-31','14:55:00',2.26),('15844','2014-03-31','15:00:00',2.25),('15844','2014-03-31','15:05:00',2.15),('15844','2014-03-31','15:10:00',2.05),('15844','2014-03-31','15:15:00',1.93),('15844','2014-03-31','15:20:00',1.85),('15844','2014-03-31','15:25:00',1.76),('15844','2014-03-31','15:30:00',1.67),('15844','2014-03-31','15:35:00',1.57),('15844','2014-03-31','15:40:00',1.46),('15844','2014-03-31','15:45:00',1.34),('15844','2014-03-31','15:50:00',1.24),('15844','2014-03-31','15:55:00',1.19),('15844','2014-03-31','16:00:00',1.12),('15844','2014-03-31','16:05:00',1.05),('15844','2013-05-11','08:15:00',1.16),('15844','2013-05-11','08:20:00',1.03),('15844','2013-05-11','08:25:00',1.13),('15844','2013-05-11','08:35:00',1.02),('15844','2013-05-11','08:40:00',1.3),('15844','2013-05-11','08:50:00',1.06),('15844','2013-05-11','08:55:00',1.57),('15844','2013-05-11','09:00:00',1.76),('15844','2013-05-11','09:05:00',1.22),('15844','2013-05-11','09:10:00',2.45),('15844','2013-05-11','09:15:00',2.15),('15844','2013-05-11','09:20:00',2.14),('15844','2013-05-11','09:25:00',1.81),('15844','2013-05-11','09:30:00',1.57),('15844','2013-05-11','09:35:00',1.12),('15844','2013-05-11','09:40:00',1.4),('15844','2013-05-11','09:45:00',1.72),('15844','2013-05-11','09:50:00',1.33),('15844','2013-05-11','10:10:00',1.08),('15844','2013-05-11','10:15:00',2.2),('15844','2013-05-11','10:20:00',3.73),('15844','2013-05-11','10:25:00',4.29),('15844','2013-05-11','10:30:00',2.77),('15844','2013-05-11','10:35:00',4.17),('15844','2013-05-11','10:40:00',4.39),('15844','2013-05-11','10:45:00',3.2),('15844','2013-05-11','10:50:00',4.67),('15844','2013-05-11','10:55:00',4.58),('15844','2013-05-11','11:00:00',2.39),('15844','2013-05-11','11:05:00',1.3),('15844','2013-05-11','11:30:00',1.25),('15844','2013-05-11','11:35:00',2.84),('15844','2013-05-11','11:40:00',1.66),('15844','2013-05-11','11:45:00',2.33),('15844','2013-05-11','11:50:00',5.02),('15844','2013-05-11','11:55:00',4.61),('15844','2013-05-11','12:00:00',2.8),('15844','2013-05-11','12:05:00',2.53),('15844','2013-05-11','12:10:00',3.35),('15844','2013-05-11','12:15:00',3.66),('15844','2013-05-11','12:20:00',4.15),('15844','2013-05-11','12:25:00',5.07),('15844','2013-05-11','12:30:00',4.61),('15844','2013-05-11','12:35:00',2.67),('15844','2013-05-11','12:40:00',1.79),('15844','2013-05-11','12:45:00',3.23),('15844','2013-05-11','12:50:00',1.92),('15844','2013-05-11','12:55:00',1.67),('15844','2013-05-11','13:00:00',1.82),('15844','2013-05-11','13:05:00',2.96),('15844','2013-05-11','13:10:00',3.36),('15844','2013-05-11','13:15:00',1.56),('15844','2013-05-11','13:20:00',1.8),('15844','2013-05-11','13:30:00',1.24),('15844','2013-05-11','13:35:00',2.77),('15844','2013-05-11','13:40:00',2.62),('15844','2013-05-11','13:45:00',2.01),('15844','2013-05-11','13:50:00',2.6),('15844','2013-05-11','13:55:00',3.02),('15844','2013-05-11','14:00:00',3.78),('15844','2013-05-11','14:05:00',2.28),('15844','2013-05-11','14:10:00',2.3),('15844','2013-05-11','14:15:00',2.03),('15844','2013-05-11','14:20:00',2.57),('15844','2013-05-11','14:25:00',2.4),('15844','2013-05-11','14:30:00',3.19),('15844','2013-05-11','14:35:00',2.5),('15844','2013-05-11','14:40:00',2.08),('15844','2013-05-11','14:45:00',2.34),('15844','2013-05-11','14:50:00',1.7),('15844','2013-05-11','14:55:00',1.56),('15844','2013-05-11','15:00:00',1.19),('15844','2013-05-11','15:05:00',2.18),('15844','2013-05-11','15:10:00',2.31),('15844','2013-05-11','15:15:00',1.93),('15844','2013-05-11','15:20:00',2.09),('15844','2013-05-11','15:25:00',2.64),('15844','2013-05-11','15:30:00',1.83),('15844','2013-05-11','15:35:00',2.49),('15844','2013-05-11','15:40:00',2.8),('15844','2013-05-11','15:45:00',2.19),('15844','2013-05-11','15:50:00',1.67),('15844','2013-05-11','15:55:00',2.08),('15844','2013-05-11','16:00:00',1.74),('15844','2013-05-11','16:05:00',1.61),('15844','2013-05-11','16:10:00',1.54),('15844','2013-05-11','16:15:00',1.25),('15844','2013-05-11','16:20:00',1.36),('15844','2013-05-11','16:25:00',1.37),('15844','2013-05-11','16:30:00',1.27),('15844','2013-05-11','16:40:00',1.11),('15844','2013-05-11','16:55:00',1.09),('15844','2013-05-10','08:00:00',1.21),('15844','2013-05-10','08:05:00',1.31),('15844','2013-05-10','08:10:00',1.37),('15844','2013-05-10','08:15:00',1.26),('15844','2013-05-10','08:20:00',1.2),('15844','2013-05-10','08:25:00',1.04),('15844','2013-05-10','08:55:00',1.52),('15844','2013-05-10','09:00:00',1.79),('15844','2013-05-10','09:05:00',1.88),('15844','2013-05-10','09:10:00',1.86),('15844','2013-05-10','09:15:00',1.77),('15844','2013-05-10','09:20:00',1.97),('15844','2013-05-10','09:25:00',2.48),('15844','2013-05-10','09:30:00',2.2),('15844','2013-05-10','09:35:00',1.94),('15844','2013-05-10','09:40:00',2.53),('15844','2013-05-10','09:45:00',2.88),('15844','2013-05-10','09:50:00',3.07),('15844','2013-05-10','09:55:00',2.97),('15844','2013-05-10','10:00:00',3.06),('15844','2013-05-10','10:05:00',1.29),('15844','2013-05-10','10:10:00',1.3),('15844','2013-05-10','10:15:00',1.39),('15844','2013-05-10','10:20:00',1.09),('15844','2013-05-10','10:25:00',3.02),('15844','2013-05-10','10:30:00',3.85),('15844','2013-05-10','10:35:00',3.94),('15844','2013-05-10','10:40:00',3.98),('15844','2013-05-10','10:45:00',4.15),('15844','2013-05-10','10:50:00',4.36),('15844','2013-05-10','10:55:00',4.6),('15844','2013-05-10','11:00:00',3.37),('15844','2013-05-10','11:05:00',4.31),('15844','2013-05-10','11:10:00',4.37),('15844','2013-05-10','11:15:00',4.32),('15844','2013-05-10','11:20:00',3.33),('15844','2013-05-10','11:25:00',3.52),('15844','2013-05-10','11:30:00',2.43),('15844','2013-05-10','11:35:00',2.48),('15844','2013-05-10','11:40:00',2.7),('15844','2013-05-10','11:45:00',3.06),('15844','2013-05-10','11:50:00',3.42),('15844','2013-05-10','11:55:00',3.15),('15844','2013-05-10','12:00:00',3.29),('15844','2013-05-10','12:05:00',3.62),('15844','2013-05-10','12:10:00',3.51),('15844','2013-05-10','12:15:00',3.06),('15844','2013-05-10','12:20:00',3.27),('15844','2013-05-10','12:25:00',2.69),('15844','2013-05-10','12:30:00',4.33),('15844','2013-05-10','12:35:00',5.05),('15844','2013-05-10','12:40:00',4.41),('15844','2013-05-10','12:45:00',4.19),('15844','2013-05-10','12:50:00',4.03),('15844','2013-05-10','12:55:00',5.01),('15844','2013-05-10','13:00:00',4.04),('15844','2013-05-10','13:05:00',4.69),('15844','2013-05-10','13:10:00',3.93),('15844','2013-05-10','13:15:00',2.54),('15844','2013-05-10','13:20:00',4.28),('15844','2013-05-10','13:25:00',5.42),('15844','2013-05-10','13:30:00',4.72),('15844','2013-05-10','13:35:00',4.35),('15844','2013-05-10','13:40:00',2.18),('15844','2013-05-10','13:45:00',1.85),('15844','2013-05-10','13:50:00',1.68),('15844','2013-05-10','13:55:00',1.69),('15844','2013-05-10','14:00:00',2.04),('15844','2013-05-10','14:05:00',2.55),('15844','2013-05-10','14:10:00',2.55),('15844','2013-05-10','14:15:00',2.54),('15844','2013-05-10','14:20:00',2.13),('15844','2013-05-10','14:25:00',2.13),('15844','2013-05-10','14:30:00',2.62),('15844','2013-05-10','14:35:00',1.77),('15844','2013-05-10','14:40:00',1.41),('15844','2013-05-10','14:45:00',1.15),('15844','2013-05-10','14:50:00',1.02),('15844','2013-05-10','14:55:00',1.11),('15844','2013-05-10','15:00:00',1.58),('15844','2013-05-10','15:05:00',2.54),('15844','2013-05-10','15:10:00',2.05),('15844','2013-05-10','15:15:00',1.66),('15844','2013-05-10','15:20:00',1.63),('15844','2013-05-10','15:25:00',1.8),('15844','2013-05-10','15:30:00',1.93),('15844','2013-05-10','15:35:00',1.91),('15844','2013-05-10','15:40:00',1.75),('15844','2013-05-10','15:45:00',1.53),('15844','2013-05-10','15:50:00',1.48),('15844','2013-05-10','15:55:00',1.5),('15844','2013-05-10','16:00:00',1.44),('15844','2013-05-10','16:05:00',1.3),('15844','2013-05-10','16:10:00',1.23),('15844','2013-05-10','16:15:00',1.21),('15844','2013-05-10','16:20:00',1.33),('15844','2013-05-10','16:25:00',1.42),('15844','2013-05-10','16:30:00',1.38),('15844','2013-05-10','16:35:00',1.35),('15844','2013-05-10','16:40:00',1.33),('15844','2013-05-10','16:45:00',1.12),('15844','2013-05-10','17:05:00',1.18),('15844','2013-05-10','17:10:00',1.32),('15844','2013-05-10','17:15:00',1.43),('15844','2013-05-10','17:20:00',1.4),('15844','2013-05-10','17:25:00',1.31),('15844','2013-05-10','17:30:00',1.11),('15844','2013-05-09','08:20:00',1.02),('15844','2013-05-09','08:25:00',1.18),('15844','2013-05-09','08:30:00',1.28),('15844','2013-05-09','08:35:00',1.35),('15844','2013-05-09','08:40:00',1.43),('15844','2013-05-09','08:45:00',1.51),('15844','2013-05-09','08:50:00',1.64),('15844','2013-05-09','08:55:00',1.7),('15844','2013-05-09','09:00:00',1.76),('15844','2013-05-09','09:05:00',1.83),('15844','2013-05-09','09:10:00',1.91),('15844','2013-05-09','09:15:00',2.05),('15844','2013-05-09','09:20:00',2.2),('15844','2013-05-09','09:25:00',2.32),('15844','2013-05-09','09:30:00',2.41),('15844','2013-05-09','09:35:00',2.5),('15844','2013-05-09','09:40:00',2.58),('15844','2013-05-09','09:45:00',2.66),('15844','2013-05-09','09:50:00',2.84),('15844','2013-05-09','09:55:00',2.94),('15844','2013-05-09','10:00:00',3.03),('15844','2013-05-09','10:05:00',3.12),('15844','2013-05-09','10:10:00',3.25),('15844','2013-05-09','10:15:00',3.44),('15844','2013-05-09','10:20:00',3.58),('15844','2013-05-09','10:25:00',3.67),('15844','2013-05-09','10:30:00',3.76),('15844','2013-05-09','10:35:00',3.79),('15844','2013-05-09','10:40:00',3.87),('15844','2013-05-09','10:45:00',4.01),('15844','2013-05-09','10:50:00',4.12),('15844','2013-05-09','10:55:00',4.16),('15844','2013-05-09','11:00:00',4.21),('15844','2013-05-09','11:05:00',4.25),('15844','2013-05-09','11:10:00',4.27),('15844','2013-05-09','11:15:00',4.28),('15844','2013-05-09','11:20:00',4.25),('15844','2013-05-09','11:25:00',4.24),('15844','2013-05-09','11:30:00',4.29),('15844','2013-05-09','11:35:00',4.31),('15844','2013-05-09','11:40:00',4.35),('15844','2013-05-09','11:45:00',4.37),('15844','2013-05-09','11:50:00',4.4),('15844','2013-05-09','11:55:00',4.42),('15844','2013-05-09','12:00:00',4.44),('15844','2013-05-09','12:05:00',4.43),('15844','2013-05-09','12:10:00',4.43),('15844','2013-05-09','12:15:00',4.4),('15844','2013-05-09','12:20:00',4.37),('15844','2013-05-09','12:25:00',4.35),('15844','2013-05-09','12:30:00',4.37),('15844','2013-05-09','12:35:00',4.34),('15844','2013-05-09','12:40:00',4.33),('15844','2013-05-09','12:45:00',4.29),('15844','2013-05-09','12:50:00',4.34),('15844','2013-05-09','12:55:00',4.31),('15844','2013-05-09','13:00:00',4.27),('15844','2013-05-09','13:05:00',4.23),('15844','2013-05-09','13:10:00',4.18),('15844','2013-05-09','13:15:00',4.42),('15844','2013-05-09','13:20:00',2.54),('15844','2013-05-09','13:25:00',1.64),('15844','2013-05-09','13:30:00',2.41),('15844','2013-05-09','13:40:00',1.45),('15844','2013-05-09','13:45:00',3.1),('15844','2013-05-09','13:50:00',4.36),('15844','2013-05-09','13:55:00',4.26),('15844','2013-05-09','14:00:00',4.11),('15844','2013-05-09','14:05:00',3.94),('15844','2013-05-09','14:10:00',3.74),('15844','2013-05-09','14:15:00',3.6),('15844','2013-05-09','14:20:00',3.52),('15844','2013-05-09','14:25:00',3.43),('15844','2013-05-09','14:30:00',3.29),('15844','2013-05-09','14:35:00',3.18),('15844','2013-05-09','14:40:00',3.07),('15844','2013-05-09','14:45:00',2.98),('15844','2013-05-09','14:50:00',2.85),('15844','2013-05-09','14:55:00',2.7),('15844','2013-05-09','15:00:00',2.55),('15844','2013-05-09','15:05:00',2.46),('15844','2013-05-09','15:10:00',2.44),('15844','2013-05-09','15:15:00',2.43),('15844','2013-05-09','15:20:00',2.38),('15844','2013-05-09','15:25:00',2.29),('15844','2013-05-09','15:30:00',2.18),('15844','2013-05-09','15:35:00',2.06),('15844','2013-05-09','15:40:00',1.97),('15844','2013-05-09','15:45:00',1.88),('15844','2013-05-09','15:50:00',1.78),('15844','2013-05-09','15:55:00',1.68),('15844','2013-05-09','16:00:00',1.58),('15844','2013-05-09','16:05:00',1.48),('15844','2013-05-09','16:10:00',1.43),('15844','2013-05-09','16:15:00',1.35),('15844','2013-05-09','16:20:00',1.3),('15844','2013-05-09','16:25:00',1.23),('15844','2013-05-09','16:30:00',1.15),('15844','2013-05-09','16:35:00',1.06),('15844','2013-05-08','08:30:00',1.06),('15844','2013-05-08','08:35:00',1.23),('15844','2013-05-08','08:40:00',1.4),('15844','2013-05-08','08:45:00',1.79),('15844','2013-05-08','08:50:00',2.02),('15844','2013-05-08','08:55:00',1.93),('15844','2013-05-08','09:00:00',1.98),('15844','2013-05-08','09:05:00',1.55),('15844','2013-05-08','09:10:00',2.37),('15844','2013-05-08','09:15:00',2.6),('15844','2013-05-08','09:20:00',2.22),('15844','2013-05-08','09:55:00',1.04),('15844','2013-05-08','10:00:00',3.84),('15844','2013-05-08','10:05:00',2.53),('15844','2013-05-08','10:10:00',3.48),('15844','2013-05-08','10:15:00',2.19),('15844','2013-05-08','10:20:00',2.64),('15844','2013-05-08','10:25:00',2.88),('15844','2013-05-08','10:30:00',3.79),('15844','2013-05-08','10:35:00',2.45),('15844','2013-05-08','10:40:00',3.78),('15844','2013-05-08','10:45:00',4.22),('15844','2013-05-08','10:50:00',3.57),('15844','2013-05-08','10:55:00',1.36),('15844','2013-05-08','11:00:00',3.68),('15844','2013-05-08','11:05:00',4.84),('15844','2013-05-08','11:10:00',2.49),('15844','2013-05-08','11:15:00',1.48),('15844','2013-05-08','11:20:00',1.12),('15844','2013-05-08','11:30:00',1.13),('15844','2013-05-08','11:35:00',1.08),('15844','2013-05-08','11:40:00',1.22),('15844','2013-05-08','11:45:00',2.87),('15844','2013-05-08','11:50:00',3.95),('15844','2013-05-08','11:55:00',4.48),('15844','2013-05-08','12:00:00',5.05),('15844','2013-05-08','12:05:00',3.44),('15844','2013-05-08','12:35:00',1.72),('15844','2013-05-08','12:40:00',1.08),('15844','2013-05-08','12:45:00',2.39),('15844','2013-05-08','12:50:00',4.19),('15844','2013-05-08','12:55:00',2.37),('15844','2013-05-08','13:00:00',1.39),('15844','2013-05-08','13:05:00',2.62),('15844','2013-05-08','13:10:00',2.08),('15844','2013-05-08','13:15:00',1.71),('15844','2013-05-08','13:20:00',1.22),('15844','2013-05-08','13:25:00',1.29),('15844','2013-05-08','13:30:00',2.28),('15844','2013-05-08','13:35:00',4.93),('15844','2013-05-08','13:40:00',4.35),('15844','2013-05-08','13:45:00',3.75),('15844','2013-05-08','13:50:00',3.67),('15844','2013-05-08','13:55:00',3.46),('15844','2013-05-08','14:00:00',2.01),('15844','2013-05-08','14:05:00',3.53),('15844','2013-05-08','14:10:00',3.97),('15844','2013-05-08','14:15:00',3.94),('15844','2013-05-08','14:20:00',3.88),('15844','2013-05-08','14:25:00',3.7),('15844','2013-05-08','14:30:00',3.69),('15844','2013-05-08','14:35:00',3.48),('15844','2013-05-08','14:40:00',3.36),('15844','2013-05-08','14:45:00',3.18),('15844','2013-05-08','14:50:00',2.86),('15844','2013-05-08','14:55:00',2.95),('15844','2013-05-08','15:00:00',2.78),('15844','2013-05-08','15:05:00',2.69),('15844','2013-05-08','15:10:00',2.59),('15844','2013-05-08','15:15:00',2.5),('15844','2013-05-08','15:20:00',2.45),('15844','2013-05-08','15:25:00',2.39),('15844','2013-05-08','15:30:00',2.24),('15844','2013-05-08','15:35:00',1.97),('15844','2013-05-08','15:40:00',2.08),('15844','2013-05-08','15:45:00',1.97),('15844','2013-05-08','15:50:00',1.89),('15844','2013-05-08','15:55:00',1.79),('15844','2013-05-08','16:00:00',1.66),('15844','2013-05-08','16:05:00',1.58),('15844','2013-05-08','16:10:00',1.49),('15844','2013-05-08','16:15:00',1.39),('15844','2013-05-08','16:20:00',1.3),('15844','2013-05-08','16:25:00',1.26),('15844','2013-05-08','16:30:00',1.22),('15844','2013-05-08','16:35:00',1.19),('15844','2013-05-08','16:40:00',1),('15844','2013-05-07','08:20:00',1.05),('15844','2013-05-07','08:25:00',1.18),('15844','2013-05-07','08:30:00',1.27),('15844','2013-05-07','08:35:00',1.34),('15844','2013-05-07','08:40:00',1.44),('15844','2013-05-07','08:45:00',1.59),('15844','2013-05-07','08:50:00',1.49),('15844','2013-05-07','08:55:00',1.66),('15844','2013-05-07','09:00:00',1.77),('15844','2013-05-07','09:05:00',1.71),('15844','2013-05-07','09:10:00',2.39),('15844','2013-05-07','09:15:00',1.18),('15844','2013-05-07','09:45:00',1.63),('15844','2013-05-07','10:20:00',1.64),('15844','2013-05-07','10:25:00',1.29),('15844','2013-05-07','11:20:00',1.37),('15844','2013-05-07','11:25:00',2.29),('15844','2013-05-07','11:30:00',4.79),('15844','2013-05-07','11:35:00',4.9),('15844','2013-05-07','11:40:00',4.82),('15844','2013-05-07','11:45:00',5.13),('15844','2013-05-07','11:50:00',2.16),('15844','2013-05-07','11:55:00',1.11),('15844','2013-05-07','12:00:00',1.17),('15844','2013-05-07','12:05:00',1.33),('15844','2013-05-07','12:10:00',1.8),('15844','2013-05-07','12:15:00',2.37),('15844','2013-05-07','12:20:00',1.86),('15844','2013-05-07','12:25:00',2.21),('15844','2013-05-07','12:30:00',2.08),('15844','2013-05-07','12:35:00',1.99),('15844','2013-05-07','12:40:00',2.26),('15844','2013-05-07','12:45:00',2.79),('15844','2013-05-07','12:50:00',1.62),('15844','2013-05-07','12:55:00',1.23),('15844','2013-05-07','13:00:00',1.57),('15844','2013-05-07','13:05:00',2.2),('15844','2013-05-07','13:10:00',5.22),('15844','2013-05-07','13:15:00',4.53),('15844','2013-05-07','13:20:00',4.66),('15844','2013-05-07','13:25:00',4.25),('15844','2013-05-07','13:30:00',3.86),('15844','2013-05-07','13:35:00',4.35),('15844','2013-05-07','13:40:00',3.96),('15844','2013-05-07','13:45:00',4.37),('15844','2013-05-07','13:50:00',3.68),('15844','2013-05-07','13:55:00',4.02),('15844','2013-05-07','14:00:00',4.37),('15844','2013-05-07','14:05:00',4.55),('15844','2013-05-07','14:10:00',4.35),('15844','2013-05-07','14:15:00',4.37),('15844','2013-05-07','14:20:00',4.03),('15844','2013-05-07','14:25:00',3.57),('15844','2013-05-07','14:30:00',3.55),('15844','2013-05-07','14:35:00',3.11),('15844','2013-05-07','14:40:00',3.48),('15844','2013-05-07','14:45:00',3.18),('15844','2013-05-07','14:50:00',3.01),('15844','2013-05-07','14:55:00',2.94),('15844','2013-05-07','15:00:00',2.03),('15844','2013-05-07','15:05:00',2.97),('15844','2013-05-07','15:10:00',2.78),('15844','2013-05-07','15:15:00',2.77),('15844','2013-05-07','15:20:00',2.75),('15844','2013-05-07','15:25:00',2.15),('15844','2013-05-07','15:30:00',1.47),('15844','2013-05-07','15:35:00',1.07),('15844','2013-05-07','15:40:00',2),('15844','2013-05-07','15:45:00',1.16),('15844','2013-05-07','15:50:00',1.69),('15844','2013-05-07','15:55:00',2.28),('15844','2013-05-07','16:00:00',2.74),('15844','2013-05-07','16:05:00',2.34),('15844','2013-05-07','16:10:00',2.04),('15844','2013-05-07','16:15:00',1.85),('15844','2013-05-07','16:20:00',1.84),('15844','2013-05-07','16:25:00',1.63),('15844','2013-05-07','16:30:00',1.57),('15844','2013-05-07','16:35:00',1.59),('15844','2013-05-07','16:40:00',1.65),('15844','2013-05-07','16:45:00',1.29),('15844','2013-05-07','16:50:00',1.05),('15844','2013-05-07','16:55:00',1.33),('15844','2013-05-07','17:00:00',1.09),('15844','2013-05-06','08:20:00',1.35),('15844','2013-05-06','08:25:00',1.13),('15844','2013-05-06','08:35:00',1.09),('15844','2013-05-06','08:40:00',1.35),('15844','2013-05-06','08:45:00',1.26),('15844','2013-05-06','08:50:00',1.8),('15844','2013-05-06','08:55:00',1.45),('15844','2013-05-06','09:00:00',1.3),('15844','2013-05-06','09:05:00',1.04),('15844','2013-05-06','09:10:00',1.3),('15844','2013-05-06','09:15:00',2.04),('15844','2013-05-06','09:20:00',1.59),('15844','2013-05-06','09:40:00',1.42),('15844','2013-05-06','10:10:00',1.09),('15844','2013-05-06','10:15:00',1.56),('15844','2013-05-06','10:20:00',1.44),('15844','2013-05-06','10:25:00',1.69),('15844','2013-05-06','10:30:00',1.79),('15844','2013-05-06','10:35:00',2.2),('15844','2013-05-06','10:40:00',1.32),('15844','2013-05-06','10:50:00',1.74),('15844','2013-05-06','10:55:00',1.66),('15844','2013-05-06','11:00:00',1.26),('15844','2013-05-06','11:10:00',1.07),('15844','2013-05-06','11:15:00',1.92),('15844','2013-05-06','11:20:00',1.16),('15844','2013-05-06','11:30:00',1.77),('15844','2013-05-06','11:35:00',2.08),('15844','2013-05-06','11:40:00',1.09),('15844','2013-05-06','11:45:00',1.56),('15844','2013-05-06','11:50:00',1.87),('15844','2013-05-06','11:55:00',1.3),('15844','2013-05-06','12:00:00',1.36),('15844','2013-05-06','12:05:00',1.92),('15844','2013-05-06','12:10:00',3.01),('15844','2013-05-06','12:15:00',2.25),('15844','2013-05-06','12:20:00',3.07),('15844','2013-05-06','12:25:00',3.17),('15844','2013-05-06','12:30:00',3.14),('15844','2013-05-06','12:35:00',3.94),('15844','2013-05-06','12:40:00',4.69),('15844','2013-05-06','12:45:00',3.65),('15844','2013-05-06','12:50:00',3.41),('15844','2013-05-06','12:55:00',3.78),('15844','2013-05-06','13:00:00',3.22),('15844','2013-05-06','13:05:00',3.59),('15844','2013-05-06','13:10:00',4.43),('15844','2013-05-06','13:15:00',4.12),('15844','2013-05-06','13:20:00',3.75),('15844','2013-05-06','13:25:00',2.65),('15844','2013-05-06','13:30:00',2.95),('15844','2013-05-06','13:35:00',3.85),('15844','2013-05-06','13:40:00',4.41),('15844','2013-05-06','13:45:00',4.37),('15844','2013-05-06','13:50:00',2.63),('15844','2013-05-06','13:55:00',3.29),('15844','2013-05-06','14:00:00',3.4),('15844','2013-05-06','14:05:00',2.54),('15844','2013-05-06','14:10:00',2.64),('15844','2013-05-06','14:15:00',3),('15844','2013-05-06','14:20:00',4.13),('15844','2013-05-06','14:25:00',2.98),('15844','2013-05-06','14:30:00',3.71),('15844','2013-05-06','14:35:00',2.73),('15844','2013-05-06','14:40:00',2.81),('15844','2013-05-06','14:45:00',3.57),('15844','2013-05-06','14:50:00',3.17),('15844','2013-05-06','14:55:00',2.26),('15844','2013-05-06','15:00:00',2.97),('15844','2013-05-06','15:05:00',1.64),('15844','2013-05-06','15:10:00',2.39),('15844','2013-05-06','15:15:00',1.83),('15844','2013-05-06','15:20:00',2.59),('15844','2013-05-06','15:25:00',2.45),('15844','2013-05-06','15:30:00',2.08),('15844','2013-05-06','15:35:00',2.13),('15844','2013-05-06','15:40:00',2.34),('15844','2013-05-06','15:45:00',2.11),('15844','2013-05-06','15:50:00',1.41),('15844','2013-05-06','15:55:00',1.67),('15844','2013-05-06','16:00:00',2.07),('15844','2013-05-06','16:05:00',1.41),('15844','2013-05-06','16:10:00',1.65),('15844','2013-05-06','16:15:00',1.9),('15844','2013-05-06','16:20:00',1.39),('15844','2013-05-06','16:25:00',1.68),('15844','2013-05-06','16:30:00',1.53),('15844','2013-05-06','16:40:00',1.39),('15844','2013-05-06','16:45:00',1.14),('15844','2013-05-06','17:10:00',1.21),('15844','2013-05-06','17:25:00',1.06),('15844','2013-05-05','08:20:00',1.11),('15844','2013-05-05','08:25:00',1.07),('15844','2013-05-05','08:30:00',1.14),('15844','2013-05-05','08:35:00',1.38),('15844','2013-05-05','08:40:00',1.59),('15844','2013-05-05','08:45:00',1.46),('15844','2013-05-05','08:50:00',1.33),('15844','2013-05-05','08:55:00',1.37),('15844','2013-05-05','09:00:00',1.48),('15844','2013-05-05','09:05:00',1.21),('15844','2013-05-05','09:10:00',1.22),('15844','2013-05-05','09:15:00',1.34),('15844','2013-05-05','09:20:00',1.75),('15844','2013-05-05','09:25:00',2.23),('15844','2013-05-05','09:30:00',2.13),('15844','2013-05-05','09:35:00',2.85),('15844','2013-05-05','09:40:00',2.84),('15844','2013-05-05','09:45:00',3.12),('15844','2013-05-05','09:50:00',2.7),('15844','2013-05-05','09:55:00',1.83),('15844','2013-05-05','10:00:00',1.84),('15844','2013-05-05','10:05:00',2.22),('15844','2013-05-05','10:10:00',2.55),('15844','2013-05-05','10:15:00',2.88),('15844','2013-05-05','10:20:00',3.22),('15844','2013-05-05','10:25:00',3.5),('15844','2013-05-05','10:30:00',2.4),('15844','2013-05-05','10:35:00',1.44),('15844','2013-05-05','10:40:00',1.23),('15844','2013-05-05','10:45:00',1.02),('15844','2013-05-05','11:00:00',1.23),('15844','2013-05-05','11:05:00',1.42),('15844','2013-05-05','11:10:00',3.82),('15844','2013-05-05','11:15:00',3.2),('15844','2013-05-05','11:20:00',1.69),('15844','2013-05-05','11:25:00',2.63),('15844','2013-05-05','11:30:00',2.32),('15844','2013-05-05','11:35:00',3.03),('15844','2013-05-05','11:40:00',4.24),('15844','2013-05-05','11:45:00',4.41),('15844','2013-05-05','11:50:00',3.46),('15844','2013-05-05','11:55:00',4.28),('15844','2013-05-05','12:00:00',4.77),('15844','2013-05-05','12:05:00',3.65),('15844','2013-05-05','12:10:00',4.44),('15844','2013-05-05','12:15:00',4.25),('15844','2013-05-05','12:20:00',4.31),('15844','2013-05-05','12:25:00',4.22),('15844','2013-05-05','12:30:00',3.73),('15844','2013-05-05','12:35:00',3.68),('15844','2013-05-05','12:40:00',3.38),('15844','2013-05-05','12:45:00',1.87),('15844','2013-05-05','12:50:00',2.23),('15844','2013-05-05','12:55:00',2.34),('15844','2013-05-05','13:00:00',2.77),('15844','2013-05-05','13:05:00',2.66),('15844','2013-05-05','13:10:00',1.45),('15844','2013-05-05','13:15:00',2.98),('15844','2013-05-05','13:20:00',3.84),('15844','2013-05-05','13:25:00',4.08),('15844','2013-05-05','13:30:00',4.21),('15844','2013-05-05','13:35:00',4),('15844','2013-05-05','13:40:00',1.88),('15844','2013-05-05','13:45:00',1.91),('15844','2013-05-05','13:50:00',3.65),('15844','2013-05-05','13:55:00',3.71),('15844','2013-05-05','14:00:00',3.92),('15844','2013-05-05','14:05:00',3.81),('15844','2013-05-05','14:10:00',3.78),('15844','2013-05-05','14:15:00',3.41),('15844','2013-05-05','14:20:00',3.14),('15844','2013-05-05','14:25:00',3.24),('15844','2013-05-05','14:30:00',3.13),('15844','2013-05-05','14:35:00',3.01),('15844','2013-05-05','14:40:00',2.91),('15844','2013-05-05','14:45:00',2.78),('15844','2013-05-05','14:50:00',2.64),('15844','2013-05-05','14:55:00',2.63),('15844','2013-05-05','15:00:00',2.56),('15844','2013-05-05','15:05:00',2.47),('15844','2013-05-05','15:10:00',2.39),('15844','2013-05-05','15:15:00',2.32),('15844','2013-05-05','15:20:00',2.24),('15844','2013-05-05','15:25:00',2.16),('15844','2013-05-05','15:30:00',2.08),('15844','2013-05-05','15:35:00',1.98),('15844','2013-05-05','15:40:00',1.91),('15844','2013-05-05','15:45:00',1.8),('15844','2013-05-05','15:50:00',1.7),('15844','2013-05-05','15:55:00',1.64),('15844','2013-05-05','16:00:00',1.55),('15844','2013-05-05','16:05:00',1.48),('15844','2013-05-05','16:10:00',1.41),('15844','2013-05-05','16:15:00',1.34),('15844','2013-05-05','16:20:00',1.28),('15844','2013-05-05','16:25:00',1.22),('15844','2013-05-05','16:30:00',1.14),('15844','2013-05-05','16:35:00',1.04),('15844','2013-05-04','08:25:00',1.09),('15844','2013-05-04','08:30:00',1.18),('15844','2013-05-04','08:35:00',1.26),('15844','2013-05-04','08:40:00',1.36),('15844','2013-05-04','08:45:00',1.43),('15844','2013-05-04','08:50:00',1.5),('15844','2013-05-04','08:55:00',1.55),('15844','2013-05-04','09:00:00',1.58),('15844','2013-05-04','09:05:00',1.7),('15844','2013-05-04','09:10:00',1.8),('15844','2013-05-04','09:15:00',1.88),('15844','2013-05-04','09:20:00',2),('15844','2013-05-04','09:25:00',2.13),('15844','2013-05-04','09:30:00',2.18),('15844','2013-05-04','09:35:00',2.21),('15844','2013-05-04','09:40:00',2.33),('15844','2013-05-04','09:45:00',2.38),('15844','2013-05-04','09:50:00',2.6),('15844','2013-05-04','09:55:00',2.79),('15844','2013-05-04','10:00:00',2.92),('15844','2013-05-04','10:05:00',2.93),('15844','2013-05-04','10:10:00',3.1),('15844','2013-05-04','10:15:00',3.19),('15844','2013-05-04','10:20:00',3.3),('15844','2013-05-04','10:25:00',3.37),('15844','2013-05-04','10:30:00',3.48),('15844','2013-05-04','10:35:00',3.47),('15844','2013-05-04','10:40:00',3.42),('15844','2013-05-04','10:45:00',3.43),('15844','2013-05-04','10:50:00',3.61),('15844','2013-05-04','10:55:00',3.71),('15844','2013-05-04','11:00:00',3.79),('15844','2013-05-04','11:05:00',3.8),('15844','2013-05-04','11:10:00',3.63),('15844','2013-05-04','11:15:00',3.34),('15844','2013-05-04','11:20:00',3.59),('15844','2013-05-04','11:25:00',3.68),('15844','2013-05-04','11:30:00',3.5),('15844','2013-05-04','11:35:00',3.55),('15844','2013-05-04','11:40:00',3.49),('15844','2013-05-04','11:45:00',3.46),('15844','2013-05-04','11:50:00',3.43),('15844','2013-05-04','11:55:00',3.46),('15844','2013-05-04','12:00:00',3.52),('15844','2013-05-04','12:05:00',3.45),('15844','2013-05-04','12:10:00',3.61),('15844','2013-05-04','12:15:00',3.76),('15844','2013-05-04','12:20:00',3.88),('15844','2013-05-04','12:25:00',3.88),('15844','2013-05-04','12:30:00',3.95),('15844','2013-05-04','12:35:00',3.9),('15844','2013-05-04','12:40:00',3.85),('15844','2013-05-04','12:45:00',3.84),('15844','2013-05-04','12:50:00',3.85),('15844','2013-05-04','12:55:00',3.71),('15844','2013-05-04','13:00:00',3.6),('15844','2013-05-04','13:05:00',3.6),('15844','2013-05-04','13:10:00',3.52),('15844','2013-05-04','13:15:00',3.69),('15844','2013-05-04','13:20:00',3.81),('15844','2013-05-04','13:25:00',3.71),('15844','2013-05-04','13:30:00',3.37),('15844','2013-05-04','13:35:00',3.46),('15844','2013-05-04','13:40:00',3.42),('15844','2013-05-04','13:45:00',3.19),('15844','2013-05-04','13:50:00',2.82),('15844','2013-05-04','13:55:00',3.29),('15844','2013-05-04','14:00:00',3.25),('15844','2013-05-04','14:05:00',3.12),('15844','2013-05-04','14:10:00',3.11),('15844','2013-05-04','14:15:00',3.12),('15844','2013-05-04','14:20:00',2.84),('15844','2013-05-04','14:25:00',2.8),('15844','2013-05-04','14:30:00',2.79),('15844','2013-05-04','14:35:00',2.55),('15844','2013-05-04','14:40:00',2.7),('15844','2013-05-04','14:45:00',2.45),('15844','2013-05-04','14:50:00',2.35),('15844','2013-05-04','14:55:00',2.38),('15844','2013-05-04','15:00:00',2.35),('15844','2013-05-04','15:05:00',2.27),('15844','2013-05-04','15:10:00',2.19),('15844','2013-05-04','15:15:00',2.23),('15844','2013-05-04','15:20:00',2.14),('15844','2013-05-04','15:25:00',2.11),('15844','2013-05-04','15:30:00',2.03),('15844','2013-05-04','15:35:00',1.86),('15844','2013-05-04','15:40:00',1.86),('15844','2013-05-04','15:45:00',1.74),('15844','2013-05-04','15:50:00',1.62),('15844','2013-05-04','15:55:00',1.55),('15844','2013-05-04','16:00:00',1.47),('15844','2013-05-04','16:05:00',1.38),('15844','2013-05-04','16:10:00',1.32),('15844','2013-05-04','16:15:00',1.27),('15844','2013-05-04','16:20:00',1.22),('15844','2013-05-04','16:25:00',1.16),('15844','2013-05-04','16:30:00',1.08),('15844','2013-05-03','08:25:00',1.02),('15844','2013-05-03','08:40:00',1),('15844','2013-05-03','08:45:00',1.22),('15844','2013-05-03','08:50:00',1.22),('15844','2013-05-03','08:55:00',1.18),('15844','2013-05-03','09:00:00',1.37),('15844','2013-05-03','09:05:00',1.65),('15844','2013-05-03','09:10:00',1.83),('15844','2013-05-03','09:15:00',1.97),('15844','2013-05-03','09:20:00',2.11),('15844','2013-05-03','09:25:00',2.24),('15844','2013-05-03','09:30:00',2.32),('15844','2013-05-03','09:35:00',2.39),('15844','2013-05-03','09:40:00',2.45),('15844','2013-05-03','09:45:00',2.49),('15844','2013-05-03','09:50:00',2.64),('15844','2013-05-03','09:55:00',2.83),('15844','2013-05-03','10:00:00',2.9),('15844','2013-05-03','10:05:00',3),('15844','2013-05-03','10:10:00',3.14),('15844','2013-05-03','10:15:00',3.26),('15844','2013-05-03','10:20:00',3.38),('15844','2013-05-03','10:25:00',3.5),('15844','2013-05-03','10:30:00',3.58),('15844','2013-05-03','10:35:00',3.63),('15844','2013-05-03','10:40:00',3.66),('15844','2013-05-03','10:45:00',3.83),('15844','2013-05-03','10:50:00',3.91),('15844','2013-05-03','10:55:00',3.95),('15844','2013-05-03','11:00:00',3.96),('15844','2013-05-03','11:05:00',4.02),('15844','2013-05-03','11:10:00',4.07),('15844','2013-05-03','11:15:00',4.11),('15844','2013-05-03','11:20:00',4.11),('15844','2013-05-03','11:25:00',4.16),('15844','2013-05-03','11:30:00',4.2),('15844','2013-05-03','11:35:00',4.19),('15844','2013-05-03','11:40:00',4.15),('15844','2013-05-03','11:45:00',4.17),('15844','2013-05-03','11:50:00',4.19),('15844','2013-05-03','11:55:00',4.18),('15844','2013-05-03','12:00:00',4.18),('15844','2013-05-03','12:05:00',4.18),('15844','2013-05-03','12:10:00',4.2),('15844','2013-05-03','12:15:00',4.19),('15844','2013-05-03','12:20:00',4.13),('15844','2013-05-03','12:25:00',4.12),('15844','2013-05-03','12:30:00',4.11),('15844','2013-05-03','12:35:00',4.11),('15844','2013-05-03','12:40:00',4.08),('15844','2013-05-03','12:45:00',3.91),('15844','2013-05-03','12:50:00',4.04),('15844','2013-05-03','12:55:00',4),('15844','2013-05-03','13:00:00',4.01),('15844','2013-05-03','13:05:00',4),('15844','2013-05-03','13:10:00',3.97),('15844','2013-05-03','13:15:00',3.94),('15844','2013-05-03','13:20:00',3.91),('15844','2013-05-03','13:25:00',3.9),('15844','2013-05-03','13:30:00',3.76),('15844','2013-05-03','13:35:00',3.69),('15844','2013-05-03','13:40:00',3.75),('15844','2013-05-03','13:45:00',3.71),('15844','2013-05-03','13:50:00',3.66),('15844','2013-05-03','13:55:00',3.63),('15844','2013-05-03','14:00:00',3.34),('15844','2013-05-03','14:05:00',3.24),('15844','2013-05-03','14:10:00',3.41),('15844','2013-05-03','14:15:00',3.29),('15844','2013-05-03','14:20:00',3.24),('15844','2013-05-03','14:25:00',3.16),('15844','2013-05-03','14:30:00',3.03),('15844','2013-05-03','14:35:00',2.9),('15844','2013-05-03','14:40:00',2.79),('15844','2013-05-03','14:45:00',2.69),('15844','2013-05-03','14:50:00',2.6),('15844','2013-05-03','14:55:00',2.51),('15844','2013-05-03','15:00:00',2.42),('15844','2013-05-03','15:05:00',2.35),('15844','2013-05-03','15:10:00',2.28),('15844','2013-05-03','15:15:00',2.22),('15844','2013-05-03','15:20:00',2.13),('15844','2013-05-03','15:25:00',2.08),('15844','2013-05-03','15:30:00',2.01),('15844','2013-05-03','15:35:00',1.91),('15844','2013-05-03','15:40:00',1.82),('15844','2013-05-03','15:45:00',1.72),('15844','2013-05-03','15:50:00',1.62),('15844','2013-05-03','15:55:00',1.54),('15844','2013-05-03','16:00:00',1.46),('15844','2013-05-03','16:05:00',1.37),('15844','2013-05-03','16:10:00',1.3),('15844','2013-05-03','16:15:00',1.24),('15844','2013-05-03','16:20:00',1.21),('15844','2013-05-03','16:25:00',1.18),('15844','2013-05-03','16:30:00',1.1),('15844','2013-05-03','16:35:00',1.01),('15844','2013-05-02','08:55:00',1.04),('15844','2013-05-02','09:25:00',1.3),('15844','2013-05-02','09:30:00',1.58),('15844','2013-05-02','09:35:00',1.26),('15844','2013-05-02','09:40:00',1.49),('15844','2013-05-02','09:45:00',1.35),('15844','2013-05-02','09:50:00',1.71),('15844','2013-05-02','09:55:00',1.15),('15844','2013-05-02','10:05:00',1.3),('15844','2013-05-02','10:15:00',2.81),('15844','2013-05-02','10:20:00',1.31),('15844','2013-05-02','10:25:00',1.95),('15844','2013-05-02','10:30:00',3.12),('15844','2013-05-02','10:35:00',3.81),('15844','2013-05-02','10:40:00',3.12),('15844','2013-05-02','10:45:00',2.44),('15844','2013-05-02','10:50:00',2.63),('15844','2013-05-02','10:55:00',3.15),('15844','2013-05-02','11:00:00',3.46),('15844','2013-05-02','11:05:00',4.21),('15844','2013-05-02','11:10:00',3.1),('15844','2013-05-02','11:15:00',3.17),('15844','2013-05-02','11:20:00',3.33),('15844','2013-05-02','11:25:00',4.04),('15844','2013-05-02','11:30:00',4.49),('15844','2013-05-02','11:35:00',4.22),('15844','2013-05-02','11:40:00',4.15),('15844','2013-05-02','11:45:00',4.15),('15844','2013-05-02','11:50:00',4.09),('15844','2013-05-02','11:55:00',4.09),('15844','2013-05-02','12:00:00',4.1),('15844','2013-05-02','12:05:00',4.07),('15844','2013-05-02','12:10:00',4.07),('15844','2013-05-02','12:15:00',4.04),('15844','2013-05-02','12:20:00',4.02),('15844','2013-05-02','12:25:00',3.98),('15844','2013-05-02','12:30:00',4.01),('15844','2013-05-02','12:35:00',2.87),('15844','2013-05-02','12:40:00',3.76),('15844','2013-05-02','12:45:00',4.09),('15844','2013-05-02','12:50:00',4.03),('15844','2013-05-02','12:55:00',4.09),('15844','2013-05-02','13:00:00',4.05),('15844','2013-05-02','13:05:00',4.05),('15844','2013-05-02','13:10:00',4.03),('15844','2013-05-02','13:15:00',4.01),('15844','2013-05-02','13:20:00',3.97),('15844','2013-05-02','13:25:00',3.94),('15844','2013-05-02','13:30:00',3.92),('15844','2013-05-02','13:35:00',3.87),('15844','2013-05-02','13:40:00',3.81),('15844','2013-05-02','13:45:00',3.77),('15844','2013-05-02','13:50:00',3.68),('15844','2013-05-02','13:55:00',3.57),('15844','2013-05-02','14:00:00',3.51),('15844','2013-05-02','14:05:00',3.48),('15844','2013-05-02','14:10:00',3.44),('15844','2013-05-02','14:15:00',3.37),('15844','2013-05-02','14:20:00',3.3),('15844','2013-05-02','14:25:00',3.19),('15844','2013-05-02','14:30:00',3.08),('15844','2013-05-02','14:35:00',2.98),('15844','2013-05-02','14:40:00',2.86),('15844','2013-05-02','14:45:00',2.73),('15844','2013-05-02','14:50:00',2.6),('15844','2013-05-02','14:55:00',2.49),('15844','2013-05-02','15:00:00',2.38),('15844','2013-05-02','15:05:00',2.33),('15844','2013-05-02','15:10:00',2.33),('15844','2013-05-02','15:15:00',2.27),('15844','2013-05-02','15:20:00',2.2),('15844','2013-05-02','15:25:00',2.12),('15844','2013-05-02','15:30:00',2.03),('15844','2013-05-02','15:35:00',1.95),('15844','2013-05-02','15:40:00',1.85),('15844','2013-05-02','15:45:00',1.73),('15844','2013-05-02','15:50:00',1.63),('15844','2013-05-02','15:55:00',1.56),('15844','2013-05-02','16:00:00',1.46),('15844','2013-05-02','16:05:00',1.36),('15844','2013-05-02','16:10:00',1.28),('15844','2013-05-02','16:15:00',1.26),('15844','2013-05-02','16:20:00',1.23),('15844','2013-05-02','16:25:00',1.19),('15844','2013-05-02','16:30:00',1.1),('15844','2013-05-02','16:35:00',1),('15844','2014-03-30','08:50:00',1.01),('15844','2014-03-30','08:55:00',1.04),('15844','2014-03-30','09:00:00',1.08),('15844','2014-03-30','09:05:00',1.14),('15844','2014-03-30','09:10:00',1.28),('15844','2014-03-30','09:15:00',1.39),('15844','2014-03-30','09:20:00',1.44),('15844','2014-03-30','09:25:00',1.68),('15844','2014-03-30','09:30:00',1.69),('15844','2014-03-30','09:35:00',1.78),('15844','2014-03-30','09:40:00',1.83),('15844','2014-03-30','09:45:00',1.94),('15844','2014-03-30','09:50:00',1.99),('15844','2014-03-30','09:55:00',2.13),('15844','2014-03-30','10:00:00',2.26),('15844','2014-03-30','10:05:00',2.45),('15844','2014-03-30','10:10:00',2.53),('15844','2014-03-30','10:15:00',2.55),('15844','2014-03-30','10:20:00',2.59),('15844','2014-03-30','10:25:00',2.66),('15844','2014-03-30','10:30:00',2.79),('15844','2014-03-30','10:35:00',2.82),('15844','2014-03-30','10:40:00',2.94),('15844','2014-03-30','10:45:00',2.97),('15844','2014-03-30','10:50:00',3),('15844','2014-03-30','10:55:00',3.05),('15844','2014-03-30','11:00:00',3.13),('15844','2014-03-30','11:05:00',3.05),('15844','2014-03-30','11:10:00',2.9),('15844','2014-03-30','11:15:00',2.87),('15844','2014-03-30','11:20:00',3.2),('15844','2014-03-30','11:25:00',3.28),('15844','2014-03-30','11:30:00',3.5),('15844','2014-03-30','11:35:00',3.65),('15844','2014-03-30','11:40:00',3.71),('15844','2014-03-30','11:45:00',3.68),('15844','2014-03-30','11:50:00',3.67),('15844','2014-03-30','11:55:00',3.68),('15844','2014-03-30','12:00:00',3.8),('15844','2014-03-30','12:05:00',3.76),('15844','2014-03-30','12:10:00',3.87),('15844','2014-03-30','12:15:00',3.87),('15844','2014-03-30','12:20:00',3.69),('15844','2014-03-30','12:25:00',3.78),('15844','2014-03-30','12:30:00',3.79),('15844','2014-03-30','12:35:00',3.73),('15844','2014-03-30','12:40:00',3.69),('15844','2014-03-30','12:45:00',3.65),('15844','2014-03-30','12:50:00',3.66),('15844','2014-03-30','12:55:00',3.65),('15844','2014-03-30','13:00:00',3.66),('15844','2014-03-30','13:05:00',3.64),('15844','2014-03-30','13:10:00',3.7),('15844','2014-03-30','13:15:00',3.72),('15844','2014-03-30','13:20:00',3.68),('15844','2014-03-30','13:25:00',3.68),('15844','2014-03-30','13:30:00',3.6),('15844','2014-03-30','13:35:00',3.59),('15844','2014-03-30','13:40:00',3.56),('15844','2014-03-30','13:45:00',3.49),('15844','2014-03-30','13:50:00',3.4),('15844','2014-03-30','13:55:00',3.34),('15844','2014-03-30','14:00:00',3.29),('15844','2014-03-30','14:05:00',2.92),('15844','2014-03-30','14:10:00',2.71),('15844','2014-03-30','14:15:00',2.76),('15844','2014-03-30','14:20:00',2.58),('15844','2014-03-30','14:25:00',2.14),('15844','2014-03-30','14:30:00',1.67),('15844','2014-03-30','14:35:00',1.51),('15844','2014-03-30','14:40:00',1.59),('15844','2014-03-30','14:45:00',1.53),('15844','2014-03-30','14:50:00',1.88),('15844','2014-03-30','14:55:00',2.05),('15844','2014-03-30','15:00:00',1.97),('15844','2014-03-30','15:05:00',1.94),('15844','2014-03-30','15:10:00',1.94),('15844','2014-03-30','15:15:00',1.88),('15844','2014-03-30','15:20:00',1.82),('15844','2014-03-30','15:25:00',1.7),('15844','2014-03-30','15:30:00',1.64),('15844','2014-03-30','15:35:00',1.53),('15844','2014-03-30','15:40:00',1.51),('15844','2014-03-30','15:45:00',1.49),('15844','2014-03-30','15:50:00',1.43),('15844','2014-03-30','15:55:00',1.41),('15844','2014-03-30','16:00:00',1.36),('15844','2014-03-30','16:05:00',1.3),('15844','2014-03-30','16:10:00',1.17),('15844','2014-03-30','16:15:00',1.12),('15844','2014-03-30','16:20:00',1.09),('15844','2013-05-01','08:30:00',1.02),('15844','2013-05-01','08:35:00',1.07),('15844','2013-05-01','08:40:00',1.13),('15844','2013-05-01','08:45:00',1.21),('15844','2013-05-01','08:50:00',1.29),('15844','2013-05-01','08:55:00',1.4),('15844','2013-05-01','09:00:00',1.51),('15844','2013-05-01','09:05:00',1.57),('15844','2013-05-01','09:10:00',1.64),('15844','2013-05-01','09:15:00',1.75),('15844','2013-05-01','09:20:00',1.84),('15844','2013-05-01','09:25:00',1.86),('15844','2013-05-01','09:30:00',1.98),('15844','2013-05-01','09:35:00',2.06),('15844','2013-05-01','09:40:00',2.19),('15844','2013-05-01','09:45:00',2.33),('15844','2013-05-01','09:50:00',2.39),('15844','2013-05-01','09:55:00',2.5),('15844','2013-05-01','10:00:00',2.6);
INSERT INTO `solarlogmod` VALUES ('15844','2013-05-01','10:05:00',2.72),('15844','2013-05-01','10:10:00',2.83),('15844','2013-05-01','10:15:00',2.94),('15844','2013-05-01','10:20:00',3.05),('15844','2013-05-01','10:25:00',3.13),('15844','2013-05-01','10:30:00',3.29),('15844','2013-05-01','10:35:00',3.41),('15844','2013-05-01','10:40:00',3.51),('15844','2013-05-01','10:45:00',3.6),('15844','2013-05-01','10:50:00',3.68),('15844','2013-05-01','10:55:00',3.75),('15844','2013-05-01','11:00:00',3.77),('15844','2013-05-01','11:05:00',3.75),('15844','2013-05-01','11:10:00',3.53),('15844','2013-05-01','11:15:00',3.86),('15844','2013-05-01','11:20:00',3.49),('15844','2013-05-01','11:25:00',3.64),('15844','2013-05-01','11:30:00',3.48),('15844','2013-05-01','11:35:00',3.43),('15844','2013-05-01','11:40:00',2.29),('15844','2013-05-01','11:45:00',3.74),('15844','2013-05-01','11:50:00',4.02),('15844','2013-05-01','11:55:00',3.96),('15844','2013-05-01','12:00:00',3.91),('15844','2013-05-01','12:05:00',3.9),('15844','2013-05-01','12:10:00',3.82),('15844','2013-05-01','12:15:00',3.8),('15844','2013-05-01','12:20:00',3.76),('15844','2013-05-01','12:25:00',3.79),('15844','2013-05-01','12:30:00',3.82),('15844','2013-05-01','12:35:00',3.87),('15844','2013-05-01','12:40:00',3.44),('15844','2013-05-01','12:45:00',2.26),('15844','2013-05-01','12:50:00',1.31),('15844','2013-05-01','12:55:00',1.18),('15844','2013-05-01','13:00:00',1.35),('15844','2013-05-01','13:05:00',2.11),('15844','2013-05-01','13:10:00',4.06),('15844','2013-05-01','13:15:00',4.22),('15844','2013-05-01','13:20:00',4.14),('15844','2013-05-01','13:25:00',3.02),('15844','2013-05-01','13:30:00',2.48),('15844','2013-05-01','13:35:00',4.16),('15844','2013-05-01','13:40:00',3.97),('15844','2013-05-01','13:45:00',3.51),('15844','2013-05-01','13:50:00',3.61),('15844','2013-05-01','13:55:00',3.48),('15844','2013-05-01','14:00:00',3.41),('15844','2013-05-01','14:05:00',3.23),('15844','2013-05-01','14:10:00',3.28),('15844','2013-05-01','14:15:00',2.91),('15844','2013-05-01','14:20:00',3.26),('15844','2013-05-01','14:25:00',3.15),('15844','2013-05-01','14:30:00',3.18),('15844','2013-05-01','14:35:00',2.95),('15844','2013-05-01','14:40:00',2.64),('15844','2013-05-01','14:45:00',2.78),('15844','2013-05-01','14:50:00',2.64),('15844','2013-05-01','14:55:00',2.09),('15844','2013-05-01','15:00:00',1.84),('15844','2013-05-01','15:05:00',2.43),('15844','2013-05-01','15:10:00',2.5),('15844','2013-05-01','15:15:00',2.33),('15844','2013-05-01','15:20:00',2.12),('15844','2013-05-01','15:25:00',1.84),('15844','2013-05-01','15:30:00',1.56),('15844','2013-05-01','15:35:00',1.53),('15844','2013-05-01','15:40:00',1.6),('15844','2013-05-01','15:45:00',1.5),('15844','2013-05-01','15:50:00',1.33),('15844','2013-05-01','15:55:00',1.36),('15844','2013-05-01','16:00:00',1.48),('15844','2013-05-01','16:05:00',1.4),('15844','2013-05-01','16:10:00',1.29),('15844','2013-05-01','16:15:00',1.22),('15844','2013-05-01','16:20:00',1.11),('15844','2013-04-30','08:50:00',1.28),('15844','2013-04-30','08:55:00',1.42),('15844','2013-04-30','09:00:00',1.53),('15844','2013-04-30','09:05:00',1.17),('15844','2013-04-30','09:10:00',1.63),('15844','2013-04-30','09:15:00',1.85),('15844','2013-04-30','09:20:00',1.7),('15844','2013-04-30','09:25:00',1.8),('15844','2013-04-30','09:30:00',1.73),('15844','2013-04-30','09:35:00',1.95),('15844','2013-04-30','09:40:00',1.75),('15844','2013-04-30','09:45:00',1.88),('15844','2013-04-30','09:50:00',2.32),('15844','2013-04-30','09:55:00',2.74),('15844','2013-04-30','10:00:00',2.83),('15844','2013-04-30','10:05:00',2.13),('15844','2013-04-30','10:10:00',2.13),('15844','2013-04-30','10:15:00',1.99),('15844','2013-04-30','10:20:00',1.66),('15844','2013-04-30','10:25:00',2),('15844','2013-04-30','10:30:00',2.14),('15844','2013-04-30','10:35:00',1.55),('15844','2013-04-30','10:40:00',1.39),('15844','2013-04-30','10:45:00',1.4),('15844','2013-04-30','10:50:00',1.34),('15844','2013-04-30','10:55:00',1.68),('15844','2013-04-30','11:00:00',2.02),('15844','2013-04-30','11:05:00',1.98),('15844','2013-04-30','11:10:00',2.28),('15844','2013-04-30','11:15:00',2.26),('15844','2013-04-30','11:20:00',2.26),('15844','2013-04-30','11:25:00',2.07),('15844','2013-04-30','11:30:00',2.08),('15844','2013-04-30','11:35:00',2.02),('15844','2013-04-30','11:40:00',1.64),('15844','2013-04-30','11:45:00',1.29),('15844','2013-04-30','11:50:00',1.32),('15844','2013-04-30','11:55:00',1.36),('15844','2013-04-30','12:00:00',1.71),('15844','2013-04-30','12:05:00',1.49),('15844','2013-04-30','12:10:00',1.62),('15844','2013-04-30','12:15:00',1.77),('15844','2013-04-30','12:20:00',1.75),('15844','2013-04-30','12:25:00',1.35),('15844','2013-04-30','12:30:00',1.56),('15844','2013-04-30','12:35:00',2.97),('15844','2013-04-30','12:40:00',4.53),('15844','2013-04-30','12:45:00',4.04),('15844','2013-04-30','12:50:00',3.72),('15844','2013-04-30','12:55:00',3.69),('15844','2013-04-30','13:00:00',3.85),('15844','2013-04-30','13:05:00',3.89),('15844','2013-04-30','13:10:00',3.83),('15844','2013-04-30','13:15:00',3.76),('15844','2013-04-30','13:20:00',3.7),('15844','2013-04-30','13:25:00',3.65),('15844','2013-04-30','13:30:00',3.6),('15844','2013-04-30','13:35:00',3.58),('15844','2013-04-30','13:40:00',3.55),('15844','2013-04-30','13:45:00',3.48),('15844','2013-04-30','13:50:00',3.42),('15844','2013-04-30','13:55:00',3.35),('15844','2013-04-30','14:00:00',3.31),('15844','2013-04-30','14:05:00',3.25),('15844','2013-04-30','14:10:00',3.2),('15844','2013-04-30','14:15:00',3.13),('15844','2013-04-30','14:20:00',3.06),('15844','2013-04-30','14:25:00',3),('15844','2013-04-30','14:30:00',2.9),('15844','2013-04-30','14:35:00',2.8),('15844','2013-04-30','14:40:00',2.69),('15844','2013-04-30','14:45:00',2.59),('15844','2013-04-30','14:50:00',2.5),('15844','2013-04-30','14:55:00',2.39),('15844','2013-04-30','15:00:00',2.3),('15844','2013-04-30','15:05:00',2.19),('15844','2013-04-30','15:10:00',2.13),('15844','2013-04-30','15:15:00',2.05),('15844','2013-04-30','15:20:00',1.98),('15844','2013-04-30','15:25:00',1.93),('15844','2013-04-30','15:30:00',1.88),('15844','2013-04-30','15:35:00',1.8),('15844','2013-04-30','15:40:00',1.73),('15844','2013-04-30','15:45:00',1.67),('15844','2013-04-30','15:50:00',1.61),('15844','2013-04-30','15:55:00',1.54),('15844','2013-04-30','16:00:00',1.49),('15844','2013-04-30','16:05:00',1.41),('15844','2013-04-30','16:10:00',1.34),('15844','2013-04-30','16:15:00',1.29),('15844','2013-04-30','16:20:00',1.26),('15844','2013-04-30','16:25:00',1.22),('15844','2013-04-30','16:30:00',1.07),('15844','2013-04-30','16:35:00',1.12),('15844','2013-04-30','16:40:00',1.03),('15844','2013-04-29','08:20:00',1.04),('15844','2013-04-29','08:25:00',1.21),('15844','2013-04-29','08:30:00',1.37),('15844','2013-04-29','08:35:00',1.4),('15844','2013-04-29','08:40:00',1.34),('15844','2013-04-29','08:45:00',1.45),('15844','2013-04-29','08:50:00',1.55),('15844','2013-04-29','08:55:00',1.56),('15844','2013-04-29','09:00:00',1.58),('15844','2013-04-29','09:05:00',1.84),('15844','2013-04-29','09:10:00',1.9),('15844','2013-04-29','09:15:00',1.79),('15844','2013-04-29','09:20:00',1.88),('15844','2013-04-29','09:25:00',2),('15844','2013-04-29','09:30:00',1.94),('15844','2013-04-29','09:35:00',2.05),('15844','2013-04-29','09:40:00',2.04),('15844','2013-04-29','09:45:00',2.29),('15844','2013-04-29','09:50:00',2.21),('15844','2013-04-29','09:55:00',2.33),('15844','2013-04-29','10:00:00',2.58),('15844','2013-04-29','10:05:00',2.49),('15844','2013-04-29','10:10:00',2.24),('15844','2013-04-29','10:15:00',2.54),('15844','2013-04-29','10:20:00',3.18),('15844','2013-04-29','10:25:00',3.13),('15844','2013-04-29','10:30:00',3.11),('15844','2013-04-29','10:35:00',3.04),('15844','2013-04-29','10:40:00',2.98),('15844','2013-04-29','10:45:00',2.86),('15844','2013-04-29','10:50:00',3.14),('15844','2013-04-29','10:55:00',3.21),('15844','2013-04-29','11:00:00',3.14),('15844','2013-04-29','11:05:00',2.93),('15844','2013-04-29','11:10:00',3.34),('15844','2013-04-29','11:15:00',3.59),('15844','2013-04-29','11:20:00',3.9),('15844','2013-04-29','11:25:00',3.76),('15844','2013-04-29','11:30:00',3.69),('15844','2013-04-29','11:35:00',3.63),('15844','2013-04-29','11:40:00',3.24),('15844','2013-04-29','11:45:00',3.79),('15844','2013-04-29','11:50:00',3.75),('15844','2013-04-29','11:55:00',4.01),('15844','2013-04-29','12:00:00',3.96),('15844','2013-04-29','12:05:00',3.87),('15844','2013-04-29','12:10:00',3.89),('15844','2013-04-29','12:15:00',3.93),('15844','2013-04-29','12:20:00',3.94),('15844','2013-04-29','12:25:00',4.01),('15844','2013-04-29','12:30:00',3.97),('15844','2013-04-29','12:35:00',3.89),('15844','2013-04-29','12:40:00',3.82),('15844','2013-04-29','12:45:00',3.71),('15844','2013-04-29','12:50:00',3.62),('15844','2013-04-29','12:55:00',3.68),('15844','2013-04-29','13:00:00',3.68),('15844','2013-04-29','13:05:00',3.5),('15844','2013-04-29','13:10:00',3.33),('15844','2013-04-29','13:15:00',3.38),('15844','2013-04-29','13:20:00',3.82),('15844','2013-04-29','13:25:00',3.79),('15844','2013-04-29','13:30:00',3.69),('15844','2013-04-29','13:35:00',3.64),('15844','2013-04-29','13:40:00',3.46),('15844','2013-04-29','13:45:00',3.29),('15844','2013-04-29','13:50:00',3.3),('15844','2013-04-29','13:55:00',3.41),('15844','2013-04-29','14:00:00',3.17),('15844','2013-04-29','14:05:00',3.32),('15844','2013-04-29','14:10:00',3.32),('15844','2013-04-29','14:15:00',3.34),('15844','2013-04-29','14:20:00',3.16),('15844','2013-04-29','14:25:00',2.9),('15844','2013-04-29','14:30:00',2.8),('15844','2013-04-29','14:35:00',2.67),('15844','2013-04-29','14:40:00',2.66),('15844','2013-04-29','14:45:00',2.71),('15844','2013-04-29','14:50:00',2.53),('15844','2013-04-29','14:55:00',2.38),('15844','2013-04-29','15:00:00',2.24),('15844','2013-04-29','15:05:00',2.08),('15844','2013-04-29','15:10:00',2.34),('15844','2013-04-29','15:15:00',2.23),('15844','2013-04-29','15:20:00',2.17),('15844','2013-04-29','15:25:00',1.98),('15844','2013-04-29','15:30:00',1.77),('15844','2013-04-29','15:35:00',1.73),('15844','2013-04-29','15:40:00',1.59),('15844','2013-04-29','15:45:00',1.57),('15844','2013-04-29','15:50:00',1.63),('15844','2013-04-29','15:55:00',1.67),('15844','2013-04-29','16:00:00',1.69),('15844','2013-04-29','16:05:00',1.72),('15844','2013-04-29','16:10:00',1.7),('15844','2013-04-29','16:15:00',1.65),('15844','2013-04-29','16:20:00',1.38),('15844','2013-04-29','16:25:00',1.42),('15844','2013-04-29','16:30:00',1.36),('15844','2013-04-29','16:35:00',1.39),('15844','2013-04-29','16:40:00',1.21),('15844','2013-04-29','16:45:00',1.13),('15844','2013-04-29','16:50:00',1.04),('15844','2013-04-28','08:25:00',1.07),('15844','2013-04-28','08:30:00',1.19),('15844','2013-04-28','08:35:00',1.28),('15844','2013-04-28','08:40:00',1.34),('15844','2013-04-28','08:45:00',1.41),('15844','2013-04-28','08:50:00',1.5),('15844','2013-04-28','08:55:00',1.57),('15844','2013-04-28','09:00:00',1.65),('15844','2013-04-28','09:05:00',1.75),('15844','2013-04-28','09:10:00',1.84),('15844','2013-04-28','09:15:00',1.96),('15844','2013-04-28','09:20:00',2.09),('15844','2013-04-28','09:25:00',2.21),('15844','2013-04-28','09:30:00',2.3),('15844','2013-04-28','09:35:00',2.38),('15844','2013-04-28','09:40:00',2.45),('15844','2013-04-28','09:45:00',2.49),('15844','2013-04-28','09:50:00',2.6),('15844','2013-04-28','09:55:00',2.8),('15844','2013-04-28','10:00:00',2.9),('15844','2013-04-28','10:05:00',2.96),('15844','2013-04-28','10:10:00',3.07),('15844','2013-04-28','10:15:00',3.23),('15844','2013-04-28','10:20:00',3.33),('15844','2013-04-28','10:25:00',3.17),('15844','2013-04-28','10:30:00',3.24),('15844','2013-04-28','10:35:00',3.6),('15844','2013-04-28','10:40:00',3.23),('15844','2013-04-28','10:45:00',3.75),('15844','2013-04-28','10:50:00',3.9),('15844','2013-04-28','10:55:00',3.97),('15844','2013-04-28','11:00:00',4.02),('15844','2013-04-28','11:05:00',4.09),('15844','2013-04-28','11:10:00',4.02),('15844','2013-04-28','11:15:00',4.15),('15844','2013-04-28','11:20:00',4.07),('15844','2013-04-28','11:25:00',4.15),('15844','2013-04-28','11:30:00',4.13),('15844','2013-04-28','11:35:00',3.89),('15844','2013-04-28','11:40:00',3.9),('15844','2013-04-28','11:45:00',3.78),('15844','2013-04-28','11:50:00',3.91),('15844','2013-04-28','11:55:00',3.51),('15844','2013-04-28','12:00:00',3.34),('15844','2013-04-28','12:05:00',3.46),('15844','2013-04-28','12:10:00',3.69),('15844','2013-04-28','12:15:00',3.48),('15844','2013-04-28','12:20:00',3.69),('15844','2013-04-28','12:25:00',3.63),('15844','2013-04-28','12:30:00',3.44),('15844','2013-04-28','12:35:00',3.47),('15844','2013-04-28','12:40:00',2.87),('15844','2013-04-28','12:45:00',3.57),('15844','2013-04-28','12:50:00',3.84),('15844','2013-04-28','12:55:00',3.63),('15844','2013-04-28','13:00:00',3.73),('15844','2013-04-28','13:10:00',2.33),('15844','2013-04-28','13:15:00',3.38),('15844','2013-04-28','13:20:00',3.73),('15844','2013-04-28','13:25:00',3.36),('15844','2013-04-28','13:30:00',3.52),('15844','2013-04-28','13:35:00',3.94),('15844','2013-04-28','13:40:00',3.76),('15844','2013-04-28','13:45:00',3.64),('15844','2013-04-28','13:50:00',3.67),('15844','2013-04-28','13:55:00',3.66),('15844','2013-04-28','14:00:00',3.61),('15844','2013-04-28','14:05:00',3.49),('15844','2013-04-28','14:10:00',3.4),('15844','2013-04-28','14:15:00',3.32),('15844','2013-04-28','14:20:00',2.31),('15844','2013-04-28','14:25:00',3.03),('15844','2013-04-28','14:30:00',3.09),('15844','2013-04-28','14:35:00',2.99),('15844','2013-04-28','14:40:00',2.8),('15844','2013-04-28','14:45:00',2.33),('15844','2013-04-28','14:50:00',2.52),('15844','2013-04-28','14:55:00',2.56),('15844','2013-04-28','15:00:00',2.54),('15844','2013-04-28','15:05:00',2.42),('15844','2013-04-28','15:10:00',2.35),('15844','2013-04-28','15:15:00',2.26),('15844','2013-04-28','15:20:00',2.18),('15844','2013-04-28','15:25:00',2.09),('15844','2013-04-28','15:30:00',2),('15844','2013-04-28','15:35:00',1.9),('15844','2013-04-28','15:40:00',1.8),('15844','2013-04-28','15:45:00',1.7),('15844','2013-04-28','15:50:00',1.6),('15844','2013-04-28','15:55:00',1.5),('15844','2013-04-28','16:00:00',1.41),('15844','2013-04-28','16:05:00',1.3),('15844','2013-04-28','16:10:00',1.2),('15844','2013-04-28','16:15:00',1.21),('15844','2013-04-28','16:20:00',1.14),('15844','2013-04-28','16:25:00',1.07),('15844','2013-04-27','12:55:00',1.19),('15844','2013-04-27','13:10:00',1.02),('15844','2013-04-27','13:15:00',1.87),('15844','2013-04-27','13:20:00',1.61),('15844','2013-04-27','14:30:00',1.69),('15844','2013-04-27','14:35:00',1.38),('15844','2013-04-27','16:50:00',1.01),('15844','2013-04-27','16:55:00',1.09),('15844','2013-04-27','17:00:00',1.3),('15844','2013-04-26','08:35:00',1.03),('15844','2013-04-26','08:40:00',1.08),('15844','2013-04-26','08:45:00',1.3),('15844','2013-04-26','08:50:00',1.45),('15844','2013-04-26','08:55:00',1.32),('15844','2013-04-26','09:00:00',1.35),('15844','2013-04-26','09:05:00',1.17),('15844','2013-04-26','09:10:00',1.22),('15844','2013-04-26','09:15:00',1.49),('15844','2013-04-26','09:20:00',1.67),('15844','2013-04-26','09:25:00',1.95),('15844','2013-04-26','09:30:00',1.67),('15844','2013-04-26','09:35:00',2.13),('15844','2013-04-26','09:40:00',1.97),('15844','2013-04-26','09:45:00',1.19),('15844','2013-04-26','09:50:00',1.95),('15844','2013-04-26','09:55:00',1.63),('15844','2013-04-26','10:00:00',2.45),('15844','2013-04-26','10:05:00',2.77),('15844','2013-04-26','10:10:00',2.81),('15844','2013-04-26','10:15:00',2.95),('15844','2013-04-26','10:20:00',2.98),('15844','2013-04-26','10:25:00',3.23),('15844','2013-04-26','10:30:00',3.34),('15844','2013-04-26','10:35:00',3.43),('15844','2013-04-26','10:40:00',3.17),('15844','2013-04-26','10:45:00',2.44),('15844','2013-04-26','10:50:00',3.23),('15844','2013-04-26','10:55:00',3.73),('15844','2013-04-26','11:00:00',3.7),('15844','2013-04-26','11:05:00',3.7),('15844','2013-04-26','11:10:00',3.68),('15844','2013-04-26','11:15:00',3.83),('15844','2013-04-26','11:20:00',3.59),('15844','2013-04-26','11:25:00',2.93),('15844','2013-04-26','11:30:00',3.9),('15844','2013-04-26','11:35:00',3.39),('15844','2013-04-26','11:40:00',2.78),('15844','2013-04-26','11:45:00',2.98),('15844','2013-04-26','11:50:00',3.55),('15844','2013-04-26','11:55:00',3.06),('15844','2013-04-26','12:00:00',2.25),('15844','2013-04-26','12:05:00',2.57),('15844','2013-04-26','12:10:00',2.33),('15844','2013-04-26','12:15:00',1.84),('15844','2013-04-26','12:20:00',2.05),('15844','2013-04-26','12:25:00',1.42),('15844','2013-04-26','12:30:00',1.48),('15844','2013-04-26','12:35:00',1.79),('15844','2013-04-26','12:40:00',1.98),('15844','2013-04-26','12:45:00',2.38),('15844','2013-04-26','12:50:00',1.66),('15844','2013-04-26','12:55:00',1.08),('15844','2013-04-26','13:05:00',1.03),('15844','2013-04-26','13:10:00',1.66),('15844','2013-04-26','13:15:00',2.03),('15844','2013-04-26','13:20:00',2.78),('15844','2013-04-26','13:25:00',3.7),('15844','2013-04-26','13:30:00',2.67),('15844','2013-04-26','13:35:00',2.11),('15844','2013-04-26','13:40:00',1.98),('15844','2013-04-26','13:45:00',2.84),('15844','2013-04-26','13:50:00',2.91),('15844','2013-04-26','13:55:00',2.33),('15844','2013-04-26','14:00:00',1.97),('15844','2013-04-26','14:05:00',2.07),('15844','2013-04-26','14:10:00',2.36),('15844','2013-04-26','14:15:00',1.96),('15844','2013-04-26','14:20:00',2.08),('15844','2013-04-26','14:25:00',2.62),('15844','2013-04-26','14:30:00',1.84),('15844','2013-04-26','14:35:00',1.71),('15844','2013-04-26','14:40:00',1.23),('15844','2013-04-26','14:45:00',1.09),('15844','2013-04-26','14:50:00',1.11),('15844','2013-04-26','14:55:00',1.74),('15844','2013-04-26','15:00:00',2.4),('15844','2013-04-26','15:05:00',2.2),('15844','2013-04-26','15:10:00',2.63),('15844','2013-04-26','15:15:00',1.77),('15844','2013-04-26','15:20:00',1.27),('15844','2013-04-26','15:25:00',1.78),('15844','2013-04-26','15:30:00',2.74),('15844','2013-04-26','15:35:00',2.56),('15844','2013-04-26','15:40:00',1.94),('15844','2013-04-26','15:45:00',1.94),('15844','2013-04-26','15:50:00',1.34),('15844','2013-04-25','08:40:00',1.08),('15844','2013-04-25','08:45:00',1.47),('15844','2013-04-25','08:50:00',1.57),('15844','2013-04-25','08:55:00',1.32),('15844','2013-04-25','09:00:00',1.05),('15844','2013-04-25','09:05:00',1.14),('15844','2013-04-25','09:10:00',1.08),('15844','2013-04-25','09:15:00',1.1),('15844','2013-04-25','09:20:00',1.1),('15844','2013-04-25','09:25:00',1.12),('15844','2013-04-25','09:30:00',1.37),('15844','2013-04-25','09:35:00',1.74),('15844','2013-04-25','09:40:00',2.22),('15844','2013-04-25','09:45:00',2.49),('15844','2013-04-25','09:50:00',2.66),('15844','2013-04-25','09:55:00',2.67),('15844','2013-04-25','10:00:00',2.62),('15844','2013-04-25','10:05:00',2.49),('15844','2013-04-25','10:10:00',2.95),('15844','2013-04-25','10:15:00',3.09),('15844','2013-04-25','10:20:00',3.26),('15844','2013-04-25','10:25:00',3.26),('15844','2013-04-25','10:30:00',3.3),('15844','2013-04-25','10:35:00',3.38),('15844','2013-04-25','10:40:00',3.45),('15844','2013-04-25','10:45:00',3.57),('15844','2013-04-25','10:50:00',3.66),('15844','2013-04-25','10:55:00',3.75),('15844','2013-04-25','11:00:00',3.79),('15844','2013-04-25','11:05:00',3.81),('15844','2013-04-25','11:10:00',3.85),('15844','2013-04-25','11:15:00',3.89),('15844','2013-04-25','11:20:00',3.92),('15844','2013-04-25','11:25:00',3.9),('15844','2013-04-25','11:30:00',3.98),('15844','2013-04-25','11:35:00',4.01),('15844','2013-04-25','11:40:00',4.01),('15844','2013-04-25','11:45:00',4.02),('15844','2013-04-25','11:50:00',4.04),('15844','2013-04-25','11:55:00',4.01),('15844','2013-04-25','12:00:00',3.96),('15844','2013-04-25','12:05:00',3.91),('15844','2013-04-25','12:10:00',3.96),('15844','2013-04-25','12:15:00',3.97),('15844','2013-04-25','12:20:00',3.95),('15844','2013-04-25','12:25:00',3.88),('15844','2013-04-25','12:30:00',3.83),('15844','2013-04-25','12:35:00',3.91),('15844','2013-04-25','12:40:00',3.89),('15844','2013-04-25','12:45:00',3.88),('15844','2013-04-25','12:50:00',3.85),('15844','2013-04-25','12:55:00',3.83),('15844','2013-04-25','13:00:00',3.86),('15844','2013-04-25','13:05:00',3.87),('15844','2013-04-25','13:10:00',3.83),('15844','2013-04-25','13:15:00',3.02),('15844','2013-04-25','13:20:00',2.73),('15844','2013-04-25','13:25:00',2.85),('15844','2013-04-25','13:30:00',2.54),('15844','2013-04-25','13:35:00',2.06),('15844','2013-04-25','13:40:00',1.95),('15844','2013-04-25','13:45:00',1.88),('15844','2013-04-25','13:50:00',1.82),('15844','2013-04-25','13:55:00',2.02),('15844','2013-04-25','14:00:00',1.89),('15844','2013-04-25','14:05:00',1.86),('15844','2013-04-25','14:10:00',1.99),('15844','2013-04-25','14:15:00',2.18),('15844','2013-04-25','14:20:00',2.89),('15844','2013-04-25','14:25:00',2.64),('15844','2013-04-25','14:30:00',3.16),('15844','2013-04-25','14:35:00',3.03),('15844','2013-04-25','14:40:00',2.88),('15844','2013-04-25','14:45:00',2.61),('15844','2013-04-25','14:50:00',2.43),('15844','2013-04-25','14:55:00',2.19),('15844','2013-04-25','15:00:00',2.29),('15844','2013-04-25','15:05:00',1.84),('15844','2013-04-25','15:10:00',1.94),('15844','2013-04-25','15:15:00',2.17),('15844','2013-04-25','15:20:00',2.12),('15844','2013-04-25','15:25:00',2.16),('15844','2013-04-25','15:30:00',1.91),('15844','2013-04-25','15:35:00',1.79),('15844','2013-04-25','15:40:00',1.71),('15844','2013-04-25','15:45:00',1.62),('15844','2013-04-25','15:50:00',1.43),('15844','2013-04-25','15:55:00',1.43),('15844','2013-04-25','16:00:00',1.64),('15844','2013-04-25','16:05:00',1.78),('15844','2013-04-25','16:10:00',1.4),('15844','2013-04-25','16:15:00',1.22),('15844','2013-04-25','16:20:00',1.61),('15844','2013-04-25','16:25:00',1.56),('15844','2013-04-25','16:30:00',1.45),('15844','2013-04-25','16:35:00',1.28),('15844','2013-04-25','16:40:00',1.29),('15844','2013-04-25','16:45:00',1.16),('15844','2013-04-25','16:50:00',1.01),('15844','2013-04-25','16:55:00',1.11),('15844','2013-04-25','17:00:00',1.11),('15844','2013-04-25','17:05:00',1.01),('15844','2013-04-24','08:40:00',1.07),('15844','2013-04-24','08:45:00',1.26),('15844','2013-04-24','08:50:00',1.25),('15844','2013-04-24','08:55:00',1.4),('15844','2013-04-24','09:00:00',1.66),('15844','2013-04-24','09:05:00',1.8),('15844','2013-04-24','09:10:00',2.09),('15844','2013-04-24','09:15:00',1.92),('15844','2013-04-24','09:20:00',1.43),('15844','2013-04-24','09:25:00',1.68),('15844','2013-04-24','09:30:00',2.17),('15844','2013-04-24','09:35:00',2.04),('15844','2013-04-24','09:40:00',2.29),('15844','2013-04-24','09:45:00',2.36),('15844','2013-04-24','09:50:00',2.65),('15844','2013-04-24','09:55:00',2.95),('15844','2013-04-24','10:00:00',2.99),('15844','2013-04-24','10:05:00',2.94),('15844','2013-04-24','10:10:00',2.56),('15844','2013-04-24','10:15:00',2.99),('15844','2013-04-24','10:20:00',3.24),('15844','2013-04-24','10:25:00',3.22),('15844','2013-04-24','10:30:00',3.2),('15844','2013-04-24','10:35:00',3.25),('15844','2013-04-24','10:40:00',3.58),('15844','2013-04-24','10:45:00',3.66),('15844','2013-04-24','10:50:00',3.79),('15844','2013-04-24','10:55:00',3.89),('15844','2013-04-24','11:00:00',3.78),('15844','2013-04-24','11:05:00',3.95),('15844','2013-04-24','11:10:00',4.13),('15844','2013-04-24','11:15:00',4.14),('15844','2013-04-24','11:20:00',4.29),('15844','2013-04-24','11:25:00',4.27),('15844','2013-04-24','11:30:00',3.46),('15844','2013-04-24','11:35:00',2.78),('15844','2013-04-24','11:40:00',2.92),('15844','2013-04-24','11:45:00',2.12),('15844','2013-04-24','11:50:00',2.02),('15844','2013-04-24','11:55:00',2.52),('15844','2013-04-24','12:00:00',2.66),('15844','2013-04-24','12:05:00',3.03),('15844','2013-04-24','12:10:00',2.59),('15844','2013-04-24','12:15:00',3.77),('15844','2013-04-24','12:20:00',3.49),('15844','2013-04-24','12:25:00',3.3),('15844','2013-04-24','12:30:00',3.58),('15844','2013-04-24','12:35:00',3.35),('15844','2013-04-24','12:40:00',3.54),('15844','2013-04-24','12:45:00',3.86),('15844','2013-04-24','12:50:00',3.66),('15844','2013-04-24','12:55:00',3.63),('15844','2013-04-24','13:00:00',2.89),('15844','2013-04-24','13:05:00',3.82),('15844','2013-04-24','13:10:00',3.71),('15844','2013-04-24','13:15:00',3.44),('15844','2013-04-24','13:20:00',3.16),('15844','2013-04-24','13:25:00',3.45),('15844','2013-04-24','13:30:00',2.8),('15844','2013-04-24','13:35:00',3.51),('15844','2013-04-24','13:40:00',3.44),('15844','2013-04-24','13:45:00',1.99),('15844','2013-04-24','13:50:00',3.26),('15844','2013-04-24','13:55:00',3.52),('15844','2013-04-24','14:00:00',2.42),('15844','2013-04-24','14:05:00',2.16),('15844','2013-04-24','14:10:00',3.24),('15844','2013-04-24','14:15:00',2.95),('15844','2013-04-24','14:20:00',3.16),('15844','2013-04-24','14:25:00',3.07),('15844','2013-04-24','14:30:00',2.66),('15844','2013-04-24','14:35:00',2.44),('15844','2013-04-24','14:40:00',2.13),('15844','2013-04-24','14:45:00',2.05),('15844','2013-04-24','14:50:00',1.71),('15844','2013-04-24','14:55:00',1.86),('15844','2013-04-24','15:00:00',1.78),('15844','2013-04-24','15:05:00',1.72),('15844','2013-04-24','15:10:00',1.69),('15844','2013-04-24','15:15:00',1.76),('15844','2013-04-24','15:20:00',1.63),('15844','2013-04-24','15:25:00',1.41),('15844','2013-04-24','15:30:00',1.36),('15844','2013-04-24','15:35:00',1.33),('15844','2013-04-24','15:40:00',1.33),('15844','2013-04-24','15:45:00',1.37),('15844','2013-04-24','15:50:00',1.46),('15844','2013-04-24','15:55:00',1.59),('15844','2013-04-24','16:00:00',1.69),('15844','2013-04-24','16:05:00',1.65),('15844','2013-04-24','16:10:00',1.61),('15844','2013-04-24','16:15:00',1.92),('15844','2013-04-24','16:20:00',1.6),('15844','2013-04-24','16:25:00',1.36),('15844','2013-04-24','16:30:00',1),('15844','2013-04-24','16:35:00',1.23),('15844','2013-04-24','16:40:00',1.27),('15844','2013-04-24','16:45:00',1.18),('15844','2013-04-24','16:50:00',1.17),('15844','2013-04-24','16:55:00',1.09),('15844','2013-04-23','08:25:00',1.03),('15844','2013-04-23','08:30:00',1.17),('15844','2013-04-23','08:35:00',1.29),('15844','2013-04-23','08:40:00',1.36),('15844','2013-04-23','08:45:00',1.43),('15844','2013-04-23','08:50:00',1.51),('15844','2013-04-23','08:55:00',1.6),('15844','2013-04-23','09:00:00',1.66),('15844','2013-04-23','09:05:00',1.76),('15844','2013-04-23','09:10:00',1.85),('15844','2013-04-23','09:15:00',1.98),('15844','2013-04-23','09:20:00',2.13),('15844','2013-04-23','09:25:00',2.27),('15844','2013-04-23','09:30:00',2.36),('15844','2013-04-23','09:35:00',2.44),('15844','2013-04-23','09:40:00',2.51),('15844','2013-04-23','09:45:00',2.31),('15844','2013-04-23','09:50:00',2.37),('15844','2013-04-23','09:55:00',2.67),('15844','2013-04-23','10:00:00',2.94),('15844','2013-04-23','10:05:00',3.05),('15844','2013-04-23','10:10:00',3.17),('15844','2013-04-23','10:15:00',3.3),('15844','2013-04-23','10:20:00',3.4),('15844','2013-04-23','10:25:00',3.5),('15844','2013-04-23','10:30:00',3.59),('15844','2013-04-23','10:35:00',3.69),('15844','2013-04-23','10:40:00',3.8),('15844','2013-04-23','10:45:00',3.73),('15844','2013-04-23','10:50:00',4),('15844','2013-04-23','10:55:00',4.08),('15844','2013-04-23','11:00:00',4.13),('15844','2013-04-23','11:05:00',4.17),('15844','2013-04-23','11:10:00',4.18),('15844','2013-04-23','11:15:00',4.22),('15844','2013-04-23','11:20:00',4.22),('15844','2013-04-23','11:25:00',4.24),('15844','2013-04-23','11:30:00',4.24),('15844','2013-04-23','11:35:00',4.25),('15844','2013-04-23','11:40:00',4.25),('15844','2013-04-23','11:45:00',4.24),('15844','2013-04-23','11:50:00',4.22),('15844','2013-04-23','11:55:00',4.23),('15844','2013-04-23','12:00:00',4.21),('15844','2013-04-23','12:05:00',4.19),('15844','2013-04-23','12:10:00',4.2),('15844','2013-04-23','12:15:00',4.21),('15844','2013-04-23','12:20:00',4.17),('15844','2013-04-23','12:25:00',4.19),('15844','2013-04-23','12:30:00',3.89),('15844','2013-04-23','12:35:00',4.3),('15844','2013-04-23','12:40:00',3.96),('15844','2013-04-23','12:45:00',2.16),('15844','2013-04-23','12:50:00',2.7),('15844','2013-04-23','12:55:00',4.06),('15844','2013-04-23','13:00:00',1.2),('15844','2013-04-23','13:05:00',2.52),('15844','2013-04-23','13:10:00',3.32),('15844','2013-04-23','13:15:00',4.25),('15844','2013-04-23','13:20:00',4.57),('15844','2013-04-23','13:25:00',4.17),('15844','2013-04-23','13:30:00',3.92),('15844','2013-04-23','13:35:00',4.31),('15844','2013-04-23','13:40:00',4.09),('15844','2013-04-23','13:45:00',2.99),('15844','2013-04-23','13:50:00',3.34),('15844','2013-04-23','13:55:00',4.33),('15844','2013-04-23','14:00:00',3.93),('15844','2013-04-23','14:05:00',2.17),('15844','2013-04-23','14:10:00',3.51),('15844','2013-04-23','14:15:00',3.57),('15844','2013-04-23','14:20:00',3.13),('15844','2013-04-23','14:25:00',2.49),('15844','2013-04-23','14:30:00',3.23),('15844','2013-04-23','14:35:00',2.73),('15844','2013-04-23','14:40:00',2.9),('15844','2013-04-23','14:45:00',1.68),('15844','2013-04-23','14:50:00',1.37),('15844','2013-04-23','14:55:00',1.4),('15844','2013-04-23','15:00:00',1.68),('15844','2013-04-23','15:05:00',2.16),('15844','2013-04-23','15:10:00',2.3),('15844','2013-04-23','15:15:00',2.2),('15844','2013-04-23','15:20:00',2.23),('15844','2013-04-23','15:25:00',1.82),('15844','2013-04-23','15:30:00',1.88),('15844','2013-04-23','15:35:00',1.98),('15844','2013-04-23','15:40:00',1.76),('15844','2013-04-23','15:45:00',1.69),('15844','2013-04-23','15:50:00',1.53),('15844','2013-04-23','15:55:00',1.76),('15844','2013-04-23','16:00:00',1.83),('15844','2013-04-23','16:05:00',1.69),('15844','2013-04-23','16:10:00',1.54),('15844','2013-04-23','16:15:00',1.32),('15844','2013-04-23','16:20:00',1.36),('15844','2013-04-23','16:25:00',1.37),('15844','2013-04-23','16:30:00',1.26),('15844','2013-04-23','16:35:00',1.13),('15844','2013-04-23','17:00:00',1.04),('15844','2013-04-22','09:25:00',1.37),('15844','2013-04-22','09:30:00',1.11),('15844','2013-04-22','10:35:00',2.98),('15844','2013-04-22','10:40:00',1.68),('15844','2013-04-22','10:45:00',2.61),('15844','2013-04-22','10:50:00',3.03),('15844','2013-04-22','10:55:00',1.08),('15844','2013-04-22','11:00:00',1.03),('15844','2013-04-22','11:05:00',1.58),('15844','2013-04-22','11:10:00',1.31),('15844','2013-04-22','11:15:00',1.96),('15844','2013-04-22','11:20:00',1.21),('15844','2013-04-22','11:25:00',1.5),('15844','2013-04-22','11:30:00',1.92),('15844','2013-04-22','11:35:00',2.89),('15844','2013-04-22','11:40:00',3.77),('15844','2013-04-22','11:45:00',5.2),('15844','2013-04-22','11:50:00',4.19),('15844','2013-04-22','11:55:00',4.65),('15844','2013-04-22','12:00:00',4.69),('15844','2013-04-22','12:05:00',4.27),('15844','2013-04-22','12:10:00',4.56),('15844','2013-04-22','12:15:00',4.63),('15844','2013-04-22','12:20:00',3.99),('15844','2013-04-22','12:25:00',3.3),('15844','2013-04-22','12:30:00',4.18),('15844','2013-04-22','12:35:00',3.22),('15844','2013-04-22','12:40:00',3.77),('15844','2013-04-22','12:45:00',3.92),('15844','2013-04-22','12:50:00',4.33),('15844','2013-04-22','12:55:00',4.31),('15844','2013-04-22','13:00:00',4.56),('15844','2013-04-22','13:05:00',4.16),('15844','2013-04-22','13:10:00',2.74),('15844','2013-04-22','13:15:00',1.02),('15844','2013-04-22','13:20:00',1.1),('15844','2013-04-22','13:25:00',2.51),('15844','2013-04-22','13:30:00',1.78),('15844','2013-04-22','13:35:00',1.52),('15844','2013-04-22','13:40:00',1.12),('15844','2013-04-22','13:45:00',1.73),('15844','2013-04-22','13:50:00',2.02),('15844','2013-04-22','13:55:00',2.54),('15844','2013-04-22','14:00:00',1.12),('15844','2013-04-22','14:05:00',2.81),('15844','2013-04-22','14:10:00',3.53),('15844','2013-04-22','14:15:00',1.04),('15844','2013-04-22','14:20:00',1.48),('15844','2013-04-22','14:25:00',3.36),('15844','2013-04-22','14:30:00',2.37),('15844','2013-04-22','14:35:00',2.9),('15844','2013-04-22','14:40:00',2.8),('15844','2013-04-22','14:45:00',3.18),('15844','2013-04-22','14:50:00',3.09),('15844','2013-04-22','14:55:00',3.07),('15844','2013-04-22','15:00:00',2.94),('15844','2013-04-22','15:05:00',1.68),('15844','2013-04-22','15:10:00',1.91),('15844','2013-04-22','15:15:00',3.1),('15844','2013-04-22','15:20:00',2.86),('15844','2013-04-22','15:25:00',2.22),('15844','2013-04-22','15:30:00',1.72),('15844','2013-04-22','15:35:00',1.76),('15844','2013-04-22','15:40:00',2.38),('15844','2013-04-22','15:45:00',1.84),('15844','2013-04-22','15:50:00',1.61),('15844','2014-03-29','07:50:00',1.08),('15844','2014-03-29','07:55:00',1.17),('15844','2014-03-29','08:00:00',1.26),('15844','2014-03-29','08:05:00',1.36),('15844','2014-03-29','08:10:00',1.46),('15844','2014-03-29','08:15:00',1.68),('15844','2014-03-29','08:20:00',1.81),('15844','2014-03-29','08:25:00',1.88),('15844','2014-03-29','08:30:00',2),('15844','2014-03-29','08:35:00',2.06),('15844','2014-03-29','08:40:00',2.11),('15844','2014-03-29','08:45:00',2.24),('15844','2014-03-29','08:50:00',2.33),('15844','2014-03-29','08:55:00',2.36),('15844','2014-03-29','09:00:00',2.4),('15844','2014-03-29','09:05:00',2.46),('15844','2014-03-29','09:10:00',2.53),('15844','2014-03-29','09:15:00',2.66),('15844','2014-03-29','09:20:00',2.74),('15844','2014-03-29','09:25:00',2.86),('15844','2014-03-29','09:30:00',2.91),('15844','2014-03-29','09:35:00',2.97),('15844','2014-03-29','09:40:00',3.08),('15844','2014-03-29','09:45:00',3.16),('15844','2014-03-29','09:50:00',3.18),('15844','2014-03-29','09:55:00',3.28),('15844','2014-03-29','10:00:00',3.4),('15844','2014-03-29','10:05:00',3.47),('15844','2014-03-29','10:10:00',3.5),('15844','2014-03-29','10:15:00',3.56),('15844','2014-03-29','10:20:00',3.62),('15844','2014-03-29','10:25:00',3.66),('15844','2014-03-29','10:30:00',3.67),('15844','2014-03-29','10:35:00',3.68),('15844','2014-03-29','10:40:00',3.7),('15844','2014-03-29','10:45:00',3.71),('15844','2014-03-29','10:50:00',3.72),('15844','2014-03-29','10:55:00',3.75),('15844','2014-03-29','11:00:00',3.7),('15844','2014-03-29','11:05:00',3.67),('15844','2014-03-29','11:10:00',3.66),('15844','2014-03-29','11:15:00',3.71),('15844','2014-03-29','11:20:00',3.75),('15844','2014-03-29','11:25:00',3.63),('15844','2014-03-29','11:30:00',3.63),('15844','2014-03-29','11:35:00',3.54),('15844','2014-03-29','11:40:00',3.62),('15844','2014-03-29','11:45:00',3.6),('15844','2014-03-29','11:50:00',3.65),('15844','2014-03-29','11:55:00',3.61),('15844','2014-03-29','12:00:00',3.57),('15844','2014-03-29','12:05:00',3.52),('15844','2014-03-29','12:10:00',3.51),('15844','2014-03-29','12:15:00',3.52),('15844','2014-03-29','12:20:00',3.5),('15844','2014-03-29','12:25:00',3.47),('15844','2014-03-29','12:30:00',3.45),('15844','2014-03-29','12:35:00',3.37),('15844','2014-03-29','12:40:00',3.32),('15844','2014-03-29','12:45:00',3.21),('15844','2014-03-29','12:50:00',3.29),('15844','2014-03-29','12:55:00',3.27),('15844','2014-03-29','13:00:00',3.27),('15844','2014-03-29','13:05:00',3.09),('15844','2014-03-29','13:10:00',3.08),('15844','2014-03-29','13:15:00',3.17),('15844','2014-03-29','13:20:00',2.95),('15844','2014-03-29','13:25:00',2.7),('15844','2014-03-29','13:30:00',2.19),('15844','2014-03-29','13:35:00',2.65),('15844','2014-03-29','13:40:00',2.53),('15844','2014-03-29','13:45:00',2.45),('15844','2014-03-29','13:50:00',2.35),('15844','2014-03-29','13:55:00',2.24),('15844','2014-03-29','14:00:00',2.15),('15844','2014-03-29','14:05:00',1.99),('15844','2014-03-29','14:10:00',2.02),('15844','2014-03-29','14:15:00',1.87),('15844','2014-03-29','14:20:00',1.8),('15844','2014-03-29','14:25:00',1.78),('15844','2014-03-29','14:30:00',1.65),('15844','2014-03-29','14:35:00',1.46),('15844','2014-03-29','14:40:00',1.46),('15844','2014-03-29','14:45:00',1.34),('15844','2014-03-29','14:50:00',1.28),('15844','2014-03-29','14:55:00',1.22),('15844','2014-03-29','15:00:00',1.17),('15844','2014-03-29','15:05:00',1.09),('15844','2013-04-21','08:50:00',1.03),('15844','2013-04-21','08:55:00',1.27),('15844','2013-04-21','09:00:00',1.02),('15844','2013-04-21','09:15:00',1.02),('15844','2013-04-21','09:20:00',1.23),('15844','2013-04-21','09:25:00',1.37),('15844','2013-04-21','09:30:00',1.7),('15844','2013-04-21','09:35:00',2.88),('15844','2013-04-21','09:40:00',2.41),('15844','2013-04-21','09:45:00',2.28),('15844','2013-04-21','09:50:00',1.65),('15844','2013-04-21','09:55:00',1.42),('15844','2013-04-21','10:00:00',1.2),('15844','2013-04-21','10:05:00',1.36),('15844','2013-04-21','10:10:00',2.26),('15844','2013-04-21','10:15:00',2.53),('15844','2013-04-21','10:20:00',3.39),('15844','2013-04-21','10:25:00',3.49),('15844','2013-04-21','10:30:00',3.34),('15844','2013-04-21','10:35:00',3.73),('15844','2013-04-21','10:40:00',3.75),('15844','2013-04-21','10:45:00',3.31),('15844','2013-04-21','10:50:00',3.97),('15844','2013-04-21','10:55:00',3.78),('15844','2013-04-21','11:00:00',3.6),('15844','2013-04-21','11:05:00',3.07),('15844','2013-04-21','11:10:00',3.01),('15844','2013-04-21','11:15:00',3.26),('15844','2013-04-21','11:20:00',3.31),('15844','2013-04-21','11:25:00',2.79),('15844','2013-04-21','11:30:00',2.31),('15844','2013-04-21','11:35:00',2.83),('15844','2013-04-21','11:40:00',3.04),('15844','2013-04-21','11:45:00',2.51),('15844','2013-04-21','11:50:00',2.21),('15844','2013-04-21','11:55:00',2.38),('15844','2013-04-21','12:00:00',2.31),('15844','2013-04-21','12:05:00',2.25),('15844','2013-04-21','12:10:00',2.08),('15844','2013-04-21','12:15:00',1.78),('15844','2013-04-21','12:20:00',1.64),('15844','2013-04-21','12:25:00',1.87),('15844','2013-04-21','12:30:00',1.82),('15844','2013-04-21','12:35:00',1.98),('15844','2013-04-21','12:40:00',2.05),('15844','2013-04-21','12:45:00',1.89),('15844','2013-04-21','12:50:00',1.89),('15844','2013-04-21','12:55:00',1.96),('15844','2013-04-21','13:00:00',2.03),('15844','2013-04-21','13:05:00',2.44),('15844','2013-04-21','13:10:00',2.26),('15844','2013-04-21','13:15:00',2.13),('15844','2013-04-21','13:20:00',2.33),('15844','2013-04-21','13:25:00',2.17),('15844','2013-04-21','13:30:00',2.84),('15844','2013-04-21','13:35:00',3.36),('15844','2013-04-21','13:40:00',4.01),('15844','2013-04-21','13:45:00',4.12),('15844','2013-04-21','13:50:00',3.1),('15844','2013-04-21','13:55:00',2.16),('15844','2013-04-21','14:00:00',2.13),('15844','2013-04-21','14:05:00',2.13),('15844','2013-04-21','14:10:00',2.63),('15844','2013-04-21','14:15:00',1.61),('15844','2013-04-21','14:20:00',2.79),('15844','2013-04-21','14:25:00',3.04),('15844','2013-04-21','14:30:00',3.63),('15844','2013-04-21','14:35:00',3.37),('15844','2013-04-21','14:40:00',3.16),('15844','2013-04-21','14:45:00',2.61),('15844','2013-04-21','14:50:00',2.04),('15844','2013-04-21','14:55:00',2.87),('15844','2013-04-21','15:00:00',2.83),('15844','2013-04-21','15:05:00',2.53),('15844','2013-04-21','15:10:00',2.47),('15844','2013-04-21','15:15:00',2.35),('15844','2013-04-21','15:20:00',1.91),('15844','2013-04-21','15:25:00',2.13),('15844','2013-04-21','15:30:00',1.82),('15844','2013-04-21','15:35:00',1.68),('15844','2013-04-21','15:40:00',1.78),('15844','2013-04-21','15:45:00',1.08),('15844','2013-04-20','08:30:00',1),('15844','2013-04-20','08:45:00',1.37),('15844','2013-04-20','10:30:00',1.06),('15844','2013-04-20','10:35:00',1.52),('15844','2013-04-20','10:40:00',3.11),('15844','2013-04-20','10:45:00',2.5),('15844','2013-04-20','10:50:00',1.49),('15844','2013-04-20','10:55:00',1.88),('15844','2013-04-20','11:00:00',2.92),('15844','2013-04-20','11:05:00',2),('15844','2013-04-20','11:10:00',1.46),('15844','2013-04-20','11:15:00',1.57),('15844','2013-04-20','11:20:00',4.15),('15844','2013-04-20','11:25:00',2.44),('15844','2013-04-20','11:30:00',2.25),('15844','2013-04-20','11:35:00',3.92),('15844','2013-04-20','11:40:00',1.83),('15844','2013-04-20','11:45:00',1.48),('15844','2013-04-20','11:50:00',2.01),('15844','2013-04-20','11:55:00',3.27),('15844','2013-04-20','12:00:00',3.81),('15844','2013-04-20','12:05:00',3.84),('15844','2013-04-20','12:10:00',4.53),('15844','2013-04-20','12:15:00',3.42),('15844','2013-04-20','12:20:00',2.88),('15844','2013-04-20','12:25:00',3.97),('15844','2013-04-20','12:30:00',1.48),('15844','2013-04-20','12:35:00',3.59),('15844','2013-04-20','12:40:00',3.6),('15844','2013-04-20','12:45:00',4.16),('15844','2013-04-20','12:50:00',3.76),('15844','2013-04-20','12:55:00',4.06),('15844','2013-04-20','13:00:00',4.07),('15844','2013-04-20','13:05:00',2.49),('15844','2013-04-20','13:10:00',4.06),('15844','2013-04-20','13:15:00',4.13),('15844','2013-04-20','13:20:00',2.75),('15844','2013-04-20','13:25:00',3.88),('15844','2013-04-20','13:30:00',3.98),('15844','2013-04-20','13:35:00',3.08),('15844','2013-04-20','13:40:00',2.37),('15844','2013-04-20','13:45:00',1.89),('15844','2013-04-20','13:50:00',3.92),('15844','2013-04-20','13:55:00',3.9),('15844','2013-04-20','14:00:00',3.77),('15844','2013-04-20','14:05:00',3.43),('15844','2013-04-20','14:10:00',3.33),('15844','2013-04-20','14:15:00',3.23),('15844','2013-04-20','14:20:00',3.18),('15844','2013-04-20','14:25:00',3.08),('15844','2013-04-20','14:30:00',2.62),('15844','2013-04-20','14:35:00',2.85),('15844','2013-04-20','14:40:00',2.74),('15844','2013-04-20','14:45:00',2.61),('15844','2013-04-20','14:50:00',2.6),('15844','2013-04-20','14:55:00',2.53),('15844','2013-04-20','15:00:00',2.43),('15844','2013-04-20','15:05:00',2.01),('15844','2013-04-20','15:10:00',2.12),('15844','2013-04-20','15:15:00',1.19),('15844','2013-04-20','15:20:00',1.48),('15844','2013-04-20','15:25:00',1.2),('15844','2013-04-20','16:00:00',1.04),('15844','2013-04-20','16:05:00',1.71),('15844','2013-04-20','16:10:00',2.19),('15844','2013-04-20','16:15:00',2.01),('15844','2013-04-20','16:20:00',1.82),('15844','2013-04-20','16:25:00',1.77),('15844','2013-04-20','16:30:00',1.62),('15844','2013-04-20','16:35:00',1.34),('15844','2013-04-20','16:40:00',1),('15844','2013-04-19','08:30:00',1.15),('15844','2013-04-19','08:35:00',1.19),('15844','2013-04-19','08:40:00',1.4),('15844','2013-04-19','08:45:00',1.17),('15844','2013-04-19','08:50:00',1.36),('15844','2013-04-19','08:55:00',1.5),('15844','2013-04-19','09:00:00',1.49),('15844','2013-04-19','09:05:00',1.42),('15844','2013-04-19','09:10:00',1.7),('15844','2013-04-19','09:15:00',1.82),('15844','2013-04-19','09:20:00',1.93),('15844','2013-04-19','09:25:00',2),('15844','2013-04-19','09:30:00',1.85),('15844','2013-04-19','09:35:00',1.54),('15844','2013-04-19','09:40:00',2.11),('15844','2013-04-19','09:45:00',2.19),('15844','2013-04-19','09:50:00',2.26),('15844','2013-04-19','09:55:00',2.41),('15844','2013-04-19','10:00:00',2.52),('15844','2013-04-19','10:05:00',2.64),('15844','2013-04-19','10:10:00',2.73),('15844','2013-04-19','10:15:00',2.78),('15844','2013-04-19','10:20:00',2.85),('15844','2013-04-19','10:25:00',2.97),('15844','2013-04-19','10:30:00',3.14),('15844','2013-04-19','10:35:00',3.13),('15844','2013-04-19','10:40:00',3.09),('15844','2013-04-19','10:45:00',3.17),('15844','2013-04-19','10:50:00',3.6),('15844','2013-04-19','10:55:00',3.63),('15844','2013-04-19','11:00:00',3.64),('15844','2013-04-19','11:05:00',3.57),('15844','2013-04-19','11:10:00',3.58),('15844','2013-04-19','11:15:00',3.57),('15844','2013-04-19','11:20:00',3.61),('15844','2013-04-19','11:25:00',3.61),('15844','2013-04-19','11:30:00',3.71),('15844','2013-04-19','11:35:00',3.75),('15844','2013-04-19','11:40:00',3.72),('15844','2013-04-19','11:45:00',3.85),('15844','2013-04-19','11:50:00',3.92),('15844','2013-04-19','11:55:00',3.85),('15844','2013-04-19','12:00:00',3.88),('15844','2013-04-19','12:05:00',3.82),('15844','2013-04-19','12:10:00',3.81),('15844','2013-04-19','12:15:00',3.74),('15844','2013-04-19','12:20:00',3.9),('15844','2013-04-19','12:25:00',3.82),('15844','2013-04-19','12:30:00',3.57),('15844','2013-04-19','12:35:00',3.64),('15844','2013-04-19','12:40:00',3.83),('15844','2013-04-19','12:45:00',3.83),('15844','2013-04-19','12:50:00',3.79),('15844','2013-04-19','12:55:00',3.71),('15844','2013-04-19','13:00:00',3.82),('15844','2013-04-19','13:05:00',3.74),('15844','2013-04-19','13:10:00',3.77),('15844','2013-04-19','13:15:00',3.7),('15844','2013-04-19','13:20:00',3.63),('15844','2013-04-19','13:25:00',3.68),('15844','2013-04-19','13:30:00',3.62),('15844','2013-04-19','13:35:00',3.54),('15844','2013-04-19','13:40:00',3.53),('15844','2013-04-19','13:45:00',3.45),('15844','2013-04-19','13:50:00',3.4),('15844','2013-04-19','13:55:00',3.33),('15844','2013-04-19','14:00:00',3.25),('15844','2013-04-19','14:05:00',3.22),('15844','2013-04-19','14:10:00',3.15),('15844','2013-04-19','14:15:00',3.09),('15844','2013-04-19','14:20:00',3.01),('15844','2013-04-19','14:25:00',2.9),('15844','2013-04-19','14:30:00',2.76),('15844','2013-04-19','14:35:00',2.67),('15844','2013-04-19','14:40:00',2.57),('15844','2013-04-19','14:45:00',2.46),('15844','2013-04-19','14:50:00',2.34),('15844','2013-04-19','14:55:00',2.32),('15844','2013-04-19','15:00:00',2.32),('15844','2013-04-19','15:05:00',2.25),('15844','2013-04-19','15:10:00',2.19),('15844','2013-04-19','15:15:00',2.09),('15844','2013-04-19','15:20:00',1.99),('15844','2013-04-19','15:25:00',1.92),('15844','2013-04-19','15:30:00',1.83),('15844','2013-04-19','15:35:00',1.74),('15844','2013-04-19','15:40:00',1.64),('15844','2013-04-19','15:45:00',1.54),('15844','2013-04-19','15:50:00',1.43),('15844','2013-04-19','15:55:00',1.32),('15844','2013-04-19','16:00:00',1.25),('15844','2013-04-19','16:05:00',1.2),('15844','2013-04-19','16:10:00',1.18),('15844','2013-04-19','16:15:00',1.12),('15844','2013-04-19','16:20:00',1.07),('15844','2013-04-18','08:50:00',1.11),('15844','2013-04-18','08:55:00',1.23),('15844','2013-04-18','09:00:00',1.2),('15844','2013-04-18','09:05:00',1.14),('15844','2013-04-18','09:10:00',1.19),('15844','2013-04-18','09:15:00',1.49),('15844','2013-04-18','09:20:00',1.43),('15844','2013-04-18','09:25:00',1.51),('15844','2013-04-18','09:30:00',1.61),('15844','2013-04-18','09:35:00',1.57),('15844','2013-04-18','09:40:00',1.81),('15844','2013-04-18','09:45:00',1.88),('15844','2013-04-18','09:50:00',2.15),('15844','2013-04-18','09:55:00',2.15),('15844','2013-04-18','10:00:00',2.61),('15844','2013-04-18','10:05:00',2.6),('15844','2013-04-18','10:10:00',2.65),('15844','2013-04-18','10:15:00',2.76),('15844','2013-04-18','10:20:00',2.87),('15844','2013-04-18','10:25:00',3.12),('15844','2013-04-18','10:30:00',3.3),('15844','2013-04-18','10:35:00',3.38),('15844','2013-04-18','10:40:00',3.42),('15844','2013-04-18','10:45:00',3.5),('15844','2013-04-18','10:50:00',3.57),('15844','2013-04-18','10:55:00',3.69),('15844','2013-04-18','11:00:00',3.76),('15844','2013-04-18','11:05:00',3.76),('15844','2013-04-18','11:10:00',3.79),('15844','2013-04-18','11:15:00',3.8),('15844','2013-04-18','11:20:00',3.8),('15844','2013-04-18','11:25:00',3.86),('15844','2013-04-18','11:30:00',3.88),('15844','2013-04-18','11:35:00',3.88),('15844','2013-04-18','11:40:00',3.93),('15844','2013-04-18','11:45:00',3.93),('15844','2013-04-18','11:50:00',3.94),('15844','2013-04-18','11:55:00',4),('15844','2013-04-18','12:00:00',3.83),('15844','2013-04-18','12:05:00',4.03),('15844','2013-04-18','12:10:00',4.01),('15844','2013-04-18','12:15:00',3.95),('15844','2013-04-18','12:20:00',3.98),('15844','2013-04-18','12:25:00',4),('15844','2013-04-18','12:30:00',3.99),('15844','2013-04-18','12:35:00',3.95),('15844','2013-04-18','12:40:00',3.97),('15844','2013-04-18','12:45:00',3.96),('15844','2013-04-18','12:50:00',3.92),('15844','2013-04-18','12:55:00',3.92),('15844','2013-04-18','13:00:00',3.9),('15844','2013-04-18','13:05:00',3.86),('15844','2013-04-18','13:10:00',3.85),('15844','2013-04-18','13:15:00',3.82),('15844','2013-04-18','13:20:00',3.75),('15844','2013-04-18','13:25:00',3.72),('15844','2013-04-18','13:30:00',3.71),('15844','2013-04-18','13:35:00',3.68),('15844','2013-04-18','13:40:00',3.62),('15844','2013-04-18','13:45:00',3.55),('15844','2013-04-18','13:50:00',3.48),('15844','2013-04-18','13:55:00',3.43),('15844','2013-04-18','14:00:00',3.36),('15844','2013-04-18','14:05:00',3.3),('15844','2013-04-18','14:10:00',3.22),('15844','2013-04-18','14:15:00',3.14),('15844','2013-04-18','14:20:00',3.08),('15844','2013-04-18','14:25:00',2.98),('15844','2013-04-18','14:30:00',2.88),('15844','2013-04-18','14:35:00',2.76),('15844','2013-04-18','14:40:00',2.67),('15844','2013-04-18','14:45:00',2.62),('15844','2013-04-18','14:50:00',2.56),('15844','2013-04-18','14:55:00',2.47),('15844','2013-04-18','15:00:00',2.37),('15844','2013-04-18','15:05:00',2.28),('15844','2013-04-18','15:10:00',2.21),('15844','2013-04-18','15:15:00',2.12),('15844','2013-04-18','15:20:00',2),('15844','2013-04-18','15:25:00',1.93),('15844','2013-04-18','15:30:00',1.84),('15844','2013-04-18','15:35:00',1.75),('15844','2013-04-18','15:40:00',1.63),('15844','2013-04-18','15:45:00',1.53),('15844','2013-04-18','15:50:00',1.41),('15844','2013-04-18','15:55:00',1.29),('15844','2013-04-18','16:00:00',1.21),('15844','2013-04-18','16:05:00',1.16),('15844','2013-04-18','16:10:00',1.14),('15844','2013-04-18','16:15:00',1.1),('15844','2013-04-18','16:20:00',1.06),('15844','2013-04-17','08:40:00',1.03),('15844','2013-04-17','08:45:00',1.21),('15844','2013-04-17','08:50:00',1.36),('15844','2013-04-17','08:55:00',1.46),('15844','2013-04-17','09:00:00',1.59),('15844','2013-04-17','09:05:00',1.71),('15844','2013-04-17','09:10:00',1.8),('15844','2013-04-17','09:15:00',1.89),('15844','2013-04-17','09:20:00',2),('15844','2013-04-17','09:25:00',2.1),('15844','2013-04-17','09:30:00',2.18),('15844','2013-04-17','09:35:00',2.27),('15844','2013-04-17','09:40:00',2.36),('15844','2013-04-17','09:45:00',2.42),('15844','2013-04-17','09:50:00',2.49),('15844','2013-04-17','09:55:00',2.59),('15844','2013-04-17','10:00:00',2.76),('15844','2013-04-17','10:05:00',2.85),('15844','2013-04-17','10:10:00',2.94),('15844','2013-04-17','10:15:00',2.98),('15844','2013-04-17','10:20:00',3.07),('15844','2013-04-17','10:25:00',3.12),('15844','2013-04-17','10:30:00',3.28),('15844','2013-04-17','10:35:00',3.39),('15844','2013-04-17','10:40:00',3.47),('15844','2013-04-17','10:45:00',3.53),('15844','2013-04-17','10:50:00',3.6),('15844','2013-04-17','10:55:00',3.73),('15844','2013-04-17','11:00:00',3.82),('15844','2013-04-17','11:05:00',3.86),('15844','2013-04-17','11:10:00',3.91),('15844','2013-04-17','11:15:00',3.92),('15844','2013-04-17','11:20:00',3.95),('15844','2013-04-17','11:25:00',3.95),('15844','2013-04-17','11:30:00',3.96),('15844','2013-04-17','11:35:00',3.98),('15844','2013-04-17','11:40:00',3.97),('15844','2013-04-17','11:45:00',3.98),('15844','2013-04-17','11:50:00',4),('15844','2013-04-17','11:55:00',3.99),('15844','2013-04-17','12:00:00',4),('15844','2013-04-17','12:05:00',4.04),('15844','2013-04-17','12:10:00',4),('15844','2013-04-17','12:15:00',3.95),('15844','2013-04-17','12:20:00',3.94),('15844','2013-04-17','12:25:00',3.95),('15844','2013-04-17','12:30:00',3.97),('15844','2013-04-17','12:35:00',3.97),('15844','2013-04-17','12:40:00',3.94),('15844','2013-04-17','12:45:00',3.94),('15844','2013-04-17','12:50:00',3.94),('15844','2013-04-17','12:55:00',3.95),('15844','2013-04-17','13:00:00',3.92),('15844','2013-04-17','13:05:00',3.85),('15844','2013-04-17','13:10:00',3.81),('15844','2013-04-17','13:15:00',3.81),('15844','2013-04-17','13:20:00',3.76),('15844','2013-04-17','13:25:00',3.74),('15844','2013-04-17','13:30:00',3.78),('15844','2013-04-17','13:35:00',3.67),('15844','2013-04-17','13:40:00',3.75),('15844','2013-04-17','13:45:00',3.53),('15844','2013-04-17','13:50:00',3.34),('15844','2013-04-17','13:55:00',2.95),('15844','2013-04-17','14:00:00',3.21),('15844','2013-04-17','14:05:00',2.79),('15844','2013-04-17','14:10:00',3.48),('15844','2013-04-17','14:15:00',3.32),('15844','2013-04-17','14:20:00',3.24),('15844','2013-04-17','14:25:00',3.06),('15844','2013-04-17','14:30:00',2.41),('15844','2013-04-17','14:35:00',3.1),('15844','2013-04-17','14:40:00',3.03),('15844','2013-04-17','14:45:00',1.83),('15844','2013-04-17','14:50:00',1.93),('15844','2013-04-17','14:55:00',1.95),('15844','2013-04-17','15:00:00',2.27),('15844','2013-04-17','15:05:00',2.64),('15844','2013-04-17','15:10:00',2.69),('15844','2013-04-17','15:15:00',2.55),('15844','2013-04-17','15:20:00',1.85),('15844','2013-04-17','15:30:00',1.18),('15844','2013-04-17','15:35:00',1.41),('15844','2013-04-17','15:40:00',1.45),('15844','2013-04-17','15:45:00',1.31),('15844','2013-04-17','15:50:00',1.44),('15844','2013-04-17','15:55:00',1.2),('15844','2013-04-17','16:00:00',1.43),('15844','2013-04-17','16:05:00',1.28),('15844','2013-04-17','16:10:00',1.04),('15844','2013-04-17','16:15:00',1.16),('15844','2013-04-17','16:20:00',1.1),('15844','2013-04-16','09:05:00',1.27),('15844','2013-04-16','09:10:00',1.72),('15844','2013-04-16','09:15:00',1.95),('15844','2013-04-16','09:20:00',1.87),('15844','2013-04-16','09:25:00',1.37),('15844','2013-04-16','09:30:00',1.44),('15844','2013-04-16','09:35:00',1.67),('15844','2013-04-16','09:40:00',1.85),('15844','2013-04-16','09:45:00',1.78),('15844','2013-04-16','09:50:00',1.53),('15844','2013-04-16','09:55:00',1.42),('15844','2013-04-16','10:00:00',1.41),('15844','2013-04-16','10:05:00',1.26),('15844','2013-04-16','10:10:00',1.28),('15844','2013-04-16','10:15:00',1.31),('15844','2013-04-16','10:20:00',1.26),('15844','2013-04-16','10:25:00',1.25),('15844','2013-04-16','10:30:00',1.25),('15844','2013-04-16','10:35:00',1.27),('15844','2013-04-16','10:40:00',1.35),('15844','2013-04-16','10:45:00',1.42),('15844','2013-04-16','10:50:00',1.41),('15844','2013-04-16','10:55:00',1.46),('15844','2013-04-16','11:00:00',1.49),('15844','2013-04-16','11:05:00',1.53),('15844','2013-04-16','11:10:00',1.53),('15844','2013-04-16','11:15:00',1.59),('15844','2013-04-16','11:20:00',1.59),('15844','2013-04-16','11:25:00',1.65),('15844','2013-04-16','11:30:00',1.54),('15844','2013-04-16','11:35:00',1.38),('15844','2013-04-16','11:40:00',1.59),('15844','2013-04-16','11:45:00',1.87),('15844','2013-04-16','11:50:00',2.02),('15844','2013-04-16','11:55:00',2.39),('15844','2013-04-16','12:00:00',3.1),('15844','2013-04-16','12:05:00',3.25),('15844','2013-04-16','12:10:00',2.73),('15844','2013-04-16','12:15:00',2.7),('15844','2013-04-16','12:20:00',3.17),('15844','2013-04-16','12:25:00',2.92),('15844','2013-04-16','12:30:00',3.22),('15844','2013-04-16','12:35:00',3.07),('15844','2013-04-16','12:40:00',2.42),('15844','2013-04-16','12:45:00',2.26),('15844','2013-04-16','12:50:00',3.58),('15844','2013-04-16','12:55:00',3.63),('15844','2013-04-16','13:00:00',3.69),('15844','2013-04-16','13:05:00',3.68),('15844','2013-04-16','13:10:00',3.52),('15844','2013-04-16','13:15:00',3.61),('15844','2013-04-16','13:20:00',3.64),('15844','2013-04-16','13:25:00',3.64),('15844','2013-04-16','13:30:00',3.66),('15844','2013-04-16','13:35:00',3.61),('15844','2013-04-16','13:40:00',3.52),('15844','2013-04-16','13:45:00',3.45),('15844','2013-04-16','13:50:00',3.36),('15844','2013-04-16','13:55:00',3.35),('15844','2013-04-16','14:00:00',3.26),('15844','2013-04-16','14:05:00',3.22),('15844','2013-04-16','14:10:00',3.17),('15844','2013-04-16','14:15:00',3.19),('15844','2013-04-16','14:20:00',3.12),('15844','2013-04-16','14:25:00',2.75),('15844','2013-04-16','14:30:00',2.21),('15844','2013-04-16','14:35:00',1.9),('15844','2013-04-16','14:40:00',2.38),('15844','2013-04-16','14:45:00',2.63),('15844','2013-04-16','14:50:00',2.56),('15844','2013-04-16','14:55:00',2.43),('15844','2013-04-16','15:00:00',2.23),('15844','2013-04-16','15:05:00',2.31),('15844','2013-04-16','15:10:00',2.22),('15844','2013-04-16','15:15:00',2.09),('15844','2013-04-16','15:20:00',1.41),('15844','2013-04-16','15:25:00',1.66),('15844','2013-04-16','15:30:00',1.67),('15844','2013-04-16','15:35:00',1.69),('15844','2013-04-16','15:40:00',1.66),('15844','2013-04-16','15:45:00',1.51),('15844','2013-04-16','15:50:00',1.44),('15844','2013-04-16','15:55:00',1.3),('15844','2013-04-16','16:00:00',1.22),('15844','2013-04-16','16:05:00',1.17),('15844','2013-04-16','16:10:00',1.13),('15844','2013-04-16','16:15:00',1.09),('15844','2013-04-16','16:20:00',1.02),('15844','2013-04-15','08:40:00',1.16),('15844','2013-04-15','08:45:00',1.23),('15844','2013-04-15','08:50:00',1.4),('15844','2013-04-15','08:55:00',1.47),('15844','2013-04-15','09:00:00',1.61),('15844','2013-04-15','09:05:00',1.73),('15844','2013-04-15','09:10:00',1.81),('15844','2013-04-15','09:15:00',1.89),('15844','2013-04-15','09:20:00',2),('15844','2013-04-15','09:25:00',2.13),('15844','2013-04-15','09:30:00',2.24),('15844','2013-04-15','09:35:00',2.36),('15844','2013-04-15','09:40:00',2.45),('15844','2013-04-15','09:45:00',2.52),('15844','2013-04-15','09:50:00',2.58),('15844','2013-04-15','09:55:00',2.65),('15844','2013-04-15','10:00:00',2.8),('15844','2013-04-15','10:05:00',2.92),('15844','2013-04-15','10:10:00',2.98),('15844','2013-04-15','10:15:00',3.05),('15844','2013-04-15','10:20:00',3.1),('15844','2013-04-15','10:25:00',3.15),('15844','2013-04-15','10:30:00',3.24),('15844','2013-04-15','10:35:00',3.41),('15844','2013-04-15','10:40:00',3.46),('15844','2013-04-15','10:45:00',3.52),('15844','2013-04-15','10:50:00',3.58),('15844','2013-04-15','10:55:00',3.69),('15844','2013-04-15','11:00:00',3.84),('15844','2013-04-15','11:05:00',3.9),('15844','2013-04-15','11:10:00',3.91),('15844','2013-04-15','11:15:00',3.94),('15844','2013-04-15','11:20:00',3.96),('15844','2013-04-15','11:25:00',3.98),('15844','2013-04-15','11:30:00',3.99),('15844','2013-04-15','11:35:00',4),('15844','2013-04-15','11:40:00',4.04),('15844','2013-04-15','11:45:00',4.03),('15844','2013-04-15','11:50:00',4.02),('15844','2013-04-15','11:55:00',4.03),('15844','2013-04-15','12:00:00',4.02),('15844','2013-04-15','12:05:00',4.03),('15844','2013-04-15','12:10:00',4.01),('15844','2013-04-15','12:15:00',4.01),('15844','2013-04-15','12:20:00',4.01),('15844','2013-04-15','12:25:00',3.99),('15844','2013-04-15','12:30:00',3.99),('15844','2013-04-15','12:35:00',3.97),('15844','2013-04-15','12:40:00',3.96),('15844','2013-04-15','12:45:00',3.94),('15844','2013-04-15','12:50:00',3.91),('15844','2013-04-15','12:55:00',3.89),('15844','2013-04-15','13:00:00',3.87),('15844','2013-04-15','13:05:00',3.88),('15844','2013-04-15','13:10:00',3.86),('15844','2013-04-15','13:15:00',3.82),('15844','2013-04-15','13:20:00',3.78),('15844','2013-04-15','13:25:00',3.73),('15844','2013-04-15','13:30:00',3.71),('15844','2013-04-15','13:35:00',3.72),('15844','2013-04-15','13:40:00',3.69),('15844','2013-04-15','13:45:00',3.53),('15844','2013-04-15','13:50:00',3.56),('15844','2013-04-15','13:55:00',3.48),('15844','2013-04-15','14:00:00',3.41),('15844','2013-04-15','14:05:00',3.35),('15844','2013-04-15','14:10:00',3.28),('15844','2013-04-15','14:15:00',3.19),('15844','2013-04-15','14:20:00',3.11),('15844','2013-04-15','14:25:00',3),('15844','2013-04-15','14:30:00',2.88),('15844','2013-04-15','14:35:00',2.75),('15844','2013-04-15','14:40:00',2.61),('15844','2013-04-15','14:45:00',2.47),('15844','2013-04-15','14:50:00',2.46),('15844','2013-04-15','14:55:00',2.47),('15844','2013-04-15','15:00:00',2.37),('15844','2013-04-15','15:05:00',2.28),('15844','2013-04-15','15:10:00',2.2),('15844','2013-04-15','15:15:00',2.1),('15844','2013-04-15','15:20:00',2),('15844','2013-04-15','15:25:00',1.94),('15844','2013-04-15','15:30:00',1.84),('15844','2013-04-15','15:35:00',1.74),('15844','2013-04-15','15:40:00',1.63),('15844','2013-04-15','15:45:00',1.52),('15844','2013-04-15','15:50:00',1.37),('15844','2013-04-15','15:55:00',1.23),('15844','2013-04-15','16:00:00',1.17),('15844','2013-04-15','16:05:00',1.12),('15844','2013-04-15','16:10:00',1.06),('15844','2013-04-15','16:15:00',1.03),('15844','2013-04-14','08:40:00',1.03),('15844','2013-04-14','08:45:00',1.19),('15844','2013-04-14','08:50:00',1.32),('15844','2013-04-14','08:55:00',1.4),('15844','2013-04-14','09:00:00',1.5),('15844','2013-04-14','09:05:00',1.62),('15844','2013-04-14','09:10:00',1.7),('15844','2013-04-14','09:15:00',1.75),('15844','2013-04-14','09:20:00',1.86),('15844','2013-04-14','09:25:00',2),('15844','2013-04-14','09:30:00',2.12),('15844','2013-04-14','09:35:00',2.18),('15844','2013-04-14','09:40:00',2.29),('15844','2013-04-14','09:45:00',2.34),('15844','2013-04-14','09:50:00',2.41),('15844','2013-04-14','09:55:00',2.49),('15844','2013-04-14','10:00:00',2.61),('15844','2013-04-14','10:05:00',2.75),('15844','2013-04-14','10:10:00',2.83),('15844','2013-04-14','10:15:00',2.9),('15844','2013-04-14','10:20:00',2.97),('15844','2013-04-14','10:25:00',3.04),('15844','2013-04-14','10:30:00',3.15),('15844','2013-04-14','10:35:00',3.27),('15844','2013-04-14','10:40:00',3.37),('15844','2013-04-14','10:45:00',3.45),('15844','2013-04-14','10:50:00',3.51),('15844','2013-04-14','10:55:00',3.62),('15844','2013-04-14','11:00:00',3.75),('15844','2013-04-14','11:05:00',3.75),('15844','2013-04-14','11:10:00',3.8),('15844','2013-04-14','11:15:00',3.83),('15844','2013-04-14','11:20:00',3.9),('15844','2013-04-14','11:25:00',3.9),('15844','2013-04-14','11:30:00',3.93),('15844','2013-04-14','11:35:00',3.93),('15844','2013-04-14','11:40:00',3.9),('15844','2013-04-14','11:45:00',3.93),('15844','2013-04-14','11:50:00',3.89),('15844','2013-04-14','11:55:00',3.86),('15844','2013-04-14','12:00:00',3.91),('15844','2013-04-14','12:05:00',3.89),('15844','2013-04-14','12:10:00',3.89),('15844','2013-04-14','12:15:00',3.87),('15844','2013-04-14','12:20:00',3.84),('15844','2013-04-14','12:25:00',3.91),('15844','2013-04-14','12:30:00',3.91),('15844','2013-04-14','12:35:00',3.86),('15844','2013-04-14','12:40:00',3.88),('15844','2013-04-14','12:45:00',3.93),('15844','2013-04-14','12:50:00',3.88),('15844','2013-04-14','12:55:00',3.85),('15844','2013-04-14','13:00:00',3.88),('15844','2013-04-14','13:05:00',3.81),('15844','2013-04-14','13:10:00',3.82),('15844','2013-04-14','13:15:00',3.83),('15844','2013-04-14','13:20:00',3.9),('15844','2013-04-14','13:25:00',1.81),('15844','2013-04-14','13:35:00',3.08),('15844','2013-04-14','13:40:00',1.82),('15844','2013-04-14','13:45:00',3.2),('15844','2013-04-14','13:50:00',3.68),('15844','2013-04-14','13:55:00',3.48),('15844','2013-04-14','14:00:00',3.31),('15844','2013-04-14','14:05:00',2.81),('15844','2013-04-14','14:10:00',3.16),('15844','2013-04-14','14:15:00',3.01),('15844','2013-04-14','14:20:00',2.12),('15844','2013-04-14','14:25:00',2.88),('15844','2013-04-14','14:30:00',2.86),('15844','2013-04-14','14:35:00',2.74),('15844','2013-04-14','14:40:00',2.6),('15844','2013-04-14','14:45:00',2.49),('15844','2013-04-14','14:50:00',2.44),('15844','2013-04-14','14:55:00',2.48),('15844','2013-04-14','15:00:00',2.29),('15844','2013-04-14','15:05:00',2.28),('15844','2013-04-14','15:10:00',2.31),('15844','2013-04-14','15:15:00',1.89),('15844','2013-04-14','15:20:00',1.98),('15844','2013-04-14','15:25:00',1.89),('15844','2013-04-14','15:30:00',1.82),('15844','2013-04-14','15:35:00',1.74),('15844','2013-04-14','15:40:00',1.65),('15844','2013-04-14','15:45:00',1.55),('15844','2013-04-14','15:50:00',1.41),('15844','2013-04-14','15:55:00',1.27),('15844','2013-04-14','16:00:00',1.18),('15844','2013-04-14','16:05:00',1.13),('15844','2013-04-14','16:10:00',1.06),('15844','2013-04-14','16:15:00',1.01),('15844','2013-04-13','08:15:00',1.11),('15844','2013-04-13','09:00:00',1.64),('15844','2013-04-13','09:05:00',1.48),('15844','2013-04-13','09:10:00',1.69),('15844','2013-04-13','09:15:00',1.75),('15844','2013-04-13','09:20:00',1.96),('15844','2013-04-13','09:25:00',2.1),('15844','2013-04-13','09:30:00',2.24),('15844','2013-04-13','09:35:00',2),('15844','2013-04-13','09:40:00',2.34),('15844','2013-04-13','09:45:00',2.43),('15844','2013-04-13','09:50:00',2.59),('15844','2013-04-13','09:55:00',2.69),('15844','2013-04-13','10:00:00',2.74),('15844','2013-04-13','10:05:00',2.97),('15844','2013-04-13','10:10:00',2.81),('15844','2013-04-13','10:15:00',3.16),('15844','2013-04-13','10:20:00',3.3),('15844','2013-04-13','10:25:00',2.23),('15844','2013-04-13','10:30:00',2.42),('15844','2013-04-13','10:35:00',1.25),('15844','2013-04-13','10:40:00',1.64),('15844','2013-04-13','10:45:00',1.18),('15844','2013-04-13','10:50:00',3.44),('15844','2013-04-13','10:55:00',2.96),('15844','2013-04-13','11:05:00',2.83),('15844','2013-04-13','11:10:00',3.77),('15844','2013-04-13','11:15:00',3.29),('15844','2013-04-13','11:20:00',1.73),('15844','2013-04-13','11:25:00',4.07),('15844','2013-04-13','11:30:00',2.72),('15844','2013-04-13','11:40:00',3.45),('15844','2013-04-13','11:45:00',4.25),('15844','2013-04-13','11:50:00',3.65),('15844','2013-04-13','11:55:00',2.65),('15844','2013-04-13','12:00:00',4.36),('15844','2013-04-13','12:05:00',3.03),('15844','2013-04-13','12:10:00',4.04),('15844','2013-04-13','12:15:00',3.92),('15844','2013-04-13','12:20:00',4.28),('15844','2013-04-13','12:25:00',3.82),('15844','2013-04-13','12:30:00',4.18),('15844','2013-04-13','12:35:00',4.17),('15844','2013-04-13','12:40:00',4.05),('15844','2013-04-13','12:45:00',2.56),('15844','2013-04-13','12:50:00',3.81),('15844','2013-04-13','12:55:00',3.86),('15844','2013-04-13','13:00:00',3.81),('15844','2013-04-13','13:05:00',4),('15844','2013-04-13','13:10:00',3.89),('15844','2013-04-13','13:15:00',3.71),('15844','2013-04-13','13:20:00',3.63),('15844','2013-04-13','13:25:00',3.66),('15844','2013-04-13','13:30:00',3.28),('15844','2013-04-13','13:35:00',3.27),('15844','2013-04-13','13:40:00',3.21),('15844','2013-04-13','13:45:00',2.96),('15844','2013-04-13','13:50:00',2.78),('15844','2013-04-13','13:55:00',3),('15844','2013-04-13','14:00:00',2.82),('15844','2013-04-13','14:05:00',2.49),('15844','2013-04-13','14:10:00',2.47),('15844','2013-04-13','14:15:00',2.66),('15844','2013-04-13','14:20:00',2.63),('15844','2013-04-13','14:25:00',2.81),('15844','2013-04-13','14:30:00',2.89),('15844','2013-04-13','14:35:00',2.82),('15844','2013-04-13','14:40:00',2.67),('15844','2013-04-13','14:45:00',2.61),('15844','2013-04-13','14:50:00',2.46),('15844','2013-04-13','14:55:00',2.35),('15844','2013-04-13','15:00:00',2.17),('15844','2013-04-13','15:05:00',2.17),('15844','2013-04-13','15:10:00',2.01),('15844','2013-04-13','15:15:00',1.94),('15844','2013-04-13','15:20:00',1.85),('15844','2013-04-13','15:25:00',1.77),('15844','2013-04-13','15:30:00',1.74),('15844','2013-04-13','15:35:00',1.67),('15844','2013-04-13','15:40:00',1.68),('15844','2013-04-13','15:45:00',1.64),('15844','2013-04-13','15:50:00',1.56),('15844','2013-04-13','15:55:00',1.49),('15844','2013-04-13','16:00:00',1.49),('15844','2013-04-13','16:05:00',1.38),('15844','2013-04-13','16:10:00',1.35),('15844','2013-04-13','16:15:00',1.31),('15844','2013-04-13','16:20:00',1.3),('15844','2013-04-13','16:25:00',1.19),('15844','2013-04-13','16:30:00',1.15),('15844','2013-04-13','16:35:00',1.06),('15844','2013-04-12','08:45:00',1.07),('15844','2013-04-12','08:50:00',1.04),('15844','2013-04-12','09:40:00',1.08),('15844','2013-04-12','09:45:00',2.06),('15844','2013-04-12','09:50:00',1.32),('15844','2013-04-12','09:55:00',1.15),('15844','2013-04-12','10:00:00',1.18),('15844','2013-04-12','10:10:00',1.06),('15844','2013-04-12','10:15:00',1.32),('15844','2013-04-12','10:20:00',1.72),('15844','2013-04-12','10:30:00',1.15),('15844','2013-04-12','10:35:00',1.67),('15844','2013-04-12','10:40:00',1.41),('15844','2013-04-12','10:45:00',1.19),('15844','2013-04-12','10:50:00',1.27),('15844','2013-04-12','10:55:00',2.02),('15844','2013-04-12','11:00:00',1.72),('15844','2013-04-12','11:05:00',2.93),('15844','2013-04-12','11:10:00',2.86),('15844','2013-04-12','11:15:00',4.33),('15844','2013-04-12','11:20:00',3.78),('15844','2013-04-12','11:25:00',2.36),('15844','2013-04-12','11:30:00',2.65),('15844','2013-04-12','11:35:00',4.33),('15844','2013-04-12','11:40:00',4.53),('15844','2013-04-12','11:45:00',3.56),('15844','2013-04-12','11:50:00',4.13),('15844','2013-04-12','11:55:00',4.08),('15844','2013-04-12','12:00:00',3.64),('15844','2013-04-12','12:05:00',3.82),('15844','2013-04-12','12:10:00',3.77),('15844','2013-04-12','12:15:00',4.16),('15844','2013-04-12','12:20:00',4.14),('15844','2013-04-12','12:25:00',4.12),('15844','2013-04-12','12:30:00',4.07),('15844','2013-04-12','12:35:00',3.95),('15844','2013-04-12','12:40:00',3.93),('15844','2013-04-12','12:45:00',3.7),('15844','2013-04-12','12:50:00',3.78),('15844','2013-04-12','12:55:00',3.92),('15844','2013-04-12','13:00:00',3.93),('15844','2013-04-12','13:05:00',3.86),('15844','2013-04-12','13:10:00',3.88),('15844','2013-04-12','13:15:00',3.85),('15844','2013-04-12','13:20:00',3.87),('15844','2013-04-12','13:25:00',3.82),('15844','2013-04-12','13:30:00',3.76),('15844','2013-04-12','13:35:00',3.69),('15844','2013-04-12','13:40:00',3.64),('15844','2013-04-12','13:45:00',3.59),('15844','2013-04-12','13:50:00',3.54),('15844','2013-04-12','13:55:00',3.47),('15844','2013-04-12','14:00:00',3.42),('15844','2013-04-12','14:05:00',3.31),('15844','2013-04-12','14:10:00',3.26),('15844','2013-04-12','14:15:00',3.18),('15844','2013-04-12','14:20:00',3.07),('15844','2013-04-12','14:25:00',2.95),('15844','2013-04-12','14:30:00',2.89),('15844','2013-04-12','14:35:00',2.77),('15844','2013-04-12','14:40:00',2.65),('15844','2013-04-12','14:45:00',2.54),('15844','2013-04-12','14:50:00',2.48),('15844','2013-04-12','14:55:00',2.43),('15844','2013-04-12','15:00:00',2.33),('15844','2013-04-12','15:05:00',2.24),('15844','2013-04-12','15:10:00',2.14),('15844','2013-04-12','15:15:00',2.03),('15844','2013-04-12','15:20:00',1.96),('15844','2013-04-12','15:25:00',1.88),('15844','2013-04-12','15:30:00',1.79),('15844','2013-04-12','15:35:00',1.68),('15844','2013-04-12','15:40:00',1.57),('15844','2013-04-12','15:45:00',1.47),('15844','2013-04-12','15:50:00',1.35),('15844','2013-04-12','15:55:00',1.24),('15844','2013-04-12','16:00:00',1.16),('15844','2013-04-12','16:05:00',1.11),('15844','2013-04-12','16:10:00',1.02),('15844','2013-04-12','16:15:00',1.13),('15844','2014-03-28','07:40:00',1.03),('15844','2014-03-28','07:45:00',1.09),('15844','2014-03-28','07:50:00',1.14),('15844','2014-03-28','07:55:00',1.21),('15844','2014-03-28','08:00:00',1.29),('15844','2014-03-28','08:05:00',1.4),('15844','2014-03-28','08:10:00',1.52),('15844','2014-03-28','08:15:00',1.74),('15844','2014-03-28','08:20:00',1.85),('15844','2014-03-28','08:25:00',1.95),('15844','2014-03-28','08:30:00',2.09),('15844','2014-03-28','08:35:00',2.16),('15844','2014-03-28','08:40:00',2.22),('15844','2014-03-28','08:45:00',2.29),('15844','2014-03-28','08:50:00',2.4),('15844','2014-03-28','08:55:00',2.52),('15844','2014-03-28','09:00:00',2.64),('15844','2014-03-28','09:05:00',2.8),('15844','2014-03-28','09:10:00',2.92),('15844','2014-03-28','09:15:00',2.88),('15844','2014-03-28','09:20:00',3.21),('15844','2014-03-28','09:25:00',3.18),('15844','2014-03-28','09:30:00',3.2),('15844','2014-03-28','09:35:00',2.28),('15844','2014-03-28','09:40:00',1.81),('15844','2014-03-28','09:45:00',2.91),('15844','2014-03-28','09:50:00',3.12),('15844','2014-03-28','09:55:00',3.41),('15844','2014-03-28','10:00:00',3.42),('15844','2014-03-28','10:05:00',3.78),('15844','2014-03-28','10:10:00',3.39),('15844','2014-03-28','10:15:00',3.33),('15844','2014-03-28','10:20:00',2.94),('15844','2014-03-28','10:25:00',2.85),('15844','2014-03-28','10:30:00',3),('15844','2014-03-28','10:35:00',3.77),('15844','2014-03-28','10:40:00',3.91),('15844','2014-03-28','10:45:00',3.91),('15844','2014-03-28','10:50:00',3.86),('15844','2014-03-28','10:55:00',3.88),('15844','2014-03-28','11:00:00',3.85),('15844','2014-03-28','11:05:00',3.86),('15844','2014-03-28','11:10:00',3.89),('15844','2014-03-28','11:15:00',2.36),('15844','2014-03-28','11:20:00',4.25),('15844','2014-03-28','11:25:00',2.82),('15844','2014-03-28','11:30:00',3.82),('15844','2014-03-28','11:35:00',1.7),('15844','2014-03-28','11:40:00',2.33),('15844','2014-03-28','11:45:00',2.71),('15844','2014-03-28','11:50:00',2),('15844','2014-03-28','11:55:00',2.48),('15844','2014-03-28','12:00:00',1.48),('15844','2014-03-28','12:05:00',3.22),('15844','2014-03-28','12:10:00',3.58),('15844','2014-03-28','12:15:00',4.12),('15844','2014-03-28','12:20:00',2.44),('15844','2014-03-28','12:25:00',3.31),('15844','2014-03-28','12:30:00',3.79),('15844','2014-03-28','12:35:00',3.78),('15844','2014-03-28','12:40:00',3.73),('15844','2014-03-28','12:45:00',3.81),('15844','2014-03-28','12:50:00',3.9),('15844','2014-03-28','12:55:00',4.11),('15844','2014-03-28','13:00:00',3.59),('15844','2014-03-28','13:05:00',3.79),('15844','2014-03-28','13:10:00',4.07),('15844','2014-03-28','13:15:00',4.28),('15844','2014-03-28','13:20:00',4.05),('15844','2014-03-28','13:25:00',3.38),('15844','2014-03-28','13:30:00',3.48),('15844','2014-03-28','13:35:00',1.99),('15844','2014-03-28','13:40:00',2.47),('15844','2014-03-28','13:45:00',2.71),('15844','2014-03-28','13:50:00',2.53),('15844','2014-03-28','13:55:00',2.3),('15844','2014-03-28','14:00:00',2.27),('15844','2014-03-28','14:05:00',2.17),('15844','2014-03-28','14:10:00',2.04),('15844','2014-03-28','14:15:00',1.93),('15844','2014-03-28','14:20:00',1.8),('15844','2014-03-28','14:25:00',1.73),('15844','2014-03-28','14:30:00',1.65),('15844','2014-03-28','14:35:00',1.55),('15844','2014-03-28','14:40:00',1.44),('15844','2014-03-28','14:45:00',1.34),('15844','2014-03-28','14:50:00',1.26),('15844','2014-03-28','14:55:00',1.22),('15844','2014-03-28','15:00:00',1.14),('15844','2014-03-28','15:05:00',1.06),('15844','2013-04-11','08:40:00',1),('15844','2013-04-11','08:45:00',1.15),('15844','2013-04-11','08:50:00',1.3),('15844','2013-04-11','08:55:00',1.37),('15844','2013-04-11','09:00:00',1.44),('15844','2013-04-11','09:05:00',1.61),('15844','2013-04-11','09:10:00',1.74),('15844','2013-04-11','09:15:00',1.83),('15844','2013-04-11','09:20:00',1.94),('15844','2013-04-11','09:25:00',2.02),('15844','2013-04-11','09:30:00',2.19),('15844','2013-04-11','09:35:00',2.38),('15844','2013-04-11','09:40:00',2.48),('15844','2013-04-11','09:45:00',2.46),('15844','2013-04-11','09:50:00',2.61),('15844','2013-04-11','09:55:00',2.62),('15844','2013-04-11','10:00:00',1.46),('15844','2013-04-11','10:05:00',2.41),('15844','2013-04-11','10:10:00',2.38),('15844','2013-04-11','10:15:00',1.82),('15844','2013-04-11','10:20:00',3.11),('15844','2013-04-11','10:25:00',3.21),('15844','2013-04-11','10:30:00',3.31),('15844','2013-04-11','10:35:00',3.54),('15844','2013-04-11','10:40:00',2.46),('15844','2013-04-11','10:45:00',3.63),('15844','2013-04-11','10:50:00',3.83),('15844','2013-04-11','10:55:00',2.85),('15844','2013-04-11','11:00:00',2.27),('15844','2013-04-11','11:05:00',3.04),('15844','2013-04-11','11:10:00',4.48),('15844','2013-04-11','11:15:00',2.99),('15844','2013-04-11','11:30:00',2.17),('15844','2013-04-11','11:40:00',1.98),('15844','2013-04-11','11:45:00',4.7),('15844','2013-04-11','11:50:00',3.63),('15844','2013-04-11','11:55:00',4.39),('15844','2013-04-11','12:00:00',2.85),('15844','2013-04-11','12:05:00',4.42),('15844','2013-04-11','12:10:00',3.04),('15844','2013-04-11','12:15:00',4.32),('15844','2013-04-11','12:20:00',3.68),('15844','2013-04-11','12:25:00',3.39),('15844','2013-04-11','12:30:00',4.41),('15844','2013-04-11','12:35:00',3.63),('15844','2013-04-11','12:40:00',3.17),('15844','2013-04-11','12:45:00',4.26),('15844','2013-04-11','12:50:00',1.88),('15844','2013-04-11','12:55:00',4.46),('15844','2013-04-11','13:00:00',4.38),('15844','2013-04-11','13:05:00',4.22),('15844','2013-04-11','13:10:00',4.1),('15844','2013-04-11','13:15:00',4.12),('15844','2013-04-11','13:20:00',4.14),('15844','2013-04-11','13:25:00',3.91),('15844','2013-04-11','13:30:00',2.2),('15844','2013-04-11','13:35:00',3.14),('15844','2013-04-11','13:40:00',3.44),('15844','2013-04-11','13:45:00',3.39),('15844','2013-04-11','13:50:00',3.9),('15844','2013-04-11','13:55:00',3.65),('15844','2013-04-11','14:00:00',3.51),('15844','2013-04-11','14:05:00',3.51),('15844','2013-04-11','14:10:00',3.48),('15844','2013-04-11','14:15:00',3.42),('15844','2013-04-11','14:20:00',3.31),('15844','2013-04-11','14:25:00',2.77),('15844','2013-04-11','14:30:00',3.08),('15844','2013-04-11','14:35:00',2.87),('15844','2013-04-11','14:40:00',2.31),('15844','2013-04-11','14:45:00',1.79),('15844','2013-04-11','14:50:00',2.57),('15844','2013-04-11','14:55:00',2.51),('15844','2013-04-11','15:00:00',1.87),('15844','2013-04-11','15:05:00',1.95),('15844','2013-04-11','15:10:00',2.2),('15844','2013-04-11','15:15:00',2.12),('15844','2013-04-11','15:20:00',2),('15844','2013-04-11','15:25:00',1.92),('15844','2013-04-11','15:30:00',1.81),('15844','2013-04-11','15:35:00',1.69),('15844','2013-04-11','15:40:00',1.43),('15844','2013-04-11','15:45:00',1.47),('15844','2013-04-11','15:50:00',1.35),('15844','2013-04-11','15:55:00',1.24),('15844','2013-04-11','16:00:00',1.19),('15844','2013-04-11','16:05:00',1.14),('15844','2013-04-11','16:10:00',1.07),('15844','2013-04-10','08:40:00',1.56),('15844','2013-04-10','08:45:00',1.69),('15844','2013-04-10','08:50:00',1.67),('15844','2013-04-10','08:55:00',1.64),('15844','2013-04-10','09:00:00',1.73),('15844','2013-04-10','09:05:00',1.24),('15844','2013-04-10','09:10:00',1.03),('15844','2013-04-10','09:15:00',1.68),('15844','2013-04-10','09:20:00',1.82),('15844','2013-04-10','09:25:00',1.94),('15844','2013-04-10','09:30:00',2.1),('15844','2013-04-10','09:35:00',2.27),('15844','2013-04-10','09:40:00',2.36),('15844','2013-04-10','09:45:00',2.45),('15844','2013-04-10','09:50:00',2.01),('15844','2013-04-10','09:55:00',2.45),('15844','2013-04-10','10:00:00',2.66),('15844','2013-04-10','10:05:00',2.96),('15844','2013-04-10','10:10:00',3.06),('15844','2013-04-10','10:15:00',3.14),('15844','2013-04-10','10:20:00',3.23),('15844','2013-04-10','10:25:00',3.28),('15844','2013-04-10','10:30:00',3.29),('15844','2013-04-10','10:35:00',3.46),('15844','2013-04-10','10:40:00',3.6),('15844','2013-04-10','10:45:00',3.68),('15844','2013-04-10','10:50:00',3.5),('15844','2013-04-10','10:55:00',3.74),('15844','2013-04-10','11:00:00',2.98),('15844','2013-04-10','11:05:00',3.68),('15844','2013-04-10','11:10:00',2.53),('15844','2013-04-10','11:15:00',3.57),('15844','2013-04-10','11:20:00',4.19),('15844','2013-04-10','11:25:00',3.04),('15844','2013-04-10','11:30:00',4.24),('15844','2013-04-10','11:35:00',4.3),('15844','2013-04-10','11:40:00',2.55),('15844','2013-04-10','11:45:00',3.61),('15844','2013-04-10','11:50:00',3.3),('15844','2013-04-10','11:55:00',3.91),('15844','2013-04-10','12:00:00',3.65),('15844','2013-04-10','12:05:00',1.85),('15844','2013-04-10','12:10:00',1.93),('15844','2013-04-10','12:15:00',1.11),('15844','2013-04-10','12:20:00',3.47),('15844','2013-04-10','12:25:00',2.72),('15844','2013-04-10','12:30:00',4.32),('15844','2013-04-10','12:35:00',2.15),('15844','2013-04-10','12:40:00',4.32),('15844','2013-04-10','12:45:00',4.2),('15844','2013-04-10','12:50:00',4.22),('15844','2013-04-10','12:55:00',3.96),('15844','2013-04-10','13:00:00',4.22),('15844','2013-04-10','13:05:00',4.1),('15844','2013-04-10','13:10:00',3.77),('15844','2013-04-10','13:15:00',3.39),('15844','2013-04-10','13:20:00',4.11),('15844','2013-04-10','13:25:00',3.31),('15844','2013-04-10','13:30:00',3.35),('15844','2013-04-10','13:35:00',3.57),('15844','2013-04-10','13:40:00',3.89),('15844','2013-04-10','13:45:00',3.53),('15844','2013-04-10','13:50:00',3.45),('15844','2013-04-10','13:55:00',3.39),('15844','2013-04-10','14:00:00',3.51),('15844','2013-04-10','14:05:00',3.09),('15844','2013-04-10','14:10:00',3.24),('15844','2013-04-10','14:15:00',2.79),('15844','2013-04-10','14:20:00',3),('15844','2013-04-10','14:25:00',1.86),('15844','2013-04-10','14:30:00',2.84),('15844','2013-04-10','14:35:00',3.05),('15844','2013-04-10','14:40:00',2.53),('15844','2013-04-10','14:45:00',2.66),('15844','2013-04-10','14:50:00',2.57),('15844','2013-04-10','14:55:00',2.45),('15844','2013-04-10','15:00:00',2.13),('15844','2013-04-10','15:05:00',2.36),('15844','2013-04-10','15:10:00',2.31),('15844','2013-04-10','15:15:00',2.22),('15844','2013-04-10','15:20:00',1.76),('15844','2013-04-10','15:25:00',1.95),('15844','2013-04-10','15:30:00',1.82),('15844','2013-04-10','15:35:00',1.73),('15844','2013-04-10','15:40:00',1.69),('15844','2013-04-10','15:45:00',1.53),('15844','2013-04-10','15:50:00',1.44),('15844','2013-04-10','15:55:00',1.32),('15844','2013-04-10','16:00:00',1.21),('15844','2013-04-10','16:05:00',1.19),('15844','2013-04-10','16:10:00',1.14),('15844','2013-04-10','16:15:00',1.07),('15844','2013-04-10','16:20:00',1.08),('15844','2013-04-09','08:20:00',1.01),('15844','2013-04-09','08:35:00',1.24),('15844','2013-04-09','08:40:00',1.09),('15844','2013-04-09','08:50:00',1.21),('15844','2013-04-09','08:55:00',1.2),('15844','2013-04-09','09:00:00',1.11),('15844','2013-04-09','09:35:00',1.82),('15844','2013-04-09','09:40:00',2.37),('15844','2013-04-09','09:45:00',2.76),('15844','2013-04-09','09:50:00',1.46),('15844','2013-04-09','10:20:00',2.11),('15844','2013-04-09','10:25:00',2.94),('15844','2013-04-09','10:30:00',3.77),('15844','2013-04-09','10:35:00',1.14),('15844','2013-04-09','10:40:00',1.95),('15844','2013-04-09','10:45:00',2.03),('15844','2013-04-09','10:50:00',1.28),('15844','2013-04-09','10:55:00',4.46),('15844','2013-04-09','11:00:00',3.39),('15844','2013-04-09','11:05:00',3.37),('15844','2013-04-09','11:10:00',3.89),('15844','2013-04-09','11:15:00',1.89),('15844','2013-04-09','11:20:00',3.87),('15844','2013-04-09','11:25:00',3.47),('15844','2013-04-09','11:30:00',1.57),('15844','2013-04-09','11:35:00',4.52),('15844','2013-04-09','11:40:00',2.06),('15844','2013-04-09','11:45:00',1.06),('15844','2013-04-09','11:50:00',3.66),('15844','2013-04-09','11:55:00',4.15),('15844','2013-04-09','12:00:00',1.5),('15844','2013-04-09','12:05:00',3.49),('15844','2013-04-09','12:10:00',1.92),('15844','2013-04-09','12:15:00',3.74),('15844','2013-04-09','12:20:00',4.51),('15844','2013-04-09','12:25:00',4.27),('15844','2013-04-09','12:30:00',1.44),('15844','2013-04-09','12:35:00',3.03),('15844','2013-04-09','12:40:00',2.48),('15844','2013-04-09','12:45:00',1.25),('15844','2013-04-09','12:50:00',3.36),('15844','2013-04-09','12:55:00',3.41),('15844','2013-04-09','13:00:00',3.78),('15844','2013-04-09','13:05:00',3.77),('15844','2013-04-09','13:10:00',3.5),('15844','2013-04-09','13:15:00',2.85),('15844','2013-04-09','13:20:00',4.05),('15844','2013-04-09','13:25:00',1.55),('15844','2013-04-09','13:30:00',3.56),('15844','2013-04-09','13:35:00',1.24),('15844','2013-04-09','13:40:00',3.22),('15844','2013-04-09','13:45:00',3.8),('15844','2013-04-09','13:50:00',3.61),('15844','2013-04-09','13:55:00',3.07),('15844','2013-04-09','14:00:00',2.98),('15844','2013-04-09','14:05:00',3.28),('15844','2013-04-09','14:10:00',2.34),('15844','2013-04-09','14:15:00',3.08),('15844','2013-04-09','14:20:00',2.49),('15844','2013-04-09','14:25:00',2.75),('15844','2013-04-09','14:30:00',2.74),('15844','2013-04-09','14:35:00',2.78),('15844','2013-04-09','14:40:00',2.5),('15844','2013-04-09','14:45:00',1.95),('15844','2013-04-09','14:50:00',1.85),('15844','2013-04-09','14:55:00',2.67),('15844','2013-04-09','15:00:00',2.05),('15844','2013-04-09','15:05:00',2.1),('15844','2013-04-09','15:10:00',2.27),('15844','2013-04-09','15:15:00',2.15),('15844','2013-04-09','15:20:00',2.09),('15844','2013-04-09','15:25:00',2.02),('15844','2013-04-09','15:30:00',1.91),('15844','2013-04-09','15:35:00',1.75),('15844','2013-04-09','15:40:00',1.7),('15844','2013-04-09','15:45:00',1.53),('15844','2013-04-09','15:50:00',1.41),('15844','2013-04-09','15:55:00',1.05),('15844','2013-04-09','16:00:00',1.16),('15844','2013-04-09','16:05:00',1.3),('15844','2013-04-09','16:10:00',1.17),('15844','2013-04-09','16:15:00',1.06),('15844','2013-04-09','16:20:00',1.07),('15844','2013-04-09','16:25:00',1.09),('15844','2013-04-08','08:45:00',1.13),('15844','2013-04-08','08:50:00',1.19),('15844','2013-04-08','08:55:00',1.2),('15844','2013-04-08','09:00:00',1.35),('15844','2013-04-08','09:05:00',1.63),('15844','2013-04-08','09:10:00',1.57),('15844','2013-04-08','09:15:00',1.82),('15844','2013-04-08','09:20:00',2),('15844','2013-04-08','09:25:00',2.12),('15844','2013-04-08','09:30:00',2.28),('15844','2013-04-08','09:35:00',2.48),('15844','2013-04-08','09:40:00',2.39),('15844','2013-04-08','09:45:00',1.99),('15844','2013-04-08','09:50:00',1.15),('15844','2013-04-08','09:55:00',2.36),('15844','2013-04-08','10:00:00',2.76),('15844','2013-04-08','10:05:00',2.74),('15844','2013-04-08','10:10:00',2.88),('15844','2013-04-08','10:15:00',2.89),('15844','2013-04-08','10:20:00',2.9),('15844','2013-04-08','10:25:00',2.87),('15844','2013-04-08','10:30:00',2.72),('15844','2013-04-08','10:35:00',3.2),('15844','2013-04-08','10:40:00',3.39),('15844','2013-04-08','10:45:00',3.44),('15844','2013-04-08','10:50:00',3.35),('15844','2013-04-08','10:55:00',3.4),('15844','2013-04-08','11:00:00',3.16),('15844','2013-04-08','11:05:00',2.93),('15844','2013-04-08','11:10:00',2.7),('15844','2013-04-08','11:15:00',2.22),('15844','2013-04-08','11:20:00',1.76),('15844','2013-04-08','11:25:00',1.94),('15844','2013-04-08','11:30:00',2.73),('15844','2013-04-08','11:35:00',2.7),('15844','2013-04-08','11:40:00',2.67),('15844','2013-04-08','11:45:00',2.31),('15844','2013-04-08','11:50:00',2.21),('15844','2013-04-08','11:55:00',2.13),('15844','2013-04-08','12:00:00',1.92),('15844','2013-04-08','12:05:00',1.98),('15844','2013-04-08','12:10:00',2.43),('15844','2013-04-08','12:15:00',2.43),('15844','2013-04-08','12:20:00',2.47),('15844','2013-04-08','12:25:00',2.52),('15844','2013-04-08','12:30:00',2.59),('15844','2013-04-08','12:35:00',2.35),('15844','2013-04-08','12:40:00',2.9),('15844','2013-04-08','12:45:00',2.16),('15844','2013-04-08','12:50:00',2.82),('15844','2013-04-08','12:55:00',2.22),('15844','2013-04-08','13:00:00',2.51),('15844','2013-04-08','13:05:00',2.7),('15844','2013-04-08','13:10:00',2.61),('15844','2013-04-08','13:15:00',3.22),('15844','2013-04-08','13:20:00',2.82),('15844','2013-04-08','13:25:00',2.34),('15844','2013-04-08','13:30:00',1.41),('15844','2013-04-08','13:35:00',2.3),('15844','2013-04-08','13:40:00',2.36),('15844','2013-04-08','13:45:00',2.78),('15844','2013-04-08','13:50:00',3.19),('15844','2013-04-08','13:55:00',2.91),('15844','2013-04-08','14:00:00',2.32),('15844','2013-04-08','14:05:00',2.67),('15844','2013-04-08','14:10:00',3.18),('15844','2013-04-08','14:15:00',2.6),('15844','2013-04-08','14:20:00',2.85),('15844','2013-04-08','14:25:00',2.88),('15844','2013-04-08','14:30:00',2.73),('15844','2013-04-08','14:35:00',2.68),('15844','2013-04-08','14:40:00',2.68),('15844','2013-04-08','14:45:00',2.59),('15844','2013-04-08','14:50:00',2.54),('15844','2013-04-08','14:55:00',2.22),('15844','2013-04-08','15:00:00',2.12),('15844','2013-04-08','15:05:00',2.27),('15844','2013-04-08','15:10:00',1.85),('15844','2013-04-08','15:15:00',1.75),('15844','2013-04-08','15:20:00',2.07),('15844','2013-04-08','15:25:00',1.98),('15844','2013-04-08','15:30:00',1.83),('15844','2013-04-08','15:35:00',1.71),('15844','2013-04-08','15:40:00',1.57),('15844','2013-04-08','15:45:00',1.42),('15844','2013-04-08','15:50:00',1.31),('15844','2013-04-08','15:55:00',1.24),('15844','2013-04-08','16:00:00',1.16),('15844','2013-04-08','16:05:00',1.06),('15844','2013-04-08','16:10:00',1.1),('15844','2013-04-08','16:15:00',1.07),('15844','2013-04-07','08:50:00',1.05),('15844','2013-04-07','08:55:00',1.11),('15844','2013-04-07','09:00:00',1.15),('15844','2013-04-07','09:05:00',1.18),('15844','2013-04-07','09:10:00',1.31),('15844','2013-04-07','09:15:00',1.32),('15844','2013-04-07','09:20:00',1.24),('15844','2013-04-07','09:25:00',1.31),('15844','2013-04-07','09:30:00',1.37),('15844','2013-04-07','09:35:00',1.59),('15844','2013-04-07','09:40:00',1.81),('15844','2013-04-07','09:45:00',1.78),('15844','2013-04-07','09:50:00',1.72),('15844','2013-04-07','09:55:00',1.5),('15844','2013-04-07','10:00:00',1.31),('15844','2013-04-07','10:05:00',1.79),('15844','2013-04-07','10:10:00',1.89),('15844','2013-04-07','10:15:00',2.19),('15844','2013-04-07','10:20:00',2.48),('15844','2013-04-07','10:25:00',2.58),('15844','2013-04-07','10:30:00',2.83),('15844','2013-04-07','10:35:00',3.03),('15844','2013-04-07','10:40:00',2.83),('15844','2013-04-07','10:45:00',2.66),('15844','2013-04-07','10:50:00',2.72),('15844','2013-04-07','10:55:00',1.05),('15844','2013-04-07','11:00:00',1.41),('15844','2013-04-07','11:05:00',2.45),('15844','2013-04-07','11:10:00',2.09),('15844','2013-04-07','11:15:00',1.98),('15844','2013-04-07','11:20:00',1.91),('15844','2013-04-07','11:25:00',2.17),('15844','2013-04-07','11:30:00',3.04),('15844','2013-04-07','11:35:00',3.5),('15844','2013-04-07','11:40:00',3.79),('15844','2013-04-07','11:45:00',3.71),('15844','2013-04-07','11:50:00',3.48),('15844','2013-04-07','11:55:00',2.75),('15844','2013-04-07','12:00:00',2.29),('15844','2013-04-07','12:05:00',2.4),('15844','2013-04-07','12:10:00',2.52),('15844','2013-04-07','12:15:00',2.25),('15844','2013-04-07','12:20:00',2.52),('15844','2013-04-07','12:25:00',2.82),('15844','2013-04-07','12:30:00',2.78),('15844','2013-04-07','12:35:00',2.9),('15844','2013-04-07','12:40:00',2.69),('15844','2013-04-07','12:45:00',2.78),('15844','2013-04-07','12:50:00',2.68),('15844','2013-04-07','12:55:00',2.51),('15844','2013-04-07','13:00:00',2.31),('15844','2013-04-07','13:05:00',2.51),('15844','2013-04-07','13:10:00',2.74),('15844','2013-04-07','13:15:00',2.81),('15844','2013-04-07','13:20:00',2.54),('15844','2013-04-07','13:25:00',2.22),('15844','2013-04-07','13:30:00',2.59),('15844','2013-04-07','13:35:00',2.87),('15844','2013-04-07','13:40:00',2.85),('15844','2013-04-07','13:45:00',2.55),('15844','2013-04-07','13:50:00',2.35),('15844','2013-04-07','13:55:00',2.19),('15844','2013-04-07','14:00:00',2.26),('15844','2013-04-07','14:05:00',2.37),('15844','2013-04-07','14:10:00',2.35),('15844','2013-04-07','14:15:00',2.38),('15844','2013-04-07','14:20:00',2.3),('15844','2013-04-07','14:25:00',2.27),('15844','2013-04-07','14:30:00',2.11),('15844','2013-04-07','14:35:00',2),('15844','2013-04-07','14:40:00',1.91),('15844','2013-04-07','14:45:00',1.83),('15844','2013-04-07','14:50:00',1.66),('15844','2013-04-07','14:55:00',1.59),('15844','2013-04-07','15:00:00',1.24),('15844','2013-04-07','15:05:00',1.03),('15844','2013-04-07','15:10:00',1.33),('15844','2013-04-07','15:15:00',1.42),('15844','2013-04-07','15:20:00',1.42),('15844','2013-04-07','15:25:00',1.52),('15844','2013-04-07','15:30:00',1.42),('15844','2013-04-07','15:35:00',1.5),('15844','2013-04-07','15:40:00',1.42),('15844','2013-04-07','15:45:00',1.45),('15844','2013-04-07','15:50:00',1.43),('15844','2013-04-07','15:55:00',1.28),('15844','2013-04-07','16:00:00',1.14),('15844','2013-04-07','16:05:00',1.01),('15844','2013-04-07','16:25:00',1.02),('15844','2013-04-06','08:45:00',1.03),('15844','2013-04-06','08:50:00',1.21),('15844','2013-04-06','08:55:00',1.34),('15844','2013-04-06','09:00:00',1.39),('15844','2013-04-06','09:05:00',1.51),('15844','2013-04-06','09:10:00',1.67),('15844','2013-04-06','09:15:00',1.81),('15844','2013-04-06','09:20:00',1.94),('15844','2013-04-06','09:25:00',2.09),('15844','2013-04-06','09:30:00',2.21),('15844','2013-04-06','09:35:00',2.27),('15844','2013-04-06','09:40:00',2.43),('15844','2013-04-06','09:45:00',2.49),('15844','2013-04-06','09:50:00',2.55),('15844','2013-04-06','09:55:00',2.63),('15844','2013-04-06','10:00:00',2.69),('15844','2013-04-06','10:05:00',2.79),('15844','2013-04-06','10:10:00',2.9),('15844','2013-04-06','10:15:00',2.92),('15844','2013-04-06','10:20:00',2.95),('15844','2013-04-06','10:25:00',3.05),('15844','2013-04-06','10:30:00',3.1),('15844','2013-04-06','10:35:00',3.11),('15844','2013-04-06','10:40:00',3.25),('15844','2013-04-06','10:45:00',3.41),('15844','2013-04-06','10:50:00',3.49),('15844','2013-04-06','10:55:00',3.56),('15844','2013-04-06','11:00:00',3.69),('15844','2013-04-06','11:05:00',3.75),('15844','2013-04-06','11:10:00',3.8),('15844','2013-04-06','11:15:00',3.76),('15844','2013-04-06','11:20:00',3.84),('15844','2013-04-06','11:25:00',3.92),('15844','2013-04-06','11:30:00',4),('15844','2013-04-06','11:35:00',4.06),('15844','2013-04-06','11:40:00',4.04),('15844','2013-04-06','11:45:00',4.04),('15844','2013-04-06','11:50:00',4),('15844','2013-04-06','11:55:00',3.94),('15844','2013-04-06','12:00:00',3.96),('15844','2013-04-06','12:05:00',3.98),('15844','2013-04-06','12:10:00',3.96),('15844','2013-04-06','12:15:00',3.58),('15844','2013-04-06','12:20:00',4.04),('15844','2013-04-06','12:25:00',4.12),('15844','2013-04-06','12:30:00',3.87),('15844','2013-04-06','12:35:00',3.95),('15844','2013-04-06','12:40:00',3.8),('15844','2013-04-06','12:45:00',3.66),('15844','2013-04-06','12:50:00',3.92),('15844','2013-04-06','12:55:00',2.79),('15844','2013-04-06','13:00:00',3.8),('15844','2013-04-06','13:05:00',1.82),('15844','2013-04-06','13:10:00',1.18),('15844','2013-04-06','13:15:00',3.52),('15844','2013-04-06','13:20:00',3.92),('15844','2013-04-06','13:25:00',3.01),('15844','2013-04-06','13:30:00',3.78),('15844','2013-04-06','13:35:00',2.64),('15844','2013-04-06','13:40:00',3.61),('15844','2013-04-06','13:45:00',1.29),('15844','2013-04-06','13:50:00',4.01),('15844','2013-04-06','13:55:00',3.89),('15844','2013-04-06','14:00:00',3.81),('15844','2013-04-06','14:05:00',3.54),('15844','2013-04-06','14:10:00',2.45),('15844','2013-04-06','14:15:00',3.61),('15844','2013-04-06','14:20:00',3.07),('15844','2013-04-06','14:25:00',2.93),('15844','2013-04-06','14:30:00',2.88),('15844','2013-04-06','14:35:00',2.76),('15844','2013-04-06','14:40:00',2.64),('15844','2013-04-06','14:45:00',2.55),('15844','2013-04-06','14:50:00',2.43),('15844','2013-04-06','14:55:00',2.43),('15844','2013-04-06','15:00:00',2.32),('15844','2013-04-06','15:05:00',2.2),('15844','2013-04-06','15:10:00',2.07),('15844','2013-04-06','15:15:00',1.99),('15844','2013-04-06','15:20:00',1.89),('15844','2013-04-06','15:25:00',1.78),('15844','2013-04-06','15:30:00',1.65),('15844','2013-04-06','15:35:00',1.63),('15844','2013-04-06','15:40:00',1.52),('15844','2013-04-06','15:45:00',1.41),('15844','2013-04-06','15:50:00',1.3),('15844','2013-04-06','15:55:00',1.25),('15844','2013-04-06','16:00:00',1.09),('15844','2013-04-06','16:05:00',1.02),('15844','2013-04-06','16:10:00',1.08),('15844','2013-04-06','16:15:00',1.06),('15844','2013-04-05','08:45:00',1.06),('15844','2013-04-05','08:50:00',1.38),('15844','2013-04-05','08:55:00',1.13),('15844','2013-04-05','09:20:00',1.03),('15844','2013-04-05','09:25:00',1.1),('15844','2013-04-05','09:30:00',1.31),('15844','2013-04-05','09:40:00',1.44),('15844','2013-04-05','09:45:00',1.65),('15844','2013-04-05','09:50:00',1.01),('15844','2013-04-05','10:05:00',2.21),('15844','2013-04-05','10:10:00',2.41),('15844','2013-04-05','10:15:00',1.75),('15844','2013-04-05','10:20:00',1.86),('15844','2013-04-05','10:25:00',2.93),('15844','2013-04-05','10:30:00',2.81),('15844','2013-04-05','10:35:00',3.44),('15844','2013-04-05','10:40:00',3.07),('15844','2013-04-05','10:45:00',2.39),('15844','2013-04-05','10:50:00',2.32),('15844','2013-04-05','10:55:00',3.43),('15844','2013-04-05','11:00:00',3.34),('15844','2013-04-05','11:05:00',3.52),('15844','2013-04-05','11:10:00',2.81),('15844','2013-04-05','11:15:00',4.07),('15844','2013-04-05','11:20:00',4.05),('15844','2013-04-05','11:25:00',4.02),('15844','2013-04-05','11:30:00',4.08),('15844','2013-04-05','11:35:00',4.01),('15844','2013-04-05','11:40:00',4.11),('15844','2013-04-05','11:45:00',4.22),('15844','2013-04-05','11:50:00',3.78),('15844','2013-04-05','11:55:00',3.42),('15844','2013-04-05','12:00:00',3),('15844','2013-04-05','12:05:00',3.9),('15844','2013-04-05','12:10:00',4.39),('15844','2013-04-05','12:15:00',2.33),('15844','2013-04-05','12:20:00',1.41),('15844','2013-04-05','12:25:00',1.24),('15844','2013-04-05','12:30:00',2.78),('15844','2013-04-05','12:35:00',1.14),('15844','2013-04-05','12:40:00',2.12),('15844','2013-04-05','12:45:00',3.05),('15844','2013-04-05','12:50:00',3.47),('15844','2013-04-05','12:55:00',4.35),('15844','2013-04-05','13:00:00',4.18),('15844','2013-04-05','13:05:00',3.04),('15844','2013-04-05','13:10:00',2.7),('15844','2013-04-05','13:15:00',3.58),('15844','2013-04-05','13:20:00',2.77),('15844','2013-04-05','13:25:00',3.19),('15844','2013-04-05','13:30:00',3.77),('15844','2013-04-05','13:35:00',3.77),('15844','2013-04-05','13:40:00',3.05),('15844','2013-04-05','13:45:00',3.22),('15844','2013-04-05','13:50:00',3.39),('15844','2013-04-05','13:55:00',2.74),('15844','2013-04-05','14:00:00',2.83),('15844','2013-04-05','14:05:00',2.54),('15844','2013-04-05','14:10:00',2.6),('15844','2013-04-05','14:15:00',2.06),('15844','2013-04-05','14:20:00',2.56),('15844','2013-04-05','14:25:00',2.2),('15844','2013-04-05','14:30:00',2.94),('15844','2013-04-05','14:35:00',2.83),('15844','2013-04-05','14:40:00',3.47),('15844','2013-04-05','14:45:00',3.18),('15844','2013-04-05','14:50:00',1.72),('15844','2013-04-05','14:55:00',1.43),('15844','2013-04-05','15:00:00',2.2),('15844','2013-04-05','15:05:00',1.38),('15844','2013-04-05','15:10:00',1.39),('15844','2013-04-05','15:15:00',1.17),('15844','2013-04-05','15:20:00',1.08),('15844','2013-04-05','16:05:00',1.29),('15844','2013-04-05','16:10:00',1.14),('15844','2013-04-05','16:20:00',1.03),('15844','2013-04-05','16:25:00',1.03),('15844','2013-04-05','16:30:00',1.07),('15844','2013-04-05','16:35:00',1.11),('15844','2013-04-05','16:40:00',1.31),('15844','2013-04-05','16:45:00',1.04),('15844','2013-04-05','17:00:00',1.06),('15844','2013-04-04','08:55:00',1.28),('15844','2013-04-04','09:00:00',1.34),('15844','2013-04-04','09:10:00',1.07),('15844','2013-04-04','09:15:00',1.03),('15844','2013-04-04','09:30:00',1.6),('15844','2013-04-04','09:35:00',2.15),('15844','2013-04-04','09:40:00',1.6),('15844','2013-04-04','09:45:00',1.09),('15844','2013-04-04','09:55:00',1.22),('15844','2013-04-04','10:00:00',1.8),('15844','2013-04-04','10:05:00',2.01),('15844','2013-04-04','10:10:00',1.31),('15844','2013-04-04','10:15:00',1.29),('15844','2013-04-04','10:20:00',2.08),('15844','2013-04-04','10:25:00',2.88),('15844','2013-04-04','10:30:00',1.89),('15844','2013-04-04','10:35:00',2.9),('15844','2013-04-04','10:40:00',2.45),('15844','2013-04-04','10:45:00',1.7),('15844','2013-04-04','10:50:00',3.08),('15844','2013-04-04','10:55:00',2.74),('15844','2013-04-04','11:00:00',1.14),('15844','2013-04-04','11:10:00',1.01),('15844','2013-04-04','11:15:00',1.3),('15844','2013-04-04','11:30:00',1.04),('15844','2013-04-04','11:35:00',1.91),('15844','2013-04-04','11:40:00',2.97),('15844','2013-04-04','11:45:00',3.41),('15844','2013-04-04','11:50:00',2.78),('15844','2013-04-04','11:55:00',1.79),('15844','2013-04-04','12:00:00',1.77),('15844','2013-04-04','12:05:00',3.48),('15844','2013-04-04','12:10:00',3.65),('15844','2013-04-04','12:15:00',3.4),('15844','2013-04-04','12:20:00',2.72),('15844','2013-04-04','12:25:00',2.27),('15844','2013-04-04','12:30:00',3.09),('15844','2013-04-04','12:35:00',2.01),('15844','2013-04-04','12:40:00',1.9),('15844','2013-04-04','12:45:00',3.12),('15844','2013-04-04','12:50:00',2.46),('15844','2013-04-04','12:55:00',1.96),('15844','2013-04-04','13:00:00',2.49),('15844','2013-04-04','13:05:00',3.47),('15844','2013-04-04','13:10:00',3.67),('15844','2013-04-04','13:15:00',3.64),('15844','2013-04-04','13:20:00',3.62),('15844','2013-04-04','13:25:00',3.63),('15844','2013-04-04','13:30:00',3.34),('15844','2013-04-04','13:35:00',3.06),('15844','2013-04-04','13:40:00',2.75),('15844','2013-04-04','13:45:00',2.57),('15844','2013-04-04','13:50:00',2.31),('15844','2013-04-04','13:55:00',1.94),('15844','2013-04-04','14:00:00',2.39),('15844','2013-04-04','14:05:00',3.27),('15844','2013-04-04','14:10:00',3.28),('15844','2013-04-04','14:15:00',3.1),('15844','2013-04-04','14:20:00',2.99),('15844','2013-04-04','14:25:00',2.96),('15844','2013-04-04','14:30:00',2.94),('15844','2013-04-04','14:35:00',2.86),('15844','2013-04-04','14:40:00',2.66),('15844','2013-04-04','14:45:00',2.59),('15844','2013-04-04','14:50:00',2.41),('15844','2013-04-04','14:55:00',2.28),('15844','2013-04-04','15:00:00',2.2),('15844','2013-04-04','15:05:00',2.04),('15844','2013-04-04','15:10:00',1.85),('15844','2013-04-04','15:15:00',1.95),('15844','2013-04-04','15:20:00',1.83),('15844','2013-04-04','15:25:00',1.85),('15844','2013-04-04','15:30:00',1.74),('15844','2013-04-04','15:35:00',1.59),('15844','2013-04-04','15:40:00',1.51),('15844','2013-04-04','15:45:00',1.45),('15844','2013-04-04','15:50:00',1.39),('15844','2013-04-04','15:55:00',1.34),('15844','2013-04-04','16:00:00',1.26),('15844','2013-04-04','16:05:00',1.25),('15844','2013-04-04','16:10:00',1.18),('15844','2013-04-04','16:15:00',1.22),('15844','2013-04-04','16:20:00',1.22),('15844','2013-04-04','16:25:00',1.2),('15844','2013-04-03','08:20:00',1.01),('15844','2013-04-03','08:25:00',1.07),('15844','2013-04-03','08:30:00',1),('15844','2013-04-03','08:40:00',1.01),('15844','2013-04-03','08:45:00',1.08),('15844','2013-04-03','08:50:00',1.19),('15844','2013-04-03','08:55:00',1.28),('15844','2013-04-03','09:00:00',1.3),('15844','2013-04-03','09:05:00',1.4),('15844','2013-04-03','09:10:00',1.76),('15844','2013-04-03','09:15:00',1.18),('15844','2013-04-03','09:20:00',1.87),('15844','2013-04-03','09:25:00',2.11),('15844','2013-04-03','09:30:00',2.45),('15844','2013-04-03','09:35:00',2.28),('15844','2013-04-03','09:40:00',2.15),('15844','2013-04-03','09:45:00',2.74),('15844','2013-04-03','09:50:00',2.36),('15844','2013-04-03','09:55:00',1.14),('15844','2013-04-03','10:00:00',1.1),('15844','2013-04-03','10:05:00',2.47),('15844','2013-04-03','10:10:00',2.01),('15844','2013-04-03','10:15:00',2.93),('15844','2013-04-03','10:20:00',2.89),('15844','2013-04-03','10:25:00',1.79),('15844','2013-04-03','10:30:00',1.49),('15844','2013-04-03','10:35:00',1.51),('15844','2013-04-03','10:40:00',1.66),('15844','2013-04-03','10:45:00',3.08),('15844','2013-04-03','10:50:00',3.76),('15844','2013-04-03','10:55:00',2.14),('15844','2013-04-03','11:00:00',2.52),('15844','2013-04-03','11:05:00',3.52),('15844','2013-04-03','11:10:00',3.22),('15844','2013-04-03','11:15:00',1.95),('15844','2013-04-03','11:20:00',2.06),('15844','2013-04-03','11:30:00',1.06),('15844','2013-04-03','11:35:00',2.04),('15844','2013-04-03','11:40:00',2.58),('15844','2013-04-03','11:45:00',2.78),('15844','2013-04-03','11:50:00',1.79),('15844','2013-04-03','11:55:00',4.29),('15844','2013-04-03','12:00:00',2.56),('15844','2013-04-03','12:05:00',1.78),('15844','2013-04-03','12:10:00',4.1),('15844','2013-04-03','12:15:00',2.94),('15844','2013-04-03','12:20:00',3.96),('15844','2013-04-03','12:25:00',4.2),('15844','2013-04-03','12:30:00',4.55),('15844','2013-04-03','12:35:00',4.33),('15844','2013-04-03','12:40:00',4.02),('15844','2013-04-03','12:45:00',2.31),('15844','2013-04-03','12:50:00',4.21),('15844','2013-04-03','12:55:00',3.27),('15844','2013-04-03','13:00:00',1.83),('15844','2013-04-03','13:05:00',2.8),('15844','2013-04-03','13:10:00',2.66),('15844','2013-04-03','13:15:00',2.89),('15844','2013-04-03','13:20:00',4.01),('15844','2013-04-03','13:25:00',2.74),('15844','2013-04-03','13:30:00',4.09),('15844','2013-04-03','13:35:00',4.4),('15844','2013-04-03','13:40:00',4.36),('15844','2013-04-03','13:45:00',4.2),('15844','2013-04-03','13:50:00',3.85),('15844','2013-04-03','13:55:00',3.72),('15844','2013-04-03','14:00:00',3.9),('15844','2013-04-03','14:05:00',3.9),('15844','2013-04-03','14:10:00',3.18),('15844','2013-04-03','14:15:00',3.05),('15844','2013-04-03','14:20:00',3.01),('15844','2013-04-03','14:25:00',3.68),('15844','2013-04-03','14:30:00',2.69),('15844','2013-04-03','14:35:00',3.13),('15844','2013-04-03','14:40:00',2.88),('15844','2013-04-03','14:45:00',2.27),('15844','2013-04-03','14:50:00',2.71),('15844','2013-04-03','14:55:00',2.44),('15844','2013-04-03','15:00:00',2.59),('15844','2013-04-03','15:05:00',2.34),('15844','2013-04-03','15:10:00',2.09),('15844','2013-04-03','15:15:00',2.11),('15844','2013-04-03','15:20:00',1.83),('15844','2013-04-03','15:25:00',1.86),('15844','2013-04-03','15:30:00',1.48),('15844','2013-04-03','15:35:00',1.73),('15844','2013-04-03','15:40:00',1.08),('15844','2013-04-03','15:50:00',1.36),('15844','2013-04-03','15:55:00',1.19),('15844','2013-04-03','16:00:00',1.01),('15844','2013-04-03','16:05:00',1.19),('15844','2013-04-03','16:10:00',1.08),('15844','2013-04-02','08:40:00',1.49),('15844','2013-04-02','08:45:00',1.13),('15844','2013-04-02','09:00:00',1.5),('15844','2013-04-02','09:05:00',1.59),('15844','2013-04-02','09:10:00',1.72),('15844','2013-04-02','09:15:00',1.78),('15844','2013-04-02','09:20:00',1.84),('15844','2013-04-02','09:25:00',2.11),('15844','2013-04-02','09:30:00',2.25),('15844','2013-04-02','09:35:00',2.07),('15844','2013-04-02','09:40:00',2.27),('15844','2013-04-02','09:45:00',2.66),('15844','2013-04-02','09:50:00',2.81),('15844','2013-04-02','09:55:00',2.69),('15844','2013-04-02','10:00:00',2.89),('15844','2013-04-02','10:05:00',2.18),('15844','2013-04-02','10:10:00',2.16),('15844','2013-04-02','10:15:00',2.86),('15844','2013-04-02','10:20:00',3.19),('15844','2013-04-02','10:25:00',3.7),('15844','2013-04-02','10:30:00',3.99),('15844','2013-04-02','10:35:00',3.29),('15844','2013-04-02','10:40:00',1.31),('15844','2013-04-02','10:45:00',1.81),('15844','2013-04-02','10:50:00',3.79),('15844','2013-04-02','10:55:00',2.69),('15844','2013-04-02','11:00:00',3.44),('15844','2013-04-02','11:05:00',3.45),('15844','2013-04-02','11:10:00',3.77),('15844','2013-04-02','11:15:00',2.54),('15844','2013-04-02','11:20:00',3.15),('15844','2013-04-02','11:25:00',1.19),('15844','2013-04-02','11:30:00',2.18),('15844','2013-04-02','11:35:00',3.41),('15844','2013-04-02','11:40:00',2),('15844','2013-04-02','11:45:00',1.16),('15844','2013-04-02','11:50:00',1.3),('15844','2013-04-02','12:00:00',1.03),('15844','2013-04-02','12:05:00',2.86),('15844','2013-04-02','12:10:00',2.15),('15844','2013-04-02','12:15:00',1.38),('15844','2013-04-02','12:25:00',1.03),('15844','2013-04-02','12:30:00',3.61),('15844','2013-04-02','12:35:00',3.32),('15844','2013-04-02','12:40:00',2.8),('15844','2013-04-02','12:45:00',3.96),('15844','2013-04-02','12:50:00',2.3),('15844','2013-04-02','12:55:00',1.96),('15844','2013-04-02','13:00:00',2.36),('15844','2013-04-02','13:05:00',2.55),('15844','2013-04-02','13:10:00',1.26),('15844','2013-04-02','13:15:00',1.04),('15844','2013-04-02','13:20:00',1.36),('15844','2013-04-02','13:25:00',1.52),('15844','2013-04-02','13:30:00',1.47),('15844','2013-04-02','13:35:00',1.93),('15844','2013-04-02','13:40:00',2.1),('15844','2013-04-02','13:45:00',1.81),('15844','2013-04-02','13:55:00',1.78),('15844','2013-04-02','14:00:00',2.83),('15844','2013-04-02','14:05:00',2.61),('15844','2013-04-02','14:10:00',2.61),('15844','2013-04-02','14:15:00',2.68),('15844','2013-04-02','14:20:00',1.72),('15844','2013-04-02','14:25:00',1.24),('15844','2013-04-02','14:40:00',1.26),('15844','2013-04-02','15:15:00',1.28),('15844','2014-05-02','08:40:00',1.12),('15844','2014-05-02','08:50:00',1.01),('15844','2014-05-02','08:55:00',1.21),('15844','2014-05-02','09:00:00',1.33),('15844','2014-05-02','09:05:00',1.2),('15844','2014-05-02','09:10:00',1.49),('15844','2014-05-02','09:15:00',2.01),('15844','2014-05-02','09:20:00',2.1),('15844','2014-05-02','09:25:00',1.3),('15844','2014-05-02','09:30:00',1.42),('15844','2014-05-02','09:35:00',2.25),('15844','2014-05-02','09:40:00',2.28),('15844','2014-05-02','09:45:00',1.87),('15844','2014-05-02','09:50:00',1.76),('15844','2014-05-02','09:55:00',1.52),('15844','2014-05-02','10:00:00',1.14),('15844','2014-05-02','12:40:00',1.29),('15844','2014-05-02','12:45:00',1.69),('15844','2014-05-02','12:50:00',2.01),('15844','2014-05-02','12:55:00',2.31),('15844','2014-05-02','13:00:00',2.06),('15844','2014-05-02','13:05:00',2.15),('15844','2014-05-02','13:10:00',2.95),('15844','2014-05-02','13:15:00',2.56),('15844','2014-05-02','13:20:00',3.44),('15844','2014-05-02','13:25:00',3.68),('15844','2014-05-02','13:30:00',2.41),('15844','2014-05-02','13:35:00',2.38),('15844','2014-05-02','13:40:00',3.28),('15844','2014-05-02','13:45:00',2.62),('15844','2014-05-02','13:50:00',1.96),('15844','2014-05-02','13:55:00',3.36),('15844','2014-05-02','14:00:00',3.69),('15844','2014-05-02','14:05:00',2.91),('15844','2014-05-02','14:10:00',1.89),('15844','2014-05-02','14:15:00',2.2),('15844','2014-05-02','14:20:00',1.49),('15844','2014-05-02','14:25:00',1.51),('15844','2014-05-02','14:30:00',1.34),('15844','2014-05-02','14:50:00',1.27),('15844','2014-05-02','14:55:00',1.15),('15844','2014-05-02','15:00:00',1.05),('15844','2014-05-02','15:05:00',1.82),('15844','2014-05-02','15:10:00',1.54),('15844','2014-05-02','15:15:00',1.79),('15844','2014-05-02','15:20:00',1.7),('15844','2014-05-02','15:25:00',1.39),('15844','2014-05-02','15:30:00',1.88),('15844','2014-05-02','15:35:00',2.37),('15844','2014-05-02','15:50:00',1.04),('15844','2014-05-02','15:55:00',1.51),('15844','2014-05-02','16:00:00',1.48),('15844','2014-05-02','16:05:00',1.35),('15844','2014-05-02','16:10:00',1.1),('15844','2014-03-27','09:15:00',1.12),('15844','2014-03-27','09:20:00',1.04),('15844','2014-03-27','09:25:00',1.06),('15844','2014-03-27','10:05:00',1.18),('15844','2014-03-27','10:10:00',1.33),('15844','2014-03-27','10:15:00',1.46),('15844','2014-03-27','10:20:00',1.39),('15844','2014-03-27','10:25:00',1.28),('15844','2014-03-27','10:35:00',1.22),('15844','2014-03-27','10:40:00',1.89),('15844','2014-03-27','10:45:00',1.72),('15844','2014-03-27','11:05:00',1.2),('15844','2014-03-27','11:10:00',1.51),('15844','2014-03-27','11:50:00',1.42),('15844','2014-03-27','11:55:00',4.75),('15844','2014-03-27','12:00:00',3.26),('15844','2014-03-27','12:05:00',1),('15844','2014-03-27','13:00:00',1.03),('15844','2014-03-27','13:05:00',1.35),('15844','2014-03-27','13:10:00',2.15),('15844','2014-03-27','13:15:00',2.18),('15844','2014-03-27','13:20:00',2.1),('15844','2014-03-27','13:25:00',1.91),('15844','2014-03-27','13:30:00',1.69),('15844','2014-03-27','13:35:00',1.86),('15844','2014-03-27','13:40:00',1.72),('15844','2014-03-27','13:45:00',1.51),('15844','2014-03-27','13:50:00',1.54),('15844','2014-03-27','13:55:00',1.67),('15844','2014-03-27','14:00:00',2.23),('15844','2014-03-27','14:05:00',2.41),('15844','2014-03-27','14:20:00',2.26),('15844','2014-03-27','14:25:00',1.79),('15844','2014-03-27','14:30:00',1.74),('15844','2014-03-27','14:35:00',1.3),('15844','2014-03-27','14:40:00',1.53),('15844','2014-03-27','14:45:00',1.55),('15844','2014-03-27','14:50:00',1.66),('15844','2014-03-27','14:55:00',1.66),('15844','2014-03-27','15:35:00',1.17),('15844','2014-03-27','15:40:00',1.3),('15844','2014-03-27','15:45:00',1.16),('15844','2013-04-01','08:25:00',1.02),('15844','2013-04-01','08:30:00',1.33),('15844','2013-04-01','08:35:00',1.41),('15844','2013-04-01','08:55:00',1.38),('15844','2013-04-01','09:00:00',1.45),('15844','2013-04-01','09:05:00',1.56),('15844','2013-04-01','09:10:00',1.75),('15844','2013-04-01','09:15:00',1.77),('15844','2013-04-01','09:20:00',1.33),('15844','2013-04-01','09:25:00',1.86),('15844','2013-04-01','09:40:00',2.23),('15844','2013-04-01','09:45:00',2.26),('15844','2013-04-01','09:50:00',2.24),('15844','2013-04-01','09:55:00',2.16),('15844','2013-04-01','10:00:00',2.59),('15844','2013-04-01','10:05:00',2.12),('15844','2013-04-01','10:10:00',2.63),('15844','2013-04-01','10:15:00',2.73),('15844','2013-04-01','10:20:00',3.03),('15844','2013-04-01','10:25:00',3.29),('15844','2013-04-01','10:30:00',2.86),('15844','2013-04-01','10:35:00',3.32),('15844','2013-04-01','10:40:00',3.71),('15844','2013-04-01','10:45:00',3.95),('15844','2013-04-01','10:50:00',4.24),('15844','2013-04-01','10:55:00',3.68),('15844','2013-04-01','11:00:00',4.21),('15844','2013-04-01','11:05:00',3.41),('15844','2013-04-01','11:10:00',2.07),('15844','2013-04-01','11:15:00',1.51),('15844','2013-04-01','11:20:00',1.28),('15844','2013-04-01','11:25:00',2.15),('15844','2013-04-01','11:30:00',1.7),('15844','2013-04-01','11:35:00',2.45),('15844','2013-04-01','11:40:00',2.51),('15844','2013-04-01','11:45:00',1.82),('15844','2013-04-01','11:50:00',1.89),('15844','2013-04-01','11:55:00',2.13),('15844','2013-04-01','12:00:00',1.68),('15844','2013-04-01','12:05:00',1.7),('15844','2013-04-01','12:10:00',2.12),('15844','2013-04-01','12:15:00',1.8),('15844','2013-04-01','12:20:00',1.37),('15844','2013-04-01','12:25:00',1.39),('15844','2013-04-01','12:30:00',2.04),('15844','2013-04-01','12:35:00',1.67),('15844','2013-04-01','12:40:00',2.11),('15844','2013-04-01','12:45:00',2.26),('15844','2013-04-01','12:50:00',2.58),('15844','2013-04-01','12:55:00',2.54),('15844','2013-04-01','13:00:00',2.6),('15844','2013-04-01','13:05:00',2.89),('15844','2013-04-01','13:10:00',2.44),('15844','2013-04-01','13:15:00',2.24),('15844','2013-04-01','13:20:00',2.03),('15844','2013-04-01','13:25:00',1.9),('15844','2013-04-01','13:30:00',2.34),('15844','2013-04-01','13:35:00',2.1),('15844','2013-04-01','13:40:00',2.85),('15844','2013-04-01','13:45:00',2.83),('15844','2013-04-01','13:50:00',2.9),('15844','2013-04-01','13:55:00',2.59),('15844','2013-04-01','14:00:00',1.6),('15844','2013-04-01','14:05:00',1.61),('15844','2013-04-01','14:10:00',1.87),('15844','2013-04-01','14:15:00',1.93),('15844','2013-04-01','14:20:00',2.54),('15844','2013-04-01','14:25:00',2.34),('15844','2013-04-01','14:30:00',1.62),('15844','2013-04-01','14:35:00',1.82),('15844','2013-04-01','14:40:00',1.45),('15844','2013-04-01','14:45:00',1.75),('15844','2013-04-01','14:50:00',1.81),('15844','2013-04-01','14:55:00',1.66),('15844','2013-04-01','15:00:00',1.56),('15844','2013-04-01','15:05:00',1.55),('15844','2013-04-01','15:10:00',1.71),('15844','2013-04-01','15:15:00',1.68),('15844','2013-04-01','15:20:00',1.68),('15844','2013-04-01','15:25:00',1.61),('15844','2013-04-01','15:30:00',1.6),('15844','2013-04-01','15:35:00',1.61),('15844','2013-04-01','15:40:00',1.57),('15844','2013-04-01','15:45:00',1.93),('15844','2013-04-01','15:50:00',1.83),('15844','2013-04-01','15:55:00',1.39),('15844','2013-04-01','16:00:00',1.27),('15844','2013-04-01','16:05:00',1.14),('15844','2013-03-31','08:50:00',1.01),('15844','2013-03-31','09:15:00',1.17),('15844','2013-03-31','09:20:00',1.08),('15844','2013-03-31','09:25:00',1.73),('15844','2013-03-31','09:30:00',2.24),('15844','2013-03-31','09:35:00',1.63),('15844','2013-03-31','09:40:00',2.33),('15844','2013-03-31','09:45:00',1.3),('15844','2013-03-31','10:10:00',1.03),('15844','2013-03-31','10:15:00',1.45),('15844','2013-03-31','10:20:00',1.59),('15844','2013-03-31','10:25:00',1.75),('15844','2013-03-31','10:30:00',1.68),('15844','2013-03-31','10:35:00',1.08),('15844','2013-03-31','10:45:00',1.2),('15844','2013-03-31','10:50:00',1.35),('15844','2013-03-31','11:05:00',2.2),('15844','2013-03-31','11:20:00',1.06),('15844','2013-03-31','11:25:00',1.76),('15844','2013-03-31','11:30:00',1.51),('15844','2013-03-31','11:35:00',2.65),('15844','2013-03-31','11:40:00',3.49),('15844','2013-03-31','11:45:00',3.98),('15844','2013-03-31','11:50:00',1.57),('15844','2013-03-31','11:55:00',1.16),('15844','2013-03-31','12:25:00',1.07),('15844','2013-03-31','12:30:00',2.25),('15844','2013-03-31','12:35:00',4.08),('15844','2013-03-31','12:40:00',2.35),('15844','2013-03-31','12:45:00',2.7),('15844','2013-03-31','12:50:00',1.99),('15844','2013-03-31','12:55:00',2.45),('15844','2013-03-31','13:00:00',2.71),('15844','2013-03-31','13:05:00',2),('15844','2013-03-31','13:10:00',2.28),('15844','2013-03-31','13:15:00',2.85),('15844','2013-03-31','13:20:00',4.05),('15844','2013-03-31','13:25:00',1.82),('15844','2013-03-31','13:35:00',1.31),('15844','2013-03-31','13:40:00',4.02),('15844','2013-03-31','13:45:00',2.84),('15844','2013-03-31','13:50:00',3.38),('15844','2013-03-31','13:55:00',2.93),('15844','2013-03-31','14:00:00',2.28),('15844','2013-03-31','14:05:00',1.93),('15844','2013-03-31','14:10:00',1.4),('15844','2013-03-31','14:15:00',2.99),('15844','2013-03-31','14:20:00',2.35),('15844','2013-03-31','14:25:00',2.41),('15844','2013-03-31','14:30:00',3.33),('15844','2013-03-31','14:35:00',2.81),('15844','2013-03-31','14:40:00',2.3),('15844','2013-03-31','14:45:00',2.05),('15844','2013-03-31','14:50:00',2.66),('15844','2013-03-31','14:55:00',3.41),('15844','2013-03-31','15:00:00',2.22),('15844','2013-03-31','15:05:00',2.88),('15844','2013-03-31','15:10:00',2.2),('15844','2013-03-31','15:15:00',2.59),('15844','2013-03-31','15:20:00',2.06),('15844','2013-03-31','15:25:00',2.12),('15844','2013-03-31','15:30:00',1.99),('15844','2013-03-31','15:35:00',1.88),('15844','2013-03-31','15:40:00',1.73),('15844','2013-03-31','15:45:00',1.33),('15844','2013-03-31','16:15:00',1.68),('15844','2013-03-31','16:20:00',1.37),('15844','2013-03-31','16:35:00',1.06),('15844','2013-03-30','09:20:00',1.11),('15844','2013-03-30','09:25:00',1.38),('15844','2013-03-30','09:30:00',1.83),('15844','2013-03-30','09:35:00',1.5),('15844','2013-03-30','09:40:00',1.4),('15844','2013-03-30','09:45:00',1.45),('15844','2013-03-30','09:50:00',1.51),('15844','2013-03-30','09:55:00',1.64),('15844','2013-03-30','10:00:00',1.72),('15844','2013-03-30','10:05:00',1.86),('15844','2013-03-30','10:10:00',1.48),('15844','2013-03-30','10:15:00',1.19),('15844','2013-03-30','10:20:00',1.28),('15844','2013-03-30','10:25:00',1.39),('15844','2013-03-30','10:30:00',1.61),('15844','2013-03-30','10:35:00',1.78),('15844','2013-03-30','10:40:00',1.78),('15844','2013-03-30','10:45:00',1.59),('15844','2013-03-30','10:50:00',1.74),('15844','2013-03-30','10:55:00',2.28),('15844','2013-03-30','11:00:00',2.48),('15844','2013-03-30','11:05:00',2.49),('15844','2013-03-30','11:10:00',2.4),('15844','2013-03-30','11:15:00',2.43),('15844','2013-03-30','11:20:00',1.75),('15844','2013-03-30','11:25:00',1.75),('15844','2013-03-30','11:30:00',3.17),('15844','2013-03-30','11:35:00',2.25),('15844','2013-03-30','11:40:00',2.31),('15844','2013-03-30','11:45:00',1.46),('15844','2013-03-30','11:50:00',1.77),('15844','2013-03-30','11:55:00',1.61),('15844','2013-03-30','12:00:00',1.34),('15844','2013-03-30','12:05:00',1.12),('15844','2013-03-30','13:00:00',1.44),('15844','2013-03-30','13:05:00',1.57),('15844','2013-03-30','13:10:00',1.45),('15844','2013-03-30','13:15:00',2.26),('15844','2013-03-30','13:20:00',1.25),('15844','2013-03-30','13:35:00',1.2),('15844','2013-03-30','13:45:00',1.38),('15844','2013-03-30','13:50:00',1.64),('15844','2013-03-30','13:55:00',1.47),('15844','2013-03-30','14:00:00',1.19),('15844','2013-03-30','14:05:00',1.29),('15844','2013-03-30','14:10:00',1.13),('15844','2013-03-30','14:15:00',1.01),('15844','2013-03-30','14:20:00',2.02),('15844','2013-03-30','14:25:00',1.33),('15844','2013-03-30','14:40:00',1.14),('15844','2013-03-30','14:45:00',1.39),('15844','2013-03-30','14:50:00',1.08),('15844','2013-03-29','07:45:00',1.03),('15844','2013-03-29','07:50:00',1.35),('15844','2013-03-29','08:05:00',1.34),('15844','2013-03-29','08:10:00',1.64),('15844','2013-03-29','08:15:00',1.81),('15844','2013-03-29','08:20:00',1.89),('15844','2013-03-29','08:25:00',2.01),('15844','2013-03-29','08:30:00',2.11),('15844','2013-03-29','08:35:00',2.19),('15844','2013-03-29','08:40:00',2.2),('15844','2013-03-29','08:45:00',2.27),('15844','2013-03-29','08:50:00',1.87),('15844','2013-03-29','08:55:00',2.22),('15844','2013-03-29','09:00:00',2.43),('15844','2013-03-29','09:05:00',2.39),('15844','2013-03-29','09:10:00',2.58),('15844','2013-03-29','09:15:00',2.89),('15844','2013-03-29','09:20:00',2.81),('15844','2013-03-29','09:25:00',2.62),('15844','2013-03-29','09:30:00',3.03),('15844','2013-03-29','09:35:00',3.22),('15844','2013-03-29','09:40:00',2.94),('15844','2013-03-29','09:45:00',2.92),('15844','2013-03-29','09:50:00',3.03),('15844','2013-03-29','09:55:00',3.24),('15844','2013-03-29','10:00:00',3.18),('15844','2013-03-29','10:05:00',2.57),('15844','2013-03-29','10:10:00',2.94),('15844','2013-03-29','10:15:00',3.08),('15844','2013-03-29','10:20:00',3.04),('15844','2013-03-29','10:25:00',2.98),('15844','2013-03-29','10:30:00',3.2),('15844','2013-03-29','10:35:00',3.59),('15844','2013-03-29','10:40:00',3.52),('15844','2013-03-29','10:45:00',3.45),('15844','2013-03-29','10:50:00',3.35),('15844','2013-03-29','10:55:00',3.66),('15844','2013-03-29','11:00:00',3.49),('15844','2013-03-29','11:05:00',3.9),('15844','2013-03-29','11:10:00',4.04),('15844','2013-03-29','11:15:00',4.01),('15844','2013-03-29','11:20:00',4.04),('15844','2013-03-29','11:25:00',4.01),('15844','2013-03-29','11:30:00',3.85),('15844','2013-03-29','11:35:00',3.94),('15844','2013-03-29','11:40:00',3.98),('15844','2013-03-29','11:45:00',3.45),('15844','2013-03-29','11:50:00',3.99),('15844','2013-03-29','11:55:00',4),('15844','2013-03-29','12:00:00',3.94),('15844','2013-03-29','12:05:00',4),('15844','2013-03-29','12:10:00',3.86),('15844','2013-03-29','12:15:00',3.81),('15844','2013-03-29','12:20:00',3.79),('15844','2013-03-29','12:25:00',3.56),('15844','2013-03-29','12:30:00',3.75),('15844','2013-03-29','12:35:00',3.56),('15844','2013-03-29','12:40:00',3.52),('15844','2013-03-29','12:45:00',3.71),('15844','2013-03-29','12:50:00',3.61),('15844','2013-03-29','12:55:00',3.58),('15844','2013-03-29','13:00:00',3.35),('15844','2013-03-29','13:05:00',3.26),('15844','2013-03-29','13:10:00',3.12),('15844','2013-03-29','13:15:00',2.71),('15844','2013-03-29','13:20:00',3.3),('15844','2013-03-29','13:25:00',3.3),('15844','2013-03-29','13:30:00',2.71),('15844','2013-03-29','13:35:00',2.29),('15844','2013-03-29','13:40:00',2.59),('15844','2013-03-29','13:45:00',2.55),('15844','2013-03-29','13:50:00',2.56),('15844','2013-03-29','13:55:00',2.56),('15844','2013-03-29','14:00:00',2.31),('15844','2013-03-29','14:05:00',1.7),('15844','2013-03-29','14:10:00',1.68),('15844','2013-03-29','14:15:00',1.67),('15844','2013-03-29','14:20:00',1.75),('15844','2013-03-29','14:25:00',1.7),('15844','2013-03-29','14:30:00',1.53),('15844','2013-03-29','14:35:00',1.47),('15844','2013-03-29','14:40:00',1.47),('15844','2013-03-29','14:45:00',1.39),('15844','2013-03-29','14:50:00',1.4),('15844','2013-03-29','14:55:00',1.32),('15844','2013-03-29','15:00:00',1.24),('15844','2013-03-29','15:05:00',1.18),('15844','2013-03-29','15:10:00',1.12),('15844','2013-03-29','15:15:00',1.11),('15844','2013-03-29','15:20:00',1.04),('15844','2013-03-28','09:15:00',1.36),('15844','2013-03-28','09:20:00',1.28),('15844','2013-03-28','09:25:00',1.43),('15844','2013-03-28','12:55:00',1.12),('15844','2013-03-28','13:00:00',2.16),('15844','2013-03-28','13:05:00',2.07),('15844','2013-03-28','13:10:00',1.87),('15844','2013-03-28','13:15:00',2.26),('15844','2013-03-28','13:20:00',3.11),('15844','2013-03-28','13:25:00',2.93),('15844','2013-03-28','13:30:00',1.97),('15844','2013-03-28','13:35:00',1.17),('15844','2013-03-28','13:40:00',1.09),('15844','2013-03-28','13:45:00',1.02),('15844','2013-03-28','14:00:00',1.34),('15844','2013-03-28','14:05:00',2.11),('15844','2013-03-28','14:10:00',1.99),('15844','2013-03-28','14:15:00',1.74),('15844','2013-03-28','14:20:00',1.18),('15844','2013-03-28','14:30:00',1.22),('15844','2013-03-28','15:05:00',1.66),('15844','2013-03-28','15:10:00',2.23),('15844','2013-03-28','15:15:00',1.81),('15844','2013-03-28','15:20:00',1.2),('15844','2013-03-28','15:45:00',1.18),('15844','2013-03-28','15:50:00',1),('15844','2013-03-27','07:45:00',1.14),('15844','2013-03-27','07:50:00',1.42),('15844','2013-03-27','07:55:00',1.46),('15844','2013-03-27','08:00:00',1.15),('15844','2013-03-27','08:10:00',1.1),('15844','2013-03-27','08:15:00',1.12),('15844','2013-03-27','08:20:00',1.06),('15844','2013-03-27','08:25:00',1.43),('15844','2013-03-27','08:30:00',1.61),('15844','2013-03-27','08:35:00',1.55),('15844','2013-03-27','08:40:00',1.1),('15844','2013-03-27','08:45:00',1.51),('15844','2013-03-27','08:50:00',1.22),('15844','2013-03-27','08:55:00',1.1),('15844','2013-03-27','09:10:00',1.86),('15844','2013-03-27','09:15:00',1.88),('15844','2013-03-27','09:20:00',1.24),('15844','2013-03-27','09:50:00',2.77),('15844','2013-03-27','09:55:00',2.31),('15844','2013-03-27','10:00:00',1.39),('15844','2013-03-27','10:05:00',1.24),('15844','2013-03-27','10:10:00',1.93),('15844','2013-03-27','10:15:00',1.23),('15844','2013-03-27','10:25:00',1.13),('15844','2013-03-27','10:30:00',1.2),('15844','2013-03-27','10:35:00',1.14),('15844','2013-03-27','10:40:00',1.29),('15844','2013-03-27','10:45:00',1.71),('15844','2013-03-27','10:50:00',1.28),('15844','2013-03-27','11:15:00',1.12),('15844','2013-03-27','11:20:00',1.15),('15844','2013-03-27','11:25:00',1.81),('15844','2013-03-27','11:30:00',1.88),('15844','2013-03-27','11:35:00',1.6),('15844','2013-03-27','11:40:00',1.67),('15844','2013-03-27','11:45:00',1.66),('15844','2013-03-27','11:50:00',2.23),('15844','2013-03-27','11:55:00',2.55),('15844','2013-03-27','12:00:00',2.62),('15844','2013-03-27','12:05:00',2.65),('15844','2013-03-27','12:10:00',2.71),('15844','2013-03-27','12:15:00',2.16),('15844','2013-03-27','12:20:00',1.31),('15844','2013-03-27','12:25:00',1.75),('15844','2013-03-27','12:30:00',1.44),('15844','2013-03-27','12:35:00',1.47),('15844','2013-03-27','12:40:00',2.56),('15844','2013-03-27','12:45:00',1.92),('15844','2013-03-27','12:50:00',1.46),('15844','2013-03-27','12:55:00',1.34),('15844','2013-03-27','13:00:00',1.62),('15844','2013-03-27','13:05:00',1.78),('15844','2013-03-27','13:10:00',1.6),('15844','2013-03-27','13:15:00',1.38),('15844','2013-03-27','13:20:00',1.28),('15844','2013-03-27','13:25:00',1.23),('15844','2013-03-27','13:30:00',1.39),('15844','2013-03-27','13:35:00',1.68),('15844','2013-03-27','13:40:00',1.98),('15844','2013-03-27','13:45:00',1.91),('15844','2013-03-27','13:50:00',1.39),('15844','2013-03-27','13:55:00',1.32),('15844','2013-03-27','14:00:00',1.25),('15844','2013-03-27','14:05:00',1.24),('15844','2013-03-27','14:10:00',1.5),('15844','2013-03-27','14:15:00',1.55),('15844','2013-03-27','14:20:00',1.13),('15844','2013-03-27','14:35:00',1.15),('15844','2013-03-27','14:40:00',1.24),('15844','2013-03-26','07:50:00',1.03),('15844','2013-03-26','09:10:00',1.59),('15844','2013-03-26','09:45:00',1.42),('15844','2013-03-26','09:50:00',1.03),('15844','2013-03-26','09:55:00',1.6),('15844','2013-03-26','10:50:00',1.09),('15844','2013-03-26','11:00:00',1.47),('15844','2013-03-26','11:05:00',1.06),('15844','2013-03-26','11:10:00',2.04),('15844','2013-03-26','11:50:00',1.76),('15844','2013-03-26','11:55:00',2.23),('15844','2013-03-26','12:00:00',2.09),('15844','2013-03-26','12:05:00',1.28),('15844','2013-03-26','12:10:00',1.22),('15844','2013-03-26','12:15:00',1.24),('15844','2013-03-26','12:20:00',2.01),('15844','2013-03-26','12:25:00',2.92),('15844','2013-03-26','12:30:00',2.48),('15844','2013-03-26','12:35:00',1.57),('15844','2013-03-26','12:40:00',2.28),('15844','2013-03-26','12:45:00',1.43),('15844','2013-03-26','12:50:00',1.42),('15844','2013-03-26','12:55:00',1.23),('15844','2013-03-26','13:00:00',2.4),('15844','2013-03-26','13:05:00',1.68),('15844','2013-03-26','13:10:00',1.55),('15844','2013-03-26','13:15:00',1.12),('15844','2013-03-26','13:20:00',1.48),('15844','2013-03-26','13:25:00',1.44),('15844','2013-03-26','13:30:00',1.43),('15844','2013-03-26','13:35:00',1.87),('15844','2013-03-26','13:40:00',1.93),('15844','2013-03-26','13:45:00',1.43),('15844','2013-03-26','13:50:00',1.15),('15844','2013-03-26','13:55:00',1.26),('15844','2013-03-26','14:00:00',1.26),('15844','2013-03-26','14:05:00',1.51),('15844','2013-03-26','14:10:00',1.36),('15844','2013-03-26','14:15:00',1.19),('15844','2013-03-26','14:20:00',1.03),('15844','2013-03-26','14:25:00',1.1),('15844','2013-03-26','14:30:00',1.04),('15844','2013-03-25','08:20:00',1.45),('15844','2013-03-25','08:25:00',1.81),('15844','2013-03-25','08:50:00',1.15),('15844','2013-03-25','09:20:00',1.26),('15844','2013-03-25','09:25:00',2.01),('15844','2013-03-25','10:05:00',2.19),('15844','2013-03-25','10:10:00',1.26),('15844','2013-03-25','10:15:00',2.19),('15844','2013-03-25','10:20:00',1.85),('15844','2013-03-25','10:40:00',1.4),('15844','2013-03-25','10:45:00',1.13),('15844','2013-03-25','10:50:00',1.14),('15844','2013-03-25','10:55:00',1.3),('15844','2013-03-25','11:25:00',1.78),('15844','2013-03-25','11:30:00',1.09),('15844','2013-03-25','11:35:00',1.12),('15844','2013-03-25','11:40:00',1.25),('15844','2013-03-25','11:45:00',1.65),('15844','2013-03-25','11:50:00',3.41),('15844','2013-03-25','11:55:00',2.54),('15844','2013-03-25','12:00:00',4.11),('15844','2013-03-25','12:05:00',3.3),('15844','2013-03-25','12:10:00',2.09),('15844','2013-03-25','12:15:00',3.42),('15844','2013-03-25','12:20:00',3.04),('15844','2013-03-25','12:25:00',3.61),('15844','2013-03-25','12:30:00',2.2),('15844','2013-03-25','12:35:00',2.82),('15844','2013-03-25','12:40:00',3.13),('15844','2013-03-25','12:45:00',3.81),('15844','2013-03-25','12:50:00',4.34),('15844','2013-03-25','12:55:00',4.33),('15844','2013-03-25','13:00:00',3.59),('15844','2013-03-25','13:05:00',3.8),('15844','2013-03-25','13:10:00',1.59),('15844','2013-03-25','13:40:00',1.43),('15844','2013-03-25','13:45:00',1.06),('15844','2013-03-25','14:00:00',1.65),('15844','2013-03-25','14:05:00',2.35),('15844','2013-03-25','14:10:00',2.76),('15844','2013-03-25','14:15:00',1.75),('15844','2013-03-25','14:20:00',1.52),('15844','2013-03-25','14:25:00',2.2),('15844','2013-03-25','14:30:00',1.46),('15844','2013-03-25','14:35:00',1.53),('15844','2013-03-25','14:40:00',1.47),('15844','2013-03-25','14:45:00',1.26),('15844','2013-03-25','14:50:00',1.17),('15844','2013-03-25','14:55:00',1.59),('15844','2013-03-25','15:00:00',1.63),('15844','2013-03-25','15:05:00',1.3),('15844','2013-03-25','15:10:00',1.17),('15844','2013-03-25','15:15:00',1.27),('15844','2013-03-25','15:20:00',1.01),('15844','2013-03-25','15:25:00',1.15),('15844','2013-03-25','15:30:00',1.2),('15844','2013-03-24','08:00:00',1.13),('15844','2013-03-24','08:05:00',1.28),('15844','2013-03-24','08:10:00',1.34),('15844','2013-03-24','08:15:00',1.55),('15844','2013-03-24','08:20:00',1.67),('15844','2013-03-24','08:25:00',1.77),('15844','2013-03-24','08:30:00',1.88),('15844','2013-03-24','08:35:00',2.04),('15844','2013-03-24','08:40:00',2.15),('15844','2013-03-24','08:45:00',2.25),('15844','2013-03-24','08:50:00',2.31),('15844','2013-03-24','08:55:00',2.38),('15844','2013-03-24','09:00:00',2.46),('15844','2013-03-24','09:05:00',2.52),('15844','2013-03-24','09:10:00',2.61),('15844','2013-03-24','09:15:00',2.68),('15844','2013-03-24','09:20:00',2.72),('15844','2013-03-24','09:25:00',2.8),('15844','2013-03-24','09:30:00',2.87),('15844','2013-03-24','09:35:00',2.96),('15844','2013-03-24','09:40:00',2.99),('15844','2013-03-24','09:45:00',3.06),('15844','2013-03-24','09:50:00',3.13),('15844','2013-03-24','09:55:00',3.18),('15844','2013-03-24','10:00:00',3.24),('15844','2013-03-24','10:05:00',3.38),('15844','2013-03-24','10:10:00',3.43),('15844','2013-03-24','10:15:00',3.46),('15844','2013-03-24','10:20:00',3.47),('15844','2013-03-24','10:25:00',3.47),('15844','2013-03-24','10:30:00',3.51),('15844','2013-03-24','10:35:00',3.51),('15844','2013-03-24','10:40:00',3.51),('15844','2013-03-24','10:45:00',3.57),('15844','2013-03-24','10:50:00',3.56),('15844','2013-03-24','10:55:00',3.59),('15844','2013-03-24','11:00:00',3.58),('15844','2013-03-24','11:05:00',3.6),('15844','2013-03-24','11:10:00',3.57),('15844','2013-03-24','11:15:00',3.58),('15844','2013-03-24','11:20:00',3.58),('15844','2013-03-24','11:25:00',3.55),('15844','2013-03-24','11:30:00',3.55),('15844','2013-03-24','11:35:00',3.54),('15844','2013-03-24','11:40:00',3.5),('15844','2013-03-24','11:45:00',3.45),('15844','2013-03-24','11:50:00',3.44),('15844','2013-03-24','11:55:00',3.44),('15844','2013-03-24','12:00:00',3.43),('15844','2013-03-24','12:05:00',3.48),('15844','2013-03-24','12:10:00',3.5),('15844','2013-03-24','12:15:00',3.5),('15844','2013-03-24','12:20:00',3.49),('15844','2013-03-24','12:25:00',3.48),('15844','2013-03-24','12:30:00',3.46),('15844','2013-03-24','12:35:00',3.44),('15844','2013-03-24','12:40:00',3.41),('15844','2013-03-24','12:45:00',3.38),('15844','2013-03-24','12:50:00',3.35),('15844','2013-03-24','12:55:00',3.29),('15844','2013-03-24','13:00:00',3.21),('15844','2013-03-24','13:05:00',3.18),('15844','2013-03-24','13:10:00',3.11),('15844','2013-03-24','13:15:00',3.08),('15844','2013-03-24','13:20:00',2.99),('15844','2013-03-24','13:25:00',2.9),('15844','2013-03-24','13:30:00',2.82),('15844','2013-03-24','13:35:00',2.72),('15844','2013-03-24','13:40:00',2.61),('15844','2013-03-24','13:45:00',2.51),('15844','2013-03-24','13:50:00',2.4),('15844','2013-03-24','13:55:00',2.28),('15844','2013-03-24','14:00:00',2.17),('15844','2013-03-24','14:05:00',2.09),('15844','2013-03-24','14:10:00',1.98),('15844','2013-03-24','14:15:00',1.87),('15844','2013-03-24','14:20:00',1.74),('15844','2013-03-24','14:25:00',1.59),('15844','2013-03-24','14:30:00',1.47),('15844','2013-03-24','14:35:00',1.37),('15844','2013-03-24','14:40:00',1.31),('15844','2013-03-24','14:45:00',1.24),('15844','2013-03-24','14:50:00',1.17),('15844','2013-03-24','14:55:00',1.21),('15844','2013-03-24','15:00:00',1.16),('15844','2013-03-24','15:05:00',1.12),('15844','2013-03-24','15:15:00',1.04),('15844','2013-03-23','07:55:00',1.04),('15844','2013-03-23','08:00:00',1.2),('15844','2013-03-23','08:05:00',1.32),('15844','2013-03-23','08:10:00',1.39),('15844','2013-03-23','08:15:00',1.49),('15844','2013-03-23','08:20:00',1.6),('15844','2013-03-23','08:25:00',1.73),('15844','2013-03-23','08:30:00',1.83),('15844','2013-03-23','08:35:00',1.91),('15844','2013-03-23','08:40:00',2.21),('15844','2013-03-23','08:45:00',2.31),('15844','2013-03-23','08:50:00',2.45),('15844','2013-03-23','08:55:00',2.52),('15844','2013-03-23','09:00:00',2.6),('15844','2013-03-23','09:05:00',2.69),('15844','2013-03-23','09:10:00',2.75),('15844','2013-03-23','09:15:00',2.78),('15844','2013-03-23','09:20:00',2.87),('15844','2013-03-23','09:25:00',2.99),('15844','2013-03-23','09:30:00',3.1),('15844','2013-03-23','09:35:00',3.06),('15844','2013-03-23','09:40:00',3.07),('15844','2013-03-23','09:45:00',3.13),('15844','2013-03-23','09:50:00',3.22),('15844','2013-03-23','09:55:00',3.28),('15844','2013-03-23','10:00:00',3.29),('15844','2013-03-23','10:05:00',3.38),('15844','2013-03-23','10:10:00',3.49),('15844','2013-03-23','10:15:00',3.48),('15844','2013-03-23','10:20:00',3.32),('15844','2013-03-23','10:25:00',3.57),('15844','2013-03-23','10:30:00',3.66),('15844','2013-03-23','10:35:00',3.61),('15844','2013-03-23','10:40:00',3.6),('15844','2013-03-23','10:45:00',3.59),('15844','2013-03-23','10:50:00',3.45),('15844','2013-03-23','10:55:00',3.33),('15844','2013-03-23','11:00:00',3.22),('15844','2013-03-23','11:05:00',2.74),('15844','2013-03-23','11:10:00',2.49),('15844','2013-03-23','11:15:00',2.98),('15844','2013-03-23','11:20:00',3.4),('15844','2013-03-23','11:25:00',3.27),('15844','2013-03-23','11:30:00',3.44),('15844','2013-03-23','11:35:00',3.56),('15844','2013-03-23','11:40:00',3.45),('15844','2013-03-23','11:45:00',3.5),('15844','2013-03-23','11:50:00',2.94),('15844','2013-03-23','11:55:00',3.03),('15844','2013-03-23','12:00:00',3.36),('15844','2013-03-23','12:05:00',3.41),('15844','2013-03-23','12:10:00',3.47),('15844','2013-03-23','12:15:00',3.41),('15844','2013-03-23','12:20:00',3.4),('15844','2013-03-23','12:25:00',3.35),('15844','2013-03-23','12:30:00',3.37),('15844','2013-03-23','12:35:00',3.29),('15844','2013-03-23','12:40:00',3.19),('15844','2013-03-23','12:45:00',3.24),('15844','2013-03-23','12:50:00',3.15),('15844','2013-03-23','12:55:00',2.7),('15844','2013-03-23','13:00:00',2.73),('15844','2013-03-23','13:05:00',3.09),('15844','2013-03-23','13:10:00',2.99),('15844','2013-03-23','13:15:00',2.92),('15844','2013-03-23','13:20:00',2.96),('15844','2013-03-23','13:25:00',2.79),('15844','2013-03-23','13:30:00',2.77),('15844','2013-03-23','13:35:00',2.67),('15844','2013-03-23','13:40:00',2.52),('15844','2013-03-23','13:45:00',2.43),('15844','2013-03-23','13:50:00',2.3),('15844','2013-03-23','13:55:00',2.24),('15844','2013-03-23','14:00:00',2.16),('15844','2013-03-23','14:05:00',2.07),('15844','2013-03-23','14:10:00',1.91),('15844','2013-03-23','14:15:00',1.8),('15844','2013-03-23','14:20:00',1.71),('15844','2013-03-23','14:25:00',1.64),('15844','2013-03-23','14:30:00',1.59),('15844','2013-03-23','14:35:00',1.5),('15844','2013-03-23','14:40:00',1.35),('15844','2013-03-23','14:45:00',1.22),('15844','2013-03-23','14:50:00',1.23),('15844','2013-03-23','14:55:00',1.18),('15844','2013-03-23','15:00:00',1.14),('15844','2013-03-23','15:05:00',1.04),('15844','2014-03-26','07:40:00',1.09),('15844','2014-03-26','07:45:00',1.13),('15844','2014-03-26','07:50:00',1.15),('15844','2014-03-26','07:55:00',1.19),('15844','2014-03-26','08:00:00',1.28),('15844','2014-03-26','08:05:00',1.38),('15844','2014-03-26','08:10:00',1.51),('15844','2014-03-26','08:15:00',1.79),('15844','2014-03-26','08:20:00',1.11),('15844','2014-03-26','08:45:00',1.04),('15844','2014-03-26','08:50:00',1.1),('15844','2014-03-26','08:55:00',2.42),('15844','2014-03-26','09:00:00',3.24),('15844','2014-03-26','09:05:00',1.61),('15844','2014-03-26','09:10:00',1.63),('15844','2014-03-26','09:15:00',2.58),('15844','2014-03-26','09:20:00',2.81),('15844','2014-03-26','09:25:00',3),('15844','2014-03-26','09:30:00',3.04),('15844','2014-03-26','09:35:00',3.09),('15844','2014-03-26','09:40:00',3.14),('15844','2014-03-26','09:45:00',3.19),('15844','2014-03-26','09:50:00',3.23),('15844','2014-03-26','09:55:00',3.3),('15844','2014-03-26','10:00:00',3.35),('15844','2014-03-26','10:05:00',3.57),('15844','2014-03-26','10:10:00',2.66),('15844','2014-03-26','10:15:00',4),('15844','2014-03-26','10:20:00',3.9),('15844','2014-03-26','10:25:00',3.85),('15844','2014-03-26','10:30:00',3.59),('15844','2014-03-26','10:35:00',3.22),('15844','2014-03-26','10:40:00',1.99),('15844','2014-03-26','10:45:00',4.2),('15844','2014-03-26','10:50:00',2.51),('15844','2014-03-26','10:55:00',1.09),('15844','2014-03-26','11:10:00',1.14),('15844','2014-03-26','11:35:00',1.15),('15844','2014-03-26','11:40:00',1.62),('15844','2014-03-26','11:45:00',3.27),('15844','2014-03-26','11:50:00',2.64),('15844','2014-03-26','11:55:00',4.34),('15844','2014-03-26','12:00:00',4.58),('15844','2014-03-26','12:05:00',1.53),('15844','2014-03-26','12:10:00',1.28),('15844','2014-03-26','12:20:00',1.02),('15844','2014-03-26','12:25:00',1.36),('15844','2014-03-26','12:30:00',1.39),('15844','2014-03-26','12:35:00',2.03),('15844','2014-03-26','12:40:00',2.19),('15844','2014-03-26','12:45:00',3.2),('15844','2014-03-26','12:50:00',4.15),('15844','2014-03-26','12:55:00',3.7),('15844','2014-03-26','13:00:00',3.59),('15844','2014-03-26','13:05:00',3.66),('15844','2014-03-26','13:10:00',3.73),('15844','2014-03-26','13:15:00',2.84),('15844','2014-03-26','13:20:00',2.98),('15844','2014-03-26','13:25:00',2.67),('15844','2014-03-26','13:30:00',2.8),('15844','2014-03-26','13:35:00',2.22),('15844','2014-03-26','13:40:00',1.02),('15844','2014-03-26','13:50:00',1.03),('15844','2014-03-26','13:55:00',1.01),('15844','2014-03-26','14:00:00',1.6),('15844','2014-03-26','14:05:00',2.74),('15844','2014-03-26','14:10:00',1.51),('15844','2014-03-26','14:15:00',2.49),('15844','2014-03-26','14:20:00',1.26),('15844','2014-03-26','14:25:00',1.17),('15844','2014-03-26','14:30:00',1.47),('15844','2014-03-26','14:55:00',1.31),('15844','2014-03-26','15:00:00',1.47),('15844','2014-03-26','15:05:00',1.42),('15844','2014-03-26','15:10:00',1.09),('15844','2014-03-26','15:20:00',1.06),('15844','2013-03-22','07:55:00',1),('15844','2013-03-22','08:00:00',1.1),('15844','2013-03-22','08:05:00',1.2),('15844','2013-03-22','08:10:00',1.34),('15844','2013-03-22','08:15:00',1.45),('15844','2013-03-22','08:20:00',1.59),('15844','2013-03-22','08:25:00',1.73),('15844','2013-03-22','08:30:00',1.85),('15844','2013-03-22','08:35:00',1.95),('15844','2013-03-22','08:40:00',2.05),('15844','2013-03-22','08:45:00',2.21),('15844','2013-03-22','08:50:00',2.3),('15844','2013-03-22','08:55:00',2.41),('15844','2013-03-22','09:00:00',2.53),('15844','2013-03-22','09:05:00',2.58),('15844','2013-03-22','09:10:00',2.67),('15844','2013-03-22','09:15:00',2.71),('15844','2013-03-22','09:20:00',2.82),('15844','2013-03-22','09:25:00',2.92),('15844','2013-03-22','09:30:00',3.01),('15844','2013-03-22','09:35:00',3.03),('15844','2013-03-22','09:40:00',3.13),('15844','2013-03-22','09:45:00',3.13),('15844','2013-03-22','09:50:00',3.23),('15844','2013-03-22','09:55:00',3.25),('15844','2013-03-22','10:00:00',3.28),('15844','2013-03-22','10:05:00',3.48),('15844','2013-03-22','10:10:00',3.51),('15844','2013-03-22','10:15:00',3.55),('15844','2013-03-22','10:20:00',3.64),('15844','2013-03-22','10:25:00',3.65),('15844','2013-03-22','10:30:00',3.71),('15844','2013-03-22','10:35:00',3.72),('15844','2013-03-22','10:40:00',3.74),('15844','2013-03-22','10:45:00',3.75),('15844','2013-03-22','10:50:00',3.77),('15844','2013-03-22','10:55:00',3.78),('15844','2013-03-22','11:00:00',3.81),('15844','2013-03-22','11:05:00',3.78),('15844','2013-03-22','11:10:00',3.78),('15844','2013-03-22','11:15:00',3.8),('15844','2013-03-22','11:20:00',3.77),('15844','2013-03-22','11:25:00',3.73),('15844','2013-03-22','11:30:00',3.78),('15844','2013-03-22','11:35:00',3.76),('15844','2013-03-22','11:40:00',3.77),('15844','2013-03-22','11:45:00',3.77),('15844','2013-03-22','11:50:00',3.75),('15844','2013-03-22','11:55:00',3.76),('15844','2013-03-22','12:00:00',3.73),('15844','2013-03-22','12:05:00',3.69),('15844','2013-03-22','12:10:00',3.67),('15844','2013-03-22','12:15:00',3.64),('15844','2013-03-22','12:20:00',3.64),('15844','2013-03-22','12:25:00',3.62),('15844','2013-03-22','12:30:00',3.58),('15844','2013-03-22','12:35:00',3.55),('15844','2013-03-22','12:40:00',3.45),('15844','2013-03-22','12:45:00',3.47),('15844','2013-03-22','12:50:00',3.36),('15844','2013-03-22','12:55:00',3.39),('15844','2013-03-22','13:00:00',3.29),('15844','2013-03-22','13:05:00',3.28),('15844','2013-03-22','13:10:00',3.21),('15844','2013-03-22','13:15:00',3.09),('15844','2013-03-22','13:20:00',2.97),('15844','2013-03-22','13:25:00',2.51),('15844','2013-03-22','13:30:00',2.77),('15844','2013-03-22','13:35:00',2.72),('15844','2013-03-22','13:40:00',2.3),('15844','2013-03-22','13:45:00',2.61),('15844','2013-03-22','13:50:00',2.43),('15844','2013-03-22','13:55:00',2.3),('15844','2013-03-22','14:00:00',2.16),('15844','2013-03-22','14:05:00',2.07),('15844','2013-03-22','14:10:00',1.96),('15844','2013-03-22','14:15:00',1.83),('15844','2013-03-22','14:20:00',1.7),('15844','2013-03-22','14:25:00',1.62),('15844','2013-03-22','14:30:00',1.58),('15844','2013-03-22','14:35:00',1.49),('15844','2013-03-22','14:40:00',1.37),('15844','2013-03-22','14:45:00',1.25),('15844','2013-03-22','14:50:00',1.21),('15844','2013-03-22','14:55:00',1.17),('15844','2013-03-22','15:00:00',1.1),('15844','2013-03-21','07:35:00',1.07),('15844','2013-03-21','07:40:00',1.19),('15844','2013-03-21','08:05:00',1.35),('15844','2013-03-21','08:10:00',1.29),('15844','2013-03-21','08:15:00',1.48),('15844','2013-03-21','08:20:00',1.68),('15844','2013-03-21','08:25:00',1.73),('15844','2013-03-21','08:30:00',1.42),('15844','2013-03-21','08:35:00',2.23),('15844','2013-03-21','08:40:00',2.46),('15844','2013-03-21','08:45:00',1.13),('15844','2013-03-21','08:50:00',1.94),('15844','2013-03-21','08:55:00',2.08),('15844','2013-03-21','09:05:00',1.04),('15844','2013-03-21','09:10:00',2.14),('15844','2013-03-21','09:15:00',1.79),('15844','2013-03-21','09:20:00',2.66),('15844','2013-03-21','09:25:00',2.42),('15844','2013-03-21','09:30:00',3.25),('15844','2013-03-21','09:35:00',3.28),('15844','2013-03-21','09:40:00',3.3),('15844','2013-03-21','09:45:00',3.3),('15844','2013-03-21','09:50:00',3.4),('15844','2013-03-21','09:55:00',3.48),('15844','2013-03-21','10:00:00',3.52),('15844','2013-03-21','10:05:00',2.71),('15844','2013-03-21','10:10:00',3.75),('15844','2013-03-21','10:15:00',3.72),('15844','2013-03-21','10:20:00',3.73),('15844','2013-03-21','10:25:00',3.77),('15844','2013-03-21','10:30:00',3.77),('15844','2013-03-21','10:35:00',3.78),('15844','2013-03-21','10:40:00',3.77),('15844','2013-03-21','10:45:00',2.89),('15844','2013-03-21','10:50:00',1.96),('15844','2013-03-21','10:55:00',3.83),('15844','2013-03-21','11:00:00',3.82),('15844','2013-03-21','11:05:00',3.82),('15844','2013-03-21','11:10:00',3.82),('15844','2013-03-21','11:15:00',3.86),('15844','2013-03-21','11:20:00',3.88),('15844','2013-03-21','11:25:00',3.87),('15844','2013-03-21','11:30:00',3.87),('15844','2013-03-21','11:35:00',3.86),('15844','2013-03-21','11:40:00',3.86),('15844','2013-03-21','11:45:00',3.86),('15844','2013-03-21','11:50:00',3.86),('15844','2013-03-21','11:55:00',3.81),('15844','2013-03-21','12:00:00',3.8),('15844','2013-03-21','12:05:00',3.79),('15844','2013-03-21','12:10:00',3.77),('15844','2013-03-21','12:15:00',3.72),('15844','2013-03-21','12:20:00',3.69),('15844','2013-03-21','12:25:00',3.67),('15844','2013-03-21','12:30:00',3.65),('15844','2013-03-21','12:35:00',3.62),('15844','2013-03-21','12:40:00',3.57),('15844','2013-03-21','12:45:00',3.53),('15844','2013-03-21','12:50:00',3.48),('15844','2013-03-21','12:55:00',3.41),('15844','2013-03-21','13:00:00',3.29),('15844','2013-03-21','13:05:00',3.29),('15844','2013-03-21','13:10:00',3.21),('15844','2013-03-21','13:15:00',3.13),('15844','2013-03-21','13:20:00',3.06),('15844','2013-03-21','13:25:00',2.99),('15844','2013-03-21','13:30:00',2.88),('15844','2013-03-21','13:35:00',2.75),('15844','2013-03-21','13:40:00',2.63),('15844','2013-03-21','13:45:00',2.51),('15844','2013-03-21','13:50:00',2.4),('15844','2013-03-21','13:55:00',2.31),('15844','2013-03-21','14:00:00',2.18),('15844','2013-03-21','14:05:00',2.07),('15844','2013-03-21','14:10:00',1.95),('15844','2013-03-21','14:15:00',1.81),('15844','2013-03-21','14:20:00',1.68),('15844','2013-03-21','14:25:00',1.64),('15844','2013-03-21','14:30:00',1.56),('15844','2013-03-21','14:35:00',1.47),('15844','2013-03-21','14:40:00',1.35),('15844','2013-03-21','14:45:00',1.24),('15844','2013-03-21','14:50:00',1.19),('15844','2013-03-21','14:55:00',1.15),('15844','2013-03-21','15:00:00',1.08),('15844','2013-03-21','15:05:00',1),('15844','2013-03-20','07:50:00',1.11),('15844','2013-03-20','07:55:00',1.11),('15844','2013-03-20','08:05:00',1.26),('15844','2013-03-20','08:10:00',1.44),('15844','2013-03-20','08:15:00',1.55),('15844','2013-03-20','08:20:00',1.66),('15844','2013-03-20','08:25:00',1.72),('15844','2013-03-20','08:30:00',1.71),('15844','2013-03-20','08:35:00',1.49),('15844','2013-03-20','08:40:00',1.97),('15844','2013-03-20','08:45:00',2.18),('15844','2013-03-20','08:50:00',2.32),('15844','2013-03-20','08:55:00',2.3),('15844','2013-03-20','09:00:00',2.34),('15844','2013-03-20','09:05:00',1.53),('15844','2013-03-20','09:10:00',2.44),('15844','2013-03-20','09:15:00',2.38),('15844','2013-03-20','09:20:00',2.68),('15844','2013-03-20','09:25:00',2.78),('15844','2013-03-20','09:30:00',3.06),('15844','2013-03-20','09:35:00',2.9),('15844','2013-03-20','09:40:00',3.05),('15844','2013-03-20','09:45:00',2.95),('15844','2013-03-20','09:50:00',3.06),('15844','2013-03-20','09:55:00',3.27),('15844','2013-03-20','10:00:00',3.31),('15844','2013-03-20','10:05:00',3.15),('15844','2013-03-20','10:10:00',3.48),('15844','2013-03-20','10:15:00',2.56),('15844','2013-03-20','10:20:00',2.31),('15844','2013-03-20','10:25:00',3),('15844','2013-03-20','10:30:00',3.79),('15844','2013-03-20','10:35:00',3.65),('15844','2013-03-20','10:40:00',2.22),('15844','2013-03-20','10:45:00',3.39),('15844','2013-03-20','10:50:00',2.65),('15844','2013-03-20','10:55:00',2.69),('15844','2013-03-20','11:00:00',2.66),('15844','2013-03-20','11:05:00',2.89),('15844','2013-03-20','11:10:00',1.94),('15844','2013-03-20','11:15:00',1.96),('15844','2013-03-20','11:20:00',2.54),('15844','2013-03-20','11:25:00',2.09),('15844','2013-03-20','11:30:00',2.07),('15844','2013-03-20','11:35:00',2.35),('15844','2013-03-20','11:40:00',1.84),('15844','2013-03-20','11:45:00',1.71),('15844','2013-03-20','11:50:00',1.74),('15844','2013-03-20','11:55:00',1.74),('15844','2013-03-20','12:00:00',1.89),('15844','2013-03-20','12:05:00',1.83),('15844','2013-03-20','12:10:00',1.61),('15844','2013-03-20','12:15:00',1.32),('15844','2013-03-20','12:20:00',1.16),('15844','2013-03-20','12:30:00',1.02),('15844','2013-03-20','12:35:00',1.26),('15844','2013-03-20','12:50:00',1.28),('15844','2013-03-20','12:55:00',1.87),('15844','2013-03-20','13:00:00',1.31),('15844','2013-03-20','13:05:00',1.15),('15844','2013-03-20','13:10:00',1.11),('15844','2013-03-20','13:20:00',1.09),('15844','2013-03-20','13:25:00',1.16),('15844','2013-03-20','13:30:00',1.24),('15844','2013-03-20','13:35:00',1.2),('15844','2013-03-20','13:40:00',1.57),('15844','2013-03-20','13:45:00',1.58),('15844','2013-03-20','13:50:00',1.32),('15844','2013-03-20','13:55:00',1.35),('15844','2013-03-20','14:00:00',1.31),('15844','2013-03-20','14:05:00',1.04),('15844','2013-03-20','14:10:00',1.06),('15844','2013-03-20','14:15:00',1.51),('15844','2013-03-20','14:20:00',1.61),('15844','2013-03-20','14:25:00',1.62),('15844','2013-03-20','14:30:00',1.42),('15844','2013-03-20','14:35:00',1.09),('15844','2013-03-19','07:50:00',1.14),('15844','2013-03-19','08:05:00',1.25),('15844','2013-03-19','08:10:00',1.37),('15844','2013-03-19','08:15:00',1.5),('15844','2013-03-19','08:20:00',1.67),('15844','2013-03-19','08:25:00',1.83),('15844','2013-03-19','08:30:00',1.95),('15844','2013-03-19','08:35:00',1.95),('15844','2013-03-19','08:40:00',2.16),('15844','2013-03-19','08:45:00',2.23),('15844','2013-03-19','08:50:00',2.48),('15844','2013-03-19','08:55:00',2.58),('15844','2013-03-19','09:00:00',2.53),('15844','2013-03-19','09:05:00',2.73),('15844','2013-03-19','09:10:00',2.77),('15844','2013-03-19','09:15:00',2.85),('15844','2013-03-19','09:20:00',2.91),('15844','2013-03-19','09:25:00',2.96),('15844','2013-03-19','09:30:00',3.06),('15844','2013-03-19','09:35:00',3.05),('15844','2013-03-19','09:40:00',3.11),('15844','2013-03-19','09:45:00',2.91),('15844','2013-03-19','09:50:00',3.13),('15844','2013-03-19','09:55:00',3.2),('15844','2013-03-19','10:00:00',2.88),('15844','2013-03-19','10:05:00',3.53),('15844','2013-03-19','10:10:00',3.57),('15844','2013-03-19','10:15:00',3.65),('15844','2013-03-19','10:20:00',3.71),('15844','2013-03-19','10:25:00',3.7),('15844','2013-03-19','10:30:00',3.72),('15844','2013-03-19','10:35:00',3.75),('15844','2013-03-19','10:40:00',3.78),('15844','2013-03-19','10:45:00',3.78),('15844','2013-03-19','10:50:00',3.82),('15844','2013-03-19','10:55:00',3.83),('15844','2013-03-19','11:00:00',3.82),('15844','2013-03-19','11:05:00',3.82),('15844','2013-03-19','11:10:00',3.79),('15844','2013-03-19','11:15:00',3.87),('15844','2013-03-19','11:20:00',3.76),('15844','2013-03-19','11:25:00',3.9),('15844','2013-03-19','11:30:00',3.53),('15844','2013-03-19','11:35:00',2.36),('15844','2013-03-19','11:40:00',3.46),('15844','2013-03-19','11:45:00',3.29),('15844','2013-03-19','11:50:00',3.86),('15844','2013-03-19','11:55:00',3.84),('15844','2013-03-19','12:00:00',3.78),('15844','2013-03-19','12:05:00',3.66),('15844','2013-03-19','12:10:00',3.61),('15844','2013-03-19','12:15:00',3.6),('15844','2013-03-19','12:20:00',3.62),('15844','2013-03-19','12:25:00',3.55),('15844','2013-03-19','12:30:00',3.55),('15844','2013-03-19','12:35:00',3.54),('15844','2013-03-19','12:40:00',3.47),('15844','2013-03-19','12:45:00',3.49),('15844','2013-03-19','12:50:00',3.14),('15844','2013-03-19','12:55:00',3.32),('15844','2013-03-19','13:00:00',3.15),('15844','2013-03-19','13:05:00',3.16),('15844','2013-03-19','13:10:00',3.1),('15844','2013-03-19','13:15:00',3.02),('15844','2013-03-19','13:20:00',2.96),('15844','2013-03-19','13:25:00',2.86),('15844','2013-03-19','13:30:00',2.73),('15844','2013-03-19','13:35:00',2.59),('15844','2013-03-19','13:40:00',2.48),('15844','2013-03-19','13:45:00',2.44),('15844','2013-03-19','13:50:00',2.32),('15844','2013-03-19','13:55:00',2.24),('15844','2013-03-19','14:00:00',2.12),('15844','2013-03-19','14:05:00',2.02),('15844','2013-03-19','14:10:00',1.9),('15844','2013-03-19','14:15:00',1.78),('15844','2013-03-19','14:20:00',1.44),('15844','2013-03-19','14:25:00',1.5),('15844','2013-03-19','14:30:00',1.38),('15844','2013-03-19','14:35:00',1.41),('15844','2013-03-19','14:40:00',1.26),('15844','2013-03-19','14:45:00',1.13),('15844','2013-03-19','14:50:00',1.18),('15844','2013-03-19','14:55:00',1.09),('15844','2013-03-19','15:00:00',1.05),('15844','2013-03-18','09:55:00',1.1),('15844','2013-03-18','10:00:00',1.35),('15844','2013-03-18','10:05:00',1.51),('15844','2013-03-18','10:10:00',1.78),('15844','2013-03-18','10:15:00',1.79),('15844','2013-03-18','10:20:00',2.13),('15844','2013-03-18','10:25:00',2.08),('15844','2013-03-18','10:30:00',1.78),('15844','2013-03-18','10:35:00',1.46),('15844','2013-03-18','10:40:00',1.49),('15844','2013-03-18','10:45:00',1.53),('15844','2013-03-18','11:00:00',1.03),('15844','2013-03-18','11:05:00',1.17),('15844','2013-03-18','11:10:00',1.48),('15844','2013-03-18','11:15:00',1.71),('15844','2013-03-18','11:20:00',1.78),('15844','2013-03-18','11:25:00',2.02),('15844','2013-03-18','11:30:00',2.19),('15844','2013-03-18','11:35:00',1.69),('15844','2013-03-18','11:40:00',1.41),('15844','2013-03-18','11:45:00',1.09),('15844','2013-03-18','11:50:00',1.01),('15844','2013-03-18','11:55:00',1.14),('15844','2013-03-18','12:00:00',1.53),('15844','2013-03-18','12:05:00',2.01),('15844','2013-03-18','12:10:00',2.71),('15844','2013-03-18','12:15:00',3.69),('15844','2013-03-18','12:20:00',2.79),('15844','2013-03-18','12:25:00',2.9),('15844','2013-03-18','12:30:00',3.2),('15844','2013-03-18','12:35:00',2.49),('15844','2013-03-18','12:40:00',1.74),('15844','2013-03-18','12:45:00',2.61),('15844','2013-03-18','12:50:00',2.75),('15844','2013-03-18','12:55:00',2.58),('15844','2013-03-18','13:00:00',1.85),('15844','2013-03-18','13:05:00',2.12),('15844','2013-03-18','13:10:00',1.4),('15844','2013-03-18','13:20:00',1.77),('15844','2013-03-18','13:25:00',1.86),('15844','2013-03-18','13:35:00',1.21),('15844','2013-03-18','13:40:00',1.55),('15844','2013-03-18','13:45:00',1.36),('15844','2013-03-18','13:50:00',1.18),('15844','2013-03-18','14:00:00',1.41),('15844','2013-03-18','14:05:00',1.39),('15844','2013-03-18','14:10:00',1.5),('15844','2013-03-17','08:20:00',1.08),('15844','2013-03-17','08:25:00',1.29),('15844','2013-03-17','08:30:00',1.08),('15844','2013-03-17','08:40:00',1.12),('15844','2013-03-17','08:45:00',1.26),('15844','2013-03-17','08:50:00',1.11),('15844','2013-03-17','09:00:00',1.09),('15844','2013-03-17','09:05:00',1.42),('15844','2013-03-17','09:10:00',1.7),('15844','2013-03-17','09:15:00',1.45),('15844','2013-03-17','09:20:00',1.22),('15844','2013-03-17','09:25:00',1.01),('15844','2013-03-17','09:30:00',1.3),('15844','2013-03-17','09:35:00',1.25),('15844','2013-03-17','09:40:00',1.24),('15844','2013-03-17','09:45:00',1.38),('15844','2013-03-17','09:50:00',1.51),('15844','2013-03-17','09:55:00',1.65),('15844','2013-03-17','10:00:00',1.66),('15844','2013-03-17','10:05:00',1.39),('15844','2013-03-17','10:10:00',1.49),('15844','2013-03-17','10:15:00',1.55),('15844','2013-03-17','10:20:00',1.66),('15844','2013-03-17','10:25:00',1.65),('15844','2013-03-17','10:30:00',1.58),('15844','2013-03-17','10:35:00',1.55),('15844','2013-03-17','10:40:00',1.5),('15844','2013-03-17','10:45:00',1.54),('15844','2013-03-17','10:50:00',1.31),('15844','2013-03-17','10:55:00',1.15),('15844','2013-03-17','11:00:00',1.12),('15844','2013-03-17','11:05:00',1.23),('15844','2013-03-17','11:10:00',1.2),('15844','2013-03-17','11:15:00',1.45),('15844','2013-03-17','11:20:00',1.6),('15844','2013-03-17','11:25:00',1.39),('15844','2013-03-17','11:30:00',1.32),('15844','2013-03-17','11:35:00',1.32),('15844','2013-03-17','11:40:00',1.26),('15844','2013-03-17','11:45:00',1.15),('15844','2013-03-17','11:50:00',1.04),('15844','2013-03-17','12:10:00',1.37),('15844','2013-03-17','12:15:00',1.86),('15844','2013-03-17','12:20:00',2.06),('15844','2013-03-17','12:25:00',2.17),('15844','2013-03-17','12:30:00',2.09),('15844','2013-03-17','12:35:00',2.03),('15844','2013-03-17','12:40:00',2.01),('15844','2013-03-17','12:45:00',1.88),('15844','2013-03-17','12:50:00',1.54),('15844','2013-03-17','12:55:00',1.48),('15844','2013-03-17','13:00:00',1.73),('15844','2013-03-17','13:05:00',1.74),('15844','2013-03-17','13:10:00',1.96),('15844','2013-03-17','13:15:00',1.64),('15844','2013-03-17','13:20:00',1.42),('15844','2013-03-17','13:25:00',1.7),('15844','2013-03-17','13:30:00',2.34),('15844','2013-03-17','13:35:00',1.89),('15844','2013-03-17','13:40:00',1.63),('15844','2013-03-17','13:45:00',1.26),('15844','2013-03-17','13:50:00',1.47),('15844','2013-03-17','13:55:00',1.98),('15844','2013-03-17','14:00:00',1.67),('15844','2013-03-17','14:05:00',1.96),('15844','2013-03-17','14:10:00',1.99),('15844','2013-03-17','14:15:00',1.8),('15844','2013-03-17','14:20:00',1.74),('15844','2013-03-17','14:25:00',1.78),('15844','2013-03-17','14:30:00',1.57),('15844','2013-03-17','14:35:00',1.5),('15844','2013-03-17','14:40:00',1.19),('15844','2013-03-17','14:45:00',1.09),('15844','2013-03-17','14:55:00',1.11),('15844','2013-03-17','15:00:00',1.3),('15844','2013-03-17','15:05:00',1.75),('15844','2013-03-17','15:10:00',1.64),('15844','2013-03-17','15:15:00',1.26),('15844','2013-03-17','15:20:00',1.13),('15844','2013-03-17','15:30:00',1.01),('15844','2013-03-16','08:05:00',1.05),('15844','2013-03-16','08:20:00',1.2),('15844','2013-03-16','08:25:00',1.45),('15844','2013-03-16','08:30:00',1.9),('15844','2013-03-16','08:35:00',1.92),('15844','2013-03-16','08:40:00',1.97),('15844','2013-03-16','08:45:00',2.13),('15844','2013-03-16','08:50:00',2.65),('15844','2013-03-16','08:55:00',2.4),('15844','2013-03-16','09:00:00',2.56),('15844','2013-03-16','09:05:00',2.59),('15844','2013-03-16','09:10:00',2.75),('15844','2013-03-16','09:15:00',2.83),('15844','2013-03-16','09:20:00',2.59),('15844','2013-03-16','09:25:00',2.98),('15844','2013-03-16','09:30:00',3.04),('15844','2013-03-16','09:35:00',2.71),('15844','2013-03-16','09:40:00',2.3),('15844','2013-03-16','09:45:00',2.67),('15844','2013-03-16','09:50:00',3.42),('15844','2013-03-16','09:55:00',2.61),('15844','2013-03-16','10:00:00',2.45),('15844','2013-03-16','10:05:00',3.44),('15844','2013-03-16','10:10:00',2.92),('15844','2013-03-16','10:15:00',2.6),('15844','2013-03-16','10:20:00',2.04),('15844','2013-03-16','10:25:00',3.22),('15844','2013-03-16','10:30:00',3.43),('15844','2013-03-16','10:35:00',3.88),('15844','2013-03-16','10:40:00',3.82),('15844','2013-03-16','10:45:00',3.8),('15844','2013-03-16','10:50:00',3.74),('15844','2013-03-16','10:55:00',3.73),('15844','2013-03-16','11:00:00',3.71),('15844','2013-03-16','11:05:00',3.78),('15844','2013-03-16','11:10:00',3.77),('15844','2013-03-16','11:15:00',3.77),('15844','2013-03-16','11:20:00',3.75),('15844','2013-03-16','11:25:00',3.73),('15844','2013-03-16','11:30:00',3.75),('15844','2013-03-16','11:35:00',3.71),('15844','2013-03-16','11:40:00',3.7),('15844','2013-03-16','11:45:00',3.67),('15844','2013-03-16','11:50:00',3.65),('15844','2013-03-16','11:55:00',3.62),('15844','2013-03-16','12:00:00',3.57),('15844','2013-03-16','12:05:00',3.56),('15844','2013-03-16','12:10:00',3.55),('15844','2013-03-16','12:15:00',3.56),('15844','2013-03-16','12:20:00',3.54),('15844','2013-03-16','12:25:00',3.46),('15844','2013-03-16','12:30:00',3.43),('15844','2013-03-16','12:35:00',3.41),('15844','2013-03-16','12:40:00',3.41),('15844','2013-03-16','12:45:00',3.38),('15844','2013-03-16','12:50:00',3.3),('15844','2013-03-16','12:55:00',3.24),('15844','2013-03-16','13:00:00',3.19),('15844','2013-03-16','13:05:00',3.1),('15844','2013-03-16','13:10:00',3.03),('15844','2013-03-16','13:15:00',3.04),('15844','2013-03-16','13:20:00',2.95),('15844','2013-03-16','13:25:00',2.66),('15844','2013-03-16','13:30:00',2.85),('15844','2013-03-16','13:35:00',2.19),('15844','2013-03-16','13:40:00',2.19),('15844','2013-03-16','13:45:00',2.64),('15844','2013-03-16','13:50:00',2.5),('15844','2013-03-16','13:55:00',2.4),('15844','2013-03-16','14:00:00',1.96),('15844','2013-03-16','14:05:00',2.39),('15844','2013-03-16','14:10:00',2.32),('15844','2013-03-16','14:15:00',2.21),('15844','2013-03-16','14:20:00',1.99),('15844','2013-03-16','14:25:00',1.81),('15844','2013-03-16','14:30:00',1.67),('15844','2013-03-15','10:30:00',1),('15844','2013-03-15','10:35:00',1.12),('15844','2013-03-15','10:40:00',1.13),('15844','2013-03-15','10:45:00',1.12),('15844','2013-03-15','10:50:00',1.35),('15844','2013-03-15','10:55:00',1.36),('15844','2013-03-15','11:00:00',1.35),('15844','2013-03-15','11:05:00',1.18),('15844','2013-03-15','11:25:00',1.09),('15844','2013-03-15','11:30:00',1.38),('15844','2013-03-15','11:35:00',1.51),('15844','2013-03-15','11:40:00',1.63),('15844','2013-03-15','11:45:00',1.79),('15844','2013-03-15','11:50:00',1.68),('15844','2013-03-15','11:55:00',1.75),('15844','2013-03-15','12:00:00',1.65),('15844','2013-03-15','12:05:00',1.45),('15844','2013-03-15','12:10:00',1.64),('15844','2013-03-15','12:15:00',1.65),('15844','2013-03-15','12:20:00',1.64),('15844','2013-03-15','12:25:00',1.74),('15844','2013-03-15','12:30:00',1.86),('15844','2013-03-15','12:35:00',1.64),('15844','2013-03-15','12:40:00',1.22),('15844','2013-03-15','12:45:00',1.08),('15844','2013-03-15','12:50:00',1.09),('15844','2013-03-15','12:55:00',1.08),('15844','2013-03-15','13:00:00',1.01),('15844','2013-03-15','13:05:00',1.06),('15844','2013-03-15','13:10:00',1.15),('15844','2013-03-15','13:15:00',1.33),('15844','2013-03-15','13:20:00',1.57),('15844','2013-03-15','13:25:00',1.68),('15844','2013-03-15','13:30:00',1.33),('15844','2013-03-15','13:35:00',1.25),('15844','2013-03-15','13:40:00',1.17),('15844','2013-03-15','14:50:00',1.1),('15844','2013-03-15','14:55:00',1.08),('15844','2013-03-15','15:00:00',1.06),('15844','2013-03-15','15:05:00',1.05),('15844','2013-03-15','15:10:00',1.03),('15844','2013-03-15','15:15:00',1.13),('15844','2013-03-15','15:20:00',1.15),('15844','2013-03-14','13:00:00',1.11),('15844','2013-03-14','13:05:00',1.14),('15844','2013-03-14','13:10:00',1.17),('15844','2013-03-14','13:15:00',1.2),('15844','2013-03-14','13:20:00',1.26),('15844','2013-03-14','13:25:00',1.47),('15844','2013-03-14','13:30:00',1.75),('15844','2013-03-14','13:35:00',1.83),('15844','2013-03-14','13:40:00',1.51),('15844','2013-03-14','13:45:00',1.07),('15844','2013-03-14','13:50:00',1.23),('15844','2013-03-14','13:55:00',1.11),('15844','2013-03-14','14:00:00',1.03),('15844','2013-03-14','14:15:00',1.16),('15844','2013-03-14','14:20:00',1.16),('15844','2013-03-13','09:10:00',1.01),('15844','2013-03-13','10:10:00',1.56),('15844','2013-03-13','10:15:00',1.33),('15844','2013-03-13','10:30:00',1.37),('15844','2013-03-13','10:35:00',1.72),('15844','2013-03-13','10:40:00',2.15),('15844','2013-03-13','10:45:00',1.85),('15844','2013-03-13','10:50:00',1.77),('15844','2013-03-13','10:55:00',1.08),('15844','2013-03-13','11:00:00',1.21),('15844','2013-03-13','11:05:00',1.39),('15844','2013-03-13','11:10:00',1.55),('15844','2013-03-13','11:15:00',1.33),('15844','2013-03-13','11:20:00',1.2),('15844','2013-03-13','11:25:00',1.31),('15844','2013-03-13','11:30:00',1.32),('15844','2013-03-13','11:35:00',1.29),('15844','2013-03-13','11:40:00',1.38),('15844','2013-03-13','11:45:00',1.37),('15844','2013-03-13','11:50:00',1.2),('15844','2013-03-13','12:50:00',1.01),('15844','2013-03-13','13:35:00',1.13),('15844','2013-03-13','13:40:00',1.16),('15844','2014-03-25','08:05:00',1.02),('15844','2014-03-25','08:10:00',1.12),('15844','2014-03-25','08:15:00',1.09),('15844','2014-03-25','08:40:00',1.26),('15844','2014-03-25','08:45:00',1.55),('15844','2014-03-25','08:50:00',1.54),('15844','2014-03-25','08:55:00',1.54),('15844','2014-03-25','09:00:00',1.44),('15844','2014-03-25','09:05:00',1.54),('15844','2014-03-25','09:10:00',1.63),('15844','2014-03-25','09:15:00',2.06),('15844','2014-03-25','09:20:00',2.04),('15844','2014-03-25','09:25:00',1.73),('15844','2014-03-25','09:30:00',1.55),('15844','2014-03-25','09:35:00',1.58),('15844','2014-03-25','09:40:00',1.51),('15844','2014-03-25','09:45:00',1.52),('15844','2014-03-25','09:50:00',1.68),('15844','2014-03-25','09:55:00',1.97),('15844','2014-03-25','10:00:00',2.16),('15844','2014-03-25','10:05:00',2.41),('15844','2014-03-25','10:10:00',2.76),('15844','2014-03-25','10:15:00',2.69),('15844','2014-03-25','10:20:00',2.71),('15844','2014-03-25','10:25:00',2.7),('15844','2014-03-25','10:30:00',2.2),('15844','2014-03-25','10:35:00',1.88),('15844','2014-03-25','10:40:00',1.72),('15844','2014-03-25','10:45:00',1.56),('15844','2014-03-25','10:50:00',1.53),('15844','2014-03-25','10:55:00',1.7),('15844','2014-03-25','11:00:00',1.9),('15844','2014-03-25','11:05:00',2.19),('15844','2014-03-25','11:10:00',2.33),('15844','2014-03-25','11:15:00',2.39),('15844','2014-03-25','11:20:00',2.56),('15844','2014-03-25','11:25:00',2.79),('15844','2014-03-25','11:30:00',2.88),('15844','2014-03-25','11:35:00',2.57),('15844','2014-03-25','11:40:00',2.3),('15844','2014-03-25','11:45:00',1.76),('15844','2014-03-25','11:50:00',1.87),('15844','2014-03-25','11:55:00',1.22),('15844','2014-03-25','12:20:00',1.06),('15844','2014-03-25','12:25:00',1.31),('15844','2014-03-25','12:30:00',1.16),('15844','2014-03-25','12:35:00',1.05),('15844','2014-03-25','12:40:00',1.04),('15844','2014-03-25','12:45:00',1.02),('15844','2014-03-25','12:50:00',1),('15844','2013-03-12','08:15:00',1.07),('15844','2013-03-12','08:20:00',1.74),('15844','2013-03-12','08:25:00',1.45),('15844','2013-03-12','08:30:00',1.37),('15844','2013-03-12','08:35:00',1.28),('15844','2013-03-12','08:40:00',1.35),('15844','2013-03-12','08:45:00',1.29),('15844','2013-03-12','08:50:00',1.14),('15844','2013-03-12','08:55:00',2.23),('15844','2013-03-12','09:00:00',2.34),('15844','2013-03-12','09:05:00',2.38),('15844','2013-03-12','09:10:00',2.51),('15844','2013-03-12','09:15:00',2.58),('15844','2013-03-12','09:20:00',2.65),('15844','2013-03-12','09:25:00',2.76),('15844','2013-03-12','09:30:00',2.86),('15844','2013-03-12','09:35:00',2.95),('15844','2013-03-12','09:40:00',2.84),('15844','2013-03-12','09:45:00',2.56),('15844','2013-03-12','09:50:00',2.61),('15844','2013-03-12','09:55:00',3.37),('15844','2013-03-12','10:00:00',2.81),('15844','2013-03-12','10:05:00',3.45),('15844','2013-03-12','10:10:00',3.01),('15844','2013-03-12','10:15:00',2.78),('15844','2013-03-12','10:20:00',3.45),('15844','2013-03-12','10:25:00',3.91),('15844','2013-03-12','10:30:00',2.99),('15844','2013-03-12','10:35:00',3.87),('15844','2013-03-12','10:40:00',3.73),('15844','2013-03-12','10:45:00',3.7),('15844','2013-03-12','10:50:00',3.43),('15844','2013-03-12','10:55:00',3.74),('15844','2013-03-12','11:00:00',3.37),('15844','2013-03-12','11:05:00',1.45),('15844','2013-03-12','11:15:00',1.1),('15844','2013-03-12','11:20:00',1.62),('15844','2013-03-12','11:25:00',3.17),('15844','2013-03-12','11:30:00',1.51),('15844','2013-03-12','11:35:00',1.43),('15844','2013-03-12','11:40:00',1.62),('15844','2013-03-12','11:45:00',2.22),('15844','2013-03-12','11:50:00',3.06),('15844','2013-03-12','11:55:00',4.39),('15844','2013-03-12','12:00:00',4.08),('15844','2013-03-12','12:05:00',2.88),('15844','2013-03-12','12:10:00',2.96),('15844','2013-03-12','12:15:00',1.58),('15844','2013-03-12','12:20:00',1.78),('15844','2013-03-12','12:25:00',2.39),('15844','2013-03-12','12:30:00',4.22),('15844','2013-03-12','12:35:00',2.78),('15844','2013-03-12','12:40:00',2.12),('15844','2013-03-12','12:45:00',2.33),('15844','2013-03-12','12:50:00',2.53),('15844','2013-03-12','12:55:00',1.62),('15844','2013-03-12','13:00:00',2.19),('15844','2013-03-12','13:05:00',3.15),('15844','2013-03-12','13:10:00',3.07),('15844','2013-03-12','13:15:00',1.55),('15844','2013-03-12','13:20:00',1.76),('15844','2013-03-12','13:25:00',1.4),('15844','2013-03-12','13:30:00',1.62),('15844','2013-03-12','13:35:00',2.01),('15844','2013-03-12','13:40:00',2.83),('15844','2013-03-12','13:45:00',2.21),('15844','2013-03-12','13:50:00',1.8),('15844','2013-03-12','13:55:00',1.94),('15844','2013-03-12','14:05:00',1.25),('15844','2013-03-12','14:10:00',1.9),('15844','2013-03-12','14:15:00',1.94),('15844','2013-03-12','14:20:00',1.4),('15844','2013-03-12','14:55:00',1.74),('15844','2013-03-12','15:00:00',1.41),('15844','2013-03-12','15:05:00',1.05),('15844','2013-03-12','15:10:00',1.04),('15844','2013-03-12','15:15:00',1.32),('15844','2013-03-12','15:20:00',1.09),('15844','2013-03-11','08:00:00',1.01),('15844','2013-03-11','08:05:00',1.2),('15844','2013-03-11','08:10:00',1.3),('15844','2013-03-11','08:15:00',1.44),('15844','2013-03-11','08:20:00',1.56),('15844','2013-03-11','08:25:00',1.69),('15844','2013-03-11','08:30:00',1.83),('15844','2013-03-11','08:35:00',1.94),('15844','2013-03-11','08:40:00',1.56),('15844','2013-03-11','08:45:00',1.75),('15844','2013-03-11','08:50:00',2.01),('15844','2013-03-11','08:55:00',2.33),('15844','2013-03-11','09:00:00',2.44),('15844','2013-03-11','09:05:00',2.48),('15844','2013-03-11','09:10:00',2.59),('15844','2013-03-11','09:15:00',2.68),('15844','2013-03-11','09:20:00',1.42),('15844','2013-03-11','09:25:00',1.92),('15844','2013-03-11','09:30:00',2.16),('15844','2013-03-11','09:35:00',1.63),('15844','2013-03-11','10:00:00',1.02),('15844','2013-03-11','10:05:00',1.1),('15844','2013-03-11','10:10:00',1.09),('15844','2013-03-11','10:15:00',1.18),('15844','2013-03-11','10:20:00',1.21),('15844','2013-03-11','10:25:00',1.22),('15844','2013-03-11','10:30:00',1.18),('15844','2013-03-11','10:35:00',1.83),('15844','2013-03-11','10:40:00',2.93),('15844','2013-03-11','10:45:00',2.82),('15844','2013-03-11','10:50:00',3.63),('15844','2013-03-11','10:55:00',2.08),('15844','2013-03-11','11:00:00',3.03),('15844','2013-03-11','11:05:00',1.3),('15844','2013-03-11','11:10:00',1.05),('15844','2013-03-11','11:15:00',1.18),('15844','2013-03-11','11:20:00',1.31),('15844','2013-03-11','11:25:00',1.2),('15844','2013-03-11','11:30:00',1.55),('15844','2013-03-11','11:35:00',2.65),('15844','2013-03-11','11:40:00',2.34),('15844','2013-03-11','11:45:00',1.61),('15844','2013-03-11','11:50:00',1.86),('15844','2013-03-11','11:55:00',1.28),('15844','2013-03-11','12:00:00',1.05),('15844','2013-03-11','12:10:00',1.62),('15844','2013-03-11','12:15:00',1.7),('15844','2013-03-11','12:20:00',2.5),('15844','2013-03-11','12:25:00',1.03),('15844','2013-03-11','12:30:00',2.91),('15844','2013-03-11','12:35:00',1.63),('15844','2013-03-11','12:40:00',2.21),('15844','2013-03-11','12:45:00',1.28),('15844','2013-03-11','12:50:00',2.59),('15844','2013-03-11','12:55:00',3.59),('15844','2013-03-11','13:00:00',3.41),('15844','2013-03-11','13:05:00',2.94),('15844','2013-03-11','13:10:00',3.16),('15844','2013-03-11','13:15:00',2.25),('15844','2013-03-11','13:20:00',2.7),('15844','2013-03-11','13:25:00',2.79),('15844','2013-03-11','13:30:00',2.69),('15844','2013-03-11','13:35:00',2.67),('15844','2013-03-11','13:40:00',1.63),('15844','2013-03-11','13:45:00',2.67),('15844','2013-03-11','13:50:00',2.31),('15844','2013-03-11','13:55:00',1.6),('15844','2013-03-11','14:00:00',2.35),('15844','2013-03-11','14:05:00',2.29),('15844','2013-03-11','14:10:00',1.55),('15844','2013-03-11','14:15:00',1.66),('15844','2013-03-11','14:20:00',2.2),('15844','2013-03-11','14:25:00',1.77),('15844','2013-03-11','14:30:00',1.61),('15844','2013-03-11','14:35:00',1.81),('15844','2013-03-11','14:40:00',1.59),('15844','2013-03-11','14:45:00',1.39),('15844','2013-03-11','14:50:00',1.17),('15844','2013-03-11','14:55:00',1.08),('15844','2013-03-11','15:05:00',1.1),('15844','2013-03-10','07:55:00',1.01),('15844','2013-03-10','08:00:00',1.06),('15844','2013-03-10','08:05:00',1.19),('15844','2013-03-10','08:10:00',1.31),('15844','2013-03-10','08:15:00',1.43),('15844','2013-03-10','08:20:00',1.55),('15844','2013-03-10','08:25:00',1.68),('15844','2013-03-10','08:30:00',1.82),('15844','2013-03-10','08:35:00',1.92),('15844','2013-03-10','08:40:00',2.01),('15844','2013-03-10','08:45:00',2.13),('15844','2013-03-10','08:50:00',2.27),('15844','2013-03-10','08:55:00',2.32),('15844','2013-03-10','09:00:00',2.39),('15844','2013-03-10','09:05:00',2.48),('15844','2013-03-10','09:10:00',2.55),('15844','2013-03-10','09:15:00',2.58),('15844','2013-03-10','09:20:00',2.71),('15844','2013-03-10','09:25:00',2.82),('15844','2013-03-10','09:30:00',1.91),('15844','2013-03-10','09:35:00',2.44),('15844','2013-03-10','09:40:00',2.8),('15844','2013-03-10','09:45:00',3.3),('15844','2013-03-10','09:50:00',2.73),('15844','2013-03-10','09:55:00',2.6),('15844','2013-03-10','10:00:00',3.13),('15844','2013-03-10','10:05:00',3.46),('15844','2013-03-10','10:10:00',3.59),('15844','2013-03-10','10:15:00',3.5),('15844','2013-03-10','10:20:00',3.06),('15844','2013-03-10','10:25:00',3.55),('15844','2013-03-10','10:30:00',3.49),('15844','2013-03-10','10:35:00',3.52),('15844','2013-03-10','10:40:00',3.55),('15844','2013-03-10','10:45:00',2.89),('15844','2013-03-10','10:50:00',2.98),('15844','2013-03-10','10:55:00',3.66),('15844','2013-03-10','11:00:00',3.45),('15844','2013-03-10','11:05:00',3.64),('15844','2013-03-10','11:10:00',3.57),('15844','2013-03-10','11:15:00',3.05),('15844','2013-03-10','11:20:00',3.77),('15844','2013-03-10','11:25:00',3.62),('15844','2013-03-10','11:30:00',2.32),('15844','2013-03-10','11:35:00',3.63),('15844','2013-03-10','11:40:00',3.72),('15844','2013-03-10','11:45:00',3.73),('15844','2013-03-10','11:50:00',3.58),('15844','2013-03-10','11:55:00',3.47),('15844','2013-03-10','12:00:00',3.48),('15844','2013-03-10','12:05:00',3.45),('15844','2013-03-10','12:10:00',3.44),('15844','2013-03-10','12:15:00',3.43),('15844','2013-03-10','12:20:00',3.45),('15844','2013-03-10','12:25:00',3.37),('15844','2013-03-10','12:30:00',3.31),('15844','2013-03-10','12:35:00',1.98),('15844','2013-03-10','12:40:00',1.57),('15844','2013-03-10','12:45:00',3.14),('15844','2013-03-10','12:50:00',3.72),('15844','2013-03-10','12:55:00',3.27),('15844','2013-03-10','13:00:00',3.07),('15844','2013-03-10','13:05:00',3.01),('15844','2013-03-10','13:10:00',2.91),('15844','2013-03-10','13:15:00',2.93),('15844','2013-03-10','13:20:00',2.65),('15844','2013-03-10','13:25:00',2.46),('15844','2013-03-10','13:30:00',2.61),('15844','2013-03-10','13:35:00',1.53),('15844','2013-03-10','13:40:00',1.53),('15844','2013-03-10','13:45:00',1.35),('15844','2013-03-10','13:50:00',1.34),('15844','2013-03-10','13:55:00',1.43),('15844','2013-03-10','14:00:00',1.32),('15844','2013-03-10','14:05:00',1.46),('15844','2013-03-10','14:10:00',1.38),('15844','2013-03-10','14:15:00',1.37),('15844','2013-03-10','14:20:00',1.61),('15844','2013-03-10','14:25:00',1.3),('15844','2013-03-10','14:40:00',1.25),('15844','2013-03-10','14:45:00',1.25),('15844','2013-03-10','14:50:00',1.29),('15844','2013-03-10','15:05:00',1.09),('15844','2013-03-09','08:10:00',1.33),('15844','2013-03-09','08:15:00',1.45),('15844','2013-03-09','08:20:00',1.6),('15844','2013-03-09','08:25:00',1.73),('15844','2013-03-09','08:30:00',1.82),('15844','2013-03-09','08:35:00',1.92),('15844','2013-03-09','08:40:00',2),('15844','2013-03-09','08:45:00',2.09),('15844','2013-03-09','08:50:00',2.2),('15844','2013-03-09','08:55:00',1.94),('15844','2013-03-09','09:00:00',1.41),('15844','2013-03-09','09:05:00',1.04),('15844','2013-03-09','09:10:00',1.79),('15844','2013-03-09','09:20:00',1.03),('15844','2013-03-09','09:25:00',1.79),('15844','2013-03-09','09:30:00',2.64),('15844','2013-03-09','09:35:00',2.69),('15844','2013-03-09','09:40:00',3.06),('15844','2013-03-09','09:45:00',3.11),('15844','2013-03-09','09:50:00',3.31),('15844','2013-03-09','09:55:00',3.59),('15844','2013-03-09','10:00:00',3.68),('15844','2013-03-09','10:05:00',3.62),('15844','2013-03-09','10:10:00',3.56),('15844','2013-03-09','10:15:00',3.66),('15844','2013-03-09','10:20:00',3.25),('15844','2013-03-09','10:25:00',2.63),('15844','2013-03-09','10:30:00',2.82),('15844','2013-03-09','10:35:00',2.71),('15844','2013-03-09','10:40:00',3.99),('15844','2013-03-09','10:45:00',3.77),('15844','2013-03-09','10:50:00',3.67),('15844','2013-03-09','10:55:00',3.65),('15844','2013-03-09','11:00:00',3.61),('15844','2013-03-09','11:05:00',3.6),('15844','2013-03-09','11:10:00',3.61),('15844','2013-03-09','11:15:00',3.61),('15844','2013-03-09','11:20:00',3.6),('15844','2013-03-09','11:25:00',3.59),('15844','2013-03-09','11:30:00',3.57),('15844','2013-03-09','11:35:00',3.55),('15844','2013-03-09','11:40:00',3.52),('15844','2013-03-09','11:45:00',3.46),('15844','2013-03-09','11:50:00',3.48),('15844','2013-03-09','11:55:00',3.45),('15844','2013-03-09','12:00:00',3.45),('15844','2013-03-09','12:05:00',3.26),('15844','2013-03-09','12:10:00',3.11),('15844','2013-03-09','12:15:00',2.13),('15844','2013-03-09','12:20:00',2.09),('15844','2013-03-09','12:25:00',2.99),('15844','2013-03-09','12:30:00',2.21),('15844','2013-03-09','12:35:00',1.74),('15844','2013-03-09','12:40:00',3.83),('15844','2013-03-09','12:45:00',3.55),('15844','2013-03-09','12:50:00',3.22),('15844','2013-03-09','12:55:00',3.13),('15844','2013-03-09','13:00:00',3.06),('15844','2013-03-09','13:05:00',2.99),('15844','2013-03-09','13:10:00',2.68),('15844','2013-03-09','13:15:00',2.15),('15844','2013-03-09','13:20:00',2.64),('15844','2013-03-09','13:25:00',2.02),('15844','2013-03-09','13:30:00',2.51),('15844','2013-03-09','13:35:00',2.48),('15844','2013-03-09','13:40:00',2.37),('15844','2013-03-09','13:45:00',2.28),('15844','2013-03-09','13:50:00',2.18),('15844','2013-03-09','13:55:00',2.1),('15844','2013-03-09','14:00:00',1.48),('15844','2013-03-09','14:10:00',1.48),('15844','2013-03-09','14:15:00',1.23),('15844','2013-03-09','14:20:00',1.57),('15844','2013-03-09','14:25:00',1.41),('15844','2013-03-09','14:30:00',1.27),('15844','2013-03-09','14:35:00',1.19),('15844','2013-03-09','14:40:00',1.11),('15844','2013-03-09','14:45:00',1.07),('15844','2013-03-09','14:50:00',1.02),('15844','2013-03-08','09:05:00',1.25),('15844','2013-03-08','09:10:00',2.14),('15844','2013-03-08','09:15:00',2.22),('15844','2013-03-08','09:20:00',2.41),('15844','2013-03-08','09:25:00',2.5),('15844','2013-03-08','09:30:00',2.66),('15844','2013-03-08','09:35:00',1.45),('15844','2013-03-08','09:40:00',3.12),('15844','2013-03-08','09:45:00',2.89),('15844','2013-03-08','09:50:00',1.96),('15844','2013-03-08','09:55:00',3.27),('15844','2013-03-08','10:00:00',1.34),('15844','2013-03-08','10:05:00',1.94),('15844','2013-03-08','10:10:00',1.9),('15844','2013-03-08','10:15:00',2.05),('15844','2013-03-08','10:20:00',2.48),('15844','2013-03-08','10:25:00',1.71),('15844','2013-03-08','10:30:00',1.42),('15844','2013-03-08','11:50:00',1.11),('15844','2013-03-08','11:55:00',2.1),('15844','2013-03-08','12:05:00',1.15),('15844','2013-03-08','12:10:00',1.72),('15844','2013-03-08','12:15:00',1.63),('15844','2013-03-08','12:20:00',1.42),('15844','2013-03-08','12:25:00',1.14),('15844','2013-03-08','12:35:00',1.01),('15844','2013-03-08','12:40:00',1.45),('15844','2013-03-08','12:45:00',1.7),('15844','2013-03-08','12:50:00',1.82),('15844','2013-03-08','12:55:00',2.87),('15844','2013-03-08','13:00:00',3.23),('15844','2013-03-08','13:05:00',1.85),('15844','2013-03-08','13:10:00',1.12),('15844','2013-03-08','13:15:00',1.04),('15844','2013-03-08','13:30:00',1.03),('15844','2013-03-07','08:50:00',1.15),('15844','2013-03-07','08:55:00',1.04),('15844','2013-03-07','10:35:00',1.06),('15844','2013-03-07','10:45:00',1.01),('15844','2013-03-07','10:50:00',1.22),('15844','2013-03-07','10:55:00',1.15),('15844','2013-03-07','11:00:00',1.04),('15844','2013-03-07','11:05:00',1.14),('15844','2013-03-07','11:10:00',1.15),('15844','2013-03-07','11:35:00',1.93),('15844','2013-03-07','11:40:00',4.13),('15844','2013-03-07','11:45:00',2.37),('15844','2013-03-07','11:50:00',1.95),('15844','2013-03-07','11:55:00',2.07),('15844','2013-03-07','12:00:00',1.6),('15844','2013-03-07','12:20:00',1.33),('15844','2013-03-07','12:25:00',1.29),('15844','2013-03-07','13:00:00',1.14),('15844','2013-03-07','13:05:00',2.36),('15844','2013-03-07','13:10:00',2.73),('15844','2013-03-07','13:15:00',1.65),('15844','2013-03-07','13:20:00',1.04),('15844','2013-03-07','13:25:00',1.12),('15844','2013-03-07','13:30:00',1.58),('15844','2013-03-07','13:35:00',1.33),('15844','2013-03-07','15:35:00',1.17),('15844','2013-03-07','15:40:00',1.01),('15844','2013-03-05','08:25:00',1.44),('15844','2013-03-05','08:30:00',1.23),('15844','2013-03-05','08:35:00',1.35),('15844','2013-03-05','08:40:00',1.19),('15844','2013-03-05','08:45:00',1.28),('15844','2013-03-05','08:50:00',1.34),('15844','2013-03-05','08:55:00',1.3),('15844','2013-03-05','09:00:00',1.28),('15844','2013-03-05','09:05:00',1.26),('15844','2013-03-05','09:10:00',1.19),('15844','2013-03-05','09:15:00',1.19),('15844','2013-03-05','09:20:00',1.24),('15844','2013-03-05','09:25:00',1.24),('15844','2013-03-05','09:30:00',1.37),('15844','2013-03-05','09:35:00',1.44),('15844','2013-03-05','09:40:00',1.47),('15844','2013-03-05','09:45:00',1.45),('15844','2013-03-05','09:50:00',1.37),('15844','2013-03-05','09:55:00',1.45),('15844','2013-03-05','10:00:00',1.47),('15844','2013-03-05','10:05:00',1.4),('15844','2013-03-05','10:10:00',1.46),('15844','2013-03-05','10:15:00',1.59),('15844','2013-03-05','10:20:00',1.73),('15844','2013-03-05','10:25:00',1.57),('15844','2013-03-05','10:30:00',1.7),('15844','2013-03-05','10:35:00',1.89),('15844','2013-03-05','10:40:00',2.02),('15844','2013-03-05','10:45:00',2.11),('15844','2013-03-05','10:50:00',2.35),('15844','2013-03-05','10:55:00',2.23),('15844','2013-03-05','11:00:00',2.23),('15844','2013-03-05','11:05:00',2.34),('15844','2013-03-05','11:10:00',2.33),('15844','2013-03-05','11:15:00',2.21),('15844','2013-03-05','11:20:00',2.15),('15844','2013-03-05','11:25:00',2.14),('15844','2013-03-05','11:30:00',2.28),('15844','2013-03-05','11:35:00',2.51),('15844','2013-03-05','11:40:00',2.61),('15844','2013-03-05','11:45:00',2.5),('15844','2013-03-05','11:50:00',2.61),('15844','2013-03-05','11:55:00',2.61),('15844','2013-03-05','12:00:00',2.64),('15844','2013-03-05','12:05:00',2.69),('15844','2013-03-05','12:10:00',2.71),('15844','2013-03-05','12:15:00',2.11),('15844','2013-03-05','12:20:00',2.53),('15844','2013-03-05','12:25:00',2.34),('15844','2013-03-05','12:30:00',1.92),('15844','2013-03-05','12:35:00',1.94),('15844','2013-03-05','12:40:00',2),('15844','2013-03-05','12:45:00',1.99),('15844','2013-03-05','12:50:00',1.76),('15844','2013-03-05','12:55:00',1.5),('15844','2013-03-05','13:00:00',1.34),('15844','2013-03-05','13:05:00',1.33),('15844','2013-03-05','13:10:00',1.45),('15844','2013-03-05','13:15:00',1.46),('15844','2013-03-05','13:20:00',1.36),('15844','2013-03-05','13:25:00',1.25),('15844','2013-03-05','13:30:00',1.15),('15844','2013-03-05','13:35:00',1.08),('15844','2013-03-05','13:40:00',1),('15844','2013-03-04','08:20:00',1.16),('15844','2013-03-04','08:25:00',1.29),('15844','2013-03-04','08:30:00',1.4),('15844','2013-03-04','08:35:00',1.5),('15844','2013-03-04','08:40:00',1.62),('15844','2013-03-04','08:45:00',1.71),('15844','2013-03-04','08:50:00',1.8),('15844','2013-03-04','08:55:00',1.91),('15844','2013-03-04','09:00:00',2),('15844','2013-03-04','09:05:00',2.1),('15844','2013-03-04','09:10:00',2.19),('15844','2013-03-04','09:15:00',2.31),('15844','2013-03-04','09:20:00',2.4),('15844','2013-03-04','09:25:00',2.49),('15844','2013-03-04','09:30:00',2.55),('15844','2013-03-04','09:35:00',2.6),('15844','2013-03-04','09:40:00',2.65),('15844','2013-03-04','09:45:00',2.71),('15844','2013-03-04','09:50:00',2.78),('15844','2013-03-04','09:55:00',2.81),('15844','2013-03-04','10:00:00',2.88),('15844','2013-03-04','10:05:00',2.88),('15844','2013-03-04','10:10:00',2.92),('15844','2013-03-04','10:15:00',2.94),('15844','2013-03-04','10:20:00',3.04),('15844','2013-03-04','10:25:00',3),('15844','2013-03-04','10:30:00',3.06),('15844','2013-03-04','10:35:00',3.06),('15844','2013-03-04','10:40:00',3.05),('15844','2013-03-04','10:45:00',3.12),('15844','2013-03-04','10:50:00',3.13),('15844','2013-03-04','10:55:00',3.19),('15844','2013-03-04','11:00:00',3.21),('15844','2013-03-04','11:05:00',3.22),('15844','2013-03-04','11:10:00',3.22),('15844','2013-03-04','11:15:00',3.25),('15844','2013-03-04','11:20:00',3.22),('15844','2013-03-04','11:25:00',3.21),('15844','2013-03-04','11:30:00',3.16),('15844','2013-03-04','11:35:00',3.12),('15844','2013-03-04','11:40:00',3.14),('15844','2013-03-04','11:45:00',3.14),('15844','2013-03-04','11:50:00',3.1),('15844','2013-03-04','11:55:00',3.02),('15844','2013-03-04','12:00:00',3.02),('15844','2013-03-04','12:05:00',3.07),('15844','2013-03-04','12:10:00',3.07),('15844','2013-03-04','12:15:00',3.06),('15844','2013-03-04','12:20:00',3),('15844','2013-03-04','12:25:00',2.97),('15844','2013-03-04','12:30:00',2.91),('15844','2013-03-04','12:35:00',2.86),('15844','2013-03-04','12:40:00',2.87),('15844','2013-03-04','12:45:00',2.8),('15844','2013-03-04','12:50:00',2.68),('15844','2013-03-04','12:55:00',2.64),('15844','2013-03-04','13:00:00',2.6),('15844','2013-03-04','13:05:00',2.62),('15844','2013-03-04','13:10:00',2.47),('15844','2013-03-04','13:15:00',2.46),('15844','2013-03-04','13:20:00',2.41),('15844','2013-03-04','13:25:00',2.4),('15844','2013-03-04','13:30:00',2.44),('15844','2013-03-04','13:35:00',2.2),('15844','2013-03-04','13:40:00',2.04),('15844','2013-03-04','13:45:00',1.99),('15844','2013-03-04','13:50:00',1.88),('15844','2013-03-04','13:55:00',1.79),('15844','2013-03-04','14:00:00',1.7),('15844','2013-03-04','14:05:00',1.61),('15844','2013-03-04','14:10:00',1.53),('15844','2013-03-04','14:15:00',1.45),('15844','2013-03-04','14:20:00',1.37),('15844','2013-03-04','14:25:00',1.29),('15844','2013-03-04','14:30:00',1.19),('15844','2013-03-04','14:35:00',1.07),('15844','2013-03-03','08:00:00',1.03),('15844','2013-03-03','08:05:00',1.14),('15844','2013-03-03','08:10:00',1.23),('15844','2013-03-03','08:15:00',1.34),('15844','2013-03-03','08:20:00',1.44),('15844','2013-03-03','08:25:00',1.52),('15844','2013-03-03','08:30:00',1.59),('15844','2013-03-03','08:35:00',1.68),('15844','2013-03-03','08:40:00',1.75),('15844','2013-03-03','08:45:00',1.82),('15844','2013-03-03','08:50:00',1.89),('15844','2013-03-03','08:55:00',1.96),('15844','2013-03-03','09:00:00',2.03),('15844','2013-03-03','09:05:00',2.09),('15844','2013-03-03','09:10:00',2.15),('15844','2013-03-03','09:15:00',2.22),('15844','2013-03-03','09:20:00',2.38),('15844','2013-03-03','09:25:00',2.48),('15844','2013-03-03','09:30:00',2.56),('15844','2013-03-03','09:35:00',2.65),('15844','2013-03-03','09:40:00',2.73),('15844','2013-03-03','09:45:00',2.81),('15844','2013-03-03','09:50:00',2.84),('15844','2013-03-03','09:55:00',2.92),('15844','2013-03-03','10:00:00',2.96),('15844','2013-03-03','10:05:00',2.97),('15844','2013-03-03','10:10:00',3.03),('15844','2013-03-03','10:15:00',3.08),('15844','2013-03-03','10:20:00',3.1),('15844','2013-03-03','10:25:00',3.14),('15844','2013-03-03','10:30:00',3.18),('15844','2013-03-03','10:35:00',3.2),('15844','2013-03-03','10:40:00',3.24),('15844','2013-03-03','10:45:00',3.26),('15844','2013-03-03','10:50:00',3.29),('15844','2013-03-03','10:55:00',3.3),('15844','2013-03-03','11:00:00',3.32),('15844','2013-03-03','11:05:00',3.33),('15844','2013-03-03','11:10:00',3.33),('15844','2013-03-03','11:15:00',3.33),('15844','2013-03-03','11:20:00',3.33),('15844','2013-03-03','11:25:00',3.33),('15844','2013-03-03','11:30:00',3.31),('15844','2013-03-03','11:35:00',3.31),('15844','2013-03-03','11:40:00',3.29),('15844','2013-03-03','11:45:00',3.27),('15844','2013-03-03','11:50:00',3.25),('15844','2013-03-03','11:55:00',3.23),('15844','2013-03-03','12:00:00',3.23),('15844','2013-03-03','12:05:00',3.21),('15844','2013-03-03','12:10:00',3.2),('15844','2013-03-03','12:15:00',3.17),('15844','2013-03-03','12:20:00',3.14),('15844','2013-03-03','12:25:00',3.08),('15844','2013-03-03','12:30:00',3.04),('15844','2013-03-03','12:35:00',3.02),('15844','2013-03-03','12:40:00',2.99),('15844','2013-03-03','12:45:00',2.87),('15844','2013-03-03','12:50:00',2.91),('15844','2013-03-03','12:55:00',2.83),('15844','2013-03-03','13:00:00',2.78),('15844','2013-03-03','13:05:00',2.7),('15844','2013-03-03','13:10:00',2.66),('15844','2013-03-03','13:15:00',2.58),('15844','2013-03-03','13:20:00',2.5),('15844','2013-03-03','13:25:00',2.4),('15844','2013-03-03','13:30:00',2.28),('15844','2013-03-03','13:35:00',2.19),('15844','2013-03-03','13:40:00',2.09),('15844','2013-03-03','13:45:00',2.04),('15844','2013-03-03','13:50:00',1.94),('15844','2013-03-03','13:55:00',1.87),('15844','2013-03-03','14:00:00',1.75),('15844','2013-03-03','14:05:00',1.66),('15844','2013-03-03','14:10:00',1.56),('15844','2013-03-03','14:15:00',1.44),('15844','2013-03-03','14:20:00',1.32),('15844','2013-03-03','14:25:00',1.22),('15844','2013-03-03','14:30:00',1.13),('15844','2013-03-03','14:35:00',1.03),('15844','2014-03-24','08:50:00',1.17),('15844','2014-03-24','08:55:00',1.58),('15844','2014-03-24','09:15:00',1.14),('15844','2014-03-24','09:20:00',1.62),('15844','2014-03-24','09:25:00',1.66),('15844','2014-03-24','09:35:00',1.35),('15844','2014-03-24','09:40:00',1.78),('15844','2014-03-24','09:45:00',1.35),('15844','2014-03-24','09:55:00',2),('15844','2014-03-24','10:00:00',3.45),('15844','2014-03-24','10:05:00',3.54),('15844','2014-03-24','10:10:00',2.35),('15844','2014-03-24','10:30:00',1.08),('15844','2014-03-24','10:40:00',1.23),('15844','2014-03-24','10:45:00',2.73),('15844','2014-03-24','10:50:00',4.05),('15844','2014-03-24','10:55:00',3.01),('15844','2014-03-24','11:00:00',2.51),('15844','2014-03-24','11:05:00',2.53),('15844','2014-03-24','11:10:00',3.24),('15844','2014-03-24','11:15:00',3.34),('15844','2014-03-24','11:20:00',2.57),('15844','2014-03-24','11:25:00',2.36),('15844','2014-03-24','11:30:00',1.92),('15844','2014-03-24','12:25:00',1.08),('15844','2014-03-24','12:30:00',1.72),('15844','2014-03-24','12:35:00',1.79),('15844','2014-03-24','12:40:00',1.46),('15844','2014-03-24','12:45:00',1.25),('15844','2014-03-24','12:50:00',1.2),('15844','2014-03-24','12:55:00',1.15),('15844','2014-03-24','13:00:00',1.15),('15844','2014-03-24','13:05:00',1.02),('15844','2014-03-24','13:15:00',1.12),('15844','2014-03-24','13:20:00',1.08),('15844','2014-03-24','13:25:00',1.21),('15844','2014-03-24','13:30:00',1.18),('15844','2014-03-24','13:35:00',1.27),('15844','2014-03-24','13:40:00',1.26),('15844','2014-03-24','13:45:00',1.11),('15844','2014-03-24','13:50:00',1.08),('15844','2014-03-24','14:10:00',1.12),('15844','2014-03-24','14:15:00',1.53),('15844','2014-03-24','14:20:00',1.74),('15844','2014-03-24','14:25:00',1.59),('15844','2014-03-24','14:30:00',1.6),('15844','2014-03-24','14:35:00',1.92),('15844','2014-03-24','14:40:00',1.97),('15844','2014-03-24','14:45:00',1.9),('15844','2014-03-24','14:50:00',1.67),('15844','2014-03-24','14:55:00',1.42),('15844','2014-03-24','15:00:00',1.36),('15844','2014-03-24','15:05:00',1.29),('15844','2014-03-24','15:10:00',1.21),('15844','2014-03-24','15:15:00',1.25),('15844','2014-03-24','15:20:00',1.16),('15844','2014-03-24','15:25:00',1.15),('15844','2014-03-24','15:30:00',1.1),('15844','2013-03-02','11:05:00',1.02),('15844','2013-03-02','11:35:00',1.1),('15844','2013-03-02','11:40:00',1.42),('15844','2013-03-02','11:45:00',1.65),('15844','2013-03-02','11:50:00',1.45),('15844','2013-03-02','11:55:00',1.83),('15844','2013-03-02','12:00:00',1.54),('15844','2013-03-02','12:05:00',2.26),('15844','2013-03-02','12:10:00',2.48),('15844','2013-03-02','12:15:00',2.05),('15844','2013-03-02','12:20:00',2.64),('15844','2013-03-02','12:25:00',2.5),('15844','2013-03-02','12:30:00',1.94),('15844','2013-03-02','12:35:00',1.88),('15844','2013-03-02','12:40:00',1.79),('15844','2013-03-02','12:45:00',1.05),('15844','2013-03-02','12:55:00',1.02),('15844','2013-03-02','13:30:00',1.02),('15844','2013-03-02','13:35:00',1.01),('15844','2013-03-02','13:55:00',1.06),('15844','2013-03-02','14:00:00',1.13),('15844','2013-03-02','14:05:00',1.06),('15844','2013-03-01','08:30:00',1.02),('15844','2013-03-01','08:35:00',1.08),('15844','2013-03-01','08:40:00',1.24),('15844','2013-03-01','08:45:00',1.35),('15844','2013-03-01','08:50:00',1.43),('15844','2013-03-01','08:55:00',1.58),('15844','2013-03-01','09:00:00',1.71),('15844','2013-03-01','09:05:00',1.71),('15844','2013-03-01','09:10:00',1.74),('15844','2013-03-01','09:15:00',1.87),('15844','2013-03-01','09:20:00',1.93),('15844','2013-03-01','09:25:00',2.01),('15844','2013-03-01','09:30:00',2.05),('15844','2013-03-01','09:35:00',2.14),('15844','2013-03-01','09:40:00',2.2),('15844','2013-03-01','09:45:00',2.29),('15844','2013-03-01','09:50:00',2.34),('15844','2013-03-01','09:55:00',2.23),('15844','2013-03-01','10:00:00',2.05),('15844','2013-03-01','10:05:00',1.69),('15844','2013-03-01','10:10:00',1.7),('15844','2013-03-01','10:15:00',1.72),('15844','2013-03-01','10:20:00',1.69),('15844','2013-03-01','10:25:00',1.86),('15844','2013-03-01','10:30:00',2.3),('15844','2013-03-01','10:35:00',2.25),('15844','2013-03-01','10:40:00',1.99),('15844','2013-03-01','10:45:00',1.86),('15844','2013-03-01','10:50:00',1.81),('15844','2013-03-01','10:55:00',1.63),('15844','2013-03-01','11:00:00',1.47),('15844','2013-03-01','11:05:00',1.4),('15844','2013-03-01','11:10:00',1.43),('15844','2013-03-01','11:15:00',1.53),('15844','2013-03-01','11:20:00',1.55),('15844','2013-03-01','11:25:00',1.52),('15844','2013-03-01','11:30:00',1.51),('15844','2013-03-01','11:35:00',1.49),('15844','2013-03-01','11:40:00',1.4),('15844','2013-03-01','11:45:00',1.37),('15844','2013-03-01','11:50:00',1.3),('15844','2013-03-01','11:55:00',1.22),('15844','2013-03-01','12:00:00',1.13),('15844','2013-03-01','12:05:00',1.06),('15844','2013-03-01','12:50:00',1.04),('15844','2013-03-01','12:55:00',1.1),('15844','2013-03-01','13:00:00',1.11),('15844','2013-03-01','13:05:00',1.12),('15844','2013-03-01','13:10:00',1.17),('15844','2013-03-01','13:15:00',1.26),('15844','2013-03-01','13:20:00',1.4),('15844','2013-03-01','13:25:00',1.4),('15844','2013-03-01','13:30:00',1.32),('15844','2013-03-01','13:35:00',1.23),('15844','2013-03-01','13:40:00',1.18),('15844','2013-03-01','13:45:00',1.18),('15844','2013-03-01','13:50:00',1.18),('15844','2013-03-01','13:55:00',1.15),('15844','2013-03-01','14:00:00',1.09),('15844','2013-03-01','14:05:00',1.03),('15844','2013-02-28','08:20:00',1.01),('15844','2013-02-28','08:25:00',1.09),('15844','2013-02-28','08:30:00',1.18),('15844','2013-02-28','08:35:00',1.28),('15844','2013-02-28','08:40:00',1.37),('15844','2013-02-28','08:45:00',1.45),('15844','2013-02-28','08:50:00',1.55),('15844','2013-02-28','08:55:00',1.67),('15844','2013-02-28','09:00:00',1.77),('15844','2013-02-28','09:05:00',1.87),('15844','2013-02-28','09:10:00',1.91),('15844','2013-02-28','09:15:00',2.04),('15844','2013-02-28','09:20:00',2.11),('15844','2013-02-28','09:25:00',2.18),('15844','2013-02-28','09:30:00',2.27),('15844','2013-02-28','09:35:00',2.34),('15844','2013-02-28','09:40:00',2.41),('15844','2013-02-28','09:45:00',2.47),('15844','2013-02-28','09:50:00',2.34),('15844','2013-02-28','09:55:00',2.54),('15844','2013-02-28','10:00:00',2.6),('15844','2013-02-28','10:05:00',2.64),('15844','2013-02-28','10:10:00',2.66),('15844','2013-02-28','10:15:00',2.73),('15844','2013-02-28','10:20:00',2.77),('15844','2013-02-28','10:25:00',2.77),('15844','2013-02-28','10:30:00',2.84),('15844','2013-02-28','10:35:00',2.91),('15844','2013-02-28','10:40:00',2.92),('15844','2013-02-28','10:45:00',2.92),('15844','2013-02-28','10:50:00',2.91),('15844','2013-02-28','10:55:00',2.93),('15844','2013-02-28','11:00:00',2.98),('15844','2013-02-28','11:05:00',3.02),('15844','2013-02-28','11:10:00',3.02),('15844','2013-02-28','11:15:00',3.01),('15844','2013-02-28','11:20:00',2.97),('15844','2013-02-28','11:25:00',2.95),('15844','2013-02-28','11:30:00',2.91),('15844','2013-02-28','11:35:00',2.85),('15844','2013-02-28','11:40:00',2.94),('15844','2013-02-28','11:45:00',2.83),('15844','2013-02-28','11:50:00',2.76),('15844','2013-02-28','11:55:00',2.82),('15844','2013-02-28','12:00:00',2.84),('15844','2013-02-28','12:05:00',2.89),('15844','2013-02-28','12:10:00',2.95),('15844','2013-02-28','12:15:00',2.94),('15844','2013-02-28','12:20:00',2.9),('15844','2013-02-28','12:25:00',2.87),('15844','2013-02-28','12:30:00',2.9),('15844','2013-02-28','12:35:00',2.83),('15844','2013-02-28','12:40:00',2.75),('15844','2013-02-28','12:45:00',2.72),('15844','2013-02-28','12:50:00',2.74),('15844','2013-02-28','12:55:00',2.63),('15844','2013-02-28','13:00:00',2.47),('15844','2013-02-28','13:05:00',2.5),('15844','2013-02-28','13:10:00',2.3),('15844','2013-02-28','13:15:00',2.26),('15844','2013-02-28','13:20:00',2.27),('15844','2013-02-28','13:25:00',2.14),('15844','2013-02-28','13:30:00',2.2),('15844','2013-02-28','13:35:00',2.13),('15844','2013-02-28','13:40:00',1.29),('15844','2013-02-28','13:50:00',1.87),('15844','2013-02-28','13:55:00',1.8),('15844','2013-02-28','14:00:00',1.72),('15844','2013-02-28','14:05:00',1.63),('15844','2013-02-28','14:10:00',1.56),('15844','2013-02-28','14:15:00',1.46),('15844','2013-02-28','14:20:00',1.35),('15844','2013-02-28','14:25:00',1.27),('15844','2013-02-28','14:45:00',1.03),('15844','2013-02-27','08:25:00',1.09),('15844','2013-02-27','08:30:00',1.17),('15844','2013-02-27','08:35:00',1.26),('15844','2013-02-27','08:40:00',1.33),('15844','2013-02-27','08:45:00',1.45),('15844','2013-02-27','08:50:00',1.58),('15844','2013-02-27','08:55:00',1.65),('15844','2013-02-27','09:00:00',1.71),('15844','2013-02-27','09:05:00',1.82),('15844','2013-02-27','09:10:00',1.94),('15844','2013-02-27','09:15:00',2.04),('15844','2013-02-27','09:20:00',2.12),('15844','2013-02-27','09:25:00',2.18),('15844','2013-02-27','09:30:00',2.24),('15844','2013-02-27','09:35:00',2.31),('15844','2013-02-27','09:40:00',2.38),('15844','2013-02-27','09:45:00',2.44),('15844','2013-02-27','09:50:00',2.49),('15844','2013-02-27','09:55:00',2.53),('15844','2013-02-27','10:00:00',2.58),('15844','2013-02-27','10:05:00',2.63),('15844','2013-02-27','10:10:00',2.66),('15844','2013-02-27','10:15:00',2.71),('15844','2013-02-27','10:20:00',2.8),('15844','2013-02-27','10:25:00',2.84),('15844','2013-02-27','10:30:00',2.9),('15844','2013-02-27','10:35:00',2.91),('15844','2013-02-27','10:40:00',2.99),('15844','2013-02-27','10:45:00',3),('15844','2013-02-27','10:50:00',2.96),('15844','2013-02-27','10:55:00',3.03),('15844','2013-02-27','11:00:00',3.01),('15844','2013-02-27','11:05:00',2.99),('15844','2013-02-27','11:10:00',2.96),('15844','2013-02-27','11:15:00',2.96),('15844','2013-02-27','11:20:00',3.04),('15844','2013-02-27','11:25:00',3.11),('15844','2013-02-27','11:30:00',3.09),('15844','2013-02-27','11:35:00',3.04),('15844','2013-02-27','11:40:00',2.91),('15844','2013-02-27','11:45:00',2.52),('15844','2013-02-27','11:50:00',3.16),('15844','2013-02-27','11:55:00',3.14),('15844','2013-02-27','12:00:00',3.1),('15844','2013-02-27','12:05:00',3.19),('15844','2013-02-27','12:10:00',3.18),('15844','2013-02-27','12:15:00',3.05),('15844','2013-02-27','12:20:00',3.02),('15844','2013-02-27','12:25:00',2.95),('15844','2013-02-27','12:30:00',2.89),('15844','2013-02-27','12:35:00',2.82),('15844','2013-02-27','12:40:00',2.75),('15844','2013-02-27','12:45:00',2.94),('15844','2013-02-27','12:50:00',2.81),('15844','2013-02-27','12:55:00',2.77),('15844','2013-02-27','13:00:00',2.68),('15844','2013-02-27','13:05:00',2.6),('15844','2013-02-27','13:10:00',2.52),('15844','2013-02-27','13:15:00',2.49),('15844','2013-02-27','13:20:00',2.47),('15844','2013-02-27','13:25:00',2.33),('15844','2013-02-27','13:30:00',2.21),('15844','2013-02-27','13:35:00',2.16),('15844','2013-02-27','13:40:00',2.11),('15844','2013-02-27','13:45:00',2.06),('15844','2013-02-27','13:50:00',1.94),('15844','2013-02-27','14:05:00',1.18),('15844','2013-02-27','14:10:00',1.45),('15844','2013-02-27','14:15:00',1.4),('15844','2013-02-27','14:20:00',1.37),('15844','2013-02-27','14:25:00',1.34),('15844','2013-02-27','14:30:00',1.29),('15844','2013-02-27','14:35:00',1.24),('15844','2013-02-27','14:40:00',1.14),('15844','2013-02-27','14:45:00',1.25),('15844','2013-02-27','14:50:00',1.28),('15844','2013-02-27','14:55:00',1.15),('15844','2013-02-27','15:00:00',1.13),('15844','2013-02-27','15:05:00',1.03),('15844','2013-02-26','09:25:00',1.02),('15844','2013-02-26','09:30:00',1.17),('15844','2013-02-26','09:35:00',1.36),('15844','2013-02-26','09:40:00',1.46),('15844','2013-02-26','09:45:00',1.71),('15844','2013-02-26','09:50:00',2.11),('15844','2013-02-26','09:55:00',2.38),('15844','2013-02-26','10:00:00',2.56),('15844','2013-02-26','10:05:00',2.46),('15844','2013-02-26','10:10:00',2.24),('15844','2013-02-26','10:15:00',2.48),('15844','2013-02-26','10:20:00',2.54),('15844','2013-02-26','10:25:00',1.59),('15844','2013-02-26','10:30:00',1.77),('15844','2013-02-26','10:35:00',2.8),('15844','2013-02-26','10:40:00',2.16),('15844','2013-02-26','10:45:00',2.02),('15844','2013-02-26','10:50:00',1.69),('15844','2013-02-26','10:55:00',1.97),('15844','2013-02-26','11:00:00',1.85),('15844','2013-02-26','11:05:00',2.07),('15844','2013-02-26','11:10:00',1.49),('15844','2013-02-26','11:15:00',1.74),('15844','2013-02-26','11:20:00',1.81),('15844','2013-02-26','11:25:00',1.66),('15844','2013-02-26','11:30:00',1.7),('15844','2013-02-26','11:35:00',1.79),('15844','2013-02-26','11:40:00',1.6),('15844','2013-02-26','11:45:00',2.63),('15844','2013-02-26','11:50:00',2.65),('15844','2013-02-26','11:55:00',2.18),('15844','2013-02-26','12:00:00',1.8),('15844','2013-02-26','12:05:00',1.69),('15844','2013-02-26','12:10:00',2.11),('15844','2013-02-26','12:15:00',1.81),('15844','2013-02-26','12:20:00',1.48),('15844','2013-02-26','12:25:00',1.4),('15844','2013-02-26','12:30:00',1.27),('15844','2013-02-26','12:35:00',1),('15844','2013-02-26','13:15:00',1.02),('15844','2013-02-25','10:40:00',1.1),('15844','2013-02-25','10:45:00',1.89),('15844','2013-02-25','10:50:00',3.46),('15844','2013-02-25','10:55:00',3.4),('15844','2013-02-25','11:00:00',2.05),('15844','2013-02-25','11:05:00',3.91),('15844','2013-02-25','11:10:00',3.53),('15844','2013-02-25','11:15:00',3.45),('15844','2013-02-25','11:20:00',3.7),('15844','2013-02-25','11:25:00',3.28),('15844','2013-02-25','11:30:00',1.44),('15844','2013-02-25','11:35:00',1.15),('15844','2013-02-25','11:40:00',1.06),('15844','2013-02-25','11:45:00',1.1),('15844','2013-02-25','11:50:00',1.04),('15844','2013-02-25','11:55:00',1.12),('15844','2013-02-25','12:00:00',1.24),('15844','2013-02-25','12:05:00',1.54),('15844','2013-02-25','12:10:00',1.75),('15844','2013-02-25','12:15:00',1.86),('15844','2013-02-25','12:20:00',3.2),('15844','2013-02-25','12:25:00',1.4),('15844','2013-02-25','12:30:00',1.47),('15844','2013-02-25','12:35:00',2.08),('15844','2013-02-25','12:40:00',1.5),('15844','2013-02-25','12:45:00',2.07),('15844','2013-02-25','12:50:00',3.36),('15844','2013-02-25','12:55:00',2.03),('15844','2013-02-25','13:00:00',2.54),('15844','2013-02-25','13:05:00',1.86),('15844','2013-02-25','13:15:00',1.41),('15844','2013-02-25','13:20:00',1.33),('15844','2013-02-25','13:25:00',1.17),('15844','2013-02-25','13:55:00',1.03),('15844','2013-02-24','10:45:00',1.45),('15844','2013-02-24','10:50:00',2.65),('15844','2013-02-24','10:55:00',1.81),('15844','2013-02-24','11:00:00',1.47),('15844','2013-02-24','11:05:00',1.26),('15844','2013-02-24','12:35:00',1.22),('15844','2013-02-24','12:45:00',1.01),('15844','2013-02-24','12:50:00',1.63),('15844','2013-02-24','12:55:00',1.45),('15844','2013-02-24','13:00:00',1.39),('15844','2013-02-24','13:05:00',1.24),('15844','2013-02-24','13:10:00',1.15),('15844','2013-02-24','13:25:00',1.1),('15844','2013-02-24','14:00:00',1.52),('15844','2013-02-24','14:05:00',1.35),('15844','2013-02-24','14:10:00',1.03),('15844','2013-02-24','14:55:00',1.06),('15844','2013-02-24','15:00:00',1.2),('15844','2013-02-24','15:05:00',1.19),('15844','2013-02-23','08:05:00',1.07),('15844','2013-02-23','08:10:00',1.34),('15844','2013-02-23','08:15:00',1.25),('15844','2013-02-23','09:00:00',1.22),('15844','2013-02-23','09:05:00',1.16),('15844','2013-02-23','09:50:00',1.01),('15844','2013-02-23','10:40:00',1.01),('15844','2013-02-23','10:45:00',1.03),('15844','2013-02-23','10:50:00',1.1),('15844','2013-02-23','11:35:00',1.04),('15844','2013-02-23','14:00:00',1.12),('15844','2013-02-23','14:05:00',1.22),('15844','2013-02-22','14:00:00',1.02),('15844','2013-02-22','14:25:00',1.03),('15844','2013-02-21','12:05:00',1.02),('15844','2013-02-21','12:35:00',1),('15844','2013-02-21','12:40:00',1.05),('15844','2013-02-21','13:15:00',1.02),('15844','2013-02-21','13:20:00',1.09),('15844','2013-02-21','13:25:00',1.04),('15844','2014-03-23','08:30:00',1.1),('15844','2014-03-23','08:50:00',1.41),('15844','2014-03-23','08:55:00',1.31),('15844','2014-03-23','09:00:00',1.59),('15844','2014-03-23','09:05:00',2.35),('15844','2014-03-23','09:10:00',2.48),('15844','2014-03-23','09:15:00',1.89),('15844','2014-03-23','09:20:00',1.05),('15844','2014-03-23','09:30:00',1.25),('15844','2014-03-23','10:25:00',1.45),('15844','2014-03-23','10:40:00',1.39),('15844','2014-03-23','10:50:00',1.61),('15844','2014-03-23','10:55:00',1.35),('15844','2014-03-23','11:05:00',1.12),('15844','2014-03-23','11:20:00',1.07),('15844','2014-03-23','11:35:00',1.51),('15844','2014-03-23','11:40:00',1.67),('15844','2014-03-23','13:35:00',1.03),('15844','2014-03-23','13:40:00',2.03),('15844','2014-03-23','13:45:00',1.31),('15844','2014-03-23','13:50:00',1.06),('15844','2014-03-23','14:55:00',1.17),('15844','2014-03-23','15:00:00',1.02),('15844','2014-03-23','15:05:00',1.17),('15844','2014-03-23','15:10:00',1.31),('15844','2014-03-23','15:15:00',1.01),('15844','2013-02-20','08:25:00',1.05),('15844','2013-02-20','08:30:00',1.13),('15844','2013-02-20','08:35:00',1.24),('15844','2013-02-20','08:40:00',1.34),('15844','2013-02-20','08:45:00',1.42),('15844','2013-02-20','08:50:00',1.51),('15844','2013-02-20','08:55:00',1.59),('15844','2013-02-20','09:00:00',1.62),('15844','2013-02-20','09:05:00',1.29),('15844','2013-02-20','09:10:00',1.67),('15844','2013-02-20','09:20:00',1.87),('15844','2013-02-20','09:25:00',1.2),('15844','2013-02-20','09:30:00',1.94),('15844','2013-02-20','09:35:00',1.24),('15844','2013-02-20','09:40:00',1.76),('15844','2013-02-20','09:45:00',1.92),('15844','2013-02-20','10:10:00',1.02),('15844','2013-02-20','10:15:00',1.33),('15844','2013-02-20','10:20:00',1.29),('15844','2013-02-20','10:35:00',2.28),('15844','2013-02-20','10:40:00',2.46),('15844','2013-02-20','10:45:00',3.27),('15844','2013-02-20','10:50:00',3.26),('15844','2013-02-20','10:55:00',3.33),('15844','2013-02-20','11:00:00',3.62),('15844','2013-02-20','11:05:00',1.72),('15844','2013-02-20','11:15:00',1.38),('15844','2013-02-20','11:20:00',1.23),('15844','2013-02-20','11:25:00',1.01),('15844','2013-02-20','11:30:00',1.35),('15844','2013-02-20','11:35:00',1.27),('15844','2013-02-20','11:40:00',1.62),('15844','2013-02-20','11:45:00',1.17),('15844','2013-02-20','11:50:00',2.31),('15844','2013-02-20','11:55:00',3.9),('15844','2013-02-20','12:00:00',1.87),('15844','2013-02-20','12:05:00',1.57),('15844','2013-02-20','12:10:00',1.19),('15844','2013-02-20','12:25:00',1.49),('15844','2013-02-20','12:30:00',1.26),('15844','2013-02-20','12:35:00',2.49),('15844','2013-02-20','12:40:00',1.52),('15844','2013-02-20','12:45:00',2.68),('15844','2013-02-20','12:50:00',3.37),('15844','2013-02-20','12:55:00',2.83),('15844','2013-02-20','13:00:00',2.08),('15844','2013-02-20','13:05:00',1.59),('15844','2013-02-20','13:10:00',1.82),('15844','2013-02-20','13:15:00',2.36),('15844','2013-02-20','13:20:00',3),('15844','2013-02-20','13:25:00',2.79),('15844','2013-02-20','13:30:00',2.69),('15844','2013-02-20','13:35:00',1.69),('15844','2013-02-20','13:40:00',1.15),('15844','2013-02-20','13:45:00',1.04),('15844','2013-02-20','14:15:00',1.49),('15844','2013-02-20','14:20:00',1.27),('15844','2013-02-20','14:55:00',1.03),('15844','2013-02-20','15:05:00',1.02),('15844','2013-02-20','15:20:00',1),('15844','2013-02-19','08:25:00',1.08),('15844','2013-02-19','08:30:00',1.17),('15844','2013-02-19','08:35:00',1.25),('15844','2013-02-19','08:40:00',1.31),('15844','2013-02-19','08:45:00',1.39),('15844','2013-02-19','08:50:00',1.46),('15844','2013-02-19','08:55:00',1.52),('15844','2013-02-19','09:00:00',1.58),('15844','2013-02-19','09:05:00',1.71),('15844','2013-02-19','09:10:00',1.81),('15844','2013-02-19','09:15:00',1.9),('15844','2013-02-19','09:20:00',2),('15844','2013-02-19','09:25:00',2.09),('15844','2013-02-19','09:30:00',2.16),('15844','2013-02-19','09:35:00',2.22),('15844','2013-02-19','09:40:00',2.27),('15844','2013-02-19','09:45:00',2.33),('15844','2013-02-19','09:50:00',2.41),('15844','2013-02-19','09:55:00',2.48),('15844','2013-02-19','10:00:00',2.51),('15844','2013-02-19','10:05:00',2.53),('15844','2013-02-19','10:10:00',2.58),('15844','2013-02-19','10:15:00',2.62),('15844','2013-02-19','10:20:00',2.65),('15844','2013-02-19','10:25:00',2.72),('15844','2013-02-19','10:30:00',2.72),('15844','2013-02-19','10:35:00',2.74),('15844','2013-02-19','10:40:00',2.8),('15844','2013-02-19','10:45:00',2.84),('15844','2013-02-19','10:50:00',2.87),('15844','2013-02-19','10:55:00',2.94),('15844','2013-02-19','11:00:00',2.94),('15844','2013-02-19','11:05:00',2.94),('15844','2013-02-19','11:10:00',2.94),('15844','2013-02-19','11:15:00',2.93),('15844','2013-02-19','11:20:00',2.94),('15844','2013-02-19','11:25:00',2.95),('15844','2013-02-19','11:30:00',2.93),('15844','2013-02-19','11:35:00',2.9),('15844','2013-02-19','11:40:00',2.89),('15844','2013-02-19','11:45:00',2.91),('15844','2013-02-19','11:50:00',2.92),('15844','2013-02-19','11:55:00',2.91),('15844','2013-02-19','12:00:00',2.92),('15844','2013-02-19','12:05:00',2.87),('15844','2013-02-19','12:10:00',2.84),('15844','2013-02-19','12:15:00',2.82),('15844','2013-02-19','12:20:00',2.79),('15844','2013-02-19','12:25:00',2.79),('15844','2013-02-19','12:30:00',2.73),('15844','2013-02-19','12:35:00',2.65),('15844','2013-02-19','12:40:00',2.65),('15844','2013-02-19','12:45:00',2.6),('15844','2013-02-19','12:50:00',2.53),('15844','2013-02-19','12:55:00',2.51),('15844','2013-02-19','13:00:00',2.41),('15844','2013-02-19','13:05:00',2.35),('15844','2013-02-19','13:10:00',2.32),('15844','2013-02-19','13:15:00',2.22),('15844','2013-02-19','13:20:00',2.1),('15844','2013-02-19','13:25:00',2),('15844','2013-02-19','13:30:00',1.93),('15844','2013-02-19','13:35:00',1.78),('15844','2013-02-19','13:40:00',1.62),('15844','2013-02-19','13:45:00',1.58),('15844','2013-02-19','13:50:00',1.52),('15844','2013-02-19','13:55:00',1.55),('15844','2013-02-19','14:00:00',1.44),('15844','2013-02-19','14:05:00',1.38),('15844','2013-02-19','14:10:00',1.31),('15844','2013-02-19','14:15:00',1.24),('15844','2013-02-19','14:20:00',1.16),('15844','2013-02-19','14:25:00',1.06),('15844','2013-02-18','08:30:00',1.07),('15844','2013-02-18','08:35:00',1.15),('15844','2013-02-18','08:40:00',1.22),('15844','2013-02-18','08:45:00',1.3),('15844','2013-02-18','08:50:00',1.37),('15844','2013-02-18','08:55:00',1.44),('15844','2013-02-18','09:00:00',1.55),('15844','2013-02-18','09:05:00',1.66),('15844','2013-02-18','09:10:00',1.48),('15844','2013-02-18','09:15:00',1.55),('15844','2013-02-18','09:20:00',1.62),('15844','2013-02-18','09:25:00',1.32),('15844','2013-02-18','09:35:00',1.3),('15844','2013-02-18','10:00:00',1.42),('15844','2013-02-18','10:05:00',2.2),('15844','2013-02-18','11:05:00',1.2),('15844','2013-02-18','11:10:00',1.48),('15844','2013-02-18','11:15:00',1.5),('15844','2013-02-18','11:20:00',1.66),('15844','2013-02-18','11:25:00',1.39),('15844','2013-02-18','11:30:00',1.47),('15844','2013-02-18','11:35:00',1.53),('15844','2013-02-18','11:40:00',1.55),('15844','2013-02-18','11:45:00',1.62),('15844','2013-02-18','11:50:00',1.83),('15844','2013-02-18','11:55:00',1.73),('15844','2013-02-18','12:00:00',1.46),('15844','2013-02-18','12:05:00',1.23),('15844','2013-02-18','12:10:00',1.15),('15844','2013-02-18','12:15:00',1.16),('15844','2013-02-18','12:20:00',1.1),('15844','2013-02-18','12:25:00',1.2),('15844','2013-02-18','12:30:00',1.09),('15844','2013-02-18','12:35:00',1.01),('15844','2013-02-18','12:40:00',1.18),('15844','2013-02-18','12:45:00',1.31),('15844','2013-02-18','12:50:00',1.22),('15844','2013-02-18','12:55:00',1.29),('15844','2013-02-18','13:00:00',1.29),('15844','2013-02-18','13:05:00',1.51),('15844','2013-02-18','13:10:00',1.63),('15844','2013-02-18','13:15:00',1.64),('15844','2013-02-18','13:20:00',1.58),('15844','2013-02-18','13:25:00',1.27),('15844','2013-02-18','13:30:00',1.09),('15844','2013-02-18','13:35:00',1.03),('15844','2013-02-18','13:40:00',1.15),('15844','2013-02-18','13:45:00',1.17),('15844','2013-02-18','13:50:00',1.23),('15844','2013-02-18','13:55:00',1.45),('15844','2013-02-18','14:00:00',1.44),('15844','2013-02-18','14:05:00',1.33),('15844','2013-02-18','14:10:00',1.04),('15844','2013-02-18','14:15:00',1.32),('15844','2013-02-18','14:20:00',1.08),('15844','2013-02-18','14:55:00',1),('15844','2013-02-17','08:30:00',1.09),('15844','2013-02-17','08:35:00',1.19),('15844','2013-02-17','08:40:00',1.24),('15844','2013-02-17','08:45:00',1.16),('15844','2013-02-17','08:50:00',1.28),('15844','2013-02-17','08:55:00',1.43),('15844','2013-02-17','09:00:00',1.32),('15844','2013-02-17','09:05:00',1.55),('15844','2013-02-17','09:10:00',1.7),('15844','2013-02-17','09:15:00',1.81),('15844','2013-02-17','09:20:00',1.89),('15844','2013-02-17','09:25:00',1.96),('15844','2013-02-17','09:30:00',1.98),('15844','2013-02-17','09:35:00',2.04),('15844','2013-02-17','09:40:00',2.09),('15844','2013-02-17','09:45:00',2.17),('15844','2013-02-17','09:50:00',2.23),('15844','2013-02-17','09:55:00',2.28),('15844','2013-02-17','10:00:00',2.34),('15844','2013-02-17','10:05:00',2.38),('15844','2013-02-17','10:10:00',2.44),('15844','2013-02-17','10:15:00',2.44),('15844','2013-02-17','10:20:00',2.52),('15844','2013-02-17','10:25:00',2.55),('15844','2013-02-17','10:30:00',2.6),('15844','2013-02-17','10:35:00',2.64),('15844','2013-02-17','10:40:00',2.71),('15844','2013-02-17','10:45:00',2.74),('15844','2013-02-17','10:50:00',2.75),('15844','2013-02-17','10:55:00',2.79),('15844','2013-02-17','11:00:00',2.82),('15844','2013-02-17','11:05:00',2.82),('15844','2013-02-17','11:10:00',2.83),('15844','2013-02-17','11:15:00',2.82),('15844','2013-02-17','11:20:00',2.83),('15844','2013-02-17','11:25:00',2.84),('15844','2013-02-17','11:30:00',2.84),('15844','2013-02-17','11:35:00',2.82),('15844','2013-02-17','11:40:00',2.75),('15844','2013-02-17','11:45:00',2.79),('15844','2013-02-17','11:50:00',2.76),('15844','2013-02-17','11:55:00',2.76),('15844','2013-02-17','12:00:00',2.75),('15844','2013-02-17','12:05:00',2.76),('15844','2013-02-17','12:10:00',2.72),('15844','2013-02-17','12:15:00',2.7),('15844','2013-02-17','12:20:00',2.7),('15844','2013-02-17','12:25:00',2.67),('15844','2013-02-17','12:30:00',2.62),('15844','2013-02-17','12:35:00',2.57),('15844','2013-02-17','12:40:00',2.54),('15844','2013-02-17','12:45:00',2.48),('15844','2013-02-17','12:50:00',2.42),('15844','2013-02-17','12:55:00',2.34),('15844','2013-02-17','13:00:00',2.27),('15844','2013-02-17','13:05:00',2.19),('15844','2013-02-17','13:10:00',2.13),('15844','2013-02-17','13:15:00',2.04),('15844','2013-02-17','13:20:00',1.27),('15844','2013-02-17','13:25:00',1.46),('15844','2013-02-17','13:30:00',1.87),('15844','2013-02-17','13:35:00',1.87),('15844','2013-02-17','13:40:00',1.76),('15844','2013-02-17','13:45:00',1.66),('15844','2013-02-17','13:50:00',1.54),('15844','2013-02-17','13:55:00',1.46),('15844','2013-02-17','14:00:00',1.53),('15844','2013-02-17','14:05:00',1.72),('15844','2013-02-17','14:10:00',1.75),('15844','2013-02-17','14:25:00',1.22),('15844','2013-02-17','14:30:00',1.11),('15844','2013-02-17','14:35:00',1.01),('15844','2013-02-17','14:45:00',1.04),('15844','2013-02-17','14:50:00',1.01),('15844','2013-02-16','08:30:00',1.01),('15844','2013-02-16','08:35:00',1.09),('15844','2013-02-16','08:40:00',1.17),('15844','2013-02-16','08:45:00',1.24),('15844','2013-02-16','08:50:00',1.34),('15844','2013-02-16','08:55:00',1.42),('15844','2013-02-16','09:00:00',1.57),('15844','2013-02-16','09:05:00',1.25),('15844','2013-02-16','09:10:00',1.65),('15844','2013-02-16','09:15:00',1.74),('15844','2013-02-16','09:25:00',1.81),('15844','2013-02-16','09:30:00',1.69),('15844','2013-02-16','09:35:00',2.25),('15844','2013-02-16','09:40:00',2.26),('15844','2013-02-16','09:45:00',2.27),('15844','2013-02-16','09:50:00',2.34),('15844','2013-02-16','09:55:00',2.37),('15844','2013-02-16','10:00:00',2.37),('15844','2013-02-16','10:05:00',2.44),('15844','2013-02-16','10:10:00',2.44),('15844','2013-02-16','10:15:00',2.47),('15844','2013-02-16','10:20:00',2.57),('15844','2013-02-16','10:25:00',2.6),('15844','2013-02-16','10:30:00',2.66),('15844','2013-02-16','10:35:00',2.69),('15844','2013-02-16','10:40:00',2.73),('15844','2013-02-16','10:45:00',2.79),('15844','2013-02-16','10:50:00',2.81),('15844','2013-02-16','10:55:00',2.84),('15844','2013-02-16','11:00:00',2.86),('15844','2013-02-16','11:05:00',2.88),('15844','2013-02-16','11:10:00',2.88),('15844','2013-02-16','11:15:00',2.91),('15844','2013-02-16','11:20:00',2.9),('15844','2013-02-16','11:25:00',2.91),('15844','2013-02-16','11:30:00',2.91),('15844','2013-02-16','11:35:00',2.88),('15844','2013-02-16','11:40:00',2.9),('15844','2013-02-16','11:45:00',2.89),('15844','2013-02-16','11:50:00',2.88),('15844','2013-02-16','11:55:00',2.84),('15844','2013-02-16','12:00:00',2.81),('15844','2013-02-16','12:05:00',2.79),('15844','2013-02-16','12:10:00',2.78),('15844','2013-02-16','12:15:00',2.78),('15844','2013-02-16','12:20:00',2.73),('15844','2013-02-16','12:25:00',2.71),('15844','2013-02-16','12:30:00',2.7),('15844','2013-02-16','12:35:00',2.63),('15844','2013-02-16','12:40:00',2.61),('15844','2013-02-16','12:45:00',2.56),('15844','2013-02-16','12:50:00',2.52),('15844','2013-02-16','12:55:00',2.46),('15844','2013-02-16','13:00:00',2.38),('15844','2013-02-16','13:05:00',2.27),('15844','2013-02-16','13:10:00',2.24),('15844','2013-02-16','13:15:00',2.16),('15844','2013-02-16','13:20:00',2.08),('15844','2013-02-16','13:25:00',1.97),('15844','2013-02-16','13:30:00',1.9),('15844','2013-02-16','13:35:00',1.76),('15844','2013-02-16','13:40:00',1.68),('15844','2013-02-16','13:45:00',1.61),('15844','2013-02-16','13:50:00',1.57),('15844','2013-02-16','13:55:00',1.49),('15844','2013-02-16','14:00:00',1.42),('15844','2013-02-16','14:05:00',1.36),('15844','2013-02-16','14:10:00',1.25),('15844','2013-02-16','14:15:00',1.2),('15844','2013-02-16','14:25:00',1.07),('15844','2013-02-15','09:25:00',1.33),('15844','2013-02-15','09:30:00',1.52),('15844','2013-02-15','09:35:00',1.27),('15844','2013-02-15','09:40:00',1.22),('15844','2013-02-15','09:55:00',1.47),('15844','2013-02-15','10:00:00',2.38),('15844','2013-02-15','10:05:00',1.62),('15844','2013-02-15','10:10:00',2),('15844','2013-02-15','10:15:00',1.56),('15844','2013-02-15','10:20:00',1.59),('15844','2013-02-15','10:25:00',2.04),('15844','2013-02-15','10:30:00',2.38),('15844','2013-02-15','10:35:00',2.6),('15844','2013-02-15','10:40:00',2.5),('15844','2013-02-15','10:45:00',1.79),('15844','2013-02-15','10:50:00',1.35),('15844','2013-02-15','10:55:00',1.67),('15844','2013-02-15','11:00:00',1.83),('15844','2013-02-15','11:05:00',1.7),('15844','2013-02-15','11:10:00',3.03),('15844','2013-02-15','11:15:00',3.06),('15844','2013-02-15','11:20:00',2.87),('15844','2013-02-15','11:25:00',2.9),('15844','2013-02-15','11:30:00',3),('15844','2013-02-15','11:35:00',2.83),('15844','2013-02-15','11:40:00',3.02),('15844','2013-02-15','11:45:00',2.32),('15844','2013-02-15','11:50:00',1.68),('15844','2013-02-15','11:55:00',2.58),('15844','2013-02-15','12:00:00',2.07),('15844','2013-02-15','12:05:00',2.96),('15844','2013-02-15','12:10:00',2.67),('15844','2013-02-15','12:15:00',3.08),('15844','2013-02-15','12:20:00',3.01),('15844','2013-02-15','12:25:00',2.84),('15844','2013-02-15','12:30:00',2.7),('15844','2013-02-15','12:35:00',2.62),('15844','2013-02-15','12:40:00',2.55),('15844','2013-02-15','12:45:00',2.61),('15844','2013-02-15','12:50:00',2.53),('15844','2013-02-15','12:55:00',2.47),('15844','2013-02-15','13:00:00',2.36),('15844','2013-02-15','13:05:00',2.28),('15844','2013-02-15','13:10:00',1.75),('15844','2013-02-15','13:20:00',1.7),('15844','2013-02-15','13:25:00',2.12),('15844','2013-02-15','13:30:00',2.38),('15844','2013-02-15','13:35:00',2.13),('15844','2013-02-15','13:40:00',1.54),('15844','2013-02-15','13:45:00',1.61),('15844','2013-02-15','13:50:00',1.46),('15844','2013-02-15','13:55:00',1.5),('15844','2013-02-15','14:00:00',1.88),('15844','2013-02-15','14:05:00',1.74),('15844','2013-02-15','14:10:00',1.3),('15844','2013-02-15','14:15:00',1.26),('15844','2013-02-15','14:20:00',1.11),('15844','2013-02-15','14:35:00',1.08),('15844','2013-02-14','08:20:00',1.04),('15844','2013-02-14','08:25:00',1.16),('15844','2013-02-14','08:30:00',1.25),('15844','2013-02-14','08:35:00',1.31),('15844','2013-02-14','08:40:00',1.38),('15844','2013-02-14','08:45:00',1.44),('15844','2013-02-14','08:50:00',1.49),('15844','2013-02-14','08:55:00',1.56),('15844','2013-02-14','09:00:00',1.64),('15844','2013-02-14','09:05:00',1.74),('15844','2013-02-14','09:10:00',1.86),('15844','2013-02-14','09:15:00',1.96),('15844','2013-02-14','09:20:00',2.04),('15844','2013-02-14','09:25:00',2.11),('15844','2013-02-14','09:30:00',2.17),('15844','2013-02-14','09:35:00',2.22),('15844','2013-02-14','09:40:00',2.28),('15844','2013-02-14','09:45:00',2.37),('15844','2013-02-14','09:50:00',2.44),('15844','2013-02-14','09:55:00',2.51),('15844','2013-02-14','10:00:00',2.56),('15844','2013-02-14','10:05:00',2.6),('15844','2013-02-14','10:10:00',2.63),('15844','2013-02-14','10:15:00',2.67),('15844','2013-02-14','10:20:00',2.69),('15844','2013-02-14','10:25:00',2.73),('15844','2013-02-14','10:30:00',2.77),('15844','2013-02-14','10:35:00',2.82),('15844','2013-02-14','10:40:00',2.86),('15844','2013-02-14','10:45:00',2.91),('15844','2013-02-14','10:50:00',2.94),('15844','2013-02-14','10:55:00',2.96),('15844','2013-02-14','11:00:00',2.97),('15844','2013-02-14','11:05:00',2.99),('15844','2013-02-14','11:10:00',2.99),('15844','2013-02-14','11:15:00',2.98),('15844','2013-02-14','11:20:00',2.99),('15844','2013-02-14','11:25:00',3),('15844','2013-02-14','11:30:00',2.97),('15844','2013-02-14','11:35:00',2.97),('15844','2013-02-14','11:40:00',2.96),('15844','2013-02-14','11:45:00',2.95),('15844','2013-02-14','11:50:00',2.95),('15844','2013-02-14','11:55:00',2.91),('15844','2013-02-14','12:00:00',2.88),('15844','2013-02-14','12:05:00',2.88),('15844','2013-02-14','12:10:00',2.86),('15844','2013-02-14','12:15:00',2.83),('15844','2013-02-14','12:20:00',2.79),('15844','2013-02-14','12:25:00',2.77),('15844','2013-02-14','12:30:00',2.74),('15844','2013-02-14','12:35:00',2.71),('15844','2013-02-14','12:40:00',2.68),('15844','2013-02-14','12:45:00',2.63),('15844','2013-02-14','12:50:00',2.58),('15844','2013-02-14','12:55:00',2.51),('15844','2013-02-14','13:00:00',2.39),('15844','2013-02-14','13:05:00',2.31),('15844','2013-02-14','13:10:00',2.26),('15844','2013-02-14','13:15:00',2.18),('15844','2013-02-14','13:20:00',2.07),('15844','2013-02-14','13:25:00',1.97),('15844','2013-02-14','13:30:00',1.91),('15844','2013-02-14','13:35:00',1.85),('15844','2013-02-14','13:40:00',1.77),('15844','2013-02-14','13:45:00',1.68),('15844','2013-02-14','13:50:00',1.58),('15844','2013-02-14','13:55:00',1.46),('15844','2013-02-14','14:00:00',1.37),('15844','2013-02-14','14:05:00',1.29),('15844','2013-02-14','14:10:00',1.22),('15844','2013-02-14','14:15:00',1.14),('15844','2013-02-14','14:20:00',1.04),('15844','2013-02-13','09:20:00',1.24),('15844','2013-02-13','09:25:00',1.14),('15844','2013-02-13','09:30:00',1.67),('15844','2013-02-13','09:35:00',1.83),('15844','2013-02-13','09:40:00',1.86),('15844','2013-02-13','09:45:00',1.65),('15844','2013-02-13','09:50:00',1.56),('15844','2013-02-13','09:55:00',1.8),('15844','2013-02-13','10:00:00',2.11),('15844','2013-02-13','10:05:00',2.35),('15844','2013-02-13','10:10:00',2.51),('15844','2013-02-13','10:15:00',2.53),('15844','2013-02-13','10:20:00',2.59),('15844','2013-02-13','10:25:00',2.66),('15844','2013-02-13','10:30:00',2.79),('15844','2013-02-13','10:35:00',2.79),('15844','2013-02-13','10:40:00',2.8),('15844','2013-02-13','10:45:00',2.92),('15844','2013-02-13','10:50:00',2.82),('15844','2013-02-13','10:55:00',2.75),('15844','2013-02-13','11:00:00',2.76),('15844','2013-02-13','11:05:00',2.54),('15844','2013-02-13','11:10:00',2.42),('15844','2013-02-13','11:15:00',2.26),('15844','2013-02-13','11:20:00',2.35),('15844','2013-02-13','11:25:00',2.62),('15844','2013-02-13','11:30:00',2.72),('15844','2013-02-13','11:35:00',2.98),('15844','2013-02-13','11:40:00',3.09),('15844','2013-02-13','11:45:00',2.78),('15844','2013-02-13','11:50:00',3.13),('15844','2013-02-13','11:55:00',2.85),('15844','2013-02-13','12:00:00',2.71),('15844','2013-02-13','12:05:00',3.2),('15844','2013-02-13','12:10:00',2.78),('15844','2013-02-13','12:15:00',2.76),('15844','2013-02-13','12:20:00',2.19),('15844','2013-02-13','12:25:00',1.34),('15844','2013-02-13','12:30:00',2.26),('15844','2013-02-13','12:35:00',2.57),('15844','2013-02-13','12:40:00',2.54),('15844','2013-02-13','12:45:00',2.61),('15844','2013-02-13','12:50:00',2.52),('15844','2013-02-13','12:55:00',2.38),('15844','2013-02-13','13:00:00',2.01),('15844','2013-02-13','13:05:00',1.76),('15844','2013-02-13','13:10:00',1.79),('15844','2013-02-13','13:15:00',1.73),('15844','2013-02-13','13:20:00',1.91),('15844','2013-02-13','13:25:00',2.06),('15844','2013-02-13','13:30:00',2.1),('15844','2013-02-13','13:35:00',2.08),('15844','2013-02-13','13:40:00',2.15),('15844','2013-02-13','13:45:00',2.14),('15844','2013-02-13','13:50:00',1.88),('15844','2013-02-13','13:55:00',1.6),('15844','2013-02-13','14:00:00',1.41),('15844','2013-02-13','14:05:00',1.1),('15844','2013-02-13','14:10:00',1.07),('15844','2013-02-13','14:15:00',1.1),('15844','2013-02-13','14:20:00',1.03),('15844','2014-03-22','08:10:00',1.18),('15844','2014-03-22','08:15:00',1.31),('15844','2014-03-22','08:20:00',1.21),('15844','2014-03-22','08:25:00',1.4),('15844','2014-03-22','08:30:00',1.67),('15844','2014-03-22','08:35:00',1.72),('15844','2014-03-22','08:40:00',1.88),('15844','2014-03-22','08:45:00',2.11),('15844','2014-03-22','08:50:00',1.73),('15844','2014-03-22','08:55:00',1.84),('15844','2014-03-22','09:00:00',1.78),('15844','2014-03-22','09:05:00',1.93),('15844','2014-03-22','09:10:00',1.23),('15844','2014-03-22','09:15:00',1.13),('15844','2014-03-22','09:20:00',1.41),('15844','2014-03-22','09:25:00',2.16),('15844','2014-03-22','09:30:00',1.35),('15844','2014-03-22','09:35:00',2.3),('15844','2014-03-22','09:40:00',2.45),('15844','2014-03-22','09:45:00',2.98),('15844','2014-03-22','09:50:00',3.17),('15844','2014-03-22','09:55:00',3.14),('15844','2014-03-22','10:00:00',2.54),('15844','2014-03-22','10:05:00',3.32),('15844','2014-03-22','10:10:00',1.5),('15844','2014-03-22','10:15:00',1.1),('15844','2014-03-22','10:20:00',1.29),('15844','2014-03-22','10:25:00',1.64),('15844','2014-03-22','10:30:00',1.64),('15844','2014-03-22','10:35:00',1.51),('15844','2014-03-22','10:40:00',1.68),('15844','2014-03-22','10:45:00',1.97),('15844','2014-03-22','10:50:00',1.29),('15844','2014-03-22','10:55:00',1.16),('15844','2014-03-22','11:00:00',1.05),('15844','2014-03-22','11:05:00',2.13),('15844','2014-03-22','11:10:00',3.57),('15844','2014-03-22','11:15:00',1.72),('15844','2014-03-22','11:20:00',2.85),('15844','2014-03-22','11:25:00',2.54),('15844','2014-03-22','11:30:00',2.28),('15844','2014-03-22','11:35:00',2.36),('15844','2014-03-22','11:40:00',3.11),('15844','2014-03-22','11:45:00',2.43),('15844','2014-03-22','11:50:00',1.67),('15844','2014-03-22','11:55:00',1.29),('15844','2014-03-22','12:00:00',2.36),('15844','2014-03-22','12:05:00',2.02),('15844','2014-03-22','12:10:00',1.13),('15844','2014-03-22','12:15:00',1.89),('15844','2014-03-22','12:20:00',3.99),('15844','2014-03-22','12:25:00',3.67),('15844','2014-03-22','12:30:00',3.54),('15844','2014-03-22','12:35:00',3.05),('15844','2014-03-22','12:40:00',2.66),('15844','2014-03-22','12:45:00',3.62),('15844','2014-03-22','12:50:00',3.33),('15844','2014-03-22','12:55:00',2.82),('15844','2014-03-22','13:00:00',3.11),('15844','2014-03-22','13:05:00',2.13),('15844','2014-03-22','13:10:00',3.3),('15844','2014-03-22','13:15:00',2.89),('15844','2014-03-22','13:20:00',3.03),('15844','2014-03-22','13:25:00',2.86),('15844','2014-03-22','13:30:00',2.71),('15844','2014-03-22','13:35:00',2.75),('15844','2014-03-22','13:40:00',2.77),('15844','2014-03-22','13:45:00',2.53),('15844','2014-03-22','13:50:00',2.21),('15844','2014-03-22','13:55:00',2.04),('15844','2014-03-22','14:00:00',2.2),('15844','2014-03-22','14:05:00',2.14),('15844','2014-03-22','14:10:00',1.87),('15844','2014-03-22','14:15:00',1.77),('15844','2014-03-22','14:20:00',1.64),('15844','2014-03-22','14:25:00',1.41),('15844','2014-03-22','14:30:00',1.4),('15844','2014-03-22','14:35:00',1.15),('15844','2014-03-22','14:40:00',1.17),('15844','2014-03-22','14:50:00',1.17),('15844','2014-03-22','14:55:00',1.16),('15844','2014-03-22','15:00:00',1.06),('15844','2014-03-22','15:05:00',1),('15844','2014-03-21','07:55:00',1.01),('15844','2014-03-21','08:00:00',1.08),('15844','2014-03-21','08:05:00',1.17),('15844','2014-03-21','08:10:00',1.26),('15844','2014-03-21','08:15:00',1.36),('15844','2014-03-21','08:20:00',1.46),('15844','2014-03-21','08:25:00',1.59),('15844','2014-03-21','08:30:00',1.7),('15844','2014-03-21','08:35:00',1.74),('15844','2014-03-21','08:40:00',1.85),('15844','2014-03-21','08:45:00',1.99),('15844','2014-03-21','08:50:00',2.09),('15844','2014-03-21','08:55:00',2.15),('15844','2014-03-21','09:00:00',2.27),('15844','2014-03-21','09:05:00',2.31),('15844','2014-03-21','09:10:00',2.45),('15844','2014-03-21','09:15:00',2.47),('15844','2014-03-21','09:20:00',2.53),('15844','2014-03-21','09:25:00',2.51),('15844','2014-03-21','09:30:00',2.54),('15844','2014-03-21','09:35:00',2.72),('15844','2014-03-21','09:40:00',2.78),('15844','2014-03-21','09:45:00',2.78),('15844','2014-03-21','09:50:00',2.7),('15844','2014-03-21','09:55:00',2.63),('15844','2014-03-21','10:00:00',2.94),('15844','2014-03-21','10:05:00',3.05),('15844','2014-03-21','10:10:00',3.18),('15844','2014-03-21','10:15:00',3.17),('15844','2014-03-21','10:20:00',3.04),('15844','2014-03-21','10:25:00',3.03),('15844','2014-03-21','10:30:00',3.05),('15844','2014-03-21','10:35:00',3.07),('15844','2014-03-21','10:40:00',3.14),('15844','2014-03-21','10:45:00',3.11),('15844','2014-03-21','10:50:00',3.16),('15844','2014-03-21','10:55:00',3.26),('15844','2014-03-21','11:00:00',3.24),('15844','2014-03-21','11:05:00',3.17),('15844','2014-03-21','11:10:00',3.18),('15844','2014-03-21','11:15:00',3.17),('15844','2014-03-21','11:20:00',3.23),('15844','2014-03-21','11:25:00',3.24),('15844','2014-03-21','11:30:00',3.25),('15844','2014-03-21','11:35:00',3.12),('15844','2014-03-21','11:40:00',3.19),('15844','2014-03-21','11:45:00',3.21),('15844','2014-03-21','11:50:00',3.08),('15844','2014-03-21','11:55:00',3.23),('15844','2014-03-21','12:00:00',3.29),('15844','2014-03-21','12:05:00',3.27),('15844','2014-03-21','12:10:00',3.16),('15844','2014-03-21','12:15:00',3.16),('15844','2014-03-21','12:20:00',3.21),('15844','2014-03-21','12:25:00',3.2),('15844','2014-03-21','12:30:00',3.17),('15844','2014-03-21','12:35:00',3.17),('15844','2014-03-21','12:40:00',3.1),('15844','2014-03-21','12:45:00',3.04),('15844','2014-03-21','12:50:00',3.02),('15844','2014-03-21','12:55:00',3),('15844','2014-03-21','13:00:00',2.95),('15844','2014-03-21','13:05:00',2.89),('15844','2014-03-21','13:10:00',2.84),('15844','2014-03-21','13:15:00',2.79),('15844','2014-03-21','13:20:00',2.75),('15844','2014-03-21','13:25:00',2.66),('15844','2014-03-21','13:30:00',2.58),('15844','2014-03-21','13:35:00',2.47),('15844','2014-03-21','13:40:00',2.38),('15844','2014-03-21','13:45:00',2.27),('15844','2014-03-21','13:50:00',2.18),('15844','2014-03-21','13:55:00',2.07),('15844','2014-03-21','14:00:00',2.01),('15844','2014-03-21','14:05:00',1.91),('15844','2014-03-21','14:10:00',1.79),('15844','2014-03-21','14:15:00',1.68),('15844','2014-03-21','14:20:00',1.56),('15844','2014-03-21','14:25:00',1.49),('15844','2014-03-21','14:30:00',1.41),('15844','2014-03-21','14:35:00',1.31),('15844','2014-03-21','14:40:00',1.16),('15844','2014-03-21','15:05:00',1.16),('15844','2014-03-21','15:10:00',1.29),('15844','2014-03-21','15:15:00',1.25),('15844','2014-03-21','15:25:00',1.08),('15844','2014-03-21','15:30:00',1.02),('15844','2014-03-20','08:00:00',1.06),('15844','2014-03-20','08:05:00',1.11),('15844','2014-03-20','08:10:00',1.13),('15844','2014-03-20','08:15:00',1.26),('15844','2014-03-20','08:20:00',1.39),('15844','2014-03-20','08:25:00',1.5),('15844','2014-03-20','08:30:00',1.58),('15844','2014-03-20','08:35:00',1.75),('15844','2014-03-20','08:40:00',1.93),('15844','2014-03-20','08:45:00',2.03),('15844','2014-03-20','08:50:00',2.15),('15844','2014-03-20','08:55:00',2.18),('15844','2014-03-20','09:00:00',2.26),('15844','2014-03-20','09:05:00',2.37),('15844','2014-03-20','09:10:00',2.41),('15844','2014-03-20','09:15:00',2.46),('15844','2014-03-20','09:20:00',2.47),('15844','2014-03-20','09:25:00',2.55),('15844','2014-03-20','09:30:00',2.62),('15844','2014-03-20','09:35:00',2.7),('15844','2014-03-20','09:40:00',2.68),('15844','2014-03-20','09:45:00',2.71),('15844','2014-03-20','09:50:00',2.83),('15844','2014-03-20','09:55:00',2.92),('15844','2014-03-20','10:00:00',2.97),('15844','2014-03-20','10:05:00',3.09),('15844','2014-03-20','10:10:00',3.17),('15844','2014-03-20','10:15:00',3.1),('15844','2014-03-20','10:20:00',3.17),('15844','2014-03-20','10:25:00',3.19),('15844','2014-03-20','10:30:00',3.24),('15844','2014-03-20','10:35:00',3.13),('15844','2014-03-20','10:40:00',3.04),('15844','2014-03-20','10:45:00',3.18),('15844','2014-03-20','10:50:00',3.27),('15844','2014-03-20','10:55:00',3.32),('15844','2014-03-20','11:00:00',3.33),('15844','2014-03-20','11:05:00',3.32),('15844','2014-03-20','11:10:00',3.12),('15844','2014-03-20','11:15:00',3.02),('15844','2014-03-20','11:20:00',3.2),('15844','2014-03-20','11:25:00',3.21),('15844','2014-03-20','11:30:00',3.15),('15844','2014-03-20','11:35:00',3.22),('15844','2014-03-20','11:40:00',3.29),('15844','2014-03-20','11:45:00',3.14),('15844','2014-03-20','11:50:00',3),('15844','2014-03-20','11:55:00',2.97),('15844','2014-03-20','12:00:00',2.68),('15844','2014-03-20','12:05:00',3.01),('15844','2014-03-20','12:10:00',3.11),('15844','2014-03-20','12:15:00',3.3),('15844','2014-03-20','12:20:00',3.12),('15844','2014-03-20','12:25:00',2.91),('15844','2014-03-20','12:30:00',3.09),('15844','2014-03-20','12:35:00',3.18),('15844','2014-03-20','12:40:00',3.2),('15844','2014-03-20','12:45:00',3.12),('15844','2014-03-20','12:50:00',3.08),('15844','2014-03-20','12:55:00',2.97),('15844','2014-03-20','13:00:00',2.93),('15844','2014-03-20','13:05:00',2.79),('15844','2014-03-20','13:10:00',2.7),('15844','2014-03-20','13:15:00',2.69),('15844','2014-03-20','13:20:00',2.59),('15844','2014-03-20','13:25:00',2.52),('15844','2014-03-20','13:30:00',2.37),('15844','2014-03-20','13:35:00',2.26),('15844','2014-03-20','13:40:00',2.08),('15844','2014-03-20','13:45:00',1.97),('15844','2014-03-20','13:50:00',1.84),('15844','2014-03-20','13:55:00',1.74),('15844','2014-03-20','14:00:00',1.78),('15844','2014-03-20','14:05:00',1.74),('15844','2014-03-20','14:10:00',1.66),('15844','2014-03-20','14:15:00',1.67),('15844','2014-03-20','14:20:00',1.4),('15844','2014-03-20','14:25:00',1.26),('15844','2014-03-20','14:30:00',1.18),('15844','2014-03-20','14:35:00',1.2),('15844','2014-03-20','14:40:00',1.11),('15844','2014-03-20','14:45:00',1.05),('15844','2014-03-20','14:50:00',1.04),('15844','2014-03-20','14:55:00',1.01),('15844','2014-03-19','09:10:00',1.01),('15844','2014-03-19','09:15:00',1.08),('15844','2014-03-19','09:20:00',1.3),('15844','2014-03-19','09:25:00',1.56),('15844','2014-03-19','09:30:00',1.72),('15844','2014-03-19','09:35:00',1.64),('15844','2014-03-19','09:40:00',2.26),('15844','2014-03-19','09:45:00',1.56),('15844','2014-03-19','09:50:00',1.12),('15844','2014-03-19','10:05:00',1.74),('15844','2014-03-19','10:10:00',1.79),('15844','2014-03-19','10:15:00',1.27),('15844','2014-03-19','10:20:00',1.17),('15844','2014-03-19','10:25:00',1.3),('15844','2014-03-19','10:30:00',1.38),('15844','2014-03-19','10:35:00',1.18),('15844','2014-03-19','10:40:00',1.68),('15844','2014-03-19','10:45:00',2.04),('15844','2014-03-19','10:50:00',1.87),('15844','2014-03-19','10:55:00',2.08),('15844','2014-03-19','11:00:00',1.55),('15844','2014-03-19','11:05:00',3.32),('15844','2014-03-19','11:10:00',3.18),('15844','2014-03-19','11:15:00',2.52),('15844','2014-03-19','11:20:00',2.75),('15844','2014-03-19','11:25:00',3.38),('15844','2014-03-19','11:30:00',2.91),('15844','2014-03-19','11:35:00',2.09),('15844','2014-03-19','11:40:00',1.93),('15844','2014-03-19','11:45:00',1.72),('15844','2014-03-19','11:50:00',1.22),('15844','2014-03-19','11:55:00',1.22),('15844','2014-03-19','12:00:00',1.3),('15844','2014-03-19','12:05:00',2.52),('15844','2014-03-19','12:10:00',1.79),('15844','2014-03-19','12:15:00',3.62),('15844','2014-03-19','12:20:00',3.59),('15844','2014-03-19','12:25:00',3.02),('15844','2014-03-19','12:30:00',3.04),('15844','2014-03-19','12:35:00',2.96),('15844','2014-03-19','12:40:00',3.14),('15844','2014-03-19','12:45:00',2.54),('15844','2014-03-19','12:50:00',2.28),('15844','2014-03-19','12:55:00',2.95),('15844','2014-03-19','13:00:00',2.87),('15844','2014-03-19','13:05:00',2.91),('15844','2014-03-19','13:10:00',2.82),('15844','2014-03-19','13:15:00',2.61),('15844','2014-03-19','13:20:00',2.3),('15844','2014-03-19','13:25:00',2.62),('15844','2014-03-19','13:30:00',2.52),('15844','2014-03-19','13:35:00',2.48),('15844','2014-03-19','13:40:00',2.32),('15844','2014-03-19','13:45:00',2.21),('15844','2014-03-19','13:50:00',2.13),('15844','2014-03-19','13:55:00',1.98),('15844','2014-03-19','14:00:00',1.96),('15844','2014-03-19','14:05:00',1.89),('15844','2014-03-19','14:10:00',1.78),('15844','2014-03-19','14:15:00',1.69),('15844','2014-03-19','14:20:00',1.55),('15844','2014-03-19','14:25:00',1.45),('15844','2014-03-19','14:30:00',1.38),('15844','2014-03-19','14:35:00',1.34),('15844','2014-03-19','14:40:00',1.25),('15844','2014-03-19','14:45:00',1.18),('15844','2014-03-19','14:50:00',1.14),('15844','2014-03-19','14:55:00',1.07),('15844','2014-03-19','15:00:00',1.01),('15844','2014-03-18','08:10:00',1.03),('15844','2014-03-18','08:15:00',1.4),('15844','2014-03-18','08:20:00',1.07),('15844','2014-03-18','08:25:00',1.02),('15844','2014-03-18','09:05:00',1.21),('15844','2014-03-18','09:10:00',2.47),('15844','2014-03-18','09:15:00',1.33),('15844','2014-03-18','09:20:00',1.35),('15844','2014-03-18','09:25:00',1.24),('15844','2014-03-18','09:30:00',1.75),('15844','2014-03-18','09:35:00',2.47),('15844','2014-03-18','09:40:00',3.09),('15844','2014-03-18','09:45:00',3.15),('15844','2014-03-18','09:50:00',3.03),('15844','2014-03-18','09:55:00',1.36),('15844','2014-03-18','10:00:00',1.25),('15844','2014-03-18','10:05:00',1.01),('15844','2014-03-18','10:10:00',1.24),('15844','2014-03-18','10:15:00',1.19),('15844','2014-03-18','10:20:00',1.08),('15844','2014-03-18','10:25:00',1.61),('15844','2014-03-18','10:30:00',3.17),('15844','2014-03-18','10:35:00',2.09),('15844','2014-03-18','10:40:00',2.46),('15844','2014-03-18','10:45:00',3.83),('15844','2014-03-18','10:50:00',2.74),('15844','2014-03-18','10:55:00',2.42),('15844','2014-03-18','11:00:00',1.66),('15844','2014-03-18','11:05:00',2.14),('15844','2014-03-18','11:10:00',2.33),('15844','2014-03-18','11:15:00',1.3),('15844','2014-03-18','11:20:00',1.46),('15844','2014-03-18','11:25:00',2.53),('15844','2014-03-18','11:30:00',2.23),('15844','2014-03-18','11:35:00',2.12),('15844','2014-03-18','11:40:00',2.19),('15844','2014-03-18','11:45:00',2.99),('15844','2014-03-18','11:50:00',3.61),('15844','2014-03-18','11:55:00',3.65),('15844','2014-03-18','12:00:00',2.26),('15844','2014-03-18','12:05:00',3.29),('15844','2014-03-18','12:10:00',3.61),('15844','2014-03-18','12:15:00',2.64),('15844','2014-03-18','12:20:00',3.54),('15844','2014-03-18','12:25:00',3.63),('15844','2014-03-18','12:30:00',3.49),('15844','2014-03-18','12:35:00',3.23),('15844','2014-03-18','12:40:00',3.33),('15844','2014-03-18','12:45:00',2.98),('15844','2014-03-18','12:50:00',3.07),('15844','2014-03-18','12:55:00',2.84),('15844','2014-03-18','13:00:00',2.92),('15844','2014-03-18','13:05:00',2.91),('15844','2014-03-18','13:10:00',2.83),('15844','2014-03-18','13:15:00',2.77),('15844','2014-03-18','13:20:00',2.7),('15844','2014-03-18','13:25:00',2.57),('15844','2014-03-18','13:30:00',2.52),('15844','2014-03-18','13:35:00',2.41),('15844','2014-03-18','13:40:00',2.32),('15844','2014-03-18','13:45:00',2.22),('15844','2014-03-18','13:50:00',2.14),('15844','2014-03-18','13:55:00',2.04),('15844','2014-03-18','14:00:00',1.96),('15844','2014-03-18','14:05:00',1.86),('15844','2014-03-18','14:10:00',1.76),('15844','2014-03-18','14:15:00',1.67),('15844','2014-03-18','14:20:00',1.56),('15844','2014-03-18','14:25:00',1.41),('15844','2014-03-18','14:30:00',1.31),('15844','2014-03-18','14:35:00',1.3),('15844','2014-03-18','14:40:00',1.23),('15844','2014-03-18','14:45:00',1.15),('15844','2014-03-18','14:50:00',1.1),('15844','2014-03-18','14:55:00',1.03),('15844','2014-05-01','08:25:00',1.12),('15844','2014-05-01','08:30:00',1.27),('15844','2014-05-01','08:35:00',1.35),('15844','2014-05-01','08:40:00',1.47),('15844','2014-05-01','08:45:00',1.5),('15844','2014-05-01','08:50:00',1.32),('15844','2014-05-01','08:55:00',1.22),('15844','2014-05-01','09:00:00',1.16),('15844','2014-05-01','09:05:00',1.24),('15844','2014-05-01','09:10:00',1.43),('15844','2014-05-01','09:15:00',2.02),('15844','2014-05-01','09:20:00',2.3),('15844','2014-05-01','09:25:00',2.27),('15844','2014-05-01','09:30:00',2.48),('15844','2014-05-01','09:35:00',1.49),('15844','2014-05-01','09:40:00',1.53),('15844','2014-05-01','09:45:00',1.22),('15844','2014-05-01','10:00:00',1.7),('15844','2014-05-01','10:05:00',1.07),('15844','2014-05-01','10:10:00',3.05),('15844','2014-05-01','10:15:00',2.21),('15844','2014-05-01','10:20:00',3.96),('15844','2014-05-01','10:25:00',2.05),('15844','2014-05-01','10:30:00',1.46),('15844','2014-05-01','10:35:00',1.11),('15844','2014-05-01','10:40:00',2.89),('15844','2014-05-01','10:45:00',2.37),('15844','2014-05-01','10:50:00',2.95),('15844','2014-05-01','10:55:00',1.7),('15844','2014-05-01','11:05:00',4.28),('15844','2014-05-01','11:10:00',4.68),('15844','2014-05-01','11:15:00',4.58),('15844','2014-05-01','11:20:00',4.63),('15844','2014-05-01','11:25:00',3.05),('15844','2014-05-01','11:30:00',4.71),('15844','2014-05-01','11:35:00',3.94),('15844','2014-05-01','11:40:00',4.83),('15844','2014-05-01','11:45:00',4.92),('15844','2014-05-01','11:50:00',4.86),('15844','2014-05-01','11:55:00',1.4),('15844','2014-05-01','12:05:00',1.05),('15844','2014-05-01','12:10:00',4.92),('15844','2014-05-01','12:15:00',4.99),('15844','2014-05-01','12:20:00',4.73),('15844','2014-05-01','12:25:00',4.4),('15844','2014-05-01','12:30:00',2.16),('15844','2014-05-01','12:35:00',4.69),('15844','2014-05-01','12:40:00',4.85),('15844','2014-05-01','12:45:00',4.44),('15844','2014-05-01','12:55:00',1.03),('15844','2014-05-01','13:00:00',4.27),('15844','2014-05-01','13:05:00',4.51),('15844','2014-05-01','13:10:00',4.19),('15844','2014-05-01','13:15:00',4.55),('15844','2014-05-01','13:20:00',4.32),('15844','2014-05-01','13:25:00',2.88),('15844','2014-05-01','13:30:00',1.28),('15844','2014-05-01','13:35:00',1.9),('15844','2014-05-01','13:40:00',3.98),('15844','2014-05-01','13:45:00',4.52),('15844','2014-05-01','13:50:00',4.06),('15844','2014-05-01','13:55:00',3.9),('15844','2014-05-01','14:00:00',3.75),('15844','2014-05-01','14:05:00',3.68),('15844','2014-05-01','14:10:00',3.64),('15844','2014-05-01','14:15:00',3.56),('15844','2014-05-01','14:20:00',3.44),('15844','2014-05-01','14:25:00',3.3),('15844','2014-05-01','14:30:00',3.06),('15844','2014-05-01','14:35:00',3.08),('15844','2014-05-01','14:40:00',3.07),('15844','2014-05-01','14:45:00',3.02),('15844','2014-05-01','14:50:00',2.9),('15844','2014-05-01','14:55:00',2.57),('15844','2014-05-01','15:00:00',2.77),('15844','2014-05-01','15:05:00',2.72),('15844','2014-05-01','15:10:00',2.61),('15844','2014-05-01','15:15:00',2.12),('15844','2014-05-01','15:20:00',2.5),('15844','2014-05-01','15:25:00',2.28),('15844','2014-05-01','15:30:00',2.16),('15844','2014-05-01','15:35:00',2.05),('15844','2014-05-01','15:40:00',1.93),('15844','2014-05-01','15:45:00',1.76),('15844','2014-05-01','15:50:00',1.71),('15844','2014-05-01','15:55:00',1.53),('15844','2014-05-01','16:00:00',1.54),('15844','2014-05-01','16:05:00',1.39),('15844','2014-05-01','16:10:00',1.34),('15844','2014-05-01','16:15:00',1.31),('15844','2014-05-01','16:20:00',1.19),('15844','2014-05-01','16:25:00',1.28),('15844','2014-05-01','16:30:00',1.2),('15844','2014-05-01','16:35:00',1.08),('15844','2014-03-17','09:15:00',1.07),('15844','2014-03-17','09:50:00',1.07),('15844','2014-03-17','10:45:00',1.29),('15844','2014-03-17','10:50:00',1.14),('15844','2014-03-17','11:00:00',1.15),('15844','2014-03-17','11:05:00',1.38),('15844','2014-03-17','11:10:00',1.42),('15844','2014-03-17','11:15:00',1.11),('15844','2014-03-17','11:20:00',1.28),('15844','2014-03-17','11:25:00',1.22),('15844','2014-03-17','11:30:00',1.46),('15844','2014-03-17','11:35:00',1.22),('15844','2014-03-17','11:40:00',1.03),('15844','2014-03-17','11:50:00',1.4),('15844','2014-03-17','11:55:00',1.64),('15844','2014-03-17','12:00:00',1.51),('15844','2014-03-17','12:05:00',1.56),('15844','2014-03-17','12:10:00',3.1),('15844','2014-03-17','12:15:00',2.15),('15844','2014-03-17','12:20:00',3.19),('15844','2014-03-17','12:25:00',2.94),('15844','2014-03-17','12:30:00',3.58),('15844','2014-03-17','12:35:00',3.4),('15844','2014-03-17','12:40:00',2.27),('15844','2014-03-17','12:45:00',2.93),('15844','2014-03-17','12:50:00',3.06),('15844','2014-03-17','12:55:00',3.13),('15844','2014-03-17','13:00:00',3.03),('15844','2014-03-17','13:05:00',2.69),('15844','2014-03-17','13:10:00',2.81),('15844','2014-03-17','13:15:00',2.77),('15844','2014-03-17','13:20:00',2.8),('15844','2014-03-17','13:25:00',2.29),('15844','2014-03-17','13:30:00',1.59),('15844','2014-03-17','13:35:00',2.58),('15844','2014-03-17','13:40:00',1.71),('15844','2014-03-17','13:45:00',2.26),('15844','2014-03-17','13:50:00',2.4),('15844','2014-03-17','13:55:00',1.9),('15844','2014-03-17','14:00:00',1.04),('15844','2014-03-17','14:05:00',1.47),('15844','2014-03-17','14:10:00',1.27),('15844','2014-03-17','14:15:00',1.21),('15844','2014-03-17','14:20:00',1.66),('15844','2014-03-17','14:25:00',1.53),('15844','2014-03-17','14:30:00',1.73),('15844','2014-03-17','14:35:00',1.46),('15844','2014-03-17','14:40:00',1.08),('15844','2014-03-17','14:45:00',1.3),('15844','2014-03-17','14:50:00',1.27),('15844','2014-03-17','14:55:00',1.31),('15844','2014-03-16','08:10:00',1.06),('15844','2014-03-16','08:15:00',1.08),('15844','2014-03-16','08:20:00',1.15),('15844','2014-03-16','08:25:00',1.31),('15844','2014-03-16','08:30:00',1.39),('15844','2014-03-16','08:35:00',1.45),('15844','2014-03-16','08:40:00',1.51),('15844','2014-03-16','08:45:00',1.62),('15844','2014-03-16','08:50:00',1.7),('15844','2014-03-16','08:55:00',1.77),('15844','2014-03-16','09:00:00',1.76),('15844','2014-03-16','09:05:00',1.84),('15844','2014-03-16','09:10:00',1.94),('15844','2014-03-16','09:15:00',2.11),('15844','2014-03-16','09:20:00',2.11),('15844','2014-03-16','09:25:00',2.12),('15844','2014-03-16','09:30:00',2.18),('15844','2014-03-16','09:35:00',2.19),('15844','2014-03-16','09:40:00',2.36),('15844','2014-03-16','09:45:00',2.36),('15844','2014-03-16','09:50:00',2.57),('15844','2014-03-16','09:55:00',2.61),('15844','2014-03-16','10:00:00',2.66),('15844','2014-03-16','10:05:00',2.74),('15844','2014-03-16','10:10:00',2.78),('15844','2014-03-16','10:15:00',2.91),('15844','2014-03-16','10:20:00',2.92),('15844','2014-03-16','10:25:00',2.86),('15844','2014-03-16','10:30:00',2.86),('15844','2014-03-16','10:35:00',2.8),('15844','2014-03-16','10:40:00',2.86),('15844','2014-03-16','10:45:00',2.92),('15844','2014-03-16','10:50:00',3),('15844','2014-03-16','10:55:00',3.16),('15844','2014-03-16','11:00:00',3.07),('15844','2014-03-16','11:05:00',3.04),('15844','2014-03-16','11:10:00',2.86),('15844','2014-03-16','11:15:00',2.79),('15844','2014-03-16','11:20:00',2.93),('15844','2014-03-16','11:25:00',3.06),('15844','2014-03-16','11:30:00',3.1),('15844','2014-03-16','11:35:00',3.12),('15844','2014-03-16','11:40:00',3.01),('15844','2014-03-16','11:45:00',2.97),('15844','2014-03-16','11:50:00',2.96),('15844','2014-03-16','11:55:00',2.97),('15844','2014-03-16','12:00:00',2.97),('15844','2014-03-16','12:05:00',2.99),('15844','2014-03-16','12:10:00',2.98),('15844','2014-03-16','12:15:00',2.96),('15844','2014-03-16','12:20:00',2.95),('15844','2014-03-16','12:25:00',2.92),('15844','2014-03-16','12:30:00',2.91),('15844','2014-03-16','12:35:00',2.9),('15844','2014-03-16','12:40:00',2.84),('15844','2014-03-16','12:45:00',2.48),('15844','2014-03-16','12:50:00',1.86),('15844','2014-03-16','12:55:00',2.72),('15844','2014-03-16','13:00:00',2.68),('15844','2014-03-16','13:05:00',2.64),('15844','2014-03-16','13:10:00',2.59),('15844','2014-03-16','13:15:00',2.53),('15844','2014-03-16','13:20:00',2.46),('15844','2014-03-16','13:25:00',2.41),('15844','2014-03-16','13:30:00',2.33),('15844','2014-03-16','13:35:00',2.23),('15844','2014-03-16','13:40:00',2.23),('15844','2014-03-16','13:45:00',2.14),('15844','2014-03-16','13:50:00',2.02),('15844','2014-03-16','13:55:00',1.95),('15844','2014-03-16','14:00:00',1.84),('15844','2014-03-16','14:05:00',1.77),('15844','2014-03-16','14:10:00',1.69),('15844','2014-03-16','14:15:00',1.61),('15844','2014-03-16','14:20:00',1.52),('15844','2014-03-16','14:25:00',1.43),('15844','2014-03-16','14:30:00',1.31),('15844','2014-03-16','14:35:00',1.18),('15844','2014-03-16','14:40:00',1.17),('15844','2014-03-16','14:45:00',1.12),('15844','2014-03-16','14:50:00',1.03),('15844','2014-03-16','14:55:00',1.09),('15844','2014-03-15','08:15:00',1.06),('15844','2014-03-15','08:20:00',1.13),('15844','2014-03-15','08:25:00',1.22),('15844','2014-03-15','08:30:00',1.3),('15844','2014-03-15','08:35:00',1.38),('15844','2014-03-15','08:40:00',1.47),('15844','2014-03-15','08:45:00',1.54),('15844','2014-03-15','08:50:00',1.62),('15844','2014-03-15','08:55:00',1.72),('15844','2014-03-15','09:00:00',1.78),('15844','2014-03-15','09:05:00',1.87),('15844','2014-03-15','09:10:00',1.93),('15844','2014-03-15','09:15:00',2.02),('15844','2014-03-15','09:20:00',2.08),('15844','2014-03-15','09:25:00',2.1),('15844','2014-03-15','09:30:00',2.15),('15844','2014-03-15','09:35:00',2.24),('15844','2014-03-15','09:40:00',2.32),('15844','2014-03-15','09:45:00',2.38),('15844','2014-03-15','09:50:00',2.48),('15844','2014-03-15','09:55:00',2.56),('15844','2014-03-15','10:00:00',2.56),('15844','2014-03-15','10:05:00',2.59),('15844','2014-03-15','10:10:00',2.66),('15844','2014-03-15','10:15:00',2.62),('15844','2014-03-15','10:20:00',2.61),('15844','2014-03-15','10:25:00',2.7),('15844','2014-03-15','10:30:00',2.74),('15844','2014-03-15','10:35:00',2.73),('15844','2014-03-15','10:40:00',2.81),('15844','2014-03-15','10:45:00',2.95),('15844','2014-03-15','10:50:00',2.93),('15844','2014-03-15','10:55:00',2.95),('15844','2014-03-15','11:00:00',2.99),('15844','2014-03-15','11:05:00',3.01),('15844','2014-03-15','11:10:00',2.95),('15844','2014-03-15','11:15:00',2.95),('15844','2014-03-15','11:20:00',3.07),('15844','2014-03-15','11:25:00',3.08),('15844','2014-03-15','11:30:00',3.12),('15844','2014-03-15','11:35:00',3.1),('15844','2014-03-15','11:40:00',2.96),('15844','2014-03-15','11:45:00',3.03),('15844','2014-03-15','11:50:00',3.06),('15844','2014-03-15','11:55:00',3),('15844','2014-03-15','12:00:00',2.99),('15844','2014-03-15','12:05:00',2.88),('15844','2014-03-15','12:10:00',2.95),('15844','2014-03-15','12:15:00',2.89),('15844','2014-03-15','12:20:00',2.95),('15844','2014-03-15','12:25:00',2.89),('15844','2014-03-15','12:30:00',2.98),('15844','2014-03-15','12:35:00',2.91),('15844','2014-03-15','12:40:00',2.87),('15844','2014-03-15','12:45:00',2.82),('15844','2014-03-15','12:50:00',2.78),('15844','2014-03-15','12:55:00',2.73),('15844','2014-03-15','13:00:00',2.71),('15844','2014-03-15','13:05:00',2.64),('15844','2014-03-15','13:10:00',2.58),('15844','2014-03-15','13:15:00',2.56),('15844','2014-03-15','13:20:00',2.47),('15844','2014-03-15','13:25:00',2.46),('15844','2014-03-15','13:30:00',2.35),('15844','2014-03-15','13:35:00',2.26),('15844','2014-03-15','13:40:00',2.19),('15844','2014-03-15','13:45:00',2.1),('15844','2014-03-15','13:50:00',2.02),('15844','2014-03-15','13:55:00',1.93),('15844','2014-03-15','14:00:00',1.86),('15844','2014-03-15','14:05:00',1.77),('15844','2014-03-15','14:10:00',1.7),('15844','2014-03-15','14:15:00',1.6),('15844','2014-03-15','14:20:00',1.51),('15844','2014-03-15','14:25:00',1.42),('15844','2014-03-15','14:30:00',1.32),('15844','2014-03-15','14:35:00',1.21),('15844','2014-03-15','14:40:00',1.12),('15844','2014-03-15','14:45:00',1.05),('15844','2014-03-14','09:05:00',1.05),('15844','2014-03-14','09:10:00',1.34),('15844','2014-03-14','09:15:00',1.52),('15844','2014-03-14','09:20:00',1.53),('15844','2014-03-14','09:25:00',1.39),('15844','2014-03-14','09:30:00',1.43),('15844','2014-03-14','09:35:00',1.45),('15844','2014-03-14','09:40:00',1.67),('15844','2014-03-14','09:45:00',2.02),('15844','2014-03-14','09:50:00',2.27),('15844','2014-03-14','09:55:00',2.68),('15844','2014-03-14','10:00:00',2.95),('15844','2014-03-14','10:05:00',3.14),('15844','2014-03-14','10:10:00',2.95),('15844','2014-03-14','10:15:00',2.94),('15844','2014-03-14','10:20:00',3.16),('15844','2014-03-14','10:25:00',3.09),('15844','2014-03-14','10:30:00',2.87),('15844','2014-03-14','10:35:00',3.02),('15844','2014-03-14','10:40:00',3.05),('15844','2014-03-14','10:45:00',2.91),('15844','2014-03-14','10:50:00',2.47),('15844','2014-03-14','10:55:00',1.96),('15844','2014-03-14','11:00:00',2.79),('15844','2014-03-14','11:05:00',2.89),('15844','2014-03-14','11:10:00',2.95),('15844','2014-03-14','11:15:00',3.24),('15844','2014-03-14','11:20:00',3.23),('15844','2014-03-14','11:25:00',3.02),('15844','2014-03-14','11:30:00',2.8),('15844','2014-03-14','11:35:00',2.9),('15844','2014-03-14','11:40:00',2.94),('15844','2014-03-14','11:45:00',2.91),('15844','2014-03-14','11:50:00',2.93),('15844','2014-03-14','11:55:00',3.05),('15844','2014-03-14','12:00:00',3.04),('15844','2014-03-14','12:05:00',3.09),('15844','2014-03-14','12:10:00',3.04),('15844','2014-03-14','12:15:00',2.92),('15844','2014-03-14','12:20:00',2.63),('15844','2014-03-14','12:25:00',2.48),('15844','2014-03-14','12:30:00',1.97),('15844','2014-03-14','12:35:00',1.73),('15844','2014-03-14','12:40:00',1.44),('15844','2014-03-14','12:45:00',1.43),('15844','2014-03-14','12:50:00',1.84),('15844','2014-03-14','12:55:00',1.89),('15844','2014-03-14','13:00:00',1.88),('15844','2014-03-14','13:05:00',1.4),('15844','2014-03-14','13:10:00',1.64),('15844','2014-03-14','13:15:00',1.93),('15844','2014-03-14','13:20:00',1.74),('15844','2014-03-14','13:25:00',1.76),('15844','2014-03-14','13:30:00',1.7),('15844','2014-03-14','13:35:00',1.55),('15844','2014-03-14','13:40:00',1.38),('15844','2014-03-14','13:45:00',1.48),('15844','2014-03-14','13:50:00',1.56),('15844','2014-03-14','13:55:00',1.58),('15844','2014-03-14','14:00:00',1.46),('15844','2014-03-14','14:05:00',1.61),('15844','2014-03-14','14:10:00',1.77),('15844','2014-03-14','14:15:00',1.44),('15844','2014-03-14','14:20:00',1.49),('15844','2014-03-14','14:25:00',1.76),('15844','2014-03-14','14:30:00',1.51),('15844','2014-03-14','14:35:00',1.39),('15844','2014-03-14','14:40:00',1.3),('15844','2014-03-14','14:45:00',1.13),('15844','2014-03-14','14:50:00',1.05),('15844','2014-03-14','14:55:00',1.01),('15844','2014-03-13','08:00:00',1.04),('15844','2014-03-13','08:05:00',1.15),('15844','2014-03-13','08:10:00',1.22),('15844','2014-03-13','08:15:00',1.33),('15844','2014-03-13','08:20:00',1.47),('15844','2014-03-13','08:25:00',1.6),('15844','2014-03-13','08:30:00',1.7),('15844','2014-03-13','08:35:00',1.77),('15844','2014-03-13','08:40:00',1.86),('15844','2014-03-13','08:45:00',1.93),('15844','2014-03-13','08:50:00',2.04),('15844','2014-03-13','08:55:00',2.16),('15844','2014-03-13','09:00:00',2.22),('15844','2014-03-13','09:05:00',2.33),('15844','2014-03-13','09:10:00',2.38),('15844','2014-03-13','09:15:00',2.44),('15844','2014-03-13','09:20:00',2.48),('15844','2014-03-13','09:25:00',2.55),('15844','2014-03-13','09:30:00',2.63),('15844','2014-03-13','09:35:00',2.67),('15844','2014-03-13','09:40:00',2.71),('15844','2014-03-13','09:45:00',2.78),('15844','2014-03-13','09:50:00',2.81),('15844','2014-03-13','09:55:00',2.91),('15844','2014-03-13','10:00:00',3),('15844','2014-03-13','10:05:00',3.04),('15844','2014-03-13','10:10:00',3.11),('15844','2014-03-13','10:15:00',3.18),('15844','2014-03-13','10:20:00',3.24),('15844','2014-03-13','10:25:00',3.25),('15844','2014-03-13','10:30:00',3.28),('15844','2014-03-13','10:35:00',3.3),('15844','2014-03-13','10:40:00',3.32),('15844','2014-03-13','10:45:00',3.34),('15844','2014-03-13','10:50:00',3.34),('15844','2014-03-13','10:55:00',3.35),('15844','2014-03-13','11:00:00',3.36),('15844','2014-03-13','11:05:00',3.34),('15844','2014-03-13','11:10:00',3.36),('15844','2014-03-13','11:15:00',3.35),('15844','2014-03-13','11:20:00',3.33),('15844','2014-03-13','11:25:00',3.33),('15844','2014-03-13','11:30:00',3.32),('15844','2014-03-13','11:35:00',3.34),('15844','2014-03-13','11:40:00',3.29),('15844','2014-03-13','11:45:00',3.28),('15844','2014-03-13','11:50:00',3.24),('15844','2014-03-13','11:55:00',3.21),('15844','2014-03-13','12:00:00',3.2),('15844','2014-03-13','12:05:00',3.17),('15844','2014-03-13','12:10:00',3.13),('15844','2014-03-13','12:15:00',3.12),('15844','2014-03-13','12:20:00',3.06),('15844','2014-03-13','12:25:00',3.02),('15844','2014-03-13','12:30:00',2.98),('15844','2014-03-13','12:35:00',2.95),('15844','2014-03-13','12:40:00',2.92),('15844','2014-03-13','12:45:00',2.83),('15844','2014-03-13','12:50:00',2.8),('15844','2014-03-13','12:55:00',2.78),('15844','2014-03-13','13:00:00',2.71),('15844','2014-03-13','13:05:00',2.66),('15844','2014-03-13','13:10:00',2.6),('15844','2014-03-13','13:15:00',2.54),('15844','2014-03-13','13:20:00',2.47),('15844','2014-03-13','13:25:00',2.41),('15844','2014-03-13','13:30:00',2.33),('15844','2014-03-13','13:35:00',2.25),('15844','2014-03-13','13:40:00',2.18),('15844','2014-03-13','13:45:00',2.08),('15844','2014-03-13','13:50:00',2),('15844','2014-03-13','13:55:00',1.91),('15844','2014-03-13','14:00:00',1.82),('15844','2014-03-13','14:05:00',1.72),('15844','2014-03-13','14:10:00',1.61),('15844','2014-03-13','14:15:00',1.53),('15844','2014-03-13','14:20:00',1.44),('15844','2014-03-13','14:25:00',1.35),('15844','2014-03-13','14:30:00',1.23),('15844','2014-03-13','14:35:00',1.11),('15844','2014-03-13','14:40:00',1.09),('15844','2014-03-13','14:45:00',1.04),('15844','2014-03-13','14:50:00',1.01),('15844','2014-03-12','08:00:00',1.01),('15844','2014-03-12','08:05:00',1.1),('15844','2014-03-12','08:10:00',1.18),('15844','2014-03-12','08:15:00',1.31),('15844','2014-03-12','08:20:00',1.44),('15844','2014-03-12','08:25:00',1.58),('15844','2014-03-12','08:30:00',1.68),('15844','2014-03-12','08:35:00',1.77),('15844','2014-03-12','08:40:00',1.82),('15844','2014-03-12','08:45:00',1.91),('15844','2014-03-12','08:50:00',2.02),('15844','2014-03-12','08:55:00',2.13),('15844','2014-03-12','09:00:00',2.22),('15844','2014-03-12','09:05:00',2.29),('15844','2014-03-12','09:10:00',2.34),('15844','2014-03-12','09:15:00',2.4),('15844','2014-03-12','09:20:00',2.45),('15844','2014-03-12','09:25:00',2.51),('15844','2014-03-12','09:30:00',2.55),('15844','2014-03-12','09:35:00',2.62),('15844','2014-03-12','09:40:00',2.66),('15844','2014-03-12','09:45:00',2.71),('15844','2014-03-12','09:50:00',2.74),('15844','2014-03-12','09:55:00',2.82),('15844','2014-03-12','10:00:00',2.9),('15844','2014-03-12','10:05:00',3),('15844','2014-03-12','10:10:00',3.05),('15844','2014-03-12','10:15:00',3.1),('15844','2014-03-12','10:20:00',3.12),('15844','2014-03-12','10:25:00',3.14),('15844','2014-03-12','10:30:00',3.15),('15844','2014-03-12','10:35:00',3.17),('15844','2014-03-12','10:40:00',3.18),('15844','2014-03-12','10:45:00',3.21),('15844','2014-03-12','10:50:00',3.26),('15844','2014-03-12','10:55:00',3.25),('15844','2014-03-12','11:00:00',3.27),('15844','2014-03-12','11:05:00',3.28),('15844','2014-03-12','11:10:00',3.3),('15844','2014-03-12','11:15:00',3.31),('15844','2014-03-12','11:20:00',3.29),('15844','2014-03-12','11:25:00',3.28),('15844','2014-03-12','11:30:00',3.3),('15844','2014-03-12','11:35:00',3.27),('15844','2014-03-12','11:40:00',3.27),('15844','2014-03-12','11:45:00',3.26),('15844','2014-03-12','11:50:00',3.23),('15844','2014-03-12','11:55:00',3.23),('15844','2014-03-12','12:00:00',3.2),('15844','2014-03-12','12:05:00',3.2),('15844','2014-03-12','12:10:00',3.2),('15844','2014-03-12','12:15:00',3.16),('15844','2014-03-12','12:20:00',3.14),('15844','2014-03-12','12:25:00',3.13),('15844','2014-03-12','12:30:00',3.1),('15844','2014-03-12','12:35:00',3.07),('15844','2014-03-12','12:40:00',3.01),('15844','2014-03-12','12:45:00',2.98),('15844','2014-03-12','12:50:00',2.93),('15844','2014-03-12','12:55:00',2.88),('15844','2014-03-12','13:00:00',2.82),('15844','2014-03-12','13:05:00',2.74),('15844','2014-03-12','13:10:00',2.7),('15844','2014-03-12','13:15:00',2.63),('15844','2014-03-12','13:20:00',2.56),('15844','2014-03-12','13:25:00',2.49),('15844','2014-03-12','13:30:00',2.36),('15844','2014-03-12','13:35:00',2.32),('15844','2014-03-12','13:40:00',2.21),('15844','2014-03-12','13:45:00',2.13),('15844','2014-03-12','13:50:00',2.06),('15844','2014-03-12','13:55:00',1.98),('15844','2014-03-12','14:00:00',1.88),('15844','2014-03-12','14:05:00',1.76),('15844','2014-03-12','14:10:00',1.64),('15844','2014-03-12','14:15:00',1.55),('15844','2014-03-12','14:20:00',1.5),('15844','2014-03-12','14:25:00',1.39),('15844','2014-03-12','14:30:00',1.27),('15844','2014-03-12','14:35:00',1.21),('15844','2014-03-12','14:40:00',1.14),('15844','2014-03-12','14:45:00',1.07),('15844','2014-03-12','14:50:00',1.05),('15844','2014-03-12','14:55:00',1.02),('15844','2014-03-11','11:15:00',1.04),('15844','2014-03-11','11:20:00',1.06),('15844','2014-03-11','12:15:00',1.06),('15844','2014-03-11','12:20:00',1.3),('15844','2014-03-11','12:25:00',1.23),('15844','2014-03-11','12:30:00',1.16),('15844','2014-03-11','12:35:00',1.24),('15844','2014-03-11','12:40:00',1.21),('15844','2014-03-11','12:45:00',1.34),('15844','2014-03-11','12:50:00',1.43),('15844','2014-03-11','12:55:00',1.37),('15844','2014-03-11','13:00:00',1.3),('15844','2014-03-11','13:05:00',1.14),('15844','2014-03-11','13:10:00',1.32),('15844','2014-03-11','13:15:00',1.25),('15844','2014-03-11','13:20:00',1.28),('15844','2014-03-11','13:25:00',1.22),('15844','2014-03-11','13:45:00',1.01),('15844','2014-03-11','13:50:00',1.1),('15844','2014-03-11','13:55:00',1.19),('15844','2014-03-11','14:00:00',1.34),('15844','2014-03-11','14:05:00',1.45),('15844','2014-03-11','14:10:00',1.52),('15844','2014-03-11','14:15:00',1.92),('15844','2014-03-11','14:20:00',1.64),('15844','2014-03-11','14:25:00',1.37),('15844','2014-03-11','14:30:00',1.31),('15844','2014-03-11','14:35:00',1.36),('15844','2014-03-11','14:40:00',1.28),('15844','2014-03-11','14:45:00',1.25),('15844','2014-03-11','14:50:00',1.09),('15844','2014-03-11','14:55:00',1.09),('15844','2014-03-11','15:00:00',1.14),('15844','2014-03-11','15:05:00',1.19),('15844','2014-03-11','15:10:00',1.16),('15844','2014-03-11','15:15:00',1.2),('15844','2014-03-11','15:20:00',1.14),('15844','2014-03-11','15:25:00',1.05),('15844','2014-03-10','09:40:00',1.04),('15844','2014-03-10','09:45:00',1.1),('15844','2014-03-10','09:50:00',1.14),('15844','2014-03-10','10:20:00',1.07),('15844','2014-03-10','14:55:00',1.02),('15844','2014-03-10','15:00:00',1.31),('15844','2014-03-10','15:05:00',1.63),('15844','2014-03-10','15:10:00',1.27),('15844','2014-03-10','15:15:00',1.07),('15844','2014-03-09','08:05:00',1.02),('15844','2014-03-09','08:10:00',1.18),('15844','2014-03-09','08:15:00',1.29),('15844','2014-03-09','08:20:00',1.41),('15844','2014-03-09','08:25:00',1.52),('15844','2014-03-09','08:30:00',1.62),('15844','2014-03-09','08:35:00',1.7),('15844','2014-03-09','08:40:00',1.78),('15844','2014-03-09','08:45:00',1.92),('15844','2014-03-09','08:50:00',2.04),('15844','2014-03-09','08:55:00',2.13),('15844','2014-03-09','09:00:00',2.22),('15844','2014-03-09','09:05:00',2.28),('15844','2014-03-09','09:10:00',2.35),('15844','2014-03-09','09:15:00',2.4),('15844','2014-03-09','09:20:00',1.79),('15844','2014-03-09','09:25:00',2.59),('15844','2014-03-09','09:30:00',2.74),('15844','2014-03-09','09:35:00',2.81),('15844','2014-03-09','09:40:00',2.78),('15844','2014-03-09','09:45:00',2.86),('15844','2014-03-09','09:50:00',2.88),('15844','2014-03-09','09:55:00',2.74),('15844','2014-03-09','10:00:00',2.98),('15844','2014-03-09','10:05:00',2.99),('15844','2014-03-09','10:10:00',3.03),('15844','2014-03-09','10:15:00',3.09),('15844','2014-03-09','10:20:00',3.09),('15844','2014-03-09','10:25:00',3.17),('15844','2014-03-09','10:30:00',3.16),('15844','2014-03-09','10:35:00',3.3),('15844','2014-03-09','10:40:00',3.36),('15844','2014-03-09','10:45:00',3.36),('15844','2014-03-09','10:50:00',3.33),('15844','2014-03-09','10:55:00',3.46),('15844','2014-03-09','11:00:00',3.53),('15844','2014-03-09','11:05:00',3.53),('15844','2014-03-09','11:10:00',3.61),('15844','2014-03-09','11:15:00',1.86),('15844','2014-03-09','11:20:00',1.33),('15844','2014-03-09','11:35:00',1.07),('15844','2014-03-09','11:40:00',1.53),('15844','2014-03-09','11:45:00',1.97),('15844','2014-03-09','11:50:00',1.03),('15844','2014-03-09','11:55:00',1.06),('15844','2014-03-09','12:00:00',1.19),('15844','2014-03-09','12:05:00',1.11),('15844','2014-03-09','12:15:00',1.1),('15844','2014-03-09','12:20:00',3),('15844','2014-03-09','12:25:00',3.34),('15844','2014-03-09','12:30:00',3.39),('15844','2014-03-09','12:35:00',3.4),('15844','2014-03-09','12:40:00',3.32),('15844','2014-03-09','12:45:00',2.98),('15844','2014-03-09','12:50:00',3.02),('15844','2014-03-09','12:55:00',3.03),('15844','2014-03-09','13:00:00',3.02),('15844','2014-03-09','13:05:00',3.08),('15844','2014-03-09','13:10:00',3.1),('15844','2014-03-09','13:15:00',2.96),('15844','2014-03-09','13:20:00',2.89),('15844','2014-03-09','13:25:00',2.8),('15844','2014-03-09','13:30:00',2.68),('15844','2014-03-09','13:35:00',2.58),('15844','2014-03-09','13:40:00',2.46),('15844','2014-03-09','13:45:00',2.35),('15844','2014-03-09','13:50:00',1.9),('15844','2014-03-09','14:15:00',1.57),('15844','2014-03-09','14:20:00',1.53),('15844','2014-03-09','14:25:00',1.5),('15844','2014-03-09','14:30:00',1.42),('15844','2014-03-09','14:35:00',1.4),('15844','2014-03-09','14:40:00',1.29),('15844','2014-03-09','14:45:00',1.28),('15844','2014-03-09','14:50:00',1.07),('15844','2014-03-09','14:55:00',1.01),('15844','2014-03-08','08:00:00',1.06),('15844','2014-03-08','08:05:00',1.12),('15844','2014-03-08','08:10:00',1.17),('15844','2014-03-08','08:15:00',1.26),('15844','2014-03-08','08:20:00',1.36),('15844','2014-03-08','08:25:00',1.5),('15844','2014-03-08','08:30:00',1.58),('15844','2014-03-08','08:35:00',1.68),('15844','2014-03-08','08:40:00',1.77),('15844','2014-03-08','08:45:00',1.83),('15844','2014-03-08','08:50:00',1.96),('15844','2014-03-08','08:55:00',2.08),('15844','2014-03-08','09:00:00',2.15),('15844','2014-03-08','09:05:00',2.23),('15844','2014-03-08','09:10:00',2.34),('15844','2014-03-08','09:15:00',2.43),('15844','2014-03-08','09:20:00',2.52),('15844','2014-03-08','09:25:00',2.59),('15844','2014-03-08','09:30:00',2.65),('15844','2014-03-08','09:35:00',2.7),('15844','2014-03-08','09:40:00',2.77),('15844','2014-03-08','09:45:00',2.8),('15844','2014-03-08','09:50:00',2.85),('15844','2014-03-08','09:55:00',2.93),('15844','2014-03-08','10:00:00',2.98),('15844','2014-03-08','10:05:00',2.98),('15844','2014-03-08','10:10:00',3.03),('15844','2014-03-08','10:15:00',3.07),('15844','2014-03-08','10:20:00',3.08),('15844','2014-03-08','10:25:00',3.13),('15844','2014-03-08','10:30:00',3.14),('15844','2014-03-08','10:35:00',3.18),('15844','2014-03-08','10:40:00',3.21),('15844','2014-03-08','10:45:00',3.25),('15844','2014-03-08','10:50:00',3.27),('15844','2014-03-08','10:55:00',3.3),('15844','2014-03-08','11:00:00',3.33),('15844','2014-03-08','11:05:00',3.35),('15844','2014-03-08','11:10:00',3.37),('15844','2014-03-08','11:15:00',3.39),('15844','2014-03-08','11:20:00',3.4),('15844','2014-03-08','11:25:00',3.39),('15844','2014-03-08','11:30:00',3.55),('15844','2014-03-08','11:35:00',3.7),('15844','2014-03-08','11:40:00',3.67),('15844','2014-03-08','11:45:00',2.72),('15844','2014-03-08','11:50:00',3.65),('15844','2014-03-08','11:55:00',3.19),('15844','2014-03-08','12:00:00',2.35),('15844','2014-03-08','12:05:00',2.65),('15844','2014-03-08','12:10:00',1.65),('15844','2014-03-08','12:15:00',1.4),('15844','2014-03-08','12:20:00',1.29),('15844','2014-03-08','12:25:00',1.18),('15844','2014-03-08','12:30:00',1.2),('15844','2014-03-08','12:35:00',1.22),('15844','2014-03-08','12:40:00',1.34),('15844','2014-03-08','12:45:00',1.47),('15844','2014-03-08','12:50:00',1.49),('15844','2014-03-08','12:55:00',1.38),('15844','2014-03-08','13:00:00',1.89),('15844','2014-03-08','13:05:00',2.47),('15844','2014-03-08','13:10:00',1.42),('15844','2014-03-08','13:15:00',1.2),('15844','2014-03-08','13:35:00',1.49),('15844','2014-03-08','13:40:00',2.3),('15844','2014-03-08','13:45:00',1.39),('15844','2014-03-08','13:50:00',2.15),('15844','2014-03-08','13:55:00',1.45),('15844','2014-03-08','14:00:00',1.07),('15844','2014-03-08','14:05:00',1.02),('15844','2014-03-08','15:25:00',1.21),('15844','2014-04-30','08:25:00',1.09),('15844','2014-04-30','08:30:00',1.22),('15844','2014-04-30','08:35:00',1.29),('15844','2014-04-30','08:40:00',1.36),('15844','2014-04-30','08:45:00',1.44),('15844','2014-04-30','08:50:00',1.49),('15844','2014-04-30','08:55:00',1.57),('15844','2014-04-30','09:00:00',1.49),('15844','2014-04-30','09:05:00',1.17),('15844','2014-04-30','09:10:00',1.65),('15844','2014-04-30','09:15:00',2.11),('15844','2014-04-30','09:20:00',2.21),('15844','2014-04-30','09:25:00',2.45),('15844','2014-04-30','09:30:00',2.59),('15844','2014-04-30','09:35:00',2.55),('15844','2014-04-30','09:40:00',1.47),('15844','2014-04-30','09:45:00',2.39),('15844','2014-04-30','09:50:00',1.32),('15844','2014-04-30','09:55:00',3.06),('15844','2014-04-30','10:00:00',2.55),('15844','2014-04-30','10:05:00',2.41),('15844','2014-04-30','10:10:00',2.68),('15844','2014-04-30','10:15:00',1.7),('15844','2014-04-30','10:20:00',2.44),('15844','2014-04-30','10:25:00',1.82),('15844','2014-04-30','10:30:00',1.65),('15844','2014-04-30','10:35:00',2.07),('15844','2014-04-30','10:40:00',2.83),('15844','2014-04-30','10:45:00',1.35),('15844','2014-04-30','10:50:00',4.12),('15844','2014-04-30','10:55:00',3.53),('15844','2014-04-30','11:00:00',2.06),('15844','2014-04-30','11:05:00',2.18),('15844','2014-04-30','11:10:00',3.03),('15844','2014-04-30','11:15:00',3.32),('15844','2014-04-30','11:20:00',3.04),('15844','2014-04-30','11:25:00',1.91),('15844','2014-04-30','11:30:00',2.47),('15844','2014-04-30','11:35:00',1.47),('15844','2014-04-30','11:40:00',2.15),('15844','2014-04-30','11:45:00',1.39),('15844','2014-04-30','11:50:00',3.6),('15844','2014-04-30','11:55:00',4.16),('15844','2014-04-30','12:00:00',1.91),('15844','2014-04-30','12:05:00',1.6),('15844','2014-04-30','12:10:00',1.11),('15844','2014-04-30','12:20:00',1.3),('15844','2014-04-30','12:25:00',2.46),('15844','2014-04-30','12:30:00',3.81),('15844','2014-04-30','12:35:00',4.22),('15844','2014-04-30','12:40:00',2.74),('15844','2014-04-30','12:45:00',3.51),('15844','2014-04-30','12:50:00',3.81),('15844','2014-04-30','12:55:00',2.95),('15844','2014-04-30','13:00:00',4.05),('15844','2014-04-30','13:05:00',1.33),('15844','2014-04-30','13:10:00',3.03),('15844','2014-04-30','13:15:00',3.6),('15844','2014-04-30','13:20:00',1.44),('15844','2014-04-30','13:25:00',3.62),('15844','2014-04-30','13:30:00',3.38),('15844','2014-04-30','13:35:00',3.48),('15844','2014-04-30','13:40:00',4.38),('15844','2014-04-30','13:45:00',2.93),('15844','2014-04-30','13:50:00',1.58),('15844','2014-04-30','13:55:00',1.55),('15844','2014-04-30','14:00:00',1.57),('15844','2014-04-30','14:05:00',1.47),('15844','2014-04-30','14:10:00',2.29),('15844','2014-04-30','14:15:00',2.68),('15844','2014-04-30','14:20:00',1.85),('15844','2014-04-30','14:25:00',1.39),('15844','2014-04-30','14:30:00',2.05),('15844','2014-04-30','14:35:00',1.41),('15844','2014-04-30','14:40:00',1.09),('15844','2014-04-30','14:45:00',1.04),('15844','2014-04-30','14:50:00',1.23),('15844','2014-04-30','14:55:00',1.58),('15844','2014-04-30','15:00:00',1.37),('15844','2014-04-30','15:05:00',1.49),('15844','2014-04-30','15:10:00',1.46),('15844','2014-04-30','15:15:00',1.41),('15844','2014-04-30','15:20:00',1.22),('15844','2014-04-30','15:25:00',1.34),('15844','2014-04-30','15:30:00',1.33),('15844','2014-04-30','15:35:00',2.18),('15844','2014-04-30','15:40:00',1.74),('15844','2014-04-30','15:45:00',2.54),('15844','2014-04-30','15:50:00',1.87),('15844','2014-04-30','15:55:00',1.41),('15844','2014-04-30','16:00:00',1.51),('15844','2014-04-30','16:05:00',1.25),('15844','2014-04-30','16:10:00',1.08),('15844','2014-04-30','16:15:00',1.34),('15844','2014-04-30','16:20:00',1.79),('15844','2014-04-30','16:25:00',1.36),('15844','2014-04-30','16:30:00',1.47),('15844','2014-04-30','16:35:00',1.42),('15844','2014-04-30','16:40:00',1.18),('15844','2014-04-30','16:45:00',1.05),('15844','2014-04-30','16:55:00',1.02),('15844','2014-03-07','10:00:00',1.92),('15844','2014-03-07','10:10:00',1.08),('15844','2014-03-07','10:20:00',2.31),('15844','2014-03-07','10:25:00',3.59),('15844','2014-03-07','10:30:00',2.77),('15844','2014-03-07','10:35:00',3.77),('15844','2014-03-07','10:40:00',2.81),('15844','2014-03-07','10:45:00',1.84),('15844','2014-03-07','10:50:00',2.66),('15844','2014-03-07','10:55:00',3.43),('15844','2014-03-07','11:00:00',3.27),('15844','2014-03-07','11:05:00',1.66),('15844','2014-03-07','11:10:00',1.79),('15844','2014-03-07','11:15:00',1.09),('15844','2014-03-07','11:20:00',2.59),('15844','2014-03-07','11:25:00',3.13),('15844','2014-03-07','11:30:00',1.77),('15844','2014-03-07','11:35:00',1.72),('15844','2014-03-07','11:40:00',1.48),('15844','2014-03-07','11:55:00',1.31),('15844','2014-03-07','12:00:00',1.71),('15844','2014-03-07','12:05:00',2.25),('15844','2014-03-07','12:10:00',1.41),('15844','2014-03-07','12:15:00',2.35),('15844','2014-03-07','12:20:00',3.26),('15844','2014-03-07','12:25:00',1.73),('15844','2014-03-07','12:45:00',2.12),('15844','2014-03-07','12:50:00',3.21),('15844','2014-03-07','12:55:00',3.06),('15844','2014-03-07','13:00:00',2.63),('15844','2014-03-07','13:05:00',1.85),('15844','2014-03-07','13:10:00',2.39),('15844','2014-03-07','13:15:00',3.22),('15844','2014-03-07','13:20:00',2.78),('15844','2014-03-07','13:25:00',1.81),('15844','2014-03-07','13:30:00',1.64),('15844','2014-03-07','13:35:00',1.77),('15844','2014-03-07','13:40:00',1.61),('15844','2014-03-07','13:45:00',1.4),('15844','2014-03-07','13:50:00',1.31),('15844','2014-03-07','13:55:00',1.21),('15844','2014-03-07','14:00:00',1.1),('15844','2014-03-07','14:05:00',1),('15844','2014-03-07','14:35:00',1.06),('15844','2014-03-07','14:40:00',1.14),('15844','2014-03-07','14:45:00',1.27),('15844','2014-03-07','14:50:00',1.43),('15844','2014-03-07','14:55:00',1.61),('15844','2014-03-07','15:00:00',1.61),('15844','2014-03-07','15:05:00',1.49),('15844','2014-03-07','15:10:00',1.34),('15844','2014-03-07','15:15:00',1.25),('15844','2014-03-07','15:20:00',1.12),('15844','2014-03-06','08:15:00',1.14),('15844','2014-03-06','08:50:00',1.47),('15844','2014-03-06','09:05:00',1.34),('15844','2014-03-06','09:25:00',1.17),('15844','2014-03-06','09:30:00',2.5),('15844','2014-03-06','09:35:00',1.99),('15844','2014-03-06','09:40:00',1.47),('15844','2014-03-06','09:45:00',1.56),('15844','2014-03-06','09:50:00',1.62),('15844','2014-03-06','09:55:00',1.75),('15844','2014-03-06','10:00:00',1.69),('15844','2014-03-06','10:05:00',1.94),('15844','2014-03-06','10:10:00',2.43),('15844','2014-03-06','10:15:00',2.53),('15844','2014-03-06','10:20:00',2.72),('15844','2014-03-06','10:25:00',3.22),('15844','2014-03-06','10:30:00',2.76),('15844','2014-03-06','10:35:00',3.48),('15844','2014-03-06','10:40:00',3.48),('15844','2014-03-06','10:45:00',3.4),('15844','2014-03-06','10:50:00',3.39),('15844','2014-03-06','10:55:00',3.4),('15844','2014-03-06','11:00:00',3.43),('15844','2014-03-06','11:05:00',3.56),('15844','2014-03-06','11:10:00',1.81),('15844','2014-03-06','11:15:00',2.24),('15844','2014-03-06','11:25:00',1.26),('15844','2014-03-06','11:30:00',1.21),('15844','2014-03-06','11:35:00',2.63),('15844','2014-03-06','11:40:00',1.36),('15844','2014-03-06','11:45:00',1.03),('15844','2014-03-06','11:50:00',1.13),('15844','2014-03-06','11:55:00',1.43),('15844','2014-03-06','12:00:00',1.7),('15844','2014-03-06','12:05:00',1.83),('15844','2014-03-06','12:10:00',1.58),('15844','2014-03-06','12:15:00',2.57),('15844','2014-03-06','12:20:00',2.13),('15844','2014-03-06','12:35:00',1.97),('15844','2014-03-06','12:50:00',1.17),('15844','2014-03-06','12:55:00',1.22),('15844','2014-03-06','13:00:00',1.51),('15844','2014-03-06','13:05:00',1.32),('15844','2014-03-06','13:10:00',1.1),('15844','2014-03-06','13:15:00',1.08),('15844','2014-03-06','14:10:00',1.03),('15844','2014-03-06','14:15:00',1.03),('15844','2014-03-06','14:20:00',1.05),('15844','2014-03-05','07:50:00',1.06),('15844','2014-03-05','07:55:00',1.13),('15844','2014-03-05','08:00:00',1.22),('15844','2014-03-05','08:05:00',1.3),('15844','2014-03-05','08:10:00',1.43),('15844','2014-03-05','08:15:00',1.38),('15844','2014-03-05','08:20:00',1.2),('15844','2014-03-05','08:25:00',1.84),('15844','2014-03-05','08:30:00',1.9),('15844','2014-03-05','08:35:00',1.58),('15844','2014-03-05','08:45:00',1.38),('15844','2014-03-05','08:50:00',1.28),('15844','2014-03-05','08:55:00',2.44),('15844','2014-03-05','09:00:00',2.55),('15844','2014-03-05','09:05:00',2.27),('15844','2014-03-05','09:10:00',2.32),('15844','2014-03-05','09:15:00',2.54),('15844','2014-03-05','09:20:00',2.6),('15844','2014-03-05','09:25:00',2.65),('15844','2014-03-05','09:30:00',2.71),('15844','2014-03-05','09:35:00',2.7),('15844','2014-03-05','09:40:00',2.78),('15844','2014-03-05','09:45:00',2.84),('15844','2014-03-05','09:50:00',2.87),('15844','2014-03-05','09:55:00',2.9),('15844','2014-03-05','10:00:00',2.95),('15844','2014-03-05','10:05:00',2.99),('15844','2014-03-05','10:10:00',3.01),('15844','2014-03-05','10:15:00',3.04),('15844','2014-03-05','10:20:00',3.07),('15844','2014-03-05','10:25:00',3.11),('15844','2014-03-05','10:30:00',3.16),('15844','2014-03-05','10:35:00',3.26),('15844','2014-03-05','10:40:00',3.24),('15844','2014-03-05','10:45:00',3.25),('15844','2014-03-05','10:50:00',3.26),('15844','2014-03-05','10:55:00',3.28),('15844','2014-03-05','11:00:00',3.31),('15844','2014-03-05','11:05:00',3.36),('15844','2014-03-05','11:10:00',3.39),('15844','2014-03-05','11:15:00',3.05),('15844','2014-03-05','11:20:00',3.26),('15844','2014-03-05','11:30:00',1.03),('15844','2014-03-05','11:35:00',1.16),('15844','2014-03-05','11:40:00',3.22),('15844','2014-03-05','11:45:00',2.39),('15844','2014-03-05','11:50:00',3.55),('15844','2014-03-05','11:55:00',3.44),('15844','2014-03-05','12:00:00',2.75),('15844','2014-03-05','12:05:00',2.73),('15844','2014-03-05','12:10:00',1.96),('15844','2014-03-05','12:15:00',2.59),('15844','2014-03-05','12:20:00',2.43),('15844','2014-03-05','12:25:00',2.59),('15844','2014-03-05','12:30:00',1.68),('15844','2014-03-05','12:35:00',2.58),('15844','2014-03-05','12:40:00',1.61),('15844','2014-03-05','12:45:00',1.75),('15844','2014-03-05','12:50:00',2),('15844','2014-03-05','12:55:00',1.39),('15844','2014-03-05','13:00:00',1.91),('15844','2014-03-05','13:05:00',2.06),('15844','2014-03-05','13:10:00',2.07),('15844','2014-03-05','13:15:00',2.26),('15844','2014-03-05','13:20:00',1.2),('15844','2014-03-05','13:25:00',1.76),('15844','2014-03-05','13:30:00',2.13),('15844','2014-03-05','13:35:00',2.43),('15844','2014-03-05','13:40:00',2.25),('15844','2014-03-05','13:45:00',2.75),('15844','2014-03-05','13:50:00',1.72),('15844','2014-03-05','13:55:00',1.44),('15844','2014-03-05','14:00:00',1.04),('15844','2014-03-05','14:05:00',1.03),('15844','2014-03-05','14:10:00',1.01),('15844','2014-03-05','14:20:00',1.13),('15844','2014-03-05','14:25:00',1.12),('15844','2014-03-05','14:30:00',1.09),('15844','2014-03-05','14:35:00',1.02),('15844','2014-03-05','14:55:00',1.08),('15844','2014-03-04','09:10:00',2.81),('15844','2014-03-04','09:20:00',1.01),('15844','2014-03-04','09:55:00',1.65),('15844','2014-03-04','10:00:00',1.39),('15844','2014-03-04','10:30:00',3.38),('15844','2014-03-04','10:35:00',2.02),('15844','2014-03-04','10:40:00',2.74),('15844','2014-03-04','10:45:00',2.58),('15844','2014-03-04','10:50:00',4.06),('15844','2014-03-04','10:55:00',4.15),('15844','2014-03-04','11:00:00',3.52),('15844','2014-03-04','11:05:00',3.33),('15844','2014-03-04','11:10:00',2.09),('15844','2014-03-04','11:25:00',1.32),('15844','2014-03-04','11:45:00',1.32),('15844','2014-03-04','11:50:00',3.23),('15844','2014-03-04','11:55:00',3.78),('15844','2014-03-04','12:00:00',2.71),('15844','2014-03-04','12:05:00',3.55),('15844','2014-03-04','12:10:00',3.15),('15844','2014-03-04','12:15:00',3.09),('15844','2014-03-04','12:20:00',2.87),('15844','2014-03-04','12:25:00',3.27),('15844','2014-03-04','12:30:00',3.13),('15844','2014-03-04','12:35:00',3.08),('15844','2014-03-04','12:40:00',3.13),('15844','2014-03-04','12:45:00',2.85),('15844','2014-03-04','12:50:00',3),('15844','2014-03-04','12:55:00',2.91),('15844','2014-03-04','13:00:00',2.91),('15844','2014-03-04','13:05:00',2.86),('15844','2014-03-04','13:10:00',2.78),('15844','2014-03-04','13:15:00',2.44),('15844','2014-03-04','13:20:00',2.42),('15844','2014-03-04','13:25:00',1.02),('15844','2014-03-04','13:40:00',1.06),('15844','2014-03-04','13:55:00',1.27),('15844','2014-03-04','14:00:00',1.33),('15844','2014-03-04','14:05:00',1.69),('15844','2014-03-04','14:10:00',1.82),('15844','2014-03-04','14:15:00',1.86),('15844','2014-03-04','14:20:00',1.65),('15844','2014-03-04','14:25:00',1.42),('15844','2014-03-04','14:30:00',1.22),('15844','2014-03-04','14:35:00',1.09),('15844','2014-03-04','14:40:00',1.02),('15844','2014-03-03','08:00:00',1.05),('15844','2014-03-03','08:05:00',1.2),('15844','2014-03-03','08:10:00',1.29),('15844','2014-03-03','08:15:00',1.38),('15844','2014-03-03','08:20:00',1.46),('15844','2014-03-03','08:25:00',1.54),('15844','2014-03-03','08:30:00',1.63),('15844','2014-03-03','08:35:00',1.7),('15844','2014-03-03','08:40:00',1.79),('15844','2014-03-03','08:45:00',1.85),('15844','2014-03-03','08:50:00',1.87),('15844','2014-03-03','08:55:00',1.97),('15844','2014-03-03','09:00:00',1.85),('15844','2014-03-03','09:05:00',1.72),('15844','2014-03-03','09:10:00',2.34),('15844','2014-03-03','09:15:00',2.46),('15844','2014-03-03','09:20:00',2.55),('15844','2014-03-03','09:25:00',2.57),('15844','2014-03-03','09:30:00',2.55),('15844','2014-03-03','09:35:00',2.58),('15844','2014-03-03','09:40:00',2.4),('15844','2014-03-03','09:45:00',2.67),('15844','2014-03-03','09:50:00',2.74),('15844','2014-03-03','09:55:00',2.85),('15844','2014-03-03','10:00:00',2.92),('15844','2014-03-03','10:05:00',2.9),('15844','2014-03-03','10:10:00',2.97),('15844','2014-03-03','10:15:00',3.02),('15844','2014-03-03','10:20:00',3.05),('15844','2014-03-03','10:25:00',3.06),('15844','2014-03-03','10:30:00',3.12),('15844','2014-03-03','10:35:00',3.17),('15844','2014-03-03','10:40:00',3.17),('15844','2014-03-03','10:45:00',3.2),('15844','2014-03-03','10:50:00',3.16),('15844','2014-03-03','10:55:00',3.23),('15844','2014-03-03','11:00:00',3.25),('15844','2014-03-03','11:05:00',3.24),('15844','2014-03-03','11:10:00',3.24),('15844','2014-03-03','11:15:00',3.26),('15844','2014-03-03','11:20:00',3.28),('15844','2014-03-03','11:25:00',3.27),('15844','2014-03-03','11:30:00',3.24),('15844','2014-03-03','11:35:00',3.23),('15844','2014-03-03','11:40:00',3.24),('15844','2014-03-03','11:45:00',3.25),('15844','2014-03-03','11:50:00',3.22),('15844','2014-03-03','11:55:00',3.22),('15844','2014-03-03','12:00:00',3.19),('15844','2014-03-03','12:05:00',3.17),('15844','2014-03-03','12:10:00',3.17),('15844','2014-03-03','12:15:00',3.15),('15844','2014-03-03','12:20:00',3.11),('15844','2014-03-03','12:25:00',3.09),('15844','2014-03-03','12:30:00',3.04),('15844','2014-03-03','12:35:00',3.02),('15844','2014-03-03','12:40:00',3.03),('15844','2014-03-03','12:45:00',2.96),('15844','2014-03-03','12:50:00',2.89),('15844','2014-03-03','12:55:00',2.84),('15844','2014-03-03','13:00:00',2.79),('15844','2014-03-03','13:05:00',2.71),('15844','2014-03-03','13:10:00',2.64),('15844','2014-03-03','13:15:00',2.58),('15844','2014-03-03','13:20:00',2.49),('15844','2014-03-03','13:25:00',2.39),('15844','2014-03-03','13:30:00',2.32),('15844','2014-03-03','13:35:00',2.25),('15844','2014-03-03','13:40:00',1.81),('15844','2014-03-03','13:45:00',1.97),('15844','2014-03-03','13:50:00',1.82),('15844','2014-03-03','13:55:00',1.88),('15844','2014-03-03','14:00:00',1.77),('15844','2014-03-03','14:05:00',1.6),('15844','2014-03-03','14:10:00',1.59),('15844','2014-03-03','14:15:00',1.5),('15844','2014-03-03','14:20:00',1.28),('15844','2014-03-03','14:30:00',1.21),('15844','2014-03-03','14:35:00',1.05),('15844','2014-03-02','08:25:00',1.62),('15844','2014-03-02','08:30:00',1.62),('15844','2014-03-02','08:35:00',1.71),('15844','2014-03-02','08:40:00',1.82),('15844','2014-03-02','08:45:00',1.93),('15844','2014-03-02','08:50:00',2.03),('15844','2014-03-02','08:55:00',2.14),('15844','2014-03-02','09:00:00',2.22),('15844','2014-03-02','09:05:00',2.35),('15844','2014-03-02','09:10:00',2.33),('15844','2014-03-02','09:15:00',2.44),('15844','2014-03-02','09:20:00',2.64),('15844','2014-03-02','09:25:00',2.37),('15844','2014-03-02','09:30:00',2.02),('15844','2014-03-02','09:35:00',2.52),('15844','2014-03-02','10:15:00',1.16),('15844','2014-03-02','10:20:00',1.89),('15844','2014-03-02','10:25:00',2.78),('15844','2014-03-02','10:30:00',3.76),('15844','2014-03-02','10:35:00',3.92),('15844','2014-03-02','10:40:00',3.72),('15844','2014-03-02','10:45:00',3.2),('15844','2014-03-02','10:50:00',2.5),('15844','2014-03-02','10:55:00',1.33),('15844','2014-03-02','11:00:00',1.89),('15844','2014-03-02','11:05:00',4.27),('15844','2014-03-02','11:10:00',3.11),('15844','2014-03-02','11:15:00',3.42),('15844','2014-03-02','11:20:00',2.7),('15844','2014-03-02','11:25:00',1.64),('15844','2014-03-02','11:30:00',1.52),('15844','2014-03-02','11:35:00',1.48),('15844','2014-03-02','11:40:00',1.81),('15844','2014-03-02','11:45:00',2.84),('15844','2014-03-02','11:50:00',2.71),('15844','2014-03-02','11:55:00',3.93),('15844','2014-03-02','12:00:00',3.1),('15844','2014-03-02','12:05:00',3.41),('15844','2014-03-02','12:10:00',1.89),('15844','2014-03-02','12:15:00',1.6),('15844','2014-03-02','12:20:00',1.8),('15844','2014-03-02','12:25:00',1.19),('15844','2014-02-28','08:15:00',1.09),('15844','2014-02-28','08:30:00',1.3),('15844','2014-02-28','09:20:00',1.86),('15844','2014-02-28','09:25:00',1.82),('15844','2014-02-28','09:30:00',1.2),('15844','2014-02-28','09:35:00',2.84),('15844','2014-02-28','09:40:00',2.43),('15844','2014-02-28','09:45:00',1.32),('15844','2014-02-28','09:50:00',1.23),('15844','2014-02-28','09:55:00',1.1),('15844','2014-02-28','10:10:00',1.06),('15844','2014-02-28','10:15:00',3.21),('15844','2014-02-28','10:20:00',3.41),('15844','2014-02-28','10:25:00',2.1),('15844','2014-02-28','10:35:00',1.1),('15844','2014-02-28','11:05:00',1.3),('15844','2014-02-28','11:10:00',1.2),('15844','2014-02-28','11:15:00',1.28),('15844','2014-02-28','11:20:00',1.55),('15844','2014-02-28','11:25:00',1.32),('15844','2014-02-28','11:50:00',1.05),('15844','2014-02-28','11:55:00',1.23),('15844','2014-02-28','12:00:00',1.68),('15844','2014-02-28','12:05:00',1.08),('15844','2014-02-28','12:20:00',1.49),('15844','2014-02-28','12:25:00',1.95),('15844','2014-02-28','12:30:00',2.81),('15844','2014-02-28','12:35:00',1.91),('15844','2014-02-28','12:40:00',1.34),('15844','2014-02-28','12:45:00',2.19),('15844','2014-02-28','12:50:00',1.51),('15844','2014-02-28','12:55:00',2.45),('15844','2014-02-28','13:00:00',1.17),('15844','2014-02-28','13:05:00',1.27),('15844','2014-02-28','13:10:00',1.04),('15844','2014-02-28','14:15:00',1.15),('15844','2014-02-28','14:20:00',1.1),('15844','2014-02-28','14:25:00',1.13),('15844','2014-02-28','14:30:00',1.18),('15844','2014-02-28','14:35:00',1.04),('15844','2014-02-28','14:50:00',1.08),('15844','2014-02-28','15:20:00',1.02),('15844','2014-02-27','10:40:00',1.06),('15844','2014-02-27','10:45:00',1.07),('15844','2014-02-27','10:50:00',1.1),('15844','2014-02-27','10:55:00',1.29),('15844','2014-02-27','11:00:00',1.49),('15844','2014-02-27','11:05:00',1.42),('15844','2014-02-27','11:10:00',1.32),('15844','2014-02-27','11:15:00',1.11),('15844','2014-02-27','11:20:00',1.16),('15844','2014-02-27','11:25:00',1.48),('15844','2014-02-27','11:30:00',1.32),('15844','2014-02-27','11:35:00',1.1),('15844','2014-02-27','11:50:00',1.1),('15844','2014-02-27','11:55:00',1.1),('15844','2014-02-27','12:00:00',1),('15844','2014-02-27','12:05:00',1.1),('15844','2014-02-27','12:10:00',1.12),('15844','2014-02-27','12:15:00',1.13),('15844','2014-02-27','12:20:00',1.11),('15844','2014-02-27','12:25:00',1.08),('15844','2014-02-27','12:30:00',1.06),('15844','2014-02-27','12:35:00',1.01),('15844','2014-02-27','12:50:00',1.01),('15844','2014-02-27','12:55:00',1.01),('15844','2014-02-27','13:25:00',1.09),('15844','2014-02-27','13:30:00',1.25),('15844','2014-02-27','13:35:00',1.4),('15844','2014-02-27','13:40:00',1.37),('15844','2014-02-27','13:45:00',1.27),('15844','2014-02-27','13:50:00',1.42),('15844','2014-02-27','13:55:00',1.7),('15844','2014-02-27','14:00:00',1.64),('15844','2014-02-27','14:05:00',1.23),('15844','2014-02-27','14:10:00',1.11),('15844','2014-02-27','14:15:00',1.01),('15844','2014-02-27','14:45:00',1.04),('15844','2014-02-27','14:50:00',1.01),('15844','2014-02-27','14:55:00',1.02),('15844','2014-02-27','15:00:00',1.08),('15844','2014-02-27','15:05:00',1.12),('15844','2014-02-27','15:10:00',1.17),('15844','2014-02-27','15:15:00',1.14),('15844','2014-02-27','15:20:00',1.08),('15844','2014-02-26','08:10:00',1.06),('15844','2014-02-26','08:15:00',1.14),('15844','2014-02-26','08:20:00',1.19),('15844','2014-02-26','08:25:00',1.3),('15844','2014-02-26','08:30:00',1.39),('15844','2014-02-26','08:35:00',1.49),('15844','2014-02-26','08:40:00',1.54),('15844','2014-02-26','08:45:00',1.34),('15844','2014-02-26','08:50:00',1.71),('15844','2014-02-26','08:55:00',1.76),('15844','2014-02-26','09:00:00',1.89),('15844','2014-02-26','09:05:00',1.91),('15844','2014-02-26','09:10:00',1.87),('15844','2014-02-26','09:15:00',2.11),('15844','2014-02-26','09:20:00',1.93),('15844','2014-02-26','09:25:00',1.39),('15844','2014-02-26','09:30:00',2.16),('15844','2014-02-26','09:35:00',1.78),('15844','2014-02-26','09:40:00',1.49),('15844','2014-02-26','09:45:00',1.67),('15844','2014-02-26','09:50:00',1.3),('15844','2014-02-26','09:55:00',1.03),('15844','2014-02-26','12:15:00',1.08),('15844','2014-02-26','12:20:00',1.1),('15844','2014-02-26','12:25:00',1.21),('15844','2014-02-26','12:30:00',1.62),('15844','2014-02-26','12:35:00',3.31),('15844','2014-02-26','12:40:00',3.04),('15844','2014-02-26','12:45:00',2.95),('15844','2014-02-26','12:50:00',2.69),('15844','2014-02-26','12:55:00',2.6),('15844','2014-02-26','13:00:00',2.1),('15844','2014-02-26','13:05:00',1.43),('15844','2014-02-26','13:20:00',2.41),('15844','2014-02-26','13:25:00',2.5),('15844','2014-02-26','13:30:00',2.02),('15844','2014-02-26','13:35:00',2.32),('15844','2014-02-26','13:40:00',1.99),('15844','2014-02-26','13:45:00',1.78),('15844','2014-02-26','13:50:00',1.14),('15844','2014-02-26','13:55:00',1.96),('15844','2014-02-26','14:00:00',1.68),('15844','2014-02-26','14:05:00',1.38),('15844','2014-02-26','14:10:00',1.78),('15844','2014-02-26','14:15:00',1.97),('15844','2014-02-26','14:20:00',1.58),('15844','2014-02-26','14:25:00',1.03),('15844','2014-02-26','14:35:00',1.12),('15844','2014-02-26','14:40:00',1.01),('15844','2014-02-26','14:45:00',1.12),('15844','2014-04-29','09:50:00',1.12),('15844','2014-04-29','09:55:00',2.16),('15844','2014-04-29','10:00:00',3.21),('15844','2014-04-29','10:05:00',3.23),('15844','2014-04-29','10:10:00',2.95),('15844','2014-04-29','10:15:00',2.33),('15844','2014-04-29','10:20:00',3.22),('15844','2014-04-29','10:25:00',3.79),('15844','2014-04-29','10:30:00',3.85),('15844','2014-04-29','10:35:00',3.97),('15844','2014-04-29','10:40:00',4.04),('15844','2014-04-29','10:45:00',3.58),('15844','2014-04-29','10:50:00',3.64),('15844','2014-04-29','10:55:00',4.36),('15844','2014-04-29','11:00:00',4.11),('15844','2014-04-29','11:05:00',4.47),('15844','2014-04-29','11:10:00',3.29),('15844','2014-04-29','11:15:00',4.54),('15844','2014-04-29','11:20:00',4.5),('15844','2014-04-29','11:25:00',4.18),('15844','2014-04-29','11:30:00',3.92),('15844','2014-04-29','11:35:00',1.62),('15844','2014-04-29','11:40:00',1.58),('15844','2014-04-29','11:45:00',2.51),('15844','2014-04-29','12:00:00',1.03),('15844','2014-04-29','12:05:00',2.11),('15844','2014-04-29','12:10:00',4.13),('15844','2014-04-29','12:15:00',2.88),('15844','2014-04-29','12:20:00',2.41),('15844','2014-04-29','12:25:00',3.16),('15844','2014-04-29','12:30:00',2.5),('15844','2014-04-29','12:35:00',2.08),('15844','2014-04-29','12:40:00',1.93),('15844','2014-04-29','12:45:00',1.78),('15844','2014-04-29','12:50:00',4.18),('15844','2014-04-29','12:55:00',1.65),('15844','2014-04-29','13:00:00',1.86),('15844','2014-04-29','13:05:00',4.03),('15844','2014-04-29','13:10:00',3.72),('15844','2014-04-29','13:15:00',1.59),('15844','2014-04-29','13:20:00',3.95),('15844','2014-04-29','13:25:00',4.55),('15844','2014-04-29','13:30:00',1.43),('15844','2014-04-29','13:35:00',2.65),('15844','2014-04-29','13:40:00',1.44),('15844','2014-04-29','13:45:00',1.41),('15844','2014-04-29','13:50:00',1.2),('15844','2014-04-29','15:05:00',1.08),('15844','2014-04-29','15:10:00',1.28),('15844','2014-04-29','15:15:00',1.74),('15844','2014-04-29','15:40:00',1.17),('15844','2014-02-25','08:15:00',1.09),('15844','2014-02-25','08:20:00',1.18),('15844','2014-02-25','08:25:00',1.25),('15844','2014-02-25','08:30:00',1.31),('15844','2014-02-25','08:35:00',1.39),('15844','2014-02-25','08:40:00',1.47),('15844','2014-02-25','08:45:00',1.58),('15844','2014-02-25','08:50:00',1.7),('15844','2014-02-25','08:55:00',1.8),('15844','2014-02-25','09:00:00',1.87),('15844','2014-02-25','09:05:00',1.93),('15844','2014-02-25','09:10:00',2),('15844','2014-02-25','09:15:00',2.08),('15844','2014-02-25','09:20:00',2.17),('15844','2014-02-25','09:25:00',2.24),('15844','2014-02-25','09:30:00',2.32),('15844','2014-02-25','09:35:00',2.38),('15844','2014-02-25','09:40:00',2.43),('15844','2014-02-25','09:45:00',2.47),('15844','2014-02-25','09:50:00',2.52),('15844','2014-02-25','09:55:00',2.54),('15844','2014-02-25','10:00:00',2.56),('15844','2014-02-25','10:05:00',2.61),('15844','2014-02-25','10:10:00',2.65),('15844','2014-02-25','10:15:00',2.71),('15844','2014-02-25','10:20:00',2.74),('15844','2014-02-25','10:25:00',2.75),('15844','2014-02-25','10:30:00',2.78),('15844','2014-02-25','10:35:00',2.85),('15844','2014-02-25','10:40:00',2.91),('15844','2014-02-25','10:45:00',2.93),('15844','2014-02-25','10:50:00',2.94),('15844','2014-02-25','10:55:00',2.98),('15844','2014-02-25','11:00:00',3.01),('15844','2014-02-25','11:05:00',3.02),('15844','2014-02-25','11:10:00',3),('15844','2014-02-25','11:15:00',2.97),('15844','2014-02-25','11:20:00',2.95),('15844','2014-02-25','11:25:00',2.95),('15844','2014-02-25','11:30:00',2.94),('15844','2014-02-25','11:35:00',2.87),('15844','2014-02-25','11:40:00',2.91),('15844','2014-02-25','11:45:00',2.97),('15844','2014-02-25','11:50:00',2.96),('15844','2014-02-25','11:55:00',2.91),('15844','2014-02-25','12:00:00',2.89),('15844','2014-02-25','12:05:00',2.91),('15844','2014-02-25','12:10:00',2.86),('15844','2014-02-25','12:15:00',2.79),('15844','2014-02-25','12:20:00',2.74),('15844','2014-02-25','12:25:00',2.7),('15844','2014-02-25','12:30:00',2.69),('15844','2014-02-25','12:35:00',2.66),('15844','2014-02-25','12:40:00',2.69),('15844','2014-02-25','12:45:00',2.67),('15844','2014-02-25','12:50:00',2.6),('15844','2014-02-25','12:55:00',2.54),('15844','2014-02-25','13:00:00',2.54),('15844','2014-02-25','13:05:00',2.46),('15844','2014-02-25','13:10:00',2.4),('15844','2014-02-25','13:15:00',2.26),('15844','2014-02-25','13:20:00',1.76),('15844','2014-02-25','13:25:00',1.9),('15844','2014-02-25','13:30:00',2.49),('15844','2014-02-25','13:35:00',2.24),('15844','2014-02-25','13:40:00',2.08),('15844','2014-02-25','13:45:00',1.4),('15844','2014-02-25','13:50:00',1.46),('15844','2014-02-25','13:55:00',1.14),('15844','2014-02-25','14:05:00',1.62),('15844','2014-02-25','14:10:00',1.65),('15844','2014-02-25','14:15:00',1.41),('15844','2014-02-25','14:20:00',1.19),('15844','2014-02-25','14:25:00',1.12),('15844','2014-02-25','14:30:00',1.02),('15844','2014-02-25','14:35:00',1.07),('15844','2014-02-25','14:40:00',1.05),('15844','2014-02-25','14:45:00',1.03),('15844','2014-02-25','14:50:00',1),('15844','2014-02-24','08:05:00',1.14),('15844','2014-02-24','08:10:00',1.25),('15844','2014-02-24','08:15:00',1.15),('15844','2014-02-24','08:50:00',1.14),('15844','2014-02-24','08:55:00',2.01),('15844','2014-02-24','09:00:00',2),('15844','2014-02-24','09:05:00',2.02),('15844','2014-02-24','09:10:00',2.07),('15844','2014-02-24','09:15:00',2.14),('15844','2014-02-24','09:20:00',2.21),('15844','2014-02-24','09:25:00',2.29),('15844','2014-02-24','09:30:00',2.36),('15844','2014-02-24','09:35:00',2.41),('15844','2014-02-24','09:40:00',2.45),('15844','2014-02-24','09:45:00',2.54),('15844','2014-02-24','09:50:00',2.59),('15844','2014-02-24','09:55:00',2.65),('15844','2014-02-24','10:00:00',2.69),('15844','2014-02-24','10:05:00',2.73),('15844','2014-02-24','10:10:00',2.77),('15844','2014-02-24','10:15:00',2.78),('15844','2014-02-24','10:20:00',2.81),('15844','2014-02-24','10:25:00',2.84),('15844','2014-02-24','10:30:00',2.88),('15844','2014-02-24','10:35:00',2.91),('15844','2014-02-24','10:40:00',2.94),('15844','2014-02-24','10:45:00',2.96),('15844','2014-02-24','10:50:00',2.99),('15844','2014-02-24','10:55:00',2.99),('15844','2014-02-24','11:00:00',3.03),('15844','2014-02-24','11:05:00',3.02),('15844','2014-02-24','11:10:00',3.03),('15844','2014-02-24','11:15:00',3.04),('15844','2014-02-24','11:20:00',3.06),('15844','2014-02-24','11:25:00',3.16),('15844','2014-02-24','11:30:00',3.33),('15844','2014-02-24','11:35:00',2.97),('15844','2014-02-24','11:40:00',2.56),('15844','2014-02-24','11:45:00',1.64),('15844','2014-02-24','11:50:00',2.51),('15844','2014-02-24','11:55:00',2.96),('15844','2014-02-24','12:00:00',3.04),('15844','2014-02-24','12:05:00',2.99),('15844','2014-02-24','12:10:00',2.99),('15844','2014-02-24','12:15:00',2.92),('15844','2014-02-24','12:20:00',2.9),('15844','2014-02-24','12:25:00',2.89),('15844','2014-02-24','12:30:00',2.89),('15844','2014-02-24','12:35:00',2.84),('15844','2014-02-24','12:40:00',2.79),('15844','2014-02-24','12:45:00',2.81),('15844','2014-02-24','12:50:00',2.77),('15844','2014-02-24','12:55:00',2.81),('15844','2014-02-24','13:00:00',2.96),('15844','2014-02-24','13:05:00',3.18),('15844','2014-02-24','13:10:00',2.38),('15844','2014-02-24','13:15:00',1.02),('15844','2014-02-24','14:05:00',1.01),('15844','2014-02-24','14:10:00',1.13),('15844','2014-02-24','14:15:00',1.09),('15844','2014-02-24','14:20:00',1.07),('15844','2014-02-24','14:25:00',1.09),('15844','2014-02-24','15:15:00',1.14),('15844','2014-02-24','15:20:00',1.02),('15844','2014-02-23','08:10:00',1.01),('15844','2014-02-23','08:15:00',1.1),('15844','2014-02-23','08:20:00',1.18),('15844','2014-02-23','08:25:00',1.27),('15844','2014-02-23','08:30:00',1.32),('15844','2014-02-23','08:35:00',1.4),('15844','2014-02-23','08:40:00',1.46),('15844','2014-02-23','08:45:00',1.55),('15844','2014-02-23','08:50:00',1.66),('15844','2014-02-23','08:55:00',1.78),('15844','2014-02-23','09:00:00',1.86),('15844','2014-02-23','09:05:00',1.93),('15844','2014-02-23','09:10:00',2.03),('15844','2014-02-23','09:15:00',2.12),('15844','2014-02-23','09:20:00',2.12),('15844','2014-02-23','09:25:00',1.9),('15844','2014-02-23','09:30:00',2.21),('15844','2014-02-23','09:35:00',2.37),('15844','2014-02-23','09:40:00',2.42),('15844','2014-02-23','09:45:00',2.45),('15844','2014-02-23','09:50:00',2.53),('15844','2014-02-23','09:55:00',2.56),('15844','2014-02-23','10:00:00',2.58),('15844','2014-02-23','10:05:00',2.62),('15844','2014-02-23','10:10:00',2.68),('15844','2014-02-23','10:15:00',2.71),('15844','2014-02-23','10:20:00',2.74),('15844','2014-02-23','10:25:00',2.78),('15844','2014-02-23','10:30:00',2.83),('15844','2014-02-23','10:35:00',2.88),('15844','2014-02-23','10:40:00',2.91),('15844','2014-02-23','10:45:00',2.95),('15844','2014-02-23','10:50:00',2.97),('15844','2014-02-23','10:55:00',2.95),('15844','2014-02-23','11:00:00',2.92),('15844','2014-02-23','11:05:00',2.96),('15844','2014-02-23','11:10:00',2.94),('15844','2014-02-23','11:15:00',2.8),('15844','2014-02-23','11:20:00',3.05),('15844','2014-02-23','11:25:00',2.35),('15844','2014-02-23','11:30:00',2.91),('15844','2014-02-23','11:35:00',3.1),('15844','2014-02-23','11:40:00',3.09),('15844','2014-02-23','11:45:00',3.12),('15844','2014-02-23','11:50:00',2.16),('15844','2014-02-23','11:55:00',3.04),('15844','2014-02-23','12:00:00',3),('15844','2014-02-23','12:05:00',2.99),('15844','2014-02-23','12:10:00',3.17),('15844','2014-02-23','12:15:00',2.81),('15844','2014-02-23','12:20:00',1.75),('15844','2014-02-23','12:25:00',1.82),('15844','2014-02-23','12:30:00',2.11),('15844','2014-02-23','12:35:00',1.76),('15844','2014-02-23','12:40:00',1.94),('15844','2014-02-23','12:45:00',1.74),('15844','2014-02-23','12:50:00',1.81),('15844','2014-02-23','12:55:00',2.27),('15844','2014-02-23','13:00:00',2.73),('15844','2014-02-23','13:05:00',2.57),('15844','2014-02-23','13:10:00',2.47),('15844','2014-02-23','13:15:00',2.43),('15844','2014-02-23','13:20:00',2.41),('15844','2014-02-23','13:25:00',2.05),('15844','2014-02-23','13:30:00',1.84),('15844','2014-02-23','13:35:00',1.01),('15844','2014-02-23','13:40:00',1.49),('15844','2014-02-23','13:45:00',1.82),('15844','2014-02-23','13:50:00',1.46),('15844','2014-02-23','13:55:00',1.42),('15844','2014-02-23','14:00:00',1.33),('15844','2014-02-23','14:05:00',1.76),('15844','2014-02-23','14:10:00',1.13),('15844','2014-02-23','14:15:00',1.09),('15844','2014-02-23','14:20:00',1.32),('15844','2014-02-23','14:25:00',1.06),('15844','2014-02-23','14:30:00',1.21),('15844','2014-02-23','14:35:00',1.65),('15844','2014-02-23','14:40:00',1.72),('15844','2014-02-23','14:45:00',1.61),('15844','2014-02-23','14:50:00',1.28),('15844','2014-02-23','15:20:00',1.07),('15844','2014-02-23','15:25:00',1.04),('15844','2014-02-23','15:35:00',1.05),('15844','2014-02-22','09:40:00',2.26),('15844','2014-02-22','09:45:00',1.55),('15844','2014-02-22','09:50:00',1.18),('15844','2014-02-22','09:55:00',1.08),('15844','2014-02-22','10:00:00',1.2),('15844','2014-02-22','10:05:00',1.75),('15844','2014-02-22','10:10:00',1.03),('15844','2014-02-22','10:20:00',1),('15844','2014-02-22','10:25:00',1.56),('15844','2014-02-22','10:30:00',1.77),('15844','2014-02-22','10:35:00',2.58),('15844','2014-02-22','10:40:00',2.78),('15844','2014-02-22','10:45:00',1.87),('15844','2014-02-22','12:00:00',1.01),('15844','2014-02-22','12:05:00',1.2),('15844','2014-02-22','12:10:00',1.2),('15844','2014-02-22','12:15:00',1.69),('15844','2014-02-22','12:20:00',1.42),('15844','2014-02-22','12:30:00',1.14),('15844','2014-02-22','12:35:00',1.64),('15844','2014-02-22','12:40:00',2.71),('15844','2014-02-22','12:45:00',2.99),('15844','2014-02-22','12:50:00',2.59),('15844','2014-02-22','12:55:00',1.35),('15844','2014-02-22','13:00:00',1.65),('15844','2014-02-22','13:05:00',2.61),('15844','2014-02-22','13:15:00',1.25),('15844','2014-02-22','13:20:00',1.87),('15844','2014-02-22','13:25:00',1),('15844','2014-02-22','13:30:00',1.43),('15844','2014-02-22','13:35:00',2.18),('15844','2014-02-22','13:40:00',2.33),('15844','2014-02-22','13:45:00',1.06),('15844','2014-02-22','13:50:00',1.67),('15844','2014-02-22','13:55:00',1.49),('15844','2014-02-22','14:00:00',1.81),('15844','2014-02-22','14:10:00',1.51),('15844','2014-02-22','14:15:00',1.73),('15844','2014-02-22','14:20:00',1.3),('15844','2014-02-22','14:25:00',1.69),('15844','2014-02-22','14:30:00',1.11),('15844','2014-02-22','15:00:00',1.02),('15844','2014-02-22','15:05:00',1),('15844','2014-02-21','09:45:00',1.06),('15844','2014-02-21','09:50:00',1.22),('15844','2014-02-21','09:55:00',1.29),('15844','2014-02-21','10:00:00',1.19),('15844','2014-02-21','10:05:00',1.34),('15844','2014-02-21','10:10:00',1.63),('15844','2014-02-21','10:15:00',1.63),('15844','2014-02-21','10:20:00',1.71),('15844','2014-02-21','10:25:00',1.83),('15844','2014-02-21','10:30:00',1.43),('15844','2014-02-21','10:35:00',1.25),('15844','2014-02-21','10:40:00',1.69),('15844','2014-02-21','10:45:00',1.79),('15844','2014-02-21','10:50:00',3.02),('15844','2014-02-21','10:55:00',3.02),('15844','2014-02-21','11:00:00',3.29),('15844','2014-02-21','11:05:00',1.85),('15844','2014-02-21','11:10:00',1.41),('15844','2014-02-21','11:15:00',2.19),('15844','2014-02-21','11:20:00',2.14),('15844','2014-02-21','11:25:00',1.87),('15844','2014-02-21','11:30:00',2.98),('15844','2014-02-21','11:35:00',2.63),('15844','2014-02-21','11:40:00',1.6),('15844','2014-02-21','11:45:00',2.56),('15844','2014-02-21','11:50:00',1.62),('15844','2014-02-21','11:55:00',1.11),('15844','2014-02-21','12:00:00',1.17),('15844','2014-02-21','12:05:00',1.17),('15844','2014-02-21','12:10:00',1.06),('15844','2014-02-21','12:15:00',1.04),('15844','2014-02-21','14:35:00',1.1),('15844','2014-02-21','14:40:00',1.03),('15844','2014-02-20','13:15:00',1.26),('15844','2014-02-20','13:30:00',1.06),('15844','2014-02-19','09:40:00',1.02),('15844','2014-02-19','09:45:00',1.23),('15844','2014-02-19','09:50:00',1.16),('15844','2014-02-19','09:55:00',1.05),('15844','2014-02-19','10:00:00',1.07),('15844','2014-02-19','10:05:00',1.08),('15844','2014-02-19','10:10:00',1.21),('15844','2014-02-19','10:15:00',1.31),('15844','2014-02-19','10:20:00',1.19),('15844','2014-02-19','10:25:00',1.17),('15844','2014-02-19','10:30:00',1.05),('15844','2014-02-19','10:35:00',1.12),('15844','2014-02-19','10:40:00',1.32),('15844','2014-02-19','10:45:00',1.3),('15844','2014-02-19','10:50:00',1.49),('15844','2014-02-19','10:55:00',1.3),('15844','2014-02-19','12:05:00',1.1),('15844','2014-02-19','12:10:00',1.02),('15844','2014-02-19','12:40:00',1.06),('15844','2014-02-19','12:45:00',1.24),('15844','2014-02-19','12:50:00',1.37),('15844','2014-02-19','12:55:00',1.14),('15844','2014-02-19','13:00:00',1.36),('15844','2014-02-19','13:05:00',1.38),('15844','2014-02-19','13:10:00',1.25),('15844','2014-02-19','13:15:00',1.44),('15844','2014-02-19','13:20:00',1.25),('15844','2014-02-19','13:25:00',1.36),('15844','2014-02-19','13:30:00',1.23),('15844','2014-02-19','13:35:00',1.33),('15844','2014-02-19','13:40:00',1.41),('15844','2014-02-19','13:45:00',1.48),('15844','2014-02-19','13:50:00',1.4),('15844','2014-02-19','13:55:00',1.4),('15844','2014-02-19','14:00:00',1.21),('15844','2014-02-19','14:20:00',1.12),('15844','2014-02-18','08:20:00',1.06),('15844','2014-02-18','08:25:00',1.15),('15844','2014-02-18','08:30:00',1.22),('15844','2014-02-18','08:35:00',1.28),('15844','2014-02-18','08:40:00',1.36),('15844','2014-02-18','08:45:00',1.43),('15844','2014-02-18','08:50:00',1.52),('15844','2014-02-18','08:55:00',1.61),('15844','2014-02-18','09:00:00',1.69),('15844','2014-02-18','09:05:00',1.75),('15844','2014-02-18','09:10:00',1.81),('15844','2014-02-18','09:15:00',1.88),('15844','2014-02-18','09:20:00',1.95),('15844','2014-02-18','09:25:00',2.06),('15844','2014-02-18','09:30:00',2.14),('15844','2014-02-18','09:35:00',2.2),('15844','2014-02-18','09:40:00',2.25),('15844','2014-02-18','09:45:00',2.28),('15844','2014-02-18','09:50:00',2.32),('15844','2014-02-18','09:55:00',2.36),('15844','2014-02-18','10:00:00',2.41),('15844','2014-02-18','10:05:00',2.44),('15844','2014-02-18','10:10:00',2.46),('15844','2014-02-18','10:15:00',2.49),('15844','2014-02-18','10:20:00',2.49),('15844','2014-02-18','10:25:00',2.49),('15844','2014-02-18','10:30:00',2.55),('15844','2014-02-18','10:35:00',2.61),('15844','2014-02-18','10:40:00',2.68),('15844','2014-02-18','10:45:00',2.71),('15844','2014-02-18','10:50:00',2.73),('15844','2014-02-18','10:55:00',2.79),('15844','2014-02-18','11:00:00',2.82),('15844','2014-02-18','11:05:00',2.5),('15844','2014-02-18','11:10:00',2.42),('15844','2014-02-18','11:15:00',2.35),('15844','2014-02-18','11:20:00',2.68),('15844','2014-02-18','11:25:00',2.85),('15844','2014-02-18','11:30:00',2.8),('15844','2014-02-18','11:35:00',2.01),('15844','2014-02-18','11:40:00',1.38),('15844','2014-02-18','11:45:00',1.42),('15844','2014-02-18','11:50:00',1.22),('15844','2014-02-18','11:55:00',1.22),('15844','2014-02-18','12:00:00',1.22),('15844','2014-02-18','12:05:00',1.19),('15844','2014-02-18','12:10:00',1.28),('15844','2014-02-18','12:15:00',1.41),('15844','2014-02-18','12:20:00',1.46),('15844','2014-02-18','12:25:00',1.61),('15844','2014-02-18','12:30:00',1.48),('15844','2014-02-18','12:35:00',1.3),('15844','2014-02-18','12:40:00',1.21),('15844','2014-02-18','12:45:00',1.18),('15844','2014-02-18','12:50:00',1.17),('15844','2014-02-18','12:55:00',1.22),('15844','2014-02-18','13:00:00',1.1),('15844','2014-02-18','13:05:00',1.02),('15844','2014-02-18','13:10:00',1.04),('15844','2014-02-18','13:15:00',1.35),('15844','2014-02-18','13:20:00',1.68),('15844','2014-02-18','13:25:00',2.09),('15844','2014-02-18','13:30:00',1.41),('15844','2014-02-18','13:35:00',1.3),('15844','2014-02-18','13:40:00',1.54),('15844','2014-02-18','13:45:00',1.48),('15844','2014-02-18','13:50:00',1.18),('15844','2014-02-18','13:55:00',1.17),('15844','2014-02-18','14:00:00',1.21),('15844','2014-02-18','14:05:00',1.4),('15844','2014-02-18','14:10:00',1.17),('15844','2014-02-17','08:30:00',1.05),('15844','2014-02-17','08:35:00',1.13),('15844','2014-02-17','08:40:00',1.2),('15844','2014-02-17','08:45:00',1.26),('15844','2014-02-17','08:50:00',1.34),('15844','2014-02-17','08:55:00',1.41),('15844','2014-02-17','09:00:00',1.49),('15844','2014-02-17','09:05:00',1.53),('15844','2014-02-17','09:10:00',1.62),('15844','2014-02-17','09:15:00',1.7),('15844','2014-02-17','09:20:00',1.78),('15844','2014-02-17','09:25:00',1.87),('15844','2014-02-17','09:30:00',1.93),('15844','2014-02-17','09:35:00',1.98),('15844','2014-02-17','09:40:00',2.03),('15844','2014-02-17','09:45:00',2.04),('15844','2014-02-17','09:50:00',2.09),('15844','2014-02-17','09:55:00',2.13),('15844','2014-02-17','10:00:00',2.18),('15844','2014-02-17','10:05:00',2.2),('15844','2014-02-17','10:10:00',2.22),('15844','2014-02-17','10:15:00',2.23),('15844','2014-02-17','10:20:00',2.28),('15844','2014-02-17','10:25:00',2.32),('15844','2014-02-17','10:30:00',2.34),('15844','2014-02-17','10:35:00',2.34),('15844','2014-02-17','10:40:00',2.34),('15844','2014-02-17','10:45:00',2.36),('15844','2014-02-17','10:50:00',2.39),('15844','2014-02-17','10:55:00',2.38),('15844','2014-02-17','11:00:00',2.43),('15844','2014-02-17','11:05:00',2.43),('15844','2014-02-17','11:10:00',2.44),('15844','2014-02-17','11:15:00',2.45),('15844','2014-02-17','11:20:00',2.46),('15844','2014-02-17','11:25:00',2.48),('15844','2014-02-17','11:30:00',2.49),('15844','2014-02-17','11:35:00',2.54),('15844','2014-02-17','11:40:00',2.54),('15844','2014-02-17','11:45:00',2.54),('15844','2014-02-17','11:50:00',2.54),('15844','2014-02-17','11:55:00',2.52),('15844','2014-02-17','12:00:00',2.5),('15844','2014-02-17','12:05:00',2.48),('15844','2014-02-17','12:10:00',2.45),('15844','2014-02-17','12:15:00',2.44),('15844','2014-02-17','12:20:00',2.45),('15844','2014-02-17','12:25:00',2.43),('15844','2014-02-17','12:30:00',2.39),('15844','2014-02-17','12:35:00',2.37),('15844','2014-02-17','12:40:00',2.33),('15844','2014-02-17','12:45:00',2.3),('15844','2014-02-17','12:50:00',2.25),('15844','2014-02-17','12:55:00',2.21),('15844','2014-02-17','13:00:00',2.16),('15844','2014-02-17','13:05:00',2.09),('15844','2014-02-17','13:10:00',2.02),('15844','2014-02-17','13:15:00',1.97),('15844','2014-02-17','13:20:00',1.91),('15844','2014-02-17','13:25:00',1.85),('15844','2014-02-17','13:30:00',1.79),('15844','2014-02-17','13:35:00',1.69),('15844','2014-02-17','13:40:00',1.61),('15844','2014-02-17','13:45:00',1.5),('15844','2014-02-17','13:50:00',1.47),('15844','2014-02-17','13:55:00',1.4),('15844','2014-02-17','14:00:00',1.36),('15844','2014-02-17','14:05:00',1.29),('15844','2014-02-17','14:10:00',1.18),('15844','2014-02-17','14:15:00',1.18),('15844','2014-02-17','14:20:00',1.09),('15844','2014-02-17','14:25:00',1.01),('15844','2014-02-16','08:20:00',1.05),('15844','2014-02-16','08:25:00',1.1),('15844','2014-02-16','08:30:00',1.18),('15844','2014-02-16','08:35:00',1.24),('15844','2014-02-16','08:40:00',1.19),('15844','2014-02-16','08:45:00',1.32),('15844','2014-02-16','08:50:00',1.56),('15844','2014-02-16','08:55:00',1.61),('15844','2014-02-16','09:00:00',1.76),('15844','2014-02-16','09:05:00',1.82),('15844','2014-02-16','09:10:00',1.62),('15844','2014-02-16','09:15:00',1.72),('15844','2014-02-16','09:20:00',1.85),('15844','2014-02-16','09:25:00',1.96),('15844','2014-02-16','09:30:00',1.75),('15844','2014-02-16','09:35:00',2.02),('15844','2014-02-16','09:40:00',2.22),('15844','2014-02-16','09:45:00',2.28),('15844','2014-02-16','09:50:00',2.29),('15844','2014-02-16','09:55:00',2.2),('15844','2014-02-16','10:00:00',2.32),('15844','2014-02-16','10:05:00',2.47),('15844','2014-02-16','10:10:00',2.48),('15844','2014-02-16','10:15:00',2.49),('15844','2014-02-16','10:20:00',2.48),('15844','2014-02-16','10:25:00',2.53),('15844','2014-02-16','10:30:00',2.59),('15844','2014-02-16','10:35:00',2.53),('15844','2014-02-16','10:40:00',2.71),('15844','2014-02-16','10:45:00',2.56),('15844','2014-02-16','10:50:00',2.17),('15844','2014-02-16','10:55:00',2.58),('15844','2014-02-16','11:00:00',2.65),('15844','2014-02-16','11:05:00',2.59),('15844','2014-02-16','11:10:00',2.69),('15844','2014-02-16','11:15:00',2.48),('15844','2014-02-16','11:20:00',2.43),('15844','2014-02-16','11:25:00',2.4),('15844','2014-02-16','11:30:00',2.61),('15844','2014-02-16','11:35:00',2.58),('15844','2014-02-16','11:40:00',2.26),('15844','2014-02-16','11:45:00',2.58),('15844','2014-02-16','11:50:00',2.28),('15844','2014-02-16','11:55:00',2.63),('15844','2014-02-16','12:00:00',2.58),('15844','2014-02-16','12:05:00',2.59),('15844','2014-02-16','12:10:00',2.55),('15844','2014-02-16','12:15:00',2.53),('15844','2014-02-16','12:20:00',2.49),('15844','2014-02-16','12:25:00',2.46),('15844','2014-02-16','12:30:00',2.42),('15844','2014-02-16','12:35:00',2.38),('15844','2014-02-16','12:40:00',2.38),('15844','2014-02-16','12:45:00',2.34),('15844','2014-02-16','12:50:00',2.32),('15844','2014-02-16','12:55:00',2.25),('15844','2014-02-16','13:00:00',2.2),('15844','2014-02-16','13:05:00',2.14),('15844','2014-02-16','13:10:00',2.07),('15844','2014-02-16','13:15:00',2.06),('15844','2014-02-16','13:20:00',1.97),('15844','2014-02-16','13:25:00',1.92),('15844','2014-02-16','13:30:00',1.89),('15844','2014-02-16','13:35:00',1.81),('15844','2014-02-16','13:40:00',1.74),('15844','2014-02-16','13:45:00',1.59),('15844','2014-02-16','13:50:00',1.53),('15844','2014-02-16','13:55:00',1.45),('15844','2014-02-16','14:00:00',1.4),('15844','2014-02-16','14:05:00',1.3),('15844','2014-02-16','14:10:00',1.22),('15844','2014-02-16','14:15:00',1.14),('15844','2014-02-16','14:20:00',1.05),('15844','2014-04-28','08:15:00',1.07),('15844','2014-04-28','08:20:00',1.11),('15844','2014-04-28','08:25:00',1.03),('15844','2014-04-28','08:35:00',1.01),('15844','2014-04-28','08:40:00',1.11),('15844','2014-04-28','09:05:00',1.91),('15844','2014-04-28','09:10:00',1.48),('15844','2014-04-28','09:15:00',2.2),('15844','2014-04-28','09:20:00',1.79),('15844','2014-04-28','09:25:00',2.5),('15844','2014-04-28','09:30:00',2.31),('15844','2014-04-28','09:35:00',1.64),('15844','2014-04-28','09:40:00',1.17),('15844','2014-04-28','09:45:00',1.97),('15844','2014-04-28','09:50:00',1.35),('15844','2014-04-28','09:55:00',1.64),('15844','2014-04-28','10:00:00',1.72),('15844','2014-04-28','10:05:00',1.67),('15844','2014-04-28','10:10:00',1.18),('15844','2014-04-28','10:30:00',1.07),('15844','2014-04-28','10:35:00',1.38),('15844','2014-04-28','10:40:00',1.16),('15844','2014-04-28','10:45:00',1.28),('15844','2014-04-28','10:50:00',3.03),('15844','2014-04-28','10:55:00',2.89),('15844','2014-04-28','11:00:00',2.25),('15844','2014-04-28','11:05:00',2.36),('15844','2014-04-28','11:10:00',2.26),('15844','2014-04-28','11:15:00',1.52),('15844','2014-04-28','11:20:00',1.38),('15844','2014-04-28','11:25:00',1.24),('15844','2014-04-28','11:30:00',1.27),('15844','2014-04-28','11:35:00',1.3),('15844','2014-04-28','11:40:00',1.25),('15844','2014-04-28','11:45:00',1.43),('15844','2014-04-28','11:50:00',1.47),('15844','2014-04-28','11:55:00',1.56),('15844','2014-04-28','12:00:00',1.59),('15844','2014-04-28','12:05:00',1.44),('15844','2014-04-28','12:10:00',1.73),('15844','2014-04-28','12:15:00',1.75),('15844','2014-04-28','12:20:00',2.01),('15844','2014-04-28','12:25:00',2.13),('15844','2014-04-28','12:30:00',2.04),('15844','2014-04-28','12:35:00',2.12),('15844','2014-04-28','12:40:00',1.97),('15844','2014-04-28','12:45:00',1.97),('15844','2014-04-28','12:50:00',1.97),('15844','2014-04-28','12:55:00',2.07),('15844','2014-04-28','13:00:00',1.89),('15844','2014-04-28','13:05:00',1.9),('15844','2014-04-28','13:10:00',2.86),('15844','2014-04-28','13:15:00',4.29),('15844','2014-04-28','13:20:00',3.7),('15844','2014-04-28','13:25:00',2.38),('15844','2014-04-28','13:30:00',5.07),('15844','2014-04-28','13:35:00',3.71),('15844','2014-04-28','13:40:00',3.04),('15844','2014-04-28','13:45:00',2.72),('15844','2014-04-28','13:50:00',2.21),('15844','2014-04-28','13:55:00',3.13),('15844','2014-04-28','14:00:00',4.32),('15844','2014-04-28','14:05:00',3.47),('15844','2014-04-28','14:10:00',1.5),('15844','2014-04-28','14:15:00',3.2),('15844','2014-04-28','14:20:00',2.76),('15844','2014-04-28','14:25:00',3.98),('15844','2014-04-28','14:30:00',3.19),('15844','2014-04-28','14:35:00',1.5),('15844','2014-04-28','14:40:00',2.2),('15844','2014-04-28','14:45:00',1.5),('15844','2014-04-28','14:50:00',2.71),('15844','2014-04-28','14:55:00',2.56),('15844','2014-04-28','15:00:00',3.26),('15844','2014-04-28','15:05:00',2.31),('15844','2014-04-28','15:10:00',2.07),('15844','2014-04-28','15:15:00',1.45),('15844','2014-04-28','15:20:00',1.93),('15844','2014-04-28','15:25:00',1.11),('15844','2014-04-28','15:30:00',1.19),('15844','2014-04-28','15:35:00',1.29),('15844','2014-04-28','15:40:00',1.51),('15844','2014-04-28','15:45:00',1.77),('15844','2014-04-28','15:50:00',2.53),('15844','2014-04-28','15:55:00',1.73),('15844','2014-04-28','16:00:00',1.57),('15844','2014-04-28','16:10:00',1.19),('15844','2014-04-28','16:15:00',1.76),('15844','2014-04-28','16:20:00',1.58),('15844','2014-04-28','16:25:00',1.38),('15844','2014-04-28','16:50:00',1.4),('15844','2014-02-15','08:25:00',1.05),('15844','2014-02-15','08:30:00',1.11),('15844','2014-02-15','08:35:00',1.16),('15844','2014-02-15','08:40:00',1.24),('15844','2014-02-15','08:45:00',1.31),('15844','2014-02-15','08:50:00',1.26),('15844','2014-02-15','08:55:00',1.44),('15844','2014-02-15','09:00:00',1.52),('15844','2014-02-15','09:05:00',1.59),('15844','2014-02-15','09:10:00',1.67),('15844','2014-02-15','09:15:00',1.75),('15844','2014-02-15','09:20:00',1.84),('15844','2014-02-15','09:25:00',1.93),('15844','2014-02-15','09:30:00',1.99),('15844','2014-02-15','09:35:00',2.04),('15844','2014-02-15','09:40:00',2.15),('15844','2014-02-15','09:45:00',2.2),('15844','2014-02-15','09:50:00',2.23),('15844','2014-02-15','09:55:00',2.23),('15844','2014-02-15','10:00:00',2.24),('15844','2014-02-15','10:05:00',2.25),('15844','2014-02-15','10:10:00',2.27),('15844','2014-02-15','10:15:00',2.26),('15844','2014-02-15','10:20:00',2.26),('15844','2014-02-15','10:25:00',2.26),('15844','2014-02-15','10:30:00',2.36),('15844','2014-02-15','10:35:00',2.45),('15844','2014-02-15','10:40:00',2.47),('15844','2014-02-15','10:45:00',2.47),('15844','2014-02-15','10:50:00',2.49),('15844','2014-02-15','10:55:00',2.52),('15844','2014-02-15','11:00:00',2.51),('15844','2014-02-15','11:05:00',2.5),('15844','2014-02-15','11:10:00',2.5),('15844','2014-02-15','11:15:00',2.51),('15844','2014-02-15','11:20:00',2.52),('15844','2014-02-15','11:25:00',2.51),('15844','2014-02-15','11:30:00',2.65),('15844','2014-02-15','11:35:00',2.6),('15844','2014-02-15','11:40:00',2.12),('15844','2014-02-15','11:45:00',1.43),('15844','2014-02-15','11:50:00',2.99),('15844','2014-02-15','11:55:00',2.12),('15844','2014-02-15','12:00:00',2.64),('15844','2014-02-15','12:05:00',2.68),('15844','2014-02-15','12:10:00',2.66),('15844','2014-02-15','12:15:00',2.63),('15844','2014-02-15','12:20:00',2.64),('15844','2014-02-15','12:25:00',2.61),('15844','2014-02-15','12:30:00',2.56),('15844','2014-02-15','12:35:00',2.56),('15844','2014-02-15','12:40:00',2.5),('15844','2014-02-15','12:45:00',2.44),('15844','2014-02-15','12:50:00',2.38),('15844','2014-02-15','12:55:00',2.35),('15844','2014-02-15','13:00:00',2.25),('15844','2014-02-15','13:05:00',2.2),('15844','2014-02-15','13:10:00',2.16),('15844','2014-02-15','13:15:00',2.07),('15844','2014-02-15','13:20:00',1.98),('15844','2014-02-15','13:25:00',1.89),('15844','2014-02-15','13:30:00',1.74),('15844','2014-02-15','13:35:00',1.68),('15844','2014-02-15','13:40:00',1.59),('15844','2014-02-15','13:45:00',1.49),('15844','2014-02-15','13:50:00',1.44),('15844','2014-02-15','13:55:00',1.35),('15844','2014-02-15','14:00:00',1.29),('15844','2014-02-15','14:05:00',1.24),('15844','2014-02-15','14:10:00',1.13),('15844','2014-02-15','14:15:00',1.09),('15844','2014-02-15','14:20:00',1.01),('15844','2014-02-14','08:35:00',1.12),('15844','2014-02-14','08:40:00',1.3),('15844','2014-02-14','08:45:00',1.39),('15844','2014-02-14','08:50:00',1.45),('15844','2014-02-14','08:55:00',1.53),('15844','2014-02-14','09:00:00',1.61),('15844','2014-02-14','09:05:00',1.68),('15844','2014-02-14','09:10:00',1.63),('15844','2014-02-14','09:20:00',1.5),('15844','2014-02-14','09:25:00',2.23),('15844','2014-02-14','09:30:00',1.75),('15844','2014-02-14','09:35:00',2.01),('15844','2014-02-14','09:40:00',2.11),('15844','2014-02-14','09:45:00',2.23),('15844','2014-02-14','09:50:00',2.25),('15844','2014-02-14','09:55:00',2.05),('15844','2014-02-14','10:00:00',2.45),('15844','2014-02-14','10:05:00',2.45),('15844','2014-02-14','10:10:00',2.39),('15844','2014-02-14','10:15:00',2.01),('15844','2014-02-14','10:20:00',2.2),('15844','2014-02-14','10:25:00',2.37),('15844','2014-02-14','10:30:00',2.51),('15844','2014-02-14','10:35:00',2.69),('15844','2014-02-14','10:40:00',2.73),('15844','2014-02-14','10:45:00',2.68),('15844','2014-02-14','10:50:00',2.73),('15844','2014-02-14','10:55:00',2.78),('15844','2014-02-14','11:00:00',2.78),('15844','2014-02-14','11:05:00',2.8),('15844','2014-02-14','11:10:00',2.75),('15844','2014-02-14','11:15:00',2.8),('15844','2014-02-14','11:20:00',2.79),('15844','2014-02-14','11:25:00',2.8),('15844','2014-02-14','11:30:00',2.78),('15844','2014-02-14','11:35:00',2.79),('15844','2014-02-14','11:40:00',2.68),('15844','2014-02-14','11:45:00',2.78),('15844','2014-02-14','11:50:00',2.77),('15844','2014-02-14','11:55:00',2.74),('15844','2014-02-14','12:00:00',2.73),('15844','2014-02-14','12:05:00',2.69),('15844','2014-02-14','12:10:00',2.67),('15844','2014-02-14','12:15:00',2.64),('15844','2014-02-14','12:20:00',2.63),('15844','2014-02-14','12:25:00',2.61),('15844','2014-02-14','12:30:00',2.57),('15844','2014-02-14','12:35:00',2.53),('15844','2014-02-14','12:40:00',2.5),('15844','2014-02-14','12:45:00',2.44),('15844','2014-02-14','12:50:00',2.4),('15844','2014-02-14','12:55:00',2.33),('15844','2014-02-14','13:00:00',2.28),('15844','2014-02-14','13:05:00',2.22),('15844','2014-02-14','13:10:00',2.16),('15844','2014-02-14','13:15:00',2.08),('15844','2014-02-14','13:20:00',2.01),('15844','2014-02-14','13:25:00',1.9),('15844','2014-02-14','13:30:00',1.77),('15844','2014-02-14','13:35:00',1.71),('15844','2014-02-14','13:40:00',1.63),('15844','2014-02-14','13:45:00',1.59),('15844','2014-02-14','13:50:00',1.51),('15844','2014-02-14','13:55:00',1.41),('15844','2014-02-14','14:00:00',1.31),('15844','2014-02-14','14:05:00',1.24),('15844','2014-02-14','14:10:00',1.17),('15844','2014-02-14','14:15:00',1.09),('15844','2014-02-14','14:20:00',1.01),('15844','2014-02-13','08:30:00',1.07),('15844','2014-02-13','08:35:00',1.13),('15844','2014-02-13','08:40:00',1.23),('15844','2014-02-13','08:45:00',1.29),('15844','2014-02-13','08:50:00',1.4),('15844','2014-02-13','08:55:00',1.48),('15844','2014-02-13','09:00:00',1.55),('15844','2014-02-13','09:05:00',1.64),('15844','2014-02-13','09:10:00',1.74),('15844','2014-02-13','09:15:00',1.83),('15844','2014-02-13','09:20:00',1.87),('15844','2014-02-13','09:25:00',1.95),('15844','2014-02-13','09:30:00',2.01),('15844','2014-02-13','09:35:00',2.05),('15844','2014-02-13','09:40:00',2.11),('15844','2014-02-13','09:45:00',2.15),('15844','2014-02-13','09:50:00',2.2),('15844','2014-02-13','09:55:00',2.23),('15844','2014-02-13','10:00:00',2.27),('15844','2014-02-13','10:05:00',2.27),('15844','2014-02-13','10:10:00',2.3),('15844','2014-02-13','10:15:00',2.36),('15844','2014-02-13','10:20:00',2.39),('15844','2014-02-13','10:25:00',2.43),('15844','2014-02-13','10:30:00',2.47),('15844','2014-02-13','10:35:00',2.49),('15844','2014-02-13','10:40:00',2.5),('15844','2014-02-13','10:45:00',2.52),('15844','2014-02-13','10:50:00',2.6),('15844','2014-02-13','10:55:00',2.62),('15844','2014-02-13','11:00:00',2.26),('15844','2014-02-13','11:05:00',2.74),('15844','2014-02-13','11:10:00',2.73),('15844','2014-02-13','11:15:00',2.65),('15844','2014-02-13','11:20:00',2.67),('15844','2014-02-13','11:25:00',1.63),('15844','2014-02-13','11:45:00',1.07),('15844','2014-02-13','11:50:00',2.75),('15844','2014-02-13','11:55:00',2.35),('15844','2014-02-13','12:00:00',2.57),('15844','2014-02-13','12:05:00',2.3),('15844','2014-02-13','12:10:00',2.8),('15844','2014-02-13','12:15:00',1.73),('15844','2014-02-13','12:25:00',1.77),('15844','2014-02-13','12:30:00',1.64),('15844','2014-02-13','12:35:00',2.14),('15844','2014-02-13','12:40:00',2.76),('15844','2014-02-13','12:45:00',2.59),('15844','2014-02-13','12:50:00',2.45),('15844','2014-02-13','12:55:00',2.38),('15844','2014-02-13','13:00:00',2.39),('15844','2014-02-13','13:05:00',2.27),('15844','2014-02-13','13:10:00',2.18),('15844','2014-02-13','13:15:00',2.09),('15844','2014-02-13','13:20:00',1.98),('15844','2014-02-13','13:25:00',1.89),('15844','2014-02-13','13:30:00',1.85),('15844','2014-02-13','13:35:00',1.76),('15844','2014-02-13','13:40:00',1.67),('15844','2014-02-13','13:45:00',1.59),('15844','2014-02-13','13:50:00',1.5),('15844','2014-02-13','13:55:00',1.4),('15844','2014-02-13','14:00:00',1.32),('15844','2014-02-13','14:05:00',1.25),('15844','2014-02-13','14:10:00',1.21),('15844','2014-02-13','14:15:00',1.11),('15844','2014-02-13','14:20:00',1.02),('15844','2014-02-12','08:25:00',1.03),('15844','2014-02-12','08:40:00',1.28),('15844','2014-02-12','08:45:00',1.37),('15844','2014-02-12','08:50:00',1.47),('15844','2014-02-12','08:55:00',1.59),('15844','2014-02-12','09:00:00',1.53),('15844','2014-02-12','09:05:00',1.74),('15844','2014-02-12','09:10:00',1.83),('15844','2014-02-12','09:15:00',1.94),('15844','2014-02-12','09:20:00',2.02),('15844','2014-02-12','09:25:00',2.02),('15844','2014-02-12','09:30:00',1.03),('15844','2014-02-12','09:35:00',1.1),('15844','2014-02-12','09:40:00',1.15),('15844','2014-02-12','09:45:00',1.65),('15844','2014-02-12','10:00:00',1.17),('15844','2014-02-12','10:05:00',1.14),('15844','2014-02-12','10:40:00',1.07),('15844','2014-02-12','10:45:00',1.09),('15844','2014-02-12','10:50:00',1.05),('15844','2014-02-12','10:55:00',1.03),('15844','2014-02-12','11:00:00',1.06),('15844','2014-02-12','11:05:00',1.02),('15844','2014-02-12','11:10:00',1.01),('15844','2014-02-12','11:15:00',1.05),('15844','2014-02-12','11:35:00',1.46),('15844','2014-02-12','11:40:00',1.89),('15844','2014-02-12','11:45:00',2.46),('15844','2014-02-12','11:50:00',1.11),('15844','2014-02-12','12:10:00',1.02),('15844','2014-02-12','12:15:00',1.09),('15844','2014-02-12','12:20:00',1.09),('15844','2014-02-12','12:25:00',1.07),('15844','2014-02-12','12:30:00',1.13),('15844','2014-02-12','12:35:00',1.15),('15844','2014-02-12','12:40:00',1.17),('15844','2014-02-12','12:45:00',1.31),('15844','2014-02-12','12:50:00',1.47),('15844','2014-02-12','12:55:00',1.53),('15844','2014-02-12','13:00:00',1.24),('15844','2014-02-12','13:05:00',1.29),('15844','2014-02-12','13:10:00',1.35),('15844','2014-02-12','13:15:00',1.22),('15844','2014-02-12','13:20:00',1.23),('15844','2014-02-12','13:25:00',1.18),('15844','2014-02-12','13:30:00',1.06),('15844','2014-02-12','13:35:00',1.1),('15844','2014-02-12','13:40:00',1.05),('15844','2014-02-12','13:50:00',1.03),('15844','2014-02-12','13:55:00',1.21),('15844','2014-02-12','14:00:00',1.63),('15844','2014-02-12','14:05:00',1.67),('15844','2014-02-12','14:30:00',1.05),('15844','2014-02-11','09:30:00',1.02),('15844','2014-02-11','09:45:00',1.03),('15844','2014-02-11','09:50:00',1.04),('15844','2014-02-11','10:10:00',1.03),('15844','2014-02-11','10:15:00',1.29),('15844','2014-02-11','10:20:00',1.52),('15844','2014-02-11','10:25:00',1.74),('15844','2014-02-11','10:30:00',1.83),('15844','2014-02-11','10:35:00',1.81),('15844','2014-02-11','10:40:00',1.57),('15844','2014-02-11','10:45:00',1.69),('15844','2014-02-11','10:50:00',1.91),('15844','2014-02-11','10:55:00',1.67),('15844','2014-02-11','11:00:00',1.82),('15844','2014-02-11','11:05:00',2.1),('15844','2014-02-11','11:10:00',1.97),('15844','2014-02-11','11:15:00',2.07),('15844','2014-02-11','11:20:00',2.11),('15844','2014-02-11','11:25:00',1.75),('15844','2014-02-11','11:30:00',2.11),('15844','2014-02-11','11:35:00',2.06),('15844','2014-02-11','11:40:00',2.09),('15844','2014-02-11','11:45:00',1.86),('15844','2014-02-11','11:50:00',1.76),('15844','2014-02-11','11:55:00',1.48),('15844','2014-02-11','12:00:00',1.38),('15844','2014-02-11','12:05:00',1.4),('15844','2014-02-11','12:10:00',1.83),('15844','2014-02-11','12:15:00',1.43),('15844','2014-02-11','12:20:00',1.23),('15844','2014-02-11','12:25:00',1.53),('15844','2014-02-11','12:30:00',1.74),('15844','2014-02-11','12:35:00',1.79),('15844','2014-02-11','12:40:00',1.16),('15844','2014-02-11','12:45:00',1.48),('15844','2014-02-11','12:50:00',1.26),('15844','2014-02-11','12:55:00',1.28),('15844','2014-02-11','13:00:00',1.63),('15844','2014-02-11','13:05:00',1.58),('15844','2014-02-11','13:10:00',2.27),('15844','2014-02-11','13:15:00',2.15),('15844','2014-02-11','13:20:00',2.04),('15844','2014-02-11','13:25:00',1.74),('15844','2014-02-11','13:30:00',1.61),('15844','2014-02-11','13:35:00',1.57),('15844','2014-02-11','13:40:00',1.64),('15844','2014-02-11','13:45:00',1.37),('15844','2014-02-11','13:50:00',1.3),('15844','2014-02-11','13:55:00',1.01),('15844','2014-02-11','14:05:00',1.13),('15844','2014-02-11','14:10:00',1.13),('15844','2014-02-11','14:15:00',1.08),('15844','2014-02-11','14:20:00',1.05),('15844','2014-02-09','12:05:00',1.17),('15844','2014-02-09','12:10:00',2.23),('15844','2014-02-09','12:20:00',1.18),('15844','2014-02-09','12:25:00',1.86),('15844','2014-02-09','12:30:00',1.2),('15844','2014-02-09','12:40:00',1.43),('15844','2014-02-09','12:55:00',2.19),('15844','2014-02-09','13:10:00',1.01),('15844','2014-02-09','13:40:00',1.72),('15844','2014-02-09','13:45:00',1.08),('15844','2014-02-09','13:50:00',1.16),('15844','2014-02-09','13:55:00',1.19),('15844','2014-02-09','14:00:00',1.34),('15844','2014-02-08','09:40:00',1.02),('15844','2014-02-08','09:50:00',1.65),('15844','2014-02-08','09:55:00',2.27),('15844','2014-02-08','10:00:00',1.52),('15844','2014-02-08','10:05:00',1.49),('15844','2014-02-08','10:10:00',2.39),('15844','2014-02-08','10:15:00',1.89),('15844','2014-02-08','10:20:00',1.41),('15844','2014-02-08','10:30:00',1.29),('15844','2014-02-08','10:40:00',1.57),('15844','2014-02-08','10:45:00',1.63),('15844','2014-02-08','10:50:00',1.27),('15844','2014-02-08','10:55:00',2.4),('15844','2014-02-08','11:00:00',1.98),('15844','2014-02-08','11:05:00',1.65),('15844','2014-02-08','11:10:00',2.69),('15844','2014-02-08','11:15:00',3.12),('15844','2014-02-08','11:20:00',1.64),('15844','2014-02-08','11:25:00',1.4),('15844','2014-02-08','11:30:00',1.14),('15844','2014-02-08','11:40:00',1.11),('15844','2014-02-08','11:45:00',1.31),('15844','2014-02-08','11:55:00',1.73),('15844','2014-02-08','12:00:00',2.15),('15844','2014-02-08','12:15:00',1.94),('15844','2014-02-08','12:20:00',1.78),('15844','2014-02-08','12:30:00',1.01),('15844','2014-02-08','12:35:00',1.12),('15844','2014-02-08','12:40:00',1.22),('15844','2014-02-08','12:45:00',2.82),('15844','2014-02-08','12:50:00',2.62),('15844','2014-02-08','12:55:00',1.91),('15844','2014-02-08','13:00:00',2.08),('15844','2014-02-08','13:05:00',1.52),('15844','2014-02-08','13:10:00',1.23),('15844','2014-02-08','13:15:00',2.54),('15844','2014-02-08','13:20:00',1.07),('15844','2014-02-08','13:30:00',1.82),('15844','2014-02-08','13:35:00',1.1),('15844','2014-02-08','13:40:00',1.79),('15844','2014-02-08','13:45:00',1.25),('15844','2014-02-08','13:50:00',1.19),('15844','2014-02-08','13:55:00',1.59),('15844','2014-02-08','14:00:00',1.21),('15844','2014-02-08','14:10:00',1.17),('15844','2014-02-08','14:15:00',1.06),('15844','2014-02-08','14:30:00',1.23),('15844','2014-02-07','08:35:00',1.05),('15844','2014-02-07','08:40:00',1.15),('15844','2014-02-07','08:45:00',1.24),('15844','2014-02-07','08:50:00',1.31),('15844','2014-02-07','08:55:00',1.38),('15844','2014-02-07','09:00:00',1.45),('15844','2014-02-07','09:05:00',1.52),('15844','2014-02-07','09:10:00',1.6),('15844','2014-02-07','09:15:00',1.67),('15844','2014-02-07','09:20:00',1.73),('15844','2014-02-07','09:25:00',1.79),('15844','2014-02-07','09:30:00',1.84),('15844','2014-02-07','09:35:00',1.89),('15844','2014-02-07','09:40:00',1.93),('15844','2014-02-07','09:45:00',1.95),('15844','2014-02-07','09:50:00',1.96),('15844','2014-02-07','09:55:00',1.84),('15844','2014-02-07','10:20:00',1.31),('15844','2014-02-07','10:25:00',1.54),('15844','2014-02-07','10:30:00',1.35),('15844','2014-02-07','10:55:00',2.27),('15844','2014-02-07','11:00:00',1.83),('15844','2014-02-07','11:05:00',2.51),('15844','2014-02-07','11:10:00',3.22),('15844','2014-02-07','11:15:00',2.76),('15844','2014-02-07','11:20:00',2.28),('15844','2014-02-07','11:25:00',2.18),('15844','2014-02-07','11:30:00',2.12),('15844','2014-02-07','11:35:00',2.64),('15844','2014-02-07','11:40:00',1.05),('15844','2014-02-07','11:45:00',2.56),('15844','2014-02-07','11:50:00',1.43),('15844','2014-02-07','12:00:00',1.92),('15844','2014-02-07','12:05:00',2.37),('15844','2014-02-07','12:10:00',1.44),('15844','2014-02-07','12:15:00',2.17),('15844','2014-02-07','12:20:00',2.62),('15844','2014-02-07','12:25:00',2.75),('15844','2014-02-07','12:30:00',2.06),('15844','2014-02-07','12:35:00',2.32),('15844','2014-02-07','12:40:00',2.36),('15844','2014-02-07','12:45:00',2.51),('15844','2014-02-07','12:50:00',2.63),('15844','2014-02-07','12:55:00',2.21),('15844','2014-02-07','13:00:00',1.69),('15844','2014-02-07','13:05:00',2.24),('15844','2014-02-07','13:10:00',2.03),('15844','2014-02-07','13:15:00',2.08),('15844','2014-02-07','13:20:00',1.28),('15844','2014-02-07','13:25:00',1.81),('15844','2014-02-07','13:30:00',1.87),('15844','2014-02-07','13:35:00',1.52),('15844','2014-02-07','13:40:00',1.59),('15844','2014-02-07','13:45:00',1.5),('15844','2014-02-07','13:50:00',1.39),('15844','2014-02-07','13:55:00',1.3),('15844','2014-02-07','14:10:00',1.16),('15844','2014-02-06','08:45:00',1.22),('15844','2014-02-06','08:50:00',1.38),('15844','2014-02-06','08:55:00',1.56),('15844','2014-02-06','09:00:00',1.74),('15844','2014-02-06','09:05:00',1.8),('15844','2014-02-06','09:10:00',1.49),('15844','2014-02-06','09:20:00',2.02),('15844','2014-02-06','09:25:00',1.41),('15844','2014-02-06','09:30:00',1.52),('15844','2014-02-06','09:35:00',1.99),('15844','2014-02-06','09:40:00',1.75),('15844','2014-02-06','09:45:00',1.79),('15844','2014-02-06','09:50:00',2.13),('15844','2014-02-06','09:55:00',2.16),('15844','2014-02-06','10:00:00',2.19),('15844','2014-02-06','10:05:00',2.23),('15844','2014-02-06','10:10:00',2.26),('15844','2014-02-06','10:15:00',1.96),('15844','2014-02-06','10:20:00',2.24),('15844','2014-02-06','10:25:00',2.37),('15844','2014-02-06','10:30:00',2.6),('15844','2014-02-06','10:35:00',1.82),('15844','2014-02-06','10:40:00',2.4),('15844','2014-02-06','10:45:00',2.36),('15844','2014-02-06','10:50:00',1.21),('15844','2014-02-06','10:55:00',2.86),('15844','2014-02-06','11:00:00',2.02),('15844','2014-02-06','11:05:00',2.77),('15844','2014-02-06','11:10:00',2.82),('15844','2014-02-06','11:15:00',2.21),('15844','2014-02-06','11:20:00',2.73),('15844','2014-02-06','11:25:00',2.7),('15844','2014-02-06','11:30:00',2.68),('15844','2014-02-06','11:35:00',2.65),('15844','2014-02-06','11:40:00',2.64),('15844','2014-02-06','11:45:00',2.62),('15844','2014-02-06','11:50:00',2.62),('15844','2014-02-06','11:55:00',2.59),('15844','2014-02-06','12:00:00',2.58),('15844','2014-02-06','12:05:00',2.6),('15844','2014-02-06','12:10:00',2.54),('15844','2014-02-06','12:15:00',2.54),('15844','2014-02-06','12:20:00',2.41),('15844','2014-02-06','12:25:00',2.47),('15844','2014-02-06','12:30:00',2.44),('15844','2014-02-06','12:35:00',2.4),('15844','2014-02-06','12:40:00',2.36),('15844','2014-02-06','12:45:00',2.3),('15844','2014-02-06','12:50:00',2.25),('15844','2014-02-06','12:55:00',2.22),('15844','2014-02-06','13:00:00',2.14),('15844','2014-02-06','13:05:00',2.06),('15844','2014-02-06','13:10:00',2),('15844','2014-02-06','13:15:00',1.92),('15844','2014-02-06','13:20:00',1.86),('15844','2014-02-06','13:25:00',1.9),('15844','2014-02-06','13:30:00',1.76),('15844','2014-02-06','13:35:00',1.64),('15844','2014-02-06','13:40:00',1.54),('15844','2014-02-06','13:45:00',1.46),('15844','2014-02-06','13:50:00',1.37),('15844','2014-02-06','13:55:00',1.29),('15844','2014-02-06','14:00:00',1.2),('15844','2014-02-06','14:10:00',1.04),('15844','2014-02-06','14:15:00',1.01),('15844','2014-04-27','08:45:00',1.01),('15844','2014-04-27','09:10:00',1),('15844','2014-04-27','10:15:00',1.24),('15844','2014-04-27','10:20:00',1.35),('15844','2014-04-27','10:35:00',1.1),('15844','2014-04-27','10:40:00',1.15),('15844','2014-04-27','10:45:00',1.02),('15844','2014-04-27','10:50:00',1.11),('15844','2014-04-27','11:25:00',1.71),('15844','2014-04-27','11:30:00',1.63),('15844','2014-04-27','11:40:00',1.13),('15844','2014-04-27','11:45:00',2.16),('15844','2014-04-27','11:50:00',1.57),('15844','2014-04-27','11:55:00',1.34),('15844','2014-04-27','12:10:00',1.24),('15844','2014-04-27','12:15:00',2.21),('15844','2014-04-27','12:20:00',2.58),('15844','2014-04-27','12:25:00',2.31),('15844','2014-04-27','12:30:00',2.32),('15844','2014-04-27','12:35:00',2.26),('15844','2014-04-27','12:40:00',2.31),('15844','2014-04-27','12:45:00',2.74),('15844','2014-04-27','12:50:00',2.22),('15844','2014-04-27','12:55:00',2.1),('15844','2014-04-27','13:00:00',1.92),('15844','2014-04-27','13:05:00',1.95),('15844','2014-04-27','13:10:00',1.81),('15844','2014-04-27','13:15:00',1.97),('15844','2014-04-27','13:20:00',1.95),('15844','2014-04-27','13:25:00',1.55),('15844','2014-04-27','13:30:00',1.63),('15844','2014-04-27','13:35:00',1.47),('15844','2014-04-27','13:40:00',1.56),('15844','2014-04-27','13:45:00',1.67),('15844','2014-04-27','13:50:00',1.62),('15844','2014-04-27','13:55:00',2.17),('15844','2014-04-27','14:00:00',2.58),('15844','2014-04-27','14:05:00',1.8),('15844','2014-04-27','14:10:00',1.21),('15844','2014-04-27','14:15:00',1.54),('15844','2014-04-27','14:20:00',1.93),('15844','2014-04-27','14:25:00',2.14),('15844','2014-04-27','14:30:00',1.99),('15844','2014-04-27','14:35:00',2.57),('15844','2014-04-27','14:40:00',2.45),('15844','2014-04-27','14:45:00',1.84),('15844','2014-04-27','14:50:00',1.58),('15844','2014-04-27','14:55:00',1.67),('15844','2014-04-27','15:00:00',2.1),('15844','2014-04-27','15:05:00',2.46),('15844','2014-04-27','15:10:00',2.3),('15844','2014-04-27','15:15:00',1.87),('15844','2014-04-27','15:20:00',1.08),('15844','2014-02-05','10:15:00',1.41),('15844','2014-02-05','10:20:00',2.43),('15844','2014-02-05','10:25:00',2.19),('15844','2014-02-05','10:30:00',2.46),('15844','2014-02-05','10:35:00',2.51),('15844','2014-02-05','10:40:00',2.23),('15844','2014-02-05','10:45:00',1.7),('15844','2014-02-05','10:50:00',1.46),('15844','2014-02-05','11:00:00',1.96),('15844','2014-02-05','11:05:00',1.38),('15844','2014-02-05','11:10:00',1.08),('15844','2014-02-05','11:20:00',1.48),('15844','2014-02-05','12:40:00',1.05),('15844','2014-02-05','12:45:00',1.83),('15844','2014-02-05','12:50:00',1.65),('15844','2014-02-05','12:55:00',1.58),('15844','2014-02-05','13:00:00',1.62),('15844','2014-02-05','13:05:00',1.62),('15844','2014-02-05','13:10:00',1.27),('15844','2014-02-05','13:15:00',1.06),('15844','2014-02-05','13:25:00',1.04),('15844','2014-02-05','13:30:00',1.2),('15844','2014-02-05','13:35:00',1.25),('15844','2014-02-05','13:40:00',1.41),('15844','2014-02-05','13:45:00',1.46),('15844','2014-02-05','13:50:00',1.07),('15844','2014-02-05','14:20:00',1.15),('15844','2014-02-05','14:25:00',1.26),('15844','2014-02-04','09:35:00',1.65),('15844','2014-02-04','09:40:00',2.14),('15844','2014-02-04','09:45:00',2.07),('15844','2014-02-04','09:50:00',2.05),('15844','2014-02-04','09:55:00',1.7),('15844','2014-02-04','10:00:00',2.07),('15844','2014-02-04','10:05:00',1.52),('15844','2014-02-04','10:10:00',1.6),('15844','2014-02-04','10:15:00',1.98),('15844','2014-02-04','10:20:00',2.63),('15844','2014-02-04','10:25:00',2.28),('15844','2014-02-04','10:30:00',1.01),('15844','2014-02-04','10:35:00',1.26),('15844','2014-02-04','10:40:00',2.09),('15844','2014-02-04','10:45:00',1.76),('15844','2014-02-04','10:50:00',1.46),('15844','2014-02-04','10:55:00',1.5),('15844','2014-02-04','11:00:00',1.11),('15844','2014-02-04','11:05:00',2.05),('15844','2014-02-04','11:10:00',3.01),('15844','2014-02-04','11:15:00',3.1),('15844','2014-02-04','11:20:00',2.01),('15844','2014-02-04','11:25:00',2.26),('15844','2014-02-04','11:30:00',1.37),('15844','2014-02-04','11:35:00',1.09),('15844','2014-02-04','11:50:00',1.11),('15844','2014-02-04','11:55:00',1.21),('15844','2014-02-04','12:00:00',1.3),('15844','2014-02-04','12:05:00',1.38),('15844','2014-02-04','12:10:00',1.08),('15844','2014-02-04','12:55:00',1.23),('15844','2014-02-04','13:00:00',1.22),('15844','2014-02-04','13:05:00',1.09),('15844','2014-02-04','13:10:00',1.24),('15844','2014-02-04','13:15:00',1.12),('15844','2014-02-03','11:40:00',1.03),('15844','2014-02-03','11:45:00',1.15),('15844','2014-02-03','11:50:00',1.18),('15844','2014-02-03','11:55:00',1.15),('15844','2014-02-03','12:00:00',1.08),('15844','2014-02-03','12:05:00',1.08),('15844','2014-02-03','12:10:00',1),('15844','2014-02-01','11:10:00',1.07),('15844','2014-02-01','11:15:00',1.58),('15844','2014-02-01','11:20:00',1.7),('15844','2014-02-01','11:25:00',1.59),('15844','2014-02-01','11:30:00',1.66),('15844','2014-02-01','11:35:00',1.72),('15844','2014-02-01','11:40:00',1.54),('15844','2014-02-01','11:45:00',1.33),('15844','2014-02-01','12:05:00',1.2),('15844','2014-02-01','12:10:00',1.17),('15844','2014-02-01','12:25:00',1.34),('15844','2014-02-01','12:30:00',1.62),('15844','2014-02-01','12:35:00',1.6),('15844','2014-02-01','12:40:00',1.59),('15844','2014-02-01','12:45:00',1.69),('15844','2014-02-01','12:50:00',1.62),('15844','2014-02-01','12:55:00',1.34),('15844','2014-01-30','09:55:00',1.48),('15844','2014-01-30','10:00:00',1.38),('15844','2014-01-30','10:05:00',1.01),('15844','2014-01-30','10:10:00',1.34),('15844','2014-01-30','10:15:00',1.42),('15844','2014-01-30','10:20:00',1.3),('15844','2014-01-30','10:25:00',1.18),('15844','2014-01-30','10:30:00',1.78),('15844','2014-01-30','10:35:00',2.19),('15844','2014-01-30','10:40:00',2.05),('15844','2014-01-30','10:45:00',1.78),('15844','2014-01-30','10:50:00',1.67),('15844','2014-01-30','10:55:00',1.01),('15844','2014-01-30','11:00:00',1.5),('15844','2014-01-30','11:05:00',2.22),('15844','2014-01-30','11:10:00',2.69),('15844','2014-01-30','11:15:00',2.3),('15844','2014-01-30','11:20:00',2.39),('15844','2014-01-30','11:25:00',2.41),('15844','2014-01-30','11:30:00',2.04),('15844','2014-01-30','11:35:00',2.37),('15844','2014-01-30','11:40:00',2.47),('15844','2014-01-30','11:45:00',2.44),('15844','2014-01-30','11:50:00',2.35),('15844','2014-01-30','11:55:00',1.98),('15844','2014-01-30','12:00:00',2.24),('15844','2014-01-30','12:05:00',2.39),('15844','2014-01-30','12:10:00',2.54),('15844','2014-01-30','12:15:00',2.44),('15844','2014-01-30','12:20:00',1.94),('15844','2014-01-30','12:25:00',1.83),('15844','2014-01-30','12:30:00',1.87),('15844','2014-01-30','12:35:00',2.08),('15844','2014-01-30','12:40:00',2.01),('15844','2014-01-30','12:45:00',2.02),('15844','2014-01-30','12:50:00',2),('15844','2014-01-30','12:55:00',2),('15844','2014-01-30','13:00:00',1.9),('15844','2014-01-30','13:05:00',1.85),('15844','2014-01-30','13:10:00',1.79),('15844','2014-01-30','13:15:00',1.72),('15844','2014-01-30','13:20:00',1.66),('15844','2014-01-30','13:25:00',1.42),('15844','2014-01-30','13:30:00',1.23),('15844','2014-01-30','13:35:00',1.21),('15844','2014-01-30','13:40:00',1.4),('15844','2014-01-30','13:45:00',1.48),('15844','2014-01-30','13:50:00',1.31),('15844','2014-01-30','13:55:00',1.05),('15844','2014-01-29','09:15:00',1.13),('15844','2014-01-29','09:20:00',1.23),('15844','2014-01-29','09:25:00',1.01),('15844','2014-01-29','09:30:00',1.27),('15844','2014-01-29','09:35:00',1.18),('15844','2014-01-29','09:40:00',1.3),('15844','2014-01-29','09:45:00',1.22),('15844','2014-01-29','10:00:00',1.3),('15844','2014-01-29','10:05:00',2.09),('15844','2014-01-29','10:10:00',1.44),('15844','2014-01-29','10:15:00',1.69),('15844','2014-01-29','10:20:00',2.01),('15844','2014-01-29','10:25:00',2.34),('15844','2014-01-29','10:30:00',2.7),('15844','2014-01-29','10:35:00',2.18),('15844','2014-01-29','10:40:00',1.71),('15844','2014-01-29','10:45:00',1.52),('15844','2014-01-29','10:50:00',1.46),('15844','2014-01-29','10:55:00',1.45),('15844','2014-01-29','11:00:00',1.89),('15844','2014-01-29','11:05:00',1.73),('15844','2014-01-29','11:10:00',1.59),('15844','2014-01-29','11:15:00',1.82),('15844','2014-01-29','11:20:00',1.81),('15844','2014-01-29','11:25:00',2.41),('15844','2014-01-29','11:30:00',1.49),('15844','2014-01-29','11:35:00',1.08),('15844','2014-01-29','12:40:00',1.62),('15844','2014-01-29','12:45:00',2.38),('15844','2014-01-29','12:50:00',1.87),('15844','2014-01-29','12:55:00',1.96),('15844','2014-01-29','13:00:00',1.55),('15844','2014-01-29','13:30:00',1.01),('15844','2014-01-29','13:35:00',1.68),('15844','2014-01-29','13:40:00',1.71),('15844','2014-01-29','13:45:00',1.44),('15844','2014-01-29','13:50:00',1.1),('15844','2014-01-29','13:55:00',1.05),('15844','2014-01-28','09:05:00',1.12),('15844','2014-01-28','09:20:00',1.07),('15844','2014-01-28','09:25:00',1.24),('15844','2014-01-28','09:30:00',1.21),('15844','2014-01-28','09:35:00',1.12),('15844','2014-01-28','09:40:00',1.24),('15844','2014-01-28','09:45:00',1.44),('15844','2014-01-28','09:50:00',1.69),('15844','2014-01-28','09:55:00',1.62),('15844','2014-01-28','10:00:00',1.67),('15844','2014-01-28','10:05:00',1.9),('15844','2014-01-28','10:10:00',2.01),('15844','2014-01-28','10:15:00',2.1),('15844','2014-01-28','10:20:00',2.13),('15844','2014-01-28','10:25:00',2.16),('15844','2014-01-28','10:30:00',2.16),('15844','2014-01-28','10:35:00',2.19),('15844','2014-01-28','10:40:00',2.28),('15844','2014-01-28','10:45:00',2.4),('15844','2014-01-28','10:50:00',2.29),('15844','2014-01-28','10:55:00',2.44),('15844','2014-01-28','11:00:00',1.18),('15844','2014-01-28','11:05:00',2.19),('15844','2014-01-28','11:10:00',1.59),('15844','2014-01-28','11:20:00',1.75),('15844','2014-01-28','11:25:00',1.45),('15844','2014-01-28','11:35:00',1.71),('15844','2014-01-28','11:40:00',1.55),('15844','2014-01-28','11:45:00',1.94),('15844','2014-01-28','11:50:00',1.98),('15844','2014-01-28','11:55:00',2.33),('15844','2014-01-28','12:00:00',1.73),('15844','2014-01-28','12:05:00',1.47),('15844','2014-01-28','12:10:00',1.33),('15844','2014-01-28','12:15:00',1.33),('15844','2014-01-28','12:30:00',1.06),('15844','2014-01-28','12:35:00',1.09),('15844','2014-01-28','12:40:00',1.88),('15844','2014-01-28','12:45:00',2.51),('15844','2014-01-28','12:50:00',1.53),('15844','2014-01-28','12:55:00',1.93),('15844','2014-01-28','13:00:00',2.26),('15844','2014-01-28','13:05:00',1.64),('15844','2014-01-28','13:10:00',1.72),('15844','2014-01-28','13:15:00',1.75),('15844','2014-01-28','13:20:00',1.82),('15844','2014-01-28','13:25:00',1.3),('15844','2014-01-28','13:30:00',1.59),('15844','2014-01-28','13:35:00',1.56),('15844','2014-01-28','13:40:00',1.41),('15844','2014-01-28','13:45:00',1.31),('15844','2014-01-28','13:50:00',1.21),('15844','2014-01-28','13:55:00',1.12),('15844','2014-01-28','14:00:00',1.04),('16100','2014-05-04','07:50:00',1.03),('16100','2014-05-04','07:55:00',1.18),('16100','2014-05-04','08:00:00',1.34),('16100','2014-05-04','08:05:00',1.51),('16100','2014-05-04','08:10:00',1.69),('16100','2014-05-04','08:15:00',1.9),('16100','2014-05-04','08:20:00',2.06),('16100','2014-05-04','08:25:00',2.27),('16100','2014-05-04','08:30:00',2.5),('16100','2014-05-04','08:35:00',2.82),('16100','2014-05-04','08:40:00',3.09),('16100','2014-05-04','08:45:00',3.25),('16100','2014-05-04','08:50:00',3.4),('16100','2014-05-04','08:55:00',3.59),('16100','2014-05-04','09:00:00',3.78),('16100','2014-05-04','09:05:00',3.93),('16100','2014-05-04','09:10:00',4.08),('16100','2014-05-04','09:15:00',4.23),('16100','2014-05-04','09:20:00',4.37),('16100','2014-05-04','09:25:00',4.54),('16100','2014-05-04','09:30:00',4.71),('16100','2014-05-04','09:35:00',4.85),('16100','2014-05-04','09:40:00',4.96),('16100','2014-05-04','09:45:00',5.08),('16100','2014-05-04','09:50:00',5.17),('16100','2014-05-04','09:55:00',5.27),('16100','2014-05-04','10:00:00',5.42),('16100','2014-05-04','10:05:00',5.56),('16100','2014-05-04','10:10:00',5.78),('16100','2014-05-04','10:15:00',5.83),('16100','2014-05-04','10:20:00',5.94),('16100','2014-05-04','10:25:00',6.06),('16100','2014-05-04','10:30:00',6.19),('16100','2014-05-04','10:35:00',6.34),('16100','2014-05-04','10:40:00',6.39),('16100','2014-05-04','10:45:00',6.43),('16100','2014-05-04','10:50:00',6.5),('16100','2014-05-04','10:55:00',6.56),('16100','2014-05-04','11:00:00',6.68),('16100','2014-05-04','11:05:00',6.75),('16100','2014-05-04','11:10:00',6.88),('16100','2014-05-04','11:15:00',7.01),('16100','2014-05-04','11:20:00',5.16),('16100','2014-05-04','11:25:00',3.69),('16100','2014-05-04','11:30:00',6.77),('16100','2014-05-04','11:35:00',7.05),('16100','2014-05-04','11:40:00',6.31),('16100','2014-05-04','11:45:00',7.36),('16100','2014-05-04','11:50:00',7.82),('16100','2014-05-04','11:55:00',5.61),('16100','2014-05-04','12:00:00',5.21),('16100','2014-05-04','12:05:00',5.92),('16100','2014-05-04','12:10:00',8.04),('16100','2014-05-04','12:15:00',5),('16100','2014-05-04','12:20:00',2.53),('16100','2014-05-04','12:25:00',2.67),('16100','2014-05-04','12:30:00',4.55),('16100','2014-05-04','12:35:00',4.13),('16100','2014-05-04','12:40:00',7.5),('16100','2014-05-04','12:45:00',8.26),('16100','2014-05-04','12:50:00',7.92),('16100','2014-05-04','12:55:00',7.9),('16100','2014-05-04','13:00:00',7.35),('16100','2014-05-04','13:05:00',7.01),('16100','2014-05-04','13:10:00',7.81),('16100','2014-05-04','13:15:00',7.78),('16100','2014-05-04','13:20:00',7.73),('16100','2014-05-04','13:25:00',7.7),('16100','2014-05-04','13:30:00',7.83),('16100','2014-05-04','13:35:00',8.02),('16100','2014-05-04','13:40:00',8.14),('16100','2014-05-04','13:45:00',8.36),('16100','2014-05-04','13:50:00',3.02),('16100','2014-05-04','13:55:00',2.17),('16100','2014-05-04','14:00:00',2.17),('16100','2014-05-04','14:05:00',1.95),('16100','2014-05-04','14:10:00',8.29),('16100','2014-05-04','14:15:00',8.37),('16100','2014-05-04','14:20:00',8.28),('16100','2014-05-04','14:25:00',4.5),('16100','2014-05-04','14:30:00',8.07),('16100','2014-05-04','14:35:00',7.9),('16100','2014-05-04','14:40:00',7.79),('16100','2014-05-04','14:45:00',7.64),('16100','2014-05-04','14:50:00',7.57),('16100','2014-05-04','14:55:00',7.65),('16100','2014-05-04','15:00:00',7.3),('16100','2014-05-04','15:05:00',7.04),('16100','2014-05-04','15:10:00',6.89),('16100','2014-05-04','15:15:00',6.84),('16100','2014-05-04','15:20:00',6.64),('16100','2014-05-04','15:25:00',6.52),('16100','2014-05-04','15:30:00',6.52),('16100','2014-05-04','15:35:00',6.43),('16100','2014-05-04','15:40:00',6.34),('16100','2014-05-04','15:45:00',6.28),('16100','2014-05-04','15:50:00',6.13),('16100','2014-05-04','15:55:00',6.04),('16100','2014-05-04','16:00:00',5.94),('16100','2014-05-04','16:05:00',5.82),('16100','2014-05-04','16:10:00',5.78),('16100','2014-05-04','16:15:00',5.62),('16100','2014-05-04','16:20:00',5.46),('16100','2014-05-04','16:25:00',5.28),('16100','2014-05-04','16:30:00',5.11),('16100','2014-05-04','16:35:00',4.94),('16100','2014-05-04','16:40:00',4.84),('16100','2014-05-04','16:45:00',4.7),('16100','2014-05-04','16:50:00',4.63),('16100','2014-05-04','16:55:00',4.49),('16100','2014-05-04','17:00:00',4.25),('16100','2014-05-04','17:05:00',4.02),('16100','2014-05-04','17:10:00',3.89),('16100','2014-05-04','17:15:00',3.77),('16100','2014-05-04','17:20:00',3.6),('16100','2014-05-04','17:25:00',3.16),('16100','2014-05-04','17:30:00',2.16),('16100','2014-05-04','17:35:00',2.27),('16100','2014-05-04','17:40:00',2.97),('16100','2014-05-04','17:45:00',2.74),('16100','2014-05-04','17:50:00',2.14),('16100','2014-05-04','17:55:00',2.42),('16100','2014-05-04','18:00:00',2.25),('16100','2014-05-04','18:05:00',2.07),('16100','2014-05-04','18:10:00',1.95),('16100','2014-05-04','18:15:00',1.8),('16100','2014-05-04','18:20:00',1.65),('16100','2014-05-04','18:25:00',1.48),('16100','2014-05-04','18:30:00',1.33),('16100','2014-05-04','18:35:00',1.16),('16100','2014-04-25','08:15:00',1.04),('16100','2014-04-25','08:20:00',1.12),('16100','2014-04-25','08:25:00',1.07),('16100','2014-04-25','08:30:00',1.08),('16100','2014-04-25','08:35:00',1.06),('16100','2014-04-25','08:40:00',1.08),('16100','2014-04-25','08:45:00',1.11),('16100','2014-04-25','08:50:00',1.2),('16100','2014-04-25','08:55:00',1.39),('16100','2014-04-25','09:00:00',1.54),('16100','2014-04-25','09:05:00',1.69),('16100','2014-04-25','09:10:00',1.69),('16100','2014-04-25','09:15:00',1.68),('16100','2014-04-25','09:20:00',1.55),('16100','2014-04-25','09:25:00',1.24),('16100','2014-04-25','09:30:00',1.03),('16100','2014-04-25','09:35:00',1.14),('16100','2014-04-25','09:40:00',1.32),('16100','2014-04-25','09:45:00',1.69),('16100','2014-04-25','09:50:00',1.8),('16100','2014-04-25','09:55:00',2.28),('16100','2014-04-25','10:00:00',2.57),('16100','2014-04-25','10:05:00',2.9),('16100','2014-04-25','10:10:00',2.86),('16100','2014-04-25','10:15:00',3.21),('16100','2014-04-25','10:20:00',2.98),('16100','2014-04-25','10:25:00',2.62),('16100','2014-04-25','10:30:00',3.01),('16100','2014-04-25','10:35:00',2.72),('16100','2014-04-25','10:40:00',2.59),('16100','2014-04-25','10:45:00',3),('16100','2014-04-25','10:50:00',3.12),('16100','2014-04-25','10:55:00',3.82),('16100','2014-04-25','11:00:00',3.67),('16100','2014-04-25','11:05:00',5.03),('16100','2014-04-25','11:10:00',6.38),('16100','2014-04-25','11:15:00',6.19),('16100','2014-04-25','11:20:00',6.31),('16100','2014-04-25','11:25:00',5.6),('16100','2014-04-25','11:30:00',5.88),('16100','2014-04-25','11:35:00',5.41),('16100','2014-04-25','11:40:00',5.06),('16100','2014-04-25','11:45:00',5.39),('16100','2014-04-25','11:50:00',5.54),('16100','2014-04-25','11:55:00',3.47),('16100','2014-04-25','12:00:00',4.35),('16100','2014-04-25','12:05:00',5.84),('16100','2014-04-25','12:10:00',3.88),('16100','2014-04-25','12:15:00',3.01),('16100','2014-04-25','12:20:00',4.65),('16100','2014-04-25','12:25:00',5.17),('16100','2014-04-25','12:30:00',3.46),('16100','2014-04-25','12:35:00',3.62),('16100','2014-04-25','12:40:00',4.35),('16100','2014-04-25','12:45:00',4.24),('16100','2014-04-25','12:50:00',3.51),('16100','2014-04-25','12:55:00',6.52),('16100','2014-04-25','13:00:00',5.39),('16100','2014-04-25','13:05:00',5.98),('16100','2014-04-25','13:10:00',7.38),('16100','2014-04-25','13:15:00',7.61),('16100','2014-04-25','13:20:00',6),('16100','2014-04-25','13:25:00',3.38),('16100','2014-04-25','13:30:00',3.5),('16100','2014-04-25','13:35:00',6.52),('16100','2014-04-25','13:40:00',7.4),('16100','2014-04-25','13:45:00',4.14),('16100','2014-04-25','13:50:00',2.93),('16100','2014-04-25','13:55:00',4.33),('16100','2014-04-25','14:00:00',4.05),('16100','2014-04-25','14:05:00',3.85),('16100','2014-04-25','14:10:00',1.49),('16100','2014-04-25','14:15:00',1.46),('16100','2014-04-25','14:20:00',1.63),('16100','2014-04-25','14:25:00',1.62),('16100','2014-04-25','14:30:00',1.62),('16100','2014-04-25','14:45:00',1.36),('16100','2014-04-25','18:35:00',1.21),('16100','2014-04-25','18:40:00',1.48),('16100','2014-04-25','18:45:00',1.24),('16100','2014-01-25','08:10:00',1.01),('16100','2014-01-25','08:55:00',1.13),('16100','2014-01-25','09:00:00',1.69),('16100','2014-01-25','09:05:00',2.22),('16100','2014-01-25','09:10:00',1.01),('16100','2014-01-25','09:20:00',1.14),('16100','2014-01-25','09:25:00',2.6),('16100','2014-01-25','09:30:00',2.94),('16100','2014-01-25','09:35:00',2.34),('16100','2014-01-25','09:40:00',1.79),('16100','2014-01-25','09:45:00',1.95),('16100','2014-01-25','09:50:00',2.32),('16100','2014-01-25','09:55:00',1.59),('16100','2014-01-25','10:00:00',1.21),('16100','2014-01-25','10:05:00',1.83),('16100','2014-01-25','10:10:00',2.41),('16100','2014-01-25','10:15:00',2.93),('16100','2014-01-25','10:20:00',1.57),('16100','2014-01-25','10:25:00',1.43),('16100','2014-01-25','10:30:00',1.49),('16100','2014-01-25','10:35:00',1.06),('16100','2014-01-25','10:40:00',1.08),('16100','2014-01-25','10:45:00',1.32),('16100','2014-01-25','10:50:00',1.46),('16100','2014-01-25','10:55:00',1.44),('16100','2014-01-25','11:00:00',1.47),('16100','2014-01-25','11:05:00',1.57),('16100','2014-01-25','11:10:00',1.25),('16100','2014-01-25','11:15:00',1.21),('16100','2014-01-25','11:20:00',1.72),('16100','2014-01-25','11:25:00',2.21),('16100','2014-01-25','11:30:00',1.35),('16100','2014-01-25','11:35:00',1.18),('16100','2014-01-25','11:40:00',1.01),('16100','2014-01-25','12:05:00',1.17),('16100','2014-01-25','12:10:00',1.77),('16100','2014-01-25','12:15:00',2.26),('16100','2014-01-25','12:20:00',2.49),('16100','2014-01-25','12:25:00',3.99),('16100','2014-01-25','12:30:00',4.38),('16100','2014-01-25','12:35:00',2.06),('16100','2014-01-25','12:40:00',1.76),('16100','2014-01-25','12:45:00',1.52),('16100','2014-01-25','12:50:00',1.36),('16100','2014-01-25','12:55:00',1.49),('16100','2014-01-25','13:00:00',1.73),('16100','2014-01-25','13:05:00',1.96),('16100','2014-01-25','13:10:00',2.31),('16100','2014-01-25','13:15:00',2.41),('16100','2014-01-25','13:20:00',2.45),('16100','2014-01-25','13:25:00',1.78),('16100','2014-01-25','13:30:00',1.39),('16100','2014-01-25','13:35:00',1.25),('16100','2014-01-25','13:40:00',1.04),('16100','2014-01-25','13:45:00',2.3),('16100','2014-01-25','13:50:00',1.53),('16100','2014-01-25','14:10:00',1.02),('16100','2014-01-25','15:20:00',1.05),('16100','2014-01-25','15:40:00',2.8),('16100','2014-01-25','15:45:00',1.43),('16100','2014-01-24','09:40:00',1.24),('16100','2014-01-24','09:45:00',1.57),('16100','2014-01-24','09:50:00',3.01),('16100','2014-01-24','09:55:00',2.27),('16100','2014-01-24','10:00:00',2.95),('16100','2014-01-24','10:05:00',5.08),('16100','2014-01-24','10:10:00',5.05),('16100','2014-01-24','10:15:00',4.48),('16100','2014-01-24','10:20:00',4.05),('16100','2014-01-24','10:25:00',3.37),('16100','2014-01-24','10:30:00',4.32),('16100','2014-01-24','10:35:00',3.95),('16100','2014-01-24','10:40:00',2.94),('16100','2014-01-24','10:45:00',4.79),('16100','2014-01-24','10:50:00',5.94),('16100','2014-01-24','10:55:00',5.42),('16100','2014-01-24','11:00:00',5.07),('16100','2014-01-24','11:05:00',5.09),('16100','2014-01-24','11:10:00',6.23),('16100','2014-01-24','11:15:00',6.39),('16100','2014-01-24','11:20:00',6.92),('16100','2014-01-24','11:25:00',6.75),('16100','2014-01-24','11:30:00',3.23),('16100','2014-01-24','11:35:00',4.86),('16100','2014-01-24','11:40:00',3.48),('16100','2014-01-24','11:45:00',3.39),('16100','2014-01-24','11:50:00',3.43),('16100','2014-01-24','11:55:00',3.38),('16100','2014-01-24','12:00:00',3.23),('16100','2014-01-24','12:05:00',3.38),('16100','2014-01-24','12:10:00',3.48),('16100','2014-01-24','12:15:00',3.33),('16100','2014-01-24','12:20:00',3.16),('16100','2014-01-24','12:25:00',2.98),('16100','2014-01-24','12:30:00',2.93),('16100','2014-01-24','12:35:00',3.17),('16100','2014-01-24','12:40:00',2.69),('16100','2014-01-24','12:45:00',3.25),('16100','2014-01-24','12:50:00',4.48),('16100','2014-01-24','12:55:00',4.99),('16100','2014-01-24','13:00:00',5.26),('16100','2014-01-24','13:05:00',5.53),('16100','2014-01-24','13:10:00',6.07),('16100','2014-01-24','13:15:00',6.29),('16100','2014-01-24','13:20:00',6.15),('16100','2014-01-24','13:25:00',6.06),('16100','2014-01-24','13:30:00',6.28),('16100','2014-01-24','13:35:00',5.24),('16100','2014-01-24','13:40:00',5.32),('16100','2014-01-24','13:45:00',5.42),('16100','2014-01-24','13:50:00',3.14),('16100','2014-01-24','13:55:00',5.98),('16100','2014-01-24','14:00:00',4.38),('16100','2014-01-24','14:05:00',5.45),('16100','2014-01-24','14:10:00',5.32),('16100','2014-01-24','14:15:00',5.22),('16100','2014-01-24','14:20:00',5.15),('16100','2014-01-24','14:25:00',5.51),('16100','2014-01-24','14:30:00',5.89),('16100','2014-01-24','14:35:00',4.9),('16100','2014-01-24','14:40:00',2.73),('16100','2014-01-24','14:45:00',2.73),('16100','2014-01-24','14:50:00',2.39),('16100','2014-01-24','14:55:00',1.18),('16100','2014-01-24','15:00:00',2.69),('16100','2014-01-24','15:05:00',4.11),('16100','2014-01-24','15:10:00',3.95),('16100','2014-01-24','15:15:00',3.89),('16100','2014-01-24','15:20:00',3.6),('16100','2014-01-24','15:25:00',3.4),('16100','2014-01-24','15:30:00',3.2),('16100','2014-01-24','15:35:00',3.05),('16100','2014-01-24','15:40:00',2.89),('16100','2014-01-24','15:45:00',2.74),('16100','2014-01-24','15:50:00',2.53),('16100','2014-01-24','15:55:00',2.37),('16100','2014-01-24','16:00:00',2.22),('16100','2014-01-24','16:05:00',2.04),('16100','2014-01-24','16:10:00',1.88),('16100','2014-01-24','16:15:00',1.67),('16100','2014-01-24','16:20:00',1.47),('16100','2014-01-24','16:25:00',1.3),('16100','2014-01-24','16:30:00',1.11),('16100','2014-01-23','10:00:00',1.43),('16100','2014-01-23','10:05:00',2.55),('16100','2014-01-23','10:10:00',3.25),('16100','2014-01-23','10:15:00',3.81),('16100','2014-01-23','10:20:00',4.61),('16100','2014-01-23','10:25:00',2.95),('16100','2014-01-23','10:30:00',4.67),('16100','2014-01-23','10:35:00',2.99),('16100','2014-01-23','10:40:00',4.54),('16100','2014-01-23','10:45:00',3.31),('16100','2014-01-23','10:50:00',5.25),('16100','2014-01-23','10:55:00',3.01),('16100','2014-01-23','11:00:00',1.78),('16100','2014-01-23','11:05:00',1.17),('16100','2014-01-23','11:15:00',1.58),('16100','2014-01-23','11:20:00',1.75),('16100','2014-01-23','11:25:00',1.49),('16100','2014-01-23','11:30:00',4.01),('16100','2014-01-23','11:35:00',1.14),('16100','2014-01-23','11:40:00',2.93),('16100','2014-01-23','11:45:00',6.54),('16100','2014-01-23','11:50:00',2),('16100','2014-01-23','11:55:00',1.56),('16100','2014-01-23','12:00:00',4.75),('16100','2014-01-23','12:05:00',3.38),('16100','2014-01-23','12:10:00',3.84),('16100','2014-01-23','12:15:00',2.68),('16100','2014-01-23','12:20:00',4.2),('16100','2014-01-23','12:25:00',4.14),('16100','2014-01-23','12:30:00',2.22),('16100','2014-01-23','12:35:00',2.07),('16100','2014-01-23','12:40:00',4.21),('16100','2014-01-23','12:45:00',6.24),('16100','2014-01-23','12:50:00',3.91),('16100','2014-01-23','12:55:00',1.81),('16100','2014-01-23','13:00:00',1.96),('16100','2014-01-23','13:05:00',1.88),('16100','2014-01-23','13:10:00',1.67),('16100','2014-01-23','13:15:00',4.06),('16100','2014-01-23','13:20:00',6.49),('16100','2014-01-23','13:25:00',3.67),('16100','2014-01-23','13:30:00',4.97),('16100','2014-01-23','13:35:00',1.02),('16100','2014-01-23','13:40:00',3.69),('16100','2014-01-23','13:45:00',4.04),('16100','2014-01-23','13:50:00',4.85),('16100','2014-01-23','13:55:00',6.07),('16100','2014-01-23','14:00:00',4.38),('16100','2014-01-23','14:05:00',4.73),('16100','2014-01-23','14:10:00',4.17),('16100','2014-01-23','14:15:00',3.67),('16100','2014-01-23','14:20:00',5.73),('16100','2014-01-23','14:25:00',6.02),('16100','2014-01-23','14:30:00',4.52),('16100','2014-01-23','14:35:00',2.45),('16100','2014-01-23','14:40:00',2.07),('16100','2014-01-23','14:45:00',4.44),('16100','2014-01-23','14:50:00',2.5),('16100','2014-01-22','10:20:00',1.12),('16100','2014-01-22','10:45:00',1.37),('16100','2014-01-22','10:50:00',1.46),('16100','2014-01-22','10:55:00',1.49),('16100','2014-01-22','11:00:00',1.52),('16100','2014-01-22','11:05:00',1.66),('16100','2014-01-22','11:10:00',1.75),('16100','2014-01-22','11:15:00',1.52),('16100','2014-01-22','11:20:00',1.44),('16100','2014-01-22','11:25:00',1.25),('16100','2014-01-22','12:05:00',1.33),('16100','2014-01-22','12:10:00',1.37),('16100','2014-01-22','12:25:00',1.5),('16100','2014-01-22','12:30:00',1.99),('16100','2014-01-22','12:35:00',2.09),('16100','2014-01-22','12:40:00',1.73),('16100','2014-01-22','12:45:00',1.08),('16100','2014-01-22','14:00:00',1.01),('16100','2014-01-22','14:05:00',1.1),('16100','2014-01-22','14:10:00',1.19),('16100','2014-01-22','14:15:00',1.18),('16100','2014-01-21','11:00:00',1.14),('16100','2014-01-21','11:05:00',1.31),('16100','2014-01-21','11:10:00',1.53),('16100','2014-01-21','11:15:00',1.58),('16100','2014-01-21','11:20:00',1.57),('16100','2014-01-21','11:25:00',1.47),('16100','2014-01-21','11:30:00',1.24),('16100','2014-01-21','11:35:00',1.31),('16100','2014-01-21','11:40:00',1.39),('16100','2014-01-21','12:00:00',1.26),('16100','2014-01-21','12:05:00',1.25),('16100','2014-01-21','12:10:00',1.23),('16100','2014-01-21','12:15:00',1),('16100','2014-01-21','12:35:00',1.08),('16100','2014-01-21','12:40:00',1.32),('16100','2014-01-21','12:45:00',1.86),('16100','2014-01-21','12:50:00',1.88),('16100','2014-01-21','12:55:00',2.03),('16100','2014-01-21','13:00:00',1.53),('16100','2014-01-21','13:05:00',1.2),('16100','2014-01-21','13:15:00',1.02),('16100','2014-01-21','13:20:00',1.02),('16100','2014-01-21','13:25:00',1.03),('16100','2014-01-21','13:30:00',1.07),('16100','2014-01-21','13:40:00',1.06),('16100','2014-01-21','13:45:00',1.1),('16100','2014-01-21','13:50:00',1.07),('16100','2014-01-21','13:55:00',1.03),('16100','2014-01-21','16:05:00',2),('16100','2014-01-21','16:10:00',2.3),('16100','2014-01-21','16:15:00',2.02),('16100','2014-01-21','16:25:00',1.24),('16100','2014-01-21','16:30:00',1.05),('16100','2014-01-20','09:40:00',1.28),('16100','2014-01-20','09:45:00',1.11),('16100','2014-01-20','09:50:00',1.58),('16100','2014-01-20','09:55:00',3.21),('16100','2014-01-20','10:00:00',1.22),('16100','2014-01-20','10:25:00',1.11),('16100','2014-01-20','10:30:00',1.35),('16100','2014-01-20','10:55:00',1.18),('16100','2014-01-20','11:00:00',1.09),('16100','2014-01-20','11:05:00',1.14),('16100','2014-01-20','11:10:00',1.23),('16100','2014-01-20','11:15:00',1.18),('16100','2014-01-20','11:20:00',1.12),('16100','2014-01-20','11:30:00',1),('16100','2014-01-20','11:35:00',3.37),('16100','2014-01-20','11:40:00',5.14),('16100','2014-01-20','11:45:00',4.46),('16100','2014-01-20','11:50:00',1.99),('16100','2014-01-20','11:55:00',2.61),('16100','2014-01-20','12:00:00',2.63),('16100','2014-01-20','12:05:00',2.59),('16100','2014-01-20','12:10:00',2.13),('16100','2014-01-20','12:15:00',2.18),('16100','2014-01-20','12:20:00',3.37),('16100','2014-01-20','12:25:00',2.59),('16100','2014-01-20','12:30:00',2.42),('16100','2014-01-20','12:35:00',2.27),('16100','2014-01-20','12:40:00',1.5),('16100','2014-01-20','12:45:00',1.44),('16100','2014-01-20','12:50:00',1.37),('16100','2014-01-20','12:55:00',1.27),('16100','2014-01-20','13:00:00',1.3),('16100','2014-01-20','13:05:00',1.25),('16100','2014-01-20','13:10:00',1.23),('16100','2014-01-20','13:15:00',1.55),('16100','2014-01-20','13:20:00',1.33),('16100','2014-01-20','13:50:00',1.06),('16100','2014-01-20','13:55:00',1.21),('16100','2014-01-20','14:00:00',1.21),('16100','2014-01-20','15:00:00',1.02),('16100','2014-01-20','15:05:00',1.7),('16100','2014-01-20','15:10:00',1.4),('16100','2014-01-20','15:20:00',2.12),('16100','2014-01-20','15:25:00',1.49),('16100','2014-01-20','15:30:00',1.37),('16100','2014-01-20','15:35:00',1.88),('16100','2014-01-20','15:40:00',2.15),('16100','2014-01-19','10:35:00',1),('16100','2014-01-19','11:50:00',1.14),('16100','2014-01-19','11:55:00',2.79),('16100','2014-01-19','12:00:00',2.2),('16100','2014-01-19','12:05:00',3.12),('16100','2014-01-19','12:10:00',2.67),('16100','2014-01-19','12:15:00',2.06),('16100','2014-01-19','12:20:00',1.42),('16100','2014-01-19','12:25:00',1.45),('16100','2014-01-19','12:30:00',3.06),('16100','2014-01-19','12:35:00',2.42),('16100','2014-01-19','12:40:00',3.46),('16100','2014-01-19','12:45:00',7),('16100','2014-01-19','12:50:00',1.8),('16100','2014-01-19','12:55:00',4.88),('16100','2014-01-19','13:00:00',4.3),('16100','2014-01-19','13:05:00',1.97),('16100','2014-01-19','13:25:00',1.34),('16100','2014-01-19','13:30:00',1.78),('16100','2014-01-19','13:35:00',1.93),('16100','2014-01-19','13:40:00',1.57),('16100','2014-01-19','13:45:00',1.15),('16100','2014-01-19','14:10:00',1.19),('16100','2014-01-19','14:15:00',1.75),('16100','2014-01-19','14:20:00',1.91),('16100','2014-01-19','14:25:00',1.11),('16100','2014-01-18','11:45:00',1.16),('16100','2014-01-18','11:50:00',1.66),('16100','2014-01-18','11:55:00',2),('16100','2014-01-18','12:00:00',1.66),('16100','2014-01-18','12:05:00',1.62),('16100','2014-01-18','12:10:00',1.48),('16100','2014-01-18','12:15:00',1.34),('16100','2014-01-18','12:20:00',1.49),('16100','2014-01-18','12:25:00',1.61),('16100','2014-01-18','12:30:00',1.45),('16100','2014-01-18','13:00:00',1.06),('16100','2014-01-18','13:05:00',1.65),('16100','2014-01-18','13:10:00',1.89),('16100','2014-01-18','13:15:00',1.44),('16100','2014-01-18','13:20:00',1.14),('16100','2014-01-18','13:25:00',1.02),('16100','2014-01-18','13:30:00',1.06),('16100','2014-01-18','13:35:00',1.03),('16100','2014-01-18','13:55:00',1.21),('16100','2014-01-18','14:00:00',1.05),('16100','2014-01-18','14:15:00',1.82),('16100','2014-01-18','14:20:00',2.56),('16100','2014-01-18','14:25:00',2.26),('16100','2014-01-18','14:30:00',1.99),('16100','2014-01-18','14:35:00',1.56),('16100','2014-01-18','14:40:00',1.16),('16100','2014-01-17','09:35:00',1.3),('16100','2014-01-17','09:40:00',1.43),('16100','2014-01-17','09:45:00',1.92),('16100','2014-01-17','09:50:00',2.09),('16100','2014-01-17','09:55:00',2.02),('16100','2014-01-17','10:00:00',3.67),('16100','2014-01-17','10:05:00',2.8),('16100','2014-01-17','10:10:00',3.14),('16100','2014-01-17','10:15:00',5.23),('16100','2014-01-17','10:20:00',4.3),('16100','2014-01-17','10:25:00',3.51),('16100','2014-01-17','10:30:00',3.57),('16100','2014-01-17','10:35:00',2.77),('16100','2014-01-17','10:40:00',3.29),('16100','2014-01-17','10:45:00',2.54),('16100','2014-01-17','10:50:00',2.04),('16100','2014-01-17','10:55:00',1.62),('16100','2014-01-17','11:00:00',1.49),('16100','2014-01-17','11:05:00',4.43),('16100','2014-01-17','11:10:00',5.54),('16100','2014-01-17','11:15:00',3.35),('16100','2014-01-17','11:20:00',5.1),('16100','2014-01-17','11:25:00',5.68),('16100','2014-01-17','11:30:00',5.69),('16100','2014-01-17','11:35:00',5.7),('16100','2014-01-17','11:40:00',4.07),('16100','2014-01-17','11:45:00',2),('16100','2014-01-17','11:50:00',1.91),('16100','2014-01-17','11:55:00',2.93),('16100','2014-01-17','12:00:00',5.13),('16100','2014-01-17','12:05:00',2.65),('16100','2014-01-17','12:10:00',6.03),('16100','2014-01-17','12:15:00',5.68),('16100','2014-01-17','12:20:00',5.8),('16100','2014-01-17','12:25:00',5.69),('16100','2014-01-17','12:30:00',5.88),('16100','2014-01-17','12:35:00',5.85),('16100','2014-01-17','12:40:00',5.54),('16100','2014-01-17','12:45:00',5.65),('16100','2014-01-17','12:50:00',5.31),('16100','2014-01-17','12:55:00',4.98),('16100','2014-01-17','13:00:00',4.69),('16100','2014-01-17','13:05:00',3.63),('16100','2014-01-17','13:10:00',4.47),('16100','2014-01-17','13:15:00',5.87),('16100','2014-01-17','13:20:00',5.74),('16100','2014-01-17','13:25:00',3.38),('16100','2014-01-17','13:30:00',4.62),('16100','2014-01-17','13:35:00',5.74),('16100','2014-01-17','13:40:00',4.63),('16100','2014-01-17','13:45:00',5.46),('16100','2014-01-17','13:50:00',5.29),('16100','2014-01-17','13:55:00',3.84),('16100','2014-01-17','14:00:00',5.12),('16100','2014-01-17','14:05:00',4.83),('16100','2014-01-17','14:10:00',4.65),('16100','2014-01-17','14:15:00',4.38),('16100','2014-01-17','14:20:00',4.55),('16100','2014-01-17','14:25:00',4.4),('16100','2014-01-17','14:30:00',4.25),('16100','2014-01-17','14:35:00',4.1),('16100','2014-01-17','14:40:00',3.88),('16100','2014-01-17','14:45:00',3.8),('16100','2014-01-17','14:50:00',3.45),('16100','2014-01-17','14:55:00',2.1),('16100','2014-01-17','15:05:00',1.07),('16100','2014-01-17','15:10:00',1.11),('16100','2014-01-17','15:15:00',1.03),('16100','2014-01-17','15:20:00',1.09),('16100','2014-01-17','15:25:00',1.06),('16100','2014-01-17','15:30:00',2.01),('16100','2014-01-17','15:35:00',1.01),('16100','2014-01-17','15:50:00',1.58),('16100','2014-01-17','15:55:00',1.89),('16100','2014-01-17','16:00:00',1.2),('16100','2014-01-17','16:05:00',1.57),('16100','2014-01-16','08:55:00',1.9),('16100','2014-01-16','09:00:00',2.05),('16100','2014-01-16','09:05:00',2.08),('16100','2014-01-16','09:10:00',2.28),('16100','2014-01-16','09:15:00',2.33),('16100','2014-01-16','09:20:00',2.13),('16100','2014-01-16','09:25:00',2.83),('16100','2014-01-16','09:30:00',2.83),('16100','2014-01-16','09:35:00',2.9),('16100','2014-01-16','09:40:00',2.2),('16100','2014-01-16','09:45:00',1.32),('16100','2014-01-16','09:55:00',1.26),('16100','2014-04-24','07:55:00',1.08),('16100','2014-04-24','08:00:00',1.17),('16100','2014-04-24','08:05:00',1.34),('16100','2014-04-24','08:10:00',1.16),('16100','2014-04-24','08:15:00',1.06),('16100','2014-04-24','08:20:00',1.88),('16100','2014-04-24','08:25:00',2.08),('16100','2014-04-24','08:30:00',2.25),('16100','2014-04-24','08:35:00',2.37),('16100','2014-04-24','08:40:00',2.54),('16100','2014-04-24','08:45:00',2.69),('16100','2014-04-24','08:50:00',2.88),('16100','2014-04-24','08:55:00',3.13),('16100','2014-04-24','09:00:00',3.48),('16100','2014-04-24','09:05:00',3.4),('16100','2014-04-24','09:10:00',2.96),('16100','2014-04-24','09:15:00',3.1),('16100','2014-04-24','09:20:00',1.83),('16100','2014-04-24','09:25:00',1.48),('16100','2014-04-24','09:30:00',1.44),('16100','2014-04-24','09:35:00',1.35),('16100','2014-04-24','09:40:00',1.3),('16100','2014-04-24','09:45:00',1.17),('16100','2014-04-24','09:50:00',1.2),('16100','2014-04-24','09:55:00',1.55),('16100','2014-04-24','10:00:00',2.1),('16100','2014-04-24','10:05:00',2.53),('16100','2014-04-24','10:10:00',2.63),('16100','2014-04-24','10:15:00',3.45),('16100','2014-04-24','10:20:00',3.72),('16100','2014-04-24','10:25:00',2.34),('16100','2014-04-24','10:30:00',1.18),('16100','2014-04-24','10:35:00',1.07),('16100','2014-04-24','10:40:00',1.49),('16100','2014-04-24','10:45:00',2.07),('16100','2014-04-24','10:50:00',3.67),('16100','2014-04-24','10:55:00',7.14),('16100','2014-04-24','11:00:00',2.76),('16100','2014-04-24','11:05:00',3.83),('16100','2014-04-24','11:10:00',6.9),('16100','2014-04-24','11:15:00',7.22),('16100','2014-04-24','11:20:00',4.37),('16100','2014-04-24','11:25:00',2.06),('16100','2014-04-24','11:30:00',1.91),('16100','2014-04-24','11:35:00',2.09),('16100','2014-04-24','11:40:00',4.01),('16100','2014-04-24','11:45:00',7.51),('16100','2014-04-24','11:50:00',7.95),('16100','2014-04-24','11:55:00',4.9),('16100','2014-04-24','12:00:00',3.89),('16100','2014-04-24','12:05:00',6.8),('16100','2014-04-24','12:10:00',7.41),('16100','2014-04-24','12:15:00',6.5),('16100','2014-04-24','12:20:00',6.32),('16100','2014-04-24','12:25:00',7.93),('16100','2014-04-24','12:30:00',7.81),('16100','2014-04-24','12:35:00',4.28),('16100','2014-04-24','12:40:00',7.98),('16100','2014-04-24','12:45:00',5.11),('16100','2014-04-24','12:50:00',2.97),('16100','2014-04-24','12:55:00',8.73),('16100','2014-04-24','13:00:00',4.39),('16100','2014-04-24','13:05:00',7.5),('16100','2014-04-24','13:10:00',7.32),('16100','2014-04-24','13:15:00',7.12),('16100','2014-04-24','13:20:00',7.23),('16100','2014-04-24','13:25:00',4.5),('16100','2014-04-24','13:30:00',7.08),('16100','2014-04-24','13:35:00',7.48),('16100','2014-04-24','13:40:00',5.66),('16100','2014-04-24','13:45:00',2.94),('16100','2014-04-24','13:50:00',3.23),('16100','2014-04-24','13:55:00',5.05),('16100','2014-04-24','14:00:00',4.97),('16100','2014-04-24','14:05:00',6.7),('16100','2014-04-24','14:10:00',6.36),('16100','2014-04-24','14:15:00',7.3),('16100','2014-04-24','14:20:00',7.12),('16100','2014-04-24','14:25:00',7.07),('16100','2014-04-24','14:30:00',7.04),('16100','2014-04-24','14:35:00',6.95),('16100','2014-04-24','14:40:00',6.9),('16100','2014-04-24','14:45:00',6.84),('16100','2014-04-24','14:50:00',6.8),('16100','2014-04-24','14:55:00',6.76),('16100','2014-04-24','15:00:00',6.71),('16100','2014-04-24','15:05:00',6.51),('16100','2014-04-24','15:10:00',6.4),('16100','2014-04-24','15:15:00',6.34),('16100','2014-04-24','15:20:00',6.27),('16100','2014-04-24','15:25:00',6.06),('16100','2014-04-24','15:30:00',6.05),('16100','2014-04-24','15:35:00',6.08),('16100','2014-04-24','15:40:00',5.91),('16100','2014-04-24','15:45:00',5.7),('16100','2014-04-24','15:50:00',5.69),('16100','2014-04-24','15:55:00',5.66),('16100','2014-04-24','16:00:00',5.43),('16100','2014-04-24','16:05:00',5.13),('16100','2014-04-24','16:10:00',5.19),('16100','2014-04-24','16:15:00',4.58),('16100','2014-04-24','16:20:00',4.57),('16100','2014-04-24','16:25:00',4.51),('16100','2014-04-24','16:30:00',4.34),('16100','2014-04-24','16:35:00',4.61),('16100','2014-04-24','16:40:00',4.66),('16100','2014-04-24','16:45:00',4.42),('16100','2014-04-24','16:50:00',3.89),('16100','2014-04-24','16:55:00',2.75),('16100','2014-04-24','17:00:00',3),('16100','2014-04-24','17:05:00',2.77),('16100','2014-04-24','17:10:00',1.49),('16100','2014-04-24','17:15:00',2.17),('16100','2014-04-24','17:20:00',2.58),('16100','2014-04-24','17:25:00',2.3),('16100','2014-04-24','17:30:00',2.55),('16100','2014-04-24','17:35:00',1.78),('16100','2014-04-24','17:40:00',1.59),('16100','2014-04-24','17:45:00',1.58),('16100','2014-04-24','17:50:00',1.3),('16100','2014-04-24','17:55:00',1.25),('16100','2014-04-24','18:00:00',1.22),('16100','2014-04-24','18:05:00',1.14),('16100','2014-04-24','18:10:00',1.06),('16100','2014-01-15','08:15:00',1.04),('16100','2014-01-15','08:20:00',1.36),('16100','2014-01-15','08:25:00',1.26),('16100','2014-01-15','08:30:00',1.25),('16100','2014-01-15','08:35:00',1.43),('16100','2014-01-15','08:40:00',1.4),('16100','2014-01-15','08:45:00',1.24),('16100','2014-01-15','08:50:00',1.25),('16100','2014-01-15','08:55:00',1.44),('16100','2014-01-15','09:00:00',1.62),('16100','2014-01-15','09:05:00',1.85),('16100','2014-01-15','09:10:00',2.03),('16100','2014-01-15','09:15:00',2.52),('16100','2014-01-15','09:20:00',3.22),('16100','2014-01-15','09:25:00',3.35),('16100','2014-01-15','09:30:00',3.34),('16100','2014-01-15','09:35:00',3.52),('16100','2014-01-15','09:40:00',3.36),('16100','2014-01-15','09:45:00',2.45),('16100','2014-01-15','09:50:00',1.86),('16100','2014-01-15','09:55:00',1.54),('16100','2014-01-15','10:00:00',1.58),('16100','2014-01-15','10:05:00',1.81),('16100','2014-01-15','10:10:00',2.31),('16100','2014-01-15','10:15:00',2.34),('16100','2014-01-15','10:20:00',2.45),('16100','2014-01-15','10:25:00',3.56),('16100','2014-01-15','10:30:00',4.69),('16100','2014-01-15','10:35:00',4.68),('16100','2014-01-15','10:40:00',3.08),('16100','2014-01-15','10:45:00',3.57),('16100','2014-01-15','10:50:00',4.03),('16100','2014-01-15','10:55:00',3.83),('16100','2014-01-15','11:00:00',4.14),('16100','2014-01-15','11:05:00',4.3),('16100','2014-01-15','11:10:00',4.44),('16100','2014-01-15','11:15:00',3.93),('16100','2014-01-15','11:20:00',3.91),('16100','2014-01-15','11:25:00',3.71),('16100','2014-01-15','11:30:00',3.39),('16100','2014-01-15','11:35:00',3.49),('16100','2014-01-15','11:40:00',3.57),('16100','2014-01-15','11:45:00',3.71),('16100','2014-01-15','11:50:00',3.77),('16100','2014-01-15','11:55:00',3.9),('16100','2014-01-15','12:00:00',3.82),('16100','2014-01-15','12:05:00',3.71),('16100','2014-01-15','12:10:00',3.66),('16100','2014-01-15','12:15:00',3.28),('16100','2014-01-15','12:20:00',3),('16100','2014-01-15','12:25:00',2.98),('16100','2014-01-15','12:30:00',3.38),('16100','2014-01-15','12:35:00',3.85),('16100','2014-01-15','12:40:00',3.93),('16100','2014-01-15','12:45:00',4.08),('16100','2014-01-15','12:50:00',4.27),('16100','2014-01-15','12:55:00',4.4),('16100','2014-01-15','13:00:00',4.56),('16100','2014-01-15','13:05:00',4.55),('16100','2014-01-15','13:10:00',4.53),('16100','2014-01-15','13:15:00',4.61),('16100','2014-01-15','13:20:00',4.75),('16100','2014-01-15','13:25:00',4.79),('16100','2014-01-15','13:30:00',4.87),('16100','2014-01-15','13:35:00',4.73),('16100','2014-01-15','13:40:00',4.99),('16100','2014-01-15','13:45:00',5.12),('16100','2014-01-15','13:50:00',2.37),('16100','2014-01-15','13:55:00',1.47),('16100','2014-01-15','14:00:00',1.57),('16100','2014-01-15','14:05:00',1.69),('16100','2014-01-15','14:10:00',1.66),('16100','2014-01-15','14:15:00',1.59),('16100','2014-01-15','14:20:00',1.57),('16100','2014-01-15','14:25:00',1.57),('16100','2014-01-15','14:30:00',1.57),('16100','2014-01-15','14:35:00',1.49),('16100','2014-01-15','14:40:00',1.4),('16100','2014-01-15','14:45:00',1.37),('16100','2014-01-15','14:50:00',1.39),('16100','2014-01-15','14:55:00',1.38),('16100','2014-01-15','15:00:00',1.81),('16100','2014-01-15','15:05:00',1.4),('16100','2014-01-15','15:10:00',1.44),('16100','2014-01-15','15:15:00',1.09),('16100','2014-01-14','09:30:00',1.33),('16100','2014-01-14','09:35:00',1.81),('16100','2014-01-14','09:40:00',1.39),('16100','2014-01-14','09:55:00',1.03),('16100','2014-01-14','10:00:00',1.99),('16100','2014-01-14','10:05:00',3.07),('16100','2014-01-14','10:10:00',3.93),('16100','2014-01-14','10:15:00',4.52),('16100','2014-01-14','10:20:00',4.69),('16100','2014-01-14','10:25:00',4.82),('16100','2014-01-14','10:30:00',5),('16100','2014-01-14','10:35:00',4.81),('16100','2014-01-14','10:40:00',4.71),('16100','2014-01-14','10:45:00',4.65),('16100','2014-01-14','10:50:00',4.5),('16100','2014-01-14','10:55:00',4.67),('16100','2014-01-14','11:00:00',5.45),('16100','2014-01-14','11:05:00',5.7),('16100','2014-01-14','11:10:00',5.57),('16100','2014-01-14','11:15:00',5.8),('16100','2014-01-14','11:20:00',5.93),('16100','2014-01-14','11:25:00',5.91),('16100','2014-01-14','11:30:00',4.3),('16100','2014-01-14','11:35:00',4.06),('16100','2014-01-14','11:40:00',3.3),('16100','2014-01-14','11:45:00',3.11),('16100','2014-01-14','11:50:00',2.86),('16100','2014-01-14','11:55:00',2.68),('16100','2014-01-14','12:00:00',2.86),('16100','2014-01-14','12:05:00',3.24),('16100','2014-01-14','12:10:00',3.05),('16100','2014-01-14','12:15:00',3.35),('16100','2014-01-14','12:20:00',2.73),('16100','2014-01-14','12:25:00',2.35),('16100','2014-01-14','12:30:00',2.83),('16100','2014-01-14','12:35:00',4.24),('16100','2014-01-14','12:40:00',4.6),('16100','2014-01-14','12:45:00',4.33),('16100','2014-01-14','12:50:00',5.2),('16100','2014-01-14','12:55:00',5.2),('16100','2014-01-14','13:00:00',6.01),('16100','2014-01-14','13:05:00',4.97),('16100','2014-01-14','13:10:00',4.85),('16100','2014-01-14','13:15:00',5.86),('16100','2014-01-14','13:20:00',5.74),('16100','2014-01-14','13:25:00',5.59),('16100','2014-01-14','13:30:00',5.49),('16100','2014-01-14','13:35:00',5.52),('16100','2014-01-14','13:40:00',5.32),('16100','2014-01-14','13:45:00',2.98),('16100','2014-01-14','13:55:00',4.2),('16100','2014-01-14','14:10:00',3.2),('16100','2014-01-14','14:15:00',4.24),('16100','2014-01-14','14:20:00',4.15),('16100','2014-01-14','14:25:00',3.89),('16100','2014-01-14','14:30:00',2.14),('16100','2014-01-14','14:35:00',4.23),('16100','2014-01-14','14:40:00',4.12),('16100','2014-01-14','14:45:00',3.97),('16100','2014-01-14','14:50:00',3.85),('16100','2014-01-14','14:55:00',3.76),('16100','2014-01-14','15:00:00',3.64),('16100','2014-01-14','15:05:00',3.5),('16100','2014-01-14','15:10:00',3.34),('16100','2014-01-14','15:15:00',3.21),('16100','2014-01-14','15:20:00',3.05),('16100','2014-01-14','15:25:00',2.9),('16100','2014-01-14','15:30:00',2.71),('16100','2014-01-14','15:35:00',2.57),('16100','2014-01-14','15:40:00',2.42),('16100','2014-01-14','15:45:00',2.22),('16100','2014-01-14','15:50:00',2.04),('16100','2014-01-14','15:55:00',1.87),('16100','2014-01-14','16:00:00',1.7),('16100','2014-01-14','16:05:00',1.52),('16100','2014-01-14','16:10:00',1.34),('16100','2014-01-14','16:15:00',1.16),('16100','2014-01-13','10:20:00',1.04),('16100','2014-01-13','10:25:00',3.36),('16100','2014-01-13','10:30:00',5.09),('16100','2014-01-13','10:35:00',3.86),('16100','2014-01-13','10:40:00',1.79),('16100','2014-01-13','10:45:00',1.89),('16100','2014-01-13','10:50:00',1.69),('16100','2014-01-13','10:55:00',1.99),('16100','2014-01-13','11:00:00',2.01),('16100','2014-01-13','11:05:00',1.38),('16100','2014-01-13','11:30:00',1.15),('16100','2014-01-12','08:55:00',1.28),('16100','2014-01-12','09:00:00',1.71),('16100','2014-01-12','09:05:00',1.37),('16100','2014-01-12','09:10:00',2.37),('16100','2014-01-12','09:15:00',2.76),('16100','2014-01-12','09:20:00',2.8),('16100','2014-01-12','09:25:00',2.88),('16100','2014-01-12','09:30:00',3.02),('16100','2014-01-12','09:35:00',3.13),('16100','2014-01-12','09:40:00',3.22),('16100','2014-01-12','09:45:00',3.33),('16100','2014-01-12','09:50:00',3.46),('16100','2014-01-12','09:55:00',3.57),('16100','2014-01-12','10:00:00',3.7),('16100','2014-01-12','10:05:00',3.83),('16100','2014-01-12','10:10:00',3.92),('16100','2014-01-12','10:15:00',4.04),('16100','2014-01-12','10:20:00',4.15),('16100','2014-01-12','10:25:00',4.23),('16100','2014-01-12','10:30:00',4.32),('16100','2014-01-12','10:35:00',4.44),('16100','2014-01-12','10:40:00',4.55),('16100','2014-01-12','10:45:00',4.69),('16100','2014-01-12','10:50:00',4.79),('16100','2014-01-12','10:55:00',4.84),('16100','2014-01-12','11:00:00',4.81),('16100','2014-01-12','11:05:00',4.96),('16100','2014-01-12','11:10:00',4.98),('16100','2014-01-12','11:15:00',5.05),('16100','2014-01-12','11:20:00',5.12),('16100','2014-01-12','11:25:00',5.15),('16100','2014-01-12','11:30:00',5.13),('16100','2014-01-12','11:35:00',5.12),('16100','2014-01-12','11:40:00',5.18),('16100','2014-01-12','11:45:00',5.18),('16100','2014-01-12','11:50:00',5.15),('16100','2014-01-12','11:55:00',5.15),('16100','2014-01-12','12:00:00',5.13),('16100','2014-01-12','12:05:00',5.13),('16100','2014-01-12','12:10:00',5.09),('16100','2014-01-12','12:15:00',5.09),('16100','2014-01-12','12:20:00',5.18),('16100','2014-01-12','12:25:00',5.13),('16100','2014-01-12','12:30:00',5.15),('16100','2014-01-12','12:35:00',5.14),('16100','2014-01-12','12:40:00',5.17),('16100','2014-01-12','12:45:00',5.19),('16100','2014-01-12','12:50:00',5.14),('16100','2014-01-12','12:55:00',4.96),('16100','2014-01-12','13:00:00',4.91),('16100','2014-01-12','13:05:00',4.78),('16100','2014-01-12','13:10:00',4.51),('16100','2014-01-12','13:15:00',4.55),('16100','2014-01-12','13:20:00',4.73),('16100','2014-01-12','13:25:00',4.28),('16100','2014-01-12','13:30:00',4.19),('16100','2014-01-12','13:35:00',4.67),('16100','2014-01-12','13:40:00',4.59),('16100','2014-01-12','13:45:00',4.58),('16100','2014-01-12','13:50:00',4.43),('16100','2014-01-12','13:55:00',4.43),('16100','2014-01-12','14:00:00',4.21),('16100','2014-01-12','14:05:00',4.17),('16100','2014-01-12','14:10:00',4.17),('16100','2014-01-12','14:15:00',4.06),('16100','2014-01-12','14:20:00',3.84),('16100','2014-01-12','14:25:00',3.58),('16100','2014-01-12','14:30:00',3.5),('16100','2014-01-12','14:35:00',3.45),('16100','2014-01-12','14:40:00',3.32),('16100','2014-01-12','14:45:00',3.21),('16100','2014-01-12','14:50:00',3.13),('16100','2014-01-12','14:55:00',3.08),('16100','2014-01-12','15:00:00',3.02),('16100','2014-01-12','15:05:00',2.94),('16100','2014-01-12','15:10:00',2.83),('16100','2014-01-12','15:15:00',2.67),('16100','2014-01-12','15:20:00',2.51),('16100','2014-01-12','15:25:00',2.35),('16100','2014-01-12','15:30:00',2.24),('16100','2014-01-12','15:35:00',2.1),('16100','2014-01-12','15:40:00',1.96),('16100','2014-01-12','15:45:00',1.8),('16100','2014-01-12','15:50:00',1.64),('16100','2014-01-12','15:55:00',1.52),('16100','2014-01-12','16:00:00',1.36),('16100','2014-01-12','16:05:00',1.19),('16100','2014-01-12','16:10:00',1.03),('16100','2014-01-11','09:20:00',1.02),('16100','2014-01-11','09:25:00',1.09),('16100','2014-01-11','09:35:00',1.12),('16100','2014-01-11','09:40:00',1.34),('16100','2014-01-11','09:45:00',1.39),('16100','2014-01-11','09:50:00',1.4),('16100','2014-01-11','09:55:00',1.38),('16100','2014-01-11','10:00:00',1.31),('16100','2014-01-11','10:05:00',1.29),('16100','2014-01-11','10:10:00',1.32),('16100','2014-01-11','10:15:00',1.41),('16100','2014-01-11','10:20:00',1.49),('16100','2014-01-11','10:25:00',1.57),('16100','2014-01-11','10:30:00',1.82),('16100','2014-01-11','10:35:00',1.98),('16100','2014-01-11','10:40:00',2.52),('16100','2014-01-11','10:45:00',2.4),('16100','2014-01-11','10:50:00',2.26),('16100','2014-01-11','10:55:00',2.42),('16100','2014-01-11','11:00:00',2.87),('16100','2014-01-11','11:05:00',2.83),('16100','2014-01-11','11:10:00',3.76),('16100','2014-01-11','11:15:00',3.15),('16100','2014-01-11','11:20:00',2.81),('16100','2014-01-11','11:25:00',2.81),('16100','2014-01-11','11:30:00',2.73),('16100','2014-01-11','11:35:00',3.36),('16100','2014-01-11','11:40:00',3.38),('16100','2014-01-11','11:45:00',3.78),('16100','2014-01-11','11:50:00',4.21),('16100','2014-01-11','11:55:00',2.8),('16100','2014-01-11','12:00:00',2.91),('16100','2014-01-11','12:05:00',2.49),('16100','2014-01-11','12:10:00',2.23),('16100','2014-01-11','12:15:00',2.04),('16100','2014-01-11','12:20:00',1.92),('16100','2014-01-11','12:25:00',1.87),('16100','2014-01-11','12:30:00',2.01),('16100','2014-01-11','12:35:00',1.96),('16100','2014-01-11','12:40:00',1.76),('16100','2014-01-11','12:45:00',1.66),('16100','2014-01-11','12:50:00',1.74),('16100','2014-01-11','12:55:00',1.79),('16100','2014-01-11','13:00:00',1.7),('16100','2014-01-11','13:05:00',1.71),('16100','2014-01-11','13:10:00',1.72),('16100','2014-01-11','13:15:00',1.72),('16100','2014-01-11','13:20:00',1.77),('16100','2014-01-11','13:25:00',1.92),('16100','2014-01-11','13:30:00',2.11),('16100','2014-01-11','13:35:00',2.11),('16100','2014-01-11','13:40:00',1.98),('16100','2014-01-11','13:45:00',1.85),('16100','2014-01-11','13:50:00',1.83),('16100','2014-01-11','13:55:00',1.73),('16100','2014-01-11','14:00:00',1.46),('16100','2014-01-11','14:05:00',1.3),('16100','2014-01-11','14:10:00',1.23),('16100','2014-01-11','14:15:00',1.11),('16100','2014-01-11','14:20:00',1),('16100','2014-01-10','09:20:00',1.33),('16100','2014-01-10','09:25:00',1.1),('16100','2014-01-10','09:45:00',1.72),('16100','2014-01-10','09:50:00',2.6),('16100','2014-01-10','09:55:00',2.95),('16100','2014-01-10','10:00:00',2.57),('16100','2014-01-10','10:05:00',2.35),('16100','2014-01-10','10:10:00',2.91),('16100','2014-01-10','10:15:00',2.9),('16100','2014-01-10','10:20:00',3.71),('16100','2014-01-10','10:25:00',3.29),('16100','2014-01-10','10:30:00',3.55),('16100','2014-01-10','10:35:00',3.92),('16100','2014-01-10','10:40:00',4.51),('16100','2014-01-10','10:45:00',4.8),('16100','2014-01-10','10:50:00',4.81),('16100','2014-01-10','10:55:00',4.83),('16100','2014-01-10','11:00:00',4.84),('16100','2014-01-10','11:05:00',4.31),('16100','2014-01-10','11:10:00',3.97),('16100','2014-01-10','11:15:00',3.91),('16100','2014-01-10','11:20:00',3.64),('16100','2014-01-10','11:25:00',3.32),('16100','2014-01-10','11:30:00',3.45),('16100','2014-01-10','11:35:00',4.15),('16100','2014-01-10','11:40:00',3.87),('16100','2014-01-10','11:45:00',3.93),('16100','2014-01-10','11:50:00',4.04),('16100','2014-01-10','11:55:00',4.15),('16100','2014-01-10','12:00:00',4.02),('16100','2014-01-10','12:05:00',3.86),('16100','2014-01-10','12:10:00',4.61),('16100','2014-01-10','12:15:00',5.17),('16100','2014-01-10','12:20:00',3.32),('16100','2014-01-10','12:25:00',3.13),('16100','2014-01-10','12:30:00',3.1),('16100','2014-01-10','12:35:00',2.54),('16100','2014-01-10','12:40:00',3.69),('16100','2014-01-10','12:45:00',3.52),('16100','2014-01-10','12:50:00',4.22),('16100','2014-01-10','12:55:00',4.44),('16100','2014-01-10','13:00:00',4.52),('16100','2014-01-10','13:05:00',4.89),('16100','2014-01-10','13:10:00',3.55),('16100','2014-01-10','13:15:00',3.67),('16100','2014-01-10','13:20:00',3.42),('16100','2014-01-10','13:25:00',2.69),('16100','2014-01-10','13:30:00',2.61),('16100','2014-01-10','13:35:00',2.4),('16100','2014-01-10','13:40:00',2.29),('16100','2014-01-10','13:45:00',1.74),('16100','2014-01-10','13:50:00',1.79),('16100','2014-01-10','13:55:00',2.32),('16100','2014-01-10','14:00:00',2.68),('16100','2014-01-10','14:05:00',2.65),('16100','2014-01-10','14:10:00',1.4),('16100','2014-01-10','14:15:00',1.08),('16100','2014-01-10','14:30:00',1.1),('16100','2014-01-10','14:35:00',1.21),('16100','2014-01-10','14:40:00',1.27),('16100','2014-01-10','14:45:00',1.21),('16100','2014-01-10','14:50:00',1.06),('16100','2014-01-10','14:55:00',1),('16100','2014-01-09','10:40:00',1.02),('16100','2014-01-09','10:45:00',1.07),('16100','2014-01-09','10:50:00',1.06),('16100','2014-01-09','10:55:00',1.13),('16100','2014-01-09','11:00:00',1.22),('16100','2014-01-09','11:05:00',1.15),('16100','2014-01-09','11:10:00',1.06),('16100','2014-01-09','11:25:00',1.02),('16100','2014-01-09','11:30:00',1.21),('16100','2014-01-09','11:35:00',1.28),('16100','2014-01-09','11:40:00',1.25),('16100','2014-01-09','11:45:00',1.47),('16100','2014-01-09','11:50:00',1.76),('16100','2014-01-09','11:55:00',1.68),('16100','2014-01-09','12:00:00',1.3),('16100','2014-01-09','12:10:00',1),('16100','2014-01-09','12:15:00',1.12),('16100','2014-01-09','12:20:00',1.23),('16100','2014-01-09','12:25:00',1.2),('16100','2014-01-09','12:30:00',1.28),('16100','2014-01-09','12:35:00',1.23),('16100','2014-01-09','12:40:00',1.19),('16100','2014-01-09','12:45:00',1.25),('16100','2014-01-09','12:50:00',1.33),('16100','2014-01-09','12:55:00',1.26),('16100','2014-01-09','13:00:00',1.26),('16100','2014-01-09','13:05:00',1.2),('16100','2014-01-09','13:10:00',1.01),('16100','2014-01-09','13:35:00',1.01),('16100','2014-01-09','13:45:00',1.05),('16100','2014-01-09','13:50:00',1.05),('16100','2014-01-08','09:20:00',1.07),('16100','2014-01-08','09:25:00',1.12),('16100','2014-01-08','09:30:00',1.14),('16100','2014-01-08','09:35:00',1.12),('16100','2014-01-08','09:40:00',1.26),('16100','2014-01-08','09:45:00',1.61),('16100','2014-01-08','09:50:00',1.76),('16100','2014-01-08','09:55:00',1.77),('16100','2014-01-08','10:00:00',1.62),('16100','2014-01-08','10:05:00',1.52),('16100','2014-01-08','10:10:00',1.64),('16100','2014-01-08','10:15:00',1.7),('16100','2014-01-08','10:20:00',1.64),('16100','2014-01-08','10:25:00',1.61),('16100','2014-01-08','10:30:00',1.79),('16100','2014-01-08','10:35:00',1.93),('16100','2014-01-08','10:40:00',2.28),('16100','2014-01-08','10:45:00',2.06),('16100','2014-01-08','10:50:00',1.87),('16100','2014-01-08','10:55:00',1.73),('16100','2014-01-08','11:00:00',1.69),('16100','2014-01-08','11:05:00',1.73),('16100','2014-01-08','11:10:00',1.96),('16100','2014-01-08','11:15:00',2.06),('16100','2014-01-08','11:20:00',2.5),('16100','2014-01-08','11:25:00',2.58),('16100','2014-01-08','11:30:00',1.98),('16100','2014-01-08','11:35:00',2.08),('16100','2014-01-08','11:40:00',2.12),('16100','2014-01-08','11:45:00',2.68),('16100','2014-01-08','11:50:00',2.7),('16100','2014-01-08','11:55:00',2.84),('16100','2014-01-08','12:00:00',2.57),('16100','2014-01-08','12:05:00',2.67),('16100','2014-01-08','12:10:00',3.19),('16100','2014-01-08','12:15:00',2.52),('16100','2014-01-08','12:20:00',3.69),('16100','2014-01-08','12:25:00',2.89),('16100','2014-01-08','12:30:00',1.88),('16100','2014-01-08','12:35:00',2.54),('16100','2014-01-08','12:40:00',3.57),('16100','2014-01-08','12:45:00',3.21),('16100','2014-01-08','12:50:00',3.36),('16100','2014-01-08','12:55:00',2.8),('16100','2014-01-08','13:00:00',2.96),('16100','2014-01-08','13:05:00',2.72),('16100','2014-01-08','13:10:00',2.8),('16100','2014-01-08','13:15:00',2.84),('16100','2014-01-08','13:20:00',2.18),('16100','2014-01-08','13:25:00',2),('16100','2014-01-08','13:30:00',1.99),('16100','2014-01-08','13:35:00',2.12),('16100','2014-01-08','13:40:00',1.8),('16100','2014-01-08','13:45:00',1.67),('16100','2014-01-08','13:50:00',1.8),('16100','2014-01-08','13:55:00',2.05),('16100','2014-01-08','14:00:00',1.91),('16100','2014-01-08','14:05:00',1.5),('16100','2014-01-08','14:10:00',1.51),('16100','2014-01-08','14:15:00',1.48),('16100','2014-01-08','14:20:00',1.41),('16100','2014-01-08','14:25:00',1.69),('16100','2014-01-08','14:30:00',1.76),('16100','2014-01-08','14:35:00',1.49),('16100','2014-01-08','14:40:00',1.45),('16100','2014-01-08','14:45:00',1.72),('16100','2014-01-08','14:50:00',1.72),('16100','2014-01-08','14:55:00',1.69),('16100','2014-01-08','15:00:00',1.63),('16100','2014-01-08','15:05:00',1.34),('16100','2014-01-08','15:10:00',1.13),('16100','2014-01-08','15:15:00',1.06),('16100','2014-01-07','08:25:00',1.03),('16100','2014-01-07','08:30:00',1.19),('16100','2014-01-07','08:35:00',1.34),('16100','2014-01-07','08:40:00',1.39),('16100','2014-01-07','08:45:00',1.34),('16100','2014-01-07','08:50:00',1.55),('16100','2014-01-07','08:55:00',1.98),('16100','2014-01-07','09:00:00',2.12),('16100','2014-01-07','09:05:00',2.32),('16100','2014-01-07','09:10:00',2.51),('16100','2014-01-07','09:15:00',2.62),('16100','2014-01-07','09:20:00',2.77),('16100','2014-01-07','09:25:00',2.93),('16100','2014-01-07','09:30:00',2.82),('16100','2014-01-07','09:35:00',3.09),('16100','2014-01-07','09:40:00',3.25),('16100','2014-01-07','09:45:00',3.33),('16100','2014-01-07','09:50:00',3.57),('16100','2014-01-07','09:55:00',3.7),('16100','2014-01-07','10:00:00',3.52),('16100','2014-01-07','10:05:00',3.66),('16100','2014-01-07','10:10:00',3.85),('16100','2014-01-07','10:15:00',4.18),('16100','2014-01-07','10:20:00',4.36),('16100','2014-01-07','10:25:00',4.43),('16100','2014-01-07','10:30:00',4.39),('16100','2014-01-07','10:35:00',4.12),('16100','2014-01-07','10:40:00',4.49),('16100','2014-01-07','10:45:00',4.67),('16100','2014-01-07','10:50:00',4.73),('16100','2014-01-07','10:55:00',4.81),('16100','2014-01-07','11:00:00',4.82),('16100','2014-01-07','11:05:00',4.92),('16100','2014-01-07','11:10:00',4.93),('16100','2014-01-07','11:15:00',4.94),('16100','2014-01-07','11:20:00',4.93),('16100','2014-01-07','11:25:00',4.92),('16100','2014-01-07','11:30:00',5.16),('16100','2014-01-07','11:35:00',5.21),('16100','2014-01-07','11:40:00',5.17),('16100','2014-01-07','11:45:00',5.15),('16100','2014-01-07','11:50:00',5.15),('16100','2014-01-07','11:55:00',5.02),('16100','2014-01-07','12:00:00',5.01),('16100','2014-01-07','12:05:00',5.12),('16100','2014-01-07','12:10:00',5.25),('16100','2014-01-07','12:15:00',5.28),('16100','2014-01-07','12:20:00',5.29),('16100','2014-01-07','12:25:00',5.18),('16100','2014-01-07','12:30:00',5.2),('16100','2014-01-07','12:35:00',5.06),('16100','2014-01-07','12:40:00',4.91),('16100','2014-01-07','12:45:00',4.79),('16100','2014-01-07','12:50:00',4.8),('16100','2014-01-07','12:55:00',4.71),('16100','2014-01-07','13:00:00',4.79),('16100','2014-01-07','13:05:00',4.65),('16100','2014-01-07','13:10:00',4.79),('16100','2014-01-07','13:15:00',4.91),('16100','2014-01-07','13:20:00',4.7),('16100','2014-01-07','13:25:00',4.64),('16100','2014-01-07','13:30:00',4.46),('16100','2014-01-07','13:35:00',4.67),('16100','2014-01-07','13:40:00',4.7),('16100','2014-01-07','13:45:00',4.62),('16100','2014-01-07','13:50:00',4.42),('16100','2014-01-07','13:55:00',4.44),('16100','2014-01-07','14:00:00',4.3),('16100','2014-01-07','14:05:00',4.19),('16100','2014-01-07','14:10:00',3.92),('16100','2014-01-07','14:15:00',3.75),('16100','2014-01-07','14:20:00',3.31),('16100','2014-01-07','14:25:00',3.48),('16100','2014-01-07','14:30:00',3.89),('16100','2014-01-07','14:35:00',3.51),('16100','2014-01-07','14:40:00',3.16),('16100','2014-01-07','14:45:00',3.27),('16100','2014-01-07','14:50:00',3.15),('16100','2014-01-07','14:55:00',2.61),('16100','2014-01-07','15:00:00',2.49),('16100','2014-01-07','15:05:00',2.24),('16100','2014-01-07','15:10:00',2.08),('16100','2014-01-07','15:15:00',2.01),('16100','2014-01-07','15:20:00',2.28),('16100','2014-01-07','15:25:00',2),('16100','2014-01-07','15:30:00',1.83),('16100','2014-01-07','15:35:00',1.87),('16100','2014-01-07','15:40:00',1.75),('16100','2014-01-07','15:45:00',1.59),('16100','2014-01-07','15:50:00',1.31),('16100','2014-01-07','15:55:00',1.11),('16100','2014-01-06','08:25:00',1.11),('16100','2014-01-06','08:30:00',1.27),('16100','2014-01-06','08:35:00',1.43),('16100','2014-01-06','08:40:00',1.59),('16100','2014-01-06','08:45:00',1.76),('16100','2014-01-06','08:50:00',1.92),('16100','2014-01-06','08:55:00',2.09),('16100','2014-01-06','09:00:00',2.29),('16100','2014-01-06','09:05:00',2.44),('16100','2014-01-06','09:10:00',2.56),('16100','2014-01-06','09:15:00',2.71),('16100','2014-01-06','09:20:00',2.88),('16100','2014-01-06','09:25:00',3.03),('16100','2014-01-06','09:30:00',3.19),('16100','2014-01-06','09:35:00',3.35),('16100','2014-01-06','09:40:00',3.49),('16100','2014-01-06','09:45:00',3.62),('16100','2014-01-06','09:50:00',3.81),('16100','2014-01-06','09:55:00',3.9),('16100','2014-01-06','10:00:00',3.97),('16100','2014-01-06','10:05:00',4.09),('16100','2014-01-06','10:10:00',4.18),('16100','2014-01-06','10:15:00',4.31),('16100','2014-01-06','10:20:00',4.44),('16100','2014-01-06','10:25:00',4.52),('16100','2014-01-06','10:30:00',4.62),('16100','2014-01-06','10:35:00',4.7),('16100','2014-01-06','10:40:00',4.76),('16100','2014-01-06','10:45:00',4.83),('16100','2014-01-06','10:50:00',4.9),('16100','2014-01-06','10:55:00',4.94),('16100','2014-01-06','11:00:00',4.94),('16100','2014-01-06','11:05:00',5.02),('16100','2014-01-06','11:10:00',5.05),('16100','2014-01-06','11:15:00',5.08),('16100','2014-01-06','11:20:00',5.22),('16100','2014-01-06','11:25:00',5.24),('16100','2014-01-06','11:30:00',5.27),('16100','2014-01-06','11:35:00',5.28),('16100','2014-01-06','11:40:00',5.26),('16100','2014-01-06','11:45:00',5.29),('16100','2014-01-06','11:50:00',5.24),('16100','2014-01-06','11:55:00',5.26),('16100','2014-01-06','12:00:00',5.29),('16100','2014-01-06','12:05:00',5.34),('16100','2014-01-06','12:10:00',5.41),('16100','2014-01-06','12:15:00',5.44),('16100','2014-01-06','12:20:00',5.51),('16100','2014-01-06','12:25:00',5.59),('16100','2014-01-06','12:30:00',5.55),('16100','2014-01-06','12:35:00',5.59),('16100','2014-01-06','12:40:00',5.47),('16100','2014-01-06','12:45:00',5.48),('16100','2014-01-06','12:50:00',5.36),('16100','2014-01-06','12:55:00',5.49),('16100','2014-01-06','13:00:00',5.41),('16100','2014-01-06','13:05:00',5.29),('16100','2014-01-06','13:10:00',5.3),('16100','2014-01-06','13:15:00',5.13),('16100','2014-01-06','13:20:00',4.88),('16100','2014-01-06','13:25:00',4.72),('16100','2014-01-06','13:30:00',4.81),('16100','2014-01-06','13:35:00',4.8),('16100','2014-01-06','13:40:00',4.87),('16100','2014-01-06','13:45:00',4.88),('16100','2014-01-06','13:50:00',4.71),('16100','2014-01-06','13:55:00',4.58),('16100','2014-01-06','14:00:00',4.4),('16100','2014-01-06','14:05:00',4.07),('16100','2014-01-06','14:10:00',4.2),('16100','2014-01-06','14:15:00',4.17),('16100','2014-01-06','14:20:00',4),('16100','2014-01-06','14:25:00',3.99),('16100','2014-01-06','14:30:00',3.74),('16100','2014-01-06','14:35:00',3.79),('16100','2014-01-06','14:40:00',3.63),('16100','2014-01-06','14:45:00',3.66),('16100','2014-01-06','14:50:00',3.41),('16100','2014-01-06','14:55:00',3.34),('16100','2014-01-06','15:00:00',3.29),('16100','2014-01-06','15:05:00',3.25),('16100','2014-01-06','15:10:00',3),('16100','2014-01-06','15:15:00',2.85),('16100','2014-01-06','15:20:00',2.7),('16100','2014-01-06','15:25:00',2.39),('16100','2014-01-06','15:30:00',2.15),('16100','2014-01-06','15:35:00',1.72),('16100','2014-01-06','15:40:00',1.52),('16100','2014-01-06','15:45:00',1.47),('16100','2014-01-06','15:50:00',1.49),('16100','2014-01-06','15:55:00',1.15),('16100','2014-01-06','16:00:00',1.09),('16100','2014-01-06','16:05:00',1.13),('16100','2014-01-06','16:10:00',1.09),('16100','2014-04-23','08:00:00',1.07),('16100','2014-04-23','08:05:00',1.23),('16100','2014-04-23','08:10:00',1.38),('16100','2014-04-23','08:15:00',1.62),('16100','2014-04-23','08:20:00',1.85),('16100','2014-04-23','08:25:00',2.06),('16100','2014-04-23','08:30:00',2.28),('16100','2014-04-23','08:35:00',2.46),('16100','2014-04-23','08:40:00',2.62),('16100','2014-04-23','08:45:00',2.8),('16100','2014-04-23','08:50:00',2.94),('16100','2014-04-23','08:55:00',3.11),('16100','2014-04-23','09:00:00',3.26),('16100','2014-04-23','09:05:00',3.44),('16100','2014-04-23','09:10:00',3.56),('16100','2014-04-23','09:15:00',3.73),('16100','2014-04-23','09:20:00',3.89),('16100','2014-04-23','09:25:00',4.01),('16100','2014-04-23','09:30:00',4.14),('16100','2014-04-23','09:35:00',4.31),('16100','2014-04-23','09:40:00',4.46),('16100','2014-04-23','09:45:00',4.58),('16100','2014-04-23','09:50:00',4.71),('16100','2014-04-23','09:55:00',4.83),('16100','2014-04-23','10:00:00',4.92),('16100','2014-04-23','10:05:00',5.03),('16100','2014-04-23','10:10:00',5.19),('16100','2014-04-23','10:15:00',5.32),('16100','2014-04-23','10:20:00',5.48),('16100','2014-04-23','10:25:00',5.56),('16100','2014-04-23','10:30:00',5.66),('16100','2014-04-23','10:35:00',5.8),('16100','2014-04-23','10:40:00',5.87),('16100','2014-04-23','10:45:00',5.93),('16100','2014-04-23','10:50:00',6.04),('16100','2014-04-23','10:55:00',6.15),('16100','2014-04-23','11:00:00',6.16),('16100','2014-04-23','11:05:00',6.31),('16100','2014-04-23','11:10:00',6.53),('16100','2014-04-23','11:15:00',6.52),('16100','2014-04-23','11:20:00',3.47),('16100','2014-04-23','11:25:00',3.82),('16100','2014-04-23','11:30:00',5.23),('16100','2014-04-23','11:35:00',6.02),('16100','2014-04-23','11:40:00',3.76),('16100','2014-04-23','11:45:00',6.15),('16100','2014-04-23','11:50:00',7.08),('16100','2014-04-23','11:55:00',7.17),('16100','2014-04-23','12:00:00',7.05),('16100','2014-04-23','12:05:00',6.96),('16100','2014-04-23','12:10:00',6.9),('16100','2014-04-23','12:15:00',7.05),('16100','2014-04-23','12:20:00',7.25),('16100','2014-04-23','12:25:00',7.18),('16100','2014-04-23','12:30:00',7.19),('16100','2014-04-23','12:35:00',7.18),('16100','2014-04-23','12:40:00',7.1),('16100','2014-04-23','12:45:00',7.33),('16100','2014-04-23','12:50:00',7.41),('16100','2014-04-23','12:55:00',7.49),('16100','2014-04-23','13:00:00',3.85),('16100','2014-04-23','13:05:00',4.99),('16100','2014-04-23','13:10:00',7.79),('16100','2014-04-23','13:15:00',7.57),('16100','2014-04-23','13:20:00',7.62),('16100','2014-04-23','13:25:00',7.46),('16100','2014-04-23','13:30:00',7.41),('16100','2014-04-23','13:35:00',7.57),('16100','2014-04-23','13:40:00',7.86),('16100','2014-04-23','13:45:00',7.69),('16100','2014-04-23','13:50:00',7.8),('16100','2014-04-23','13:55:00',7.62),('16100','2014-04-23','14:00:00',7.64),('16100','2014-04-23','14:05:00',7.75),('16100','2014-04-23','14:10:00',7.55),('16100','2014-04-23','14:15:00',7.54),('16100','2014-04-23','14:20:00',7.79),('16100','2014-04-23','14:25:00',7.9),('16100','2014-04-23','14:30:00',8.05),('16100','2014-04-23','14:35:00',5.86),('16100','2014-04-23','14:40:00',7.02),('16100','2014-04-23','14:45:00',7.65),('16100','2014-04-23','14:50:00',7.33),('16100','2014-04-23','14:55:00',7.18),('16100','2014-04-23','15:00:00',6.54),('16100','2014-04-23','15:05:00',4.76),('16100','2014-04-23','15:10:00',7.28),('16100','2014-04-23','15:15:00',3.33),('16100','2014-04-23','15:20:00',4.04),('16100','2014-04-23','15:25:00',6.08),('16100','2014-04-23','15:30:00',6.28),('16100','2014-04-23','15:35:00',7.35),('16100','2014-04-23','15:40:00',4.98),('16100','2014-04-23','15:45:00',4.4),('16100','2014-04-23','15:50:00',4.95),('16100','2014-04-23','15:55:00',6.64),('16100','2014-04-23','16:00:00',5.93),('16100','2014-04-23','16:05:00',6.33),('16100','2014-04-23','16:10:00',6.31),('16100','2014-04-23','16:15:00',6.14),('16100','2014-04-23','16:20:00',4.38),('16100','2014-04-23','16:25:00',6.58),('16100','2014-04-23','16:30:00',6.29),('16100','2014-04-23','16:35:00',6.42),('16100','2014-04-23','16:40:00',4.96),('16100','2014-04-23','16:45:00',5.35),('16100','2014-04-23','16:50:00',3.89),('16100','2014-04-23','16:55:00',2.95),('16100','2014-04-23','17:00:00',2.53),('16100','2014-04-23','17:05:00',2.01),('16100','2014-04-23','17:10:00',2.29),('16100','2014-04-23','17:15:00',2.11),('16100','2014-04-23','17:20:00',1.92),('16100','2014-04-23','17:25:00',2.16),('16100','2014-04-23','17:30:00',1.6),('16100','2014-04-23','17:35:00',1.27),('16100','2014-01-05','10:25:00',1.49),('16100','2014-01-05','10:30:00',1.44),('16100','2014-01-05','10:35:00',1.4),('16100','2014-01-05','10:40:00',1.34),('16100','2014-01-05','10:45:00',1.35),('16100','2014-01-05','13:55:00',4.29),('16100','2014-01-05','14:00:00',4.51),('16100','2014-01-05','14:05:00',4.51),('16100','2014-01-05','14:10:00',2.64),('16100','2014-01-05','14:15:00',3.64),('16100','2014-01-05','14:20:00',4.11),('16100','2014-01-05','14:25:00',3.36),('16100','2014-01-05','14:30:00',1.14),('16100','2014-01-05','14:35:00',1.09),('16100','2014-01-05','14:40:00',3.59),('16100','2014-01-05','14:45:00',3.95),('16100','2014-01-05','14:50:00',3.58),('16100','2014-01-05','14:55:00',3.39),('16100','2014-01-05','15:00:00',3.35),('16100','2014-01-05','15:05:00',3.24),('16100','2014-01-05','15:10:00',1.08),('16100','2014-01-05','15:20:00',2.89),('16100','2014-01-05','15:25:00',2.73),('16100','2014-01-05','15:30:00',2.07),('16100','2014-01-05','15:50:00',1.47),('16100','2014-01-05','15:55:00',1.39),('16100','2014-01-05','16:00:00',1.2),('16100','2014-01-05','16:05:00',1.26),('16100','2014-01-05','16:10:00',1.05),('16100','2014-01-03','14:40:00',1.19),('16100','2014-01-03','14:55:00',1.09),('16100','2014-01-03','15:00:00',1.13),('16100','2014-01-02','08:45:00',1.77),('16100','2014-01-02','08:50:00',1.85),('16100','2014-01-02','08:55:00',2.01),('16100','2014-01-02','09:00:00',2.2),('16100','2014-01-02','09:05:00',2.39),('16100','2014-01-02','09:10:00',2.56),('16100','2014-01-02','09:15:00',2.74),('16100','2014-01-02','09:20:00',2.99),('16100','2014-01-02','09:25:00',3.28),('16100','2014-01-02','09:30:00',3.56),('16100','2014-01-02','09:35:00',3.82),('16100','2014-01-02','09:40:00',3.44),('16100','2014-01-02','09:45:00',1.03),('16100','2014-01-02','09:55:00',2.06),('16100','2014-01-02','10:00:00',3.87),('16100','2014-01-02','10:05:00',4.44),('16100','2014-01-02','10:10:00',3.4),('16100','2014-01-02','10:15:00',2.39),('16100','2014-01-02','10:20:00',2.18),('16100','2014-01-02','10:25:00',1.96),('16100','2014-01-02','10:30:00',2.27),('16100','2014-01-02','10:35:00',2.44),('16100','2014-01-02','10:40:00',2.17),('16100','2014-01-02','10:45:00',1.73),('16100','2014-01-02','10:50:00',2.04),('16100','2014-01-02','10:55:00',1.65),('16100','2014-01-02','11:00:00',1.54),('16100','2014-01-02','11:05:00',1.7),('16100','2014-01-02','11:10:00',1.72),('16100','2014-01-02','11:15:00',1.86),('16100','2014-01-02','11:20:00',1.58),('16100','2014-01-02','11:25:00',1.5),('16100','2014-01-02','11:30:00',1.33),('16100','2014-01-02','11:35:00',1.22),('16100','2014-01-02','11:40:00',1.55),('16100','2014-01-02','11:45:00',1.66),('16100','2014-01-02','11:50:00',1.64),('16100','2014-01-02','11:55:00',1.89),('16100','2014-01-02','12:00:00',2.31),('16100','2014-01-02','12:05:00',3.49),('16100','2014-01-02','12:10:00',4.64),('16100','2014-01-02','12:15:00',4.58),('16100','2014-01-02','12:20:00',3.96),('16100','2014-01-02','12:25:00',3.75),('16100','2014-01-02','12:30:00',4.02),('16100','2014-01-02','12:35:00',3.84),('16100','2014-01-02','12:40:00',3.76),('16100','2014-01-02','12:45:00',3.69),('16100','2014-01-02','12:50:00',3.72),('16100','2014-01-02','12:55:00',4.17),('16100','2014-01-02','13:00:00',4.02),('16100','2014-01-02','13:05:00',4.02),('16100','2014-01-02','13:10:00',3.85),('16100','2014-01-02','13:15:00',3.56),('16100','2014-01-02','13:20:00',2.95),('16100','2014-01-02','13:25:00',3.52),('16100','2014-01-02','13:30:00',2.98),('16100','2014-01-02','13:35:00',2.49),('16100','2014-01-02','13:40:00',2.59),('16100','2014-01-02','13:45:00',2.56),('16100','2014-01-02','13:50:00',1.95),('16100','2014-01-02','13:55:00',1.77),('16100','2014-01-02','14:00:00',1.48),('16100','2014-01-02','14:05:00',1.15),('16100','2014-01-01','08:35:00',1.29),('16100','2014-01-01','08:40:00',1.58),('16100','2014-01-01','08:45:00',1.18),('16100','2014-01-01','08:50:00',1.92),('16100','2014-01-01','08:55:00',2.11),('16100','2014-01-01','09:00:00',2.24),('16100','2014-01-01','09:05:00',2.42),('16100','2014-01-01','09:10:00',2.57),('16100','2014-01-01','09:15:00',2.74),('16100','2014-01-01','09:20:00',2.87),('16100','2014-01-01','09:25:00',3.01),('16100','2014-01-01','09:30:00',3.16),('16100','2014-01-01','09:35:00',3.28),('16100','2014-01-01','09:40:00',3.41),('16100','2014-01-01','09:45:00',3.54),('16100','2014-01-01','09:50:00',3.67),('16100','2014-01-01','09:55:00',3.78),('16100','2014-01-01','10:00:00',3.91),('16100','2014-01-01','10:05:00',4.02),('16100','2014-01-01','10:10:00',4.16),('16100','2014-01-01','10:15:00',4.29),('16100','2014-01-01','10:20:00',4.39),('16100','2014-01-01','10:25:00',4.5),('16100','2014-01-01','10:30:00',4.6),('16100','2014-01-01','10:35:00',4.69),('16100','2014-01-01','10:40:00',4.81),('16100','2014-01-01','10:45:00',4.91),('16100','2014-01-01','10:50:00',5.08),('16100','2014-01-01','10:55:00',4.45),('16100','2014-01-01','11:00:00',3.96),('16100','2014-01-01','11:05:00',4.93),('16100','2014-01-01','11:10:00',4.23),('16100','2014-01-01','11:15:00',2.86),('16100','2014-01-01','11:20:00',2.45),('16100','2014-01-01','11:25:00',2.58),('16100','2014-01-01','11:30:00',2.8),('16100','2014-01-01','11:35:00',3.36),('16100','2014-01-01','11:40:00',2.85),('16100','2014-01-01','11:45:00',2.38),('16100','2014-01-01','11:50:00',2.14),('16100','2014-01-01','11:55:00',2.13),('16100','2014-01-01','12:00:00',1.89),('16100','2014-01-01','12:05:00',1.54),('16100','2014-01-01','12:10:00',1.17),('16100','2014-01-01','12:15:00',1.2),('16100','2014-01-01','12:20:00',1.5),('16100','2014-01-01','12:25:00',1.47),('16100','2014-01-01','12:30:00',1.46),('16100','2014-01-01','12:35:00',1.68),('16100','2014-01-01','12:40:00',1.9),('16100','2014-01-01','12:45:00',2.45),('16100','2014-01-01','12:50:00',3.94),('16100','2014-01-01','12:55:00',5.75),('16100','2014-01-01','13:00:00',4.98),('16100','2014-01-01','13:05:00',1.17),('16100','2014-01-01','13:10:00',1.25),('16100','2014-01-01','13:15:00',1.24),('16100','2014-01-01','13:20:00',1.36),('16100','2014-01-01','13:25:00',1.76),('16100','2014-01-01','13:30:00',2.24),('16100','2014-01-01','13:35:00',1.32),('16100','2014-01-01','13:40:00',1.01),('16100','2013-12-31','08:25:00',1.12),('16100','2013-12-31','08:30:00',1.33),('16100','2013-12-31','08:35:00',1.54),('16100','2013-12-31','08:40:00',1.73),('16100','2013-12-31','08:45:00',2.01),('16100','2013-12-31','08:50:00',2.34),('16100','2013-12-31','08:55:00',1.86),('16100','2013-12-31','09:05:00',1.15),('16100','2013-12-31','09:10:00',1.09),('16100','2013-12-31','09:25:00',1.03),('16100','2013-12-31','09:30:00',1.12),('16100','2013-12-31','09:35:00',1.46),('16100','2013-12-31','09:40:00',1.68),('16100','2013-12-31','09:45:00',1.73),('16100','2013-12-31','09:50:00',1.65),('16100','2013-12-31','09:55:00',1.82),('16100','2013-12-31','10:00:00',1.88),('16100','2013-12-31','10:05:00',1.73),('16100','2013-12-31','10:10:00',1.39),('16100','2013-12-31','10:15:00',1.27),('16100','2013-12-31','10:20:00',1.24),('16100','2013-12-31','10:25:00',1.25),('16100','2013-12-31','10:30:00',1.19),('16100','2013-12-31','10:35:00',1.17),('16100','2013-12-31','10:40:00',1.1),('16100','2013-12-31','10:45:00',1.23),('16100','2013-12-31','10:50:00',1.44),('16100','2013-12-31','10:55:00',1.5),('16100','2013-12-31','11:00:00',1.48),('16100','2013-12-31','11:05:00',1.47),('16100','2013-12-31','11:10:00',1.54),('16100','2013-12-31','11:15:00',1.56),('16100','2013-12-31','11:20:00',1.67),('16100','2013-12-31','11:25:00',1.65),('16100','2013-12-31','11:30:00',1.66),('16100','2013-12-31','11:35:00',1.86),('16100','2013-12-31','11:40:00',1.89),('16100','2013-12-31','11:45:00',1.79),('16100','2013-12-31','11:50:00',1.74),('16100','2013-12-31','11:55:00',1.79),('16100','2013-12-31','12:00:00',1.84),('16100','2013-12-31','12:05:00',2.03),('16100','2013-12-31','12:10:00',2.33),('16100','2013-12-31','12:15:00',2.32),('16100','2013-12-31','12:20:00',2.32),('16100','2013-12-31','12:25:00',2.35),('16100','2013-12-31','12:30:00',2.3),('16100','2013-12-31','12:35:00',2.12),('16100','2013-12-31','12:40:00',2.14),('16100','2013-12-31','12:45:00',2.55),('16100','2013-12-31','12:50:00',2.54),('16100','2013-12-31','12:55:00',2.65),('16100','2013-12-31','13:00:00',2.18),('16100','2013-12-31','13:05:00',1.99),('16100','2013-12-31','13:10:00',1.87),('16100','2013-12-31','13:15:00',2.16),('16100','2013-12-31','13:25:00',2.17),('16100','2013-12-31','13:30:00',3.49),('16100','2013-12-31','13:35:00',6.04),('16100','2013-12-31','13:40:00',4.64),('16100','2013-12-31','13:45:00',3.53),('16100','2013-12-31','13:50:00',2.73),('16100','2013-12-31','13:55:00',2.65),('16100','2013-12-31','14:00:00',1.81),('16100','2013-12-31','14:05:00',2.01),('16100','2013-12-31','14:10:00',2.19),('16100','2013-12-31','14:15:00',2.91),('16100','2013-12-31','14:20:00',1.57),('16100','2013-12-31','14:25:00',1.43),('16100','2013-12-31','14:30:00',1.38),('16100','2013-12-31','14:35:00',1.51),('16100','2013-12-31','14:40:00',1.89),('16100','2013-12-31','14:45:00',1.88),('16100','2013-12-31','14:50:00',2.14),('16100','2013-12-31','14:55:00',2.99),('16100','2013-12-31','15:00:00',2.82),('16100','2013-12-31','15:05:00',2.46),('16100','2013-12-31','15:10:00',2.75),('16100','2013-12-31','15:15:00',2.66),('16100','2013-12-31','15:20:00',2.43),('16100','2013-12-31','15:25:00',2.24),('16100','2013-12-31','15:30:00',2.09),('16100','2013-12-31','15:35:00',1.9),('16100','2013-12-31','15:40:00',1.76),('16100','2013-12-31','15:45:00',1.57),('16100','2013-12-31','15:50:00',1.39),('16100','2013-12-31','15:55:00',1.2),('16100','2013-12-31','16:00:00',1.02),('16100','2013-12-30','08:45:00',1.5),('16100','2013-12-30','08:50:00',2.25),('16100','2013-12-30','08:55:00',2.46),('16100','2013-12-30','09:00:00',2.62),('16100','2013-12-30','09:05:00',2.77),('16100','2013-12-30','09:10:00',2.84),('16100','2013-12-30','09:15:00',3.01),('16100','2013-12-30','09:20:00',3.13),('16100','2013-12-30','09:25:00',3.5),('16100','2013-12-30','09:30:00',3.78),('16100','2013-12-30','09:35:00',3.82),('16100','2013-12-30','09:40:00',4.1),('16100','2013-12-30','09:45:00',4.08),('16100','2013-12-30','09:50:00',2.89),('16100','2013-12-30','09:55:00',2.26),('16100','2013-12-30','10:00:00',3.89),('16100','2013-12-30','10:05:00',3.09),('16100','2013-12-30','10:10:00',3.34),('16100','2013-12-30','10:15:00',4.73),('16100','2013-12-30','10:20:00',2.72),('16100','2013-12-30','10:25:00',1.99),('16100','2013-12-30','10:30:00',1.77),('16100','2013-12-30','10:35:00',1.75),('16100','2013-12-30','10:40:00',1.83),('16100','2013-12-30','10:45:00',2.2),('16100','2013-12-30','10:50:00',1.82),('16100','2013-12-30','10:55:00',1.66),('16100','2013-12-30','11:00:00',2.18),('16100','2013-12-30','11:05:00',2.27),('16100','2013-12-30','11:10:00',3.71),('16100','2013-12-30','11:15:00',2.12),('16100','2013-12-30','11:20:00',2.63),('16100','2013-12-30','11:25:00',2.9),('16100','2013-12-30','11:30:00',6.21),('16100','2013-12-30','11:35:00',5.88),('16100','2013-12-30','11:40:00',6.06),('16100','2013-12-30','11:45:00',5.84),('16100','2013-12-30','11:50:00',5.82),('16100','2013-12-30','11:55:00',5.84),('16100','2013-12-30','12:00:00',5.79),('16100','2013-12-30','12:05:00',5.65),('16100','2013-12-30','12:10:00',5.67),('16100','2013-12-30','12:15:00',5.64),('16100','2013-12-30','12:20:00',5.58),('16100','2013-12-30','12:25:00',5.53),('16100','2013-12-30','12:30:00',5.47),('16100','2013-12-30','12:35:00',5.47),('16100','2013-12-30','12:40:00',5.42),('16100','2013-12-30','12:45:00',5.32),('16100','2013-12-30','12:50:00',5.33),('16100','2013-12-30','12:55:00',5.29),('16100','2013-12-30','13:00:00',5.28),('16100','2013-12-30','13:05:00',5.2),('16100','2013-12-30','13:10:00',5.22),('16100','2013-12-30','13:15:00',5.15),('16100','2013-12-30','13:20:00',5.1),('16100','2013-12-30','13:25:00',5.04),('16100','2013-12-30','13:30:00',4.95),('16100','2013-12-30','13:35:00',4.92),('16100','2013-12-30','13:40:00',4.84),('16100','2013-12-30','13:45:00',4.78),('16100','2013-12-30','13:50:00',4.7),('16100','2013-12-30','13:55:00',4.58),('16100','2013-12-30','14:00:00',4.5),('16100','2013-12-30','14:05:00',4.41),('16100','2013-12-30','14:10:00',4.3),('16100','2013-12-30','14:15:00',4.2),('16100','2013-12-30','14:20:00',4.12),('16100','2013-12-30','14:25:00',3.99),('16100','2013-12-30','14:30:00',3.85),('16100','2013-12-30','14:35:00',3.71),('16100','2013-12-30','14:40:00',3.56),('16100','2013-12-30','14:45:00',3.43),('16100','2013-12-30','14:50:00',3.31),('16100','2013-12-30','14:55:00',3.2),('16100','2013-12-30','15:00:00',3.06),('16100','2013-12-30','15:05:00',2.93),('16100','2013-12-30','15:10:00',2.78),('16100','2013-12-30','15:15:00',2.64),('16100','2013-12-30','15:20:00',2.5),('16100','2013-12-30','15:25:00',2.36),('16100','2013-12-30','15:30:00',2.2),('16100','2013-12-30','15:35:00',2),('16100','2013-12-30','15:40:00',1.83),('16100','2013-12-30','15:45:00',1.66),('16100','2013-12-30','15:50:00',1.48),('16100','2013-12-30','15:55:00',1.3),('16100','2013-12-30','16:00:00',1.13),('16100','2013-12-29','11:20:00',1.04),('16100','2013-12-29','11:25:00',1.29),('16100','2013-12-29','11:30:00',1.38),('16100','2013-12-29','11:35:00',1.42),('16100','2013-12-29','11:40:00',1.3),('16100','2013-12-29','11:45:00',1.28),('16100','2013-12-29','11:50:00',1.13),('16100','2013-12-29','11:55:00',1.01),('16100','2013-12-29','12:05:00',1.04),('16100','2013-12-29','12:10:00',1.07),('16100','2013-12-29','12:15:00',1.04),('16100','2013-12-29','12:40:00',1.05),('16100','2013-12-29','12:45:00',1.11),('16100','2013-12-29','12:50:00',1.13),('16100','2013-12-29','12:55:00',1.08),('16100','2013-12-29','13:00:00',1.05),('16100','2013-12-29','13:05:00',1.09),('16100','2013-12-29','13:10:00',1.05),('16100','2013-12-29','13:15:00',1.03),('16100','2013-12-29','13:20:00',1.03),('16100','2013-12-29','13:25:00',1.03),('16100','2013-12-28','08:15:00',1.16),('16100','2013-12-28','09:10:00',1.61),('16100','2013-12-28','09:15:00',2.42),('16100','2013-12-28','09:20:00',2.84),('16100','2013-12-28','09:25:00',2.6),('16100','2013-12-28','09:30:00',2.21),('16100','2013-12-28','09:35:00',3.15),('16100','2013-12-28','09:40:00',3.9),('16100','2013-12-28','09:45:00',4.14),('16100','2013-12-28','09:50:00',3.9),('16100','2013-12-28','09:55:00',3.31),('16100','2013-12-28','10:00:00',2.15),('16100','2013-12-28','10:05:00',2.3),('16100','2013-12-28','10:10:00',3.51),('16100','2013-12-28','10:15:00',4.46),('16100','2013-12-28','10:20:00',4.93),('16100','2013-12-28','10:25:00',5.25),('16100','2013-12-28','10:30:00',2.55),('16100','2013-12-28','10:35:00',2.61),('16100','2013-12-28','10:40:00',2.73),('16100','2013-12-28','10:45:00',2.99),('16100','2013-12-28','10:50:00',4.73),('16100','2013-12-28','10:55:00',1.25),('16100','2013-12-28','11:25:00',1.43),('16100','2013-12-28','11:30:00',1.88),('16100','2013-12-28','11:35:00',2.06),('16100','2013-12-28','11:40:00',2.66),('16100','2013-12-28','11:45:00',1.4),('16100','2013-12-28','11:55:00',1),('16100','2013-12-27','08:20:00',1.06),('16100','2013-12-27','08:25:00',1.24),('16100','2013-12-27','08:30:00',1.41),('16100','2013-12-27','08:35:00',1.57),('16100','2013-12-27','08:40:00',1.73),('16100','2013-12-27','08:45:00',1.9),('16100','2013-12-27','08:50:00',2.07),('16100','2013-12-27','08:55:00',2.22),('16100','2013-12-27','09:00:00',2.38),('16100','2013-12-27','09:05:00',2.57),('16100','2013-12-27','09:10:00',2.72),('16100','2013-12-27','09:15:00',2.91),('16100','2013-12-27','09:20:00',3.08),('16100','2013-12-27','09:25:00',3.21),('16100','2013-12-27','09:30:00',3.33),('16100','2013-12-27','09:35:00',3.46),('16100','2013-12-27','09:40:00',3.6),('16100','2013-12-27','09:45:00',3.76),('16100','2013-12-27','09:50:00',3.89),('16100','2013-12-27','09:55:00',4.01),('16100','2013-12-27','10:00:00',4.13),('16100','2013-12-27','10:05:00',4.25),('16100','2013-12-27','10:10:00',4.36),('16100','2013-12-27','10:15:00',4.47),('16100','2013-12-27','10:20:00',4.58),('16100','2013-12-27','10:25:00',4.69),('16100','2013-12-27','10:30:00',4.78),('16100','2013-12-27','10:35:00',4.85),('16100','2013-12-27','10:40:00',4.91),('16100','2013-12-27','10:45:00',4.96),('16100','2013-12-27','10:50:00',5.01),('16100','2013-12-27','10:55:00',5.05),('16100','2013-12-27','11:00:00',5.12),('16100','2013-12-27','11:05:00',5.17),('16100','2013-12-27','11:10:00',5.23),('16100','2013-12-27','11:15:00',5.31),('16100','2013-12-27','11:20:00',5.33),('16100','2013-12-27','11:25:00',5.33),('16100','2013-12-27','11:30:00',5.35),('16100','2013-12-27','11:35:00',5.4),('16100','2013-12-27','11:40:00',5.43),('16100','2013-12-27','11:45:00',5.45),('16100','2013-12-27','11:50:00',5.49),('16100','2013-12-27','11:55:00',5.51),('16100','2013-12-27','12:00:00',5.51),('16100','2013-12-27','12:05:00',5.53),('16100','2013-12-27','12:10:00',5.53),('16100','2013-12-27','12:15:00',5.52),('16100','2013-12-27','12:20:00',5.54),('16100','2013-12-27','12:25:00',5.49),('16100','2013-12-27','12:30:00',5.58),('16100','2013-12-27','12:35:00',5.5),('16100','2013-12-27','12:40:00',5.39),('16100','2013-12-27','12:45:00',5.32),('16100','2013-12-27','12:50:00',5.31),('16100','2013-12-27','12:55:00',5.21),('16100','2013-12-27','13:00:00',5.19),('16100','2013-12-27','13:05:00',5.17),('16100','2013-12-27','13:10:00',5.11),('16100','2013-12-27','13:15:00',4.98),('16100','2013-12-27','13:20:00',4.98),('16100','2013-12-27','13:25:00',4.84),('16100','2013-12-27','13:30:00',4.71),('16100','2013-12-27','13:35:00',4.67),('16100','2013-12-27','13:40:00',4.59),('16100','2013-12-27','13:45:00',4.48),('16100','2013-12-27','13:50:00',4.44),('16100','2013-12-27','13:55:00',4.37),('16100','2013-12-27','14:00:00',4.26),('16100','2013-12-27','14:05:00',4.22),('16100','2013-12-27','14:10:00',4.06),('16100','2013-12-27','14:15:00',4.04),('16100','2013-12-27','14:20:00',4),('16100','2013-12-27','14:25:00',3.92),('16100','2013-12-27','14:30:00',3.81),('16100','2013-12-27','14:35:00',3.74),('16100','2013-12-27','14:40:00',3.19),('16100','2013-12-27','14:45:00',1.75),('16100','2013-12-27','14:50:00',1.8),('16100','2013-12-27','14:55:00',2.35),('16100','2013-12-27','15:00:00',3.2),('16100','2013-12-27','15:05:00',2.96),('16100','2013-12-27','15:10:00',2.81),('16100','2013-12-27','15:15:00',2.64),('16100','2013-12-27','15:20:00',2.49),('16100','2013-12-27','15:25:00',2.22),('16100','2013-12-27','15:30:00',2.13),('16100','2013-12-27','15:35:00',1.98),('16100','2013-12-27','15:40:00',1.73),('16100','2013-12-27','15:45:00',1.68),('16100','2013-12-27','15:50:00',1.52),('16100','2013-12-27','15:55:00',1.28),('16100','2014-04-22','10:45:00',1.2),('16100','2014-04-22','10:50:00',1.45),('16100','2014-04-22','10:55:00',1.47),('16100','2014-04-22','11:00:00',1.36),('16100','2014-04-22','11:05:00',1.23),('16100','2014-04-22','11:10:00',1.14),('16100','2014-04-22','11:15:00',1.04),('16100','2014-04-22','11:20:00',1.05),('16100','2014-04-22','12:45:00',1.01),('16100','2014-04-22','13:15:00',1.1),('16100','2014-04-22','13:20:00',1.23),('16100','2014-04-22','13:25:00',1.37),('16100','2014-04-22','13:30:00',1.57),('16100','2014-04-22','13:35:00',1.81),('16100','2014-04-22','13:40:00',2.02),('16100','2014-04-22','13:45:00',2.2),('16100','2014-04-22','13:50:00',2.26),('16100','2014-04-22','13:55:00',2.43),('16100','2014-04-22','14:00:00',2.5),('16100','2014-04-22','14:05:00',2.51),('16100','2014-04-22','14:10:00',2.45),('16100','2014-04-22','14:15:00',2.33),('16100','2014-04-22','14:20:00',2.18),('16100','2014-04-22','14:25:00',2),('16100','2014-04-22','14:30:00',1.8),('16100','2014-04-22','14:35:00',1.56),('16100','2014-04-22','14:40:00',1.46),('16100','2014-04-22','14:45:00',1.48),('16100','2014-04-22','14:50:00',1.46),('16100','2014-04-22','14:55:00',1.4),('16100','2014-04-22','15:00:00',1.43),('16100','2014-04-22','15:05:00',1.58),('16100','2014-04-22','15:10:00',1.82),('16100','2014-04-22','15:15:00',2.1),('16100','2014-04-22','15:20:00',2.15),('16100','2014-04-22','15:25:00',2.26),('16100','2014-04-22','15:30:00',2.1),('16100','2014-04-22','15:35:00',1.84),('16100','2014-04-22','15:40:00',1.71),('16100','2014-04-22','15:45:00',1.33),('16100','2014-04-22','15:50:00',1.23),('16100','2014-04-22','15:55:00',1.2),('16100','2014-04-22','16:00:00',1.14),('16100','2013-12-26','10:25:00',1.1),('16100','2013-12-26','10:30:00',1.13),('16100','2013-12-26','10:35:00',1.12),('16100','2013-12-26','10:40:00',1.03),('16100','2013-12-26','11:20:00',1.08),('16100','2013-12-26','11:25:00',1.23),('16100','2013-12-26','11:30:00',1.18),('16100','2013-12-26','11:35:00',1.09),('16100','2013-12-26','11:40:00',1.1),('16100','2013-12-26','11:45:00',1.39),('16100','2013-12-26','11:50:00',1.84),('16100','2013-12-26','11:55:00',2.17),('16100','2013-12-26','12:00:00',3.78),('16100','2013-12-26','12:05:00',4.04),('16100','2013-12-26','12:10:00',4.86),('16100','2013-12-26','12:15:00',2.65),('16100','2013-12-26','12:20:00',1.65),('16100','2013-12-26','12:25:00',1.86),('16100','2013-12-26','12:30:00',2.23),('16100','2013-12-26','12:35:00',2.38),('16100','2013-12-26','12:40:00',3.78),('16100','2013-12-26','12:45:00',4.93),('16100','2013-12-26','12:50:00',4.5),('16100','2013-12-26','12:55:00',4.55),('16100','2013-12-26','13:00:00',4.95),('16100','2013-12-26','13:05:00',5.13),('16100','2013-12-26','13:10:00',5.12),('16100','2013-12-26','13:15:00',5.23),('16100','2013-12-26','13:20:00',5.13),('16100','2013-12-26','13:25:00',5.36),('16100','2013-12-26','13:30:00',4.59),('16100','2013-12-26','13:35:00',2.54),('16100','2013-12-26','13:40:00',2.28),('16100','2013-12-26','13:45:00',2.16),('16100','2013-12-26','13:50:00',2.06),('16100','2013-12-26','13:55:00',2.16),('16100','2013-12-26','14:00:00',2.51),('16100','2013-12-26','14:05:00',2.7),('16100','2013-12-26','14:10:00',4.16),('16100','2013-12-26','14:15:00',3.08),('16100','2013-12-26','14:20:00',2.2),('16100','2013-12-26','14:25:00',2.08),('16100','2013-12-26','14:30:00',2.24),('16100','2013-12-26','14:35:00',2.76),('16100','2013-12-26','14:40:00',1.98),('16100','2013-12-26','14:45:00',1.17),('16100','2013-12-25','10:00:00',1.03),('16100','2013-12-24','09:10:00',1.17),('16100','2013-12-24','09:15:00',1.27),('16100','2013-12-24','09:20:00',1.17),('16100','2013-12-24','09:25:00',1.25),('16100','2013-12-24','09:30:00',1.16),('16100','2013-12-24','10:35:00',1.56),('16100','2013-12-24','10:40:00',1.92),('16100','2013-12-24','10:45:00',1.96),('16100','2013-12-24','10:50:00',1.67),('16100','2013-12-24','10:55:00',1.41),('16100','2013-12-24','11:00:00',1.24),('16100','2013-12-24','11:05:00',1.45),('16100','2013-12-24','11:10:00',1.8),('16100','2013-12-24','11:15:00',1.71),('16100','2013-12-24','11:20:00',2.14),('16100','2013-12-24','11:25:00',2.5),('16100','2013-12-24','11:30:00',1.92),('16100','2013-12-24','11:35:00',1.23),('16100','2013-12-24','11:40:00',2.15),('16100','2013-12-24','11:45:00',3.71),('16100','2013-12-24','11:50:00',5.06),('16100','2013-12-24','11:55:00',5.47),('16100','2013-12-24','12:00:00',1.67),('16100','2013-12-24','12:05:00',2.09),('16100','2013-12-24','12:10:00',3.01),('16100','2013-12-24','12:15:00',1.79),('16100','2013-12-24','12:20:00',4.21),('16100','2013-12-24','12:25:00',4.49),('16100','2013-12-24','12:30:00',5.09),('16100','2013-12-24','12:35:00',3.4),('16100','2013-12-24','12:40:00',3.3),('16100','2013-12-24','12:45:00',2.72),('16100','2013-12-24','12:50:00',2.05),('16100','2013-12-24','12:55:00',2.14),('16100','2013-12-24','13:00:00',1.87),('16100','2013-12-24','13:05:00',1.87),('16100','2013-12-24','13:10:00',1.1),('16100','2013-12-24','13:25:00',1.02),('16100','2013-12-24','13:40:00',1.2),('16100','2013-12-24','13:45:00',1.39),('16100','2013-12-24','13:50:00',1.39),('16100','2013-12-24','13:55:00',1.3),('16100','2013-12-24','14:05:00',1.08),('16100','2013-12-24','14:10:00',1.12),('16100','2013-12-24','15:10:00',1.46),('16100','2013-12-24','15:15:00',2.03),('16100','2013-12-24','15:20:00',1.96),('16100','2013-12-23','08:40:00',1.16),('16100','2013-12-23','08:45:00',1.67),('16100','2013-12-23','08:50:00',1.88),('16100','2013-12-23','08:55:00',1.96),('16100','2013-12-23','09:00:00',2.12),('16100','2013-12-23','09:05:00',2.34),('16100','2013-12-23','09:10:00',2.49),('16100','2013-12-23','09:15:00',2.67),('16100','2013-12-23','09:20:00',2.83),('16100','2013-12-23','09:25:00',2.97),('16100','2013-12-23','09:30:00',3.07),('16100','2013-12-23','09:35:00',3.17),('16100','2013-12-23','09:40:00',3.27),('16100','2013-12-23','09:45:00',3.4),('16100','2013-12-23','09:50:00',3.49),('16100','2013-12-23','09:55:00',3.6),('16100','2013-12-23','10:00:00',3.69),('16100','2013-12-23','10:05:00',3.77),('16100','2013-12-23','10:10:00',3.82),('16100','2013-12-23','10:15:00',3.83),('16100','2013-12-23','10:20:00',3.98),('16100','2013-12-23','10:25:00',4.14),('16100','2013-12-23','10:30:00',4.16),('16100','2013-12-23','10:35:00',4.19),('16100','2013-12-23','10:40:00',4.34),('16100','2013-12-23','10:45:00',4.49),('16100','2013-12-23','10:50:00',4.49),('16100','2013-12-23','10:55:00',4.56),('16100','2013-12-23','11:00:00',4.65),('16100','2013-12-23','11:05:00',4.77),('16100','2013-12-23','11:10:00',4.83),('16100','2013-12-23','11:15:00',4.58),('16100','2013-12-23','11:20:00',4.74),('16100','2013-12-23','11:25:00',4.91),('16100','2013-12-23','11:30:00',4.96),('16100','2013-12-23','11:35:00',4.96),('16100','2013-12-23','11:40:00',5.03),('16100','2013-12-23','11:45:00',5.02),('16100','2013-12-23','11:50:00',5.02),('16100','2013-12-23','11:55:00',5.03),('16100','2013-12-23','12:00:00',5),('16100','2013-12-23','12:05:00',5.03),('16100','2013-12-23','12:10:00',4.96),('16100','2013-12-23','12:15:00',4.95),('16100','2013-12-23','12:20:00',4.94),('16100','2013-12-23','12:25:00',4.93),('16100','2013-12-23','12:30:00',4.92),('16100','2013-12-23','12:35:00',4.93),('16100','2013-12-23','12:40:00',4.93),('16100','2013-12-23','12:45:00',4.92),('16100','2013-12-23','12:50:00',4.78),('16100','2013-12-23','12:55:00',4.73),('16100','2013-12-23','13:00:00',4.72),('16100','2013-12-23','13:05:00',4.69),('16100','2013-12-23','13:10:00',4.54),('16100','2013-12-23','13:15:00',4.36),('16100','2013-12-23','13:20:00',4.36),('16100','2013-12-23','13:25:00',4.2),('16100','2013-12-23','13:30:00',4.09),('16100','2013-12-23','13:35:00',3.92),('16100','2013-12-23','13:40:00',3.92),('16100','2013-12-23','13:45:00',3.84),('16100','2013-12-23','13:50:00',3.78),('16100','2013-12-23','13:55:00',3.66),('16100','2013-12-23','14:00:00',3.38),('16100','2013-12-23','14:05:00',3.27),('16100','2013-12-23','14:10:00',3.09),('16100','2013-12-23','14:15:00',3.1),('16100','2013-12-23','14:20:00',3.04),('16100','2013-12-23','14:25:00',2.92),('16100','2013-12-23','14:30:00',2.76),('16100','2013-12-23','14:35:00',2.62),('16100','2013-12-23','14:40:00',2.47),('16100','2013-12-23','14:45:00',2.37),('16100','2013-12-23','14:50:00',2.21),('16100','2013-12-23','14:55:00',2.11),('16100','2013-12-23','15:00:00',1.99),('16100','2013-12-23','15:05:00',1.94),('16100','2013-12-23','15:10:00',1.81),('16100','2013-12-23','15:15:00',1.74),('16100','2013-12-23','15:20:00',1.63),('16100','2013-12-23','15:25:00',1.55),('16100','2013-12-23','15:30:00',1.47),('16100','2013-12-23','15:35:00',1.33),('16100','2013-12-23','15:40:00',1.16),('16100','2013-12-23','15:45:00',1.01),('16100','2013-12-22','08:50:00',1.08),('16100','2013-12-22','08:55:00',1.17),('16100','2013-12-22','09:00:00',1.43),('16100','2013-12-22','09:05:00',1.29),('16100','2013-12-22','09:10:00',1.16),('16100','2013-12-22','09:15:00',1.52),('16100','2013-12-22','09:20:00',1.83),('16100','2013-12-22','09:25:00',1.75),('16100','2013-12-22','09:30:00',1.82),('16100','2013-12-22','09:35:00',2.01),('16100','2013-12-22','09:40:00',1.92),('16100','2013-12-22','09:45:00',1.93),('16100','2013-12-22','09:50:00',1.68),('16100','2013-12-22','09:55:00',1.96),('16100','2013-12-22','10:00:00',2.17),('16100','2013-12-22','10:05:00',2.66),('16100','2013-12-22','10:10:00',3.41),('16100','2013-12-22','10:15:00',3.71),('16100','2013-12-22','10:20:00',3.67),('16100','2013-12-22','10:25:00',4.15),('16100','2013-12-22','10:30:00',4.21),('16100','2013-12-22','10:35:00',4.19),('16100','2013-12-22','10:40:00',4.09),('16100','2013-12-22','10:45:00',4.08),('16100','2013-12-22','10:50:00',4.33),('16100','2013-12-22','10:55:00',4.65),('16100','2013-12-22','11:00:00',5.07),('16100','2013-12-22','11:05:00',5.05),('16100','2013-12-22','11:10:00',5.09),('16100','2013-12-22','11:15:00',5.05),('16100','2013-12-22','11:20:00',5.2),('16100','2013-12-22','11:25:00',4.97),('16100','2013-12-22','11:30:00',5.18),('16100','2013-12-22','11:35:00',5.42),('16100','2013-12-22','11:40:00',5.27),('16100','2013-12-22','11:45:00',4.71),('16100','2013-12-22','11:50:00',4.93),('16100','2013-12-22','11:55:00',5.23),('16100','2013-12-22','12:00:00',5.35),('16100','2013-12-22','12:05:00',5.22),('16100','2013-12-22','12:10:00',5.14),('16100','2013-12-22','12:15:00',5.07),('16100','2013-12-22','12:20:00',4.98),('16100','2013-12-22','12:25:00',4.92),('16100','2013-12-22','12:30:00',4.95),('16100','2013-12-22','12:35:00',4.81),('16100','2013-12-22','12:40:00',4.8),('16100','2013-12-22','12:45:00',4.81),('16100','2013-12-22','12:50:00',4.75),('16100','2013-12-22','12:55:00',4.65),('16100','2013-12-22','13:00:00',4.67),('16100','2013-12-22','13:05:00',4.62),('16100','2013-12-22','13:10:00',4.61),('16100','2013-12-22','13:15:00',4.64),('16100','2013-12-22','13:20:00',4.53),('16100','2013-12-22','13:25:00',4.59),('16100','2013-12-22','13:30:00',4.57),('16100','2013-12-22','13:35:00',4.51),('16100','2013-12-22','13:40:00',4.42),('16100','2013-12-22','13:45:00',4.41),('16100','2013-12-22','13:50:00',4.05),('16100','2013-12-22','13:55:00',4.15),('16100','2013-12-22','14:00:00',3.74),('16100','2013-12-22','14:05:00',3.65),('16100','2013-12-22','14:10:00',3.66),('16100','2013-12-22','14:15:00',3.72),('16100','2013-12-22','14:20:00',3.63),('16100','2013-12-22','14:25:00',3.55),('16100','2013-12-22','14:30:00',3.38),('16100','2013-12-22','14:35:00',3.28),('16100','2013-12-22','14:40:00',3.12),('16100','2013-12-22','14:45:00',3),('16100','2013-12-22','14:50:00',2.85),('16100','2013-12-22','14:55:00',2.73),('16100','2013-12-22','15:00:00',2.56),('16100','2013-12-22','15:05:00',2.4),('16100','2013-12-22','15:10:00',2.24),('16100','2013-12-22','15:15:00',2.06),('16100','2013-12-22','15:20:00',1.89),('16100','2013-12-22','15:25:00',1.67),('16100','2013-12-22','15:30:00',1.53),('16100','2013-12-22','15:35:00',1.38),('16100','2013-12-22','15:40:00',1.21),('16100','2013-12-22','15:45:00',1.09),('16100','2013-12-21','08:40:00',1.28),('16100','2013-12-21','08:45:00',1.38),('16100','2013-12-21','08:50:00',1.31),('16100','2013-12-21','08:55:00',1.16),('16100','2013-12-21','09:00:00',1.15),('16100','2013-12-21','09:05:00',1.38),('16100','2013-12-21','09:10:00',1.78),('16100','2013-12-21','09:15:00',2.2),('16100','2013-12-21','09:20:00',2.1),('16100','2013-12-21','09:25:00',2.18),('16100','2013-12-21','09:30:00',2.57),('16100','2013-12-21','09:35:00',3.23),('16100','2013-12-21','09:40:00',4.05),('16100','2013-12-21','09:45:00',4.18),('16100','2013-12-21','09:50:00',4.47),('16100','2013-12-21','09:55:00',4.68),('16100','2013-12-21','10:00:00',4.68),('16100','2013-12-21','10:05:00',4.54),('16100','2013-12-21','10:10:00',4.34),('16100','2013-12-21','10:15:00',4.56),('16100','2013-12-21','10:20:00',4.52),('16100','2013-12-21','10:25:00',4.44),('16100','2013-12-21','10:30:00',4.31),('16100','2013-12-21','10:35:00',4.43),('16100','2013-12-21','10:40:00',4.43),('16100','2013-12-21','10:45:00',4.08),('16100','2013-12-21','10:50:00',4.38),('16100','2013-12-21','10:55:00',4.73),('16100','2013-12-21','11:00:00',4.59),('16100','2013-12-21','11:05:00',4.86),('16100','2013-12-21','11:10:00',4.24),('16100','2013-12-21','11:15:00',4.23),('16100','2013-12-21','11:20:00',4.88),('16100','2013-12-21','11:25:00',4.72),('16100','2013-12-21','11:30:00',4.55),('16100','2013-12-21','11:35:00',4.9),('16100','2013-12-21','11:40:00',4.74),('16100','2013-12-21','11:45:00',4.52),('16100','2013-12-21','11:50:00',3.53),('16100','2013-12-21','11:55:00',2.59),('16100','2013-12-21','12:00:00',2.18),('16100','2013-12-21','12:05:00',1.79),('16100','2013-12-21','12:10:00',1.58),('16100','2013-12-21','12:15:00',1.69),('16100','2013-12-21','12:20:00',1.84),('16100','2013-12-21','12:25:00',2.17),('16100','2013-12-21','12:30:00',2.21),('16100','2013-12-21','12:35:00',2.67),('16100','2013-12-21','12:40:00',2.91),('16100','2013-12-21','12:45:00',2.98),('16100','2013-12-21','12:50:00',2.84),('16100','2013-12-21','12:55:00',3.14),('16100','2013-12-21','13:00:00',4.42),('16100','2013-12-21','13:05:00',4.8),('16100','2013-12-21','13:10:00',5.2),('16100','2013-12-21','13:15:00',5.01),('16100','2013-12-21','13:20:00',4.14),('16100','2013-12-21','13:25:00',4.2),('16100','2013-12-21','13:30:00',4.69),('16100','2013-12-21','13:35:00',3.9),('16100','2013-12-21','13:40:00',3.89),('16100','2013-12-21','13:45:00',3.87),('16100','2013-12-21','13:50:00',2.44),('16100','2013-12-21','13:55:00',2.44),('16100','2013-12-21','14:00:00',3.03),('16100','2013-12-21','14:05:00',2.78),('16100','2013-12-21','14:10:00',3.12),('16100','2013-12-21','14:15:00',2.75),('16100','2013-12-21','14:20:00',2.07),('16100','2013-12-21','14:25:00',1.9),('16100','2013-12-21','14:30:00',1.63),('16100','2013-12-21','14:35:00',2.89),('16100','2013-12-21','14:40:00',3.13),('16100','2013-12-21','14:45:00',3.01),('16100','2013-12-21','14:50:00',1.91),('16100','2013-12-21','14:55:00',1.39),('16100','2013-12-21','15:00:00',1.22),('16100','2013-12-21','15:05:00',1.48),('16100','2013-12-21','15:10:00',2.19),('16100','2013-12-21','15:15:00',1.82),('16100','2013-12-21','15:20:00',1.11),('16100','2013-12-20','08:20:00',1.01),('16100','2013-12-20','08:25:00',1.16),('16100','2013-12-20','08:30:00',1.32),('16100','2013-12-20','08:35:00',1.48),('16100','2013-12-20','08:40:00',1.6),('16100','2013-12-20','08:45:00',1.75),('16100','2013-12-20','08:50:00',1.95),('16100','2013-12-20','08:55:00',2.09),('16100','2013-12-20','09:00:00',2.25),('16100','2013-12-20','09:05:00',2.4),('16100','2013-12-20','09:10:00',2.54),('16100','2013-12-20','09:15:00',2.71),('16100','2013-12-20','09:20:00',2.8),('16100','2013-12-20','09:25:00',2.82),('16100','2013-12-20','09:30:00',3.11),('16100','2013-12-20','09:35:00',3.21),('16100','2013-12-20','09:40:00',3.36),('16100','2013-12-20','09:45:00',3.51),('16100','2013-12-20','09:50:00',3.64),('16100','2013-12-20','09:55:00',3.76),('16100','2013-12-20','10:00:00',3.89),('16100','2013-12-20','10:05:00',3.98),('16100','2013-12-20','10:10:00',4.1),('16100','2013-12-20','10:15:00',4.21),('16100','2013-12-20','10:20:00',4.35),('16100','2013-12-20','10:25:00',4.47),('16100','2013-12-20','10:30:00',4.58),('16100','2013-12-20','10:35:00',4.66),('16100','2013-12-20','10:40:00',4.75),('16100','2013-12-20','10:45:00',4.82),('16100','2013-12-20','10:50:00',4.9),('16100','2013-12-20','10:55:00',4.97),('16100','2013-12-20','11:00:00',5.03),('16100','2013-12-20','11:05:00',5.09),('16100','2013-12-20','11:10:00',5.16),('16100','2013-12-20','11:15:00',5.22),('16100','2013-12-20','11:20:00',5.27),('16100','2013-12-20','11:25:00',5.33),('16100','2013-12-20','11:30:00',5.38),('16100','2013-12-20','11:35:00',5.41),('16100','2013-12-20','11:40:00',5.42),('16100','2013-12-20','11:45:00',5.43),('16100','2013-12-20','11:50:00',5.45),('16100','2013-12-20','11:55:00',5.44),('16100','2013-12-20','12:00:00',5.47),('16100','2013-12-20','12:05:00',5.41),('16100','2013-12-20','12:10:00',5.4),('16100','2013-12-20','12:15:00',5.39),('16100','2013-12-20','12:20:00',5.4),('16100','2013-12-20','12:25:00',5.35),('16100','2013-12-20','12:30:00',5.36),('16100','2013-12-20','12:35:00',5.38),('16100','2013-12-20','12:40:00',5.31),('16100','2013-12-20','12:45:00',5.26),('16100','2013-12-20','12:50:00',5.23),('16100','2013-12-20','12:55:00',5.23),('16100','2013-12-20','13:00:00',5.17),('16100','2013-12-20','13:05:00',5.18),('16100','2013-12-20','13:10:00',5.16),('16100','2013-12-20','13:15:00',5.13),('16100','2013-12-20','13:20:00',5.08),('16100','2013-12-20','13:25:00',5.01),('16100','2013-12-20','13:30:00',4.94),('16100','2013-12-20','13:35:00',4.9),('16100','2013-12-20','13:40:00',4.77),('16100','2013-12-20','13:45:00',4.7),('16100','2013-12-20','13:50:00',4.62),('16100','2013-12-20','13:55:00',4.51),('16100','2013-12-20','14:00:00',4.38),('16100','2013-12-20','14:05:00',4.27),('16100','2013-12-20','14:10:00',4.17),('16100','2013-12-20','14:15:00',4.03),('16100','2013-12-20','14:20:00',3.93),('16100','2013-12-20','14:25:00',3.77),('16100','2013-12-20','14:30:00',3.65),('16100','2013-12-20','14:35:00',3.51),('16100','2013-12-20','14:40:00',3.35),('16100','2013-12-20','14:45:00',3.24),('16100','2013-12-20','14:50:00',3.11),('16100','2013-12-20','14:55:00',2.97),('16100','2013-12-20','15:00:00',2.85),('16100','2013-12-20','15:05:00',2.72),('16100','2013-12-20','15:10:00',2.59),('16100','2013-12-20','15:15:00',2.45),('16100','2013-12-20','15:20:00',2.29),('16100','2013-12-20','15:25:00',2.1),('16100','2013-12-20','15:30:00',1.91),('16100','2013-12-20','15:35:00',1.78),('16100','2013-12-20','15:40:00',1.6),('16100','2013-12-20','15:45:00',1.45),('16100','2013-12-20','15:50:00',1.27),('16100','2013-12-20','15:55:00',1.1),('16100','2013-12-19','08:30:00',1.29),('16100','2013-12-19','08:35:00',1.41),('16100','2013-12-19','08:40:00',1.5),('16100','2013-12-19','08:45:00',1.69),('16100','2013-12-19','08:50:00',1.67),('16100','2013-12-19','08:55:00',1.94),('16100','2013-12-19','09:00:00',2.18),('16100','2013-12-19','09:05:00',2.33),('16100','2013-12-19','09:10:00',2.47),('16100','2013-12-19','09:15:00',2.63),('16100','2013-12-19','09:20:00',2.79),('16100','2013-12-19','09:25:00',2.92),('16100','2013-12-19','09:30:00',3.02),('16100','2013-12-19','09:35:00',3.16),('16100','2013-12-19','09:40:00',3.28),('16100','2013-12-19','09:45:00',3.42),('16100','2013-12-19','09:50:00',3.51),('16100','2013-12-19','09:55:00',3.64),('16100','2013-12-19','10:00:00',3.71),('16100','2013-12-19','10:05:00',3.81),('16100','2013-12-19','10:10:00',3.92),('16100','2013-12-19','10:15:00',4.02),('16100','2013-12-19','10:20:00',4.07),('16100','2013-12-19','10:25:00',4.17),('16100','2013-12-19','10:30:00',4.25),('16100','2013-12-19','10:35:00',4.31),('16100','2013-12-19','10:40:00',4.44),('16100','2013-12-19','10:45:00',4.51),('16100','2013-12-19','10:50:00',4.53),('16100','2013-12-19','10:55:00',4.55),('16100','2013-12-19','11:00:00',4.58),('16100','2013-12-19','11:05:00',4.7),('16100','2013-12-19','11:10:00',4.81),('16100','2013-12-19','11:15:00',4.87),('16100','2013-12-19','11:20:00',4.88),('16100','2013-12-19','11:25:00',4.89),('16100','2013-12-19','11:30:00',4.95),('16100','2013-12-19','11:35:00',5.03),('16100','2013-12-19','11:40:00',5.07),('16100','2013-12-19','11:45:00',5.04),('16100','2013-12-19','11:50:00',5.08),('16100','2013-12-19','11:55:00',5.12),('16100','2013-12-19','12:00:00',5.08),('16100','2013-12-19','12:05:00',5.09),('16100','2013-12-19','12:10:00',5.1),('16100','2013-12-19','12:15:00',5.11),('16100','2013-12-19','12:20:00',5.09),('16100','2013-12-19','12:25:00',5.03),('16100','2013-12-19','12:30:00',5),('16100','2013-12-19','12:35:00',4.95),('16100','2013-12-19','12:40:00',4.94),('16100','2013-12-19','12:45:00',4.9),('16100','2013-12-19','12:50:00',4.83),('16100','2013-12-19','12:55:00',4.81),('16100','2013-12-19','13:00:00',4.71),('16100','2013-12-19','13:05:00',4.6),('16100','2013-12-19','13:10:00',4.4),('16100','2013-12-19','13:15:00',4.22),('16100','2013-12-19','13:20:00',4.28),('16100','2013-12-19','13:25:00',4.25),('16100','2013-12-19','13:30:00',4.21),('16100','2013-12-19','13:35:00',3.95),('16100','2013-12-19','13:40:00',3.84),('16100','2013-12-19','13:45:00',3.97),('16100','2013-12-19','13:50:00',3.79),('16100','2013-12-19','13:55:00',3.67),('16100','2013-12-19','14:00:00',2.9),('16100','2013-12-19','14:05:00',1.28),('16100','2013-12-19','14:10:00',2.92),('16100','2013-12-19','14:15:00',1.99),('16100','2013-12-19','14:20:00',1.41),('16100','2013-12-19','14:25:00',2.31),('16100','2013-12-19','14:30:00',1.4),('16100','2013-12-19','14:40:00',1.65),('16100','2013-12-19','14:45:00',2.02),('16100','2013-12-19','14:55:00',1.37),('16100','2013-12-18','08:30:00',1.11),('16100','2013-12-18','08:35:00',1.29),('16100','2013-12-18','08:40:00',1.39),('16100','2013-12-18','08:45:00',1.58),('16100','2013-12-18','08:50:00',1.65),('16100','2013-12-18','08:55:00',1.37),('16100','2013-12-18','09:00:00',1.02),('16100','2013-12-18','09:05:00',1.52),('16100','2013-12-18','09:10:00',1.06),('16100','2013-12-18','09:15:00',1.09),('16100','2013-12-18','09:20:00',1),('16100','2013-12-18','09:25:00',1.14),('16100','2013-12-18','09:45:00',1.27),('16100','2013-12-18','09:50:00',1.96),('16100','2013-12-18','09:55:00',1.95),('16100','2013-12-18','10:00:00',1.21),('16100','2013-12-18','10:05:00',1.12),('16100','2013-12-18','10:10:00',1.18),('16100','2013-12-18','10:15:00',1.05),('16100','2013-12-18','10:30:00',1.15),('16100','2013-12-18','10:35:00',2.5),('16100','2013-12-18','10:40:00',3.98),('16100','2013-12-18','10:45:00',2.94),('16100','2013-12-18','10:50:00',1.56),('16100','2013-12-18','10:55:00',1.31),('16100','2013-12-18','11:00:00',1.07),('16100','2013-12-18','11:05:00',1.12),('16100','2013-12-18','11:10:00',1.2),('16100','2013-12-18','11:15:00',1.26),('16100','2013-12-18','11:20:00',1.19),('16100','2013-12-18','11:25:00',1.13),('16100','2013-12-18','12:30:00',1.38),('16100','2013-12-18','12:35:00',1.59),('16100','2013-12-18','12:40:00',1.53),('16100','2013-12-18','12:45:00',1.33),('16100','2013-12-18','12:50:00',1.31),('16100','2013-12-18','12:55:00',1.32),('16100','2013-12-18','13:00:00',1.22),('16100','2013-12-18','13:05:00',1.19),('16100','2013-12-18','13:10:00',1.07),('16100','2013-12-18','13:15:00',1.04),('16100','2013-12-18','13:20:00',1.06),('16100','2013-12-18','13:25:00',1.07),('16100','2013-12-18','13:30:00',1.09),('16100','2013-12-18','13:35:00',1.02),('16100','2013-12-18','13:40:00',1.11),('16100','2013-12-18','13:45:00',1.43),('16100','2013-12-18','13:50:00',1.91),('16100','2013-12-18','13:55:00',1.78),('16100','2013-12-18','14:00:00',1.21),('16100','2013-12-18','14:05:00',1.05),('16100','2013-12-18','14:10:00',1.16),('16100','2013-12-18','14:15:00',1.21),('16100','2013-12-18','14:20:00',1.31),('16100','2013-12-18','14:25:00',2.98),('16100','2013-12-18','14:30:00',2.87),('16100','2013-12-18','14:35:00',3.57),('16100','2013-12-18','14:40:00',3.48),('16100','2013-12-18','14:45:00',3.03),('16100','2013-12-18','14:50:00',1.74),('16100','2013-12-18','14:55:00',2.18),('16100','2013-12-18','15:00:00',1.5),('16100','2013-12-18','15:05:00',1.13),('16100','2013-12-17','08:20:00',1.07),('16100','2013-12-17','08:25:00',1.23),('16100','2013-12-17','08:30:00',1.37),('16100','2013-12-17','08:35:00',1.52),('16100','2013-12-17','08:40:00',1.71),('16100','2013-12-17','08:45:00',1.86),('16100','2013-12-17','08:50:00',2.05),('16100','2013-12-17','08:55:00',2.2),('16100','2013-12-17','09:00:00',2.39),('16100','2013-12-17','09:05:00',2.55),('16100','2013-12-17','09:10:00',2.73),('16100','2013-12-17','09:15:00',2.88),('16100','2013-12-17','09:20:00',3.04),('16100','2013-12-17','09:25:00',3.18),('16100','2013-12-17','09:30:00',3.3),('16100','2013-12-17','09:35:00',3.45),('16100','2013-12-17','09:40:00',3.58),('16100','2013-12-17','09:45:00',3.73),('16100','2013-12-17','09:50:00',3.87),('16100','2013-12-17','09:55:00',3.98),('16100','2013-12-17','10:00:00',4.09),('16100','2013-12-17','10:05:00',4.18),('16100','2013-12-17','10:10:00',4.27),('16100','2013-12-17','10:15:00',4.34),('16100','2013-12-17','10:20:00',4.41),('16100','2013-12-17','10:25:00',4.56),('16100','2013-12-17','10:30:00',4.64),('16100','2013-12-17','10:35:00',4.72),('16100','2013-12-17','10:40:00',4.8),('16100','2013-12-17','10:45:00',4.81),('16100','2013-12-17','10:50:00',4.9),('16100','2013-12-17','10:55:00',4.98),('16100','2013-12-17','11:00:00',4.96),('16100','2013-12-17','11:05:00',4.99),('16100','2013-12-17','11:10:00',5.05),('16100','2013-12-17','11:15:00',5.05),('16100','2013-12-17','11:20:00',5.11),('16100','2013-12-17','11:25:00',5.11),('16100','2013-12-17','11:30:00',5.07),('16100','2013-12-17','11:35:00',5.07),('16100','2013-12-17','11:40:00',5.08),('16100','2013-12-17','11:45:00',5.18),('16100','2013-12-17','11:50:00',5.18),('16100','2013-12-17','11:55:00',5.13),('16100','2013-12-17','12:00:00',5.13),('16100','2013-12-17','12:05:00',5.17),('16100','2013-12-17','12:10:00',5.16),('16100','2013-12-17','12:15:00',5.17),('16100','2013-12-17','12:20:00',5.21),('16100','2013-12-17','12:25:00',5.18),('16100','2013-12-17','12:30:00',5.25),('16100','2013-12-17','12:35:00',5.17),('16100','2013-12-17','12:40:00',5.05),('16100','2013-12-17','12:45:00',4.98),('16100','2013-12-17','12:50:00',4.96),('16100','2013-12-17','12:55:00',5.04),('16100','2013-12-17','13:00:00',5.05),('16100','2013-12-17','13:05:00',4.95),('16100','2013-12-17','13:10:00',4.89),('16100','2013-12-17','13:15:00',4.84),('16100','2013-12-17','13:20:00',4.79),('16100','2013-12-17','13:25:00',4.72),('16100','2013-12-17','13:30:00',4.69),('16100','2013-12-17','13:35:00',4.62),('16100','2013-12-17','13:40:00',4.51),('16100','2013-12-17','13:45:00',4.52),('16100','2013-12-17','13:50:00',4.42),('16100','2013-12-17','13:55:00',4.29),('16100','2013-12-17','14:00:00',4.22),('16100','2013-12-17','14:05:00',4.11),('16100','2013-12-17','14:10:00',3.96),('16100','2013-12-17','14:15:00',3.89),('16100','2013-12-17','14:20:00',3.8),('16100','2013-12-17','14:25:00',3.64),('16100','2013-12-17','14:30:00',3.5),('16100','2013-12-17','14:35:00',3.34),('16100','2013-12-17','14:40:00',3.25),('16100','2013-12-17','14:45:00',3.11),('16100','2013-12-17','14:50:00',2.97),('16100','2013-12-17','14:55:00',2.78),('16100','2013-12-17','15:00:00',2.68),('16100','2013-12-17','15:05:00',2.54),('16100','2013-12-17','15:10:00',2.4),('16100','2013-12-17','15:15:00',2.27),('16100','2013-12-17','15:20:00',2.09),('16100','2013-12-17','15:25:00',1.97),('16100','2013-12-17','15:30:00',1.77),('16100','2013-12-17','15:35:00',1.57),('16100','2013-12-17','15:40:00',1.28),('16100','2013-12-17','15:45:00',1.18),('16100','2013-12-17','15:50:00',1.05),('16100','2014-04-21','08:00:00',1.06),('16100','2014-04-21','08:05:00',1.23),('16100','2014-04-21','08:10:00',1.42),('16100','2014-04-21','08:15:00',1.67),('16100','2014-04-21','08:20:00',1.88),('16100','2014-04-21','08:25:00',2.11),('16100','2014-04-21','08:30:00',2.28),('16100','2014-04-21','08:35:00',2.32),('16100','2014-04-21','08:40:00',2.43),('16100','2014-04-21','08:45:00',2.68),('16100','2014-04-21','08:50:00',2.81),('16100','2014-04-21','08:55:00',2.99),('16100','2014-04-21','09:00:00',3.23),('16100','2014-04-21','09:05:00',3.49),('16100','2014-04-21','09:10:00',3.13),('16100','2014-04-21','09:15:00',2.43),('16100','2014-04-21','09:20:00',2.09),('16100','2014-04-21','09:25:00',4.39),('16100','2014-04-21','09:30:00',4.12),('16100','2014-04-21','09:35:00',4.32),('16100','2014-04-21','09:40:00',4.37),('16100','2014-04-21','09:45:00',4.86),('16100','2014-04-21','09:50:00',2.21),('16100','2014-04-21','09:55:00',2.28),('16100','2014-04-21','10:00:00',2.81),('16100','2014-04-21','10:05:00',2.44),('16100','2014-04-21','10:10:00',2.79),('16100','2014-04-21','10:15:00',2.78),('16100','2014-04-21','10:20:00',5.53),('16100','2014-04-21','10:25:00',3.07),('16100','2014-04-21','10:30:00',4.29),('16100','2014-04-21','10:35:00',2.94),('16100','2014-04-21','10:40:00',3.67),('16100','2014-04-21','10:45:00',6.09),('16100','2014-04-21','10:50:00',5.21),('16100','2014-04-21','10:55:00',5.12),('16100','2014-04-21','11:00:00',5.8),('16100','2014-04-21','11:05:00',3.78),('16100','2014-04-21','11:10:00',2.82),('16100','2014-04-21','11:15:00',2.42),('16100','2014-04-21','11:20:00',1.99),('16100','2014-04-21','11:25:00',1.69),('16100','2014-04-21','11:30:00',1.58),('16100','2014-04-21','11:35:00',1.42),('16100','2014-04-21','11:40:00',1.41),('16100','2014-04-21','11:45:00',1.45),('16100','2014-04-21','11:50:00',1.68),('16100','2014-04-21','11:55:00',1.5),('16100','2014-04-21','12:00:00',1.67),('16100','2014-04-21','12:05:00',1.86),('16100','2014-04-21','12:10:00',1.7),('16100','2014-04-21','12:15:00',1.8),('16100','2014-04-21','12:20:00',1.87),('16100','2014-04-21','12:25:00',1.93),('16100','2014-04-21','12:30:00',1.85),('16100','2014-04-21','12:35:00',1.43),('16100','2014-04-21','12:40:00',1.22),('16100','2014-04-21','12:45:00',1.19),('16100','2014-04-21','12:50:00',1.16),('16100','2014-04-21','12:55:00',1.22),('16100','2014-04-21','13:00:00',1.34),('16100','2014-04-21','13:05:00',1.51),('16100','2014-04-21','13:10:00',1.87),('16100','2014-04-21','13:15:00',2.15),('16100','2014-04-21','13:20:00',2.39),('16100','2014-04-21','13:25:00',3.06),('16100','2014-04-21','13:30:00',4.34),('16100','2014-04-21','13:35:00',4.93),('16100','2014-04-21','13:40:00',4.94),('16100','2014-04-21','13:45:00',4.68),('16100','2014-04-21','13:50:00',3.02),('16100','2014-04-21','13:55:00',2.53),('16100','2014-04-21','14:00:00',2.62),('16100','2014-04-21','14:05:00',5.38),('16100','2014-04-21','14:10:00',8.44),('16100','2014-04-21','14:15:00',6.23),('16100','2014-04-21','14:20:00',4.61),('16100','2014-04-21','14:25:00',2.86),('16100','2014-04-21','14:30:00',3.67),('16100','2014-04-21','14:35:00',4.8),('16100','2014-04-21','14:40:00',3.84),('16100','2014-04-21','14:45:00',3.41),('16100','2014-04-21','14:50:00',5.25),('16100','2014-04-21','14:55:00',3.57),('16100','2014-04-21','15:00:00',2.05),('16100','2014-04-21','15:05:00',2.24),('16100','2014-04-21','15:10:00',2.13),('16100','2014-04-21','15:15:00',2.03),('16100','2014-04-21','15:20:00',2.1),('16100','2014-04-21','15:25:00',2.93),('16100','2014-04-21','15:30:00',3.31),('16100','2014-04-21','15:35:00',3.27),('16100','2014-04-21','15:40:00',3.52),('16100','2014-04-21','15:45:00',4.39),('16100','2014-04-21','15:50:00',3.99),('16100','2014-04-21','15:55:00',3.5),('16100','2014-04-21','16:00:00',4.66),('16100','2014-04-21','16:05:00',3.35),('16100','2014-04-21','16:10:00',2.9),('16100','2014-04-21','16:15:00',2.26),('16100','2014-04-21','16:20:00',2.61),('16100','2014-04-21','16:25:00',2.51),('16100','2014-04-21','16:30:00',2.13),('16100','2014-04-21','16:35:00',2.29),('16100','2014-04-21','16:40:00',2.25),('16100','2014-04-21','16:45:00',2.18),('16100','2014-04-21','16:50:00',1.98),('16100','2014-04-21','16:55:00',2.08),('16100','2014-04-21','17:00:00',2.61),('16100','2014-04-21','17:05:00',2.11),('16100','2014-04-21','17:10:00',1.62),('16100','2014-04-21','17:15:00',1.4),('16100','2014-04-21','17:20:00',1.14),('16100','2014-04-21','17:25:00',1.04),('16100','2014-04-21','17:35:00',1.14),('16100','2014-04-21','17:40:00',1.23),('16100','2014-04-21','17:45:00',1.06),('16100','2013-12-16','08:10:00',1.03),('16100','2013-12-16','08:15:00',1.19),('16100','2013-12-16','08:20:00',1.37),('16100','2013-12-16','08:25:00',1.54),('16100','2013-12-16','08:30:00',1.72),('16100','2013-12-16','08:35:00',1.88),('16100','2013-12-16','08:40:00',2.04),('16100','2013-12-16','08:45:00',2.18),('16100','2013-12-16','08:50:00',2.36),('16100','2013-12-16','08:55:00',2.51),('16100','2013-12-16','09:00:00',2.66),('16100','2013-12-16','09:05:00',2.84),('16100','2013-12-16','09:10:00',3),('16100','2013-12-16','09:15:00',3.13),('16100','2013-12-16','09:20:00',3.26),('16100','2013-12-16','09:25:00',3.41),('16100','2013-12-16','09:30:00',3.55),('16100','2013-12-16','09:35:00',3.66),('16100','2013-12-16','09:40:00',3.79),('16100','2013-12-16','09:45:00',3.97),('16100','2013-12-16','09:50:00',4.07),('16100','2013-12-16','09:55:00',4.16),('16100','2013-12-16','10:00:00',4.27),('16100','2013-12-16','10:05:00',4.37),('16100','2013-12-16','10:10:00',4.49),('16100','2013-12-16','10:15:00',4.53),('16100','2013-12-16','10:20:00',4.6),('16100','2013-12-16','10:25:00',4.71),('16100','2013-12-16','10:30:00',4.78),('16100','2013-12-16','10:35:00',4.84),('16100','2013-12-16','10:40:00',4.92),('16100','2013-12-16','10:45:00',5.01),('16100','2013-12-16','10:50:00',5.09),('16100','2013-12-16','10:55:00',5.14),('16100','2013-12-16','11:00:00',5.2),('16100','2013-12-16','11:05:00',5.24),('16100','2013-12-16','11:10:00',5.29),('16100','2013-12-16','11:15:00',5.32),('16100','2013-12-16','11:20:00',5.36),('16100','2013-12-16','11:25:00',5.45),('16100','2013-12-16','11:30:00',5.45),('16100','2013-12-16','11:35:00',5.5),('16100','2013-12-16','11:40:00',5.57),('16100','2013-12-16','11:45:00',5.56),('16100','2013-12-16','11:50:00',5.59),('16100','2013-12-16','11:55:00',5.58),('16100','2013-12-16','12:00:00',5.6),('16100','2013-12-16','12:05:00',5.65),('16100','2013-12-16','12:10:00',5.65),('16100','2013-12-16','12:15:00',5.64),('16100','2013-12-16','12:20:00',5.65),('16100','2013-12-16','12:25:00',5.63),('16100','2013-12-16','12:30:00',5.58),('16100','2013-12-16','12:35:00',5.52),('16100','2013-12-16','12:40:00',5.46),('16100','2013-12-16','12:45:00',5.43),('16100','2013-12-16','12:50:00',5.4),('16100','2013-12-16','12:55:00',5.38),('16100','2013-12-16','13:00:00',5.33),('16100','2013-12-16','13:05:00',5.26),('16100','2013-12-16','13:10:00',5.16),('16100','2013-12-16','13:15:00',5.11),('16100','2013-12-16','13:20:00',5.08),('16100','2013-12-16','13:25:00',5.03),('16100','2013-12-16','13:30:00',4.98),('16100','2013-12-16','13:35:00',4.92),('16100','2013-12-16','13:40:00',4.8),('16100','2013-12-16','13:45:00',4.72),('16100','2013-12-16','13:50:00',4.56),('16100','2013-12-16','13:55:00',4.5),('16100','2013-12-16','14:00:00',4.4),('16100','2013-12-16','14:05:00',4.24),('16100','2013-12-16','14:10:00',4.13),('16100','2013-12-16','14:15:00',3.99),('16100','2013-12-16','14:20:00',3.88),('16100','2013-12-16','14:25:00',3.74),('16100','2013-12-16','14:30:00',3.61),('16100','2013-12-16','14:35:00',3.46),('16100','2013-12-16','14:40:00',3.34),('16100','2013-12-16','14:45:00',3.18),('16100','2013-12-16','14:50:00',3.07),('16100','2013-12-16','14:55:00',2.94),('16100','2013-12-16','15:00:00',2.82),('16100','2013-12-16','15:05:00',2.67),('16100','2013-12-16','15:10:00',2.56),('16100','2013-12-16','15:15:00',2.42),('16100','2013-12-16','15:20:00',2.23),('16100','2013-12-16','15:25:00',2.06),('16100','2013-12-16','15:30:00',1.87),('16100','2013-12-16','15:35:00',1.75),('16100','2013-12-16','15:40:00',1.59),('16100','2013-12-16','15:45:00',1.42),('16100','2013-12-16','15:50:00',1.24),('16100','2013-12-16','15:55:00',1.1),('16100','2013-12-15','08:15:00',1.14),('16100','2013-12-15','08:20:00',1.31),('16100','2013-12-15','08:25:00',1.46),('16100','2013-12-15','08:30:00',1.61),('16100','2013-12-15','08:35:00',1.78),('16100','2013-12-15','08:40:00',1.95),('16100','2013-12-15','08:45:00',2.11),('16100','2013-12-15','08:50:00',2.3),('16100','2013-12-15','08:55:00',2.44),('16100','2013-12-15','09:00:00',2.58),('16100','2013-12-15','09:05:00',2.73),('16100','2013-12-15','09:10:00',2.89),('16100','2013-12-15','09:15:00',3.02),('16100','2013-12-15','09:20:00',3.2),('16100','2013-12-15','09:25:00',3.35),('16100','2013-12-15','09:30:00',3.5),('16100','2013-12-15','09:35:00',3.63),('16100','2013-12-15','09:40:00',3.77),('16100','2013-12-15','09:45:00',3.89),('16100','2013-12-15','09:50:00',4),('16100','2013-12-15','09:55:00',4.1),('16100','2013-12-15','10:00:00',4.17),('16100','2013-12-15','10:05:00',4.27),('16100','2013-12-15','10:10:00',4.4),('16100','2013-12-15','10:15:00',4.52),('16100','2013-12-15','10:20:00',4.64),('16100','2013-12-15','10:25:00',4.73),('16100','2013-12-15','10:30:00',4.82),('16100','2013-12-15','10:35:00',4.88),('16100','2013-12-15','10:40:00',4.92),('16100','2013-12-15','10:45:00',4.97),('16100','2013-12-15','10:50:00',5.06),('16100','2013-12-15','10:55:00',5.13),('16100','2013-12-15','11:00:00',5.15),('16100','2013-12-15','11:05:00',5.22),('16100','2013-12-15','11:10:00',5.3),('16100','2013-12-15','11:15:00',5.4),('16100','2013-12-15','11:20:00',5.5),('16100','2013-12-15','11:25:00',5.48),('16100','2013-12-15','11:30:00',5.51),('16100','2013-12-15','11:35:00',5.52),('16100','2013-12-15','11:40:00',5.55),('16100','2013-12-15','11:45:00',5.55),('16100','2013-12-15','11:50:00',5.6),('16100','2013-12-15','11:55:00',5.61),('16100','2013-12-15','12:00:00',5.59),('16100','2013-12-15','12:05:00',5.55),('16100','2013-12-15','12:10:00',5.56),('16100','2013-12-15','12:15:00',5.48),('16100','2013-12-15','12:20:00',5.4),('16100','2013-12-15','12:25:00',5.39),('16100','2013-12-15','12:30:00',5.36),('16100','2013-12-15','12:35:00',5.33),('16100','2013-12-15','12:40:00',5.33),('16100','2013-12-15','12:45:00',5.34),('16100','2013-12-15','12:50:00',5.3),('16100','2013-12-15','12:55:00',5.2),('16100','2013-12-15','13:00:00',5.19),('16100','2013-12-15','13:05:00',5.1),('16100','2013-12-15','13:10:00',5.04),('16100','2013-12-15','13:15:00',5.02),('16100','2013-12-15','13:20:00',5),('16100','2013-12-15','13:25:00',5.03),('16100','2013-12-15','13:30:00',4.95),('16100','2013-12-15','13:35:00',4.84),('16100','2013-12-15','13:40:00',4.74),('16100','2013-12-15','13:45:00',4.68),('16100','2013-12-15','13:50:00',4.55),('16100','2013-12-15','13:55:00',4.45),('16100','2013-12-15','14:00:00',4.33),('16100','2013-12-15','14:05:00',4.23),('16100','2013-12-15','14:10:00',4.11),('16100','2013-12-15','14:15:00',4.02),('16100','2013-12-15','14:20:00',3.91),('16100','2013-12-15','14:25:00',3.73),('16100','2013-12-15','14:30:00',3.58),('16100','2013-12-15','14:35:00',3.5),('16100','2013-12-15','14:40:00',3.32),('16100','2013-12-15','14:45:00',3.14),('16100','2013-12-15','14:50:00',3.15),('16100','2013-12-15','14:55:00',3.02),('16100','2013-12-15','15:00:00',2.92),('16100','2013-12-15','15:05:00',2.79),('16100','2013-12-15','15:10:00',2.67),('16100','2013-12-15','15:15:00',2.45),('16100','2013-12-15','15:20:00',2.28),('16100','2013-12-15','15:25:00',2.09),('16100','2013-12-15','15:30:00',1.93),('16100','2013-12-15','15:35:00',1.77),('16100','2013-12-15','15:40:00',1.61),('16100','2013-12-15','15:45:00',1.42),('16100','2013-12-15','15:50:00',1.28),('16100','2013-12-15','15:55:00',1.11),('16100','2013-12-14','09:45:00',1.03),('16100','2013-12-14','09:50:00',1.04),('16100','2013-12-14','10:10:00',1.01),('16100','2013-12-14','10:15:00',1.01),('16100','2013-12-14','10:20:00',1.34),('16100','2013-12-14','10:25:00',1.73),('16100','2013-12-14','10:30:00',2.88),('16100','2013-12-14','10:35:00',1.85),('16100','2013-12-14','10:40:00',1.8),('16100','2013-12-14','10:45:00',1.66),('16100','2013-12-14','10:50:00',1.36),('16100','2013-12-14','10:55:00',1.13),('16100','2013-12-14','11:00:00',1.17),('16100','2013-12-14','11:05:00',1.26),('16100','2013-12-14','11:10:00',1.47),('16100','2013-12-14','11:15:00',1.67),('16100','2013-12-14','11:20:00',1.64),('16100','2013-12-14','11:25:00',1.49),('16100','2013-12-14','11:30:00',1.6),('16100','2013-12-14','11:35:00',1.56),('16100','2013-12-14','11:40:00',1.46),('16100','2013-12-14','11:45:00',1.39),('16100','2013-12-14','11:50:00',1.37),('16100','2013-12-14','11:55:00',1.55),('16100','2013-12-14','12:00:00',1.72),('16100','2013-12-14','12:05:00',1.39),('16100','2013-12-14','12:10:00',1.09),('16100','2013-12-14','12:15:00',1.01),('16100','2013-12-13','08:20:00',1.07),('16100','2013-12-13','08:25:00',1.22),('16100','2013-12-13','08:30:00',1.38),('16100','2013-12-13','08:35:00',1.55),('16100','2013-12-13','08:40:00',1.7),('16100','2013-12-13','08:45:00',1.85),('16100','2013-12-13','08:50:00',2),('16100','2013-12-13','08:55:00',2.16),('16100','2013-12-13','09:00:00',2.33),('16100','2013-12-13','09:05:00',2.52),('16100','2013-12-13','09:10:00',2.69),('16100','2013-12-13','09:15:00',2.79),('16100','2013-12-13','09:20:00',2.96),('16100','2013-12-13','09:25:00',3.1),('16100','2013-12-13','09:30:00',3.25),('16100','2013-12-13','09:35:00',3.42),('16100','2013-12-13','09:40:00',3.55),('16100','2013-12-13','09:45:00',3.59),('16100','2013-12-13','09:50:00',3.65),('16100','2013-12-13','09:55:00',3.77),('16100','2013-12-13','10:00:00',3.88),('16100','2013-12-13','10:05:00',4.01),('16100','2013-12-13','10:10:00',4.08),('16100','2013-12-13','10:15:00',4.19),('16100','2013-12-13','10:20:00',4.3),('16100','2013-12-13','10:25:00',4.41),('16100','2013-12-13','10:30:00',4.52),('16100','2013-12-13','10:35:00',4.57),('16100','2013-12-13','10:40:00',4.66),('16100','2013-12-13','10:45:00',4.77),('16100','2013-12-13','10:50:00',4.67),('16100','2013-12-13','10:55:00',4.84),('16100','2013-12-13','11:00:00',4.87),('16100','2013-12-13','11:05:00',4.92),('16100','2013-12-13','11:10:00',5.01),('16100','2013-12-13','11:15:00',5.06),('16100','2013-12-13','11:20:00',5.09),('16100','2013-12-13','11:25:00',5.11),('16100','2013-12-13','11:30:00',5.07),('16100','2013-12-13','11:35:00',5.11),('16100','2013-12-13','11:40:00',5.06),('16100','2013-12-13','11:45:00',5.04),('16100','2013-12-13','11:50:00',5),('16100','2013-12-13','11:55:00',4.97),('16100','2013-12-13','12:00:00',5.02),('16100','2013-12-13','12:05:00',5.05),('16100','2013-12-13','12:10:00',4.97),('16100','2013-12-13','12:15:00',4.98),('16100','2013-12-13','12:20:00',4.95),('16100','2013-12-13','12:25:00',5.04),('16100','2013-12-13','12:30:00',4.91),('16100','2013-12-13','12:35:00',4.82),('16100','2013-12-13','12:40:00',4.91),('16100','2013-12-13','12:45:00',4.86),('16100','2013-12-13','12:50:00',4.83),('16100','2013-12-13','12:55:00',4.89),('16100','2013-12-13','13:00:00',4.88),('16100','2013-12-13','13:05:00',4.89),('16100','2013-12-13','13:10:00',4.83),('16100','2013-12-13','13:15:00',4.86),('16100','2013-12-13','13:20:00',4.66),('16100','2013-12-13','13:25:00',4.64),('16100','2013-12-13','13:30:00',4.57),('16100','2013-12-13','13:35:00',4.46),('16100','2013-12-13','13:40:00',4.38),('16100','2013-12-13','13:45:00',4.29),('16100','2013-12-13','13:50:00',4.17),('16100','2013-12-13','13:55:00',4.15),('16100','2013-12-13','14:00:00',4.06),('16100','2013-12-13','14:05:00',4.02),('16100','2013-12-13','14:10:00',3.92),('16100','2013-12-13','14:15:00',3.82),('16100','2013-12-13','14:20:00',3.75),('16100','2013-12-13','14:25:00',3.6),('16100','2013-12-13','14:30:00',3.49),('16100','2013-12-13','14:35:00',3.36),('16100','2013-12-13','14:40:00',3.24),('16100','2013-12-13','14:45:00',3.09),('16100','2013-12-13','14:50:00',2.96),('16100','2013-12-13','14:55:00',2.83),('16100','2013-12-13','15:00:00',2.64),('16100','2013-12-13','15:05:00',2.51),('16100','2013-12-13','15:10:00',2.28),('16100','2013-12-13','15:15:00',2.17),('16100','2013-12-13','15:20:00',2.01),('16100','2013-12-13','15:25:00',1.8),('16100','2013-12-13','15:30:00',1.71),('16100','2013-12-13','15:35:00',1.56),('16100','2013-12-13','15:40:00',1.38),('16100','2013-12-13','15:45:00',1.22),('16100','2013-12-13','15:50:00',1.08),('16100','2013-12-12','08:25:00',1.15),('16100','2013-12-12','08:30:00',1.31),('16100','2013-12-12','08:35:00',1.47),('16100','2013-12-12','08:40:00',1.62),('16100','2013-12-12','08:45:00',1.75),('16100','2013-12-12','08:50:00',1.88),('16100','2013-12-12','08:55:00',1.99),('16100','2013-12-12','09:00:00',2.08),('16100','2013-12-12','09:05:00',2.21),('16100','2013-12-12','09:10:00',2.38),('16100','2013-12-12','09:15:00',2.55),('16100','2013-12-12','09:20:00',2.69),('16100','2013-12-12','09:25:00',2.79),('16100','2013-12-12','09:30:00',2.87),('16100','2013-12-12','09:35:00',3.03),('16100','2013-12-12','09:40:00',3.22),('16100','2013-12-12','09:45:00',3.33),('16100','2013-12-12','09:50:00',3.49),('16100','2013-12-12','09:55:00',3.56),('16100','2013-12-12','10:00:00',3.66),('16100','2013-12-12','10:05:00',3.77),('16100','2013-12-12','10:10:00',3.84),('16100','2013-12-12','10:15:00',3.95),('16100','2013-12-12','10:20:00',4.07),('16100','2013-12-12','10:25:00',4.15),('16100','2013-12-12','10:30:00',4.23),('16100','2013-12-12','10:35:00',4.34),('16100','2013-12-12','10:40:00',4.43),('16100','2013-12-12','10:45:00',4.5),('16100','2013-12-12','10:50:00',4.56),('16100','2013-12-12','10:55:00',4.58),('16100','2013-12-12','11:00:00',4.66),('16100','2013-12-12','11:05:00',4.69),('16100','2013-12-12','11:10:00',4.74),('16100','2013-12-12','11:15:00',4.79),('16100','2013-12-12','11:20:00',4.92),('16100','2013-12-12','11:25:00',4.98),('16100','2013-12-12','11:30:00',4.99),('16100','2013-12-12','11:35:00',4.97),('16100','2013-12-12','11:40:00',5.06),('16100','2013-12-12','11:45:00',5.06),('16100','2013-12-12','11:50:00',5.07),('16100','2013-12-12','11:55:00',5.03),('16100','2013-12-12','12:00:00',5.03),('16100','2013-12-12','12:05:00',5.04),('16100','2013-12-12','12:10:00',5.02),('16100','2013-12-12','12:15:00',4.93),('16100','2013-12-12','12:20:00',4.94),('16100','2013-12-12','12:25:00',4.94),('16100','2013-12-12','12:30:00',5.32),('16100','2013-12-12','12:35:00',4.87),('16100','2013-12-12','12:40:00',4.78),('16100','2013-12-12','12:45:00',4.85),('16100','2013-12-12','12:50:00',4.79),('16100','2013-12-12','12:55:00',4.86),('16100','2013-12-12','13:00:00',4.78),('16100','2013-12-12','13:05:00',4.88),('16100','2013-12-12','13:10:00',4.66),('16100','2013-12-12','13:15:00',4.63),('16100','2013-12-12','13:20:00',4.5),('16100','2013-12-12','13:25:00',4.46),('16100','2013-12-12','13:30:00',4.51),('16100','2013-12-12','13:35:00',4.5),('16100','2013-12-12','13:40:00',4.49),('16100','2013-12-12','13:45:00',4.46),('16100','2013-12-12','13:50:00',4.25),('16100','2013-12-12','13:55:00',4.1),('16100','2013-12-12','14:00:00',3.99),('16100','2013-12-12','14:05:00',3.95),('16100','2013-12-12','14:10:00',3.77),('16100','2013-12-12','14:15:00',3.66),('16100','2013-12-12','14:20:00',3.59),('16100','2013-12-12','14:25:00',3.44),('16100','2013-12-12','14:30:00',3.24),('16100','2013-12-12','14:35:00',3.18),('16100','2013-12-12','14:40:00',3.18),('16100','2013-12-12','14:45:00',3.01),('16100','2013-12-12','14:50:00',2.89),('16100','2013-12-12','14:55:00',2.73),('16100','2013-12-12','15:00:00',2.65),('16100','2013-12-12','15:05:00',2.51),('16100','2013-12-12','15:10:00',2.37),('16100','2013-12-12','15:15:00',2.22),('16100','2013-12-12','15:20:00',2.08),('16100','2013-12-12','15:25:00',1.92),('16100','2013-12-12','15:30:00',1.75),('16100','2013-12-12','15:35:00',1.57),('16100','2013-12-12','15:40:00',1.41),('16100','2013-12-12','15:45:00',1.24),('16100','2013-12-12','15:50:00',1.06),('16100','2013-12-11','08:20:00',1.12),('16100','2013-12-11','08:25:00',1.27),('16100','2013-12-11','08:30:00',1.43),('16100','2013-12-11','08:35:00',1.6),('16100','2013-12-11','08:40:00',1.72),('16100','2013-12-11','08:45:00',1.87),('16100','2013-12-11','08:50:00',2.05),('16100','2013-12-11','08:55:00',2.19),('16100','2013-12-11','09:00:00',2.32),('16100','2013-12-11','09:05:00',2.49),('16100','2013-12-11','09:10:00',2.63),('16100','2013-12-11','09:15:00',2.74),('16100','2013-12-11','09:20:00',2.89),('16100','2013-12-11','09:25:00',3.09),('16100','2013-12-11','09:30:00',3.22),('16100','2013-12-11','09:35:00',3.37),('16100','2013-12-11','09:40:00',3.53),('16100','2013-12-11','09:45:00',3.64),('16100','2013-12-11','09:50:00',3.75),('16100','2013-12-11','09:55:00',3.83),('16100','2013-12-11','10:00:00',3.95),('16100','2013-12-11','10:05:00',4.08),('16100','2013-12-11','10:10:00',4.18),('16100','2013-12-11','10:15:00',4.3),('16100','2013-12-11','10:20:00',4.39),('16100','2013-12-11','10:25:00',4.48),('16100','2013-12-11','10:30:00',4.54),('16100','2013-12-11','10:35:00',4.62),('16100','2013-12-11','10:40:00',4.69),('16100','2013-12-11','10:45:00',4.73),('16100','2013-12-11','10:50:00',4.77),('16100','2013-12-11','10:55:00',4.82),('16100','2013-12-11','11:00:00',4.86),('16100','2013-12-11','11:05:00',4.92),('16100','2013-12-11','11:10:00',4.97),('16100','2013-12-11','11:15:00',4.99),('16100','2013-12-11','11:20:00',5.06),('16100','2013-12-11','11:25:00',5.05),('16100','2013-12-11','11:30:00',5.07),('16100','2013-12-11','11:35:00',5.09),('16100','2013-12-11','11:40:00',5.13),('16100','2013-12-11','11:45:00',5.12),('16100','2013-12-11','11:50:00',5.16),('16100','2013-12-11','11:55:00',5.19),('16100','2013-12-11','12:00:00',5.19),('16100','2013-12-11','12:05:00',5.2),('16100','2013-12-11','12:10:00',5.17),('16100','2013-12-11','12:15:00',5.18),('16100','2013-12-11','12:20:00',5.17),('16100','2013-12-11','12:25:00',5.2),('16100','2013-12-11','12:30:00',5.15),('16100','2013-12-11','12:35:00',5.17),('16100','2013-12-11','12:40:00',5.02),('16100','2013-12-11','12:45:00',4.9),('16100','2013-12-11','12:50:00',5.07),('16100','2013-12-11','12:55:00',5),('16100','2013-12-11','13:00:00',5.02),('16100','2013-12-11','13:05:00',5),('16100','2013-12-11','13:10:00',4.94),('16100','2013-12-11','13:15:00',4.89),('16100','2013-12-11','13:20:00',4.83),('16100','2013-12-11','13:25:00',4.7),('16100','2013-12-11','13:30:00',4.66),('16100','2013-12-11','13:35:00',4.54),('16100','2013-12-11','13:40:00',4.44),('16100','2013-12-11','13:45:00',4.39),('16100','2013-12-11','13:50:00',4.28),('16100','2013-12-11','13:55:00',4.16),('16100','2013-12-11','14:00:00',4.06),('16100','2013-12-11','14:05:00',3.96),('16100','2013-12-11','14:10:00',3.83),('16100','2013-12-11','14:15:00',3.7),('16100','2013-12-11','14:20:00',3.54),('16100','2013-12-11','14:25:00',3.43),('16100','2013-12-11','14:30:00',3.36),('16100','2013-12-11','14:35:00',3.24),('16100','2013-12-11','14:40:00',3.11),('16100','2013-12-11','14:45:00',2.95),('16100','2013-12-11','14:50:00',2.75),('16100','2013-12-11','14:55:00',2.63),('16100','2013-12-11','15:00:00',2.47),('16100','2013-12-11','15:05:00',2.31),('16100','2013-12-11','15:10:00',2.19),('16100','2013-12-11','15:15:00',2.04),('16100','2013-12-11','15:20:00',1.88),('16100','2013-12-11','15:25:00',1.72),('16100','2013-12-11','15:30:00',1.55),('16100','2013-12-11','15:35:00',1.4),('16100','2013-12-11','15:40:00',1.21),('16100','2013-12-11','15:45:00',1.04),('16100','2013-12-10','08:15:00',1.09),('16100','2013-12-10','08:20:00',1.28),('16100','2013-12-10','08:25:00',1.43),('16100','2013-12-10','08:30:00',1.62),('16100','2013-12-10','08:35:00',1.76),('16100','2013-12-10','08:40:00',1.95),('16100','2013-12-10','08:45:00',2.13),('16100','2013-12-10','08:50:00',2.31),('16100','2013-12-10','08:55:00',2.48),('16100','2013-12-10','09:00:00',2.61),('16100','2013-12-10','09:05:00',2.77),('16100','2013-12-10','09:10:00',2.95),('16100','2013-12-10','09:15:00',3.07),('16100','2013-12-10','09:20:00',3.17),('16100','2013-12-10','09:25:00',3.28),('16100','2013-12-10','09:30:00',3.41),('16100','2013-12-10','09:35:00',3.57),('16100','2013-12-10','09:40:00',3.72),('16100','2013-12-10','09:45:00',3.8),('16100','2013-12-10','09:50:00',3.88),('16100','2013-12-10','09:55:00',3.99),('16100','2013-12-10','10:00:00',4.11),('16100','2013-12-10','10:05:00',4.27),('16100','2013-12-10','10:10:00',4.45),('16100','2013-12-10','10:15:00',4.6),('16100','2013-12-10','10:20:00',4.67),('16100','2013-12-10','10:25:00',4.71),('16100','2013-12-10','10:30:00',4.7),('16100','2013-12-10','10:35:00',4.76),('16100','2013-12-10','10:40:00',4.85),('16100','2013-12-10','10:45:00',4.85),('16100','2013-12-10','10:50:00',4.89),('16100','2013-12-10','10:55:00',4.95),('16100','2013-12-10','11:00:00',5.06),('16100','2013-12-10','11:05:00',5.21),('16100','2013-12-10','11:10:00',5.21),('16100','2013-12-10','11:15:00',5.2),('16100','2013-12-10','11:20:00',5.26),('16100','2013-12-10','11:25:00',5.36),('16100','2013-12-10','11:30:00',5.44),('16100','2013-12-10','11:35:00',5.51),('16100','2013-12-10','11:40:00',5.51),('16100','2013-12-10','11:45:00',5.57),('16100','2013-12-10','11:50:00',5.59),('16100','2013-12-10','11:55:00',5.62),('16100','2013-12-10','12:00:00',5.59),('16100','2013-12-10','12:05:00',5.59),('16100','2013-12-10','12:10:00',5.59),('16100','2013-12-10','12:15:00',5.52),('16100','2013-12-10','12:20:00',5.54),('16100','2013-12-10','12:25:00',5.54),('16100','2013-12-10','12:30:00',5.53),('16100','2013-12-10','12:35:00',5.5),('16100','2013-12-10','12:40:00',5.42),('16100','2013-12-10','12:45:00',5.37),('16100','2013-12-10','12:50:00',5.3),('16100','2013-12-10','12:55:00',5.28),('16100','2013-12-10','13:00:00',5.28),('16100','2013-12-10','13:05:00',5.26),('16100','2013-12-10','13:10:00',5.2),('16100','2013-12-10','13:15:00',5.15),('16100','2013-12-10','13:20:00',5.08),('16100','2013-12-10','13:25:00',5.02),('16100','2013-12-10','13:30:00',4.9),('16100','2013-12-10','13:35:00',4.76),('16100','2013-12-10','13:40:00',4.66),('16100','2013-12-10','13:45:00',4.53),('16100','2013-12-10','13:50:00',4.45),('16100','2013-12-10','13:55:00',4.38),('16100','2013-12-10','14:00:00',4.31),('16100','2013-12-10','14:05:00',4.24),('16100','2013-12-10','14:10:00',4.17),('16100','2013-12-10','14:15:00',4.03),('16100','2013-12-10','14:20:00',3.85),('16100','2013-12-10','14:25:00',3.74),('16100','2013-12-10','14:30:00',3.68),('16100','2013-12-10','14:35:00',3.54),('16100','2013-12-10','14:40:00',3.41),('16100','2013-12-10','14:45:00',3.26),('16100','2013-12-10','14:50:00',3.06),('16100','2013-12-10','14:55:00',2.9),('16100','2013-12-10','15:00:00',2.74),('16100','2013-12-10','15:05:00',2.61),('16100','2013-12-10','15:10:00',2.45),('16100','2013-12-10','15:15:00',2.27),('16100','2013-12-10','15:20:00',2.09),('16100','2013-12-10','15:25:00',1.87),('16100','2013-12-10','15:30:00',1.71),('16100','2013-12-10','15:35:00',1.57),('16100','2013-12-10','15:40:00',1.41),('16100','2013-12-10','15:45:00',1.23),('16100','2013-12-10','15:50:00',1.03),('16100','2013-12-09','08:15:00',1.15),('16100','2013-12-09','08:20:00',1.32),('16100','2013-12-09','08:25:00',1.48),('16100','2013-12-09','08:30:00',1.64),('16100','2013-12-09','08:35:00',1.8),('16100','2013-12-09','08:40:00',1.98),('16100','2013-12-09','08:45:00',2.18),('16100','2013-12-09','08:50:00',2.33),('16100','2013-12-09','08:55:00',2.5),('16100','2013-12-09','09:00:00',2.66),('16100','2013-12-09','09:05:00',2.86),('16100','2013-12-09','09:10:00',3.01),('16100','2013-12-09','09:15:00',3.13),('16100','2013-12-09','09:20:00',3.24),('16100','2013-12-09','09:25:00',3.35),('16100','2013-12-09','09:30:00',3.52),('16100','2013-12-09','09:35:00',3.68),('16100','2013-12-09','09:40:00',3.83),('16100','2013-12-09','09:45:00',3.94),('16100','2013-12-09','09:50:00',4.05),('16100','2013-12-09','09:55:00',4.15),('16100','2013-12-09','10:00:00',4.23),('16100','2013-12-09','10:05:00',4.35),('16100','2013-12-09','10:10:00',4.38),('16100','2013-12-09','10:15:00',4.5),('16100','2013-12-09','10:20:00',4.61),('16100','2013-12-09','10:25:00',4.69),('16100','2013-12-09','10:30:00',4.76),('16100','2013-12-09','10:35:00',4.85),('16100','2013-12-09','10:40:00',4.9),('16100','2013-12-09','10:45:00',4.96),('16100','2013-12-09','10:50:00',5.02),('16100','2013-12-09','10:55:00',5.09),('16100','2013-12-09','11:00:00',5.14),('16100','2013-12-09','11:05:00',5.2),('16100','2013-12-09','11:10:00',5.28),('16100','2013-12-09','11:15:00',5.38),('16100','2013-12-09','11:20:00',5.44),('16100','2013-12-09','11:25:00',5.49),('16100','2013-12-09','11:30:00',5.52),('16100','2013-12-09','11:35:00',5.57),('16100','2013-12-09','11:40:00',5.59),('16100','2013-12-09','11:45:00',5.56),('16100','2013-12-09','11:50:00',5.54),('16100','2013-12-09','11:55:00',5.51),('16100','2013-12-09','12:00:00',5.47),('16100','2013-12-09','12:05:00',5.43),('16100','2013-12-09','12:10:00',5.42),('16100','2013-12-09','12:15:00',5.43),('16100','2013-12-09','12:20:00',5.4),('16100','2013-12-09','12:25:00',5.41),('16100','2013-12-09','12:30:00',5.47),('16100','2013-12-09','12:35:00',5.4),('16100','2013-12-09','12:40:00',5.35),('16100','2013-12-09','12:45:00',5.31),('16100','2013-12-09','12:50:00',5.23),('16100','2013-12-09','12:55:00',5.2),('16100','2013-12-09','13:00:00',5.17),('16100','2013-12-09','13:05:00',5.17),('16100','2013-12-09','13:10:00',5.09),('16100','2013-12-09','13:15:00',5.02),('16100','2013-12-09','13:20:00',4.94),('16100','2013-12-09','13:25:00',4.89),('16100','2013-12-09','13:30:00',4.85),('16100','2013-12-09','13:35:00',4.75),('16100','2013-12-09','13:40:00',4.6),('16100','2013-12-09','13:45:00',4.49),('16100','2013-12-09','13:50:00',4.41),('16100','2013-12-09','13:55:00',4.33),('16100','2013-12-09','14:00:00',4.26),('16100','2013-12-09','14:05:00',4.19),('16100','2013-12-09','14:10:00',4.09),('16100','2013-12-09','14:15:00',4.02),('16100','2013-12-09','14:20:00',3.93),('16100','2013-12-09','14:25:00',3.78),('16100','2013-12-09','14:30:00',3.67),('16100','2013-12-09','14:35:00',3.54),('16100','2013-12-09','14:40:00',3.35),('16100','2013-12-09','14:45:00',3.21),('16100','2013-12-09','14:50:00',3.13),('16100','2013-12-09','14:55:00',3.01),('16100','2013-12-09','15:00:00',2.9),('16100','2013-12-09','15:05:00',2.76),('16100','2013-12-09','15:10:00',2.6),('16100','2013-12-09','15:15:00',2.4),('16100','2013-12-09','15:20:00',2.24),('16100','2013-12-09','15:25:00',2.03),('16100','2013-12-09','15:30:00',1.87),('16100','2013-12-09','15:35:00',1.71),('16100','2013-12-09','15:40:00',1.54),('16100','2013-12-09','15:45:00',1.36),('16100','2013-12-09','15:50:00',1.18),('16100','2013-12-09','15:55:00',1.01),('16100','2013-12-08','09:15:00',1.98),('16100','2013-12-08','09:20:00',3.48),('16100','2013-12-08','09:25:00',3.43),('16100','2013-12-08','09:30:00',3.43),('16100','2013-12-08','09:35:00',3.58),('16100','2013-12-08','09:40:00',3.71),('16100','2013-12-08','09:45:00',3.89),('16100','2013-12-08','09:50:00',4.21),('16100','2013-12-08','09:55:00',4.77),('16100','2013-12-08','10:00:00',4.94),('16100','2013-12-08','10:05:00',4.34),('16100','2013-12-08','10:10:00',1.67),('16100','2013-12-08','10:15:00',1.15),('16100','2013-12-08','12:00:00',1.16),('16100','2013-12-08','12:05:00',1.34),('16100','2013-12-08','12:10:00',1.28),('16100','2013-12-08','12:15:00',1.18),('16100','2013-12-08','12:20:00',1.44),('16100','2013-12-08','12:25:00',2),('16100','2013-12-08','12:30:00',5.51),('16100','2013-12-08','12:35:00',3.09),('16100','2013-12-08','12:40:00',1.83),('16100','2013-12-08','12:45:00',3.04),('16100','2013-12-08','12:50:00',4.19),('16100','2013-12-08','12:55:00',5.53),('16100','2013-12-08','13:00:00',5.23),('16100','2013-12-08','13:05:00',4.39),('16100','2013-12-08','13:10:00',3.56),('16100','2013-12-08','13:15:00',2.56),('16100','2013-12-08','13:20:00',5),('16100','2013-12-08','13:25:00',4.57),('16100','2013-12-08','13:30:00',2.27),('16100','2013-12-08','13:35:00',2.8),('16100','2013-12-08','13:40:00',2.5),('16100','2013-12-08','13:45:00',2.24),('16100','2013-12-08','13:50:00',2.48),('16100','2013-12-08','13:55:00',1.66),('16100','2013-12-08','14:00:00',1.07),('16100','2013-12-07','08:55:00',1.22),('16100','2013-12-07','09:00:00',1.37),('16100','2013-12-07','09:05:00',1.94),('16100','2013-12-07','09:10:00',1.76),('16100','2013-12-07','09:15:00',2.39),('16100','2013-12-07','09:20:00',1.07),('16100','2013-12-07','09:25:00',1.01),('16100','2013-12-07','09:35:00',1.07),('16100','2013-12-07','10:05:00',1.02),('16100','2013-12-07','10:10:00',1.11),('16100','2013-12-07','10:15:00',1.07),('16100','2013-12-07','10:20:00',1.15),('16100','2013-12-07','10:25:00',1.08),('16100','2013-12-07','10:30:00',1.09),('16100','2013-12-07','10:35:00',1.31),('16100','2013-12-07','10:40:00',1.07),('16100','2013-12-07','10:45:00',1.06),('16100','2013-12-07','10:50:00',1.02),('16100','2013-12-07','11:00:00',1.09),('16100','2013-12-07','11:05:00',1.12),('16100','2013-12-07','11:10:00',1.04),('16100','2013-12-07','11:15:00',1.2),('16100','2013-12-07','11:20:00',2.64),('16100','2013-12-07','11:25:00',1.87),('16100','2013-12-07','11:30:00',2.04),('16100','2013-12-07','11:35:00',1.96),('16100','2013-12-07','11:40:00',1.83),('16100','2013-12-07','11:45:00',1.8),('16100','2013-12-07','11:50:00',2.36),('16100','2013-12-07','11:55:00',2.02),('16100','2013-12-07','12:00:00',1.78),('16100','2013-12-07','12:05:00',1.55),('16100','2013-12-07','12:10:00',1.52),('16100','2013-12-07','12:15:00',1.56),('16100','2013-12-07','12:20:00',1.65),('16100','2013-12-07','12:25:00',1.48),('16100','2013-12-07','12:30:00',1.44),('16100','2013-12-07','12:35:00',1.55),('16100','2013-12-07','12:40:00',1.51),('16100','2013-12-07','12:45:00',2.81),('16100','2013-12-07','12:50:00',2.74),('16100','2013-12-07','12:55:00',2.46),('16100','2013-12-07','13:00:00',1.54),('16100','2013-12-07','13:05:00',1.43),('16100','2014-04-20','08:35:00',1.06),('16100','2014-04-20','08:40:00',1.51),('16100','2014-04-20','08:45:00',1.71),('16100','2014-04-20','08:50:00',2.48),('16100','2014-04-20','08:55:00',2.57),('16100','2014-04-20','09:00:00',2.61),('16100','2014-04-20','09:05:00',2.36),('16100','2014-04-20','09:10:00',2.2),('16100','2014-04-20','09:15:00',2.42),('16100','2014-04-20','09:20:00',1.79),('16100','2014-04-20','09:25:00',3),('16100','2014-04-20','09:30:00',3.04),('16100','2014-04-20','09:35:00',3.13),('16100','2014-04-20','09:40:00',2.61),('16100','2014-04-20','09:45:00',1.4),('16100','2014-04-20','09:50:00',1.84),('16100','2014-04-20','09:55:00',2.12),('16100','2014-04-20','10:00:00',2.28),('16100','2014-04-20','10:05:00',2.36),('16100','2014-04-20','10:10:00',5.82),('16100','2014-04-20','10:15:00',5.84),('16100','2014-04-20','10:20:00',5.84),('16100','2014-04-20','10:25:00',5.67),('16100','2014-04-20','10:30:00',5.59),('16100','2014-04-20','10:35:00',5.65),('16100','2014-04-20','10:40:00',5.74),('16100','2014-04-20','10:45:00',5.84),('16100','2014-04-20','10:50:00',5.91),('16100','2014-04-20','10:55:00',5.98),('16100','2014-04-20','11:00:00',6.05),('16100','2014-04-20','11:05:00',6.17),('16100','2014-04-20','11:10:00',6.28),('16100','2014-04-20','11:15:00',6.33),('16100','2014-04-20','11:20:00',6.4),('16100','2014-04-20','11:25:00',6.48),('16100','2014-04-20','11:30:00',6.62),('16100','2014-04-20','11:35:00',6.68),('16100','2014-04-20','11:40:00',6.8),('16100','2014-04-20','11:45:00',6.85),('16100','2014-04-20','11:50:00',6.94),('16100','2014-04-20','11:55:00',7),('16100','2014-04-20','12:00:00',7.06),('16100','2014-04-20','12:05:00',7.13),('16100','2014-04-20','12:10:00',7.17),('16100','2014-04-20','12:15:00',7.23),('16100','2014-04-20','12:20:00',7.3),('16100','2014-04-20','12:25:00',7.29),('16100','2014-04-20','12:30:00',7.36),('16100','2014-04-20','12:35:00',7.4),('16100','2014-04-20','12:40:00',7.36),('16100','2014-04-20','12:45:00',7.41),('16100','2014-04-20','12:50:00',7.45),('16100','2014-04-20','12:55:00',7.49),('16100','2014-04-20','13:00:00',7.48),('16100','2014-04-20','13:05:00',7.45),('16100','2014-04-20','13:10:00',7.48),('16100','2014-04-20','13:15:00',7.46),('16100','2014-04-20','13:20:00',7.48),('16100','2014-04-20','13:25:00',7.47),('16100','2014-04-20','13:30:00',7.49),('16100','2014-04-20','13:35:00',7.5),('16100','2014-04-20','13:40:00',7.49),('16100','2014-04-20','13:45:00',7.51),('16100','2014-04-20','13:50:00',7.5),('16100','2014-04-20','13:55:00',7.49),('16100','2014-04-20','14:00:00',7.49),('16100','2014-04-20','14:05:00',7.41),('16100','2014-04-20','14:10:00',7.32),('16100','2014-04-20','14:15:00',7.28),('16100','2014-04-20','14:20:00',7.24),('16100','2014-04-20','14:25:00',7.18),('16100','2014-04-20','14:30:00',7.1),('16100','2014-04-20','14:35:00',7.05),('16100','2014-04-20','14:40:00',7.04),('16100','2014-04-20','14:45:00',7.01),('16100','2014-04-20','14:50:00',6.94),('16100','2014-04-20','14:55:00',6.86),('16100','2014-04-20','15:00:00',6.77),('16100','2014-04-20','15:05:00',6.71),('16100','2014-04-20','15:10:00',6.63),('16100','2014-04-20','15:15:00',6.55),('16100','2014-04-20','15:20:00',6.41),('16100','2014-04-20','15:25:00',6.3),('16100','2014-04-20','15:30:00',6.22),('16100','2014-04-20','15:35:00',6.11),('16100','2014-04-20','15:40:00',5.98),('16100','2014-04-20','15:45:00',5.9),('16100','2014-04-20','15:50:00',5.79),('16100','2014-04-20','15:55:00',5.69),('16100','2014-04-20','16:00:00',5.7),('16100','2014-04-20','16:05:00',5.82),('16100','2014-04-20','16:10:00',5.51),('16100','2014-04-20','16:15:00',5.28),('16100','2014-04-20','16:20:00',5.16),('16100','2014-04-20','16:25:00',5.13),('16100','2014-04-20','16:30:00',5.01),('16100','2014-04-20','16:35:00',4.76),('16100','2014-04-20','16:40:00',4.66),('16100','2014-04-20','16:45:00',4.51),('16100','2014-04-20','16:50:00',4.38),('16100','2014-04-20','16:55:00',4.24),('16100','2014-04-20','17:00:00',4.08),('16100','2014-04-20','17:05:00',3.96),('16100','2014-04-20','17:10:00',3.81),('16100','2014-04-20','17:15:00',3.65),('16100','2014-04-20','17:20:00',3.51),('16100','2014-04-20','17:25:00',3.33),('16100','2014-04-20','17:30:00',3.18),('16100','2014-04-20','17:35:00',3.03),('16100','2014-04-20','17:40:00',2.86),('16100','2014-04-20','17:45:00',2.7),('16100','2014-04-20','17:50:00',2.53),('16100','2014-04-20','17:55:00',2.35),('16100','2014-04-20','18:00:00',2.18),('16100','2014-04-20','18:05:00',2),('16100','2014-04-20','18:10:00',1.81),('16100','2014-04-20','18:15:00',1.59),('16100','2014-04-20','18:20:00',1.46),('16100','2014-04-20','18:25:00',1.3),('16100','2014-04-20','18:30:00',1.14),('16100','2013-12-06','08:10:00',1.07),('16100','2013-12-06','08:15:00',1.22),('16100','2013-12-06','08:20:00',1.36),('16100','2013-12-06','08:25:00',1.5),('16100','2013-12-06','08:30:00',1.66),('16100','2013-12-06','08:35:00',1.81),('16100','2013-12-06','08:40:00',1.96),('16100','2013-12-06','08:45:00',2.09),('16100','2013-12-06','08:50:00',2.22),('16100','2013-12-06','08:55:00',2.38),('16100','2013-12-06','09:00:00',2.52),('16100','2013-12-06','09:05:00',2.71),('16100','2013-12-06','09:10:00',2.86),('16100','2013-12-06','09:15:00',2.99),('16100','2013-12-06','09:20:00',3.14),('16100','2013-12-06','09:25:00',3.29),('16100','2013-12-06','09:30:00',3.45),('16100','2013-12-06','09:35:00',3.62),('16100','2013-12-06','09:40:00',3.73),('16100','2013-12-06','09:45:00',3.84),('16100','2013-12-06','09:50:00',3.96),('16100','2013-12-06','09:55:00',4.07),('16100','2013-12-06','10:00:00',4.18),('16100','2013-12-06','10:05:00',4.33),('16100','2013-12-06','10:10:00',4.43),('16100','2013-12-06','10:15:00',4.53),('16100','2013-12-06','10:20:00',4.6),('16100','2013-12-06','10:25:00',4.63),('16100','2013-12-06','10:30:00',4.72),('16100','2013-12-06','10:35:00',4.81),('16100','2013-12-06','10:40:00',4.89),('16100','2013-12-06','10:45:00',4.99),('16100','2013-12-06','10:50:00',4.97),('16100','2013-12-06','10:55:00',5.03),('16100','2013-12-06','11:00:00',5.06),('16100','2013-12-06','11:05:00',5.11),('16100','2013-12-06','11:10:00',5.08),('16100','2013-12-06','11:15:00',5.08),('16100','2013-12-06','11:20:00',5.1),('16100','2013-12-06','11:25:00',5.15),('16100','2013-12-06','11:30:00',5.21),('16100','2013-12-06','11:35:00',5.33),('16100','2013-12-06','11:40:00',5.32),('16100','2013-12-06','11:45:00',5.28),('16100','2013-12-06','11:50:00',5.24),('16100','2013-12-06','11:55:00',5.22),('16100','2013-12-06','12:00:00',5.26),('16100','2013-12-06','12:05:00',5.27),('16100','2013-12-06','12:10:00',5.23),('16100','2013-12-06','12:15:00',5.26),('16100','2013-12-06','12:20:00',5.18),('16100','2013-12-06','12:25:00',5.12),('16100','2013-12-06','12:30:00',5.15),('16100','2013-12-06','12:35:00',5),('16100','2013-12-06','12:40:00',4.93),('16100','2013-12-06','12:45:00',5.05),('16100','2013-12-06','12:50:00',5.04),('16100','2013-12-06','12:55:00',5.01),('16100','2013-12-06','13:00:00',4.95),('16100','2013-12-06','13:05:00',4.81),('16100','2013-12-06','13:10:00',4.71),('16100','2013-12-06','13:15:00',4.68),('16100','2013-12-06','13:20:00',4.61),('16100','2013-12-06','13:25:00',4.46),('16100','2013-12-06','13:30:00',4.46),('16100','2013-12-06','13:35:00',4.33),('16100','2013-12-06','13:40:00',4.28),('16100','2013-12-06','13:45:00',4.17),('16100','2013-12-06','13:50:00',4.13),('16100','2013-12-06','13:55:00',4.11),('16100','2013-12-06','14:00:00',4.07),('16100','2013-12-06','14:05:00',3.99),('16100','2013-12-06','14:10:00',3.89),('16100','2013-12-06','14:15:00',3.77),('16100','2013-12-06','14:20:00',3.61),('16100','2013-12-06','14:25:00',3.51),('16100','2013-12-06','14:30:00',3.4),('16100','2013-12-06','14:35:00',3.29),('16100','2013-12-06','14:40:00',3.14),('16100','2013-12-06','14:45:00',3),('16100','2013-12-06','14:50:00',2.88),('16100','2013-12-06','14:55:00',2.75),('16100','2013-12-06','15:00:00',2.58),('16100','2013-12-06','15:05:00',2.44),('16100','2013-12-06','15:10:00',2.26),('16100','2013-12-06','15:15:00',2.09),('16100','2013-12-06','15:20:00',1.94),('16100','2013-12-06','15:25:00',1.77),('16100','2013-12-06','15:30:00',1.61),('16100','2013-12-06','15:35:00',1.44),('16100','2013-12-06','15:40:00',1.29),('16100','2013-12-06','15:45:00',1.12),('16100','2013-12-05','09:55:00',1.04),('16100','2013-12-05','10:00:00',1.44),('16100','2013-12-05','10:05:00',1.28),('16100','2013-12-05','10:10:00',1.37),('16100','2013-12-05','10:15:00',1.69),('16100','2013-12-05','10:20:00',1.68),('16100','2013-12-05','10:25:00',1.52),('16100','2013-12-05','10:30:00',1.42),('16100','2013-12-05','10:35:00',1.38),('16100','2013-12-05','10:40:00',1.81),('16100','2013-12-05','10:45:00',1.77),('16100','2013-12-05','10:50:00',1.7),('16100','2013-12-05','10:55:00',1.56),('16100','2013-12-05','11:00:00',1.44),('16100','2013-12-05','11:05:00',1.66),('16100','2013-12-05','11:10:00',1.57),('16100','2013-12-05','11:15:00',1.68),('16100','2013-12-05','11:20:00',2.09),('16100','2013-12-05','11:25:00',2.5),('16100','2013-12-05','11:30:00',2.89),('16100','2013-12-05','11:35:00',3.67),('16100','2013-12-05','11:40:00',3.45),('16100','2013-12-05','11:45:00',3.19),('16100','2013-12-05','11:50:00',4.03),('16100','2013-12-05','11:55:00',4.34),('16100','2013-12-05','12:00:00',3.78),('16100','2013-12-05','12:05:00',5.07),('16100','2013-12-05','12:10:00',3.4),('16100','2013-12-05','12:15:00',4.99),('16100','2013-12-05','12:20:00',6.53),('16100','2013-12-05','12:25:00',5.12),('16100','2013-12-05','12:30:00',2.59),('16100','2013-12-05','12:35:00',2.14),('16100','2013-12-05','12:40:00',1.83),('16100','2013-12-05','12:45:00',1.58),('16100','2013-12-05','12:50:00',1.42),('16100','2013-12-05','12:55:00',1.41),('16100','2013-12-05','13:00:00',1.49),('16100','2013-12-05','13:05:00',1.18),('16100','2013-12-05','13:10:00',1.07),('16100','2013-12-05','13:15:00',1.05),('16100','2013-12-05','13:20:00',1.2),('16100','2013-12-05','13:25:00',1.44),('16100','2013-12-05','13:30:00',1.46),('16100','2013-12-05','13:35:00',1.48),('16100','2013-12-05','13:40:00',1.56),('16100','2013-12-05','13:45:00',1.5),('16100','2013-12-05','13:50:00',1.59),('16100','2013-12-05','13:55:00',1.42),('16100','2013-12-05','14:00:00',1.19),('16100','2013-12-05','14:05:00',1.16),('16100','2013-12-05','14:10:00',1.2),('16100','2013-12-05','14:15:00',1.2),('16100','2013-12-05','14:20:00',1.27),('16100','2013-12-05','14:25:00',1.24),('16100','2013-12-05','14:30:00',1.11),('16100','2013-12-05','14:35:00',1.07),('16100','2013-12-05','14:40:00',1.56),('16100','2013-12-05','14:45:00',1.49),('16100','2013-12-05','14:50:00',1.64),('16100','2013-12-05','14:55:00',2.33),('16100','2013-12-05','15:00:00',2.91),('16100','2013-12-05','15:05:00',2.82),('16100','2013-12-05','15:10:00',2.51),('16100','2013-12-05','15:15:00',2.75),('16100','2013-12-05','15:20:00',1.73),('16100','2013-12-05','15:25:00',1.57),('16100','2013-12-05','15:30:00',1.58),('16100','2013-12-05','15:35:00',1.18),('16100','2013-12-05','15:40:00',1.04),('16100','2013-12-05','15:45:00',1.39),('16100','2013-12-05','15:50:00',1.14),('16100','2013-12-04','08:10:00',1.1),('16100','2013-12-04','08:15:00',1.26),('16100','2013-12-04','08:20:00',1.43),('16100','2013-12-04','08:25:00',1.59),('16100','2013-12-04','08:30:00',1.76),('16100','2013-12-04','08:35:00',1.91),('16100','2013-12-04','08:40:00',2.09),('16100','2013-12-04','08:45:00',2.26),('16100','2013-12-04','08:50:00',2.44),('16100','2013-12-04','08:55:00',2.6),('16100','2013-12-04','09:00:00',2.77),('16100','2013-12-04','09:05:00',2.95),('16100','2013-12-04','09:10:00',3.08),('16100','2013-12-04','09:15:00',3.2),('16100','2013-12-04','09:20:00',3.35),('16100','2013-12-04','09:25:00',3.47),('16100','2013-12-04','09:30:00',3.61),('16100','2013-12-04','09:35:00',3.77),('16100','2013-12-04','09:40:00',3.89),('16100','2013-12-04','09:45:00',3.99),('16100','2013-12-04','09:50:00',4.11),('16100','2013-12-04','09:55:00',4.18),('16100','2013-12-04','10:00:00',4.29),('16100','2013-12-04','10:05:00',4.39),('16100','2013-12-04','10:10:00',4.51),('16100','2013-12-04','10:15:00',4.61),('16100','2013-12-04','10:20:00',4.68),('16100','2013-12-04','10:25:00',4.75),('16100','2013-12-04','10:30:00',4.87),('16100','2013-12-04','10:35:00',4.94),('16100','2013-12-04','10:40:00',4.97),('16100','2013-12-04','10:45:00',4.98),('16100','2013-12-04','10:50:00',5.02),('16100','2013-12-04','10:55:00',5.05),('16100','2013-12-04','11:00:00',5.1),('16100','2013-12-04','11:05:00',5.25),('16100','2013-12-04','11:10:00',5.28),('16100','2013-12-04','11:15:00',5.28),('16100','2013-12-04','11:20:00',5.33),('16100','2013-12-04','11:25:00',5.43),('16100','2013-12-04','11:30:00',5.42),('16100','2013-12-04','11:35:00',5.33),('16100','2013-12-04','11:40:00',5.36),('16100','2013-12-04','11:45:00',5.35),('16100','2013-12-04','11:50:00',5.37),('16100','2013-12-04','11:55:00',5.38),('16100','2013-12-04','12:00:00',5.35),('16100','2013-12-04','12:05:00',5.43),('16100','2013-12-04','12:10:00',5.29),('16100','2013-12-04','12:15:00',5.39),('16100','2013-12-04','12:20:00',5.25),('16100','2013-12-04','12:25:00',5.39),('16100','2013-12-04','12:30:00',5.3),('16100','2013-12-04','12:35:00',5.37),('16100','2013-12-04','12:40:00',5.31),('16100','2013-12-04','12:45:00',5.41),('16100','2013-12-04','12:50:00',5.34),('16100','2013-12-04','12:55:00',5.23),('16100','2013-12-04','13:00:00',5.32),('16100','2013-12-04','13:05:00',5.28),('16100','2013-12-04','13:10:00',5.14),('16100','2013-12-04','13:15:00',4.86),('16100','2013-12-04','13:20:00',5.02),('16100','2013-12-04','13:25:00',4.88),('16100','2013-12-04','13:30:00',4.9),('16100','2013-12-04','13:35:00',4.59),('16100','2013-12-04','13:40:00',4.55),('16100','2013-12-04','13:45:00',4.36),('16100','2013-12-04','13:50:00',4),('16100','2013-12-04','13:55:00',4.4),('16100','2013-12-04','14:00:00',4.21),('16100','2013-12-04','14:05:00',4.25),('16100','2013-12-04','14:10:00',4.14),('16100','2013-12-04','14:15:00',3.91),('16100','2013-12-04','14:20:00',3.59),('16100','2013-12-04','14:25:00',3.49),('16100','2013-12-04','14:30:00',3.48),('16100','2013-12-04','14:35:00',3.41),('16100','2013-12-04','14:40:00',3.23),('16100','2013-12-04','14:45:00',3.06),('16100','2013-12-04','14:50:00',2.92),('16100','2013-12-04','14:55:00',2.76),('16100','2013-12-04','15:00:00',2.58),('16100','2013-12-04','15:05:00',2.44),('16100','2013-12-04','15:10:00',2.35),('16100','2013-12-04','15:15:00',2.07),('16100','2013-12-04','15:20:00',1.85),('16100','2013-12-04','15:25:00',1.7),('16100','2013-12-04','15:30:00',1.55),('16100','2013-12-04','15:35:00',1.41),('16100','2013-12-04','15:40:00',1.18),('16100','2013-12-03','08:00:00',1.05),('16100','2013-12-03','08:05:00',1.23),('16100','2013-12-03','08:10:00',1.41),('16100','2013-12-03','08:15:00',1.59),('16100','2013-12-03','08:20:00',1.76),('16100','2013-12-03','08:25:00',1.94),('16100','2013-12-03','08:30:00',2.1),('16100','2013-12-03','08:35:00',2.26),('16100','2013-12-03','08:40:00',2.47),('16100','2013-12-03','08:45:00',2.64),('16100','2013-12-03','08:50:00',2.83),('16100','2013-12-03','08:55:00',2.98),('16100','2013-12-03','09:00:00',3.12),('16100','2013-12-03','09:05:00',3.28),('16100','2013-12-03','09:10:00',3.42),('16100','2013-12-03','09:15:00',3.55),('16100','2013-12-03','09:20:00',3.68),('16100','2013-12-03','09:25:00',3.8),('16100','2013-12-03','09:30:00',3.94),('16100','2013-12-03','09:35:00',4.1),('16100','2013-12-03','09:40:00',4.22),('16100','2013-12-03','09:45:00',4.32),('16100','2013-12-03','09:50:00',4.42),('16100','2013-12-03','09:55:00',4.52),('16100','2013-12-03','10:00:00',4.66),('16100','2013-12-03','10:05:00',4.77),('16100','2013-12-03','10:10:00',4.87),('16100','2013-12-03','10:15:00',4.97),('16100','2013-12-03','10:20:00',5.05),('16100','2013-12-03','10:25:00',5.16),('16100','2013-12-03','10:30:00',5.25),('16100','2013-12-03','10:35:00',5.29),('16100','2013-12-03','10:40:00',5.32),('16100','2013-12-03','10:45:00',5.38),('16100','2013-12-03','10:50:00',5.44),('16100','2013-12-03','10:55:00',5.51),('16100','2013-12-03','11:00:00',5.58),('16100','2013-12-03','11:05:00',5.63),('16100','2013-12-03','11:10:00',5.64),('16100','2013-12-03','11:15:00',5.67),('16100','2013-12-03','11:20:00',5.71),('16100','2013-12-03','11:25:00',5.73),('16100','2013-12-03','11:30:00',5.75),('16100','2013-12-03','11:35:00',5.77),('16100','2013-12-03','11:40:00',5.8),('16100','2013-12-03','11:45:00',5.83),('16100','2013-12-03','11:50:00',5.84),('16100','2013-12-03','11:55:00',5.84),('16100','2013-12-03','12:00:00',5.85),('16100','2013-12-03','12:05:00',5.84),('16100','2013-12-03','12:10:00',5.81),('16100','2013-12-03','12:15:00',5.83),('16100','2013-12-03','12:20:00',5.75),('16100','2013-12-03','12:25:00',5.75),('16100','2013-12-03','12:30:00',5.7),('16100','2013-12-03','12:35:00',5.62),('16100','2013-12-03','12:40:00',5.6),('16100','2013-12-03','12:45:00',5.55),('16100','2013-12-03','12:50:00',5.52),('16100','2013-12-03','12:55:00',5.47),('16100','2013-12-03','13:00:00',5.46),('16100','2013-12-03','13:05:00',5.39),('16100','2013-12-03','13:10:00',5.36),('16100','2013-12-03','13:15:00',5.31),('16100','2013-12-03','13:20:00',5.22),('16100','2013-12-03','13:25:00',5.13),('16100','2013-12-03','13:30:00',5.08),('16100','2013-12-03','13:35:00',4.97),('16100','2013-12-03','13:40:00',4.87),('16100','2013-12-03','13:45:00',4.72),('16100','2013-12-03','13:50:00',4.53),('16100','2013-12-03','13:55:00',4.58),('16100','2013-12-03','14:00:00',4.53),('16100','2013-12-03','14:05:00',4.42),('16100','2013-12-03','14:10:00',4.33),('16100','2013-12-03','14:15:00',4.21),('16100','2013-12-03','14:20:00',4.04),('16100','2013-12-03','14:25:00',3.96),('16100','2013-12-03','14:30:00',3.82),('16100','2013-12-03','14:35:00',3.73),('16100','2013-12-03','14:40:00',3.63),('16100','2013-12-03','14:45:00',3.49),('16100','2013-12-03','14:50:00',3.37),('16100','2013-12-03','14:55:00',3.24),('16100','2013-12-03','15:00:00',3.08),('16100','2013-12-03','15:05:00',2.91),('16100','2013-12-03','15:10:00',2.75),('16100','2013-12-03','15:15:00',2.59),('16100','2013-12-03','15:20:00',2.43),('16100','2013-12-03','15:25:00',2.25),('16100','2013-12-03','15:30:00',2.08),('16100','2013-12-03','15:35:00',1.9),('16100','2013-12-03','15:40:00',1.72),('16100','2013-12-03','15:45:00',1.54),('16100','2013-12-03','15:50:00',1.36),('16100','2013-12-03','15:55:00',1.15),('16100','2013-12-02','08:50:00',1.07),('16100','2013-12-02','08:55:00',2.03),('16100','2013-12-02','09:00:00',1.69),('16100','2013-12-02','09:10:00',1.1),('16100','2013-12-02','09:15:00',1.07),('16100','2013-12-02','09:20:00',1.3),('16100','2013-12-02','09:25:00',1.89),('16100','2013-12-02','09:30:00',2.51),('16100','2013-12-02','09:35:00',2.92),('16100','2013-12-02','09:40:00',3.36),('16100','2013-12-02','09:45:00',4.42),('16100','2013-12-02','09:50:00',4.28),('16100','2013-12-02','09:55:00',4.03),('16100','2013-12-02','10:00:00',4.42),('16100','2013-12-02','10:05:00',4.73),('16100','2013-12-02','10:10:00',4.83),('16100','2013-12-02','10:15:00',4.94),('16100','2013-12-02','10:20:00',5.02),('16100','2013-12-02','10:25:00',5.1),('16100','2013-12-02','10:30:00',5.16),('16100','2013-12-02','10:35:00',5.21),('16100','2013-12-02','10:40:00',5.26),('16100','2013-12-02','10:45:00',5.32),('16100','2013-12-02','10:50:00',5.4),('16100','2013-12-02','10:55:00',5.46),('16100','2013-12-02','11:00:00',5.58),('16100','2013-12-02','11:05:00',5.65),('16100','2013-12-02','11:10:00',5.71),('16100','2013-12-02','11:15:00',5.75),('16100','2013-12-02','11:20:00',5.8),('16100','2013-12-02','11:25:00',5.85),('16100','2013-12-02','11:30:00',5.86),('16100','2013-12-02','11:35:00',5.88),('16100','2013-12-02','11:40:00',5.94),('16100','2013-12-02','11:45:00',5.95),('16100','2013-12-02','11:50:00',5.96),('16100','2013-12-02','11:55:00',5.98),('16100','2013-12-02','12:00:00',5.97),('16100','2013-12-02','12:05:00',5.98),('16100','2013-12-02','12:10:00',6.04),('16100','2013-12-02','12:15:00',6.12),('16100','2013-12-02','12:20:00',6.11),('16100','2013-12-02','12:25:00',6.16),('16100','2013-12-02','12:30:00',6.18),('16100','2013-12-02','12:35:00',6.22),('16100','2013-12-02','12:40:00',6.31),('16100','2013-12-02','12:45:00',6.4),('16100','2013-12-02','12:50:00',6.51),('16100','2013-12-02','12:55:00',6.67),('16100','2013-12-02','13:00:00',6.79),('16100','2013-12-02','13:05:00',6.69),('16100','2013-12-02','13:10:00',6.73),('16100','2013-12-02','13:15:00',6.57),('16100','2013-12-02','13:20:00',5.85),('16100','2013-12-02','13:25:00',4.26),('16100','2013-12-02','13:30:00',3.68),('16100','2013-12-02','13:35:00',3.87),('16100','2013-12-02','13:40:00',3.99),('16100','2013-12-02','13:45:00',3.86),('16100','2013-12-02','13:50:00',2.66),('16100','2013-12-02','13:55:00',1.89),('16100','2013-12-02','14:00:00',1.95),('16100','2013-12-02','14:05:00',2.49),('16100','2013-12-02','14:10:00',3.38),('16100','2013-12-02','14:15:00',3.93),('16100','2013-12-02','14:20:00',3.67),('16100','2013-12-02','14:25:00',3.89),('16100','2013-12-02','14:30:00',3.88),('16100','2013-12-02','14:35:00',3.74),('16100','2013-12-02','14:40:00',3.59),('16100','2013-12-02','14:45:00',3.43),('16100','2013-12-02','14:50:00',3.27),('16100','2013-12-02','14:55:00',3.14),('16100','2013-12-02','15:00:00',2.99),('16100','2013-12-02','15:05:00',2.83),('16100','2013-12-02','15:10:00',2.65),('16100','2013-12-02','15:15:00',2.46),('16100','2013-12-02','15:20:00',2.29),('16100','2013-12-02','15:25:00',2.09),('16100','2013-12-02','15:30:00',1.91),('16100','2013-12-02','15:35:00',1.74),('16100','2013-12-02','15:40:00',1.54),('16100','2013-12-02','15:45:00',1.38),('16100','2013-12-02','15:50:00',1.19),('16100','2013-12-02','15:55:00',1.02),('16100','2013-11-30','11:25:00',1.08),('16100','2013-11-30','11:30:00',1.38),('16100','2013-11-30','11:35:00',2.26),('16100','2013-11-30','11:40:00',3.19),('16100','2013-11-30','11:45:00',2.48),('16100','2013-11-30','11:50:00',2.06),('16100','2013-11-30','11:55:00',3.06),('16100','2013-11-30','12:00:00',3.81),('16100','2013-11-30','12:05:00',2.9),('16100','2013-11-30','12:10:00',4.37),('16100','2013-11-30','12:15:00',3.5),('16100','2013-11-30','12:20:00',2.12),('16100','2013-11-30','12:25:00',1.29),('16100','2013-11-30','12:45:00',2.85),('16100','2013-11-30','12:50:00',4.25),('16100','2013-11-30','12:55:00',1.79),('16100','2013-11-30','13:00:00',1.94),('16100','2013-11-30','13:05:00',1.54),('16100','2013-11-30','13:20:00',1.07),('16100','2013-11-30','14:05:00',1.09),('16100','2013-11-29','08:55:00',1.02),('16100','2013-11-29','09:00:00',1.02),('16100','2013-11-29','09:05:00',1.18),('16100','2013-11-29','09:10:00',2.87),('16100','2013-11-29','09:15:00',3.06),('16100','2013-11-29','09:20:00',3.24),('16100','2013-11-29','09:25:00',3.17),('16100','2013-11-29','09:30:00',3.48),('16100','2013-11-29','09:35:00',3.15),('16100','2013-11-29','09:40:00',3.39),('16100','2013-11-29','09:45:00',2.14),('16100','2013-11-29','09:50:00',1.89),('16100','2013-11-29','09:55:00',1.63),('16100','2013-11-29','10:00:00',1.57),('16100','2013-11-29','10:05:00',1.68),('16100','2013-11-29','10:10:00',1.74),('16100','2013-11-29','10:15:00',1.58),('16100','2013-11-29','10:20:00',1.78),('16100','2013-11-29','10:25:00',1.85),('16100','2013-11-29','10:30:00',1.89),('16100','2013-11-29','10:35:00',1.97),('16100','2013-11-29','10:40:00',2.03),('16100','2013-11-29','10:45:00',2.47),('16100','2013-11-29','10:50:00',2.27),('16100','2013-11-29','10:55:00',1.93),('16100','2013-11-29','11:00:00',1.66),('16100','2013-11-29','11:05:00',1.82),('16100','2013-11-29','11:10:00',2.18),('16100','2013-11-29','11:15:00',2.19),('16100','2013-11-29','11:20:00',2.31),('16100','2013-11-29','11:25:00',2.22),('16100','2013-11-29','11:30:00',2.17),('16100','2013-11-29','11:35:00',1.89),('16100','2013-11-29','11:40:00',1.5),('16100','2013-11-29','11:45:00',1.38),('16100','2013-11-29','11:50:00',1.53),('16100','2013-11-29','11:55:00',1.41),('16100','2013-11-29','12:00:00',1.21),('16100','2013-11-29','12:05:00',1),('16100','2013-11-28','08:00:00',1.1),('16100','2013-11-28','08:05:00',1.25),('16100','2013-11-28','08:10:00',1.43),('16100','2013-11-28','08:15:00',1.61),('16100','2013-11-28','08:20:00',1.77),('16100','2013-11-28','08:25:00',1.96),('16100','2013-11-28','08:30:00',2.11),('16100','2013-11-28','08:35:00',2.26),('16100','2013-11-28','08:40:00',2.43),('16100','2013-11-28','08:45:00',2.59),('16100','2013-11-28','08:50:00',2.74),('16100','2013-11-28','08:55:00',2.87),('16100','2013-11-28','09:00:00',3.04),('16100','2013-11-28','09:05:00',3.18),('16100','2013-11-28','09:10:00',3.31),('16100','2013-11-28','09:15:00',3.45),('16100','2013-11-28','09:20:00',3.6),('16100','2013-11-28','09:25:00',3.71),('16100','2013-11-28','09:30:00',3.89),('16100','2013-11-28','09:35:00',4.07),('16100','2013-11-28','09:40:00',4.18),('16100','2013-11-28','09:45:00',4.29),('16100','2013-11-28','09:50:00',4.42),('16100','2013-11-28','09:55:00',4.54),('16100','2013-11-28','10:00:00',4.69),('16100','2013-11-28','10:05:00',4.81),('16100','2013-11-28','10:10:00',4.95),('16100','2013-11-28','10:15:00',5.05),('16100','2013-11-28','10:20:00',5.14),('16100','2013-11-28','10:25:00',5.24),('16100','2013-11-28','10:30:00',5.32),('16100','2013-11-28','10:35:00',5.39),('16100','2013-11-28','10:40:00',5.45),('16100','2013-11-28','10:45:00',5.5),('16100','2013-11-28','10:50:00',5.55),('16100','2013-11-28','10:55:00',5.6),('16100','2013-11-28','11:00:00',5.65),('16100','2013-11-28','11:05:00',5.68),('16100','2013-11-28','11:10:00',5.74),('16100','2013-11-28','11:15:00',5.76),('16100','2013-11-28','11:20:00',5.78),('16100','2013-11-28','11:25:00',5.8),('16100','2013-11-28','11:30:00',5.82),('16100','2013-11-28','11:35:00',5.88),('16100','2013-11-28','11:40:00',5.88),('16100','2013-11-28','11:45:00',5.9),('16100','2013-11-28','11:50:00',5.91),('16100','2013-11-28','11:55:00',5.91),('16100','2013-11-28','12:00:00',5.92),('16100','2013-11-28','12:05:00',5.91),('16100','2013-11-28','12:10:00',5.89),('16100','2013-11-28','12:15:00',5.87),('16100','2013-11-28','12:20:00',5.86),('16100','2013-11-28','12:25:00',5.84),('16100','2013-11-28','12:30:00',5.78),('16100','2013-11-28','12:35:00',5.73),('16100','2013-11-28','12:40:00',5.68),('16100','2013-11-28','12:45:00',5.65),('16100','2013-11-28','12:50:00',5.65),('16100','2013-11-28','12:55:00',5.57),('16100','2013-11-28','13:00:00',5.53),('16100','2013-11-28','13:05:00',5.5),('16100','2013-11-28','13:10:00',5.47),('16100','2013-11-28','13:15:00',5.44),('16100','2013-11-28','13:20:00',5.41),('16100','2013-11-28','13:25:00',5.34),('16100','2013-11-28','13:30:00',5.21),('16100','2013-11-28','13:35:00',5.12),('16100','2013-11-28','13:40:00',4.99),('16100','2013-11-28','13:45:00',4.9),('16100','2013-11-28','13:50:00',4.8),('16100','2013-11-28','13:55:00',4.69),('16100','2013-11-28','14:00:00',4.6),('16100','2013-11-28','14:05:00',4.49),('16100','2013-11-28','14:10:00',4.39),('16100','2013-11-28','14:15:00',4.24),('16100','2013-11-28','14:20:00',4.11),('16100','2013-11-28','14:25:00',3.98),('16100','2013-11-28','14:30:00',3.84),('16100','2013-11-28','14:35:00',3.71),('16100','2013-11-28','14:40:00',3.59),('16100','2013-11-28','14:45:00',3.45),('16100','2013-11-28','14:50:00',3.3),('16100','2013-11-28','14:55:00',3.18),('16100','2013-11-28','15:00:00',3),('16100','2013-11-28','15:05:00',2.85),('16100','2013-11-28','15:10:00',2.68),('16100','2013-11-28','15:15:00',2.51),('16100','2013-11-28','15:20:00',2.33),('16100','2013-11-28','15:25:00',2.16),('16100','2013-11-28','15:30:00',1.99),('16100','2013-11-28','15:35:00',1.81),('16100','2013-11-28','15:40:00',1.61),('16100','2013-11-28','15:45:00',1.43),('16100','2013-11-28','15:50:00',1.23),('16100','2013-11-28','15:55:00',1.05),('16100','2013-11-27','12:50:00',1.04),('16100','2013-11-27','13:30:00',1.08),('16100','2013-11-27','13:40:00',1.22),('16100','2013-11-27','13:45:00',1.52),('16100','2013-11-27','13:50:00',1.09),('16100','2014-04-19','08:00:00',1.08),('16100','2014-04-19','08:05:00',1.33),('16100','2014-04-19','08:10:00',1.31),('16100','2014-04-19','08:15:00',1.43),('16100','2014-04-19','08:20:00',2.43),('16100','2014-04-19','08:25:00',3.02),('16100','2014-04-19','08:30:00',3.3),('16100','2014-04-19','08:35:00',2.23),('16100','2014-04-19','08:40:00',1.31),('16100','2014-04-19','08:45:00',1.51),('16100','2014-04-19','08:50:00',2.21),('16100','2014-04-19','08:55:00',3.32),('16100','2014-04-19','09:00:00',3.69),('16100','2014-04-19','09:05:00',2.94),('16100','2014-04-19','09:10:00',1.75),('16100','2014-04-19','09:15:00',4.1),('16100','2014-04-19','09:20:00',4.17),('16100','2014-04-19','09:25:00',4.54),('16100','2014-04-19','09:30:00',4.99),('16100','2014-04-19','09:35:00',5.3),('16100','2014-04-19','09:40:00',5.93),('16100','2014-04-19','09:45:00',4.8),('16100','2014-04-19','09:50:00',3.01),('16100','2014-04-19','09:55:00',3.03),('16100','2014-04-19','10:00:00',3.86),('16100','2014-04-19','10:05:00',4.59),('16100','2014-04-19','10:10:00',4.46),('16100','2014-04-19','10:15:00',4.33),('16100','2014-04-19','10:20:00',4.51),('16100','2014-04-19','10:25:00',4.39),('16100','2014-04-19','10:30:00',3.76),('16100','2014-04-19','10:35:00',3.74),('16100','2014-04-19','10:40:00',3.76),('16100','2014-04-19','10:45:00',4.36),('16100','2014-04-19','10:50:00',4.85),('16100','2014-04-19','10:55:00',5.95),('16100','2014-04-19','11:00:00',4.37),('16100','2014-04-19','11:05:00',6.03),('16100','2014-04-19','11:10:00',5.5),('16100','2014-04-19','11:15:00',6.14),('16100','2014-04-19','11:20:00',7.74),('16100','2014-04-19','11:25:00',7.46),('16100','2014-04-19','11:30:00',7.36),('16100','2014-04-19','11:35:00',7.51),('16100','2014-04-19','11:40:00',7.38),('16100','2014-04-19','11:45:00',6.42),('16100','2014-04-19','11:50:00',7.44),('16100','2014-04-19','11:55:00',7.35),('16100','2014-04-19','12:00:00',7.38),('16100','2014-04-19','12:05:00',7.46),('16100','2014-04-19','12:10:00',7.41),('16100','2014-04-19','12:15:00',7.41),('16100','2014-04-19','12:20:00',7.53),('16100','2014-04-19','12:25:00',7.43),('16100','2014-04-19','12:30:00',6.4),('16100','2014-04-19','12:35:00',7.81),('16100','2014-04-19','12:40:00',8.15),('16100','2014-04-19','12:45:00',7.72),('16100','2014-04-19','12:50:00',6.81),('16100','2014-04-19','12:55:00',7.55),('16100','2014-04-19','13:00:00',8.1),('16100','2014-04-19','13:05:00',8.11),('16100','2014-04-19','13:10:00',8.09),('16100','2014-04-19','13:15:00',7.86),('16100','2014-04-19','13:20:00',7.56),('16100','2014-04-19','13:25:00',7.53),('16100','2014-04-19','13:30:00',7.61),('16100','2014-04-19','13:35:00',7.65),('16100','2014-04-19','13:40:00',7.62),('16100','2014-04-19','13:45:00',7.68),('16100','2014-04-19','13:50:00',7.65),('16100','2014-04-19','13:55:00',7.54),('16100','2014-04-19','14:00:00',7.53),('16100','2014-04-19','14:05:00',7.55),('16100','2014-04-19','14:10:00',7.56),('16100','2014-04-19','14:15:00',6.95),('16100','2014-04-19','14:20:00',6.37),('16100','2014-04-19','14:25:00',4.68),('16100','2014-04-19','14:30:00',4.62),('16100','2014-04-19','14:35:00',3.97),('16100','2014-04-19','14:40:00',3.76),('16100','2014-04-19','14:45:00',4.01),('16100','2014-04-19','14:50:00',4.34),('16100','2014-04-19','14:55:00',4.58),('16100','2014-04-19','15:00:00',7.02),('16100','2014-04-19','15:05:00',7.47),('16100','2014-04-19','15:10:00',6.91),('16100','2014-04-19','15:15:00',6.59),('16100','2014-04-19','15:20:00',6.41),('16100','2014-04-19','15:25:00',6.4),('16100','2014-04-19','15:30:00',6.37),('16100','2014-04-19','15:35:00',6.32),('16100','2014-04-19','15:40:00',6.32),('16100','2014-04-19','15:45:00',5.47),('16100','2014-04-19','15:50:00',5.22),('16100','2014-04-19','15:55:00',5.9),('16100','2014-04-19','16:00:00',5.76),('16100','2014-04-19','16:05:00',5.68),('16100','2014-04-19','16:10:00',5.56),('16100','2014-04-19','16:15:00',5.41),('16100','2014-04-19','16:20:00',5.39),('16100','2014-04-19','16:25:00',5.37),('16100','2014-04-19','16:30:00',5.02),('16100','2014-04-19','16:35:00',5.27),('16100','2014-04-19','16:40:00',5.05),('16100','2014-04-19','16:45:00',3.46),('16100','2014-04-19','16:50:00',4.43),('16100','2014-04-19','16:55:00',4.48),('16100','2014-04-19','17:00:00',4.19),('16100','2014-04-19','17:05:00',3.99),('16100','2014-04-19','17:10:00',3.79),('16100','2014-04-19','17:15:00',3.62),('16100','2014-04-19','17:20:00',3.44),('16100','2014-04-19','17:25:00',3.27),('16100','2014-04-19','17:30:00',3.13),('16100','2014-04-19','17:35:00',2.99),('16100','2014-04-19','17:40:00',2.8),('16100','2014-04-19','17:45:00',2.61),('16100','2014-04-19','17:50:00',2.43),('16100','2014-04-19','17:55:00',2.28),('16100','2014-04-19','18:00:00',2.11),('16100','2014-04-19','18:05:00',1.96),('16100','2014-04-19','18:10:00',1.75),('16100','2014-04-19','18:15:00',1.47),('16100','2014-04-19','18:20:00',1.16),('16100','2014-04-19','18:25:00',1.03),('16100','2014-04-19','18:30:00',1.21),('16100','2014-04-19','18:35:00',1.15),('16100','2013-11-26','08:50:00',2.02),('16100','2013-11-26','08:55:00',1.74),('16100','2013-11-26','09:00:00',1.57),('16100','2013-11-26','09:05:00',1.43),('16100','2013-11-26','09:10:00',1.17),('16100','2013-11-26','09:15:00',1.1),('16100','2013-11-26','09:20:00',1.17),('16100','2013-11-26','09:25:00',1.69),('16100','2013-11-26','09:30:00',1.87),('16100','2013-11-26','09:35:00',1.87),('16100','2013-11-26','09:40:00',1.72),('16100','2013-11-26','09:45:00',1.47),('16100','2013-11-26','09:50:00',1.42),('16100','2013-11-26','09:55:00',1.47),('16100','2013-11-26','10:00:00',1.74),('16100','2013-11-26','10:05:00',2.05),('16100','2013-11-26','10:10:00',1.91),('16100','2013-11-26','10:15:00',2.15),('16100','2013-11-26','10:20:00',2.19),('16100','2013-11-26','10:25:00',2.1),('16100','2013-11-26','10:30:00',2.03),('16100','2013-11-26','10:35:00',2.11),('16100','2013-11-26','10:40:00',2.06),('16100','2013-11-26','10:45:00',2.09),('16100','2013-11-26','10:50:00',2.45),('16100','2013-11-26','10:55:00',2.14),('16100','2013-11-26','11:00:00',2.39),('16100','2013-11-26','11:05:00',2.53),('16100','2013-11-26','11:10:00',2.91),('16100','2013-11-26','11:15:00',2.57),('16100','2013-11-26','11:20:00',2.48),('16100','2013-11-26','11:25:00',2.97),('16100','2013-11-26','11:30:00',3.01),('16100','2013-11-26','11:35:00',2.88),('16100','2013-11-26','11:40:00',3.06),('16100','2013-11-26','11:45:00',3.62),('16100','2013-11-26','11:50:00',5.5),('16100','2013-11-26','11:55:00',6.9),('16100','2013-11-26','12:00:00',5.06),('16100','2013-11-26','12:05:00',3.36),('16100','2013-11-26','12:10:00',3.54),('16100','2013-11-26','12:15:00',2.93),('16100','2013-11-26','12:20:00',4.2),('16100','2013-11-26','12:25:00',4.81),('16100','2013-11-26','12:30:00',5.2),('16100','2013-11-26','12:35:00',3.81),('16100','2013-11-26','12:40:00',2.19),('16100','2013-11-26','12:45:00',1.82),('16100','2013-11-26','12:50:00',1.47),('16100','2013-11-26','12:55:00',1.42),('16100','2013-11-26','13:00:00',1.66),('16100','2013-11-26','13:05:00',1.75),('16100','2013-11-26','13:10:00',1.9),('16100','2013-11-26','13:15:00',1.85),('16100','2013-11-26','13:20:00',1.66),('16100','2013-11-26','13:25:00',1.82),('16100','2013-11-26','13:30:00',1.83),('16100','2013-11-26','13:35:00',1.73),('16100','2013-11-26','13:40:00',1.6),('16100','2013-11-26','13:45:00',1.24),('16100','2013-11-25','08:00:00',1.43),('16100','2013-11-25','08:05:00',1.61),('16100','2013-11-25','08:10:00',1.47),('16100','2013-11-25','08:40:00',1.97),('16100','2013-11-25','08:45:00',1.5),('16100','2013-11-25','08:55:00',1.15),('16100','2013-11-25','09:00:00',1.6),('16100','2013-11-25','09:05:00',2.47),('16100','2013-11-25','09:10:00',1.96),('16100','2013-11-25','09:15:00',1.78),('16100','2013-11-25','09:20:00',1.81),('16100','2013-11-25','09:25:00',2.05),('16100','2013-11-25','09:30:00',2.37),('16100','2013-11-25','09:35:00',3.41),('16100','2013-11-25','09:40:00',2.35),('16100','2013-11-25','09:45:00',2.28),('16100','2013-11-25','09:50:00',2.8),('16100','2013-11-25','09:55:00',4.25),('16100','2013-11-25','10:00:00',2.78),('16100','2013-11-25','10:05:00',2.38),('16100','2013-11-25','10:10:00',6.17),('16100','2013-11-25','10:15:00',3.34),('16100','2013-11-25','10:20:00',4.16),('16100','2013-11-25','10:25:00',3.68),('16100','2013-11-25','10:30:00',6.08),('16100','2013-11-25','10:35:00',5.97),('16100','2013-11-25','10:40:00',6.01),('16100','2013-11-25','10:45:00',6.08),('16100','2013-11-25','10:50:00',6.05),('16100','2013-11-25','10:55:00',6.22),('16100','2013-11-25','11:00:00',6.21),('16100','2013-11-25','11:05:00',6.77),('16100','2013-11-25','11:10:00',6.02),('16100','2013-11-25','11:15:00',6.48),('16100','2013-11-25','11:20:00',6.89),('16100','2013-11-25','11:25:00',3.25),('16100','2013-11-25','11:30:00',4.73),('16100','2013-11-25','11:35:00',2.32),('16100','2013-11-25','11:40:00',2.81),('16100','2013-11-25','11:45:00',7.22),('16100','2013-11-25','11:50:00',3.93),('16100','2013-11-25','11:55:00',4.8),('16100','2013-11-25','12:00:00',5.54),('16100','2013-11-25','12:05:00',4.42),('16100','2013-11-25','12:10:00',4.53),('16100','2013-11-25','12:15:00',5.73),('16100','2013-11-25','12:20:00',6.57),('16100','2013-11-25','12:25:00',6.51),('16100','2013-11-25','12:30:00',6.53),('16100','2013-11-25','12:35:00',6.38),('16100','2013-11-25','12:40:00',6.22),('16100','2013-11-25','12:45:00',6.27),('16100','2013-11-25','12:50:00',6.22),('16100','2013-11-25','12:55:00',6.17),('16100','2013-11-25','13:00:00',6.11),('16100','2013-11-25','13:05:00',6.05),('16100','2013-11-25','13:10:00',5.98),('16100','2013-11-25','13:15:00',5.95),('16100','2013-11-25','13:20:00',5.85),('16100','2013-11-25','13:25:00',5.8),('16100','2013-11-25','13:30:00',5.69),('16100','2013-11-25','13:35:00',5.6),('16100','2013-11-25','13:40:00',5.5),('16100','2013-11-25','13:45:00',5.41),('16100','2013-11-25','13:50:00',4.95),('16100','2013-11-25','13:55:00',3.89),('16100','2013-11-25','14:00:00',5.04),('16100','2013-11-25','14:05:00',5.19),('16100','2013-11-25','14:10:00',4.9),('16100','2013-11-25','14:15:00',5.94),('16100','2013-11-25','14:20:00',5.62),('16100','2013-11-25','14:25:00',4.71),('16100','2013-11-25','14:30:00',4.34),('16100','2013-11-25','14:35:00',3.94),('16100','2013-11-25','14:40:00',3.98),('16100','2013-11-25','14:45:00',3.81),('16100','2013-11-25','14:50:00',3.94),('16100','2013-11-25','14:55:00',3.34),('16100','2013-11-25','15:00:00',3.74),('16100','2013-11-25','15:05:00',3.43),('16100','2013-11-25','15:10:00',3.22),('16100','2013-11-25','15:15:00',2.99),('16100','2013-11-25','15:20:00',2.78),('16100','2013-11-25','15:25:00',2.58),('16100','2013-11-25','15:30:00',2.38),('16100','2013-11-25','15:35:00',2.19),('16100','2013-11-25','15:40:00',1.99),('16100','2013-11-25','15:45:00',1.82),('16100','2013-11-25','15:50:00',1.53),('16100','2013-11-24','07:50:00',1.01),('16100','2013-11-24','07:55:00',1.18),('16100','2013-11-24','08:00:00',1.35),('16100','2013-11-24','08:05:00',1.53),('16100','2013-11-24','08:10:00',1.75),('16100','2013-11-24','08:15:00',1.98),('16100','2013-11-24','08:20:00',2.4),('16100','2013-11-24','08:25:00',2.6),('16100','2013-11-24','08:30:00',2.4),('16100','2013-11-24','08:35:00',2.2),('16100','2013-11-24','08:40:00',2.63),('16100','2013-11-24','08:45:00',3.67),('16100','2013-11-24','08:50:00',3.92),('16100','2013-11-24','08:55:00',3.62),('16100','2013-11-24','09:00:00',1.42),('16100','2013-11-24','09:05:00',1.81),('16100','2013-11-24','09:10:00',2.94),('16100','2013-11-24','09:15:00',3.62),('16100','2013-11-24','09:20:00',1.43),('16100','2013-11-24','09:25:00',1.32),('16100','2013-11-24','09:30:00',2.38),('16100','2013-11-24','09:35:00',2.06),('16100','2013-11-24','09:40:00',1.77),('16100','2013-11-24','09:45:00',1.64),('16100','2013-11-24','09:50:00',4.15),('16100','2013-11-24','09:55:00',2.48),('16100','2013-11-24','10:00:00',2.9),('16100','2013-11-24','10:05:00',2.03),('16100','2013-11-24','10:10:00',5.75),('16100','2013-11-24','10:15:00',5.83),('16100','2013-11-24','10:20:00',5.58),('16100','2013-11-24','10:25:00',5.4),('16100','2013-11-24','10:30:00',3.35),('16100','2013-11-24','10:35:00',4.57),('16100','2013-11-24','10:40:00',5.12),('16100','2013-11-24','10:45:00',6.08),('16100','2013-11-24','10:50:00',5.51),('16100','2013-11-24','10:55:00',5.85),('16100','2013-11-24','11:00:00',6.09),('16100','2013-11-24','11:05:00',6.03),('16100','2013-11-24','11:10:00',2.63),('16100','2013-11-24','11:15:00',2.34),('16100','2013-11-24','11:20:00',2.31),('16100','2013-11-24','11:25:00',2.21),('16100','2013-11-24','11:30:00',1.84),('16100','2013-11-24','11:35:00',1.9),('16100','2013-11-24','11:40:00',1.7),('16100','2013-11-24','11:45:00',6.16),('16100','2013-11-24','11:50:00',5.66),('16100','2013-11-24','11:55:00',4.13),('16100','2013-11-24','12:00:00',3.71),('16100','2013-11-24','12:05:00',3.2),('16100','2013-11-24','12:10:00',3.06),('16100','2013-11-24','12:15:00',2.6),('16100','2013-11-24','12:20:00',3.22),('16100','2013-11-24','12:25:00',3.68),('16100','2013-11-24','12:30:00',3.53),('16100','2013-11-24','12:35:00',3.06),('16100','2013-11-24','12:40:00',2.55),('16100','2013-11-24','12:45:00',4.7),('16100','2013-11-24','12:50:00',6.03),('16100','2013-11-24','12:55:00',6.52),('16100','2013-11-24','13:00:00',5.05),('16100','2013-11-24','13:05:00',2.87),('16100','2013-11-24','13:10:00',2.97),('16100','2013-11-24','13:15:00',3.96),('16100','2013-11-24','13:20:00',6.64),('16100','2013-11-24','13:25:00',4.34),('16100','2013-11-24','13:30:00',3.8),('16100','2013-11-24','13:35:00',1.71),('16100','2013-11-24','13:40:00',1.67),('16100','2013-11-24','13:45:00',2.04),('16100','2013-11-24','13:50:00',2.58),('16100','2013-11-24','13:55:00',1.49),('16100','2013-11-23','09:55:00',1.53),('16100','2013-11-23','10:00:00',2.46),('16100','2013-11-23','10:05:00',2.46),('16100','2013-11-23','10:10:00',2.11),('16100','2013-11-23','10:15:00',2.33),('16100','2013-11-23','10:20:00',2.47),('16100','2013-11-23','10:25:00',3.42),('16100','2013-11-23','10:30:00',4.37),('16100','2013-11-23','10:35:00',4.27),('16100','2013-11-23','10:40:00',2.26),('16100','2013-11-23','10:45:00',1.38),('16100','2013-11-23','10:50:00',1.6),('16100','2013-11-23','10:55:00',2.1),('16100','2013-11-23','11:00:00',2.17),('16100','2013-11-23','11:05:00',2.22),('16100','2013-11-23','11:10:00',2.54),('16100','2013-11-23','11:15:00',2.97),('16100','2013-11-23','11:20:00',2.41),('16100','2013-11-23','11:25:00',2.38),('16100','2013-11-23','11:30:00',2.19),('16100','2013-11-23','11:35:00',2.03),('16100','2013-11-23','11:40:00',1.5),('16100','2013-11-23','11:45:00',1.02),('16100','2013-11-23','11:50:00',1.01),('16100','2013-11-23','11:55:00',1.19),('16100','2013-11-23','12:00:00',1.17),('16100','2013-11-23','12:05:00',1.04),('16100','2013-11-23','12:15:00',1.1),('16100','2013-11-23','12:20:00',1.17),('16100','2013-11-23','12:25:00',1.3),('16100','2013-11-23','12:30:00',1.45),('16100','2013-11-23','12:35:00',1.64),('16100','2013-11-23','12:40:00',1.77),('16100','2013-11-23','12:45:00',2.09),('16100','2013-11-23','12:50:00',2.83),('16100','2013-11-23','12:55:00',3.45),('16100','2013-11-23','13:00:00',2.38),('16100','2013-11-23','13:05:00',1.3),('16100','2013-11-23','13:10:00',1.53),('16100','2013-11-23','13:15:00',1.82),('16100','2013-11-23','13:20:00',1.88),('16100','2013-11-23','13:25:00',1.8),('16100','2013-11-23','13:30:00',1.7),('16100','2013-11-23','13:35:00',1.7),('16100','2013-11-23','13:40:00',1.63),('16100','2013-11-23','13:45:00',1.46),('16100','2013-11-23','13:50:00',1.36),('16100','2013-11-23','13:55:00',1.23),('16100','2013-11-23','14:00:00',1.18),('16100','2013-11-23','14:05:00',1.11),('16100','2013-11-23','14:10:00',1.05),('16100','2013-11-22','08:15:00',1.06),('16100','2013-11-22','08:20:00',1.17),('16100','2013-11-22','08:40:00',1.78),('16100','2013-11-22','08:45:00',1.79),('16100','2013-11-22','10:05:00',1),('16100','2013-11-22','10:15:00',1.7),('16100','2013-11-22','10:20:00',2.13),('16100','2013-11-22','10:25:00',2.42),('16100','2013-11-22','10:30:00',4.41),('16100','2013-11-22','10:35:00',3.95),('16100','2013-11-22','13:35:00',1.14),('16100','2013-11-22','14:00:00',1.34),('16100','2013-11-22','14:05:00',1.11),('16100','2013-11-22','16:05:00',1.18),('16100','2013-11-22','16:10:00',1.24),('16100','2013-11-21','12:15:00',1.09),('16100','2013-11-21','12:20:00',1.29),('16100','2013-11-21','12:25:00',1.19),('16100','2013-11-20','08:00:00',1.14),('16100','2013-11-20','08:05:00',1.81),('16100','2013-11-20','08:10:00',1.88),('16100','2013-11-20','08:15:00',1.23),('16100','2013-11-20','09:05:00',1.04),('16100','2013-11-20','09:10:00',1.18),('16100','2013-11-20','09:15:00',1.39),('16100','2013-11-20','09:20:00',1.7),('16100','2013-11-20','09:25:00',1.39),('16100','2013-11-20','09:35:00',1.07),('16100','2013-11-20','09:40:00',2.02),('16100','2013-11-20','09:45:00',2.43),('16100','2013-11-20','09:50:00',3.99),('16100','2013-11-20','09:55:00',4.84),('16100','2013-11-20','10:00:00',4.82),('16100','2013-11-20','10:05:00',4.93),('16100','2013-11-20','10:10:00',4.88),('16100','2013-11-20','10:15:00',5.07),('16100','2013-11-20','10:20:00',5.42),('16100','2013-11-20','10:25:00',5.72),('16100','2013-11-20','10:30:00',5.88),('16100','2013-11-20','10:35:00',5.48),('16100','2013-11-20','10:40:00',4.18),('16100','2013-11-20','10:45:00',3.83),('16100','2013-11-20','10:50:00',5.96),('16100','2013-11-20','10:55:00',4.94),('16100','2013-11-20','11:00:00',4.32),('16100','2013-11-20','11:05:00',2.76),('16100','2013-11-20','11:10:00',4.76),('16100','2013-11-20','11:15:00',5.94),('16100','2013-11-20','11:20:00',6.05),('16100','2013-11-20','11:25:00',6.23),('16100','2013-11-20','11:30:00',6.2),('16100','2013-11-20','11:35:00',6.13),('16100','2013-11-20','11:40:00',6.13),('16100','2013-11-20','11:45:00',6.18),('16100','2013-11-20','11:50:00',6.17),('16100','2013-11-20','11:55:00',6.17),('16100','2013-11-20','12:00:00',6.18),('16100','2013-11-20','12:05:00',6.59),('16100','2013-11-20','12:10:00',6.55),('16100','2013-11-20','12:15:00',6.97),('16100','2013-11-20','12:20:00',6.26),('16100','2013-11-20','12:25:00',7.28),('16100','2013-11-20','12:30:00',4.41),('16100','2013-11-20','12:35:00',6.8),('16100','2013-11-20','12:40:00',5.42),('16100','2013-11-20','12:45:00',2.15),('16100','2013-11-20','12:55:00',1.66),('16100','2013-11-20','13:00:00',3.42),('16100','2013-11-20','13:05:00',3.89),('16100','2013-11-20','13:10:00',5.79),('16100','2013-11-20','13:15:00',5.63),('16100','2013-11-20','13:20:00',5.81),('16100','2013-11-20','13:25:00',6.02),('16100','2013-11-20','13:30:00',5.81),('16100','2013-11-20','13:35:00',2.6),('16100','2013-11-20','13:40:00',3.51),('16100','2013-11-20','13:45:00',4.76),('16100','2013-11-20','13:50:00',1.33),('16100','2013-11-20','13:55:00',5.59),('16100','2013-11-20','14:00:00',4.84),('16100','2013-11-20','14:05:00',3.8),('16100','2013-11-20','14:10:00',5.08),('16100','2013-11-20','14:15:00',4.55),('16100','2013-11-20','14:20:00',2.96),('16100','2013-11-20','14:25:00',4.2),('16100','2013-11-20','14:30:00',4.04),('16100','2013-11-20','14:35:00',3.88),('16100','2013-11-20','14:40:00',3.77),('16100','2013-11-20','14:45:00',3.69),('16100','2013-11-20','14:50:00',2.34),('16100','2013-11-20','14:55:00',3.35),('16100','2013-11-20','15:00:00',3.17),('16100','2013-11-20','15:05:00',2.98),('16100','2013-11-20','15:10:00',2.03),('16100','2013-11-20','15:35:00',2.01),('16100','2013-11-20','15:40:00',1.1),('16100','2013-11-20','15:50:00',1.28),('16100','2013-11-19','08:00:00',1.07),('16100','2013-11-19','08:05:00',1.17),('16100','2013-11-19','08:10:00',1.29),('16100','2013-11-19','08:15:00',1.82),('16100','2013-11-19','08:50:00',1.6),('16100','2013-11-19','08:55:00',3.54),('16100','2013-11-19','09:00:00',3.36),('16100','2013-11-19','09:05:00',3.36),('16100','2013-11-19','09:10:00',3.55),('16100','2013-11-19','09:15:00',3.82),('16100','2013-11-19','09:20:00',4.14),('16100','2013-11-19','09:25:00',3.94),('16100','2013-11-19','09:30:00',1.37),('16100','2013-11-19','09:55:00',1.8),('16100','2013-11-19','10:20:00',1.11),('16100','2013-11-19','10:45:00',1.63),('16100','2013-11-19','10:50:00',1.14),('16100','2013-11-19','11:20:00',1.51),('16100','2013-11-19','11:25:00',3.05),('16100','2013-11-19','11:30:00',2.3),('16100','2013-11-19','11:35:00',2.35),('16100','2013-11-19','11:55:00',1.78),('16100','2013-11-19','12:00:00',2.2),('16100','2013-11-19','12:15:00',3.06),('16100','2013-11-19','12:20:00',3.56),('16100','2013-11-19','12:25:00',2.98),('16100','2013-11-19','12:30:00',1.14),('16100','2013-11-19','12:35:00',1.27),('16100','2013-11-19','12:40:00',2.29),('16100','2013-11-19','12:45:00',1.95),('16100','2013-11-19','12:50:00',1.39),('16100','2013-11-19','12:55:00',2.28),('16100','2013-11-19','13:00:00',2.69),('16100','2013-11-19','13:05:00',3.85),('16100','2013-11-19','13:10:00',2.48),('16100','2013-11-19','13:15:00',3.41),('16100','2013-11-19','13:20:00',1.74),('16100','2013-11-19','13:25:00',3.68),('16100','2013-11-19','13:30:00',1.79),('16100','2013-11-19','13:35:00',1.87),('16100','2013-11-19','13:40:00',1.49),('16100','2013-11-19','13:45:00',1.62),('16100','2013-11-19','13:50:00',3.45),('16100','2013-11-19','13:55:00',2.05),('16100','2013-11-19','14:00:00',1.15),('16100','2013-11-19','14:05:00',1.03),('16100','2013-11-19','14:15:00',1.56),('16100','2013-11-19','14:20:00',2.71),('16100','2013-11-19','14:25:00',1.87),('16100','2013-11-19','14:30:00',1.05),('16100','2013-11-19','14:35:00',2.25),('16100','2013-11-19','14:40:00',2.98),('16100','2013-11-19','14:50:00',1.64),('16100','2013-11-19','14:55:00',3.28),('16100','2013-11-19','15:00:00',2.99),('16100','2013-11-19','15:05:00',1.99),('16100','2013-11-19','15:10:00',1.32),('16100','2013-11-19','15:15:00',2.39),('16100','2013-11-19','15:20:00',1.29),('16100','2013-11-19','15:35:00',1.41),('16100','2013-11-19','15:40:00',1.43),('16100','2013-11-19','15:45:00',1.22),('16100','2013-11-18','08:10:00',1.18),('16100','2013-11-18','08:15:00',1.06),('16100','2013-11-18','09:35:00',3.86),('16100','2013-11-18','09:40:00',4.12),('16100','2013-11-18','09:45:00',4.25),('16100','2013-11-18','09:50:00',3.77),('16100','2013-11-18','09:55:00',3.45),('16100','2013-11-18','10:00:00',3.71),('16100','2013-11-18','10:05:00',5.13),('16100','2013-11-18','10:10:00',4.93),('16100','2013-11-18','10:15:00',3.78),('16100','2013-11-18','10:20:00',2.33),('16100','2013-11-18','10:55:00',1.03),('16100','2013-11-18','11:00:00',1.09),('16100','2013-11-18','11:05:00',1.32),('16100','2013-11-18','11:10:00',1.33),('16100','2013-11-18','11:15:00',2.65),('16100','2013-11-18','11:20:00',3.58),('16100','2013-11-18','11:25:00',2.83),('16100','2013-11-18','11:30:00',1.69),('16100','2013-11-18','11:35:00',5.03),('16100','2013-11-18','11:40:00',4.94),('16100','2013-11-18','11:45:00',5.43),('16100','2013-11-18','11:50:00',5.67),('16100','2013-11-18','11:55:00',5.52),('16100','2013-11-18','12:00:00',5.09),('16100','2013-11-18','12:05:00',5.58),('16100','2013-11-18','12:10:00',5.53),('16100','2013-11-18','12:15:00',5.58),('16100','2013-11-18','12:20:00',5.58),('16100','2013-11-18','12:25:00',4.2),('16100','2013-11-18','12:30:00',3.02),('16100','2013-11-18','12:35:00',2.38),('16100','2013-11-18','12:40:00',5.36),('16100','2013-11-18','12:45:00',3.37),('16100','2013-11-18','12:50:00',5.39),('16100','2013-11-18','12:55:00',5.65),('16100','2013-11-18','13:10:00',1.04),('16100','2013-11-18','13:15:00',1.11),('16100','2013-11-18','13:30:00',1.47),('16100','2013-11-18','13:35:00',1.33),('16100','2013-11-18','14:35:00',1.17),('16100','2013-11-18','14:40:00',1.26),('16100','2013-11-18','14:45:00',1.07),('16100','2013-11-18','15:20:00',1.37),('16100','2013-11-18','15:25:00',2.74),('16100','2013-11-18','15:30:00',3.24),('16100','2013-11-18','15:35:00',2.49),('16100','2013-11-18','15:40:00',1.92),('16100','2013-11-18','15:45:00',1.7),('16100','2013-11-18','15:50:00',1.44),('16100','2013-11-18','15:55:00',1.14),('16100','2013-11-17','07:55:00',1.12),('16100','2013-11-17','08:00:00',1.54),('16100','2013-11-17','08:05:00',1.78),('16100','2013-11-17','08:10:00',1.35),('16100','2013-11-17','08:15:00',1.41),('16100','2013-11-17','08:20:00',1.55),('16100','2013-11-17','08:25:00',1.59),('16100','2013-11-17','08:30:00',1.5),('16100','2013-11-17','08:35:00',1.73),('16100','2013-11-17','08:40:00',1.92),('16100','2013-11-17','08:45:00',1.67),('16100','2013-11-17','08:50:00',1.8),('16100','2013-11-17','08:55:00',1.88),('16100','2013-11-17','09:00:00',1.69),('16100','2013-11-17','09:05:00',1.48),('16100','2013-11-17','09:10:00',1.4),('16100','2013-11-17','09:15:00',1.96),('16100','2013-11-17','09:20:00',2.69),('16100','2013-11-17','09:25:00',2.82),('16100','2013-11-17','09:30:00',3.46),('16100','2013-11-17','09:35:00',4.03),('16100','2013-11-17','09:40:00',2.65),('16100','2013-11-17','09:45:00',1.83),('16100','2013-11-17','09:50:00',1.63),('16100','2013-11-17','09:55:00',1.7),('16100','2013-11-17','10:00:00',1.93),('16100','2013-11-17','10:05:00',2.69),('16100','2013-11-17','10:10:00',2.91),('16100','2013-11-17','10:15:00',3.17),('16100','2013-11-17','10:20:00',2.54),('16100','2013-11-17','10:25:00',2.06),('16100','2013-11-17','10:30:00',1.88),('16100','2013-11-17','10:35:00',2),('16100','2013-11-17','10:40:00',2.25),('16100','2013-11-17','10:45:00',2.42),('16100','2013-11-17','10:50:00',2.18),('16100','2013-11-17','10:55:00',1.7),('16100','2013-11-17','11:00:00',1.47),('16100','2013-11-17','11:05:00',1.33),('16100','2013-11-17','11:10:00',1.19),('16100','2013-11-17','11:15:00',1.16),('16100','2013-11-17','11:20:00',1.33),('16100','2013-11-17','11:25:00',1.68),('16100','2013-11-17','11:30:00',1.85),('16100','2013-11-17','11:35:00',1.98),('16100','2013-11-17','11:40:00',2),('16100','2013-11-17','11:45:00',2.01),('16100','2013-11-17','11:50:00',2.16),('16100','2013-11-17','11:55:00',2.4),('16100','2013-11-17','12:00:00',2.56),('16100','2013-11-17','12:05:00',2.49),('16100','2013-11-17','12:10:00',2.44),('16100','2013-11-17','12:15:00',2.58),('16100','2013-11-17','12:20:00',2.91),('16100','2013-11-17','12:25:00',3.4),('16100','2013-11-17','12:30:00',3.16),('16100','2013-11-17','12:35:00',2.67),('16100','2013-11-17','12:40:00',2.12),('16100','2013-11-17','12:45:00',1.73),('16100','2013-11-17','12:50:00',1.53),('16100','2013-11-17','12:55:00',1.42),('16100','2013-11-17','13:00:00',1.38),('16100','2013-11-17','13:05:00',1.42),('16100','2013-11-17','13:10:00',1.87),('16100','2013-11-17','13:15:00',1.56),('16100','2013-11-17','13:20:00',1.52),('16100','2013-11-17','13:25:00',1.28),('16100','2013-11-17','13:30:00',1.37),('16100','2013-11-17','13:35:00',1.59),('16100','2013-11-17','13:40:00',1.73),('16100','2013-11-17','13:45:00',1.99),('16100','2013-11-17','13:50:00',1.75),('16100','2013-11-17','13:55:00',1.4),('16100','2013-11-17','14:00:00',1.21),('16100','2014-04-18','07:40:00',1.06),('16100','2014-04-18','07:45:00',1.05),('16100','2014-04-18','07:50:00',1.76),('16100','2014-04-18','07:55:00',1.62),('16100','2014-04-18','08:00:00',1.13),('16100','2014-04-18','08:05:00',1.22),('16100','2014-04-18','08:10:00',1.55),('16100','2014-04-18','08:15:00',2.02),('16100','2014-04-18','08:20:00',2.19),('16100','2014-04-18','08:25:00',2.11),('16100','2014-04-18','08:30:00',1.98),('16100','2014-04-18','08:35:00',2.26),('16100','2014-04-18','08:40:00',1.84),('16100','2014-04-18','08:45:00',1.64),('16100','2014-04-18','08:50:00',1.19),('16100','2014-04-18','09:10:00',1.1),('16100','2014-04-18','09:15:00',1.55),('16100','2014-04-18','09:20:00',2.03),('16100','2014-04-18','09:25:00',2.65),('16100','2014-04-18','09:30:00',2.16),('16100','2014-04-18','09:35:00',1.35),('16100','2014-04-18','09:40:00',1.09),('16100','2014-04-18','10:25:00',1.24),('16100','2014-04-18','10:30:00',1.62),('16100','2014-04-18','10:35:00',2.2),('16100','2014-04-18','10:40:00',2.46),('16100','2014-04-18','10:45:00',2.38),('16100','2014-04-18','10:50:00',3.06),('16100','2014-04-18','10:55:00',2.85),('16100','2014-04-18','11:00:00',1.79),('16100','2014-04-18','11:05:00',2.28),('16100','2014-04-18','11:10:00',3.22),('16100','2014-04-18','11:15:00',4.44),('16100','2014-04-18','11:20:00',5.37),('16100','2014-04-18','11:25:00',7.49),('16100','2014-04-18','11:30:00',6.37),('16100','2014-04-18','11:35:00',4.56),('16100','2014-04-18','11:40:00',3.62),('16100','2014-04-18','11:45:00',2.75),('16100','2014-04-18','11:50:00',1.65),('16100','2014-04-18','11:55:00',1.32),('16100','2014-04-18','13:10:00',1.45),('16100','2014-04-18','13:15:00',1.85),('16100','2014-04-18','14:25:00',1.08),('16100','2014-04-18','14:30:00',1.54),('16100','2014-04-18','14:35:00',2.15),('16100','2014-04-18','14:40:00',2.81),('16100','2014-04-18','14:45:00',2.08),('16100','2014-04-18','14:55:00',1.07),('16100','2014-04-18','15:00:00',2.3),('16100','2014-04-18','15:05:00',2.07),('16100','2014-04-18','15:25:00',1.61),('16100','2014-04-18','15:30:00',1.16),('16100','2014-04-18','15:40:00',2.87),('16100','2014-04-18','15:45:00',5.05),('16100','2014-04-18','15:50:00',4.27),('16100','2014-04-18','15:55:00',3.68),('16100','2014-04-18','16:00:00',2.79),('16100','2014-04-18','16:05:00',2.55),('16100','2014-04-18','16:10:00',2.7),('16100','2014-04-18','16:15:00',3.13),('16100','2014-04-18','16:20:00',2.63),('16100','2014-04-18','16:25:00',3.05),('16100','2014-04-18','16:30:00',2.84),('16100','2014-04-18','16:35:00',1.96),('16100','2014-04-18','16:40:00',2.46),('16100','2014-04-18','16:45:00',1.8),('16100','2014-04-18','16:50:00',1.11),('16100','2014-04-18','16:55:00',1.07),('16100','2014-04-18','17:00:00',1.77),('16100','2014-04-18','17:05:00',2.13),('16100','2014-04-18','17:10:00',1.63),('16100','2014-04-18','17:15:00',2.25),('16100','2014-04-18','17:20:00',2.3),('16100','2014-04-18','17:25:00',1.58),('16100','2014-04-18','17:30:00',1.28),('16100','2014-04-18','17:35:00',1.18),('16100','2014-04-18','17:40:00',1.08),('16100','2013-11-16','08:40:00',1.19),('16100','2013-11-16','08:45:00',1.19),('16100','2013-11-16','08:50:00',1.11),('16100','2013-11-16','08:55:00',3.44),('16100','2013-11-16','09:00:00',4.06),('16100','2013-11-16','09:05:00',3.87),('16100','2013-11-16','09:10:00',3.86),('16100','2013-11-16','09:15:00',3.82),('16100','2013-11-16','09:20:00',4.01),('16100','2013-11-16','09:25:00',3.84),('16100','2013-11-16','09:30:00',3.62),('16100','2013-11-16','09:35:00',4.27),('16100','2013-11-16','09:40:00',4.46),('16100','2013-11-16','09:45:00',4.53),('16100','2013-11-16','09:50:00',4.56),('16100','2013-11-16','09:55:00',4.65),('16100','2013-11-16','10:00:00',4.77),('16100','2013-11-16','10:05:00',4.85),('16100','2013-11-16','10:10:00',4.92),('16100','2013-11-16','10:15:00',4.99),('16100','2013-11-16','10:20:00',5.06),('16100','2013-11-16','10:25:00',5.14),('16100','2013-11-16','10:30:00',5.2),('16100','2013-11-16','10:35:00',5.25),('16100','2013-11-16','10:40:00',5.3),('16100','2013-11-16','10:45:00',5.4),('16100','2013-11-16','10:50:00',5.5),('16100','2013-11-16','10:55:00',5.53),('16100','2013-11-16','11:00:00',5.55),('16100','2013-11-16','11:05:00',5.62),('16100','2013-11-16','11:10:00',5.66),('16100','2013-11-16','11:15:00',5.68),('16100','2013-11-16','11:20:00',5.7),('16100','2013-11-16','11:25:00',5.72),('16100','2013-11-16','11:30:00',5.74),('16100','2013-11-16','11:35:00',5.74),('16100','2013-11-16','11:40:00',5.73),('16100','2013-11-16','11:45:00',5.73),('16100','2013-11-16','11:50:00',5.75),('16100','2013-11-16','11:55:00',5.79),('16100','2013-11-16','12:00:00',5.74),('16100','2013-11-16','12:05:00',5.75),('16100','2013-11-16','12:10:00',5.77),('16100','2013-11-16','12:15:00',5.63),('16100','2013-11-16','12:20:00',5.66),('16100','2013-11-16','12:25:00',5.58),('16100','2013-11-16','12:30:00',5.56),('16100','2013-11-16','12:35:00',5.55),('16100','2013-11-16','12:40:00',5.56),('16100','2013-11-16','12:45:00',5.51),('16100','2013-11-16','12:50:00',5.47),('16100','2013-11-16','12:55:00',5.44),('16100','2013-11-16','13:00:00',5.39),('16100','2013-11-16','13:05:00',5.34),('16100','2013-11-16','13:10:00',5.29),('16100','2013-11-16','13:15:00',5.24),('16100','2013-11-16','13:20:00',5.16),('16100','2013-11-16','13:25:00',5.13),('16100','2013-11-16','13:30:00',4.35),('16100','2013-11-16','13:35:00',2.75),('16100','2013-11-16','13:40:00',4.96),('16100','2013-11-16','13:45:00',4.67),('16100','2013-11-16','13:50:00',4.57),('16100','2013-11-16','13:55:00',3.92),('16100','2013-11-16','14:15:00',2.78),('16100','2013-11-16','14:20:00',4.06),('16100','2013-11-16','14:25:00',3.9),('16100','2013-11-16','14:30:00',3.77),('16100','2013-11-16','14:35:00',3.19),('16100','2013-11-16','14:55:00',2.11),('16100','2013-11-16','15:00:00',2.31),('16100','2013-11-16','15:05:00',2.01),('16100','2013-11-16','15:10:00',2.44),('16100','2013-11-16','15:15:00',2.32),('16100','2013-11-16','15:20:00',2.64),('16100','2013-11-16','15:25:00',2.43),('16100','2013-11-16','15:30:00',2.18),('16100','2013-11-16','15:35:00',1.94),('16100','2013-11-16','15:40:00',1.73),('16100','2013-11-16','15:45:00',1.55),('16100','2013-11-16','15:50:00',1.35),('16100','2013-11-16','15:55:00',1.21),('16100','2013-11-15','12:50:00',1.3),('16100','2013-11-15','12:55:00',1.88),('16100','2013-11-15','13:00:00',1.94),('16100','2013-11-15','13:05:00',1.9),('16100','2013-11-15','13:10:00',1.62),('16100','2013-11-15','13:15:00',1.45),('16100','2013-11-15','13:20:00',1.18),('16100','2013-11-14','09:05:00',1.01),('16100','2013-11-14','09:10:00',1.88),('16100','2013-11-14','09:15:00',2.7),('16100','2013-11-14','09:20:00',2.15),('16100','2013-11-14','09:25:00',1.75),('16100','2013-11-14','09:30:00',1.33),('16100','2013-11-14','09:35:00',1.16),('16100','2013-11-14','09:40:00',1.01),('16100','2013-11-14','09:45:00',1.83),('16100','2013-11-14','09:50:00',2.21),('16100','2013-11-14','09:55:00',1.87),('16100','2013-11-14','10:00:00',1.83),('16100','2013-11-14','10:05:00',1.73),('16100','2013-11-14','10:10:00',1.81),('16100','2013-11-14','10:15:00',1.99),('16100','2013-11-14','10:20:00',1.96),('16100','2013-11-14','10:25:00',2.33),('16100','2013-11-14','10:30:00',2.18),('16100','2013-11-14','10:35:00',2.65),('16100','2013-11-14','10:40:00',1.66),('16100','2013-11-14','10:45:00',1.42),('16100','2013-11-14','10:50:00',1.52),('16100','2013-11-14','10:55:00',1.5),('16100','2013-11-14','11:00:00',1.82),('16100','2013-11-14','11:05:00',2.08),('16100','2013-11-14','11:10:00',2.24),('16100','2013-11-14','11:15:00',2.52),('16100','2013-11-14','11:20:00',2.1),('16100','2013-11-14','11:25:00',1.92),('16100','2013-11-14','11:30:00',2.45),('16100','2013-11-14','11:35:00',4.64),('16100','2013-11-14','11:40:00',2.74),('16100','2013-11-14','11:45:00',2.71),('16100','2013-11-14','11:50:00',2.48),('16100','2013-11-14','11:55:00',2.15),('16100','2013-11-14','12:00:00',1.98),('16100','2013-11-14','12:05:00',1.68),('16100','2013-11-14','12:10:00',1.4),('16100','2013-11-14','12:15:00',1.43),('16100','2013-11-14','12:20:00',1.44),('16100','2013-11-14','12:25:00',1.64),('16100','2013-11-14','12:30:00',2.06),('16100','2013-11-14','12:35:00',1.72),('16100','2013-11-14','12:40:00',1.64),('16100','2013-11-14','12:45:00',1.64),('16100','2013-11-14','12:50:00',1.68),('16100','2013-11-14','12:55:00',1.77),('16100','2013-11-14','13:00:00',1.94),('16100','2013-11-14','13:05:00',1.93),('16100','2013-11-14','13:10:00',1.9),('16100','2013-11-14','13:15:00',1.67),('16100','2013-11-14','13:20:00',1.59),('16100','2013-11-14','13:25:00',1.44),('16100','2013-11-14','13:30:00',1.39),('16100','2013-11-14','13:35:00',1.39),('16100','2013-11-14','13:40:00',1.41),('16100','2013-11-14','13:45:00',1.46),('16100','2013-11-14','13:50:00',1.47),('16100','2013-11-14','13:55:00',1.51),('16100','2013-11-14','14:00:00',1.49),('16100','2013-11-14','14:05:00',1.53),('16100','2013-11-14','14:10:00',1.31),('16100','2013-11-14','14:15:00',1.1),('16100','2013-11-13','08:15:00',1.37),('16100','2013-11-13','08:50:00',2.29),('16100','2013-11-13','08:55:00',2.15),('16100','2013-11-13','09:05:00',1.4),('16100','2013-11-13','09:15:00',1.94),('16100','2013-11-13','09:20:00',3.48),('16100','2013-11-13','09:25:00',3.68),('16100','2013-11-13','09:30:00',4.08),('16100','2013-11-13','09:35:00',4.2),('16100','2013-11-13','09:40:00',4.29),('16100','2013-11-13','09:45:00',4.42),('16100','2013-11-13','09:50:00',4.52),('16100','2013-11-13','09:55:00',4.53),('16100','2013-11-13','10:00:00',4.66),('16100','2013-11-13','10:05:00',4.67),('16100','2013-11-13','10:10:00',4.77),('16100','2013-11-13','10:15:00',4.86),('16100','2013-11-13','10:20:00',4.98),('16100','2013-11-13','10:25:00',4.56),('16100','2013-11-13','10:30:00',4.56),('16100','2013-11-13','10:35:00',5.02),('16100','2013-11-13','10:40:00',5.3),('16100','2013-11-13','10:45:00',5.48),('16100','2013-11-13','10:50:00',5.53),('16100','2013-11-13','10:55:00',5.55),('16100','2013-11-13','11:00:00',5.62),('16100','2013-11-13','11:05:00',5.66),('16100','2013-11-13','11:10:00',5.98),('16100','2013-11-13','11:15:00',5.55),('16100','2013-11-13','11:20:00',5.98),('16100','2013-11-13','11:25:00',6.07),('16100','2013-11-13','11:30:00',5.22),('16100','2013-11-13','11:35:00',5.07),('16100','2013-11-13','11:40:00',5.24),('16100','2013-11-13','11:45:00',5.5),('16100','2013-11-13','11:50:00',5.31),('16100','2013-11-13','11:55:00',3.65),('16100','2013-11-13','12:00:00',2.14),('16100','2013-11-13','12:05:00',1.97),('16100','2013-11-13','12:10:00',1.93),('16100','2013-11-13','12:15:00',1.95),('16100','2013-11-13','12:20:00',2),('16100','2013-11-13','12:25:00',2.27),('16100','2013-11-13','12:30:00',2.55),('16100','2013-11-13','12:35:00',2.92),('16100','2013-11-13','12:40:00',3.37),('16100','2013-11-13','12:45:00',2.6),('16100','2013-11-13','12:50:00',2.33),('16100','2013-11-13','12:55:00',2.34),('16100','2013-11-13','13:00:00',2.05),('16100','2013-11-13','13:05:00',2),('16100','2013-11-13','13:10:00',2.59),('16100','2013-11-13','13:15:00',2.09),('16100','2013-11-13','13:20:00',2.08),('16100','2013-11-13','13:25:00',2.72),('16100','2013-11-13','13:30:00',5.55),('16100','2013-11-13','13:35:00',5.73),('16100','2013-11-13','13:40:00',3.88),('16100','2013-11-13','13:45:00',5.37),('16100','2013-11-13','13:50:00',5.4),('16100','2013-11-13','13:55:00',3.29),('16100','2013-11-13','14:00:00',5.3),('16100','2013-11-13','14:05:00',2.65),('16100','2013-11-13','14:10:00',2.23),('16100','2013-11-13','14:15:00',1.68),('16100','2013-11-13','14:20:00',1.45),('16100','2013-11-13','14:25:00',1.36),('16100','2013-11-13','14:30:00',1.26),('16100','2013-11-13','14:35:00',1.27),('16100','2013-11-13','14:40:00',1.21),('16100','2013-11-13','14:45:00',1.23),('16100','2013-11-13','14:50:00',1.21),('16100','2013-11-13','14:55:00',1.02),('16100','2013-11-12','10:00:00',1.01),('16100','2013-11-12','10:05:00',2.39),('16100','2013-11-12','10:10:00',2.44),('16100','2013-11-12','10:15:00',1.73),('16100','2013-11-12','10:20:00',1.91),('16100','2013-11-12','10:25:00',3.11),('16100','2013-11-12','10:30:00',1.81),('16100','2013-11-12','10:35:00',2.09),('16100','2013-11-12','10:40:00',2.18),('16100','2013-11-12','10:45:00',1.94),('16100','2013-11-12','10:50:00',1.82),('16100','2013-11-12','10:55:00',1.5),('16100','2013-11-12','11:00:00',1.36),('16100','2013-11-12','11:05:00',1.56),('16100','2013-11-12','11:10:00',1.92),('16100','2013-11-12','11:15:00',2.18),('16100','2013-11-12','11:20:00',3.16),('16100','2013-11-12','11:25:00',3.32),('16100','2013-11-12','11:30:00',1.89),('16100','2013-11-12','11:35:00',1.53),('16100','2013-11-12','11:40:00',1.39),('16100','2013-11-12','11:45:00',1.49),('16100','2013-11-12','11:50:00',1.7),('16100','2013-11-12','11:55:00',1.99),('16100','2013-11-12','12:00:00',2.77),('16100','2013-11-12','12:05:00',2.09),('16100','2013-11-12','12:10:00',1.98),('16100','2013-11-12','12:15:00',1.65),('16100','2013-11-12','12:20:00',1.8),('16100','2013-11-12','12:25:00',1.52),('16100','2013-11-12','12:30:00',1.19),('16100','2013-11-12','12:45:00',1.41),('16100','2013-11-12','12:50:00',1.56),('16100','2013-11-12','12:55:00',1.68),('16100','2013-11-12','13:00:00',1.73),('16100','2013-11-12','13:05:00',1.88),('16100','2013-11-12','13:10:00',1.95),('16100','2013-11-12','13:15:00',1.98),('16100','2013-11-12','13:20:00',2.1),('16100','2013-11-12','13:25:00',1.73),('16100','2013-11-12','13:30:00',1.49),('16100','2013-11-12','13:35:00',1.38),('16100','2013-11-12','13:40:00',1.56),('16100','2013-11-12','13:45:00',2.45),('16100','2013-11-12','13:50:00',1.74),('16100','2013-11-12','13:55:00',2.46),('16100','2013-11-12','14:00:00',3.25),('16100','2013-11-12','14:05:00',3.7),('16100','2013-11-12','14:10:00',4),('16100','2013-11-12','14:15:00',3.41),('16100','2013-11-12','14:20:00',3.09),('16100','2013-11-12','14:25:00',2.94),('16100','2013-11-12','14:30:00',3.42),('16100','2013-11-12','14:35:00',2.69),('16100','2013-11-12','14:40:00',1.85),('16100','2013-11-12','14:45:00',1.2),('16100','2013-11-12','15:30:00',1),('16100','2013-11-11','11:00:00',1.07),('16100','2013-11-11','11:05:00',1.06),('16100','2013-11-11','11:10:00',1.16),('16100','2013-11-11','11:15:00',1.17),('16100','2013-11-11','11:20:00',1.18),('16100','2013-11-11','11:25:00',1.38),('16100','2013-11-11','11:30:00',1.41),('16100','2013-11-11','11:35:00',1.47),('16100','2013-11-11','11:40:00',5.27),('16100','2013-11-11','11:45:00',2.03),('16100','2013-11-11','11:50:00',1.37),('16100','2013-11-11','11:55:00',1.42),('16100','2013-11-11','12:00:00',4.58),('16100','2013-11-11','12:05:00',4.02),('16100','2013-11-11','12:10:00',1.79),('16100','2013-11-11','12:15:00',1.18),('16100','2013-11-11','12:20:00',1.34),('16100','2013-11-11','12:25:00',1.2),('16100','2013-11-11','12:30:00',2.01),('16100','2013-11-11','12:35:00',8.05),('16100','2013-11-11','12:40:00',5.7),('16100','2013-11-11','12:45:00',4.96),('16100','2013-11-11','12:50:00',3.89),('16100','2013-11-11','12:55:00',2.94),('16100','2013-11-11','13:00:00',3.21),('16100','2013-11-11','13:05:00',2.88),('16100','2013-11-11','13:10:00',2.57),('16100','2013-11-11','13:15:00',3.68),('16100','2013-11-11','13:20:00',3.31),('16100','2013-11-11','13:25:00',2.84),('16100','2013-11-11','13:30:00',2.9),('16100','2013-11-11','13:35:00',3.13),('16100','2013-11-11','13:40:00',3.19),('16100','2013-11-11','13:45:00',4.32),('16100','2013-11-11','13:50:00',6.14),('16100','2013-11-11','13:55:00',3.52),('16100','2013-11-11','14:00:00',3.82),('16100','2013-11-11','14:05:00',2.34),('16100','2013-11-11','14:10:00',3.97),('16100','2013-11-11','14:15:00',4.7),('16100','2013-11-11','14:20:00',4.27),('16100','2013-11-11','14:25:00',3.51),('16100','2013-11-11','14:30:00',1.85),('16100','2013-11-11','14:35:00',4.73),('16100','2013-11-11','14:40:00',2.51),('16100','2013-11-11','14:45:00',2.28),('16100','2013-11-11','14:50:00',2.83),('16100','2013-11-11','14:55:00',3.03),('16100','2013-11-11','15:00:00',2.95),('16100','2013-11-11','15:05:00',2.53),('16100','2013-11-11','15:10:00',1.55),('16100','2013-11-11','15:15:00',1.4),('16100','2013-11-11','15:20:00',1.63),('16100','2013-11-11','15:25:00',1.56),('16100','2013-11-11','15:30:00',1.67),('16100','2013-11-10','09:55:00',1.01),('16100','2013-11-10','10:30:00',1.7),('16100','2013-11-10','10:35:00',2.01),('16100','2013-11-10','10:40:00',1.74),('16100','2013-11-10','10:45:00',1.49),('16100','2013-11-10','10:50:00',1.26),('16100','2013-11-10','10:55:00',1.51),('16100','2013-11-10','11:00:00',1.74),('16100','2013-11-10','11:05:00',1.11),('16100','2013-11-10','11:10:00',1.74),('16100','2013-11-10','11:15:00',3.39),('16100','2013-11-10','11:20:00',5.49),('16100','2013-11-10','11:25:00',7.86),('16100','2013-11-10','11:30:00',3.41),('16100','2013-11-10','11:35:00',1.88),('16100','2013-11-10','11:40:00',2.86),('16100','2013-11-10','11:45:00',3.4),('16100','2013-11-10','11:50:00',3.51),('16100','2013-11-10','11:55:00',2.65),('16100','2013-11-10','12:00:00',4.7),('16100','2013-11-10','12:05:00',5.5),('16100','2013-11-10','12:10:00',4.62),('16100','2013-11-10','12:15:00',7.04),('16100','2013-11-10','12:20:00',7.28),('16100','2013-11-10','12:25:00',5.45),('16100','2013-11-10','12:30:00',6.79),('16100','2013-11-10','12:35:00',6.82),('16100','2013-11-10','12:40:00',4.28),('16100','2013-11-10','12:45:00',2.96),('16100','2013-11-10','12:50:00',4.28),('16100','2013-11-10','12:55:00',4.13),('16100','2013-11-10','13:00:00',5.9),('16100','2013-11-10','13:05:00',5.27),('16100','2013-11-10','13:10:00',5.01),('16100','2013-11-10','13:15:00',5.17),('16100','2013-11-10','13:20:00',6.01),('16100','2013-11-10','13:25:00',3.95),('16100','2013-11-10','13:40:00',1.57),('16100','2013-11-10','13:45:00',2.3),('16100','2013-11-10','13:50:00',4.95),('16100','2013-11-10','13:55:00',1.84),('16100','2013-11-10','14:00:00',1.09),('16100','2013-11-10','14:05:00',2.05),('16100','2013-11-10','14:10:00',5.4),('16100','2013-11-10','14:15:00',5.27),('16100','2013-11-10','14:20:00',4.94),('16100','2013-11-10','14:25:00',4.83),('16100','2013-11-10','14:30:00',4.51),('16100','2013-11-10','14:35:00',4.2),('16100','2013-11-10','14:40:00',4.15),('16100','2013-11-10','14:45:00',3.78),('16100','2013-11-10','14:50:00',2.82),('16100','2013-11-10','14:55:00',2.31),('16100','2013-11-10','15:00:00',2),('16100','2013-11-10','15:05:00',1.67),('16100','2013-11-09','07:35:00',1.06),('16100','2013-11-09','07:40:00',1.05),('16100','2013-11-09','07:45:00',1.69),('16100','2013-11-09','07:50:00',1.89),('16100','2013-11-09','07:55:00',1.45),('16100','2013-11-09','08:00:00',1.76),('16100','2013-11-09','08:05:00',1.16),('16100','2013-11-09','08:10:00',1.33),('16100','2013-11-09','08:15:00',1.6),('16100','2013-11-09','08:20:00',2),('16100','2013-11-09','08:25:00',2.45),('16100','2013-11-09','08:30:00',1.72),('16100','2013-11-09','08:35:00',2.6),('16100','2013-11-09','08:40:00',3.25),('16100','2013-11-09','08:45:00',3.11),('16100','2013-11-09','08:50:00',3),('16100','2013-11-09','08:55:00',3.26),('16100','2013-11-09','09:00:00',3.08),('16100','2013-11-09','09:05:00',2.38),('16100','2013-11-09','09:10:00',2.66),('16100','2013-11-09','09:15:00',3.46),('16100','2013-11-09','09:20:00',3.67),('16100','2013-11-09','09:25:00',4.08),('16100','2013-11-09','09:30:00',3.07),('16100','2013-11-09','09:35:00',3.69),('16100','2013-11-09','09:40:00',4.31),('16100','2013-11-09','09:45:00',3.66),('16100','2013-11-09','09:50:00',4.12),('16100','2013-11-09','09:55:00',4.18),('16100','2013-11-09','10:00:00',4.68),('16100','2013-11-09','10:05:00',3.25),('16100','2013-11-09','10:10:00',3.15),('16100','2013-11-09','10:15:00',2.63),('16100','2013-11-09','10:20:00',2.87),('16100','2013-11-09','10:25:00',3.77),('16100','2013-11-09','10:30:00',4.33),('16100','2013-11-09','10:35:00',2.37),('16100','2013-11-09','10:40:00',5.62),('16100','2013-11-09','10:45:00',6.69),('16100','2013-11-09','10:50:00',7.04),('16100','2013-11-09','10:55:00',4.43),('16100','2013-11-09','11:00:00',1.5),('16100','2013-11-09','11:10:00',1.14),('16100','2013-11-09','11:15:00',2.11),('16100','2013-11-09','11:20:00',2.69),('16100','2013-11-09','11:25:00',3.31),('16100','2013-11-09','11:30:00',2.68),('16100','2013-11-09','11:35:00',4.77),('16100','2013-11-09','11:40:00',3.08),('16100','2013-11-09','11:45:00',1.81),('16100','2013-11-09','11:50:00',2.04),('16100','2013-11-09','11:55:00',3.73),('16100','2013-11-09','12:00:00',7.53),('16100','2013-11-09','12:05:00',7.09),('16100','2013-11-09','12:10:00',6.41),('16100','2013-11-09','12:15:00',4.63),('16100','2013-11-09','12:20:00',1.67),('16100','2013-11-09','12:25:00',1.99),('16100','2013-11-09','12:30:00',2.75),('16100','2013-11-09','12:35:00',4.56),('16100','2013-11-09','12:40:00',5.37),('16100','2013-11-09','12:45:00',2),('16100','2013-11-09','12:50:00',1.72),('16100','2013-11-09','12:55:00',2.27),('16100','2013-11-09','13:00:00',3.46),('16100','2013-11-09','13:05:00',2.63),('16100','2013-11-09','13:10:00',2.6),('16100','2013-11-09','13:15:00',1.19),('16100','2013-11-09','13:25:00',1.91),('16100','2013-11-09','13:30:00',4.58),('16100','2013-11-09','13:35:00',4.66),('16100','2013-11-09','13:40:00',3.77),('16100','2013-11-09','13:45:00',1.32),('16100','2013-11-09','14:25:00',1.3),('16100','2013-11-08','09:10:00',1.21),('16100','2013-11-08','09:30:00',3.16),('16100','2013-11-08','09:35:00',1.43),('16100','2013-11-08','09:40:00',3.15),('16100','2013-11-08','09:45:00',3.79),('16100','2013-11-08','09:50:00',5.54),('16100','2013-11-08','09:55:00',5.74),('16100','2013-11-08','10:00:00',4.11),('16100','2013-11-08','10:05:00',2.38),('16100','2013-11-08','10:10:00',2.51),('16100','2013-11-08','10:15:00',2.95),('16100','2013-11-08','10:20:00',5.33),('16100','2013-11-08','10:25:00',2.28),('16100','2013-11-08','10:30:00',1.49),('16100','2013-11-08','10:35:00',3.92),('16100','2013-11-08','10:40:00',6.05),('16100','2013-11-08','10:45:00',4.38),('16100','2013-11-08','10:50:00',3.16),('16100','2013-11-08','10:55:00',4.79),('16100','2013-11-08','11:00:00',7.51),('16100','2013-11-08','11:05:00',5.06),('16100','2013-11-08','11:10:00',4.91),('16100','2013-11-08','11:15:00',2.22),('16100','2013-11-08','11:20:00',1.82),('16100','2013-11-08','11:25:00',1.26),('16100','2013-11-08','11:30:00',2.83),('16100','2013-11-08','11:35:00',6.93),('16100','2013-11-08','11:40:00',4.43),('16100','2013-11-08','11:45:00',7.22),('16100','2013-11-08','11:50:00',6.87),('16100','2013-11-08','11:55:00',7.03),('16100','2013-11-08','12:00:00',7.74),('16100','2013-11-08','12:05:00',7),('16100','2013-11-08','12:10:00',1.74),('16100','2013-11-08','12:15:00',1.41),('16100','2013-11-08','12:20:00',1.3),('16100','2013-11-08','12:25:00',1.63),('16100','2013-11-08','12:30:00',2.22),('16100','2013-11-08','12:35:00',2.21),('16100','2013-11-08','12:40:00',3.06),('16100','2013-11-08','12:45:00',4.45),('16100','2013-11-08','12:50:00',7.03),('16100','2013-11-08','12:55:00',6.64),('16100','2013-11-08','13:00:00',5.56),('16100','2013-11-08','13:05:00',6.32),('16100','2013-11-08','13:10:00',2.51),('16100','2013-11-08','13:15:00',2.43),('16100','2013-11-08','13:20:00',3.99),('16100','2013-11-08','13:25:00',4.79),('16100','2013-11-08','13:30:00',2.85),('16100','2013-11-08','13:35:00',2.15),('16100','2013-11-08','13:40:00',3.38),('16100','2013-11-08','13:45:00',4.69),('16100','2013-11-08','13:50:00',5.46),('16100','2013-11-08','13:55:00',5.35),('16100','2013-11-08','14:00:00',2.67),('16100','2013-11-08','14:05:00',1.38),('16100','2013-11-08','14:10:00',1.42),('16100','2013-11-08','14:15:00',2.46),('16100','2013-11-08','14:20:00',2.73),('16100','2013-11-08','14:25:00',1.74),('16100','2013-11-08','14:30:00',2.71),('16100','2013-11-08','14:35:00',3.77),('16100','2013-11-08','14:40:00',3.08),('16100','2013-11-08','14:45:00',2.65),('16100','2013-11-08','14:50:00',1.84),('16100','2013-11-08','15:10:00',1.23),('16100','2013-11-08','15:15:00',2.16),('16100','2013-11-08','15:20:00',2.14),('16100','2013-11-08','15:25:00',2.13),('16100','2013-11-08','15:30:00',2.31),('16100','2013-11-08','15:40:00',1.66),('16100','2013-11-08','15:45:00',1.37),('16100','2013-11-08','15:50:00',1.41),('16100','2013-11-07','08:50:00',1.04),('16100','2013-11-07','08:55:00',1.26),('16100','2013-11-07','09:00:00',1.74),('16100','2013-11-07','09:05:00',1.78),('16100','2013-11-07','09:10:00',1.25),('16100','2013-11-07','09:15:00',1.51),('16100','2013-11-07','09:20:00',2.11),('16100','2013-11-07','09:25:00',1.27),('16100','2013-11-07','09:35:00',1.79),('16100','2013-11-07','09:40:00',4.31),('16100','2013-11-07','09:45:00',3.08),('16100','2013-11-07','09:50:00',3.39),('16100','2013-11-07','09:55:00',4.1),('16100','2013-11-07','10:00:00',1.45),('16100','2013-11-07','10:05:00',1.56),('16100','2013-11-07','10:10:00',1.46),('16100','2013-11-07','10:15:00',3.96),('16100','2013-11-07','10:20:00',5.95),('16100','2013-11-07','10:25:00',6.23),('16100','2013-11-07','10:30:00',4.59),('16100','2013-11-07','10:35:00',4.74),('16100','2013-11-07','10:40:00',1.38),('16100','2013-11-07','10:45:00',1.09),('16100','2013-11-07','10:50:00',3.76),('16100','2013-11-07','10:55:00',1.61),('16100','2013-11-07','11:00:00',1.67),('16100','2013-11-07','11:05:00',1.22),('16100','2013-11-07','11:20:00',3.19),('16100','2013-11-07','11:25:00',2.88),('16100','2013-11-07','11:30:00',6.74),('16100','2013-11-07','11:35:00',6.87),('16100','2013-11-07','11:40:00',6.85),('16100','2013-11-07','11:45:00',6.69),('16100','2013-11-07','11:50:00',6.78),('16100','2013-11-07','11:55:00',6.56),('16100','2013-11-07','12:00:00',6.22),('16100','2013-11-07','12:05:00',6.07),('16100','2013-11-07','12:10:00',6.05),('16100','2013-11-07','12:15:00',6.01),('16100','2013-11-07','12:20:00',6.03),('16100','2013-11-07','12:25:00',6.11),('16100','2013-11-07','12:30:00',5.62),('16100','2013-11-07','12:35:00',3.52),('16100','2013-11-07','12:40:00',2.83),('16100','2013-11-07','12:45:00',3.62),('16100','2013-11-07','12:50:00',4.09),('16100','2013-11-07','12:55:00',1.56),('16100','2013-11-07','13:00:00',3.51),('16100','2013-11-07','13:05:00',6.16),('16100','2013-11-07','13:10:00',6.25),('16100','2013-11-07','13:15:00',5.97),('16100','2013-11-07','13:20:00',5.84),('16100','2013-11-07','13:25:00',5.89),('16100','2013-11-07','13:30:00',5.62),('16100','2013-11-07','13:35:00',3.38),('16100','2013-11-07','13:40:00',3.47),('16100','2013-11-07','13:45:00',5.27),('16100','2013-11-07','13:50:00',5.37),('16100','2013-11-07','13:55:00',5.26),('16100','2013-11-07','14:00:00',4.99),('16100','2013-11-07','14:05:00',4.89),('16100','2013-11-07','14:10:00',1.68),('16100','2013-11-07','14:15:00',1.28),('16100','2013-11-07','14:20:00',3.14),('16100','2013-11-07','14:25:00',4.31),('16100','2013-11-07','14:30:00',4.14),('16100','2013-11-07','14:35:00',3.29),('16100','2013-11-07','14:45:00',3.11),('16100','2013-11-07','14:50:00',3.62),('16100','2013-11-07','14:55:00',3.42),('16100','2013-11-07','15:00:00',2.71),('16100','2013-11-07','15:05:00',3.09),('16100','2013-11-07','15:10:00',2.97),('16100','2013-11-07','15:15:00',2.86),('16100','2013-11-07','15:20:00',2.63),('16100','2013-11-07','15:25:00',2.51),('16100','2013-11-07','15:30:00',2.37),('16100','2013-11-07','15:35:00',2.2),('16100','2013-11-07','15:40:00',2.03),('16100','2013-11-07','15:45:00',1.83),('16100','2013-11-07','15:50:00',1.33),('16100','2013-11-07','15:55:00',1.23),('16100','2013-11-07','16:00:00',1.3),('16100','2013-11-07','16:05:00',1.14),('16100','2014-04-17','08:05:00',1.05),('16100','2014-04-17','08:10:00',1.59),('16100','2014-04-17','08:15:00',1.37),('16100','2014-04-17','08:20:00',1.59),('16100','2014-04-17','08:30:00',1.08),('16100','2014-04-17','08:35:00',1.89),('16100','2014-04-17','08:40:00',1.74),('16100','2014-04-17','08:45:00',2.84),('16100','2014-04-17','08:50:00',2.19),('16100','2014-04-17','08:55:00',1.64),('16100','2014-04-17','09:00:00',1.56),('16100','2014-04-17','09:05:00',2.36),('16100','2014-04-17','09:10:00',4.81),('16100','2014-04-17','09:15:00',4.52),('16100','2014-04-17','09:20:00',4.64),('16100','2014-04-17','09:25:00',3.25),('16100','2014-04-17','09:30:00',4.14),('16100','2014-04-17','09:35:00',1.75),('16100','2014-04-17','09:40:00',2.99),('16100','2014-04-17','09:45:00',3.97),('16100','2014-04-17','09:50:00',3.64),('16100','2014-04-17','09:55:00',3.91),('16100','2014-04-17','10:00:00',2.47),('16100','2014-04-17','10:05:00',2.18),('16100','2014-04-17','10:10:00',2.22),('16100','2014-04-17','10:15:00',2.04),('16100','2014-04-17','10:20:00',2.64),('16100','2014-04-17','10:25:00',2.31),('16100','2014-04-17','10:30:00',2),('16100','2014-04-17','10:35:00',2.12),('16100','2014-04-17','10:40:00',3.3),('16100','2014-04-17','10:45:00',4.36),('16100','2014-04-17','10:50:00',5.87),('16100','2014-04-17','10:55:00',4.24),('16100','2014-04-17','11:00:00',4),('16100','2014-04-17','11:05:00',3.31),('16100','2014-04-17','11:10:00',2.97),('16100','2014-04-17','11:15:00',3.52),('16100','2014-04-17','11:20:00',3.05),('16100','2014-04-17','11:25:00',3.14),('16100','2014-04-17','11:30:00',3.17),('16100','2014-04-17','11:35:00',3.7),('16100','2014-04-17','11:40:00',3.79),('16100','2014-04-17','11:45:00',4.98),('16100','2014-04-17','11:50:00',4.36),('16100','2014-04-17','11:55:00',3.48),('16100','2014-04-17','12:00:00',3.31),('16100','2014-04-17','12:05:00',4.94),('16100','2014-04-17','12:10:00',5.97),('16100','2014-04-17','12:15:00',7.37),('16100','2014-04-17','12:20:00',7.45),('16100','2014-04-17','12:25:00',5.92),('16100','2014-04-17','12:30:00',8.42),('16100','2014-04-17','12:35:00',8.13),('16100','2014-04-17','12:40:00',7.32),('16100','2014-04-17','12:45:00',6.74),('16100','2014-04-17','12:50:00',5.49),('16100','2014-04-17','12:55:00',7.76),('16100','2014-04-17','13:00:00',7.59),('16100','2014-04-17','13:05:00',4.77),('16100','2014-04-17','13:10:00',5.38),('16100','2014-04-17','13:15:00',4.77),('16100','2014-04-17','13:20:00',3.95),('16100','2014-04-17','13:25:00',2.92),('16100','2014-04-17','13:30:00',1.97),('16100','2014-04-17','13:35:00',2.27),('16100','2014-04-17','13:40:00',2.37),('16100','2014-04-17','13:45:00',2.42),('16100','2014-04-17','13:50:00',2.29),('16100','2014-04-17','13:55:00',2.57),('16100','2014-04-17','14:00:00',2.77),('16100','2014-04-17','14:05:00',2.78),('16100','2014-04-17','14:10:00',2.85),('16100','2014-04-17','14:15:00',3.15),('16100','2014-04-17','14:20:00',2.74),('16100','2014-04-17','14:25:00',3.35),('16100','2014-04-17','14:30:00',3.55),('16100','2014-04-17','14:35:00',3.93),('16100','2014-04-17','14:40:00',4.35),('16100','2014-04-17','14:45:00',5.83),('16100','2014-04-17','14:50:00',6.78),('16100','2014-04-17','14:55:00',8.05),('16100','2014-04-17','15:00:00',6.95),('16100','2014-04-17','15:05:00',7.2),('16100','2014-04-17','15:10:00',5.99),('16100','2014-04-17','15:15:00',7.77),('16100','2014-04-17','15:20:00',7.6),('16100','2014-04-17','15:25:00',7.52),('16100','2014-04-17','15:30:00',7.47),('16100','2014-04-17','15:35:00',6.98),('16100','2014-04-17','15:40:00',6.8),('16100','2014-04-17','15:45:00',5.27),('16100','2014-04-17','15:50:00',4.98),('16100','2014-04-17','15:55:00',4.07),('16100','2014-04-17','16:00:00',5.1),('16100','2014-04-17','16:05:00',5.97),('16100','2014-04-17','16:10:00',4.35),('16100','2014-04-17','16:15:00',5.95),('16100','2014-04-17','16:20:00',6.23),('16100','2014-04-17','16:25:00',5.89),('16100','2014-04-17','16:30:00',5.48),('16100','2014-04-17','16:35:00',5.36),('16100','2014-04-17','16:40:00',4.63),('16100','2014-04-17','16:45:00',3.11),('16100','2014-04-17','16:50:00',3.3),('16100','2014-04-17','16:55:00',5.16),('16100','2014-04-17','17:00:00',4.45),('16100','2014-04-17','17:05:00',4.16),('16100','2014-04-17','17:10:00',3.94),('16100','2014-04-17','17:15:00',3.55),('16100','2014-04-17','17:20:00',3.31),('16100','2014-04-17','17:25:00',3.21),('16100','2014-04-17','17:30:00',1.47),('16100','2014-04-17','17:35:00',2.88),('16100','2014-04-17','17:40:00',2.8),('16100','2014-04-17','17:45:00',2.6),('16100','2014-04-17','17:50:00',2.52),('16100','2014-04-17','17:55:00',2.39),('16100','2014-04-17','18:00:00',2.25),('16100','2014-04-17','18:05:00',1.96),('16100','2014-04-17','18:10:00',1.77),('16100','2014-04-17','18:15:00',1.6),('16100','2014-04-17','18:20:00',1.4),('16100','2014-04-17','18:25:00',1.18),('16100','2014-04-17','18:30:00',1.03),('16100','2013-11-06','07:40:00',1.13),('16100','2013-11-06','07:45:00',1.3),('16100','2013-11-06','07:50:00',1.46),('16100','2013-11-06','07:55:00',1.66),('16100','2013-11-06','08:00:00',1.83),('16100','2013-11-06','08:05:00',1.97),('16100','2013-11-06','08:10:00',2.15),('16100','2013-11-06','08:15:00',2.32),('16100','2013-11-06','08:20:00',2.48),('16100','2013-11-06','08:25:00',2.65),('16100','2013-11-06','08:30:00',2.78),('16100','2013-11-06','08:35:00',2.94),('16100','2013-11-06','08:40:00',3.1),('16100','2013-11-06','08:45:00',3.24),('16100','2013-11-06','08:50:00',3.36),('16100','2013-11-06','08:55:00',3.49),('16100','2013-11-06','09:00:00',3.63),('16100','2013-11-06','09:05:00',3.74),('16100','2013-11-06','09:10:00',3.88),('16100','2013-11-06','09:15:00',4),('16100','2013-11-06','09:20:00',4.11),('16100','2013-11-06','09:25:00',4.2),('16100','2013-11-06','09:30:00',4.32),('16100','2013-11-06','09:35:00',4.42),('16100','2013-11-06','09:40:00',4.54),('16100','2013-11-06','09:45:00',4.67),('16100','2013-11-06','09:50:00',4.77),('16100','2013-11-06','09:55:00',4.89),('16100','2013-11-06','10:00:00',4.98),('16100','2013-11-06','10:05:00',5.09),('16100','2013-11-06','10:10:00',5.14),('16100','2013-11-06','10:15:00',5.22),('16100','2013-11-06','10:20:00',5.29),('16100','2013-11-06','10:25:00',5.37),('16100','2013-11-06','10:30:00',5.44),('16100','2013-11-06','10:35:00',5.46),('16100','2013-11-06','10:40:00',5.51),('16100','2013-11-06','10:45:00',5.55),('16100','2013-11-06','10:50:00',5.57),('16100','2013-11-06','10:55:00',5.58),('16100','2013-11-06','11:00:00',5.6),('16100','2013-11-06','11:05:00',5.62),('16100','2013-11-06','11:10:00',5.65),('16100','2013-11-06','11:15:00',5.66),('16100','2013-11-06','11:20:00',5.68),('16100','2013-11-06','11:25:00',5.67),('16100','2013-11-06','11:30:00',5.66),('16100','2013-11-06','11:35:00',5.69),('16100','2013-11-06','11:40:00',5.72),('16100','2013-11-06','11:45:00',5.68),('16100','2013-11-06','11:50:00',5.69),('16100','2013-11-06','11:55:00',5.61),('16100','2013-11-06','12:00:00',5.63),('16100','2013-11-06','12:05:00',5.64),('16100','2013-11-06','12:10:00',5.7),('16100','2013-11-06','12:15:00',5.76),('16100','2013-11-06','12:20:00',4.99),('16100','2013-11-06','12:25:00',1.99),('16100','2013-11-06','12:30:00',2.34),('16100','2013-11-06','12:35:00',3.85),('16100','2013-11-06','12:40:00',6.12),('16100','2013-11-06','12:45:00',4.5),('16100','2013-11-06','12:50:00',2.15),('16100','2013-11-06','12:55:00',4.03),('16100','2013-11-06','13:00:00',4.3),('16100','2013-11-06','13:05:00',4.1),('16100','2013-11-06','13:10:00',1.68),('16100','2013-11-06','13:15:00',2.99),('16100','2013-11-06','13:20:00',5.53),('16100','2013-11-06','13:25:00',5.42),('16100','2013-11-06','13:30:00',5.32),('16100','2013-11-06','13:35:00',5.09),('16100','2013-11-06','13:40:00',4.56),('16100','2013-11-06','13:45:00',4.82),('16100','2013-11-06','13:50:00',4.75),('16100','2013-11-06','13:55:00',4.84),('16100','2013-11-06','14:00:00',4.72),('16100','2013-11-06','14:05:00',4.39),('16100','2013-11-06','14:10:00',5.11),('16100','2013-11-06','14:15:00',4.69),('16100','2013-11-06','14:20:00',4.29),('16100','2013-11-06','14:25:00',4.16),('16100','2013-11-06','14:30:00',4.04),('16100','2013-11-06','14:35:00',4.01),('16100','2013-11-06','14:40:00',3.93),('16100','2013-11-06','14:45:00',3.79),('16100','2013-11-06','14:50:00',3.63),('16100','2013-11-06','14:55:00',3.48),('16100','2013-11-06','15:00:00',3.27),('16100','2013-11-06','15:05:00',3.13),('16100','2013-11-06','15:10:00',2.96),('16100','2013-11-06','15:15:00',2.84),('16100','2013-11-06','15:20:00',2.68),('16100','2013-11-06','15:25:00',2.49),('16100','2013-11-06','15:30:00',2.34),('16100','2013-11-06','15:35:00',2.18),('16100','2013-11-06','15:40:00',2.02),('16100','2013-11-06','15:45:00',1.85),('16100','2013-11-06','15:50:00',1.65),('16100','2013-11-06','15:55:00',1.47),('16100','2013-11-06','16:00:00',1.3),('16100','2013-11-06','16:05:00',1.13),('16100','2013-11-05','08:00:00',1.64),('16100','2013-11-05','08:05:00',1.28),('16100','2013-11-05','08:10:00',2.28),('16100','2013-11-05','08:15:00',2.58),('16100','2013-11-05','08:20:00',1.63),('16100','2013-11-05','08:30:00',1.74),('16100','2013-11-05','08:35:00',3.15),('16100','2013-11-05','08:40:00',3.28),('16100','2013-11-05','08:45:00',3.42),('16100','2013-11-05','08:50:00',3.67),('16100','2013-11-05','08:55:00',2.7),('16100','2013-11-05','09:00:00',2.6),('16100','2013-11-05','09:05:00',2.79),('16100','2013-11-05','09:10:00',3.61),('16100','2013-11-05','09:15:00',3.93),('16100','2013-11-05','09:20:00',4.16),('16100','2013-11-05','09:25:00',4.44),('16100','2013-11-05','09:30:00',4.49),('16100','2013-11-05','09:35:00',4.59),('16100','2013-11-05','09:40:00',4.7),('16100','2013-11-05','09:45:00',4.83),('16100','2013-11-05','09:50:00',4.94),('16100','2013-11-05','09:55:00',5.04),('16100','2013-11-05','10:00:00',5.09),('16100','2013-11-05','10:05:00',5.16),('16100','2013-11-05','10:10:00',5.23),('16100','2013-11-05','10:15:00',5.32),('16100','2013-11-05','10:20:00',5.36),('16100','2013-11-05','10:25:00',5.39),('16100','2013-11-05','10:30:00',5.48),('16100','2013-11-05','10:35:00',5.63),('16100','2013-11-05','10:40:00',5.7),('16100','2013-11-05','10:45:00',5.75),('16100','2013-11-05','10:50:00',5.8),('16100','2013-11-05','10:55:00',5.86),('16100','2013-11-05','11:00:00',5.86),('16100','2013-11-05','11:05:00',5.89),('16100','2013-11-05','11:10:00',5.92),('16100','2013-11-05','11:15:00',5.92),('16100','2013-11-05','11:20:00',5.96),('16100','2013-11-05','11:25:00',6.01),('16100','2013-11-05','11:30:00',6.05),('16100','2013-11-05','11:35:00',6.07),('16100','2013-11-05','11:40:00',6.08),('16100','2013-11-05','11:45:00',6.11),('16100','2013-11-05','11:50:00',6.1),('16100','2013-11-05','11:55:00',6.13),('16100','2013-11-05','12:00:00',6.12),('16100','2013-11-05','12:05:00',6.07),('16100','2013-11-05','12:10:00',6.03),('16100','2013-11-05','12:15:00',6.03),('16100','2013-11-05','12:20:00',6.03),('16100','2013-11-05','12:25:00',6.02),('16100','2013-11-05','12:30:00',5.98),('16100','2013-11-05','12:35:00',6.02),('16100','2013-11-05','12:40:00',5.89),('16100','2013-11-05','12:45:00',5.83),('16100','2013-11-05','12:50:00',5.87),('16100','2013-11-05','12:55:00',5.78),('16100','2013-11-05','13:00:00',5.73),('16100','2013-11-05','13:05:00',5.75),('16100','2013-11-05','13:10:00',5.68),('16100','2013-11-05','13:15:00',5.55),('16100','2013-11-05','13:20:00',5.49),('16100','2013-11-05','13:25:00',5.43),('16100','2013-11-05','13:30:00',5.38),('16100','2013-11-05','13:35:00',5.26),('16100','2013-11-05','13:40:00',5.14),('16100','2013-11-05','13:45:00',5.06),('16100','2013-11-05','13:50:00',4.99),('16100','2013-11-05','13:55:00',4.91),('16100','2013-11-05','14:00:00',4.84),('16100','2013-11-05','14:05:00',4.71),('16100','2013-11-05','14:10:00',4.61),('16100','2013-11-05','14:15:00',4.53),('16100','2013-11-05','14:20:00',4.4),('16100','2013-11-05','14:25:00',4.31),('16100','2013-11-05','14:30:00',4.2),('16100','2013-11-05','14:35:00',4.09),('16100','2013-11-05','14:40:00',3.98),('16100','2013-11-05','14:45:00',3.82),('16100','2013-11-05','14:50:00',3.68),('16100','2013-11-05','14:55:00',3.55),('16100','2013-11-05','15:00:00',3.38),('16100','2013-11-05','15:05:00',3.2),('16100','2013-11-05','15:10:00',3.06),('16100','2013-11-05','15:15:00',2.9),('16100','2013-11-05','15:20:00',2.73),('16100','2013-11-05','15:25:00',2.57),('16100','2013-11-05','15:30:00',2.44),('16100','2013-11-05','15:35:00',2.28),('16100','2013-11-05','15:40:00',2.11),('16100','2013-11-05','15:45:00',1.94),('16100','2013-11-05','15:50:00',1.77),('16100','2013-11-05','15:55:00',1.6),('16100','2013-11-05','16:00:00',1.45),('16100','2013-11-05','16:05:00',1.28),('16100','2013-11-05','16:10:00',1.1),('16100','2013-11-04','08:30:00',1.31),('16100','2013-11-04','08:35:00',1.45),('16100','2013-11-04','08:40:00',1.13),('16100','2013-11-04','08:45:00',1.06),('16100','2013-11-04','08:50:00',1.1),('16100','2013-11-04','08:55:00',1.3),('16100','2013-11-04','10:10:00',1.06),('16100','2013-11-04','10:15:00',1.35),('16100','2013-11-04','10:20:00',1.73),('16100','2013-11-04','10:25:00',2),('16100','2013-11-04','10:30:00',1.99),('16100','2013-11-04','10:35:00',1.84),('16100','2013-11-04','10:40:00',2.44),('16100','2013-11-04','10:45:00',2.54),('16100','2013-11-04','10:50:00',2.14),('16100','2013-11-04','10:55:00',1.34),('16100','2013-11-04','11:25:00',1.12),('16100','2013-11-04','11:30:00',1.4),('16100','2013-11-04','11:35:00',1.94),('16100','2013-11-04','11:40:00',2.62),('16100','2013-11-04','11:45:00',2.28),('16100','2013-11-04','11:50:00',1.76),('16100','2013-11-04','11:55:00',1.68),('16100','2013-11-04','12:00:00',1.77),('16100','2013-11-04','12:05:00',2.02),('16100','2013-11-04','12:10:00',1.53),('16100','2013-11-04','12:15:00',1.34),('16100','2013-11-04','12:20:00',1.62),('16100','2013-11-04','12:25:00',2.38),('16100','2013-11-04','12:30:00',1.96),('16100','2013-11-04','12:35:00',1.1),('16100','2013-11-04','12:40:00',1.06),('16100','2013-11-04','12:45:00',1.26),('16100','2013-11-04','13:15:00',1.31),('16100','2013-11-04','13:20:00',2.23),('16100','2013-11-04','13:25:00',2.53),('16100','2013-11-04','13:30:00',2.62),('16100','2013-11-04','13:35:00',4.24),('16100','2013-11-04','13:40:00',4.42),('16100','2013-11-04','13:45:00',3.8),('16100','2013-11-04','13:50:00',5.11),('16100','2013-11-04','13:55:00',5.35),('16100','2013-11-04','14:00:00',5.61),('16100','2013-11-04','14:05:00',5.19),('16100','2013-11-04','14:10:00',5.17),('16100','2013-11-04','14:15:00',1.79),('16100','2013-11-04','14:20:00',2.74),('16100','2013-11-04','14:25:00',4.77),('16100','2013-11-04','14:30:00',5.14),('16100','2013-11-04','14:35:00',3.65),('16100','2013-11-04','14:40:00',3.98),('16100','2013-11-04','14:45:00',4.02),('16100','2013-11-04','14:50:00',3.08),('16100','2013-11-04','14:55:00',3.09),('16100','2013-11-04','15:05:00',1.52),('16100','2013-11-04','15:30:00',1.7),('16100','2013-11-04','15:35:00',1.94),('16100','2013-11-04','15:40:00',2.31),('16100','2013-11-04','15:45:00',2.31),('16100','2013-11-04','15:50:00',1.91),('16100','2013-11-04','15:55:00',1.58),('16100','2013-11-04','16:00:00',1.9),('16100','2013-11-04','16:05:00',1.71),('16100','2013-11-04','16:15:00',1.05),('16100','2013-11-03','07:50:00',1.36),('16100','2013-11-03','07:55:00',1.59),('16100','2013-11-03','08:00:00',1.76),('16100','2013-11-03','08:05:00',1.93),('16100','2013-11-03','08:10:00',2.06),('16100','2013-11-03','08:15:00',2.22),('16100','2013-11-03','08:20:00',2.38),('16100','2013-11-03','08:25:00',2.59),('16100','2013-11-03','08:30:00',2.78),('16100','2013-11-03','08:35:00',3.04),('16100','2013-11-03','08:40:00',1.44),('16100','2013-11-03','08:45:00',1.08),('16100','2013-11-03','08:50:00',2.67),('16100','2013-11-03','08:55:00',3.63),('16100','2013-11-03','09:00:00',3.61),('16100','2013-11-03','09:05:00',3.9),('16100','2013-11-03','09:10:00',3.95),('16100','2013-11-03','09:15:00',4.39),('16100','2013-11-03','09:20:00',3.95),('16100','2013-11-03','09:25:00',3.85),('16100','2013-11-03','09:30:00',4.51),('16100','2013-11-03','09:35:00',4.57),('16100','2013-11-03','09:40:00',4.69),('16100','2013-11-03','09:45:00',4.7),('16100','2013-11-03','09:50:00',4.94),('16100','2013-11-03','09:55:00',3.17),('16100','2013-11-03','10:15:00',1.22),('16100','2013-11-03','10:20:00',1.68),('16100','2013-11-03','10:55:00',1.62),('16100','2013-11-03','11:10:00',1.14),('16100','2013-11-03','11:50:00',1.53),('16100','2013-11-03','11:55:00',2.71),('16100','2013-11-03','12:00:00',1.09),('16100','2013-11-03','12:05:00',3.2),('16100','2013-11-03','12:10:00',1.74),('16100','2013-11-03','12:15:00',3.48),('16100','2013-11-03','12:20:00',5.61),('16100','2013-11-03','12:25:00',6.33),('16100','2013-11-03','12:30:00',6.41),('16100','2013-11-03','12:35:00',6.23),('16100','2013-11-03','12:40:00',6.37),('16100','2013-11-03','12:45:00',4.61),('16100','2013-11-03','12:50:00',4.9),('16100','2013-11-03','12:55:00',4.29),('16100','2013-11-03','13:00:00',5.16),('16100','2013-11-03','13:05:00',5.07),('16100','2013-11-03','13:10:00',3.19),('16100','2013-11-03','13:15:00',4.55),('16100','2013-11-03','13:20:00',5.81),('16100','2013-11-03','13:25:00',2.67),('16100','2013-11-03','13:30:00',3.31),('16100','2013-11-03','13:35:00',2.55),('16100','2013-11-03','13:40:00',2.44),('16100','2013-11-03','13:45:00',1.87),('16100','2013-11-03','13:50:00',3.77),('16100','2013-11-03','13:55:00',1.08),('16100','2013-11-03','14:00:00',1.25),('16100','2013-11-03','14:05:00',1.71),('16100','2013-11-03','14:10:00',3),('16100','2013-11-03','14:15:00',2.11),('16100','2013-11-03','14:20:00',2.58),('16100','2013-11-03','14:25:00',3.94),('16100','2013-11-03','14:30:00',3.27),('16100','2013-11-03','14:35:00',1.11),('16100','2013-11-03','14:40:00',2.07),('16100','2013-11-03','14:45:00',4.15),('16100','2013-11-03','14:50:00',3.12),('16100','2013-11-03','14:55:00',3.88),('16100','2013-11-03','15:00:00',3.4),('16100','2013-11-03','15:05:00',2.18),('16100','2013-11-03','15:10:00',2.88),('16100','2013-11-03','15:15:00',3.14),('16100','2013-11-03','15:20:00',2.85),('16100','2013-11-03','15:25:00',2.62),('16100','2013-11-03','15:30:00',2.46),('16100','2013-11-03','15:35:00',1.16),('16100','2013-11-02','07:30:00',1.16),('16100','2013-11-02','07:35:00',1.35),('16100','2013-11-02','07:40:00',1.52),('16100','2013-11-02','07:45:00',1.66),('16100','2013-11-02','07:50:00',1.47),('16100','2013-11-02','07:55:00',1.37),('16100','2013-11-02','08:05:00',1.61),('16100','2013-11-02','08:10:00',1.39),('16100','2013-11-02','08:15:00',1.97),('16100','2013-11-02','08:20:00',1.61),('16100','2013-11-02','08:25:00',1.95),('16100','2013-11-02','08:30:00',2.4),('16100','2013-11-02','08:35:00',2.88),('16100','2013-11-02','08:40:00',3.26),('16100','2013-11-02','08:50:00',3.52),('16100','2013-11-02','08:55:00',1.93),('16100','2013-11-02','09:00:00',3.31),('16100','2013-11-02','09:05:00',2.49),('16100','2013-11-02','09:10:00',2.29),('16100','2013-11-02','09:15:00',2.77),('16100','2013-11-02','09:20:00',2.53),('16100','2013-11-02','09:25:00',2.63),('16100','2013-11-02','09:30:00',3.95),('16100','2013-11-02','09:35:00',4.61),('16100','2013-11-02','09:40:00',1.63),('16100','2013-11-02','09:50:00',1.11),('16100','2013-11-02','10:00:00',2.18),('16100','2013-11-02','10:05:00',1.39),('16100','2013-11-02','10:10:00',3.18),('16100','2013-11-02','10:15:00',5.21),('16100','2013-11-02','10:20:00',5.42),('16100','2013-11-02','10:25:00',5.68),('16100','2013-11-02','10:30:00',5.43),('16100','2013-11-02','10:35:00',6.06),('16100','2013-11-02','10:40:00',5.73),('16100','2013-11-02','10:45:00',4.34),('16100','2013-11-02','11:05:00',1.73),('16100','2013-11-02','11:10:00',4.68),('16100','2013-11-02','11:15:00',6.35),('16100','2013-11-02','11:20:00',5.77),('16100','2013-11-02','11:25:00',3.79),('16100','2013-11-02','11:30:00',4.76),('16100','2013-11-02','11:35:00',6.76),('16100','2013-11-02','11:40:00',6.64),('16100','2013-11-02','11:45:00',5.18),('16100','2013-11-02','11:50:00',5.09),('16100','2013-11-02','11:55:00',4.25),('16100','2013-11-02','12:00:00',3.63),('16100','2013-11-02','12:05:00',3.22),('16100','2013-11-02','12:10:00',1.43),('16100','2013-11-02','12:15:00',3.32),('16100','2013-11-02','12:20:00',4.67),('16100','2013-11-02','12:25:00',2.75),('16100','2013-11-02','12:30:00',1.37),('16100','2013-11-02','12:40:00',1.51),('16100','2013-11-02','12:45:00',1.73),('16100','2013-11-02','12:50:00',1.85),('16100','2013-11-02','12:55:00',1.78),('16100','2013-11-02','13:00:00',1.72),('16100','2013-11-02','13:05:00',1.7),('16100','2013-11-02','13:10:00',1.78),('16100','2013-11-02','13:15:00',1.74),('16100','2013-11-02','13:20:00',1.81),('16100','2013-11-02','13:25:00',2.63),('16100','2013-11-02','13:30:00',1.5),('16100','2013-11-02','13:35:00',1.32),('16100','2013-11-02','13:40:00',1.55),('16100','2013-11-02','13:45:00',2.05),('16100','2013-11-02','13:50:00',2.14),('16100','2013-11-02','13:55:00',2.14),('16100','2013-11-02','14:00:00',2.6),('16100','2013-11-02','14:05:00',4.14),('16100','2013-11-02','14:10:00',2.23),('16100','2013-11-02','14:15:00',3.01),('16100','2013-11-02','14:20:00',2.82),('16100','2013-11-02','14:25:00',3.69),('16100','2013-11-02','14:30:00',3.3),('16100','2013-11-02','14:35:00',1.72),('16100','2013-11-02','14:40:00',2.13),('16100','2013-11-02','14:45:00',1.32),('16100','2013-11-02','14:50:00',1.07),('16100','2013-11-02','14:55:00',2.2),('16100','2013-11-02','15:10:00',1.06),('16100','2013-11-02','15:15:00',1.54),('16100','2013-11-02','15:25:00',1.89),('16100','2013-11-02','15:30:00',1.82),('16100','2013-11-02','15:35:00',1.66),('16100','2013-11-02','15:40:00',1.08),('16100','2013-11-02','15:50:00',1.04),('16100','2013-11-01','07:45:00',1.07),('16100','2013-11-01','07:50:00',1.24),('16100','2013-11-01','07:55:00',1.43),('16100','2013-11-01','08:00:00',1.6),('16100','2013-11-01','08:05:00',1.79),('16100','2013-11-01','08:10:00',1.97),('16100','2013-11-01','08:15:00',2.12),('16100','2013-11-01','08:20:00',2.32),('16100','2013-11-01','08:25:00',2.47),('16100','2013-11-01','08:30:00',2.64),('16100','2013-11-01','08:35:00',2.83),('16100','2013-11-01','08:40:00',2.97),('16100','2013-11-01','08:45:00',3.15),('16100','2013-11-01','08:50:00',3.3),('16100','2013-11-01','08:55:00',3.54),('16100','2013-11-01','09:00:00',3.74),('16100','2013-11-01','09:05:00',3.14),('16100','2013-11-01','09:10:00',2.53),('16100','2013-11-01','09:15:00',4.12),('16100','2013-11-01','09:20:00',3.36),('16100','2013-11-01','09:25:00',4.03),('16100','2013-11-01','09:30:00',4.28),('16100','2013-11-01','09:35:00',4.35),('16100','2013-11-01','09:40:00',4.42),('16100','2013-11-01','09:45:00',4.69),('16100','2013-11-01','09:50:00',4.08),('16100','2013-11-01','09:55:00',4.5),('16100','2013-11-01','10:00:00',2.87),('16100','2013-11-01','10:05:00',3.01),('16100','2013-11-01','10:10:00',2.07),('16100','2013-11-01','10:15:00',1.47),('16100','2013-11-01','10:20:00',1.29),('16100','2013-11-01','10:25:00',1.08),('16100','2013-11-01','10:50:00',1.16),('16100','2013-11-01','10:55:00',1.67),('16100','2013-11-01','11:00:00',2.21),('16100','2013-11-01','11:05:00',2.79),('16100','2013-11-01','11:10:00',3.96),('16100','2013-11-01','11:15:00',1.59),('16100','2013-11-01','11:20:00',3.39),('16100','2013-11-01','11:25:00',7.13),('16100','2013-11-01','11:30:00',7.22),('16100','2013-11-01','11:35:00',6.49),('16100','2013-11-01','11:40:00',6.7),('16100','2013-11-01','11:45:00',6.68),('16100','2013-11-01','11:50:00',6.65),('16100','2013-11-01','11:55:00',6.53),('16100','2013-11-01','12:00:00',6.35),('16100','2013-11-01','12:05:00',5.22),('16100','2013-11-01','12:10:00',7.11),('16100','2013-11-01','12:15:00',4.52),('16100','2013-11-01','12:20:00',2.22),('16100','2013-11-01','12:25:00',1.97),('16100','2013-11-01','12:30:00',2.84),('16100','2013-11-01','12:35:00',2.83),('16100','2013-11-01','12:40:00',6.14),('16100','2013-11-01','12:45:00',2.7),('16100','2013-11-01','12:50:00',2.27),('16100','2013-11-01','12:55:00',4.59),('16100','2013-11-01','13:00:00',2.74),('16100','2013-11-01','13:05:00',3.61),('16100','2013-11-01','13:10:00',4.23),('16100','2013-11-01','13:15:00',6.9),('16100','2013-11-01','13:20:00',4.62),('16100','2013-11-01','13:25:00',1.75),('16100','2013-11-01','13:30:00',1.62),('16100','2013-11-01','13:35:00',2.2),('16100','2013-11-01','13:40:00',2.52),('16100','2013-11-01','13:45:00',5.34),('16100','2013-11-01','13:50:00',6.35),('16100','2013-11-01','13:55:00',5.72),('16100','2013-11-01','14:00:00',5.36),('16100','2013-11-01','14:05:00',4.9),('16100','2013-11-01','14:10:00',4.66),('16100','2013-11-01','14:15:00',4.59),('16100','2013-11-01','14:20:00',4.45),('16100','2013-11-01','14:25:00',4.51),('16100','2013-11-01','14:30:00',3.89),('16100','2013-11-01','14:35:00',4.18),('16100','2013-11-01','14:40:00',4.13),('16100','2013-11-01','14:45:00',3.53),('16100','2013-11-01','14:50:00',3.83),('16100','2013-11-01','14:55:00',3.07),('16100','2013-11-01','15:00:00',4.07),('16100','2013-11-01','15:05:00',3.09),('16100','2013-11-01','15:10:00',2.73),('16100','2013-11-01','15:15:00',1.4),('16100','2013-11-01','15:20:00',2.41),('16100','2013-11-01','15:25:00',2.26),('16100','2013-11-01','15:45:00',1.74),('16100','2013-11-01','15:50:00',2.03),('16100','2013-11-01','15:55:00',1.48),('16100','2013-11-01','16:00:00',1.09),('16100','2013-11-01','16:10:00',1.07),('16100','2013-11-01','16:15:00',1.01),('16100','2013-10-31','07:40:00',1.12),('16100','2013-10-31','07:45:00',1.28),('16100','2013-10-31','07:50:00',1.39),('16100','2013-10-31','07:55:00',1.51),('16100','2013-10-31','08:00:00',1.64),('16100','2013-10-31','08:05:00',1.62),('16100','2013-10-31','08:10:00',1.23),('16100','2013-10-31','08:15:00',1.43),('16100','2013-10-31','08:20:00',1.73),('16100','2013-10-31','08:25:00',2.1),('16100','2013-10-31','08:30:00',2.5),('16100','2013-10-31','08:35:00',2.72),('16100','2013-10-31','08:40:00',2.71),('16100','2013-10-31','08:45:00',2.49),('16100','2013-10-31','08:50:00',2.52),('16100','2013-10-31','08:55:00',2.74),('16100','2013-10-31','09:00:00',2.75),('16100','2013-10-31','09:05:00',3.5),('16100','2013-10-31','09:10:00',3.76),('16100','2013-10-31','09:15:00',3.86),('16100','2013-10-31','09:20:00',3.95),('16100','2013-10-31','09:25:00',4.07),('16100','2013-10-31','09:30:00',4.23),('16100','2013-10-31','09:35:00',4.37),('16100','2013-10-31','09:40:00',4.51),('16100','2013-10-31','09:45:00',4.64),('16100','2013-10-31','09:50:00',4.75),('16100','2013-10-31','09:55:00',4.91),('16100','2013-10-31','10:00:00',5.06),('16100','2013-10-31','10:05:00',5.19),('16100','2013-10-31','10:10:00',5.32),('16100','2013-10-31','10:15:00',5.38),('16100','2013-10-31','10:20:00',5.45),('16100','2013-10-31','10:25:00',5.53),('16100','2013-10-31','10:30:00',5.57),('16100','2013-10-31','10:35:00',5.69),('16100','2013-10-31','10:40:00',5.73),('16100','2013-10-31','10:45:00',5.73),('16100','2013-10-31','10:50:00',5.59),('16100','2013-10-31','10:55:00',5.74),('16100','2013-10-31','11:00:00',5.76),('16100','2013-10-31','11:05:00',5.83),('16100','2013-10-31','11:10:00',5.34),('16100','2013-10-31','11:15:00',4.76),('16100','2013-10-31','11:20:00',4.92),('16100','2013-10-31','11:25:00',4.72),('16100','2013-10-31','11:30:00',5.46),('16100','2013-10-31','11:35:00',6.09),('16100','2013-10-31','11:40:00',5.92),('16100','2013-10-31','11:45:00',5.52),('16100','2013-10-31','11:50:00',5.6),('16100','2013-10-31','11:55:00',6.06),('16100','2013-10-31','12:00:00',6.17),('16100','2013-10-31','12:05:00',6.05),('16100','2013-10-31','12:10:00',6.09),('16100','2013-10-31','12:15:00',5.22),('16100','2013-10-31','12:20:00',4.3),('16100','2013-10-31','12:25:00',4.99),('16100','2013-10-31','12:30:00',4.25),('16100','2013-10-31','12:35:00',3.6),('16100','2013-10-31','12:40:00',1.77),('16100','2013-10-31','12:45:00',1.84),('16100','2013-10-31','12:50:00',1.88),('16100','2013-10-31','12:55:00',2.71),('16100','2013-10-31','13:00:00',3.73),('16100','2013-10-31','13:05:00',4.78),('16100','2013-10-31','13:10:00',4.71),('16100','2013-10-31','13:15:00',4.03),('16100','2013-10-31','13:20:00',3.27),('16100','2013-10-31','13:25:00',1.84),('16100','2013-10-31','13:30:00',1.53),('16100','2013-10-31','13:35:00',1.69),('16100','2013-10-31','13:40:00',1.81),('16100','2013-10-31','13:45:00',1.25),('16100','2013-10-31','13:50:00',1.06),('16100','2013-10-31','13:55:00',1.21),('16100','2013-10-31','14:00:00',1.32),('16100','2013-10-31','14:05:00',1.65),('16100','2013-10-31','14:10:00',1.64),('16100','2013-10-31','14:15:00',1.52),('16100','2013-10-31','14:20:00',1.37),('16100','2013-10-31','14:25:00',1.15),('16100','2013-10-30','08:20:00',2.29),('16100','2013-10-30','08:25:00',1.82),('16100','2013-10-30','08:30:00',2.6),('16100','2013-10-30','08:35:00',2.67),('16100','2013-10-30','08:40:00',1.94),('16100','2013-10-30','08:45:00',1.75),('16100','2013-10-30','08:50:00',1.39),('16100','2013-10-30','08:55:00',1.87),('16100','2013-10-30','09:00:00',2.6),('16100','2013-10-30','09:05:00',3.04),('16100','2013-10-30','09:10:00',3.6),('16100','2013-10-30','09:15:00',3.92),('16100','2013-10-30','09:20:00',3.65),('16100','2013-10-30','09:25:00',2.98),('16100','2013-10-30','09:30:00',2.96),('16100','2013-10-30','09:35:00',3.63),('16100','2013-10-30','09:40:00',3.55),('16100','2013-10-30','09:45:00',3.65),('16100','2013-10-30','09:50:00',3.81),('16100','2013-10-30','09:55:00',4.16),('16100','2013-10-30','10:00:00',4.32),('16100','2013-10-30','10:05:00',4.52),('16100','2013-10-30','10:10:00',4.49),('16100','2013-10-30','10:15:00',4.61),('16100','2013-10-30','10:20:00',4.83),('16100','2013-10-30','10:25:00',4.76),('16100','2013-10-30','10:30:00',4.61),('16100','2013-10-30','10:35:00',4.43),('16100','2013-10-30','10:40:00',4.5),('16100','2013-10-30','10:45:00',4.17),('16100','2013-10-30','10:50:00',4.88),('16100','2013-10-30','10:55:00',4.67),('16100','2013-10-30','11:00:00',4.71),('16100','2013-10-30','11:05:00',4.59),('16100','2013-10-30','11:10:00',5.02),('16100','2013-10-30','11:15:00',4.72),('16100','2013-10-30','11:20:00',5.16),('16100','2013-10-30','11:25:00',5.33),('16100','2013-10-30','11:30:00',4.88),('16100','2013-10-30','11:35:00',4.42),('16100','2013-10-30','11:40:00',3.1),('16100','2013-10-30','11:45:00',4.43),('16100','2013-10-30','11:50:00',5.48),('16100','2013-10-30','11:55:00',5.8),('16100','2013-10-30','12:00:00',5.8),('16100','2013-10-30','12:05:00',5.82),('16100','2013-10-30','12:10:00',5.81),('16100','2013-10-30','12:15:00',5.76),('16100','2013-10-30','12:20:00',5.51),('16100','2013-10-30','12:25:00',5.52),('16100','2013-10-30','12:30:00',5.48),('16100','2013-10-30','12:35:00',5.32),('16100','2013-10-30','12:40:00',5.22),('16100','2013-10-30','12:45:00',5.43),('16100','2013-10-30','12:50:00',5.54),('16100','2013-10-30','12:55:00',5.62),('16100','2013-10-30','13:00:00',5.57),('16100','2013-10-30','13:05:00',5.6),('16100','2013-10-30','13:10:00',5.47),('16100','2013-10-30','13:15:00',5.32),('16100','2013-10-30','13:20:00',5.13),('16100','2013-10-30','13:25:00',5.09),('16100','2013-10-30','13:30:00',5.04),('16100','2013-10-30','13:35:00',4.89),('16100','2013-10-30','13:40:00',4.75),('16100','2013-10-30','13:45:00',4.54),('16100','2013-10-30','13:50:00',4.59),('16100','2013-10-30','13:55:00',4.51),('16100','2013-10-30','14:00:00',4.19),('16100','2013-10-30','14:05:00',3.7),('16100','2013-10-30','14:10:00',3.41),('16100','2013-10-30','14:15:00',1.99),('16100','2013-10-30','14:20:00',4.07),('16100','2013-10-30','14:25:00',2.14),('16100','2013-10-30','14:30:00',2.32),('16100','2013-10-30','14:35:00',1.93),('16100','2013-10-30','14:40:00',3.11),('16100','2013-10-30','14:45:00',3.02),('16100','2013-10-30','14:50:00',2.91),('16100','2013-10-30','14:55:00',2.94),('16100','2013-10-30','15:00:00',2.47),('16100','2013-10-30','15:05:00',2.48),('16100','2013-10-30','15:10:00',2.36),('16100','2013-10-30','15:15:00',2.17),('16100','2013-10-30','15:20:00',2.14),('16100','2013-10-30','15:25:00',1.93),('16100','2013-10-30','15:30:00',1.79),('16100','2013-10-30','15:35:00',1.67),('16100','2013-10-30','15:40:00',1.54),('16100','2013-10-30','15:45:00',1.37),('16100','2013-10-30','15:50:00',1.39),('16100','2013-10-30','15:55:00',1.17),('16100','2013-10-29','07:50:00',1.16),('16100','2013-10-29','07:55:00',1.31),('16100','2013-10-29','08:00:00',1.45),('16100','2013-10-29','08:05:00',1.62),('16100','2013-10-29','08:10:00',1.78),('16100','2013-10-29','08:15:00',1.89),('16100','2013-10-29','08:20:00',2.06),('16100','2013-10-29','08:25:00',2.18),('16100','2013-10-29','08:30:00',2.38),('16100','2013-10-29','08:35:00',2.55),('16100','2013-10-29','08:40:00',2.68),('16100','2013-10-29','08:45:00',2.91),('16100','2013-10-29','08:50:00',2.93),('16100','2013-10-29','08:55:00',2.98),('16100','2013-10-29','09:00:00',3.18),('16100','2013-10-29','09:05:00',3.47),('16100','2013-10-29','09:10:00',3.62),('16100','2013-10-29','09:15:00',3.7),('16100','2013-10-29','09:20:00',3.76),('16100','2013-10-29','09:25:00',3.96),('16100','2013-10-29','09:30:00',4.11),('16100','2013-10-29','09:35:00',4.11),('16100','2013-10-29','09:40:00',3.91),('16100','2013-10-29','09:45:00',3.84),('16100','2013-10-29','09:50:00',3.93),('16100','2013-10-29','09:55:00',4.45),('16100','2013-10-29','10:00:00',4.14),('16100','2013-10-29','10:05:00',4.58),('16100','2013-10-29','10:10:00',4.24),('16100','2013-10-29','10:15:00',3.87),('16100','2013-10-29','10:20:00',4.31),('16100','2013-10-29','10:25:00',4.67),('16100','2013-10-29','10:30:00',4.88),('16100','2013-10-29','10:35:00',4.88),('16100','2013-10-29','10:40:00',4.74),('16100','2013-10-29','10:45:00',4.12),('16100','2013-10-29','10:50:00',4.82),('16100','2013-10-29','10:55:00',5.27),('16100','2013-10-29','11:00:00',5.23),('16100','2013-10-29','11:05:00',4.98),('16100','2013-10-29','11:10:00',5.42),('16100','2013-10-29','11:15:00',5.23),('16100','2013-10-29','11:20:00',5.1),('16100','2013-10-29','11:25:00',5.24),('16100','2013-10-29','11:30:00',3.6),('16100','2013-10-29','11:35:00',3.84),('16100','2013-10-29','11:40:00',3.42),('16100','2013-10-29','11:45:00',4.31),('16100','2013-10-29','11:50:00',3.8),('16100','2013-10-29','11:55:00',2.62),('16100','2013-10-29','12:00:00',4.49),('16100','2013-10-29','12:05:00',4.67),('16100','2013-10-29','12:10:00',4.95),('16100','2013-10-29','12:15:00',5.37),('16100','2013-10-29','12:20:00',4.31),('16100','2013-10-29','12:25:00',1.83),('16100','2013-10-29','12:30:00',1.29),('16100','2013-10-29','12:35:00',1.21),('16100','2013-10-29','12:40:00',1.69),('16100','2013-10-29','12:45:00',4.29),('16100','2013-10-29','12:50:00',4.69),('16100','2013-10-29','12:55:00',3.1),('16100','2013-10-29','13:00:00',2.95),('16100','2013-10-29','13:05:00',3.03),('16100','2013-10-29','13:10:00',1.33),('16100','2013-10-29','13:15:00',1.2),('16100','2013-10-29','13:20:00',1.44),('16100','2013-10-29','13:25:00',4.49),('16100','2013-10-29','13:30:00',3.13),('16100','2013-10-29','13:35:00',4.5),('16100','2013-10-29','13:40:00',4.84),('16100','2013-10-29','13:45:00',3.61),('16100','2013-10-29','13:50:00',1.42),('16100','2013-10-29','13:55:00',1.07),('16100','2013-10-29','14:00:00',1.25),('16100','2013-10-29','14:05:00',3.27),('16100','2013-10-29','14:10:00',2.77),('16100','2013-10-29','14:15:00',3.05),('16100','2013-10-29','14:20:00',3.15),('16100','2013-10-29','14:25:00',4.13),('16100','2013-10-29','14:30:00',1.02),('16100','2013-10-29','14:35:00',1.15),('16100','2013-10-29','14:40:00',1.35),('16100','2013-10-29','15:05:00',2.33),('16100','2013-10-29','15:10:00',1.75),('16100','2013-10-29','15:15:00',2.43),('16100','2013-10-29','15:25:00',2.05),('16100','2013-10-29','15:30:00',1.31),('16100','2013-10-29','15:50:00',1.39),('16100','2013-10-29','15:55:00',1.24),('16100','2013-10-28','08:10:00',1.2),('16100','2013-10-28','08:15:00',1.08),('16100','2013-10-28','08:20:00',1.37),('16100','2013-10-28','08:25:00',2.25),('16100','2013-10-28','08:30:00',2.14),('16100','2013-10-28','08:35:00',2.34),('16100','2013-10-28','08:40:00',2.92),('16100','2013-10-28','08:45:00',3.08),('16100','2013-10-28','08:50:00',3.25),('16100','2013-10-28','08:55:00',3.4),('16100','2013-10-28','09:00:00',3.51),('16100','2013-10-28','09:05:00',3.61),('16100','2013-10-28','09:10:00',3.75),('16100','2013-10-28','09:15:00',3.89),('16100','2013-10-28','09:20:00',4.01),('16100','2013-10-28','09:25:00',4.05),('16100','2013-10-28','09:30:00',4.19),('16100','2013-10-28','09:35:00',4.32),('16100','2013-10-28','09:40:00',4.51),('16100','2013-10-28','09:45:00',4.67),('16100','2013-10-28','09:50:00',4.56),('16100','2013-10-28','09:55:00',4.18),('16100','2013-10-28','10:00:00',4.77),('16100','2013-10-28','10:05:00',4.88),('16100','2013-10-28','10:10:00',4.68),('16100','2013-10-28','10:15:00',3.99),('16100','2013-10-28','10:20:00',2.98),('16100','2013-10-28','10:25:00',3.24),('16100','2013-10-28','10:30:00',3.4),('16100','2013-10-28','10:35:00',4.58),('16100','2013-10-28','10:40:00',3.42),('16100','2013-10-28','10:45:00',3.86),('16100','2013-10-28','10:50:00',6.09),('16100','2013-10-28','10:55:00',6.16),('16100','2013-10-28','11:00:00',5.24),('16100','2013-10-28','11:05:00',3.54),('16100','2013-10-28','11:10:00',2.36),('16100','2013-10-28','11:15:00',2.03),('16100','2013-10-28','11:20:00',2.11),('16100','2013-10-28','11:25:00',4.27),('16100','2013-10-28','11:30:00',3.91),('16100','2013-10-28','11:35:00',2.95),('16100','2013-10-28','11:40:00',4.61),('16100','2013-10-28','11:45:00',4.21),('16100','2013-10-28','11:50:00',6.5),('16100','2013-10-28','11:55:00',5.89),('16100','2013-10-28','12:00:00',3.3),('16100','2013-10-28','12:05:00',6.01),('16100','2013-10-28','12:10:00',5.98),('16100','2013-10-28','12:15:00',5.93),('16100','2013-10-28','12:20:00',5.82),('16100','2013-10-28','12:25:00',5.78),('16100','2013-10-28','12:30:00',5.8),('16100','2013-10-28','12:35:00',5.74),('16100','2013-10-28','12:40:00',5.72),('16100','2013-10-28','12:45:00',5.67),('16100','2013-10-28','12:50:00',5.68),('16100','2013-10-28','12:55:00',5.66),('16100','2013-10-28','13:00:00',5.58),('16100','2013-10-28','13:05:00',5.17),('16100','2013-10-28','13:10:00',5.1),('16100','2013-10-28','13:15:00',5.12),('16100','2013-10-28','13:20:00',3.99),('16100','2013-10-28','13:25:00',5.05),('16100','2013-10-28','13:30:00',4.32),('16100','2013-10-28','13:35:00',5.09),('16100','2013-10-28','13:40:00',5.09),('16100','2013-10-28','13:45:00',3.91),('16100','2013-10-28','13:50:00',2.37),('16100','2013-10-28','13:55:00',4.47),('16100','2013-10-28','14:00:00',4.35),('16100','2013-10-28','14:05:00',3.95),('16100','2013-10-28','14:10:00',2.91),('16100','2013-10-28','14:15:00',4.38),('16100','2013-10-28','14:20:00',4.16),('16100','2013-10-28','14:25:00',3.75),('16100','2013-10-28','14:30:00',2.5),('16100','2013-10-28','14:35:00',3.62),('16100','2013-10-28','14:40:00',3.72),('16100','2013-10-28','14:45:00',3.65),('16100','2013-10-28','14:50:00',3.47),('16100','2013-10-28','14:55:00',3.28),('16100','2013-10-28','15:00:00',3.13),('16100','2013-10-28','15:05:00',2.95),('16100','2013-10-28','15:10:00',2.78),('16100','2013-10-28','15:15:00',2.61),('16100','2013-10-28','15:20:00',2.5),('16100','2013-10-28','15:25:00',2.34),('16100','2013-10-28','15:30:00',2.15),('16100','2013-10-28','15:35:00',2.01),('16100','2013-10-28','15:40:00',1.83),('16100','2013-10-28','15:45:00',1.66),('16100','2013-10-28','15:50:00',1.49),('16100','2013-10-28','15:55:00',1.33),('16100','2013-10-28','16:00:00',1.19),('16100','2013-10-28','16:05:00',1.04),('16100','2014-04-16','08:00:00',1.06),('16100','2014-04-16','08:05:00',1.18),('16100','2014-04-16','08:10:00',1.46),('16100','2014-04-16','08:15:00',1.6),('16100','2014-04-16','08:20:00',2.01),('16100','2014-04-16','08:25:00',2.17),('16100','2014-04-16','08:30:00',2.35),('16100','2014-04-16','08:35:00',2.56),('16100','2014-04-16','08:40:00',2.74),('16100','2014-04-16','08:45:00',2.9),('16100','2014-04-16','08:50:00',3.12),('16100','2014-04-16','08:55:00',3.33),('16100','2014-04-16','09:00:00',3.45),('16100','2014-04-16','09:05:00',3.69),('16100','2014-04-16','09:10:00',3.9),('16100','2014-04-16','09:15:00',4.05),('16100','2014-04-16','09:20:00',4.21),('16100','2014-04-16','09:25:00',4.37),('16100','2014-04-16','09:30:00',4.5),('16100','2014-04-16','09:35:00',4.65),('16100','2014-04-16','09:40:00',4.84),('16100','2014-04-16','09:45:00',4.97),('16100','2014-04-16','09:50:00',5.13),('16100','2014-04-16','09:55:00',5.27),('16100','2014-04-16','10:00:00',5.5),('16100','2014-04-16','10:05:00',4.01),('16100','2014-04-16','10:10:00',3.61),('16100','2014-04-16','10:15:00',3.55),('16100','2014-04-16','10:20:00',5.16),('16100','2014-04-16','10:25:00',6.39),('16100','2014-04-16','10:30:00',6.07),('16100','2014-04-16','10:35:00',5.58),('16100','2014-04-16','10:40:00',4.74),('16100','2014-04-16','10:45:00',4.3),('16100','2014-04-16','10:50:00',4.27),('16100','2014-04-16','10:55:00',5.32),('16100','2014-04-16','11:00:00',4.15),('16100','2014-04-16','11:05:00',5.68),('16100','2014-04-16','11:10:00',5.04),('16100','2014-04-16','11:15:00',6.53),('16100','2014-04-16','11:20:00',6.4),('16100','2014-04-16','11:25:00',4.1),('16100','2014-04-16','11:30:00',4.32),('16100','2014-04-16','11:35:00',3.89),('16100','2014-04-16','11:40:00',6.52),('16100','2014-04-16','11:45:00',6.58),('16100','2014-04-16','11:50:00',6.93),('16100','2014-04-16','11:55:00',6.34),('16100','2014-04-16','12:00:00',5.32),('16100','2014-04-16','12:05:00',3.8),('16100','2014-04-16','12:10:00',3.74),('16100','2014-04-16','12:15:00',4.41),('16100','2014-04-16','12:20:00',4.79),('16100','2014-04-16','12:25:00',6.52),('16100','2014-04-16','12:30:00',6.67),('16100','2014-04-16','12:35:00',7.67),('16100','2014-04-16','12:40:00',7.74),('16100','2014-04-16','12:45:00',7.95),('16100','2014-04-16','12:50:00',8.07),('16100','2014-04-16','12:55:00',8.05),('16100','2014-04-16','13:00:00',8),('16100','2014-04-16','13:05:00',7.95),('16100','2014-04-16','13:10:00',7.99),('16100','2014-04-16','13:15:00',8.06),('16100','2014-04-16','13:20:00',7.54),('16100','2014-04-16','13:25:00',5.81),('16100','2014-04-16','13:30:00',1.95),('16100','2014-04-16','13:35:00',2.2),('16100','2014-04-16','13:40:00',6.45),('16100','2014-04-16','13:45:00',5.47),('16100','2014-04-16','13:50:00',8.84),('16100','2014-04-16','13:55:00',9.09),('16100','2014-04-16','14:00:00',8.63),('16100','2014-04-16','14:05:00',8.61),('16100','2014-04-16','14:10:00',8.62),('16100','2014-04-16','14:15:00',8.72),('16100','2014-04-16','14:20:00',6.8),('16100','2014-04-16','14:25:00',8.11),('16100','2014-04-16','14:30:00',7.63),('16100','2014-04-16','14:35:00',6.15),('16100','2014-04-16','14:40:00',4.2),('16100','2014-04-16','14:45:00',1.97),('16100','2014-04-16','14:50:00',1.26),('16100','2014-04-16','14:55:00',1.01),('16100','2014-04-16','15:05:00',1.03),('16100','2014-04-16','15:10:00',1.28),('16100','2014-04-16','15:15:00',1.95),('16100','2014-04-16','15:20:00',2.53),('16100','2014-04-16','15:25:00',2.58),('16100','2014-04-16','15:30:00',2.68),('16100','2014-04-16','15:35:00',2.35),('16100','2014-04-16','15:40:00',1.81),('16100','2014-04-16','15:45:00',1.95),('16100','2014-04-16','15:50:00',2.04),('16100','2014-04-16','15:55:00',1.79),('16100','2014-04-16','16:00:00',1.34),('16100','2014-04-16','16:05:00',1.13),('16100','2014-04-16','16:10:00',1.12),('16100','2014-04-16','16:15:00',1.39),('16100','2014-04-16','16:20:00',1.82),('16100','2014-04-16','16:25:00',1.68),('16100','2014-04-16','16:30:00',1.69),('16100','2014-04-16','16:35:00',1.88),('16100','2014-04-16','16:40:00',2.02),('16100','2014-04-16','16:45:00',2.46),('16100','2014-04-16','16:50:00',1.99),('16100','2014-04-16','16:55:00',1.82),('16100','2014-04-16','17:00:00',1.71),('16100','2014-04-16','17:05:00',1.56),('16100','2014-04-16','17:10:00',1.57),('16100','2014-04-16','17:15:00',1.67),('16100','2014-04-16','17:20:00',1.66),('16100','2014-04-16','17:25:00',2.2),('16100','2014-04-16','17:30:00',2.39),('16100','2014-04-16','17:35:00',2.12),('16100','2014-04-16','17:40:00',1.69),('16100','2014-04-16','17:45:00',1.74),('16100','2014-04-16','17:50:00',1.07),('16100','2013-10-27','07:55:00',1.06),('16100','2013-10-27','08:00:00',1.18),('16100','2013-10-27','08:05:00',1.15),('16100','2013-10-27','08:20:00',1.04),('16100','2013-10-27','08:25:00',1.26),('16100','2013-10-27','08:30:00',1.89),('16100','2013-10-27','08:35:00',1.55),('16100','2013-10-27','08:40:00',2.7),('16100','2013-10-27','08:45:00',3.11),('16100','2013-10-27','08:50:00',2.94),('16100','2013-10-27','08:55:00',2.47),('16100','2013-10-27','09:00:00',1.19),('16100','2013-10-27','09:05:00',1.84),('16100','2013-10-27','09:10:00',2.9),('16100','2013-10-27','09:15:00',3.84),('16100','2013-10-27','09:20:00',3.71),('16100','2013-10-27','09:25:00',4.05),('16100','2013-10-27','09:30:00',4.23),('16100','2013-10-27','09:35:00',4.59),('16100','2013-10-27','09:40:00',5),('16100','2013-10-27','09:45:00',3.97),('16100','2013-10-27','09:50:00',1.59),('16100','2013-10-27','09:55:00',1.36),('16100','2013-10-27','10:00:00',1.33),('16100','2013-10-27','10:05:00',1.38),('16100','2013-10-27','10:10:00',1.51),('16100','2013-10-27','10:15:00',1.39),('16100','2013-10-27','10:20:00',1.29),('16100','2013-10-27','10:25:00',1.25),('16100','2013-10-27','10:35:00',4.96),('16100','2013-10-27','10:40:00',5.79),('16100','2013-10-27','10:45:00',5.71),('16100','2013-10-27','10:50:00',5.75),('16100','2013-10-27','10:55:00',5.77),('16100','2013-10-27','11:00:00',5.79),('16100','2013-10-27','11:05:00',5.82),('16100','2013-10-27','11:10:00',5.78),('16100','2013-10-27','11:15:00',5.84),('16100','2013-10-27','11:20:00',5.93),('16100','2013-10-27','11:25:00',5.21),('16100','2013-10-27','11:30:00',5.11),('16100','2013-10-27','11:35:00',5.83),('16100','2013-10-27','11:40:00',6),('16100','2013-10-27','11:45:00',5.97),('16100','2013-10-27','11:50:00',5.97),('16100','2013-10-27','11:55:00',6.04),('16100','2013-10-27','12:00:00',6.02),('16100','2013-10-27','12:05:00',6.07),('16100','2013-10-27','12:10:00',5.53),('16100','2013-10-27','12:15:00',4.36),('16100','2013-10-27','12:20:00',6.81),('16100','2013-10-27','12:25:00',6.3),('16100','2013-10-27','12:30:00',6.12),('16100','2013-10-27','12:35:00',5.91),('16100','2013-10-27','12:40:00',6.17),('16100','2013-10-27','12:45:00',6.11),('16100','2013-10-27','12:50:00',6),('16100','2013-10-27','12:55:00',5.93),('16100','2013-10-27','13:00:00',5.89),('16100','2013-10-27','13:05:00',5.8),('16100','2013-10-27','13:10:00',5.68),('16100','2013-10-27','13:15:00',5.66),('16100','2013-10-27','13:20:00',5.56),('16100','2013-10-27','13:25:00',5.26),('16100','2013-10-27','13:30:00',4.83),('16100','2013-10-27','13:35:00',5.45),('16100','2013-10-27','13:40:00',5.34),('16100','2013-10-27','13:45:00',5.26),('16100','2013-10-27','13:50:00',3.63),('16100','2013-10-27','13:55:00',3.97),('16100','2013-10-27','14:00:00',3.58),('16100','2013-10-27','14:05:00',4.91),('16100','2013-10-27','14:10:00',4.48),('16100','2013-10-27','14:15:00',4.92),('16100','2013-10-27','14:20:00',4.29),('16100','2013-10-27','14:25:00',4.19),('16100','2013-10-27','14:30:00',3.64),('16100','2013-10-27','14:35:00',4.01),('16100','2013-10-27','14:40:00',2.47),('16100','2013-10-27','14:45:00',3.7),('16100','2013-10-27','14:50:00',3.76),('16100','2013-10-27','14:55:00',3.64),('16100','2013-10-27','15:00:00',2.36),('16100','2013-10-27','15:05:00',1.66),('16100','2013-10-27','15:10:00',3.39),('16100','2013-10-27','15:15:00',1.7),('16100','2013-10-27','15:20:00',2.4),('16100','2013-10-27','15:25:00',1.31),('16100','2013-10-27','15:30:00',1.73),('16100','2013-10-27','15:35:00',1.63),('16100','2013-10-27','15:40:00',1.49),('16100','2013-10-27','16:05:00',1.18),('16100','2013-10-26','09:25:00',1.08),('16100','2013-10-26','09:30:00',1.36),('16100','2013-10-26','09:35:00',1.52),('16100','2013-10-26','09:40:00',1.49),('16100','2013-10-26','09:45:00',1.63),('16100','2013-10-26','09:50:00',1.58),('16100','2013-10-26','09:55:00',1.53),('16100','2013-10-26','10:00:00',1.53),('16100','2013-10-26','10:05:00',1.56),('16100','2013-10-26','10:10:00',1.6),('16100','2013-10-26','10:15:00',1.69),('16100','2013-10-26','10:20:00',1.99),('16100','2013-10-26','10:25:00',2.13),('16100','2013-10-26','10:30:00',2.25),('16100','2013-10-26','10:35:00',2.91),('16100','2013-10-26','10:40:00',2.67),('16100','2013-10-26','10:45:00',2.64),('16100','2013-10-26','10:50:00',2.15),('16100','2013-10-26','10:55:00',1.74),('16100','2013-10-26','11:00:00',1.53),('16100','2013-10-26','11:05:00',1.96),('16100','2013-10-26','11:10:00',2.27),('16100','2013-10-26','11:15:00',2.52),('16100','2013-10-26','11:20:00',2.65),('16100','2013-10-26','11:25:00',2.58),('16100','2013-10-26','11:30:00',2.46),('16100','2013-10-26','11:35:00',2.24),('16100','2013-10-26','11:40:00',2.27),('16100','2013-10-26','11:45:00',2.51),('16100','2013-10-26','11:50:00',2.33),('16100','2013-10-26','11:55:00',3.94),('16100','2013-10-26','12:00:00',5.16),('16100','2013-10-26','12:05:00',7.01),('16100','2013-10-26','12:10:00',3.74),('16100','2013-10-26','12:15:00',4.9),('16100','2013-10-26','12:20:00',3.33),('16100','2013-10-26','12:25:00',1.87),('16100','2013-10-26','12:30:00',2.8),('16100','2013-10-26','12:35:00',5.72),('16100','2013-10-26','12:40:00',6.38),('16100','2013-10-26','12:45:00',3.66),('16100','2013-10-26','12:50:00',4.11),('16100','2013-10-26','12:55:00',2.45),('16100','2013-10-26','13:00:00',1.61),('16100','2013-10-26','13:05:00',1.79),('16100','2013-10-26','13:10:00',2.41),('16100','2013-10-26','13:15:00',2.09),('16100','2013-10-26','13:20:00',3.99),('16100','2013-10-26','13:25:00',3.33),('16100','2013-10-26','13:40:00',1.26),('16100','2013-10-26','13:45:00',2.39),('16100','2013-10-26','13:50:00',2.24),('16100','2013-10-26','13:55:00',1.35),('16100','2013-10-26','14:00:00',1.39),('16100','2013-10-26','14:05:00',1.52),('16100','2013-10-26','14:10:00',1.75),('16100','2013-10-26','14:15:00',3.2),('16100','2013-10-26','14:20:00',4.25),('16100','2013-10-26','14:25:00',4.15),('16100','2013-10-26','14:30:00',3.96),('16100','2013-10-26','14:35:00',3.17),('16100','2013-10-26','14:40:00',4.11),('16100','2013-10-26','14:45:00',4.03),('16100','2013-10-26','14:50:00',2.68),('16100','2013-10-26','14:55:00',2.57),('16100','2013-10-26','15:00:00',3.05),('16100','2013-10-26','15:05:00',3.14),('16100','2013-10-26','15:10:00',2.94),('16100','2013-10-26','15:15:00',3.11),('16100','2013-10-26','15:20:00',3.12),('16100','2013-10-26','15:25:00',2.94),('16100','2013-10-26','15:30:00',2.54),('16100','2013-10-26','15:35:00',2.16),('16100','2013-10-26','15:45:00',1.63),('16100','2013-10-26','15:50:00',1.66),('16100','2013-10-26','15:55:00',1.32),('16100','2013-10-26','16:00:00',1.14),('16100','2013-10-26','16:05:00',1.06),('16100','2013-10-25','08:35:00',1.05),('16100','2013-10-25','08:40:00',1.23),('16100','2013-10-25','08:45:00',1.4),('16100','2013-10-25','08:50:00',1.57),('16100','2013-10-25','08:55:00',1.74),('16100','2013-10-25','09:00:00',1.91),('16100','2013-10-25','09:05:00',2.06),('16100','2013-10-25','09:10:00',2.22),('16100','2013-10-25','09:15:00',2.37),('16100','2013-10-25','09:20:00',2.51),('16100','2013-10-25','09:25:00',2.69),('16100','2013-10-25','09:30:00',2.82),('16100','2013-10-25','09:35:00',2.98),('16100','2013-10-25','09:40:00',3.13),('16100','2013-10-25','09:45:00',3.28),('16100','2013-10-25','09:50:00',3.37),('16100','2013-10-25','09:55:00',3.53),('16100','2013-10-25','10:00:00',3.66),('16100','2013-10-25','10:05:00',3.75),('16100','2013-10-25','10:10:00',3.9),('16100','2013-10-25','10:15:00',4.01),('16100','2013-10-25','10:20:00',4.11),('16100','2013-10-25','10:25:00',4.22),('16100','2013-10-25','10:30:00',4.35),('16100','2013-10-25','10:35:00',4.46),('16100','2013-10-25','10:40:00',4.65),('16100','2013-10-25','10:45:00',4.77),('16100','2013-10-25','10:50:00',4.82),('16100','2013-10-25','10:55:00',4.91),('16100','2013-10-25','11:00:00',5.02),('16100','2013-10-25','11:05:00',5.11),('16100','2013-10-25','11:10:00',5.18),('16100','2013-10-25','11:15:00',5.22),('16100','2013-10-25','11:20:00',5.28),('16100','2013-10-25','11:25:00',5.36),('16100','2013-10-25','11:30:00',5.41),('16100','2013-10-25','11:35:00',5.48),('16100','2013-10-25','11:40:00',5.53),('16100','2013-10-25','11:45:00',5.55),('16100','2013-10-25','11:50:00',5.6),('16100','2013-10-25','11:55:00',5.67),('16100','2013-10-25','12:00:00',5.7),('16100','2013-10-25','12:05:00',5.7),('16100','2013-10-25','12:10:00',5.69),('16100','2013-10-25','12:15:00',5.78),('16100','2013-10-25','12:20:00',5.88),('16100','2013-10-25','12:25:00',5.76),('16100','2013-10-25','12:30:00',5.71),('16100','2013-10-25','12:35:00',5.72),('16100','2013-10-25','12:40:00',5.63),('16100','2013-10-25','12:45:00',5.92),('16100','2013-10-25','12:50:00',5.79),('16100','2013-10-25','12:55:00',5.89),('16100','2013-10-25','13:00:00',5.73),('16100','2013-10-25','13:05:00',5.83),('16100','2013-10-25','13:10:00',5.72),('16100','2013-10-25','13:15:00',5.73),('16100','2013-10-25','13:20:00',5.59),('16100','2013-10-25','13:25:00',5.75),('16100','2013-10-25','13:30:00',5.65),('16100','2013-10-25','13:35:00',5.34),('16100','2013-10-25','13:40:00',5.55),('16100','2013-10-25','13:45:00',5.59),('16100','2013-10-25','13:50:00',5.49),('16100','2013-10-25','13:55:00',5.47),('16100','2013-10-25','14:00:00',5.27),('16100','2013-10-25','14:05:00',5.22),('16100','2013-10-25','14:10:00',5.38),('16100','2013-10-25','14:15:00',5.19),('16100','2013-10-25','14:20:00',5.24),('16100','2013-10-25','14:25:00',5.07),('16100','2013-10-25','14:30:00',4.92),('16100','2013-10-25','14:35:00',5),('16100','2013-10-25','14:40:00',4.74),('16100','2013-10-25','14:45:00',4.6),('16100','2013-10-25','14:50:00',4.59),('16100','2013-10-25','14:55:00',3.54),('16100','2013-10-25','15:00:00',4.13),('16100','2013-10-25','15:05:00',3.91),('16100','2013-10-25','15:10:00',3.31),('16100','2013-10-25','15:15:00',4.1),('16100','2013-10-25','15:20:00',3.97),('16100','2013-10-25','15:25:00',3.86),('16100','2013-10-25','15:30:00',3.54),('16100','2013-10-25','15:35:00',3.52),('16100','2013-10-25','15:40:00',3.46),('16100','2013-10-25','15:45:00',3.35),('16100','2013-10-25','15:50:00',3.32),('16100','2013-10-25','15:55:00',3.14),('16100','2013-10-25','16:00:00',2.91),('16100','2013-10-25','16:05:00',2.82),('16100','2013-10-25','16:10:00',2.64),('16100','2013-10-25','16:15:00',2.58),('16100','2013-10-25','16:20:00',2.45),('16100','2013-10-25','16:25:00',2.33),('16100','2013-10-25','16:30:00',2.1),('16100','2013-10-25','16:35:00',1.89),('16100','2013-10-25','16:40:00',1.73),('16100','2013-10-25','16:45:00',1.56),('16100','2013-10-25','16:50:00',1.43),('16100','2013-10-25','16:55:00',1.32),('16100','2013-10-25','17:00:00',1.18),('16100','2013-10-25','17:05:00',1.05),('16100','2013-10-24','08:35:00',1.04),('16100','2013-10-24','08:40:00',1.19),('16100','2013-10-24','08:45:00',1.36),('16100','2013-10-24','08:50:00',1.53),('16100','2013-10-24','08:55:00',1.69),('16100','2013-10-24','09:00:00',1.85),('16100','2013-10-24','09:05:00',2.05),('16100','2013-10-24','09:10:00',2.22),('16100','2013-10-24','09:15:00',2.32),('16100','2013-10-24','09:20:00',2.38),('16100','2013-10-24','09:25:00',2.64),('16100','2013-10-24','09:30:00',2.83),('16100','2013-10-24','09:35:00',3),('16100','2013-10-24','09:40:00',3.08),('16100','2013-10-24','09:45:00',3.17),('16100','2013-10-24','09:50:00',3.37),('16100','2013-10-24','09:55:00',3.49),('16100','2013-10-24','10:00:00',3.62),('16100','2013-10-24','10:05:00',3.71),('16100','2013-10-24','10:10:00',3.91),('16100','2013-10-24','10:15:00',4.02),('16100','2013-10-24','10:20:00',4.18),('16100','2013-10-24','10:25:00',4.28),('16100','2013-10-24','10:30:00',4.38),('16100','2013-10-24','10:35:00',4.55),('16100','2013-10-24','10:40:00',4.69),('16100','2013-10-24','10:45:00',4.76),('16100','2013-10-24','10:50:00',4.82),('16100','2013-10-24','10:55:00',4.99),('16100','2013-10-24','11:00:00',5.08),('16100','2013-10-24','11:05:00',5.22),('16100','2013-10-24','11:10:00',5.37),('16100','2013-10-24','11:15:00',5.38),('16100','2013-10-24','11:20:00',5.43),('16100','2013-10-24','11:25:00',5.49),('16100','2013-10-24','11:30:00',5.59),('16100','2013-10-24','11:35:00',5.67),('16100','2013-10-24','11:40:00',5.69),('16100','2013-10-24','11:45:00',5.78),('16100','2013-10-24','11:50:00',5.77),('16100','2013-10-24','11:55:00',5.88),('16100','2013-10-24','12:00:00',5.86),('16100','2013-10-24','12:05:00',5.9),('16100','2013-10-24','12:10:00',6),('16100','2013-10-24','12:15:00',5.99),('16100','2013-10-24','12:20:00',5.98),('16100','2013-10-24','12:25:00',5.97),('16100','2013-10-24','12:30:00',6.02),('16100','2013-10-24','12:35:00',6.03),('16100','2013-10-24','12:40:00',6.07),('16100','2013-10-24','12:45:00',6.08),('16100','2013-10-24','12:50:00',6.11),('16100','2013-10-24','12:55:00',6.15),('16100','2013-10-24','13:00:00',6.13),('16100','2013-10-24','13:05:00',6.07),('16100','2013-10-24','13:10:00',6.05),('16100','2013-10-24','13:15:00',6.02),('16100','2013-10-24','13:20:00',6.04),('16100','2013-10-24','13:25:00',6.02),('16100','2013-10-24','13:30:00',6.01),('16100','2013-10-24','13:35:00',6.02),('16100','2013-10-24','13:40:00',5.92),('16100','2013-10-24','13:45:00',5.91),('16100','2013-10-24','13:50:00',5.84),('16100','2013-10-24','13:55:00',5.76),('16100','2013-10-24','14:00:00',5.74),('16100','2013-10-24','14:05:00',5.69),('16100','2013-10-24','14:10:00',5.58),('16100','2013-10-24','14:15:00',5.51),('16100','2013-10-24','14:20:00',4.62),('16100','2013-10-24','14:25:00',5.15),('16100','2013-10-24','14:30:00',5.25),('16100','2013-10-24','14:35:00',5.11),('16100','2013-10-24','14:40:00',5.07),('16100','2013-10-24','14:45:00',5.01),('16100','2013-10-24','14:50:00',4.96),('16100','2013-10-24','14:55:00',4.81),('16100','2013-10-24','15:00:00',4.74),('16100','2013-10-24','15:05:00',4.65),('16100','2013-10-24','15:10:00',4.57),('16100','2013-10-24','15:15:00',4.44),('16100','2013-10-24','15:20:00',4.2),('16100','2013-10-24','15:25:00',4.1),('16100','2013-10-24','15:30:00',4.04),('16100','2013-10-24','15:35:00',3.92),('16100','2013-10-24','15:40:00',3.86),('16100','2013-10-24','15:45:00',3.77),('16100','2013-10-24','15:50:00',3.66),('16100','2013-10-24','15:55:00',3.54),('16100','2013-10-24','16:00:00',3.41),('16100','2013-10-24','16:05:00',3.24),('16100','2013-10-24','16:10:00',3.1),('16100','2013-10-24','16:15:00',3.02),('16100','2013-10-24','16:20:00',2.87),('16100','2013-10-24','16:25:00',2.73),('16100','2013-10-24','16:30:00',2.55),('16100','2013-10-24','16:35:00',2.36),('16100','2013-10-24','16:40:00',2.19),('16100','2013-10-24','16:45:00',2.04),('16100','2013-10-24','16:50:00',1.87),('16100','2013-10-24','16:55:00',1.7),('16100','2013-10-24','17:00:00',1.54),('16100','2013-10-24','17:05:00',1.38),('16100','2013-10-24','17:10:00',1.21),('16100','2013-10-24','17:15:00',1.04),('16100','2013-10-23','08:50:00',1.12),('16100','2013-10-23','09:00:00',2.16),('16100','2013-10-23','09:05:00',2.45),('16100','2013-10-23','09:10:00',2.49),('16100','2013-10-23','09:15:00',1.41),('16100','2013-10-23','09:20:00',1.42),('16100','2013-10-23','09:25:00',1.57),('16100','2013-10-23','09:30:00',1.79),('16100','2013-10-23','09:35:00',1.71),('16100','2013-10-23','09:40:00',1.72),('16100','2013-10-23','09:45:00',1.8),('16100','2013-10-23','09:50:00',1.74),('16100','2013-10-23','09:55:00',1.63),('16100','2013-10-23','10:00:00',1.49),('16100','2013-10-23','10:05:00',1.38),('16100','2013-10-23','10:10:00',1.44),('16100','2013-10-23','10:15:00',1.1),('16100','2013-10-23','10:20:00',1.11),('16100','2013-10-23','10:25:00',1.31),('16100','2013-10-23','10:30:00',3.09),('16100','2013-10-23','10:35:00',4.65),('16100','2013-10-23','10:40:00',6.21),('16100','2013-10-23','10:45:00',5.22),('16100','2013-10-23','10:50:00',5.5),('16100','2013-10-23','10:55:00',3.63),('16100','2013-10-23','11:00:00',4.66),('16100','2013-10-23','11:05:00',2.38),('16100','2013-10-23','11:10:00',2.88),('16100','2013-10-23','11:15:00',2.47),('16100','2013-10-23','11:20:00',3.81),('16100','2013-10-23','11:25:00',1.92),('16100','2013-10-23','11:30:00',2.12),('16100','2013-10-23','11:35:00',4.62),('16100','2013-10-23','11:40:00',6.28),('16100','2013-10-23','11:45:00',5.72),('16100','2013-10-23','11:50:00',6.6),('16100','2013-10-23','11:55:00',4.55),('16100','2013-10-23','12:00:00',2.23),('16100','2013-10-23','12:05:00',2.26),('16100','2013-10-23','12:10:00',2.4),('16100','2013-10-23','12:15:00',2.69),('16100','2013-10-23','12:20:00',3.53),('16100','2013-10-23','12:25:00',3.38),('16100','2013-10-23','12:30:00',3.35),('16100','2013-10-23','12:35:00',3.47),('16100','2013-10-23','12:40:00',2.98),('16100','2013-10-23','12:45:00',3.07),('16100','2013-10-23','12:50:00',3.05),('16100','2013-10-23','12:55:00',3.25),('16100','2013-10-23','13:00:00',2.72),('16100','2013-10-23','13:05:00',2.44),('16100','2013-10-23','13:10:00',2.29),('16100','2013-10-23','13:15:00',2.33),('16100','2013-10-23','13:20:00',2.18),('16100','2013-10-23','13:25:00',2.09),('16100','2013-10-23','13:30:00',2.08),('16100','2013-10-23','13:35:00',2.07),('16100','2013-10-23','13:40:00',2.09),('16100','2013-10-23','13:45:00',2.26),('16100','2013-10-23','13:50:00',3.37),('16100','2013-10-23','13:55:00',2.58),('16100','2013-10-23','14:00:00',2.22),('16100','2013-10-23','14:05:00',2.5),('16100','2013-10-23','14:10:00',2.43),('16100','2013-10-23','14:15:00',2.52),('16100','2013-10-23','14:20:00',2.48),('16100','2013-10-23','14:25:00',2.62),('16100','2013-10-23','14:30:00',3.24),('16100','2013-10-23','14:35:00',4.12),('16100','2013-10-23','14:40:00',3.36),('16100','2013-10-23','14:45:00',2.95),('16100','2013-10-23','14:50:00',1.37),('16100','2013-10-23','14:55:00',1.55),('16100','2013-10-23','15:00:00',2.26),('16100','2013-10-23','15:05:00',3),('16100','2013-10-23','15:10:00',2.05),('16100','2013-10-23','15:15:00',2.6),('16100','2013-10-23','15:20:00',1.81),('16100','2013-10-23','15:25:00',2.58),('16100','2013-10-23','15:30:00',3.14),('16100','2013-10-23','15:35:00',4.86),('16100','2013-10-23','15:40:00',4.76),('16100','2013-10-23','15:45:00',4.02),('16100','2013-10-23','15:50:00',1.75),('16100','2013-10-23','15:55:00',1.42),('16100','2013-10-23','16:00:00',1.24),('16100','2013-10-23','16:05:00',1.18),('16100','2013-10-23','16:10:00',1.15),('16100','2013-10-23','16:15:00',1.09),('16100','2013-10-22','09:45:00',1.24),('16100','2013-10-22','09:50:00',1.44),('16100','2013-10-22','09:55:00',1.31),('16100','2013-10-22','10:00:00',1.07),('16100','2013-10-22','10:05:00',1.12),('16100','2013-10-22','10:10:00',1.17),('16100','2013-10-22','10:15:00',1.24),('16100','2013-10-22','10:20:00',1.31),('16100','2013-10-22','10:25:00',1.59),('16100','2013-10-22','10:30:00',1.63),('16100','2013-10-22','10:35:00',2.28),('16100','2013-10-22','10:40:00',1.97),('16100','2013-10-22','10:45:00',2.39),('16100','2013-10-22','10:50:00',2.23),('16100','2013-10-22','10:55:00',3.49),('16100','2013-10-22','11:00:00',5.4),('16100','2013-10-22','11:05:00',5.16),('16100','2013-10-22','11:10:00',5.35),('16100','2013-10-22','11:15:00',5.35),('16100','2013-10-22','11:20:00',5.25),('16100','2013-10-22','11:25:00',5.42),('16100','2013-10-22','11:30:00',5.48),('16100','2013-10-22','11:35:00',5.58),('16100','2013-10-22','11:40:00',5.5),('16100','2013-10-22','11:45:00',5.56),('16100','2013-10-22','11:50:00',5.53),('16100','2013-10-22','11:55:00',5.3),('16100','2013-10-22','12:00:00',5.81),('16100','2013-10-22','12:05:00',5.76),('16100','2013-10-22','12:10:00',5.69),('16100','2013-10-22','12:15:00',5.71),('16100','2013-10-22','12:20:00',4.51),('16100','2013-10-22','12:25:00',5.72),('16100','2013-10-22','12:30:00',5.79),('16100','2013-10-22','12:35:00',5.66),('16100','2013-10-22','12:40:00',5.11),('16100','2013-10-22','12:45:00',5.93),('16100','2013-10-22','12:50:00',5.9),('16100','2013-10-22','12:55:00',5.8),('16100','2013-10-22','13:00:00',5.89),('16100','2013-10-22','13:05:00',5.65),('16100','2013-10-22','13:10:00',5.7),('16100','2013-10-22','13:15:00',5.76),('16100','2013-10-22','13:20:00',5.77),('16100','2013-10-22','13:25:00',5.71),('16100','2013-10-22','13:30:00',5.68),('16100','2013-10-22','13:35:00',5.49),('16100','2013-10-22','13:40:00',5.56),('16100','2013-10-22','13:45:00',5.69),('16100','2013-10-22','13:50:00',5.63),('16100','2013-10-22','13:55:00',5.56),('16100','2013-10-22','14:00:00',5.51),('16100','2013-10-22','14:05:00',5.36),('16100','2013-10-22','14:10:00',5.31),('16100','2013-10-22','14:15:00',5.25),('16100','2013-10-22','14:20:00',5.07),('16100','2013-10-22','14:25:00',5),('16100','2013-10-22','14:30:00',4.87),('16100','2013-10-22','14:35:00',4.68),('16100','2013-10-22','14:40:00',4.42),('16100','2013-10-22','14:45:00',4.15),('16100','2013-10-22','14:50:00',4.21),('16100','2013-10-22','14:55:00',4.4),('16100','2013-10-22','15:00:00',4.25),('16100','2013-10-22','15:05:00',4.04),('16100','2013-10-22','15:10:00',3.69),('16100','2013-10-22','15:15:00',3.76),('16100','2013-10-22','15:20:00',3.88),('16100','2013-10-22','15:25:00',3.57),('16100','2013-10-22','15:30:00',3.11),('16100','2013-10-22','15:35:00',3.42),('16100','2013-10-22','15:40:00',3.89),('16100','2013-10-22','15:45:00',3.82),('16100','2013-10-22','15:50:00',3.46),('16100','2013-10-22','15:55:00',2.4),('16100','2013-10-22','16:00:00',1.79),('16100','2013-10-22','16:05:00',1.66),('16100','2013-10-22','16:10:00',1.67),('16100','2013-10-22','16:15:00',1.8),('16100','2013-10-22','16:20:00',2.06),('16100','2013-10-22','16:25:00',1.93),('16100','2013-10-22','16:30:00',2.2),('16100','2013-10-22','16:35:00',2.3),('16100','2013-10-22','16:40:00',2.03),('16100','2013-10-22','16:45:00',1.65),('16100','2013-10-22','16:50:00',1.44),('16100','2013-10-22','16:55:00',1.43),('16100','2013-10-22','17:00:00',1.23),('16100','2013-10-21','08:35:00',1.06),('16100','2013-10-21','08:40:00',1.21),('16100','2013-10-21','08:45:00',1.38),('16100','2013-10-21','08:50:00',1.57),('16100','2013-10-21','08:55:00',1.72),('16100','2013-10-21','09:00:00',1.87),('16100','2013-10-21','09:05:00',2.02),('16100','2013-10-21','09:10:00',2.18),('16100','2013-10-21','09:15:00',2.34),('16100','2013-10-21','09:20:00',2.5),('16100','2013-10-21','09:25:00',2.68),('16100','2013-10-21','09:30:00',2.83),('16100','2013-10-21','09:35:00',2.98),('16100','2013-10-21','09:40:00',3.15),('16100','2013-10-21','09:45:00',3.29),('16100','2013-10-21','09:50:00',3.43),('16100','2013-10-21','09:55:00',3.52),('16100','2013-10-21','10:00:00',3.67),('16100','2013-10-21','10:05:00',3.75),('16100','2013-10-21','10:10:00',3.85),('16100','2013-10-21','10:15:00',3.99),('16100','2013-10-21','10:20:00',4.07),('16100','2013-10-21','10:25:00',4.21),('16100','2013-10-21','10:30:00',4.3),('16100','2013-10-21','10:35:00',4.4),('16100','2013-10-21','10:40:00',4.5),('16100','2013-10-21','10:45:00',4.61),('16100','2013-10-21','10:50:00',4.59),('16100','2013-10-21','10:55:00',4.67),('16100','2013-10-21','11:00:00',4.79),('16100','2013-10-21','11:05:00',4.96),('16100','2013-10-21','11:10:00',5.07),('16100','2013-10-21','11:15:00',5.11),('16100','2013-10-21','11:20:00',5.16),('16100','2013-10-21','11:25:00',5.21),('16100','2013-10-21','11:30:00',5.25),('16100','2013-10-21','11:35:00',5.29),('16100','2013-10-21','11:40:00',5.3),('16100','2013-10-21','11:45:00',5.45),('16100','2013-10-21','11:50:00',5.59),('16100','2013-10-21','11:55:00',5.56),('16100','2013-10-21','12:00:00',5.61),('16100','2013-10-21','12:05:00',5.61),('16100','2013-10-21','12:10:00',5.6),('16100','2013-10-21','12:15:00',5.5),('16100','2013-10-21','12:20:00',5.57),('16100','2013-10-21','12:25:00',5.77),('16100','2013-10-21','12:30:00',5.6),('16100','2013-10-21','12:35:00',5.63),('16100','2013-10-21','12:40:00',5.72),('16100','2013-10-21','12:45:00',5.76),('16100','2013-10-21','12:50:00',5.77),('16100','2013-10-21','12:55:00',5.82),('16100','2013-10-21','13:00:00',5.64),('16100','2013-10-21','13:05:00',5.48),('16100','2013-10-21','13:10:00',5.68),('16100','2013-10-21','13:15:00',5.78),('16100','2013-10-21','13:20:00',5.8),('16100','2013-10-21','13:25:00',5.48),('16100','2013-10-21','13:30:00',5.63),('16100','2013-10-21','13:35:00',5.6),('16100','2013-10-21','13:40:00',5.58),('16100','2013-10-21','13:45:00',5.52),('16100','2013-10-21','13:50:00',5.53),('16100','2013-10-21','13:55:00',5.54),('16100','2013-10-21','14:00:00',5.37),('16100','2013-10-21','14:05:00',5.53),('16100','2013-10-21','14:10:00',5.66),('16100','2013-10-21','14:15:00',4.32),('16100','2013-10-21','14:20:00',2.92),('16100','2013-10-21','14:25:00',5.06),('16100','2013-10-21','14:30:00',5.07),('16100','2013-10-21','14:35:00',5.1),('16100','2013-10-21','14:40:00',5.2),('16100','2013-10-21','14:45:00',5.03),('16100','2013-10-21','14:50:00',4.75),('16100','2013-10-21','14:55:00',4.61),('16100','2013-10-21','15:00:00',4.51),('16100','2013-10-21','15:05:00',4.42),('16100','2013-10-21','15:10:00',4.29),('16100','2013-10-21','15:15:00',4.09),('16100','2013-10-21','15:20:00',4.04),('16100','2013-10-21','15:25:00',3.29),('16100','2013-10-21','15:30:00',3.9),('16100','2013-10-21','15:35:00',3.13),('16100','2013-10-21','15:40:00',3.19),('16100','2013-10-21','15:45:00',3.52),('16100','2013-10-21','15:50:00',3.4),('16100','2013-10-21','15:55:00',3.34),('16100','2013-10-21','16:00:00',3.13),('16100','2013-10-21','16:05:00',2.97),('16100','2013-10-21','16:10:00',2.83),('16100','2013-10-21','16:15:00',2.69),('16100','2013-10-21','16:20:00',2.61),('16100','2013-10-21','16:25:00',2.42),('16100','2013-10-21','16:30:00',2.29),('16100','2013-10-21','16:35:00',2.14),('16100','2013-10-21','16:40:00',1.99),('16100','2013-10-21','16:45:00',1.83),('16100','2013-10-21','16:50:00',1.69),('16100','2013-10-21','16:55:00',1.53),('16100','2013-10-21','17:00:00',1.36),('16100','2013-10-21','17:05:00',1.21),('16100','2013-10-21','17:10:00',1.09),('16100','2013-10-20','08:40:00',1.15),('16100','2013-10-20','08:45:00',1.25),('16100','2013-10-20','08:50:00',1.16),('16100','2013-10-20','08:55:00',1.26),('16100','2013-10-20','09:00:00',1.1),('16100','2013-10-20','09:05:00',1.69),('16100','2013-10-20','09:10:00',2.14),('16100','2013-10-20','09:15:00',2.62),('16100','2013-10-20','09:20:00',2.69),('16100','2013-10-20','09:25:00',2.74),('16100','2013-10-20','09:30:00',2.6),('16100','2013-10-20','09:35:00',2.67),('16100','2013-10-20','09:40:00',2.97),('16100','2013-10-20','09:45:00',2.86),('16100','2013-10-20','09:50:00',3.06),('16100','2013-10-20','09:55:00',3.51),('16100','2013-10-20','10:00:00',3.75),('16100','2013-10-20','10:05:00',3.72),('16100','2013-10-20','10:10:00',3.96),('16100','2013-10-20','10:15:00',4.22),('16100','2013-10-20','10:20:00',4.32),('16100','2013-10-20','10:25:00',4.52),('16100','2013-10-20','10:30:00',4.35),('16100','2013-10-20','10:35:00',4.56),('16100','2013-10-20','10:40:00',4.64),('16100','2013-10-20','10:45:00',4.74),('16100','2013-10-20','10:50:00',5),('16100','2013-10-20','10:55:00',5.09),('16100','2013-10-20','11:00:00',4.92),('16100','2013-10-20','11:05:00',5.26),('16100','2013-10-20','11:10:00',5.37),('16100','2013-10-20','11:15:00',5.39),('16100','2013-10-20','11:20:00',5.37),('16100','2013-10-20','11:25:00',5.47),('16100','2013-10-20','11:30:00',5.65),('16100','2013-10-20','11:35:00',5.6),('16100','2013-10-20','11:40:00',5.66),('16100','2013-10-20','11:45:00',5.74),('16100','2013-10-20','11:50:00',5.68),('16100','2013-10-20','11:55:00',5.84),('16100','2013-10-20','12:00:00',5.88),('16100','2013-10-20','12:05:00',5.87),('16100','2013-10-20','12:10:00',5.88),('16100','2013-10-20','12:15:00',5.94),('16100','2013-10-20','12:20:00',5.98),('16100','2013-10-20','12:25:00',5.9),('16100','2013-10-20','12:30:00',6.01),('16100','2013-10-20','12:35:00',6.03),('16100','2013-10-20','12:40:00',5.9),('16100','2013-10-20','12:45:00',5.88),('16100','2013-10-20','12:50:00',5.98),('16100','2013-10-20','12:55:00',5.85),('16100','2013-10-20','13:00:00',5.86),('16100','2013-10-20','13:05:00',5.54),('16100','2013-10-20','13:10:00',5.82),('16100','2013-10-20','13:15:00',5.71),('16100','2013-10-20','13:20:00',5.6),('16100','2013-10-20','13:25:00',5.86),('16100','2013-10-20','13:30:00',5.83),('16100','2013-10-20','13:35:00',5.81),('16100','2013-10-20','13:40:00',5.98),('16100','2013-10-20','13:45:00',5.96),('16100','2013-10-20','13:50:00',5.63),('16100','2013-10-20','13:55:00',5.45),('16100','2013-10-20','14:00:00',5.79),('16100','2013-10-20','14:05:00',5.69),('16100','2013-10-20','14:10:00',5.63),('16100','2013-10-20','14:15:00',5.56),('16100','2013-10-20','14:20:00',5.54),('16100','2013-10-20','14:25:00',5.46),('16100','2013-10-20','14:30:00',5.4),('16100','2013-10-20','14:35:00',5.26),('16100','2013-10-20','14:40:00',5.17),('16100','2013-10-20','14:45:00',5.08),('16100','2013-10-20','14:50:00',4.95),('16100','2013-10-20','14:55:00',4.78),('16100','2013-10-20','15:00:00',4.73),('16100','2013-10-20','15:05:00',4.64),('16100','2013-10-20','15:10:00',4.53),('16100','2013-10-20','15:15:00',4.28),('16100','2013-10-20','15:20:00',4.33),('16100','2013-10-20','15:25:00',4.28),('16100','2013-10-20','15:30:00',4.16),('16100','2013-10-20','15:35:00',4.04),('16100','2013-10-20','15:40:00',3.88),('16100','2013-10-20','15:45:00',3.75),('16100','2013-10-20','15:50:00',3.65),('16100','2013-10-20','15:55:00',3.47),('16100','2013-10-20','16:00:00',3.36),('16100','2013-10-20','16:05:00',3.29),('16100','2013-10-20','16:10:00',3.19),('16100','2013-10-20','16:15:00',3.04),('16100','2013-10-20','16:20:00',2.74),('16100','2013-10-20','16:25:00',2.58),('16100','2013-10-20','16:30:00',2.44),('16100','2013-10-20','16:35:00',2.33),('16100','2013-10-20','16:40:00',2.23),('16100','2013-10-20','16:45:00',2.09),('16100','2013-10-20','16:50:00',1.69),('16100','2013-10-20','16:55:00',1.49),('16100','2013-10-20','17:00:00',1.5),('16100','2013-10-20','17:05:00',1.47),('16100','2013-10-20','17:10:00',1.38),('16100','2013-10-20','17:15:00',1.2),('16100','2013-10-19','08:25:00',1.15),('16100','2013-10-19','08:30:00',1.25),('16100','2013-10-19','08:35:00',1),('16100','2013-10-19','08:45:00',1.86),('16100','2013-10-19','08:50:00',1.99),('16100','2013-10-19','08:55:00',1.97),('16100','2013-10-19','09:00:00',2.12),('16100','2013-10-19','09:05:00',2.25),('16100','2013-10-19','09:10:00',2.45),('16100','2013-10-19','09:15:00',2.64),('16100','2013-10-19','09:20:00',2.78),('16100','2013-10-19','09:25:00',2.95),('16100','2013-10-19','09:30:00',3.12),('16100','2013-10-19','09:35:00',3.21),('16100','2013-10-19','09:40:00',3.37),('16100','2013-10-19','09:45:00',3.53),('16100','2013-10-19','09:50:00',3.67),('16100','2013-10-19','09:55:00',3.85),('16100','2013-10-19','10:00:00',3.97),('16100','2013-10-19','10:05:00',4.12),('16100','2013-10-19','10:10:00',4.24),('16100','2013-10-19','10:15:00',4.38),('16100','2013-10-19','10:20:00',4.51),('16100','2013-10-19','10:25:00',4.59),('16100','2013-10-19','10:30:00',4.67),('16100','2013-10-19','10:35:00',4.82),('16100','2013-10-19','10:40:00',4.93),('16100','2013-10-19','10:45:00',5),('16100','2013-10-19','10:50:00',5.11),('16100','2013-10-19','10:55:00',5.19),('16100','2013-10-19','11:00:00',5.28),('16100','2013-10-19','11:05:00',5.39),('16100','2013-10-19','11:10:00',5.47),('16100','2013-10-19','11:15:00',5.57),('16100','2013-10-19','11:20:00',5.66),('16100','2013-10-19','11:25:00',5.68),('16100','2013-10-19','11:30:00',5.79),('16100','2013-10-19','11:35:00',5.78),('16100','2013-10-19','11:40:00',5.88),('16100','2013-10-19','11:45:00',5.94),('16100','2013-10-19','11:50:00',5.93),('16100','2013-10-19','11:55:00',5.94),('16100','2013-10-19','12:00:00',6.11),('16100','2013-10-19','12:05:00',6.09),('16100','2013-10-19','12:10:00',6.07),('16100','2013-10-19','12:15:00',6.22),('16100','2013-10-19','12:20:00',5.98),('16100','2013-10-19','12:25:00',3.46),('16100','2013-10-19','12:30:00',4.65),('16100','2013-10-19','12:35:00',2.65),('16100','2013-10-19','12:40:00',4.28),('16100','2013-10-19','12:45:00',3.38),('16100','2013-10-19','12:50:00',4.12),('16100','2013-10-19','12:55:00',2.25),('16100','2013-10-19','13:00:00',3.54),('16100','2013-10-19','13:05:00',3.12),('16100','2013-10-19','13:10:00',3.15),('16100','2013-10-19','13:15:00',2.49),('16100','2013-10-19','13:20:00',3.26),('16100','2013-10-19','13:25:00',4.97),('16100','2013-10-19','13:30:00',6.49),('16100','2013-10-19','13:35:00',1.95),('16100','2013-10-19','13:40:00',6.39),('16100','2013-10-19','13:45:00',6.36),('16100','2013-10-19','13:50:00',6.37),('16100','2013-10-19','13:55:00',2.07),('16100','2013-10-19','14:00:00',5.93),('16100','2013-10-19','14:05:00',6.18),('16100','2013-10-19','14:10:00',6.09),('16100','2013-10-19','14:15:00',5.98),('16100','2013-10-19','14:20:00',5.39),('16100','2013-10-19','14:25:00',6.07),('16100','2013-10-19','14:30:00',5.88),('16100','2013-10-19','14:35:00',5.6),('16100','2013-10-19','14:40:00',5.58),('16100','2013-10-19','14:45:00',5.5),('16100','2013-10-19','15:20:00',1.03),('16100','2013-10-19','15:25:00',3.51),('16100','2013-10-19','15:30:00',1.33),('16100','2013-10-19','15:55:00',1.19),('16100','2013-10-19','16:00:00',1.93),('16100','2013-10-19','16:05:00',3.65),('16100','2013-10-19','16:10:00',3.53),('16100','2013-10-19','16:15:00',3.58),('16100','2013-10-19','16:20:00',3.61),('16100','2013-10-19','16:25:00',3.53),('16100','2013-10-19','16:30:00',3.55),('16100','2013-10-19','16:35:00',3.4),('16100','2013-10-19','16:40:00',3.08),('16100','2013-10-19','16:45:00',2.6),('16100','2013-10-19','16:50:00',2.34),('16100','2013-10-19','16:55:00',2.07),('16100','2013-10-19','17:00:00',1.87),('16100','2013-10-19','17:05:00',1.67),('16100','2013-10-19','17:10:00',1.48),('16100','2013-10-19','17:15:00',1.3),('16100','2013-10-19','17:20:00',1.11),('16100','2013-10-18','08:20:00',1.01),('16100','2013-10-18','08:30:00',1.32),('16100','2013-10-18','08:35:00',1.58),('16100','2013-10-18','08:40:00',1.74),('16100','2013-10-18','08:45:00',1.96),('16100','2013-10-18','08:50:00',2.22),('16100','2013-10-18','08:55:00',2.49),('16100','2013-10-18','09:00:00',2.66),('16100','2013-10-18','09:05:00',2.47),('16100','2013-10-18','09:10:00',3.18),('16100','2013-10-18','09:15:00',3.38),('16100','2013-10-18','09:20:00',3.51),('16100','2013-10-18','09:25:00',3.64),('16100','2013-10-18','09:30:00',3.79),('16100','2013-10-18','09:35:00',3.9),('16100','2013-10-18','09:40:00',4.05),('16100','2013-10-18','09:45:00',3.97),('16100','2013-10-18','09:50:00',4.24),('16100','2013-10-18','09:55:00',4.51),('16100','2013-10-18','10:00:00',4.47),('16100','2013-10-18','10:05:00',4.55),('16100','2013-10-18','10:10:00',4.63),('16100','2013-10-18','10:15:00',4.89),('16100','2013-10-18','10:20:00',5),('16100','2013-10-18','10:25:00',5.24),('16100','2013-10-18','10:30:00',5.3),('16100','2013-10-18','10:35:00',5.35),('16100','2013-10-18','10:40:00',5.39),('16100','2013-10-18','10:45:00',5.54),('16100','2013-10-18','10:50:00',5.56),('16100','2013-10-18','10:55:00',5.71),('16100','2013-10-18','11:00:00',4.03),('16100','2013-10-18','11:05:00',3.55),('16100','2013-10-18','11:10:00',5.31),('16100','2013-10-18','11:15:00',5.74),('16100','2013-10-18','11:20:00',6.37),('16100','2013-10-18','11:25:00',6.28),('16100','2013-10-18','11:30:00',6.31),('16100','2013-10-18','11:35:00',6.28),('16100','2013-10-18','11:40:00',6.39),('16100','2013-10-18','11:45:00',5.41),('16100','2013-10-18','11:50:00',6.2),('16100','2013-10-18','11:55:00',6.53),('16100','2013-10-18','12:00:00',6.5),('16100','2013-10-18','12:05:00',6.46),('16100','2013-10-18','12:10:00',6.5),('16100','2013-10-18','12:15:00',6.48),('16100','2013-10-18','12:20:00',6.38),('16100','2013-10-18','12:25:00',6.81),('16100','2013-10-18','12:30:00',6.7),('16100','2013-10-18','12:35:00',6.76),('16100','2013-10-18','12:40:00',7.15),('16100','2013-10-18','12:45:00',7.27),('16100','2013-10-18','12:50:00',7.47),('16100','2013-10-18','12:55:00',5.27),('16100','2013-10-18','13:00:00',5.57),('16100','2013-10-18','13:05:00',7.46),('16100','2013-10-18','13:10:00',5.64),('16100','2013-10-18','13:15:00',6.14),('16100','2013-10-18','13:20:00',5.38),('16100','2013-10-18','13:25:00',5.17),('16100','2013-10-18','13:30:00',5.3),('16100','2013-10-18','13:35:00',5.52),('16100','2013-10-18','13:40:00',6.37),('16100','2013-10-18','13:45:00',6.72),('16100','2013-10-18','13:50:00',6.49),('16100','2013-10-18','13:55:00',5),('16100','2013-10-18','14:00:00',4.93),('16100','2013-10-18','14:05:00',5.96),('16100','2013-10-18','14:10:00',6.03),('16100','2013-10-18','14:15:00',4.5),('16100','2013-10-18','14:20:00',4.75),('16100','2013-10-18','14:25:00',5.83),('16100','2013-10-18','14:30:00',6.55),('16100','2013-10-18','14:35:00',6.38),('16100','2013-10-18','14:40:00',6.08),('16100','2013-10-18','14:45:00',5.78),('16100','2013-10-18','14:50:00',5.57),('16100','2013-10-18','14:55:00',5.41),('16100','2013-10-18','15:00:00',5.25),('16100','2013-10-18','15:05:00',5.3),('16100','2013-10-18','15:10:00',4.92),('16100','2013-10-18','15:15:00',4.84),('16100','2013-10-18','15:20:00',4.68),('16100','2013-10-18','15:25:00',4.67),('16100','2013-10-18','15:30:00',4.39),('16100','2013-10-18','15:35:00',4),('16100','2013-10-18','15:40:00',3.55),('16100','2013-10-18','15:45:00',4.33),('16100','2013-10-18','15:50:00',4.38),('16100','2013-10-18','15:55:00',4.11),('16100','2013-10-18','16:00:00',3.72),('16100','2013-10-18','16:05:00',3.94),('16100','2013-10-18','16:10:00',3.89),('16100','2013-10-18','16:15:00',2.28),('16100','2013-10-18','16:20:00',2.86),('16100','2013-10-18','16:25:00',3.32),('16100','2013-10-18','16:30:00',3.41),('16100','2013-10-18','16:35:00',3.09),('16100','2013-10-18','16:40:00',2.98),('16100','2013-10-18','16:45:00',2.33),('16100','2013-10-18','16:50:00',1.71),('16100','2013-10-18','16:55:00',1.9),('16100','2013-10-18','17:00:00',1.19),('16100','2013-10-18','17:05:00',1.58),('16100','2013-10-18','17:10:00',1.5),('16100','2013-10-18','17:15:00',1.78),('16100','2013-10-18','17:20:00',1.19),('16100','2014-05-03','07:45:00',1.08),('16100','2014-05-03','07:50:00',1.05),('16100','2014-05-03','07:55:00',1.27),('16100','2014-05-03','08:00:00',1.13),('16100','2014-05-03','08:05:00',1.62),('16100','2014-05-03','08:10:00',1.74),('16100','2014-05-03','08:15:00',1.53),('16100','2014-05-03','08:20:00',2.14),('16100','2014-05-03','08:25:00',1.91),('16100','2014-05-03','08:30:00',2.62),('16100','2014-05-03','08:35:00',1.44),('16100','2014-05-03','08:40:00',1.42),('16100','2014-05-03','08:45:00',1.47),('16100','2014-05-03','08:50:00',1.45),('16100','2014-05-03','08:55:00',1.3),('16100','2014-05-03','09:00:00',1.44),('16100','2014-05-03','09:05:00',1.85),('16100','2014-05-03','09:10:00',2.34),('16100','2014-05-03','09:15:00',2.15),('16100','2014-05-03','09:20:00',2.12),('16100','2014-05-03','09:25:00',5.02),('16100','2014-05-03','09:30:00',5.08),('16100','2014-05-03','09:35:00',2.82),('16100','2014-05-03','09:40:00',2.36),('16100','2014-05-03','09:45:00',4.07),('16100','2014-05-03','09:50:00',5.3),('16100','2014-05-03','09:55:00',6.27),('16100','2014-05-03','10:00:00',5.14),('16100','2014-05-03','10:05:00',5.22),('16100','2014-05-03','10:10:00',4.3),('16100','2014-05-03','10:15:00',2.88),('16100','2014-05-03','10:20:00',2.56),('16100','2014-05-03','10:25:00',2.62),('16100','2014-05-03','10:30:00',2.76),('16100','2014-05-03','10:35:00',2.94),('16100','2014-05-03','10:40:00',3.2),('16100','2014-05-03','10:45:00',3.59),('16100','2014-05-03','10:50:00',4.06),('16100','2014-05-03','10:55:00',2.76),('16100','2014-05-03','11:00:00',3.08),('16100','2014-05-03','11:05:00',3.72),('16100','2014-05-03','11:10:00',5.14),('16100','2014-05-03','11:15:00',6.36),('16100','2014-05-03','11:20:00',7.2),('16100','2014-05-03','11:25:00',6.18),('16100','2014-05-03','11:30:00',6.66),('16100','2014-05-03','11:35:00',5.27),('16100','2014-05-03','11:40:00',3.49),('16100','2014-05-03','11:45:00',3.14),('16100','2014-05-03','11:50:00',2.75),('16100','2014-05-03','11:55:00',2.89),('16100','2014-05-03','12:00:00',2.23),('16100','2014-05-03','12:05:00',1.67),('16100','2014-05-03','12:10:00',1.92),('16100','2014-05-03','12:15:00',7.18),('16100','2014-05-03','12:20:00',8.63),('16100','2014-05-03','12:25:00',5.1),('16100','2014-05-03','12:30:00',2.99),('16100','2014-05-03','12:35:00',1.95),('16100','2014-05-03','12:40:00',2.12),('16100','2014-05-03','12:45:00',2.28),('16100','2014-05-03','12:50:00',2.19),('16100','2014-05-03','12:55:00',1.68),('16100','2014-05-03','13:00:00',1.45),('16100','2014-05-03','13:05:00',1.45),('16100','2014-05-03','13:10:00',1.55),('16100','2014-05-03','13:15:00',1.53),('16100','2014-05-03','13:20:00',1.53),('16100','2014-05-03','13:25:00',1.66),('16100','2014-05-03','13:30:00',1.88),('16100','2014-05-03','13:35:00',2.12),('16100','2014-05-03','13:40:00',2.3),('16100','2014-05-03','13:45:00',2.5),('16100','2014-05-03','13:50:00',2.72),('16100','2014-05-03','13:55:00',3.71),('16100','2014-05-03','14:00:00',2.48),('16100','2014-05-03','14:05:00',1.48),('16100','2014-05-03','14:20:00',1.19),('16100','2014-05-03','14:25:00',1.7),('16100','2014-05-03','14:30:00',1.58),('16100','2014-05-03','14:35:00',1.46),('16100','2014-05-03','14:40:00',1.85),('16100','2014-05-03','14:45:00',2.61),('16100','2014-05-03','14:50:00',4.66),('16100','2014-05-03','14:55:00',5.57),('16100','2014-05-03','15:00:00',3.35),('16100','2014-05-03','15:05:00',4.19),('16100','2014-05-03','15:10:00',5.19),('16100','2014-05-03','15:15:00',7.75),('16100','2014-05-03','15:20:00',6.59),('16100','2014-05-03','15:25:00',3.62),('16100','2014-05-03','15:30:00',2.25),('16100','2014-05-03','15:35:00',1.75),('16100','2014-05-03','15:40:00',1.64),('16100','2014-05-03','15:45:00',1.57),('16100','2014-05-03','15:50:00',1.51),('16100','2014-05-03','15:55:00',1.37),('16100','2014-05-03','16:00:00',1.29),('16100','2014-05-03','16:05:00',1.2),('16100','2014-05-03','16:10:00',1.08),('16100','2014-05-03','17:25:00',1.26),('16100','2014-05-03','17:30:00',1.7),('16100','2014-05-03','17:35:00',1.86),('16100','2014-05-03','17:40:00',1.29),('16100','2014-04-15','08:00:00',1.02),('16100','2014-04-15','08:05:00',1.23),('16100','2014-04-15','08:10:00',1.48),('16100','2014-04-15','08:15:00',1.75),('16100','2014-04-15','08:20:00',1.95),('16100','2014-04-15','08:25:00',1.34),('16100','2014-04-15','08:35:00',1.69),('16100','2014-04-15','08:40:00',2.28),('16100','2014-04-15','08:45:00',2.96),('16100','2014-04-15','08:50:00',3.17),('16100','2014-04-15','08:55:00',3.32),('16100','2014-04-15','09:00:00',3.48),('16100','2014-04-15','09:05:00',3.66),('16100','2014-04-15','09:10:00',3.88),('16100','2014-04-15','09:15:00',4),('16100','2014-04-15','09:20:00',4.2),('16100','2014-04-15','09:25:00',4.38),('16100','2014-04-15','09:30:00',4.57),('16100','2014-04-15','09:35:00',1.75),('16100','2014-04-15','09:40:00',1.67),('16100','2014-04-15','09:45:00',3.29),('16100','2014-04-15','09:50:00',5.09),('16100','2014-04-15','09:55:00',4.43),('16100','2014-04-15','10:00:00',5.42),('16100','2014-04-15','10:05:00',5.55),('16100','2014-04-15','10:10:00',5.64),('16100','2014-04-15','10:15:00',5.73),('16100','2014-04-15','10:20:00',5.92),('16100','2014-04-15','10:25:00',6.15),('16100','2014-04-15','10:30:00',6.32),('16100','2014-04-15','10:35:00',6.45),('16100','2014-04-15','11:30:00',3.71),('16100','2014-04-15','11:35:00',6.85),('16100','2014-04-15','11:40:00',9.07),('16100','2014-04-15','11:45:00',8.52),('16100','2014-04-15','11:50:00',6.91),('16100','2014-04-15','11:55:00',7.45),('16100','2014-04-15','12:00:00',6.29),('16100','2014-04-15','12:05:00',5.95),('16100','2014-04-15','12:10:00',6.3),('16100','2014-04-15','12:15:00',8.7),('16100','2014-04-15','12:20:00',8.27),('16100','2014-04-15','12:25:00',9.28),('16100','2014-04-15','12:30:00',9.13),('16100','2014-04-15','12:35:00',3.8),('16100','2014-04-15','12:40:00',4.86),('16100','2014-04-15','12:45:00',8.59),('16100','2014-04-15','12:50:00',7.15),('16100','2014-04-15','12:55:00',9.35),('16100','2014-04-15','13:00:00',4.75),('16100','2014-04-15','13:05:00',2.67),('16100','2014-04-15','13:10:00',1.79),('16100','2014-04-15','13:15:00',1.65),('16100','2014-04-15','13:20:00',4.52),('16100','2014-04-15','13:25:00',5.59),('16100','2014-04-15','13:30:00',2.72),('16100','2014-04-15','13:35:00',3.73),('16100','2014-04-15','13:40:00',7.12),('16100','2014-04-15','13:45:00',6.8),('16100','2014-04-15','13:50:00',8.84),('16100','2014-04-15','13:55:00',7.7),('16100','2014-04-15','14:00:00',3.78),('16100','2014-04-15','14:05:00',5.95),('16100','2014-04-15','14:10:00',5.82),('16100','2014-04-15','14:15:00',3.6),('16100','2014-04-15','14:20:00',9),('16100','2014-04-15','14:25:00',8.14),('16100','2014-04-15','14:30:00',7.9),('16100','2014-04-15','14:35:00',5.05),('16100','2014-04-15','14:40:00',6.85),('16100','2014-04-15','14:45:00',4.8),('16100','2014-04-15','14:50:00',3.25),('16100','2014-04-15','14:55:00',5.06),('16100','2014-04-15','15:00:00',4.39),('16100','2014-04-15','15:05:00',2.98),('16100','2014-04-15','15:10:00',1.97),('16100','2014-04-15','15:15:00',1.1),('16100','2014-04-15','15:20:00',1.57),('16100','2014-04-15','15:25:00',1.84),('16100','2014-04-15','15:30:00',4.88),('16100','2014-04-15','15:35:00',2.37),('16100','2014-04-15','15:40:00',4.25),('16100','2014-04-15','15:45:00',4.95),('16100','2014-04-15','15:50:00',1.11),('16100','2014-04-15','15:55:00',1.05),('16100','2014-04-15','16:00:00',4.83),('16100','2014-04-15','16:05:00',6.23),('16100','2014-04-15','16:10:00',5.88),('16100','2014-04-15','16:15:00',5.68),('16100','2014-04-15','16:20:00',5.57),('16100','2014-04-15','16:25:00',4.7),('16100','2014-04-15','16:30:00',3.83),('16100','2014-04-15','16:35:00',4.9),('16100','2014-04-15','16:40:00',5.05),('16100','2014-04-15','16:45:00',4.88),('16100','2014-04-15','16:50:00',4.75),('16100','2014-04-15','16:55:00',4.56),('16100','2014-04-15','17:00:00',4.4),('16100','2014-04-15','17:05:00',4.23),('16100','2014-04-15','17:10:00',4.1),('16100','2014-04-15','17:15:00',3.91),('16100','2014-04-15','17:20:00',3.73),('16100','2014-04-15','17:25:00',3.53),('16100','2014-04-15','17:30:00',3.35),('16100','2014-04-15','17:35:00',3.17),('16100','2014-04-15','17:40:00',3),('16100','2014-04-15','17:45:00',2.83),('16100','2014-04-15','17:50:00',2.64),('16100','2014-04-15','17:55:00',2.49),('16100','2014-04-15','18:00:00',2.36),('16100','2014-04-15','18:05:00',1.8),('16100','2014-04-15','18:10:00',2.03),('16100','2014-04-15','18:15:00',1.79),('16100','2014-04-15','18:20:00',1.62),('16100','2014-04-15','18:25:00',1.06),('16100','2014-04-15','18:30:00',1.25),('16100','2014-04-15','18:35:00',1.07),('16100','2013-10-17','08:25:00',1.09),('16100','2013-10-17','08:30:00',1.07),('16100','2013-10-17','08:35:00',1.31),('16100','2013-10-17','08:40:00',1.61),('16100','2013-10-17','08:45:00',1.79),('16100','2013-10-17','08:50:00',1.94),('16100','2013-10-17','08:55:00',2.06),('16100','2013-10-17','09:00:00',2.43),('16100','2013-10-17','09:05:00',2.61),('16100','2013-10-17','09:10:00',2.79),('16100','2013-10-17','09:15:00',2.93),('16100','2013-10-17','09:20:00',3.18),('16100','2013-10-17','09:25:00',3.34),('16100','2013-10-17','09:30:00',3.59),('16100','2013-10-17','09:35:00',3.74),('16100','2013-10-17','09:40:00',3.87),('16100','2013-10-17','09:45:00',4.05),('16100','2013-10-17','09:50:00',4.17),('16100','2013-10-17','09:55:00',4.29),('16100','2013-10-17','10:00:00',4.44),('16100','2013-10-17','10:05:00',4.6),('16100','2013-10-17','10:10:00',4.69),('16100','2013-10-17','10:15:00',4.86),('16100','2013-10-17','10:20:00',4.92),('16100','2013-10-17','10:25:00',5.06),('16100','2013-10-17','10:30:00',5.19),('16100','2013-10-17','10:35:00',5.32),('16100','2013-10-17','10:40:00',5.36),('16100','2013-10-17','10:45:00',5.51),('16100','2013-10-17','10:50:00',5.6),('16100','2013-10-17','10:55:00',5.65),('16100','2013-10-17','11:00:00',5.5),('16100','2013-10-17','11:05:00',5.78),('16100','2013-10-17','11:10:00',5.18),('16100','2013-10-17','11:15:00',5.36),('16100','2013-10-17','11:20:00',4.77),('16100','2013-10-17','11:25:00',6.12),('16100','2013-10-17','11:30:00',6.04),('16100','2013-10-17','11:35:00',6.31),('16100','2013-10-17','11:40:00',6.11),('16100','2013-10-17','11:45:00',6.26),('16100','2013-10-17','11:50:00',6.4),('16100','2013-10-17','11:55:00',6.2),('16100','2013-10-17','12:00:00',6.37),('16100','2013-10-17','12:05:00',6.35),('16100','2013-10-17','12:10:00',6.37),('16100','2013-10-17','12:15:00',6.25),('16100','2013-10-17','12:20:00',6.33),('16100','2013-10-17','12:25:00',6.54),('16100','2013-10-17','12:30:00',6.51),('16100','2013-10-17','12:35:00',6.42),('16100','2013-10-17','12:40:00',6.5),('16100','2013-10-17','12:45:00',6.39),('16100','2013-10-17','12:50:00',6.33),('16100','2013-10-17','12:55:00',6.3),('16100','2013-10-17','13:00:00',6.15),('16100','2013-10-17','13:05:00',6.19),('16100','2013-10-17','13:10:00',6.42),('16100','2013-10-17','13:15:00',6.44),('16100','2013-10-17','13:20:00',6.36),('16100','2013-10-17','13:25:00',6.49),('16100','2013-10-17','13:30:00',6.48),('16100','2013-10-17','13:35:00',6.4),('16100','2013-10-17','13:40:00',6.36),('16100','2013-10-17','13:45:00',6.05),('16100','2013-10-17','13:50:00',6.17),('16100','2013-10-17','13:55:00',5.99),('16100','2013-10-17','14:00:00',5.92),('16100','2013-10-17','14:05:00',6.05),('16100','2013-10-17','14:10:00',6.02),('16100','2013-10-17','14:15:00',6),('16100','2013-10-17','14:20:00',5.97),('16100','2013-10-17','14:25:00',5.93),('16100','2013-10-17','14:30:00',5.76),('16100','2013-10-17','14:35:00',5.82),('16100','2013-10-17','14:40:00',5.65),('16100','2013-10-17','14:45:00',5.56),('16100','2013-10-17','14:50:00',5.53),('16100','2013-10-17','14:55:00',5.39),('16100','2013-10-17','15:00:00',4.75),('16100','2013-10-17','15:05:00',4.86),('16100','2013-10-17','15:10:00',4.72),('16100','2013-10-17','15:15:00',5.17),('16100','2013-10-17','15:20:00',4.85),('16100','2013-10-17','15:25:00',4.74),('16100','2013-10-17','15:30:00',4.77),('16100','2013-10-17','15:35:00',4.47),('16100','2013-10-17','15:40:00',4.15),('16100','2013-10-17','15:45:00',3.95),('16100','2013-10-17','15:50:00',3.92),('16100','2013-10-17','15:55:00',3.87),('16100','2013-10-17','16:00:00',3.72),('16100','2013-10-17','16:05:00',3.62),('16100','2013-10-17','16:10:00',3.37),('16100','2013-10-17','16:15:00',3.21),('16100','2013-10-17','16:20:00',2.62),('16100','2013-10-17','16:25:00',2.37),('16100','2013-10-17','16:30:00',2.26),('16100','2013-10-17','16:35:00',1.77),('16100','2013-10-17','16:40:00',1.45),('16100','2013-10-17','16:45:00',1.59),('16100','2013-10-17','16:50:00',1.82),('16100','2013-10-17','16:55:00',1.6),('16100','2013-10-17','17:00:00',1.39),('16100','2013-10-17','17:05:00',1.29),('16100','2013-10-17','17:10:00',1.09),('16100','2013-10-17','17:15:00',1.02),('16100','2013-10-16','08:20:00',1.01),('16100','2013-10-16','08:25:00',1.2),('16100','2013-10-16','08:30:00',1.4),('16100','2013-10-16','08:35:00',1.59),('16100','2013-10-16','08:40:00',1.79),('16100','2013-10-16','08:45:00',1.98),('16100','2013-10-16','08:50:00',2.18),('16100','2013-10-16','08:55:00',2.35),('16100','2013-10-16','09:00:00',2.51),('16100','2013-10-16','09:05:00',2.68),('16100','2013-10-16','09:10:00',2.85),('16100','2013-10-16','09:15:00',3.05),('16100','2013-10-16','09:20:00',3.22),('16100','2013-10-16','09:25:00',3.38),('16100','2013-10-16','09:30:00',3.55),('16100','2013-10-16','09:35:00',3.7),('16100','2013-10-16','09:40:00',3.85),('16100','2013-10-16','09:45:00',4.01),('16100','2013-10-16','09:50:00',4.17),('16100','2013-10-16','09:55:00',4.3),('16100','2013-10-16','10:00:00',4.43),('16100','2013-10-16','10:05:00',4.56),('16100','2013-10-16','10:10:00',4.68),('16100','2013-10-16','10:15:00',4.8),('16100','2013-10-16','10:20:00',5),('16100','2013-10-16','10:25:00',5.1),('16100','2013-10-16','10:30:00',5.21),('16100','2013-10-16','10:35:00',5.33),('16100','2013-10-16','10:40:00',5.45),('16100','2013-10-16','10:45:00',5.52),('16100','2013-10-16','10:50:00',5.61),('16100','2013-10-16','10:55:00',5.69),('16100','2013-10-16','11:00:00',5.76),('16100','2013-10-16','11:05:00',5.88),('16100','2013-10-16','11:10:00',5.97),('16100','2013-10-16','11:15:00',6.05),('16100','2013-10-16','11:20:00',6.12),('16100','2013-10-16','11:25:00',6.19),('16100','2013-10-16','11:30:00',6.22),('16100','2013-10-16','11:35:00',6.22),('16100','2013-10-16','11:40:00',6.34),('16100','2013-10-16','11:45:00',6.42),('16100','2013-10-16','11:50:00',6.48),('16100','2013-10-16','11:55:00',6.49),('16100','2013-10-16','12:00:00',6.54),('16100','2013-10-16','12:05:00',6.56),('16100','2013-10-16','12:10:00',6.6),('16100','2013-10-16','12:15:00',6.64),('16100','2013-10-16','12:20:00',6.65),('16100','2013-10-16','12:25:00',6.68),('16100','2013-10-16','12:30:00',6.72),('16100','2013-10-16','12:35:00',6.69),('16100','2013-10-16','12:40:00',6.71),('16100','2013-10-16','12:45:00',6.72),('16100','2013-10-16','12:50:00',6.71),('16100','2013-10-16','12:55:00',6.71),('16100','2013-10-16','13:00:00',6.76),('16100','2013-10-16','13:05:00',6.78),('16100','2013-10-16','13:10:00',6.77),('16100','2013-10-16','13:15:00',6.77),('16100','2013-10-16','13:20:00',6.73),('16100','2013-10-16','13:25:00',6.73),('16100','2013-10-16','13:30:00',6.7),('16100','2013-10-16','13:35:00',6.69),('16100','2013-10-16','13:40:00',6.64),('16100','2013-10-16','13:45:00',6.61),('16100','2013-10-16','13:50:00',6.55),('16100','2013-10-16','13:55:00',6.51),('16100','2013-10-16','14:00:00',6.44),('16100','2013-10-16','14:05:00',6.36),('16100','2013-10-16','14:10:00',6.32),('16100','2013-10-16','14:15:00',6.24),('16100','2013-10-16','14:20:00',6.16),('16100','2013-10-16','14:25:00',6.15),('16100','2013-10-16','14:30:00',6.11),('16100','2013-10-16','14:35:00',6.02),('16100','2013-10-16','14:40:00',5.93),('16100','2013-10-16','14:45:00',5.82),('16100','2013-10-16','14:50:00',5.77),('16100','2013-10-16','14:55:00',5.65),('16100','2013-10-16','15:00:00',5.55),('16100','2013-10-16','15:05:00',5.48),('16100','2013-10-16','15:10:00',5.39),('16100','2013-10-16','15:15:00',5.26),('16100','2013-10-16','15:20:00',5.14),('16100','2013-10-16','15:25:00',5.02),('16100','2013-10-16','15:30:00',4.88),('16100','2013-10-16','15:35:00',4.77),('16100','2013-10-16','15:40:00',4.66),('16100','2013-10-16','15:45:00',4.52),('16100','2013-10-16','15:50:00',4.33),('16100','2013-10-16','15:55:00',4.18),('16100','2013-10-16','16:00:00',4.05),('16100','2013-10-16','16:05:00',3.94),('16100','2013-10-16','16:10:00',3.84),('16100','2013-10-16','16:15:00',3.67),('16100','2013-10-16','16:20:00',3.53),('16100','2013-10-16','16:25:00',3.36),('16100','2013-10-16','16:30:00',3.2),('16100','2013-10-16','16:35:00',3.04),('16100','2013-10-16','16:40:00',2.85),('16100','2013-10-16','16:45:00',2.7),('16100','2013-10-16','16:50:00',2.56),('16100','2013-10-16','16:55:00',2.37),('16100','2013-10-16','17:00:00',1.8),('16100','2013-10-16','17:05:00',1.23),('16100','2013-10-16','17:10:00',1.87),('16100','2013-10-16','17:15:00',1.33),('16100','2013-10-16','17:20:00',1.5),('16100','2013-10-16','17:25:00',1.35),('16100','2013-10-16','17:30:00',1.18),('16100','2013-10-16','17:35:00',1.01),('16100','2013-10-15','09:40:00',2.73),('16100','2013-10-15','09:45:00',1.66),('16100','2013-10-15','09:50:00',1.19),('16100','2013-10-15','09:55:00',1.59),('16100','2013-10-15','10:00:00',1.48),('16100','2013-10-15','11:05:00',1.19),('16100','2013-10-15','11:10:00',1.86),('16100','2013-10-15','11:45:00',2.2),('16100','2013-10-15','11:50:00',1.42),('16100','2013-10-15','12:00:00',1.23),('16100','2013-10-15','12:05:00',2),('16100','2013-10-15','12:10:00',2.04),('16100','2013-10-15','12:15:00',3.04),('16100','2013-10-15','12:20:00',1.49),('16100','2013-10-15','12:25:00',1.02),('16100','2013-10-15','12:30:00',2.2),('16100','2013-10-15','12:35:00',2.77),('16100','2013-10-15','12:40:00',1.7),('16100','2013-10-15','12:45:00',2.16),('16100','2013-10-15','12:50:00',2.57),('16100','2013-10-15','12:55:00',2.41),('16100','2013-10-15','13:00:00',3.48),('16100','2013-10-15','13:05:00',4.08),('16100','2013-10-15','13:10:00',4.55),('16100','2013-10-15','13:15:00',6.31),('16100','2013-10-15','13:20:00',7.15),('16100','2013-10-15','13:25:00',7),('16100','2013-10-15','13:30:00',4.15),('16100','2013-10-15','13:35:00',2.41),('16100','2013-10-15','13:40:00',5.86),('16100','2013-10-15','13:45:00',6.12),('16100','2013-10-15','13:50:00',6.63),('16100','2013-10-15','13:55:00',3.14),('16100','2013-10-15','14:00:00',6.19),('16100','2013-10-15','14:05:00',6.71),('16100','2013-10-15','14:10:00',6.44),('16100','2013-10-15','14:15:00',6.13),('16100','2013-10-15','14:20:00',6.35),('16100','2013-10-15','14:25:00',6.29),('16100','2013-10-15','14:30:00',6.48),('16100','2013-10-15','14:35:00',4.23),('16100','2013-10-15','14:40:00',6.18),('16100','2013-10-15','14:45:00',5.98),('16100','2013-10-15','14:50:00',4.36),('16100','2013-10-15','14:55:00',4.39),('16100','2013-10-15','15:00:00',5.64),('16100','2013-10-15','15:05:00',5.32),('16100','2013-10-15','15:10:00',5.47),('16100','2013-10-15','15:15:00',5.38),('16100','2013-10-15','15:20:00',5.21),('16100','2013-10-15','15:25:00',5.15),('16100','2013-10-15','15:30:00',5.16),('16100','2013-10-15','15:35:00',4.06),('16100','2013-10-15','15:40:00',4.51),('16100','2013-10-15','15:45:00',4.49),('16100','2013-10-15','15:50:00',4.32),('16100','2013-10-15','15:55:00',4.19),('16100','2013-10-15','16:00:00',3.61),('16100','2013-10-15','16:05:00',3.83),('16100','2013-10-15','16:10:00',3.76),('16100','2013-10-15','16:15:00',3.64),('16100','2013-10-15','16:20:00',3.42),('16100','2013-10-15','16:25:00',3.19),('16100','2013-10-15','16:30:00',3.09),('16100','2013-10-15','16:35:00',3),('16100','2013-10-15','16:40:00',2.8),('16100','2013-10-15','16:45:00',2.65),('16100','2013-10-15','16:50:00',2.5),('16100','2013-10-15','16:55:00',2.33),('16100','2013-10-15','17:00:00',2.16),('16100','2013-10-15','17:05:00',2),('16100','2013-10-15','17:10:00',1.79),('16100','2013-10-15','17:15:00',1.59),('16100','2013-10-15','17:20:00',1.45),('16100','2013-10-15','17:25:00',1.28),('16100','2013-10-15','17:30:00',1.12),('16100','2013-10-14','09:00:00',1.09),('16100','2013-10-14','09:05:00',1.32),('16100','2013-10-14','09:10:00',1.27),('16100','2013-10-14','09:15:00',1.42),('16100','2013-10-14','09:20:00',1.62),('16100','2013-10-14','09:25:00',2.29),('16100','2013-10-14','09:30:00',1.31),('16100','2013-10-14','09:35:00',2.46),('16100','2013-10-14','09:40:00',2.61),('16100','2013-10-14','09:45:00',3.84),('16100','2013-10-14','09:50:00',4.33),('16100','2013-10-14','09:55:00',4.6),('16100','2013-10-14','10:00:00',3.95),('16100','2013-10-14','10:05:00',3.99),('16100','2013-10-14','10:10:00',2.61),('16100','2013-10-14','10:15:00',2.14),('16100','2013-10-14','10:20:00',2.94),('16100','2013-10-14','10:25:00',4.72),('16100','2013-10-14','10:30:00',3.94),('16100','2013-10-14','10:35:00',4.32),('16100','2013-10-14','10:40:00',5.06),('16100','2013-10-14','10:45:00',3.61),('16100','2013-10-14','10:50:00',3.22),('16100','2013-10-14','10:55:00',3.4),('16100','2013-10-14','11:00:00',3.46),('16100','2013-10-14','11:05:00',4.93),('16100','2013-10-14','11:10:00',5.57),('16100','2013-10-14','11:15:00',5.01),('16100','2013-10-14','11:20:00',4.92),('16100','2013-10-14','11:25:00',4.72),('16100','2013-10-14','11:30:00',4.44),('16100','2013-10-14','11:35:00',3.2),('16100','2013-10-14','11:40:00',2.74),('16100','2013-10-14','11:45:00',2.82),('16100','2013-10-14','11:50:00',2.87),('16100','2013-10-14','11:55:00',2.55),('16100','2013-10-14','12:00:00',2.51),('16100','2013-10-14','12:05:00',2.46),('16100','2013-10-14','12:10:00',2.43),('16100','2013-10-14','12:15:00',2.44),('16100','2013-10-14','12:20:00',2.49),('16100','2013-10-14','12:25:00',2.13),('16100','2013-10-14','12:30:00',2.17),('16100','2013-10-14','12:35:00',2.21),('16100','2013-10-14','12:40:00',2.42),('16100','2013-10-14','12:45:00',2.32),('16100','2013-10-14','12:50:00',1.98),('16100','2013-10-14','12:55:00',1.91),('16100','2013-10-14','13:00:00',2.22),('16100','2013-10-14','13:05:00',2.95),('16100','2013-10-14','13:10:00',3.02),('16100','2013-10-14','13:15:00',4.64),('16100','2013-10-14','13:20:00',5.35),('16100','2013-10-14','13:25:00',3.87),('16100','2013-10-14','13:30:00',3.32),('16100','2013-10-14','13:35:00',2.8),('16100','2013-10-14','13:40:00',3.03),('16100','2013-10-14','13:45:00',2.6),('16100','2013-10-14','13:50:00',2.19),('16100','2013-10-14','13:55:00',1.91),('16100','2013-10-14','14:00:00',1.84),('16100','2013-10-14','14:05:00',1.97),('16100','2013-10-14','14:10:00',2.58),('16100','2013-10-14','14:15:00',3.63),('16100','2013-10-14','14:20:00',4.18),('16100','2013-10-14','14:25:00',4.41),('16100','2013-10-14','14:30:00',2.69),('16100','2013-10-14','14:35:00',3.43),('16100','2013-10-14','14:40:00',4.14),('16100','2013-10-14','14:45:00',5.17),('16100','2013-10-14','14:50:00',4.11),('16100','2013-10-14','14:55:00',2.62),('16100','2013-10-14','15:00:00',2.89),('16100','2013-10-14','15:05:00',2.81),('16100','2013-10-14','15:10:00',2.35),('16100','2013-10-14','15:15:00',1.92),('16100','2013-10-14','15:20:00',1.7),('16100','2013-10-14','15:25:00',1.61),('16100','2013-10-14','15:30:00',1.64),('16100','2013-10-14','15:35:00',1.79),('16100','2013-10-14','15:40:00',1.79),('16100','2013-10-14','15:45:00',1.57),('16100','2013-10-14','15:50:00',1.34),('16100','2013-10-14','15:55:00',1.17),('16100','2013-10-14','16:00:00',1.14),('16100','2013-10-14','16:05:00',1.18),('16100','2013-10-14','16:10:00',1.16),('16100','2013-10-14','16:15:00',1.16),('16100','2013-10-14','16:20:00',1.55),('16100','2013-10-14','16:25:00',1.99),('16100','2013-10-14','16:30:00',2.22),('16100','2013-10-14','16:35:00',1.85),('16100','2013-10-14','16:40:00',1.42),('16100','2013-10-14','16:45:00',1.3),('16100','2013-10-14','16:50:00',1.44),('16100','2013-10-14','16:55:00',1.38),('16100','2013-10-14','17:00:00',1.06),('16100','2013-10-13','08:20:00',1.18),('16100','2013-10-13','08:25:00',1.32),('16100','2013-10-13','08:30:00',1.48),('16100','2013-10-13','08:35:00',1.56),('16100','2013-10-13','08:40:00',1.59),('16100','2013-10-13','08:45:00',1.68),('16100','2013-10-13','08:50:00',1.94),('16100','2013-10-13','08:55:00',1.9),('16100','2013-10-13','09:00:00',1.82),('16100','2013-10-13','09:05:00',1.64),('16100','2013-10-13','09:10:00',1.41),('16100','2013-10-13','09:15:00',2.12),('16100','2013-10-13','09:20:00',2.82),('16100','2013-10-13','09:25:00',3.02),('16100','2013-10-13','09:30:00',3.39),('16100','2013-10-13','09:35:00',2.33),('16100','2013-10-13','09:40:00',2.61),('16100','2013-10-13','09:45:00',3.21),('16100','2013-10-13','09:50:00',3.63),('16100','2013-10-13','09:55:00',3.65),('16100','2013-10-13','10:00:00',4.23),('16100','2013-10-13','10:05:00',4.29),('16100','2013-10-13','10:10:00',4.45),('16100','2013-10-13','10:15:00',4.55),('16100','2013-10-13','10:20:00',4.67),('16100','2013-10-13','10:25:00',4.8),('16100','2013-10-13','10:30:00',4.92),('16100','2013-10-13','10:35:00',4.92),('16100','2013-10-13','10:40:00',4.93),('16100','2013-10-13','10:45:00',5.03),('16100','2013-10-13','10:50:00',5.3),('16100','2013-10-13','10:55:00',5.37),('16100','2013-10-13','11:00:00',5.37),('16100','2013-10-13','11:05:00',5.23),('16100','2013-10-13','11:10:00',5.64),('16100','2013-10-13','11:15:00',5.54),('16100','2013-10-13','11:20:00',5.71),('16100','2013-10-13','11:25:00',5.9),('16100','2013-10-13','11:30:00',5.94),('16100','2013-10-13','11:35:00',5.9),('16100','2013-10-13','11:40:00',5.96),('16100','2013-10-13','11:45:00',5.89),('16100','2013-10-13','11:50:00',5.99),('16100','2013-10-13','11:55:00',6.08),('16100','2013-10-13','12:00:00',6.14),('16100','2013-10-13','12:05:00',6.17),('16100','2013-10-13','12:10:00',6.27),('16100','2013-10-13','12:15:00',5.98),('16100','2013-10-13','12:20:00',5.8),('16100','2013-10-13','12:25:00',6.37),('16100','2013-10-13','12:30:00',6.38),('16100','2013-10-13','12:35:00',6.36),('16100','2013-10-13','12:40:00',6.36),('16100','2013-10-13','12:45:00',6.36),('16100','2013-10-13','12:50:00',6.33),('16100','2013-10-13','12:55:00',6.29),('16100','2013-10-13','13:00:00',6.33),('16100','2013-10-13','13:05:00',6.31),('16100','2013-10-13','13:10:00',6.29),('16100','2013-10-13','13:15:00',6.28),('16100','2013-10-13','13:20:00',6.26),('16100','2013-10-13','13:25:00',6.23),('16100','2013-10-13','13:30:00',6.2),('16100','2013-10-13','13:35:00',6.18),('16100','2013-10-13','13:40:00',6.1),('16100','2013-10-13','13:45:00',6.04),('16100','2013-10-13','13:50:00',6.01),('16100','2013-10-13','13:55:00',5.96),('16100','2013-10-13','14:00:00',5.9),('16100','2013-10-13','14:05:00',5.8),('16100','2013-10-13','14:10:00',5.76),('16100','2013-10-13','14:15:00',4.85),('16100','2013-10-13','14:20:00',5.36),('16100','2013-10-13','14:25:00',5.59),('16100','2013-10-13','14:30:00',5.56),('16100','2013-10-13','14:35:00',5.51),('16100','2013-10-13','14:40:00',5.42),('16100','2013-10-13','14:45:00',5.35),('16100','2013-10-13','14:50:00',5.28),('16100','2013-10-13','14:55:00',5.23),('16100','2013-10-13','15:00:00',5.16),('16100','2013-10-13','15:05:00',5.07),('16100','2013-10-13','15:10:00',4.98),('16100','2013-10-13','15:15:00',4.86),('16100','2013-10-13','15:20:00',4.73),('16100','2013-10-13','15:25:00',4.62),('16100','2013-10-13','15:30:00',4.48),('16100','2013-10-13','15:35:00',4.38),('16100','2013-10-13','15:40:00',4.25),('16100','2013-10-13','15:45:00',2.88),('16100','2013-10-13','15:50:00',1.57),('16100','2013-10-13','15:55:00',2.34),('16100','2013-10-13','16:00:00',2.04),('16100','2013-10-13','16:05:00',1.58),('16100','2013-10-13','16:10:00',2.06),('16100','2013-10-13','16:15:00',2.46),('16100','2013-10-13','16:20:00',2.41),('16100','2013-10-13','16:25:00',2.49),('16100','2013-10-13','16:30:00',1.76),('16100','2013-10-13','16:35:00',1.25),('16100','2013-10-13','16:40:00',2.7),('16100','2013-10-13','16:45:00',1.88),('16100','2013-10-13','16:50:00',1.52),('16100','2013-10-13','17:15:00',1.29),('16100','2013-10-12','08:35:00',1.12),('16100','2013-10-12','08:40:00',1.13),('16100','2013-10-12','08:45:00',1.21),('16100','2013-10-12','08:50:00',1.46),('16100','2013-10-12','08:55:00',1.88),('16100','2013-10-12','09:00:00',1.92),('16100','2013-10-12','09:05:00',1.94),('16100','2013-10-12','09:10:00',2.38),('16100','2013-10-12','09:15:00',3),('16100','2013-10-12','09:20:00',3.21),('16100','2013-10-12','09:25:00',2.41),('16100','2013-10-12','09:30:00',1.96),('16100','2013-10-12','09:35:00',2.23),('16100','2013-10-12','09:40:00',4.74),('16100','2013-10-12','09:45:00',4.39),('16100','2013-10-12','09:50:00',3.84),('16100','2013-10-12','09:55:00',4.33),('16100','2013-10-12','10:00:00',3.48),('16100','2013-10-12','10:05:00',3.63),('16100','2013-10-12','10:10:00',4.56),('16100','2013-10-12','10:15:00',3.84),('16100','2013-10-12','10:20:00',2.78),('16100','2013-10-12','10:25:00',3.31),('16100','2013-10-12','10:30:00',4.73),('16100','2013-10-12','10:35:00',6.28),('16100','2013-10-12','10:40:00',6.19),('16100','2013-10-12','10:45:00',5.96),('16100','2013-10-12','10:50:00',6.23),('16100','2013-10-12','10:55:00',5.57),('16100','2013-10-12','11:00:00',3.94),('16100','2013-10-12','11:05:00',4.96),('16100','2013-10-12','11:10:00',5.52),('16100','2013-10-12','11:15:00',5.9),('16100','2013-10-12','11:20:00',5.64),('16100','2013-10-12','11:25:00',5.29),('16100','2013-10-12','11:30:00',5.94),('16100','2013-10-12','11:35:00',6.01),('16100','2013-10-12','11:40:00',5.96),('16100','2013-10-12','11:45:00',5.86),('16100','2013-10-12','11:50:00',5.99),('16100','2013-10-12','11:55:00',6.19),('16100','2013-10-12','12:00:00',6.24),('16100','2013-10-12','12:05:00',6.3),('16100','2013-10-12','12:10:00',6.26),('16100','2013-10-12','12:15:00',6.31),('16100','2013-10-12','12:20:00',6.31),('16100','2013-10-12','12:25:00',6.3),('16100','2013-10-12','12:30:00',6.24),('16100','2013-10-12','12:35:00',6.45),('16100','2013-10-12','12:40:00',6.34),('16100','2013-10-12','12:45:00',6.32),('16100','2013-10-12','12:50:00',6.33),('16100','2013-10-12','12:55:00',4.63),('16100','2013-10-12','13:00:00',6.23),('16100','2013-10-12','13:05:00',6.32),('16100','2013-10-12','13:10:00',6.46),('16100','2013-10-12','13:15:00',6.49),('16100','2013-10-12','13:20:00',6.45),('16100','2013-10-12','13:25:00',5.8),('16100','2013-10-12','13:30:00',6.2),('16100','2013-10-12','13:35:00',5.92),('16100','2013-10-12','13:40:00',6.52),('16100','2013-10-12','13:45:00',6.27),('16100','2013-10-12','13:50:00',6.25),('16100','2013-10-12','13:55:00',5.91),('16100','2013-10-12','14:00:00',4.35),('16100','2013-10-12','14:05:00',6.65),('16100','2013-10-12','14:10:00',5.7),('16100','2013-10-12','14:15:00',6.2),('16100','2013-10-12','14:20:00',6.3),('16100','2013-10-12','14:25:00',6.22),('16100','2013-10-12','14:30:00',5.34),('16100','2013-10-12','14:35:00',4.02),('16100','2013-10-12','14:40:00',4.94),('16100','2013-10-12','14:45:00',4.99),('16100','2013-10-12','14:50:00',4.47),('16100','2013-10-12','14:55:00',4.76),('16100','2013-10-12','15:00:00',4.43),('16100','2013-10-12','15:05:00',5.25),('16100','2013-10-12','15:10:00',5.12),('16100','2013-10-12','15:15:00',4.38),('16100','2013-10-12','15:20:00',4.36),('16100','2013-10-12','15:25:00',3.26),('16100','2013-10-12','15:30:00',3.5),('16100','2013-10-12','15:35:00',3.12),('16100','2013-10-12','15:40:00',2.54),('16100','2013-10-12','15:45:00',2.71),('16100','2013-10-12','15:50:00',2.78),('16100','2013-10-12','15:55:00',3.56),('16100','2013-10-12','16:00:00',3.36),('16100','2013-10-12','16:05:00',3.3),('16100','2013-10-12','16:10:00',3.6),('16100','2013-10-12','16:15:00',3.81),('16100','2013-10-12','16:20:00',3.39),('16100','2013-10-12','16:25:00',2.42),('16100','2013-10-12','16:30:00',2.46),('16100','2013-10-12','16:35:00',3.05),('16100','2013-10-12','16:40:00',1.75),('16100','2013-10-12','16:45:00',1.49),('16100','2013-10-12','16:50:00',1.41),('16100','2013-10-12','16:55:00',1.03),('16100','2013-10-12','17:20:00',1.55),('16100','2013-10-12','17:25:00',1.24),('16100','2013-10-12','17:30:00',1.32),('16100','2013-10-12','17:35:00',1.18),('16100','2013-10-11','11:00:00',1.14),('16100','2013-10-11','11:05:00',1.2),('16100','2013-10-11','11:10:00',1.32),('16100','2013-10-11','11:15:00',1.56),('16100','2013-10-11','11:20:00',1.94),('16100','2013-10-11','11:25:00',2.01),('16100','2013-10-11','11:30:00',2.98),('16100','2013-10-11','11:35:00',4.32),('16100','2013-10-11','11:40:00',2.7),('16100','2013-10-11','11:45:00',2.17),('16100','2013-10-11','11:50:00',2),('16100','2013-10-11','11:55:00',1.4),('16100','2013-10-11','12:00:00',1.06),('16100','2013-10-11','12:05:00',1.19),('16100','2013-10-11','12:10:00',1.62),('16100','2013-10-11','12:15:00',2.21),('16100','2013-10-11','12:20:00',5.23),('16100','2013-10-11','12:25:00',4.93),('16100','2013-10-11','12:30:00',4.79),('16100','2013-10-11','12:35:00',6.47),('16100','2013-10-11','12:40:00',6.96),('16100','2013-10-11','12:45:00',5.22),('16100','2013-10-11','12:50:00',5.8),('16100','2013-10-11','12:55:00',5.32),('16100','2013-10-11','13:00:00',4.72),('16100','2013-10-11','13:05:00',1.37),('16100','2013-10-11','13:10:00',1),('16100','2013-10-11','13:15:00',1.49),('16100','2013-10-11','13:20:00',2.14),('16100','2013-10-11','13:25:00',3.17),('16100','2013-10-11','13:30:00',2.35),('16100','2013-10-11','13:55:00',1.23),('16100','2013-10-11','15:15:00',1.09),('16100','2013-10-11','15:20:00',1.22),('16100','2013-10-11','15:25:00',1.32),('16100','2013-10-11','15:30:00',1.31),('16100','2013-10-11','15:40:00',1.04),('16100','2013-10-11','15:45:00',1.09),('16100','2013-10-11','15:50:00',1.31),('16100','2013-10-11','15:55:00',1.44),('16100','2013-10-11','16:00:00',1.57),('16100','2013-10-11','16:05:00',1.48),('16100','2013-10-11','16:10:00',1.58),('16100','2013-10-11','16:15:00',3.59),('16100','2013-10-11','16:20:00',3.57),('16100','2013-10-11','16:25:00',2.45),('16100','2013-10-11','16:30:00',1.6),('16100','2013-10-11','16:35:00',1.86),('16100','2013-10-11','16:40:00',1.35),('16100','2013-10-10','08:20:00',1.12),('16100','2013-10-10','08:25:00',1.3),('16100','2013-10-10','08:30:00',1.51),('16100','2013-10-10','08:35:00',1.78),('16100','2013-10-10','08:40:00',1.99),('16100','2013-10-10','08:45:00',2.14),('16100','2013-10-10','08:50:00',1.85),('16100','2013-10-10','08:55:00',2.19),('16100','2013-10-10','09:00:00',2.51),('16100','2013-10-10','09:05:00',2.69),('16100','2013-10-10','09:10:00',2.86),('16100','2013-10-10','09:15:00',3.05),('16100','2013-10-10','09:20:00',3.23),('16100','2013-10-10','09:25:00',3.41),('16100','2013-10-10','09:30:00',3.57),('16100','2013-10-10','09:35:00',3.76),('16100','2013-10-10','09:40:00',3.92),('16100','2013-10-10','09:45:00',4.04),('16100','2013-10-10','09:50:00',4.2),('16100','2013-10-10','09:55:00',4.35),('16100','2013-10-10','10:00:00',4.41),('16100','2013-10-10','10:05:00',4.63),('16100','2013-10-10','10:10:00',4.94),('16100','2013-10-10','10:15:00',5.32),('16100','2013-10-10','10:20:00',5.7),('16100','2013-10-10','10:25:00',6.13),('16100','2013-10-10','10:30:00',4.35),('16100','2013-10-10','10:35:00',6.21),('16100','2013-10-10','10:40:00',4.14),('16100','2013-10-10','10:45:00',5.53),('16100','2013-10-10','10:50:00',5.14),('16100','2013-10-10','10:55:00',2.86),('16100','2013-10-10','11:00:00',2.28),('16100','2013-10-10','11:05:00',2.29),('16100','2013-10-10','11:10:00',2.08),('16100','2013-10-10','11:15:00',1.65),('16100','2013-10-10','11:20:00',1.42),('16100','2013-10-10','11:25:00',1.47),('16100','2013-10-10','11:30:00',1.58),('16100','2013-10-10','11:35:00',1.67),('16100','2013-10-10','11:40:00',2.15),('16100','2013-10-10','11:45:00',4.19),('16100','2013-10-10','11:50:00',1.13),('16100','2013-10-10','12:15:00',3.73),('16100','2013-10-10','12:20:00',7.19),('16100','2013-10-10','12:25:00',2),('16100','2013-10-10','12:30:00',1.31),('16100','2013-10-10','13:00:00',1.44),('16100','2013-10-10','13:30:00',1.97),('16100','2013-10-10','13:35:00',1.51),('16100','2013-10-10','13:40:00',1.9),('16100','2013-10-10','13:45:00',3.42),('16100','2013-10-10','13:50:00',3.55),('16100','2013-10-10','13:55:00',1.29),('16100','2013-10-10','14:35:00',1.37),('16100','2013-10-10','15:45:00',1.01),('16100','2013-10-10','16:15:00',1.31),('16100','2013-10-10','16:20:00',2.09),('16100','2013-10-10','16:25:00',1),('16100','2013-10-10','16:30:00',2.54),('16100','2013-10-10','16:35:00',3.71),('16100','2013-10-10','16:40:00',3.38),('16100','2013-10-10','16:45:00',1.84),('16100','2013-10-10','16:50:00',1.57),('16100','2013-10-10','17:00:00',1.63),('16100','2013-10-10','17:05:00',1.6),('16100','2013-10-10','17:10:00',2.03),('16100','2013-10-10','17:15:00',1.36),('16100','2013-10-10','17:25:00',1.3),('16100','2013-10-09','08:20:00',1.07),('16100','2013-10-09','08:25:00',1.27),('16100','2013-10-09','08:30:00',1.48),('16100','2013-10-09','08:35:00',1.67),('16100','2013-10-09','08:40:00',1.9),('16100','2013-10-09','08:45:00',2.1),('16100','2013-10-09','08:50:00',2.32),('16100','2013-10-09','08:55:00',2.57),('16100','2013-10-09','09:00:00',2.8),('16100','2013-10-09','09:05:00',2.9),('16100','2013-10-09','09:10:00',3),('16100','2013-10-09','09:15:00',3.08),('16100','2013-10-09','09:20:00',3.28),('16100','2013-10-09','09:25:00',3.46),('16100','2013-10-09','09:30:00',3.61),('16100','2013-10-09','09:35:00',3.78),('16100','2013-10-09','09:40:00',3.96),('16100','2013-10-09','09:45:00',3.96),('16100','2013-10-09','09:50:00',4.09),('16100','2013-10-09','09:55:00',4.23),('16100','2013-10-09','10:00:00',3.85),('16100','2013-10-09','10:05:00',4.57),('16100','2013-10-09','10:10:00',5.05),('16100','2013-10-09','10:15:00',5.44),('16100','2013-10-09','10:20:00',3.57),('16100','2013-10-09','10:40:00',1.16),('16100','2013-10-09','10:45:00',1.01),('16100','2013-10-09','10:50:00',1.37),('16100','2013-10-09','10:55:00',3.1),('16100','2013-10-09','11:00:00',1.51),('16100','2013-10-09','11:10:00',2.95),('16100','2013-10-09','11:15:00',4.27),('16100','2013-10-09','11:20:00',6.01),('16100','2013-10-09','11:25:00',6.13),('16100','2013-10-09','11:30:00',4.37),('16100','2013-10-09','11:35:00',4.31),('16100','2013-10-09','11:40:00',6.6),('16100','2013-10-09','11:45:00',2.48),('16100','2013-10-09','11:50:00',4.91),('16100','2013-10-09','11:55:00',7.29),('16100','2013-10-09','12:00:00',7.98),('16100','2013-10-09','12:05:00',7.57),('16100','2013-10-09','12:10:00',3.47),('16100','2013-10-09','12:15:00',1.76),('16100','2013-10-09','12:20:00',3.78),('16100','2013-10-09','12:25:00',7.98),('16100','2013-10-09','12:30:00',1.85),('16100','2013-10-09','12:35:00',7.44),('16100','2013-10-09','12:40:00',2.5),('16100','2013-10-09','12:45:00',3.53),('16100','2013-10-09','12:50:00',3.82),('16100','2013-10-09','12:55:00',6.08),('16100','2013-10-09','13:00:00',8.17),('16100','2013-10-09','13:05:00',7.69),('16100','2013-10-09','13:10:00',6.2),('16100','2013-10-09','13:15:00',2.36),('16100','2013-10-09','13:20:00',3.69),('16100','2013-10-09','13:25:00',4.34),('16100','2013-10-09','13:30:00',6.54),('16100','2013-10-09','13:35:00',4.19),('16100','2013-10-09','13:40:00',7.53),('16100','2013-10-09','13:45:00',6.42),('16100','2013-10-09','13:50:00',7.57),('16100','2013-10-09','13:55:00',7.25),('16100','2013-10-09','14:00:00',7.21),('16100','2013-10-09','14:05:00',7.08),('16100','2013-10-09','14:10:00',7.37),('16100','2013-10-09','14:15:00',1.63),('16100','2013-10-09','14:20:00',2.36),('16100','2013-10-09','14:25:00',1.94),('16100','2013-10-09','14:30:00',3.93),('16100','2013-10-09','14:35:00',1.95),('16100','2013-10-09','14:40:00',4.11),('16100','2013-10-09','14:45:00',3.97),('16100','2013-10-09','14:50:00',6.96),('16100','2013-10-09','14:55:00',3.29),('16100','2013-10-09','15:00:00',6.23),('16100','2013-10-09','15:05:00',4.79),('16100','2013-10-09','15:10:00',4.65),('16100','2013-10-09','15:15:00',2.81),('16100','2013-10-09','15:20:00',2.31),('16100','2013-10-09','15:25:00',3.01),('16100','2013-10-09','15:30:00',3.31),('16100','2013-10-09','15:35:00',2.77),('16100','2013-10-09','15:40:00',1.83),('16100','2013-10-09','15:45:00',2.75),('16100','2013-10-09','15:50:00',1.64),('16100','2013-10-09','15:55:00',3.68),('16100','2013-10-09','16:00:00',4.16),('16100','2013-10-09','16:05:00',5.64),('16100','2013-10-09','16:10:00',4.69),('16100','2013-10-09','16:15:00',2.62),('16100','2013-10-09','16:20:00',4.13),('16100','2013-10-09','16:25:00',4.17),('16100','2013-10-09','16:30:00',4.32),('16100','2013-10-09','16:35:00',4.08),('16100','2013-10-09','16:40:00',2.3),('16100','2013-10-09','16:55:00',3.19),('16100','2013-10-09','17:00:00',2.67),('16100','2013-10-09','17:05:00',2.14),('16100','2013-10-09','17:10:00',2.47),('16100','2013-10-09','17:15:00',2.48),('16100','2013-10-09','17:20:00',1.76),('16100','2013-10-08','08:25:00',1.16),('16100','2013-10-08','08:35:00',1.76),('16100','2013-10-08','08:40:00',1.93),('16100','2013-10-08','08:45:00',2.09),('16100','2013-10-08','08:50:00',2.32),('16100','2013-10-08','08:55:00',2.52),('16100','2013-10-08','09:00:00',2.68),('16100','2013-10-08','09:05:00',2.91),('16100','2013-10-08','09:10:00',3.09),('16100','2013-10-08','09:15:00',2.87),('16100','2013-10-08','09:20:00',3.45),('16100','2013-10-08','09:25:00',3.66),('16100','2013-10-08','09:30:00',4.02),('16100','2013-10-08','09:35:00',4.55),('16100','2013-10-08','09:40:00',4.85),('16100','2013-10-08','09:45:00',5.09),('16100','2013-10-08','09:50:00',4.92),('16100','2013-10-08','09:55:00',5.06),('16100','2013-10-08','10:00:00',4.41),('16100','2013-10-08','10:05:00',2.04),('16100','2013-10-08','10:10:00',1.18),('16100','2013-10-08','10:15:00',1.12),('16100','2013-10-08','10:20:00',2.13),('16100','2013-10-08','10:25:00',3.8),('16100','2013-10-08','10:30:00',5.63),('16100','2013-10-08','10:35:00',3.31),('16100','2013-10-08','10:40:00',2.97),('16100','2013-10-08','11:10:00',1.11),('16100','2013-10-08','11:15:00',1.36),('16100','2013-10-08','11:20:00',2.74),('16100','2013-10-08','11:25:00',4.05),('16100','2013-10-08','11:30:00',2.04),('16100','2013-10-08','11:35:00',5.4),('16100','2013-10-08','11:40:00',2.68),('16100','2013-10-08','11:45:00',3.47),('16100','2013-10-08','11:50:00',2.55),('16100','2013-10-08','11:55:00',4.13),('16100','2013-10-08','12:00:00',4.14),('16100','2013-10-08','12:05:00',3.09),('16100','2013-10-08','12:10:00',1.71),('16100','2013-10-08','12:25:00',1.31),('16100','2013-10-08','12:30:00',2.76),('16100','2013-10-08','12:35:00',1.84),('16100','2013-10-08','12:40:00',1.58),('16100','2013-10-08','12:45:00',1.42),('16100','2013-10-08','12:50:00',1.85),('16100','2013-10-08','12:55:00',2.15),('16100','2013-10-08','13:00:00',2.88),('16100','2013-10-08','13:05:00',4.08),('16100','2013-10-08','13:10:00',5.95),('16100','2013-10-08','13:15:00',5.45),('16100','2013-10-08','13:20:00',5.3),('16100','2013-10-08','13:25:00',3.33),('16100','2013-10-08','13:30:00',2.14),('16100','2013-10-08','13:35:00',2.42),('16100','2013-10-08','13:40:00',3.93),('16100','2013-10-08','13:45:00',2.87),('16100','2013-10-08','13:50:00',5.72),('16100','2013-10-08','13:55:00',7.26),('16100','2013-10-08','14:00:00',7.36),('16100','2013-10-08','14:05:00',7.05),('16100','2013-10-08','14:10:00',7.15),('16100','2013-10-08','14:15:00',5.03),('16100','2013-10-08','14:20:00',5.22),('16100','2013-10-08','14:25:00',2.32),('16100','2013-10-08','14:30:00',1.32),('16100','2013-10-08','14:35:00',2.28),('16100','2013-10-08','14:40:00',6.01),('16100','2013-10-08','14:45:00',4.64),('16100','2013-10-08','14:50:00',2.55),('16100','2013-10-08','14:55:00',4.25),('16100','2013-10-08','15:00:00',5.34),('16100','2013-10-08','15:05:00',5.82),('16100','2013-10-08','15:10:00',3.48),('16100','2013-10-08','15:15:00',1.68),('16100','2013-10-08','15:20:00',3.99),('16100','2013-10-08','15:25:00',4.4),('16100','2013-10-08','15:30:00',2.56),('16100','2013-10-08','15:35:00',2.42),('16100','2013-10-08','15:40:00',1.92),('16100','2013-10-08','15:45:00',4.53),('16100','2013-10-08','15:50:00',2.85),('16100','2013-10-08','15:55:00',3.97),('16100','2013-10-08','16:00:00',2.61),('16100','2013-10-08','16:05:00',1.35),('16100','2013-10-08','16:10:00',2.81),('16100','2013-10-08','16:15:00',3.48),('16100','2013-10-08','16:20:00',2.78),('16100','2013-10-08','16:25:00',3.82),('16100','2013-10-08','16:30:00',4.13),('16100','2013-10-08','16:35:00',2.88),('16100','2013-10-08','16:40:00',1.31),('16100','2013-10-08','16:45:00',1.12),('16100','2013-10-08','16:55:00',2.17),('16100','2013-10-08','17:30:00',1.14),('16100','2013-10-08','17:35:00',2.03),('16100','2013-10-08','17:40:00',1.28),('16100','2014-04-14','07:55:00',1.14),('16100','2014-04-14','08:55:00',2.75),('16100','2014-04-14','09:00:00',3.31),('16100','2014-04-14','09:05:00',2.67),('16100','2014-04-14','09:10:00',3.94),('16100','2014-04-14','09:15:00',3.48),('16100','2014-04-14','09:20:00',2.43),('16100','2014-04-14','09:25:00',1.69),('16100','2014-04-14','09:30:00',3.49),('16100','2014-04-14','09:35:00',3.28),('16100','2014-04-14','09:40:00',1.97),('16100','2014-04-14','09:45:00',3.58),('16100','2014-04-14','09:50:00',1.34),('16100','2014-04-14','10:00:00',1.04),('16100','2014-04-14','10:05:00',2.28),('16100','2014-04-14','10:10:00',2.44),('16100','2014-04-14','10:15:00',2.89),('16100','2014-04-14','10:20:00',3),('16100','2014-04-14','10:25:00',6.61),('16100','2014-04-14','10:30:00',5.4),('16100','2014-04-14','10:35:00',6.86),('16100','2014-04-14','10:40:00',6.17),('16100','2014-04-14','10:45:00',4.78),('16100','2014-04-14','10:50:00',6.53),('16100','2014-04-14','10:55:00',3.24),('16100','2014-04-14','11:00:00',4.4),('16100','2014-04-14','11:05:00',5.57),('16100','2014-04-14','11:10:00',4.2),('16100','2014-04-14','11:15:00',4.66),('16100','2014-04-14','11:20:00',1.54),('16100','2014-04-14','11:25:00',2.33),('16100','2014-04-14','11:30:00',2.29),('16100','2014-04-14','11:35:00',1.5),('16100','2014-04-14','11:40:00',1.69),('16100','2014-04-14','11:45:00',2.14),('16100','2014-04-14','11:50:00',1.92),('16100','2014-04-14','11:55:00',1.65),('16100','2014-04-14','12:00:00',1.07),('16100','2014-04-14','12:10:00',2.5),('16100','2014-04-14','12:15:00',3.73),('16100','2014-04-14','12:20:00',4.07),('16100','2014-04-14','12:25:00',1.55),('16100','2014-04-14','12:35:00',1.01),('16100','2014-04-14','12:40:00',1.01),('16100','2014-04-14','13:05:00',2.37),('16100','2014-04-14','13:10:00',3.62),('16100','2014-04-14','13:15:00',3.66),('16100','2014-04-14','13:20:00',2.91),('16100','2014-04-14','13:25:00',3.56),('16100','2014-04-14','13:30:00',2.72),('16100','2014-04-14','13:35:00',1.81),('16100','2014-04-14','13:40:00',3.57),('16100','2014-04-14','13:45:00',4.04),('16100','2014-04-14','13:50:00',4.45),('16100','2014-04-14','13:55:00',5.81),('16100','2014-04-14','14:00:00',5.22),('16100','2014-04-14','14:05:00',6.63),('16100','2014-04-14','14:10:00',8.3),('16100','2014-04-14','14:15:00',5.68),('16100','2014-04-14','14:20:00',6.22),('16100','2014-04-14','14:25:00',3.94),('16100','2014-04-14','14:30:00',3.09),('16100','2014-04-14','14:35:00',6.4),('16100','2014-04-14','14:40:00',8.13),('16100','2014-04-14','14:45:00',6.91),('16100','2014-04-14','14:50:00',6.49),('16100','2014-04-14','14:55:00',4.78),('16100','2014-04-14','15:00:00',3.24),('16100','2014-04-14','15:05:00',2.65),('16100','2014-04-14','15:10:00',2.8),('16100','2014-04-14','15:15:00',5.58),('16100','2014-04-14','15:20:00',7.75),('16100','2014-04-14','15:25:00',5.93),('16100','2014-04-14','15:30:00',3.99),('16100','2014-04-14','15:35:00',3.3),('16100','2014-04-14','15:40:00',3.53),('16100','2014-04-14','15:45:00',2.78),('16100','2014-04-14','15:50:00',2.37),('16100','2014-04-14','15:55:00',1.81),('16100','2014-04-14','16:00:00',1.81),('16100','2014-04-14','16:05:00',1.63),('16100','2014-04-14','16:10:00',1.4),('16100','2014-04-14','16:15:00',1.26),('16100','2013-10-07','08:05:00',1.02),('16100','2013-10-07','08:10:00',1.42),('16100','2013-10-07','08:15:00',1.77),('16100','2013-10-07','08:20:00',1.07),('16100','2013-10-07','09:50:00',3.75),('16100','2013-10-07','09:55:00',1.44),('16100','2013-10-07','10:00:00',5.3),('16100','2013-10-07','10:05:00',6.01),('16100','2013-10-07','10:10:00',5.76),('16100','2013-10-07','10:15:00',3.39),('16100','2013-10-07','10:20:00',1.11),('16100','2013-10-07','10:55:00',1.1),('16100','2013-10-07','11:00:00',1.38),('16100','2013-10-07','11:05:00',1.34),('16100','2013-10-07','11:10:00',1.24),('16100','2013-10-07','11:15:00',1.25),('16100','2013-10-07','11:20:00',2.47),('16100','2013-10-07','11:25:00',4.07),('16100','2013-10-07','11:30:00',1.55),('16100','2013-10-07','11:35:00',1.16),('16100','2013-10-07','12:25:00',1.92),('16100','2013-10-07','12:30:00',1.84),('16100','2013-10-07','12:35:00',4.43),('16100','2013-10-07','12:40:00',2.92),('16100','2013-10-07','12:45:00',1.76),('16100','2013-10-07','12:50:00',2.02),('16100','2013-10-07','12:55:00',4.46),('16100','2013-10-07','13:00:00',3.58),('16100','2013-10-07','13:05:00',6.15),('16100','2013-10-07','13:10:00',4.15),('16100','2013-10-07','13:15:00',1.97),('16100','2013-10-07','13:20:00',4.42),('16100','2013-10-07','13:25:00',4.2),('16100','2013-10-07','13:30:00',1.79),('16100','2013-10-07','13:35:00',1.77),('16100','2013-10-07','13:40:00',1.35),('16100','2013-10-07','13:45:00',1.8),('16100','2013-10-07','13:50:00',2.08),('16100','2013-10-07','13:55:00',1.41),('16100','2013-10-07','14:00:00',1.1),('16100','2013-10-07','14:20:00',1.92),('16100','2013-10-07','14:25:00',2.6),('16100','2013-10-07','14:30:00',5.1),('16100','2013-10-07','14:35:00',7.83),('16100','2013-10-07','14:40:00',6.38),('16100','2013-10-07','14:45:00',5.56),('16100','2013-10-07','14:50:00',6.32),('16100','2013-10-07','14:55:00',6.16),('16100','2013-10-07','15:00:00',6.06),('16100','2013-10-07','15:05:00',5.96),('16100','2013-10-07','15:10:00',6),('16100','2013-10-07','15:15:00',4.47),('16100','2013-10-07','15:20:00',4.99),('16100','2013-10-07','15:25:00',2.33),('16100','2013-10-07','15:30:00',1.45),('16100','2013-10-07','15:35:00',1.01),('16100','2013-10-07','15:45:00',1.28),('16100','2013-10-07','15:55:00',1.05),('16100','2013-10-06','08:20:00',1.16),('16100','2013-10-06','08:25:00',1.35),('16100','2013-10-06','08:30:00',1.42),('16100','2013-10-06','08:35:00',1.66),('16100','2013-10-06','08:40:00',1.96),('16100','2013-10-06','08:45:00',1.26),('16100','2013-10-06','09:00:00',1.05),('16100','2013-10-06','09:05:00',1.47),('16100','2013-10-06','09:10:00',3.1),('16100','2013-10-06','09:15:00',3.84),('16100','2013-10-06','09:20:00',3.5),('16100','2013-10-06','09:25:00',3.55),('16100','2013-10-06','09:30:00',3.7),('16100','2013-10-06','09:35:00',3.85),('16100','2013-10-06','09:40:00',3.95),('16100','2013-10-06','09:45:00',4.1),('16100','2013-10-06','09:50:00',4.22),('16100','2013-10-06','09:55:00',4.35),('16100','2013-10-06','10:00:00',4.52),('16100','2013-10-06','10:05:00',4.59),('16100','2013-10-06','10:10:00',4.72),('16100','2013-10-06','10:15:00',4.85),('16100','2013-10-06','10:20:00',4.96),('16100','2013-10-06','10:25:00',5.11),('16100','2013-10-06','10:30:00',5.28),('16100','2013-10-06','10:35:00',5.43),('16100','2013-10-06','10:40:00',5.52),('16100','2013-10-06','10:45:00',5.43),('16100','2013-10-06','10:50:00',4.99),('16100','2013-10-06','10:55:00',5.47),('16100','2013-10-06','11:00:00',4.78),('16100','2013-10-06','11:05:00',6.08),('16100','2013-10-06','11:10:00',6.07),('16100','2013-10-06','11:15:00',6.07),('16100','2013-10-06','11:20:00',6.12),('16100','2013-10-06','11:25:00',6.18),('16100','2013-10-06','11:30:00',6.26),('16100','2013-10-06','11:35:00',6.51),('16100','2013-10-06','11:40:00',6.49),('16100','2013-10-06','11:45:00',6.63),('16100','2013-10-06','11:50:00',3.46),('16100','2013-10-06','11:55:00',6.36),('16100','2013-10-06','12:00:00',6.86),('16100','2013-10-06','12:05:00',6.71),('16100','2013-10-06','12:10:00',2.2),('16100','2013-10-06','12:15:00',5.89),('16100','2013-10-06','12:20:00',7.18),('16100','2013-10-06','12:25:00',3.65),('16100','2013-10-06','12:30:00',5.11),('16100','2013-10-06','12:35:00',3.13),('16100','2013-10-06','12:40:00',1.35),('16100','2013-10-06','12:45:00',4.05),('16100','2013-10-06','12:50:00',2.58),('16100','2013-10-06','12:55:00',3.94),('16100','2013-10-06','13:00:00',2.76),('16100','2013-10-06','13:05:00',7.77),('16100','2013-10-06','13:10:00',5.01),('16100','2013-10-06','13:15:00',7.48),('16100','2013-10-06','13:20:00',4.8),('16100','2013-10-06','13:25:00',5.71),('16100','2013-10-06','13:30:00',1.49),('16100','2013-10-06','13:35:00',3.38),('16100','2013-10-06','13:40:00',1.22),('16100','2013-10-06','13:45:00',1.4),('16100','2013-10-06','13:50:00',4.4),('16100','2013-10-06','13:55:00',2.34),('16100','2013-10-06','14:00:00',2.95),('16100','2013-10-06','14:05:00',7.43),('16100','2013-10-06','14:10:00',8.33),('16100','2013-10-06','14:15:00',6.25),('16100','2013-10-06','14:20:00',4.93),('16100','2013-10-06','14:25:00',3.86),('16100','2013-10-06','14:30:00',6.35),('16100','2013-10-06','14:35:00',3.55),('16100','2013-10-06','14:40:00',4.22),('16100','2013-10-06','14:45:00',4.05),('16100','2013-10-06','14:50:00',6.4),('16100','2013-10-06','14:55:00',4.44),('16100','2013-10-06','15:00:00',2.2),('16100','2013-10-06','15:05:00',6),('16100','2013-10-06','15:10:00',3.92),('16100','2013-10-06','15:15:00',4.53),('16100','2013-10-06','15:20:00',2.47),('16100','2013-10-06','15:25:00',1.52),('16100','2013-10-06','15:30:00',2.48),('16100','2013-10-06','15:35:00',6.49),('16100','2013-10-06','15:40:00',3.14),('16100','2013-10-06','15:45:00',3.7),('16100','2013-10-06','15:50:00',3.19),('16100','2013-10-06','15:55:00',5.37),('16100','2013-10-06','16:00:00',4.81),('16100','2013-10-06','16:05:00',1.61),('16100','2013-10-06','16:10:00',1.85),('16100','2013-10-06','16:15:00',3.53),('16100','2013-10-06','16:20:00',4.51),('16100','2013-10-06','16:25:00',4.16),('16100','2013-10-06','16:30:00',3.16),('16100','2013-10-06','16:35:00',3.7),('16100','2013-10-06','16:40:00',3.49),('16100','2013-10-06','16:45:00',3.27),('16100','2013-10-06','16:50:00',3.03),('16100','2013-10-06','16:55:00',2.8),('16100','2013-10-06','17:00:00',2.6),('16100','2013-10-06','17:05:00',2.46),('16100','2013-10-06','17:10:00',2.28),('16100','2013-10-06','17:15:00',2.12),('16100','2013-10-06','17:20:00',1.95),('16100','2013-10-06','17:25:00',1.76),('16100','2013-10-06','17:30:00',1.59),('16100','2013-10-06','17:35:00',1.43),('16100','2013-10-06','17:40:00',1.26),('16100','2013-10-06','17:45:00',1.1),('16100','2013-10-05','08:55:00',1.33),('16100','2013-10-05','09:00:00',1.29),('16100','2013-10-05','09:05:00',2.12),('16100','2013-10-05','09:10:00',1.22),('16100','2013-10-05','09:20:00',1.51),('16100','2013-10-05','09:25:00',2.2),('16100','2013-10-05','09:30:00',3.84),('16100','2013-10-05','09:35:00',3.9),('16100','2013-10-05','09:40:00',3.53),('16100','2013-10-05','09:45:00',3.1),('16100','2013-10-05','09:50:00',4.21),('16100','2013-10-05','09:55:00',4.5),('16100','2013-10-05','10:00:00',4.82),('16100','2013-10-05','10:05:00',4.35),('16100','2013-10-05','10:10:00',4.42),('16100','2013-10-05','10:15:00',4.32),('16100','2013-10-05','10:20:00',4.28),('16100','2013-10-05','10:25:00',4.88),('16100','2013-10-05','10:30:00',4.78),('16100','2013-10-05','10:35:00',4.38),('16100','2013-10-05','10:40:00',3.65),('16100','2013-10-05','10:45:00',4.13),('16100','2013-10-05','10:50:00',4.48),('16100','2013-10-05','10:55:00',4.8),('16100','2013-10-05','11:00:00',5.57),('16100','2013-10-05','11:05:00',4.84),('16100','2013-10-05','11:10:00',5.6),('16100','2013-10-05','11:15:00',5.62),('16100','2013-10-05','11:20:00',5.4),('16100','2013-10-05','11:25:00',5.06),('16100','2013-10-05','11:30:00',5.17),('16100','2013-10-05','11:35:00',4.45),('16100','2013-10-05','11:40:00',4.11),('16100','2013-10-05','11:45:00',2.94),('16100','2013-10-05','11:50:00',4.84),('16100','2013-10-05','11:55:00',4.33),('16100','2013-10-05','12:00:00',6.18),('16100','2013-10-05','12:05:00',6.11),('16100','2013-10-05','12:10:00',6.73),('16100','2013-10-05','12:15:00',5.18),('16100','2013-10-05','12:20:00',5.31),('16100','2013-10-05','12:25:00',4.8),('16100','2013-10-05','12:30:00',3.16),('16100','2013-10-05','12:35:00',6.33),('16100','2013-10-05','12:40:00',5.46),('16100','2013-10-05','12:45:00',6.14),('16100','2013-10-05','12:50:00',6.9),('16100','2013-10-05','12:55:00',6.31),('16100','2013-10-05','13:00:00',6.61),('16100','2013-10-05','13:05:00',6.91),('16100','2013-10-05','13:10:00',5.44),('16100','2013-10-05','13:15:00',6.15),('16100','2013-10-05','13:20:00',5.8),('16100','2013-10-05','13:25:00',3.23),('16100','2013-10-05','13:30:00',1.86),('16100','2013-10-05','13:35:00',1.47),('16100','2013-10-05','13:40:00',1.39),('16100','2013-10-05','13:45:00',1.54),('16100','2013-10-05','13:50:00',2.6),('16100','2013-10-05','13:55:00',4.27),('16100','2013-10-05','14:00:00',4.03),('16100','2013-10-05','14:05:00',5.5),('16100','2013-10-05','14:10:00',4.12),('16100','2013-10-05','14:15:00',4.61),('16100','2013-10-05','14:20:00',3.71),('16100','2013-10-05','14:25:00',3.59),('16100','2013-10-05','14:30:00',4.83),('16100','2013-10-05','14:35:00',4.69),('16100','2013-10-05','14:40:00',5),('16100','2013-10-05','14:45:00',2.94),('16100','2013-10-05','14:50:00',2.05),('16100','2013-10-05','14:55:00',3.03),('16100','2013-10-05','15:00:00',3.29),('16100','2013-10-05','15:05:00',3.86),('16100','2013-10-05','15:10:00',3.1),('16100','2013-10-05','15:15:00',2.75),('16100','2013-10-05','15:20:00',1.76),('16100','2013-10-05','15:25:00',1.57),('16100','2013-10-05','15:30:00',1.52),('16100','2013-10-05','15:35:00',1.43),('16100','2013-10-05','15:40:00',1.24),('16100','2013-10-05','15:45:00',1.09),('16100','2013-10-05','15:55:00',2.16),('16100','2013-10-05','16:00:00',1.6),('16100','2013-10-05','16:05:00',1.01),('16100','2013-10-05','17:10:00',1.74),('16100','2013-10-05','17:15:00',1.48),('16100','2013-10-05','17:20:00',1.25),('16100','2013-10-04','15:35:00',1.05),('16100','2013-10-04','15:40:00',1.07),('16100','2013-10-04','15:45:00',1.15),('16100','2013-10-04','15:50:00',1.29),('16100','2013-10-04','15:55:00',1.51),('16100','2013-10-04','16:00:00',2),('16100','2013-10-04','16:05:00',2.14),('16100','2013-10-04','16:10:00',1.9),('16100','2013-10-04','16:15:00',1.88),('16100','2013-10-04','16:20:00',1.79),('16100','2013-10-04','16:25:00',1.52),('16100','2013-10-04','16:30:00',1.38),('16100','2013-10-04','16:35:00',1.54),('16100','2013-10-04','16:40:00',1.36),('16100','2013-10-04','16:45:00',1.83),('16100','2013-10-04','16:50:00',1.75),('16100','2013-10-04','16:55:00',1.86),('16100','2013-10-04','17:00:00',1.13),('16100','2013-10-04','17:05:00',1.15),('16100','2013-10-04','17:10:00',1.2),('16100','2013-10-04','17:15:00',1.12),('16100','2013-10-03','08:45:00',1.09),('16100','2013-10-03','08:55:00',1.03),('16100','2013-10-03','09:05:00',1.14),('16100','2013-10-03','09:10:00',1.08),('16100','2013-10-03','09:15:00',1),('16100','2013-10-03','09:20:00',1.5),('16100','2013-10-03','09:25:00',1.69),('16100','2013-10-03','09:30:00',1.86),('16100','2013-10-03','09:35:00',1.76),('16100','2013-10-03','09:40:00',1.72),('16100','2013-10-03','09:45:00',2.06),('16100','2013-10-03','09:50:00',2.95),('16100','2013-10-03','09:55:00',3.62),('16100','2013-10-03','10:00:00',2.36),('16100','2013-10-03','10:05:00',2.31),('16100','2013-10-03','10:10:00',2.65),('16100','2013-10-03','10:15:00',2.41),('16100','2013-10-03','10:20:00',2.74),('16100','2013-10-03','10:25:00',3.53),('16100','2013-10-03','10:30:00',4.39),('16100','2013-10-03','10:35:00',2.78),('16100','2013-10-03','10:40:00',6.98),('16100','2013-10-03','10:45:00',5.02),('16100','2013-10-03','10:50:00',4.79),('16100','2013-10-03','10:55:00',4.5),('16100','2013-10-03','11:00:00',2.89),('16100','2013-10-03','11:05:00',2.67),('16100','2013-10-03','11:10:00',3.59),('16100','2013-10-03','11:15:00',4.23),('16100','2013-10-03','11:20:00',4.26),('16100','2013-10-03','11:25:00',7.33),('16100','2013-10-03','11:30:00',6.37),('16100','2013-10-03','11:35:00',6.31),('16100','2013-10-03','11:40:00',6.76),('16100','2013-10-03','11:45:00',6.63),('16100','2013-10-03','11:50:00',6.64),('16100','2013-10-03','11:55:00',6.73),('16100','2013-10-03','12:00:00',6.85),('16100','2013-10-03','12:05:00',6.9),('16100','2013-10-03','12:10:00',6.79),('16100','2013-10-03','12:15:00',6.94),('16100','2013-10-03','12:20:00',6.98),('16100','2013-10-03','12:25:00',7.15),('16100','2013-10-03','12:30:00',6.89),('16100','2013-10-03','12:35:00',6.96),('16100','2013-10-03','12:40:00',6.83),('16100','2013-10-03','12:45:00',6.92),('16100','2013-10-03','12:50:00',6.62),('16100','2013-10-03','12:55:00',6.74),('16100','2013-10-03','13:00:00',6.79),('16100','2013-10-03','13:05:00',6.76),('16100','2013-10-03','13:10:00',6.95),('16100','2013-10-03','13:15:00',7.05),('16100','2013-10-03','13:20:00',6.58),('16100','2013-10-03','13:25:00',6.8),('16100','2013-10-03','13:30:00',7.08),('16100','2013-10-03','13:35:00',6.8),('16100','2013-10-03','13:40:00',6.76),('16100','2013-10-03','13:45:00',6.65),('16100','2013-10-03','13:50:00',6.71),('16100','2013-10-03','13:55:00',6.78),('16100','2013-10-03','14:00:00',6.71),('16100','2013-10-03','14:05:00',6.26),('16100','2013-10-03','14:10:00',5.38),('16100','2013-10-03','14:15:00',5.61),('16100','2013-10-03','14:20:00',6.54),('16100','2013-10-03','14:25:00',5.69),('16100','2013-10-03','14:30:00',4.58),('16100','2013-10-03','14:35:00',3.24),('16100','2013-10-03','14:40:00',3.34),('16100','2013-10-03','14:45:00',4.43),('16100','2013-10-03','14:50:00',5.12),('16100','2013-10-03','14:55:00',4.06),('16100','2013-10-03','15:00:00',4.73),('16100','2013-10-03','15:05:00',4.37),('16100','2013-10-03','15:10:00',3.42),('16100','2013-10-03','15:15:00',2.74),('16100','2013-10-03','15:20:00',4.11),('16100','2013-10-03','15:25:00',3.59),('16100','2013-10-03','15:30:00',2.61),('16100','2013-10-03','15:35:00',1.96),('16100','2013-10-03','15:40:00',1.5),('16100','2013-10-03','15:45:00',1.33),('16100','2013-10-03','15:50:00',1.33),('16100','2013-10-03','15:55:00',1.61),('16100','2013-10-03','16:00:00',1.9),('16100','2013-10-03','16:05:00',1.81),('16100','2013-10-03','16:10:00',1.5),('16100','2013-10-03','16:15:00',1.29),('16100','2013-10-02','08:15:00',1.16),('16100','2013-10-02','08:20:00',1.35),('16100','2013-10-02','08:25:00',1.54),('16100','2013-10-02','08:30:00',1.74),('16100','2013-10-02','08:35:00',1.95),('16100','2013-10-02','08:40:00',2.14),('16100','2013-10-02','08:45:00',2.33),('16100','2013-10-02','08:50:00',2.54),('16100','2013-10-02','08:55:00',2.74),('16100','2013-10-02','09:00:00',2.92),('16100','2013-10-02','09:05:00',3.1),('16100','2013-10-02','09:10:00',3.26),('16100','2013-10-02','09:15:00',3.42),('16100','2013-10-02','09:20:00',3.66),('16100','2013-10-02','09:25:00',3.85),('16100','2013-10-02','09:30:00',4.01),('16100','2013-10-02','09:35:00',4.15),('16100','2013-10-02','09:40:00',4.31),('16100','2013-10-02','09:45:00',4.42),('16100','2013-10-02','09:50:00',4.6),('16100','2013-10-02','09:55:00',4.77),('16100','2013-10-02','10:00:00',4.9),('16100','2013-10-02','10:05:00',5.06),('16100','2013-10-02','10:10:00',5.17),('16100','2013-10-02','10:15:00',5.31),('16100','2013-10-02','10:20:00',5.47),('16100','2013-10-02','10:25:00',5.59),('16100','2013-10-02','10:30:00',5.72),('16100','2013-10-02','10:35:00',5.89),('16100','2013-10-02','10:40:00',5.99),('16100','2013-10-02','10:45:00',6.05),('16100','2013-10-02','10:50:00',6.16),('16100','2013-10-02','10:55:00',6.26),('16100','2013-10-02','11:00:00',6.32),('16100','2013-10-02','11:05:00',6.4),('16100','2013-10-02','11:10:00',6.5),('16100','2013-10-02','11:15:00',6.64),('16100','2013-10-02','11:20:00',6.74),('16100','2013-10-02','11:25:00',6.79),('16100','2013-10-02','11:30:00',6.84),('16100','2013-10-02','11:35:00',6.91),('16100','2013-10-02','11:40:00',7.01),('16100','2013-10-02','11:45:00',7.08),('16100','2013-10-02','11:50:00',7.15),('16100','2013-10-02','11:55:00',7.1),('16100','2013-10-02','12:00:00',7.14),('16100','2013-10-02','12:05:00',7.19),('16100','2013-10-02','12:10:00',7.24),('16100','2013-10-02','12:15:00',7.29),('16100','2013-10-02','12:20:00',7.32),('16100','2013-10-02','12:25:00',7.36),('16100','2013-10-02','12:30:00',7.35),('16100','2013-10-02','12:35:00',7.35),('16100','2013-10-02','12:40:00',7.41),('16100','2013-10-02','12:45:00',7.45),('16100','2013-10-02','12:50:00',7.44),('16100','2013-10-02','12:55:00',7.47),('16100','2013-10-02','13:00:00',7.46),('16100','2013-10-02','13:05:00',7.47),('16100','2013-10-02','13:10:00',7.51),('16100','2013-10-02','13:15:00',7.44),('16100','2013-10-02','13:20:00',7.47),('16100','2013-10-02','13:25:00',7.46),('16100','2013-10-02','13:30:00',7.44),('16100','2013-10-02','13:35:00',7.37),('16100','2013-10-02','13:40:00',7.32),('16100','2013-10-02','13:45:00',7.27),('16100','2013-10-02','13:50:00',7.27),('16100','2013-10-02','13:55:00',7.23),('16100','2013-10-02','14:00:00',7.11),('16100','2013-10-02','14:05:00',7.07),('16100','2013-10-02','14:10:00',6.99),('16100','2013-10-02','14:15:00',6.92),('16100','2013-10-02','14:20:00',6.88),('16100','2013-10-02','14:25:00',6.8),('16100','2013-10-02','14:30:00',6.75),('16100','2013-10-02','14:35:00',6.66),('16100','2013-10-02','14:40:00',6.59),('16100','2013-10-02','14:45:00',6.51),('16100','2013-10-02','14:50:00',6.41),('16100','2013-10-02','14:55:00',6.3),('16100','2013-10-02','15:00:00',6.19),('16100','2013-10-02','15:05:00',6.14),('16100','2013-10-02','15:10:00',5.95),('16100','2013-10-02','15:15:00',5.87),('16100','2013-10-02','15:20:00',5.76),('16100','2013-10-02','15:25:00',5.68),('16100','2013-10-02','15:30:00',5.56),('16100','2013-10-02','15:35:00',5.4),('16100','2013-10-02','15:40:00',5.32),('16100','2013-10-02','15:45:00',5.27),('16100','2013-10-02','15:50:00',5.13),('16100','2013-10-02','15:55:00',5),('16100','2013-10-02','16:00:00',4.82),('16100','2013-10-02','16:05:00',4.69),('16100','2013-10-02','16:10:00',4.55),('16100','2013-10-02','16:15:00',4.4),('16100','2013-10-02','16:20:00',4.26),('16100','2013-10-02','16:25:00',4.11),('16100','2013-10-02','16:30:00',3.96),('16100','2013-10-02','16:35:00',3.79),('16100','2013-10-02','16:40:00',3.63),('16100','2013-10-02','16:45:00',3.45),('16100','2013-10-02','16:50:00',3.28),('16100','2013-10-02','16:55:00',3.1),('16100','2013-10-02','17:00:00',2.91),('16100','2013-10-02','17:05:00',2.72),('16100','2013-10-02','17:10:00',2.53),('16100','2013-10-02','17:15:00',2.33),('16100','2013-10-02','17:20:00',2.12),('16100','2013-10-02','17:25:00',1.95),('16100','2013-10-02','17:30:00',1.78),('16100','2013-10-02','17:35:00',1.6),('16100','2013-10-02','17:40:00',1.4),('16100','2013-10-02','17:45:00',1.24),('16100','2013-10-02','17:50:00',1.07),('16100','2013-10-01','08:20:00',1.16),('16100','2013-10-01','08:25:00',1.4),('16100','2013-10-01','08:30:00',1.63),('16100','2013-10-01','08:35:00',1.81),('16100','2013-10-01','08:40:00',2),('16100','2013-10-01','08:45:00',2.19),('16100','2013-10-01','08:50:00',2.39),('16100','2013-10-01','08:55:00',2.58),('16100','2013-10-01','09:00:00',2.76),('16100','2013-10-01','09:05:00',2.91),('16100','2013-10-01','09:10:00',3.07),('16100','2013-10-01','09:15:00',3.24),('16100','2013-10-01','09:20:00',3.47),('16100','2013-10-01','09:25:00',3.65),('16100','2013-10-01','09:30:00',3.8),('16100','2013-10-01','09:35:00',3.93),('16100','2013-10-01','09:40:00',4.06),('16100','2013-10-01','09:45:00',4.21),('16100','2013-10-01','09:50:00',4.38),('16100','2013-10-01','09:55:00',4.53),('16100','2013-10-01','10:00:00',4.69),('16100','2013-10-01','10:05:00',4.8),('16100','2013-10-01','10:10:00',4.92),('16100','2013-10-01','10:15:00',5.03),('16100','2013-10-01','10:20:00',5.14),('16100','2013-10-01','10:25:00',5.29),('16100','2013-10-01','10:30:00',5.46),('16100','2013-10-01','10:35:00',5.57),('16100','2013-10-01','10:40:00',5.64),('16100','2013-10-01','10:45:00',5.72),('16100','2013-10-01','10:50:00',5.83),('16100','2013-10-01','10:55:00',5.89),('16100','2013-10-01','11:00:00',5.99),('16100','2013-10-01','11:05:00',6.09),('16100','2013-10-01','11:10:00',6.18),('16100','2013-10-01','11:15:00',6.3),('16100','2013-10-01','11:20:00',6.42),('16100','2013-10-01','11:25:00',6.48),('16100','2013-10-01','11:30:00',6.56),('16100','2013-10-01','11:35:00',6.61),('16100','2013-10-01','11:40:00',6.67),('16100','2013-10-01','11:45:00',6.7),('16100','2013-10-01','11:50:00',6.73),('16100','2013-10-01','11:55:00',6.84),('16100','2013-10-01','12:00:00',6.87),('16100','2013-10-01','12:05:00',6.9),('16100','2013-10-01','12:10:00',6.94),('16100','2013-10-01','12:15:00',6.95),('16100','2013-10-01','12:20:00',7.02),('16100','2013-10-01','12:25:00',7.08),('16100','2013-10-01','12:30:00',7.12),('16100','2013-10-01','12:35:00',7.17),('16100','2013-10-01','12:40:00',7.14),('16100','2013-10-01','12:45:00',7.15),('16100','2013-10-01','12:50:00',7.15),('16100','2013-10-01','12:55:00',7.19),('16100','2013-10-01','13:00:00',7.23),('16100','2013-10-01','13:05:00',7.19),('16100','2013-10-01','13:10:00',7.17),('16100','2013-10-01','13:15:00',7.15),('16100','2013-10-01','13:20:00',7.13),('16100','2013-10-01','13:25:00',7.09),('16100','2013-10-01','13:30:00',7.02),('16100','2013-10-01','13:35:00',7.03),('16100','2013-10-01','13:40:00',6.95),('16100','2013-10-01','13:45:00',6.92),('16100','2013-10-01','13:50:00',6.88),('16100','2013-10-01','13:55:00',6.9),('16100','2013-10-01','14:00:00',6.78),('16100','2013-10-01','14:05:00',6.73),('16100','2013-10-01','14:10:00',6.68),('16100','2013-10-01','14:15:00',6.64),('16100','2013-10-01','14:20:00',6.58),('16100','2013-10-01','14:25:00',6.49),('16100','2013-10-01','14:30:00',6.46),('16100','2013-10-01','14:35:00',6.48),('16100','2013-10-01','14:40:00',6.36),('16100','2013-10-01','14:45:00',6.27),('16100','2013-10-01','14:50:00',6.22),('16100','2013-10-01','14:55:00',6.14),('16100','2013-10-01','15:00:00',6.06),('16100','2013-10-01','15:05:00',5.96),('16100','2013-10-01','15:10:00',5.83),('16100','2013-10-01','15:15:00',5.71),('16100','2013-10-01','15:20:00',5.59),('16100','2013-10-01','15:25:00',5.54),('16100','2013-10-01','15:30:00',5.41),('16100','2013-10-01','15:35:00',5.3),('16100','2013-10-01','15:40:00',5.21),('16100','2013-10-01','15:45:00',5.07),('16100','2013-10-01','15:50:00',4.92),('16100','2013-10-01','15:55:00',4.83),('16100','2013-10-01','16:00:00',4.67),('16100','2013-10-01','16:05:00',4.54),('16100','2013-10-01','16:10:00',4.39),('16100','2013-10-01','16:15:00',4.22),('16100','2013-10-01','16:20:00',4.07),('16100','2013-10-01','16:25:00',3.94),('16100','2013-10-01','16:30:00',3.81),('16100','2013-10-01','16:35:00',3.63),('16100','2013-10-01','16:40:00',3.49),('16100','2013-10-01','16:45:00',3.29),('16100','2013-10-01','16:50:00',3.14),('16100','2013-10-01','16:55:00',2.96),('16100','2013-10-01','17:00:00',2.76),('16100','2013-10-01','17:05:00',2.54),('16100','2013-10-01','17:10:00',2.37),('16100','2013-10-01','17:15:00',2.18),('16100','2013-10-01','17:20:00',1.97),('16100','2013-10-01','17:25:00',1.77),('16100','2013-10-01','17:30:00',1.6),('16100','2013-10-01','17:35:00',1.46),('16100','2013-10-01','17:40:00',1.28),('16100','2013-10-01','17:45:00',1.1),('16100','2013-09-30','08:15:00',1.09),('16100','2013-09-30','08:20:00',1.19),('16100','2013-09-30','08:25:00',1.45),('16100','2013-09-30','08:30:00',1.66),('16100','2013-09-30','08:35:00',1.85),('16100','2013-09-30','08:40:00',2.03),('16100','2013-09-30','08:45:00',2.23),('16100','2013-09-30','08:50:00',2.4),('16100','2013-09-30','08:55:00',2.53),('16100','2013-09-30','09:00:00',2.75),('16100','2013-09-30','09:05:00',2.92),('16100','2013-09-30','09:10:00',3.05),('16100','2013-09-30','09:15:00',3.2),('16100','2013-09-30','09:20:00',3.41),('16100','2013-09-30','09:25:00',3.53),('16100','2013-09-30','09:30:00',3.71),('16100','2013-09-30','09:35:00',3.87),('16100','2013-09-30','09:40:00',3.96),('16100','2013-09-30','09:45:00',4.1),('16100','2013-09-30','09:50:00',4.31),('16100','2013-09-30','09:55:00',4.39),('16100','2013-09-30','10:00:00',4.45),('16100','2013-09-30','10:05:00',4.59),('16100','2013-09-30','10:10:00',4.69),('16100','2013-09-30','10:15:00',4.81),('16100','2013-09-30','10:20:00',5.01),('16100','2013-09-30','10:25:00',5.17),('16100','2013-09-30','10:30:00',5.34),('16100','2013-09-30','10:35:00',5.06),('16100','2013-09-30','10:40:00',4.81),('16100','2013-09-30','10:45:00',5.7),('16100','2013-09-30','10:50:00',5.81),('16100','2013-09-30','10:55:00',5.73),('16100','2013-09-30','11:00:00',5.86),('16100','2013-09-30','11:05:00',6.09),('16100','2013-09-30','11:10:00',6.2),('16100','2013-09-30','11:15:00',6.4),('16100','2013-09-30','11:20:00',6.62),('16100','2013-09-30','11:25:00',6.71),('16100','2013-09-30','11:30:00',6.54),('16100','2013-09-30','11:35:00',6.5),('16100','2013-09-30','11:40:00',6.63),('16100','2013-09-30','11:45:00',6.93),('16100','2013-09-30','11:50:00',7.09),('16100','2013-09-30','11:55:00',5.77),('16100','2013-09-30','12:00:00',7.34),('16100','2013-09-30','12:05:00',1.51),('16100','2013-09-30','12:10:00',4.15),('16100','2013-09-30','12:15:00',4.88),('16100','2013-09-30','12:20:00',4.04),('16100','2013-09-30','12:25:00',6.59),('16100','2013-09-30','12:30:00',7.42),('16100','2013-09-30','12:35:00',6.68),('16100','2013-09-30','12:40:00',2.9),('16100','2013-09-30','12:45:00',7.53),('16100','2013-09-30','12:50:00',5.54),('16100','2013-09-30','12:55:00',4.04),('16100','2013-09-30','13:00:00',2.08),('16100','2013-09-30','13:05:00',4.52),('16100','2013-09-30','13:10:00',6.95),('16100','2013-09-30','13:15:00',4.71),('16100','2013-09-30','13:20:00',3.49),('16100','2013-09-30','13:25:00',7.6),('16100','2013-09-30','13:30:00',7.42),('16100','2013-09-30','13:35:00',7.52),('16100','2013-09-30','13:40:00',7.29),('16100','2013-09-30','13:45:00',6.95),('16100','2013-09-30','13:50:00',6.87),('16100','2013-09-30','13:55:00',6.84),('16100','2013-09-30','14:00:00',6.76),('16100','2013-09-30','14:05:00',6.64),('16100','2013-09-30','14:10:00',6.59),('16100','2013-09-30','14:15:00',6.57),('16100','2013-09-30','14:20:00',6.5),('16100','2013-09-30','14:25:00',6.41),('16100','2013-09-30','14:30:00',6.2),('16100','2013-09-30','14:35:00',5.67),('16100','2013-09-30','14:40:00',5.25),('16100','2013-09-30','14:45:00',6.15),('16100','2013-09-30','14:50:00',6.44),('16100','2013-09-30','14:55:00',6.21),('16100','2013-09-30','15:00:00',6.08),('16100','2013-09-30','15:05:00',5.95),('16100','2013-09-30','15:10:00',5.79),('16100','2013-09-30','15:15:00',5.69),('16100','2013-09-30','15:20:00',5.59),('16100','2013-09-30','15:25:00',5.55),('16100','2013-09-30','15:30:00',5.42),('16100','2013-09-30','15:35:00',5.28),('16100','2013-09-30','15:40:00',5.14),('16100','2013-09-30','15:45:00',5.02),('16100','2013-09-30','15:50:00',4.9),('16100','2013-09-30','15:55:00',4.76),('16100','2013-09-30','16:00:00',4.61),('16100','2013-09-30','16:05:00',4.51),('16100','2013-09-30','16:10:00',4.4),('16100','2013-09-30','16:15:00',4.28),('16100','2013-09-30','16:20:00',4.14),('16100','2013-09-30','16:25:00',4),('16100','2013-09-30','16:30:00',3.87),('16100','2013-09-30','16:35:00',3.72),('16100','2013-09-30','16:40:00',3.54),('16100','2013-09-30','16:45:00',3.36),('16100','2013-09-30','16:50:00',3.21),('16100','2013-09-30','16:55:00',3.05),('16100','2013-09-30','17:00:00',2.81),('16100','2013-09-30','17:05:00',2.67),('16100','2013-09-30','17:10:00',2.51),('16100','2013-09-30','17:15:00',2.32),('16100','2013-09-30','17:20:00',2.11),('16100','2013-09-30','17:25:00',1.94),('16100','2013-09-30','17:30:00',1.77),('16100','2013-09-30','17:35:00',1.58),('16100','2013-09-30','17:40:00',1.44),('16100','2013-09-30','17:45:00',1.24),('16100','2013-09-30','17:50:00',1.09),('16100','2013-09-29','09:25:00',1.08),('16100','2013-09-29','09:30:00',1.23),('16100','2013-09-29','09:35:00',1.58),('16100','2013-09-29','09:40:00',1.92),('16100','2013-09-29','09:45:00',3.35),('16100','2013-09-29','09:50:00',2.88),('16100','2013-09-29','09:55:00',1.51),('16100','2013-09-29','10:00:00',1.43),('16100','2013-09-29','10:05:00',1.6),('16100','2013-09-29','10:10:00',1.85),('16100','2013-09-29','10:15:00',1.86),('16100','2013-09-29','10:20:00',1.91),('16100','2013-09-29','10:25:00',2.33),('16100','2013-09-29','10:30:00',2.73),('16100','2013-09-29','10:35:00',3.54),('16100','2013-09-29','10:40:00',4.28),('16100','2013-09-29','10:45:00',5.78),('16100','2013-09-29','10:50:00',5.76),('16100','2013-09-29','10:55:00',4.9),('16100','2013-09-29','11:00:00',5.2),('16100','2013-09-29','11:05:00',4.69),('16100','2013-09-29','11:10:00',6.4),('16100','2013-09-29','11:15:00',5.08),('16100','2013-09-29','11:20:00',4.92),('16100','2013-09-29','11:25:00',4.82),('16100','2013-09-29','11:30:00',6.26),('16100','2013-09-29','11:35:00',6.77),('16100','2013-09-29','11:40:00',3.85),('16100','2013-09-29','11:45:00',1.95),('16100','2013-09-29','11:50:00',3.86),('16100','2013-09-29','11:55:00',3.75),('16100','2013-09-29','12:00:00',4.83),('16100','2013-09-29','12:05:00',6.88),('16100','2013-09-29','12:10:00',3.78),('16100','2013-09-29','12:15:00',4.69),('16100','2013-09-29','12:20:00',7.35),('16100','2013-09-29','12:25:00',7.2),('16100','2013-09-29','12:30:00',7.18),('16100','2013-09-29','12:35:00',6.96),('16100','2013-09-29','12:40:00',5.87),('16100','2013-09-29','12:45:00',3.33),('16100','2013-09-29','12:50:00',7.46),('16100','2013-09-29','12:55:00',6.96),('16100','2013-09-29','13:00:00',7.42),('16100','2013-09-29','13:05:00',7.49),('16100','2013-09-29','13:10:00',4.75),('16100','2013-09-29','13:15:00',7.45),('16100','2013-09-29','13:20:00',5.67),('16100','2013-09-29','13:25:00',4.45),('16100','2013-09-29','13:30:00',6.16),('16100','2013-09-29','13:35:00',4),('16100','2013-09-29','13:40:00',8.35),('16100','2013-09-29','13:45:00',3.78),('16100','2013-09-29','13:50:00',1.47),('16100','2013-09-29','13:55:00',1.51),('16100','2013-09-29','14:00:00',1.8),('16100','2013-09-29','14:05:00',2.22),('16100','2013-09-29','14:10:00',2.08),('16100','2013-09-29','14:15:00',1.72),('16100','2013-09-29','14:20:00',1.56),('16100','2013-09-29','14:25:00',2.62),('16100','2013-09-29','14:30:00',6.48),('16100','2013-09-29','14:35:00',7.97),('16100','2013-09-29','14:40:00',7.09),('16100','2013-09-29','14:45:00',6.57),('16100','2013-09-29','14:50:00',2.53),('16100','2013-09-29','14:55:00',3.4),('16100','2013-09-29','15:00:00',2.91),('16100','2013-09-29','15:05:00',5.52),('16100','2013-09-29','15:10:00',4.33),('16100','2013-09-29','15:15:00',1.66),('16100','2013-09-29','15:20:00',4.05),('16100','2013-09-29','15:25:00',5.76),('16100','2013-09-29','15:30:00',2),('16100','2013-09-29','15:35:00',1.23),('16100','2013-09-29','15:55:00',3.19),('16100','2013-09-29','16:00:00',5.44),('16100','2013-09-29','16:05:00',5.44),('16100','2013-09-29','16:10:00',4.46),('16100','2013-09-29','16:15:00',4.67),('16100','2013-09-29','16:20:00',3.58),('16100','2013-09-29','16:25:00',1.43),('16100','2013-09-29','16:30:00',4.45),('16100','2013-09-29','16:35:00',2.25),('16100','2013-09-29','16:40:00',1.98),('16100','2013-09-29','16:45:00',3.85),('16100','2013-09-29','16:50:00',1.79),('16100','2013-09-29','16:55:00',2.72),('16100','2013-09-29','17:00:00',3.27),('16100','2013-09-29','17:05:00',3.4),('16100','2013-09-29','17:10:00',2.18),('16100','2013-09-29','17:30:00',1.53),('16100','2013-09-29','17:35:00',1.27),('16100','2013-09-29','17:40:00',1.13),('16100','2013-09-28','08:40:00',1.43),('16100','2013-09-28','08:45:00',1.76),('16100','2013-09-28','08:50:00',1.64),('16100','2013-09-28','08:55:00',1.43),('16100','2013-09-28','09:00:00',1.31),('16100','2013-09-28','09:05:00',1.09),('16100','2013-09-28','09:10:00',1.16),('16100','2013-09-28','09:15:00',1.23),('16100','2013-09-28','09:20:00',1.35),('16100','2013-09-28','09:25:00',1.46),('16100','2013-09-28','09:30:00',1.34),('16100','2013-09-28','09:35:00',1.23),('16100','2013-09-28','09:40:00',1.3),('16100','2013-09-28','09:45:00',1.54),('16100','2013-09-28','09:50:00',1.79),('16100','2013-09-28','09:55:00',2.34),('16100','2013-09-28','10:00:00',3.64),('16100','2013-09-28','10:05:00',3.41),('16100','2013-09-28','10:10:00',4.24),('16100','2013-09-28','10:15:00',3.78),('16100','2013-09-28','10:20:00',4.01),('16100','2013-09-28','10:25:00',4.27),('16100','2013-09-28','10:30:00',4.56),('16100','2013-09-28','10:35:00',4.66),('16100','2013-09-28','10:40:00',4.88),('16100','2013-09-28','10:45:00',5.09),('16100','2013-09-28','10:50:00',5.2),('16100','2013-09-28','10:55:00',4.94),('16100','2013-09-28','11:00:00',5.25),('16100','2013-09-28','11:05:00',4.96),('16100','2013-09-28','11:10:00',4.99),('16100','2013-09-28','11:15:00',5.43),('16100','2013-09-28','11:20:00',5.4),('16100','2013-09-28','11:25:00',5.26),('16100','2013-09-28','11:30:00',5.63),('16100','2013-09-28','11:35:00',5.52),('16100','2013-09-28','11:40:00',5.93),('16100','2013-09-28','11:45:00',6.08),('16100','2013-09-28','11:50:00',6.35),('16100','2013-09-28','11:55:00',6.2),('16100','2013-09-28','12:00:00',6.43),('16100','2013-09-28','12:05:00',6.29),('16100','2013-09-28','12:10:00',6.7),('16100','2013-09-28','12:15:00',4.15),('16100','2013-09-28','12:20:00',2.9),('16100','2013-09-28','12:25:00',2.21),('16100','2013-09-28','12:30:00',2.5),('16100','2013-09-28','12:35:00',2.35),('16100','2013-09-28','12:40:00',2.29),('16100','2013-09-28','12:45:00',1.89),('16100','2013-09-28','12:50:00',2.02),('16100','2013-09-28','12:55:00',1.8),('16100','2013-09-28','13:00:00',1.62),('16100','2013-09-28','13:05:00',1.19),('16100','2013-09-28','13:25:00',1.88),('16100','2013-09-28','13:30:00',3.05),('16100','2013-09-28','13:35:00',5.92),('16100','2013-09-28','13:40:00',3.33),('16100','2013-09-28','13:45:00',5.13),('16100','2013-09-28','13:50:00',4.86),('16100','2013-09-28','13:55:00',2.86),('16100','2013-09-28','14:00:00',3.37),('16100','2013-09-28','14:05:00',1.87),('16100','2013-09-28','14:10:00',1.77),('16100','2013-09-28','14:15:00',1.94),('16100','2013-09-28','14:20:00',2.05),('16100','2013-09-28','14:25:00',1.65),('16100','2013-09-28','14:30:00',1.41),('16100','2013-09-28','14:50:00',2.13),('16100','2013-09-28','14:55:00',1.42),('16100','2013-09-28','15:15:00',2.04),('16100','2013-09-28','15:20:00',1.25),('16100','2013-09-28','15:25:00',1.65),('16100','2013-09-28','15:30:00',1.18),('16100','2013-09-28','15:55:00',1.73),('16100','2013-09-28','16:00:00',1.71),('16100','2013-09-28','16:05:00',1.24),('16100','2013-09-28','16:20:00',1.32),('16100','2013-09-28','16:25:00',2.52),('16100','2013-09-28','16:30:00',3.29),('16100','2013-09-28','16:35:00',1.65),('16100','2013-09-28','16:40:00',1.1),('16100','2013-09-28','16:45:00',1.08),('16100','2014-04-13','08:05:00',1.16),('16100','2014-04-13','08:10:00',1.38),('16100','2014-04-13','08:15:00',1.64),('16100','2014-04-13','08:20:00',1.82),('16100','2014-04-13','08:25:00',2.01),('16100','2014-04-13','08:30:00',2.18),('16100','2014-04-13','08:35:00',2.36),('16100','2014-04-13','08:40:00',2.54),('16100','2014-04-13','08:45:00',2.71),('16100','2014-04-13','08:50:00',2.89),('16100','2014-04-13','08:55:00',3.06),('16100','2014-04-13','09:00:00',3.22),('16100','2014-04-13','09:05:00',3.38),('16100','2014-04-13','09:10:00',3.58),('16100','2014-04-13','09:15:00',3.73),('16100','2014-04-13','09:20:00',3.89),('16100','2014-04-13','09:25:00',4.04),('16100','2014-04-13','09:30:00',4.2),('16100','2014-04-13','09:35:00',4.33),('16100','2014-04-13','09:40:00',4.48),('16100','2014-04-13','09:45:00',4.64),('16100','2014-04-13','09:50:00',4.77),('16100','2014-04-13','09:55:00',4.91),('16100','2014-04-13','10:00:00',5.05),('16100','2014-04-13','10:05:00',5.17),('16100','2014-04-13','10:10:00',5.29),('16100','2014-04-13','10:15:00',5.39),('16100','2014-04-13','10:20:00',5.54),('16100','2014-04-13','10:25:00',5.69),('16100','2014-04-13','10:30:00',5.81),('16100','2014-04-13','10:35:00',5.9),('16100','2014-04-13','10:40:00',6),('16100','2014-04-13','10:45:00',6.12),('16100','2014-04-13','10:50:00',6.24),('16100','2014-04-13','10:55:00',6.33),('16100','2014-04-13','11:00:00',6.42),('16100','2014-04-13','11:05:00',6.49),('16100','2014-04-13','11:10:00',6.68),('16100','2014-04-13','11:15:00',6.75),('16100','2014-04-13','11:20:00',6.83),('16100','2014-04-13','11:25:00',6.87),('16100','2014-04-13','11:30:00',6.9),('16100','2014-04-13','11:35:00',6.99),('16100','2014-04-13','11:40:00',7.05),('16100','2014-04-13','11:45:00',7.06),('16100','2014-04-13','11:50:00',7.12),('16100','2014-04-13','11:55:00',7.21),('16100','2014-04-13','12:00:00',7.26),('16100','2014-04-13','12:05:00',7.34),('16100','2014-04-13','12:10:00',7.39),('16100','2014-04-13','12:15:00',7.41),('16100','2014-04-13','12:20:00',7.35),('16100','2014-04-13','12:25:00',7.41),('16100','2014-04-13','12:30:00',7.44),('16100','2014-04-13','12:35:00',7.43),('16100','2014-04-13','12:40:00',7.51),('16100','2014-04-13','12:45:00',7.58),('16100','2014-04-13','12:50:00',7.63),('16100','2014-04-13','12:55:00',7.7),('16100','2014-04-13','13:00:00',7.7),('16100','2014-04-13','13:05:00',7.73),('16100','2014-04-13','13:10:00',7.75),('16100','2014-04-13','13:15:00',7.69),('16100','2014-04-13','13:20:00',7.75),('16100','2014-04-13','13:25:00',7.73),('16100','2014-04-13','13:30:00',7.72),('16100','2014-04-13','13:35:00',7.69),('16100','2014-04-13','13:40:00',7.68),('16100','2014-04-13','13:45:00',7.65),('16100','2014-04-13','13:50:00',7.68),('16100','2014-04-13','13:55:00',7.66),('16100','2014-04-13','14:00:00',7.66),('16100','2014-04-13','14:05:00',7.6),('16100','2014-04-13','14:10:00',7.51),('16100','2014-04-13','14:15:00',7.48),('16100','2014-04-13','14:20:00',7.43),('16100','2014-04-13','14:25:00',7.4),('16100','2014-04-13','14:30:00',7.34),('16100','2014-04-13','14:35:00',7.26),('16100','2014-04-13','14:40:00',7.22),('16100','2014-04-13','14:45:00',7.17),('16100','2014-04-13','14:50:00',7.13),('16100','2014-04-13','14:55:00',7.05),('16100','2014-04-13','15:00:00',6.99),('16100','2014-04-13','15:05:00',6.93),('16100','2014-04-13','15:10:00',6.85),('16100','2014-04-13','15:15:00',6.74),('16100','2014-04-13','15:20:00',6.61),('16100','2014-04-13','15:25:00',6.52),('16100','2014-04-13','15:30:00',6.39),('16100','2014-04-13','15:35:00',6.3),('16100','2014-04-13','15:40:00',6.22),('16100','2014-04-13','15:45:00',6.12),('16100','2014-04-13','15:50:00',6.01),('16100','2014-04-13','15:55:00',5.89),('16100','2014-04-13','16:00:00',5.76),('16100','2014-04-13','16:05:00',5.66),('16100','2014-04-13','16:10:00',5.47),('16100','2014-04-13','16:15:00',5.35),('16100','2014-04-13','16:20:00',5.26),('16100','2014-04-13','16:25:00',5.09),('16100','2014-04-13','16:30:00',4.97),('16100','2014-04-13','16:35:00',4.84),('16100','2014-04-13','16:40:00',4.7),('16100','2014-04-13','16:45:00',4.57),('16100','2014-04-13','16:50:00',4.42),('16100','2014-04-13','16:55:00',4.25),('16100','2014-04-13','17:00:00',4.11),('16100','2014-04-13','17:05:00',3.94),('16100','2014-04-13','17:10:00',3.77),('16100','2014-04-13','17:15:00',3.64),('16100','2014-04-13','17:20:00',3.47),('16100','2014-04-13','17:25:00',3.27),('16100','2014-04-13','17:30:00',3.11),('16100','2014-04-13','17:35:00',2.94),('16100','2014-04-13','17:40:00',2.76),('16100','2014-04-13','17:45:00',2.57),('16100','2014-04-13','17:50:00',2.38),('16100','2014-04-13','17:55:00',2.23),('16100','2014-04-13','18:00:00',2.04),('16100','2014-04-13','18:05:00',1.86),('16100','2014-04-13','18:10:00',1.71),('16100','2014-04-13','18:15:00',1.57),('16100','2014-04-13','18:20:00',1.41),('16100','2014-04-13','18:25:00',1.23),('16100','2014-04-13','18:30:00',1.08),('16100','2013-09-27','08:20:00',1.13),('16100','2013-09-27','08:25:00',1.34),('16100','2013-09-27','08:30:00',1.55),('16100','2013-09-27','08:35:00',1.7),('16100','2013-09-27','08:40:00',1.86),('16100','2013-09-27','08:45:00',2.08),('16100','2013-09-27','08:50:00',2.26),('16100','2013-09-27','08:55:00',2.44),('16100','2013-09-27','09:00:00',2.62),('16100','2013-09-27','09:05:00',2.78),('16100','2013-09-27','09:10:00',2.88),('16100','2013-09-27','09:15:00',3.11),('16100','2013-09-27','09:20:00',3.3),('16100','2013-09-27','09:25:00',3.39),('16100','2013-09-27','09:30:00',3.57),('16100','2013-09-27','09:35:00',3.7),('16100','2013-09-27','09:40:00',3.86),('16100','2013-09-27','09:45:00',4.08),('16100','2013-09-27','09:50:00',4.39),('16100','2013-09-27','09:55:00',4),('16100','2013-09-27','10:00:00',3.76),('16100','2013-09-27','10:05:00',4.43),('16100','2013-09-27','10:10:00',4.87),('16100','2013-09-27','10:15:00',5.03),('16100','2013-09-27','10:20:00',5.15),('16100','2013-09-27','10:25:00',5.24),('16100','2013-09-27','10:30:00',5.58),('16100','2013-09-27','10:35:00',3.16),('16100','2013-09-27','10:40:00',4.23),('16100','2013-09-27','10:45:00',3.6),('16100','2013-09-27','10:50:00',3.02),('16100','2013-09-27','10:55:00',6.06),('16100','2013-09-27','11:00:00',6),('16100','2013-09-27','11:05:00',6.21),('16100','2013-09-27','11:10:00',6.47),('16100','2013-09-27','11:15:00',6.75),('16100','2013-09-27','11:20:00',3.68),('16100','2013-09-27','11:25:00',2.18),('16100','2013-09-27','11:30:00',7.06),('16100','2013-09-27','11:35:00',6.7),('16100','2013-09-27','11:40:00',6.12),('16100','2013-09-27','11:45:00',6.79),('16100','2013-09-27','11:50:00',6.27),('16100','2013-09-27','11:55:00',7.06),('16100','2013-09-27','12:00:00',6.22),('16100','2013-09-27','12:05:00',4.5),('16100','2013-09-27','12:10:00',7.11),('16100','2013-09-27','12:15:00',3.57),('16100','2013-09-27','12:20:00',6.83),('16100','2013-09-27','12:25:00',6.96),('16100','2013-09-27','12:30:00',7.02),('16100','2013-09-27','12:35:00',7.2),('16100','2013-09-27','12:40:00',7.05),('16100','2013-09-27','12:45:00',7.13),('16100','2013-09-27','12:50:00',7.09),('16100','2013-09-27','12:55:00',7.16),('16100','2013-09-27','13:00:00',5.28),('16100','2013-09-27','13:05:00',7.17),('16100','2013-09-27','13:10:00',4.92),('16100','2013-09-27','13:15:00',2.27),('16100','2013-09-27','13:20:00',5.42),('16100','2013-09-27','13:25:00',7.37),('16100','2013-09-27','13:30:00',4.32),('16100','2013-09-27','13:35:00',5.94),('16100','2013-09-27','13:40:00',5.17),('16100','2013-09-27','13:45:00',3.28),('16100','2013-09-27','13:50:00',7.27),('16100','2013-09-27','13:55:00',6.94),('16100','2013-09-27','14:00:00',5.89),('16100','2013-09-27','14:05:00',6.52),('16100','2013-09-27','14:10:00',4.55),('16100','2013-09-27','14:15:00',6.34),('16100','2013-09-27','14:20:00',6.6),('16100','2013-09-27','14:25:00',6.52),('16100','2013-09-27','14:30:00',6.06),('16100','2013-09-27','14:35:00',6.58),('16100','2013-09-27','14:40:00',6.48),('16100','2013-09-27','14:45:00',5.81),('16100','2013-09-27','14:50:00',6.24),('16100','2013-09-27','14:55:00',6.19),('16100','2013-09-27','15:00:00',5.78),('16100','2013-09-27','15:05:00',5.91),('16100','2013-09-27','15:10:00',4.59),('16100','2013-09-27','15:15:00',5.36),('16100','2013-09-27','15:20:00',4.52),('16100','2013-09-27','15:25:00',5.16),('16100','2013-09-27','15:30:00',4.35),('16100','2013-09-27','15:35:00',4.3),('16100','2013-09-27','15:40:00',2.41),('16100','2013-09-27','15:45:00',3.15),('16100','2013-09-27','15:50:00',3.01),('16100','2013-09-27','15:55:00',3.86),('16100','2013-09-27','16:00:00',4.59),('16100','2013-09-27','16:05:00',4.38),('16100','2013-09-27','16:10:00',4.3),('16100','2013-09-27','16:15:00',4.17),('16100','2013-09-27','16:20:00',3.89),('16100','2013-09-27','16:25:00',3.23),('16100','2013-09-27','16:30:00',3.61),('16100','2013-09-27','16:35:00',3.58),('16100','2013-09-27','16:40:00',3.34),('16100','2013-09-27','16:45:00',3.18),('16100','2013-09-27','16:50:00',3.07),('16100','2013-09-27','16:55:00',2.94),('16100','2013-09-27','17:00:00',2.72),('16100','2013-09-27','17:05:00',2.57),('16100','2013-09-27','17:10:00',2.38),('16100','2013-09-27','17:15:00',2.24),('16100','2013-09-27','17:20:00',2.09),('16100','2013-09-27','17:25:00',1.95),('16100','2013-09-27','17:30:00',1.76),('16100','2013-09-27','17:35:00',1.51),('16100','2013-09-27','17:40:00',1.22),('16100','2013-09-26','08:20:00',1.26),('16100','2013-09-26','08:25:00',1.35),('16100','2013-09-26','08:30:00',1.83),('16100','2013-09-26','08:35:00',1.15),('16100','2013-09-26','08:45:00',1.03),('16100','2013-09-26','08:50:00',1.61),('16100','2013-09-26','08:55:00',2.13),('16100','2013-09-26','09:00:00',1.53),('16100','2013-09-26','09:05:00',1.05),('16100','2013-09-26','09:10:00',1.29),('16100','2013-09-26','09:15:00',1.29),('16100','2013-09-26','09:20:00',1.91),('16100','2013-09-26','09:25:00',2.72),('16100','2013-09-26','09:30:00',1.5),('16100','2013-09-26','09:35:00',1.52),('16100','2013-09-26','09:40:00',1.79),('16100','2013-09-26','09:45:00',1.96),('16100','2013-09-26','09:50:00',1.45),('16100','2013-09-26','09:55:00',1.36),('16100','2013-09-26','10:00:00',1.42),('16100','2013-09-26','10:05:00',1.46),('16100','2013-09-26','10:10:00',2.65),('16100','2013-09-26','10:15:00',4.7),('16100','2013-09-26','10:20:00',3.75),('16100','2013-09-26','10:25:00',2.36),('16100','2013-09-26','10:30:00',2.87),('16100','2013-09-26','10:35:00',5.2),('16100','2013-09-26','10:40:00',5.32),('16100','2013-09-26','10:45:00',5.57),('16100','2013-09-26','10:50:00',5.55),('16100','2013-09-26','10:55:00',5.5),('16100','2013-09-26','11:00:00',5.63),('16100','2013-09-26','11:05:00',5.83),('16100','2013-09-26','11:10:00',5.92),('16100','2013-09-26','11:15:00',6.05),('16100','2013-09-26','11:20:00',6.17),('16100','2013-09-26','11:25:00',4.42),('16100','2013-09-26','11:30:00',3.79),('16100','2013-09-26','11:35:00',3.74),('16100','2013-09-26','11:40:00',3.19),('16100','2013-09-26','11:45:00',6.23),('16100','2013-09-26','11:50:00',3.97),('16100','2013-09-26','11:55:00',2.11),('16100','2013-09-26','12:00:00',2.42),('16100','2013-09-26','12:05:00',1.51),('16100','2013-09-26','12:10:00',2.27),('16100','2013-09-26','12:15:00',1.63),('16100','2013-09-26','12:20:00',1.71),('16100','2013-09-26','12:25:00',2.73),('16100','2013-09-26','12:30:00',5.36),('16100','2013-09-26','12:35:00',7.35),('16100','2013-09-26','12:40:00',7.53),('16100','2013-09-26','12:45:00',5.06),('16100','2013-09-26','12:50:00',2.97),('16100','2013-09-26','12:55:00',2.91),('16100','2013-09-26','13:00:00',1.5),('16100','2013-09-26','13:05:00',3.18),('16100','2013-09-26','13:10:00',8.13),('16100','2013-09-26','13:15:00',7.63),('16100','2013-09-26','13:20:00',7.39),('16100','2013-09-26','13:25:00',7.56),('16100','2013-09-26','13:30:00',5.45),('16100','2013-09-26','13:35:00',6.92),('16100','2013-09-26','13:40:00',7.25),('16100','2013-09-26','13:45:00',5.04),('16100','2013-09-26','13:50:00',6.28),('16100','2013-09-26','13:55:00',6.98),('16100','2013-09-26','14:00:00',6.96),('16100','2013-09-26','14:05:00',6.9),('16100','2013-09-26','14:10:00',5.96),('16100','2013-09-26','14:15:00',4.75),('16100','2013-09-26','14:20:00',6.77),('16100','2013-09-26','14:25:00',6.63),('16100','2013-09-26','14:30:00',6.48),('16100','2013-09-26','14:35:00',6.34),('16100','2013-09-26','14:40:00',6.54),('16100','2013-09-26','14:45:00',6.65),('16100','2013-09-26','14:50:00',6.46),('16100','2013-09-26','14:55:00',6.2),('16100','2013-09-26','15:00:00',4.18),('16100','2013-09-26','15:05:00',5.37),('16100','2013-09-26','15:10:00',5.66),('16100','2013-09-26','15:15:00',5.74),('16100','2013-09-26','15:20:00',5.66),('16100','2013-09-26','15:25:00',5.02),('16100','2013-09-26','15:30:00',4.61),('16100','2013-09-26','15:35:00',4.81),('16100','2013-09-26','15:40:00',5.33),('16100','2013-09-26','15:45:00',5.14),('16100','2013-09-26','15:50:00',4.53),('16100','2013-09-26','15:55:00',4.8),('16100','2013-09-26','16:00:00',4.64),('16100','2013-09-26','16:05:00',4.55),('16100','2013-09-26','16:10:00',4.32),('16100','2013-09-26','16:15:00',4.3),('16100','2013-09-26','16:20:00',4.15),('16100','2013-09-26','16:25:00',3.95),('16100','2013-09-26','16:30:00',3.89),('16100','2013-09-26','16:35:00',3.7),('16100','2013-09-26','16:40:00',3.44),('16100','2013-09-26','16:45:00',3.31),('16100','2013-09-26','16:50:00',3.11),('16100','2013-09-26','16:55:00',2.84),('16100','2013-09-26','17:00:00',2.81),('16100','2013-09-26','17:05:00',2.37),('16100','2013-09-26','17:10:00',2.45),('16100','2013-09-26','17:15:00',2.38),('16100','2013-09-26','17:20:00',2.05),('16100','2013-09-26','17:25:00',1.25),('16100','2013-09-26','17:35:00',1.31),('16100','2013-09-26','17:40:00',1.11),('16100','2013-09-25','08:15:00',1.14),('16100','2013-09-25','08:20:00',1.3),('16100','2013-09-25','08:25:00',1.52),('16100','2013-09-25','08:30:00',1.7),('16100','2013-09-25','08:35:00',1.85),('16100','2013-09-25','08:40:00',2.06),('16100','2013-09-25','08:45:00',2.26),('16100','2013-09-25','08:50:00',2.42),('16100','2013-09-25','08:55:00',2.59),('16100','2013-09-25','09:00:00',2.8),('16100','2013-09-25','09:05:00',2.97),('16100','2013-09-25','09:10:00',3.1),('16100','2013-09-25','09:15:00',3.27),('16100','2013-09-25','09:20:00',3.51),('16100','2013-09-25','09:25:00',3.64),('16100','2013-09-25','09:30:00',3.77),('16100','2013-09-25','09:35:00',3.89),('16100','2013-09-25','09:40:00',4.02),('16100','2013-09-25','09:45:00',4.18),('16100','2013-09-25','09:50:00',4.35),('16100','2013-09-25','09:55:00',4.45),('16100','2013-09-25','10:00:00',4.6),('16100','2013-09-25','10:05:00',4.7),('16100','2013-09-25','10:10:00',4.82),('16100','2013-09-25','10:15:00',4.97),('16100','2013-09-25','10:20:00',5.08),('16100','2013-09-25','10:25:00',5.2),('16100','2013-09-25','10:30:00',5.29),('16100','2013-09-25','10:35:00',5.42),('16100','2013-09-25','10:40:00',5.4),('16100','2013-09-25','10:45:00',5.51),('16100','2013-09-25','10:50:00',5.49),('16100','2013-09-25','10:55:00',5.7),('16100','2013-09-25','11:00:00',5.77),('16100','2013-09-25','11:05:00',5.85),('16100','2013-09-25','11:10:00',5.96),('16100','2013-09-25','11:15:00',6.09),('16100','2013-09-25','11:20:00',6.69),('16100','2013-09-25','11:25:00',6.23),('16100','2013-09-25','11:30:00',6.45),('16100','2013-09-25','11:35:00',6.56),('16100','2013-09-25','11:40:00',6.66),('16100','2013-09-25','11:45:00',5.57),('16100','2013-09-25','11:50:00',6.08),('16100','2013-09-25','11:55:00',6.3),('16100','2013-09-25','12:00:00',5.19),('16100','2013-09-25','12:05:00',5.86),('16100','2013-09-25','12:10:00',4.85),('16100','2013-09-25','12:15:00',2.61),('16100','2013-09-25','12:20:00',4.88),('16100','2013-09-25','12:25:00',5.56),('16100','2013-09-25','12:30:00',3.18),('16100','2013-09-25','12:35:00',3.29),('16100','2013-09-25','12:40:00',3.56),('16100','2013-09-25','12:45:00',3.25),('16100','2013-09-25','12:50:00',4.02),('16100','2013-09-25','12:55:00',5.17),('16100','2013-09-25','13:00:00',4.51),('16100','2013-09-25','13:05:00',4.77),('16100','2013-09-25','13:10:00',7.26),('16100','2013-09-25','13:15:00',5.64),('16100','2013-09-25','13:20:00',5.33),('16100','2013-09-25','13:25:00',4.19),('16100','2013-09-25','13:30:00',3.26),('16100','2013-09-25','13:35:00',3.33),('16100','2013-09-25','13:40:00',3.56),('16100','2013-09-25','13:45:00',2.15),('16100','2013-09-25','13:50:00',3.79),('16100','2013-09-25','13:55:00',8.23),('16100','2013-09-25','14:00:00',6.79),('16100','2013-09-25','14:05:00',4.1),('16100','2013-09-25','14:10:00',6.75),('16100','2013-09-25','14:15:00',6.01),('16100','2013-09-25','14:20:00',3.83),('16100','2013-09-25','14:25:00',4.89),('16100','2013-09-25','14:30:00',5.54),('16100','2013-09-25','14:35:00',6.38),('16100','2013-09-25','14:40:00',6.45),('16100','2013-09-25','14:45:00',6.6),('16100','2013-09-25','14:50:00',6.47),('16100','2013-09-25','14:55:00',6.34),('16100','2013-09-25','15:00:00',5.8),('16100','2013-09-25','15:05:00',6.22),('16100','2013-09-25','15:10:00',2.77),('16100','2013-09-25','15:15:00',5.04),('16100','2013-09-25','15:20:00',2.59),('16100','2013-09-25','15:25:00',5.3),('16100','2013-09-25','15:30:00',5.77),('16100','2013-09-25','15:35:00',5.36),('16100','2013-09-25','15:40:00',4.75),('16100','2013-09-25','15:45:00',5.4),('16100','2013-09-25','15:50:00',4.73),('16100','2013-09-25','15:55:00',4.88),('16100','2013-09-25','16:00:00',4.19),('16100','2013-09-25','16:05:00',4.64),('16100','2013-09-25','16:10:00',4.61),('16100','2013-09-25','16:15:00',4.41),('16100','2013-09-25','16:20:00',4.46),('16100','2013-09-25','16:25:00',4.04),('16100','2013-09-25','16:30:00',3.99),('16100','2013-09-25','16:35:00',3.81),('16100','2013-09-25','16:40:00',3.51),('16100','2013-09-25','16:45:00',3.42),('16100','2013-09-25','16:50:00',3.3),('16100','2013-09-25','16:55:00',3.09),('16100','2013-09-25','17:00:00',2.43),('16100','2013-09-25','17:10:00',1.87),('16100','2013-09-25','17:15:00',1.66),('16100','2013-09-25','17:20:00',2.44),('16100','2013-09-25','17:25:00',2.6),('16100','2013-09-25','17:30:00',2.47),('16100','2013-09-25','17:35:00',2.06),('16100','2013-09-25','17:40:00',1.71),('16100','2013-09-25','17:45:00',1.48),('16100','2013-09-25','17:50:00',1.31),('16100','2013-09-25','17:55:00',1.04),('16100','2013-09-24','08:10:00',1.31),('16100','2013-09-24','08:30:00',1.77),('16100','2013-09-24','08:35:00',1.95),('16100','2013-09-24','08:40:00',1.82),('16100','2013-09-24','08:45:00',2.03),('16100','2013-09-24','08:50:00',2.39),('16100','2013-09-24','08:55:00',2.91),('16100','2013-09-24','09:00:00',2.55),('16100','2013-09-24','09:05:00',2.66),('16100','2013-09-24','09:10:00',1.65),('16100','2013-09-24','09:15:00',1.78),('16100','2013-09-24','09:20:00',3.48),('16100','2013-09-24','09:25:00',2.18),('16100','2013-09-24','09:30:00',1.89),('16100','2013-09-24','09:35:00',3.46),('16100','2013-09-24','09:40:00',2.11),('16100','2013-09-24','09:45:00',1.17),('16100','2013-09-24','10:15:00',1.25),('16100','2013-09-24','10:20:00',2.02),('16100','2013-09-24','10:25:00',4.6),('16100','2013-09-24','10:30:00',5.54),('16100','2013-09-24','10:35:00',5.25),('16100','2013-09-24','10:40:00',3.86),('16100','2013-09-24','10:45:00',4.42),('16100','2013-09-24','10:50:00',5.59),('16100','2013-09-24','10:55:00',5.99),('16100','2013-09-24','11:00:00',6.36),('16100','2013-09-24','11:05:00',6.67),('16100','2013-09-24','11:10:00',6.96),('16100','2013-09-24','11:15:00',5.87),('16100','2013-09-24','11:20:00',1.92),('16100','2013-09-24','11:25:00',1.65),('16100','2013-09-24','11:30:00',1.51),('16100','2013-09-24','11:35:00',2.24),('16100','2013-09-24','11:40:00',7.28),('16100','2013-09-24','11:45:00',7.19),('16100','2013-09-24','11:50:00',7.22),('16100','2013-09-24','11:55:00',7.81),('16100','2013-09-24','12:00:00',5.18),('16100','2013-09-24','12:05:00',3.31),('16100','2013-09-24','12:10:00',2.03),('16100','2013-09-24','12:15:00',2),('16100','2013-09-24','12:20:00',3.01),('16100','2013-09-24','12:25:00',6.46),('16100','2013-09-24','12:30:00',7.64),('16100','2013-09-24','12:35:00',7.78),('16100','2013-09-24','12:40:00',7.81),('16100','2013-09-24','12:45:00',7.73),('16100','2013-09-24','12:50:00',7.75),('16100','2013-09-24','12:55:00',7.61),('16100','2013-09-24','13:00:00',7.54),('16100','2013-09-24','13:05:00',7.7),('16100','2013-09-24','13:10:00',7.89),('16100','2013-09-24','13:15:00',7.72),('16100','2013-09-24','13:20:00',4.6),('16100','2013-09-24','13:25:00',3.91),('16100','2013-09-24','13:30:00',1.78),('16100','2013-09-24','13:35:00',7.02),('16100','2013-09-24','13:40:00',1.72),('16100','2013-09-24','13:45:00',4.09),('16100','2013-09-24','13:50:00',8),('16100','2013-09-24','13:55:00',5.92),('16100','2013-09-24','14:00:00',2.77),('16100','2013-09-24','14:05:00',7.35),('16100','2013-09-24','14:10:00',2.64),('16100','2013-09-24','14:15:00',2.02),('16100','2013-09-24','14:20:00',3.24),('16100','2013-09-24','14:25:00',6.55),('16100','2013-09-24','14:30:00',6.97),('16100','2013-09-24','14:35:00',4.39),('16100','2013-09-24','14:40:00',3.51),('16100','2013-09-24','14:45:00',4.54),('16100','2013-09-24','14:50:00',7.4),('16100','2013-09-24','14:55:00',5.8),('16100','2013-09-24','15:00:00',3.8),('16100','2013-09-24','15:05:00',6.55),('16100','2013-09-24','15:10:00',5.6),('16100','2013-09-24','15:15:00',6.28),('16100','2013-09-24','15:20:00',6.23),('16100','2013-09-24','15:25:00',6.16),('16100','2013-09-24','15:30:00',5.13),('16100','2013-09-24','15:35:00',5.54),('16100','2013-09-24','15:40:00',5.5),('16100','2013-09-24','15:45:00',5.38),('16100','2013-09-24','15:50:00',3.81),('16100','2013-09-24','15:55:00',3.74),('16100','2013-09-24','16:00:00',5.26),('16100','2013-09-24','16:05:00',1.14),('16100','2013-09-24','16:10:00',4.75),('16100','2013-09-24','16:15:00',4.84),('16100','2013-09-24','16:20:00',3.97),('16100','2013-09-24','16:25:00',4.5),('16100','2013-09-24','16:30:00',3.02),('16100','2013-09-24','16:35:00',4.07),('16100','2013-09-24','16:40:00',3.84),('16100','2013-09-24','16:45:00',3.68),('16100','2013-09-24','16:50:00',3.51),('16100','2013-09-24','16:55:00',3.37),('16100','2013-09-24','17:00:00',3.22),('16100','2013-09-24','17:05:00',3.02),('16100','2013-09-24','17:10:00',2.82),('16100','2013-09-24','17:15:00',2.64),('16100','2013-09-24','17:20:00',2.47),('16100','2013-09-24','17:25:00',2.29),('16100','2013-09-24','17:30:00',2.1),('16100','2013-09-24','17:35:00',1.93),('16100','2013-09-24','17:40:00',1.76),('16100','2013-09-24','17:45:00',1.59),('16100','2013-09-24','17:50:00',1.41),('16100','2013-09-24','17:55:00',1.24),('16100','2013-09-24','18:00:00',1.07),('16100','2013-09-23','08:10:00',1.07),('16100','2013-09-23','08:15:00',1.25),('16100','2013-09-23','08:20:00',1.44),('16100','2013-09-23','08:25:00',1.64),('16100','2013-09-23','08:30:00',1.83),('16100','2013-09-23','08:35:00',2.03),('16100','2013-09-23','08:40:00',2.21),('16100','2013-09-23','08:45:00',2.42),('16100','2013-09-23','08:50:00',2.61),('16100','2013-09-23','08:55:00',2.79),('16100','2013-09-23','09:00:00',2.98),('16100','2013-09-23','09:05:00',3.15),('16100','2013-09-23','09:10:00',3.3),('16100','2013-09-23','09:15:00',3.47),('16100','2013-09-23','09:20:00',3.67),('16100','2013-09-23','09:25:00',3.84),('16100','2013-09-23','09:30:00',3.99),('16100','2013-09-23','09:35:00',4.09),('16100','2013-09-23','09:40:00',4.2),('16100','2013-09-23','09:45:00',4.36),('16100','2013-09-23','09:50:00',4.49),('16100','2013-09-23','09:55:00',4.59),('16100','2013-09-23','10:00:00',4.74),('16100','2013-09-23','10:05:00',4.84),('16100','2013-09-23','10:10:00',4.96),('16100','2013-09-23','10:15:00',5.1),('16100','2013-09-23','10:20:00',5.25),('16100','2013-09-23','10:25:00',5.43),('16100','2013-09-23','10:30:00',5.56),('16100','2013-09-23','10:35:00',5.65),('16100','2013-09-23','10:40:00',5.76),('16100','2013-09-23','10:45:00',5.83),('16100','2013-09-23','10:50:00',5.9),('16100','2013-09-23','10:55:00',6.02),('16100','2013-09-23','11:00:00',6.1),('16100','2013-09-23','11:05:00',6.18),('16100','2013-09-23','11:10:00',6.26),('16100','2013-09-23','11:15:00',6.34),('16100','2013-09-23','11:20:00',6.47),('16100','2013-09-23','11:25:00',6.51),('16100','2013-09-23','11:30:00',6.61),('16100','2013-09-23','11:35:00',6.67),('16100','2013-09-23','11:40:00',6.68),('16100','2013-09-23','11:45:00',6.75),('16100','2013-09-23','11:50:00',6.8),('16100','2013-09-23','11:55:00',6.85),('16100','2013-09-23','12:00:00',6.87),('16100','2013-09-23','12:05:00',6.94),('16100','2013-09-23','12:10:00',7),('16100','2013-09-23','12:15:00',7.01),('16100','2013-09-23','12:20:00',7.01),('16100','2013-09-23','12:25:00',7.07),('16100','2013-09-23','12:30:00',7.12),('16100','2013-09-23','12:35:00',7.13),('16100','2013-09-23','12:40:00',7.16),('16100','2013-09-23','12:45:00',7.2),('16100','2013-09-23','12:50:00',7.16),('16100','2013-09-23','12:55:00',7.16),('16100','2013-09-23','13:00:00',7.21),('16100','2013-09-23','13:05:00',7.19),('16100','2013-09-23','13:10:00',7.23),('16100','2013-09-23','13:15:00',7.24),('16100','2013-09-23','13:20:00',7.18),('16100','2013-09-23','13:25:00',7.17),('16100','2013-09-23','13:30:00',7.14),('16100','2013-09-23','13:35:00',7.13),('16100','2013-09-23','13:40:00',7.1),('16100','2013-09-23','13:45:00',7.15),('16100','2013-09-23','13:50:00',7.13),('16100','2013-09-23','13:55:00',7.06),('16100','2013-09-23','14:00:00',6.95),('16100','2013-09-23','14:05:00',6.96),('16100','2013-09-23','14:10:00',6.89),('16100','2013-09-23','14:15:00',6.89),('16100','2013-09-23','14:20:00',6.81),('16100','2013-09-23','14:25:00',6.79),('16100','2013-09-23','14:30:00',6.72),('16100','2013-09-23','14:35:00',6.64),('16100','2013-09-23','14:40:00',6.56),('16100','2013-09-23','14:45:00',6.52),('16100','2013-09-23','14:50:00',6.43),('16100','2013-09-23','14:55:00',6.36),('16100','2013-09-23','15:00:00',6.27),('16100','2013-09-23','15:05:00',6.15),('16100','2013-09-23','15:10:00',6.04),('16100','2013-09-23','15:15:00',5.97),('16100','2013-09-23','15:20:00',5.87),('16100','2013-09-23','15:25:00',5.8),('16100','2013-09-23','15:30:00',5.68),('16100','2013-09-23','15:35:00',5.64),('16100','2013-09-23','15:40:00',5.53),('16100','2013-09-23','15:45:00',5.43),('16100','2013-09-23','15:50:00',5.33),('16100','2013-09-23','15:55:00',5.04),('16100','2013-09-23','16:00:00',4.99),('16100','2013-09-23','16:05:00',4.87),('16100','2013-09-23','16:10:00',4.82),('16100','2013-09-23','16:15:00',4.66),('16100','2013-09-23','16:20:00',4.57),('16100','2013-09-23','16:25:00',4.41),('16100','2013-09-23','16:30:00',4.27),('16100','2013-09-23','16:35:00',4.12),('16100','2013-09-23','16:40:00',3.93),('16100','2013-09-23','16:45:00',3.76),('16100','2013-09-23','16:50:00',3.61),('16100','2013-09-23','16:55:00',3.44),('16100','2013-09-23','17:00:00',3.27),('16100','2013-09-23','17:05:00',3.1),('16100','2013-09-23','17:10:00',2.92),('16100','2013-09-23','17:15:00',2.74),('16100','2013-09-23','17:20:00',2.59),('16100','2013-09-23','17:25:00',2.41),('16100','2013-09-23','17:30:00',2.21),('16100','2013-09-23','17:35:00',2.03),('16100','2013-09-23','17:40:00',1.87),('16100','2013-09-23','17:45:00',1.69),('16100','2013-09-23','17:50:00',1.52),('16100','2013-09-23','17:55:00',1.34),('16100','2013-09-23','18:00:00',1.16),('16100','2013-09-22','08:10:00',1.14),('16100','2013-09-22','08:15:00',1.32),('16100','2013-09-22','08:20:00',1.51),('16100','2013-09-22','08:25:00',1.72),('16100','2013-09-22','08:30:00',1.91),('16100','2013-09-22','08:35:00',2.11),('16100','2013-09-22','08:40:00',2.29),('16100','2013-09-22','08:45:00',2.51),('16100','2013-09-22','08:50:00',2.69),('16100','2013-09-22','08:55:00',2.86),('16100','2013-09-22','09:00:00',3.05),('16100','2013-09-22','09:05:00',3.21),('16100','2013-09-22','09:10:00',3.37),('16100','2013-09-22','09:15:00',3.55),('16100','2013-09-22','09:20:00',3.76),('16100','2013-09-22','09:25:00',3.9),('16100','2013-09-22','09:30:00',4.04),('16100','2013-09-22','09:35:00',4.18),('16100','2013-09-22','09:40:00',4.31),('16100','2013-09-22','09:45:00',4.44),('16100','2013-09-22','09:50:00',4.56),('16100','2013-09-22','09:55:00',4.69),('16100','2013-09-22','10:00:00',4.83),('16100','2013-09-22','10:05:00',4.95),('16100','2013-09-22','10:10:00',5.08),('16100','2013-09-22','10:15:00',5.19),('16100','2013-09-22','10:20:00',5.33),('16100','2013-09-22','10:25:00',5.48),('16100','2013-09-22','10:30:00',5.61),('16100','2013-09-22','10:35:00',5.73),('16100','2013-09-22','10:40:00',5.84),('16100','2013-09-22','10:45:00',5.96),('16100','2013-09-22','10:50:00',6.06),('16100','2013-09-22','10:55:00',6.15),('16100','2013-09-22','11:00:00',6.24),('16100','2013-09-22','11:05:00',6.32),('16100','2013-09-22','11:10:00',6.4),('16100','2013-09-22','11:15:00',6.51),('16100','2013-09-22','11:20:00',6.64),('16100','2013-09-22','11:25:00',6.75),('16100','2013-09-22','11:30:00',6.8),('16100','2013-09-22','11:35:00',6.87),('16100','2013-09-22','11:40:00',6.92),('16100','2013-09-22','11:45:00',6.96),('16100','2013-09-22','11:50:00',7.01),('16100','2013-09-22','11:55:00',7.11),('16100','2013-09-22','12:00:00',7.12),('16100','2013-09-22','12:05:00',7.11),('16100','2013-09-22','12:10:00',7.12),('16100','2013-09-22','12:15:00',7.17),('16100','2013-09-22','12:20:00',7.17),('16100','2013-09-22','12:25:00',7.31),('16100','2013-09-22','12:30:00',7.25),('16100','2013-09-22','12:35:00',7.24),('16100','2013-09-22','12:40:00',7.25),('16100','2013-09-22','12:45:00',7.27),('16100','2013-09-22','12:50:00',7.28),('16100','2013-09-22','12:55:00',7.29),('16100','2013-09-22','13:00:00',7.29),('16100','2013-09-22','13:05:00',7.29),('16100','2013-09-22','13:10:00',7.29),('16100','2013-09-22','13:15:00',7.21),('16100','2013-09-22','13:20:00',7.17),('16100','2013-09-22','13:25:00',7.15),('16100','2013-09-22','13:30:00',7.2),('16100','2013-09-22','13:35:00',7.14),('16100','2013-09-22','13:40:00',7.12),('16100','2013-09-22','13:45:00',7.07),('16100','2013-09-22','13:50:00',6.96),('16100','2013-09-22','13:55:00',6.89),('16100','2013-09-22','14:00:00',6.8),('16100','2013-09-22','14:05:00',6.81),('16100','2013-09-22','14:10:00',6.8),('16100','2013-09-22','14:15:00',6.86),('16100','2013-09-22','14:20:00',6.86),('16100','2013-09-22','14:25:00',6.8),('16100','2013-09-22','14:30:00',6.56),('16100','2013-09-22','14:35:00',6.42),('16100','2013-09-22','14:40:00',6.36),('16100','2013-09-22','14:45:00',6.32),('16100','2013-09-22','14:50:00',6.23),('16100','2013-09-22','14:55:00',6.13),('16100','2013-09-22','15:00:00',6.06),('16100','2013-09-22','15:05:00',6.02),('16100','2013-09-22','15:10:00',5.99),('16100','2013-09-22','15:15:00',5.93),('16100','2013-09-22','15:20:00',5.78),('16100','2013-09-22','15:25:00',5.71),('16100','2013-09-22','15:30:00',5.78),('16100','2013-09-22','15:35:00',3.99),('16100','2013-09-22','15:40:00',1.89),('16100','2013-09-22','15:45:00',5.52),('16100','2013-09-22','15:50:00',5.3),('16100','2013-09-22','15:55:00',4.74),('16100','2013-09-22','16:00:00',4.79),('16100','2013-09-22','16:05:00',4.71),('16100','2013-09-22','16:10:00',4.53),('16100','2013-09-22','16:15:00',4.44),('16100','2013-09-22','16:20:00',4.25),('16100','2013-09-22','16:25:00',4.23),('16100','2013-09-22','16:30:00',4.16),('16100','2013-09-22','16:35:00',3.98),('16100','2013-09-22','16:40:00',3.81),('16100','2013-09-22','16:45:00',3.68),('16100','2013-09-22','16:50:00',3.5),('16100','2013-09-22','16:55:00',3.34),('16100','2013-09-22','17:00:00',3.2),('16100','2013-09-22','17:05:00',3.02),('16100','2013-09-22','17:10:00',2.83),('16100','2013-09-22','17:15:00',2.63),('16100','2013-09-22','17:20:00',2.46),('16100','2013-09-22','17:25:00',2.28),('16100','2013-09-22','17:30:00',2.11),('16100','2013-09-22','17:35:00',1.95),('16100','2013-09-22','17:40:00',1.77),('16100','2013-09-22','17:45:00',1.6),('16100','2013-09-22','17:50:00',1.4),('16100','2013-09-22','17:55:00',1.26),('16100','2013-09-22','18:00:00',1.1),('16100','2013-09-21','08:05:00',1.01),('16100','2013-09-21','08:10:00',1.21),('16100','2013-09-21','08:15:00',1.31),('16100','2013-09-21','08:20:00',1.48),('16100','2013-09-21','08:25:00',1.65),('16100','2013-09-21','08:30:00',1.84),('16100','2013-09-21','08:35:00',2.03),('16100','2013-09-21','08:40:00',2.21),('16100','2013-09-21','08:45:00',2.43),('16100','2013-09-21','08:50:00',2.64),('16100','2013-09-21','08:55:00',2.82),('16100','2013-09-21','09:00:00',3),('16100','2013-09-21','09:05:00',3.16),('16100','2013-09-21','09:10:00',3.31),('16100','2013-09-21','09:15:00',3.48),('16100','2013-09-21','09:20:00',3.7),('16100','2013-09-21','09:25:00',3.87),('16100','2013-09-21','09:30:00',4.02),('16100','2013-09-21','09:35:00',4.17),('16100','2013-09-21','09:40:00',4.33),('16100','2013-09-21','09:45:00',4.47),('16100','2013-09-21','09:50:00',4.64),('16100','2013-09-21','09:55:00',4.77),('16100','2013-09-21','10:00:00',4.92),('16100','2013-09-21','10:05:00',5.06),('16100','2013-09-21','10:10:00',5.18),('16100','2013-09-21','10:15:00',5.29),('16100','2013-09-21','10:20:00',5.43),('16100','2013-09-21','10:25:00',5.63),('16100','2013-09-21','10:30:00',5.78),('16100','2013-09-21','10:35:00',5.88),('16100','2013-09-21','10:40:00',5.98),('16100','2013-09-21','10:45:00',6.1),('16100','2013-09-21','10:50:00',6.24),('16100','2013-09-21','10:55:00',6.36),('16100','2013-09-21','11:00:00',6.42),('16100','2013-09-21','11:05:00',6.49),('16100','2013-09-21','11:10:00',6.6),('16100','2013-09-21','11:15:00',6.71),('16100','2013-09-21','11:20:00',6.77),('16100','2013-09-21','11:25:00',6.86),('16100','2013-09-21','11:30:00',6.92),('16100','2013-09-21','11:35:00',6.93),('16100','2013-09-21','11:40:00',7),('16100','2013-09-21','11:45:00',7.06),('16100','2013-09-21','11:50:00',7.13),('16100','2013-09-21','11:55:00',7.19),('16100','2013-09-21','12:00:00',7.22),('16100','2013-09-21','12:05:00',7.26),('16100','2013-09-21','12:10:00',7.23),('16100','2013-09-21','12:15:00',7.28),('16100','2013-09-21','12:20:00',7.37),('16100','2013-09-21','12:25:00',7.4),('16100','2013-09-21','12:30:00',7.41),('16100','2013-09-21','12:35:00',7.43),('16100','2013-09-21','12:40:00',7.46),('16100','2013-09-21','12:45:00',7.46),('16100','2013-09-21','12:50:00',7.51),('16100','2013-09-21','12:55:00',7.48),('16100','2013-09-21','13:00:00',7.48),('16100','2013-09-21','13:05:00',7.44),('16100','2013-09-21','13:10:00',7.45),('16100','2013-09-21','13:15:00',7.43),('16100','2013-09-21','13:20:00',7.43),('16100','2013-09-21','13:25:00',7.42),('16100','2013-09-21','13:30:00',7.39),('16100','2013-09-21','13:35:00',7.43),('16100','2013-09-21','13:40:00',7.47),('16100','2013-09-21','13:45:00',7.64),('16100','2013-09-21','13:50:00',7.47),('16100','2013-09-21','13:55:00',5.55),('16100','2013-09-21','14:00:00',6.49),('16100','2013-09-21','14:05:00',6.52),('16100','2013-09-21','14:10:00',6.2),('16100','2013-09-21','14:15:00',6.47),('16100','2013-09-21','14:20:00',6.22),('16100','2013-09-21','14:25:00',3.74),('16100','2013-09-21','14:30:00',2.4),('16100','2013-09-21','14:35:00',6.28),('16100','2013-09-21','14:40:00',7.06),('16100','2013-09-21','14:45:00',6.83),('16100','2013-09-21','14:50:00',6.67),('16100','2013-09-21','14:55:00',6.69),('16100','2013-09-21','15:00:00',6.94),('16100','2013-09-21','15:05:00',4.57),('16100','2013-09-21','15:10:00',6.18),('16100','2013-09-21','15:15:00',7.52),('16100','2013-09-21','15:20:00',3.49),('16100','2013-09-21','15:25:00',3),('16100','2013-09-21','15:30:00',5.1),('16100','2013-09-21','15:35:00',6.92),('16100','2013-09-21','15:40:00',6.02),('16100','2013-09-21','15:45:00',5.65),('16100','2013-09-21','15:50:00',5.71),('16100','2013-09-21','15:55:00',5.77),('16100','2013-09-21','16:00:00',6.04),('16100','2013-09-21','16:05:00',3.74),('16100','2013-09-21','16:10:00',4),('16100','2013-09-21','16:15:00',2.65),('16100','2013-09-21','16:20:00',2.33),('16100','2013-09-21','16:25:00',2.26),('16100','2013-09-21','16:30:00',1.78),('16100','2013-09-21','16:35:00',2.31),('16100','2013-09-21','16:40:00',2.09),('16100','2013-09-21','16:45:00',1.88),('16100','2013-09-21','16:50:00',3.1),('16100','2013-09-21','16:55:00',3.55),('16100','2013-09-21','17:00:00',3.99),('16100','2013-09-21','17:05:00',3.54),('16100','2013-09-21','17:10:00',3.22),('16100','2013-09-21','17:15:00',2.88),('16100','2013-09-21','17:20:00',2.79),('16100','2013-09-21','17:25:00',2.51),('16100','2013-09-21','17:30:00',2.26),('16100','2013-09-21','17:35:00',1.15),('16100','2013-09-21','17:40:00',1.24),('16100','2013-09-21','17:55:00',1.27),('16100','2013-09-20','08:10:00',1.09),('16100','2013-09-20','08:15:00',1.28),('16100','2013-09-20','08:20:00',1.48),('16100','2013-09-20','08:25:00',1.65),('16100','2013-09-20','08:30:00',1.85),('16100','2013-09-20','08:35:00',2.03),('16100','2013-09-20','08:40:00',2.22),('16100','2013-09-20','08:45:00',2.44),('16100','2013-09-20','08:50:00',2.62),('16100','2013-09-20','08:55:00',2.78),('16100','2013-09-20','09:00:00',2.96),('16100','2013-09-20','09:05:00',3.12),('16100','2013-09-20','09:10:00',3.27),('16100','2013-09-20','09:15:00',3.45),('16100','2013-09-20','09:20:00',3.65),('16100','2013-09-20','09:25:00',3.77),('16100','2013-09-20','09:30:00',3.91),('16100','2013-09-20','09:35:00',4.07),('16100','2013-09-20','09:40:00',4.22),('16100','2013-09-20','09:45:00',4.36),('16100','2013-09-20','09:50:00',4.47),('16100','2013-09-20','09:55:00',4.53),('16100','2013-09-20','10:00:00',4.8),('16100','2013-09-20','10:05:00',4.91),('16100','2013-09-20','10:10:00',5),('16100','2013-09-20','10:15:00',5.09),('16100','2013-09-20','10:20:00',5.22),('16100','2013-09-20','10:25:00',5.42),('16100','2013-09-20','10:30:00',5.52),('16100','2013-09-20','10:35:00',5.62),('16100','2013-09-20','10:40:00',5.72),('16100','2013-09-20','10:45:00',5.82),('16100','2013-09-20','10:50:00',5.91),('16100','2013-09-20','10:55:00',5.98),('16100','2013-09-20','11:00:00',6.06),('16100','2013-09-20','11:05:00',6.18),('16100','2013-09-20','11:10:00',6.24),('16100','2013-09-20','11:15:00',6.34),('16100','2013-09-20','11:20:00',6.41),('16100','2013-09-20','11:25:00',6.48),('16100','2013-09-20','11:30:00',6.55),('16100','2013-09-20','11:35:00',6.59),('16100','2013-09-20','11:40:00',6.64),('16100','2013-09-20','11:45:00',6.62),('16100','2013-09-20','11:50:00',6.57),('16100','2013-09-20','11:55:00',6.93),('16100','2013-09-20','12:00:00',6.99),('16100','2013-09-20','12:05:00',7),('16100','2013-09-20','12:10:00',7.05),('16100','2013-09-20','12:15:00',6.55),('16100','2013-09-20','12:20:00',5.59),('16100','2013-09-20','12:25:00',6.51),('16100','2013-09-20','12:30:00',7.1),('16100','2013-09-20','12:35:00',6.91),('16100','2013-09-20','12:40:00',5.97),('16100','2013-09-20','12:45:00',6.38),('16100','2013-09-20','12:50:00',7.26),('16100','2013-09-20','12:55:00',5.44),('16100','2013-09-20','13:00:00',5.75),('16100','2013-09-20','13:05:00',7.24),('16100','2013-09-20','13:10:00',7.03),('16100','2013-09-20','13:15:00',7.49),('16100','2013-09-20','13:20:00',4.46),('16100','2013-09-20','13:25:00',6.69),('16100','2013-09-20','13:30:00',5.79),('16100','2013-09-20','13:35:00',5.2),('16100','2013-09-20','13:40:00',6.77),('16100','2013-09-20','13:45:00',7.1),('16100','2013-09-20','13:50:00',7.11),('16100','2013-09-20','13:55:00',7.01),('16100','2013-09-20','14:00:00',6.58),('16100','2013-09-20','14:05:00',6.7),('16100','2013-09-20','14:10:00',6.71),('16100','2013-09-20','14:15:00',6.37),('16100','2013-09-20','14:20:00',6.69),('16100','2013-09-20','14:25:00',6.63),('16100','2013-09-20','14:30:00',6.59),('16100','2013-09-20','14:35:00',6.47),('16100','2013-09-20','14:40:00',6.46),('16100','2013-09-20','14:45:00',6.35),('16100','2013-09-20','14:50:00',6.25),('16100','2013-09-20','14:55:00',6.2),('16100','2013-09-20','15:00:00',6.06),('16100','2013-09-20','15:05:00',5.75),('16100','2013-09-20','15:10:00',5.99),('16100','2013-09-20','15:15:00',5.9),('16100','2013-09-20','15:20:00',5.79),('16100','2013-09-20','15:25:00',5.67),('16100','2013-09-20','15:30:00',5.58),('16100','2013-09-20','15:35:00',5.54),('16100','2013-09-20','15:40:00',5.44),('16100','2013-09-20','15:45:00',5.24),('16100','2013-09-20','15:50:00',5.26),('16100','2013-09-20','15:55:00',4.47),('16100','2013-09-20','16:00:00',3.24),('16100','2013-09-20','16:05:00',3.43),('16100','2013-09-20','16:10:00',2.85),('16100','2013-09-20','16:15:00',3.85),('16100','2013-09-20','16:20:00',1.74),('16100','2013-09-20','16:25:00',2.66),('16100','2013-09-20','16:30:00',3.85),('16100','2013-09-20','16:35:00',1.83),('16100','2013-09-20','16:40:00',1.87),('16100','2013-09-20','16:45:00',2.12),('16100','2013-09-20','16:50:00',1.41),('16100','2013-09-20','16:55:00',1.67),('16100','2013-09-20','17:00:00',2.27),('16100','2013-09-20','17:05:00',1.73),('16100','2013-09-20','17:10:00',2.49),('16100','2013-09-20','17:15:00',1.9),('16100','2013-09-20','17:20:00',1.12),('16100','2013-09-20','17:25:00',1.19),('16100','2013-09-20','17:30:00',1.82),('16100','2013-09-20','17:35:00',1.69),('16100','2013-09-20','17:40:00',1.86),('16100','2013-09-20','17:45:00',1.65),('16100','2013-09-20','17:50:00',1.29),('16100','2013-09-20','17:55:00',1.21),('16100','2013-09-20','18:00:00',1.08),('16100','2013-09-19','08:30:00',1.07),('16100','2013-09-19','08:35:00',1.21),('16100','2013-09-19','08:40:00',2.45),('16100','2013-09-19','08:45:00',2.41),('16100','2013-09-19','08:50:00',1.51),('16100','2013-09-19','08:55:00',1.5),('16100','2013-09-19','09:00:00',1.52),('16100','2013-09-19','09:05:00',1.45),('16100','2013-09-19','09:10:00',1.42),('16100','2013-09-19','09:15:00',1.51),('16100','2013-09-19','09:20:00',1.56),('16100','2013-09-19','09:25:00',1.59),('16100','2013-09-19','09:30:00',1.61),('16100','2013-09-19','09:35:00',1.78),('16100','2013-09-19','09:40:00',1.87),('16100','2013-09-19','09:45:00',2.04),('16100','2013-09-19','09:50:00',2.21),('16100','2013-09-19','09:55:00',2.56),('16100','2013-09-19','10:00:00',2.54),('16100','2013-09-19','10:05:00',3.35),('16100','2013-09-19','10:10:00',4.33),('16100','2013-09-19','10:15:00',5.91),('16100','2013-09-19','10:20:00',6.29),('16100','2013-09-19','10:25:00',5.25),('16100','2013-09-19','10:30:00',4.59),('16100','2013-09-19','10:35:00',3.82),('16100','2013-09-19','10:40:00',4.53),('16100','2013-09-19','10:45:00',5.17),('16100','2013-09-19','10:50:00',7.27),('16100','2013-09-19','10:55:00',4.36),('16100','2013-09-19','11:00:00',3.91),('16100','2013-09-19','11:05:00',3.92),('16100','2013-09-19','11:10:00',3.92),('16100','2013-09-19','11:15:00',4.21),('16100','2013-09-19','11:20:00',4.7),('16100','2013-09-19','11:25:00',4.09),('16100','2013-09-19','11:30:00',4.31),('16100','2013-09-19','11:35:00',4.57),('16100','2013-09-19','11:40:00',4.31),('16100','2013-09-19','11:45:00',6.49),('16100','2013-09-19','11:50:00',6.1),('16100','2013-09-19','11:55:00',7.25),('16100','2013-09-19','12:00:00',7.82),('16100','2013-09-19','12:05:00',7.45),('16100','2013-09-19','12:10:00',7.21),('16100','2013-09-19','12:15:00',7.23),('16100','2013-09-19','12:20:00',7.4),('16100','2013-09-19','12:25:00',7.62),('16100','2013-09-19','12:30:00',4.89),('16100','2013-09-19','12:35:00',7.44),('16100','2013-09-19','12:40:00',5.54),('16100','2013-09-19','12:45:00',7.41),('16100','2013-09-19','12:50:00',7.51),('16100','2013-09-19','12:55:00',6.81),('16100','2013-09-19','13:00:00',6.48),('16100','2013-09-19','13:05:00',7.22),('16100','2013-09-19','13:10:00',7.14),('16100','2013-09-19','13:15:00',7.11),('16100','2013-09-19','13:20:00',7.13),('16100','2013-09-19','13:25:00',7.1),('16100','2013-09-19','13:30:00',6.89),('16100','2013-09-19','13:35:00',7.15),('16100','2013-09-19','13:40:00',7.14),('16100','2013-09-19','13:45:00',7.09),('16100','2013-09-19','13:50:00',6.64),('16100','2013-09-19','13:55:00',6.94),('16100','2013-09-19','14:00:00',6.28),('16100','2013-09-19','14:05:00',7.17),('16100','2013-09-19','14:10:00',7.2),('16100','2013-09-19','14:15:00',2.33),('16100','2013-09-19','14:20:00',3.01),('16100','2013-09-19','14:25:00',1.74),('16100','2013-09-19','14:30:00',1.65),('16100','2013-09-19','14:35:00',2.16),('16100','2013-09-19','14:40:00',5.69),('16100','2013-09-19','14:45:00',2.16),('16100','2013-09-19','14:50:00',2.2),('16100','2013-09-19','14:55:00',2.59),('16100','2013-09-19','15:00:00',4.53),('16100','2013-09-19','15:05:00',6.59),('16100','2013-09-19','15:10:00',2.61),('16100','2013-09-19','15:15:00',4.63),('16100','2013-09-19','15:20:00',3.41),('16100','2013-09-19','15:25:00',6.67),('16100','2013-09-19','15:30:00',6.5),('16100','2013-09-19','15:35:00',6.06),('16100','2013-09-19','15:40:00',5.42),('16100','2013-09-19','15:45:00',5.33),('16100','2013-09-19','15:50:00',3.83),('16100','2013-09-19','15:55:00',5.64),('16100','2013-09-19','16:00:00',5.58),('16100','2013-09-19','16:05:00',5.65),('16100','2013-09-19','16:10:00',5.64),('16100','2013-09-19','16:15:00',5.64),('16100','2013-09-19','16:20:00',5.28),('16100','2013-09-19','16:25:00',4.84),('16100','2013-09-19','16:30:00',3.41),('16100','2013-09-19','16:35:00',1.76),('16100','2013-09-19','16:40:00',1.35),('16100','2013-09-19','16:45:00',1.85),('16100','2013-09-19','16:50:00',3.04),('16100','2013-09-19','16:55:00',4.03),('16100','2013-09-19','17:00:00',3.86),('16100','2013-09-19','17:05:00',3.95),('16100','2013-09-19','17:10:00',4.07),('16100','2013-09-19','17:15:00',4.06),('16100','2013-09-19','17:20:00',3.86),('16100','2013-09-19','17:25:00',3.5),('16100','2013-09-19','17:30:00',3.44),('16100','2013-09-19','17:35:00',3.34),('16100','2013-09-19','17:40:00',3.06),('16100','2013-09-19','17:45:00',2.78),('16100','2013-09-19','17:50:00',2.06),('16100','2013-09-19','17:55:00',1.45),('16100','2013-09-19','18:00:00',1.51),('16100','2013-09-19','18:05:00',1.39),('16100','2013-09-19','18:10:00',1.37),('16100','2013-09-19','18:15:00',1.06),('16100','2013-09-18','08:15:00',1.29),('16100','2013-09-18','08:20:00',1.43),('16100','2013-09-18','08:25:00',1.35),('16100','2013-09-18','08:30:00',1.88),('16100','2013-09-18','08:35:00',1.67),('16100','2013-09-18','08:40:00',1.51),('16100','2013-09-18','08:45:00',1.69),('16100','2013-09-18','08:50:00',1.1),('16100','2013-09-18','08:55:00',1.55),('16100','2013-09-18','09:00:00',2.73),('16100','2013-09-18','09:05:00',3.04),('16100','2013-09-18','09:10:00',3.69),('16100','2013-09-18','09:15:00',2.36),('16100','2013-09-18','09:20:00',1.62),('16100','2013-09-18','09:25:00',2.35),('16100','2013-09-18','09:30:00',3.68),('16100','2013-09-18','09:35:00',1.33),('16100','2013-09-18','09:40:00',3.95),('16100','2013-09-18','09:45:00',4.47),('16100','2013-09-18','09:50:00',3.62),('16100','2013-09-18','09:55:00',2.53),('16100','2013-09-18','10:00:00',4.63),('16100','2013-09-18','10:05:00',3.79),('16100','2013-09-18','10:10:00',2.63),('16100','2013-09-18','10:15:00',4.25),('16100','2013-09-18','10:20:00',4.97),('16100','2013-09-18','10:25:00',6.03),('16100','2013-09-18','10:30:00',4.2),('16100','2013-09-18','10:35:00',3.34),('16100','2013-09-18','10:40:00',1.92),('16100','2013-09-18','10:45:00',2.18),('16100','2013-09-18','10:50:00',2.04),('16100','2013-09-18','10:55:00',1.49),('16100','2013-09-18','11:00:00',4.34),('16100','2013-09-18','11:05:00',7.05),('16100','2013-09-18','11:10:00',4.78),('16100','2013-09-18','11:15:00',2.44),('16100','2013-09-18','11:20:00',1.33),('16100','2013-09-18','11:25:00',3.14),('16100','2013-09-18','11:30:00',6.78),('16100','2013-09-18','11:35:00',7.14),('16100','2013-09-18','11:40:00',7.82),('16100','2013-09-18','11:45:00',8),('16100','2013-09-18','11:50:00',4.67),('16100','2013-09-18','11:55:00',7.52),('16100','2013-09-18','12:00:00',6.97),('16100','2013-09-18','12:05:00',3.54),('16100','2013-09-18','12:10:00',3.48),('16100','2013-09-18','12:15:00',8.29),('16100','2013-09-18','12:20:00',6.43),('16100','2013-09-18','12:25:00',5.69),('16100','2013-09-18','12:30:00',7.92),('16100','2013-09-18','12:35:00',7.83),('16100','2013-09-18','12:40:00',6.28),('16100','2013-09-18','12:45:00',1.01),('16100','2013-09-18','12:50:00',3.21),('16100','2013-09-18','12:55:00',8.42),('16100','2013-09-18','13:00:00',4.93),('16100','2013-09-18','13:05:00',8.2),('16100','2013-09-18','13:10:00',7.94),('16100','2013-09-18','13:15:00',7.12),('16100','2013-09-18','13:20:00',2.02),('16100','2013-09-18','13:25:00',8.2),('16100','2013-09-18','13:30:00',8),('16100','2013-09-18','13:35:00',7.94),('16100','2013-09-18','13:40:00',8.08),('16100','2013-09-18','13:45:00',6.19),('16100','2013-09-18','13:50:00',5.84),('16100','2013-09-18','13:55:00',6.14),('16100','2013-09-18','14:00:00',6.45),('16100','2013-09-18','14:05:00',7.4),('16100','2013-09-18','14:10:00',7.28),('16100','2013-09-18','14:15:00',7.2),('16100','2013-09-18','14:20:00',7.09),('16100','2013-09-18','14:25:00',7.08),('16100','2013-09-18','14:30:00',6.95),('16100','2013-09-18','14:35:00',6.59),('16100','2013-09-18','14:40:00',6.83),('16100','2013-09-18','14:45:00',6.81),('16100','2013-09-18','14:50:00',6.81),('16100','2013-09-18','14:55:00',6.9),('16100','2013-09-18','15:00:00',6.29),('16100','2013-09-18','15:05:00',5.41),('16100','2013-09-18','15:10:00',6.5),('16100','2013-09-18','15:15:00',3.24),('16100','2013-09-18','15:20:00',3.99),('16100','2013-09-18','15:25:00',5.01),('16100','2013-09-18','15:30:00',4.48),('16100','2013-09-18','15:35:00',5.26),('16100','2013-09-18','15:40:00',6.06),('16100','2013-09-18','15:45:00',4.63),('16100','2013-09-18','15:50:00',5.07),('16100','2013-09-18','15:55:00',4.83),('16100','2013-09-18','16:00:00',4),('16100','2013-09-18','16:05:00',4.24),('16100','2013-09-18','16:10:00',4.53),('16100','2013-09-18','16:15:00',4.84),('16100','2013-09-18','16:20:00',3.79),('16100','2013-09-18','16:25:00',4.39),('16100','2013-09-18','16:30:00',4.22),('16100','2013-09-18','16:35:00',3.98),('16100','2013-09-18','16:40:00',4.05),('16100','2013-09-18','16:45:00',4.23),('16100','2013-09-18','16:50:00',3.86),('16100','2013-09-18','16:55:00',3.44),('16100','2013-09-18','17:00:00',3.47),('16100','2013-09-18','17:05:00',2.96),('16100','2013-09-18','17:10:00',3.08),('16100','2013-09-18','17:15:00',2.43),('16100','2013-09-18','17:20:00',2.48),('16100','2013-09-18','17:25:00',2.53),('16100','2013-09-18','17:30:00',1.7),('16100','2013-09-18','17:35:00',1.23),('16100','2013-09-18','17:40:00',1.49),('16100','2013-09-18','17:45:00',1.15),('16100','2013-09-18','17:50:00',1.36),('16100','2014-04-12','08:35:00',1.11),('16100','2014-04-12','08:40:00',1.21),('16100','2014-04-12','08:45:00',1.21),('16100','2014-04-12','08:50:00',1.26),('16100','2014-04-12','08:55:00',1.24),('16100','2014-04-12','09:00:00',2.11),('16100','2014-04-12','09:05:00',2.13),('16100','2014-04-12','09:10:00',1.82),('16100','2014-04-12','09:15:00',1.88),('16100','2014-04-12','09:20:00',2.16),('16100','2014-04-12','09:25:00',2.36),('16100','2014-04-12','09:30:00',2.16),('16100','2014-04-12','09:35:00',2.22),('16100','2014-04-12','09:40:00',2.34),('16100','2014-04-12','09:45:00',2.56),('16100','2014-04-12','09:50:00',2.74),('16100','2014-04-12','09:55:00',4.58),('16100','2014-04-12','10:00:00',5.55),('16100','2014-04-12','10:05:00',4.75),('16100','2014-04-12','10:10:00',2.65),('16100','2014-04-12','10:15:00',3.28),('16100','2014-04-12','10:20:00',3.21),('16100','2014-04-12','10:25:00',4.41),('16100','2014-04-12','10:30:00',5.25),('16100','2014-04-12','10:35:00',5.93),('16100','2014-04-12','10:40:00',5.94),('16100','2014-04-12','10:45:00',6.18),('16100','2014-04-12','10:50:00',6.29),('16100','2014-04-12','10:55:00',6.34),('16100','2014-04-12','11:00:00',6.63),('16100','2014-04-12','11:05:00',7.02),('16100','2014-04-12','11:10:00',7.85),('16100','2014-04-12','11:15:00',5.92),('16100','2014-04-12','11:20:00',3.63),('16100','2014-04-12','11:25:00',5.63),('16100','2014-04-12','11:30:00',6.39),('16100','2014-04-12','11:35:00',5.27),('16100','2014-04-12','11:40:00',5.79),('16100','2014-04-12','11:45:00',7.33),('16100','2014-04-12','11:50:00',7.69),('16100','2014-04-12','11:55:00',5.1),('16100','2014-04-12','12:00:00',2.38),('16100','2014-04-12','12:05:00',2.21),('16100','2014-04-12','12:10:00',1.96),('16100','2014-04-12','12:15:00',1.91),('16100','2014-04-12','12:20:00',1.47),('16100','2014-04-12','12:45:00',1.04),('16100','2014-04-12','12:50:00',1.56),('16100','2014-04-12','12:55:00',2.06),('16100','2014-04-12','13:00:00',2.49),('16100','2014-04-12','13:05:00',3.07),('16100','2014-04-12','13:10:00',4.74),('16100','2014-04-12','13:15:00',7.72),('16100','2014-04-12','13:20:00',8.1),('16100','2014-04-12','13:25:00',7.13),('16100','2014-04-12','13:30:00',7.42),('16100','2014-04-12','13:35:00',3.87),('16100','2014-04-12','13:40:00',4.13),('16100','2014-04-12','13:45:00',4.7),('16100','2014-04-12','13:50:00',5.74),('16100','2014-04-12','13:55:00',5.26),('16100','2014-04-12','14:00:00',6.99),('16100','2014-04-12','14:05:00',6.93),('16100','2014-04-12','14:10:00',6.55),('16100','2014-04-12','14:15:00',3.64),('16100','2014-04-12','14:20:00',3.08),('16100','2014-04-12','14:25:00',2.87),('16100','2014-04-12','14:30:00',2.98),('16100','2014-04-12','14:35:00',2.95),('16100','2014-04-12','14:40:00',5.47),('16100','2014-04-12','14:45:00',7.7),('16100','2014-04-12','14:50:00',7.31),('16100','2014-04-12','14:55:00',7.15),('16100','2014-04-12','15:00:00',7.02),('16100','2014-04-12','15:05:00',6.96),('16100','2014-04-12','15:10:00',5.74),('16100','2014-04-12','15:15:00',5.77),('16100','2014-04-12','15:20:00',6.62),('16100','2014-04-12','15:25:00',6.28),('16100','2014-04-12','15:30:00',3.28),('16100','2014-04-12','15:35:00',3.93),('16100','2014-04-12','15:40:00',3.83),('16100','2014-04-12','15:45:00',3.58),('16100','2014-04-12','15:50:00',3.69),('16100','2014-04-12','15:55:00',4.59),('16100','2014-04-12','16:00:00',2.46),('16100','2014-04-12','16:05:00',2.03),('16100','2014-04-12','16:10:00',1.93),('16100','2014-04-12','16:15:00',2.16),('16100','2014-04-12','16:20:00',2.2),('16100','2014-04-12','16:25:00',1.88),('16100','2014-04-12','16:30:00',2.95),('16100','2014-04-12','16:35:00',4.68),('16100','2014-04-12','16:40:00',4.6),('16100','2014-04-12','16:45:00',3.65),('16100','2014-04-12','16:50:00',3.78),('16100','2014-04-12','16:55:00',2.12),('16100','2014-04-12','17:00:00',2.34),('16100','2014-04-12','17:05:00',2.26),('16100','2014-04-12','17:10:00',1.71),('16100','2014-04-12','17:15:00',1.72),('16100','2014-04-12','17:20:00',1.64),('16100','2014-04-12','17:25:00',1.13),('16100','2014-04-12','17:30:00',1.76),('16100','2014-04-12','17:35:00',2.07),('16100','2014-04-12','17:40:00',2.07),('16100','2014-04-12','17:45:00',1.89),('16100','2014-04-12','17:50:00',2.02),('16100','2014-04-12','17:55:00',1.89),('16100','2014-04-12','18:00:00',2.05),('16100','2014-04-12','18:05:00',1.91),('16100','2014-04-12','18:10:00',1.44),('16100','2014-04-12','18:15:00',1.15),('16100','2013-09-17','08:10:00',1.06),('16100','2013-09-17','08:15:00',1.21),('16100','2013-09-17','08:20:00',1.4),('16100','2013-09-17','08:25:00',1.49),('16100','2013-09-17','08:30:00',1.4),('16100','2013-09-17','08:35:00',1.87),('16100','2013-09-17','08:40:00',2.21),('16100','2013-09-17','09:00:00',1.72),('16100','2013-09-17','09:05:00',3.2),('16100','2013-09-17','09:10:00',3.53),('16100','2013-09-17','09:15:00',2.89),('16100','2013-09-17','09:20:00',1.46),('16100','2013-09-17','09:25:00',1.8),('16100','2013-09-17','09:30:00',2.81),('16100','2013-09-17','09:35:00',4.69),('16100','2013-09-17','09:40:00',4.6),('16100','2013-09-17','09:45:00',1.19),('16100','2013-09-17','09:55:00',1.13),('16100','2013-09-17','10:00:00',3.51),('16100','2013-09-17','10:05:00',5.1),('16100','2013-09-17','10:10:00',4.79),('16100','2013-09-17','10:15:00',4.41),('16100','2013-09-17','10:20:00',5.15),('16100','2013-09-17','10:25:00',5.37),('16100','2013-09-17','10:30:00',5.52),('16100','2013-09-17','10:35:00',5.59),('16100','2013-09-17','10:40:00',5.68),('16100','2013-09-17','10:45:00',5.85),('16100','2013-09-17','10:50:00',5.93),('16100','2013-09-17','10:55:00',5.96),('16100','2013-09-17','11:00:00',6.08),('16100','2013-09-17','11:05:00',5.45),('16100','2013-09-17','11:10:00',6.51),('16100','2013-09-17','11:15:00',6.38),('16100','2013-09-17','11:20:00',6.56),('16100','2013-09-17','11:25:00',7.02),('16100','2013-09-17','11:30:00',7.04),('16100','2013-09-17','11:35:00',7.09),('16100','2013-09-17','11:40:00',6.24),('16100','2013-09-17','11:45:00',6.17),('16100','2013-09-17','11:50:00',5.82),('16100','2013-09-17','11:55:00',7.28),('16100','2013-09-17','12:00:00',6.9),('16100','2013-09-17','12:05:00',7.35),('16100','2013-09-17','12:10:00',7.42),('16100','2013-09-17','12:15:00',6.7),('16100','2013-09-17','12:20:00',8.05),('16100','2013-09-17','12:25:00',8.22),('16100','2013-09-17','12:30:00',8.28),('16100','2013-09-17','12:35:00',8.02),('16100','2013-09-17','12:40:00',7.86),('16100','2013-09-17','12:45:00',8.11),('16100','2013-09-17','12:50:00',6.91),('16100','2013-09-17','12:55:00',2.65),('16100','2013-09-17','13:00:00',3.63),('16100','2013-09-17','13:05:00',8.41),('16100','2013-09-17','13:10:00',8.43),('16100','2013-09-17','13:15:00',2.88),('16100','2013-09-17','13:20:00',2.94),('16100','2013-09-17','13:25:00',6.56),('16100','2013-09-17','13:30:00',8.3),('16100','2013-09-17','13:35:00',8.26),('16100','2013-09-17','13:40:00',7.68),('16100','2013-09-17','13:45:00',4.19),('16100','2013-09-17','13:50:00',8.08),('16100','2013-09-17','13:55:00',7.53),('16100','2013-09-17','14:00:00',6.26),('16100','2013-09-17','14:05:00',7.11),('16100','2013-09-17','14:10:00',7.37),('16100','2013-09-17','14:15:00',3.52),('16100','2013-09-17','14:20:00',7.23),('16100','2013-09-17','14:25:00',7.41),('16100','2013-09-17','14:30:00',7.23),('16100','2013-09-17','14:35:00',7.15),('16100','2013-09-17','14:40:00',6.12),('16100','2013-09-17','14:45:00',3.92),('16100','2013-09-17','14:50:00',4.35),('16100','2013-09-17','14:55:00',7.34),('16100','2013-09-17','15:00:00',5.93),('16100','2013-09-17','15:05:00',2.32),('16100','2013-09-17','15:10:00',5.07),('16100','2013-09-17','15:15:00',1.91),('16100','2013-09-17','15:20:00',2.52),('16100','2013-09-17','15:25:00',5.25),('16100','2013-09-17','15:30:00',6.42),('16100','2013-09-17','15:35:00',4.73),('16100','2013-09-17','15:40:00',6.07),('16100','2013-09-17','15:45:00',3.66),('16100','2013-09-17','15:50:00',5.57),('16100','2013-09-17','15:55:00',5.63),('16100','2013-09-17','16:00:00',5.52),('16100','2013-09-17','16:05:00',4.82),('16100','2013-09-17','16:10:00',5.35),('16100','2013-09-17','16:15:00',3.71),('16100','2013-09-17','16:20:00',4.61),('16100','2013-09-17','16:25:00',4.5),('16100','2013-09-17','16:30:00',4.13),('16100','2013-09-17','16:35:00',4.05),('16100','2013-09-17','16:40:00',3.6),('16100','2013-09-17','16:45:00',3.39),('16100','2013-09-17','16:50:00',3.56),('16100','2013-09-17','16:55:00',3.63),('16100','2013-09-17','17:00:00',3.3),('16100','2013-09-17','17:05:00',3.38),('16100','2013-09-17','17:10:00',2.83),('16100','2013-09-17','17:15:00',3.23),('16100','2013-09-17','17:20:00',2.92),('16100','2013-09-17','17:25:00',1.56),('16100','2013-09-17','17:30:00',2.53),('16100','2013-09-17','17:35:00',2.2),('16100','2013-09-17','17:40:00',1.98),('16100','2013-09-17','17:45:00',1.83),('16100','2013-09-17','17:50:00',1.68),('16100','2013-09-17','17:55:00',1.47),('16100','2013-09-17','18:00:00',1.25),('16100','2013-09-17','18:05:00',1.14),('16100','2013-09-16','09:00:00',1.03),('16100','2013-09-16','09:05:00',1.13),('16100','2013-09-16','09:10:00',1.54),('16100','2013-09-16','09:15:00',1.18),('16100','2013-09-16','09:20:00',1.37),('16100','2013-09-16','09:25:00',1.74),('16100','2013-09-16','09:30:00',1.53),('16100','2013-09-16','09:35:00',1.3),('16100','2013-09-16','09:40:00',3.91),('16100','2013-09-16','09:45:00',2.43),('16100','2013-09-16','09:50:00',2.6),('16100','2013-09-16','09:55:00',3.07),('16100','2013-09-16','10:00:00',4.03),('16100','2013-09-16','10:05:00',4.17),('16100','2013-09-16','10:10:00',2.36),('16100','2013-09-16','10:15:00',3.5),('16100','2013-09-16','10:20:00',5.61),('16100','2013-09-16','10:25:00',3.84),('16100','2013-09-16','10:30:00',3.94),('16100','2013-09-16','10:35:00',4.5),('16100','2013-09-16','10:40:00',6.6),('16100','2013-09-16','10:45:00',5.36),('16100','2013-09-16','10:50:00',5.26),('16100','2013-09-16','10:55:00',3.22),('16100','2013-09-16','11:00:00',3.42),('16100','2013-09-16','11:05:00',5.83),('16100','2013-09-16','11:10:00',6.21),('16100','2013-09-16','11:15:00',2.96),('16100','2013-09-16','11:20:00',2.16),('16100','2013-09-16','11:25:00',4.3),('16100','2013-09-16','11:30:00',2.54),('16100','2013-09-16','11:35:00',4.32),('16100','2013-09-16','11:40:00',4.05),('16100','2013-09-16','11:45:00',6.95),('16100','2013-09-16','11:50:00',2.45),('16100','2013-09-16','11:55:00',6.83),('16100','2013-09-16','12:00:00',3.71),('16100','2013-09-16','12:05:00',1.64),('16100','2013-09-16','12:10:00',1.8),('16100','2013-09-16','12:15:00',2.91),('16100','2013-09-16','12:20:00',4.75),('16100','2013-09-16','12:25:00',2.66),('16100','2013-09-16','12:30:00',2.57),('16100','2013-09-16','12:35:00',2.56),('16100','2013-09-16','12:40:00',1.61),('16100','2013-09-16','12:45:00',2.41),('16100','2013-09-16','12:50:00',5.05),('16100','2013-09-16','12:55:00',5.1),('16100','2013-09-16','13:00:00',5.8),('16100','2013-09-16','13:05:00',5.94),('16100','2013-09-16','13:10:00',4.04),('16100','2013-09-16','13:15:00',2.51),('16100','2013-09-16','13:20:00',2.62),('16100','2013-09-16','13:25:00',3.38),('16100','2013-09-16','13:30:00',2.28),('16100','2013-09-16','13:35:00',2.52),('16100','2013-09-16','13:40:00',2.44),('16100','2013-09-16','13:45:00',2.12),('16100','2013-09-16','13:50:00',1.95),('16100','2013-09-16','13:55:00',2.31),('16100','2013-09-16','14:00:00',1.68),('16100','2013-09-16','14:05:00',2.9),('16100','2013-09-16','14:10:00',3.48),('16100','2013-09-16','14:15:00',1.96),('16100','2013-09-16','14:20:00',1.07),('16100','2013-09-16','14:30:00',2.85),('16100','2013-09-16','14:35:00',1.95),('16100','2013-09-16','14:40:00',1.42),('16100','2013-09-16','14:45:00',1.59),('16100','2013-09-16','14:50:00',2.55),('16100','2013-09-16','14:55:00',6.26),('16100','2013-09-16','15:00:00',6.34),('16100','2013-09-16','15:05:00',5.25),('16100','2013-09-16','15:10:00',4.96),('16100','2013-09-16','15:15:00',3.32),('16100','2013-09-16','15:20:00',1.35),('16100','2013-09-16','15:25:00',1.37),('16100','2013-09-16','15:30:00',1.24),('16100','2013-09-16','15:35:00',1.88),('16100','2013-09-16','15:40:00',2.08),('16100','2013-09-16','15:45:00',4.35),('16100','2013-09-16','15:50:00',2.69),('16100','2013-09-16','15:55:00',4.04),('16100','2013-09-16','16:00:00',4.14),('16100','2013-09-16','16:05:00',3.63),('16100','2013-09-16','16:10:00',3.98),('16100','2013-09-16','16:15:00',2.75),('16100','2013-09-16','16:20:00',1.33),('16100','2013-09-16','16:35:00',1.64),('16100','2013-09-16','16:40:00',2.62),('16100','2013-09-16','16:45:00',2.66),('16100','2013-09-16','16:50:00',1.82),('16100','2013-09-16','16:55:00',2.06),('16100','2013-09-16','17:00:00',2.95),('16100','2013-09-16','17:05:00',2.9),('16100','2013-09-16','17:10:00',3.05),('16100','2013-09-16','17:15:00',2.81),('16100','2013-09-16','17:20:00',2.46),('16100','2013-09-16','17:25:00',2.43),('16100','2013-09-16','17:30:00',2.33),('16100','2013-09-16','17:35:00',2.2),('16100','2013-09-16','17:40:00',1.67),('16100','2013-09-16','17:45:00',1.42),('16100','2013-09-16','17:50:00',1.15),('16100','2013-09-16','17:55:00',1.13),('16100','2013-09-16','18:00:00',1.1),('16100','2013-09-16','18:05:00',1.15),('16100','2013-09-15','08:05:00',1.01),('16100','2013-09-15','08:10:00',1.2),('16100','2013-09-15','08:15:00',1.36),('16100','2013-09-15','08:20:00',1.54),('16100','2013-09-15','08:25:00',1.72),('16100','2013-09-15','08:30:00',2),('16100','2013-09-15','08:35:00',2.05),('16100','2013-09-15','08:40:00',2.17),('16100','2013-09-15','08:45:00',2.5),('16100','2013-09-15','08:50:00',2.6),('16100','2013-09-15','08:55:00',1.24),('16100','2013-09-15','09:00:00',1.4),('16100','2013-09-15','09:05:00',1.79),('16100','2013-09-15','09:10:00',1.64),('16100','2013-09-15','09:15:00',2.42),('16100','2013-09-15','09:20:00',3.02),('16100','2013-09-15','09:25:00',3.89),('16100','2013-09-15','09:30:00',3.99),('16100','2013-09-15','09:35:00',4.13),('16100','2013-09-15','09:40:00',4.29),('16100','2013-09-15','09:45:00',4.42),('16100','2013-09-15','09:50:00',4.64),('16100','2013-09-15','09:55:00',4.73),('16100','2013-09-15','10:00:00',4.9),('16100','2013-09-15','10:05:00',5.02),('16100','2013-09-15','10:10:00',5.33),('16100','2013-09-15','10:15:00',3.46),('16100','2013-09-15','10:20:00',4.04),('16100','2013-09-15','10:25:00',1.34),('16100','2013-09-15','10:30:00',1.36),('16100','2013-09-15','10:45:00',6.06),('16100','2013-09-15','10:50:00',5.87),('16100','2013-09-15','10:55:00',7.14),('16100','2013-09-15','11:00:00',3.11),('16100','2013-09-15','11:05:00',4.19),('16100','2013-09-15','11:10:00',7.38),('16100','2013-09-15','11:15:00',6.72),('16100','2013-09-15','11:20:00',7.28),('16100','2013-09-15','11:25:00',6.17),('16100','2013-09-15','11:30:00',5.66),('16100','2013-09-15','11:35:00',7.34),('16100','2013-09-15','11:40:00',5.24),('16100','2013-09-15','11:45:00',4.41),('16100','2013-09-15','11:50:00',5.37),('16100','2013-09-15','11:55:00',6.9),('16100','2013-09-15','12:00:00',8.15),('16100','2013-09-15','12:05:00',6.99),('16100','2013-09-15','12:10:00',1.5),('16100','2013-09-15','12:15:00',6.36),('16100','2013-09-15','12:20:00',7.88),('16100','2013-09-15','12:25:00',7.67),('16100','2013-09-15','12:30:00',6.1),('16100','2013-09-15','12:35:00',4.5),('16100','2013-09-15','12:40:00',7.13),('16100','2013-09-15','12:45:00',2.84),('16100','2013-09-15','12:50:00',4.8),('16100','2013-09-15','12:55:00',1.78),('16100','2013-09-15','13:00:00',4.23),('16100','2013-09-15','13:05:00',7.02),('16100','2013-09-15','13:10:00',7.39),('16100','2013-09-15','13:15:00',7.85),('16100','2013-09-15','13:20:00',7.8),('16100','2013-09-15','13:25:00',7.72),('16100','2013-09-15','13:30:00',7.65),('16100','2013-09-15','13:35:00',7.62),('16100','2013-09-15','13:40:00',7.78),('16100','2013-09-15','13:45:00',7.4),('16100','2013-09-15','13:50:00',3.65),('16100','2013-09-15','13:55:00',6.42),('16100','2013-09-15','14:00:00',7.71),('16100','2013-09-15','14:05:00',7.34),('16100','2013-09-15','14:10:00',7.2),('16100','2013-09-15','14:15:00',7.16),('16100','2013-09-15','14:20:00',7.09),('16100','2013-09-15','14:25:00',7),('16100','2013-09-15','14:30:00',7),('16100','2013-09-15','14:35:00',6.89),('16100','2013-09-15','14:40:00',6.82),('16100','2013-09-15','14:45:00',6.84),('16100','2013-09-15','14:50:00',6.75),('16100','2013-09-15','14:55:00',6.71),('16100','2013-09-15','15:00:00',6.63),('16100','2013-09-15','15:05:00',6.54),('16100','2013-09-15','15:10:00',6.42),('16100','2013-09-15','15:15:00',6.32),('16100','2013-09-15','15:20:00',6.22),('16100','2013-09-15','15:25:00',6.15),('16100','2013-09-15','15:30:00',6.02),('16100','2013-09-15','15:35:00',5.94),('16100','2013-09-15','15:40:00',5.86),('16100','2013-09-15','15:45:00',5.78),('16100','2013-09-15','15:50:00',5.66),('16100','2013-09-15','15:55:00',4.32),('16100','2013-09-15','16:00:00',4.85),('16100','2013-09-15','16:05:00',5.44),('16100','2013-09-15','16:10:00',5.14),('16100','2013-09-15','16:15:00',5),('16100','2013-09-15','16:20:00',4.87),('16100','2013-09-15','16:25:00',4.74),('16100','2013-09-15','16:30:00',4.6),('16100','2013-09-15','16:35:00',4.48),('16100','2013-09-15','16:40:00',4.32),('16100','2013-09-15','16:45:00',4.16),('16100','2013-09-15','16:50:00',4.01),('16100','2013-09-15','16:55:00',3.81),('16100','2013-09-15','17:00:00',3.69),('16100','2013-09-15','17:05:00',3.46),('16100','2013-09-15','17:10:00',3.34),('16100','2013-09-15','17:15:00',2.88),('16100','2013-09-15','17:20:00',2.8),('16100','2013-09-15','17:25:00',2.51),('16100','2013-09-15','17:30:00',1.62),('16100','2013-09-15','17:35:00',2.04),('16100','2013-09-15','17:40:00',2.3),('16100','2013-09-15','17:45:00',2.07),('16100','2013-09-15','17:50:00',1.84),('16100','2013-09-15','17:55:00',1.68),('16100','2013-09-15','18:00:00',1.47),('16100','2013-09-15','18:05:00',1.32),('16100','2013-09-15','18:10:00',1.14),('16100','2013-09-14','08:05:00',1.05),('16100','2013-09-14','08:10:00',1.23),('16100','2013-09-14','08:15:00',1.43),('16100','2013-09-14','08:20:00',1.63),('16100','2013-09-14','08:25:00',1.82),('16100','2013-09-14','08:30:00',2.03),('16100','2013-09-14','08:35:00',2.27),('16100','2013-09-14','08:40:00',2.49),('16100','2013-09-14','08:45:00',2.69),('16100','2013-09-14','08:50:00',2.69),('16100','2013-09-14','08:55:00',2.84),('16100','2013-09-14','09:00:00',2.98),('16100','2013-09-14','09:05:00',3.2),('16100','2013-09-14','09:10:00',3.36),('16100','2013-09-14','09:15:00',3.69),('16100','2013-09-14','09:20:00',3.66),('16100','2013-09-14','09:25:00',3.82),('16100','2013-09-14','09:30:00',3.88),('16100','2013-09-14','09:35:00',4.11),('16100','2013-09-14','09:40:00',4.28),('16100','2013-09-14','09:45:00',4.46),('16100','2013-09-14','09:50:00',4.53),('16100','2013-09-14','09:55:00',4.83),('16100','2013-09-14','10:00:00',4.89),('16100','2013-09-14','10:05:00',4.92),('16100','2013-09-14','10:10:00',4.61),('16100','2013-09-14','10:15:00',4.86),('16100','2013-09-14','10:20:00',5.04),('16100','2013-09-14','10:25:00',5.23),('16100','2013-09-14','10:30:00',5.24),('16100','2013-09-14','10:35:00',5.74),('16100','2013-09-14','10:40:00',5.81),('16100','2013-09-14','10:45:00',5.54),('16100','2013-09-14','10:50:00',5.91),('16100','2013-09-14','10:55:00',5.41),('16100','2013-09-14','11:00:00',4.68),('16100','2013-09-14','11:05:00',6.97),('16100','2013-09-14','11:10:00',7.14),('16100','2013-09-14','11:15:00',3.51),('16100','2013-09-14','11:20:00',1.47),('16100','2013-09-14','11:25:00',1.51),('16100','2013-09-14','11:30:00',2.28),('16100','2013-09-14','11:35:00',5.06),('16100','2013-09-14','11:40:00',2.09),('16100','2013-09-14','11:45:00',1.87),('16100','2013-09-14','11:50:00',2.11),('16100','2013-09-14','11:55:00',3.05),('16100','2013-09-14','12:00:00',3.72),('16100','2013-09-14','12:05:00',3.07),('16100','2013-09-14','12:10:00',3.61),('16100','2013-09-14','12:15:00',2.86),('16100','2013-09-14','12:20:00',2.62),('16100','2013-09-14','12:25:00',3.2),('16100','2013-09-14','12:30:00',5.83),('16100','2013-09-14','12:35:00',3.37),('16100','2013-09-14','12:40:00',2.92),('16100','2013-09-14','12:45:00',2.18),('16100','2013-09-14','12:50:00',2.07),('16100','2013-09-14','12:55:00',1.99),('16100','2013-09-14','13:00:00',2.15),('16100','2013-09-14','13:05:00',2.31),('16100','2013-09-14','13:10:00',3.49),('16100','2013-09-14','13:15:00',2.89),('16100','2013-09-14','13:20:00',2.52),('16100','2013-09-14','13:25:00',2.3),('16100','2013-09-14','13:30:00',2.3),('16100','2013-09-14','13:35:00',2.43),('16100','2013-09-14','13:40:00',3.01),('16100','2013-09-14','13:45:00',4.92),('16100','2013-09-14','13:50:00',2.97),('16100','2013-09-14','13:55:00',3.39),('16100','2013-09-14','14:00:00',5.04),('16100','2013-09-14','14:05:00',3.05),('16100','2013-09-14','14:10:00',3.3),('16100','2013-09-14','14:15:00',3.03),('16100','2013-09-14','14:20:00',2.58),('16100','2013-09-14','14:25:00',2.29),('16100','2013-09-14','14:30:00',2.02),('16100','2013-09-14','14:35:00',1.62),('16100','2013-09-14','14:40:00',1.56),('16100','2013-09-14','14:45:00',1.56),('16100','2013-09-14','14:50:00',1.7),('16100','2013-09-14','14:55:00',1.76),('16100','2013-09-14','15:00:00',1.89),('16100','2013-09-14','15:05:00',1.84),('16100','2013-09-14','15:10:00',2.51),('16100','2013-09-14','15:15:00',3.22),('16100','2013-09-14','15:20:00',3.07),('16100','2013-09-14','15:25:00',1.95),('16100','2013-09-14','15:30:00',1.48),('16100','2013-09-14','15:35:00',1.6),('16100','2013-09-14','15:40:00',1.46),('16100','2013-09-14','15:45:00',1.21),('16100','2013-09-14','15:50:00',1.15),('16100','2013-09-14','16:00:00',1.09),('16100','2013-09-14','16:05:00',1.45),('16100','2013-09-14','16:10:00',1.16),('16100','2013-09-14','16:35:00',1.24),('16100','2013-09-14','16:40:00',1.57),('16100','2013-09-14','16:45:00',1.4),('16100','2013-09-14','16:50:00',1.06),('16100','2013-09-14','17:00:00',1.25),('16100','2013-09-14','17:05:00',1.16),('16100','2013-09-14','17:10:00',1.03),('16100','2013-09-14','17:15:00',1.08),('16100','2013-09-14','17:20:00',1.12),('16100','2013-09-13','08:05:00',1.03),('16100','2013-09-13','08:10:00',1.19),('16100','2013-09-13','08:15:00',1.37),('16100','2013-09-13','08:20:00',1.56),('16100','2013-09-13','08:25:00',1.74),('16100','2013-09-13','08:30:00',1.94),('16100','2013-09-13','08:35:00',2.13),('16100','2013-09-13','08:40:00',2.31),('16100','2013-09-13','08:45:00',2.51),('16100','2013-09-13','08:50:00',2.66),('16100','2013-09-13','08:55:00',2.81),('16100','2013-09-13','09:00:00',3.02),('16100','2013-09-13','09:05:00',3.19),('16100','2013-09-13','09:10:00',3.35),('16100','2013-09-13','09:15:00',3.55),('16100','2013-09-13','09:20:00',3.72),('16100','2013-09-13','09:25:00',3.89),('16100','2013-09-13','09:30:00',4.07),('16100','2013-09-13','09:35:00',4.21),('16100','2013-09-13','09:40:00',4.33),('16100','2013-09-13','09:45:00',4.47),('16100','2013-09-13','09:50:00',4.62),('16100','2013-09-13','09:55:00',4.8),('16100','2013-09-13','10:00:00',4.92),('16100','2013-09-13','10:05:00',5.05),('16100','2013-09-13','10:10:00',5.12),('16100','2013-09-13','10:15:00',4.9),('16100','2013-09-13','10:20:00',5.43),('16100','2013-09-13','10:25:00',5.26),('16100','2013-09-13','10:30:00',5.63),('16100','2013-09-13','10:35:00',5.75),('16100','2013-09-13','10:40:00',5.65),('16100','2013-09-13','10:45:00',5.95),('16100','2013-09-13','10:50:00',6.07),('16100','2013-09-13','10:55:00',5.93),('16100','2013-09-13','11:00:00',3.06),('16100','2013-09-13','11:05:00',1.65),('16100','2013-09-13','11:10:00',2.11),('16100','2013-09-13','11:15:00',2.58),('16100','2013-09-13','11:20:00',7.16),('16100','2013-09-13','11:25:00',6.44),('16100','2013-09-13','11:30:00',7.04),('16100','2013-09-13','11:35:00',6.95),('16100','2013-09-13','11:40:00',7.13),('16100','2013-09-13','11:45:00',7.15),('16100','2013-09-13','11:50:00',5.69),('16100','2013-09-13','11:55:00',6.75),('16100','2013-09-13','12:00:00',6.79),('16100','2013-09-13','12:05:00',7.08),('16100','2013-09-13','12:10:00',5.78),('16100','2013-09-13','12:15:00',6.34),('16100','2013-09-13','12:20:00',7.07),('16100','2013-09-13','12:25:00',7.35),('16100','2013-09-13','12:30:00',7.34),('16100','2013-09-13','12:35:00',7.62),('16100','2013-09-13','12:40:00',7.52),('16100','2013-09-13','12:45:00',7.59),('16100','2013-09-13','12:50:00',7.64),('16100','2013-09-13','12:55:00',7.7),('16100','2013-09-13','13:00:00',7.69),('16100','2013-09-13','13:05:00',7.69),('16100','2013-09-13','13:10:00',7.72),('16100','2013-09-13','13:15:00',7.63),('16100','2013-09-13','13:20:00',7.53),('16100','2013-09-13','13:25:00',7.51),('16100','2013-09-13','13:30:00',7.5),('16100','2013-09-13','13:35:00',7.61),('16100','2013-09-13','13:40:00',7.62),('16100','2013-09-13','13:45:00',5.24),('16100','2013-09-13','13:50:00',5.72),('16100','2013-09-13','13:55:00',6.68),('16100','2013-09-13','14:00:00',7.8),('16100','2013-09-13','14:05:00',7.53),('16100','2013-09-13','14:10:00',7.39),('16100','2013-09-13','14:15:00',7.18),('16100','2013-09-13','14:20:00',7.01),('16100','2013-09-13','14:25:00',6.99),('16100','2013-09-13','14:30:00',6.9),('16100','2013-09-13','14:35:00',6.88),('16100','2013-09-13','14:40:00',6.85),('16100','2013-09-13','14:45:00',6.76),('16100','2013-09-13','14:50:00',6.68),('16100','2013-09-13','14:55:00',6.67),('16100','2013-09-13','15:00:00',6.58),('16100','2013-09-13','15:05:00',6.42),('16100','2013-09-13','15:10:00',6.32),('16100','2013-09-13','15:15:00',6.11),('16100','2013-09-13','15:20:00',6.09),('16100','2013-09-13','15:25:00',6.05),('16100','2013-09-13','15:30:00',5.94),('16100','2013-09-13','15:35:00',5.85),('16100','2013-09-13','15:40:00',5.8),('16100','2013-09-13','15:45:00',5.7),('16100','2013-09-13','15:50:00',5.55),('16100','2013-09-13','15:55:00',5.49),('16100','2013-09-13','16:00:00',5.28),('16100','2013-09-13','16:05:00',5.18),('16100','2013-09-13','16:10:00',5.06),('16100','2013-09-13','16:15:00',4.96),('16100','2013-09-13','16:20:00',4.84),('16100','2013-09-13','16:25:00',4.71),('16100','2013-09-13','16:30:00',4.54),('16100','2013-09-13','16:35:00',4.44),('16100','2013-09-13','16:40:00',4.23),('16100','2013-09-13','16:45:00',4),('16100','2013-09-13','16:50:00',3.97),('16100','2013-09-13','16:55:00',3.87),('16100','2013-09-13','17:00:00',3.64),('16100','2013-09-13','17:05:00',3.42),('16100','2013-09-13','17:10:00',3.31),('16100','2013-09-13','17:15:00',3.11),('16100','2013-09-13','17:20:00',2.91),('16100','2013-09-13','17:25:00',2.29),('16100','2013-09-13','17:30:00',2.55),('16100','2013-09-13','17:35:00',2.37),('16100','2013-09-13','17:40:00',2.25),('16100','2013-09-13','17:45:00',2.03),('16100','2013-09-13','17:50:00',1.85),('16100','2013-09-13','17:55:00',1.68),('16100','2013-09-13','18:00:00',1.49),('16100','2013-09-13','18:05:00',1.37),('16100','2013-09-13','18:10:00',1.17),('16100','2013-09-12','08:45:00',1.02),('16100','2013-09-12','08:50:00',1.07),('16100','2013-09-12','08:55:00',1.07),('16100','2013-09-12','09:00:00',1.08),('16100','2013-09-12','09:05:00',1.08),('16100','2013-09-12','09:10:00',1.13),('16100','2013-09-12','09:15:00',1.24),('16100','2013-09-12','09:20:00',1.45),('16100','2013-09-12','09:25:00',1.57),('16100','2013-09-12','09:30:00',1.61),('16100','2013-09-12','09:35:00',1.72),('16100','2013-09-12','09:40:00',1.85),('16100','2013-09-12','09:45:00',1.95),('16100','2013-09-12','09:50:00',1.95),('16100','2013-09-12','09:55:00',1.95),('16100','2013-09-12','10:00:00',2.52),('16100','2013-09-12','10:05:00',6.69),('16100','2013-09-12','10:10:00',3.83),('16100','2013-09-12','10:15:00',3.62),('16100','2013-09-12','10:20:00',3.03),('16100','2013-09-12','10:25:00',5),('16100','2013-09-12','10:30:00',5.26),('16100','2013-09-12','10:35:00',5.99),('16100','2013-09-12','10:40:00',5.96),('16100','2013-09-12','10:45:00',6.02),('16100','2013-09-12','10:50:00',6.1),('16100','2013-09-12','10:55:00',6.16),('16100','2013-09-12','11:00:00',6.28),('16100','2013-09-12','11:05:00',6.37),('16100','2013-09-12','11:10:00',6.42),('16100','2013-09-12','11:15:00',6.53),('16100','2013-09-12','11:20:00',6.59),('16100','2013-09-12','11:25:00',6.66),('16100','2013-09-12','11:30:00',6.71),('16100','2013-09-12','11:35:00',6.77),('16100','2013-09-12','11:40:00',6.8),('16100','2013-09-12','11:45:00',6.89),('16100','2013-09-12','11:50:00',7.02),('16100','2013-09-12','11:55:00',7.04),('16100','2013-09-12','12:00:00',7.13),('16100','2013-09-12','12:05:00',7.09),('16100','2013-09-12','12:10:00',5.23),('16100','2013-09-12','12:15:00',6.76),('16100','2013-09-12','12:20:00',7.39),('16100','2013-09-12','12:25:00',7.48),('16100','2013-09-12','12:30:00',6.2),('16100','2013-09-12','12:35:00',7.7),('16100','2013-09-12','12:40:00',7.61),('16100','2013-09-12','12:45:00',6.31),('16100','2013-09-12','12:50:00',3.61),('16100','2013-09-12','12:55:00',1.51),('16100','2013-09-12','13:00:00',5.47),('16100','2013-09-12','13:05:00',7.79),('16100','2013-09-12','13:10:00',7.62),('16100','2013-09-12','13:15:00',7.51),('16100','2013-09-12','13:20:00',7.44),('16100','2013-09-12','13:25:00',7.38),('16100','2013-09-12','13:30:00',7.34),('16100','2013-09-12','13:35:00',7.33),('16100','2013-09-12','13:40:00',7.3),('16100','2013-09-12','13:45:00',7.24),('16100','2013-09-12','13:50:00',7.18),('16100','2013-09-12','13:55:00',7.19),('16100','2013-09-12','14:00:00',7.19),('16100','2013-09-12','14:05:00',7.09),('16100','2013-09-12','14:10:00',7.16),('16100','2013-09-12','14:15:00',7.19),('16100','2013-09-12','14:20:00',7.14),('16100','2013-09-12','14:25:00',6.97),('16100','2013-09-12','14:30:00',7),('16100','2013-09-12','14:35:00',7.06),('16100','2013-09-12','14:40:00',6.78),('16100','2013-09-12','14:45:00',6.82),('16100','2013-09-12','14:50:00',6.82),('16100','2013-09-12','14:55:00',6.79),('16100','2013-09-12','15:00:00',6.64),('16100','2013-09-12','15:05:00',6.63),('16100','2013-09-12','15:10:00',6.45),('16100','2013-09-12','15:15:00',6.37),('16100','2013-09-12','15:20:00',6.25),('16100','2013-09-12','15:25:00',6.16),('16100','2013-09-12','15:30:00',6.04),('16100','2013-09-12','15:35:00',5.96),('16100','2013-09-12','15:40:00',5.91),('16100','2013-09-12','15:45:00',5.8),('16100','2013-09-12','15:50:00',5.68),('16100','2013-09-12','15:55:00',5.61),('16100','2013-09-12','16:00:00',5.42),('16100','2013-09-12','16:05:00',5.29),('16100','2013-09-12','16:10:00',5.16),('16100','2013-09-12','16:15:00',5.03),('16100','2013-09-12','16:20:00',4.86),('16100','2013-09-12','16:25:00',4.75),('16100','2013-09-12','16:30:00',4.61),('16100','2013-09-12','16:35:00',4.45),('16100','2013-09-12','16:40:00',4.31),('16100','2013-09-12','16:45:00',4.12),('16100','2013-09-12','16:50:00',3.95),('16100','2013-09-12','16:55:00',3.82),('16100','2013-09-12','17:00:00',3.69),('16100','2013-09-12','17:05:00',3.5),('16100','2013-09-12','17:10:00',3.29),('16100','2013-09-12','17:15:00',3.13),('16100','2013-09-12','17:20:00',2.97),('16100','2013-09-12','17:25:00',2.78),('16100','2013-09-12','17:30:00',2.6),('16100','2013-09-12','17:35:00',2.44),('16100','2013-09-12','17:40:00',2.28),('16100','2013-09-12','17:45:00',2.1),('16100','2013-09-12','17:50:00',1.92),('16100','2013-09-12','17:55:00',1.75),('16100','2013-09-12','18:00:00',1.57),('16100','2013-09-12','18:05:00',1.39),('16100','2013-09-12','18:10:00',1.22),('16100','2013-09-12','18:15:00',1.05),('16100','2013-09-11','07:50:00',1.03),('16100','2013-09-11','07:55:00',1.09),('16100','2013-09-11','08:00:00',1.01),('16100','2013-09-11','08:20:00',1.83),('16100','2013-09-11','08:25:00',1.31),('16100','2013-09-11','08:40:00',1.14),('16100','2013-09-11','08:45:00',1.3),('16100','2013-09-11','08:50:00',1.86),('16100','2013-09-11','08:55:00',2.9),('16100','2013-09-11','09:00:00',3.06),('16100','2013-09-11','09:05:00',2.62),('16100','2013-09-11','09:10:00',2.46),('16100','2013-09-11','09:15:00',2.34),('16100','2013-09-11','09:20:00',2.47),('16100','2013-09-11','09:25:00',4.08),('16100','2013-09-11','09:30:00',4.08),('16100','2013-09-11','09:35:00',2.6),('16100','2013-09-11','09:40:00',2.59),('16100','2013-09-11','09:45:00',1.1),('16100','2013-09-11','09:50:00',2.18),('16100','2013-09-11','09:55:00',2.05),('16100','2013-09-11','10:00:00',2.24),('16100','2013-09-11','10:05:00',3.62),('16100','2013-09-11','10:10:00',3.05),('16100','2013-09-11','10:15:00',1.94),('16100','2013-09-11','10:20:00',1.38),('16100','2013-09-11','10:25:00',2.48),('16100','2013-09-11','10:30:00',2.21),('16100','2013-09-11','10:35:00',1.05),('16100','2013-09-11','10:40:00',2.45),('16100','2013-09-11','10:45:00',2.43),('16100','2013-09-11','10:50:00',4.49),('16100','2013-09-11','10:55:00',7.02),('16100','2013-09-11','11:00:00',4.97),('16100','2013-09-11','11:05:00',4.92),('16100','2013-09-11','11:10:00',2.08),('16100','2013-09-11','11:35:00',1.99),('16100','2013-09-11','11:40:00',2.46),('16100','2013-09-11','11:45:00',3.62),('16100','2013-09-11','11:50:00',4.06),('16100','2013-09-11','11:55:00',6.89),('16100','2013-09-11','12:00:00',7.65),('16100','2013-09-11','12:05:00',7.46),('16100','2013-09-11','12:10:00',6.72),('16100','2013-09-11','12:15:00',5),('16100','2013-09-11','12:20:00',5.81),('16100','2013-09-11','12:25:00',7.56),('16100','2013-09-11','12:30:00',4.71),('16100','2013-09-11','12:35:00',3.15),('16100','2013-09-11','12:40:00',6.26),('16100','2013-09-11','12:45:00',4.74),('16100','2013-09-11','12:50:00',5.57),('16100','2013-09-11','12:55:00',6.64),('16100','2013-09-11','13:00:00',8.34),('16100','2013-09-11','13:05:00',6.6),('16100','2013-09-11','13:10:00',8.16),('16100','2013-09-11','13:15:00',6.37),('16100','2013-09-11','13:20:00',3.5),('16100','2013-09-11','13:25:00',5.09),('16100','2013-09-11','13:30:00',6.03),('16100','2013-09-11','13:35:00',5.85),('16100','2013-09-11','13:40:00',1.91),('16100','2013-09-11','13:45:00',7.41),('16100','2013-09-11','13:50:00',7.61),('16100','2013-09-11','13:55:00',3.92),('16100','2013-09-11','14:00:00',4.61),('16100','2013-09-11','14:05:00',5.74),('16100','2013-09-11','14:10:00',7.59),('16100','2013-09-11','14:15:00',7.5),('16100','2013-09-11','14:20:00',7.04),('16100','2013-09-11','14:25:00',6.11),('16100','2013-09-11','14:30:00',5.42),('16100','2013-09-11','14:35:00',7.68),('16100','2013-09-11','14:40:00',7.52),('16100','2013-09-11','14:45:00',7.31),('16100','2013-09-11','14:50:00',7.12),('16100','2013-09-11','14:55:00',5),('16100','2013-09-11','15:00:00',7.11),('16100','2013-09-11','15:05:00',6.8),('16100','2013-09-11','15:10:00',6.69),('16100','2013-09-11','15:15:00',6.56),('16100','2013-09-11','15:20:00',6.45),('16100','2013-09-11','15:25:00',6.32),('16100','2013-09-11','15:30:00',6.28),('16100','2013-09-11','15:35:00',6.14),('16100','2013-09-11','15:40:00',6.06),('16100','2013-09-11','15:45:00',5.97),('16100','2013-09-11','15:50:00',5.99),('16100','2013-09-11','15:55:00',5.44),('16100','2013-09-11','16:00:00',5.75),('16100','2013-09-11','16:05:00',5.71),('16100','2013-09-11','16:10:00',5.48),('16100','2013-09-11','16:15:00',4.28),('16100','2013-09-11','16:20:00',5.27),('16100','2013-09-11','16:25:00',4.99),('16100','2013-09-11','16:30:00',4.9),('16100','2013-09-11','16:35:00',4.92),('16100','2013-09-11','16:40:00',3.4),('16100','2013-09-11','16:45:00',4.58),('16100','2013-09-11','16:50:00',4.3),('16100','2013-09-11','16:55:00',3.44),('16100','2013-09-11','17:00:00',4.02),('16100','2013-09-11','17:05:00',3.13),('16100','2013-09-11','17:10:00',3.7),('16100','2013-09-11','17:15:00',3.38),('16100','2013-09-11','17:20:00',3.17),('16100','2013-09-11','17:25:00',2.97),('16100','2013-09-11','17:30:00',2.8),('16100','2013-09-11','17:35:00',2.58),('16100','2013-09-11','17:40:00',2.39),('16100','2013-09-11','17:45:00',2.21),('16100','2013-09-11','17:50:00',2.01),('16100','2013-09-11','17:55:00',1.29),('16100','2013-09-11','18:00:00',1.04),('16100','2013-09-11','18:05:00',1.54),('16100','2013-09-11','18:10:00',1.43),('16100','2013-09-10','08:05:00',1.72),('16100','2013-09-10','08:25:00',1.02),('16100','2013-09-10','08:30:00',1.02),('16100','2013-09-10','08:50:00',1.24),('16100','2013-09-10','08:55:00',1.19),('16100','2013-09-10','09:00:00',1.14),('16100','2013-09-10','09:05:00',1.13),('16100','2013-09-10','09:10:00',1.31),('16100','2013-09-10','09:15:00',1.57),('16100','2013-09-10','09:20:00',1.65),('16100','2013-09-10','09:25:00',1.41),('16100','2013-09-10','09:30:00',1.29),('16100','2013-09-10','09:45:00',1.05),('16100','2013-09-10','09:50:00',1.55),('16100','2013-09-10','09:55:00',1.82),('16100','2013-09-10','10:00:00',1.9),('16100','2013-09-10','10:05:00',2.62),('16100','2013-09-10','10:10:00',5.27),('16100','2013-09-10','10:15:00',5.29),('16100','2013-09-10','10:20:00',5.36),('16100','2013-09-10','10:25:00',5.57),('16100','2013-09-10','10:30:00',6),('16100','2013-09-10','10:35:00',5.99),('16100','2013-09-10','10:40:00',3.59),('16100','2013-09-10','10:45:00',2.33),('16100','2013-09-10','10:50:00',3.18),('16100','2013-09-10','10:55:00',3.96),('16100','2013-09-10','11:00:00',5.31),('16100','2013-09-10','11:05:00',3.75),('16100','2013-09-10','11:10:00',6.24),('16100','2013-09-10','11:15:00',6.44),('16100','2013-09-10','11:20:00',3.29),('16100','2013-09-10','11:25:00',6),('16100','2013-09-10','11:30:00',4.2),('16100','2013-09-10','11:35:00',7.73),('16100','2013-09-10','11:40:00',5.57),('16100','2013-09-10','11:45:00',7.48),('16100','2013-09-10','11:50:00',7.39),('16100','2013-09-10','11:55:00',7.48),('16100','2013-09-10','12:00:00',7.74),('16100','2013-09-10','12:05:00',6.09),('16100','2013-09-10','12:10:00',5.33),('16100','2013-09-10','12:15:00',7.29),('16100','2013-09-10','12:20:00',4.02),('16100','2013-09-10','12:25:00',6.57),('16100','2013-09-10','12:30:00',7.12),('16100','2013-09-10','12:35:00',5.86),('16100','2013-09-10','12:40:00',6.73),('16100','2013-09-10','12:45:00',5.84),('16100','2013-09-10','12:50:00',8.18),('16100','2013-09-10','12:55:00',8.09),('16100','2013-09-10','13:00:00',6.79),('16100','2013-09-10','13:05:00',5.5),('16100','2013-09-10','13:10:00',3.15),('16100','2013-09-10','13:15:00',5.32),('16100','2013-09-10','13:20:00',7.18),('16100','2013-09-10','13:25:00',2.78),('16100','2013-09-10','13:30:00',7.63),('16100','2013-09-10','13:35:00',5.48),('16100','2013-09-10','13:40:00',3.56),('16100','2013-09-10','13:45:00',2.78),('16100','2013-09-10','13:50:00',3.27),('16100','2013-09-10','13:55:00',7.02),('16100','2013-09-10','14:00:00',4.87),('16100','2013-09-10','14:05:00',6.23),('16100','2013-09-10','14:10:00',7.74),('16100','2013-09-10','14:15:00',7.46),('16100','2013-09-10','14:20:00',7.36),('16100','2013-09-10','14:25:00',5.34),('16100','2013-09-10','14:30:00',6.73),('16100','2013-09-10','14:35:00',6.12),('16100','2013-09-10','14:40:00',7.87),('16100','2013-09-10','14:45:00',4.94),('16100','2013-09-10','14:50:00',5.22),('16100','2013-09-10','14:55:00',6.27),('16100','2013-09-10','15:00:00',6.33),('16100','2013-09-10','15:05:00',2.54),('16100','2013-09-10','15:10:00',4.54),('16100','2013-09-10','15:15:00',3.02),('16100','2013-09-10','15:20:00',2.13),('16100','2013-09-10','15:25:00',1.42),('16100','2013-09-10','15:30:00',2.08),('16100','2013-09-10','15:35:00',2.17),('16100','2013-09-10','15:40:00',2.34),('16100','2013-09-10','15:45:00',2.07),('16100','2013-09-10','15:50:00',2.56),('16100','2013-09-10','15:55:00',1.65),('16100','2013-09-10','16:00:00',2.85),('16100','2013-09-10','16:05:00',5.29),('16100','2013-09-10','16:10:00',4.55),('16100','2013-09-10','16:15:00',5.31),('16100','2013-09-10','16:20:00',4.61),('16100','2013-09-10','16:25:00',4.43),('16100','2013-09-10','16:30:00',1.72),('16100','2013-09-10','16:35:00',4.28),('16100','2013-09-10','16:40:00',3.57),('16100','2013-09-10','16:45:00',4.52),('16100','2013-09-10','16:50:00',4.23),('16100','2013-09-10','16:55:00',4.13),('16100','2013-09-10','17:00:00',3.16),('16100','2013-09-10','17:05:00',3.47),('16100','2013-09-10','17:10:00',3.43),('16100','2013-09-10','17:15:00',3.25),('16100','2013-09-10','17:20:00',3.05),('16100','2013-09-10','17:25:00',3.01),('16100','2013-09-10','17:30:00',2.78),('16100','2013-09-10','17:35:00',1.88),('16100','2013-09-10','17:40:00',2.42),('16100','2013-09-10','17:45:00',2.26),('16100','2013-09-10','17:50:00',1.99),('16100','2013-09-10','17:55:00',1.34),('16100','2013-09-10','18:00:00',1.71),('16100','2013-09-10','18:05:00',1.49),('16100','2013-09-10','18:10:00',1.34),('16100','2013-09-10','18:15:00',1.13),('16100','2013-09-09','08:10:00',1.12),('16100','2013-09-09','08:15:00',1.13),('16100','2013-09-09','08:20:00',1.04),('16100','2013-09-09','08:50:00',1.93),('16100','2013-09-09','08:55:00',2.81),('16100','2013-09-09','09:00:00',3.26),('16100','2013-09-09','09:05:00',4),('16100','2013-09-09','09:10:00',3.72),('16100','2013-09-09','09:15:00',2.05),('16100','2013-09-09','09:20:00',2.84),('16100','2013-09-09','09:25:00',3.28),('16100','2013-09-09','09:30:00',4.37),('16100','2013-09-09','09:35:00',2.52),('16100','2013-09-09','09:40:00',2.09),('16100','2013-09-09','09:45:00',1.95),('16100','2013-09-09','09:50:00',2.01),('16100','2013-09-09','09:55:00',1.62),('16100','2013-09-09','10:00:00',1.25),('16100','2013-09-09','10:05:00',1.06),('16100','2013-09-09','10:15:00',1.18),('16100','2013-09-09','10:20:00',1.55),('16100','2013-09-09','10:25:00',1.56),('16100','2013-09-09','10:30:00',1.42),('16100','2013-09-09','10:35:00',1.73),('16100','2013-09-09','10:40:00',2.32),('16100','2013-09-09','10:45:00',2.57),('16100','2013-09-09','10:50:00',2),('16100','2013-09-09','10:55:00',2.5),('16100','2013-09-09','11:00:00',4.15),('16100','2013-09-09','11:05:00',2.99),('16100','2013-09-09','11:10:00',1.9),('16100','2013-09-09','11:15:00',1.59),('16100','2013-09-09','11:20:00',2.49),('16100','2013-09-09','11:25:00',3.1),('16100','2013-09-09','11:30:00',1.58),('16100','2013-09-09','11:35:00',1.17),('16100','2013-09-09','11:40:00',1.79),('16100','2013-09-09','11:45:00',2.42),('16100','2013-09-09','11:50:00',1.92),('16100','2013-09-09','11:55:00',1.98),('16100','2013-09-09','12:00:00',1.64),('16100','2013-09-09','12:05:00',1.43),('16100','2013-09-09','12:10:00',1.58),('16100','2013-09-09','12:15:00',3.4),('16100','2013-09-09','12:20:00',2.39),('16100','2013-09-09','12:25:00',1.71),('16100','2013-09-09','12:30:00',1.2),('16100','2013-09-09','12:45:00',1.01),('16100','2013-09-09','12:50:00',1.2),('16100','2013-09-09','12:55:00',1.31),('16100','2013-09-09','13:00:00',1.35),('16100','2013-09-09','13:05:00',1.29),('16100','2013-09-09','13:10:00',1.2),('16100','2013-09-09','13:15:00',1.71),('16100','2013-09-09','13:20:00',1.59),('16100','2013-09-09','13:25:00',1.85),('16100','2013-09-09','13:30:00',1.6),('16100','2013-09-09','13:35:00',2.26),('16100','2013-09-09','13:40:00',3.21),('16100','2013-09-09','13:45:00',3.96),('16100','2013-09-09','13:50:00',3.9),('16100','2013-09-09','13:55:00',3.37),('16100','2013-09-09','14:00:00',2.65),('16100','2013-09-09','14:05:00',2.2),('16100','2013-09-09','14:10:00',2.41),('16100','2013-09-09','14:15:00',3.13),('16100','2013-09-09','14:20:00',3.49),('16100','2013-09-09','14:25:00',4.17),('16100','2013-09-09','14:30:00',3.69),('16100','2013-09-09','14:35:00',2.44),('16100','2013-09-09','14:40:00',2.74),('16100','2013-09-09','14:45:00',3.49),('16100','2013-09-09','14:50:00',4.16),('16100','2013-09-09','14:55:00',4.04),('16100','2013-09-09','15:00:00',4.67),('16100','2013-09-09','15:05:00',4.45),('16100','2013-09-09','15:10:00',4.28),('16100','2013-09-09','15:15:00',3.5),('16100','2013-09-09','15:20:00',2.28),('16100','2013-09-09','15:25:00',3.29),('16100','2013-09-09','15:30:00',2.86),('16100','2013-09-09','15:35:00',2.54),('16100','2013-09-09','15:40:00',2.21),('16100','2013-09-09','15:45:00',1.91),('16100','2013-09-09','15:50:00',1.83),('16100','2013-09-09','15:55:00',1.56),('16100','2013-09-09','16:00:00',1.47),('16100','2013-09-09','16:05:00',1.54),('16100','2013-09-09','16:10:00',1.43),('16100','2013-09-09','16:15:00',1.88),('16100','2013-09-09','16:20:00',1.34),('16100','2013-09-09','16:25:00',1.3),('16100','2013-09-09','16:30:00',1.07),('16100','2013-09-09','16:45:00',1.72),('16100','2013-09-09','16:50:00',1.51),('16100','2013-09-09','16:55:00',1.47),('16100','2013-09-09','17:00:00',1.13),('16100','2013-09-09','17:15:00',1.17),('16100','2013-09-09','17:20:00',1.09),('16100','2013-09-09','17:25:00',1.03),('16100','2013-09-09','17:45:00',1.09),('16100','2013-09-09','17:50:00',1.11),('16100','2013-09-08','07:40:00',1.16),('16100','2013-09-08','07:45:00',1.06),('16100','2013-09-08','07:50:00',1.15),('16100','2013-09-08','07:55:00',1.03),('16100','2013-09-08','08:40:00',1.09),('16100','2013-09-08','08:45:00',1.33),('16100','2013-09-08','08:50:00',1.68),('16100','2013-09-08','08:55:00',1.88),('16100','2013-09-08','09:00:00',1.94),('16100','2013-09-08','09:05:00',1.63),('16100','2013-09-08','09:10:00',1.53),('16100','2013-09-08','09:15:00',1.62),('16100','2013-09-08','09:20:00',1.37),('16100','2013-09-08','09:35:00',1.07),('16100','2013-09-08','09:40:00',1.82),('16100','2013-09-08','09:45:00',2.04),('16100','2013-09-08','09:50:00',2.02),('16100','2013-09-08','09:55:00',2.09),('16100','2013-09-08','10:00:00',2.2),('16100','2013-09-08','10:05:00',2.32),('16100','2013-09-08','10:10:00',2.17),('16100','2013-09-08','10:15:00',2.4),('16100','2013-09-08','10:20:00',2.26),('16100','2013-09-08','10:25:00',2.19),('16100','2013-09-08','10:30:00',2.4),('16100','2013-09-08','10:35:00',3.04),('16100','2013-09-08','10:40:00',3.37),('16100','2013-09-08','10:45:00',4.21),('16100','2013-09-08','10:50:00',4.94),('16100','2013-09-08','10:55:00',4.75),('16100','2013-09-08','11:00:00',4.53),('16100','2013-09-08','11:05:00',3.45),('16100','2013-09-08','11:10:00',2.65),('16100','2013-09-08','11:15:00',2.52),('16100','2013-09-08','11:20:00',3.23),('16100','2013-09-08','11:25:00',3.98),('16100','2013-09-08','11:30:00',2.43),('16100','2013-09-08','11:35:00',2.52),('16100','2013-09-08','11:40:00',4.35),('16100','2013-09-08','11:45:00',3.36),('16100','2013-09-08','11:50:00',4.17),('16100','2013-09-08','11:55:00',3.51),('16100','2013-09-08','12:00:00',2.63),('16100','2013-09-08','12:05:00',3.2),('16100','2013-09-08','12:10:00',2),('16100','2013-09-08','12:15:00',2.22),('16100','2013-09-08','12:20:00',1.83),('16100','2013-09-08','12:25:00',1.87),('16100','2013-09-08','12:30:00',1.87),('16100','2013-09-08','12:35:00',1.75),('16100','2013-09-08','12:40:00',2.04),('16100','2013-09-08','12:45:00',1.89),('16100','2013-09-08','12:50:00',2.1),('16100','2013-09-08','12:55:00',2.13),('16100','2013-09-08','13:00:00',2.83),('16100','2013-09-08','13:05:00',4.02),('16100','2013-09-08','13:10:00',6.55),('16100','2013-09-08','13:15:00',6.18),('16100','2013-09-08','13:20:00',5.37),('16100','2013-09-08','13:25:00',4.06),('16100','2013-09-08','13:30:00',6.83),('16100','2013-09-08','13:35:00',7.05),('16100','2013-09-08','13:40:00',6.77),('16100','2013-09-08','13:45:00',7.05),('16100','2013-09-08','13:50:00',7.61),('16100','2013-09-08','13:55:00',5.72),('16100','2013-09-08','14:00:00',7.04),('16100','2013-09-08','14:05:00',4.22),('16100','2013-09-08','14:10:00',5.38),('16100','2013-09-08','14:15:00',5.12),('16100','2013-09-08','14:20:00',6.67),('16100','2013-09-08','14:25:00',3.25),('16100','2013-09-08','14:30:00',4.29),('16100','2013-09-08','14:35:00',5.12),('16100','2013-09-08','14:40:00',5.1),('16100','2013-09-08','14:45:00',5.09),('16100','2013-09-08','14:50:00',4.85),('16100','2013-09-08','14:55:00',4.17),('16100','2013-09-08','15:00:00',4.39),('16100','2013-09-08','15:05:00',6),('16100','2013-09-08','15:10:00',4.86),('16100','2013-09-08','15:15:00',3.86),('16100','2013-09-08','15:20:00',6.33),('16100','2013-09-08','15:25:00',4.93),('16100','2013-09-08','15:30:00',4.58),('16100','2013-09-08','15:35:00',5.64),('16100','2013-09-08','15:40:00',4.31),('16100','2013-09-08','15:45:00',3.43),('16100','2013-09-08','15:50:00',2.18),('16100','2013-09-08','15:55:00',2.62),('16100','2013-09-08','16:00:00',2.16),('16100','2013-09-08','16:05:00',2.32),('16100','2013-09-08','16:10:00',2.82),('16100','2013-09-08','16:15:00',2.24),('16100','2013-09-08','16:20:00',2.12),('16100','2013-09-08','16:25:00',1.74),('16100','2013-09-08','16:30:00',1.66),('16100','2013-09-08','16:35:00',1.69),('16100','2013-09-08','16:40:00',2.15),('16100','2013-09-08','16:45:00',1.95),('16100','2013-09-08','16:50:00',1.64),('16100','2013-09-08','16:55:00',1.14),('16100','2013-09-08','17:00:00',1.25),('16100','2013-09-08','17:05:00',1.06),('16100','2013-09-08','17:10:00',1.14),('16100','2013-09-08','18:05:00',1.38),('16100','2013-09-08','18:10:00',1.7),('16100','2013-09-08','18:15:00',1.06),('16100','2013-09-08','18:25:00',1.15),('16100','2014-04-11','08:30:00',1.01),('16100','2014-04-11','08:35:00',1.29),('16100','2014-04-11','08:40:00',1.89),('16100','2014-04-11','08:45:00',1.66),('16100','2014-04-11','08:50:00',1.09),('16100','2014-04-11','08:55:00',1.03),('16100','2014-04-11','09:00:00',1.23),('16100','2014-04-11','09:05:00',2.07),('16100','2014-04-11','09:10:00',3.33),('16100','2014-04-11','09:15:00',2.68),('16100','2014-04-11','09:20:00',2.46),('16100','2014-04-11','09:25:00',2.77),('16100','2014-04-11','09:30:00',3.47),('16100','2014-04-11','09:35:00',2.84),('16100','2014-04-11','09:40:00',2.61),('16100','2014-04-11','09:45:00',2.59),('16100','2014-04-11','09:50:00',2.79),('16100','2014-04-11','09:55:00',2.76),('16100','2014-04-11','10:00:00',2.86),('16100','2014-04-11','10:05:00',3.08),('16100','2014-04-11','10:10:00',3.13),('16100','2014-04-11','10:15:00',3.15),('16100','2014-04-11','10:20:00',3.21),('16100','2014-04-11','10:25:00',3.84),('16100','2014-04-11','10:30:00',3.95),('16100','2014-04-11','10:35:00',3.17),('16100','2014-04-11','10:40:00',2.84),('16100','2014-04-11','10:45:00',3.31),('16100','2014-04-11','10:50:00',3.52),('16100','2014-04-11','10:55:00',6.35),('16100','2014-04-11','11:00:00',4.95),('16100','2014-04-11','11:05:00',5.86),('16100','2014-04-11','11:10:00',5.07),('16100','2014-04-11','11:15:00',4.7),('16100','2014-04-11','11:20:00',5.83),('16100','2014-04-11','11:25:00',5.31),('16100','2014-04-11','11:30:00',6.36),('16100','2014-04-11','11:35:00',5.74),('16100','2014-04-11','11:40:00',6.76),('16100','2014-04-11','11:45:00',7.04),('16100','2014-04-11','11:50:00',6.69),('16100','2014-04-11','11:55:00',6.98),('16100','2014-04-11','12:00:00',3.88),('16100','2014-04-11','12:05:00',2.46),('16100','2014-04-11','12:10:00',2.64),('16100','2014-04-11','12:15:00',5.11),('16100','2014-04-11','12:20:00',5.69),('16100','2014-04-11','12:25:00',3.12),('16100','2014-04-11','12:30:00',2.04),('16100','2014-04-11','12:35:00',1.99),('16100','2014-04-11','12:40:00',2.22),('16100','2014-04-11','12:45:00',2.38),('16100','2014-04-11','12:50:00',2.41),('16100','2014-04-11','12:55:00',2.46),('16100','2014-04-11','13:00:00',3.78),('16100','2014-04-11','13:05:00',4.28),('16100','2014-04-11','13:10:00',6.74),('16100','2014-04-11','13:15:00',6.68),('16100','2014-04-11','13:20:00',3.62),('16100','2014-04-11','13:25:00',3.08),('16100','2014-04-11','13:30:00',7.58),('16100','2014-04-11','13:35:00',4.86),('16100','2014-04-11','13:40:00',6.83),('16100','2014-04-11','13:45:00',6.5),('16100','2014-04-11','13:50:00',7.94),('16100','2014-04-11','13:55:00',6.84),('16100','2014-04-11','14:00:00',7.56),('16100','2014-04-11','14:05:00',7.48),('16100','2014-04-11','14:10:00',7.61),('16100','2014-04-11','14:15:00',3.93),('16100','2014-04-11','14:20:00',3.57),('16100','2014-04-11','14:25:00',6.05),('16100','2014-04-11','14:30:00',3.24),('16100','2014-04-11','14:35:00',4.09),('16100','2014-04-11','14:40:00',5.47),('16100','2014-04-11','14:45:00',6.42),('16100','2014-04-11','14:50:00',5.98),('16100','2014-04-11','14:55:00',6.74),('16100','2014-04-11','15:00:00',6.23),('16100','2014-04-11','15:05:00',6.28),('16100','2014-04-11','15:10:00',5.77),('16100','2014-04-11','15:15:00',5.69),('16100','2014-04-11','15:20:00',5.01),('16100','2014-04-11','15:25:00',4.88),('16100','2014-04-11','15:30:00',5.32),('16100','2014-04-11','15:35:00',5.56),('16100','2014-04-11','15:40:00',5.82),('16100','2014-04-11','15:45:00',6.11),('16100','2014-04-11','15:50:00',5.6),('16100','2014-04-11','15:55:00',5.89),('16100','2014-04-11','16:00:00',5.95),('16100','2014-04-11','16:05:00',5.83),('16100','2014-04-11','16:10:00',5.33),('16100','2014-04-11','16:15:00',4.63),('16100','2014-04-11','16:20:00',5.13),('16100','2014-04-11','16:25:00',4.39),('16100','2014-04-11','16:30:00',4.15),('16100','2014-04-11','16:35:00',3.05),('16100','2014-04-11','16:40:00',2.49),('16100','2014-04-11','16:45:00',2.33),('16100','2014-04-11','16:50:00',2.62),('16100','2014-04-11','16:55:00',3.75),('16100','2014-04-11','17:00:00',4.09),('16100','2014-04-11','17:05:00',3.88),('16100','2014-04-11','17:10:00',3.56),('16100','2014-04-11','17:15:00',2.98),('16100','2014-04-11','17:20:00',3.34),('16100','2014-04-11','17:25:00',3.34),('16100','2014-04-11','17:30:00',3.22),('16100','2014-04-11','17:35:00',2.38),('16100','2014-04-11','17:40:00',2.72),('16100','2014-04-11','17:45:00',3.22),('16100','2014-04-11','17:50:00',2.22),('16100','2014-04-11','17:55:00',1.45),('16100','2014-04-11','18:00:00',1.26),('16100','2014-04-11','18:05:00',1.09),('16100','2014-04-11','18:10:00',1.11),('16100','2014-04-11','18:15:00',1.04),('16100','2014-04-11','18:25:00',1.07),('16100','2014-04-11','18:30:00',1.1),('16100','2013-09-07','08:35:00',1.04),('16100','2013-09-07','08:40:00',1.04),('16100','2013-09-07','08:45:00',1.08),('16100','2013-09-07','08:50:00',1.25),('16100','2013-09-07','08:55:00',1.38),('16100','2013-09-07','09:00:00',1.64),('16100','2013-09-07','09:05:00',1.58),('16100','2013-09-07','09:10:00',2.39),('16100','2013-09-07','09:15:00',3.1),('16100','2013-09-07','09:20:00',3.34),('16100','2013-09-07','09:25:00',3.46),('16100','2013-09-07','09:30:00',3.61),('16100','2013-09-07','09:35:00',3.75),('16100','2013-09-07','09:40:00',3.92),('16100','2013-09-07','09:45:00',4.06),('16100','2013-09-07','09:50:00',4.2),('16100','2013-09-07','09:55:00',4.33),('16100','2013-09-07','10:00:00',4.42),('16100','2013-09-07','10:05:00',4.52),('16100','2013-09-07','10:10:00',4.61),('16100','2013-09-07','10:15:00',4.78),('16100','2013-09-07','10:20:00',4.94),('16100','2013-09-07','10:25:00',5.01),('16100','2013-09-07','10:30:00',5.16),('16100','2013-09-07','10:35:00',5.39),('16100','2013-09-07','10:40:00',5.49),('16100','2013-09-07','10:45:00',5.54),('16100','2013-09-07','10:50:00',5.62),('16100','2013-09-07','10:55:00',5.55),('16100','2013-09-07','11:00:00',5.63),('16100','2013-09-07','11:05:00',5.76),('16100','2013-09-07','11:10:00',5.86),('16100','2013-09-07','11:15:00',5.91),('16100','2013-09-07','11:20:00',5.78),('16100','2013-09-07','11:25:00',5.97),('16100','2013-09-07','11:30:00',6.13),('16100','2013-09-07','11:35:00',6.17),('16100','2013-09-07','11:40:00',6.25),('16100','2013-09-07','11:45:00',6.18),('16100','2013-09-07','11:50:00',6.16),('16100','2013-09-07','11:55:00',6.11),('16100','2013-09-07','12:00:00',6.12),('16100','2013-09-07','12:05:00',6.12),('16100','2013-09-07','12:10:00',6.27),('16100','2013-09-07','12:15:00',6.56),('16100','2013-09-07','12:20:00',6.51),('16100','2013-09-07','12:25:00',6.56),('16100','2013-09-07','12:30:00',6.8),('16100','2013-09-07','12:35:00',6.79),('16100','2013-09-07','12:40:00',6.66),('16100','2013-09-07','12:45:00',6.81),('16100','2013-09-07','12:50:00',6.78),('16100','2013-09-07','12:55:00',6.69),('16100','2013-09-07','13:00:00',6.53),('16100','2013-09-07','13:05:00',6.83),('16100','2013-09-07','13:10:00',6.49),('16100','2013-09-07','13:15:00',6.36),('16100','2013-09-07','13:20:00',6.53),('16100','2013-09-07','13:25:00',5.85),('16100','2013-09-07','13:30:00',6.05),('16100','2013-09-07','13:35:00',5.32),('16100','2013-09-07','13:40:00',3.87),('16100','2013-09-07','13:45:00',4.31),('16100','2013-09-07','13:50:00',4.97),('16100','2013-09-07','13:55:00',6.73),('16100','2013-09-07','14:00:00',5.62),('16100','2013-09-07','14:05:00',5.43),('16100','2013-09-07','14:10:00',5.41),('16100','2013-09-07','14:15:00',5.25),('16100','2013-09-07','14:20:00',6.18),('16100','2013-09-07','14:25:00',5.87),('16100','2013-09-07','14:30:00',6.81),('16100','2013-09-07','14:35:00',6.69),('16100','2013-09-07','14:40:00',6.59),('16100','2013-09-07','14:45:00',6.91),('16100','2013-09-07','14:50:00',6.11),('16100','2013-09-07','14:55:00',6.4),('16100','2013-09-07','15:00:00',6.41),('16100','2013-09-07','15:05:00',3.96),('16100','2013-09-07','15:10:00',4.23),('16100','2013-09-07','15:15:00',5.69),('16100','2013-09-07','15:20:00',6.33),('16100','2013-09-07','15:25:00',6.23),('16100','2013-09-07','15:30:00',5.98),('16100','2013-09-07','15:35:00',5.35),('16100','2013-09-07','15:40:00',5.58),('16100','2013-09-07','15:45:00',5.69),('16100','2013-09-07','15:50:00',4.66),('16100','2013-09-07','15:55:00',4.53),('16100','2013-09-07','16:00:00',4.41),('16100','2013-09-07','16:05:00',4),('16100','2013-09-07','16:10:00',4.47),('16100','2013-09-07','16:15:00',4.43),('16100','2013-09-07','16:20:00',4.44),('16100','2013-09-07','16:25:00',3.46),('16100','2013-09-07','16:30:00',4.21),('16100','2013-09-07','16:35:00',3.48),('16100','2013-09-07','16:40:00',2.81),('16100','2013-09-07','16:45:00',2.75),('16100','2013-09-07','16:50:00',1.53),('16100','2013-09-07','16:55:00',2.15),('16100','2013-09-07','17:00:00',3.69),('16100','2013-09-07','17:05:00',3.63),('16100','2013-09-07','17:10:00',3.29),('16100','2013-09-07','17:15:00',3.03),('16100','2013-09-07','17:20:00',2.73),('16100','2013-09-07','17:25:00',2.59),('16100','2013-09-07','17:30:00',1.2),('16100','2013-09-07','17:35:00',1.43),('16100','2013-09-07','17:40:00',1.93),('16100','2013-09-07','17:45:00',1.9),('16100','2013-09-07','17:50:00',1.75),('16100','2013-09-07','17:55:00',1.62),('16100','2013-09-07','18:00:00',1.38),('16100','2013-09-07','18:05:00',1.18),('16100','2013-09-07','18:10:00',1.03),('16100','2013-09-06','08:05:00',1.03),('16100','2013-09-06','08:10:00',1.19),('16100','2013-09-06','08:15:00',1.36),('16100','2013-09-06','08:20:00',1.53),('16100','2013-09-06','08:25:00',1.68),('16100','2013-09-06','08:30:00',1.85),('16100','2013-09-06','08:35:00',2),('16100','2013-09-06','08:40:00',2.18),('16100','2013-09-06','08:45:00',2.36),('16100','2013-09-06','08:50:00',2.52),('16100','2013-09-06','08:55:00',2.71),('16100','2013-09-06','09:00:00',2.88),('16100','2013-09-06','09:05:00',3.03),('16100','2013-09-06','09:10:00',3.2),('16100','2013-09-06','09:15:00',3.36),('16100','2013-09-06','09:20:00',3.51),('16100','2013-09-06','09:25:00',3.62),('16100','2013-09-06','09:30:00',3.76),('16100','2013-09-06','09:35:00',3.92),('16100','2013-09-06','09:40:00',4.05),('16100','2013-09-06','09:45:00',4.22),('16100','2013-09-06','09:50:00',4.33),('16100','2013-09-06','09:55:00',4.46),('16100','2013-09-06','10:00:00',4.56),('16100','2013-09-06','10:05:00',4.69),('16100','2013-09-06','10:10:00',4.77),('16100','2013-09-06','10:15:00',4.88),('16100','2013-09-06','10:20:00',5.02),('16100','2013-09-06','10:25:00',5.18),('16100','2013-09-06','10:30:00',5.3),('16100','2013-09-06','10:35:00',5.39),('16100','2013-09-06','10:40:00',5.46),('16100','2013-09-06','10:45:00',5.55),('16100','2013-09-06','10:50:00',5.63),('16100','2013-09-06','10:55:00',5.74),('16100','2013-09-06','11:00:00',5.78),('16100','2013-09-06','11:05:00',5.82),('16100','2013-09-06','11:10:00',5.93),('16100','2013-09-06','11:15:00',6.05),('16100','2013-09-06','11:20:00',6.06),('16100','2013-09-06','11:25:00',6.12),('16100','2013-09-06','11:30:00',6.23),('16100','2013-09-06','11:35:00',6.33),('16100','2013-09-06','11:40:00',6.42),('16100','2013-09-06','11:45:00',6.51),('16100','2013-09-06','11:50:00',6.51),('16100','2013-09-06','11:55:00',6.52),('16100','2013-09-06','12:00:00',6.67),('16100','2013-09-06','12:05:00',6.76),('16100','2013-09-06','12:10:00',6.86),('16100','2013-09-06','12:15:00',6.9),('16100','2013-09-06','12:20:00',6.84),('16100','2013-09-06','12:25:00',6.85),('16100','2013-09-06','12:30:00',6.83),('16100','2013-09-06','12:35:00',6.83),('16100','2013-09-06','12:40:00',6.59),('16100','2013-09-06','12:45:00',6.36),('16100','2013-09-06','12:50:00',6.99),('16100','2013-09-06','12:55:00',6.98),('16100','2013-09-06','13:00:00',6.94),('16100','2013-09-06','13:05:00',7.04),('16100','2013-09-06','13:10:00',6.96),('16100','2013-09-06','13:15:00',6.96),('16100','2013-09-06','13:20:00',6.99),('16100','2013-09-06','13:25:00',6.8),('16100','2013-09-06','13:30:00',6.81),('16100','2013-09-06','13:35:00',6.98),('16100','2013-09-06','13:40:00',6.94),('16100','2013-09-06','13:45:00',7),('16100','2013-09-06','13:50:00',7.02),('16100','2013-09-06','13:55:00',6.98),('16100','2013-09-06','14:00:00',6.94),('16100','2013-09-06','14:05:00',6.86),('16100','2013-09-06','14:10:00',6.84),('16100','2013-09-06','14:15:00',6.86),('16100','2013-09-06','14:20:00',6.83),('16100','2013-09-06','14:25:00',6.7),('16100','2013-09-06','14:30:00',6.69),('16100','2013-09-06','14:35:00',6.67),('16100','2013-09-06','14:40:00',6.65),('16100','2013-09-06','14:45:00',6.53),('16100','2013-09-06','14:50:00',6.47),('16100','2013-09-06','14:55:00',6.49),('16100','2013-09-06','15:00:00',6.39),('16100','2013-09-06','15:05:00',6.3),('16100','2013-09-06','15:10:00',6.23),('16100','2013-09-06','15:15:00',6.13),('16100','2013-09-06','15:20:00',6.03),('16100','2013-09-06','15:25:00',5.93),('16100','2013-09-06','15:30:00',5.81),('16100','2013-09-06','15:35:00',5.74),('16100','2013-09-06','15:40:00',5.65),('16100','2013-09-06','15:45:00',5.56),('16100','2013-09-06','15:50:00',5.45),('16100','2013-09-06','15:55:00',5.34),('16100','2013-09-06','16:00:00',5.22),('16100','2013-09-06','16:05:00',5.07),('16100','2013-09-06','16:10:00',4.94),('16100','2013-09-06','16:15:00',4.75),('16100','2013-09-06','16:20:00',4.62),('16100','2013-09-06','16:25:00',4.54),('16100','2013-09-06','16:30:00',4.4),('16100','2013-09-06','16:35:00',4.26),('16100','2013-09-06','16:40:00',4.13),('16100','2013-09-06','16:45:00',3.97),('16100','2013-09-06','16:50:00',3.83),('16100','2013-09-06','16:55:00',3.68),('16100','2013-09-06','17:00:00',3.52),('16100','2013-09-06','17:05:00',3.41),('16100','2013-09-06','17:10:00',3.22),('16100','2013-09-06','17:15:00',3.03),('16100','2013-09-06','17:20:00',2.86),('16100','2013-09-06','17:25:00',2.65),('16100','2013-09-06','17:30:00',2.5),('16100','2013-09-06','17:35:00',2.37),('16100','2013-09-06','17:40:00',2.22),('16100','2013-09-06','17:45:00',2.07),('16100','2013-09-06','17:50:00',1.9),('16100','2013-09-06','17:55:00',1.75),('16100','2013-09-06','18:00:00',1.57),('16100','2013-09-06','18:05:00',1.41),('16100','2013-09-06','18:10:00',1.26),('16100','2013-09-06','18:15:00',1.11),('16100','2013-09-05','08:05:00',1.04),('16100','2013-09-05','08:10:00',1.2),('16100','2013-09-05','08:15:00',1.36),('16100','2013-09-05','08:20:00',1.54),('16100','2013-09-05','08:25:00',1.71),('16100','2013-09-05','08:30:00',1.9),('16100','2013-09-05','08:35:00',2.06),('16100','2013-09-05','08:40:00',2.24),('16100','2013-09-05','08:45:00',2.4),('16100','2013-09-05','08:50:00',2.57),('16100','2013-09-05','08:55:00',2.76),('16100','2013-09-05','09:00:00',2.89),('16100','2013-09-05','09:05:00',3.09),('16100','2013-09-05','09:10:00',3.25),('16100','2013-09-05','09:15:00',3.46),('16100','2013-09-05','09:20:00',3.6),('16100','2013-09-05','09:25:00',3.72),('16100','2013-09-05','09:30:00',3.85),('16100','2013-09-05','09:35:00',3.98),('16100','2013-09-05','09:40:00',4.14),('16100','2013-09-05','09:45:00',4.32),('16100','2013-09-05','09:50:00',4.43),('16100','2013-09-05','09:55:00',4.51),('16100','2013-09-05','10:00:00',4.66),('16100','2013-09-05','10:05:00',4.81),('16100','2013-09-05','10:10:00',4.92),('16100','2013-09-05','10:15:00',4.99),('16100','2013-09-05','10:20:00',5.14),('16100','2013-09-05','10:25:00',5.27),('16100','2013-09-05','10:30:00',5.43),('16100','2013-09-05','10:35:00',5.54),('16100','2013-09-05','10:40:00',5.63),('16100','2013-09-05','10:45:00',5.74),('16100','2013-09-05','10:50:00',5.85),('16100','2013-09-05','10:55:00',5.94),('16100','2013-09-05','11:00:00',6),('16100','2013-09-05','11:05:00',6.07),('16100','2013-09-05','11:10:00',6.08),('16100','2013-09-05','11:15:00',6.23),('16100','2013-09-05','11:20:00',6.3),('16100','2013-09-05','11:25:00',6.38),('16100','2013-09-05','11:30:00',6.44),('16100','2013-09-05','11:35:00',6.5),('16100','2013-09-05','11:40:00',6.59),('16100','2013-09-05','11:45:00',6.68),('16100','2013-09-05','11:50:00',6.7),('16100','2013-09-05','11:55:00',6.74),('16100','2013-09-05','12:00:00',6.76),('16100','2013-09-05','12:05:00',6.77),('16100','2013-09-05','12:10:00',6.73),('16100','2013-09-05','12:15:00',6.8),('16100','2013-09-05','12:20:00',6.89),('16100','2013-09-05','12:25:00',6.92),('16100','2013-09-05','12:30:00',6.99),('16100','2013-09-05','12:35:00',6.99),('16100','2013-09-05','12:40:00',7.04),('16100','2013-09-05','12:45:00',7.04),('16100','2013-09-05','12:50:00',7.06),('16100','2013-09-05','12:55:00',7.07),('16100','2013-09-05','13:00:00',7.03),('16100','2013-09-05','13:05:00',7.05),('16100','2013-09-05','13:10:00',7.03),('16100','2013-09-05','13:15:00',6.97),('16100','2013-09-05','13:20:00',6.97),('16100','2013-09-05','13:25:00',6.99),('16100','2013-09-05','13:30:00',6.99),('16100','2013-09-05','13:35:00',6.96),('16100','2013-09-05','13:40:00',6.89),('16100','2013-09-05','13:45:00',6.86),('16100','2013-09-05','13:50:00',6.87),('16100','2013-09-05','13:55:00',6.86),('16100','2013-09-05','14:00:00',6.78),('16100','2013-09-05','14:05:00',6.75),('16100','2013-09-05','14:10:00',6.62),('16100','2013-09-05','14:15:00',6.62),('16100','2013-09-05','14:20:00',6.56),('16100','2013-09-05','14:25:00',6.44),('16100','2013-09-05','14:30:00',6.4),('16100','2013-09-05','14:35:00',6.35),('16100','2013-09-05','14:40:00',6.49),('16100','2013-09-05','14:45:00',6.4),('16100','2013-09-05','14:50:00',6.22),('16100','2013-09-05','14:55:00',6.24),('16100','2013-09-05','15:00:00',6.27),('16100','2013-09-05','15:05:00',6.17),('16100','2013-09-05','15:10:00',6.11),('16100','2013-09-05','15:15:00',6.01),('16100','2013-09-05','15:20:00',5.91),('16100','2013-09-05','15:25:00',5.84),('16100','2013-09-05','15:30:00',5.72),('16100','2013-09-05','15:35:00',5.6),('16100','2013-09-05','15:40:00',5.58),('16100','2013-09-05','15:45:00',5.49),('16100','2013-09-05','15:50:00',5.4),('16100','2013-09-05','15:55:00',5.34),('16100','2013-09-05','16:00:00',5.24),('16100','2013-09-05','16:05:00',5.12),('16100','2013-09-05','16:10:00',5),('16100','2013-09-05','16:15:00',4.85),('16100','2013-09-05','16:20:00',4.71),('16100','2013-09-05','16:25:00',4.64),('16100','2013-09-05','16:30:00',4.49),('16100','2013-09-05','16:35:00',4.33),('16100','2013-09-05','16:40:00',4.22),('16100','2013-09-05','16:45:00',4.06),('16100','2013-09-05','16:50:00',3.8),('16100','2013-09-05','16:55:00',3.64),('16100','2013-09-05','17:00:00',3.54),('16100','2013-09-05','17:05:00',3.36),('16100','2013-09-05','17:10:00',3.18),('16100','2013-09-05','17:15:00',2.99),('16100','2013-09-05','17:20:00',2.84),('16100','2013-09-05','17:25:00',2.67),('16100','2013-09-05','17:30:00',2.56),('16100','2013-09-05','17:35:00',2.4),('16100','2013-09-05','17:40:00',2.17),('16100','2013-09-05','17:45:00',2.02),('16100','2013-09-05','17:50:00',1.88),('16100','2013-09-05','17:55:00',1.7),('16100','2013-09-05','18:00:00',1.5),('16100','2013-09-05','18:05:00',1.36),('16100','2013-09-05','18:10:00',1.23),('16100','2013-09-05','18:15:00',1.11),('16100','2013-09-04','08:05:00',1.17),('16100','2013-09-04','08:10:00',1.34),('16100','2013-09-04','08:15:00',1.53),('16100','2013-09-04','08:20:00',1.71),('16100','2013-09-04','08:25:00',1.9),('16100','2013-09-04','08:30:00',2.08),('16100','2013-09-04','08:35:00',2.26),('16100','2013-09-04','08:40:00',2.46),('16100','2013-09-04','08:45:00',2.63),('16100','2013-09-04','08:50:00',2.8),('16100','2013-09-04','08:55:00',3),('16100','2013-09-04','09:00:00',3.14),('16100','2013-09-04','09:05:00',3.29),('16100','2013-09-04','09:10:00',3.46),('16100','2013-09-04','09:15:00',3.65),('16100','2013-09-04','09:20:00',3.8),('16100','2013-09-04','09:25:00',3.94),('16100','2013-09-04','09:30:00',4.09),('16100','2013-09-04','09:35:00',4.22),('16100','2013-09-04','09:40:00',4.33),('16100','2013-09-04','09:45:00',4.49),('16100','2013-09-04','09:50:00',4.61),('16100','2013-09-04','09:55:00',4.76),('16100','2013-09-04','10:00:00',4.9),('16100','2013-09-04','10:05:00',5.02),('16100','2013-09-04','10:10:00',5.11),('16100','2013-09-04','10:15:00',5.19),('16100','2013-09-04','10:20:00',5.34),('16100','2013-09-04','10:25:00',5.45),('16100','2013-09-04','10:30:00',5.58),('16100','2013-09-04','10:35:00',5.64),('16100','2013-09-04','10:40:00',5.72),('16100','2013-09-04','10:45:00',5.86),('16100','2013-09-04','10:50:00',5.94),('16100','2013-09-04','10:55:00',6.02),('16100','2013-09-04','11:00:00',6.08),('16100','2013-09-04','11:05:00',6.16),('16100','2013-09-04','11:10:00',6.22),('16100','2013-09-04','11:15:00',6.34),('16100','2013-09-04','11:20:00',6.44),('16100','2013-09-04','11:25:00',6.49),('16100','2013-09-04','11:30:00',6.57),('16100','2013-09-04','11:35:00',6.59),('16100','2013-09-04','11:40:00',6.6),('16100','2013-09-04','11:45:00',6.64),('16100','2013-09-04','11:50:00',6.77),('16100','2013-09-04','11:55:00',6.76),('16100','2013-09-04','12:00:00',6.83),('16100','2013-09-04','12:05:00',6.89),('16100','2013-09-04','12:10:00',6.98),('16100','2013-09-04','12:15:00',7),('16100','2013-09-04','12:20:00',7.01),('16100','2013-09-04','12:25:00',7.08),('16100','2013-09-04','12:30:00',7.14),('16100','2013-09-04','12:35:00',7.12),('16100','2013-09-04','12:40:00',7.17),('16100','2013-09-04','12:45:00',7.2),('16100','2013-09-04','12:50:00',7.16),('16100','2013-09-04','12:55:00',7.13),('16100','2013-09-04','13:00:00',7.08),('16100','2013-09-04','13:05:00',7.16),('16100','2013-09-04','13:10:00',7.21),('16100','2013-09-04','13:15:00',7.2),('16100','2013-09-04','13:20:00',7.17),('16100','2013-09-04','13:25:00',7.17),('16100','2013-09-04','13:30:00',7.09),('16100','2013-09-04','13:35:00',7.08),('16100','2013-09-04','13:40:00',7.15),('16100','2013-09-04','13:45:00',7.13),('16100','2013-09-04','13:50:00',7.09),('16100','2013-09-04','13:55:00',7.04),('16100','2013-09-04','14:00:00',6.96),('16100','2013-09-04','14:05:00',6.87),('16100','2013-09-04','14:10:00',6.8),('16100','2013-09-04','14:15:00',6.84),('16100','2013-09-04','14:20:00',6.81),('16100','2013-09-04','14:25:00',6.74),('16100','2013-09-04','14:30:00',6.69),('16100','2013-09-04','14:35:00',6.68),('16100','2013-09-04','14:40:00',6.67),('16100','2013-09-04','14:45:00',6.65),('16100','2013-09-04','14:50:00',6.61),('16100','2013-09-04','14:55:00',6.56),('16100','2013-09-04','15:00:00',6.49),('16100','2013-09-04','15:05:00',6.4),('16100','2013-09-04','15:10:00',6.33),('16100','2013-09-04','15:15:00',6.23),('16100','2013-09-04','15:20:00',6.03),('16100','2013-09-04','15:25:00',6.02),('16100','2013-09-04','15:30:00',5.92),('16100','2013-09-04','15:35:00',5.84),('16100','2013-09-04','15:40:00',5.74),('16100','2013-09-04','15:45:00',5.62),('16100','2013-09-04','15:50:00',5.53),('16100','2013-09-04','15:55:00',5.46),('16100','2013-09-04','16:00:00',5.36),('16100','2013-09-04','16:05:00',5.26),('16100','2013-09-04','16:10:00',5.09),('16100','2013-09-04','16:15:00',5.03),('16100','2013-09-04','16:20:00',4.91),('16100','2013-09-04','16:25:00',4.8),('16100','2013-09-04','16:30:00',4.71),('16100','2013-09-04','16:35:00',4.6),('16100','2013-09-04','16:40:00',4.51),('16100','2013-09-04','16:45:00',4.44),('16100','2013-09-04','16:50:00',4.27),('16100','2013-09-04','16:55:00',3.78),('16100','2013-09-04','17:00:00',2.69),('16100','2013-09-04','17:05:00',2.37),('16100','2013-09-04','17:10:00',2.45),('16100','2013-09-04','17:15:00',2.35),('16100','2013-09-04','17:20:00',2.24),('16100','2013-09-04','17:25:00',2.53),('16100','2013-09-04','17:30:00',2.25),('16100','2013-09-04','17:35:00',2.53),('16100','2013-09-04','17:40:00',2.68),('16100','2013-09-04','17:45:00',2.65),('16100','2013-09-04','17:50:00',2.28),('16100','2013-09-04','17:55:00',2.24),('16100','2013-09-04','18:00:00',1.72),('16100','2013-09-04','18:05:00',1.55),('16100','2013-09-04','18:10:00',1.36),('16100','2013-09-04','18:15:00',1.28),('16100','2013-09-04','18:20:00',1.11),('16100','2013-09-04','18:25:00',1.01),('16100','2013-09-03','08:05:00',1.17),('16100','2013-09-03','08:10:00',1.36),('16100','2013-09-03','08:15:00',1.54),('16100','2013-09-03','08:20:00',1.72),('16100','2013-09-03','08:25:00',1.91),('16100','2013-09-03','08:30:00',2.08),('16100','2013-09-03','08:35:00',2.26),('16100','2013-09-03','08:40:00',2.46),('16100','2013-09-03','08:45:00',2.62),('16100','2013-09-03','08:50:00',2.79),('16100','2013-09-03','08:55:00',2.99),('16100','2013-09-03','09:00:00',3.15),('16100','2013-09-03','09:05:00',3.31),('16100','2013-09-03','09:10:00',3.47),('16100','2013-09-03','09:15:00',3.64),('16100','2013-09-03','09:20:00',3.79),('16100','2013-09-03','09:25:00',3.92),('16100','2013-09-03','09:30:00',4.07),('16100','2013-09-03','09:35:00',4.22),('16100','2013-09-03','09:40:00',4.35),('16100','2013-09-03','09:45:00',4.52),('16100','2013-09-03','09:50:00',4.66),('16100','2013-09-03','09:55:00',4.78),('16100','2013-09-03','10:00:00',4.89),('16100','2013-09-03','10:05:00',5.01),('16100','2013-09-03','10:10:00',5.12),('16100','2013-09-03','10:15:00',5.21),('16100','2013-09-03','10:20:00',5.34),('16100','2013-09-03','10:25:00',5.44),('16100','2013-09-03','10:30:00',5.59),('16100','2013-09-03','10:35:00',5.7),('16100','2013-09-03','10:40:00',5.79),('16100','2013-09-03','10:45:00',5.91),('16100','2013-09-03','10:50:00',6.02),('16100','2013-09-03','10:55:00',6.12),('16100','2013-09-03','11:00:00',6.27),('16100','2013-09-03','11:05:00',6.37),('16100','2013-09-03','11:10:00',6.44),('16100','2013-09-03','11:15:00',6.55),('16100','2013-09-03','11:20:00',6.62),('16100','2013-09-03','11:25:00',6.69),('16100','2013-09-03','11:30:00',6.76),('16100','2013-09-03','11:35:00',6.84),('16100','2013-09-03','11:40:00',6.85),('16100','2013-09-03','11:45:00',6.91),('16100','2013-09-03','11:50:00',6.97),('16100','2013-09-03','11:55:00',7.05),('16100','2013-09-03','12:00:00',7.12),('16100','2013-09-03','12:05:00',7.16),('16100','2013-09-03','12:10:00',7.19),('16100','2013-09-03','12:15:00',7.26),('16100','2013-09-03','12:20:00',7.31),('16100','2013-09-03','12:25:00',7.32),('16100','2013-09-03','12:30:00',7.36),('16100','2013-09-03','12:35:00',7.34),('16100','2013-09-03','12:40:00',7.33),('16100','2013-09-03','12:45:00',7.31),('16100','2013-09-03','12:50:00',7.33),('16100','2013-09-03','12:55:00',7.35),('16100','2013-09-03','13:00:00',7.39),('16100','2013-09-03','13:05:00',7.4),('16100','2013-09-03','13:10:00',7.41),('16100','2013-09-03','13:15:00',7.38),('16100','2013-09-03','13:20:00',7.35),('16100','2013-09-03','13:25:00',7.38),('16100','2013-09-03','13:30:00',7.34),('16100','2013-09-03','13:35:00',7.27),('16100','2013-09-03','13:40:00',7.27),('16100','2013-09-03','13:45:00',7.25),('16100','2013-09-03','13:50:00',7.24),('16100','2013-09-03','13:55:00',7.26),('16100','2013-09-03','14:00:00',7.21),('16100','2013-09-03','14:05:00',7.14),('16100','2013-09-03','14:10:00',7.05),('16100','2013-09-03','14:15:00',7.03),('16100','2013-09-03','14:20:00',6.91),('16100','2013-09-03','14:25:00',6.87),('16100','2013-09-03','14:30:00',6.83),('16100','2013-09-03','14:35:00',6.81),('16100','2013-09-03','14:40:00',6.73),('16100','2013-09-03','14:45:00',6.65),('16100','2013-09-03','14:50:00',6.61),('16100','2013-09-03','14:55:00',6.53),('16100','2013-09-03','15:00:00',6.48),('16100','2013-09-03','15:05:00',6.42),('16100','2013-09-03','15:10:00',6.36),('16100','2013-09-03','15:15:00',6.25),('16100','2013-09-03','15:20:00',6.17),('16100','2013-09-03','15:25:00',6.08),('16100','2013-09-03','15:30:00',5.98),('16100','2013-09-03','15:35:00',5.93),('16100','2013-09-03','15:40:00',5.81),('16100','2013-09-03','15:45:00',5.71),('16100','2013-09-03','15:50:00',5.6),('16100','2013-09-03','15:55:00',5.52),('16100','2013-09-03','16:00:00',5.4),('16100','2013-09-03','16:05:00',5.23),('16100','2013-09-03','16:10:00',5.1),('16100','2013-09-03','16:15:00',5),('16100','2013-09-03','16:20:00',4.93),('16100','2013-09-03','16:25:00',4.74),('16100','2013-09-03','16:30:00',4.57),('16100','2013-09-03','16:35:00',3.27),('16100','2013-09-03','16:40:00',4.4),('16100','2013-09-03','16:45:00',4.26),('16100','2013-09-03','16:50:00',4.07),('16100','2013-09-03','16:55:00',3.93),('16100','2013-09-03','17:00:00',3.79),('16100','2013-09-03','17:05:00',3.35),('16100','2013-09-03','17:10:00',3.44),('16100','2013-09-03','17:15:00',3.23),('16100','2013-09-03','17:20:00',3),('16100','2013-09-03','17:25:00',2.83),('16100','2013-09-03','17:30:00',2.7),('16100','2013-09-03','17:35:00',2.52),('16100','2013-09-03','17:40:00',2.39),('16100','2013-09-03','17:45:00',2.22),('16100','2013-09-03','17:50:00',2.06),('16100','2013-09-03','17:55:00',1.93),('16100','2013-09-03','18:00:00',1.77),('16100','2013-09-03','18:05:00',1.61),('16100','2013-09-03','18:10:00',1.44),('16100','2013-09-03','18:15:00',1.27),('16100','2013-09-03','18:20:00',1.12),('16100','2013-09-02','08:05:00',1.06),('16100','2013-09-02','08:10:00',1.24),('16100','2013-09-02','08:15:00',1.4),('16100','2013-09-02','08:20:00',1.56),('16100','2013-09-02','08:25:00',1.73),('16100','2013-09-02','08:30:00',1.89),('16100','2013-09-02','08:35:00',2.05),('16100','2013-09-02','08:40:00',2.24),('16100','2013-09-02','08:45:00',2.4),('16100','2013-09-02','08:50:00',2.55),('16100','2013-09-02','08:55:00',2.74),('16100','2013-09-02','09:00:00',2.89),('16100','2013-09-02','09:05:00',3.03),('16100','2013-09-02','09:10:00',3.23),('16100','2013-09-02','09:15:00',3.42),('16100','2013-09-02','09:20:00',3.54),('16100','2013-09-02','09:25:00',3.68),('16100','2013-09-02','09:30:00',3.83),('16100','2013-09-02','09:35:00',3.97),('16100','2013-09-02','09:40:00',4.12),('16100','2013-09-02','09:45:00',4.27),('16100','2013-09-02','09:50:00',4.39),('16100','2013-09-02','09:55:00',4.51),('16100','2013-09-02','10:00:00',4.63),('16100','2013-09-02','10:05:00',4.78),('16100','2013-09-02','10:10:00',4.95),('16100','2013-09-02','10:15:00',5.07),('16100','2013-09-02','10:20:00',5.18),('16100','2013-09-02','10:25:00',5.33),('16100','2013-09-02','10:30:00',5.47),('16100','2013-09-02','10:35:00',5.57),('16100','2013-09-02','10:40:00',5.65),('16100','2013-09-02','10:45:00',5.73),('16100','2013-09-02','10:50:00',5.78),('16100','2013-09-02','10:55:00',5.87),('16100','2013-09-02','11:00:00',5.94),('16100','2013-09-02','11:05:00',6),('16100','2013-09-02','11:10:00',6.1),('16100','2013-09-02','11:15:00',6.21),('16100','2013-09-02','11:20:00',6.29),('16100','2013-09-02','11:25:00',6.38),('16100','2013-09-02','11:30:00',6.5),('16100','2013-09-02','11:35:00',6.54),('16100','2013-09-02','11:40:00',6.63),('16100','2013-09-02','11:45:00',6.69),('16100','2013-09-02','11:50:00',6.75),('16100','2013-09-02','11:55:00',6.82),('16100','2013-09-02','12:00:00',6.81),('16100','2013-09-02','12:05:00',6.87),('16100','2013-09-02','12:10:00',6.98),('16100','2013-09-02','12:15:00',6.97),('16100','2013-09-02','12:20:00',7.05),('16100','2013-09-02','12:25:00',7.08),('16100','2013-09-02','12:30:00',7.16),('16100','2013-09-02','12:35:00',7.16),('16100','2013-09-02','12:40:00',7.14),('16100','2013-09-02','12:45:00',7.18),('16100','2013-09-02','12:50:00',7.21),('16100','2013-09-02','12:55:00',7.24),('16100','2013-09-02','13:00:00',7.31),('16100','2013-09-02','13:05:00',7.25),('16100','2013-09-02','13:10:00',7.21),('16100','2013-09-02','13:15:00',7.15),('16100','2013-09-02','13:20:00',7.26),('16100','2013-09-02','13:25:00',7.27),('16100','2013-09-02','13:30:00',7.18),('16100','2013-09-02','13:35:00',7.16),('16100','2013-09-02','13:40:00',7.16),('16100','2013-09-02','13:45:00',7.19),('16100','2013-09-02','13:50:00',7.16),('16100','2013-09-02','13:55:00',7.15),('16100','2013-09-02','14:00:00',7.03),('16100','2013-09-02','14:05:00',6.95),('16100','2013-09-02','14:10:00',6.89),('16100','2013-09-02','14:15:00',6.85),('16100','2013-09-02','14:20:00',6.78),('16100','2013-09-02','14:25:00',6.8),('16100','2013-09-02','14:30:00',6.81),('16100','2013-09-02','14:35:00',6.84),('16100','2013-09-02','14:40:00',6.75),('16100','2013-09-02','14:45:00',6.68),('16100','2013-09-02','14:50:00',6.54),('16100','2013-09-02','14:55:00',6.52),('16100','2013-09-02','15:00:00',6.55),('16100','2013-09-02','15:05:00',6.43),('16100','2013-09-02','15:10:00',6.35),('16100','2013-09-02','15:15:00',6.19),('16100','2013-09-02','15:20:00',6.12),('16100','2013-09-02','15:25:00',6.09),('16100','2013-09-02','15:30:00',6.02),('16100','2013-09-02','15:35:00',5.93),('16100','2013-09-02','15:40:00',5.79),('16100','2013-09-02','15:45:00',5.62),('16100','2013-09-02','15:50:00',5.54),('16100','2013-09-02','15:55:00',5.46),('16100','2013-09-02','16:00:00',5.35),('16100','2013-09-02','16:05:00',5.18),('16100','2013-09-02','16:10:00',4.9),('16100','2013-09-02','16:15:00',4.93),('16100','2013-09-02','16:20:00',4.8),('16100','2013-09-02','16:25:00',4.7),('16100','2013-09-02','16:30:00',4.6),('16100','2013-09-02','16:35:00',4.51),('16100','2013-09-02','16:40:00',4.35),('16100','2013-09-02','16:45:00',4.21),('16100','2013-09-02','16:50:00',4.03),('16100','2013-09-02','16:55:00',3.91),('16100','2013-09-02','17:00:00',3.77),('16100','2013-09-02','17:05:00',3.62),('16100','2013-09-02','17:10:00',3.46),('16100','2013-09-02','17:15:00',3.3),('16100','2013-09-02','17:20:00',3.15),('16100','2013-09-02','17:25:00',2.95),('16100','2013-09-02','17:30:00',2.72),('16100','2013-09-02','17:35:00',2.47),('16100','2013-09-02','17:40:00',2.31),('16100','2013-09-02','17:45:00',2.15),('16100','2013-09-02','17:50:00',1.99),('16100','2013-09-02','17:55:00',1.83),('16100','2013-09-02','18:00:00',1.67),('16100','2013-09-02','18:05:00',1.57),('16100','2013-09-02','18:10:00',1.4),('16100','2013-09-02','18:15:00',1.25),('16100','2013-09-02','18:20:00',1.13),('16100','2013-09-01','08:05:00',1.09),('16100','2013-09-01','08:10:00',1.28),('16100','2013-09-01','08:15:00',1.45),('16100','2013-09-01','08:20:00',1.62),('16100','2013-09-01','08:25:00',1.8),('16100','2013-09-01','08:30:00',1.97),('16100','2013-09-01','08:35:00',2.14),('16100','2013-09-01','08:40:00',2.31),('16100','2013-09-01','08:45:00',2.48),('16100','2013-09-01','08:50:00',2.66),('16100','2013-09-01','08:55:00',2.85),('16100','2013-09-01','09:00:00',3.01),('16100','2013-09-01','09:05:00',3.15),('16100','2013-09-01','09:10:00',3.33),('16100','2013-09-01','09:15:00',3.51),('16100','2013-09-01','09:20:00',3.64),('16100','2013-09-01','09:25:00',3.79),('16100','2013-09-01','09:30:00',3.93),('16100','2013-09-01','09:35:00',4.04),('16100','2013-09-01','09:40:00',4.2),('16100','2013-09-01','09:45:00',4.38),('16100','2013-09-01','09:50:00',4.51),('16100','2013-09-01','09:55:00',4.62),('16100','2013-09-01','10:00:00',4.78),('16100','2013-09-01','10:05:00',4.87),('16100','2013-09-01','10:10:00',5.01),('16100','2013-09-01','10:15:00',5.13),('16100','2013-09-01','10:20:00',5.25),('16100','2013-09-01','10:25:00',5.4),('16100','2013-09-01','10:30:00',5.54),('16100','2013-09-01','10:35:00',5.65),('16100','2013-09-01','10:40:00',5.73),('16100','2013-09-01','10:45:00',5.81),('16100','2013-09-01','10:50:00',5.91),('16100','2013-09-01','10:55:00',6),('16100','2013-09-01','11:00:00',6.1),('16100','2013-09-01','11:05:00',6.19),('16100','2013-09-01','11:10:00',6.27),('16100','2013-09-01','11:15:00',6.35),('16100','2013-09-01','11:20:00',6.41),('16100','2013-09-01','11:25:00',6.51),('16100','2013-09-01','11:30:00',6.55),('16100','2013-09-01','11:35:00',6.62),('16100','2013-09-01','11:40:00',6.68),('16100','2013-09-01','11:45:00',6.69),('16100','2013-09-01','11:50:00',6.74),('16100','2013-09-01','11:55:00',6.78),('16100','2013-09-01','12:00:00',6.85),('16100','2013-09-01','12:05:00',6.93),('16100','2013-09-01','12:10:00',6.97),('16100','2013-09-01','12:15:00',6.97),('16100','2013-09-01','12:20:00',6.98),('16100','2013-09-01','12:25:00',7.01),('16100','2013-09-01','12:30:00',7.11),('16100','2013-09-01','12:35:00',7.11),('16100','2013-09-01','12:40:00',7.1),('16100','2013-09-01','12:45:00',7.15),('16100','2013-09-01','12:50:00',7.19),('16100','2013-09-01','12:55:00',7.19),('16100','2013-09-01','13:00:00',7.18),('16100','2013-09-01','13:05:00',7.2),('16100','2013-09-01','13:10:00',7.16),('16100','2013-09-01','13:15:00',7.13),('16100','2013-09-01','13:20:00',7.11),('16100','2013-09-01','13:25:00',7.14),('16100','2013-09-01','13:30:00',7.18),('16100','2013-09-01','13:35:00',7.17),('16100','2013-09-01','13:40:00',7.19),('16100','2013-09-01','13:45:00',7.18),('16100','2013-09-01','13:50:00',7.21),('16100','2013-09-01','13:55:00',7.11),('16100','2013-09-01','14:00:00',7.06),('16100','2013-09-01','14:05:00',6.96),('16100','2013-09-01','14:10:00',6.88),('16100','2013-09-01','14:15:00',6.96),('16100','2013-09-01','14:20:00',6.95),('16100','2013-09-01','14:25:00',4.74),('16100','2013-09-01','14:30:00',6.89),('16100','2013-09-01','14:35:00',3.54),('16100','2013-09-01','14:40:00',5.26),('16100','2013-09-01','14:45:00',6.82),('16100','2013-09-01','14:50:00',6.57),('16100','2013-09-01','14:55:00',6.58),('16100','2013-09-01','15:00:00',6.49),('16100','2013-09-01','15:05:00',6.45),('16100','2013-09-01','15:10:00',6.27),('16100','2013-09-01','15:15:00',6.04),('16100','2013-09-01','15:20:00',5.86),('16100','2013-09-01','15:25:00',5.93),('16100','2013-09-01','15:30:00',5.93),('16100','2013-09-01','15:35:00',5.88),('16100','2013-09-01','15:40:00',5.76),('16100','2013-09-01','15:45:00',5.73),('16100','2013-09-01','15:50:00',5.64),('16100','2013-09-01','15:55:00',5.49),('16100','2013-09-01','16:00:00',5.4),('16100','2013-09-01','16:05:00',5.31),('16100','2013-09-01','16:10:00',5.07),('16100','2013-09-01','16:15:00',4.99),('16100','2013-09-01','16:20:00',4.87),('16100','2013-09-01','16:25:00',4.7),('16100','2013-09-01','16:30:00',4.6),('16100','2013-09-01','16:35:00',4.47),('16100','2013-09-01','16:40:00',4.36),('16100','2013-09-01','16:45:00',4.22),('16100','2013-09-01','16:50:00',4.05),('16100','2013-09-01','16:55:00',3.91),('16100','2013-09-01','17:00:00',3.75),('16100','2013-09-01','17:05:00',3.55),('16100','2013-09-01','17:10:00',3.4),('16100','2013-09-01','17:15:00',3.29),('16100','2013-09-01','17:20:00',3.07),('16100','2013-09-01','17:25:00',2.88),('16100','2013-09-01','17:30:00',2.75),('16100','2013-09-01','17:35:00',2.58),('16100','2013-09-01','17:40:00',2.4),('16100','2013-09-01','17:45:00',2.25),('16100','2013-09-01','17:50:00',2.09),('16100','2013-09-01','17:55:00',1.92),('16100','2013-09-01','18:00:00',1.78),('16100','2013-09-01','18:05:00',1.63),('16100','2013-09-01','18:10:00',1.45),('16100','2013-09-01','18:15:00',1.28),('16100','2013-09-01','18:20:00',1.12),('16100','2013-08-31','08:05:00',1.12),('16100','2013-08-31','08:10:00',1.35),('16100','2013-08-31','08:15:00',1.54),('16100','2013-08-31','08:20:00',1.72),('16100','2013-08-31','08:25:00',1.91),('16100','2013-08-31','08:30:00',2.08),('16100','2013-08-31','08:35:00',2.25),('16100','2013-08-31','08:40:00',2.42),('16100','2013-08-31','08:45:00',2.58),('16100','2013-08-31','08:50:00',2.74),('16100','2013-08-31','08:55:00',2.93),('16100','2013-08-31','09:00:00',3.08),('16100','2013-08-31','09:05:00',3.24),('16100','2013-08-31','09:10:00',3.43),('16100','2013-08-31','09:15:00',3.61),('16100','2013-08-31','09:20:00',3.76),('16100','2013-08-31','09:25:00',3.89),('16100','2013-08-31','09:30:00',4.04),('16100','2013-08-31','09:35:00',4.16),('16100','2013-08-31','09:40:00',4.31),('16100','2013-08-31','09:45:00',4.48),('16100','2013-08-31','09:50:00',4.58),('16100','2013-08-31','09:55:00',4.7),('16100','2013-08-31','10:00:00',4.82),('16100','2013-08-31','10:05:00',4.95),('16100','2013-08-31','10:10:00',5.04),('16100','2013-08-31','10:15:00',5.18),('16100','2013-08-31','10:20:00',5.3),('16100','2013-08-31','10:25:00',5.39),('16100','2013-08-31','10:30:00',5.61),('16100','2013-08-31','10:35:00',5.71),('16100','2013-08-31','10:40:00',5.83),('16100','2013-08-31','10:45:00',5.92),('16100','2013-08-31','10:50:00',6.02),('16100','2013-08-31','10:55:00',6.12),('16100','2013-08-31','11:00:00',6.19),('16100','2013-08-31','11:05:00',6.34),('16100','2013-08-31','11:10:00',6.45),('16100','2013-08-31','11:15:00',6.6),('16100','2013-08-31','11:20:00',6.64),('16100','2013-08-31','11:25:00',6.71),('16100','2013-08-31','11:30:00',6.78),('16100','2013-08-31','11:35:00',6.85),('16100','2013-08-31','11:40:00',6.87),('16100','2013-08-31','11:45:00',6.91),('16100','2013-08-31','11:50:00',6.97),('16100','2013-08-31','11:55:00',6.96),('16100','2013-08-31','12:00:00',7),('16100','2013-08-31','12:05:00',7.03),('16100','2013-08-31','12:10:00',7.07),('16100','2013-08-31','12:15:00',7.1),('16100','2013-08-31','12:20:00',7.04),('16100','2013-08-31','12:25:00',7.05),('16100','2013-08-31','12:30:00',7.19),('16100','2013-08-31','12:35:00',7.16),('16100','2013-08-31','12:40:00',7.22),('16100','2013-08-31','12:45:00',7.21),('16100','2013-08-31','12:50:00',7.26),('16100','2013-08-31','12:55:00',7.25),('16100','2013-08-31','13:00:00',7.17),('16100','2013-08-31','13:05:00',6.97),('16100','2013-08-31','13:10:00',7.09),('16100','2013-08-31','13:15:00',7.07),('16100','2013-08-31','13:20:00',6.95),('16100','2013-08-31','13:25:00',6.2),('16100','2013-08-31','13:30:00',6.77),('16100','2013-08-31','13:35:00',7.44),('16100','2013-08-31','13:40:00',7.42),('16100','2013-08-31','13:45:00',7.44),('16100','2013-08-31','13:50:00',7.43),('16100','2013-08-31','13:55:00',7.26),('16100','2013-08-31','14:00:00',7.12),('16100','2013-08-31','14:05:00',6.92),('16100','2013-08-31','14:10:00',6.44),('16100','2013-08-31','14:15:00',6.7),('16100','2013-08-31','14:20:00',6.06),('16100','2013-08-31','14:25:00',5.85),('16100','2013-08-31','14:30:00',5.89),('16100','2013-08-31','14:35:00',5.55),('16100','2013-08-31','14:40:00',5.7),('16100','2013-08-31','14:45:00',6.47),('16100','2013-08-31','14:50:00',6.33),('16100','2013-08-31','14:55:00',6.19),('16100','2013-08-31','15:00:00',6.16),('16100','2013-08-31','15:05:00',6.09),('16100','2013-08-31','15:10:00',6.08),('16100','2013-08-31','15:15:00',5.78),('16100','2013-08-31','15:20:00',5.81),('16100','2013-08-31','15:25:00',5.65),('16100','2013-08-31','15:30:00',4.75),('16100','2013-08-31','15:35:00',4.71),('16100','2013-08-31','15:40:00',4.67),('16100','2013-08-31','15:45:00',4.67),('16100','2013-08-31','15:50:00',4.56),('16100','2013-08-31','15:55:00',4.62),('16100','2013-08-31','16:00:00',4.69),('16100','2013-08-31','16:05:00',3.88),('16100','2013-08-31','16:10:00',4.83),('16100','2013-08-31','16:15:00',4.95),('16100','2013-08-31','16:20:00',4.56),('16100','2013-08-31','16:25:00',4.82),('16100','2013-08-31','16:30:00',4.07),('16100','2013-08-31','16:35:00',4.4),('16100','2013-08-31','16:40:00',4.24),('16100','2013-08-31','16:45:00',3.88),('16100','2013-08-31','16:50:00',3.51),('16100','2013-08-31','16:55:00',3.12),('16100','2013-08-31','17:00:00',3.37),('16100','2013-08-31','17:05:00',3.39),('16100','2013-08-31','17:10:00',3.26),('16100','2013-08-31','17:15:00',3.41),('16100','2013-08-31','17:20:00',3.17),('16100','2013-08-31','17:25:00',2.84),('16100','2013-08-31','17:30:00',2.83),('16100','2013-08-31','17:35:00',2.76),('16100','2013-08-31','17:40:00',2.24),('16100','2013-08-31','17:45:00',2.33),('16100','2013-08-31','17:50:00',2.48),('16100','2013-08-31','17:55:00',2.22),('16100','2013-08-31','18:00:00',1.93),('16100','2013-08-31','18:05:00',1.81),('16100','2013-08-31','18:10:00',1.78),('16100','2013-08-31','18:15:00',1.45),('16100','2013-08-31','18:20:00',1.36),('16100','2013-08-31','18:25:00',1.4),('16100','2013-08-31','18:30:00',1.15),('16100','2013-08-31','18:35:00',1.09),('16100','2013-08-31','18:40:00',1.07),('16100','2013-08-30','08:15:00',1.3),('16100','2013-08-30','08:20:00',1.6),('16100','2013-08-30','08:25:00',1.96),('16100','2013-08-30','08:30:00',2.16),('16100','2013-08-30','08:35:00',2.28),('16100','2013-08-30','08:40:00',2.49),('16100','2013-08-30','08:45:00',2.77),('16100','2013-08-30','08:50:00',3.09),('16100','2013-08-30','08:55:00',3.44),('16100','2013-08-30','09:00:00',3.12),('16100','2013-08-30','09:05:00',2.51),('16100','2013-08-30','09:10:00',2.25),('16100','2013-08-30','09:15:00',3.96),('16100','2013-08-30','09:20:00',3.91),('16100','2013-08-30','09:25:00',4.24),('16100','2013-08-30','09:30:00',4.43),('16100','2013-08-30','09:35:00',4.49),('16100','2013-08-30','09:40:00',4.18),('16100','2013-08-30','09:45:00',4.49),('16100','2013-08-30','09:50:00',5.01),('16100','2013-08-30','09:55:00',4.89),('16100','2013-08-30','10:00:00',5.22),('16100','2013-08-30','10:05:00',5.15),('16100','2013-08-30','10:10:00',5.3),('16100','2013-08-30','10:15:00',5.32),('16100','2013-08-30','10:20:00',5.39),('16100','2013-08-30','10:25:00',5.57),('16100','2013-08-30','10:30:00',5.69),('16100','2013-08-30','10:35:00',5.72),('16100','2013-08-30','10:40:00',5.86),('16100','2013-08-30','10:45:00',6.04),('16100','2013-08-30','10:50:00',6.17),('16100','2013-08-30','10:55:00',6.32),('16100','2013-08-30','11:00:00',6.41),('16100','2013-08-30','11:05:00',6.52),('16100','2013-08-30','11:10:00',6.59),('16100','2013-08-30','11:15:00',6.68),('16100','2013-08-30','11:20:00',6.75),('16100','2013-08-30','11:25:00',6.8),('16100','2013-08-30','11:30:00',6.88),('16100','2013-08-30','11:35:00',6.95),('16100','2013-08-30','11:40:00',7.04),('16100','2013-08-30','11:45:00',7.12),('16100','2013-08-30','11:50:00',7.15),('16100','2013-08-30','11:55:00',7.19),('16100','2013-08-30','12:00:00',7.22),('16100','2013-08-30','12:05:00',7.26),('16100','2013-08-30','12:10:00',7.3),('16100','2013-08-30','12:15:00',7.36),('16100','2013-08-30','12:20:00',7.32),('16100','2013-08-30','12:25:00',7.32),('16100','2013-08-30','12:30:00',7.31),('16100','2013-08-30','12:35:00',7.43),('16100','2013-08-30','12:40:00',7.49),('16100','2013-08-30','12:45:00',7.48),('16100','2013-08-30','12:50:00',7.47),('16100','2013-08-30','12:55:00',7.46),('16100','2013-08-30','13:00:00',7.48),('16100','2013-08-30','13:05:00',7.44),('16100','2013-08-30','13:10:00',7.48),('16100','2013-08-30','13:15:00',7.48),('16100','2013-08-30','13:20:00',7.41),('16100','2013-08-30','13:25:00',7.36),('16100','2013-08-30','13:30:00',7.28),('16100','2013-08-30','13:35:00',7.33),('16100','2013-08-30','13:40:00',7.36),('16100','2013-08-30','13:45:00',7.3),('16100','2013-08-30','13:50:00',7.24),('16100','2013-08-30','13:55:00',7.16),('16100','2013-08-30','14:00:00',7.24),('16100','2013-08-30','14:05:00',7.13),('16100','2013-08-30','14:10:00',7),('16100','2013-08-30','14:15:00',6.91),('16100','2013-08-30','14:20:00',6.81),('16100','2013-08-30','14:25:00',6.8),('16100','2013-08-30','14:30:00',6.74),('16100','2013-08-30','14:35:00',6.68),('16100','2013-08-30','14:40:00',6.71),('16100','2013-08-30','14:45:00',6.57),('16100','2013-08-30','14:50:00',6.46),('16100','2013-08-30','14:55:00',6.39),('16100','2013-08-30','15:00:00',6.28),('16100','2013-08-30','15:05:00',6.24),('16100','2013-08-30','15:10:00',6.09),('16100','2013-08-30','15:15:00',6.02),('16100','2013-08-30','15:20:00',5.93),('16100','2013-08-30','15:25:00',5.88),('16100','2013-08-30','15:30:00',5.77),('16100','2013-08-30','15:35:00',5.71),('16100','2013-08-30','15:40:00',5.56),('16100','2013-08-30','15:45:00',5.43),('16100','2013-08-30','15:50:00',5.41),('16100','2013-08-30','15:55:00',5.37),('16100','2013-08-30','16:00:00',5.3),('16100','2013-08-30','16:05:00',5.13),('16100','2013-08-30','16:10:00',4.93),('16100','2013-08-30','16:15:00',4.76),('16100','2013-08-30','16:20:00',4.76),('16100','2013-08-30','16:25:00',4.43),('16100','2013-08-30','16:30:00',4.59),('16100','2013-08-30','16:35:00',4.42),('16100','2013-08-30','16:40:00',4.08),('16100','2013-08-30','16:45:00',3.98),('16100','2013-08-30','16:50:00',3.92),('16100','2013-08-30','16:55:00',3.9),('16100','2013-08-30','17:00:00',3.76),('16100','2013-08-30','17:05:00',3.66),('16100','2013-08-30','17:10:00',3.56),('16100','2013-08-30','17:15:00',3.34),('16100','2013-08-30','17:20:00',3.11),('16100','2013-08-30','17:25:00',2.87),('16100','2013-08-30','17:30:00',2.7),('16100','2013-08-30','17:35:00',2.69),('16100','2013-08-30','17:40:00',2.52),('16100','2013-08-30','17:45:00',2.28),('16100','2013-08-30','17:50:00',1.85),('16100','2013-08-30','17:55:00',1.41),('16100','2013-08-30','18:00:00',1.1),('16100','2013-08-30','18:05:00',1.19),('16100','2013-08-30','18:10:00',1.14),('16100','2013-08-29','08:00:00',1.15),('16100','2013-08-29','08:05:00',1.43),('16100','2013-08-29','08:10:00',1.58),('16100','2013-08-29','08:15:00',1.62),('16100','2013-08-29','08:20:00',1.88),('16100','2013-08-29','08:25:00',1.93),('16100','2013-08-29','08:30:00',2.03),('16100','2013-08-29','08:35:00',2.13),('16100','2013-08-29','08:40:00',2.16),('16100','2013-08-29','08:45:00',1.91),('16100','2013-08-29','08:50:00',1.88),('16100','2013-08-29','08:55:00',2.19),('16100','2013-08-29','09:00:00',2.42),('16100','2013-08-29','09:05:00',2.41),('16100','2013-08-29','09:10:00',2.14),('16100','2013-08-29','09:15:00',1.9),('16100','2013-08-29','09:20:00',1.85),('16100','2013-08-29','09:25:00',2.35),('16100','2013-08-29','09:30:00',2.61),('16100','2013-08-29','09:35:00',2.75),('16100','2013-08-29','09:40:00',2.94),('16100','2013-08-29','09:45:00',3),('16100','2013-08-29','09:50:00',3.23),('16100','2013-08-29','09:55:00',3.33),('16100','2013-08-29','10:00:00',2.99),('16100','2013-08-29','10:05:00',3.02),('16100','2013-08-29','10:10:00',3.39),('16100','2013-08-29','10:15:00',3.43),('16100','2013-08-29','10:20:00',3.29),('16100','2013-08-29','10:25:00',3.59),('16100','2013-08-29','10:30:00',3.77),('16100','2013-08-29','10:35:00',3.64),('16100','2013-08-29','10:40:00',3.39),('16100','2013-08-29','10:45:00',3.61),('16100','2013-08-29','10:50:00',3.57),('16100','2013-08-29','10:55:00',3.5),('16100','2013-08-29','11:00:00',3.67),('16100','2013-08-29','11:05:00',3.98),('16100','2013-08-29','11:10:00',4.34),('16100','2013-08-29','11:15:00',4.15),('16100','2013-08-29','11:20:00',4.46),('16100','2013-08-29','11:25:00',4.44),('16100','2013-08-29','11:30:00',4.74),('16100','2013-08-29','11:35:00',4.58),('16100','2013-08-29','11:40:00',5.12),('16100','2013-08-29','11:45:00',5.33),('16100','2013-08-29','11:50:00',5.41),('16100','2013-08-29','11:55:00',5.05),('16100','2013-08-29','12:00:00',4.02),('16100','2013-08-29','12:05:00',4.24),('16100','2013-08-29','12:10:00',4.56),('16100','2013-08-29','12:15:00',4.32),('16100','2013-08-29','12:20:00',5.04),('16100','2013-08-29','12:25:00',5.68),('16100','2013-08-29','12:30:00',6.21),('16100','2013-08-29','12:35:00',5.69),('16100','2013-08-29','12:40:00',6.03),('16100','2013-08-29','12:45:00',5.76),('16100','2013-08-29','12:50:00',5.55),('16100','2013-08-29','12:55:00',5.15),('16100','2013-08-29','13:00:00',5.09),('16100','2013-08-29','13:05:00',4.68),('16100','2013-08-29','13:10:00',4.69),('16100','2013-08-29','13:15:00',5.11),('16100','2013-08-29','13:20:00',5.82),('16100','2013-08-29','13:25:00',7.45),('16100','2013-08-29','13:30:00',7.4),('16100','2013-08-29','13:35:00',6.78),('16100','2013-08-29','13:40:00',7.35),('16100','2013-08-29','13:45:00',7.19),('16100','2013-08-29','13:50:00',6.93),('16100','2013-08-29','13:55:00',7.05),('16100','2013-08-29','14:00:00',7.24),('16100','2013-08-29','14:05:00',7.21),('16100','2013-08-29','14:10:00',7.26),('16100','2013-08-29','14:15:00',6.93),('16100','2013-08-29','14:20:00',6.91),('16100','2013-08-29','14:25:00',7.06),('16100','2013-08-29','14:30:00',7.04),('16100','2013-08-29','14:35:00',7.03),('16100','2013-08-29','14:40:00',6.21),('16100','2013-08-29','14:45:00',6.31),('16100','2013-08-29','14:50:00',4.96),('16100','2013-08-29','14:55:00',6.27),('16100','2013-08-29','15:00:00',4.75),('16100','2013-08-29','15:05:00',4.92),('16100','2013-08-29','15:10:00',5.11),('16100','2013-08-29','15:15:00',4.8),('16100','2013-08-29','15:20:00',4.76),('16100','2013-08-29','15:25:00',4.64),('16100','2013-08-29','15:30:00',4.42),('16100','2013-08-29','15:35:00',4.08),('16100','2013-08-29','15:40:00',4.83),('16100','2013-08-29','15:45:00',4.69),('16100','2013-08-29','15:50:00',4.12),('16100','2013-08-29','15:55:00',3.86),('16100','2013-08-29','16:00:00',3.44),('16100','2013-08-29','16:05:00',3.02),('16100','2013-08-29','16:10:00',3.34),('16100','2013-08-29','16:15:00',3.68),('16100','2013-08-29','16:20:00',3.62),('16100','2013-08-29','16:25:00',3.41),('16100','2013-08-29','16:30:00',3.73),('16100','2013-08-29','16:35:00',4.18),('16100','2013-08-29','16:40:00',4.26),('16100','2013-08-29','16:45:00',4.22),('16100','2013-08-29','16:50:00',4.01),('16100','2013-08-29','16:55:00',2.68),('16100','2013-08-29','17:00:00',3.23),('16100','2013-08-29','17:05:00',2.11),('16100','2013-08-29','17:10:00',2.15),('16100','2013-08-29','17:15:00',2.08),('16100','2013-08-29','17:20:00',2.83),('16100','2013-08-29','17:25:00',2.52),('16100','2013-08-29','17:30:00',2.47),('16100','2013-08-29','17:35:00',2.18),('16100','2013-08-29','17:40:00',2.33),('16100','2013-08-29','17:45:00',1.65),('16100','2013-08-29','17:50:00',2.18),('16100','2013-08-29','17:55:00',2.19),('16100','2013-08-29','18:00:00',1.61),('16100','2013-08-29','18:05:00',1.03),('16100','2014-04-10','08:25:00',1.48),('16100','2014-04-10','08:30:00',2.08),('16100','2014-04-10','08:35:00',2.38),('16100','2014-04-10','08:40:00',2.57),('16100','2014-04-10','08:45:00',2.73),('16100','2014-04-10','08:50:00',2.91),('16100','2014-04-10','08:55:00',3.07),('16100','2014-04-10','09:00:00',3.18),('16100','2014-04-10','09:05:00',3.3),('16100','2014-04-10','09:10:00',3.46),('16100','2014-04-10','09:15:00',3.62),('16100','2014-04-10','09:20:00',3.71),('16100','2014-04-10','09:25:00',3.81),('16100','2014-04-10','09:30:00',4.03),('16100','2014-04-10','09:35:00',4.18),('16100','2014-04-10','09:40:00',4.35),('16100','2014-04-10','09:45:00',4.54),('16100','2014-04-10','09:50:00',4.68),('16100','2014-04-10','09:55:00',4.79),('16100','2014-04-10','10:00:00',4.9),('16100','2014-04-10','10:05:00',5.07),('16100','2014-04-10','10:10:00',5.24),('16100','2014-04-10','10:15:00',5.37),('16100','2014-04-10','10:20:00',5.49),('16100','2014-04-10','10:25:00',5.62),('16100','2014-04-10','10:30:00',5.71),('16100','2014-04-10','10:35:00',5.87),('16100','2014-04-10','10:40:00',5.99),('16100','2014-04-10','10:45:00',6.11),('16100','2014-04-10','10:50:00',6.2),('16100','2014-04-10','10:55:00',6.27),('16100','2014-04-10','11:00:00',6.39),('16100','2014-04-10','11:05:00',6.47),('16100','2014-04-10','11:10:00',6.64),('16100','2014-04-10','11:15:00',6.73),('16100','2014-04-10','11:20:00',6.83),('16100','2014-04-10','11:25:00',6.95),('16100','2014-04-10','11:30:00',7.05),('16100','2014-04-10','11:35:00',7.06),('16100','2014-04-10','11:40:00',6.76),('16100','2014-04-10','11:45:00',7.39),('16100','2014-04-10','11:50:00',7.36),('16100','2014-04-10','11:55:00',6.07),('16100','2014-04-10','12:00:00',6.05),('16100','2014-04-10','12:05:00',7.49),('16100','2014-04-10','12:10:00',7.72),('16100','2014-04-10','12:15:00',5.44),('16100','2014-04-10','12:20:00',5.68),('16100','2014-04-10','12:25:00',8.23),('16100','2014-04-10','12:30:00',6.95),('16100','2014-04-10','12:35:00',8.28),('16100','2014-04-10','12:40:00',7.76),('16100','2014-04-10','12:45:00',6.4),('16100','2014-04-10','12:50:00',2.32),('16100','2014-04-10','12:55:00',5.41),('16100','2014-04-10','13:00:00',8.27),('16100','2014-04-10','13:05:00',8.26),('16100','2014-04-10','13:10:00',5.72),('16100','2014-04-10','13:15:00',5.47),('16100','2014-04-10','13:20:00',7.73),('16100','2014-04-10','13:25:00',6.44),('16100','2014-04-10','13:30:00',8.37),('16100','2014-04-10','13:35:00',4.99),('16100','2014-04-10','13:40:00',6.06),('16100','2014-04-10','13:45:00',6.12),('16100','2014-04-10','13:50:00',4.29),('16100','2014-04-10','13:55:00',5.03),('16100','2014-04-10','14:00:00',5.65),('16100','2014-04-10','14:05:00',2.96),('16100','2014-04-10','14:10:00',4.52),('16100','2014-04-10','14:15:00',4.37),('16100','2014-04-10','14:20:00',5.19),('16100','2014-04-10','14:25:00',3.08),('16100','2014-04-10','14:30:00',3.98),('16100','2014-04-10','14:35:00',4.39),('16100','2014-04-10','14:40:00',6.15),('16100','2014-04-10','14:45:00',8.42),('16100','2014-04-10','14:50:00',7.73),('16100','2014-04-10','14:55:00',7.55),('16100','2014-04-10','15:00:00',7.58),('16100','2014-04-10','15:05:00',7.23),('16100','2014-04-10','15:10:00',6.86),('16100','2014-04-10','15:15:00',6.55),('16100','2014-04-10','15:20:00',6.63),('16100','2014-04-10','15:25:00',6.45),('16100','2014-04-10','15:30:00',6.38),('16100','2014-04-10','15:35:00',6.23),('16100','2014-04-10','15:40:00',6.15),('16100','2014-04-10','15:45:00',6),('16100','2014-04-10','15:50:00',6.06),('16100','2014-04-10','15:55:00',5.69),('16100','2014-04-10','16:00:00',5.23),('16100','2014-04-10','16:05:00',5.59),('16100','2014-04-10','16:10:00',5.44),('16100','2014-04-10','16:15:00',3.09),('16100','2014-04-10','16:20:00',5.34),('16100','2014-04-10','16:25:00',5.34),('16100','2014-04-10','16:30:00',4.64),('16100','2014-04-10','16:35:00',5.05),('16100','2014-04-10','16:40:00',2.99),('16100','2014-04-10','16:45:00',4.46),('16100','2014-04-10','16:50:00',3.99),('16100','2014-04-10','16:55:00',4.42),('16100','2014-04-10','17:00:00',4.13),('16100','2014-04-10','17:05:00',4.27),('16100','2014-04-10','17:10:00',3.89),('16100','2014-04-10','17:15:00',3.27),('16100','2014-04-10','17:20:00',3.15),('16100','2014-04-10','17:25:00',2.51),('16100','2014-04-10','17:30:00',3.15),('16100','2014-04-10','17:35:00',3.22),('16100','2014-04-10','17:40:00',2.82),('16100','2014-04-10','17:45:00',2.26),('16100','2014-04-10','17:50:00',1.3),('16100','2014-04-10','17:55:00',1.52),('16100','2014-04-10','18:00:00',1.36),('16100','2014-04-10','18:05:00',1.65),('16100','2014-04-10','18:10:00',1.55),('16100','2014-04-10','18:15:00',1.36),('16100','2013-08-28','08:05:00',1.13),('16100','2013-08-28','08:10:00',1.41),('16100','2013-08-28','08:15:00',1.73),('16100','2013-08-28','08:20:00',2),('16100','2013-08-28','08:25:00',2.4),('16100','2013-08-28','08:30:00',2.82),('16100','2013-08-28','08:35:00',2.83),('16100','2013-08-28','08:40:00',1.98),('16100','2013-08-28','08:45:00',1.66),('16100','2013-08-28','08:50:00',1.79),('16100','2013-08-28','08:55:00',2.22),('16100','2013-08-28','09:00:00',2.2),('16100','2013-08-28','09:05:00',2.1),('16100','2013-08-28','09:10:00',2.28),('16100','2013-08-28','09:15:00',2.24),('16100','2013-08-28','09:20:00',2.34),('16100','2013-08-28','09:25:00',2.55),('16100','2013-08-28','09:30:00',2.54),('16100','2013-08-28','09:35:00',2.94),('16100','2013-08-28','09:40:00',2.69),('16100','2013-08-28','09:45:00',2.29),('16100','2013-08-28','09:50:00',2.24),('16100','2013-08-28','09:55:00',2.32),('16100','2013-08-28','10:00:00',2.36),('16100','2013-08-28','10:05:00',2.32),('16100','2013-08-28','10:10:00',2.27),('16100','2013-08-28','10:15:00',2.29),('16100','2013-08-28','10:20:00',2.35),('16100','2013-08-28','10:25:00',2.4),('16100','2013-08-28','10:30:00',2.42),('16100','2013-08-28','10:35:00',2.17),('16100','2013-08-28','10:40:00',1.95),('16100','2013-08-28','10:45:00',1.9),('16100','2013-08-28','10:50:00',2.05),('16100','2013-08-28','10:55:00',2.39),('16100','2013-08-28','11:00:00',2.44),('16100','2013-08-28','11:05:00',2.72),('16100','2013-08-28','11:10:00',3.16),('16100','2013-08-28','11:15:00',3.31),('16100','2013-08-28','11:20:00',2.96),('16100','2013-08-28','11:25:00',2.32),('16100','2013-08-28','11:30:00',2.02),('16100','2013-08-28','11:35:00',2.24),('16100','2013-08-28','11:40:00',2.73),('16100','2013-08-28','11:45:00',2.95),('16100','2013-08-28','11:50:00',3.11),('16100','2013-08-28','11:55:00',3.12),('16100','2013-08-28','12:00:00',3.16),('16100','2013-08-28','12:05:00',3.81),('16100','2013-08-28','12:10:00',5.65),('16100','2013-08-28','12:15:00',5.47),('16100','2013-08-28','12:20:00',5.58),('16100','2013-08-28','12:25:00',5.06),('16100','2013-08-28','12:30:00',4.5),('16100','2013-08-28','12:35:00',5.61),('16100','2013-08-28','12:40:00',6.63),('16100','2013-08-28','12:45:00',7.47),('16100','2013-08-28','12:50:00',5.8),('16100','2013-08-28','12:55:00',4.66),('16100','2013-08-28','13:00:00',4.68),('16100','2013-08-28','13:05:00',4.19),('16100','2013-08-28','13:10:00',3.63),('16100','2013-08-28','13:15:00',3.9),('16100','2013-08-28','13:20:00',3.7),('16100','2013-08-28','13:25:00',3.08),('16100','2013-08-28','13:30:00',3.07),('16100','2013-08-28','13:35:00',3.16),('16100','2013-08-28','13:40:00',2.65),('16100','2013-08-28','13:45:00',2.53),('16100','2013-08-28','13:50:00',2.98),('16100','2013-08-28','13:55:00',4.84),('16100','2013-08-28','14:00:00',3.44),('16100','2013-08-28','14:05:00',2.47),('16100','2013-08-28','14:10:00',2.06),('16100','2013-08-28','14:15:00',1.73),('16100','2013-08-28','14:20:00',1.56),('16100','2013-08-28','14:25:00',1.5),('16100','2013-08-28','14:30:00',1.51),('16100','2013-08-28','14:35:00',1.63),('16100','2013-08-28','14:40:00',1.81),('16100','2013-08-28','14:45:00',2.01),('16100','2013-08-28','14:50:00',2.2),('16100','2013-08-28','14:55:00',2.98),('16100','2013-08-28','15:00:00',3.53),('16100','2013-08-28','15:05:00',3.69),('16100','2013-08-28','15:10:00',2.1),('16100','2013-08-28','15:15:00',2.22),('16100','2013-08-28','15:20:00',3.6),('16100','2013-08-28','15:25:00',4.38),('16100','2013-08-28','15:30:00',4.1),('16100','2013-08-28','15:35:00',3.83),('16100','2013-08-28','15:40:00',4.13),('16100','2013-08-28','15:45:00',3.28),('16100','2013-08-28','15:50:00',3.61),('16100','2013-08-28','15:55:00',4.85),('16100','2013-08-28','16:00:00',6.72),('16100','2013-08-28','16:05:00',6.37),('16100','2013-08-28','16:10:00',5.6),('16100','2013-08-28','16:15:00',5.33),('16100','2013-08-28','16:20:00',5.19),('16100','2013-08-28','16:25:00',4.53),('16100','2013-08-28','16:30:00',4.99),('16100','2013-08-28','16:35:00',4.84),('16100','2013-08-28','16:40:00',4.69),('16100','2013-08-28','16:45:00',4.5),('16100','2013-08-28','16:50:00',4.39),('16100','2013-08-28','16:55:00',4.17),('16100','2013-08-28','17:00:00',4.04),('16100','2013-08-28','17:05:00',3.9),('16100','2013-08-28','17:10:00',3.73),('16100','2013-08-28','17:15:00',3.56),('16100','2013-08-28','17:20:00',3.39),('16100','2013-08-28','17:25:00',3.22),('16100','2013-08-28','17:30:00',3.04),('16100','2013-08-28','17:35:00',2.87),('16100','2013-08-28','17:40:00',2.67),('16100','2013-08-28','17:45:00',2.5),('16100','2013-08-28','17:50:00',2.35),('16100','2013-08-28','17:55:00',2.2),('16100','2013-08-28','18:00:00',2.03),('16100','2013-08-28','18:05:00',1.87),('16100','2013-08-28','18:10:00',1.71),('16100','2013-08-28','18:15:00',1.54),('16100','2013-08-28','18:20:00',1.36),('16100','2013-08-28','18:25:00',1.21),('16100','2013-08-28','18:30:00',1.06),('16100','2013-08-27','07:55:00',1),('16100','2013-08-27','08:00:00',1.01),('16100','2013-08-27','08:05:00',1.16),('16100','2013-08-27','08:10:00',1.48),('16100','2013-08-27','08:15:00',1.82),('16100','2013-08-27','08:20:00',1.74),('16100','2013-08-27','08:25:00',1.39),('16100','2013-08-27','08:30:00',1.86),('16100','2013-08-27','08:35:00',2.68),('16100','2013-08-27','08:40:00',2.02),('16100','2013-08-27','08:50:00',1.23),('16100','2013-08-27','08:55:00',2),('16100','2013-08-27','09:00:00',3.08),('16100','2013-08-27','09:05:00',2.73),('16100','2013-08-27','09:10:00',1.69),('16100','2013-08-27','09:15:00',1.91),('16100','2013-08-27','09:20:00',2.55),('16100','2013-08-27','09:25:00',2.23),('16100','2013-08-27','09:30:00',2.16),('16100','2013-08-27','09:35:00',2.67),('16100','2013-08-27','09:40:00',4.85),('16100','2013-08-27','09:45:00',4.68),('16100','2013-08-27','09:50:00',4.66),('16100','2013-08-27','09:55:00',4.75),('16100','2013-08-27','10:00:00',4.89),('16100','2013-08-27','10:05:00',5.01),('16100','2013-08-27','10:10:00',4.88),('16100','2013-08-27','10:15:00',5.28),('16100','2013-08-27','10:20:00',5.47),('16100','2013-08-27','10:25:00',5.58),('16100','2013-08-27','10:30:00',3.08),('16100','2013-08-27','10:35:00',5.99),('16100','2013-08-27','10:40:00',6.16),('16100','2013-08-27','10:45:00',5.22),('16100','2013-08-27','10:50:00',3.64),('16100','2013-08-27','10:55:00',4.29),('16100','2013-08-27','11:00:00',6.39),('16100','2013-08-27','11:05:00',5.69),('16100','2013-08-27','11:10:00',2.97),('16100','2013-08-27','11:15:00',3.5),('16100','2013-08-27','11:20:00',3.06),('16100','2013-08-27','11:25:00',7.57),('16100','2013-08-27','11:30:00',7.69),('16100','2013-08-27','11:35:00',5.1),('16100','2013-08-27','11:40:00',6.5),('16100','2013-08-27','11:45:00',7.17),('16100','2013-08-27','11:50:00',7.94),('16100','2013-08-27','11:55:00',7.76),('16100','2013-08-27','12:00:00',2.96),('16100','2013-08-27','12:05:00',6.77),('16100','2013-08-27','12:10:00',5.08),('16100','2013-08-27','12:15:00',5.56),('16100','2013-08-27','12:20:00',6.45),('16100','2013-08-27','12:25:00',7.32),('16100','2013-08-27','12:30:00',7.67),('16100','2013-08-27','12:35:00',7.9),('16100','2013-08-27','12:40:00',3.73),('16100','2013-08-27','12:45:00',7.88),('16100','2013-08-27','12:50:00',7.82),('16100','2013-08-27','12:55:00',7.77),('16100','2013-08-27','13:00:00',7.74),('16100','2013-08-27','13:05:00',7.71),('16100','2013-08-27','13:10:00',7.61),('16100','2013-08-27','13:15:00',5.78),('16100','2013-08-27','13:20:00',7.84),('16100','2013-08-27','13:25:00',7.76),('16100','2013-08-27','13:30:00',6.4),('16100','2013-08-27','13:35:00',7.42),('16100','2013-08-27','13:40:00',5.17),('16100','2013-08-27','13:45:00',7.52),('16100','2013-08-27','13:50:00',7.63),('16100','2013-08-27','13:55:00',7.03),('16100','2013-08-27','14:00:00',7.69),('16100','2013-08-27','14:05:00',7.61),('16100','2013-08-27','14:10:00',7.49),('16100','2013-08-27','14:15:00',7.49),('16100','2013-08-27','14:20:00',7.48),('16100','2013-08-27','14:25:00',7.44),('16100','2013-08-27','14:30:00',7.42),('16100','2013-08-27','14:35:00',7.33),('16100','2013-08-27','14:40:00',7.26),('16100','2013-08-27','14:45:00',7.22),('16100','2013-08-27','14:50:00',7.11),('16100','2013-08-27','14:55:00',5.87),('16100','2013-08-27','15:00:00',7.15),('16100','2013-08-27','15:05:00',7.08),('16100','2013-08-27','15:10:00',5.88),('16100','2013-08-27','15:15:00',7),('16100','2013-08-27','15:20:00',6.68),('16100','2013-08-27','15:25:00',6.71),('16100','2013-08-27','15:30:00',6.71),('16100','2013-08-27','15:35:00',6.78),('16100','2013-08-27','15:40:00',5.02),('16100','2013-08-27','15:45:00',5.74),('16100','2013-08-27','15:50:00',4.81),('16100','2013-08-27','15:55:00',6.11),('16100','2013-08-27','16:00:00',6.05),('16100','2013-08-27','16:05:00',5.97),('16100','2013-08-27','16:10:00',5.76),('16100','2013-08-27','16:15:00',5.44),('16100','2013-08-27','16:20:00',5.43),('16100','2013-08-27','16:25:00',5.27),('16100','2013-08-27','16:30:00',5.09),('16100','2013-08-27','16:35:00',4.96),('16100','2013-08-27','16:40:00',4.84),('16100','2013-08-27','16:45:00',4.65),('16100','2013-08-27','16:50:00',3.08),('16100','2013-08-27','16:55:00',4.45),('16100','2013-08-27','17:00:00',4.21),('16100','2013-08-27','17:05:00',2.41),('16100','2013-08-27','17:10:00',3.01),('16100','2013-08-27','17:15:00',3.77),('16100','2013-08-27','17:20:00',1.89),('16100','2013-08-27','17:25:00',3.29),('16100','2013-08-27','17:30:00',3.63),('16100','2013-08-27','17:35:00',1.43),('16100','2013-08-27','17:40:00',1.85),('16100','2013-08-27','17:45:00',1.26),('16100','2013-08-27','17:50:00',1.36),('16100','2013-08-27','17:55:00',2.54),('16100','2013-08-27','18:00:00',1.38),('16100','2013-08-27','18:05:00',1.27),('16100','2013-08-27','18:10:00',1.61),('16100','2013-08-26','08:15:00',1.22),('16100','2013-08-26','08:20:00',1.58),('16100','2013-08-26','08:25:00',1.71),('16100','2013-08-26','08:30:00',1.57),('16100','2013-08-26','08:35:00',1.34),('16100','2013-08-26','08:40:00',1.51),('16100','2013-08-26','08:45:00',1.44),('16100','2013-08-26','08:50:00',2.03),('16100','2013-08-26','08:55:00',1.61),('16100','2013-08-26','09:00:00',1.54),('16100','2013-08-26','09:05:00',1.71),('16100','2013-08-26','09:10:00',2.96),('16100','2013-08-26','09:15:00',2.82),('16100','2013-08-26','09:20:00',3.06),('16100','2013-08-26','09:25:00',3.78),('16100','2013-08-26','09:30:00',4.12),('16100','2013-08-26','09:35:00',3.02),('16100','2013-08-26','09:40:00',2.52),('16100','2013-08-26','09:45:00',2.47),('16100','2013-08-26','09:50:00',3.04),('16100','2013-08-26','09:55:00',2.97),('16100','2013-08-26','10:00:00',3.88),('16100','2013-08-26','10:05:00',4.05),('16100','2013-08-26','10:10:00',5.19),('16100','2013-08-26','10:15:00',5.21),('16100','2013-08-26','10:20:00',5.26),('16100','2013-08-26','10:25:00',5.37),('16100','2013-08-26','10:30:00',5.46),('16100','2013-08-26','10:35:00',5.57),('16100','2013-08-26','10:40:00',5.7),('16100','2013-08-26','10:45:00',5.7),('16100','2013-08-26','10:50:00',5.91),('16100','2013-08-26','10:55:00',6.05),('16100','2013-08-26','11:00:00',6.04),('16100','2013-08-26','11:05:00',6.16),('16100','2013-08-26','11:10:00',6.14),('16100','2013-08-26','11:15:00',6.21),('16100','2013-08-26','11:20:00',6.28),('16100','2013-08-26','11:25:00',6.33),('16100','2013-08-26','11:30:00',5.89),('16100','2013-08-26','11:35:00',6.4),('16100','2013-08-26','11:40:00',5.87),('16100','2013-08-26','11:45:00',2.69),('16100','2013-08-26','11:50:00',4.13),('16100','2013-08-26','11:55:00',5.9),('16100','2013-08-26','12:00:00',3.16),('16100','2013-08-26','12:05:00',3.31),('16100','2013-08-26','12:10:00',5.05),('16100','2013-08-26','12:15:00',5.34),('16100','2013-08-26','12:20:00',6.91),('16100','2013-08-26','12:25:00',7.48),('16100','2013-08-26','12:30:00',7.27),('16100','2013-08-26','12:35:00',7.38),('16100','2013-08-26','12:40:00',7.77),('16100','2013-08-26','12:45:00',5.41),('16100','2013-08-26','12:50:00',5.15),('16100','2013-08-26','12:55:00',2.74),('16100','2013-08-26','13:00:00',2.45),('16100','2013-08-26','13:05:00',2.77),('16100','2013-08-26','13:10:00',3.3),('16100','2013-08-26','13:15:00',2.95),('16100','2013-08-26','13:20:00',4.25),('16100','2013-08-26','13:25:00',4.68),('16100','2013-08-26','13:30:00',4.19),('16100','2013-08-26','13:35:00',3.72),('16100','2013-08-26','13:40:00',3.46),('16100','2013-08-26','13:45:00',4.9),('16100','2013-08-26','13:50:00',4.52),('16100','2013-08-26','13:55:00',5.31),('16100','2013-08-26','14:00:00',4.93),('16100','2013-08-26','14:05:00',3.83),('16100','2013-08-26','14:10:00',5.79),('16100','2013-08-26','14:15:00',5.34),('16100','2013-08-26','14:20:00',4.15),('16100','2013-08-26','14:25:00',2.8),('16100','2013-08-26','14:30:00',2.02),('16100','2013-08-26','14:35:00',2.09),('16100','2013-08-26','14:40:00',2.27),('16100','2013-08-26','14:45:00',1.95),('16100','2013-08-26','14:50:00',1.51),('16100','2013-08-26','14:55:00',1.34),('16100','2013-08-26','15:00:00',1.47),('16100','2013-08-26','15:05:00',1.49),('16100','2013-08-26','15:10:00',1.34),('16100','2013-08-26','15:15:00',1.16),('16100','2013-08-26','16:00:00',1.19),('16100','2013-08-26','16:05:00',2.53),('16100','2013-08-26','16:10:00',5.28),('16100','2013-08-26','16:15:00',5.12),('16100','2013-08-26','16:20:00',2.73),('16100','2013-08-26','16:25:00',1.21),('16100','2013-08-26','16:30:00',2.89),('16100','2013-08-26','16:35:00',1.33),('16100','2013-08-26','16:40:00',1.56),('16100','2013-08-26','16:45:00',1.77),('16100','2013-08-26','16:50:00',1.84),('16100','2013-08-26','16:55:00',1.78),('16100','2013-08-26','17:00:00',1.7),('16100','2013-08-26','17:05:00',2.97),('16100','2013-08-26','17:10:00',1.84),('16100','2013-08-26','17:20:00',1.22),('16100','2013-08-26','17:25:00',1.1),('16100','2013-08-26','17:35:00',1.57),('16100','2013-08-26','17:40:00',1.23),('16100','2013-08-26','17:45:00',1.52),('16100','2013-08-26','17:50:00',1.27),('16100','2013-08-26','17:55:00',1.97),('16100','2013-08-26','18:00:00',1.68),('16100','2013-08-25','08:00:00',1.25),('16100','2013-08-25','08:05:00',1.12),('16100','2013-08-25','08:15:00',1.32),('16100','2013-08-25','08:20:00',1.34),('16100','2013-08-25','08:25:00',2.1),('16100','2013-08-25','08:30:00',2.07),('16100','2013-08-25','08:35:00',2.2),('16100','2013-08-25','08:40:00',2.44),('16100','2013-08-25','08:45:00',2.59),('16100','2013-08-25','08:50:00',2.78),('16100','2013-08-25','08:55:00',2.96),('16100','2013-08-25','09:00:00',3.11),('16100','2013-08-25','09:05:00',3.27),('16100','2013-08-25','09:10:00',3.47),('16100','2013-08-25','09:15:00',3.65),('16100','2013-08-25','09:20:00',3.77),('16100','2013-08-25','09:25:00',3.89),('16100','2013-08-25','09:30:00',4.03),('16100','2013-08-25','09:35:00',4.15),('16100','2013-08-25','09:40:00',4.35),('16100','2013-08-25','09:45:00',4.49),('16100','2013-08-25','09:50:00',4.54),('16100','2013-08-25','09:55:00',4.7),('16100','2013-08-25','10:00:00',4.85),('16100','2013-08-25','10:05:00',4.98),('16100','2013-08-25','10:10:00',5.08),('16100','2013-08-25','10:15:00',5.15),('16100','2013-08-25','10:20:00',5.35),('16100','2013-08-25','10:25:00',5.65),('16100','2013-08-25','10:30:00',5.57),('16100','2013-08-25','10:35:00',5.7),('16100','2013-08-25','10:40:00',5.83),('16100','2013-08-25','10:45:00',5.88),('16100','2013-08-25','10:50:00',5.96),('16100','2013-08-25','10:55:00',6.02),('16100','2013-08-25','11:00:00',6.12),('16100','2013-08-25','11:05:00',6.2),('16100','2013-08-25','11:10:00',6.35),('16100','2013-08-25','11:15:00',6.46),('16100','2013-08-25','11:20:00',6.54),('16100','2013-08-25','11:25:00',6.54),('16100','2013-08-25','11:30:00',6.64),('16100','2013-08-25','11:35:00',6.69),('16100','2013-08-25','11:40:00',6.78),('16100','2013-08-25','11:45:00',6.86),('16100','2013-08-25','11:50:00',6.92),('16100','2013-08-25','11:55:00',6.91),('16100','2013-08-25','12:00:00',6.92),('16100','2013-08-25','12:05:00',6.89),('16100','2013-08-25','12:10:00',6.95),('16100','2013-08-25','12:15:00',7.04),('16100','2013-08-25','12:20:00',7.1),('16100','2013-08-25','12:25:00',7.06),('16100','2013-08-25','12:30:00',7.11),('16100','2013-08-25','12:35:00',7.25),('16100','2013-08-25','12:40:00',6.76),('16100','2013-08-25','12:45:00',7.59),('16100','2013-08-25','12:50:00',7.52),('16100','2013-08-25','12:55:00',7.55),('16100','2013-08-25','13:00:00',5.62),('16100','2013-08-25','13:05:00',4.64),('16100','2013-08-25','13:10:00',3.17),('16100','2013-08-25','13:15:00',2.93),('16100','2013-08-25','13:20:00',4.12),('16100','2013-08-25','13:25:00',3.15),('16100','2013-08-25','13:30:00',4.55),('16100','2013-08-25','13:35:00',5.05),('16100','2013-08-25','13:40:00',6.84),('16100','2013-08-25','13:45:00',7.45),('16100','2013-08-25','13:50:00',4.3),('16100','2013-08-25','13:55:00',5.45),('16100','2013-08-25','14:00:00',5.49),('16100','2013-08-25','14:05:00',6.79),('16100','2013-08-25','14:10:00',4.83),('16100','2013-08-25','14:15:00',4.85),('16100','2013-08-25','14:20:00',7.02),('16100','2013-08-25','14:25:00',6.86),('16100','2013-08-25','14:30:00',6.95),('16100','2013-08-25','14:35:00',6.88),('16100','2013-08-25','14:40:00',6.92),('16100','2013-08-25','14:45:00',4.78),('16100','2013-08-25','14:50:00',4.55),('16100','2013-08-25','14:55:00',3.22),('16100','2013-08-25','15:00:00',3.46),('16100','2013-08-25','15:05:00',2.17),('16100','2013-08-25','15:10:00',1.83),('16100','2013-08-25','15:15:00',1.49),('16100','2013-08-25','15:20:00',1.3),('16100','2013-08-25','15:25:00',1.34),('16100','2013-08-25','15:30:00',1.44),('16100','2013-08-25','15:35:00',1.79),('16100','2013-08-25','15:40:00',3.28),('16100','2013-08-25','15:45:00',2.57),('16100','2013-08-25','15:50:00',2.53),('16100','2013-08-25','15:55:00',3.31),('16100','2013-08-25','16:00:00',5.06),('16100','2013-08-25','16:05:00',5.8),('16100','2013-08-25','16:10:00',4.96),('16100','2013-08-25','16:15:00',5.03),('16100','2013-08-25','16:20:00',4.9),('16100','2013-08-25','16:25:00',4.74),('16100','2013-08-25','16:30:00',4.63),('16100','2013-08-25','16:35:00',4.52),('16100','2013-08-25','16:40:00',4.41),('16100','2013-08-25','16:45:00',4.17),('16100','2013-08-25','16:50:00',4.11),('16100','2013-08-25','16:55:00',3.94),('16100','2013-08-25','17:00:00',3.34),('16100','2013-08-25','17:05:00',3.6),('16100','2013-08-25','17:10:00',3.47),('16100','2013-08-25','17:15:00',3.29),('16100','2013-08-25','17:20:00',2.3),('16100','2013-08-25','17:25:00',1.79),('16100','2013-08-25','17:30:00',2.26),('16100','2013-08-25','17:35:00',1.65),('16100','2013-08-25','17:40:00',1.48),('16100','2013-08-25','17:45:00',2.47),('16100','2013-08-25','17:50:00',2.53),('16100','2013-08-25','17:55:00',2.3),('16100','2013-08-25','18:00:00',1.95),('16100','2013-08-25','18:05:00',1.71),('16100','2013-08-25','18:10:00',1.54),('16100','2013-08-25','18:15:00',1.36),('16100','2013-08-25','18:20:00',1.22),('16100','2013-08-25','18:25:00',1.07),('16100','2013-08-24','08:00:00',1.11),('16100','2013-08-24','08:05:00',1.35),('16100','2013-08-24','08:10:00',1.45),('16100','2013-08-24','08:15:00',1.37),('16100','2013-08-24','08:20:00',1.6),('16100','2013-08-24','08:25:00',1.65),('16100','2013-08-24','08:30:00',1.89),('16100','2013-08-24','08:35:00',2.21),('16100','2013-08-24','08:40:00',1.93),('16100','2013-08-24','08:45:00',1.61),('16100','2013-08-24','08:50:00',1.65),('16100','2013-08-24','08:55:00',2.59),('16100','2013-08-24','09:00:00',3.15),('16100','2013-08-24','09:05:00',2.76),('16100','2013-08-24','09:10:00',2.91),('16100','2013-08-24','09:15:00',3.41),('16100','2013-08-24','09:20:00',3.23),('16100','2013-08-24','09:25:00',4.07),('16100','2013-08-24','09:30:00',4.34),('16100','2013-08-24','09:35:00',4.75),('16100','2013-08-24','09:40:00',5.19),('16100','2013-08-24','09:45:00',4.71),('16100','2013-08-24','09:50:00',5.34),('16100','2013-08-24','09:55:00',3.37),('16100','2013-08-24','10:00:00',2.01),('16100','2013-08-24','10:05:00',1.2),('16100','2013-08-24','15:00:00',1.31),('16100','2013-08-24','15:05:00',1.63),('16100','2013-08-24','15:10:00',1.76),('16100','2013-08-24','15:15:00',2.07),('16100','2013-08-24','15:20:00',2.72),('16100','2013-08-24','15:25:00',2.79),('16100','2013-08-24','15:30:00',6.22),('16100','2013-08-24','15:35:00',6.71),('16100','2013-08-24','15:40:00',4.87),('16100','2013-08-24','15:45:00',3.94),('16100','2013-08-24','15:50:00',5.76),('16100','2013-08-24','15:55:00',6.63),('16100','2013-08-24','16:00:00',6.18),('16100','2013-08-24','16:05:00',5.34),('16100','2013-08-24','16:10:00',5.35),('16100','2013-08-24','16:15:00',5.12),('16100','2013-08-24','16:20:00',5.11),('16100','2013-08-24','16:25:00',4.98),('16100','2013-08-24','16:30:00',4.81),('16100','2013-08-24','16:35:00',4.68),('16100','2013-08-24','16:40:00',3.45),('16100','2013-08-24','16:45:00',2.64),('16100','2013-08-24','16:50:00',4.86),('16100','2013-08-24','16:55:00',4.42),('16100','2013-08-24','17:00:00',4.22),('16100','2013-08-24','17:05:00',4.07),('16100','2013-08-24','17:10:00',3.18),('16100','2013-08-24','17:15:00',3.52),('16100','2013-08-24','17:20:00',3.31),('16100','2013-08-24','17:25:00',3.14),('16100','2013-08-24','17:30:00',2.77),('16100','2013-08-24','17:35:00',2.4),('16100','2013-08-24','17:40:00',2.59),('16100','2013-08-24','17:45:00',2.46),('16100','2013-08-24','17:50:00',2.23),('16100','2013-08-24','17:55:00',1.34),('16100','2013-08-24','18:00:00',1.65),('16100','2013-08-24','18:05:00',1.59),('16100','2013-08-24','18:10:00',1.78),('16100','2013-08-24','18:15:00',1.69),('16100','2013-08-24','18:20:00',1.47),('16100','2013-08-24','18:25:00',1.13),('16100','2013-08-23','08:10:00',1.14),('16100','2013-08-23','08:15:00',1.35),('16100','2013-08-23','08:20:00',1.54),('16100','2013-08-23','08:25:00',1.75),('16100','2013-08-23','08:30:00',1.91),('16100','2013-08-23','08:35:00',2.06),('16100','2013-08-23','08:40:00',2.22),('16100','2013-08-23','08:45:00',2.41),('16100','2013-08-23','08:50:00',2.61),('16100','2013-08-23','08:55:00',2.72),('16100','2013-08-23','09:00:00',2.92),('16100','2013-08-23','09:05:00',3.06),('16100','2013-08-23','09:10:00',3.21),('16100','2013-08-23','09:15:00',3.34),('16100','2013-08-23','09:20:00',3.53),('16100','2013-08-23','09:25:00',3.7),('16100','2013-08-23','09:30:00',3.85),('16100','2013-08-23','09:35:00',3.99),('16100','2013-08-23','09:40:00',4.15),('16100','2013-08-23','09:45:00',4.33),('16100','2013-08-23','09:50:00',4.46),('16100','2013-08-23','09:55:00',4.6),('16100','2013-08-23','10:00:00',4.73),('16100','2013-08-23','10:05:00',4.88),('16100','2013-08-23','10:10:00',4.98),('16100','2013-08-23','10:15:00',5.05),('16100','2013-08-23','10:20:00',5.2),('16100','2013-08-23','10:25:00',5.29),('16100','2013-08-23','10:30:00',5.47),('16100','2013-08-23','10:35:00',5.57),('16100','2013-08-23','10:40:00',5.69),('16100','2013-08-23','10:45:00',5.78),('16100','2013-08-23','10:50:00',5.91),('16100','2013-08-23','10:55:00',5.99),('16100','2013-08-23','11:00:00',6.03),('16100','2013-08-23','11:05:00',6.11),('16100','2013-08-23','11:10:00',6.3),('16100','2013-08-23','11:15:00',6.31),('16100','2013-08-23','11:20:00',6.35),('16100','2013-08-23','11:25:00',6.36),('16100','2013-08-23','11:30:00',6.51),('16100','2013-08-23','11:35:00',6.61),('16100','2013-08-23','11:40:00',6.67),('16100','2013-08-23','11:45:00',6.74),('16100','2013-08-23','11:50:00',6.77),('16100','2013-08-23','11:55:00',6.88),('16100','2013-08-23','12:00:00',6.83),('16100','2013-08-23','12:05:00',7),('16100','2013-08-23','12:10:00',6.9),('16100','2013-08-23','12:15:00',6.97),('16100','2013-08-23','12:20:00',7.08),('16100','2013-08-23','12:25:00',7.12),('16100','2013-08-23','12:30:00',7.15),('16100','2013-08-23','12:35:00',7.12),('16100','2013-08-23','12:40:00',7.08),('16100','2013-08-23','12:45:00',7.12),('16100','2013-08-23','12:50:00',7.15),('16100','2013-08-23','12:55:00',7.19),('16100','2013-08-23','13:00:00',7.15),('16100','2013-08-23','13:05:00',7.21),('16100','2013-08-23','13:10:00',7.21),('16100','2013-08-23','13:15:00',7.2),('16100','2013-08-23','13:20:00',7.28),('16100','2013-08-23','13:25:00',7.3),('16100','2013-08-23','13:30:00',7.32),('16100','2013-08-23','13:35:00',7.32),('16100','2013-08-23','13:40:00',7.27),('16100','2013-08-23','13:45:00',7.26),('16100','2013-08-23','13:50:00',7.26),('16100','2013-08-23','13:55:00',7.19),('16100','2013-08-23','14:00:00',7.16),('16100','2013-08-23','14:05:00',7.1),('16100','2013-08-23','14:10:00',7),('16100','2013-08-23','14:15:00',7),('16100','2013-08-23','14:20:00',6.95),('16100','2013-08-23','14:25:00',6.95),('16100','2013-08-23','14:30:00',6.9),('16100','2013-08-23','14:35:00',6.83),('16100','2013-08-23','14:40:00',6.77),('16100','2013-08-23','14:45:00',6.75),('16100','2013-08-23','14:50:00',6.69),('16100','2013-08-23','14:55:00',6.67),('16100','2013-08-23','15:00:00',6.61),('16100','2013-08-23','15:05:00',6.55),('16100','2013-08-23','15:10:00',6.46),('16100','2013-08-23','15:15:00',6.36),('16100','2013-08-23','15:20:00',6.24),('16100','2013-08-23','15:25:00',6.17),('16100','2013-08-23','15:30:00',6.03),('16100','2013-08-23','15:35:00',5.95),('16100','2013-08-23','15:40:00',5.84),('16100','2013-08-23','15:45:00',5.73),('16100','2013-08-23','15:50:00',5.68),('16100','2013-08-23','15:55:00',5.58),('16100','2013-08-23','16:00:00',5.49),('16100','2013-08-23','16:05:00',5.4),('16100','2013-08-23','16:10:00',5.28),('16100','2013-08-23','16:15:00',4.99),('16100','2013-08-23','16:20:00',5.01),('16100','2013-08-23','16:25:00',4.88),('16100','2013-08-23','16:30:00',4.76),('16100','2013-08-23','16:35:00',4.64),('16100','2013-08-23','16:40:00',4.52),('16100','2013-08-23','16:45:00',4.37),('16100','2013-08-23','16:50:00',4.25),('16100','2013-08-23','16:55:00',4.1),('16100','2013-08-23','17:00:00',3.93),('16100','2013-08-23','17:05:00',3.79),('16100','2013-08-23','17:10:00',3.65),('16100','2013-08-23','17:15:00',3.49),('16100','2013-08-23','17:20:00',3.33),('16100','2013-08-23','17:25:00',3.15),('16100','2013-08-23','17:30:00',3),('16100','2013-08-23','17:35:00',2.86),('16100','2013-08-23','17:40:00',2.69),('16100','2013-08-23','17:45:00',2.5),('16100','2013-08-23','17:50:00',2.35),('16100','2013-08-23','17:55:00',2.18),('16100','2013-08-23','18:00:00',2.02),('16100','2013-08-23','18:05:00',1.86),('16100','2013-08-23','18:10:00',1.72),('16100','2013-08-23','18:15:00',1.57),('16100','2013-08-23','18:20:00',1.41),('16100','2013-08-23','18:25:00',1.26),('16100','2013-08-23','18:30:00',1.11),('16100','2013-08-22','08:10:00',1.12),('16100','2013-08-22','08:15:00',1.28),('16100','2013-08-22','08:20:00',1.46),('16100','2013-08-22','08:25:00',1.66),('16100','2013-08-22','08:30:00',1.79),('16100','2013-08-22','08:35:00',1.96),('16100','2013-08-22','08:40:00',2.1),('16100','2013-08-22','08:45:00',2.28),('16100','2013-08-22','08:50:00',2.4),('16100','2013-08-22','08:55:00',2.61),('16100','2013-08-22','09:00:00',2.69),('16100','2013-08-22','09:05:00',2.83),('16100','2013-08-22','09:10:00',3.06),('16100','2013-08-22','09:15:00',3.14),('16100','2013-08-22','09:20:00',3.29),('16100','2013-08-22','09:25:00',3.44),('16100','2013-08-22','09:30:00',3.55),('16100','2013-08-22','09:35:00',3.68),('16100','2013-08-22','09:40:00',3.85),('16100','2013-08-22','09:45:00',3.98),('16100','2013-08-22','09:50:00',4.06),('16100','2013-08-22','09:55:00',4.17),('16100','2013-08-22','10:00:00',4.32),('16100','2013-08-22','10:05:00',4.48),('16100','2013-08-22','10:10:00',4.59),('16100','2013-08-22','10:15:00',4.68),('16100','2013-08-22','10:20:00',4.81),('16100','2013-08-22','10:25:00',4.95),('16100','2013-08-22','10:30:00',5.03),('16100','2013-08-22','10:35:00',5.09),('16100','2013-08-22','10:40:00',4.15),('16100','2013-08-22','10:45:00',5.21),('16100','2013-08-22','10:50:00',5.3),('16100','2013-08-22','10:55:00',5.27),('16100','2013-08-22','11:00:00',5.32),('16100','2013-08-22','11:05:00',5.02),('16100','2013-08-22','11:10:00',6.08),('16100','2013-08-22','11:15:00',6.06),('16100','2013-08-22','11:20:00',6.3),('16100','2013-08-22','11:25:00',6.4),('16100','2013-08-22','11:30:00',6.48),('16100','2013-08-22','11:35:00',3.86),('16100','2013-08-22','11:40:00',6.33),('16100','2013-08-22','11:45:00',6.42),('16100','2013-08-22','11:50:00',6.7),('16100','2013-08-22','11:55:00',6.94),('16100','2013-08-22','12:00:00',7.14),('16100','2013-08-22','12:05:00',5.18),('16100','2013-08-22','12:10:00',3.21),('16100','2013-08-22','12:15:00',2.09),('16100','2013-08-22','12:20:00',3.25),('16100','2013-08-22','12:25:00',7.67),('16100','2013-08-22','12:30:00',3.29),('16100','2013-08-22','12:35:00',3.68),('16100','2013-08-22','12:40:00',7.11),('16100','2013-08-22','12:45:00',7.37),('16100','2013-08-22','12:50:00',7.53),('16100','2013-08-22','12:55:00',7.28),('16100','2013-08-22','13:00:00',7.22),('16100','2013-08-22','13:05:00',7.28),('16100','2013-08-22','13:10:00',7.33),('16100','2013-08-22','13:15:00',7.24),('16100','2013-08-22','13:20:00',7.29),('16100','2013-08-22','13:25:00',7.22),('16100','2013-08-22','13:30:00',7.29),('16100','2013-08-22','13:35:00',7.3),('16100','2013-08-22','13:40:00',7.23),('16100','2013-08-22','13:45:00',7.21),('16100','2013-08-22','13:50:00',7.22),('16100','2013-08-22','13:55:00',7.22),('16100','2013-08-22','14:00:00',7.17),('16100','2013-08-22','14:05:00',7.08),('16100','2013-08-22','14:10:00',6.99),('16100','2013-08-22','14:15:00',7.01),('16100','2013-08-22','14:20:00',6.95),('16100','2013-08-22','14:25:00',6.92),('16100','2013-08-22','14:30:00',6.86),('16100','2013-08-22','14:35:00',6.82),('16100','2013-08-22','14:40:00',6.77),('16100','2013-08-22','14:45:00',6.72),('16100','2013-08-22','14:50:00',6.65),('16100','2013-08-22','14:55:00',6.25),('16100','2013-08-22','15:00:00',6.33),('16100','2013-08-22','15:05:00',6.29),('16100','2013-08-22','15:10:00',6.1),('16100','2013-08-22','15:15:00',5.22),('16100','2013-08-22','15:20:00',5.25),('16100','2013-08-22','15:25:00',6.01),('16100','2013-08-22','15:30:00',5.71),('16100','2013-08-22','15:35:00',5.96),('16100','2013-08-22','15:40:00',5.66),('16100','2013-08-22','15:45:00',5.18),('16100','2013-08-22','15:50:00',5.1),('16100','2013-08-22','15:55:00',5.02),('16100','2013-08-22','16:00:00',4.88),('16100','2013-08-22','16:05:00',4.88),('16100','2013-08-22','16:10:00',4.48),('16100','2013-08-22','16:15:00',4.32),('16100','2013-08-22','16:20:00',4.69),('16100','2013-08-22','16:25:00',4.44),('16100','2013-08-22','16:30:00',4.2),('16100','2013-08-22','16:35:00',4.58),('16100','2013-08-22','16:40:00',4.6),('16100','2013-08-22','16:45:00',4.47),('16100','2013-08-22','16:50:00',4.25),('16100','2013-08-22','16:55:00',4.03),('16100','2013-08-22','17:00:00',3.83),('16100','2013-08-22','17:05:00',3.7),('16100','2013-08-22','17:10:00',3.54),('16100','2013-08-22','17:15:00',3.42),('16100','2013-08-22','17:20:00',3.26),('16100','2013-08-22','17:25:00',3.06),('16100','2013-08-22','17:30:00',2.9),('16100','2013-08-22','17:35:00',2.75),('16100','2013-08-22','17:40:00',2.55),('16100','2013-08-22','17:45:00',2.44),('16100','2013-08-22','17:50:00',2.31),('16100','2013-08-22','17:55:00',1.54),('16100','2013-08-22','18:00:00',1.5),('16100','2013-08-22','18:05:00',1.85),('16100','2013-08-22','18:10:00',1.73),('16100','2013-08-22','18:15:00',1.55),('16100','2013-08-22','18:20:00',1.44),('16100','2013-08-22','18:25:00',1.31),('16100','2013-08-22','18:30:00',1.15),('16100','2013-08-22','18:35:00',1.02),('16100','2013-08-21','08:05:00',1.02),('16100','2013-08-21','08:10:00',1.16),('16100','2013-08-21','08:15:00',1.35),('16100','2013-08-21','08:20:00',1.54),('16100','2013-08-21','08:25:00',1.74),('16100','2013-08-21','08:30:00',1.87),('16100','2013-08-21','08:35:00',2.06),('16100','2013-08-21','08:40:00',2.25),('16100','2013-08-21','08:45:00',2.44),('16100','2013-08-21','08:50:00',2.65),('16100','2013-08-21','08:55:00',2.83),('16100','2013-08-21','09:00:00',2.92),('16100','2013-08-21','09:05:00',3.16),('16100','2013-08-21','09:10:00',3.29),('16100','2013-08-21','09:15:00',3.5),('16100','2013-08-21','09:20:00',3.69),('16100','2013-08-21','09:25:00',3.93),('16100','2013-08-21','09:30:00',4.08),('16100','2013-08-21','09:35:00',4.15),('16100','2013-08-21','09:40:00',4.22),('16100','2013-08-21','09:45:00',4.31),('16100','2013-08-21','09:50:00',4.45),('16100','2013-08-21','09:55:00',3.67),('16100','2013-08-21','10:00:00',2.75),('16100','2013-08-21','10:05:00',3.81),('16100','2013-08-21','10:10:00',4.33),('16100','2013-08-21','10:15:00',5.23),('16100','2013-08-21','10:20:00',5.04),('16100','2013-08-21','10:25:00',5.55),('16100','2013-08-21','10:30:00',5.68),('16100','2013-08-21','10:35:00',5.74),('16100','2013-08-21','10:40:00',5.76),('16100','2013-08-21','10:45:00',5.75),('16100','2013-08-21','10:50:00',5.83),('16100','2013-08-21','10:55:00',5.91),('16100','2013-08-21','11:00:00',5.95),('16100','2013-08-21','11:05:00',6.02),('16100','2013-08-21','11:10:00',6.16),('16100','2013-08-21','11:15:00',6.24),('16100','2013-08-21','11:20:00',6.34),('16100','2013-08-21','11:25:00',6.38),('16100','2013-08-21','11:30:00',6.44),('16100','2013-08-21','11:35:00',6.5),('16100','2013-08-21','11:40:00',6.53),('16100','2013-08-21','11:45:00',6.6),('16100','2013-08-21','11:50:00',6.61),('16100','2013-08-21','11:55:00',6.65),('16100','2013-08-21','12:00:00',6.68),('16100','2013-08-21','12:05:00',6.73),('16100','2013-08-21','12:10:00',6.77),('16100','2013-08-21','12:15:00',6.77),('16100','2013-08-21','12:20:00',6.77),('16100','2013-08-21','12:25:00',6.84),('16100','2013-08-21','12:30:00',6.84),('16100','2013-08-21','12:35:00',6.84),('16100','2013-08-21','12:40:00',6.87),('16100','2013-08-21','12:45:00',6.83),('16100','2013-08-21','12:50:00',6.84),('16100','2013-08-21','12:55:00',6.91),('16100','2013-08-21','13:00:00',6.88),('16100','2013-08-21','13:05:00',6.86),('16100','2013-08-21','13:10:00',6.87),('16100','2013-08-21','13:15:00',6.87),('16100','2013-08-21','13:20:00',6.84),('16100','2013-08-21','13:25:00',6.78),('16100','2013-08-21','13:30:00',6.76),('16100','2013-08-21','13:35:00',6.76),('16100','2013-08-21','13:40:00',6.77),('16100','2013-08-21','13:45:00',6.64),('16100','2013-08-21','13:50:00',6.68),('16100','2013-08-21','13:55:00',6.69),('16100','2013-08-21','14:00:00',6.75),('16100','2013-08-21','14:05:00',6.79),('16100','2013-08-21','14:10:00',6.66),('16100','2013-08-21','14:15:00',6.67),('16100','2013-08-21','14:20:00',6.67),('16100','2013-08-21','14:25:00',6.57),('16100','2013-08-21','14:30:00',6.56),('16100','2013-08-21','14:35:00',6.55),('16100','2013-08-21','14:40:00',6.47),('16100','2013-08-21','14:45:00',6.21),('16100','2013-08-21','14:50:00',4.59),('16100','2013-08-21','14:55:00',6.27),('16100','2013-08-21','15:00:00',4.18),('16100','2013-08-21','15:05:00',5.71),('16100','2013-08-21','15:10:00',6.13),('16100','2013-08-21','15:15:00',6.11),('16100','2013-08-21','15:20:00',6.01),('16100','2013-08-21','15:25:00',5.93),('16100','2013-08-21','15:30:00',5.81),('16100','2013-08-21','15:35:00',5.72),('16100','2013-08-21','15:40:00',5.64),('16100','2013-08-21','15:45:00',5.52),('16100','2013-08-21','15:50:00',5.46),('16100','2013-08-21','15:55:00',5.35),('16100','2013-08-21','16:00:00',5.26),('16100','2013-08-21','16:05:00',5.15),('16100','2013-08-21','16:10:00',5.02),('16100','2013-08-21','16:15:00',4.81),('16100','2013-08-21','16:20:00',4.73),('16100','2013-08-21','16:25:00',4.64),('16100','2013-08-21','16:30:00',4.55),('16100','2013-08-21','16:35:00',4.36),('16100','2013-08-21','16:40:00',4.18),('16100','2013-08-21','16:45:00',4.03),('16100','2013-08-21','16:50:00',3.94),('16100','2013-08-21','16:55:00',3.84),('16100','2013-08-21','17:00:00',3.65),('16100','2013-08-21','17:05:00',3.5),('16100','2013-08-21','17:10:00',3.34),('16100','2013-08-21','17:15:00',3.25),('16100','2013-08-21','17:20:00',3.09),('16100','2013-08-21','17:25:00',2.91),('16100','2013-08-21','17:30:00',2.75),('16100','2013-08-21','17:35:00',2.61),('16100','2013-08-21','17:40:00',2.45),('16100','2013-08-21','17:45:00',2.27),('16100','2013-08-21','17:50:00',2.14),('16100','2013-08-21','17:55:00',2.03),('16100','2013-08-21','18:00:00',1.88),('16100','2013-08-21','18:05:00',1.74),('16100','2013-08-21','18:10:00',1.63),('16100','2013-08-21','18:15:00',1.55),('16100','2013-08-21','18:20:00',1.39),('16100','2013-08-21','18:25:00',1.22),('16100','2013-08-21','18:30:00',1),('16100','2013-08-20','08:30:00',1.18),('16100','2013-08-20','08:35:00',1.25),('16100','2013-08-20','08:40:00',1.37),('16100','2013-08-20','08:45:00',1.13),('16100','2013-08-20','08:50:00',1.08),('16100','2013-08-20','08:55:00',1.08),('16100','2013-08-20','09:00:00',1.19),('16100','2013-08-20','09:05:00',1.37),('16100','2013-08-20','09:10:00',1.91),('16100','2013-08-20','09:15:00',2.18),('16100','2013-08-20','09:20:00',3.28),('16100','2013-08-20','09:25:00',3.42),('16100','2013-08-20','09:30:00',1.67),('16100','2013-08-20','09:35:00',1.14),('16100','2013-08-20','09:40:00',1.15),('16100','2013-08-20','09:45:00',1.48),('16100','2013-08-20','09:50:00',1.66),('16100','2013-08-20','09:55:00',2.2),('16100','2013-08-20','10:00:00',3.46),('16100','2013-08-20','10:05:00',5.45),('16100','2013-08-20','10:10:00',5.24),('16100','2013-08-20','10:15:00',5.03),('16100','2013-08-20','10:20:00',5.24),('16100','2013-08-20','10:25:00',5.52),('16100','2013-08-20','10:30:00',4.61),('16100','2013-08-20','10:35:00',5.55),('16100','2013-08-20','10:40:00',5.64),('16100','2013-08-20','10:45:00',6.03),('16100','2013-08-20','10:50:00',5.65),('16100','2013-08-20','10:55:00',6.4),('16100','2013-08-20','11:00:00',5.35),('16100','2013-08-20','11:05:00',4.07),('16100','2013-08-20','11:10:00',4.31),('16100','2013-08-20','11:15:00',2.75),('16100','2013-08-20','11:20:00',3.03),('16100','2013-08-20','11:25:00',5.3),('16100','2013-08-20','11:30:00',8.27),('16100','2013-08-20','11:35:00',6.01),('16100','2013-08-20','11:40:00',7.5),('16100','2013-08-20','11:45:00',7.13),('16100','2013-08-20','11:50:00',6.81),('16100','2013-08-20','11:55:00',7.12),('16100','2013-08-20','12:00:00',6.77),('16100','2013-08-20','12:05:00',7.1),('16100','2013-08-20','12:10:00',7.12),('16100','2013-08-20','12:15:00',7.15),('16100','2013-08-20','12:20:00',7.19),('16100','2013-08-20','12:25:00',7.02),('16100','2013-08-20','12:30:00',7.27),('16100','2013-08-20','12:35:00',6.95),('16100','2013-08-20','12:40:00',6.54),('16100','2013-08-20','12:45:00',5.5),('16100','2013-08-20','12:50:00',6.58),('16100','2013-08-20','12:55:00',6.94),('16100','2013-08-20','13:00:00',6.7),('16100','2013-08-20','13:05:00',6.63),('16100','2013-08-20','13:10:00',6.77),('16100','2013-08-20','13:15:00',7.09),('16100','2013-08-20','13:20:00',7.21),('16100','2013-08-20','13:25:00',7.09),('16100','2013-08-20','13:30:00',7),('16100','2013-08-20','13:35:00',6.98),('16100','2013-08-20','13:40:00',6.93),('16100','2013-08-20','13:45:00',7.08),('16100','2013-08-20','13:50:00',7.04),('16100','2013-08-20','13:55:00',7.12),('16100','2013-08-20','14:00:00',7.18),('16100','2013-08-20','14:05:00',7.11),('16100','2013-08-20','14:10:00',6.88),('16100','2013-08-20','14:15:00',5.91),('16100','2013-08-20','14:20:00',4.03),('16100','2013-08-20','14:25:00',5.58),('16100','2013-08-20','14:30:00',4.28),('16100','2013-08-20','14:35:00',5.95),('16100','2013-08-20','14:40:00',6.31),('16100','2013-08-20','14:45:00',6.18),('16100','2013-08-20','14:50:00',6.18),('16100','2013-08-20','14:55:00',5.89),('16100','2013-08-20','15:00:00',6.23),('16100','2013-08-20','15:05:00',6.32),('16100','2013-08-20','15:10:00',6.27),('16100','2013-08-20','15:15:00',6.19),('16100','2013-08-20','15:20:00',5.84),('16100','2013-08-20','15:25:00',5.6),('16100','2013-08-20','15:30:00',5.24),('16100','2013-08-20','15:35:00',5.19),('16100','2013-08-20','15:40:00',5.28),('16100','2013-08-20','15:45:00',5.01),('16100','2013-08-20','15:50:00',5.04),('16100','2013-08-20','15:55:00',4.88),('16100','2013-08-20','16:00:00',4.72),('16100','2013-08-20','16:05:00',4.51),('16100','2013-08-20','16:10:00',4.63),('16100','2013-08-20','16:15:00',4.93),('16100','2013-08-20','16:20:00',4.77),('16100','2013-08-20','16:25:00',4.83),('16100','2013-08-20','16:30:00',4.74),('16100','2013-08-20','16:35:00',4.66),('16100','2013-08-20','16:40:00',4.51),('16100','2013-08-20','16:45:00',4.33),('16100','2013-08-20','16:50:00',4.27),('16100','2013-08-20','16:55:00',4.17),('16100','2013-08-20','17:00:00',4.08),('16100','2013-08-20','17:05:00',3.88),('16100','2013-08-20','17:10:00',3.81),('16100','2013-08-20','17:15:00',3.67),('16100','2013-08-20','17:20:00',3.51),('16100','2013-08-20','17:25:00',3.39),('16100','2013-08-20','17:30:00',3.25),('16100','2013-08-20','17:35:00',3.1),('16100','2013-08-20','17:40:00',3.02),('16100','2013-08-20','17:45:00',2.89),('16100','2013-08-20','17:50:00',2.71),('16100','2013-08-20','17:55:00',2.54),('16100','2013-08-20','18:00:00',2.35),('16100','2013-08-20','18:05:00',2.21),('16100','2013-08-20','18:10:00',2.04),('16100','2013-08-20','18:15:00',1.91),('16100','2013-08-20','18:20:00',1.75),('16100','2013-08-20','18:25:00',1.44),('16100','2013-08-20','18:30:00',1.29),('16100','2013-08-20','18:35:00',1.18),('16100','2013-08-20','18:40:00',1.04),('16100','2013-08-19','07:50:00',1.19),('16100','2013-08-19','07:55:00',1.24),('16100','2013-08-19','08:00:00',1.1),('16100','2013-08-19','08:30:00',1.05),('16100','2013-08-19','08:35:00',1.1),('16100','2013-08-19','08:40:00',1.15),('16100','2013-08-19','08:45:00',1.3),('16100','2013-08-19','08:50:00',1.6),('16100','2013-08-19','08:55:00',1.69),('16100','2013-08-19','09:00:00',1.26),('16100','2013-08-19','09:10:00',1.19),('16100','2013-08-19','09:15:00',1.4),('16100','2013-08-19','09:20:00',2.75),('16100','2013-08-19','09:25:00',2.48),('16100','2013-08-19','09:30:00',4.32),('16100','2013-08-19','09:35:00',4.7),('16100','2013-08-19','09:40:00',3.62),('16100','2013-08-19','09:45:00',1.83),('16100','2013-08-19','09:50:00',1.1),('16100','2013-08-19','09:55:00',1.2),('16100','2013-08-19','10:00:00',2.48),('16100','2013-08-19','10:05:00',4),('16100','2013-08-19','10:10:00',2.13),('16100','2013-08-19','10:15:00',1.36),('16100','2013-08-19','10:20:00',1.65),('16100','2013-08-19','10:25:00',2.87),('16100','2013-08-19','10:30:00',3.04),('16100','2013-08-19','10:35:00',4.88),('16100','2013-08-19','10:40:00',6.77),('16100','2013-08-19','10:45:00',4.45),('16100','2013-08-19','11:00:00',1.64),('16100','2013-08-19','11:05:00',6.98),('16100','2013-08-19','11:10:00',7.06),('16100','2013-08-19','11:15:00',3.25),('16100','2013-08-19','11:20:00',5.33),('16100','2013-08-19','11:25:00',7.62),('16100','2013-08-19','11:30:00',6.07),('16100','2013-08-19','11:35:00',8.05),('16100','2013-08-19','11:40:00',7.16),('16100','2013-08-19','11:45:00',4.4),('16100','2013-08-19','11:50:00',3.51),('16100','2013-08-19','11:55:00',3.35),('16100','2013-08-19','12:00:00',3.07),('16100','2013-08-19','12:05:00',2.39),('16100','2013-08-19','12:10:00',2.41),('16100','2013-08-19','12:15:00',2.43),('16100','2013-08-19','12:20:00',2.43),('16100','2013-08-19','12:25:00',2.7),('16100','2013-08-19','12:30:00',3.02),('16100','2013-08-19','12:35:00',3.4),('16100','2013-08-19','12:40:00',6.42),('16100','2013-08-19','12:45:00',3.2),('16100','2013-08-19','12:50:00',4.64),('16100','2013-08-19','12:55:00',6.75),('16100','2013-08-19','13:00:00',3.14),('16100','2013-08-19','13:05:00',2.46),('16100','2013-08-19','13:10:00',2.58),('16100','2013-08-19','13:15:00',3.01),('16100','2013-08-19','13:20:00',2.87),('16100','2013-08-19','13:25:00',2.9),('16100','2013-08-19','13:30:00',3.38),('16100','2013-08-19','13:35:00',3.71),('16100','2013-08-19','13:40:00',3.91),('16100','2013-08-19','13:45:00',6.54),('16100','2013-08-19','13:50:00',7.68),('16100','2013-08-19','13:55:00',7.58),('16100','2013-08-19','14:00:00',7.51),('16100','2013-08-19','14:05:00',7.6),('16100','2013-08-19','14:10:00',7.21),('16100','2013-08-19','14:15:00',7.37),('16100','2013-08-19','14:20:00',3.8),('16100','2013-08-19','14:25:00',4.54),('16100','2013-08-19','14:30:00',5.8),('16100','2013-08-19','14:35:00',7.28),('16100','2013-08-19','14:40:00',7.71),('16100','2013-08-19','14:45:00',7.42),('16100','2013-08-19','14:50:00',5.26),('16100','2013-08-19','14:55:00',3.59),('16100','2013-08-19','15:00:00',7.31),('16100','2013-08-19','15:05:00',6.95),('16100','2013-08-19','15:10:00',6.9),('16100','2013-08-19','15:15:00',6.99),('16100','2013-08-19','15:20:00',7.07),('16100','2013-08-19','15:25:00',6.35),('16100','2013-08-19','15:30:00',5.81),('16100','2013-08-19','15:35:00',1.97),('16100','2013-08-19','15:40:00',4),('16100','2013-08-19','15:45:00',6.48),('16100','2013-08-19','15:50:00',6.44),('16100','2013-08-19','15:55:00',6.55),('16100','2013-08-19','16:00:00',6.42),('16100','2013-08-19','16:05:00',6.31),('16100','2013-08-19','16:10:00',6.36),('16100','2013-08-19','16:15:00',6.38),('16100','2013-08-19','16:20:00',6.27),('16100','2013-08-19','16:25:00',5.86),('16100','2013-08-19','16:30:00',5.5),('16100','2013-08-19','16:35:00',3.54),('16100','2013-08-19','16:40:00',4.81),('16100','2013-08-19','16:45:00',4.4),('16100','2013-08-19','16:50:00',4.17),('16100','2013-08-19','16:55:00',4.39),('16100','2013-08-19','17:00:00',4.28),('16100','2013-08-19','17:05:00',4.05),('16100','2013-08-19','17:10:00',3.88),('16100','2013-08-19','17:15:00',3.71),('16100','2013-08-19','17:20:00',3.56),('16100','2013-08-19','17:25:00',2.79),('16100','2013-08-19','17:30:00',3.24),('16100','2013-08-19','17:35:00',3.2),('16100','2013-08-19','17:40:00',3.05),('16100','2013-08-19','17:45:00',2.71),('16100','2013-08-19','17:50:00',2.44),('16100','2013-08-19','17:55:00',2.28),('16100','2013-08-19','18:00:00',2.17),('16100','2013-08-19','18:05:00',2.05),('16100','2013-08-19','18:10:00',1.96),('16100','2013-08-19','18:15:00',1.79),('16100','2013-08-19','18:20:00',1.67),('16100','2013-08-19','18:25:00',1.63),('16100','2013-08-19','18:30:00',1.54),('16100','2013-08-19','18:35:00',1.36),('16100','2013-08-19','18:40:00',1.29),('16100','2013-08-19','18:45:00',1.18),('16100','2013-08-19','18:50:00',1.06),('16100','2013-08-19','18:55:00',1.03),('16100','2014-04-09','08:05:00',1.12),('16100','2014-04-09','08:10:00',1.37),('16100','2014-04-09','08:15:00',1.56),('16100','2014-04-09','08:20:00',1.76),('16100','2014-04-09','08:25:00',1.95),('16100','2014-04-09','08:30:00',2.13),('16100','2014-04-09','08:35:00',2.32),('16100','2014-04-09','08:40:00',2.53),('16100','2014-04-09','08:45:00',2.71),('16100','2014-04-09','08:50:00',2.88),('16100','2014-04-09','08:55:00',3.04),('16100','2014-04-09','09:00:00',3.25),('16100','2014-04-09','09:05:00',3.43),('16100','2014-04-09','09:10:00',3.57),('16100','2014-04-09','09:15:00',3.66),('16100','2014-04-09','09:20:00',3.88),('16100','2014-04-09','09:25:00',4.12),('16100','2014-04-09','09:30:00',4.25),('16100','2014-04-09','09:35:00',4.38),('16100','2014-04-09','09:40:00',4.46),('16100','2014-04-09','09:45:00',4.67),('16100','2014-04-09','09:50:00',4.83),('16100','2014-04-09','09:55:00',4.96),('16100','2014-04-09','10:00:00',5.07),('16100','2014-04-09','10:05:00',5.18),('16100','2014-04-09','10:10:00',5.28),('16100','2014-04-09','10:15:00',5.32),('16100','2014-04-09','10:20:00',5.54),('16100','2014-04-09','10:25:00',5.69),('16100','2014-04-09','10:30:00',5.88),('16100','2014-04-09','10:35:00',6.12),('16100','2014-04-09','10:40:00',6.11),('16100','2014-04-09','10:45:00',6.16),('16100','2014-04-09','10:50:00',6.13),('16100','2014-04-09','10:55:00',6.29),('16100','2014-04-09','11:00:00',6.58),('16100','2014-04-09','11:05:00',6.44),('16100','2014-04-09','11:10:00',6.67),('16100','2014-04-09','11:15:00',6.75),('16100','2014-04-09','11:20:00',7.11),('16100','2014-04-09','11:25:00',7.17),('16100','2014-04-09','11:30:00',7.18),('16100','2014-04-09','11:35:00',7.14),('16100','2014-04-09','11:40:00',7.22),('16100','2014-04-09','11:45:00',7.22),('16100','2014-04-09','11:50:00',7.17),('16100','2014-04-09','11:55:00',7.26),('16100','2014-04-09','12:00:00',6.96),('16100','2014-04-09','12:05:00',6.87),('16100','2014-04-09','12:10:00',7.33),('16100','2014-04-09','12:15:00',7.31),('16100','2014-04-09','12:20:00',7.12),('16100','2014-04-09','12:25:00',6.86),('16100','2014-04-09','12:30:00',7.27),('16100','2014-04-09','12:35:00',7.43),('16100','2014-04-09','12:40:00',7.09),('16100','2014-04-09','12:45:00',7.22),('16100','2014-04-09','12:50:00',7.25),('16100','2014-04-09','12:55:00',7.42),('16100','2014-04-09','13:00:00',6.86),('16100','2014-04-09','13:05:00',7.1),('16100','2014-04-09','13:10:00',7.66),('16100','2014-04-09','13:15:00',7.24),('16100','2014-04-09','13:20:00',7),('16100','2014-04-09','13:25:00',7.37),('16100','2014-04-09','13:30:00',7.67),('16100','2014-04-09','13:35:00',7.61),('16100','2014-04-09','13:40:00',7.29),('16100','2014-04-09','13:45:00',7.59),('16100','2014-04-09','13:50:00',7.5),('16100','2014-04-09','13:55:00',7.45),('16100','2014-04-09','14:00:00',7.4),('16100','2014-04-09','14:05:00',7.15),('16100','2014-04-09','14:10:00',7.2),('16100','2014-04-09','14:15:00',7.29),('16100','2014-04-09','14:20:00',7.26),('16100','2014-04-09','14:25:00',7.15),('16100','2014-04-09','14:30:00',7.09),('16100','2014-04-09','14:35:00',7.06),('16100','2014-04-09','14:40:00',6.87),('16100','2014-04-09','14:45:00',6.27),('16100','2014-04-09','14:50:00',6.99),('16100','2014-04-09','14:55:00',6.84),('16100','2014-04-09','15:00:00',6.75),('16100','2014-04-09','15:05:00',6.72),('16100','2014-04-09','15:10:00',6.47),('16100','2014-04-09','15:15:00',6.48),('16100','2014-04-09','15:20:00',6.31),('16100','2014-04-09','15:25:00',6.18),('16100','2014-04-09','15:30:00',5.71),('16100','2014-04-09','15:35:00',5.4),('16100','2014-04-09','15:40:00',5.77),('16100','2014-04-09','15:45:00',5.69),('16100','2014-04-09','15:50:00',5.55),('16100','2014-04-09','15:55:00',5.76),('16100','2014-04-09','16:00:00',5.75),('16100','2014-04-09','16:05:00',5.77),('16100','2014-04-09','16:10:00',5.74),('16100','2014-04-09','16:15:00',5.58),('16100','2014-04-09','16:20:00',5.14),('16100','2014-04-09','16:25:00',5.26),('16100','2014-04-09','16:30:00',5.22),('16100','2014-04-09','16:35:00',4.91),('16100','2014-04-09','16:40:00',4.93),('16100','2014-04-09','16:45:00',4.61),('16100','2014-04-09','16:50:00',4.6),('16100','2014-04-09','16:55:00',4.36),('16100','2014-04-09','17:00:00',4.15),('16100','2014-04-09','17:05:00',4.11),('16100','2014-04-09','17:10:00',3.87),('16100','2014-04-09','17:15:00',3.72),('16100','2014-04-09','17:20:00',3.53),('16100','2014-04-09','17:25:00',3.32),('16100','2014-04-09','17:30:00',3.13),('16100','2014-04-09','17:35:00',2.94),('16100','2014-04-09','17:40:00',2.74),('16100','2014-04-09','17:45:00',2.57),('16100','2014-04-09','17:50:00',2.39),('16100','2014-04-09','17:55:00',2.22),('16100','2014-04-09','18:00:00',2.05),('16100','2014-04-09','18:05:00',1.88),('16100','2014-04-09','18:10:00',1.7),('16100','2014-04-09','18:15:00',1.53),('16100','2014-04-09','18:20:00',1.36),('16100','2014-04-09','18:25:00',1.19),('16100','2014-04-09','18:30:00',1.02),('16100','2013-08-18','07:55:00',1.02),('16100','2013-08-18','08:00:00',1.24),('16100','2013-08-18','08:05:00',1.27),('16100','2013-08-18','08:10:00',1.14),('16100','2013-08-18','08:15:00',1.26),('16100','2013-08-18','08:20:00',1.59),('16100','2013-08-18','08:25:00',1.78),('16100','2013-08-18','08:30:00',2.03),('16100','2013-08-18','08:35:00',2.24),('16100','2013-08-18','08:40:00',2.36),('16100','2013-08-18','08:45:00',2.55),('16100','2013-08-18','08:50:00',2.74),('16100','2013-08-18','08:55:00',2.9),('16100','2013-08-18','09:00:00',3.08),('16100','2013-08-18','09:05:00',3.21),('16100','2013-08-18','09:10:00',3.36),('16100','2013-08-18','09:15:00',3.53),('16100','2013-08-18','09:20:00',3.7),('16100','2013-08-18','09:25:00',3.83),('16100','2013-08-18','09:30:00',3.97),('16100','2013-08-18','09:35:00',4.13),('16100','2013-08-18','09:40:00',4.27),('16100','2013-08-18','09:45:00',4.38),('16100','2013-08-18','09:50:00',4.49),('16100','2013-08-18','09:55:00',4.62),('16100','2013-08-18','10:00:00',4.74),('16100','2013-08-18','10:05:00',4.82),('16100','2013-08-18','10:10:00',4.95),('16100','2013-08-18','10:15:00',5.05),('16100','2013-08-18','10:20:00',5.14),('16100','2013-08-18','10:25:00',5.29),('16100','2013-08-18','10:30:00',5.45),('16100','2013-08-18','10:35:00',5.55),('16100','2013-08-18','10:40:00',5.67),('16100','2013-08-18','10:45:00',5.75),('16100','2013-08-18','10:50:00',5.84),('16100','2013-08-18','10:55:00',5.88),('16100','2013-08-18','11:00:00',6),('16100','2013-08-18','11:05:00',6.1),('16100','2013-08-18','11:10:00',6.19),('16100','2013-08-18','11:15:00',5.09),('16100','2013-08-18','11:20:00',6.23),('16100','2013-08-18','11:25:00',6.42),('16100','2013-08-18','11:30:00',6.49),('16100','2013-08-18','11:35:00',6.55),('16100','2013-08-18','11:40:00',6.52),('16100','2013-08-18','11:45:00',6.56),('16100','2013-08-18','11:50:00',6.62),('16100','2013-08-18','11:55:00',6.7),('16100','2013-08-18','12:00:00',6.71),('16100','2013-08-18','12:05:00',6.74),('16100','2013-08-18','12:10:00',6.92),('16100','2013-08-18','12:15:00',7.05),('16100','2013-08-18','12:20:00',7.04),('16100','2013-08-18','12:25:00',6.95),('16100','2013-08-18','12:30:00',6.93),('16100','2013-08-18','12:35:00',7.1),('16100','2013-08-18','12:40:00',7.2),('16100','2013-08-18','12:45:00',7.19),('16100','2013-08-18','12:50:00',7.25),('16100','2013-08-18','12:55:00',7.23),('16100','2013-08-18','13:00:00',7.26),('16100','2013-08-18','13:05:00',7.31),('16100','2013-08-18','13:10:00',7.33),('16100','2013-08-18','13:15:00',7.38),('16100','2013-08-18','13:20:00',7.4),('16100','2013-08-18','13:25:00',7.42),('16100','2013-08-18','13:30:00',7.38),('16100','2013-08-18','13:35:00',7.31),('16100','2013-08-18','13:40:00',7.33),('16100','2013-08-18','13:45:00',7.33),('16100','2013-08-18','13:50:00',7.27),('16100','2013-08-18','13:55:00',7.25),('16100','2013-08-18','14:00:00',7.22),('16100','2013-08-18','14:05:00',7.19),('16100','2013-08-18','14:10:00',7.07),('16100','2013-08-18','14:15:00',7.09),('16100','2013-08-18','14:20:00',7.11),('16100','2013-08-18','14:25:00',7),('16100','2013-08-18','14:30:00',6.85),('16100','2013-08-18','14:35:00',6.93),('16100','2013-08-18','14:40:00',6.85),('16100','2013-08-18','14:45:00',6.8),('16100','2013-08-18','14:50:00',6.83),('16100','2013-08-18','14:55:00',6.74),('16100','2013-08-18','15:00:00',6.68),('16100','2013-08-18','15:05:00',6.63),('16100','2013-08-18','15:10:00',6.59),('16100','2013-08-18','15:15:00',6.54),('16100','2013-08-18','15:20:00',6.4),('16100','2013-08-18','15:25:00',6.28),('16100','2013-08-18','15:30:00',6.2),('16100','2013-08-18','15:35:00',6.14),('16100','2013-08-18','15:40:00',6.06),('16100','2013-08-18','15:45:00',5.98),('16100','2013-08-18','15:50:00',5.89),('16100','2013-08-18','15:55:00',5.78),('16100','2013-08-18','16:00:00',5.64),('16100','2013-08-18','16:05:00',5.54),('16100','2013-08-18','16:10:00',5.41),('16100','2013-08-18','16:15:00',5.26),('16100','2013-08-18','16:20:00',5.09),('16100','2013-08-18','16:25:00',5.06),('16100','2013-08-18','16:30:00',4.92),('16100','2013-08-18','16:35:00',4.81),('16100','2013-08-18','16:40:00',4.7),('16100','2013-08-18','16:45:00',4.56),('16100','2013-08-18','16:50:00',4.42),('16100','2013-08-18','16:55:00',4.29),('16100','2013-08-18','17:00:00',4.13),('16100','2013-08-18','17:05:00',3.96),('16100','2013-08-18','17:10:00',3.81),('16100','2013-08-18','17:15:00',3.67),('16100','2013-08-18','17:20:00',3.52),('16100','2013-08-18','17:25:00',3.36),('16100','2013-08-18','17:30:00',3.21),('16100','2013-08-18','17:35:00',3.05),('16100','2013-08-18','17:40:00',2.89),('16100','2013-08-18','17:45:00',2.74),('16100','2013-08-18','17:50:00',2.58),('16100','2013-08-18','17:55:00',2.41),('16100','2013-08-18','18:00:00',2.26),('16100','2013-08-18','18:05:00',2.11),('16100','2013-08-18','18:10:00',1.94),('16100','2013-08-18','18:15:00',1.78),('16100','2013-08-18','18:20:00',1.62),('16100','2013-08-18','18:25:00',1.46),('16100','2013-08-18','18:30:00',1.31),('16100','2013-08-18','18:35:00',1.15),('16100','2013-08-17','08:05:00',1.07),('16100','2013-08-17','08:10:00',1.24),('16100','2013-08-17','08:15:00',1.39),('16100','2013-08-17','08:20:00',1.6),('16100','2013-08-17','08:25:00',1.83),('16100','2013-08-17','08:30:00',2.06),('16100','2013-08-17','08:35:00',2.3),('16100','2013-08-17','08:40:00',2.46),('16100','2013-08-17','08:45:00',2.62),('16100','2013-08-17','08:50:00',2.81),('16100','2013-08-17','08:55:00',2.95),('16100','2013-08-17','09:00:00',3.1),('16100','2013-08-17','09:05:00',3.27),('16100','2013-08-17','09:10:00',3.47),('16100','2013-08-17','09:15:00',3.63),('16100','2013-08-17','09:20:00',3.78),('16100','2013-08-17','09:25:00',3.91),('16100','2013-08-17','09:30:00',4.03),('16100','2013-08-17','09:35:00',4.17),('16100','2013-08-17','09:40:00',4.1),('16100','2013-08-17','09:45:00',3.57),('16100','2013-08-17','09:50:00',4.53),('16100','2013-08-17','09:55:00',4.4),('16100','2013-08-17','10:00:00',4.71),('16100','2013-08-17','10:05:00',4.92),('16100','2013-08-17','10:10:00',4.99),('16100','2013-08-17','10:15:00',5.14),('16100','2013-08-17','10:20:00',5.25),('16100','2013-08-17','10:25:00',5.37),('16100','2013-08-17','10:30:00',5.49),('16100','2013-08-17','10:35:00',5.59),('16100','2013-08-17','10:40:00',5.64),('16100','2013-08-17','10:45:00',5.69),('16100','2013-08-17','10:50:00',5.75),('16100','2013-08-17','10:55:00',5.82),('16100','2013-08-17','11:00:00',5.89),('16100','2013-08-17','11:05:00',5.96),('16100','2013-08-17','11:10:00',6.05),('16100','2013-08-17','11:15:00',6.15),('16100','2013-08-17','11:20:00',6.31),('16100','2013-08-17','11:25:00',6.34),('16100','2013-08-17','11:30:00',6.41),('16100','2013-08-17','11:35:00',6.45),('16100','2013-08-17','11:40:00',6.55),('16100','2013-08-17','11:45:00',6.57),('16100','2013-08-17','11:50:00',6.6),('16100','2013-08-17','11:55:00',6.61),('16100','2013-08-17','12:00:00',6.66),('16100','2013-08-17','12:05:00',6.78),('16100','2013-08-17','12:10:00',6.83),('16100','2013-08-17','12:15:00',6.91),('16100','2013-08-17','12:20:00',6.63),('16100','2013-08-17','12:25:00',6.97),('16100','2013-08-17','12:30:00',7.07),('16100','2013-08-17','12:35:00',7.04),('16100','2013-08-17','12:40:00',7.36),('16100','2013-08-17','12:45:00',6.54),('16100','2013-08-17','12:50:00',7.26),('16100','2013-08-17','12:55:00',7.18),('16100','2013-08-17','13:00:00',7.22),('16100','2013-08-17','13:05:00',7.15),('16100','2013-08-17','13:10:00',7.28),('16100','2013-08-17','13:15:00',7.24),('16100','2013-08-17','13:20:00',7.16),('16100','2013-08-17','13:25:00',7.26),('16100','2013-08-17','13:30:00',7.18),('16100','2013-08-17','13:35:00',7.2),('16100','2013-08-17','13:40:00',7.2),('16100','2013-08-17','13:45:00',7.18),('16100','2013-08-17','13:50:00',7.21),('16100','2013-08-17','13:55:00',7.21),('16100','2013-08-17','14:00:00',7.19),('16100','2013-08-17','14:05:00',7.17),('16100','2013-08-17','14:10:00',7.1),('16100','2013-08-17','14:15:00',7.07),('16100','2013-08-17','14:20:00',7.05),('16100','2013-08-17','14:25:00',7.05),('16100','2013-08-17','14:30:00',7.06),('16100','2013-08-17','14:35:00',6.98),('16100','2013-08-17','14:40:00',6.97),('16100','2013-08-17','14:45:00',6.87),('16100','2013-08-17','14:50:00',6.76),('16100','2013-08-17','14:55:00',6.69),('16100','2013-08-17','15:00:00',6.66),('16100','2013-08-17','15:05:00',6.62),('16100','2013-08-17','15:10:00',6.55),('16100','2013-08-17','15:15:00',6.52),('16100','2013-08-17','15:20:00',6.39),('16100','2013-08-17','15:25:00',6.28),('16100','2013-08-17','15:30:00',6.16),('16100','2013-08-17','15:35:00',6.06),('16100','2013-08-17','15:40:00',6),('16100','2013-08-17','15:45:00',5.89),('16100','2013-08-17','15:50:00',5.81),('16100','2013-08-17','15:55:00',5.75),('16100','2013-08-17','16:00:00',5.62),('16100','2013-08-17','16:05:00',5.54),('16100','2013-08-17','16:10:00',5.45),('16100','2013-08-17','16:15:00',5.33),('16100','2013-08-17','16:20:00',5.12),('16100','2013-08-17','16:25:00',5.03),('16100','2013-08-17','16:30:00',4.92),('16100','2013-08-17','16:35:00',4.81),('16100','2013-08-17','16:40:00',4.7),('16100','2013-08-17','16:45:00',4.59),('16100','2013-08-17','16:50:00',4.45),('16100','2013-08-17','16:55:00',4.32),('16100','2013-08-17','17:00:00',4.15),('16100','2013-08-17','17:05:00',4.01),('16100','2013-08-17','17:10:00',3.86),('16100','2013-08-17','17:15:00',3.71),('16100','2013-08-17','17:20:00',3.57),('16100','2013-08-17','17:25:00',3.41),('16100','2013-08-17','17:30:00',3.24),('16100','2013-08-17','17:35:00',3.09),('16100','2013-08-17','17:40:00',2.93),('16100','2013-08-17','17:45:00',2.77),('16100','2013-08-17','17:50:00',2.59),('16100','2013-08-17','17:55:00',2.44),('16100','2013-08-17','18:00:00',2.26),('16100','2013-08-17','18:05:00',2.11),('16100','2013-08-17','18:10:00',1.95),('16100','2013-08-17','18:15:00',1.79),('16100','2013-08-17','18:20:00',1.63),('16100','2013-08-17','18:25:00',1.48),('16100','2013-08-17','18:30:00',1.32),('16100','2013-08-17','18:35:00',1.17),('16100','2013-08-17','18:40:00',1.01),('16100','2013-08-16','08:05:00',1.06),('16100','2013-08-16','08:10:00',1.21),('16100','2013-08-16','08:15:00',1.35),('16100','2013-08-16','08:20:00',1.53),('16100','2013-08-16','08:25:00',1.77),('16100','2013-08-16','08:30:00',1.98),('16100','2013-08-16','08:35:00',2.27),('16100','2013-08-16','08:40:00',2.45),('16100','2013-08-16','08:45:00',2.63),('16100','2013-08-16','08:50:00',2.81),('16100','2013-08-16','08:55:00',2.97),('16100','2013-08-16','09:00:00',3.12),('16100','2013-08-16','09:05:00',3.28),('16100','2013-08-16','09:10:00',3.47),('16100','2013-08-16','09:15:00',3.63),('16100','2013-08-16','09:20:00',3.76),('16100','2013-08-16','09:25:00',3.9),('16100','2013-08-16','09:30:00',4.04),('16100','2013-08-16','09:35:00',4.17),('16100','2013-08-16','09:40:00',4.33),('16100','2013-08-16','09:45:00',4.46),('16100','2013-08-16','09:50:00',4.57),('16100','2013-08-16','09:55:00',4.68),('16100','2013-08-16','10:00:00',4.79),('16100','2013-08-16','10:05:00',4.9),('16100','2013-08-16','10:10:00',5.01),('16100','2013-08-16','10:15:00',5.15),('16100','2013-08-16','10:20:00',5.28),('16100','2013-08-16','10:25:00',5.4),('16100','2013-08-16','10:30:00',5.51),('16100','2013-08-16','10:35:00',5.62),('16100','2013-08-16','10:40:00',5.73),('16100','2013-08-16','10:45:00',5.83),('16100','2013-08-16','10:50:00',5.88),('16100','2013-08-16','10:55:00',5.97),('16100','2013-08-16','11:00:00',6.07),('16100','2013-08-16','11:05:00',6.1),('16100','2013-08-16','11:10:00',6.21),('16100','2013-08-16','11:15:00',6.32),('16100','2013-08-16','11:20:00',6.42),('16100','2013-08-16','11:25:00',6.45),('16100','2013-08-16','11:30:00',6.5),('16100','2013-08-16','11:35:00',6.59),('16100','2013-08-16','11:40:00',6.53),('16100','2013-08-16','11:45:00',6.58),('16100','2013-08-16','11:50:00',6.66),('16100','2013-08-16','11:55:00',6.76),('16100','2013-08-16','12:00:00',6.91),('16100','2013-08-16','12:05:00',6.87),('16100','2013-08-16','12:10:00',6.99),('16100','2013-08-16','12:15:00',6.87),('16100','2013-08-16','12:20:00',6.55),('16100','2013-08-16','12:25:00',6.38),('16100','2013-08-16','12:30:00',6.71),('16100','2013-08-16','12:35:00',6.96),('16100','2013-08-16','12:40:00',7.24),('16100','2013-08-16','12:45:00',7.08),('16100','2013-08-16','12:50:00',7.01),('16100','2013-08-16','12:55:00',7.06),('16100','2013-08-16','13:00:00',7.05),('16100','2013-08-16','13:05:00',7.25),('16100','2013-08-16','13:10:00',7.29),('16100','2013-08-16','13:15:00',7.21),('16100','2013-08-16','13:20:00',7.15),('16100','2013-08-16','13:25:00',7.25),('16100','2013-08-16','13:30:00',7.26),('16100','2013-08-16','13:35:00',6.9),('16100','2013-08-16','13:40:00',7.13),('16100','2013-08-16','13:45:00',7.12),('16100','2013-08-16','13:50:00',7.33),('16100','2013-08-16','13:55:00',7.29),('16100','2013-08-16','14:00:00',7.19),('16100','2013-08-16','14:05:00',7.02),('16100','2013-08-16','14:10:00',7.06),('16100','2013-08-16','14:15:00',7.08),('16100','2013-08-16','14:20:00',7.1),('16100','2013-08-16','14:25:00',7.1),('16100','2013-08-16','14:30:00',6.98),('16100','2013-08-16','14:35:00',6.89),('16100','2013-08-16','14:40:00',6.89),('16100','2013-08-16','14:45:00',6.84),('16100','2013-08-16','14:50:00',6.76),('16100','2013-08-16','14:55:00',6.72),('16100','2013-08-16','15:00:00',6.66),('16100','2013-08-16','15:05:00',6.61),('16100','2013-08-16','15:10:00',6.5),('16100','2013-08-16','15:15:00',6.48),('16100','2013-08-16','15:20:00',6.35),('16100','2013-08-16','15:25:00',6.32),('16100','2013-08-16','15:30:00',6.24),('16100','2013-08-16','15:35:00',6.16),('16100','2013-08-16','15:40:00',6.05),('16100','2013-08-16','15:45:00',5.95),('16100','2013-08-16','15:50:00',5.86),('16100','2013-08-16','15:55:00',5.77),('16100','2013-08-16','16:00:00',5.69),('16100','2013-08-16','16:05:00',5.61),('16100','2013-08-16','16:10:00',5.51),('16100','2013-08-16','16:15:00',5.41),('16100','2013-08-16','16:20:00',5.18),('16100','2013-08-16','16:25:00',5.11),('16100','2013-08-16','16:30:00',5.01),('16100','2013-08-16','16:35:00',4.9),('16100','2013-08-16','16:40:00',4.81),('16100','2013-08-16','16:45:00',4.66),('16100','2013-08-16','16:50:00',4.55),('16100','2013-08-16','16:55:00',4.39),('16100','2013-08-16','17:00:00',4.26),('16100','2013-08-16','17:05:00',4.04),('16100','2013-08-16','17:10:00',3.95),('16100','2013-08-16','17:15:00',3.67),('16100','2013-08-16','17:20:00',3.74),('16100','2013-08-16','17:25:00',3.45),('16100','2013-08-16','17:30:00',3.38),('16100','2013-08-16','17:35:00',3.25),('16100','2013-08-16','17:40:00',3.09),('16100','2013-08-16','17:45:00',2.9),('16100','2013-08-16','17:50:00',2.71),('16100','2013-08-16','17:55:00',2.56),('16100','2013-08-16','18:00:00',2.38),('16100','2013-08-16','18:05:00',2.22),('16100','2013-08-16','18:10:00',2.07),('16100','2013-08-16','18:15:00',1.9),('16100','2013-08-16','18:20:00',1.7),('16100','2013-08-16','18:25:00',1.55),('16100','2013-08-16','18:30:00',1.39),('16100','2013-08-16','18:35:00',1.22),('16100','2013-08-16','18:40:00',1.07),('16100','2013-08-15','08:05:00',1.08),('16100','2013-08-15','08:10:00',1.24),('16100','2013-08-15','08:15:00',1.39),('16100','2013-08-15','08:20:00',1.57),('16100','2013-08-15','08:25:00',1.8),('16100','2013-08-15','08:30:00',2),('16100','2013-08-15','08:35:00',2.28),('16100','2013-08-15','08:40:00',2.47),('16100','2013-08-15','08:45:00',2.65),('16100','2013-08-15','08:50:00',2.84),('16100','2013-08-15','08:55:00',3),('16100','2013-08-15','09:00:00',3.17),('16100','2013-08-15','09:05:00',3.35),('16100','2013-08-15','09:10:00',3.54),('16100','2013-08-15','09:15:00',3.68),('16100','2013-08-15','09:20:00',3.83),('16100','2013-08-15','09:25:00',3.98),('16100','2013-08-15','09:30:00',4.13),('16100','2013-08-15','09:35:00',4.26),('16100','2013-08-15','09:40:00',4.43),('16100','2013-08-15','09:45:00',4.56),('16100','2013-08-15','09:50:00',4.7),('16100','2013-08-15','09:55:00',4.83),('16100','2013-08-15','10:00:00',4.93),('16100','2013-08-15','10:05:00',5.05),('16100','2013-08-15','10:10:00',5.16),('16100','2013-08-15','10:15:00',5.29),('16100','2013-08-15','10:20:00',5.41),('16100','2013-08-15','10:25:00',5.51),('16100','2013-08-15','10:30:00',5.61),('16100','2013-08-15','10:35:00',5.72),('16100','2013-08-15','10:40:00',5.83),('16100','2013-08-15','10:45:00',5.93),('16100','2013-08-15','10:50:00',6.03),('16100','2013-08-15','10:55:00',6.13),('16100','2013-08-15','11:00:00',6.21),('16100','2013-08-15','11:05:00',6.33),('16100','2013-08-15','11:10:00',6.46),('16100','2013-08-15','11:15:00',6.55),('16100','2013-08-15','11:20:00',6.61),('16100','2013-08-15','11:25:00',6.66),('16100','2013-08-15','11:30:00',6.71),('16100','2013-08-15','11:35:00',6.78),('16100','2013-08-15','11:40:00',6.84),('16100','2013-08-15','11:45:00',6.86),('16100','2013-08-15','11:50:00',6.9),('16100','2013-08-15','11:55:00',6.94),('16100','2013-08-15','12:00:00',6.98),('16100','2013-08-15','12:05:00',7),('16100','2013-08-15','12:10:00',7.05),('16100','2013-08-15','12:15:00',7.05),('16100','2013-08-15','12:20:00',7.1),('16100','2013-08-15','12:25:00',7.1),('16100','2013-08-15','12:30:00',7.07),('16100','2013-08-15','12:35:00',7.14),('16100','2013-08-15','12:40:00',7.19),('16100','2013-08-15','12:45:00',7.16),('16100','2013-08-15','12:50:00',7.16),('16100','2013-08-15','12:55:00',7.2),('16100','2013-08-15','13:00:00',7.2),('16100','2013-08-15','13:05:00',7.19),('16100','2013-08-15','13:10:00',7.17),('16100','2013-08-15','13:15:00',7.18),('16100','2013-08-15','13:20:00',7.15),('16100','2013-08-15','13:25:00',7.11),('16100','2013-08-15','13:30:00',7.13),('16100','2013-08-15','13:35:00',7.14),('16100','2013-08-15','13:40:00',7.11),('16100','2013-08-15','13:45:00',7.08),('16100','2013-08-15','13:50:00',7.1),('16100','2013-08-15','13:55:00',7.06),('16100','2013-08-15','14:00:00',7.02),('16100','2013-08-15','14:05:00',7.03),('16100','2013-08-15','14:10:00',6.97),('16100','2013-08-15','14:15:00',6.91),('16100','2013-08-15','14:20:00',6.93),('16100','2013-08-15','14:25:00',6.9),('16100','2013-08-15','14:30:00',6.85),('16100','2013-08-15','14:35:00',6.75),('16100','2013-08-15','14:40:00',6.75),('16100','2013-08-15','14:45:00',6.73),('16100','2013-08-15','14:50:00',6.65),('16100','2013-08-15','14:55:00',6.57),('16100','2013-08-15','15:00:00',6.54),('16100','2013-08-15','15:05:00',6.59),('16100','2013-08-15','15:10:00',6.52),('16100','2013-08-15','15:15:00',6.45),('16100','2013-08-15','15:20:00',6.42),('16100','2013-08-15','15:25:00',6.32),('16100','2013-08-15','15:30:00',6.2),('16100','2013-08-15','15:35:00',6.13),('16100','2013-08-15','15:40:00',6.05),('16100','2013-08-15','15:45:00',5.95),('16100','2013-08-15','15:50:00',5.87),('16100','2013-08-15','15:55:00',5.75),('16100','2013-08-15','16:00:00',5.65),('16100','2013-08-15','16:05:00',5.57),('16100','2013-08-15','16:10:00',5.44),('16100','2013-08-15','16:15:00',5.32),('16100','2013-08-15','16:20:00',5.08),('16100','2013-08-15','16:25:00',5.06),('16100','2013-08-15','16:30:00',4.94),('16100','2013-08-15','16:35:00',4.84),('16100','2013-08-15','16:40:00',4.71),('16100','2013-08-15','16:45:00',4.57),('16100','2013-08-15','16:50:00',4.45),('16100','2013-08-15','16:55:00',4.31),('16100','2013-08-15','17:00:00',4.17),('16100','2013-08-15','17:05:00',4.01),('16100','2013-08-15','17:10:00',3.87),('16100','2013-08-15','17:15:00',3.73),('16100','2013-08-15','17:20:00',3.58),('16100','2013-08-15','17:25:00',3.45),('16100','2013-08-15','17:30:00',3.28),('16100','2013-08-15','17:35:00',3.1),('16100','2013-08-15','17:40:00',2.94),('16100','2013-08-15','17:45:00',2.78),('16100','2013-08-15','17:50:00',2.6),('16100','2013-08-15','17:55:00',2.45),('16100','2013-08-15','18:00:00',2.29),('16100','2013-08-15','18:05:00',2.14),('16100','2013-08-15','18:10:00',1.99),('16100','2013-08-15','18:15:00',1.83),('16100','2013-08-15','18:20:00',1.66),('16100','2013-08-15','18:25:00',1.29),('16100','2013-08-14','08:10:00',1.4),('16100','2013-08-14','08:15:00',1.67),('16100','2013-08-14','08:20:00',1.8),('16100','2013-08-14','08:25:00',2),('16100','2013-08-14','08:30:00',2.11),('16100','2013-08-14','08:35:00',2.32),('16100','2013-08-14','08:40:00',2.53),('16100','2013-08-14','08:45:00',2.74),('16100','2013-08-14','08:50:00',2.94),('16100','2013-08-14','08:55:00',3.05),('16100','2013-08-14','09:00:00',3.25),('16100','2013-08-14','09:05:00',3.46),('16100','2013-08-14','09:10:00',3.68),('16100','2013-08-14','09:15:00',3.85),('16100','2013-08-14','09:20:00',3.95),('16100','2013-08-14','09:25:00',4.03),('16100','2013-08-14','09:30:00',4.16),('16100','2013-08-14','09:35:00',4.32),('16100','2013-08-14','09:40:00',4.52),('16100','2013-08-14','09:45:00',4.65),('16100','2013-08-14','09:50:00',4.74),('16100','2013-08-14','09:55:00',4.89),('16100','2013-08-14','10:00:00',5.01),('16100','2013-08-14','10:05:00',5.11),('16100','2013-08-14','10:10:00',5.24),('16100','2013-08-14','10:15:00',5.39),('16100','2013-08-14','10:20:00',5.51),('16100','2013-08-14','10:25:00',5.66),('16100','2013-08-14','10:30:00',5.78),('16100','2013-08-14','10:35:00',5.89),('16100','2013-08-14','10:40:00',6.01),('16100','2013-08-14','10:45:00',6.13),('16100','2013-08-14','10:50:00',6.25),('16100','2013-08-14','10:55:00',6.38),('16100','2013-08-14','11:00:00',6.46),('16100','2013-08-14','11:05:00',6.56),('16100','2013-08-14','11:10:00',5.96),('16100','2013-08-14','11:15:00',6.57),('16100','2013-08-14','11:20:00',6.47),('16100','2013-08-14','11:25:00',6.76),('16100','2013-08-14','11:30:00',6.65),('16100','2013-08-14','11:35:00',5.6),('16100','2013-08-14','11:40:00',4.21),('16100','2013-08-14','11:45:00',4.85),('16100','2013-08-14','11:50:00',4.95),('16100','2013-08-14','11:55:00',5.89),('16100','2013-08-14','12:00:00',6.55),('16100','2013-08-14','12:05:00',6.31),('16100','2013-08-14','12:10:00',6.9),('16100','2013-08-14','12:15:00',7.33),('16100','2013-08-14','12:20:00',7.45),('16100','2013-08-14','12:25:00',7.34),('16100','2013-08-14','12:30:00',7.55),('16100','2013-08-14','12:35:00',7.6),('16100','2013-08-14','12:40:00',7.57),('16100','2013-08-14','12:45:00',7.57),('16100','2013-08-14','12:50:00',7.55),('16100','2013-08-14','12:55:00',7.47),('16100','2013-08-14','13:00:00',7.32),('16100','2013-08-14','13:05:00',7.35),('16100','2013-08-14','13:10:00',7.26),('16100','2013-08-14','13:15:00',7.35),('16100','2013-08-14','13:20:00',7.32),('16100','2013-08-14','13:25:00',7.37),('16100','2013-08-14','13:30:00',7.55),('16100','2013-08-14','13:35:00',7.51),('16100','2013-08-14','13:40:00',7.3),('16100','2013-08-14','13:45:00',7.19),('16100','2013-08-14','13:50:00',7.21),('16100','2013-08-14','13:55:00',7.23),('16100','2013-08-14','14:00:00',7.28),('16100','2013-08-14','14:05:00',7.2),('16100','2013-08-14','14:10:00',7.19),('16100','2013-08-14','14:15:00',6.98),('16100','2013-08-14','14:20:00',7.08),('16100','2013-08-14','14:25:00',7.03),('16100','2013-08-14','14:30:00',6.97),('16100','2013-08-14','14:35:00',6.83),('16100','2013-08-14','14:40:00',6.77),('16100','2013-08-14','14:45:00',6.56),('16100','2013-08-14','14:50:00',5.67),('16100','2013-08-14','14:55:00',6.58),('16100','2013-08-14','15:00:00',6.5),('16100','2013-08-14','15:05:00',6.44),('16100','2013-08-14','15:10:00',6.38),('16100','2013-08-14','15:15:00',6.29),('16100','2013-08-14','15:20:00',6.18),('16100','2013-08-14','15:25:00',6.05),('16100','2013-08-14','15:30:00',5.99),('16100','2013-08-14','15:35:00',5.92),('16100','2013-08-14','15:40:00',5.83),('16100','2013-08-14','15:45:00',5.73),('16100','2013-08-14','15:50:00',5.65),('16100','2013-08-14','15:55:00',5.47),('16100','2013-08-14','16:00:00',5.4),('16100','2013-08-14','16:05:00',5.37),('16100','2013-08-14','16:10:00',5.24),('16100','2013-08-14','16:15:00',5.11),('16100','2013-08-14','16:20:00',5.02),('16100','2013-08-14','16:25:00',4.99),('16100','2013-08-14','16:30:00',4.89),('16100','2013-08-14','16:35:00',4.73),('16100','2013-08-14','16:40:00',3.11),('16100','2013-08-14','16:45:00',4.51),('16100','2013-08-14','16:50:00',4.26),('16100','2013-08-14','16:55:00',4.21),('16100','2013-08-14','17:00:00',4.09),('16100','2013-08-14','17:05:00',3.79),('16100','2013-08-14','17:10:00',3.72),('16100','2013-08-14','17:15:00',3.62),('16100','2013-08-14','17:20:00',3.4),('16100','2013-08-14','17:25:00',3.33),('16100','2013-08-14','17:30:00',3.18),('16100','2013-08-14','17:35:00',3.03),('16100','2013-08-14','17:40:00',2.85),('16100','2013-08-14','17:45:00',2.72),('16100','2013-08-14','17:50:00',2.53),('16100','2013-08-14','17:55:00',2.32),('16100','2013-08-14','18:00:00',2.25),('16100','2013-08-14','18:05:00',2.09),('16100','2013-08-14','18:10:00',1.91),('16100','2013-08-14','18:15:00',1.78),('16100','2013-08-14','18:20:00',1.64),('16100','2013-08-14','18:25:00',1.47),('16100','2013-08-14','18:30:00',1.33),('16100','2013-08-14','18:35:00',1.16),('16100','2013-08-13','08:05:00',1.11),('16100','2013-08-13','08:10:00',1.23),('16100','2013-08-13','08:15:00',1.38),('16100','2013-08-13','08:20:00',1.59),('16100','2013-08-13','08:25:00',1.89),('16100','2013-08-13','08:30:00',2.23),('16100','2013-08-13','08:35:00',1.92),('16100','2013-08-13','08:40:00',1.91),('16100','2013-08-13','08:45:00',2.29),('16100','2013-08-13','08:50:00',2.76),('16100','2013-08-13','08:55:00',2.9),('16100','2013-08-13','09:00:00',3.1),('16100','2013-08-13','09:05:00',3.25),('16100','2013-08-13','09:10:00',3.44),('16100','2013-08-13','09:15:00',3.63),('16100','2013-08-13','09:20:00',3.9),('16100','2013-08-13','09:25:00',4.04),('16100','2013-08-13','09:30:00',3.98),('16100','2013-08-13','09:35:00',4.18),('16100','2013-08-13','09:40:00',2.44),('16100','2013-08-13','09:45:00',1.6),('16100','2013-08-13','09:50:00',1.54),('16100','2013-08-13','09:55:00',2.88),('16100','2013-08-13','10:00:00',4.94),('16100','2013-08-13','10:05:00',4.58),('16100','2013-08-13','10:10:00',5.32),('16100','2013-08-13','10:15:00',4.15),('16100','2013-08-13','10:20:00',3.31),('16100','2013-08-13','10:25:00',2.37),('16100','2013-08-13','10:30:00',4.35),('16100','2013-08-13','10:35:00',6.18),('16100','2013-08-13','10:40:00',6.1),('16100','2013-08-13','10:45:00',3.68),('16100','2013-08-13','10:50:00',2.71),('16100','2013-08-13','10:55:00',5.95),('16100','2013-08-13','11:00:00',3.05),('16100','2013-08-13','11:05:00',2.42),('16100','2013-08-13','11:10:00',5.53),('16100','2013-08-13','11:15:00',5.93),('16100','2013-08-13','11:20:00',5.72),('16100','2013-08-13','11:25:00',5.91),('16100','2013-08-13','11:30:00',6.46),('16100','2013-08-13','11:35:00',6.85),('16100','2013-08-13','11:40:00',4.62),('16100','2013-08-13','11:45:00',2.47),('16100','2013-08-13','11:50:00',3.14),('16100','2013-08-13','11:55:00',4.76),('16100','2013-08-13','12:00:00',5.76),('16100','2013-08-13','12:05:00',5.39),('16100','2013-08-13','12:10:00',2.74),('16100','2013-08-13','12:15:00',2.43),('16100','2013-08-13','12:20:00',5.87),('16100','2013-08-13','12:25:00',7.73),('16100','2013-08-13','12:30:00',7.48),('16100','2013-08-13','12:35:00',6.68),('16100','2013-08-13','12:40:00',2.09),('16100','2013-08-13','12:45:00',2.35),('16100','2013-08-13','12:50:00',3.31),('16100','2013-08-13','12:55:00',1.92),('16100','2013-08-13','13:00:00',2.79),('16100','2013-08-13','13:05:00',6.05),('16100','2013-08-13','13:10:00',6.19),('16100','2013-08-13','13:15:00',4.39),('16100','2013-08-13','13:20:00',3.05),('16100','2013-08-13','13:25:00',7.61),('16100','2013-08-13','13:30:00',7.47),('16100','2013-08-13','13:35:00',7.63),('16100','2013-08-13','13:40:00',7.48),('16100','2013-08-13','13:45:00',7.57),('16100','2013-08-13','13:50:00',7.93),('16100','2013-08-13','13:55:00',5.66),('16100','2013-08-13','14:00:00',6.11),('16100','2013-08-13','14:05:00',6.68),('16100','2013-08-13','14:10:00',7.36),('16100','2013-08-13','14:15:00',5.51),('16100','2013-08-13','14:20:00',5.94),('16100','2013-08-13','14:25:00',6.04),('16100','2013-08-13','14:30:00',7.87),('16100','2013-08-13','14:35:00',5.4),('16100','2013-08-13','14:40:00',7.14),('16100','2013-08-13','14:45:00',6.97),('16100','2013-08-13','14:50:00',6.97),('16100','2013-08-13','14:55:00',6.77),('16100','2013-08-13','15:00:00',6.79),('16100','2013-08-13','15:05:00',6.67),('16100','2013-08-13','15:10:00',6.61),('16100','2013-08-13','15:15:00',6.55),('16100','2013-08-13','15:20:00',6.48),('16100','2013-08-13','15:25:00',6.29),('16100','2013-08-13','15:30:00',6.19),('16100','2013-08-13','15:35:00',6.14),('16100','2013-08-13','15:40:00',6.01),('16100','2013-08-13','15:45:00',5.95),('16100','2013-08-13','15:50:00',5.84),('16100','2013-08-13','15:55:00',5.78),('16100','2013-08-13','16:00:00',5.66),('16100','2013-08-13','16:05:00',5.57),('16100','2013-08-13','16:10:00',5.51),('16100','2013-08-13','16:15:00',5.41),('16100','2013-08-13','16:20:00',5.24),('16100','2013-08-13','16:25:00',5.14),('16100','2013-08-13','16:30:00',5.04),('16100','2013-08-13','16:35:00',4.92),('16100','2013-08-13','16:40:00',4.81),('16100','2013-08-13','16:45:00',4.67),('16100','2013-08-13','16:50:00',4.4),('16100','2013-08-13','16:55:00',4.07),('16100','2013-08-13','17:00:00',4.08),('16100','2013-08-13','17:05:00',3.91),('16100','2013-08-13','17:10:00',3.87),('16100','2013-08-13','17:15:00',3.68),('16100','2013-08-13','17:20:00',3.59),('16100','2013-08-13','17:25:00',3.45),('16100','2013-08-13','17:30:00',3.31),('16100','2013-08-13','17:35:00',3.17),('16100','2013-08-13','17:40:00',3.01),('16100','2013-08-13','17:45:00',2.84),('16100','2013-08-13','17:50:00',2.67),('16100','2013-08-13','17:55:00',2.49),('16100','2013-08-13','18:00:00',2.33),('16100','2013-08-13','18:05:00',2.18),('16100','2013-08-13','18:10:00',2.04),('16100','2013-08-13','18:15:00',1.88),('16100','2013-08-13','18:20:00',1.75),('16100','2013-08-13','18:25:00',1.68),('16100','2013-08-13','18:30:00',1.59),('16100','2013-08-13','18:35:00',1.4),('16100','2013-08-13','18:40:00',1.17),('16100','2013-08-13','18:45:00',1.05),('16100','2013-08-12','08:05:00',1.1),('16100','2013-08-12','08:10:00',1.29),('16100','2013-08-12','08:15:00',1.45),('16100','2013-08-12','08:20:00',1.61),('16100','2013-08-12','08:25:00',1.79),('16100','2013-08-12','08:30:00',2),('16100','2013-08-12','08:35:00',2.23),('16100','2013-08-12','08:40:00',2.5),('16100','2013-08-12','08:45:00',2.69),('16100','2013-08-12','08:50:00',2.88),('16100','2013-08-12','08:55:00',3.04),('16100','2013-08-12','09:00:00',3.18),('16100','2013-08-12','09:05:00',3.38),('16100','2013-08-12','09:10:00',3.54),('16100','2013-08-12','09:15:00',3.67),('16100','2013-08-12','09:20:00',3.82),('16100','2013-08-12','09:25:00',3.97),('16100','2013-08-12','09:30:00',4.08),('16100','2013-08-12','09:35:00',4.24),('16100','2013-08-12','09:40:00',4.42),('16100','2013-08-12','09:45:00',4.53),('16100','2013-08-12','09:50:00',4.65),('16100','2013-08-12','09:55:00',4.77),('16100','2013-08-12','10:00:00',4.92),('16100','2013-08-12','10:05:00',5.07),('16100','2013-08-12','10:10:00',5.24),('16100','2013-08-12','10:15:00',5.4),('16100','2013-08-12','10:20:00',5.51),('16100','2013-08-12','10:25:00',5.78),('16100','2013-08-12','10:30:00',6.04),('16100','2013-08-12','10:35:00',6.23),('16100','2013-08-12','10:40:00',6.2),('16100','2013-08-12','10:45:00',2.97),('16100','2013-08-12','10:50:00',5.43),('16100','2013-08-12','10:55:00',6.27),('16100','2013-08-12','11:00:00',6.39),('16100','2013-08-12','11:05:00',6.32),('16100','2013-08-12','11:10:00',6.3),('16100','2013-08-12','11:15:00',6.45),('16100','2013-08-12','11:20:00',6.53),('16100','2013-08-12','11:25:00',6.54),('16100','2013-08-12','11:30:00',6.58),('16100','2013-08-12','11:35:00',6.59),('16100','2013-08-12','11:40:00',6.65),('16100','2013-08-12','11:45:00',6.66),('16100','2013-08-12','11:50:00',5.02),('16100','2013-08-12','11:55:00',7.15),('16100','2013-08-12','12:00:00',7.12),('16100','2013-08-12','12:05:00',7.28),('16100','2013-08-12','12:10:00',7.46),('16100','2013-08-12','12:15:00',7.54),('16100','2013-08-12','12:20:00',7.39),('16100','2013-08-12','12:25:00',7.5),('16100','2013-08-12','12:30:00',7.5),('16100','2013-08-12','12:35:00',4.78),('16100','2013-08-12','12:40:00',4.71),('16100','2013-08-12','12:45:00',7.93),('16100','2013-08-12','12:50:00',7.56),('16100','2013-08-12','12:55:00',7.05),('16100','2013-08-12','13:00:00',4.89),('16100','2013-08-12','13:05:00',6.82),('16100','2013-08-12','13:10:00',7.73),('16100','2013-08-12','13:15:00',7.39),('16100','2013-08-12','13:20:00',7.46),('16100','2013-08-12','13:25:00',7.48),('16100','2013-08-12','13:30:00',7.42),('16100','2013-08-12','13:35:00',7.28),('16100','2013-08-12','13:40:00',7.29),('16100','2013-08-12','13:45:00',7.41),('16100','2013-08-12','13:50:00',7.23),('16100','2013-08-12','13:55:00',7.44),('16100','2013-08-12','14:00:00',7.57),('16100','2013-08-12','14:05:00',7.37),('16100','2013-08-12','14:10:00',7.24),('16100','2013-08-12','14:15:00',7.02),('16100','2013-08-12','14:20:00',7.06),('16100','2013-08-12','14:25:00',7.24),('16100','2013-08-12','14:30:00',7.15),('16100','2013-08-12','14:35:00',7.1),('16100','2013-08-12','14:40:00',6.98),('16100','2013-08-12','14:45:00',7.01),('16100','2013-08-12','14:50:00',6.88),('16100','2013-08-12','14:55:00',6.79),('16100','2013-08-12','15:00:00',6.7),('16100','2013-08-12','15:05:00',6.66),('16100','2013-08-12','15:10:00',6.54),('16100','2013-08-12','15:15:00',6.44),('16100','2013-08-12','15:20:00',6.45),('16100','2013-08-12','15:25:00',6.26),('16100','2013-08-12','15:30:00',6.21),('16100','2013-08-12','15:35:00',6.16),('16100','2013-08-12','15:40:00',6.04),('16100','2013-08-12','15:45:00',5.97),('16100','2013-08-12','15:50:00',5.89),('16100','2013-08-12','15:55:00',5.76),('16100','2013-08-12','16:00:00',5.66),('16100','2013-08-12','16:05:00',5.6),('16100','2013-08-12','16:10:00',5.49),('16100','2013-08-12','16:15:00',5.42),('16100','2013-08-12','16:20:00',5.23),('16100','2013-08-12','16:25:00',5.14),('16100','2013-08-12','16:30:00',5),('16100','2013-08-12','16:35:00',4.9),('16100','2013-08-12','16:40:00',4.79),('16100','2013-08-12','16:45:00',4.67),('16100','2013-08-12','16:50:00',4.52),('16100','2013-08-12','16:55:00',4.38),('16100','2013-08-12','17:00:00',4.24),('16100','2013-08-12','17:05:00',4.08),('16100','2013-08-12','17:10:00',3.96),('16100','2013-08-12','17:15:00',3.83),('16100','2013-08-12','17:20:00',3.69),('16100','2013-08-12','17:25:00',3.54),('16100','2013-08-12','17:30:00',3.36),('16100','2013-08-12','17:35:00',3.19),('16100','2013-08-12','17:40:00',3.03),('16100','2013-08-12','17:45:00',2.9),('16100','2013-08-12','17:50:00',2.71),('16100','2013-08-12','17:55:00',2.55),('16100','2013-08-12','18:00:00',2.38),('16100','2013-08-12','18:05:00',2.22),('16100','2013-08-12','18:10:00',2.06),('16100','2013-08-12','18:15:00',1.9),('16100','2013-08-12','18:20:00',1.74),('16100','2013-08-12','18:25:00',1.59),('16100','2013-08-12','18:30:00',1.43),('16100','2013-08-12','18:35:00',1.28),('16100','2013-08-12','18:40:00',1.15),('16100','2013-08-11','08:05:00',1.11),('16100','2013-08-11','08:10:00',1.26),('16100','2013-08-11','08:15:00',1.41),('16100','2013-08-11','08:20:00',1.56),('16100','2013-08-11','08:25:00',1.74),('16100','2013-08-11','08:30:00',1.94),('16100','2013-08-11','08:35:00',2.16),('16100','2013-08-11','08:40:00',2.4),('16100','2013-08-11','08:45:00',2.64),('16100','2013-08-11','08:50:00',2.82),('16100','2013-08-11','08:55:00',2.97),('16100','2013-08-11','09:00:00',3.12),('16100','2013-08-11','09:05:00',3.32),('16100','2013-08-11','09:10:00',3.47),('16100','2013-08-11','09:15:00',3.61),('16100','2013-08-11','09:20:00',3.73),('16100','2013-08-11','09:25:00',3.87),('16100','2013-08-11','09:30:00',4.02),('16100','2013-08-11','09:35:00',4.15),('16100','2013-08-11','09:40:00',4.27),('16100','2013-08-11','09:45:00',4.41),('16100','2013-08-11','09:50:00',4.49),('16100','2013-08-11','09:55:00',4.6),('16100','2013-08-11','10:00:00',4.7),('16100','2013-08-11','10:05:00',4.82),('16100','2013-08-11','10:10:00',4.93),('16100','2013-08-11','10:15:00',5.06),('16100','2013-08-11','10:20:00',5.18),('16100','2013-08-11','10:25:00',5.3),('16100','2013-08-11','10:30:00',5.42),('16100','2013-08-11','10:35:00',5.47),('16100','2013-08-11','10:40:00',5.6),('16100','2013-08-11','10:45:00',5.69),('16100','2013-08-11','10:50:00',5.79),('16100','2013-08-11','10:55:00',5.91),('16100','2013-08-11','11:00:00',5.99),('16100','2013-08-11','11:05:00',6.04),('16100','2013-08-11','11:10:00',6.14),('16100','2013-08-11','11:15:00',6.26),('16100','2013-08-11','11:20:00',6.36),('16100','2013-08-11','11:25:00',6.4),('16100','2013-08-11','11:30:00',6.41),('16100','2013-08-11','11:35:00',6.6),('16100','2013-08-11','11:40:00',6.78),('16100','2013-08-11','11:45:00',4.6),('16100','2013-08-11','11:50:00',7.21),('16100','2013-08-11','11:55:00',7.25),('16100','2013-08-11','12:00:00',7.28),('16100','2013-08-11','12:05:00',5.05),('16100','2013-08-11','12:10:00',4.63),('16100','2013-08-11','12:15:00',6.64),('16100','2013-08-11','12:20:00',7.38),('16100','2013-08-11','12:25:00',7.55),('16100','2013-08-11','12:30:00',7.37),('16100','2013-08-11','12:35:00',7.54),('16100','2013-08-11','12:40:00',6.74),('16100','2013-08-11','12:45:00',4.98),('16100','2013-08-11','12:50:00',5.23),('16100','2013-08-11','12:55:00',5.16),('16100','2013-08-11','13:00:00',7.71),('16100','2013-08-11','13:05:00',5.26),('16100','2013-08-11','13:10:00',2.41),('16100','2013-08-11','13:15:00',2.58),('16100','2013-08-11','13:20:00',3.28),('16100','2013-08-11','13:25:00',3.08),('16100','2013-08-11','13:30:00',4.36),('16100','2013-08-11','13:35:00',5.74),('16100','2013-08-11','13:40:00',3.23),('16100','2013-08-11','13:45:00',2.02),('16100','2013-08-11','13:50:00',2.51),('16100','2013-08-11','13:55:00',5.03),('16100','2013-08-11','14:00:00',4.32),('16100','2013-08-11','14:05:00',3.59),('16100','2013-08-11','14:10:00',6.57),('16100','2013-08-11','14:15:00',5.58),('16100','2013-08-11','14:20:00',6.34),('16100','2013-08-11','14:25:00',2.19),('16100','2013-08-11','14:30:00',6.26),('16100','2013-08-11','14:35:00',6.47),('16100','2013-08-11','14:40:00',7.25),('16100','2013-08-11','14:45:00',7.48),('16100','2013-08-11','14:50:00',7.05),('16100','2013-08-11','14:55:00',7.11),('16100','2013-08-11','15:00:00',7.16),('16100','2013-08-11','15:05:00',5.1),('16100','2013-08-11','15:10:00',6.69),('16100','2013-08-11','15:15:00',6.62),('16100','2013-08-11','15:20:00',6.6),('16100','2013-08-11','15:25:00',6.44),('16100','2013-08-11','15:30:00',5.95),('16100','2013-08-11','15:35:00',6.23),('16100','2013-08-11','15:40:00',6.28),('16100','2013-08-11','15:45:00',6.03),('16100','2013-08-11','15:50:00',5.87),('16100','2013-08-11','15:55:00',5.79),('16100','2013-08-11','16:00:00',5.68),('16100','2013-08-11','16:05:00',5.61),('16100','2013-08-11','16:10:00',5.37),('16100','2013-08-11','16:15:00',5.31),('16100','2013-08-11','16:20:00',5.12),('16100','2013-08-11','16:25:00',5.03),('16100','2013-08-11','16:30:00',4.94),('16100','2013-08-11','16:35:00',4.84),('16100','2013-08-11','16:40:00',4.73),('16100','2013-08-11','16:45:00',4.64),('16100','2013-08-11','16:50:00',4.5),('16100','2013-08-11','16:55:00',4.33),('16100','2013-08-11','17:00:00',4.24),('16100','2013-08-11','17:05:00',4.05),('16100','2013-08-11','17:10:00',3.83),('16100','2013-08-11','17:15:00',3.79),('16100','2013-08-11','17:20:00',3.63),('16100','2013-08-11','17:25:00',3.47),('16100','2013-08-11','17:30:00',3.27),('16100','2013-08-11','17:35:00',3.13),('16100','2013-08-11','17:40:00',2.98),('16100','2013-08-11','17:45:00',2.85),('16100','2013-08-11','17:50:00',2.72),('16100','2013-08-11','17:55:00',2.57),('16100','2013-08-11','18:00:00',2.42),('16100','2013-08-11','18:05:00',2.22),('16100','2013-08-11','18:10:00',2.09),('16100','2013-08-11','18:15:00',1.93),('16100','2013-08-11','18:20:00',1.78),('16100','2013-08-11','18:25:00',1.63),('16100','2013-08-11','18:30:00',1.49),('16100','2013-08-11','18:35:00',1.35),('16100','2013-08-11','18:40:00',1.21),('16100','2013-08-11','18:45:00',1.06),('16100','2013-08-10','08:00:00',1.03),('16100','2013-08-10','08:05:00',1.16),('16100','2013-08-10','08:10:00',1.31),('16100','2013-08-10','08:15:00',1.46),('16100','2013-08-10','08:20:00',1.6),('16100','2013-08-10','08:25:00',1.79),('16100','2013-08-10','08:30:00',1.99),('16100','2013-08-10','08:35:00',2.21),('16100','2013-08-10','08:40:00',2.44),('16100','2013-08-10','08:45:00',2.7),('16100','2013-08-10','08:50:00',2.88),('16100','2013-08-10','08:55:00',3.05),('16100','2013-08-10','09:00:00',3.21),('16100','2013-08-10','09:05:00',3.4),('16100','2013-08-10','09:10:00',3.57),('16100','2013-08-10','09:15:00',3.7),('16100','2013-08-10','09:20:00',3.83),('16100','2013-08-10','09:25:00',3.96),('16100','2013-08-10','09:30:00',4.11),('16100','2013-08-10','09:35:00',4.23),('16100','2013-08-10','09:40:00',4.39),('16100','2013-08-10','09:45:00',4.52),('16100','2013-08-10','09:50:00',4.64),('16100','2013-08-10','09:55:00',4.75),('16100','2013-08-10','10:00:00',4.86),('16100','2013-08-10','10:05:00',4.96),('16100','2013-08-10','10:10:00',5.07),('16100','2013-08-10','10:15:00',5.22),('16100','2013-08-10','10:20:00',5.35),('16100','2013-08-10','10:25:00',5.48),('16100','2013-08-10','10:30:00',5.55),('16100','2013-08-10','10:35:00',5.68),('16100','2013-08-10','10:40:00',5.81),('16100','2013-08-10','10:45:00',5.89),('16100','2013-08-10','10:50:00',6.01),('16100','2013-08-10','10:55:00',6.08),('16100','2013-08-10','11:00:00',6.18),('16100','2013-08-10','11:05:00',6.27),('16100','2013-08-10','11:10:00',6.39),('16100','2013-08-10','11:15:00',6.45),('16100','2013-08-10','11:20:00',6.5),('16100','2013-08-10','11:25:00',6.52),('16100','2013-08-10','11:30:00',6.55),('16100','2013-08-10','11:35:00',6.63),('16100','2013-08-10','11:40:00',6.73),('16100','2013-08-10','11:45:00',6.8),('16100','2013-08-10','11:50:00',6.83),('16100','2013-08-10','11:55:00',6.88),('16100','2013-08-10','12:00:00',6.92),('16100','2013-08-10','12:05:00',6.98),('16100','2013-08-10','12:10:00',6.99),('16100','2013-08-10','12:15:00',6.97),('16100','2013-08-10','12:20:00',6.98),('16100','2013-08-10','12:25:00',7.05),('16100','2013-08-10','12:30:00',7.03),('16100','2013-08-10','12:35:00',7.06),('16100','2013-08-10','12:40:00',7.09),('16100','2013-08-10','12:45:00',7.1),('16100','2013-08-10','12:50:00',7.15),('16100','2013-08-10','12:55:00',7.14),('16100','2013-08-10','13:00:00',7.18),('16100','2013-08-10','13:05:00',7.17),('16100','2013-08-10','13:10:00',7.19),('16100','2013-08-10','13:15:00',7.13),('16100','2013-08-10','13:20:00',7.14),('16100','2013-08-10','13:25:00',7.09),('16100','2013-08-10','13:30:00',7.04),('16100','2013-08-10','13:35:00',7.03),('16100','2013-08-10','13:40:00',7.05),('16100','2013-08-10','13:45:00',7.04),('16100','2013-08-10','13:50:00',7.05),('16100','2013-08-10','13:55:00',7.02),('16100','2013-08-10','14:00:00',6.98),('16100','2013-08-10','14:05:00',7.03),('16100','2013-08-10','14:10:00',6.97),('16100','2013-08-10','14:15:00',6.74),('16100','2013-08-10','14:20:00',6.93),('16100','2013-08-10','14:25:00',6.95),('16100','2013-08-10','14:30:00',6.87),('16100','2013-08-10','14:35:00',6.87),('16100','2013-08-10','14:40:00',6.79),('16100','2013-08-10','14:45:00',6.67),('16100','2013-08-10','14:50:00',6.63),('16100','2013-08-10','14:55:00',6.56),('16100','2013-08-10','15:00:00',6.49),('16100','2013-08-10','15:05:00',6.4),('16100','2013-08-10','15:10:00',6.44),('16100','2013-08-10','15:15:00',4.81),('16100','2013-08-10','15:20:00',5.62),('16100','2013-08-10','15:25:00',6.15),('16100','2013-08-10','15:30:00',5.97),('16100','2013-08-10','15:35:00',5.97),('16100','2013-08-10','15:40:00',5.96),('16100','2013-08-10','15:45:00',5.92),('16100','2013-08-10','15:50:00',5.87),('16100','2013-08-10','15:55:00',5.77),('16100','2013-08-10','16:00:00',5.65),('16100','2013-08-10','16:05:00',5.56),('16100','2013-08-10','16:10:00',5.47),('16100','2013-08-10','16:15:00',5.39),('16100','2013-08-10','16:20:00',5.17),('16100','2013-08-10','16:25:00',5.09),('16100','2013-08-10','16:30:00',4.97),('16100','2013-08-10','16:35:00',4.85),('16100','2013-08-10','16:40:00',4.72),('16100','2013-08-10','16:45:00',4.59),('16100','2013-08-10','16:50:00',4.47),('16100','2013-08-10','16:55:00',4.32),('16100','2013-08-10','17:00:00',4.18),('16100','2013-08-10','17:05:00',4.02),('16100','2013-08-10','17:10:00',3.89),('16100','2013-08-10','17:15:00',3.75),('16100','2013-08-10','17:20:00',3.61),('16100','2013-08-10','17:25:00',3.44),('16100','2013-08-10','17:30:00',3.31),('16100','2013-08-10','17:35:00',3.15),('16100','2013-08-10','17:40:00',2.99),('16100','2013-08-10','17:45:00',2.83),('16100','2013-08-10','17:50:00',2.67),('16100','2013-08-10','17:55:00',2.49),('16100','2013-08-10','18:00:00',2.34),('16100','2013-08-10','18:05:00',2.2),('16100','2013-08-10','18:10:00',2.05),('16100','2013-08-10','18:15:00',1.89),('16100','2013-08-10','18:20:00',1.73),('16100','2013-08-10','18:25:00',1.59),('16100','2013-08-10','18:30:00',1.44),('16100','2013-08-10','18:35:00',1.29),('16100','2013-08-10','18:40:00',1.15),('16100','2013-08-10','18:45:00',1.01),('16100','2013-08-09','08:00:00',1.03),('16100','2013-08-09','08:05:00',1.17),('16100','2013-08-09','08:10:00',1.31),('16100','2013-08-09','08:15:00',1.47),('16100','2013-08-09','08:20:00',1.64),('16100','2013-08-09','08:25:00',1.81),('16100','2013-08-09','08:30:00',1.97),('16100','2013-08-09','08:35:00',2.16),('16100','2013-08-09','08:40:00',2.46),('16100','2013-08-09','08:45:00',2.76),('16100','2013-08-09','08:50:00',2.93),('16100','2013-08-09','08:55:00',3.09),('16100','2013-08-09','09:00:00',3.23),('16100','2013-08-09','09:05:00',3.43),('16100','2013-08-09','09:10:00',3.58),('16100','2013-08-09','09:15:00',3.71),('16100','2013-08-09','09:20:00',3.85),('16100','2013-08-09','09:25:00',4),('16100','2013-08-09','09:30:00',4.12),('16100','2013-08-09','09:35:00',4.29),('16100','2013-08-09','09:40:00',4.43),('16100','2013-08-09','09:45:00',4.57),('16100','2013-08-09','09:50:00',4.71),('16100','2013-08-09','09:55:00',4.81),('16100','2013-08-09','10:00:00',4.91),('16100','2013-08-09','10:05:00',5.01),('16100','2013-08-09','10:10:00',5.11),('16100','2013-08-09','10:15:00',5.23),('16100','2013-08-09','10:20:00',5.39),('16100','2013-08-09','10:25:00',5.49),('16100','2013-08-09','10:30:00',5.57),('16100','2013-08-09','10:35:00',5.7),('16100','2013-08-09','10:40:00',5.79),('16100','2013-08-09','10:45:00',5.86),('16100','2013-08-09','10:50:00',5.97),('16100','2013-08-09','10:55:00',6.1),('16100','2013-08-09','11:00:00',6.29),('16100','2013-08-09','11:05:00',6.4),('16100','2013-08-09','11:10:00',5.78),('16100','2013-08-09','11:15:00',6.55),('16100','2013-08-09','11:20:00',6.55),('16100','2013-08-09','11:25:00',6.63),('16100','2013-08-09','11:30:00',6.68),('16100','2013-08-09','11:35:00',6.63),('16100','2013-08-09','11:40:00',6.79),('16100','2013-08-09','11:45:00',6.78),('16100','2013-08-09','11:50:00',6.87),('16100','2013-08-09','11:55:00',7.04),('16100','2013-08-09','12:00:00',7.21),('16100','2013-08-09','12:05:00',7.1),('16100','2013-08-09','12:10:00',7.12),('16100','2013-08-09','12:15:00',7.18),('16100','2013-08-09','12:20:00',7.19),('16100','2013-08-09','12:25:00',7.22),('16100','2013-08-09','12:30:00',7.19),('16100','2013-08-09','12:35:00',7.41),('16100','2013-08-09','12:40:00',7.49),('16100','2013-08-09','12:45:00',4.13),('16100','2013-08-09','12:50:00',7.66),('16100','2013-08-09','12:55:00',7.33),('16100','2013-08-09','13:00:00',6.71),('16100','2013-08-09','13:05:00',7.39),('16100','2013-08-09','13:10:00',7.64),('16100','2013-08-09','13:15:00',7.09),('16100','2013-08-09','13:20:00',1.6),('16100','2013-08-09','13:25:00',6.75),('16100','2013-08-09','13:30:00',2.43),('16100','2013-08-09','13:35:00',1.78),('16100','2013-08-09','13:40:00',7.18),('16100','2013-08-09','13:45:00',2.7),('16100','2013-08-09','13:50:00',3.68),('16100','2013-08-09','13:55:00',4.54),('16100','2013-08-09','14:00:00',6.84),('16100','2013-08-09','14:05:00',8.19),('16100','2013-08-09','14:10:00',5.69),('16100','2013-08-09','14:15:00',2.8),('16100','2013-08-09','14:20:00',1.49),('16100','2013-08-09','14:25:00',1.53),('16100','2013-08-09','14:30:00',1.33),('16100','2013-08-09','14:35:00',1.19),('16100','2013-08-09','14:40:00',1.09),('16100','2013-08-09','14:45:00',1.06),('16100','2013-08-09','14:50:00',1.12),('16100','2013-08-09','14:55:00',1.47),('16100','2013-08-09','15:00:00',1.4),('16100','2013-08-09','15:05:00',1.21),('16100','2013-08-09','15:10:00',1.28),('16100','2013-08-09','15:15:00',1.44),('16100','2013-08-09','15:20:00',1.33),('16100','2013-08-09','15:25:00',1.39),('16100','2013-08-09','15:30:00',1.68),('16100','2013-08-09','15:35:00',1.65),('16100','2013-08-09','15:40:00',2.18),('16100','2013-08-09','15:45:00',2.46),('16100','2013-08-09','15:50:00',2.39),('16100','2013-08-09','15:55:00',2.55),('16100','2013-08-09','16:00:00',2.89),('16100','2013-08-09','16:05:00',2.25),('16100','2013-08-09','16:10:00',2.05),('16100','2013-08-09','16:15:00',1.96),('16100','2013-08-09','16:20:00',2.85),('16100','2013-08-09','16:25:00',3.97),('16100','2013-08-09','16:30:00',3.98),('16100','2013-08-09','16:35:00',2.64),('16100','2013-08-09','16:40:00',1.52),('16100','2013-08-09','16:45:00',3.1),('16100','2013-08-09','16:50:00',4.19),('16100','2013-08-09','16:55:00',1.76),('16100','2013-08-09','17:00:00',1.28),('16100','2013-08-09','17:05:00',1.7),('16100','2013-08-09','17:10:00',1.99),('16100','2013-08-09','17:15:00',2.01),('16100','2013-08-09','17:20:00',1.65),('16100','2013-08-09','17:25:00',1.71),('16100','2013-08-09','17:30:00',1.72),('16100','2013-08-09','17:35:00',1.05),('16100','2013-08-09','17:45:00',1.38),('16100','2013-08-09','17:50:00',1.09),('16100','2014-04-08','08:00:00',1.19),('16100','2014-04-08','08:05:00',1.31),('16100','2014-04-08','08:10:00',1.22),('16100','2014-04-08','08:15:00',1.22),('16100','2014-04-08','08:50:00',1.19),('16100','2014-04-08','08:55:00',1.09),('16100','2014-04-08','09:00:00',1.13),('16100','2014-04-08','09:05:00',1.08),('16100','2014-04-08','09:10:00',1.06),('16100','2014-04-08','09:15:00',1.17),('16100','2014-04-08','09:20:00',1.17),('16100','2014-04-08','09:50:00',1.36),('16100','2014-04-08','09:55:00',2.1),('16100','2014-04-08','10:00:00',3.79),('16100','2014-04-08','10:05:00',3.06),('16100','2014-04-08','10:10:00',2.54),('16100','2014-04-08','10:15:00',1.84),('16100','2014-04-08','10:20:00',1.48),('16100','2014-04-08','10:25:00',1.8),('16100','2014-04-08','10:30:00',1.63),('16100','2014-04-08','10:35:00',1.11),('16100','2014-04-08','10:45:00',3.26),('16100','2014-04-08','10:50:00',5.36),('16100','2014-04-08','10:55:00',6.62),('16100','2014-04-08','11:00:00',4.83),('16100','2014-04-08','11:05:00',2.09),('16100','2014-04-08','11:10:00',2.88),('16100','2014-04-08','11:15:00',2.03),('16100','2014-04-08','11:20:00',1.93),('16100','2014-04-08','11:25:00',2.53),('16100','2014-04-08','11:30:00',6.98),('16100','2014-04-08','11:35:00',7.6),('16100','2014-04-08','11:40:00',6.06),('16100','2014-04-08','11:45:00',5.1),('16100','2014-04-08','11:50:00',2.22),('16100','2014-04-08','11:55:00',2),('16100','2014-04-08','12:00:00',1.96),('16100','2014-04-08','12:05:00',1.82),('16100','2014-04-08','12:10:00',1.72),('16100','2014-04-08','12:15:00',1.86),('16100','2014-04-08','12:20:00',1.81),('16100','2014-04-08','12:25:00',1.79),('16100','2014-04-08','12:30:00',1.44),('16100','2014-04-08','12:35:00',1.32),('16100','2014-04-08','12:40:00',1.42),('16100','2014-04-08','12:45:00',1.66),('16100','2014-04-08','12:50:00',1.75),('16100','2014-04-08','12:55:00',1.96),('16100','2014-04-08','13:00:00',1.97),('16100','2014-04-08','13:05:00',1.87),('16100','2014-04-08','13:10:00',2.05),('16100','2014-04-08','13:15:00',1.96),('16100','2014-04-08','13:20:00',1.97),('16100','2014-04-08','13:25:00',1.99),('16100','2014-04-08','13:30:00',2.4),('16100','2014-04-08','13:35:00',2.86),('16100','2014-04-08','13:40:00',2.84),('16100','2014-04-08','13:45:00',2.63),('16100','2014-04-08','13:50:00',2.5),('16100','2014-04-08','13:55:00',2.08),('16100','2014-04-08','14:00:00',2.56),('16100','2014-04-08','14:05:00',2.38),('16100','2014-04-08','14:10:00',2.25),('16100','2014-04-08','14:15:00',2.33),('16100','2014-04-08','14:20:00',2.54),('16100','2014-04-08','14:25:00',6.62),('16100','2014-04-08','14:30:00',5.88),('16100','2014-04-08','14:35:00',7.45),('16100','2014-04-08','14:40:00',7.28),('16100','2014-04-08','14:45:00',7.18),('16100','2014-04-08','14:50:00',7.42),('16100','2014-04-08','14:55:00',3.5),('16100','2014-04-08','15:00:00',2.77),('16100','2014-04-08','15:05:00',1.85),('16100','2014-04-08','15:10:00',1.74),('16100','2014-04-08','15:15:00',1.93),('16100','2014-04-08','15:20:00',1.6),('16100','2014-04-08','15:25:00',1.22),('16100','2014-04-08','15:30:00',1.19),('16100','2014-04-08','15:35:00',1.24),('16100','2014-04-08','15:40:00',1.89),('16100','2014-04-08','15:45:00',2.5),('16100','2014-04-08','15:50:00',4.79),('16100','2014-04-08','15:55:00',5.46),('16100','2014-04-08','16:00:00',5.87),('16100','2014-04-08','16:05:00',5.53),('16100','2014-04-08','16:10:00',5.39),('16100','2014-04-08','16:15:00',5.28),('16100','2014-04-08','16:20:00',4.37),('16100','2014-04-08','16:25:00',4.94),('16100','2014-04-08','16:30:00',4.94),('16100','2014-04-08','16:35:00',4.8),('16100','2014-04-08','16:40:00',4.87),('16100','2014-04-08','16:45:00',4.48),('16100','2014-04-08','16:50:00',3.89),('16100','2014-04-08','16:55:00',3.61),('16100','2014-04-08','17:00:00',2.86),('16100','2014-04-08','17:05:00',3.6),('16100','2014-04-08','17:10:00',3.51),('16100','2014-04-08','17:15:00',3.28),('16100','2014-04-08','17:20:00',3.04),('16100','2014-04-08','17:25:00',2.16),('16100','2014-04-08','17:30:00',1.99),('16100','2014-04-08','17:35:00',2.53),('16100','2014-04-08','17:40:00',2.55),('16100','2014-04-08','17:45:00',2.66),('16100','2014-04-08','17:50:00',2.44),('16100','2014-04-08','17:55:00',2.29),('16100','2014-04-08','18:00:00',1.43),('16100','2014-04-08','18:05:00',1.52),('16100','2014-04-08','18:10:00',1.51),('16100','2014-04-08','18:15:00',1.3),('16100','2013-08-08','08:00:00',1.2),('16100','2013-08-08','08:05:00',1.09),('16100','2013-08-08','08:10:00',1.03),('16100','2013-08-08','08:15:00',1.05),('16100','2013-08-08','08:20:00',1.02),('16100','2013-08-08','08:30:00',1.09),('16100','2013-08-08','08:35:00',1.68),('16100','2013-08-08','08:40:00',1.81),('16100','2013-08-08','08:45:00',2.28),('16100','2013-08-08','08:50:00',2.66),('16100','2013-08-08','08:55:00',2.9),('16100','2013-08-08','09:00:00',3.12),('16100','2013-08-08','09:05:00',3),('16100','2013-08-08','09:10:00',2.71),('16100','2013-08-08','09:15:00',2.78),('16100','2013-08-08','09:20:00',3.42),('16100','2013-08-08','09:25:00',1.95),('16100','2013-08-08','09:30:00',3.02),('16100','2013-08-08','09:35:00',4.34),('16100','2013-08-08','09:40:00',3.87),('16100','2013-08-08','09:45:00',3.87),('16100','2013-08-08','09:50:00',2.47),('16100','2013-08-08','09:55:00',3.38),('16100','2013-08-08','10:00:00',4.48),('16100','2013-08-08','10:05:00',3.97),('16100','2013-08-08','10:10:00',4.58),('16100','2013-08-08','10:15:00',4.62),('16100','2013-08-08','10:20:00',4.77),('16100','2013-08-08','10:25:00',4.82),('16100','2013-08-08','10:30:00',4.96),('16100','2013-08-08','10:35:00',5.15),('16100','2013-08-08','10:40:00',5.18),('16100','2013-08-08','10:45:00',5.32),('16100','2013-08-08','10:50:00',5.46),('16100','2013-08-08','10:55:00',5.48),('16100','2013-08-08','11:00:00',5.54),('16100','2013-08-08','11:05:00',5.61),('16100','2013-08-08','11:10:00',5.8),('16100','2013-08-08','11:15:00',5.89),('16100','2013-08-08','11:20:00',6),('16100','2013-08-08','11:25:00',6.03),('16100','2013-08-08','11:30:00',6),('16100','2013-08-08','11:35:00',6.05),('16100','2013-08-08','11:40:00',6.1),('16100','2013-08-08','11:45:00',6.14),('16100','2013-08-08','11:50:00',6.08),('16100','2013-08-08','11:55:00',6.14),('16100','2013-08-08','12:00:00',6.39),('16100','2013-08-08','12:05:00',6.5),('16100','2013-08-08','12:10:00',6.56),('16100','2013-08-08','12:15:00',6.69),('16100','2013-08-08','12:20:00',6.96),('16100','2013-08-08','12:25:00',7.21),('16100','2013-08-08','12:30:00',7.4),('16100','2013-08-08','12:35:00',5.05),('16100','2013-08-08','12:40:00',5.28),('16100','2013-08-08','12:45:00',4.9),('16100','2013-08-08','12:50:00',5.4),('16100','2013-08-08','12:55:00',4.36),('16100','2013-08-08','13:00:00',1.9),('16100','2013-08-08','13:05:00',1.34),('16100','2013-08-08','13:10:00',1.23),('16100','2013-08-08','13:15:00',1.62),('16100','2013-08-08','13:20:00',2.39),('16100','2013-08-08','13:25:00',3.29),('16100','2013-08-08','13:30:00',2.83),('16100','2013-08-08','13:35:00',2.64),('16100','2013-08-08','13:40:00',2.15),('16100','2013-08-08','13:45:00',1.78),('16100','2013-08-08','13:50:00',1.82),('16100','2013-08-08','13:55:00',2.08),('16100','2013-08-08','14:00:00',2.07),('16100','2013-08-08','14:05:00',1.79),('16100','2013-08-08','14:10:00',1.52),('16100','2013-08-08','14:15:00',1.3),('16100','2013-08-08','14:20:00',1.07),('16100','2013-08-08','14:30:00',1.08),('16100','2013-08-08','14:35:00',1.19),('16100','2013-08-08','14:40:00',1),('16100','2013-08-08','15:10:00',2.14),('16100','2013-08-08','15:15:00',5.35),('16100','2013-08-08','15:20:00',4.35),('16100','2013-08-08','15:25:00',1.6),('16100','2013-08-08','15:30:00',2),('16100','2013-08-08','15:35:00',2.92),('16100','2013-08-08','15:40:00',5.47),('16100','2013-08-08','15:45:00',4.19),('16100','2013-08-08','15:50:00',2.65),('16100','2013-08-08','15:55:00',2.44),('16100','2013-08-08','16:00:00',1.47),('16100','2013-08-08','16:05:00',1.1),('16100','2013-08-08','16:35:00',1.16),('16100','2013-08-08','16:40:00',1.18),('16100','2013-08-08','16:45:00',2.26),('16100','2013-08-08','16:50:00',3.03),('16100','2013-08-08','16:55:00',2.73),('16100','2013-08-08','17:00:00',1.44),('16100','2013-08-08','17:05:00',1.39),('16100','2013-08-08','17:10:00',1.47),('16100','2013-08-08','17:15:00',1.11),('16100','2013-08-08','17:30:00',1),('16100','2013-08-08','17:35:00',1.07),('16100','2013-08-08','17:40:00',1.08),('16100','2013-08-08','17:45:00',1.03),('16100','2013-08-08','19:00:00',1.14),('16100','2013-08-08','19:05:00',1.28),('16100','2013-08-08','19:10:00',1.28),('16100','2013-08-08','19:15:00',1.3),('16100','2013-08-08','19:20:00',1.32),('16100','2013-08-08','19:25:00',1.35),('16100','2013-08-07','08:05:00',1.04),('16100','2013-08-07','08:10:00',1.17),('16100','2013-08-07','08:15:00',1.31),('16100','2013-08-07','08:20:00',1.46),('16100','2013-08-07','08:25:00',1.6),('16100','2013-08-07','08:30:00',1.74),('16100','2013-08-07','08:35:00',1.92),('16100','2013-08-07','08:40:00',2.1),('16100','2013-08-07','08:45:00',2.38),('16100','2013-08-07','08:50:00',2.58),('16100','2013-08-07','08:55:00',2.71),('16100','2013-08-07','09:00:00',2.85),('16100','2013-08-07','09:05:00',3.01),('16100','2013-08-07','09:10:00',3.14),('16100','2013-08-07','09:15:00',3.29),('16100','2013-08-07','09:20:00',3.43),('16100','2013-08-07','09:25:00',3.56),('16100','2013-08-07','09:30:00',3.7),('16100','2013-08-07','09:35:00',3.84),('16100','2013-08-07','09:40:00',3.99),('16100','2013-08-07','09:45:00',4.11),('16100','2013-08-07','09:50:00',4.22),('16100','2013-08-07','09:55:00',4.32),('16100','2013-08-07','10:00:00',4.46),('16100','2013-08-07','10:05:00',4.59),('16100','2013-08-07','10:10:00',4.69),('16100','2013-08-07','10:15:00',4.79),('16100','2013-08-07','10:20:00',4.97),('16100','2013-08-07','10:25:00',5.06),('16100','2013-08-07','10:30:00',5.13),('16100','2013-08-07','10:35:00',5.22),('16100','2013-08-07','10:40:00',5.31),('16100','2013-08-07','10:45:00',5.37),('16100','2013-08-07','10:50:00',5.48),('16100','2013-08-07','11:00:00',5.68),('16100','2013-08-07','11:05:00',5.72),('16100','2013-08-07','11:10:00',5.85),('16100','2013-08-07','11:15:00',5.88),('16100','2013-08-07','11:20:00',5.95),('16100','2013-08-07','11:25:00',5.94),('16100','2013-08-07','11:30:00',6.01),('16100','2013-08-07','11:35:00',6.16),('16100','2013-08-07','11:40:00',6.29),('16100','2013-08-07','11:45:00',6.25),('16100','2013-08-07','11:50:00',6.29),('16100','2013-08-07','11:55:00',6.4),('16100','2013-08-07','12:00:00',6.46),('16100','2013-08-07','12:05:00',6.38),('16100','2013-08-07','12:10:00',6.52),('16100','2013-08-07','12:15:00',6.5),('16100','2013-08-07','12:20:00',6.65),('16100','2013-08-07','12:25:00',6.64),('16100','2013-08-07','12:30:00',6.73),('16100','2013-08-07','12:35:00',6.78),('16100','2013-08-07','12:40:00',6.82),('16100','2013-08-07','12:45:00',6.9),('16100','2013-08-07','12:50:00',6.95),('16100','2013-08-07','12:55:00',6.97),('16100','2013-08-07','13:00:00',6.99),('16100','2013-08-07','13:05:00',7),('16100','2013-08-07','13:10:00',6.96),('16100','2013-08-07','13:15:00',7),('16100','2013-08-07','13:20:00',7.02),('16100','2013-08-07','13:25:00',7.01),('16100','2013-08-07','13:30:00',6.94),('16100','2013-08-07','13:35:00',6.99),('16100','2013-08-07','13:40:00',6.95),('16100','2013-08-07','13:45:00',6.9),('16100','2013-08-07','13:50:00',6.89),('16100','2013-08-07','13:55:00',6.83),('16100','2013-08-07','14:00:00',6.86),('16100','2013-08-07','14:05:00',6.82),('16100','2013-08-07','14:10:00',6.75),('16100','2013-08-07','14:15:00',6.63),('16100','2013-08-07','14:20:00',6.65),('16100','2013-08-07','14:25:00',6.64),('16100','2013-08-07','14:30:00',6.55),('16100','2013-08-07','14:35:00',6.53),('16100','2013-08-07','14:40:00',6.5),('16100','2013-08-07','14:45:00',6.48),('16100','2013-08-07','14:50:00',6.43),('16100','2013-08-07','14:55:00',6.33),('16100','2013-08-07','15:00:00',6.24),('16100','2013-08-07','15:05:00',6.16),('16100','2013-08-07','15:10:00',6.1),('16100','2013-08-07','15:15:00',6.03),('16100','2013-08-07','15:20:00',5.97),('16100','2013-08-07','15:25:00',5.89),('16100','2013-08-07','15:30:00',5.8),('16100','2013-08-07','15:35:00',5.7),('16100','2013-08-07','15:40:00',5.59),('16100','2013-08-07','15:45:00',5.56),('16100','2013-08-07','15:50:00',5.47),('16100','2013-08-07','15:55:00',5.37),('16100','2013-08-07','16:00:00',5.33),('16100','2013-08-07','16:05:00',5.23),('16100','2013-08-07','16:10:00',5.15),('16100','2013-08-07','16:15:00',5.02),('16100','2013-08-07','16:20:00',4.85),('16100','2013-08-07','16:25:00',3.85),('16100','2013-08-07','16:30:00',4.63),('16100','2013-08-07','16:35:00',4.5),('16100','2013-08-07','16:40:00',4.41),('16100','2013-08-07','16:45:00',4.29),('16100','2013-08-07','16:50:00',4.16),('16100','2013-08-07','16:55:00',3.74),('16100','2013-08-07','17:00:00',3.2),('16100','2013-08-07','17:05:00',3.02),('16100','2013-08-07','17:10:00',3.61),('16100','2013-08-07','17:15:00',3.49),('16100','2013-08-07','17:20:00',2.66),('16100','2013-08-07','17:25:00',3.24),('16100','2013-08-07','17:30:00',2.6),('16100','2013-08-07','17:35:00',2.64),('16100','2013-08-07','17:40:00',1.9),('16100','2013-08-07','17:45:00',2.09),('16100','2013-08-07','17:50:00',1.46),('16100','2013-08-07','17:55:00',2.32),('16100','2013-08-07','18:00:00',2.17),('16100','2013-08-07','18:05:00',2.03),('16100','2013-08-07','18:10:00',1.89),('16100','2013-08-07','18:15:00',1.76),('16100','2013-08-07','18:20:00',1.61),('16100','2013-08-07','18:25:00',1.47),('16100','2013-08-07','18:30:00',1.35),('16100','2013-08-07','18:35:00',1.23),('16100','2013-08-07','18:40:00',1.09),('16100','2013-08-06','08:05:00',1.09),('16100','2013-08-06','08:10:00',1.21),('16100','2013-08-06','08:15:00',1.34),('16100','2013-08-06','08:20:00',1.5),('16100','2013-08-06','08:25:00',1.65),('16100','2013-08-06','08:30:00',1.79),('16100','2013-08-06','08:35:00',1.95),('16100','2013-08-06','08:40:00',2.13),('16100','2013-08-06','08:45:00',2.45),('16100','2013-08-06','08:50:00',2.67),('16100','2013-08-06','08:55:00',2.82),('16100','2013-08-06','09:00:00',2.97),('16100','2013-08-06','09:05:00',3.13),('16100','2013-08-06','09:10:00',3.28),('16100','2013-08-06','09:15:00',3.39),('16100','2013-08-06','09:20:00',3.51),('16100','2013-08-06','09:25:00',3.61),('16100','2013-08-06','09:30:00',3.73),('16100','2013-08-06','09:35:00',3.87),('16100','2013-08-06','09:40:00',3.92),('16100','2013-08-06','09:45:00',4.08),('16100','2013-08-06','09:50:00',4.19),('16100','2013-08-06','09:55:00',4.38),('16100','2013-08-06','10:00:00',4.5),('16100','2013-08-06','10:05:00',4.62),('16100','2013-08-06','10:10:00',4.7),('16100','2013-08-06','10:15:00',4.83),('16100','2013-08-06','10:20:00',4.93),('16100','2013-08-06','10:25:00',5.08),('16100','2013-08-06','10:30:00',5.18),('16100','2013-08-06','10:35:00',5.31),('16100','2013-08-06','10:40:00',5.38),('16100','2013-08-06','10:45:00',5.44),('16100','2013-08-06','10:50:00',5.51),('16100','2013-08-06','10:55:00',5.61),('16100','2013-08-06','11:00:00',5.68),('16100','2013-08-06','11:05:00',5.75),('16100','2013-08-06','11:10:00',5.82),('16100','2013-08-06','11:15:00',5.87),('16100','2013-08-06','11:20:00',5.95),('16100','2013-08-06','11:25:00',6.05),('16100','2013-08-06','11:30:00',6.12),('16100','2013-08-06','11:35:00',6.2),('16100','2013-08-06','11:40:00',6.27),('16100','2013-08-06','11:45:00',6.3),('16100','2013-08-06','11:50:00',6.37),('16100','2013-08-06','11:55:00',6.42),('16100','2013-08-06','12:00:00',6.42),('16100','2013-08-06','12:05:00',6.4),('16100','2013-08-06','12:10:00',6.41),('16100','2013-08-06','12:15:00',6.5),('16100','2013-08-06','12:20:00',6.56),('16100','2013-08-06','12:25:00',6.46),('16100','2013-08-06','12:30:00',6.6),('16100','2013-08-06','12:35:00',6.5),('16100','2013-08-06','12:40:00',6.62),('16100','2013-08-06','12:45:00',6.75),('16100','2013-08-06','12:50:00',6.73),('16100','2013-08-06','12:55:00',6.86),('16100','2013-08-06','13:00:00',6.86),('16100','2013-08-06','13:05:00',7.01),('16100','2013-08-06','13:10:00',6.89),('16100','2013-08-06','13:15:00',6.87),('16100','2013-08-06','13:20:00',6.96),('16100','2013-08-06','13:25:00',6.99),('16100','2013-08-06','13:30:00',6.97),('16100','2013-08-06','13:35:00',6.9),('16100','2013-08-06','13:40:00',6.99),('16100','2013-08-06','13:45:00',6.97),('16100','2013-08-06','13:50:00',6.95),('16100','2013-08-06','13:55:00',6.9),('16100','2013-08-06','14:00:00',6.88),('16100','2013-08-06','14:05:00',6.9),('16100','2013-08-06','14:10:00',6.87),('16100','2013-08-06','14:15:00',6.79),('16100','2013-08-06','14:20:00',6.76),('16100','2013-08-06','14:25:00',6.75),('16100','2013-08-06','14:30:00',6.71),('16100','2013-08-06','14:35:00',6.67),('16100','2013-08-06','14:40:00',6.66),('16100','2013-08-06','14:45:00',6.63),('16100','2013-08-06','14:50:00',6.59),('16100','2013-08-06','14:55:00',6.54),('16100','2013-08-06','15:00:00',6.5),('16100','2013-08-06','15:05:00',6.43),('16100','2013-08-06','15:10:00',6.35),('16100','2013-08-06','15:15:00',6.28),('16100','2013-08-06','15:20:00',6.15),('16100','2013-08-06','15:25:00',6.08),('16100','2013-08-06','15:30:00',5.97),('16100','2013-08-06','15:35:00',5.91),('16100','2013-08-06','15:40:00',5.81),('16100','2013-08-06','15:45:00',5.71),('16100','2013-08-06','15:50:00',5.62),('16100','2013-08-06','15:55:00',5.53),('16100','2013-08-06','16:00:00',5.46),('16100','2013-08-06','16:05:00',5.36),('16100','2013-08-06','16:10:00',5.26),('16100','2013-08-06','16:15:00',5.16),('16100','2013-08-06','16:20:00',4.99),('16100','2013-08-06','16:25:00',4.88),('16100','2013-08-06','16:30:00',4.76),('16100','2013-08-06','16:35:00',4.63),('16100','2013-08-06','16:40:00',4.51),('16100','2013-08-06','16:45:00',4.41),('16100','2013-08-06','16:50:00',4.3),('16100','2013-08-06','16:55:00',4.18),('16100','2013-08-06','17:00:00',4.05),('16100','2013-08-06','17:05:00',3.9),('16100','2013-08-06','17:10:00',3.73),('16100','2013-08-06','17:15:00',3.59),('16100','2013-08-06','17:20:00',3.46),('16100','2013-08-06','17:25:00',3.31),('16100','2013-08-06','17:30:00',3.17),('16100','2013-08-06','17:35:00',3),('16100','2013-08-06','17:40:00',2.88),('16100','2013-08-06','17:45:00',2.75),('16100','2013-08-06','17:50:00',2.61),('16100','2013-08-06','17:55:00',2.43),('16100','2013-08-06','18:00:00',2.27),('16100','2013-08-06','18:05:00',2.12),('16100','2013-08-06','18:10:00',1.98),('16100','2013-08-06','18:15:00',1.81),('16100','2013-08-06','18:20:00',1.68),('16100','2013-08-06','18:25:00',1.53),('16100','2013-08-06','18:30:00',1.4),('16100','2013-08-06','18:35:00',1.27),('16100','2013-08-05','08:05:00',1.07),('16100','2013-08-05','08:10:00',1.19),('16100','2013-08-05','08:15:00',1.31),('16100','2013-08-05','08:20:00',1.47),('16100','2013-08-05','08:25:00',1.61),('16100','2013-08-05','08:30:00',1.76),('16100','2013-08-05','08:35:00',1.92),('16100','2013-08-05','08:40:00',2.06),('16100','2013-08-05','08:45:00',2.35),('16100','2013-08-05','08:50:00',2.59),('16100','2013-08-05','08:55:00',2.75),('16100','2013-08-05','09:00:00',2.93),('16100','2013-08-05','09:05:00',3.09),('16100','2013-08-05','09:10:00',3.19),('16100','2013-08-05','09:15:00',3.28),('16100','2013-08-05','09:20:00',3.44),('16100','2013-08-05','09:25:00',3.61),('16100','2013-08-05','09:30:00',3.73),('16100','2013-08-05','09:35:00',3.88),('16100','2013-08-05','09:40:00',3.98),('16100','2013-08-05','09:45:00',4.08),('16100','2013-08-05','09:50:00',4.22),('16100','2013-08-05','09:55:00',4.35),('16100','2013-08-05','10:00:00',4.47),('16100','2013-08-05','10:05:00',4.63),('16100','2013-08-05','10:10:00',4.73),('16100','2013-08-05','10:15:00',4.89),('16100','2013-08-05','10:20:00',5.06),('16100','2013-08-05','10:25:00',5.19),('16100','2013-08-05','10:30:00',5.25),('16100','2013-08-05','10:35:00',5.32),('16100','2013-08-05','10:40:00',5.39),('16100','2013-08-05','10:45:00',5.47),('16100','2013-08-05','10:50:00',5.57),('16100','2013-08-05','10:55:00',5.65),('16100','2013-08-05','11:00:00',5.73),('16100','2013-08-05','11:05:00',5.78),('16100','2013-08-05','11:10:00',5.86),('16100','2013-08-05','11:15:00',5.98),('16100','2013-08-05','11:20:00',6.01),('16100','2013-08-05','11:25:00',6.09),('16100','2013-08-05','11:30:00',6.22),('16100','2013-08-05','11:35:00',6.22),('16100','2013-08-05','11:40:00',6.2),('16100','2013-08-05','11:45:00',6.3),('16100','2013-08-05','11:50:00',6.3),('16100','2013-08-05','11:55:00',6.36),('16100','2013-08-05','12:00:00',6.37),('16100','2013-08-05','12:05:00',6.31),('16100','2013-08-05','12:10:00',6.41),('16100','2013-08-05','12:15:00',6.46),('16100','2013-08-05','12:20:00',6.67),('16100','2013-08-05','12:25:00',6.52),('16100','2013-08-05','12:30:00',6.52),('16100','2013-08-05','12:35:00',6.6),('16100','2013-08-05','12:40:00',6.69),('16100','2013-08-05','12:45:00',6.77),('16100','2013-08-05','12:50:00',6.84),('16100','2013-08-05','12:55:00',6.83),('16100','2013-08-05','13:00:00',6.45),('16100','2013-08-05','13:05:00',6.88),('16100','2013-08-05','13:10:00',6.95),('16100','2013-08-05','13:15:00',7.03),('16100','2013-08-05','13:20:00',7.05),('16100','2013-08-05','13:25:00',7.07),('16100','2013-08-05','13:30:00',7.03),('16100','2013-08-05','13:35:00',6.9),('16100','2013-08-05','13:40:00',6.72),('16100','2013-08-05','13:45:00',7.09),('16100','2013-08-05','13:50:00',7.1),('16100','2013-08-05','13:55:00',7.08),('16100','2013-08-05','14:00:00',7.08),('16100','2013-08-05','14:05:00',7.03),('16100','2013-08-05','14:10:00',7.03),('16100','2013-08-05','14:15:00',6.95),('16100','2013-08-05','14:20:00',6.71),('16100','2013-08-05','14:25:00',6.78),('16100','2013-08-05','14:30:00',6.76),('16100','2013-08-05','14:35:00',6.73),('16100','2013-08-05','14:40:00',6.69),('16100','2013-08-05','14:45:00',6.65),('16100','2013-08-05','14:50:00',6.6),('16100','2013-08-05','14:55:00',6.55),('16100','2013-08-05','15:00:00',6.47),('16100','2013-08-05','15:05:00',6.46),('16100','2013-08-05','15:10:00',6.44),('16100','2013-08-05','15:15:00',6.36),('16100','2013-08-05','15:20:00',6.29),('16100','2013-08-05','15:25:00',6.16),('16100','2013-08-05','15:30:00',6.04),('16100','2013-08-05','15:35:00',5.96),('16100','2013-08-05','15:40:00',5.86),('16100','2013-08-05','15:45:00',5.77),('16100','2013-08-05','15:50:00',5.68),('16100','2013-08-05','15:55:00',5.58),('16100','2013-08-05','16:00:00',5.49),('16100','2013-08-05','16:05:00',5.43),('16100','2013-08-05','16:10:00',5.32),('16100','2013-08-05','16:15:00',5.2),('16100','2013-08-05','16:20:00',5.05),('16100','2013-08-05','16:25:00',4.92),('16100','2013-08-05','16:30:00',4.82),('16100','2013-08-05','16:35:00',4.7),('16100','2013-08-05','16:40:00',4.61),('16100','2013-08-05','16:45:00',4.48),('16100','2013-08-05','16:50:00',4.35),('16100','2013-08-05','16:55:00',4.23),('16100','2013-08-05','17:00:00',4.1),('16100','2013-08-05','17:05:00',3.96),('16100','2013-08-05','17:10:00',3.8),('16100','2013-08-05','17:15:00',3.68),('16100','2013-08-05','17:20:00',3.53),('16100','2013-08-05','17:25:00',3.4),('16100','2013-08-05','17:30:00',3.26),('16100','2013-08-05','17:35:00',3.07),('16100','2013-08-05','17:40:00',2.91),('16100','2013-08-05','17:45:00',2.77),('16100','2013-08-05','17:50:00',2.63),('16100','2013-08-05','17:55:00',2.46),('16100','2013-08-05','18:00:00',2.31),('16100','2013-08-05','18:05:00',2.17),('16100','2013-08-05','18:10:00',2.03),('16100','2013-08-05','18:15:00',1.9),('16100','2013-08-05','18:20:00',1.76),('16100','2013-08-05','18:25:00',1.61),('16100','2013-08-05','18:30:00',1.44),('16100','2013-08-05','18:35:00',1.29),('16100','2013-08-05','18:40:00',1.14),('16100','2013-08-04','08:05:00',1.12),('16100','2013-08-04','08:10:00',1.24),('16100','2013-08-04','08:15:00',1.37),('16100','2013-08-04','08:20:00',1.53),('16100','2013-08-04','08:25:00',1.68),('16100','2013-08-04','08:30:00',1.83),('16100','2013-08-04','08:35:00',1.98),('16100','2013-08-04','08:40:00',2.18),('16100','2013-08-04','08:45:00',2.4),('16100','2013-08-04','08:50:00',2.66),('16100','2013-08-04','08:55:00',2.83),('16100','2013-08-04','09:00:00',2.99),('16100','2013-08-04','09:05:00',3.19),('16100','2013-08-04','09:10:00',3.34),('16100','2013-08-04','09:15:00',3.47),('16100','2013-08-04','09:20:00',3.54),('16100','2013-08-04','09:25:00',3.68),('16100','2013-08-04','09:30:00',3.83),('16100','2013-08-04','09:35:00',3.95),('16100','2013-08-04','09:40:00',4.09),('16100','2013-08-04','09:45:00',4.21),('16100','2013-08-04','09:50:00',4.33),('16100','2013-08-04','09:55:00',4.43),('16100','2013-08-04','10:00:00',4.54),('16100','2013-08-04','10:05:00',4.66),('16100','2013-08-04','10:10:00',4.79),('16100','2013-08-04','10:15:00',4.95),('16100','2013-08-04','10:20:00',5.12),('16100','2013-08-04','10:25:00',5.24),('16100','2013-08-04','10:30:00',5.32),('16100','2013-08-04','10:35:00',5.41),('16100','2013-08-04','10:40:00',5.49),('16100','2013-08-04','10:45:00',5.55),('16100','2013-08-04','10:50:00',5.62),('16100','2013-08-04','10:55:00',5.7),('16100','2013-08-04','11:00:00',5.8),('16100','2013-08-04','11:05:00',5.89),('16100','2013-08-04','11:10:00',5.98),('16100','2013-08-04','11:15:00',6.13),('16100','2013-08-04','11:20:00',6.21),('16100','2013-08-04','11:25:00',6.24),('16100','2013-08-04','11:30:00',6.35),('16100','2013-08-04','11:35:00',6.39),('16100','2013-08-04','11:40:00',6.46),('16100','2013-08-04','11:45:00',6.54),('16100','2013-08-04','11:50:00',6.57),('16100','2013-08-04','11:55:00',6.65),('16100','2013-08-04','12:00:00',6.69),('16100','2013-08-04','12:05:00',6.76),('16100','2013-08-04','12:10:00',6.77),('16100','2013-08-04','12:15:00',6.82),('16100','2013-08-04','12:20:00',6.91),('16100','2013-08-04','12:25:00',6.84),('16100','2013-08-04','12:30:00',6.84),('16100','2013-08-04','12:35:00',6.87),('16100','2013-08-04','12:40:00',6.87),('16100','2013-08-04','12:45:00',6.96),('16100','2013-08-04','12:50:00',6.95),('16100','2013-08-04','12:55:00',6.99),('16100','2013-08-04','13:00:00',7),('16100','2013-08-04','13:05:00',6.98),('16100','2013-08-04','13:10:00',7),('16100','2013-08-04','13:15:00',7.03),('16100','2013-08-04','13:20:00',7.06),('16100','2013-08-04','13:25:00',7.01),('16100','2013-08-04','13:30:00',6.99),('16100','2013-08-04','13:35:00',6.98),('16100','2013-08-04','13:40:00',6.97),('16100','2013-08-04','13:45:00',6.95),('16100','2013-08-04','13:50:00',6.94),('16100','2013-08-04','13:55:00',6.89),('16100','2013-08-04','14:00:00',6.86),('16100','2013-08-04','14:05:00',6.8),('16100','2013-08-04','14:10:00',6.83),('16100','2013-08-04','14:15:00',6.75),('16100','2013-08-04','14:20:00',6.79),('16100','2013-08-04','14:25:00',6.76),('16100','2013-08-04','14:30:00',6.71),('16100','2013-08-04','14:35:00',6.61),('16100','2013-08-04','14:40:00',6.56),('16100','2013-08-04','14:45:00',6.53),('16100','2013-08-04','14:50:00',6.46),('16100','2013-08-04','14:55:00',6.43),('16100','2013-08-04','15:00:00',6.4),('16100','2013-08-04','15:05:00',6.36),('16100','2013-08-04','15:10:00',6.28),('16100','2013-08-04','15:15:00',6.18),('16100','2013-08-04','15:20:00',6.15),('16100','2013-08-04','15:25:00',6.1),('16100','2013-08-04','15:30:00',5.99),('16100','2013-08-04','15:35:00',5.92),('16100','2013-08-04','15:40:00',5.85),('16100','2013-08-04','15:45:00',5.76),('16100','2013-08-04','15:50:00',5.68),('16100','2013-08-04','15:55:00',5.58),('16100','2013-08-04','16:00:00',5.45),('16100','2013-08-04','16:05:00',5.37),('16100','2013-08-04','16:10:00',5.29),('16100','2013-08-04','16:15:00',5.19),('16100','2013-08-04','16:20:00',5.02),('16100','2013-08-04','16:25:00',4.9),('16100','2013-08-04','16:30:00',4.81),('16100','2013-08-04','16:35:00',4.68),('16100','2013-08-04','16:40:00',4.54),('16100','2013-08-04','16:45:00',4.43),('16100','2013-08-04','16:50:00',4.3),('16100','2013-08-04','16:55:00',4.19),('16100','2013-08-04','17:00:00',4.05),('16100','2013-08-04','17:05:00',3.9),('16100','2013-08-04','17:10:00',3.71),('16100','2013-08-04','17:15:00',3.62),('16100','2013-08-04','17:20:00',3.49),('16100','2013-08-04','17:25:00',3.36),('16100','2013-08-04','17:30:00',3.23),('16100','2013-08-04','17:35:00',3.06),('16100','2013-08-04','17:40:00',2.92),('16100','2013-08-04','17:45:00',2.75),('16100','2013-08-04','17:50:00',2.59),('16100','2013-08-04','17:55:00',2.43),('16100','2013-08-04','18:00:00',2.27),('16100','2013-08-04','18:05:00',2.12),('16100','2013-08-04','18:10:00',1.97),('16100','2013-08-04','18:15:00',1.86),('16100','2013-08-04','18:20:00',1.73),('16100','2013-08-04','18:25:00',1.59),('16100','2013-08-04','18:30:00',1.44),('16100','2013-08-04','18:35:00',1.32),('16100','2013-08-04','18:40:00',1.16),('16100','2013-08-04','18:45:00',1),('16100','2013-08-03','08:00:00',1.02);
INSERT INTO `solarlogmod` VALUES ('16100','2013-08-03','08:05:00',1.15),('16100','2013-08-03','08:10:00',1.27),('16100','2013-08-03','08:15:00',1.42),('16100','2013-08-03','08:20:00',1.59),('16100','2013-08-03','08:25:00',1.75),('16100','2013-08-03','08:30:00',1.91),('16100','2013-08-03','08:35:00',2.07),('16100','2013-08-03','08:40:00',2.18),('16100','2013-08-03','08:45:00',2.42),('16100','2013-08-03','08:50:00',2.73),('16100','2013-08-03','08:55:00',2.97),('16100','2013-08-03','09:00:00',3.14),('16100','2013-08-03','09:05:00',3.31),('16100','2013-08-03','09:10:00',3.46),('16100','2013-08-03','09:15:00',3.59),('16100','2013-08-03','09:20:00',3.73),('16100','2013-08-03','09:25:00',3.86),('16100','2013-08-03','09:30:00',3.96),('16100','2013-08-03','09:35:00',4.1),('16100','2013-08-03','09:40:00',4.23),('16100','2013-08-03','09:45:00',4.36),('16100','2013-08-03','09:50:00',4.51),('16100','2013-08-03','09:55:00',4.65),('16100','2013-08-03','10:00:00',4.73),('16100','2013-08-03','10:05:00',4.83),('16100','2013-08-03','10:10:00',4.92),('16100','2013-08-03','10:15:00',5.08),('16100','2013-08-03','10:20:00',5.25),('16100','2013-08-03','10:25:00',5.39),('16100','2013-08-03','10:30:00',5.44),('16100','2013-08-03','10:35:00',5.52),('16100','2013-08-03','10:40:00',5.61),('16100','2013-08-03','10:45:00',5.7),('16100','2013-08-03','10:50:00',5.78),('16100','2013-08-03','10:55:00',5.89),('16100','2013-08-03','11:00:00',6.03),('16100','2013-08-03','11:05:00',6.16),('16100','2013-08-03','11:10:00',6.27),('16100','2013-08-03','11:15:00',6.31),('16100','2013-08-03','11:20:00',6.4),('16100','2013-08-03','11:25:00',6.47),('16100','2013-08-03','11:30:00',6.49),('16100','2013-08-03','11:35:00',6.5),('16100','2013-08-03','11:40:00',6.59),('16100','2013-08-03','11:45:00',6.76),('16100','2013-08-03','11:50:00',6.72),('16100','2013-08-03','11:55:00',6.81),('16100','2013-08-03','12:00:00',6.91),('16100','2013-08-03','12:05:00',6.85),('16100','2013-08-03','12:10:00',6.88),('16100','2013-08-03','12:15:00',6.89),('16100','2013-08-03','12:20:00',6.88),('16100','2013-08-03','12:25:00',6.9),('16100','2013-08-03','12:30:00',6.95),('16100','2013-08-03','12:35:00',7.01),('16100','2013-08-03','12:40:00',7.05),('16100','2013-08-03','12:45:00',7.06),('16100','2013-08-03','12:50:00',7.06),('16100','2013-08-03','12:55:00',7.11),('16100','2013-08-03','13:00:00',7.17),('16100','2013-08-03','13:05:00',7.14),('16100','2013-08-03','13:10:00',7.11),('16100','2013-08-03','13:15:00',7.17),('16100','2013-08-03','13:20:00',7.21),('16100','2013-08-03','13:25:00',7.25),('16100','2013-08-03','13:30:00',7.24),('16100','2013-08-03','13:35:00',7.23),('16100','2013-08-03','13:40:00',7.22),('16100','2013-08-03','13:45:00',7.21),('16100','2013-08-03','13:50:00',7.18),('16100','2013-08-03','13:55:00',7.18),('16100','2013-08-03','14:00:00',7.14),('16100','2013-08-03','14:05:00',7.14),('16100','2013-08-03','14:10:00',7.13),('16100','2013-08-03','14:15:00',7.02),('16100','2013-08-03','14:20:00',6.97),('16100','2013-08-03','14:25:00',6.91),('16100','2013-08-03','14:30:00',6.9),('16100','2013-08-03','14:35:00',6.86),('16100','2013-08-03','14:40:00',6.83),('16100','2013-08-03','14:45:00',6.81),('16100','2013-08-03','14:50:00',6.74),('16100','2013-08-03','14:55:00',5.31),('16100','2013-08-03','15:00:00',5.33),('16100','2013-08-03','15:05:00',6.55),('16100','2013-08-03','15:10:00',6.5),('16100','2013-08-03','15:15:00',6.4),('16100','2013-08-03','15:20:00',6.3),('16100','2013-08-03','15:25:00',6.26),('16100','2013-08-03','15:30:00',6.18),('16100','2013-08-03','15:35:00',6.11),('16100','2013-08-03','15:40:00',6.03),('16100','2013-08-03','15:45:00',5.89),('16100','2013-08-03','15:50:00',5.93),('16100','2013-08-03','15:55:00',5.82),('16100','2013-08-03','16:00:00',5.66),('16100','2013-08-03','16:05:00',5.52),('16100','2013-08-03','16:10:00',5.46),('16100','2013-08-03','16:15:00',5.32),('16100','2013-08-03','16:20:00',5.07),('16100','2013-08-03','16:25:00',5.02),('16100','2013-08-03','16:30:00',4.9),('16100','2013-08-03','16:35:00',4.81),('16100','2013-08-03','16:40:00',4.69),('16100','2013-08-03','16:45:00',4.66),('16100','2013-08-03','16:50:00',4.46),('16100','2013-08-03','16:55:00',4.3),('16100','2013-08-03','17:00:00',4.17),('16100','2013-08-03','17:05:00',4.06),('16100','2013-08-03','17:10:00',3.91),('16100','2013-08-03','17:15:00',3.75),('16100','2013-08-03','17:20:00',3.62),('16100','2013-08-03','17:25:00',3.46),('16100','2013-08-03','17:30:00',3.31),('16100','2013-08-03','17:35:00',3.14),('16100','2013-08-03','17:40:00',2.98),('16100','2013-08-03','17:45:00',2.82),('16100','2013-08-03','17:50:00',2.62),('16100','2013-08-03','17:55:00',2.47),('16100','2013-08-03','18:00:00',2.33),('16100','2013-08-03','18:05:00',2.14),('16100','2013-08-03','18:10:00',2.01),('16100','2013-08-03','18:15:00',1.88),('16100','2013-08-03','18:20:00',1.73),('16100','2013-08-03','18:25:00',1.59),('16100','2013-08-03','18:30:00',1.44),('16100','2013-08-03','18:35:00',1.3),('16100','2013-08-03','18:40:00',1.14),('16100','2013-08-02','08:00:00',1.03),('16100','2013-08-02','08:05:00',1.16),('16100','2013-08-02','08:10:00',1.28),('16100','2013-08-02','08:15:00',1.44),('16100','2013-08-02','08:20:00',1.61),('16100','2013-08-02','08:25:00',1.78),('16100','2013-08-02','08:30:00',1.96),('16100','2013-08-02','08:35:00',2.11),('16100','2013-08-02','08:40:00',2.28),('16100','2013-08-02','08:45:00',2.49),('16100','2013-08-02','08:50:00',2.73),('16100','2013-08-02','08:55:00',2.99),('16100','2013-08-02','09:00:00',3.16),('16100','2013-08-02','09:05:00',3.36),('16100','2013-08-02','09:10:00',3.49),('16100','2013-08-02','09:15:00',3.62),('16100','2013-08-02','09:20:00',3.74),('16100','2013-08-02','09:25:00',3.87),('16100','2013-08-02','09:30:00',3.96),('16100','2013-08-02','09:35:00',4.14),('16100','2013-08-02','09:40:00',4.29),('16100','2013-08-02','09:45:00',4.42),('16100','2013-08-02','09:50:00',4.54),('16100','2013-08-02','09:55:00',4.66),('16100','2013-08-02','10:00:00',4.75),('16100','2013-08-02','10:05:00',4.87),('16100','2013-08-02','10:10:00',4.97),('16100','2013-08-02','10:15:00',5.11),('16100','2013-08-02','10:20:00',5.24),('16100','2013-08-02','10:25:00',5.33),('16100','2013-08-02','10:30:00',5.42),('16100','2013-08-02','10:35:00',5.5),('16100','2013-08-02','10:40:00',5.56),('16100','2013-08-02','10:45:00',5.65),('16100','2013-08-02','10:50:00',5.82),('16100','2013-08-02','10:55:00',5.91),('16100','2013-08-02','11:00:00',5.95),('16100','2013-08-02','11:05:00',6.07),('16100','2013-08-02','11:10:00',6.18),('16100','2013-08-02','11:15:00',6.24),('16100','2013-08-02','11:20:00',6.3),('16100','2013-08-02','11:25:00',6.4),('16100','2013-08-02','11:30:00',6.39),('16100','2013-08-02','11:35:00',6.46),('16100','2013-08-02','11:40:00',6.55),('16100','2013-08-02','11:45:00',6.61),('16100','2013-08-02','11:50:00',6.71),('16100','2013-08-02','11:55:00',6.78),('16100','2013-08-02','12:00:00',6.82),('16100','2013-08-02','12:05:00',6.83),('16100','2013-08-02','12:10:00',6.8),('16100','2013-08-02','12:15:00',6.76),('16100','2013-08-02','12:20:00',6.71),('16100','2013-08-02','12:25:00',6.88),('16100','2013-08-02','12:30:00',6.9),('16100','2013-08-02','12:35:00',6.85),('16100','2013-08-02','12:40:00',6.8),('16100','2013-08-02','12:45:00',6.89),('16100','2013-08-02','12:50:00',7.01),('16100','2013-08-02','12:55:00',7.06),('16100','2013-08-02','13:00:00',6.95),('16100','2013-08-02','13:05:00',6.88),('16100','2013-08-02','13:10:00',6.89),('16100','2013-08-02','13:15:00',6.92),('16100','2013-08-02','13:20:00',7.01),('16100','2013-08-02','13:25:00',7.04),('16100','2013-08-02','13:30:00',6.94),('16100','2013-08-02','13:35:00',6.88),('16100','2013-08-02','13:40:00',6.91),('16100','2013-08-02','13:45:00',6.68),('16100','2013-08-02','13:50:00',6.97),('16100','2013-08-02','13:55:00',6.58),('16100','2013-08-02','14:00:00',6.6),('16100','2013-08-02','14:05:00',6.83),('16100','2013-08-02','14:10:00',6.88),('16100','2013-08-02','14:15:00',6.9),('16100','2013-08-02','14:20:00',6.87),('16100','2013-08-02','14:25:00',6.85),('16100','2013-08-02','14:30:00',6.79),('16100','2013-08-02','14:35:00',6.76),('16100','2013-08-02','14:40:00',6.79),('16100','2013-08-02','14:45:00',6.8),('16100','2013-08-02','14:50:00',6.73),('16100','2013-08-02','14:55:00',6.65),('16100','2013-08-02','15:00:00',6.61),('16100','2013-08-02','15:05:00',6.54),('16100','2013-08-02','15:10:00',6.45),('16100','2013-08-02','15:15:00',6.36),('16100','2013-08-02','15:20:00',6.31),('16100','2013-08-02','15:25:00',6.23),('16100','2013-08-02','15:30:00',6.14),('16100','2013-08-02','15:35:00',6.03),('16100','2013-08-02','15:40:00',5.99),('16100','2013-08-02','15:45:00',5.95),('16100','2013-08-02','15:50:00',5.87),('16100','2013-08-02','15:55:00',5.77),('16100','2013-08-02','16:00:00',5.67),('16100','2013-08-02','16:05:00',5.59),('16100','2013-08-02','16:10:00',5.45),('16100','2013-08-02','16:15:00',5.31),('16100','2013-08-02','16:20:00',5.17),('16100','2013-08-02','16:25:00',5.04),('16100','2013-08-02','16:30:00',4.91),('16100','2013-08-02','16:35:00',4.81),('16100','2013-08-02','16:40:00',4.7),('16100','2013-08-02','16:45:00',4.57),('16100','2013-08-02','16:50:00',4.45),('16100','2013-08-02','16:55:00',4.34),('16100','2013-08-02','17:00:00',4.22),('16100','2013-08-02','17:05:00',4.09),('16100','2013-08-02','17:10:00',3.92),('16100','2013-08-02','17:15:00',3.79),('16100','2013-08-02','17:20:00',3.65),('16100','2013-08-02','17:25:00',3.51),('16100','2013-08-02','17:30:00',3.38),('16100','2013-08-02','17:35:00',3.22),('16100','2013-08-02','17:40:00',3.06),('16100','2013-08-02','17:45:00',2.9),('16100','2013-08-02','17:50:00',2.74),('16100','2013-08-02','17:55:00',2.59),('16100','2013-08-02','18:00:00',2.43),('16100','2013-08-02','18:05:00',2.29),('16100','2013-08-02','18:10:00',2.15),('16100','2013-08-02','18:15:00',1.99),('16100','2013-08-02','18:20:00',1.84),('16100','2013-08-02','18:25:00',1.69),('16100','2013-08-02','18:30:00',1.55),('16100','2013-08-02','18:35:00',1.4),('16100','2013-08-02','18:40:00',1.22),('16100','2013-08-02','18:45:00',1.05),('16100','2013-08-01','08:00:00',1.06),('16100','2013-08-01','08:05:00',1.21),('16100','2013-08-01','08:10:00',1.34),('16100','2013-08-01','08:15:00',1.52),('16100','2013-08-01','08:20:00',1.68),('16100','2013-08-01','08:25:00',1.85),('16100','2013-08-01','08:30:00',2.04),('16100','2013-08-01','08:35:00',2.2),('16100','2013-08-01','08:40:00',2.34),('16100','2013-08-01','08:45:00',2.53),('16100','2013-08-01','08:50:00',2.76),('16100','2013-08-01','08:55:00',3.08),('16100','2013-08-01','09:00:00',3.29),('16100','2013-08-01','09:05:00',3.48),('16100','2013-08-01','09:10:00',3.61),('16100','2013-08-01','09:15:00',3.76),('16100','2013-08-01','09:20:00',3.89),('16100','2013-08-01','09:25:00',4.03),('16100','2013-08-01','09:30:00',4.16),('16100','2013-08-01','09:35:00',4.31),('16100','2013-08-01','09:40:00',4.4),('16100','2013-08-01','09:45:00',4.52),('16100','2013-08-01','09:50:00',4.65),('16100','2013-08-01','09:55:00',4.77),('16100','2013-08-01','10:00:00',4.88),('16100','2013-08-01','10:05:00',4.97),('16100','2013-08-01','10:10:00',5.06),('16100','2013-08-01','10:15:00',5.24),('16100','2013-08-01','10:20:00',5.35),('16100','2013-08-01','10:25:00',5.44),('16100','2013-08-01','10:30:00',5.54),('16100','2013-08-01','10:35:00',5.65),('16100','2013-08-01','10:40:00',5.77),('16100','2013-08-01','10:45:00',5.89),('16100','2013-08-01','10:50:00',5.95),('16100','2013-08-01','10:55:00',6.03),('16100','2013-08-01','11:00:00',6.08),('16100','2013-08-01','11:05:00',6.2),('16100','2013-08-01','11:10:00',6.29),('16100','2013-08-01','11:15:00',6.37),('16100','2013-08-01','11:20:00',6.38),('16100','2013-08-01','11:25:00',6.44),('16100','2013-08-01','11:30:00',6.5),('16100','2013-08-01','11:35:00',6.6),('16100','2013-08-01','11:40:00',6.66),('16100','2013-08-01','11:45:00',6.7),('16100','2013-08-01','11:50:00',6.79),('16100','2013-08-01','11:55:00',6.83),('16100','2013-08-01','12:00:00',6.86),('16100','2013-08-01','12:05:00',6.89),('16100','2013-08-01','12:10:00',6.95),('16100','2013-08-01','12:15:00',7),('16100','2013-08-01','12:20:00',7),('16100','2013-08-01','12:25:00',6.99),('16100','2013-08-01','12:30:00',7.02),('16100','2013-08-01','12:35:00',7.09),('16100','2013-08-01','12:40:00',7.11),('16100','2013-08-01','12:45:00',7.17),('16100','2013-08-01','12:50:00',7.23),('16100','2013-08-01','12:55:00',7.23),('16100','2013-08-01','13:00:00',7.22),('16100','2013-08-01','13:05:00',7.17),('16100','2013-08-01','13:10:00',7.18),('16100','2013-08-01','13:15:00',7.16),('16100','2013-08-01','13:20:00',7.15),('16100','2013-08-01','13:25:00',7.08),('16100','2013-08-01','13:30:00',7.08),('16100','2013-08-01','13:35:00',7.08),('16100','2013-08-01','13:40:00',7.03),('16100','2013-08-01','13:45:00',7.06),('16100','2013-08-01','13:50:00',7.03),('16100','2013-08-01','13:55:00',6.93),('16100','2013-08-01','14:00:00',6.84),('16100','2013-08-01','14:05:00',7.07),('16100','2013-08-01','14:10:00',6.98),('16100','2013-08-01','14:15:00',6.77),('16100','2013-08-01','14:20:00',6.66),('16100','2013-08-01','14:25:00',6.75),('16100','2013-08-01','14:30:00',6.8),('16100','2013-08-01','14:35:00',6.79),('16100','2013-08-01','14:40:00',6.79),('16100','2013-08-01','14:45:00',6.79),('16100','2013-08-01','14:50:00',6.74),('16100','2013-08-01','14:55:00',6.67),('16100','2013-08-01','15:00:00',6.58),('16100','2013-08-01','15:05:00',6.57),('16100','2013-08-01','15:10:00',6.51),('16100','2013-08-01','15:15:00',6.46),('16100','2013-08-01','15:20:00',6.39),('16100','2013-08-01','15:25:00',6.33),('16100','2013-08-01','15:30:00',6.19),('16100','2013-08-01','15:35:00',6.11),('16100','2013-08-01','15:40:00',6.05),('16100','2013-08-01','15:45:00',5.98),('16100','2013-08-01','15:50:00',5.9),('16100','2013-08-01','15:55:00',5.83),('16100','2013-08-01','16:00:00',5.78),('16100','2013-08-01','16:05:00',5.68),('16100','2013-08-01','16:10:00',5.55),('16100','2013-08-01','16:15:00',5.41),('16100','2013-08-01','16:20:00',5.25),('16100','2013-08-01','16:25:00',5.06),('16100','2013-08-01','16:30:00',4.98),('16100','2013-08-01','16:35:00',4.86),('16100','2013-08-01','16:40:00',4.76),('16100','2013-08-01','16:45:00',4.65),('16100','2013-08-01','16:50:00',4.45),('16100','2013-08-01','16:55:00',4.34),('16100','2013-08-01','17:00:00',4.28),('16100','2013-08-01','17:05:00',4.18),('16100','2013-08-01','17:10:00',3.99),('16100','2013-08-01','17:15:00',3.86),('16100','2013-08-01','17:20:00',3.73),('16100','2013-08-01','17:25:00',3.57),('16100','2013-08-01','17:30:00',3.41),('16100','2013-08-01','17:35:00',3.27),('16100','2013-08-01','17:40:00',3.12),('16100','2013-08-01','17:45:00',2.93),('16100','2013-08-01','17:50:00',2.8),('16100','2013-08-01','17:55:00',2.65),('16100','2013-08-01','18:00:00',2.5),('16100','2013-08-01','18:05:00',2.35),('16100','2013-08-01','18:10:00',2.2),('16100','2013-08-01','18:15:00',2.04),('16100','2013-08-01','18:20:00',1.88),('16100','2013-08-01','18:25:00',1.73),('16100','2013-08-01','18:30:00',1.58),('16100','2013-08-01','18:35:00',1.42),('16100','2013-08-01','18:40:00',1.25),('16100','2013-08-01','18:45:00',1.09),('16100','2013-07-31','08:00:00',1.09),('16100','2013-07-31','08:05:00',1.24),('16100','2013-07-31','08:10:00',1.39),('16100','2013-07-31','08:15:00',1.54),('16100','2013-07-31','08:20:00',1.69),('16100','2013-07-31','08:25:00',1.87),('16100','2013-07-31','08:30:00',2.05),('16100','2013-07-31','08:35:00',2.2),('16100','2013-07-31','08:40:00',2.36),('16100','2013-07-31','08:45:00',2.59),('16100','2013-07-31','08:50:00',2.8),('16100','2013-07-31','08:55:00',3.13),('16100','2013-07-31','09:00:00',3.33),('16100','2013-07-31','09:05:00',3.53),('16100','2013-07-31','09:10:00',3.7),('16100','2013-07-31','09:15:00',3.85),('16100','2013-07-31','09:20:00',4.01),('16100','2013-07-31','09:25:00',4.15),('16100','2013-07-31','09:30:00',4.31),('16100','2013-07-31','09:35:00',4.5),('16100','2013-07-31','09:40:00',4.65),('16100','2013-07-31','09:45:00',4.76),('16100','2013-07-31','09:50:00',4.89),('16100','2013-07-31','09:55:00',5.02),('16100','2013-07-31','10:00:00',5.16),('16100','2013-07-31','10:05:00',5.25),('16100','2013-07-31','10:10:00',5.38),('16100','2013-07-31','10:15:00',5.6),('16100','2013-07-31','10:20:00',5.74),('16100','2013-07-31','10:25:00',5.85),('16100','2013-07-31','10:30:00',5.96),('16100','2013-07-31','10:35:00',6.11),('16100','2013-07-31','10:40:00',6.18),('16100','2013-07-31','10:45:00',6.27),('16100','2013-07-31','10:50:00',6.36),('16100','2013-07-31','10:55:00',6.44),('16100','2013-07-31','11:00:00',6.53),('16100','2013-07-31','11:05:00',6.64),('16100','2013-07-31','11:10:00',6.75),('16100','2013-07-31','11:15:00',6.85),('16100','2013-07-31','11:20:00',6.87),('16100','2013-07-31','11:25:00',6.9),('16100','2013-07-31','11:30:00',6.97),('16100','2013-07-31','11:35:00',7.05),('16100','2013-07-31','11:40:00',7.06),('16100','2013-07-31','11:45:00',7.09),('16100','2013-07-31','11:50:00',7.21),('16100','2013-07-31','11:55:00',7.28),('16100','2013-07-31','12:00:00',7.35),('16100','2013-07-31','12:05:00',7.42),('16100','2013-07-31','12:10:00',7.49),('16100','2013-07-31','12:15:00',7.49),('16100','2013-07-31','12:20:00',7.53),('16100','2013-07-31','12:25:00',7.52),('16100','2013-07-31','12:30:00',7.51),('16100','2013-07-31','12:35:00',7.57),('16100','2013-07-31','12:40:00',7.59),('16100','2013-07-31','12:45:00',7.61),('16100','2013-07-31','12:50:00',7.62),('16100','2013-07-31','12:55:00',7.64),('16100','2013-07-31','13:00:00',7.69),('16100','2013-07-31','13:05:00',7.69),('16100','2013-07-31','13:10:00',7.68),('16100','2013-07-31','13:15:00',7.67),('16100','2013-07-31','13:20:00',7.68),('16100','2013-07-31','13:25:00',7.71),('16100','2013-07-31','13:30:00',7.72),('16100','2013-07-31','13:35:00',7.68),('16100','2013-07-31','13:40:00',7.65),('16100','2013-07-31','13:45:00',7.61),('16100','2013-07-31','13:50:00',7.6),('16100','2013-07-31','13:55:00',7.6),('16100','2013-07-31','14:00:00',7.58),('16100','2013-07-31','14:05:00',7.54),('16100','2013-07-31','14:10:00',7.45),('16100','2013-07-31','14:15:00',7.29),('16100','2013-07-31','14:20:00',7.27),('16100','2013-07-31','14:25:00',7.25),('16100','2013-07-31','14:30:00',7.21),('16100','2013-07-31','14:35:00',7.16),('16100','2013-07-31','14:40:00',7.08),('16100','2013-07-31','14:45:00',7.02),('16100','2013-07-31','14:50:00',6.98),('16100','2013-07-31','14:55:00',6.97),('16100','2013-07-31','15:00:00',6.92),('16100','2013-07-31','15:05:00',6.82),('16100','2013-07-31','15:10:00',6.72),('16100','2013-07-31','15:15:00',6.68),('16100','2013-07-31','15:20:00',6.56),('16100','2013-07-31','15:25:00',6.45),('16100','2013-07-31','15:30:00',6.38),('16100','2013-07-31','15:35:00',6.31),('16100','2013-07-31','15:40:00',6.29),('16100','2013-07-31','15:45:00',6.14),('16100','2013-07-31','15:50:00',6.05),('16100','2013-07-31','15:55:00',5.93),('16100','2013-07-31','16:00:00',5.81),('16100','2013-07-31','16:05:00',5.74),('16100','2013-07-31','16:10:00',5.66),('16100','2013-07-31','16:15:00',5.52),('16100','2013-07-31','16:20:00',5.38),('16100','2013-07-31','16:25:00',5.16),('16100','2013-07-31','16:30:00',5.06),('16100','2013-07-31','16:35:00',4.98),('16100','2013-07-31','16:40:00',4.88),('16100','2013-07-31','16:45:00',4.74),('16100','2013-07-31','16:50:00',4.62),('16100','2013-07-31','16:55:00',4.51),('16100','2013-07-31','17:00:00',4.39),('16100','2013-07-31','17:05:00',4.26),('16100','2013-07-31','17:10:00',4.06),('16100','2013-07-31','17:15:00',3.92),('16100','2013-07-31','17:20:00',3.8),('16100','2013-07-31','17:25:00',3.61),('16100','2013-07-31','17:30:00',3.48),('16100','2013-07-31','17:35:00',3.34),('16100','2013-07-31','17:40:00',3.2),('16100','2013-07-31','17:45:00',3),('16100','2013-07-31','17:50:00',2.86),('16100','2013-07-31','17:55:00',2.66),('16100','2013-07-31','18:00:00',2.55),('16100','2013-07-31','18:05:00',2.41),('16100','2013-07-31','18:10:00',2.25),('16100','2013-07-31','18:15:00',2.09),('16100','2013-07-31','18:20:00',1.94),('16100','2013-07-31','18:25:00',1.78),('16100','2013-07-31','18:30:00',1.63),('16100','2013-07-31','18:35:00',1.47),('16100','2013-07-31','18:40:00',1.27),('16100','2013-07-31','18:45:00',1.13),('16100','2013-07-30','08:00:00',1.11),('16100','2013-07-30','08:05:00',1.24),('16100','2013-07-30','08:10:00',1.38),('16100','2013-07-30','08:15:00',1.54),('16100','2013-07-30','08:20:00',1.71),('16100','2013-07-30','08:25:00',1.88),('16100','2013-07-30','08:30:00',2.04),('16100','2013-07-30','08:35:00',2.2),('16100','2013-07-30','08:40:00',2.36),('16100','2013-07-30','08:45:00',2.56),('16100','2013-07-30','08:50:00',2.73),('16100','2013-07-30','08:55:00',3.07),('16100','2013-07-30','09:00:00',3.34),('16100','2013-07-30','09:05:00',3.49),('16100','2013-07-30','09:10:00',3.65),('16100','2013-07-30','09:15:00',3.78),('16100','2013-07-30','09:20:00',3.96),('16100','2013-07-30','09:25:00',4.07),('16100','2013-07-30','09:30:00',4.23),('16100','2013-07-30','09:35:00',4.39),('16100','2013-07-30','09:40:00',4.5),('16100','2013-07-30','09:45:00',4.61),('16100','2013-07-30','09:50:00',4.75),('16100','2013-07-30','09:55:00',4.9),('16100','2013-07-30','10:00:00',5.02),('16100','2013-07-30','10:05:00',5.12),('16100','2013-07-30','10:10:00',5.25),('16100','2013-07-30','10:15:00',5.42),('16100','2013-07-30','10:20:00',5.5),('16100','2013-07-30','10:25:00',5.6),('16100','2013-07-30','10:30:00',5.8),('16100','2013-07-30','10:35:00',5.9),('16100','2013-07-30','10:40:00',6.01),('16100','2013-07-30','10:45:00',6.11),('16100','2013-07-30','10:50:00',6.17),('16100','2013-07-30','10:55:00',6.29),('16100','2013-07-30','11:00:00',6.35),('16100','2013-07-30','11:05:00',6.49),('16100','2013-07-30','11:10:00',6.6),('16100','2013-07-30','11:15:00',6.67),('16100','2013-07-30','11:20:00',6.71),('16100','2013-07-30','11:25:00',6.79),('16100','2013-07-30','11:30:00',6.83),('16100','2013-07-30','11:35:00',6.91),('16100','2013-07-30','11:40:00',6.96),('16100','2013-07-30','11:45:00',7.08),('16100','2013-07-30','11:50:00',7.12),('16100','2013-07-30','11:55:00',7.24),('16100','2013-07-30','12:00:00',7.27),('16100','2013-07-30','12:05:00',7.35),('16100','2013-07-30','12:10:00',7.39),('16100','2013-07-30','12:15:00',7.39),('16100','2013-07-30','12:20:00',7.46),('16100','2013-07-30','12:25:00',7.52),('16100','2013-07-30','12:30:00',7.49),('16100','2013-07-30','12:35:00',7.52),('16100','2013-07-30','12:40:00',7.56),('16100','2013-07-30','12:45:00',7.54),('16100','2013-07-30','12:50:00',7.55),('16100','2013-07-30','12:55:00',7.6),('16100','2013-07-30','13:00:00',7.63),('16100','2013-07-30','13:05:00',7.64),('16100','2013-07-30','13:10:00',7.65),('16100','2013-07-30','13:15:00',7.64),('16100','2013-07-30','13:20:00',7.64),('16100','2013-07-30','13:25:00',7.55),('16100','2013-07-30','13:30:00',7.56),('16100','2013-07-30','13:35:00',7.57),('16100','2013-07-30','13:40:00',7.29),('16100','2013-07-30','13:45:00',7.58),('16100','2013-07-30','13:50:00',7.16),('16100','2013-07-30','13:55:00',3.33),('16100','2013-07-30','14:00:00',7.7),('16100','2013-07-30','14:05:00',7.5),('16100','2013-07-30','14:10:00',7.2),('16100','2013-07-30','14:15:00',4.83),('16100','2013-07-30','14:20:00',7.45),('16100','2013-07-30','14:25:00',7.32),('16100','2013-07-30','14:30:00',7.25),('16100','2013-07-30','14:35:00',7.16),('16100','2013-07-30','14:40:00',7.14),('16100','2013-07-30','14:45:00',6.99),('16100','2013-07-30','14:50:00',6.97),('16100','2013-07-30','14:55:00',7.07),('16100','2013-07-30','15:00:00',6.9),('16100','2013-07-30','15:05:00',6.84),('16100','2013-07-30','15:10:00',6.86),('16100','2013-07-30','15:15:00',6.72),('16100','2013-07-30','15:20:00',6.6),('16100','2013-07-30','15:25:00',6.46),('16100','2013-07-30','15:30:00',6.37),('16100','2013-07-30','15:35:00',6.25),('16100','2013-07-30','15:40:00',6.04),('16100','2013-07-30','15:45:00',3.42),('16100','2013-07-30','15:50:00',5.36),('16100','2013-07-30','15:55:00',1.73),('16100','2013-07-30','16:00:00',5.63),('16100','2013-07-30','16:05:00',5.71),('16100','2013-07-30','16:10:00',4.97),('16100','2013-07-30','16:15:00',2.29),('16100','2013-07-30','16:20:00',5.52),('16100','2013-07-30','16:25:00',5.21),('16100','2013-07-30','16:30:00',5.14),('16100','2013-07-30','16:35:00',5.01),('16100','2013-07-30','16:40:00',4.87),('16100','2013-07-30','16:45:00',4.83),('16100','2013-07-30','16:50:00',4.75),('16100','2013-07-30','16:55:00',4.56),('16100','2013-07-30','17:00:00',4.47),('16100','2013-07-30','17:05:00',4.37),('16100','2013-07-30','17:10:00',4.22),('16100','2013-07-30','17:15:00',4.01),('16100','2013-07-30','17:20:00',3.79),('16100','2013-07-30','17:25:00',3.58),('16100','2013-07-30','17:30:00',3.44),('16100','2013-07-30','17:35:00',3.31),('16100','2013-07-30','17:40:00',3.13),('16100','2013-07-30','17:45:00',3.02),('16100','2013-07-30','17:50:00',2.89),('16100','2013-07-30','17:55:00',2.75),('16100','2013-07-30','18:00:00',2.59),('16100','2013-07-30','18:05:00',2.44),('16100','2013-07-30','18:10:00',2.28),('16100','2013-07-30','18:15:00',2.15),('16100','2013-07-30','18:20:00',2.02),('16100','2013-07-30','18:25:00',1.87),('16100','2013-07-30','18:30:00',1.72),('16100','2013-07-30','18:35:00',1.53),('16100','2013-07-30','18:40:00',1.33),('16100','2013-07-30','18:45:00',1.16),('16100','2013-07-30','18:50:00',1.01),('16100','2014-04-07','08:20:00',1.06),('16100','2014-04-07','08:30:00',1.41),('16100','2014-04-07','08:35:00',1.81),('16100','2014-04-07','08:40:00',2.02),('16100','2014-04-07','08:45:00',2.3),('16100','2014-04-07','08:50:00',2.5),('16100','2014-04-07','08:55:00',2.7),('16100','2014-04-07','09:00:00',2.92),('16100','2014-04-07','09:05:00',3.07),('16100','2014-04-07','09:10:00',3.21),('16100','2014-04-07','09:15:00',3.41),('16100','2014-04-07','09:20:00',3.59),('16100','2014-04-07','09:25:00',3.73),('16100','2014-04-07','09:30:00',3.8),('16100','2014-04-07','09:35:00',3.83),('16100','2014-04-07','09:40:00',4),('16100','2014-04-07','09:45:00',4.17),('16100','2014-04-07','09:50:00',4.26),('16100','2014-04-07','09:55:00',4.27),('16100','2014-04-07','10:00:00',4.51),('16100','2014-04-07','10:05:00',4.83),('16100','2014-04-07','10:10:00',4.92),('16100','2014-04-07','10:15:00',4.99),('16100','2014-04-07','10:20:00',5.12),('16100','2014-04-07','10:25:00',5.25),('16100','2014-04-07','10:30:00',5.37),('16100','2014-04-07','10:35:00',5.5),('16100','2014-04-07','10:40:00',5.62),('16100','2014-04-07','10:45:00',5.74),('16100','2014-04-07','10:50:00',5.8),('16100','2014-04-07','10:55:00',5.91),('16100','2014-04-07','11:00:00',6),('16100','2014-04-07','11:05:00',6.11),('16100','2014-04-07','11:10:00',6.17),('16100','2014-04-07','11:15:00',6.22),('16100','2014-04-07','11:20:00',6.34),('16100','2014-04-07','11:25:00',6.41),('16100','2014-04-07','11:30:00',6.33),('16100','2014-04-07','11:35:00',6.65),('16100','2014-04-07','11:40:00',6.63),('16100','2014-04-07','11:45:00',6.5),('16100','2014-04-07','11:50:00',6.65),('16100','2014-04-07','11:55:00',6.81),('16100','2014-04-07','12:00:00',6.63),('16100','2014-04-07','12:05:00',6.36),('16100','2014-04-07','12:10:00',6.04),('16100','2014-04-07','12:15:00',5.62),('16100','2014-04-07','12:20:00',6.18),('16100','2014-04-07','12:25:00',6.62),('16100','2014-04-07','12:30:00',6.08),('16100','2014-04-07','12:35:00',6.3),('16100','2014-04-07','12:40:00',6.12),('16100','2014-04-07','12:45:00',6.31),('16100','2014-04-07','12:50:00',6.94),('16100','2014-04-07','12:55:00',6.84),('16100','2014-04-07','13:00:00',7.21),('16100','2014-04-07','13:05:00',7.46),('16100','2014-04-07','13:10:00',7.34),('16100','2014-04-07','13:15:00',7.3),('16100','2014-04-07','13:20:00',7.38),('16100','2014-04-07','13:25:00',7.46),('16100','2014-04-07','13:30:00',7.49),('16100','2014-04-07','13:35:00',7.47),('16100','2014-04-07','13:40:00',7.38),('16100','2014-04-07','13:45:00',7.35),('16100','2014-04-07','13:50:00',7.27),('16100','2014-04-07','13:55:00',7.28),('16100','2014-04-07','14:00:00',7.31),('16100','2014-04-07','14:05:00',7.32),('16100','2014-04-07','14:10:00',7.32),('16100','2014-04-07','14:15:00',7.04),('16100','2014-04-07','14:20:00',6.32),('16100','2014-04-07','14:25:00',6.84),('16100','2014-04-07','14:30:00',7.02),('16100','2014-04-07','14:35:00',6.02),('16100','2014-04-07','14:40:00',6.28),('16100','2014-04-07','14:45:00',6.55),('16100','2014-04-07','14:50:00',6.97),('16100','2014-04-07','14:55:00',6.75),('16100','2014-04-07','15:00:00',6.53),('16100','2014-04-07','15:05:00',6.56),('16100','2014-04-07','15:10:00',6.35),('16100','2014-04-07','15:15:00',6.36),('16100','2014-04-07','15:20:00',6.41),('16100','2014-04-07','15:25:00',6.23),('16100','2014-04-07','15:30:00',6.07),('16100','2014-04-07','15:35:00',5.89),('16100','2014-04-07','15:40:00',5.56),('16100','2014-04-07','15:45:00',5.75),('16100','2014-04-07','15:50:00',5.66),('16100','2014-04-07','15:55:00',5.48),('16100','2014-04-07','16:00:00',5.44),('16100','2014-04-07','16:05:00',5.26),('16100','2014-04-07','16:10:00',4.97),('16100','2014-04-07','16:15:00',4.78),('16100','2014-04-07','16:20:00',4.51),('16100','2014-04-07','16:25:00',4.93),('16100','2014-04-07','16:30:00',4.6),('16100','2014-04-07','16:35:00',4.53),('16100','2014-04-07','16:40:00',4.32),('16100','2014-04-07','16:45:00',4.17),('16100','2014-04-07','16:50:00',4.06),('16100','2014-04-07','16:55:00',3.67),('16100','2014-04-07','17:00:00',3.73),('16100','2014-04-07','17:05:00',3.62),('16100','2014-04-07','17:10:00',3.45),('16100','2014-04-07','17:15:00',3.26),('16100','2014-04-07','17:20:00',2.98),('16100','2014-04-07','17:25:00',2.74),('16100','2014-04-07','17:30:00',2.46),('16100','2014-04-07','17:35:00',2.57),('16100','2014-04-07','17:40:00',2.33),('16100','2014-04-07','17:45:00',2.26),('16100','2014-04-07','17:50:00',2.05),('16100','2014-04-07','17:55:00',1.82),('16100','2014-04-07','18:00:00',1.83),('16100','2014-04-07','18:05:00',1.6),('16100','2014-04-07','18:10:00',1.51),('16100','2014-04-07','18:15:00',1.36),('16100','2014-04-07','18:20:00',1.19),('16100','2013-07-29','08:00:00',1.29),('16100','2013-07-29','08:05:00',1.32),('16100','2013-07-29','08:10:00',1.39),('16100','2013-07-29','08:15:00',1.54),('16100','2013-07-29','08:20:00',1.7),('16100','2013-07-29','08:25:00',1.88),('16100','2013-07-29','08:30:00',2.05),('16100','2013-07-29','08:35:00',2.19),('16100','2013-07-29','08:40:00',2.38),('16100','2013-07-29','08:45:00',2.58),('16100','2013-07-29','08:50:00',1.12),('16100','2013-07-29','08:55:00',2.51),('16100','2013-07-29','09:00:00',2.77),('16100','2013-07-29','09:05:00',3.03),('16100','2013-07-29','09:10:00',2.3),('16100','2013-07-29','09:15:00',1.01),('16100','2013-07-29','09:30:00',1.42),('16100','2013-07-29','09:35:00',4.49),('16100','2013-07-29','09:40:00',4.93),('16100','2013-07-29','09:45:00',4.98),('16100','2013-07-29','09:50:00',4.91),('16100','2013-07-29','10:00:00',4.52),('16100','2013-07-29','10:05:00',2.06),('16100','2013-07-29','10:10:00',1.2),('16100','2013-07-29','10:15:00',5.31),('16100','2013-07-29','10:20:00',6.15),('16100','2013-07-29','10:25:00',6.08),('16100','2013-07-29','10:30:00',6.14),('16100','2013-07-29','10:35:00',6.11),('16100','2013-07-29','10:40:00',6.06),('16100','2013-07-29','10:45:00',6.13),('16100','2013-07-29','10:50:00',6.19),('16100','2013-07-29','10:55:00',6.19),('16100','2013-07-29','11:00:00',6.21),('16100','2013-07-29','11:05:00',5.69),('16100','2013-07-29','11:10:00',6.46),('16100','2013-07-29','11:15:00',6.74),('16100','2013-07-29','11:20:00',6.62),('16100','2013-07-29','11:25:00',6.71),('16100','2013-07-29','11:30:00',6.72),('16100','2013-07-29','11:35:00',6.7),('16100','2013-07-29','11:40:00',6.68),('16100','2013-07-29','11:45:00',5.85),('16100','2013-07-29','11:50:00',4.85),('16100','2013-07-29','11:55:00',7.18),('16100','2013-07-29','12:00:00',7.13),('16100','2013-07-29','12:05:00',7.28),('16100','2013-07-29','12:10:00',7.33),('16100','2013-07-29','12:15:00',7.21),('16100','2013-07-29','12:20:00',7.22),('16100','2013-07-29','12:25:00',7.19),('16100','2013-07-29','12:30:00',7.29),('16100','2013-07-29','12:35:00',6.51),('16100','2013-07-29','12:40:00',5.77),('16100','2013-07-29','12:45:00',7.42),('16100','2013-07-29','12:50:00',6.95),('16100','2013-07-29','12:55:00',4.03),('16100','2013-07-29','13:00:00',6.21),('16100','2013-07-29','13:05:00',8.06),('16100','2013-07-29','13:10:00',6.7),('16100','2013-07-29','13:15:00',3.35),('16100','2013-07-29','13:20:00',1.97),('16100','2013-07-29','13:25:00',4.5),('16100','2013-07-29','13:30:00',3.48),('16100','2013-07-29','13:35:00',7.88),('16100','2013-07-29','13:40:00',7.37),('16100','2013-07-29','13:45:00',7.87),('16100','2013-07-29','13:50:00',7.86),('16100','2013-07-29','13:55:00',7.79),('16100','2013-07-29','14:00:00',5.98),('16100','2013-07-29','14:05:00',5.24),('16100','2013-07-29','14:10:00',7.55),('16100','2013-07-29','14:15:00',7.28),('16100','2013-07-29','14:20:00',7.27),('16100','2013-07-29','14:25:00',7.26),('16100','2013-07-29','14:30:00',7.13),('16100','2013-07-29','14:35:00',7.15),('16100','2013-07-29','14:40:00',6.98),('16100','2013-07-29','14:45:00',6.86),('16100','2013-07-29','14:50:00',6.79),('16100','2013-07-29','14:55:00',6.82),('16100','2013-07-29','15:00:00',6.75),('16100','2013-07-29','15:05:00',6.67),('16100','2013-07-29','15:10:00',6.67),('16100','2013-07-29','15:15:00',6.55),('16100','2013-07-29','15:20:00',6.44),('16100','2013-07-29','15:25:00',6.32),('16100','2013-07-29','15:30:00',6.24),('16100','2013-07-29','15:35:00',6.2),('16100','2013-07-29','15:40:00',6.07),('16100','2013-07-29','15:45:00',6.02),('16100','2013-07-29','15:50:00',5.89),('16100','2013-07-29','15:55:00',5.78),('16100','2013-07-29','16:00:00',5.73),('16100','2013-07-29','16:05:00',5.57),('16100','2013-07-29','16:10:00',5.42),('16100','2013-07-29','16:15:00',5.32),('16100','2013-07-29','16:20:00',5.23),('16100','2013-07-29','16:25:00',5.01),('16100','2013-07-29','16:30:00',4.91),('16100','2013-07-29','16:35:00',4.91),('16100','2013-07-29','16:40:00',4.77),('16100','2013-07-29','16:45:00',4.63),('16100','2013-07-29','16:50:00',4.5),('16100','2013-07-29','16:55:00',4.44),('16100','2013-07-29','17:00:00',4.25),('16100','2013-07-29','17:05:00',4.09),('16100','2013-07-29','17:10:00',3.96),('16100','2013-07-29','17:15:00',3.83),('16100','2013-07-29','17:20:00',3.69),('16100','2013-07-29','17:25:00',3.51),('16100','2013-07-29','17:30:00',3.36),('16100','2013-07-29','17:35:00',3.22),('16100','2013-07-29','17:40:00',3.05),('16100','2013-07-29','17:45:00',2.93),('16100','2013-07-29','17:50:00',2.79),('16100','2013-07-29','17:55:00',2.63),('16100','2013-07-29','18:00:00',2.47),('16100','2013-07-29','18:05:00',2.32),('16100','2013-07-29','18:10:00',2.19),('16100','2013-07-29','18:15:00',2.03),('16100','2013-07-29','18:20:00',1.87),('16100','2013-07-29','18:25:00',1.7),('16100','2013-07-29','18:30:00',1.57),('16100','2013-07-29','18:35:00',1.41),('16100','2013-07-29','18:40:00',1.24),('16100','2013-07-29','18:45:00',1.1),('16100','2013-07-28','08:00:00',1.06),('16100','2013-07-28','08:05:00',1.19),('16100','2013-07-28','08:10:00',1.3),('16100','2013-07-28','08:15:00',1.45),('16100','2013-07-28','08:20:00',1.59),('16100','2013-07-28','08:25:00',1.74),('16100','2013-07-28','08:30:00',1.9),('16100','2013-07-28','08:35:00',2.04),('16100','2013-07-28','08:40:00',2.22),('16100','2013-07-28','08:45:00',2.36),('16100','2013-07-28','08:50:00',2.5),('16100','2013-07-28','08:55:00',2.73),('16100','2013-07-28','09:00:00',3.02),('16100','2013-07-28','09:05:00',3.2),('16100','2013-07-28','09:10:00',3.36),('16100','2013-07-28','09:15:00',3.48),('16100','2013-07-28','09:20:00',3.62),('16100','2013-07-28','09:25:00',3.79),('16100','2013-07-28','09:30:00',3.88),('16100','2013-07-28','09:35:00',4),('16100','2013-07-28','09:40:00',4.12),('16100','2013-07-28','09:45:00',4.28),('16100','2013-07-28','09:50:00',4.4),('16100','2013-07-28','09:55:00',4.47),('16100','2013-07-28','10:00:00',4.59),('16100','2013-07-28','10:05:00',4.72),('16100','2013-07-28','10:10:00',4.84),('16100','2013-07-28','10:15:00',4.96),('16100','2013-07-28','10:20:00',5.04),('16100','2013-07-28','10:25:00',5.22),('16100','2013-07-28','10:30:00',5.35),('16100','2013-07-28','10:35:00',5.4),('16100','2013-07-28','10:40:00',5.45),('16100','2013-07-28','10:45:00',5.55),('16100','2013-07-28','10:50:00',5.61),('16100','2013-07-28','10:55:00',5.61),('16100','2013-07-28','11:00:00',5.68),('16100','2013-07-28','11:05:00',5.8),('16100','2013-07-28','11:10:00',5.89),('16100','2013-07-28','11:15:00',5.9),('16100','2013-07-28','11:20:00',6.02),('16100','2013-07-28','11:25:00',6.12),('16100','2013-07-28','11:30:00',6.26),('16100','2013-07-28','11:35:00',6.35),('16100','2013-07-28','11:40:00',6.38),('16100','2013-07-28','11:45:00',6.42),('16100','2013-07-28','11:50:00',6.47),('16100','2013-07-28','11:55:00',6.52),('16100','2013-07-28','12:00:00',6.58),('16100','2013-07-28','12:05:00',6.7),('16100','2013-07-28','12:10:00',6.77),('16100','2013-07-28','12:15:00',6.8),('16100','2013-07-28','12:20:00',6.82),('16100','2013-07-28','12:25:00',6.8),('16100','2013-07-28','12:30:00',6.77),('16100','2013-07-28','12:35:00',6.88),('16100','2013-07-28','12:40:00',6.93),('16100','2013-07-28','12:45:00',6.92),('16100','2013-07-28','12:50:00',6.92),('16100','2013-07-28','12:55:00',7.06),('16100','2013-07-28','13:00:00',7.24),('16100','2013-07-28','13:05:00',7.25),('16100','2013-07-28','13:10:00',7.2),('16100','2013-07-28','13:15:00',7.28),('16100','2013-07-28','13:20:00',7.3),('16100','2013-07-28','13:25:00',7.27),('16100','2013-07-28','13:30:00',7.3),('16100','2013-07-28','13:35:00',7.29),('16100','2013-07-28','13:40:00',7.29),('16100','2013-07-28','13:45:00',7.3),('16100','2013-07-28','13:50:00',7.3),('16100','2013-07-28','13:55:00',7.27),('16100','2013-07-28','14:00:00',7.27),('16100','2013-07-28','14:05:00',7.25),('16100','2013-07-28','14:10:00',7.16),('16100','2013-07-28','14:15:00',7.03),('16100','2013-07-28','14:20:00',6.94),('16100','2013-07-28','14:25:00',6.95),('16100','2013-07-28','14:30:00',6.88),('16100','2013-07-28','14:35:00',6.87),('16100','2013-07-28','14:40:00',6.79),('16100','2013-07-28','14:45:00',6.73),('16100','2013-07-28','14:50:00',6.72),('16100','2013-07-28','14:55:00',6.68),('16100','2013-07-28','15:00:00',6.61),('16100','2013-07-28','15:05:00',6.54),('16100','2013-07-28','15:10:00',6.48),('16100','2013-07-28','15:15:00',6.41),('16100','2013-07-28','15:20:00',6.33),('16100','2013-07-28','15:25:00',6.27),('16100','2013-07-28','15:30:00',6.2),('16100','2013-07-28','15:35:00',6.25),('16100','2013-07-28','15:40:00',5.58),('16100','2013-07-28','15:45:00',4.01),('16100','2013-07-28','15:50:00',4.32),('16100','2013-07-28','15:55:00',3.42),('16100','2013-07-28','16:00:00',4.07),('16100','2013-07-28','16:05:00',5.6),('16100','2013-07-28','16:10:00',4.39),('16100','2013-07-28','16:15:00',5.4),('16100','2013-07-28','16:20:00',4.06),('16100','2013-07-28','16:25:00',4.81),('16100','2013-07-28','16:30:00',5.31),('16100','2013-07-28','16:35:00',5.05),('16100','2013-07-28','16:40:00',4.96),('16100','2013-07-28','16:45:00',4.02),('16100','2013-07-28','16:50:00',3),('16100','2013-07-28','16:55:00',2.32),('16100','2013-07-28','17:00:00',2.24),('16100','2013-07-28','17:05:00',3.36),('16100','2013-07-28','17:10:00',4.02),('16100','2013-07-28','17:15:00',3.6),('16100','2013-07-28','17:20:00',3.61),('16100','2013-07-28','17:25:00',3.2),('16100','2013-07-28','17:30:00',1.75),('16100','2013-07-28','17:35:00',1.45),('16100','2013-07-28','17:40:00',3.58),('16100','2013-07-28','17:45:00',3.19),('16100','2013-07-28','17:50:00',2.75),('16100','2013-07-28','17:55:00',1.8),('16100','2013-07-28','18:00:00',1.87),('16100','2013-07-28','18:05:00',2.02),('16100','2013-07-28','18:10:00',1.83),('16100','2013-07-28','18:15:00',2.03),('16100','2013-07-28','18:20:00',2.03),('16100','2013-07-28','18:25:00',1.84),('16100','2013-07-28','18:30:00',1.62),('16100','2013-07-28','18:35:00',1.32),('16100','2013-07-28','18:55:00',1.13),('16100','2013-07-28','19:00:00',1.06),('16100','2013-07-27','08:00:00',1.03),('16100','2013-07-27','08:05:00',1.18),('16100','2013-07-27','08:10:00',1.31),('16100','2013-07-27','08:15:00',1.45),('16100','2013-07-27','08:20:00',1.59),('16100','2013-07-27','08:25:00',1.77),('16100','2013-07-27','08:30:00',1.91),('16100','2013-07-27','08:35:00',2.07),('16100','2013-07-27','08:40:00',2.24),('16100','2013-07-27','08:45:00',2.4),('16100','2013-07-27','08:50:00',2.58),('16100','2013-07-27','08:55:00',2.81),('16100','2013-07-27','09:00:00',3.13),('16100','2013-07-27','09:05:00',3.31),('16100','2013-07-27','09:10:00',3.43),('16100','2013-07-27','09:15:00',3.54),('16100','2013-07-27','09:20:00',3.68),('16100','2013-07-27','09:25:00',3.82),('16100','2013-07-27','09:30:00',3.96),('16100','2013-07-27','09:35:00',4.11),('16100','2013-07-27','09:40:00',4.22),('16100','2013-07-27','09:45:00',4.33),('16100','2013-07-27','09:50:00',4.44),('16100','2013-07-27','09:55:00',4.53),('16100','2013-07-27','10:00:00',4.66),('16100','2013-07-27','10:05:00',4.77),('16100','2013-07-27','10:10:00',4.88),('16100','2013-07-27','10:15:00',4.99),('16100','2013-07-27','10:20:00',5.1),('16100','2013-07-27','10:25:00',5.26),('16100','2013-07-27','10:30:00',5.4),('16100','2013-07-27','10:35:00',5.48),('16100','2013-07-27','10:40:00',5.52),('16100','2013-07-27','10:45:00',5.61),('16100','2013-07-27','10:50:00',5.64),('16100','2013-07-27','10:55:00',5.73),('16100','2013-07-27','11:00:00',5.81),('16100','2013-07-27','11:05:00',5.88),('16100','2013-07-27','11:10:00',5.96),('16100','2013-07-27','11:15:00',6.06),('16100','2013-07-27','11:20:00',6.12),('16100','2013-07-27','11:25:00',5.97),('16100','2013-07-27','11:30:00',5.9),('16100','2013-07-27','11:35:00',6.07),('16100','2013-07-27','11:40:00',6.19),('16100','2013-07-27','11:45:00',6.3),('16100','2013-07-27','11:50:00',6.44),('16100','2013-07-27','11:55:00',6.49),('16100','2013-07-27','12:00:00',6.53),('16100','2013-07-27','12:05:00',6.61),('16100','2013-07-27','12:10:00',6.64),('16100','2013-07-27','12:15:00',6.64),('16100','2013-07-27','12:20:00',6.81),('16100','2013-07-27','12:25:00',6.82),('16100','2013-07-27','12:30:00',6.89),('16100','2013-07-27','12:35:00',6.92),('16100','2013-07-27','12:40:00',6.3),('16100','2013-07-27','12:45:00',6.93),('16100','2013-07-27','12:50:00',6.98),('16100','2013-07-27','12:55:00',5.55),('16100','2013-07-27','13:00:00',6.84),('16100','2013-07-27','13:05:00',7.19),('16100','2013-07-27','13:10:00',7.24),('16100','2013-07-27','13:15:00',6.67),('16100','2013-07-27','13:20:00',7.28),('16100','2013-07-27','13:25:00',7.25),('16100','2013-07-27','13:30:00',7.2),('16100','2013-07-27','13:35:00',7.17),('16100','2013-07-27','13:40:00',7.21),('16100','2013-07-27','13:45:00',7.21),('16100','2013-07-27','13:50:00',7.14),('16100','2013-07-27','13:55:00',7.18),('16100','2013-07-27','14:00:00',7.1),('16100','2013-07-27','14:05:00',7.13),('16100','2013-07-27','14:10:00',7.07),('16100','2013-07-27','14:15:00',6.99),('16100','2013-07-27','14:20:00',6.95),('16100','2013-07-27','14:25:00',6.88),('16100','2013-07-27','14:30:00',6.91),('16100','2013-07-27','14:35:00',6.87),('16100','2013-07-27','14:40:00',6.86),('16100','2013-07-27','14:45:00',6.76),('16100','2013-07-27','14:50:00',6.72),('16100','2013-07-27','14:55:00',6.65),('16100','2013-07-27','15:00:00',6.55),('16100','2013-07-27','15:05:00',6.48),('16100','2013-07-27','15:10:00',6.39),('16100','2013-07-27','15:15:00',6.28),('16100','2013-07-27','15:20:00',6.25),('16100','2013-07-27','15:25:00',6.2),('16100','2013-07-27','15:30:00',6.13),('16100','2013-07-27','15:35:00',6.06),('16100','2013-07-27','15:40:00',5.98),('16100','2013-07-27','15:45:00',5.92),('16100','2013-07-27','15:50:00',5.88),('16100','2013-07-27','15:55:00',5.82),('16100','2013-07-27','16:00:00',5.73),('16100','2013-07-27','16:05:00',5.63),('16100','2013-07-27','16:10:00',5.57),('16100','2013-07-27','16:15:00',5.47),('16100','2013-07-27','16:20:00',5.36),('16100','2013-07-27','16:25:00',5.17),('16100','2013-07-27','16:30:00',5.06),('16100','2013-07-27','16:35:00',4.95),('16100','2013-07-27','16:40:00',4.85),('16100','2013-07-27','16:45:00',4.74),('16100','2013-07-27','16:50:00',4.58),('16100','2013-07-27','16:55:00',4.47),('16100','2013-07-27','17:00:00',4.36),('16100','2013-07-27','17:05:00',4.22),('16100','2013-07-27','17:10:00',4.05),('16100','2013-07-27','17:15:00',3.91),('16100','2013-07-27','17:20:00',3.78),('16100','2013-07-27','17:25:00',3.64),('16100','2013-07-27','17:30:00',3.51),('16100','2013-07-27','17:35:00',3.35),('16100','2013-07-27','17:40:00',3.17),('16100','2013-07-27','17:45:00',3.01),('16100','2013-07-27','17:50:00',2.85),('16100','2013-07-27','17:55:00',2.68),('16100','2013-07-27','18:00:00',2.52),('16100','2013-07-27','18:05:00',2.38),('16100','2013-07-27','18:10:00',2.24),('16100','2013-07-27','18:15:00',2.1),('16100','2013-07-27','18:20:00',1.95),('16100','2013-07-27','18:25:00',1.8),('16100','2013-07-27','18:30:00',1.62),('16100','2013-07-27','18:35:00',1.43),('16100','2013-07-27','18:40:00',1.28),('16100','2013-07-27','18:45:00',1.15),('16100','2013-07-27','18:50:00',1.01),('16100','2013-07-26','08:00:00',1.07),('16100','2013-07-26','08:05:00',1.2),('16100','2013-07-26','08:10:00',1.35),('16100','2013-07-26','08:15:00',1.49),('16100','2013-07-26','08:20:00',1.63),('16100','2013-07-26','08:25:00',1.8),('16100','2013-07-26','08:30:00',1.94),('16100','2013-07-26','08:35:00',2.1),('16100','2013-07-26','08:40:00',2.29),('16100','2013-07-26','08:45:00',2.43),('16100','2013-07-26','08:50:00',2.61),('16100','2013-07-26','08:55:00',2.86),('16100','2013-07-26','09:00:00',3.16),('16100','2013-07-26','09:05:00',3.35),('16100','2013-07-26','09:10:00',3.5),('16100','2013-07-26','09:15:00',3.64),('16100','2013-07-26','09:20:00',3.77),('16100','2013-07-26','09:25:00',3.88),('16100','2013-07-26','09:30:00',4.02),('16100','2013-07-26','09:35:00',4.18),('16100','2013-07-26','09:40:00',4.29),('16100','2013-07-26','09:45:00',4.41),('16100','2013-07-26','09:50:00',4.52),('16100','2013-07-26','09:55:00',4.65),('16100','2013-07-26','10:00:00',4.75),('16100','2013-07-26','10:05:00',4.88),('16100','2013-07-26','10:10:00',4.98),('16100','2013-07-26','10:15:00',5.15),('16100','2013-07-26','10:20:00',5.3),('16100','2013-07-26','10:25:00',5.38),('16100','2013-07-26','10:30:00',5.46),('16100','2013-07-26','10:35:00',5.56),('16100','2013-07-26','10:40:00',5.68),('16100','2013-07-26','10:45:00',5.78),('16100','2013-07-26','10:50:00',5.86),('16100','2013-07-26','10:55:00',5.94),('16100','2013-07-26','11:00:00',5.97),('16100','2013-07-26','11:05:00',6.04),('16100','2013-07-26','11:10:00',6.13),('16100','2013-07-26','11:15:00',6.22),('16100','2013-07-26','11:20:00',6.22),('16100','2013-07-26','11:25:00',6.25),('16100','2013-07-26','11:30:00',6.39),('16100','2013-07-26','11:35:00',6.38),('16100','2013-07-26','11:40:00',6.41),('16100','2013-07-26','11:45:00',6.55),('16100','2013-07-26','11:50:00',6.54),('16100','2013-07-26','11:55:00',6.58),('16100','2013-07-26','12:00:00',6.66),('16100','2013-07-26','12:05:00',6.66),('16100','2013-07-26','12:10:00',6.59),('16100','2013-07-26','12:15:00',6.68),('16100','2013-07-26','12:20:00',6.66),('16100','2013-07-26','12:25:00',6.84),('16100','2013-07-26','12:30:00',5.89),('16100','2013-07-26','12:35:00',6.41),('16100','2013-07-26','12:40:00',7.12),('16100','2013-07-26','12:45:00',7.06),('16100','2013-07-26','12:50:00',7.3),('16100','2013-07-26','12:55:00',7.15),('16100','2013-07-26','13:00:00',6.99),('16100','2013-07-26','13:05:00',7.21),('16100','2013-07-26','13:10:00',7.27),('16100','2013-07-26','13:15:00',7.17),('16100','2013-07-26','13:20:00',7.23),('16100','2013-07-26','13:25:00',7.17),('16100','2013-07-26','13:30:00',7.26),('16100','2013-07-26','13:35:00',7.18),('16100','2013-07-26','13:40:00',7.11),('16100','2013-07-26','13:45:00',7.21),('16100','2013-07-26','13:50:00',7.2),('16100','2013-07-26','13:55:00',7.18),('16100','2013-07-26','14:00:00',7.18),('16100','2013-07-26','14:05:00',7.12),('16100','2013-07-26','14:10:00',7.06),('16100','2013-07-26','14:15:00',6.98),('16100','2013-07-26','14:20:00',6.94),('16100','2013-07-26','14:25:00',6.84),('16100','2013-07-26','14:30:00',6.88),('16100','2013-07-26','14:35:00',6.78),('16100','2013-07-26','14:40:00',6.75),('16100','2013-07-26','14:45:00',6.74),('16100','2013-07-26','14:50:00',6.69),('16100','2013-07-26','14:55:00',6.66),('16100','2013-07-26','15:00:00',6.59),('16100','2013-07-26','15:05:00',6.51),('16100','2013-07-26','15:10:00',6.47),('16100','2013-07-26','15:15:00',6.41),('16100','2013-07-26','15:20:00',6.36),('16100','2013-07-26','15:25:00',6.2),('16100','2013-07-26','15:30:00',6.08),('16100','2013-07-26','15:35:00',6.08),('16100','2013-07-26','15:40:00',6.05),('16100','2013-07-26','15:45:00',5.97),('16100','2013-07-26','15:50:00',5.87),('16100','2013-07-26','15:55:00',5.75),('16100','2013-07-26','16:00:00',5.66),('16100','2013-07-26','16:05:00',5.58),('16100','2013-07-26','16:10:00',5.45),('16100','2013-07-26','16:15:00',5.36),('16100','2013-07-26','16:20:00',5.22),('16100','2013-07-26','16:25:00',5.11),('16100','2013-07-26','16:30:00',5.02),('16100','2013-07-26','16:35:00',4.93),('16100','2013-07-26','16:40:00',4.8),('16100','2013-07-26','16:45:00',4.7),('16100','2013-07-26','16:50:00',4.59),('16100','2013-07-26','16:55:00',4.46),('16100','2013-07-26','17:00:00',4.33),('16100','2013-07-26','17:05:00',4.22),('16100','2013-07-26','17:10:00',4.06),('16100','2013-07-26','17:15:00',3.9),('16100','2013-07-26','17:20:00',3.78),('16100','2013-07-26','17:25:00',3.63),('16100','2013-07-26','17:30:00',3.48),('16100','2013-07-26','17:35:00',3.34),('16100','2013-07-26','17:40:00',3.16),('16100','2013-07-26','17:45:00',3),('16100','2013-07-26','17:50:00',2.85),('16100','2013-07-26','17:55:00',2.69),('16100','2013-07-26','18:00:00',2.54),('16100','2013-07-26','18:05:00',2.4),('16100','2013-07-26','18:10:00',2.25),('16100','2013-07-26','18:15:00',2.1),('16100','2013-07-26','18:20:00',1.96),('16100','2013-07-26','18:25:00',1.82),('16100','2013-07-26','18:30:00',1.67),('16100','2013-07-26','18:35:00',1.47),('16100','2013-07-26','18:40:00',1.32),('16100','2013-07-26','18:45:00',1.17),('16100','2013-07-26','18:50:00',1.04),('16100','2013-07-25','07:55:00',1.04),('16100','2013-07-25','08:00:00',1.18),('16100','2013-07-25','08:05:00',1.21),('16100','2013-07-25','08:10:00',1.3),('16100','2013-07-25','08:15:00',1.48),('16100','2013-07-25','08:20:00',1.67),('16100','2013-07-25','08:25:00',1.83),('16100','2013-07-25','08:30:00',1.94),('16100','2013-07-25','08:35:00',2.03),('16100','2013-07-25','08:40:00',2.28),('16100','2013-07-25','08:45:00',2.42),('16100','2013-07-25','08:50:00',2.54),('16100','2013-07-25','08:55:00',2.81),('16100','2013-07-25','09:00:00',2.98),('16100','2013-07-25','09:05:00',3.32),('16100','2013-07-25','09:10:00',3.44),('16100','2013-07-25','09:15:00',3.47),('16100','2013-07-25','09:20:00',3.71),('16100','2013-07-25','09:25:00',3.85),('16100','2013-07-25','09:30:00',3.98),('16100','2013-07-25','09:35:00',4.14),('16100','2013-07-25','09:40:00',4.28),('16100','2013-07-25','09:45:00',4.41),('16100','2013-07-25','09:50:00',4.49),('16100','2013-07-25','09:55:00',4.61),('16100','2013-07-25','10:00:00',4.76),('16100','2013-07-25','10:05:00',4.88),('16100','2013-07-25','10:10:00',4.99),('16100','2013-07-25','10:15:00',5.07),('16100','2013-07-25','10:20:00',5.22),('16100','2013-07-25','10:25:00',5.32),('16100','2013-07-25','10:30:00',5.49),('16100','2013-07-25','10:35:00',5.51),('16100','2013-07-25','10:40:00',5.5),('16100','2013-07-25','10:45:00',5.55),('16100','2013-07-25','10:50:00',5.75),('16100','2013-07-25','10:55:00',5.94),('16100','2013-07-25','11:00:00',6.1),('16100','2013-07-25','11:05:00',6.09),('16100','2013-07-25','11:10:00',6.12),('16100','2013-07-25','11:15:00',6.32),('16100','2013-07-25','11:20:00',6.37),('16100','2013-07-25','11:25:00',6.43),('16100','2013-07-25','11:30:00',6.5),('16100','2013-07-25','11:35:00',6.48),('16100','2013-07-25','11:40:00',6.67),('16100','2013-07-25','11:45:00',6.76),('16100','2013-07-25','11:50:00',6.99),('16100','2013-07-25','11:55:00',6.86),('16100','2013-07-25','12:00:00',6.97),('16100','2013-07-25','12:05:00',7.05),('16100','2013-07-25','12:10:00',7.12),('16100','2013-07-25','12:15:00',6.57),('16100','2013-07-25','12:20:00',5.8),('16100','2013-07-25','12:25:00',7.46),('16100','2013-07-25','12:30:00',6.66),('16100','2013-07-25','12:35:00',2.52),('16100','2013-07-25','12:40:00',2.42),('16100','2013-07-25','12:45:00',7.19),('16100','2013-07-25','12:50:00',7.97),('16100','2013-07-25','12:55:00',4.25),('16100','2013-07-25','13:00:00',5.12),('16100','2013-07-25','13:05:00',5.94),('16100','2013-07-25','13:10:00',4.48),('16100','2013-07-25','13:15:00',4.43),('16100','2013-07-25','13:20:00',7.84),('16100','2013-07-25','13:25:00',7.71),('16100','2013-07-25','13:30:00',7.81),('16100','2013-07-25','13:35:00',7.55),('16100','2013-07-25','13:40:00',7.38),('16100','2013-07-25','13:45:00',6.93),('16100','2013-07-25','13:50:00',6.93),('16100','2013-07-25','13:55:00',7.62),('16100','2013-07-25','14:00:00',7.29),('16100','2013-07-25','14:05:00',7.71),('16100','2013-07-25','14:10:00',7.34),('16100','2013-07-25','14:15:00',7.22),('16100','2013-07-25','14:20:00',7.11),('16100','2013-07-25','14:25:00',7.09),('16100','2013-07-25','14:30:00',7.03),('16100','2013-07-25','14:35:00',6.98),('16100','2013-07-25','14:40:00',6.93),('16100','2013-07-25','14:45:00',6.88),('16100','2013-07-25','14:50:00',6.8),('16100','2013-07-25','14:55:00',6.72),('16100','2013-07-25','15:00:00',6.66),('16100','2013-07-25','15:05:00',6.6),('16100','2013-07-25','15:10:00',6.59),('16100','2013-07-25','15:15:00',6.47),('16100','2013-07-25','15:20:00',6.37),('16100','2013-07-25','15:25:00',6.33),('16100','2013-07-25','15:30:00',6.2),('16100','2013-07-25','15:35:00',6.15),('16100','2013-07-25','15:40:00',6.04),('16100','2013-07-25','15:45:00',5.96),('16100','2013-07-25','15:50:00',5.89),('16100','2013-07-25','15:55:00',5.85),('16100','2013-07-25','16:00:00',5.76),('16100','2013-07-25','16:05:00',5.68),('16100','2013-07-25','16:10:00',5.56),('16100','2013-07-25','16:15:00',5.43),('16100','2013-07-25','16:20:00',5.29),('16100','2013-07-25','16:25:00',5.17),('16100','2013-07-25','16:30:00',5.02),('16100','2013-07-25','16:35:00',4.95),('16100','2013-07-25','16:40:00',4.82),('16100','2013-07-25','16:45:00',4.67),('16100','2013-07-25','16:50:00',4.58),('16100','2013-07-25','16:55:00',4.46),('16100','2013-07-25','17:00:00',4.34),('16100','2013-07-25','17:05:00',4.2),('16100','2013-07-25','17:10:00',4.07),('16100','2013-07-25','17:15:00',3.9),('16100','2013-07-25','17:20:00',3.78),('16100','2013-07-25','17:25:00',3.6),('16100','2013-07-25','17:30:00',3.46),('16100','2013-07-25','17:35:00',3.28),('16100','2013-07-25','17:40:00',3.12),('16100','2013-07-25','17:45:00',2.94),('16100','2013-07-25','17:50:00',2.77),('16100','2013-07-25','17:55:00',2.66),('16100','2013-07-25','18:00:00',2.5),('16100','2013-07-25','18:05:00',2.35),('16100','2013-07-25','18:10:00',2.23),('16100','2013-07-25','18:15:00',2.07),('16100','2013-07-25','18:20:00',1.9),('16100','2013-07-25','18:25:00',1.75),('16100','2013-07-25','18:30:00',1.58),('16100','2013-07-25','18:35:00',1.39),('16100','2013-07-25','18:40:00',1.24),('16100','2013-07-25','18:45:00',1.13),('16100','2013-07-24','08:00:00',1.09),('16100','2013-07-24','08:05:00',1.23),('16100','2013-07-24','08:10:00',1.37),('16100','2013-07-24','08:15:00',1.49),('16100','2013-07-24','08:20:00',1.61),('16100','2013-07-24','08:25:00',1.79),('16100','2013-07-24','08:30:00',1.94),('16100','2013-07-24','08:35:00',2.09),('16100','2013-07-24','08:40:00',2.26),('16100','2013-07-24','08:45:00',2.36),('16100','2013-07-24','08:50:00',2.55),('16100','2013-07-24','08:55:00',2.73),('16100','2013-07-24','09:00:00',3.07),('16100','2013-07-24','09:05:00',3.31),('16100','2013-07-24','09:10:00',3.37),('16100','2013-07-24','09:15:00',3.64),('16100','2013-07-24','09:20:00',3.96),('16100','2013-07-24','09:25:00',4.13),('16100','2013-07-24','09:30:00',4.49),('16100','2013-07-24','09:35:00',3.03),('16100','2013-07-24','09:40:00',4.49),('16100','2013-07-24','09:45:00',4.07),('16100','2013-07-24','09:50:00',3.3),('16100','2013-07-24','09:55:00',2.62),('16100','2013-07-24','10:00:00',3.94),('16100','2013-07-24','10:05:00',5.1),('16100','2013-07-24','10:10:00',5.33),('16100','2013-07-24','10:15:00',5.39),('16100','2013-07-24','10:20:00',5.41),('16100','2013-07-24','10:25:00',5.59),('16100','2013-07-24','10:30:00',5.55),('16100','2013-07-24','10:35:00',3.28),('16100','2013-07-24','10:40:00',5.07),('16100','2013-07-24','10:45:00',6.09),('16100','2013-07-24','10:50:00',6.24),('16100','2013-07-24','10:55:00',6.28),('16100','2013-07-24','11:00:00',5.37),('16100','2013-07-24','11:05:00',2.72),('16100','2013-07-24','11:10:00',6.07),('16100','2013-07-24','11:15:00',6.8),('16100','2013-07-24','11:20:00',6.62),('16100','2013-07-24','11:25:00',6.53),('16100','2013-07-24','11:30:00',6.68),('16100','2013-07-24','11:35:00',6.05),('16100','2013-07-24','11:40:00',6.06),('16100','2013-07-24','11:45:00',6.95),('16100','2013-07-24','11:50:00',6.96),('16100','2013-07-24','11:55:00',6.96),('16100','2013-07-24','12:00:00',6.92),('16100','2013-07-24','12:05:00',6.4),('16100','2013-07-24','12:10:00',4.82),('16100','2013-07-24','12:15:00',3.13),('16100','2013-07-24','12:20:00',7.95),('16100','2013-07-24','12:25:00',7.67),('16100','2013-07-24','12:30:00',2.87),('16100','2013-07-24','12:35:00',7.59),('16100','2013-07-24','12:40:00',7.53),('16100','2013-07-24','12:45:00',7.29),('16100','2013-07-24','12:50:00',6.42),('16100','2013-07-24','12:55:00',5.21),('16100','2013-07-24','13:00:00',7.56),('16100','2013-07-24','13:05:00',7.42),('16100','2013-07-24','13:10:00',7.41),('16100','2013-07-24','13:15:00',7.46),('16100','2013-07-24','13:20:00',7.49),('16100','2013-07-24','13:25:00',7.41),('16100','2013-07-24','13:30:00',7.43),('16100','2013-07-24','13:35:00',7.49),('16100','2013-07-24','13:40:00',7.59),('16100','2013-07-24','13:45:00',7.53),('16100','2013-07-24','13:50:00',7.5),('16100','2013-07-24','13:55:00',7.5),('16100','2013-07-24','14:00:00',7.43),('16100','2013-07-24','14:05:00',7.44),('16100','2013-07-24','14:10:00',7.41),('16100','2013-07-24','14:15:00',7.36),('16100','2013-07-24','14:20:00',7.36),('16100','2013-07-24','14:25:00',7.28),('16100','2013-07-24','14:30:00',7.25),('16100','2013-07-24','14:35:00',7.22),('16100','2013-07-24','14:40:00',7.15),('16100','2013-07-24','14:45:00',7.11),('16100','2013-07-24','14:50:00',7.07),('16100','2013-07-24','14:55:00',7.02),('16100','2013-07-24','15:00:00',6.98),('16100','2013-07-24','15:05:00',6.94),('16100','2013-07-24','15:10:00',6.81),('16100','2013-07-24','15:15:00',6.78),('16100','2013-07-24','15:20:00',6.71),('16100','2013-07-24','15:25:00',6.58),('16100','2013-07-24','15:30:00',6.46),('16100','2013-07-24','15:35:00',6.43),('16100','2013-07-24','15:40:00',6.31),('16100','2013-07-24','15:45:00',6.23),('16100','2013-07-24','15:50:00',6.16),('16100','2013-07-24','15:55:00',6.05),('16100','2013-07-24','16:00:00',5.99),('16100','2013-07-24','16:05:00',5.87),('16100','2013-07-24','16:10:00',5.77),('16100','2013-07-24','16:15:00',5.65),('16100','2013-07-24','16:20:00',5.57),('16100','2013-07-24','16:25:00',5.42),('16100','2013-07-24','16:30:00',5.27),('16100','2013-07-24','16:35:00',5.1),('16100','2013-07-24','16:40:00',5),('16100','2013-07-24','16:45:00',4.86),('16100','2013-07-24','16:50:00',4.74),('16100','2013-07-24','16:55:00',4.64),('16100','2013-07-24','17:00:00',4.59),('16100','2013-07-24','17:05:00',4.37),('16100','2013-07-24','17:10:00',4.18),('16100','2013-07-24','17:15:00',4.05),('16100','2013-07-24','17:20:00',3.97),('16100','2013-07-24','17:25:00',3.81),('16100','2013-07-24','17:30:00',3.65),('16100','2013-07-24','17:35:00',3.52),('16100','2013-07-24','17:40:00',3.31),('16100','2013-07-24','17:45:00',3.16),('16100','2013-07-24','17:50:00',2.99),('16100','2013-07-24','17:55:00',2.85),('16100','2013-07-24','18:00:00',2.68),('16100','2013-07-24','18:05:00',2.51),('16100','2013-07-24','18:10:00',2.31),('16100','2013-07-24','18:15:00',2.2),('16100','2013-07-24','18:20:00',2.06),('16100','2013-07-24','18:25:00',1.88),('16100','2013-07-24','18:30:00',1.72),('16100','2013-07-24','18:35:00',1.5),('16100','2013-07-24','18:40:00',1.36),('16100','2013-07-24','18:45:00',1.22),('16100','2013-07-24','18:50:00',1.08),('16100','2013-07-23','07:50:00',1.08),('16100','2013-07-23','07:55:00',1.17),('16100','2013-07-23','08:00:00',1.34),('16100','2013-07-23','08:05:00',1.49),('16100','2013-07-23','08:10:00',1.63),('16100','2013-07-23','08:15:00',1.75),('16100','2013-07-23','08:20:00',1.96),('16100','2013-07-23','08:25:00',2.14),('16100','2013-07-23','08:30:00',1.57),('16100','2013-07-23','08:35:00',1.64),('16100','2013-07-23','08:40:00',2),('16100','2013-07-23','08:45:00',1.98),('16100','2013-07-23','08:50:00',2.03),('16100','2013-07-23','08:55:00',1.74),('16100','2013-07-23','09:00:00',2.11),('16100','2013-07-23','09:05:00',3.29),('16100','2013-07-23','09:10:00',3.56),('16100','2013-07-23','09:15:00',3.69),('16100','2013-07-23','09:20:00',4.04),('16100','2013-07-23','09:25:00',3.88),('16100','2013-07-23','09:30:00',2.42),('16100','2013-07-23','09:35:00',1.65),('16100','2013-07-23','09:40:00',1.44),('16100','2013-07-23','09:45:00',1.57),('16100','2013-07-23','09:50:00',2.5),('16100','2013-07-23','09:55:00',4.86),('16100','2013-07-23','10:00:00',5.16),('16100','2013-07-23','10:05:00',5.4),('16100','2013-07-23','10:10:00',5.76),('16100','2013-07-23','10:15:00',5.46),('16100','2013-07-23','10:20:00',2.44),('16100','2013-07-23','10:25:00',1.62),('16100','2013-07-23','10:30:00',1.41),('16100','2013-07-23','10:35:00',1.96),('16100','2013-07-23','10:40:00',5.46),('16100','2013-07-23','10:45:00',6.2),('16100','2013-07-23','10:50:00',6.42),('16100','2013-07-23','10:55:00',5.32),('16100','2013-07-23','11:00:00',3.96),('16100','2013-07-23','11:05:00',6.02),('16100','2013-07-23','11:10:00',3.55),('16100','2013-07-23','11:15:00',5.18),('16100','2013-07-23','11:20:00',5.74),('16100','2013-07-23','11:25:00',4.3),('16100','2013-07-23','11:30:00',5.14),('16100','2013-07-23','11:35:00',5.56),('16100','2013-07-23','11:40:00',6.73),('16100','2013-07-23','11:45:00',7.04),('16100','2013-07-23','11:50:00',6.22),('16100','2013-07-23','11:55:00',6.46),('16100','2013-07-23','12:00:00',7.13),('16100','2013-07-23','12:05:00',5.92),('16100','2013-07-23','12:10:00',3.61),('16100','2013-07-23','12:15:00',4.56),('16100','2013-07-23','12:20:00',7.85),('16100','2013-07-23','12:25:00',7.8),('16100','2013-07-23','12:30:00',7.62),('16100','2013-07-23','12:35:00',7.4),('16100','2013-07-23','12:40:00',7.52),('16100','2013-07-23','12:45:00',7.73),('16100','2013-07-23','12:50:00',7.42),('16100','2013-07-23','12:55:00',7.36),('16100','2013-07-23','13:00:00',7.23),('16100','2013-07-23','13:05:00',7.35),('16100','2013-07-23','13:10:00',7.58),('16100','2013-07-23','13:15:00',7.29),('16100','2013-07-23','13:20:00',7.44),('16100','2013-07-23','13:25:00',7.52),('16100','2013-07-23','13:30:00',7.43),('16100','2013-07-23','13:35:00',7.51),('16100','2013-07-23','13:40:00',7.44),('16100','2013-07-23','13:45:00',7.58),('16100','2013-07-23','13:50:00',7.44),('16100','2013-07-23','13:55:00',7.39),('16100','2013-07-23','14:00:00',7.44),('16100','2013-07-23','14:05:00',7.49),('16100','2013-07-23','14:10:00',7.43),('16100','2013-07-23','14:15:00',7.37),('16100','2013-07-23','14:20:00',7.31),('16100','2013-07-23','14:25:00',7.37),('16100','2013-07-23','14:30:00',7.34),('16100','2013-07-23','14:35:00',7.24),('16100','2013-07-23','14:40:00',7.21),('16100','2013-07-23','14:45:00',7.19),('16100','2013-07-23','14:50:00',7.12),('16100','2013-07-23','14:55:00',7.06),('16100','2013-07-23','15:00:00',7.03),('16100','2013-07-23','15:05:00',6.94),('16100','2013-07-23','15:10:00',6.74),('16100','2013-07-23','15:15:00',6.77),('16100','2013-07-23','15:20:00',6.5),('16100','2013-07-23','15:25:00',6.19),('16100','2013-07-23','15:30:00',6.59),('16100','2013-07-23','15:35:00',6.29),('16100','2013-07-23','15:40:00',6.25),('16100','2013-07-23','15:45:00',6.11),('16100','2013-07-23','15:50:00',5.94),('16100','2013-07-23','15:55:00',5.66),('16100','2013-07-23','16:00:00',5.45),('16100','2013-07-23','16:05:00',5.99),('16100','2013-07-23','16:10:00',5.93),('16100','2013-07-23','16:15:00',5.68),('16100','2013-07-23','16:20:00',5.61),('16100','2013-07-23','16:25:00',5.29),('16100','2013-07-23','16:30:00',5.28),('16100','2013-07-23','16:35:00',4.5),('16100','2013-07-23','16:40:00',5.02),('16100','2013-07-23','16:45:00',5.25),('16100','2013-07-23','16:50:00',5.05),('16100','2013-07-23','16:55:00',3.92),('16100','2013-07-23','17:00:00',3.92),('16100','2013-07-23','17:05:00',4.78),('16100','2013-07-23','17:10:00',4.53),('16100','2013-07-23','17:15:00',4.25),('16100','2013-07-23','17:20:00',4.04),('16100','2013-07-23','17:25:00',3.85),('16100','2013-07-23','17:30:00',3.55),('16100','2013-07-23','17:35:00',3.49),('16100','2013-07-23','17:40:00',3.35),('16100','2013-07-23','17:45:00',3.18),('16100','2013-07-23','17:50:00',2.94),('16100','2013-07-23','17:55:00',2.74),('16100','2013-07-23','18:00:00',2.68),('16100','2013-07-23','18:05:00',2.44),('16100','2013-07-23','18:10:00',2.24),('16100','2013-07-23','18:15:00',2.16),('16100','2013-07-23','18:20:00',2.08),('16100','2013-07-23','18:25:00',1.85),('16100','2013-07-23','18:30:00',1.72),('16100','2013-07-23','18:35:00',1.52),('16100','2013-07-23','18:40:00',1.41),('16100','2013-07-23','18:45:00',1.09),('16100','2013-07-22','08:00:00',1.17),('16100','2013-07-22','08:05:00',1.32),('16100','2013-07-22','08:15:00',1.24),('16100','2013-07-22','08:20:00',1.37),('16100','2013-07-22','08:25:00',1.99),('16100','2013-07-22','08:30:00',2.16),('16100','2013-07-22','08:35:00',2.32),('16100','2013-07-22','08:40:00',2.52),('16100','2013-07-22','08:45:00',2.65),('16100','2013-07-22','08:50:00',2.79),('16100','2013-07-22','08:55:00',2.95),('16100','2013-07-22','09:00:00',3.2),('16100','2013-07-22','09:05:00',3.47),('16100','2013-07-22','09:10:00',3.63),('16100','2013-07-22','09:15:00',3.78),('16100','2013-07-22','09:20:00',3.88),('16100','2013-07-22','09:25:00',4.03),('16100','2013-07-22','09:30:00',4.21),('16100','2013-07-22','09:35:00',4.34),('16100','2013-07-22','09:40:00',4.45),('16100','2013-07-22','09:45:00',4.59),('16100','2013-07-22','09:50:00',4.65),('16100','2013-07-22','09:55:00',4.76),('16100','2013-07-22','10:00:00',4.88),('16100','2013-07-22','10:05:00',5),('16100','2013-07-22','10:10:00',5.14),('16100','2013-07-22','10:15:00',5.3),('16100','2013-07-22','10:20:00',5.37),('16100','2013-07-22','10:25:00',5.05),('16100','2013-07-22','10:30:00',5.53),('16100','2013-07-22','10:35:00',5.58),('16100','2013-07-22','10:40:00',5.57),('16100','2013-07-22','10:45:00',5.69),('16100','2013-07-22','10:50:00',5.81),('16100','2013-07-22','10:55:00',5.93),('16100','2013-07-22','11:00:00',6.05),('16100','2013-07-22','11:05:00',6.18),('16100','2013-07-22','11:10:00',6.15),('16100','2013-07-22','11:15:00',6.01),('16100','2013-07-22','11:20:00',3.77),('16100','2013-07-22','11:25:00',3.95),('16100','2013-07-22','11:30:00',2.66),('16100','2013-07-22','11:35:00',1.81),('16100','2013-07-22','11:40:00',1.69),('16100','2013-07-22','11:45:00',2.07),('16100','2013-07-22','11:50:00',2.75),('16100','2013-07-22','11:55:00',7.78),('16100','2013-07-22','12:00:00',6.66),('16100','2013-07-22','12:05:00',6.75),('16100','2013-07-22','12:10:00',3.63),('16100','2013-07-22','12:15:00',2.4),('16100','2013-07-22','12:20:00',4.33),('16100','2013-07-22','12:25:00',7.56),('16100','2013-07-22','12:30:00',7.84),('16100','2013-07-22','12:35:00',7.33),('16100','2013-07-22','12:40:00',3.66),('16100','2013-07-22','12:45:00',6.43),('16100','2013-07-22','12:50:00',5.04),('16100','2013-07-22','12:55:00',4.69),('16100','2013-07-22','13:00:00',2.8),('16100','2013-07-22','13:05:00',7.83),('16100','2013-07-22','13:10:00',7.89),('16100','2013-07-22','13:15:00',7.42),('16100','2013-07-22','13:20:00',7.47),('16100','2013-07-22','13:25:00',7.22),('16100','2013-07-22','13:30:00',6.54),('16100','2013-07-22','13:35:00',7.63),('16100','2013-07-22','13:40:00',7.59),('16100','2013-07-22','13:45:00',7.51),('16100','2013-07-22','13:50:00',7.55),('16100','2013-07-22','13:55:00',7.95),('16100','2013-07-22','14:00:00',4.88),('16100','2013-07-22','14:05:00',7.96),('16100','2013-07-22','14:10:00',3.68),('16100','2013-07-22','14:15:00',5.39),('16100','2013-07-22','14:20:00',7.67),('16100','2013-07-22','14:25:00',7.48),('16100','2013-07-22','14:30:00',7.44),('16100','2013-07-22','14:35:00',7.45),('16100','2013-07-22','14:40:00',7.37),('16100','2013-07-22','14:45:00',7.23),('16100','2013-07-22','14:50:00',7.17),('16100','2013-07-22','14:55:00',6.92),('16100','2013-07-22','15:00:00',6.88),('16100','2013-07-22','15:05:00',6.9),('16100','2013-07-22','15:10:00',6.82),('16100','2013-07-22','15:15:00',6.66),('16100','2013-07-22','15:20:00',6.56),('16100','2013-07-22','15:25:00',6.51),('16100','2013-07-22','15:30:00',6.32),('16100','2013-07-22','15:35:00',6.26),('16100','2013-07-22','15:40:00',6.22),('16100','2013-07-22','15:45:00',6.12),('16100','2013-07-22','15:50:00',5.61),('16100','2013-07-22','15:55:00',5.94),('16100','2013-07-22','16:00:00',5.84),('16100','2013-07-22','16:05:00',5.73),('16100','2013-07-22','16:10:00',5.65),('16100','2013-07-22','16:15:00',5.57),('16100','2013-07-22','16:20:00',5.49),('16100','2013-07-22','16:25:00',5.36),('16100','2013-07-22','16:30:00',5.18),('16100','2013-07-22','16:35:00',5.06),('16100','2013-07-22','16:40:00',4.95),('16100','2013-07-22','16:45:00',4.85),('16100','2013-07-22','16:50:00',4.71),('16100','2013-07-22','16:55:00',4.59),('16100','2013-07-22','17:00:00',4.45),('16100','2013-07-22','17:05:00',4.3),('16100','2013-07-22','17:10:00',4.15),('16100','2013-07-22','17:15:00',4.01),('16100','2013-07-22','17:20:00',3.88),('16100','2013-07-22','17:25:00',3.74),('16100','2013-07-22','17:30:00',3.59),('16100','2013-07-22','17:35:00',3.49),('16100','2013-07-22','17:40:00',3.31),('16100','2013-07-22','17:45:00',3.17),('16100','2013-07-22','17:50:00',3.01),('16100','2013-07-22','17:55:00',2.83),('16100','2013-07-22','18:00:00',2.64),('16100','2013-07-22','18:05:00',2.49),('16100','2013-07-22','18:10:00',2.36),('16100','2013-07-22','18:15:00',2.21),('16100','2013-07-22','18:20:00',2.06),('16100','2013-07-22','18:25:00',1.92),('16100','2013-07-22','18:30:00',1.73),('16100','2013-07-22','18:35:00',1.47),('16100','2013-07-22','18:40:00',1.05),('16100','2013-07-22','18:50:00',1.03),('16100','2013-07-21','08:00:00',1.18),('16100','2013-07-21','08:05:00',1.33),('16100','2013-07-21','08:10:00',1.48),('16100','2013-07-21','08:15:00',1.63),('16100','2013-07-21','08:20:00',1.8),('16100','2013-07-21','08:25:00',1.98),('16100','2013-07-21','08:30:00',2.12),('16100','2013-07-21','08:35:00',2.27),('16100','2013-07-21','08:40:00',2.46),('16100','2013-07-21','08:45:00',2.61),('16100','2013-07-21','08:50:00',2.77),('16100','2013-07-21','08:55:00',2.97),('16100','2013-07-21','09:00:00',3.14),('16100','2013-07-21','09:05:00',3.47),('16100','2013-07-21','09:10:00',3.64),('16100','2013-07-21','09:15:00',3.77),('16100','2013-07-21','09:20:00',3.9),('16100','2013-07-21','09:25:00',4.05),('16100','2013-07-21','09:30:00',4.21),('16100','2013-07-21','09:35:00',4.31),('16100','2013-07-21','09:40:00',4.46),('16100','2013-07-21','09:45:00',4.59),('16100','2013-07-21','09:50:00',4.71),('16100','2013-07-21','09:55:00',4.83),('16100','2013-07-21','10:00:00',4.95),('16100','2013-07-21','10:05:00',5.07),('16100','2013-07-21','10:10:00',5.21),('16100','2013-07-21','10:15:00',5.35),('16100','2013-07-21','10:20:00',5.45),('16100','2013-07-21','10:25:00',5.58),('16100','2013-07-21','10:30:00',5.68),('16100','2013-07-21','10:35:00',5.75),('16100','2013-07-21','10:40:00',5.8),('16100','2013-07-21','10:45:00',5.91),('16100','2013-07-21','10:50:00',6.01),('16100','2013-07-21','10:55:00',6.04),('16100','2013-07-21','11:00:00',6.16),('16100','2013-07-21','11:05:00',6.29),('16100','2013-07-21','11:10:00',6.38),('16100','2013-07-21','11:15:00',6.44),('16100','2013-07-21','11:20:00',6.49),('16100','2013-07-21','11:25:00',6.52),('16100','2013-07-21','11:30:00',6.6),('16100','2013-07-21','11:35:00',6.65),('16100','2013-07-21','11:40:00',6.73),('16100','2013-07-21','11:45:00',6.8),('16100','2013-07-21','11:50:00',6.86),('16100','2013-07-21','11:55:00',6.92),('16100','2013-07-21','12:00:00',6.98),('16100','2013-07-21','12:05:00',7.02),('16100','2013-07-21','12:10:00',7.09),('16100','2013-07-21','12:15:00',7.07),('16100','2013-07-21','12:20:00',7.13),('16100','2013-07-21','12:25:00',7.16),('16100','2013-07-21','12:30:00',7.13),('16100','2013-07-21','12:35:00',7.17),('16100','2013-07-21','12:40:00',7.15),('16100','2013-07-21','12:45:00',7.21),('16100','2013-07-21','12:50:00',7.25),('16100','2013-07-21','12:55:00',7.24),('16100','2013-07-21','13:00:00',7.25),('16100','2013-07-21','13:05:00',7.28),('16100','2013-07-21','13:10:00',7.22),('16100','2013-07-21','13:15:00',7.19),('16100','2013-07-21','13:20:00',7.24),('16100','2013-07-21','13:25:00',7.17),('16100','2013-07-21','13:30:00',7.19),('16100','2013-07-21','13:35:00',7.24),('16100','2013-07-21','13:40:00',7.2),('16100','2013-07-21','13:45:00',7.25),('16100','2013-07-21','13:50:00',7.26),('16100','2013-07-21','13:55:00',7.18),('16100','2013-07-21','14:00:00',7.11),('16100','2013-07-21','14:05:00',7.07),('16100','2013-07-21','14:10:00',7.11),('16100','2013-07-21','14:15:00',6.96),('16100','2013-07-21','14:20:00',6.97),('16100','2013-07-21','14:25:00',6.87),('16100','2013-07-21','14:30:00',6.86),('16100','2013-07-21','14:35:00',6.86),('16100','2013-07-21','14:40:00',6.95),('16100','2013-07-21','14:45:00',6.73),('16100','2013-07-21','14:50:00',5.18),('16100','2013-07-21','14:55:00',6.51),('16100','2013-07-21','15:00:00',6.75),('16100','2013-07-21','15:05:00',6.58),('16100','2013-07-21','15:10:00',6.66),('16100','2013-07-21','15:15:00',6.42),('16100','2013-07-21','15:20:00',1.65),('16100','2013-07-21','15:25:00',1.63),('16100','2013-07-21','15:30:00',2.52),('16100','2013-07-21','15:35:00',1.98),('16100','2013-07-21','15:40:00',1.61),('16100','2013-07-21','15:45:00',1.89),('16100','2013-07-21','15:50:00',4.26),('16100','2013-07-21','15:55:00',3.19),('16100','2013-07-21','16:00:00',5.29),('16100','2013-07-21','16:05:00',5.09),('16100','2013-07-21','16:10:00',5.89),('16100','2013-07-21','16:15:00',5.83),('16100','2013-07-21','16:20:00',5.66),('16100','2013-07-21','16:25:00',5.59),('16100','2013-07-21','16:30:00',5.18),('16100','2013-07-21','16:35:00',4.95),('16100','2013-07-21','16:40:00',4.81),('16100','2013-07-21','16:45:00',4.48),('16100','2013-07-21','16:50:00',3.33),('16100','2013-07-21','16:55:00',4.55),('16100','2013-07-21','17:00:00',4.4),('16100','2013-07-21','17:05:00',4.24),('16100','2013-07-21','17:10:00',4.11),('16100','2013-07-21','17:15:00',3.95),('16100','2013-07-21','17:20:00',3.83),('16100','2013-07-21','17:25:00',3.68),('16100','2013-07-21','17:30:00',3.6),('16100','2013-07-21','17:35:00',3.48),('16100','2013-07-21','17:40:00',3.32),('16100','2013-07-21','17:45:00',3.14),('16100','2013-07-21','17:50:00',3.03),('16100','2013-07-21','17:55:00',2.89),('16100','2013-07-21','18:00:00',2.68),('16100','2013-07-21','18:05:00',2.44),('16100','2013-07-21','18:10:00',2.02),('16100','2013-07-21','18:15:00',1.57),('16100','2013-07-21','18:20:00',1.95),('16100','2013-07-21','18:25:00',1.73),('16100','2013-07-21','18:30:00',1.71),('16100','2013-07-21','18:35:00',1.59),('16100','2013-07-21','18:40:00',1.3),('16100','2013-07-21','18:45:00',1.17),('16100','2013-07-21','18:50:00',1.02),('16100','2013-07-20','07:55:00',1.02),('16100','2013-07-20','08:00:00',1.16),('16100','2013-07-20','08:05:00',1.29),('16100','2013-07-20','08:10:00',1.43),('16100','2013-07-20','08:15:00',1.56),('16100','2013-07-20','08:20:00',1.71),('16100','2013-07-20','08:25:00',1.9),('16100','2013-07-20','08:30:00',2.05),('16100','2013-07-20','08:35:00',2.21),('16100','2013-07-20','08:40:00',2.38),('16100','2013-07-20','08:45:00',2.51),('16100','2013-07-20','08:50:00',2.67),('16100','2013-07-20','08:55:00',2.85),('16100','2013-07-20','09:00:00',2.99),('16100','2013-07-20','09:05:00',3.34),('16100','2013-07-20','09:10:00',3.54),('16100','2013-07-20','09:15:00',3.69),('16100','2013-07-20','09:20:00',3.81),('16100','2013-07-20','09:25:00',3.93),('16100','2013-07-20','09:30:00',4.08),('16100','2013-07-20','09:35:00',4.21),('16100','2013-07-20','09:40:00',4.35),('16100','2013-07-20','09:45:00',4.46),('16100','2013-07-20','09:50:00',4.52),('16100','2013-07-20','09:55:00',4.67),('16100','2013-07-20','10:00:00',4.76),('16100','2013-07-20','10:05:00',4.88),('16100','2013-07-20','10:10:00',5.02),('16100','2013-07-20','10:15:00',5.17),('16100','2013-07-20','10:20:00',5.31),('16100','2013-07-20','10:25:00',5.44),('16100','2013-07-20','10:30:00',5.48),('16100','2013-07-20','10:35:00',5.56),('16100','2013-07-20','10:40:00',5.76),('16100','2013-07-20','10:45:00',5.82),('16100','2013-07-20','10:50:00',5.93),('16100','2013-07-20','10:55:00',6.01),('16100','2013-07-20','11:00:00',6.05),('16100','2013-07-20','11:05:00',6.19),('16100','2013-07-20','11:10:00',6.29),('16100','2013-07-20','11:15:00',6.36),('16100','2013-07-20','11:20:00',6.44),('16100','2013-07-20','11:25:00',6.48),('16100','2013-07-20','11:30:00',6.54),('16100','2013-07-20','11:35:00',6.6),('16100','2013-07-20','11:40:00',6.66),('16100','2013-07-20','11:45:00',6.78),('16100','2013-07-20','11:50:00',6.78),('16100','2013-07-20','11:55:00',6.84),('16100','2013-07-20','12:00:00',6.75),('16100','2013-07-20','12:05:00',6.84),('16100','2013-07-20','12:10:00',7.12),('16100','2013-07-20','12:15:00',7.74),('16100','2013-07-20','12:20:00',4.7),('16100','2013-07-20','12:25:00',3.66),('16100','2013-07-20','12:30:00',3.79),('16100','2013-07-20','12:35:00',4.78),('16100','2013-07-20','12:40:00',5.61),('16100','2013-07-20','12:45:00',6.23),('16100','2013-07-20','12:50:00',3.7),('16100','2013-07-20','12:55:00',3.24),('16100','2013-07-20','13:00:00',3.21),('16100','2013-07-20','13:05:00',3.37),('16100','2013-07-20','13:10:00',3.3),('16100','2013-07-20','13:15:00',3.4),('16100','2013-07-20','13:20:00',8.03),('16100','2013-07-20','13:25:00',6.62),('16100','2013-07-20','13:30:00',6.46),('16100','2013-07-20','13:35:00',6.03),('16100','2013-07-20','13:40:00',7.16),('16100','2013-07-20','13:45:00',7.69),('16100','2013-07-20','13:50:00',7.93),('16100','2013-07-20','13:55:00',5.21),('16100','2013-07-20','14:00:00',3.39),('16100','2013-07-20','14:05:00',4.82),('16100','2013-07-20','14:10:00',4.31),('16100','2013-07-20','14:15:00',4.07),('16100','2013-07-20','14:20:00',2.92),('16100','2013-07-20','14:25:00',2.9),('16100','2013-07-20','14:30:00',2.48),('16100','2013-07-20','14:35:00',2.21),('16100','2013-07-20','14:40:00',2.21),('16100','2013-07-20','14:45:00',2.45),('16100','2013-07-20','14:50:00',3.23),('16100','2013-07-20','14:55:00',3.71),('16100','2013-07-20','15:00:00',2.21),('16100','2013-07-20','15:05:00',2.12),('16100','2013-07-20','15:10:00',2.06),('16100','2013-07-20','15:15:00',2.15),('16100','2013-07-20','15:20:00',2.44),('16100','2013-07-20','15:25:00',2.31),('16100','2013-07-20','15:30:00',2.34),('16100','2013-07-20','15:35:00',2.75),('16100','2013-07-20','15:40:00',3.53),('16100','2013-07-20','15:45:00',3.08),('16100','2013-07-20','15:50:00',4.84),('16100','2013-07-20','15:55:00',3.58),('16100','2013-07-20','16:00:00',2.24),('16100','2013-07-20','16:05:00',1.66),('16100','2013-07-20','16:10:00',1.43),('16100','2013-07-20','16:15:00',1.23),('16100','2013-07-20','16:20:00',1.12),('16100','2013-07-20','16:25:00',1.12),('16100','2013-07-20','16:30:00',1.25),('16100','2013-07-20','16:35:00',1.5),('16100','2013-07-20','16:40:00',1.69),('16100','2013-07-20','16:45:00',1.68),('16100','2013-07-20','16:50:00',1.66),('16100','2013-07-20','16:55:00',1.63),('16100','2013-07-20','17:00:00',1.82),('16100','2013-07-20','17:05:00',2.43),('16100','2013-07-20','17:10:00',1.96),('16100','2013-07-20','17:15:00',1.58),('16100','2013-07-20','17:20:00',1.35),('16100','2013-07-20','17:25:00',1.22),('16100','2013-07-20','17:30:00',1.14),('16100','2013-07-20','17:35:00',1.08),('16100','2013-07-20','17:40:00',1.07),('16100','2013-07-20','17:45:00',1.08),('16100','2013-07-20','17:50:00',1.09),('16100','2013-07-20','17:55:00',1.12),('16100','2013-07-20','18:00:00',1.12),('16100','2013-07-20','18:05:00',1.03),('16100','2014-04-06','08:10:00',1.05),('16100','2014-04-06','08:15:00',1.26),('16100','2014-04-06','08:20:00',1.35),('16100','2014-04-06','08:25:00',1.57),('16100','2014-04-06','08:30:00',1.57),('16100','2014-04-06','08:35:00',1.71),('16100','2014-04-06','08:40:00',1.58),('16100','2014-04-06','08:45:00',1.54),('16100','2014-04-06','08:50:00',1.53),('16100','2014-04-06','08:55:00',1.52),('16100','2014-04-06','09:00:00',1.55),('16100','2014-04-06','09:05:00',1.64),('16100','2014-04-06','09:10:00',1.61),('16100','2014-04-06','09:15:00',1.57),('16100','2014-04-06','09:20:00',1.57),('16100','2014-04-06','09:25:00',1.59),('16100','2014-04-06','09:30:00',1.64),('16100','2014-04-06','09:35:00',1.7),('16100','2014-04-06','09:40:00',1.78),('16100','2014-04-06','09:45:00',1.84),('16100','2014-04-06','09:50:00',1.84),('16100','2014-04-06','09:55:00',1.86),('16100','2014-04-06','10:00:00',1.87),('16100','2014-04-06','10:05:00',1.87),('16100','2014-04-06','10:10:00',1.87),('16100','2014-04-06','10:15:00',1.91),('16100','2014-04-06','10:20:00',1.94),('16100','2014-04-06','10:25:00',1.91),('16100','2014-04-06','10:30:00',1.91),('16100','2014-04-06','10:35:00',1.98),('16100','2014-04-06','10:40:00',2.11),('16100','2014-04-06','10:45:00',2.25),('16100','2014-04-06','10:50:00',2.39),('16100','2014-04-06','10:55:00',2.44),('16100','2014-04-06','11:00:00',2.54),('16100','2014-04-06','11:05:00',2.57),('16100','2014-04-06','11:10:00',2.63),('16100','2014-04-06','11:15:00',2.72),('16100','2014-04-06','11:20:00',2.75),('16100','2014-04-06','11:25:00',2.68),('16100','2014-04-06','11:30:00',2.72),('16100','2014-04-06','11:35:00',2.6),('16100','2014-04-06','11:40:00',2.58),('16100','2014-04-06','11:45:00',2.62),('16100','2014-04-06','11:50:00',2.61),('16100','2014-04-06','11:55:00',3.08),('16100','2014-04-06','12:00:00',3.77),('16100','2014-04-06','12:05:00',5.38),('16100','2014-04-06','12:10:00',6.07),('16100','2014-04-06','12:15:00',6.39),('16100','2014-04-06','12:20:00',5.49),('16100','2014-04-06','12:25:00',3.65),('16100','2014-04-06','12:30:00',3.41),('16100','2014-04-06','12:35:00',6.53),('16100','2014-04-06','12:40:00',7.46),('16100','2014-04-06','12:45:00',7.19),('16100','2014-04-06','12:50:00',7.01),('16100','2014-04-06','12:55:00',7.03),('16100','2014-04-06','13:00:00',7.05),('16100','2014-04-06','13:05:00',7.04),('16100','2014-04-06','13:10:00',7.04),('16100','2014-04-06','13:15:00',7.03),('16100','2014-04-06','13:20:00',7.04),('16100','2014-04-06','13:25:00',7.03),('16100','2014-04-06','13:30:00',7.02),('16100','2014-04-06','13:35:00',6.99),('16100','2014-04-06','13:40:00',6.98),('16100','2014-04-06','13:45:00',6.94),('16100','2014-04-06','13:50:00',6.91),('16100','2014-04-06','13:55:00',6.9),('16100','2014-04-06','14:00:00',6.8),('16100','2014-04-06','14:05:00',6.8),('16100','2014-04-06','14:10:00',6.76),('16100','2014-04-06','14:15:00',6.7),('16100','2014-04-06','14:20:00',6.72),('16100','2014-04-06','14:25:00',6.64),('16100','2014-04-06','14:30:00',6.63),('16100','2014-04-06','14:35:00',6.56),('16100','2014-04-06','14:40:00',6.57),('16100','2014-04-06','14:45:00',6.69),('16100','2014-04-06','14:50:00',6.56),('16100','2014-04-06','14:55:00',6.37),('16100','2014-04-06','15:00:00',6.34),('16100','2014-04-06','15:05:00',5.51),('16100','2014-04-06','15:10:00',6.32),('16100','2014-04-06','15:15:00',6.26),('16100','2014-04-06','15:20:00',6.15),('16100','2014-04-06','15:25:00',6.04),('16100','2014-04-06','15:30:00',5.94),('16100','2014-04-06','15:35:00',5.9),('16100','2014-04-06','15:40:00',5.85),('16100','2014-04-06','15:45:00',5.78),('16100','2014-04-06','15:50:00',5.76),('16100','2014-04-06','15:55:00',5.69),('16100','2014-04-06','16:00:00',5.6),('16100','2014-04-06','16:05:00',5.49),('16100','2014-04-06','16:10:00',5.23),('16100','2014-04-06','16:15:00',3.4),('16100','2014-04-06','16:20:00',1.52),('16100','2014-04-06','16:25:00',1.12),('16100','2014-04-06','16:30:00',1.98),('16100','2014-04-06','16:35:00',2.61),('16100','2014-04-06','16:40:00',1.33),('16100','2014-04-06','16:45:00',2.78),('16100','2014-04-06','16:50:00',4.48),('16100','2014-04-06','16:55:00',4.5),('16100','2014-04-06','17:00:00',4.55),('16100','2014-04-06','17:05:00',4.02),('16100','2014-04-06','17:10:00',3.18),('16100','2014-04-06','17:15:00',2.9),('16100','2014-04-06','17:20:00',2.84),('16100','2014-04-06','17:25:00',2.7),('16100','2014-04-06','17:30:00',2.37),('16100','2014-04-06','17:35:00',2.76),('16100','2014-04-06','17:40:00',2.77),('16100','2014-04-06','17:45:00',2.52),('16100','2014-04-06','17:50:00',2.1),('16100','2014-04-06','17:55:00',1.77),('16100','2014-04-06','18:00:00',1.55),('16100','2014-04-06','18:05:00',1.53),('16100','2014-04-06','18:10:00',1.49),('16100','2014-04-06','18:15:00',1.48),('16100','2014-04-06','18:20:00',1.22),('16100','2014-04-06','18:25:00',1.02),('16100','2013-07-19','08:00:00',1.19),('16100','2013-07-19','08:05:00',1.36),('16100','2013-07-19','08:10:00',1.51),('16100','2013-07-19','08:15:00',1.68),('16100','2013-07-19','08:20:00',1.86),('16100','2013-07-19','08:25:00',2.03),('16100','2013-07-19','08:30:00',2.18),('16100','2013-07-19','08:35:00',2.35),('16100','2013-07-19','08:40:00',2.55),('16100','2013-07-19','08:45:00',2.7),('16100','2013-07-19','08:50:00',2.89),('16100','2013-07-19','08:55:00',3.09),('16100','2013-07-19','09:00:00',3.21),('16100','2013-07-19','09:05:00',3.61),('16100','2013-07-19','09:10:00',3.87),('16100','2013-07-19','09:15:00',4.03),('16100','2013-07-19','09:20:00',4.06),('16100','2013-07-19','09:25:00',4.04),('16100','2013-07-19','09:30:00',4.26),('16100','2013-07-19','09:35:00',4.29),('16100','2013-07-19','09:40:00',4.24),('16100','2013-07-19','09:45:00',4.04),('16100','2013-07-19','09:50:00',4.35),('16100','2013-07-19','09:55:00',4.67),('16100','2013-07-19','10:00:00',4.98),('16100','2013-07-19','10:05:00',5.1),('16100','2013-07-19','10:10:00',5.26),('16100','2013-07-19','10:15:00',5.38),('16100','2013-07-19','10:20:00',5.49),('16100','2013-07-19','10:25:00',5.62),('16100','2013-07-19','10:30:00',5.71),('16100','2013-07-19','10:35:00',5.78),('16100','2013-07-19','10:40:00',5.84),('16100','2013-07-19','10:45:00',5.95),('16100','2013-07-19','10:50:00',5.98),('16100','2013-07-19','10:55:00',6.11),('16100','2013-07-19','11:00:00',6.22),('16100','2013-07-19','11:05:00',6.35),('16100','2013-07-19','11:10:00',6.39),('16100','2013-07-19','11:15:00',6.47),('16100','2013-07-19','11:20:00',6.57),('16100','2013-07-19','11:25:00',6.63),('16100','2013-07-19','11:30:00',6.72),('16100','2013-07-19','11:35:00',6.8),('16100','2013-07-19','11:40:00',6.83),('16100','2013-07-19','11:45:00',6.86),('16100','2013-07-19','11:50:00',6.95),('16100','2013-07-19','11:55:00',6.98),('16100','2013-07-19','12:00:00',7.1),('16100','2013-07-19','12:05:00',7.16),('16100','2013-07-19','12:10:00',7.17),('16100','2013-07-19','12:15:00',7.23),('16100','2013-07-19','12:20:00',7.26),('16100','2013-07-19','12:25:00',7.23),('16100','2013-07-19','12:30:00',7.37),('16100','2013-07-19','12:35:00',7.34),('16100','2013-07-19','12:40:00',7.35),('16100','2013-07-19','12:45:00',7.4),('16100','2013-07-19','12:50:00',7.44),('16100','2013-07-19','12:55:00',4.03),('16100','2013-07-19','13:00:00',7.15),('16100','2013-07-19','13:05:00',7.6),('16100','2013-07-19','13:10:00',7.63),('16100','2013-07-19','13:15:00',7.48),('16100','2013-07-19','13:20:00',7.52),('16100','2013-07-19','13:25:00',7.37),('16100','2013-07-19','13:30:00',7.27),('16100','2013-07-19','13:35:00',2.3),('16100','2013-07-19','13:40:00',5.47),('16100','2013-07-19','13:45:00',3.93),('16100','2013-07-19','13:50:00',7.81),('16100','2013-07-19','13:55:00',6.82),('16100','2013-07-19','14:00:00',6.3),('16100','2013-07-19','14:05:00',7.78),('16100','2013-07-19','14:10:00',6.6),('16100','2013-07-19','14:15:00',4.98),('16100','2013-07-19','14:20:00',7.55),('16100','2013-07-19','14:25:00',7.32),('16100','2013-07-19','14:30:00',7.36),('16100','2013-07-19','14:35:00',7.1),('16100','2013-07-19','14:40:00',7.13),('16100','2013-07-19','14:45:00',7.11),('16100','2013-07-19','14:50:00',7.08),('16100','2013-07-19','14:55:00',6.95),('16100','2013-07-19','15:00:00',6.8),('16100','2013-07-19','15:05:00',6.84),('16100','2013-07-19','15:10:00',6.72),('16100','2013-07-19','15:15:00',6.7),('16100','2013-07-19','15:20:00',6.63),('16100','2013-07-19','15:25:00',6.5),('16100','2013-07-19','15:30:00',6.39),('16100','2013-07-19','15:35:00',6.29),('16100','2013-07-19','15:40:00',6.25),('16100','2013-07-19','15:45:00',6.21),('16100','2013-07-19','15:50:00',6.13),('16100','2013-07-19','15:55:00',5.98),('16100','2013-07-19','16:00:00',5.86),('16100','2013-07-19','16:05:00',5.79),('16100','2013-07-19','16:10:00',5.66),('16100','2013-07-19','16:15:00',5.52),('16100','2013-07-19','16:20:00',5.47),('16100','2013-07-19','16:25:00',5.33),('16100','2013-07-19','16:30:00',5.19),('16100','2013-07-19','16:35:00',5.05),('16100','2013-07-19','16:40:00',4.99),('16100','2013-07-19','16:45:00',4.88),('16100','2013-07-19','16:50:00',4.77),('16100','2013-07-19','16:55:00',4.62),('16100','2013-07-19','17:00:00',4.5),('16100','2013-07-19','17:05:00',4.38),('16100','2013-07-19','17:10:00',4.24),('16100','2013-07-19','17:15:00',4.04),('16100','2013-07-19','17:20:00',3.94),('16100','2013-07-19','17:25:00',3.78),('16100','2013-07-19','17:30:00',3.63),('16100','2013-07-19','17:35:00',3.48),('16100','2013-07-19','17:40:00',3.34),('16100','2013-07-19','17:45:00',3.15),('16100','2013-07-19','17:50:00',3.01),('16100','2013-07-19','17:55:00',2.88),('16100','2013-07-19','18:00:00',2.7),('16100','2013-07-19','18:05:00',2.52),('16100','2013-07-19','18:10:00',2.37),('16100','2013-07-19','18:15:00',2.22),('16100','2013-07-19','18:20:00',2.06),('16100','2013-07-19','18:25:00',1.87),('16100','2013-07-19','18:30:00',1.67),('16100','2013-07-19','18:35:00',1.53),('16100','2013-07-19','18:40:00',1.37),('16100','2013-07-19','18:45:00',1.23),('16100','2013-07-19','18:50:00',1.08),('16100','2014-05-02','07:50:00',1.03),('16100','2014-05-02','07:55:00',1.19),('16100','2014-05-02','08:00:00',1.45),('16100','2014-05-02','08:05:00',1.7),('16100','2014-05-02','08:10:00',1.94),('16100','2014-05-02','08:15:00',1.07),('16100','2014-05-02','08:20:00',1.01),('16100','2014-05-02','08:25:00',1.55),('16100','2014-05-02','08:30:00',2.86),('16100','2014-05-02','08:35:00',3.19),('16100','2014-05-02','08:40:00',3.62),('16100','2014-05-02','08:45:00',3.88),('16100','2014-05-02','08:50:00',3.54),('16100','2014-05-02','08:55:00',1.66),('16100','2014-05-02','09:00:00',3.49),('16100','2014-05-02','09:05:00',4.4),('16100','2014-05-02','09:10:00',4.13),('16100','2014-05-02','09:15:00',2.33),('16100','2014-05-02','09:20:00',3.78),('16100','2014-05-02','09:25:00',3.01),('16100','2014-05-02','09:30:00',1.76),('16100','2014-05-02','09:35:00',2.39),('16100','2014-05-02','09:40:00',5.55),('16100','2014-05-02','09:45:00',4.2),('16100','2014-05-02','09:50:00',2.95),('16100','2014-05-02','09:55:00',5.83),('16100','2014-05-02','10:00:00',3.39),('16100','2014-05-02','10:05:00',4.73),('16100','2014-05-02','10:10:00',3.72),('16100','2014-05-02','10:15:00',3.38),('16100','2014-05-02','10:20:00',3.23),('16100','2014-05-02','10:25:00',2.09),('16100','2014-05-02','10:30:00',2.92),('16100','2014-05-02','10:35:00',2.58),('16100','2014-05-02','10:40:00',4.07),('16100','2014-05-02','10:45:00',2.62),('16100','2014-05-02','10:50:00',3.66),('16100','2014-05-02','10:55:00',3.87),('16100','2014-05-02','11:00:00',1.41),('16100','2014-05-02','11:05:00',1.6),('16100','2014-05-02','11:10:00',2.04),('16100','2014-05-02','11:15:00',3.65),('16100','2014-05-02','11:20:00',1.17),('16100','2014-05-02','11:35:00',1.09),('16100','2014-05-02','11:40:00',2.48),('16100','2014-05-02','11:45:00',6.81),('16100','2014-05-02','11:50:00',5.27),('16100','2014-05-02','11:55:00',4.73),('16100','2014-05-02','12:00:00',4.65),('16100','2014-05-02','12:05:00',4.65),('16100','2014-05-02','12:10:00',3.23),('16100','2014-05-02','12:15:00',2.32),('16100','2014-05-02','12:20:00',2.45),('16100','2014-05-02','12:25:00',2.39),('16100','2014-05-02','12:30:00',1.96),('16100','2014-05-02','12:35:00',1.98),('16100','2014-05-02','12:40:00',2.37),('16100','2014-05-02','12:45:00',2.84),('16100','2014-05-02','12:50:00',4.2),('16100','2014-05-02','12:55:00',4.14),('16100','2014-05-02','13:00:00',4.5),('16100','2014-05-02','13:05:00',4.55),('16100','2014-05-02','13:10:00',3.96),('16100','2014-05-02','13:15:00',7.16),('16100','2014-05-02','13:20:00',7.04),('16100','2014-05-02','13:25:00',4.06),('16100','2014-05-02','13:30:00',2.12),('16100','2014-05-02','13:35:00',3.84),('16100','2014-05-02','13:40:00',4),('16100','2014-05-02','13:45:00',3.38),('16100','2014-05-02','13:50:00',3.14),('16100','2014-05-02','13:55:00',3.51),('16100','2014-05-02','14:00:00',4.6),('16100','2014-05-02','14:05:00',5.37),('16100','2014-05-02','14:10:00',4.53),('16100','2014-05-02','14:15:00',4),('16100','2014-05-02','14:20:00',4.08),('16100','2014-05-02','14:25:00',4.1),('16100','2014-05-02','14:30:00',4.11),('16100','2014-05-02','14:35:00',4.42),('16100','2014-05-02','14:40:00',4.59),('16100','2014-05-02','14:45:00',2.03),('16100','2014-05-02','16:45:00',1.02),('16100','2014-05-02','16:50:00',1.1),('16100','2014-05-02','16:55:00',1.16),('16100','2014-05-02','17:00:00',1.22),('16100','2014-05-02','17:05:00',1.26),('16100','2014-05-02','17:10:00',1.3),('16100','2014-05-02','17:15:00',1.35),('16100','2014-05-02','17:20:00',1.41),('16100','2014-05-02','17:25:00',1.44),('16100','2014-05-02','17:30:00',1.55),('16100','2014-05-02','17:35:00',2.15),('16100','2014-05-02','17:40:00',1.87),('16100','2014-05-02','17:45:00',1.93),('16100','2014-05-02','17:50:00',1.85),('16100','2014-05-02','17:55:00',1.87),('16100','2014-05-02','18:00:00',1.78),('16100','2014-05-02','18:05:00',1.83),('16100','2014-05-02','18:10:00',1.41),('16100','2014-05-02','18:15:00',1.05),('16100','2014-05-02','18:20:00',1.05),('16100','2014-05-02','18:30:00',1.01),('16100','2014-05-02','18:35:00',1.04),('16100','2014-05-02','18:40:00',1.07),('16100','2014-04-05','08:15:00',1.19),('16100','2014-04-05','08:20:00',1.29),('16100','2014-04-05','08:25:00',1.61),('16100','2014-04-05','08:30:00',1.91),('16100','2014-04-05','08:35:00',2.09),('16100','2014-04-05','08:40:00',2.28),('16100','2014-04-05','08:45:00',2.48),('16100','2014-04-05','08:50:00',2.65),('16100','2014-04-05','08:55:00',2.84),('16100','2014-04-05','09:00:00',3.06),('16100','2014-04-05','09:05:00',3.24),('16100','2014-04-05','09:10:00',3.45),('16100','2014-04-05','09:15:00',3.63),('16100','2014-04-05','09:20:00',3.5),('16100','2014-04-05','09:25:00',1.91),('16100','2014-04-05','09:30:00',2.03),('16100','2014-04-05','09:35:00',3.1),('16100','2014-04-05','09:40:00',2.94),('16100','2014-04-05','09:45:00',2.63),('16100','2014-04-05','09:50:00',4.43),('16100','2014-04-05','09:55:00',5.24),('16100','2014-04-05','10:00:00',2.9),('16100','2014-04-05','10:05:00',2.57),('16100','2014-04-05','10:10:00',2.15),('16100','2014-04-05','10:15:00',2.65),('16100','2014-04-05','10:20:00',4.05),('16100','2014-04-05','10:25:00',6.65),('16100','2014-04-05','10:30:00',6.34),('16100','2014-04-05','10:35:00',7.44),('16100','2014-04-05','10:40:00',4.27),('16100','2014-04-05','10:45:00',2.33),('16100','2014-04-05','10:50:00',3.78),('16100','2014-04-05','10:55:00',6.06),('16100','2014-04-05','11:00:00',7.22),('16100','2014-04-05','11:05:00',7.37),('16100','2014-04-05','11:10:00',7.28),('16100','2014-04-05','11:15:00',7.32),('16100','2014-04-05','11:20:00',6.86),('16100','2014-04-05','11:25:00',7.46),('16100','2014-04-05','11:30:00',7.63),('16100','2014-04-05','11:35:00',7.28),('16100','2014-04-05','11:40:00',7.16),('16100','2014-04-05','11:45:00',7.08),('16100','2014-04-05','11:50:00',7.08),('16100','2014-04-05','11:55:00',7.11),('16100','2014-04-05','12:00:00',7.25),('16100','2014-04-05','12:05:00',7.5),('16100','2014-04-05','12:10:00',7.53),('16100','2014-04-05','12:15:00',7.52),('16100','2014-04-05','12:20:00',7.48),('16100','2014-04-05','12:25:00',6.96),('16100','2014-04-05','12:30:00',7.59),('16100','2014-04-05','12:35:00',7.6),('16100','2014-04-05','12:40:00',7.62),('16100','2014-04-05','12:45:00',7.63),('16100','2014-04-05','12:50:00',7.72),('16100','2014-04-05','12:55:00',7.6),('16100','2014-04-05','13:00:00',7.48),('16100','2014-04-05','13:05:00',8.16),('16100','2014-04-05','13:10:00',7.17),('16100','2014-04-05','13:15:00',6.49),('16100','2014-04-05','13:20:00',5.91),('16100','2014-04-05','13:25:00',1.96),('16100','2014-04-05','13:30:00',4.68),('16100','2014-04-05','13:35:00',7.96),('16100','2014-04-05','13:40:00',7.83),('16100','2014-04-05','13:45:00',7.17),('16100','2014-04-05','13:50:00',3.21),('16100','2014-04-05','13:55:00',4.31),('16100','2014-04-05','14:00:00',6.07),('16100','2014-04-05','14:05:00',4.8),('16100','2014-04-05','14:10:00',7.59),('16100','2014-04-05','14:15:00',2.45),('16100','2014-04-05','14:20:00',4.53),('16100','2014-04-05','14:25:00',7.76),('16100','2014-04-05','14:30:00',7.67),('16100','2014-04-05','14:35:00',3.5),('16100','2014-04-05','14:40:00',4.29),('16100','2014-04-05','14:45:00',7.73),('16100','2014-04-05','14:50:00',7.78),('16100','2014-04-05','14:55:00',3.46),('16100','2014-04-05','15:00:00',2.13),('16100','2014-04-05','15:05:00',1.1),('16100','2014-04-05','15:20:00',1.1),('16100','2014-04-05','15:25:00',1.2),('16100','2014-04-05','15:30:00',1.15),('16100','2014-04-05','15:40:00',1.03),('16100','2014-04-05','15:45:00',1.16),('16100','2014-04-05','15:50:00',1.44),('16100','2014-04-05','15:55:00',1.99),('16100','2014-04-05','16:00:00',4.9),('16100','2014-04-05','16:05:00',6.79),('16100','2014-04-05','16:10:00',3.97),('16100','2014-04-05','16:15:00',1.56),('16100','2014-04-05','16:20:00',1.33),('16100','2014-04-05','16:25:00',1.14),('16100','2014-04-05','16:30:00',1.12),('16100','2014-04-05','16:40:00',2.65),('16100','2014-04-05','16:45:00',3.36),('16100','2014-04-05','16:50:00',2.47),('16100','2014-04-05','16:55:00',1.98),('16100','2014-04-05','17:00:00',1.6),('16100','2014-04-05','17:05:00',1.12),('16100','2014-04-05','17:20:00',1.38),('16100','2014-04-05','17:25:00',3.48),('16100','2014-04-05','17:30:00',3.44),('16100','2014-04-05','17:35:00',3),('16100','2014-04-05','17:40:00',2.98),('16100','2014-04-05','17:45:00',2.81),('16100','2014-04-05','17:50:00',2.6),('16100','2014-04-05','17:55:00',2.28),('16100','2014-04-05','18:00:00',2.06),('16100','2014-04-05','18:05:00',1.86),('16100','2014-04-05','18:10:00',1.78),('16100','2014-04-05','18:15:00',1.69),('16100','2014-04-05','18:20:00',1.59),('16100','2014-04-05','18:25:00',1.35),('16100','2014-04-05','18:30:00',1.1),('16100','2013-07-09','07:35:00',1.1),('16100','2013-07-09','07:40:00',1.26),('16100','2013-07-09','07:45:00',1.44),('16100','2013-07-09','07:50:00',1.55),('16100','2013-07-09','07:55:00',1.72),('16100','2013-07-09','08:00:00',1.32),('16100','2013-07-09','08:05:00',1.36),('16100','2013-07-09','08:10:00',1.47),('16100','2013-07-09','08:15:00',1.67),('16100','2013-07-09','08:20:00',1.73),('16100','2013-07-09','08:25:00',1.59),('16100','2013-07-09','08:30:00',1.49),('16100','2013-07-09','08:35:00',1.5),('16100','2013-07-09','08:40:00',1.56),('16100','2013-07-09','08:45:00',1.99),('16100','2013-07-09','08:50:00',3.27),('16100','2013-07-09','08:55:00',3.28),('16100','2013-07-09','09:00:00',3.37),('16100','2013-07-09','09:05:00',3.57),('16100','2013-07-09','09:10:00',3.76),('16100','2013-07-09','09:15:00',4),('16100','2013-07-09','09:20:00',4.18),('16100','2013-07-09','09:25:00',4.31),('16100','2013-07-09','09:30:00',4.43),('16100','2013-07-09','09:35:00',4.52),('16100','2013-07-09','09:40:00',4.64),('16100','2013-07-09','09:45:00',4.72),('16100','2013-07-09','09:50:00',4.85),('16100','2013-07-09','09:55:00',4.99),('16100','2013-07-09','10:00:00',5.12),('16100','2013-07-09','10:05:00',5.23),('16100','2013-07-09','10:10:00',5.35),('16100','2013-07-09','10:15:00',5.47),('16100','2013-07-09','10:20:00',5.61),('16100','2013-07-09','10:25:00',5.68),('16100','2013-07-09','10:30:00',5.79),('16100','2013-07-09','10:35:00',5.87),('16100','2013-07-09','10:40:00',5.92),('16100','2013-07-09','10:45:00',6),('16100','2013-07-09','10:50:00',6.07),('16100','2013-07-09','10:55:00',6.17),('16100','2013-07-09','11:00:00',6.26),('16100','2013-07-09','11:05:00',6.43),('16100','2013-07-09','11:10:00',6.47),('16100','2013-07-09','11:15:00',6.54),('16100','2013-07-09','11:20:00',6.58),('16100','2013-07-09','11:25:00',6.65),('16100','2013-07-09','11:30:00',6.73),('16100','2013-07-09','11:35:00',6.84),('16100','2013-07-09','11:40:00',6.95),('16100','2013-07-09','11:45:00',6.99),('16100','2013-07-09','11:50:00',6.97),('16100','2013-07-09','11:55:00',7.07),('16100','2013-07-09','12:00:00',6.95),('16100','2013-07-09','12:05:00',6.71),('16100','2013-07-09','12:10:00',7.04),('16100','2013-07-09','12:15:00',6.88),('16100','2013-07-09','12:20:00',7.29),('16100','2013-07-09','12:25:00',7.42),('16100','2013-07-09','12:30:00',7.38),('16100','2013-07-09','12:35:00',7.48),('16100','2013-07-09','12:40:00',7.43),('16100','2013-07-09','12:45:00',7.51),('16100','2013-07-09','12:50:00',7.6),('16100','2013-07-09','12:55:00',7.55),('16100','2013-07-09','13:00:00',7.59),('16100','2013-07-09','13:05:00',7.51),('16100','2013-07-09','13:10:00',7.61),('16100','2013-07-09','13:15:00',7.64),('16100','2013-07-09','13:20:00',7.6),('16100','2013-07-09','13:25:00',7.6),('16100','2013-07-09','13:30:00',7.64),('16100','2013-07-09','13:35:00',7.67),('16100','2013-07-09','13:40:00',7.68),('16100','2013-07-09','13:45:00',7.64),('16100','2013-07-09','13:50:00',7.68),('16100','2013-07-09','13:55:00',7.67),('16100','2013-07-09','14:00:00',7.71),('16100','2013-07-09','14:05:00',7.66),('16100','2013-07-09','14:10:00',7.56),('16100','2013-07-09','14:15:00',7.5),('16100','2013-07-09','14:20:00',7.48),('16100','2013-07-09','14:25:00',7.43),('16100','2013-07-09','14:30:00',7.42),('16100','2013-07-09','14:35:00',7.4),('16100','2013-07-09','14:40:00',7.32),('16100','2013-07-09','14:45:00',7.25),('16100','2013-07-09','14:50:00',7.21),('16100','2013-07-09','14:55:00',7.17),('16100','2013-07-09','15:00:00',7.17),('16100','2013-07-09','15:05:00',7.1),('16100','2013-07-09','15:10:00',7),('16100','2013-07-09','15:15:00',6.91),('16100','2013-07-09','15:20:00',6.84),('16100','2013-07-09','15:25:00',6.77),('16100','2013-07-09','15:30:00',6.65),('16100','2013-07-09','15:35:00',6.55),('16100','2013-07-09','15:40:00',6.47),('16100','2013-07-09','15:45:00',5.66),('16100','2013-07-09','15:50:00',6.26),('16100','2013-07-09','15:55:00',6.14),('16100','2013-07-09','16:00:00',6.1),('16100','2013-07-09','16:05:00',5.96),('16100','2013-07-09','16:10:00',5.87),('16100','2013-07-09','16:15:00',5.72),('16100','2013-07-09','16:20:00',5.6),('16100','2013-07-09','16:25:00',5.5),('16100','2013-07-09','16:30:00',5.35),('16100','2013-07-09','16:35:00',5.25),('16100','2013-07-09','16:40:00',5.12),('16100','2013-07-09','16:45:00',5.02),('16100','2013-07-09','16:50:00',5),('16100','2013-07-09','17:00:00',4.82),('16100','2013-07-09','17:05:00',2.24),('16100','2013-07-09','17:10:00',2.09),('16100','2013-07-09','17:15:00',1.67),('16100','2013-07-09','17:20:00',1.5),('16100','2013-07-09','17:25:00',1.46),('16100','2013-07-09','17:30:00',2.73),('16100','2013-07-09','17:35:00',3.64),('16100','2013-07-09','17:40:00',3.94),('16100','2013-07-09','17:45:00',3.49),('16100','2013-07-09','17:50:00',2.66),('16100','2013-07-09','17:55:00',1.99),('16100','2013-07-09','18:00:00',1.29),('16100','2013-07-09','18:05:00',1.19),('16100','2013-07-09','19:05:00',1.05),('16100','2013-07-08','07:45:00',1.05),('16100','2013-07-08','07:50:00',1.1),('16100','2013-07-08','07:55:00',1.22),('16100','2013-07-08','08:00:00',1.37),('16100','2013-07-08','08:05:00',1.28),('16100','2013-07-08','08:10:00',1.65),('16100','2013-07-08','08:15:00',1.82),('16100','2013-07-08','08:20:00',1.98),('16100','2013-07-08','08:25:00',2.13),('16100','2013-07-08','08:30:00',2.27),('16100','2013-07-08','08:35:00',2.46),('16100','2013-07-08','08:40:00',2.58),('16100','2013-07-08','08:45:00',2.7),('16100','2013-07-08','08:50:00',2.92),('16100','2013-07-08','08:55:00',3.08),('16100','2013-07-08','09:00:00',3.25),('16100','2013-07-08','09:05:00',3.35),('16100','2013-07-08','09:10:00',3.6),('16100','2013-07-08','09:15:00',3.91),('16100','2013-07-08','09:20:00',4.06),('16100','2013-07-08','09:25:00',4.2),('16100','2013-07-08','09:30:00',4.35),('16100','2013-07-08','09:35:00',4.4),('16100','2013-07-08','09:40:00',4.5),('16100','2013-07-08','09:45:00',4.67),('16100','2013-07-08','09:50:00',4.81),('16100','2013-07-08','09:55:00',4.89),('16100','2013-07-08','10:00:00',5.02),('16100','2013-07-08','10:05:00',5.2),('16100','2013-07-08','10:10:00',5.33),('16100','2013-07-08','10:15:00',5.46),('16100','2013-07-08','10:20:00',5.57),('16100','2013-07-08','10:25:00',5.64),('16100','2013-07-08','10:30:00',5.72),('16100','2013-07-08','10:35:00',5.84),('16100','2013-07-08','10:40:00',5.95),('16100','2013-07-08','10:45:00',6.04),('16100','2013-07-08','10:50:00',6.12),('16100','2013-07-08','10:55:00',6.2),('16100','2013-07-08','11:00:00',6.33),('16100','2013-07-08','11:05:00',6.34),('16100','2013-07-08','11:10:00',6.48),('16100','2013-07-08','11:15:00',6.53),('16100','2013-07-08','11:20:00',6.63),('16100','2013-07-08','11:25:00',6.73),('16100','2013-07-08','11:30:00',6.87),('16100','2013-07-08','11:35:00',6.74),('16100','2013-07-08','11:40:00',6.85),('16100','2013-07-08','11:45:00',7.2),('16100','2013-07-08','11:50:00',7),('16100','2013-07-08','11:55:00',7.34),('16100','2013-07-08','12:00:00',7.35),('16100','2013-07-08','12:05:00',7.31),('16100','2013-07-08','12:10:00',6.94),('16100','2013-07-08','12:15:00',6.53),('16100','2013-07-08','12:20:00',5.33),('16100','2013-07-08','12:25:00',7.22),('16100','2013-07-08','12:30:00',7.15),('16100','2013-07-08','12:35:00',7.21),('16100','2013-07-08','12:40:00',7.34),('16100','2013-07-08','12:45:00',7.52),('16100','2013-07-08','12:50:00',7.67),('16100','2013-07-08','12:55:00',7.62),('16100','2013-07-08','13:00:00',7.61),('16100','2013-07-08','13:05:00',7.72),('16100','2013-07-08','13:10:00',7.93),('16100','2013-07-08','13:15:00',7.65),('16100','2013-07-08','13:20:00',7.73),('16100','2013-07-08','13:25:00',7.76),('16100','2013-07-08','13:30:00',7.92),('16100','2013-07-08','13:35:00',7.66),('16100','2013-07-08','13:40:00',7.59),('16100','2013-07-08','13:45:00',6.27),('16100','2013-07-08','13:50:00',7.48),('16100','2013-07-08','13:55:00',7.54),('16100','2013-07-08','14:00:00',5.82),('16100','2013-07-08','14:05:00',6.26),('16100','2013-07-08','14:10:00',7.2),('16100','2013-07-08','14:15:00',7.54),('16100','2013-07-08','14:20:00',7.94),('16100','2013-07-08','14:25:00',4.9),('16100','2013-07-08','14:30:00',1.84),('16100','2013-07-08','14:35:00',1.45),('16100','2013-07-08','14:40:00',1.28),('16100','2013-07-07','07:40:00',1.05),('16100','2013-07-07','07:45:00',1.13),('16100','2013-07-07','07:50:00',1.08),('16100','2013-07-07','07:55:00',1.18),('16100','2013-07-07','08:00:00',1.38),('16100','2013-07-07','08:05:00',1.46),('16100','2013-07-07','08:10:00',1.68),('16100','2013-07-07','08:15:00',1.88),('16100','2013-07-07','08:20:00',2.04),('16100','2013-07-07','08:25:00',2.11),('16100','2013-07-07','08:30:00',2.26),('16100','2013-07-07','08:35:00',2.44),('16100','2013-07-07','08:40:00',2.58),('16100','2013-07-07','08:45:00',2.72),('16100','2013-07-07','08:50:00',2.88),('16100','2013-07-07','08:55:00',2.95),('16100','2013-07-07','09:00:00',3.16),('16100','2013-07-07','09:05:00',3.34),('16100','2013-07-07','09:10:00',3.54),('16100','2013-07-07','09:15:00',3.85),('16100','2013-07-07','09:20:00',4.01),('16100','2013-07-07','09:25:00',4.15),('16100','2013-07-07','09:30:00',4.28),('16100','2013-07-07','09:35:00',4.4),('16100','2013-07-07','09:40:00',4.53),('16100','2013-07-07','09:45:00',4.65),('16100','2013-07-07','10:20:00',5.52),('16100','2013-07-07','10:25:00',5.3),('16100','2013-07-07','10:30:00',5.46),('16100','2013-07-07','10:35:00',5.01),('16100','2013-07-07','10:40:00',5.83),('16100','2013-07-07','10:45:00',6),('16100','2013-07-07','10:50:00',6.03),('16100','2013-07-07','10:55:00',6.08),('16100','2013-07-07','11:00:00',6.22),('16100','2013-07-07','11:05:00',6.41),('16100','2013-07-07','11:10:00',6.52),('16100','2013-07-07','11:15:00',6.64),('16100','2013-07-07','11:20:00',6.41),('16100','2013-07-07','11:25:00',6.47),('16100','2013-07-07','11:30:00',6.64),('16100','2013-07-07','11:35:00',6.42),('16100','2013-07-07','11:40:00',6.37),('16100','2013-07-07','11:45:00',7.11),('16100','2013-07-07','11:50:00',7.11),('16100','2013-07-07','11:55:00',6.8),('16100','2013-07-07','12:00:00',7.15),('16100','2013-07-07','12:05:00',7.19),('16100','2013-07-07','12:10:00',6.25),('16100','2013-07-07','12:15:00',7.17),('16100','2013-07-07','12:20:00',6.74),('16100','2013-07-07','12:25:00',7.56),('16100','2013-07-07','12:30:00',7.52),('16100','2013-07-07','12:35:00',7.49),('16100','2013-07-07','12:40:00',7.47),('16100','2013-07-07','12:45:00',7.27),('16100','2013-07-07','12:50:00',7.5),('16100','2013-07-07','12:55:00',7.56),('16100','2013-07-07','13:00:00',4.81),('16100','2013-07-07','13:05:00',8.1),('16100','2013-07-07','13:10:00',3.01),('16100','2013-07-07','13:15:00',4.26),('16100','2013-07-07','13:20:00',4.09),('16100','2013-07-07','13:25:00',1.24),('16100','2013-07-07','14:01:00',1.1),('16100','2013-07-07','14:05:00',1.52),('16100','2013-07-07','14:10:00',1.75),('16100','2013-07-07','14:15:00',1.8),('16100','2013-07-07','14:20:00',1.76),('16100','2013-07-07','14:25:00',1.79),('16100','2013-07-07','14:30:00',1.89),('16100','2013-07-07','14:35:00',2.5),('16100','2013-07-07','14:40:00',3.59),('16100','2013-07-07','14:45:00',3.03),('16100','2013-07-07','14:50:00',2.67),('16100','2013-07-07','14:55:00',2.2),('16100','2013-07-07','15:00:00',2),('16100','2013-07-07','15:05:00',2.01),('16100','2013-07-07','15:10:00',1.9),('16100','2013-07-07','15:15:00',1.65),('16100','2013-07-07','15:20:00',1.25),('16100','2013-07-07','17:35:00',1.14),('16100','2013-07-07','17:40:00',1.31),('16100','2013-07-07','17:45:00',1.42),('16100','2013-07-07','17:50:00',1.49),('16100','2013-07-07','17:55:00',1.45),('16100','2013-07-07','18:00:00',1.33),('16100','2013-07-07','18:05:00',1.24),('16100','2013-07-07','18:10:00',1.18),('16100','2013-07-07','18:15:00',1.18),('16100','2013-07-07','18:20:00',1.26),('16100','2013-07-07','18:25:00',1.56),('16100','2013-07-07','18:30:00',1.83),('16100','2013-07-07','18:35:00',1.93),('16100','2013-07-07','18:40:00',1.74),('16100','2013-07-07','18:45:00',1.39),('16100','2013-07-07','18:50:00',1.23),('16100','2013-07-07','18:55:00',1.04),('16100','2013-07-06','07:55:00',1.14),('16100','2013-07-06','08:00:00',1.36),('16100','2013-07-06','08:05:00',1.56),('16100','2013-07-06','08:10:00',1.74),('16100','2013-07-06','08:15:00',1.95),('16100','2013-07-06','08:20:00',2.12),('16100','2013-07-06','08:25:00',2.3),('16100','2013-07-06','08:30:00',2.25),('16100','2013-07-06','08:35:00',1.17),('16100','2013-07-06','08:40:00',2.01),('16100','2013-07-06','08:45:00',2.66),('16100','2013-07-06','08:50:00',3.22),('16100','2013-07-06','08:55:00',3.42),('16100','2013-07-06','09:00:00',3.6),('16100','2013-07-06','09:05:00',3.51),('16100','2013-07-06','09:10:00',2.36),('16100','2013-07-06','09:15:00',1.98),('16100','2013-07-06','09:20:00',2.19),('16100','2013-07-06','09:25:00',2.76),('16100','2013-07-06','09:30:00',4.06),('16100','2013-07-06','09:36:00',4.76),('16100','2013-07-06','09:40:00',4.25),('16100','2013-07-06','09:45:00',5.24),('16100','2013-07-06','09:50:00',5.4),('16100','2013-07-06','09:55:00',5.43),('16100','2013-07-06','10:00:00',5.39),('16100','2013-07-06','10:05:00',5.31),('16100','2013-07-06','10:10:00',5.06),('16100','2013-07-06','10:15:00',4.83),('16100','2013-07-06','10:20:00',6.09),('16100','2013-07-06','10:25:00',6.13),('16100','2013-07-06','10:30:00',5.75),('16100','2013-07-06','10:35:00',5.42),('16100','2013-07-06','10:40:00',6.08),('16100','2013-07-06','10:45:00',6.41),('16100','2013-07-06','10:50:00',6.41),('16100','2013-07-06','10:55:00',6.43),('16100','2013-07-06','11:00:00',6.48),('16100','2013-07-06','11:05:00',6.56),('16100','2013-07-06','11:10:00',6.72),('16100','2013-07-06','11:15:00',6.71),('16100','2013-07-06','11:20:00',6),('16100','2013-07-06','11:25:00',6.63),('16100','2013-07-06','11:30:00',6.33),('16100','2013-07-06','11:35:00',6.31),('16100','2013-07-06','11:40:00',6.39),('16100','2013-07-06','11:45:00',6.78),('16100','2013-07-06','11:50:00',6.93),('16100','2013-07-06','11:55:00',6.56),('16100','2013-07-06','12:00:00',4.29),('16100','2013-07-06','12:05:00',5.24),('16100','2013-07-06','12:10:00',5.55),('16100','2013-07-06','12:15:00',4.69),('16100','2013-07-06','12:20:00',6.05),('16100','2013-07-06','12:25:00',7.23),('16100','2013-07-06','12:30:00',7.3),('16100','2013-07-06','12:35:00',7.39),('16100','2013-07-06','12:40:00',7.25),('16100','2013-07-06','12:45:00',7.49),('16100','2013-07-06','12:50:00',7.72),('16100','2013-07-06','12:55:00',7.78),('16100','2013-07-06','13:00:00',7.44),('16100','2013-07-06','13:05:00',7.49),('16100','2013-07-06','13:10:00',7.53),('16100','2013-07-06','13:15:00',7.67),('16100','2013-07-06','13:20:00',7.64),('16100','2013-07-06','13:25:00',7.62),('16100','2013-07-06','13:30:00',7.75),('16100','2013-07-06','13:35:00',7.53),('16100','2013-07-06','13:40:00',5.52),('16100','2013-07-06','13:45:00',7.53),('16100','2013-07-06','13:50:00',7.61),('16100','2013-07-06','13:55:00',3.56),('16100','2013-07-06','14:00:00',1.29),('16100','2013-07-06','14:05:00',1.26),('16100','2013-07-06','14:10:00',1.66),('16100','2013-07-06','14:15:00',2.16),('16100','2013-07-06','14:20:00',3.58),('16100','2013-07-06','14:25:00',4.18),('16100','2013-07-06','14:30:00',3.19),('16100','2013-07-06','14:35:00',2.51),('16100','2013-07-06','14:40:00',1.96),('16100','2013-07-06','14:45:00',1.71),('16100','2013-07-06','14:50:00',1.6),('16100','2013-07-06','14:55:00',1.65),('16100','2013-07-06','15:00:00',1.91),('16100','2013-07-06','15:05:00',2.32),('16100','2013-07-06','15:10:00',1.92),('16100','2013-07-06','15:15:00',1.08),('16100','2013-07-06','16:55:00',1.15),('16100','2013-07-06','17:00:00',1.32),('16100','2013-07-06','17:05:00',1.54),('16100','2013-07-06','17:10:00',1.67),('16100','2013-07-06','17:15:00',1.8),('16100','2013-07-06','17:20:00',1.86),('16100','2013-07-06','17:25:00',1.94),('16100','2013-07-06','17:30:00',2.05),('16100','2013-07-06','17:35:00',2.03),('16100','2013-07-06','17:40:00',2.03),('16100','2013-07-06','17:45:00',1.83),('16100','2013-07-06','17:50:00',1.74),('16100','2013-07-06','17:55:00',1.69),('16100','2013-07-06','18:00:00',1.56),('16100','2013-07-06','18:05:00',1.46),('16100','2013-07-06','18:10:00',1.36),('16100','2013-07-06','18:15:00',1.36),('16100','2013-07-06','18:20:00',1.35),('16100','2013-07-06','18:25:00',1.24),('16100','2013-07-06','18:30:00',1.14),('16100','2013-07-05','07:55:00',1.14),('16100','2013-07-05','08:00:00',1.32),('16100','2013-07-05','08:05:00',1.51),('16100','2013-07-05','08:10:00',1.66),('16100','2013-07-05','08:15:00',1.86),('16100','2013-07-05','08:20:00',2.01),('16100','2013-07-05','08:25:00',2.17),('16100','2013-07-05','08:30:00',2.31),('16100','2013-07-05','08:35:00',2.47),('16100','2013-07-05','08:40:00',2.63),('16100','2013-07-05','08:45:00',2.77),('16100','2013-07-05','08:50:00',2.98),('16100','2013-07-05','08:55:00',3.11),('16100','2013-07-05','09:00:00',3.26),('16100','2013-07-05','09:05:00',3.39),('16100','2013-07-05','09:10:00',3.6),('16100','2013-07-05','09:15:00',3.9),('16100','2013-07-05','09:20:00',4.1),('16100','2013-07-05','09:25:00',4.28),('16100','2013-07-05','09:30:00',4.39),('16100','2013-07-05','09:35:00',4.52),('16100','2013-07-05','09:40:00',4.68),('16100','2013-07-05','09:45:00',4.8),('16100','2013-07-05','09:50:00',4.9),('16100','2013-07-05','09:55:00',4.99),('16100','2013-07-05','10:00:00',5.12),('16100','2013-07-05','10:05:00',5.29),('16100','2013-07-05','10:10:00',5.41),('16100','2013-07-05','10:15:00',5.54),('16100','2013-07-05','10:20:00',5.67),('16100','2013-07-05','10:25:00',5.74),('16100','2013-07-05','10:30:00',5.87),('16100','2013-07-05','10:35:00',5.96),('16100','2013-07-05','10:40:00',6.02),('16100','2013-07-05','10:45:00',6.11),('16100','2013-07-05','10:50:00',6.17),('16100','2013-07-05','10:55:00',6.23),('16100','2013-07-05','11:00:00',6.36),('16100','2013-07-05','11:05:00',6.48),('16100','2013-07-05','11:10:00',6.5),('16100','2013-07-05','11:15:00',6.56),('16100','2013-07-05','11:20:00',6.62),('16100','2013-07-05','11:25:00',6.77),('16100','2013-07-05','11:30:00',6.8),('16100','2013-07-05','11:35:00',6.89),('16100','2013-07-05','11:40:00',6.96),('16100','2013-07-05','11:45:00',6.97),('16100','2013-07-05','11:50:00',7.02),('16100','2013-07-05','11:55:00',7.08),('16100','2013-07-05','12:00:00',7.07),('16100','2013-07-05','12:05:00',7.18),('16100','2013-07-05','12:10:00',7.27),('16100','2013-07-05','12:15:00',7.33),('16100','2013-07-05','12:20:00',7.3),('16100','2013-07-05','12:25:00',7.42),('16100','2013-07-05','12:30:00',7.49),('16100','2013-07-05','12:35:00',7.54),('16100','2013-07-05','12:40:00',7.5),('16100','2013-07-05','12:45:00',7.44),('16100','2013-07-05','12:50:00',7.44),('16100','2013-07-05','12:55:00',7.43),('16100','2013-07-05','13:00:00',7.47),('16100','2013-07-05','13:05:00',7.48),('16100','2013-07-05','13:10:00',7.44),('16100','2013-07-05','13:15:00',7.42),('16100','2013-07-05','13:20:00',7.51),('16100','2013-07-05','13:25:00',7.55),('16100','2013-07-05','13:30:00',7.66),('16100','2013-07-05','13:35:00',7.72),('16100','2013-07-05','13:40:00',7.62),('16100','2013-07-05','13:45:00',7.49),('16100','2013-07-05','13:50:00',7.53),('16100','2013-07-05','13:55:00',7.44),('16100','2013-07-05','14:00:00',7.52),('16100','2013-07-05','14:05:00',7.5),('16100','2013-07-05','14:10:00',7.34),('16100','2013-07-05','14:15:00',7.27),('16100','2013-07-05','14:20:00',7.32),('16100','2013-07-05','14:25:00',7.19),('16100','2013-07-05','14:30:00',7.1),('16100','2013-07-05','14:35:00',7.1),('16100','2013-07-05','14:40:00',6.05),('16100','2013-07-05','14:45:00',7.1),('16100','2013-07-05','14:50:00',4.14),('16100','2013-07-05','14:55:00',7.61),('16100','2013-07-05','15:00:00',7.43),('16100','2013-07-05','15:05:00',6.73),('16100','2013-07-05','15:10:00',6.75),('16100','2013-07-05','15:15:00',6.81),('16100','2013-07-05','15:20:00',6.95),('16100','2013-07-05','15:25:00',3.58),('16100','2013-07-05','15:30:00',1.39),('16100','2013-07-05','16:10:00',1.11),('16100','2013-07-05','16:15:00',1.61),('16100','2013-07-05','16:20:00',1.45),('16100','2013-07-05','16:25:00',1.18),('16100','2013-07-05','16:30:00',1.26),('16100','2013-07-05','16:35:00',1.8),('16100','2013-07-05','16:40:00',1.44),('16100','2013-07-05','16:45:00',1.77),('16100','2013-07-05','16:50:00',3.58),('16100','2013-07-05','16:55:00',5.11),('16100','2013-07-05','17:00:00',3.48),('16100','2013-07-05','17:05:00',4.01),('16100','2013-07-05','17:10:00',2.25),('16100','2013-07-05','17:15:00',2.02),('16100','2013-07-05','17:20:00',1.9),('16100','2013-07-05','17:25:00',1.7),('16100','2013-07-05','17:30:00',1.59),('16100','2013-07-05','17:35:00',1.47),('16100','2013-07-05','17:40:00',1.38),('16100','2013-07-05','17:45:00',1.37),('16100','2013-07-05','17:50:00',1.21),('16100','2013-07-05','17:55:00',1.05),('16100','2013-07-04','07:55:00',1.17),('16100','2013-07-04','08:00:00',1.33),('16100','2013-07-04','08:05:00',1.52),('16100','2013-07-04','08:10:00',1.71),('16100','2013-07-04','08:15:00',1.91),('16100','2013-07-04','08:20:00',2.08),('16100','2013-07-04','08:25:00',2.2),('16100','2013-07-04','08:30:00',2.36),('16100','2013-07-04','08:35:00',2.52),('16100','2013-07-04','08:40:00',2.65),('16100','2013-07-04','08:45:00',2.82),('16100','2013-07-04','08:50:00',3.02),('16100','2013-07-04','08:55:00',3.17),('16100','2013-07-04','09:00:00',3.33),('16100','2013-07-04','09:05:00',3.44),('16100','2013-07-04','09:10:00',3.61),('16100','2013-07-04','09:15:00',3.87),('16100','2013-07-04','09:20:00',4.1),('16100','2013-07-04','09:25:00',4.26),('16100','2013-07-04','09:30:00',4.35),('16100','2013-07-04','09:35:00',4.48),('16100','2013-07-04','09:40:00',4.61),('16100','2013-07-04','09:45:00',4.72),('16100','2013-07-04','09:50:00',4.83),('16100','2013-07-04','09:55:00',4.91),('16100','2013-07-04','10:00:00',5.05),('16100','2013-07-04','10:05:00',5.19),('16100','2013-07-04','10:10:00',5.29),('16100','2013-07-04','10:15:00',5.4),('16100','2013-07-04','10:20:00',5.48),('16100','2013-07-04','10:25:00',5.64),('16100','2013-07-04','10:30:00',5.78),('16100','2013-07-04','10:35:00',5.87),('16100','2013-07-04','10:40:00',5.97),('16100','2013-07-04','10:45:00',6.09),('16100','2013-07-04','10:50:00',6.16),('16100','2013-07-04','10:55:00',6.25),('16100','2013-07-04','11:00:00',6.38),('16100','2013-07-04','11:05:00',6.46),('16100','2013-07-04','11:10:00',6.55),('16100','2013-07-04','11:15:00',6.61),('16100','2013-07-04','11:20:00',6.68),('16100','2013-07-04','11:25:00',6.74),('16100','2013-07-04','11:30:00',6.79),('16100','2013-07-04','11:35:00',6.85),('16100','2013-07-04','11:40:00',6.92),('16100','2013-07-04','11:45:00',6.95),('16100','2013-07-04','11:50:00',7.01),('16100','2013-07-04','11:55:00',6.84),('16100','2013-07-04','12:00:00',5.29),('16100','2013-07-04','12:05:00',6.32),('16100','2013-07-04','12:10:00',4.32),('16100','2013-07-04','12:15:00',7.49),('16100','2013-07-04','12:20:00',7.51),('16100','2013-07-04','12:25:00',5.84),('16100','2013-07-04','12:30:00',2.55),('16100','2013-07-04','12:35:00',3.23),('16100','2013-07-04','12:40:00',3.26),('16100','2013-07-04','12:45:00',6.47),('16100','2013-07-04','12:50:00',3.8),('16100','2013-07-04','12:55:00',1.31),('16100','2013-07-04','13:00:00',4.2),('16100','2013-07-04','13:05:00',5.07),('16100','2013-07-04','13:10:00',7.12),('16100','2013-07-04','13:15:00',8),('16100','2013-07-04','13:20:00',7.88),('16100','2013-07-04','13:25:00',7.93),('16100','2013-07-04','13:30:00',8),('16100','2013-07-04','13:35:00',7.91),('16100','2013-07-04','13:40:00',7.8),('16100','2013-07-04','13:45:00',7.75),('16100','2013-07-04','13:50:00',7.69),('16100','2013-07-04','13:55:00',7.66),('16100','2013-07-04','14:00:00',7.74),('16100','2013-07-04','14:05:00',7.69),('16100','2013-07-04','14:10:00',7.78),('16100','2013-07-04','14:15:00',7.54),('16100','2013-07-04','14:20:00',7.03),('16100','2013-07-04','14:25:00',7.49),('16100','2013-07-04','14:30:00',7.22),('16100','2013-07-04','14:35:00',7.34),('16100','2013-07-04','14:40:00',7.27),('16100','2013-07-04','14:45:00',7.19),('16100','2013-07-04','14:50:00',7.15),('16100','2013-07-04','14:55:00',7.06),('16100','2013-07-04','15:00:00',6.78),('16100','2013-07-04','15:05:00',4.9),('16100','2013-07-04','15:10:00',2.96),('16100','2013-07-04','15:15:00',6.37),('16100','2013-07-04','15:20:00',6.9),('16100','2013-07-04','15:25:00',6.83),('16100','2013-07-04','15:30:00',4.71),('16100','2013-07-04','15:35:00',6.63),('16100','2013-07-04','15:40:00',6.5),('16100','2013-07-04','15:45:00',6.38),('16100','2013-07-04','15:50:00',6.24),('16100','2013-07-04','15:55:00',6.11),('16100','2013-07-04','16:00:00',6.03),('16100','2013-07-04','16:05:00',5.87),('16100','2013-07-04','16:10:00',5.86),('16100','2013-07-04','16:15:00',5.72),('16100','2013-07-04','16:20:00',5.63),('16100','2013-07-04','16:25:00',5.45),('16100','2013-07-04','16:30:00',5.26),('16100','2013-07-04','16:35:00',5.09),('16100','2013-07-04','16:40:00',5.04),('16100','2013-07-04','16:45:00',4.95),('16100','2013-07-04','16:50:00',4.81),('16100','2013-07-04','16:55:00',4.63),('16100','2013-07-04','17:00:00',4.54),('16100','2013-07-04','17:05:00',4.34),('16100','2013-07-04','17:10:00',4.42),('16100','2013-07-04','17:15:00',3.91),('16100','2013-07-04','17:20:00',1.61),('16100','2013-07-04','17:25:00',3.89),('16100','2013-07-04','17:30:00',3.72),('16100','2013-07-04','17:35:00',3.6),('16100','2013-07-04','17:40:00',3.38),('16100','2013-07-04','17:45:00',3.24),('16100','2013-07-04','17:50:00',3.1),('16100','2013-07-04','17:55:00',3),('16100','2013-07-04','18:00:00',2.99),('16100','2013-07-04','18:05:00',3.04),('16100','2013-07-04','18:10:00',2.99),('16100','2013-07-04','18:15:00',2.76),('16100','2013-07-04','18:20:00',2.38),('16100','2013-07-04','18:25:00',2.1),('16100','2013-07-04','18:30:00',1.92),('16100','2013-07-04','18:35:00',1.71),('16100','2013-07-04','18:40:00',1.52),('16100','2013-07-04','18:45:00',1.35),('16100','2013-07-04','18:50:00',1.22),('16100','2013-07-04','18:55:00',1.07),('16100','2013-07-03','08:50:00',1.12),('16100','2013-07-03','08:55:00',1.09),('16100','2013-07-03','09:10:00',1.09),('16100','2013-07-03','09:15:00',1.1),('16100','2013-07-03','09:20:00',1.1),('16100','2013-07-03','09:25:00',1.03),('16100','2013-07-03','10:30:00',1.07),('16100','2013-07-03','10:35:00',1.03),('16100','2013-07-03','10:50:00',1.03),('16100','2013-07-03','10:55:00',1.24),('16100','2013-07-03','11:00:00',1.36),('16100','2013-07-03','11:05:00',1.66),('16100','2013-07-03','11:10:00',1.68),('16100','2013-07-03','11:15:00',1.59),('16100','2013-07-03','11:20:00',1.66),('16100','2013-07-03','11:25:00',1.71),('16100','2013-07-03','11:30:00',1.9),('16100','2013-07-03','11:35:00',2.11),('16100','2013-07-03','11:40:00',2.45),('16100','2013-07-03','11:45:00',2.78),('16100','2013-07-03','11:50:00',2.67),('16100','2013-07-03','11:55:00',2.44),('16100','2013-07-03','12:00:00',2.31),('16100','2013-07-03','12:05:00',2.19),('16100','2013-07-03','12:10:00',1.87),('16100','2013-07-03','12:15:00',1.75),('16100','2013-07-03','12:20:00',1.53),('16100','2013-07-03','12:25:00',1.52),('16100','2013-07-03','12:30:00',1.12),('16100','2013-07-03','13:00:00',1.31),('16100','2013-07-03','13:05:00',1.38),('16100','2013-07-03','13:10:00',1.26),('16100','2013-07-03','13:15:00',1.46),('16100','2013-07-03','13:20:00',1.44),('16100','2013-07-03','13:25:00',1.83),('16100','2013-07-03','13:30:00',2.63),('16100','2013-07-03','13:35:00',2.98),('16100','2013-07-03','13:45:00',3.23),('16100','2013-07-03','13:50:00',3.33),('16100','2013-07-03','13:55:00',3.44),('16100','2013-07-03','14:00:00',4.24),('16100','2013-07-03','14:05:00',4.7),('16100','2013-07-03','14:10:00',3.45),('16100','2013-07-03','14:15:00',3.57),('16100','2013-07-03','14:20:00',3.58),('16100','2013-07-03','14:25:00',3.09),('16100','2013-07-03','14:30:00',3),('16100','2013-07-03','14:35:00',3.19),('16100','2013-07-03','14:40:00',3.83),('16100','2013-07-03','14:45:00',2.89),('16100','2013-07-03','14:50:00',3.09),('16100','2013-07-03','14:55:00',3.74),('16100','2013-07-03','15:00:00',6.16),('16100','2013-07-03','15:05:00',6.59),('16100','2013-07-03','15:10:00',4.46),('16100','2013-07-03','15:15:00',6.96),('16100','2013-07-03','15:20:00',5.85),('16100','2013-07-03','15:25:00',3.7),('16100','2013-07-03','15:30:00',4.51),('16100','2013-07-03','15:35:00',4.85),('16100','2013-07-03','15:40:00',4.78),('16100','2013-07-03','15:45:00',3.93),('16100','2013-07-03','15:50:00',6.47),('16100','2013-07-03','15:55:00',6.01),('16100','2013-07-03','16:00:00',4.98),('16100','2013-07-03','16:05:00',3.25),('16100','2013-07-03','16:10:00',3.78),('16100','2013-07-03','16:15:00',3.83),('16100','2013-07-03','16:20:00',4.1),('16100','2013-07-03','16:25:00',3.68),('16100','2013-07-03','16:30:00',3.32),('16100','2013-07-03','16:35:00',2.69),('16100','2013-07-03','16:40:00',2.32),('16100','2013-07-03','16:45:00',2.36),('16100','2013-07-03','16:50:00',2.2),('16100','2013-07-03','16:55:00',2.52),('16100','2013-07-03','17:00:00',3.12),('16100','2013-07-03','17:05:00',3.34),('16100','2013-07-03','17:10:00',2.84),('16100','2013-07-03','17:15:00',4.19),('16100','2013-07-03','17:20:00',4.84),('16100','2013-07-03','17:25:00',4.15),('16100','2013-07-03','17:30:00',3.45),('16100','2013-07-03','17:35:00',4.22),('16100','2013-07-03','17:40:00',3.69),('16100','2013-07-03','17:45:00',3.5),('16100','2013-07-03','17:50:00',3.41),('16100','2013-07-03','17:55:00',3.34),('16100','2013-07-03','18:00:00',2.97),('16100','2013-07-03','18:05:00',2.8),('16100','2013-07-03','18:10:00',2.69),('16100','2013-07-03','18:15:00',2.07),('16100','2013-07-03','18:20:00',1.93),('16100','2013-07-03','18:25:00',1.45),('16100','2013-07-03','18:30:00',1.08),('16100','2013-07-03','18:35:00',1.13),('16100','2013-07-03','18:40:00',1.2),('16100','2013-07-03','18:45:00',1.22),('16100','2013-07-02','07:55:00',1.2),('16100','2013-07-02','08:00:00',1.41),('16100','2013-07-02','08:05:00',1.61),('16100','2013-07-02','08:10:00',1.78),('16100','2013-07-02','08:15:00',2),('16100','2013-07-02','08:20:00',2.17),('16100','2013-07-02','08:25:00',2.31),('16100','2013-07-02','08:30:00',2.49),('16100','2013-07-02','08:35:00',2.62),('16100','2013-07-02','08:40:00',2.77),('16100','2013-07-02','08:45:00',2.96),('16100','2013-07-02','08:50:00',3.17),('16100','2013-07-02','08:55:00',3.35),('16100','2013-07-02','09:00:00',3.47),('16100','2013-07-02','09:05:00',3.55),('16100','2013-07-02','09:10:00',3.73),('16100','2013-07-02','09:15:00',4.06),('16100','2013-07-02','09:20:00',4.3),('16100','2013-07-02','09:25:00',4.46),('16100','2013-07-02','09:30:00',4.55),('16100','2013-07-02','09:35:00',4.69),('16100','2013-07-02','09:40:00',4.81),('16100','2013-07-02','09:45:00',4.95),('16100','2013-07-02','09:50:00',5.08),('16100','2013-07-02','09:55:00',5.17),('16100','2013-07-02','10:00:00',5.27),('16100','2013-07-02','10:05:00',5.39),('16100','2013-07-02','10:10:00',5.53),('16100','2013-07-02','10:15:00',5.64),('16100','2013-07-02','10:20:00',5.74),('16100','2013-07-02','10:25:00',5.79),('16100','2013-07-02','10:30:00',5.91),('16100','2013-07-02','10:35:00',6.08),('16100','2013-07-02','10:40:00',6.22),('16100','2013-07-02','10:45:00',6.34),('16100','2013-07-02','10:50:00',6.38),('16100','2013-07-02','10:55:00',6.42),('16100','2013-07-02','11:00:00',6.5),('16100','2013-07-02','11:05:00',6.63),('16100','2013-07-02','11:10:00',6.79),('16100','2013-07-02','11:15:00',6.87),('16100','2013-07-02','11:20:00',6.94),('16100','2013-07-02','11:25:00',7.02),('16100','2013-07-02','11:30:00',7.1),('16100','2013-07-02','11:35:00',7.19),('16100','2013-07-02','11:40:00',7.28),('16100','2013-07-02','11:45:00',7.34),('16100','2013-07-02','11:50:00',7.37),('16100','2013-07-02','11:55:00',7.46),('16100','2013-07-02','12:00:00',7.52),('16100','2013-07-02','12:05:00',7.58),('16100','2013-07-02','12:10:00',7.6),('16100','2013-07-02','12:15:00',7.62),('16100','2013-07-02','12:20:00',7.65),('16100','2013-07-02','12:25:00',7.67),('16100','2013-07-02','12:30:00',7.67),('16100','2013-07-02','12:35:00',7.68),('16100','2013-07-02','12:40:00',7.71),('16100','2013-07-02','12:45:00',7.74),('16100','2013-07-02','12:50:00',7.74),('16100','2013-07-02','12:55:00',7.8),('16100','2013-07-02','13:00:00',7.83),('16100','2013-07-02','13:05:00',7.86),('16100','2013-07-02','13:10:00',7.86),('16100','2013-07-02','13:15:00',7.81),('16100','2013-07-02','13:20:00',7.83),('16100','2013-07-02','13:25:00',7.82),('16100','2013-07-02','13:30:00',7.82),('16100','2013-07-02','13:35:00',7.86),('16100','2013-07-02','13:40:00',7.79),('16100','2013-07-02','13:45:00',7.83),('16100','2013-07-02','13:50:00',7.81),('16100','2013-07-02','13:55:00',7.77),('16100','2013-07-02','14:00:00',7.78),('16100','2013-07-02','14:05:00',7.75),('16100','2013-07-02','14:10:00',7.66),('16100','2013-07-02','14:15:00',7.6),('16100','2013-07-02','14:20:00',7.56),('16100','2013-07-02','14:25:00',7.56),('16100','2013-07-02','14:30:00',7.52),('16100','2013-07-02','14:35:00',7.49),('16100','2013-07-02','14:40:00',7.43),('16100','2013-07-02','14:45:00',7.39),('16100','2013-07-02','14:50:00',7.36),('16100','2013-07-02','14:55:00',7.32),('16100','2013-07-02','15:00:00',7.28),('16100','2013-07-02','15:05:00',7.24),('16100','2013-07-02','15:10:00',7.16),('16100','2013-07-02','15:15:00',7.1),('16100','2013-07-02','15:20:00',6.99),('16100','2013-07-02','15:25:00',6.91),('16100','2013-07-02','15:30:00',6.78),('16100','2013-07-02','15:35:00',6.69),('16100','2013-07-02','15:40:00',6.61),('16100','2013-07-02','15:45:00',6.53),('16100','2013-07-02','15:50:00',6.46),('16100','2013-07-02','15:55:00',6.33),('16100','2013-07-02','16:00:00',6.23),('16100','2013-07-02','16:05:00',6.15),('16100','2013-07-02','16:10:00',6.04),('16100','2013-07-02','16:15:00',5.89),('16100','2013-07-02','16:20:00',5.82),('16100','2013-07-02','16:25:00',5.65),('16100','2013-07-02','16:30:00',5.54),('16100','2013-07-02','16:35:00',5.44),('16100','2013-07-02','16:40:00',5.35),('16100','2013-07-02','16:45:00',5.22),('16100','2013-07-02','16:50:00',5.11),('16100','2013-07-02','16:55:00',4.99),('16100','2013-07-02','17:00:00',4.84),('16100','2013-07-02','17:05:00',4.7),('16100','2013-07-02','17:10:00',4.57),('16100','2013-07-02','17:15:00',4.39),('16100','2013-07-02','17:20:00',4.26),('16100','2013-07-02','17:25:00',4.11),('16100','2013-07-02','17:30:00',3.97),('16100','2013-07-02','17:35:00',3.82),('16100','2013-07-02','17:40:00',3.63),('16100','2013-07-02','17:45:00',3.48),('16100','2013-07-02','17:50:00',3.33),('16100','2013-07-02','17:55:00',3.21),('16100','2013-07-02','18:00:00',3.04),('16100','2013-07-02','18:05:00',2.85),('16100','2013-07-02','18:10:00',2.68),('16100','2013-07-02','18:15:00',2.46),('16100','2013-07-02','18:20:00',2.28),('16100','2013-07-02','18:25:00',2.12),('16100','2013-07-02','18:30:00',1.95),('16100','2013-07-02','18:35:00',1.8),('16100','2013-07-02','18:40:00',1.63),('16100','2013-07-02','18:45:00',1.48),('16100','2013-07-02','18:50:00',1.32),('16100','2013-07-02','18:55:00',1.17),('16100','2013-07-02','19:00:00',1.02),('16100','2013-07-01','07:50:00',1.01),('16100','2013-07-01','07:55:00',1.2),('16100','2013-07-01','08:00:00',1.38),('16100','2013-07-01','08:05:00',1.58),('16100','2013-07-01','08:10:00',1.76),('16100','2013-07-01','08:15:00',1.95),('16100','2013-07-01','08:20:00',2.14),('16100','2013-07-01','08:25:00',2.27),('16100','2013-07-01','08:30:00',2.46),('16100','2013-07-01','08:35:00',2.62),('16100','2013-07-01','08:40:00',2.77),('16100','2013-07-01','08:45:00',2.93),('16100','2013-07-01','08:50:00',3.13),('16100','2013-07-01','08:55:00',3.27),('16100','2013-07-01','09:00:00',3.42),('16100','2013-07-01','09:05:00',3.55),('16100','2013-07-01','09:10:00',3.71),('16100','2013-07-01','09:15:00',3.96),('16100','2013-07-01','09:20:00',4.23),('16100','2013-07-01','09:25:00',4.4),('16100','2013-07-01','09:30:00',4.52),('16100','2013-07-01','09:35:00',4.63),('16100','2013-07-01','09:40:00',4.76),('16100','2013-07-01','09:45:00',4.89),('16100','2013-07-01','09:50:00',5),('16100','2013-07-01','09:55:00',5.08),('16100','2013-07-01','10:00:00',5.19),('16100','2013-07-01','10:05:00',5.33),('16100','2013-07-01','10:10:00',5.48),('16100','2013-07-01','10:15:00',5.61),('16100','2013-07-01','10:20:00',5.68),('16100','2013-07-01','10:25:00',5.77),('16100','2013-07-01','10:30:00',5.84),('16100','2013-07-01','10:35:00',5.93),('16100','2013-07-01','10:40:00',6.06),('16100','2013-07-01','10:45:00',6.13),('16100','2013-07-01','10:50:00',6.18),('16100','2013-07-01','10:55:00',6.24),('16100','2013-07-01','11:00:00',6.36),('16100','2013-07-01','11:05:00',6.46),('16100','2013-07-01','11:10:00',6.52),('16100','2013-07-01','11:15:00',6.51),('16100','2013-07-01','11:20:00',6.59),('16100','2013-07-01','11:25:00',6.67),('16100','2013-07-01','11:30:00',6.67),('16100','2013-07-01','11:35:00',6.71),('16100','2013-07-01','11:40:00',6.82),('16100','2013-07-01','11:45:00',6.92),('16100','2013-07-01','11:50:00',7.04),('16100','2013-07-01','11:55:00',6.98),('16100','2013-07-01','12:00:00',7.06),('16100','2013-07-01','12:05:00',7.24),('16100','2013-07-01','12:10:00',7.27),('16100','2013-07-01','12:15:00',7.29),('16100','2013-07-01','12:20:00',7.6),('16100','2013-07-01','12:25:00',7.58),('16100','2013-07-01','12:30:00',7.39),('16100','2013-07-01','12:35:00',7.27),('16100','2013-07-01','12:40:00',5.56),('16100','2013-07-01','12:45:00',5.35),('16100','2013-07-01','12:50:00',6.85),('16100','2013-07-01','12:55:00',7.66),('16100','2013-07-01','13:00:00',7.77),('16100','2013-07-01','13:05:00',7.68),('16100','2013-07-01','13:10:00',7.69),('16100','2013-07-01','13:15:00',7.52),('16100','2013-07-01','13:20:00',7.38),('16100','2013-07-01','13:25:00',7.48),('16100','2013-07-01','13:30:00',7.58),('16100','2013-07-01','13:35:00',7.58),('16100','2013-07-01','13:40:00',7.54),('16100','2013-07-01','13:45:00',7.53),('16100','2013-07-01','13:50:00',7.48),('16100','2013-07-01','13:55:00',7.47),('16100','2013-07-01','14:00:00',7.42),('16100','2013-07-01','14:05:00',7.47),('16100','2013-07-01','14:10:00',7.49),('16100','2013-07-01','14:15:00',7.47),('16100','2013-07-01','14:20:00',7.38),('16100','2013-07-01','14:25:00',7.27),('16100','2013-07-01','14:30:00',7.21),('16100','2013-07-01','14:35:00',7.33),('16100','2013-07-01','14:40:00',7.23),('16100','2013-07-01','14:45:00',7.18),('16100','2013-07-01','14:50:00',7.16),('16100','2013-07-01','14:55:00',7.08),('16100','2013-07-01','15:00:00',7.01),('16100','2013-07-01','15:05:00',6.92),('16100','2013-07-01','15:10:00',6.86),('16100','2013-07-01','15:15:00',6.78),('16100','2013-07-01','15:20:00',6.72),('16100','2013-07-01','15:25:00',6.7),('16100','2013-07-01','15:30:00',6.59),('16100','2013-07-01','15:35:00',6.49),('16100','2013-07-01','15:40:00',6.45),('16100','2013-07-01','15:45:00',6.38),('16100','2013-07-01','15:50:00',6.27),('16100','2013-07-01','15:55:00',6.15),('16100','2013-07-01','16:00:00',6.07),('16100','2013-07-01','16:05:00',6),('16100','2013-07-01','16:10:00',5.89),('16100','2013-07-01','16:15:00',5.78),('16100','2013-07-01','16:20:00',5.67),('16100','2013-07-01','16:25:00',5.5),('16100','2013-07-01','16:30:00',5.38),('16100','2013-07-01','16:35:00',5.27),('16100','2013-07-01','16:40:00',5.13),('16100','2013-07-01','16:45:00',5.04),('16100','2013-07-01','16:50:00',4.93),('16100','2013-07-01','16:55:00',4.79),('16100','2013-07-01','17:00:00',4.67),('16100','2013-07-01','17:05:00',4.52),('16100','2013-07-01','17:10:00',4.35),('16100','2013-07-01','17:15:00',4.16),('16100','2013-07-01','17:20:00',4.1),('16100','2013-07-01','17:26:00',3.97),('16100','2013-07-01','17:30:00',3.78),('16100','2013-07-01','17:35:00',3.65),('16100','2013-07-01','17:40:00',3.49),('16100','2013-07-01','17:45:00',3.31),('16100','2013-07-01','17:50:00',3.18),('16100','2013-07-01','17:55:00',3.04),('16100','2013-07-01','18:00:00',2.87),('16100','2013-07-01','18:05:00',2.7),('16100','2013-07-01','18:10:00',2.52),('16100','2013-07-01','18:15:00',2.3),('16100','2013-07-01','18:20:00',2.09),('16100','2013-07-01','18:25:00',1.99),('16100','2013-07-01','18:30:00',1.82),('16100','2013-07-01','18:35:00',1.68),('16100','2013-07-01','18:41:00',1.53),('16100','2013-07-01','18:45:00',1.36),('16100','2013-07-01','18:50:00',1.24),('16100','2013-07-01','18:55:00',1.1),('16100','2013-06-30','07:50:00',1.04),('16100','2013-06-30','07:55:00',1.25),('16100','2013-06-30','08:00:00',1.45),('16100','2013-06-30','08:05:00',1.65),('16100','2013-06-30','08:10:00',1.84),('16100','2013-06-30','08:15:00',2.04),('16100','2013-06-30','08:20:00',2.21),('16100','2013-06-30','08:25:00',2.34),('16100','2013-06-30','08:30:00',2.52),('16100','2013-06-30','08:35:00',2.66),('16100','2013-06-30','08:40:00',2.82),('16100','2013-06-30','08:45:00',3.01),('16100','2013-06-30','08:50:00',3.19),('16100','2013-06-30','08:55:00',3.33),('16100','2013-06-30','09:00:00',3.49),('16100','2013-06-30','09:05:00',3.61),('16100','2013-06-30','09:10:00',3.82),('16100','2013-06-30','09:15:00',4.1),('16100','2013-06-30','09:20:00',4.41),('16100','2013-06-30','09:25:00',4.56),('16100','2013-06-30','09:30:00',4.69),('16100','2013-06-30','09:35:00',4.84),('16100','2013-06-30','09:40:00',4.98),('16100','2013-06-30','09:45:00',5.08),('16100','2013-06-30','09:50:00',5.18),('16100','2013-06-30','09:55:00',5.28),('16100','2013-06-30','10:00:00',5.38),('16100','2013-06-30','10:05:00',5.49),('16100','2013-06-30','10:10:00',5.62),('16100','2013-06-30','10:15:00',5.76),('16100','2013-06-30','10:20:00',5.88),('16100','2013-06-30','10:25:00',5.97),('16100','2013-06-30','10:30:00',6.03),('16100','2013-06-30','10:35:00',6.13),('16100','2013-06-30','10:40:00',6.21),('16100','2013-06-30','10:45:00',6.29),('16100','2013-06-30','10:50:00',6.32),('16100','2013-06-30','10:55:00',6.41),('16100','2013-06-30','11:00:00',6.6),('16100','2013-06-30','11:05:00',6.68),('16100','2013-06-30','11:10:00',6.73),('16100','2013-06-30','11:15:00',6.79),('16100','2013-06-30','11:20:00',6.89),('16100','2013-06-30','11:25:00',7),('16100','2013-06-30','11:30:00',7.1),('16100','2013-06-30','11:35:00',7.18),('16100','2013-06-30','11:40:00',7.24),('16100','2013-06-30','11:45:00',7.24),('16100','2013-06-30','11:50:00',7.31),('16100','2013-06-30','11:55:00',7.33),('16100','2013-06-30','12:00:00',7.41),('16100','2013-06-30','12:05:00',7.36),('16100','2013-06-30','12:10:00',7.3),('16100','2013-06-30','12:15:00',7.31),('16100','2013-06-30','12:20:00',7.32),('16100','2013-06-30','12:25:00',7.35),('16100','2013-06-30','12:30:00',7.39),('16100','2013-06-30','12:35:00',7.44),('16100','2013-06-30','12:40:00',7.45),('16100','2013-06-30','12:45:00',7.54),('16100','2013-06-30','12:50:00',7.56),('16100','2013-06-30','12:55:00',7.52),('16100','2013-06-30','13:00:00',7.47),('16100','2013-06-30','13:05:00',7.58),('16100','2013-06-30','13:10:00',4.73),('16100','2013-06-30','13:15:00',4.25),('16100','2013-06-30','13:20:00',8.03),('16100','2013-06-30','13:25:00',7.88),('16100','2013-06-30','13:30:00',7.82),('16100','2013-06-30','13:35:00',7.95),('16100','2013-06-30','13:40:00',7.91),('16100','2013-06-30','13:45:00',7.73),('16100','2013-06-30','13:50:00',7.73),('16100','2013-06-30','13:55:00',7.45),('16100','2013-06-30','14:00:00',7.6),('16100','2013-06-30','14:05:00',7.47),('16100','2013-06-30','14:10:00',7.45),('16100','2013-06-30','14:15:00',7.49),('16100','2013-06-30','14:20:00',7.47),('16100','2013-06-30','14:25:00',7.35),('16100','2013-06-30','14:30:00',7.32),('16100','2013-06-30','14:35:00',7.31),('16100','2013-06-30','14:40:00',7.28),('16100','2013-06-30','14:45:00',7.24),('16100','2013-06-30','14:50:00',7.2),('16100','2013-06-30','14:55:00',7.12),('16100','2013-06-30','15:00:00',7.07),('16100','2013-06-30','15:05:00',7.03),('16100','2013-06-30','15:10:00',6.97),('16100','2013-06-30','15:15:00',6.86),('16100','2013-06-30','15:20:00',6.79),('16100','2013-06-30','15:25:00',6.69),('16100','2013-06-30','15:30:00',6.53),('16100','2013-06-30','15:35:00',6.43),('16100','2013-06-30','15:40:00',6.32),('16100','2013-06-30','15:45:00',6.3),('16100','2013-06-30','15:50:00',6.21),('16100','2013-06-30','15:55:00',6.1),('16100','2013-06-30','16:00:00',6),('16100','2013-06-30','16:05:00',5.68),('16100','2013-06-30','16:10:00',5.52),('16100','2013-06-30','16:15:00',5.68),('16100','2013-06-30','16:20:00',5.6),('16100','2013-06-30','16:25:00',5.45),('16100','2013-06-30','16:30:00',5.37),('16100','2013-06-30','16:35:00',5.28),('16100','2013-06-30','16:40:00',5.19),('16100','2013-06-30','16:45:00',5.03),('16100','2013-06-30','16:50:00',4.91),('16100','2013-06-30','16:55:00',4.78),('16100','2013-06-30','17:00:00',4.65),('16100','2013-06-30','17:05:00',4.5),('16100','2013-06-30','17:10:00',4.37),('16100','2013-06-30','17:15:00',4.19),('16100','2013-06-30','17:20:00',4.06),('16100','2013-06-30','17:25:00',3.92),('16100','2013-06-30','17:30:00',3.79),('16100','2013-06-30','17:35:00',3.62),('16100','2013-06-30','17:40:00',3.45),('16100','2013-06-30','17:45:00',3.3),('16100','2013-06-30','17:50:00',3.13),('16100','2013-06-30','17:55:00',3.03),('16100','2013-06-30','18:00:00',2.87),('16100','2013-06-30','18:05:00',2.47),('16100','2013-06-30','18:10:00',2.35),('16100','2013-06-30','18:15:00',2.22),('16100','2013-06-30','18:20:00',2.13),('16100','2013-06-30','18:25:00',2.06),('16100','2013-06-30','18:30:00',1.87),('16100','2013-06-30','18:35:00',1.55),('16100','2013-06-30','18:40:00',1.52),('16100','2013-06-30','18:45:00',1.36),('16100','2013-06-30','18:50:00',1.16),('16100','2013-06-30','18:55:00',1.02),('16100','2014-04-04','08:35:00',1.23),('16100','2014-04-04','08:40:00',1.31),('16100','2014-04-04','08:45:00',1.43),('16100','2014-04-04','08:50:00',1.18),('16100','2014-04-04','09:10:00',1.08),('16100','2014-04-04','09:15:00',1.21),('16100','2014-04-04','09:20:00',1.7),('16100','2014-04-04','09:25:00',2.39),('16100','2014-04-04','09:30:00',2.86),('16100','2014-04-04','09:35:00',3.26),('16100','2014-04-04','09:40:00',3.44),('16100','2014-04-04','09:45:00',3.53),('16100','2014-04-04','09:50:00',3.73),('16100','2014-04-04','09:55:00',4.32),('16100','2014-04-04','10:00:00',4.26),('16100','2014-04-04','10:05:00',3.61),('16100','2014-04-04','10:10:00',3.22),('16100','2014-04-04','10:15:00',3.54),('16100','2014-04-04','10:20:00',3.15),('16100','2014-04-04','10:25:00',4.58),('16100','2014-04-04','10:30:00',5.53),('16100','2014-04-04','10:35:00',2.47),('16100','2014-04-04','10:40:00',2.55),('16100','2014-04-04','10:45:00',3.32),('16100','2014-04-04','10:50:00',5.31),('16100','2014-04-04','10:55:00',4.88),('16100','2014-04-04','11:00:00',5.03),('16100','2014-04-04','11:05:00',4.87),('16100','2014-04-04','11:10:00',4.39),('16100','2014-04-04','11:15:00',4.98),('16100','2014-04-04','11:20:00',6.05),('16100','2014-04-04','11:25:00',6.33),('16100','2014-04-04','11:30:00',6.58),('16100','2014-04-04','11:35:00',6.49),('16100','2014-04-04','11:40:00',5.81),('16100','2014-04-04','11:45:00',4.88),('16100','2014-04-04','11:50:00',5.12),('16100','2014-04-04','11:55:00',4.72),('16100','2014-04-04','12:00:00',4.8),('16100','2014-04-04','12:05:00',4.6),('16100','2014-04-04','12:10:00',4.43),('16100','2014-04-04','12:15:00',4.21),('16100','2014-04-04','12:20:00',5.65),('16100','2014-04-04','12:25:00',6.98),('16100','2014-04-04','12:30:00',5.59),('16100','2014-04-04','12:35:00',6.93),('16100','2014-04-04','12:40:00',5.84),('16100','2014-04-04','12:45:00',5.68),('16100','2014-04-04','12:50:00',4.67),('16100','2014-04-04','12:55:00',5.59),('16100','2014-04-04','13:00:00',7.16),('16100','2014-04-04','13:05:00',7.37),('16100','2014-04-04','13:10:00',7.72),('16100','2014-04-04','13:15:00',6.82),('16100','2014-04-04','13:20:00',5.18),('16100','2014-04-04','13:25:00',4.83),('16100','2014-04-04','13:30:00',5.13),('16100','2014-04-04','13:35:00',4.3),('16100','2014-04-04','13:40:00',5.69),('16100','2014-04-04','13:45:00',8.22),('16100','2014-04-04','13:50:00',5.49),('16100','2014-04-04','13:55:00',7.89),('16100','2014-04-04','14:00:00',2.8),('16100','2014-04-04','14:05:00',2.34),('16100','2014-04-04','14:10:00',2.76),('16100','2014-04-04','14:15:00',1.58),('16100','2014-04-04','14:30:00',1.14),('16100','2014-04-04','14:35:00',1.26),('16100','2014-04-04','14:40:00',1.21),('16100','2014-04-04','14:45:00',1.47),('16100','2014-04-04','14:50:00',7.81),('16100','2014-04-04','14:55:00',7.97),('16100','2014-04-04','15:00:00',6.7),('16100','2014-04-04','15:05:00',5.85),('16100','2014-04-04','15:10:00',6.53),('16100','2014-04-04','15:15:00',7.87),('16100','2014-04-04','15:20:00',7.12),('16100','2014-04-04','15:25:00',4.52),('16100','2014-04-04','15:30:00',3.66),('16100','2014-04-04','15:35:00',5.56),('16100','2014-04-04','15:40:00',7.44),('16100','2014-04-04','15:45:00',2.94),('16100','2014-04-04','15:50:00',1.43),('16100','2014-04-04','15:55:00',1.52),('16100','2014-04-04','16:00:00',1.84),('16100','2014-04-04','16:05:00',2.16),('16100','2014-04-04','16:10:00',2.92),('16100','2014-04-04','16:15:00',2.35),('16100','2014-04-04','16:20:00',1.89),('16100','2014-04-04','16:25:00',4.93),('16100','2014-04-04','16:30:00',4.31),('16100','2014-04-04','16:35:00',2.43),('16100','2014-04-04','16:40:00',2.81),('16100','2014-04-04','16:45:00',4.33),('16100','2014-04-04','16:50:00',5.33),('16100','2014-04-04','16:55:00',4.48),('16100','2014-04-04','17:00:00',2.37),('16100','2014-04-04','17:05:00',3.75),('16100','2014-04-04','17:10:00',3.94),('16100','2014-04-04','17:15:00',3.31),('16100','2014-04-04','17:20:00',3.09),('16100','2014-04-04','17:25:00',1.31),('16100','2014-04-04','17:30:00',1.82),('16100','2014-04-04','17:45:00',1.75),('16100','2014-04-04','17:50:00',1.66),('16100','2014-04-04','17:55:00',1.06),('16100','2014-04-04','18:00:00',1.2),('16100','2014-04-04','18:05:00',1.2),('16100','2014-04-04','18:10:00',1.18),('16100','2014-04-04','18:15:00',1.12),('16100','2014-04-04','18:20:00',1.15),('16100','2013-06-29','07:50:00',1.09),('16100','2013-06-29','07:55:00',1.3),('16100','2013-06-29','08:00:00',1.51),('16100','2013-06-29','08:05:00',1.7),('16100','2013-06-29','08:10:00',1.9),('16100','2013-06-29','08:15:00',2.1),('16100','2013-06-29','08:20:00',2.28),('16100','2013-06-29','08:25:00',2.41),('16100','2013-06-29','08:30:00',2.6),('16100','2013-06-29','08:35:00',2.77),('16100','2013-06-29','08:40:00',2.92),('16100','2013-06-29','08:45:00',3.11),('16100','2013-06-29','08:50:00',3.29),('16100','2013-06-29','08:55:00',3.45),('16100','2013-06-29','09:00:00',3.58),('16100','2013-06-29','09:05:00',3.7),('16100','2013-06-29','09:10:00',3.88),('16100','2013-06-29','09:15:00',4.14),('16100','2013-06-29','09:20:00',4.42),('16100','2013-06-29','09:25:00',4.57),('16100','2013-06-29','09:30:00',4.71),('16100','2013-06-29','09:35:00',4.86),('16100','2013-06-29','09:40:00',5.03),('16100','2013-06-29','09:45:00',5.16),('16100','2013-06-29','09:50:00',5.28),('16100','2013-06-29','09:55:00',5.4),('16100','2013-06-29','10:00:00',5.5),('16100','2013-06-29','10:05:00',5.62),('16100','2013-06-29','10:10:00',5.73),('16100','2013-06-29','10:15:00',5.88),('16100','2013-06-29','10:20:00',5.99),('16100','2013-06-29','10:25:00',6.08),('16100','2013-06-29','10:30:00',6.14),('16100','2013-06-29','10:35:00',6.26),('16100','2013-06-29','10:40:00',6.37),('16100','2013-06-29','10:45:00',6.44),('16100','2013-06-29','10:50:00',6.52),('16100','2013-06-29','10:55:00',6.6),('16100','2013-06-29','11:00:00',6.74),('16100','2013-06-29','11:05:00',6.85),('16100','2013-06-29','11:10:00',6.92),('16100','2013-06-29','11:15:00',6.97),('16100','2013-06-29','11:20:00',7.04),('16100','2013-06-29','11:25:00',7.12),('16100','2013-06-29','11:30:00',7.18),('16100','2013-06-29','11:35:00',7.24),('16100','2013-06-29','11:40:00',7.33),('16100','2013-06-29','11:45:00',7.33),('16100','2013-06-29','11:50:00',7.34),('16100','2013-06-29','11:55:00',7.39),('16100','2013-06-29','12:00:00',7.45),('16100','2013-06-29','12:05:00',7.48),('16100','2013-06-29','12:10:00',7.55),('16100','2013-06-29','12:15:00',7.55),('16100','2013-06-29','12:20:00',7.55),('16100','2013-06-29','12:25:00',7.59),('16100','2013-06-29','12:30:00',7.68),('16100','2013-06-29','12:35:00',7.66),('16100','2013-06-29','12:40:00',7.74),('16100','2013-06-29','12:45:00',7.44),('16100','2013-06-29','12:50:00',7.81),('16100','2013-06-29','12:55:00',7.88),('16100','2013-06-29','13:00:00',7.62),('16100','2013-06-29','13:05:00',4.45),('16100','2013-06-29','13:10:00',7.49),('16100','2013-06-29','13:15:00',5.1),('16100','2013-06-29','13:20:00',8.07),('16100','2013-06-29','13:25:00',3.79),('16100','2013-06-29','13:30:00',6.46),('16100','2013-06-29','13:35:00',6.73),('16100','2013-06-29','13:40:00',5.22),('16100','2013-06-29','13:45:00',4.91),('16100','2013-06-29','13:50:00',8.52),('16100','2013-06-29','13:55:00',8.19),('16100','2013-06-29','14:00:00',6.77),('16100','2013-06-29','14:05:00',6.67),('16100','2013-06-29','14:10:00',7.73),('16100','2013-06-29','14:15:00',6.44),('16100','2013-06-29','14:20:00',6.36),('16100','2013-06-29','14:25:00',7.69),('16100','2013-06-29','14:30:00',7.55),('16100','2013-06-29','14:35:00',7.47),('16100','2013-06-29','14:40:00',7.42),('16100','2013-06-29','14:45:00',7.4),('16100','2013-06-29','14:50:00',7.32),('16100','2013-06-29','14:55:00',7.21),('16100','2013-06-29','15:00:00',7.16),('16100','2013-06-29','15:05:00',7.23),('16100','2013-06-29','15:10:00',7.17),('16100','2013-06-29','15:15:00',7.06),('16100','2013-06-29','15:20:00',7),('16100','2013-06-29','15:25:00',6.9),('16100','2013-06-29','15:30:00',6.93),('16100','2013-06-29','15:35:00',6.78),('16100','2013-06-29','15:40:00',5.69),('16100','2013-06-29','15:45:00',6.53),('16100','2013-06-29','15:50:00',6.5),('16100','2013-06-29','15:55:00',6.5),('16100','2013-06-29','16:00:00',6.29),('16100','2013-06-29','16:05:00',6.15),('16100','2013-06-29','16:10:00',6.14),('16100','2013-06-29','16:15:00',6.05),('16100','2013-06-29','16:20:00',5.94),('16100','2013-06-29','16:25:00',5.72),('16100','2013-06-29','16:30:00',5.67),('16100','2013-06-29','16:35:00',5.54),('16100','2013-06-29','16:40:00',5.28),('16100','2013-06-29','16:45:00',5.1),('16100','2013-06-29','16:50:00',5.03),('16100','2013-06-29','16:55:00',4.85),('16100','2013-06-29','17:00:00',4.71),('16100','2013-06-29','17:05:00',4.57),('16100','2013-06-29','17:10:00',4.39),('16100','2013-06-29','17:15:00',4.23),('16100','2013-06-29','17:20:00',4.11),('16100','2013-06-29','17:25:00',3.99),('16100','2013-06-29','17:30:00',3.81),('16100','2013-06-29','17:35:00',2.92),('16100','2013-06-29','17:40:00',2.92),('16100','2013-06-29','17:45:00',3.39),('16100','2013-06-29','17:50:00',3.3),('16100','2013-06-29','17:55:00',2.94),('16100','2013-06-29','18:00:00',2.78),('16100','2013-06-29','18:05:00',2.56),('16100','2013-06-29','18:10:00',2.4),('16100','2013-06-29','18:15:00',2.24),('16100','2013-06-29','18:20:00',2.04),('16100','2013-06-29','18:25:00',1.94),('16100','2013-06-29','18:30:00',1.75),('16100','2013-06-29','18:35:00',1.67),('16100','2013-06-29','18:40:00',1.55),('16100','2013-06-29','18:45:00',1.4),('16100','2013-06-29','18:50:00',1.29),('16100','2013-06-29','18:55:00',1.15),('16100','2013-06-29','19:00:00',1.02),('16100','2013-06-28','07:25:00',1.02),('16100','2013-06-28','07:30:00',1.27),('16100','2013-06-28','07:35:00',1.3),('16100','2013-06-28','07:40:00',1.32),('16100','2013-06-28','07:45:00',1.24),('16100','2013-06-28','07:50:00',1.62),('16100','2013-06-28','07:55:00',1.65),('16100','2013-06-28','08:00:00',2.03),('16100','2013-06-28','08:05:00',1.59),('16100','2013-06-28','08:20:00',2.02),('16100','2013-06-28','08:25:00',2.52),('16100','2013-06-28','08:30:00',2.61),('16100','2013-06-28','08:35:00',2.74),('16100','2013-06-28','08:40:00',2.89),('16100','2013-06-28','08:45:00',3.05),('16100','2013-06-28','08:50:00',3.21),('16100','2013-06-28','08:55:00',3.36),('16100','2013-06-28','09:00:00',3.51),('16100','2013-06-28','09:05:00',3.65),('16100','2013-06-28','09:10:00',3.83),('16100','2013-06-28','09:15:00',4.08),('16100','2013-06-28','09:20:00',4.37),('16100','2013-06-28','09:25:00',4.52),('16100','2013-06-28','09:30:00',4.67),('16100','2013-06-28','09:35:00',4.77),('16100','2013-06-28','09:40:00',4.92),('16100','2013-06-28','09:45:00',5.05),('16100','2013-06-28','09:50:00',5.16),('16100','2013-06-28','09:55:00',5.27),('16100','2013-06-28','10:00:00',5.4),('16100','2013-06-28','10:05:00',5.52),('16100','2013-06-28','10:10:00',5.64),('16100','2013-06-28','10:15:00',5.75),('16100','2013-06-28','10:20:00',5.87),('16100','2013-06-28','10:25:00',5.97),('16100','2013-06-28','10:30:00',6.1),('16100','2013-06-28','10:35:00',6.23),('16100','2013-06-28','10:40:00',6.11),('16100','2013-06-28','10:45:00',4.19),('16100','2013-06-28','10:50:00',5.97),('16100','2013-06-28','10:55:00',6.78),('16100','2013-06-28','11:00:00',2.93),('16100','2013-06-28','11:05:00',6.82),('16100','2013-06-28','11:10:00',5.29),('16100','2013-06-28','11:15:00',3.81),('16100','2013-06-28','11:20:00',7.56),('16100','2013-06-28','11:25:00',5.89),('16100','2013-06-28','11:30:00',6.65),('16100','2013-06-28','11:35:00',7.82),('16100','2013-06-28','11:40:00',2.24),('16100','2013-06-28','11:45:00',5.05),('16100','2013-06-28','11:50:00',7.24),('16100','2013-06-28','11:55:00',7.81),('16100','2013-06-28','12:00:00',7.92),('16100','2013-06-28','12:05:00',3.65),('16100','2013-06-28','12:10:00',8.11),('16100','2013-06-28','12:15:00',8.03),('16100','2013-06-28','12:20:00',7.97),('16100','2013-06-28','12:25:00',8),('16100','2013-06-28','12:30:00',6.96),('16100','2013-06-28','12:35:00',2.48),('16100','2013-06-28','12:40:00',4.65),('16100','2013-06-28','12:45:00',5.01),('16100','2013-06-28','12:50:00',2.63),('16100','2013-06-28','12:55:00',4.94),('16100','2013-06-28','13:00:00',8.17),('16100','2013-06-28','13:05:00',3.2),('16100','2013-06-28','13:10:00',6.68),('16100','2013-06-28','13:15:00',2.8),('16100','2013-06-28','13:20:00',2.35),('16100','2013-06-28','13:25:00',5.29),('16100','2013-06-28','13:30:00',3.92),('16100','2013-06-28','13:35:00',4.6),('16100','2013-06-28','13:40:00',6.72),('16100','2013-06-28','13:45:00',2.24),('16100','2013-06-28','13:50:00',6.9),('16100','2013-06-28','13:55:00',7.23),('16100','2013-06-28','14:00:00',8.21),('16100','2013-06-28','14:05:00',8.2),('16100','2013-06-28','14:10:00',8.47),('16100','2013-06-28','14:15:00',7.23),('16100','2013-06-28','14:20:00',6.11),('16100','2013-06-28','14:25:00',8.05),('16100','2013-06-28','14:30:00',8.01),('16100','2013-06-28','14:35:00',7.95),('16100','2013-06-28','14:40:00',8.06),('16100','2013-06-28','14:45:00',7.7),('16100','2013-06-28','14:50:00',8.2),('16100','2013-06-28','14:55:00',8.18),('16100','2013-06-28','15:00:00',8.49),('16100','2013-06-28','15:05:00',4.57),('16100','2013-06-28','15:10:00',5.65),('16100','2013-06-28','15:15:00',6.48),('16100','2013-06-28','15:20:00',3.9),('16100','2013-06-28','15:25:00',2.6),('16100','2013-06-28','15:30:00',2.05),('16100','2013-06-28','15:35:00',1.34),('16100','2013-06-28','16:15:00',1.09),('16100','2013-06-28','16:20:00',1.5),('16100','2013-06-28','16:25:00',1.89),('16100','2013-06-28','16:30:00',2.77),('16100','2013-06-28','16:35:00',4.6),('16100','2013-06-28','16:40:00',5.84),('16100','2013-06-28','16:45:00',5.17),('16100','2013-06-28','16:50:00',2.96),('16100','2013-06-28','16:55:00',2.12),('16100','2013-06-28','17:00:00',2.04),('16100','2013-06-28','17:05:00',1.95),('16100','2013-06-28','17:10:00',1.95),('16100','2013-06-28','17:15:00',2.08),('16100','2013-06-28','17:20:00',2.58),('16100','2013-06-28','17:25:00',3.75),('16100','2013-06-28','17:30:00',4.52),('16100','2013-06-28','17:35:00',3.41),('16100','2013-06-28','17:40:00',4.1),('16100','2013-06-28','17:45:00',3.81),('16100','2013-06-28','17:50:00',1.33),('16100','2013-06-28','17:55:00',1.29),('16100','2013-06-28','18:00:00',1.61),('16100','2013-06-28','18:05:00',1.25),('16100','2013-06-28','18:15:00',2.03),('16100','2013-06-28','18:20:00',2.04),('16100','2013-06-28','18:30:00',1.23),('16100','2013-06-28','18:35:00',1.37),('16100','2013-06-28','18:40:00',1.13),('16100','2013-06-28','18:55:00',1.18),('16100','2013-06-28','19:00:00',1.33),('16100','2013-06-27','07:50:00',1.13),('16100','2013-06-27','07:55:00',1.3),('16100','2013-06-27','08:00:00',1.31),('16100','2013-06-27','08:05:00',1.54),('16100','2013-06-27','08:10:00',1.55),('16100','2013-06-27','08:15:00',1.97),('16100','2013-06-27','08:20:00',2.01),('16100','2013-06-27','08:25:00',2.3),('16100','2013-06-27','08:30:00',2.49),('16100','2013-06-27','08:35:00',2.69),('16100','2013-06-27','08:40:00',2.82),('16100','2013-06-27','08:45:00',3.01),('16100','2013-06-27','08:50:00',3.14),('16100','2013-06-27','08:55:00',3.33),('16100','2013-06-27','09:00:00',3.48),('16100','2013-06-27','09:05:00',3.68),('16100','2013-06-27','09:10:00',4.05),('16100','2013-06-27','09:15:00',4.54),('16100','2013-06-27','09:20:00',4.01),('16100','2013-06-27','09:25:00',3.59),('16100','2013-06-27','09:30:00',4.49),('16100','2013-06-27','09:35:00',4.18),('16100','2013-06-27','09:40:00',3.46),('16100','2013-06-27','09:45:00',4.91),('16100','2013-06-27','09:50:00',3.85),('16100','2013-06-27','09:55:00',1.59),('16100','2013-06-27','10:00:00',1.75),('16100','2013-06-27','10:05:00',4.48),('16100','2013-06-27','10:10:00',6.44),('16100','2013-06-27','10:15:00',4.05),('16100','2013-06-27','10:20:00',3.42),('16100','2013-06-27','10:25:00',1.86),('16100','2013-06-27','10:30:00',7.15),('16100','2013-06-27','10:35:00',7.05),('16100','2013-06-27','10:40:00',3.62),('16100','2013-06-27','10:45:00',6.31),('16100','2013-06-27','10:50:00',1.69),('16100','2013-06-27','10:55:00',2.09),('16100','2013-06-27','11:00:00',2.5),('16100','2013-06-27','11:05:00',2.7),('16100','2013-06-27','11:10:00',4.54),('16100','2013-06-27','11:15:00',6.16),('16100','2013-06-27','11:20:00',5.18),('16100','2013-06-27','11:25:00',7.24),('16100','2013-06-27','11:30:00',6.37),('16100','2013-06-27','11:35:00',7),('16100','2013-06-27','11:40:00',6.29),('16100','2013-06-27','11:45:00',7.35),('16100','2013-06-27','11:50:00',5.13),('16100','2013-06-27','11:55:00',7.67),('16100','2013-06-27','12:00:00',4.54),('16100','2013-06-27','12:05:00',8.62),('16100','2013-06-27','12:10:00',7.86),('16100','2013-06-27','12:15:00',7.3),('16100','2013-06-27','12:20:00',7.79),('16100','2013-06-27','12:25:00',8.13),('16100','2013-06-27','12:30:00',6.58),('16100','2013-06-27','12:35:00',6.65),('16100','2013-06-27','12:40:00',8.11),('16100','2013-06-27','12:45:00',7.05),('16100','2013-06-27','12:50:00',8.27),('16100','2013-06-27','12:55:00',4.65),('16100','2013-06-27','13:00:00',7.62),('16100','2013-06-27','13:05:00',2.72),('16100','2013-06-27','13:10:00',8.3),('16100','2013-06-27','13:15:00',6.54),('16100','2013-06-27','13:20:00',5.9),('16100','2013-06-27','13:25:00',8.17),('16100','2013-06-27','13:30:00',8.04),('16100','2013-06-27','13:35:00',7.94),('16100','2013-06-27','13:40:00',8.01),('16100','2013-06-27','13:45:00',8.67),('16100','2013-06-27','13:50:00',6.23),('16100','2013-06-27','13:55:00',6.92),('16100','2013-06-27','14:00:00',7.96),('16100','2013-06-27','14:05:00',6.9),('16100','2013-06-27','14:10:00',5.75),('16100','2013-06-27','14:15:00',3.91),('16100','2013-06-27','14:20:00',6.29),('16100','2013-06-27','14:25:00',4.81),('16100','2013-06-27','14:30:00',7.29),('16100','2013-06-27','14:35:00',8.15),('16100','2013-06-27','14:40:00',7.08),('16100','2013-06-27','14:45:00',3.59),('16100','2013-06-27','14:50:00',3.69),('16100','2013-06-27','14:55:00',7.26),('16100','2013-06-27','15:00:00',6.82),('16100','2013-06-27','15:05:00',6.75),('16100','2013-06-27','15:10:00',2.46),('16100','2013-06-27','15:15:00',5.6),('16100','2013-06-27','15:20:00',5.51),('16100','2013-06-27','15:25:00',2.47),('16100','2013-06-27','15:30:00',6.88),('16100','2013-06-27','15:35:00',3.64),('16100','2013-06-27','15:40:00',3.06),('16100','2013-06-27','15:45:00',4.66),('16100','2013-06-27','15:50:00',6.72),('16100','2013-06-27','15:55:00',6.51),('16100','2013-06-27','16:00:00',6.84),('16100','2013-06-27','16:05:00',6.1),('16100','2013-06-27','16:10:00',5.59),('16100','2013-06-27','16:15:00',6.32),('16100','2013-06-27','16:20:00',3.51),('16100','2013-06-27','16:25:00',6.19),('16100','2013-06-27','16:30:00',6.16),('16100','2013-06-27','16:35:00',3.99),('16100','2013-06-27','16:40:00',5.74),('16100','2013-06-27','16:45:00',6.09),('16100','2013-06-27','16:50:00',4.56),('16100','2013-06-27','16:55:00',4.83),('16100','2013-06-27','17:00:00',5.42),('16100','2013-06-27','17:05:00',5.15),('16100','2013-06-27','17:10:00',4.65),('16100','2013-06-27','17:15:00',4.38),('16100','2013-06-27','17:20:00',4.18),('16100','2013-06-27','17:25:00',4),('16100','2013-06-27','17:30:00',3.82),('16100','2013-06-27','17:35:00',3.71),('16100','2013-06-27','17:40:00',3.58),('16100','2013-06-27','17:45:00',3.39),('16100','2013-06-27','17:50:00',3.23),('16100','2013-06-27','17:55:00',3.04),('16100','2013-06-27','18:00:00',2.89),('16100','2013-06-27','18:05:00',2.41),('16100','2013-06-27','18:10:00',1.54),('16100','2013-06-27','18:15:00',2.31),('16100','2013-06-27','18:20:00',2.14),('16100','2013-06-27','18:25:00',2.01),('16100','2013-06-27','18:30:00',1.87),('16100','2013-06-27','18:35:00',1.78),('16100','2013-06-27','18:40:00',1.61),('16100','2013-06-27','18:45:00',1.31),('16100','2013-06-27','18:50:00',1.29),('16100','2013-06-27','18:55:00',1.06),('16100','2013-06-26','07:50:00',1.02),('16100','2013-06-26','07:55:00',1.29),('16100','2013-06-26','08:00:00',1.51),('16100','2013-06-26','08:05:00',1.73),('16100','2013-06-26','08:10:00',1.9),('16100','2013-06-26','08:15:00',2.09),('16100','2013-06-26','08:20:00',2.25),('16100','2013-06-26','08:25:00',2.39),('16100','2013-06-26','08:30:00',2.53),('16100','2013-06-26','08:35:00',2.65),('16100','2013-06-26','08:40:00',2.85),('16100','2013-06-26','08:45:00',3.03),('16100','2013-06-26','08:50:00',3.24),('16100','2013-06-26','08:55:00',3.49),('16100','2013-06-26','09:00:00',3.55),('16100','2013-06-26','09:05:00',3.64),('16100','2013-06-26','09:10:00',3.84),('16100','2013-06-26','09:15:00',4.13),('16100','2013-06-26','09:20:00',4.43),('16100','2013-06-26','09:25:00',4.57),('16100','2013-06-26','09:30:00',4.71),('16100','2013-06-26','09:35:00',4.87),('16100','2013-06-26','09:40:00',4.96),('16100','2013-06-26','09:45:00',5.08),('16100','2013-06-26','09:50:00',5.2),('16100','2013-06-26','09:55:00',5.37),('16100','2013-06-26','10:00:00',5.51),('16100','2013-06-26','10:05:00',5.6),('16100','2013-06-26','10:10:00',5.75),('16100','2013-06-26','10:15:00',5.86),('16100','2013-06-26','10:20:00',6.03),('16100','2013-06-26','10:25:00',6.1),('16100','2013-06-26','10:30:00',6.28),('16100','2013-06-26','10:35:00',5.71),('16100','2013-06-26','10:40:00',4.73),('16100','2013-06-26','10:45:00',2.1),('16100','2013-06-26','10:50:00',2.07),('16100','2013-06-26','10:55:00',6.54),('16100','2013-06-26','11:00:00',7.44),('16100','2013-06-26','11:05:00',7.51),('16100','2013-06-26','11:10:00',6.36),('16100','2013-06-26','11:15:00',7.42),('16100','2013-06-26','11:20:00',7.3),('16100','2013-06-26','11:25:00',7.41),('16100','2013-06-26','11:30:00',7.63),('16100','2013-06-26','11:35:00',4.4),('16100','2013-06-26','11:40:00',7.71),('16100','2013-06-26','11:45:00',7.87),('16100','2013-06-26','11:50:00',7.86),('16100','2013-06-26','11:55:00',7.94),('16100','2013-06-26','12:00:00',6.38),('16100','2013-06-26','12:05:00',2.66),('16100','2013-06-26','12:10:00',1.73),('16100','2013-06-26','12:15:00',1.77),('16100','2013-06-26','12:20:00',1.51),('16100','2013-06-26','12:25:00',1.33),('16100','2013-06-26','12:30:00',1.58),('16100','2013-06-26','12:35:00',2.01),('16100','2013-06-26','12:40:00',4.02),('16100','2013-06-26','12:45:00',3.97),('16100','2013-06-26','12:50:00',2.48),('16100','2013-06-26','12:55:00',3.85),('16100','2013-06-26','13:00:00',2.82),('16100','2013-06-26','13:05:00',4.21),('16100','2013-06-26','13:10:00',7.32),('16100','2013-06-26','13:15:00',8.38),('16100','2013-06-26','13:20:00',7.66),('16100','2013-06-26','13:25:00',8.1),('16100','2013-06-26','13:30:00',6.72),('16100','2013-06-26','13:35:00',3.22),('16100','2013-06-26','13:40:00',3.62),('16100','2013-06-26','13:45:00',3.18),('16100','2013-06-26','13:50:00',4.32),('16100','2013-06-26','13:55:00',6.52),('16100','2013-06-26','14:00:00',7.79),('16100','2013-06-26','14:05:00',8.01),('16100','2013-06-26','14:10:00',7.74),('16100','2013-06-26','14:15:00',7.4),('16100','2013-06-26','14:20:00',6.17),('16100','2013-06-26','14:25:00',3.96),('16100','2013-06-26','14:30:00',3.47),('16100','2013-06-26','14:35:00',3.38),('16100','2013-06-26','14:40:00',5.9),('16100','2013-06-26','14:45:00',7.48),('16100','2013-06-26','14:50:00',7.19),('16100','2013-06-26','14:55:00',7.01),('16100','2013-06-26','15:00:00',6.96),('16100','2013-06-26','15:05:00',6.95),('16100','2013-06-26','15:10:00',6.92),('16100','2013-06-26','15:15:00',6.89),('16100','2013-06-26','15:20:00',6.84),('16100','2013-06-26','15:25:00',6.73),('16100','2013-06-26','15:30:00',6.6),('16100','2013-06-26','15:35:00',6.49),('16100','2013-06-26','15:40:00',6.33),('16100','2013-06-26','15:45:00',6.28),('16100','2013-06-26','15:50:00',6.14),('16100','2013-06-26','15:55:00',6.01),('16100','2013-06-26','16:00:00',5.9),('16100','2013-06-26','16:05:00',5.83),('16100','2013-06-26','16:10:00',5.79),('16100','2013-06-26','16:15:00',5.68),('16100','2013-06-26','16:20:00',5.59),('16100','2013-06-26','16:25:00',5.43),('16100','2013-06-26','16:30:00',5.25),('16100','2013-06-26','16:35:00',4.86),('16100','2013-06-26','16:40:00',5.02),('16100','2013-06-26','16:45:00',4.95),('16100','2013-06-26','16:50:00',4.74),('16100','2013-06-26','16:55:00',4.67),('16100','2013-06-26','17:00:00',4.51),('16100','2013-06-26','17:05:00',4.31),('16100','2013-06-26','17:10:00',4.06),('16100','2013-06-26','17:15:00',4.05),('16100','2013-06-26','17:20:00',4.02),('16100','2013-06-26','17:25:00',3.95),('16100','2013-06-26','17:30:00',3.84),('16100','2013-06-26','17:35:00',3.81),('16100','2013-06-26','17:40:00',3.18),('16100','2013-06-26','17:45:00',3.37),('16100','2013-06-26','17:50:00',3.24),('16100','2013-06-26','17:55:00',3.13),('16100','2013-06-26','18:00:00',2.9),('16100','2013-06-26','18:05:00',2.71),('16100','2013-06-26','18:10:00',2.56),('16100','2013-06-26','18:15:00',2.25),('16100','2013-06-26','18:20:00',2.07),('16100','2013-06-26','18:25:00',1.92),('16100','2013-06-26','18:30:00',1.72),('16100','2013-06-26','18:35:00',1.58),('16100','2013-06-26','18:40:00',1.46),('16100','2013-06-26','18:45:00',1.35),('16100','2013-06-26','18:50:00',1.24),('16100','2013-06-26','18:55:00',1.12),('16100','2013-06-25','07:50:00',1.11),('16100','2013-06-25','07:55:00',1.3),('16100','2013-06-25','08:00:00',1.5),('16100','2013-06-25','08:05:00',1.7),('16100','2013-06-25','08:10:00',1.89),('16100','2013-06-25','08:15:00',2.08),('16100','2013-06-25','08:20:00',2.23),('16100','2013-06-25','08:25:00',2.37),('16100','2013-06-25','08:30:00',2.55),('16100','2013-06-25','08:35:00',2.69),('16100','2013-06-25','08:40:00',2.86),('16100','2013-06-25','08:45:00',3.03),('16100','2013-06-25','08:50:00',3.22),('16100','2013-06-25','08:55:00',3.37),('16100','2013-06-25','09:00:00',3.51),('16100','2013-06-25','09:05:00',3.63),('16100','2013-06-25','09:10:00',3.75),('16100','2013-06-25','09:15:00',4),('16100','2013-06-25','09:20:00',4.36),('16100','2013-06-25','09:25:00',4.49),('16100','2013-06-25','09:30:00',4.59),('16100','2013-06-25','09:35:00',4.71),('16100','2013-06-25','09:40:00',4.88),('16100','2013-06-25','09:45:00',5.02),('16100','2013-06-25','09:50:00',5.11),('16100','2013-06-25','09:55:00',5.24),('16100','2013-06-25','10:00:00',5.38),('16100','2013-06-25','10:05:00',5.53),('16100','2013-06-25','10:10:00',5.66),('16100','2013-06-25','10:15:00',5.8),('16100','2013-06-25','10:20:00',5.85),('16100','2013-06-25','10:25:00',5.98),('16100','2013-06-25','10:30:00',6.01),('16100','2013-06-25','10:35:00',6.05),('16100','2013-06-25','10:40:00',6.17),('16100','2013-06-25','10:45:00',6.37),('16100','2013-06-25','10:50:00',6.45),('16100','2013-06-25','10:55:00',6.48),('16100','2013-06-25','11:00:00',6.6),('16100','2013-06-25','11:05:00',6.65),('16100','2013-06-25','11:10:00',6.7),('16100','2013-06-25','11:15:00',6.8),('16100','2013-06-25','11:20:00',6.89),('16100','2013-06-25','11:25:00',6.93),('16100','2013-06-25','11:30:00',6.96),('16100','2013-06-25','11:35:00',7.06),('16100','2013-06-25','11:40:00',7.1),('16100','2013-06-25','11:45:00',7.18),('16100','2013-06-25','11:50:00',7.28),('16100','2013-06-25','11:55:00',7.31),('16100','2013-06-25','12:00:00',7.3),('16100','2013-06-25','12:05:00',7.3),('16100','2013-06-25','12:10:00',7.3),('16100','2013-06-25','12:15:00',7.38),('16100','2013-06-25','12:20:00',7.37),('16100','2013-06-25','12:25:00',7.45),('16100','2013-06-25','12:30:00',7.6),('16100','2013-06-25','12:35:00',7.73),('16100','2013-06-25','12:40:00',7.78),('16100','2013-06-25','12:45:00',7.86),('16100','2013-06-25','12:50:00',7.97),('16100','2013-06-25','12:55:00',7.99),('16100','2013-06-25','13:00:00',8.08),('16100','2013-06-25','13:05:00',8.12),('16100','2013-06-25','13:10:00',8.09),('16100','2013-06-25','13:15:00',5.37),('16100','2013-06-25','13:20:00',4.11),('16100','2013-06-25','13:25:00',6.47),('16100','2013-06-25','13:30:00',2.04),('16100','2013-06-25','13:35:00',4.62),('16100','2013-06-25','13:40:00',1.72),('16100','2013-06-25','13:45:00',1.44),('16100','2013-06-25','13:50:00',1.2),('16100','2013-06-25','13:55:00',1.71),('16100','2013-06-25','14:00:00',7.16),('16100','2013-06-25','14:05:00',7.89),('16100','2013-06-25','14:10:00',7.64),('16100','2013-06-25','14:15:00',7.6),('16100','2013-06-25','14:20:00',7.46),('16100','2013-06-25','14:25:00',7.37),('16100','2013-06-25','14:30:00',7.32),('16100','2013-06-25','14:35:00',7.36),('16100','2013-06-25','14:40:00',7.35),('16100','2013-06-25','14:45:00',7.3),('16100','2013-06-25','14:50:00',7.26),('16100','2013-06-25','14:55:00',7.22),('16100','2013-06-25','15:00:00',7.15),('16100','2013-06-25','15:05:00',7.08),('16100','2013-06-25','15:10:00',7.03),('16100','2013-06-25','15:15:00',6.9),('16100','2013-06-25','15:20:00',6.86),('16100','2013-06-25','15:25:00',6.7),('16100','2013-06-25','15:30:00',6.62),('16100','2013-06-25','15:35:00',6.55),('16100','2013-06-25','15:40:00',6.45),('16100','2013-06-25','15:45:00',6.35),('16100','2013-06-25','15:50:00',6.3),('16100','2013-06-25','15:55:00',6.2),('16100','2013-06-25','16:00:00',6.11),('16100','2013-06-25','16:05:00',5.97),('16100','2013-06-25','16:10:00',5.85),('16100','2013-06-25','16:15:00',5.76),('16100','2013-06-25','16:20:00',5.67),('16100','2013-06-25','16:25:00',5.49),('16100','2013-06-25','16:30:00',5.4),('16100','2013-06-25','16:35:00',5.25),('16100','2013-06-25','16:40:00',5.16),('16100','2013-06-25','16:45:00',5.06),('16100','2013-06-25','16:50:00',4.91),('16100','2013-06-25','16:55:00',4.78),('16100','2013-06-25','17:00:00',4.65),('16100','2013-06-25','17:05:00',4.53),('16100','2013-06-25','17:10:00',4.38),('16100','2013-06-25','17:15:00',4.18),('16100','2013-06-25','17:20:00',4.05),('16100','2013-06-25','17:25:00',3.94),('16100','2013-06-25','17:30:00',3.79),('16100','2013-06-25','17:35:00',3.65),('16100','2013-06-25','17:40:00',3.5),('16100','2013-06-25','17:45:00',3.31),('16100','2013-06-25','17:50:00',3.18),('16100','2013-06-25','17:55:00',2.97),('16100','2013-06-25','18:00:00',2.78),('16100','2013-06-25','18:05:00',2.65),('16100','2013-06-25','18:10:00',2.46),('16100','2013-06-25','18:15:00',2.16),('16100','2013-06-25','18:20:00',2.41),('16100','2013-06-25','18:25:00',1.75),('16100','2013-06-25','18:30:00',1.17),('16100','2013-06-25','19:05:00',1.02),('16100','2013-06-25','19:10:00',1),('16100','2013-06-24','08:00:00',1.7),('16100','2013-06-24','08:05:00',1.73),('16100','2013-06-24','08:10:00',1.79),('16100','2013-06-24','08:15:00',1.19),('16100','2013-06-24','08:40:00',2.46),('16100','2013-06-24','08:45:00',3.21),('16100','2013-06-24','08:50:00',3.32),('16100','2013-06-24','08:55:00',3.43),('16100','2013-06-24','09:00:00',3.55),('16100','2013-06-24','09:05:00',3.74),('16100','2013-06-24','09:10:00',3.9),('16100','2013-06-24','09:15:00',4.12),('16100','2013-06-24','09:20:00',4.48),('16100','2013-06-24','09:25:00',4.9),('16100','2013-06-24','09:30:00',5.05),('16100','2013-06-24','09:35:00',5.08),('16100','2013-06-24','09:40:00',5.2),('16100','2013-06-24','09:45:00',5.29),('16100','2013-06-24','09:50:00',5.5),('16100','2013-06-24','09:55:00',5.81),('16100','2013-06-24','10:00:00',6.17),('16100','2013-06-24','10:05:00',6.24),('16100','2013-06-24','10:10:00',6.35),('16100','2013-06-24','10:15:00',4.14),('16100','2013-06-24','10:20:00',5.18),('16100','2013-06-24','10:25:00',1.56),('16100','2013-06-24','10:30:00',1.55),('16100','2013-06-24','10:35:00',1.44),('16100','2013-06-24','10:40:00',4.08),('16100','2013-06-24','10:45:00',6.57),('16100','2013-06-24','10:50:00',6.9),('16100','2013-06-24','10:55:00',2.1),('16100','2013-06-24','11:00:00',6.5),('16100','2013-06-24','11:05:00',7.31),('16100','2013-06-24','11:10:00',7.2),('16100','2013-06-24','11:15:00',7.27),('16100','2013-06-24','11:20:00',7.55),('16100','2013-06-24','11:25:00',7.72),('16100','2013-06-24','11:30:00',7.92),('16100','2013-06-24','11:35:00',6.55),('16100','2013-06-24','11:40:00',2.7),('16100','2013-06-24','11:45:00',6.22),('16100','2013-06-24','11:50:00',4.6),('16100','2013-06-24','11:55:00',2.92),('16100','2013-06-24','12:00:00',2.9),('16100','2013-06-24','12:05:00',8.49),('16100','2013-06-24','12:10:00',9.09),('16100','2013-06-24','12:15:00',8.51),('16100','2013-06-24','12:20:00',8.25),('16100','2013-06-24','12:25:00',3.54),('16100','2013-06-24','12:30:00',8.23),('16100','2013-06-24','12:35:00',8.17),('16100','2013-06-24','12:40:00',8.32),('16100','2013-06-24','12:45:00',5.39),('16100','2013-06-24','12:50:00',6.95),('16100','2013-06-24','12:55:00',3.46),('16100','2013-06-24','13:00:00',7.31),('16100','2013-06-24','13:05:00',8.34),('16100','2013-06-24','13:10:00',7.93),('16100','2013-06-24','13:15:00',8.06),('16100','2013-06-24','13:20:00',8.23),('16100','2013-06-24','13:25:00',8.04),('16100','2013-06-24','13:30:00',7.93),('16100','2013-06-24','13:35:00',7.86),('16100','2013-06-24','13:40:00',7.88),('16100','2013-06-24','13:45:00',7.92),('16100','2013-06-24','13:50:00',7.82),('16100','2013-06-24','13:55:00',7.79),('16100','2013-06-24','14:00:00',7.79),('16100','2013-06-24','14:05:00',7.58),('16100','2013-06-24','14:10:00',7.61),('16100','2013-06-24','14:15:00',7.57),('16100','2013-06-24','14:20:00',7.6),('16100','2013-06-24','14:25:00',7.58),('16100','2013-06-24','14:30:00',7.54),('16100','2013-06-24','14:35:00',7.43),('16100','2013-06-24','14:40:00',7.44),('16100','2013-06-24','14:45:00',7.37),('16100','2013-06-24','14:50:00',7.32),('16100','2013-06-24','14:55:00',7.23),('16100','2013-06-24','15:00:00',7.14),('16100','2013-06-24','15:05:00',7.1),('16100','2013-06-24','15:10:00',7.05),('16100','2013-06-24','15:15:00',6.93),('16100','2013-06-24','15:20:00',6.88),('16100','2013-06-24','15:25:00',6.79),('16100','2013-06-24','15:30:00',6.64),('16100','2013-06-24','15:35:00',6.5),('16100','2013-06-24','15:40:00',6.44),('16100','2013-06-24','15:45:00',6.36),('16100','2013-06-24','15:50:00',6.23),('16100','2013-06-24','15:55:00',6.14),('16100','2013-06-24','16:00:00',6.06),('16100','2013-06-24','16:05:00',5.96),('16100','2013-06-24','16:10:00',5.83),('16100','2013-06-24','16:15:00',5.73),('16100','2013-06-24','16:20:00',5.65),('16100','2013-06-24','16:25:00',5.47),('16100','2013-06-24','16:30:00',5.35),('16100','2013-06-24','16:35:00',5.24),('16100','2013-06-24','16:40:00',5.09),('16100','2013-06-24','16:45:00',4.98),('16100','2013-06-24','16:50:00',4.84),('16100','2013-06-24','16:55:00',4.75),('16100','2013-06-24','17:02:00',4.62),('16100','2013-06-24','17:05:00',4.46),('16100','2013-06-24','17:10:00',4.34),('16100','2013-06-24','17:15:00',4.19),('16100','2013-06-24','17:20:00',4.06),('16100','2013-06-24','17:25:00',3.89),('16100','2013-06-24','17:30:00',3.75),('16100','2013-06-24','17:35:00',3.59),('16100','2013-06-24','17:40:00',3.45),('16100','2013-06-24','17:45:00',3.28),('16100','2013-06-24','17:50:00',3.14),('16100','2013-06-24','17:55:00',3),('16100','2013-06-24','18:00:00',2.84),('16100','2013-06-24','18:05:00',2.64),('16100','2013-06-24','18:10:00',2.42),('16100','2013-06-24','18:15:00',2.21),('16100','2013-06-24','18:20:00',2.09),('16100','2013-06-24','18:25:00',1.96),('16100','2013-06-24','18:30:00',1.81),('16100','2013-06-24','18:35:00',1.65),('16100','2013-06-24','18:40:00',1.51),('16100','2013-06-24','18:45:00',1.35),('16100','2013-06-24','18:50:00',1.21),('16100','2013-06-24','18:55:00',1.09),('16100','2013-06-23','08:30:00',1.04),('16100','2013-06-23','08:35:00',1.44),('16100','2013-06-23','08:40:00',1.65),('16100','2013-06-23','08:45:00',3.29),('16100','2013-06-23','08:50:00',3.48),('16100','2013-06-23','08:55:00',3.18),('16100','2013-06-23','09:00:00',1.73),('16100','2013-06-23','09:05:00',4.53),('16100','2013-06-23','09:10:00',3.54),('16100','2013-06-23','09:15:00',2.49),('16100','2013-06-23','09:20:00',4.08),('16100','2013-06-23','09:25:00',4.63),('16100','2013-06-23','09:35:00',2.74),('16100','2013-06-23','09:40:00',5.66),('16100','2013-06-23','09:45:00',5.67),('16100','2013-06-23','09:50:00',5.72),('16100','2013-06-23','09:55:00',6.1),('16100','2013-06-23','10:00:00',3.44),('16100','2013-06-23','10:05:00',4.94),('16100','2013-06-23','10:10:00',3.67),('16100','2013-06-23','10:15:00',4.87),('16100','2013-06-23','10:20:00',5.58),('16100','2013-06-23','10:25:00',6.26),('16100','2013-06-23','10:30:00',4.02),('16100','2013-06-23','10:35:00',6.83),('16100','2013-06-23','10:40:00',4.12),('16100','2013-06-23','10:45:00',7.19),('16100','2013-06-23','10:50:00',6.79),('16100','2013-06-23','10:55:00',7.4),('16100','2013-06-23','11:00:00',3.18),('16100','2013-06-23','11:05:00',5.12),('16100','2013-06-23','11:10:00',3.04),('16100','2013-06-23','11:15:00',6.42),('16100','2013-06-23','11:20:00',3.89),('16100','2013-06-23','11:25:00',3.18),('16100','2013-06-23','11:30:00',3.71),('16100','2013-06-23','11:35:00',2.34),('16100','2013-06-23','11:40:00',3.33),('16100','2013-06-23','11:45:00',3.77),('16100','2013-06-23','11:50:00',4.45),('16100','2013-06-23','11:55:00',8.84),('16100','2013-06-23','12:00:00',8.07),('16100','2013-06-23','12:05:00',3.45),('16100','2013-06-23','12:10:00',7.61),('16100','2013-06-23','12:15:00',5.45),('16100','2013-06-23','12:20:00',6.62),('16100','2013-06-23','12:25:00',3.34),('16100','2013-06-23','12:30:00',2.1),('16100','2013-06-23','12:35:00',2.41),('16100','2013-06-23','12:40:00',8.87),('16100','2013-06-23','12:45:00',2.94),('16100','2013-06-23','12:50:00',4.75),('16100','2013-06-23','12:55:00',5.63),('16100','2013-06-23','13:00:00',5.19),('16100','2013-06-23','13:05:00',3.75),('16100','2013-06-23','13:10:00',4.95),('16100','2013-06-23','13:15:00',6.38),('16100','2013-06-23','13:20:00',7.11),('16100','2013-06-23','13:25:00',8.95),('16100','2013-06-23','13:30:00',8.66),('16100','2013-06-23','13:35:00',8.83),('16100','2013-06-23','13:40:00',8.33),('16100','2013-06-23','13:45:00',8.46),('16100','2013-06-23','13:50:00',8.27),('16100','2013-06-23','13:55:00',6.79),('16100','2013-06-23','14:00:00',8.22),('16100','2013-06-23','14:05:00',8.08),('16100','2013-06-23','14:10:00',8.05),('16100','2013-06-23','14:15:00',8.09),('16100','2013-06-23','14:20:00',7.29),('16100','2013-06-23','14:25:00',6.43),('16100','2013-06-23','14:30:00',7.33),('16100','2013-06-23','14:35:00',6.76),('16100','2013-06-23','14:40:00',7.45),('16100','2013-06-23','14:45:00',8.5),('16100','2013-06-23','14:50:00',4.77),('16100','2013-06-23','14:55:00',3.66),('16100','2013-06-23','15:00:00',3.77),('16100','2013-06-23','15:05:00',2.53),('16100','2013-06-23','15:10:00',5.74),('16100','2013-06-23','15:15:00',7.6),('16100','2013-06-23','15:20:00',3.91),('16100','2013-06-23','15:25:00',2.05),('16100','2013-06-23','15:30:00',6.47),('16100','2013-06-23','15:35:00',6.02),('16100','2013-06-23','15:40:00',6.16),('16100','2013-06-23','15:45:00',4.15),('16100','2013-06-23','15:50:00',4.63),('16100','2013-06-23','15:55:00',3.22),('16100','2013-06-23','16:00:00',6.46),('16100','2013-06-23','16:05:00',2.97),('16100','2013-06-23','16:10:00',5.74),('16100','2013-06-23','16:15:00',7.08),('16100','2013-06-23','16:20:00',5.4),('16100','2013-06-23','16:25:00',4.92),('16100','2013-06-23','16:30:00',3.74),('16100','2013-06-23','16:35:00',5.01),('16100','2013-06-23','16:40:00',4.29),('16100','2013-06-23','16:45:00',2.09),('16100','2013-06-23','16:50:00',1.9),('16100','2013-06-23','16:55:00',1.74),('16100','2013-06-23','17:00:00',2.02),('16100','2013-06-23','17:05:00',4.67),('16100','2013-06-23','17:10:00',3.47),('16100','2013-06-23','17:15:00',2.73),('16100','2013-06-23','17:20:00',2.37),('16100','2013-06-23','17:25:00',3.24),('16100','2013-06-23','17:30:00',1.93),('16100','2013-06-23','17:35:00',2),('16100','2013-06-23','17:40:00',1.68),('16100','2013-06-23','17:45:00',2.77),('16100','2013-06-23','17:50:00',1.48),('16100','2013-06-23','17:55:00',1.63),('16100','2013-06-23','18:00:00',3.1),('16100','2013-06-23','18:05:00',2.42),('16100','2013-06-23','18:10:00',1.77),('16100','2013-06-23','18:15:00',1.15),('16100','2013-06-23','18:20:00',2.69),('16100','2013-06-23','18:25:00',2.25),('16100','2013-06-23','18:30:00',2),('16100','2013-06-23','18:35:00',1.68),('16100','2013-06-23','18:40:00',1.7),('16100','2013-06-23','18:45:00',1.49),('16100','2013-06-23','18:50:00',1.34),('16100','2013-06-23','18:55:00',1.23),('16100','2013-06-23','19:00:00',1.04),('16100','2013-06-22','08:35:00',1.04),('16100','2013-06-22','08:40:00',1.27),('16100','2013-06-22','08:45:00',1.34),('16100','2013-06-22','08:50:00',1.9),('16100','2013-06-22','08:55:00',1.87),('16100','2013-06-22','09:00:00',1.52),('16100','2013-06-22','09:05:00',1.1),('16100','2013-06-22','09:10:00',1.93),('16100','2013-06-22','09:15:00',3.44),('16100','2013-06-22','09:20:00',4.51),('16100','2013-06-22','09:25:00',4.64),('16100','2013-06-22','09:30:00',4.72),('16100','2013-06-22','09:35:00',3.1),('16100','2013-06-22','09:40:00',2.23),('16100','2013-06-22','09:45:00',2.97),('16100','2013-06-22','09:50:00',5.45),('16100','2013-06-22','09:55:00',5.39),('16100','2013-06-22','10:00:00',5.42),('16100','2013-06-22','10:05:00',5.6),('16100','2013-06-22','10:10:00',2.49),('16100','2013-06-22','10:15:00',5.86),('16100','2013-06-22','10:20:00',6.11),('16100','2013-06-22','10:25:00',6.02),('16100','2013-06-22','10:30:00',6.13),('16100','2013-06-22','10:35:00',6.19),('16100','2013-06-22','10:40:00',6.22),('16100','2013-06-22','10:45:00',6.33),('16100','2013-06-22','10:50:00',6.37),('16100','2013-06-22','10:55:00',6.48),('16100','2013-06-22','11:00:00',6.62),('16100','2013-06-22','11:05:00',6.62),('16100','2013-06-22','11:10:00',6.74),('16100','2013-06-22','11:15:00',6.74),('16100','2013-06-22','11:20:00',6.7),('16100','2013-06-22','11:25:00',6.86),('16100','2013-06-22','11:30:00',6.98),('16100','2013-06-22','11:35:00',7.1),('16100','2013-06-22','11:40:00',7.17),('16100','2013-06-22','11:45:00',7.17),('16100','2013-06-22','11:50:00',7.21),('16100','2013-06-22','11:55:00',7.2),('16100','2013-06-22','12:00:00',7.28),('16100','2013-06-22','12:05:00',7.28),('16100','2013-06-22','12:10:00',7.52),('16100','2013-06-22','12:15:00',7.56),('16100','2013-06-22','12:20:00',7.57),('16100','2013-06-22','12:25:00',7.61),('16100','2013-06-22','12:30:00',7.61),('16100','2013-06-22','12:35:00',7.62),('16100','2013-06-22','12:40:00',7.72),('16100','2013-06-22','12:45:00',7.74),('16100','2013-06-22','12:50:00',7.73),('16100','2013-06-22','12:55:00',7.76),('16100','2013-06-22','13:00:00',7.8),('16100','2013-06-22','13:05:00',7.81),('16100','2013-06-22','13:10:00',7.78),('16100','2013-06-22','13:15:00',7.76),('16100','2013-06-22','13:20:00',7.78),('16100','2013-06-22','13:25:00',7.77),('16100','2013-06-22','13:30:00',7.79),('16100','2013-06-22','13:35:00',7.84),('16100','2013-06-22','13:40:00',7.84),('16100','2013-06-22','13:45:00',7.83),('16100','2013-06-22','13:50:00',7.84),('16100','2013-06-22','13:55:00',7.88),('16100','2013-06-22','14:00:00',7.86),('16100','2013-06-22','14:05:00',7.77),('16100','2013-06-22','14:10:00',7.64),('16100','2013-06-22','14:15:00',7.72),('16100','2013-06-22','14:20:00',7.65),('16100','2013-06-22','14:25:00',7.62),('16100','2013-06-22','14:30:00',7.63),('16100','2013-06-22','14:35:00',7.6),('16100','2013-06-22','14:40:00',7.52),('16100','2013-06-22','14:45:00',7.5),('16100','2013-06-22','14:50:00',7.44),('16100','2013-06-22','14:55:00',7.42),('16100','2013-06-22','15:00:00',7.31),('16100','2013-06-22','15:05:00',7.2),('16100','2013-06-22','15:10:00',7.11),('16100','2013-06-22','15:15:00',7.05),('16100','2013-06-22','15:20:00',6.87),('16100','2013-06-22','15:25:00',6.85),('16100','2013-06-22','15:30:00',6.8),('16100','2013-06-22','15:35:00',6.64),('16100','2013-06-22','15:40:00',6.59),('16100','2013-06-22','15:45:00',6.49),('16100','2013-06-22','15:50:00',6.4),('16100','2013-06-22','15:55:00',6.29),('16100','2013-06-22','16:00:00',6.21),('16100','2013-06-22','16:05:00',6.12),('16100','2013-06-22','16:10:00',5.99),('16100','2013-06-22','16:15:00',5.9),('16100','2013-06-22','16:20:00',5.73),('16100','2013-06-22','16:25:00',5.6),('16100','2013-06-22','16:30:00',5.47),('16100','2013-06-22','16:35:00',5.35),('16100','2013-06-22','16:40:00',5.24),('16100','2013-06-22','16:45:00',5.11),('16100','2013-06-22','16:50:00',5.03),('16100','2013-06-22','16:55:00',4.9),('16100','2013-06-22','17:00:00',4.8),('16100','2013-06-22','17:05:00',4.69),('16100','2013-06-22','17:10:00',3.79),('16100','2013-06-22','17:15:00',4.45),('16100','2013-06-22','17:20:00',4.25),('16100','2013-06-22','17:25:00',4.1),('16100','2013-06-22','17:30:00',3.95),('16100','2013-06-22','17:35:00',3.77),('16100','2013-06-22','17:40:00',3.62),('16100','2013-06-22','17:45:00',3.36),('16100','2013-06-22','17:50:00',3.33),('16100','2013-06-22','17:55:00',3.14),('16100','2013-06-22','18:00:00',2.93),('16100','2013-06-22','18:05:00',2.77),('16100','2013-06-22','18:10:00',2.58),('16100','2013-06-22','18:15:00',2.29),('16100','2013-06-22','18:20:00',2.19),('16100','2013-06-22','18:25:00',2.06),('16100','2013-06-22','18:30:00',1.89),('16100','2013-06-22','18:35:00',1.73),('16100','2013-06-22','18:40:00',1.55),('16100','2013-06-22','18:45:00',1.41),('16100','2013-06-22','18:50:00',1.28),('16100','2013-06-22','18:55:00',1.16),('16100','2013-06-22','19:00:00',1.12),('16100','2013-06-21','07:50:00',1.02),('16100','2013-06-21','07:55:00',1.22),('16100','2013-06-21','08:00:00',1.41),('16100','2013-06-21','08:05:00',1.53),('16100','2013-06-21','08:10:00',1.72),('16100','2013-06-21','08:15:00',1.95),('16100','2013-06-21','08:20:00',2.09),('16100','2013-06-21','08:25:00',2.23),('16100','2013-06-21','08:30:00',2.43),('16100','2013-06-21','08:35:00',2.59),('16100','2013-06-21','08:40:00',2.74),('16100','2013-06-21','08:45:00',2.95),('16100','2013-06-21','08:50:00',3.09),('16100','2013-06-21','08:55:00',3.18),('16100','2013-06-21','09:00:00',3.21),('16100','2013-06-21','09:05:00',3.42),('16100','2013-06-21','09:10:00',3.59),('16100','2013-06-21','09:15:00',3.85),('16100','2013-06-21','09:20:00',4.19),('16100','2013-06-21','09:25:00',4.31),('16100','2013-06-21','09:30:00',4.43),('16100','2013-06-21','09:35:00',4.57),('16100','2013-06-21','09:40:00',4.69),('16100','2013-06-21','09:45:00',4.82),('16100','2013-06-21','09:50:00',4.95),('16100','2013-06-21','09:55:00',5.06),('16100','2013-06-21','10:00:00',5.23),('16100','2013-06-21','10:05:00',5.39),('16100','2013-06-21','10:10:00',5.56),('16100','2013-06-21','10:15:00',5.68),('16100','2013-06-21','10:20:00',5.84),('16100','2013-06-21','10:25:00',5.87),('16100','2013-06-21','10:30:00',5.95),('16100','2013-06-21','10:35:00',6.01),('16100','2013-06-21','10:40:00',6.14),('16100','2013-06-21','10:45:00',6.22),('16100','2013-06-21','10:50:00',6.31),('16100','2013-06-21','10:55:00',6.46),('16100','2013-06-21','11:00:00',6.56),('16100','2013-06-21','11:05:00',6.6),('16100','2013-06-21','11:10:00',6.65),('16100','2013-06-21','11:15:00',6.76),('16100','2013-06-21','11:20:00',6.82),('16100','2013-06-21','11:25:00',6.87),('16100','2013-06-21','11:30:00',6.93),('16100','2013-06-21','11:35:00',6.97),('16100','2013-06-21','11:40:00',7.06),('16100','2013-06-21','11:45:00',7.05),('16100','2013-06-21','11:50:00',7.13),('16100','2013-06-21','11:55:00',7.03),('16100','2013-06-21','12:00:00',7.22),('16100','2013-06-21','12:05:00',7.25),('16100','2013-06-21','12:10:00',7.28),('16100','2013-06-21','12:15:00',7.37),('16100','2013-06-21','12:20:00',7.38),('16100','2013-06-21','12:25:00',7.46),('16100','2013-06-21','12:30:00',7.44),('16100','2013-06-21','12:35:00',6.79),('16100','2013-06-21','12:40:00',7.09),('16100','2013-06-21','12:45:00',7.34),('16100','2013-06-21','12:50:00',7.36),('16100','2013-06-21','12:55:00',7.31),('16100','2013-06-21','13:00:00',7.16),('16100','2013-06-21','13:05:00',7.37),('16100','2013-06-21','13:10:00',7.24),('16100','2013-06-21','13:15:00',7.64),('16100','2013-06-21','13:20:00',7.61),('16100','2013-06-21','13:25:00',7.68),('16100','2013-06-21','13:30:00',7.76),('16100','2013-06-21','13:35:00',7.47),('16100','2013-06-21','13:40:00',6.86),('16100','2013-06-21','13:45:00',7.69),('16100','2013-06-21','13:50:00',6.94),('16100','2013-06-21','13:55:00',5.94),('16100','2013-06-21','14:00:00',7.96),('16100','2013-06-21','14:05:00',8.03),('16100','2013-06-21','14:10:00',7.82),('16100','2013-06-21','14:15:00',6.05),('16100','2013-06-21','14:20:00',4.25),('16100','2013-06-21','14:25:00',6.35),('16100','2013-06-21','14:30:00',4.28),('16100','2013-06-21','14:35:00',3.21),('16100','2013-06-21','14:40:00',4.39),('16100','2013-06-21','14:45:00',5.66),('16100','2013-06-21','14:50:00',7.12),('16100','2013-06-21','14:55:00',6.85),('16100','2013-06-21','15:00:00',7.25),('16100','2013-06-21','15:05:00',6.45),('16100','2013-06-21','15:10:00',7.22),('16100','2013-06-21','15:15:00',7.07),('16100','2013-06-21','15:20:00',7.12),('16100','2013-06-21','15:25:00',6.57),('16100','2013-06-21','15:30:00',6.17),('16100','2013-06-21','15:35:00',4.99),('16100','2013-06-21','15:40:00',4.12),('16100','2013-06-21','15:45:00',3.27),('16100','2013-06-21','15:50:00',3.14),('16100','2013-06-21','15:55:00',3.92),('16100','2013-06-21','16:00:00',2.52),('16100','2013-06-21','16:05:00',2),('16100','2013-06-21','16:10:00',2.18),('16100','2013-06-21','16:15:00',2.78),('16100','2013-06-21','16:20:00',2.32),('16100','2013-06-21','16:25:00',2.06),('16100','2013-06-21','16:30:00',1.81),('16100','2013-06-21','16:35:00',1.58),('16100','2013-06-21','16:40:00',1.42),('16100','2013-06-21','16:45:00',1.39),('16100','2013-06-21','16:50:00',1.68),('16100','2013-06-21','16:55:00',2.51),('16100','2013-06-21','17:00:00',3.74),('16100','2013-06-21','17:05:00',4.18),('16100','2013-06-21','17:10:00',4.76),('16100','2013-06-21','17:15:00',3.87),('16100','2013-06-21','17:20:00',4.23),('16100','2013-06-21','17:25:00',4.41),('16100','2013-06-21','17:30:00',3.89),('16100','2013-06-21','17:35:00',3.76),('16100','2013-06-21','17:40:00',3.44),('16100','2013-06-21','17:45:00',3.34),('16100','2013-06-21','17:50:00',2.81),('16100','2013-06-21','17:55:00',2.71),('16100','2013-06-21','18:00:00',2.51),('16100','2013-06-21','18:05:00',1.91),('16100','2013-06-21','18:10:00',1.2),('16100','2013-06-21','18:15:00',1.23),('16100','2013-06-21','18:20:00',1.07),('16100','2013-06-20','07:50:00',1.06),('16100','2013-06-20','08:00:00',1.43),('16100','2013-06-20','08:05:00',1.59),('16100','2013-06-20','08:10:00',1.76),('16100','2013-06-20','08:15:00',1.93),('16100','2013-06-20','08:20:00',2.06),('16100','2013-06-20','08:25:00',2.2),('16100','2013-06-20','08:30:00',2.35),('16100','2013-06-20','08:35:00',2.49),('16100','2013-06-20','08:40:00',2.63),('16100','2013-06-20','08:45:00',2.81),('16100','2013-06-20','08:50:00',2.37),('16100','2013-06-20','08:55:00',2.46),('16100','2013-06-20','09:00:00',3.18),('16100','2013-06-20','09:05:00',3.37),('16100','2013-06-20','09:10:00',3.49),('16100','2013-06-20','09:15:00',3.77),('16100','2013-06-20','09:20:00',4.05),('16100','2013-06-20','09:25:00',4.21),('16100','2013-06-20','09:30:00',4.33),('16100','2013-06-20','09:35:00',4.43),('16100','2013-06-20','09:40:00',3.61),('16100','2013-06-20','09:45:00',4.63),('16100','2013-06-20','09:50:00',4.72),('16100','2013-06-20','09:55:00',4.85),('16100','2013-06-20','10:00:00',4.99),('16100','2013-06-20','10:05:00',5.11),('16100','2013-06-20','10:10:00',5.28),('16100','2013-06-20','10:15:00',5.33),('16100','2013-06-20','10:20:00',5.32),('16100','2013-06-20','10:25:00',5.42),('16100','2013-06-20','10:30:00',5.5),('16100','2013-06-20','10:35:00',5.53),('16100','2013-06-20','10:40:00',5.62),('16100','2013-06-20','10:45:00',5.61),('16100','2013-06-20','10:50:00',5.78),('16100','2013-06-20','10:55:00',6.02),('16100','2013-06-20','11:00:00',6.07),('16100','2013-06-20','11:05:00',5.98),('16100','2013-06-20','11:10:00',6.06),('16100','2013-06-20','11:15:00',6.14),('16100','2013-06-20','11:20:00',6.27),('16100','2013-06-20','11:25:00',6.38),('16100','2013-06-20','11:30:00',6.49),('16100','2013-06-20','11:35:00',6.58),('16100','2013-06-20','11:40:00',6.65),('16100','2013-06-20','11:45:00',6.77),('16100','2013-06-20','11:50:00',6.82),('16100','2013-06-20','11:55:00',6.81),('16100','2013-06-20','12:00:00',6.79),('16100','2013-06-20','12:05:00',6.84),('16100','2013-06-20','12:10:00',6.92),('16100','2013-06-20','12:15:00',7.02),('16100','2013-06-20','12:20:00',7.05),('16100','2013-06-20','12:25:00',7.04),('16100','2013-06-20','12:30:00',7.17),('16100','2013-06-20','12:35:00',7.15),('16100','2013-06-20','12:40:00',7.22),('16100','2013-06-20','12:45:00',7.23),('16100','2013-06-20','12:50:00',7.19),('16100','2013-06-20','12:55:00',7.21),('16100','2013-06-20','13:00:00',7.31),('16100','2013-06-20','13:05:00',7.31),('16100','2013-06-20','13:10:00',7.23),('16100','2013-06-20','13:15:00',7.29),('16100','2013-06-20','13:20:00',7.32),('16100','2013-06-20','13:25:00',7.33),('16100','2013-06-20','13:30:00',7.34),('16100','2013-06-20','13:35:00',7.37),('16100','2013-06-20','13:40:00',7.39),('16100','2013-06-20','13:45:00',7.37),('16100','2013-06-20','13:50:00',7.42),('16100','2013-06-20','13:55:00',7.46),('16100','2013-06-20','14:00:00',7.4),('16100','2013-06-20','14:05:00',7.33),('16100','2013-06-20','14:10:00',7.22),('16100','2013-06-20','14:15:00',7.28),('16100','2013-06-20','14:20:00',7.3),('16100','2013-06-20','14:25:00',7.25),('16100','2013-06-20','14:30:00',7.23),('16100','2013-06-20','14:35:00',7.15),('16100','2013-06-20','14:40:00',7.09),('16100','2013-06-20','14:45:00',7.05),('16100','2013-06-20','14:50:00',6.95),('16100','2013-06-20','14:55:00',6.91),('16100','2013-06-20','15:00:00',6.9),('16100','2013-06-20','15:05:00',6.86),('16100','2013-06-20','15:10:00',6.81),('16100','2013-06-20','15:15:00',6.74),('16100','2013-06-20','15:20:00',6.64),('16100','2013-06-20','15:25:00',6.54),('16100','2013-06-20','15:30:00',6.44),('16100','2013-06-20','15:35:00',6.39),('16100','2013-06-20','15:40:00',6.29),('16100','2013-06-20','15:45:00',6.23),('16100','2013-06-20','15:50:00',6.15),('16100','2013-06-20','15:55:00',6.01),('16100','2013-06-20','16:00:00',5.91),('16100','2013-06-20','16:05:00',5.82),('16100','2013-06-20','16:10:00',5.71),('16100','2013-06-20','16:15:00',5.59),('16100','2013-06-20','16:20:00',5.46),('16100','2013-06-20','16:25:00',5.31),('16100','2013-06-20','16:30:00',5.24),('16100','2013-06-20','16:35:00',5.12),('16100','2013-06-20','16:40:00',5),('16100','2013-06-20','16:45:00',4.86),('16100','2013-06-20','16:50:00',4.74),('16100','2013-06-20','16:55:00',4.59),('16100','2013-06-20','17:00:00',4.46),('16100','2013-06-20','17:05:00',4.37),('16100','2013-06-20','17:10:00',4.25),('16100','2013-06-20','17:15:00',4.06),('16100','2013-06-20','17:20:00',3.95),('16100','2013-06-20','17:25:00',3.79),('16100','2013-06-20','17:30:00',3.64),('16100','2013-06-20','17:35:00',3.49),('16100','2013-06-20','17:40:00',3.33),('16100','2013-06-20','17:45:00',3.17),('16100','2013-06-20','17:50:00',3.04),('16100','2013-06-20','17:55:00',2.9),('16100','2013-06-20','18:00:00',2.72),('16100','2013-06-20','18:05:00',2.55),('16100','2013-06-20','18:10:00',2.32),('16100','2013-06-20','18:15:00',2.13),('16100','2013-06-20','18:20:00',2.02),('16100','2013-06-20','18:25:00',1.86),('16100','2013-06-20','18:30:00',1.71),('16100','2013-06-20','18:35:00',1.56),('16100','2013-06-20','18:40:00',1.41),('16100','2013-06-20','18:45:00',1.29),('16100','2013-06-20','18:50:00',1.15),('16100','2013-06-20','18:55:00',1.02),('16100','2014-04-03','08:50:00',1.02),('16100','2014-04-03','08:55:00',1.23),('16100','2014-04-03','09:00:00',1.51),('16100','2014-04-03','09:05:00',1.69),('16100','2014-04-03','09:10:00',2.03),('16100','2014-04-03','09:15:00',1.51),('16100','2014-04-03','10:25:00',1.02),('16100','2014-04-03','10:55:00',1.02),('16100','2014-04-03','11:00:00',1.8),('16100','2014-04-03','11:05:00',1.82),('16100','2014-04-03','12:35:00',1.14),('16100','2014-04-03','12:50:00',1.38),('16100','2014-04-03','12:55:00',1.38),('16100','2014-04-03','13:00:00',1.67),('16100','2014-04-03','13:05:00',4.64),('16100','2014-04-03','13:10:00',3.16),('16100','2014-04-03','13:15:00',2.38),('16100','2014-04-03','13:20:00',4.43),('16100','2014-04-03','13:25:00',3.75),('16100','2014-04-03','13:30:00',4.6),('16100','2014-04-03','13:35:00',5.71),('16100','2014-04-03','13:40:00',5.31),('16100','2014-04-03','13:45:00',6.39),('16100','2014-04-03','13:50:00',6.27),('16100','2014-04-03','13:55:00',3.29),('16100','2014-04-03','14:00:00',2.88),('16100','2014-04-03','14:05:00',8.2),('16100','2014-04-03','14:10:00',5.73),('16100','2014-04-03','14:15:00',5.72),('16100','2014-04-03','14:20:00',3.44),('16100','2014-04-03','14:25:00',2.41),('16100','2014-04-03','14:30:00',4.25),('16100','2014-04-03','14:35:00',3.96),('16100','2014-04-03','14:40:00',6.7),('16100','2014-04-03','14:45:00',1.96),('16100','2014-04-03','14:50:00',2.52),('16100','2014-04-03','14:55:00',4.9),('16100','2014-04-03','15:00:00',5.87),('16100','2014-04-03','15:05:00',3.03),('16100','2014-04-03','15:10:00',2.48),('16100','2014-04-03','15:15:00',2.27),('16100','2014-04-03','15:20:00',4.5),('16100','2014-04-03','15:25:00',4.16),('16100','2014-04-03','15:30:00',1.7),('16100','2014-04-03','15:35:00',1.74),('16100','2014-04-03','15:40:00',1.98),('16100','2014-04-03','15:45:00',2.29),('16100','2014-04-03','15:50:00',2.46),('16100','2014-04-03','15:55:00',3.67),('16100','2014-04-03','16:00:00',6.12),('16100','2014-04-03','16:05:00',5.64),('16100','2014-04-03','16:10:00',4.39),('16100','2014-04-03','16:15:00',6.74),('16100','2014-04-03','16:20:00',6.06),('16100','2014-04-03','16:25:00',2.6),('16100','2014-04-03','16:30:00',2.89),('16100','2014-04-03','16:35:00',4.87),('16100','2014-04-03','16:40:00',4.62),('16100','2014-04-03','16:45:00',2.6),('16100','2014-04-03','16:50:00',2.8),('16100','2014-04-03','16:55:00',3.74),('16100','2014-04-03','17:00:00',2.27),('16100','2014-04-03','17:05:00',1.84),('16100','2014-04-03','17:10:00',1.72),('16100','2014-04-03','17:15:00',2.55),('16100','2014-04-03','17:20:00',2.07),('16100','2014-04-03','17:25:00',3.75),('16100','2014-04-03','17:30:00',3.11),('16100','2014-04-03','17:35:00',2.8),('16100','2014-04-03','17:40:00',2.13),('16100','2014-04-03','17:45:00',1.25),('16100','2014-04-03','17:50:00',2.5),('16100','2014-04-03','17:55:00',2.07),('16100','2014-04-03','18:05:00',1.37),('16100','2014-04-03','18:10:00',1.26),('16100','2013-06-19','07:50:00',1.05),('16100','2013-06-19','07:55:00',1.23),('16100','2013-06-19','08:00:00',1.4),('16100','2013-06-19','08:05:00',1.58),('16100','2013-06-19','08:10:00',1.74),('16100','2013-06-19','08:15:00',1.89),('16100','2013-06-19','08:20:00',2.02),('16100','2013-06-19','08:25:00',2.2),('16100','2013-06-19','08:30:00',2.38),('16100','2013-06-19','08:35:00',2.52),('16100','2013-06-19','08:40:00',2.66),('16100','2013-06-19','08:45:00',2.9),('16100','2013-06-19','08:50:00',3.06),('16100','2013-06-19','08:55:00',3.2),('16100','2013-06-19','09:00:00',3.32),('16100','2013-06-19','09:05:00',3.49),('16100','2013-06-19','09:10:00',3.62),('16100','2013-06-19','09:15:00',3.89),('16100','2013-06-19','09:20:00',4.13),('16100','2013-06-19','09:25:00',4.24),('16100','2013-06-19','09:30:00',4.36),('16100','2013-06-19','09:35:00',4.54),('16100','2013-06-19','09:40:00',4.65),('16100','2013-06-19','09:45:00',4.8),('16100','2013-06-19','09:50:00',4.89),('16100','2013-06-19','09:55:00',5.01),('16100','2013-06-19','10:00:00',5.09),('16100','2013-06-19','10:05:00',5.22),('16100','2013-06-19','10:10:00',5.35),('16100','2013-06-19','10:15:00',5.43),('16100','2013-06-19','10:20:00',5.53),('16100','2013-06-19','10:25:00',5.64),('16100','2013-06-19','10:30:00',5.76),('16100','2013-06-19','10:35:00',5.88),('16100','2013-06-19','10:40:00',5.94),('16100','2013-06-19','10:45:00',6),('16100','2013-06-19','10:50:00',6.09),('16100','2013-06-19','10:55:00',6.16),('16100','2013-06-19','11:00:00',6.23),('16100','2013-06-19','11:05:00',6.29),('16100','2013-06-19','11:10:00',6.32),('16100','2013-06-19','11:15:00',6.37),('16100','2013-06-19','11:20:00',6.42),('16100','2013-06-19','11:25:00',5.23),('16100','2013-06-19','11:30:00',6.5),('16100','2013-06-19','11:35:00',6.59),('16100','2013-06-19','11:40:00',6.71),('16100','2013-06-19','11:45:00',6.76),('16100','2013-06-19','11:50:00',6.78),('16100','2013-06-19','11:55:00',6.72),('16100','2013-06-19','12:00:00',6.74),('16100','2013-06-19','12:05:00',6.8),('16100','2013-06-19','12:10:00',6.92),('16100','2013-06-19','12:15:00',7.03),('16100','2013-06-19','12:20:00',6.91),('16100','2013-06-19','12:25:00',6.97),('16100','2013-06-19','12:30:00',7.06),('16100','2013-06-19','12:35:00',7.13),('16100','2013-06-19','12:40:00',7.14),('16100','2013-06-19','12:45:00',7.05),('16100','2013-06-19','12:50:00',6.93),('16100','2013-06-19','12:55:00',6.96),('16100','2013-06-19','13:00:00',6.89),('16100','2013-06-19','13:05:00',7.1),('16100','2013-06-19','13:10:00',7.03),('16100','2013-06-19','13:15:00',7.34),('16100','2013-06-19','13:20:00',7.32),('16100','2013-06-19','13:25:00',7.26),('16100','2013-06-19','13:30:00',7.24),('16100','2013-06-19','13:35:00',7.44),('16100','2013-06-19','13:40:00',7.47),('16100','2013-06-19','13:45:00',7.53),('16100','2013-06-19','13:50:00',7.55),('16100','2013-06-19','13:55:00',7.56),('16100','2013-06-19','14:00:00',7.54),('16100','2013-06-19','14:05:00',7.51),('16100','2013-06-19','14:10:00',7.39),('16100','2013-06-19','14:15:00',7.42),('16100','2013-06-19','14:20:00',7.42),('16100','2013-06-19','14:25:00',7.37),('16100','2013-06-19','14:30:00',7.37),('16100','2013-06-19','14:35:00',7.33),('16100','2013-06-19','14:40:00',7.3),('16100','2013-06-19','14:45:00',7.22),('16100','2013-06-19','14:50:00',7.16),('16100','2013-06-19','14:55:00',7.12),('16100','2013-06-19','15:00:00',7),('16100','2013-06-19','15:05:00',6.91),('16100','2013-06-19','15:10:00',6.82),('16100','2013-06-19','15:15:00',6.78),('16100','2013-06-19','15:20:00',6.75),('16100','2013-06-19','15:25:00',6.64),('16100','2013-06-19','15:30:00',6.5),('16100','2013-06-19','15:35:00',6.41),('16100','2013-06-19','15:40:00',6.36),('16100','2013-06-19','15:45:00',6.25),('16100','2013-06-19','15:50:00',6.17),('16100','2013-06-19','15:55:00',6.06),('16100','2013-06-19','16:00:00',5.95),('16100','2013-06-19','16:05:00',5.84),('16100','2013-06-19','16:10:00',5.82),('16100','2013-06-19','16:15:00',5.68),('16100','2013-06-19','16:20:00',5.58),('16100','2013-06-19','16:25:00',5.41),('16100','2013-06-19','16:30:00',5.31),('16100','2013-06-19','16:35:00',5.19),('16100','2013-06-19','16:40:00',5.08),('16100','2013-06-19','16:45:00',4.95),('16100','2013-06-19','16:50:00',4.82),('16100','2013-06-19','16:55:00',4.7),('16100','2013-06-19','17:00:00',4.59),('16100','2013-06-19','17:05:00',4.46),('16100','2013-06-19','17:10:00',4.31),('16100','2013-06-19','17:15:00',4.14),('16100','2013-06-19','17:20:00',3.99),('16100','2013-06-19','17:25:00',3.85),('16100','2013-06-19','17:30:00',3.72),('16100','2013-06-19','17:35:00',3.57),('16100','2013-06-19','17:40:00',3.4),('16100','2013-06-19','17:45:00',3.25),('16100','2013-06-19','17:50:00',3.13),('16100','2013-06-19','17:55:00',2.98),('16100','2013-06-19','18:00:00',2.8),('16100','2013-06-19','18:05:00',2.63),('16100','2013-06-19','18:10:00',2.41),('16100','2013-06-19','18:15:00',2.19),('16100','2013-06-19','18:20:00',2.07),('16100','2013-06-19','18:25:00',1.91),('16100','2013-06-19','18:30:00',1.75),('16100','2013-06-19','18:35:00',1.6),('16100','2013-06-19','18:40:00',1.44),('16100','2013-06-19','18:45:00',1.3),('16100','2013-06-19','18:50:00',1.17),('16100','2013-06-19','18:55:00',1.02),('16100','2013-06-18','07:50:00',1.03),('16100','2013-06-18','07:55:00',1.24),('16100','2013-06-18','08:00:00',1.41),('16100','2013-06-18','08:05:00',1.59),('16100','2013-06-18','08:10:00',1.77),('16100','2013-06-18','08:15:00',1.95),('16100','2013-06-18','08:20:00',2.08),('16100','2013-06-18','08:25:00',2.22),('16100','2013-06-18','08:30:00',2.37),('16100','2013-06-18','08:35:00',2.5),('16100','2013-06-18','08:40:00',2.64),('16100','2013-06-18','08:45:00',2.84),('16100','2013-06-18','08:50:00',2.97),('16100','2013-06-18','08:55:00',3.12),('16100','2013-06-18','09:00:00',3.25),('16100','2013-06-18','09:05:00',3.39),('16100','2013-06-18','09:10:00',3.55),('16100','2013-06-18','09:15:00',3.8),('16100','2013-06-18','09:20:00',4.04),('16100','2013-06-18','09:25:00',4.16),('16100','2013-06-18','09:30:00',4.28),('16100','2013-06-18','09:35:00',4.39),('16100','2013-06-18','09:40:00',4.52),('16100','2013-06-18','09:45:00',4.63),('16100','2013-06-18','09:50:00',4.72),('16100','2013-06-18','09:55:00',4.82),('16100','2013-06-18','10:00:00',4.98),('16100','2013-06-18','10:05:00',5.1),('16100','2013-06-18','10:10:00',5.22),('16100','2013-06-18','10:15:00',5.32),('16100','2013-06-18','10:20:00',5.41),('16100','2013-06-18','10:25:00',5.48),('16100','2013-06-18','10:30:00',5.56),('16100','2013-06-18','10:35:00',5.63),('16100','2013-06-18','10:40:00',5.67),('16100','2013-06-18','10:45:00',5.76),('16100','2013-06-18','10:50:00',5.84),('16100','2013-06-18','10:55:00',5.91),('16100','2013-06-18','11:00:00',5.97),('16100','2013-06-18','11:05:00',6.03),('16100','2013-06-18','11:10:00',6.07),('16100','2013-06-18','11:15:00',6.17),('16100','2013-06-18','11:20:00',6.15),('16100','2013-06-18','11:25:00',6.32),('16100','2013-06-18','11:30:00',6.38),('16100','2013-06-18','11:35:00',6.52),('16100','2013-06-18','11:40:00',6.45),('16100','2013-06-18','11:45:00',6.47),('16100','2013-06-18','11:50:00',6.65),('16100','2013-06-18','11:55:00',6.71),('16100','2013-06-18','12:00:00',6.75),('16100','2013-06-18','12:05:00',6.96),('16100','2013-06-18','12:10:00',6.91),('16100','2013-06-18','12:15:00',6.88),('16100','2013-06-18','12:20:00',7.08),('16100','2013-06-18','12:25:00',7.1),('16100','2013-06-18','12:30:00',7.05),('16100','2013-06-18','12:35:00',7.22),('16100','2013-06-18','12:40:00',7.16),('16100','2013-06-18','12:45:00',7.2),('16100','2013-06-18','12:50:00',7.22),('16100','2013-06-18','12:55:00',7.23),('16100','2013-06-18','13:00:00',7.2),('16100','2013-06-18','13:05:00',7.25),('16100','2013-06-18','13:10:00',7.3),('16100','2013-06-18','13:15:00',7.34),('16100','2013-06-18','13:20:00',7.36),('16100','2013-06-18','13:25:00',7.38),('16100','2013-06-18','13:30:00',7.38),('16100','2013-06-18','13:35:00',7.37),('16100','2013-06-18','13:40:00',7.34),('16100','2013-06-18','13:45:00',7.36),('16100','2013-06-18','13:50:00',7.41),('16100','2013-06-18','13:55:00',7.4),('16100','2013-06-18','14:00:00',7.37),('16100','2013-06-18','14:05:00',7.32),('16100','2013-06-18','14:10:00',7.18),('16100','2013-06-18','14:15:00',7.27),('16100','2013-06-18','14:20:00',7.25),('16100','2013-06-18','14:25:00',7.15),('16100','2013-06-18','14:30:00',7.1),('16100','2013-06-18','14:35:00',7.03),('16100','2013-06-18','14:40:00',6.99),('16100','2013-06-18','14:45:00',6.93),('16100','2013-06-18','14:50:00',6.88),('16100','2013-06-18','14:55:00',6.84),('16100','2013-06-18','15:00:00',6.73),('16100','2013-06-18','15:05:00',6.64),('16100','2013-06-18','15:10:00',6.59),('16100','2013-06-18','15:15:00',6.5),('16100','2013-06-18','15:20:00',6.43),('16100','2013-06-18','15:25:00',6.36),('16100','2013-06-18','15:30:00',6.23),('16100','2013-06-18','15:35:00',6.14),('16100','2013-06-18','15:40:00',6.08),('16100','2013-06-18','15:45:00',6.01),('16100','2013-06-18','15:50:00',5.95),('16100','2013-06-18','15:55:00',5.83),('16100','2013-06-18','16:00:00',5.71),('16100','2013-06-18','16:05:00',5.62),('16100','2013-06-18','16:10:00',5.54),('16100','2013-06-18','16:15:00',5.45),('16100','2013-06-18','16:20:00',5.32),('16100','2013-06-18','16:25:00',5.16),('16100','2013-06-18','16:30:00',5.05),('16100','2013-06-18','16:35:00',4.98),('16100','2013-06-18','16:40:00',4.87),('16100','2013-06-18','16:45:00',4.76),('16100','2013-06-18','16:50:00',4.65),('16100','2013-06-18','16:55:00',4.53),('16100','2013-06-18','17:00:00',4.43),('16100','2013-06-18','17:05:00',4.28),('16100','2013-06-18','17:10:00',4.12),('16100','2013-06-18','17:15:00',3.92),('16100','2013-06-18','17:20:00',3.83),('16100','2013-06-18','17:25:00',3.7),('16100','2013-06-18','17:30:00',3.55),('16100','2013-06-18','17:35:00',3.41),('16100','2013-06-18','17:40:00',3.29),('16100','2013-06-18','17:45:00',3.12),('16100','2013-06-18','17:50:00',2.97),('16100','2013-06-18','17:55:00',2.85),('16100','2013-06-18','18:00:00',2.68),('16100','2013-06-18','18:05:00',2.49),('16100','2013-06-18','18:10:00',2.26),('16100','2013-06-18','18:15:00',2.09),('16100','2013-06-18','18:20:00',1.99),('16100','2013-06-18','18:25:00',1.85),('16100','2013-06-18','18:30:00',1.7),('16100','2013-06-18','18:35:00',1.55),('16100','2013-06-18','18:40:00',1.41),('16100','2013-06-18','18:45:00',1.27),('16100','2013-06-18','18:50:00',1.12),('16100','2013-06-17','07:55:00',1.21),('16100','2013-06-17','08:00:00',1.37),('16100','2013-06-17','08:05:00',1.54),('16100','2013-06-17','08:10:00',1.72),('16100','2013-06-17','08:15:00',1.88),('16100','2013-06-17','08:20:00',2.01),('16100','2013-06-17','08:25:00',2.16),('16100','2013-06-17','08:30:00',2.33),('16100','2013-06-17','08:35:00',2.47),('16100','2013-06-17','08:40:00',2.62),('16100','2013-06-17','08:45:00',2.82),('16100','2013-06-17','08:50:00',2.96),('16100','2013-06-17','08:55:00',3.1),('16100','2013-06-17','09:00:00',3.23),('16100','2013-06-17','09:05:00',3.4),('16100','2013-06-17','09:10:00',3.55),('16100','2013-06-17','09:15:00',3.82),('16100','2013-06-17','09:20:00',4.05),('16100','2013-06-17','09:25:00',4.16),('16100','2013-06-17','09:30:00',4.25),('16100','2013-06-17','09:35:00',4.4),('16100','2013-06-17','09:40:00',4.49),('16100','2013-06-17','09:45:00',4.61),('16100','2013-06-17','09:50:00',4.7),('16100','2013-06-17','09:55:00',4.8),('16100','2013-06-17','10:00:00',4.93),('16100','2013-06-17','10:05:00',5.06),('16100','2013-06-17','10:10:00',5.17),('16100','2013-06-17','10:15:00',5.27),('16100','2013-06-17','10:20:00',5.37),('16100','2013-06-17','10:25:00',5.51),('16100','2013-06-17','10:30:00',5.57),('16100','2013-06-17','10:35:00',5.66),('16100','2013-06-17','10:40:00',5.77),('16100','2013-06-17','10:45:00',5.86),('16100','2013-06-17','10:50:00',5.94),('16100','2013-06-17','10:55:00',6.01),('16100','2013-06-17','11:00:00',6.12),('16100','2013-06-17','11:05:00',6.14),('16100','2013-06-17','11:10:00',6.19),('16100','2013-06-17','11:15:00',6.29),('16100','2013-06-17','11:20:00',6.33),('16100','2013-06-17','11:25:00',6.37),('16100','2013-06-17','11:30:00',6.45),('16100','2013-06-17','11:35:00',6.47),('16100','2013-06-17','11:40:00',6.49),('16100','2013-06-17','11:45:00',6.58),('16100','2013-06-17','11:50:00',6.54),('16100','2013-06-17','11:55:00',6.52),('16100','2013-06-17','12:00:00',6.59),('16100','2013-06-17','12:05:00',6.56),('16100','2013-06-17','12:10:00',6.58),('16100','2013-06-17','12:15:00',6.54),('16100','2013-06-17','12:20:00',6.5),('16100','2013-06-17','12:25:00',6.66),('16100','2013-06-17','12:30:00',6.83),('16100','2013-06-17','12:35:00',6.84),('16100','2013-06-17','12:40:00',6.9),('16100','2013-06-17','12:45:00',6.77),('16100','2013-06-17','12:50:00',6.94),('16100','2013-06-17','12:55:00',6.79),('16100','2013-06-17','13:00:00',6.55),('16100','2013-06-17','13:05:00',6.4),('16100','2013-06-17','13:10:00',7.13),('16100','2013-06-17','13:15:00',7.19),('16100','2013-06-17','13:20:00',5.5),('16100','2013-06-17','13:25:00',7.21),('16100','2013-06-17','13:30:00',6.36),('16100','2013-06-17','13:35:00',6.04),('16100','2013-06-17','13:40:00',7.11),('16100','2013-06-17','13:45:00',7.21),('16100','2013-06-17','13:50:00',7.15),('16100','2013-06-17','13:55:00',7.28),('16100','2013-06-17','14:00:00',7.21),('16100','2013-06-17','14:05:00',7.27),('16100','2013-06-17','14:10:00',7.21),('16100','2013-06-17','14:15:00',7.17),('16100','2013-06-17','14:20:00',7.25),('16100','2013-06-17','14:25:00',7.01),('16100','2013-06-17','14:30:00',7.14),('16100','2013-06-17','14:35:00',7.04),('16100','2013-06-17','14:40:00',4.46),('16100','2013-06-17','14:45:00',6.67),('16100','2013-06-17','14:50:00',7.08),('16100','2013-06-17','14:55:00',7),('16100','2013-06-17','15:00:00',6.87),('16100','2013-06-17','15:05:00',6.71),('16100','2013-06-17','15:10:00',6.67),('16100','2013-06-17','15:15:00',6.6),('16100','2013-06-17','15:20:00',6.43),('16100','2013-06-17','15:25:00',6.32),('16100','2013-06-17','15:30:00',6.19),('16100','2013-06-17','15:35:00',6.14),('16100','2013-06-17','15:40:00',6.09),('16100','2013-06-17','15:45:00',6.02),('16100','2013-06-17','15:50:00',5.96),('16100','2013-06-17','15:55:00',5.86),('16100','2013-06-17','16:00:00',5.81),('16100','2013-06-17','16:05:00',5.81),('16100','2013-06-17','16:10:00',5.73),('16100','2013-06-17','16:15:00',5.17),('16100','2013-06-17','16:20:00',5.62),('16100','2013-06-17','16:25:00',5.38),('16100','2013-06-17','16:30:00',5.08),('16100','2013-06-17','16:35:00',3.67),('16100','2013-06-17','16:40:00',3.63),('16100','2013-06-17','16:45:00',4.83),('16100','2013-06-17','16:50:00',4.74),('16100','2013-06-17','16:55:00',4.5),('16100','2013-06-17','17:00:00',4.48),('16100','2013-06-17','17:05:00',4.34),('16100','2013-06-17','17:10:00',4.17),('16100','2013-06-17','17:15:00',4.01),('16100','2013-06-17','17:20:00',3.89),('16100','2013-06-17','17:25:00',3.75),('16100','2013-06-17','17:30:00',3.59),('16100','2013-06-17','17:35:00',3.44),('16100','2013-06-17','17:40:00',3.26),('16100','2013-06-17','17:45:00',3.1),('16100','2013-06-17','17:50:00',2.97),('16100','2013-06-17','17:55:00',2.82),('16100','2013-06-17','18:00:00',2.68),('16100','2013-06-17','18:05:00',2.52),('16100','2013-06-17','18:10:00',2.31),('16100','2013-06-17','18:15:00',2.09),('16100','2013-06-17','18:20:00',2.03),('16100','2013-06-17','18:25:00',1.9),('16100','2013-06-17','18:30:00',1.75),('16100','2013-06-17','18:35:00',1.59),('16100','2013-06-17','18:40:00',1.45),('16100','2013-06-17','18:45:00',1.31),('16100','2013-06-17','18:50:00',1.17),('16100','2013-06-17','18:55:00',1.04),('16100','2013-06-16','07:50:00',1.09),('16100','2013-06-16','07:55:00',1.29),('16100','2013-06-16','08:00:00',1.48),('16100','2013-06-16','08:05:00',1.66),('16100','2013-06-16','08:10:00',1.84),('16100','2013-06-16','08:15:00',2.01),('16100','2013-06-16','08:20:00',2.15),('16100','2013-06-16','08:25:00',2.31),('16100','2013-06-16','08:30:00',2.49),('16100','2013-06-16','08:35:00',2.64),('16100','2013-06-16','08:40:00',2.81),('16100','2013-06-16','08:45:00',2.99),('16100','2013-06-16','08:50:00',3.13),('16100','2013-06-16','08:55:00',3.25),('16100','2013-06-16','09:00:00',3.36),('16100','2013-06-16','09:05:00',3.52),('16100','2013-06-16','09:10:00',3.71),('16100','2013-06-16','09:15:00',4.01),('16100','2013-06-16','09:20:00',4.25),('16100','2013-06-16','09:25:00',4.38),('16100','2013-06-16','09:30:00',4.52),('16100','2013-06-16','09:35:00',4.64),('16100','2013-06-16','09:40:00',4.75),('16100','2013-06-16','09:45:00',4.88),('16100','2013-06-16','09:50:00',4.98),('16100','2013-06-16','09:55:00',5.08),('16100','2013-06-16','10:00:00',5.22),('16100','2013-06-16','10:05:00',5.34),('16100','2013-06-16','10:10:00',5.48),('16100','2013-06-16','10:15:00',5.57),('16100','2013-06-16','10:20:00',5.67),('16100','2013-06-16','10:25:00',5.76),('16100','2013-06-16','10:30:00',5.85),('16100','2013-06-16','10:35:00',5.93),('16100','2013-06-16','10:40:00',5.98),('16100','2013-06-16','10:45:00',6.05),('16100','2013-06-16','10:50:00',6.17),('16100','2013-06-16','10:55:00',6.25),('16100','2013-06-16','11:00:00',6.35),('16100','2013-06-16','11:05:00',6.39),('16100','2013-06-16','11:10:00',6.48),('16100','2013-06-16','11:15:00',6.5),('16100','2013-06-16','11:20:00',6.58),('16100','2013-06-16','11:25:00',6.63),('16100','2013-06-16','11:30:00',6.69),('16100','2013-06-16','11:35:00',6.74),('16100','2013-06-16','11:40:00',6.78),('16100','2013-06-16','11:45:00',6.77),('16100','2013-06-16','11:50:00',6.8),('16100','2013-06-16','11:55:00',6.77),('16100','2013-06-16','12:00:00',6.93),('16100','2013-06-16','12:05:00',6.94),('16100','2013-06-16','12:10:00',7.11),('16100','2013-06-16','12:15:00',7.13),('16100','2013-06-16','12:20:00',7.24),('16100','2013-06-16','12:25:00',7.36),('16100','2013-06-16','12:30:00',7.3),('16100','2013-06-16','12:35:00',7.31),('16100','2013-06-16','12:40:00',7.37),('16100','2013-06-16','12:45:00',7.38),('16100','2013-06-16','12:50:00',7.44),('16100','2013-06-16','12:55:00',7.45),('16100','2013-06-16','13:00:00',7.47),('16100','2013-06-16','13:05:00',7.47),('16100','2013-06-16','13:10:00',7.51),('16100','2013-06-16','13:15:00',7.44),('16100','2013-06-16','13:20:00',7.43),('16100','2013-06-16','13:25:00',7.39),('16100','2013-06-16','13:30:00',7.4),('16100','2013-06-16','13:35:00',7.36),('16100','2013-06-16','13:40:00',7.36),('16100','2013-06-16','13:45:00',7.34),('16100','2013-06-16','13:50:00',7.28),('16100','2013-06-16','13:55:00',7.3),('16100','2013-06-16','14:00:00',7.31),('16100','2013-06-16','14:05:00',7.24),('16100','2013-06-16','14:10:00',7.13),('16100','2013-06-16','14:15:00',7.22),('16100','2013-06-16','14:20:00',7.2),('16100','2013-06-16','14:25:00',7.19),('16100','2013-06-16','14:30:00',7.12),('16100','2013-06-16','14:35:00',7.04),('16100','2013-06-16','14:40:00',7.02),('16100','2013-06-16','14:45:00',6.94),('16100','2013-06-16','14:50:00',6.88),('16100','2013-06-16','14:55:00',6.86),('16100','2013-06-16','15:00:00',6.78),('16100','2013-06-16','15:05:00',6.71),('16100','2013-06-16','15:10:00',6.65),('16100','2013-06-16','15:15:00',6.6),('16100','2013-06-16','15:20:00',6.52),('16100','2013-06-16','15:25:00',6.44),('16100','2013-06-16','15:30:00',6.37),('16100','2013-06-16','15:35:00',6.32),('16100','2013-06-16','15:40:00',6.22),('16100','2013-06-16','15:45:00',6.15),('16100','2013-06-16','15:50:00',6.07),('16100','2013-06-16','15:55:00',5.99),('16100','2013-06-16','16:00:00',5.87),('16100','2013-06-16','16:05:00',5.75),('16100','2013-06-16','16:10:00',5.65),('16100','2013-06-16','16:15:00',5.56),('16100','2013-06-16','16:20:00',5.44),('16100','2013-06-16','16:25:00',5.26),('16100','2013-06-16','16:30:00',5.24),('16100','2013-06-16','16:35:00',5.11),('16100','2013-06-16','16:40:00',4.98),('16100','2013-06-16','16:45:00',4.86),('16100','2013-06-16','16:50:00',4.75),('16100','2013-06-16','16:55:00',4.65),('16100','2013-06-16','17:00:00',4.53),('16100','2013-06-16','17:05:00',4.4),('16100','2013-06-16','17:10:00',4.24),('16100','2013-06-16','17:15:00',4.08),('16100','2013-06-16','17:20:00',3.97),('16100','2013-06-16','17:25:00',3.87),('16100','2013-06-16','17:30:00',3.73),('16100','2013-06-16','17:35:00',3.6),('16100','2013-06-16','17:40:00',3.44),('16100','2013-06-16','17:45:00',3.29),('16100','2013-06-16','17:50:00',3.17),('16100','2013-06-16','17:55:00',3.02),('16100','2013-06-16','18:00:00',2.84),('16100','2013-06-16','18:05:00',2.67),('16100','2013-06-16','18:10:00',2.44),('16100','2013-06-16','18:15:00',2.21),('16100','2013-06-16','18:20:00',2.13),('16100','2013-06-16','18:25:00',2),('16100','2013-06-16','18:30:00',1.85),('16100','2013-06-16','18:35:00',1.62),('16100','2013-06-16','18:40:00',1.54),('16100','2013-06-16','18:45:00',1.41),('16100','2013-06-16','18:50:00',1.3),('16100','2013-06-16','18:55:00',1.2),('16100','2013-06-16','19:00:00',1.06),('16100','2013-06-15','07:50:00',1.08),('16100','2013-06-15','07:55:00',1.31),('16100','2013-06-15','08:00:00',1.49),('16100','2013-06-15','08:05:00',1.69),('16100','2013-06-15','08:10:00',1.89),('16100','2013-06-15','08:15:00',2.06),('16100','2013-06-15','08:20:00',2.19),('16100','2013-06-15','08:25:00',2.36),('16100','2013-06-15','08:30:00',2.55),('16100','2013-06-15','08:35:00',2.69),('16100','2013-06-15','08:40:00',2.83),('16100','2013-06-15','08:45:00',3),('16100','2013-06-15','08:50:00',3.17),('16100','2013-06-15','08:55:00',3.32),('16100','2013-06-15','09:00:00',3.45),('16100','2013-06-15','09:05:00',3.58),('16100','2013-06-15','09:10:00',3.77),('16100','2013-06-15','09:15:00',4.07),('16100','2013-06-15','09:20:00',4.29),('16100','2013-06-15','09:25:00',4.41),('16100','2013-06-15','09:30:00',4.57),('16100','2013-06-15','09:35:00',4.69),('16100','2013-06-15','09:40:00',4.8),('16100','2013-06-15','09:45:00',4.92),('16100','2013-06-15','09:50:00',4.98),('16100','2013-06-15','09:55:00',5.08),('16100','2013-06-15','10:00:00',5.21),('16100','2013-06-15','10:05:00',5.39),('16100','2013-06-15','10:10:00',5.5),('16100','2013-06-15','10:15:00',5.58),('16100','2013-06-15','10:20:00',5.67),('16100','2013-06-15','10:25:00',5.78),('16100','2013-06-15','10:30:00',5.9),('16100','2013-06-15','10:35:00',5.98),('16100','2013-06-15','10:40:00',6.06),('16100','2013-06-15','10:45:00',6.19),('16100','2013-06-15','10:50:00',6.24),('16100','2013-06-15','10:55:00',6.34),('16100','2013-06-15','11:00:00',6.47),('16100','2013-06-15','11:05:00',6.56),('16100','2013-06-15','11:10:00',6.72),('16100','2013-06-15','11:15:00',6.78),('16100','2013-06-15','11:20:00',6.82),('16100','2013-06-15','11:25:00',6.9),('16100','2013-06-15','11:30:00',6.95),('16100','2013-06-15','11:35:00',6.95),('16100','2013-06-15','11:40:00',7),('16100','2013-06-15','11:45:00',7.05),('16100','2013-06-15','11:50:00',7.06),('16100','2013-06-15','11:55:00',7.18),('16100','2013-06-15','12:00:00',7.18),('16100','2013-06-15','12:05:00',7.17),('16100','2013-06-15','12:10:00',7.23),('16100','2013-06-15','12:15:00',7.19),('16100','2013-06-15','12:20:00',7.3),('16100','2013-06-15','12:25:00',7.41),('16100','2013-06-15','12:30:00',7.44),('16100','2013-06-15','12:35:00',7.44),('16100','2013-06-15','12:40:00',7.52),('16100','2013-06-15','12:45:00',7.62),('16100','2013-06-15','12:50:00',7.6),('16100','2013-06-15','12:55:00',7.65),('16100','2013-06-15','13:00:00',7.7),('16100','2013-06-15','13:05:00',7.72),('16100','2013-06-15','13:10:00',7.63),('16100','2013-06-15','13:15:00',7.67),('16100','2013-06-15','13:20:00',7.71),('16100','2013-06-15','13:25:00',7.74),('16100','2013-06-15','13:30:00',7.73),('16100','2013-06-15','13:35:00',7.73),('16100','2013-06-15','13:40:00',7.71),('16100','2013-06-15','13:45:00',7.68),('16100','2013-06-15','13:50:00',7.64),('16100','2013-06-15','13:55:00',7.65),('16100','2013-06-15','14:00:00',7.64),('16100','2013-06-15','14:05:00',7.55),('16100','2013-06-15','14:10:00',7.38),('16100','2013-06-15','14:15:00',7.43),('16100','2013-06-15','14:20:00',7.38),('16100','2013-06-15','14:25:00',7.35),('16100','2013-06-15','14:30:00',7.31),('16100','2013-06-15','14:35:00',7.25),('16100','2013-06-15','14:40:00',7.19),('16100','2013-06-15','14:45:00',7.15),('16100','2013-06-15','14:50:00',7.12),('16100','2013-06-15','14:55:00',7.05),('16100','2013-06-15','15:00:00',7),('16100','2013-06-15','15:05:00',6.95),('16100','2013-06-15','15:10:00',6.91),('16100','2013-06-15','15:15:00',6.85),('16100','2013-06-15','15:20:00',6.74),('16100','2013-06-15','15:25:00',6.64),('16100','2013-06-15','15:30:00',6.55),('16100','2013-06-15','15:35:00',6.44),('16100','2013-06-15','15:40:00',6.35),('16100','2013-06-15','15:45:00',6.23),('16100','2013-06-15','15:50:00',6.14),('16100','2013-06-15','15:55:00',6.04),('16100','2013-06-15','16:00:00',6),('16100','2013-06-15','16:05:00',5.88),('16100','2013-06-15','16:10:00',5.75),('16100','2013-06-15','16:15:00',5.63),('16100','2013-06-15','16:20:00',5.5),('16100','2013-06-15','16:25:00',5.38),('16100','2013-06-15','16:30:00',5.28),('16100','2013-06-15','16:35:00',5.17),('16100','2013-06-15','16:40:00',5.05),('16100','2013-06-15','16:45:00',4.92),('16100','2013-06-15','16:50:00',4.8),('16100','2013-06-15','16:55:00',4.67),('16100','2013-06-15','17:00:00',4.53),('16100','2013-06-15','17:05:00',4.42),('16100','2013-06-15','17:10:00',4.28),('16100','2013-06-15','17:15:00',4.11),('16100','2013-06-15','17:20:00',3.97),('16100','2013-06-15','17:25:00',3.83),('16100','2013-06-15','17:30:00',3.69),('16100','2013-06-15','17:35:00',3.53),('16100','2013-06-15','17:40:00',3.36),('16100','2013-06-15','17:45:00',3.22),('16100','2013-06-15','17:50:00',3.08),('16100','2013-06-15','17:55:00',2.92),('16100','2013-06-15','18:00:00',2.75),('16100','2013-06-15','18:05:00',2.55),('16100','2013-06-15','18:10:00',2.34),('16100','2013-06-15','18:15:00',2.13),('16100','2013-06-15','18:20:00',2.03),('16100','2013-06-15','18:25:00',1.89),('16100','2013-06-15','18:30:00',1.73),('16100','2013-06-15','18:35:00',1.59),('16100','2013-06-15','18:40:00',1.43),('16100','2013-06-15','18:45:00',1.29),('16100','2013-06-15','18:50:00',1.17),('16100','2013-06-15','18:55:00',1.02),('16100','2013-06-14','07:50:00',1.12),('16100','2013-06-14','07:55:00',1.33),('16100','2013-06-14','08:00:00',1.47),('16100','2013-06-14','08:05:00',1.68),('16100','2013-06-14','08:10:00',1.86),('16100','2013-06-14','08:15:00',2.05),('16100','2013-06-14','08:20:00',2.18),('16100','2013-06-14','08:25:00',2.37),('16100','2013-06-14','08:30:00',2.52),('16100','2013-06-14','08:35:00',2.69),('16100','2013-06-14','08:40:00',2.91),('16100','2013-06-14','08:45:00',3.12),('16100','2013-06-14','08:50:00',3.41),('16100','2013-06-14','08:55:00',3.9),('16100','2013-06-14','09:00:00',4.14),('16100','2013-06-14','09:05:00',4.13),('16100','2013-06-14','09:10:00',4.52),('16100','2013-06-14','09:15:00',3.88),('16100','2013-06-14','09:20:00',3.05),('16100','2013-06-14','09:25:00',2.02),('16100','2013-06-14','09:30:00',4.3),('16100','2013-06-14','09:35:00',4.71),('16100','2013-06-14','09:40:00',4.85),('16100','2013-06-14','09:45:00',4.97),('16100','2013-06-14','09:50:00',5.07),('16100','2013-06-14','09:55:00',5.15),('16100','2013-06-14','10:00:00',5.34),('16100','2013-06-14','10:05:00',5.45),('16100','2013-06-14','10:10:00',5.55),('16100','2013-06-14','10:15:00',5.66),('16100','2013-06-14','10:20:00',5.74),('16100','2013-06-14','10:25:00',5.91),('16100','2013-06-14','10:30:00',6.01),('16100','2013-06-14','10:35:00',6.03),('16100','2013-06-14','10:40:00',6.11),('16100','2013-06-14','10:45:00',6.22),('16100','2013-06-14','10:50:00',6.37),('16100','2013-06-14','10:55:00',6.29),('16100','2013-06-14','11:00:00',6.45),('16100','2013-06-14','11:05:00',6.21),('16100','2013-06-14','11:10:00',6.73),('16100','2013-06-14','11:15:00',6.68),('16100','2013-06-14','11:20:00',6.93),('16100','2013-06-14','11:25:00',7),('16100','2013-06-14','11:30:00',7.04),('16100','2013-06-14','11:35:00',7.08),('16100','2013-06-14','11:40:00',7.17),('16100','2013-06-14','11:45:00',6.94),('16100','2013-06-14','11:50:00',7.12),('16100','2013-06-14','11:55:00',7.35),('16100','2013-06-14','12:00:00',7.23),('16100','2013-06-14','12:05:00',7.39),('16100','2013-06-14','12:10:00',7.46),('16100','2013-06-14','12:15:00',7.48),('16100','2013-06-14','12:20:00',7.48),('16100','2013-06-14','12:25:00',7.59),('16100','2013-06-14','12:30:00',7.58),('16100','2013-06-14','12:35:00',7.63),('16100','2013-06-14','12:40:00',7.63),('16100','2013-06-14','12:45:00',7.67),('16100','2013-06-14','12:50:00',7.69),('16100','2013-06-14','12:55:00',7.69),('16100','2013-06-14','13:00:00',7.65),('16100','2013-06-14','13:05:00',7.71),('16100','2013-06-14','13:10:00',7.71),('16100','2013-06-14','13:15:00',7.65),('16100','2013-06-14','13:20:00',7.68),('16100','2013-06-14','13:25:00',7.64),('16100','2013-06-14','13:30:00',7.63),('16100','2013-06-14','13:35:00',7.58),('16100','2013-06-14','13:40:00',7.52),('16100','2013-06-14','13:45:00',7.62),('16100','2013-06-14','13:50:00',7.53),('16100','2013-06-14','13:55:00',7.52),('16100','2013-06-14','14:00:00',7.5),('16100','2013-06-14','14:05:00',7.51),('16100','2013-06-14','14:10:00',7.31),('16100','2013-06-14','14:15:00',7.43),('16100','2013-06-14','14:20:00',7.41),('16100','2013-06-14','14:25:00',7.35),('16100','2013-06-14','14:30:00',7.34),('16100','2013-06-14','14:35:00',7.29),('16100','2013-06-14','14:40:00',7.24),('16100','2013-06-14','14:45:00',7.18),('16100','2013-06-14','14:50:00',7.16),('16100','2013-06-14','14:55:00',7.08),('16100','2013-06-14','15:00:00',7.01),('16100','2013-06-14','15:05:00',6.92),('16100','2013-06-14','15:10:00',6.85),('16100','2013-06-14','15:15:00',6.82),('16100','2013-06-14','15:20:00',6.75),('16100','2013-06-14','15:25:00',6.63),('16100','2013-06-14','15:30:00',6.52),('16100','2013-06-14','15:35:00',6.43),('16100','2013-06-14','15:40:00',6.34),('16100','2013-06-14','15:45:00',6.26),('16100','2013-06-14','15:50:00',6.16),('16100','2013-06-14','15:55:00',6.04),('16100','2013-06-14','16:00:00',5.96),('16100','2013-06-14','16:05:00',5.81),('16100','2013-06-14','16:10:00',5.73),('16100','2013-06-14','16:15:00',5.65),('16100','2013-06-14','16:20:00',5.53),('16100','2013-06-14','16:25:00',5.35),('16100','2013-06-14','16:30:00',5.25),('16100','2013-06-14','16:35:00',5.12),('16100','2013-06-14','16:40:00',4.99),('16100','2013-06-14','16:45:00',4.88),('16100','2013-06-14','16:50:00',4.74),('16100','2013-06-14','16:55:00',4.63),('16100','2013-06-14','17:00:00',4.5),('16100','2013-06-14','17:05:00',4.35),('16100','2013-06-14','17:10:00',4.23),('16100','2013-06-14','17:15:00',4.04),('16100','2013-06-14','17:20:00',3.89),('16100','2013-06-14','17:25:00',3.7),('16100','2013-06-14','17:30:00',3.61),('16100','2013-06-14','17:35:00',3.43),('16100','2013-06-14','17:40:00',3.28),('16100','2013-06-14','17:45:00',3.15),('16100','2013-06-14','17:50:00',3.01),('16100','2013-06-14','17:55:00',2.87),('16100','2013-06-14','18:00:00',2.67),('16100','2013-06-14','18:05:00',2.52),('16100','2013-06-14','18:10:00',2.29),('16100','2013-06-14','18:15:00',2.12),('16100','2013-06-14','18:20:00',2),('16100','2013-06-14','18:25:00',1.84),('16100','2013-06-14','18:30:00',1.7),('16100','2013-06-14','18:35:00',1.55),('16100','2013-06-14','18:40:00',1.42),('16100','2013-06-14','18:45:00',1.29),('16100','2013-06-14','18:50:00',1.16),('16100','2013-06-14','18:55:00',1.01),('16100','2013-06-13','07:45:00',1.02),('16100','2013-06-13','07:50:00',1.22),('16100','2013-06-13','07:55:00',1.41),('16100','2013-06-13','08:00:00',1.63),('16100','2013-06-13','08:05:00',1.83),('16100','2013-06-13','08:10:00',2.02),('16100','2013-06-13','08:15:00',2.22),('16100','2013-06-13','08:20:00',2.35),('16100','2013-06-13','08:25:00',2.53),('16100','2013-06-13','08:30:00',2.71),('16100','2013-06-13','08:35:00',2.86),('16100','2013-06-13','08:40:00',3.02),('16100','2013-06-13','08:45:00',3.24),('16100','2013-06-13','08:50:00',3.37),('16100','2013-06-13','08:55:00',3.52),('16100','2013-06-13','09:00:00',3.66),('16100','2013-06-13','09:05:00',3.79),('16100','2013-06-13','09:10:00',3.96),('16100','2013-06-13','09:15:00',4.27),('16100','2013-06-13','09:20:00',4.46),('16100','2013-06-13','09:25:00',4.56),('16100','2013-06-13','09:30:00',4.69),('16100','2013-06-13','09:35:00',4.88),('16100','2013-06-13','09:40:00',5.04),('16100','2013-06-13','09:45:00',5.17),('16100','2013-06-13','09:50:00',5.28),('16100','2013-06-13','09:55:00',5.37),('16100','2013-06-13','10:00:00',5.41),('16100','2013-06-13','10:05:00',5.6),('16100','2013-06-13','10:10:00',5.77),('16100','2013-06-13','10:15:00',5.88),('16100','2013-06-13','10:20:00',6.01),('16100','2013-06-13','10:25:00',6.17),('16100','2013-06-13','10:30:00',6.03),('16100','2013-06-13','10:35:00',6.35),('16100','2013-06-13','10:40:00',6.35),('16100','2013-06-13','10:45:00',6.37),('16100','2013-06-13','10:50:00',6.39),('16100','2013-06-13','10:55:00',6.51),('16100','2013-06-13','11:00:00',6.68),('16100','2013-06-13','11:05:00',6.81),('16100','2013-06-13','11:10:00',6.7),('16100','2013-06-13','11:15:00',6.79),('16100','2013-06-13','11:20:00',6.97),('16100','2013-06-13','11:25:00',7),('16100','2013-06-13','11:30:00',7.05),('16100','2013-06-13','11:35:00',7.1),('16100','2013-06-13','11:40:00',7.19),('16100','2013-06-13','11:45:00',7.22),('16100','2013-06-13','11:50:00',7.23),('16100','2013-06-13','11:55:00',7.18),('16100','2013-06-13','12:00:00',7.21),('16100','2013-06-13','12:05:00',7.33),('16100','2013-06-13','12:10:00',7.41),('16100','2013-06-13','12:15:00',7.41),('16100','2013-06-13','12:20:00',7.51),('16100','2013-06-13','12:25:00',7.45),('16100','2013-06-13','12:30:00',7.53),('16100','2013-06-13','12:35:00',7.59),('16100','2013-06-13','12:40:00',7.58),('16100','2013-06-13','12:45:00',7.55),('16100','2013-06-13','12:50:00',7.67),('16100','2013-06-13','12:55:00',7.68),('16100','2013-06-13','13:00:00',7.61),('16100','2013-06-13','13:05:00',7.59),('16100','2013-06-13','13:10:00',7.58),('16100','2013-06-13','13:15:00',7.62),('16100','2013-06-13','13:20:00',7.67),('16100','2013-06-13','13:25:00',7.68),('16100','2013-06-13','13:30:00',7.69),('16100','2013-06-13','13:35:00',7.67),('16100','2013-06-13','13:40:00',7.57),('16100','2013-06-13','13:45:00',7.62),('16100','2013-06-13','13:50:00',7.66),('16100','2013-06-13','13:55:00',7.67),('16100','2013-06-13','14:00:00',7.61),('16100','2013-06-13','14:05:00',7.45),('16100','2013-06-13','14:10:00',7.28),('16100','2013-06-13','14:15:00',7.48),('16100','2013-06-13','14:20:00',7.4),('16100','2013-06-13','14:25:00',7.34),('16100','2013-06-13','14:30:00',7.39),('16100','2013-06-13','14:35:00',7.38),('16100','2013-06-13','14:40:00',7.31),('16100','2013-06-13','14:45:00',7.24),('16100','2013-06-13','14:50:00',7.2),('16100','2013-06-13','14:55:00',7.1),('16100','2013-06-13','15:00:00',7.01),('16100','2013-06-13','15:05:00',6.97),('16100','2013-06-13','15:10:00',6.9),('16100','2013-06-13','15:15:00',6.83),('16100','2013-06-13','15:20:00',6.76),('16100','2013-06-13','15:25:00',6.77),('16100','2013-06-13','15:30:00',6.64),('16100','2013-06-13','15:35:00',6.59),('16100','2013-06-13','15:40:00',6.45),('16100','2013-06-13','15:45:00',6.35),('16100','2013-06-13','15:50:00',6.26),('16100','2013-06-13','15:55:00',6.22),('16100','2013-06-13','16:00:00',6.14),('16100','2013-06-13','16:05:00',5.97),('16100','2013-06-13','16:10:00',5.92),('16100','2013-06-13','16:15:00',5.82),('16100','2013-06-13','16:20:00',5.67),('16100','2013-06-13','16:25:00',5.57),('16100','2013-06-13','16:30:00',5.42),('16100','2013-06-13','16:35:00',5.3),('16100','2013-06-13','16:40:00',5.22),('16100','2013-06-13','16:45:00',5.1),('16100','2013-06-13','16:50:00',4.93),('16100','2013-06-13','16:55:00',4.78),('16100','2013-06-13','17:00:00',4.69),('16100','2013-06-13','17:05:00',4.38),('16100','2013-06-13','17:10:00',4.29),('16100','2013-06-13','17:15:00',4.14),('16100','2013-06-13','17:20:00',4),('16100','2013-06-13','17:25:00',3.78),('16100','2013-06-13','17:30:00',3.67),('16100','2013-06-13','17:35:00',3.65),('16100','2013-06-13','17:40:00',3.5),('16100','2013-06-13','17:45:00',3.34),('16100','2013-06-13','17:50:00',3.2),('16100','2013-06-13','17:55:00',3.04),('16100','2013-06-13','18:00:00',2.81),('16100','2013-06-13','18:05:00',2.68),('16100','2013-06-13','18:10:00',2.42),('16100','2013-06-13','18:15:00',2.21),('16100','2013-06-13','18:20:00',2.1),('16100','2013-06-13','18:25:00',1.97),('16100','2013-06-13','18:30:00',1.81),('16100','2013-06-13','18:35:00',1.64),('16100','2013-06-13','18:40:00',1.5),('16100','2013-06-13','18:45:00',1.36),('16100','2013-06-13','18:50:00',1.21),('16100','2013-06-13','18:55:00',1.06),('16100','2013-06-12','07:45:00',1.05),('16100','2013-06-12','07:50:00',1.26),('16100','2013-06-12','07:55:00',1.44),('16100','2013-06-12','08:00:00',1.66),('16100','2013-06-12','08:05:00',1.84),('16100','2013-06-12','08:10:00',2.05),('16100','2013-06-12','08:15:00',2.25),('16100','2013-06-12','08:20:00',2.39),('16100','2013-06-12','08:25:00',2.57),('16100','2013-06-12','08:30:00',2.74),('16100','2013-06-12','08:35:00',2.9),('16100','2013-06-12','08:40:00',3.07),('16100','2013-06-12','08:45:00',3.27),('16100','2013-06-12','08:50:00',3.44),('16100','2013-06-12','08:55:00',3.59),('16100','2013-06-12','09:00:00',3.73),('16100','2013-06-12','09:05:00',3.88),('16100','2013-06-12','09:10:00',4.1),('16100','2013-06-12','09:15:00',4.42),('16100','2013-06-12','09:20:00',4.61),('16100','2013-06-12','09:25:00',4.78),('16100','2013-06-12','09:30:00',4.9),('16100','2013-06-12','09:35:00',5.03),('16100','2013-06-12','09:40:00',5.11),('16100','2013-06-12','09:45:00',5.24),('16100','2013-06-12','09:50:00',5.38),('16100','2013-06-12','09:55:00',5.48),('16100','2013-06-12','10:00:00',5.64),('16100','2013-06-12','10:05:00',5.77),('16100','2013-06-12','10:10:00',5.93),('16100','2013-06-12','10:15:00',6.05),('16100','2013-06-12','10:20:00',6.15),('16100','2013-06-12','10:25:00',6.28),('16100','2013-06-12','10:30:00',6.34),('16100','2013-06-12','10:35:00',6.42),('16100','2013-06-12','10:40:00',6.49),('16100','2013-06-12','10:45:00',6.6),('16100','2013-06-12','10:50:00',6.7),('16100','2013-06-12','10:55:00',6.79),('16100','2013-06-12','11:00:00',6.87),('16100','2013-06-12','11:05:00',6.94),('16100','2013-06-12','11:10:00',7.02),('16100','2013-06-12','11:15:00',7.12),('16100','2013-06-12','11:20:00',7.19),('16100','2013-06-12','11:25:00',7.21),('16100','2013-06-12','11:30:00',7.33),('16100','2013-06-12','11:35:00',7.41),('16100','2013-06-12','11:40:00',7.46),('16100','2013-06-12','11:45:00',7.5),('16100','2013-06-12','11:50:00',7.56),('16100','2013-06-12','11:55:00',7.59),('16100','2013-06-12','12:00:00',7.59),('16100','2013-06-12','12:05:00',7.62),('16100','2013-06-12','12:10:00',7.72),('16100','2013-06-12','12:15:00',7.7),('16100','2013-06-12','12:20:00',7.72),('16100','2013-06-12','12:25:00',7.78),('16100','2013-06-12','12:30:00',7.83),('16100','2013-06-12','12:35:00',7.84),('16100','2013-06-12','12:40:00',7.83),('16100','2013-06-12','12:45:00',7.83),('16100','2013-06-12','12:50:00',7.93),('16100','2013-06-12','12:55:00',7.88),('16100','2013-06-12','13:00:00',7.85),('16100','2013-06-12','13:05:00',7.82),('16100','2013-06-12','13:10:00',7.86),('16100','2013-06-12','13:15:00',7.84),('16100','2013-06-12','13:20:00',7.88),('16100','2013-06-12','13:25:00',7.81),('16100','2013-06-12','13:30:00',7.78),('16100','2013-06-12','13:35:00',7.75),('16100','2013-06-12','13:40:00',7.81),('16100','2013-06-12','13:45:00',7.74),('16100','2013-06-12','13:50:00',7.7),('16100','2013-06-12','13:55:00',7.7),('16100','2013-06-12','14:00:00',7.67),('16100','2013-06-12','14:05:00',7.5),('16100','2013-06-12','14:10:00',7.27),('16100','2013-06-12','14:15:00',7.52),('16100','2013-06-12','14:20:00',7.45),('16100','2013-06-12','14:25:00',7.46),('16100','2013-06-12','14:30:00',5.6),('16100','2013-06-12','14:35:00',3.75),('16100','2013-06-12','14:40:00',7.83),('16100','2013-06-12','14:45:00',7.58),('16100','2013-06-12','14:50:00',6.94),('16100','2013-06-12','14:55:00',7.29),('16100','2013-06-12','15:00:00',7.06),('16100','2013-06-12','15:05:00',6.98),('16100','2013-06-12','15:10:00',6.91),('16100','2013-06-12','15:15:00',6.78),('16100','2013-06-12','15:20:00',6.74),('16100','2013-06-12','15:25:00',6.56),('16100','2013-06-12','15:30:00',6.48),('16100','2013-06-12','15:35:00',6.44),('16100','2013-06-12','15:40:00',6.38),('16100','2013-06-12','15:45:00',6.36),('16100','2013-06-12','15:50:00',6.18),('16100','2013-06-12','15:55:00',6.05),('16100','2013-06-12','16:00:00',5.95),('16100','2013-06-12','16:05:00',5.85),('16100','2013-06-12','16:10:00',5.74),('16100','2013-06-12','16:15:00',5.63),('16100','2013-06-12','16:20:00',5.57),('16100','2013-06-12','16:25:00',5.43),('16100','2013-06-12','16:30:00',5.44),('16100','2013-06-12','16:35:00',5.08),('16100','2013-06-12','16:40:00',4.99),('16100','2013-06-12','16:45:00',4.9),('16100','2013-06-12','16:50:00',4.87),('16100','2013-06-12','16:55:00',4.74),('16100','2013-06-12','17:00:00',4.56),('16100','2013-06-12','17:05:00',4.45),('16100','2013-06-12','17:10:00',4.33),('16100','2013-06-12','17:15:00',4.21),('16100','2013-06-12','17:20:00',4.04),('16100','2013-06-12','17:25:00',3.88),('16100','2013-06-12','17:30:00',3.71),('16100','2013-06-12','17:35:00',3.53),('16100','2013-06-12','17:40:00',3.34),('16100','2013-06-12','17:45:00',3.18),('16100','2013-06-12','17:50:00',3.07),('16100','2013-06-12','17:55:00',2.93),('16100','2013-06-12','18:00:00',2.76),('16100','2013-06-12','18:05:00',2.61),('16100','2013-06-12','18:10:00',2.37),('16100','2013-06-12','18:15:00',2.17),('16100','2013-06-12','18:20:00',2.06),('16100','2013-06-12','18:25:00',1.92),('16100','2013-06-12','18:30:00',1.75),('16100','2013-06-12','18:35:00',1.6),('16100','2013-06-12','18:40:00',1.45),('16100','2013-06-12','18:45:00',1.3),('16100','2013-06-12','18:50:00',1.16),('16100','2013-06-12','18:55:00',1.02),('16100','2013-06-11','07:45:00',1.05),('16100','2013-06-11','07:50:00',1.26),('16100','2013-06-11','07:55:00',1.47),('16100','2013-06-11','08:00:00',1.69),('16100','2013-06-11','08:05:00',1.89),('16100','2013-06-11','08:10:00',2.07),('16100','2013-06-11','08:15:00',1.61),('16100','2013-06-11','08:20:00',2.35),('16100','2013-06-11','08:25:00',2.58),('16100','2013-06-11','08:30:00',2.74),('16100','2013-06-11','08:35:00',2.89),('16100','2013-06-11','08:40:00',3.06),('16100','2013-06-11','08:45:00',3.26),('16100','2013-06-11','08:50:00',3.41),('16100','2013-06-11','08:55:00',3.59),('16100','2013-06-11','09:00:00',3.7),('16100','2013-06-11','09:05:00',3.87),('16100','2013-06-11','09:10:00',4.11),('16100','2013-06-11','09:15:00',4.42),('16100','2013-06-11','09:20:00',4.6),('16100','2013-06-11','09:25:00',4.74),('16100','2013-06-11','09:30:00',4.88),('16100','2013-06-11','09:35:00',5.01),('16100','2013-06-11','09:40:00',5.14),('16100','2013-06-11','09:45:00',5.23),('16100','2013-06-11','09:50:00',5.32),('16100','2013-06-11','09:55:00',5.45),('16100','2013-06-11','10:00:00',5.61),('16100','2013-06-11','10:05:00',5.75),('16100','2013-06-11','10:10:00',5.89),('16100','2013-06-11','10:15:00',6.02),('16100','2013-06-11','10:20:00',6.08),('16100','2013-06-11','10:25:00',6.16),('16100','2013-06-11','10:30:00',6.29),('16100','2013-06-11','10:35:00',6.42),('16100','2013-06-11','10:40:00',6.55),('16100','2013-06-11','10:45:00',6.64),('16100','2013-06-11','10:50:00',6.75),('16100','2013-06-11','10:55:00',6.79),('16100','2013-06-11','11:00:00',6.83),('16100','2013-06-11','11:05:00',6.96),('16100','2013-06-11','11:10:00',7.07),('16100','2013-06-11','11:15:00',7.14),('16100','2013-06-11','11:20:00',7.12),('16100','2013-06-11','11:25:00',7.22),('16100','2013-06-11','11:30:00',7.23),('16100','2013-06-11','11:35:00',7.34),('16100','2013-06-11','11:40:00',7.49),('16100','2013-06-11','11:45:00',7.53),('16100','2013-06-11','11:50:00',7.53),('16100','2013-06-11','11:55:00',7.57),('16100','2013-06-11','12:00:00',7.6),('16100','2013-06-11','12:05:00',7.65),('16100','2013-06-11','12:10:00',7.6),('16100','2013-06-11','12:15:00',7.64),('16100','2013-06-11','12:20:00',7.7),('16100','2013-06-11','12:25:00',7.73),('16100','2013-06-11','12:30:00',7.86),('16100','2013-06-11','12:35:00',6.31),('16100','2013-06-11','12:40:00',7.82),('16100','2013-06-11','12:45:00',8.01),('16100','2013-06-11','12:50:00',8.05),('16100','2013-06-11','12:55:00',8.06),('16100','2013-06-11','13:00:00',7.99),('16100','2013-06-11','13:05:00',7.89),('16100','2013-06-11','13:10:00',7.96),('16100','2013-06-11','13:15:00',7.91),('16100','2013-06-11','13:20:00',7.84),('16100','2013-06-11','13:25:00',7.88),('16100','2013-06-11','13:30:00',7.83),('16100','2013-06-11','13:35:00',7.75),('16100','2013-06-11','13:40:00',7.8),('16100','2013-06-11','13:45:00',7.77),('16100','2013-06-11','13:50:00',5.81),('16100','2013-06-11','13:55:00',3.16),('16100','2013-06-11','14:00:00',7),('16100','2013-06-11','14:05:00',8.27),('16100','2013-06-11','14:10:00',8.04),('16100','2013-06-11','14:15:00',7.82),('16100','2013-06-11','14:20:00',7.79),('16100','2013-06-11','14:25:00',7.76),('16100','2013-06-11','14:30:00',7.67),('16100','2013-06-11','14:35:00',7.58),('16100','2013-06-11','14:40:00',7.47),('16100','2013-06-11','14:45:00',7.34),('16100','2013-06-11','14:50:00',7.33),('16100','2013-06-11','14:55:00',7.34),('16100','2013-06-11','15:00:00',6.86),('16100','2013-06-11','15:05:00',6.72),('16100','2013-06-11','15:10:00',7.1),('16100','2013-06-11','15:15:00',7.24),('16100','2013-06-11','15:20:00',6.92),('16100','2013-06-11','15:25:00',6.77),('16100','2013-06-11','15:30:00',6.78),('16100','2013-06-11','15:35:00',6.77),('16100','2013-06-11','15:40:00',6.67),('16100','2013-06-11','15:45:00',6.53),('16100','2013-06-11','15:50:00',6.46),('16100','2013-06-11','15:55:00',6.44),('16100','2013-06-11','16:00:00',6.34),('16100','2013-06-11','16:05:00',6.15),('16100','2013-06-11','16:10:00',5.94),('16100','2013-06-11','16:15:00',5.98),('16100','2013-06-11','16:20:00',5.81),('16100','2013-06-11','16:25:00',5.94),('16100','2013-06-11','16:30:00',5.71),('16100','2013-06-11','16:35:00',5.48),('16100','2013-06-11','16:40:00',5.69),('16100','2013-06-11','16:45:00',5.51),('16100','2013-06-11','16:50:00',5.19),('16100','2013-06-11','16:55:00',4.97),('16100','2013-06-11','17:00:00',4.84),('16100','2013-06-11','17:05:00',4.67),('16100','2013-06-11','17:10:00',4.44),('16100','2013-06-11','17:15:00',4.32),('16100','2013-06-11','17:20:00',4.21),('16100','2013-06-11','17:25:00',4.06),('16100','2013-06-11','17:30:00',3.44),('16100','2013-06-11','17:35:00',3.45),('16100','2013-06-11','17:40:00',3.96),('16100','2013-06-11','17:45:00',3.85),('16100','2013-06-11','17:50:00',3.74),('16100','2013-06-11','17:55:00',3.71),('16100','2013-06-11','18:00:00',3.08),('16100','2013-06-11','18:05:00',1.22),('16100','2013-06-11','18:10:00',2.4),('16100','2013-06-11','18:15:00',2.32),('16100','2013-06-11','18:20:00',2.21),('16100','2013-06-11','18:25:00',2.02),('16100','2013-06-11','18:30:00',1.85),('16100','2013-06-11','18:35:00',1.64),('16100','2013-06-11','18:40:00',1.46),('16100','2013-06-11','18:45:00',1.33),('16100','2013-06-11','18:50:00',1.17),('16100','2013-06-11','18:55:00',1.02),('16100','2013-06-10','07:45:00',1.01),('16100','2013-06-10','07:50:00',1.22),('16100','2013-06-10','07:55:00',1.39),('16100','2013-06-10','08:00:00',1.59),('16100','2013-06-10','08:05:00',1.81),('16100','2013-06-10','08:10:00',2.01),('16100','2013-06-10','08:15:00',2.2),('16100','2013-06-10','08:20:00',2.35),('16100','2013-06-10','08:25:00',2.51),('16100','2013-06-10','08:30:00',2.7),('16100','2013-06-10','08:35:00',2.82),('16100','2013-06-10','08:40:00',3.05),('16100','2013-06-10','08:45:00',3.23),('16100','2013-06-10','08:50:00',3.43),('16100','2013-06-10','08:55:00',3.61),('16100','2013-06-10','09:00:00',3.77),('16100','2013-06-10','09:05:00',4.02),('16100','2013-06-10','09:10:00',4.14),('16100','2013-06-10','09:15:00',4.42),('16100','2013-06-10','09:20:00',4.73),('16100','2013-06-10','09:25:00',4.81),('16100','2013-06-10','09:30:00',4.9),('16100','2013-06-10','09:35:00',5.08),('16100','2013-06-10','09:40:00',5.16),('16100','2013-06-10','09:45:00',5.31),('16100','2013-06-10','09:50:00',5.44),('16100','2013-06-10','09:55:00',5.24),('16100','2013-06-10','10:00:00',5.63),('16100','2013-06-10','10:05:00',5.76),('16100','2013-06-10','10:10:00',6.1),('16100','2013-06-10','10:15:00',6.11),('16100','2013-06-10','10:20:00',5.5),('16100','2013-06-10','10:25:00',6.66),('16100','2013-06-10','10:30:00',6.45),('16100','2013-06-10','10:35:00',5.9),('16100','2013-06-10','10:40:00',6.84),('16100','2013-06-10','10:45:00',5.19),('16100','2013-06-10','10:50:00',4.87),('16100','2013-06-10','10:55:00',6.98),('16100','2013-06-10','11:00:00',5.37),('16100','2013-06-10','11:05:00',2.11),('16100','2013-06-10','11:10:00',7.21),('16100','2013-06-10','11:15:00',7.39),('16100','2013-06-10','11:20:00',7.39),('16100','2013-06-10','11:25:00',7.42),('16100','2013-06-10','11:30:00',7.52),('16100','2013-06-10','11:35:00',7.52),('16100','2013-06-10','11:40:00',7.58),('16100','2013-06-10','11:45:00',7.68),('16100','2013-06-10','11:50:00',7.69),('16100','2013-06-10','11:55:00',7.8),('16100','2013-06-10','12:00:00',7.93),('16100','2013-06-10','12:05:00',6.76),('16100','2013-06-10','12:10:00',8.05),('16100','2013-06-10','12:15:00',8.02),('16100','2013-06-10','12:20:00',7.97),('16100','2013-06-10','12:25:00',8.06),('16100','2013-06-10','12:30:00',8.06),('16100','2013-06-10','12:35:00',8.21),('16100','2013-06-10','12:40:00',8.11),('16100','2013-06-10','12:45:00',8.14),('16100','2013-06-10','12:50:00',8.2),('16100','2013-06-10','12:55:00',8.16),('16100','2013-06-10','13:00:00',6.76),('16100','2013-06-10','13:05:00',7.65),('16100','2013-06-10','13:10:00',8.28),('16100','2013-06-10','13:15:00',8.27),('16100','2013-06-10','13:20:00',8.26),('16100','2013-06-10','13:25:00',8.28),('16100','2013-06-10','13:30:00',8.28),('16100','2013-06-10','13:35:00',8.37),('16100','2013-06-10','13:40:00',5.66),('16100','2013-06-10','13:45:00',8.32),('16100','2013-06-10','13:50:00',8.25),('16100','2013-06-10','13:55:00',8.23),('16100','2013-06-10','14:00:00',8.11),('16100','2013-06-10','14:05:00',7.94),('16100','2013-06-10','14:10:00',7.95),('16100','2013-06-10','14:15:00',7.92),('16100','2013-06-10','14:20:00',7.88),('16100','2013-06-10','14:25:00',7.83),('16100','2013-06-10','14:30:00',7.73),('16100','2013-06-10','14:35:00',7.7),('16100','2013-06-10','14:40:00',7.68),('16100','2013-06-10','14:45:00',7.6),('16100','2013-06-10','14:50:00',7.55),('16100','2013-06-10','14:55:00',7.4),('16100','2013-06-10','15:00:00',7.14),('16100','2013-06-10','15:05:00',7.35),('16100','2013-06-10','15:10:00',7.25),('16100','2013-06-10','15:15:00',7.12),('16100','2013-06-10','15:20:00',7.06),('16100','2013-06-10','15:25:00',7.1),('16100','2013-06-10','15:30:00',7.09),('16100','2013-06-10','15:35:00',5.5),('16100','2013-06-10','15:40:00',6.27),('16100','2013-06-10','15:45:00',6.7),('16100','2013-06-10','15:50:00',6.66),('16100','2013-06-10','15:55:00',5.07),('16100','2013-06-10','16:00:00',6.44),('16100','2013-06-10','16:05:00',6.29),('16100','2013-06-10','16:10:00',6.13),('16100','2013-06-10','16:15:00',6),('16100','2013-06-10','16:20:00',5.83),('16100','2013-06-10','16:25:00',5.74),('16100','2013-06-10','16:30:00',5.6),('16100','2013-06-10','16:35:00',5.48),('16100','2013-06-10','16:40:00',5.6),('16100','2013-06-10','16:45:00',5.72),('16100','2013-06-10','16:50:00',5.61),('16100','2013-06-10','16:55:00',4.41),('16100','2013-06-10','17:00:00',3.36),('16100','2013-06-10','17:05:00',2.03),('16100','2013-06-10','17:10:00',1.17),('16100','2013-06-10','17:15:00',1.04),('16100','2014-04-02','08:35:00',1.03),('16100','2014-04-02','08:40:00',1.23),('16100','2014-04-02','08:45:00',1.35),('16100','2014-04-02','08:50:00',1.5),('16100','2014-04-02','08:55:00',1.66),('16100','2014-04-02','09:00:00',1.9),('16100','2014-04-02','09:05:00',2.11),('16100','2014-04-02','09:10:00',1.97),('16100','2014-04-02','09:15:00',1.81),('16100','2014-04-02','09:20:00',1.94),('16100','2014-04-02','09:25:00',2.11),('16100','2014-04-02','09:30:00',2.32),('16100','2014-04-02','09:35:00',2.64),('16100','2014-04-02','09:40:00',2.68),('16100','2014-04-02','09:45:00',2.68),('16100','2014-04-02','09:50:00',2.66),('16100','2014-04-02','09:55:00',3.01),('16100','2014-04-02','10:00:00',3.69),('16100','2014-04-02','10:05:00',4.05),('16100','2014-04-02','10:10:00',4.22),('16100','2014-04-02','10:15:00',4.87),('16100','2014-04-02','10:20:00',4.65),('16100','2014-04-02','10:25:00',3.33),('16100','2014-04-02','10:30:00',4.78),('16100','2014-04-02','10:35:00',4.56),('16100','2014-04-02','10:40:00',4.17),('16100','2014-04-02','10:45:00',5),('16100','2014-04-02','10:50:00',4.29),('16100','2014-04-02','10:55:00',3.53),('16100','2014-04-02','11:00:00',3.16),('16100','2014-04-02','11:05:00',2.79),('16100','2014-04-02','11:10:00',2.59),('16100','2014-04-02','11:15:00',2.39),('16100','2014-04-02','11:20:00',2.16),('16100','2014-04-02','11:25:00',1.96),('16100','2014-04-02','11:30:00',2),('16100','2014-04-02','11:35:00',2.25),('16100','2014-04-02','11:40:00',2.46),('16100','2014-04-02','11:45:00',2.63),('16100','2014-04-02','11:50:00',3.12),('16100','2014-04-02','11:55:00',3.53),('16100','2014-04-02','12:00:00',3.98),('16100','2014-04-02','12:05:00',4.01),('16100','2014-04-02','12:10:00',3.56),('16100','2014-04-02','12:15:00',3.66),('16100','2014-04-02','12:20:00',4.02),('16100','2014-04-02','12:25:00',5.2),('16100','2014-04-02','12:30:00',6.94),('16100','2014-04-02','12:35:00',7.34),('16100','2014-04-02','12:40:00',4.9),('16100','2014-04-02','12:45:00',3.94),('16100','2014-04-02','12:50:00',4.67),('16100','2014-04-02','12:55:00',4.56),('16100','2014-04-02','13:00:00',3.55),('16100','2014-04-02','13:05:00',3.77),('16100','2014-04-02','13:10:00',4.3),('16100','2014-04-02','13:15:00',5.77),('16100','2014-04-02','13:20:00',4.1),('16100','2014-04-02','13:25:00',5.74),('16100','2014-04-02','13:30:00',6.22),('16100','2014-04-02','13:35:00',7.12),('16100','2014-04-02','13:40:00',5.16),('16100','2014-04-02','13:45:00',2.92),('16100','2014-04-02','13:50:00',4.14),('16100','2014-04-02','13:55:00',4.79),('16100','2014-04-02','14:00:00',4.86),('16100','2014-04-02','14:05:00',6.98),('16100','2014-04-02','14:10:00',5.67),('16100','2014-04-02','14:15:00',6.51),('16100','2014-04-02','14:20:00',6.29),('16100','2014-04-02','14:25:00',5.77),('16100','2014-04-02','14:30:00',6.81),('16100','2014-04-02','14:35:00',6.89),('16100','2014-04-02','14:40:00',6.72),('16100','2014-04-02','14:45:00',6.15),('16100','2014-04-02','14:50:00',6.42),('16100','2014-04-02','14:55:00',6.26),('16100','2014-04-02','15:00:00',6.28),('16100','2014-04-02','15:05:00',6.3),('16100','2014-04-02','15:10:00',6.26),('16100','2014-04-02','15:15:00',6.21),('16100','2014-04-02','15:20:00',6.09),('16100','2014-04-02','15:25:00',5.99),('16100','2014-04-02','15:30:00',5.84),('16100','2014-04-02','15:35:00',5.76),('16100','2014-04-02','15:40:00',5.7),('16100','2014-04-02','15:45:00',5.69),('16100','2014-04-02','15:50:00',5.63),('16100','2014-04-02','15:55:00',5.53),('16100','2014-04-02','16:00:00',5.59),('16100','2014-04-02','16:05:00',5.39),('16100','2014-04-02','16:10:00',5.31),('16100','2014-04-02','16:15:00',5.14),('16100','2014-04-02','16:20:00',5.06),('16100','2014-04-02','16:25:00',4.95),('16100','2014-04-02','16:30:00',4.73),('16100','2014-04-02','16:35:00',4.6),('16100','2014-04-02','16:40:00',4.54),('16100','2014-04-02','16:45:00',4.42),('16100','2014-04-02','16:50:00',4.32),('16100','2014-04-02','16:55:00',3.77),('16100','2014-04-02','17:00:00',3.13),('16100','2014-04-02','17:05:00',2.08),('16100','2014-04-02','17:10:00',2.19),('16100','2014-04-02','17:15:00',2.12),('16100','2014-04-02','17:20:00',1.93),('16100','2014-04-02','17:25:00',2.15),('16100','2014-04-02','17:30:00',1.6),('16100','2014-04-02','17:35:00',1.08),('16100','2014-04-02','17:40:00',1.09),('16100','2014-04-02','17:45:00',1.43),('16100','2014-04-02','17:50:00',2.45),('16100','2014-04-02','17:55:00',2.12),('16100','2014-04-02','18:00:00',1.91),('16100','2014-04-02','18:05:00',1.71),('16100','2014-04-02','18:10:00',1.54),('16100','2014-04-02','18:15:00',1.37),('16100','2014-04-02','18:20:00',1.19),('16100','2013-06-09','07:25:00',1.02),('16100','2013-06-09','07:30:00',1.26),('16100','2013-06-09','07:35:00',1.33),('16100','2013-06-09','07:50:00',1.02),('16100','2013-06-09','07:55:00',1.24),('16100','2013-06-09','08:00:00',1.57),('16100','2013-06-09','08:05:00',1.46),('16100','2013-06-09','08:10:00',1.65),('16100','2013-06-09','08:15:00',1.75),('16100','2013-06-09','08:20:00',1.73),('16100','2013-06-09','08:25:00',1.95),('16100','2013-06-09','08:30:00',1.24),('16100','2013-06-09','08:35:00',1.25),('16100','2013-06-09','08:45:00',1.86),('16100','2013-06-09','08:50:00',2.91),('16100','2013-06-09','08:55:00',2.52),('16100','2013-06-09','09:00:00',1.42),('16100','2013-06-09','09:05:00',2.08),('16100','2013-06-09','09:10:00',1.63),('16100','2013-06-09','09:15:00',4.75),('16100','2013-06-09','09:20:00',4.96),('16100','2013-06-09','09:25:00',4.76),('16100','2013-06-09','09:30:00',3.58),('16100','2013-06-09','09:35:00',3.09),('16100','2013-06-09','09:40:00',1.61),('16100','2013-06-09','09:45:00',3.31),('16100','2013-06-09','09:50:00',2.86),('16100','2013-06-09','09:55:00',2.51),('16100','2013-06-09','10:00:00',3.19),('16100','2013-06-09','10:05:00',2.73),('16100','2013-06-09','10:10:00',4.48),('16100','2013-06-09','10:15:00',4.52),('16100','2013-06-09','10:20:00',3.43),('16100','2013-06-09','10:25:00',2.1),('16100','2013-06-09','10:30:00',2.05),('16100','2013-06-09','10:35:00',2.15),('16100','2013-06-09','10:40:00',4.96),('16100','2013-06-09','10:45:00',6.66),('16100','2013-06-09','10:50:00',6.33),('16100','2013-06-09','10:55:00',5.74),('16100','2013-06-09','11:00:00',7.28),('16100','2013-06-09','11:05:00',7.4),('16100','2013-06-09','11:10:00',7.28),('16100','2013-06-09','11:15:00',3.98),('16100','2013-06-09','11:20:00',7.09),('16100','2013-06-09','11:25:00',6.66),('16100','2013-06-09','11:30:00',5.43),('16100','2013-06-09','11:35:00',4.21),('16100','2013-06-09','11:40:00',4.8),('16100','2013-06-09','11:45:00',2.88),('16100','2013-06-09','11:50:00',9.09),('16100','2013-06-09','11:55:00',4.64),('16100','2013-06-09','12:00:00',1.73),('16100','2013-06-09','12:05:00',2.99),('16100','2013-06-09','12:10:00',2.95),('16100','2013-06-09','12:15:00',5.7),('16100','2013-06-09','12:20:00',7.08),('16100','2013-06-09','12:25:00',8.03),('16100','2013-06-09','12:30:00',7.4),('16100','2013-06-09','12:35:00',9.12),('16100','2013-06-09','12:40:00',6.57),('16100','2013-06-09','12:45:00',8.65),('16100','2013-06-09','12:50:00',5.73),('16100','2013-06-09','12:55:00',9.05),('16100','2013-06-09','13:00:00',6.2),('16100','2013-06-09','13:05:00',6.58),('16100','2013-06-09','13:10:00',5.43),('16100','2013-06-09','13:15:00',5.71),('16100','2013-06-09','13:20:00',9.14),('16100','2013-06-09','13:25:00',6.85),('16100','2013-06-09','13:30:00',8.05),('16100','2013-06-09','13:35:00',3.51),('16100','2013-06-09','13:40:00',1.62),('16100','2013-06-09','13:45:00',6.46),('16100','2013-06-09','13:50:00',3.2),('16100','2013-06-09','13:55:00',2.69),('16100','2013-06-09','14:00:00',3.75),('16100','2013-06-09','14:05:00',7.41),('16100','2013-06-09','14:10:00',4.75),('16100','2013-06-09','14:15:00',7.69),('16100','2013-06-09','14:20:00',8.16),('16100','2013-06-09','14:25:00',6.85),('16100','2013-06-09','14:30:00',6.34),('16100','2013-06-09','14:35:00',7.82),('16100','2013-06-09','14:40:00',7.66),('16100','2013-06-09','14:45:00',7.56),('16100','2013-06-09','14:50:00',7.57),('16100','2013-06-09','14:55:00',7.52),('16100','2013-06-09','15:00:00',7.48),('16100','2013-06-09','15:05:00',7.44),('16100','2013-06-09','15:10:00',7.35),('16100','2013-06-09','15:15:00',7.27),('16100','2013-06-09','15:20:00',7.18),('16100','2013-06-09','15:25:00',7.08),('16100','2013-06-09','15:30:00',6.96),('16100','2013-06-09','15:35:00',6.89),('16100','2013-06-09','15:40:00',6.78),('16100','2013-06-09','15:45:00',6.69),('16100','2013-06-09','15:50:00',6.6),('16100','2013-06-09','15:55:00',6.51),('16100','2013-06-09','16:00:00',6.38),('16100','2013-06-09','16:05:00',6.28),('16100','2013-06-09','16:10:00',6.16),('16100','2013-06-09','16:15:00',6.1),('16100','2013-06-09','16:20:00',5.95),('16100','2013-06-09','16:25:00',5.82),('16100','2013-06-09','16:30:00',5.68),('16100','2013-06-09','16:35:00',5.56),('16100','2013-06-09','16:40:00',5.4),('16100','2013-06-09','16:45:00',5.3),('16100','2013-06-09','16:50:00',5.18),('16100','2013-06-09','16:55:00',5.06),('16100','2013-06-09','17:00:00',4.92),('16100','2013-06-09','17:05:00',4.78),('16100','2013-06-09','17:10:00',4.6),('16100','2013-06-09','17:15:00',4.47),('16100','2013-06-09','17:20:00',4.31),('16100','2013-06-09','17:25:00',4.11),('16100','2013-06-09','17:30:00',3.99),('16100','2013-06-09','17:35:00',3.81),('16100','2013-06-09','17:40:00',3.6),('16100','2013-06-09','17:45:00',3.44),('16100','2013-06-09','17:50:00',3.32),('16100','2013-06-09','17:55:00',3.15),('16100','2013-06-09','18:00:00',2.96),('16100','2013-06-09','18:05:00',2.78),('16100','2013-06-09','18:10:00',2.53),('16100','2013-06-09','18:15:00',2.32),('16100','2013-06-09','18:20:00',2.18),('16100','2013-06-09','18:25:00',2.02),('16100','2013-06-09','18:30:00',1.85),('16100','2013-06-09','18:35:00',1.67),('16100','2013-06-09','18:40:00',1.52),('16100','2013-06-09','18:45:00',1.38),('16100','2013-06-09','18:50:00',1.21),('16100','2013-06-09','18:55:00',1.04),('16100','2013-06-08','07:30:00',1.16),('16100','2013-06-08','07:35:00',1.39),('16100','2013-06-08','07:50:00',1.28),('16100','2013-06-08','07:55:00',1.36),('16100','2013-06-08','08:00:00',1.54),('16100','2013-06-08','08:05:00',1.51),('16100','2013-06-08','08:10:00',1.8),('16100','2013-06-08','08:15:00',2.18),('16100','2013-06-08','08:20:00',2.42),('16100','2013-06-08','08:25:00',2.5),('16100','2013-06-08','08:30:00',2.63),('16100','2013-06-08','08:35:00',2.75),('16100','2013-06-08','08:40:00',2.94),('16100','2013-06-08','08:45:00',3.11),('16100','2013-06-08','08:50:00',3.22),('16100','2013-06-08','08:55:00',3.39),('16100','2013-06-08','09:00:00',3.51),('16100','2013-06-08','09:05:00',3.68),('16100','2013-06-08','09:10:00',4.05),('16100','2013-06-08','09:15:00',4.27),('16100','2013-06-08','09:20:00',4.39),('16100','2013-06-08','09:25:00',4.34),('16100','2013-06-08','09:30:00',4.49),('16100','2013-06-08','09:35:00',4.67),('16100','2013-06-08','09:40:00',4.9),('16100','2013-06-08','09:45:00',5.05),('16100','2013-06-08','09:50:00',5.2),('16100','2013-06-08','09:55:00',5.29),('16100','2013-06-08','10:00:00',5.38),('16100','2013-06-08','10:05:00',5.52),('16100','2013-06-08','10:10:00',5.59),('16100','2013-06-08','10:15:00',5.82),('16100','2013-06-08','10:20:00',5.87),('16100','2013-06-08','10:25:00',6.02),('16100','2013-06-08','10:30:00',6.08),('16100','2013-06-08','10:35:00',6.15),('16100','2013-06-08','10:40:00',6.24),('16100','2013-06-08','10:45:00',6.33),('16100','2013-06-08','10:50:00',6.39),('16100','2013-06-08','10:55:00',6.54),('16100','2013-06-08','11:00:00',6.54),('16100','2013-06-08','11:05:00',6.63),('16100','2013-06-08','11:10:00',6.68),('16100','2013-06-08','11:15:00',6.71),('16100','2013-06-08','11:20:00',6.53),('16100','2013-06-08','11:25:00',6.72),('16100','2013-06-08','11:30:00',6.87),('16100','2013-06-08','11:35:00',6.89),('16100','2013-06-08','11:40:00',7.04),('16100','2013-06-08','11:45:00',6.95),('16100','2013-06-08','11:50:00',7.13),('16100','2013-06-08','11:55:00',7.04),('16100','2013-06-08','12:00:00',7.09),('16100','2013-06-08','12:05:00',6.93),('16100','2013-06-08','12:10:00',6.36),('16100','2013-06-08','12:15:00',7.48),('16100','2013-06-08','12:20:00',7.37),('16100','2013-06-08','12:25:00',7.38),('16100','2013-06-08','12:30:00',7.35),('16100','2013-06-08','12:35:00',7.57),('16100','2013-06-08','12:40:00',6.81),('16100','2013-06-08','12:45:00',7.1),('16100','2013-06-08','12:50:00',7.38),('16100','2013-06-08','12:55:00',6.54),('16100','2013-06-08','13:00:00',7.2),('16100','2013-06-08','13:05:00',7.56),('16100','2013-06-08','13:10:00',7.28),('16100','2013-06-08','13:15:00',7.44),('16100','2013-06-08','13:20:00',7.88),('16100','2013-06-08','13:25:00',7.92),('16100','2013-06-08','13:30:00',8.02),('16100','2013-06-08','13:35:00',8.26),('16100','2013-06-08','13:40:00',7.14),('16100','2013-06-08','13:45:00',6.6),('16100','2013-06-08','13:50:00',6.36),('16100','2013-06-08','13:55:00',5.44),('16100','2013-06-08','14:00:00',8.13),('16100','2013-06-08','14:05:00',8.12),('16100','2013-06-08','14:10:00',8.09),('16100','2013-06-08','14:15:00',7.18),('16100','2013-06-08','14:20:00',2.32),('16100','2013-06-08','14:25:00',1.73),('16100','2013-06-08','14:30:00',2.4),('16100','2013-06-08','14:35:00',6.04),('16100','2013-06-08','14:40:00',7.93),('16100','2013-06-08','14:45:00',5.57),('16100','2013-06-08','14:50:00',7.23),('16100','2013-06-08','14:55:00',7.45),('16100','2013-06-08','15:00:00',6.72),('16100','2013-06-08','15:05:00',7.33),('16100','2013-06-08','15:10:00',7.11),('16100','2013-06-08','15:15:00',6.93),('16100','2013-06-08','15:20:00',6.84),('16100','2013-06-08','15:25:00',6.86),('16100','2013-06-08','15:30:00',6.6),('16100','2013-06-08','15:35:00',6.68),('16100','2013-06-08','15:40:00',5.65),('16100','2013-06-08','15:45:00',4.6),('16100','2013-06-08','15:50:00',5.62),('16100','2013-06-08','15:55:00',6.54),('16100','2013-06-08','16:00:00',6.26),('16100','2013-06-08','16:05:00',5.48),('16100','2013-06-08','16:10:00',5.14),('16100','2013-06-08','16:15:00',5.81),('16100','2013-06-08','16:20:00',3.4),('16100','2013-06-08','16:25:00',5.2),('16100','2013-06-08','16:30:00',1.95),('16100','2013-06-08','16:35:00',1.61),('16100','2013-06-08','16:40:00',1.43),('16100','2013-06-08','16:45:00',1.46),('16100','2013-06-08','16:50:00',1.38),('16100','2013-06-08','16:55:00',1.31),('16100','2013-06-08','17:00:00',1.49),('16100','2013-06-08','17:05:00',1.49),('16100','2013-06-08','17:10:00',1.52),('16100','2013-06-08','17:15:00',1.02),('16100','2013-06-08','17:20:00',1.07),('16100','2013-06-08','17:40:00',1.09),('16100','2013-06-08','17:45:00',1.17),('16100','2013-06-08','18:00:00',1.53),('16100','2013-06-08','18:05:00',2.42),('16100','2013-06-08','18:10:00',1.76),('16100','2013-06-08','18:45:00',1.04),('16100','2013-06-07','07:50:00',1.2),('16100','2013-06-07','07:55:00',1.41),('16100','2013-06-07','08:00:00',1.61),('16100','2013-06-07','08:05:00',1.78),('16100','2013-06-07','08:10:00',1.97),('16100','2013-06-07','08:15:00',2.14),('16100','2013-06-07','08:20:00',2.28),('16100','2013-06-07','08:25:00',2.45),('16100','2013-06-07','08:30:00',2.62),('16100','2013-06-07','08:35:00',2.8),('16100','2013-06-07','08:40:00',2.93),('16100','2013-06-07','08:45:00',3.13),('16100','2013-06-07','08:50:00',3.28),('16100','2013-06-07','08:55:00',3.44),('16100','2013-06-07','09:00:00',3.53),('16100','2013-06-07','09:05:00',3.69),('16100','2013-06-07','09:10:00',4.02),('16100','2013-06-07','09:15:00',4.32),('16100','2013-06-07','09:20:00',4.46),('16100','2013-06-07','09:25:00',4.54),('16100','2013-06-07','09:30:00',4.77),('16100','2013-06-07','09:35:00',4.91),('16100','2013-06-07','09:40:00',5.07),('16100','2013-06-07','09:45:00',5.2),('16100','2013-06-07','09:50:00',5.34),('16100','2013-06-07','09:55:00',5.56),('16100','2013-06-07','10:00:00',5.51),('16100','2013-06-07','10:05:00',5.67),('16100','2013-06-07','10:10:00',5.69),('16100','2013-06-07','10:15:00',2.16),('16100','2013-06-07','10:20:00',3.09),('16100','2013-06-07','10:25:00',6.18),('16100','2013-06-07','10:30:00',6.38),('16100','2013-06-07','10:35:00',6.6),('16100','2013-06-07','10:40:00',6.48),('16100','2013-06-07','10:45:00',6.86),('16100','2013-06-07','10:50:00',4.5),('16100','2013-06-07','10:55:00',6.82),('16100','2013-06-07','11:00:00',7.86),('16100','2013-06-07','11:05:00',7.08),('16100','2013-06-07','11:10:00',6.44),('16100','2013-06-07','11:15:00',6.12),('16100','2013-06-07','11:20:00',2.51),('16100','2013-06-07','11:25:00',8.02),('16100','2013-06-07','11:30:00',7.61),('16100','2013-06-07','11:35:00',6.63),('16100','2013-06-07','11:40:00',7.77),('16100','2013-06-07','11:45:00',7.93),('16100','2013-06-07','11:50:00',2.71),('16100','2013-06-07','11:55:00',7.9),('16100','2013-06-07','12:00:00',8.28),('16100','2013-06-07','12:05:00',6.19),('16100','2013-06-07','12:10:00',6.29),('16100','2013-06-07','12:15:00',5.74),('16100','2013-06-07','12:20:00',8.25),('16100','2013-06-07','12:25:00',7.76),('16100','2013-06-07','12:30:00',6.03),('16100','2013-06-07','12:35:00',6.2),('16100','2013-06-07','12:40:00',7.64),('16100','2013-06-07','12:45:00',7.82),('16100','2013-06-07','12:50:00',7.97),('16100','2013-06-07','12:55:00',7.91),('16100','2013-06-07','13:00:00',7.92),('16100','2013-06-07','13:05:00',8.04),('16100','2013-06-07','13:10:00',7.83),('16100','2013-06-07','13:15:00',7.91),('16100','2013-06-07','13:20:00',7.94),('16100','2013-06-07','13:25:00',7.92),('16100','2013-06-07','13:30:00',7.91),('16100','2013-06-07','13:35:00',7.86),('16100','2013-06-07','13:40:00',7.84),('16100','2013-06-07','13:45:00',7.87),('16100','2013-06-07','13:50:00',7.84),('16100','2013-06-07','13:55:00',8.02),('16100','2013-06-07','14:00:00',7.94),('16100','2013-06-07','14:05:00',7.76),('16100','2013-06-07','14:10:00',7.77),('16100','2013-06-07','14:15:00',7.74),('16100','2013-06-07','14:20:00',7.7),('16100','2013-06-07','14:25:00',7.67),('16100','2013-06-07','14:30:00',7.69),('16100','2013-06-07','14:35:00',7.6),('16100','2013-06-07','14:40:00',7.55),('16100','2013-06-07','14:45:00',7.49),('16100','2013-06-07','14:50:00',7.39),('16100','2013-06-07','14:55:00',7.29),('16100','2013-06-07','15:00:00',7.19),('16100','2013-06-07','15:05:00',7.05),('16100','2013-06-07','15:10:00',7.09),('16100','2013-06-07','15:15:00',7.2),('16100','2013-06-07','15:20:00',7.14),('16100','2013-06-07','15:25:00',6.96),('16100','2013-06-07','15:30:00',7.18),('16100','2013-06-07','15:35:00',7.13),('16100','2013-06-07','15:40:00',6.82),('16100','2013-06-07','15:45:00',6.99),('16100','2013-06-07','15:50:00',6.79),('16100','2013-06-07','15:55:00',6.52),('16100','2013-06-07','16:00:00',6.45),('16100','2013-06-07','16:05:00',5.74),('16100','2013-06-07','16:10:00',6.44),('16100','2013-06-07','16:15:00',6.25),('16100','2013-06-07','16:20:00',5.9),('16100','2013-06-07','16:25:00',5.68),('16100','2013-06-07','16:30:00',5.53),('16100','2013-06-07','16:35:00',5.41),('16100','2013-06-07','16:40:00',5.3),('16100','2013-06-07','16:45:00',4.91),('16100','2013-06-07','16:50:00',4.57),('16100','2013-06-07','16:55:00',4.7),('16100','2013-06-07','17:00:00',2.38),('16100','2013-06-07','17:05:00',4.4),('16100','2013-06-07','17:10:00',5.05),('16100','2013-06-07','17:15:00',4.79),('16100','2013-06-07','17:20:00',4.37),('16100','2013-06-07','17:25:00',2.28),('16100','2013-06-07','17:35:00',2.07),('16100','2013-06-07','17:40:00',3.73),('16100','2013-06-07','17:45:00',3.19),('16100','2013-06-07','17:50:00',3.35),('16100','2013-06-07','17:55:00',2.79),('16100','2013-06-07','18:00:00',2.29),('16100','2013-06-07','18:05:00',1.86),('16100','2013-06-07','18:10:00',1.72),('16100','2013-06-07','18:15:00',1.75),('16100','2013-06-07','18:20:00',1.51),('16100','2013-06-06','07:45:00',1.06),('16100','2013-06-06','07:50:00',1.25),('16100','2013-06-06','07:55:00',1.46),('16100','2013-06-06','08:00:00',1.69),('16100','2013-06-06','08:06:00',1.89),('16100','2013-06-06','08:10:00',2.1),('16100','2013-06-06','08:15:00',2.27),('16100','2013-06-06','08:20:00',2.41),('16100','2013-06-06','08:25:00',2.6),('16100','2013-06-06','08:30:00',2.78),('16100','2013-06-06','08:35:00',2.94),('16100','2013-06-06','08:40:00',3.13),('16100','2013-06-06','08:45:00',3.34),('16100','2013-06-06','08:50:00',3.47),('16100','2013-06-06','08:55:00',3.62),('16100','2013-06-06','09:00:00',3.76),('16100','2013-06-06','09:05:00',3.96),('16100','2013-06-06','09:10:00',4.28),('16100','2013-06-06','09:15:00',4.48),('16100','2013-06-06','09:20:00',4.63),('16100','2013-06-06','09:25:00',4.7),('16100','2013-06-06','09:30:00',4.87),('16100','2013-06-06','09:35:00',5.06),('16100','2013-06-06','09:40:00',5.21),('16100','2013-06-06','09:45:00',5.32),('16100','2013-06-06','09:50:00',5.45),('16100','2013-06-06','09:55:00',5.54),('16100','2013-06-06','10:00:00',5.67),('16100','2013-06-06','10:05:00',5.82),('16100','2013-06-06','10:10:00',5.99),('16100','2013-06-06','10:15:00',6.09),('16100','2013-06-06','10:20:00',6.21),('16100','2013-06-06','10:25:00',6.31),('16100','2013-06-06','10:30:00',6.4),('16100','2013-06-06','10:35:00',6.5),('16100','2013-06-06','10:40:00',6.59),('16100','2013-06-06','10:45:00',6.68),('16100','2013-06-06','10:50:00',6.75),('16100','2013-06-06','10:55:00',6.92),('16100','2013-06-06','11:00:00',7.03),('16100','2013-06-06','11:05:00',7.09),('16100','2013-06-06','11:10:00',7.15),('16100','2013-06-06','11:15:00',7.22),('16100','2013-06-06','11:20:00',7.28),('16100','2013-06-06','11:25:00',7.31),('16100','2013-06-06','11:30:00',7.36),('16100','2013-06-06','11:35:00',7.42),('16100','2013-06-06','11:40:00',7.47),('16100','2013-06-06','11:45:00',7.53),('16100','2013-06-06','11:50:00',7.56),('16100','2013-06-06','11:55:00',7.58),('16100','2013-06-06','12:00:00',7.67),('16100','2013-06-06','12:05:00',7.75),('16100','2013-06-06','12:10:00',7.78),('16100','2013-06-06','12:15:00',7.74),('16100','2013-06-06','12:20:00',7.72),('16100','2013-06-06','12:25:00',7.82),('16100','2013-06-06','12:30:00',7.81),('16100','2013-06-06','12:35:00',7.81),('16100','2013-06-06','12:40:00',7.76),('16100','2013-06-06','12:45:00',7.82),('16100','2013-06-06','12:50:00',7.83),('16100','2013-06-06','12:55:00',7.79),('16100','2013-06-06','13:00:00',7.84),('16100','2013-06-06','13:05:00',7.79),('16100','2013-06-06','13:10:00',7.75),('16100','2013-06-06','13:15:00',7.79),('16100','2013-06-06','13:20:00',7.82),('16100','2013-06-06','13:25:00',7.84),('16100','2013-06-06','13:30:00',7.82),('16100','2013-06-06','13:35:00',7.79),('16100','2013-06-06','13:40:00',7.78),('16100','2013-06-06','13:45:00',7.72),('16100','2013-06-06','13:50:00',7.67),('16100','2013-06-06','13:55:00',7.72),('16100','2013-06-06','14:00:00',7.61),('16100','2013-06-06','14:05:00',7.47),('16100','2013-06-06','14:10:00',7.33),('16100','2013-06-06','14:15:00',7.44),('16100','2013-06-06','14:20:00',7.38),('16100','2013-06-06','14:25:00',7.31),('16100','2013-06-06','14:30:00',7.3),('16100','2013-06-06','14:35:00',7.32),('16100','2013-06-06','14:40:00',7.27),('16100','2013-06-06','14:45:00',7.22),('16100','2013-06-06','14:50:00',7.17),('16100','2013-06-06','14:55:00',7.21),('16100','2013-06-06','15:00:00',7.18),('16100','2013-06-06','15:05:00',7.13),('16100','2013-06-06','15:10:00',7.07),('16100','2013-06-06','15:15:00',6.97),('16100','2013-06-06','15:20:00',6.91),('16100','2013-06-06','15:25:00',6.83),('16100','2013-06-06','15:30:00',6.82),('16100','2013-06-06','15:35:00',6.73),('16100','2013-06-06','15:40:00',6.68),('16100','2013-06-06','15:45:00',6.56),('16100','2013-06-06','15:50:00',6.47),('16100','2013-06-06','15:55:00',6.37),('16100','2013-06-06','16:00:00',6.24),('16100','2013-06-06','16:05:00',6.16),('16100','2013-06-06','16:10:00',6.05),('16100','2013-06-06','16:15:00',5.96),('16100','2013-06-06','16:20:00',5.79),('16100','2013-06-06','16:25:00',5.66),('16100','2013-06-06','16:30:00',5.52),('16100','2013-06-06','16:35:00',5.39),('16100','2013-06-06','16:40:00',5.27),('16100','2013-06-06','16:45:00',5.14),('16100','2013-06-06','16:50:00',5.02),('16100','2013-06-06','16:55:00',4.87),('16100','2013-06-06','17:00:00',4.73),('16100','2013-06-06','17:05:00',4.57),('16100','2013-06-06','17:10:00',4.39),('16100','2013-06-06','17:15:00',4.22),('16100','2013-06-06','17:20:00',4.08),('16100','2013-06-06','17:25:00',3.99),('16100','2013-06-06','17:30:00',3.9),('16100','2013-06-06','17:35:00',3.78),('16100','2013-06-06','17:40:00',3.72),('16100','2013-06-06','17:45:00',3.73),('16100','2013-06-06','17:50:00',3.42),('16100','2013-06-06','17:55:00',2.88),('16100','2013-06-06','18:00:00',2.96),('16100','2013-06-06','18:05:00',2.72),('16100','2013-06-06','18:10:00',1.98),('16100','2013-06-06','18:15:00',2.07),('16100','2013-06-06','18:20:00',2.09),('16100','2013-06-06','18:25:00',1.87),('16100','2013-06-06','18:30:00',1.7),('16100','2013-06-06','18:35:00',1.55),('16100','2013-06-06','18:40:00',1.4),('16100','2013-06-06','18:45:00',1.27),('16100','2013-06-06','18:50:00',1.15),('16100','2013-06-06','18:55:00',1.02),('16100','2013-06-05','07:45:00',1.12),('16100','2013-06-05','07:50:00',1.47),('16100','2013-06-05','07:55:00',1.56),('16100','2013-06-05','08:00:00',1.46),('16100','2013-06-05','08:05:00',1.67),('16100','2013-06-05','08:10:00',1.86),('16100','2013-06-05','08:15:00',1.84),('16100','2013-06-05','08:20:00',2.35),('16100','2013-06-05','08:25:00',2.55),('16100','2013-06-05','08:30:00',2.71),('16100','2013-06-05','08:35:00',2.81),('16100','2013-06-05','08:40:00',2.97),('16100','2013-06-05','08:45:00',3.15),('16100','2013-06-05','08:50:00',3.35),('16100','2013-06-05','08:55:00',3.56),('16100','2013-06-05','09:00:00',3.67),('16100','2013-06-05','09:05:00',3.81),('16100','2013-06-05','09:10:00',4.24),('16100','2013-06-05','09:15:00',4.46),('16100','2013-06-05','09:20:00',4.4),('16100','2013-06-05','09:25:00',4.63),('16100','2013-06-05','09:30:00',4.83),('16100','2013-06-05','09:35:00',4.94),('16100','2013-06-05','09:40:00',5.11),('16100','2013-06-05','09:45:00',5.21),('16100','2013-06-05','09:50:00',5.26),('16100','2013-06-05','09:55:00',5.33),('16100','2013-06-05','10:00:00',5.51),('16100','2013-06-05','10:05:00',5.47),('16100','2013-06-05','10:10:00',5.27),('16100','2013-06-05','10:15:00',5.86),('16100','2013-06-05','10:20:00',6.08),('16100','2013-06-05','10:25:00',6.17),('16100','2013-06-05','10:30:00',6.29),('16100','2013-06-05','10:35:00',6.55),('16100','2013-06-05','10:40:00',6.51),('16100','2013-06-05','10:45:00',6.64),('16100','2013-06-05','10:50:00',6.61),('16100','2013-06-05','10:55:00',6.62),('16100','2013-06-05','11:00:00',6.67),('16100','2013-06-05','11:05:00',6.84),('16100','2013-06-05','11:10:00',6.53),('16100','2013-06-05','11:15:00',6.98),('16100','2013-06-05','11:20:00',6.9),('16100','2013-06-05','11:25:00',7.17),('16100','2013-06-05','11:30:00',7.25),('16100','2013-06-05','11:35:00',7.29),('16100','2013-06-05','11:40:00',7.47),('16100','2013-06-05','11:45:00',7.37),('16100','2013-06-05','11:50:00',7.43),('16100','2013-06-05','11:55:00',7.49),('16100','2013-06-05','12:00:00',7.6),('16100','2013-06-05','12:05:00',7.6),('16100','2013-06-05','12:10:00',7.61),('16100','2013-06-05','12:15:00',7.56),('16100','2013-06-05','12:20:00',7.44),('16100','2013-06-05','12:25:00',7.75),('16100','2013-06-05','12:30:00',7.71),('16100','2013-06-05','12:35:00',7.67),('16100','2013-06-05','12:40:00',7.6),('16100','2013-06-05','12:45:00',7.74),('16100','2013-06-05','12:50:00',7.89),('16100','2013-06-05','12:55:00',8.07),('16100','2013-06-05','13:00:00',8.12),('16100','2013-06-05','13:05:00',7.93),('16100','2013-06-05','13:10:00',7.74),('16100','2013-06-05','13:15:00',7.95),('16100','2013-06-05','13:20:00',7.87),('16100','2013-06-05','13:25:00',5.96),('16100','2013-06-05','13:30:00',1.76),('16100','2013-06-05','13:35:00',2),('16100','2013-06-05','13:40:00',1.81),('16100','2013-06-05','13:45:00',5.8),('16100','2013-06-05','13:50:00',8.32),('16100','2013-06-05','13:55:00',8.11),('16100','2013-06-05','14:00:00',7.37),('16100','2013-06-05','14:05:00',7.86),('16100','2013-06-05','14:10:00',5.79),('16100','2013-06-05','14:15:00',6.03),('16100','2013-06-05','14:20:00',7.94),('16100','2013-06-05','14:25:00',7.84),('16100','2013-06-05','14:30:00',7.65),('16100','2013-06-05','14:35:00',7.33),('16100','2013-06-05','14:40:00',7.36),('16100','2013-06-05','14:45:00',7.38),('16100','2013-06-05','14:50:00',7.39),('16100','2013-06-05','14:55:00',7.26),('16100','2013-06-05','15:00:00',7.14),('16100','2013-06-05','15:05:00',7.06),('16100','2013-06-05','15:10:00',6.97),('16100','2013-06-05','15:15:00',6.94),('16100','2013-06-05','15:20:00',6.85),('16100','2013-06-05','15:25:00',6.75),('16100','2013-06-05','15:30:00',6.69),('16100','2013-06-05','15:35:00',6.5),('16100','2013-06-05','15:40:00',6.44),('16100','2013-06-05','15:45:00',6.33),('16100','2013-06-05','15:50:00',6.16),('16100','2013-06-05','15:55:00',6.16),('16100','2013-06-05','16:00:00',6.01),('16100','2013-06-05','16:05:00',5.92),('16100','2013-06-05','16:10:00',5.88),('16100','2013-06-05','16:15:00',5.65),('16100','2013-06-05','16:20:00',5.54),('16100','2013-06-05','16:25:00',5.45),('16100','2013-06-05','16:30:00',5.37),('16100','2013-06-05','16:35:00',5.24),('16100','2013-06-05','16:40:00',5.11),('16100','2013-06-05','16:45:00',5),('16100','2013-06-05','16:50:00',4.85),('16100','2013-06-05','16:55:00',4.73),('16100','2013-06-05','17:00:00',4.55),('16100','2013-06-05','17:05:00',4.38),('16100','2013-06-05','17:10:00',4.18),('16100','2013-06-05','17:15:00',4.13),('16100','2013-06-05','17:20:00',3.94),('16100','2013-06-05','17:25:00',3.76),('16100','2013-06-05','17:30:00',3.62),('16100','2013-06-05','17:35:00',3.47),('16100','2013-06-05','17:40:00',3.33),('16100','2013-06-05','17:45:00',3.21),('16100','2013-06-05','17:50:00',3.07),('16100','2013-06-05','17:55:00',2.88),('16100','2013-06-05','18:00:00',2.72),('16100','2013-06-05','18:05:00',2.54),('16100','2013-06-05','18:10:00',2.32),('16100','2013-06-05','18:15:00',2.1),('16100','2013-06-05','18:20:00',1.99),('16100','2013-06-05','18:25:00',1.81),('16100','2013-06-05','18:30:00',1.69),('16100','2013-06-05','18:35:00',1.55),('16100','2013-06-05','18:40:00',1.4),('16100','2013-06-05','18:45:00',1.27),('16100','2013-06-05','18:50:00',1.11),('16100','2013-06-04','07:40:00',1.07),('16100','2013-06-04','07:45:00',1.18),('16100','2013-06-04','07:50:00',1.16),('16100','2013-06-04','07:55:00',1.43),('16100','2013-06-04','08:00:00',1.65),('16100','2013-06-04','08:05:00',1.73),('16100','2013-06-04','08:10:00',2.03),('16100','2013-06-04','08:15:00',2.27),('16100','2013-06-04','08:20:00',2.4),('16100','2013-06-04','08:25:00',2.57),('16100','2013-06-04','08:30:00',2.74),('16100','2013-06-04','08:35:00',2.91),('16100','2013-06-04','08:40:00',3.09),('16100','2013-06-04','08:45:00',3.3),('16100','2013-06-04','08:50:00',3.38),('16100','2013-06-04','08:55:00',3.59),('16100','2013-06-04','09:00:00',3.68),('16100','2013-06-04','09:05:00',4.15),('16100','2013-06-04','09:10:00',4.77),('16100','2013-06-04','09:15:00',4.43),('16100','2013-06-04','09:20:00',5.48),('16100','2013-06-04','09:25:00',5.17),('16100','2013-06-04','09:30:00',2.56),('16100','2013-06-04','09:35:00',3.84),('16100','2013-06-04','09:40:00',2.31),('16100','2013-06-04','09:45:00',1.84),('16100','2013-06-04','09:50:00',2.82),('16100','2013-06-04','09:55:00',4.39),('16100','2013-06-04','10:00:00',4.26),('16100','2013-06-04','10:05:00',2.66),('16100','2013-06-04','10:10:00',2.04),('16100','2013-06-04','10:15:00',6.45),('16100','2013-06-04','10:20:00',7.09),('16100','2013-06-04','10:25:00',7.32),('16100','2013-06-04','10:30:00',7.13),('16100','2013-06-04','10:35:00',7.11),('16100','2013-06-04','10:40:00',7.31),('16100','2013-06-04','10:45:00',3.51),('16100','2013-06-04','10:50:00',2.08),('16100','2013-06-04','10:55:00',1.96),('16100','2013-06-04','11:00:00',2.04),('16100','2013-06-04','11:05:00',3.12),('16100','2013-06-04','11:10:00',7.78),('16100','2013-06-04','11:15:00',8.34),('16100','2013-06-04','11:20:00',7.64),('16100','2013-06-04','11:25:00',3.66),('16100','2013-06-04','11:30:00',1.75),('16100','2013-06-04','11:35:00',1.66),('16100','2013-06-04','11:40:00',2.5),('16100','2013-06-04','11:45:00',7.12),('16100','2013-06-04','11:50:00',6.65),('16100','2013-06-04','11:55:00',2.81),('16100','2013-06-04','12:00:00',3.05),('16100','2013-06-04','12:05:00',2.66),('16100','2013-06-04','12:10:00',2.3),('16100','2013-06-04','12:15:00',2.51),('16100','2013-06-04','12:20:00',4.59),('16100','2013-06-04','12:25:00',2.8),('16100','2013-06-04','12:30:00',3.06),('16100','2013-06-04','12:35:00',3.55),('16100','2013-06-04','12:40:00',3.64),('16100','2013-06-04','12:45:00',5.17),('16100','2013-06-04','12:50:00',3.5),('16100','2013-06-04','12:55:00',6.32),('16100','2013-06-04','13:00:00',8.93),('16100','2013-06-04','13:05:00',8.7),('16100','2013-06-04','13:10:00',7.94),('16100','2013-06-04','13:15:00',6.8),('16100','2013-06-04','13:20:00',8.03),('16100','2013-06-04','13:25:00',8.79),('16100','2013-06-04','13:30:00',8.36),('16100','2013-06-04','13:35:00',8.13),('16100','2013-06-04','13:40:00',4.53),('16100','2013-06-04','13:45:00',6.41),('16100','2013-06-04','13:50:00',6.98),('16100','2013-06-04','13:55:00',7.65),('16100','2013-06-04','14:00:00',8.14),('16100','2013-06-04','14:05:00',8.04),('16100','2013-06-04','14:10:00',8.02),('16100','2013-06-04','14:15:00',8.02),('16100','2013-06-04','14:20:00',7.98),('16100','2013-06-04','14:25:00',5.81),('16100','2013-06-04','14:30:00',5.95),('16100','2013-06-04','14:35:00',8.05),('16100','2013-06-04','14:40:00',4.67),('16100','2013-06-04','14:45:00',7.43),('16100','2013-06-04','14:50:00',7.71),('16100','2013-06-04','14:55:00',7.55),('16100','2013-06-04','15:00:00',7.54),('16100','2013-06-04','15:05:00',6.52),('16100','2013-06-04','15:10:00',7.53),('16100','2013-06-04','15:15:00',7.49),('16100','2013-06-04','15:20:00',7.53),('16100','2013-06-04','15:25:00',7.36),('16100','2013-06-04','15:30:00',5.41),('16100','2013-06-04','15:35:00',4.4),('16100','2013-06-04','15:40:00',4.58),('16100','2013-06-04','15:45:00',5.46),('16100','2013-06-04','15:50:00',3.65),('16100','2013-06-04','15:55:00',6.04),('16100','2013-06-04','16:00:00',5.58),('16100','2013-06-04','16:05:00',5.01),('16100','2013-06-04','16:10:00',4.49),('16100','2013-06-04','16:15:00',4.62),('16100','2013-06-04','16:20:00',5.48),('16100','2013-06-04','16:25:00',3.18),('16100','2013-06-04','16:30:00',4.8),('16100','2013-06-04','16:35:00',5.97),('16100','2013-06-04','16:40:00',5.42),('16100','2013-06-04','16:45:00',3.54),('16100','2013-06-04','16:50:00',3.22),('16100','2013-06-04','16:55:00',2.42),('16100','2013-06-04','17:00:00',3.32),('16100','2013-06-04','17:05:00',5.31),('16100','2013-06-04','17:10:00',4.75),('16100','2013-06-04','17:15:00',3.45),('16100','2013-06-04','17:20:00',2.62),('16100','2013-06-04','17:25:00',4),('16100','2013-06-04','17:30:00',3.66),('16100','2013-06-04','17:35:00',3.77),('16100','2013-06-04','17:40:00',3.43),('16100','2013-06-04','17:45:00',3.28),('16100','2013-06-04','17:50:00',2.02),('16100','2013-06-04','17:55:00',1.94),('16100','2013-06-04','18:00:00',3.02),('16100','2013-06-04','18:05:00',1.26),('16100','2013-06-04','18:10:00',1.46),('16100','2013-06-04','18:15:00',2.44),('16100','2013-06-04','18:20:00',2.06),('16100','2013-06-04','18:30:00',1.46),('16100','2013-06-04','18:35:00',1.5),('16100','2013-06-04','18:40:00',1.32),('16100','2013-06-03','07:35:00',1.06),('16100','2013-06-03','07:40:00',1.34),('16100','2013-06-03','07:45:00',1.61),('16100','2013-06-03','07:50:00',1.95),('16100','2013-06-03','07:55:00',2.27),('16100','2013-06-03','08:00:00',2.46),('16100','2013-06-03','08:05:00',2.58),('16100','2013-06-03','08:10:00',2.63),('16100','2013-06-03','08:15:00',2.66),('16100','2013-06-03','08:20:00',2.69),('16100','2013-06-03','08:25:00',2.84),('16100','2013-06-03','08:30:00',2.55),('16100','2013-06-03','08:35:00',2.95),('16100','2013-06-03','08:40:00',2.38),('16100','2013-06-03','08:45:00',2.11),('16100','2013-06-03','08:50:00',2.22),('16100','2013-06-03','08:55:00',2.59),('16100','2013-06-03','09:00:00',3.8),('16100','2013-06-03','09:05:00',3.41),('16100','2013-06-03','09:10:00',3.79),('16100','2013-06-03','09:15:00',3.72),('16100','2013-06-03','09:20:00',3.47),('16100','2013-06-03','09:25:00',2.68),('16100','2013-06-03','09:30:00',2.57),('16100','2013-06-03','09:35:00',2.36),('16100','2013-06-03','09:40:00',2.31),('16100','2013-06-03','09:45:00',2.46),('16100','2013-06-03','09:50:00',2.74),('16100','2013-06-03','09:55:00',4.04),('16100','2013-06-03','10:00:00',6.5),('16100','2013-06-03','10:05:00',3.64),('16100','2013-06-03','10:10:00',3.06),('16100','2013-06-03','10:15:00',3.57),('16100','2013-06-03','10:20:00',2.81),('16100','2013-06-03','10:25:00',2.59),('16100','2013-06-03','10:30:00',2.62),('16100','2013-06-03','10:35:00',2.9),('16100','2013-06-03','10:40:00',3.21),('16100','2013-06-03','10:45:00',3.72),('16100','2013-06-03','10:50:00',4.75),('16100','2013-06-03','10:55:00',3.72),('16100','2013-06-03','11:00:00',5.75),('16100','2013-06-03','11:05:00',3.5),('16100','2013-06-03','11:10:00',2.85),('16100','2013-06-03','11:15:00',3.48),('16100','2013-06-03','11:20:00',5.68),('16100','2013-06-03','11:25:00',4.37),('16100','2013-06-03','11:30:00',4.5),('16100','2013-06-03','11:35:00',6.28),('16100','2013-06-03','11:40:00',7.4),('16100','2013-06-03','11:45:00',8.24),('16100','2013-06-03','11:50:00',5.75),('16100','2013-06-03','11:55:00',5.01),('16100','2013-06-03','12:00:00',4.46),('16100','2013-06-03','12:05:00',4.9),('16100','2013-06-03','12:10:00',4.39),('16100','2013-06-03','12:15:00',4.95),('16100','2013-06-03','12:20:00',3.32),('16100','2013-06-03','12:25:00',4.55),('16100','2013-06-03','12:30:00',6.73),('16100','2013-06-03','12:35:00',4.37),('16100','2013-06-03','12:40:00',4.81),('16100','2013-06-03','12:45:00',4.71),('16100','2013-06-03','12:50:00',2.71),('16100','2013-06-03','12:55:00',2.49),('16100','2013-06-03','13:00:00',2.01),('16100','2013-06-03','13:05:00',1.74),('16100','2013-06-03','13:10:00',1.66),('16100','2013-06-03','13:15:00',2.29),('16100','2013-06-03','13:20:00',3.57),('16100','2013-06-03','13:25:00',9.11),('16100','2013-06-03','13:30:00',9.84),('16100','2013-06-03','13:35:00',9.86),('16100','2013-06-03','13:40:00',6.97),('16100','2013-06-03','13:45:00',4.5),('16100','2013-06-03','13:50:00',6.17),('16100','2013-06-03','13:55:00',6.87),('16100','2013-06-03','14:00:00',5.22),('16100','2013-06-03','14:05:00',4.67),('16100','2013-06-03','14:10:00',9.2),('16100','2013-06-03','14:15:00',6.14),('16100','2013-06-03','14:20:00',1.55),('16100','2013-06-03','14:25:00',1.36),('16100','2013-06-03','14:30:00',1.74),('16100','2013-06-03','14:35:00',2.77),('16100','2013-06-03','14:40:00',2.6),('16100','2013-06-03','14:45:00',3.07),('16100','2013-06-03','14:50:00',8.37),('16100','2013-06-03','14:55:00',9.52),('16100','2013-06-03','15:00:00',8.96),('16100','2013-06-03','15:05:00',6.51),('16100','2013-06-03','15:10:00',5.33),('16100','2013-06-03','15:15:00',2.85),('16100','2013-06-03','15:20:00',2.13),('16100','2013-06-03','15:25:00',1.56),('16100','2013-06-03','15:30:00',1.09),('16100','2013-06-03','15:50:00',1.25),('16100','2013-06-03','15:55:00',1.15),('16100','2013-06-03','16:00:00',1.08),('16100','2013-06-03','17:10:00',1.06),('16100','2013-06-03','17:15:00',1.11),('16100','2013-06-03','18:00:00',1.05),('16100','2013-06-03','18:35:00',1.22),('16100','2013-06-03','18:40:00',1.39),('16100','2013-06-03','18:45:00',1.59),('16100','2013-06-03','18:50:00',1.23),('16100','2013-06-02','07:45:00',1.11),('16100','2013-06-02','07:50:00',1.36),('16100','2013-06-02','08:00:00',1.32),('16100','2013-06-02','08:05:00',1.92),('16100','2013-06-02','08:10:00',2.07),('16100','2013-06-02','08:15:00',2.22),('16100','2013-06-02','08:20:00',2.4),('16100','2013-06-02','08:25:00',2.55),('16100','2013-06-02','08:30:00',2.72),('16100','2013-06-02','08:35:00',2.84),('16100','2013-06-02','08:40:00',3.11),('16100','2013-06-02','08:45:00',3.36),('16100','2013-06-02','08:50:00',3.57),('16100','2013-06-02','08:55:00',2.5),('16100','2013-06-02','09:00:00',1.9),('16100','2013-06-02','09:05:00',2.5),('16100','2013-06-02','09:10:00',2.24),('16100','2013-06-02','09:15:00',3.15),('16100','2013-06-02','09:20:00',4.89),('16100','2013-06-02','09:25:00',5.38),('16100','2013-06-02','09:30:00',6.12),('16100','2013-06-02','09:35:00',3.26),('16100','2013-06-02','09:40:00',3.27),('16100','2013-06-02','09:45:00',3.53),('16100','2013-06-02','09:50:00',3.6),('16100','2013-06-02','09:55:00',3.78),('16100','2013-06-02','10:00:00',3.1),('16100','2013-06-02','10:05:00',2.84),('16100','2013-06-02','10:10:00',2.33),('16100','2013-06-02','10:15:00',3.07),('16100','2013-06-02','10:20:00',3),('16100','2013-06-02','10:25:00',2.38),('16100','2013-06-02','10:30:00',2.39),('16100','2013-06-02','10:35:00',2.08),('16100','2013-06-02','10:40:00',1.99),('16100','2013-06-02','10:45:00',2.21),('16100','2013-06-02','10:50:00',2.46),('16100','2013-06-02','10:55:00',2.86),('16100','2013-06-02','11:00:00',2.81),('16100','2013-06-02','11:05:00',2.88),('16100','2013-06-02','11:10:00',3.32),('16100','2013-06-02','11:15:00',5.71),('16100','2013-06-02','11:20:00',7),('16100','2013-06-02','11:25:00',7.96),('16100','2013-06-02','11:30:00',4.19),('16100','2013-06-02','11:35:00',7.2),('16100','2013-06-02','11:40:00',7.95),('16100','2013-06-02','11:45:00',5.7),('16100','2013-06-02','11:50:00',8.94),('16100','2013-06-02','11:55:00',4.56),('16100','2013-06-02','12:00:00',2.3),('16100','2013-06-02','12:05:00',2.5),('16100','2013-06-02','12:10:00',4.77),('16100','2013-06-02','12:15:00',5.91),('16100','2013-06-02','12:20:00',3.05),('16100','2013-06-02','12:25:00',2.41),('16100','2013-06-02','12:30:00',2.22),('16100','2013-06-02','12:35:00',2.73),('16100','2013-06-02','12:40:00',2.74),('16100','2013-06-02','12:45:00',1.79),('16100','2013-06-02','12:50:00',1.82),('16100','2013-06-02','12:55:00',2.21),('16100','2013-06-02','13:00:00',3.27),('16100','2013-06-02','13:05:00',5.06),('16100','2013-06-02','13:10:00',4.16),('16100','2013-06-02','13:15:00',2.83),('16100','2013-06-02','13:20:00',2.69),('16100','2013-06-02','13:25:00',3.69),('16100','2013-06-02','13:30:00',3.36),('16100','2013-06-02','13:35:00',4.2),('16100','2013-06-02','13:40:00',2.99),('16100','2013-06-02','13:45:00',2.27),('16100','2013-06-02','13:50:00',6.31),('16100','2013-06-02','13:55:00',6.12),('16100','2013-06-02','14:00:00',5.66),('16100','2013-06-02','14:05:00',5.99),('16100','2013-06-02','14:10:00',7.01),('16100','2013-06-02','14:15:00',9.1),('16100','2013-06-02','14:20:00',7.64),('16100','2013-06-02','14:25:00',8.52),('16100','2013-06-02','14:30:00',8.4),('16100','2013-06-02','14:35:00',4.37),('16100','2013-06-02','14:40:00',5.38),('16100','2013-06-02','14:45:00',8.09),('16100','2013-06-02','14:50:00',7.92),('16100','2013-06-02','14:55:00',7.21),('16100','2013-06-02','15:00:00',7.69),('16100','2013-06-02','15:05:00',5.87),('16100','2013-06-02','15:10:00',5.53),('16100','2013-06-02','15:15:00',7.39),('16100','2013-06-02','15:20:00',7.48),('16100','2013-06-02','15:25:00',6.86),('16100','2013-06-02','15:30:00',7.22),('16100','2013-06-02','15:35:00',5.55),('16100','2013-06-02','15:40:00',6.79),('16100','2013-06-02','15:45:00',6.6),('16100','2013-06-02','15:50:00',6.54),('16100','2013-06-02','15:55:00',6.42),('16100','2013-06-02','16:00:00',6.38),('16100','2013-06-02','16:05:00',6.31),('16100','2013-06-02','16:10:00',5.88),('16100','2013-06-02','16:15:00',5.01),('16100','2013-06-02','16:20:00',5.43),('16100','2013-06-02','16:25:00',5.58),('16100','2013-06-02','16:30:00',4.91),('16100','2013-06-02','16:35:00',4.4),('16100','2013-06-02','16:40:00',3.32),('16100','2013-06-02','16:45:00',3.35),('16100','2013-06-02','16:50:00',4),('16100','2013-06-02','16:55:00',4.34),('16100','2013-06-02','17:00:00',3.92),('16100','2013-06-02','17:05:00',4.79),('16100','2013-06-02','17:10:00',4.44),('16100','2013-06-02','17:15:00',3.64),('16100','2013-06-02','17:20:00',3.21),('16100','2013-06-02','17:25:00',2.35),('16100','2013-06-02','17:30:00',2.22),('16100','2013-06-02','17:35:00',1.48),('16100','2013-06-02','17:40:00',1.38),('16100','2013-06-02','17:45:00',1.5),('16100','2013-06-02','17:50:00',1.44),('16100','2013-06-02','17:55:00',1.41),('16100','2013-06-02','18:00:00',1.2),('16100','2013-06-01','08:20:00',1.02),('16100','2013-06-01','08:25:00',1.04),('16100','2013-06-01','08:30:00',1.1),('16100','2013-06-01','08:35:00',1.03),('16100','2013-06-01','08:40:00',1.53),('16100','2013-06-01','08:45:00',1.85),('16100','2013-06-01','08:50:00',1.31),('16100','2013-06-01','08:55:00',1.28),('16100','2013-06-01','09:00:00',1.39),('16100','2013-06-01','09:05:00',1.93),('16100','2013-06-01','09:10:00',2.19),('16100','2013-06-01','09:15:00',5.34),('16100','2013-06-01','09:20:00',4.03),('16100','2013-06-01','09:25:00',5.14),('16100','2013-06-01','09:30:00',5.17),('16100','2013-06-01','09:35:00',5.25),('16100','2013-06-01','09:40:00',5.33),('16100','2013-06-01','09:45:00',5.44),('16100','2013-06-01','09:50:00',5.55),('16100','2013-06-01','09:55:00',5.64),('16100','2013-06-01','10:00:00',5.82),('16100','2013-06-01','10:05:00',5.94),('16100','2013-06-01','10:10:00',6.07),('16100','2013-06-01','10:15:00',6.12),('16100','2013-06-01','10:20:00',6.44),('16100','2013-06-01','10:25:00',6.43),('16100','2013-06-01','10:30:00',6.64),('16100','2013-06-01','10:35:00',6.79),('16100','2013-06-01','10:40:00',7.17),('16100','2013-06-01','10:45:00',5.93),('16100','2013-06-01','10:50:00',5.78),('16100','2013-06-01','10:55:00',5.89),('16100','2013-06-01','11:00:00',8.35),('16100','2013-06-01','11:05:00',8.09),('16100','2013-06-01','11:10:00',4.97),('16100','2013-06-01','11:15:00',5.33),('16100','2013-06-01','11:20:00',2.18),('16100','2013-06-01','11:25:00',4.03),('16100','2013-06-01','11:30:00',5.79),('16100','2013-06-01','11:35:00',6.54),('16100','2013-06-01','11:40:00',4.62),('16100','2013-06-01','11:45:00',4.12),('16100','2013-06-01','11:50:00',2.24),('16100','2013-06-01','11:55:00',3.8),('16100','2013-06-01','12:00:00',3.98),('16100','2013-06-01','12:05:00',3.15),('16100','2013-06-01','12:10:00',4.92),('16100','2013-06-01','12:15:00',4.37),('16100','2013-06-01','12:20:00',9.05),('16100','2013-06-01','12:25:00',8.63),('16100','2013-06-01','12:30:00',8.26),('16100','2013-06-01','12:35:00',8.21),('16100','2013-06-01','12:40:00',8.35),('16100','2013-06-01','12:45:00',8.15),('16100','2013-06-01','12:50:00',8.39),('16100','2013-06-01','12:55:00',8.52),('16100','2013-06-01','13:00:00',8.31),('16100','2013-06-01','13:05:00',8.37),('16100','2013-06-01','13:10:00',8.49),('16100','2013-06-01','13:15:00',8.04),('16100','2013-06-01','13:20:00',8.3),('16100','2013-06-01','13:25:00',8.26),('16100','2013-06-01','13:30:00',8.2),('16100','2013-06-01','13:35:00',8.24),('16100','2013-06-01','13:40:00',8.25),('16100','2013-06-01','13:45:00',8.22),('16100','2013-06-01','13:50:00',8.21),('16100','2013-06-01','13:55:00',8.23),('16100','2013-06-01','14:00:00',8.09),('16100','2013-06-01','14:05:00',8.15),('16100','2013-06-01','14:10:00',7.87),('16100','2013-06-01','14:15:00',6.3),('16100','2013-06-01','14:20:00',8.05),('16100','2013-06-01','14:25:00',7.99),('16100','2013-06-01','14:30:00',8),('16100','2013-06-01','14:35:00',7.85),('16100','2013-06-01','14:40:00',7.62),('16100','2013-06-01','14:45:00',7.72),('16100','2013-06-01','14:50:00',7.67),('16100','2013-06-01','14:55:00',7.57),('16100','2013-06-01','15:00:00',6.41),('16100','2013-06-01','15:05:00',7.24),('16100','2013-06-01','15:10:00',7.42),('16100','2013-06-01','15:15:00',6.19),('16100','2013-06-01','15:20:00',7.26),('16100','2013-06-01','15:25:00',5.63),('16100','2013-06-01','15:30:00',5.67),('16100','2013-06-01','15:35:00',3.7),('16100','2013-06-01','15:40:00',5.76),('16100','2013-06-01','15:45:00',6.83),('16100','2013-06-01','15:50:00',7.05),('16100','2013-06-01','15:55:00',6.14),('16100','2013-06-01','16:00:00',4.88),('16100','2013-06-01','16:05:00',5.56),('16100','2013-06-01','16:10:00',7.09),('16100','2013-06-01','16:15:00',4.12),('16100','2013-06-01','16:20:00',3.43),('16100','2013-06-01','16:25:00',4.54),('16100','2013-06-01','16:30:00',5.99),('16100','2013-06-01','16:35:00',4.83),('16100','2013-06-01','16:40:00',5.63),('16100','2013-06-01','16:45:00',4.89),('16100','2013-06-01','16:50:00',2.71),('16100','2013-06-01','16:55:00',4.37),('16100','2013-06-01','17:00:00',4.8),('16100','2013-06-01','17:05:00',4.66),('16100','2013-06-01','17:10:00',4.51),('16100','2013-06-01','17:15:00',3.35),('16100','2013-06-01','17:20:00',3.14),('16100','2013-06-01','17:25:00',3.91),('16100','2013-06-01','17:30:00',4.28),('16100','2013-06-01','17:35:00',3.16),('16100','2013-06-01','17:40:00',2.06),('16100','2013-06-01','17:45:00',2.29),('16100','2013-06-01','17:50:00',1.2),('16100','2013-06-01','17:55:00',1.65),('16100','2013-06-01','18:00:00',1.41),('16100','2013-06-01','18:05:00',1.34),('16100','2013-06-01','18:10:00',1.8),('16100','2013-06-01','18:15:00',1.12),('16100','2013-06-01','18:20:00',1.32),('16100','2013-06-01','18:25:00',1.3),('16100','2013-06-01','18:30:00',1.3),('16100','2013-06-01','18:35:00',1.2),('16100','2013-06-01','18:40:00',1.18),('16100','2013-06-01','18:45:00',1.08),('16100','2013-05-31','07:40:00',1.02),('16100','2013-05-31','07:45:00',1.13),('16100','2013-05-31','07:50:00',1.92),('16100','2013-05-31','07:55:00',1.45),('16100','2013-05-31','08:00:00',1.02),('16100','2013-05-31','08:05:00',1.26),('16100','2013-05-31','08:10:00',1.5),('16100','2013-05-31','08:30:00',1.41),('16100','2013-05-31','08:35:00',1.43),('16100','2013-05-31','08:40:00',1.07),('16100','2013-05-31','08:45:00',2.75),('16100','2013-05-31','08:50:00',1.29),('16100','2013-05-31','09:00:00',1.04),('16100','2013-05-31','09:45:00',1.05),('16100','2013-05-31','10:25:00',1.21),('16100','2013-05-31','10:30:00',1.57),('16100','2013-05-31','10:35:00',2.24),('16100','2013-05-31','10:40:00',2.09),('16100','2013-05-31','10:45:00',2.41),('16100','2013-05-31','10:50:00',3.87),('16100','2013-05-31','10:55:00',4.16),('16100','2013-05-31','11:00:00',1.51),('16100','2013-05-31','11:05:00',1.71),('16100','2013-05-31','11:10:00',1.48),('16100','2013-05-31','11:15:00',1.16),('16100','2013-05-31','11:20:00',1.71),('16100','2013-05-31','11:25:00',1.51),('16100','2013-05-31','11:30:00',1.29),('16100','2013-05-31','11:35:00',1.14),('16100','2013-05-31','11:40:00',1.16),('16100','2013-05-31','11:45:00',1.72),('16100','2013-05-31','11:50:00',2.73),('16100','2013-05-31','11:55:00',3.73),('16100','2013-05-31','12:00:00',1.27),('16100','2013-05-31','12:05:00',1.22),('16100','2013-05-31','12:10:00',1.57),('16100','2013-05-31','12:15:00',1.43),('16100','2013-05-31','12:20:00',1.65),('16100','2013-05-31','12:25:00',1.63),('16100','2013-05-31','12:30:00',1.68),('16100','2013-05-31','12:35:00',1.64),('16100','2013-05-31','12:40:00',2.78),('16100','2013-05-31','12:45:00',2.76),('16100','2013-05-31','12:50:00',2.48),('16100','2013-05-31','12:55:00',2.95),('16100','2013-05-31','13:00:00',2.73),('16100','2013-05-31','13:05:00',2.4),('16100','2013-05-31','13:10:00',2.46),('16100','2013-05-31','13:15:00',3.24),('16100','2013-05-31','13:20:00',3.46),('16100','2013-05-31','13:25:00',3.75),('16100','2013-05-31','13:30:00',3.22),('16100','2013-05-31','13:35:00',2.71),('16100','2013-05-31','13:40:00',2.95),('16100','2013-05-31','13:45:00',1.95),('16100','2013-05-31','13:50:00',2.1),('16100','2013-05-31','13:55:00',2.51),('16100','2013-05-31','14:00:00',4.2),('16100','2013-05-31','14:05:00',6.07),('16100','2013-05-31','14:10:00',4.59),('16100','2013-05-31','14:15:00',3.25),('16100','2013-05-31','14:20:00',3.51),('16100','2013-05-31','14:25:00',3.16),('16100','2013-05-31','14:30:00',2.12),('16100','2013-05-31','14:35:00',1.76),('16100','2013-05-31','14:40:00',1.32),('16100','2013-05-31','14:45:00',1.49),('16100','2013-05-31','14:50:00',1.78),('16100','2013-05-31','14:55:00',1.82),('16100','2013-05-31','15:00:00',1.45),('16100','2013-05-31','15:05:00',1.29),('16100','2013-05-31','15:10:00',1.14),('16100','2013-05-31','15:30:00',1.13),('16100','2013-05-31','15:35:00',1.45),('16100','2013-05-31','15:40:00',1.98),('16100','2013-05-31','15:45:00',2.36),('16100','2013-05-31','15:50:00',3.22),('16100','2013-05-31','15:55:00',2.88),('16100','2013-05-31','16:00:00',2.17),('16100','2013-05-31','16:05:00',1.8),('16100','2013-05-31','16:10:00',1.22),('16100','2013-05-31','16:15:00',1.74),('16100','2013-05-31','16:20:00',1.83),('16100','2013-05-31','16:25:00',1.73),('16100','2013-05-31','16:30:00',1.54),('16100','2013-05-31','16:35:00',1.37),('16100','2013-05-31','16:40:00',1.52),('16100','2013-05-31','16:45:00',1.57),('16100','2013-05-31','16:50:00',1.68),('16100','2013-05-31','16:55:00',1.66),('16100','2013-05-31','18:15:00',1.33),('16100','2013-05-31','18:20:00',1.29),('16100','2013-05-31','18:35:00',1.1),('16100','2013-05-31','18:40:00',1.2),('16100','2013-05-31','18:45:00',1.45),('16100','2013-05-31','18:50:00',1.69),('16100','2013-05-31','18:55:00',1.74),('16100','2013-05-31','19:00:00',1.17),('16100','2014-04-01','08:20:00',1.49),('16100','2014-04-01','08:25:00',1.51),('16100','2014-04-01','08:30:00',1.74),('16100','2014-04-01','08:35:00',1.36),('16100','2014-04-01','08:40:00',1.45),('16100','2014-04-01','09:10:00',1.38),('16100','2014-04-01','09:15:00',2.23),('16100','2014-04-01','09:20:00',2.56),('16100','2014-04-01','09:25:00',4.21),('16100','2014-04-01','09:30:00',4.86),('16100','2014-04-01','09:35:00',3.91),('16100','2014-04-01','09:40:00',2.42),('16100','2014-04-01','10:05:00',1.25),('16100','2014-04-01','10:10:00',1.74),('16100','2014-04-01','10:15:00',4.2),('16100','2014-04-01','10:20:00',6.29),('16100','2014-04-01','10:25:00',5.85),('16100','2014-04-01','10:30:00',3.79),('16100','2014-04-01','10:35:00',6.47),('16100','2014-04-01','10:40:00',5.64),('16100','2014-04-01','10:45:00',4.27),('16100','2014-04-01','10:50:00',2.05),('16100','2014-04-01','10:55:00',2.59),('16100','2014-04-01','11:00:00',2.96),('16100','2014-04-01','11:05:00',1.93),('16100','2014-04-01','11:10:00',1.64),('16100','2014-04-01','11:15:00',1.79),('16100','2014-04-01','11:20:00',1.73),('16100','2014-04-01','11:25:00',2.84),('16100','2014-04-01','11:30:00',7.96),('16100','2014-04-01','11:35:00',3.19),('16100','2014-04-01','11:40:00',1.94),('16100','2014-04-01','11:45:00',3.75),('16100','2014-04-01','11:50:00',4.51),('16100','2014-04-01','11:55:00',3.3),('16100','2014-04-01','12:00:00',6.94),('16100','2014-04-01','12:05:00',6.8),('16100','2014-04-01','12:10:00',7.47),('16100','2014-04-01','12:15:00',1.75),('16100','2014-04-01','12:20:00',4),('16100','2014-04-01','12:25:00',6.79),('16100','2014-04-01','12:30:00',6.37),('16100','2014-04-01','12:35:00',8.12),('16100','2014-04-01','12:40:00',5.87),('16100','2014-04-01','12:45:00',6.97),('16100','2014-04-01','12:50:00',8.32),('16100','2014-04-01','12:55:00',4.36),('16100','2014-04-01','13:00:00',3.96),('16100','2014-04-01','13:05:00',4.21),('16100','2014-04-01','13:10:00',4.08),('16100','2014-04-01','13:15:00',5.86),('16100','2014-04-01','13:20:00',6.1),('16100','2014-04-01','13:25:00',8.45),('16100','2014-04-01','13:30:00',7.11),('16100','2014-04-01','13:35:00',8.17),('16100','2014-04-01','13:40:00',7.91),('16100','2014-04-01','13:45:00',8.15),('16100','2014-04-01','13:50:00',8),('16100','2014-04-01','13:55:00',7.68),('16100','2014-04-01','14:00:00',7.91),('16100','2014-04-01','14:05:00',7.61),('16100','2014-04-01','14:10:00',7.56),('16100','2014-04-01','14:15:00',7.48),('16100','2014-04-01','14:20:00',7.46),('16100','2014-04-01','14:25:00',7.35),('16100','2014-04-01','14:30:00',7.26),('16100','2014-04-01','14:35:00',7.11),('16100','2014-04-01','14:40:00',7.2),('16100','2014-04-01','14:45:00',6.96),('16100','2014-04-01','14:50:00',6.3),('16100','2014-04-01','14:55:00',6.6),('16100','2014-04-01','15:00:00',6.71),('16100','2014-04-01','15:05:00',6.69),('16100','2014-04-01','15:10:00',6.09),('16100','2014-04-01','15:15:00',6.22),('16100','2014-04-01','15:20:00',6.19),('16100','2014-04-01','15:25:00',5.89),('16100','2014-04-01','15:30:00',5.58),('16100','2014-04-01','15:35:00',6.11),('16100','2014-04-01','15:40:00',6.1),('16100','2014-04-01','15:45:00',5.9),('16100','2014-04-01','15:50:00',5.43),('16100','2014-04-01','15:55:00',5.4),('16100','2014-04-01','16:00:00',5.49),('16100','2014-04-01','16:05:00',5.34),('16100','2014-04-01','16:10:00',5.24),('16100','2014-04-01','16:15:00',5.02),('16100','2014-04-01','16:20:00',4.85),('16100','2014-04-01','16:25:00',4.73),('16100','2014-04-01','16:30:00',4.69),('16100','2014-04-01','16:35:00',4.47),('16100','2014-04-01','16:40:00',4.43),('16100','2014-04-01','16:45:00',4.15),('16100','2014-04-01','16:50:00',3.88),('16100','2014-04-01','16:55:00',4.08),('16100','2014-04-01','17:00:00',3.99),('16100','2014-04-01','17:05:00',3.61),('16100','2014-04-01','17:10:00',3.52),('16100','2014-04-01','17:15:00',3.19),('16100','2014-04-01','17:20:00',3.12),('16100','2014-04-01','17:25:00',2.92),('16100','2014-04-01','17:30:00',2.55),('16100','2014-04-01','17:35:00',2.42),('16100','2014-04-01','17:40:00',1.96),('16100','2014-04-01','17:45:00',2.07),('16100','2014-04-01','17:50:00',2.27),('16100','2014-04-01','17:55:00',1.76),('16100','2014-04-01','18:00:00',1.3),('16100','2014-04-01','18:05:00',1.01),('16100','2014-04-01','18:15:00',1.03),('16100','2013-05-30','07:45:00',1.16),('16100','2013-05-30','07:50:00',1.4),('16100','2013-05-30','07:55:00',1.7),('16100','2013-05-30','08:00:00',1.59),('16100','2013-05-30','08:10:00',1.54),('16100','2013-05-30','08:15:00',2.13),('16100','2013-05-30','08:20:00',2.41),('16100','2013-05-30','08:25:00',2.67),('16100','2013-05-30','08:30:00',2.9),('16100','2013-05-30','08:35:00',3.26),('16100','2013-05-30','08:40:00',3.33),('16100','2013-05-30','08:45:00',2.49),('16100','2013-05-30','08:50:00',1.68),('16100','2013-05-30','08:55:00',1.32),('16100','2013-05-30','09:00:00',1.9),('16100','2013-05-30','09:05:00',4.2),('16100','2013-05-30','09:10:00',2.68),('16100','2013-05-30','09:15:00',3.55),('16100','2013-05-30','09:20:00',2.14),('16100','2013-05-30','09:25:00',4.14),('16100','2013-05-30','09:30:00',4.96),('16100','2013-05-30','09:35:00',4.4),('16100','2013-05-30','09:40:00',5.62),('16100','2013-05-30','09:45:00',5.88),('16100','2013-05-30','09:50:00',4.66),('16100','2013-05-30','09:55:00',5.66),('16100','2013-05-30','10:00:00',5.35),('16100','2013-05-30','10:05:00',5.16),('16100','2013-05-30','10:10:00',5.56),('16100','2013-05-30','10:15:00',3.35),('16100','2013-05-30','10:20:00',2),('16100','2013-05-30','10:25:00',1.97),('16100','2013-05-30','10:30:00',4.61),('16100','2013-05-30','10:35:00',7.37),('16100','2013-05-30','10:40:00',6.56),('16100','2013-05-30','10:45:00',7.98),('16100','2013-05-30','10:50:00',3.52),('16100','2013-05-30','10:55:00',4.06),('16100','2013-05-30','11:00:00',3.54),('16100','2013-05-30','11:05:00',4.27),('16100','2013-05-30','11:10:00',4.55),('16100','2013-05-30','11:15:00',8.44),('16100','2013-05-30','11:20:00',1.49),('16100','2013-05-30','11:25:00',7.8),('16100','2013-05-30','11:30:00',4.76),('16100','2013-05-30','11:35:00',1.65),('16100','2013-05-30','11:40:00',7.24),('16100','2013-05-30','11:45:00',1.81),('16100','2013-05-30','11:50:00',2.61),('16100','2013-05-30','11:55:00',3.83),('16100','2013-05-30','12:00:00',9.51),('16100','2013-05-30','12:05:00',5.47),('16100','2013-05-30','12:10:00',3.4),('16100','2013-05-30','12:15:00',5.05),('16100','2013-05-30','12:20:00',4.88),('16100','2013-05-30','12:25:00',6.11),('16100','2013-05-30','12:30:00',2.49),('16100','2013-05-30','12:35:00',3.14),('16100','2013-05-30','12:40:00',2.34),('16100','2013-05-30','12:50:00',4.15),('16100','2013-05-30','12:55:00',9.12),('16100','2013-05-30','13:00:00',5.11),('16100','2013-05-30','13:05:00',1.82),('16100','2013-05-30','13:10:00',1.57),('16100','2013-05-30','13:15:00',4.47),('16100','2013-05-30','13:20:00',6.99),('16100','2013-05-30','13:25:00',6.08),('16100','2013-05-30','13:30:00',3.34),('16100','2013-05-30','13:35:00',1.76),('16100','2013-05-30','13:40:00',2.27),('16100','2013-05-30','13:45:00',7.23),('16100','2013-05-30','13:50:00',7.82),('16100','2013-05-30','13:55:00',4.05),('16100','2013-05-30','14:00:00',1.52),('16100','2013-05-30','14:20:00',1.03),('16100','2013-05-30','14:25:00',1.97),('16100','2013-05-30','14:30:00',3.07),('16100','2013-05-30','14:35:00',1.41),('16100','2013-05-30','14:45:00',1.22),('16100','2013-05-30','14:55:00',2.12),('16100','2013-05-30','15:00:00',2.47),('16100','2013-05-30','15:05:00',2.21),('16100','2013-05-30','15:10:00',3.8),('16100','2013-05-30','15:15:00',5.05),('16100','2013-05-30','15:20:00',6.08),('16100','2013-05-30','15:25:00',4.17),('16100','2013-05-30','15:30:00',4.19),('16100','2013-05-30','15:35:00',3.35),('16100','2013-05-30','15:40:00',3),('16100','2013-05-30','15:45:00',4.68),('16100','2013-05-30','15:50:00',6.33),('16100','2013-05-30','15:55:00',4.26),('16100','2013-05-30','16:00:00',2.5),('16100','2013-05-30','16:05:00',1.7),('16100','2013-05-30','16:10:00',1.31),('16100','2013-05-30','16:15:00',1.19),('16100','2013-05-30','16:20:00',2.05),('16100','2013-05-30','16:25:00',1.99),('16100','2013-05-30','16:30:00',1.41),('16100','2013-05-30','16:35:00',1.35),('16100','2013-05-30','16:40:00',1.69),('16100','2013-05-30','16:45:00',1.41),('16100','2013-05-30','17:20:00',1.1),('16100','2013-05-30','17:25:00',1.22),('16100','2013-05-30','17:30:00',1.2),('16100','2013-05-30','17:35:00',1.14),('16100','2013-05-29','07:40:00',1.08),('16100','2013-05-29','07:45:00',1.77),('16100','2013-05-29','07:50:00',1.22),('16100','2013-05-29','07:55:00',1.28),('16100','2013-05-29','08:00:00',1.15),('16100','2013-05-29','08:05:00',1.07),('16100','2013-05-29','08:10:00',1.37),('16100','2013-05-29','08:15:00',1.36),('16100','2013-05-29','08:20:00',1.02),('16100','2013-05-29','08:25:00',1.09),('16100','2013-05-29','08:30:00',2.8),('16100','2013-05-29','08:35:00',3.2),('16100','2013-05-29','08:40:00',3.36),('16100','2013-05-29','08:45:00',3.53),('16100','2013-05-29','08:50:00',3.65),('16100','2013-05-29','08:55:00',3.89),('16100','2013-05-29','09:00:00',4.17),('16100','2013-05-29','09:05:00',4.44),('16100','2013-05-29','09:10:00',4.66),('16100','2013-05-29','09:15:00',5),('16100','2013-05-29','09:20:00',5.39),('16100','2013-05-29','09:25:00',5.53),('16100','2013-05-29','09:30:00',4.6),('16100','2013-05-29','09:35:00',5.22),('16100','2013-05-29','09:40:00',4.32),('16100','2013-05-29','09:45:00',4.4),('16100','2013-05-29','09:50:00',2.54),('16100','2013-05-29','09:55:00',3.67),('16100','2013-05-29','10:00:00',2.8),('16100','2013-05-29','10:05:00',4.45),('16100','2013-05-29','10:10:00',4.17),('16100','2013-05-29','10:15:00',5.35),('16100','2013-05-29','10:20:00',4.58),('16100','2013-05-29','10:25:00',3.73),('16100','2013-05-29','10:30:00',1.51),('16100','2013-05-29','10:35:00',1.05),('16100','2013-05-29','10:40:00',6.84),('16100','2013-05-29','10:45:00',8.23),('16100','2013-05-29','10:50:00',8.02),('16100','2013-05-29','10:55:00',7.15),('16100','2013-05-29','11:00:00',8.12),('16100','2013-05-29','11:05:00',5.42),('16100','2013-05-29','11:10:00',7.17),('16100','2013-05-29','11:15:00',3.79),('16100','2013-05-29','11:20:00',6.22),('16100','2013-05-29','11:25:00',8.05),('16100','2013-05-29','11:30:00',2.77),('16100','2013-05-29','11:35:00',6.83),('16100','2013-05-29','11:40:00',8.81),('16100','2013-05-29','11:45:00',5.71),('16100','2013-05-29','11:50:00',3.88),('16100','2013-05-29','11:55:00',8.94),('16100','2013-05-29','12:00:00',2.81),('16100','2013-05-29','12:05:00',1.68),('16100','2013-05-29','12:10:00',7.79),('16100','2013-05-29','12:15:00',8.44),('16100','2013-05-29','12:20:00',6.06),('16100','2013-05-29','12:25:00',5.88),('16100','2013-05-29','12:30:00',8.28),('16100','2013-05-29','12:35:00',9.32),('16100','2013-05-29','12:40:00',6.5),('16100','2013-05-29','12:45:00',4.42),('16100','2013-05-29','12:50:00',8.21),('16100','2013-05-29','12:55:00',5.2),('16100','2013-05-29','13:00:00',7.86),('16100','2013-05-29','13:05:00',9.48),('16100','2013-05-29','13:10:00',3.35),('16100','2013-05-29','13:15:00',3.56),('16100','2013-05-29','13:20:00',5.55),('16100','2013-05-29','13:25:00',4.87),('16100','2013-05-29','13:30:00',6.8),('16100','2013-05-29','13:35:00',3.93),('16100','2013-05-29','13:40:00',3.32),('16100','2013-05-29','13:45:00',4.42),('16100','2013-05-29','13:50:00',8.42),('16100','2013-05-29','13:55:00',8.46),('16100','2013-05-29','14:00:00',8.21),('16100','2013-05-29','14:05:00',3.59),('16100','2013-05-29','14:10:00',5.01),('16100','2013-05-29','14:15:00',4.74),('16100','2013-05-29','14:20:00',6.39),('16100','2013-05-29','14:25:00',2.89),('16100','2013-05-29','14:30:00',4.03),('16100','2013-05-29','14:35:00',2.57),('16100','2013-05-29','14:40:00',7.11),('16100','2013-05-29','14:45:00',2.84),('16100','2013-05-29','14:50:00',3.26),('16100','2013-05-29','14:55:00',3.96),('16100','2013-05-29','15:00:00',3.27),('16100','2013-05-29','15:05:00',4.99),('16100','2013-05-29','15:10:00',6.09),('16100','2013-05-29','15:15:00',2.46),('16100','2013-05-29','15:20:00',6.01),('16100','2013-05-29','15:25:00',2.69),('16100','2013-05-29','15:30:00',4.73),('16100','2013-05-29','15:35:00',3.17),('16100','2013-05-29','15:40:00',8.68),('16100','2013-05-29','15:45:00',7.46),('16100','2013-05-29','15:50:00',2.56),('16100','2013-05-29','15:55:00',1.78),('16100','2013-05-29','16:00:00',6.49),('16100','2013-05-29','16:05:00',7.13),('16100','2013-05-29','16:10:00',7),('16100','2013-05-29','16:15:00',4.73),('16100','2013-05-29','16:20:00',1.25),('16100','2013-05-29','16:25:00',1.75),('16100','2013-05-29','16:30:00',1.7),('16100','2013-05-29','16:35:00',1.75),('16100','2013-05-29','16:40:00',4.49),('16100','2013-05-29','16:45:00',5.3),('16100','2013-05-29','16:50:00',1.97),('16100','2013-05-29','16:55:00',2.22),('16100','2013-05-29','17:00:00',4.02),('16100','2013-05-29','17:05:00',2.06),('16100','2013-05-29','17:10:00',2.41),('16100','2013-05-29','17:15:00',1.32),('16100','2013-05-29','17:55:00',1.5),('16100','2013-05-29','18:00:00',1.7),('16100','2013-05-29','18:05:00',2.47),('16100','2013-05-29','18:10:00',1.99),('16100','2013-05-29','18:15:00',1.14),('16100','2013-05-29','18:20:00',1.23),('16100','2013-05-29','18:25:00',2.25),('16100','2013-05-29','18:30:00',2.57),('16100','2013-05-29','18:35:00',2.59),('16100','2013-05-29','18:40:00',2.19),('16100','2013-05-29','18:45:00',1.75),('16100','2013-05-29','18:50:00',1.01),('16100','2013-05-28','07:45:00',1.08),('16100','2013-05-28','07:50:00',1.31),('16100','2013-05-28','07:55:00',1.52),('16100','2013-05-28','08:00:00',1.72),('16100','2013-05-28','08:05:00',1.9),('16100','2013-05-28','08:10:00',2.1),('16100','2013-05-28','08:15:00',2.29),('16100','2013-05-28','08:20:00',2.44),('16100','2013-05-28','08:25:00',2.61),('16100','2013-05-28','08:30:00',2.8),('16100','2013-05-28','08:35:00',2.98),('16100','2013-05-28','08:40:00',3.15),('16100','2013-05-28','08:45:00',3.38),('16100','2013-05-28','08:50:00',3.52),('16100','2013-05-28','08:55:00',3.71),('16100','2013-05-28','09:00:00',3.96),('16100','2013-05-28','09:05:00',4.31),('16100','2013-05-28','09:10:00',4.47),('16100','2013-05-28','09:15:00',4.63),('16100','2013-05-28','09:20:00',4.77),('16100','2013-05-28','09:25:00',4.93),('16100','2013-05-28','09:30:00',5.07),('16100','2013-05-28','09:35:00',5.2),('16100','2013-05-28','09:40:00',5.37),('16100','2013-05-28','09:45:00',5.5),('16100','2013-05-28','09:50:00',5.64),('16100','2013-05-28','09:55:00',5.75),('16100','2013-05-28','10:00:00',5.94),('16100','2013-05-28','10:05:00',6.08),('16100','2013-05-28','10:10:00',6.22),('16100','2013-05-28','10:15:00',6.34),('16100','2013-05-28','10:20:00',6.52),('16100','2013-05-28','10:25:00',6.66),('16100','2013-05-28','10:30:00',6.79),('16100','2013-05-28','10:35:00',6.9),('16100','2013-05-28','10:40:00',6.99),('16100','2013-05-28','10:45:00',7.12),('16100','2013-05-28','10:50:00',7.28),('16100','2013-05-28','10:55:00',7.55),('16100','2013-05-28','11:00:00',7.36),('16100','2013-05-28','11:05:00',7.86),('16100','2013-05-28','11:10:00',8.01),('16100','2013-05-28','11:15:00',8.31),('16100','2013-05-28','11:20:00',8.53),('16100','2013-05-28','11:25:00',5.17),('16100','2013-05-28','11:30:00',4.6),('16100','2013-05-28','11:35:00',5.88),('16100','2013-05-28','11:40:00',6.91),('16100','2013-05-28','11:45:00',8.01),('16100','2013-05-28','11:50:00',7.66),('16100','2013-05-28','11:55:00',8.79),('16100','2013-05-28','12:00:00',8.36),('16100','2013-05-28','12:05:00',3.64),('16100','2013-05-28','12:10:00',8.47),('16100','2013-05-28','12:15:00',8.49),('16100','2013-05-28','12:20:00',8.49),('16100','2013-05-28','12:25:00',8.42),('16100','2013-05-28','12:30:00',6.78),('16100','2013-05-28','12:35:00',8.5),('16100','2013-05-28','12:40:00',8.62),('16100','2013-05-28','12:45:00',8.45),('16100','2013-05-28','12:50:00',8.47),('16100','2013-05-28','12:55:00',8.59),('16100','2013-05-28','13:00:00',8.64),('16100','2013-05-28','13:05:00',8.63),('16100','2013-05-28','13:10:00',8.88),('16100','2013-05-28','13:15:00',6.69),('16100','2013-05-28','13:20:00',3.95),('16100','2013-05-28','13:25:00',9.39),('16100','2013-05-28','13:30:00',6.86),('16100','2013-05-28','13:35:00',4.27),('16100','2013-05-28','13:40:00',5.43),('16100','2013-05-28','13:45:00',3.71),('16100','2013-05-28','13:50:00',6.56),('16100','2013-05-28','13:55:00',8.46),('16100','2013-05-28','14:00:00',7.06),('16100','2013-05-28','14:05:00',4.81),('16100','2013-05-28','14:10:00',5.95),('16100','2013-05-28','14:15:00',8.52),('16100','2013-05-28','14:20:00',8.24),('16100','2013-05-28','14:25:00',8.35),('16100','2013-05-28','14:30:00',8.21),('16100','2013-05-28','14:35:00',7.42),('16100','2013-05-28','14:40:00',3.48),('16100','2013-05-28','14:45:00',5.23),('16100','2013-05-28','14:50:00',5.31),('16100','2013-05-28','14:55:00',4.94),('16100','2013-05-28','15:00:00',8.1),('16100','2013-05-28','15:05:00',5.17),('16100','2013-05-28','15:10:00',6.48),('16100','2013-05-28','15:15:00',6.26),('16100','2013-05-28','15:20:00',5.45),('16100','2013-05-28','15:25:00',6.55),('16100','2013-05-28','15:30:00',6.59),('16100','2013-05-28','15:35:00',6.44),('16100','2013-05-28','15:40:00',6.16),('16100','2013-05-28','15:45:00',5.78),('16100','2013-05-28','15:50:00',5.08),('16100','2013-05-28','15:55:00',5.16),('16100','2013-05-28','16:00:00',4.41),('16100','2013-05-28','16:05:00',4.22),('16100','2013-05-28','16:10:00',4.29),('16100','2013-05-28','16:15:00',4.12),('16100','2013-05-28','16:20:00',4.24),('16100','2013-05-28','16:25:00',4.25),('16100','2013-05-28','16:30:00',4.69),('16100','2013-05-28','16:35:00',4.24),('16100','2013-05-28','16:40:00',3.18),('16100','2013-05-28','16:45:00',2.96),('16100','2013-05-28','16:50:00',2.27),('16100','2013-05-28','16:55:00',1.88),('16100','2013-05-28','17:00:00',1.35),('16100','2013-05-28','17:25:00',1.05),('16100','2013-05-28','17:30:00',1.83),('16100','2013-05-28','17:35:00',2.63),('16100','2013-05-28','17:40:00',2.63),('16100','2013-05-28','17:45:00',1.78),('16100','2013-05-28','17:50:00',1.34),('16100','2013-05-28','17:55:00',1.88),('16100','2013-05-28','18:00:00',1.95),('16100','2013-05-28','18:05:00',1.66),('16100','2013-05-28','18:10:00',2.5),('16100','2013-05-28','18:15:00',3.25),('16100','2013-05-28','18:20:00',1.8),('16100','2013-05-28','18:55:00',1.22),('16100','2013-05-28','19:00:00',1.08),('16100','2013-05-27','07:30:00',1.18),('16100','2013-05-27','07:35:00',1.16),('16100','2013-05-27','07:40:00',1.16),('16100','2013-05-27','07:45:00',1.4),('16100','2013-05-27','07:50:00',1.52),('16100','2013-05-27','07:55:00',1.49),('16100','2013-05-27','08:00:00',1.37),('16100','2013-05-27','08:05:00',1.71),('16100','2013-05-27','08:10:00',1.77),('16100','2013-05-27','08:15:00',2.13),('16100','2013-05-27','08:20:00',2.25),('16100','2013-05-27','08:25:00',1.99),('16100','2013-05-27','08:30:00',2.52),('16100','2013-05-27','08:35:00',2.66),('16100','2013-05-27','08:40:00',2.47),('16100','2013-05-27','08:45:00',2.11),('16100','2013-05-27','08:50:00',2.43),('16100','2013-05-27','08:55:00',2.48),('16100','2013-05-27','09:00:00',2.33),('16100','2013-05-27','09:05:00',2.88),('16100','2013-05-27','09:10:00',3.01),('16100','2013-05-27','09:15:00',3.35),('16100','2013-05-27','09:20:00',3.34),('16100','2013-05-27','09:25:00',3.47),('16100','2013-05-27','09:30:00',3.84),('16100','2013-05-27','09:35:00',4.32),('16100','2013-05-27','09:40:00',4.18),('16100','2013-05-27','09:45:00',4.29),('16100','2013-05-27','09:50:00',4.01),('16100','2013-05-27','09:55:00',4.16),('16100','2013-05-27','10:00:00',3.51),('16100','2013-05-27','10:05:00',3.44),('16100','2013-05-27','10:10:00',3.89),('16100','2013-05-27','10:15:00',4.16),('16100','2013-05-27','10:20:00',4.13),('16100','2013-05-27','10:25:00',4.07),('16100','2013-05-27','10:30:00',4.51),('16100','2013-05-27','10:35:00',5.11),('16100','2013-05-27','10:40:00',5.13),('16100','2013-05-27','10:45:00',4.69),('16100','2013-05-27','10:50:00',4.14),('16100','2013-05-27','10:55:00',4.88),('16100','2013-05-27','11:00:00',4.98),('16100','2013-05-27','11:05:00',5.13),('16100','2013-05-27','11:10:00',5.31),('16100','2013-05-27','11:15:00',5.51),('16100','2013-05-27','11:20:00',3.22),('16100','2013-05-27','11:25:00',4.96),('16100','2013-05-27','11:30:00',6.89),('16100','2013-05-27','11:35:00',6.8),('16100','2013-05-27','11:40:00',6.95),('16100','2013-05-27','11:45:00',4.83),('16100','2013-05-27','11:50:00',1.84),('16100','2013-05-27','11:55:00',1.95),('16100','2013-05-27','12:00:00',3.11),('16100','2013-05-27','12:05:00',3.69),('16100','2013-05-27','12:10:00',3.76),('16100','2013-05-27','12:15:00',4.29),('16100','2013-05-27','12:20:00',3.88),('16100','2013-05-27','12:25:00',4.09),('16100','2013-05-27','12:30:00',5.44),('16100','2013-05-27','12:35:00',3.95),('16100','2013-05-27','12:40:00',4.06),('16100','2013-05-27','12:45:00',3.92),('16100','2013-05-27','12:50:00',4),('16100','2013-05-27','12:55:00',4.54),('16100','2013-05-27','13:00:00',4.73),('16100','2013-05-27','13:05:00',4.87),('16100','2013-05-27','13:10:00',4.5),('16100','2013-05-27','13:15:00',3.19),('16100','2013-05-27','13:20:00',3.65),('16100','2013-05-27','13:25:00',6.36),('16100','2013-05-27','13:30:00',6.35),('16100','2013-05-27','13:35:00',6.98),('16100','2013-05-27','13:40:00',4.94),('16100','2013-05-27','13:45:00',4.17),('16100','2013-05-27','13:50:00',3.18),('16100','2013-05-27','13:55:00',3.06),('16100','2013-05-27','14:00:00',3.09),('16100','2013-05-27','14:05:00',4.04),('16100','2013-05-27','14:10:00',4.22),('16100','2013-05-27','14:15:00',5.36),('16100','2013-05-27','14:20:00',5.9),('16100','2013-05-27','14:25:00',5.22),('16100','2013-05-27','14:30:00',5.44),('16100','2013-05-27','14:35:00',6.47),('16100','2013-05-27','14:40:00',5.18),('16100','2013-05-27','14:45:00',5.14),('16100','2013-05-27','14:50:00',6.24),('16100','2013-05-27','14:55:00',6.09),('16100','2013-05-27','15:00:00',6.53),('16100','2013-05-27','15:05:00',4.4),('16100','2013-05-27','15:10:00',3.01),('16100','2013-05-27','15:15:00',3.8),('16100','2013-05-27','15:20:00',4.46),('16100','2013-05-27','15:25:00',2.98),('16100','2013-05-27','15:30:00',2.91),('16100','2013-05-27','15:35:00',3.4),('16100','2013-05-27','15:40:00',2.76),('16100','2013-05-27','15:45:00',3.72),('16100','2013-05-27','15:50:00',3.77),('16100','2013-05-27','15:55:00',5.08),('16100','2013-05-27','16:00:00',5.81),('16100','2013-05-27','16:05:00',3.49),('16100','2013-05-27','16:10:00',2.9),('16100','2013-05-27','16:15:00',3.05),('16100','2013-05-27','16:20:00',5.4),('16100','2013-05-27','16:25:00',4.64),('16100','2013-05-27','16:30:00',2.18),('16100','2013-05-27','16:35:00',2.3),('16100','2013-05-27','16:40:00',4.82),('16100','2013-05-27','16:45:00',4.97),('16100','2013-05-27','16:50:00',4.77),('16100','2013-05-27','16:55:00',4.61),('16100','2013-05-27','17:00:00',4.47),('16100','2013-05-27','17:05:00',4.32),('16100','2013-05-27','17:10:00',4.21),('16100','2013-05-27','17:15:00',4.04),('16100','2013-05-27','17:20:00',3.88),('16100','2013-05-27','17:25:00',3.76),('16100','2013-05-27','17:30:00',3.61),('16100','2013-05-27','17:35:00',3.42),('16100','2013-05-27','17:40:00',3.2),('16100','2013-05-27','17:45:00',3.08),('16100','2013-05-27','17:50:00',2.93),('16100','2013-05-27','17:55:00',2.74),('16100','2013-05-27','18:00:00',2.43),('16100','2013-05-27','18:05:00',1.55),('16100','2013-05-27','18:10:00',1.52),('16100','2013-05-27','18:15:00',2.11),('16100','2013-05-27','18:20:00',2.17),('16100','2013-05-27','18:25:00',1.91),('16100','2013-05-27','18:30:00',1.65),('16100','2013-05-27','18:35:00',1.41),('16100','2013-05-27','18:40:00',1.29),('16100','2013-05-27','18:45:00',1.16),('16100','2013-05-27','18:50:00',1.02),('16100','2013-05-26','07:45:00',1.02),('16100','2013-05-26','07:50:00',1.51),('16100','2013-05-26','07:55:00',1.56),('16100','2013-05-26','08:00:00',1.34),('16100','2013-05-26','08:05:00',2.46),('16100','2013-05-26','08:10:00',1.6),('16100','2013-05-26','08:15:00',1.31),('16100','2013-05-26','08:20:00',1.28),('16100','2013-05-26','08:25:00',2.29),('16100','2013-05-26','08:30:00',2.96),('16100','2013-05-26','08:35:00',3.28),('16100','2013-05-26','08:40:00',3.41),('16100','2013-05-26','08:45:00',3.8),('16100','2013-05-26','08:50:00',3.3),('16100','2013-05-26','08:55:00',3.68),('16100','2013-05-26','09:00:00',4.87),('16100','2013-05-26','09:05:00',3.45),('16100','2013-05-26','09:10:00',2.31),('16100','2013-05-26','09:15:00',5.31),('16100','2013-05-26','09:20:00',5.56),('16100','2013-05-26','09:25:00',5.36),('16100','2013-05-26','09:30:00',4.03),('16100','2013-05-26','09:35:00',5.55),('16100','2013-05-26','09:40:00',5.61),('16100','2013-05-26','09:45:00',5.43),('16100','2013-05-26','09:50:00',5.94),('16100','2013-05-26','09:55:00',6.07),('16100','2013-05-26','10:00:00',4.62),('16100','2013-05-26','10:05:00',6.56),('16100','2013-05-26','10:10:00',6.9),('16100','2013-05-26','10:15:00',6.79),('16100','2013-05-26','10:20:00',7.12),('16100','2013-05-26','10:25:00',5.82),('16100','2013-05-26','10:30:00',6.51),('16100','2013-05-26','10:35:00',7.77),('16100','2013-05-26','10:40:00',3.77),('16100','2013-05-26','10:45:00',4.6),('16100','2013-05-26','10:50:00',5.18),('16100','2013-05-26','10:55:00',5.37),('16100','2013-05-26','11:00:00',5.8),('16100','2013-05-26','11:05:00',7.01),('16100','2013-05-26','11:10:00',7.72),('16100','2013-05-26','11:15:00',2.94),('16100','2013-05-26','11:20:00',5.75),('16100','2013-05-26','11:25:00',8.29),('16100','2013-05-26','11:30:00',6.07),('16100','2013-05-26','11:35:00',5.72),('16100','2013-05-26','11:40:00',3.9),('16100','2013-05-26','11:45:00',7.81),('16100','2013-05-26','11:50:00',5.51),('16100','2013-05-26','11:55:00',4.01),('16100','2013-05-26','12:00:00',9.18),('16100','2013-05-26','12:05:00',7.21),('16100','2013-05-26','12:10:00',9.09),('16100','2013-05-26','12:15:00',4.68),('16100','2013-05-26','12:20:00',6.71),('16100','2013-05-26','12:25:00',9),('16100','2013-05-26','12:30:00',8.77),('16100','2013-05-26','12:35:00',8.59),('16100','2013-05-26','12:40:00',8.64),('16100','2013-05-26','12:45:00',8.7),('16100','2013-05-26','12:50:00',8.83),('16100','2013-05-26','12:55:00',8.75),('16100','2013-05-26','13:00:00',8.87),('16100','2013-05-26','13:05:00',8.6),('16100','2013-05-26','13:10:00',8.16),('16100','2013-05-26','13:15:00',8.13),('16100','2013-05-26','13:20:00',8.17),('16100','2013-05-26','13:25:00',8.5),('16100','2013-05-26','13:30:00',7.87),('16100','2013-05-26','13:35:00',8.24),('16100','2013-05-26','13:40:00',8.66),('16100','2013-05-26','13:45:00',7.31),('16100','2013-05-26','13:50:00',8.56),('16100','2013-05-26','13:55:00',8.36),('16100','2013-05-26','14:00:00',8.13),('16100','2013-05-26','14:05:00',8.38),('16100','2013-05-26','14:10:00',8.27),('16100','2013-05-26','14:15:00',8.01),('16100','2013-05-26','14:20:00',8.15),('16100','2013-05-26','14:25:00',8.13),('16100','2013-05-26','14:30:00',8.16),('16100','2013-05-26','14:35:00',8.17),('16100','2013-05-26','14:40:00',8.07),('16100','2013-05-26','14:45:00',8.1),('16100','2013-05-26','14:50:00',7.73),('16100','2013-05-26','14:55:00',6.56),('16100','2013-05-26','15:00:00',3.85),('16100','2013-05-26','15:05:00',7.74),('16100','2013-05-26','15:10:00',7.56),('16100','2013-05-26','15:15:00',5.2),('16100','2013-05-26','15:20:00',5.7),('16100','2013-05-26','15:25:00',7.29),('16100','2013-05-26','15:30:00',7.12),('16100','2013-05-26','15:35:00',6.84),('16100','2013-05-26','15:40:00',4.52),('16100','2013-05-26','15:45:00',6.33),('16100','2013-05-26','15:50:00',6.43),('16100','2013-05-26','15:55:00',5.69),('16100','2013-05-26','16:00:00',6.25),('16100','2013-05-26','16:05:00',5.08),('16100','2013-05-26','16:10:00',3.83),('16100','2013-05-26','16:15:00',4.58),('16100','2013-05-26','16:20:00',6.68),('16100','2013-05-26','16:25:00',6.07),('16100','2013-05-26','16:30:00',5.49),('16100','2013-05-26','16:35:00',5.7),('16100','2013-05-26','16:40:00',2.82),('16100','2013-05-26','16:45:00',2.12),('16100','2013-05-26','16:50:00',2.15),('16100','2013-05-26','16:55:00',2.31),('16100','2013-05-26','17:00:00',2.44),('16100','2013-05-26','17:05:00',2.65),('16100','2013-05-26','17:10:00',2.85),('16100','2013-05-26','17:15:00',2.16),('16100','2013-05-26','17:20:00',1.94),('16100','2013-05-26','17:25:00',1.88),('16100','2013-05-26','17:30:00',1.79),('16100','2013-05-26','17:35:00',1.62),('16100','2013-05-26','17:40:00',1.5),('16100','2013-05-26','17:45:00',1.43),('16100','2013-05-26','17:50:00',1.38),('16100','2013-05-26','17:55:00',1.42),('16100','2013-05-26','18:00:00',1.33),('16100','2013-05-26','18:05:00',1.26),('16100','2013-05-26','18:10:00',1.45),('16100','2013-05-26','18:15:00',1.47),('16100','2013-05-26','18:20:00',2.15),('16100','2013-05-26','18:25:00',2.67),('16100','2013-05-26','18:30:00',2.32),('16100','2013-05-26','18:35:00',1.24),('16100','2013-05-26','18:55:00',1.26),('16100','2013-05-26','19:00:00',1.32),('16100','2013-05-26','19:05:00',1.2),('16100','2013-05-25','07:40:00',1.11),('16100','2013-05-25','07:45:00',2.02),('16100','2013-05-25','07:50:00',1.11),('16100','2013-05-25','07:55:00',1.21),('16100','2013-05-25','08:00:00',1.65),('16100','2013-05-25','08:05:00',2.02),('16100','2013-05-25','08:10:00',1.88),('16100','2013-05-25','08:15:00',3.26),('16100','2013-05-25','08:20:00',2.22),('16100','2013-05-25','08:25:00',2.08),('16100','2013-05-25','08:30:00',1.8),('16100','2013-05-25','08:35:00',2.25),('16100','2013-05-25','08:40:00',3.62),('16100','2013-05-25','08:45:00',2.53),('16100','2013-05-25','08:50:00',1.64),('16100','2013-05-25','08:55:00',1.82),('16100','2013-05-25','09:00:00',3),('16100','2013-05-25','09:05:00',1.98),('16100','2013-05-25','09:10:00',3.06),('16100','2013-05-25','09:15:00',1.69),('16100','2013-05-25','09:20:00',1.41),('16100','2013-05-25','09:25:00',2.39),('16100','2013-05-25','09:30:00',3.55),('16100','2013-05-25','09:40:00',4.17),('16100','2013-05-25','09:50:00',1.02),('16100','2013-05-25','09:55:00',4.45),('16100','2013-05-25','10:00:00',6.02),('16100','2013-05-25','10:05:00',1.58),('16100','2013-05-25','10:10:00',5.35),('16100','2013-05-25','10:15:00',6.08),('16100','2013-05-25','10:20:00',7.13),('16100','2013-05-25','10:25:00',5.79),('16100','2013-05-25','10:30:00',7.38),('16100','2013-05-25','10:35:00',7.29),('16100','2013-05-25','10:40:00',7.37),('16100','2013-05-25','10:45:00',7.46),('16100','2013-05-25','10:50:00',7.53),('16100','2013-05-25','10:55:00',7.65),('16100','2013-05-25','11:00:00',7.77),('16100','2013-05-25','11:05:00',7.97),('16100','2013-05-25','11:10:00',7.98),('16100','2013-05-25','11:15:00',8.04),('16100','2013-05-25','11:20:00',6.94),('16100','2013-05-25','11:25:00',8.22),('16100','2013-05-25','11:30:00',8.28),('16100','2013-05-25','11:35:00',8.39),('16100','2013-05-25','11:40:00',8.34),('16100','2013-05-25','11:45:00',8.44),('16100','2013-05-25','11:50:00',8.51),('16100','2013-05-25','11:55:00',8.59),('16100','2013-05-25','12:00:00',8.68),('16100','2013-05-25','12:05:00',8.87),('16100','2013-05-25','12:10:00',8.96),('16100','2013-05-25','12:15:00',8.1),('16100','2013-05-25','12:20:00',9.06),('16100','2013-05-25','12:25:00',9.15),('16100','2013-05-25','12:30:00',6),('16100','2013-05-25','12:35:00',2.96),('16100','2013-05-25','12:40:00',5.06),('16100','2013-05-25','12:45:00',6.15),('16100','2013-05-25','12:50:00',5.17),('16100','2013-05-25','12:55:00',6.85),('16100','2013-05-25','13:00:00',9.28),('16100','2013-05-25','13:05:00',8.83),('16100','2013-05-25','13:10:00',8.94),('16100','2013-05-25','13:15:00',8.9),('16100','2013-05-25','13:20:00',8.99),('16100','2013-05-25','13:25:00',6.91),('16100','2013-05-25','13:30:00',8.86),('16100','2013-05-25','13:35:00',8.85),('16100','2013-05-25','13:40:00',8.8),('16100','2013-05-25','13:45:00',8.83),('16100','2013-05-25','13:50:00',8.73),('16100','2013-05-25','13:55:00',8.67),('16100','2013-05-25','14:00:00',8.58),('16100','2013-05-25','14:05:00',8.49),('16100','2013-05-25','14:10:00',8.48),('16100','2013-05-25','14:15:00',8.46),('16100','2013-05-25','14:20:00',8.38),('16100','2013-05-25','14:25:00',8.34),('16100','2013-05-25','14:30:00',8.28),('16100','2013-05-25','14:35:00',8.24),('16100','2013-05-25','14:40:00',8.16),('16100','2013-05-25','14:45:00',8.12),('16100','2013-05-25','14:50:00',8.07),('16100','2013-05-25','14:55:00',7.96),('16100','2013-05-25','15:00:00',7.89),('16100','2013-05-25','15:05:00',7.81),('16100','2013-05-25','15:10:00',7.79),('16100','2013-05-25','15:15:00',7.65),('16100','2013-05-25','15:20:00',7.48),('16100','2013-05-25','15:25:00',7.38),('16100','2013-05-25','15:30:00',7.31),('16100','2013-05-25','15:35:00',7.2),('16100','2013-05-25','15:40:00',7.15),('16100','2013-05-25','15:45:00',7.08),('16100','2013-05-25','15:50:00',6.93),('16100','2013-05-25','15:55:00',6.83),('16100','2013-05-25','16:00:00',6.74),('16100','2013-05-25','16:05:00',6.62),('16100','2013-05-25','16:10:00',6.49),('16100','2013-05-25','16:15:00',6.31),('16100','2013-05-25','16:20:00',6.15),('16100','2013-05-25','16:25:00',6.02),('16100','2013-05-25','16:30:00',5.91),('16100','2013-05-25','16:35:00',5.76),('16100','2013-05-25','16:40:00',5.62),('16100','2013-05-25','16:45:00',5.46),('16100','2013-05-25','16:50:00',5.34),('16100','2013-05-25','16:55:00',5.22),('16100','2013-05-25','17:00:00',5.04),('16100','2013-05-25','17:05:00',4.84),('16100','2013-05-25','17:10:00',4.7),('16100','2013-05-25','17:15:00',4.56),('16100','2013-05-25','17:20:00',4.4),('16100','2013-05-25','17:25:00',4.23),('16100','2013-05-25','17:30:00',4.02),('16100','2013-05-25','17:35:00',3.83),('16100','2013-05-25','17:40:00',3.67),('16100','2013-05-25','17:45:00',3.51),('16100','2013-05-25','17:50:00',3.35),('16100','2013-05-25','17:55:00',3.14),('16100','2013-05-25','18:00:00',2.99),('16100','2013-05-25','18:05:00',2.81),('16100','2013-05-25','18:10:00',2.61),('16100','2013-05-25','18:15:00',2.35),('16100','2013-05-25','18:20:00',2.05),('16100','2013-05-25','18:25:00',1.94),('16100','2013-05-25','18:30:00',1.79),('16100','2013-05-25','18:35:00',1.62),('16100','2013-05-25','18:40:00',1.46),('16100','2013-05-25','18:45:00',1.29),('16100','2013-05-25','18:50:00',1.11),('16100','2013-05-24','07:35:00',1.22),('16100','2013-05-24','07:40:00',1.44),('16100','2013-05-24','07:45:00',1.57),('16100','2013-05-24','07:50:00',1.96),('16100','2013-05-24','07:55:00',1.96),('16100','2013-05-24','08:00:00',1.01),('16100','2013-05-24','08:15:00',1.26),('16100','2013-05-24','08:20:00',2.69),('16100','2013-05-24','08:25:00',2.89),('16100','2013-05-24','08:30:00',1.41),('16100','2013-05-24','08:35:00',2.87),('16100','2013-05-24','08:40:00',2.41),('16100','2013-05-24','08:45:00',2.45),('16100','2013-05-24','08:50:00',3.29),('16100','2013-05-24','08:55:00',4.48),('16100','2013-05-24','09:00:00',3.6),('16100','2013-05-24','09:05:00',4.03),('16100','2013-05-24','09:10:00',1.79),('16100','2013-05-24','09:15:00',1.62),('16100','2013-05-24','09:20:00',2.04),('16100','2013-05-24','09:25:00',4.16),('16100','2013-05-24','09:30:00',4.12),('16100','2013-05-24','09:35:00',2.34),('16100','2013-05-24','09:40:00',2.78),('16100','2013-05-24','09:45:00',3.17),('16100','2013-05-24','09:50:00',2.64),('16100','2013-05-24','09:55:00',1.33),('16100','2013-05-24','10:05:00',1.73),('16100','2013-05-24','10:10:00',2.11),('16100','2013-05-24','10:20:00',1.19),('16100','2013-05-24','10:30:00',1.82),('16100','2013-05-24','10:35:00',2.37),('16100','2013-05-24','10:40:00',1.17),('16100','2013-05-24','10:50:00',1.76),('16100','2013-05-24','10:55:00',1.75),('16100','2013-05-24','11:00:00',3.9),('16100','2013-05-24','11:05:00',7.53),('16100','2013-05-24','11:10:00',2.7),('16100','2013-05-24','11:15:00',3.65),('16100','2013-05-24','11:20:00',1.05),('16100','2013-05-24','11:25:00',1.57),('16100','2013-05-24','11:30:00',3.56),('16100','2013-05-24','11:35:00',2.63),('16100','2013-05-24','11:40:00',4.62),('16100','2013-05-24','11:45:00',4.28),('16100','2013-05-24','11:50:00',3.5),('16100','2013-05-24','11:55:00',4.71),('16100','2013-05-24','12:00:00',3.33),('16100','2013-05-24','12:05:00',2.55),('16100','2013-05-24','12:10:00',2.25),('16100','2013-05-24','12:15:00',3.02),('16100','2013-05-24','12:20:00',3.56),('16100','2013-05-24','12:25:00',2.13),('16100','2013-05-24','12:30:00',3.78),('16100','2013-05-24','12:35:00',1.38),('16100','2013-05-24','12:40:00',1.91),('16100','2013-05-24','12:45:00',3.08),('16100','2013-05-24','12:50:00',4.24),('16100','2013-05-24','12:55:00',3.2),('16100','2013-05-24','13:00:00',5.75),('16100','2013-05-24','13:05:00',2.82),('16100','2013-05-24','13:10:00',3.94),('16100','2013-05-24','13:15:00',3.69),('16100','2013-05-24','13:20:00',4.61),('16100','2013-05-24','13:25:00',3.42),('16100','2013-05-24','13:30:00',5.69),('16100','2013-05-24','13:35:00',3.68),('16100','2013-05-24','13:40:00',3.49),('16100','2013-05-24','13:45:00',3.94),('16100','2013-05-24','13:50:00',4.33),('16100','2013-05-24','13:55:00',7.57),('16100','2013-05-24','14:00:00',9.43),('16100','2013-05-24','14:05:00',8.04),('16100','2013-05-24','14:10:00',8.57),('16100','2013-05-24','14:15:00',3.04),('16100','2013-05-24','14:20:00',3.49),('16100','2013-05-24','14:25:00',7.9),('16100','2013-05-24','14:30:00',6.17),('16100','2013-05-24','14:35:00',5.85),('16100','2013-05-24','14:40:00',6.52),('16100','2013-05-24','14:45:00',4.28),('16100','2013-05-24','14:50:00',5.53),('16100','2013-05-24','14:55:00',5.58),('16100','2013-05-24','15:00:00',2.8),('16100','2013-05-24','15:05:00',4.13),('16100','2013-05-24','15:10:00',5.35),('16100','2013-05-24','15:15:00',2.13),('16100','2013-05-24','15:20:00',4.12),('16100','2013-05-24','15:25:00',4.6),('16100','2013-05-24','15:30:00',2.16),('16100','2013-05-24','15:35:00',3.67),('16100','2013-05-24','15:40:00',1.97),('16100','2013-05-24','15:45:00',6.05),('16100','2013-05-24','15:50:00',4.92),('16100','2013-05-24','15:55:00',5.1),('16100','2013-05-24','16:00:00',6.38),('16100','2013-05-24','16:05:00',3.89),('16100','2013-05-24','16:10:00',6.78),('16100','2013-05-24','16:15:00',3.95),('16100','2013-05-24','16:20:00',3.9),('16100','2013-05-24','16:25:00',4.79),('16100','2013-05-24','16:30:00',4.11),('16100','2013-05-24','16:35:00',2.76),('16100','2013-05-24','16:40:00',2.71),('16100','2013-05-24','16:45:00',3.59),('16100','2013-05-24','16:50:00',2.81),('16100','2013-05-24','16:55:00',5.46),('16100','2013-05-24','17:00:00',4.26),('16100','2013-05-24','17:05:00',1.68),('16100','2013-05-24','17:10:00',4.72),('16100','2013-05-24','17:15:00',2.36),('16100','2013-05-24','17:20:00',2.64),('16100','2013-05-24','17:25:00',1.65),('16100','2013-05-24','17:30:00',2.09),('16100','2013-05-24','17:35:00',4),('16100','2013-05-24','17:40:00',4.45),('16100','2013-05-24','17:45:00',3.92),('16100','2013-05-24','17:50:00',4.14),('16100','2013-05-24','17:55:00',3.76),('16100','2013-05-24','18:00:00',3.74),('16100','2013-05-24','18:05:00',1.65),('16100','2013-05-24','18:15:00',1.16),('16100','2013-05-23','07:55:00',1.13),('16100','2013-05-23','08:00:00',1.21),('16100','2013-05-23','08:05:00',1.92),('16100','2013-05-23','08:10:00',1.48),('16100','2013-05-23','08:15:00',2.35),('16100','2013-05-23','08:20:00',2.67),('16100','2013-05-23','08:25:00',2.82),('16100','2013-05-23','08:30:00',2.92),('16100','2013-05-23','08:35:00',1.3),('16100','2013-05-23','08:40:00',3.18),('16100','2013-05-23','08:45:00',3.56),('16100','2013-05-23','08:50:00',3.58),('16100','2013-05-23','08:55:00',3.96),('16100','2013-05-23','09:00:00',4.1),('16100','2013-05-23','09:05:00',3.69),('16100','2013-05-23','09:10:00',1.59),('16100','2013-05-23','09:15:00',3.52),('16100','2013-05-23','09:20:00',4.52),('16100','2013-05-23','09:25:00',1.14),('16100','2013-05-23','09:30:00',4.15),('16100','2013-05-23','09:35:00',2.75),('16100','2013-05-23','09:40:00',1.24),('16100','2013-05-23','09:45:00',1.04),('16100','2013-05-23','09:50:00',1.86),('16100','2013-05-23','09:55:00',5.33),('16100','2013-05-23','10:00:00',6.69),('16100','2013-05-23','10:05:00',2.37),('16100','2013-05-23','10:20:00',1.29),('16100','2013-05-23','10:25:00',2.55),('16100','2013-05-23','10:30:00',3.93),('16100','2013-05-23','10:35:00',4.23),('16100','2013-05-23','10:40:00',6.86),('16100','2013-05-23','10:45:00',3.19),('16100','2013-05-23','10:50:00',4.78),('16100','2013-05-23','10:55:00',3.95),('16100','2013-05-23','11:00:00',5.79),('16100','2013-05-23','11:05:00',7.9),('16100','2013-05-23','11:10:00',6.05),('16100','2013-05-23','11:15:00',4.67),('16100','2013-05-23','11:20:00',2.58),('16100','2013-05-23','11:25:00',6.41),('16100','2013-05-23','11:30:00',4.61),('16100','2013-05-23','11:35:00',8.86),('16100','2013-05-23','11:40:00',2.02),('16100','2013-05-23','11:45:00',1.49),('16100','2013-05-23','11:50:00',1.68),('16100','2013-05-23','11:55:00',2.52),('16100','2013-05-23','12:00:00',5.96),('16100','2013-05-23','12:05:00',6.42),('16100','2013-05-23','12:10:00',4.32),('16100','2013-05-23','12:15:00',3.36),('16100','2013-05-23','12:20:00',3.39),('16100','2013-05-23','12:25:00',4.53),('16100','2013-05-23','12:30:00',3.41),('16100','2013-05-23','12:35:00',4.08),('16100','2013-05-23','12:40:00',5.37),('16100','2013-05-23','12:45:00',3.17),('16100','2013-05-23','12:50:00',4.93),('16100','2013-05-23','12:55:00',6.27),('16100','2013-05-23','13:00:00',4.08),('16100','2013-05-23','13:05:00',4.18),('16100','2013-05-23','13:10:00',6.87),('16100','2013-05-23','13:15:00',4.89),('16100','2013-05-23','13:20:00',4.6),('16100','2013-05-23','13:25:00',5.38),('16100','2013-05-23','13:30:00',7.85),('16100','2013-05-23','13:35:00',4.82),('16100','2013-05-23','13:40:00',4.91),('16100','2013-05-23','13:45:00',1.96),('16100','2013-05-23','13:50:00',4.92),('16100','2013-05-23','13:55:00',5.75),('16100','2013-05-23','14:00:00',6.05),('16100','2013-05-23','14:05:00',4.67),('16100','2013-05-23','14:10:00',6.51),('16100','2013-05-23','14:15:00',2.45),('16100','2013-05-23','14:20:00',5.81),('16100','2013-05-23','14:25:00',5.45),('16100','2013-05-23','14:30:00',6.12),('16100','2013-05-23','14:35:00',7.34),('16100','2013-05-23','14:40:00',6.61),('16100','2013-05-23','14:45:00',2.8),('16100','2013-05-23','14:50:00',3.19),('16100','2013-05-23','14:55:00',3.18),('16100','2013-05-23','15:00:00',3.14),('16100','2013-05-23','15:05:00',2.96),('16100','2013-05-23','15:10:00',4.33),('16100','2013-05-23','15:15:00',5.36),('16100','2013-05-23','15:20:00',8.15),('16100','2013-05-23','15:25:00',5.63),('16100','2013-05-23','15:30:00',3.5),('16100','2013-05-23','15:35:00',4.51),('16100','2013-05-23','15:40:00',4.81),('16100','2013-05-23','15:45:00',6.63),('16100','2013-05-23','15:50:00',4.5),('16100','2013-05-23','15:55:00',3.29),('16100','2013-05-23','16:00:00',2.92),('16100','2013-05-23','16:05:00',2.89),('16100','2013-05-23','16:10:00',2.9),('16100','2013-05-23','16:15:00',2.38),('16100','2013-05-23','16:20:00',2.56),('16100','2013-05-23','16:25:00',2.79),('16100','2013-05-23','16:30:00',1.78),('16100','2013-05-23','16:35:00',1.55),('16100','2013-05-23','16:40:00',1.73),('16100','2013-05-23','16:45:00',2.44),('16100','2013-05-23','16:50:00',2.83),('16100','2013-05-23','16:55:00',1.96),('16100','2013-05-23','17:00:00',1.85),('16100','2013-05-23','17:05:00',1.75),('16100','2013-05-23','17:10:00',1.79),('16100','2013-05-23','17:15:00',1.82),('16100','2013-05-23','17:20:00',2.23),('16100','2013-05-23','17:25:00',2.18),('16100','2013-05-23','17:30:00',1.86),('16100','2013-05-23','17:35:00',1.99),('16100','2013-05-23','17:40:00',1.5),('16100','2013-05-23','17:45:00',1.34),('16100','2013-05-23','17:50:00',1.1),('16100','2013-05-22','07:00:00',1.37),('16100','2013-05-22','07:05:00',1.42),('16100','2013-05-22','07:45:00',1.5),('16100','2013-05-22','07:50:00',1.75),('16100','2013-05-22','07:55:00',1.4),('16100','2013-05-22','08:00:00',1.46),('16100','2013-05-22','08:05:00',1.57),('16100','2013-05-22','08:10:00',1.44),('16100','2013-05-22','08:15:00',1.15),('16100','2013-05-22','08:20:00',1.54),('16100','2013-05-22','08:25:00',1.6),('16100','2013-05-22','08:30:00',2.38),('16100','2013-05-22','08:35:00',3.51),('16100','2013-05-22','08:40:00',4.22),('16100','2013-05-22','08:45:00',2.85),('16100','2013-05-22','08:50:00',2.16),('16100','2013-05-22','09:15:00',3.03),('16100','2013-05-22','09:20:00',4.95),('16100','2013-05-22','09:25:00',1.4),('16100','2013-05-22','09:30:00',3.39),('16100','2013-05-22','09:35:00',1.92),('16100','2013-05-22','09:40:00',3.97),('16100','2013-05-22','09:45:00',2.98),('16100','2013-05-22','09:50:00',4.03),('16100','2013-05-22','09:55:00',3.97),('16100','2013-05-22','10:00:00',3.88),('16100','2013-05-22','10:05:00',3.25),('16100','2013-05-22','10:10:00',4.25),('16100','2013-05-22','10:15:00',4.63),('16100','2013-05-22','10:20:00',3.54),('16100','2013-05-22','10:25:00',5.03),('16100','2013-05-22','10:30:00',5.5),('16100','2013-05-22','10:35:00',6.9),('16100','2013-05-22','10:40:00',5.92),('16100','2013-05-22','10:45:00',2.56),('16100','2013-05-22','10:50:00',3.84),('16100','2013-05-22','10:55:00',2.45),('16100','2013-05-22','11:00:00',3.24),('16100','2013-05-22','11:05:00',3.92),('16100','2013-05-22','11:10:00',7.84),('16100','2013-05-22','11:15:00',7.59),('16100','2013-05-22','11:20:00',1.86),('16100','2013-05-22','11:25:00',6.12),('16100','2013-05-22','11:30:00',4.8),('16100','2013-05-22','11:35:00',2.57),('16100','2013-05-22','11:40:00',3.68),('16100','2013-05-22','11:45:00',2.84),('16100','2013-05-22','11:50:00',4.59),('16100','2013-05-22','11:55:00',2.03),('16100','2013-05-22','12:00:00',6.89),('16100','2013-05-22','12:05:00',4.29),('16100','2013-05-22','12:10:00',3.46),('16100','2013-05-22','12:15:00',4.36),('16100','2013-05-22','12:20:00',5.2),('16100','2013-05-22','12:25:00',2.52),('16100','2013-05-22','12:30:00',2.09),('16100','2013-05-22','12:35:00',2.1),('16100','2013-05-22','12:40:00',6.32),('16100','2013-05-22','12:45:00',9.44),('16100','2013-05-22','12:50:00',3.37),('16100','2013-05-22','12:55:00',6.47),('16100','2013-05-22','13:00:00',8.5),('16100','2013-05-22','13:05:00',8.08),('16100','2013-05-22','13:10:00',7.23),('16100','2013-05-22','13:15:00',3.38),('16100','2013-05-22','13:20:00',5.78),('16100','2013-05-22','13:25:00',2.85),('16100','2013-05-22','13:30:00',3.62),('16100','2013-05-22','13:35:00',4.23),('16100','2013-05-22','13:40:00',2.59),('16100','2013-05-22','13:45:00',5.64),('16100','2013-05-22','13:50:00',6.49),('16100','2013-05-22','13:55:00',8.43),('16100','2013-05-22','14:00:00',4.63),('16100','2013-05-22','14:05:00',3.02),('16100','2013-05-22','14:10:00',6),('16100','2013-05-22','14:15:00',2.72),('16100','2013-05-22','14:20:00',5.38),('16100','2013-05-22','14:25:00',5.81),('16100','2013-05-22','14:30:00',8.8),('16100','2013-05-22','14:35:00',3.47),('16100','2013-05-22','14:40:00',6.78),('16100','2013-05-22','14:45:00',3.29),('16100','2013-05-22','14:50:00',6.74),('16100','2013-05-22','14:55:00',7.25),('16100','2013-05-22','15:00:00',5.58),('16100','2013-05-22','15:05:00',4.88),('16100','2013-05-22','15:10:00',5.47),('16100','2013-05-22','15:15:00',1.55),('16100','2013-05-22','15:20:00',2.51),('16100','2013-05-22','15:25:00',3.98),('16100','2013-05-22','15:30:00',3.9),('16100','2013-05-22','15:35:00',4.52),('16100','2013-05-22','15:40:00',3.75),('16100','2013-05-22','15:45:00',1.78),('16100','2013-05-22','15:50:00',4.25),('16100','2013-05-22','15:55:00',7.82),('16100','2013-05-22','16:00:00',5.93),('16100','2013-05-22','16:05:00',3.05),('16100','2013-05-22','16:10:00',4.37),('16100','2013-05-22','16:15:00',4.92),('16100','2013-05-22','16:20:00',5.21),('16100','2013-05-22','16:25:00',5.65),('16100','2013-05-22','16:30:00',4.11),('16100','2013-05-22','16:35:00',3.13),('16100','2013-05-22','16:40:00',1.9),('16100','2013-05-22','16:45:00',2.01),('16100','2013-05-22','16:50:00',2.12),('16100','2013-05-22','16:55:00',5.4),('16100','2013-05-22','17:00:00',3.32),('16100','2013-05-22','17:05:00',3.5),('16100','2013-05-22','17:10:00',1.32),('16100','2013-05-22','17:15:00',1.75),('16100','2013-05-22','17:20:00',1.3),('16100','2013-05-22','17:25:00',1.33),('16100','2013-05-22','17:30:00',1.48),('16100','2013-05-22','17:35:00',1.32),('16100','2013-05-22','17:40:00',1.39),('16100','2013-05-22','17:45:00',2.57),('16100','2013-05-22','17:50:00',1.69),('16100','2013-05-22','17:55:00',2.37),('16100','2013-05-22','18:00:00',2.43),('16100','2013-05-22','18:40:00',1.28),('16100','2013-05-22','18:45:00',1.6),('16100','2013-05-22','18:50:00',1.4),('16100','2013-05-22','18:55:00',1.06),('16100','2013-05-21','07:45:00',1.08),('16100','2013-05-21','07:50:00',1.28),('16100','2013-05-21','07:55:00',1.28),('16100','2013-05-21','08:00:00',1.31),('16100','2013-05-21','08:05:00',1.61),('16100','2013-05-21','08:10:00',2.38),('16100','2013-05-21','08:15:00',1.92),('16100','2013-05-21','08:20:00',1.53),('16100','2013-05-21','08:25:00',2),('16100','2013-05-21','08:30:00',3.17),('16100','2013-05-21','08:35:00',1.79),('16100','2013-05-21','08:40:00',1.13),('16100','2013-05-21','09:15:00',1.03),('16100','2013-05-21','09:20:00',1.64),('16100','2013-05-21','09:25:00',3.29),('16100','2013-05-21','09:30:00',5.17),('16100','2013-05-21','09:35:00',4.97),('16100','2013-05-21','09:40:00',5.04),('16100','2013-05-21','09:45:00',5.16),('16100','2013-05-21','09:50:00',5.24),('16100','2013-05-21','09:55:00',5.38),('16100','2013-05-21','10:00:00',5.58),('16100','2013-05-21','10:05:00',5.73),('16100','2013-05-21','10:10:00',5.82),('16100','2013-05-21','10:15:00',5.89),('16100','2013-05-21','10:20:00',6.1),('16100','2013-05-21','10:25:00',6.02),('16100','2013-05-21','10:30:00',6.23),('16100','2013-05-21','10:35:00',6.59),('16100','2013-05-21','10:40:00',5.73),('16100','2013-05-21','10:45:00',6.28),('16100','2013-05-21','10:50:00',6.71),('16100','2013-05-21','10:55:00',6.69),('16100','2013-05-21','11:00:00',6.81),('16100','2013-05-21','11:05:00',6.87),('16100','2013-05-21','11:10:00',7),('16100','2013-05-21','11:15:00',7.05),('16100','2013-05-21','11:20:00',7.1),('16100','2013-05-21','11:25:00',7.28),('16100','2013-05-21','11:30:00',4.63),('16100','2013-05-21','11:35:00',6.92),('16100','2013-05-21','11:40:00',6.8),('16100','2013-05-21','11:45:00',8.24),('16100','2013-05-21','11:50:00',7.17),('16100','2013-05-21','11:55:00',6.58),('16100','2013-05-21','12:00:00',3.46),('16100','2013-05-21','12:05:00',4.52),('16100','2013-05-21','12:10:00',4.3),('16100','2013-05-21','12:15:00',3.98),('16100','2013-05-21','12:20:00',8.44),('16100','2013-05-21','12:25:00',8.08),('16100','2013-05-21','12:30:00',4.47),('16100','2013-05-21','12:35:00',2.67),('16100','2013-05-21','12:40:00',2.27),('16100','2013-05-21','12:45:00',1.39),('16100','2013-05-21','13:05:00',1.71),('16100','2013-05-21','13:10:00',4.13),('16100','2013-05-21','13:15:00',4.79),('16100','2013-05-21','13:20:00',3.68),('16100','2013-05-21','13:25:00',2.16),('16100','2013-05-21','13:30:00',2.46),('16100','2013-05-21','13:35:00',3.2),('16100','2013-05-21','13:40:00',2.9),('16100','2013-05-21','13:45:00',4.53),('16100','2013-05-21','13:50:00',4.72),('16100','2013-05-21','13:55:00',4.78),('16100','2013-05-21','14:00:00',4.58),('16100','2013-05-21','14:05:00',4.13),('16100','2013-05-21','14:10:00',5.98),('16100','2013-05-21','14:15:00',7.74),('16100','2013-05-21','14:20:00',7.57),('16100','2013-05-21','14:25:00',7.47),('16100','2013-05-21','14:30:00',7.39),('16100','2013-05-21','14:35:00',6.89),('16100','2013-05-21','14:40:00',6.16),('16100','2013-05-21','14:45:00',7.2),('16100','2013-05-21','14:50:00',7.11),('16100','2013-05-21','14:55:00',7.08),('16100','2013-05-21','15:00:00',7.02),('16100','2013-05-21','15:05:00',6.91),('16100','2013-05-21','15:10:00',6.37),('16100','2013-05-21','15:15:00',6.54),('16100','2013-05-21','15:20:00',6.69),('16100','2013-05-21','15:25:00',5.09),('16100','2013-05-21','15:30:00',6.16),('16100','2013-05-21','15:35:00',5.14),('16100','2013-05-21','15:40:00',4.3),('16100','2013-05-21','15:45:00',6.96),('16100','2013-05-21','15:50:00',6.29),('16100','2013-05-21','15:55:00',5.96),('16100','2013-05-21','16:00:00',5.85),('16100','2013-05-21','16:05:00',5.74),('16100','2013-05-21','16:10:00',5.56),('16100','2013-05-21','16:15:00',5.43),('16100','2013-05-21','16:20:00',5.28),('16100','2013-05-21','16:25:00',5.15),('16100','2013-05-21','16:30:00',4.19),('16100','2013-05-21','16:35:00',2.3),('16100','2013-05-21','16:40:00',4.08),('16100','2013-05-21','16:45:00',4.66),('16100','2013-05-21','16:50:00',4.57),('16100','2013-05-21','16:55:00',2.52),('16100','2013-05-21','17:00:00',1.06),('16100','2013-05-21','17:15:00',1.19),('16100','2013-05-21','17:20:00',2.13),('16100','2013-05-21','17:25:00',2.54),('16100','2013-05-21','17:30:00',3.19),('16100','2013-05-21','17:35:00',2.77),('16100','2013-05-21','17:40:00',2.74),('16100','2013-05-21','18:00:00',1.8),('16100','2013-05-21','18:05:00',2.32),('16100','2013-05-21','18:10:00',1.72),('16100','2013-05-21','18:15:00',1.4),('16100','2013-05-21','18:20:00',1.04),('16100','2013-05-21','18:25:00',1.11),('16100','2013-05-21','18:35:00',1.25),('16100','2013-05-21','18:40:00',1.21),('16100','2013-05-21','18:45:00',1.17),('16100','2014-03-31','08:15:00',1.11),('16100','2014-03-31','08:20:00',1.28),('16100','2014-03-31','08:25:00',1.46),('16100','2014-03-31','08:30:00',1.65),('16100','2014-03-31','08:35:00',1.85),('16100','2014-03-31','08:40:00',2.04),('16100','2014-03-31','08:45:00',2.23),('16100','2014-03-31','08:50:00',2.45),('16100','2014-03-31','08:55:00',2.62),('16100','2014-03-31','09:00:00',2.81),('16100','2014-03-31','09:05:00',2.99),('16100','2014-03-31','09:10:00',3.16),('16100','2014-03-31','09:15:00',3.3),('16100','2014-03-31','09:20:00',3.49),('16100','2014-03-31','09:25:00',3.68),('16100','2014-03-31','09:30:00',3.8),('16100','2014-03-31','09:35:00',3.91),('16100','2014-03-31','09:40:00',4.08),('16100','2014-03-31','09:45:00',4.19),('16100','2014-03-31','09:50:00',4.31),('16100','2014-03-31','09:55:00',4.49),('16100','2014-03-31','10:00:00',4.51),('16100','2014-03-31','10:05:00',4.6),('16100','2014-03-31','10:10:00',3.2),('16100','2014-03-31','10:15:00',5.01),('16100','2014-03-31','10:20:00',5.36),('16100','2014-03-31','10:25:00',5.46),('16100','2014-03-31','10:30:00',5.62),('16100','2014-03-31','10:35:00',5.69),('16100','2014-03-31','10:40:00',5.7),('16100','2014-03-31','10:45:00',6.01),('16100','2014-03-31','10:50:00',4.54),('16100','2014-03-31','10:55:00',3.56),('16100','2014-03-31','11:00:00',6.16),('16100','2014-03-31','11:05:00',6.04),('16100','2014-03-31','11:10:00',6.58),('16100','2014-03-31','11:15:00',5.03),('16100','2014-03-31','11:20:00',5.54),('16100','2014-03-31','11:25:00',6.78),('16100','2014-03-31','11:30:00',6.92),('16100','2014-03-31','11:35:00',6.97),('16100','2014-03-31','11:40:00',6.99),('16100','2014-03-31','11:45:00',6.92),('16100','2014-03-31','11:50:00',7),('16100','2014-03-31','11:55:00',7.12),('16100','2014-03-31','12:00:00',7.15),('16100','2014-03-31','12:05:00',7.22),('16100','2014-03-31','12:10:00',7.34),('16100','2014-03-31','12:15:00',7.38),('16100','2014-03-31','12:20:00',7.47),('16100','2014-03-31','12:25:00',7.57),('16100','2014-03-31','12:30:00',7.66),('16100','2014-03-31','12:35:00',7.69),('16100','2014-03-31','12:40:00',7.76),('16100','2014-03-31','12:45:00',7.82),('16100','2014-03-31','12:50:00',7.96),('16100','2014-03-31','12:55:00',6.72),('16100','2014-03-31','13:00:00',7.87),('16100','2014-03-31','13:05:00',7.84),('16100','2014-03-31','13:10:00',7.81),('16100','2014-03-31','13:15:00',6.66),('16100','2014-03-31','13:20:00',6.7),('16100','2014-03-31','13:25:00',5.34),('16100','2014-03-31','13:30:00',8.01),('16100','2014-03-31','13:35:00',6.28),('16100','2014-03-31','13:40:00',5.73),('16100','2014-03-31','13:45:00',5.9),('16100','2014-03-31','13:50:00',6.05),('16100','2014-03-31','13:55:00',8),('16100','2014-03-31','14:00:00',7.86),('16100','2014-03-31','14:05:00',7.69),('16100','2014-03-31','14:10:00',5.79),('16100','2014-03-31','14:15:00',5.26),('16100','2014-03-31','14:20:00',5.63),('16100','2014-03-31','14:25:00',7.64),('16100','2014-03-31','14:30:00',7.72),('16100','2014-03-31','14:35:00',7.59),('16100','2014-03-31','14:40:00',3.5),('16100','2014-03-31','14:45:00',5.48),('16100','2014-03-31','14:50:00',7.76),('16100','2014-03-31','14:55:00',5.5),('16100','2014-03-31','15:00:00',5.81),('16100','2014-03-31','15:05:00',7.12),('16100','2014-03-31','15:10:00',6.01),('16100','2014-03-31','15:15:00',6.58),('16100','2014-03-31','15:20:00',6.89),('16100','2014-03-31','15:25:00',5.26),('16100','2014-03-31','15:30:00',3.11),('16100','2014-03-31','15:35:00',3.37),('16100','2014-03-31','15:40:00',4.17),('16100','2014-03-31','15:45:00',6.05),('16100','2014-03-31','15:50:00',4.58),('16100','2014-03-31','15:55:00',4.94),('16100','2014-03-31','16:00:00',5.05),('16100','2014-03-31','16:05:00',5.66),('16100','2014-03-31','16:10:00',4.29),('16100','2014-03-31','16:15:00',4.99),('16100','2014-03-31','16:20:00',5.52),('16100','2014-03-31','16:25:00',5.39),('16100','2014-03-31','16:30:00',3.86),('16100','2014-03-31','16:35:00',4.83),('16100','2014-03-31','16:40:00',2.99),('16100','2014-03-31','16:45:00',3.02),('16100','2014-03-31','16:50:00',2.68),('16100','2014-03-31','16:55:00',3.07),('16100','2014-03-31','17:00:00',2.47),('16100','2014-03-31','17:05:00',4.26),('16100','2014-03-31','17:10:00',2.19),('16100','2014-03-31','17:15:00',2.8),('16100','2014-03-31','17:20:00',2.25),('16100','2014-03-31','17:25:00',3.24),('16100','2014-03-31','17:30:00',2.97),('16100','2014-03-31','17:35:00',2.85),('16100','2014-03-31','17:40:00',2.18),('16100','2014-03-31','17:45:00',2.27),('16100','2014-03-31','17:50:00',2.28),('16100','2014-03-31','17:55:00',2.08),('16100','2014-03-31','18:00:00',1.89),('16100','2014-03-31','18:05:00',1.75),('16100','2014-03-31','18:10:00',1.47),('16100','2014-03-31','18:15:00',1.3),('16100','2014-03-31','18:20:00',1.1),('16100','2013-05-20','07:35:00',1.41),('16100','2013-05-20','07:40:00',1.55),('16100','2013-05-20','07:45:00',1.4),('16100','2013-05-20','07:50:00',1.3),('16100','2013-05-20','07:55:00',1.28),('16100','2013-05-20','08:00:00',1.14),('16100','2013-05-20','08:05:00',1.66),('16100','2013-05-20','08:10:00',2.6),('16100','2013-05-20','08:15:00',2.1),('16100','2013-05-20','08:20:00',2.14),('16100','2013-05-20','08:25:00',2.29),('16100','2013-05-20','08:30:00',1.87),('16100','2013-05-20','08:35:00',2.19),('16100','2013-05-20','08:40:00',2.53),('16100','2013-05-20','08:45:00',1.96),('16100','2013-05-20','08:50:00',2.04),('16100','2013-05-20','08:55:00',2.28),('16100','2013-05-20','09:00:00',2.18),('16100','2013-05-20','09:05:00',2.05),('16100','2013-05-20','09:10:00',2.4),('16100','2013-05-20','09:15:00',2.92),('16100','2013-05-20','09:20:00',3.2),('16100','2013-05-20','09:25:00',3.39),('16100','2013-05-20','09:30:00',3.02),('16100','2013-05-20','09:35:00',3.06),('16100','2013-05-20','09:40:00',3.08),('16100','2013-05-20','09:45:00',2.77),('16100','2013-05-20','09:50:00',2.96),('16100','2013-05-20','09:55:00',2.86),('16100','2013-05-20','10:00:00',3.45),('16100','2013-05-20','10:05:00',3.35),('16100','2013-05-20','10:10:00',3.32),('16100','2013-05-20','10:15:00',3.5),('16100','2013-05-20','10:20:00',2.98),('16100','2013-05-20','10:25:00',4.47),('16100','2013-05-20','10:30:00',3.36),('16100','2013-05-20','10:35:00',3.06),('16100','2013-05-20','10:40:00',4.33),('16100','2013-05-20','10:45:00',5.41),('16100','2013-05-20','10:50:00',4.88),('16100','2013-05-20','10:55:00',3.29),('16100','2013-05-20','11:00:00',2.81),('16100','2013-05-20','11:05:00',2.64),('16100','2013-05-20','11:10:00',4.09),('16100','2013-05-20','11:15:00',6.6),('16100','2013-05-20','11:20:00',6.34),('16100','2013-05-20','11:25:00',7.24),('16100','2013-05-20','11:30:00',6.92),('16100','2013-05-20','11:35:00',4.76),('16100','2013-05-20','11:40:00',3.61),('16100','2013-05-20','11:45:00',5.63),('16100','2013-05-20','11:50:00',5.54),('16100','2013-05-20','11:55:00',4.79),('16100','2013-05-20','12:00:00',4.33),('16100','2013-05-20','12:05:00',6.03),('16100','2013-05-20','12:10:00',7.65),('16100','2013-05-20','12:15:00',5.5),('16100','2013-05-20','12:20:00',4.5),('16100','2013-05-20','12:25:00',3.9),('16100','2013-05-20','12:30:00',5.42),('16100','2013-05-20','12:35:00',4.76),('16100','2013-05-20','12:40:00',4.68),('16100','2013-05-20','12:45:00',4.51),('16100','2013-05-20','12:50:00',6.3),('16100','2013-05-20','12:55:00',6.63),('16100','2013-05-20','13:00:00',5.31),('16100','2013-05-20','13:05:00',5.47),('16100','2013-05-20','13:10:00',5.08),('16100','2013-05-20','13:15:00',7),('16100','2013-05-20','13:20:00',7.93),('16100','2013-05-20','13:25:00',4.6),('16100','2013-05-20','13:30:00',2.89),('16100','2013-05-20','13:35:00',2.15),('16100','2013-05-20','13:40:00',1.51),('16100','2013-05-20','14:05:00',1.43),('16100','2013-05-20','14:10:00',2.49),('16100','2013-05-20','14:15:00',3.04),('16100','2013-05-20','14:20:00',3.43),('16100','2013-05-20','14:25:00',4.15),('16100','2013-05-20','14:30:00',3.88),('16100','2013-05-20','14:35:00',4.29),('16100','2013-05-20','14:40:00',3.85),('16100','2013-05-20','14:45:00',2.23),('16100','2013-05-20','14:50:00',1.06),('16100','2013-05-20','15:15:00',1.97),('16100','2013-05-20','15:20:00',2.67),('16100','2013-05-20','15:25:00',3.68),('16100','2013-05-20','15:30:00',5.23),('16100','2013-05-20','15:35:00',4.61),('16100','2013-05-20','15:40:00',5.6),('16100','2013-05-20','15:45:00',4.8),('16100','2013-05-20','15:50:00',1.97),('16100','2013-05-20','15:55:00',1.66),('16100','2013-05-20','16:00:00',1.46),('16100','2013-05-20','16:05:00',1.89),('16100','2013-05-20','16:10:00',2.04),('16100','2013-05-20','16:15:00',1.29),('16100','2013-05-20','16:20:00',1.38),('16100','2013-05-20','16:25:00',1.85),('16100','2013-05-20','16:30:00',2.64),('16100','2013-05-20','16:35:00',3.13),('16100','2013-05-20','16:40:00',2.61),('16100','2013-05-20','16:45:00',1.97),('16100','2013-05-20','16:50:00',1.53),('16100','2013-05-19','07:20:00',1.08),('16100','2013-05-19','07:25:00',1.17),('16100','2013-05-19','07:35:00',1.16),('16100','2013-05-19','07:40:00',1.29),('16100','2013-05-19','07:50:00',1.51),('16100','2013-05-19','07:55:00',1.01),('16100','2013-05-19','08:00:00',1.74),('16100','2013-05-19','08:05:00',1.73),('16100','2013-05-19','08:10:00',1.87),('16100','2013-05-19','08:15:00',2.05),('16100','2013-05-19','08:20:00',1.74),('16100','2013-05-19','08:25:00',2.76),('16100','2013-05-19','08:30:00',2.57),('16100','2013-05-19','08:35:00',1.45),('16100','2013-05-19','08:40:00',3.11),('16100','2013-05-19','08:45:00',3.42),('16100','2013-05-19','08:55:00',1.04),('16100','2013-05-19','09:05:00',3.88),('16100','2013-05-19','09:10:00',4.06),('16100','2013-05-19','09:15:00',4.88),('16100','2013-05-19','09:20:00',5.29),('16100','2013-05-19','09:25:00',5.21),('16100','2013-05-19','09:30:00',4.81),('16100','2013-05-19','09:35:00',4.59),('16100','2013-05-19','09:40:00',3.4),('16100','2013-05-19','09:45:00',5.92),('16100','2013-05-19','09:50:00',6.7),('16100','2013-05-19','09:55:00',5.02),('16100','2013-05-19','10:00:00',2.25),('16100','2013-05-19','10:05:00',4.83),('16100','2013-05-19','10:10:00',6.36),('16100','2013-05-19','10:15:00',3.57),('16100','2013-05-19','10:20:00',5.68),('16100','2013-05-19','10:25:00',2.93),('16100','2013-05-19','10:30:00',1.83),('16100','2013-05-19','10:35:00',6.81),('16100','2013-05-19','10:40:00',7),('16100','2013-05-19','10:45:00',7.03),('16100','2013-05-19','10:50:00',7.24),('16100','2013-05-19','10:55:00',4.75),('16100','2013-05-19','11:00:00',5.26),('16100','2013-05-19','11:05:00',4.35),('16100','2013-05-19','11:10:00',2.94),('16100','2013-05-19','11:15:00',2.33),('16100','2013-05-19','11:20:00',6.9),('16100','2013-05-19','11:25:00',7.73),('16100','2013-05-19','11:30:00',5.85),('16100','2013-05-19','11:35:00',7.99),('16100','2013-05-19','11:40:00',8.85),('16100','2013-05-19','11:45:00',7.95),('16100','2013-05-19','11:50:00',6.16),('16100','2013-05-19','11:55:00',6.76),('16100','2013-05-19','12:00:00',8.38),('16100','2013-05-19','12:05:00',8.42),('16100','2013-05-19','12:10:00',8.37),('16100','2013-05-19','12:15:00',8.42),('16100','2013-05-19','12:20:00',8.49),('16100','2013-05-19','12:25:00',8.39),('16100','2013-05-19','12:30:00',8.53),('16100','2013-05-19','12:35:00',8.63),('16100','2013-05-19','12:40:00',8.67),('16100','2013-05-19','12:45:00',8.58),('16100','2013-05-19','12:50:00',8.51),('16100','2013-05-19','12:55:00',8.5),('16100','2013-05-19','13:00:00',8.53),('16100','2013-05-19','13:05:00',8.59),('16100','2013-05-19','13:10:00',8.58),('16100','2013-05-19','13:15:00',8.49),('16100','2013-05-19','13:20:00',8.49),('16100','2013-05-19','13:25:00',8.51),('16100','2013-05-19','13:30:00',8.47),('16100','2013-05-19','13:35:00',8.42),('16100','2013-05-19','13:40:00',8.42),('16100','2013-05-19','13:45:00',8.3),('16100','2013-05-19','13:50:00',8.32),('16100','2013-05-19','13:55:00',8.26),('16100','2013-05-19','14:00:00',8.18),('16100','2013-05-19','14:05:00',8.14),('16100','2013-05-19','14:10:00',8.19),('16100','2013-05-19','14:15:00',8.11),('16100','2013-05-19','14:20:00',8),('16100','2013-05-19','14:25:00',7.91),('16100','2013-05-19','14:30:00',7.81),('16100','2013-05-19','14:35:00',7.79),('16100','2013-05-19','14:40:00',7.79),('16100','2013-05-19','14:45:00',7.71),('16100','2013-05-19','14:50:00',7.64),('16100','2013-05-19','14:55:00',7.64),('16100','2013-05-19','15:00:00',7.56),('16100','2013-05-19','15:05:00',7.53),('16100','2013-05-19','15:10:00',7.46),('16100','2013-05-19','15:15:00',7.36),('16100','2013-05-19','15:20:00',7.28),('16100','2013-05-19','15:25:00',7.21),('16100','2013-05-19','15:30:00',7.08),('16100','2013-05-19','15:35:00',7),('16100','2013-05-19','15:40:00',6.89),('16100','2013-05-19','15:45:00',6.8),('16100','2013-05-19','15:50:00',6.73),('16100','2013-05-19','15:55:00',6.63),('16100','2013-05-19','16:00:00',6.47),('16100','2013-05-19','16:05:00',6.34),('16100','2013-05-19','16:10:00',6.2),('16100','2013-05-19','16:15:00',6.02),('16100','2013-05-19','16:20:00',5.83),('16100','2013-05-19','16:25:00',5.74),('16100','2013-05-19','16:30:00',5.65),('16100','2013-05-19','16:35:00',5.42),('16100','2013-05-19','16:40:00',5.16),('16100','2013-05-19','16:45:00',4.79),('16100','2013-05-19','16:50:00',5.11),('16100','2013-05-19','16:55:00',4.75),('16100','2013-05-19','17:00:00',3.37),('16100','2013-05-19','17:05:00',4.28),('16100','2013-05-19','17:10:00',4.23),('16100','2013-05-19','17:15:00',2.86),('16100','2013-05-19','17:20:00',5.13),('16100','2013-05-19','17:25:00',4.41),('16100','2013-05-19','17:30:00',3.87),('16100','2013-05-19','17:35:00',3.63),('16100','2013-05-19','17:40:00',3.42),('16100','2013-05-19','17:45:00',3.27),('16100','2013-05-19','17:50:00',3.06),('16100','2013-05-19','17:55:00',2.89),('16100','2013-05-19','18:00:00',2.56),('16100','2013-05-19','18:05:00',1.72),('16100','2013-05-19','18:10:00',2.13),('16100','2013-05-19','18:15:00',2.34),('16100','2013-05-19','18:20:00',1.98),('16100','2013-05-19','18:25:00',1.79),('16100','2013-05-19','18:30:00',1.59),('16100','2013-05-19','18:35:00',1.4),('16100','2013-05-19','18:45:00',1.03),('16100','2013-05-18','08:25:00',1.19),('16100','2013-05-18','08:30:00',1.58),('16100','2013-05-18','08:35:00',2.05),('16100','2013-05-18','08:40:00',2.22),('16100','2013-05-18','08:45:00',1.61),('16100','2013-05-18','08:50:00',1.62),('16100','2013-05-18','08:55:00',2.07),('16100','2013-05-18','09:00:00',1.59),('16100','2013-05-18','09:05:00',1.26),('16100','2013-05-18','09:10:00',1.24),('16100','2013-05-18','09:30:00',1.47),('16100','2013-05-18','09:35:00',1.79),('16100','2013-05-18','09:40:00',1.33),('16100','2013-05-18','09:45:00',1.59),('16100','2013-05-18','09:50:00',2.02),('16100','2013-05-18','09:55:00',2.2),('16100','2013-05-18','10:00:00',2.69),('16100','2013-05-18','10:05:00',3.46),('16100','2013-05-18','10:10:00',3.98),('16100','2013-05-18','10:15:00',3.46),('16100','2013-05-18','10:20:00',3.83),('16100','2013-05-18','10:25:00',4.94),('16100','2013-05-18','10:30:00',6.75),('16100','2013-05-18','10:35:00',6.69),('16100','2013-05-18','10:40:00',4.46),('16100','2013-05-18','10:45:00',4.68),('16100','2013-05-18','10:50:00',4.59),('16100','2013-05-18','10:55:00',6.5),('16100','2013-05-18','11:00:00',7.06),('16100','2013-05-18','11:05:00',4.31),('16100','2013-05-18','11:10:00',5.33),('16100','2013-05-18','11:15:00',4.27),('16100','2013-05-18','11:20:00',6.87),('16100','2013-05-18','11:25:00',6.08),('16100','2013-05-18','11:30:00',8.45),('16100','2013-05-18','11:35:00',6.76),('16100','2013-05-18','11:40:00',8.3),('16100','2013-05-18','11:45:00',8.15),('16100','2013-05-18','11:50:00',8.19),('16100','2013-05-18','11:55:00',8.28),('16100','2013-05-18','12:00:00',8.31),('16100','2013-05-18','12:05:00',8.3),('16100','2013-05-18','12:10:00',8.38),('16100','2013-05-18','12:15:00',8.48),('16100','2013-05-18','12:20:00',8.59),('16100','2013-05-18','12:25:00',8.81),('16100','2013-05-18','12:30:00',8.96),('16100','2013-05-18','12:35:00',8.95),('16100','2013-05-18','12:40:00',9.19),('16100','2013-05-18','12:45:00',9.04),('16100','2013-05-18','12:50:00',8.12),('16100','2013-05-18','12:55:00',8.86),('16100','2013-05-18','13:00:00',8.8),('16100','2013-05-18','13:05:00',8.84),('16100','2013-05-18','13:10:00',8.73),('16100','2013-05-18','13:15:00',8.65),('16100','2013-05-18','13:20:00',8.57),('16100','2013-05-18','13:25:00',8.48),('16100','2013-05-18','13:30:00',8.55),('16100','2013-05-18','13:35:00',8.54),('16100','2013-05-18','13:40:00',8.5),('16100','2013-05-18','13:45:00',8.53),('16100','2013-05-18','13:50:00',8.48),('16100','2013-05-18','13:55:00',8.41),('16100','2013-05-18','14:00:00',8.33),('16100','2013-05-18','14:05:00',8.2),('16100','2013-05-18','14:10:00',8.23),('16100','2013-05-18','14:15:00',8.29),('16100','2013-05-18','14:20:00',8.21),('16100','2013-05-18','14:25:00',8.12),('16100','2013-05-18','14:30:00',8.07),('16100','2013-05-18','14:35:00',8.04),('16100','2013-05-18','14:40:00',8.04),('16100','2013-05-18','14:45:00',7.96),('16100','2013-05-18','14:50:00',7.92),('16100','2013-05-18','14:55:00',7.85),('16100','2013-05-18','15:00:00',7.75),('16100','2013-05-18','15:05:00',7.67),('16100','2013-05-18','15:10:00',7.51),('16100','2013-05-18','15:15:00',7.47),('16100','2013-05-18','15:20:00',7.34),('16100','2013-05-18','15:25:00',7.27),('16100','2013-05-18','15:30:00',7.18),('16100','2013-05-18','15:35:00',7.09),('16100','2013-05-18','15:40:00',6.96),('16100','2013-05-18','15:45:00',6.89),('16100','2013-05-18','15:50:00',6.8),('16100','2013-05-18','15:55:00',6.65),('16100','2013-05-18','16:00:00',6.55),('16100','2013-05-18','16:05:00',6.48),('16100','2013-05-18','16:10:00',6.38),('16100','2013-05-18','16:15:00',6.17),('16100','2013-05-18','16:20:00',6),('16100','2013-05-18','16:25:00',5.89),('16100','2013-05-18','16:30:00',5.74),('16100','2013-05-18','16:35:00',5.59),('16100','2013-05-18','16:40:00',5.49),('16100','2013-05-18','16:45:00',5.36),('16100','2013-05-18','16:50:00',5.21),('16100','2013-05-18','16:55:00',5.1),('16100','2013-05-18','17:00:00',4.88),('16100','2013-05-18','17:05:00',4.77),('16100','2013-05-18','17:10:00',4.62),('16100','2013-05-18','17:15:00',4.44),('16100','2013-05-18','17:20:00',4.27),('16100','2013-05-18','17:25:00',4.13),('16100','2013-05-18','17:30:00',3.97),('16100','2013-05-18','17:35:00',3.78),('16100','2013-05-18','17:40:00',3.64),('16100','2013-05-18','17:45:00',3.48),('16100','2013-05-18','17:50:00',3.28),('16100','2013-05-18','17:55:00',3.11),('16100','2013-05-18','18:00:00',2.91),('16100','2013-05-18','18:05:00',2.73),('16100','2013-05-18','18:10:00',2.55),('16100','2013-05-18','18:15:00',2.36),('16100','2013-05-18','18:20:00',2.1),('16100','2013-05-18','18:25:00',1.84),('16100','2013-05-18','18:30:00',1.73),('16100','2013-05-18','18:35:00',1.55),('16100','2013-05-18','18:40:00',1.38),('16100','2013-05-18','18:45:00',1.2),('16100','2013-05-18','18:50:00',1.03),('16100','2013-05-17','07:45:00',1.06),('16100','2013-05-17','07:50:00',1.52),('16100','2013-05-17','07:55:00',1.26),('16100','2013-05-17','08:00:00',1.78),('16100','2013-05-17','08:05:00',1.6),('16100','2013-05-17','08:10:00',1.4),('16100','2013-05-17','08:15:00',1.57),('16100','2013-05-17','08:20:00',1.8),('16100','2013-05-17','08:25:00',2.07),('16100','2013-05-17','08:30:00',3.09),('16100','2013-05-17','08:35:00',2.24),('16100','2013-05-17','08:40:00',3.05),('16100','2013-05-17','08:45:00',3.04),('16100','2013-05-17','08:50:00',3.7),('16100','2013-05-17','08:55:00',4),('16100','2013-05-17','09:00:00',4.1),('16100','2013-05-17','09:05:00',4.25),('16100','2013-05-17','09:10:00',4.41),('16100','2013-05-17','09:15:00',4.51),('16100','2013-05-17','09:20:00',4.66),('16100','2013-05-17','09:25:00',4.85),('16100','2013-05-17','09:30:00',5),('16100','2013-05-17','09:35:00',5.12),('16100','2013-05-17','09:40:00',5.24),('16100','2013-05-17','09:45:00',5.35),('16100','2013-05-17','09:50:00',5.48),('16100','2013-05-17','09:55:00',5.57),('16100','2013-05-17','10:00:00',5.71),('16100','2013-05-17','10:05:00',5.87),('16100','2013-05-17','10:10:00',6.05),('16100','2013-05-17','10:15:00',6.16),('16100','2013-05-17','10:20:00',6.23),('16100','2013-05-17','10:25:00',6.31),('16100','2013-05-17','10:30:00',6.41),('16100','2013-05-17','10:35:00',6.46),('16100','2013-05-17','10:40:00',6.58),('16100','2013-05-17','10:45:00',6.68),('16100','2013-05-17','10:50:00',6.8),('16100','2013-05-17','10:55:00',7.05),('16100','2013-05-17','11:00:00',7.25),('16100','2013-05-17','11:05:00',7.44),('16100','2013-05-17','11:10:00',6.6),('16100','2013-05-17','11:15:00',6.9),('16100','2013-05-17','11:20:00',7.11),('16100','2013-05-17','11:25:00',4.35),('16100','2013-05-17','11:30:00',7.1),('16100','2013-05-17','11:35:00',5.42),('16100','2013-05-17','11:40:00',6.4),('16100','2013-05-17','11:45:00',7.47),('16100','2013-05-17','11:50:00',7.51),('16100','2013-05-17','11:55:00',7.08),('16100','2013-05-17','12:00:00',7.55),('16100','2013-05-17','12:05:00',7.47),('16100','2013-05-17','12:10:00',7.47),('16100','2013-05-17','12:15:00',7.54),('16100','2013-05-17','12:20:00',7.59),('16100','2013-05-17','12:25:00',7.65),('16100','2013-05-17','12:30:00',7.71),('16100','2013-05-17','12:35:00',7.67),('16100','2013-05-17','12:40:00',7.65),('16100','2013-05-17','12:45:00',7.49),('16100','2013-05-17','12:50:00',5.9),('16100','2013-05-17','12:55:00',7.64),('16100','2013-05-17','13:00:00',7.65),('16100','2013-05-17','13:05:00',7.66),('16100','2013-05-17','13:10:00',7.2),('16100','2013-05-17','13:15:00',7.62),('16100','2013-05-17','13:20:00',7.62),('16100','2013-05-17','13:25:00',7.6),('16100','2013-05-17','13:30:00',7.67),('16100','2013-05-17','13:35:00',7.74),('16100','2013-05-17','13:40:00',7.59),('16100','2013-05-17','13:45:00',7.74),('16100','2013-05-17','13:50:00',7.65),('16100','2013-05-17','13:55:00',6.86),('16100','2013-05-17','14:00:00',7.38),('16100','2013-05-17','14:05:00',5.35),('16100','2013-05-17','14:10:00',5.44),('16100','2013-05-17','14:15:00',5.65),('16100','2013-05-17','14:20:00',6.04),('16100','2013-05-17','14:25:00',6.27),('16100','2013-05-17','14:30:00',7.01),('16100','2013-05-17','14:35:00',6.54),('16100','2013-05-17','14:40:00',7.77),('16100','2013-05-17','14:45:00',6.49),('16100','2013-05-17','14:50:00',5.9),('16100','2013-05-17','14:55:00',6.93),('16100','2013-05-17','15:00:00',6.6),('16100','2013-05-17','15:05:00',6.55),('16100','2013-05-17','15:10:00',6.58),('16100','2013-05-17','15:15:00',6.45),('16100','2013-05-17','15:20:00',6.28),('16100','2013-05-17','15:25:00',6.2),('16100','2013-05-17','15:30:00',6.1),('16100','2013-05-17','15:35:00',6.02),('16100','2013-05-17','15:40:00',6),('16100','2013-05-17','15:45:00',5.83),('16100','2013-05-17','15:50:00',5.75),('16100','2013-05-17','15:55:00',5.62),('16100','2013-05-17','16:00:00',5.52),('16100','2013-05-17','16:05:00',5.41),('16100','2013-05-17','16:10:00',5.24),('16100','2013-05-17','16:15:00',5.06),('16100','2013-05-17','16:20:00',4.99),('16100','2013-05-17','16:25:00',4.88),('16100','2013-05-17','16:30:00',4.75),('16100','2013-05-17','16:35:00',4.61),('16100','2013-05-17','16:40:00',4.52),('16100','2013-05-17','16:45:00',4.39),('16100','2013-05-17','16:50:00',4.23),('16100','2013-05-17','16:55:00',4.11),('16100','2013-05-17','17:00:00',3.92),('16100','2013-05-17','17:05:00',3.79),('16100','2013-05-17','17:10:00',3.68),('16100','2013-05-17','17:15:00',3.54),('16100','2013-05-17','17:20:00',3.42),('16100','2013-05-17','17:25:00',3.28),('16100','2013-05-17','17:30:00',3.11),('16100','2013-05-17','17:35:00',2.97),('16100','2013-05-17','17:40:00',2.83),('16100','2013-05-17','17:45:00',2.69),('16100','2013-05-17','17:50:00',2.53),('16100','2013-05-17','17:55:00',2.39),('16100','2013-05-17','18:00:00',2.25),('16100','2013-05-17','18:05:00',2.1),('16100','2013-05-17','18:10:00',1.95),('16100','2013-05-17','18:15:00',1.8),('16100','2013-05-17','18:20:00',1.63),('16100','2013-05-17','18:25:00',1.47),('16100','2013-05-17','18:30:00',1.32),('16100','2013-05-17','18:35:00',1.19),('16100','2013-05-17','18:40:00',1.08),('16100','2013-05-16','07:40:00',1.1),('16100','2013-05-16','07:45:00',1.36),('16100','2013-05-16','07:50:00',1.56),('16100','2013-05-16','07:55:00',1.44),('16100','2013-05-16','08:00:00',1.68),('16100','2013-05-16','08:05:00',1.86),('16100','2013-05-16','08:10:00',2.49),('16100','2013-05-16','08:15:00',3.35),('16100','2013-05-16','08:20:00',3.51),('16100','2013-05-16','08:25:00',2.67),('16100','2013-05-16','08:30:00',1.23),('16100','2013-05-16','09:10:00',1.23),('16100','2013-05-16','09:15:00',1.14),('16100','2013-05-16','10:15:00',1.29),('16100','2013-05-16','10:20:00',1.75),('16100','2013-05-16','10:25:00',1.95),('16100','2013-05-16','10:30:00',2.56),('16100','2013-05-16','10:35:00',2.08),('16100','2013-05-16','10:40:00',2.13),('16100','2013-05-16','10:45:00',3.92),('16100','2013-05-16','10:50:00',4.31),('16100','2013-05-16','10:55:00',4.36),('16100','2013-05-16','11:00:00',3.32),('16100','2013-05-16','11:05:00',2.59),('16100','2013-05-16','11:10:00',2.21),('16100','2013-05-16','11:15:00',6.39),('16100','2013-05-16','11:20:00',4.19),('16100','2013-05-16','11:25:00',4.25),('16100','2013-05-16','11:30:00',2.89),('16100','2013-05-16','11:35:00',3.35),('16100','2013-05-16','11:40:00',2.7),('16100','2013-05-16','11:45:00',3.2),('16100','2013-05-16','11:50:00',3.32),('16100','2013-05-16','11:55:00',4.68),('16100','2013-05-16','12:00:00',3.04),('16100','2013-05-16','12:05:00',4.09),('16100','2013-05-16','12:10:00',5.32),('16100','2013-05-16','12:15:00',4.81),('16100','2013-05-16','12:20:00',2.47),('16100','2013-05-16','12:25:00',3.35),('16100','2013-05-16','12:30:00',4.66),('16100','2013-05-16','12:35:00',3.3),('16100','2013-05-16','12:40:00',2.31),('16100','2013-05-16','12:45:00',3.89),('16100','2013-05-16','12:50:00',7.5),('16100','2013-05-16','12:55:00',4.89),('16100','2013-05-16','13:00:00',4.44),('16100','2013-05-16','13:05:00',2.77),('16100','2013-05-16','13:10:00',2.61),('16100','2013-05-16','13:15:00',2.39),('16100','2013-05-16','13:20:00',2.09),('16100','2013-05-16','13:25:00',5.75),('16100','2013-05-16','13:30:00',8.19),('16100','2013-05-16','13:35:00',5.06),('16100','2013-05-16','13:40:00',4.91),('16100','2013-05-16','13:45:00',4.14),('16100','2013-05-16','13:50:00',6.43),('16100','2013-05-16','13:55:00',3.14),('16100','2013-05-16','14:00:00',2.94),('16100','2013-05-16','14:05:00',5.18),('16100','2013-05-16','14:10:00',8.11),('16100','2013-05-16','14:15:00',6.83),('16100','2013-05-16','14:20:00',5.82),('16100','2013-05-16','14:25:00',5.74),('16100','2013-05-16','14:30:00',8.04),('16100','2013-05-16','14:35:00',8.88),('16100','2013-05-16','14:40:00',6.32),('16100','2013-05-16','14:45:00',4.01),('16100','2013-05-16','14:50:00',2.17),('16100','2013-05-16','14:55:00',3.29),('16100','2013-05-16','15:00:00',6.37),('16100','2013-05-16','15:05:00',5),('16100','2013-05-16','15:10:00',6.8),('16100','2013-05-16','15:15:00',7.86),('16100','2013-05-16','15:20:00',7.49),('16100','2013-05-16','15:25:00',7.07),('16100','2013-05-16','15:30:00',7.21),('16100','2013-05-16','15:35:00',7.2),('16100','2013-05-16','15:40:00',6.5),('16100','2013-05-16','15:45:00',5.71),('16100','2013-05-16','15:50:00',5.01),('16100','2013-05-16','15:55:00',6.64),('16100','2013-05-16','16:00:00',6.64),('16100','2013-05-16','16:05:00',6.68),('16100','2013-05-16','16:10:00',6.38),('16100','2013-05-16','16:15:00',6.5),('16100','2013-05-16','16:20:00',6.67),('16100','2013-05-16','16:25:00',6.33),('16100','2013-05-16','16:30:00',4.95),('16100','2013-05-16','16:35:00',6.37),('16100','2013-05-16','16:40:00',5.3),('16100','2013-05-16','16:45:00',5.91),('16100','2013-05-16','16:50:00',5.87),('16100','2013-05-16','16:55:00',5.19),('16100','2013-05-16','17:00:00',4.45),('16100','2013-05-16','17:05:00',1.08),('16100','2013-05-16','17:10:00',3.58),('16100','2013-05-16','17:15:00',1.34),('16100','2013-05-16','17:20:00',3.13),('16100','2013-05-16','17:25:00',3.53),('16100','2013-05-16','17:30:00',3.99),('16100','2013-05-16','17:35:00',3.52),('16100','2013-05-16','17:40:00',3.65),('16100','2013-05-16','17:45:00',3.3),('16100','2013-05-16','17:50:00',3.2),('16100','2013-05-16','17:55:00',3.07),('16100','2013-05-16','18:00:00',2.81),('16100','2013-05-16','18:05:00',2.67),('16100','2013-05-16','18:10:00',2.56),('16100','2013-05-16','18:15:00',2.4),('16100','2013-05-16','18:20:00',2.17),('16100','2013-05-16','18:25:00',1.98),('16100','2013-05-16','18:30:00',1.91),('16100','2013-05-16','18:35:00',1.83),('16100','2013-05-16','18:40:00',1.67),('16100','2013-05-16','18:45:00',1.44),('16100','2013-05-16','18:50:00',1.24),('16100','2013-05-16','18:55:00',1.07),('16100','2013-05-15','09:15:00',1.34),('16100','2013-05-15','09:20:00',1.77),('16100','2013-05-15','09:25:00',2.52),('16100','2013-05-15','09:30:00',2.29),('16100','2013-05-15','09:35:00',2.54),('16100','2013-05-15','09:40:00',3.2),('16100','2013-05-15','09:45:00',4.68),('16100','2013-05-15','09:50:00',4.42),('16100','2013-05-15','09:55:00',1.7),('16100','2013-05-15','10:00:00',3.2),('16100','2013-05-15','10:05:00',2.18),('16100','2013-05-15','10:10:00',1.75),('16100','2013-05-15','10:15:00',2.06),('16100','2013-05-15','10:20:00',3.28),('16100','2013-05-15','10:25:00',2.47),('16100','2013-05-15','10:30:00',2.51),('16100','2013-05-15','10:35:00',2.24),('16100','2013-05-15','10:40:00',2.92),('16100','2013-05-15','10:45:00',3.48),('16100','2013-05-15','10:50:00',3.14),('16100','2013-05-15','10:55:00',6.99),('16100','2013-05-15','11:00:00',7.52),('16100','2013-05-15','11:05:00',6.9),('16100','2013-05-15','11:10:00',6.43),('16100','2013-05-15','11:15:00',4.29),('16100','2013-05-15','11:20:00',4.45),('16100','2013-05-15','11:25:00',2.8),('16100','2013-05-15','11:30:00',3.54),('16100','2013-05-15','11:35:00',5.55),('16100','2013-05-15','11:40:00',7.79),('16100','2013-05-15','11:45:00',7.74),('16100','2013-05-15','11:50:00',8.44),('16100','2013-05-15','11:55:00',5.99),('16100','2013-05-15','12:00:00',2.38),('16100','2013-05-15','12:05:00',1.73),('16100','2013-05-15','12:10:00',1.75),('16100','2013-05-15','12:15:00',2.32),('16100','2013-05-15','12:20:00',2.92),('16100','2013-05-15','12:25:00',4.12),('16100','2013-05-15','12:30:00',5.59),('16100','2013-05-15','12:35:00',5.47),('16100','2013-05-15','12:40:00',4.42),('16100','2013-05-15','12:45:00',6.18),('16100','2013-05-15','12:50:00',4.26),('16100','2013-05-15','12:55:00',7.23),('16100','2013-05-15','13:00:00',7.77),('16100','2013-05-15','13:05:00',7.79),('16100','2013-05-15','13:10:00',7.62),('16100','2013-05-15','13:15:00',7.53),('16100','2013-05-15','13:20:00',7.58),('16100','2013-05-15','13:25:00',7.6),('16100','2013-05-15','13:30:00',7.44),('16100','2013-05-15','13:35:00',7.43),('16100','2013-05-15','13:40:00',7.38),('16100','2013-05-15','13:45:00',7.35),('16100','2013-05-15','13:50:00',7.43),('16100','2013-05-15','13:55:00',7.42),('16100','2013-05-15','14:00:00',7.33),('16100','2013-05-15','14:05:00',7.15),('16100','2013-05-15','14:10:00',7.08),('16100','2013-05-15','14:15:00',7.17),('16100','2013-05-15','14:20:00',7.09),('16100','2013-05-15','14:25:00',7.05),('16100','2013-05-15','14:30:00',6.85),('16100','2013-05-15','14:35:00',6.75),('16100','2013-05-15','14:40:00',6.74),('16100','2013-05-15','14:45:00',6.54),('16100','2013-05-15','14:50:00',6.74),('16100','2013-05-15','14:55:00',6.77),('16100','2013-05-15','15:00:00',6.57),('16100','2013-05-15','15:05:00',6.61),('16100','2013-05-15','15:10:00',6.39),('16100','2013-05-15','15:15:00',4.53),('16100','2013-05-15','15:20:00',6.37),('16100','2013-05-15','15:25:00',6.16),('16100','2013-05-15','15:30:00',6.07),('16100','2013-05-15','15:35:00',5.89),('16100','2013-05-15','15:40:00',5.88),('16100','2013-05-15','15:45:00',5.69),('16100','2013-05-15','15:50:00',5.65),('16100','2013-05-15','15:55:00',5.47),('16100','2013-05-15','16:00:00',5.43),('16100','2013-05-15','16:05:00',5.09),('16100','2013-05-15','16:10:00',5.33),('16100','2013-05-15','16:15:00',4.47),('16100','2013-05-15','16:20:00',4.85),('16100','2013-05-15','16:25:00',4.85),('16100','2013-05-15','16:30:00',4.47),('16100','2013-05-15','16:35:00',4.52),('16100','2013-05-15','16:40:00',4.73),('16100','2013-05-15','16:45:00',3.24),('16100','2013-05-15','16:50:00',3.81),('16100','2013-05-15','16:55:00',3.06),('16100','2013-05-15','17:00:00',2.16),('16100','2013-05-15','17:05:00',2),('16100','2013-05-15','17:10:00',1.46),('16100','2013-05-15','17:15:00',1.97),('16100','2013-05-15','17:20:00',2.18),('16100','2013-05-15','17:25:00',2.96),('16100','2013-05-15','17:30:00',3),('16100','2013-05-15','17:35:00',2.01),('16100','2013-05-15','17:40:00',1.2),('16100','2013-05-15','17:45:00',1.24),('16100','2013-05-15','17:50:00',1),('16100','2013-05-15','18:20:00',1.13),('16100','2013-05-15','18:25:00',1.18),('16100','2013-05-15','18:30:00',1.33),('16100','2013-05-15','18:35:00',1.56),('16100','2013-05-15','18:40:00',1.62),('16100','2013-05-15','18:45:00',1.68),('16100','2013-05-15','18:50:00',1.59),('16100','2013-05-15','18:55:00',1.49),('16100','2013-05-15','19:00:00',1.33),('16100','2013-05-15','19:05:00',1.09),('16100','2013-05-14','07:45:00',1.17),('16100','2013-05-14','07:50:00',1.48),('16100','2013-05-14','07:55:00',1.61),('16100','2013-05-14','08:00:00',1.55),('16100','2013-05-14','08:05:00',1.56),('16100','2013-05-14','08:10:00',1.87),('16100','2013-05-14','08:15:00',2.11),('16100','2013-05-14','08:20:00',2.28),('16100','2013-05-14','08:25:00',2.34),('16100','2013-05-14','08:30:00',2.52),('16100','2013-05-14','08:35:00',2.83),('16100','2013-05-14','08:40:00',3.02),('16100','2013-05-14','08:45:00',3.27),('16100','2013-05-14','08:50:00',3.66),('16100','2013-05-14','08:55:00',3.83),('16100','2013-05-14','09:00:00',3.85),('16100','2013-05-14','09:05:00',3.96),('16100','2013-05-14','09:10:00',4.13),('16100','2013-05-14','09:15:00',4.26),('16100','2013-05-14','09:20:00',4.31),('16100','2013-05-14','09:25:00',4.62),('16100','2013-05-14','09:30:00',4.88),('16100','2013-05-14','09:35:00',4.84),('16100','2013-05-14','09:40:00',4.92),('16100','2013-05-14','09:45:00',5.18),('16100','2013-05-14','09:50:00',5.34),('16100','2013-05-14','09:55:00',5.44),('16100','2013-05-14','10:00:00',5.52),('16100','2013-05-14','10:05:00',5.75),('16100','2013-05-14','10:10:00',5.83),('16100','2013-05-14','10:15:00',5.93),('16100','2013-05-14','10:20:00',6.09),('16100','2013-05-14','10:25:00',6.22),('16100','2013-05-14','10:30:00',6.12),('16100','2013-05-14','10:35:00',6.19),('16100','2013-05-14','10:40:00',6.34),('16100','2013-05-14','10:45:00',6.53),('16100','2013-05-14','10:50:00',6.66),('16100','2013-05-14','10:55:00',6.7),('16100','2013-05-14','11:00:00',6.57),('16100','2013-05-14','11:05:00',6.8),('16100','2013-05-14','11:10:00',6.7),('16100','2013-05-14','11:15:00',6.75),('16100','2013-05-14','11:20:00',6.79),('16100','2013-05-14','11:25:00',7.19),('16100','2013-05-14','11:30:00',7.52),('16100','2013-05-14','11:35:00',7.54),('16100','2013-05-14','11:40:00',7.25),('16100','2013-05-14','11:45:00',6.69),('16100','2013-05-14','11:50:00',4.54),('16100','2013-05-14','11:55:00',4.16),('16100','2013-05-14','12:00:00',6.5),('16100','2013-05-14','12:05:00',6.88),('16100','2013-05-14','12:10:00',7.7),('16100','2013-05-14','12:15:00',7.92),('16100','2013-05-14','12:20:00',8.74),('16100','2013-05-14','12:25:00',6.18),('16100','2013-05-14','12:30:00',7.25),('16100','2013-05-14','12:35:00',5.6),('16100','2013-05-14','12:40:00',4.85),('16100','2013-05-14','12:45:00',4.15),('16100','2013-05-14','12:50:00',3.94),('16100','2013-05-14','12:55:00',3.96),('16100','2013-05-14','13:00:00',4.07),('16100','2013-05-14','13:05:00',4.36),('16100','2013-05-14','13:10:00',4.11),('16100','2013-05-14','13:15:00',4.29),('16100','2013-05-14','13:20:00',4.12),('16100','2013-05-14','13:25:00',4.81),('16100','2013-05-14','13:30:00',4.34),('16100','2013-05-14','13:35:00',4.64),('16100','2013-05-14','13:40:00',4.96),('16100','2013-05-14','13:45:00',3.6),('16100','2013-05-14','13:50:00',3.68),('16100','2013-05-14','13:55:00',4.32),('16100','2013-05-14','14:00:00',3.19),('16100','2013-05-14','14:05:00',3.53),('16100','2013-05-14','14:10:00',3.89),('16100','2013-05-14','14:15:00',3.74),('16100','2013-05-14','14:20:00',3.74),('16100','2013-05-14','14:25:00',3.18),('16100','2013-05-14','14:30:00',2.61),('16100','2013-05-14','14:35:00',2.25),('16100','2013-05-14','14:40:00',2.2),('16100','2013-05-14','14:45:00',2.13),('16100','2013-05-14','14:50:00',2.11),('16100','2013-05-14','14:55:00',2.21),('16100','2013-05-14','15:00:00',2.12),('16100','2013-05-14','15:05:00',1.68),('16100','2013-05-14','15:10:00',1.39),('16100','2013-05-14','15:15:00',1.29),('16100','2013-05-14','15:20:00',1.24),('16100','2013-05-14','15:25:00',1.32),('16100','2013-05-14','15:30:00',1.4),('16100','2013-05-14','15:35:00',1.41),('16100','2013-05-14','15:40:00',1.54),('16100','2013-05-14','15:45:00',1.99),('16100','2013-05-14','15:50:00',2.74),('16100','2013-05-14','15:55:00',3.1),('16100','2013-05-14','16:00:00',2.94),('16100','2013-05-14','16:05:00',3.01),('16100','2013-05-14','16:10:00',2.86),('16100','2013-05-14','16:15:00',2.91),('16100','2013-05-14','16:20:00',2.89),('16100','2013-05-14','16:25:00',2.56),('16100','2013-05-14','16:30:00',2.17),('16100','2013-05-14','16:35:00',2.36),('16100','2013-05-14','16:40:00',2.13),('16100','2013-05-14','16:45:00',1.94),('16100','2013-05-14','16:50:00',2.04),('16100','2013-05-14','16:55:00',2.19),('16100','2013-05-14','17:00:00',2.47),('16100','2013-05-14','17:05:00',2.91),('16100','2013-05-14','17:10:00',2.92),('16100','2013-05-14','17:15:00',4.11),('16100','2013-05-14','17:20:00',3.92),('16100','2013-05-14','17:25:00',2.24),('16100','2013-05-14','17:30:00',1.89),('16100','2013-05-14','17:35:00',1.49),('16100','2013-05-14','17:40:00',1.39),('16100','2013-05-14','17:45:00',1.39),('16100','2013-05-14','17:50:00',1.3),('16100','2013-05-14','17:55:00',1.2),('16100','2013-05-13','07:45:00',1.09),('16100','2013-05-13','07:50:00',1.31),('16100','2013-05-13','07:55:00',1.49),('16100','2013-05-13','08:00:00',1.68),('16100','2013-05-13','08:05:00',1.87),('16100','2013-05-13','08:10:00',2.07),('16100','2013-05-13','08:15:00',2.26),('16100','2013-05-13','08:20:00',2.46),('16100','2013-05-13','08:25:00',2.64),('16100','2013-05-13','08:30:00',2.84),('16100','2013-05-13','08:35:00',3.02),('16100','2013-05-13','08:40:00',3.18),('16100','2013-05-13','08:45:00',3.47),('16100','2013-05-13','08:50:00',3.86),('16100','2013-05-13','08:55:00',4.06),('16100','2013-05-13','09:00:00',4.23),('16100','2013-05-13','09:05:00',4.37),('16100','2013-05-13','09:10:00',4.52),('16100','2013-05-13','09:15:00',4.66),('16100','2013-05-13','09:20:00',4.81),('16100','2013-05-13','09:25:00',4.95),('16100','2013-05-13','09:30:00',5.06),('16100','2013-05-13','09:35:00',5.19),('16100','2013-05-13','09:40:00',5.36),('16100','2013-05-13','09:45:00',5.51),('16100','2013-05-13','09:50:00',5.61),('16100','2013-05-13','09:55:00',5.75),('16100','2013-05-13','10:00:00',5.89),('16100','2013-05-13','10:05:00',6.05),('16100','2013-05-13','10:10:00',6.12),('16100','2013-05-13','10:15:00',6.22),('16100','2013-05-13','10:20:00',6.44),('16100','2013-05-13','10:25:00',6.55),('16100','2013-05-13','10:30:00',6.65),('16100','2013-05-13','10:35:00',6.73),('16100','2013-05-13','10:40:00',6.84),('16100','2013-05-13','10:45:00',6.88),('16100','2013-05-13','10:50:00',6.93),('16100','2013-05-13','10:55:00',7.01),('16100','2013-05-13','11:00:00',7.18),('16100','2013-05-13','11:05:00',7.26),('16100','2013-05-13','11:10:00',7.33),('16100','2013-05-13','11:15:00',7.35),('16100','2013-05-13','11:20:00',7.44),('16100','2013-05-13','11:25:00',6.17),('16100','2013-05-13','11:30:00',7.47),('16100','2013-05-13','11:35:00',7.53),('16100','2013-05-13','11:40:00',7.61),('16100','2013-05-13','11:45:00',7.65),('16100','2013-05-13','11:50:00',7.73),('16100','2013-05-13','11:55:00',7.75),('16100','2013-05-13','12:00:00',7.79),('16100','2013-05-13','12:05:00',6.23),('16100','2013-05-13','12:10:00',7.85),('16100','2013-05-13','12:15:00',7.87),('16100','2013-05-13','12:20:00',7.87),('16100','2013-05-13','12:25:00',7.83),('16100','2013-05-13','12:30:00',7.93),('16100','2013-05-13','12:35:00',7.91),('16100','2013-05-13','12:40:00',7.93),('16100','2013-05-13','12:45:00',7.95),('16100','2013-05-13','12:50:00',7.95),('16100','2013-05-13','12:55:00',8),('16100','2013-05-13','13:00:00',7.98),('16100','2013-05-13','13:05:00',7.97),('16100','2013-05-13','13:10:00',7.94),('16100','2013-05-13','13:15:00',7.91),('16100','2013-05-13','13:20:00',7.93),('16100','2013-05-13','13:25:00',7.92),('16100','2013-05-13','13:30:00',7.96),('16100','2013-05-13','13:35:00',8),('16100','2013-05-13','13:40:00',7.95),('16100','2013-05-13','13:45:00',7.96),('16100','2013-05-13','13:50:00',7.95),('16100','2013-05-13','13:55:00',7.89),('16100','2013-05-13','14:00:00',7.81),('16100','2013-05-13','14:05:00',7.59),('16100','2013-05-13','14:10:00',7.59),('16100','2013-05-13','14:15:00',7.57),('16100','2013-05-13','14:20:00',7.56),('16100','2013-05-13','14:25:00',7.54),('16100','2013-05-13','14:30:00',7.53),('16100','2013-05-13','14:35:00',7.57),('16100','2013-05-13','14:40:00',7.6),('16100','2013-05-13','14:45:00',7.6),('16100','2013-05-13','14:50:00',7.56),('16100','2013-05-13','14:55:00',7.53),('16100','2013-05-13','15:00:00',7.48),('16100','2013-05-13','15:05:00',7.4),('16100','2013-05-13','15:10:00',7.33),('16100','2013-05-13','15:15:00',7.23),('16100','2013-05-13','15:20:00',7.12),('16100','2013-05-13','15:25:00',7.07),('16100','2013-05-13','15:30:00',6.97),('16100','2013-05-13','15:35:00',6.86),('16100','2013-05-13','15:40:00',6.75),('16100','2013-05-13','15:45:00',6.65),('16100','2013-05-13','15:50:00',6.56),('16100','2013-05-13','15:55:00',6.46),('16100','2013-05-13','16:00:00',6.33),('16100','2013-05-13','16:05:00',6.22),('16100','2013-05-13','16:10:00',6.1),('16100','2013-05-13','16:15:00',5.91),('16100','2013-05-13','16:20:00',5.8),('16100','2013-05-13','16:25:00',5.67),('16100','2013-05-13','16:30:00',5.57),('16100','2013-05-13','16:35:00',5.44),('16100','2013-05-13','16:40:00',5.29),('16100','2013-05-13','16:45:00',5.13),('16100','2013-05-13','16:50:00',5.01),('16100','2013-05-13','16:55:00',4.86),('16100','2013-05-13','17:00:00',4.68),('16100','2013-05-13','17:05:00',4.52),('16100','2013-05-13','17:10:00',4.36),('16100','2013-05-13','17:15:00',4.21),('16100','2013-05-13','17:20:00',4.05),('16100','2013-05-13','17:25:00',3.88),('16100','2013-05-13','17:30:00',3.68),('16100','2013-05-13','17:35:00',3.51),('16100','2013-05-13','17:40:00',3.36),('16100','2013-05-13','17:45:00',3.19),('16100','2013-05-13','17:50:00',3),('16100','2013-05-13','17:55:00',2.83),('16100','2013-05-13','18:00:00',2.66),('16100','2013-05-13','18:05:00',2.49),('16100','2013-05-13','18:10:00',2.32),('16100','2013-05-13','18:15:00',2.14),('16100','2013-05-13','18:20:00',1.95),('16100','2013-05-13','18:25:00',1.73),('16100','2013-05-13','18:30:00',1.56),('16100','2013-05-13','18:35:00',1.38),('16100','2013-05-13','18:40:00',1.2),('16100','2013-05-13','18:45:00',1.04),('16100','2013-05-12','07:45:00',1.2),('16100','2013-05-12','07:50:00',1.42),('16100','2013-05-12','07:55:00',1.48),('16100','2013-05-12','08:00:00',1.57),('16100','2013-05-12','08:05:00',1.73),('16100','2013-05-12','08:10:00',1.88),('16100','2013-05-12','08:15:00',2.06),('16100','2013-05-12','08:20:00',2.27),('16100','2013-05-12','08:25:00',2.42),('16100','2013-05-12','08:30:00',2.61),('16100','2013-05-12','08:35:00',2.79),('16100','2013-05-12','08:40:00',2.96),('16100','2013-05-12','08:45:00',3.3),('16100','2013-05-12','08:50:00',3.6),('16100','2013-05-12','08:55:00',3.78),('16100','2013-05-12','09:00:00',3.95),('16100','2013-05-12','09:05:00',4.03),('16100','2013-05-12','09:10:00',4.18),('16100','2013-05-12','09:15:00',4.35),('16100','2013-05-12','09:20:00',4.54),('16100','2013-05-12','09:25:00',4.74),('16100','2013-05-12','09:30:00',4.89),('16100','2013-05-12','09:35:00',5.06),('16100','2013-05-12','09:40:00',4.53),('16100','2013-05-12','09:45:00',5.85),('16100','2013-05-12','09:50:00',4.94),('16100','2013-05-12','09:55:00',1.86),('16100','2013-05-12','10:00:00',2.15),('16100','2013-05-12','10:05:00',4.17),('16100','2013-05-12','10:10:00',3.43),('16100','2013-05-12','10:15:00',4.03),('16100','2013-05-12','10:20:00',6.91),('16100','2013-05-12','10:25:00',3.37),('16100','2013-05-12','10:30:00',2.4),('16100','2013-05-12','10:35:00',4.91),('16100','2013-05-12','10:40:00',7.1),('16100','2013-05-12','10:45:00',7.18),('16100','2013-05-12','10:50:00',4.59),('16100','2013-05-12','10:55:00',7.16),('16100','2013-05-12','11:00:00',7.84),('16100','2013-05-12','11:05:00',5.19),('16100','2013-05-12','11:10:00',6.41),('16100','2013-05-12','11:15:00',6.18),('16100','2013-05-12','11:20:00',5.93),('16100','2013-05-12','11:25:00',4.02),('16100','2013-05-12','11:30:00',3.79),('16100','2013-05-12','11:35:00',8.49),('16100','2013-05-12','11:40:00',8.1),('16100','2013-05-12','11:45:00',8.06),('16100','2013-05-12','11:50:00',6.03),('16100','2013-05-12','11:55:00',5.4),('16100','2013-05-12','12:00:00',3.07),('16100','2013-05-12','12:05:00',3.89),('16100','2013-05-12','12:10:00',2.48),('16100','2013-05-12','12:15:00',6.28),('16100','2013-05-12','12:20:00',5.53),('16100','2013-05-12','12:25:00',7.5),('16100','2013-05-12','12:30:00',6.11),('16100','2013-05-12','12:35:00',8.68),('16100','2013-05-12','12:40:00',8.9),('16100','2013-05-12','12:45:00',8.5),('16100','2013-05-12','12:50:00',8.51),('16100','2013-05-12','12:55:00',8.03),('16100','2013-05-12','13:00:00',8.75),('16100','2013-05-12','13:05:00',8.88),('16100','2013-05-12','13:10:00',8.96),('16100','2013-05-12','13:15:00',2.74),('16100','2013-05-12','13:20:00',1.68),('16100','2013-05-12','13:25:00',4.24),('16100','2013-05-12','13:30:00',3.73),('16100','2013-05-12','13:35:00',2.02),('16100','2013-05-12','13:40:00',5.43),('16100','2013-05-12','13:45:00',7.97),('16100','2013-05-12','13:50:00',8.96),('16100','2013-05-12','13:55:00',8.64),('16100','2013-05-12','14:00:00',8.37),('16100','2013-05-12','14:05:00',5.18),('16100','2013-05-12','14:10:00',2.56),('16100','2013-05-12','14:15:00',6.25),('16100','2013-05-12','14:20:00',2),('16100','2013-05-12','14:25:00',1.21),('16100','2013-05-12','14:35:00',1.35),('16100','2013-05-12','14:40:00',7.55),('16100','2013-05-12','14:45:00',6.88),('16100','2013-05-12','14:50:00',7.03),('16100','2013-05-12','14:55:00',2.83),('16100','2013-05-12','15:00:00',1.76),('16100','2013-05-12','15:05:00',1.5),('16100','2013-05-12','15:10:00',1.33),('16100','2013-05-12','15:15:00',1.23),('16100','2013-05-12','15:20:00',1.13),('16100','2013-05-12','15:25:00',1.24),('16100','2013-05-12','15:30:00',1.29),('16100','2013-05-12','15:35:00',1.63),('16100','2013-05-12','15:40:00',3.51),('16100','2013-05-12','15:45:00',1.84),('16100','2013-05-12','15:50:00',1.15),('16100','2013-05-12','15:55:00',1.75),('16100','2013-05-12','16:00:00',2.41),('16100','2013-05-12','16:05:00',2.81),('16100','2013-05-12','16:10:00',2.41),('16100','2013-05-12','16:15:00',2.1),('16100','2013-05-12','16:20:00',1.94),('16100','2013-05-12','16:25:00',1.72),('16100','2013-05-12','16:30:00',1.56),('16100','2013-05-12','16:35:00',1.54),('16100','2013-05-12','16:40:00',1.55),('16100','2013-05-12','16:45:00',1.58),('16100','2013-05-12','16:50:00',3.18),('16100','2013-05-12','16:55:00',4.96),('16100','2013-05-12','17:00:00',2.25),('16100','2013-05-12','17:05:00',1.27),('16100','2013-05-12','17:10:00',1.19),('16100','2013-05-12','17:15:00',1.73),('16100','2013-05-12','17:25:00',2.85),('16100','2013-05-12','17:30:00',2.98),('16100','2013-05-12','17:35:00',3.77),('16100','2013-05-12','17:40:00',3.65),('16100','2013-05-12','17:45:00',3.5),('16100','2013-05-12','17:50:00',3.51),('16100','2013-05-12','17:55:00',3.26),('16100','2013-05-12','18:00:00',2.35),('16100','2013-05-12','18:05:00',1.5),('16100','2013-05-12','18:10:00',2.18),('16100','2013-05-12','18:15:00',2.43),('16100','2013-05-12','18:20:00',2.48),('16100','2013-05-12','18:25:00',1.94),('16100','2013-05-12','18:30:00',1.77),('16100','2013-05-12','18:35:00',1.58),('16100','2013-05-12','18:40:00',1.16),('16100','2013-05-11','07:40:00',1.08),('16100','2013-05-11','07:45:00',1.45),('16100','2013-05-11','07:50:00',1.58),('16100','2013-05-11','07:55:00',1.36),('16100','2013-05-11','08:00:00',1.49),('16100','2013-05-11','08:05:00',1.47),('16100','2013-05-11','08:10:00',1.11),('16100','2013-05-11','08:15:00',1.26),('16100','2013-05-11','08:20:00',1.36),('16100','2013-05-11','08:25:00',1.27),('16100','2013-05-11','08:30:00',1.39),('16100','2013-05-11','08:35:00',1.52),('16100','2013-05-11','08:40:00',1.72),('16100','2013-05-11','08:45:00',1.77),('16100','2013-05-11','08:50:00',2.3),('16100','2013-05-11','08:55:00',1.75),('16100','2013-05-11','09:00:00',2.24),('16100','2013-05-11','09:05:00',2.63),('16100','2013-05-11','09:10:00',4.87),('16100','2013-05-11','09:15:00',3.04),('16100','2013-05-11','09:20:00',2.68),('16100','2013-05-11','09:25:00',5.71),('16100','2013-05-11','09:30:00',3.13),('16100','2013-05-11','09:35:00',2.91),('16100','2013-05-11','09:40:00',4.95),('16100','2013-05-11','09:45:00',3.11),('16100','2013-05-11','09:50:00',4.9),('16100','2013-05-11','09:55:00',6),('16100','2013-05-11','10:00:00',6.15),('16100','2013-05-11','10:05:00',6.44),('16100','2013-05-11','10:10:00',6.8),('16100','2013-05-11','10:15:00',6.99),('16100','2013-05-11','10:20:00',6.16),('16100','2013-05-11','10:25:00',2.82),('16100','2013-05-11','10:30:00',3.82),('16100','2013-05-11','10:35:00',3.51),('16100','2013-05-11','10:40:00',1.87),('16100','2013-05-11','10:45:00',6.21),('16100','2013-05-11','10:50:00',8.04),('16100','2013-05-11','10:55:00',7.77),('16100','2013-05-11','11:00:00',7.74),('16100','2013-05-11','11:05:00',7.97),('16100','2013-05-11','11:10:00',8.26),('16100','2013-05-11','11:15:00',8.54),('16100','2013-05-11','11:20:00',5.35),('16100','2013-05-11','11:25:00',4.24),('16100','2013-05-11','11:30:00',2.9),('16100','2013-05-11','11:35:00',2.02),('16100','2013-05-11','11:40:00',1.91),('16100','2013-05-11','11:45:00',6.13),('16100','2013-05-11','11:50:00',3.98),('16100','2013-05-11','11:55:00',1.68),('16100','2013-05-11','12:00:00',4.56),('16100','2013-05-11','12:05:00',7.4),('16100','2013-05-11','12:10:00',4.1),('16100','2013-05-11','12:15:00',2.11),('16100','2013-05-11','12:20:00',1.82),('16100','2013-05-11','12:25:00',2.02),('16100','2013-05-11','12:30:00',2.26),('16100','2013-05-11','12:35:00',2.52),('16100','2013-05-11','12:40:00',8.07),('16100','2013-05-11','12:45:00',8.3),('16100','2013-05-11','12:50:00',9.13),('16100','2013-05-11','12:55:00',8.73),('16100','2013-05-11','13:00:00',8.4),('16100','2013-05-11','13:05:00',8.11),('16100','2013-05-11','13:10:00',5.49),('16100','2013-05-11','13:15:00',8.6),('16100','2013-05-11','13:20:00',7.99),('16100','2013-05-11','13:25:00',8.51),('16100','2013-05-11','13:30:00',5.17),('16100','2013-05-11','13:35:00',9.07),('16100','2013-05-11','13:40:00',8.88),('16100','2013-05-11','13:45:00',6.16),('16100','2013-05-11','13:50:00',6.24),('16100','2013-05-11','13:55:00',8.6),('16100','2013-05-11','14:00:00',3.9),('16100','2013-05-11','14:05:00',4.82),('16100','2013-05-11','14:10:00',5.87),('16100','2013-05-11','14:15:00',7.17),('16100','2013-05-11','14:20:00',7.45),('16100','2013-05-11','14:25:00',8.54),('16100','2013-05-11','14:30:00',8.67),('16100','2013-05-11','14:35:00',8.43),('16100','2013-05-11','14:40:00',5.5),('16100','2013-05-11','14:45:00',6.94),('16100','2013-05-11','14:50:00',7.51),('16100','2013-05-11','14:55:00',7.05),('16100','2013-05-11','15:00:00',6.8),('16100','2013-05-11','15:05:00',6.2),('16100','2013-05-11','15:10:00',5.97),('16100','2013-05-11','15:15:00',6.77),('16100','2013-05-11','15:20:00',7.17),('16100','2013-05-11','15:25:00',7.13),('16100','2013-05-11','15:30:00',6.39),('16100','2013-05-11','15:35:00',6.87),('16100','2013-05-11','15:40:00',6.63),('16100','2013-05-11','15:45:00',6.54),('16100','2013-05-11','15:50:00',6.45),('16100','2013-05-11','15:55:00',6.33),('16100','2013-05-11','16:00:00',6.2),('16100','2013-05-11','16:05:00',6.07),('16100','2013-05-11','16:10:00',5.96),('16100','2013-05-11','16:15:00',5.8),('16100','2013-05-11','16:20:00',4.88),('16100','2013-05-11','16:25:00',5.75),('16100','2013-05-11','16:30:00',5.4),('16100','2013-05-11','16:35:00',5.72),('16100','2013-05-11','16:40:00',5.71),('16100','2013-05-11','16:45:00',5.76),('16100','2013-05-11','16:50:00',6.12),('16100','2013-05-11','16:55:00',6),('16100','2013-05-11','17:00:00',5.62),('16100','2013-05-11','17:05:00',3.77),('16100','2013-05-11','17:10:00',5.54),('16100','2013-05-11','17:15:00',4.4),('16100','2013-05-11','17:20:00',3.71),('16100','2013-05-11','17:25:00',3.04),('16100','2013-05-11','17:30:00',2.51),('16100','2013-05-11','17:35:00',3.83),('16100','2013-05-11','17:40:00',3.57),('16100','2013-05-11','17:45:00',2.36),('16100','2013-05-11','17:50:00',2.65),('16100','2013-05-11','17:55:00',2.1),('16100','2013-05-11','18:00:00',2.42),('16100','2013-05-11','18:05:00',2.13),('16100','2013-05-11','18:10:00',2.86),('16100','2013-05-11','18:15:00',2.4),('16100','2013-05-11','18:20:00',2.1),('16100','2013-05-11','18:25:00',1.98),('16100','2013-05-11','18:30:00',1.78),('16100','2013-05-11','18:35:00',2.02),('16100','2013-05-11','18:40:00',1.64),('16100','2013-05-11','18:45:00',1.11),('16100','2013-05-11','18:55:00',1.01),('16100','2013-05-11','19:00:00',1.03),('16100','2013-05-11','19:05:00',1.25),('16100','2013-05-11','19:15:00',1.06),('16100','2014-03-30','08:15:00',1.12),('16100','2014-03-30','08:20:00',1.29),('16100','2014-03-30','08:25:00',1.46),('16100','2014-03-30','08:30:00',1.64),('16100','2014-03-30','08:35:00',1.84),('16100','2014-03-30','08:40:00',2.02),('16100','2014-03-30','08:45:00',2.22),('16100','2014-03-30','08:50:00',2.42),('16100','2014-03-30','08:55:00',2.6),('16100','2014-03-30','09:00:00',2.77),('16100','2014-03-30','09:05:00',2.96),('16100','2014-03-30','09:10:00',3.12),('16100','2014-03-30','09:15:00',3.28),('16100','2014-03-30','09:20:00',3.46),('16100','2014-03-30','09:25:00',3.67),('16100','2014-03-30','09:30:00',3.81),('16100','2014-03-30','09:35:00',3.95),('16100','2014-03-30','09:40:00',4.08),('16100','2014-03-30','09:45:00',4.23),('16100','2014-03-30','09:50:00',4.38),('16100','2014-03-30','09:55:00',4.54),('16100','2014-03-30','10:00:00',4.65),('16100','2014-03-30','10:05:00',4.77),('16100','2014-03-30','10:10:00',4.91),('16100','2014-03-30','10:15:00',5.02),('16100','2014-03-30','10:20:00',5.09),('16100','2014-03-30','10:25:00',5.21),('16100','2014-03-30','10:30:00',5.34),('16100','2014-03-30','10:35:00',5.51),('16100','2014-03-30','10:40:00',5.61),('16100','2014-03-30','10:45:00',5.71),('16100','2014-03-30','10:50:00',5.78),('16100','2014-03-30','10:55:00',5.91),('16100','2014-03-30','11:00:00',6.03),('16100','2014-03-30','11:05:00',6.11),('16100','2014-03-30','11:10:00',6.21),('16100','2014-03-30','11:15:00',6.25),('16100','2014-03-30','11:20:00',6.36),('16100','2014-03-30','11:25:00',6.44),('16100','2014-03-30','11:30:00',6.47),('16100','2014-03-30','11:35:00',6.62),('16100','2014-03-30','11:40:00',6.72),('16100','2014-03-30','11:45:00',6.71),('16100','2014-03-30','11:50:00',6.77),('16100','2014-03-30','11:55:00',6.84),('16100','2014-03-30','12:00:00',6.91),('16100','2014-03-30','12:05:00',7.01),('16100','2014-03-30','12:10:00',7.13),('16100','2014-03-30','12:15:00',7.17),('16100','2014-03-30','12:20:00',7.15),('16100','2014-03-30','12:25:00',7.19),('16100','2014-03-30','12:30:00',7.17),('16100','2014-03-30','12:35:00',7.21),('16100','2014-03-30','12:40:00',7.23),('16100','2014-03-30','12:45:00',7.29),('16100','2014-03-30','12:50:00',7.37),('16100','2014-03-30','12:55:00',7.37),('16100','2014-03-30','13:00:00',7.36),('16100','2014-03-30','13:05:00',7.4),('16100','2014-03-30','13:10:00',7.4),('16100','2014-03-30','13:15:00',7.39),('16100','2014-03-30','13:20:00',7.42),('16100','2014-03-30','13:25:00',7.36),('16100','2014-03-30','13:30:00',7.39),('16100','2014-03-30','13:35:00',7.4),('16100','2014-03-30','13:40:00',7.39),('16100','2014-03-30','13:45:00',7.41),('16100','2014-03-30','13:50:00',7.36),('16100','2014-03-30','13:55:00',7.39),('16100','2014-03-30','14:00:00',7.36),('16100','2014-03-30','14:05:00',7.33),('16100','2014-03-30','14:10:00',7.3),('16100','2014-03-30','14:15:00',7.19),('16100','2014-03-30','14:20:00',7.18),('16100','2014-03-30','14:25:00',7.13),('16100','2014-03-30','14:30:00',7.09),('16100','2014-03-30','14:35:00',7.04),('16100','2014-03-30','14:40:00',7.02),('16100','2014-03-30','14:45:00',6.96),('16100','2014-03-30','14:50:00',6.9),('16100','2014-03-30','14:55:00',6.84),('16100','2014-03-30','15:00:00',6.75),('16100','2014-03-30','15:05:00',6.7),('16100','2014-03-30','15:10:00',6.62),('16100','2014-03-30','15:15:00',6.57),('16100','2014-03-30','15:20:00',6.42),('16100','2014-03-30','15:25:00',6.29),('16100','2014-03-30','15:30:00',6.2),('16100','2014-03-30','15:35:00',6.15),('16100','2014-03-30','15:40:00',6.01),('16100','2014-03-30','15:45:00',5.87),('16100','2014-03-30','15:50:00',5.69),('16100','2014-03-30','15:55:00',5.59),('16100','2014-03-30','16:00:00',5.46),('16100','2014-03-30','16:05:00',5.36),('16100','2014-03-30','16:10:00',5.18),('16100','2014-03-30','16:15:00',5.09),('16100','2014-03-30','16:20:00',4.93),('16100','2014-03-30','16:25:00',4.82),('16100','2014-03-30','16:30:00',4.71),('16100','2014-03-30','16:35:00',4.59),('16100','2014-03-30','16:40:00',4.46),('16100','2014-03-30','16:45:00',4.28),('16100','2014-03-30','16:50:00',4.13),('16100','2014-03-30','16:55:00',3.97),('16100','2014-03-30','17:00:00',3.83),('16100','2014-03-30','17:05:00',3.67),('16100','2014-03-30','17:10:00',3.44),('16100','2014-03-30','17:15:00',3.3),('16100','2014-03-30','17:20:00',3.11),('16100','2014-03-30','17:25:00',2.91),('16100','2014-03-30','17:30:00',2.75),('16100','2014-03-30','17:35:00',2.58),('16100','2014-03-30','17:40:00',2.42),('16100','2014-03-30','17:45:00',2.27),('16100','2014-03-30','17:50:00',2.08),('16100','2014-03-30','17:55:00',1.91),('16100','2014-03-30','18:00:00',1.76),('16100','2014-03-30','18:05:00',1.61),('16100','2014-03-30','18:10:00',1.48),('16100','2014-03-30','18:15:00',1.35),('16100','2014-03-30','18:20:00',1.25),('16100','2014-03-30','18:25:00',1.15),('16100','2014-03-30','18:30:00',1.03),('16100','2013-05-10','07:40:00',1.06),('16100','2013-05-10','07:45:00',1.58),('16100','2013-05-10','07:50:00',1.47),('16100','2013-05-10','07:55:00',1.02),('16100','2013-05-10','08:00:00',1.82),('16100','2013-05-10','08:05:00',2.24),('16100','2013-05-10','08:10:00',2.23),('16100','2013-05-10','08:15:00',1.44),('16100','2013-05-10','08:20:00',1.03),('16100','2013-05-10','08:40:00',1.38),('16100','2013-05-10','08:45:00',1.48),('16100','2013-05-10','08:50:00',1.48),('16100','2013-05-10','08:55:00',3.12),('16100','2013-05-10','09:00:00',3.34),('16100','2013-05-10','09:05:00',3.74),('16100','2013-05-10','09:10:00',2.74),('16100','2013-05-10','09:15:00',2.48),('16100','2013-05-10','09:20:00',5.26),('16100','2013-05-10','09:25:00',3.11),('16100','2013-05-10','09:30:00',1.72),('16100','2013-05-10','09:35:00',1.49),('16100','2013-05-10','09:40:00',2.88),('16100','2013-05-10','09:45:00',1.81),('16100','2013-05-10','09:50:00',1.84),('16100','2013-05-10','09:55:00',1.93),('16100','2013-05-10','10:00:00',2.48),('16100','2013-05-10','10:05:00',2.88),('16100','2013-05-10','10:10:00',2.05),('16100','2013-05-10','10:15:00',2.47),('16100','2013-05-10','10:20:00',2.35),('16100','2013-05-10','10:25:00',5.91),('16100','2013-05-10','10:30:00',1.71),('16100','2013-05-10','10:35:00',1.24),('16100','2013-05-10','10:40:00',1.24),('16100','2013-05-10','10:45:00',4.19),('16100','2013-05-10','10:50:00',1.34),('16100','2013-05-10','10:55:00',2.02),('16100','2013-05-10','11:00:00',5.2),('16100','2013-05-10','11:05:00',2.63),('16100','2013-05-10','11:10:00',2.07),('16100','2013-05-10','11:15:00',2.25),('16100','2013-05-10','11:20:00',1.71),('16100','2013-05-10','11:25:00',4.05),('16100','2013-05-10','11:30:00',8.74),('16100','2013-05-10','11:35:00',5.26),('16100','2013-05-10','11:40:00',7.64),('16100','2013-05-10','11:45:00',3.23),('16100','2013-05-10','11:50:00',3.16),('16100','2013-05-10','11:55:00',6.44),('16100','2013-05-10','12:00:00',6.76),('16100','2013-05-10','12:05:00',5.34),('16100','2013-05-10','12:10:00',6.37),('16100','2013-05-10','12:15:00',5.01),('16100','2013-05-10','12:20:00',2.9),('16100','2013-05-10','12:25:00',1.97),('16100','2013-05-10','12:30:00',3.08),('16100','2013-05-10','12:35:00',2.53),('16100','2013-05-10','12:40:00',3.09),('16100','2013-05-10','12:45:00',2.22),('16100','2013-05-10','12:50:00',2.59),('16100','2013-05-10','12:55:00',2.9),('16100','2013-05-10','13:00:00',5.74),('16100','2013-05-10','13:05:00',7.22),('16100','2013-05-10','13:10:00',7.7),('16100','2013-05-10','13:15:00',8.57),('16100','2013-05-10','13:20:00',6.5),('16100','2013-05-10','13:25:00',6.44),('16100','2013-05-10','13:30:00',3.72),('16100','2013-05-10','13:35:00',3.54),('16100','2013-05-10','13:40:00',5.73),('16100','2013-05-10','13:45:00',7.22),('16100','2013-05-10','13:50:00',6.75),('16100','2013-05-10','13:55:00',7.74),('16100','2013-05-10','14:00:00',3.28),('16100','2013-05-10','14:05:00',4.41),('16100','2013-05-10','14:10:00',5.81),('16100','2013-05-10','14:15:00',5.12),('16100','2013-05-10','14:20:00',2.79),('16100','2013-05-10','14:25:00',4.66),('16100','2013-05-10','14:30:00',7.36),('16100','2013-05-10','14:35:00',6.53),('16100','2013-05-10','14:40:00',4.88),('16100','2013-05-10','14:45:00',2.85),('16100','2013-05-10','14:50:00',3.64),('16100','2013-05-10','14:55:00',6.95),('16100','2013-05-10','15:00:00',3.7),('16100','2013-05-10','15:05:00',3.59),('16100','2013-05-10','15:10:00',6.26),('16100','2013-05-10','15:15:00',4.9),('16100','2013-05-10','15:20:00',3.14),('16100','2013-05-10','15:25:00',3.52),('16100','2013-05-10','15:30:00',5.05),('16100','2013-05-10','15:35:00',5.18),('16100','2013-05-10','15:40:00',5.06),('16100','2013-05-10','15:45:00',4.31),('16100','2013-05-10','15:50:00',4.84),('16100','2013-05-10','15:55:00',5.86),('16100','2013-05-10','16:00:00',4.78),('16100','2013-05-10','16:05:00',5.61),('16100','2013-05-10','16:10:00',5.92),('16100','2013-05-10','16:15:00',6.19),('16100','2013-05-10','16:20:00',4.29),('16100','2013-05-10','16:25:00',6.12),('16100','2013-05-10','16:30:00',5.25),('16100','2013-05-10','16:35:00',5.6),('16100','2013-05-10','16:40:00',5.38),('16100','2013-05-10','16:45:00',5.07),('16100','2013-05-10','16:50:00',5.11),('16100','2013-05-10','16:55:00',3.16),('16100','2013-05-10','17:00:00',1.99),('16100','2013-05-10','17:05:00',3.14),('16100','2013-05-10','17:10:00',3.16),('16100','2013-05-10','17:15:00',4.53),('16100','2013-05-10','17:20:00',3.9),('16100','2013-05-10','17:25:00',4.26),('16100','2013-05-10','17:30:00',2.59),('16100','2013-05-10','17:35:00',2.86),('16100','2013-05-10','17:40:00',1.19),('16100','2013-05-10','17:45:00',1.62),('16100','2013-05-10','17:50:00',3.7),('16100','2013-05-10','17:55:00',2.88),('16100','2013-05-10','18:00:00',2.96),('16100','2013-05-10','18:05:00',1.64),('16100','2013-05-10','18:10:00',2.78),('16100','2013-05-10','18:15:00',2.05),('16100','2013-05-10','18:20:00',2.72),('16100','2013-05-10','18:25:00',1.56),('16100','2013-05-10','18:30:00',1.54),('16100','2013-05-10','18:35:00',1.2),('16100','2013-05-10','18:40:00',1.13),('16100','2013-05-09','07:20:00',1.14),('16100','2013-05-09','07:25:00',1.28),('16100','2013-05-09','07:30:00',1.59),('16100','2013-05-09','07:35:00',1.51),('16100','2013-05-09','07:40:00',1.41),('16100','2013-05-09','07:45:00',1.5),('16100','2013-05-09','07:50:00',1.77),('16100','2013-05-09','07:55:00',1.87),('16100','2013-05-09','08:00:00',2.26),('16100','2013-05-09','08:05:00',2.02),('16100','2013-05-09','08:10:00',2),('16100','2013-05-09','08:15:00',1.74),('16100','2013-05-09','08:20:00',2),('16100','2013-05-09','08:25:00',2.26),('16100','2013-05-09','08:30:00',1.98),('16100','2013-05-09','08:35:00',1.18),('16100','2013-05-09','08:45:00',1.22),('16100','2013-05-09','08:50:00',2.32),('16100','2013-05-09','08:55:00',3.89),('16100','2013-05-09','09:00:00',4.01),('16100','2013-05-09','09:05:00',4.08),('16100','2013-05-09','09:10:00',4.36),('16100','2013-05-09','09:15:00',4.58),('16100','2013-05-09','09:20:00',4.16),('16100','2013-05-09','09:25:00',4.86),('16100','2013-05-09','09:30:00',4.92),('16100','2013-05-09','09:35:00',4.75),('16100','2013-05-09','09:40:00',5.08),('16100','2013-05-09','09:45:00',5.13),('16100','2013-05-09','09:50:00',4.37),('16100','2013-05-09','09:55:00',4.96),('16100','2013-05-09','10:00:00',6.28),('16100','2013-05-09','10:05:00',4.89),('16100','2013-05-09','10:10:00',2.37),('16100','2013-05-09','10:15:00',1.86),('16100','2013-05-09','10:20:00',1.52),('16100','2013-05-09','10:25:00',3.87),('16100','2013-05-09','10:30:00',6.73),('16100','2013-05-09','10:35:00',6.4),('16100','2013-05-09','10:40:00',6.63),('16100','2013-05-09','10:45:00',6.73),('16100','2013-05-09','10:50:00',7.07),('16100','2013-05-09','10:55:00',7.07),('16100','2013-05-09','11:00:00',7.5),('16100','2013-05-09','11:05:00',7.7),('16100','2013-05-09','11:10:00',7.85),('16100','2013-05-09','11:15:00',7.39),('16100','2013-05-09','11:20:00',7.24),('16100','2013-05-09','11:25:00',6.03),('16100','2013-05-09','11:30:00',8.04),('16100','2013-05-09','11:35:00',6.36),('16100','2013-05-09','11:40:00',3.11),('16100','2013-05-09','11:45:00',8.09),('16100','2013-05-09','11:50:00',6.26),('16100','2013-05-09','11:55:00',4.05),('16100','2013-05-09','12:00:00',7.6),('16100','2013-05-09','12:05:00',6.03),('16100','2013-05-09','12:10:00',5.35),('16100','2013-05-09','12:15:00',4.97),('16100','2013-05-09','12:20:00',4.9),('16100','2013-05-09','12:25:00',4.81),('16100','2013-05-09','12:30:00',7.02),('16100','2013-05-09','12:35:00',9.38),('16100','2013-05-09','12:40:00',9.05),('16100','2013-05-09','12:45:00',7.45),('16100','2013-05-09','12:50:00',7.72),('16100','2013-05-09','12:55:00',8.78),('16100','2013-05-09','13:00:00',6.5),('16100','2013-05-09','13:05:00',6.54),('16100','2013-05-09','13:10:00',7.96),('16100','2013-05-09','13:15:00',6.5),('16100','2013-05-09','13:20:00',5.94),('16100','2013-05-09','13:25:00',8.1),('16100','2013-05-09','13:30:00',9),('16100','2013-05-09','13:35:00',9.37),('16100','2013-05-09','13:40:00',6.68),('16100','2013-05-09','13:45:00',3.98),('16100','2013-05-09','13:50:00',3.35),('16100','2013-05-09','13:55:00',3.28),('16100','2013-05-09','14:00:00',3.9),('16100','2013-05-09','14:05:00',4.88),('16100','2013-05-09','14:10:00',4.91),('16100','2013-05-09','14:15:00',4.9),('16100','2013-05-09','14:20:00',4.19),('16100','2013-05-09','14:25:00',4.24),('16100','2013-05-09','14:30:00',4.59),('16100','2013-05-09','14:35:00',3.75),('16100','2013-05-09','14:40:00',2.99),('16100','2013-05-09','14:45:00',2.46),('16100','2013-05-09','14:50:00',2.27),('16100','2013-05-09','14:55:00',2.7),('16100','2013-05-09','15:00:00',4.43),('16100','2013-05-09','15:05:00',7.26),('16100','2013-05-09','15:10:00',5.34),('16100','2013-05-09','15:15:00',3.7),('16100','2013-05-09','15:20:00',3.47),('16100','2013-05-09','15:25:00',3.59),('16100','2013-05-09','15:30:00',4.19),('16100','2013-05-09','15:35:00',3.88),('16100','2013-05-09','15:40:00',3.44),('16100','2013-05-09','15:45:00',3.08),('16100','2013-05-09','15:50:00',2.91),('16100','2013-05-09','15:55:00',2.91),('16100','2013-05-09','16:00:00',2.88),('16100','2013-05-09','16:05:00',2.64),('16100','2013-05-09','16:10:00',2.41),('16100','2013-05-09','16:15:00',2.39),('16100','2013-05-09','16:20:00',2.44),('16100','2013-05-09','16:25:00',2.66),('16100','2013-05-09','16:30:00',2.87),('16100','2013-05-09','16:35:00',2.55),('16100','2013-05-09','16:40:00',2.41),('16100','2013-05-09','16:45:00',2.18),('16100','2013-05-09','16:50:00',1.78),('16100','2013-05-09','16:55:00',1.79),('16100','2013-05-09','17:00:00',2.04),('16100','2013-05-09','17:05:00',2.58),('16100','2013-05-09','17:10:00',2.85),('16100','2013-05-09','17:15:00',3.28),('16100','2013-05-09','17:20:00',4.4),('16100','2013-05-09','17:25:00',5.54),('16100','2013-05-09','17:30:00',4.37),('16100','2013-05-09','17:35:00',2.17),('16100','2013-05-09','17:40:00',2.4),('16100','2013-05-09','17:45:00',1.68),('16100','2013-05-09','17:50:00',1.54),('16100','2013-05-09','17:55:00',1.46),('16100','2013-05-09','18:00:00',1.37),('16100','2013-05-09','18:05:00',1.28),('16100','2013-05-09','18:10:00',1.16),('16100','2013-05-09','18:15:00',1.11),('16100','2013-05-08','07:45:00',1.01),('16100','2013-05-08','07:50:00',1.21),('16100','2013-05-08','07:55:00',1.38),('16100','2013-05-08','08:00:00',1.52),('16100','2013-05-08','08:05:00',1.7),('16100','2013-05-08','08:10:00',1.88),('16100','2013-05-08','08:15:00',2.08),('16100','2013-05-08','08:20:00',2.26),('16100','2013-05-08','08:25:00',2.44),('16100','2013-05-08','08:30:00',2.62),('16100','2013-05-08','08:35:00',2.89),('16100','2013-05-08','08:40:00',3.13),('16100','2013-05-08','08:45:00',3.44),('16100','2013-05-08','08:50:00',3.64),('16100','2013-05-08','08:55:00',3.86),('16100','2013-05-08','09:00:00',4.01),('16100','2013-05-08','09:05:00',4.16),('16100','2013-05-08','09:10:00',4.33),('16100','2013-05-08','09:15:00',4.49),('16100','2013-05-08','09:20:00',4.59),('16100','2013-05-08','09:25:00',4.75),('16100','2013-05-08','09:30:00',4.93),('16100','2013-05-08','09:35:00',5.02),('16100','2013-05-08','09:40:00',5.15),('16100','2013-05-08','09:45:00',5.31),('16100','2013-05-08','09:50:00',5.44),('16100','2013-05-08','09:55:00',5.56),('16100','2013-05-08','10:00:00',5.73),('16100','2013-05-08','10:05:00',5.88),('16100','2013-05-08','10:10:00',5.98),('16100','2013-05-08','10:15:00',6.09),('16100','2013-05-08','10:20:00',6.18),('16100','2013-05-08','10:25:00',6.29),('16100','2013-05-08','10:30:00',6.35),('16100','2013-05-08','10:35:00',6.42),('16100','2013-05-08','10:40:00',6.56),('16100','2013-05-08','10:45:00',6.62),('16100','2013-05-08','10:50:00',6.7),('16100','2013-05-08','10:55:00',6.77),('16100','2013-05-08','11:00:00',6.85),('16100','2013-05-08','11:05:00',6.9),('16100','2013-05-08','11:10:00',7.06),('16100','2013-05-08','11:15:00',7.14),('16100','2013-05-08','11:20:00',7.08),('16100','2013-05-08','11:25:00',7.25),('16100','2013-05-08','11:30:00',7.38),('16100','2013-05-08','11:35:00',7.47),('16100','2013-05-08','11:40:00',7.48),('16100','2013-05-08','11:45:00',7.47),('16100','2013-05-08','11:50:00',7.55),('16100','2013-05-08','11:55:00',7.58),('16100','2013-05-08','12:00:00',7.68),('16100','2013-05-08','12:05:00',7.61),('16100','2013-05-08','12:10:00',7.67),('16100','2013-05-08','12:15:00',7.79),('16100','2013-05-08','12:20:00',7.81),('16100','2013-05-08','12:25:00',7.82),('16100','2013-05-08','12:30:00',7.85),('16100','2013-05-08','12:35:00',7.95),('16100','2013-05-08','12:40:00',7.07),('16100','2013-05-08','12:45:00',1.19),('16100','2013-05-08','12:50:00',3.24),('16100','2013-05-08','12:55:00',8.46),('16100','2013-05-08','13:00:00',8.24),('16100','2013-05-08','13:05:00',6.97),('16100','2013-05-08','13:10:00',6.49),('16100','2013-05-08','13:15:00',5.48),('16100','2013-05-08','13:20:00',7.44),('16100','2013-05-08','13:25:00',8.41),('16100','2013-05-08','13:30:00',8.23),('16100','2013-05-08','13:35:00',8.31),('16100','2013-05-08','13:40:00',8.34),('16100','2013-05-08','13:45:00',8.39),('16100','2013-05-08','13:50:00',8.46),('16100','2013-05-08','13:55:00',5.42),('16100','2013-05-08','14:00:00',4.56),('16100','2013-05-08','14:05:00',7.26),('16100','2013-05-08','14:10:00',8.26),('16100','2013-05-08','14:15:00',8.1),('16100','2013-05-08','14:20:00',7.92),('16100','2013-05-08','14:25:00',7.99),('16100','2013-05-08','14:30:00',7.92),('16100','2013-05-08','14:35:00',7.99),('16100','2013-05-08','14:40:00',7.73),('16100','2013-05-08','14:45:00',7.54),('16100','2013-05-08','14:50:00',7.34),('16100','2013-05-08','14:55:00',7.32),('16100','2013-05-08','15:00:00',7.24),('16100','2013-05-08','15:05:00',7.2),('16100','2013-05-08','15:10:00',7.16),('16100','2013-05-08','15:15:00',7.02),('16100','2013-05-08','15:20:00',6.88),('16100','2013-05-08','15:25:00',6.9),('16100','2013-05-08','15:30:00',6.8),('16100','2013-05-08','15:35:00',6.65),('16100','2013-05-08','15:40:00',6.55),('16100','2013-05-08','15:45:00',6.48),('16100','2013-05-08','15:50:00',6.35),('16100','2013-05-08','15:55:00',6.26),('16100','2013-05-08','16:00:00',6.2),('16100','2013-05-08','16:05:00',6.05),('16100','2013-05-08','16:10:00',5.87),('16100','2013-05-08','16:15:00',5.7),('16100','2013-05-08','16:20:00',5.59),('16100','2013-05-08','16:25:00',5.5),('16100','2013-05-08','16:30:00',5.38),('16100','2013-05-08','16:35:00',5.23),('16100','2013-05-08','16:40:00',5.12),('16100','2013-05-08','16:45:00',5),('16100','2013-05-08','16:50:00',4.86),('16100','2013-05-08','16:55:00',4.71),('16100','2013-05-08','17:00:00',4.51),('16100','2013-05-08','17:05:00',4.38),('16100','2013-05-08','17:10:00',4.23),('16100','2013-05-08','17:15:00',4.08),('16100','2013-05-08','17:20:00',3.94),('16100','2013-05-08','17:25:00',3.75),('16100','2013-05-08','17:30:00',3.55),('16100','2013-05-08','17:35:00',3.39),('16100','2013-05-08','17:40:00',3.23),('16100','2013-05-08','17:45:00',3.05),('16100','2013-05-08','17:50:00',2.86),('16100','2013-05-08','17:55:00',2.69),('16100','2013-05-08','18:00:00',2.53),('16100','2013-05-08','18:05:00',2.37),('16100','2013-05-08','18:10:00',2.18),('16100','2013-05-08','18:15:00',1.99),('16100','2013-05-08','18:20:00',1.84),('16100','2013-05-08','18:25:00',1.67),('16100','2013-05-08','18:30:00',1.47),('16100','2013-05-08','18:35:00',1.27),('16100','2013-05-08','18:40:00',1.12),('16100','2013-05-07','07:55:00',1.42),('16100','2013-05-07','08:00:00',1.55),('16100','2013-05-07','08:05:00',1.71),('16100','2013-05-07','08:10:00',1.87),('16100','2013-05-07','08:15:00',2.05),('16100','2013-05-07','08:20:00',2.23),('16100','2013-05-07','08:25:00',2.42),('16100','2013-05-07','08:30:00',2.59),('16100','2013-05-07','08:35:00',2.9),('16100','2013-05-07','08:40:00',3.48),('16100','2013-05-07','08:45:00',3.82),('16100','2013-05-07','08:50:00',4.11),('16100','2013-05-07','08:55:00',4.54),('16100','2013-05-07','09:00:00',4.85),('16100','2013-05-07','09:05:00',2.89),('16100','2013-05-07','09:10:00',5.24),('16100','2013-05-07','09:15:00',5.43),('16100','2013-05-07','09:20:00',5.66),('16100','2013-05-07','09:25:00',6.08),('16100','2013-05-07','09:30:00',5.75),('16100','2013-05-07','09:35:00',3.18),('16100','2013-05-07','09:55:00',1.21),('16100','2013-05-07','10:00:00',4.47),('16100','2013-05-07','10:05:00',6.04),('16100','2013-05-07','10:10:00',4.93),('16100','2013-05-07','10:15:00',6.33),('16100','2013-05-07','10:20:00',3.39),('16100','2013-05-07','10:25:00',3.25),('16100','2013-05-07','10:30:00',4.89),('16100','2013-05-07','10:35:00',1.9),('16100','2013-05-07','10:40:00',7.06),('16100','2013-05-07','10:45:00',7.16),('16100','2013-05-07','10:50:00',7.44),('16100','2013-05-07','10:55:00',7.56),('16100','2013-05-07','11:00:00',6.57),('16100','2013-05-07','11:05:00',6.95),('16100','2013-05-07','11:10:00',1.93),('16100','2013-05-07','11:15:00',1.93),('16100','2013-05-07','11:20:00',1.9),('16100','2013-05-07','11:25:00',1.83),('16100','2013-05-07','11:30:00',2.58),('16100','2013-05-07','11:35:00',5.79),('16100','2013-05-07','11:40:00',4.67),('16100','2013-05-07','11:45:00',8.74),('16100','2013-05-07','11:50:00',3.87),('16100','2013-05-07','11:55:00',8.36),('16100','2013-05-07','12:00:00',4.69),('16100','2013-05-07','12:05:00',3.63),('16100','2013-05-07','12:10:00',2.6),('16100','2013-05-07','12:15:00',1.33),('16100','2013-05-07','12:20:00',1.45),('16100','2013-05-07','12:25:00',1.82),('16100','2013-05-07','12:30:00',7.21),('16100','2013-05-07','12:35:00',8.95),('16100','2013-05-07','12:40:00',8.99),('16100','2013-05-07','12:45:00',8.84),('16100','2013-05-07','12:50:00',5.78),('16100','2013-05-07','12:55:00',7.49),('16100','2013-05-07','13:00:00',2.66),('16100','2013-05-07','13:05:00',6.12),('16100','2013-05-07','13:10:00',3.42),('16100','2013-05-07','13:15:00',3.5),('16100','2013-05-07','13:20:00',6.91),('16100','2013-05-07','13:25:00',3.18),('16100','2013-05-07','13:30:00',2.6),('16100','2013-05-07','13:35:00',2.78),('16100','2013-05-07','13:40:00',5.68),('16100','2013-05-07','13:45:00',2.47),('16100','2013-05-07','13:50:00',2.63),('16100','2013-05-07','13:55:00',8.68),('16100','2013-05-07','14:00:00',4.31),('16100','2013-05-07','14:05:00',7.14),('16100','2013-05-07','14:10:00',8.71),('16100','2013-05-07','14:15:00',5.04),('16100','2013-05-07','14:20:00',2.61),('16100','2013-05-07','14:25:00',3.02),('16100','2013-05-07','14:30:00',2.95),('16100','2013-05-07','14:35:00',4.61),('16100','2013-05-07','14:40:00',6.17),('16100','2013-05-07','14:45:00',6.44),('16100','2013-05-07','14:50:00',8.68),('16100','2013-05-07','14:55:00',6.41),('16100','2013-05-07','15:00:00',3.76),('16100','2013-05-07','15:05:00',3.64),('16100','2013-05-07','15:10:00',8.08),('16100','2013-05-07','15:15:00',7.25),('16100','2013-05-07','15:20:00',7.72),('16100','2013-05-07','15:25:00',7.14),('16100','2013-05-07','15:30:00',6.58),('16100','2013-05-07','15:35:00',6.89),('16100','2013-05-07','15:40:00',6.85),('16100','2013-05-07','15:45:00',6.75),('16100','2013-05-07','15:50:00',6.56),('16100','2013-05-07','15:55:00',6.42),('16100','2013-05-07','16:00:00',6.28),('16100','2013-05-07','16:05:00',6.12),('16100','2013-05-07','16:10:00',6),('16100','2013-05-07','16:15:00',5.83),('16100','2013-05-07','16:20:00',5.72),('16100','2013-05-07','16:25:00',5.59),('16100','2013-05-07','16:30:00',5.45),('16100','2013-05-07','16:35:00',5.32),('16100','2013-05-07','16:40:00',5.29),('16100','2013-05-07','16:45:00',4.93),('16100','2013-05-07','16:50:00',4.59),('16100','2013-05-07','16:55:00',4.35),('16100','2013-05-07','17:00:00',3.87),('16100','2013-05-07','17:05:00',4.15),('16100','2013-05-07','17:10:00',3.47),('16100','2013-05-07','17:15:00',2.85),('16100','2013-05-07','17:20:00',1.16),('16100','2013-05-07','17:25:00',3.15),('16100','2013-05-07','17:30:00',3.86),('16100','2013-05-07','17:35:00',3.86),('16100','2013-05-07','17:40:00',3.91),('16100','2013-05-07','17:45:00',3.87),('16100','2013-05-07','17:50:00',3.76),('16100','2013-05-07','17:55:00',3.62),('16100','2013-05-07','18:00:00',3.38),('16100','2013-05-07','18:05:00',3.24),('16100','2013-05-07','18:10:00',2.92),('16100','2013-05-07','18:15:00',2.58),('16100','2013-05-07','18:20:00',2.28),('16100','2013-05-07','18:25:00',1.97),('16100','2013-05-07','18:30:00',1.42),('16100','2013-05-06','07:45:00',1.04),('16100','2013-05-06','07:50:00',1.21),('16100','2013-05-06','07:55:00',1.36),('16100','2013-05-06','08:00:00',1.52),('16100','2013-05-06','08:05:00',1.68),('16100','2013-05-06','08:10:00',1.85),('16100','2013-05-06','08:15:00',2.06),('16100','2013-05-06','08:20:00',2.27),('16100','2013-05-06','08:25:00',2.45),('16100','2013-05-06','08:30:00',2.63),('16100','2013-05-06','08:35:00',2.94),('16100','2013-05-06','08:40:00',3.3),('16100','2013-05-06','08:45:00',3.68),('16100','2013-05-06','08:50:00',4.03),('16100','2013-05-06','08:55:00',4.01),('16100','2013-05-06','09:00:00',4.65),('16100','2013-05-06','09:05:00',4.82),('16100','2013-05-06','09:10:00',3.19),('16100','2013-05-06','09:15:00',3.38),('16100','2013-05-06','09:20:00',5.01),('16100','2013-05-06','09:25:00',5.91),('16100','2013-05-06','09:30:00',1.83),('16100','2013-05-06','09:35:00',1.31),('16100','2013-05-06','09:40:00',1.04),('16100','2013-05-06','10:25:00',1.25),('16100','2013-05-06','10:30:00',2.9),('16100','2013-05-06','10:35:00',8.1),('16100','2013-05-06','10:40:00',7.06),('16100','2013-05-06','10:45:00',2.53),('16100','2013-05-06','10:50:00',1.89),('16100','2013-05-06','10:55:00',1.51),('16100','2013-05-06','11:00:00',1.36),('16100','2013-05-06','11:05:00',1.42),('16100','2013-05-06','11:10:00',2.23),('16100','2013-05-06','11:15:00',7.2),('16100','2013-05-06','11:20:00',8.72),('16100','2013-05-06','11:25:00',8.37),('16100','2013-05-06','11:30:00',8.33),('16100','2013-05-06','11:35:00',6.13),('16100','2013-05-06','11:40:00',6.23),('16100','2013-05-06','11:45:00',9.18),('16100','2013-05-06','11:50:00',5.78),('16100','2013-05-06','11:55:00',3.44),('16100','2013-05-06','12:00:00',2.49),('16100','2013-05-06','12:05:00',2.3),('16100','2013-05-06','12:10:00',2.27),('16100','2013-05-06','12:15:00',3.41),('16100','2013-05-06','12:20:00',1.97),('16100','2013-05-06','12:25:00',1.85),('16100','2013-05-06','12:30:00',1.34),('16100','2013-05-06','12:35:00',1.36),('16100','2013-05-06','12:40:00',1.56),('16100','2013-05-06','12:45:00',1.99),('16100','2013-05-06','12:50:00',2.82),('16100','2013-05-06','12:55:00',2.71),('16100','2013-05-06','13:00:00',2.97),('16100','2013-05-06','13:05:00',2.95),('16100','2013-05-06','13:10:00',3.3),('16100','2013-05-06','13:15:00',4.5),('16100','2013-05-06','13:20:00',9.19),('16100','2013-05-06','13:25:00',9.64),('16100','2013-05-06','13:30:00',9.25),('16100','2013-05-06','13:35:00',8.62),('16100','2013-05-06','13:40:00',8.58),('16100','2013-05-06','13:45:00',8.75),('16100','2013-05-06','13:50:00',7.57),('16100','2013-05-06','13:55:00',7.21),('16100','2013-05-06','14:00:00',6.63),('16100','2013-05-06','14:05:00',7.16),('16100','2013-05-06','14:10:00',8.25),('16100','2013-05-06','14:15:00',8.81),('16100','2013-05-06','14:20:00',3.9),('16100','2013-05-06','14:25:00',7.59),('16100','2013-05-06','14:30:00',8.5),('16100','2013-05-06','14:35:00',8.44),('16100','2013-05-06','14:40:00',8.5),('16100','2013-05-06','14:45:00',7.82),('16100','2013-05-06','14:50:00',8.18),('16100','2013-05-06','14:55:00',7.89),('16100','2013-05-06','15:00:00',7.78),('16100','2013-05-06','15:05:00',6.26),('16100','2013-05-06','15:10:00',7.54),('16100','2013-05-06','15:15:00',4.63),('16100','2013-05-06','15:20:00',6.14),('16100','2013-05-06','15:25:00',5.06),('16100','2013-05-06','15:30:00',7.44),('16100','2013-05-06','15:35:00',4.36),('16100','2013-05-06','15:40:00',7.34),('16100','2013-05-06','15:45:00',7.78),('16100','2013-05-06','15:50:00',4.65),('16100','2013-05-06','15:55:00',4.5),('16100','2013-05-06','16:00:00',7.23),('16100','2013-05-06','16:05:00',6.98),('16100','2013-05-06','16:10:00',5.39),('16100','2013-05-06','16:15:00',6.48),('16100','2013-05-06','16:20:00',6.86),('16100','2013-05-06','16:25:00',6.81),('16100','2013-05-06','16:30:00',6.7),('16100','2013-05-06','16:35:00',5.52),('16100','2013-05-06','16:40:00',3.45),('16100','2013-05-06','16:45:00',2.11),('16100','2013-05-06','16:50:00',2.89),('16100','2013-05-06','16:55:00',3.35),('16100','2013-05-06','17:00:00',3.41),('16100','2013-05-06','17:05:00',3.49),('16100','2013-05-06','17:10:00',1.91),('16100','2013-05-06','17:15:00',1.95),('16100','2013-05-06','17:20:00',1.92),('16100','2013-05-06','17:25:00',2.3),('16100','2013-05-06','17:30:00',1.87),('16100','2013-05-06','17:35:00',1.58),('16100','2013-05-06','17:40:00',1.3),('16100','2013-05-05','08:15:00',1.12),('16100','2013-05-05','08:20:00',1.98),('16100','2013-05-05','08:25:00',2.51),('16100','2013-05-05','08:30:00',1.64),('16100','2013-05-05','08:35:00',1.64),('16100','2013-05-05','08:40:00',2.39),('16100','2013-05-05','08:45:00',2.48),('16100','2013-05-05','08:50:00',2.49),('16100','2013-05-05','08:55:00',2.35),('16100','2013-05-05','09:00:00',2.49),('16100','2013-05-05','09:05:00',2.19),('16100','2013-05-05','09:10:00',2.26),('16100','2013-05-05','09:15:00',3.11),('16100','2013-05-05','09:20:00',3.15),('16100','2013-05-05','09:25:00',3.62),('16100','2013-05-05','09:30:00',2.72),('16100','2013-05-05','09:45:00',1.53),('16100','2013-05-05','09:50:00',1.06),('16100','2013-05-05','09:55:00',1.09),('16100','2013-05-05','10:00:00',1.64),('16100','2013-05-05','10:05:00',1.8),('16100','2013-05-05','10:10:00',1.8),('16100','2013-05-05','10:15:00',2.56),('16100','2013-05-05','10:20:00',2.74),('16100','2013-05-05','10:25:00',2.67),('16100','2013-05-05','10:30:00',2.32),('16100','2013-05-05','10:35:00',2.44),('16100','2013-05-05','10:40:00',3.83),('16100','2013-05-05','10:45:00',2.69),('16100','2013-05-05','10:50:00',2.26),('16100','2013-05-05','10:55:00',3.36),('16100','2013-05-05','11:00:00',2.92),('16100','2013-05-05','11:05:00',2.09),('16100','2013-05-05','11:10:00',1.71),('16100','2013-05-05','11:15:00',2.7),('16100','2013-05-05','11:20:00',3.22),('16100','2013-05-05','11:25:00',1.43),('16100','2013-05-05','11:30:00',1.91),('16100','2013-05-05','11:35:00',4.36),('16100','2013-05-05','11:40:00',3.48),('16100','2013-05-05','11:45:00',3.48),('16100','2013-05-05','11:50:00',2.53),('16100','2013-05-05','11:55:00',2.07),('16100','2013-05-05','12:00:00',2.58),('16100','2013-05-05','12:05:00',2.91),('16100','2013-05-05','12:10:00',2.75),('16100','2013-05-05','12:15:00',8.25),('16100','2013-05-05','12:20:00',9.54),('16100','2013-05-05','12:25:00',9.17),('16100','2013-05-05','12:30:00',6.75),('16100','2013-05-05','12:35:00',4.63),('16100','2013-05-05','12:40:00',4.29),('16100','2013-05-05','12:45:00',5.6),('16100','2013-05-05','12:50:00',6.2),('16100','2013-05-05','12:55:00',5.4),('16100','2013-05-05','13:00:00',7.14),('16100','2013-05-05','13:05:00',8.49),('16100','2013-05-05','13:10:00',4.46),('16100','2013-05-05','13:15:00',7.09),('16100','2013-05-05','13:20:00',6.92),('16100','2013-05-05','13:25:00',5.85),('16100','2013-05-05','13:30:00',3.72),('16100','2013-05-05','13:35:00',3.26),('16100','2013-05-05','13:40:00',7.6),('16100','2013-05-05','13:49:00',4.83),('16100','2013-05-05','13:50:00',8.87),('16100','2013-05-05','13:55:00',4.75),('16100','2013-05-05','14:00:00',3.23),('16100','2013-05-05','14:05:00',4.5),('16100','2013-05-05','14:10:00',7.61),('16100','2013-05-05','14:15:00',2.96),('16100','2013-05-05','14:20:00',3.28),('16100','2013-05-05','14:25:00',3.39),('16100','2013-05-05','14:30:00',5.22),('16100','2013-05-05','14:35:00',3.27),('16100','2013-05-05','14:40:00',3.39),('16100','2013-05-05','14:45:00',2.59),('16100','2013-05-05','14:50:00',2.12),('16100','2013-05-05','14:55:00',2.3),('16100','2013-05-05','15:00:00',3.43),('16100','2013-05-05','15:05:00',3.4),('16100','2013-05-05','15:10:00',2.73),('16100','2013-05-05','15:15:00',2.57),('16100','2013-05-05','15:20:00',4.45),('16100','2013-05-05','15:25:00',5.52),('16100','2013-05-05','15:30:00',3),('16100','2013-05-05','15:35:00',3.92),('16100','2013-05-05','15:40:00',5.3),('16100','2013-05-05','15:45:00',3),('16100','2013-05-05','15:50:00',3.43),('16100','2013-05-05','15:55:00',2.05),('16100','2013-05-05','16:00:00',3.51),('16100','2013-05-05','16:05:00',2.57),('16100','2013-05-05','16:10:00',1.98),('16100','2013-05-05','16:15:00',2),('16100','2013-05-05','16:20:00',2.87),('16100','2013-05-05','16:25:00',5.31),('16100','2013-05-05','16:30:00',5.37),('16100','2013-05-05','16:35:00',3.29),('16100','2013-05-05','16:40:00',3.8),('16100','2013-05-05','16:45:00',2.84),('16100','2013-05-05','16:50:00',3.77),('16100','2013-05-05','16:55:00',1.89),('16100','2013-05-05','17:10:00',4.03),('16100','2013-05-05','17:15:00',4.13),('16100','2013-05-05','17:20:00',2.81),('16100','2013-05-05','17:25:00',2.42),('16100','2013-05-05','17:30:00',1.97),('16100','2013-05-05','17:35:00',2.26),('16100','2013-05-05','17:40:00',3.32),('16100','2013-05-05','17:45:00',3.45),('16100','2013-05-05','17:50:00',2.4),('16100','2013-05-05','17:55:00',3.25),('16100','2013-05-05','18:00:00',3.02),('16100','2013-05-05','18:05:00',2.64),('16100','2013-05-05','18:10:00',1.68),('16100','2013-05-05','18:15:00',1.83),('16100','2013-05-05','18:20:00',2.36),('16100','2013-05-05','18:25:00',1.42),('16100','2014-03-29','08:10:00',1),('16100','2014-03-29','08:15:00',1.07),('16100','2014-03-29','08:20:00',1.27),('16100','2014-03-29','08:25:00',1.48),('16100','2014-03-29','08:30:00',1.71),('16100','2014-03-29','08:35:00',1.89),('16100','2014-03-29','08:40:00',1.98),('16100','2014-03-29','08:45:00',2.03),('16100','2014-03-29','08:50:00',2.09),('16100','2014-03-29','08:55:00',2.13),('16100','2014-03-29','09:00:00',2.15),('16100','2014-03-29','09:05:00',2.3),('16100','2014-03-29','09:10:00',2.42),('16100','2014-03-29','09:15:00',2.5),('16100','2014-03-29','09:20:00',2.84),('16100','2014-03-29','09:25:00',3.13),('16100','2014-03-29','09:30:00',3.16),('16100','2014-03-29','09:35:00',3.41),('16100','2014-03-29','09:40:00',3.59),('16100','2014-03-29','09:45:00',3.74),('16100','2014-03-29','09:50:00',3.92),('16100','2014-03-29','09:55:00',4.02),('16100','2014-03-29','10:00:00',4.03),('16100','2014-03-29','10:05:00',4.19),('16100','2014-03-29','10:10:00',4.53),('16100','2014-03-29','10:15:00',4.64),('16100','2014-03-29','10:20:00',4.84),('16100','2014-03-29','10:25:00',5.19),('16100','2014-03-29','10:30:00',5.33),('16100','2014-03-29','10:35:00',5.44),('16100','2014-03-29','10:40:00',5.44),('16100','2014-03-29','10:45:00',5.5),('16100','2014-03-29','10:50:00',5.75),('16100','2014-03-29','10:55:00',5.77),('16100','2014-03-29','11:00:00',5.66),('16100','2014-03-29','11:05:00',5.71),('16100','2014-03-29','11:10:00',5.84),('16100','2014-03-29','11:15:00',5.95),('16100','2014-03-29','11:20:00',5.93),('16100','2014-03-29','11:25:00',5.6),('16100','2014-03-29','11:30:00',5.72),('16100','2014-03-29','11:35:00',6.09),('16100','2014-03-29','11:40:00',6.26),('16100','2014-03-29','11:45:00',6.5),('16100','2014-03-29','11:50:00',6.5),('16100','2014-03-29','11:55:00',6.8),('16100','2014-03-29','12:00:00',6.69),('16100','2014-03-29','12:05:00',6.9),('16100','2014-03-29','12:10:00',6.97),('16100','2014-03-29','12:15:00',7.04),('16100','2014-03-29','12:20:00',7.19),('16100','2014-03-29','12:25:00',7.28),('16100','2014-03-29','12:30:00',7.02),('16100','2014-03-29','12:35:00',7.25),('16100','2014-03-29','12:40:00',7.3),('16100','2014-03-29','12:45:00',7.36),('16100','2014-03-29','12:50:00',7.41),('16100','2014-03-29','12:55:00',7.31),('16100','2014-03-29','13:00:00',7.27),('16100','2014-03-29','13:05:00',7.36),('16100','2014-03-29','13:10:00',7.4),('16100','2014-03-29','13:15:00',7.4),('16100','2014-03-29','13:20:00',7.47),('16100','2014-03-29','13:25:00',7.64),('16100','2014-03-29','13:30:00',7.68),('16100','2014-03-29','13:35:00',7.62),('16100','2014-03-29','13:40:00',7.66),('16100','2014-03-29','13:45:00',7.71),('16100','2014-03-29','13:50:00',7.7),('16100','2014-03-29','13:55:00',7.67),('16100','2014-03-29','14:00:00',7.56),('16100','2014-03-29','14:05:00',7.57),('16100','2014-03-29','14:10:00',7.31),('16100','2014-03-29','14:15:00',6.79),('16100','2014-03-29','14:20:00',6.29),('16100','2014-03-29','14:25:00',6.31),('16100','2014-03-29','14:30:00',6.3),('16100','2014-03-29','14:35:00',5.81),('16100','2014-03-29','14:40:00',3.89),('16100','2014-03-29','14:45:00',2.6),('16100','2014-03-29','14:50:00',2.38),('16100','2014-03-29','14:55:00',2.89),('16100','2014-03-29','15:00:00',3.49),('16100','2014-03-29','15:05:00',4.32),('16100','2014-03-29','15:10:00',4.93),('16100','2014-03-29','15:15:00',5.45),('16100','2014-03-29','15:20:00',5.34),('16100','2014-03-29','15:25:00',5.41),('16100','2014-03-29','15:30:00',5.58),('16100','2014-03-29','15:35:00',5.5),('16100','2014-03-29','15:40:00',5.4),('16100','2014-03-29','15:45:00',5.44),('16100','2014-03-29','15:50:00',4.98),('16100','2014-03-29','15:55:00',5.14),('16100','2014-03-29','16:00:00',5.37),('16100','2014-03-29','16:05:00',5.47),('16100','2014-03-29','16:10:00',5.46),('16100','2014-03-29','16:15:00',5.22),('16100','2014-03-29','16:20:00',4.73),('16100','2014-03-29','16:25:00',5.1),('16100','2014-03-29','16:30:00',4.72),('16100','2014-03-29','16:35:00',3.99),('16100','2014-03-29','16:40:00',4.28),('16100','2014-03-29','16:45:00',3.91),('16100','2014-03-29','16:50:00',3.9),('16100','2014-03-29','16:55:00',3.34),('16100','2014-03-29','17:00:00',3.1),('16100','2014-03-29','17:05:00',3.2),('16100','2014-03-29','17:10:00',3.04),('16100','2014-03-29','17:15:00',2.85),('16100','2014-03-29','17:20:00',2.89),('16100','2014-03-29','17:25:00',2.93),('16100','2014-03-29','17:30:00',2.8),('16100','2014-03-29','17:35:00',2.62),('16100','2014-03-29','17:40:00',2.5),('16100','2014-03-29','17:45:00',2.52),('16100','2014-03-29','17:50:00',2.29),('16100','2014-03-29','17:55:00',2.05),('16100','2014-03-29','18:00:00',1.89),('16100','2014-03-29','18:05:00',1.56),('16100','2014-03-29','18:10:00',1.34),('16100','2014-03-29','18:15:00',1.49),('16100','2014-03-29','18:20:00',1.23),('16100','2014-03-29','18:25:00',1.15),('16100','2014-03-28','07:15:00',1),('16100','2014-03-28','07:20:00',1.18),('16100','2014-03-28','07:25:00',1.36),('16100','2014-03-28','07:30:00',1.55),('16100','2014-03-28','07:35:00',1.78),('16100','2014-03-28','07:40:00',2),('16100','2014-03-28','07:45:00',2.2),('16100','2014-03-28','07:50:00',2.37),('16100','2014-03-28','07:55:00',2.52),('16100','2014-03-28','08:00:00',2.66),('16100','2014-03-28','08:05:00',2.89),('16100','2014-03-28','08:10:00',3.07),('16100','2014-03-28','08:15:00',3.27),('16100','2014-03-28','08:20:00',3.45),('16100','2014-03-28','08:25:00',3.68),('16100','2014-03-28','08:30:00',3.83),('16100','2014-03-28','08:35:00',3.93),('16100','2014-03-28','08:40:00',4.05),('16100','2014-03-28','08:45:00',4.17),('16100','2014-03-28','08:50:00',4.32),('16100','2014-03-28','08:55:00',4.49),('16100','2014-03-28','09:00:00',4.65),('16100','2014-03-28','09:05:00',4.74),('16100','2014-03-28','09:10:00',4.86),('16100','2014-03-28','09:15:00',4.98),('16100','2014-03-28','09:20:00',5.13),('16100','2014-03-28','09:25:00',5.23),('16100','2014-03-28','09:30:00',5.34),('16100','2014-03-28','09:35:00',5.56),('16100','2014-03-28','09:40:00',5.7),('16100','2014-03-28','09:45:00',5.76),('16100','2014-03-28','09:50:00',5.9),('16100','2014-03-28','09:55:00',6),('16100','2014-03-28','10:00:00',6.08),('16100','2014-03-28','10:05:00',6.09),('16100','2014-03-28','10:10:00',6.14),('16100','2014-03-28','10:15:00',6.22),('16100','2014-03-28','10:20:00',6.4),('16100','2014-03-28','10:25:00',6.55),('16100','2014-03-28','10:30:00',6.68),('16100','2014-03-28','10:35:00',6.73),('16100','2014-03-28','10:40:00',6.83),('16100','2014-03-28','10:45:00',6.87),('16100','2014-03-28','10:50:00',6.94),('16100','2014-03-28','10:55:00',7.03),('16100','2014-03-28','11:00:00',7.11),('16100','2014-03-28','11:05:00',7.2),('16100','2014-03-28','11:10:00',7.2),('16100','2014-03-28','11:15:00',7.14),('16100','2014-03-28','11:20:00',7.14),('16100','2014-03-28','11:25:00',7.18),('16100','2014-03-28','11:30:00',7.16),('16100','2014-03-28','11:35:00',7.08),('16100','2014-03-28','11:40:00',7.31),('16100','2014-03-28','11:45:00',7.38),('16100','2014-03-28','11:50:00',7.36),('16100','2014-03-28','11:55:00',7.34),('16100','2014-03-28','12:00:00',7.31),('16100','2014-03-28','12:05:00',7.28),('16100','2014-03-28','12:10:00',7.32),('16100','2014-03-28','12:15:00',7.4),('16100','2014-03-28','12:20:00',7.47),('16100','2014-03-28','12:25:00',7.46),('16100','2014-03-28','12:30:00',7.55),('16100','2014-03-28','12:35:00',7.48),('16100','2014-03-28','12:40:00',7.29),('16100','2014-03-28','12:45:00',7.22),('16100','2014-03-28','12:50:00',7.24),('16100','2014-03-28','12:55:00',4.68),('16100','2014-03-28','13:00:00',7.41),('16100','2014-03-28','13:05:00',7.35),('16100','2014-03-28','13:10:00',6.12),('16100','2014-03-28','13:15:00',3.15),('16100','2014-03-28','13:20:00',5.71),('16100','2014-03-28','13:25:00',6.94),('16100','2014-03-28','13:30:00',7.19),('16100','2014-03-28','13:35:00',7.15),('16100','2014-03-28','13:40:00',6.95),('16100','2014-03-28','13:45:00',6.77),('16100','2014-03-28','13:50:00',6.68),('16100','2014-03-28','13:55:00',6.62),('16100','2014-03-28','14:00:00',6.5),('16100','2014-03-28','14:05:00',6.24),('16100','2014-03-28','14:10:00',6.29),('16100','2014-03-28','14:15:00',6.04),('16100','2014-03-28','14:20:00',5.99),('16100','2014-03-28','14:25:00',6.01),('16100','2014-03-28','14:30:00',6.14),('16100','2014-03-28','14:35:00',6.03),('16100','2014-03-28','14:40:00',5.59),('16100','2014-03-28','14:45:00',5.49),('16100','2014-03-28','14:50:00',5.36),('16100','2014-03-28','14:55:00',5.47),('16100','2014-03-28','15:00:00',5.4),('16100','2014-03-28','15:05:00',5.24),('16100','2014-03-28','15:10:00',4.96),('16100','2014-03-28','15:15:00',4.91),('16100','2014-03-28','15:20:00',4.79),('16100','2014-03-28','15:25:00',4.66),('16100','2014-03-28','15:30:00',4.54),('16100','2014-03-28','15:35:00',4.4),('16100','2014-03-28','15:40:00',4.29),('16100','2014-03-28','15:45:00',4.11),('16100','2014-03-28','15:50:00',3.98),('16100','2014-03-28','15:55:00',3.82),('16100','2014-03-28','16:00:00',3.64),('16100','2014-03-28','16:05:00',3.46),('16100','2014-03-28','16:10:00',3.27),('16100','2014-03-28','16:15:00',3.07),('16100','2014-03-28','16:20:00',2.83),('16100','2014-03-28','16:25:00',2.83),('16100','2014-03-28','16:30:00',2.65),('16100','2014-03-28','16:35:00',2.26),('16100','2014-03-28','16:40:00',1.69),('16100','2014-03-28','16:45:00',1.84),('16100','2014-03-28','16:50:00',1.91),('16100','2014-03-28','16:55:00',1.79),('16100','2014-03-28','17:00:00',1.62),('16100','2014-03-28','17:05:00',1.46),('16100','2014-03-28','17:10:00',1.32),('16100','2014-03-28','17:15:00',1.18),('16100','2013-04-20','08:05:00',1.14),('16100','2013-04-20','08:10:00',1.14),('16100','2013-04-20','08:15:00',1.34),('16100','2013-04-20','08:20:00',1.41),('16100','2013-04-20','08:25:00',1.43),('16100','2013-04-20','08:30:00',1.39),('16100','2013-04-20','08:35:00',1.47),('16100','2013-04-20','08:40:00',1.6),('16100','2013-04-20','08:45:00',1.78),('16100','2013-04-20','08:50:00',1.87),('16100','2013-04-20','08:55:00',1.8),('16100','2013-04-20','09:00:00',1.89),('16100','2013-04-20','09:05:00',1.94),('16100','2013-04-20','09:10:00',2.04),('16100','2013-04-20','09:15:00',2.09),('16100','2013-04-20','09:20:00',2.21),('16100','2013-04-20','09:25:00',3),('16100','2013-04-20','09:30:00',4.44),('16100','2013-04-20','09:35:00',4.04),('16100','2013-04-20','09:40:00',5.76),('16100','2013-04-20','09:45:00',5.11),('16100','2013-04-20','09:50:00',3.65),('16100','2013-04-20','09:55:00',2.62),('16100','2013-04-20','10:00:00',2.29),('16100','2013-04-20','10:05:00',1.76),('16100','2013-04-20','10:10:00',2.27),('16100','2013-04-20','10:15:00',5.77),('16100','2013-04-20','10:20:00',3.92),('16100','2013-04-20','10:25:00',6.21),('16100','2013-04-20','10:30:00',6.95),('16100','2013-04-20','10:35:00',6.7),('16100','2013-04-20','10:40:00',6.57),('16100','2013-04-20','10:45:00',6.7),('16100','2013-04-20','10:50:00',6.95),('16100','2013-04-20','10:55:00',7.1),('16100','2013-04-20','11:00:00',4.92),('16100','2013-04-20','11:05:00',5.63),('16100','2013-04-20','11:10:00',7.45),('16100','2013-04-20','11:15:00',6.96),('16100','2013-04-20','11:20:00',5.91),('16100','2013-04-20','11:25:00',5.46),('16100','2013-04-20','11:30:00',4.14),('16100','2013-04-20','11:35:00',5.18),('16100','2013-04-20','11:40:00',5.05),('16100','2013-04-20','11:45:00',4.93),('16100','2013-04-20','11:50:00',5.12),('16100','2013-04-20','11:55:00',4.63),('16100','2013-04-20','12:00:00',4.37),('16100','2013-04-20','12:05:00',4.18),('16100','2013-04-20','12:10:00',4.23),('16100','2013-04-20','12:15:00',3.73),('16100','2013-04-20','12:20:00',3.23),('16100','2013-04-20','12:25:00',3.42),('16100','2013-04-20','12:30:00',3.62),('16100','2013-04-20','12:35:00',3.65),('16100','2013-04-20','12:40:00',4.05),('16100','2013-04-20','12:45:00',3.69),('16100','2013-04-20','12:50:00',3.64),('16100','2013-04-20','12:55:00',3.77),('16100','2013-04-20','13:00:00',3.89),('16100','2013-04-20','13:05:00',4.85),('16100','2013-04-20','13:10:00',5.11),('16100','2013-04-20','13:15:00',4.46),('16100','2013-04-20','13:20:00',4.31),('16100','2013-04-20','13:25:00',4.38),('16100','2013-04-20','13:30:00',4.7),('16100','2013-04-20','13:35:00',5.74),('16100','2013-04-20','13:40:00',7.09),('16100','2013-04-20','13:45:00',7.34),('16100','2013-04-20','13:50:00',6.55),('16100','2013-04-20','13:55:00',6.33),('16100','2013-04-20','14:00:00',4.66),('16100','2013-04-20','14:05:00',4.69),('16100','2013-04-20','14:10:00',5.62),('16100','2013-04-20','14:15:00',4.1),('16100','2013-04-20','14:20:00',4.75),('16100','2013-04-20','14:25:00',5.26),('16100','2013-04-20','14:30:00',8.29),('16100','2013-04-20','14:35:00',8.57),('16100','2013-04-20','14:40:00',8.49),('16100','2013-04-20','14:45:00',7.2),('16100','2013-04-20','14:50:00',5.6),('16100','2013-04-20','14:55:00',5.16),('16100','2013-04-20','15:00:00',7.17),('16100','2013-04-20','15:05:00',7.47),('16100','2013-04-20','15:10:00',7),('16100','2013-04-20','15:15:00',7.54),('16100','2013-04-20','15:20:00',5.79),('16100','2013-04-20','15:25:00',5.41),('16100','2013-04-20','15:30:00',4.51),('16100','2013-04-20','15:35:00',4.09),('16100','2013-04-20','15:40:00',4.35),('16100','2013-04-20','15:45:00',2.34),('16100','2013-04-20','15:50:00',1.85),('16100','2013-04-20','15:55:00',1.32),('16100','2013-04-20','16:00:00',1.17),('16100','2013-04-20','16:05:00',1.05),('16100','2013-04-20','16:10:00',1.07),('16100','2013-04-19','07:30:00',1.06),('16100','2013-04-19','07:35:00',1.02),('16100','2013-04-19','08:05:00',1.38),('16100','2013-04-19','08:10:00',1.34),('16100','2013-04-19','08:15:00',1.25),('16100','2013-04-19','08:20:00',1.75),('16100','2013-04-19','08:25:00',2.03),('16100','2013-04-19','08:30:00',2.31),('16100','2013-04-19','08:35:00',2.04),('16100','2013-04-19','08:40:00',2.88),('16100','2013-04-19','08:45:00',3.1),('16100','2013-04-19','08:50:00',3.34),('16100','2013-04-19','08:55:00',3.46),('16100','2013-04-19','09:00:00',3.6),('16100','2013-04-19','09:05:00',3.67),('16100','2013-04-19','09:10:00',2.07),('16100','2013-04-19','09:15:00',1.35),('16100','2013-04-19','09:20:00',1.26),('16100','2013-04-19','09:25:00',1.25),('16100','2013-04-19','09:30:00',1.22),('16100','2013-04-19','10:15:00',1.12),('16100','2013-04-19','10:20:00',1.27),('16100','2013-04-19','10:25:00',1.31),('16100','2013-04-19','10:30:00',1.66),('16100','2013-04-19','10:35:00',1.96),('16100','2013-04-19','10:40:00',2.01),('16100','2013-04-19','10:45:00',2.49),('16100','2013-04-19','10:50:00',4.94),('16100','2013-04-19','10:55:00',7.16),('16100','2013-04-19','11:00:00',5.7),('16100','2013-04-19','11:05:00',6.22),('16100','2013-04-19','11:10:00',5.56),('16100','2013-04-19','11:15:00',3.41),('16100','2013-04-19','11:20:00',2.78),('16100','2013-04-19','11:25:00',2.8),('16100','2013-04-19','11:30:00',3.68),('16100','2013-04-19','11:35:00',5.7),('16100','2013-04-19','11:40:00',8.21),('16100','2013-04-19','11:45:00',4.72),('16100','2013-04-19','11:50:00',8.98),('16100','2013-04-19','11:55:00',3.75),('16100','2013-04-19','12:00:00',2.93),('16100','2013-04-19','12:05:00',3.44),('16100','2013-04-19','12:10:00',4.31),('16100','2013-04-19','12:15:00',4.45),('16100','2013-04-19','12:20:00',8.82),('16100','2013-04-19','12:25:00',8.86),('16100','2013-04-19','12:30:00',7.08),('16100','2013-04-19','12:35:00',7.62),('16100','2013-04-19','12:40:00',8.7),('16100','2013-04-19','12:45:00',8.74),('16100','2013-04-19','12:50:00',8.32),('16100','2013-04-19','12:55:00',8.26),('16100','2013-04-19','13:00:00',8.09),('16100','2013-04-19','13:05:00',4.76),('16100','2013-04-19','13:10:00',8.44),('16100','2013-04-19','13:15:00',8.39),('16100','2013-04-19','13:20:00',8.81),('16100','2013-04-19','13:25:00',8.45),('16100','2013-04-19','13:30:00',8.56),('16100','2013-04-19','13:35:00',8.55),('16100','2013-04-19','13:40:00',3.19),('16100','2013-04-19','13:45:00',8.37),('16100','2013-04-19','13:50:00',6.99),('16100','2013-04-19','13:55:00',5.48),('16100','2013-04-19','14:00:00',7.15),('16100','2013-04-19','14:05:00',8.19),('16100','2013-04-19','14:10:00',7.49),('16100','2013-04-19','14:15:00',7.63),('16100','2013-04-19','14:20:00',6.89),('16100','2013-04-19','14:25:00',5.92),('16100','2013-04-19','14:30:00',7.29),('16100','2013-04-19','14:35:00',7.02),('16100','2013-04-19','14:40:00',7.02),('16100','2013-04-19','14:45:00',7.31),('16100','2013-04-19','14:50:00',7.28),('16100','2013-04-19','14:55:00',7.28),('16100','2013-04-19','15:00:00',7.29),('16100','2013-04-19','15:05:00',7.12),('16100','2013-04-19','15:10:00',7.22),('16100','2013-04-19','15:15:00',5.1),('16100','2013-04-19','15:20:00',3.82),('16100','2013-04-19','15:25:00',5.69),('16100','2013-04-19','15:30:00',3.29),('16100','2013-04-19','15:35:00',1.97),('16100','2013-04-19','15:40:00',1.44),('16100','2013-04-19','15:45:00',1.29),('16100','2013-04-19','15:50:00',1.22),('16100','2013-04-19','15:55:00',1.35),('16100','2013-04-19','16:00:00',1.74),('16100','2013-04-19','16:05:00',2.72),('16100','2013-04-19','16:10:00',4.92),('16100','2013-04-19','16:15:00',6.32),('16100','2013-04-19','16:20:00',5.55),('16100','2013-04-19','16:25:00',5.19),('16100','2013-04-19','16:30:00',6.04),('16100','2013-04-19','16:35:00',5.73),('16100','2013-04-19','16:40:00',5.46),('16100','2013-04-19','16:45:00',5.08),('16100','2013-04-19','16:50:00',4.77),('16100','2013-04-19','16:55:00',3.93),('16100','2013-04-19','17:00:00',4.4),('16100','2013-04-19','17:05:00',4.13),('16100','2013-04-19','17:10:00',3.91),('16100','2013-04-19','17:15:00',3.17),('16100','2013-04-19','17:20:00',2.61),('16100','2013-04-19','17:25:00',3.67),('16100','2013-04-19','17:30:00',3.7),('16100','2013-04-19','17:35:00',3.55),('16100','2013-04-19','17:40:00',1.58),('16100','2013-04-19','17:45:00',1.21),('16100','2013-04-19','17:50:00',2.24),('16100','2013-04-19','17:55:00',2.31),('16100','2013-04-19','18:00:00',1.5),('16100','2013-04-19','18:05:00',2.55),('16100','2013-04-19','18:10:00',2.33),('16100','2013-04-19','18:15:00',1.36),('16100','2013-04-19','18:35:00',1.09),('16100','2013-04-18','08:00:00',1.09),('16100','2013-04-18','08:05:00',1.4),('16100','2013-04-18','08:10:00',1.75),('16100','2013-04-18','08:15:00',1.88),('16100','2013-04-18','08:20:00',2.08),('16100','2013-04-18','08:25:00',1.92),('16100','2013-04-18','08:30:00',2.41),('16100','2013-04-18','08:35:00',2.81),('16100','2013-04-18','08:40:00',3.02),('16100','2013-04-18','08:45:00',1.64),('16100','2013-04-18','08:50:00',2.62),('16100','2013-04-18','08:55:00',2.97),('16100','2013-04-18','09:00:00',2.54),('16100','2013-04-18','09:05:00',3.56),('16100','2013-04-18','09:10:00',3.69),('16100','2013-04-18','09:15:00',3.88),('16100','2013-04-18','09:20:00',4.17),('16100','2013-04-18','09:25:00',4.07),('16100','2013-04-18','09:30:00',4.31),('16100','2013-04-18','09:35:00',4.49),('16100','2013-04-18','09:40:00',3.77),('16100','2013-04-18','09:45:00',4.71),('16100','2013-04-18','09:50:00',4.8),('16100','2013-04-18','09:55:00',4.91),('16100','2013-04-18','10:00:00',5.1),('16100','2013-04-18','10:05:00',5.2),('16100','2013-04-18','10:10:00',5.35),('16100','2013-04-18','10:15:00',5.5),('16100','2013-04-18','10:20:00',5.61),('16100','2013-04-18','10:25:00',5.73),('16100','2013-04-18','10:30:00',5.94),('16100','2013-04-18','10:35:00',6.02),('16100','2013-04-18','10:40:00',5.71),('16100','2013-04-18','10:45:00',6.09),('16100','2013-04-18','10:50:00',6.13),('16100','2013-04-18','10:55:00',6.28),('16100','2013-04-18','11:00:00',6.39),('16100','2013-04-18','11:05:00',6.45),('16100','2013-04-18','11:10:00',6.66),('16100','2013-04-18','11:15:00',6.69),('16100','2013-04-18','11:20:00',6.69),('16100','2013-04-18','11:25:00',6.72),('16100','2013-04-18','11:30:00',6.78),('16100','2013-04-18','11:35:00',6.71),('16100','2013-04-18','11:40:00',6.83),('16100','2013-04-18','11:45:00',6.88),('16100','2013-04-18','11:50:00',7.07),('16100','2013-04-18','11:55:00',7.14),('16100','2013-04-18','12:00:00',7.2),('16100','2013-04-18','12:05:00',7.28),('16100','2013-04-18','12:10:00',7.34),('16100','2013-04-18','12:15:00',7.36),('16100','2013-04-18','12:20:00',7.38),('16100','2013-04-18','12:25:00',7.39),('16100','2013-04-18','12:30:00',7.37),('16100','2013-04-18','12:35:00',7.33),('16100','2013-04-18','12:40:00',7.32),('16100','2013-04-18','12:45:00',7.5),('16100','2013-04-18','12:50:00',7.72),('16100','2013-04-18','12:55:00',7.58),('16100','2013-04-18','13:00:00',7.65),('16100','2013-04-18','13:05:00',7.67),('16100','2013-04-18','13:10:00',7.66),('16100','2013-04-18','13:15:00',7.73),('16100','2013-04-18','13:20:00',7.66),('16100','2013-04-18','13:25:00',7.66),('16100','2013-04-18','13:30:00',7.68),('16100','2013-04-18','13:35:00',7.64),('16100','2013-04-18','13:40:00',7.62),('16100','2013-04-18','13:45:00',7.55),('16100','2013-04-18','13:50:00',7.56),('16100','2013-04-18','13:55:00',7.49),('16100','2013-04-18','14:00:00',7.55),('16100','2013-04-18','14:05:00',7.44),('16100','2013-04-18','14:10:00',7.33),('16100','2013-04-18','14:15:00',7.35),('16100','2013-04-18','14:20:00',7.28),('16100','2013-04-18','14:25:00',7.24),('16100','2013-04-18','14:30:00',7.2),('16100','2013-04-18','14:35:00',7.16),('16100','2013-04-18','14:40:00',7.18),('16100','2013-04-18','14:45:00',7.14),('16100','2013-04-18','14:50:00',7.03),('16100','2013-04-18','14:55:00',6.94),('16100','2013-04-18','15:00:00',6.9),('16100','2013-04-18','15:05:00',6.82),('16100','2013-04-18','15:10:00',6.71),('16100','2013-04-18','15:15:00',6.62),('16100','2013-04-18','15:20:00',6.49),('16100','2013-04-18','15:25:00',6.42),('16100','2013-04-18','15:30:00',6.38),('16100','2013-04-18','15:35:00',6.29),('16100','2013-04-18','15:40:00',6.19),('16100','2013-04-18','15:45:00',6.07),('16100','2013-04-18','15:50:00',5.99),('16100','2013-04-18','15:55:00',5.86),('16100','2013-04-18','16:00:00',5.73),('16100','2013-04-18','16:05:00',5.62),('16100','2013-04-18','16:10:00',5.41),('16100','2013-04-18','16:15:00',5.28),('16100','2013-04-18','16:20:00',5.13),('16100','2013-04-18','16:25:00',5.02),('16100','2013-04-18','16:30:00',4.89),('16100','2013-04-18','16:35:00',4.74),('16100','2013-04-18','16:40:00',4.54),('16100','2013-04-18','16:45:00',4.41),('16100','2013-04-18','16:50:00',4.22),('16100','2013-04-18','16:55:00',4.05),('16100','2013-04-18','17:00:00',3.92),('16100','2013-04-18','17:05:00',3.72),('16100','2013-04-18','17:10:00',3.58),('16100','2013-04-18','17:15:00',3.46),('16100','2013-04-18','17:20:00',3.28),('16100','2013-04-18','17:25:00',3.08),('16100','2013-04-18','17:30:00',2.89),('16100','2013-04-18','17:35:00',2.74),('16100','2013-04-18','17:40:00',2.55),('16100','2013-04-18','17:45:00',2.38),('16100','2013-04-18','17:50:00',2.22),('16100','2013-04-18','17:55:00',2.09),('16100','2013-04-18','18:00:00',1.92),('16100','2013-04-18','18:05:00',1.79),('16100','2013-04-18','18:10:00',1.63),('16100','2013-04-18','18:15:00',1.49),('16100','2013-04-18','18:20:00',1.33),('16100','2013-04-18','18:25:00',1.18),('16100','2013-04-18','18:30:00',1.04),('16100','2013-04-17','08:00:00',1.09),('16100','2013-04-17','08:05:00',1.21),('16100','2013-04-17','08:10:00',1.5),('16100','2013-04-17','08:15:00',1.65),('16100','2013-04-17','08:20:00',1.71),('16100','2013-04-17','08:25:00',1.76),('16100','2013-04-17','08:30:00',1.8),('16100','2013-04-17','08:35:00',1.92),('16100','2013-04-17','08:40:00',1.88),('16100','2013-04-17','08:45:00',2.08),('16100','2013-04-17','08:50:00',2.29),('16100','2013-04-17','08:55:00',2.58),('16100','2013-04-17','09:00:00',2.52),('16100','2013-04-17','09:05:00',2.41),('16100','2013-04-17','09:10:00',2.66),('16100','2013-04-17','09:15:00',2.97),('16100','2013-04-17','09:20:00',2.97),('16100','2013-04-17','09:25:00',3.18),('16100','2013-04-17','09:30:00',3.14),('16100','2013-04-17','09:35:00',3.28),('16100','2013-04-17','09:40:00',4.4),('16100','2013-04-17','09:45:00',4.46),('16100','2013-04-17','09:50:00',4.54),('16100','2013-04-17','09:55:00',4.79),('16100','2013-04-17','10:00:00',5.06),('16100','2013-04-17','10:05:00',5.01),('16100','2013-04-17','10:10:00',5.06),('16100','2013-04-17','10:15:00',5.16),('16100','2013-04-17','10:20:00',5.57),('16100','2013-04-17','10:25:00',6),('16100','2013-04-17','10:30:00',6.14),('16100','2013-04-17','10:35:00',6.24),('16100','2013-04-17','10:40:00',6.25),('16100','2013-04-17','10:45:00',6.35),('16100','2013-04-17','10:50:00',6.44),('16100','2013-04-17','10:55:00',6.52),('16100','2013-04-17','11:00:00',6.6),('16100','2013-04-17','11:05:00',6.73),('16100','2013-04-17','11:10:00',6.86),('16100','2013-04-17','11:15:00',6.94),('16100','2013-04-17','11:20:00',6.99),('16100','2013-04-17','11:25:00',7.03),('16100','2013-04-17','11:30:00',7.06),('16100','2013-04-17','11:35:00',7.16),('16100','2013-04-17','11:40:00',7.3),('16100','2013-04-17','11:45:00',7.28),('16100','2013-04-17','11:50:00',7.46),('16100','2013-04-17','11:55:00',7.58),('16100','2013-04-17','12:00:00',7.33),('16100','2013-04-17','12:05:00',7.67),('16100','2013-04-17','12:10:00',7.68),('16100','2013-04-17','12:15:00',7.64),('16100','2013-04-17','12:20:00',7.73),('16100','2013-04-17','12:25:00',7.79),('16100','2013-04-17','12:30:00',7.73),('16100','2013-04-17','12:35:00',7.81),('16100','2013-04-17','12:40:00',7.83),('16100','2013-04-17','12:45:00',7.88),('16100','2013-04-17','12:50:00',7.84),('16100','2013-04-17','12:55:00',7.88),('16100','2013-04-17','13:00:00',7.92),('16100','2013-04-17','13:05:00',7.9),('16100','2013-04-17','13:10:00',7.91),('16100','2013-04-17','13:15:00',7.89),('16100','2013-04-17','13:20:00',7.87),('16100','2013-04-17','13:25:00',7.9),('16100','2013-04-17','13:30:00',7.96),('16100','2013-04-17','13:35:00',7.9),('16100','2013-04-17','13:40:00',7.87),('16100','2013-04-17','13:45:00',7.82),('16100','2013-04-17','13:50:00',7.77),('16100','2013-04-17','13:55:00',7.83),('16100','2013-04-17','14:00:00',7.85),('16100','2013-04-17','14:05:00',7.68),('16100','2013-04-17','14:10:00',7.7),('16100','2013-04-17','14:15:00',7.7),('16100','2013-04-17','14:20:00',7.65),('16100','2013-04-17','14:25:00',7.6),('16100','2013-04-17','14:30:00',7.56),('16100','2013-04-17','14:35:00',7.48),('16100','2013-04-17','14:40:00',7.4),('16100','2013-04-17','14:45:00',7.35),('16100','2013-04-17','14:50:00',7.28),('16100','2013-04-17','14:55:00',7.22),('16100','2013-04-17','15:00:00',7.18),('16100','2013-04-17','15:05:00',7.09),('16100','2013-04-17','15:10:00',6.98),('16100','2013-04-17','15:15:00',6.88),('16100','2013-04-17','15:20:00',6.72),('16100','2013-04-17','15:25:00',6.61),('16100','2013-04-17','15:30:00',6.49),('16100','2013-04-17','15:35:00',6.43),('16100','2013-04-17','15:40:00',6.32),('16100','2013-04-17','15:45:00',6.19),('16100','2013-04-17','15:50:00',6.07),('16100','2013-04-17','15:55:00',5.94),('16100','2013-04-17','16:00:00',5.83),('16100','2013-04-17','16:05:00',5.74),('16100','2013-04-17','16:10:00',5.54),('16100','2013-04-17','16:15:00',5.38),('16100','2013-04-17','16:20:00',5.25),('16100','2013-04-17','16:25:00',5.12),('16100','2013-04-17','16:30:00',4.95),('16100','2013-04-17','16:35:00',4.83),('16100','2013-04-17','16:40:00',4.71),('16100','2013-04-17','16:45:00',4.6),('16100','2013-04-17','16:50:00',4.43),('16100','2013-04-17','16:55:00',4.24),('16100','2013-04-17','17:00:00',4.04),('16100','2013-04-17','17:05:00',3.85),('16100','2013-04-17','17:10:00',3.66),('16100','2013-04-17','17:15:00',3.53),('16100','2013-04-17','17:20:00',3.36),('16100','2013-04-17','17:25:00',3.2),('16100','2013-04-17','17:30:00',3.05),('16100','2013-04-17','17:35:00',2.88),('16100','2013-04-17','17:40:00',2.67),('16100','2013-04-17','17:45:00',2.49),('16100','2013-04-17','17:50:00',2.28),('16100','2013-04-17','17:55:00',2.13),('16100','2013-04-17','18:00:00',2.01),('16100','2013-04-17','18:05:00',1.87),('16100','2013-04-17','18:10:00',1.7),('16100','2013-04-17','18:15:00',1.52),('16100','2013-04-17','18:20:00',1.37),('16100','2013-04-17','18:25:00',1.18),('16100','2013-04-17','18:30:00',1.02),('16100','2013-04-16','08:00:00',1.11),('16100','2013-04-16','08:05:00',1.29),('16100','2013-04-16','08:10:00',1.54),('16100','2013-04-16','08:15:00',1.78),('16100','2013-04-16','08:20:00',2.04),('16100','2013-04-16','08:25:00',2.23),('16100','2013-04-16','08:30:00',2.43),('16100','2013-04-16','08:35:00',2.62),('16100','2013-04-16','08:40:00',2.78),('16100','2013-04-16','08:45:00',2.96),('16100','2013-04-16','08:50:00',3.17),('16100','2013-04-16','08:55:00',3.33),('16100','2013-04-16','09:00:00',3.49),('16100','2013-04-16','09:05:00',3.68),('16100','2013-04-16','09:10:00',3.87),('16100','2013-04-16','09:15:00',4.01),('16100','2013-04-16','09:20:00',4.16),('16100','2013-04-16','09:25:00',4.3),('16100','2013-04-16','09:30:00',4.44),('16100','2013-04-16','09:35:00',4.6),('16100','2013-04-16','09:40:00',4.78),('16100','2013-04-16','09:45:00',4.89),('16100','2013-04-16','09:50:00',5.03),('16100','2013-04-16','09:55:00',5.17),('16100','2013-04-16','10:00:00',5.32),('16100','2013-04-16','10:05:00',5.44),('16100','2013-04-16','10:10:00',5.57),('16100','2013-04-16','10:15:00',5.7),('16100','2013-04-16','10:20:00',5.84),('16100','2013-04-16','10:25:00',5.93),('16100','2013-04-16','10:30:00',6.05),('16100','2013-04-16','10:35:00',6.17),('16100','2013-04-16','10:40:00',6.28),('16100','2013-04-16','10:45:00',6.39),('16100','2013-04-16','10:50:00',6.5),('16100','2013-04-16','10:55:00',6.59),('16100','2013-04-16','11:00:00',6.73),('16100','2013-04-16','11:05:00',6.83),('16100','2013-04-16','11:10:00',6.98),('16100','2013-04-16','11:15:00',7.04),('16100','2013-04-16','11:20:00',7.09),('16100','2013-04-16','11:25:00',7.15),('16100','2013-04-16','11:30:00',7.22),('16100','2013-04-16','11:35:00',7.27),('16100','2013-04-16','11:40:00',7.32),('16100','2013-04-16','11:45:00',7.39),('16100','2013-04-16','11:50:00',7.45),('16100','2013-04-16','11:55:00',7.49),('16100','2013-04-16','12:00:00',7.52),('16100','2013-04-16','12:05:00',7.57),('16100','2013-04-16','12:10:00',7.64),('16100','2013-04-16','12:15:00',7.66),('16100','2013-04-16','12:20:00',7.73),('16100','2013-04-16','12:25:00',7.73),('16100','2013-04-16','12:30:00',7.81),('16100','2013-04-16','12:35:00',7.88),('16100','2013-04-16','12:40:00',7.87),('16100','2013-04-16','12:45:00',7.9),('16100','2013-04-16','12:50:00',7.89),('16100','2013-04-16','12:55:00',7.94),('16100','2013-04-16','13:00:00',8.01),('16100','2013-04-16','13:05:00',7.98),('16100','2013-04-16','13:10:00',8.02),('16100','2013-04-16','13:15:00',8.04),('16100','2013-04-16','13:20:00',8.1),('16100','2013-04-16','13:25:00',8.13),('16100','2013-04-16','13:30:00',7.98),('16100','2013-04-16','13:35:00',8.22),('16100','2013-04-16','13:40:00',8.19),('16100','2013-04-16','13:45:00',7.62),('16100','2013-04-16','13:50:00',7.6),('16100','2013-04-16','13:55:00',6.78),('16100','2013-04-16','14:00:00',7.79),('16100','2013-04-16','14:05:00',7.74),('16100','2013-04-16','14:10:00',8.36),('16100','2013-04-16','14:15:00',7.9),('16100','2013-04-16','14:20:00',8.32),('16100','2013-04-16','14:25:00',6.32),('16100','2013-04-16','14:30:00',6.93),('16100','2013-04-16','14:35:00',7.75),('16100','2013-04-16','14:40:00',7.52),('16100','2013-04-16','14:45:00',4.94),('16100','2013-04-16','14:50:00',6.73),('16100','2013-04-16','14:55:00',7.64),('16100','2013-04-16','15:00:00',8),('16100','2013-04-16','15:05:00',7.98),('16100','2013-04-16','15:10:00',8.15),('16100','2013-04-16','15:15:00',7.63),('16100','2013-04-16','15:20:00',3.98),('16100','2013-04-16','15:25:00',3.24),('16100','2013-04-16','15:30:00',5.45),('16100','2013-04-16','15:35:00',5.22),('16100','2013-04-16','15:40:00',5.49),('16100','2013-04-16','15:45:00',5.58),('16100','2013-04-16','15:50:00',6.44),('16100','2013-04-16','15:55:00',6.46),('16100','2013-04-16','16:00:00',6.39),('16100','2013-04-16','16:05:00',4.64),('16100','2013-04-16','16:10:00',5.74),('16100','2013-04-16','16:15:00',5.76),('16100','2013-04-16','16:20:00',5.58),('16100','2013-04-16','16:25:00',5.39),('16100','2013-04-16','16:30:00',5.26),('16100','2013-04-16','16:35:00',4.67),('16100','2013-04-16','16:40:00',3.94),('16100','2013-04-16','16:45:00',4.67),('16100','2013-04-16','16:50:00',4.59),('16100','2013-04-16','16:55:00',4.36),('16100','2013-04-16','17:00:00',4.16),('16100','2013-04-16','17:05:00',3.99),('16100','2013-04-16','17:10:00',3.84),('16100','2013-04-16','17:15:00',3.68),('16100','2013-04-16','17:20:00',3.5),('16100','2013-04-16','17:25:00',3.32),('16100','2013-04-16','17:30:00',3.15),('16100','2013-04-16','17:35:00',2.98),('16100','2013-04-16','17:40:00',2.78),('16100','2013-04-16','17:45:00',2.59),('16100','2013-04-16','17:50:00',2.42),('16100','2013-04-16','17:55:00',2.24),('16100','2013-04-16','18:00:00',2.09),('16100','2013-04-16','18:05:00',1.93),('16100','2013-04-16','18:10:00',1.76),('16100','2013-04-16','18:15:00',1.58),('16100','2013-04-16','18:20:00',1.42),('16100','2013-04-16','18:25:00',1.26),('16100','2013-04-16','18:30:00',1.09),('16100','2013-04-15','08:00:00',1.02),('16100','2013-04-15','08:05:00',1.36),('16100','2013-04-15','08:10:00',1.75),('16100','2013-04-15','08:15:00',1.21),('16100','2013-04-15','08:40:00',1.16),('16100','2013-04-15','08:45:00',1.54),('16100','2013-04-15','08:50:00',1.68),('16100','2013-04-15','09:05:00',2.8),('16100','2013-04-15','09:10:00',3.88),('16100','2013-04-15','09:15:00',4.14),('16100','2013-04-15','09:20:00',3.97),('16100','2013-04-15','09:25:00',2.49),('16100','2013-04-15','09:30:00',2.42),('16100','2013-04-15','09:35:00',2.91),('16100','2013-04-15','09:40:00',3.76),('16100','2013-04-15','09:45:00',2.99),('16100','2013-04-15','09:50:00',2.54),('16100','2013-04-15','09:55:00',2.33),('16100','2013-04-15','10:00:00',2.26),('16100','2013-04-15','10:05:00',2.24),('16100','2013-04-15','10:10:00',2.31),('16100','2013-04-15','10:15:00',2.41),('16100','2013-04-15','10:20:00',2.34),('16100','2013-04-15','10:25:00',2.36),('16100','2013-04-15','10:30:00',2.38),('16100','2013-04-15','10:35:00',2.47),('16100','2013-04-15','10:40:00',2.63),('16100','2013-04-15','10:45:00',2.75),('16100','2013-04-15','10:50:00',2.69),('16100','2013-04-15','10:55:00',2.69),('16100','2013-04-15','11:00:00',2.74),('16100','2013-04-15','11:05:00',2.8),('16100','2013-04-15','11:10:00',2.84),('16100','2013-04-15','11:15:00',2.9),('16100','2013-04-15','11:20:00',2.94),('16100','2013-04-15','11:25:00',2.97),('16100','2013-04-15','11:30:00',2.73),('16100','2013-04-15','11:35:00',2.64),('16100','2013-04-15','11:40:00',3.24),('16100','2013-04-15','11:45:00',3.67),('16100','2013-04-15','11:50:00',3.93),('16100','2013-04-15','11:55:00',4.51),('16100','2013-04-15','12:00:00',5.4),('16100','2013-04-15','12:05:00',5.74),('16100','2013-04-15','12:10:00',5.96),('16100','2013-04-15','12:15:00',5.03),('16100','2013-04-15','12:20:00',4.97),('16100','2013-04-15','12:25:00',5.94),('16100','2013-04-15','12:30:00',6.25),('16100','2013-04-15','12:35:00',4.77),('16100','2013-04-15','12:40:00',5.59),('16100','2013-04-15','12:45:00',6.26),('16100','2013-04-15','12:50:00',6.66),('16100','2013-04-15','12:55:00',7.53),('16100','2013-04-15','13:00:00',7.52),('16100','2013-04-15','13:05:00',7.28),('16100','2013-04-15','13:10:00',7.32),('16100','2013-04-15','13:15:00',7.33),('16100','2013-04-15','13:20:00',7.34),('16100','2013-04-15','13:25:00',7.49),('16100','2013-04-15','13:30:00',7.51),('16100','2013-04-15','13:35:00',7.62),('16100','2013-04-15','13:40:00',7.56),('16100','2013-04-15','13:45:00',7.67),('16100','2013-04-15','13:50:00',7.39),('16100','2013-04-15','13:55:00',7.62),('16100','2013-04-15','14:00:00',7.61),('16100','2013-04-15','14:05:00',7.5),('16100','2013-04-15','14:10:00',7.64),('16100','2013-04-15','14:15:00',7.65),('16100','2013-04-15','14:20:00',7.66),('16100','2013-04-15','14:25:00',6.95),('16100','2013-04-15','14:30:00',6.05),('16100','2013-04-15','14:35:00',6.01),('16100','2013-04-15','14:40:00',7.24),('16100','2013-04-15','14:45:00',7.06),('16100','2013-04-15','14:50:00',7.2),('16100','2013-04-15','14:55:00',7.02),('16100','2013-04-15','15:00:00',7.2),('16100','2013-04-15','15:05:00',7.16),('16100','2013-04-15','15:10:00',7.05),('16100','2013-04-15','15:15:00',5.8),('16100','2013-04-15','15:20:00',5.62),('16100','2013-04-15','15:25:00',5.66),('16100','2013-04-15','15:30:00',6.02),('16100','2013-04-15','15:35:00',6.25),('16100','2013-04-15','15:40:00',6.23),('16100','2013-04-15','15:45:00',5.95),('16100','2013-04-15','15:50:00',5.98),('16100','2013-04-15','15:55:00',5.83),('16100','2013-04-15','16:00:00',5.7),('16100','2013-04-15','16:05:00',5.54),('16100','2013-04-15','16:10:00',5.35),('16100','2013-04-15','16:15:00',5.3),('16100','2013-04-15','16:20:00',5.1),('16100','2013-04-15','16:25:00',5.03),('16100','2013-04-15','16:30:00',4.9),('16100','2013-04-15','16:35:00',4.88),('16100','2013-04-15','16:40:00',4.89),('16100','2013-04-15','16:45:00',4.47),('16100','2013-04-15','16:50:00',3.83),('16100','2013-04-15','16:55:00',4.09),('16100','2013-04-15','17:00:00',4.09),('16100','2013-04-15','17:05:00',3.97),('16100','2013-04-15','17:10:00',3.8),('16100','2013-04-15','17:15:00',3.72),('16100','2013-04-15','17:20:00',3.64),('16100','2013-04-15','17:25:00',3.34),('16100','2013-04-15','17:30:00',3.19),('16100','2013-04-15','17:35:00',3),('16100','2013-04-15','17:40:00',2.74),('16100','2013-04-15','17:45:00',2.54),('16100','2013-04-15','17:50:00',2.39),('16100','2013-04-15','17:55:00',2.39),('16100','2013-04-15','18:00:00',2.4),('16100','2013-04-15','18:05:00',2.22),('16100','2013-04-15','18:10:00',1.7),('16100','2013-04-15','18:15:00',1.17),('16100','2013-04-15','18:20:00',1.26),('16100','2013-04-15','18:25:00',1.13),('16100','2013-04-15','18:30:00',1.01),('16100','2013-04-14','08:00:00',1.08),('16100','2013-04-14','08:05:00',1.27),('16100','2013-04-14','08:10:00',1.52),('16100','2013-04-14','08:15:00',1.8),('16100','2013-04-14','08:20:00',2.02),('16100','2013-04-14','08:25:00',2.21),('16100','2013-04-14','08:30:00',2.33),('16100','2013-04-14','08:35:00',2.58),('16100','2013-04-14','08:40:00',2.79),('16100','2013-04-14','08:45:00',2.96),('16100','2013-04-14','08:50:00',3.18),('16100','2013-04-14','08:55:00',3.35),('16100','2013-04-14','09:00:00',3.52),('16100','2013-04-14','09:05:00',3.69),('16100','2013-04-14','09:10:00',3.92),('16100','2013-04-14','09:15:00',4.1),('16100','2013-04-14','09:20:00',4.25),('16100','2013-04-14','09:25:00',4.4),('16100','2013-04-14','09:30:00',4.53),('16100','2013-04-14','09:35:00',4.67),('16100','2013-04-14','09:40:00',4.85),('16100','2013-04-14','09:45:00',5),('16100','2013-04-14','09:50:00',5.12),('16100','2013-04-14','09:55:00',5.24),('16100','2013-04-14','10:00:00',5.35),('16100','2013-04-14','10:05:00',5.45),('16100','2013-04-14','10:10:00',5.58),('16100','2013-04-14','10:15:00',5.69),('16100','2013-04-14','10:20:00',5.85),('16100','2013-04-14','10:25:00',5.99),('16100','2013-04-14','10:30:00',6.16),('16100','2013-04-14','10:35:00',6.31),('16100','2013-04-14','10:40:00',6.38),('16100','2013-04-14','10:45:00',6.47),('16100','2013-04-14','10:50:00',6.55),('16100','2013-04-14','10:55:00',6.66),('16100','2013-04-14','11:00:00',6.74),('16100','2013-04-14','11:05:00',6.83),('16100','2013-04-14','11:10:00',6.98),('16100','2013-04-14','11:15:00',7.02),('16100','2013-04-14','11:20:00',7.09),('16100','2013-04-14','11:25:00',7.12),('16100','2013-04-14','11:30:00',7.22),('16100','2013-04-14','11:35:00',7.29),('16100','2013-04-14','11:40:00',7.32),('16100','2013-04-14','11:45:00',7.4),('16100','2013-04-14','11:50:00',7.49),('16100','2013-04-14','11:55:00',7.5),('16100','2013-04-14','12:00:00',7.56),('16100','2013-04-14','12:05:00',7.58),('16100','2013-04-14','12:10:00',7.62),('16100','2013-04-14','12:15:00',7.68),('16100','2013-04-14','12:20:00',7.68),('16100','2013-04-14','12:25:00',7.69),('16100','2013-04-14','12:30:00',7.67),('16100','2013-04-14','12:35:00',7.73),('16100','2013-04-14','12:40:00',7.76),('16100','2013-04-14','12:45:00',7.77),('16100','2013-04-14','12:50:00',7.8),('16100','2013-04-14','12:55:00',7.79),('16100','2013-04-14','13:00:00',7.78),('16100','2013-04-14','13:05:00',7.84),('16100','2013-04-14','13:10:00',7.87),('16100','2013-04-14','13:15:00',7.82),('16100','2013-04-14','13:20:00',7.88),('16100','2013-04-14','13:25:00',7.87),('16100','2013-04-14','13:30:00',7.79),('16100','2013-04-14','13:35:00',7.72),('16100','2013-04-14','13:40:00',7.77),('16100','2013-04-14','13:45:00',7.88),('16100','2013-04-14','13:50:00',7.95),('16100','2013-04-14','13:55:00',7.94),('16100','2013-04-14','14:00:00',7.95),('16100','2013-04-14','14:05:00',7.84),('16100','2013-04-14','14:10:00',7.82),('16100','2013-04-14','14:15:00',7.79),('16100','2013-04-14','14:20:00',7.75),('16100','2013-04-14','14:25:00',7.68),('16100','2013-04-14','14:30:00',7.59),('16100','2013-04-14','14:35:00',7.5),('16100','2013-04-14','14:40:00',7.43),('16100','2013-04-14','14:45:00',7.36),('16100','2013-04-14','14:50:00',7.33),('16100','2013-04-14','14:55:00',7.29),('16100','2013-04-14','15:00:00',7.2),('16100','2013-04-14','15:05:00',7.12),('16100','2013-04-14','15:10:00',7.03),('16100','2013-04-14','15:15:00',6.9),('16100','2013-04-14','15:20:00',6.83),('16100','2013-04-14','15:25:00',6.72),('16100','2013-04-14','15:30:00',6.62),('16100','2013-04-14','15:35:00',6.54),('16100','2013-04-14','15:40:00',6.4),('16100','2013-04-14','15:45:00',6.31),('16100','2013-04-14','15:50:00',6.19),('16100','2013-04-14','15:55:00',6.07),('16100','2013-04-14','16:00:00',5.92),('16100','2013-04-14','16:05:00',5.81),('16100','2013-04-14','16:10:00',5.58),('16100','2013-04-14','16:15:00',5.55),('16100','2013-04-14','16:20:00',5.42),('16100','2013-04-14','16:25:00',5.27),('16100','2013-04-14','16:30:00',5.12),('16100','2013-04-14','16:35:00',4.96),('16100','2013-04-14','16:40:00',4.81),('16100','2013-04-14','16:45:00',4.65),('16100','2013-04-14','16:50:00',4.5),('16100','2013-04-14','16:55:00',4.32),('16100','2013-04-14','17:00:00',4.15),('16100','2013-04-14','17:05:00',4),('16100','2013-04-14','17:10:00',3.84),('16100','2013-04-14','17:15:00',3.67),('16100','2013-04-14','17:20:00',3.48),('16100','2013-04-14','17:25:00',3.29),('16100','2013-04-14','17:30:00',3.15),('16100','2013-04-14','17:35:00',2.98),('16100','2013-04-14','17:40:00',2.79),('16100','2013-04-14','17:45:00',2.61),('16100','2013-04-14','17:50:00',2.43),('16100','2013-04-14','17:55:00',2.25),('16100','2013-04-14','18:00:00',2.08),('16100','2013-04-14','18:05:00',1.92),('16100','2013-04-14','18:10:00',1.74),('16100','2013-04-14','18:15:00',1.58),('16100','2013-04-14','18:20:00',1.42),('16100','2013-04-14','18:25:00',1.26),('16100','2013-04-14','18:30:00',1.11),('16100','2013-04-13','08:00:00',1.04),('16100','2013-04-13','08:05:00',1.24),('16100','2013-04-13','08:10:00',1.48),('16100','2013-04-13','08:15:00',1.72),('16100','2013-04-13','08:20:00',1.88),('16100','2013-04-13','08:25:00',2.06),('16100','2013-04-13','08:30:00',2.26),('16100','2013-04-13','08:35:00',2.41),('16100','2013-04-13','08:40:00',2.61),('16100','2013-04-13','08:45:00',2.77),('16100','2013-04-13','08:50:00',2.97),('16100','2013-04-13','08:55:00',3.14),('16100','2013-04-13','09:00:00',3.27),('16100','2013-04-13','09:05:00',3.36),('16100','2013-04-13','09:10:00',3.55),('16100','2013-04-13','09:15:00',3.77),('16100','2013-04-13','09:20:00',3.95),('16100','2013-04-13','09:25:00',4.1),('16100','2013-04-13','09:30:00',4.28),('16100','2013-04-13','09:35:00',4.41),('16100','2013-04-13','09:40:00',4.55),('16100','2013-04-13','09:45:00',4.72),('16100','2013-04-13','09:50:00',4.86),('16100','2013-04-13','09:55:00',4.98),('16100','2013-04-13','10:00:00',5.14),('16100','2013-04-13','10:05:00',5.28),('16100','2013-04-13','10:10:00',5.4),('16100','2013-04-13','10:15:00',5.52),('16100','2013-04-13','10:20:00',5.66),('16100','2013-04-13','10:25:00',5.8),('16100','2013-04-13','10:30:00',5.94),('16100','2013-04-13','10:35:00',6.03),('16100','2013-04-13','10:40:00',6.15),('16100','2013-04-13','10:45:00',6.28),('16100','2013-04-13','10:50:00',6.35),('16100','2013-04-13','10:55:00',6.47),('16100','2013-04-13','11:00:00',6.56),('16100','2013-04-13','11:05:00',6.65),('16100','2013-04-13','11:10:00',6.77),('16100','2013-04-13','11:15:00',6.87),('16100','2013-04-13','11:20:00',6.95),('16100','2013-04-13','11:25:00',6.96),('16100','2013-04-13','11:30:00',7.02),('16100','2013-04-13','11:35:00',7.06),('16100','2013-04-13','11:40:00',7.15),('16100','2013-04-13','11:45:00',7.21),('16100','2013-04-13','11:50:00',7.32),('16100','2013-04-13','11:55:00',7.29),('16100','2013-04-13','12:00:00',7.37),('16100','2013-04-13','12:05:00',7.4),('16100','2013-04-13','12:10:00',7.41),('16100','2013-04-13','12:15:00',7.37),('16100','2013-04-13','12:20:00',7.41),('16100','2013-04-13','12:25:00',7.52),('16100','2013-04-13','12:30:00',7.53),('16100','2013-04-13','12:35:00',7.65),('16100','2013-04-13','12:40:00',7.68),('16100','2013-04-13','12:45:00',7.55),('16100','2013-04-13','12:50:00',7.62),('16100','2013-04-13','12:55:00',7.68),('16100','2013-04-13','13:00:00',7.8),('16100','2013-04-13','13:05:00',7.83),('16100','2013-04-13','13:10:00',6.79),('16100','2013-04-13','13:15:00',7.72),('16100','2013-04-13','13:20:00',4.08),('16100','2013-04-13','13:25:00',7.8),('16100','2013-04-13','13:30:00',7.52),('16100','2013-04-13','13:35:00',7.87),('16100','2013-04-13','13:40:00',8.05),('16100','2013-04-13','13:45:00',5.4),('16100','2013-04-13','13:50:00',6.36),('16100','2013-04-13','13:55:00',6.88),('16100','2013-04-13','14:00:00',7.67),('16100','2013-04-13','14:05:00',7.58),('16100','2013-04-13','14:10:00',7.34),('16100','2013-04-13','14:15:00',7.26),('16100','2013-04-13','14:20:00',7.44),('16100','2013-04-13','14:25:00',7.19),('16100','2013-04-13','14:30:00',7.47),('16100','2013-04-13','14:35:00',7.34),('16100','2013-04-13','14:40:00',7.22),('16100','2013-04-13','14:45:00',7.2),('16100','2013-04-13','14:50:00',7.33),('16100','2013-04-13','14:55:00',7.28),('16100','2013-04-13','15:00:00',7.34),('16100','2013-04-13','15:05:00',7.04),('16100','2013-04-13','15:10:00',7.37),('16100','2013-04-13','15:15:00',6.62),('16100','2013-04-13','15:20:00',6.66),('16100','2013-04-13','15:25:00',6.58),('16100','2013-04-13','15:30:00',6.39),('16100','2013-04-13','15:35:00',6.43),('16100','2013-04-13','15:40:00',6.18),('16100','2013-04-13','15:45:00',6.22),('16100','2013-04-13','15:50:00',6.04),('16100','2013-04-13','15:55:00',5.77),('16100','2013-04-13','16:00:00',5.61),('16100','2013-04-13','16:05:00',5.56),('16100','2013-04-13','16:10:00',5.3),('16100','2013-04-13','16:15:00',5.24),('16100','2013-04-13','16:20:00',5.16),('16100','2013-04-13','16:25:00',5.06),('16100','2013-04-13','16:30:00',4.89),('16100','2013-04-13','16:35:00',4.71),('16100','2013-04-13','16:40:00',4.61),('16100','2013-04-13','16:45:00',4.48),('16100','2013-04-13','16:50:00',4.28),('16100','2013-04-13','16:55:00',4.11),('16100','2013-04-13','17:00:00',4.01),('16100','2013-04-13','17:05:00',3.87),('16100','2013-04-13','17:10:00',3.69),('16100','2013-04-13','17:15:00',3.51),('16100','2013-04-13','17:20:00',3.4),('16100','2013-04-13','17:25:00',3.17),('16100','2013-04-13','17:30:00',2.99),('16100','2013-04-13','17:35:00',2.84),('16100','2013-04-13','17:40:00',2.67),('16100','2013-04-13','17:45:00',2.52),('16100','2013-04-13','17:50:00',2.32),('16100','2013-04-13','17:55:00',2.16),('16100','2013-04-13','18:00:00',1.99),('16100','2013-04-13','18:05:00',1.81),('16100','2013-04-13','18:10:00',1.64),('16100','2013-04-13','18:15:00',1.49),('16100','2013-04-13','18:20:00',1.34),('16100','2013-04-13','18:25:00',1.18),('16100','2013-04-13','18:30:00',1.04),('16100','2013-04-12','08:00:00',1.03),('16100','2013-04-12','08:05:00',1.27),('16100','2013-04-12','08:10:00',1.69),('16100','2013-04-12','08:15:00',1.02),('16100','2013-04-12','08:45:00',1.75),('16100','2013-04-12','08:50:00',3.08),('16100','2013-04-12','08:55:00',3.21),('16100','2013-04-12','09:00:00',3.19),('16100','2013-04-12','09:05:00',3.46),('16100','2013-04-12','09:10:00',3.73),('16100','2013-04-12','09:15:00',3.76),('16100','2013-04-12','09:20:00',3.97),('16100','2013-04-12','09:25:00',4.13),('16100','2013-04-12','09:30:00',4.33),('16100','2013-04-12','09:35:00',3.91),('16100','2013-04-12','09:40:00',4.79),('16100','2013-04-12','09:45:00',4.91),('16100','2013-04-12','09:50:00',5.04),('16100','2013-04-12','09:55:00',5.01),('16100','2013-04-12','10:00:00',2.66),('16100','2013-04-12','10:05:00',3.6),('16100','2013-04-12','10:10:00',4.78),('16100','2013-04-12','10:15:00',4.92),('16100','2013-04-12','10:20:00',5.99),('16100','2013-04-12','10:25:00',6.58),('16100','2013-04-12','10:30:00',6.81),('16100','2013-04-12','10:35:00',6.67),('16100','2013-04-12','10:40:00',5.94),('16100','2013-04-12','10:45:00',2.44),('16100','2013-04-12','10:50:00',3.5),('16100','2013-04-12','10:55:00',3.72),('16100','2013-04-12','11:00:00',6.67),('16100','2013-04-12','11:05:00',4.83),('16100','2013-04-12','11:10:00',3.54),('16100','2013-04-12','11:15:00',4.29),('16100','2013-04-12','11:20:00',6.23),('16100','2013-04-12','11:25:00',7.27),('16100','2013-04-12','11:30:00',7.21),('16100','2013-04-12','11:35:00',4.72),('16100','2013-04-12','11:40:00',6.37),('16100','2013-04-12','11:45:00',2.86),('16100','2013-04-12','11:50:00',7.86),('16100','2013-04-12','11:55:00',5.28),('16100','2013-04-12','12:00:00',8.1),('16100','2013-04-12','12:05:00',8.1),('16100','2013-04-12','12:10:00',6.4),('16100','2013-04-12','12:15:00',6.1),('16100','2013-04-12','12:20:00',5.36),('16100','2013-04-12','12:25:00',7.4),('16100','2013-04-12','12:30:00',6.69),('16100','2013-04-12','12:35:00',7.76),('16100','2013-04-12','12:40:00',8.24),('16100','2013-04-12','12:45:00',8.15),('16100','2013-04-12','12:50:00',7.94),('16100','2013-04-12','12:55:00',7.98),('16100','2013-04-12','13:00:00',7.88),('16100','2013-04-12','13:05:00',7.86),('16100','2013-04-12','13:10:00',7.81),('16100','2013-04-12','13:15:00',7.58),('16100','2013-04-12','13:20:00',7.6),('16100','2013-04-12','13:25:00',7.76),('16100','2013-04-12','13:30:00',7.26),('16100','2013-04-12','13:35:00',7.09),('16100','2013-04-12','13:40:00',6.65),('16100','2013-04-12','13:45:00',6.46),('16100','2013-04-12','13:50:00',4.39),('16100','2013-04-12','13:55:00',6.3),('16100','2013-04-12','14:00:00',6.44),('16100','2013-04-12','14:05:00',6.51),('16100','2013-04-12','14:10:00',6.31),('16100','2013-04-12','14:15:00',6.46),('16100','2013-04-12','14:20:00',6.33),('16100','2013-04-12','14:25:00',6.68),('16100','2013-04-12','14:30:00',7.15),('16100','2013-04-12','14:35:00',7.07),('16100','2013-04-12','14:40:00',7),('16100','2013-04-12','14:45:00',6.81),('16100','2013-04-12','14:50:00',6.52),('16100','2013-04-12','14:55:00',6.17),('16100','2013-04-12','15:00:00',6.07),('16100','2013-04-12','15:05:00',6.11),('16100','2013-04-12','15:10:00',5.85),('16100','2013-04-12','15:15:00',5.41),('16100','2013-04-12','15:20:00',5.13),('16100','2013-04-12','15:25:00',5.25),('16100','2013-04-12','15:30:00',5.03),('16100','2013-04-12','15:35:00',5.2),('16100','2013-04-12','15:40:00',5.28),('16100','2013-04-12','15:45:00',5.3),('16100','2013-04-12','15:50:00',5.49),('16100','2013-04-12','15:55:00',4.77),('16100','2013-04-12','16:00:00',4.87),('16100','2013-04-12','16:05:00',4.5),('16100','2013-04-12','16:10:00',4.54),('16100','2013-04-12','16:15:00',4.37),('16100','2013-04-12','16:20:00',4.09),('16100','2013-04-12','16:25:00',3.55),('16100','2013-04-12','16:30:00',3.64),('16100','2013-04-12','16:35:00',3.13),('16100','2013-04-12','16:40:00',3.14),('16100','2013-04-12','16:45:00',3.34),('16100','2013-04-12','16:50:00',2.98),('16100','2013-04-12','16:55:00',2.44),('16100','2013-04-12','17:00:00',2.66),('16100','2013-04-12','17:05:00',3.92),('16100','2013-04-12','17:10:00',3.89),('16100','2013-04-12','17:15:00',3.24),('16100','2013-04-12','17:20:00',3.29),('16100','2013-04-12','17:25:00',3.31),('16100','2013-04-12','17:30:00',3.05),('16100','2013-04-12','17:35:00',3.02),('16100','2013-04-12','17:40:00',2.71),('16100','2013-04-12','17:45:00',2.42),('16100','2013-04-12','17:50:00',2.21),('16100','2013-04-12','17:55:00',2.31),('16100','2013-04-12','18:00:00',1.77),('16100','2013-04-12','18:05:00',1.73),('16100','2013-04-12','18:10:00',1.68),('16100','2013-04-12','18:15:00',1.63),('16100','2013-04-12','18:20:00',1.51),('16100','2013-04-12','18:25:00',1.36),('16100','2013-04-12','18:30:00',1.14),('16100','2013-04-11','08:00:00',1.11),('16100','2013-04-11','08:05:00',1.48),('16100','2013-04-11','08:10:00',1.34),('16100','2013-04-11','08:15:00',1.49),('16100','2013-04-11','08:35:00',1.12),('16100','2013-04-11','08:40:00',2.33),('16100','2013-04-11','08:45:00',1.98),('16100','2013-04-11','08:50:00',1.74),('16100','2013-04-11','08:55:00',1.62),('16100','2013-04-11','09:00:00',1.91),('16100','2013-04-11','09:05:00',1.24),('16100','2013-04-11','09:10:00',1.2),('16100','2013-04-11','09:15:00',1.49),('16100','2013-04-11','09:20:00',1.77),('16100','2013-04-11','09:25:00',1.73),('16100','2013-04-11','09:30:00',1.65),('16100','2013-04-11','09:35:00',1.52),('16100','2013-04-11','09:40:00',1.59),('16100','2013-04-11','09:45:00',1.55),('16100','2013-04-11','09:50:00',2.47),('16100','2013-04-11','09:55:00',3.1),('16100','2013-04-11','10:00:00',2.13),('16100','2013-04-11','10:05:00',2.39),('16100','2013-04-11','10:10:00',2.56),('16100','2013-04-11','10:15:00',2.4),('16100','2013-04-11','10:20:00',2.01),('16100','2013-04-11','10:25:00',1.54),('16100','2013-04-11','10:30:00',2.19),('16100','2013-04-11','10:35:00',2.5),('16100','2013-04-11','10:40:00',2.77),('16100','2013-04-11','10:45:00',2.46),('16100','2013-04-11','10:50:00',1.82),('16100','2013-04-11','10:55:00',1.87),('16100','2013-04-11','11:00:00',2.39),('16100','2013-04-11','11:05:00',3.04),('16100','2013-04-11','11:10:00',4.05),('16100','2013-04-11','11:15:00',4.72),('16100','2013-04-11','11:20:00',4.24),('16100','2013-04-11','11:25:00',7.83),('16100','2013-04-11','11:30:00',6.12),('16100','2013-04-11','11:35:00',5.73),('16100','2013-04-11','11:40:00',4.11),('16100','2013-04-11','11:45:00',7.68),('16100','2013-04-11','11:50:00',7.63),('16100','2013-04-11','11:55:00',6.16),('16100','2013-04-11','12:00:00',5.77),('16100','2013-04-11','12:05:00',7.67),('16100','2013-04-11','12:10:00',7.72),('16100','2013-04-11','12:15:00',8.32),('16100','2013-04-11','12:20:00',8.19),('16100','2013-04-11','12:25:00',8.14),('16100','2013-04-11','12:30:00',8.08),('16100','2013-04-11','12:35:00',7.93),('16100','2013-04-11','12:40:00',7.94),('16100','2013-04-11','12:45:00',7.62),('16100','2013-04-11','12:50:00',8.07),('16100','2013-04-11','12:55:00',8.18),('16100','2013-04-11','13:00:00',8.2),('16100','2013-04-11','13:05:00',8.21),('16100','2013-04-11','13:10:00',8.14),('16100','2013-04-11','13:15:00',8.09),('16100','2013-04-11','13:20:00',8.08),('16100','2013-04-11','13:25:00',8.09),('16100','2013-04-11','13:30:00',8.01),('16100','2013-04-11','13:35:00',8),('16100','2013-04-11','13:40:00',8.01),('16100','2013-04-11','13:45:00',7.97),('16100','2013-04-11','13:50:00',7.91),('16100','2013-04-11','13:55:00',7.93),('16100','2013-04-11','14:00:00',7.93),('16100','2013-04-11','14:05:00',7.82),('16100','2013-04-11','14:10:00',7.73),('16100','2013-04-11','14:15:00',7.7),('16100','2013-04-11','14:20:00',7.63),('16100','2013-04-11','14:25:00',7.53),('16100','2013-04-11','14:30:00',7.46),('16100','2013-04-11','14:35:00',7.38),('16100','2013-04-11','14:40:00',7.32),('16100','2013-04-11','14:45:00',7.29),('16100','2013-04-11','14:50:00',7.27),('16100','2013-04-11','14:55:00',7.17),('16100','2013-04-11','15:00:00',7.09),('16100','2013-04-11','15:05:00',7.06),('16100','2013-04-11','15:10:00',6.92),('16100','2013-04-11','15:15:00',6.83),('16100','2013-04-11','15:20:00',6.76),('16100','2013-04-11','15:25:00',6.65),('16100','2013-04-11','15:30:00',6.54),('16100','2013-04-11','15:35:00',6.43),('16100','2013-04-11','15:40:00',6.31),('16100','2013-04-11','15:45:00',6.2),('16100','2013-04-11','15:50:00',6.1),('16100','2013-04-11','15:55:00',6),('16100','2013-04-11','16:00:00',5.87),('16100','2013-04-11','16:05:00',5.72),('16100','2013-04-11','16:10:00',4.76),('16100','2013-04-11','16:15:00',4.95),('16100','2013-04-11','16:20:00',5.37),('16100','2013-04-11','16:25:00',5.29),('16100','2013-04-11','16:30:00',5.01),('16100','2013-04-11','16:35:00',5.07),('16100','2013-04-11','16:40:00',5.02),('16100','2013-04-11','16:45:00',4.08),('16100','2013-04-11','16:50:00',4.38),('16100','2013-04-11','16:55:00',4.35),('16100','2013-04-11','17:00:00',3.82),('16100','2013-04-11','17:05:00',3.19),('16100','2013-04-11','17:10:00',2.72),('16100','2013-04-11','17:15:00',4.3),('16100','2013-04-11','17:20:00',4.01),('16100','2013-04-11','17:25:00',2.91),('16100','2013-04-11','17:30:00',4.03),('16100','2013-04-11','17:35:00',3.25),('16100','2013-04-11','17:40:00',2.58),('16100','2013-04-11','17:45:00',2.94),('16100','2013-04-11','17:50:00',2.63),('16100','2013-04-11','17:55:00',2.25),('16100','2013-04-11','18:00:00',1.82),('16100','2014-03-27','07:15:00',1.08),('16100','2014-03-27','07:20:00',1.26),('16100','2014-03-27','07:25:00',1.42),('16100','2014-03-27','07:30:00',1.54),('16100','2014-03-27','07:35:00',1.84),('16100','2014-03-27','07:40:00',2.05),('16100','2014-03-27','07:45:00',2.2),('16100','2014-03-27','07:50:00',2.38),('16100','2014-03-27','07:55:00',2.57),('16100','2014-03-27','08:00:00',2.78),('16100','2014-03-27','08:05:00',2.99),('16100','2014-03-27','08:10:00',3.14),('16100','2014-03-27','08:15:00',3.32),('16100','2014-03-27','08:20:00',3.47),('16100','2014-03-27','08:25:00',3.68),('16100','2014-03-27','08:30:00',3.85),('16100','2014-03-27','08:35:00',3.97),('16100','2014-03-27','08:40:00',4.14),('16100','2014-03-27','08:45:00',4.34),('16100','2014-03-27','08:50:00',4.35),('16100','2014-03-27','08:55:00',4.73),('16100','2014-03-27','09:00:00',5.01),('16100','2014-03-27','09:05:00',5.24),('16100','2014-03-27','09:10:00',4.42),('16100','2014-03-27','09:15:00',4.83),('16100','2014-03-27','09:20:00',5.37),('16100','2014-03-27','09:25:00',5.05),('16100','2014-03-27','09:30:00',3.59),('16100','2014-03-27','09:35:00',2.76),('16100','2014-03-27','09:40:00',4.13),('16100','2014-03-27','09:45:00',5.76),('16100','2014-03-27','09:50:00',6.11),('16100','2014-03-27','09:55:00',6.3),('16100','2014-03-27','10:00:00',6.2),('16100','2014-03-27','10:05:00',4.52),('16100','2014-03-27','10:10:00',3.85),('16100','2014-03-27','10:15:00',6.31),('16100','2014-03-27','10:20:00',6.33),('16100','2014-03-27','10:25:00',6.14),('16100','2014-03-27','10:30:00',5.36),('16100','2014-03-27','10:35:00',5.59),('16100','2014-03-27','10:40:00',7.1),('16100','2014-03-27','10:45:00',7.13),('16100','2014-03-27','10:50:00',7.12),('16100','2014-03-27','10:55:00',7.15),('16100','2014-03-27','11:00:00',7.15),('16100','2014-03-27','11:05:00',7.29),('16100','2014-03-27','11:10:00',6.6),('16100','2014-03-27','11:15:00',1.79),('16100','2014-03-27','11:20:00',2.65),('16100','2014-03-27','11:25:00',5.3),('16100','2014-03-27','11:30:00',7.9),('16100','2014-03-27','11:35:00',7.78),('16100','2014-03-27','11:40:00',7.78),('16100','2014-03-27','11:45:00',5.91),('16100','2014-03-27','11:50:00',8.07),('16100','2014-03-27','11:55:00',8.18),('16100','2014-03-27','12:00:00',7.92),('16100','2014-03-27','12:05:00',3.97),('16100','2014-03-27','12:10:00',4.85),('16100','2014-03-27','12:15:00',6.64),('16100','2014-03-27','12:20:00',3.78),('16100','2014-03-27','12:25:00',8.58),('16100','2014-03-27','12:30:00',6.45),('16100','2014-03-27','12:35:00',2.76),('16100','2014-03-27','12:40:00',4.79),('16100','2014-03-27','12:45:00',1.83),('16100','2014-03-27','12:50:00',5.3),('16100','2014-03-27','12:55:00',6.47),('16100','2014-03-27','13:00:00',6.58),('16100','2014-03-27','13:05:00',9.45),('16100','2014-03-27','13:10:00',8.1),('16100','2014-03-27','13:15:00',4.8),('16100','2014-03-27','13:20:00',4.4),('16100','2014-03-27','13:25:00',3.41),('16100','2014-03-27','13:30:00',3.65),('16100','2014-03-27','13:35:00',8.12),('16100','2014-03-27','13:40:00',7.51),('16100','2014-03-27','13:45:00',7.34),('16100','2014-03-27','13:50:00',6.96),('16100','2014-03-27','13:55:00',7),('16100','2014-03-27','14:00:00',7.09),('16100','2014-03-27','14:05:00',6.86),('16100','2014-03-27','14:10:00',6.79),('16100','2014-03-27','14:15:00',6.73),('16100','2014-03-27','14:20:00',6.61),('16100','2014-03-27','14:25:00',6.47),('16100','2014-03-27','14:30:00',6.41),('16100','2014-03-27','14:35:00',6.32),('16100','2014-03-27','14:40:00',6.25),('16100','2014-03-27','14:45:00',6.12),('16100','2014-03-27','14:50:00',6.01),('16100','2014-03-27','14:55:00',5.97),('16100','2014-03-27','15:00:00',5.85),('16100','2014-03-27','15:05:00',5.68),('16100','2014-03-27','15:10:00',5.44),('16100','2014-03-27','15:15:00',5.34),('16100','2014-03-27','15:20:00',5.25),('16100','2014-03-27','15:25:00',5.11),('16100','2014-03-27','15:30:00',4.99),('16100','2014-03-27','15:35:00',4.98),('16100','2014-03-27','15:40:00',4.77),('16100','2014-03-27','15:45:00',4.7),('16100','2014-03-27','15:50:00',4.17),('16100','2014-03-27','15:55:00',4.72),('16100','2014-03-27','16:00:00',4.85),('16100','2014-03-27','16:05:00',4.77),('16100','2014-03-27','16:10:00',4.29),('16100','2014-03-27','16:15:00',3.79),('16100','2014-03-27','16:20:00',3.03),('16100','2014-03-27','16:25:00',2.55),('16100','2014-03-27','16:30:00',1.41),('16100','2014-03-27','16:35:00',1.85),('16100','2014-03-27','16:40:00',1.1),('16100','2014-03-27','16:45:00',2.06),('16100','2014-03-27','16:50:00',1.43),('16100','2014-03-27','16:55:00',2.21),('16100','2014-03-27','17:00:00',1.96),('16100','2014-03-27','17:05:00',1.74),('16100','2014-03-27','17:10:00',1.65),('16100','2014-03-27','17:15:00',1.11),('16100','2014-03-27','17:25:00',1.33),('16100','2014-03-27','17:30:00',1.06),('16100','2013-04-10','08:05:00',1.21),('16100','2013-04-10','08:10:00',1.45),('16100','2013-04-10','08:15:00',1.65),('16100','2013-04-10','08:20:00',1.83),('16100','2013-04-10','08:25:00',2.02),('16100','2013-04-10','08:30:00',2.2),('16100','2013-04-10','08:35:00',2.38),('16100','2013-04-10','08:40:00',2.6),('16100','2013-04-10','08:45:00',2.77),('16100','2013-04-10','08:50:00',2.96),('16100','2013-04-10','08:55:00',3.16),('16100','2013-04-10','09:00:00',3.33),('16100','2013-04-10','09:05:00',3.48),('16100','2013-04-10','09:10:00',3.67),('16100','2013-04-10','09:15:00',3.86),('16100','2013-04-10','09:20:00',4),('16100','2013-04-10','09:25:00',4.15),('16100','2013-04-10','09:30:00',4.33),('16100','2013-04-10','09:35:00',4.55),('16100','2013-04-10','09:40:00',4.66),('16100','2013-04-10','09:45:00',4.95),('16100','2013-04-10','09:50:00',5.12),('16100','2013-04-10','09:55:00',4.63),('16100','2013-04-10','10:00:00',5.84),('16100','2013-04-10','10:05:00',6.19),('16100','2013-04-10','10:10:00',6.12),('16100','2013-04-10','10:15:00',5.88),('16100','2013-04-10','10:20:00',3.49),('16100','2013-04-10','10:25:00',2.21),('16100','2013-04-10','10:30:00',1.8),('16100','2013-04-10','10:35:00',1.72),('16100','2013-04-10','10:40:00',4.35),('16100','2013-04-10','10:45:00',2.27),('16100','2013-04-10','10:50:00',2.81),('16100','2013-04-10','10:55:00',4.11),('16100','2013-04-10','11:00:00',6.01),('16100','2013-04-10','11:05:00',2.66),('16100','2013-04-10','11:10:00',1.51),('16100','2013-04-10','11:15:00',1.54),('16100','2013-04-10','11:20:00',8.11),('16100','2013-04-10','11:25:00',6.25),('16100','2013-04-10','11:30:00',5.9),('16100','2013-04-10','11:35:00',4.69),('16100','2013-04-10','11:40:00',2.19),('16100','2013-04-10','11:45:00',1.57),('16100','2013-04-10','11:50:00',1.88),('16100','2013-04-10','11:55:00',2.2),('16100','2013-04-10','12:00:00',3.22),('16100','2013-04-10','12:05:00',3.17),('16100','2013-04-10','12:10:00',1.81),('16100','2013-04-10','12:15:00',1.63),('16100','2013-04-10','12:20:00',7.22),('16100','2013-04-10','12:25:00',7.41),('16100','2013-04-10','12:30:00',7.86),('16100','2013-04-10','12:35:00',5.54),('16100','2013-04-10','12:40:00',6.16),('16100','2013-04-10','12:45:00',8.07),('16100','2013-04-10','12:50:00',5.25),('16100','2013-04-10','12:55:00',4.5),('16100','2013-04-10','13:00:00',8.62),('16100','2013-04-10','13:05:00',8.64),('16100','2013-04-10','13:10:00',7.78),('16100','2013-04-10','13:15:00',2.8),('16100','2013-04-10','13:20:00',8.92),('16100','2013-04-10','13:25:00',8.61),('16100','2013-04-10','13:30:00',7.16),('16100','2013-04-10','13:35:00',3.71),('16100','2013-04-10','13:40:00',8.75),('16100','2013-04-10','13:45:00',7.63),('16100','2013-04-10','13:50:00',7.26),('16100','2013-04-10','13:55:00',8.44),('16100','2013-04-10','14:00:00',8.04),('16100','2013-04-10','14:05:00',7.61),('16100','2013-04-10','14:10:00',3.21),('16100','2013-04-10','14:15:00',1.77),('16100','2013-04-10','14:20:00',1.82),('16100','2013-04-10','14:25:00',7.13),('16100','2013-04-10','14:30:00',8.14),('16100','2013-04-10','14:35:00',7.26),('16100','2013-04-10','14:40:00',7.9),('16100','2013-04-10','14:45:00',4),('16100','2013-04-10','14:50:00',7.74),('16100','2013-04-10','14:55:00',7.47),('16100','2013-04-10','15:00:00',7.35),('16100','2013-04-10','15:05:00',7.19),('16100','2013-04-10','15:10:00',7.12),('16100','2013-04-10','15:15:00',6.96),('16100','2013-04-10','15:20:00',6.84),('16100','2013-04-10','15:25:00',6.75),('16100','2013-04-10','15:30:00',6.61),('16100','2013-04-10','15:35:00',6.57),('16100','2013-04-10','15:40:00',6.49),('16100','2013-04-10','15:45:00',6.35),('16100','2013-04-10','15:50:00',6.26),('16100','2013-04-10','15:55:00',5.72),('16100','2013-04-10','16:00:00',5.89),('16100','2013-04-10','16:05:00',5.87),('16100','2013-04-10','16:10:00',5.64),('16100','2013-04-10','16:15:00',5.56),('16100','2013-04-10','16:20:00',5.43),('16100','2013-04-10','16:25:00',5.34),('16100','2013-04-10','16:30:00',5.21),('16100','2013-04-10','16:35:00',5.09),('16100','2013-04-10','16:40:00',4.94),('16100','2013-04-10','16:45:00',4.77),('16100','2013-04-10','16:50:00',4.58),('16100','2013-04-10','16:55:00',4.35),('16100','2013-04-10','17:00:00',4.18),('16100','2013-04-10','17:05:00',4.04),('16100','2013-04-10','17:10:00',3.89),('16100','2013-04-10','17:15:00',3.72),('16100','2013-04-10','17:20:00',3.54),('16100','2013-04-10','17:25:00',3.36),('16100','2013-04-10','17:30:00',3.19),('16100','2013-04-10','17:35:00',3.03),('16100','2013-04-10','17:40:00',2.82),('16100','2013-04-10','17:45:00',2.65),('16100','2013-04-10','17:50:00',2.47),('16100','2013-04-10','17:55:00',2.25),('16100','2013-04-10','18:00:00',1.92),('16100','2013-04-10','18:05:00',1.76),('16100','2013-04-10','18:10:00',1.56),('16100','2013-04-10','18:15:00',1.57),('16100','2013-04-10','18:20:00',1.46),('16100','2013-04-10','18:25:00',1.31),('16100','2013-04-10','18:30:00',1.07),('16100','2013-04-09','08:35:00',1.36),('16100','2013-04-09','08:40:00',3.17),('16100','2013-04-09','08:45:00',3.43),('16100','2013-04-09','08:50:00',3.16),('16100','2013-04-09','08:55:00',3.35),('16100','2013-04-09','09:00:00',3.61),('16100','2013-04-09','09:05:00',3.03),('16100','2013-04-09','09:10:00',2.88),('16100','2013-04-09','09:15:00',3.5),('16100','2013-04-09','09:20:00',4.24),('16100','2013-04-09','09:25:00',4.32),('16100','2013-04-09','09:30:00',4.51),('16100','2013-04-09','09:35:00',4.7),('16100','2013-04-09','09:40:00',4.34),('16100','2013-04-09','09:45:00',4.98),('16100','2013-04-09','09:50:00',5.47),('16100','2013-04-09','09:55:00',5.62),('16100','2013-04-09','10:00:00',5.73),('16100','2013-04-09','10:05:00',5.78),('16100','2013-04-09','10:10:00',5.86),('16100','2013-04-09','10:15:00',5.98),('16100','2013-04-09','10:20:00',6.17),('16100','2013-04-09','10:25:00',6.31),('16100','2013-04-09','10:30:00',6.41),('16100','2013-04-09','10:35:00',6.5),('16100','2013-04-09','10:40:00',6.8),('16100','2013-04-09','10:45:00',5.97),('16100','2013-04-09','10:50:00',6.85),('16100','2013-04-09','10:55:00',7.09),('16100','2013-04-09','11:00:00',7.37),('16100','2013-04-09','11:05:00',5.88),('16100','2013-04-09','11:10:00',5.49),('16100','2013-04-09','11:15:00',6.44),('16100','2013-04-09','11:20:00',4.66),('16100','2013-04-09','11:25:00',7.55),('16100','2013-04-09','11:30:00',7.35),('16100','2013-04-09','11:35:00',8.14),('16100','2013-04-09','11:40:00',7.95),('16100','2013-04-09','11:45:00',5.77),('16100','2013-04-09','11:50:00',4.33),('16100','2013-04-09','11:55:00',5.26),('16100','2013-04-09','12:00:00',6.14),('16100','2013-04-09','12:05:00',3.72),('16100','2013-04-09','12:10:00',2.26),('16100','2013-04-09','12:15:00',1.63),('16100','2013-04-09','12:20:00',3.01),('16100','2013-04-09','12:25:00',9.39),('16100','2013-04-09','12:30:00',5.37),('16100','2013-04-09','12:35:00',9.08),('16100','2013-04-09','12:40:00',7.74),('16100','2013-04-09','12:45:00',8.79),('16100','2013-04-09','12:50:00',8.57),('16100','2013-04-09','12:55:00',5.74),('16100','2013-04-09','13:00:00',2.87),('16100','2013-04-09','13:05:00',2.14),('16100','2013-04-09','13:10:00',6.42),('16100','2013-04-09','13:15:00',8.77),('16100','2013-04-09','13:20:00',7.68),('16100','2013-04-09','13:25:00',8.3),('16100','2013-04-09','13:30:00',8.94),('16100','2013-04-09','13:35:00',9.08),('16100','2013-04-09','13:40:00',8.71),('16100','2013-04-09','13:45:00',6.54),('16100','2013-04-09','13:50:00',8.75),('16100','2013-04-09','13:55:00',3.91),('16100','2013-04-09','14:00:00',9.3),('16100','2013-04-09','14:05:00',5.43),('16100','2013-04-09','14:10:00',8.65),('16100','2013-04-09','14:15:00',7.76),('16100','2013-04-09','14:20:00',7),('16100','2013-04-09','14:25:00',7.62),('16100','2013-04-09','14:30:00',6.17),('16100','2013-04-09','14:35:00',4.41),('16100','2013-04-09','14:40:00',6.26),('16100','2013-04-09','14:45:00',5.9),('16100','2013-04-09','14:50:00',6.88),('16100','2013-04-09','14:55:00',3.97),('16100','2013-04-09','15:00:00',3.25),('16100','2013-04-09','15:05:00',7.1),('16100','2013-04-09','15:10:00',5.3),('16100','2013-04-09','15:15:00',7.18),('16100','2013-04-09','15:20:00',5.71),('16100','2013-04-09','15:25:00',6.91),('16100','2013-04-09','15:30:00',6.81),('16100','2013-04-09','15:35:00',6.59),('16100','2013-04-09','15:40:00',6.57),('16100','2013-04-09','15:45:00',6.63),('16100','2013-04-09','15:50:00',6.37),('16100','2013-04-09','15:55:00',6.15),('16100','2013-04-09','16:00:00',5.99),('16100','2013-04-09','16:05:00',5.9),('16100','2013-04-09','16:10:00',5.66),('16100','2013-04-09','16:15:00',5.31),('16100','2013-04-09','16:20:00',4.7),('16100','2013-04-09','16:25:00',4.98),('16100','2013-04-09','16:30:00',5.21),('16100','2013-04-09','16:35:00',4.64),('16100','2013-04-09','16:40:00',2.71),('16100','2013-04-09','16:45:00',4.26),('16100','2013-04-09','16:50:00',4.66),('16100','2013-04-09','16:55:00',4.28),('16100','2013-04-09','17:00:00',2.97),('16100','2013-04-09','17:05:00',1.39),('16100','2013-04-09','17:10:00',1.36),('16100','2013-04-09','17:15:00',1),('16100','2013-04-08','08:05:00',1.17),('16100','2013-04-08','08:10:00',1.42),('16100','2013-04-08','08:15:00',1.84),('16100','2013-04-08','08:20:00',2.49),('16100','2013-04-08','08:25:00',1.9),('16100','2013-04-08','08:30:00',1.26),('16100','2013-04-08','08:35:00',1.29),('16100','2013-04-08','08:40:00',1.15),('16100','2013-04-08','08:45:00',1.82),('16100','2013-04-08','08:50:00',3.03),('16100','2013-04-08','08:55:00',2.86),('16100','2013-04-08','09:00:00',2.23),('16100','2013-04-08','09:05:00',1.49),('16100','2013-04-08','09:10:00',1.59),('16100','2013-04-08','09:15:00',1.48),('16100','2013-04-08','09:20:00',1.47),('16100','2013-04-08','09:25:00',2.29),('16100','2013-04-08','09:30:00',3.49),('16100','2013-04-08','09:35:00',2.68),('16100','2013-04-08','09:40:00',1.74),('16100','2013-04-08','09:45:00',1.72),('16100','2013-04-08','09:50:00',3.13),('16100','2013-04-08','09:55:00',3.42),('16100','2013-04-08','10:00:00',3.78),('16100','2013-04-08','10:05:00',2.17),('16100','2013-04-08','10:10:00',1.74),('16100','2013-04-08','10:15:00',1.97),('16100','2013-04-08','10:20:00',4.31),('16100','2013-04-08','10:25:00',7.44),('16100','2013-04-08','10:30:00',3.95),('16100','2013-04-08','10:35:00',6),('16100','2013-04-08','10:40:00',6.29),('16100','2013-04-08','10:45:00',3.75),('16100','2013-04-08','10:50:00',7.77),('16100','2013-04-08','10:55:00',7.52),('16100','2013-04-08','11:00:00',4.57),('16100','2013-04-08','11:05:00',3.75),('16100','2013-04-08','11:10:00',6.09),('16100','2013-04-08','11:15:00',6.45),('16100','2013-04-08','11:20:00',6.7),('16100','2013-04-08','11:25:00',6.66),('16100','2013-04-08','11:30:00',8.33),('16100','2013-04-08','11:35:00',4.7),('16100','2013-04-08','11:40:00',8.65),('16100','2013-04-08','11:45:00',4.02),('16100','2013-04-08','11:50:00',6.89),('16100','2013-04-08','11:55:00',6.44),('16100','2013-04-08','12:00:00',8.81),('16100','2013-04-08','12:05:00',8.8),('16100','2013-04-08','12:10:00',8.58),('16100','2013-04-08','12:15:00',5.17),('16100','2013-04-08','12:20:00',6.32),('16100','2013-04-08','12:25:00',7.7),('16100','2013-04-08','12:30:00',9.25),('16100','2013-04-08','12:35:00',8.19),('16100','2013-04-08','12:40:00',8.51),('16100','2013-04-08','12:45:00',6.99),('16100','2013-04-08','12:50:00',7.08),('16100','2013-04-08','12:55:00',9.27),('16100','2013-04-08','13:00:00',2.49),('16100','2013-04-08','13:05:00',5.89),('16100','2013-04-08','13:10:00',5.13),('16100','2013-04-08','13:15:00',4.11),('16100','2013-04-08','13:20:00',4.6),('16100','2013-04-08','13:25:00',2.66),('16100','2013-04-08','13:30:00',3.47),('16100','2013-04-08','13:35:00',7.81),('16100','2013-04-08','13:40:00',6.99),('16100','2013-04-08','13:45:00',7.12),('16100','2013-04-08','13:50:00',7.17),('16100','2013-04-08','13:55:00',8.13),('16100','2013-04-08','14:00:00',7.71),('16100','2013-04-08','14:05:00',7.82),('16100','2013-04-08','14:10:00',7.74),('16100','2013-04-08','14:15:00',7.18),('16100','2013-04-08','14:20:00',6.54),('16100','2013-04-08','14:25:00',6.73),('16100','2013-04-08','14:30:00',7.1),('16100','2013-04-08','14:35:00',7.14),('16100','2013-04-08','14:40:00',7.11),('16100','2013-04-08','14:45:00',6.53),('16100','2013-04-08','14:50:00',5.58),('16100','2013-04-08','14:55:00',6.7),('16100','2013-04-08','15:00:00',7.75),('16100','2013-04-08','15:05:00',6.99),('16100','2013-04-08','15:10:00',7.27),('16100','2013-04-08','15:15:00',7.07),('16100','2013-04-08','15:20:00',7.04),('16100','2013-04-08','15:25:00',7.07),('16100','2013-04-08','15:30:00',5.75),('16100','2013-04-08','15:35:00',6.69),('16100','2013-04-08','15:40:00',6.82),('16100','2013-04-08','15:45:00',6.64),('16100','2013-04-08','15:50:00',6.27),('16100','2013-04-08','15:55:00',5.29),('16100','2013-04-08','16:00:00',5.53),('16100','2013-04-08','16:05:00',6.29),('16100','2013-04-08','16:10:00',5.89),('16100','2013-04-08','16:15:00',5.33),('16100','2013-04-08','16:20:00',5.3),('16100','2013-04-08','16:25:00',5.32),('16100','2013-04-08','16:30:00',4.72),('16100','2013-04-08','16:35:00',4.59),('16100','2013-04-08','16:40:00',4.17),('16100','2013-04-08','16:45:00',4.5),('16100','2013-04-08','16:50:00',3.61),('16100','2013-04-08','16:55:00',3.62),('16100','2013-04-08','17:00:00',4.85),('16100','2013-04-08','17:05:00',5.18),('16100','2013-04-08','17:10:00',4.63),('16100','2013-04-08','17:15:00',4.21),('16100','2013-04-08','17:20:00',4.04),('16100','2013-04-08','17:25:00',3.46),('16100','2013-04-08','17:30:00',2.96),('16100','2013-04-08','17:35:00',2.44),('16100','2013-04-08','17:40:00',1.84),('16100','2013-04-08','17:45:00',1.34),('16100','2013-04-08','17:50:00',1.12),('16100','2013-04-08','17:55:00',1.32),('16100','2013-04-08','18:00:00',1.58),('16100','2013-04-08','18:05:00',1.4),('16100','2013-04-08','18:10:00',1.3),('16100','2013-04-08','18:15:00',1.88),('16100','2013-04-07','08:10:00',1.02),('16100','2013-04-07','08:20:00',1.41),('16100','2013-04-07','08:25:00',1.35),('16100','2013-04-07','08:30:00',1.43),('16100','2013-04-07','08:40:00',1.61),('16100','2013-04-07','08:45:00',1.72),('16100','2013-04-07','08:50:00',1.97),('16100','2013-04-07','08:55:00',2.9),('16100','2013-04-07','09:00:00',1.65),('16100','2013-04-07','09:05:00',2.74),('16100','2013-04-07','09:10:00',2.09),('16100','2013-04-07','09:15:00',3.26),('16100','2013-04-07','09:20:00',2.59),('16100','2013-04-07','09:25:00',3.01),('16100','2013-04-07','09:30:00',4.71),('16100','2013-04-07','09:35:00',5.06),('16100','2013-04-07','09:40:00',5.03),('16100','2013-04-07','09:45:00',5.09),('16100','2013-04-07','09:50:00',2.41),('16100','2013-04-07','09:55:00',4.02),('16100','2013-04-07','10:00:00',5.38),('16100','2013-04-07','10:05:00',4.52),('16100','2013-04-07','10:10:00',4.86),('16100','2013-04-07','10:15:00',5.81),('16100','2013-04-07','10:20:00',5.91),('16100','2013-04-07','10:25:00',5.75),('16100','2013-04-07','10:30:00',5.88),('16100','2013-04-07','10:35:00',6.12),('16100','2013-04-07','10:40:00',6.57),('16100','2013-04-07','10:45:00',6.61),('16100','2013-04-07','10:50:00',6.5),('16100','2013-04-07','10:55:00',6.49),('16100','2013-04-07','11:00:00',5.7),('16100','2013-04-07','11:05:00',5.47),('16100','2013-04-07','11:10:00',5.39),('16100','2013-04-07','11:15:00',4.79),('16100','2013-04-07','11:20:00',3.8),('16100','2013-04-07','11:25:00',3.82),('16100','2013-04-07','11:30:00',4.36),('16100','2013-04-07','11:35:00',5.45),('16100','2013-04-07','11:40:00',4.65),('16100','2013-04-07','11:45:00',4.5),('16100','2013-04-07','11:50:00',4.4),('16100','2013-04-07','11:55:00',4.63),('16100','2013-04-07','12:00:00',3.98),('16100','2013-04-07','12:05:00',4.01),('16100','2013-04-07','12:10:00',4.76),('16100','2013-04-07','12:15:00',5.21),('16100','2013-04-07','12:20:00',5.15),('16100','2013-04-07','12:25:00',5.39),('16100','2013-04-07','12:30:00',5.5),('16100','2013-04-07','12:35:00',5.94),('16100','2013-04-07','12:40:00',5.36),('16100','2013-04-07','12:45:00',5.12),('16100','2013-04-07','12:50:00',4.95),('16100','2013-04-07','12:55:00',5.04),('16100','2013-04-07','13:00:00',6.19),('16100','2013-04-07','13:05:00',5.77),('16100','2013-04-07','13:10:00',6.35),('16100','2013-04-07','13:15:00',4.93),('16100','2013-04-07','13:20:00',6.85),('16100','2013-04-07','13:25:00',6.64),('16100','2013-04-07','13:30:00',4.37),('16100','2013-04-07','13:35:00',7.27),('16100','2013-04-07','13:40:00',5.18),('16100','2013-04-07','13:45:00',7.37),('16100','2013-04-07','13:50:00',5.73),('16100','2013-04-07','13:55:00',6.75),('16100','2013-04-07','14:00:00',6.72),('16100','2013-04-07','14:05:00',6.84),('16100','2013-04-07','14:10:00',7.8),('16100','2013-04-07','14:15:00',5.87),('16100','2013-04-07','14:20:00',6.57),('16100','2013-04-07','14:25:00',6.97),('16100','2013-04-07','14:30:00',6.92),('16100','2013-04-07','14:35:00',6.95),('16100','2013-04-07','14:40:00',6.81),('16100','2013-04-07','14:45:00',7.32),('16100','2013-04-07','14:50:00',7.41),('16100','2013-04-07','14:55:00',6.9),('16100','2013-04-07','15:00:00',6.12),('16100','2013-04-07','15:05:00',7.04),('16100','2013-04-07','15:10:00',6.28),('16100','2013-04-07','15:15:00',5.91),('16100','2013-04-07','15:20:00',6.71),('16100','2013-04-07','15:25:00',6.92),('16100','2013-04-07','15:30:00',6.76),('16100','2013-04-07','15:35:00',6.64),('16100','2013-04-07','15:40:00',6.51),('16100','2013-04-07','15:45:00',6.35),('16100','2013-04-07','15:50:00',6.29),('16100','2013-04-07','15:55:00',6.04),('16100','2013-04-07','16:00:00',6.04),('16100','2013-04-07','16:05:00',5.56),('16100','2013-04-07','16:10:00',5.48),('16100','2013-04-07','16:15:00',5.72),('16100','2013-04-07','16:20:00',5.51),('16100','2013-04-07','16:25:00',5.29),('16100','2013-04-07','16:30:00',5.26),('16100','2013-04-07','16:35:00',5.09),('16100','2013-04-07','16:40:00',4.95),('16100','2013-04-07','16:45:00',4.82),('16100','2013-04-07','16:50:00',4.64),('16100','2013-04-07','16:55:00',4.42),('16100','2013-04-07','17:00:00',4.3),('16100','2013-04-07','17:05:00',4.16),('16100','2013-04-07','17:10:00',4.01),('16100','2013-04-07','17:15:00',3.8),('16100','2013-04-07','17:20:00',3.58),('16100','2013-04-07','17:25:00',3.56),('16100','2013-04-07','17:30:00',3.23),('16100','2013-04-07','17:35:00',3.04),('16100','2013-04-07','17:40:00',2.49),('16100','2013-04-07','17:45:00',2.49),('16100','2013-04-07','17:50:00',1.83),('16100','2013-04-07','17:55:00',1.78),('16100','2013-04-07','18:00:00',1.87),('16100','2013-04-07','18:10:00',1.08),('16100','2013-04-07','18:15:00',1.73),('16100','2013-04-07','18:20:00',2.1),('16100','2013-04-07','18:25:00',1.58),('16100','2013-04-06','08:20:00',1.1),('16100','2013-04-06','08:25:00',1.27),('16100','2013-04-06','08:30:00',1.47),('16100','2013-04-06','08:35:00',1.61),('16100','2013-04-06','08:40:00',1.86),('16100','2013-04-06','08:45:00',2.11),('16100','2013-04-06','08:50:00',2.23),('16100','2013-04-06','08:55:00',2.35),('16100','2013-04-06','09:00:00',2.34),('16100','2013-04-06','09:05:00',2.34),('16100','2013-04-06','09:10:00',2.24),('16100','2013-04-06','09:15:00',2.36),('16100','2013-04-06','09:20:00',2.5),('16100','2013-04-06','09:25:00',2.9),('16100','2013-04-06','09:30:00',3.16),('16100','2013-04-06','09:35:00',3.4),('16100','2013-04-06','09:40:00',3.33),('16100','2013-04-06','09:45:00',3.44),('16100','2013-04-06','09:50:00',3.16),('16100','2013-04-06','09:55:00',2.96),('16100','2013-04-06','10:00:00',3.58),('16100','2013-04-06','10:05:00',3.91),('16100','2013-04-06','10:10:00',4.17),('16100','2013-04-06','10:15:00',4.94),('16100','2013-04-06','10:20:00',5.2),('16100','2013-04-06','10:25:00',5.2),('16100','2013-04-06','10:30:00',5.36),('16100','2013-04-06','10:35:00',5.63),('16100','2013-04-06','10:40:00',5.15),('16100','2013-04-06','10:45:00',4.96),('16100','2013-04-06','10:50:00',4.97),('16100','2013-04-06','10:55:00',3.84),('16100','2013-04-06','11:00:00',4.6),('16100','2013-04-06','11:05:00',4.49),('16100','2013-04-06','11:10:00',4),('16100','2013-04-06','11:15:00',3.64),('16100','2013-04-06','11:20:00',3.65),('16100','2013-04-06','11:25:00',4.28),('16100','2013-04-06','11:30:00',5.97),('16100','2013-04-06','11:35:00',7.19),('16100','2013-04-06','11:40:00',7.47),('16100','2013-04-06','11:45:00',7.15),('16100','2013-04-06','11:50:00',6.79),('16100','2013-04-06','11:55:00',5.63),('16100','2013-04-06','12:00:00',4.7),('16100','2013-04-06','12:05:00',4.84),('16100','2013-04-06','12:10:00',4.8),('16100','2013-04-06','12:15:00',4.79),('16100','2013-04-06','12:20:00',5.63),('16100','2013-04-06','12:25:00',5.17),('16100','2013-04-06','12:30:00',5.92),('16100','2013-04-06','12:35:00',6.01),('16100','2013-04-06','12:40:00',5.78),('16100','2013-04-06','12:45:00',5.79),('16100','2013-04-06','12:50:00',5.63),('16100','2013-04-06','12:55:00',4.74),('16100','2013-04-06','13:00:00',5.37),('16100','2013-04-06','13:05:00',5.3),('16100','2013-04-06','13:10:00',6.02),('16100','2013-04-06','13:15:00',5.96),('16100','2013-04-06','13:20:00',5.92),('16100','2013-04-06','13:25:00',5.5),('16100','2013-04-06','13:30:00',5.63),('16100','2013-04-06','13:35:00',5.91),('16100','2013-04-06','13:40:00',6.56),('16100','2013-04-06','13:45:00',6.46),('16100','2013-04-06','13:50:00',5.92),('16100','2013-04-06','13:55:00',5.24),('16100','2013-04-06','14:00:00',4.92),('16100','2013-04-06','14:05:00',5.04),('16100','2013-04-06','14:10:00',5.73),('16100','2013-04-06','14:15:00',6.46),('16100','2013-04-06','14:20:00',6.12),('16100','2013-04-06','14:25:00',5.58),('16100','2013-04-06','14:30:00',4.83),('16100','2013-04-06','14:35:00',4.41),('16100','2013-04-06','14:40:00',4.06),('16100','2013-04-06','14:45:00',3.37),('16100','2013-04-06','14:50:00',2.63),('16100','2013-04-06','14:55:00',2.92),('16100','2013-04-06','15:00:00',3.53),('16100','2013-04-06','15:05:00',3.23),('16100','2013-04-06','15:10:00',3.74),('16100','2013-04-06','15:15:00',3.72),('16100','2013-04-06','15:20:00',4.44),('16100','2013-04-06','15:25:00',4.83),('16100','2013-04-06','15:30:00',4.94),('16100','2013-04-06','15:35:00',4.81),('16100','2013-04-06','15:40:00',4.76),('16100','2013-04-06','15:45:00',4.57),('16100','2013-04-06','15:50:00',3.52),('16100','2013-04-06','15:55:00',3.31),('16100','2013-04-06','16:00:00',2.54),('16100','2013-04-06','16:05:00',2.39),('16100','2013-04-06','16:10:00',2.15),('16100','2013-04-06','16:15:00',2.41),('16100','2013-04-06','16:20:00',2.14),('16100','2013-04-06','16:25:00',2.41),('16100','2013-04-06','16:30:00',2.01),('16100','2013-04-06','16:35:00',1.97),('16100','2013-04-06','16:40:00',2.13),('16100','2013-04-06','16:45:00',2.24),('16100','2013-04-06','16:50:00',3.08),('16100','2013-04-06','16:55:00',2.58),('16100','2013-04-06','17:00:00',2),('16100','2013-04-06','17:05:00',1.74),('16100','2013-04-06','17:10:00',2.4),('16100','2013-04-06','17:15:00',3.33),('16100','2013-04-06','17:20:00',3.97),('16100','2013-04-06','17:25:00',3.65),('16100','2013-04-06','17:30:00',3.36),('16100','2013-04-06','17:35:00',3.13),('16100','2013-04-06','17:40:00',2.77),('16100','2013-04-06','17:45:00',2.6),('16100','2013-04-06','17:50:00',2.1),('16100','2013-04-06','18:05:00',1.03),('16100','2013-04-05','08:05:00',1.14),('16100','2013-04-05','08:10:00',1.33),('16100','2013-04-05','08:15:00',1.51),('16100','2013-04-05','08:20:00',1.61),('16100','2013-04-05','08:25:00',1.9),('16100','2013-04-05','08:30:00',2.07),('16100','2013-04-05','08:35:00',2.27),('16100','2013-04-05','08:40:00',2.47),('16100','2013-04-05','08:45:00',2.69),('16100','2013-04-05','08:50:00',2.86),('16100','2013-04-05','08:55:00',3.03),('16100','2013-04-05','09:00:00',3.25),('16100','2013-04-05','09:05:00',3.44),('16100','2013-04-05','09:10:00',3.59),('16100','2013-04-05','09:15:00',3.75),('16100','2013-04-05','09:20:00',3.9),('16100','2013-04-05','09:25:00',4.12),('16100','2013-04-05','09:30:00',4.27),('16100','2013-04-05','09:35:00',4.42),('16100','2013-04-05','09:40:00',4.44),('16100','2013-04-05','09:45:00',4.72),('16100','2013-04-05','09:50:00',4.89),('16100','2013-04-05','09:55:00',5.03),('16100','2013-04-05','10:00:00',5.21),('16100','2013-04-05','10:05:00',5.38),('16100','2013-04-05','10:10:00',5.51),('16100','2013-04-05','10:15:00',4.69),('16100','2013-04-05','10:20:00',1.61),('16100','2013-04-05','10:25:00',6.16),('16100','2013-04-05','10:30:00',6.11),('16100','2013-04-05','10:35:00',6.13),('16100','2013-04-05','10:40:00',6.28),('16100','2013-04-05','10:45:00',6.4),('16100','2013-04-05','10:50:00',6.45),('16100','2013-04-05','10:55:00',6.52),('16100','2013-04-05','11:00:00',6.64),('16100','2013-04-05','11:05:00',6.74),('16100','2013-04-05','11:10:00',6.87),('16100','2013-04-05','11:15:00',6.93),('16100','2013-04-05','11:20:00',7.03),('16100','2013-04-05','11:25:00',7.16),('16100','2013-04-05','11:30:00',7.33),('16100','2013-04-05','11:35:00',7.4),('16100','2013-04-05','11:40:00',7.43),('16100','2013-04-05','11:45:00',6.94),('16100','2013-04-05','11:50:00',7.53),('16100','2013-04-05','11:55:00',7.58),('16100','2013-04-05','12:00:00',7.54),('16100','2013-04-05','12:05:00',7.59),('16100','2013-04-05','12:10:00',7.66),('16100','2013-04-05','12:15:00',7.74),('16100','2013-04-05','12:20:00',7.81),('16100','2013-04-05','12:25:00',7.25),('16100','2013-04-05','12:30:00',7.88),('16100','2013-04-05','12:35:00',7.97),('16100','2013-04-05','12:40:00',7.93),('16100','2013-04-05','12:45:00',7.79),('16100','2013-04-05','12:50:00',5.53),('16100','2013-04-05','12:55:00',8.2),('16100','2013-04-05','13:00:00',8.36),('16100','2013-04-05','13:05:00',8.06),('16100','2013-04-05','13:10:00',4.47),('16100','2013-04-05','13:15:00',1.3),('16100','2013-04-05','13:20:00',2.99),('16100','2013-04-05','13:25:00',2.13),('16100','2013-04-05','13:30:00',1.63),('16100','2013-04-05','13:35:00',8.94),('16100','2013-04-05','13:40:00',8.83),('16100','2013-04-05','13:45:00',8.69),('16100','2013-04-05','13:50:00',8.39),('16100','2013-04-05','13:55:00',7.85),('16100','2013-04-05','14:00:00',8.8),('16100','2013-04-05','14:05:00',8.54),('16100','2013-04-05','14:10:00',8.48),('16100','2013-04-05','14:15:00',8.1),('16100','2013-04-05','14:20:00',7.94),('16100','2013-04-05','14:25:00',7.56),('16100','2013-04-05','14:30:00',7.5),('16100','2013-04-05','14:35:00',7.51),('16100','2013-04-05','14:40:00',7.38),('16100','2013-04-05','14:45:00',7.38),('16100','2013-04-05','14:50:00',7.37),('16100','2013-04-05','14:55:00',7.4),('16100','2013-04-05','15:00:00',7.4),('16100','2013-04-05','15:05:00',7.27),('16100','2013-04-05','15:10:00',6.96),('16100','2013-04-05','15:15:00',6.89),('16100','2013-04-05','15:20:00',6.78),('16100','2013-04-05','15:25:00',6.74),('16100','2013-04-05','15:30:00',6.53),('16100','2013-04-05','15:35:00',6.49),('16100','2013-04-05','15:40:00',6.25),('16100','2013-04-05','15:45:00',6.32),('16100','2013-04-05','15:50:00',6.37),('16100','2013-04-05','15:55:00',5.94),('16100','2013-04-05','16:00:00',5.01),('16100','2013-04-05','16:05:00',4.89),('16100','2013-04-05','16:10:00',4.45),('16100','2013-04-05','16:15:00',4.09),('16100','2013-04-05','16:20:00',4.43),('16100','2013-04-05','16:25:00',3.85),('16100','2013-04-05','16:30:00',2.83),('16100','2013-04-05','16:35:00',4.57),('16100','2013-04-05','16:40:00',4.18),('16100','2013-04-05','16:45:00',4.3),('16100','2013-04-05','16:50:00',4.47),('16100','2013-04-05','16:55:00',3.56),('16100','2013-04-05','17:00:00',3.16),('16100','2013-04-05','17:05:00',2.49),('16100','2013-04-05','17:10:00',2.68),('16100','2013-04-05','17:15:00',2.44),('16100','2013-04-05','17:20:00',1.87),('16100','2013-04-05','17:25:00',1.87),('16100','2013-04-05','17:30:00',1.66),('16100','2013-04-05','17:35:00',1.6),('16100','2013-04-05','17:40:00',1.35),('16100','2013-04-05','17:45:00',1.19),('16100','2013-04-05','17:50:00',1.1),('16100','2013-04-05','17:55:00',1.04),('16100','2013-04-04','08:00:00',1.18),('16100','2013-04-04','08:05:00',1.28),('16100','2013-04-04','08:10:00',1.1),('16100','2013-04-04','08:45:00',2.14),('16100','2013-04-04','08:50:00',3.1),('16100','2013-04-04','08:55:00',2.32),('16100','2013-04-04','09:00:00',2.22),('16100','2013-04-04','09:05:00',1.09),('16100','2013-04-04','09:10:00',1.15),('16100','2013-04-04','09:15:00',1.46),('16100','2013-04-04','09:20:00',1.33),('16100','2013-04-04','09:25:00',2.66),('16100','2013-04-04','09:30:00',1.67),('16100','2013-04-04','09:35:00',1.67),('16100','2013-04-04','09:40:00',1.48),('16100','2013-04-04','09:45:00',1.89),('16100','2013-04-04','09:50:00',3.18),('16100','2013-04-04','09:55:00',1.92),('16100','2013-04-04','10:00:00',2.79),('16100','2013-04-04','10:05:00',3.68),('16100','2013-04-04','10:10:00',4.2),('16100','2013-04-04','10:15:00',4.42),('16100','2013-04-04','10:20:00',6.39),('16100','2013-04-04','10:25:00',6.71),('16100','2013-04-04','10:30:00',6.06),('16100','2013-04-04','10:35:00',6.88),('16100','2013-04-04','10:40:00',7.14),('16100','2013-04-04','10:45:00',3.21),('16100','2013-04-04','10:50:00',4.34),('16100','2013-04-04','10:55:00',3.84),('16100','2013-04-04','11:00:00',6.76),('16100','2013-04-04','11:05:00',7.41),('16100','2013-04-04','11:10:00',5.51),('16100','2013-04-04','11:15:00',7.23),('16100','2013-04-04','11:20:00',7.65),('16100','2013-04-04','11:25:00',6.04),('16100','2013-04-04','11:30:00',7.57),('16100','2013-04-04','11:35:00',3.22),('16100','2013-04-04','11:40:00',7.47),('16100','2013-04-04','11:45:00',4.34),('16100','2013-04-04','11:50:00',6.42),('16100','2013-04-04','11:55:00',4.66),('16100','2013-04-04','12:00:00',6.29),('16100','2013-04-04','12:05:00',4.66),('16100','2013-04-04','12:10:00',2.74),('16100','2013-04-04','12:15:00',2.59),('16100','2013-04-04','12:20:00',2.25),('16100','2013-04-04','12:25:00',1.63),('16100','2013-04-04','12:30:00',2.93),('16100','2013-04-04','12:35:00',1.86),('16100','2013-04-04','12:40:00',2.3),('16100','2013-04-04','12:45:00',5.26),('16100','2013-04-04','12:50:00',3.4),('16100','2013-04-04','12:55:00',7.28),('16100','2013-04-04','13:00:00',7.23),('16100','2013-04-04','13:05:00',7.24),('16100','2013-04-04','13:10:00',7.35),('16100','2013-04-04','13:15:00',7.39),('16100','2013-04-04','13:20:00',8.68),('16100','2013-04-04','13:25:00',8.66),('16100','2013-04-04','13:30:00',5.93),('16100','2013-04-04','13:35:00',7.03),('16100','2013-04-04','13:40:00',8.6),('16100','2013-04-04','13:45:00',8.19),('16100','2013-04-04','13:50:00',2.62),('16100','2013-04-04','13:55:00',6.93),('16100','2013-04-04','14:00:00',8.97),('16100','2013-04-04','14:05:00',4.76),('16100','2013-04-04','14:10:00',7.08),('16100','2013-04-04','14:15:00',3.78),('16100','2013-04-04','14:20:00',4.72),('16100','2013-04-04','14:25:00',3.16),('16100','2013-04-04','14:30:00',6.02),('16100','2013-04-04','14:35:00',6.81),('16100','2013-04-04','14:40:00',4.51),('16100','2013-04-04','14:45:00',7.32),('16100','2013-04-04','14:50:00',3.14),('16100','2013-04-04','14:55:00',3.08),('16100','2013-04-04','15:00:00',3.88),('16100','2013-04-04','15:05:00',2.98),('16100','2013-04-04','15:10:00',2.74),('16100','2013-04-04','15:15:00',2.04),('16100','2013-04-04','15:20:00',1.83),('16100','2013-04-04','15:25:00',1.62),('16100','2013-04-04','15:30:00',1.26),('16100','2013-04-04','15:35:00',1.25),('16100','2013-04-04','15:40:00',1.37),('16100','2013-04-04','15:45:00',1.39),('16100','2013-04-04','15:50:00',1.5),('16100','2013-04-04','15:55:00',1.45),('16100','2013-04-04','16:00:00',1.96),('16100','2013-04-04','16:05:00',2.88),('16100','2013-04-04','16:10:00',2.76),('16100','2013-04-04','16:15:00',2.07),('16100','2013-04-04','16:20:00',3.1),('16100','2013-04-04','16:25:00',2.24),('16100','2013-04-04','16:30:00',2.41),('16100','2013-04-04','16:35:00',2.09),('16100','2013-04-04','16:40:00',3.31),('16100','2013-04-04','16:45:00',2.84),('16100','2013-04-04','16:50:00',1.94),('16100','2013-04-04','16:55:00',3.06),('16100','2013-04-04','17:00:00',2.58),('16100','2013-04-04','17:05:00',2.82),('16100','2013-04-04','17:10:00',2.19),('16100','2013-04-04','17:15:00',4.25),('16100','2013-04-04','17:20:00',2.79),('16100','2013-04-04','17:25:00',3.07),('16100','2013-04-04','17:30:00',2.88),('16100','2013-04-04','17:35:00',1.08),('16100','2013-04-04','17:40:00',1.2),('16100','2013-04-04','17:45:00',3.63),('16100','2013-04-04','17:55:00',2.18),('16100','2013-04-04','18:00:00',2.34),('16100','2013-04-04','18:05:00',1.19),('16100','2013-04-04','18:15:00',1.13),('16100','2013-04-04','18:20:00',1.2),('16100','2013-04-03','08:45:00',1.13),('16100','2013-04-03','08:50:00',1.51),('16100','2013-04-03','08:55:00',2.59),('16100','2013-04-03','09:00:00',2.57),('16100','2013-04-03','09:05:00',1.63),('16100','2013-04-03','09:10:00',1.75),('16100','2013-04-03','09:15:00',1.83),('16100','2013-04-03','09:20:00',1.59),('16100','2013-04-03','09:25:00',1.72),('16100','2013-04-03','09:30:00',2.96),('16100','2013-04-03','09:35:00',4.96),('16100','2013-04-03','09:40:00',2.92),('16100','2013-04-03','09:45:00',2.37),('16100','2013-04-03','09:50:00',1.77),('16100','2013-04-03','09:55:00',2.31),('16100','2013-04-03','10:00:00',3.41),('16100','2013-04-03','10:05:00',4.57),('16100','2013-04-03','10:10:00',3.55),('16100','2013-04-03','10:15:00',2.51),('16100','2013-04-03','10:50:00',4.86),('16100','2013-04-03','10:55:00',4.13),('16100','2013-04-03','11:00:00',2.32),('16100','2013-04-03','11:05:00',1.7),('16100','2013-04-03','11:10:00',2.18),('16100','2013-04-03','11:15:00',2.49),('16100','2013-04-03','11:20:00',1.88),('16100','2013-04-03','11:25:00',1.83),('16100','2013-04-03','11:30:00',2.03),('16100','2013-04-03','11:35:00',2.94),('16100','2013-04-03','11:40:00',4.58),('16100','2013-04-03','11:45:00',4.6),('16100','2013-04-03','11:50:00',6.63),('16100','2013-04-03','12:25:00',4.97),('16100','2013-04-03','12:30:00',4.93),('16100','2013-04-03','12:35:00',7.91),('16100','2013-04-03','12:40:00',7.9),('16100','2013-04-03','12:45:00',7.97),('16100','2013-04-03','12:50:00',6.53),('16100','2013-04-03','12:55:00',5.95),('16100','2013-04-03','13:00:00',3.27),('16100','2013-04-03','13:05:00',2.85),('16100','2013-04-03','13:10:00',3.09),('16100','2013-04-03','13:15:00',6.31),('16100','2013-04-03','13:20:00',5.26),('16100','2013-04-03','13:25:00',4.1),('16100','2013-04-03','13:30:00',7.69),('16100','2013-04-03','13:35:00',7.49),('16100','2013-04-03','13:40:00',6.61),('16100','2013-04-03','13:45:00',6.31),('16100','2013-04-03','13:50:00',5.66),('16100','2013-04-03','13:55:00',4.06),('16100','2013-04-03','14:00:00',4.8),('16100','2013-04-03','14:05:00',6.25),('16100','2013-04-03','14:10:00',7.36),('16100','2013-04-03','14:15:00',7.01),('16100','2013-04-03','14:20:00',7.12),('16100','2013-04-03','14:25:00',7.03),('16100','2013-04-03','14:30:00',7.12),('16100','2013-04-03','14:35:00',7.06),('16100','2013-04-03','14:40:00',7.11),('16100','2013-04-03','14:45:00',5.59),('16100','2013-04-03','14:50:00',6.81),('16100','2013-04-03','14:55:00',6.79),('16100','2013-04-03','15:00:00',6.71),('16100','2013-04-03','15:05:00',6.69),('16100','2013-04-03','15:10:00',6.39),('16100','2013-04-03','15:15:00',6.21),('16100','2013-04-03','15:20:00',5.83),('16100','2013-04-03','15:25:00',5.78),('16100','2013-04-03','15:30:00',6.13),('16100','2013-04-03','15:35:00',6.02),('16100','2013-04-03','15:40:00',5.79),('16100','2013-04-03','15:45:00',5.62),('16100','2013-04-03','15:50:00',5.55),('16100','2013-04-03','15:55:00',5.52),('16100','2013-04-03','16:00:00',5.22),('16100','2013-04-03','16:05:00',5.3),('16100','2013-04-03','16:10:00',4.57),('16100','2013-04-03','16:15:00',4.45),('16100','2013-04-03','16:20:00',3.97),('16100','2013-04-03','16:25:00',5.02),('16100','2013-04-03','16:30:00',4.62),('16100','2013-04-03','16:35:00',3.52),('16100','2013-04-03','16:40:00',4.13),('16100','2013-04-03','16:45:00',3.03),('16100','2013-04-03','16:50:00',3.15),('16100','2013-04-03','16:55:00',3.24),('16100','2013-04-03','17:00:00',3.08),('16100','2013-04-03','17:05:00',3.34),('16100','2013-04-03','17:10:00',2.44),('16100','2013-04-03','17:15:00',2.5),('16100','2013-04-03','17:20:00',2.08),('16100','2013-04-03','17:25:00',1.86),('16100','2013-04-03','17:30:00',1.21),('16100','2013-04-03','17:35:00',1.19),('16100','2013-04-03','17:40:00',1.38),('16100','2013-04-03','17:45:00',1.26),('16100','2013-04-03','17:50:00',1.72),('16100','2013-04-03','17:55:00',2.18),('16100','2013-04-03','18:00:00',1.9),('16100','2013-04-03','18:05:00',1.34),('16100','2013-04-02','08:05:00',1.12),('16100','2013-04-02','08:10:00',1.4),('16100','2013-04-02','08:15:00',1.83),('16100','2013-04-02','08:20:00',2.14),('16100','2013-04-02','08:25:00',1.68),('16100','2013-04-02','08:30:00',2.09),('16100','2013-04-02','08:35:00',2.31),('16100','2013-04-02','08:40:00',2.52),('16100','2013-04-02','09:15:00',2.93),('16100','2013-04-02','09:20:00',2.09),('16100','2013-04-02','09:25:00',3.04),('16100','2013-04-02','09:30:00',2.86),('16100','2013-04-02','09:35:00',4.81),('16100','2013-04-02','09:40:00',4.64),('16100','2013-04-02','09:45:00',4.22),('16100','2013-04-02','09:50:00',4.29),('16100','2013-04-02','09:55:00',4.36),('16100','2013-04-02','10:00:00',2.63),('16100','2013-04-02','10:05:00',4.58),('16100','2013-04-02','10:10:00',6.17),('16100','2013-04-02','10:15:00',5.98),('16100','2013-04-02','10:50:00',3.54),('16100','2013-04-02','10:55:00',3.83),('16100','2013-04-02','11:00:00',6.48),('16100','2013-04-02','11:05:00',4.01),('16100','2013-04-02','11:10:00',6.13),('16100','2013-04-02','11:15:00',3.83),('16100','2013-04-02','11:55:00',4.14),('16100','2013-04-02','12:00:00',4.16),('16100','2013-04-02','12:05:00',5.82),('16100','2013-04-02','12:10:00',5.34),('16100','2013-04-02','12:15:00',6.9),('16100','2013-04-02','12:20:00',5.61),('16100','2013-04-02','12:25:00',7.24),('16100','2013-04-02','12:30:00',8.15),('16100','2013-04-02','12:35:00',6.95),('16100','2013-04-02','12:40:00',7.51),('16100','2013-04-02','12:45:00',5.93),('16100','2013-04-02','12:50:00',6.92),('16100','2013-04-02','12:55:00',5.06),('16100','2013-04-02','13:00:00',9.5),('16100','2013-04-02','13:05:00',7.51),('16100','2013-04-02','13:10:00',8.33),('16100','2013-04-02','13:15:00',6.03),('16100','2013-04-02','13:20:00',6.23),('16100','2013-04-02','13:25:00',4.73),('16100','2013-04-02','13:30:00',6.45),('16100','2013-04-02','13:35:00',6.93),('16100','2013-04-02','13:40:00',8.94),('16100','2013-04-02','13:45:00',6.36),('16100','2013-04-02','13:50:00',6.27),('16100','2013-04-02','13:55:00',5.01),('16100','2013-04-02','14:00:00',4.63),('16100','2013-04-02','14:05:00',3.93),('16100','2013-04-02','14:10:00',5.79),('16100','2013-04-02','14:15:00',6.3),('16100','2013-04-02','14:20:00',7.4),('16100','2013-04-02','14:25:00',7.29),('16100','2013-04-02','14:30:00',6.42),('16100','2013-04-02','14:35:00',8.96),('16100','2013-04-02','14:40:00',7.82),('16100','2013-04-02','14:45:00',8.48),('16100','2013-04-02','14:50:00',6.61),('16100','2013-04-02','14:55:00',7.13),('16100','2013-04-02','15:00:00',7.4),('16100','2013-04-02','15:05:00',4.87),('16100','2013-04-02','15:10:00',6.38),('16100','2013-04-02','15:15:00',4.59),('16100','2013-04-02','15:20:00',6.52),('16100','2013-04-02','15:25:00',6.06),('16100','2013-04-02','15:30:00',1.93),('16100','2013-04-02','15:35:00',3.34),('16100','2013-04-02','15:40:00',5.87),('16100','2013-04-02','15:45:00',4.62),('16100','2013-04-02','15:50:00',2.59),('16100','2013-04-02','15:55:00',6.14),('16100','2013-04-02','16:00:00',5.44),('16100','2013-04-02','16:05:00',6.39),('16100','2013-04-02','16:10:00',6.2),('16100','2013-04-02','16:15:00',5.99),('16100','2013-04-02','16:20:00',5.81),('16100','2013-04-02','16:25:00',5.68),('16100','2013-04-02','16:30:00',5.53),('16100','2013-04-02','16:35:00',5.36),('16100','2013-04-02','16:40:00',5.09),('16100','2013-04-02','16:45:00',4.81),('16100','2013-04-02','16:50:00',4.51),('16100','2013-04-02','16:55:00',4.68),('16100','2013-04-02','17:00:00',4.55),('16100','2013-04-02','17:05:00',4.34),('16100','2013-04-02','17:10:00',4.18),('16100','2013-04-02','17:15:00',4.01),('16100','2013-04-02','17:20:00',3.78),('16100','2013-04-02','17:25:00',3.6),('16100','2013-04-02','17:30:00',3.41),('16100','2013-04-02','17:35:00',3.19),('16100','2013-04-02','17:40:00',2.98),('16100','2013-04-02','17:45:00',2.79),('16100','2013-04-02','17:50:00',2.6),('16100','2013-04-02','17:55:00',1.25),('16100','2013-04-02','18:00:00',1.87),('16100','2013-04-02','18:05:00',1.96),('16100','2013-04-02','18:10:00',1.82),('16100','2013-04-02','18:15:00',1.66),('16100','2013-04-02','18:20:00',1.47),('16100','2013-04-02','18:25:00',1.24),('16100','2013-04-02','18:30:00',1.08),('16100','2013-04-01','08:30:00',1.21),('16100','2013-04-01','08:40:00',2.62),('16100','2013-04-01','08:45:00',2.49),('16100','2013-04-01','08:50:00',1.69),('16100','2013-04-01','08:55:00',1.61),('16100','2013-04-01','09:00:00',3.28),('16100','2013-04-01','09:05:00',3.46),('16100','2013-04-01','09:10:00',3.66),('16100','2013-04-01','09:15:00',3.87),('16100','2013-04-01','09:20:00',3.94),('16100','2013-04-01','09:25:00',4.2),('16100','2013-04-01','09:30:00',4.87),('16100','2013-04-01','09:35:00',4.87),('16100','2013-04-01','09:40:00',5.52),('16100','2013-04-01','09:45:00',5.22),('16100','2013-04-01','09:50:00',6.14),('16100','2013-04-01','09:55:00',6.02),('16100','2013-04-01','10:00:00',4.61),('16100','2013-04-01','10:05:00',5.08),('16100','2013-04-01','10:10:00',4.33),('16100','2013-04-01','10:15:00',3.42),('16100','2013-04-01','10:20:00',5.31),('16100','2013-04-01','10:25:00',6.54),('16100','2013-04-01','10:30:00',6.29),('16100','2013-04-01','10:35:00',6.37),('16100','2013-04-01','10:40:00',5.14),('16100','2013-04-01','10:45:00',4.46),('16100','2013-04-01','10:50:00',7.18),('16100','2013-04-01','10:55:00',6.05),('16100','2013-04-01','11:00:00',7.37),('16100','2013-04-01','11:05:00',5.45),('16100','2013-04-01','11:10:00',2.8),('16100','2013-04-01','11:15:00',4.69),('16100','2013-04-01','11:20:00',6.6),('16100','2013-04-01','11:25:00',3.71),('16100','2013-04-01','11:30:00',3.77),('16100','2013-04-01','11:35:00',5.54),('16100','2013-04-01','11:40:00',8.27),('16100','2013-04-01','11:45:00',1.29),('16100','2013-04-01','11:50:00',4.77),('16100','2013-04-01','11:55:00',1.73),('16100','2013-04-01','12:00:00',1.57),('16100','2013-04-01','12:05:00',2.91),('16100','2013-04-01','12:10:00',4.26),('16100','2013-04-01','12:15:00',3.39),('16100','2013-04-01','12:20:00',1.5),('16100','2013-04-01','12:25:00',1.2),('16100','2013-04-01','12:30:00',4.65),('16100','2013-04-01','12:35:00',6.59),('16100','2013-04-01','12:40:00',6.59),('16100','2013-04-01','12:45:00',5.88),('16100','2013-04-01','12:50:00',3.72),('16100','2013-04-01','12:55:00',2.56),('16100','2013-04-01','13:00:00',2.47),('16100','2013-04-01','13:05:00',3.88),('16100','2013-04-01','13:10:00',2.63),('16100','2013-04-01','13:15:00',1.68),('16100','2013-04-01','13:20:00',2.69),('16100','2013-04-01','13:25:00',2.92),('16100','2013-04-01','13:30:00',2.87),('16100','2013-04-01','13:35:00',3.02),('16100','2013-04-01','13:40:00',4.05),('16100','2013-04-01','13:45:00',4),('16100','2013-04-01','13:50:00',1.67),('16100','2013-04-01','13:55:00',3.68),('16100','2013-04-01','14:00:00',5.11),('16100','2013-04-01','14:05:00',4.1),('16100','2013-04-01','14:10:00',5.97),('16100','2013-04-01','14:15:00',5.5),('16100','2013-04-01','14:20:00',3.47),('16100','2013-04-01','14:25:00',2.57),('16100','2013-04-01','14:30:00',2.48),('16100','2013-04-01','14:35:00',1.11),('16100','2013-04-01','14:40:00',1.77),('16100','2013-04-01','14:45:00',1.36),('16100','2013-04-01','14:55:00',1.68),('16100','2013-04-01','15:00:00',1.32),('16100','2013-04-01','15:15:00',1.28),('16100','2013-04-01','15:20:00',1.98),('16100','2013-04-01','15:35:00',1.17),('16100','2013-04-01','15:40:00',1.29),('16100','2013-04-01','15:45:00',1.06),('16100','2013-04-01','15:50:00',1.1),('16100','2013-04-01','15:55:00',2.13),('16100','2013-04-01','16:00:00',1.3),('16100','2013-04-01','16:05:00',1.45),('16100','2013-04-01','16:10:00',1.43),('16100','2013-04-01','16:15:00',1.4),('16100','2013-04-01','16:20:00',1.28),('16100','2013-04-01','16:25:00',1.19),('16100','2013-04-01','16:30:00',1.38),('16100','2013-04-01','16:35:00',1.3),('16100','2013-04-01','16:40:00',1.17),('16100','2013-04-01','17:05:00',1.13),('16100','2013-04-01','17:40:00',1.18),('16100','2013-04-01','17:45:00',2.13),('16100','2014-05-01','07:50:00',1.48),('16100','2014-05-01','07:55:00',1.8),('16100','2014-05-01','08:00:00',1.01),('16100','2014-05-01','08:05:00',1.23),('16100','2014-05-01','08:10:00',1.35),('16100','2014-05-01','08:15:00',1.16),('16100','2014-05-01','08:20:00',1.2),('16100','2014-05-01','08:35:00',1.42),('16100','2014-05-01','08:40:00',1.85),('16100','2014-05-01','08:45:00',1.73),('16100','2014-05-01','08:50:00',1.49),('16100','2014-05-01','08:55:00',1.59),('16100','2014-05-01','09:00:00',1.61),('16100','2014-05-01','09:05:00',1.59),('16100','2014-05-01','09:10:00',1.71),('16100','2014-05-01','09:15:00',2.74),('16100','2014-05-01','09:20:00',2.62),('16100','2014-05-01','09:25:00',2.15),('16100','2014-05-01','09:30:00',2.32),('16100','2014-05-01','09:35:00',3.34),('16100','2014-05-01','09:40:00',3.45),('16100','2014-05-01','09:45:00',2.63),('16100','2014-05-01','09:50:00',2.74),('16100','2014-05-01','09:55:00',2.27),('16100','2014-05-01','10:00:00',1.84),('16100','2014-05-01','10:05:00',1.35),('16100','2014-05-01','10:25:00',1.11),('16100','2014-05-01','10:30:00',1.28),('16100','2014-05-01','10:35:00',1.06),('16100','2014-05-01','10:40:00',1.06),('16100','2014-05-01','10:45:00',1.25),('16100','2014-05-01','10:50:00',1.21),('16100','2014-05-01','10:55:00',1.48),('16100','2014-05-01','11:00:00',1.66),('16100','2014-05-01','11:05:00',1.52),('16100','2014-05-01','11:10:00',1.37),('16100','2014-05-01','11:15:00',1.05),('16100','2014-05-01','12:35:00',1.35),('16100','2014-05-01','12:40:00',1.75),('16100','2014-05-01','12:45:00',2.62),('16100','2014-05-01','12:50:00',2.83),('16100','2014-05-01','12:55:00',3.94),('16100','2014-05-01','13:00:00',4.15),('16100','2014-05-01','13:05:00',3.28),('16100','2014-05-01','13:10:00',4.79),('16100','2014-05-01','13:15:00',4.76),('16100','2014-05-01','13:20:00',3.17),('16100','2014-05-01','13:25:00',3.6),('16100','2014-05-01','13:30:00',6.47),('16100','2014-05-01','13:35:00',5.95),('16100','2014-05-01','13:40:00',4.15),('16100','2014-05-01','13:45:00',4.61),('16100','2014-05-01','13:50:00',4.84),('16100','2014-05-01','13:55:00',2.57),('16100','2014-05-01','14:00:00',3.49),('16100','2014-05-01','14:05:00',5.77),('16100','2014-05-01','14:10:00',7.03),('16100','2014-05-01','14:15:00',4.86),('16100','2014-05-01','14:20:00',5.23),('16100','2014-05-01','14:25:00',4.78),('16100','2014-05-01','14:30:00',5.96),('16100','2014-05-01','14:35:00',2.06),('16100','2014-05-01','14:40:00',1.27),('16100','2014-05-01','14:45:00',1.86),('16100','2014-05-01','14:50:00',1.2),('16100','2014-05-01','14:55:00',1.87),('16100','2014-05-01','15:00:00',1.61),('16100','2014-05-01','15:05:00',2.14),('16100','2014-05-01','15:10:00',2.47),('16100','2014-05-01','15:15:00',2.45),('16100','2014-05-01','15:20:00',3.05),('16100','2014-05-01','15:25:00',3.99),('16100','2014-05-01','15:30:00',2.81),('16100','2014-05-01','15:35:00',4.5),('16100','2014-05-01','15:40:00',3.3),('16100','2014-05-01','15:45:00',1.48),('16100','2014-05-01','15:50:00',1.54),('16100','2014-05-01','15:55:00',3.72),('16100','2014-05-01','16:00:00',2.87),('16100','2014-05-01','16:05:00',1.79),('16100','2014-05-01','16:10:00',2.73),('16100','2014-05-01','16:15:00',2.58),('16100','2014-05-01','16:20:00',1.48),('16100','2014-05-01','16:25:00',1.71),('16100','2014-05-01','16:30:00',1.64),('16100','2014-05-01','16:35:00',1.06),('16100','2014-05-01','16:45:00',1.66),('16100','2014-05-01','16:50:00',1.52),('16100','2014-05-01','16:55:00',1.54),('16100','2014-05-01','17:00:00',1.36),('16100','2014-05-01','17:05:00',1.17),('16100','2014-05-01','17:10:00',1.16),('16100','2014-05-01','17:15:00',1.1),('16100','2014-03-26','07:55:00',1.25),('16100','2014-03-26','08:00:00',1.49),('16100','2014-03-26','08:05:00',1.58),('16100','2014-03-26','08:10:00',1.06),('16100','2014-03-26','09:10:00',1.28),('16100','2014-03-26','09:15:00',1.47),('16100','2014-03-26','09:20:00',1.39),('16100','2014-03-26','09:25:00',1.76),('16100','2014-03-26','09:30:00',1.68),('16100','2014-03-26','09:35:00',1.23),('16100','2014-03-26','10:00:00',1.2),('16100','2014-03-26','10:05:00',1.91),('16100','2014-03-26','10:10:00',2.32),('16100','2014-03-26','10:15:00',2.42),('16100','2014-03-26','10:20:00',2.47),('16100','2014-03-26','10:25:00',2.1),('16100','2014-03-26','10:30:00',1.66),('16100','2014-03-26','10:35:00',2.27),('16100','2014-03-26','10:40:00',2.55),('16100','2014-03-26','10:45:00',4.7),('16100','2014-03-26','10:50:00',4.38),('16100','2014-03-26','10:55:00',1.89),('16100','2014-03-26','11:00:00',1.05),('16100','2014-03-26','11:05:00',1.92),('16100','2014-03-26','11:10:00',6.14),('16100','2014-03-26','11:15:00',2.77),('16100','2014-03-26','11:20:00',1.28),('16100','2014-03-26','11:50:00',1.77),('16100','2014-03-26','11:55:00',6.28),('16100','2014-03-26','12:00:00',6.83),('16100','2014-03-26','12:05:00',1.88),('16100','2014-03-26','12:10:00',1.04),('16100','2014-03-26','12:45:00',1.15),('16100','2014-03-26','12:50:00',1.31),('16100','2014-03-26','12:55:00',1.68),('16100','2014-03-26','13:00:00',1.93),('16100','2014-03-26','13:05:00',2.26),('16100','2014-03-26','13:10:00',3.08),('16100','2014-03-26','13:15:00',4.67),('16100','2014-03-26','13:20:00',4.32),('16100','2014-03-26','13:25:00',4.76),('16100','2014-03-26','13:30:00',4.13),('16100','2014-03-26','13:35:00',4.56),('16100','2014-03-26','13:40:00',4.38),('16100','2014-03-26','13:45:00',4.03),('16100','2014-03-26','13:50:00',3.52),('16100','2014-03-26','13:55:00',2.96),('16100','2014-03-26','14:00:00',2.84),('16100','2014-03-26','14:05:00',4.04),('16100','2014-03-26','14:10:00',4.41),('16100','2014-03-26','14:15:00',1.4),('16100','2014-03-26','14:20:00',2.16),('16100','2014-03-26','14:25:00',5.64),('16100','2014-03-26','14:30:00',3.78),('16100','2014-03-26','14:35:00',2.15),('16100','2014-03-26','14:40:00',1.8),('16100','2014-03-26','14:45:00',2.63),('16100','2014-03-26','14:50:00',2.9),('16100','2014-03-26','14:55:00',2.97),('16100','2014-03-26','15:00:00',2.46),('16100','2014-03-26','15:05:00',1.04),('16100','2014-03-26','15:35:00',2.25),('16100','2014-03-26','15:40:00',5.29),('16100','2014-03-26','15:45:00',6),('16100','2014-03-26','15:50:00',1.85),('16100','2014-03-26','16:20:00',1.15),('16100','2014-03-26','16:25:00',2.29),('16100','2014-03-26','16:30:00',1.23),('16100','2014-03-26','16:40:00',1.03),('16100','2014-03-26','16:45:00',2.63),('16100','2014-03-26','16:50:00',2.84),('16100','2014-03-26','16:55:00',1.29),('16100','2013-03-31','08:15:00',1.34),('16100','2013-03-31','08:20:00',1.62),('16100','2013-03-31','08:25:00',1.99),('16100','2013-03-31','08:30:00',2.69),('16100','2013-03-31','08:35:00',3.26),('16100','2013-03-31','08:40:00',2.47),('16100','2013-03-31','08:45:00',1.16),('16100','2013-03-31','08:55:00',2.63),('16100','2013-03-31','09:00:00',3.27),('16100','2013-03-31','09:05:00',3.49),('16100','2013-03-31','09:10:00',3.73),('16100','2013-03-31','09:15:00',3.79),('16100','2013-03-31','09:20:00',3.59),('16100','2013-03-31','09:25:00',3.89),('16100','2013-03-31','09:30:00',2.33),('16100','2013-03-31','09:35:00',2.32),('16100','2013-03-31','09:40:00',5.08),('16100','2013-03-31','09:45:00',5.36),('16100','2013-03-31','09:50:00',4.87),('16100','2013-03-31','09:55:00',4.93),('16100','2013-03-31','10:00:00',3.57),('16100','2013-03-31','10:05:00',5.99),('16100','2013-03-31','10:10:00',4.26),('16100','2013-03-31','10:15:00',4.64),('16100','2013-03-31','10:20:00',5.3),('16100','2013-03-31','10:25:00',6.2),('16100','2013-03-31','10:30:00',5.12),('16100','2013-03-31','10:35:00',5.61),('16100','2013-03-31','10:40:00',6.89),('16100','2013-03-31','10:45:00',4.14),('16100','2013-03-31','10:50:00',4.74),('16100','2013-03-31','10:55:00',8.39),('16100','2013-03-31','11:00:00',3.89),('16100','2013-03-31','11:05:00',5.64),('16100','2013-03-31','11:10:00',6.56),('16100','2013-03-31','11:15:00',4.26),('16100','2013-03-31','11:20:00',2.47),('16100','2013-03-31','11:25:00',2.44),('16100','2013-03-31','11:30:00',2.41),('16100','2013-03-31','11:35:00',2.55),('16100','2013-03-31','11:40:00',3.15),('16100','2013-03-31','11:45:00',2.56),('16100','2013-03-31','11:50:00',2.99),('16100','2013-03-31','11:55:00',3.96),('16100','2013-03-31','12:00:00',4.19),('16100','2013-03-31','12:05:00',4.14),('16100','2013-03-31','12:10:00',3.95),('16100','2013-03-31','12:15:00',3.53),('16100','2013-03-31','12:20:00',3.37),('16100','2013-03-31','12:55:00',5.01),('16100','2013-03-31','13:00:00',4.69),('16100','2013-03-31','13:05:00',5.28),('16100','2013-03-31','13:10:00',5.16),('16100','2013-03-31','13:15:00',5.11),('16100','2013-03-31','13:20:00',4.86),('16100','2013-03-31','13:25:00',3.93),('16100','2013-03-31','13:30:00',4.04),('16100','2013-03-31','13:35:00',3.87),('16100','2013-03-31','13:40:00',4.28),('16100','2013-03-31','13:45:00',5.27),('16100','2013-03-31','13:50:00',6.83),('16100','2013-03-31','13:55:00',6.06),('16100','2013-03-31','14:00:00',3.86),('16100','2013-03-31','14:05:00',3.03),('16100','2013-03-31','14:10:00',3.38),('16100','2013-03-31','14:15:00',4.26),('16100','2013-03-31','14:20:00',5.16),('16100','2013-03-31','14:25:00',7.26),('16100','2013-03-31','14:30:00',7.16),('16100','2013-03-31','14:35:00',2.52),('16100','2013-03-31','14:40:00',2.71),('16100','2013-03-31','14:45:00',4.84),('16100','2013-03-31','14:50:00',5.08),('16100','2013-03-31','14:55:00',3.69),('16100','2013-03-31','15:00:00',3.35),('16100','2013-03-31','15:05:00',3.03),('16100','2013-03-31','15:10:00',3.51),('16100','2013-03-31','15:15:00',3.71),('16100','2013-03-31','15:20:00',4.01),('16100','2013-03-31','15:25:00',4.8),('16100','2013-03-31','15:30:00',3.93),('16100','2013-03-31','15:35:00',4.63),('16100','2013-03-31','15:40:00',3.33),('16100','2013-03-31','15:45:00',4.35),('16100','2013-03-31','15:50:00',5.2),('16100','2013-03-31','15:55:00',3.97),('16100','2013-03-31','16:00:00',3.39),('16100','2013-03-31','16:05:00',2.7),('16100','2013-03-31','16:10:00',2.24),('16100','2013-03-31','16:15:00',1.44),('16100','2013-03-31','16:20:00',1.48),('16100','2013-03-31','16:25:00',1.39),('16100','2013-03-30','08:10:00',1.02),('16100','2013-03-30','08:20:00',1.01),('16100','2013-03-30','08:25:00',1.18),('16100','2013-03-30','08:40:00',1.09),('16100','2013-03-30','08:45:00',1.36),('16100','2013-03-30','08:50:00',1.74),('16100','2013-03-30','08:55:00',1.22),('16100','2013-03-30','09:00:00',1.63),('16100','2013-03-30','09:05:00',2.06),('16100','2013-03-30','09:10:00',2.83),('16100','2013-03-30','09:15:00',1.71),('16100','2013-03-30','09:20:00',1.62),('16100','2013-03-30','09:25:00',2.68),('16100','2013-03-30','09:30:00',2.46),('16100','2013-03-30','09:35:00',1.39),('16100','2013-03-30','09:40:00',1.89),('16100','2013-03-30','09:45:00',3.84),('16100','2013-03-30','09:50:00',2.38),('16100','2013-03-30','10:00:00',1.06),('16100','2013-03-30','10:05:00',1.22),('16100','2013-03-30','10:10:00',2.51),('16100','2013-03-30','10:15:00',3.71),('16100','2013-03-30','10:20:00',5.18),('16100','2013-03-30','10:25:00',3.56),('16100','2013-03-30','10:30:00',3.09),('16100','2013-03-30','10:35:00',3.53),('16100','2013-03-30','10:40:00',1.03),('16100','2013-03-30','10:45:00',1.02),('16100','2013-03-30','10:50:00',3.74),('16100','2013-03-30','10:55:00',4.01),('16100','2013-03-30','11:00:00',4.05),('16100','2013-03-30','11:05:00',6.76),('16100','2013-03-30','11:10:00',2.26),('16100','2013-03-30','11:15:00',1.69),('16100','2013-03-30','11:20:00',1.76),('16100','2013-03-30','11:25:00',2.44),('16100','2013-03-30','11:30:00',3.68),('16100','2013-03-30','11:35:00',5.04),('16100','2013-03-30','11:40:00',3.97),('16100','2013-03-30','11:45:00',5.02),('16100','2013-03-30','11:50:00',2.63),('16100','2013-03-30','11:55:00',2.14),('16100','2013-03-30','12:00:00',1.77),('16100','2013-03-30','12:05:00',1.33),('16100','2013-03-30','12:10:00',1.25),('16100','2013-03-30','12:15:00',1),('16100','2013-03-30','12:25:00',1.6),('16100','2013-03-30','12:30:00',2.95),('16100','2013-03-30','12:35:00',5.21),('16100','2013-03-30','12:40:00',5.35),('16100','2013-03-30','12:45:00',5.46),('16100','2013-03-30','12:50:00',2.66),('16100','2013-03-30','12:55:00',4.14),('16100','2013-03-30','13:00:00',5.11),('16100','2013-03-30','13:05:00',3.64),('16100','2013-03-30','13:10:00',2.66),('16100','2013-03-30','13:15:00',5.96),('16100','2013-03-30','13:20:00',7.55),('16100','2013-03-30','13:25:00',3.86),('16100','2013-03-30','13:30:00',2.58),('16100','2013-03-30','13:35:00',3),('16100','2013-03-30','13:40:00',3.02),('16100','2013-03-30','13:45:00',3.64),('16100','2013-03-30','13:50:00',4.38),('16100','2013-03-30','13:55:00',5.64),('16100','2013-03-30','14:00:00',4.06),('16100','2013-03-30','14:05:00',2.8),('16100','2013-03-30','14:10:00',5.77),('16100','2013-03-30','14:15:00',5.86),('16100','2013-03-30','14:20:00',3.78),('16100','2013-03-30','14:25:00',4.44),('16100','2013-03-30','14:30:00',4.33),('16100','2013-03-30','14:35:00',3.64),('16100','2013-03-30','14:40:00',6.1),('16100','2013-03-30','14:45:00',6.29),('16100','2013-03-30','14:50:00',5.26),('16100','2013-03-30','14:55:00',4.06),('16100','2013-03-30','15:00:00',5.78),('16100','2013-03-30','15:05:00',5.33),('16100','2013-03-30','15:10:00',6.18),('16100','2013-03-30','15:15:00',6.98),('16100','2013-03-30','15:20:00',8.58),('16100','2013-03-30','15:25:00',4.93),('16100','2013-03-30','15:30:00',4.86),('16100','2013-03-30','15:35:00',5.05),('16100','2013-03-30','15:40:00',3.86),('16100','2013-03-30','15:45:00',3.86),('16100','2013-03-30','15:50:00',1.52),('16100','2013-03-30','15:55:00',1.19),('16100','2013-03-30','16:00:00',1.61),('16100','2013-03-30','16:15:00',1.65),('16100','2013-03-30','16:20:00',3.45),('16100','2013-03-30','16:25:00',1.86),('16100','2013-03-30','16:30:00',1.82),('16100','2013-03-30','16:35:00',2.74),('16100','2013-03-30','16:40:00',1.94),('16100','2013-03-30','16:45:00',1.49),('16100','2013-03-30','16:50:00',1.29),('16100','2013-03-30','16:55:00',1.91),('16100','2013-03-30','17:00:00',3),('16100','2013-03-30','17:05:00',2.26),('16100','2013-03-30','17:10:00',1.04),('16100','2013-03-30','17:25:00',1.14),('16100','2013-03-30','17:30:00',1.8),('16100','2013-03-30','17:35:00',1.65),('16100','2013-03-30','17:40:00',1.28),('16100','2013-03-30','17:45:00',2.67),('16100','2013-03-30','17:50:00',3.02),('16100','2013-03-30','17:55:00',2.29),('16100','2013-03-30','18:10:00',1.32),('16100','2013-03-30','18:15:00',2.05),('16100','2013-03-30','18:25:00',1.21),('16100','2013-03-29','08:10:00',1.16),('16100','2013-03-29','08:15:00',1.2),('16100','2013-03-29','08:20:00',1.27),('16100','2013-03-29','08:25:00',1.42),('16100','2013-03-29','08:30:00',1.36),('16100','2013-03-29','08:35:00',1.59),('16100','2013-03-29','08:40:00',1.49),('16100','2013-03-29','09:00:00',1.68),('16100','2013-03-29','09:05:00',2.32),('16100','2013-03-29','09:10:00',3.53),('16100','2013-03-29','09:15:00',2.74),('16100','2013-03-29','09:20:00',3.15),('16100','2013-03-29','09:25:00',3.19),('16100','2013-03-29','09:30:00',3.44),('16100','2013-03-29','09:35:00',1.9),('16100','2013-03-29','09:40:00',1.63),('16100','2013-03-29','09:45:00',2.26),('16100','2013-03-29','09:50:00',2.33),('16100','2013-03-29','09:55:00',3.7),('16100','2013-03-29','10:00:00',3.39),('16100','2013-03-29','10:05:00',2.96),('16100','2013-03-29','10:10:00',2.87),('16100','2013-03-29','10:15:00',2.07),('16100','2013-03-29','10:50:00',3.48),('16100','2013-03-29','10:55:00',4.12),('16100','2013-03-29','11:00:00',4.7),('16100','2013-03-29','11:05:00',4.69),('16100','2013-03-29','11:10:00',4.06),('16100','2013-03-29','11:15:00',3.24),('16100','2013-03-29','11:20:00',6.2),('16100','2013-03-29','11:25:00',6.28),('16100','2013-03-29','11:30:00',5.2),('16100','2013-03-29','11:35:00',4.67),('16100','2013-03-29','11:40:00',5.89),('16100','2013-03-29','11:45:00',5.43),('16100','2013-03-29','11:50:00',5.53),('16100','2013-03-29','11:55:00',5.05),('16100','2013-03-29','12:00:00',4.16),('16100','2013-03-29','12:05:00',3.09),('16100','2013-03-29','12:10:00',3.02),('16100','2013-03-29','12:15:00',2.06),('16100','2013-03-29','12:20:00',1.83),('16100','2013-03-29','12:25:00',1.96),('16100','2013-03-29','12:30:00',1.91),('16100','2013-03-29','12:35:00',1.82),('16100','2013-03-29','13:05:00',6.68),('16100','2013-03-29','13:10:00',3.34),('16100','2013-03-29','13:15:00',3.26),('16100','2013-03-29','13:20:00',5.45),('16100','2013-03-29','13:55:00',3.85),('16100','2013-03-29','14:00:00',3.94),('16100','2013-03-29','14:05:00',2.78),('16100','2013-03-29','14:10:00',3.98),('16100','2013-03-29','14:15:00',4.06),('16100','2013-03-29','14:20:00',2.97),('16100','2013-03-29','14:25:00',2.99),('16100','2013-03-29','14:30:00',2.09),('16100','2013-03-29','14:35:00',1.55),('16100','2013-03-29','14:40:00',1.18),('16100','2013-03-29','14:45:00',1.76),('16100','2013-03-29','14:50:00',1.83),('16100','2013-03-29','14:55:00',1.53),('16100','2013-03-29','15:00:00',1.36),('16100','2013-03-29','15:05:00',1.03),('16100','2013-03-29','15:15:00',1.03),('16100','2013-03-28','07:10:00',1),('16100','2013-03-28','07:15:00',1.17),('16100','2013-03-28','07:20:00',1.55),('16100','2013-03-28','07:35:00',1.5),('16100','2013-03-28','07:40:00',2.13),('16100','2013-03-28','07:46:00',1.94),('16100','2013-03-28','07:50:00',2.82),('16100','2013-03-28','07:55:00',1.79),('16100','2013-03-28','08:05:00',1.54),('16100','2013-03-28','08:10:00',3.62),('16100','2013-03-28','08:15:00',3.88),('16100','2013-03-28','08:20:00',3.77),('16100','2013-03-28','08:25:00',3.98),('16100','2013-03-28','08:30:00',4.15),('16100','2013-03-28','08:35:00',4.31),('16100','2013-03-28','08:40:00',4.26),('16100','2013-03-28','08:45:00',4.4),('16100','2013-03-28','08:50:00',4.18),('16100','2013-03-28','08:55:00',4.48),('16100','2013-03-28','09:00:00',4.55),('16100','2013-03-28','09:05:00',4.7),('16100','2013-03-28','09:10:00',5.37),('16100','2013-03-28','09:15:00',5.59),('16100','2013-03-28','09:20:00',4.84),('16100','2013-03-28','09:25:00',5.57),('16100','2013-03-28','09:30:00',5.76),('16100','2013-03-28','09:35:00',5.57),('16100','2013-03-28','09:40:00',5.04),('16100','2013-03-28','09:45:00',5.34),('16100','2013-03-28','09:50:00',5.42),('16100','2013-03-28','09:55:00',5.68),('16100','2013-03-28','10:00:00',5.52),('16100','2013-03-28','10:05:00',4.56),('16100','2013-03-28','10:10:00',5.65),('16100','2013-03-28','10:15:00',5.64),('16100','2013-03-28','10:20:00',5.7),('16100','2013-03-28','10:25:00',5.41),('16100','2013-03-28','10:30:00',5.84),('16100','2013-03-28','10:35:00',6.42),('16100','2013-03-28','10:40:00',6.15),('16100','2013-03-28','10:45:00',5.89),('16100','2013-03-28','10:50:00',6.06),('16100','2013-03-28','10:55:00',7.44),('16100','2013-03-28','11:00:00',7.35),('16100','2013-03-28','11:05:00',7.53),('16100','2013-03-28','11:10:00',8.5),('16100','2013-03-28','11:15:00',8.14),('16100','2013-03-28','11:20:00',8.05),('16100','2013-03-28','11:25:00',8.17),('16100','2013-03-28','11:30:00',8.08),('16100','2013-03-28','11:35:00',7.97),('16100','2013-03-28','11:40:00',7.93),('16100','2013-03-28','11:45:00',8.13),('16100','2013-03-28','11:50:00',8.05),('16100','2013-03-28','11:55:00',8.12),('16100','2013-03-28','12:00:00',8.24),('16100','2013-03-28','12:05:00',8.33),('16100','2013-03-28','12:10:00',7.48),('16100','2013-03-28','12:15:00',8.03),('16100','2013-03-28','12:20:00',7.82),('16100','2013-03-28','12:25:00',7.57),('16100','2013-03-28','12:30:00',7.85),('16100','2013-03-28','12:35:00',8.08),('16100','2013-03-28','12:40:00',7.44),('16100','2013-03-28','12:45:00',8.15),('16100','2013-03-28','12:50:00',7.66),('16100','2013-03-28','12:55:00',7.59),('16100','2013-03-28','13:00:00',6.99),('16100','2013-03-28','13:05:00',5.15),('16100','2013-03-28','13:10:00',5.65),('16100','2013-03-28','13:15:00',7.27),('16100','2013-03-28','13:20:00',8.47),('16100','2013-03-28','13:25:00',8.06),('16100','2013-03-28','13:30:00',6.58),('16100','2013-03-28','13:35:00',6.37),('16100','2013-03-28','13:40:00',6.11),('16100','2013-03-28','13:45:00',6.55),('16100','2013-03-28','13:50:00',6.06),('16100','2013-03-28','13:55:00',6.66),('16100','2013-03-28','14:00:00',6.43),('16100','2013-03-28','14:05:00',4.97),('16100','2013-03-28','14:10:00',4.51),('16100','2013-03-28','14:15:00',4.24),('16100','2013-03-28','14:20:00',4.26),('16100','2013-03-28','14:25:00',3.82),('16100','2013-03-28','14:30:00',3.51),('16100','2013-03-28','14:35:00',3.3),('16100','2013-03-28','14:40:00',3.37),('16100','2013-03-28','14:45:00',3.09),('16100','2013-03-28','14:50:00',2.96),('16100','2013-03-28','14:55:00',2.74),('16100','2013-03-28','15:00:00',2.51),('16100','2013-03-28','15:05:00',2.58),('16100','2013-03-28','15:10:00',2.43),('16100','2013-03-28','15:15:00',2.41),('16100','2013-03-28','15:20:00',2.13),('16100','2013-03-28','15:25:00',1.91),('16100','2013-03-28','15:30:00',1.8),('16100','2013-03-28','15:35:00',1.7),('16100','2013-03-28','15:40:00',1.63),('16100','2013-03-28','15:45:00',1.71),('16100','2013-03-28','15:50:00',1.97),('16100','2013-03-28','15:55:00',2.16),('16100','2013-03-28','16:00:00',2.16),('16100','2013-03-28','16:05:00',1.98),('16100','2013-03-28','16:10:00',1.74),('16100','2013-03-28','16:15:00',1.55),('16100','2013-03-28','16:20:00',1.5),('16100','2013-03-28','16:25:00',2.25),('16100','2013-03-28','16:30:00',1.71),('16100','2013-03-28','16:35:00',2.65),('16100','2013-03-28','16:40:00',3.38),('16100','2013-03-28','16:45:00',2.43),('16100','2013-03-28','16:50:00',1.74),('16100','2013-03-28','16:55:00',1.86),('16100','2013-03-28','17:00:00',2.65),('16100','2013-03-28','17:05:00',1.77),('16100','2013-03-28','17:10:00',1.12),('16100','2013-03-28','17:15:00',1.29),('16100','2013-03-28','17:20:00',1.81),('16100','2013-03-28','17:25:00',1.47),('16100','2013-03-28','17:30:00',1.5),('16100','2013-03-27','09:10:00',1.66),('16100','2013-03-27','09:15:00',1.96),('16100','2013-03-27','09:20:00',2.51),('16100','2013-03-27','09:25:00',2.89),('16100','2013-03-27','09:30:00',2.24),('16100','2013-03-27','09:45:00',1.05),('16100','2013-03-27','09:55:00',1.28),('16100','2013-03-27','10:00:00',1.62),('16100','2013-03-27','10:15:00',1.01),('16100','2013-03-27','11:00:00',1.22),('16100','2013-03-27','11:05:00',1.4),('16100','2013-03-27','12:05:00',1.01),('16100','2013-03-27','13:00:00',1.13),('16100','2013-03-27','13:05:00',1.77),('16100','2013-03-27','13:10:00',1.57),('16100','2013-03-27','13:15:00',1.83),('16100','2013-03-27','13:20:00',1.82),('16100','2013-03-27','13:25:00',3.27),('16100','2013-03-27','13:30:00',2.52),('16100','2013-03-27','13:35:00',4),('16100','2013-03-27','13:40:00',1.52),('16100','2013-03-27','13:45:00',1.66),('16100','2013-03-27','13:50:00',1.67),('16100','2013-03-27','13:55:00',1.23),('16100','2013-03-27','14:00:00',1),('16100','2013-03-27','14:05:00',3.79),('16100','2013-03-27','14:10:00',4.74),('16100','2013-03-27','14:15:00',4.34),('16100','2013-03-27','14:20:00',3.72),('16100','2013-03-27','14:25:00',2.21),('16100','2013-03-27','14:30:00',2.01),('16100','2013-03-27','14:35:00',2.27),('16100','2013-03-27','14:40:00',2.01),('16100','2013-03-27','14:45:00',1.85),('16100','2013-03-27','14:55:00',1.14),('16100','2013-03-27','15:00:00',1.55),('16100','2013-03-27','15:05:00',2.16),('16100','2013-03-27','15:10:00',3.31),('16100','2013-03-27','15:15:00',6.09),('16100','2013-03-27','15:20:00',6.6),('16100','2013-03-27','15:25:00',4.49),('16100','2013-03-27','15:30:00',2.33),('16100','2013-03-27','15:35:00',1.15),('16100','2013-03-27','15:40:00',1.09),('16100','2013-03-27','15:45:00',2.67),('16100','2013-03-27','15:50:00',2.03),('16100','2013-03-27','15:55:00',1.79),('16100','2013-03-27','16:00:00',1.34),('16100','2013-03-27','16:05:00',1.8),('16100','2013-03-27','16:10:00',1.54),('16100','2013-03-27','16:15:00',1.22),('16100','2013-03-27','16:25:00',1.24),('16100','2013-03-27','16:40:00',2.36),('16100','2013-03-27','16:45:00',2.22),('16100','2013-03-27','16:50:00',1.26),('16100','2013-03-27','16:55:00',1.52),('16100','2013-03-27','17:00:00',1.95),('16100','2013-03-27','17:05:00',2.32),('16100','2013-03-27','17:10:00',1.23),('16100','2013-03-27','17:15:00',1.57),('16100','2013-03-27','17:20:00',1.19),('16100','2013-03-26','07:00:00',1.13),('16100','2013-03-26','07:15:00',1.41),('16100','2013-03-26','07:20:00',1.35),('16100','2013-03-26','07:25:00',1.49),('16100','2013-03-26','07:30:00',1.72),('16100','2013-03-26','07:35:00',1.91),('16100','2013-03-26','07:40:00',2.14),('16100','2013-03-26','07:45:00',2.4),('16100','2013-03-26','07:50:00',3.33),('16100','2013-03-26','07:55:00',3.33),('16100','2013-03-26','08:00:00',2.06),('16100','2013-03-26','08:05:00',1.75),('16100','2013-03-26','08:10:00',1.81),('16100','2013-03-26','08:15:00',1.98),('16100','2013-03-26','08:20:00',1.92),('16100','2013-03-26','08:25:00',3.08),('16100','2013-03-26','08:30:00',3.05),('16100','2013-03-26','08:35:00',3.84),('16100','2013-03-26','08:40:00',2.89),('16100','2013-03-26','08:45:00',5.15),('16100','2013-03-26','08:50:00',3.16),('16100','2013-03-26','08:55:00',4.71),('16100','2013-03-26','09:00:00',2.47),('16100','2013-03-26','09:05:00',2.22),('16100','2013-03-26','09:10:00',3.03),('16100','2013-03-26','09:15:00',2.95),('16100','2013-03-26','09:20:00',1.72),('16100','2013-03-26','09:25:00',1.82),('16100','2013-03-26','09:30:00',2.85),('16100','2013-03-26','09:35:00',3.05),('16100','2013-03-26','09:40:00',2.08),('16100','2013-03-26','09:45:00',1.67),('16100','2013-03-26','09:50:00',3.12),('16100','2013-03-26','09:55:00',3.87),('16100','2013-03-26','10:00:00',4.63),('16100','2013-03-26','10:05:00',2.3),('16100','2013-03-26','10:10:00',3.34),('16100','2013-03-26','10:15:00',4.86),('16100','2013-03-26','10:20:00',8.76),('16100','2013-03-26','10:25:00',6.19),('16100','2013-03-26','10:30:00',3.77),('16100','2013-03-26','10:35:00',4.45),('16100','2013-03-26','10:40:00',3.2),('16100','2013-03-26','10:45:00',2.79),('16100','2013-03-26','10:50:00',3.07),('16100','2013-03-26','10:55:00',2.65),('16100','2013-03-26','11:00:00',2.45),('16100','2013-03-26','11:05:00',2.52),('16100','2013-03-26','11:10:00',2.05),('16100','2013-03-26','11:15:00',1.91),('16100','2013-03-26','11:20:00',1.97),('16100','2013-03-26','11:25:00',4.65),('16100','2013-03-26','11:30:00',5.82),('16100','2013-03-26','11:35:00',4.01),('16100','2013-03-26','11:40:00',2.85),('16100','2013-03-26','11:45:00',2.76),('16100','2013-03-26','11:50:00',3.83),('16100','2013-03-26','11:55:00',4.27),('16100','2013-03-26','12:00:00',4.04),('16100','2013-03-26','12:05:00',4.74),('16100','2013-03-26','12:10:00',4.47),('16100','2013-03-26','12:15:00',4.1),('16100','2013-03-26','12:20:00',2.48),('16100','2013-03-26','12:25:00',3.24),('16100','2013-03-26','12:30:00',3.17),('16100','2013-03-26','12:35:00',2.44),('16100','2013-03-26','12:40:00',2.82),('16100','2013-03-26','12:45:00',3.22),('16100','2013-03-26','12:50:00',4.07),('16100','2013-03-26','12:55:00',4.11),('16100','2013-03-26','13:00:00',4.34),('16100','2013-03-26','13:05:00',3.29),('16100','2013-03-26','13:10:00',3.31),('16100','2013-03-26','13:15:00',3.22),('16100','2013-03-26','13:20:00',2.67),('16100','2013-03-26','13:25:00',2.54),('16100','2013-03-26','13:30:00',2.75),('16100','2013-03-26','13:35:00',3.33),('16100','2013-03-26','13:40:00',3.53),('16100','2013-03-26','13:45:00',3.6),('16100','2013-03-26','13:50:00',2.81),('16100','2013-03-26','13:55:00',2.42),('16100','2013-03-26','14:00:00',2.32),('16100','2013-03-26','14:05:00',2.6),('16100','2013-03-26','14:10:00',2.78),('16100','2013-03-26','14:15:00',3.15),('16100','2013-03-26','14:20:00',2.75),('16100','2013-03-26','14:25:00',2.65),('16100','2013-03-26','14:30:00',2.11),('16100','2013-03-26','14:35:00',1.97),('16100','2013-03-26','14:40:00',2.24),('16100','2013-03-26','14:45:00',2.13),('16100','2013-03-26','14:50:00',2.5),('16100','2013-03-26','14:55:00',2.15),('16100','2013-03-26','15:00:00',1.51),('16100','2013-03-26','15:05:00',1.24),('16100','2013-03-26','15:10:00',1.31),('16100','2013-03-26','15:15:00',1.44),('16100','2013-03-26','15:20:00',1.86),('16100','2013-03-26','15:25:00',1.91),('16100','2013-03-26','15:30:00',1.32),('16100','2013-03-26','15:35:00',1.12),('16100','2013-03-26','15:40:00',1.55),('16100','2013-03-26','15:45:00',1.17),('16100','2013-03-26','16:05:00',1.28),('16100','2013-03-26','16:10:00',1.46),('16100','2013-03-26','16:15:00',1.47),('16100','2013-03-26','16:20:00',2.09),('16100','2013-03-26','16:25:00',1.86),('16100','2013-03-26','16:30:00',1.98),('16100','2013-03-26','16:35:00',1.82),('16100','2013-03-26','16:40:00',2.57),('16100','2013-03-26','16:45:00',1.57),('16100','2013-03-26','16:50:00',1.56),('16100','2013-03-26','16:55:00',1.82),('16100','2013-03-26','17:00:00',2.28),('16100','2013-03-26','17:05:00',2.38),('16100','2013-03-26','17:10:00',1.11),('16100','2013-03-25','07:40:00',1.25),('16100','2013-03-25','07:45:00',1.77),('16100','2013-03-25','07:50:00',2.2),('16100','2013-03-25','07:55:00',1.33),('16100','2013-03-25','08:00:00',1.09),('16100','2013-03-25','08:10:00',1.12),('16100','2013-03-25','08:15:00',1.25),('16100','2013-03-25','08:20:00',1.23),('16100','2013-03-25','08:25:00',1.2),('16100','2013-03-25','08:30:00',1.57),('16100','2013-03-25','08:35:00',1.59),('16100','2013-03-25','08:40:00',1.56),('16100','2013-03-25','08:45:00',1.18),('16100','2013-03-25','08:50:00',1.25),('16100','2013-03-25','08:55:00',1.19),('16100','2013-03-25','09:00:00',1.48),('16100','2013-03-25','09:05:00',1.52),('16100','2013-03-25','09:10:00',2.44),('16100','2013-03-25','09:15:00',2.32),('16100','2013-03-25','09:20:00',1.14),('16100','2013-03-25','09:50:00',1.53),('16100','2013-03-25','09:55:00',1.18),('16100','2013-03-25','10:00:00',1.18),('16100','2013-03-25','10:05:00',2.18),('16100','2013-03-25','10:10:00',1.6),('16100','2013-03-25','10:30:00',1.34),('16100','2013-03-25','10:35:00',1.6),('16100','2013-03-25','10:40:00',1.51),('16100','2013-03-25','10:45:00',1.74),('16100','2013-03-25','10:50:00',2.13),('16100','2013-03-25','10:55:00',3.06),('16100','2013-03-25','11:00:00',3.66),('16100','2013-03-25','11:05:00',2.07),('16100','2013-03-25','11:40:00',1.43),('16100','2013-03-25','11:45:00',3.13),('16100','2013-03-25','11:50:00',4.39),('16100','2013-03-25','11:55:00',7.9),('16100','2013-03-25','12:00:00',3.44),('16100','2013-03-25','12:05:00',2.11),('16100','2013-03-25','12:10:00',2.11),('16100','2013-03-25','12:15:00',2.38),('16100','2013-03-25','12:20:00',4.05),('16100','2013-03-25','12:25:00',6.61),('16100','2013-03-25','12:30:00',5.72),('16100','2013-03-25','12:35:00',4.73),('16100','2013-03-25','12:40:00',2.15),('16100','2013-03-25','12:45:00',2.27),('16100','2013-03-25','12:50:00',3.11),('16100','2013-03-25','12:55:00',2.43),('16100','2013-03-25','13:00:00',2.31),('16100','2013-03-25','13:05:00',3.43),('16100','2013-03-25','13:10:00',2.98),('16100','2013-03-25','13:15:00',2.04),('16100','2013-03-25','13:20:00',3.25),('16100','2013-03-25','13:25:00',3.09),('16100','2013-03-25','13:30:00',2.44),('16100','2013-03-25','13:35:00',2.36),('16100','2013-03-25','13:40:00',3.59),('16100','2013-03-25','13:45:00',4.35),('16100','2013-03-25','13:50:00',2.66),('16100','2013-03-25','13:55:00',2.03),('16100','2013-03-25','14:00:00',2.19),('16100','2013-03-25','14:05:00',2.38),('16100','2013-03-25','14:10:00',2.83),('16100','2013-03-25','14:15:00',2.13),('16100','2013-03-25','14:20:00',1.93),('16100','2013-03-25','14:25:00',1.82),('16100','2013-03-25','14:30:00',1.86),('16100','2013-03-25','14:35:00',1.87),('16100','2013-03-25','14:40:00',1.86),('16100','2013-03-25','14:45:00',1.6),('16100','2013-03-25','14:50:00',1.32),('16100','2013-03-25','14:55:00',1.16),('16100','2013-03-25','15:00:00',1.29),('16100','2013-03-25','15:05:00',1.49),('16100','2013-03-25','15:10:00',1.31),('16100','2013-03-25','15:15:00',1.15),('16100','2013-03-25','15:20:00',1.19),('16100','2013-03-25','15:25:00',1.26),('16100','2013-03-25','15:30:00',1.52),('16100','2013-03-25','15:35:00',1.36),('16100','2013-03-24','08:15:00',1.07),('16100','2013-03-24','08:50:00',1.82),('16100','2013-03-24','08:55:00',1.5),('16100','2013-03-24','09:20:00',1.21),('16100','2013-03-24','09:25:00',2.19),('16100','2013-03-24','09:30:00',3.73),('16100','2013-03-24','09:35:00',2.12),('16100','2013-03-24','09:40:00',1.9),('16100','2013-03-24','09:45:00',1.74),('16100','2013-03-24','09:50:00',1.64),('16100','2013-03-24','09:55:00',1.86),('16100','2013-03-24','10:00:00',1.53),('16100','2013-03-24','10:05:00',1.58),('16100','2013-03-24','10:10:00',2.86),('16100','2013-03-24','10:15:00',3.58),('16100','2013-03-24','10:20:00',2.23),('16100','2013-03-24','10:40:00',2),('16100','2013-03-24','10:45:00',2.63),('16100','2013-03-24','10:50:00',2.18),('16100','2013-03-24','10:55:00',2.07),('16100','2013-03-24','11:00:00',1.79),('16100','2013-03-24','11:05:00',1.07),('16100','2013-03-24','11:15:00',1.02),('16100','2013-03-24','11:20:00',1.16),('16100','2013-03-24','11:25:00',1.76),('16100','2013-03-24','11:30:00',2.21),('16100','2013-03-24','11:35:00',1.55),('16100','2013-03-24','11:40:00',2.73),('16100','2013-03-24','11:45:00',7.16),('16100','2013-03-24','11:50:00',9.24),('16100','2013-03-24','11:55:00',9.38),('16100','2013-03-24','12:00:00',9.55),('16100','2013-03-24','12:05:00',6.06),('16100','2013-03-24','12:10:00',4.69),('16100','2013-03-24','12:15:00',3.39),('16100','2013-03-24','12:20:00',6.23),('16100','2013-03-24','12:25:00',6.62),('16100','2013-03-24','12:30:00',6.09),('16100','2013-03-24','12:35:00',6.08),('16100','2013-03-24','12:40:00',6.34),('16100','2013-03-24','12:45:00',7.49),('16100','2013-03-24','12:50:00',8.66),('16100','2013-03-24','12:55:00',9.36),('16100','2013-03-24','13:00:00',3.29),('16100','2013-03-24','13:05:00',8.49),('16100','2013-03-24','13:10:00',2.77),('16100','2013-03-24','13:15:00',1.38),('16100','2013-03-24','13:20:00',1.29),('16100','2013-03-24','13:25:00',1.42),('16100','2013-03-24','13:30:00',2.23),('16100','2013-03-24','13:35:00',4.29),('16100','2013-03-24','13:40:00',1.84),('16100','2013-03-24','13:45:00',1.69),('16100','2013-03-24','13:50:00',3.38),('16100','2013-03-24','13:55:00',2.66),('16100','2013-03-24','14:00:00',3.98),('16100','2013-03-24','14:05:00',3.63),('16100','2013-03-24','14:10:00',4.75),('16100','2013-03-24','14:15:00',7.38),('16100','2013-03-24','14:20:00',6.14),('16100','2013-03-24','14:25:00',6.69),('16100','2013-03-24','14:30:00',8.47),('16100','2013-03-24','14:35:00',6.98),('16100','2013-03-24','14:40:00',5.89),('16100','2013-03-24','14:45:00',3.92),('16100','2013-03-24','14:50:00',4.31),('16100','2013-03-24','14:55:00',3.65),('16100','2013-03-24','15:00:00',3.91),('16100','2013-03-24','15:05:00',4.09),('16100','2013-03-24','15:10:00',4.98),('16100','2013-03-24','15:15:00',4.42),('16100','2013-03-24','15:20:00',5.35),('16100','2013-03-24','15:25:00',5.77),('16100','2013-03-24','15:30:00',4.3),('16100','2013-03-24','15:35:00',5.17),('16100','2013-03-24','15:40:00',3.46),('16100','2013-03-24','15:45:00',5.52),('16100','2013-03-24','15:50:00',5.25),('16100','2013-03-24','15:55:00',3.45),('16100','2013-03-24','16:00:00',1.87),('16100','2013-03-24','16:05:00',1.43),('16100','2013-03-24','16:10:00',2.29),('16100','2013-03-24','16:15:00',1.6),('16100','2013-03-24','16:20:00',1.17),('16100','2013-03-24','16:25:00',1.99),('16100','2013-03-24','16:30:00',4.12),('16100','2013-03-24','16:35:00',3.75),('16100','2013-03-24','16:40:00',2.67),('16100','2013-03-24','16:45:00',1.37),('16100','2013-03-24','16:55:00',1.04),('16100','2013-03-23','07:25:00',1.21),('16100','2013-03-23','07:30:00',1.25),('16100','2013-03-23','07:35:00',1.16),('16100','2013-03-23','07:40:00',1.43),('16100','2013-03-23','07:45:00',1.53),('16100','2013-03-23','07:50:00',1.78),('16100','2013-03-23','07:55:00',2.01),('16100','2013-03-23','08:00:00',2.38),('16100','2013-03-23','08:05:00',2.92),('16100','2013-03-23','08:10:00',3.01),('16100','2013-03-23','08:15:00',3.28),('16100','2013-03-23','08:20:00',3.47),('16100','2013-03-23','08:25:00',3.63),('16100','2013-03-23','08:30:00',3.85),('16100','2013-03-23','08:35:00',4.04),('16100','2013-03-23','08:40:00',4.2),('16100','2013-03-23','08:45:00',4.35),('16100','2013-03-23','08:50:00',4.46),('16100','2013-03-23','08:55:00',4.49),('16100','2013-03-23','09:00:00',4.7),('16100','2013-03-23','09:05:00',4.79),('16100','2013-03-23','09:10:00',4.98),('16100','2013-03-23','09:15:00',5.11),('16100','2013-03-23','09:20:00',5.28),('16100','2013-03-23','09:25:00',5.37),('16100','2013-03-23','09:30:00',5.49),('16100','2013-03-23','09:35:00',5.63),('16100','2013-03-23','09:40:00',5.77),('16100','2013-03-23','09:45:00',5.9),('16100','2013-03-23','09:50:00',6.03),('16100','2013-03-23','09:55:00',6.12),('16100','2013-03-23','10:00:00',6.21),('16100','2013-03-23','10:05:00',6.31),('16100','2013-03-23','10:10:00',6.43),('16100','2013-03-23','10:15:00',6.56),('16100','2013-03-23','10:20:00',6.61),('16100','2013-03-23','10:25:00',6.74),('16100','2013-03-23','10:30:00',6.79),('16100','2013-03-23','10:35:00',6.82),('16100','2013-03-23','10:40:00',6.9),('16100','2013-03-23','10:45:00',7),('16100','2013-03-23','10:50:00',7.04),('16100','2013-03-23','10:55:00',7.12),('16100','2013-03-23','11:00:00',7.16),('16100','2013-03-23','11:05:00',7.2),('16100','2013-03-23','11:10:00',7.23),('16100','2013-03-23','11:15:00',7.25),('16100','2013-03-23','11:20:00',7.29),('16100','2013-03-23','11:25:00',7.34),('16100','2013-03-23','11:30:00',7.39),('16100','2013-03-23','11:35:00',7.4),('16100','2013-03-23','11:40:00',7.38),('16100','2013-03-23','11:45:00',7.42),('16100','2013-03-23','11:50:00',7.4),('16100','2013-03-23','11:55:00',7.41),('16100','2013-03-23','12:00:00',7.39),('16100','2013-03-23','12:05:00',7.4),('16100','2013-03-23','12:10:00',7.4),('16100','2013-03-23','12:15:00',7.48),('16100','2013-03-23','12:20:00',7.7),('16100','2013-03-23','12:25:00',7.81),('16100','2013-03-23','12:30:00',7.82),('16100','2013-03-23','12:35:00',7.86),('16100','2013-03-23','12:40:00',7.87),('16100','2013-03-23','12:45:00',7.86),('16100','2013-03-23','12:50:00',7.83),('16100','2013-03-23','12:55:00',7.84),('16100','2013-03-23','13:00:00',7.84),('16100','2013-03-23','13:05:00',7.81),('16100','2013-03-23','13:10:00',7.71),('16100','2013-03-23','13:15:00',7.68),('16100','2013-03-23','13:20:00',7.6),('16100','2013-03-23','13:25:00',7.54),('16100','2013-03-23','13:30:00',7.42),('16100','2013-03-23','13:35:00',7.39),('16100','2013-03-23','13:40:00',7.32),('16100','2013-03-23','13:45:00',7.27),('16100','2013-03-23','13:50:00',7.26),('16100','2013-03-23','13:55:00',7.13),('16100','2013-03-23','14:00:00',7.08),('16100','2013-03-23','14:05:00',7),('16100','2013-03-23','14:10:00',6.91),('16100','2013-03-23','14:15:00',6.78),('16100','2013-03-23','14:20:00',6.64),('16100','2013-03-23','14:25:00',6.48),('16100','2013-03-23','14:30:00',6.25),('16100','2013-03-23','14:35:00',6.03),('16100','2013-03-23','14:40:00',6.02),('16100','2013-03-23','14:45:00',6.03),('16100','2013-03-23','14:50:00',5.78),('16100','2013-03-23','14:55:00',5.64),('16100','2013-03-23','15:00:00',5.55),('16100','2013-03-23','15:05:00',5.49),('16100','2013-03-23','15:10:00',5.22),('16100','2013-03-23','15:15:00',5.24),('16100','2013-03-23','15:20:00',5.2),('16100','2013-03-23','15:25:00',4.94),('16100','2013-03-23','15:30:00',4.68),('16100','2013-03-23','15:35:00',4.73),('16100','2013-03-23','15:40:00',4.42),('16100','2013-03-23','15:45:00',3.7),('16100','2013-03-23','15:50:00',2.31),('16100','2013-03-23','15:55:00',2.24),('16100','2013-03-23','16:00:00',2.1),('16100','2013-03-23','16:05:00',2.25),('16100','2013-03-23','16:10:00',1.83),('16100','2013-03-23','16:15:00',3.17),('16100','2013-03-23','16:20:00',2.7),('16100','2013-03-23','16:25:00',1.57),('16100','2013-03-23','16:30:00',1.82),('16100','2013-03-23','16:35:00',1.81),('16100','2013-03-23','16:40:00',1.17),('16100','2013-03-23','16:45:00',1.4),('16100','2013-03-23','16:50:00',1.13),('16100','2013-03-22','07:20:00',1.14),('16100','2013-03-22','07:25:00',1.16),('16100','2013-03-22','07:30:00',1.45),('16100','2013-03-22','07:35:00',1.5),('16100','2013-03-22','07:40:00',1.84),('16100','2013-03-22','07:45:00',1.85),('16100','2013-03-22','07:50:00',2.23),('16100','2013-03-22','07:55:00',2.48),('16100','2013-03-22','08:00:00',2.8),('16100','2013-03-22','08:05:00',3.07),('16100','2013-03-22','08:10:00',3.21),('16100','2013-03-22','08:15:00',3.4),('16100','2013-03-22','08:20:00',3.57),('16100','2013-03-22','08:25:00',3.69),('16100','2013-03-22','08:30:00',3.92),('16100','2013-03-22','08:35:00',4.02),('16100','2013-03-22','08:40:00',4.25),('16100','2013-03-22','08:45:00',4.44),('16100','2013-03-22','08:50:00',4.6),('16100','2013-03-22','08:55:00',4.75),('16100','2013-03-22','09:00:00',4.98),('16100','2013-03-22','09:05:00',5.09),('16100','2013-03-22','09:10:00',5.21),('16100','2013-03-22','09:15:00',5.33),('16100','2013-03-22','09:20:00',5.34),('16100','2013-03-22','09:25:00',5.64),('16100','2013-03-22','09:30:00',5.7),('16100','2013-03-22','09:35:00',5.79),('16100','2013-03-22','09:40:00',5.78),('16100','2013-03-22','09:45:00',6.17),('16100','2013-03-22','09:50:00',6.21),('16100','2013-03-22','09:55:00',6.34),('16100','2013-03-22','10:00:00',6.37),('16100','2013-03-22','10:05:00',6.44),('16100','2013-03-22','10:10:00',6.42),('16100','2013-03-22','10:15:00',6.42),('16100','2013-03-22','10:20:00',6.57),('16100','2013-03-22','10:25:00',6.64),('16100','2013-03-22','10:30:00',6.77),('16100','2013-03-22','10:35:00',6.76),('16100','2013-03-22','10:40:00',6.91),('16100','2013-03-22','10:45:00',7.11),('16100','2013-03-22','10:50:00',6.82),('16100','2013-03-22','10:55:00',6.8),('16100','2013-03-22','11:00:00',5.93),('16100','2013-03-22','11:05:00',5.62),('16100','2013-03-22','11:10:00',6.18),('16100','2013-03-22','11:15:00',7.11),('16100','2013-03-22','11:20:00',6.45),('16100','2013-03-22','11:25:00',6.94),('16100','2013-03-22','11:30:00',7.17),('16100','2013-03-22','11:35:00',7.65),('16100','2013-03-22','11:40:00',7.35),('16100','2013-03-22','11:45:00',7.03),('16100','2013-03-22','11:50:00',7.14),('16100','2013-03-22','11:55:00',7.42),('16100','2013-03-22','12:00:00',7.47),('16100','2013-03-22','12:05:00',7.38),('16100','2013-03-22','12:10:00',7.35),('16100','2013-03-22','12:15:00',7.14),('16100','2013-03-22','12:20:00',7.58),('16100','2013-03-22','12:25:00',7.34),('16100','2013-03-22','12:30:00',7.58),('16100','2013-03-22','12:35:00',7.47),('16100','2013-03-22','12:40:00',7.47),('16100','2013-03-22','12:45:00',7.67),('16100','2013-03-22','12:50:00',7.65),('16100','2013-03-22','12:55:00',7.23),('16100','2013-03-22','13:00:00',6.79),('16100','2013-03-22','13:05:00',7.38),('16100','2013-03-22','13:10:00',7.36),('16100','2013-03-22','13:15:00',7.46),('16100','2013-03-22','13:20:00',7.57),('16100','2013-03-22','13:25:00',7.41),('16100','2013-03-22','13:30:00',7.11),('16100','2013-03-22','13:35:00',6.32),('16100','2013-03-22','13:40:00',6.85),('16100','2013-03-22','13:45:00',7.18),('16100','2013-03-22','13:50:00',6.97),('16100','2013-03-22','13:55:00',7.16),('16100','2013-03-22','14:00:00',7.24),('16100','2013-03-22','14:05:00',7.07),('16100','2013-03-22','14:10:00',6.77),('16100','2013-03-22','14:15:00',6.65),('16100','2013-03-22','14:20:00',6.49),('16100','2013-03-22','14:25:00',6.61),('16100','2013-03-22','14:30:00',6.48),('16100','2013-03-22','14:35:00',6.3),('16100','2013-03-22','14:40:00',6.02),('16100','2013-03-22','14:45:00',5.66),('16100','2013-03-22','14:50:00',5.84),('16100','2013-03-22','14:55:00',5.69),('16100','2013-03-22','15:00:00',5.47),('16100','2013-03-22','15:05:00',5.65),('16100','2013-03-22','15:10:00',4.92),('16100','2013-03-22','15:15:00',4.8),('16100','2013-03-22','15:20:00',5.06),('16100','2013-03-22','15:25:00',4.95),('16100','2013-03-22','15:30:00',4.39),('16100','2013-03-22','15:35:00',4.47),('16100','2013-03-22','15:40:00',4.31),('16100','2013-03-22','15:45:00',3.65),('16100','2013-03-22','15:50:00',3.18),('16100','2013-03-22','15:55:00',3.26),('16100','2013-03-22','16:00:00',2.88),('16100','2013-03-22','16:05:00',3.29),('16100','2013-03-22','16:10:00',3.72),('16100','2013-03-22','16:15:00',3.54),('16100','2013-03-22','16:20:00',3.04),('16100','2013-03-22','16:25:00',2.79),('16100','2013-03-22','16:30:00',2.4),('16100','2013-03-22','16:35:00',2.45),('16100','2013-03-22','16:40:00',1.95),('16100','2013-03-22','16:45:00',1.81),('16100','2013-03-22','16:50:00',1.74),('16100','2013-03-22','16:55:00',1.67),('16100','2013-03-22','17:00:00',2.04),('16100','2013-03-22','17:05:00',2.06),('16100','2013-03-22','17:10:00',1.72),('16100','2013-03-22','17:15:00',1.43),('16100','2013-03-22','17:20:00',1.21),('16100','2013-03-22','17:25:00',1.05),('16100','2014-03-25','07:15:00',1.05),('16100','2014-03-25','07:20:00',1.2),('16100','2014-03-25','07:25:00',1.33),('16100','2014-03-25','07:30:00',1.76),('16100','2014-03-25','07:35:00',2.01),('16100','2014-03-25','07:40:00',1.42),('16100','2014-03-25','07:45:00',1.45),('16100','2014-03-25','07:50:00',2.68),('16100','2014-03-25','07:55:00',2.9),('16100','2014-03-25','08:00:00',2.81),('16100','2014-03-25','08:05:00',2.95),('16100','2014-03-25','08:10:00',3.17),('16100','2014-03-25','08:15:00',3.51),('16100','2014-03-25','08:20:00',4.52),('16100','2014-03-25','08:25:00',3.22),('16100','2014-03-25','08:30:00',1.65),('16100','2014-03-25','08:35:00',1.41),('16100','2014-03-25','08:40:00',1.54),('16100','2014-03-25','08:45:00',2.06),('16100','2014-03-25','08:50:00',1.87),('16100','2014-03-25','08:55:00',2.16),('16100','2014-03-25','09:00:00',2.6),('16100','2014-03-25','09:05:00',3.24),('16100','2014-03-25','09:10:00',5.42),('16100','2014-03-25','09:15:00',5.37),('16100','2014-03-25','09:20:00',6.33),('16100','2014-03-25','09:25:00',5.64),('16100','2014-03-25','09:30:00',5.57),('16100','2014-03-25','09:35:00',5.69),('16100','2014-03-25','09:40:00',5.82),('16100','2014-03-25','09:45:00',5.97),('16100','2014-03-25','09:50:00',6.07),('16100','2014-03-25','09:55:00',6.3),('16100','2014-03-25','10:00:00',5.06),('16100','2014-03-25','10:05:00',6.45),('16100','2014-03-25','10:10:00',6.5),('16100','2014-03-25','10:15:00',4.53),('16100','2014-03-25','10:20:00',6.07),('16100','2014-03-25','10:25:00',5.04),('16100','2014-03-25','10:30:00',3.01),('16100','2014-03-25','10:35:00',5.81),('16100','2014-03-25','10:40:00',6.43),('16100','2014-03-25','10:45:00',3.88),('16100','2014-03-25','10:50:00',7.63),('16100','2014-03-25','10:55:00',8.39),('16100','2014-03-25','11:00:00',2.5),('16100','2014-03-25','11:05:00',2.31),('16100','2014-03-25','11:10:00',1.57),('16100','2014-03-25','11:15:00',2.54),('16100','2014-03-25','11:20:00',1.63),('16100','2014-03-25','11:25:00',1.27),('16100','2014-03-25','11:30:00',1.26),('16100','2014-03-25','11:35:00',1.25),('16100','2014-03-25','11:40:00',1.16),('16100','2014-03-25','11:45:00',2.82),('16100','2014-03-25','11:50:00',8.01),('16100','2014-03-25','11:55:00',5.71),('16100','2014-03-25','12:00:00',5.16),('16100','2014-03-25','12:05:00',5.08),('16100','2014-03-25','12:10:00',3.13),('16100','2014-03-25','12:15:00',2.47),('16100','2014-03-25','12:20:00',1.69),('16100','2014-03-25','12:25:00',2.44),('16100','2014-03-25','12:30:00',2.89),('16100','2014-03-25','12:35:00',2.97),('16100','2014-03-25','12:40:00',4.46),('16100','2014-03-25','12:45:00',5.17),('16100','2014-03-25','12:50:00',7.13),('16100','2014-03-25','12:55:00',4.96),('16100','2014-03-25','13:00:00',7.87),('16100','2014-03-25','13:05:00',7.22),('16100','2014-03-25','13:10:00',2.83),('16100','2014-03-25','13:15:00',1.73),('16100','2014-03-25','13:20:00',1.67),('16100','2014-03-25','13:25:00',1.67),('16100','2014-03-25','13:30:00',5.35),('16100','2014-03-25','13:35:00',5.55),('16100','2014-03-25','13:40:00',6.54),('16100','2014-03-25','13:45:00',5.16),('16100','2014-03-25','13:50:00',3.72),('16100','2014-03-25','13:55:00',7.43),('16100','2014-03-25','14:00:00',7.23),('16100','2014-03-25','14:05:00',5.44),('16100','2014-03-25','14:10:00',5.58),('16100','2014-03-25','14:15:00',2.63),('16100','2014-03-25','14:20:00',2.76),('16100','2014-03-25','14:25:00',2.09),('16100','2014-03-25','14:30:00',1.4),('16100','2014-03-25','14:35:00',1.09),('16100','2014-03-25','14:55:00',1.02),('16100','2014-03-25','15:00:00',1.21),('16100','2014-03-25','15:05:00',1.78),('16100','2014-03-25','15:10:00',4.41),('16100','2014-03-25','15:15:00',4.87),('16100','2014-03-25','15:20:00',5.6),('16100','2014-03-25','15:25:00',5.01),('16100','2014-03-25','15:30:00',5.25),('16100','2014-03-25','15:35:00',5.1),('16100','2014-03-25','15:40:00',4.67),('16100','2014-03-25','15:45:00',4.34),('16100','2014-03-25','15:50:00',3.59),('16100','2014-03-25','15:55:00',1.42),('16100','2014-03-25','16:00:00',1.04),('16100','2014-03-25','16:15:00',1.87),('16100','2014-03-25','16:20:00',3.46),('16100','2014-03-25','16:25:00',3.34),('16100','2014-03-25','16:30:00',1.83),('16100','2014-03-25','16:35:00',2.11),('16100','2014-03-25','16:40:00',1.01),('16100','2013-03-21','07:20:00',1.1),('16100','2013-03-21','07:25:00',1.28),('16100','2013-03-21','07:30:00',1.49),('16100','2013-03-21','07:35:00',1.7),('16100','2013-03-21','07:40:00',1.9),('16100','2013-03-21','07:45:00',2.1),('16100','2013-03-21','07:50:00',2.28),('16100','2013-03-21','07:55:00',2.51),('16100','2013-03-21','08:00:00',2.75),('16100','2013-03-21','08:05:00',2.95),('16100','2013-03-21','08:10:00',3.13),('16100','2013-03-21','08:15:00',3.34),('16100','2013-03-21','08:20:00',3.52),('16100','2013-03-21','08:25:00',3.71),('16100','2013-03-21','08:30:00',3.93),('16100','2013-03-21','08:35:00',4.14),('16100','2013-03-21','08:40:00',4.3),('16100','2013-03-21','08:45:00',4.44),('16100','2013-03-21','08:50:00',4.6),('16100','2013-03-21','08:55:00',4.77),('16100','2013-03-21','09:00:00',4.93),('16100','2013-03-21','09:05:00',5.06),('16100','2013-03-21','09:10:00',5.21),('16100','2013-03-21','09:15:00',5.32),('16100','2013-03-21','09:20:00',5.39),('16100','2013-03-21','09:25:00',5.52),('16100','2013-03-21','09:30:00',5.64),('16100','2013-03-21','09:35:00',5.8),('16100','2013-03-21','09:40:00',6.05),('16100','2013-03-21','09:45:00',6.08),('16100','2013-03-21','09:50:00',6.29),('16100','2013-03-21','09:55:00',6.47),('16100','2013-03-21','10:00:00',6.44),('16100','2013-03-21','10:05:00',6.55),('16100','2013-03-21','10:10:00',6.72),('16100','2013-03-21','10:15:00',6.78),('16100','2013-03-21','10:20:00',6.92),('16100','2013-03-21','10:25:00',7.04),('16100','2013-03-21','10:30:00',7.1),('16100','2013-03-21','10:35:00',7.19),('16100','2013-03-21','10:40:00',7.18),('16100','2013-03-21','10:45:00',7.27),('16100','2013-03-21','10:50:00',7.38),('16100','2013-03-21','10:55:00',7.46),('16100','2013-03-21','11:00:00',7.57),('16100','2013-03-21','11:05:00',7.63),('16100','2013-03-21','11:10:00',7.75),('16100','2013-03-21','11:15:00',7.79),('16100','2013-03-21','11:20:00',7.87),('16100','2013-03-21','11:25:00',7.86),('16100','2013-03-21','11:30:00',7.91),('16100','2013-03-21','11:35:00',7.92),('16100','2013-03-21','11:40:00',8),('16100','2013-03-21','11:45:00',7.99),('16100','2013-03-21','11:50:00',7.97),('16100','2013-03-21','11:55:00',8.1),('16100','2013-03-21','12:00:00',8.21),('16100','2013-03-21','12:05:00',8.21),('16100','2013-03-21','12:10:00',8.2),('16100','2013-03-21','12:15:00',8.19),('16100','2013-03-21','12:20:00',8.23),('16100','2013-03-21','12:25:00',8.24),('16100','2013-03-21','12:30:00',8.27),('16100','2013-03-21','12:35:00',8.25),('16100','2013-03-21','12:40:00',8.29),('16100','2013-03-21','12:45:00',8.27),('16100','2013-03-21','12:50:00',7.39),('16100','2013-03-21','12:55:00',7.77),('16100','2013-03-21','13:00:00',8.06),('16100','2013-03-21','13:05:00',8.17),('16100','2013-03-21','13:10:00',8.1),('16100','2013-03-21','13:15:00',8),('16100','2013-03-21','13:20:00',7.73),('16100','2013-03-21','13:25:00',7.43),('16100','2013-03-21','13:30:00',7.8),('16100','2013-03-21','13:35:00',7.03),('16100','2013-03-21','13:40:00',6.11),('16100','2013-03-21','13:45:00',7.48),('16100','2013-03-21','13:50:00',7.61),('16100','2013-03-21','13:55:00',7.47),('16100','2013-03-21','14:00:00',7.38),('16100','2013-03-21','14:05:00',7.3),('16100','2013-03-21','14:10:00',7.28),('16100','2013-03-21','14:15:00',7.13),('16100','2013-03-21','14:20:00',6.98),('16100','2013-03-21','14:25:00',6.93),('16100','2013-03-21','14:30:00',6.84),('16100','2013-03-21','14:35:00',6.76),('16100','2013-03-21','14:40:00',6.61),('16100','2013-03-21','14:45:00',6.31),('16100','2013-03-21','14:50:00',6.45),('16100','2013-03-21','14:55:00',6.39),('16100','2013-03-21','15:00:00',6.24),('16100','2013-03-21','15:05:00',6.07),('16100','2013-03-21','15:10:00',5.46),('16100','2013-03-21','15:15:00',4.34),('16100','2013-03-21','15:20:00',4.8),('16100','2013-03-21','15:25:00',4.55),('16100','2013-03-21','15:30:00',4.91),('16100','2013-03-21','15:35:00',4.94),('16100','2013-03-21','15:40:00',4.57),('16100','2013-03-21','15:45:00',4.46),('16100','2013-03-21','15:50:00',4.46),('16100','2013-03-21','15:55:00',3.16),('16100','2013-03-21','16:00:00',2.37),('16100','2013-03-21','16:05:00',2.7),('16100','2013-03-21','16:10:00',3.56),('16100','2013-03-21','16:15:00',3.57),('16100','2013-03-21','16:20:00',2.03),('16100','2013-03-21','16:25:00',2.76),('16100','2013-03-21','16:30:00',3.1),('16100','2013-03-21','16:35:00',3.21),('16100','2013-03-21','16:40:00',2.97),('16100','2013-03-21','16:45:00',2.83),('16100','2013-03-21','16:50:00',2.76),('16100','2013-03-21','16:55:00',2.55),('16100','2013-03-21','17:00:00',2.22),('16100','2013-03-21','17:05:00',1.86),('16100','2013-03-21','17:10:00',1.57),('16100','2013-03-21','17:15:00',1.61),('16100','2013-03-20','07:15:00',1.06),('16100','2013-03-20','07:20:00',1.66),('16100','2013-03-20','07:25:00',1.78),('16100','2013-03-20','07:30:00',1.82),('16100','2013-03-20','07:35:00',2.04),('16100','2013-03-20','07:40:00',2.42),('16100','2013-03-20','07:45:00',3.1),('16100','2013-03-20','07:50:00',3.07),('16100','2013-03-20','08:00:00',2.11),('16100','2013-03-20','08:05:00',2.61),('16100','2013-03-20','08:10:00',3.35),('16100','2013-03-20','08:15:00',3.53),('16100','2013-03-20','08:20:00',3.74),('16100','2013-03-20','08:25:00',3.94),('16100','2013-03-20','08:30:00',4.12),('16100','2013-03-20','08:35:00',4.35),('16100','2013-03-20','08:40:00',4.59),('16100','2013-03-20','08:45:00',4.89),('16100','2013-03-20','08:50:00',5.66),('16100','2013-03-20','08:55:00',2.53),('16100','2013-03-20','09:00:00',3.5),('16100','2013-03-20','09:05:00',4.86),('16100','2013-03-20','09:10:00',5.69),('16100','2013-03-20','09:15:00',5.78),('16100','2013-03-20','09:20:00',5.92),('16100','2013-03-20','09:25:00',6.02),('16100','2013-03-20','09:30:00',6.15),('16100','2013-03-20','09:35:00',6.31),('16100','2013-03-20','09:40:00',6.45),('16100','2013-03-20','09:45:00',6.59),('16100','2013-03-20','09:50:00',6.71),('16100','2013-03-20','09:55:00',6.78),('16100','2013-03-20','10:00:00',6.83),('16100','2013-03-20','10:05:00',6.98),('16100','2013-03-20','10:10:00',7.22),('16100','2013-03-20','10:15:00',6.73),('16100','2013-03-20','10:20:00',7.58),('16100','2013-03-20','10:25:00',7.26),('16100','2013-03-20','10:30:00',7.29),('16100','2013-03-20','10:35:00',7.39),('16100','2013-03-20','10:40:00',7.5),('16100','2013-03-20','10:45:00',7.65),('16100','2013-03-20','10:50:00',7.79),('16100','2013-03-20','10:55:00',7.88),('16100','2013-03-20','11:00:00',7.96),('16100','2013-03-20','11:05:00',8.08),('16100','2013-03-20','11:10:00',8.1),('16100','2013-03-20','11:15:00',8.12),('16100','2013-03-20','11:20:00',8.18),('16100','2013-03-20','11:25:00',8.22),('16100','2013-03-20','11:30:00',8.31),('16100','2013-03-20','11:35:00',8.41),('16100','2013-03-20','11:40:00',8.46),('16100','2013-03-20','11:45:00',8.5),('16100','2013-03-20','11:50:00',8.56),('16100','2013-03-20','11:55:00',8.55),('16100','2013-03-20','12:00:00',8.5),('16100','2013-03-20','12:05:00',8.54),('16100','2013-03-20','12:10:00',8.53),('16100','2013-03-20','12:15:00',8.55),('16100','2013-03-20','12:20:00',8.59),('16100','2013-03-20','12:25:00',8.62),('16100','2013-03-20','12:30:00',8.61),('16100','2013-03-20','12:35:00',8.63),('16100','2013-03-20','12:40:00',8.63),('16100','2013-03-20','12:45:00',8.57),('16100','2013-03-20','12:50:00',8.5),('16100','2013-03-20','12:55:00',8.46),('16100','2013-03-20','13:00:00',8.4),('16100','2013-03-20','13:05:00',8.41),('16100','2013-03-20','13:10:00',8.33),('16100','2013-03-20','13:15:00',8.25),('16100','2013-03-20','13:20:00',8.23),('16100','2013-03-20','13:25:00',8.15),('16100','2013-03-20','13:30:00',8.11),('16100','2013-03-20','13:35:00',8.04),('16100','2013-03-20','13:40:00',7.99),('16100','2013-03-20','13:45:00',7.9),('16100','2013-03-20','13:50:00',7.84),('16100','2013-03-20','13:55:00',7.76),('16100','2013-03-20','14:00:00',7.63),('16100','2013-03-20','14:05:00',7.54),('16100','2013-03-20','14:10:00',7.45),('16100','2013-03-20','14:15:00',7.36),('16100','2013-03-20','14:20:00',7.22),('16100','2013-03-20','14:25:00',7.08),('16100','2013-03-20','14:30:00',6.95),('16100','2013-03-20','14:35:00',6.85),('16100','2013-03-20','14:40:00',6.73),('16100','2013-03-20','14:45:00',6.62),('16100','2013-03-20','14:50:00',6.47),('16100','2013-03-20','14:55:00',6.33),('16100','2013-03-20','15:00:00',6.28),('16100','2013-03-20','15:05:00',6.14),('16100','2013-03-20','15:10:00',5.92),('16100','2013-03-20','15:15:00',5.79),('16100','2013-03-20','15:20:00',5.62),('16100','2013-03-20','15:25:00',5.49),('16100','2013-03-20','15:30:00',5.36),('16100','2013-03-20','15:35:00',5.22),('16100','2013-03-20','15:40:00',5.07),('16100','2013-03-20','15:45:00',4.89),('16100','2013-03-20','15:50:00',4.68),('16100','2013-03-20','15:55:00',4.46),('16100','2013-03-20','16:00:00',4.32),('16100','2013-03-20','16:05:00',4.17),('16100','2013-03-20','16:10:00',3.99),('16100','2013-03-20','16:15:00',3.81),('16100','2013-03-20','16:20:00',3.61),('16100','2013-03-20','16:25:00',3.41),('16100','2013-03-20','16:30:00',3.21),('16100','2013-03-20','16:35:00',3.01),('16100','2013-03-20','16:40:00',2.79),('16100','2013-03-20','16:45:00',2.62),('16100','2013-03-20','16:50:00',2.42),('16100','2013-03-20','16:55:00',2.22),('16100','2013-03-20','17:00:00',2.03),('16100','2013-03-20','17:05:00',1.83),('16100','2013-03-20','17:10:00',1.64),('16100','2013-03-20','17:15:00',1.42),('16100','2013-03-20','17:20:00',1.22),('16100','2013-03-20','17:25:00',1.03),('16100','2013-03-19','07:20:00',1.02),('16100','2013-03-19','07:25:00',1.24),('16100','2013-03-19','07:30:00',1.48),('16100','2013-03-19','07:35:00',1.71),('16100','2013-03-19','07:40:00',1.88),('16100','2013-03-19','07:45:00',2.03),('16100','2013-03-19','07:50:00',2.26),('16100','2013-03-19','07:55:00',2.7),('16100','2013-03-19','08:00:00',1.71),('16100','2013-03-19','08:05:00',2.05),('16100','2013-03-19','08:10:00',3),('16100','2013-03-19','08:15:00',3.29),('16100','2013-03-19','08:20:00',3.46),('16100','2013-03-19','08:25:00',3.66),('16100','2013-03-19','08:30:00',3.89),('16100','2013-03-19','08:35:00',3.58),('16100','2013-03-19','08:40:00',4.03),('16100','2013-03-19','08:45:00',4.23),('16100','2013-03-19','08:50:00',4.21),('16100','2013-03-19','08:55:00',4.19),('16100','2013-03-19','09:00:00',4.71),('16100','2013-03-19','09:05:00',4.03),('16100','2013-03-19','09:10:00',3.06),('16100','2013-03-19','09:15:00',4.53),('16100','2013-03-19','09:20:00',3.66),('16100','2013-03-19','09:25:00',5.92),('16100','2013-03-19','09:30:00',4.37),('16100','2013-03-19','09:35:00',5.15),('16100','2013-03-19','09:40:00',5.71),('16100','2013-03-19','09:45:00',6.1),('16100','2013-03-19','09:50:00',6.26),('16100','2013-03-19','09:55:00',6.24),('16100','2013-03-19','10:00:00',6.81),('16100','2013-03-19','10:05:00',6.71),('16100','2013-03-19','10:10:00',6.74),('16100','2013-03-19','10:15:00',4.98),('16100','2013-03-19','10:20:00',4.23),('16100','2013-03-19','10:25:00',5.1),('16100','2013-03-19','10:30:00',5.63),('16100','2013-03-19','10:35:00',6.15),('16100','2013-03-19','10:40:00',4.24),('16100','2013-03-19','10:45:00',3.75),('16100','2013-03-19','10:50:00',5.8),('16100','2013-03-19','10:55:00',5.41),('16100','2013-03-19','11:00:00',4.63),('16100','2013-03-19','11:05:00',5.56),('16100','2013-03-19','11:10:00',4.14),('16100','2013-03-19','11:15:00',4.59),('16100','2013-03-19','11:20:00',4.77),('16100','2013-03-19','11:25:00',4.36),('16100','2013-03-19','11:30:00',4.47),('16100','2013-03-19','11:35:00',5.01),('16100','2013-03-19','11:40:00',4.13),('16100','2013-03-19','11:45:00',3.68),('16100','2013-03-19','11:50:00',3.56),('16100','2013-03-19','11:55:00',3.7),('16100','2013-03-19','12:00:00',3.82),('16100','2013-03-19','12:05:00',3.72),('16100','2013-03-19','12:10:00',3.3),('16100','2013-03-19','12:15:00',2.72),('16100','2013-03-19','12:20:00',2.34),('16100','2013-03-19','12:25:00',1.84),('16100','2013-03-19','12:30:00',1.68),('16100','2013-03-19','12:35:00',1.87),('16100','2013-03-19','12:40:00',1.45),('16100','2013-03-19','12:45:00',1.38),('16100','2013-03-19','12:50:00',1.98),('16100','2013-03-19','12:55:00',2.85),('16100','2013-03-19','13:00:00',2.13),('16100','2013-03-19','13:05:00',1.68),('16100','2013-03-19','13:10:00',1.81),('16100','2013-03-19','13:15:00',1.59),('16100','2013-03-19','13:20:00',1.8),('16100','2013-03-19','13:25:00',2.16),('16100','2013-03-19','13:30:00',2.42),('16100','2013-03-19','13:35:00',2.32),('16100','2013-03-19','13:40:00',3.2),('16100','2013-03-19','13:45:00',3.25),('16100','2013-03-19','13:50:00',2.62),('16100','2013-03-19','13:55:00',2.74),('16100','2013-03-19','14:00:00',2.58),('16100','2013-03-19','14:05:00',2.04),('16100','2013-03-19','14:10:00',2.03),('16100','2013-03-19','14:15:00',2.85),('16100','2013-03-19','14:20:00',3.48),('16100','2013-03-19','14:25:00',3.61),('16100','2013-03-19','14:30:00',3.34),('16100','2013-03-19','14:35:00',2.28),('16100','2013-03-19','14:40:00',1.74),('16100','2013-03-19','14:45:00',1.7),('16100','2013-03-19','14:50:00',1.24),('16100','2013-03-19','15:10:00',1.03),('16100','2013-03-18','07:25:00',1.16),('16100','2013-03-18','07:30:00',1.35),('16100','2013-03-18','07:35:00',1.56),('16100','2013-03-18','07:40:00',1.8),('16100','2013-03-18','07:45:00',2.01),('16100','2013-03-18','07:50:00',2.26),('16100','2013-03-18','07:55:00',2.22),('16100','2013-03-18','08:00:00',2.05),('16100','2013-03-18','08:05:00',2.76),('16100','2013-03-18','08:10:00',2.82),('16100','2013-03-18','08:15:00',2.95),('16100','2013-03-18','08:20:00',3.27),('16100','2013-03-18','08:25:00',3.53),('16100','2013-03-18','08:30:00',3.82),('16100','2013-03-18','08:35:00',4.1),('16100','2013-03-18','08:40:00',4.27),('16100','2013-03-18','08:45:00',4.42),('16100','2013-03-18','08:50:00',4.6),('16100','2013-03-18','08:55:00',4.74),('16100','2013-03-18','09:00:00',4.92),('16100','2013-03-18','09:05:00',5.12),('16100','2013-03-18','09:10:00',5.27),('16100','2013-03-18','09:15:00',5.42),('16100','2013-03-18','09:20:00',5.57),('16100','2013-03-18','09:25:00',5.71),('16100','2013-03-18','09:30:00',5.9),('16100','2013-03-18','09:35:00',6.04),('16100','2013-03-18','09:40:00',6.24),('16100','2013-03-18','09:45:00',6.4),('16100','2013-03-18','09:50:00',6.61),('16100','2013-03-18','09:55:00',5.44),('16100','2013-03-18','10:00:00',5.34),('16100','2013-03-18','10:05:00',6.94),('16100','2013-03-18','10:10:00',7.01),('16100','2013-03-18','10:15:00',7.07),('16100','2013-03-18','10:20:00',7.21),('16100','2013-03-18','10:25:00',7.36),('16100','2013-03-18','10:30:00',7.53),('16100','2013-03-18','10:35:00',7.64),('16100','2013-03-18','10:40:00',7.7),('16100','2013-03-18','10:45:00',7.77),('16100','2013-03-18','10:50:00',7.91),('16100','2013-03-18','10:55:00',8),('16100','2013-03-18','11:00:00',8.1),('16100','2013-03-18','11:05:00',8.15),('16100','2013-03-18','11:10:00',8.2),('16100','2013-03-18','11:15:00',8.28),('16100','2013-03-18','11:20:00',8.28),('16100','2013-03-18','11:25:00',8.39),('16100','2013-03-18','11:30:00',8.16),('16100','2013-03-18','11:35:00',6.23),('16100','2013-03-18','11:40:00',6.36),('16100','2013-03-18','11:45:00',7.02),('16100','2013-03-18','11:50:00',8.24),('16100','2013-03-18','11:55:00',8.58),('16100','2013-03-18','12:00:00',8.57),('16100','2013-03-18','12:05:00',8.62),('16100','2013-03-18','12:10:00',8.52),('16100','2013-03-18','12:15:00',8.55),('16100','2013-03-18','12:20:00',8.42),('16100','2013-03-18','12:25:00',8.2),('16100','2013-03-18','12:30:00',8.4),('16100','2013-03-18','12:35:00',8.41),('16100','2013-03-18','12:40:00',8.46),('16100','2013-03-18','12:45:00',8.14),('16100','2013-03-18','12:50:00',8.23),('16100','2013-03-18','12:55:00',8.18),('16100','2013-03-18','13:00:00',8.3),('16100','2013-03-18','13:05:00',8.11),('16100','2013-03-18','13:10:00',8.17),('16100','2013-03-18','13:15:00',8.06),('16100','2013-03-18','13:20:00',8.03),('16100','2013-03-18','13:25:00',8.02),('16100','2013-03-18','13:30:00',7.87),('16100','2013-03-18','13:35:00',7.77),('16100','2013-03-18','13:40:00',7.66),('16100','2013-03-18','13:45:00',7.43),('16100','2013-03-18','13:50:00',7.64),('16100','2013-03-18','13:55:00',7.53),('16100','2013-03-18','14:00:00',7.43),('16100','2013-03-18','14:05:00',7.38),('16100','2013-03-18','14:10:00',7.31),('16100','2013-03-18','14:15:00',7.19),('16100','2013-03-18','14:20:00',7.01),('16100','2013-03-18','14:25:00',6.92),('16100','2013-03-18','14:30:00',6.87),('16100','2013-03-18','14:35:00',6.77),('16100','2013-03-18','14:40:00',6.66),('16100','2013-03-18','14:45:00',6.55),('16100','2013-03-18','14:50:00',6.41),('16100','2013-03-18','14:55:00',6.24),('16100','2013-03-18','15:00:00',6.13),('16100','2013-03-18','15:05:00',5.94),('16100','2013-03-18','15:10:00',5.78),('16100','2013-03-18','15:15:00',5.66),('16100','2013-03-18','15:20:00',5.54),('16100','2013-03-18','15:25:00',5.41),('16100','2013-03-18','15:30:00',5.28),('16100','2013-03-18','15:35:00',5.11),('16100','2013-03-18','15:40:00',4.93),('16100','2013-03-18','15:45:00',4.8),('16100','2013-03-18','15:50:00',4.61),('16100','2013-03-18','15:55:00',4.4),('16100','2013-03-18','16:00:00',4.28),('16100','2013-03-18','16:05:00',4.06),('16100','2013-03-18','16:10:00',3.91),('16100','2013-03-18','16:15:00',3.76),('16100','2013-03-18','16:20:00',3.54),('16100','2013-03-18','16:25:00',3.37),('16100','2013-03-18','16:30:00',3.21),('16100','2013-03-18','16:35:00',2.75),('16100','2013-03-18','16:40:00',2.77),('16100','2013-03-18','16:45:00',2.43),('16100','2013-03-18','16:50:00',1.73),('16100','2013-03-18','16:55:00',1.99),('16100','2013-03-18','17:00:00',1.26),('16100','2013-03-18','17:10:00',1.2),('16100','2013-03-18','17:15:00',1.53),('16100','2013-03-18','17:20:00',1.31),('16100','2013-03-18','17:25:00',1.13),('16100','2013-03-17','08:20:00',1.17),('16100','2013-03-17','08:25:00',1.18),('16100','2013-03-17','08:35:00',1.39),('16100','2013-03-17','08:40:00',1.95),('16100','2013-03-17','08:45:00',1.86),('16100','2013-03-17','08:50:00',1.59),('16100','2013-03-17','09:40:00',1.18),('16100','2013-03-17','09:45:00',1.16),('16100','2013-03-17','09:50:00',1.5),('16100','2013-03-17','09:55:00',1.97),('16100','2013-03-17','10:00:00',2.37),('16100','2013-03-17','10:05:00',3.19),('16100','2013-03-17','10:10:00',3.52),('16100','2013-03-17','10:15:00',3.68),('16100','2013-03-17','10:20:00',4.72),('16100','2013-03-17','10:25:00',6.06),('16100','2013-03-17','10:30:00',3.72),('16100','2013-03-17','10:35:00',2.99),('16100','2013-03-17','10:40:00',2.65),('16100','2013-03-17','10:45:00',3.23),('16100','2013-03-17','10:50:00',1.81),('16100','2013-03-17','10:55:00',1.65),('16100','2013-03-17','11:00:00',1.89),('16100','2013-03-17','11:05:00',2.2),('16100','2013-03-17','11:10:00',2.67),('16100','2013-03-17','11:15:00',3.34),('16100','2013-03-17','11:20:00',3.52),('16100','2013-03-17','11:25:00',3.65),('16100','2013-03-17','11:30:00',4.08),('16100','2013-03-17','11:35:00',3.28),('16100','2013-03-17','11:40:00',2.42),('16100','2013-03-17','11:45:00',1.97),('16100','2013-03-17','11:50:00',1.82),('16100','2013-03-17','11:55:00',2.07),('16100','2013-03-17','12:00:00',2.41),('16100','2013-03-17','12:05:00',3.48),('16100','2013-03-17','12:10:00',4.53),('16100','2013-03-17','12:15:00',7.1),('16100','2013-03-17','12:20:00',7.18),('16100','2013-03-17','12:25:00',7.69),('16100','2013-03-17','12:30:00',7.01),('16100','2013-03-17','12:35:00',4.53),('16100','2013-03-17','12:40:00',3.42),('16100','2013-03-17','12:45:00',5.46),('16100','2013-03-17','12:50:00',6.44),('16100','2013-03-17','12:55:00',5.26),('16100','2013-03-17','13:00:00',2.79),('16100','2013-03-17','13:05:00',3.82),('16100','2013-03-17','13:10:00',2.3),('16100','2013-03-17','13:15:00',1.41),('16100','2013-03-17','13:20:00',3.27),('16100','2013-03-17','13:25:00',3.83),('16100','2013-03-17','13:30:00',1.78),('16100','2013-03-17','13:35:00',2.13),('16100','2013-03-17','13:40:00',2.56),('16100','2013-03-17','13:45:00',2.23),('16100','2013-03-17','13:50:00',1.85),('16100','2013-03-17','13:55:00',1.59),('16100','2013-03-17','14:00:00',3.15),('16100','2013-03-17','14:05:00',2.64),('16100','2013-03-17','14:10:00',3.41),('16100','2013-03-17','14:15:00',1.6),('16100','2013-03-17','14:20:00',1.5),('16100','2013-03-17','14:25:00',1.34),('16100','2013-03-17','14:30:00',1.06),('16100','2013-03-17','14:35:00',1.6),('16100','2013-03-17','14:40:00',1.55),('16100','2013-03-17','14:55:00',1.44),('16100','2013-03-17','15:00:00',1.27),('16100','2013-03-17','15:05:00',1.24),('16100','2013-03-17','15:15:00',1.06),('16100','2013-03-16','08:05:00',1.22),('16100','2013-03-16','08:10:00',1.31),('16100','2013-03-16','08:15:00',1.48),('16100','2013-03-16','08:20:00',2.1),('16100','2013-03-16','08:25:00',2.52),('16100','2013-03-16','08:30:00',2.17),('16100','2013-03-16','08:35:00',1.94),('16100','2013-03-16','08:40:00',2.09),('16100','2013-03-16','08:45:00',2.47),('16100','2013-03-16','08:50:00',2.22),('16100','2013-03-16','08:55:00',1.93),('16100','2013-03-16','09:00:00',2.22),('16100','2013-03-16','09:05:00',2.85),('16100','2013-03-16','09:10:00',2.94),('16100','2013-03-16','09:15:00',2.83),('16100','2013-03-16','09:20:00',2.5),('16100','2013-03-16','09:25:00',2.02),('16100','2013-03-16','09:30:00',2.47),('16100','2013-03-16','09:35:00',2.53),('16100','2013-03-16','09:40:00',2.41),('16100','2013-03-16','09:45:00',2.61),('16100','2013-03-16','09:50:00',2.87),('16100','2013-03-16','09:55:00',3),('16100','2013-03-16','10:00:00',3.2),('16100','2013-03-16','10:05:00',2.68),('16100','2013-03-16','10:10:00',2.86),('16100','2013-03-16','10:15:00',2.97),('16100','2013-03-16','10:20:00',3.06),('16100','2013-03-16','10:25:00',3.25),('16100','2013-03-16','10:30:00',3.1),('16100','2013-03-16','10:35:00',3.02),('16100','2013-03-16','10:40:00',2.99),('16100','2013-03-16','10:45:00',3.1),('16100','2013-03-16','10:50:00',2.45),('16100','2013-03-16','10:55:00',2.19),('16100','2013-03-16','11:00:00',2.01),('16100','2013-03-16','11:05:00',2.19),('16100','2013-03-16','11:10:00',2.45),('16100','2013-03-16','11:15:00',2.95),('16100','2013-03-16','11:20:00',3.51),('16100','2013-03-16','11:25:00',2.98),('16100','2013-03-16','11:30:00',2.72),('16100','2013-03-16','11:35:00',2.53),('16100','2013-03-16','11:40:00',2.35),('16100','2013-03-16','11:45:00',2.11),('16100','2013-03-16','11:50:00',1.93),('16100','2013-03-16','11:55:00',1.82),('16100','2013-03-16','12:00:00',1.68),('16100','2013-03-16','12:05:00',1.9),('16100','2013-03-16','12:10:00',2.54),('16100','2013-03-16','12:15:00',3.56),('16100','2013-03-16','12:20:00',4.03),('16100','2013-03-16','12:25:00',4.83),('16100','2013-03-16','12:30:00',4.25),('16100','2013-03-16','12:35:00',3.9),('16100','2013-03-16','12:40:00',4.18),('16100','2013-03-16','12:45:00',3.81),('16100','2013-03-16','12:50:00',3.01),('16100','2013-03-16','12:55:00',2.73),('16100','2013-03-16','13:00:00',2.91),('16100','2013-03-16','13:05:00',3.1),('16100','2013-03-16','13:10:00',3.39),('16100','2013-03-16','13:15:00',2.94),('16100','2013-03-16','13:20:00',2.49),('16100','2013-03-16','13:25:00',3.11),('16100','2013-03-16','13:30:00',4.95),('16100','2013-03-16','13:35:00',4.69),('16100','2013-03-16','13:40:00',2.97),('16100','2013-03-16','13:45:00',2.37),('16100','2013-03-16','13:50:00',2.65),('16100','2013-03-16','13:55:00',3.45),('16100','2013-03-16','14:00:00',3.18),('16100','2013-03-16','14:05:00',3.79),('16100','2013-03-16','14:10:00',4.9),('16100','2013-03-16','14:15:00',4.59),('16100','2013-03-16','14:20:00',4.62),('16100','2013-03-16','14:25:00',3.92),('16100','2013-03-16','14:30:00',3.92),('16100','2013-03-16','14:35:00',4.81),('16100','2013-03-16','14:40:00',3.09),('16100','2013-03-16','14:45:00',2.4),('16100','2013-03-16','14:50:00',1.95),('16100','2013-03-16','14:55:00',2.37),('16100','2013-03-16','15:00:00',2.75),('16100','2013-03-16','15:05:00',4.05),('16100','2013-03-16','15:10:00',5.99),('16100','2013-03-16','15:15:00',3.5),('16100','2013-03-16','15:20:00',4.91),('16100','2013-03-16','15:25:00',4.71),('16100','2013-03-16','15:30:00',2.74),('16100','2013-03-16','15:35:00',2.44),('16100','2013-03-16','15:40:00',1.73),('16100','2013-03-16','15:45:00',1.51),('16100','2013-03-16','15:50:00',1.08),('16100','2013-03-16','15:55:00',1.23),('16100','2013-03-16','16:40:00',1.35),('16100','2013-03-16','16:45:00',1.61),('16100','2013-03-15','07:45:00',1.02),('16100','2013-03-15','07:50:00',1.44),('16100','2013-03-15','07:55:00',2.51),('16100','2013-03-15','08:00:00',1.83),('16100','2013-03-15','08:05:00',2.43),('16100','2013-03-15','08:10:00',3.24),('16100','2013-03-15','08:15:00',2.41),('16100','2013-03-15','08:20:00',2.71),('16100','2013-03-15','08:25:00',3.82),('16100','2013-03-15','08:30:00',4.08),('16100','2013-03-15','08:35:00',4.49),('16100','2013-03-15','08:40:00',4.86),('16100','2013-03-15','08:45:00',4.82),('16100','2013-03-15','08:50:00',5.25),('16100','2013-03-15','08:55:00',2.49),('16100','2013-03-15','09:00:00',4.57),('16100','2013-03-15','09:05:00',5.23),('16100','2013-03-15','09:10:00',5.39),('16100','2013-03-15','09:15:00',5.6),('16100','2013-03-15','09:20:00',5.74),('16100','2013-03-15','09:25:00',5.42),('16100','2013-03-15','09:30:00',6.01),('16100','2013-03-15','09:35:00',6.04),('16100','2013-03-15','09:40:00',4.28),('16100','2013-03-15','09:45:00',4.26),('16100','2013-03-15','09:50:00',6.6),('16100','2013-03-15','09:55:00',4.05),('16100','2013-03-15','10:00:00',4.51),('16100','2013-03-15','10:05:00',4.21),('16100','2013-03-15','10:10:00',3.78),('16100','2013-03-15','10:15:00',3.38),('16100','2013-03-15','10:20:00',3.53),('16100','2013-03-15','10:25:00',3.77),('16100','2013-03-15','10:30:00',6.97),('16100','2013-03-15','10:35:00',7.82),('16100','2013-03-15','10:40:00',7.64),('16100','2013-03-15','10:45:00',7.66),('16100','2013-03-15','10:50:00',7.76),('16100','2013-03-15','10:55:00',7.84),('16100','2013-03-15','11:00:00',7.92),('16100','2013-03-15','11:05:00',7.86),('16100','2013-03-15','11:10:00',7.91),('16100','2013-03-15','11:15:00',7.93),('16100','2013-03-15','11:20:00',8.03),('16100','2013-03-15','11:25:00',8.08),('16100','2013-03-15','11:30:00',8.07),('16100','2013-03-15','11:35:00',8.1),('16100','2013-03-15','11:40:00',8.19),('16100','2013-03-15','11:45:00',8.22),('16100','2013-03-15','11:50:00',8.18),('16100','2013-03-15','11:55:00',8.16),('16100','2013-03-15','12:00:00',8.16),('16100','2013-03-15','12:05:00',8.2),('16100','2013-03-15','12:10:00',8.2),('16100','2013-03-15','12:15:00',8.29),('16100','2013-03-15','12:20:00',8.42),('16100','2013-03-15','12:25:00',8.3),('16100','2013-03-15','12:30:00',8.35),('16100','2013-03-15','12:35:00',8.13),('16100','2013-03-15','12:40:00',7.58),('16100','2013-03-15','12:45:00',5.12),('16100','2013-03-15','12:50:00',8.55),('16100','2013-03-15','12:55:00',8.43),('16100','2013-03-15','13:00:00',8.34),('16100','2013-03-15','13:05:00',8.26),('16100','2013-03-15','13:10:00',8.21),('16100','2013-03-15','13:15:00',8.21),('16100','2013-03-15','13:20:00',8.17),('16100','2013-03-15','13:25:00',7.47),('16100','2013-03-15','13:30:00',3.22),('16100','2013-03-15','13:35:00',7.25),('16100','2013-03-15','13:40:00',4.37),('16100','2013-03-15','13:45:00',3.41),('16100','2013-03-15','13:50:00',6.22),('16100','2013-03-15','13:55:00',4.51),('16100','2013-03-15','14:00:00',6.33),('16100','2013-03-15','14:05:00',4.78),('16100','2013-03-15','14:10:00',6.43),('16100','2013-03-15','14:15:00',1.61),('16100','2013-03-15','14:20:00',5.18),('16100','2013-03-15','14:25:00',5),('16100','2013-03-15','14:30:00',2.71),('16100','2013-03-15','14:35:00',1.4),('16100','2013-03-15','14:40:00',2.41),('16100','2013-03-15','14:45:00',1.09),('16100','2013-03-15','14:50:00',1.4),('16100','2013-03-15','14:55:00',1.09),('16100','2013-03-15','15:10:00',1.27),('16100','2013-03-15','15:15:00',5.05),('16100','2013-03-15','15:20:00',5.82),('16100','2013-03-15','15:25:00',5.65),('16100','2013-03-15','15:30:00',5.49),('16100','2013-03-15','15:35:00',5.25),('16100','2013-03-15','15:40:00',5.11),('16100','2013-03-15','15:45:00',3.56),('16100','2013-03-15','15:50:00',2.17),('16100','2013-03-15','15:55:00',4.51),('16100','2013-03-15','16:00:00',4.34),('16100','2013-03-15','16:05:00',4.22),('16100','2013-03-15','16:10:00',2.69),('16100','2013-03-15','16:15:00',1.27),('16100','2013-03-15','16:20:00',2.28),('16100','2013-03-15','16:25:00',3.77),('16100','2013-03-15','16:30:00',3.55),('16100','2013-03-15','16:35:00',3.46),('16100','2013-03-15','16:40:00',3.18),('16100','2013-03-15','16:45:00',2.95),('16100','2013-03-15','16:50:00',2.74),('16100','2013-03-15','16:55:00',1.45),('16100','2013-03-15','17:00:00',1.16),('16100','2013-03-15','17:15:00',1.47),('16100','2013-03-15','17:20:00',1.33),('16100','2013-03-15','17:25:00',1.08),('16100','2013-03-14','10:05:00',1.07),('16100','2013-03-14','10:10:00',1.03),('16100','2013-03-14','10:15:00',1.05),('16100','2013-03-14','10:20:00',1.17),('16100','2013-03-14','10:25:00',1.43),('16100','2013-03-14','10:30:00',1.76),('16100','2013-03-14','10:35:00',2.1),('16100','2013-03-14','10:40:00',2.24),('16100','2013-03-14','10:45:00',2.04),('16100','2013-03-14','10:50:00',2.23),('16100','2013-03-14','10:55:00',2.59),('16100','2013-03-14','11:00:00',2.71),('16100','2013-03-14','11:05:00',2.21),('16100','2013-03-14','11:10:00',1.62),('16100','2013-03-14','11:15:00',1.59),('16100','2013-03-14','11:20:00',1.53),('16100','2013-03-14','11:25:00',1.72),('16100','2013-03-14','11:30:00',2.17),('16100','2013-03-14','11:35:00',2.46),('16100','2013-03-14','11:40:00',2.96),('16100','2013-03-14','11:45:00',2.95),('16100','2013-03-14','11:50:00',2.64),('16100','2013-03-14','11:55:00',2.94),('16100','2013-03-14','12:00:00',2.84),('16100','2013-03-14','12:05:00',2.79),('16100','2013-03-14','12:10:00',2.67),('16100','2013-03-14','12:15:00',3.26),('16100','2013-03-14','12:20:00',3.39),('16100','2013-03-14','12:25:00',3.38),('16100','2013-03-14','12:30:00',3.09),('16100','2013-03-14','12:35:00',2.63),('16100','2013-03-14','12:40:00',2.18),('16100','2013-03-14','12:45:00',2.22),('16100','2013-03-14','12:50:00',2.23),('16100','2013-03-14','12:55:00',2.05),('16100','2013-03-14','13:00:00',1.93),('16100','2013-03-14','13:05:00',2.18),('16100','2013-03-14','13:10:00',2.68),('16100','2013-03-14','13:15:00',3.25),('16100','2013-03-14','13:20:00',3.56),('16100','2013-03-14','13:25:00',3.43),('16100','2013-03-14','13:30:00',2.63),('16100','2013-03-14','13:35:00',2.49),('16100','2013-03-14','13:40:00',2.23),('16100','2013-03-14','13:45:00',1.85),('16100','2013-03-14','13:50:00',1.9),('16100','2013-03-14','13:55:00',1.68),('16100','2013-03-14','14:00:00',1.41),('16100','2013-03-14','14:05:00',1.24),('16100','2013-03-14','14:10:00',1.07),('16100','2013-03-14','14:35:00',1.19),('16100','2013-03-14','14:40:00',1.55),('16100','2013-03-14','14:45:00',1.8),('16100','2013-03-14','14:50:00',1.92),('16100','2013-03-14','14:55:00',1.89),('16100','2013-03-14','15:00:00',1.88),('16100','2013-03-14','15:05:00',1.91),('16100','2013-03-14','15:10:00',1.88),('16100','2013-03-14','15:15:00',2.15),('16100','2013-03-14','15:20:00',2.51),('16100','2013-03-14','15:25:00',1.98),('16100','2013-03-14','15:30:00',1.57),('16100','2013-03-14','15:35:00',1.45),('16100','2013-03-14','15:40:00',1.39),('16100','2013-03-14','15:45:00',1.28),('16100','2013-03-14','15:50:00',1.19),('16100','2013-03-14','15:55:00',1.14),('16100','2013-03-14','16:00:00',1.08),('16100','2013-03-14','16:05:00',1.01),('16100','2013-03-14','17:00:00',1.56),('16100','2013-03-14','17:05:00',1.62),('16100','2013-03-14','17:10:00',1.09),('16100','2013-03-14','17:15:00',1.43),('16100','2013-03-14','17:20:00',1.01),('16100','2013-03-13','09:40:00',1.1),('16100','2013-03-13','09:45:00',1.22),('16100','2013-03-13','09:50:00',1.3),('16100','2013-03-13','09:55:00',1.28),('16100','2013-03-13','10:00:00',1.2),('16100','2013-03-13','10:05:00',1.18),('16100','2013-03-13','10:10:00',1.18),('16100','2013-03-13','10:15:00',1.17),('16100','2013-03-13','10:20:00',1.15),('16100','2013-03-13','10:25:00',1.05),('16100','2013-03-13','11:20:00',1.09),('16100','2013-03-13','11:25:00',1.17),('16100','2013-03-13','11:30:00',1.12),('16100','2013-03-13','11:35:00',1.01),('16100','2013-03-13','12:20:00',1.09),('16100','2013-03-13','12:25:00',1.18),('16100','2013-03-13','12:30:00',1.34),('16100','2013-03-13','12:35:00',1.53),('16100','2013-03-13','12:40:00',1.66),('16100','2013-03-13','12:45:00',1.61),('16100','2013-03-13','12:50:00',1.49),('16100','2013-03-13','12:55:00',1.65),('16100','2013-03-13','13:00:00',1.64),('16100','2013-03-13','13:05:00',1.87),('16100','2013-03-13','13:10:00',2.08),('16100','2013-03-13','13:15:00',1.91),('16100','2013-03-13','13:20:00',2.01),('16100','2013-03-13','13:25:00',2.42),('16100','2013-03-13','13:30:00',3.08),('16100','2013-03-13','13:35:00',2.92),('16100','2013-03-13','13:40:00',3.05),('16100','2013-03-13','13:45:00',3.19),('16100','2013-03-13','13:50:00',2.56),('16100','2013-03-13','13:55:00',1.98),('16100','2013-03-13','14:00:00',1.69),('16100','2013-03-13','14:05:00',1.96),('16100','2013-03-13','14:10:00',2.32),('16100','2013-03-13','14:15:00',2.52),('16100','2013-03-13','14:20:00',2.12),('16100','2013-03-13','14:25:00',1.21),('16100','2013-03-13','15:05:00',1.33),('16100','2013-03-13','15:10:00',1.41),('16100','2013-03-13','15:15:00',1.54),('16100','2013-03-13','15:20:00',1.68),('16100','2013-03-13','15:25:00',1.65),('16100','2013-03-13','15:30:00',1.21),('16100','2013-03-13','16:25:00',1.01),('16100','2013-03-12','08:10:00',1.11),('16100','2013-03-12','08:50:00',1.01),('16100','2013-03-12','08:55:00',1.06),('16100','2013-03-12','09:00:00',1.02),('16100','2013-03-12','09:05:00',1.12),('16100','2013-03-12','09:10:00',1.65),('16100','2013-03-12','09:15:00',1.71),('16100','2013-03-12','09:20:00',1.24),('16100','2013-03-12','09:25:00',1.06),('16100','2013-03-12','09:30:00',1.07),('16100','2013-03-12','09:40:00',1.29),('16100','2013-03-12','09:45:00',1.77),('16100','2013-03-12','09:50:00',1.14),('16100','2013-03-12','10:05:00',1.11),('16100','2013-03-12','10:10:00',1.41),('16100','2013-03-12','10:15:00',1.94),('16100','2013-03-12','10:20:00',1.43),('16100','2013-03-12','10:30:00',1.67),('16100','2013-03-12','10:35:00',2.67),('16100','2013-03-12','10:40:00',3.88),('16100','2013-03-12','10:45:00',5.21),('16100','2013-03-12','10:50:00',2.61),('16100','2013-03-12','10:55:00',2.42),('16100','2013-03-12','11:00:00',1.62),('16100','2013-03-12','11:05:00',2.99),('16100','2013-03-12','11:10:00',2.67),('16100','2013-03-12','11:15:00',2.93),('16100','2013-03-12','11:20:00',2.34),('16100','2013-03-12','11:25:00',2.65),('16100','2013-03-12','11:30:00',2.43),('16100','2013-03-12','11:35:00',2.58),('16100','2013-03-12','11:40:00',2.35),('16100','2013-03-12','11:45:00',2.52),('16100','2013-03-12','11:50:00',2.17),('16100','2013-03-12','11:55:00',1.74),('16100','2013-03-12','12:35:00',1.31),('16100','2013-03-12','12:40:00',1.56),('16100','2013-03-12','12:45:00',1.7),('16100','2013-03-12','12:50:00',1.87),('16100','2013-03-12','12:55:00',1.81),('16100','2013-03-12','13:00:00',1.59),('16100','2013-03-12','13:05:00',1.42),('16100','2013-03-12','13:10:00',1.45),('16100','2013-03-12','13:15:00',1.27),('16100','2013-03-12','13:20:00',1.03),('16100','2013-03-12','13:30:00',1.34),('16100','2013-03-12','13:35:00',1.99),('16100','2013-03-12','13:40:00',2.51),('16100','2013-03-12','13:45:00',2.02),('16100','2013-03-12','13:50:00',1.41),('16100','2013-03-12','13:55:00',1.18),('16100','2014-03-24','07:15:00',1.34),('16100','2014-03-24','07:20:00',1.62),('16100','2014-03-24','07:25:00',1.78),('16100','2014-03-24','07:30:00',1.96),('16100','2014-03-24','07:35:00',1.53),('16100','2014-03-24','07:40:00',1.51),('16100','2014-03-24','07:45:00',1.67),('16100','2014-03-24','07:50:00',1.85),('16100','2014-03-24','07:55:00',1.54),('16100','2014-03-24','08:00:00',1.68),('16100','2014-03-24','08:05:00',1.79),('16100','2014-03-24','08:10:00',1.91),('16100','2014-03-24','08:15:00',1.89),('16100','2014-03-24','08:20:00',1.76),('16100','2014-03-24','08:25:00',1.64),('16100','2014-03-24','08:30:00',1.57),('16100','2014-03-24','08:35:00',1.76),('16100','2014-03-24','08:40:00',2.23),('16100','2014-03-24','08:45:00',2.72),('16100','2014-03-24','08:50:00',2.79),('16100','2014-03-24','08:55:00',2.95),('16100','2014-03-24','09:00:00',2.79),('16100','2014-03-24','09:05:00',2.9),('16100','2014-03-24','09:10:00',3.08),('16100','2014-03-24','09:15:00',3.91),('16100','2014-03-24','09:20:00',3.95),('16100','2014-03-24','09:25:00',3.36),('16100','2014-03-24','09:30:00',3.03),('16100','2014-03-24','09:35:00',2.98),('16100','2014-03-24','09:40:00',2.93),('16100','2014-03-24','09:45:00',2.99),('16100','2014-03-24','09:50:00',3.3),('16100','2014-03-24','09:55:00',3.64),('16100','2014-03-24','10:00:00',4.22),('16100','2014-03-24','10:05:00',4.56),('16100','2014-03-24','10:10:00',4.78),('16100','2014-03-24','10:15:00',5.14),('16100','2014-03-24','10:20:00',5.7),('16100','2014-03-24','10:25:00',5.05),('16100','2014-03-24','10:30:00',4.15),('16100','2014-03-24','10:35:00',3.69),('16100','2014-03-24','10:40:00',3.47),('16100','2014-03-24','10:45:00',3.07),('16100','2014-03-24','10:50:00',3.12),('16100','2014-03-24','10:55:00',3.72),('16100','2014-03-24','11:00:00',4.16),('16100','2014-03-24','11:05:00',4.61),('16100','2014-03-24','11:10:00',4.87),('16100','2014-03-24','11:15:00',4.89),('16100','2014-03-24','11:20:00',5.28),('16100','2014-03-24','11:25:00',4.79),('16100','2014-03-24','11:30:00',5.95),('16100','2014-03-24','11:35:00',5.97),('16100','2014-03-24','11:40:00',5.46),('16100','2014-03-24','11:45:00',4.54),('16100','2014-03-24','11:50:00',3.62),('16100','2014-03-24','11:55:00',3.06),('16100','2014-03-24','12:00:00',1.99),('16100','2014-03-24','12:05:00',1.63),('16100','2014-03-24','12:10:00',1.47),('16100','2014-03-24','12:15:00',1.49),('16100','2014-03-24','12:20:00',1.66),('16100','2014-03-24','12:25:00',2.06),('16100','2014-03-24','12:30:00',2),('16100','2014-03-24','12:35:00',1.59),('16100','2014-03-24','12:40:00',1.41),('16100','2014-03-24','12:45:00',1.55),('16100','2014-03-24','12:50:00',1.52),('16100','2014-03-24','12:55:00',1.71),('16100','2014-03-24','13:00:00',1.36),('16100','2014-03-24','15:15:00',1.02),('16100','2013-03-11','08:25:00',3.37),('16100','2013-03-11','08:30:00',3.48),('16100','2013-03-11','08:35:00',3.54),('16100','2013-03-11','08:40:00',3.78),('16100','2013-03-11','08:45:00',3.78),('16100','2013-03-11','08:50:00',4.21),('16100','2013-03-11','08:55:00',4.31),('16100','2013-03-11','09:00:00',4.54),('16100','2013-03-11','09:05:00',4.69),('16100','2013-03-11','09:10:00',4.86),('16100','2013-03-11','09:15:00',5.04),('16100','2013-03-11','09:20:00',5.2),('16100','2013-03-11','09:25:00',5.38),('16100','2013-03-11','09:30:00',5.11),('16100','2013-03-11','09:35:00',5.77),('16100','2013-03-11','09:40:00',5.76),('16100','2013-03-11','09:45:00',5.95),('16100','2013-03-11','09:50:00',5.05),('16100','2013-03-11','09:55:00',6.26),('16100','2013-03-11','10:00:00',6.81),('16100','2013-03-11','10:05:00',7.01),('16100','2013-03-11','10:10:00',4.5),('16100','2013-03-11','10:15:00',6.58),('16100','2013-03-11','10:20:00',7.31),('16100','2013-03-11','10:25:00',6.84),('16100','2013-03-11','10:30:00',7.54),('16100','2013-03-11','10:35:00',7.59),('16100','2013-03-11','10:40:00',7.51),('16100','2013-03-11','10:45:00',7.69),('16100','2013-03-11','10:50:00',7.62),('16100','2013-03-11','10:55:00',5.25),('16100','2013-03-11','11:00:00',6.15),('16100','2013-03-11','11:05:00',8.15),('16100','2013-03-11','11:10:00',7.32),('16100','2013-03-11','11:15:00',7.94),('16100','2013-03-11','11:20:00',6.94),('16100','2013-03-11','11:25:00',2.26),('16100','2013-03-11','11:30:00',1.62),('16100','2013-03-11','11:35:00',2.12),('16100','2013-03-11','11:40:00',3.37),('16100','2013-03-11','11:45:00',2.72),('16100','2013-03-11','11:50:00',2.66),('16100','2013-03-11','11:55:00',8.84),('16100','2013-03-11','12:00:00',9.43),('16100','2013-03-11','12:05:00',6.17),('16100','2013-03-11','12:10:00',1.76),('16100','2013-03-11','12:20:00',1.75),('16100','2013-03-11','12:25:00',2.19),('16100','2013-03-11','12:30:00',2.34),('16100','2013-03-11','12:35:00',7.64),('16100','2013-03-11','12:40:00',6.37),('16100','2013-03-11','12:45:00',4.63),('16100','2013-03-11','12:50:00',9.53),('16100','2013-03-11','12:55:00',7.38),('16100','2013-03-11','13:00:00',4.88),('16100','2013-03-11','13:05:00',4.02),('16100','2013-03-11','13:10:00',5.96),('16100','2013-03-11','13:15:00',6.46),('16100','2013-03-11','13:20:00',3.99),('16100','2013-03-11','13:25:00',3),('16100','2013-03-11','13:30:00',3.33),('16100','2013-03-11','13:35:00',3.76),('16100','2013-03-11','13:40:00',6.12),('16100','2013-03-11','13:45:00',5.44),('16100','2013-03-11','13:50:00',7.1),('16100','2013-03-11','13:55:00',6.22),('16100','2013-03-11','14:00:00',6.77),('16100','2013-03-11','14:05:00',7.49),('16100','2013-03-11','14:10:00',4.35),('16100','2013-03-11','14:15:00',5.7),('16100','2013-03-11','14:20:00',5.56),('16100','2013-03-11','14:25:00',5.6),('16100','2013-03-11','14:30:00',2.41),('16100','2013-03-11','14:55:00',3.47),('16100','2013-03-11','15:00:00',4.59),('16100','2013-03-11','15:05:00',2.21),('16100','2013-03-11','15:10:00',3.11),('16100','2013-03-11','15:15:00',4.6),('16100','2013-03-11','15:20:00',2.76),('16100','2013-03-11','15:25:00',2.09),('16100','2013-03-11','15:30:00',1.18),('16100','2013-03-11','15:35:00',1.12),('16100','2013-03-10','07:50:00',1.64),('16100','2013-03-10','07:55:00',2.23),('16100','2013-03-10','08:00:00',1.94),('16100','2013-03-10','08:05:00',1.97),('16100','2013-03-10','08:10:00',2.67),('16100','2013-03-10','08:15:00',2.91),('16100','2013-03-10','08:20:00',3.24),('16100','2013-03-10','08:25:00',3.27),('16100','2013-03-10','08:30:00',3.41),('16100','2013-03-10','08:35:00',3.6),('16100','2013-03-10','08:40:00',3.89),('16100','2013-03-10','08:45:00',2.56),('16100','2013-03-10','08:50:00',3.53),('16100','2013-03-10','08:55:00',4.44),('16100','2013-03-10','09:00:00',4.6),('16100','2013-03-10','09:05:00',4.72),('16100','2013-03-10','09:10:00',4.88),('16100','2013-03-10','09:15:00',5.05),('16100','2013-03-10','09:20:00',5.26),('16100','2013-03-10','09:25:00',5.75),('16100','2013-03-10','09:30:00',5.72),('16100','2013-03-10','09:35:00',5.94),('16100','2013-03-10','09:40:00',5.45),('16100','2013-03-10','09:45:00',3.7),('16100','2013-03-10','09:50:00',1.87),('16100','2013-03-10','09:55:00',1.55),('16100','2013-03-10','10:00:00',2.28),('16100','2013-03-10','10:05:00',2.73),('16100','2013-03-10','10:10:00',3.3),('16100','2013-03-10','10:15:00',2.9),('16100','2013-03-10','10:20:00',2.7),('16100','2013-03-10','10:25:00',2.76),('16100','2013-03-10','10:30:00',2.75),('16100','2013-03-10','10:35:00',2.87),('16100','2013-03-10','10:40:00',3.64),('16100','2013-03-10','10:45:00',3.27),('16100','2013-03-10','10:50:00',3.31),('16100','2013-03-10','10:55:00',2.54),('16100','2013-03-10','11:00:00',2.7),('16100','2013-03-10','11:05:00',2.41),('16100','2013-03-10','11:10:00',1.98),('16100','2013-03-10','11:15:00',2),('16100','2013-03-10','11:20:00',3.37),('16100','2013-03-10','11:25:00',3.66),('16100','2013-03-10','11:30:00',4.94),('16100','2013-03-10','11:35:00',5.77),('16100','2013-03-10','11:40:00',3.6),('16100','2013-03-10','11:45:00',2.83),('16100','2013-03-10','11:50:00',2.64),('16100','2013-03-10','11:55:00',1.78),('16100','2013-03-10','12:00:00',2.14),('16100','2013-03-10','12:05:00',2.07),('16100','2013-03-10','12:10:00',3.7),('16100','2013-03-10','12:15:00',7.41),('16100','2013-03-10','12:20:00',8.6),('16100','2013-03-10','12:25:00',7.18),('16100','2013-03-10','12:30:00',2.46),('16100','2013-03-10','12:35:00',8.95),('16100','2013-03-10','12:40:00',8.53),('16100','2013-03-10','12:45:00',7.49),('16100','2013-03-10','12:50:00',8.6),('16100','2013-03-10','12:55:00',7.18),('16100','2013-03-10','13:00:00',8.31),('16100','2013-03-10','13:05:00',8.27),('16100','2013-03-10','13:10:00',8.09),('16100','2013-03-10','13:15:00',7.82),('16100','2013-03-10','13:20:00',5.91),('16100','2013-03-10','13:25:00',7.76),('16100','2013-03-10','13:30:00',7.78),('16100','2013-03-10','13:35:00',6.36),('16100','2013-03-10','13:40:00',7.03),('16100','2013-03-10','13:45:00',6.88),('16100','2013-03-10','13:50:00',6.4),('16100','2013-03-10','13:55:00',8.21),('16100','2013-03-10','14:00:00',6.21),('16100','2013-03-10','14:05:00',7.68),('16100','2013-03-10','14:10:00',7.25),('16100','2013-03-10','14:15:00',7.52),('16100','2013-03-10','14:20:00',5.26),('16100','2013-03-10','14:25:00',2.77),('16100','2013-03-10','14:30:00',3.01),('16100','2013-03-10','14:35:00',3.51),('16100','2013-03-10','14:40:00',4.54),('16100','2013-03-10','14:45:00',7.12),('16100','2013-03-10','14:50:00',4.4),('16100','2013-03-10','14:55:00',6.46),('16100','2013-03-10','15:00:00',6.16),('16100','2013-03-10','15:05:00',6.43),('16100','2013-03-10','15:10:00',6.42),('16100','2013-03-10','15:15:00',6.04),('16100','2013-03-10','15:20:00',4.22),('16100','2013-03-10','15:25:00',4.12),('16100','2013-03-10','15:30:00',4.95),('16100','2013-03-10','15:35:00',5.25),('16100','2013-03-10','15:40:00',2.95),('16100','2013-03-10','15:45:00',3.54),('16100','2013-03-10','15:50:00',4.85),('16100','2013-03-10','15:55:00',3.92),('16100','2013-03-10','16:00:00',3.51),('16100','2013-03-10','16:05:00',3.54),('16100','2013-03-10','16:10:00',3.29),('16100','2013-03-10','16:15:00',3.47),('16100','2013-03-10','16:20:00',3.25),('16100','2013-03-10','16:25:00',3.06),('16100','2013-03-10','16:30:00',2.91),('16100','2013-03-10','16:35:00',2.28),('16100','2013-03-10','16:40:00',2.16),('16100','2013-03-10','16:45:00',1.48),('16100','2013-03-10','17:00:00',1.05),('16100','2013-03-10','17:05:00',1.26),('16100','2013-03-10','17:10:00',1.13),('16100','2013-03-09','07:35:00',1.15),('16100','2013-03-09','07:40:00',1.31),('16100','2013-03-09','07:45:00',1.59),('16100','2013-03-09','07:50:00',1.84),('16100','2013-03-09','07:55:00',2.02),('16100','2013-03-09','08:00:00',2.2),('16100','2013-03-09','08:05:00',2.46),('16100','2013-03-09','08:10:00',2.26),('16100','2013-03-09','08:15:00',2.63),('16100','2013-03-09','08:20:00',3.09),('16100','2013-03-09','08:25:00',3.3),('16100','2013-03-09','08:30:00',3.48),('16100','2013-03-09','08:35:00',1.8),('16100','2013-03-09','08:40:00',3.46),('16100','2013-03-09','08:45:00',4.01),('16100','2013-03-09','08:50:00',4.22),('16100','2013-03-09','08:55:00',4.4),('16100','2013-03-09','09:00:00',4.58),('16100','2013-03-09','09:05:00',4.72),('16100','2013-03-09','09:10:00',4.87),('16100','2013-03-09','09:15:00',5.04),('16100','2013-03-09','09:20:00',5.17),('16100','2013-03-09','09:25:00',5.32),('16100','2013-03-09','09:30:00',5.54),('16100','2013-03-09','09:35:00',5.74),('16100','2013-03-09','09:40:00',5.81),('16100','2013-03-09','09:45:00',4.39),('16100','2013-03-09','09:50:00',3.92),('16100','2013-03-09','09:55:00',6.39),('16100','2013-03-09','10:00:00',6.63),('16100','2013-03-09','10:05:00',6.01),('16100','2013-03-09','10:10:00',4.63),('16100','2013-03-09','10:15:00',6.74),('16100','2013-03-09','10:20:00',4.98),('16100','2013-03-09','10:25:00',7.1),('16100','2013-03-09','10:30:00',4.25),('16100','2013-03-09','10:35:00',7.35),('16100','2013-03-09','10:40:00',4.92),('16100','2013-03-09','10:45:00',7.33),('16100','2013-03-09','10:50:00',7.27),('16100','2013-03-09','10:55:00',7.27),('16100','2013-03-09','11:00:00',7.29),('16100','2013-03-09','11:05:00',6.92),('16100','2013-03-09','11:10:00',7.58),('16100','2013-03-09','11:15:00',6.36),('16100','2013-03-09','11:20:00',7.74),('16100','2013-03-09','11:25:00',6.72),('16100','2013-03-09','11:30:00',8.15),('16100','2013-03-09','11:35:00',6.9),('16100','2013-03-09','11:40:00',4.83),('16100','2013-03-09','11:45:00',7.14),('16100','2013-03-09','11:50:00',8.04),('16100','2013-03-09','11:55:00',7.75),('16100','2013-03-09','12:00:00',7.37),('16100','2013-03-09','12:05:00',7.76),('16100','2013-03-09','12:10:00',7.86),('16100','2013-03-09','12:15:00',7.97),('16100','2013-03-09','12:20:00',7.84),('16100','2013-03-09','12:25:00',6.24),('16100','2013-03-09','12:30:00',5.68),('16100','2013-03-09','12:35:00',5.33),('16100','2013-03-09','12:40:00',5.67),('16100','2013-03-09','12:45:00',2.93),('16100','2013-03-09','12:50:00',7.33),('16100','2013-03-09','12:55:00',7.09),('16100','2013-03-09','13:00:00',4.68),('16100','2013-03-09','13:05:00',7.26),('16100','2013-03-09','13:10:00',8.14),('16100','2013-03-09','13:15:00',7.9),('16100','2013-03-09','13:20:00',8.17),('16100','2013-03-09','13:25:00',8.3),('16100','2013-03-09','13:30:00',7.55),('16100','2013-03-09','13:35:00',6.19),('16100','2013-03-09','13:40:00',3.29),('16100','2013-03-09','13:45:00',2.68),('16100','2013-03-09','13:50:00',2.59),('16100','2013-03-09','13:55:00',2.65),('16100','2013-03-09','14:00:00',2.61),('16100','2013-03-09','14:05:00',3.27),('16100','2013-03-09','14:10:00',3.1),('16100','2013-03-09','14:15:00',3.16),('16100','2013-03-09','14:20:00',3.49),('16100','2013-03-09','14:25:00',3.81),('16100','2013-03-09','14:30:00',3.46),('16100','2013-03-09','14:35:00',2.58),('16100','2013-03-09','14:40:00',2.58),('16100','2013-03-09','14:45:00',2.11),('16100','2013-03-09','14:50:00',2.66),('16100','2013-03-09','14:55:00',2.13),('16100','2013-03-09','15:00:00',1.25),('16100','2013-03-09','15:05:00',1.49),('16100','2013-03-09','15:10:00',1.4),('16100','2013-03-09','15:15:00',1.49),('16100','2013-03-09','15:20:00',1.11),('16100','2013-03-09','15:50:00',1.2),('16100','2013-03-08','07:45:00',1.51),('16100','2013-03-08','08:10:00',2.6),('16100','2013-03-08','08:15:00',2.84),('16100','2013-03-08','08:20:00',3.08),('16100','2013-03-08','08:25:00',3.23),('16100','2013-03-08','08:30:00',3.42),('16100','2013-03-08','08:35:00',3.58),('16100','2013-03-08','08:40:00',3.75),('16100','2013-03-08','08:45:00',3.97),('16100','2013-03-08','08:50:00',4.15),('16100','2013-03-08','08:55:00',4.32),('16100','2013-03-08','09:00:00',3.83),('16100','2013-03-08','09:05:00',3.28),('16100','2013-03-08','09:10:00',4.28),('16100','2013-03-08','09:15:00',3.11),('16100','2013-03-08','09:20:00',2.63),('16100','2013-03-08','09:25:00',2.85),('16100','2013-03-08','09:30:00',2.14),('16100','2013-03-08','09:35:00',2.15),('16100','2013-03-08','09:40:00',2.84),('16100','2013-03-08','09:45:00',2.48),('16100','2013-03-08','09:50:00',2.05),('16100','2013-03-08','09:55:00',1.59),('16100','2013-03-08','10:05:00',1.23),('16100','2013-03-08','10:10:00',3.06),('16100','2013-03-08','10:15:00',1.51),('16100','2013-03-08','10:20:00',2.28),('16100','2013-03-08','10:25:00',1.87),('16100','2013-03-08','10:30:00',5.86),('16100','2013-03-08','10:35:00',7.55),('16100','2013-03-08','10:40:00',5.18),('16100','2013-03-08','10:45:00',2.72),('16100','2013-03-08','10:50:00',8.3),('16100','2013-03-08','10:55:00',5.53),('16100','2013-03-08','11:00:00',7.62),('16100','2013-03-08','11:05:00',6.07),('16100','2013-03-08','11:10:00',7.55),('16100','2013-03-08','11:15:00',7.62),('16100','2013-03-08','11:20:00',7.71),('16100','2013-03-08','11:25:00',7.83),('16100','2013-03-08','11:30:00',7.63),('16100','2013-03-08','11:35:00',7.71),('16100','2013-03-08','11:40:00',7.76),('16100','2013-03-08','11:45:00',7.78),('16100','2013-03-08','11:50:00',7.73),('16100','2013-03-08','11:55:00',7.84),('16100','2013-03-08','12:00:00',7.81),('16100','2013-03-08','12:05:00',6.25),('16100','2013-03-08','12:10:00',7.78),('16100','2013-03-08','12:15:00',5.45),('16100','2013-03-08','12:20:00',4.69),('16100','2013-03-08','12:25:00',4.58),('16100','2013-03-08','12:30:00',6.27),('16100','2013-03-08','12:35:00',4.23),('16100','2013-03-08','12:40:00',5.06),('16100','2013-03-08','12:45:00',6.04),('16100','2013-03-08','12:50:00',8.25),('16100','2013-03-08','12:55:00',7.86),('16100','2013-03-08','13:00:00',5.39),('16100','2013-03-08','13:05:00',7.57),('16100','2013-03-08','13:10:00',6.74),('16100','2013-03-08','13:15:00',6.36),('16100','2013-03-08','13:20:00',7.39),('16100','2013-03-08','13:25:00',7.28),('16100','2013-03-08','13:30:00',7.56),('16100','2013-03-08','13:35:00',7.12),('16100','2013-03-08','13:40:00',7.27),('16100','2013-03-08','13:45:00',7.32),('16100','2013-03-08','13:50:00',7.23),('16100','2013-03-08','13:55:00',7.13),('16100','2013-03-08','14:00:00',7.03),('16100','2013-03-08','14:05:00',6.98),('16100','2013-03-08','14:10:00',6.91),('16100','2013-03-08','14:15:00',4.28),('16100','2013-03-08','14:20:00',6.66),('16100','2013-03-08','14:25:00',4.91),('16100','2013-03-08','14:30:00',6.56),('16100','2013-03-08','14:35:00',6.25),('16100','2013-03-08','14:40:00',6.15),('16100','2013-03-08','14:45:00',6.08),('16100','2013-03-08','14:50:00',5.96),('16100','2013-03-08','14:55:00',5.79),('16100','2013-03-08','15:00:00',5.72),('16100','2013-03-08','15:05:00',5.58),('16100','2013-03-08','15:10:00',5.46),('16100','2013-03-08','15:15:00',5.36),('16100','2013-03-08','15:20:00',5.22),('16100','2013-03-08','15:25:00',5.01),('16100','2013-03-08','15:30:00',4.89),('16100','2013-03-08','15:35:00',4.75),('16100','2013-03-08','15:40:00',4.65),('16100','2013-03-08','15:45:00',4.52),('16100','2013-03-08','15:50:00',4.29),('16100','2013-03-08','15:55:00',3.93),('16100','2013-03-08','16:00:00',3.53),('16100','2013-03-08','16:05:00',2.92),('16100','2013-03-08','16:10:00',2.87),('16100','2013-03-08','16:15:00',2.54),('16100','2013-03-08','16:20:00',1.13),('16100','2013-03-08','16:25:00',2.13),('16100','2013-03-08','16:30:00',1.82),('16100','2013-03-08','16:35:00',1.9),('16100','2013-03-08','16:40:00',1.77),('16100','2013-03-08','16:45:00',1.48),('16100','2013-03-08','16:50:00',1.06),('16100','2013-03-07','08:25:00',1.56),('16100','2013-03-07','08:30:00',1.87),('16100','2013-03-07','08:35:00',1.67),('16100','2013-03-07','08:40:00',1.95),('16100','2013-03-07','09:05:00',1.15),('16100','2013-03-07','09:10:00',3.5),('16100','2013-03-07','09:15:00',5.02),('16100','2013-03-07','09:20:00',4.86),('16100','2013-03-07','09:25:00',2.07),('16100','2013-03-07','09:30:00',2.42),('16100','2013-03-07','09:35:00',2.48),('16100','2013-03-07','09:40:00',3.38),('16100','2013-03-07','09:45:00',2.48),('16100','2013-03-07','09:50:00',2.33),('16100','2013-03-07','09:55:00',3.79),('16100','2013-03-07','10:00:00',1.92),('16100','2013-03-07','10:05:00',1.7),('16100','2013-03-07','10:10:00',1.84),('16100','2013-03-07','10:15:00',1.82),('16100','2013-03-07','10:20:00',3.35),('16100','2013-03-07','10:25:00',2.81),('16100','2013-03-07','10:30:00',2.32),('16100','2013-03-07','10:35:00',1.39),('16100','2013-03-07','10:40:00',1.29),('16100','2013-03-07','10:45:00',1.4),('16100','2013-03-07','11:40:00',1.01),('16100','2013-03-07','11:55:00',1.35),('16100','2013-03-07','12:00:00',1.6),('16100','2013-03-07','12:05:00',2.1),('16100','2013-03-07','12:10:00',1.71),('16100','2013-03-07','12:15:00',2.37),('16100','2013-03-07','12:20:00',3.91),('16100','2013-03-07','12:25:00',2.8),('16100','2013-03-07','12:30:00',2.02),('16100','2013-03-07','12:35:00',1.69),('16100','2013-03-07','12:40:00',1.9),('16100','2013-03-07','12:45:00',1.99),('16100','2013-03-07','12:50:00',3.48),('16100','2013-03-07','12:55:00',2.74),('16100','2013-03-07','13:00:00',3.6),('16100','2013-03-07','13:05:00',3),('16100','2013-03-07','13:10:00',2.57),('16100','2013-03-07','13:15:00',1.97),('16100','2013-03-07','13:20:00',1.73),('16100','2013-03-07','13:25:00',1.63),('16100','2013-03-07','13:30:00',1.83),('16100','2013-03-07','13:35:00',2.02),('16100','2013-03-07','13:40:00',1.07),('16100','2013-03-07','13:45:00',1.44),('16100','2013-03-07','17:10:00',1.47),('16100','2013-03-07','17:15:00',1.08),('16100','2013-03-06','08:45:00',1.15),('16100','2013-03-06','08:50:00',1.79),('16100','2013-03-06','08:55:00',2.18),('16100','2013-03-06','09:00:00',1.31),('16100','2013-03-06','09:15:00',1.2),('16100','2013-03-06','09:20:00',1.65),('16100','2013-03-06','09:25:00',1.51),('16100','2013-03-06','10:20:00',1.17),('16100','2013-03-06','10:30:00',1.06),('16100','2013-03-06','10:35:00',1.94),('16100','2013-03-06','10:40:00',1.7),('16100','2013-03-06','10:45:00',1.89),('16100','2013-03-06','10:50:00',2.65),('16100','2013-03-06','10:55:00',3.2),('16100','2013-03-06','11:00:00',2.15),('16100','2013-03-06','11:05:00',1.76),('16100','2013-03-06','11:10:00',1.72),('16100','2013-03-06','11:15:00',1.16),('16100','2013-03-06','11:35:00',1.07),('16100','2013-03-06','11:40:00',4.43),('16100','2013-03-06','11:45:00',6.31),('16100','2013-03-06','11:50:00',5.19),('16100','2013-03-06','11:55:00',4.08),('16100','2013-03-06','12:00:00',3.68),('16100','2013-03-06','12:05:00',2.77),('16100','2013-03-06','12:10:00',1.32),('16100','2013-03-06','12:20:00',2.47),('16100','2013-03-06','12:25:00',4.83),('16100','2013-03-06','12:30:00',2.49),('16100','2013-03-06','12:35:00',1.35),('16100','2013-03-06','13:00:00',1.63),('16100','2013-03-06','13:05:00',3.21),('16100','2013-03-06','13:10:00',5.14),('16100','2013-03-06','13:15:00',5.81),('16100','2013-03-06','13:20:00',2.78),('16100','2013-03-06','13:25:00',1.75),('16100','2013-03-06','13:30:00',2.33),('16100','2013-03-06','13:35:00',3.04),('16100','2013-03-06','13:40:00',2.1),('16100','2013-03-06','14:00:00',1.07),('16100','2013-03-06','14:05:00',1.74),('16100','2013-03-06','14:10:00',1.36),('16100','2013-03-06','14:15:00',1.23),('16100','2013-03-06','14:20:00',1.41),('16100','2013-03-06','14:25:00',1.84),('16100','2013-03-06','14:40:00',1.4),('16100','2013-03-06','14:45:00',1.56),('16100','2013-03-06','14:50:00',1.05),('16100','2013-03-06','15:30:00',1.01),('16100','2013-03-06','15:35:00',1.22),('16100','2013-03-06','15:40:00',1.68),('16100','2013-03-06','15:45:00',1.55),('16100','2013-03-06','15:50:00',1.38),('16100','2013-03-06','16:35:00',1.79),('16100','2013-03-06','16:40:00',1.12),('16100','2013-03-06','16:45:00',1.04),('16100','2013-03-05','09:50:00',1.03),('16100','2013-03-04','08:00:00',1.07),('16100','2013-03-04','08:05:00',1.54),('16100','2013-03-04','08:10:00',1.91),('16100','2013-03-04','08:15:00',3.09),('16100','2013-03-04','08:20:00',1.69),('16100','2013-03-04','08:25:00',2.76),('16100','2013-03-04','08:30:00',2.22),('16100','2013-03-04','08:35:00',3.35),('16100','2013-03-04','08:40:00',3.51),('16100','2013-03-04','08:45:00',3),('16100','2013-03-04','08:50:00',3.3),('16100','2013-03-04','08:55:00',3.22),('16100','2013-03-04','09:00:00',2.6),('16100','2013-03-04','09:05:00',2.5),('16100','2013-03-04','09:10:00',2.32),('16100','2013-03-04','09:15:00',2.36),('16100','2013-03-04','09:20:00',2.44),('16100','2013-03-04','09:25:00',2.4),('16100','2013-03-04','09:30:00',2.58),('16100','2013-03-04','09:35:00',2.75),('16100','2013-03-04','09:40:00',2.83),('16100','2013-03-04','09:45:00',2.96),('16100','2013-03-04','09:50:00',2.82),('16100','2013-03-04','09:55:00',3.17),('16100','2013-03-04','10:00:00',3.83),('16100','2013-03-04','10:05:00',3.7),('16100','2013-03-04','10:10:00',2.95),('16100','2013-03-04','10:15:00',3.07),('16100','2013-03-04','10:20:00',3.75),('16100','2013-03-04','10:25:00',3.6),('16100','2013-03-04','10:30:00',3.06),('16100','2013-03-04','10:35:00',3.09),('16100','2013-03-04','10:40:00',4.1),('16100','2013-03-04','10:45:00',4.72),('16100','2013-03-04','10:50:00',5.13),('16100','2013-03-04','10:55:00',5.18),('16100','2013-03-04','11:00:00',5.14),('16100','2013-03-04','11:05:00',5.04),('16100','2013-03-04','11:10:00',5.39),('16100','2013-03-04','11:15:00',4.85),('16100','2013-03-04','11:20:00',4.72),('16100','2013-03-04','11:25:00',4.6),('16100','2013-03-04','11:30:00',4.64),('16100','2013-03-04','11:35:00',5.39),('16100','2013-03-04','11:40:00',5.55),('16100','2013-03-04','11:45:00',5.65),('16100','2013-03-04','11:50:00',5.98),('16100','2013-03-04','11:55:00',6.11),('16100','2013-03-04','12:00:00',6.01),('16100','2013-03-04','12:05:00',6.51),('16100','2013-03-04','12:10:00',6.2),('16100','2013-03-04','12:15:00',5.53),('16100','2013-03-04','12:20:00',6.51),('16100','2013-03-04','12:25:00',6),('16100','2013-03-04','12:30:00',5.32),('16100','2013-03-04','12:35:00',5.49),('16100','2013-03-04','12:40:00',4.99),('16100','2013-03-04','12:45:00',4.69),('16100','2013-03-04','12:50:00',4.37),('16100','2013-03-04','12:55:00',3.51),('16100','2013-03-04','13:00:00',2.84),('16100','2013-03-04','13:05:00',2.77),('16100','2013-03-04','13:10:00',3.06),('16100','2013-03-04','13:15:00',3.18),('16100','2013-03-04','13:20:00',2.92),('16100','2013-03-04','13:25:00',2.58),('16100','2013-03-04','13:30:00',2.26),('16100','2013-03-04','13:35:00',2.11),('16100','2013-03-04','13:40:00',1.94),('16100','2013-03-04','13:45:00',1.73),('16100','2013-03-04','13:50:00',1.6),('16100','2013-03-04','13:55:00',1.64),('16100','2013-03-04','14:00:00',1.7),('16100','2013-03-04','14:05:00',1.72),('16100','2013-03-04','14:10:00',1.55),('16100','2013-03-04','14:15:00',1.48),('16100','2013-03-04','14:20:00',1.49),('16100','2013-03-04','14:25:00',1.53),('16100','2013-03-04','14:30:00',1.53),('16100','2013-03-04','14:35:00',1.56),('16100','2013-03-04','14:40:00',1.57),('16100','2013-03-04','14:45:00',1.6),('16100','2013-03-04','14:50:00',1.5),('16100','2013-03-04','14:55:00',1.32),('16100','2013-03-04','15:00:00',1.19),('16100','2013-03-04','15:05:00',1.09),('16100','2013-03-04','15:25:00',1.15),('16100','2013-03-04','15:30:00',1.43),('16100','2013-03-04','15:35:00',1.5),('16100','2013-03-04','15:40:00',1.8),('16100','2013-03-04','15:45:00',2.13),('16100','2013-03-04','15:50:00',1.88),('16100','2013-03-04','15:55:00',1.55),('16100','2013-03-04','16:00:00',1.4),('16100','2013-03-04','16:05:00',1.2),('16100','2014-03-23','07:30:00',1.05),('16100','2014-03-23','07:35:00',1.14),('16100','2014-03-23','07:40:00',1.45),('16100','2014-03-23','07:45:00',1.3),('16100','2014-03-23','07:50:00',1.26),('16100','2014-03-23','08:30:00',1.26),('16100','2014-03-23','08:35:00',1.55),('16100','2014-03-23','08:40:00',1.18),('16100','2014-03-23','08:45:00',1.05),('16100','2014-03-23','08:50:00',1.86),('16100','2014-03-23','08:55:00',3.09),('16100','2014-03-23','09:00:00',1.13),('16100','2014-03-23','09:15:00',2.3),('16100','2014-03-23','09:20:00',5.4),('16100','2014-03-23','09:25:00',4.66),('16100','2014-03-23','09:30:00',2.03),('16100','2014-03-23','09:35:00',3.55),('16100','2014-03-23','09:40:00',3.17),('16100','2014-03-23','09:45:00',3.57),('16100','2014-03-23','09:50:00',1.21),('16100','2014-03-23','09:55:00',3.03),('16100','2014-03-23','10:00:00',6.33),('16100','2014-03-23','10:05:00',5.91),('16100','2014-03-23','10:10:00',6.13),('16100','2014-03-23','10:20:00',2.55),('16100','2014-03-23','10:25:00',1.45),('16100','2014-03-23','10:30:00',1.83),('16100','2014-03-23','10:35:00',1.75),('16100','2014-03-23','10:40:00',3.08),('16100','2014-03-23','10:45:00',2.4),('16100','2014-03-23','10:50:00',7.95),('16100','2014-03-23','10:55:00',7.83),('16100','2014-03-23','11:00:00',4.9),('16100','2014-03-23','11:05:00',5.88),('16100','2014-03-23','11:10:00',5.33),('16100','2014-03-23','11:15:00',7.07),('16100','2014-03-23','11:20:00',8.04),('16100','2014-03-23','11:25:00',8.36),('16100','2014-03-23','11:30:00',4.12),('16100','2014-03-23','11:35:00',1.46),('16100','2014-03-23','11:50:00',1.1),('16100','2014-03-23','12:20:00',1.37),('16100','2014-03-23','12:25:00',2.18),('16100','2014-03-23','12:30:00',2.72),('16100','2014-03-23','12:35:00',3.6),('16100','2014-03-23','12:40:00',3.11),('16100','2014-03-23','12:45:00',2.51),('16100','2014-03-23','12:50:00',2.47),('16100','2014-03-23','12:55:00',2.36),('16100','2014-03-23','13:00:00',2.18),('16100','2014-03-23','13:05:00',1.97),('16100','2014-03-23','13:10:00',2.33),('16100','2014-03-23','13:15:00',3.43),('16100','2014-03-23','13:20:00',3.7),('16100','2014-03-23','13:25:00',4.06),('16100','2014-03-23','13:30:00',3.81),('16100','2014-03-23','13:35:00',2.82),('16100','2014-03-23','13:40:00',2.24),('16100','2014-03-23','13:45:00',2.03),('16100','2014-03-23','13:50:00',1.9),('16100','2014-03-23','13:55:00',1.6),('16100','2014-03-23','14:00:00',1.74),('16100','2014-03-23','14:05:00',1.96),('16100','2014-03-23','14:10:00',2.21),('16100','2014-03-23','14:15:00',3.11),('16100','2014-03-23','14:20:00',4.02),('16100','2014-03-23','14:25:00',3.58),('16100','2014-03-23','14:30:00',3.83),('16100','2014-03-23','14:35:00',5.45),('16100','2014-03-23','14:40:00',6.1),('16100','2014-03-23','14:45:00',4.25),('16100','2014-03-23','14:50:00',4.82),('16100','2014-03-23','14:55:00',4.51),('16100','2014-03-23','15:00:00',2.85),('16100','2014-03-23','15:05:00',3.77),('16100','2014-03-23','15:10:00',3.84),('16100','2014-03-23','15:15:00',3.6),('16100','2014-03-23','15:20:00',2.87),('16100','2014-03-23','15:25:00',2.61),('16100','2014-03-23','15:30:00',3.07),('16100','2014-03-23','15:35:00',3.06),('16100','2014-03-23','15:40:00',2.17),('16100','2014-03-23','15:45:00',1.79),('16100','2014-03-23','15:50:00',1.87),('16100','2014-03-23','15:55:00',3.13),('16100','2014-03-23','16:00:00',1.87),('16100','2014-03-23','16:05:00',1.48),('16100','2014-03-22','08:15:00',1.1),('16100','2014-03-22','08:20:00',1.54),('16100','2014-03-22','08:55:00',2.84),('16100','2014-03-22','09:00:00',2.19),('16100','2014-03-22','09:05:00',4.24),('16100','2014-03-22','09:10:00',4.48),('16100','2014-03-22','09:15:00',3.84),('16100','2014-03-22','09:20:00',2.04),('16100','2014-03-22','09:25:00',1.62),('16100','2014-03-22','09:30:00',2.29),('16100','2014-03-22','09:35:00',1.73),('16100','2014-03-22','09:40:00',1.21),('16100','2014-03-22','09:45:00',1.22),('16100','2014-03-22','09:50:00',1.32),('16100','2014-03-22','09:55:00',1.26),('16100','2014-03-22','10:05:00',1.01),('16100','2014-03-22','10:20:00',1.22),('16100','2014-03-22','10:25:00',2.16),('16100','2014-03-22','10:30:00',1.11),('16100','2014-03-22','10:40:00',1.98),('16100','2014-03-22','10:45:00',1.68),('16100','2014-03-22','10:50:00',1.7),('16100','2014-03-22','10:55:00',2.21),('16100','2014-03-22','11:00:00',1.41),('16100','2014-03-22','11:05:00',2.07),('16100','2014-03-22','11:10:00',1.3),('16100','2014-03-22','11:20:00',1.85),('16100','2014-03-22','11:25:00',1.83),('16100','2014-03-22','11:30:00',1.57),('16100','2014-03-22','11:35:00',1.82),('16100','2014-03-22','11:40:00',1.94),('16100','2014-03-22','12:00:00',1.18),('16100','2014-03-22','12:25:00',1.07),('16100','2014-03-22','13:05:00',1.24),('16100','2014-03-22','13:35:00',2.72),('16100','2014-03-22','13:40:00',3.3),('16100','2014-03-22','13:45:00',3.4),('16100','2014-03-22','13:50:00',1.76),('16100','2014-03-22','13:55:00',1.09),('16100','2014-03-22','14:45:00',1.89),('16100','2014-03-22','14:55:00',1.66),('16100','2014-03-22','15:00:00',1.77),('16100','2014-03-22','15:05:00',1.86),('16100','2014-03-22','15:10:00',3.88),('16100','2014-03-22','15:15:00',2.92),('16100','2014-03-22','15:20:00',1.99),('16100','2014-03-22','15:25:00',1.31),('16100','2014-03-22','15:30:00',1.04),('16100','2014-03-22','15:35:00',1.33),('16100','2014-03-21','07:35:00',1.5),('16100','2014-03-21','07:40:00',1.28),('16100','2014-03-21','07:45:00',1.29),('16100','2014-03-21','07:50:00',1.16),('16100','2014-03-21','08:05:00',1.43),('16100','2014-03-21','08:10:00',2.18),('16100','2014-03-21','08:15:00',2.71),('16100','2014-03-21','08:20:00',2.42),('16100','2014-03-21','08:25:00',2.47),('16100','2014-03-21','08:30:00',3.21),('16100','2014-03-21','08:35:00',2.89),('16100','2014-03-21','08:40:00',2.17),('16100','2014-03-21','08:45:00',3.07),('16100','2014-03-21','08:50:00',2.55),('16100','2014-03-21','08:55:00',2.44),('16100','2014-03-21','09:00:00',2.27),('16100','2014-03-21','09:05:00',2.61),('16100','2014-03-21','09:10:00',3.26),('16100','2014-03-21','09:15:00',3.47),('16100','2014-03-21','09:20:00',2.36),('16100','2014-03-21','09:25:00',2.63),('16100','2014-03-21','09:30:00',3.96),('16100','2014-03-21','09:35:00',5.1),('16100','2014-03-21','09:40:00',4.5),('16100','2014-03-21','09:45:00',5.19),('16100','2014-03-21','09:50:00',4.92),('16100','2014-03-21','09:55:00',5.07),('16100','2014-03-21','10:00:00',5.09),('16100','2014-03-21','10:05:00',6.34),('16100','2014-03-21','10:10:00',4),('16100','2014-03-21','10:15:00',2.22),('16100','2014-03-21','10:20:00',2.02),('16100','2014-03-21','10:25:00',2.34),('16100','2014-03-21','10:30:00',3.53),('16100','2014-03-21','10:35:00',3.6),('16100','2014-03-21','10:40:00',3.18),('16100','2014-03-21','10:45:00',4.18),('16100','2014-03-21','10:50:00',5.54),('16100','2014-03-21','10:55:00',3.98),('16100','2014-03-21','11:00:00',1.9),('16100','2014-03-21','11:05:00',2.18),('16100','2014-03-21','11:10:00',3.52),('16100','2014-03-21','11:15:00',5.55),('16100','2014-03-21','11:20:00',7.38),('16100','2014-03-21','11:25:00',4.97),('16100','2014-03-21','11:30:00',4.52),('16100','2014-03-21','11:35:00',6.71),('16100','2014-03-21','11:40:00',4.14),('16100','2014-03-21','11:45:00',4.53),('16100','2014-03-21','11:50:00',1.95),('16100','2014-03-21','11:55:00',5.41),('16100','2014-03-21','12:00:00',4.83),('16100','2014-03-21','12:05:00',7.1),('16100','2014-03-21','12:10:00',4.47),('16100','2014-03-21','12:15:00',7.44),('16100','2014-03-21','12:20:00',6.76),('16100','2014-03-21','12:25:00',5.68),('16100','2014-03-21','12:30:00',4.73),('16100','2014-03-21','12:35:00',5.34),('16100','2014-03-21','12:40:00',7.98),('16100','2014-03-21','12:45:00',6.35),('16100','2014-03-21','12:50:00',6.93),('16100','2014-03-21','12:55:00',7.95),('16100','2014-03-21','13:00:00',7.58),('16100','2014-03-21','13:05:00',4.06),('16100','2014-03-21','13:10:00',4.55),('16100','2014-03-21','13:15:00',5.77),('16100','2014-03-21','13:20:00',2.57),('16100','2014-03-21','13:25:00',7.56),('16100','2014-03-21','13:30:00',6.68),('16100','2014-03-21','13:35:00',6.92),('16100','2014-03-21','13:40:00',7),('16100','2014-03-21','13:45:00',6.8),('16100','2014-03-21','13:50:00',6.72),('16100','2014-03-21','13:55:00',6.56),('16100','2014-03-21','14:00:00',6.62),('16100','2014-03-21','14:05:00',6.21),('16100','2014-03-21','14:10:00',6.31),('16100','2014-03-21','14:15:00',6.21),('16100','2014-03-21','14:20:00',6.06),('16100','2014-03-21','14:25:00',5.92),('16100','2014-03-21','14:30:00',5.88),('16100','2014-03-21','14:35:00',5.72),('16100','2014-03-21','14:40:00',5.39),('16100','2014-03-21','14:45:00',5.53),('16100','2014-03-21','14:50:00',5.03),('16100','2014-03-21','14:55:00',5.3),('16100','2014-03-21','15:00:00',4.51),('16100','2014-03-21','15:05:00',4.98),('16100','2014-03-21','15:10:00',4.83),('16100','2014-03-21','15:15:00',4.7),('16100','2014-03-21','15:20:00',4.82),('16100','2014-03-21','15:25:00',4.48),('16100','2014-03-21','15:30:00',3.28),('16100','2014-03-21','15:35:00',4.91),('16100','2014-03-21','15:40:00',4.62),('16100','2014-03-21','15:45:00',4.18),('16100','2014-03-21','15:50:00',3.54),('16100','2014-03-21','15:55:00',3.18),('16100','2014-03-21','16:00:00',3.15),('16100','2014-03-21','16:05:00',1.32),('16100','2014-03-21','16:10:00',2.23),('16100','2014-03-21','16:15:00',2.45),('16100','2014-03-21','16:20:00',1.84),('16100','2014-03-21','16:25:00',1.23),('16100','2014-03-21','16:30:00',1.13),('16100','2014-03-21','16:35:00',1.31),('16100','2014-03-21','16:40:00',1.85),('16100','2014-03-21','16:45:00',2.33),('16100','2014-03-21','16:50:00',1.2),('16100','2014-03-20','07:35:00',1.15),('16100','2014-03-20','07:40:00',1.35),('16100','2014-03-20','07:45:00',1.57),('16100','2014-03-20','07:50:00',1.81),('16100','2014-03-20','07:55:00',2.02),('16100','2014-03-20','08:00:00',2.2),('16100','2014-03-20','08:05:00',2.37),('16100','2014-03-20','08:10:00',2.52),('16100','2014-03-20','08:15:00',2.7),('16100','2014-03-20','08:20:00',2.82),('16100','2014-03-20','08:25:00',3),('16100','2014-03-20','08:30:00',3.23),('16100','2014-03-20','08:35:00',3.39),('16100','2014-03-20','08:40:00',3.56),('16100','2014-03-20','08:45:00',3.69),('16100','2014-03-20','08:50:00',3.79),('16100','2014-03-20','08:55:00',3.96),('16100','2014-03-20','09:00:00',4.13),('16100','2014-03-20','09:05:00',4.29),('16100','2014-03-20','09:10:00',4.48),('16100','2014-03-20','09:15:00',4.6),('16100','2014-03-20','09:20:00',4.76),('16100','2014-03-20','09:25:00',4.79),('16100','2014-03-20','09:30:00',4.8),('16100','2014-03-20','09:35:00',4.81),('16100','2014-03-20','09:40:00',5.23),('16100','2014-03-20','09:45:00',5.31),('16100','2014-03-20','09:50:00',5.5),('16100','2014-03-20','09:55:00',5.53),('16100','2014-03-20','10:00:00',5.6),('16100','2014-03-20','10:05:00',5.72),('16100','2014-03-20','10:10:00',5.73),('16100','2014-03-20','10:15:00',5.87),('16100','2014-03-20','10:20:00',5.94),('16100','2014-03-20','10:25:00',5.97),('16100','2014-03-20','10:30:00',6.05),('16100','2014-03-20','10:35:00',6.02),('16100','2014-03-20','10:40:00',6.16),('16100','2014-03-20','10:45:00',5.34),('16100','2014-03-20','10:50:00',5.39),('16100','2014-03-20','10:55:00',6.34),('16100','2014-03-20','11:00:00',6.31),('16100','2014-03-20','11:05:00',6.36),('16100','2014-03-20','11:10:00',6.43),('16100','2014-03-20','11:15:00',6.6),('16100','2014-03-20','11:20:00',6.59),('16100','2014-03-20','11:25:00',6.69),('16100','2014-03-20','11:30:00',6.64),('16100','2014-03-20','11:35:00',6.53),('16100','2014-03-20','11:40:00',5.42),('16100','2014-03-20','11:45:00',6.55),('16100','2014-03-20','11:50:00',6.72),('16100','2014-03-20','11:55:00',6.83),('16100','2014-03-20','12:00:00',5.84),('16100','2014-03-20','12:05:00',6.27),('16100','2014-03-20','12:10:00',6.91),('16100','2014-03-20','12:15:00',6.94),('16100','2014-03-20','12:20:00',7.03),('16100','2014-03-20','12:25:00',7.07),('16100','2014-03-20','12:30:00',7.15),('16100','2014-03-20','12:35:00',7.15),('16100','2014-03-20','12:40:00',7.19),('16100','2014-03-20','12:45:00',7.19),('16100','2014-03-20','12:50:00',7.17),('16100','2014-03-20','12:55:00',7.17),('16100','2014-03-20','13:00:00',7.12),('16100','2014-03-20','13:05:00',7),('16100','2014-03-20','13:10:00',7.05),('16100','2014-03-20','13:15:00',6.96),('16100','2014-03-20','13:20:00',6.91),('16100','2014-03-20','13:25:00',6.84),('16100','2014-03-20','13:30:00',6.8),('16100','2014-03-20','13:35:00',6.76),('16100','2014-03-20','13:40:00',6.66),('16100','2014-03-20','13:45:00',6.64),('16100','2014-03-20','13:50:00',6.74),('16100','2014-03-20','13:55:00',6.65),('16100','2014-03-20','14:00:00',6.55),('16100','2014-03-20','14:05:00',6.41),('16100','2014-03-20','14:10:00',6.36),('16100','2014-03-20','14:15:00',6.34),('16100','2014-03-20','14:20:00',6.28),('16100','2014-03-20','14:25:00',6.09),('16100','2014-03-20','14:30:00',6),('16100','2014-03-20','14:35:00',5.82),('16100','2014-03-20','14:40:00',5.54),('16100','2014-03-20','14:45:00',4.67),('16100','2014-03-20','14:50:00',3.13),('16100','2014-03-20','14:55:00',1.73),('16100','2014-03-20','15:00:00',1.69),('16100','2014-03-20','15:05:00',4.69),('16100','2014-03-20','15:10:00',5.42),('16100','2014-03-20','15:15:00',5.74),('16100','2014-03-20','15:20:00',4.88),('16100','2014-03-20','15:25:00',3.13),('16100','2014-03-20','15:30:00',5.29),('16100','2014-03-20','15:35:00',4.73),('16100','2014-03-20','15:40:00',4.44),('16100','2014-03-20','15:45:00',4.24),('16100','2014-03-20','15:50:00',4.7),('16100','2014-03-20','15:55:00',4.5),('16100','2014-03-20','16:00:00',4.26),('16100','2014-03-20','16:05:00',3.97),('16100','2014-03-20','16:10:00',3.72),('16100','2014-03-20','16:15:00',3.44),('16100','2014-03-20','16:20:00',3.1),('16100','2014-03-20','16:25:00',2.88),('16100','2014-03-20','16:30:00',2.69),('16100','2014-03-20','16:35:00',2.46),('16100','2014-03-20','16:40:00',2.29),('16100','2014-03-20','16:45:00',2.14),('16100','2014-03-20','16:50:00',1.96),('16100','2014-03-20','16:55:00',1.75),('16100','2014-03-20','17:00:00',1.47),('16100','2014-03-20','17:05:00',1.24),('16100','2014-03-20','17:10:00',1.12),('16100','2014-03-19','07:25:00',1.08),('16100','2014-03-19','07:30:00',1.22),('16100','2014-03-19','07:35:00',1.39),('16100','2014-03-19','07:40:00',1.55),('16100','2014-03-19','07:45:00',1.79),('16100','2014-03-19','07:50:00',1.96),('16100','2014-03-19','07:55:00',2.04),('16100','2014-03-19','08:00:00',2.1),('16100','2014-03-19','08:05:00',2.25),('16100','2014-03-19','08:10:00',2.17),('16100','2014-03-19','08:15:00',2.33),('16100','2014-03-19','08:20:00',2.49),('16100','2014-03-19','08:25:00',2.82),('16100','2014-03-19','08:30:00',3.05),('16100','2014-03-19','08:35:00',3.25),('16100','2014-03-19','08:40:00',3.52),('16100','2014-03-19','08:45:00',3.7),('16100','2014-03-19','08:50:00',3.89),('16100','2014-03-19','08:55:00',3.9),('16100','2014-03-19','09:00:00',4),('16100','2014-03-19','09:05:00',4.17),('16100','2014-03-19','09:10:00',4.35),('16100','2014-03-19','09:15:00',4.52),('16100','2014-03-19','09:20:00',4.65),('16100','2014-03-19','09:25:00',4.88),('16100','2014-03-19','09:30:00',4.95),('16100','2014-03-19','09:35:00',5.09),('16100','2014-03-19','09:40:00',5.11),('16100','2014-03-19','09:45:00',5.26),('16100','2014-03-19','09:50:00',5.49),('16100','2014-03-19','09:55:00',5.51),('16100','2014-03-19','10:00:00',5.7),('16100','2014-03-19','10:05:00',5.87),('16100','2014-03-19','10:10:00',5.91),('16100','2014-03-19','10:15:00',5.98),('16100','2014-03-19','10:20:00',6.14),('16100','2014-03-19','10:25:00',6.31),('16100','2014-03-19','10:30:00',6.42),('16100','2014-03-19','10:35:00',6.35),('16100','2014-03-19','10:40:00',6.06),('16100','2014-03-19','10:45:00',6.02),('16100','2014-03-19','10:50:00',6.5),('16100','2014-03-19','10:55:00',6.75),('16100','2014-03-19','11:00:00',6.74),('16100','2014-03-19','11:05:00',6.84),('16100','2014-03-19','11:10:00',6.74),('16100','2014-03-19','11:15:00',6.21),('16100','2014-03-19','11:20:00',6.46),('16100','2014-03-19','11:25:00',6.6),('16100','2014-03-19','11:30:00',6.79),('16100','2014-03-19','11:35:00',6.66),('16100','2014-03-19','11:40:00',6.52),('16100','2014-03-19','11:45:00',6.41),('16100','2014-03-19','11:50:00',6.46),('16100','2014-03-19','11:55:00',6.45),('16100','2014-03-19','12:00:00',6.81),('16100','2014-03-19','12:05:00',6.25),('16100','2014-03-19','12:10:00',6.54),('16100','2014-03-19','12:15:00',7.02),('16100','2014-03-19','12:20:00',7.11),('16100','2014-03-19','12:25:00',6.96),('16100','2014-03-19','12:30:00',6.64),('16100','2014-03-19','12:35:00',6.92),('16100','2014-03-19','12:40:00',7.13),('16100','2014-03-19','12:45:00',7.24),('16100','2014-03-19','12:50:00',7.25),('16100','2014-03-19','12:55:00',7.29),('16100','2014-03-19','13:00:00',7.2),('16100','2014-03-19','13:05:00',7.03),('16100','2014-03-19','13:10:00',6.87),('16100','2014-03-19','13:15:00',6.77),('16100','2014-03-19','13:20:00',6.75),('16100','2014-03-19','13:25:00',6.8),('16100','2014-03-19','13:30:00',6.6),('16100','2014-03-19','13:35:00',6.48),('16100','2014-03-19','13:40:00',6.16),('16100','2014-03-19','13:45:00',5.96),('16100','2014-03-19','13:50:00',5.83),('16100','2014-03-19','13:55:00',5.59),('16100','2014-03-19','14:00:00',5.43),('16100','2014-03-19','14:05:00',5.65),('16100','2014-03-19','14:10:00',5.65),('16100','2014-03-19','14:15:00',5.77),('16100','2014-03-19','14:20:00',4.91),('16100','2014-03-19','14:25:00',4.74),('16100','2014-03-19','14:30:00',4.25),('16100','2014-03-19','14:35:00',4.66),('16100','2014-03-19','14:40:00',4.45),('16100','2014-03-19','14:45:00',4.31),('16100','2014-03-19','14:50:00',4.25),('16100','2014-03-19','14:55:00',4.19),('16100','2014-03-19','15:00:00',4.17),('16100','2014-03-19','15:05:00',4.14),('16100','2014-03-19','15:10:00',4.24),('16100','2014-03-19','15:15:00',4.05),('16100','2014-03-19','15:20:00',4.02),('16100','2014-03-19','15:25:00',3.78),('16100','2014-03-19','15:30:00',3.42),('16100','2014-03-19','15:35:00',3.08),('16100','2014-03-19','15:40:00',2.9),('16100','2014-03-19','15:45:00',2.7),('16100','2014-03-19','15:50:00',2.41),('16100','2014-03-19','15:55:00',1.98),('16100','2014-03-19','16:00:00',2),('16100','2014-03-19','16:05:00',2.04),('16100','2014-03-19','16:10:00',1.8),('16100','2014-03-19','16:15:00',1.63),('16100','2014-03-19','16:20:00',1.58),('16100','2014-03-19','16:25:00',1.48),('16100','2014-03-19','16:30:00',1.38),('16100','2014-03-19','16:35:00',1.51),('16100','2014-03-19','16:40:00',1.55),('16100','2014-03-19','16:45:00',1.25),('16100','2014-03-18','08:25:00',1.03),('16100','2014-03-18','08:30:00',1.17),('16100','2014-03-18','08:35:00',1.34),('16100','2014-03-18','08:40:00',1.37),('16100','2014-03-18','08:45:00',1.46),('16100','2014-03-18','08:50:00',1.73),('16100','2014-03-18','08:55:00',1.49),('16100','2014-03-18','09:00:00',1.48),('16100','2014-03-18','09:05:00',1.68),('16100','2014-03-18','09:10:00',1.84),('16100','2014-03-18','09:15:00',2.02),('16100','2014-03-18','09:20:00',2.46),('16100','2014-03-18','09:25:00',3.16),('16100','2014-03-18','09:30:00',3.17),('16100','2014-03-18','09:35:00',3.74),('16100','2014-03-18','09:40:00',3.83),('16100','2014-03-18','09:45:00',3.88),('16100','2014-03-18','09:50:00',4.5),('16100','2014-03-18','09:55:00',3.84),('16100','2014-03-18','10:00:00',3.01),('16100','2014-03-18','10:05:00',2.61),('16100','2014-03-18','10:10:00',2.56),('16100','2014-03-18','10:15:00',2.66),('16100','2014-03-18','10:20:00',2.31),('16100','2014-03-18','10:25:00',2.3),('16100','2014-03-18','10:30:00',2.31),('16100','2014-03-18','10:35:00',2.43),('16100','2014-03-18','10:40:00',2.96),('16100','2014-03-18','10:45:00',3.02),('16100','2014-03-18','10:50:00',3.6),('16100','2014-03-18','10:55:00',2.61),('16100','2014-03-18','11:00:00',2.15),('16100','2014-03-18','11:05:00',2.5),('16100','2014-03-18','11:10:00',3.7),('16100','2014-03-18','11:15:00',3.53),('16100','2014-03-18','11:20:00',5.39),('16100','2014-03-18','11:25:00',7),('16100','2014-03-18','11:30:00',5.75),('16100','2014-03-18','11:35:00',7.7),('16100','2014-03-18','11:40:00',6.55),('16100','2014-03-18','11:45:00',5.46),('16100','2014-03-18','11:50:00',6.26),('16100','2014-03-18','11:55:00',4),('16100','2014-03-18','12:00:00',5.7),('16100','2014-03-18','12:05:00',4.24),('16100','2014-03-18','12:10:00',2.65),('16100','2014-03-18','12:15:00',6.84),('16100','2014-03-18','12:20:00',7.01),('16100','2014-03-18','12:25:00',6.94),('16100','2014-03-18','12:30:00',7.12),('16100','2014-03-18','12:35:00',7.05),('16100','2014-03-18','12:40:00',6.67),('16100','2014-03-18','12:45:00',6.74),('16100','2014-03-18','12:50:00',5.93),('16100','2014-03-18','12:55:00',7.09),('16100','2014-03-18','13:00:00',7.03),('16100','2014-03-18','13:05:00',7.03),('16100','2014-03-18','13:10:00',6.65),('16100','2014-03-18','13:15:00',6.19),('16100','2014-03-18','13:20:00',6.3),('16100','2014-03-18','13:25:00',6.93),('16100','2014-03-18','13:30:00',6.58),('16100','2014-03-18','13:35:00',6.72),('16100','2014-03-18','13:40:00',6.72),('16100','2014-03-18','13:45:00',6.65),('16100','2014-03-18','13:50:00',6.44),('16100','2014-03-18','13:55:00',6.44),('16100','2014-03-18','14:00:00',6.42),('16100','2014-03-18','14:05:00',6.38),('16100','2014-03-18','14:10:00',6.26),('16100','2014-03-18','14:15:00',6.09),('16100','2014-03-18','14:20:00',6.02),('16100','2014-03-18','14:25:00',5.83),('16100','2014-03-18','14:30:00',5.74),('16100','2014-03-18','14:35:00',5.72),('16100','2014-03-18','14:40:00',5.68),('16100','2014-03-18','14:45:00',5.55),('16100','2014-03-18','14:50:00',5.49),('16100','2014-03-18','14:55:00',5.32),('16100','2014-03-18','15:00:00',5.17),('16100','2014-03-18','15:05:00',5.18),('16100','2014-03-18','15:10:00',5.05),('16100','2014-03-18','15:15:00',4.83),('16100','2014-03-18','15:20:00',4.75),('16100','2014-03-18','15:25:00',4.61),('16100','2014-03-18','15:30:00',4.41),('16100','2014-03-18','15:35:00',4.27),('16100','2014-03-18','15:40:00',4.19),('16100','2014-03-18','15:45:00',4.1),('16100','2014-03-18','15:50:00',3.89),('16100','2014-03-18','15:55:00',3.68),('16100','2014-03-18','16:00:00',3.59),('16100','2014-03-18','16:05:00',3.51),('16100','2014-03-18','16:10:00',3.28),('16100','2014-03-18','16:15:00',3.06),('16100','2014-03-18','16:20:00',2.88),('16100','2014-03-18','16:25:00',2.77),('16100','2014-03-18','16:30:00',2.44),('16100','2014-03-18','16:35:00',2.24),('16100','2014-03-18','16:40:00',2.06),('16100','2014-03-18','16:45:00',1.94),('16100','2014-03-18','16:50:00',1.68),('16100','2014-03-18','16:55:00',1.59),('16100','2014-03-18','17:00:00',1.33),('16100','2014-03-18','17:05:00',1.09),('16100','2014-03-17','08:00:00',1.37),('16100','2014-03-17','08:05:00',1.3),('16100','2014-03-17','08:10:00',1.43),('16100','2014-03-17','08:15:00',1.82),('16100','2014-03-17','08:20:00',2.17),('16100','2014-03-17','08:25:00',1.69),('16100','2014-03-17','08:30:00',1.75),('16100','2014-03-17','08:35:00',3.03),('16100','2014-03-17','08:40:00',1.69),('16100','2014-03-17','08:45:00',1.49),('16100','2014-03-17','08:50:00',1.26),('16100','2014-03-17','08:55:00',1.21),('16100','2014-03-17','09:00:00',2),('16100','2014-03-17','09:05:00',1.39),('16100','2014-03-17','09:10:00',2.03),('16100','2014-03-17','09:15:00',3.75),('16100','2014-03-17','09:20:00',4.6),('16100','2014-03-17','09:25:00',4.37),('16100','2014-03-17','09:30:00',4.2),('16100','2014-03-17','09:35:00',4.51),('16100','2014-03-17','09:40:00',4.48),('16100','2014-03-17','09:45:00',2.88),('16100','2014-03-17','09:50:00',3.43),('16100','2014-03-17','09:55:00',2.92),('16100','2014-03-17','10:00:00',5.98),('16100','2014-03-17','10:05:00',4),('16100','2014-03-17','10:10:00',1.92),('16100','2014-03-17','10:15:00',2.18),('16100','2014-03-17','10:20:00',3.15),('16100','2014-03-17','10:25:00',2.24),('16100','2014-03-17','10:30:00',1.99),('16100','2014-03-17','10:35:00',2.61),('16100','2014-03-17','10:40:00',3.36),('16100','2014-03-17','10:45:00',2.08),('16100','2014-03-17','10:50:00',2.03),('16100','2014-03-17','10:55:00',2.01),('16100','2014-03-17','11:00:00',2.85),('16100','2014-03-17','11:05:00',1.91),('16100','2014-03-17','11:10:00',2.54),('16100','2014-03-17','11:15:00',7.39),('16100','2014-03-17','11:20:00',4.44),('16100','2014-03-17','11:25:00',2.61),('16100','2014-03-17','11:30:00',5.13),('16100','2014-03-17','11:35:00',7.7),('16100','2014-03-17','11:40:00',7.67),('16100','2014-03-17','11:45:00',7.84),('16100','2014-03-17','11:50:00',7.04),('16100','2014-03-17','11:55:00',2.9),('16100','2014-03-17','12:00:00',4.29),('16100','2014-03-17','12:05:00',6.27),('16100','2014-03-17','12:10:00',3.54),('16100','2014-03-17','12:15:00',7.3),('16100','2014-03-17','12:20:00',8.33),('16100','2014-03-17','12:25:00',4.52),('16100','2014-03-17','12:30:00',7.6),('16100','2014-03-17','12:35:00',7.85),('16100','2014-03-17','12:40:00',7.71),('16100','2014-03-17','12:45:00',7.59),('16100','2014-03-17','12:50:00',7.14),('16100','2014-03-17','12:55:00',7.05),('16100','2014-03-17','13:00:00',7.55),('16100','2014-03-17','13:05:00',7.14),('16100','2014-03-17','13:10:00',7.31),('16100','2014-03-17','13:15:00',7.05),('16100','2014-03-17','13:20:00',6.94),('16100','2014-03-17','13:25:00',6.99),('16100','2014-03-17','13:30:00',6.84),('16100','2014-03-17','13:35:00',6.79),('16100','2014-03-17','13:40:00',6.77),('16100','2014-03-17','13:45:00',6.69),('16100','2014-03-17','13:50:00',6.74),('16100','2014-03-17','13:55:00',6.59),('16100','2014-03-17','14:00:00',6.51),('16100','2014-03-17','14:05:00',6.39),('16100','2014-03-17','14:10:00',6.21),('16100','2014-03-17','14:15:00',6.26),('16100','2014-03-17','14:20:00',6.16),('16100','2014-03-17','14:25:00',6.04),('16100','2014-03-17','14:30:00',5.93),('16100','2014-03-17','14:35:00',5.89),('16100','2014-03-17','14:40:00',5.75),('16100','2014-03-17','14:45:00',5.63),('16100','2014-03-17','14:50:00',5.56),('16100','2014-03-17','14:55:00',5.49),('16100','2014-03-17','15:00:00',5.32),('16100','2014-03-17','15:05:00',5.22),('16100','2014-03-17','15:10:00',5.07),('16100','2014-03-17','15:15:00',4.83),('16100','2014-03-17','15:20:00',4.72),('16100','2014-03-17','15:25:00',4.64),('16100','2014-03-17','15:30:00',4.49),('16100','2014-03-17','15:35:00',4.36),('16100','2014-03-17','15:40:00',4.2),('16100','2014-03-17','15:45:00',3.99),('16100','2014-03-17','15:50:00',3.86),('16100','2014-03-17','15:55:00',3.71),('16100','2014-03-17','16:00:00',3.54),('16100','2014-03-17','16:05:00',3.38),('16100','2014-03-17','16:10:00',3.18),('16100','2014-03-17','16:15:00',3.07),('16100','2014-03-17','16:20:00',2.93),('16100','2014-03-17','16:25:00',2.81),('16100','2014-03-17','16:30:00',2.54),('16100','2014-03-17','16:35:00',2.37),('16100','2014-03-17','16:40:00',2.21),('16100','2014-03-17','16:45:00',2.03),('16100','2014-03-17','16:50:00',1.81),('16100','2014-03-17','16:55:00',1.67),('16100','2014-03-17','17:00:00',1.47),('16100','2014-03-17','17:05:00',1.27),('16100','2014-03-17','17:10:00',1.12),('16100','2014-04-30','07:55:00',1.25),('16100','2014-04-30','08:00:00',1.2),('16100','2014-04-30','08:05:00',1.38),('16100','2014-04-30','08:10:00',1.64),('16100','2014-04-30','08:15:00',1.8),('16100','2014-04-30','08:20:00',1.97),('16100','2014-04-30','08:25:00',2.25),('16100','2014-04-30','08:30:00',2.51),('16100','2014-04-30','08:35:00',2.8),('16100','2014-04-30','08:40:00',3.3),('16100','2014-04-30','08:45:00',3.21),('16100','2014-04-30','08:50:00',1.51),('16100','2014-04-30','08:55:00',1.59),('16100','2014-04-30','09:00:00',2.49),('16100','2014-04-30','09:05:00',2.43),('16100','2014-04-30','09:10:00',4.42),('16100','2014-04-30','09:15:00',4.45),('16100','2014-04-30','09:20:00',4.31),('16100','2014-04-30','09:25:00',3.73),('16100','2014-04-30','09:30:00',3.92),('16100','2014-04-30','09:35:00',2.38),('16100','2014-04-30','09:40:00',2.42),('16100','2014-04-30','09:45:00',3.26),('16100','2014-04-30','09:50:00',1.81),('16100','2014-04-30','09:55:00',2.14),('16100','2014-04-30','10:00:00',2.3),('16100','2014-04-30','10:05:00',2.36),('16100','2014-04-30','10:10:00',4.08),('16100','2014-04-30','10:15:00',3.72),('16100','2014-04-30','10:20:00',5.22),('16100','2014-04-30','10:25:00',4.44),('16100','2014-04-30','10:30:00',6.95),('16100','2014-04-30','10:35:00',6.67),('16100','2014-04-30','10:40:00',3.23),('16100','2014-04-30','10:45:00',3.18),('16100','2014-04-30','10:50:00',1.88),('16100','2014-04-30','10:55:00',6.84),('16100','2014-04-30','11:00:00',7.5),('16100','2014-04-30','11:05:00',7.65),('16100','2014-04-30','11:10:00',6.49),('16100','2014-04-30','11:15:00',6.9),('16100','2014-04-30','11:20:00',6.03),('16100','2014-04-30','11:25:00',3.17),('16100','2014-04-30','11:30:00',7.6),('16100','2014-04-30','11:35:00',7.89),('16100','2014-04-30','11:40:00',5.35),('16100','2014-04-30','11:45:00',8.06),('16100','2014-04-30','11:50:00',8.14),('16100','2014-04-30','11:55:00',5.2),('16100','2014-04-30','12:00:00',5.73),('16100','2014-04-30','12:05:00',8.38),('16100','2014-04-30','12:10:00',5.28),('16100','2014-04-30','12:15:00',5.78),('16100','2014-04-30','12:20:00',8.31),('16100','2014-04-30','12:25:00',8.36),('16100','2014-04-30','12:30:00',5.23),('16100','2014-04-30','12:35:00',8.9),('16100','2014-04-30','12:40:00',6.36),('16100','2014-04-30','12:45:00',8.33),('16100','2014-04-30','12:50:00',3.17),('16100','2014-04-30','12:55:00',4.13),('16100','2014-04-30','13:00:00',8.1),('16100','2014-04-30','13:05:00',7.86),('16100','2014-04-30','13:10:00',8.33),('16100','2014-04-30','13:15:00',8.24),('16100','2014-04-30','13:20:00',5.8),('16100','2014-04-30','13:25:00',7.73),('16100','2014-04-30','13:30:00',7.75),('16100','2014-04-30','13:35:00',3.33),('16100','2014-04-30','13:40:00',6.9),('16100','2014-04-30','13:45:00',8.73),('16100','2014-04-30','13:50:00',7.92),('16100','2014-04-30','13:55:00',8.15),('16100','2014-04-30','14:00:00',7.81),('16100','2014-04-30','14:05:00',7.69),('16100','2014-04-30','14:10:00',7.49),('16100','2014-04-30','14:15:00',7.49),('16100','2014-04-30','14:20:00',7.42),('16100','2014-04-30','14:25:00',7.39),('16100','2014-04-30','14:30:00',4.68),('16100','2014-04-30','14:35:00',6.48),('16100','2014-04-30','14:40:00',7.61),('16100','2014-04-30','14:45:00',7.5),('16100','2014-04-30','14:50:00',3.75),('16100','2014-04-30','14:55:00',7.37),('16100','2014-04-30','15:00:00',7.31),('16100','2014-04-30','15:05:00',6.19),('16100','2014-04-30','15:10:00',7.18),('16100','2014-04-30','15:15:00',6.86),('16100','2014-04-30','15:20:00',6.73),('16100','2014-04-30','15:25:00',6.62),('16100','2014-04-30','15:30:00',6.53),('16100','2014-04-30','15:35:00',6.42),('16100','2014-04-30','15:40:00',6.35),('16100','2014-04-30','15:45:00',6.21),('16100','2014-04-30','15:50:00',6.13),('16100','2014-04-30','15:55:00',6.02),('16100','2014-04-30','16:00:00',5.89),('16100','2014-04-30','16:05:00',5.79),('16100','2014-04-30','16:10:00',5.81),('16100','2014-04-30','16:15:00',5.47),('16100','2014-04-30','16:20:00',4.98),('16100','2014-04-30','16:25:00',5.01),('16100','2014-04-30','16:30:00',4.98),('16100','2014-04-30','16:35:00',4.84),('16100','2014-04-30','16:40:00',4.47),('16100','2014-04-30','16:45:00',4.12),('16100','2014-04-30','16:50:00',4.7),('16100','2014-04-30','16:55:00',4.35),('16100','2014-04-30','17:00:00',4.2),('16100','2014-04-30','17:05:00',4.2),('16100','2014-04-30','17:10:00',4.03),('16100','2014-04-30','17:15:00',3.86),('16100','2014-04-30','17:20:00',3.63),('16100','2014-04-30','17:25:00',2.92),('16100','2014-04-30','17:30:00',2.59),('16100','2014-04-30','17:35:00',3.09),('16100','2014-04-30','17:40:00',1.56),('16100','2014-04-30','17:45:00',2.95),('16100','2014-04-30','17:50:00',2.72),('16100','2014-04-30','17:55:00',2.51),('16100','2014-04-30','18:00:00',1.5),('16100','2014-04-30','18:05:00',2.36),('16100','2014-04-30','18:10:00',2.07),('16100','2014-04-30','18:15:00',1.48),('16100','2014-04-30','18:20:00',1.68),('16100','2014-04-30','18:25:00',1.54),('16100','2014-04-30','18:30:00',1.21),('16100','2014-04-30','18:35:00',1.17),('16100','2014-03-16','08:30:00',1.14),('16100','2014-03-16','08:35:00',1.2),('16100','2014-03-16','08:40:00',1.2),('16100','2014-03-16','08:45:00',1.17),('16100','2014-03-16','08:50:00',1.34),('16100','2014-03-16','08:55:00',1.65),('16100','2014-03-16','09:00:00',1.38),('16100','2014-03-16','09:05:00',1.61),('16100','2014-03-16','09:10:00',1.52),('16100','2014-03-16','09:15:00',1.82),('16100','2014-03-16','09:20:00',1.8),('16100','2014-03-16','09:25:00',1.6),('16100','2014-03-16','09:30:00',1.61),('16100','2014-03-16','09:35:00',1.62),('16100','2014-03-16','09:40:00',1.65),('16100','2014-03-16','09:45:00',1.8),('16100','2014-03-16','09:50:00',1.57),('16100','2014-03-16','09:55:00',1.71),('16100','2014-03-16','10:00:00',1.66),('16100','2014-03-16','10:05:00',1.74),('16100','2014-03-16','10:10:00',1.92),('16100','2014-03-16','10:15:00',1.85),('16100','2014-03-16','10:20:00',1.86),('16100','2014-03-16','10:25:00',1.54),('16100','2014-03-16','10:30:00',1.26),('16100','2014-03-16','10:35:00',1.45),('16100','2014-03-16','10:40:00',1.52),('16100','2014-03-16','10:45:00',1.42),('16100','2014-03-16','10:50:00',2.66),('16100','2014-03-16','10:55:00',1.76),('16100','2014-03-16','11:00:00',1.62),('16100','2014-03-16','11:05:00',2.23),('16100','2014-03-16','11:10:00',3.65),('16100','2014-03-16','11:15:00',2.52),('16100','2014-03-16','11:20:00',2.27),('16100','2014-03-16','11:25:00',2.03),('16100','2014-03-16','11:30:00',1.62),('16100','2014-03-16','11:35:00',1.73),('16100','2014-03-16','11:40:00',1.86),('16100','2014-03-16','11:45:00',2.07),('16100','2014-03-16','11:50:00',2.01),('16100','2014-03-16','11:55:00',2.88),('16100','2014-03-16','12:00:00',2.66),('16100','2014-03-16','12:05:00',3.12),('16100','2014-03-16','12:10:00',4.88),('16100','2014-03-16','12:15:00',3.7),('16100','2014-03-16','12:20:00',3.03),('16100','2014-03-16','12:25:00',3.65),('16100','2014-03-16','12:30:00',5.44),('16100','2014-03-16','12:35:00',7.19),('16100','2014-03-16','12:40:00',8.63),('16100','2014-03-16','12:45:00',6.73),('16100','2014-03-16','12:50:00',5.26),('16100','2014-03-16','12:55:00',4.93),('16100','2014-03-16','13:00:00',4),('16100','2014-03-16','13:05:00',7.6),('16100','2014-03-16','13:10:00',6.95),('16100','2014-03-16','13:15:00',5.44),('16100','2014-03-16','13:20:00',5.95),('16100','2014-03-16','13:25:00',6.89),('16100','2014-03-16','13:30:00',5.04),('16100','2014-03-16','13:35:00',6.73),('16100','2014-03-16','13:40:00',7.21),('16100','2014-03-16','13:45:00',6.78),('16100','2014-03-16','13:50:00',7.08),('16100','2014-03-16','13:55:00',6.48),('16100','2014-03-16','14:00:00',6.27),('16100','2014-03-16','14:05:00',5.57),('16100','2014-03-16','14:10:00',6.34),('16100','2014-03-16','14:15:00',6.33),('16100','2014-03-16','14:20:00',5.48),('16100','2014-03-16','14:25:00',3.24),('16100','2014-03-16','14:30:00',2.78),('16100','2014-03-16','14:35:00',2.9),('16100','2014-03-16','14:40:00',4.04),('16100','2014-03-16','14:45:00',2.5),('16100','2014-03-16','14:50:00',3.86),('16100','2014-03-16','14:55:00',3.31),('16100','2014-03-16','15:00:00',2.65),('16100','2014-03-16','15:05:00',2.38),('16100','2014-03-16','15:10:00',4.31),('16100','2014-03-16','15:15:00',5.09),('16100','2014-03-16','15:20:00',4.7),('16100','2014-03-16','15:25:00',4.16),('16100','2014-03-16','15:30:00',4.3),('16100','2014-03-16','15:35:00',4.26),('16100','2014-03-16','15:40:00',4),('16100','2014-03-16','15:45:00',4.02),('16100','2014-03-16','15:50:00',3.36),('16100','2014-03-16','15:55:00',2.47),('16100','2014-03-16','16:00:00',3.18),('16100','2014-03-16','16:05:00',3.17),('16100','2014-03-16','16:10:00',3.08),('16100','2014-03-16','16:15:00',2.87),('16100','2014-03-16','16:20:00',2.75),('16100','2014-03-16','16:25:00',2.55),('16100','2014-03-16','16:30:00',2.42),('16100','2014-03-16','16:35:00',2.19),('16100','2014-03-16','16:40:00',2.01),('16100','2014-03-16','16:45:00',1.83),('16100','2014-03-16','16:50:00',1.61),('16100','2014-03-16','16:55:00',1.18),('16100','2014-03-15','07:40:00',1.07),('16100','2014-03-15','07:45:00',1.15),('16100','2014-03-15','07:50:00',1.17),('16100','2014-03-15','07:55:00',1.49),('16100','2014-03-15','08:00:00',1.8),('16100','2014-03-15','08:05:00',2.03),('16100','2014-03-15','08:10:00',2.1),('16100','2014-03-15','08:15:00',2.14),('16100','2014-03-15','08:20:00',2.3),('16100','2014-03-15','08:25:00',2.6),('16100','2014-03-15','08:30:00',2.81),('16100','2014-03-15','08:35:00',2.96),('16100','2014-03-15','08:40:00',3.05),('16100','2014-03-15','08:45:00',3.23),('16100','2014-03-15','08:50:00',3.39),('16100','2014-03-15','08:55:00',3.48),('16100','2014-03-15','09:00:00',3.37),('16100','2014-03-15','09:05:00',3.67),('16100','2014-03-15','09:10:00',3.93),('16100','2014-03-15','09:15:00',4.19),('16100','2014-03-15','09:20:00',4.22),('16100','2014-03-15','09:25:00',4.2),('16100','2014-03-15','09:30:00',4.29),('16100','2014-03-15','09:35:00',4.4),('16100','2014-03-15','09:40:00',4.55),('16100','2014-03-15','09:45:00',4.78),('16100','2014-03-15','09:50:00',5.07),('16100','2014-03-15','09:55:00',5.12),('16100','2014-03-15','10:00:00',5.23),('16100','2014-03-15','10:05:00',5.36),('16100','2014-03-15','10:10:00',5.51),('16100','2014-03-15','10:15:00',5.61),('16100','2014-03-15','10:20:00',5.64),('16100','2014-03-15','10:25:00',5.55),('16100','2014-03-15','10:30:00',5.73),('16100','2014-03-15','10:35:00',5.87),('16100','2014-03-15','10:40:00',5.92),('16100','2014-03-15','10:45:00',6.08),('16100','2014-03-15','10:50:00',6.08),('16100','2014-03-15','10:55:00',6.23),('16100','2014-03-15','11:00:00',6.22),('16100','2014-03-15','11:05:00',6.3),('16100','2014-03-15','11:10:00',6.34),('16100','2014-03-15','11:15:00',6.53),('16100','2014-03-15','11:20:00',6.61),('16100','2014-03-15','11:25:00',6.46),('16100','2014-03-15','11:30:00',6.38),('16100','2014-03-15','11:35:00',6.39),('16100','2014-03-15','11:40:00',6.48),('16100','2014-03-15','11:45:00',6.51),('16100','2014-03-15','11:50:00',6.57),('16100','2014-03-15','11:55:00',6.64),('16100','2014-03-15','12:00:00',6.68),('16100','2014-03-15','12:05:00',6.67),('16100','2014-03-15','12:10:00',6.7),('16100','2014-03-15','12:15:00',6.66),('16100','2014-03-15','12:20:00',6.63),('16100','2014-03-15','12:25:00',6.55),('16100','2014-03-15','12:30:00',6.4),('16100','2014-03-15','12:35:00',6.58),('16100','2014-03-15','12:40:00',6.6),('16100','2014-03-15','12:45:00',6.59),('16100','2014-03-15','12:50:00',6.61),('16100','2014-03-15','12:55:00',6.6),('16100','2014-03-15','13:00:00',6.5),('16100','2014-03-15','13:05:00',6.58),('16100','2014-03-15','13:10:00',6.53),('16100','2014-03-15','13:15:00',6.55),('16100','2014-03-15','13:20:00',6.3),('16100','2014-03-15','13:25:00',6.49),('16100','2014-03-15','13:30:00',6.33),('16100','2014-03-15','13:35:00',6.4),('16100','2014-03-15','13:40:00',6.35),('16100','2014-03-15','13:45:00',6.33),('16100','2014-03-15','13:50:00',6.14),('16100','2014-03-15','13:55:00',6.23),('16100','2014-03-15','14:00:00',5.97),('16100','2014-03-15','14:05:00',5.92),('16100','2014-03-15','14:10:00',5.84),('16100','2014-03-15','14:15:00',5.82),('16100','2014-03-15','14:20:00',5.76),('16100','2014-03-15','14:25:00',5.63),('16100','2014-03-15','14:30:00',5.48),('16100','2014-03-15','14:35:00',5.3),('16100','2014-03-15','14:40:00',5.37),('16100','2014-03-15','14:45:00',5.03),('16100','2014-03-15','14:50:00',4.74),('16100','2014-03-15','14:55:00',4.95),('16100','2014-03-15','15:00:00',4.6),('16100','2014-03-15','15:05:00',4.39),('16100','2014-03-15','15:10:00',4.05),('16100','2014-03-15','15:15:00',3.16),('16100','2014-03-15','15:20:00',3.43),('16100','2014-03-15','15:25:00',3.43),('16100','2014-03-15','15:30:00',3.35),('16100','2014-03-15','15:35:00',2.45),('16100','2014-03-15','15:40:00',2.47),('16100','2014-03-15','15:45:00',3.08),('16100','2014-03-15','15:50:00',2.87),('16100','2014-03-15','15:55:00',2.49),('16100','2014-03-15','16:00:00',2.45),('16100','2014-03-15','16:05:00',2.98),('16100','2014-03-15','16:10:00',3),('16100','2014-03-15','16:15:00',2.81),('16100','2014-03-15','16:20:00',2.6),('16100','2014-03-15','16:25:00',2.52),('16100','2014-03-15','16:30:00',2.46),('16100','2014-03-15','16:35:00',2.15),('16100','2014-03-15','16:40:00',1.89),('16100','2014-03-15','16:45:00',1.74),('16100','2014-03-15','16:50:00',1.51),('16100','2014-03-15','16:55:00',1.23),('16100','2014-03-15','17:00:00',1.01),('16100','2014-03-14','07:40:00',1.02),('16100','2014-03-14','07:45:00',1.16),('16100','2014-03-14','07:50:00',1.3),('16100','2014-03-14','07:55:00',1.45),('16100','2014-03-14','08:00:00',1.61),('16100','2014-03-14','08:05:00',1.76),('16100','2014-03-14','08:10:00',1.93),('16100','2014-03-14','08:15:00',2.07),('16100','2014-03-14','08:20:00',2.25),('16100','2014-03-14','08:25:00',2.41),('16100','2014-03-14','08:30:00',2.53),('16100','2014-03-14','08:35:00',2.7),('16100','2014-03-14','08:40:00',2.86),('16100','2014-03-14','08:45:00',3.01),('16100','2014-03-14','08:50:00',3.15),('16100','2014-03-14','08:55:00',3.28),('16100','2014-03-14','09:00:00',3.4),('16100','2014-03-14','09:05:00',3.56),('16100','2014-03-14','09:10:00',3.69),('16100','2014-03-14','09:15:00',3.83),('16100','2014-03-14','09:20:00',3.96),('16100','2014-03-14','09:25:00',4.1),('16100','2014-03-14','09:30:00',4.21),('16100','2014-03-14','09:35:00',4.3),('16100','2014-03-14','09:40:00',4.45),('16100','2014-03-14','09:45:00',4.68),('16100','2014-03-14','09:50:00',4.81),('16100','2014-03-14','09:55:00',4.95),('16100','2014-03-14','10:00:00',5.05),('16100','2014-03-14','10:05:00',5.08),('16100','2014-03-14','10:10:00',5.16),('16100','2014-03-14','10:15:00',5.27),('16100','2014-03-14','10:20:00',5.35),('16100','2014-03-14','10:25:00',5.49),('16100','2014-03-14','10:30:00',5.52),('16100','2014-03-14','10:35:00',5.66),('16100','2014-03-14','10:40:00',5.74),('16100','2014-03-14','10:45:00',5.76),('16100','2014-03-14','10:50:00',5.75),('16100','2014-03-14','10:55:00',5.68),('16100','2014-03-14','11:00:00',6.01),('16100','2014-03-14','11:05:00',5.98),('16100','2014-03-14','11:10:00',6.17),('16100','2014-03-14','11:15:00',6.32),('16100','2014-03-14','11:20:00',6.28),('16100','2014-03-14','11:25:00',6.33),('16100','2014-03-14','11:30:00',6.31),('16100','2014-03-14','11:35:00',6.31),('16100','2014-03-14','11:40:00',6.49),('16100','2014-03-14','11:45:00',6.66),('16100','2014-03-14','11:50:00',6.61),('16100','2014-03-14','11:55:00',6.6),('16100','2014-03-14','12:00:00',6.69),('16100','2014-03-14','12:05:00',6.71),('16100','2014-03-14','12:10:00',6.69),('16100','2014-03-14','12:15:00',6.61),('16100','2014-03-14','12:20:00',6.65),('16100','2014-03-14','12:25:00',6.73),('16100','2014-03-14','12:30:00',6.76),('16100','2014-03-14','12:35:00',6.77),('16100','2014-03-14','12:40:00',6.79),('16100','2014-03-14','12:45:00',6.77),('16100','2014-03-14','12:50:00',6.74),('16100','2014-03-14','12:55:00',6.71),('16100','2014-03-14','13:00:00',6.7),('16100','2014-03-14','13:05:00',6.78),('16100','2014-03-14','13:10:00',6.69),('16100','2014-03-14','13:15:00',6.64),('16100','2014-03-14','13:20:00',6.6),('16100','2014-03-14','13:25:00',6.6),('16100','2014-03-14','13:30:00',6.54),('16100','2014-03-14','13:35:00',6.55),('16100','2014-03-14','13:40:00',6.46),('16100','2014-03-14','13:45:00',6.43),('16100','2014-03-14','13:50:00',6.33),('16100','2014-03-14','13:55:00',6.33),('16100','2014-03-14','14:00:00',6.22),('16100','2014-03-14','14:05:00',6.15),('16100','2014-03-14','14:10:00',6.06),('16100','2014-03-14','14:15:00',5.99),('16100','2014-03-14','14:20:00',5.9),('16100','2014-03-14','14:25:00',5.79),('16100','2014-03-14','14:30:00',5.67),('16100','2014-03-14','14:35:00',5.54),('16100','2014-03-14','14:40:00',5.39),('16100','2014-03-14','14:45:00',5.32),('16100','2014-03-14','14:50:00',5.24),('16100','2014-03-14','14:55:00',5.15),('16100','2014-03-14','15:00:00',4.99),('16100','2014-03-14','15:05:00',4.79),('16100','2014-03-14','15:10:00',4.66),('16100','2014-03-14','15:15:00',4.59),('16100','2014-03-14','15:20:00',4.33),('16100','2014-03-14','15:25:00',4.25),('16100','2014-03-14','15:30:00',4.17),('16100','2014-03-14','15:35:00',4.02),('16100','2014-03-14','15:40:00',3.84),('16100','2014-03-14','15:45:00',3.73),('16100','2014-03-14','15:50:00',3.37),('16100','2014-03-14','15:55:00',3.16),('16100','2014-03-14','16:00:00',3.04),('16100','2014-03-14','16:05:00',2.8),('16100','2014-03-14','16:10:00',2.65),('16100','2014-03-14','16:15:00',2.52),('16100','2014-03-14','16:20:00',2.46),('16100','2014-03-14','16:25:00',2.3),('16100','2014-03-14','16:30:00',2.12),('16100','2014-03-14','16:35:00',1.93),('16100','2014-03-14','16:40:00',1.75),('16100','2014-03-14','16:45:00',1.6),('16100','2014-03-14','16:50:00',1.45),('16100','2014-03-14','16:55:00',1.29),('16100','2014-03-14','17:00:00',1.14),('16100','2014-03-13','08:00:00',1.08),('16100','2014-03-13','08:05:00',1.15),('16100','2014-03-13','08:10:00',1.23),('16100','2014-03-13','08:15:00',1.34),('16100','2014-03-13','08:20:00',1.44),('16100','2014-03-13','08:25:00',1.57),('16100','2014-03-13','08:30:00',1.87),('16100','2014-03-13','08:35:00',1.91),('16100','2014-03-13','08:40:00',1.76),('16100','2014-03-13','08:45:00',1.62),('16100','2014-03-13','08:50:00',1.61),('16100','2014-03-13','08:55:00',1.71),('16100','2014-03-13','09:00:00',1.76),('16100','2014-03-13','09:05:00',1.89),('16100','2014-03-13','09:10:00',2.19),('16100','2014-03-13','09:15:00',2.85),('16100','2014-03-13','09:20:00',3.18),('16100','2014-03-13','09:25:00',3.11),('16100','2014-03-13','09:30:00',2.82),('16100','2014-03-13','09:35:00',2.99),('16100','2014-03-13','09:40:00',3.26),('16100','2014-03-13','09:45:00',3.86),('16100','2014-03-13','09:50:00',4.36),('16100','2014-03-13','09:55:00',4.85),('16100','2014-03-13','10:00:00',5.46),('16100','2014-03-13','10:05:00',5.7),('16100','2014-03-13','10:10:00',5.97),('16100','2014-03-13','10:15:00',5.95),('16100','2014-03-13','10:20:00',6.01),('16100','2014-03-13','10:25:00',6.2),('16100','2014-03-13','10:30:00',6.01),('16100','2014-03-13','10:35:00',5.76),('16100','2014-03-13','10:40:00',6.01),('16100','2014-03-13','10:45:00',6.25),('16100','2014-03-13','10:50:00',6.1),('16100','2014-03-13','10:55:00',4.23),('16100','2014-03-13','11:00:00',4.4),('16100','2014-03-13','11:05:00',6.05),('16100','2014-03-13','11:10:00',6.01),('16100','2014-03-13','11:15:00',6.53),('16100','2014-03-13','11:20:00',6.83),('16100','2014-03-13','11:25:00',6.73),('16100','2014-03-13','11:30:00',6.53),('16100','2014-03-13','11:35:00',6.55),('16100','2014-03-13','11:40:00',6.48),('16100','2014-03-13','11:45:00',6.42),('16100','2014-03-13','11:50:00',6.27),('16100','2014-03-13','11:55:00',6.61),('16100','2014-03-13','12:00:00',6.53),('16100','2014-03-13','12:05:00',6.78),('16100','2014-03-13','12:10:00',6.75),('16100','2014-03-13','12:15:00',6.54),('16100','2014-03-13','12:20:00',6.22),('16100','2014-03-13','12:25:00',6.22),('16100','2014-03-13','12:30:00',6.18),('16100','2014-03-13','12:35:00',5.14),('16100','2014-03-13','12:40:00',4.18),('16100','2014-03-13','12:45:00',3.69),('16100','2014-03-13','12:50:00',3.49),('16100','2014-03-13','12:55:00',4.08),('16100','2014-03-13','13:00:00',3.82),('16100','2014-03-13','13:05:00',3.36),('16100','2014-03-13','13:10:00',2.93),('16100','2014-03-13','13:15:00',3.89),('16100','2014-03-13','13:20:00',4.28),('16100','2014-03-13','13:25:00',4.54),('16100','2014-03-13','13:30:00',5.19),('16100','2014-03-13','13:35:00',4.77),('16100','2014-03-13','13:40:00',4.09),('16100','2014-03-13','13:45:00',3.38),('16100','2014-03-13','13:50:00',3.63),('16100','2014-03-13','13:55:00',3.84),('16100','2014-03-13','14:00:00',3.95),('16100','2014-03-13','14:05:00',4.1),('16100','2014-03-13','14:10:00',3.87),('16100','2014-03-13','14:15:00',3.81),('16100','2014-03-13','14:20:00',5.06),('16100','2014-03-13','14:25:00',4.4),('16100','2014-03-13','14:30:00',4.28),('16100','2014-03-13','14:35:00',4.58),('16100','2014-03-13','14:40:00',4.78),('16100','2014-03-13','14:45:00',3.8),('16100','2014-03-13','14:50:00',2.97),('16100','2014-03-13','14:55:00',2.66),('16100','2014-03-13','15:00:00',2.38),('16100','2014-03-13','15:05:00',2.07),('16100','2014-03-13','15:10:00',1.93),('16100','2014-03-13','15:15:00',1.83),('16100','2014-03-13','15:20:00',1.73),('16100','2014-03-13','15:25:00',1.97),('16100','2014-03-13','15:30:00',2.35),('16100','2014-03-13','15:35:00',2.29),('16100','2014-03-13','15:40:00',2.61),('16100','2014-03-13','15:45:00',2.71),('16100','2014-03-13','15:50:00',2.24),('16100','2014-03-13','15:55:00',1.91),('16100','2014-03-13','16:00:00',1.74),('16100','2014-03-13','16:05:00',1.54),('16100','2014-03-13','16:10:00',1.47),('16100','2014-03-13','16:15:00',1.31),('16100','2014-03-13','16:20:00',1.18),('16100','2014-03-12','07:35:00',1.12),('16100','2014-03-12','07:40:00',1.29),('16100','2014-03-12','07:45:00',1.48),('16100','2014-03-12','07:50:00',1.67),('16100','2014-03-12','07:55:00',1.87),('16100','2014-03-12','08:00:00',2.04),('16100','2014-03-12','08:05:00',2.25),('16100','2014-03-12','08:10:00',2.45),('16100','2014-03-12','08:15:00',2.63),('16100','2014-03-12','08:20:00',2.82),('16100','2014-03-12','08:25:00',2.99),('16100','2014-03-12','08:30:00',3.15),('16100','2014-03-12','08:35:00',3.34),('16100','2014-03-12','08:40:00',3.53),('16100','2014-03-12','08:45:00',3.68),('16100','2014-03-12','08:50:00',3.85),('16100','2014-03-12','08:55:00',4),('16100','2014-03-12','09:00:00',4.15),('16100','2014-03-12','09:05:00',3.99),('16100','2014-03-12','09:10:00',4.44),('16100','2014-03-12','09:15:00',4.58),('16100','2014-03-12','09:20:00',4.71),('16100','2014-03-12','09:25:00',4.83),('16100','2014-03-12','09:30:00',4.96),('16100','2014-03-12','09:35:00',5.07),('16100','2014-03-12','09:40:00',5.18),('16100','2014-03-12','09:45:00',5.33),('16100','2014-03-12','09:50:00',5.5),('16100','2014-03-12','09:55:00',5.19),('16100','2014-03-12','10:00:00',5.3),('16100','2014-03-12','10:05:00',5.8),('16100','2014-03-12','10:10:00',5.89),('16100','2014-03-12','10:15:00',5.98),('16100','2014-03-12','10:20:00',6.06),('16100','2014-03-12','10:25:00',6.13),('16100','2014-03-12','10:30:00',6.23),('16100','2014-03-12','10:35:00',6.31),('16100','2014-03-12','10:40:00',6.41),('16100','2014-03-12','10:45:00',6.54),('16100','2014-03-12','10:50:00',6.59),('16100','2014-03-12','10:55:00',6.66),('16100','2014-03-12','11:00:00',6.66),('16100','2014-03-12','11:05:00',6.71),('16100','2014-03-12','11:10:00',6.72),('16100','2014-03-12','11:15:00',6.82),('16100','2014-03-12','11:20:00',6.91),('16100','2014-03-12','11:25:00',6.89),('16100','2014-03-12','11:30:00',6.95),('16100','2014-03-12','11:35:00',7.02),('16100','2014-03-12','11:40:00',7.09),('16100','2014-03-12','11:45:00',7.08),('16100','2014-03-12','11:50:00',7.11),('16100','2014-03-12','11:55:00',7.1),('16100','2014-03-12','12:00:00',7.1),('16100','2014-03-12','12:05:00',7.11),('16100','2014-03-12','12:10:00',7.13),('16100','2014-03-12','12:15:00',7.1),('16100','2014-03-12','12:20:00',7.09),('16100','2014-03-12','12:25:00',7.08),('16100','2014-03-12','12:30:00',7.04),('16100','2014-03-12','12:35:00',7.04),('16100','2014-03-12','12:40:00',7.01),('16100','2014-03-12','12:45:00',6.99),('16100','2014-03-12','12:50:00',6.92),('16100','2014-03-12','12:55:00',6.81),('16100','2014-03-12','13:00:00',6.87),('16100','2014-03-12','13:05:00',6.94),('16100','2014-03-12','13:10:00',6.91),('16100','2014-03-12','13:15:00',6.94),('16100','2014-03-12','13:20:00',6.84),('16100','2014-03-12','13:25:00',6.77),('16100','2014-03-12','13:30:00',6.74),('16100','2014-03-12','13:35:00',6.7),('16100','2014-03-12','13:40:00',6.66),('16100','2014-03-12','13:45:00',6.59),('16100','2014-03-12','13:50:00',6.49),('16100','2014-03-12','13:55:00',6.38),('16100','2014-03-12','14:00:00',6.32),('16100','2014-03-12','14:05:00',6.26),('16100','2014-03-12','14:10:00',6.16),('16100','2014-03-12','14:15:00',6.07),('16100','2014-03-12','14:20:00',5.98),('16100','2014-03-12','14:25:00',5.89),('16100','2014-03-12','14:30:00',5.74),('16100','2014-03-12','14:35:00',5.63),('16100','2014-03-12','14:40:00',5.51),('16100','2014-03-12','14:45:00',5.41),('16100','2014-03-12','14:50:00',5.27),('16100','2014-03-12','14:55:00',5.16),('16100','2014-03-12','15:00:00',5),('16100','2014-03-12','15:05:00',4.86),('16100','2014-03-12','15:10:00',4.75),('16100','2014-03-12','15:15:00',4.59),('16100','2014-03-12','15:20:00',4.4),('16100','2014-03-12','15:25:00',4.27),('16100','2014-03-12','15:30:00',4.14),('16100','2014-03-12','15:35:00',4.02),('16100','2014-03-12','15:40:00',3.88),('16100','2014-03-12','15:45:00',3.73),('16100','2014-03-12','15:50:00',3.58),('16100','2014-03-12','15:55:00',3.43),('16100','2014-03-12','16:00:00',3.28),('16100','2014-03-12','16:05:00',3.09),('16100','2014-03-12','16:10:00',2.9),('16100','2014-03-12','16:15:00',2.74),('16100','2014-03-12','16:20:00',2.62),('16100','2014-03-12','16:25:00',2.49),('16100','2014-03-12','16:30:00',2.34),('16100','2014-03-12','16:35:00',2.16),('16100','2014-03-12','16:40:00',1.96),('16100','2014-03-12','16:45:00',1.81),('16100','2014-03-12','16:50:00',1.65),('16100','2014-03-12','16:55:00',1.46),('16100','2014-03-12','17:00:00',1.33),('16100','2014-03-12','17:05:00',1.15),('16100','2014-03-12','17:10:00',1.02),('16100','2014-03-11','07:35:00',1.05),('16100','2014-03-11','07:40:00',1.22),('16100','2014-03-11','07:45:00',1.41),('16100','2014-03-11','07:50:00',1.59),('16100','2014-03-11','07:55:00',1.79),('16100','2014-03-11','08:00:00',1.97),('16100','2014-03-11','08:05:00',2.18),('16100','2014-03-11','08:10:00',2.38),('16100','2014-03-11','08:15:00',2.56),('16100','2014-03-11','08:20:00',2.75),('16100','2014-03-11','08:25:00',2.92),('16100','2014-03-11','08:30:00',3.07),('16100','2014-03-11','08:35:00',3.23),('16100','2014-03-11','08:40:00',3.45),('16100','2014-03-11','08:45:00',3.59),('16100','2014-03-11','08:50:00',3.74),('16100','2014-03-11','08:55:00',3.92),('16100','2014-03-11','09:00:00',4.06),('16100','2014-03-11','09:05:00',4.19),('16100','2014-03-11','09:10:00',4.34),('16100','2014-03-11','09:15:00',4.46),('16100','2014-03-11','09:20:00',4.57),('16100','2014-03-11','09:25:00',4.72),('16100','2014-03-11','09:30:00',4.89),('16100','2014-03-11','09:35:00',5.01),('16100','2014-03-11','09:40:00',5.12),('16100','2014-03-11','09:45:00',5.26),('16100','2014-03-11','09:50:00',5.41),('16100','2014-03-11','09:55:00',5.54),('16100','2014-03-11','10:00:00',5.69),('16100','2014-03-11','10:05:00',5.78),('16100','2014-03-11','10:10:00',5.88),('16100','2014-03-11','10:15:00',5.98),('16100','2014-03-11','10:20:00',6.07),('16100','2014-03-11','10:25:00',6.14),('16100','2014-03-11','10:30:00',6.23),('16100','2014-03-11','10:35:00',6.35),('16100','2014-03-11','10:40:00',6.45),('16100','2014-03-11','10:45:00',6.55),('16100','2014-03-11','10:50:00',6.56),('16100','2014-03-11','10:55:00',6.66),('16100','2014-03-11','11:00:00',6.72),('16100','2014-03-11','11:05:00',6.77),('16100','2014-03-11','11:10:00',6.81),('16100','2014-03-11','11:15:00',6.84),('16100','2014-03-11','11:20:00',6.91),('16100','2014-03-11','11:25:00',6.95),('16100','2014-03-11','11:30:00',7),('16100','2014-03-11','11:35:00',7.03),('16100','2014-03-11','11:40:00',7.09),('16100','2014-03-11','11:45:00',7.05),('16100','2014-03-11','11:50:00',7.13),('16100','2014-03-11','11:55:00',7.17),('16100','2014-03-11','12:00:00',7.22),('16100','2014-03-11','12:05:00',7.2),('16100','2014-03-11','12:10:00',7.19),('16100','2014-03-11','12:15:00',7.22),('16100','2014-03-11','12:20:00',7.25),('16100','2014-03-11','12:25:00',7.25),('16100','2014-03-11','12:30:00',7.18),('16100','2014-03-11','12:35:00',7.12),('16100','2014-03-11','12:40:00',7.13),('16100','2014-03-11','12:45:00',7.15),('16100','2014-03-11','12:50:00',7.12),('16100','2014-03-11','12:55:00',7.13),('16100','2014-03-11','13:00:00',7.08),('16100','2014-03-11','13:05:00',7.03),('16100','2014-03-11','13:10:00',7),('16100','2014-03-11','13:15:00',6.98),('16100','2014-03-11','13:20:00',6.87),('16100','2014-03-11','13:25:00',6.79),('16100','2014-03-11','13:30:00',6.75),('16100','2014-03-11','13:35:00',6.68),('16100','2014-03-11','13:40:00',6.59),('16100','2014-03-11','13:45:00',6.62),('16100','2014-03-11','13:50:00',6.58),('16100','2014-03-11','13:55:00',6.52),('16100','2014-03-11','14:00:00',6.36),('16100','2014-03-11','14:05:00',6.27),('16100','2014-03-11','14:10:00',6.14),('16100','2014-03-11','14:15:00',6.07),('16100','2014-03-11','14:20:00',6),('16100','2014-03-11','14:25:00',5.9),('16100','2014-03-11','14:30:00',5.79),('16100','2014-03-11','14:35:00',5.66),('16100','2014-03-11','14:40:00',5.39),('16100','2014-03-11','14:45:00',5.4),('16100','2014-03-11','14:50:00',5.33),('16100','2014-03-11','14:55:00',5.28),('16100','2014-03-11','15:00:00',4.92),('16100','2014-03-11','15:05:00',4.9),('16100','2014-03-11','15:10:00',4.76),('16100','2014-03-11','15:15:00',4.66),('16100','2014-03-11','15:20:00',4.52),('16100','2014-03-11','15:25:00',4.37),('16100','2014-03-11','15:30:00',4.22),('16100','2014-03-11','15:35:00',4.11),('16100','2014-03-11','15:40:00',3.97),('16100','2014-03-11','15:45:00',3.8),('16100','2014-03-11','15:50:00',3.63),('16100','2014-03-11','15:55:00',3.47),('16100','2014-03-11','16:00:00',3.3),('16100','2014-03-11','16:05:00',3.15),('16100','2014-03-11','16:10:00',3.01),('16100','2014-03-11','16:15:00',2.87),('16100','2014-03-11','16:20:00',2.7),('16100','2014-03-11','16:25:00',2.53),('16100','2014-03-11','16:30:00',2.34),('16100','2014-03-11','16:35:00',2.15),('16100','2014-03-11','16:40:00',1.95),('16100','2014-03-11','16:45:00',1.75),('16100','2014-03-11','16:50:00',1.58),('16100','2014-03-11','16:55:00',1.41),('16100','2014-03-11','17:00:00',1.24),('16100','2014-03-11','17:05:00',1.09),('16100','2014-03-10','09:15:00',1.02),('16100','2014-03-10','10:15:00',1.15),('16100','2014-03-10','10:20:00',1.33),('16100','2014-03-10','10:25:00',1.38),('16100','2014-03-10','10:30:00',1.38),('16100','2014-03-10','10:35:00',1.24),('16100','2014-03-10','10:40:00',1.06),('16100','2014-03-10','10:50:00',1.04),('16100','2014-03-10','10:55:00',1.19),('16100','2014-03-10','11:00:00',1.29),('16100','2014-03-10','11:05:00',1.28),('16100','2014-03-10','11:10:00',1.38),('16100','2014-03-10','11:15:00',1.64),('16100','2014-03-10','11:20:00',1.6),('16100','2014-03-10','11:25:00',1.41),('16100','2014-03-10','11:30:00',1.11),('16100','2014-03-10','11:35:00',1.16),('16100','2014-03-10','11:40:00',1.25),('16100','2014-03-10','11:45:00',1.3),('16100','2014-03-10','11:50:00',1.35),('16100','2014-03-10','11:55:00',1.61),('16100','2014-03-10','12:00:00',1.75),('16100','2014-03-10','12:05:00',1.79),('16100','2014-03-10','12:10:00',1.95),('16100','2014-03-10','12:15:00',2.3),('16100','2014-03-10','12:20:00',2.58),('16100','2014-03-10','12:25:00',2.37),('16100','2014-03-10','12:30:00',2.06),('16100','2014-03-10','12:35:00',1.98),('16100','2014-03-10','12:40:00',1.91),('16100','2014-03-10','12:45:00',2.33),('16100','2014-03-10','12:50:00',2.96),('16100','2014-03-10','12:55:00',3.11),('16100','2014-03-10','13:00:00',3.44),('16100','2014-03-10','13:05:00',3),('16100','2014-03-10','13:10:00',3),('16100','2014-03-10','13:15:00',2.13),('16100','2014-03-10','13:20:00',2.27),('16100','2014-03-10','13:25:00',2.17),('16100','2014-03-10','13:30:00',1.84),('16100','2014-03-10','13:35:00',1.79),('16100','2014-03-10','13:40:00',2.01),('16100','2014-03-10','13:45:00',2.35),('16100','2014-03-10','13:50:00',2.6),('16100','2014-03-10','13:55:00',2.85),('16100','2014-03-10','14:00:00',4.57),('16100','2014-03-10','14:05:00',4.27),('16100','2014-03-10','14:10:00',4.23),('16100','2014-03-10','14:15:00',3.49),('16100','2014-03-10','14:20:00',3.3),('16100','2014-03-10','14:25:00',3.68),('16100','2014-03-10','14:30:00',3.12),('16100','2014-03-10','14:35:00',2.92),('16100','2014-03-10','14:40:00',2.91),('16100','2014-03-10','14:45:00',2.95),('16100','2014-03-10','14:50:00',2.62),('16100','2014-03-10','14:55:00',2.63),('16100','2014-03-10','15:00:00',2.85),('16100','2014-03-10','15:05:00',2.89),('16100','2014-03-10','15:10:00',2.9),('16100','2014-03-10','15:15:00',2.75),('16100','2014-03-10','15:20:00',2),('16100','2014-03-10','15:25:00',1.74),('16100','2014-03-10','15:30:00',1.6),('16100','2014-03-10','15:35:00',1.44),('16100','2014-03-10','15:40:00',1.35),('16100','2014-03-10','15:45:00',1.41),('16100','2014-03-10','15:50:00',1.18),('16100','2014-03-10','15:55:00',1),('16100','2014-03-09','08:30:00',1.08),('16100','2014-03-09','08:35:00',1.18),('16100','2014-03-09','08:40:00',1.32),('16100','2014-03-09','08:45:00',1.37),('16100','2014-03-09','08:50:00',1.45),('16100','2014-03-09','08:55:00',1.53),('16100','2014-03-09','09:00:00',1.56),('16100','2014-03-09','09:05:00',1.6),('16100','2014-03-09','09:10:00',1.64),('16100','2014-03-09','09:15:00',1.63),('16100','2014-03-09','09:20:00',1.24),('16100','2014-03-09','09:25:00',1.14),('16100','2014-03-09','09:30:00',1.34),('16100','2014-03-09','09:35:00',1.7),('16100','2014-03-09','09:40:00',1.9),('16100','2014-03-09','09:45:00',2.01),('16100','2014-03-09','09:50:00',2.01),('16100','2014-03-09','09:55:00',1.58),('16100','2014-03-09','10:00:00',1.21),('16100','2014-03-09','10:05:00',1.28),('16100','2014-03-09','10:10:00',1.24),('16100','2014-03-09','10:15:00',1.48),('16100','2014-03-09','10:20:00',1.6),('16100','2014-03-09','10:25:00',1.38),('16100','2014-03-09','10:30:00',1.4),('16100','2014-03-09','10:35:00',1.43),('16100','2014-03-09','10:40:00',1.29),('16100','2014-03-09','11:15:00',1.11),('16100','2014-03-09','11:20:00',1.37),('16100','2014-03-09','11:25:00',1.25),('16100','2014-03-09','11:30:00',1.1),('16100','2014-03-09','12:10:00',1.03),('16100','2014-03-09','12:35:00',1.03),('16100','2014-03-09','12:40:00',1.23),('16100','2014-03-09','12:45:00',1.4),('16100','2014-03-09','12:50:00',1.47),('16100','2014-03-09','12:55:00',1.54),('16100','2014-03-09','13:00:00',1.71),('16100','2014-03-09','13:05:00',1.79),('16100','2014-03-09','13:10:00',1.85),('16100','2014-03-09','13:15:00',1.69),('16100','2014-03-09','13:20:00',1.5),('16100','2014-03-09','13:25:00',1.41),('16100','2014-03-09','13:30:00',1.15),('16100','2014-03-09','13:35:00',1.06),('16100','2014-03-09','14:05:00',1),('16100','2014-03-09','14:10:00',1.58),('16100','2014-03-09','14:15:00',1.85),('16100','2014-03-09','14:20:00',1.77),('16100','2014-03-09','14:25:00',1.24),('16100','2014-03-09','14:30:00',1.25),('16100','2014-03-09','14:35:00',1.66),('16100','2014-03-09','14:40:00',1.76),('16100','2014-03-09','14:45:00',1.6),('16100','2014-03-09','14:50:00',1.71),('16100','2014-03-09','14:55:00',1.98),('16100','2014-03-09','15:00:00',2.44),('16100','2014-03-09','15:05:00',5.91),('16100','2014-03-09','15:10:00',5.21),('16100','2014-03-09','15:15:00',5.33),('16100','2014-03-09','15:20:00',4.81),('16100','2014-03-09','15:25:00',3.94),('16100','2014-03-09','15:30:00',3.81),('16100','2014-03-09','15:35:00',2.63),('16100','2014-03-09','15:40:00',1.64),('16100','2014-03-09','15:45:00',1.36),('16100','2014-03-09','15:50:00',1.51),('16100','2014-03-09','15:55:00',1.53),('16100','2014-03-09','16:00:00',1.4),('16100','2014-03-09','16:05:00',1.03),('16100','2014-03-09','16:20:00',1.07),('16100','2014-03-09','16:25:00',1.45),('16100','2014-03-09','16:30:00',2.39),('16100','2014-03-09','16:35:00',2.8),('16100','2014-03-09','16:40:00',1.98),('16100','2014-03-09','16:45:00',1.48),('16100','2014-03-09','16:50:00',1.12),('16100','2014-03-09','16:55:00',1.29),('16100','2014-03-09','17:00:00',1.4),('16100','2014-03-09','17:05:00',1.39),('16100','2014-03-08','07:40:00',1.01),('16100','2014-03-08','07:45:00',1.31),('16100','2014-03-08','07:50:00',1.5),('16100','2014-03-08','07:55:00',1.69),('16100','2014-03-08','08:00:00',1.88),('16100','2014-03-08','08:05:00',2.07),('16100','2014-03-08','08:10:00',2.27),('16100','2014-03-08','08:15:00',2.46),('16100','2014-03-08','08:20:00',2.66),('16100','2014-03-08','08:25:00',2.86),('16100','2014-03-08','08:30:00',3.05),('16100','2014-03-08','08:35:00',3.22),('16100','2014-03-08','08:40:00',3.44),('16100','2014-03-08','08:45:00',3.69),('16100','2014-03-08','08:50:00',3.8),('16100','2014-03-08','08:55:00',3.89),('16100','2014-03-08','09:00:00',4.09),('16100','2014-03-08','09:05:00',4.25),('16100','2014-03-08','09:10:00',4.38),('16100','2014-03-08','09:15:00',4.57),('16100','2014-03-08','09:20:00',4.77),('16100','2014-03-08','09:25:00',3.56),('16100','2014-03-08','09:30:00',5.16),('16100','2014-03-08','09:35:00',5.38),('16100','2014-03-08','09:40:00',5.61),('16100','2014-03-08','09:45:00',5.69),('16100','2014-03-08','09:50:00',5.95),('16100','2014-03-08','09:55:00',6.01),('16100','2014-03-08','10:00:00',6.14),('16100','2014-03-08','10:05:00',6.18),('16100','2014-03-08','10:10:00',6.27),('16100','2014-03-08','10:15:00',6.37),('16100','2014-03-08','10:20:00',6.42),('16100','2014-03-08','10:25:00',6.45),('16100','2014-03-08','10:30:00',6.45),('16100','2014-03-08','10:35:00',6.67),('16100','2014-03-08','10:40:00',6.76),('16100','2014-03-08','10:45:00',6.91),('16100','2014-03-08','10:50:00',6.85),('16100','2014-03-08','10:55:00',7.03),('16100','2014-03-08','11:00:00',7.48),('16100','2014-03-08','11:05:00',7.56),('16100','2014-03-08','11:10:00',7.68),('16100','2014-03-08','11:15:00',7.79),('16100','2014-03-08','11:20:00',4.87),('16100','2014-03-08','11:25:00',1.52),('16100','2014-03-08','11:30:00',1.77),('16100','2014-03-08','11:35:00',4.34),('16100','2014-03-08','11:40:00',7.74),('16100','2014-03-08','11:45:00',2.88),('16100','2014-03-08','11:50:00',2.11),('16100','2014-03-08','11:55:00',3.15),('16100','2014-03-08','12:00:00',5.21),('16100','2014-03-08','12:05:00',3.08),('16100','2014-03-08','12:10:00',2.38),('16100','2014-03-08','12:15:00',5.16),('16100','2014-03-08','12:20:00',8.59),('16100','2014-03-08','12:25:00',8.44),('16100','2014-03-08','12:30:00',8.18),('16100','2014-03-08','12:35:00',8.23),('16100','2014-03-08','12:40:00',8.08),('16100','2014-03-08','12:45:00',7.86),('16100','2014-03-08','12:50:00',7.62),('16100','2014-03-08','12:55:00',7.14),('16100','2014-03-08','13:00:00',4.21),('16100','2014-03-08','13:05:00',2.41),('16100','2014-03-08','13:10:00',4.58),('16100','2014-03-08','13:15:00',2.81),('16100','2014-03-08','13:20:00',4.77),('16100','2014-03-08','13:25:00',7.16),('16100','2014-03-08','13:30:00',3.94),('16100','2014-03-08','13:35:00',2.51),('16100','2014-03-08','13:40:00',1.61),('16100','2014-03-08','13:45:00',4.69),('16100','2014-03-08','13:50:00',6.45),('16100','2014-03-08','13:55:00',5.1),('16100','2014-03-08','14:00:00',3.42),('16100','2014-03-08','14:05:00',3.78),('16100','2014-03-08','14:10:00',6.29),('16100','2014-03-08','14:15:00',6.64),('16100','2014-03-08','14:20:00',6.48),('16100','2014-03-08','14:25:00',6.41),('16100','2014-03-08','14:30:00',6.36),('16100','2014-03-08','14:35:00',6.35),('16100','2014-03-08','14:40:00',6.19),('16100','2014-03-08','14:45:00',6.11),('16100','2014-03-08','14:50:00',5.82),('16100','2014-03-08','14:55:00',5.61),('16100','2014-03-08','15:00:00',5.57),('16100','2014-03-08','15:05:00',5.58),('16100','2014-03-08','15:10:00',5.55),('16100','2014-03-08','15:15:00',2.89),('16100','2014-03-08','15:20:00',1.48),('16100','2014-03-08','15:25:00',1.55),('16100','2014-03-08','15:30:00',1.23),('16100','2014-03-08','15:35:00',2.86),('16100','2014-03-08','15:40:00',3.19),('16100','2014-03-08','15:45:00',2.57),('16100','2014-03-08','15:50:00',3.81),('16100','2014-03-08','15:55:00',2.54),('16100','2014-03-08','16:05:00',1.03),('16100','2014-03-08','16:20:00',2.28),('16100','2014-03-08','16:25:00',2.67),('16100','2014-03-08','16:30:00',2.43),('16100','2014-03-08','16:35:00',2.22),('16100','2014-03-08','16:40:00',2.03),('16100','2014-03-08','16:45:00',1.84),('16100','2014-03-08','16:50:00',1.69),('16100','2014-03-08','16:55:00',1.51),('16100','2014-03-08','17:00:00',1.35),('16100','2014-03-08','17:05:00',1.18),('16100','2014-03-07','07:40:00',1.14),('16100','2014-03-07','07:45:00',1.31),('16100','2014-03-07','07:50:00',1.49),('16100','2014-03-07','07:55:00',1.66),('16100','2014-03-07','08:00:00',1.86),('16100','2014-03-07','08:05:00',2.05),('16100','2014-03-07','08:10:00',2.26),('16100','2014-03-07','08:15:00',2.47),('16100','2014-03-07','08:20:00',2.64),('16100','2014-03-07','08:25:00',2.82),('16100','2014-03-07','08:30:00',2.98),('16100','2014-03-07','08:35:00',3.14),('16100','2014-03-07','08:40:00',3.32),('16100','2014-03-07','08:45:00',3.51),('16100','2014-03-07','08:50:00',3.69),('16100','2014-03-07','08:55:00',3.84),('16100','2014-03-07','09:00:00',3.96),('16100','2014-03-07','09:05:00',4.12),('16100','2014-03-07','09:10:00',4.27),('16100','2014-03-07','09:15:00',4.44),('16100','2014-03-07','09:20:00',4.59),('16100','2014-03-07','09:25:00',4.73),('16100','2014-03-07','09:30:00',4.85),('16100','2014-03-07','09:35:00',4.93),('16100','2014-03-07','09:40:00',5.02),('16100','2014-03-07','09:45:00',5.19),('16100','2014-03-07','09:50:00',5.38),('16100','2014-03-07','09:55:00',5.56),('16100','2014-03-07','10:00:00',5.64),('16100','2014-03-07','10:05:00',5.76),('16100','2014-03-07','10:10:00',5.84),('16100','2014-03-07','10:15:00',5.97),('16100','2014-03-07','10:20:00',6.02),('16100','2014-03-07','10:25:00',6.15),('16100','2014-03-07','10:30:00',6.24),('16100','2014-03-07','10:35:00',6.43),('16100','2014-03-07','10:40:00',6.67),('16100','2014-03-07','10:45:00',6.73),('16100','2014-03-07','10:50:00',6.7),('16100','2014-03-07','10:55:00',6.78),('16100','2014-03-07','11:00:00',6.82),('16100','2014-03-07','11:05:00',6.89),('16100','2014-03-07','11:10:00',7.06),('16100','2014-03-07','11:15:00',7.15),('16100','2014-03-07','11:20:00',7.39),('16100','2014-03-07','11:25:00',7.5),('16100','2014-03-07','11:30:00',7.75),('16100','2014-03-07','11:35:00',7.16),('16100','2014-03-07','11:40:00',8.35),('16100','2014-03-07','11:45:00',8.25),('16100','2014-03-07','11:50:00',8.44),('16100','2014-03-07','11:55:00',8.46),('16100','2014-03-07','12:00:00',8.49),('16100','2014-03-07','12:05:00',7.16),('16100','2014-03-07','12:10:00',6.89),('16100','2014-03-07','12:15:00',9.33),('16100','2014-03-07','12:20:00',7.87),('16100','2014-03-07','12:25:00',4.97),('16100','2014-03-07','12:30:00',3.26),('16100','2014-03-07','12:35:00',2.81),('16100','2014-03-07','12:40:00',2.92),('16100','2014-03-07','12:45:00',2.91),('16100','2014-03-07','12:50:00',2.83),('16100','2014-03-07','12:55:00',3.4),('16100','2014-03-07','13:00:00',3.72),('16100','2014-03-07','13:05:00',3.33),('16100','2014-03-07','13:10:00',2.74),('16100','2014-03-07','13:15:00',2.32),('16100','2014-03-07','13:20:00',1.91),('16100','2014-03-07','13:25:00',1.62),('16100','2014-03-07','13:30:00',1.71),('16100','2014-03-07','13:35:00',2.13),('16100','2014-03-07','13:40:00',3.1),('16100','2014-03-07','13:45:00',2.7),('16100','2014-03-07','13:50:00',3.69),('16100','2014-03-07','13:55:00',3.91),('16100','2014-03-07','14:00:00',2.34),('16100','2014-03-07','14:05:00',2.04),('16100','2014-03-07','14:10:00',1.75),('16100','2014-03-07','14:15:00',1.4),('16100','2014-03-07','14:20:00',1.09),('16100','2014-03-07','14:25:00',1.06),('16100','2014-03-07','14:40:00',1.17),('16100','2014-03-07','14:45:00',1.33),('16100','2014-03-07','14:50:00',1.39),('16100','2014-03-07','14:55:00',1.56),('16100','2014-03-07','15:00:00',1.66),('16100','2014-03-07','15:05:00',1.55),('16100','2014-03-07','15:10:00',1.31),('16100','2014-03-07','15:15:00',1.38),('16100','2014-03-07','15:20:00',1.75),('16100','2014-03-07','15:25:00',2.78),('16100','2014-03-07','15:30:00',1.63),('16100','2014-03-07','15:35:00',1.14),('16100','2014-03-07','15:55:00',1.1),('16100','2014-03-07','16:00:00',1.28),('16100','2014-03-07','16:05:00',1.3),('16100','2014-03-07','16:10:00',1.28),('16100','2014-03-07','16:30:00',2.18),('16100','2014-03-07','16:40:00',2.28),('16100','2014-03-07','16:45:00',2.01),('16100','2014-03-07','16:50:00',1.83),('16100','2014-03-07','16:55:00',1.63),('16100','2014-03-07','17:00:00',1.39),('16100','2014-03-07','17:05:00',1.22),('16100','2014-03-07','17:10:00',1.06),('16100','2014-04-29','07:55:00',1.06),('16100','2014-04-29','08:00:00',1.24),('16100','2014-04-29','08:05:00',1.38),('16100','2014-04-29','08:10:00',1.59),('16100','2014-04-29','08:15:00',1.77),('16100','2014-04-29','08:20:00',1.94),('16100','2014-04-29','08:25:00',2.22),('16100','2014-04-29','08:30:00',2.49),('16100','2014-04-29','08:35:00',2.74),('16100','2014-04-29','08:40:00',2.88),('16100','2014-04-29','08:45:00',3.05),('16100','2014-04-29','08:50:00',3.23),('16100','2014-04-29','08:55:00',3.32),('16100','2014-04-29','09:00:00',3.49),('16100','2014-04-29','09:05:00',3.69),('16100','2014-04-29','09:10:00',3.72),('16100','2014-04-29','09:15:00',4.07),('16100','2014-04-29','09:20:00',4.3),('16100','2014-04-29','09:25:00',4.63),('16100','2014-04-29','09:30:00',1.87),('16100','2014-04-29','09:35:00',2.69),('16100','2014-04-29','09:40:00',3.25),('16100','2014-04-29','09:45:00',4.63),('16100','2014-04-29','09:50:00',5.27),('16100','2014-04-29','09:55:00',4.48),('16100','2014-04-29','10:00:00',5.64),('16100','2014-04-29','10:05:00',5.65),('16100','2014-04-29','10:10:00',5.74),('16100','2014-04-29','10:15:00',4.94),('16100','2014-04-29','10:20:00',6.06),('16100','2014-04-29','10:25:00',3.28),('16100','2014-04-29','10:30:00',7.04),('16100','2014-04-29','10:35:00',3.91),('16100','2014-04-29','10:40:00',1.58),('16100','2014-04-29','10:45:00',1.85),('16100','2014-04-29','10:50:00',2.18),('16100','2014-04-29','10:55:00',3.78),('16100','2014-04-29','11:00:00',3.73),('16100','2014-04-29','11:05:00',3.32),('16100','2014-04-29','11:10:00',3.04),('16100','2014-04-29','11:15:00',5.01),('16100','2014-04-29','11:20:00',5.03),('16100','2014-04-29','11:25:00',5.7),('16100','2014-04-29','11:30:00',4.21),('16100','2014-04-29','11:35:00',3.48),('16100','2014-04-29','11:40:00',4.83),('16100','2014-04-29','11:45:00',6.63),('16100','2014-04-29','11:50:00',4.7),('16100','2014-04-29','11:55:00',3.59),('16100','2014-04-29','12:00:00',2.76),('16100','2014-04-29','12:05:00',4.61),('16100','2014-04-29','12:10:00',3.48),('16100','2014-04-29','12:15:00',7.43),('16100','2014-04-29','12:20:00',6.56),('16100','2014-04-29','12:25:00',8.55),('16100','2014-04-29','12:30:00',4.97),('16100','2014-04-29','12:35:00',5.39),('16100','2014-04-29','12:40:00',8.47),('16100','2014-04-29','12:45:00',8.78),('16100','2014-04-29','12:50:00',8.15),('16100','2014-04-29','12:55:00',5.59),('16100','2014-04-29','13:00:00',6.11),('16100','2014-04-29','13:05:00',3.3),('16100','2014-04-29','13:10:00',1.88),('16100','2014-04-29','13:15:00',4.77),('16100','2014-04-29','13:20:00',3.35),('16100','2014-04-29','13:25:00',3.96),('16100','2014-04-29','13:30:00',3.97),('16100','2014-04-29','13:35:00',3.01),('16100','2014-04-29','13:40:00',3.63),('16100','2014-04-29','13:45:00',3.13),('16100','2014-04-29','13:50:00',2.75),('16100','2014-04-29','13:55:00',2.73),('16100','2014-04-29','14:00:00',3.32),('16100','2014-04-29','14:05:00',3.87),('16100','2014-04-29','14:10:00',3.94),('16100','2014-04-29','14:15:00',2.45),('16100','2014-04-29','14:20:00',2.09),('16100','2014-04-29','14:25:00',2.19),('16100','2014-04-29','14:30:00',3.35),('16100','2014-04-29','14:35:00',2.88),('16100','2014-04-29','14:40:00',2.44),('16100','2014-04-29','14:45:00',2.38),('16100','2014-04-29','14:50:00',2.78),('16100','2014-04-29','14:55:00',2.44),('16100','2014-04-29','15:00:00',2.33),('16100','2014-04-29','15:05:00',2.13),('16100','2014-04-29','15:10:00',2.44),('16100','2014-04-29','15:15:00',1.79),('16100','2014-04-29','15:20:00',1.67),('16100','2014-04-29','15:25:00',3.37),('16100','2014-04-29','15:30:00',5.92),('16100','2014-04-29','15:35:00',6.17),('16100','2014-04-29','15:40:00',5.94),('16100','2014-04-29','15:45:00',6.36),('16100','2014-04-29','15:50:00',4.49),('16100','2014-04-29','15:55:00',4.86),('16100','2014-04-29','16:00:00',4.06),('16100','2014-04-29','16:05:00',5.43),('16100','2014-04-29','16:10:00',1.96),('16100','2014-04-29','16:15:00',3.23),('16100','2014-04-29','16:20:00',4.49),('16100','2014-04-29','16:25:00',5.07),('16100','2014-04-29','16:30:00',2.83),('16100','2014-04-29','16:35:00',4.18),('16100','2014-04-29','16:40:00',5.47),('16100','2014-04-29','16:45:00',2.86),('16100','2014-04-29','16:50:00',3.59),('16100','2014-04-29','16:55:00',2.71),('16100','2014-04-29','17:00:00',2.27),('16100','2014-04-29','17:05:00',2.51),('16100','2014-04-29','17:10:00',1.88),('16100','2014-04-29','17:15:00',1.37),('16100','2014-04-29','17:20:00',1.81),('16100','2014-04-29','17:30:00',1.14),('16100','2014-04-29','17:35:00',1.71),('16100','2014-04-29','17:40:00',1.28),('16100','2014-04-29','17:50:00',1.35),('16100','2014-03-06','07:35:00',1.03),('16100','2014-03-06','07:50:00',1.06),('16100','2014-03-06','07:55:00',1.15),('16100','2014-03-06','10:05:00',1.04),('16100','2014-03-06','10:15:00',1.35),('16100','2014-03-06','10:20:00',2.72),('16100','2014-03-06','10:25:00',4.8),('16100','2014-03-06','10:30:00',5.29),('16100','2014-03-06','10:35:00',1.42),('16100','2014-03-06','10:40:00',1.43),('16100','2014-03-06','10:45:00',2.43),('16100','2014-03-06','10:50:00',4.67),('16100','2014-03-06','10:55:00',2.65),('16100','2014-03-06','11:00:00',2.59),('16100','2014-03-06','11:05:00',1.41),('16100','2014-03-06','11:10:00',1.47),('16100','2014-03-06','11:15:00',2.04),('16100','2014-03-06','11:20:00',8.9),('16100','2014-03-06','11:25:00',6.58),('16100','2014-03-06','11:30:00',8.45),('16100','2014-03-06','11:35:00',5.33),('16100','2014-03-06','11:40:00',5.41),('16100','2014-03-06','11:45:00',5.65),('16100','2014-03-06','11:50:00',7.7),('16100','2014-03-06','11:55:00',8.34),('16100','2014-03-06','12:00:00',8.22),('16100','2014-03-06','12:05:00',7.96),('16100','2014-03-06','12:10:00',7.64),('16100','2014-03-06','12:15:00',7.62),('16100','2014-03-06','12:20:00',7.62),('16100','2014-03-06','12:25:00',4.53),('16100','2014-03-06','12:30:00',5.93),('16100','2014-03-06','12:35:00',5.08),('16100','2014-03-06','12:40:00',5.82),('16100','2014-03-06','12:45:00',7.75),('16100','2014-03-06','12:50:00',7.71),('16100','2014-03-06','12:55:00',7.82),('16100','2014-03-06','13:00:00',7.76),('16100','2014-03-06','13:05:00',4.27),('16100','2014-03-06','13:10:00',2.09),('16100','2014-03-06','13:15:00',3.65),('16100','2014-03-06','13:20:00',6.76),('16100','2014-03-06','13:25:00',5.57),('16100','2014-03-06','13:30:00',6.09),('16100','2014-03-06','13:35:00',4.43),('16100','2014-03-06','13:40:00',3.2),('16100','2014-03-06','13:45:00',3.03),('16100','2014-03-06','13:50:00',3.02),('16100','2014-03-06','13:55:00',2.46),('16100','2014-03-06','14:00:00',2.14),('16100','2014-03-06','14:05:00',2.02),('16100','2014-03-06','14:10:00',1.91),('16100','2014-03-06','14:15:00',1.86),('16100','2014-03-06','14:20:00',1.91),('16100','2014-03-06','14:25:00',1.95),('16100','2014-03-06','14:30:00',1.99),('16100','2014-03-06','14:35:00',2.27),('16100','2014-03-06','14:40:00',2.43),('16100','2014-03-06','14:45:00',2.96),('16100','2014-03-06','14:50:00',3.61),('16100','2014-03-06','14:55:00',4.35),('16100','2014-03-06','15:00:00',4.63),('16100','2014-03-06','15:05:00',5.22),('16100','2014-03-06','15:10:00',5.23),('16100','2014-03-06','15:15:00',5.34),('16100','2014-03-06','15:20:00',4.71),('16100','2014-03-06','15:25:00',3.71),('16100','2014-03-06','15:30:00',1.54),('16100','2014-03-06','15:35:00',2.08),('16100','2014-03-06','15:40:00',4.31),('16100','2014-03-06','15:45:00',4.13),('16100','2014-03-06','15:50:00',2.57),('16100','2014-03-06','15:55:00',3.91),('16100','2014-03-06','16:00:00',3.81),('16100','2014-03-06','16:05:00',3.5),('16100','2014-03-06','16:10:00',3.14),('16100','2014-03-06','16:15:00',3.06),('16100','2014-03-06','16:20:00',2.76),('16100','2014-03-06','16:25:00',2.66),('16100','2014-03-06','16:30:00',2.48),('16100','2014-03-06','16:35:00',2.35),('16100','2014-03-06','16:40:00',2.3),('16100','2014-03-06','16:45:00',2.14),('16100','2014-03-06','16:50:00',1.98),('16100','2014-03-06','16:55:00',1.81),('16100','2014-03-06','17:00:00',1.64),('16100','2014-03-06','17:05:00',1.47),('16100','2014-03-06','17:10:00',1.29),('16100','2014-03-06','17:15:00',1.09),('16100','2014-03-05','08:10:00',1.51),('16100','2014-03-05','08:15:00',1.59),('16100','2014-03-05','08:20:00',1.24),('16100','2014-03-05','08:30:00',1.1),('16100','2014-03-05','08:35:00',1.34),('16100','2014-03-05','08:40:00',1.1),('16100','2014-03-05','08:45:00',1.47),('16100','2014-03-05','08:50:00',1.66),('16100','2014-03-05','08:55:00',1.02),('16100','2014-03-05','09:00:00',1.11),('16100','2014-03-05','09:05:00',3.04),('16100','2014-03-05','09:10:00',2.76),('16100','2014-03-05','09:15:00',2.07),('16100','2014-03-05','09:20:00',3.08),('16100','2014-03-05','09:25:00',3.35),('16100','2014-03-05','09:30:00',3.94),('16100','2014-03-05','09:35:00',2.78),('16100','2014-03-05','09:40:00',2.59),('16100','2014-03-05','09:45:00',2.88),('16100','2014-03-05','09:50:00',3.43),('16100','2014-03-05','09:55:00',3.36),('16100','2014-03-05','10:00:00',3.55),('16100','2014-03-05','10:05:00',3.96),('16100','2014-03-05','10:10:00',4.43),('16100','2014-03-05','10:15:00',5.07),('16100','2014-03-05','10:20:00',5.29),('16100','2014-03-05','10:25:00',5.01),('16100','2014-03-05','10:30:00',6.52),('16100','2014-03-05','10:35:00',6.22),('16100','2014-03-05','10:40:00',6.94),('16100','2014-03-05','10:45:00',6.94),('16100','2014-03-05','10:50:00',7.03),('16100','2014-03-05','10:55:00',7.03),('16100','2014-03-05','11:00:00',7.13),('16100','2014-03-05','11:05:00',6.92),('16100','2014-03-05','11:10:00',5.54),('16100','2014-03-05','11:15:00',6.56),('16100','2014-03-05','11:20:00',7.36),('16100','2014-03-05','11:25:00',5.72),('16100','2014-03-05','11:30:00',8.09),('16100','2014-03-05','11:35:00',6.07),('16100','2014-03-05','11:40:00',3.11),('16100','2014-03-05','11:45:00',2.21),('16100','2014-03-05','11:50:00',2.33),('16100','2014-03-05','11:55:00',2.36),('16100','2014-03-05','12:00:00',3.18),('16100','2014-03-05','12:05:00',2.29),('16100','2014-03-05','12:10:00',3.57),('16100','2014-03-05','12:15:00',6.19),('16100','2014-03-05','12:20:00',2.45),('16100','2014-03-05','12:25:00',1.79),('16100','2014-03-05','12:30:00',1.56),('16100','2014-03-05','12:35:00',1.94),('16100','2014-03-05','12:40:00',3.43),('16100','2014-03-05','12:45:00',1.99),('16100','2014-03-05','12:50:00',3.72),('16100','2014-03-05','12:55:00',5.28),('16100','2014-03-05','13:00:00',2.9),('16100','2014-03-05','13:05:00',2.68),('16100','2014-03-05','13:10:00',2.16),('16100','2014-03-05','13:15:00',2.23),('16100','2014-03-05','13:20:00',2.09),('16100','2014-03-05','13:25:00',1.9),('16100','2014-03-05','13:30:00',1.67),('16100','2014-03-05','13:35:00',1.53),('16100','2014-03-05','13:40:00',1.46),('16100','2014-03-05','13:45:00',1.7),('16100','2014-03-05','13:50:00',1.8),('16100','2014-03-05','13:55:00',1.71),('16100','2014-03-05','14:00:00',1.78),('16100','2014-03-05','14:05:00',1.8),('16100','2014-03-05','14:10:00',2.08),('16100','2014-03-05','14:15:00',2.09),('16100','2014-03-05','14:20:00',2.05),('16100','2014-03-05','14:25:00',1.97),('16100','2014-03-05','14:30:00',1.84),('16100','2014-03-05','14:35:00',1.74),('16100','2014-03-05','14:40:00',1.45),('16100','2014-03-05','14:45:00',1.35),('16100','2014-03-05','14:50:00',1.48),('16100','2014-03-05','14:55:00',1.41),('16100','2014-03-05','15:00:00',1.58),('16100','2014-03-05','15:05:00',1.71),('16100','2014-03-05','15:10:00',3.17),('16100','2014-03-05','15:15:00',5.24),('16100','2014-03-05','15:20:00',1.6),('16100','2014-03-05','15:25:00',1.27),('16100','2014-03-05','15:30:00',1.14),('16100','2014-03-05','15:35:00',1.17),('16100','2014-03-05','15:40:00',1.21),('16100','2014-03-05','15:45:00',1.04),('16100','2014-03-05','17:05:00',1.04),('16100','2014-03-05','17:10:00',1.4),('16100','2014-03-05','17:15:00',1.21),('16100','2014-03-04','07:40:00',1.21),('16100','2014-03-04','07:45:00',1.37),('16100','2014-03-04','07:50:00',1.83),('16100','2014-03-04','07:55:00',2.07),('16100','2014-03-04','08:00:00',2.28),('16100','2014-03-04','08:05:00',2.46),('16100','2014-03-04','08:10:00',2.59),('16100','2014-03-04','08:15:00',2.76),('16100','2014-03-04','08:20:00',3.01),('16100','2014-03-04','08:25:00',1.85),('16100','2014-03-04','08:30:00',3.14),('16100','2014-03-04','08:35:00',3.43),('16100','2014-03-04','08:40:00',4.16),('16100','2014-03-04','08:45:00',4.15),('16100','2014-03-04','08:50:00',4.17),('16100','2014-03-04','08:55:00',4.22),('16100','2014-03-04','09:00:00',3.04),('16100','2014-03-04','09:05:00',4.33),('16100','2014-03-04','09:10:00',4.51),('16100','2014-03-04','09:15:00',4.59),('16100','2014-03-04','09:20:00',4.74),('16100','2014-03-04','09:25:00',4.84),('16100','2014-03-04','09:30:00',4.92),('16100','2014-03-04','09:35:00',5.04),('16100','2014-03-04','09:40:00',5.22),('16100','2014-03-04','09:45:00',5.41),('16100','2014-03-04','09:50:00',5.43),('16100','2014-03-04','09:55:00',5.55),('16100','2014-03-04','10:00:00',5.64),('16100','2014-03-04','10:05:00',5.72),('16100','2014-03-04','10:10:00',5.81),('16100','2014-03-04','10:15:00',5.91),('16100','2014-03-04','10:20:00',6),('16100','2014-03-04','10:25:00',6.13),('16100','2014-03-04','10:30:00',6.24),('16100','2014-03-04','10:35:00',6.37),('16100','2014-03-04','10:40:00',6.43),('16100','2014-03-04','10:45:00',6.48),('16100','2014-03-04','10:50:00',6.56),('16100','2014-03-04','10:55:00',5.73),('16100','2014-03-04','11:00:00',5.17),('16100','2014-03-04','11:05:00',6.65),('16100','2014-03-04','11:10:00',7.01),('16100','2014-03-04','11:15:00',7.08),('16100','2014-03-04','11:20:00',7.27),('16100','2014-03-04','11:25:00',7.41),('16100','2014-03-04','11:30:00',3.96),('16100','2014-03-04','11:35:00',2.95),('16100','2014-03-04','11:40:00',3.11),('16100','2014-03-04','11:45:00',5.41),('16100','2014-03-04','11:50:00',3.64),('16100','2014-03-04','11:55:00',7.11),('16100','2014-03-04','12:00:00',4.61),('16100','2014-03-04','12:05:00',4.6),('16100','2014-03-04','12:10:00',2.23),('16100','2014-03-04','12:15:00',2.55),('16100','2014-03-04','12:20:00',7.62),('16100','2014-03-04','12:25:00',6.91),('16100','2014-03-04','12:30:00',7.37),('16100','2014-03-04','12:35:00',4.86),('16100','2014-03-04','12:40:00',2.87),('16100','2014-03-04','12:45:00',2.44),('16100','2014-03-04','12:50:00',1.92),('16100','2014-03-04','12:55:00',1.95),('16100','2014-03-04','13:00:00',5.8),('16100','2014-03-04','13:05:00',5.83),('16100','2014-03-04','13:10:00',6.17),('16100','2014-03-04','13:15:00',4.87),('16100','2014-03-04','13:20:00',4.55),('16100','2014-03-04','13:25:00',7.64),('16100','2014-03-04','13:30:00',7.73),('16100','2014-03-04','13:35:00',6.23),('16100','2014-03-04','13:40:00',4.76),('16100','2014-03-04','13:45:00',3.19),('16100','2014-03-04','13:50:00',2.23),('16100','2014-03-04','13:55:00',2.48),('16100','2014-03-04','14:00:00',2.26),('16100','2014-03-04','14:05:00',3.57),('16100','2014-03-04','14:10:00',2.8),('16100','2014-03-04','14:15:00',2.51),('16100','2014-03-04','14:20:00',2.61),('16100','2014-03-04','14:25:00',2.85),('16100','2014-03-04','14:30:00',2.98),('16100','2014-03-04','14:35:00',4.57),('16100','2014-03-04','14:40:00',2.67),('16100','2014-03-04','14:45:00',5.85),('16100','2014-03-04','14:50:00',3.62),('16100','2014-03-04','14:55:00',4.32),('16100','2014-03-04','15:00:00',2.17),('16100','2014-03-04','15:05:00',1.32),('16100','2014-03-04','15:10:00',1.02),('16100','2014-03-04','15:15:00',1.01),('16100','2014-03-04','15:20:00',1.13),('16100','2014-03-04','15:25:00',1.38),('16100','2014-03-04','15:30:00',1.79),('16100','2014-03-04','15:35:00',1.78),('16100','2014-03-04','15:40:00',2.74),('16100','2014-03-04','15:45:00',2.64),('16100','2014-03-04','15:50:00',5.27),('16100','2014-03-04','15:55:00',3.48),('16100','2014-03-04','16:00:00',4.22),('16100','2014-03-04','16:05:00',2.24),('16100','2014-03-04','16:10:00',1.89),('16100','2014-03-03','09:00:00',1.11),('16100','2014-03-03','09:05:00',2.14),('16100','2014-03-03','09:10:00',3.3),('16100','2014-03-03','09:15:00',3.53),('16100','2014-03-03','09:20:00',1.77),('16100','2014-03-03','09:25:00',1.02),('16100','2014-03-03','09:30:00',1.34),('16100','2014-03-03','09:35:00',1.17),('16100','2014-03-03','09:50:00',1.43),('16100','2014-03-03','09:55:00',2.47),('16100','2014-03-03','10:00:00',3.26),('16100','2014-03-03','10:05:00',3.04),('16100','2014-03-03','10:10:00',1.53),('16100','2014-03-03','10:15:00',1.13),('16100','2014-03-03','10:20:00',1.6),('16100','2014-03-03','10:30:00',2.85),('16100','2014-03-03','10:35:00',3.52),('16100','2014-03-03','10:40:00',2.36),('16100','2014-03-03','10:45:00',2.95),('16100','2014-03-03','10:50:00',7.14),('16100','2014-03-03','10:55:00',7.57),('16100','2014-03-03','11:00:00',4.48),('16100','2014-03-03','11:05:00',4.06),('16100','2014-03-03','11:10:00',2.41),('16100','2014-03-03','11:25:00',2.2),('16100','2014-03-03','11:30:00',2.72),('16100','2014-03-03','11:35:00',2.15),('16100','2014-03-03','11:40:00',1.81),('16100','2014-03-03','11:45:00',1.78),('16100','2014-03-03','11:50:00',4.87),('16100','2014-03-03','11:55:00',7.49),('16100','2014-03-03','12:00:00',6.49),('16100','2014-03-03','12:05:00',5.22),('16100','2014-03-03','12:10:00',7.7),('16100','2014-03-03','12:15:00',7.57),('16100','2014-03-03','12:20:00',6.12),('16100','2014-03-03','12:25:00',7.55),('16100','2014-03-03','12:30:00',7.44),('16100','2014-03-03','12:35:00',7.43),('16100','2014-03-03','12:40:00',7.41),('16100','2014-03-03','12:45:00',7.44),('16100','2014-03-03','12:50:00',7.49),('16100','2014-03-03','12:55:00',7.41),('16100','2014-03-03','13:00:00',7.12),('16100','2014-03-03','13:05:00',5.71),('16100','2014-03-03','13:10:00',7.69),('16100','2014-03-03','13:15:00',6.76),('16100','2014-03-03','13:20:00',4.31),('16100','2014-03-03','13:25:00',2.82),('16100','2014-03-03','13:30:00',1.15),('16100','2014-03-03','13:40:00',1.51),('16100','2014-03-03','13:45:00',1.56),('16100','2014-03-03','13:50:00',3.1),('16100','2014-03-03','13:55:00',2.87),('16100','2014-03-03','14:00:00',3.26),('16100','2014-03-03','14:05:00',6.56),('16100','2014-03-03','14:10:00',6.62),('16100','2014-03-03','14:15:00',6.93),('16100','2014-03-03','14:20:00',6.86),('16100','2014-03-03','14:25:00',6.72),('16100','2014-03-03','14:30:00',6.31),('16100','2014-03-03','14:35:00',6.18),('16100','2014-03-03','14:40:00',6.02),('16100','2014-03-03','14:45:00',5.68),('16100','2014-03-03','14:50:00',5.81),('16100','2014-03-03','14:55:00',5.25),('16100','2014-03-03','15:00:00',5.56),('16100','2014-03-03','15:05:00',5.39),('16100','2014-03-03','15:10:00',5.23),('16100','2014-03-03','15:15:00',5.08),('16100','2014-03-03','15:20:00',4.69),('16100','2014-03-03','15:25:00',3.44),('16100','2014-03-03','15:30:00',5.18),('16100','2014-03-03','15:35:00',3.58),('16100','2014-03-03','15:40:00',3.42),('16100','2014-03-03','15:45:00',2.32),('16100','2014-03-03','15:50:00',1.59),('16100','2014-03-03','15:55:00',1.34),('16100','2014-03-03','16:00:00',1.58),('16100','2014-03-03','16:05:00',1.49),('16100','2014-03-03','16:10:00',1.02),('16100','2014-03-03','16:15:00',1.03),('16100','2014-03-03','16:20:00',1.23),('16100','2014-03-03','16:25:00',2.91),('16100','2014-03-03','16:30:00',2.55),('16100','2014-03-03','16:35:00',2.02),('16100','2014-03-03','16:40:00',2.08),('16100','2014-03-03','16:45:00',2.06),('16100','2014-03-03','16:50:00',1.84),('16100','2014-03-03','16:55:00',1.59),('16100','2014-03-03','17:00:00',1.24),('16100','2014-03-02','07:40:00',1.02),('16100','2014-03-02','07:45:00',1.15),('16100','2014-03-02','07:50:00',1.1),('16100','2014-03-02','07:55:00',1.42),('16100','2014-03-02','08:00:00',1.38),('16100','2014-03-02','08:05:00',2.03),('16100','2014-03-02','08:10:00',2.24),('16100','2014-03-02','08:15:00',2.47),('16100','2014-03-02','08:20:00',2.64),('16100','2014-03-02','08:25:00',2.79),('16100','2014-03-02','08:30:00',2.99),('16100','2014-03-02','08:35:00',3.14),('16100','2014-03-02','08:40:00',3.32),('16100','2014-03-02','08:45:00',3.43),('16100','2014-03-02','08:50:00',3.63),('16100','2014-03-02','08:55:00',3.4),('16100','2014-03-02','09:00:00',3.09),('16100','2014-03-02','09:05:00',3.01),('16100','2014-03-02','09:10:00',4.2),('16100','2014-03-02','09:15:00',4.32),('16100','2014-03-02','09:20:00',4.58),('16100','2014-03-02','09:25:00',4.59),('16100','2014-03-02','09:30:00',4.56),('16100','2014-03-02','09:35:00',4.22),('16100','2014-03-02','09:40:00',4.59),('16100','2014-03-02','09:45:00',4.81),('16100','2014-03-02','09:50:00',5.03),('16100','2014-03-02','09:55:00',5.21),('16100','2014-03-02','10:00:00',5.59),('16100','2014-03-02','10:05:00',5.72),('16100','2014-03-02','10:10:00',5.83),('16100','2014-03-02','10:15:00',5.91),('16100','2014-03-02','10:20:00',6),('16100','2014-03-02','10:25:00',6.05),('16100','2014-03-02','10:30:00',6.11),('16100','2014-03-02','10:35:00',6.26),('16100','2014-03-02','10:40:00',6.33),('16100','2014-03-02','10:45:00',6.38),('16100','2014-03-02','10:50:00',6.46),('16100','2014-03-02','10:55:00',6.52),('16100','2014-03-02','11:00:00',6.56),('16100','2014-03-02','11:05:00',6.56),('16100','2014-03-02','11:10:00',6.64),('16100','2014-03-02','11:15:00',6.69),('16100','2014-03-02','11:20:00',6.71),('16100','2014-03-02','11:25:00',6.85),('16100','2014-03-02','11:30:00',6.97),('16100','2014-03-02','11:35:00',7.05),('16100','2014-03-02','11:40:00',7.16),('16100','2014-03-02','11:45:00',7.23),('16100','2014-03-02','11:50:00',7.25),('16100','2014-03-02','11:55:00',7.32),('16100','2014-03-02','12:00:00',7.33),('16100','2014-03-02','12:05:00',7.34),('16100','2014-03-02','12:10:00',7.35),('16100','2014-03-02','12:15:00',7.33),('16100','2014-03-02','12:20:00',7.35),('16100','2014-03-02','12:25:00',7.35),('16100','2014-03-02','12:30:00',7.35),('16100','2014-03-02','12:35:00',7.38),('16100','2014-03-02','12:40:00',7.39),('16100','2014-03-02','12:45:00',7.31),('16100','2014-03-02','12:50:00',7.28),('16100','2014-03-02','12:55:00',7.27),('16100','2014-03-02','13:00:00',7.25),('16100','2014-03-02','13:05:00',7.23),('16100','2014-03-02','13:10:00',7.17),('16100','2014-03-02','13:15:00',7.14),('16100','2014-03-02','13:20:00',7.13),('16100','2014-03-02','13:25:00',7.04),('16100','2014-03-02','13:30:00',6.99),('16100','2014-03-02','13:35:00',6.97),('16100','2014-03-02','13:40:00',6.88),('16100','2014-03-02','13:45:00',6.95),('16100','2014-03-02','13:50:00',6.92),('16100','2014-03-02','13:55:00',6.75),('16100','2014-03-02','14:00:00',6.66),('16100','2014-03-02','14:05:00',6.58),('16100','2014-03-02','14:10:00',6.49),('16100','2014-03-02','14:15:00',6.46),('16100','2014-03-02','14:20:00',5.36),('16100','2014-03-02','14:25:00',4.77),('16100','2014-03-02','14:30:00',6.3),('16100','2014-03-02','14:35:00',6.1),('16100','2014-03-02','14:40:00',5.59),('16100','2014-03-02','14:45:00',5.79),('16100','2014-03-02','14:50:00',5.66),('16100','2014-03-02','14:55:00',5.49),('16100','2014-03-02','15:00:00',5.42),('16100','2014-03-02','15:05:00',5.32),('16100','2014-03-02','15:10:00',5.19),('16100','2014-03-02','15:15:00',5.1),('16100','2014-03-02','15:20:00',4.97),('16100','2014-03-02','15:25:00',3.74),('16100','2014-03-02','15:30:00',4.82),('16100','2014-03-02','15:35:00',4.63),('16100','2014-03-02','15:40:00',4.43),('16100','2014-03-02','15:45:00',4.09),('16100','2014-03-02','15:50:00',3.39),('16100','2014-03-02','15:55:00',3.83),('16100','2014-03-02','16:00:00',3.13),('16100','2014-03-02','16:05:00',3.39),('16100','2014-03-02','16:10:00',3.27),('16100','2014-03-02','16:15:00',3.06),('16100','2014-03-02','16:20:00',2.88),('16100','2014-03-02','16:25:00',2.7),('16100','2014-03-02','16:30:00',2.5),('16100','2014-03-02','16:35:00',2.32),('16100','2014-03-02','16:40:00',2.15),('16100','2014-03-02','16:45:00',1.97),('16100','2014-03-02','16:50:00',1.74),('16100','2014-03-02','16:55:00',1.46),('16100','2014-03-02','17:00:00',1.45),('16100','2014-03-02','17:05:00',1.22),('16100','2014-03-01','07:55:00',1.24),('16100','2014-03-01','08:00:00',1.13),('16100','2014-03-01','08:20:00',3.06),('16100','2014-03-01','08:25:00',2.25),('16100','2014-03-01','08:30:00',3.23),('16100','2014-03-01','08:35:00',3.26),('16100','2014-03-01','08:40:00',3.38),('16100','2014-03-01','08:45:00',3.58),('16100','2014-03-01','08:50:00',3.82),('16100','2014-03-01','08:55:00',3.96),('16100','2014-03-01','09:00:00',4.17),('16100','2014-03-01','09:05:00',4.39),('16100','2014-03-01','09:10:00',4.61),('16100','2014-03-01','09:15:00',4.74),('16100','2014-03-01','09:20:00',5.01),('16100','2014-03-01','09:25:00',5.12),('16100','2014-03-01','09:30:00',5.75),('16100','2014-03-01','09:35:00',5.79),('16100','2014-03-01','09:40:00',5.5),('16100','2014-03-01','09:45:00',2.12),('16100','2014-03-01','10:10:00',1.32),('16100','2014-03-01','10:15:00',2.64),('16100','2014-03-01','10:20:00',2.77),('16100','2014-03-01','10:25:00',3.61),('16100','2014-03-01','10:30:00',6),('16100','2014-03-01','10:35:00',7.89),('16100','2014-03-01','10:40:00',7.95),('16100','2014-03-01','10:45:00',7.73),('16100','2014-03-01','10:50:00',6.32),('16100','2014-03-01','10:55:00',2.34),('16100','2014-03-01','11:00:00',2.22),('16100','2014-03-01','11:05:00',2.54),('16100','2014-03-01','11:10:00',6.77),('16100','2014-03-01','11:15:00',6.46),('16100','2014-03-01','11:20:00',3.27),('16100','2014-03-01','11:25:00',2.83),('16100','2014-03-01','11:30:00',2.79),('16100','2014-03-01','11:35:00',3.18),('16100','2014-03-01','11:40:00',3.38),('16100','2014-03-01','11:45:00',5.14),('16100','2014-03-01','11:50:00',7.04),('16100','2014-03-01','11:55:00',2.86),('16100','2014-03-01','12:00:00',7.11),('16100','2014-03-01','12:05:00',8.2),('16100','2014-03-01','12:10:00',6.37),('16100','2014-03-01','12:15:00',3.82),('16100','2014-03-01','12:20:00',2.94),('16100','2014-03-01','12:25:00',2.23),('16100','2014-03-01','12:30:00',1.35),('16100','2014-03-01','12:35:00',1.02),('16100','2014-03-01','13:15:00',1.24),('16100','2014-03-01','13:20:00',1.19),('16100','2014-03-01','13:25:00',1.44),('16100','2014-03-01','13:30:00',1.56),('16100','2014-03-01','13:35:00',1.24),('16100','2014-03-01','13:40:00',1.42),('16100','2014-03-01','13:45:00',1.58),('16100','2014-03-01','13:50:00',1.51),('16100','2014-03-01','13:55:00',1.46),('16100','2014-03-01','14:00:00',1.49),('16100','2014-03-01','14:05:00',1.5),('16100','2014-03-01','14:10:00',1.49),('16100','2014-03-01','14:15:00',1.51),('16100','2014-03-01','14:20:00',1.51),('16100','2014-03-01','14:25:00',1.49),('16100','2014-03-01','14:30:00',1.47),('16100','2014-03-01','14:35:00',1.44),('16100','2014-03-01','14:40:00',1.47),('16100','2014-03-01','14:45:00',1.57),('16100','2014-03-01','14:50:00',1.59),('16100','2014-03-01','14:55:00',1.76),('16100','2014-03-01','15:00:00',1.97),('16100','2014-03-01','15:05:00',2.04),('16100','2014-03-01','15:10:00',2.1),('16100','2014-03-01','15:15:00',2.1),('16100','2014-03-01','15:20:00',2.07),('16100','2014-03-01','15:25:00',2.13),('16100','2014-03-01','15:30:00',2.37),('16100','2014-03-01','15:35:00',2.4),('16100','2014-03-01','15:40:00',2.59),('16100','2014-03-01','15:45:00',2.63),('16100','2014-03-01','15:50:00',2.68),('16100','2014-03-01','15:55:00',2.54),('16100','2014-03-01','16:00:00',2.18),('16100','2014-03-01','16:05:00',1.86),('16100','2014-03-01','16:10:00',1.72),('16100','2014-03-01','16:15:00',1.53),('16100','2014-03-01','16:20:00',1.37),('16100','2014-03-01','16:25:00',1.04),('16100','2014-02-28','16:15:00',1.09),('16100','2014-02-27','07:45:00',1.14),('16100','2014-02-27','07:50:00',1.51),('16100','2014-02-27','07:55:00',1.99),('16100','2014-02-27','08:00:00',2.06),('16100','2014-02-27','08:10:00',1.05),('16100','2014-02-27','08:15:00',1.86),('16100','2014-02-27','08:20:00',2.15),('16100','2014-02-27','08:25:00',1.14),('16100','2014-02-27','08:30:00',1.75),('16100','2014-02-27','09:05:00',1.52),('16100','2014-02-27','09:10:00',1.51),('16100','2014-02-27','09:15:00',1.41),('16100','2014-02-27','09:20:00',3.51),('16100','2014-02-27','09:25:00',2.88),('16100','2014-02-27','09:30:00',4.54),('16100','2014-02-27','09:35:00',5.41),('16100','2014-02-27','09:40:00',5.48),('16100','2014-02-27','09:45:00',4.65),('16100','2014-02-27','09:50:00',4.53),('16100','2014-02-27','09:55:00',3.34),('16100','2014-02-27','10:00:00',2.08),('16100','2014-02-27','10:05:00',1.79),('16100','2014-02-27','10:10:00',1.99),('16100','2014-02-27','10:15:00',4.56),('16100','2014-02-27','10:20:00',6.46),('16100','2014-02-27','10:25:00',6.28),('16100','2014-02-27','10:30:00',4.9),('16100','2014-02-27','10:35:00',2.04),('16100','2014-02-27','10:40:00',1.98),('16100','2014-02-27','10:45:00',1.52),('16100','2014-02-27','10:50:00',1.47),('16100','2014-02-27','10:55:00',1.36),('16100','2014-02-27','11:00:00',1.46),('16100','2014-02-27','11:05:00',1.93),('16100','2014-02-27','11:10:00',2),('16100','2014-02-27','11:15:00',2.17),('16100','2014-02-27','11:20:00',2.45),('16100','2014-02-27','11:25:00',2.15),('16100','2014-02-27','11:30:00',2.01),('16100','2014-02-27','11:35:00',1.39),('16100','2014-02-27','11:50:00',1.39),('16100','2014-02-27','11:55:00',2.43),('16100','2014-02-27','12:00:00',2.22),('16100','2014-02-27','12:05:00',1.9),('16100','2014-02-27','12:20:00',1.44),('16100','2014-02-27','12:25:00',5.45),('16100','2014-02-27','12:30:00',7.9),('16100','2014-02-27','12:35:00',8.32),('16100','2014-02-27','12:40:00',4.34),('16100','2014-02-27','12:45:00',3.49),('16100','2014-02-27','12:50:00',4.03),('16100','2014-02-27','12:55:00',6.78),('16100','2014-02-27','13:00:00',4.04),('16100','2014-02-27','13:05:00',1.87),('16100','2014-02-27','13:10:00',1.58),('16100','2014-02-27','13:15:00',1.67),('16100','2014-02-27','13:20:00',1.36),('16100','2014-02-27','13:40:00',1.21),('16100','2014-02-27','13:45:00',1.47),('16100','2014-02-27','13:50:00',1.65),('16100','2014-02-27','13:55:00',1.76),('16100','2014-02-27','14:00:00',1.17),('16100','2014-02-27','14:05:00',1.44),('16100','2014-02-27','14:10:00',1.32),('16100','2014-02-27','14:15:00',2.01),('16100','2014-02-27','14:20:00',7.99),('16100','2014-02-27','14:25:00',2.59),('16100','2014-02-27','14:30:00',1.92),('16100','2014-02-27','14:35:00',1.37),('16100','2014-02-27','15:20:00',1.01),('16100','2014-02-27','15:25:00',1.83),('16100','2014-02-27','15:30:00',2.08),('16100','2014-02-27','15:35:00',5.56),('16100','2014-02-27','15:40:00',1.66),('16100','2014-02-27','16:30:00',1.28),('16100','2014-02-27','16:35:00',2.37),('16100','2014-02-27','16:40:00',1.94),('16100','2014-02-27','16:45:00',1.09),('16100','2014-02-26','10:20:00',1.02),('16100','2014-02-26','10:25:00',1.28),('16100','2014-02-26','10:30:00',1.55),('16100','2014-02-26','10:35:00',1.85),('16100','2014-02-26','10:40:00',2.19),('16100','2014-02-26','10:45:00',2.25),('16100','2014-02-26','10:50:00',2.08),('16100','2014-02-26','10:55:00',2.2),('16100','2014-02-26','11:00:00',2.57),('16100','2014-02-26','11:05:00',2.38),('16100','2014-02-26','11:10:00',2.36),('16100','2014-02-26','11:15:00',2.19),('16100','2014-02-26','11:20:00',2.18),('16100','2014-02-26','11:25:00',2.55),('16100','2014-02-26','11:30:00',2.63),('16100','2014-02-26','11:35:00',2.07),('16100','2014-02-26','11:40:00',1.87),('16100','2014-02-26','11:45:00',1.77),('16100','2014-02-26','11:50:00',1.82),('16100','2014-02-26','11:55:00',2.04),('16100','2014-02-26','12:00:00',1.97),('16100','2014-02-26','12:05:00',2.08),('16100','2014-02-26','12:10:00',2.14),('16100','2014-02-26','12:15:00',2.17),('16100','2014-02-26','12:20:00',2.14),('16100','2014-02-26','12:25:00',2.11),('16100','2014-02-26','12:30:00',2.07),('16100','2014-02-26','12:35:00',1.97),('16100','2014-02-26','12:40:00',1.96),('16100','2014-02-26','12:45:00',2),('16100','2014-02-26','12:50:00',1.89),('16100','2014-02-26','12:55:00',1.88),('16100','2014-02-26','13:00:00',1.86),('16100','2014-02-26','13:05:00',1.9),('16100','2014-02-26','13:10:00',1.95),('16100','2014-02-26','13:15:00',2.08),('16100','2014-02-26','13:20:00',2.22),('16100','2014-02-26','13:25:00',2.45),('16100','2014-02-26','13:30:00',2.67),('16100','2014-02-26','13:35:00',2.88),('16100','2014-02-26','13:40:00',3),('16100','2014-02-26','13:45:00',2.91),('16100','2014-02-26','13:50:00',3.27),('16100','2014-02-26','13:55:00',3.72),('16100','2014-02-26','14:00:00',3.03),('16100','2014-02-26','14:05:00',2.55),('16100','2014-02-26','14:10:00',2.2),('16100','2014-02-26','14:15:00',2.47),('16100','2014-02-26','14:20:00',2.27),('16100','2014-02-26','14:25:00',1.95),('16100','2014-02-26','14:30:00',1.59),('16100','2014-02-26','14:35:00',1.67),('16100','2014-02-26','14:40:00',1.79),('16100','2014-02-26','14:45:00',2.22),('16100','2014-02-26','14:50:00',2.35),('16100','2014-02-26','14:55:00',2.62),('16100','2014-02-26','15:00:00',2.66),('16100','2014-02-26','15:05:00',2.8),('16100','2014-02-26','15:10:00',3.54),('16100','2014-02-26','15:15:00',3.08),('16100','2014-02-26','15:20:00',3.03),('16100','2014-02-26','15:25:00',2.9),('16100','2014-02-26','15:30:00',2.08),('16100','2014-02-26','15:35:00',1.89),('16100','2014-02-26','15:40:00',1.26),('16100','2014-02-26','15:45:00',1.01),('16100','2014-02-26','15:55:00',1.11),('16100','2014-02-26','16:00:00',1.03),('16100','2014-02-26','16:40:00',1.26),('16100','2014-02-26','16:45:00',2.03),('16100','2014-02-26','16:50:00',1.75),('16100','2014-02-26','16:55:00',1.65),('16100','2014-02-26','17:00:00',1.24),('16100','2014-02-25','07:50:00',1.01),('16100','2014-02-25','07:55:00',1.29),('16100','2014-02-25','08:00:00',1.52),('16100','2014-02-25','08:05:00',1.75),('16100','2014-02-25','08:10:00',1.95),('16100','2014-02-25','08:15:00',2.15),('16100','2014-02-25','08:20:00',2.26),('16100','2014-02-25','08:25:00',2.57),('16100','2014-02-25','08:30:00',2.74),('16100','2014-02-25','08:35:00',2.97),('16100','2014-02-25','08:40:00',3.22),('16100','2014-02-25','08:45:00',2.29),('16100','2014-02-25','08:50:00',3.56),('16100','2014-02-25','08:55:00',3.53),('16100','2014-02-25','09:00:00',3.66),('16100','2014-02-25','09:05:00',3.78),('16100','2014-02-25','09:10:00',3.7),('16100','2014-02-25','09:15:00',3.97),('16100','2014-02-25','09:20:00',3.53),('16100','2014-02-25','09:25:00',3.54),('16100','2014-02-25','09:30:00',3.49),('16100','2014-02-25','09:35:00',3.95),('16100','2014-02-25','09:40:00',4.11),('16100','2014-02-25','09:45:00',3.72),('16100','2014-02-25','09:50:00',2.49),('16100','2014-02-25','09:55:00',2.66),('16100','2014-02-25','10:00:00',5.05),('16100','2014-02-25','10:05:00',2.27),('16100','2014-02-25','10:10:00',1.59),('16100','2014-02-25','10:15:00',1.62),('16100','2014-02-25','10:20:00',1.2),('16100','2014-02-25','10:30:00',1.14),('16100','2014-02-25','10:35:00',1.24),('16100','2014-02-25','10:55:00',1.31),('16100','2014-02-25','11:00:00',1.35),('16100','2014-02-25','11:05:00',1.37),('16100','2014-02-25','11:10:00',1.33),('16100','2014-02-25','11:15:00',1.18),('16100','2014-02-25','11:50:00',1.05),('16100','2014-02-25','11:55:00',1.06),('16100','2014-02-25','12:00:00',1.2),('16100','2014-02-25','12:05:00',1.07),('16100','2014-02-25','12:10:00',1.07),('16100','2014-02-25','12:15:00',1.5),('16100','2014-02-25','12:20:00',1.61),('16100','2014-02-25','12:25:00',2.39),('16100','2014-02-25','12:30:00',2.35),('16100','2014-02-25','12:35:00',2.21),('16100','2014-02-25','12:40:00',5.37),('16100','2014-02-25','12:45:00',7.02),('16100','2014-02-25','12:50:00',7.11),('16100','2014-02-25','12:55:00',6.79),('16100','2014-02-25','13:00:00',6.41),('16100','2014-02-25','13:05:00',5.51),('16100','2014-02-25','13:10:00',5.11),('16100','2014-02-25','13:15:00',3.03),('16100','2014-02-25','13:20:00',3.39),('16100','2014-02-25','13:25:00',2.15),('16100','2014-02-25','13:30:00',3.84),('16100','2014-02-25','13:35:00',5.72),('16100','2014-02-25','13:40:00',5.38),('16100','2014-02-25','13:45:00',7.29),('16100','2014-02-25','13:50:00',7.08),('16100','2014-02-25','13:55:00',7.24),('16100','2014-02-25','14:00:00',5.97),('16100','2014-02-25','14:05:00',3.31),('16100','2014-02-25','14:10:00',1.5),('16100','2014-02-25','14:15:00',1.61),('16100','2014-02-25','14:20:00',4.95),('16100','2014-02-25','14:25:00',3.58),('16100','2014-02-25','14:30:00',5.68),('16100','2014-02-25','14:35:00',5.9),('16100','2014-02-25','14:40:00',4.76),('16100','2014-02-25','14:45:00',3.1),('16100','2014-02-25','14:50:00',4.89),('16100','2014-02-25','14:55:00',1.42),('16100','2014-02-25','15:00:00',3.57),('16100','2014-02-25','15:05:00',5.92),('16100','2014-02-25','15:10:00',5.04),('16100','2014-02-25','15:15:00',3.92),('16100','2014-02-25','15:20:00',2.78),('16100','2014-02-25','15:25:00',2.43),('16100','2014-02-25','15:30:00',3.58),('16100','2014-02-25','15:35:00',2.82),('16100','2014-02-25','15:40:00',2.89),('16100','2014-02-25','15:45:00',3.2),('16100','2014-02-25','15:50:00',3.62),('16100','2014-02-25','15:55:00',3.3),('16100','2014-02-25','16:00:00',3.17),('16100','2014-02-25','16:05:00',2.52),('16100','2014-02-25','16:10:00',2.31),('16100','2014-02-25','16:15:00',2.22),('16100','2014-02-25','16:20:00',1.67),('16100','2014-02-25','16:25:00',1.01),('16100','2014-04-28','09:40:00',1.25),('16100','2014-04-28','09:45:00',1.51),('16100','2014-04-28','09:50:00',1.72),('16100','2014-04-28','09:55:00',3.01),('16100','2014-04-28','10:00:00',5.7),('16100','2014-04-28','10:05:00',6.04),('16100','2014-04-28','10:10:00',6.76),('16100','2014-04-28','10:15:00',5.43),('16100','2014-04-28','10:20:00',6.67),('16100','2014-04-28','10:25:00',6.69),('16100','2014-04-28','10:30:00',6.69),('16100','2014-04-28','10:35:00',6.66),('16100','2014-04-28','10:40:00',6.72),('16100','2014-04-28','10:45:00',6.22),('16100','2014-04-28','10:50:00',6.62),('16100','2014-04-28','10:55:00',6.92),('16100','2014-04-28','11:00:00',6.86),('16100','2014-04-28','11:05:00',7.07),('16100','2014-04-28','11:10:00',7.14),('16100','2014-04-28','11:15:00',7.53),('16100','2014-04-28','11:20:00',5.37),('16100','2014-04-28','11:25:00',7.45),('16100','2014-04-28','11:30:00',7.7),('16100','2014-04-28','11:35:00',4.7),('16100','2014-04-28','11:40:00',2.72),('16100','2014-04-28','11:45:00',2.66),('16100','2014-04-28','11:50:00',3.43),('16100','2014-04-28','11:55:00',2.12),('16100','2014-04-28','12:00:00',1.29),('16100','2014-04-28','12:05:00',1.17),('16100','2014-04-28','12:10:00',3.86),('16100','2014-04-28','12:15:00',6.89),('16100','2014-04-28','12:20:00',7.99),('16100','2014-04-28','12:25:00',2.07),('16100','2014-04-28','12:30:00',2.22),('16100','2014-04-28','12:35:00',4.21),('16100','2014-04-28','12:40:00',4.94),('16100','2014-04-28','12:45:00',4.27),('16100','2014-04-28','12:50:00',6.67),('16100','2014-04-28','12:55:00',8.94),('16100','2014-04-28','13:00:00',4.66),('16100','2014-04-28','13:05:00',4.07),('16100','2014-04-28','13:10:00',3.11),('16100','2014-04-28','13:15:00',4.85),('16100','2014-04-28','13:20:00',2.2),('16100','2014-04-28','13:25:00',2.69),('16100','2014-04-28','13:30:00',6.59),('16100','2014-04-28','13:35:00',6.19),('16100','2014-04-28','13:40:00',5.52),('16100','2014-04-28','13:45:00',5.18),('16100','2014-04-28','13:50:00',2.06),('16100','2014-04-28','13:55:00',1.86),('16100','2014-04-28','14:00:00',1.81),('16100','2014-04-28','14:05:00',1.59),('16100','2014-04-28','14:10:00',1.42),('16100','2014-04-28','14:15:00',1.29),('16100','2014-04-28','14:40:00',1.16),('16100','2014-04-28','14:45:00',1.55),('16100','2014-04-28','14:50:00',1.54),('16100','2014-04-28','14:55:00',2.1),('16100','2014-04-28','15:00:00',3.07),('16100','2014-04-28','15:05:00',2.44),('16100','2014-04-28','15:10:00',1.97),('16100','2014-04-28','15:15:00',1.29),('16100','2014-04-28','15:55:00',1.33),('16100','2014-04-28','16:00:00',1.8),('16100','2014-04-28','16:05:00',1.26),('16100','2014-04-28','16:50:00',1.14),('16100','2014-04-28','16:55:00',1.33),('16100','2014-04-28','17:00:00',1.36),('16100','2014-04-28','17:05:00',1.52),('16100','2014-04-28','17:10:00',1.57),('16100','2014-04-28','17:15:00',3.56),('16100','2014-04-28','17:20:00',2.54),('16100','2014-04-28','17:25:00',1.73),('16100','2014-04-28','17:30:00',1.89),('16100','2014-04-28','17:35:00',1.34),('16100','2014-02-24','07:50:00',1.1),('16100','2014-02-24','07:55:00',1.28),('16100','2014-02-24','08:00:00',1.46),('16100','2014-02-24','08:05:00',1.63),('16100','2014-02-24','08:10:00',1.84),('16100','2014-02-24','08:15:00',2.04),('16100','2014-02-24','08:20:00',2.19),('16100','2014-02-24','08:25:00',2.41),('16100','2014-02-24','08:30:00',2.59),('16100','2014-02-24','08:35:00',2.75),('16100','2014-02-24','08:40:00',2.91),('16100','2014-02-24','08:45:00',3.09),('16100','2014-02-24','08:50:00',3.26),('16100','2014-02-24','08:55:00',3.44),('16100','2014-02-24','09:00:00',3.6),('16100','2014-02-24','09:05:00',3.76),('16100','2014-02-24','09:10:00',3.87),('16100','2014-02-24','09:15:00',4.04),('16100','2014-02-24','09:20:00',4.23),('16100','2014-02-24','09:25:00',4.35),('16100','2014-02-24','09:30:00',4.47),('16100','2014-02-24','09:35:00',4.61),('16100','2014-02-24','09:40:00',4.74),('16100','2014-02-24','09:45:00',4.82),('16100','2014-02-24','09:50:00',4.98),('16100','2014-02-24','09:55:00',5.08),('16100','2014-02-24','10:00:00',5.24),('16100','2014-02-24','10:05:00',5.37),('16100','2014-02-24','10:10:00',5.46),('16100','2014-02-24','10:15:00',5.53),('16100','2014-02-24','10:20:00',5.63),('16100','2014-02-24','10:25:00',5.71),('16100','2014-02-24','10:30:00',5.83),('16100','2014-02-24','10:35:00',5.91),('16100','2014-02-24','10:40:00',5.99),('16100','2014-02-24','10:45:00',6.04),('16100','2014-02-24','10:50:00',6.11),('16100','2014-02-24','10:55:00',6.19),('16100','2014-02-24','11:00:00',6.27),('16100','2014-02-24','11:05:00',6.31),('16100','2014-02-24','11:10:00',6.37),('16100','2014-02-24','11:15:00',6.43),('16100','2014-02-24','11:20:00',6.52),('16100','2014-02-24','11:25:00',6.59),('16100','2014-02-24','11:30:00',6.63),('16100','2014-02-24','11:35:00',6.69),('16100','2014-02-24','11:40:00',6.67),('16100','2014-02-24','11:45:00',6.68),('16100','2014-02-24','11:50:00',6.75),('16100','2014-02-24','11:55:00',6.75),('16100','2014-02-24','12:00:00',6.7),('16100','2014-02-24','12:05:00',6.72),('16100','2014-02-24','12:10:00',6.74),('16100','2014-02-24','12:15:00',6.71),('16100','2014-02-24','12:20:00',6.84),('16100','2014-02-24','12:25:00',6.89),('16100','2014-02-24','12:30:00',6.93),('16100','2014-02-24','12:35:00',6.93),('16100','2014-02-24','12:40:00',6.88),('16100','2014-02-24','12:45:00',6.9),('16100','2014-02-24','12:50:00',6.8),('16100','2014-02-24','12:55:00',6.79),('16100','2014-02-24','13:00:00',6.65),('16100','2014-02-24','13:05:00',6.64),('16100','2014-02-24','13:10:00',6.75),('16100','2014-02-24','13:15:00',6.72),('16100','2014-02-24','13:20:00',6.63),('16100','2014-02-24','13:25:00',4.91),('16100','2014-02-24','13:30:00',2.91),('16100','2014-02-24','13:35:00',2.74),('16100','2014-02-24','13:40:00',2.39),('16100','2014-02-24','13:45:00',2.4),('16100','2014-02-24','13:50:00',3.63),('16100','2014-02-24','13:55:00',6.49),('16100','2014-02-24','14:00:00',6.22),('16100','2014-02-24','14:05:00',5.42),('16100','2014-02-24','14:10:00',3.14),('16100','2014-02-24','14:15:00',6.15),('16100','2014-02-24','14:20:00',5.49),('16100','2014-02-24','14:25:00',5.33),('16100','2014-02-24','14:30:00',4.62),('16100','2014-02-24','14:35:00',5.02),('16100','2014-02-24','14:40:00',5.11),('16100','2014-02-24','14:45:00',5.16),('16100','2014-02-24','14:50:00',4.72),('16100','2014-02-24','14:55:00',5.06),('16100','2014-02-24','15:00:00',4.87),('16100','2014-02-24','15:05:00',4.67),('16100','2014-02-24','15:10:00',4.55),('16100','2014-02-24','15:15:00',4.3),('16100','2014-02-24','15:20:00',4.2),('16100','2014-02-24','15:25:00',3.96),('16100','2014-02-24','15:30:00',3.73),('16100','2014-02-24','15:35:00',3.51),('16100','2014-02-24','15:40:00',2.1),('16100','2014-02-24','15:45:00',1.51),('16100','2014-02-24','15:50:00',2.31),('16100','2014-02-24','15:55:00',2.41),('16100','2014-02-24','16:00:00',2.21),('16100','2014-02-24','16:05:00',2.13),('16100','2014-02-24','16:10:00',2),('16100','2014-02-24','16:15:00',1.75),('16100','2014-02-24','16:20:00',1.85),('16100','2014-02-24','16:25:00',1.46),('16100','2014-02-23','07:50:00',1.1),('16100','2014-02-23','07:55:00',1.42),('16100','2014-02-23','08:00:00',1.8),('16100','2014-02-23','08:05:00',2.17),('16100','2014-02-23','08:10:00',2.42),('16100','2014-02-23','08:15:00',2.65),('16100','2014-02-23','08:20:00',2.17),('16100','2014-02-23','08:25:00',1.45),('16100','2014-02-23','08:30:00',1.74),('16100','2014-02-23','08:35:00',1.74),('16100','2014-02-23','08:40:00',1.18),('16100','2014-02-23','08:45:00',2.63),('16100','2014-02-23','08:50:00',3.69),('16100','2014-02-23','08:55:00',3.68),('16100','2014-02-23','09:00:00',3.75),('16100','2014-02-23','09:05:00',3.83),('16100','2014-02-23','09:10:00',3.96),('16100','2014-02-23','09:15:00',4.13),('16100','2014-02-23','09:20:00',4.27),('16100','2014-02-23','09:25:00',4.38),('16100','2014-02-23','09:30:00',4.53),('16100','2014-02-23','09:35:00',4.67),('16100','2014-02-23','09:40:00',4.78),('16100','2014-02-23','09:45:00',4.94),('16100','2014-02-23','09:50:00',5.08),('16100','2014-02-23','09:55:00',5.21),('16100','2014-02-23','10:00:00',5.35),('16100','2014-02-23','10:05:00',5.48),('16100','2014-02-23','10:10:00',5.6),('16100','2014-02-23','10:15:00',5.7),('16100','2014-02-23','10:20:00',5.75),('16100','2014-02-23','10:25:00',5.86),('16100','2014-02-23','10:30:00',5.99),('16100','2014-02-23','10:35:00',6.09),('16100','2014-02-23','10:40:00',6.14),('16100','2014-02-23','10:45:00',6.17),('16100','2014-02-23','10:50:00',6.27),('16100','2014-02-23','10:55:00',6.29),('16100','2014-02-23','11:00:00',6.39),('16100','2014-02-23','11:05:00',6.52),('16100','2014-02-23','11:10:00',6.64),('16100','2014-02-23','11:15:00',6.63),('16100','2014-02-23','11:20:00',6.9),('16100','2014-02-23','11:25:00',7.12),('16100','2014-02-23','11:30:00',4.78),('16100','2014-02-23','11:35:00',5.38),('16100','2014-02-23','11:40:00',2.46),('16100','2014-02-23','11:45:00',3.55),('16100','2014-02-23','11:50:00',7.41),('16100','2014-02-23','11:55:00',7.06),('16100','2014-02-23','12:00:00',6.96),('16100','2014-02-23','12:05:00',6.12),('16100','2014-02-23','12:10:00',5.52),('16100','2014-02-23','12:15:00',7.05),('16100','2014-02-23','12:20:00',6.93),('16100','2014-02-23','12:25:00',6.84),('16100','2014-02-23','12:30:00',6.89),('16100','2014-02-23','12:35:00',6.96),('16100','2014-02-23','12:40:00',6.91),('16100','2014-02-23','12:45:00',6.87),('16100','2014-02-23','12:50:00',7.14),('16100','2014-02-23','12:55:00',3.67),('16100','2014-02-23','13:00:00',3.11),('16100','2014-02-23','13:05:00',3.23),('16100','2014-02-23','13:10:00',1.8),('16100','2014-02-23','13:15:00',1.43),('16100','2014-02-23','13:20:00',1.29),('16100','2014-02-23','13:25:00',1.22),('16100','2014-02-23','13:30:00',1.13),('16100','2014-02-23','13:35:00',1.16),('16100','2014-02-23','13:40:00',1.35),('16100','2014-02-23','13:45:00',1.56),('16100','2014-02-23','13:50:00',1.68),('16100','2014-02-23','13:55:00',1.84),('16100','2014-02-23','14:00:00',2.09),('16100','2014-02-23','14:05:00',2.14),('16100','2014-02-23','14:10:00',2.36),('16100','2014-02-23','14:15:00',3.63),('16100','2014-02-23','14:20:00',2.19),('16100','2014-02-23','14:25:00',1.68),('16100','2014-02-23','14:30:00',1.46),('16100','2014-02-23','14:35:00',1.36),('16100','2014-02-23','14:40:00',1.34),('16100','2014-02-23','14:45:00',1.4),('16100','2014-02-23','14:50:00',1.58),('16100','2014-02-23','14:55:00',1.75),('16100','2014-02-23','15:00:00',1.81),('16100','2014-02-23','15:05:00',1.95),('16100','2014-02-23','15:10:00',2.15),('16100','2014-02-23','15:15:00',4.9),('16100','2014-02-23','15:20:00',5.26),('16100','2014-02-23','15:25:00',4.79),('16100','2014-02-23','15:30:00',4.48),('16100','2014-02-23','15:35:00',4.25),('16100','2014-02-23','15:40:00',4.04),('16100','2014-02-23','15:45:00',3.81),('16100','2014-02-23','15:50:00',3.67),('16100','2014-02-23','15:55:00',3.56),('16100','2014-02-23','16:00:00',3.58),('16100','2014-02-23','16:05:00',3.45),('16100','2014-02-23','16:10:00',2.92),('16100','2014-02-23','16:15:00',1.58),('16100','2014-02-23','16:25:00',1.14),('16100','2014-02-23','16:30:00',2.07),('16100','2014-02-23','16:35:00',2.02),('16100','2014-02-23','16:40:00',1.86),('16100','2014-02-23','16:45:00',1.68),('16100','2014-02-23','16:50:00',1.48),('16100','2014-02-23','16:55:00',1.34),('16100','2014-02-23','17:00:00',1.16),('16100','2014-02-22','07:55:00',1.14),('16100','2014-02-22','08:00:00',1.33),('16100','2014-02-22','08:05:00',1.52),('16100','2014-02-22','08:10:00',1.71),('16100','2014-02-22','08:15:00',1.89),('16100','2014-02-22','08:20:00',2.08),('16100','2014-02-22','08:25:00',2.26),('16100','2014-02-22','08:30:00',2.43),('16100','2014-02-22','08:35:00',2.57),('16100','2014-02-22','08:40:00',2.75),('16100','2014-02-22','08:45:00',2.94),('16100','2014-02-22','08:50:00',3.1),('16100','2014-02-22','08:55:00',3.3),('16100','2014-02-22','09:00:00',3.47),('16100','2014-02-22','09:05:00',3.63),('16100','2014-02-22','09:10:00',3.82),('16100','2014-02-22','09:15:00',3.97),('16100','2014-02-22','09:20:00',3.87),('16100','2014-02-22','09:25:00',3.99),('16100','2014-02-22','09:30:00',4.32),('16100','2014-02-22','09:35:00',4.43),('16100','2014-02-22','09:40:00',4.53),('16100','2014-02-22','09:45:00',4.66),('16100','2014-02-22','09:50:00',4.78),('16100','2014-02-22','09:55:00',4.89),('16100','2014-02-22','10:00:00',5.02),('16100','2014-02-22','10:05:00',5.16),('16100','2014-02-22','10:10:00',5.28),('16100','2014-02-22','10:15:00',5.37),('16100','2014-02-22','10:20:00',5.47),('16100','2014-02-22','10:25:00',5.58),('16100','2014-02-22','10:30:00',5.7),('16100','2014-02-22','10:35:00',5.8),('16100','2014-02-22','10:40:00',5.91),('16100','2014-02-22','10:45:00',5.96),('16100','2014-02-22','10:50:00',6.06),('16100','2014-02-22','10:55:00',6.13),('16100','2014-02-22','11:00:00',6.15),('16100','2014-02-22','11:05:00',6.18),('16100','2014-02-22','11:10:00',6.4),('16100','2014-02-22','11:15:00',6.41),('16100','2014-02-22','11:20:00',6.37),('16100','2014-02-22','11:25:00',6.53),('16100','2014-02-22','11:30:00',6.6),('16100','2014-02-22','11:35:00',6.65),('16100','2014-02-22','11:40:00',6.73),('16100','2014-02-22','11:45:00',6.81),('16100','2014-02-22','11:50:00',6.93),('16100','2014-02-22','11:55:00',6.89),('16100','2014-02-22','12:00:00',6.92),('16100','2014-02-22','12:05:00',7.01),('16100','2014-02-22','12:10:00',6.65),('16100','2014-02-22','12:15:00',6.56),('16100','2014-02-22','12:20:00',3.38),('16100','2014-02-22','12:25:00',6.33),('16100','2014-02-22','12:30:00',6.83),('16100','2014-02-22','12:35:00',4.24),('16100','2014-02-22','12:40:00',4.46),('16100','2014-02-22','12:45:00',6.88),('16100','2014-02-22','12:50:00',7.43),('16100','2014-02-22','12:55:00',6.92),('16100','2014-02-22','13:00:00',6.8),('16100','2014-02-22','13:05:00',6.71),('16100','2014-02-22','13:10:00',6.64),('16100','2014-02-22','13:15:00',6.68),('16100','2014-02-22','13:20:00',5.37),('16100','2014-02-22','13:25:00',2.69),('16100','2014-02-22','13:30:00',4.38),('16100','2014-02-22','13:35:00',5.58),('16100','2014-02-22','13:40:00',6.48),('16100','2014-02-22','13:45:00',4.7),('16100','2014-02-22','13:50:00',4.92),('16100','2014-02-22','13:55:00',5.74),('16100','2014-02-22','14:00:00',6.14),('16100','2014-02-22','14:05:00',4.96),('16100','2014-02-22','14:10:00',4.17),('16100','2014-02-22','14:15:00',5.12),('16100','2014-02-22','14:20:00',4.64),('16100','2014-02-22','14:25:00',5.18),('16100','2014-02-22','14:30:00',6.84),('16100','2014-02-22','14:35:00',5.99),('16100','2014-02-22','14:40:00',6.19),('16100','2014-02-22','14:45:00',3.67),('16100','2014-02-22','14:50:00',4.33),('16100','2014-02-22','14:55:00',1.9),('16100','2014-02-22','15:00:00',2.32),('16100','2014-02-22','15:05:00',1.7),('16100','2014-02-22','15:10:00',1.77),('16100','2014-02-22','15:15:00',4.56),('16100','2014-02-22','15:20:00',5.31),('16100','2014-02-22','15:25:00',3.65),('16100','2014-02-22','15:30:00',5.05),('16100','2014-02-22','15:35:00',4.88),('16100','2014-02-22','15:40:00',3.85),('16100','2014-02-22','15:45:00',3.73),('16100','2014-02-22','15:50:00',2.35),('16100','2014-02-21','09:10:00',1.01),('16100','2014-02-21','09:15:00',1.53),('16100','2014-02-21','09:20:00',1.52),('16100','2014-02-21','09:25:00',1.11),('16100','2014-02-21','09:30:00',1.43),('16100','2014-02-21','09:35:00',1.89),('16100','2014-02-21','09:40:00',3.68),('16100','2014-02-21','09:45:00',4.09),('16100','2014-02-21','09:50:00',1.71),('16100','2014-02-21','09:55:00',3.9),('16100','2014-02-21','10:00:00',3.01),('16100','2014-02-21','10:05:00',3.45),('16100','2014-02-21','10:10:00',1.68),('16100','2014-02-21','10:15:00',1.53),('16100','2014-02-21','10:20:00',1.93),('16100','2014-02-21','10:25:00',4.45),('16100','2014-02-21','10:30:00',3.2),('16100','2014-02-21','10:35:00',2.8),('16100','2014-02-21','10:40:00',2.62),('16100','2014-02-21','10:45:00',3.84),('16100','2014-02-21','10:50:00',1.11),('16100','2014-02-21','11:35:00',1.32),('16100','2014-02-21','11:40:00',1.14),('16100','2014-02-21','11:45:00',1.02),('16100','2014-02-21','11:50:00',1.16),('16100','2014-02-21','11:55:00',1.39),('16100','2014-02-21','12:00:00',1.58),('16100','2014-02-21','12:05:00',1.76),('16100','2014-02-21','12:10:00',2.44),('16100','2014-02-21','12:15:00',3.04),('16100','2014-02-21','12:20:00',2.61),('16100','2014-02-21','12:25:00',2.11),('16100','2014-02-21','12:30:00',2.74),('16100','2014-02-21','12:35:00',2.56),('16100','2014-02-21','12:40:00',7.23),('16100','2014-02-21','12:45:00',6.85),('16100','2014-02-21','12:50:00',7.93),('16100','2014-02-21','12:55:00',2.94),('16100','2014-02-21','13:00:00',5.14),('16100','2014-02-21','13:05:00',6.92),('16100','2014-02-21','13:10:00',1.59),('16100','2014-02-21','13:15:00',1.61),('16100','2014-02-21','13:20:00',1.78),('16100','2014-02-21','13:25:00',2.26),('16100','2014-02-21','13:30:00',4.24),('16100','2014-02-21','13:35:00',5.97),('16100','2014-02-21','13:40:00',4),('16100','2014-02-21','13:45:00',3.86),('16100','2014-02-21','13:50:00',4.17),('16100','2014-02-21','13:55:00',4.77),('16100','2014-02-21','14:00:00',2.26),('16100','2014-02-21','14:05:00',4.05),('16100','2014-02-21','14:10:00',1.53),('16100','2014-02-21','14:15:00',5.02),('16100','2014-02-21','14:20:00',3.34),('16100','2014-02-21','14:25:00',1.42),('16100','2014-02-21','14:30:00',5.06),('16100','2014-02-21','14:35:00',5.54),('16100','2014-02-21','14:40:00',3.32),('16100','2014-02-21','14:45:00',1.59),('16100','2014-02-21','14:50:00',1.52),('16100','2014-02-21','14:55:00',1.99),('16100','2014-02-21','15:00:00',2.69),('16100','2014-02-21','15:05:00',2.96),('16100','2014-02-21','15:10:00',4.37),('16100','2014-02-21','15:15:00',3.93),('16100','2014-02-21','15:20:00',3.23),('16100','2014-02-21','15:25:00',2.5),('16100','2014-02-21','15:30:00',1.56),('16100','2014-02-21','15:35:00',2.99),('16100','2014-02-21','15:40:00',2.36),('16100','2014-02-21','15:45:00',4.49),('16100','2014-02-21','15:50:00',3.96),('16100','2014-02-21','15:55:00',3.47),('16100','2014-02-21','16:00:00',3.24),('16100','2014-02-21','16:05:00',2.87),('16100','2014-02-21','16:10:00',2.15),('16100','2014-02-21','16:15:00',2.46),('16100','2014-02-21','16:20:00',2.54),('16100','2014-02-21','16:25:00',2.27),('16100','2014-02-21','16:30:00',1.98),('16100','2014-02-21','16:35:00',2),('16100','2014-02-21','16:40:00',1.66),('16100','2014-02-21','16:45:00',1.35),('16100','2014-02-21','16:50:00',1.05),('16100','2014-02-21','16:55:00',1.23),('16100','2014-02-21','17:00:00',1.05),('16100','2014-02-20','08:45:00',1.04),('16100','2014-02-20','08:50:00',1.1),('16100','2014-02-20','08:55:00',1.19),('16100','2014-02-20','09:00:00',1.28),('16100','2014-02-20','09:05:00',1.33),('16100','2014-02-20','09:10:00',1.39),('16100','2014-02-20','09:15:00',1.58),('16100','2014-02-20','09:20:00',1.71),('16100','2014-02-20','09:25:00',1.66),('16100','2014-02-20','09:30:00',1.72),('16100','2014-02-20','09:35:00',1.69),('16100','2014-02-20','09:40:00',1.86),('16100','2014-02-20','09:45:00',1.94),('16100','2014-02-20','09:50:00',2.12),('16100','2014-02-20','09:55:00',2.12),('16100','2014-02-20','10:00:00',2.19),('16100','2014-02-20','10:05:00',2.16),('16100','2014-02-20','10:10:00',2.38),('16100','2014-02-20','10:15:00',3.05),('16100','2014-02-20','10:20:00',3.33),('16100','2014-02-20','10:25:00',3.73),('16100','2014-02-20','10:30:00',3.72),('16100','2014-02-20','10:35:00',2.51),('16100','2014-02-20','10:40:00',2.45),('16100','2014-02-20','10:45:00',2.66),('16100','2014-02-20','10:50:00',3.59),('16100','2014-02-20','10:55:00',5.47),('16100','2014-02-20','11:00:00',5.92),('16100','2014-02-20','11:05:00',4.45),('16100','2014-02-20','11:10:00',3.14),('16100','2014-02-20','11:15:00',2.79),('16100','2014-02-20','11:20:00',4.92),('16100','2014-02-20','11:25:00',4.61),('16100','2014-02-20','11:30:00',7.09),('16100','2014-02-20','11:35:00',7.52),('16100','2014-02-20','11:40:00',3.45),('16100','2014-02-20','11:45:00',4.88),('16100','2014-02-20','11:50:00',3.51),('16100','2014-02-20','11:55:00',5.97),('16100','2014-02-20','12:00:00',5.62),('16100','2014-02-20','12:05:00',2.66),('16100','2014-02-20','12:10:00',2.84),('16100','2014-02-20','12:15:00',2.19),('16100','2014-02-20','12:20:00',1.55),('16100','2014-02-20','12:25:00',1.22),('16100','2014-02-20','12:30:00',1.23),('16100','2014-02-20','12:35:00',1.06),('16100','2014-02-20','12:55:00',1.04),('16100','2014-02-20','13:05:00',1.04),('16100','2014-02-20','13:10:00',1.04),('16100','2014-02-20','13:15:00',1.12),('16100','2014-02-20','13:25:00',1.05),('16100','2014-02-20','13:30:00',1.23),('16100','2014-02-20','13:35:00',1.44),('16100','2014-02-20','13:40:00',2.26),('16100','2014-02-20','13:45:00',2.79),('16100','2014-02-20','13:50:00',1.92),('16100','2014-02-20','13:55:00',1.7),('16100','2014-02-20','14:00:00',1.49),('16100','2014-02-20','14:05:00',1.64),('16100','2014-02-20','14:10:00',1.55),('16100','2014-02-20','14:15:00',1.59),('16100','2014-02-20','14:20:00',1.58),('16100','2014-02-20','14:25:00',1.66),('16100','2014-02-20','14:30:00',2.11),('16100','2014-02-20','14:35:00',2.38),('16100','2014-02-20','14:40:00',2.26),('16100','2014-02-20','14:45:00',2.18),('16100','2014-02-20','14:50:00',1.73),('16100','2014-02-20','14:55:00',1.64),('16100','2014-02-20','15:00:00',1.8),('16100','2014-02-20','15:05:00',1.54),('16100','2014-02-20','15:10:00',1.58),('16100','2014-02-20','15:15:00',2.49),('16100','2014-02-20','15:20:00',4.36),('16100','2014-02-20','15:25:00',4.07),('16100','2014-02-20','15:30:00',3.84),('16100','2014-02-20','15:35:00',3.63),('16100','2014-02-20','15:40:00',3.33),('16100','2014-02-20','15:45:00',3.28),('16100','2014-02-20','15:50:00',3.08),('16100','2014-02-20','15:55:00',3.02),('16100','2014-02-20','16:00:00',2.16),('16100','2014-02-20','16:05:00',2.66),('16100','2014-02-20','16:10:00',2.45),('16100','2014-02-20','16:15:00',2.31),('16100','2014-02-20','16:20:00',2.15),('16100','2014-02-20','16:25:00',1.97),('16100','2014-02-20','16:30:00',1.81),('16100','2014-02-20','16:35:00',1.64),('16100','2014-02-20','16:40:00',1.46),('16100','2014-02-20','16:45:00',1.3),('16100','2014-02-20','16:50:00',1.14),('16100','2014-02-19','09:35:00',1.15),('16100','2014-02-19','09:40:00',1.25),('16100','2014-02-19','09:45:00',1.18),('16100','2014-02-19','09:50:00',1.18),('16100','2014-02-19','09:55:00',1.02),('16100','2014-02-19','10:00:00',1.01),('16100','2014-02-19','10:15:00',1.34),('16100','2014-02-19','10:20:00',1.43),('16100','2014-02-19','10:25:00',1.55),('16100','2014-02-19','10:30:00',1.44),('16100','2014-02-19','10:35:00',1.54),('16100','2014-02-19','10:40:00',1.62),('16100','2014-02-19','10:45:00',1.6),('16100','2014-02-19','10:50:00',1.2),('16100','2014-02-19','10:55:00',1.23),('16100','2014-02-19','11:00:00',1.06),('16100','2014-02-19','11:20:00',1.74),('16100','2014-02-19','11:25:00',2.1),('16100','2014-02-19','11:30:00',2.15),('16100','2014-02-19','11:35:00',2.08),('16100','2014-02-19','11:40:00',2.01),('16100','2014-02-19','11:45:00',1.74),('16100','2014-02-19','11:50:00',1.39),('16100','2014-02-19','11:55:00',1.65),('16100','2014-02-19','12:00:00',1.66),('16100','2014-02-19','12:05:00',1.41),('16100','2014-02-19','12:10:00',1.42),('16100','2014-02-19','12:15:00',1.39),('16100','2014-02-19','12:20:00',1.49),('16100','2014-02-19','13:10:00',1.02),('16100','2014-02-19','13:15:00',1.84),('16100','2014-02-19','13:20:00',1.34),('16100','2014-02-19','13:25:00',1.38),('16100','2014-02-19','13:30:00',1.81),('16100','2014-02-19','13:35:00',1.46),('16100','2014-02-19','13:40:00',1.57),('16100','2014-02-19','13:45:00',1.71),('16100','2014-02-19','13:50:00',1.77),('16100','2014-02-19','13:55:00',1.69),('16100','2014-02-19','14:00:00',1.85),('16100','2014-02-19','14:05:00',1.81),('16100','2014-02-19','14:10:00',1.57),('16100','2014-02-19','14:15:00',1.25),('16100','2014-02-19','14:20:00',1.14),('16100','2014-02-18','08:45:00',1.09),('16100','2014-02-18','08:50:00',1.04),('16100','2014-02-18','09:00:00',1.01),('16100','2014-02-18','09:10:00',1.16),('16100','2014-02-18','09:15:00',1.24),('16100','2014-02-18','09:20:00',1.3),('16100','2014-02-18','09:25:00',1.58),('16100','2014-02-18','09:30:00',1.5),('16100','2014-02-18','09:35:00',1.68),('16100','2014-02-18','09:40:00',1.96),('16100','2014-02-18','09:45:00',2.37),('16100','2014-02-18','09:50:00',2.32),('16100','2014-02-18','09:55:00',2.02),('16100','2014-02-18','10:00:00',2.12),('16100','2014-02-18','10:05:00',2.15),('16100','2014-02-18','10:10:00',2.27),('16100','2014-02-18','10:15:00',2.66),('16100','2014-02-18','10:20:00',2.41),('16100','2014-02-18','10:25:00',2.29),('16100','2014-02-18','10:30:00',2.02),('16100','2014-02-18','10:35:00',2.11),('16100','2014-02-18','10:40:00',2.55),('16100','2014-02-18','10:45:00',2.46),('16100','2014-02-18','10:50:00',2.72),('16100','2014-02-18','10:55:00',2.77),('16100','2014-02-18','11:00:00',1.83),('16100','2014-02-18','11:05:00',1.4),('16100','2014-02-18','11:10:00',1.27),('16100','2014-02-18','11:15:00',1.62),('16100','2014-02-18','11:20:00',2.01),('16100','2014-02-18','11:25:00',1.94),('16100','2014-02-18','11:30:00',1.52),('16100','2014-02-18','11:35:00',1.85),('16100','2014-02-18','11:40:00',2.31),('16100','2014-02-18','11:45:00',1.92),('16100','2014-02-18','11:50:00',2.13),('16100','2014-02-18','11:55:00',2.21),('16100','2014-02-18','12:00:00',2.4),('16100','2014-02-18','12:05:00',2.72),('16100','2014-02-18','12:10:00',2.61),('16100','2014-02-18','12:15:00',2.19),('16100','2014-02-18','12:20:00',1.44),('16100','2014-02-18','12:25:00',1.37),('16100','2014-02-18','12:30:00',1.88),('16100','2014-02-18','12:35:00',2.15),('16100','2014-02-18','12:40:00',1.88),('16100','2014-02-18','12:45:00',2.07),('16100','2014-02-18','12:50:00',2),('16100','2014-02-18','12:55:00',1.62),('16100','2014-02-18','13:00:00',2.01),('16100','2014-02-18','13:05:00',2.22),('16100','2014-02-18','13:10:00',1.55),('16100','2014-02-18','13:15:00',1.67),('16100','2014-02-18','13:20:00',1.85),('16100','2014-02-18','13:25:00',2.31),('16100','2014-02-18','13:30:00',2.47),('16100','2014-02-18','13:35:00',2.84),('16100','2014-02-18','13:40:00',3.31),('16100','2014-02-18','13:45:00',3.83),('16100','2014-02-18','13:50:00',3.72),('16100','2014-02-18','13:55:00',3.77),('16100','2014-02-18','14:00:00',3.28),('16100','2014-02-18','14:05:00',2.19),('16100','2014-02-18','14:10:00',1.97),('16100','2014-02-18','14:15:00',2.03),('16100','2014-02-18','14:20:00',2.46),('16100','2014-02-18','14:25:00',2.04),('16100','2014-02-18','14:30:00',2.77),('16100','2014-02-18','14:35:00',2.24),('16100','2014-02-18','14:40:00',2.04),('16100','2014-02-18','14:45:00',1.61),('16100','2014-02-18','14:50:00',2.16),('16100','2014-02-18','14:55:00',1.69),('16100','2014-02-18','15:00:00',1.41),('16100','2014-02-18','15:05:00',1.4),('16100','2014-02-18','15:10:00',1.32),('16100','2014-02-18','15:15:00',1.69),('16100','2014-02-18','15:20:00',1.28),('16100','2014-02-18','15:25:00',1.5),('16100','2014-02-18','15:30:00',1.39),('16100','2014-02-18','15:35:00',1.41),('16100','2014-02-18','15:40:00',1.52),('16100','2014-02-18','15:45:00',1.63),('16100','2014-02-18','15:50:00',1.74),('16100','2014-02-18','15:55:00',1.38),('16100','2014-02-18','16:00:00',1.34),('16100','2014-02-18','16:05:00',1.28),('16100','2014-02-18','16:10:00',1.14),('16100','2014-02-18','16:15:00',1.02),('16100','2014-02-17','07:55:00',1),('16100','2014-02-17','08:00:00',1.19),('16100','2014-02-17','08:05:00',1.37),('16100','2014-02-17','08:10:00',1.54),('16100','2014-02-17','08:15:00',1.73),('16100','2014-02-17','08:20:00',1.91),('16100','2014-02-17','08:25:00',2.06),('16100','2014-02-17','08:30:00',2.19),('16100','2014-02-17','08:35:00',2.38),('16100','2014-02-17','08:40:00',2.54),('16100','2014-02-17','08:45:00',2.71),('16100','2014-02-17','08:50:00',2.89),('16100','2014-02-17','08:55:00',3.07),('16100','2014-02-17','09:00:00',3.22),('16100','2014-02-17','09:05:00',3.4),('16100','2014-02-17','09:10:00',3.56),('16100','2014-02-17','09:15:00',3.7),('16100','2014-02-17','09:20:00',3.84),('16100','2014-02-17','09:25:00',3.91),('16100','2014-02-17','09:30:00',4.07),('16100','2014-02-17','09:35:00',4.21),('16100','2014-02-17','09:40:00',4.31),('16100','2014-02-17','09:45:00',4.47),('16100','2014-02-17','09:50:00',4.58),('16100','2014-02-17','09:55:00',4.69),('16100','2014-02-17','10:00:00',4.82),('16100','2014-02-17','10:05:00',4.95),('16100','2014-02-17','10:10:00',5.05),('16100','2014-02-17','10:15:00',5.13),('16100','2014-02-17','10:20:00',5.24),('16100','2014-02-17','10:25:00',5.33),('16100','2014-02-17','10:30:00',5.46),('16100','2014-02-17','10:35:00',5.52),('16100','2014-02-17','10:40:00',5.61),('16100','2014-02-17','10:45:00',5.7),('16100','2014-02-17','10:50:00',5.78),('16100','2014-02-17','10:55:00',5.9),('16100','2014-02-17','11:00:00',6.03),('16100','2014-02-17','11:05:00',5.92),('16100','2014-02-17','11:10:00',5.62),('16100','2014-02-17','11:15:00',4.9),('16100','2014-02-17','11:20:00',5.78),('16100','2014-02-17','11:25:00',6.27),('16100','2014-02-17','11:30:00',5.29),('16100','2014-02-17','11:35:00',3.66),('16100','2014-02-17','11:40:00',3.34),('16100','2014-02-17','11:45:00',3.2),('16100','2014-02-17','11:50:00',2.45),('16100','2014-02-17','11:55:00',2.42),('16100','2014-02-17','12:00:00',2.51),('16100','2014-02-17','12:05:00',2.42),('16100','2014-02-17','12:10:00',2.49),('16100','2014-02-17','12:15:00',2.76),('16100','2014-02-17','12:20:00',2.98),('16100','2014-02-17','12:25:00',3.38),('16100','2014-02-17','12:30:00',2.97),('16100','2014-02-17','12:35:00',2.64),('16100','2014-02-17','12:40:00',2.55),('16100','2014-02-17','12:45:00',2.45),('16100','2014-02-17','12:50:00',2.27),('16100','2014-02-17','12:55:00',2.42),('16100','2014-02-17','13:00:00',2.27),('16100','2014-02-17','13:05:00',2.09),('16100','2014-02-17','13:10:00',2.12),('16100','2014-02-17','13:15:00',2.72),('16100','2014-02-17','13:20:00',3.85),('16100','2014-02-17','13:25:00',5.57),('16100','2014-02-17','13:30:00',3.73),('16100','2014-02-17','13:35:00',3.09),('16100','2014-02-17','13:40:00',3.67),('16100','2014-02-17','13:45:00',3.81),('16100','2014-02-17','13:50:00',3),('16100','2014-02-17','13:55:00',2.71),('16100','2014-02-17','14:00:00',3.04),('16100','2014-02-17','14:05:00',3.5),('16100','2014-02-17','14:10:00',3.2),('16100','2014-02-17','14:15:00',2.35),('16100','2014-02-17','14:20:00',1.97),('16100','2014-02-17','14:25:00',1.8),('16100','2014-02-17','14:30:00',2.1),('16100','2014-02-17','14:35:00',2.15),('16100','2014-02-17','14:40:00',1.87),('16100','2014-02-17','14:45:00',1.61),('16100','2014-02-17','14:50:00',1.56),('16100','2014-02-17','14:55:00',1.48),('16100','2014-02-17','15:00:00',1.3),('16100','2014-02-17','15:05:00',1.2),('16100','2014-02-17','15:10:00',1.18),('16100','2014-02-17','15:15:00',1.13),('16100','2014-02-17','15:20:00',1.05),('16100','2014-02-17','15:25:00',1.2),('16100','2014-02-17','15:30:00',1.42),('16100','2014-02-17','15:35:00',1.7),('16100','2014-02-17','15:40:00',2.04),('16100','2014-02-17','15:45:00',1.81),('16100','2014-02-17','15:50:00',1.6),('16100','2014-02-17','15:55:00',1.43),('16100','2014-02-17','16:00:00',1.71),('16100','2014-02-17','16:05:00',1.9),('16100','2014-02-17','16:10:00',1.46),('16100','2014-02-17','16:15:00',1.23),('16100','2014-02-17','16:35:00',1.06),('16100','2014-02-16','08:05:00',1.14),('16100','2014-02-16','08:10:00',1.29),('16100','2014-02-16','08:15:00',1.46),('16100','2014-02-16','08:20:00',1.65),('16100','2014-02-16','08:25:00',1.79),('16100','2014-02-16','08:30:00',1.94),('16100','2014-02-16','08:35:00',2.14),('16100','2014-02-16','08:40:00',2.28),('16100','2014-02-16','08:45:00',2.38),('16100','2014-02-16','08:50:00',2.53),('16100','2014-02-16','08:55:00',2.66),('16100','2014-02-16','09:00:00',2.87),('16100','2014-02-16','09:05:00',3.05),('16100','2014-02-16','09:10:00',3.2),('16100','2014-02-16','09:15:00',3.36),('16100','2014-02-16','09:20:00',3.52),('16100','2014-02-16','09:25:00',3.65),('16100','2014-02-16','09:30:00',3.8),('16100','2014-02-16','09:35:00',3.93),('16100','2014-02-16','09:40:00',4.04),('16100','2014-02-16','09:45:00',4.11),('16100','2014-02-16','09:50:00',4.2),('16100','2014-02-16','09:55:00',4.31),('16100','2014-02-16','10:00:00',4.4),('16100','2014-02-16','10:05:00',4.49),('16100','2014-02-16','10:10:00',4.59),('16100','2014-02-16','10:15:00',4.65),('16100','2014-02-16','10:20:00',4.75),('16100','2014-02-16','10:25:00',4.87),('16100','2014-02-16','10:30:00',4.97),('16100','2014-02-16','10:35:00',5.02),('16100','2014-02-16','10:40:00',5.08),('16100','2014-02-16','10:45:00',5.15),('16100','2014-02-16','10:50:00',5.16),('16100','2014-02-16','10:55:00',5.22),('16100','2014-02-16','11:00:00',5.3),('16100','2014-02-16','11:05:00',5.35),('16100','2014-02-16','11:10:00',5.4),('16100','2014-02-16','11:15:00',5.43),('16100','2014-02-16','11:20:00',5.49),('16100','2014-02-16','11:25:00',5.48),('16100','2014-02-16','11:30:00',5.47),('16100','2014-02-16','11:35:00',5.5),('16100','2014-02-16','11:40:00',5.54),('16100','2014-02-16','11:45:00',5.61),('16100','2014-02-16','11:50:00',5.77),('16100','2014-02-16','11:55:00',5.86),('16100','2014-02-16','12:00:00',5.91),('16100','2014-02-16','12:05:00',5.92),('16100','2014-02-16','12:10:00',5.93),('16100','2014-02-16','12:15:00',5.99),('16100','2014-02-16','12:20:00',6.02),('16100','2014-02-16','12:25:00',6.08),('16100','2014-02-16','12:30:00',6.08),('16100','2014-02-16','12:35:00',6.03),('16100','2014-02-16','12:40:00',5.99),('16100','2014-02-16','12:45:00',5.98),('16100','2014-02-16','12:50:00',6),('16100','2014-02-16','12:55:00',5.98),('16100','2014-02-16','13:00:00',5.95),('16100','2014-02-16','13:05:00',5.9),('16100','2014-02-16','13:10:00',5.9),('16100','2014-02-16','13:15:00',5.84),('16100','2014-02-16','13:20:00',5.78),('16100','2014-02-16','13:25:00',5.73),('16100','2014-02-16','13:30:00',5.72),('16100','2014-02-16','13:35:00',5.63),('16100','2014-02-16','13:40:00',5.55),('16100','2014-02-16','13:45:00',5.47),('16100','2014-02-16','13:50:00',5.4),('16100','2014-02-16','13:55:00',5.38),('16100','2014-02-16','14:00:00',5.22),('16100','2014-02-16','14:05:00',5.15),('16100','2014-02-16','14:10:00',4.97),('16100','2014-02-16','14:15:00',5.05),('16100','2014-02-16','14:20:00',4.97),('16100','2014-02-16','14:25:00',4.79),('16100','2014-02-16','14:30:00',4.62),('16100','2014-02-16','14:35:00',4.47),('16100','2014-02-16','14:40:00',4.43),('16100','2014-02-16','14:45:00',4.39),('16100','2014-02-16','14:50:00',4.32),('16100','2014-02-16','14:55:00',4.2),('16100','2014-02-16','15:00:00',4.07),('16100','2014-02-16','15:05:00',3.79),('16100','2014-02-16','15:10:00',3.47),('16100','2014-02-16','15:15:00',3.65),('16100','2014-02-16','15:20:00',3.57),('16100','2014-02-16','15:25:00',3.43),('16100','2014-02-16','15:30:00',3.39),('16100','2014-02-16','15:35:00',3.24),('16100','2014-02-16','15:40:00',2.97),('16100','2014-02-16','15:45:00',2.97),('16100','2014-02-16','15:50:00',2.8),('16100','2014-02-16','15:55:00',2.68),('16100','2014-02-16','16:00:00',2.42),('16100','2014-02-16','16:05:00',2.28),('16100','2014-02-16','16:10:00',2.12),('16100','2014-02-16','16:15:00',1.91),('16100','2014-02-16','16:20:00',1.78),('16100','2014-02-16','16:25:00',1.66),('16100','2014-02-16','16:30:00',1.43),('16100','2014-02-16','16:35:00',1.27),('16100','2014-02-16','16:40:00',1.1),('16100','2014-02-15','08:00:00',1.12),('16100','2014-02-15','08:05:00',1.29),('16100','2014-02-15','08:10:00',1.46),('16100','2014-02-15','08:15:00',1.66),('16100','2014-02-15','08:20:00',1.86),('16100','2014-02-15','08:25:00',2.06),('16100','2014-02-15','08:30:00',2.25),('16100','2014-02-15','08:35:00',2.35),('16100','2014-02-15','08:40:00',2.58),('16100','2014-02-15','08:45:00',2.77),('16100','2014-02-15','08:50:00',2.89),('16100','2014-02-15','08:55:00',3.19),('16100','2014-02-15','09:00:00',3.39),('16100','2014-02-15','09:05:00',3.3),('16100','2014-02-15','09:10:00',3.17),('16100','2014-02-15','09:15:00',3.61),('16100','2014-02-15','09:20:00',3.66),('16100','2014-02-15','09:25:00',3.91),('16100','2014-02-15','09:30:00',3.08),('16100','2014-02-15','09:35:00',4.13),('16100','2014-02-15','09:40:00',4.41),('16100','2014-02-15','09:45:00',4.34),('16100','2014-02-15','09:50:00',4.49),('16100','2014-02-15','09:55:00',4.57),('16100','2014-02-15','10:00:00',4.61),('16100','2014-02-15','10:05:00',5.04),('16100','2014-02-15','10:10:00',5.11),('16100','2014-02-15','10:15:00',5.14),('16100','2014-02-15','10:20:00',4.91),('16100','2014-02-15','10:25:00',5.4),('16100','2014-02-15','10:30:00',5.53),('16100','2014-02-15','10:35:00',5.59),('16100','2014-02-15','10:40:00',5.65),('16100','2014-02-15','10:45:00',5.57),('16100','2014-02-15','10:50:00',4.63),('16100','2014-02-15','10:55:00',5.66),('16100','2014-02-15','11:00:00',5.81),('16100','2014-02-15','11:05:00',5.71),('16100','2014-02-15','11:10:00',5.65),('16100','2014-02-15','11:15:00',5.58),('16100','2014-02-15','11:20:00',4.94),('16100','2014-02-15','11:25:00',5.64),('16100','2014-02-15','11:30:00',5.99),('16100','2014-02-15','11:35:00',6.02),('16100','2014-02-15','11:40:00',5.38),('16100','2014-02-15','11:45:00',6.09),('16100','2014-02-15','11:50:00',5.97),('16100','2014-02-15','11:55:00',6.26),('16100','2014-02-15','12:00:00',6.25),('16100','2014-02-15','12:05:00',6.25),('16100','2014-02-15','12:10:00',6.27),('16100','2014-02-15','12:15:00',6.26),('16100','2014-02-15','12:20:00',6.26),('16100','2014-02-15','12:25:00',6.22),('16100','2014-02-15','12:30:00',6.22),('16100','2014-02-15','12:35:00',6.19),('16100','2014-02-15','12:40:00',6.16),('16100','2014-02-15','12:45:00',6.14),('16100','2014-02-15','12:50:00',6.09),('16100','2014-02-15','12:55:00',6.11),('16100','2014-02-15','13:00:00',6.12),('16100','2014-02-15','13:05:00',5.96),('16100','2014-02-15','13:10:00',5.92),('16100','2014-02-15','13:15:00',6.09),('16100','2014-02-15','13:20:00',6.02),('16100','2014-02-15','13:25:00',5.92),('16100','2014-02-15','13:30:00',5.97),('16100','2014-02-15','13:35:00',5.88),('16100','2014-02-15','13:40:00',5.8),('16100','2014-02-15','13:45:00',5.54),('16100','2014-02-15','13:50:00',5.55),('16100','2014-02-15','13:55:00',5.47),('16100','2014-02-15','14:00:00',5.53),('16100','2014-02-15','14:05:00',5.48),('16100','2014-02-15','14:10:00',5.42),('16100','2014-02-15','14:15:00',5.37),('16100','2014-02-15','14:20:00',5.06),('16100','2014-02-15','14:25:00',5.17),('16100','2014-02-15','14:30:00',5.14),('16100','2014-02-15','14:35:00',4.85),('16100','2014-02-15','14:40:00',4.89),('16100','2014-02-15','14:45:00',4.86),('16100','2014-02-15','14:50:00',4.65),('16100','2014-02-15','14:55:00',3.69),('16100','2014-02-15','15:00:00',3.98),('16100','2014-02-15','15:05:00',4.48),('16100','2014-02-15','15:10:00',4.32),('16100','2014-02-15','15:15:00',4.17),('16100','2014-02-15','15:20:00',4.06),('16100','2014-02-15','15:25:00',3.92),('16100','2014-02-15','15:30:00',3.68),('16100','2014-02-15','15:35:00',3.34),('16100','2014-02-15','15:40:00',2.96),('16100','2014-02-15','15:45:00',1.42),('16100','2014-02-15','15:50:00',2.24),('16100','2014-02-15','15:55:00',1.03),('16100','2014-02-15','16:05:00',1.06),('16100','2014-02-15','16:10:00',2.06),('16100','2014-02-15','16:15:00',2.24),('16100','2014-02-15','16:20:00',2.73),('16100','2014-02-15','16:25:00',2.5),('16100','2014-02-15','16:30:00',2.18),('16100','2014-02-15','16:35:00',1.41),('16100','2014-04-27','08:05:00',1.15),('16100','2014-04-27','08:10:00',1.71),('16100','2014-04-27','08:15:00',2.22),('16100','2014-04-27','08:20:00',2.68),('16100','2014-04-27','08:25:00',1.65),('16100','2014-04-27','08:30:00',1.58),('16100','2014-04-27','08:35:00',1.78),('16100','2014-04-27','08:40:00',1.9),('16100','2014-04-27','08:45:00',2),('16100','2014-04-27','08:50:00',1.65),('16100','2014-04-27','08:55:00',1.5),('16100','2014-04-27','09:00:00',2.28),('16100','2014-04-27','09:05:00',4.12),('16100','2014-04-27','09:10:00',4.24),('16100','2014-04-27','09:15:00',3.82),('16100','2014-04-27','09:20:00',4.58),('16100','2014-04-27','09:25:00',5.12),('16100','2014-04-27','09:30:00',4.45),('16100','2014-04-27','09:35:00',4.76),('16100','2014-04-27','09:40:00',3.75),('16100','2014-04-27','09:45:00',2.19),('16100','2014-04-27','09:50:00',2.32),('16100','2014-04-27','09:55:00',2.73),('16100','2014-04-27','10:00:00',3.52),('16100','2014-04-27','10:05:00',2.4),('16100','2014-04-27','10:10:00',1.87),('16100','2014-04-27','10:15:00',1.73),('16100','2014-04-27','10:20:00',1.79),('16100','2014-04-27','10:25:00',2.36),('16100','2014-04-27','10:30:00',2.19),('16100','2014-04-27','10:35:00',1.83),('16100','2014-04-27','10:40:00',1.62),('16100','2014-04-27','10:45:00',1.74),('16100','2014-04-27','10:50:00',2.13),('16100','2014-04-27','10:55:00',3.03),('16100','2014-04-27','11:00:00',2.97),('16100','2014-04-27','11:05:00',3.09),('16100','2014-04-27','11:10:00',3.09),('16100','2014-04-27','11:15:00',2.69),('16100','2014-04-27','11:20:00',2.44),('16100','2014-04-27','11:25:00',1.91),('16100','2014-04-27','11:30:00',1.98),('16100','2014-04-27','11:35:00',2.86),('16100','2014-04-27','11:40:00',2.72),('16100','2014-04-27','11:45:00',2.41),('16100','2014-04-27','11:50:00',2.4),('16100','2014-04-27','11:55:00',2.72),('16100','2014-04-27','12:00:00',3.18),('16100','2014-04-27','12:05:00',3.2),('16100','2014-04-27','12:10:00',2.75),('16100','2014-04-27','12:15:00',2.33),('16100','2014-04-27','12:20:00',2.57),('16100','2014-04-27','12:25:00',3.22),('16100','2014-04-27','12:30:00',3.81),('16100','2014-04-27','12:35:00',4.88),('16100','2014-04-27','12:40:00',3.93),('16100','2014-04-27','12:45:00',3.67),('16100','2014-04-27','12:50:00',3.59),('16100','2014-04-27','12:55:00',3.77),('16100','2014-04-27','13:00:00',4.34),('16100','2014-04-27','13:05:00',5.06),('16100','2014-04-27','13:10:00',5.03),('16100','2014-04-27','13:15:00',5.45),('16100','2014-04-27','13:20:00',6.09),('16100','2014-04-27','13:25:00',5.25),('16100','2014-04-27','13:30:00',4.39),('16100','2014-04-27','13:35:00',5.97),('16100','2014-04-27','13:40:00',4.8),('16100','2014-04-27','13:45:00',4.9),('16100','2014-04-27','13:50:00',3.97),('16100','2014-04-27','13:55:00',4.17),('16100','2014-04-27','14:00:00',5.21),('16100','2014-04-27','14:05:00',6.72),('16100','2014-04-27','14:10:00',3.94),('16100','2014-04-27','14:15:00',6.11),('16100','2014-04-27','14:20:00',8.31),('16100','2014-04-27','14:25:00',7),('16100','2014-04-27','14:30:00',3.72),('16100','2014-04-27','14:35:00',4.65),('16100','2014-04-27','14:40:00',3.06),('16100','2014-04-27','14:45:00',6.2),('16100','2014-04-27','14:50:00',2.52),('16100','2014-04-27','14:55:00',3.32),('16100','2014-04-27','15:00:00',7.47),('16100','2014-04-27','15:05:00',3.54),('16100','2014-04-27','15:10:00',7.41),('16100','2014-04-27','15:15:00',3.53),('16100','2014-04-27','15:20:00',2.3),('16100','2014-04-27','15:25:00',4),('16100','2014-04-27','15:30:00',3.67),('16100','2014-04-27','15:35:00',2.67),('16100','2014-04-27','15:40:00',6.74),('16100','2014-04-27','15:45:00',5.75),('16100','2014-04-27','15:50:00',1.7),('16100','2014-04-27','15:55:00',4.62),('16100','2014-04-27','16:00:00',2.56),('16100','2014-04-27','16:05:00',1.49),('16100','2014-04-27','16:10:00',1.69),('16100','2014-04-27','16:15:00',2.68),('16100','2014-04-27','16:20:00',3.04),('16100','2014-04-27','16:25:00',2.24),('16100','2014-04-27','16:30:00',5.19),('16100','2014-04-27','16:35:00',2.8),('16100','2014-04-27','16:40:00',1.29),('16100','2014-04-27','16:45:00',1.22),('16100','2014-04-27','16:50:00',1.84),('16100','2014-04-27','16:55:00',3.57),('16100','2014-04-27','17:00:00',3.24),('16100','2014-04-27','17:05:00',3.53),('16100','2014-04-27','17:10:00',1.36),('16100','2014-04-27','17:25:00',1.39),('16100','2014-04-27','17:30:00',1.09),('16100','2014-04-27','17:50:00',1.5),('16100','2014-04-27','17:55:00',1.12),('16100','2014-04-27','18:00:00',1.3),('16100','2014-04-27','18:10:00',1.23),('16100','2014-04-27','18:15:00',1.03),('16100','2014-04-27','18:20:00',1.01),('16100','2014-04-27','18:35:00',1.1),('16100','2014-02-14','08:00:00',1.03),('16100','2014-02-14','08:05:00',1.18),('16100','2014-02-14','08:10:00',1.35),('16100','2014-02-14','08:15:00',1.53),('16100','2014-02-14','08:20:00',1.71),('16100','2014-02-14','08:25:00',1.87),('16100','2014-02-14','08:30:00',2.06),('16100','2014-02-14','08:35:00',2.24),('16100','2014-02-14','08:40:00',2.42),('16100','2014-02-14','08:45:00',2.57),('16100','2014-02-14','08:50:00',2.72),('16100','2014-02-14','08:55:00',2.91),('16100','2014-02-14','09:00:00',3.05),('16100','2014-02-14','09:05:00',3.18),('16100','2014-02-14','09:10:00',3.33),('16100','2014-02-14','09:15:00',3.49),('16100','2014-02-14','09:20:00',3.62),('16100','2014-02-14','09:25:00',3.74),('16100','2014-02-14','09:30:00',3.86),('16100','2014-02-14','09:35:00',4.04),('16100','2014-02-14','09:40:00',4.18),('16100','2014-02-14','09:45:00',4.34),('16100','2014-02-14','09:50:00',4.45),('16100','2014-02-14','09:55:00',4.54),('16100','2014-02-14','10:00:00',4.63),('16100','2014-02-14','10:05:00',4.69),('16100','2014-02-14','10:10:00',4.83),('16100','2014-02-14','10:15:00',4.88),('16100','2014-02-14','10:20:00',5.06),('16100','2014-02-14','10:25:00',5.14),('16100','2014-02-14','10:30:00',5.19),('16100','2014-02-14','10:35:00',5.24),('16100','2014-02-14','10:40:00',5.35),('16100','2014-02-14','10:45:00',5.13),('16100','2014-02-14','10:50:00',5.47),('16100','2014-02-14','10:55:00',5.58),('16100','2014-02-14','11:00:00',5.59),('16100','2014-02-14','11:05:00',5.63),('16100','2014-02-14','11:10:00',5.61),('16100','2014-02-14','11:15:00',5.63),('16100','2014-02-14','11:20:00',5.72),('16100','2014-02-14','11:25:00',5.73),('16100','2014-02-14','11:30:00',5.78),('16100','2014-02-14','11:35:00',5.86),('16100','2014-02-14','11:40:00',5.89),('16100','2014-02-14','11:45:00',6.02),('16100','2014-02-14','11:50:00',6.15),('16100','2014-02-14','11:55:00',5.13),('16100','2014-02-14','12:00:00',2.69),('16100','2014-02-14','12:05:00',6.72),('16100','2014-02-14','12:10:00',6.55),('16100','2014-02-14','12:15:00',6.4),('16100','2014-02-14','12:20:00',6.48),('16100','2014-02-14','12:25:00',6.37),('16100','2014-02-14','12:30:00',6.38),('16100','2014-02-14','12:35:00',5.96),('16100','2014-02-14','12:40:00',4.6),('16100','2014-02-14','12:45:00',5.48),('16100','2014-02-14','12:50:00',6.44),('16100','2014-02-14','12:55:00',6.25),('16100','2014-02-14','13:00:00',6.22),('16100','2014-02-14','13:05:00',6.17),('16100','2014-02-14','13:10:00',6.23),('16100','2014-02-14','13:15:00',6.19),('16100','2014-02-14','13:20:00',6.22),('16100','2014-02-14','13:25:00',6.06),('16100','2014-02-14','13:30:00',6.01),('16100','2014-02-14','13:35:00',5.99),('16100','2014-02-14','13:40:00',5.83),('16100','2014-02-14','13:45:00',5.81),('16100','2014-02-14','13:50:00',5.73),('16100','2014-02-14','13:55:00',5.62),('16100','2014-02-14','14:00:00',5.6),('16100','2014-02-14','14:05:00',5.49),('16100','2014-02-14','14:10:00',5.4),('16100','2014-02-14','14:15:00',5.33),('16100','2014-02-14','14:20:00',5.22),('16100','2014-02-14','14:25:00',5.15),('16100','2014-02-14','14:30:00',5.03),('16100','2014-02-14','14:35:00',4.93),('16100','2014-02-14','14:40:00',4.88),('16100','2014-02-14','14:45:00',4.78),('16100','2014-02-14','14:50:00',4.68),('16100','2014-02-14','14:55:00',4.58),('16100','2014-02-14','15:00:00',4.43),('16100','2014-02-14','15:05:00',4.28),('16100','2014-02-14','15:10:00',4.18),('16100','2014-02-14','15:15:00',4.08),('16100','2014-02-14','15:20:00',3.95),('16100','2014-02-14','15:25:00',3.83),('16100','2014-02-14','15:30:00',3.72),('16100','2014-02-14','15:35:00',3.49),('16100','2014-02-14','15:40:00',3.39),('16100','2014-02-14','15:45:00',3.26),('16100','2014-02-14','15:50:00',3.15),('16100','2014-02-14','15:55:00',2.98),('16100','2014-02-14','16:00:00',2.76),('16100','2014-02-14','16:05:00',2.59),('16100','2014-02-14','16:10:00',2.4),('16100','2014-02-14','16:15:00',2.23),('16100','2014-02-14','16:20:00',2.09),('16100','2014-02-14','16:25:00',1.96),('16100','2014-02-14','16:30:00',1.81),('16100','2014-02-14','16:35:00',1.62),('16100','2014-02-14','16:40:00',1.45),('16100','2014-02-14','16:45:00',1.3),('16100','2014-02-14','16:50:00',1.12),('16100','2014-02-13','08:35:00',1.53),('16100','2014-02-13','08:40:00',2.34),('16100','2014-02-13','08:45:00',2.56),('16100','2014-02-13','08:50:00',2.7),('16100','2014-02-13','08:55:00',2.86),('16100','2014-02-13','09:00:00',3.03),('16100','2014-02-13','09:05:00',3.19),('16100','2014-02-13','09:10:00',3.37),('16100','2014-02-13','09:15:00',3.46),('16100','2014-02-13','09:20:00',3.22),('16100','2014-02-13','09:25:00',2.44),('16100','2014-02-13','09:30:00',2.65),('16100','2014-02-13','09:35:00',1.85),('16100','2014-02-13','09:40:00',2.89),('16100','2014-02-13','09:45:00',2.58),('16100','2014-02-13','09:50:00',2.25),('16100','2014-02-13','09:55:00',3.9),('16100','2014-02-13','10:00:00',2.11),('16100','2014-02-13','10:05:00',3.13),('16100','2014-02-13','10:10:00',4.75),('16100','2014-02-13','10:15:00',5.08),('16100','2014-02-13','10:20:00',5.19),('16100','2014-02-13','10:25:00',4.24),('16100','2014-02-13','10:30:00',5.65),('16100','2014-02-13','10:35:00',5.39),('16100','2014-02-13','10:40:00',5.55),('16100','2014-02-13','10:45:00',5.66),('16100','2014-02-13','10:50:00',5.96),('16100','2014-02-13','10:55:00',6.01),('16100','2014-02-13','11:00:00',6.11),('16100','2014-02-13','11:05:00',6.2),('16100','2014-02-13','11:10:00',6.22),('16100','2014-02-13','11:15:00',6.34),('16100','2014-02-13','11:20:00',5.79),('16100','2014-02-13','11:25:00',5.08),('16100','2014-02-13','11:30:00',6.49),('16100','2014-02-13','11:35:00',6.65),('16100','2014-02-13','11:40:00',6.54),('16100','2014-02-13','11:45:00',5.25),('16100','2014-02-13','11:50:00',6.38),('16100','2014-02-13','11:55:00',6.69),('16100','2014-02-13','12:00:00',6.73),('16100','2014-02-13','12:05:00',6.67),('16100','2014-02-13','12:10:00',6.55),('16100','2014-02-13','12:15:00',6.73),('16100','2014-02-13','12:20:00',6.67),('16100','2014-02-13','12:25:00',6.7),('16100','2014-02-13','12:30:00',6.66),('16100','2014-02-13','12:35:00',6.67),('16100','2014-02-13','12:40:00',6.68),('16100','2014-02-13','12:45:00',6.66),('16100','2014-02-13','12:50:00',6.63),('16100','2014-02-13','12:55:00',6.64),('16100','2014-02-13','13:00:00',6.67),('16100','2014-02-13','13:05:00',6.6),('16100','2014-02-13','13:10:00',6.59),('16100','2014-02-13','13:15:00',6.57),('16100','2014-02-13','13:20:00',6.54),('16100','2014-02-13','13:25:00',6.47),('16100','2014-02-13','13:30:00',6.44),('16100','2014-02-13','13:35:00',6.33),('16100','2014-02-13','13:40:00',6.17),('16100','2014-02-13','13:45:00',6.16),('16100','2014-02-13','13:50:00',6.03),('16100','2014-02-13','13:55:00',5.95),('16100','2014-02-13','14:00:00',5.9),('16100','2014-02-13','14:05:00',5.82),('16100','2014-02-13','14:10:00',5.75),('16100','2014-02-13','14:15:00',5.62),('16100','2014-02-13','14:20:00',5.47),('16100','2014-02-13','14:25:00',5.39),('16100','2014-02-13','14:30:00',5.31),('16100','2014-02-13','14:35:00',5.24),('16100','2014-02-13','14:40:00',5.17),('16100','2014-02-13','14:45:00',5.06),('16100','2014-02-13','14:50:00',4.9),('16100','2014-02-13','14:55:00',4.74),('16100','2014-02-13','15:00:00',4.57),('16100','2014-02-13','15:05:00',4.43),('16100','2014-02-13','15:10:00',4.32),('16100','2014-02-13','15:15:00',4.17),('16100','2014-02-13','15:20:00',4.05),('16100','2014-02-13','15:25:00',3.92),('16100','2014-02-13','15:30:00',3.78),('16100','2014-02-13','15:35:00',3.61),('16100','2014-02-13','15:40:00',3.47),('16100','2014-02-13','15:45:00',3.31),('16100','2014-02-13','15:50:00',3.16),('16100','2014-02-13','15:55:00',2.98),('16100','2014-02-13','16:00:00',2.8),('16100','2014-02-13','16:05:00',2.65),('16100','2014-02-13','16:10:00',2.43),('16100','2014-02-13','16:15:00',2.22),('16100','2014-02-13','16:20:00',2.04),('16100','2014-02-13','16:25:00',1.88),('16100','2014-02-13','16:30:00',1.73),('16100','2014-02-13','16:35:00',1.51),('16100','2014-02-13','16:40:00',1.33),('16100','2014-02-13','16:45:00',1.18),('16100','2014-02-13','16:50:00',1.01),('16100','2014-02-12','08:00:00',1.06),('16100','2014-02-12','08:05:00',1.21),('16100','2014-02-12','08:10:00',1.27),('16100','2014-02-12','08:15:00',1.48),('16100','2014-02-12','08:20:00',1.05),('16100','2014-02-12','08:25:00',1.69),('16100','2014-02-12','08:30:00',2.09),('16100','2014-02-12','08:35:00',2.25),('16100','2014-02-12','08:40:00',2.44),('16100','2014-02-12','08:45:00',2.61),('16100','2014-02-12','08:50:00',2.76),('16100','2014-02-12','08:55:00',2.91),('16100','2014-02-12','09:00:00',3.11),('16100','2014-02-12','09:05:00',3.3),('16100','2014-02-12','09:10:00',3.46),('16100','2014-02-12','09:15:00',3.57),('16100','2014-02-12','09:20:00',3.73),('16100','2014-02-12','09:25:00',3.89),('16100','2014-02-12','09:30:00',3.95),('16100','2014-02-12','09:35:00',4.09),('16100','2014-02-12','09:40:00',4.22),('16100','2014-02-12','09:45:00',4.35),('16100','2014-02-12','09:50:00',4.51),('16100','2014-02-12','09:55:00',4.64),('16100','2014-02-12','10:00:00',4.79),('16100','2014-02-12','10:05:00',4.91),('16100','2014-02-12','10:10:00',5.01),('16100','2014-02-12','10:15:00',5.07),('16100','2014-02-12','10:20:00',5.17),('16100','2014-02-12','10:25:00',5.3),('16100','2014-02-12','10:30:00',5.42),('16100','2014-02-12','10:35:00',5.52),('16100','2014-02-12','10:40:00',5.59),('16100','2014-02-12','10:45:00',5.69),('16100','2014-02-12','10:50:00',5.71),('16100','2014-02-12','10:55:00',5.72),('16100','2014-02-12','11:00:00',5.79),('16100','2014-02-12','11:05:00',5.96),('16100','2014-02-12','11:10:00',4.89),('16100','2014-02-12','11:15:00',3.17),('16100','2014-02-12','11:20:00',6.3),('16100','2014-02-12','11:25:00',6.35),('16100','2014-02-12','11:30:00',6.4),('16100','2014-02-12','11:35:00',5.91),('16100','2014-02-12','11:40:00',6.61),('16100','2014-02-12','11:45:00',6.59),('16100','2014-02-12','11:50:00',6.79),('16100','2014-02-12','11:55:00',6.67),('16100','2014-02-12','12:00:00',6.67),('16100','2014-02-12','12:05:00',6.64),('16100','2014-02-12','12:10:00',6.65),('16100','2014-02-12','12:15:00',7.1),('16100','2014-02-12','12:20:00',6.91),('16100','2014-02-12','12:25:00',5.9),('16100','2014-02-12','12:30:00',7.25),('16100','2014-02-12','12:35:00',7.06),('16100','2014-02-12','12:40:00',6.96),('16100','2014-02-12','12:45:00',3.12),('16100','2014-02-12','12:50:00',6.91),('16100','2014-02-12','12:55:00',5.7),('16100','2014-02-12','13:00:00',6.8),('16100','2014-02-12','13:05:00',6.69),('16100','2014-02-12','13:10:00',6.64),('16100','2014-02-12','13:15:00',6.56),('16100','2014-02-12','13:20:00',6.43),('16100','2014-02-12','13:25:00',6.39),('16100','2014-02-12','13:30:00',6.3),('16100','2014-02-12','13:35:00',6.27),('16100','2014-02-12','13:40:00',6.11),('16100','2014-02-12','13:45:00',6.05),('16100','2014-02-12','13:50:00',6.08),('16100','2014-02-12','13:55:00',5.7),('16100','2014-02-12','14:00:00',5.97),('16100','2014-02-12','14:05:00',5.89),('16100','2014-02-12','14:10:00',5.74),('16100','2014-02-12','14:15:00',3.96),('16100','2014-02-12','14:20:00',5.68),('16100','2014-02-12','14:25:00',5.5),('16100','2014-02-12','14:30:00',5.29),('16100','2014-02-12','14:35:00',2),('16100','2014-02-12','14:40:00',1.62),('16100','2014-02-12','14:45:00',1.69),('16100','2014-02-12','14:50:00',5.24),('16100','2014-02-12','14:55:00',5.24),('16100','2014-02-12','15:00:00',4.52),('16100','2014-02-12','15:05:00',4.66),('16100','2014-02-12','15:10:00',5.13),('16100','2014-02-12','15:15:00',3.62),('16100','2014-02-12','15:20:00',4.44),('16100','2014-02-12','15:25:00',4.46),('16100','2014-02-12','15:30:00',2.7),('16100','2014-02-12','15:35:00',3.89),('16100','2014-02-12','15:40:00',2.74),('16100','2014-02-12','15:45:00',3.74),('16100','2014-02-12','15:50:00',3.19),('16100','2014-02-12','15:55:00',3.29),('16100','2014-02-12','16:00:00',3.02),('16100','2014-02-12','16:05:00',2.76),('16100','2014-02-12','16:10:00',2.52),('16100','2014-02-12','16:15:00',1.37),('16100','2014-02-12','16:30:00',1.37),('16100','2014-02-11','08:05:00',1.01),('16100','2014-02-11','08:10:00',1.2),('16100','2014-02-11','08:15:00',1.36),('16100','2014-02-11','08:20:00',1.37),('16100','2014-02-11','08:25:00',1.11),('16100','2014-02-11','08:30:00',1.73),('16100','2014-02-11','08:35:00',2.18),('16100','2014-02-11','08:40:00',1.88),('16100','2014-02-11','08:45:00',2.54),('16100','2014-02-11','08:50:00',2.69),('16100','2014-02-11','08:55:00',2.96),('16100','2014-02-11','09:00:00',3.01),('16100','2014-02-11','09:05:00',2.83),('16100','2014-02-11','09:10:00',3.49),('16100','2014-02-11','09:15:00',3.63),('16100','2014-02-11','09:20:00',3.79),('16100','2014-02-11','09:25:00',4.12),('16100','2014-02-11','09:30:00',1.16),('16100','2014-02-11','09:35:00',1.67),('16100','2014-02-11','09:40:00',1.69),('16100','2014-02-11','09:45:00',3.82),('16100','2014-02-11','09:50:00',2.58),('16100','2014-02-11','09:55:00',2.41),('16100','2014-02-11','10:00:00',2.81),('16100','2014-02-11','10:05:00',2.35),('16100','2014-02-11','10:10:00',1.78),('16100','2014-02-11','10:15:00',1.71),('16100','2014-02-11','10:20:00',1.83),('16100','2014-02-11','10:25:00',2.51),('16100','2014-02-11','10:30:00',2.24),('16100','2014-02-11','10:35:00',2.11),('16100','2014-02-11','10:40:00',2.95),('16100','2014-02-11','10:45:00',2.41),('16100','2014-02-11','10:50:00',3.65),('16100','2014-02-11','10:55:00',2.02),('16100','2014-02-11','11:00:00',2),('16100','2014-02-11','11:05:00',2.14),('16100','2014-02-11','11:10:00',2.16),('16100','2014-02-11','11:15:00',2.65),('16100','2014-02-11','11:20:00',3.33),('16100','2014-02-11','11:25:00',4.54),('16100','2014-02-11','11:30:00',2.44),('16100','2014-02-11','11:35:00',2.66),('16100','2014-02-11','11:40:00',5.81),('16100','2014-02-11','11:45:00',2.51),('16100','2014-02-11','11:50:00',6.3),('16100','2014-02-11','11:55:00',3.3),('16100','2014-02-11','12:00:00',3.83),('16100','2014-02-11','12:05:00',2.75),('16100','2014-02-11','12:10:00',2.18),('16100','2014-02-11','12:15:00',1.94),('16100','2014-02-11','12:20:00',1.86),('16100','2014-02-11','12:25:00',1.92),('16100','2014-02-11','12:30:00',2.05),('16100','2014-02-11','12:35:00',2.13),('16100','2014-02-11','12:40:00',2.17),('16100','2014-02-11','12:45:00',2.35),('16100','2014-02-11','12:50:00',2.83),('16100','2014-02-11','12:55:00',3.1),('16100','2014-02-11','13:00:00',3.65),('16100','2014-02-11','13:05:00',3.25),('16100','2014-02-11','13:10:00',2.99),('16100','2014-02-11','13:15:00',3.76),('16100','2014-02-11','13:20:00',3.11),('16100','2014-02-11','13:25:00',6.19),('16100','2014-02-11','13:30:00',3.48),('16100','2014-02-11','13:35:00',3.07),('16100','2014-02-11','13:40:00',2.45),('16100','2014-02-11','13:45:00',2.49),('16100','2014-02-11','13:50:00',2.31),('16100','2014-02-11','13:55:00',2.79),('16100','2014-02-11','14:00:00',2.89),('16100','2014-02-11','14:05:00',6.18),('16100','2014-02-11','14:10:00',6.1),('16100','2014-02-11','14:15:00',5.66),('16100','2014-02-11','14:20:00',5.72),('16100','2014-02-11','14:25:00',3.58),('16100','2014-02-11','14:30:00',6.04),('16100','2014-02-11','14:35:00',5.7),('16100','2014-02-11','14:40:00',5.43),('16100','2014-02-11','14:45:00',5.22),('16100','2014-02-11','14:50:00',5.17),('16100','2014-02-11','14:55:00',3.69),('16100','2014-02-11','15:00:00',2.23),('16100','2014-02-11','15:05:00',1.84),('16100','2014-02-11','15:10:00',2.33),('16100','2014-02-11','15:15:00',3.39),('16100','2014-02-11','15:20:00',2.83),('16100','2014-02-11','15:25:00',4.74),('16100','2014-02-11','15:30:00',4.23),('16100','2014-02-11','15:35:00',3.93),('16100','2014-02-11','15:40:00',3.35),('16100','2014-02-11','15:45:00',4.28),('16100','2014-02-11','15:50:00',3.09),('16100','2014-02-11','15:55:00',2.16),('16100','2014-02-11','16:00:00',2.98),('16100','2014-02-11','16:05:00',2.32),('16100','2014-02-11','16:10:00',1.76),('16100','2014-02-11','16:15:00',1.74),('16100','2014-02-11','16:20:00',1.85),('16100','2014-02-11','16:25:00',1.28),('16100','2014-02-10','09:10:00',1.01),('16100','2014-02-10','09:15:00',1.19),('16100','2014-02-10','09:20:00',1.45),('16100','2014-02-10','09:25:00',1.79),('16100','2014-02-10','09:30:00',2.09),('16100','2014-02-10','09:35:00',1.91),('16100','2014-02-10','09:40:00',1.76),('16100','2014-02-10','09:45:00',2.01),('16100','2014-02-10','09:50:00',2.18),('16100','2014-02-10','09:55:00',1.83),('16100','2014-02-10','10:00:00',1.75),('16100','2014-02-10','10:05:00',1.72),('16100','2014-02-10','10:10:00',1.96),('16100','2014-02-10','10:15:00',2.38),('16100','2014-02-10','10:20:00',3.03),('16100','2014-02-10','10:25:00',3.62),('16100','2014-02-10','10:30:00',3.78),('16100','2014-02-10','10:35:00',4.05),('16100','2014-02-10','10:40:00',3.4),('16100','2014-02-10','10:45:00',3.79),('16100','2014-02-10','10:50:00',3.91),('16100','2014-02-10','10:55:00',3.81),('16100','2014-02-10','11:00:00',3.69),('16100','2014-02-10','11:05:00',4.33),('16100','2014-02-10','11:10:00',4.31),('16100','2014-02-10','11:15:00',3.68),('16100','2014-02-10','11:20:00',3.56),('16100','2014-02-10','11:25:00',4.19),('16100','2014-02-10','11:30:00',3.58),('16100','2014-02-10','11:35:00',3.77),('16100','2014-02-10','11:40:00',4.9),('16100','2014-02-10','11:45:00',4.61),('16100','2014-02-10','11:50:00',4.2),('16100','2014-02-10','11:55:00',3.47),('16100','2014-02-10','12:00:00',2.77),('16100','2014-02-10','12:05:00',2.99),('16100','2014-02-10','12:10:00',4.05),('16100','2014-02-10','12:15:00',3.53),('16100','2014-02-10','12:20:00',2.59),('16100','2014-02-10','12:25:00',3.1),('16100','2014-02-10','12:30:00',3.82),('16100','2014-02-10','12:35:00',4.12),('16100','2014-02-10','12:40:00',2.84),('16100','2014-02-10','12:45:00',2.95),('16100','2014-02-10','12:50:00',3.14),('16100','2014-02-10','12:55:00',2.5),('16100','2014-02-10','13:00:00',4.06),('16100','2014-02-10','13:05:00',3.35),('16100','2014-02-10','13:10:00',5.89),('16100','2014-02-10','13:15:00',6.12),('16100','2014-02-10','13:20:00',6.19),('16100','2014-02-10','13:25:00',5.25),('16100','2014-02-10','13:30:00',4.86),('16100','2014-02-10','13:35:00',4.68),('16100','2014-02-10','13:40:00',5.39),('16100','2014-02-10','13:45:00',3.91),('16100','2014-02-10','13:50:00',4.26),('16100','2014-02-10','13:55:00',2.43),('16100','2014-02-10','14:00:00',2.19),('16100','2014-02-10','14:05:00',2.8),('16100','2014-02-10','14:10:00',3.4),('16100','2014-02-10','14:15:00',2.67),('16100','2014-02-10','14:20:00',3.09),('16100','2014-02-10','14:25:00',2.62),('16100','2014-02-10','14:30:00',2.67),('16100','2014-02-10','14:35:00',2.08),('16100','2014-02-10','14:40:00',1.77),('16100','2014-02-10','14:45:00',1.59),('16100','2014-02-10','14:50:00',1.45),('16100','2014-02-10','14:55:00',1.37),('16100','2014-02-10','15:00:00',1.46),('16100','2014-02-10','15:05:00',1.57),('16100','2014-02-10','15:10:00',2.34),('16100','2014-02-10','15:15:00',2.19),('16100','2014-02-10','15:20:00',2.62),('16100','2014-02-10','15:25:00',1.71),('16100','2014-02-10','15:30:00',1.52),('16100','2014-02-10','15:35:00',1.24),('16100','2014-02-10','15:40:00',1.27),('16100','2014-02-10','15:55:00',1.03),('16100','2014-02-10','16:05:00',1.06),('16100','2014-02-10','16:10:00',1.66),('16100','2014-02-10','16:15:00',1.83),('16100','2014-02-10','16:20:00',1.56),('16100','2014-02-10','16:25:00',1.48),('16100','2014-02-10','16:30:00',1.4),('16100','2014-02-10','16:35:00',1.31),('16100','2014-02-10','16:40:00',1.18),('16100','2014-02-09','12:25:00',1.2),('16100','2014-02-09','12:30:00',1.13),('16100','2014-02-09','12:50:00',1.01),('16100','2014-02-09','12:55:00',1.49),('16100','2014-02-09','13:00:00',1.68),('16100','2014-02-09','13:05:00',1.4),('16100','2014-02-09','13:10:00',1.13),('16100','2014-02-09','13:15:00',1.19),('16100','2014-02-09','13:30:00',1.07),('16100','2014-02-09','13:35:00',1.2),('16100','2014-02-09','13:40:00',1.21),('16100','2014-02-09','13:45:00',1.21),('16100','2014-02-09','13:50:00',1.16),('16100','2014-02-09','13:55:00',1.29),('16100','2014-02-09','14:00:00',1.37),('16100','2014-02-09','14:05:00',1.2),('16100','2014-02-09','14:10:00',1.22),('16100','2014-02-09','14:15:00',1.18),('16100','2014-02-09','14:20:00',1.24),('16100','2014-02-09','14:25:00',1.28),('16100','2014-02-09','14:30:00',1.39),('16100','2014-02-09','14:35:00',1.51),('16100','2014-02-09','14:40:00',1.62),('16100','2014-02-09','14:45:00',1.52),('16100','2014-02-09','14:50:00',1.27),('16100','2014-02-09','14:55:00',1.08),('16100','2014-02-09','15:00:00',1.11),('16100','2014-02-09','15:05:00',1.24),('16100','2014-02-09','15:10:00',1.2),('16100','2014-02-09','15:15:00',1),('16100','2014-02-09','15:25:00',1.18),('16100','2014-02-09','15:30:00',1.17),('16100','2014-02-08','11:25:00',1.5),('16100','2014-02-08','11:30:00',1.49),('16100','2014-02-08','11:35:00',1.52),('16100','2014-02-08','12:05:00',1.28),('16100','2014-02-08','12:10:00',1.34),('16100','2014-02-08','12:20:00',2.1),('16100','2014-02-08','12:25:00',1.4),('16100','2014-02-08','12:30:00',1.47),('16100','2014-02-08','12:35:00',1.29),('16100','2014-02-08','12:40:00',2.34),('16100','2014-02-08','12:45:00',1.36),('16100','2014-02-08','12:50:00',1.08),('16100','2014-02-08','12:55:00',2.67),('16100','2014-02-08','13:00:00',3.44),('16100','2014-02-08','13:05:00',1.73),('16100','2014-02-08','13:10:00',1.72),('16100','2014-02-08','13:15:00',1.88),('16100','2014-02-08','13:20:00',2.57),('16100','2014-02-08','13:25:00',1.87),('16100','2014-02-08','13:30:00',1.13),('16100','2014-02-08','13:35:00',4.44),('16100','2014-02-08','13:40:00',3.54),('16100','2014-02-08','13:45:00',4.75),('16100','2014-02-08','13:50:00',4.28),('16100','2014-02-08','13:55:00',6.1),('16100','2014-02-08','14:00:00',6.09),('16100','2014-02-08','14:05:00',2.81),('16100','2014-02-08','14:10:00',2.15),('16100','2014-02-08','14:15:00',1.8),('16100','2014-02-08','14:20:00',3.45),('16100','2014-02-08','14:25:00',4.87),('16100','2014-02-08','14:30:00',4.46),('16100','2014-02-08','14:35:00',2.49),('16100','2014-02-08','14:40:00',2.52),('16100','2014-02-08','14:45:00',1.6),('16100','2014-02-08','14:50:00',1.79),('16100','2014-02-08','14:55:00',4.07),('16100','2014-02-08','15:00:00',1.48),('16100','2014-02-08','15:05:00',3.32),('16100','2014-02-08','15:10:00',3.96),('16100','2014-02-08','15:15:00',2.43),('16100','2014-02-08','15:20:00',2.39),('16100','2014-02-08','15:25:00',2.99),('16100','2014-02-08','15:30:00',3.21),('16100','2014-02-08','15:35:00',2.99),('16100','2014-02-08','15:40:00',2.88),('16100','2014-02-08','15:45:00',2.8),('16100','2014-02-08','15:50:00',2.62),('16100','2014-02-08','15:55:00',2.4),('16100','2014-02-08','16:00:00',2.32),('16100','2014-02-08','16:05:00',2.2),('16100','2014-02-08','16:10:00',1.97),('16100','2014-02-08','16:15:00',1.58),('16100','2014-02-08','16:20:00',1.55),('16100','2014-02-08','16:35:00',1.13),('16100','2014-02-07','09:40:00',1.24),('16100','2014-02-07','09:45:00',1.06),('16100','2014-02-07','09:50:00',2.37),('16100','2014-02-07','09:55:00',4.84),('16100','2014-02-07','10:00:00',4.82),('16100','2014-02-07','10:05:00',4.46),('16100','2014-02-07','10:10:00',4.99),('16100','2014-02-07','10:15:00',5.28),('16100','2014-02-07','10:20:00',4.92),('16100','2014-02-07','10:25:00',3.46),('16100','2014-02-07','10:30:00',3.36),('16100','2014-02-07','10:35:00',3.31),('16100','2014-02-07','10:40:00',1.42),('16100','2014-02-07','10:45:00',2.09),('16100','2014-02-07','10:50:00',2.29),('16100','2014-02-07','10:55:00',6.03),('16100','2014-02-07','11:00:00',2.74),('16100','2014-02-07','11:05:00',6.86),('16100','2014-02-07','11:10:00',5.69),('16100','2014-02-07','11:15:00',2.41),('16100','2014-02-07','11:20:00',2.12),('16100','2014-02-07','11:25:00',3.55),('16100','2014-02-07','11:30:00',2.06),('16100','2014-02-07','11:35:00',4.52),('16100','2014-02-07','11:40:00',1.86),('16100','2014-02-07','11:45:00',1.3),('16100','2014-02-07','11:55:00',6.56),('16100','2014-02-07','12:00:00',7.34),('16100','2014-02-07','12:05:00',3.43),('16100','2014-02-07','12:10:00',3.41),('16100','2014-02-07','12:15:00',6.75),('16100','2014-02-07','12:20:00',1.59),('16100','2014-02-07','12:25:00',6.04),('16100','2014-02-07','12:30:00',6.17),('16100','2014-02-07','12:35:00',4.22),('16100','2014-02-07','12:40:00',2.35),('16100','2014-02-07','12:45:00',4.79),('16100','2014-02-07','12:50:00',3.58),('16100','2014-02-07','12:55:00',6.97),('16100','2014-02-07','13:00:00',5.48),('16100','2014-02-07','13:05:00',2.24),('16100','2014-02-07','13:10:00',4.32),('16100','2014-02-07','13:15:00',2.67),('16100','2014-02-07','13:20:00',6.84),('16100','2014-02-07','13:25:00',6.91),('16100','2014-02-07','13:30:00',6.41),('16100','2014-02-07','13:35:00',2.29),('16100','2014-02-07','13:40:00',4.59),('16100','2014-02-07','13:45:00',6.59),('16100','2014-02-07','13:50:00',4.02),('16100','2014-02-07','13:55:00',4.16),('16100','2014-02-07','14:00:00',5.82),('16100','2014-02-07','14:05:00',3.34),('16100','2014-02-07','14:10:00',2.57),('16100','2014-02-07','14:15:00',3.25),('16100','2014-02-07','14:20:00',2.43),('16100','2014-02-07','14:25:00',3.46),('16100','2014-02-07','14:30:00',3.11),('16100','2014-02-07','14:35:00',3.39),('16100','2014-02-07','14:40:00',5.02),('16100','2014-02-07','14:45:00',2.96),('16100','2014-02-07','14:50:00',2.67),('16100','2014-02-07','14:55:00',3.2),('16100','2014-02-07','15:00:00',1.31),('16100','2014-02-07','15:05:00',4.31),('16100','2014-02-07','15:10:00',2.28),('16100','2014-02-07','15:15:00',2.64),('16100','2014-02-07','15:20:00',2.72),('16100','2014-02-07','15:25:00',4.64),('16100','2014-02-07','15:30:00',2.17),('16100','2014-02-07','15:45:00',2.04),('16100','2014-02-07','15:50:00',2.72),('16100','2014-02-07','15:55:00',3.17),('16100','2014-02-07','16:00:00',2.46),('16100','2014-02-07','16:05:00',1.7),('16100','2014-02-07','16:10:00',1.4),('16100','2014-02-07','16:35:00',1.11),('16100','2014-02-07','16:40:00',1.07),('16100','2014-02-06','08:05:00',1.23),('16100','2014-02-06','08:10:00',1.45),('16100','2014-02-06','08:15:00',1.58),('16100','2014-02-06','08:20:00',1.89),('16100','2014-02-06','08:25:00',1.86),('16100','2014-02-06','08:30:00',1.86),('16100','2014-02-06','08:35:00',1.97),('16100','2014-02-06','08:40:00',2.13),('16100','2014-02-06','08:45:00',2.32),('16100','2014-02-06','08:50:00',2.5),('16100','2014-02-06','08:55:00',2.7),('16100','2014-02-06','09:00:00',2.87),('16100','2014-02-06','09:05:00',3.03),('16100','2014-02-06','09:10:00',3.17),('16100','2014-02-06','09:15:00',3.31),('16100','2014-02-06','09:20:00',3.44),('16100','2014-02-06','09:25:00',3.58),('16100','2014-02-06','09:30:00',3.72),('16100','2014-02-06','09:35:00',3.86),('16100','2014-02-06','09:40:00',3.98),('16100','2014-02-06','09:45:00',4.09),('16100','2014-02-06','09:50:00',4.2),('16100','2014-02-06','09:55:00',4.26),('16100','2014-02-06','10:00:00',4.36),('16100','2014-02-06','10:05:00',4.4),('16100','2014-02-06','10:10:00',4.48),('16100','2014-02-06','10:15:00',4.58),('16100','2014-02-06','10:20:00',4.67),('16100','2014-02-06','10:25:00',4.33),('16100','2014-02-06','10:30:00',3.59),('16100','2014-02-06','10:35:00',3.16),('16100','2014-02-06','10:40:00',2.87),('16100','2014-02-06','10:45:00',1.39),('16100','2014-02-06','10:50:00',6.08),('16100','2014-02-06','10:55:00',5.53),('16100','2014-02-06','11:00:00',5.87),('16100','2014-02-06','11:05:00',5.69),('16100','2014-02-06','11:10:00',4.71),('16100','2014-02-06','11:15:00',2.04),('16100','2014-02-06','11:20:00',3.37),('16100','2014-02-06','11:25:00',2.59),('16100','2014-02-06','11:30:00',5.96),('16100','2014-02-06','11:35:00',6.02),('16100','2014-02-06','11:40:00',3.6),('16100','2014-02-06','11:45:00',1.99),('16100','2014-02-06','11:50:00',6.35),('16100','2014-02-06','11:55:00',3.89),('16100','2014-02-06','12:00:00',2.48),('16100','2014-02-06','12:05:00',2.86),('16100','2014-02-06','12:10:00',4.58),('16100','2014-02-06','12:15:00',5.6),('16100','2014-02-06','12:20:00',6.8),('16100','2014-02-06','12:25:00',6.76),('16100','2014-02-06','12:30:00',6.59),('16100','2014-02-06','12:35:00',7.11),('16100','2014-02-06','12:40:00',6.39),('16100','2014-02-06','12:45:00',6.96),('16100','2014-02-06','12:50:00',5.29),('16100','2014-02-06','12:55:00',6.43),('16100','2014-02-06','13:00:00',5.88),('16100','2014-02-06','13:05:00',6.09),('16100','2014-02-06','13:10:00',6.82),('16100','2014-02-06','13:15:00',6.61),('16100','2014-02-06','13:20:00',6.5),('16100','2014-02-06','13:25:00',6.41),('16100','2014-02-06','13:30:00',6.42),('16100','2014-02-06','13:35:00',5.4),('16100','2014-02-06','13:40:00',6.15),('16100','2014-02-06','13:45:00',6.04),('16100','2014-02-06','13:50:00',5.9),('16100','2014-02-06','13:55:00',5.51),('16100','2014-02-06','14:00:00',5.7),('16100','2014-02-06','14:05:00',5.56),('16100','2014-02-06','14:10:00',5.3),('16100','2014-02-06','14:15:00',4.26),('16100','2014-02-06','14:20:00',4.77),('16100','2014-02-06','14:25:00',5.18),('16100','2014-02-06','14:30:00',5.18),('16100','2014-02-06','14:35:00',5.09),('16100','2014-02-06','14:40:00',4.95),('16100','2014-02-06','14:45:00',4.33),('16100','2014-02-06','14:50:00',4.83),('16100','2014-02-06','14:55:00',3.53),('16100','2014-02-06','15:00:00',4.5),('16100','2014-02-06','15:05:00',4.31),('16100','2014-02-06','15:10:00',4.37),('16100','2014-02-06','15:15:00',4.2),('16100','2014-02-06','15:20:00',3.61),('16100','2014-02-06','15:25:00',3.69),('16100','2014-02-06','15:30:00',3.59),('16100','2014-02-06','15:35:00',3.44),('16100','2014-02-06','15:40:00',3.3),('16100','2014-02-06','15:45:00',3.1),('16100','2014-02-06','15:50:00',2.98),('16100','2014-02-06','15:55:00',2.76),('16100','2014-02-06','16:00:00',2.57),('16100','2014-02-06','16:05:00',2.47),('16100','2014-02-06','16:10:00',2.34),('16100','2014-02-06','16:15:00',2.2),('16100','2014-02-06','16:20:00',2.09),('16100','2014-02-06','16:25:00',1.8),('16100','2014-02-06','16:30:00',1.59),('16100','2014-02-06','16:35:00',1.41),('16100','2014-02-06','16:40:00',1.24),('16100','2014-02-06','16:45:00',1.05),('16100','2014-02-05','08:15:00',1.11),('16100','2014-02-05','08:20:00',1.26),('16100','2014-02-05','08:25:00',1.15),('16100','2014-02-05','08:30:00',1.52),('16100','2014-02-05','08:35:00',1.97),('16100','2014-02-05','08:40:00',2.19),('16100','2014-02-05','08:45:00',2.35),('16100','2014-02-05','08:50:00',2.82),('16100','2014-02-05','08:55:00',3.33),('16100','2014-02-05','09:00:00',3.34),('16100','2014-02-05','09:05:00',1.72),('16100','2014-02-05','09:10:00',1.45),('16100','2014-02-05','09:15:00',2.74),('16100','2014-02-05','09:20:00',1.5),('16100','2014-02-05','09:25:00',2.38),('16100','2014-02-05','09:30:00',3.85),('16100','2014-02-05','09:35:00',1.92),('16100','2014-02-05','09:40:00',3.37),('16100','2014-02-05','09:45:00',4.26),('16100','2014-02-05','09:50:00',4.33),('16100','2014-02-05','09:55:00',4.47),('16100','2014-02-05','10:00:00',4.59),('16100','2014-02-05','10:05:00',4.69),('16100','2014-02-05','10:10:00',4.83),('16100','2014-02-05','10:15:00',5.01),('16100','2014-02-05','10:20:00',5.14),('16100','2014-02-05','10:25:00',5.3),('16100','2014-02-05','10:30:00',5.21),('16100','2014-02-05','10:35:00',3.19),('16100','2014-02-05','10:40:00',4.25),('16100','2014-02-05','10:45:00',5.74),('16100','2014-02-05','10:50:00',3.93),('16100','2014-02-05','10:55:00',6.1),('16100','2014-02-05','11:00:00',6.09),('16100','2014-02-05','11:05:00',5.99),('16100','2014-02-05','11:10:00',4.34),('16100','2014-02-05','11:15:00',6.37),('16100','2014-02-05','11:20:00',6.28),('16100','2014-02-05','11:25:00',6.28),('16100','2014-02-05','11:30:00',6.32),('16100','2014-02-05','11:35:00',6.29),('16100','2014-02-05','11:40:00',6.38),('16100','2014-02-05','11:45:00',6.34),('16100','2014-02-05','11:50:00',5.28),('16100','2014-02-05','11:55:00',6.56),('16100','2014-02-05','12:00:00',6.53),('16100','2014-02-05','12:05:00',6.66),('16100','2014-02-05','12:10:00',5.15),('16100','2014-02-05','12:15:00',6.78),('16100','2014-02-05','12:20:00',6.6),('16100','2014-02-05','12:25:00',6.56),('16100','2014-02-05','12:30:00',6.58),('16100','2014-02-05','12:35:00',6.52),('16100','2014-02-05','12:40:00',6.13),('16100','2014-02-05','12:45:00',6.55),('16100','2014-02-05','12:50:00',6.48),('16100','2014-02-05','12:55:00',4.77),('16100','2014-02-05','13:00:00',6.47),('16100','2014-02-05','13:05:00',6.46),('16100','2014-02-05','13:10:00',6.43),('16100','2014-02-05','13:15:00',6.36),('16100','2014-02-05','13:20:00',6.32),('16100','2014-02-05','13:25:00',6.34),('16100','2014-02-05','13:30:00',6.26),('16100','2014-02-05','13:35:00',6.13),('16100','2014-02-05','13:40:00',6.1),('16100','2014-02-05','13:45:00',5.95),('16100','2014-02-05','13:50:00',5.83),('16100','2014-02-05','13:55:00',5.16),('16100','2014-02-05','14:00:00',5.72),('16100','2014-02-05','14:05:00',5.66),('16100','2014-02-05','14:10:00',5.47),('16100','2014-02-05','14:15:00',5.43),('16100','2014-02-05','14:20:00',5.38),('16100','2014-02-05','14:25:00',5.22),('16100','2014-02-05','14:30:00',5.08),('16100','2014-02-05','14:35:00',5.11),('16100','2014-02-05','14:40:00',4.95),('16100','2014-02-05','14:45:00',4.08),('16100','2014-02-05','14:50:00',4.01),('16100','2014-02-05','14:55:00',4.51),('16100','2014-02-05','15:00:00',4.42),('16100','2014-02-05','15:05:00',4.27),('16100','2014-02-05','15:10:00',4.16),('16100','2014-02-05','15:15:00',4.05),('16100','2014-02-05','15:20:00',3.87),('16100','2014-02-05','15:25:00',3.67),('16100','2014-02-05','15:30:00',3.54),('16100','2014-02-05','15:35:00',3.35),('16100','2014-02-05','15:40:00',3.27),('16100','2014-02-05','15:45:00',3.1),('16100','2014-02-05','15:50:00',2.96),('16100','2014-02-05','15:55:00',2.8),('16100','2014-02-05','16:00:00',2.62),('16100','2014-02-05','16:05:00',2.46),('16100','2014-02-05','16:10:00',2.28),('16100','2014-02-05','16:15:00',2.08),('16100','2014-02-05','16:20:00',1.89),('16100','2014-02-05','16:25:00',1.7),('16100','2014-02-05','16:30:00',1.54),('16100','2014-02-05','16:35:00',1.38),('16100','2014-02-05','16:40:00',1.2),('16100','2014-02-05','16:45:00',1.02),('16100','2014-04-26','08:35:00',1.12),('16100','2014-04-26','08:40:00',1.17),('16100','2014-04-26','08:45:00',1.6),('16100','2014-04-26','08:50:00',1.03),('16100','2014-04-26','09:00:00',1.3),('16100','2014-04-26','09:05:00',1.74),('16100','2014-04-26','09:10:00',1.78),('16100','2014-04-26','09:15:00',1.61),('16100','2014-04-26','09:50:00',1.15),('16100','2014-04-26','09:55:00',1.42),('16100','2014-04-26','10:00:00',1.91),('16100','2014-04-26','10:05:00',1.78),('16100','2014-04-26','10:10:00',2.39),('16100','2014-04-26','10:15:00',3.02),('16100','2014-04-26','10:20:00',3.39),('16100','2014-04-26','10:25:00',2.53),('16100','2014-04-26','10:35:00',1.08),('16100','2014-04-26','10:40:00',1.19),('16100','2014-04-26','10:45:00',1.33),('16100','2014-04-26','10:50:00',1.29),('16100','2014-04-26','10:55:00',1.56),('16100','2014-04-26','11:00:00',1.32),('16100','2014-04-26','11:05:00',1.15),('16100','2014-04-26','11:10:00',1.47),('16100','2014-04-26','11:15:00',1.11),('16100','2014-04-26','11:20:00',1.53),('16100','2014-04-26','11:25:00',2.36),('16100','2014-04-26','11:30:00',4.05),('16100','2014-04-26','11:35:00',4.69),('16100','2014-04-26','11:40:00',3.03),('16100','2014-04-26','11:45:00',2.86),('16100','2014-04-26','11:50:00',2.24),('16100','2014-04-26','11:55:00',3.26),('16100','2014-04-26','12:00:00',1.91),('16100','2014-04-26','12:05:00',1.1),('16100','2014-04-26','12:10:00',1.21),('16100','2014-04-26','12:15:00',2.26),('16100','2014-04-26','12:20:00',3.41),('16100','2014-04-26','12:25:00',4.51),('16100','2014-04-26','12:30:00',5.79),('16100','2014-04-26','12:35:00',4.59),('16100','2014-04-26','12:40:00',4.41),('16100','2014-04-26','12:45:00',3.56),('16100','2014-04-26','12:50:00',4.02),('16100','2014-04-26','12:55:00',3.4),('16100','2014-04-26','13:00:00',2.84),('16100','2014-04-26','13:05:00',3.25),('16100','2014-04-26','13:10:00',2.9),('16100','2014-04-26','13:15:00',3.02),('16100','2014-04-26','13:20:00',3.33),('16100','2014-04-26','13:25:00',3.87),('16100','2014-04-26','13:30:00',3.41),('16100','2014-04-26','13:35:00',2.84),('16100','2014-04-26','13:40:00',2.66),('16100','2014-04-26','13:45:00',2.89),('16100','2014-04-26','13:50:00',3.44),('16100','2014-04-26','13:55:00',4.01),('16100','2014-04-26','14:00:00',4.02),('16100','2014-04-26','14:05:00',3.84),('16100','2014-04-26','14:10:00',2.14),('16100','2014-04-26','14:15:00',2.32),('16100','2014-04-26','14:20:00',2.92),('16100','2014-04-26','14:25:00',3.47),('16100','2014-04-26','14:30:00',3.46),('16100','2014-04-26','14:35:00',3.86),('16100','2014-04-26','14:40:00',4.8),('16100','2014-04-26','14:45:00',4.15),('16100','2014-04-26','14:50:00',3.11),('16100','2014-04-26','14:55:00',3.07),('16100','2014-04-26','15:00:00',3.8),('16100','2014-04-26','15:05:00',4.88),('16100','2014-04-26','15:10:00',5.48),('16100','2014-04-26','15:15:00',5.22),('16100','2014-04-26','15:20:00',2.56),('16100','2014-04-26','15:25:00',1.53),('16100','2014-04-26','15:30:00',1.37),('16100','2014-04-26','15:35:00',1.79),('16100','2014-04-26','15:40:00',1.77),('16100','2014-04-26','15:45:00',1.03),('16100','2014-02-04','09:25:00',2.32),('16100','2014-02-04','09:30:00',1.04),('16100','2014-02-04','10:10:00',1.33),('16100','2014-02-04','10:15:00',1.92),('16100','2014-02-04','10:20:00',2.43),('16100','2014-02-04','10:25:00',5.19),('16100','2014-02-04','10:30:00',4.26),('16100','2014-02-04','10:35:00',4.4),('16100','2014-02-04','10:40:00',5.44),('16100','2014-02-04','10:45:00',5.44),('16100','2014-02-04','10:50:00',4.32),('16100','2014-02-04','10:55:00',2.45),('16100','2014-02-04','11:00:00',3.2),('16100','2014-02-04','11:05:00',3.22),('16100','2014-02-04','11:10:00',2.73),('16100','2014-02-04','11:15:00',3.09),('16100','2014-02-04','11:20:00',1.72),('16100','2014-02-04','11:25:00',3.3),('16100','2014-02-04','12:40:00',1.72),('16100','2014-02-04','12:45:00',4.39),('16100','2014-02-04','12:50:00',5.62),('16100','2014-02-04','12:55:00',4.33),('16100','2014-02-04','13:00:00',3.99),('16100','2014-02-04','13:05:00',4.26),('16100','2014-02-04','13:10:00',3.31),('16100','2014-02-04','13:15:00',2.95),('16100','2014-02-04','13:20:00',2.03),('16100','2014-02-04','13:25:00',2.36),('16100','2014-02-04','13:30:00',3.35),('16100','2014-02-04','13:35:00',2.82),('16100','2014-02-04','13:40:00',3.53),('16100','2014-02-04','13:45:00',3.15),('16100','2014-02-04','13:50:00',2.17),('16100','2014-02-04','13:55:00',1.59),('16100','2014-02-04','14:00:00',1.31),('16100','2014-02-04','14:05:00',1.38),('16100','2014-02-04','14:10:00',1.77),('16100','2014-02-04','14:15:00',1.15),('16100','2014-02-04','14:20:00',1.55),('16100','2014-02-04','14:25:00',5.88),('16100','2014-02-04','14:30:00',3.98),('16100','2014-02-04','14:35:00',4.29),('16100','2014-02-04','14:40:00',2.8),('16100','2014-02-04','14:45:00',3.08),('16100','2014-02-04','14:50:00',2.62),('16100','2014-02-04','14:55:00',1.62),('16100','2014-02-04','15:00:00',1.02),('16100','2014-02-04','15:25:00',1.38),('16100','2014-02-03','08:40:00',1),('16100','2014-02-03','09:05:00',1.01),('16100','2014-02-03','09:10:00',1.06),('16100','2014-02-03','09:15:00',1.22),('16100','2014-02-03','09:20:00',1.43),('16100','2014-02-03','09:25:00',1.55),('16100','2014-02-03','09:30:00',2.06),('16100','2014-02-03','09:35:00',2.57),('16100','2014-02-03','09:40:00',3.71),('16100','2014-02-03','09:45:00',4.71),('16100','2014-02-03','09:50:00',4.42),('16100','2014-02-03','09:55:00',4.43),('16100','2014-02-03','10:00:00',4.55),('16100','2014-02-03','10:05:00',4.71),('16100','2014-02-03','10:10:00',3.95),('16100','2014-02-03','10:15:00',3.61),('16100','2014-02-03','10:20:00',2.6),('16100','2014-02-03','10:25:00',5.01),('16100','2014-02-03','10:30:00',5.07),('16100','2014-02-03','10:35:00',3.54),('16100','2014-02-03','10:40:00',2.59),('16100','2014-02-03','10:45:00',4.85),('16100','2014-02-03','10:50:00',2.17),('16100','2014-02-03','10:55:00',2.03),('16100','2014-02-03','11:00:00',4.64),('16100','2014-02-03','11:05:00',4.75),('16100','2014-02-03','11:10:00',5.73),('16100','2014-02-03','11:15:00',2.56),('16100','2014-02-03','11:20:00',6.53),('16100','2014-02-03','11:25:00',4.64),('16100','2014-02-03','11:30:00',1.79),('16100','2014-02-03','11:35:00',2.22),('16100','2014-02-03','11:40:00',2.37),('16100','2014-02-03','11:45:00',2.12),('16100','2014-02-03','11:50:00',1.67),('16100','2014-02-03','11:55:00',1.9),('16100','2014-02-03','12:00:00',1.62),('16100','2014-02-03','12:05:00',1.79),('16100','2014-02-03','12:10:00',1.96),('16100','2014-02-03','12:15:00',1.51),('16100','2014-02-03','12:20:00',1.05),('16100','2014-02-03','12:45:00',1.18),('16100','2014-02-03','12:50:00',1.46),('16100','2014-02-03','12:55:00',1.91),('16100','2014-02-03','13:00:00',1.9),('16100','2014-02-03','13:05:00',2.1),('16100','2014-02-03','13:10:00',2.84),('16100','2014-02-03','13:15:00',3.41),('16100','2014-02-03','13:20:00',2.42),('16100','2014-02-03','13:25:00',1.73),('16100','2014-02-03','13:30:00',1.37),('16100','2014-02-03','13:40:00',1.08),('16100','2014-02-03','13:45:00',1.29),('16100','2014-02-03','13:50:00',1.33),('16100','2014-02-03','13:55:00',1.33),('16100','2014-02-03','14:10:00',1.12),('16100','2014-02-02','09:45:00',1.12),('16100','2014-02-02','09:50:00',1.45),('16100','2014-02-02','09:55:00',1.63),('16100','2014-02-02','10:00:00',1.32),('16100','2014-02-02','10:05:00',1.14),('16100','2014-02-02','10:10:00',1.27),('16100','2014-02-02','10:15:00',1.6),('16100','2014-02-02','10:20:00',1.65),('16100','2014-02-02','10:25:00',1.43),('16100','2014-02-02','10:30:00',1.46),('16100','2014-02-02','10:35:00',1.53),('16100','2014-02-02','10:40:00',1.53),('16100','2014-02-02','10:45:00',1.54),('16100','2014-02-02','10:50:00',1.48),('16100','2014-02-02','10:55:00',1.53),('16100','2014-02-02','11:00:00',1.55),('16100','2014-02-02','11:05:00',1.61),('16100','2014-02-02','11:10:00',1.6),('16100','2014-02-02','11:15:00',1.52),('16100','2014-02-02','11:20:00',1.39),('16100','2014-02-02','11:25:00',1.55),('16100','2014-02-02','11:30:00',1.59),('16100','2014-02-02','11:35:00',1.74),('16100','2014-02-02','11:40:00',1.93),('16100','2014-02-02','11:45:00',2.07),('16100','2014-02-02','11:50:00',2.12),('16100','2014-02-02','11:55:00',1.97),('16100','2014-02-02','12:00:00',1.76),('16100','2014-02-02','12:05:00',1.6),('16100','2014-02-02','12:10:00',1.57),('16100','2014-02-02','12:15:00',1.56),('16100','2014-02-02','12:20:00',1.63),('16100','2014-02-02','12:25:00',1.61),('16100','2014-02-02','12:30:00',1.56),('16100','2014-02-02','12:35:00',1.42),('16100','2014-02-02','12:40:00',1.49),('16100','2014-02-02','12:45:00',1.26),('16100','2014-02-02','14:30:00',1.24),('16100','2014-02-02','14:35:00',1.31),('16100','2014-02-02','14:40:00',1.29),('16100','2014-02-02','14:45:00',1.32),('16100','2014-02-02','14:50:00',1.24),('16100','2014-02-02','14:55:00',1.13),('16100','2014-02-01','11:50:00',1.05),('16100','2014-02-01','11:55:00',1.09),('16100','2014-02-01','12:00:00',1.15),('16100','2014-02-01','12:05:00',1.17),('16100','2014-02-01','12:10:00',1.16),('16100','2014-02-01','12:15:00',1.13),('16100','2014-02-01','12:20:00',1.08),('16100','2014-01-31','08:50:00',1.17),('16100','2014-01-31','09:25:00',1.01),('16100','2014-01-31','10:20:00',1.21),('16100','2014-01-31','10:25:00',1.17),('16100','2014-01-31','10:30:00',1.01),('16100','2014-01-31','10:40:00',1.09),('16100','2014-01-31','10:45:00',1.23),('16100','2014-01-31','10:50:00',1.32),('16100','2014-01-31','10:55:00',1.45),('16100','2014-01-31','11:00:00',1.9),('16100','2014-01-31','11:05:00',1.92),('16100','2014-01-31','11:10:00',2.12),('16100','2014-01-31','11:15:00',3.2),('16100','2014-01-31','11:20:00',4.07),('16100','2014-01-31','11:25:00',4.1),('16100','2014-01-31','11:30:00',3.75),('16100','2014-01-31','11:35:00',3.95),('16100','2014-01-31','11:40:00',3.7),('16100','2014-01-31','11:45:00',4),('16100','2014-01-31','11:50:00',4.24),('16100','2014-01-31','11:55:00',3.02),('16100','2014-01-31','12:00:00',2.1),('16100','2014-01-31','12:05:00',4.02),('16100','2014-01-31','12:10:00',4.26),('16100','2014-01-31','12:15:00',2.89),('16100','2014-01-31','12:20:00',3.38),('16100','2014-01-31','12:25:00',2.82),('16100','2014-01-31','12:30:00',4.77),('16100','2014-01-31','12:35:00',4.59),('16100','2014-01-31','12:40:00',4.51),('16100','2014-01-31','12:45:00',4.62),('16100','2014-01-31','12:50:00',3.79),('16100','2014-01-31','12:55:00',2.93),('16100','2014-01-31','13:00:00',1.96),('16100','2014-01-31','13:05:00',1.48),('16100','2014-01-31','13:20:00',1.47),('16100','2014-01-31','13:25:00',1.66),('16100','2014-01-31','13:30:00',1.4),('16100','2014-01-31','13:35:00',1.11),('16100','2014-01-30','10:25:00',1.09),('16100','2014-01-30','10:30:00',1.58),('16100','2014-01-30','10:35:00',1.65),('16100','2014-01-29','09:10:00',1.01),('16100','2014-01-29','09:15:00',1.06),('16100','2014-01-29','09:20:00',1.15),('16100','2014-01-29','09:25:00',1.19),('16100','2014-01-29','09:30:00',1.01),('16100','2014-01-29','09:40:00',1.13),('16100','2014-01-29','09:45:00',1.02),('16100','2014-01-29','09:50:00',1.69),('16100','2014-01-29','09:55:00',2.82),('16100','2014-01-29','10:00:00',3.72),('16100','2014-01-29','10:05:00',4.65),('16100','2014-01-29','10:10:00',4.6),('16100','2014-01-29','10:15:00',3.05),('16100','2014-01-29','10:20:00',2.48),('16100','2014-01-29','10:25:00',2.28),('16100','2014-01-29','10:30:00',2.64),('16100','2014-01-29','10:35:00',2.83),('16100','2014-01-29','10:40:00',2.82),('16100','2014-01-29','10:45:00',2.7),('16100','2014-01-29','10:50:00',2.75),('16100','2014-01-29','10:55:00',2.03),('16100','2014-01-29','11:00:00',2.54),('16100','2014-01-29','11:05:00',3.38),('16100','2014-01-29','11:10:00',4.55),('16100','2014-01-29','11:15:00',3.48),('16100','2014-01-29','11:20:00',2.33),('16100','2014-01-29','11:25:00',5.22),('16100','2014-01-29','11:30:00',5.48),('16100','2014-01-29','11:35:00',5.26),('16100','2014-01-29','11:40:00',6.11),('16100','2014-01-29','11:45:00',6.28),('16100','2014-01-29','11:50:00',6.15),('16100','2014-01-29','11:55:00',5.99),('16100','2014-01-29','12:00:00',5.56),('16100','2014-01-29','12:05:00',4.54),('16100','2014-01-29','12:10:00',3.46),('16100','2014-01-29','12:15:00',2.42),('16100','2014-01-29','12:20:00',3.94),('16100','2014-01-29','12:25:00',4.78),('16100','2014-01-29','12:30:00',5.06),('16100','2014-01-29','12:35:00',5.88),('16100','2014-01-29','12:40:00',5.99),('16100','2014-01-29','12:45:00',5.93),('16100','2014-01-29','12:50:00',5.92),('16100','2014-01-29','12:55:00',5.13),('16100','2014-01-29','13:00:00',6.06),('16100','2014-01-29','13:05:00',5.89),('16100','2014-01-29','13:10:00',6),('16100','2014-01-29','13:15:00',5.91),('16100','2014-01-29','13:20:00',5.87),('16100','2014-01-29','13:25:00',5.59),('16100','2014-01-29','13:30:00',4.79),('16100','2014-01-29','13:35:00',4.56),('16100','2014-01-29','13:40:00',4.63),('16100','2014-01-29','13:45:00',6),('16100','2014-01-29','13:50:00',5.87),('16100','2014-01-29','13:55:00',5.19),('16100','2014-01-29','14:00:00',4.5),('16100','2014-01-29','14:05:00',3.99),('16100','2014-01-29','14:10:00',4.38),('16100','2014-01-29','14:15:00',4.04),('16100','2014-01-29','14:20:00',3.25),('16100','2014-01-29','14:25:00',3.59),('16100','2014-01-29','14:30:00',3.61),('16100','2014-01-29','14:35:00',3.33),('16100','2014-01-29','14:40:00',3.5),('16100','2014-01-29','14:45:00',4.44),('16100','2014-01-29','14:50:00',4.48),('16100','2014-01-29','14:55:00',4.3),('16100','2014-01-29','15:00:00',4),('16100','2014-01-29','15:05:00',3.71),('16100','2014-01-29','15:10:00',3.66),('16100','2014-01-29','15:15:00',3.59),('16100','2014-01-29','15:20:00',3.37),('16100','2014-01-29','15:25:00',3.4),('16100','2014-01-29','15:30:00',2.06),('16100','2014-01-29','15:35:00',2.06),('16100','2014-01-29','15:40:00',2.2),('16100','2014-01-29','15:45:00',1.24),('16100','2014-01-28','09:10:00',1.11),('16100','2014-01-28','09:15:00',1.98),('16100','2014-01-28','09:20:00',2.27),('16100','2014-01-28','09:25:00',2.15),('16100','2014-01-28','09:30:00',2.63),('16100','2014-01-28','09:35:00',2.81),('16100','2014-01-28','09:40:00',2.26),('16100','2014-01-28','09:45:00',2.29),('16100','2014-01-28','09:50:00',1.79),('16100','2014-01-28','09:55:00',1.48),('16100','2014-01-28','10:00:00',1.78),('16100','2014-01-28','10:05:00',2.89),('16100','2014-01-28','10:10:00',2.33),('16100','2014-01-28','10:15:00',2.69),('16100','2014-01-28','10:20:00',4.58),('16100','2014-01-28','10:25:00',5.23),('16100','2014-01-28','10:30:00',3.26),('16100','2014-01-28','10:35:00',3.26),('16100','2014-01-28','10:40:00',3.08),('16100','2014-01-28','10:45:00',2.77),('16100','2014-01-28','10:50:00',2.83),('16100','2014-01-28','10:55:00',2.78),('16100','2014-01-28','11:00:00',2.98),('16100','2014-01-28','11:05:00',3.88),('16100','2014-01-28','11:10:00',3.88),('16100','2014-01-28','11:15:00',3.48),('16100','2014-01-28','11:20:00',4.1),('16100','2014-01-28','11:25:00',2.99),('16100','2014-01-28','11:30:00',3.65),('16100','2014-01-28','11:35:00',6.99),('16100','2014-01-28','11:40:00',2.86),('16100','2014-01-28','11:45:00',2.23),('16100','2014-01-28','11:50:00',1.37),('16100','2014-01-28','12:15:00',1.01),('16100','2014-01-28','12:20:00',1.33),('16100','2014-01-28','12:35:00',1.86),('16100','2014-01-28','12:40:00',2.24),('16100','2014-01-28','12:45:00',3),('16100','2014-01-28','12:50:00',5.62),('16100','2014-01-28','12:55:00',5.58),('16100','2014-01-28','13:00:00',5.23),('16100','2014-01-28','13:05:00',4.68),('16100','2014-01-28','13:10:00',2.38),('16100','2014-01-28','13:15:00',1.32),('16100','2014-01-28','13:30:00',1.26),('16100','2014-01-28','13:35:00',5.14),('16100','2014-01-28','13:40:00',6.33),('16100','2014-01-28','13:45:00',6.11),('16100','2014-01-28','13:50:00',5.97),('16100','2014-01-28','13:55:00',5.87),('16100','2014-01-28','14:00:00',5.22),('16100','2014-01-28','14:05:00',2.07),('16100','2014-01-28','14:10:00',1.55),('16100','2014-01-28','14:15:00',1.13),('16100','2014-01-28','14:40:00',1.2),('16100','2014-01-28','15:20:00',1.15),('16100','2014-01-27','08:50:00',1.29),('16100','2014-01-27','08:55:00',1.76),('16100','2014-01-27','09:00:00',1.76),('16100','2014-01-27','09:05:00',2.51),('16100','2014-01-27','09:10:00',2.26),('16100','2014-01-27','09:15:00',2),('16100','2014-01-27','09:20:00',2.24),('16100','2014-01-27','09:25:00',2.71),('16100','2014-01-27','09:30:00',2.9),('16100','2014-01-27','09:35:00',2.58),('16100','2014-01-27','09:40:00',2.54),('16100','2014-01-27','09:45:00',2.82),('16100','2014-01-27','09:50:00',3.69),('16100','2014-01-27','09:55:00',3.85),('16100','2014-01-27','10:00:00',3.66),('16100','2014-01-27','10:05:00',3.91),('16100','2014-01-27','10:10:00',4.41),('16100','2014-01-27','10:15:00',4.74),('16100','2014-01-27','10:20:00',5.04),('16100','2014-01-27','10:25:00',5.16),('16100','2014-01-27','10:30:00',5.23),('16100','2014-01-27','10:35:00',5.33),('16100','2014-01-27','10:40:00',5.59),('16100','2014-01-27','10:45:00',4.95),('16100','2014-01-27','10:50:00',3.06),('16100','2014-01-27','10:55:00',1.81),('16100','2014-01-27','11:00:00',2.19),('16100','2014-01-27','11:05:00',5.07),('16100','2014-01-27','11:10:00',5.1),('16100','2014-01-27','11:15:00',2.39),('16100','2014-01-27','11:20:00',2.26),('16100','2014-01-27','11:25:00',4.92),('16100','2014-01-27','11:30:00',3.47),('16100','2014-01-27','11:35:00',5.68),('16100','2014-01-27','11:40:00',4.3),('16100','2014-01-27','11:45:00',4.31),('16100','2014-01-27','11:50:00',4.93),('16100','2014-01-27','11:55:00',4.87),('16100','2014-01-27','12:00:00',5.09),('16100','2014-01-27','12:05:00',4.76),('16100','2014-01-27','12:10:00',4.91),('16100','2014-01-27','12:15:00',3.32),('16100','2014-01-27','12:20:00',2.39),('16100','2014-01-27','12:25:00',2),('16100','2014-01-27','12:30:00',1.94),('16100','2014-01-27','12:35:00',2.73),('16100','2014-01-27','12:40:00',2.59),('16100','2014-01-27','12:45:00',6.59),('16100','2014-01-27','12:50:00',6.97),('16100','2014-01-27','12:55:00',3.53),('16100','2014-01-27','13:00:00',6.75),('16100','2014-01-27','13:05:00',5.31),('16100','2014-01-27','13:10:00',5.59),('16100','2014-01-27','13:15:00',5.54),('16100','2014-01-27','13:20:00',6.49),('16100','2014-01-27','13:25:00',5.73),('16100','2014-01-27','13:30:00',5.39),('16100','2014-01-27','13:35:00',6.29),('16100','2014-01-27','13:40:00',6.28),('16100','2014-01-27','13:45:00',6.14),('16100','2014-01-27','13:50:00',5.94),('16100','2014-01-27','13:55:00',5.75),('16100','2014-01-27','14:00:00',5.58),('16100','2014-01-27','14:05:00',5.49),('16100','2014-01-27','14:10:00',5.4),('16100','2014-01-27','14:15:00',5.3),('16100','2014-01-27','14:20:00',5.21),('16100','2014-01-27','14:25:00',5.11),('16100','2014-01-27','14:30:00',5.07),('16100','2014-01-27','14:35:00',4.85),('16100','2014-01-27','14:40:00',4.79),('16100','2014-01-27','14:45:00',4.58),('16100','2014-01-27','14:50:00',4.45),('16100','2014-01-27','14:55:00',4.36),('16100','2014-01-27','15:00:00',4.21),('16100','2014-01-27','15:05:00',4.08),('16100','2014-01-27','15:10:00',3.92),('16100','2014-01-27','15:15:00',3.78),('16100','2014-01-27','15:20:00',3.61),('16100','2014-01-27','15:25:00',3.44),('16100','2014-01-27','15:30:00',3.29),('16100','2014-01-27','15:35:00',3.15),('16100','2014-01-27','15:40:00',2.98),('16100','2014-01-27','15:45:00',2.83),('16100','2014-01-27','15:50:00',2.68),('16100','2014-01-27','15:55:00',2.49),('16100','2014-01-27','16:00:00',2.31),('16100','2014-01-27','16:05:00',2.12),('16100','2014-01-27','16:10:00',1.93),('16100','2014-01-27','16:15:00',1.73),('16100','2014-01-27','16:20:00',1.57),('16100','2014-01-27','16:25:00',1.28),('16100','2014-01-26','09:40:00',1.03),('16100','2014-01-26','09:45:00',1.06),('16100','2014-01-26','09:50:00',1.17),('16100','2014-01-26','10:00:00',1.05),('16100','2014-01-26','10:05:00',1.09),('16100','2014-01-26','10:10:00',1.09),('16100','2014-01-26','10:15:00',1.11),('16100','2014-01-26','10:20:00',1.18),('16100','2014-01-26','10:25:00',1.29),('16100','2014-01-26','10:30:00',1.06),('16100','2014-01-26','10:35:00',1.13),('16100','2014-01-26','10:40:00',1.1),('16100','2014-01-26','10:45:00',1.07),('16100','2014-01-26','10:55:00',1.23),('16100','2014-01-26','11:00:00',1.46),('16100','2014-01-26','11:05:00',1.4),('16100','2014-01-26','11:10:00',1.06),('16100','2014-01-26','11:15:00',1.27),('16100','2014-01-26','11:20:00',1.27),('16100','2014-01-26','11:25:00',1.36),('16100','2014-01-26','11:30:00',1.09),('16100','2014-01-26','11:35:00',1.17),('16100','2014-01-26','12:50:00',1.14),('16100','2014-01-26','12:55:00',1.18),('16100','2014-01-26','13:00:00',1.02),('16100','2014-01-26','13:05:00',1.01),('16273','2014-05-05','07:20:00',1.07),('16273','2014-05-05','07:35:00',1.36),('16273','2014-05-05','07:40:00',1.45),('16273','2014-05-05','07:45:00',1.53),('16273','2014-05-05','07:50:00',1.62),('16273','2014-05-05','07:55:00',1.71),('16273','2014-05-05','08:00:00',1.8),('16273','2014-05-05','08:05:00',1.88),('16273','2014-05-05','08:10:00',1.96),('16273','2014-05-05','08:15:00',2.03),('16273','2014-05-05','08:20:00',2.11),('16273','2014-05-05','08:25:00',2.2),('16273','2014-05-05','08:30:00',2.28),('16273','2014-05-05','08:35:00',2.35),('16273','2014-05-05','08:40:00',2.42),('16273','2014-05-05','08:45:00',2.49),('16273','2014-05-05','08:50:00',2.58),('16273','2014-05-05','08:55:00',2.64),('16273','2014-05-05','09:00:00',2.71),('16273','2014-05-05','09:05:00',2.79),('16273','2014-05-05','09:10:00',2.84),('16273','2014-05-05','09:15:00',2.91),('16273','2014-05-05','09:20:00',2.97),('16273','2014-05-05','09:25:00',3.04),('16273','2014-05-05','09:30:00',3.08),('16273','2014-05-05','09:35:00',3.15),('16273','2014-05-05','09:40:00',3.21),('16273','2014-05-05','09:45:00',3.28),('16273','2014-05-05','09:50:00',3.32),('16273','2014-05-05','09:55:00',3.37),('16273','2014-05-05','10:00:00',3.41),('16273','2014-05-05','10:05:00',3.43),('16273','2014-05-05','10:10:00',3.49),('16273','2014-05-05','10:15:00',3.53),('16273','2014-05-05','10:20:00',3.58),('16273','2014-05-05','10:25:00',3.62),('16273','2014-05-05','10:30:00',3.62),('16273','2014-05-05','10:35:00',3.58),('16273','2014-05-05','10:40:00',3.65),('16273','2014-05-05','10:45:00',3.17),('16273','2014-05-05','10:50:00',3.79),('16273','2014-05-05','10:55:00',3.78),('16273','2014-05-05','11:00:00',3.83),('16273','2014-05-05','11:05:00',3.83),('16273','2014-05-05','11:10:00',3.85),('16273','2014-05-05','11:15:00',3.84),('16273','2014-05-05','11:20:00',3.88),('16273','2014-05-05','11:25:00',3.91),('16273','2014-05-05','11:30:00',3.12),('16273','2014-05-05','11:35:00',2.86),('16273','2014-05-05','11:40:00',2.9),('16273','2014-05-05','11:45:00',3.65),('16273','2014-05-05','11:50:00',1),('16273','2014-05-05','11:55:00',1.87),('16273','2014-05-05','12:00:00',3.32),('16273','2014-05-05','12:05:00',4.28),('16273','2014-05-05','12:10:00',4.3),('16273','2014-05-05','12:15:00',3.17),('16273','2014-05-05','12:20:00',4.14),('16273','2014-05-05','12:25:00',4.06),('16273','2014-05-05','12:30:00',4.08),('16273','2014-05-05','12:35:00',4.05),('16273','2014-05-05','12:40:00',4.02),('16273','2014-05-05','12:45:00',3.96),('16273','2014-05-05','12:50:00',3.94),('16273','2014-05-05','12:55:00',3.92),('16273','2014-05-05','13:00:00',3.89),('16273','2014-05-05','13:05:00',3.86),('16273','2014-05-05','13:10:00',3.34),('16273','2014-05-05','13:15:00',1.45),('16273','2014-05-05','13:35:00',1.34),('16273','2014-05-05','13:40:00',3.31),('16273','2014-05-05','13:45:00',2.39),('16273','2014-05-05','13:50:00',1.71),('16273','2014-05-05','13:55:00',2.08),('16273','2014-05-05','14:00:00',3.36),('16273','2014-05-05','14:05:00',4.31),('16273','2014-05-05','14:10:00',4.2),('16273','2014-05-05','14:15:00',3.89),('16273','2014-05-05','14:20:00',3.71),('16273','2014-05-05','14:25:00',3.64),('16273','2014-05-05','14:30:00',3.56),('16273','2014-05-05','14:35:00',3.55),('16273','2014-05-05','14:40:00',3.57),('16273','2014-05-05','14:45:00',3.51),('16273','2014-05-05','14:50:00',3.43),('16273','2014-05-05','14:55:00',3.4),('16273','2014-05-05','15:00:00',3.28),('16273','2014-05-05','15:05:00',3.24),('16273','2014-05-05','15:10:00',3.17),('16273','2014-05-05','15:15:00',3.09),('16273','2014-05-05','15:20:00',3.04),('16273','2014-05-05','15:25:00',2.98),('16273','2014-05-05','15:30:00',2.94),('16273','2014-05-05','15:35:00',2.91),('16273','2014-05-05','15:40:00',2.83),('16273','2014-05-05','15:45:00',2.79),('16273','2014-05-05','15:50:00',2.74),('16273','2014-05-05','15:55:00',2.65),('16273','2014-05-05','16:00:00',2.56),('16273','2014-05-05','16:05:00',2.52),('16273','2014-05-05','16:10:00',2.46),('16273','2014-05-05','16:15:00',2.36),('16273','2014-05-05','16:20:00',2.32),('16273','2014-05-05','16:25:00',2.24),('16273','2014-05-05','16:30:00',2.16),('16273','2014-05-05','16:35:00',2.08),('16273','2014-05-05','16:40:00',2.01),('16273','2014-05-05','16:45:00',1.91),('16273','2014-05-05','16:50:00',1.85),('16273','2014-05-05','16:55:00',1.78),('16273','2014-05-05','17:00:00',1.72),('16273','2014-05-05','17:05:00',1.63),('16273','2014-05-05','17:10:00',1.55),('16273','2014-05-05','17:15:00',1.46),('16273','2014-05-05','17:20:00',1.39),('16273','2014-05-05','17:25:00',1.32),('16273','2014-05-05','17:30:00',1.26),('16273','2014-05-05','17:35:00',1.21),('16273','2014-05-05','17:40:00',1.1),('16273','2014-05-05','17:45:00',1.01),('16273','2014-04-26','09:10:00',1.11),('16273','2014-04-26','09:15:00',1.02),('16273','2014-04-26','09:45:00',1.01),('16273','2014-04-26','09:50:00',1.09),('16273','2014-04-26','09:55:00',1.08),('16273','2014-04-26','10:00:00',1.37),('16273','2014-04-26','10:05:00',1.64),('16273','2014-04-26','10:10:00',1.76),('16273','2014-04-26','10:15:00',1.46),('16273','2014-04-26','10:20:00',1.46),('16273','2014-04-26','10:25:00',1.72),('16273','2014-04-26','10:30:00',1.8),('16273','2014-04-26','10:35:00',1.68),('16273','2014-04-26','10:40:00',1.8),('16273','2014-04-26','10:45:00',1.5),('16273','2014-04-26','10:50:00',1.86),('16273','2014-04-26','10:55:00',2.68),('16273','2014-04-26','11:00:00',3.69),('16273','2014-04-26','11:05:00',3.86),('16273','2014-04-26','11:10:00',3.49),('16273','2014-04-26','11:15:00',3.53),('16273','2014-04-26','11:20:00',3.54),('16273','2014-04-26','11:25:00',3.39),('16273','2014-04-26','11:30:00',2.99),('16273','2014-04-26','11:35:00',3.2),('16273','2014-04-26','11:40:00',3.13),('16273','2014-04-26','11:45:00',2.89),('16273','2014-04-26','11:50:00',3.26),('16273','2014-04-26','11:55:00',3.39),('16273','2014-04-26','12:00:00',2.9),('16273','2014-04-26','12:05:00',1.54),('16273','2014-04-26','12:10:00',1.97),('16273','2014-04-26','12:15:00',2.88),('16273','2014-04-26','12:20:00',2.53),('16273','2014-04-26','12:25:00',2.13),('16273','2014-04-26','12:30:00',2.5),('16273','2014-04-26','12:35:00',2.43),('16273','2014-04-26','12:40:00',2.65),('16273','2014-04-26','12:45:00',2.56),('16273','2014-04-26','12:50:00',2.67),('16273','2014-04-26','12:55:00',3.1),('16273','2014-04-26','13:00:00',2.91),('16273','2014-04-26','13:05:00',2.3),('16273','2014-04-26','13:10:00',1.61),('16273','2014-04-26','13:15:00',2.31),('16273','2014-04-26','13:20:00',1.23),('16273','2014-04-26','13:25:00',2.71),('16273','2014-04-26','13:30:00',2.18),('16273','2014-04-26','13:35:00',2.24),('16273','2014-04-26','13:40:00',2.79),('16273','2014-04-26','13:45:00',1.28),('16273','2014-04-26','13:50:00',1),('16273','2014-04-26','14:00:00',1.57),('16273','2014-04-26','14:05:00',1.83),('16273','2014-04-26','14:10:00',1.94),('16273','2014-04-26','14:15:00',3.13),('16273','2014-04-26','14:20:00',1.76),('16273','2014-04-26','14:50:00',1.44),('16273','2014-04-26','14:55:00',1.23),('16273','2014-01-26','09:00:00',1.59),('16273','2014-01-26','09:05:00',1.3),('16273','2014-01-26','09:25:00',1.53),('16273','2014-01-26','09:30:00',1.32),('16273','2014-01-26','09:45:00',1.13),('16273','2014-01-26','10:05:00',1.34),('16273','2014-01-26','10:10:00',1.43),('16273','2014-01-26','10:15:00',1.39),('16273','2014-01-26','10:30:00',1.12),('16273','2014-01-26','10:50:00',1.01),('16273','2014-01-26','11:20:00',1.15),('16273','2014-01-26','11:25:00',1.26),('16273','2014-01-26','12:10:00',1.14),('16273','2014-01-26','12:15:00',1.26),('16273','2014-01-26','12:20:00',1.51),('16273','2014-01-26','12:25:00',1.72),('16273','2014-01-26','12:30:00',1.54),('16273','2014-01-26','12:35:00',1.18),('16273','2014-01-26','13:00:00',1.22),('16273','2014-01-26','13:05:00',1.24),('16273','2014-01-26','13:10:00',1.13),('16273','2014-01-26','13:15:00',1.3),('16273','2014-01-26','13:20:00',1.38),('16273','2014-01-26','13:25:00',1.19),('16273','2014-01-26','13:30:00',1.05),('16273','2014-01-26','13:45:00',1.08),('16273','2014-01-25','09:45:00',1.06),('16273','2014-01-25','09:50:00',1.37),('16273','2014-01-25','09:55:00',1.63),('16273','2014-01-25','10:00:00',1.7),('16273','2014-01-25','10:05:00',3.03),('16273','2014-01-25','10:10:00',2.43),('16273','2014-01-25','10:15:00',2.7),('16273','2014-01-25','10:20:00',2.94),('16273','2014-01-25','10:25:00',2.71),('16273','2014-01-25','10:30:00',2.85),('16273','2014-01-25','10:35:00',2.1),('16273','2014-01-25','10:40:00',1.74),('16273','2014-01-25','10:45:00',1.93),('16273','2014-01-25','10:50:00',2.5),('16273','2014-01-25','10:55:00',2.89),('16273','2014-01-25','11:00:00',3.11),('16273','2014-01-25','11:05:00',3.23),('16273','2014-01-25','11:10:00',2.93),('16273','2014-01-25','11:15:00',3.14),('16273','2014-01-25','11:20:00',3.1),('16273','2014-01-25','11:25:00',1.61),('16273','2014-01-25','11:30:00',1.42),('16273','2014-01-25','11:35:00',1.52),('16273','2014-01-25','11:40:00',1.59),('16273','2014-01-25','11:45:00',1.6),('16273','2014-01-25','11:50:00',1.55),('16273','2014-01-25','11:55:00',1.52),('16273','2014-01-25','12:00:00',1.68),('16273','2014-01-25','12:05:00',2.01),('16273','2014-01-25','12:10:00',1.94),('16273','2014-01-25','12:15:00',1.6),('16273','2014-01-25','12:20:00',1.66),('16273','2014-01-25','12:25:00',1.71),('16273','2014-01-25','12:30:00',1.81),('16273','2014-01-25','12:35:00',1.92),('16273','2014-01-25','12:40:00',2),('16273','2014-01-25','12:45:00',2),('16273','2014-01-25','12:50:00',2.47),('16273','2014-01-25','12:55:00',2.61),('16273','2014-01-25','13:00:00',2.54),('16273','2014-01-25','13:05:00',2.66),('16273','2014-01-25','13:10:00',2.59),('16273','2014-01-25','13:15:00',2.58),('16273','2014-01-25','13:20:00',2.55),('16273','2014-01-25','13:25:00',2.56),('16273','2014-01-25','13:30:00',2.53),('16273','2014-01-25','13:35:00',2.52),('16273','2014-01-25','13:40:00',2.51),('16273','2014-01-25','13:45:00',2.5),('16273','2014-01-25','13:50:00',2.25),('16273','2014-01-25','13:55:00',1.96),('16273','2014-01-25','14:00:00',2.22),('16273','2014-01-25','14:05:00',2.27),('16273','2014-01-25','14:10:00',1.96),('16273','2014-01-25','14:15:00',1.87),('16273','2014-01-25','14:20:00',1.35),('16273','2014-01-25','14:25:00',1.95),('16273','2014-01-25','14:30:00',1.7),('16273','2014-01-25','14:35:00',1.96),('16273','2014-01-25','14:45:00',1.01),('16273','2014-01-25','14:50:00',2.01),('16273','2014-01-25','14:55:00',1.72),('16273','2014-01-25','15:10:00',1.32),('16273','2014-01-25','15:15:00',1.25),('16273','2014-01-25','15:20:00',1.17),('16273','2014-01-25','15:25:00',1.03),('16273','2014-01-24','10:00:00',1.18),('16273','2014-01-24','10:05:00',1.68),('16273','2014-01-24','10:10:00',1.58),('16273','2014-01-24','10:15:00',2.55),('16273','2014-01-24','10:20:00',1.07),('16273','2014-01-24','10:25:00',1.89),('16273','2014-01-24','10:30:00',2.45),('16273','2014-01-24','10:35:00',2.24),('16273','2014-01-24','10:40:00',1.27),('16273','2014-01-24','10:45:00',1.52),('16273','2014-01-24','10:50:00',1.07),('16273','2014-01-24','11:15:00',1.09),('16273','2014-01-24','11:25:00',1.51),('16273','2014-01-24','11:30:00',1.03),('16273','2014-01-24','11:35:00',1.18),('16273','2014-01-24','11:40:00',3.3),('16273','2014-01-24','11:45:00',2.48),('16273','2014-01-24','11:50:00',1.16),('16273','2014-01-24','11:55:00',1.24),('16273','2014-01-24','12:00:00',3.35),('16273','2014-01-24','12:05:00',2.72),('16273','2014-01-24','12:10:00',1.34),('16273','2014-01-24','12:15:00',2.18),('16273','2014-01-24','12:20:00',2.06),('16273','2014-01-24','12:25:00',1.14),('16273','2014-01-24','12:35:00',2.12),('16273','2014-01-24','12:40:00',2.26),('16273','2014-01-24','12:45:00',1.53),('16273','2014-01-24','12:50:00',1.29),('16273','2014-01-24','12:55:00',1.57),('16273','2014-01-24','13:10:00',1.66),('16273','2014-01-24','13:15:00',1.19),('16273','2014-01-24','13:20:00',1.14),('16273','2014-01-24','13:25:00',1.79),('16273','2014-01-24','13:30:00',1.13),('16273','2014-01-24','13:35:00',1.37),('16273','2014-01-24','13:40:00',2.15),('16273','2014-01-24','13:45:00',1.71),('16273','2014-01-24','13:50:00',1.37),('16273','2014-01-24','14:00:00',1.93),('16273','2014-01-24','14:05:00',2.38),('16273','2014-01-24','14:10:00',1.75),('16273','2014-01-24','14:15:00',1.84),('16273','2014-01-24','14:20:00',2.1),('16273','2014-01-24','14:25:00',1.86),('16273','2014-01-24','14:40:00',1.72),('16273','2014-01-24','14:45:00',1.12),('16273','2014-01-23','12:15:00',1.06),('16273','2014-01-23','12:20:00',1.01),('16273','2014-01-23','12:30:00',1.08),('16273','2014-01-23','12:35:00',1.06),('16273','2014-01-22','11:25:00',1.08),('16273','2014-01-22','11:30:00',1.11),('16273','2014-01-22','16:05:00',1.04),('16273','2014-01-21','09:50:00',1.87),('16273','2014-01-21','10:25:00',1.17),('16273','2014-01-21','11:30:00',2.02),('16273','2014-01-21','11:35:00',2.5),('16273','2014-01-21','11:40:00',1.32),('16273','2014-01-21','11:50:00',1.09),('16273','2014-01-21','11:55:00',1.93),('16273','2014-01-21','12:00:00',1.6),('16273','2014-01-21','12:05:00',1.45),('16273','2014-01-21','12:10:00',1.72),('16273','2014-01-21','12:15:00',1.55),('16273','2014-01-21','12:20:00',1.74),('16273','2014-01-21','12:25:00',1.31),('16273','2014-01-21','12:30:00',1.03),('16273','2014-01-21','12:35:00',1.03),('16273','2014-01-21','13:10:00',1.13),('16273','2014-01-21','15:35:00',1.05),('16273','2014-01-20','11:55:00',1.12),('16273','2014-01-20','12:00:00',1.1),('16273','2014-01-20','12:45:00',1.59),('16273','2014-01-20','12:50:00',1.78),('16273','2014-01-20','13:25:00',1.33),('16273','2014-01-20','13:30:00',1.07),('16273','2014-01-20','14:10:00',1.14),('16273','2014-01-20','14:15:00',1.36),('16273','2014-01-19','11:50:00',1.16),('16273','2014-01-19','11:55:00',1.12),('16273','2014-01-19','13:05:00',1.07),('16273','2014-01-19','13:10:00',1.08),('16273','2014-01-19','14:15:00',1.09),('16273','2014-01-19','14:20:00',1.42),('16273','2014-01-19','14:25:00',1.23),('16273','2014-01-19','14:30:00',1.02),('16273','2014-01-18','09:45:00',1.37),('16273','2014-01-18','09:50:00',1.32),('16273','2014-01-18','09:55:00',1.65),('16273','2014-01-18','10:00:00',2.14),('16273','2014-01-18','10:05:00',1.47),('16273','2014-01-18','10:10:00',2.72),('16273','2014-01-18','10:15:00',2.98),('16273','2014-01-18','10:20:00',2.34),('16273','2014-01-18','10:25:00',2.36),('16273','2014-01-18','10:30:00',1.72),('16273','2014-01-18','10:35:00',1.84),('16273','2014-01-18','10:40:00',1.67),('16273','2014-01-18','10:45:00',1.05),('16273','2014-01-18','10:50:00',1.08),('16273','2014-01-18','11:00:00',2.02),('16273','2014-01-18','11:05:00',3.03),('16273','2014-01-18','11:10:00',2.43),('16273','2014-01-18','11:15:00',2.79),('16273','2014-01-18','11:20:00',2.83),('16273','2014-01-18','11:25:00',2.8),('16273','2014-01-18','11:30:00',2.82),('16273','2014-01-18','11:35:00',2.92),('16273','2014-01-18','11:40:00',1.66),('16273','2014-01-18','11:45:00',1.5),('16273','2014-01-18','11:50:00',1.31),('16273','2014-01-18','11:55:00',2.65),('16273','2014-01-18','12:00:00',2.1),('16273','2014-01-18','12:05:00',2.38),('16273','2014-01-18','12:10:00',2.74),('16273','2014-01-18','12:15:00',2.69),('16273','2014-01-18','12:20:00',2.71),('16273','2014-01-18','12:25:00',2.67),('16273','2014-01-18','12:30:00',2.69),('16273','2014-01-18','12:35:00',2.67),('16273','2014-01-18','12:40:00',2.72),('16273','2014-01-18','12:45:00',2.6),('16273','2014-01-18','12:50:00',2.33),('16273','2014-01-18','12:55:00',1.99),('16273','2014-01-18','13:00:00',2.1),('16273','2014-01-18','13:05:00',1.78),('16273','2014-01-18','13:10:00',2.32),('16273','2014-01-18','13:15:00',2.54),('16273','2014-01-18','13:20:00',2.59),('16273','2014-01-18','13:25:00',1.53),('16273','2014-01-18','13:30:00',2.35),('16273','2014-01-18','13:35:00',2.44),('16273','2014-01-18','13:40:00',1.93),('16273','2014-01-18','13:45:00',2.29),('16273','2014-01-18','13:50:00',1.54),('16273','2014-01-18','13:55:00',1.59),('16273','2014-01-18','14:00:00',2.11),('16273','2014-01-18','14:05:00',1.95),('16273','2014-01-18','14:10:00',1.7),('16273','2014-01-18','14:15:00',1.79),('16273','2014-01-18','14:20:00',1.77),('16273','2014-01-18','14:25:00',1.69),('16273','2014-01-18','14:30:00',1.63),('16273','2014-01-18','14:35:00',1.55),('16273','2014-01-18','14:40:00',1.49),('16273','2014-01-18','14:45:00',1.42),('16273','2014-01-18','14:50:00',1.18),('16273','2014-01-17','08:45:00',1.04),('16273','2014-01-17','08:55:00',1.13),('16273','2014-01-17','09:00:00',1.57),('16273','2014-01-17','09:05:00',1.3),('16273','2014-01-17','09:10:00',1.6),('16273','2014-01-17','09:25:00',1.44),('16273','2014-01-17','09:30:00',1.74),('16273','2014-01-17','09:35:00',1.78),('16273','2014-04-25','07:40:00',1.03),('16273','2014-04-25','07:45:00',1.18),('16273','2014-04-25','07:50:00',1.22),('16273','2014-04-25','07:55:00',1.21),('16273','2014-04-25','08:00:00',1.26),('16273','2014-04-25','08:05:00',1.35),('16273','2014-04-25','08:10:00',1.38),('16273','2014-04-25','08:15:00',1.17),('16273','2014-04-25','08:20:00',1.37),('16273','2014-04-25','08:25:00',1.54),('16273','2014-04-25','08:30:00',2.03),('16273','2014-04-25','08:35:00',1.92),('16273','2014-04-25','08:40:00',2.2),('16273','2014-04-25','08:45:00',2.3),('16273','2014-04-25','08:50:00',2.28),('16273','2014-04-25','08:55:00',1.81),('16273','2014-04-25','09:00:00',1.3),('16273','2014-04-25','09:05:00',2.08),('16273','2014-04-25','09:10:00',1.71),('16273','2014-04-25','09:15:00',1.49),('16273','2014-04-25','09:20:00',1.65),('16273','2014-04-25','09:25:00',1.28),('16273','2014-04-25','09:30:00',1.07),('16273','2014-04-25','09:35:00',1.04),('16273','2014-04-25','09:45:00',1.22),('16273','2014-04-25','09:50:00',1.69),('16273','2014-04-25','09:55:00',1.45),('16273','2014-04-25','10:00:00',1.1),('16273','2014-04-25','10:10:00',1.09),('16273','2014-04-25','10:15:00',1.07),('16273','2014-04-25','10:20:00',1.14),('16273','2014-04-25','10:25:00',1.29),('16273','2014-04-25','10:30:00',2.36),('16273','2014-04-25','10:35:00',3.08),('16273','2014-04-25','10:40:00',1.98),('16273','2014-04-25','10:45:00',1.3),('16273','2014-04-25','10:50:00',3.51),('16273','2014-04-25','10:55:00',2.84),('16273','2014-04-25','11:00:00',1.56),('16273','2014-04-25','11:05:00',1.45),('16273','2014-04-25','11:10:00',1.36),('16273','2014-04-25','11:15:00',1),('16273','2014-04-25','11:20:00',1.05),('16273','2014-04-25','11:25:00',2.96),('16273','2014-04-25','11:30:00',4.01),('16273','2014-04-25','11:35:00',3.9),('16273','2014-04-25','11:40:00',2.64),('16273','2014-04-25','11:45:00',4.01),('16273','2014-04-25','11:50:00',4.03),('16273','2014-04-25','11:55:00',4),('16273','2014-04-25','12:00:00',4.08),('16273','2014-04-25','12:05:00',1.61),('16273','2014-04-25','12:10:00',3.24),('16273','2014-04-25','12:15:00',3.96),('16273','2014-04-25','12:20:00',2.16),('16273','2014-04-25','12:25:00',1.34),('16273','2014-04-25','12:30:00',1.36),('16273','2014-04-25','12:35:00',1.36),('16273','2014-04-25','12:40:00',3.48),('16273','2014-04-25','12:45:00',4.35),('16273','2014-04-25','12:50:00',4.19),('16273','2014-04-25','12:55:00',2.8),('16273','2014-04-25','13:00:00',4.08),('16273','2014-04-25','13:05:00',3.98),('16273','2014-04-25','13:10:00',3.92),('16273','2014-04-25','13:15:00',3.86),('16273','2014-04-25','13:20:00',3.92),('16273','2014-04-25','13:25:00',3.83),('16273','2014-04-25','13:30:00',3.87),('16273','2014-04-25','13:35:00',3.95),('16273','2014-04-25','13:40:00',3.86),('16273','2014-04-25','13:45:00',3),('16273','2014-04-25','13:50:00',3.5),('16273','2014-04-25','13:55:00',3.64),('16273','2014-04-25','14:00:00',3.58),('16273','2014-04-25','14:05:00',3.55),('16273','2014-04-25','14:10:00',3.51),('16273','2014-04-25','14:15:00',3.51),('16273','2014-04-25','14:20:00',3.46),('16273','2014-04-25','14:25:00',3.43),('16273','2014-04-25','14:30:00',3.38),('16273','2014-04-25','14:35:00',3.34),('16273','2014-04-25','14:40:00',3.29),('16273','2014-04-25','14:45:00',3.25),('16273','2014-04-25','14:50:00',3.21),('16273','2014-04-25','14:55:00',3.17),('16273','2014-04-25','15:00:00',3.05),('16273','2014-04-25','15:05:00',3.04),('16273','2014-04-25','15:10:00',2.98),('16273','2014-04-25','15:15:00',2.95),('16273','2014-04-25','15:20:00',2.9),('16273','2014-04-25','15:25:00',2.87),('16273','2014-04-25','15:30:00',2.82),('16273','2014-04-25','15:35:00',2.73),('16273','2014-04-25','15:40:00',2.64),('16273','2014-04-25','15:45:00',2.57),('16273','2014-04-25','15:50:00',2.58),('16273','2014-04-25','15:55:00',2.42),('16273','2014-04-25','16:00:00',2.3),('16273','2014-04-25','16:05:00',2.36),('16273','2014-04-25','16:10:00',2.08),('16273','2014-04-25','16:15:00',1.88),('16273','2014-04-25','16:20:00',2.02),('16273','2014-04-25','16:25:00',1.92),('16273','2014-04-25','16:30:00',2),('16273','2014-04-25','16:35:00',2),('16273','2014-04-25','16:40:00',1.94),('16273','2014-04-25','16:45:00',1.71),('16273','2014-04-25','16:50:00',1.33),('16273','2014-04-25','16:55:00',1.31),('16273','2014-04-25','17:00:00',1.33),('16273','2014-04-25','17:05:00',1.37),('16273','2014-04-25','17:10:00',1.48),('16273','2014-04-25','17:15:00',1.16),('16273','2014-04-25','17:25:00',1.12),('16273','2014-01-16','08:55:00',1.06),('16273','2014-01-16','09:00:00',1.17),('16273','2014-01-16','09:05:00',1.29),('16273','2014-01-16','09:10:00',1.38),('16273','2014-01-16','09:15:00',1.88),('16273','2014-01-16','09:20:00',1.98),('16273','2014-01-16','09:25:00',2.03),('16273','2014-01-16','09:30:00',2.06),('16273','2014-01-16','09:35:00',2.05),('16273','2014-01-16','09:40:00',1.81),('16273','2014-01-16','09:45:00',1.33),('16273','2014-01-16','09:50:00',1.05),('16273','2014-01-16','10:05:00',1.2),('16273','2014-01-16','10:10:00',1.36),('16273','2014-01-16','10:15:00',1.54),('16273','2014-01-16','10:20:00',1.87),('16273','2014-01-16','10:25:00',2.58),('16273','2014-01-16','10:30:00',2.89),('16273','2014-01-16','10:35:00',1.95),('16273','2014-01-16','10:40:00',1.77),('16273','2014-01-16','10:45:00',2.17),('16273','2014-01-16','10:50:00',2.15),('16273','2014-01-16','10:55:00',2.14),('16273','2014-01-16','11:00:00',2.35),('16273','2014-01-16','11:05:00',2.22),('16273','2014-01-16','11:10:00',2),('16273','2014-01-16','11:15:00',1.74),('16273','2014-01-16','11:20:00',1.84),('16273','2014-01-16','11:25:00',1.77),('16273','2014-01-16','11:30:00',1.89),('16273','2014-01-16','11:35:00',1.95),('16273','2014-01-16','11:40:00',1.95),('16273','2014-01-16','11:45:00',2.03),('16273','2014-01-16','11:50:00',1.95),('16273','2014-01-16','11:55:00',1.87),('16273','2014-01-16','12:00:00',1.76),('16273','2014-01-16','12:05:00',1.77),('16273','2014-01-16','12:10:00',1.59),('16273','2014-01-16','12:15:00',1.49),('16273','2014-01-16','12:20:00',1.53),('16273','2014-01-16','12:25:00',1.65),('16273','2014-01-16','12:30:00',1.81),('16273','2014-01-16','12:35:00',1.79),('16273','2014-01-16','12:40:00',1.82),('16273','2014-01-16','12:45:00',1.99),('16273','2014-01-16','12:50:00',2.15),('16273','2014-01-16','12:55:00',2.25),('16273','2014-01-16','13:00:00',2.15),('16273','2014-01-16','13:05:00',2.24),('16273','2014-01-16','13:10:00',2.25),('16273','2014-01-16','13:15:00',2.15),('16273','2014-01-16','13:20:00',1.88),('16273','2014-01-16','13:25:00',1.95),('16273','2014-01-16','13:30:00',2.26),('16273','2014-01-16','13:35:00',2.44),('16273','2014-01-16','13:40:00',2.35),('16273','2014-01-16','13:45:00',2.35),('16273','2014-01-16','13:50:00',1.06),('16273','2014-01-16','13:55:00',1.05),('16273','2014-01-15','09:30:00',1.06),('16273','2014-01-15','09:55:00',1.61),('16273','2014-01-15','10:00:00',2.12),('16273','2014-01-15','10:05:00',2.37),('16273','2014-01-15','10:10:00',2.45),('16273','2014-01-15','10:15:00',2.49),('16273','2014-01-15','10:20:00',2.49),('16273','2014-01-15','10:25:00',2.57),('16273','2014-01-15','10:30:00',2.62),('16273','2014-01-15','10:35:00',2.15),('16273','2014-01-15','10:40:00',1.3),('16273','2014-01-15','10:45:00',1.02),('16273','2014-01-15','10:50:00',1.04),('16273','2014-01-15','10:55:00',2.29),('16273','2014-01-15','11:00:00',2.74),('16273','2014-01-15','11:05:00',2.79),('16273','2014-01-15','11:10:00',2.98),('16273','2014-01-15','11:15:00',2.9),('16273','2014-01-15','11:20:00',2.99),('16273','2014-01-15','11:25:00',2.77),('16273','2014-01-15','11:30:00',1.44),('16273','2014-01-15','11:35:00',1.54),('16273','2014-01-15','11:40:00',1.56),('16273','2014-01-15','11:45:00',1.45),('16273','2014-01-15','11:50:00',1.77),('16273','2014-01-15','11:55:00',1.64),('16273','2014-01-15','12:00:00',1.58),('16273','2014-01-15','12:05:00',1.8),('16273','2014-01-15','12:10:00',1.95),('16273','2014-01-15','12:15:00',1.62),('16273','2014-01-15','12:20:00',1.36),('16273','2014-01-15','12:25:00',1.63),('16273','2014-01-15','12:30:00',2.84),('16273','2014-01-15','12:35:00',2.74),('16273','2014-01-15','12:40:00',1.98),('16273','2014-01-15','12:45:00',2.19),('16273','2014-01-15','12:50:00',1.63),('16273','2014-01-15','12:55:00',2.45),('16273','2014-01-15','13:00:00',2.07),('16273','2014-01-15','13:10:00',1.66),('16273','2014-01-15','13:15:00',2.54),('16273','2014-01-15','13:20:00',2.65),('16273','2014-01-15','13:25:00',2.16),('16273','2014-01-15','13:30:00',2.29),('16273','2014-01-15','13:35:00',1.4),('16273','2014-01-15','13:40:00',1.76),('16273','2014-01-15','13:45:00',1.01),('16273','2014-01-15','13:50:00',2.05),('16273','2014-01-15','13:55:00',2.17),('16273','2014-01-15','14:00:00',2.1),('16273','2014-01-15','14:05:00',1.97),('16273','2014-01-15','14:10:00',1.89),('16273','2014-01-15','14:15:00',1.81),('16273','2014-01-15','14:20:00',1.74),('16273','2014-01-15','14:25:00',1.66),('16273','2014-01-15','14:30:00',1.59),('16273','2014-01-15','14:35:00',1.52),('16273','2014-01-15','14:40:00',1.48),('16273','2014-01-15','14:45:00',1.42),('16273','2014-01-15','14:50:00',1.37),('16273','2014-01-15','14:55:00',1.31),('16273','2014-01-15','15:00:00',1.27),('16273','2014-01-15','15:05:00',1.21),('16273','2014-01-15','15:10:00',1.14),('16273','2014-01-15','15:15:00',1.02),('16273','2014-01-14','10:20:00',1.17),('16273','2014-01-14','10:25:00',1.85),('16273','2014-01-14','10:30:00',2.21),('16273','2014-01-14','10:35:00',1.53),('16273','2014-01-14','10:40:00',1.1),('16273','2014-01-13','08:55:00',1.58),('16273','2014-01-13','09:00:00',1.33),('16273','2014-01-13','09:05:00',1.69),('16273','2014-01-13','09:10:00',1.69),('16273','2014-01-13','09:15:00',1.68),('16273','2014-01-13','09:20:00',1.72),('16273','2014-01-13','09:25:00',1.76),('16273','2014-01-13','09:30:00',1.82),('16273','2014-01-13','09:35:00',1.87),('16273','2014-01-13','09:40:00',1.9),('16273','2014-01-13','09:45:00',1.93),('16273','2014-01-13','09:50:00',1.99),('16273','2014-01-13','09:55:00',2.05),('16273','2014-01-13','10:00:00',2.08),('16273','2014-01-13','10:05:00',2.12),('16273','2014-01-13','10:10:00',2.18),('16273','2014-01-13','10:15:00',2.2),('16273','2014-01-13','10:20:00',2.22),('16273','2014-01-13','10:25:00',2.27),('16273','2014-01-13','10:30:00',2.29),('16273','2014-01-13','10:35:00',2.34),('16273','2014-01-13','10:40:00',2.35),('16273','2014-01-13','10:45:00',2.38),('16273','2014-01-13','10:50:00',2.4),('16273','2014-01-13','10:55:00',2.42),('16273','2014-01-13','11:00:00',2.42),('16273','2014-01-13','11:05:00',2.43),('16273','2014-01-13','11:10:00',2.47),('16273','2014-01-13','11:15:00',2.48),('16273','2014-01-13','11:20:00',2.48),('16273','2014-01-13','11:25:00',2.48),('16273','2014-01-13','11:30:00',2.46),('16273','2014-01-13','11:35:00',2.47),('16273','2014-01-13','11:40:00',2.46),('16273','2014-01-13','11:45:00',2.46),('16273','2014-01-13','11:50:00',2.41),('16273','2014-01-13','11:55:00',2.41),('16273','2014-01-13','12:00:00',2.45),('16273','2014-01-13','12:05:00',2.43),('16273','2014-01-13','12:10:00',2.4),('16273','2014-01-13','12:15:00',2.37),('16273','2014-01-13','12:20:00',2.33),('16273','2014-01-13','12:25:00',2.33),('16273','2014-01-13','12:30:00',2.33),('16273','2014-01-13','12:35:00',2.35),('16273','2014-01-13','12:40:00',2.28),('16273','2014-01-13','12:45:00',2.23),('16273','2014-01-13','12:50:00',2.14),('16273','2014-01-13','12:55:00',2.12),('16273','2014-01-13','13:00:00',2.08),('16273','2014-01-13','13:05:00',2.03),('16273','2014-01-13','13:10:00',2.09),('16273','2014-01-13','13:15:00',2.08),('16273','2014-01-13','13:20:00',2.09),('16273','2014-01-13','13:25:00',2.09),('16273','2014-01-13','13:30:00',2.07),('16273','2014-01-13','13:35:00',2),('16273','2014-01-13','13:40:00',1.93),('16273','2014-01-13','13:45:00',1.92),('16273','2014-01-13','13:50:00',1.89),('16273','2014-01-13','13:55:00',1.84),('16273','2014-01-13','14:00:00',1.7),('16273','2014-01-13','14:05:00',1.71),('16273','2014-01-13','14:10:00',1.66),('16273','2014-01-13','14:15:00',1.59),('16273','2014-01-13','14:20:00',1.53),('16273','2014-01-13','14:25:00',1.51),('16273','2014-01-13','14:30:00',1.44),('16273','2014-01-13','14:35:00',1.38),('16273','2014-01-13','14:40:00',1.35),('16273','2014-01-13','14:45:00',1.28),('16273','2014-01-13','14:50:00',1.22),('16273','2014-01-13','14:55:00',1.18),('16273','2014-01-13','15:00:00',1.13),('16273','2014-01-13','15:05:00',1.07),('16273','2014-01-13','15:10:00',1.01),('16273','2014-01-12','10:25:00',1.04),('16273','2014-01-12','10:30:00',1.08),('16273','2014-01-12','10:35:00',1.24),('16273','2014-01-12','10:40:00',1.28),('16273','2014-01-12','10:45:00',1.48),('16273','2014-01-12','10:50:00',1.61),('16273','2014-01-12','10:55:00',1.7),('16273','2014-01-12','11:00:00',1.55),('16273','2014-01-12','11:05:00',2.14),('16273','2014-01-12','11:10:00',1.88),('16273','2014-01-12','11:15:00',1.89),('16273','2014-01-12','11:20:00',1.62),('16273','2014-01-12','11:25:00',1.56),('16273','2014-01-12','11:30:00',1.64),('16273','2014-01-12','11:35:00',1.57),('16273','2014-01-12','11:40:00',1.61),('16273','2014-01-12','11:45:00',2.18),('16273','2014-01-12','11:50:00',1.58),('16273','2014-01-12','11:55:00',1.4),('16273','2014-01-12','12:00:00',1.25),('16273','2014-01-12','12:05:00',1.15),('16273','2014-01-12','12:10:00',1.1),('16273','2014-01-12','12:15:00',1.07),('16273','2014-01-12','12:20:00',1.04),('16273','2014-01-12','12:25:00',1.05),('16273','2014-01-12','12:30:00',1.03),('16273','2014-01-12','12:50:00',1.02),('16273','2014-01-12','13:00:00',1.02),('16273','2014-01-12','13:15:00',1.06),('16273','2014-01-12','13:20:00',1.12),('16273','2014-01-12','13:25:00',1.2),('16273','2014-01-12','13:30:00',1.19),('16273','2014-01-12','13:35:00',1.08),('16273','2014-01-12','13:40:00',1.04),('16273','2014-01-11','09:45:00',1.14),('16273','2014-01-11','09:50:00',1.67),('16273','2014-01-11','09:55:00',1.71),('16273','2014-01-11','10:00:00',1.27),('16273','2014-01-11','10:05:00',1.4),('16273','2014-01-11','10:10:00',1.6),('16273','2014-01-11','10:15:00',1.67),('16273','2014-01-11','10:20:00',1.91),('16273','2014-01-11','10:25:00',1.78),('16273','2014-01-11','10:30:00',2.12),('16273','2014-01-11','10:35:00',2.18),('16273','2014-01-11','10:40:00',2.52),('16273','2014-01-11','10:45:00',2.5),('16273','2014-01-11','10:50:00',2.47),('16273','2014-01-11','10:55:00',2.33),('16273','2014-01-11','11:00:00',2.28),('16273','2014-01-11','11:05:00',2.31),('16273','2014-01-11','11:10:00',2.14),('16273','2014-01-11','11:15:00',1.88),('16273','2014-01-11','11:20:00',1.62),('16273','2014-01-11','11:25:00',1.74),('16273','2014-01-11','11:30:00',1.81),('16273','2014-01-11','11:35:00',1.63),('16273','2014-01-11','11:40:00',1.78),('16273','2014-01-11','11:45:00',1.86),('16273','2014-01-11','11:50:00',1.78),('16273','2014-01-11','11:55:00',1.85),('16273','2014-01-11','12:00:00',1.71),('16273','2014-01-11','12:05:00',1.92),('16273','2014-01-11','12:10:00',2.16),('16273','2014-01-11','12:15:00',1.85),('16273','2014-01-11','12:20:00',1.22),('16273','2014-01-11','12:25:00',1.69),('16273','2014-01-11','12:30:00',1.86),('16273','2014-01-11','12:35:00',1.48),('16273','2014-01-11','12:40:00',1.26),('16273','2014-01-11','12:45:00',1.48),('16273','2014-01-11','12:50:00',1.53),('16273','2014-01-11','12:55:00',1.29),('16273','2014-01-11','13:00:00',1.66),('16273','2014-01-11','13:05:00',1.35),('16273','2014-01-11','13:10:00',1.07),('16273','2014-01-11','13:15:00',1.03),('16273','2014-01-11','14:00:00',1.08),('16273','2014-01-09','09:45:00',1.19),('16273','2014-01-09','09:50:00',1.48),('16273','2014-01-09','09:55:00',1.23),('16273','2014-01-09','10:00:00',1.04),('16273','2014-01-09','10:05:00',1.04),('16273','2014-01-09','10:10:00',1.09),('16273','2014-01-09','10:15:00',1.13),('16273','2014-01-09','10:35:00',1.04),('16273','2014-01-09','10:40:00',1.08),('16273','2014-01-09','10:45:00',1.01),('16273','2014-01-09','10:50:00',1.1),('16273','2014-01-09','10:55:00',1.29),('16273','2014-01-09','11:00:00',1.26),('16273','2014-01-09','11:05:00',1.3),('16273','2014-01-09','11:10:00',1.35),('16273','2014-01-09','11:15:00',1.29),('16273','2014-01-09','11:20:00',1.38),('16273','2014-01-09','11:25:00',1.37),('16273','2014-01-09','11:30:00',1.43),('16273','2014-01-09','11:35:00',1.4),('16273','2014-01-09','11:40:00',1.62),('16273','2014-01-09','11:45:00',1.3),('16273','2014-01-09','11:50:00',1.23),('16273','2014-01-09','11:55:00',1.23),('16273','2014-01-09','12:00:00',1.3),('16273','2014-01-09','12:05:00',1.57),('16273','2014-01-09','12:10:00',1.63),('16273','2014-01-09','12:15:00',1.33),('16273','2014-01-09','12:20:00',1.18),('16273','2014-01-09','12:25:00',1.33),('16273','2014-01-09','12:30:00',1.36),('16273','2014-01-09','12:35:00',1.26),('16273','2014-01-09','12:40:00',1.35),('16273','2014-01-09','12:45:00',1.44),('16273','2014-01-09','12:50:00',1.61),('16273','2014-01-09','12:55:00',1.81),('16273','2014-01-09','13:00:00',1.7),('16273','2014-01-09','13:05:00',1.49),('16273','2014-01-09','13:10:00',1.4),('16273','2014-01-09','13:15:00',1.07),('16273','2014-01-09','13:20:00',1.01),('16273','2014-01-09','13:25:00',1.04),('16273','2014-01-09','13:30:00',1.07),('16273','2014-01-09','13:35:00',1.07),('16273','2014-01-08','08:55:00',1.34),('16273','2014-01-08','09:00:00',1.43),('16273','2014-01-08','09:05:00',1.57),('16273','2014-01-08','09:10:00',1.58),('16273','2014-01-08','09:15:00',1.7),('16273','2014-01-08','09:20:00',1.78),('16273','2014-01-08','09:25:00',1.79),('16273','2014-01-08','09:30:00',1.74),('16273','2014-01-08','09:35:00',1.91),('16273','2014-01-08','09:40:00',1.85),('16273','2014-01-08','09:45:00',1.72),('16273','2014-01-08','09:50:00',1.96),('16273','2014-01-08','09:55:00',2.01),('16273','2014-01-08','10:00:00',1.89),('16273','2014-01-08','10:05:00',1.98),('16273','2014-01-08','10:10:00',2.13),('16273','2014-01-08','10:15:00',2.25),('16273','2014-01-08','10:20:00',2.3),('16273','2014-01-08','10:25:00',2.29),('16273','2014-01-08','10:30:00',2.37),('16273','2014-01-08','10:35:00',2.35),('16273','2014-01-08','10:40:00',2.39),('16273','2014-01-08','10:45:00',2.41),('16273','2014-01-08','10:50:00',2.43),('16273','2014-01-08','10:55:00',2.42),('16273','2014-01-08','11:00:00',2.45),('16273','2014-01-08','11:05:00',2.46),('16273','2014-01-08','11:10:00',2.48),('16273','2014-01-08','11:15:00',2.45),('16273','2014-01-08','11:20:00',2.31),('16273','2014-01-08','11:25:00',2.37),('16273','2014-01-08','11:30:00',2.47),('16273','2014-01-08','11:35:00',2.48),('16273','2014-01-08','11:40:00',2.49),('16273','2014-01-08','11:45:00',2.49),('16273','2014-01-08','11:50:00',2.5),('16273','2014-01-08','11:55:00',2.48),('16273','2014-01-08','12:00:00',2.46),('16273','2014-01-08','12:05:00',2.35),('16273','2014-01-08','12:10:00',2.4),('16273','2014-01-08','12:15:00',2.42),('16273','2014-01-08','12:20:00',2.39),('16273','2014-01-08','12:25:00',2.4),('16273','2014-01-08','12:30:00',2.37),('16273','2014-01-08','12:35:00',2.3),('16273','2014-01-08','12:40:00',2.17),('16273','2014-01-08','12:45:00',2.28),('16273','2014-01-08','12:50:00',2.17),('16273','2014-01-08','12:55:00',2.17),('16273','2014-01-08','13:00:00',2.15),('16273','2014-01-08','13:05:00',2.11),('16273','2014-01-08','13:10:00',2.14),('16273','2014-01-08','13:15:00',2.12),('16273','2014-01-08','13:20:00',2.12),('16273','2014-01-08','13:25:00',2.05),('16273','2014-01-08','13:30:00',2),('16273','2014-01-08','13:35:00',2),('16273','2014-01-08','13:40:00',1.93),('16273','2014-01-08','13:45:00',1.89),('16273','2014-01-08','13:50:00',1.82),('16273','2014-01-08','13:55:00',1.74),('16273','2014-01-08','14:00:00',1.72),('16273','2014-01-08','14:05:00',1.71),('16273','2014-01-08','14:10:00',1.63),('16273','2014-01-08','14:15:00',1.63),('16273','2014-01-08','14:20:00',1.48),('16273','2014-01-08','14:25:00',1.39),('16273','2014-01-08','14:30:00',1.4),('16273','2014-01-08','14:35:00',1.27),('16273','2014-01-08','14:40:00',1.18),('16273','2014-01-08','14:45:00',1.06),('16273','2014-01-08','14:55:00',1.03),('16273','2014-01-07','08:45:00',1.16),('16273','2014-01-07','08:50:00',1.13),('16273','2014-01-07','08:55:00',1.42),('16273','2014-01-07','09:00:00',1.51),('16273','2014-01-07','09:05:00',1.61),('16273','2014-01-07','09:10:00',1.69),('16273','2014-01-07','09:15:00',1.74),('16273','2014-01-07','09:20:00',1.8),('16273','2014-01-07','09:25:00',1.86),('16273','2014-01-07','09:30:00',1.92),('16273','2014-01-07','09:35:00',2),('16273','2014-01-07','09:40:00',2.06),('16273','2014-01-07','09:45:00',2.1),('16273','2014-01-07','09:50:00',2.17),('16273','2014-01-07','09:55:00',2.22),('16273','2014-01-07','10:00:00',2.27),('16273','2014-01-07','10:05:00',2.33),('16273','2014-01-07','10:10:00',2.35),('16273','2014-01-07','10:15:00',2.38),('16273','2014-01-07','10:20:00',2.42),('16273','2014-01-07','10:25:00',2.43),('16273','2014-01-07','10:30:00',2.47),('16273','2014-01-07','10:35:00',2.5),('16273','2014-01-07','10:40:00',2.48),('16273','2014-01-07','10:45:00',2.49),('16273','2014-01-07','10:50:00',2.51),('16273','2014-01-07','10:55:00',2.5),('16273','2014-01-07','11:00:00',2.54),('16273','2014-01-07','11:05:00',2.57),('16273','2014-01-07','11:10:00',2.58),('16273','2014-01-07','11:15:00',2.59),('16273','2014-01-07','11:20:00',2.59),('16273','2014-01-07','11:25:00',2.59),('16273','2014-01-07','11:30:00',2.6),('16273','2014-01-07','11:35:00',2.58),('16273','2014-01-07','11:40:00',2.56),('16273','2014-01-07','11:45:00',2.53),('16273','2014-01-07','11:50:00',2.45),('16273','2014-01-07','11:55:00',2.44),('16273','2014-01-07','12:00:00',2.44),('16273','2014-01-07','12:05:00',2.44),('16273','2014-01-07','12:10:00',2.46),('16273','2014-01-07','12:15:00',2.48),('16273','2014-01-07','12:20:00',2.47),('16273','2014-01-07','12:25:00',2.48),('16273','2014-01-07','12:30:00',2.48),('16273','2014-01-07','12:35:00',2.44),('16273','2014-01-07','12:40:00',2.38),('16273','2014-01-07','12:45:00',2.29),('16273','2014-01-07','12:50:00',2.33),('16273','2014-01-07','12:55:00',2.34),('16273','2014-01-07','13:00:00',2.32),('16273','2014-01-07','13:05:00',2.24),('16273','2014-01-07','13:10:00',2.2),('16273','2014-01-07','13:15:00',2.09),('16273','2014-01-07','13:20:00',2.06),('16273','2014-01-07','13:25:00',2.04),('16273','2014-01-07','13:30:00',2.06),('16273','2014-01-07','13:35:00',1.99),('16273','2014-01-07','13:40:00',1.96),('16273','2014-01-07','13:45:00',1.93),('16273','2014-01-07','13:50:00',1.92),('16273','2014-01-07','13:55:00',1.79),('16273','2014-01-07','14:00:00',1.77),('16273','2014-01-07','14:05:00',1.67),('16273','2014-01-07','14:10:00',1.63),('16273','2014-01-07','14:15:00',1.59),('16273','2014-01-07','14:20:00',1.54),('16273','2014-01-07','14:25:00',1.51),('16273','2014-01-07','14:30:00',1.48),('16273','2014-01-07','14:35:00',1.43),('16273','2014-01-07','14:40:00',1.36),('16273','2014-01-07','14:45:00',1.21),('16273','2014-01-07','14:50:00',1.21),('16273','2014-01-07','14:55:00',1.14),('16273','2014-01-07','15:00:00',1.15),('16273','2014-01-07','15:05:00',1.09),('16273','2014-04-24','07:35:00',1.08),('16273','2014-04-24','07:40:00',1.03),('16273','2014-04-24','07:45:00',1.29),('16273','2014-04-24','07:50:00',1.38),('16273','2014-04-24','07:55:00',1.47),('16273','2014-04-24','08:00:00',1.55),('16273','2014-04-24','08:05:00',1.63),('16273','2014-04-24','08:10:00',1.72),('16273','2014-04-24','08:15:00',1.8),('16273','2014-04-24','08:20:00',1.88),('16273','2014-04-24','08:25:00',1.96),('16273','2014-04-24','08:30:00',2.04),('16273','2014-04-24','08:35:00',2.12),('16273','2014-04-24','08:40:00',2.19),('16273','2014-04-24','08:45:00',2.28),('16273','2014-04-24','08:50:00',2.34),('16273','2014-04-24','08:55:00',2.4),('16273','2014-04-24','09:00:00',2.47),('16273','2014-04-24','09:05:00',2.52),('16273','2014-04-24','09:10:00',2.6),('16273','2014-04-24','09:15:00',2.66),('16273','2014-04-24','09:20:00',2.7),('16273','2014-04-24','09:25:00',2.76),('16273','2014-04-24','09:30:00',2.78),('16273','2014-04-24','09:35:00',2.85),('16273','2014-04-24','09:40:00',2.91),('16273','2014-04-24','09:45:00',2.93),('16273','2014-04-24','09:50:00',2.95),('16273','2014-04-24','09:55:00',3.02),('16273','2014-04-24','10:00:00',3.09),('16273','2014-04-24','10:05:00',3.13),('16273','2014-04-24','10:10:00',3.16),('16273','2014-04-24','10:15:00',3.18),('16273','2014-04-24','10:20:00',3.23),('16273','2014-04-24','10:25:00',3.34),('16273','2014-04-24','10:30:00',3.38),('16273','2014-04-24','10:35:00',3.51),('16273','2014-04-24','10:40:00',3.63),('16273','2014-04-24','10:45:00',3.55),('16273','2014-04-24','10:50:00',3.52),('16273','2014-04-24','10:55:00',3.58),('16273','2014-04-24','11:00:00',3.55),('16273','2014-04-24','11:05:00',3.61),('16273','2014-04-24','11:10:00',3.63),('16273','2014-04-24','11:15:00',3.61),('16273','2014-04-24','11:20:00',3.64),('16273','2014-04-24','11:25:00',3.68),('16273','2014-04-24','11:30:00',3.7),('16273','2014-04-24','11:35:00',3.71),('16273','2014-04-24','11:40:00',3.7),('16273','2014-04-24','11:45:00',3.7),('16273','2014-04-24','11:50:00',3.75),('16273','2014-04-24','11:55:00',3.77),('16273','2014-04-24','12:00:00',3.9),('16273','2014-04-24','12:05:00',3.93),('16273','2014-04-24','12:10:00',3.84),('16273','2014-04-24','12:15:00',3.81),('16273','2014-04-24','12:20:00',3.65),('16273','2014-04-24','12:25:00',3.82),('16273','2014-04-24','12:30:00',3.75),('16273','2014-04-24','12:35:00',3.78),('16273','2014-04-24','12:40:00',3.77),('16273','2014-04-24','12:45:00',3.75),('16273','2014-04-24','12:50:00',3.75),('16273','2014-04-24','12:55:00',3.76),('16273','2014-04-24','13:00:00',3.85),('16273','2014-04-24','13:05:00',3.85),('16273','2014-04-24','13:10:00',3.75),('16273','2014-04-24','13:15:00',3.31),('16273','2014-04-24','13:20:00',2.73),('16273','2014-04-24','13:25:00',3.84),('16273','2014-04-24','13:30:00',3.92),('16273','2014-04-24','13:35:00',3.93),('16273','2014-04-24','13:40:00',3.84),('16273','2014-04-24','13:45:00',3.69),('16273','2014-04-24','13:50:00',3.67),('16273','2014-04-24','13:55:00',3.63),('16273','2014-04-24','14:00:00',3.62),('16273','2014-04-24','14:05:00',3.61),('16273','2014-04-24','14:10:00',3.58),('16273','2014-04-24','14:15:00',3.54),('16273','2014-04-24','14:20:00',3.52),('16273','2014-04-24','14:25:00',3.5),('16273','2014-04-24','14:30:00',3.48),('16273','2014-04-24','14:35:00',3.49),('16273','2014-04-24','14:40:00',3.45),('16273','2014-04-24','14:45:00',3.38),('16273','2014-04-24','14:50:00',3.31),('16273','2014-04-24','14:55:00',3.25),('16273','2014-04-24','15:00:00',3.24),('16273','2014-04-24','15:05:00',3.11),('16273','2014-04-24','15:10:00',2.78),('16273','2014-04-24','15:15:00',3.48),('16273','2014-04-24','15:20:00',3.16),('16273','2014-04-24','15:25:00',2.56),('16273','2014-04-24','15:30:00',1.8),('16273','2014-04-24','15:35:00',3.33),('16273','2014-04-24','15:40:00',2.65),('16273','2014-04-24','15:45:00',3.19),('16273','2014-04-24','15:50:00',2.83),('16273','2014-04-24','15:55:00',2.69),('16273','2014-04-24','16:00:00',2.39),('16273','2014-04-24','16:05:00',1.71),('16273','2014-04-24','16:10:00',1.71),('16273','2014-04-24','16:15:00',2.23),('16273','2014-04-24','16:20:00',2.61),('16273','2014-04-24','16:25:00',2.48),('16273','2014-04-24','16:30:00',2.49),('16273','2014-04-24','16:35:00',2.47),('16273','2014-04-24','16:40:00',2.24),('16273','2014-04-24','16:45:00',1.75),('16273','2014-04-24','16:50:00',1.29),('16273','2014-04-24','16:55:00',1.11),('16273','2014-04-24','17:00:00',1.03),('16273','2014-04-24','17:05:00',1.17),('16273','2014-04-24','17:10:00',1.29),('16273','2014-04-24','17:15:00',1.25),('16273','2014-04-24','17:20:00',1.23),('16273','2014-04-24','17:25:00',1.03),('16273','2014-01-06','11:15:00',1.01),('16273','2014-01-06','11:20:00',1.13),('16273','2014-01-06','11:25:00',1.07),('16273','2014-01-06','11:30:00',1.5),('16273','2014-01-06','11:35:00',2.94),('16273','2014-01-06','11:40:00',2.73),('16273','2014-01-06','11:45:00',2.72),('16273','2014-01-06','11:50:00',2.66),('16273','2014-01-06','11:55:00',2.59),('16273','2014-01-06','12:00:00',2.44),('16273','2014-01-06','12:05:00',2.51),('16273','2014-01-06','12:10:00',2.57),('16273','2014-01-06','12:15:00',2.52),('16273','2014-01-06','12:20:00',2.47),('16273','2014-01-06','12:25:00',2.45),('16273','2014-01-06','12:30:00',2.4),('16273','2014-01-06','12:35:00',2.41),('16273','2014-01-06','12:40:00',2.38),('16273','2014-01-06','12:45:00',2.34),('16273','2014-01-06','12:50:00',2.26),('16273','2014-01-06','12:55:00',2.21),('16273','2014-01-06','13:00:00',2.22),('16273','2014-01-06','13:05:00',2.19),('16273','2014-01-06','13:10:00',2.18),('16273','2014-01-06','13:15:00',2.15),('16273','2014-01-06','13:20:00',2.11),('16273','2014-01-06','13:25:00',2.07),('16273','2014-01-06','13:30:00',2),('16273','2014-01-06','13:35:00',1.96),('16273','2014-01-06','13:40:00',1.99),('16273','2014-01-06','13:45:00',1.91),('16273','2014-01-06','13:50:00',1.84),('16273','2014-01-06','13:55:00',1.76),('16273','2014-01-06','14:00:00',1.72),('16273','2014-01-06','14:05:00',1.69),('16273','2014-01-06','14:10:00',1.67),('16273','2014-01-06','14:15:00',1.67),('16273','2014-01-06','14:20:00',1.59),('16273','2014-01-06','14:25:00',1.6),('16273','2014-01-06','14:30:00',1.65),('16273','2014-01-06','14:35:00',1.83),('16273','2014-01-06','14:40:00',1.5),('16273','2014-01-06','14:45:00',1.34),('16273','2014-01-06','14:50:00',1.25),('16273','2014-01-06','14:55:00',1.18),('16273','2014-01-06','15:00:00',1.15),('16273','2014-01-06','15:05:00',1.1),('16273','2014-01-03','08:50:00',1.21),('16273','2014-01-03','08:55:00',1.32),('16273','2014-01-03','09:00:00',1.22),('16273','2014-01-03','09:05:00',1.52),('16273','2014-01-03','09:10:00',1.62),('16273','2014-01-03','09:15:00',1.75),('16273','2014-01-03','09:20:00',2),('16273','2014-01-03','09:25:00',2.2),('16273','2014-01-03','09:30:00',2.23),('16273','2014-01-03','09:35:00',1.57),('16273','2014-01-03','09:45:00',1.46),('16273','2014-01-03','09:50:00',2.38),('16273','2014-01-03','09:55:00',2.4),('16273','2014-01-03','10:00:00',2.56),('16273','2014-01-03','10:05:00',1.76),('16273','2014-01-03','10:10:00',1.13),('16273','2014-01-03','10:25:00',1.07),('16273','2014-01-03','10:30:00',1.2),('16273','2014-01-03','10:35:00',1.1),('16273','2014-01-03','10:40:00',1.09),('16273','2014-01-03','10:45:00',1.19),('16273','2014-01-03','10:50:00',1.47),('16273','2014-01-03','10:55:00',1.36),('16273','2014-01-03','11:00:00',1.47),('16273','2014-01-03','11:05:00',1.86),('16273','2014-01-03','11:10:00',1.43),('16273','2014-01-03','11:15:00',1.22),('16273','2014-01-03','11:35:00',1.12),('16273','2014-01-03','11:40:00',1.57),('16273','2014-01-03','11:45:00',1.95),('16273','2014-01-03','11:50:00',1.49),('16273','2014-01-03','11:55:00',1.21),('16273','2014-01-03','12:00:00',1.5),('16273','2014-01-03','12:05:00',2.09),('16273','2014-01-03','12:10:00',2.79),('16273','2014-01-03','12:15:00',2.75),('16273','2014-01-03','12:20:00',1.56),('16273','2014-01-03','12:25:00',1.67),('16273','2014-01-03','12:30:00',1.63),('16273','2014-01-03','12:35:00',1.64),('16273','2014-01-03','12:40:00',1.46),('16273','2014-01-03','12:45:00',1.73),('16273','2014-01-03','12:50:00',1.76),('16273','2014-01-03','12:55:00',1.18),('16273','2014-01-03','13:00:00',1.47),('16273','2014-01-03','13:05:00',2.46),('16273','2014-01-03','13:10:00',1.81),('16273','2014-01-03','13:15:00',1.73),('16273','2014-01-03','13:20:00',1.37),('16273','2014-01-03','13:25:00',1.64),('16273','2014-01-03','13:30:00',1.37),('16273','2014-01-03','13:35:00',1.32),('16273','2014-01-03','13:40:00',1.08),('16273','2014-01-02','08:45:00',1.18),('16273','2014-01-02','08:50:00',1.3),('16273','2014-01-02','08:55:00',1.22),('16273','2014-01-02','09:00:00',1.5),('16273','2014-01-02','09:05:00',1.57),('16273','2014-01-02','09:10:00',1.64),('16273','2014-01-02','09:15:00',1.68),('16273','2014-01-02','09:20:00',1.74),('16273','2014-01-02','09:25:00',1.82),('16273','2014-01-02','09:30:00',1.89),('16273','2014-01-02','09:35:00',1.94),('16273','2014-01-02','09:40:00',1.99),('16273','2014-01-02','09:45:00',2.02),('16273','2014-01-02','09:50:00',2.06),('16273','2014-01-02','09:55:00',2.13),('16273','2014-01-02','10:00:00',2.16),('16273','2014-01-02','10:05:00',2.22),('16273','2014-01-02','10:10:00',2.26),('16273','2014-01-02','10:15:00',2.28),('16273','2014-01-02','10:20:00',2.32),('16273','2014-01-02','10:25:00',2.38),('16273','2014-01-02','10:30:00',2.28),('16273','2014-01-02','10:35:00',2.46),('16273','2014-01-02','10:40:00',2.52),('16273','2014-01-02','10:45:00',2.42),('16273','2014-01-02','10:50:00',1.62),('16273','2014-01-02','10:55:00',1.7),('16273','2014-01-02','11:00:00',1.6),('16273','2014-01-02','11:05:00',1.67),('16273','2014-01-02','11:10:00',1.24),('16273','2014-01-02','11:15:00',1.18),('16273','2014-01-02','11:20:00',1.24),('16273','2014-01-02','11:25:00',1.36),('16273','2014-01-02','11:30:00',1.7),('16273','2014-01-02','11:35:00',1.67),('16273','2014-01-02','11:40:00',1.3),('16273','2014-01-02','11:45:00',1.25),('16273','2014-01-02','11:50:00',1.13),('16273','2014-01-02','11:55:00',1.09),('16273','2014-01-02','12:00:00',1.04),('16273','2014-01-02','12:35:00',1.05),('16273','2014-01-02','12:40:00',1.37),('16273','2014-01-02','12:45:00',2.14),('16273','2014-01-02','12:50:00',2.82),('16273','2014-01-02','12:55:00',1.24),('16273','2014-01-02','13:00:00',1.38),('16273','2014-01-02','13:20:00',1.47),('16273','2014-01-02','13:25:00',1.64),('16273','2014-01-02','13:30:00',1.14),('16273','2014-01-01','08:45:00',1.12),('16273','2014-01-01','11:30:00',1),('16273','2014-01-01','11:35:00',1.05),('16273','2014-01-01','11:40:00',1.06),('16273','2014-01-01','11:45:00',1.09),('16273','2014-01-01','11:50:00',1.22),('16273','2014-01-01','11:55:00',1.16),('16273','2014-01-01','12:00:00',1.25),('16273','2014-01-01','12:05:00',1.24),('16273','2014-01-01','12:10:00',1.19),('16273','2014-01-01','12:15:00',1.13),('16273','2014-01-01','12:20:00',1.23),('16273','2014-01-01','12:25:00',1.99),('16273','2014-01-01','12:30:00',2.65),('16273','2014-01-01','12:35:00',2.05),('16273','2014-01-01','12:40:00',1.4),('16273','2014-01-01','12:45:00',2.62),('16273','2014-01-01','12:50:00',1.56),('16273','2014-01-01','12:55:00',1.43),('16273','2014-01-01','13:00:00',1.15),('16273','2014-01-01','13:05:00',1.04),('16273','2014-01-01','13:10:00',1.16),('16273','2014-01-01','13:15:00',1.14),('16273','2014-01-01','13:20:00',1.06),('16273','2014-01-01','13:25:00',1.13),('16273','2014-01-01','13:30:00',1.33),('16273','2014-01-01','13:35:00',1.6),('16273','2014-01-01','13:40:00',1.32),('16273','2014-01-01','13:45:00',1.49),('16273','2014-01-01','13:50:00',1.73),('16273','2014-01-01','13:55:00',1.29),('16273','2014-01-01','14:00:00',1.18),('16273','2014-01-01','14:05:00',1.65),('16273','2014-01-01','14:10:00',1.9),('16273','2014-01-01','14:15:00',1.14),('16273','2014-01-01','14:55:00',1.02),('16273','2014-01-01','15:05:00',1.08),('16273','2013-12-31','08:50:00',1.09),('16273','2013-12-31','08:55:00',1.46),('16273','2013-12-31','09:00:00',1.38),('16273','2013-12-31','09:05:00',1.66),('16273','2013-12-31','09:10:00',1.5),('16273','2013-12-31','09:15:00',1.85),('16273','2013-12-31','09:20:00',1.87),('16273','2013-12-31','09:25:00',2.08),('16273','2013-12-31','09:30:00',1.88),('16273','2013-12-31','09:35:00',1.58),('16273','2013-12-31','09:40:00',1.13),('16273','2013-12-31','10:05:00',1.42),('16273','2013-12-31','10:10:00',1.16),('16273','2013-12-31','11:00:00',1.05),('16273','2013-12-31','11:05:00',1.18),('16273','2013-12-31','11:10:00',1.36),('16273','2013-12-31','11:15:00',1.73),('16273','2013-12-31','11:20:00',2.44),('16273','2013-12-31','11:25:00',2.22),('16273','2013-12-31','11:30:00',2.53),('16273','2013-12-31','11:35:00',3.2),('16273','2013-12-31','11:40:00',2.96),('16273','2013-12-31','11:45:00',1.84),('16273','2013-12-31','11:50:00',1.96),('16273','2013-12-31','11:55:00',1.47),('16273','2013-12-31','12:00:00',2.23),('16273','2013-12-31','12:05:00',1.67),('16273','2013-12-31','12:10:00',2.1),('16273','2013-12-31','12:15:00',2.56),('16273','2013-12-31','12:20:00',2.54),('16273','2013-12-31','12:25:00',2.46),('16273','2013-12-31','12:30:00',2.42),('16273','2013-12-31','12:35:00',2.39),('16273','2013-12-31','12:40:00',2.34),('16273','2013-12-31','12:45:00',2.32),('16273','2013-12-31','12:50:00',2.29),('16273','2013-12-31','12:55:00',2.24),('16273','2013-12-31','13:00:00',2.21),('16273','2013-12-31','13:05:00',2.2),('16273','2013-12-31','13:10:00',2.15),('16273','2013-12-31','13:15:00',2.11),('16273','2013-12-31','13:20:00',2.07),('16273','2013-12-31','13:25:00',2.02),('16273','2013-12-31','13:30:00',1.98),('16273','2013-12-31','13:35:00',1.93),('16273','2013-12-31','13:40:00',1.9),('16273','2013-12-31','13:45:00',1.85),('16273','2013-12-31','13:50:00',1.79),('16273','2013-12-31','13:55:00',1.74),('16273','2013-12-31','14:00:00',1.69),('16273','2013-12-31','14:05:00',1.63),('16273','2013-12-31','14:10:00',1.59),('16273','2013-12-31','14:15:00',1.54),('16273','2013-12-31','14:20:00',1.48),('16273','2013-12-31','14:25:00',1.42),('16273','2013-12-31','14:30:00',1.36),('16273','2013-12-31','14:35:00',1.29),('16273','2013-12-31','14:40:00',1.25),('16273','2013-12-31','14:45:00',1.19),('16273','2013-12-31','14:50:00',1.13),('16273','2013-12-31','14:55:00',1.08),('16273','2013-12-31','15:00:00',1.02),('16273','2013-12-29','08:55:00',1.16),('16273','2013-12-29','09:00:00',1.34),('16273','2013-12-29','09:05:00',1.4),('16273','2013-12-29','09:10:00',1.49),('16273','2013-12-29','09:15:00',1.71),('16273','2013-12-29','09:20:00',1.8),('16273','2013-12-29','09:25:00',1.97),('16273','2013-12-29','09:30:00',2.21),('16273','2013-12-29','09:35:00',2.4),('16273','2013-12-29','09:40:00',2.13),('16273','2013-12-29','09:45:00',1.8),('16273','2013-12-29','09:50:00',1.81),('16273','2013-12-29','09:55:00',2.06),('16273','2013-12-29','10:00:00',1.94),('16273','2013-12-29','10:05:00',2.22),('16273','2013-12-29','10:10:00',2.24),('16273','2013-12-29','10:15:00',1.83),('16273','2013-12-29','10:20:00',2.21),('16273','2013-12-29','10:25:00',1.94),('16273','2013-12-29','10:30:00',1.55),('16273','2013-12-29','10:35:00',1.12),('16273','2013-12-29','11:15:00',1.1),('16273','2013-12-29','11:20:00',2.26),('16273','2013-12-29','11:25:00',1.72),('16273','2013-12-29','11:30:00',1.17),('16273','2013-12-29','11:35:00',1.13),('16273','2013-12-28','08:45:00',1.23),('16273','2013-12-28','08:50:00',1.13),('16273','2013-12-28','08:55:00',1.47),('16273','2013-12-28','09:00:00',1.55),('16273','2013-12-28','09:05:00',1.63),('16273','2013-12-28','09:10:00',1.69),('16273','2013-12-28','09:15:00',1.76),('16273','2013-12-28','09:20:00',1.83),('16273','2013-12-28','09:25:00',1.9),('16273','2013-12-28','09:30:00',1.96),('16273','2013-12-28','09:35:00',2.01),('16273','2013-12-28','09:40:00',2.06),('16273','2013-12-28','09:45:00',2.12),('16273','2013-12-28','09:50:00',2.15),('16273','2013-12-28','09:55:00',2.19),('16273','2013-12-28','10:00:00',2.23),('16273','2013-12-28','10:05:00',2.27),('16273','2013-12-28','10:10:00',2.31),('16273','2013-12-28','10:15:00',2.34),('16273','2013-12-28','10:20:00',2.37),('16273','2013-12-28','10:25:00',2.4),('16273','2013-12-28','10:30:00',2.42),('16273','2013-12-28','10:35:00',2.45),('16273','2013-12-28','10:40:00',2.47),('16273','2013-12-28','10:45:00',2.49),('16273','2013-12-28','10:50:00',2.5),('16273','2013-12-28','10:55:00',2.51),('16273','2013-12-28','11:00:00',2.5),('16273','2013-12-28','11:05:00',2.52),('16273','2013-12-28','11:10:00',2.52),('16273','2013-12-28','11:15:00',2.51),('16273','2013-12-28','11:20:00',2.53),('16273','2013-12-28','11:25:00',2.53),('16273','2013-12-28','11:30:00',2.51),('16273','2013-12-28','11:35:00',2.5),('16273','2013-12-28','11:40:00',2.53),('16273','2013-12-28','11:45:00',2.51),('16273','2013-12-28','11:50:00',2.5),('16273','2013-12-28','11:55:00',2.5),('16273','2013-12-28','12:00:00',2.48),('16273','2013-12-28','12:05:00',2.48),('16273','2013-12-28','12:10:00',2.47),('16273','2013-12-28','12:15:00',2.45),('16273','2013-12-28','12:20:00',2.4),('16273','2013-12-28','12:25:00',2.39),('16273','2013-12-28','12:30:00',2.34),('16273','2013-12-28','12:35:00',2.32),('16273','2013-12-28','12:40:00',2.29),('16273','2013-12-28','12:45:00',2.26),('16273','2013-12-28','12:50:00',2.21),('16273','2013-12-28','12:55:00',2.15),('16273','2013-12-28','13:00:00',2.15),('16273','2013-12-28','13:05:00',2.11),('16273','2013-12-28','13:10:00',2.05),('16273','2013-12-28','13:15:00',2),('16273','2013-12-28','13:20:00',1.99),('16273','2013-12-28','13:25:00',1.92),('16273','2013-12-28','13:30:00',1.88),('16273','2013-12-28','13:35:00',1.86),('16273','2013-12-28','13:40:00',1.8),('16273','2013-12-28','13:45:00',1.75),('16273','2013-12-28','13:50:00',1.73),('16273','2013-12-28','13:55:00',1.69),('16273','2013-12-28','14:00:00',1.62),('16273','2013-12-28','14:05:00',1.58),('16273','2013-12-28','14:10:00',1.54),('16273','2013-12-28','14:15:00',1.5),('16273','2013-12-28','14:20:00',1.45),('16273','2013-12-28','14:25:00',1.4),('16273','2013-12-28','14:30:00',1.35),('16273','2013-12-28','14:35:00',1.17),('16273','2013-12-28','14:50:00',1.22),('16273','2013-12-28','14:55:00',1.17),('16273','2013-12-28','15:00:00',1.08),('16273','2014-04-23','10:50:00',1.08),('16273','2014-04-23','10:55:00',1.09),('16273','2014-04-23','11:00:00',1.08),('16273','2014-04-23','11:05:00',1.08),('16273','2014-04-23','11:10:00',1.04),('16273','2014-04-23','11:15:00',1.03),('16273','2014-04-23','13:15:00',1.03),('16273','2014-04-23','13:20:00',1.03),('16273','2014-04-23','13:25:00',1.08),('16273','2014-04-23','13:30:00',1.11),('16273','2014-04-23','13:35:00',1.24),('16273','2014-04-23','13:40:00',1.33),('16273','2014-04-23','13:45:00',1.47),('16273','2014-04-23','13:50:00',1.49),('16273','2014-04-23','13:55:00',1.47),('16273','2014-04-23','14:00:00',1.46),('16273','2014-04-23','14:05:00',1.41),('16273','2014-04-23','14:10:00',1.39),('16273','2014-04-23','14:15:00',1.35),('16273','2014-04-23','14:20:00',1.28),('16273','2014-04-23','14:25:00',1.23),('16273','2014-04-23','14:30:00',1.19),('16273','2014-04-23','14:35:00',1.03),('16273','2014-04-23','15:15:00',1.06),('16273','2014-04-23','15:20:00',1.11),('16273','2014-04-23','15:25:00',1.14),('16273','2014-04-23','15:30:00',1.18),('16273','2014-04-23','15:35:00',1.09),('16273','2013-12-27','11:50:00',1.11),('16273','2013-12-27','11:55:00',1.16),('16273','2013-12-27','12:00:00',1.47),('16273','2013-12-27','12:05:00',2.41),('16273','2013-12-27','12:10:00',1.89),('16273','2013-12-27','12:15:00',1.03),('16273','2013-12-27','12:40:00',1.03),('16273','2013-12-27','12:45:00',1.38),('16273','2013-12-27','12:50:00',2),('16273','2013-12-27','12:55:00',1.99),('16273','2013-12-27','13:00:00',1.98),('16273','2013-12-27','13:05:00',1.98),('16273','2013-12-27','13:10:00',1.95),('16273','2013-12-27','13:15:00',1.95),('16273','2013-12-27','13:20:00',1.93),('16273','2013-12-27','13:25:00',2.23),('16273','2013-12-27','13:30:00',1.52),('16273','2013-12-27','13:35:00',1.23),('16273','2013-12-27','13:40:00',1.15),('16273','2013-12-27','13:45:00',1.05),('16273','2013-12-27','13:50:00',1),('16273','2013-12-27','13:55:00',1.05),('16273','2013-12-27','14:00:00',1.2),('16273','2013-12-27','14:05:00',1.37),('16273','2013-12-27','14:10:00',1.45),('16273','2013-12-27','14:35:00',1.01),('16273','2013-12-25','10:40:00',1.04),('16273','2013-12-25','11:05:00',1.41),('16273','2013-12-25','11:10:00',1.17),('16273','2013-12-25','11:15:00',1.81),('16273','2013-12-25','11:20:00',1.73),('16273','2013-12-25','11:45:00',1.22),('16273','2013-12-25','11:50:00',1.91),('16273','2013-12-25','11:55:00',1.95),('16273','2013-12-25','12:00:00',2.18),('16273','2013-12-25','12:05:00',2.55),('16273','2013-12-25','12:10:00',1.8),('16273','2013-12-25','12:15:00',1.82),('16273','2013-12-25','12:20:00',1.01),('16273','2013-12-25','12:25:00',2.74),('16273','2013-12-25','12:30:00',2.62),('16273','2013-12-25','12:35:00',1.13),('16273','2013-12-25','12:45:00',1.02),('16273','2013-12-25','12:55:00',1.05),('16273','2013-12-25','13:25:00',1.12),('16273','2013-12-25','13:35:00',1.27),('16273','2013-12-25','13:40:00',1.26),('16273','2013-12-25','13:45:00',1.22),('16273','2013-12-24','08:45:00',1.09),('16273','2013-12-24','08:50:00',1.23),('16273','2013-12-24','08:55:00',1.12),('16273','2013-12-24','09:00:00',1.37),('16273','2013-12-24','09:05:00',1.47),('16273','2013-12-24','09:10:00',1.53),('16273','2013-12-24','09:15:00',1.61),('16273','2013-12-24','09:20:00',1.67),('16273','2013-12-24','09:25:00',1.71),('16273','2013-12-24','09:30:00',1.76),('16273','2013-12-24','09:35:00',1.81),('16273','2013-12-24','09:40:00',1.88),('16273','2013-12-24','09:45:00',1.94),('16273','2013-12-24','09:50:00',1.96),('16273','2013-12-24','09:55:00',2),('16273','2013-12-24','10:00:00',2.05),('16273','2013-12-24','10:05:00',2.08),('16273','2013-12-24','10:10:00',2.12),('16273','2013-12-24','10:15:00',2.13),('16273','2013-12-24','10:20:00',2.18),('16273','2013-12-24','10:25:00',2.21),('16273','2013-12-24','10:30:00',2.23),('16273','2013-12-24','10:35:00',2.26),('16273','2013-12-24','10:40:00',2.28),('16273','2013-12-24','10:45:00',2.31),('16273','2013-12-24','10:50:00',2.33),('16273','2013-12-24','10:55:00',2.33),('16273','2013-12-24','11:00:00',2.33),('16273','2013-12-24','11:05:00',2.33),('16273','2013-12-24','11:10:00',2.33),('16273','2013-12-24','11:15:00',2.33),('16273','2013-12-24','11:20:00',2.32),('16273','2013-12-24','11:25:00',2.32),('16273','2013-12-24','11:30:00',2.27),('16273','2013-12-24','11:35:00',2.3),('16273','2013-12-24','11:40:00',2.32),('16273','2013-12-24','11:45:00',2.32),('16273','2013-12-24','11:50:00',2.28),('16273','2013-12-24','11:55:00',2.24),('16273','2013-12-24','12:00:00',2.24),('16273','2013-12-24','12:05:00',2.2),('16273','2013-12-24','12:10:00',2.19),('16273','2013-12-24','12:15:00',2.21),('16273','2013-12-24','12:20:00',2.19),('16273','2013-12-24','12:25:00',2.13),('16273','2013-12-24','12:30:00',2.08),('16273','2013-12-24','12:35:00',2.07),('16273','2013-12-24','12:40:00',2.03),('16273','2013-12-24','12:45:00',1.99),('16273','2013-12-24','12:50:00',1.95),('16273','2013-12-24','12:55:00',1.91),('16273','2013-12-24','13:00:00',1.87),('16273','2013-12-24','13:05:00',1.82),('16273','2013-12-24','13:10:00',1.84),('16273','2013-12-24','13:15:00',1.76),('16273','2013-12-24','13:20:00',1.75),('16273','2013-12-24','13:25:00',1.7),('16273','2013-12-24','13:30:00',1.69),('16273','2013-12-24','13:35:00',1.64),('16273','2013-12-24','13:40:00',1.62),('16273','2013-12-24','13:45:00',1.54),('16273','2013-12-24','13:50:00',1.51),('16273','2013-12-24','13:55:00',1.4),('16273','2013-12-24','14:00:00',1.33),('16273','2013-12-24','14:05:00',1.27),('16273','2013-12-24','14:10:00',1.18),('16273','2013-12-24','14:15:00',1.15),('16273','2013-12-24','14:20:00',1.14),('16273','2013-12-24','14:25:00',1.12),('16273','2013-12-24','14:30:00',1.07),('16273','2013-12-24','14:35:00',1.04),('16273','2013-12-24','14:40:00',1.01),('16273','2013-12-23','09:20:00',1.13),('16273','2013-12-23','09:25:00',1.18),('16273','2013-12-23','09:30:00',1.09),('16273','2013-12-23','09:50:00',1.16),('16273','2013-12-23','09:55:00',1.44),('16273','2013-12-23','10:00:00',1.37),('16273','2013-12-23','10:05:00',1.45),('16273','2013-12-23','10:10:00',1.6),('16273','2013-12-23','10:15:00',1.82),('16273','2013-12-23','10:20:00',1.96),('16273','2013-12-23','10:25:00',1.94),('16273','2013-12-23','10:30:00',1.73),('16273','2013-12-23','10:35:00',2.14),('16273','2013-12-23','10:40:00',2.11),('16273','2013-12-23','10:45:00',2.24),('16273','2013-12-23','10:50:00',2.24),('16273','2013-12-23','10:55:00',2.19),('16273','2013-12-23','11:00:00',2.32),('16273','2013-12-23','11:05:00',2.37),('16273','2013-12-23','11:10:00',2.41),('16273','2013-12-23','11:15:00',2.42),('16273','2013-12-23','11:20:00',2.55),('16273','2013-12-23','11:25:00',2.52),('16273','2013-12-23','11:30:00',2.19),('16273','2013-12-23','11:35:00',2.33),('16273','2013-12-23','11:40:00',2.34),('16273','2013-12-23','11:45:00',2.52),('16273','2013-12-23','11:50:00',2.48),('16273','2013-12-23','11:55:00',2.42),('16273','2013-12-23','12:00:00',2.37),('16273','2013-12-23','12:05:00',2.31),('16273','2013-12-23','12:10:00',2.26),('16273','2013-12-23','12:15:00',2.28),('16273','2013-12-23','12:20:00',2.23),('16273','2013-12-23','12:25:00',2.2),('16273','2013-12-23','12:30:00',2.16),('16273','2013-12-23','12:35:00',2.11),('16273','2013-12-23','12:40:00',2.09),('16273','2013-12-23','12:45:00',2.07),('16273','2013-12-23','12:50:00',2.04),('16273','2013-12-23','12:55:00',1.95),('16273','2013-12-23','13:00:00',1.96),('16273','2013-12-23','13:05:00',1.91),('16273','2013-12-23','13:10:00',1.84),('16273','2013-12-23','13:15:00',1.81),('16273','2013-12-23','13:20:00',1.82),('16273','2013-12-23','13:25:00',1.81),('16273','2013-12-23','13:30:00',1.77),('16273','2013-12-23','13:35:00',1.74),('16273','2013-12-23','13:40:00',1.51),('16273','2013-12-23','13:45:00',1.63),('16273','2013-12-23','13:50:00',1.56),('16273','2013-12-23','13:55:00',1.5),('16273','2013-12-23','14:00:00',1.48),('16273','2013-12-23','14:05:00',1.48),('16273','2013-12-23','14:10:00',1.44),('16273','2013-12-23','14:15:00',1.39),('16273','2013-12-23','14:20:00',1.33),('16273','2013-12-23','14:25:00',1.27),('16273','2013-12-23','14:30:00',1.2),('16273','2013-12-23','14:35:00',1.15),('16273','2013-12-23','14:40:00',1.11),('16273','2013-12-23','14:45:00',1.04),('16273','2013-12-23','14:50:00',1.02),('16273','2013-12-22','09:00:00',1),('16273','2013-12-22','09:05:00',1.18),('16273','2013-12-22','09:10:00',1.24),('16273','2013-12-22','09:15:00',1.3),('16273','2013-12-22','09:20:00',1.25),('16273','2013-12-22','09:25:00',1.35),('16273','2013-12-22','09:30:00',1.66),('16273','2013-12-22','09:35:00',2.07),('16273','2013-12-22','09:40:00',2.28),('16273','2013-12-22','09:45:00',2.39),('16273','2013-12-22','09:50:00',2.48),('16273','2013-12-22','09:55:00',2.54),('16273','2013-12-22','10:00:00',2.46),('16273','2013-12-22','10:05:00',2.33),('16273','2013-12-22','10:10:00',2.41),('16273','2013-12-22','10:15:00',2.36),('16273','2013-12-22','10:20:00',2.38),('16273','2013-12-22','10:25:00',2.23),('16273','2013-12-22','10:30:00',2.16),('16273','2013-12-22','10:35:00',2.16),('16273','2013-12-22','10:40:00',2.02),('16273','2013-12-22','10:45:00',2.09),('16273','2013-12-22','10:50:00',2.27),('16273','2013-12-22','10:55:00',2.24),('16273','2013-12-22','11:00:00',2.32),('16273','2013-12-22','11:05:00',2.05),('16273','2013-12-22','11:10:00',2.13),('16273','2013-12-22','11:15:00',2.26),('16273','2013-12-22','11:20:00',2.29),('16273','2013-12-22','11:25:00',2.21),('16273','2013-12-22','11:30:00',2.15),('16273','2013-12-22','11:35:00',2.27),('16273','2013-12-22','11:40:00',2.1),('16273','2013-12-22','11:45:00',1.95),('16273','2013-12-22','11:50:00',1.34),('16273','2013-12-22','11:55:00',1.1),('16273','2013-12-22','12:20:00',1.06),('16273','2013-12-22','12:25:00',1.13),('16273','2013-12-22','12:30:00',1.28),('16273','2013-12-22','12:35:00',1.44),('16273','2013-12-22','12:40:00',1.48),('16273','2013-12-22','12:45:00',1.41),('16273','2013-12-22','12:50:00',1.45),('16273','2013-12-22','12:55:00',1.82),('16273','2013-12-22','13:00:00',2.15),('16273','2013-12-22','13:05:00',2.29),('16273','2013-12-22','13:10:00',2.32),('16273','2013-12-22','13:15:00',2.07),('16273','2013-12-22','13:20:00',1.9),('16273','2013-12-22','13:25:00',1.99),('16273','2013-12-22','13:30:00',1.84),('16273','2013-12-22','13:35:00',1.66),('16273','2013-12-22','13:40:00',1.66),('16273','2013-12-22','13:45:00',1.19),('16273','2013-12-22','13:50:00',1.06),('16273','2013-12-22','13:55:00',1.17),('16273','2013-12-22','14:00:00',1.23),('16273','2013-12-22','14:05:00',1.25),('16273','2013-12-22','14:10:00',1.27),('16273','2013-12-22','14:15:00',1.01),('16273','2013-12-22','14:35:00',1.17),('16273','2013-12-22','14:40:00',1.19),('16273','2013-12-22','14:45:00',1.04),('16273','2013-12-21','08:45:00',1.04),('16273','2013-12-21','08:50:00',1.21),('16273','2013-12-21','08:55:00',1.35),('16273','2013-12-21','09:00:00',1.43),('16273','2013-12-21','09:05:00',1.51),('16273','2013-12-21','09:10:00',1.57),('16273','2013-12-21','09:15:00',1.64),('16273','2013-12-21','09:20:00',1.7),('16273','2013-12-21','09:25:00',1.78),('16273','2013-12-21','09:30:00',1.85),('16273','2013-12-21','09:35:00',1.9),('16273','2013-12-21','09:40:00',1.95),('16273','2013-12-21','09:45:00',2),('16273','2013-12-21','09:50:00',2.04),('16273','2013-12-21','09:55:00',2.09),('16273','2013-12-21','10:00:00',2.13),('16273','2013-12-21','10:05:00',2.17),('16273','2013-12-21','10:10:00',2.2),('16273','2013-12-21','10:15:00',2.23),('16273','2013-12-21','10:20:00',2.25),('16273','2013-12-21','10:25:00',2.3),('16273','2013-12-21','10:30:00',2.33),('16273','2013-12-21','10:35:00',2.37),('16273','2013-12-21','10:40:00',2.41),('16273','2013-12-21','10:45:00',2.43),('16273','2013-12-21','10:50:00',2.46),('16273','2013-12-21','10:55:00',2.46),('16273','2013-12-21','11:00:00',2.47),('16273','2013-12-21','11:05:00',2.49),('16273','2013-12-21','11:10:00',2.52),('16273','2013-12-21','11:15:00',2.52),('16273','2013-12-21','11:20:00',2.53),('16273','2013-12-21','11:25:00',2.53),('16273','2013-12-21','11:30:00',2.53),('16273','2013-12-21','11:35:00',2.49),('16273','2013-12-21','11:40:00',2.52),('16273','2013-12-21','11:45:00',2.52),('16273','2013-12-21','11:50:00',2.52),('16273','2013-12-21','11:55:00',2.5),('16273','2013-12-21','12:00:00',2.48),('16273','2013-12-21','12:05:00',2.46),('16273','2013-12-21','12:10:00',2.45),('16273','2013-12-21','12:15:00',2.42),('16273','2013-12-21','12:20:00',2.38),('16273','2013-12-21','12:25:00',2.36),('16273','2013-12-21','12:30:00',2.34),('16273','2013-12-21','12:35:00',2.33),('16273','2013-12-21','12:40:00',2.3),('16273','2013-12-21','12:45:00',2.27),('16273','2013-12-21','12:50:00',2.23),('16273','2013-12-21','12:55:00',2.2),('16273','2013-12-21','13:00:00',2.17),('16273','2013-12-21','13:05:00',2.14),('16273','2013-12-21','13:10:00',2.1),('16273','2013-12-21','13:15:00',2.06),('16273','2013-12-21','13:20:00',2.02),('16273','2013-12-21','13:25:00',1.97),('16273','2013-12-21','13:30:00',1.93),('16273','2013-12-21','13:35:00',1.88),('16273','2013-12-21','13:40:00',1.85),('16273','2013-12-21','13:45:00',1.8),('16273','2013-12-21','13:50:00',1.75),('16273','2013-12-21','13:55:00',1.69),('16273','2013-12-21','14:00:00',1.63),('16273','2013-12-21','14:05:00',1.59),('16273','2013-12-21','14:10:00',1.53),('16273','2013-12-21','14:15:00',1.47),('16273','2013-12-21','14:20:00',1.41),('16273','2013-12-21','14:25:00',1.35),('16273','2013-12-21','14:30:00',1.3),('16273','2013-12-21','14:35:00',1.23),('16273','2013-12-21','14:40:00',1.16),('16273','2013-12-21','14:45:00',1.11),('16273','2013-12-21','14:50:00',1.05),('16273','2013-12-21','14:55:00',1.01),('16273','2013-12-20','08:45:00',1.04),('16273','2013-12-20','08:50:00',1.15),('16273','2013-12-20','08:55:00',1.1),('16273','2013-12-20','09:00:00',1.39),('16273','2013-12-20','09:05:00',1.45),('16273','2013-12-20','09:10:00',1.51),('16273','2013-12-20','09:15:00',1.58),('16273','2013-12-20','09:20:00',1.65),('16273','2013-12-20','09:25:00',1.71),('16273','2013-12-20','09:30:00',1.75),('16273','2013-12-20','09:35:00',1.81),('16273','2013-12-20','09:40:00',1.84),('16273','2013-12-20','09:45:00',1.85),('16273','2013-12-20','09:50:00',1.91),('16273','2013-12-20','09:55:00',1.99),('16273','2013-12-20','10:00:00',1.98),('16273','2013-12-20','10:05:00',2.03),('16273','2013-12-20','10:10:00',2.07),('16273','2013-12-20','10:15:00',2.13),('16273','2013-12-20','10:20:00',2.18),('16273','2013-12-20','10:25:00',2.18),('16273','2013-12-20','10:30:00',2.19),('16273','2013-12-20','10:35:00',2.22),('16273','2013-12-20','10:40:00',2.25),('16273','2013-12-20','10:45:00',2.28),('16273','2013-12-20','10:50:00',2.29),('16273','2013-12-20','10:55:00',2.3),('16273','2013-12-20','11:00:00',2.3),('16273','2013-12-20','11:05:00',2.3),('16273','2013-12-20','11:10:00',2.28),('16273','2013-12-20','11:15:00',2.29),('16273','2013-12-20','11:20:00',2.31),('16273','2013-12-20','11:25:00',2.32),('16273','2013-12-20','11:30:00',2.32),('16273','2013-12-20','11:35:00',2.32),('16273','2013-12-20','11:40:00',2.32),('16273','2013-12-20','11:45:00',2.3),('16273','2013-12-20','11:50:00',2.27),('16273','2013-12-20','11:55:00',2.29),('16273','2013-12-20','12:00:00',2.26),('16273','2013-12-20','12:05:00',2.26),('16273','2013-12-20','12:10:00',2.22),('16273','2013-12-20','12:15:00',2.21),('16273','2013-12-20','12:20:00',2.18),('16273','2013-12-20','12:25:00',2.14),('16273','2013-12-20','12:30:00',2.12),('16273','2013-12-20','12:35:00',2.09),('16273','2013-12-20','12:40:00',2.04),('16273','2013-12-20','12:45:00',2),('16273','2013-12-20','12:50:00',1.97),('16273','2013-12-20','12:55:00',1.9),('16273','2013-12-20','13:00:00',1.89),('16273','2013-12-20','13:05:00',1.9),('16273','2013-12-20','13:10:00',1.87),('16273','2013-12-20','13:15:00',1.85),('16273','2013-12-20','13:20:00',1.79),('16273','2013-12-20','13:25:00',1.82),('16273','2013-12-20','13:40:00',1.34),('16273','2013-12-20','13:45:00',1.02),('16273','2013-12-20','14:15:00',1.07),('16273','2013-12-20','14:20:00',1.22),('16273','2013-12-20','14:25:00',1.13),('16273','2013-12-19','08:55:00',1.26),('16273','2013-12-19','09:00:00',1.35),('16273','2013-12-19','09:35:00',1.03),('16273','2013-12-19','09:45:00',1.09),('16273','2013-12-19','10:30:00',1.12),('16273','2013-12-19','10:40:00',1.09),('16273','2013-12-19','10:45:00',1.31),('16273','2013-12-19','10:50:00',1.1),('16273','2013-12-19','12:15:00',1.14),('16273','2013-12-19','14:10:00',1.04),('16273','2013-12-19','14:15:00',1.19),('16273','2013-12-19','14:25:00',1.49),('16273','2013-12-19','14:30:00',1.41),('16273','2013-12-19','14:35:00',1.22),('16273','2013-12-19','14:40:00',1.11),('16273','2013-12-18','08:40:00',1.11),('16273','2013-12-18','08:45:00',1.09),('16273','2013-12-18','08:50:00',1.37),('16273','2013-12-18','08:55:00',1.47),('16273','2013-12-18','09:00:00',1.55),('16273','2013-12-18','09:05:00',1.61),('16273','2013-12-18','09:10:00',1.67),('16273','2013-12-18','09:15:00',1.74),('16273','2013-12-18','09:20:00',1.83),('16273','2013-12-18','09:25:00',1.88),('16273','2013-12-18','09:30:00',1.93),('16273','2013-12-18','09:35:00',1.97),('16273','2013-12-18','09:40:00',2.03),('16273','2013-12-18','09:45:00',2.09),('16273','2013-12-18','09:50:00',2.15),('16273','2013-12-18','09:55:00',2.19),('16273','2013-12-18','10:00:00',2.23),('16273','2013-12-18','10:05:00',2.26),('16273','2013-12-18','10:10:00',2.28),('16273','2013-12-18','10:15:00',2.28),('16273','2013-12-18','10:20:00',2.31),('16273','2013-12-18','10:25:00',2.35),('16273','2013-12-18','10:30:00',2.37),('16273','2013-12-18','10:35:00',2.39),('16273','2013-12-18','10:40:00',2.42),('16273','2013-12-18','10:45:00',2.42),('16273','2013-12-18','10:50:00',2.41),('16273','2013-12-18','10:55:00',2.42),('16273','2013-12-18','11:00:00',2.44),('16273','2013-12-18','11:05:00',2.43),('16273','2013-12-18','11:10:00',2.4),('16273','2013-12-18','11:15:00',2.41),('16273','2013-12-18','11:20:00',2.41),('16273','2013-12-18','11:25:00',2.41),('16273','2013-12-18','11:30:00',2.4),('16273','2013-12-18','11:35:00',2.37),('16273','2013-12-18','11:40:00',2.38),('16273','2013-12-18','11:45:00',2.37),('16273','2013-12-18','11:50:00',2.35),('16273','2013-12-18','11:55:00',2.35),('16273','2013-12-18','12:00:00',2.33),('16273','2013-12-18','12:05:00',2.32),('16273','2013-12-18','12:10:00',2.33),('16273','2013-12-18','12:15:00',2.3),('16273','2013-12-18','12:20:00',2.3),('16273','2013-12-18','12:25:00',2.3),('16273','2013-12-18','12:30:00',2.27),('16273','2013-12-18','12:35:00',2.24),('16273','2013-12-18','12:40:00',2.22),('16273','2013-12-18','12:45:00',2.18),('16273','2013-12-18','12:50:00',2.15),('16273','2013-12-18','12:55:00',2.11),('16273','2013-12-18','13:00:00',2.04),('16273','2013-12-18','13:05:00',2.01),('16273','2013-12-18','13:10:00',1.99),('16273','2013-12-18','13:15:00',1.96),('16273','2013-12-18','13:20:00',1.92),('16273','2013-12-18','13:25:00',1.92),('16273','2013-12-18','13:30:00',1.88),('16273','2013-12-18','13:35:00',1.79),('16273','2013-12-18','13:40:00',1.77),('16273','2013-12-18','13:45:00',1.69),('16273','2013-12-18','13:50:00',1.64),('16273','2013-12-18','13:55:00',1.62),('16273','2013-12-18','14:00:00',1.56),('16273','2013-12-18','14:05:00',1.51),('16273','2013-12-18','14:10:00',1.44),('16273','2013-12-18','14:15:00',1.37),('16273','2013-12-18','14:20:00',1.34),('16273','2013-12-18','14:25:00',1.3),('16273','2013-12-18','14:30:00',1.24),('16273','2013-12-18','14:35:00',1.2),('16273','2013-12-18','14:40:00',1.16),('16273','2013-12-18','14:45:00',1.1),('16273','2013-12-18','14:50:00',1.05),('16273','2014-04-22','07:45:00',1.13),('16273','2014-04-22','07:50:00',1.24),('16273','2014-04-22','07:55:00',1.31),('16273','2014-04-22','08:00:00',1.42),('16273','2014-04-22','08:05:00',1.5),('16273','2014-04-22','08:10:00',1.59),('16273','2014-04-22','08:15:00',1.65),('16273','2014-04-22','08:20:00',1.76),('16273','2014-04-22','08:25:00',1.86),('16273','2014-04-22','08:30:00',1.93),('16273','2014-04-22','08:35:00',1.9),('16273','2014-04-22','08:40:00',1.99),('16273','2014-04-22','08:45:00',2.1),('16273','2014-04-22','08:50:00',2.11),('16273','2014-04-22','08:55:00',2.19),('16273','2014-04-22','09:00:00',2.41),('16273','2014-04-22','09:05:00',2.23),('16273','2014-04-22','09:10:00',2.14),('16273','2014-04-22','09:15:00',2.3),('16273','2014-04-22','09:20:00',2.66),('16273','2014-04-22','09:25:00',2.74),('16273','2014-04-22','09:30:00',2.79),('16273','2014-04-22','09:35:00',2.18),('16273','2014-04-22','09:40:00',1.81),('16273','2014-04-22','09:45:00',1.86),('16273','2014-04-22','09:50:00',1.07),('16273','2014-04-22','09:55:00',1.25),('16273','2014-04-22','10:00:00',1.52),('16273','2014-04-22','10:05:00',1.4),('16273','2014-04-22','10:10:00',1.66),('16273','2014-04-22','10:15:00',2.79),('16273','2014-04-22','10:20:00',2.03),('16273','2014-04-22','10:25:00',2.29),('16273','2014-04-22','10:30:00',2.26),('16273','2014-04-22','10:35:00',1.82),('16273','2014-04-22','10:40:00',3.12),('16273','2014-04-22','10:45:00',3.18),('16273','2014-04-22','10:50:00',2.79),('16273','2014-04-22','10:55:00',3.22),('16273','2014-04-22','11:00:00',2.09),('16273','2014-04-22','11:05:00',2.28),('16273','2014-04-22','11:10:00',1.57),('16273','2014-04-22','11:15:00',1.45),('16273','2014-04-22','11:20:00',1.17),('16273','2014-04-22','11:25:00',1.26),('16273','2014-04-22','11:30:00',1.08),('16273','2014-04-22','11:50:00',1.03),('16273','2014-04-22','11:55:00',1.01),('16273','2014-04-22','12:00:00',1.04),('16273','2014-04-22','12:05:00',1.06),('16273','2014-04-22','12:10:00',1.04),('16273','2014-04-22','12:15:00',1.14),('16273','2014-04-22','12:20:00',1.11),('16273','2014-04-22','12:25:00',1.19),('16273','2014-04-22','12:30:00',1.03),('16273','2014-04-22','13:10:00',1.15),('16273','2014-04-22','13:15:00',1.34),('16273','2014-04-22','13:20:00',1.45),('16273','2014-04-22','13:25:00',1.86),('16273','2014-04-22','13:30:00',2.41),('16273','2014-04-22','13:35:00',2.61),('16273','2014-04-22','13:40:00',2.38),('16273','2014-04-22','13:45:00',2.05),('16273','2014-04-22','13:50:00',1.47),('16273','2014-04-22','13:55:00',1.43),('16273','2014-04-22','14:00:00',2.28),('16273','2014-04-22','14:05:00',3.12),('16273','2014-04-22','14:10:00',2.97),('16273','2014-04-22','14:15:00',2.67),('16273','2014-04-22','14:20:00',1.62),('16273','2014-04-22','14:25:00',1.75),('16273','2014-04-22','14:30:00',2.49),('16273','2014-04-22','14:35:00',2.64),('16273','2014-04-22','14:40:00',2.5),('16273','2014-04-22','14:45:00',2.8),('16273','2014-04-22','14:50:00',2.18),('16273','2014-04-22','14:55:00',1.32),('16273','2014-04-22','15:00:00',1.11),('16273','2014-04-22','15:05:00',1.21),('16273','2014-04-22','15:10:00',1.13),('16273','2014-04-22','15:15:00',1.19),('16273','2014-04-22','15:20:00',1.21),('16273','2014-04-22','15:25:00',1.66),('16273','2014-04-22','15:30:00',1.55),('16273','2014-04-22','15:35:00',2.12),('16273','2014-04-22','15:40:00',1.9),('16273','2014-04-22','15:45:00',1.85),('16273','2014-04-22','15:50:00',1.93),('16273','2014-04-22','15:55:00',1.76),('16273','2014-04-22','16:00:00',2.22),('16273','2014-04-22','16:05:00',1.59),('16273','2014-04-22','16:10:00',1.33),('16273','2014-04-22','16:15:00',1.32),('16273','2014-04-22','16:20:00',1.46),('16273','2014-04-22','16:25:00',1.27),('16273','2014-04-22','16:30:00',1.18),('16273','2014-04-22','16:35:00',1.22),('16273','2014-04-22','16:40:00',1.18),('16273','2014-04-22','16:45:00',1.12),('16273','2014-04-22','16:50:00',1.06),('16273','2014-04-22','16:55:00',1.12),('16273','2014-04-22','17:00:00',1.24),('16273','2014-04-22','17:05:00',1.02),('16273','2013-12-17','08:40:00',1.33),('16273','2013-12-17','08:45:00',1.2),('16273','2013-12-17','08:50:00',1.57),('16273','2013-12-17','08:55:00',1.67),('16273','2013-12-17','09:00:00',1.74),('16273','2013-12-17','09:05:00',1.81),('16273','2013-12-17','09:10:00',1.86),('16273','2013-12-17','09:15:00',1.9),('16273','2013-12-17','09:20:00',1.96),('16273','2013-12-17','09:25:00',2.01),('16273','2013-12-17','09:30:00',2.04),('16273','2013-12-17','09:35:00',2.09),('16273','2013-12-17','09:40:00',2.15),('16273','2013-12-17','09:45:00',2.19),('16273','2013-12-17','09:50:00',2.23),('16273','2013-12-17','09:55:00',2.26),('16273','2013-12-17','10:00:00',2.29),('16273','2013-12-17','10:05:00',2.31),('16273','2013-12-17','10:10:00',2.37),('16273','2013-12-17','10:15:00',2.4),('16273','2013-12-17','10:20:00',2.43),('16273','2013-12-17','10:25:00',2.46),('16273','2013-12-17','10:30:00',2.47),('16273','2013-12-17','10:35:00',2.49),('16273','2013-12-17','10:40:00',2.51),('16273','2013-12-17','10:45:00',2.52),('16273','2013-12-17','10:50:00',2.54),('16273','2013-12-17','10:55:00',2.55),('16273','2013-12-17','11:00:00',2.55),('16273','2013-12-17','11:05:00',2.56),('16273','2013-12-17','11:10:00',2.55),('16273','2013-12-17','11:15:00',2.55),('16273','2013-12-17','11:20:00',2.51),('16273','2013-12-17','11:25:00',2.55),('16273','2013-12-17','11:30:00',2.54),('16273','2013-12-17','11:35:00',2.54),('16273','2013-12-17','11:40:00',2.53),('16273','2013-12-17','11:45:00',2.49),('16273','2013-12-17','11:50:00',2.46),('16273','2013-12-17','11:55:00',2.51),('16273','2013-12-17','12:00:00',2.49),('16273','2013-12-17','12:05:00',2.46),('16273','2013-12-17','12:10:00',2.43),('16273','2013-12-17','12:15:00',2.43),('16273','2013-12-17','12:20:00',2.38),('16273','2013-12-17','12:25:00',2.34),('16273','2013-12-17','12:30:00',2.35),('16273','2013-12-17','12:35:00',2.37),('16273','2013-12-17','12:40:00',2.33),('16273','2013-12-17','12:45:00',2.3),('16273','2013-12-17','12:50:00',2.27),('16273','2013-12-17','12:55:00',2.26),('16273','2013-12-17','13:00:00',2.22),('16273','2013-12-17','13:05:00',2.18),('16273','2013-12-17','13:10:00',2.14),('16273','2013-12-17','13:15:00',2.1),('16273','2013-12-17','13:20:00',2.05),('16273','2013-12-17','13:25:00',1.99),('16273','2013-12-17','13:30:00',1.93),('16273','2013-12-17','13:35:00',1.88),('16273','2013-12-17','13:40:00',1.84),('16273','2013-12-17','13:45:00',1.78),('16273','2013-12-17','13:50:00',1.72),('16273','2013-12-17','13:55:00',1.67),('16273','2013-12-17','14:00:00',1.61),('16273','2013-12-17','14:05:00',1.55),('16273','2013-12-17','14:10:00',1.51),('16273','2013-12-17','14:15:00',1.45),('16273','2013-12-17','14:20:00',1.37),('16273','2013-12-17','14:25:00',1.32),('16273','2013-12-17','14:30:00',1.26),('16273','2013-12-17','14:35:00',1.21),('16273','2013-12-17','14:40:00',1.16),('16273','2013-12-17','14:45:00',1.1),('16273','2013-12-17','14:50:00',1.04),('16273','2013-12-16','08:40:00',1.24),('16273','2013-12-16','08:45:00',1.14),('16273','2013-12-16','08:50:00',1.46),('16273','2013-12-16','08:55:00',1.58),('16273','2013-12-16','09:00:00',1.65),('16273','2013-12-16','09:05:00',1.72),('16273','2013-12-16','09:10:00',1.77),('16273','2013-12-16','09:15:00',1.84),('16273','2013-12-16','09:20:00',1.9),('16273','2013-12-16','09:25:00',1.98),('16273','2013-12-16','09:30:00',2.03),('16273','2013-12-16','09:35:00',2.08),('16273','2013-12-16','09:40:00',2.12),('16273','2013-12-16','09:45:00',2.16),('16273','2013-12-16','09:50:00',2.19),('16273','2013-12-16','09:55:00',2.23),('16273','2013-12-16','10:00:00',2.24),('16273','2013-12-16','10:05:00',2.26),('16273','2013-12-16','10:10:00',2.31),('16273','2013-12-16','10:15:00',2.33),('16273','2013-12-16','10:20:00',2.38),('16273','2013-12-16','10:25:00',2.42),('16273','2013-12-16','10:30:00',2.43),('16273','2013-12-16','10:35:00',2.43),('16273','2013-12-16','10:40:00',2.45),('16273','2013-12-16','10:45:00',2.47),('16273','2013-12-16','10:50:00',2.49),('16273','2013-12-16','10:55:00',2.53),('16273','2013-12-16','11:00:00',2.56),('16273','2013-12-16','11:05:00',2.58),('16273','2013-12-16','11:10:00',2.59),('16273','2013-12-16','11:15:00',2.58),('16273','2013-12-16','11:20:00',2.58),('16273','2013-12-16','11:25:00',2.57),('16273','2013-12-16','11:30:00',2.57),('16273','2013-12-16','11:35:00',2.56),('16273','2013-12-16','11:40:00',2.53),('16273','2013-12-16','11:45:00',2.53),('16273','2013-12-16','11:50:00',2.5),('16273','2013-12-16','11:55:00',2.51),('16273','2013-12-16','12:00:00',2.51),('16273','2013-12-16','12:05:00',2.5),('16273','2013-12-16','12:10:00',2.48),('16273','2013-12-16','12:15:00',2.45),('16273','2013-12-16','12:20:00',2.44),('16273','2013-12-16','12:25:00',2.42),('16273','2013-12-16','12:30:00',2.39),('16273','2013-12-16','12:35:00',2.37),('16273','2013-12-16','12:40:00',2.33),('16273','2013-12-16','12:45:00',2.29),('16273','2013-12-16','12:50:00',2.26),('16273','2013-12-16','12:55:00',2.25),('16273','2013-12-16','13:00:00',2.21),('16273','2013-12-16','13:05:00',2.16),('16273','2013-12-16','13:10:00',2.11),('16273','2013-12-16','13:15:00',2.07),('16273','2013-12-16','13:20:00',2.02),('16273','2013-12-16','13:25:00',1.96),('16273','2013-12-16','13:30:00',1.91),('16273','2013-12-16','13:35:00',1.85),('16273','2013-12-16','13:40:00',1.81),('16273','2013-12-16','13:45:00',1.77),('16273','2013-12-16','13:50:00',1.7),('16273','2013-12-16','13:55:00',1.65),('16273','2013-12-16','14:00:00',1.59),('16273','2013-12-16','14:05:00',1.55),('16273','2013-12-16','14:10:00',1.5),('16273','2013-12-16','14:15:00',1.43),('16273','2013-12-16','14:20:00',1.37),('16273','2013-12-16','14:25:00',1.33),('16273','2013-12-16','14:30:00',1.28),('16273','2013-12-16','14:35:00',1.22),('16273','2013-12-16','14:40:00',1.15),('16273','2013-12-16','14:45:00',1.08),('16273','2013-12-16','14:50:00',1.03),('16273','2013-12-15','10:25:00',1.11),('16273','2013-12-15','12:00:00',1.05),('16273','2013-12-14','08:40:00',1.11),('16273','2013-12-14','08:45:00',1.07),('16273','2013-12-14','08:50:00',1.32),('16273','2013-12-14','08:55:00',1.39),('16273','2013-12-14','09:00:00',1.48),('16273','2013-12-14','09:05:00',1.54),('16273','2013-12-14','09:10:00',1.6),('16273','2013-12-14','09:15:00',1.67),('16273','2013-12-14','09:20:00',1.72),('16273','2013-12-14','09:25:00',1.78),('16273','2013-12-14','09:30:00',1.83),('16273','2013-12-14','09:35:00',1.93),('16273','2013-12-14','09:40:00',2),('16273','2013-12-14','09:45:00',2.03),('16273','2013-12-14','09:50:00',2.1),('16273','2013-12-14','09:55:00',2.15),('16273','2013-12-14','10:00:00',2.17),('16273','2013-12-14','10:05:00',2.19),('16273','2013-12-14','10:10:00',2.22),('16273','2013-12-14','10:15:00',2.25),('16273','2013-12-14','10:20:00',2.25),('16273','2013-12-14','10:25:00',2.3),('16273','2013-12-14','10:30:00',2.32),('16273','2013-12-14','10:35:00',2.33),('16273','2013-12-14','10:40:00',2.34),('16273','2013-12-14','10:45:00',2.36),('16273','2013-12-14','10:50:00',2.39),('16273','2013-12-14','10:55:00',2.38),('16273','2013-12-14','11:00:00',2.41),('16273','2013-12-14','11:05:00',2.43),('16273','2013-12-14','11:10:00',2.43),('16273','2013-12-14','11:15:00',2.42),('16273','2013-12-14','11:20:00',2.43),('16273','2013-12-14','11:25:00',2.42),('16273','2013-12-14','11:30:00',2.44),('16273','2013-12-14','11:35:00',2.4),('16273','2013-12-14','11:40:00',2.36),('16273','2013-12-14','11:45:00',2.43),('16273','2013-12-14','11:50:00',2.34),('16273','2013-12-14','11:55:00',2.29),('16273','2013-12-14','12:00:00',2.32),('16273','2013-12-14','12:05:00',2.31),('16273','2013-12-14','12:10:00',2.25),('16273','2013-12-14','12:15:00',2.22),('16273','2013-12-14','12:20:00',2.2),('16273','2013-12-14','12:25:00',2.27),('16273','2013-12-14','12:30:00',2.23),('16273','2013-12-14','12:35:00',2.17),('16273','2013-12-14','12:40:00',2.19),('16273','2013-12-14','12:45:00',2.15),('16273','2013-12-14','12:50:00',2.15),('16273','2013-12-14','12:55:00',2.13),('16273','2013-12-14','13:00:00',2.09),('16273','2013-12-14','13:05:00',2.07),('16273','2013-12-14','13:10:00',2.05),('16273','2013-12-14','13:15:00',1.99),('16273','2013-12-14','13:20:00',1.96),('16273','2013-12-14','13:25:00',1.92),('16273','2013-12-14','13:30:00',1.87),('16273','2013-12-14','13:35:00',1.81),('16273','2013-12-14','13:40:00',1.74),('16273','2013-12-14','13:45:00',1.69),('16273','2013-12-14','13:50:00',1.63),('16273','2013-12-14','13:55:00',1.59),('16273','2013-12-14','14:00:00',1.56),('16273','2013-12-14','14:05:00',1.5),('16273','2013-12-14','14:10:00',1.43),('16273','2013-12-14','14:15:00',1.38),('16273','2013-12-14','14:20:00',1.33),('16273','2013-12-14','14:25:00',1.26),('16273','2013-12-14','14:30:00',1.21),('16273','2013-12-14','14:35:00',1.15),('16273','2013-12-14','14:40:00',1.11),('16273','2013-12-14','14:45:00',1.06),('16273','2013-12-14','14:50:00',1.02),('16273','2013-12-13','08:40:00',1),('16273','2013-12-13','08:45:00',1.01),('16273','2013-12-13','08:50:00',1.21),('16273','2013-12-13','08:55:00',1.29),('16273','2013-12-13','09:00:00',1.35),('16273','2013-12-13','09:05:00',1.4),('16273','2013-12-13','09:10:00',1.46),('16273','2013-12-13','09:15:00',1.51),('16273','2013-12-13','09:20:00',1.55),('16273','2013-12-13','09:25:00',1.61),('16273','2013-12-13','09:30:00',1.68),('16273','2013-12-13','09:35:00',1.74),('16273','2013-12-13','09:40:00',1.8),('16273','2013-12-13','09:45:00',1.85),('16273','2013-12-13','09:50:00',1.88),('16273','2013-12-13','09:55:00',1.9),('16273','2013-12-13','10:00:00',1.96),('16273','2013-12-13','10:05:00',2),('16273','2013-12-13','10:10:00',2.03),('16273','2013-12-13','10:15:00',2.05),('16273','2013-12-13','10:20:00',2.08),('16273','2013-12-13','10:25:00',2.11),('16273','2013-12-13','10:30:00',2.15),('16273','2013-12-13','10:35:00',2.21),('16273','2013-12-13','10:40:00',2.24),('16273','2013-12-13','10:45:00',2.24),('16273','2013-12-13','10:50:00',2.22),('16273','2013-12-13','10:55:00',2.24),('16273','2013-12-13','11:00:00',2.2),('16273','2013-12-13','11:05:00',2.19),('16273','2013-12-13','11:10:00',2.28),('16273','2013-12-13','11:15:00',2.36),('16273','2013-12-13','11:20:00',2.28),('16273','2013-12-13','11:25:00',2.34),('16273','2013-12-13','11:30:00',2.33),('16273','2013-12-13','11:35:00',2.28),('16273','2013-12-13','11:40:00',2.28),('16273','2013-12-13','11:45:00',2.27),('16273','2013-12-13','11:50:00',2.31),('16273','2013-12-13','11:55:00',2.28),('16273','2013-12-13','12:00:00',2.26),('16273','2013-12-13','12:05:00',2.25),('16273','2013-12-13','12:10:00',2.19),('16273','2013-12-13','12:15:00',2.24),('16273','2013-12-13','12:20:00',2.16),('16273','2013-12-13','12:25:00',2.15),('16273','2013-12-13','12:30:00',2.22),('16273','2013-12-13','12:35:00',2.23),('16273','2013-12-13','12:40:00',2.22),('16273','2013-12-13','12:45:00',2.11),('16273','2013-12-13','12:50:00',2.14),('16273','2013-12-13','12:55:00',2.14),('16273','2013-12-13','13:00:00',2.11),('16273','2013-12-13','13:05:00',2.08),('16273','2013-12-13','13:10:00',2.05),('16273','2013-12-13','13:15:00',1.95),('16273','2013-12-13','13:20:00',1.94),('16273','2013-12-13','13:25:00',1.88),('16273','2013-12-13','13:30:00',1.86),('16273','2013-12-13','13:35:00',1.8),('16273','2013-12-13','13:40:00',1.81),('16273','2013-12-13','13:45:00',1.7),('16273','2013-12-13','13:50:00',1.62),('16273','2013-12-13','13:55:00',1.59),('16273','2013-12-13','14:00:00',1.53),('16273','2013-12-13','14:05:00',1.52),('16273','2013-12-13','14:10:00',1.48),('16273','2013-12-13','14:15:00',1.41),('16273','2013-12-13','14:20:00',1.29),('16273','2013-12-13','14:25:00',1.28),('16273','2013-12-13','14:30:00',1.24),('16273','2013-12-13','14:35:00',1.15),('16273','2013-12-13','14:40:00',1.12),('16273','2013-12-13','14:45:00',1.05),('16273','2013-12-13','14:50:00',1.01),('16273','2013-12-12','08:35:00',1.03),('16273','2013-12-12','08:40:00',1.14),('16273','2013-12-12','08:45:00',1.07),('16273','2013-12-12','08:50:00',1.35),('16273','2013-12-12','08:55:00',1.43),('16273','2013-12-12','09:00:00',1.49),('16273','2013-12-12','09:05:00',1.54),('16273','2013-12-12','09:10:00',1.6),('16273','2013-12-12','09:15:00',1.68),('16273','2013-12-12','09:20:00',1.74),('16273','2013-12-12','09:25:00',1.79),('16273','2013-12-12','09:30:00',1.85),('16273','2013-12-12','09:35:00',1.9),('16273','2013-12-12','09:40:00',1.97),('16273','2013-12-12','09:45:00',2.03),('16273','2013-12-12','09:50:00',2.08),('16273','2013-12-12','09:55:00',2.13),('16273','2013-12-12','10:00:00',2.17),('16273','2013-12-12','10:05:00',2.19),('16273','2013-12-12','10:10:00',2.21),('16273','2013-12-12','10:15:00',2.25),('16273','2013-12-12','10:20:00',2.3),('16273','2013-12-12','10:25:00',2.32),('16273','2013-12-12','10:30:00',2.35),('16273','2013-12-12','10:35:00',2.36),('16273','2013-12-12','10:40:00',2.36),('16273','2013-12-12','10:45:00',2.36),('16273','2013-12-12','10:50:00',2.38),('16273','2013-12-12','10:55:00',2.39),('16273','2013-12-12','11:00:00',2.39),('16273','2013-12-12','11:05:00',2.4),('16273','2013-12-12','11:10:00',2.41),('16273','2013-12-12','11:15:00',2.42),('16273','2013-12-12','11:20:00',2.41),('16273','2013-12-12','11:25:00',2.4),('16273','2013-12-12','11:30:00',2.38),('16273','2013-12-12','11:35:00',2.39),('16273','2013-12-12','11:40:00',2.41),('16273','2013-12-12','11:45:00',2.41),('16273','2013-12-12','11:50:00',2.39),('16273','2013-12-12','11:55:00',2.36),('16273','2013-12-12','12:00:00',2.31),('16273','2013-12-12','12:05:00',2.3),('16273','2013-12-12','12:10:00',2.32),('16273','2013-12-12','12:15:00',2.3),('16273','2013-12-12','12:20:00',2.27),('16273','2013-12-12','12:25:00',2.21),('16273','2013-12-12','12:30:00',2.22),('16273','2013-12-12','12:35:00',2.18),('16273','2013-12-12','12:40:00',2.18),('16273','2013-12-12','12:45:00',2.12),('16273','2013-12-12','12:50:00',2.11),('16273','2013-12-12','12:55:00',2.09),('16273','2013-12-12','13:00:00',2.07),('16273','2013-12-12','13:05:00',2.02),('16273','2013-12-12','13:10:00',1.99),('16273','2013-12-12','13:15:00',1.95),('16273','2013-12-12','13:20:00',1.91),('16273','2013-12-12','13:25:00',1.86),('16273','2013-12-12','13:30:00',1.81),('16273','2013-12-12','13:35:00',1.75),('16273','2013-12-12','13:40:00',1.69),('16273','2013-12-12','13:45:00',1.65),('16273','2013-12-12','13:50:00',1.62),('16273','2013-12-12','13:55:00',1.56),('16273','2013-12-12','14:00:00',1.51),('16273','2013-12-12','14:05:00',1.46),('16273','2013-12-12','14:10:00',1.41),('16273','2013-12-12','14:15:00',1.36),('16273','2013-12-12','14:20:00',1.29),('16273','2013-12-12','14:25:00',1.25),('16273','2013-12-12','14:30:00',1.19),('16273','2013-12-12','14:35:00',1.14),('16273','2013-12-12','14:40:00',1.08),('16273','2013-12-12','14:45:00',1.01),('16273','2013-12-11','08:35:00',1.13),('16273','2013-12-11','08:40:00',1.17),('16273','2013-12-11','08:45:00',1.21),('16273','2013-12-11','08:50:00',1.44),('16273','2013-12-11','08:55:00',1.53),('16273','2013-12-11','09:00:00',1.61),('16273','2013-12-11','09:05:00',1.67),('16273','2013-12-11','09:10:00',1.71),('16273','2013-12-11','09:15:00',1.78),('16273','2013-12-11','09:20:00',1.83),('16273','2013-12-11','09:25:00',1.88),('16273','2013-12-11','09:30:00',1.91),('16273','2013-12-11','09:35:00',1.99),('16273','2013-12-11','09:40:00',2.06),('16273','2013-12-11','09:45:00',2.11),('16273','2013-12-11','09:50:00',2.16),('16273','2013-12-11','09:55:00',2.21),('16273','2013-12-11','10:00:00',2.26),('16273','2013-12-11','10:05:00',2.3),('16273','2013-12-11','10:10:00',2.34),('16273','2013-12-11','10:15:00',2.35),('16273','2013-12-11','10:20:00',2.35),('16273','2013-12-11','10:25:00',2.37),('16273','2013-12-11','10:30:00',2.38),('16273','2013-12-11','10:35:00',2.44),('16273','2013-12-11','10:40:00',2.46),('16273','2013-12-11','10:45:00',2.47),('16273','2013-12-11','10:50:00',2.47),('16273','2013-12-11','10:55:00',2.49),('16273','2013-12-11','11:00:00',2.49),('16273','2013-12-11','11:05:00',2.53),('16273','2013-12-11','11:10:00',2.54),('16273','2013-12-11','11:15:00',2.51),('16273','2013-12-11','11:20:00',2.49),('16273','2013-12-11','11:25:00',2.5),('16273','2013-12-11','11:30:00',2.52),('16273','2013-12-11','11:35:00',2.55),('16273','2013-12-11','11:40:00',2.55),('16273','2013-12-11','11:45:00',2.56),('16273','2013-12-11','11:50:00',2.51),('16273','2013-12-11','11:55:00',2.52),('16273','2013-12-11','12:00:00',2.53),('16273','2013-12-11','12:05:00',2.49),('16273','2013-12-11','12:10:00',2.45),('16273','2013-12-11','12:15:00',2.4),('16273','2013-12-11','12:20:00',2.37),('16273','2013-12-11','12:25:00',2.36),('16273','2013-12-11','12:30:00',2.34),('16273','2013-12-11','12:35:00',2.33),('16273','2013-12-11','12:40:00',2.31),('16273','2013-12-11','12:45:00',2.3),('16273','2013-12-11','12:50:00',2.25),('16273','2013-12-11','12:55:00',2.22),('16273','2013-12-11','13:00:00',2.18),('16273','2013-12-11','13:05:00',2.1),('16273','2013-12-11','13:10:00',2.08),('16273','2013-12-11','13:15:00',2.04),('16273','2013-12-11','13:20:00',1.98),('16273','2013-12-11','13:25:00',1.95),('16273','2013-12-11','13:30:00',1.9),('16273','2013-12-11','13:35:00',1.82),('16273','2013-12-11','13:40:00',1.77),('16273','2013-12-11','13:45:00',1.7),('16273','2013-12-11','13:50:00',1.65),('16273','2013-12-11','13:55:00',1.61),('16273','2013-12-11','14:00:00',1.57),('16273','2013-12-11','14:05:00',1.52),('16273','2013-12-11','14:10:00',1.47),('16273','2013-12-11','14:15:00',1.4),('16273','2013-12-11','14:20:00',1.35),('16273','2013-12-11','14:25:00',1.31),('16273','2013-12-11','14:30:00',1.25),('16273','2013-12-11','14:35:00',1.17),('16273','2013-12-11','14:40:00',1.12),('16273','2013-12-11','14:45:00',1.07),('16273','2013-12-11','14:50:00',1.02),('16273','2013-12-10','08:35:00',1.15),('16273','2013-12-10','08:40:00',1.1),('16273','2013-12-10','08:45:00',1.4),('16273','2013-12-10','08:50:00',1.48),('16273','2013-12-10','08:55:00',1.57),('16273','2013-12-10','09:00:00',1.64),('16273','2013-12-10','09:05:00',1.71),('16273','2013-12-10','09:10:00',1.77),('16273','2013-12-10','09:15:00',1.84),('16273','2013-12-10','09:20:00',1.9),('16273','2013-12-10','09:25:00',1.94),('16273','2013-12-10','09:30:00',1.99),('16273','2013-12-10','09:35:00',2.07),('16273','2013-12-10','09:40:00',2.12),('16273','2013-12-10','09:45:00',2.15),('16273','2013-12-10','09:50:00',2.2),('16273','2013-12-10','09:55:00',2.23),('16273','2013-12-10','10:00:00',2.26),('16273','2013-12-10','10:05:00',2.3),('16273','2013-12-10','10:10:00',2.33),('16273','2013-12-10','10:15:00',2.33),('16273','2013-12-10','10:20:00',2.38),('16273','2013-12-10','10:25:00',2.4),('16273','2013-12-10','10:30:00',2.41),('16273','2013-12-10','10:35:00',2.44),('16273','2013-12-10','10:40:00',2.46),('16273','2013-12-10','10:45:00',2.48),('16273','2013-12-10','10:50:00',2.49),('16273','2013-12-10','10:55:00',2.52),('16273','2013-12-10','11:00:00',2.53),('16273','2013-12-10','11:05:00',2.52),('16273','2013-12-10','11:10:00',2.52),('16273','2013-12-10','11:15:00',2.52),('16273','2013-12-10','11:20:00',2.52),('16273','2013-12-10','11:25:00',2.52),('16273','2013-12-10','11:30:00',2.48),('16273','2013-12-10','11:35:00',2.5),('16273','2013-12-10','11:40:00',2.48),('16273','2013-12-10','11:45:00',2.46),('16273','2013-12-10','11:50:00',2.46),('16273','2013-12-10','11:55:00',2.45),('16273','2013-12-10','12:00:00',2.43),('16273','2013-12-10','12:05:00',2.43),('16273','2013-12-10','12:10:00',2.4),('16273','2013-12-10','12:15:00',2.38),('16273','2013-12-10','12:20:00',2.37),('16273','2013-12-10','12:25:00',2.36),('16273','2013-12-10','12:30:00',2.35),('16273','2013-12-10','12:35:00',2.33),('16273','2013-12-10','12:40:00',2.3),('16273','2013-12-10','12:45:00',2.26),('16273','2013-12-10','12:50:00',2.22),('16273','2013-12-10','12:55:00',2.18),('16273','2013-12-10','13:00:00',2.14),('16273','2013-12-10','13:05:00',2.09),('16273','2013-12-10','13:10:00',2.05),('16273','2013-12-10','13:15:00',2.01),('16273','2013-12-10','13:20:00',1.97),('16273','2013-12-10','13:25:00',1.92),('16273','2013-12-10','13:30:00',1.88),('16273','2013-12-10','13:35:00',1.84),('16273','2013-12-10','13:40:00',1.78),('16273','2013-12-10','13:45:00',1.72),('16273','2013-12-10','13:50:00',1.66),('16273','2013-12-10','13:55:00',1.61),('16273','2013-12-10','14:00:00',1.55),('16273','2013-12-10','14:05:00',1.5),('16273','2013-12-10','14:10:00',1.43),('16273','2013-12-10','14:15:00',1.38),('16273','2013-12-10','14:20:00',1.32),('16273','2013-12-10','14:25:00',1.27),('16273','2013-12-10','14:30:00',1.2),('16273','2013-12-10','14:35:00',1.17),('16273','2013-12-10','14:40:00',1.1),('16273','2013-12-10','14:50:00',1.01),('16273','2013-12-09','09:15:00',1.52),('16273','2013-12-09','09:20:00',1.91),('16273','2013-12-09','09:25:00',1.92),('16273','2013-12-09','09:30:00',1.95),('16273','2013-12-09','09:35:00',2.03),('16273','2013-12-09','09:40:00',2.16),('16273','2013-12-09','09:45:00',2.26),('16273','2013-12-09','09:50:00',2.52),('16273','2013-12-09','09:55:00',2.68),('16273','2013-12-09','10:00:00',1.98),('16273','2013-12-09','12:20:00',1.04),('16273','2013-12-09','12:25:00',1.46),('16273','2013-12-09','12:35:00',1.16),('16273','2013-12-09','12:40:00',1.49),('16273','2013-12-09','12:45:00',2.37),('16273','2013-12-09','12:50:00',2.36),('16273','2013-12-09','12:55:00',1.82),('16273','2013-12-09','13:00:00',1.66),('16273','2013-12-09','13:05:00',1.69),('16273','2013-12-09','13:10:00',1.9),('16273','2013-12-09','13:15:00',1.61),('16273','2013-12-09','13:20:00',1.18),('16273','2013-12-09','13:30:00',1.39),('16273','2013-12-09','13:35:00',1.22),('16273','2013-12-09','13:40:00',1.27),('16273','2013-12-08','11:15:00',1.06),('16273','2013-12-08','11:20:00',1.04),('16273','2013-12-08','11:25:00',1.34),('16273','2013-12-08','11:30:00',1.36),('16273','2013-12-08','11:35:00',1.22),('16273','2013-12-08','11:40:00',1.07),('16273','2013-12-08','12:00:00',1.07),('16273','2013-12-08','12:35:00',1.03),('16273','2013-12-08','12:40:00',1.49),('16273','2013-12-08','12:45:00',1.17),('16273','2013-12-08','14:55:00',1.01),('16273','2014-04-21','08:45:00',1.31),('16273','2014-04-21','08:50:00',1.4),('16273','2014-04-21','08:55:00',1.97),('16273','2014-04-21','09:00:00',1.74),('16273','2014-04-21','09:05:00',1.3),('16273','2014-04-21','09:10:00',1.39),('16273','2014-04-21','09:15:00',1.12),('16273','2014-04-21','09:20:00',1.78),('16273','2014-04-21','09:25:00',1.61),('16273','2014-04-21','09:30:00',2.36),('16273','2014-04-21','09:35:00',1.67),('16273','2014-04-21','09:50:00',1.09),('16273','2014-04-21','09:55:00',1.31),('16273','2014-04-21','10:00:00',1.31),('16273','2014-04-21','10:05:00',1.47),('16273','2014-04-21','10:10:00',2.48),('16273','2014-04-21','10:15:00',3.57),('16273','2014-04-21','10:20:00',3.46),('16273','2014-04-21','10:25:00',3.34),('16273','2014-04-21','10:30:00',3.31),('16273','2014-04-21','10:35:00',3.32),('16273','2014-04-21','10:40:00',3.35),('16273','2014-04-21','10:45:00',3.4),('16273','2014-04-21','10:50:00',3.42),('16273','2014-04-21','10:55:00',3.43),('16273','2014-04-21','11:00:00',3.46),('16273','2014-04-21','11:05:00',3.49),('16273','2014-04-21','11:10:00',3.48),('16273','2014-04-21','11:15:00',3.53),('16273','2014-04-21','11:20:00',3.56),('16273','2014-04-21','11:25:00',3.59),('16273','2014-04-21','11:30:00',3.6),('16273','2014-04-21','11:35:00',3.62),('16273','2014-04-21','11:40:00',3.65),('16273','2014-04-21','11:45:00',3.66),('16273','2014-04-21','11:50:00',3.69),('16273','2014-04-21','11:55:00',3.69),('16273','2014-04-21','12:00:00',3.69),('16273','2014-04-21','12:05:00',3.71),('16273','2014-04-21','12:10:00',3.71),('16273','2014-04-21','12:15:00',3.73),('16273','2014-04-21','12:20:00',3.75),('16273','2014-04-21','12:25:00',3.71),('16273','2014-04-21','12:30:00',3.74),('16273','2014-04-21','12:35:00',3.75),('16273','2014-04-21','12:40:00',3.74),('16273','2014-04-21','12:45:00',3.74),('16273','2014-04-21','12:50:00',3.73),('16273','2014-04-21','12:55:00',3.71),('16273','2014-04-21','13:00:00',3.74),('16273','2014-04-21','13:05:00',3.72),('16273','2014-04-21','13:10:00',3.71),('16273','2014-04-21','13:15:00',3.73),('16273','2014-04-21','13:20:00',3.72),('16273','2014-04-21','13:25:00',3.72),('16273','2014-04-21','13:30:00',3.69),('16273','2014-04-21','13:35:00',3.69),('16273','2014-04-21','13:40:00',3.66),('16273','2014-04-21','13:45:00',3.65),('16273','2014-04-21','13:50:00',3.64),('16273','2014-04-21','13:55:00',3.61),('16273','2014-04-21','14:00:00',3.59),('16273','2014-04-21','14:05:00',3.57),('16273','2014-04-21','14:10:00',3.49),('16273','2014-04-21','14:15:00',3.49),('16273','2014-04-21','14:20:00',3.46),('16273','2014-04-21','14:25:00',3.42),('16273','2014-04-21','14:30:00',3.39),('16273','2014-04-21','14:35:00',3.36),('16273','2014-04-21','14:40:00',3.3),('16273','2014-04-21','14:45:00',3.25),('16273','2014-04-21','14:50:00',3.22),('16273','2014-04-21','14:55:00',3.17),('16273','2014-04-21','15:00:00',3.12),('16273','2014-04-21','15:05:00',3.07),('16273','2014-04-21','15:10:00',3.02),('16273','2014-04-21','15:15:00',2.95),('16273','2014-04-21','15:20:00',2.89),('16273','2014-04-21','15:25:00',2.84),('16273','2014-04-21','15:30:00',2.79),('16273','2014-04-21','15:35:00',2.73),('16273','2014-04-21','15:40:00',2.67),('16273','2014-04-21','15:45:00',2.6),('16273','2014-04-21','15:50:00',2.54),('16273','2014-04-21','15:55:00',2.48),('16273','2014-04-21','16:00:00',2.41),('16273','2014-04-21','16:05:00',2.47),('16273','2014-04-21','16:10:00',2.29),('16273','2014-04-21','16:15:00',2.17),('16273','2014-04-21','16:20:00',2.15),('16273','2014-04-21','16:25:00',2.11),('16273','2014-04-21','16:30:00',2.04),('16273','2014-04-21','16:35:00',1.96),('16273','2014-04-21','16:40:00',1.88),('16273','2014-04-21','16:45:00',1.8),('16273','2014-04-21','16:50:00',1.72),('16273','2014-04-21','16:55:00',1.64),('16273','2014-04-21','17:00:00',1.57),('16273','2014-04-21','17:05:00',1.49),('16273','2014-04-21','17:10:00',1.42),('16273','2014-04-21','17:15:00',1.34),('16273','2014-04-21','17:20:00',1.28),('16273','2014-04-21','17:25:00',1.21),('16273','2014-04-21','17:30:00',1.13),('16273','2014-04-21','17:35:00',1.05),('16273','2013-12-07','08:30:00',1.04),('16273','2013-12-07','08:35:00',1.2),('16273','2013-12-07','08:40:00',1.17),('16273','2013-12-07','08:45:00',1.41),('16273','2013-12-07','08:50:00',1.5),('16273','2013-12-07','08:55:00',1.54),('16273','2013-12-07','09:00:00',1.62),('16273','2013-12-07','09:05:00',1.69),('16273','2013-12-07','09:10:00',1.69),('16273','2013-12-07','09:15:00',1.8),('16273','2013-12-07','09:20:00',1.85),('16273','2013-12-07','09:25:00',1.9),('16273','2013-12-07','09:30:00',1.97),('16273','2013-12-07','09:35:00',2.04),('16273','2013-12-07','09:40:00',2.09),('16273','2013-12-07','09:45:00',2.11),('16273','2013-12-07','09:50:00',2.13),('16273','2013-12-07','09:55:00',2.18),('16273','2013-12-07','10:00:00',2.22),('16273','2013-12-07','10:05:00',2.28),('16273','2013-12-07','10:10:00',2.33),('16273','2013-12-07','10:15:00',2.34),('16273','2013-12-07','10:20:00',2.37),('16273','2013-12-07','10:25:00',2.4),('16273','2013-12-07','10:30:00',2.43),('16273','2013-12-07','10:35:00',2.42),('16273','2013-12-07','10:40:00',2.41),('16273','2013-12-07','10:45:00',2.44),('16273','2013-12-07','10:50:00',2.47),('16273','2013-12-07','10:55:00',2.46),('16273','2013-12-07','11:00:00',2.44),('16273','2013-12-07','11:05:00',2.49),('16273','2013-12-07','11:10:00',2.52),('16273','2013-12-07','11:15:00',2.49),('16273','2013-12-07','11:20:00',2.49),('16273','2013-12-07','11:25:00',2.48),('16273','2013-12-07','11:30:00',2.49),('16273','2013-12-07','11:35:00',2.47),('16273','2013-12-07','11:40:00',2.45),('16273','2013-12-07','11:45:00',2.43),('16273','2013-12-07','11:50:00',2.41),('16273','2013-12-07','11:55:00',2.39),('16273','2013-12-07','12:00:00',2.39),('16273','2013-12-07','12:05:00',2.35),('16273','2013-12-07','12:10:00',2.34),('16273','2013-12-07','12:15:00',2.32),('16273','2013-12-07','12:20:00',2.29),('16273','2013-12-07','12:25:00',2.24),('16273','2013-12-07','12:30:00',2.23),('16273','2013-12-07','12:35:00',2.18),('16273','2013-12-07','12:40:00',2.18),('16273','2013-12-07','12:45:00',2.14),('16273','2013-12-07','12:50:00',2.1),('16273','2013-12-07','12:55:00',2.08),('16273','2013-12-07','13:00:00',2.06),('16273','2013-12-07','13:05:00',2.03),('16273','2013-12-07','13:10:00',2),('16273','2013-12-07','13:15:00',1.96),('16273','2013-12-07','13:20:00',1.88),('16273','2013-12-07','13:25:00',1.82),('16273','2013-12-07','13:30:00',1.77),('16273','2013-12-07','13:35:00',1.73),('16273','2013-12-07','13:40:00',1.69),('16273','2013-12-07','13:45:00',1.64),('16273','2013-12-07','13:50:00',1.63),('16273','2013-12-07','13:55:00',1.59),('16273','2013-12-07','14:00:00',1.55),('16273','2013-12-07','14:05:00',1.48),('16273','2013-12-07','14:10:00',1.42),('16273','2013-12-07','14:15:00',1.36),('16273','2013-12-07','14:20:00',1.31),('16273','2013-12-07','14:25:00',1.25),('16273','2013-12-07','14:30:00',1.19),('16273','2013-12-07','14:35:00',1.15),('16273','2013-12-07','14:40:00',1.1),('16273','2013-12-07','14:45:00',1.05),('16273','2013-12-06','11:05:00',1.03),('16273','2013-12-06','11:20:00',1.11),('16273','2013-12-06','11:25:00',1.31),('16273','2013-12-06','11:30:00',1.43),('16273','2013-12-06','11:35:00',1.23),('16273','2013-12-06','11:40:00',1.68),('16273','2013-12-06','11:45:00',1.92),('16273','2013-12-06','11:50:00',1.82),('16273','2013-12-06','11:55:00',1.55),('16273','2013-12-06','12:00:00',1.88),('16273','2013-12-06','12:05:00',2.11),('16273','2013-12-06','12:10:00',2.45),('16273','2013-12-06','12:15:00',2.45),('16273','2013-12-06','12:20:00',2.6),('16273','2013-12-06','12:25:00',1.25),('16273','2013-12-06','12:30:00',1.17),('16273','2013-12-06','12:35:00',1.2),('16273','2013-12-06','14:40:00',1.31),('16273','2013-12-06','14:45:00',1.23),('16273','2013-12-06','14:50:00',1.1),('16273','2013-12-05','08:30:00',1.08),('16273','2013-12-05','08:35:00',1.05),('16273','2013-12-05','08:40:00',1.38),('16273','2013-12-05','08:45:00',1.46),('16273','2013-12-05','08:50:00',1.56),('16273','2013-12-05','08:55:00',1.63),('16273','2013-12-05','09:00:00',1.72),('16273','2013-12-05','09:05:00',1.79),('16273','2013-12-05','09:10:00',1.84),('16273','2013-12-05','09:15:00',1.91),('16273','2013-12-05','09:20:00',1.98),('16273','2013-12-05','09:25:00',2.03),('16273','2013-12-05','09:30:00',2.09),('16273','2013-12-05','09:35:00',2.13),('16273','2013-12-05','09:40:00',2.17),('16273','2013-12-05','09:45:00',2.21),('16273','2013-12-05','09:50:00',2.26),('16273','2013-12-05','09:55:00',2.28),('16273','2013-12-05','10:00:00',2.33),('16273','2013-12-05','10:05:00',2.36),('16273','2013-12-05','10:10:00',2.37),('16273','2013-12-05','10:15:00',2.41),('16273','2013-12-05','10:20:00',2.42),('16273','2013-12-05','10:25:00',2.44),('16273','2013-12-05','10:30:00',2.47),('16273','2013-12-05','10:35:00',2.47),('16273','2013-12-05','10:40:00',2.48),('16273','2013-12-05','10:45:00',2.5),('16273','2013-12-05','10:50:00',2.5),('16273','2013-12-05','10:55:00',2.54),('16273','2013-12-05','11:00:00',2.53),('16273','2013-12-05','11:05:00',2.57),('16273','2013-12-05','11:10:00',2.53),('16273','2013-12-05','11:15:00',2.56),('16273','2013-12-05','11:20:00',2.52),('16273','2013-12-05','11:25:00',2.52),('16273','2013-12-05','11:30:00',2.53),('16273','2013-12-05','11:35:00',2.51),('16273','2013-12-05','11:40:00',2.49),('16273','2013-12-05','11:45:00',2.5),('16273','2013-12-05','11:50:00',2.48),('16273','2013-12-05','11:55:00',2.43),('16273','2013-12-05','12:00:00',2.5),('16273','2013-12-05','12:05:00',2.38),('16273','2013-12-05','12:10:00',2.49),('16273','2013-12-05','12:15:00',2.35),('16273','2013-12-05','12:20:00',2.41),('16273','2013-12-05','12:25:00',2.34),('16273','2013-12-05','12:30:00',2.31),('16273','2013-12-05','12:35:00',2.29),('16273','2013-12-05','12:40:00',2.29),('16273','2013-12-05','12:45:00',2.28),('16273','2013-12-05','12:50:00',2.19),('16273','2013-12-05','12:55:00',2.12),('16273','2013-12-05','13:00:00',2.04),('16273','2013-12-05','13:05:00',2.1),('16273','2013-12-05','13:10:00',2.02),('16273','2013-12-05','13:15:00',2.01),('16273','2013-12-05','13:20:00',1.93),('16273','2013-12-05','13:25:00',1.99),('16273','2013-12-05','13:30:00',1.91),('16273','2013-12-05','13:35:00',1.78),('16273','2013-12-05','13:40:00',1.61),('16273','2013-12-05','13:45:00',1.7),('16273','2013-12-05','13:50:00',1.72),('16273','2013-12-05','14:00:00',1.22),('16273','2013-12-05','14:05:00',1.66),('16273','2013-12-05','14:10:00',1.48),('16273','2013-12-05','14:15:00',1.4),('16273','2013-12-05','14:20:00',1.36),('16273','2013-12-05','14:25:00',1.3),('16273','2013-12-05','14:30:00',1.26),('16273','2013-12-05','14:35:00',1.2),('16273','2013-12-05','14:40:00',1.12),('16273','2013-12-05','14:45:00',1.09),('16273','2013-12-04','08:30:00',1.29),('16273','2013-12-04','08:35:00',1.26),('16273','2013-12-04','08:40:00',1.59),('16273','2013-12-04','08:45:00',1.68),('16273','2013-12-04','08:50:00',1.77),('16273','2013-12-04','08:55:00',1.82),('16273','2013-12-04','09:00:00',1.9),('16273','2013-12-04','09:05:00',1.96),('16273','2013-12-04','09:10:00',2.02),('16273','2013-12-04','09:15:00',2.08),('16273','2013-12-04','09:20:00',2.13),('16273','2013-12-04','09:25:00',2.18),('16273','2013-12-04','09:30:00',2.24),('16273','2013-12-04','09:35:00',2.29),('16273','2013-12-04','09:40:00',2.33),('16273','2013-12-04','09:45:00',2.37),('16273','2013-12-04','09:50:00',2.4),('16273','2013-12-04','09:55:00',2.44),('16273','2013-12-04','10:00:00',2.48),('16273','2013-12-04','10:05:00',2.5),('16273','2013-12-04','10:10:00',2.51),('16273','2013-12-04','10:15:00',2.55),('16273','2013-12-04','10:20:00',2.59),('16273','2013-12-04','10:25:00',2.6),('16273','2013-12-04','10:30:00',2.62),('16273','2013-12-04','10:35:00',2.65),('16273','2013-12-04','10:40:00',2.64),('16273','2013-12-04','10:45:00',2.67),('16273','2013-12-04','10:50:00',2.67),('16273','2013-12-04','10:55:00',2.68),('16273','2013-12-04','11:00:00',2.69),('16273','2013-12-04','11:05:00',2.7),('16273','2013-12-04','11:10:00',2.7),('16273','2013-12-04','11:15:00',2.71),('16273','2013-12-04','11:20:00',2.71),('16273','2013-12-04','11:25:00',2.69),('16273','2013-12-04','11:30:00',2.69),('16273','2013-12-04','11:35:00',2.68),('16273','2013-12-04','11:40:00',2.66),('16273','2013-12-04','11:45:00',2.64),('16273','2013-12-04','11:50:00',2.62),('16273','2013-12-04','11:55:00',2.6),('16273','2013-12-04','12:00:00',2.6),('16273','2013-12-04','12:05:00',2.58),('16273','2013-12-04','12:10:00',2.57),('16273','2013-12-04','12:15:00',2.54),('16273','2013-12-04','12:20:00',2.53),('16273','2013-12-04','12:25:00',2.48),('16273','2013-12-04','12:30:00',2.46),('16273','2013-12-04','12:35:00',2.44),('16273','2013-12-04','12:40:00',2.42),('16273','2013-12-04','12:45:00',2.38),('16273','2013-12-04','12:50:00',2.33),('16273','2013-12-04','12:55:00',2.29),('16273','2013-12-04','13:00:00',2.24),('16273','2013-12-04','13:05:00',2.21),('16273','2013-12-04','13:10:00',2.17),('16273','2013-12-04','13:15:00',2.14),('16273','2013-12-04','13:20:00',2.09),('16273','2013-12-04','13:25:00',2.04),('16273','2013-12-04','13:30:00',1.99),('16273','2013-12-04','13:35:00',1.94),('16273','2013-12-04','13:40:00',1.86),('16273','2013-12-04','13:45:00',1.82),('16273','2013-12-04','13:50:00',1.78),('16273','2013-12-04','13:55:00',1.73),('16273','2013-12-04','14:00:00',1.68),('16273','2013-12-04','14:05:00',1.61),('16273','2013-12-04','14:10:00',1.55),('16273','2013-12-04','14:15:00',1.49),('16273','2013-12-04','14:20:00',1.44),('16273','2013-12-04','14:25:00',1.38),('16273','2013-12-04','14:30:00',1.33),('16273','2013-12-04','14:35:00',1.27),('16273','2013-12-04','14:40:00',1.21),('16273','2013-12-04','14:45:00',1.16),('16273','2013-12-04','14:50:00',1.1),('16273','2013-12-03','09:00:00',1.14),('16273','2013-12-03','09:20:00',1.1),('16273','2013-12-03','09:25:00',1.4),('16273','2013-12-03','09:30:00',1.82),('16273','2013-12-03','09:35:00',2.06),('16273','2013-12-03','09:40:00',2.19),('16273','2013-12-03','09:45:00',2.16),('16273','2013-12-03','09:50:00',2.38),('16273','2013-12-03','09:55:00',2.3),('16273','2013-12-03','10:00:00',2.44),('16273','2013-12-03','10:05:00',2.4),('16273','2013-12-03','10:10:00',2.48),('16273','2013-12-03','10:15:00',2.52),('16273','2013-12-03','10:20:00',2.54),('16273','2013-12-03','10:25:00',2.55),('16273','2013-12-03','10:30:00',2.58),('16273','2013-12-03','10:35:00',2.56),('16273','2013-12-03','10:40:00',2.6),('16273','2013-12-03','10:45:00',2.61),('16273','2013-12-03','10:50:00',2.63),('16273','2013-12-03','10:55:00',2.65),('16273','2013-12-03','11:00:00',2.68),('16273','2013-12-03','11:05:00',2.7),('16273','2013-12-03','11:10:00',2.72),('16273','2013-12-03','11:15:00',2.73),('16273','2013-12-03','11:20:00',2.73),('16273','2013-12-03','11:25:00',2.73),('16273','2013-12-03','11:30:00',2.71),('16273','2013-12-03','11:35:00',2.71),('16273','2013-12-03','11:40:00',2.7),('16273','2013-12-03','11:45:00',2.7),('16273','2013-12-03','11:50:00',2.67),('16273','2013-12-03','11:55:00',2.68),('16273','2013-12-03','12:00:00',2.67),('16273','2013-12-03','12:05:00',2.68),('16273','2013-12-03','12:10:00',2.68),('16273','2013-12-03','12:15:00',2.66),('16273','2013-12-03','12:20:00',2.66),('16273','2013-12-03','12:25:00',2.66),('16273','2013-12-03','12:30:00',2.66),('16273','2013-12-03','12:35:00',2.67),('16273','2013-12-03','12:40:00',2.67),('16273','2013-12-03','12:45:00',2.68),('16273','2013-12-03','12:50:00',2.7),('16273','2013-12-03','12:55:00',2.76),('16273','2013-12-03','13:00:00',2.81),('16273','2013-12-03','13:05:00',2.8),('16273','2013-12-03','13:10:00',2.77),('16273','2013-12-03','13:15:00',2.71),('16273','2013-12-03','13:20:00',2.58),('16273','2013-12-03','13:25:00',2.18),('16273','2013-12-03','13:30:00',1.6),('16273','2013-12-03','13:35:00',1.42),('16273','2013-12-03','13:40:00',1.51),('16273','2013-12-03','13:45:00',1.5),('16273','2013-12-03','13:50:00',1.28),('16273','2013-12-03','14:10:00',1.12),('16273','2013-12-03','14:15:00',1.34),('16273','2013-12-03','14:20:00',1.37),('16273','2013-12-03','14:25:00',1.28),('16273','2013-12-03','14:30:00',1.31),('16273','2013-12-03','14:35:00',1.26),('16273','2013-12-03','14:40:00',1.2),('16273','2013-12-03','14:45:00',1.14),('16273','2013-12-03','14:50:00',1.08),('16273','2013-12-01','11:25:00',1.1),('16273','2013-12-01','11:30:00',1.12),('16273','2013-12-01','11:35:00',1.45),('16273','2013-12-01','11:40:00',1.66),('16273','2013-12-01','11:45:00',1.76),('16273','2013-12-01','11:50:00',1.59),('16273','2013-12-01','11:55:00',1.63),('16273','2013-12-01','12:00:00',2.14),('16273','2013-12-01','12:05:00',2.35),('16273','2013-12-01','12:10:00',1.98),('16273','2013-12-01','12:15:00',1.64),('16273','2013-11-30','09:05:00',1.26),('16273','2013-11-30','09:10:00',1.8),('16273','2013-11-30','09:15:00',1.65),('16273','2013-11-30','09:20:00',1.15),('16273','2013-11-30','09:25:00',1.56),('16273','2013-11-30','09:30:00',1.77),('16273','2013-11-30','09:35:00',1.26),('16273','2013-11-30','09:40:00',1.16),('16273','2013-11-30','09:45:00',1.03),('16273','2013-11-30','10:15:00',1.05),('16273','2013-11-30','10:20:00',1.23),('16273','2013-11-30','10:25:00',1.04),('16273','2013-11-30','10:30:00',1),('16273','2013-11-30','10:40:00',1.01),('16273','2013-11-30','10:50:00',1.08),('16273','2013-11-30','10:55:00',1.17),('16273','2013-11-30','11:00:00',1.03),('16273','2013-11-30','11:05:00',1.06),('16273','2013-11-30','11:10:00',1.12),('16273','2013-11-30','11:15:00',1.12),('16273','2013-11-30','11:20:00',1.14),('16273','2013-11-30','11:25:00',1.11),('16273','2013-11-30','11:30:00',1.05),('16273','2013-11-29','08:25:00',1.2),('16273','2013-11-29','08:30:00',1.19),('16273','2013-11-29','08:35:00',1.46),('16273','2013-11-29','08:40:00',1.55),('16273','2013-11-29','08:45:00',1.64),('16273','2013-11-29','08:50:00',1.71),('16273','2013-11-29','08:55:00',1.78),('16273','2013-11-29','09:00:00',1.87),('16273','2013-11-29','09:05:00',1.95),('16273','2013-11-29','09:10:00',2.01),('16273','2013-11-29','09:15:00',2.06),('16273','2013-11-29','09:20:00',2.11),('16273','2013-11-29','09:25:00',2.15),('16273','2013-11-29','09:30:00',2.22),('16273','2013-11-29','09:35:00',2.29),('16273','2013-11-29','09:40:00',2.34),('16273','2013-11-29','09:45:00',2.37),('16273','2013-11-29','09:50:00',2.42),('16273','2013-11-29','09:55:00',2.46),('16273','2013-11-29','10:00:00',2.49),('16273','2013-11-29','10:05:00',2.53),('16273','2013-11-29','10:10:00',2.57),('16273','2013-11-29','10:15:00',2.6),('16273','2013-11-29','10:20:00',2.63),('16273','2013-11-29','10:25:00',2.66),('16273','2013-11-29','10:30:00',2.68),('16273','2013-11-29','10:35:00',2.7),('16273','2013-11-29','10:40:00',2.72),('16273','2013-11-29','10:45:00',2.73),('16273','2013-11-29','10:50:00',2.74),('16273','2013-11-29','10:55:00',2.75),('16273','2013-11-29','11:00:00',2.75),('16273','2013-11-29','11:05:00',2.75),('16273','2013-11-29','11:10:00',2.74),('16273','2013-11-29','11:15:00',2.73),('16273','2013-11-29','11:20:00',2.74),('16273','2013-11-29','11:25:00',2.74),('16273','2013-11-29','11:30:00',2.74),('16273','2013-11-29','11:35:00',2.73),('16273','2013-11-29','11:40:00',2.71),('16273','2013-11-29','11:45:00',2.7),('16273','2013-11-29','11:50:00',2.68),('16273','2013-11-29','11:55:00',2.68),('16273','2013-11-29','12:00:00',2.66),('16273','2013-11-29','12:05:00',2.63),('16273','2013-11-29','12:10:00',2.61),('16273','2013-11-29','12:15:00',2.56),('16273','2013-11-29','12:20:00',2.53),('16273','2013-11-29','12:25:00',2.52),('16273','2013-11-29','12:30:00',2.49),('16273','2013-11-29','12:35:00',2.45),('16273','2013-11-29','12:40:00',2.43),('16273','2013-11-29','12:45:00',2.38),('16273','2013-11-29','12:50:00',2.35),('16273','2013-11-29','12:55:00',2.32),('16273','2013-11-29','13:00:00',2.28),('16273','2013-11-29','13:05:00',2.25),('16273','2013-11-29','13:10:00',2.21),('16273','2013-11-29','13:15:00',2.18),('16273','2013-11-29','13:20:00',2.13),('16273','2013-11-29','13:25:00',2.08),('16273','2013-11-29','13:30:00',2.02),('16273','2013-11-29','13:35:00',1.97),('16273','2013-11-29','13:40:00',1.92),('16273','2013-11-29','13:45:00',1.86),('16273','2013-11-29','13:50:00',1.81),('16273','2013-11-29','13:55:00',1.74),('16273','2013-11-29','14:00:00',1.67),('16273','2013-11-29','14:05:00',1.61),('16273','2013-11-29','14:10:00',1.55),('16273','2013-11-29','14:15:00',1.51),('16273','2013-11-29','14:20:00',1.44),('16273','2013-11-29','14:25:00',1.38),('16273','2013-11-29','14:30:00',1.33),('16273','2013-11-29','14:35:00',1.27),('16273','2013-11-29','14:40:00',1.2),('16273','2013-11-29','14:45:00',1.15),('16273','2013-11-29','14:50:00',1.09),('16273','2014-04-20','07:35:00',1.14),('16273','2014-04-20','07:40:00',1.19),('16273','2014-04-20','07:45:00',1.27),('16273','2014-04-20','07:50:00',1.08),('16273','2014-04-20','07:55:00',1.34),('16273','2014-04-20','08:00:00',1.52),('16273','2014-04-20','08:05:00',1.11),('16273','2014-04-20','08:10:00',1.1),('16273','2014-04-20','08:15:00',1.88),('16273','2014-04-20','08:20:00',2.76),('16273','2014-04-20','08:40:00',1.97),('16273','2014-04-20','08:45:00',2.13),('16273','2014-04-20','08:50:00',2.43),('16273','2014-04-20','08:55:00',2.47),('16273','2014-04-20','09:00:00',2.5),('16273','2014-04-20','09:05:00',2.61),('16273','2014-04-20','09:10:00',2.24),('16273','2014-04-20','09:15:00',2.26),('16273','2014-04-20','09:20:00',3.06),('16273','2014-04-20','09:25:00',2.32),('16273','2014-04-20','09:30:00',2.13),('16273','2014-04-20','09:35:00',2.93),('16273','2014-04-20','09:40:00',2.1),('16273','2014-04-20','09:45:00',1.88),('16273','2014-04-20','09:50:00',1.81),('16273','2014-04-20','09:55:00',2.35),('16273','2014-04-20','10:00:00',1.81),('16273','2014-04-20','10:05:00',2.42),('16273','2014-04-20','10:10:00',2.43),('16273','2014-04-20','10:15:00',3.22),('16273','2014-04-20','10:20:00',3.07),('16273','2014-04-20','10:25:00',2.46),('16273','2014-04-20','10:30:00',2.52),('16273','2014-04-20','10:35:00',2.47),('16273','2014-04-20','10:40:00',2.28),('16273','2014-04-20','10:45:00',2.44),('16273','2014-04-20','10:50:00',2.85),('16273','2014-04-20','10:55:00',3.23),('16273','2014-04-20','11:00:00',3.03),('16273','2014-04-20','11:05:00',3.17),('16273','2014-04-20','11:10:00',3.74),('16273','2014-04-20','11:15:00',3.71),('16273','2014-04-20','11:20:00',3.78),('16273','2014-04-20','11:25:00',3.89),('16273','2014-04-20','11:30:00',3.99),('16273','2014-04-20','11:35:00',3.94),('16273','2014-04-20','11:40:00',3.94),('16273','2014-04-20','11:45:00',3.93),('16273','2014-04-20','11:50:00',3.92),('16273','2014-04-20','11:55:00',3.88),('16273','2014-04-20','12:00:00',3.89),('16273','2014-04-20','12:05:00',3.92),('16273','2014-04-20','12:10:00',3.94),('16273','2014-04-20','12:15:00',3.94),('16273','2014-04-20','12:20:00',3.92),('16273','2014-04-20','12:25:00',3.92),('16273','2014-04-20','12:30:00',3.91),('16273','2014-04-20','12:35:00',3.93),('16273','2014-04-20','12:40:00',3.94),('16273','2014-04-20','12:45:00',3.89),('16273','2014-04-20','12:50:00',3.88),('16273','2014-04-20','12:55:00',3.84),('16273','2014-04-20','13:00:00',3.84),('16273','2014-04-20','13:05:00',3.71),('16273','2014-04-20','13:10:00',3.29),('16273','2014-04-20','13:15:00',3.84),('16273','2014-04-20','13:20:00',3.83),('16273','2014-04-20','13:25:00',3.8),('16273','2014-04-20','13:30:00',3.78),('16273','2014-04-20','13:35:00',3.76),('16273','2014-04-20','13:40:00',3.74),('16273','2014-04-20','13:45:00',3.67),('16273','2014-04-20','13:50:00',3.67),('16273','2014-04-20','13:55:00',3.64),('16273','2014-04-20','14:00:00',3.64),('16273','2014-04-20','14:05:00',3.66),('16273','2014-04-20','14:10:00',3.85),('16273','2014-04-20','14:15:00',2.98),('16273','2014-04-20','14:20:00',2.24),('16273','2014-04-20','14:25:00',2.25),('16273','2014-04-20','14:30:00',2.05),('16273','2014-04-20','14:35:00',1.98),('16273','2014-04-20','14:40:00',2.04),('16273','2014-04-20','14:45:00',2.2),('16273','2014-04-20','14:50:00',2.42),('16273','2014-04-20','14:55:00',2.81),('16273','2014-04-20','15:00:00',3.81),('16273','2014-04-20','15:05:00',2.96),('16273','2014-04-20','15:10:00',2.54),('16273','2014-04-20','15:15:00',3.09),('16273','2014-04-20','15:20:00',3),('16273','2014-04-20','15:25:00',2.93),('16273','2014-04-20','15:30:00',2.88),('16273','2014-04-20','15:35:00',2.9),('16273','2014-04-20','15:40:00',2.03),('16273','2014-04-20','15:45:00',2.22),('16273','2014-04-20','15:50:00',2.73),('16273','2014-04-20','15:55:00',2.54),('16273','2014-04-20','16:00:00',2.5),('16273','2014-04-20','16:05:00',2.41),('16273','2014-04-20','16:10:00',2.34),('16273','2014-04-20','16:15:00',2.24),('16273','2014-04-20','16:20:00',2.22),('16273','2014-04-20','16:25:00',2.29),('16273','2014-04-20','16:30:00',1.97),('16273','2014-04-20','16:35:00',1.95),('16273','2014-04-20','16:40:00',1.23),('16273','2014-04-20','16:45:00',1.53),('16273','2014-04-20','16:50:00',1.92),('16273','2014-04-20','16:55:00',1.74),('16273','2014-04-20','17:00:00',1.63),('16273','2014-04-20','17:05:00',1.53),('16273','2014-04-20','17:10:00',1.43),('16273','2014-04-20','17:15:00',1.34),('16273','2014-04-20','17:20:00',1.27),('16273','2014-04-20','17:25:00',1.19),('16273','2014-04-20','17:30:00',1.11),('16273','2014-04-20','17:35:00',1.04),('16273','2013-11-27','08:50:00',1.13),('16273','2013-11-27','08:55:00',1.02),('16273','2013-11-27','09:00:00',1.2),('16273','2013-11-27','09:25:00',1.34),('16273','2013-11-27','09:30:00',1.09),('16273','2013-11-27','09:35:00',1.03),('16273','2013-11-27','09:55:00',1.01),('16273','2013-11-27','10:00:00',1.19),('16273','2013-11-27','10:05:00',1.4),('16273','2013-11-27','10:10:00',1.15),('16273','2013-11-27','10:15:00',1.36),('16273','2013-11-27','10:20:00',1.25),('16273','2013-11-27','10:25:00',1.3),('16273','2013-11-27','10:30:00',1.13),('16273','2013-11-27','10:35:00',1.04),('16273','2013-11-27','10:40:00',1.07),('16273','2013-11-27','10:45:00',1.32),('16273','2013-11-27','10:50:00',1.21),('16273','2013-11-27','10:55:00',1.21),('16273','2013-11-27','11:00:00',1.36),('16273','2013-11-27','11:05:00',1.51),('16273','2013-11-27','11:10:00',1.54),('16273','2013-11-27','11:15:00',3.15),('16273','2013-11-27','11:20:00',2.43),('16273','2013-11-27','11:25:00',1.4),('16273','2013-11-27','11:30:00',1.85),('16273','2013-11-27','11:35:00',1.67),('16273','2013-11-27','11:40:00',2.3),('16273','2013-11-27','11:45:00',2.76),('16273','2013-11-27','11:50:00',3.15),('16273','2013-11-27','11:55:00',1.67),('16273','2013-11-27','12:00:00',1.77),('16273','2013-11-27','12:05:00',1.4),('16273','2013-11-27','12:10:00',1.45),('16273','2013-11-27','12:15:00',1.58),('16273','2013-11-27','12:20:00',1.63),('16273','2013-11-27','12:25:00',1.29),('16273','2013-11-27','12:30:00',1.31),('16273','2013-11-27','12:35:00',1.12),('16273','2013-11-27','12:40:00',1.05),('16273','2013-11-27','13:25:00',1.01),('16273','2013-11-26','08:40:00',1.05),('16273','2013-11-26','08:45:00',1.1),('16273','2013-11-26','09:00:00',1.03),('16273','2013-11-26','09:05:00',1.53),('16273','2013-11-26','09:10:00',1.52),('16273','2013-11-26','09:35:00',1.02),('16273','2013-11-26','09:40:00',1.22),('16273','2013-11-26','09:45:00',1.65),('16273','2013-11-26','09:50:00',2.01),('16273','2013-11-26','09:55:00',1.87),('16273','2013-11-26','10:00:00',2.01),('16273','2013-11-26','10:20:00',1.49),('16273','2013-11-26','10:25:00',2.43),('16273','2013-11-26','10:30:00',3.01),('16273','2013-11-26','10:35:00',2.96),('16273','2013-11-26','10:40:00',2.93),('16273','2013-11-26','10:45:00',2.99),('16273','2013-11-26','10:50:00',2.99),('16273','2013-11-26','10:55:00',3.03),('16273','2013-11-26','11:00:00',3.07),('16273','2013-11-26','11:05:00',2.47),('16273','2013-11-26','11:10:00',1.06),('16273','2013-11-26','11:15:00',1.08),('16273','2013-11-26','11:20:00',1.29),('16273','2013-11-26','11:25:00',2.45),('16273','2013-11-26','11:30:00',2.45),('16273','2013-11-26','11:35:00',1.59),('16273','2013-11-26','11:40:00',1.63),('16273','2013-11-26','11:45:00',1.55),('16273','2013-11-26','11:50:00',3.24),('16273','2013-11-26','11:55:00',3.12),('16273','2013-11-26','12:00:00',3.37),('16273','2013-11-26','12:05:00',3.01),('16273','2013-11-26','12:10:00',2.59),('16273','2013-11-26','12:15:00',1.91),('16273','2013-11-26','12:20:00',2.97),('16273','2013-11-26','12:25:00',2.58),('16273','2013-11-26','12:30:00',1.05),('16273','2013-11-26','12:35:00',2.65),('16273','2013-11-26','12:40:00',2.7),('16273','2013-11-26','12:45:00',2.62),('16273','2013-11-26','12:50:00',2.58),('16273','2013-11-26','12:55:00',2.54),('16273','2013-11-26','13:00:00',2.49),('16273','2013-11-26','13:05:00',2.43),('16273','2013-11-26','13:10:00',2.38),('16273','2013-11-26','13:15:00',2.33),('16273','2013-11-26','13:20:00',2.29),('16273','2013-11-26','13:25:00',2.24),('16273','2013-11-26','13:30:00',1.86),('16273','2013-11-26','13:35:00',1.13),('16273','2013-11-26','13:40:00',1.97),('16273','2013-11-26','13:45:00',2.05),('16273','2013-11-26','13:50:00',2.05),('16273','2013-11-26','13:55:00',2.11),('16273','2013-11-26','14:00:00',2.02),('16273','2013-11-26','14:05:00',2),('16273','2013-11-26','14:10:00',1.88),('16273','2013-11-26','14:15:00',1.81),('16273','2013-11-26','14:20:00',1.34),('16273','2013-11-26','14:35:00',1.31),('16273','2013-11-26','14:40:00',1.23),('16273','2013-11-26','14:45:00',1.27),('16273','2013-11-26','14:50:00',1.27),('16273','2013-11-26','14:55:00',1.17),('16273','2013-11-25','08:15:00',1.03),('16273','2013-11-25','08:20:00',1.31),('16273','2013-11-25','08:25:00',1.51),('16273','2013-11-25','08:30:00',1.4),('16273','2013-11-25','08:35:00',1.83),('16273','2013-11-25','08:40:00',2.03),('16273','2013-11-25','08:45:00',2.26),('16273','2013-11-25','08:50:00',1.84),('16273','2013-11-25','09:20:00',1.56),('16273','2013-11-25','09:25:00',1.29),('16273','2013-11-25','09:30:00',1.05),('16273','2013-11-25','09:35:00',1.12),('16273','2013-11-25','09:40:00',1.01),('16273','2013-11-25','09:45:00',1.06),('16273','2013-11-25','09:50:00',1.2),('16273','2013-11-25','09:55:00',2.21),('16273','2013-11-25','10:00:00',1.65),('16273','2013-11-25','10:05:00',2.33),('16273','2013-11-25','10:10:00',2.14),('16273','2013-11-25','10:15:00',2.21),('16273','2013-11-25','10:20:00',2.66),('16273','2013-11-25','10:25:00',2.53),('16273','2013-11-25','10:30:00',2.17),('16273','2013-11-25','10:35:00',2.21),('16273','2013-11-25','10:40:00',2.93),('16273','2013-11-25','10:45:00',2.83),('16273','2013-11-25','10:50:00',2.71),('16273','2013-11-25','10:55:00',2.75),('16273','2013-11-25','11:00:00',2.7),('16273','2013-11-25','11:05:00',2.82),('16273','2013-11-25','11:10:00',2.31),('16273','2013-11-25','11:15:00',1.77),('16273','2013-11-25','11:20:00',1.03),('16273','2013-11-25','11:25:00',1.22),('16273','2013-11-25','11:30:00',1.36),('16273','2013-11-25','11:45:00',2.64),('16273','2013-11-25','11:50:00',1.76),('16273','2013-11-25','11:55:00',2.09),('16273','2013-11-25','12:00:00',2.08),('16273','2013-11-25','12:05:00',1.4),('16273','2013-11-25','12:10:00',1.25),('16273','2013-11-25','12:15:00',1.29),('16273','2013-11-25','12:20:00',1.45),('16273','2013-11-25','12:25:00',2.05),('16273','2013-11-25','12:30:00',1.4),('16273','2013-11-25','12:35:00',1.26),('16273','2013-11-25','12:40:00',1.91),('16273','2013-11-25','12:45:00',2.22),('16273','2013-11-25','12:50:00',2.56),('16273','2013-11-25','12:55:00',2.63),('16273','2013-11-25','13:00:00',2.42),('16273','2013-11-25','13:05:00',2.71),('16273','2013-11-25','13:10:00',2.55),('16273','2013-11-25','13:15:00',2.73),('16273','2013-11-25','13:20:00',2.79),('16273','2013-11-25','13:25:00',2.55),('16273','2013-11-25','13:30:00',1.04),('16273','2013-11-25','13:45:00',1.15),('16273','2013-11-25','13:50:00',1.36),('16273','2013-11-24','09:55:00',1.06),('16273','2013-11-24','10:00:00',1.42),('16273','2013-11-24','10:05:00',1.49),('16273','2013-11-24','10:10:00',1.38),('16273','2013-11-24','10:15:00',1.41),('16273','2013-11-24','10:20:00',1.37),('16273','2013-11-24','10:25:00',1.65),('16273','2013-11-24','10:30:00',1.55),('16273','2013-11-24','10:35:00',1.15),('16273','2013-11-24','11:15:00',1.14),('16273','2013-11-24','11:20:00',1.33),('16273','2013-11-24','11:25:00',1.21),('16273','2013-11-24','11:30:00',1.08),('16273','2013-11-24','12:40:00',1.16),('16273','2013-11-24','12:45:00',1.33),('16273','2013-11-24','12:50:00',1.36),('16273','2013-11-24','12:55:00',1.59),('16273','2013-11-24','13:00:00',1.52),('16273','2013-11-24','13:05:00',1.45),('16273','2013-11-24','13:10:00',1.37),('16273','2013-11-24','13:15:00',1.39),('16273','2013-11-24','13:20:00',1.35),('16273','2013-11-24','13:25:00',1.28),('16273','2013-11-24','13:30:00',1.21),('16273','2013-11-24','13:35:00',1.08),('16273','2013-11-23','08:40:00',1.82),('16273','2013-11-23','10:15:00',1.01),('16273','2013-11-23','10:25:00',1.73),('16273','2013-11-23','10:30:00',2.62),('16273','2013-11-22','12:15:00',1.01),('16273','2013-11-22','12:20:00',1.08),('16273','2013-11-21','08:05:00',1.06),('16273','2013-11-21','09:40:00',1.98),('16273','2013-11-21','09:45:00',1.75),('16273','2013-11-21','09:50:00',2.36),('16273','2013-11-21','09:55:00',1.95),('16273','2013-11-21','10:00:00',2.74),('16273','2013-11-21','10:05:00',1.78),('16273','2013-11-21','10:10:00',2.13),('16273','2013-11-21','10:15:00',2.07),('16273','2013-11-21','10:20:00',2.78),('16273','2013-11-21','10:25:00',3.13),('16273','2013-11-21','10:30:00',2.94),('16273','2013-11-21','10:35:00',1.97),('16273','2013-11-21','10:55:00',1.67),('16273','2013-11-21','11:00:00',1.12),('16273','2013-11-21','11:10:00',2.14),('16273','2013-11-21','11:15:00',3.06),('16273','2013-11-21','11:20:00',2.66),('16273','2013-11-21','11:30:00',2.95),('16273','2013-11-21','11:35:00',2.93),('16273','2013-11-21','11:40:00',2.89),('16273','2013-11-21','11:45:00',2.86),('16273','2013-11-21','11:50:00',2.86),('16273','2013-11-21','11:55:00',2.85),('16273','2013-11-21','12:00:00',2.9),('16273','2013-11-21','12:05:00',2.87),('16273','2013-11-21','12:10:00',2.94),('16273','2013-11-21','12:15:00',3.07),('16273','2013-11-21','12:20:00',3.06),('16273','2013-11-21','12:25:00',3.27),('16273','2013-11-21','12:30:00',3.26),('16273','2013-11-21','12:35:00',3.04),('16273','2013-11-21','12:40:00',3.04),('16273','2013-11-21','12:45:00',1.22),('16273','2013-11-21','12:50:00',1.63),('16273','2013-11-21','13:05:00',2.08),('16273','2013-11-21','13:10:00',2.32),('16273','2013-11-21','13:15:00',2.29),('16273','2013-11-21','13:20:00',1.34),('16273','2013-11-21','13:40:00',1.84),('16273','2013-11-21','13:45:00',1.07),('16273','2013-11-21','13:50:00',1.4),('16273','2013-11-21','13:55:00',1.65),('16273','2013-11-21','14:00:00',1.63),('16273','2013-11-21','14:05:00',1.04),('16273','2013-11-21','14:10:00',1.04),('16273','2013-11-21','14:25:00',1.48),('16273','2013-11-21','14:30:00',1.43),('16273','2013-11-21','14:35:00',1.37),('16273','2013-11-21','14:40:00',1.17),('16273','2013-11-21','14:50:00',1.19),('16273','2013-11-21','14:55:00',1.03),('16273','2013-11-20','08:50:00',1.29),('16273','2013-11-20','08:55:00',2.03),('16273','2013-11-20','09:00:00',1.75),('16273','2013-11-20','09:05:00',1.94),('16273','2013-11-20','09:10:00',2.36),('16273','2013-11-20','09:15:00',2.06),('16273','2013-11-20','09:50:00',1.54),('16273','2013-11-20','11:15:00',1.03),('16273','2013-11-20','11:20:00',2.13),('16273','2013-11-20','11:25:00',1.82),('16273','2013-11-20','11:30:00',1.65),('16273','2013-11-20','11:35:00',1.22),('16273','2013-11-20','11:50:00',1.36),('16273','2013-11-20','12:10:00',1.48),('16273','2013-11-20','12:15:00',1.25),('16273','2013-11-20','12:20:00',1.34),('16273','2013-11-20','12:35:00',1.15),('16273','2013-11-20','12:40:00',1.11),('16273','2013-11-20','12:50:00',1.11),('16273','2013-11-20','12:55:00',1.38),('16273','2013-11-20','13:00:00',1.31),('16273','2013-11-20','13:10:00',1.12),('16273','2013-11-20','13:15:00',1.32),('16273','2013-11-20','13:20:00',2.35),('16273','2013-11-20','13:25:00',1.94),('16273','2013-11-20','13:45:00',1.01),('16273','2013-11-20','14:15:00',1.24),('16273','2013-11-20','14:30:00',1.13),('16273','2013-11-20','14:50:00',1.12),('16273','2013-11-20','14:55:00',1.05),('16273','2013-11-19','09:15:00',1.65),('16273','2013-11-19','09:30:00',1.52),('16273','2013-11-19','09:35:00',2.42),('16273','2013-11-19','09:40:00',2.33),('16273','2013-11-19','09:45:00',2.42),('16273','2013-11-19','09:50:00',2.41),('16273','2013-11-19','09:55:00',2.51),('16273','2013-11-19','10:00:00',2.6),('16273','2013-11-19','10:05:00',1.97),('16273','2013-11-19','10:10:00',1.91),('16273','2013-11-19','10:15:00',1.21),('16273','2013-11-19','10:55:00',1.2),('16273','2013-11-19','11:20:00',1.02),('16273','2013-11-19','11:25:00',1.93),('16273','2013-11-19','11:30:00',2.88),('16273','2013-11-19','11:35:00',2.06),('16273','2013-11-19','11:40:00',2.42),('16273','2013-11-19','11:45:00',2.43),('16273','2013-11-19','11:50:00',2.58),('16273','2013-11-19','11:55:00',2.55),('16273','2013-11-19','12:00:00',2.54),('16273','2013-11-19','12:05:00',2.15),('16273','2013-11-19','12:10:00',2.35),('16273','2013-11-19','12:15:00',2.44),('16273','2013-11-19','12:20:00',1.48),('16273','2013-11-19','12:25:00',1.56),('16273','2013-11-19','12:30:00',2.71),('16273','2013-11-19','12:35:00',1.48),('16273','2013-11-19','12:40:00',1.67),('16273','2013-11-19','12:45:00',2.62),('16273','2013-11-19','12:50:00',1.12),('16273','2013-11-19','13:05:00',1.12),('16273','2013-11-19','13:10:00',1.68),('16273','2013-11-19','13:15:00',1.26),('16273','2013-11-19','15:20:00',1.15),('16273','2013-11-19','15:25:00',1.39),('16273','2013-11-19','15:30:00',1.16),('16273','2013-11-18','08:25:00',1.1),('16273','2013-11-18','08:30:00',1.11),('16273','2013-11-18','08:35:00',1.14),('16273','2013-11-18','08:45:00',1.01),('16273','2013-11-18','08:50:00',1.04),('16273','2013-11-18','09:10:00',1.01),('16273','2013-11-18','09:15:00',1.48),('16273','2013-11-18','09:20:00',1.75),('16273','2013-11-18','09:25:00',1.81),('16273','2013-11-18','09:30:00',2.26),('16273','2013-11-18','09:35:00',1.68),('16273','2013-11-18','09:40:00',1.04),('16273','2013-11-18','09:55:00',1.07),('16273','2013-11-18','10:00:00',1.39),('16273','2013-11-18','10:05:00',1.52),('16273','2013-11-18','10:10:00',1.86),('16273','2013-11-18','10:15:00',1.69),('16273','2013-11-18','10:20:00',1.23),('16273','2013-11-18','10:25:00',1.04),('16273','2013-11-18','10:30:00',1.05),('16273','2013-11-18','10:35:00',1.17),('16273','2013-11-18','10:40:00',1.3),('16273','2013-11-18','10:45:00',1.25),('16273','2013-11-18','10:50:00',1.05),('16273','2013-11-18','11:25:00',1.04),('16273','2013-11-18','11:30:00',1.1),('16273','2013-11-18','11:35:00',1.11),('16273','2013-11-18','11:40:00',1.11),('16273','2013-11-18','11:45:00',1.18),('16273','2013-11-18','11:50:00',1.26),('16273','2013-11-18','11:55:00',1.4),('16273','2013-11-18','12:00:00',1.38),('16273','2013-11-18','12:05:00',1.32),('16273','2013-11-18','12:10:00',1.38),('16273','2013-11-18','12:15:00',1.54),('16273','2013-11-18','12:20:00',1.92),('16273','2013-11-18','12:25:00',1.76),('16273','2013-11-18','12:30:00',1.55),('16273','2013-11-18','12:35:00',1.27),('16273','2013-11-18','12:40:00',1.04),('16273','2013-11-18','13:10:00',1.11),('16273','2013-11-18','13:40:00',1.06),('16273','2013-11-18','13:45:00',1.08),('16273','2014-04-19','07:30:00',1.2),('16273','2014-04-19','07:35:00',1.22),('16273','2014-04-19','07:40:00',1.09),('16273','2014-04-19','07:45:00',1.03),('16273','2014-04-19','07:50:00',1.25),('16273','2014-04-19','08:05:00',1.02),('16273','2014-04-19','08:10:00',1.13),('16273','2014-04-19','08:15:00',1.28),('16273','2014-04-19','08:20:00',1.21),('16273','2014-04-19','08:25:00',1.05),('16273','2014-04-19','08:30:00',1.19),('16273','2014-04-19','08:35:00',1.04),('16273','2014-04-19','09:15:00',1.02),('16273','2014-04-19','09:20:00',1.19),('16273','2014-04-19','09:25:00',1.02),('16273','2014-04-19','10:25:00',1.01),('16273','2014-04-19','10:30:00',1.26),('16273','2014-04-19','10:35:00',2.11),('16273','2014-04-19','10:40:00',1.69),('16273','2014-04-19','10:45:00',1.63),('16273','2014-04-19','10:50:00',2.16),('16273','2014-04-19','10:55:00',1.8),('16273','2014-04-19','11:00:00',1.43),('16273','2014-04-19','11:05:00',2),('16273','2014-04-19','11:10:00',3.51),('16273','2014-04-19','11:15:00',4.52),('16273','2014-04-19','11:20:00',3.79),('16273','2014-04-19','11:25:00',4.64),('16273','2014-04-19','11:30:00',2.68),('16273','2014-04-19','11:35:00',2.08),('16273','2014-04-19','11:40:00',1.91),('16273','2014-04-19','11:45:00',1.12),('16273','2014-04-19','13:05:00',1.16),('16273','2014-04-19','13:10:00',1.97),('16273','2014-04-19','13:15:00',1.36),('16273','2014-04-19','13:25:00',1.16),('16273','2014-04-19','14:30:00',1.51),('16273','2014-04-19','14:35:00',1.89),('16273','2014-04-19','14:40:00',1.68),('16273','2014-04-19','14:45:00',1.24),('16273','2014-04-19','14:55:00',1.23),('16273','2014-04-19','15:00:00',1.55),('16273','2014-04-19','15:40:00',3.19),('16273','2014-04-19','15:45:00',2.73),('16273','2014-04-19','15:50:00',1.86),('16273','2014-04-19','15:55:00',1.38),('16273','2014-04-19','16:05:00',1.19),('16273','2014-04-19','16:10:00',2),('16273','2014-04-19','16:15:00',2.31),('16273','2014-04-19','16:20:00',2.2),('16273','2014-04-19','16:25:00',2.07),('16273','2014-04-19','16:30:00',1.17),('16273','2014-04-19','16:40:00',1.04),('16273','2014-04-19','17:00:00',1.27),('16273','2014-04-19','17:05:00',1.09),('16273','2014-04-19','17:10:00',1.4),('16273','2014-04-19','17:15:00',1.7),('16273','2014-04-19','17:20:00',1.01),('16273','2013-11-17','08:50:00',1.03),('16273','2013-11-17','08:55:00',2.32),('16273','2013-11-17','09:00:00',1.89),('16273','2013-11-17','09:05:00',1.47),('16273','2013-11-17','09:40:00',1.01),('16273','2013-11-17','09:45:00',1.63),('16273','2013-11-17','09:50:00',2.62),('16273','2013-11-17','09:55:00',2.57),('16273','2013-11-17','10:00:00',2.58),('16273','2013-11-17','10:05:00',2.59),('16273','2013-11-17','10:10:00',2.6),('16273','2013-11-17','10:15:00',2.63),('16273','2013-11-17','10:20:00',2.66),('16273','2013-11-17','10:25:00',2.63),('16273','2013-11-17','10:30:00',2.69),('16273','2013-11-17','10:35:00',2.71),('16273','2013-11-17','10:40:00',2.74),('16273','2013-11-17','10:45:00',2.77),('16273','2013-11-17','10:50:00',2.81),('16273','2013-11-17','10:55:00',2.75),('16273','2013-11-17','11:00:00',2.74),('16273','2013-11-17','11:05:00',2.74),('16273','2013-11-17','11:10:00',2.73),('16273','2013-11-17','11:15:00',2.73),('16273','2013-11-17','11:20:00',2.74),('16273','2013-11-17','11:25:00',2.72),('16273','2013-11-17','11:30:00',2.72),('16273','2013-11-17','11:35:00',2.7),('16273','2013-11-17','11:40:00',2.7),('16273','2013-11-17','11:45:00',2.69),('16273','2013-11-17','11:50:00',2.67),('16273','2013-11-17','11:55:00',2.65),('16273','2013-11-17','12:00:00',2.62),('16273','2013-11-17','12:05:00',2.59),('16273','2013-11-17','12:10:00',2.55),('16273','2013-11-17','12:15:00',2.56),('16273','2013-11-17','12:20:00',2.56),('16273','2013-11-17','12:25:00',2.52),('16273','2013-11-17','12:30:00',2.46),('16273','2013-11-17','12:35:00',2.42),('16273','2013-11-17','12:40:00',2.41),('16273','2013-11-17','12:45:00',2.39),('16273','2013-11-17','12:50:00',2.36),('16273','2013-11-17','12:55:00',2.31),('16273','2013-11-17','13:00:00',2.26),('16273','2013-11-17','13:05:00',2.16),('16273','2013-11-17','13:10:00',2.18),('16273','2013-11-17','13:15:00',2.13),('16273','2013-11-17','13:20:00',2.15),('16273','2013-11-17','13:25:00',2.18),('16273','2013-11-17','13:30:00',2.18),('16273','2013-11-17','13:35:00',2.17),('16273','2013-11-17','13:40:00',2.09),('16273','2013-11-17','13:45:00',1.8),('16273','2013-11-17','13:50:00',1.91),('16273','2013-11-17','13:55:00',1.98),('16273','2013-11-17','14:00:00',1.59),('16273','2013-11-17','14:05:00',1.67),('16273','2013-11-17','14:10:00',1.43),('16273','2013-11-17','14:15:00',1.46),('16273','2013-11-17','14:20:00',1.49),('16273','2013-11-17','14:25:00',1.41),('16273','2013-11-17','14:30:00',1.19),('16273','2013-11-17','14:45:00',1.34),('16273','2013-11-17','14:50:00',1.38),('16273','2013-11-17','14:55:00',1.12),('16273','2013-11-17','15:00:00',1.02),('16273','2013-11-17','15:05:00',1.1),('16273','2013-11-17','15:10:00',1.04),('16273','2013-11-16','12:55:00',1.02),('16273','2013-11-16','13:00:00',1.02),('16273','2013-11-16','13:05:00',1.14),('16273','2013-11-16','13:10:00',1.11),('16273','2013-11-16','13:15:00',1.02),('16273','2013-11-15','09:50:00',1.14),('16273','2013-11-15','10:10:00',1.05),('16273','2013-11-15','10:15:00',1.07),('16273','2013-11-15','10:35:00',1.02),('16273','2013-11-15','11:00:00',1.14),('16273','2013-11-15','11:05:00',1.34),('16273','2013-11-15','11:10:00',1.44),('16273','2013-11-15','11:15:00',1.22),('16273','2013-11-15','11:20:00',1.08),('16273','2013-11-15','11:30:00',1.39),('16273','2013-11-15','11:35:00',2.23),('16273','2013-11-15','11:40:00',1.46),('16273','2013-11-15','11:45:00',1.72),('16273','2013-11-15','11:50:00',1.98),('16273','2013-11-15','11:55:00',1.28),('16273','2013-11-15','12:00:00',1.03),('16273','2013-11-14','08:25:00',1.22),('16273','2013-11-14','08:45:00',1.63),('16273','2013-11-14','08:50:00',1.91),('16273','2013-11-14','08:55:00',1.97),('16273','2013-11-14','09:00:00',2.02),('16273','2013-11-14','09:05:00',2.12),('16273','2013-11-14','09:10:00',1.52),('16273','2013-11-14','09:15:00',2.16),('16273','2013-11-14','09:20:00',2.3),('16273','2013-11-14','09:25:00',2.29),('16273','2013-11-14','09:30:00',2.35),('16273','2013-11-14','09:35:00',2.4),('16273','2013-11-14','09:40:00',2.4),('16273','2013-11-14','09:45:00',2.34),('16273','2013-11-14','09:50:00',2.27),('16273','2013-11-14','09:55:00',2.24),('16273','2013-11-14','10:00:00',2.5),('16273','2013-11-14','10:05:00',2.52),('16273','2013-11-14','10:10:00',2.5),('16273','2013-11-14','10:15:00',2.53),('16273','2013-11-14','10:20:00',2.59),('16273','2013-11-14','10:25:00',2.32),('16273','2013-11-14','10:30:00',2.51),('16273','2013-11-14','10:35:00',2.58),('16273','2013-11-14','10:40:00',2.67),('16273','2013-11-14','10:45:00',2.71),('16273','2013-11-14','10:50:00',2.75),('16273','2013-11-14','10:55:00',2.73),('16273','2013-11-14','11:00:00',2.82),('16273','2013-11-14','11:05:00',2.9),('16273','2013-11-14','11:10:00',2.93),('16273','2013-11-14','11:15:00',2.87),('16273','2013-11-14','11:20:00',3.03),('16273','2013-11-14','11:25:00',2.79),('16273','2013-11-14','11:30:00',2.69),('16273','2013-11-14','11:35:00',2.53),('16273','2013-11-14','11:40:00',1.86),('16273','2013-11-14','11:45:00',2.29),('16273','2013-11-14','11:50:00',2.71),('16273','2013-11-14','11:55:00',3.22),('16273','2013-11-14','12:00:00',3.17),('16273','2013-11-14','12:05:00',1.26),('16273','2013-11-14','12:10:00',1.15),('16273','2013-11-14','12:15:00',1.17),('16273','2013-11-14','12:20:00',1.07),('16273','2013-11-14','12:25:00',1),('16273','2013-11-14','12:30:00',1.17),('16273','2013-11-14','12:35:00',1.41),('16273','2013-11-14','12:40:00',1.46),('16273','2013-11-14','12:45:00',1.24),('16273','2013-11-14','12:50:00',1.18),('16273','2013-11-14','12:55:00',1.09),('16273','2013-11-14','13:10:00',2.04),('16273','2013-11-14','13:15:00',2.06),('16273','2013-11-14','13:20:00',2.53),('16273','2013-11-14','13:25:00',2.11),('16273','2013-11-14','13:30:00',1.12),('16273','2013-11-14','13:35:00',1.47),('16273','2013-11-14','13:40:00',1.02),('16273','2013-11-14','13:45:00',1.81),('16273','2013-11-14','13:50:00',1.8),('16273','2013-11-14','13:55:00',1.1),('16273','2013-11-13','10:00:00',1.16),('16273','2013-11-13','10:05:00',1.31),('16273','2013-11-13','10:10:00',1.22),('16273','2013-11-13','10:50:00',1.07),('16273','2013-11-13','10:55:00',2.36),('16273','2013-11-13','11:00:00',3.57),('16273','2013-11-13','11:05:00',2.54),('16273','2013-11-13','11:10:00',1.23),('16273','2013-11-13','11:15:00',2.35),('16273','2013-11-13','11:20:00',2.64),('16273','2013-11-13','11:25:00',1.73),('16273','2013-11-13','11:35:00',1.37),('16273','2013-11-13','11:40:00',1.55),('16273','2013-11-13','11:45:00',1.38),('16273','2013-11-13','11:50:00',1.25),('16273','2013-11-13','11:55:00',1.36),('16273','2013-11-13','12:00:00',1.45),('16273','2013-11-13','12:05:00',1.31),('16273','2013-11-13','12:10:00',1.1),('16273','2013-11-13','12:15:00',1.09),('16273','2013-11-13','12:20:00',1.03),('16273','2013-11-13','13:10:00',1.06),('16273','2013-11-13','13:15:00',1.07),('16273','2013-11-13','13:20:00',1.14),('16273','2013-11-13','13:25:00',1.09),('16273','2013-11-13','14:00:00',1.09),('16273','2013-11-13','14:05:00',1.47),('16273','2013-11-13','14:10:00',1.54),('16273','2013-11-13','14:15:00',1.31),('16273','2013-11-13','14:20:00',1.39),('16273','2013-11-13','14:25:00',1.24),('16273','2013-11-13','14:30:00',1.26),('16273','2013-11-13','14:35:00',1.05),('16273','2013-11-12','11:25:00',1.13),('16273','2013-11-12','11:30:00',1.19),('16273','2013-11-12','11:40:00',1.9),('16273','2013-11-12','11:45:00',2.2),('16273','2013-11-12','11:50:00',2),('16273','2013-11-12','12:00:00',1.19),('16273','2013-11-12','12:05:00',2.91);
INSERT INTO `solarlogmod` VALUES ('16273','2013-11-12','12:35:00',1.5),('16273','2013-11-12','12:40:00',1.95),('16273','2013-11-12','12:45:00',1.99),('16273','2013-11-12','12:50:00',1.77),('16273','2013-11-12','12:55:00',1.47),('16273','2013-11-12','13:00:00',1.57),('16273','2013-11-12','13:05:00',1.33),('16273','2013-11-12','13:10:00',1.29),('16273','2013-11-12','13:15:00',1.43),('16273','2013-11-12','13:20:00',1.64),('16273','2013-11-12','13:25:00',1.68),('16273','2013-11-12','13:30:00',2.37),('16273','2013-11-12','13:35:00',2.41),('16273','2013-11-12','13:40:00',2.55),('16273','2013-11-12','13:45:00',2.61),('16273','2013-11-12','13:50:00',2.45),('16273','2013-11-12','13:55:00',2.22),('16273','2013-11-12','14:00:00',2.76),('16273','2013-11-12','14:05:00',2.31),('16273','2013-11-12','14:10:00',2.21),('16273','2013-11-12','14:15:00',1.77),('16273','2013-11-12','14:20:00',1.23),('16273','2013-11-12','14:25:00',2.13),('16273','2013-11-12','14:30:00',2.04),('16273','2013-11-12','14:40:00',1.33),('16273','2013-11-12','14:45:00',1.42),('16273','2013-11-12','14:50:00',1.35),('16273','2013-11-12','15:05:00',1.06),('16273','2013-11-12','15:15:00',1.04),('16273','2013-11-11','09:45:00',1.01),('16273','2013-11-11','11:05:00',1.13),('16273','2013-11-11','11:10:00',3.07),('16273','2013-11-11','11:15:00',1.75),('16273','2013-11-11','11:20:00',1.65),('16273','2013-11-11','11:35:00',1.37),('16273','2013-11-11','11:40:00',2.7),('16273','2013-11-11','11:45:00',3.66),('16273','2013-11-11','11:50:00',1.66),('16273','2013-11-11','12:00:00',1.14),('16273','2013-11-11','12:05:00',3.41),('16273','2013-11-11','12:10:00',3.17),('16273','2013-11-11','12:15:00',2.85),('16273','2013-11-11','12:20:00',2.94),('16273','2013-11-11','12:25:00',2.96),('16273','2013-11-11','12:30:00',2.84),('16273','2013-11-11','12:35:00',2.97),('16273','2013-11-11','12:40:00',2.93),('16273','2013-11-11','12:45:00',2.83),('16273','2013-11-11','12:50:00',1.85),('16273','2013-11-11','12:55:00',2.89),('16273','2013-11-11','13:00:00',2.51),('16273','2013-11-11','13:05:00',1.69),('16273','2013-11-11','13:10:00',2.58),('16273','2013-11-11','13:15:00',2.57),('16273','2013-11-11','13:20:00',2.46),('16273','2013-11-11','13:25:00',1.42),('16273','2013-11-11','13:40:00',1.04),('16273','2013-11-11','13:45:00',1.15),('16273','2013-11-11','14:00:00',1.49),('16273','2013-11-11','14:05:00',1.85),('16273','2013-11-11','14:15:00',1.66),('16273','2013-11-11','14:30:00',1.61),('16273','2013-11-11','14:45:00',1.21),('16273','2013-11-10','08:20:00',1.19),('16273','2013-11-10','08:25:00',1.34),('16273','2013-11-10','08:35:00',1.67),('16273','2013-11-10','08:40:00',1.96),('16273','2013-11-10','08:45:00',1.79),('16273','2013-11-10','08:50:00',1.83),('16273','2013-11-10','08:55:00',2.1),('16273','2013-11-10','09:00:00',1.45),('16273','2013-11-10','09:05:00',1.37),('16273','2013-11-10','09:10:00',1.7),('16273','2013-11-10','09:15:00',2.09),('16273','2013-11-10','09:20:00',2.21),('16273','2013-11-10','09:25:00',1.98),('16273','2013-11-10','09:30:00',2.21),('16273','2013-11-10','09:35:00',2.41),('16273','2013-11-10','09:40:00',2.4),('16273','2013-11-10','09:45:00',2.29),('16273','2013-11-10','09:50:00',2.47),('16273','2013-11-10','09:55:00',2.48),('16273','2013-11-10','10:00:00',2.75),('16273','2013-11-10','10:05:00',2.67),('16273','2013-11-10','10:10:00',1.87),('16273','2013-11-10','10:15:00',1.21),('16273','2013-11-10','10:20:00',1.34),('16273','2013-11-10','10:25:00',2.34),('16273','2013-11-10','10:30:00',2.42),('16273','2013-11-10','10:35:00',2.66),('16273','2013-11-10','10:40:00',2.54),('16273','2013-11-10','10:45:00',3.42),('16273','2013-11-10','10:50:00',3.2),('16273','2013-11-10','10:55:00',1.41),('16273','2013-11-10','11:10:00',1.22),('16273','2013-11-10','11:15:00',2.61),('16273','2013-11-10','11:20:00',1.87),('16273','2013-11-10','11:25:00',1.75),('16273','2013-11-10','11:30:00',2.75),('16273','2013-11-10','11:35:00',1.83),('16273','2013-11-10','11:50:00',1.07),('16273','2013-11-10','11:55:00',1.56),('16273','2013-11-10','12:00:00',3.55),('16273','2013-11-10','12:05:00',2.96),('16273','2013-11-10','12:10:00',3.03),('16273','2013-11-10','12:15:00',3.28),('16273','2013-11-10','12:20:00',2.66),('16273','2013-11-10','12:25:00',3.09),('16273','2013-11-10','12:30:00',3.03),('16273','2013-11-10','12:35:00',2.03),('16273','2013-11-10','12:40:00',2.15),('16273','2013-11-10','12:45:00',1.07),('16273','2013-11-10','12:50:00',1.37),('16273','2013-11-10','12:55:00',1.8),('16273','2013-11-10','13:00:00',1.81),('16273','2013-11-10','13:05:00',1.04),('16273','2013-11-10','13:35:00',1.44),('16273','2013-11-10','13:40:00',1.46),('16273','2013-11-09','09:30:00',1.49),('16273','2013-11-09','09:35:00',1.48),('16273','2013-11-09','09:40:00',2.31),('16273','2013-11-09','09:45:00',1.91),('16273','2013-11-09','09:50:00',2.96),('16273','2013-11-09','09:55:00',2.88),('16273','2013-11-09','10:00:00',1.88),('16273','2013-11-09','10:10:00',1.75),('16273','2013-11-09','10:15:00',1.31),('16273','2013-11-09','10:25:00',1.06),('16273','2013-11-09','10:30:00',1.13),('16273','2013-11-09','10:35:00',1.8),('16273','2013-11-09','10:45:00',1.01),('16273','2013-11-09','10:50:00',1.53),('16273','2013-11-09','10:55:00',2.74),('16273','2013-11-09','11:00:00',1.47),('16273','2013-11-09','11:15:00',1.36),('16273','2013-11-09','11:20:00',2.31),('16273','2013-11-09','11:25:00',3.34),('16273','2013-11-09','11:30:00',1.54),('16273','2013-11-09','11:35:00',2.5),('16273','2013-11-09','11:40:00',1.69),('16273','2013-11-09','11:45:00',3.18),('16273','2013-11-09','11:50:00',1.97),('16273','2013-11-09','11:55:00',3.27),('16273','2013-11-09','12:00:00',2.75),('16273','2013-11-09','12:05:00',1.56),('16273','2013-11-09','12:10:00',1.03),('16273','2013-11-09','12:30:00',1.05),('16273','2013-11-09','12:35:00',1.16),('16273','2013-11-09','12:40:00',2.04),('16273','2013-11-09','12:45:00',3.04),('16273','2013-11-09','12:50:00',1.89),('16273','2013-11-09','12:55:00',1.16),('16273','2013-11-09','13:00:00',1.82),('16273','2013-11-09','13:05:00',1.38),('16273','2013-11-09','13:10:00',2.14),('16273','2013-11-09','13:15:00',2.36),('16273','2013-11-09','13:20:00',2.35),('16273','2013-11-09','13:25:00',2.23),('16273','2013-11-09','13:30:00',2.39),('16273','2013-11-09','13:35:00',1.75),('16273','2013-11-09','13:40:00',1.55),('16273','2013-11-09','13:45:00',1.04),('16273','2013-11-09','13:50:00',1.83),('16273','2013-11-09','13:55:00',1.85),('16273','2013-11-09','14:15:00',1.27),('16273','2013-11-09','14:25:00',1.46),('16273','2013-11-09','14:30:00',1.52),('16273','2013-11-09','14:35:00',1.4),('16273','2013-11-09','14:40:00',1.24),('16273','2013-11-09','15:20:00',1.19),('16273','2013-11-08','09:25:00',2.18),('16273','2013-11-08','09:30:00',2.46),('16273','2013-11-08','09:35:00',2.5),('16273','2013-11-08','09:40:00',2.33),('16273','2013-11-08','09:45:00',1.67),('16273','2013-11-08','09:55:00',2.35),('16273','2013-11-08','10:00:00',2.69),('16273','2013-11-08','10:05:00',2.71),('16273','2013-11-08','10:10:00',2.98),('16273','2013-11-08','10:15:00',3.06),('16273','2013-11-08','10:20:00',3.08),('16273','2013-11-08','10:25:00',2.66),('16273','2013-11-08','10:30:00',2.87),('16273','2013-11-08','10:35:00',3.07),('16273','2013-11-08','10:40:00',3.29),('16273','2013-11-08','10:45:00',3.21),('16273','2013-11-08','10:50:00',2.95),('16273','2013-11-08','10:55:00',3.13),('16273','2013-11-08','11:00:00',3.42),('16273','2013-11-08','11:05:00',3.43),('16273','2013-11-08','11:10:00',1.63),('16273','2013-11-08','11:25:00',2.13),('16273','2013-11-08','11:30:00',2.21),('16273','2013-11-08','11:35:00',3.08),('16273','2013-11-08','11:40:00',2.94),('16273','2013-11-08','11:45:00',2.91),('16273','2013-11-08','11:50:00',2.31),('16273','2013-11-08','11:55:00',1.49),('16273','2013-11-08','12:00:00',2.87),('16273','2013-11-08','12:05:00',2.79),('16273','2013-11-08','12:10:00',2.42),('16273','2013-11-08','12:15:00',2.72),('16273','2013-11-08','12:20:00',2.56),('16273','2013-11-08','12:25:00',2.25),('16273','2013-11-08','12:30:00',2.82),('16273','2013-11-08','12:35:00',2.4),('16273','2013-11-08','12:40:00',2.08),('16273','2013-11-08','12:45:00',2.84),('16273','2013-11-08','12:50:00',2.68),('16273','2013-11-08','12:55:00',2.55),('16273','2013-11-08','13:00:00',2.52),('16273','2013-11-08','13:05:00',2.53),('16273','2013-11-08','13:10:00',2.51),('16273','2013-11-08','13:15:00',2.35),('16273','2013-11-08','13:20:00',2.24),('16273','2013-11-08','13:25:00',1.92),('16273','2013-11-08','13:30:00',2.29),('16273','2013-11-08','13:35:00',1.15),('16273','2013-11-08','13:45:00',1.97),('16273','2013-11-08','13:50:00',2.1),('16273','2013-11-08','13:55:00',2.02),('16273','2013-11-08','14:00:00',2.15),('16273','2013-11-08','14:05:00',2.03),('16273','2013-11-08','14:10:00',1.35),('16273','2013-11-08','14:15:00',1.9),('16273','2013-11-08','14:20:00',1.8),('16273','2013-11-08','14:25:00',1.29),('16273','2013-11-08','14:35:00',1.34),('16273','2013-11-08','14:45:00',1.34),('16273','2013-11-08','14:50:00',1.31),('16273','2013-11-08','14:55:00',1.06),('16273','2013-11-08','15:10:00',1.06),('16273','2013-11-08','15:15:00',1.03),('16273','2014-04-18','08:10:00',1.81),('16273','2014-04-18','08:15:00',1.05),('16273','2014-04-18','08:20:00',1.76),('16273','2014-04-18','08:25:00',1.15),('16273','2014-04-18','08:30:00',1.01),('16273','2014-04-18','08:35:00',1.28),('16273','2014-04-18','08:40:00',1.26),('16273','2014-04-18','08:45:00',2.17),('16273','2014-04-18','08:50:00',1.99),('16273','2014-04-18','08:55:00',1.24),('16273','2014-04-18','09:05:00',1.12),('16273','2014-04-18','09:10:00',1.94),('16273','2014-04-18','09:15:00',3.44),('16273','2014-04-18','09:20:00',2.5),('16273','2014-04-18','09:25:00',3.08),('16273','2014-04-18','09:30:00',2.31),('16273','2014-04-18','09:35:00',2.25),('16273','2014-04-18','09:40:00',1.42),('16273','2014-04-18','09:45:00',3.07),('16273','2014-04-18','09:50:00',1.92),('16273','2014-04-18','09:55:00',1.8),('16273','2014-04-18','10:00:00',1.55),('16273','2014-04-18','10:05:00',1.31),('16273','2014-04-18','10:10:00',1.36),('16273','2014-04-18','10:15:00',1.28),('16273','2014-04-18','10:20:00',1.48),('16273','2014-04-18','10:25:00',1.45),('16273','2014-04-18','10:30:00',1.24),('16273','2014-04-18','10:35:00',1.33),('16273','2014-04-18','10:40:00',2.47),('16273','2014-04-18','10:45:00',2.77),('16273','2014-04-18','10:50:00',2.77),('16273','2014-04-18','10:55:00',2.85),('16273','2014-04-18','11:00:00',2.38),('16273','2014-04-18','11:05:00',2.3),('16273','2014-04-18','11:10:00',1.95),('16273','2014-04-18','11:15:00',2.15),('16273','2014-04-18','11:20:00',2.08),('16273','2014-04-18','11:25:00',2.05),('16273','2014-04-18','11:30:00',2.86),('16273','2014-04-18','11:35:00',2.95),('16273','2014-04-18','11:40:00',2.2),('16273','2014-04-18','11:45:00',3.24),('16273','2014-04-18','11:50:00',3.19),('16273','2014-04-18','11:55:00',2.45),('16273','2014-04-18','12:00:00',2.28),('16273','2014-04-18','12:05:00',2.02),('16273','2014-04-18','12:10:00',3.18),('16273','2014-04-18','12:15:00',3.35),('16273','2014-04-18','12:20:00',4.31),('16273','2014-04-18','12:25:00',3.27),('16273','2014-04-18','12:30:00',3.64),('16273','2014-04-18','12:35:00',4.4),('16273','2014-04-18','12:40:00',3.74),('16273','2014-04-18','12:45:00',4.11),('16273','2014-04-18','12:50:00',2.04),('16273','2014-04-18','12:55:00',3.83),('16273','2014-04-18','13:00:00',4.21),('16273','2014-04-18','13:05:00',4.32),('16273','2014-04-18','13:10:00',3.72),('16273','2014-04-18','13:15:00',2.48),('16273','2014-04-18','13:20:00',2.13),('16273','2014-04-18','13:25:00',1.94),('16273','2014-04-18','13:30:00',1.45),('16273','2014-04-18','13:35:00',1.3),('16273','2014-04-18','13:40:00',1.53),('16273','2014-04-18','13:45:00',1.41),('16273','2014-04-18','13:50:00',1.26),('16273','2014-04-18','13:55:00',1.22),('16273','2014-04-18','14:00:00',1.39),('16273','2014-04-18','14:05:00',1.38),('16273','2014-04-18','14:10:00',1.37),('16273','2014-04-18','14:15:00',1.56),('16273','2014-04-18','14:20:00',1.68),('16273','2014-04-18','14:25:00',1.83),('16273','2014-04-18','14:30:00',2.13),('16273','2014-04-18','14:35:00',2.13),('16273','2014-04-18','14:40:00',1.85),('16273','2014-04-18','14:45:00',1.59),('16273','2014-04-18','14:50:00',1.97),('16273','2014-04-18','14:55:00',2.67),('16273','2014-04-18','15:00:00',3.99),('16273','2014-04-18','15:05:00',3.52),('16273','2014-04-18','15:10:00',2.96),('16273','2014-04-18','15:15:00',3.27),('16273','2014-04-18','15:20:00',3.54),('16273','2014-04-18','15:25:00',1.77),('16273','2014-04-18','15:30:00',2.28),('16273','2014-04-18','15:35:00',2.78),('16273','2014-04-18','15:40:00',2.15),('16273','2014-04-18','15:45:00',3.07),('16273','2014-04-18','15:50:00',3.11),('16273','2014-04-18','15:55:00',2.71),('16273','2014-04-18','16:00:00',3.03),('16273','2014-04-18','16:05:00',3),('16273','2014-04-18','16:10:00',3.06),('16273','2014-04-18','16:15:00',2.94),('16273','2014-04-18','16:20:00',2.47),('16273','2014-04-18','16:25:00',2.18),('16273','2014-04-18','16:30:00',1.67),('16273','2014-04-18','16:35:00',1.56),('16273','2014-04-18','16:40:00',2.06),('16273','2014-04-18','16:45:00',1.71),('16273','2014-04-18','16:55:00',1.74),('16273','2014-04-18','17:00:00',1.79),('16273','2014-04-18','17:05:00',1.67),('16273','2014-04-18','17:10:00',1.51),('16273','2014-04-18','17:15:00',1.47),('16273','2014-04-18','17:20:00',1.15),('16273','2014-04-18','17:25:00',1.04),('16273','2014-04-18','17:30:00',1.19),('16273','2013-11-07','07:55:00',1.15),('16273','2013-11-07','08:00:00',1.29),('16273','2013-11-07','08:05:00',1.17),('16273','2013-11-07','08:10:00',1.53),('16273','2013-11-07','08:15:00',1.63),('16273','2013-11-07','08:20:00',1.72),('16273','2013-11-07','08:25:00',1.8),('16273','2013-11-07','08:30:00',1.87),('16273','2013-11-07','08:35:00',1.92),('16273','2013-11-07','08:40:00',1.99),('16273','2013-11-07','08:45:00',2.06),('16273','2013-11-07','08:50:00',2.11),('16273','2013-11-07','08:55:00',2.16),('16273','2013-11-07','09:00:00',2.21),('16273','2013-11-07','09:05:00',2.26),('16273','2013-11-07','09:10:00',2.3),('16273','2013-11-07','09:15:00',2.35),('16273','2013-11-07','09:20:00',2.39),('16273','2013-11-07','09:25:00',2.43),('16273','2013-11-07','09:30:00',2.46),('16273','2013-11-07','09:35:00',2.48),('16273','2013-11-07','09:40:00',2.48),('16273','2013-11-07','09:45:00',2.52),('16273','2013-11-07','09:50:00',2.56),('16273','2013-11-07','09:55:00',2.6),('16273','2013-11-07','10:00:00',2.64),('16273','2013-11-07','10:05:00',2.67),('16273','2013-11-07','10:10:00',2.7),('16273','2013-11-07','10:15:00',2.73),('16273','2013-11-07','10:20:00',2.74),('16273','2013-11-07','10:25:00',2.76),('16273','2013-11-07','10:30:00',2.76),('16273','2013-11-07','10:35:00',2.76),('16273','2013-11-07','10:40:00',2.76),('16273','2013-11-07','10:45:00',2.77),('16273','2013-11-07','10:50:00',2.76),('16273','2013-11-07','10:55:00',2.7),('16273','2013-11-07','11:00:00',2.67),('16273','2013-11-07','11:05:00',2.72),('16273','2013-11-07','11:10:00',2.76),('16273','2013-11-07','11:15:00',2.75),('16273','2013-11-07','11:20:00',2.74),('16273','2013-11-07','11:25:00',2.71),('16273','2013-11-07','11:30:00',2.34),('16273','2013-11-07','11:35:00',2.3),('16273','2013-11-07','11:40:00',2.15),('16273','2013-11-07','11:45:00',2.56),('16273','2013-11-07','11:50:00',2.78),('16273','2013-11-07','11:55:00',2.76),('16273','2013-11-07','12:00:00',1.61),('16273','2013-11-07','12:05:00',1.33),('16273','2013-11-07','12:10:00',2.88),('16273','2013-11-07','12:15:00',2.85),('16273','2013-11-07','12:20:00',2.76),('16273','2013-11-07','12:25:00',2.41),('16273','2013-11-07','12:30:00',1.45),('16273','2013-11-07','12:35:00',1.69),('16273','2013-11-07','12:40:00',1.02),('16273','2013-11-07','12:45:00',2.94),('16273','2013-11-07','12:50:00',2.46),('16273','2013-11-07','12:55:00',2.44),('16273','2013-11-07','13:00:00',2.41),('16273','2013-11-07','13:05:00',2.33),('16273','2013-11-07','13:10:00',2.15),('16273','2013-11-07','13:15:00',2.31),('16273','2013-11-07','13:20:00',2.25),('16273','2013-11-07','13:25:00',2.19),('16273','2013-11-07','13:30:00',2.14),('16273','2013-11-07','13:35:00',2.09),('16273','2013-11-07','13:40:00',2.07),('16273','2013-11-07','13:45:00',1.98),('16273','2013-11-07','13:50:00',1.93),('16273','2013-11-07','13:55:00',1.73),('16273','2013-11-07','14:00:00',1.18),('16273','2013-11-07','14:05:00',1.47),('16273','2013-11-07','14:10:00',1.75),('16273','2013-11-07','14:15:00',1.67),('16273','2013-11-07','14:20:00',1.59),('16273','2013-11-07','14:25:00',1.53),('16273','2013-11-07','14:30:00',1.47),('16273','2013-11-07','14:35:00',1.4),('16273','2013-11-07','14:40:00',1.33),('16273','2013-11-07','14:45:00',1.27),('16273','2013-11-07','14:50:00',1.21),('16273','2013-11-07','14:55:00',1.14),('16273','2013-11-07','15:00:00',1.09),('16273','2013-11-07','15:05:00',1.03),('16273','2013-11-06','08:10:00',1.69),('16273','2013-11-06','08:15:00',1.86),('16273','2013-11-06','08:30:00',1.25),('16273','2013-11-06','08:35:00',2.06),('16273','2013-11-06','08:40:00',2.09),('16273','2013-11-06','08:45:00',2.15),('16273','2013-11-06','08:50:00',2.27),('16273','2013-11-06','08:55:00',1.8),('16273','2013-11-06','09:00:00',1.53),('16273','2013-11-06','09:05:00',1.82),('16273','2013-11-06','09:10:00',2.52),('16273','2013-11-06','09:15:00',2.42),('16273','2013-11-06','09:20:00',2.54),('16273','2013-11-06','09:25:00',2.56),('16273','2013-11-06','09:30:00',2.57),('16273','2013-11-06','09:35:00',2.61),('16273','2013-11-06','09:40:00',2.63),('16273','2013-11-06','09:45:00',2.66),('16273','2013-11-06','09:50:00',2.69),('16273','2013-11-06','09:55:00',2.71),('16273','2013-11-06','10:00:00',2.74),('16273','2013-11-06','10:05:00',2.77),('16273','2013-11-06','10:10:00',2.79),('16273','2013-11-06','10:15:00',2.83),('16273','2013-11-06','10:20:00',2.81),('16273','2013-11-06','10:25:00',2.86),('16273','2013-11-06','10:30:00',2.88),('16273','2013-11-06','10:35:00',2.89),('16273','2013-11-06','10:40:00',2.9),('16273','2013-11-06','10:45:00',2.92),('16273','2013-11-06','10:50:00',2.92),('16273','2013-11-06','10:55:00',2.92),('16273','2013-11-06','11:00:00',2.93),('16273','2013-11-06','11:05:00',2.93),('16273','2013-11-06','11:10:00',2.92),('16273','2013-11-06','11:15:00',2.92),('16273','2013-11-06','11:20:00',2.91),('16273','2013-11-06','11:25:00',2.89),('16273','2013-11-06','11:30:00',2.87),('16273','2013-11-06','11:35:00',2.89),('16273','2013-11-06','11:40:00',2.87),('16273','2013-11-06','11:45:00',2.87),('16273','2013-11-06','11:50:00',2.88),('16273','2013-11-06','11:55:00',2.86),('16273','2013-11-06','12:00:00',2.83),('16273','2013-11-06','12:05:00',2.8),('16273','2013-11-06','12:10:00',2.77),('16273','2013-11-06','12:15:00',2.76),('16273','2013-11-06','12:20:00',2.73),('16273','2013-11-06','12:25:00',2.71),('16273','2013-11-06','12:30:00',2.68),('16273','2013-11-06','12:35:00',2.65),('16273','2013-11-06','12:40:00',2.62),('16273','2013-11-06','12:45:00',2.58),('16273','2013-11-06','12:50:00',2.55),('16273','2013-11-06','12:55:00',2.51),('16273','2013-11-06','13:00:00',2.45),('16273','2013-11-06','13:05:00',2.39),('16273','2013-11-06','13:10:00',2.37),('16273','2013-11-06','13:15:00',2.36),('16273','2013-11-06','13:20:00',2.32),('16273','2013-11-06','13:25:00',2.26),('16273','2013-11-06','13:30:00',2.21),('16273','2013-11-06','13:35:00',2.16),('16273','2013-11-06','13:40:00',2.1),('16273','2013-11-06','13:45:00',2.04),('16273','2013-11-06','13:50:00',1.99),('16273','2013-11-06','13:55:00',1.93),('16273','2013-11-06','14:00:00',1.88),('16273','2013-11-06','14:05:00',1.81),('16273','2013-11-06','14:10:00',1.76),('16273','2013-11-06','14:15:00',1.7),('16273','2013-11-06','14:20:00',1.63),('16273','2013-11-06','14:25:00',1.56),('16273','2013-11-06','14:30:00',1.49),('16273','2013-11-06','14:35:00',1.42),('16273','2013-11-06','14:40:00',1.35),('16273','2013-11-06','14:45:00',1.28),('16273','2013-11-06','14:50:00',1.22),('16273','2013-11-06','14:55:00',1.15),('16273','2013-11-06','15:00:00',1.08),('16273','2013-11-06','15:05:00',1.02),('16273','2013-11-05','10:20:00',1.02),('16273','2013-11-05','10:25:00',1.06),('16273','2013-11-05','10:35:00',1.05),('16273','2013-11-05','10:40:00',1.31),('16273','2013-11-05','10:45:00',1.09),('16273','2013-11-05','11:30:00',1.06),('16273','2013-11-05','11:35:00',1.3),('16273','2013-11-05','11:40:00',1.3),('16273','2013-11-05','11:45:00',1.17),('16273','2013-11-05','11:50:00',1.1),('16273','2013-11-05','11:55:00',1.09),('16273','2013-11-05','12:00:00',1.66),('16273','2013-11-05','12:05:00',1.37),('16273','2013-11-05','12:10:00',1.47),('16273','2013-11-05','12:15:00',1.86),('16273','2013-11-05','12:20:00',2.27),('16273','2013-11-05','12:25:00',2.72),('16273','2013-11-05','12:30:00',1.07),('16273','2013-11-05','13:00:00',1.08),('16273','2013-11-05','13:05:00',1.18),('16273','2013-11-05','13:10:00',1.18),('16273','2013-11-05','13:15:00',1.31),('16273','2013-11-05','13:20:00',1.38),('16273','2013-11-05','13:25:00',1.28),('16273','2013-11-05','13:30:00',1.69),('16273','2013-11-05','13:35:00',1.93),('16273','2013-11-05','13:40:00',1.85),('16273','2013-11-05','13:45:00',2.2),('16273','2013-11-05','13:50:00',2.14),('16273','2013-11-05','13:55:00',2.3),('16273','2013-11-05','14:00:00',2.18),('16273','2013-11-05','14:05:00',2),('16273','2013-11-05','14:10:00',1.79),('16273','2013-11-05','14:15:00',1.88),('16273','2013-11-05','14:20:00',1.43),('16273','2013-11-05','14:25:00',1.2),('16273','2013-11-05','14:30:00',1.51),('16273','2013-11-05','14:35:00',1.37),('16273','2013-11-05','14:40:00',1.1),('16273','2013-11-05','14:45:00',1.27),('16273','2013-11-05','15:25:00',1.27),('16273','2013-11-05','15:30:00',1.3),('16273','2013-11-04','07:50:00',1),('16273','2013-11-04','07:55:00',1.15),('16273','2013-11-04','08:00:00',1.24),('16273','2013-11-04','08:05:00',1.32),('16273','2013-11-04','08:10:00',1.36),('16273','2013-11-04','08:15:00',1.61),('16273','2013-11-04','08:20:00',1.7),('16273','2013-11-04','08:25:00',1.74),('16273','2013-11-04','08:30:00',1.86),('16273','2013-11-04','08:35:00',1.57),('16273','2013-11-04','08:45:00',1.65),('16273','2013-11-04','08:50:00',2.16),('16273','2013-11-04','08:55:00',2.25),('16273','2013-11-04','09:00:00',2.33),('16273','2013-11-04','09:05:00',2.39),('16273','2013-11-04','09:10:00',2.46),('16273','2013-11-04','09:15:00',2.47),('16273','2013-11-04','09:20:00',2.51),('16273','2013-11-04','09:25:00',2.54),('16273','2013-11-04','09:30:00',2.56),('16273','2013-11-04','09:35:00',2.59),('16273','2013-11-04','09:40:00',2.64),('16273','2013-11-04','09:45:00',2.55),('16273','2013-11-04','09:50:00',1.22),('16273','2013-11-04','09:55:00',1.53),('16273','2013-11-04','10:05:00',1.64),('16273','2013-11-04','10:40:00',1.12),('16273','2013-11-04','10:45:00',2.25),('16273','2013-11-04','10:50:00',3.1),('16273','2013-11-04','10:55:00',3.21),('16273','2013-11-04','11:00:00',3.25),('16273','2013-11-04','11:05:00',1.2),('16273','2013-11-04','11:40:00',2),('16273','2013-11-04','11:45:00',2.38),('16273','2013-11-04','11:50:00',3.18),('16273','2013-11-04','11:55:00',2.66),('16273','2013-11-04','12:00:00',2.42),('16273','2013-11-04','12:05:00',1.52),('16273','2013-11-04','12:40:00',2.74),('16273','2013-11-04','12:45:00',1.18),('16273','2013-11-04','12:50:00',1.35),('16273','2013-11-04','13:05:00',1.37),('16273','2013-11-04','13:10:00',1.12),('16273','2013-11-04','13:15:00',1.62),('16273','2013-11-04','13:20:00',2.13),('16273','2013-11-04','13:25:00',1.41),('16273','2013-11-04','13:30:00',1.07),('16273','2013-11-04','13:35:00',1.25),('16273','2013-11-04','13:45:00',1.63),('16273','2013-11-04','14:20:00',1.97),('16273','2013-11-04','14:25:00',1.49),('16273','2013-11-04','15:10:00',1.04),('16273','2013-11-03','08:00:00',1.01),('16273','2013-11-03','08:05:00',1.22),('16273','2013-11-03','08:10:00',1.19),('16273','2013-11-03','08:15:00',1.07),('16273','2013-11-03','08:20:00',1.15),('16273','2013-11-03','08:25:00',1.47),('16273','2013-11-03','08:30:00',1.73),('16273','2013-11-03','08:35:00',1.8),('16273','2013-11-03','08:40:00',2.11),('16273','2013-11-03','08:45:00',2.03),('16273','2013-11-03','08:55:00',2.17),('16273','2013-11-03','09:05:00',1.44),('16273','2013-11-03','09:10:00',1.34),('16273','2013-11-03','09:15:00',1.17),('16273','2013-11-03','09:20:00',1.61),('16273','2013-11-03','09:25:00',1.72),('16273','2013-11-03','10:05:00',1.8),('16273','2013-11-03','10:10:00',2.78),('16273','2013-11-03','10:15:00',2.83),('16273','2013-11-03','10:20:00',2.94),('16273','2013-11-03','10:25:00',1.79),('16273','2013-11-03','10:30:00',1.45),('16273','2013-11-03','10:35:00',1.87),('16273','2013-11-03','10:40:00',1.74),('16273','2013-11-03','11:00:00',2.14),('16273','2013-11-03','11:05:00',1.97),('16273','2013-11-03','11:10:00',2.46),('16273','2013-11-03','11:15:00',1.69),('16273','2013-11-03','11:20:00',1.91),('16273','2013-11-03','11:25:00',3.18),('16273','2013-11-03','11:30:00',3.12),('16273','2013-11-03','11:35:00',3.04),('16273','2013-11-03','11:40:00',2.97),('16273','2013-11-03','11:45:00',3.31),('16273','2013-11-03','11:50:00',3.67),('16273','2013-11-03','11:55:00',3.49),('16273','2013-11-03','12:00:00',1.91),('16273','2013-11-03','12:10:00',1.22),('16273','2013-11-03','12:15:00',3.15),('16273','2013-11-03','12:20:00',2.87),('16273','2013-11-03','12:45:00',1.03),('16273','2013-11-03','12:50:00',1.19),('16273','2013-11-03','12:55:00',1.19),('16273','2013-11-03','13:00:00',1.06),('16273','2013-11-03','13:05:00',1.07),('16273','2013-11-03','13:10:00',1.21),('16273','2013-11-03','13:15:00',1.56),('16273','2013-11-03','13:20:00',3.02),('16273','2013-11-03','13:25:00',2.05),('16273','2013-11-03','13:30:00',1),('16273','2013-11-03','13:35:00',1.11),('16273','2013-11-03','13:40:00',2.2),('16273','2013-11-03','13:45:00',1.44),('16273','2013-11-03','13:50:00',1.76),('16273','2013-11-03','13:55:00',1.62),('16273','2013-11-03','14:00:00',1.8),('16273','2013-11-03','14:05:00',1.82),('16273','2013-11-03','14:10:00',1.76),('16273','2013-11-03','14:15:00',1.38),('16273','2013-11-03','14:20:00',1.9),('16273','2013-11-03','14:25:00',1.35),('16273','2013-11-03','14:30:00',1.43),('16273','2013-11-03','14:35:00',1.47),('16273','2013-11-03','14:40:00',1.1),('16273','2013-11-03','14:45:00',1.15),('16273','2013-11-03','14:50:00',1),('16273','2013-11-02','07:55:00',1.12),('16273','2013-11-02','08:00:00',1.1),('16273','2013-11-02','08:05:00',1.27),('16273','2013-11-02','08:10:00',1.46),('16273','2013-11-02','08:15:00',1.58),('16273','2013-11-02','08:20:00',1.66),('16273','2013-11-02','08:25:00',1.71),('16273','2013-11-02','08:30:00',1.77),('16273','2013-11-02','08:35:00',1.85),('16273','2013-11-02','08:40:00',1.92),('16273','2013-11-02','08:45:00',2.03),('16273','2013-11-02','08:50:00',2.3),('16273','2013-11-02','08:55:00',2.41),('16273','2013-11-02','09:05:00',1.54),('16273','2013-11-02','09:10:00',2.47),('16273','2013-11-02','09:15:00',2.51),('16273','2013-11-02','09:20:00',2.45),('16273','2013-11-02','09:25:00',2.41),('16273','2013-11-02','09:30:00',2.45),('16273','2013-11-02','09:35:00',2.66),('16273','2013-11-02','09:40:00',2.11),('16273','2013-11-02','09:45:00',1.48),('16273','2013-11-02','09:50:00',2.8),('16273','2013-11-02','09:55:00',2.1),('16273','2013-11-02','10:00:00',2.57),('16273','2013-11-02','10:05:00',1.41),('16273','2013-11-02','10:45:00',1.04),('16273','2013-11-02','10:50:00',1.15),('16273','2013-11-02','10:55:00',2.11),('16273','2013-11-02','11:00:00',1.54),('16273','2013-11-02','11:05:00',1.48),('16273','2013-11-02','11:10:00',1.52),('16273','2013-11-02','11:15:00',2.06),('16273','2013-11-02','11:20:00',2.63),('16273','2013-11-02','11:25:00',2.48),('16273','2013-11-02','11:30:00',2.99),('16273','2013-11-02','11:35:00',2.64),('16273','2013-11-02','11:40:00',2.9),('16273','2013-11-02','11:45:00',2.47),('16273','2013-11-02','11:50:00',1.97),('16273','2013-11-02','12:00:00',2.49),('16273','2013-11-02','12:05:00',2.74),('16273','2013-11-02','12:10:00',2.51),('16273','2013-11-02','12:15:00',3.5),('16273','2013-11-02','12:20:00',2.69),('16273','2013-11-02','12:25:00',2.27),('16273','2013-11-02','12:30:00',2.56),('16273','2013-11-02','12:35:00',2.5),('16273','2013-11-02','12:40:00',2.67),('16273','2013-11-02','12:45:00',2.95),('16273','2013-11-02','12:50:00',3.15),('16273','2013-11-02','12:55:00',3.09),('16273','2013-11-02','13:00:00',2.97),('16273','2013-11-02','13:05:00',2.91),('16273','2013-11-02','13:10:00',2.69),('16273','2013-11-02','13:15:00',1.19),('16273','2013-11-02','13:20:00',1.49),('16273','2013-11-02','13:25:00',2.63),('16273','2013-11-02','13:30:00',1.54),('16273','2013-11-02','13:35:00',2.3),('16273','2013-11-02','13:40:00',2.75),('16273','2013-11-02','13:45:00',2.51),('16273','2013-11-02','13:50:00',2.22),('16273','2013-11-02','13:55:00',2.03),('16273','2013-11-02','14:00:00',1.95),('16273','2013-11-02','14:05:00',1.86),('16273','2013-11-02','14:10:00',1.78),('16273','2013-11-02','14:15:00',1.72),('16273','2013-11-02','14:20:00',1.65),('16273','2013-11-02','14:25:00',1.58),('16273','2013-11-02','14:30:00',1.53),('16273','2013-11-02','14:35:00',1.48),('16273','2013-11-02','14:40:00',1.42),('16273','2013-11-02','14:45:00',1.4),('16273','2013-11-02','14:50:00',1.31),('16273','2013-11-02','14:55:00',1.23),('16273','2013-11-02','15:00:00',1.16),('16273','2013-11-01','08:10:00',1.11),('16273','2013-11-01','08:15:00',1.13),('16273','2013-11-01','08:20:00',1.36),('16273','2013-11-01','08:25:00',1.53),('16273','2013-11-01','08:30:00',1.7),('16273','2013-11-01','08:35:00',1.79),('16273','2013-11-01','08:40:00',1.58),('16273','2013-11-01','08:45:00',1.57),('16273','2013-11-01','08:50:00',1.76),('16273','2013-11-01','08:55:00',1.96),('16273','2013-11-01','09:00:00',1.9),('16273','2013-11-01','09:05:00',2.1),('16273','2013-11-01','09:10:00',2.22),('16273','2013-11-01','09:15:00',2.25),('16273','2013-11-01','09:20:00',2.35),('16273','2013-11-01','09:25:00',2.39),('16273','2013-11-01','09:30:00',2.45),('16273','2013-11-01','09:35:00',2.49),('16273','2013-11-01','09:40:00',2.55),('16273','2013-11-01','09:45:00',2.61),('16273','2013-11-01','09:50:00',2.66),('16273','2013-11-01','09:55:00',2.68),('16273','2013-11-01','10:00:00',2.71),('16273','2013-11-01','10:05:00',2.73),('16273','2013-11-01','10:10:00',2.77),('16273','2013-11-01','10:15:00',2.81),('16273','2013-11-01','10:20:00',2.81),('16273','2013-11-01','10:25:00',2.82),('16273','2013-11-01','10:30:00',2.85),('16273','2013-11-01','10:35:00',2.82),('16273','2013-11-01','10:40:00',2.82),('16273','2013-11-01','10:45:00',2.81),('16273','2013-11-01','10:50:00',2.76),('16273','2013-11-01','10:55:00',2.85),('16273','2013-11-01','11:00:00',2.85),('16273','2013-11-01','11:05:00',2.28),('16273','2013-11-01','11:10:00',2.18),('16273','2013-11-01','11:15:00',2.2),('16273','2013-11-01','11:20:00',2.5),('16273','2013-11-01','11:25:00',2.89),('16273','2013-11-01','11:30:00',2.89),('16273','2013-11-01','11:35:00',2.65),('16273','2013-11-01','11:40:00',2.72),('16273','2013-11-01','11:45:00',2.84),('16273','2013-11-01','11:50:00',2.94),('16273','2013-11-01','11:55:00',2.99),('16273','2013-11-01','12:00:00',2.95),('16273','2013-11-01','12:05:00',2.46),('16273','2013-11-01','12:10:00',1.87),('16273','2013-11-01','12:15:00',2.43),('16273','2013-11-01','12:20:00',1.72),('16273','2013-11-01','12:25:00',1.59),('16273','2013-11-01','12:40:00',1.1),('16273','2013-11-01','12:45:00',1.16),('16273','2013-11-01','12:50:00',2.06),('16273','2013-11-01','12:55:00',2.03),('16273','2013-11-01','13:00:00',1.89),('16273','2013-11-01','13:05:00',1.58),('16273','2013-11-01','13:10:00',1.25),('16273','2013-11-01','13:15:00',1.12),('16273','2013-10-31','08:10:00',1),('16273','2013-10-31','08:20:00',1.17),('16273','2013-10-31','08:25:00',1.41),('16273','2013-10-31','08:30:00',1.47),('16273','2013-10-31','08:35:00',1.75),('16273','2013-10-31','08:40:00',1.48),('16273','2013-10-31','08:45:00',1.33),('16273','2013-10-31','09:00:00',1.91),('16273','2013-10-31','09:05:00',2.14),('16273','2013-10-31','09:10:00',2.1),('16273','2013-10-31','09:15:00',2.03),('16273','2013-10-31','09:20:00',1.89),('16273','2013-10-31','09:25:00',2.01),('16273','2013-10-31','09:30:00',2.1),('16273','2013-10-31','09:35:00',2.04),('16273','2013-10-31','09:40:00',2.08),('16273','2013-10-31','09:45:00',2.08),('16273','2013-10-31','09:50:00',2.28),('16273','2013-10-31','09:55:00',2.23),('16273','2013-10-31','10:00:00',2.34),('16273','2013-10-31','10:05:00',2.38),('16273','2013-10-31','10:10:00',2.36),('16273','2013-10-31','10:15:00',2.22),('16273','2013-10-31','10:20:00',2.1),('16273','2013-10-31','10:25:00',2.52),('16273','2013-10-31','10:30:00',2.9),('16273','2013-10-31','10:35:00',2.88),('16273','2013-10-31','10:40:00',2.85),('16273','2013-10-31','10:45:00',2.68),('16273','2013-10-31','10:50:00',2.28),('16273','2013-10-31','10:55:00',2.24),('16273','2013-10-31','11:00:00',2.39),('16273','2013-10-31','11:05:00',2.61),('16273','2013-10-31','11:10:00',2.67),('16273','2013-10-31','11:15:00',2.6),('16273','2013-10-31','11:20:00',2.49),('16273','2013-10-31','11:25:00',2.47),('16273','2013-10-31','11:30:00',2.42),('16273','2013-10-31','11:35:00',2.36),('16273','2013-10-31','11:40:00',2.24),('16273','2013-10-31','11:45:00',2.66),('16273','2013-10-31','11:50:00',2.75),('16273','2013-10-31','11:55:00',2.88),('16273','2013-10-31','12:00:00',2.85),('16273','2013-10-31','12:05:00',2.85),('16273','2013-10-31','12:10:00',2.82),('16273','2013-10-31','12:15:00',2.76),('16273','2013-10-31','12:20:00',2.69),('16273','2013-10-31','12:25:00',2.64),('16273','2013-10-31','12:30:00',2.59),('16273','2013-10-31','12:35:00',2.53),('16273','2013-10-31','12:40:00',2.56),('16273','2013-10-31','12:45:00',2.56),('16273','2013-10-31','12:50:00',2.48),('16273','2013-10-31','12:55:00',2.46),('16273','2013-10-31','13:00:00',2.48),('16273','2013-10-31','13:05:00',2.42),('16273','2013-10-31','13:10:00',2.34),('16273','2013-10-31','13:15:00',2.3),('16273','2013-10-31','13:20:00',2.25),('16273','2013-10-31','13:25:00',2.22),('16273','2013-10-31','13:30:00',2.15),('16273','2013-10-31','13:35:00',2.09),('16273','2013-10-31','13:40:00',2.02),('16273','2013-10-31','13:45:00',1.98),('16273','2013-10-31','13:50:00',1.9),('16273','2013-10-31','13:55:00',1.74),('16273','2013-10-31','14:00:00',1.47),('16273','2013-10-31','14:05:00',1.68),('16273','2013-10-31','14:10:00',1.66),('16273','2013-10-31','14:15:00',1.6),('16273','2013-10-31','14:20:00',1.26),('16273','2013-10-31','14:25:00',1.14),('16273','2013-10-31','14:30:00',1.38),('16273','2013-10-31','14:35:00',1.32),('16273','2013-10-31','14:40:00',1.19),('16273','2013-10-31','14:45:00',1.17),('16273','2013-10-31','14:50:00',1.18),('16273','2013-10-31','14:55:00',1.07),('16273','2013-10-31','15:00:00',1.04),('16273','2013-10-30','08:00:00',1.06),('16273','2013-10-30','08:05:00',1.16),('16273','2013-10-30','08:10:00',1.23),('16273','2013-10-30','08:15:00',1.3),('16273','2013-10-30','08:20:00',1.39),('16273','2013-10-30','08:25:00',1.48),('16273','2013-10-30','08:30:00',1.57),('16273','2013-10-30','08:35:00',1.64),('16273','2013-10-30','08:40:00',1.76),('16273','2013-10-30','08:45:00',1.79),('16273','2013-10-30','08:50:00',1.77),('16273','2013-10-30','08:55:00',2),('16273','2013-10-30','09:00:00',2.1),('16273','2013-10-30','09:05:00',2.17),('16273','2013-10-30','09:10:00',2.18),('16273','2013-10-30','09:15:00',2.23),('16273','2013-10-30','09:20:00',2.23),('16273','2013-10-30','09:25:00',2.2),('16273','2013-10-30','09:30:00',2),('16273','2013-10-30','09:35:00',2.07),('16273','2013-10-30','09:40:00',2.15),('16273','2013-10-30','09:45:00',1.9),('16273','2013-10-30','09:50:00',2.17),('16273','2013-10-30','09:55:00',2.28),('16273','2013-10-30','10:00:00',2.32),('16273','2013-10-30','10:15:00',1.34),('16273','2013-10-30','10:20:00',1.69),('16273','2013-10-30','10:25:00',1.22),('16273','2013-10-30','10:30:00',2.18),('16273','2013-10-30','10:35:00',2.38),('16273','2013-10-30','10:40:00',2.45),('16273','2013-10-30','10:45:00',1.59),('16273','2013-10-30','10:50:00',1.57),('16273','2013-10-30','10:55:00',2.39),('16273','2013-10-30','11:00:00',2.8),('16273','2013-10-30','11:05:00',2.51),('16273','2013-10-30','11:10:00',2.66),('16273','2013-10-30','11:15:00',2.68),('16273','2013-10-30','11:20:00',1.27),('16273','2013-10-30','11:25:00',1.28),('16273','2013-10-30','11:30:00',1.32),('16273','2013-10-30','11:40:00',1.07),('16273','2013-10-30','11:45:00',1.87),('16273','2013-10-30','11:50:00',2.85),('16273','2013-10-30','11:55:00',2.81),('16273','2013-10-30','12:00:00',2.67),('16273','2013-10-30','12:05:00',2.03),('16273','2013-10-30','12:20:00',1.07),('16273','2013-10-30','12:25:00',1.07),('16273','2013-10-30','12:30:00',1.57),('16273','2013-10-30','12:35:00',1.1),('16273','2013-10-30','12:50:00',1.49),('16273','2013-10-30','13:00:00',1.43),('16273','2013-10-30','13:10:00',1.16),('16273','2013-10-30','14:30:00',1.32),('16273','2013-10-30','14:35:00',1.96),('16273','2013-10-30','14:40:00',1.83),('16273','2013-10-30','14:45:00',1.47),('16273','2013-10-30','14:50:00',1.5),('16273','2013-10-30','14:55:00',1.07),('16273','2013-10-30','15:00:00',1.15),('16273','2013-10-30','15:15:00',1.04),('16273','2013-10-29','08:15:00',1.08),('16273','2013-10-29','08:20:00',1.06),('16273','2013-10-29','08:25:00',1.19),('16273','2013-10-29','08:30:00',1.75),('16273','2013-10-29','08:35:00',1.16),('16273','2013-10-29','08:40:00',1.51),('16273','2013-10-29','08:45:00',1.87),('16273','2013-10-29','08:50:00',2.02),('16273','2013-10-29','08:55:00',2.08),('16273','2013-10-29','09:00:00',2.13),('16273','2013-10-29','09:05:00',2.2),('16273','2013-10-29','09:10:00',2.24),('16273','2013-10-29','09:15:00',2.28),('16273','2013-10-29','09:20:00',2.35),('16273','2013-10-29','09:25:00',2.38),('16273','2013-10-29','09:30:00',2.36),('16273','2013-10-29','09:35:00',2.4),('16273','2013-10-29','09:40:00',2.44),('16273','2013-10-29','09:45:00',2.27),('16273','2013-10-29','09:50:00',2.33),('16273','2013-10-29','09:55:00',2.59),('16273','2013-10-29','10:00:00',2.05),('16273','2013-10-29','10:05:00',1.39),('16273','2013-10-29','10:10:00',1.2),('16273','2013-10-29','10:15:00',1.12),('16273','2013-10-29','10:20:00',1.61),('16273','2013-10-29','10:25:00',2.6),('16273','2013-10-29','10:30:00',2.99),('16273','2013-10-29','10:35:00',2.98),('16273','2013-10-29','10:40:00',2.94),('16273','2013-10-29','10:45:00',3.03),('16273','2013-10-29','10:50:00',3.02),('16273','2013-10-29','10:55:00',3.05),('16273','2013-10-29','11:00:00',3.14),('16273','2013-10-29','11:05:00',3.12),('16273','2013-10-29','11:10:00',3.06),('16273','2013-10-29','11:15:00',3.05),('16273','2013-10-29','11:20:00',2.99),('16273','2013-10-29','11:25:00',2.89),('16273','2013-10-29','11:30:00',2.97),('16273','2013-10-29','11:35:00',3.04),('16273','2013-10-29','11:40:00',1.66),('16273','2013-10-29','11:45:00',1.46),('16273','2013-10-29','11:50:00',1.8),('16273','2013-10-29','11:55:00',2.22),('16273','2013-10-29','12:05:00',2.26),('16273','2013-10-29','12:10:00',2.88),('16273','2013-10-29','12:15:00',2.73),('16273','2013-10-29','12:20:00',2.72),('16273','2013-10-29','12:25:00',2.63),('16273','2013-10-29','12:30:00',2.65),('16273','2013-10-29','12:35:00',2.6),('16273','2013-10-29','12:40:00',2.53),('16273','2013-10-29','12:45:00',2.53),('16273','2013-10-29','12:50:00',2.61),('16273','2013-10-29','12:55:00',2.52),('16273','2013-10-29','13:00:00',2.02),('16273','2013-10-29','13:05:00',2.37),('16273','2013-10-29','13:10:00',2.28),('16273','2013-10-29','13:15:00',2.28),('16273','2013-10-29','13:20:00',2.29),('16273','2013-10-29','13:25:00',2.18),('16273','2013-10-29','13:30:00',2.21),('16273','2013-10-29','13:35:00',2.17),('16273','2013-10-29','13:40:00',2.11),('16273','2013-10-29','13:45:00',2.04),('16273','2013-10-29','13:50:00',1.94),('16273','2013-10-29','13:55:00',1.92),('16273','2013-10-29','14:00:00',1.85),('16273','2013-10-29','14:05:00',1.8),('16273','2013-10-29','14:10:00',1.77),('16273','2013-10-29','14:15:00',1.67),('16273','2013-10-29','14:20:00',1.6),('16273','2013-10-29','14:25:00',1.54),('16273','2013-10-29','14:30:00',1.48),('16273','2013-10-29','14:35:00',1.42),('16273','2013-10-29','14:40:00',1.34),('16273','2013-10-29','14:45:00',1.28),('16273','2013-10-29','14:50:00',1.23),('16273','2013-10-29','14:55:00',1.18),('16273','2013-10-29','15:00:00',1.1),('16273','2013-10-29','15:05:00',1.06),('16273','2014-04-17','07:55:00',1.47),('16273','2014-04-17','08:00:00',1.58),('16273','2014-04-17','08:05:00',1.62),('16273','2014-04-17','08:10:00',1.58),('16273','2014-04-17','08:15:00',1.58),('16273','2014-04-17','08:20:00',1.91),('16273','2014-04-17','08:25:00',1.99),('16273','2014-04-17','08:30:00',2.1),('16273','2014-04-17','08:35:00',2.18),('16273','2014-04-17','08:40:00',2.28),('16273','2014-04-17','08:45:00',2.38),('16273','2014-04-17','08:50:00',2.46),('16273','2014-04-17','08:55:00',2.53),('16273','2014-04-17','09:00:00',2.65),('16273','2014-04-17','09:05:00',2.73),('16273','2014-04-17','09:10:00',2.8),('16273','2014-04-17','09:15:00',2.87),('16273','2014-04-17','09:20:00',2.95),('16273','2014-04-17','09:25:00',3.01),('16273','2014-04-17','09:30:00',3.07),('16273','2014-04-17','09:35:00',3.13),('16273','2014-04-17','09:40:00',3.18),('16273','2014-04-17','09:45:00',3.21),('16273','2014-04-17','09:50:00',3.28),('16273','2014-04-17','09:55:00',3.36),('16273','2014-04-17','10:00:00',3.43),('16273','2014-04-17','10:05:00',3.44),('16273','2014-04-17','10:10:00',2.86),('16273','2014-04-17','10:15:00',3.31),('16273','2014-04-17','10:20:00',2.85),('16273','2014-04-17','10:25:00',2.05),('16273','2014-04-17','10:30:00',3.13),('16273','2014-04-17','10:35:00',3.67),('16273','2014-04-17','10:40:00',2.84),('16273','2014-04-17','10:45:00',3.11),('16273','2014-04-17','10:50:00',2.51),('16273','2014-04-17','10:55:00',2.06),('16273','2014-04-17','11:00:00',2.72),('16273','2014-04-17','11:05:00',3.16),('16273','2014-04-17','11:10:00',2.43),('16273','2014-04-17','11:15:00',3.2),('16273','2014-04-17','11:20:00',2.18),('16273','2014-04-17','11:25:00',2.9),('16273','2014-04-17','11:30:00',2.32),('16273','2014-04-17','11:35:00',2.5),('16273','2014-04-17','11:40:00',3.81),('16273','2014-04-17','11:45:00',2.36),('16273','2014-04-17','11:50:00',2.39),('16273','2014-04-17','11:55:00',1.85),('16273','2014-04-17','12:00:00',2.08),('16273','2014-04-17','12:05:00',2.27),('16273','2014-04-17','12:10:00',2.58),('16273','2014-04-17','12:15:00',2.92),('16273','2014-04-17','12:20:00',2.92),('16273','2014-04-17','12:25:00',3.33),('16273','2014-04-17','12:30:00',3.86),('16273','2014-04-17','12:35:00',3.86),('16273','2014-04-17','12:40:00',3.94),('16273','2014-04-17','12:45:00',4.03),('16273','2014-04-17','12:50:00',4.02),('16273','2014-04-17','12:55:00',3.98),('16273','2014-04-17','13:00:00',4.02),('16273','2014-04-17','13:05:00',4.02),('16273','2014-04-17','13:10:00',3.99),('16273','2014-04-17','13:15:00',3.95),('16273','2014-04-17','13:20:00',3.98),('16273','2014-04-17','13:25:00',4.09),('16273','2014-04-17','13:30:00',3.87),('16273','2014-04-17','13:35:00',3.15),('16273','2014-04-17','13:40:00',4.28),('16273','2014-04-17','13:45:00',4.28),('16273','2014-04-17','13:50:00',1.4),('16273','2014-04-17','14:00:00',4.27),('16273','2014-04-17','14:05:00',4.08),('16273','2014-04-17','14:10:00',3.39),('16273','2014-04-17','14:15:00',3.7),('16273','2014-04-17','14:20:00',1.24),('16273','2014-04-17','14:25:00',1.31),('16273','2014-04-17','14:30:00',1.81),('16273','2014-04-17','14:35:00',3.07),('16273','2014-04-17','14:40:00',1.8),('16273','2014-04-17','14:45:00',2.99),('16273','2014-04-17','14:50:00',2.69),('16273','2014-04-17','14:55:00',1.79),('16273','2014-04-17','15:00:00',1.31),('16273','2014-04-17','15:05:00',1.02),('16273','2014-04-17','15:10:00',1.32),('16273','2014-04-17','16:00:00',1.08),('16273','2014-04-17','16:25:00',1.05),('16273','2014-04-17','16:30:00',1.03),('16273','2014-04-17','16:40:00',1.1),('16273','2014-04-17','16:45:00',1.16),('16273','2014-04-17','16:50:00',1.21),('16273','2014-04-17','16:55:00',1.33),('16273','2014-04-17','17:00:00',1.1),('16273','2014-04-17','17:25:00',1.07),('16273','2014-04-17','17:30:00',1.38),('16273','2014-04-17','17:35:00',1.19),('16273','2014-04-17','17:40:00',1.02),('16273','2014-04-17','17:45:00',1.01),('16273','2013-10-28','08:20:00',1.03),('16273','2013-10-28','08:25:00',1.01),('16273','2013-10-28','08:35:00',1.09),('16273','2013-10-28','08:40:00',1.8),('16273','2013-10-28','08:45:00',1.98),('16273','2013-10-28','08:50:00',2.08),('16273','2013-10-28','08:55:00',2.1),('16273','2013-10-28','09:00:00',2.12),('16273','2013-10-28','09:05:00',2.35),('16273','2013-10-28','09:10:00',2.08),('16273','2013-10-28','09:15:00',2.22),('16273','2013-10-28','09:20:00',2.05),('16273','2013-10-28','09:25:00',2.32),('16273','2013-10-28','09:30:00',2.48),('16273','2013-10-28','09:35:00',1.28),('16273','2013-10-28','10:35:00',2.2),('16273','2013-10-28','10:40:00',2.97),('16273','2013-10-28','10:45:00',2.96),('16273','2013-10-28','10:50:00',2.93),('16273','2013-10-28','10:55:00',2.93),('16273','2013-10-28','11:00:00',2.93),('16273','2013-10-28','11:05:00',2.92),('16273','2013-10-28','11:10:00',2.93),('16273','2013-10-28','11:15:00',2.93),('16273','2013-10-28','11:20:00',2.9),('16273','2013-10-28','11:25:00',2.88),('16273','2013-10-28','11:30:00',2.87),('16273','2013-10-28','11:35:00',2.89),('16273','2013-10-28','11:40:00',2.88),('16273','2013-10-28','11:45:00',1.95),('16273','2013-10-28','11:50:00',2.91),('16273','2013-10-28','11:55:00',2.88),('16273','2013-10-28','12:00:00',2.88),('16273','2013-10-28','12:05:00',2.85),('16273','2013-10-28','12:10:00',2.81),('16273','2013-10-28','12:15:00',2.32),('16273','2013-10-28','12:20:00',2.96),('16273','2013-10-28','12:25:00',2.26),('16273','2013-10-28','12:30:00',2.68),('16273','2013-10-28','12:35:00',2.71),('16273','2013-10-28','12:40:00',2.67),('16273','2013-10-28','12:45:00',2.64),('16273','2013-10-28','12:50:00',2.58),('16273','2013-10-28','12:55:00',2.55),('16273','2013-10-28','13:00:00',2.53),('16273','2013-10-28','13:05:00',2.51),('16273','2013-10-28','13:10:00',2.45),('16273','2013-10-28','13:15:00',2.41),('16273','2013-10-28','13:20:00',2.37),('16273','2013-10-28','13:25:00',2.37),('16273','2013-10-28','13:30:00',2.06),('16273','2013-10-28','13:35:00',2),('16273','2013-10-28','13:40:00',2.31),('16273','2013-10-28','13:45:00',2.23),('16273','2013-10-28','13:50:00',1.79),('16273','2013-10-28','13:55:00',2.13),('16273','2013-10-28','14:00:00',1.83),('16273','2013-10-28','14:05:00',1.9),('16273','2013-10-28','14:10:00',1.66),('16273','2013-10-28','14:15:00',1.61),('16273','2013-10-28','14:20:00',1.31),('16273','2013-10-28','14:25:00',1.14),('16273','2013-10-28','14:40:00',1.44),('16273','2013-10-28','14:45:00',1.48),('16273','2013-10-28','14:50:00',1.4),('16273','2013-10-28','14:55:00',1.34),('16273','2013-10-28','15:00:00',1.19),('16273','2013-10-28','15:05:00',1.14),('16273','2013-10-28','15:10:00',1.14),('16273','2013-10-28','15:15:00',1.1),('16273','2013-10-28','15:20:00',1.14),('16273','2013-10-27','09:50:00',1.04),('16273','2013-10-27','09:55:00',1.13),('16273','2013-10-27','10:05:00',1.01),('16273','2013-10-27','10:10:00',1.05),('16273','2013-10-27','10:20:00',1.03),('16273','2013-10-27','10:25:00',1.19),('16273','2013-10-27','10:30:00',1.66),('16273','2013-10-27','10:35:00',1.47),('16273','2013-10-27','10:40:00',1.32),('16273','2013-10-27','10:45:00',1.27),('16273','2013-10-27','10:50:00',1.13),('16273','2013-10-27','10:55:00',1.11),('16273','2013-10-27','11:00:00',1.41),('16273','2013-10-27','11:05:00',1.31),('16273','2013-10-27','11:10:00',1.35),('16273','2013-10-27','11:15:00',1.51),('16273','2013-10-27','11:20:00',1.32),('16273','2013-10-27','11:25:00',1.58),('16273','2013-10-27','11:30:00',1.21),('16273','2013-10-27','11:35:00',1.01),('16273','2013-10-27','11:40:00',1.01),('16273','2013-10-27','11:45:00',1.27),('16273','2013-10-27','11:50:00',2.64),('16273','2013-10-27','11:55:00',3.02),('16273','2013-10-27','12:00:00',1.52),('16273','2013-10-27','12:05:00',1.34),('16273','2013-10-27','12:10:00',1.57),('16273','2013-10-27','12:15:00',1.69),('16273','2013-10-27','12:40:00',1.05),('16273','2013-10-27','12:45:00',2.82),('16273','2013-10-27','12:50:00',1.72),('16273','2013-10-27','12:55:00',1.31),('16273','2013-10-27','13:00:00',1.03),('16273','2013-10-27','13:05:00',2.15),('16273','2013-10-27','13:30:00',1.64),('16273','2013-10-27','13:35:00',2.36),('16273','2013-10-27','13:40:00',1.77),('16273','2013-10-27','13:45:00',1.16),('16273','2013-10-27','13:50:00',1.84),('16273','2013-10-27','13:55:00',2.44),('16273','2013-10-27','14:00:00',2.4),('16273','2013-10-27','14:05:00',2.3),('16273','2013-10-27','14:10:00',1.78),('16273','2013-10-27','14:15:00',1.76),('16273','2013-10-27','14:20:00',1.8),('16273','2013-10-27','14:25:00',1.4),('16273','2013-10-27','14:40:00',1.49),('16273','2013-10-26','08:45:00',1.04),('16273','2013-10-26','08:50:00',1.11),('16273','2013-10-26','08:55:00',1.19),('16273','2013-10-26','09:00:00',1.38),('16273','2013-10-26','09:05:00',1.47),('16273','2013-10-26','09:10:00',1.55),('16273','2013-10-26','09:15:00',1.64),('16273','2013-10-26','09:20:00',1.73),('16273','2013-10-26','09:25:00',1.8),('16273','2013-10-26','09:30:00',1.86),('16273','2013-10-26','09:35:00',1.93),('16273','2013-10-26','09:40:00',2),('16273','2013-10-26','09:45:00',2.04),('16273','2013-10-26','09:50:00',2.09),('16273','2013-10-26','09:55:00',2.13),('16273','2013-10-26','10:00:00',2.17),('16273','2013-10-26','10:05:00',2.21),('16273','2013-10-26','10:10:00',2.24),('16273','2013-10-26','10:15:00',2.28),('16273','2013-10-26','10:20:00',2.33),('16273','2013-10-26','10:25:00',2.4),('16273','2013-10-26','10:30:00',2.46),('16273','2013-10-26','10:35:00',2.5),('16273','2013-10-26','10:40:00',2.55),('16273','2013-10-26','10:45:00',2.58),('16273','2013-10-26','10:50:00',2.62),('16273','2013-10-26','10:55:00',2.6),('16273','2013-10-26','11:00:00',2.64),('16273','2013-10-26','11:05:00',2.67),('16273','2013-10-26','11:10:00',2.72),('16273','2013-10-26','11:15:00',2.73),('16273','2013-10-26','11:20:00',2.74),('16273','2013-10-26','11:25:00',2.74),('16273','2013-10-26','11:30:00',2.74),('16273','2013-10-26','11:35:00',2.8),('16273','2013-10-26','11:40:00',2.78),('16273','2013-10-26','11:45:00',2.78),('16273','2013-10-26','11:50:00',2.75),('16273','2013-10-26','11:55:00',2.79),('16273','2013-10-26','12:00:00',2.66),('16273','2013-10-26','12:05:00',2.82),('16273','2013-10-26','12:10:00',2.77),('16273','2013-10-26','12:15:00',2.82),('16273','2013-10-26','12:20:00',2.8),('16273','2013-10-26','12:25:00',2.75),('16273','2013-10-26','12:30:00',2.78),('16273','2013-10-26','12:35:00',2.81),('16273','2013-10-26','12:40:00',2.82),('16273','2013-10-26','12:45:00',2.77),('16273','2013-10-26','12:50:00',2.7),('16273','2013-10-26','12:55:00',2.71),('16273','2013-10-26','13:00:00',2.74),('16273','2013-10-26','13:05:00',2.74),('16273','2013-10-26','13:10:00',2.65),('16273','2013-10-26','13:15:00',2.61),('16273','2013-10-26','13:20:00',2.62),('16273','2013-10-26','13:25:00',2.61),('16273','2013-10-26','13:30:00',2.6),('16273','2013-10-26','13:35:00',2.5),('16273','2013-10-26','13:40:00',2.52),('16273','2013-10-26','13:45:00',2.53),('16273','2013-10-26','13:50:00',2.46),('16273','2013-10-26','13:55:00',2.44),('16273','2013-10-26','14:00:00',2.29),('16273','2013-10-26','14:05:00',2.38),('16273','2013-10-26','14:10:00',2.21),('16273','2013-10-26','14:15:00',2.26),('16273','2013-10-26','14:20:00',2.05),('16273','2013-10-26','14:25:00',1.96),('16273','2013-10-26','14:30:00',2.28),('16273','2013-10-26','14:35:00',2.39),('16273','2013-10-26','14:40:00',1.84),('16273','2013-10-26','14:45:00',1.15),('16273','2013-10-26','14:50:00',1.83),('16273','2013-10-26','14:55:00',1.5),('16273','2013-10-26','15:00:00',1.92),('16273','2013-10-26','15:05:00',1.85),('16273','2013-10-26','15:10:00',1.8),('16273','2013-10-26','15:15:00',1.5),('16273','2013-10-26','15:20:00',1.63),('16273','2013-10-26','15:25:00',1.59),('16273','2013-10-26','15:30:00',1.53),('16273','2013-10-26','15:35:00',1.43),('16273','2013-10-26','15:40:00',1.39),('16273','2013-10-26','15:45:00',1.29),('16273','2013-10-26','15:50:00',1.25),('16273','2013-10-26','15:55:00',1.18),('16273','2013-10-26','16:00:00',1.12),('16273','2013-10-26','16:05:00',1.09),('16273','2013-10-26','16:10:00',1.02),('16273','2013-10-25','08:45:00',1.05),('16273','2013-10-25','08:50:00',1.12),('16273','2013-10-25','08:55:00',1.21),('16273','2013-10-25','09:00:00',1.41),('16273','2013-10-25','09:05:00',1.51),('16273','2013-10-25','09:10:00',1.59),('16273','2013-10-25','09:15:00',1.67),('16273','2013-10-25','09:20:00',1.75),('16273','2013-10-25','09:25:00',1.82),('16273','2013-10-25','09:30:00',1.88),('16273','2013-10-25','09:35:00',1.95),('16273','2013-10-25','09:40:00',2),('16273','2013-10-25','09:45:00',2.06),('16273','2013-10-25','09:50:00',2.12),('16273','2013-10-25','09:55:00',2.18),('16273','2013-10-25','10:00:00',2.23),('16273','2013-10-25','10:05:00',2.29),('16273','2013-10-25','10:10:00',2.34),('16273','2013-10-25','10:15:00',2.39),('16273','2013-10-25','10:20:00',2.45),('16273','2013-10-25','10:25:00',2.49),('16273','2013-10-25','10:30:00',2.52),('16273','2013-10-25','10:35:00',2.58),('16273','2013-10-25','10:40:00',2.6),('16273','2013-10-25','10:45:00',2.65),('16273','2013-10-25','10:50:00',2.7),('16273','2013-10-25','10:55:00',2.69),('16273','2013-10-25','11:00:00',2.76),('16273','2013-10-25','11:05:00',2.79),('16273','2013-10-25','11:10:00',2.81),('16273','2013-10-25','11:15:00',2.82),('16273','2013-10-25','11:20:00',2.82),('16273','2013-10-25','11:25:00',2.8),('16273','2013-10-25','11:30:00',2.88),('16273','2013-10-25','11:35:00',2.91),('16273','2013-10-25','11:40:00',2.91),('16273','2013-10-25','11:45:00',2.92),('16273','2013-10-25','11:50:00',2.92),('16273','2013-10-25','11:55:00',2.93),('16273','2013-10-25','12:00:00',2.94),('16273','2013-10-25','12:05:00',2.95),('16273','2013-10-25','12:10:00',2.95),('16273','2013-10-25','12:15:00',2.96),('16273','2013-10-25','12:20:00',2.95),('16273','2013-10-25','12:25:00',2.94),('16273','2013-10-25','12:30:00',2.92),('16273','2013-10-25','12:35:00',2.93),('16273','2013-10-25','12:40:00',2.91),('16273','2013-10-25','12:45:00',2.89),('16273','2013-10-25','12:50:00',2.88),('16273','2013-10-25','12:55:00',2.87),('16273','2013-10-25','13:00:00',2.84),('16273','2013-10-25','13:05:00',2.84),('16273','2013-10-25','13:10:00',2.79),('16273','2013-10-25','13:15:00',2.74),('16273','2013-10-25','13:20:00',2.75),('16273','2013-10-25','13:25:00',2.74),('16273','2013-10-25','13:30:00',2.7),('16273','2013-10-25','13:35:00',2.68),('16273','2013-10-25','13:40:00',2.64),('16273','2013-10-25','13:45:00',2.58),('16273','2013-10-25','13:50:00',2.53),('16273','2013-10-25','13:55:00',2.53),('16273','2013-10-25','14:00:00',2.49),('16273','2013-10-25','14:05:00',2.47),('16273','2013-10-25','14:10:00',2.43),('16273','2013-10-25','14:15:00',2.38),('16273','2013-10-25','14:20:00',2.35),('16273','2013-10-25','14:25:00',2.27),('16273','2013-10-25','14:30:00',2.22),('16273','2013-10-25','14:35:00',2.17),('16273','2013-10-25','14:40:00',2.15),('16273','2013-10-25','14:45:00',2.1),('16273','2013-10-25','14:50:00',2.03),('16273','2013-10-25','14:55:00',1.94),('16273','2013-10-25','15:00:00',1.9),('16273','2013-10-25','15:05:00',1.87),('16273','2013-10-25','15:10:00',1.83),('16273','2013-10-25','15:15:00',1.77),('16273','2013-10-25','15:20:00',1.71),('16273','2013-10-25','15:25:00',1.63),('16273','2013-10-25','15:30:00',1.56),('16273','2013-10-25','15:35:00',1.51),('16273','2013-10-25','15:40:00',1.46),('16273','2013-10-25','15:45:00',1.38),('16273','2013-10-25','15:50:00',1.33),('16273','2013-10-25','15:55:00',1.27),('16273','2013-10-25','16:00:00',1.21),('16273','2013-10-25','16:05:00',1.16),('16273','2013-10-25','16:10:00',1.11),('16273','2013-10-25','16:15:00',1.04),('16273','2013-10-24','08:55:00',1.42),('16273','2013-10-24','09:00:00',1.44),('16273','2013-10-24','09:05:00',1.65),('16273','2013-10-24','09:10:00',1.55),('16273','2013-10-24','09:25:00',1.03),('16273','2013-10-24','09:35:00',1),('16273','2013-10-24','09:40:00',1.03),('16273','2013-10-24','09:45:00',1.09),('16273','2013-10-24','09:50:00',1.01),('16273','2013-10-24','10:10:00',1.13),('16273','2013-10-24','10:25:00',1.19),('16273','2013-10-24','10:30:00',1.36),('16273','2013-10-24','10:35:00',1.3),('16273','2013-10-24','10:40:00',1.58),('16273','2013-10-24','10:45:00',2.11),('16273','2013-10-24','10:50:00',2.53),('16273','2013-10-24','10:55:00',1.74),('16273','2013-10-24','11:00:00',1.62),('16273','2013-10-24','11:05:00',1.57),('16273','2013-10-24','11:10:00',1.19),('16273','2013-10-24','11:15:00',1.11),('16273','2013-10-24','11:20:00',1.03),('16273','2013-10-24','11:25:00',1.07),('16273','2013-10-24','11:30:00',1.57),('16273','2013-10-24','11:35:00',2.57),('16273','2013-10-24','11:40:00',2.14),('16273','2013-10-24','11:45:00',3.1),('16273','2013-10-24','11:50:00',1.55),('16273','2013-10-24','11:55:00',1.29),('16273','2013-10-24','12:00:00',1.29),('16273','2013-10-24','12:05:00',1.3),('16273','2013-10-24','12:10:00',1.4),('16273','2013-10-24','12:15:00',1.54),('16273','2013-10-24','12:20:00',1.62),('16273','2013-10-24','12:25:00',1.65),('16273','2013-10-24','12:30:00',1.59),('16273','2013-10-24','12:35:00',1.56),('16273','2013-10-24','12:40:00',1.9),('16273','2013-10-24','12:45:00',1.96),('16273','2013-10-24','12:50:00',1.73),('16273','2013-10-24','12:55:00',1.64),('16273','2013-10-24','13:00:00',1.43),('16273','2013-10-24','13:05:00',1.4),('16273','2013-10-24','13:10:00',1.28),('16273','2013-10-24','13:15:00',1.22),('16273','2013-10-24','13:20:00',1.18),('16273','2013-10-24','13:25:00',1.19),('16273','2013-10-24','13:30:00',1.21),('16273','2013-10-24','13:35:00',1.26),('16273','2013-10-24','13:40:00',1.9),('16273','2013-10-24','13:45:00',1.86),('16273','2013-10-24','13:50:00',1.21),('16273','2013-10-24','13:55:00',1.21),('16273','2013-10-24','14:00:00',1.3),('16273','2013-10-24','14:05:00',1.56),('16273','2013-10-24','14:10:00',1.34),('16273','2013-10-24','14:15:00',1.3),('16273','2013-10-24','14:20:00',1.28),('16273','2013-10-24','14:25:00',1.67),('16273','2013-10-24','14:30:00',1.79),('16273','2013-10-24','14:35:00',1.3),('16273','2013-10-24','14:50:00',1.13),('16273','2013-10-24','14:55:00',1.03),('16273','2013-10-24','15:00:00',1.27),('16273','2013-10-24','15:05:00',1.13),('16273','2013-10-24','15:10:00',1.06),('16273','2013-10-24','15:20:00',1.05),('16273','2013-10-24','15:25:00',1.64),('16273','2013-10-24','15:30:00',2.11),('16273','2013-10-24','15:35:00',1.97),('16273','2013-10-24','15:40:00',1.8),('16273','2013-10-24','15:45:00',1.14),('16273','2013-10-23','09:55:00',1.07),('16273','2013-10-23','10:00:00',1.1),('16273','2013-10-23','10:05:00',1.28),('16273','2013-10-23','10:10:00',1.25),('16273','2013-10-23','10:25:00',1.26),('16273','2013-10-23','10:30:00',1.9),('16273','2013-10-23','10:35:00',2.21),('16273','2013-10-23','10:40:00',1.63),('16273','2013-10-23','10:45:00',1.44),('16273','2013-10-23','10:50:00',2.28),('16273','2013-10-23','10:55:00',2.78),('16273','2013-10-23','11:00:00',2.74),('16273','2013-10-23','11:05:00',2.82),('16273','2013-10-23','11:10:00',2.83),('16273','2013-10-23','11:15:00',2.77),('16273','2013-10-23','11:20:00',2.71),('16273','2013-10-23','11:25:00',2.69),('16273','2013-10-23','11:30:00',2.71),('16273','2013-10-23','11:35:00',2.55),('16273','2013-10-23','11:40:00',2.75),('16273','2013-10-23','11:45:00',2.83),('16273','2013-10-23','11:50:00',2.31),('16273','2013-10-23','11:55:00',2.12),('16273','2013-10-23','12:00:00',1.69),('16273','2013-10-23','12:05:00',2.02),('16273','2013-10-23','12:10:00',2.59),('16273','2013-10-23','12:15:00',1.84),('16273','2013-10-23','12:20:00',2.59),('16273','2013-10-23','12:25:00',2.93),('16273','2013-10-23','12:30:00',2.83),('16273','2013-10-23','12:35:00',2.66),('16273','2013-10-23','12:40:00',2.64),('16273','2013-10-23','12:45:00',2.67),('16273','2013-10-23','12:50:00',2.74),('16273','2013-10-23','12:55:00',2.73),('16273','2013-10-23','13:00:00',2.72),('16273','2013-10-23','13:05:00',2.66),('16273','2013-10-23','13:10:00',2.68),('16273','2013-10-23','13:15:00',2.6),('16273','2013-10-23','13:20:00',2.56),('16273','2013-10-23','13:25:00',2.62),('16273','2013-10-23','13:30:00',2.6),('16273','2013-10-23','13:35:00',2.6),('16273','2013-10-23','13:40:00',2.56),('16273','2013-10-23','13:45:00',2.62),('16273','2013-10-23','13:50:00',2.58),('16273','2013-10-23','13:55:00',2.48),('16273','2013-10-23','14:00:00',2.38),('16273','2013-10-23','14:05:00',2.2),('16273','2013-10-23','14:10:00',2.35),('16273','2013-10-23','14:15:00',2.23),('16273','2013-10-23','14:20:00',2.02),('16273','2013-10-23','14:25:00',2.01),('16273','2013-10-23','14:30:00',1.96),('16273','2013-10-23','14:35:00',1.77),('16273','2013-10-23','14:40:00',1.9),('16273','2013-10-23','14:45:00',1.94),('16273','2013-10-23','14:50:00',1.73),('16273','2013-10-23','14:55:00',1.82),('16273','2013-10-23','15:00:00',1.81),('16273','2013-10-23','15:05:00',1.74),('16273','2013-10-23','15:10:00',1.51),('16273','2013-10-23','15:15:00',1.39),('16273','2013-10-23','15:20:00',1.62),('16273','2013-10-23','15:25:00',1.5),('16273','2013-10-23','15:30:00',1.35),('16273','2013-10-23','15:35:00',1.38),('16273','2013-10-23','15:40:00',1.46),('16273','2013-10-23','15:45:00',1.34),('16273','2013-10-23','15:50:00',1.1),('16273','2013-10-23','15:55:00',1.09),('16273','2013-10-22','08:45:00',1.07),('16273','2013-10-22','08:50:00',1.03),('16273','2013-10-22','08:55:00',1.3),('16273','2013-10-22','09:00:00',1.4),('16273','2013-10-22','09:05:00',1.47),('16273','2013-10-22','09:10:00',1.56),('16273','2013-10-22','09:15:00',1.65),('16273','2013-10-22','09:20:00',1.72),('16273','2013-10-22','09:25:00',1.8),('16273','2013-10-22','09:30:00',1.87),('16273','2013-10-22','09:35:00',1.91),('16273','2013-10-22','09:40:00',1.98),('16273','2013-10-22','09:45:00',1.99),('16273','2013-10-22','09:50:00',2.04),('16273','2013-10-22','09:55:00',2.16),('16273','2013-10-22','10:00:00',2.21),('16273','2013-10-22','10:05:00',2.26),('16273','2013-10-22','10:10:00',2.31),('16273','2013-10-22','10:15:00',2.35),('16273','2013-10-22','10:20:00',2.4),('16273','2013-10-22','10:25:00',2.42),('16273','2013-10-22','10:30:00',2.45),('16273','2013-10-22','10:35:00',2.48),('16273','2013-10-22','10:40:00',2.51),('16273','2013-10-22','10:45:00',2.51),('16273','2013-10-22','10:50:00',2.53),('16273','2013-10-22','10:55:00',2.57),('16273','2013-10-22','11:00:00',2.54),('16273','2013-10-22','11:05:00',2.55),('16273','2013-10-22','11:10:00',2.62),('16273','2013-10-22','11:15:00',2.64),('16273','2013-10-22','11:20:00',2.64),('16273','2013-10-22','11:25:00',2.73),('16273','2013-10-22','11:30:00',2.74),('16273','2013-10-22','11:35:00',2.74),('16273','2013-10-22','11:40:00',2.76),('16273','2013-10-22','11:45:00',2.72),('16273','2013-10-22','11:50:00',2.79),('16273','2013-10-22','11:55:00',2.8),('16273','2013-10-22','12:00:00',2.8),('16273','2013-10-22','12:05:00',2.82),('16273','2013-10-22','12:10:00',2.84),('16273','2013-10-22','12:15:00',2.82),('16273','2013-10-22','12:20:00',2.87),('16273','2013-10-22','12:25:00',2.91),('16273','2013-10-22','12:30:00',2.92),('16273','2013-10-22','12:35:00',2.83),('16273','2013-10-22','12:40:00',2.78),('16273','2013-10-22','12:45:00',2.82),('16273','2013-10-22','12:50:00',2.84),('16273','2013-10-22','12:55:00',2.71),('16273','2013-10-22','13:00:00',2.7),('16273','2013-10-22','13:05:00',2.64),('16273','2013-10-22','13:10:00',2.72),('16273','2013-10-22','13:15:00',2.67),('16273','2013-10-22','13:20:00',2.67),('16273','2013-10-22','13:25:00',2.72),('16273','2013-10-22','13:30:00',2.76),('16273','2013-10-22','13:35:00',1.65),('16273','2013-10-22','13:40:00',1.64),('16273','2013-10-22','13:45:00',2.59),('16273','2013-10-22','13:50:00',2.76),('16273','2013-10-22','13:55:00',2.79),('16273','2013-10-22','14:00:00',2.56),('16273','2013-10-22','14:05:00',2.38),('16273','2013-10-22','14:10:00',2.13),('16273','2013-10-22','14:15:00',2.17),('16273','2013-10-22','14:20:00',2.09),('16273','2013-10-22','14:25:00',2.27),('16273','2013-10-22','14:30:00',2.04),('16273','2013-10-22','14:35:00',2.22),('16273','2013-10-22','14:40:00',2.14),('16273','2013-10-22','14:45:00',2.09),('16273','2013-10-22','14:50:00',2.01),('16273','2013-10-22','14:55:00',1.98),('16273','2013-10-22','15:00:00',1.92),('16273','2013-10-22','15:05:00',1.86),('16273','2013-10-22','15:10:00',1.8),('16273','2013-10-22','15:15:00',1.74),('16273','2013-10-22','15:20:00',1.68),('16273','2013-10-22','15:25:00',1.61),('16273','2013-10-22','15:30:00',1.57),('16273','2013-10-22','15:35:00',1.48),('16273','2013-10-22','15:40:00',1.42),('16273','2013-10-22','15:45:00',1.37),('16273','2013-10-22','15:50:00',1.31),('16273','2013-10-22','15:55:00',1.25),('16273','2013-10-22','16:00:00',1.19),('16273','2013-10-22','16:05:00',1.14),('16273','2013-10-22','16:10:00',1.06),('16273','2013-10-22','16:15:00',1.02),('16273','2013-10-21','09:00:00',1.09),('16273','2013-10-21','09:05:00',1.46),('16273','2013-10-21','09:10:00',1.68),('16273','2013-10-21','09:15:00',1.84),('16273','2013-10-21','09:20:00',1.71),('16273','2013-10-21','09:25:00',1.63),('16273','2013-10-21','09:30:00',1.6),('16273','2013-10-21','09:35:00',1.77),('16273','2013-10-21','09:40:00',1.56),('16273','2013-10-21','09:45:00',1.65),('16273','2013-10-21','09:50:00',1.93),('16273','2013-10-21','09:55:00',2.06),('16273','2013-10-21','10:00:00',2.24),('16273','2013-10-21','10:05:00',2.36),('16273','2013-10-21','10:10:00',2.48),('16273','2013-10-21','10:15:00',2.5),('16273','2013-10-21','10:20:00',2.44),('16273','2013-10-21','10:25:00',2.5),('16273','2013-10-21','10:30:00',2.42),('16273','2013-10-21','10:35:00',2.56),('16273','2013-10-21','10:40:00',2.56),('16273','2013-10-21','10:45:00',2.68),('16273','2013-10-21','10:50:00',2.8),('16273','2013-10-21','10:55:00',2.65),('16273','2013-10-21','11:00:00',2.63),('16273','2013-10-21','11:05:00',2.87),('16273','2013-10-21','11:10:00',2.85),('16273','2013-10-21','11:15:00',2.75),('16273','2013-10-21','11:20:00',2.79),('16273','2013-10-21','11:25:00',2.89),('16273','2013-10-21','11:30:00',2.78),('16273','2013-10-21','11:35:00',2.82),('16273','2013-10-21','11:40:00',2.88),('16273','2013-10-21','11:45:00',2.8),('16273','2013-10-21','11:50:00',2.93),('16273','2013-10-21','11:55:00',2.94),('16273','2013-10-21','12:00:00',2.9),('16273','2013-10-21','12:05:00',2.84),('16273','2013-10-21','12:10:00',2.87),('16273','2013-10-21','12:15:00',2.88),('16273','2013-10-21','12:20:00',2.78),('16273','2013-10-21','12:25:00',2.84),('16273','2013-10-21','12:30:00',2.87),('16273','2013-10-21','12:35:00',2.87),('16273','2013-10-21','12:40:00',2.88),('16273','2013-10-21','12:45:00',2.8),('16273','2013-10-21','12:50:00',2.81),('16273','2013-10-21','12:55:00',2.78),('16273','2013-10-21','13:00:00',2.65),('16273','2013-10-21','13:05:00',2.69),('16273','2013-10-21','13:10:00',2.66),('16273','2013-10-21','13:15:00',2.64),('16273','2013-10-21','13:20:00',2.7),('16273','2013-10-21','13:25:00',2.77),('16273','2013-10-21','13:30:00',2.73),('16273','2013-10-21','13:35:00',2.7),('16273','2013-10-21','13:40:00',2.66),('16273','2013-10-21','13:45:00',2.56),('16273','2013-10-21','13:50:00',2.47),('16273','2013-10-21','13:55:00',2.54),('16273','2013-10-21','14:00:00',2.47),('16273','2013-10-21','14:05:00',2.46),('16273','2013-10-21','14:10:00',2.4),('16273','2013-10-21','14:15:00',2.43),('16273','2013-10-21','14:20:00',2.38),('16273','2013-10-21','14:25:00',2.36),('16273','2013-10-21','14:30:00',2.3),('16273','2013-10-21','14:35:00',2.23),('16273','2013-10-21','14:40:00',2.2),('16273','2013-10-21','14:45:00',2.1),('16273','2013-10-21','14:50:00',2.07),('16273','2013-10-21','14:55:00',2.01),('16273','2013-10-21','15:00:00',1.95),('16273','2013-10-21','15:05:00',1.92),('16273','2013-10-21','15:10:00',1.82),('16273','2013-10-21','15:15:00',1.66),('16273','2013-10-21','15:20:00',1.7),('16273','2013-10-21','15:25:00',1.65),('16273','2013-10-21','15:30:00',1.63),('16273','2013-10-21','15:35:00',1.54),('16273','2013-10-21','15:40:00',1.49),('16273','2013-10-21','15:45:00',1.39),('16273','2013-10-21','15:50:00',1.32),('16273','2013-10-21','15:55:00',1.29),('16273','2013-10-21','16:00:00',1.24),('16273','2013-10-21','16:05:00',1.19),('16273','2013-10-21','16:10:00',1.13),('16273','2013-10-21','16:15:00',1.06),('16273','2013-10-20','08:35:00',1.01),('16273','2013-10-20','08:40:00',1.26),('16273','2013-10-20','08:45:00',1.29),('16273','2013-10-20','08:50:00',1.37),('16273','2013-10-20','08:55:00',1.4),('16273','2013-10-20','09:00:00',1.55),('16273','2013-10-20','09:05:00',1.62),('16273','2013-10-20','09:10:00',1.71),('16273','2013-10-20','09:15:00',1.8),('16273','2013-10-20','09:20:00',1.89),('16273','2013-10-20','09:25:00',1.96),('16273','2013-10-20','09:30:00',2.02),('16273','2013-10-20','09:35:00',2.07),('16273','2013-10-20','09:40:00',2.15),('16273','2013-10-20','09:45:00',2.23),('16273','2013-10-20','09:50:00',2.29),('16273','2013-10-20','09:55:00',2.33),('16273','2013-10-20','10:00:00',2.42),('16273','2013-10-20','10:05:00',2.45),('16273','2013-10-20','10:10:00',2.51),('16273','2013-10-20','10:15:00',2.55),('16273','2013-10-20','10:20:00',2.57),('16273','2013-10-20','10:25:00',2.64),('16273','2013-10-20','10:30:00',2.68),('16273','2013-10-20','10:35:00',2.72),('16273','2013-10-20','10:40:00',2.74),('16273','2013-10-20','10:45:00',2.77),('16273','2013-10-20','10:50:00',2.83),('16273','2013-10-20','10:55:00',2.86),('16273','2013-10-20','11:00:00',2.87),('16273','2013-10-20','11:05:00',2.93),('16273','2013-10-20','11:10:00',2.84),('16273','2013-10-20','11:15:00',2.97),('16273','2013-10-20','11:20:00',2.7),('16273','2013-10-20','11:25:00',2.68),('16273','2013-10-20','11:30:00',2.85),('16273','2013-10-20','11:35:00',3.02),('16273','2013-10-20','11:40:00',2.96),('16273','2013-10-20','11:45:00',2.98),('16273','2013-10-20','11:50:00',2.98),('16273','2013-10-20','11:55:00',2.96),('16273','2013-10-20','12:00:00',3.05),('16273','2013-10-20','12:05:00',2.22),('16273','2013-10-20','12:10:00',2.74),('16273','2013-10-20','12:15:00',2.15),('16273','2013-10-20','12:20:00',1.87),('16273','2013-10-20','12:30:00',1.27),('16273','2013-10-20','12:35:00',1.9),('16273','2013-10-20','12:40:00',2.33),('16273','2013-10-20','12:45:00',3.11),('16273','2013-10-20','12:50:00',1.22),('16273','2013-10-20','12:55:00',1.56),('16273','2013-10-20','13:05:00',1.81),('16273','2013-10-20','13:25:00',1.64),('16273','2013-10-20','13:40:00',1.28),('16273','2013-10-20','13:45:00',1.52),('16273','2013-10-20','13:50:00',1.2),('16273','2013-10-20','14:00:00',1.24),('16273','2013-10-20','14:05:00',2.7),('16273','2013-10-20','14:10:00',1.68),('16273','2013-10-20','14:15:00',1.35),('16273','2013-10-20','14:20:00',2.57),('16273','2013-10-20','14:25:00',2.81),('16273','2013-10-20','14:30:00',2.81),('16273','2013-10-20','14:35:00',2.68),('16273','2013-10-20','14:40:00',2.59),('16273','2013-10-20','14:45:00',2.44),('16273','2013-10-20','14:50:00',2.36),('16273','2013-10-20','14:55:00',2.24),('16273','2013-10-20','15:00:00',2.29),('16273','2013-10-20','15:05:00',2.3),('16273','2013-10-20','15:10:00',2.16),('16273','2013-10-20','15:15:00',2.03),('16273','2013-10-20','15:20:00',1.92),('16273','2013-10-20','15:25:00',1.96),('16273','2013-10-20','15:30:00',1.98),('16273','2013-10-20','15:35:00',1.92),('16273','2013-10-20','15:40:00',1.84),('16273','2013-10-20','15:45:00',1.78),('16273','2013-10-20','15:50:00',1.68),('16273','2013-10-20','15:55:00',1.58),('16273','2013-10-20','16:00:00',1.42),('16273','2013-10-20','16:05:00',1.42),('16273','2013-10-20','16:10:00',1.29),('16273','2013-10-20','16:15:00',1.18),('16273','2013-10-20','16:20:00',1.12),('16273','2013-10-20','16:25:00',1.05),('16273','2013-10-19','08:30:00',1.1),('16273','2013-10-19','08:35:00',1.29),('16273','2013-10-19','08:40:00',1.39),('16273','2013-10-19','08:45:00',1.09),('16273','2013-10-19','08:50:00',1.62),('16273','2013-10-19','08:55:00',1.58),('16273','2013-10-19','09:00:00',1.48),('16273','2013-10-19','09:05:00',2.08),('16273','2013-10-19','09:10:00',2.13),('16273','2013-10-19','09:15:00',2.19),('16273','2013-10-19','09:20:00',2.23),('16273','2013-10-19','09:25:00',2.24),('16273','2013-10-19','09:30:00',2.32),('16273','2013-10-19','09:35:00',2.4),('16273','2013-10-19','09:40:00',2.37),('16273','2013-10-19','09:45:00',2.54),('16273','2013-10-19','09:50:00',2.58),('16273','2013-10-19','09:55:00',2.58),('16273','2013-10-19','10:00:00',2.59),('16273','2013-10-19','10:05:00',2.73),('16273','2013-10-19','10:10:00',2.79),('16273','2013-10-19','10:15:00',2.85),('16273','2013-10-19','10:20:00',2.92),('16273','2013-10-19','10:25:00',2.95),('16273','2013-10-19','10:30:00',2.93),('16273','2013-10-19','10:35:00',2.93),('16273','2013-10-19','10:40:00',2.98),('16273','2013-10-19','10:45:00',3.04),('16273','2013-10-19','10:50:00',3.05),('16273','2013-10-19','10:55:00',2.97),('16273','2013-10-19','11:00:00',2.67),('16273','2013-10-19','11:05:00',2),('16273','2013-10-19','11:10:00',3.3),('16273','2013-10-19','11:15:00',3.31),('16273','2013-10-19','11:20:00',3.29),('16273','2013-10-19','11:25:00',3.26),('16273','2013-10-19','11:30:00',3.21),('16273','2013-10-19','11:35:00',3.18),('16273','2013-10-19','11:40:00',3.09),('16273','2013-10-19','11:45:00',3.24),('16273','2013-10-19','11:50:00',3.24),('16273','2013-10-19','11:55:00',3.2),('16273','2013-10-19','12:00:00',3.15),('16273','2013-10-19','12:05:00',3.2),('16273','2013-10-19','12:10:00',3.06),('16273','2013-10-19','12:15:00',3.14),('16273','2013-10-19','12:20:00',3.05),('16273','2013-10-19','12:25:00',3.09),('16273','2013-10-19','12:30:00',3.1),('16273','2013-10-19','12:35:00',3.18),('16273','2013-10-19','12:40:00',3.26),('16273','2013-10-19','12:45:00',3.36),('16273','2013-10-19','12:50:00',3.39),('16273','2013-10-19','12:55:00',3.11),('16273','2013-10-19','13:00:00',3.17),('16273','2013-10-19','13:05:00',2.97),('16273','2013-10-19','13:10:00',3.02),('16273','2013-10-19','13:15:00',3.22),('16273','2013-10-19','13:20:00',2.73),('16273','2013-10-19','13:25:00',2.42),('16273','2013-10-19','13:30:00',1.91),('16273','2013-10-19','13:35:00',2.63),('16273','2013-10-19','13:40:00',3.15),('16273','2013-10-19','13:45:00',2.93),('16273','2013-10-19','13:50:00',2.64),('16273','2013-10-19','13:55:00',2.92),('16273','2013-10-19','14:00:00',1.99),('16273','2013-10-19','14:05:00',2.64),('16273','2013-10-19','14:10:00',2.28),('16273','2013-10-19','14:15:00',2.54),('16273','2013-10-19','14:20:00',2.85),('16273','2013-10-19','14:25:00',2.71),('16273','2013-10-19','14:30:00',2.03),('16273','2013-10-19','14:35:00',2.46),('16273','2013-10-19','14:40:00',2.52),('16273','2013-10-19','14:45:00',2.4),('16273','2013-10-19','14:50:00',2.3),('16273','2013-10-19','14:55:00',2.24),('16273','2013-10-19','15:00:00',2.24),('16273','2013-10-19','15:05:00',2.09),('16273','2013-10-19','15:10:00',2.01),('16273','2013-10-19','15:15:00',1.92),('16273','2013-10-19','15:20:00',1.86),('16273','2013-10-19','15:25:00',1.84),('16273','2013-10-19','15:30:00',1.64),('16273','2013-10-19','15:35:00',1.47),('16273','2013-10-19','15:40:00',1.64),('16273','2013-10-19','15:45:00',1.6),('16273','2013-10-19','15:50:00',1.56),('16273','2013-10-19','15:55:00',1.47),('16273','2013-10-19','16:00:00',1.39),('16273','2013-10-19','16:05:00',1.41),('16273','2013-10-19','16:15:00',1.01),('16273','2013-10-19','16:20:00',1.24),('16273','2013-10-19','16:25:00',1.24),('16273','2013-10-19','16:30:00',1.2),('16273','2013-10-19','16:35:00',1.14),('16273','2013-10-19','16:40:00',1.04),('16273','2014-05-04','07:15:00',1.03),('16273','2014-05-04','07:20:00',1.16),('16273','2014-05-04','07:25:00',1.17),('16273','2014-05-04','07:30:00',1.29),('16273','2014-05-04','07:35:00',1.48),('16273','2014-05-04','07:40:00',1.61),('16273','2014-05-04','07:45:00',1.8),('16273','2014-05-04','07:50:00',1.77),('16273','2014-05-04','07:55:00',1.87),('16273','2014-05-04','08:00:00',1.95),('16273','2014-05-04','08:05:00',1.92),('16273','2014-05-04','08:10:00',1.44),('16273','2014-05-04','08:15:00',2.16),('16273','2014-05-04','08:20:00',2.27),('16273','2014-05-04','08:25:00',2.45),('16273','2014-05-04','08:30:00',1.6),('16273','2014-05-04','08:35:00',1.94),('16273','2014-05-04','08:40:00',1.92),('16273','2014-05-04','08:45:00',1.72),('16273','2014-05-04','08:50:00',2.19),('16273','2014-05-04','08:55:00',1.49),('16273','2014-05-04','09:00:00',1.45),('16273','2014-05-04','09:05:00',1.53),('16273','2014-05-04','09:10:00',1.51),('16273','2014-05-04','09:15:00',1.35),('16273','2014-05-04','09:20:00',2.03),('16273','2014-05-04','09:25:00',2.61),('16273','2014-05-04','09:30:00',3.25),('16273','2014-05-04','09:35:00',3.85),('16273','2014-05-04','09:40:00',3.25),('16273','2014-05-04','09:45:00',3.81),('16273','2014-05-04','09:50:00',2.39),('16273','2014-05-04','09:55:00',3.02),('16273','2014-05-04','10:00:00',3.72),('16273','2014-05-04','10:05:00',3.87),('16273','2014-05-04','10:10:00',3.59),('16273','2014-05-04','10:15:00',1.92),('16273','2014-05-04','10:20:00',2.84),('16273','2014-05-04','10:25:00',3.15),('16273','2014-05-04','10:30:00',1.82),('16273','2014-05-04','10:35:00',1.7),('16273','2014-05-04','10:40:00',1.94),('16273','2014-05-04','10:45:00',1.79),('16273','2014-05-04','10:50:00',1.93),('16273','2014-05-04','10:55:00',2.2),('16273','2014-05-04','11:00:00',2.5),('16273','2014-05-04','11:05:00',3.7),('16273','2014-05-04','11:10:00',1.9),('16273','2014-05-04','11:15:00',3.93),('16273','2014-05-04','11:20:00',3.01),('16273','2014-05-04','11:25:00',4.29),('16273','2014-05-04','11:30:00',4.07),('16273','2014-05-04','11:35:00',4.07),('16273','2014-05-04','11:40:00',4.12),('16273','2014-05-04','11:45:00',2.24),('16273','2014-05-04','11:50:00',3.98),('16273','2014-05-04','11:55:00',1.85),('16273','2014-05-04','12:00:00',1.54),('16273','2014-05-04','12:05:00',2.01),('16273','2014-05-04','12:10:00',2.77),('16273','2014-05-04','12:15:00',4.61),('16273','2014-05-04','12:20:00',4.56),('16273','2014-05-04','12:25:00',4.67),('16273','2014-05-04','12:30:00',4.15),('16273','2014-05-04','12:35:00',2.22),('16273','2014-05-04','12:40:00',1.69),('16273','2014-05-04','12:45:00',1.15),('16273','2014-05-04','12:50:00',1.26),('16273','2014-05-04','12:55:00',1.54),('16273','2014-05-04','13:00:00',1.8),('16273','2014-05-04','13:05:00',1.35),('16273','2014-05-04','13:10:00',1.18),('16273','2014-05-04','13:15:00',1.05),('16273','2014-05-04','13:30:00',1.02),('16273','2014-05-04','13:35:00',1.16),('16273','2014-05-04','13:40:00',1.25),('16273','2014-05-04','13:45:00',1.31),('16273','2014-05-04','13:50:00',1.54),('16273','2014-05-04','13:55:00',1.59),('16273','2014-05-04','14:00:00',1.32),('16273','2014-05-04','14:05:00',1.08),('16273','2014-05-04','14:30:00',1.04),('16273','2014-05-04','14:35:00',1.09),('16273','2014-05-04','14:40:00',1.31),('16273','2014-05-04','14:45:00',1.56),('16273','2014-05-04','14:50:00',1.91),('16273','2014-05-04','14:55:00',3.92),('16273','2014-05-04','15:00:00',3.84),('16273','2014-05-04','15:05:00',4.14),('16273','2014-05-04','15:10:00',2.72),('16273','2014-05-04','15:15:00',3.08),('16273','2014-05-04','15:20:00',1.59),('16273','2014-05-04','15:25:00',1.28),('16273','2014-05-04','15:30:00',1.27),('16273','2014-05-04','15:35:00',1.24),('16273','2014-05-04','15:40:00',1.15),('16273','2014-05-04','15:50:00',1.07),('16273','2014-05-04','15:55:00',1.1),('16273','2014-04-16','07:40:00',1.12),('16273','2014-04-16','07:45:00',1.26),('16273','2014-04-16','07:50:00',1.14),('16273','2014-04-16','07:55:00',1.47),('16273','2014-04-16','08:00:00',1.56),('16273','2014-04-16','08:05:00',1.67),('16273','2014-04-16','08:10:00',1.76),('16273','2014-04-16','08:15:00',1.85),('16273','2014-04-16','08:20:00',1.95),('16273','2014-04-16','08:25:00',2.04),('16273','2014-04-16','08:30:00',2.04),('16273','2014-04-16','08:35:00',2),('16273','2014-04-16','08:40:00',2.08),('16273','2014-04-16','08:45:00',2.42),('16273','2014-04-16','08:50:00',2.49),('16273','2014-04-16','08:55:00',2.55),('16273','2014-04-16','09:00:00',2.62),('16273','2014-04-16','09:05:00',2.7),('16273','2014-04-16','09:10:00',2.76),('16273','2014-04-16','09:15:00',2.83),('16273','2014-04-16','09:20:00',2.89),('16273','2014-04-16','09:25:00',2.95),('16273','2014-04-16','09:30:00',3.02),('16273','2014-04-16','09:35:00',2.61),('16273','2014-04-16','09:40:00',2.58),('16273','2014-04-16','09:45:00',2.07),('16273','2014-04-16','09:50:00',1.45),('16273','2014-04-16','09:55:00',3.3),('16273','2014-04-16','10:00:00',3.43),('16273','2014-04-16','10:05:00',3.45),('16273','2014-04-16','10:10:00',3.48),('16273','2014-04-16','10:15:00',3.53),('16273','2014-04-16','10:20:00',3.59),('16273','2014-04-16','10:25:00',3.65),('16273','2014-04-16','10:30:00',3.6),('16273','2014-04-16','10:35:00',3.69),('16273','2014-04-16','10:40:00',3.74),('16273','2014-04-16','10:45:00',3.89),('16273','2014-04-16','10:50:00',4.09),('16273','2014-04-16','10:55:00',4.15),('16273','2014-04-16','11:00:00',3.72),('16273','2014-04-16','11:05:00',4.19),('16273','2014-04-16','11:10:00',3.77),('16273','2014-04-16','11:15:00',3.57),('16273','2014-04-16','11:20:00',3.85),('16273','2014-04-16','11:25:00',3.39),('16273','2014-04-16','11:30:00',4.9),('16273','2014-04-16','11:35:00',1.92),('16273','2014-04-16','11:40:00',1.72),('16273','2014-04-16','11:45:00',1.6),('16273','2014-04-16','11:50:00',1.76),('16273','2014-04-16','11:55:00',4.07),('16273','2014-04-16','12:00:00',4.33),('16273','2014-04-16','12:05:00',4.55),('16273','2014-04-16','12:10:00',3.98),('16273','2014-04-16','12:15:00',3.66),('16273','2014-04-16','12:20:00',2.71),('16273','2014-04-16','12:25:00',2.26),('16273','2014-04-16','12:30:00',4.75),('16273','2014-04-16','12:35:00',4.83),('16273','2014-04-16','12:40:00',4.62),('16273','2014-04-16','12:45:00',4.67),('16273','2014-04-16','12:50:00',4.62),('16273','2014-04-16','12:55:00',4.76),('16273','2014-04-16','13:00:00',4.69),('16273','2014-04-16','13:05:00',4.03),('16273','2014-04-16','13:10:00',2.57),('16273','2014-04-16','13:15:00',3.46),('16273','2014-04-16','13:20:00',1.9),('16273','2014-04-16','13:25:00',2.27),('16273','2014-04-16','13:30:00',3.46),('16273','2014-04-16','13:35:00',1.96),('16273','2014-04-16','13:40:00',3.09),('16273','2014-04-16','13:45:00',4.48),('16273','2014-04-16','13:50:00',4.36),('16273','2014-04-16','13:55:00',3.93),('16273','2014-04-16','14:00:00',1.72),('16273','2014-04-16','14:05:00',1.97),('16273','2014-04-16','14:10:00',2.59),('16273','2014-04-16','14:15:00',3.86),('16273','2014-04-16','14:20:00',2.71),('16273','2014-04-16','14:25:00',3.86),('16273','2014-04-16','14:30:00',1.36),('16273','2014-04-16','14:35:00',1.49),('16273','2014-04-16','14:40:00',2.61),('16273','2014-04-16','14:45:00',3.45),('16273','2014-04-16','14:50:00',3.04),('16273','2014-04-16','14:55:00',3.79),('16273','2014-04-16','15:00:00',3.73),('16273','2014-04-16','15:05:00',2.87),('16273','2014-04-16','15:10:00',1.28),('16273','2014-04-16','15:15:00',1.05),('16273','2014-04-16','15:35:00',1.11),('16273','2014-04-16','15:40:00',1.14),('16273','2014-04-16','15:45:00',1.27),('16273','2014-04-16','15:50:00',1.42),('16273','2014-04-16','15:55:00',2.2),('16273','2014-04-16','16:00:00',2.93),('16273','2014-04-16','16:05:00',2.66),('16273','2014-04-16','16:10:00',2.3),('16273','2014-04-16','16:15:00',2.41),('16273','2014-04-16','16:20:00',2.13),('16273','2014-04-16','16:30:00',2.24),('16273','2014-04-16','16:35:00',2.11),('16273','2014-04-16','16:40:00',1.95),('16273','2014-04-16','16:45:00',1.9),('16273','2014-04-16','16:50:00',1.82),('16273','2014-04-16','16:55:00',1.75),('16273','2014-04-16','17:00:00',1.67),('16273','2014-04-16','17:05:00',1.58),('16273','2014-04-16','17:10:00',1.13),('16273','2014-04-16','17:15:00',1.39),('16273','2014-04-16','17:20:00',1.32),('16273','2014-04-16','17:25:00',1.22),('16273','2014-04-16','17:30:00',1.14),('16273','2014-04-16','17:35:00',1.07),('16273','2014-04-16','17:40:00',1),('16273','2013-10-18','08:30:00',1.05),('16273','2013-10-18','08:35:00',1.21),('16273','2013-10-18','08:40:00',1.11),('16273','2013-10-18','08:45:00',1.46),('16273','2013-10-18','08:50:00',1.46),('16273','2013-10-18','08:55:00',1.61),('16273','2013-10-18','09:00:00',1.76),('16273','2013-10-18','09:05:00',1.86),('16273','2013-10-18','09:10:00',1.97),('16273','2013-10-18','09:15:00',2.02),('16273','2013-10-18','09:20:00',2.19),('16273','2013-10-18','09:25:00',2.23),('16273','2013-10-18','09:30:00',2.3),('16273','2013-10-18','09:35:00',2.39),('16273','2013-10-18','09:40:00',2.45),('16273','2013-10-18','09:45:00',2.51),('16273','2013-10-18','09:50:00',2.58),('16273','2013-10-18','09:55:00',2.63),('16273','2013-10-18','10:00:00',2.68),('16273','2013-10-18','10:05:00',2.74),('16273','2013-10-18','10:10:00',2.76),('16273','2013-10-18','10:15:00',2.78),('16273','2013-10-18','10:20:00',2.82),('16273','2013-10-18','10:25:00',2.91),('16273','2013-10-18','10:30:00',2.94),('16273','2013-10-18','10:35:00',2.95),('16273','2013-10-18','10:40:00',2.97),('16273','2013-10-18','10:45:00',2.94),('16273','2013-10-18','10:50:00',2.88),('16273','2013-10-18','10:55:00',3.02),('16273','2013-10-18','11:00:00',3.04),('16273','2013-10-18','11:05:00',3.03),('16273','2013-10-18','11:10:00',2.96),('16273','2013-10-18','11:15:00',3.14),('16273','2013-10-18','11:20:00',3.14),('16273','2013-10-18','11:25:00',3.1),('16273','2013-10-18','11:30:00',3.14),('16273','2013-10-18','11:35:00',3.2),('16273','2013-10-18','11:40:00',2.98),('16273','2013-10-18','11:45:00',2.94),('16273','2013-10-18','11:50:00',3.18),('16273','2013-10-18','11:55:00',3.18),('16273','2013-10-18','12:00:00',3.15),('16273','2013-10-18','12:05:00',3.16),('16273','2013-10-18','12:10:00',3.15),('16273','2013-10-18','12:15:00',3.07),('16273','2013-10-18','12:20:00',3.07),('16273','2013-10-18','12:25:00',3.09),('16273','2013-10-18','12:30:00',3.07),('16273','2013-10-18','12:35:00',3.05),('16273','2013-10-18','12:40:00',3.03),('16273','2013-10-18','12:45:00',2.98),('16273','2013-10-18','12:50:00',3.03),('16273','2013-10-18','12:55:00',3.06),('16273','2013-10-18','13:00:00',3.01),('16273','2013-10-18','13:05:00',2.95),('16273','2013-10-18','13:10:00',2.89),('16273','2013-10-18','13:15:00',2.97),('16273','2013-10-18','13:20:00',2.98),('16273','2013-10-18','13:25:00',2.95),('16273','2013-10-18','13:30:00',2.91),('16273','2013-10-18','13:35:00',2.92),('16273','2013-10-18','13:40:00',2.84),('16273','2013-10-18','13:45:00',2.81),('16273','2013-10-18','13:50:00',2.83),('16273','2013-10-18','13:55:00',2.61),('16273','2013-10-18','14:00:00',2.56),('16273','2013-10-18','14:05:00',2.61),('16273','2013-10-18','14:10:00',2.62),('16273','2013-10-18','14:15:00',2.61),('16273','2013-10-18','14:20:00',2.53),('16273','2013-10-18','14:25:00',2.54),('16273','2013-10-18','14:30:00',2.46),('16273','2013-10-18','14:35:00',2.43),('16273','2013-10-18','14:40:00',2.26),('16273','2013-10-18','14:45:00',2.26),('16273','2013-10-18','14:50:00',2.29),('16273','2013-10-18','14:55:00',2.09),('16273','2013-10-18','15:00:00',1.82),('16273','2013-10-18','15:05:00',2.04),('16273','2013-10-18','15:10:00',1.99),('16273','2013-10-18','15:15:00',2.02),('16273','2013-10-18','15:20:00',1.92),('16273','2013-10-18','15:25:00',1.76),('16273','2013-10-18','15:30:00',1.75),('16273','2013-10-18','15:35:00',1.62),('16273','2013-10-18','15:40:00',1.55),('16273','2013-10-18','15:45:00',1.4),('16273','2013-10-18','15:50:00',1.32),('16273','2013-10-18','15:55:00',1.4),('16273','2013-10-18','16:00:00',1.27),('16273','2013-10-18','16:05:00',1.25),('16273','2013-10-18','16:10:00',1.11),('16273','2013-10-18','16:15:00',1.09),('16273','2013-10-17','08:25:00',1.06),('16273','2013-10-17','08:30:00',1.18),('16273','2013-10-17','08:35:00',1.29),('16273','2013-10-17','08:40:00',1.21),('16273','2013-10-17','08:45:00',1.54),('16273','2013-10-17','08:50:00',1.66),('16273','2013-10-17','08:55:00',1.76),('16273','2013-10-17','09:00:00',1.85),('16273','2013-10-17','09:05:00',1.93),('16273','2013-10-17','09:10:00',2.01),('16273','2013-10-17','09:15:00',2.09),('16273','2013-10-17','09:20:00',2.17),('16273','2013-10-17','09:25:00',2.24),('16273','2013-10-17','09:30:00',2.29),('16273','2013-10-17','09:35:00',2.38),('16273','2013-10-17','09:40:00',2.44),('16273','2013-10-17','09:45:00',2.49),('16273','2013-10-17','09:50:00',2.55),('16273','2013-10-17','09:55:00',2.6),('16273','2013-10-17','10:00:00',2.65),('16273','2013-10-17','10:05:00',2.73),('16273','2013-10-17','10:10:00',2.79),('16273','2013-10-17','10:15:00',2.82),('16273','2013-10-17','10:20:00',2.87),('16273','2013-10-17','10:25:00',2.92),('16273','2013-10-17','10:30:00',2.95),('16273','2013-10-17','10:35:00',2.99),('16273','2013-10-17','10:40:00',3.03),('16273','2013-10-17','10:45:00',3.05),('16273','2013-10-17','10:50:00',3.1),('16273','2013-10-17','10:55:00',3.13),('16273','2013-10-17','11:00:00',3.16),('16273','2013-10-17','11:05:00',3.18),('16273','2013-10-17','11:10:00',3.2),('16273','2013-10-17','11:15:00',3.21),('16273','2013-10-17','11:20:00',3.23),('16273','2013-10-17','11:25:00',3.26),('16273','2013-10-17','11:30:00',3.26),('16273','2013-10-17','11:35:00',3.27),('16273','2013-10-17','11:40:00',3.28),('16273','2013-10-17','11:45:00',3.28),('16273','2013-10-17','11:50:00',3.27),('16273','2013-10-17','11:55:00',3.25),('16273','2013-10-17','12:00:00',3.26),('16273','2013-10-17','12:05:00',3.25),('16273','2013-10-17','12:10:00',3.26),('16273','2013-10-17','12:15:00',3.27),('16273','2013-10-17','12:20:00',3.25),('16273','2013-10-17','12:25:00',3.24),('16273','2013-10-17','12:30:00',3.24),('16273','2013-10-17','12:35:00',3.26),('16273','2013-10-17','12:40:00',3.24),('16273','2013-10-17','12:45:00',3.21),('16273','2013-10-17','12:50:00',3.19),('16273','2013-10-17','12:55:00',3.18),('16273','2013-10-17','13:00:00',3.17),('16273','2013-10-17','13:05:00',3.15),('16273','2013-10-17','13:10:00',3.13),('16273','2013-10-17','13:15:00',3.11),('16273','2013-10-17','13:20:00',3.1),('16273','2013-10-17','13:25:00',3.04),('16273','2013-10-17','13:30:00',3.03),('16273','2013-10-17','13:35:00',3),('16273','2013-10-17','13:40:00',2.97),('16273','2013-10-17','13:45:00',2.93),('16273','2013-10-17','13:50:00',2.91),('16273','2013-10-17','13:55:00',2.89),('16273','2013-10-17','14:00:00',2.83),('16273','2013-10-17','14:05:00',2.79),('16273','2013-10-17','14:10:00',2.74),('16273','2013-10-17','14:15:00',2.7),('16273','2013-10-17','14:20:00',2.67),('16273','2013-10-17','14:25:00',2.62),('16273','2013-10-17','14:30:00',2.57),('16273','2013-10-17','14:35:00',2.53),('16273','2013-10-17','14:40:00',2.48),('16273','2013-10-17','14:45:00',2.42),('16273','2013-10-17','14:50:00',2.38),('16273','2013-10-17','14:55:00',2.33),('16273','2013-10-17','15:00:00',2.28),('16273','2013-10-17','15:05:00',2.21),('16273','2013-10-17','15:10:00',2.15),('16273','2013-10-17','15:15:00',2.08),('16273','2013-10-17','15:20:00',1.99),('16273','2013-10-17','15:25:00',1.95),('16273','2013-10-17','15:30:00',1.88),('16273','2013-10-17','15:35:00',1.78),('16273','2013-10-17','15:40:00',1.72),('16273','2013-10-17','15:45:00',1.67),('16273','2013-10-17','15:50:00',1.58),('16273','2013-10-17','15:55:00',1.52),('16273','2013-10-17','16:00:00',1.46),('16273','2013-10-17','16:05:00',1.39),('16273','2013-10-17','16:10:00',1.33),('16273','2013-10-17','16:15:00',1.26),('16273','2013-10-17','16:20:00',1.19),('16273','2013-10-17','16:25:00',1.12),('16273','2013-10-17','16:30:00',1.06),('16273','2013-10-17','16:35:00',1),('16273','2013-10-16','09:40:00',1.36),('16273','2013-10-16','09:45:00',1.28),('16273','2013-10-16','09:55:00',1.17),('16273','2013-10-16','11:00:00',1.29),('16273','2013-10-16','11:05:00',1.08),('16273','2013-10-16','11:10:00',1.03),('16273','2013-10-16','11:45:00',1.28),('16273','2013-10-16','11:50:00',1.01),('16273','2013-10-16','12:00:00',1.26),('16273','2013-10-16','12:05:00',2.92),('16273','2013-10-16','12:10:00',1.15),('16273','2013-10-16','12:20:00',1.03),('16273','2013-10-16','12:25:00',1.34),('16273','2013-10-16','12:30:00',2.48),('16273','2013-10-16','12:35:00',1.03),('16273','2013-10-16','12:45:00',1.42),('16273','2013-10-16','12:50:00',1.09),('16273','2013-10-16','12:55:00',1.1),('16273','2013-10-16','13:00:00',1.07),('16273','2013-10-16','13:20:00',1.09),('16273','2013-10-16','13:25:00',1.52),('16273','2013-10-16','13:30:00',2.83),('16273','2013-10-16','13:35:00',2.76),('16273','2013-10-16','13:40:00',3.04),('16273','2013-10-16','13:45:00',1.81),('16273','2013-10-16','13:50:00',3.37),('16273','2013-10-16','13:55:00',1.27),('16273','2013-10-16','14:00:00',2.06),('16273','2013-10-16','14:05:00',2.67),('16273','2013-10-16','14:10:00',2.2),('16273','2013-10-16','14:15:00',2.67),('16273','2013-10-16','14:20:00',2.09),('16273','2013-10-16','14:25:00',2.07),('16273','2013-10-16','14:30:00',2.82),('16273','2013-10-16','14:35:00',2.16),('16273','2013-10-16','14:40:00',2.21),('16273','2013-10-16','14:45:00',2.47),('16273','2013-10-16','14:50:00',2.32),('16273','2013-10-16','14:55:00',2.34),('16273','2013-10-16','15:00:00',2.34),('16273','2013-10-16','15:05:00',2.09),('16273','2013-10-16','15:10:00',1.04),('16273','2013-10-16','15:15:00',1.19),('16273','2013-10-16','15:20:00',1.27),('16273','2013-10-16','15:25:00',2.04),('16273','2013-10-16','15:30:00',1.81),('16273','2013-10-16','15:35:00',1.82),('16273','2013-10-16','15:40:00',1.74),('16273','2013-10-16','15:45:00',1.67),('16273','2013-10-16','15:50:00',1.59),('16273','2013-10-16','15:55:00',1.48),('16273','2013-10-16','16:00:00',1.41),('16273','2013-10-16','16:05:00',1.34),('16273','2013-10-16','16:10:00',1.26),('16273','2013-10-16','16:15:00',1.25),('16273','2013-10-16','16:20:00',1.18),('16273','2013-10-16','16:25:00',1.13),('16273','2013-10-16','16:30:00',1.07),('16273','2013-10-16','16:35:00',1.01),('16273','2013-10-15','09:15:00',1.02),('16273','2013-10-15','09:20:00',1.14),('16273','2013-10-15','09:25:00',1.41),('16273','2013-10-15','09:30:00',1.15),('16273','2013-10-15','09:35:00',1.53),('16273','2013-10-15','09:40:00',2.1),('16273','2013-10-15','09:45:00',2.49),('16273','2013-10-15','09:50:00',2.55),('16273','2013-10-15','09:55:00',2.37),('16273','2013-10-15','10:00:00',2.59),('16273','2013-10-15','10:05:00',2.13),('16273','2013-10-15','10:10:00',1.27),('16273','2013-10-15','10:15:00',1.23),('16273','2013-10-15','10:20:00',1.87),('16273','2013-10-15','10:25:00',2.02),('16273','2013-10-15','10:30:00',1.86),('16273','2013-10-15','10:35:00',2.18),('16273','2013-10-15','10:40:00',2.55),('16273','2013-10-15','10:45:00',2.04),('16273','2013-10-15','10:50:00',1.75),('16273','2013-10-15','10:55:00',1.76),('16273','2013-10-15','11:00:00',2.01),('16273','2013-10-15','11:05:00',2.73),('16273','2013-10-15','11:10:00',2.78),('16273','2013-10-15','11:15:00',2.82),('16273','2013-10-15','11:20:00',2.53),('16273','2013-10-15','11:25:00',2.68),('16273','2013-10-15','11:30:00',2.2),('16273','2013-10-15','11:35:00',1.65),('16273','2013-10-15','11:40:00',1.48),('16273','2013-10-15','11:45:00',1.48),('16273','2013-10-15','11:50:00',1.43),('16273','2013-10-15','11:55:00',1.41),('16273','2013-10-15','12:00:00',1.37),('16273','2013-10-15','12:05:00',1.39),('16273','2013-10-15','12:10:00',1.38),('16273','2013-10-15','12:15:00',1.48),('16273','2013-10-15','12:20:00',1.32),('16273','2013-10-15','12:25:00',1.24),('16273','2013-10-15','12:30:00',1.26),('16273','2013-10-15','12:35:00',1.31),('16273','2013-10-15','12:40:00',1.39),('16273','2013-10-15','12:45:00',1.31),('16273','2013-10-15','12:50:00',1.19),('16273','2013-10-15','12:55:00',1.19),('16273','2013-10-15','13:00:00',1.65),('16273','2013-10-15','13:05:00',1.71),('16273','2013-10-15','13:10:00',1.88),('16273','2013-10-15','13:15:00',2.71),('16273','2013-10-15','13:20:00',2.76),('16273','2013-10-15','13:25:00',1.72),('16273','2013-10-15','13:30:00',1.56),('16273','2013-10-15','13:35:00',1.56),('16273','2013-10-15','13:40:00',1.56),('16273','2013-10-15','13:45:00',1.43),('16273','2013-10-15','13:50:00',1.23),('16273','2013-10-15','13:55:00',1.09),('16273','2013-10-15','14:00:00',1.09),('16273','2013-10-15','14:05:00',1.22),('16273','2013-10-15','14:10:00',1.67),('16273','2013-10-15','14:15:00',1.82),('16273','2013-10-15','14:20:00',2.22),('16273','2013-10-15','14:25:00',1.85),('16273','2013-10-15','14:30:00',1.43),('16273','2013-10-15','14:35:00',1.79),('16273','2013-10-15','14:40:00',2.37),('16273','2013-10-15','14:45:00',2.35),('16273','2013-10-15','14:50:00',1.68),('16273','2013-10-15','14:55:00',1.16),('16273','2013-10-15','15:00:00',1.27),('16273','2013-10-15','15:05:00',1.3),('16273','2013-10-15','15:10:00',1.14),('16273','2013-10-15','15:15:00',1.02),('16273','2013-10-15','16:25:00',1.01),('16273','2013-10-15','16:30:00',1.02),('16273','2013-10-14','08:30:00',1.09),('16273','2013-10-14','08:35:00',1.14),('16273','2013-10-14','08:40:00',1.11),('16273','2013-10-14','08:45:00',1.26),('16273','2013-10-14','08:50:00',1.41),('16273','2013-10-14','08:55:00',1.36),('16273','2013-10-14','09:00:00',1.22),('16273','2013-10-14','09:05:00',1.08),('16273','2013-10-14','09:15:00',1.52),('16273','2013-10-14','09:20:00',1.86),('16273','2013-10-14','09:25:00',2.06),('16273','2013-10-14','09:30:00',2.05),('16273','2013-10-14','09:35:00',1.8),('16273','2013-10-14','09:40:00',1.9),('16273','2013-10-14','09:45:00',2.32),('16273','2013-10-14','09:50:00',2.23),('16273','2013-10-14','09:55:00',2.27),('16273','2013-10-14','10:00:00',2.53),('16273','2013-10-14','10:05:00',2.57),('16273','2013-10-14','10:10:00',2.6),('16273','2013-10-14','10:15:00',2.66),('16273','2013-10-14','10:20:00',2.7),('16273','2013-10-14','10:25:00',2.74),('16273','2013-10-14','10:30:00',2.76),('16273','2013-10-14','10:35:00',2.69),('16273','2013-10-14','10:40:00',2.71),('16273','2013-10-14','10:45:00',2.87),('16273','2013-10-14','10:50:00',2.88),('16273','2013-10-14','10:55:00',2.92),('16273','2013-10-14','11:00:00',2.86),('16273','2013-10-14','11:05:00',2.93),('16273','2013-10-14','11:10:00',2.98),('16273','2013-10-14','11:15:00',2.95),('16273','2013-10-14','11:20:00',3.05),('16273','2013-10-14','11:25:00',3.09),('16273','2013-10-14','11:30:00',3.03),('16273','2013-10-14','11:35:00',3.03),('16273','2013-10-14','11:40:00',3),('16273','2013-10-14','11:45:00',3.06),('16273','2013-10-14','11:50:00',3.06),('16273','2013-10-14','11:55:00',3.09),('16273','2013-10-14','12:00:00',3.08),('16273','2013-10-14','12:05:00',3.14),('16273','2013-10-14','12:10:00',3.07),('16273','2013-10-14','12:15:00',2.87),('16273','2013-10-14','12:20:00',3.03),('16273','2013-10-14','12:25:00',3.15),('16273','2013-10-14','12:30:00',3.12),('16273','2013-10-14','12:35:00',3.09),('16273','2013-10-14','12:40:00',3.1),('16273','2013-10-14','12:45:00',3.04),('16273','2013-10-14','12:50:00',3.06),('16273','2013-10-14','12:55:00',3.03),('16273','2013-10-14','13:00:00',3.02),('16273','2013-10-14','13:05:00',2.99),('16273','2013-10-14','13:10:00',2.97),('16273','2013-10-14','13:15:00',2.96),('16273','2013-10-14','13:20:00',2.92),('16273','2013-10-14','13:25:00',2.9),('16273','2013-10-14','13:30:00',2.87),('16273','2013-10-14','13:35:00',2.85),('16273','2013-10-14','13:40:00',2.81),('16273','2013-10-14','13:45:00',2.78),('16273','2013-10-14','13:50:00',2.74),('16273','2013-10-14','13:55:00',2.7),('16273','2013-10-14','14:00:00',2.66),('16273','2013-10-14','14:05:00',2.62),('16273','2013-10-14','14:10:00',2.57),('16273','2013-10-14','14:15:00',2.52),('16273','2013-10-14','14:20:00',2.48),('16273','2013-10-14','14:25:00',2.45),('16273','2013-10-14','14:30:00',2.39),('16273','2013-10-14','14:35:00',2.32),('16273','2013-10-14','14:40:00',2.29),('16273','2013-10-14','14:45:00',2.26),('16273','2013-10-14','14:50:00',2.22),('16273','2013-10-14','14:55:00',2.16),('16273','2013-10-14','15:00:00',2.1),('16273','2013-10-14','15:05:00',2.04),('16273','2013-10-14','15:10:00',1.98),('16273','2013-10-14','15:15:00',1.93),('16273','2013-10-14','15:20:00',1.87),('16273','2013-10-14','15:25:00',1.81),('16273','2013-10-14','15:30:00',1.75),('16273','2013-10-14','15:35:00',1.67),('16273','2013-10-14','15:40:00',1.49),('16273','2013-10-14','16:10:00',1.3),('16273','2013-10-14','16:20:00',1.03),('16273','2013-10-14','16:40:00',1.03),('16273','2013-10-13','08:50:00',1.19),('16273','2013-10-13','08:55:00',1.33),('16273','2013-10-13','09:00:00',1.34),('16273','2013-10-13','09:05:00',1.27),('16273','2013-10-13','09:10:00',1.89),('16273','2013-10-13','09:15:00',2.1),('16273','2013-10-13','09:20:00',1.96),('16273','2013-10-13','09:25:00',1.3),('16273','2013-10-13','09:30:00',1.47),('16273','2013-10-13','09:35:00',1.89),('16273','2013-10-13','09:40:00',2.67),('16273','2013-10-13','09:45:00',2.19),('16273','2013-10-13','09:50:00',2.45),('16273','2013-10-13','09:55:00',1.6),('16273','2013-10-13','10:00:00',1.64),('16273','2013-10-13','10:05:00',2.73),('16273','2013-10-13','10:10:00',1.99),('16273','2013-10-13','10:15:00',1.76),('16273','2013-10-13','10:20:00',1.78),('16273','2013-10-13','10:25:00',2.4),('16273','2013-10-13','10:30:00',3.3),('16273','2013-10-13','10:35:00',3.36),('16273','2013-10-13','10:40:00',3.17),('16273','2013-10-13','10:45:00',3),('16273','2013-10-13','10:50:00',3.16),('16273','2013-10-13','10:55:00',3),('16273','2013-10-13','11:00:00',2.64),('16273','2013-10-13','11:05:00',3.08),('16273','2013-10-13','11:10:00',2.67),('16273','2013-10-13','11:15:00',3.18),('16273','2013-10-13','11:20:00',3.03),('16273','2013-10-13','11:25:00',3.21),('16273','2013-10-13','11:30:00',3.12),('16273','2013-10-13','11:35:00',3.09),('16273','2013-10-13','11:40:00',2.98),('16273','2013-10-13','11:45:00',3.11),('16273','2013-10-13','11:50:00',3.11),('16273','2013-10-13','11:55:00',3.13),('16273','2013-10-13','12:00:00',3.14),('16273','2013-10-13','12:05:00',3.14),('16273','2013-10-13','12:10:00',3.12),('16273','2013-10-13','12:15:00',3.14),('16273','2013-10-13','12:20:00',3.07),('16273','2013-10-13','12:25:00',3.07),('16273','2013-10-13','12:30:00',3.14),('16273','2013-10-13','12:35:00',3.12),('16273','2013-10-13','12:40:00',3.08),('16273','2013-10-13','12:45:00',3.05),('16273','2013-10-13','12:50:00',3.04),('16273','2013-10-13','12:55:00',3.01),('16273','2013-10-13','13:00:00',2.98),('16273','2013-10-13','13:05:00',3.02),('16273','2013-10-13','13:10:00',3.06),('16273','2013-10-13','13:15:00',3.03),('16273','2013-10-13','13:20:00',2.99),('16273','2013-10-13','13:25:00',2.74),('16273','2013-10-13','13:30:00',2.82),('16273','2013-10-13','13:35:00',2.73),('16273','2013-10-13','13:40:00',3.01),('16273','2013-10-13','13:45:00',2.86),('16273','2013-10-13','13:50:00',2.81),('16273','2013-10-13','13:55:00',1.78),('16273','2013-10-13','14:00:00',2.98),('16273','2013-10-13','14:05:00',2.76),('16273','2013-10-13','14:10:00',2.68),('16273','2013-10-13','14:15:00',2.93),('16273','2013-10-13','14:20:00',2.78),('16273','2013-10-13','14:25:00',2.6),('16273','2013-10-13','14:30:00',2),('16273','2013-10-13','14:35:00',2.33),('16273','2013-10-13','14:40:00',2.19),('16273','2013-10-13','14:45:00',2.02),('16273','2013-10-13','14:50:00',1.96),('16273','2013-10-13','14:55:00',1.97),('16273','2013-10-13','15:00:00',2.41),('16273','2013-10-13','15:05:00',1.97),('16273','2013-10-13','15:10:00',1.88),('16273','2013-10-13','15:15:00',1.84),('16273','2013-10-13','15:20:00',1.8),('16273','2013-10-13','15:25:00',1.58),('16273','2013-10-13','15:30:00',1.6),('16273','2013-10-13','15:35:00',1.36),('16273','2013-10-13','15:40:00',1.23),('16273','2013-10-13','15:45:00',1.24),('16273','2013-10-13','15:50:00',1.43),('16273','2013-10-13','15:55:00',1.49),('16273','2013-10-13','16:00:00',1.29),('16273','2013-10-13','16:05:00',1.34),('16273','2013-10-13','16:10:00',1.36),('16273','2013-10-13','16:15:00',1.54),('16273','2013-10-13','16:20:00',1.16),('16273','2013-10-13','16:25:00',1.2),('16273','2013-10-13','16:30:00',1.15),('16273','2013-10-13','16:35:00',1.05),('16273','2013-10-12','11:15:00',1),('16273','2013-10-12','11:20:00',1.16),('16273','2013-10-12','11:25:00',1.28),('16273','2013-10-12','11:30:00',2.07),('16273','2013-10-12','11:35:00',1.73),('16273','2013-10-12','11:40:00',1.47),('16273','2013-10-12','11:45:00',1.24),('16273','2013-10-12','12:10:00',1.1),('16273','2013-10-12','12:15:00',1.96),('16273','2013-10-12','12:20:00',2.93),('16273','2013-10-12','12:25:00',2.11),('16273','2013-10-12','12:30:00',2.31),('16273','2013-10-12','12:35:00',3.51),('16273','2013-10-12','12:40:00',3.12),('16273','2013-10-12','12:45:00',3),('16273','2013-10-12','12:50:00',2.6),('16273','2013-10-12','12:55:00',2.33),('16273','2013-10-12','13:00:00',1.43),('16273','2013-10-12','13:15:00',1.11),('16273','2013-10-12','13:20:00',1.41),('16273','2013-10-12','13:25:00',2.35),('16273','2013-10-12','16:10:00',1.03),('16273','2013-10-12','16:15:00',1.46),('16273','2013-10-12','16:20:00',1.29),('16273','2013-10-12','16:25:00',1.21),('16273','2013-10-11','08:25:00',1.13),('16273','2013-10-11','08:30:00',1.25),('16273','2013-10-11','08:35:00',1.44),('16273','2013-10-11','08:40:00',1.18),('16273','2013-10-11','08:45:00',1.63),('16273','2013-10-11','08:50:00',1.74),('16273','2013-10-11','08:55:00',1.77),('16273','2013-10-11','09:00:00',1.83),('16273','2013-10-11','09:05:00',1.91),('16273','2013-10-11','09:10:00',2.01),('16273','2013-10-11','09:15:00',2.1),('16273','2013-10-11','09:20:00',2.23),('16273','2013-10-11','09:25:00',2.3),('16273','2013-10-11','09:30:00',2.34),('16273','2013-10-11','09:35:00',2.41),('16273','2013-10-11','09:40:00',2.47),('16273','2013-10-11','09:45:00',2.52),('16273','2013-10-11','09:50:00',2.59),('16273','2013-10-11','09:55:00',2.65),('16273','2013-10-11','10:00:00',2.4),('16273','2013-10-11','10:05:00',2.24),('16273','2013-10-11','10:10:00',1.76),('16273','2013-10-11','10:15:00',2.28),('16273','2013-10-11','10:20:00',3.03),('16273','2013-10-11','10:25:00',2.67),('16273','2013-10-11','10:30:00',1.76),('16273','2013-10-11','10:35:00',1.5),('16273','2013-10-11','10:40:00',1.51),('16273','2013-10-11','10:45:00',2.72),('16273','2013-10-11','10:50:00',1.86),('16273','2013-10-11','10:55:00',2.86),('16273','2013-10-11','11:00:00',3.5),('16273','2013-10-11','11:05:00',1.3),('16273','2013-10-11','11:10:00',1.43),('16273','2013-10-11','11:15:00',1.25),('16273','2013-10-11','11:20:00',1.11),('16273','2013-10-11','11:25:00',1.12),('16273','2013-10-11','11:30:00',1.08),('16273','2013-10-11','11:40:00',2.11),('16273','2013-10-11','12:05:00',2.52),('16273','2013-10-11','12:10:00',3.55),('16273','2013-10-11','12:15:00',3.84),('16273','2013-10-11','12:20:00',2.33),('16273','2013-10-11','12:25:00',1.28),('16273','2013-10-11','12:50:00',1.61),('16273','2013-10-11','12:55:00',2.46),('16273','2013-10-11','13:00:00',1.55),('16273','2013-10-11','13:45:00',1.58),('16273','2013-10-11','13:50:00',1),('16273','2013-10-11','15:40:00',1.07),('16273','2013-10-11','16:30:00',1.22),('16273','2013-10-10','08:20:00',1.07),('16273','2013-10-10','08:25:00',1.2),('16273','2013-10-10','08:30:00',1.32),('16273','2013-10-10','08:35:00',1.26),('16273','2013-10-10','08:40:00',1.62),('16273','2013-10-10','08:45:00',1.67),('16273','2013-10-10','08:50:00',1.84),('16273','2013-10-10','08:55:00',1.88),('16273','2013-10-10','09:00:00',1.88),('16273','2013-10-10','09:05:00',2.01),('16273','2013-10-10','09:10:00',2.07),('16273','2013-10-10','09:15:00',2.13),('16273','2013-10-10','09:20:00',2.22),('16273','2013-10-10','09:25:00',2.26),('16273','2013-10-10','09:30:00',2.25),('16273','2013-10-10','09:35:00',2.29),('16273','2013-10-10','09:40:00',2.47),('16273','2013-10-10','09:45:00',2.48),('16273','2013-10-10','09:50:00',2.56),('16273','2013-10-10','09:55:00',1.79),('16273','2013-10-10','10:00:00',2.22),('16273','2013-10-10','10:05:00',2.8),('16273','2013-10-10','10:10:00',2.57),('16273','2013-10-10','10:15:00',1.08),('16273','2013-10-10','10:20:00',2.27),('16273','2013-10-10','10:25:00',2.21),('16273','2013-10-10','10:30:00',1.46),('16273','2013-10-10','10:35:00',1.37),('16273','2013-10-10','10:40:00',3.32),('16273','2013-10-10','10:45:00',1.65),('16273','2013-10-10','11:00:00',1.39),('16273','2013-10-10','11:10:00',1.3),('16273','2013-10-10','11:15:00',1.22),('16273','2013-10-10','11:20:00',3.04),('16273','2013-10-10','11:25:00',3.95),('16273','2013-10-10','11:30:00',3.02),('16273','2013-10-10','11:35:00',3.96),('16273','2013-10-10','11:40:00',3.96),('16273','2013-10-10','11:45:00',3.81),('16273','2013-10-10','11:50:00',4.09),('16273','2013-10-10','11:55:00',3.93),('16273','2013-10-10','12:00:00',3.76),('16273','2013-10-10','12:05:00',3.57),('16273','2013-10-10','12:10:00',2.77),('16273','2013-10-10','12:15:00',3.03),('16273','2013-10-10','12:20:00',2.41),('16273','2013-10-10','12:25:00',3.96),('16273','2013-10-10','12:30:00',3.95),('16273','2013-10-10','12:35:00',3.73),('16273','2013-10-10','12:40:00',3.6),('16273','2013-10-10','12:45:00',3.64),('16273','2013-10-10','12:50:00',3.6),('16273','2013-10-10','12:55:00',3.59),('16273','2013-10-10','13:00:00',3.47),('16273','2013-10-10','13:05:00',3.5),('16273','2013-10-10','13:10:00',3.33),('16273','2013-10-10','13:15:00',3.39),('16273','2013-10-10','13:20:00',3.47),('16273','2013-10-10','13:25:00',3.39),('16273','2013-10-10','13:30:00',2.96),('16273','2013-10-10','13:35:00',1.82),('16273','2013-10-10','13:40:00',2.35),('16273','2013-10-10','13:45:00',2.82),('16273','2013-10-10','13:50:00',1.63),('16273','2013-10-10','13:55:00',2.01),('16273','2013-10-10','14:00:00',3.44),('16273','2013-10-10','14:05:00',2.08),('16273','2013-10-10','14:10:00',1.71),('16273','2013-10-10','14:15:00',2.5),('16273','2013-10-10','14:20:00',2.43),('16273','2013-10-10','14:25:00',2.06),('16273','2013-10-10','14:30:00',1.22),('16273','2013-10-10','14:35:00',2.48),('16273','2013-10-10','14:40:00',1.75),('16273','2013-10-10','14:45:00',1.44),('16273','2013-10-10','14:50:00',1.29),('16273','2013-10-10','14:55:00',2.41),('16273','2013-10-10','15:00:00',1.83),('16273','2013-10-10','15:05:00',1.46),('16273','2013-10-10','15:10:00',1.59),('16273','2013-10-10','15:15:00',1.75),('16273','2013-10-10','15:20:00',2.04),('16273','2013-10-10','15:25:00',1.5),('16273','2013-10-10','15:30:00',1.2),('16273','2013-10-10','15:40:00',1.1),('16273','2013-10-10','15:45:00',1.06),('16273','2013-10-10','15:50:00',1.92),('16273','2013-10-10','15:55:00',1.6),('16273','2013-10-10','16:05:00',1.1),('16273','2013-10-10','16:10:00',1.32),('16273','2013-10-10','16:15:00',1.54),('16273','2013-10-10','16:20:00',1.39),('16273','2013-10-10','16:25:00',1.27),('16273','2013-10-10','16:30:00',1.11),('16273','2013-10-10','16:40:00',1.2),('16273','2013-10-10','16:45:00',1.05),('16273','2013-10-10','16:50:00',1.04),('16273','2013-10-09','08:30:00',1.38),('16273','2013-10-09','08:35:00',1.18),('16273','2013-10-09','08:40:00',1.58),('16273','2013-10-09','08:45:00',1.69),('16273','2013-10-09','08:50:00',1.79),('16273','2013-10-09','08:55:00',1.88),('16273','2013-10-09','09:00:00',1.96),('16273','2013-10-09','09:05:00',2.09),('16273','2013-10-09','09:10:00',2.12),('16273','2013-10-09','09:15:00',2.02),('16273','2013-10-09','09:20:00',2.4),('16273','2013-10-09','09:25:00',2.68),('16273','2013-10-09','09:30:00',2.92),('16273','2013-10-09','09:35:00',3.01),('16273','2013-10-09','09:40:00',3.05),('16273','2013-10-09','09:45:00',2.92),('16273','2013-10-09','09:50:00',3.07),('16273','2013-10-09','09:55:00',2.82),('16273','2013-10-09','10:00:00',1.4),('16273','2013-10-09','10:15:00',1.07),('16273','2013-10-09','10:20:00',1.91),('16273','2013-10-09','10:25:00',1.76),('16273','2013-10-09','10:35:00',3.21),('16273','2013-10-09','10:40:00',2.57),('16273','2013-10-09','10:50:00',1.35),('16273','2013-10-09','10:55:00',1.93),('16273','2013-10-09','11:00:00',1.53),('16273','2013-10-09','11:05:00',3.1),('16273','2013-10-09','11:10:00',2.11),('16273','2013-10-09','11:15:00',1.49),('16273','2013-10-09','11:25:00',1.02),('16273','2013-10-09','11:30:00',2.99),('16273','2013-10-09','11:35:00',1.48),('16273','2013-10-09','11:40:00',1.2),('16273','2013-10-09','11:45:00',1.24),('16273','2013-10-09','11:50:00',2.65),('16273','2013-10-09','11:55:00',3.7),('16273','2013-10-09','12:00:00',3.32),('16273','2013-10-09','12:05:00',1.26),('16273','2013-10-09','12:25:00',1.9),('16273','2013-10-09','12:30:00',1.82),('16273','2013-10-09','12:35:00',1.69),('16273','2013-10-09','12:40:00',1.32),('16273','2013-10-09','12:45:00',1.15),('16273','2013-10-09','12:50:00',1.26),('16273','2013-10-09','12:55:00',1.62),('16273','2013-10-09','13:00:00',1.9),('16273','2013-10-09','13:05:00',1.89),('16273','2013-10-09','13:10:00',2.14),('16273','2013-10-09','13:15:00',3.2),('16273','2013-10-09','13:20:00',1.88),('16273','2013-10-09','13:25:00',2.16),('16273','2013-10-09','13:30:00',2.14),('16273','2013-10-09','13:40:00',3.37),('16273','2013-10-09','13:45:00',3.45),('16273','2013-10-09','13:50:00',3.25),('16273','2013-10-09','13:55:00',3.36),('16273','2013-10-09','14:00:00',2.17),('16273','2013-10-09','14:05:00',3.17),('16273','2013-10-09','14:10:00',1.28),('16273','2013-10-09','14:15:00',1.36),('16273','2013-10-09','14:20:00',1.13),('16273','2013-10-09','14:25:00',1.28),('16273','2013-10-09','14:30:00',2.3),('16273','2013-10-09','14:35:00',3.24),('16273','2013-10-09','14:40:00',2.34),('16273','2013-10-09','14:45:00',2.25),('16273','2013-10-09','14:50:00',1.82),('16273','2013-10-09','14:55:00',3.05),('16273','2013-10-09','15:00:00',2.62),('16273','2013-10-09','15:05:00',2.38),('16273','2013-10-09','15:10:00',2.12),('16273','2013-10-09','15:15:00',1.36),('16273','2013-10-09','15:30:00',1.09),('16273','2013-10-09','15:40:00',1.33),('16273','2013-10-09','15:45:00',1.11),('16273','2013-10-09','16:05:00',1.19),('16273','2013-10-09','16:10:00',1.1),('16273','2013-10-09','16:20:00',1.41),('16273','2013-10-09','16:25:00',1.43),('16273','2013-10-09','16:50:00',1.08),('16273','2014-04-15','07:50:00',1.03),('16273','2014-04-15','08:50:00',1.89),('16273','2014-04-15','08:55:00',2.39),('16273','2014-04-15','09:00:00',2.13),('16273','2014-04-15','09:05:00',2.57),('16273','2014-04-15','09:10:00',3.04),('16273','2014-04-15','09:15:00',2.79),('16273','2014-04-15','09:20:00',2.15),('16273','2014-04-15','09:25:00',1.79),('16273','2014-04-15','09:55:00',2.38),('16273','2014-04-15','10:00:00',1.57),('16273','2014-04-15','10:10:00',1.89),('16273','2014-04-15','10:15:00',2.01),('16273','2014-04-15','10:20:00',2.22),('16273','2014-04-15','10:25:00',1.34),('16273','2014-04-15','10:30:00',1.61),('16273','2014-04-15','10:35:00',1.86),('16273','2014-04-15','10:40:00',1.75),('16273','2014-04-15','10:45:00',3.99),('16273','2014-04-15','10:50:00',2.38),('16273','2014-04-15','10:55:00',2.24),('16273','2014-04-15','11:00:00',3.8),('16273','2014-04-15','11:05:00',1.83),('16273','2014-04-15','11:20:00',1.12),('16273','2014-04-15','11:25:00',1.18),('16273','2014-04-15','11:35:00',1.08),('16273','2014-04-15','11:40:00',1.52),('16273','2014-04-15','11:45:00',1.15),('16273','2014-04-15','12:05:00',1.79),('16273','2014-04-15','12:10:00',2.11),('16273','2014-04-15','12:15:00',1.76),('16273','2014-04-15','12:55:00',1.11),('16273','2014-04-15','13:00:00',1.05),('16273','2014-04-15','13:05:00',1.17),('16273','2014-04-15','13:10:00',1.75),('16273','2014-04-15','13:15:00',1.14),('16273','2014-04-15','13:20:00',1.4),('16273','2014-04-15','13:25:00',1.62),('16273','2014-04-15','13:30:00',2.45),('16273','2014-04-15','13:35:00',1.53),('16273','2014-04-15','13:40:00',3.2),('16273','2014-04-15','13:45:00',2.62),('16273','2014-04-15','13:50:00',1.87),('16273','2014-04-15','13:55:00',2.73),('16273','2014-04-15','14:00:00',2.23),('16273','2014-04-15','14:05:00',1.93),('16273','2014-04-15','14:10:00',2.25),('16273','2014-04-15','14:15:00',3.99),('16273','2014-04-15','14:20:00',2.7),('16273','2014-04-15','14:25:00',2.7),('16273','2014-04-15','14:30:00',2.15),('16273','2014-04-15','14:35:00',1.74),('16273','2014-04-15','14:40:00',2.33),('16273','2014-04-15','14:45:00',2.08),('16273','2014-04-15','14:50:00',2.14),('16273','2014-04-15','14:55:00',2.44),('16273','2014-04-15','15:00:00',2.47),('16273','2014-04-15','15:05:00',2.59),('16273','2014-04-15','15:10:00',2.38),('16273','2014-04-15','15:15:00',3.18),('16273','2014-04-15','15:20:00',3.08),('16273','2014-04-15','15:25:00',2.94),('16273','2014-04-15','15:30:00',2.04),('16273','2014-04-15','15:35:00',2.22),('16273','2014-04-15','15:40:00',1.61),('16273','2014-04-15','15:45:00',1.26),('16273','2014-04-15','15:50:00',1.29),('16273','2014-04-15','15:55:00',1.27),('16273','2014-04-15','16:00:00',1.27),('16273','2014-04-15','16:05:00',1.17),('16273','2013-10-08','08:05:00',1.12),('16273','2013-10-08','09:40:00',1.79),('16273','2013-10-08','09:45:00',2.95),('16273','2013-10-08','09:50:00',2.89),('16273','2013-10-08','09:55:00',3.29),('16273','2013-10-08','10:00:00',2.75),('16273','2013-10-08','10:05:00',1.42),('16273','2013-10-08','12:35:00',1.24),('16273','2013-10-08','12:50:00',1.18),('16273','2013-10-08','12:55:00',1.15),('16273','2013-10-08','13:00:00',1.41),('16273','2013-10-08','13:05:00',2.63),('16273','2013-10-08','13:10:00',1.97),('16273','2013-10-08','13:15:00',1.87),('16273','2013-10-08','13:20:00',1.84),('16273','2013-10-08','13:25:00',2.45),('16273','2013-10-08','13:30:00',1.09),('16273','2013-10-08','13:40:00',1.42),('16273','2013-10-08','13:45:00',1.36),('16273','2013-10-08','14:20:00',1.3),('16273','2013-10-08','14:25:00',1.43),('16273','2013-10-08','14:30:00',2.99),('16273','2013-10-08','14:35:00',3.12),('16273','2013-10-08','14:40:00',2.52),('16273','2013-10-08','14:45:00',2.65),('16273','2013-10-08','14:50:00',2.69),('16273','2013-10-08','14:55:00',2.57),('16273','2013-10-08','15:00:00',2.52),('16273','2013-10-08','15:05:00',2.5),('16273','2013-10-08','15:10:00',2.26),('16273','2013-10-07','08:20:00',1.14),('16273','2013-10-07','08:25:00',1.24),('16273','2013-10-07','08:30:00',1.36),('16273','2013-10-07','08:35:00',1.25),('16273','2013-10-07','08:40:00',1.31),('16273','2013-10-07','08:45:00',1.18),('16273','2013-10-07','08:50:00',1.71),('16273','2013-10-07','09:10:00',1.92),('16273','2013-10-07','09:15:00',2.5),('16273','2013-10-07','09:20:00',2.15),('16273','2013-10-07','09:25:00',1.57),('16273','2013-10-07','09:30:00',2.76),('16273','2013-10-07','09:35:00',2.21),('16273','2013-10-07','09:40:00',2.66),('16273','2013-10-07','09:45:00',2.64),('16273','2013-10-07','09:50:00',2.64),('16273','2013-10-07','09:55:00',2.66),('16273','2013-10-07','10:00:00',2.7),('16273','2013-10-07','10:05:00',2.75),('16273','2013-10-07','10:10:00',2.81),('16273','2013-10-07','10:15:00',2.86),('16273','2013-10-07','10:20:00',2.9),('16273','2013-10-07','10:25:00',2.93),('16273','2013-10-07','10:30:00',2.98),('16273','2013-10-07','10:35:00',3.01),('16273','2013-10-07','10:40:00',3.05),('16273','2013-10-07','10:45:00',3.1),('16273','2013-10-07','10:50:00',3.05),('16273','2013-10-07','10:55:00',3.12),('16273','2013-10-07','11:00:00',3.15),('16273','2013-10-07','11:05:00',3.23),('16273','2013-10-07','11:10:00',2.58),('16273','2013-10-07','11:15:00',3.28),('16273','2013-10-07','11:20:00',3.1),('16273','2013-10-07','11:25:00',3.32),('16273','2013-10-07','11:30:00',2.08),('16273','2013-10-07','11:35:00',2.87),('16273','2013-10-07','11:40:00',3.08),('16273','2013-10-07','11:45:00',3.55),('16273','2013-10-07','11:50:00',3.03),('16273','2013-10-07','11:55:00',2.68),('16273','2013-10-07','12:00:00',1.46),('16273','2013-10-07','12:05:00',3.01),('16273','2013-10-07','12:10:00',3.03),('16273','2013-10-07','12:20:00',1.92),('16273','2013-10-07','12:25:00',4.11),('16273','2013-10-07','12:30:00',3.92),('16273','2013-10-07','12:35:00',1.17),('16273','2013-10-07','12:40:00',1.09),('16273','2013-10-07','12:45:00',2.35),('16273','2013-10-07','12:50:00',4.24),('16273','2013-10-07','12:55:00',2.67),('16273','2013-10-07','13:00:00',3.29),('16273','2013-10-07','13:05:00',2.1),('16273','2013-10-07','13:10:00',2.18),('16273','2013-10-07','13:20:00',2.21),('16273','2013-10-07','13:35:00',1.52),('16273','2013-10-07','13:40:00',1.22),('16273','2013-10-07','13:45:00',3.19),('16273','2013-10-07','13:50:00',1.79),('16273','2013-10-07','13:55:00',1.14),('16273','2013-10-07','14:00:00',2.73),('16273','2013-10-07','14:05:00',3.56),('16273','2013-10-07','14:10:00',2.62),('16273','2013-10-07','14:15:00',1.94),('16273','2013-10-07','14:20:00',3.46),('16273','2013-10-07','14:25:00',2.46),('16273','2013-10-07','14:30:00',2.68),('16273','2013-10-07','14:35:00',3.25),('16273','2013-10-07','14:40:00',1.46),('16273','2013-10-07','14:45:00',2.74),('16273','2013-10-07','14:50:00',1.26),('16273','2013-10-07','14:55:00',2.82),('16273','2013-10-07','15:00:00',2.87),('16273','2013-10-07','15:05:00',2.22),('16273','2013-10-07','15:10:00',1.42),('16273','2013-10-07','15:25:00',1.61),('16273','2013-10-07','15:30:00',2),('16273','2013-10-07','15:35:00',1.61),('16273','2013-10-07','15:40:00',2.18),('16273','2013-10-07','15:50:00',2.06),('16273','2013-10-07','15:55:00',1.92),('16273','2013-10-07','16:00:00',1.59),('16273','2013-10-07','16:05:00',1.42),('16273','2013-10-07','16:15:00',1.59),('16273','2013-10-07','16:25:00',1.48),('16273','2013-10-07','16:30:00',1.3),('16273','2013-10-07','16:35:00',1.19),('16273','2013-10-07','16:40:00',1.11),('16273','2013-10-07','16:45:00',1.03),('16273','2013-10-06','09:05:00',1.56),('16273','2013-10-06','09:25:00',1.98),('16273','2013-10-06','09:30:00',2.41),('16273','2013-10-06','09:35:00',2.33),('16273','2013-10-06','09:40:00',1.99),('16273','2013-10-06','09:45:00',1.89),('16273','2013-10-06','09:50:00',2.58),('16273','2013-10-06','09:55:00',2.71),('16273','2013-10-06','10:00:00',2.78),('16273','2013-10-06','10:05:00',1.85),('16273','2013-10-06','10:10:00',2.41),('16273','2013-10-06','10:15:00',2.35),('16273','2013-10-06','10:20:00',2.56),('16273','2013-10-06','10:25:00',1.98),('16273','2013-10-06','10:30:00',2.55),('16273','2013-10-06','10:35:00',2.34),('16273','2013-10-06','10:40:00',1.79),('16273','2013-10-06','10:45:00',1.88),('16273','2013-10-06','10:50:00',2.4),('16273','2013-10-06','10:55:00',2.89),('16273','2013-10-06','11:00:00',2.89),('16273','2013-10-06','11:05:00',2.89),('16273','2013-10-06','11:10:00',2.96),('16273','2013-10-06','11:15:00',2.95),('16273','2013-10-06','11:20:00',2.86),('16273','2013-10-06','11:25:00',2.77),('16273','2013-10-06','11:30:00',1.86),('16273','2013-10-06','11:35:00',1.41),('16273','2013-10-06','11:40:00',1.96),('16273','2013-10-06','11:45:00',2.45),('16273','2013-10-06','11:50:00',2.71),('16273','2013-10-06','11:55:00',2.67),('16273','2013-10-06','12:00:00',2.91),('16273','2013-10-06','12:05:00',3.21),('16273','2013-10-06','12:10:00',3.26),('16273','2013-10-06','12:15:00',2.57),('16273','2013-10-06','12:20:00',1.91),('16273','2013-10-06','12:25:00',1.95),('16273','2013-10-06','12:30:00',3.21),('16273','2013-10-06','12:35:00',2.83),('16273','2013-10-06','12:40:00',1.79),('16273','2013-10-06','12:45:00',1.86),('16273','2013-10-06','12:50:00',1.31),('16273','2013-10-06','12:55:00',1.84),('16273','2013-10-06','13:00:00',1.76),('16273','2013-10-06','13:05:00',2.06),('16273','2013-10-06','13:10:00',3.06),('16273','2013-10-06','13:15:00',1.38),('16273','2013-10-06','13:20:00',1.07),('16273','2013-10-06','13:25:00',1.16),('16273','2013-10-06','13:30:00',1.19),('16273','2013-10-06','13:35:00',1.06),('16273','2013-10-06','13:40:00',1.83),('16273','2013-10-06','13:45:00',1.75),('16273','2013-10-06','13:50:00',1.39),('16273','2013-10-06','13:55:00',1.18),('16273','2013-10-06','14:00:00',1.93),('16273','2013-10-06','14:05:00',1.7),('16273','2013-10-06','14:10:00',1.16),('16273','2013-10-06','14:15:00',1.43),('16273','2013-10-06','14:20:00',2.58),('16273','2013-10-06','14:25:00',2.57),('16273','2013-10-06','14:30:00',2.13),('16273','2013-10-06','14:35:00',2.25),('16273','2013-10-06','14:40:00',2.03),('16273','2013-10-06','14:45:00',1.82),('16273','2013-10-06','14:50:00',1.93),('16273','2013-10-06','14:55:00',2.01),('16273','2013-10-06','15:00:00',1.85),('16273','2013-10-06','15:05:00',1.47),('16273','2013-10-06','15:10:00',1.12),('16273','2013-10-06','15:15:00',1.02),('16273','2013-10-06','15:45:00',1.03),('16273','2013-10-05','15:55:00',1.01),('16273','2013-10-05','16:00:00',1.15),('16273','2013-10-05','16:05:00',1.07),('16273','2013-10-05','16:10:00',1),('16273','2013-10-04','08:40:00',1.37),('16273','2013-10-04','09:10:00',1.96),('16273','2013-10-04','09:15:00',1.53),('16273','2013-10-04','09:20:00',1.57),('16273','2013-10-04','09:25:00',1.95),('16273','2013-10-04','09:30:00',1.19),('16273','2013-10-04','09:35:00',1.1),('16273','2013-10-04','09:40:00',1.25),('16273','2013-10-04','09:45:00',1.32),('16273','2013-10-04','09:50:00',1.17),('16273','2013-10-04','09:55:00',1.1),('16273','2013-10-04','10:00:00',1.27),('16273','2013-10-04','10:05:00',1.58),('16273','2013-10-04','10:10:00',1.55),('16273','2013-10-04','10:15:00',1.5),('16273','2013-10-04','10:20:00',1.62),('16273','2013-10-04','10:25:00',1.98),('16273','2013-10-04','10:30:00',2.13),('16273','2013-10-04','10:35:00',2.99),('16273','2013-10-04','10:40:00',3.27),('16273','2013-10-04','10:45:00',2.73),('16273','2013-10-04','10:50:00',1.84),('16273','2013-10-04','10:55:00',1.76),('16273','2013-10-04','11:00:00',2.73),('16273','2013-10-04','11:05:00',2.07),('16273','2013-10-04','11:10:00',2.27),('16273','2013-10-04','11:15:00',3.04),('16273','2013-10-04','11:20:00',3.52),('16273','2013-10-04','11:25:00',3.18),('16273','2013-10-04','11:30:00',2.63),('16273','2013-10-04','11:35:00',2.43),('16273','2013-10-04','11:40:00',3.24),('16273','2013-10-04','11:45:00',3.41),('16273','2013-10-04','11:50:00',3.4),('16273','2013-10-04','11:55:00',3.4),('16273','2013-10-04','12:00:00',3.43),('16273','2013-10-04','12:05:00',3.48),('16273','2013-10-04','12:10:00',3.46),('16273','2013-10-04','12:15:00',3.44),('16273','2013-10-04','12:20:00',3.39),('16273','2013-10-04','12:25:00',3.42),('16273','2013-10-04','12:30:00',3.43),('16273','2013-10-04','12:35:00',3.39),('16273','2013-10-04','12:40:00',3.34),('16273','2013-10-04','12:45:00',3.29),('16273','2013-10-04','12:50:00',3.21),('16273','2013-10-04','12:55:00',3.3),('16273','2013-10-04','13:00:00',3.26),('16273','2013-10-04','13:05:00',3.23),('16273','2013-10-04','13:10:00',3.29),('16273','2013-10-04','13:15:00',3.24),('16273','2013-10-04','13:20:00',3.16),('16273','2013-10-04','13:25:00',3.12),('16273','2013-10-04','13:30:00',3.08),('16273','2013-10-04','13:35:00',3.09),('16273','2013-10-04','13:40:00',3.06),('16273','2013-10-04','13:45:00',2.98),('16273','2013-10-04','13:50:00',3.02),('16273','2013-10-04','13:55:00',2.97),('16273','2013-10-04','14:00:00',2.94),('16273','2013-10-04','14:05:00',2.83),('16273','2013-10-04','14:10:00',2.66),('16273','2013-10-04','14:15:00',2.6),('16273','2013-10-04','14:20:00',2.67),('16273','2013-10-04','14:25:00',1.91),('16273','2013-10-04','14:30:00',1.85),('16273','2013-10-04','14:35:00',1.56),('16273','2013-10-04','14:40:00',1.76),('16273','2013-10-04','14:45:00',2.17),('16273','2013-10-04','14:50:00',1.74),('16273','2013-10-04','14:55:00',2.12),('16273','2013-10-04','15:00:00',2.03),('16273','2013-10-04','15:05:00',1.86),('16273','2013-10-04','15:10:00',1.76),('16273','2013-10-04','15:15:00',1.44),('16273','2013-10-04','15:20:00',1.41),('16273','2013-10-04','15:25:00',1.52),('16273','2013-10-04','15:30:00',1.35),('16273','2013-10-04','15:35:00',1.23),('16273','2013-10-04','15:40:00',1.03),('16273','2013-10-04','15:55:00',1.15),('16273','2013-10-03','08:25:00',1.03),('16273','2013-10-03','08:30:00',1.46),('16273','2013-10-03','08:35:00',1.67),('16273','2013-10-03','08:40:00',1.49),('16273','2013-10-03','08:45:00',1.88),('16273','2013-10-03','08:50:00',1.97),('16273','2013-10-03','08:55:00',2.06),('16273','2013-10-03','09:00:00',1.64),('16273','2013-10-03','09:05:00',2.23),('16273','2013-10-03','09:10:00',2.31),('16273','2013-10-03','09:15:00',2.37),('16273','2013-10-03','09:20:00',1.83),('16273','2013-10-03','09:25:00',2.51),('16273','2013-10-03','09:30:00',2.58),('16273','2013-10-03','09:35:00',2.65),('16273','2013-10-03','09:40:00',2.02),('16273','2013-10-03','09:45:00',2.63),('16273','2013-10-03','09:50:00',2.85),('16273','2013-10-03','09:55:00',2.92),('16273','2013-10-03','10:00:00',2.94),('16273','2013-10-03','10:05:00',3.03),('16273','2013-10-03','10:10:00',3.08),('16273','2013-10-03','10:15:00',3.13),('16273','2013-10-03','10:20:00',3.19),('16273','2013-10-03','10:25:00',3.24),('16273','2013-10-03','10:30:00',3.27),('16273','2013-10-03','10:35:00',3.31),('16273','2013-10-03','10:40:00',3.34),('16273','2013-10-03','10:45:00',3.37),('16273','2013-10-03','10:50:00',3.42),('16273','2013-10-03','10:55:00',3.45),('16273','2013-10-03','11:00:00',3.46),('16273','2013-10-03','11:05:00',3.48),('16273','2013-10-03','11:10:00',3.49),('16273','2013-10-03','11:15:00',3.48),('16273','2013-10-03','11:20:00',3.54),('16273','2013-10-03','11:25:00',3.55),('16273','2013-10-03','11:30:00',3.57),('16273','2013-10-03','11:35:00',3.61),('16273','2013-10-03','11:40:00',3.58),('16273','2013-10-03','11:45:00',3.62),('16273','2013-10-03','11:50:00',3.64),('16273','2013-10-03','11:55:00',3.65),('16273','2013-10-03','12:00:00',3.66),('16273','2013-10-03','12:05:00',3.66),('16273','2013-10-03','12:10:00',3.66),('16273','2013-10-03','12:15:00',3.66),('16273','2013-10-03','12:20:00',3.65),('16273','2013-10-03','12:25:00',3.65),('16273','2013-10-03','12:30:00',3.64),('16273','2013-10-03','12:35:00',3.62),('16273','2013-10-03','12:40:00',3.63),('16273','2013-10-03','12:45:00',3.61),('16273','2013-10-03','12:50:00',3.61),('16273','2013-10-03','12:55:00',3.58),('16273','2013-10-03','13:00:00',3.53),('16273','2013-10-03','13:05:00',3.51),('16273','2013-10-03','13:10:00',3.53),('16273','2013-10-03','13:15:00',3.51),('16273','2013-10-03','13:20:00',3.5),('16273','2013-10-03','13:25:00',3.48),('16273','2013-10-03','13:30:00',3.45),('16273','2013-10-03','13:35:00',3.4),('16273','2013-10-03','13:40:00',3.37),('16273','2013-10-03','13:45:00',3.33),('16273','2013-10-03','13:50:00',3.28),('16273','2013-10-03','13:55:00',3.26),('16273','2013-10-03','14:00:00',3.23),('16273','2013-10-03','14:05:00',3.19),('16273','2013-10-03','14:10:00',3.14),('16273','2013-10-03','14:15:00',3.09),('16273','2013-10-03','14:20:00',3.01),('16273','2013-10-03','14:25:00',2.98),('16273','2013-10-03','14:30:00',2.94),('16273','2013-10-03','14:35:00',2.88),('16273','2013-10-03','14:40:00',2.83),('16273','2013-10-03','14:45:00',2.77),('16273','2013-10-03','14:50:00',2.7),('16273','2013-10-03','14:55:00',2.64),('16273','2013-10-03','15:00:00',2.58),('16273','2013-10-03','15:05:00',2.52),('16273','2013-10-03','15:10:00',2.46),('16273','2013-10-03','15:15:00',2.4),('16273','2013-10-03','15:20:00',2.33),('16273','2013-10-03','15:25:00',2.26),('16273','2013-10-03','15:30:00',2.2),('16273','2013-10-03','15:35:00',2.12),('16273','2013-10-03','15:40:00',2.06),('16273','2013-10-03','15:45:00',1.98),('16273','2013-10-03','15:50:00',1.92),('16273','2013-10-03','15:55:00',1.85),('16273','2013-10-03','16:00:00',1.77),('16273','2013-10-03','16:05:00',1.69),('16273','2013-10-03','16:10:00',1.62),('16273','2013-10-03','16:15:00',1.54),('16273','2013-10-03','16:20:00',1.47),('16273','2013-10-03','16:25:00',1.4),('16273','2013-10-03','16:30:00',1.32),('16273','2013-10-03','16:35:00',1.25),('16273','2013-10-03','16:40:00',1.18),('16273','2013-10-03','16:45:00',1.11),('16273','2013-10-03','16:50:00',1.04),('16273','2013-10-02','08:20:00',1.09),('16273','2013-10-02','08:30:00',1.22),('16273','2013-10-02','08:35:00',1.54),('16273','2013-10-02','08:40:00',1.64),('16273','2013-10-02','08:45:00',1.74),('16273','2013-10-02','08:50:00',1.83),('16273','2013-10-02','08:55:00',1.91),('16273','2013-10-02','09:00:00',1.98),('16273','2013-10-02','09:05:00',2.05),('16273','2013-10-02','09:10:00',2.14),('16273','2013-10-02','09:15:00',2.23),('16273','2013-10-02','09:20:00',2.32),('16273','2013-10-02','09:25:00',2.4),('16273','2013-10-02','09:30:00',2.46),('16273','2013-10-02','09:35:00',2.53),('16273','2013-10-02','09:40:00',2.6),('16273','2013-10-02','09:45:00',2.66),('16273','2013-10-02','09:50:00',2.73),('16273','2013-10-02','09:55:00',2.79),('16273','2013-10-02','10:00:00',2.84),('16273','2013-10-02','10:05:00',2.88),('16273','2013-10-02','10:10:00',2.93),('16273','2013-10-02','10:15:00',2.97),('16273','2013-10-02','10:20:00',3.03),('16273','2013-10-02','10:25:00',3.09),('16273','2013-10-02','10:30:00',3.13),('16273','2013-10-02','10:35:00',3.17),('16273','2013-10-02','10:40:00',3.21),('16273','2013-10-02','10:45:00',3.24),('16273','2013-10-02','10:50:00',3.26),('16273','2013-10-02','10:55:00',3.28),('16273','2013-10-02','11:00:00',3.3),('16273','2013-10-02','11:05:00',3.32),('16273','2013-10-02','11:10:00',3.34),('16273','2013-10-02','11:15:00',3.35),('16273','2013-10-02','11:20:00',3.37),('16273','2013-10-02','11:25:00',3.39),('16273','2013-10-02','11:30:00',3.41),('16273','2013-10-02','11:35:00',3.43),('16273','2013-10-02','11:40:00',3.44),('16273','2013-10-02','11:45:00',3.45),('16273','2013-10-02','11:50:00',3.45),('16273','2013-10-02','11:55:00',3.47),('16273','2013-10-02','12:00:00',3.47),('16273','2013-10-02','12:05:00',3.45),('16273','2013-10-02','12:10:00',3.47),('16273','2013-10-02','12:15:00',3.48),('16273','2013-10-02','12:20:00',3.48),('16273','2013-10-02','12:25:00',3.48),('16273','2013-10-02','12:30:00',3.47),('16273','2013-10-02','12:35:00',3.47),('16273','2013-10-02','12:40:00',3.48),('16273','2013-10-02','12:45:00',3.44),('16273','2013-10-02','12:50:00',3.45),('16273','2013-10-02','12:55:00',3.45),('16273','2013-10-02','13:00:00',3.45),('16273','2013-10-02','13:05:00',3.43),('16273','2013-10-02','13:10:00',3.4),('16273','2013-10-02','13:15:00',3.37),('16273','2013-10-02','13:20:00',3.36),('16273','2013-10-02','13:25:00',3.32),('16273','2013-10-02','13:30:00',3.3),('16273','2013-10-02','13:35:00',3.26),('16273','2013-10-02','13:40:00',3.23),('16273','2013-10-02','13:45:00',3.18),('16273','2013-10-02','13:50:00',3.14),('16273','2013-10-02','13:55:00',3.11),('16273','2013-10-02','14:00:00',3.06),('16273','2013-10-02','14:05:00',3.04),('16273','2013-10-02','14:10:00',3),('16273','2013-10-02','14:15:00',2.97),('16273','2013-10-02','14:20:00',2.9),('16273','2013-10-02','14:25:00',2.87),('16273','2013-10-02','14:30:00',2.78),('16273','2013-10-02','14:35:00',2.78),('16273','2013-10-02','14:40:00',2.7),('16273','2013-10-02','14:45:00',2.67),('16273','2013-10-02','14:50:00',2.62),('16273','2013-10-02','14:55:00',2.56),('16273','2013-10-02','15:00:00',2.49),('16273','2013-10-02','15:05:00',2.44),('16273','2013-10-02','15:10:00',2.39),('16273','2013-10-02','15:15:00',2.31),('16273','2013-10-02','15:20:00',2.26),('16273','2013-10-02','15:25:00',2.2),('16273','2013-10-02','15:30:00',2.13),('16273','2013-10-02','15:35:00',2.07),('16273','2013-10-02','15:40:00',2),('16273','2013-10-02','15:45:00',1.91),('16273','2013-10-02','15:50:00',1.85),('16273','2013-10-02','15:55:00',1.78),('16273','2013-10-02','16:00:00',1.71),('16273','2013-10-02','16:05:00',1.65),('16273','2013-10-02','16:10:00',1.58),('16273','2013-10-02','16:15:00',1.51),('16273','2013-10-02','16:20:00',1.44),('16273','2013-10-02','16:25:00',1.37),('16273','2013-10-02','16:30:00',1.3),('16273','2013-10-02','16:35:00',1.22),('16273','2013-10-02','16:40:00',1.15),('16273','2013-10-02','16:45:00',1.09),('16273','2013-10-02','16:50:00',1.02),('16273','2013-10-01','08:10:00',1.05),('16273','2013-10-01','08:15:00',1.13),('16273','2013-10-01','08:20:00',1.22),('16273','2013-10-01','08:25:00',1.32),('16273','2013-10-01','08:30:00',1.23),('16273','2013-10-01','08:35:00',1.57),('16273','2013-10-01','08:40:00',1.66),('16273','2013-10-01','08:45:00',1.76),('16273','2013-10-01','08:50:00',1.85),('16273','2013-10-01','08:55:00',1.93),('16273','2013-10-01','09:00:00',2),('16273','2013-10-01','09:05:00',2.09),('16273','2013-10-01','09:10:00',2.14),('16273','2013-10-01','09:15:00',2.21),('16273','2013-10-01','09:20:00',2.26),('16273','2013-10-01','09:25:00',2.32),('16273','2013-10-01','09:30:00',2.34),('16273','2013-10-01','09:35:00',2.46),('16273','2013-10-01','09:40:00',2.51),('16273','2013-10-01','09:45:00',2.54),('16273','2013-10-01','09:50:00',2.62),('16273','2013-10-01','09:55:00',2.68),('16273','2013-10-01','10:00:00',2.76),('16273','2013-10-01','10:05:00',2.75),('16273','2013-10-01','10:10:00',2.78),('16273','2013-10-01','10:15:00',1.75),('16273','2013-10-01','10:20:00',3.01),('16273','2013-10-01','10:25:00',3),('16273','2013-10-01','10:30:00',3),('16273','2013-10-01','10:35:00',3.1),('16273','2013-10-01','10:40:00',3.01),('16273','2013-10-01','10:45:00',3.13),('16273','2013-10-01','10:50:00',3.13),('16273','2013-10-01','10:55:00',1.28),('16273','2013-10-01','11:00:00',3.32),('16273','2013-10-01','11:05:00',3.32),('16273','2013-10-01','11:10:00',3.33),('16273','2013-10-01','11:15:00',3.4),('16273','2013-10-01','11:20:00',3.48),('16273','2013-10-01','11:25:00',3.5),('16273','2013-10-01','11:30:00',3.48),('16273','2013-10-01','11:35:00',3.47),('16273','2013-10-01','11:40:00',3.49),('16273','2013-10-01','11:45:00',3.52),('16273','2013-10-01','11:50:00',3.57),('16273','2013-10-01','11:55:00',3.75),('16273','2013-10-01','12:00:00',3.32),('16273','2013-10-01','12:05:00',2.97),('16273','2013-10-01','12:10:00',3.54),('16273','2013-10-01','12:15:00',3.6),('16273','2013-10-01','12:20:00',3.65),('16273','2013-10-01','12:25:00',2.95),('16273','2013-10-01','12:30:00',2.61),('16273','2013-10-01','12:35:00',2.65),('16273','2013-10-01','12:40:00',2.82),('16273','2013-10-01','12:45:00',3.59),('16273','2013-10-01','12:50:00',2.2),('16273','2013-10-01','12:55:00',1.62),('16273','2013-10-01','13:00:00',3.77),('16273','2013-10-01','13:05:00',3.58),('16273','2013-10-01','13:10:00',3.5),('16273','2013-10-01','13:15:00',3.44),('16273','2013-10-01','13:20:00',3.3),('16273','2013-10-01','13:25:00',3.29),('16273','2013-10-01','13:30:00',3.29),('16273','2013-10-01','13:35:00',3.22),('16273','2013-10-01','13:40:00',3.18),('16273','2013-10-01','13:45:00',3.19),('16273','2013-10-01','13:50:00',3.12),('16273','2013-10-01','13:55:00',3.09),('16273','2013-10-01','14:00:00',3.03),('16273','2013-10-01','14:05:00',3.01),('16273','2013-10-01','14:10:00',2.99),('16273','2013-10-01','14:15:00',2.94),('16273','2013-10-01','14:20:00',2.9),('16273','2013-10-01','14:25:00',2.85),('16273','2013-10-01','14:30:00',2.81),('16273','2013-10-01','14:35:00',2.78),('16273','2013-10-01','14:40:00',2.75),('16273','2013-10-01','14:45:00',2.7),('16273','2013-10-01','14:50:00',2.65),('16273','2013-10-01','14:55:00',2.6),('16273','2013-10-01','15:00:00',2.55),('16273','2013-10-01','15:05:00',2.48),('16273','2013-10-01','15:10:00',2.43),('16273','2013-10-01','15:15:00',2.38),('16273','2013-10-01','15:20:00',2.31),('16273','2013-10-01','15:25:00',2.24),('16273','2013-10-01','15:30:00',2.19),('16273','2013-10-01','15:35:00',2.12),('16273','2013-10-01','15:40:00',2.04),('16273','2013-10-01','15:45:00',1.96),('16273','2013-10-01','15:50:00',1.88),('16273','2013-10-01','15:55:00',1.81),('16273','2013-10-01','16:00:00',1.74),('16273','2013-10-01','16:05:00',1.67),('16273','2013-10-01','16:10:00',1.6),('16273','2013-10-01','16:15:00',1.53),('16273','2013-10-01','16:20:00',1.44),('16273','2013-10-01','16:25:00',1.39),('16273','2013-10-01','16:30:00',1.31),('16273','2013-10-01','16:35:00',1.25),('16273','2013-10-01','16:40:00',1.18),('16273','2013-10-01','16:45:00',1.11),('16273','2013-10-01','16:50:00',1.03),('16273','2013-09-30','09:35:00',1.18),('16273','2013-09-30','09:40:00',1.7),('16273','2013-09-30','09:45:00',2.01),('16273','2013-09-30','09:50:00',1.03),('16273','2013-09-30','10:05:00',1),('16273','2013-09-30','10:10:00',1.08),('16273','2013-09-30','10:15:00',1.09),('16273','2013-09-30','10:20:00',1.27),('16273','2013-09-30','10:25:00',1.4),('16273','2013-09-30','10:30:00',1.71),('16273','2013-09-30','10:35:00',2.05),('16273','2013-09-30','10:40:00',3.21),('16273','2013-09-30','10:45:00',3.03),('16273','2013-09-30','10:50:00',2.9),('16273','2013-09-30','10:55:00',2.76),('16273','2013-09-30','11:00:00',3.27),('16273','2013-09-30','11:05:00',3.37),('16273','2013-09-30','11:10:00',3.43),('16273','2013-09-30','11:15:00',2.96),('16273','2013-09-30','11:20:00',2.56),('16273','2013-09-30','11:25:00',2.34),('16273','2013-09-30','11:30:00',3.41),('16273','2013-09-30','11:35:00',1.75),('16273','2013-09-30','11:45:00',1.21),('16273','2013-09-30','11:50:00',2.86),('16273','2013-09-30','11:55:00',3.7),('16273','2013-09-30','12:00:00',3.99),('16273','2013-09-30','12:05:00',3.77),('16273','2013-09-30','12:10:00',3.63),('16273','2013-09-30','12:15:00',3.52),('16273','2013-09-30','12:20:00',3.53),('16273','2013-09-30','12:25:00',3.52),('16273','2013-09-30','12:30:00',3.54),('16273','2013-09-30','12:35:00',3.63),('16273','2013-09-30','12:40:00',3.58),('16273','2013-09-30','12:45:00',3.42),('16273','2013-09-30','12:50:00',3.55),('16273','2013-09-30','12:55:00',3.54),('16273','2013-09-30','13:00:00',3.26),('16273','2013-09-30','13:05:00',3.23),('16273','2013-09-30','13:10:00',2.02),('16273','2013-09-30','13:15:00',3.19),('16273','2013-09-30','13:20:00',3.47),('16273','2013-09-30','13:25:00',3.13),('16273','2013-09-30','13:30:00',2.77),('16273','2013-09-30','13:35:00',3.3),('16273','2013-09-30','13:40:00',3),('16273','2013-09-30','13:55:00',1.02),('16273','2013-09-30','14:00:00',1.14),('16273','2013-09-30','14:05:00',1.25),('16273','2013-09-30','14:10:00',1.08),('16273','2013-09-30','14:20:00',1.08),('16273','2013-09-30','14:25:00',2.85),('16273','2013-09-30','14:30:00',3.47),('16273','2013-09-30','14:35:00',3.73),('16273','2013-09-30','14:40:00',2.39),('16273','2013-09-30','14:45:00',2.53),('16273','2013-09-30','14:50:00',1.51),('16273','2013-09-30','15:00:00',1.56),('16273','2013-09-30','15:05:00',2.78),('16273','2013-09-30','15:10:00',1.19),('16273','2013-09-30','15:15:00',1.26),('16273','2013-09-30','15:20:00',1.8),('16273','2013-09-30','15:25:00',2.02),('16273','2013-09-30','15:30:00',2.72),('16273','2013-09-30','15:35:00',1.42),('16273','2013-09-30','16:00:00',1.98),('16273','2013-09-30','16:05:00',1.93),('16273','2013-09-30','16:20:00',1.02),('16273','2013-09-30','16:30:00',1.49),('16273','2013-09-30','16:35:00',1.04),('16273','2013-09-30','16:40:00',1.54),('16273','2013-09-30','16:45:00',1.39),('16273','2013-09-30','16:50:00',1.31),('16273','2013-09-30','17:10:00',1.13),('16273','2013-09-30','17:15:00',1.02),('16273','2013-09-29','08:40:00',1.02),('16273','2013-09-29','09:50:00',1.08),('16273','2013-09-29','09:55:00',1.45),('16273','2013-09-29','10:00:00',1.92),('16273','2013-09-29','10:05:00',2.02),('16273','2013-09-29','10:10:00',2.53),('16273','2013-09-29','10:15:00',1.93),('16273','2013-09-29','10:20:00',2.22),('16273','2013-09-29','10:25:00',2.45),('16273','2013-09-29','10:30:00',2.67),('16273','2013-09-29','10:35:00',2.74),('16273','2013-09-29','10:40:00',2.75),('16273','2013-09-29','10:45:00',2.87),('16273','2013-09-29','10:50:00',2.85),('16273','2013-09-29','10:55:00',2.88),('16273','2013-09-29','11:00:00',2.77),('16273','2013-09-29','11:05:00',2.62),('16273','2013-09-29','11:10:00',2.79),('16273','2013-09-29','11:15:00',2.83),('16273','2013-09-29','11:20:00',2.65),('16273','2013-09-29','11:25:00',2.88),('16273','2013-09-29','11:30:00',2.91),('16273','2013-09-29','11:35:00',3.03),('16273','2013-09-29','11:40:00',3.17),('16273','2013-09-29','11:45:00',2.19),('16273','2013-09-29','11:50:00',1.88),('16273','2013-09-29','11:55:00',3.06),('16273','2013-09-29','12:00:00',3.21),('16273','2013-09-29','12:05:00',3.28),('16273','2013-09-29','12:10:00',2.37),('16273','2013-09-29','12:15:00',1.21),('16273','2013-09-29','12:25:00',1.08),('16273','2013-09-29','12:30:00',1.38),('16273','2013-09-29','12:35:00',1.58),('16273','2013-09-29','12:40:00',1.19),('16273','2013-09-29','12:45:00',1.17),('16273','2013-09-29','12:50:00',1.29),('16273','2013-09-29','13:20:00',1.15),('16273','2013-09-29','13:25:00',2.73),('16273','2013-09-29','13:30:00',2.42),('16273','2013-09-29','13:35:00',2.09),('16273','2013-09-29','13:40:00',2.3),('16273','2013-09-29','13:45:00',2.4),('16273','2013-09-29','13:50:00',2.6),('16273','2013-09-29','13:55:00',1.36),('16273','2013-09-29','14:05:00',1.13),('16273','2013-09-29','14:15:00',1.13),('16273','2013-09-29','14:20:00',1.17),('16273','2013-09-29','14:45:00',1.03),('16273','2013-09-29','14:50:00',1.41),('16273','2013-09-29','15:15:00',1.21),('16273','2013-09-29','15:25:00',1.17),('16273','2013-09-29','15:55:00',1.07),('16273','2013-09-29','16:25:00',1.32),('16273','2013-09-29','16:30:00',1.18),('16273','2014-04-14','07:45:00',1.08),('16273','2014-04-14','07:50:00',1.05),('16273','2014-04-14','07:55:00',1.3),('16273','2014-04-14','08:00:00',1.42),('16273','2014-04-14','08:05:00',1.51),('16273','2014-04-14','08:10:00',1.6),('16273','2014-04-14','08:15:00',1.7),('16273','2014-04-14','08:20:00',1.79),('16273','2014-04-14','08:25:00',1.88),('16273','2014-04-14','08:30:00',1.97),('16273','2014-04-14','08:35:00',2.04),('16273','2014-04-14','08:40:00',2.09),('16273','2014-04-14','08:45:00',2.17),('16273','2014-04-14','08:50:00',2.25),('16273','2014-04-14','08:55:00',2.33),('16273','2014-04-14','09:00:00',2.4),('16273','2014-04-14','09:05:00',2.48),('16273','2014-04-14','09:10:00',2.54),('16273','2014-04-14','09:15:00',2.61),('16273','2014-04-14','09:20:00',2.68),('16273','2014-04-14','09:25:00',2.75),('16273','2014-04-14','09:30:00',2.81),('16273','2014-04-14','09:35:00',2.87),('16273','2014-04-14','09:40:00',2.93),('16273','2014-04-14','09:45:00',2.99),('16273','2014-04-14','09:50:00',3.04),('16273','2014-04-14','09:55:00',3.08),('16273','2014-04-14','10:00:00',3.16),('16273','2014-04-14','10:05:00',3.21),('16273','2014-04-14','10:10:00',3.24),('16273','2014-04-14','10:15:00',3.29),('16273','2014-04-14','10:20:00',3.34),('16273','2014-04-14','10:25:00',3.37),('16273','2014-04-14','10:30:00',3.41),('16273','2014-04-14','10:35:00',3.45),('16273','2014-04-14','10:40:00',3.49),('16273','2014-04-14','10:45:00',3.53),('16273','2014-04-14','10:50:00',3.56),('16273','2014-04-14','10:55:00',3.6),('16273','2014-04-14','11:00:00',3.61),('16273','2014-04-14','11:05:00',3.63),('16273','2014-04-14','11:10:00',3.67),('16273','2014-04-14','11:15:00',3.68),('16273','2014-04-14','11:20:00',3.69),('16273','2014-04-14','11:25:00',3.71),('16273','2014-04-14','11:30:00',3.75),('16273','2014-04-14','11:35:00',3.78),('16273','2014-04-14','11:40:00',3.79),('16273','2014-04-14','11:45:00',3.8),('16273','2014-04-14','11:50:00',3.78),('16273','2014-04-14','11:55:00',3.82),('16273','2014-04-14','12:00:00',3.83),('16273','2014-04-14','12:05:00',3.83),('16273','2014-04-14','12:10:00',3.83),('16273','2014-04-14','12:15:00',3.84),('16273','2014-04-14','12:20:00',3.86),('16273','2014-04-14','12:25:00',3.85),('16273','2014-04-14','12:30:00',3.86),('16273','2014-04-14','12:35:00',3.83),('16273','2014-04-14','12:40:00',3.85),('16273','2014-04-14','12:45:00',3.86),('16273','2014-04-14','12:50:00',3.86),('16273','2014-04-14','12:55:00',3.86),('16273','2014-04-14','13:00:00',3.86),('16273','2014-04-14','13:05:00',3.86),('16273','2014-04-14','13:10:00',3.86),('16273','2014-04-14','13:15:00',3.84),('16273','2014-04-14','13:20:00',3.81),('16273','2014-04-14','13:25:00',3.8),('16273','2014-04-14','13:30:00',3.79),('16273','2014-04-14','13:35:00',3.78),('16273','2014-04-14','13:40:00',3.75),('16273','2014-04-14','13:45:00',3.74),('16273','2014-04-14','13:50:00',3.72),('16273','2014-04-14','13:55:00',3.7),('16273','2014-04-14','14:00:00',3.67),('16273','2014-04-14','14:05:00',3.64),('16273','2014-04-14','14:10:00',3.6),('16273','2014-04-14','14:15:00',3.57),('16273','2014-04-14','14:20:00',3.53),('16273','2014-04-14','14:25:00',3.49),('16273','2014-04-14','14:30:00',3.45),('16273','2014-04-14','14:35:00',3.41),('16273','2014-04-14','14:40:00',3.37),('16273','2014-04-14','14:45:00',3.33),('16273','2014-04-14','14:50:00',3.28),('16273','2014-04-14','14:55:00',3.23),('16273','2014-04-14','15:00:00',3.18),('16273','2014-04-14','15:05:00',3.14),('16273','2014-04-14','15:10:00',3.09),('16273','2014-04-14','15:15:00',3.03),('16273','2014-04-14','15:20:00',2.98),('16273','2014-04-14','15:25:00',2.92),('16273','2014-04-14','15:30:00',2.85),('16273','2014-04-14','15:35:00',2.79),('16273','2014-04-14','15:40:00',2.73),('16273','2014-04-14','15:45:00',2.67),('16273','2014-04-14','15:50:00',2.59),('16273','2014-04-14','15:55:00',2.52),('16273','2014-04-14','16:00:00',2.44),('16273','2014-04-14','16:05:00',2.38),('16273','2014-04-14','16:10:00',2.32),('16273','2014-04-14','16:15:00',2.24),('16273','2014-04-14','16:20:00',2.17),('16273','2014-04-14','16:25:00',2.08),('16273','2014-04-14','16:30:00',2),('16273','2014-04-14','16:35:00',1.93),('16273','2014-04-14','16:40:00',1.85),('16273','2014-04-14','16:45:00',1.77),('16273','2014-04-14','16:50:00',1.69),('16273','2014-04-14','16:55:00',1.61),('16273','2014-04-14','17:00:00',1.52),('16273','2014-04-14','17:05:00',1.45),('16273','2014-04-14','17:10:00',1.37),('16273','2014-04-14','17:15:00',1.29),('16273','2014-04-14','17:20:00',1.22),('16273','2014-04-14','17:25:00',1.15),('16273','2014-04-14','17:30:00',1.07),('16273','2014-04-14','17:35:00',1),('16273','2013-09-28','08:25:00',1.14),('16273','2013-09-28','08:30:00',1.3),('16273','2013-09-28','08:35:00',1.43),('16273','2013-09-28','08:40:00',1.53),('16273','2013-09-28','08:45:00',1.59),('16273','2013-09-28','08:50:00',1.67),('16273','2013-09-28','08:55:00',1.16),('16273','2013-09-28','09:00:00',1.03),('16273','2013-09-28','09:05:00',1.95),('16273','2013-09-28','09:10:00',1.84),('16273','2013-09-28','09:15:00',2.02),('16273','2013-09-28','09:20:00',2.34),('16273','2013-09-28','09:25:00',2.08),('16273','2013-09-28','09:30:00',2.49),('16273','2013-09-28','09:35:00',2.62),('16273','2013-09-28','09:40:00',2.67),('16273','2013-09-28','09:45:00',2),('16273','2013-09-28','09:50:00',2.82),('16273','2013-09-28','09:55:00',2.52),('16273','2013-09-28','10:00:00',1),('16273','2013-09-28','10:20:00',1.08),('16273','2013-09-28','10:25:00',1.43),('16273','2013-09-28','10:30:00',3.21),('16273','2013-09-28','10:35:00',3.29),('16273','2013-09-28','10:40:00',3.37),('16273','2013-09-28','10:45:00',3.39),('16273','2013-09-28','11:00:00',3.04),('16273','2013-09-28','11:05:00',2.23),('16273','2013-09-28','11:10:00',1.9),('16273','2013-09-28','11:15:00',3.43),('16273','2013-09-28','11:20:00',3.42),('16273','2013-09-28','11:25:00',3.37),('16273','2013-09-28','11:30:00',3),('16273','2013-09-28','11:35:00',1.12),('16273','2013-09-28','11:40:00',1.69),('16273','2013-09-28','11:45:00',2.49),('16273','2013-09-28','11:50:00',2.41),('16273','2013-09-28','11:55:00',1.94),('16273','2013-09-28','12:00:00',2.78),('16273','2013-09-28','12:05:00',3.57),('16273','2013-09-28','12:10:00',2.86),('16273','2013-09-28','12:20:00',3.53),('16273','2013-09-28','12:30:00',1.37),('16273','2013-09-28','12:35:00',3.07),('16273','2013-09-28','12:40:00',2.96),('16273','2013-09-28','12:45:00',3.29),('16273','2013-09-28','12:50:00',3.6),('16273','2013-09-28','12:55:00',3.46),('16273','2013-09-28','13:00:00',2.55),('16273','2013-09-28','13:05:00',1.8),('16273','2013-09-28','13:10:00',1.89),('16273','2013-09-28','13:15:00',2.89),('16273','2013-09-28','13:20:00',3.29),('16273','2013-09-28','13:25:00',3.35),('16273','2013-09-28','13:30:00',3.33),('16273','2013-09-28','13:35:00',3.11),('16273','2013-09-28','13:40:00',2.76),('16273','2013-09-28','13:45:00',2.66),('16273','2013-09-28','13:50:00',3.39),('16273','2013-09-28','13:55:00',3.18),('16273','2013-09-28','14:00:00',2.85),('16273','2013-09-28','14:05:00',3.09),('16273','2013-09-28','14:10:00',3.07),('16273','2013-09-28','14:15:00',1.55),('16273','2013-09-28','14:20:00',1.3),('16273','2013-09-28','14:25:00',1.08),('16273','2013-09-28','14:30:00',2.53),('16273','2013-09-28','14:35:00',2.49),('16273','2013-09-28','14:40:00',3.05),('16273','2013-09-28','14:45:00',1.43),('16273','2013-09-28','14:50:00',1.84),('16273','2013-09-28','14:55:00',1.44),('16273','2013-09-28','15:05:00',2.21),('16273','2013-09-28','15:10:00',1.58),('16273','2013-09-28','15:15:00',2.37),('16273','2013-09-28','15:20:00',2.24),('16273','2013-09-28','15:25:00',1.89),('16273','2013-09-28','15:30:00',2.3),('16273','2013-09-28','15:35:00',2.16),('16273','2013-09-28','15:40:00',2.03),('16273','2013-09-28','15:45:00',1.97),('16273','2013-09-28','15:50:00',1.9),('16273','2013-09-28','15:55:00',1.8),('16273','2013-09-28','16:00:00',1.76),('16273','2013-09-28','16:05:00',1.65),('16273','2013-09-28','16:10:00',1.62),('16273','2013-09-28','16:15:00',1.28),('16273','2013-09-28','16:20:00',1.3),('16273','2013-09-28','16:25:00',1.29),('16273','2013-09-28','16:30:00',1.33),('16273','2013-09-28','16:35:00',1.27),('16273','2013-09-28','16:40:00',1.18),('16273','2013-09-28','16:45:00',1.12),('16273','2013-09-28','16:50:00',1.06),('16273','2013-09-27','08:25:00',1.32),('16273','2013-09-27','08:30:00',1.1),('16273','2013-09-27','08:35:00',1.33),('16273','2013-09-27','08:40:00',1.22),('16273','2013-09-27','08:45:00',1.35),('16273','2013-09-27','08:50:00',1.34),('16273','2013-09-27','08:55:00',1.66),('16273','2013-09-27','09:00:00',1.47),('16273','2013-09-27','09:05:00',1.86),('16273','2013-09-27','09:10:00',1.14),('16273','2013-09-27','09:15:00',1.09),('16273','2013-09-27','09:20:00',1.06),('16273','2013-09-27','10:00:00',1.3),('16273','2013-09-27','10:05:00',1.87),('16273','2013-09-27','10:10:00',1.22),('16273','2013-09-27','10:15:00',1.14),('16273','2013-09-27','10:20:00',1.22),('16273','2013-09-27','10:35:00',1.59),('16273','2013-09-27','10:40:00',2.15),('16273','2013-09-27','10:45:00',1.99),('16273','2013-09-27','10:50:00',3.17),('16273','2013-09-27','10:55:00',3.21),('16273','2013-09-27','11:00:00',3.21),('16273','2013-09-27','11:05:00',3.21),('16273','2013-09-27','11:10:00',3.12),('16273','2013-09-27','11:15:00',3.1),('16273','2013-09-27','11:20:00',2.71),('16273','2013-09-27','11:25:00',1.59),('16273','2013-09-27','11:30:00',1.38),('16273','2013-09-27','11:35:00',1.01),('16273','2013-09-27','12:15:00',1.15),('16273','2013-09-27','12:20:00',2.6),('16273','2013-09-27','12:25:00',3.73),('16273','2013-09-27','12:30:00',3.31),('16273','2013-09-27','12:35:00',3.62),('16273','2013-09-27','12:40:00',2.6),('16273','2013-09-27','12:45:00',3.71),('16273','2013-09-27','12:50:00',1.12),('16273','2013-09-27','13:05:00',2.32),('16273','2013-09-27','13:10:00',2.35),('16273','2013-09-27','13:25:00',2.3),('16273','2013-09-27','13:30:00',1.4),('16273','2013-09-27','13:35:00',2.53),('16273','2013-09-27','13:40:00',2.28),('16273','2013-09-27','13:45:00',2.45),('16273','2013-09-27','13:50:00',2.03),('16273','2013-09-27','13:55:00',1.32),('16273','2013-09-27','14:00:00',3.05),('16273','2013-09-27','14:05:00',2.54),('16273','2013-09-27','14:10:00',3.12),('16273','2013-09-27','14:15:00',2.96),('16273','2013-09-27','14:20:00',2.95),('16273','2013-09-27','14:25:00',1.44),('16273','2013-09-27','14:30:00',2.1),('16273','2013-09-27','14:35:00',3.06),('16273','2013-09-27','14:40:00',2.9),('16273','2013-09-27','14:45:00',2.14),('16273','2013-09-27','14:50:00',2.83),('16273','2013-09-27','14:55:00',2.74),('16273','2013-09-27','15:00:00',2.66),('16273','2013-09-27','15:05:00',2.51),('16273','2013-09-27','15:10:00',1.11),('16273','2013-09-27','15:15:00',1.7),('16273','2013-09-27','15:20:00',2.44),('16273','2013-09-27','15:25:00',1.34),('16273','2013-09-27','15:30:00',1.97),('16273','2013-09-27','15:35:00',1),('16273','2013-09-27','15:40:00',2.27),('16273','2013-09-27','15:45:00',1.77),('16273','2013-09-27','15:50:00',2.07),('16273','2013-09-27','15:55:00',1.62),('16273','2013-09-27','16:00:00',1.99),('16273','2013-09-27','16:05:00',1.64),('16273','2013-09-27','16:10:00',1.67),('16273','2013-09-27','16:25:00',1.55),('16273','2013-09-27','16:30:00',1.42),('16273','2013-09-27','16:35:00',1.32),('16273','2013-09-27','16:45:00',1.2),('16273','2013-09-27','16:50:00',1.06),('16273','2013-09-27','16:55:00',1.06),('16273','2013-09-26','08:10:00',1.09),('16273','2013-09-26','08:15:00',1.18),('16273','2013-09-26','08:20:00',1.3),('16273','2013-09-26','08:25:00',1.21),('16273','2013-09-26','08:30:00',1.5),('16273','2013-09-26','08:35:00',1.6),('16273','2013-09-26','08:40:00',1.69),('16273','2013-09-26','08:45:00',1.78),('16273','2013-09-26','08:50:00',1.88),('16273','2013-09-26','08:55:00',1.95),('16273','2013-09-26','09:00:00',1.58),('16273','2013-09-26','09:05:00',2.13),('16273','2013-09-26','09:10:00',2.14),('16273','2013-09-26','09:15:00',2.18),('16273','2013-09-26','09:20:00',2.24),('16273','2013-09-26','09:25:00',2.34),('16273','2013-09-26','09:30:00',2.39),('16273','2013-09-26','09:35:00',2.46),('16273','2013-09-26','09:40:00',2.51),('16273','2013-09-26','09:45:00',2.61),('16273','2013-09-26','09:50:00',2.63),('16273','2013-09-26','09:55:00',2.75),('16273','2013-09-26','10:00:00',2.74),('16273','2013-09-26','10:05:00',2.72),('16273','2013-09-26','10:10:00',2.75),('16273','2013-09-26','10:15:00',2.79),('16273','2013-09-26','10:20:00',2.81),('16273','2013-09-26','10:25:00',2.93),('16273','2013-09-26','10:30:00',2.94),('16273','2013-09-26','10:35:00',3.01),('16273','2013-09-26','10:40:00',2.99),('16273','2013-09-26','10:45:00',3.02),('16273','2013-09-26','10:50:00',3.06),('16273','2013-09-26','10:55:00',3.09),('16273','2013-09-26','11:00:00',3.12),('16273','2013-09-26','11:05:00',2.89),('16273','2013-09-26','11:10:00',3.17),('16273','2013-09-26','11:15:00',3.18),('16273','2013-09-26','11:20:00',3.31),('16273','2013-09-26','11:25:00',3.4),('16273','2013-09-26','11:30:00',1.87),('16273','2013-09-26','11:40:00',2.1),('16273','2013-09-26','11:45:00',3.44),('16273','2013-09-26','11:50:00',3.53),('16273','2013-09-26','11:55:00',1.99),('16273','2013-09-26','12:00:00',2.31),('16273','2013-09-26','12:05:00',2.07),('16273','2013-09-26','12:10:00',1.57),('16273','2013-09-26','12:15:00',1.57),('16273','2013-09-26','12:20:00',1.54),('16273','2013-09-26','12:25:00',1.42),('16273','2013-09-26','12:30:00',1.44),('16273','2013-09-26','12:35:00',1.4),('16273','2013-09-26','12:40:00',1.56),('16273','2013-09-26','12:45:00',1.36),('16273','2013-09-26','12:50:00',2.57),('16273','2013-09-26','12:55:00',1.84),('16273','2013-09-26','13:00:00',1.98),('16273','2013-09-26','13:05:00',1.68),('16273','2013-09-26','13:10:00',1.35),('16273','2013-09-26','13:15:00',1.43),('16273','2013-09-26','13:20:00',2.12),('16273','2013-09-26','13:25:00',3.95),('16273','2013-09-26','13:30:00',2.53),('16273','2013-09-26','13:35:00',3.29),('16273','2013-09-26','13:40:00',3.2),('16273','2013-09-26','13:45:00',3.06),('16273','2013-09-26','13:50:00',2.32),('16273','2013-09-26','13:55:00',2.74),('16273','2013-09-26','14:00:00',3.27),('16273','2013-09-26','14:05:00',2.06),('16273','2013-09-26','14:10:00',2.63),('16273','2013-09-26','14:15:00',3.23),('16273','2013-09-26','14:20:00',3.12),('16273','2013-09-26','14:25:00',2.98),('16273','2013-09-26','14:30:00',2.93),('16273','2013-09-26','14:35:00',2.88),('16273','2013-09-26','14:40:00',2.82),('16273','2013-09-26','14:45:00',2.38),('16273','2013-09-26','14:50:00',1.56),('16273','2013-09-26','14:55:00',2.36),('16273','2013-09-26','15:00:00',2.78),('16273','2013-09-26','15:05:00',2.45),('16273','2013-09-26','15:15:00',1.05),('16273','2013-09-26','15:20:00',2.66),('16273','2013-09-26','15:25:00',2.43),('16273','2013-09-26','15:30:00',2.29),('16273','2013-09-26','15:35:00',2.29),('16273','2013-09-26','15:40:00',2.23),('16273','2013-09-26','15:45:00',2.12),('16273','2013-09-26','15:50:00',2.02),('16273','2013-09-26','15:55:00',1.96),('16273','2013-09-26','16:00:00',1.91),('16273','2013-09-26','16:05:00',1.8),('16273','2013-09-26','16:10:00',1.72),('16273','2013-09-26','16:15:00',1.58),('16273','2013-09-26','16:20:00',1.53),('16273','2013-09-26','16:25:00',1.46),('16273','2013-09-26','16:30:00',1.32),('16273','2013-09-26','16:35:00',1.3),('16273','2013-09-26','16:40:00',1.22),('16273','2013-09-26','16:45:00',1.14),('16273','2013-09-26','16:50:00',1.08),('16273','2013-09-26','16:55:00',1.03),('16273','2013-09-25','08:00:00',1),('16273','2013-09-25','08:15:00',1.24),('16273','2013-09-25','08:20:00',1.31),('16273','2013-09-25','08:25:00',1.26),('16273','2013-09-25','08:30:00',1.09),('16273','2013-09-25','08:35:00',1.42),('16273','2013-09-25','08:40:00',1.68),('16273','2013-09-25','08:45:00',1.4),('16273','2013-09-25','08:50:00',1.02),('16273','2013-09-25','08:55:00',1.74),('16273','2013-09-25','09:05:00',1.23),('16273','2013-09-25','09:10:00',1.68),('16273','2013-09-25','09:15:00',1.44),('16273','2013-09-25','10:15:00',1.03),('16273','2013-09-25','10:30:00',3.04),('16273','2013-09-25','10:35:00',3.23),('16273','2013-09-25','10:40:00',3.21),('16273','2013-09-25','10:45:00',3.35),('16273','2013-09-25','10:50:00',3.45),('16273','2013-09-25','10:55:00',1.89),('16273','2013-09-25','11:10:00',1.33),('16273','2013-09-25','11:15:00',3.64),('16273','2013-09-25','11:20:00',3.53),('16273','2013-09-25','11:25:00',3.52),('16273','2013-09-25','11:30:00',3.53),('16273','2013-09-25','11:35:00',1.64),('16273','2013-09-25','11:40:00',3.98),('16273','2013-09-25','11:45:00',3.21),('16273','2013-09-25','11:50:00',1.36),('16273','2013-09-25','11:55:00',1.09),('16273','2013-09-25','12:00:00',2.33),('16273','2013-09-25','12:05:00',1.79),('16273','2013-09-25','12:15:00',1.02),('16273','2013-09-25','12:20:00',3.44),('16273','2013-09-25','12:25:00',3.59),('16273','2013-09-25','12:30:00',3.39),('16273','2013-09-25','12:35:00',2.73),('16273','2013-09-25','12:40:00',1.2),('16273','2013-09-25','12:50:00',1.45),('16273','2013-09-25','12:55:00',4.04),('16273','2013-09-25','13:00:00',4.03),('16273','2013-09-25','13:05:00',2.93),('16273','2013-09-25','13:10:00',3.39),('16273','2013-09-25','13:15:00',3.67),('16273','2013-09-25','13:20:00',3.64),('16273','2013-09-25','13:25:00',3.7),('16273','2013-09-25','13:30:00',3.66),('16273','2013-09-25','13:35:00',3.54),('16273','2013-09-25','13:40:00',3.58),('16273','2013-09-25','13:45:00',3.5),('16273','2013-09-25','13:50:00',3.53),('16273','2013-09-25','13:55:00',3.46),('16273','2013-09-25','14:00:00',3.4),('16273','2013-09-25','14:05:00',3.44),('16273','2013-09-25','14:10:00',3.36),('16273','2013-09-25','14:15:00',3.21),('16273','2013-09-25','14:20:00',3.04),('16273','2013-09-25','14:25:00',2.91),('16273','2013-09-25','14:30:00',1.89),('16273','2013-09-25','14:35:00',1.14),('16273','2013-09-25','14:40:00',3.18),('16273','2013-09-25','14:45:00',1.76),('16273','2013-09-25','14:50:00',1.11),('16273','2013-09-25','14:55:00',1.19),('16273','2013-09-25','15:00:00',2.36),('16273','2013-09-25','15:05:00',2.75),('16273','2013-09-25','15:10:00',1.75),('16273','2013-09-25','15:15:00',1.75),('16273','2013-09-25','15:20:00',2.61),('16273','2013-09-25','15:25:00',2.47),('16273','2013-09-25','15:30:00',1.64),('16273','2013-09-25','15:35:00',1.66),('16273','2013-09-25','15:40:00',2.03),('16273','2013-09-25','15:45:00',2.14),('16273','2013-09-25','15:50:00',1.67),('16273','2013-09-25','15:55:00',2.16),('16273','2013-09-25','16:00:00',2.06),('16273','2013-09-25','16:05:00',1.7),('16273','2013-09-25','16:10:00',1.85),('16273','2013-09-25','16:15:00',1.2),('16273','2013-09-25','16:20:00',1.69),('16273','2013-09-25','16:25:00',1.57),('16273','2013-09-25','16:30:00',1.48),('16273','2013-09-25','16:35:00',1.4),('16273','2013-09-25','16:40:00',1.33),('16273','2013-09-25','16:45:00',1.25),('16273','2013-09-25','16:50:00',1.17),('16273','2013-09-25','16:55:00',1.1),('16273','2013-09-25','17:00:00',1.04),('16273','2013-09-24','08:05:00',1.04),('16273','2013-09-24','08:10:00',1.17),('16273','2013-09-24','08:15:00',1.15),('16273','2013-09-24','08:20:00',1.36),('16273','2013-09-24','08:25:00',1.5),('16273','2013-09-24','08:30:00',1.62),('16273','2013-09-24','08:35:00',1.72),('16273','2013-09-24','08:40:00',1.8),('16273','2013-09-24','08:45:00',1.88),('16273','2013-09-24','08:50:00',1.99),('16273','2013-09-24','08:55:00',2.08),('16273','2013-09-24','09:00:00',2.17),('16273','2013-09-24','09:05:00',2.25),('16273','2013-09-24','09:10:00',2.31),('16273','2013-09-24','09:15:00',2.39),('16273','2013-09-24','09:20:00',2.46),('16273','2013-09-24','09:25:00',2.52),('16273','2013-09-24','09:30:00',2.57),('16273','2013-09-24','09:35:00',2.64),('16273','2013-09-24','09:40:00',2.67),('16273','2013-09-24','09:45:00',2.72),('16273','2013-09-24','09:50:00',2.78),('16273','2013-09-24','09:55:00',2.83),('16273','2013-09-24','10:00:00',2.88),('16273','2013-09-24','10:05:00',2.93),('16273','2013-09-24','10:10:00',2.98),('16273','2013-09-24','10:15:00',3.03),('16273','2013-09-24','10:20:00',3.04),('16273','2013-09-24','10:25:00',3.09),('16273','2013-09-24','10:30:00',3.11),('16273','2013-09-24','10:35:00',3.16),('16273','2013-09-24','10:40:00',3.2),('16273','2013-09-24','10:45:00',3.24),('16273','2013-09-24','10:50:00',3.26),('16273','2013-09-24','10:55:00',3.3),('16273','2013-09-24','11:00:00',3.32),('16273','2013-09-24','11:05:00',3.37),('16273','2013-09-24','11:10:00',3.38),('16273','2013-09-24','11:15:00',3.37),('16273','2013-09-24','11:20:00',3.43),('16273','2013-09-24','11:25:00',3.43),('16273','2013-09-24','11:30:00',3.46),('16273','2013-09-24','11:35:00',3.46),('16273','2013-09-24','11:40:00',3.49),('16273','2013-09-24','11:45:00',3.49),('16273','2013-09-24','11:50:00',3.5),('16273','2013-09-24','11:55:00',3.51),('16273','2013-09-24','12:00:00',3.52),('16273','2013-09-24','12:05:00',3.48),('16273','2013-09-24','12:10:00',3.51),('16273','2013-09-24','12:15:00',3.52),('16273','2013-09-24','12:20:00',3.54),('16273','2013-09-24','12:25:00',3.54),('16273','2013-09-24','12:30:00',3.55),('16273','2013-09-24','12:35:00',3.52),('16273','2013-09-24','12:40:00',3.54),('16273','2013-09-24','12:45:00',3.51),('16273','2013-09-24','12:50:00',3.51),('16273','2013-09-24','12:55:00',3.48),('16273','2013-09-24','13:00:00',3.48),('16273','2013-09-24','13:05:00',3.45),('16273','2013-09-24','13:10:00',3.44),('16273','2013-09-24','13:15:00',3.41),('16273','2013-09-24','13:20:00',3.43),('16273','2013-09-24','13:25:00',3.38),('16273','2013-09-24','13:30:00',3.37),('16273','2013-09-24','13:35:00',3.37),('16273','2013-09-24','13:40:00',3.34),('16273','2013-09-24','13:45:00',3.32),('16273','2013-09-24','13:50:00',3.29),('16273','2013-09-24','13:55:00',3.28),('16273','2013-09-24','14:00:00',3.24),('16273','2013-09-24','14:05:00',3.22),('16273','2013-09-24','14:10:00',3.15),('16273','2013-09-24','14:15:00',3.12),('16273','2013-09-24','14:20:00',3.08),('16273','2013-09-24','14:25:00',3.04),('16273','2013-09-24','14:30:00',3.01),('16273','2013-09-24','14:35:00',2.95),('16273','2013-09-24','14:40:00',2.91),('16273','2013-09-24','14:45:00',2.86),('16273','2013-09-24','14:50:00',2.81),('16273','2013-09-24','14:55:00',2.74),('16273','2013-09-24','15:00:00',2.7),('16273','2013-09-24','15:05:00',2.66),('16273','2013-09-24','15:10:00',2.57),('16273','2013-09-24','15:15:00',2.53),('16273','2013-09-24','15:20:00',2.47),('16273','2013-09-24','15:25:00',2.42),('16273','2013-09-24','15:30:00',2.36),('16273','2013-09-24','15:35:00',2.3),('16273','2013-09-24','15:40:00',2.23),('16273','2013-09-24','15:45:00',2.14),('16273','2013-09-24','15:50:00',2.08),('16273','2013-09-24','15:55:00',2.01),('16273','2013-09-24','16:00:00',1.93),('16273','2013-09-24','16:05:00',1.83),('16273','2013-09-24','16:10:00',1.77),('16273','2013-09-24','16:15:00',1.67),('16273','2013-09-24','16:20:00',1.63),('16273','2013-09-24','16:25:00',1.53),('16273','2013-09-24','16:30:00',1.46),('16273','2013-09-24','16:35:00',1.41),('16273','2013-09-24','16:40:00',1.34),('16273','2013-09-24','16:45:00',1.27),('16273','2013-09-24','16:50:00',1.19),('16273','2013-09-24','16:55:00',1.12),('16273','2013-09-24','17:00:00',1.05),('16273','2013-09-23','08:00:00',1.02),('16273','2013-09-23','08:05:00',1.14),('16273','2013-09-23','08:10:00',1.25),('16273','2013-09-23','08:15:00',1.15),('16273','2013-09-23','08:20:00',1.49),('16273','2013-09-23','08:25:00',1.61),('16273','2013-09-23','08:30:00',1.71),('16273','2013-09-23','08:35:00',1.81),('16273','2013-09-23','08:40:00',1.9),('16273','2013-09-23','08:45:00',1.99),('16273','2013-09-23','08:50:00',2.06),('16273','2013-09-23','08:55:00',2.14),('16273','2013-09-23','09:00:00',2.22),('16273','2013-09-23','09:05:00',2.29),('16273','2013-09-23','09:10:00',2.36),('16273','2013-09-23','09:15:00',2.43),('16273','2013-09-23','09:20:00',2.5),('16273','2013-09-23','09:25:00',2.57),('16273','2013-09-23','09:30:00',2.62),('16273','2013-09-23','09:35:00',2.68),('16273','2013-09-23','09:40:00',2.75),('16273','2013-09-23','09:45:00',2.81),('16273','2013-09-23','09:50:00',2.86),('16273','2013-09-23','09:55:00',2.92),('16273','2013-09-23','10:00:00',2.97),('16273','2013-09-23','10:05:00',3.02),('16273','2013-09-23','10:10:00',3.07),('16273','2013-09-23','10:15:00',3.11),('16273','2013-09-23','10:20:00',3.15),('16273','2013-09-23','10:25:00',3.2),('16273','2013-09-23','10:30:00',3.22),('16273','2013-09-23','10:35:00',3.24),('16273','2013-09-23','10:40:00',3.27),('16273','2013-09-23','10:45:00',3.29),('16273','2013-09-23','10:50:00',3.32),('16273','2013-09-23','10:55:00',3.34),('16273','2013-09-23','11:00:00',3.39),('16273','2013-09-23','11:05:00',3.41),('16273','2013-09-23','11:10:00',3.46),('16273','2013-09-23','11:15:00',3.49),('16273','2013-09-23','11:20:00',3.52),('16273','2013-09-23','11:25:00',3.54),('16273','2013-09-23','11:30:00',3.54),('16273','2013-09-23','11:35:00',3.59),('16273','2013-09-23','11:40:00',3.59),('16273','2013-09-23','11:45:00',3.61),('16273','2013-09-23','11:50:00',3.64),('16273','2013-09-23','11:55:00',3.62),('16273','2013-09-23','12:00:00',3.58),('16273','2013-09-23','12:05:00',3.6),('16273','2013-09-23','12:10:00',3.65),('16273','2013-09-23','12:15:00',3.68),('16273','2013-09-23','12:20:00',3.66),('16273','2013-09-23','12:25:00',3.66),('16273','2013-09-23','12:30:00',3.64),('16273','2013-09-23','12:35:00',3.62),('16273','2013-09-23','12:40:00',3.61),('16273','2013-09-23','12:45:00',3.63),('16273','2013-09-23','12:50:00',3.6),('16273','2013-09-23','12:55:00',3.54),('16273','2013-09-23','13:00:00',3.52),('16273','2013-09-23','13:05:00',3.44),('16273','2013-09-23','13:10:00',3.48),('16273','2013-09-23','13:15:00',3.47),('16273','2013-09-23','13:20:00',3.44),('16273','2013-09-23','13:25:00',3.42),('16273','2013-09-23','13:30:00',3.4),('16273','2013-09-23','13:35:00',3.36),('16273','2013-09-23','13:40:00',3.31),('16273','2013-09-23','13:45:00',3.28),('16273','2013-09-23','13:50:00',3.24),('16273','2013-09-23','13:55:00',3.2),('16273','2013-09-23','14:00:00',3.19),('16273','2013-09-23','14:05:00',3.15),('16273','2013-09-23','14:10:00',3.09),('16273','2013-09-23','14:15:00',3.06),('16273','2013-09-23','14:20:00',3.03),('16273','2013-09-23','14:25:00',2.98),('16273','2013-09-23','14:30:00',2.93),('16273','2013-09-23','14:35:00',2.91),('16273','2013-09-23','14:40:00',2.83),('16273','2013-09-23','14:45:00',2.77),('16273','2013-09-23','14:50:00',2.73),('16273','2013-09-23','14:55:00',2.65),('16273','2013-09-23','15:00:00',2.64),('16273','2013-09-23','15:05:00',2.61),('16273','2013-09-23','15:10:00',2.55),('16273','2013-09-23','15:15:00',2.49),('16273','2013-09-23','15:20:00',2.41),('16273','2013-09-23','15:25:00',2.36),('16273','2013-09-23','15:30:00',2.32),('16273','2013-09-23','15:35:00',2.27),('16273','2013-09-23','15:40:00',2.22),('16273','2013-09-23','15:45:00',2.09),('16273','2013-09-23','15:50:00',2.03),('16273','2013-09-23','15:55:00',1.99),('16273','2013-09-23','16:00:00',1.88),('16273','2013-09-23','16:05:00',1.83),('16273','2013-09-23','16:10:00',1.73),('16273','2013-09-23','16:15:00',1.68),('16273','2013-09-23','16:20:00',1.62),('16273','2013-09-23','16:25:00',1.52),('16273','2013-09-23','16:30:00',1.45),('16273','2013-09-23','16:35:00',1.38),('16273','2013-09-23','16:40:00',1.31),('16273','2013-09-23','16:45:00',1.25),('16273','2013-09-23','16:50:00',1.18),('16273','2013-09-23','16:55:00',1.11),('16273','2013-09-23','17:00:00',1.03),('16273','2013-09-22','08:25:00',1.35),('16273','2013-09-22','08:30:00',1.66),('16273','2013-09-22','08:35:00',1.75),('16273','2013-09-22','08:40:00',1.84),('16273','2013-09-22','08:45:00',1.93),('16273','2013-09-22','08:50:00',2.02),('16273','2013-09-22','08:55:00',2.1),('16273','2013-09-22','09:00:00',2.17),('16273','2013-09-22','09:05:00',2.22),('16273','2013-09-22','09:10:00',2.32),('16273','2013-09-22','09:15:00',2.39),('16273','2013-09-22','09:20:00',2.47),('16273','2013-09-22','09:25:00',2.54),('16273','2013-09-22','09:30:00',2.61),('16273','2013-09-22','09:35:00',2.65),('16273','2013-09-22','09:40:00',2.72),('16273','2013-09-22','09:45:00',2.79),('16273','2013-09-22','09:50:00',2.86),('16273','2013-09-22','09:55:00',2.92),('16273','2013-09-22','10:00:00',2.98),('16273','2013-09-22','10:05:00',3.03),('16273','2013-09-22','10:10:00',3.1),('16273','2013-09-22','10:15:00',3.14),('16273','2013-09-22','10:20:00',3.19),('16273','2013-09-22','10:25:00',3.23),('16273','2013-09-22','10:30:00',3.29),('16273','2013-09-22','10:35:00',3.34),('16273','2013-09-22','10:40:00',3.37),('16273','2013-09-22','10:45:00',3.39),('16273','2013-09-22','10:50:00',3.43),('16273','2013-09-22','10:55:00',3.45),('16273','2013-09-22','11:00:00',3.51),('16273','2013-09-22','11:05:00',3.54),('16273','2013-09-22','11:10:00',3.54),('16273','2013-09-22','11:15:00',3.56),('16273','2013-09-22','11:20:00',3.61),('16273','2013-09-22','11:25:00',3.6),('16273','2013-09-22','11:30:00',3.62),('16273','2013-09-22','11:35:00',3.64),('16273','2013-09-22','11:40:00',3.64),('16273','2013-09-22','11:45:00',3.63),('16273','2013-09-22','11:50:00',3.63),('16273','2013-09-22','11:55:00',3.63),('16273','2013-09-22','12:00:00',3.64),('16273','2013-09-22','12:05:00',3.66),('16273','2013-09-22','12:10:00',3.67),('16273','2013-09-22','12:15:00',3.68),('16273','2013-09-22','12:20:00',3.68),('16273','2013-09-22','12:25:00',3.69),('16273','2013-09-22','12:30:00',3.68),('16273','2013-09-22','12:35:00',3.66),('16273','2013-09-22','12:40:00',3.64),('16273','2013-09-22','12:45:00',3.65),('16273','2013-09-22','12:50:00',3.65),('16273','2013-09-22','12:55:00',3.64),('16273','2013-09-22','13:00:00',3.62),('16273','2013-09-22','13:05:00',3.6),('16273','2013-09-22','13:10:00',3.58),('16273','2013-09-22','13:15:00',3.57),('16273','2013-09-22','13:20:00',3.57),('16273','2013-09-22','13:25:00',3.54),('16273','2013-09-22','13:30:00',3.53),('16273','2013-09-22','13:35:00',3.53),('16273','2013-09-22','13:40:00',3.51),('16273','2013-09-22','13:45:00',3.51),('16273','2013-09-22','13:50:00',3.57),('16273','2013-09-22','13:55:00',3.59),('16273','2013-09-22','14:00:00',3.39),('16273','2013-09-22','14:05:00',3.4),('16273','2013-09-22','14:10:00',2.5),('16273','2013-09-22','14:15:00',3.3),('16273','2013-09-22','14:20:00',3.3),('16273','2013-09-22','14:25:00',3.41),('16273','2013-09-22','14:30:00',3.54),('16273','2013-09-22','14:35:00',1.86),('16273','2013-09-22','14:40:00',1.27),('16273','2013-09-22','14:45:00',1.84),('16273','2013-09-22','14:50:00',2.6),('16273','2013-09-22','14:55:00',3.01),('16273','2013-09-22','15:00:00',1.92),('16273','2013-09-22','15:05:00',1.48),('16273','2013-09-22','15:10:00',1.56),('16273','2013-09-22','15:15:00',1.79),('16273','2013-09-22','15:20:00',2.25),('16273','2013-09-22','15:25:00',2.55),('16273','2013-09-22','15:30:00',1.09),('16273','2013-09-22','15:40:00',1.41),('16273','2013-09-22','15:45:00',2.34),('16273','2013-09-22','15:50:00',2.22),('16273','2013-09-22','15:55:00',1.8),('16273','2013-09-22','16:00:00',1.22),('16273','2013-09-22','16:10:00',1.49),('16273','2013-09-22','16:15:00',1.84),('16273','2013-09-22','16:20:00',1.48),('16273','2013-09-22','16:25:00',1.1),('16273','2013-09-22','16:40:00',1.06),('16273','2013-09-22','16:50:00',1.05),('16273','2013-09-22','17:00:00',1.05),('16273','2013-09-21','08:05:00',1.09),('16273','2013-09-21','08:10:00',1.21),('16273','2013-09-21','08:15:00',1.15),('16273','2013-09-21','08:20:00',1.46),('16273','2013-09-21','08:25:00',1.56),('16273','2013-09-21','08:30:00',1.67),('16273','2013-09-21','08:35:00',1.73),('16273','2013-09-21','08:40:00',1.82),('16273','2013-09-21','08:45:00',1.9),('16273','2013-09-21','08:50:00',1.99),('16273','2013-09-21','08:55:00',2.08),('16273','2013-09-21','09:00:00',2.15),('16273','2013-09-21','09:05:00',2.22),('16273','2013-09-21','09:10:00',2.3),('16273','2013-09-21','09:15:00',2.37),('16273','2013-09-21','09:20:00',2.42),('16273','2013-09-21','09:25:00',2.48),('16273','2013-09-21','09:30:00',2.54),('16273','2013-09-21','09:35:00',2.59),('16273','2013-09-21','09:40:00',2.64),('16273','2013-09-21','09:45:00',2.7),('16273','2013-09-21','09:50:00',2.75),('16273','2013-09-21','09:55:00',2.84),('16273','2013-09-21','10:00:00',2.89),('16273','2013-09-21','10:05:00',2.94),('16273','2013-09-21','10:10:00',2.99),('16273','2013-09-21','10:15:00',3.03),('16273','2013-09-21','10:20:00',3.05),('16273','2013-09-21','10:25:00',3.11),('16273','2013-09-21','10:30:00',3.13),('16273','2013-09-21','10:35:00',3.17),('16273','2013-09-21','10:40:00',3.21),('16273','2013-09-21','10:45:00',3.22),('16273','2013-09-21','10:50:00',3.26),('16273','2013-09-21','10:55:00',3.28),('16273','2013-09-21','11:00:00',3.31),('16273','2013-09-21','11:05:00',3.33),('16273','2013-09-21','11:10:00',3.35),('16273','2013-09-21','11:15:00',3.38),('16273','2013-09-21','11:20:00',3.4),('16273','2013-09-21','11:25:00',3.42),('16273','2013-09-21','11:30:00',3.45),('16273','2013-09-21','11:35:00',3.46),('16273','2013-09-21','11:40:00',3.48),('16273','2013-09-21','11:45:00',3.48),('16273','2013-09-21','11:50:00',3.44),('16273','2013-09-21','11:55:00',3.52),('16273','2013-09-21','12:00:00',3.53),('16273','2013-09-21','12:05:00',3.52),('16273','2013-09-21','12:10:00',3.56),('16273','2013-09-21','12:15:00',3.51),('16273','2013-09-21','12:20:00',3.26),('16273','2013-09-21','12:25:00',3.63),('16273','2013-09-21','12:30:00',3.49),('16273','2013-09-21','12:35:00',3.28),('16273','2013-09-21','12:40:00',3.48),('16273','2013-09-21','12:45:00',3.51),('16273','2013-09-21','12:50:00',3.57),('16273','2013-09-21','12:55:00',3.52),('16273','2013-09-21','13:00:00',3.5),('16273','2013-09-21','13:05:00',3.56),('16273','2013-09-21','13:10:00',3.55),('16273','2013-09-21','13:15:00',2.88),('16273','2013-09-21','13:20:00',3.53),('16273','2013-09-21','13:25:00',3.3),('16273','2013-09-21','13:30:00',3.3),('16273','2013-09-21','13:35:00',2.92),('16273','2013-09-21','13:40:00',2.88),('16273','2013-09-21','13:45:00',3.03),('16273','2013-09-21','13:50:00',2.97),('16273','2013-09-21','13:55:00',3.16),('16273','2013-09-21','14:00:00',3.15),('16273','2013-09-21','14:05:00',3),('16273','2013-09-21','14:10:00',3.11),('16273','2013-09-21','14:15:00',3.07),('16273','2013-09-21','14:20:00',3),('16273','2013-09-21','14:25:00',2.95),('16273','2013-09-21','14:30:00',2.89),('16273','2013-09-21','14:35:00',2.81),('16273','2013-09-21','14:40:00',2.78),('16273','2013-09-21','14:45:00',2.76),('16273','2013-09-21','14:50:00',2.7),('16273','2013-09-21','14:55:00',2.65),('16273','2013-09-21','15:00:00',2.62),('16273','2013-09-21','15:05:00',2.51),('16273','2013-09-21','15:10:00',2.5),('16273','2013-09-21','15:15:00',2.44),('16273','2013-09-21','15:20:00',2.37),('16273','2013-09-21','15:25:00',2.32),('16273','2013-09-21','15:30:00',2.27),('16273','2013-09-21','15:35:00',2.21),('16273','2013-09-21','15:40:00',1.94),('16273','2013-09-21','15:45:00',2.11),('16273','2013-09-21','15:50:00',1.92),('16273','2013-09-21','15:55:00',1.46),('16273','2013-09-21','16:00:00',1.04),('16273','2013-09-21','16:05:00',1.2),('16273','2013-09-21','16:10:00',1.18),('16273','2013-09-21','16:15:00',1.2),('16273','2013-09-21','16:25:00',1.04),('16273','2013-09-21','16:30:00',1.14),('16273','2013-09-20','08:25:00',1.25),('16273','2013-09-20','08:30:00',2.01),('16273','2013-09-20','08:35:00',2.28),('16273','2013-09-20','08:40:00',2.02),('16273','2013-09-20','08:45:00',1.02),('16273','2013-09-20','08:50:00',1.1),('16273','2013-09-20','09:40:00',1.01),('16273','2013-09-20','09:45:00',1.09),('16273','2013-09-20','09:50:00',1.15),('16273','2013-09-20','09:55:00',1.21),('16273','2013-09-20','10:00:00',1.3),('16273','2013-09-20','10:05:00',1.42),('16273','2013-09-20','10:10:00',1.57),('16273','2013-09-20','10:15:00',2.41),('16273','2013-09-20','10:20:00',2.33),('16273','2013-09-20','10:25:00',2.54),('16273','2013-09-20','10:30:00',1.9),('16273','2013-09-20','10:35:00',1.9),('16273','2013-09-20','10:40:00',1.91),('16273','2013-09-20','10:45:00',1.96),('16273','2013-09-20','10:50:00',1.92),('16273','2013-09-20','10:55:00',2.04),('16273','2013-09-20','11:00:00',1.93),('16273','2013-09-20','11:05:00',1.95),('16273','2013-09-20','11:10:00',2.03),('16273','2013-09-20','11:15:00',2.3),('16273','2013-09-20','11:20:00',2.66),('16273','2013-09-20','11:25:00',3.79),('16273','2013-09-20','11:30:00',3.3),('16273','2013-09-20','11:35:00',4.37),('16273','2013-09-20','11:40:00',4.01),('16273','2013-09-20','11:45:00',3.98),('16273','2013-09-20','11:50:00',3.92),('16273','2013-09-20','11:55:00',3.77),('16273','2013-09-20','12:00:00',3.73),('16273','2013-09-20','12:05:00',3.73),('16273','2013-09-20','12:10:00',3.85),('16273','2013-09-20','12:15:00',2.88),('16273','2013-09-20','12:20:00',2.09),('16273','2013-09-20','12:25:00',3.78),('16273','2013-09-20','12:30:00',3.05),('16273','2013-09-20','12:35:00',3.49),('16273','2013-09-20','12:40:00',3.74),('16273','2013-09-20','12:45:00',3.69),('16273','2013-09-20','12:50:00',3.57),('16273','2013-09-20','12:55:00',3.44),('16273','2013-09-20','13:00:00',3.45),('16273','2013-09-20','13:05:00',3.45),('16273','2013-09-20','13:10:00',3.42),('16273','2013-09-20','13:15:00',3.41),('16273','2013-09-20','13:20:00',3.43),('16273','2013-09-20','13:25:00',3.48),('16273','2013-09-20','13:30:00',3.42),('16273','2013-09-20','13:35:00',3.48),('16273','2013-09-20','13:40:00',3.36),('16273','2013-09-20','13:45:00',2.97),('16273','2013-09-20','13:50:00',1.83),('16273','2013-09-20','13:55:00',2.08),('16273','2013-09-20','14:30:00',1.06),('16273','2013-09-20','14:35:00',1.26),('16273','2013-09-20','14:40:00',1.17),('16273','2013-09-20','14:45:00',2.58),('16273','2013-09-20','14:50:00',2.85),('16273','2013-09-20','14:55:00',1.37),('16273','2013-09-20','15:00:00',1.12),('16273','2013-09-20','15:05:00',1.2),('16273','2013-09-20','15:10:00',1.52),('16273','2013-09-20','15:15:00',1.87),('16273','2013-09-20','15:20:00',1.99),('16273','2013-09-20','15:25:00',1.33),('16273','2013-09-20','15:45:00',1.1),('16273','2013-09-20','15:55:00',1.14),('16273','2013-09-20','16:15:00',1.29),('16273','2013-09-20','16:20:00',1.17),('16273','2013-09-20','16:25:00',1.6),('16273','2013-09-20','16:30:00',1.87),('16273','2013-09-20','16:35:00',1.9),('16273','2013-09-20','16:40:00',1.75),('16273','2013-09-20','16:45:00',1.66),('16273','2013-09-20','16:50:00',1.3),('16273','2013-09-20','17:05:00',1.03),('16273','2013-09-20','17:10:00',1.11),('16273','2013-09-20','17:15:00',1.09),('16273','2013-09-20','17:20:00',1.01),('16273','2013-09-20','17:35:00',1.02),('16273','2013-09-20','17:50:00',1.02),('16273','2013-09-19','08:15:00',1.02),('16273','2013-09-19','08:20:00',1.46),('16273','2013-09-19','08:25:00',1.69),('16273','2013-09-19','08:30:00',1.78),('16273','2013-09-19','08:35:00',1.07),('16273','2013-09-19','08:40:00',1.55),('16273','2013-09-19','08:45:00',1.05),('16273','2013-09-19','08:50:00',2.08),('16273','2013-09-19','08:55:00',1.3),('16273','2013-09-19','09:00:00',2.02),('16273','2013-09-19','09:05:00',1.78),('16273','2013-09-19','09:10:00',2.28),('16273','2013-09-19','09:15:00',1.21),('16273','2013-09-19','09:20:00',1.14),('16273','2013-09-19','09:35:00',2.67),('16273','2013-09-19','09:40:00',2.9),('16273','2013-09-19','09:45:00',2.65),('16273','2013-09-19','09:50:00',2.25),('16273','2013-09-19','09:55:00',3.07),('16273','2013-09-19','10:00:00',1.7),('16273','2013-09-19','10:05:00',2.65),('16273','2013-09-19','10:10:00',1.65),('16273','2013-09-19','10:15:00',2.2),('16273','2013-09-19','10:20:00',1.17),('16273','2013-09-19','10:40:00',1.32),('16273','2013-09-19','10:50:00',2.68),('16273','2013-09-19','10:55:00',3.51),('16273','2013-09-19','11:00:00',1.42),('16273','2013-09-19','11:15:00',1.04),('16273','2013-09-19','11:20:00',2.49),('16273','2013-09-19','11:25:00',2.13),('16273','2013-09-19','11:30:00',2.59),('16273','2013-09-19','11:35:00',2.9),('16273','2013-09-19','11:40:00',2.38),('16273','2013-09-19','11:45:00',2.23),('16273','2013-09-19','11:50:00',2.36),('16273','2013-09-19','11:55:00',1.49),('16273','2013-09-19','12:00:00',2.2),('16273','2013-09-19','12:10:00',1.18),('16273','2013-09-19','12:15:00',3.41),('16273','2013-09-19','12:20:00',3.65),('16273','2013-09-19','12:25:00',3.95),('16273','2013-09-19','12:30:00',3.95),('16273','2013-09-19','12:35:00',3.76),('16273','2013-09-19','12:40:00',3.73),('16273','2013-09-19','12:45:00',2.73),('16273','2013-09-19','12:50:00',1.14),('16273','2013-09-19','12:55:00',2.39),('16273','2013-09-19','13:00:00',2.64),('16273','2013-09-19','13:05:00',3.54),('16273','2013-09-19','13:10:00',4.11),('16273','2013-09-19','13:15:00',2.68),('16273','2013-09-19','13:20:00',1.71),('16273','2013-09-19','13:25:00',2.67),('16273','2013-09-19','13:30:00',2.23),('16273','2013-09-19','13:35:00',2.87),('16273','2013-09-19','13:40:00',3.75),('16273','2013-09-19','13:45:00',3.8),('16273','2013-09-19','13:50:00',3.77),('16273','2013-09-19','13:55:00',2.48),('16273','2013-09-19','14:00:00',2.58),('16273','2013-09-19','14:05:00',3.55),('16273','2013-09-19','14:10:00',3.29),('16273','2013-09-19','14:15:00',3.26),('16273','2013-09-19','14:20:00',2.85),('16273','2013-09-19','14:25:00',3.12),('16273','2013-09-19','14:30:00',3.07),('16273','2013-09-19','14:35:00',3.1),('16273','2013-09-19','14:40:00',2.69),('16273','2013-09-19','14:45:00',3.03),('16273','2013-09-19','14:50:00',3.08),('16273','2013-09-19','14:55:00',3.01),('16273','2013-09-19','15:00:00',2.81),('16273','2013-09-19','15:05:00',2.4),('16273','2013-09-19','15:10:00',1.98),('16273','2013-09-19','15:15:00',1.93),('16273','2013-09-19','15:20:00',2.71),('16273','2013-09-19','15:25:00',2.53),('16273','2013-09-19','15:30:00',1.55),('16273','2013-09-19','15:35:00',1.64),('16273','2013-09-19','15:40:00',1.21),('16273','2013-09-19','15:45:00',1.97),('16273','2013-09-19','15:50:00',1.9),('16273','2013-09-19','16:00:00',1.24),('16273','2013-09-19','16:10:00',1.22),('16273','2013-09-19','16:15:00',1.55),('16273','2013-09-19','16:20:00',1.78),('16273','2013-09-19','16:25:00',1.55),('16273','2013-09-19','16:30:00',1.56),('16273','2013-09-19','16:35:00',1.5),('16273','2013-09-19','16:40:00',1.45),('16273','2013-09-19','16:45:00',1.36),('16273','2013-09-19','16:55:00',1.16),('16273','2013-09-19','17:05:00',1.1),('16273','2013-09-19','17:10:00',1.04),('16273','2014-04-13','09:35:00',1.09),('16273','2014-04-13','09:40:00',1.17),('16273','2014-04-13','09:45:00',1.27),('16273','2014-04-13','09:50:00',1.67),('16273','2014-04-13','09:55:00',1.67),('16273','2014-04-13','10:00:00',2.17),('16273','2014-04-13','10:05:00',2.38),('16273','2014-04-13','10:10:00',2.76),('16273','2014-04-13','10:15:00',2.08),('16273','2014-04-13','10:20:00',2.32),('16273','2014-04-13','10:25:00',2.31),('16273','2014-04-13','10:30:00',2.89),('16273','2014-04-13','10:35:00',2.94),('16273','2014-04-13','10:40:00',3.25),('16273','2014-04-13','10:45:00',2.56),('16273','2014-04-13','10:50:00',3.6),('16273','2014-04-13','10:55:00',3.42),('16273','2014-04-13','11:00:00',1.4),('16273','2014-04-13','11:05:00',2.76),('16273','2014-04-13','11:10:00',3.09),('16273','2014-04-13','11:15:00',2.14),('16273','2014-04-13','11:20:00',1.59),('16273','2014-04-13','11:25:00',1.21),('16273','2014-04-13','11:30:00',1.78),('16273','2014-04-13','11:35:00',3.18),('16273','2014-04-13','11:40:00',2),('16273','2014-04-13','11:45:00',1.47),('16273','2014-04-13','11:50:00',1.87),('16273','2014-04-13','11:55:00',1.93),('16273','2014-04-13','12:00:00',2.03),('16273','2014-04-13','12:05:00',1.8),('16273','2014-04-13','12:10:00',2.28),('16273','2014-04-13','12:50:00',1.09),('16273','2014-04-13','12:55:00',1.47),('16273','2014-04-13','13:00:00',1.87),('16273','2014-04-13','13:05:00',3.67),('16273','2014-04-13','13:10:00',4.02),('16273','2014-04-13','13:15:00',3.83),('16273','2014-04-13','13:20:00',3.63),('16273','2014-04-13','13:25:00',3.3),('16273','2014-04-13','13:30:00',3.24),('16273','2014-04-13','13:35:00',3.27),('16273','2014-04-13','13:40:00',2.53),('16273','2014-04-13','13:45:00',2.25),('16273','2014-04-13','13:50:00',1.72),('16273','2014-04-13','13:55:00',1.73),('16273','2014-04-13','14:00:00',1.85),('16273','2014-04-13','14:05:00',2.77),('16273','2014-04-13','14:10:00',2.82),('16273','2014-04-13','14:15:00',1.57),('16273','2014-04-13','14:20:00',1.63),('16273','2014-04-13','14:25:00',1.82),('16273','2014-04-13','14:30:00',1.39),('16273','2014-04-13','14:35:00',1.47),('16273','2014-04-13','14:40:00',1.47),('16273','2014-04-13','14:45:00',2.72),('16273','2014-04-13','14:50:00',2.84),('16273','2014-04-13','14:55:00',3.37),('16273','2014-04-13','15:00:00',3.3),('16273','2014-04-13','15:05:00',2.92),('16273','2014-04-13','15:10:00',2.72),('16273','2014-04-13','15:15:00',3.01),('16273','2014-04-13','15:20:00',2.98),('16273','2014-04-13','15:25:00',2.86),('16273','2014-04-13','15:30:00',1.93),('16273','2014-04-13','15:35:00',1.75),('16273','2014-04-13','15:40:00',1.9),('16273','2014-04-13','15:45:00',2.17),('16273','2014-04-13','15:50:00',1.73),('16273','2014-04-13','15:55:00',1.38),('16273','2014-04-13','16:00:00',1.34),('16273','2014-04-13','16:05:00',1.17),('16273','2014-04-13','16:10:00',1.05),('16273','2014-04-13','16:15:00',1.16),('16273','2014-04-13','16:20:00',1.19),('16273','2014-04-13','16:25:00',1.02),('16273','2014-04-13','16:30:00',1.17),('16273','2014-04-13','16:35:00',1.65),('16273','2014-04-13','16:40:00',2.17),('16273','2014-04-13','16:45:00',1.45),('16273','2014-04-13','16:50:00',1.74),('16273','2014-04-13','16:55:00',1.62),('16273','2014-04-13','17:00:00',1.27),('16273','2014-04-13','17:05:00',1.33),('16273','2014-04-13','17:10:00',1.28),('16273','2014-04-13','17:15:00',1.03),('16273','2013-09-18','08:05:00',1.03),('16273','2013-09-18','08:10:00',1.02),('16273','2013-09-18','08:15:00',1.27),('16273','2013-09-18','08:20:00',1.03),('16273','2013-09-18','08:25:00',1.38),('16273','2013-09-18','08:30:00',1.77),('16273','2013-09-18','08:35:00',1.75),('16273','2013-09-18','08:40:00',1.49),('16273','2013-09-18','08:45:00',1.81),('16273','2013-09-18','08:50:00',1.26),('16273','2013-09-18','08:55:00',1.52),('16273','2013-09-18','09:00:00',1.1),('16273','2013-09-18','09:05:00',1.18),('16273','2013-09-18','09:10:00',1.21),('16273','2013-09-18','09:15:00',2.1),('16273','2013-09-18','09:20:00',1.66),('16273','2013-09-18','09:25:00',1.73),('16273','2013-09-18','09:30:00',1.43),('16273','2013-09-18','09:40:00',1.34),('16273','2013-09-18','09:45:00',1.42),('16273','2013-09-18','09:50:00',2.87),('16273','2013-09-18','09:55:00',2.98),('16273','2013-09-18','10:00:00',2.93),('16273','2013-09-18','10:05:00',2.94),('16273','2013-09-18','10:10:00',2.96),('16273','2013-09-18','10:15:00',2.97),('16273','2013-09-18','10:20:00',3.05),('16273','2013-09-18','10:25:00',3.1),('16273','2013-09-18','10:30:00',3.14),('16273','2013-09-18','10:35:00',3.16),('16273','2013-09-18','10:40:00',3.23),('16273','2013-09-18','10:45:00',3.24),('16273','2013-09-18','10:50:00',3.3),('16273','2013-09-18','10:55:00',3.37),('16273','2013-09-18','11:00:00',3.37),('16273','2013-09-18','11:05:00',3.05),('16273','2013-09-18','11:10:00',2.61),('16273','2013-09-18','11:15:00',3.62),('16273','2013-09-18','11:20:00',3.66),('16273','2013-09-18','11:25:00',3.67),('16273','2013-09-18','11:30:00',3.62),('16273','2013-09-18','11:35:00',3.7),('16273','2013-09-18','11:40:00',3.79),('16273','2013-09-18','11:45:00',3.7),('16273','2013-09-18','11:50:00',3.74),('16273','2013-09-18','11:55:00',3.62),('16273','2013-09-18','12:00:00',2.55),('16273','2013-09-18','12:05:00',3.72),('16273','2013-09-18','12:10:00',3.41),('16273','2013-09-18','12:15:00',2.5),('16273','2013-09-18','12:20:00',4.14),('16273','2013-09-18','12:25:00',4.06),('16273','2013-09-18','12:30:00',3.5),('16273','2013-09-18','12:35:00',3.97),('16273','2013-09-18','12:40:00',3.93),('16273','2013-09-18','12:45:00',3.56),('16273','2013-09-18','12:50:00',3.37),('16273','2013-09-18','12:55:00',3.78),('16273','2013-09-18','13:00:00',2.79),('16273','2013-09-18','13:05:00',2.71),('16273','2013-09-18','13:10:00',2.69),('16273','2013-09-18','13:20:00',1.1),('16273','2013-09-18','13:25:00',2.57),('16273','2013-09-18','13:30:00',1.11),('16273','2013-09-18','13:35:00',3.64),('16273','2013-09-18','13:40:00',2.86),('16273','2013-09-18','13:45:00',3.85),('16273','2013-09-18','13:50:00',3.68),('16273','2013-09-18','13:55:00',3.52),('16273','2013-09-18','14:00:00',3.54),('16273','2013-09-18','14:05:00',3.56),('16273','2013-09-18','14:10:00',2.73),('16273','2013-09-18','14:15:00',2.47),('16273','2013-09-18','14:20:00',3.35),('16273','2013-09-18','14:25:00',3.26),('16273','2013-09-18','14:30:00',3.23),('16273','2013-09-18','14:35:00',3.27),('16273','2013-09-18','14:40:00',3.33),('16273','2013-09-18','14:45:00',3.19),('16273','2013-09-18','14:50:00',2.72),('16273','2013-09-18','14:55:00',2.79),('16273','2013-09-18','15:00:00',2.53),('16273','2013-09-18','15:05:00',1.07),('16273','2013-09-18','15:15:00',2.61),('16273','2013-09-18','15:20:00',2.03),('16273','2013-09-18','15:25:00',2.66),('16273','2013-09-18','15:30:00',2.65),('16273','2013-09-18','15:35:00',2.59),('16273','2013-09-18','15:40:00',2.48),('16273','2013-09-18','15:45:00',2.24),('16273','2013-09-18','15:50:00',1.97),('16273','2013-09-18','15:55:00',1.49),('16273','2013-09-18','16:00:00',1.89),('16273','2013-09-18','16:05:00',1.06),('16273','2013-09-18','16:10:00',1.86),('16273','2013-09-18','16:15:00',2.06),('16273','2013-09-18','16:20:00',1.4),('16273','2013-09-18','16:25:00',1.52),('16273','2013-09-18','16:30:00',1.37),('16273','2013-09-18','16:35:00',1.5),('16273','2013-09-18','16:40:00',1.42),('16273','2013-09-18','16:45:00',1.11),('16273','2013-09-18','16:55:00',1.26),('16273','2013-09-18','17:00:00',1.11),('16273','2013-09-17','09:25:00',1.06),('16273','2013-09-17','09:40:00',2.23),('16273','2013-09-17','09:45:00',1.49),('16273','2013-09-17','09:50:00',1.24),('16273','2013-09-17','09:55:00',2.28),('16273','2013-09-17','10:00:00',1.57),('16273','2013-09-17','10:05:00',1.28),('16273','2013-09-17','10:20:00',2.29),('16273','2013-09-17','10:25:00',2.99),('16273','2013-09-17','10:30:00',1.98),('16273','2013-09-17','10:35:00',2.18),('16273','2013-09-17','10:40:00',3.83),('16273','2013-09-17','10:45:00',3.85),('16273','2013-09-17','10:50:00',3.17),('16273','2013-09-17','10:55:00',3.08),('16273','2013-09-17','11:00:00',2.03),('16273','2013-09-17','11:05:00',2.86),('16273','2013-09-17','11:10:00',1.94),('16273','2013-09-17','11:15:00',2.19),('16273','2013-09-17','11:20:00',1.55),('16273','2013-09-17','11:25:00',1.38),('16273','2013-09-17','11:30:00',2.07),('16273','2013-09-17','11:35:00',1.45),('16273','2013-09-17','11:40:00',2.26),('16273','2013-09-17','11:45:00',1.17),('16273','2013-09-17','11:50:00',2.92),('16273','2013-09-17','11:55:00',3.89),('16273','2013-09-17','12:00:00',1.84),('16273','2013-09-17','12:05:00',1.67),('16273','2013-09-17','12:10:00',3.23),('16273','2013-09-17','12:15:00',3.22),('16273','2013-09-17','12:20:00',2.25),('16273','2013-09-17','12:25:00',1.64),('16273','2013-09-17','12:30:00',2.88),('16273','2013-09-17','12:35:00',2.09),('16273','2013-09-17','12:40:00',1.54),('16273','2013-09-17','12:45:00',3.61),('16273','2013-09-17','12:50:00',2.48),('16273','2013-09-17','12:55:00',3.09),('16273','2013-09-17','13:00:00',2.93),('16273','2013-09-17','13:05:00',2.08),('16273','2013-09-17','13:10:00',1.65),('16273','2013-09-17','13:15:00',1.52),('16273','2013-09-17','13:20:00',1.28),('16273','2013-09-17','13:25:00',1.54),('16273','2013-09-17','13:30:00',1.26),('16273','2013-09-17','13:35:00',1.32),('16273','2013-09-17','13:40:00',1.14),('16273','2013-09-17','13:45:00',1.11),('16273','2013-09-17','13:50:00',1.26),('16273','2013-09-17','13:55:00',1.38),('16273','2013-09-17','14:00:00',1.14),('16273','2013-09-17','14:05:00',1.78),('16273','2013-09-17','14:10:00',1.45),('16273','2013-09-17','14:15:00',1.19),('16273','2013-09-17','14:20:00',1.42),('16273','2013-09-17','14:25:00',1.22),('16273','2013-09-17','14:30:00',1.23),('16273','2013-09-17','14:50:00',1.52),('16273','2013-09-17','14:55:00',3.19),('16273','2013-09-17','15:00:00',2.88),('16273','2013-09-17','15:05:00',2.51),('16273','2013-09-17','15:10:00',1.58),('16273','2013-09-17','15:15:00',1.77),('16273','2013-09-17','15:20:00',1.59),('16273','2013-09-17','15:25:00',1.21),('16273','2013-09-17','15:40:00',1.33),('16273','2013-09-17','15:45:00',1.24),('16273','2013-09-17','15:50:00',1.13),('16273','2013-09-17','15:55:00',1.62),('16273','2013-09-17','16:00:00',1.86),('16273','2013-09-17','16:05:00',1.31),('16273','2013-09-17','16:10:00',1.48),('16273','2013-09-17','16:35:00',1.15),('16273','2013-09-17','16:40:00',1.19),('16273','2013-09-17','16:45:00',1.08),('16273','2013-09-17','16:55:00',1.13),('16273','2013-09-17','17:00:00',1.43),('16273','2013-09-17','17:05:00',1.44),('16273','2013-09-17','17:10:00',1.32),('16273','2013-09-17','17:15:00',1.16),('16273','2013-09-17','17:20:00',1.31),('16273','2013-09-17','17:25:00',1.17),('16273','2013-09-17','17:30:00',1.18),('16273','2013-09-16','08:05:00',1.06),('16273','2013-09-16','08:10:00',1.11),('16273','2013-09-16','08:20:00',1.47),('16273','2013-09-16','08:25:00',1.38),('16273','2013-09-16','08:30:00',1.69),('16273','2013-09-16','08:35:00',1.79),('16273','2013-09-16','08:40:00',1.87),('16273','2013-09-16','08:45:00',2.07),('16273','2013-09-16','08:50:00',2.36),('16273','2013-09-16','08:55:00',1.78),('16273','2013-09-16','09:05:00',1.1),('16273','2013-09-16','09:10:00',2.4),('16273','2013-09-16','09:15:00',2.45),('16273','2013-09-16','09:20:00',2.49),('16273','2013-09-16','09:25:00',2.55),('16273','2013-09-16','09:30:00',2.6),('16273','2013-09-16','09:35:00',2.66),('16273','2013-09-16','09:40:00',2.74),('16273','2013-09-16','09:45:00',2.86),('16273','2013-09-16','09:50:00',2.96),('16273','2013-09-16','09:55:00',2.69),('16273','2013-09-16','10:00:00',2.3),('16273','2013-09-16','10:05:00',2.66),('16273','2013-09-16','10:10:00',3.17),('16273','2013-09-16','10:15:00',3.21),('16273','2013-09-16','10:20:00',3.31),('16273','2013-09-16','10:25:00',2.52),('16273','2013-09-16','10:30:00',3.48),('16273','2013-09-16','10:35:00',3.44),('16273','2013-09-16','10:40:00',2.64),('16273','2013-09-16','10:45:00',1.11),('16273','2013-09-16','10:50:00',1.44),('16273','2013-09-16','10:55:00',2.12),('16273','2013-09-16','11:00:00',1.05),('16273','2013-09-16','11:05:00',2.21),('16273','2013-09-16','11:10:00',3.54),('16273','2013-09-16','11:25:00',2.83),('16273','2013-09-16','11:30:00',3.87),('16273','2013-09-16','11:35:00',3.96),('16273','2013-09-16','11:40:00',3.87),('16273','2013-09-16','11:45:00',3.89),('16273','2013-09-16','11:50:00',2.83),('16273','2013-09-16','11:55:00',3.96),('16273','2013-09-16','12:00:00',3.81),('16273','2013-09-16','12:05:00',3.94),('16273','2013-09-16','12:10:00',3.95),('16273','2013-09-16','12:15:00',3.94),('16273','2013-09-16','12:20:00',3.83),('16273','2013-09-16','12:25:00',3.64),('16273','2013-09-16','12:30:00',4.05),('16273','2013-09-16','12:35:00',2.73),('16273','2013-09-16','12:40:00',1.4),('16273','2013-09-16','12:45:00',1.08),('16273','2013-09-16','12:50:00',1.52),('16273','2013-09-16','12:55:00',2.12),('16273','2013-09-16','13:00:00',4.08),('16273','2013-09-16','13:05:00',3.8),('16273','2013-09-16','13:10:00',3.71),('16273','2013-09-16','13:15:00',3.75),('16273','2013-09-16','13:20:00',3.6),('16273','2013-09-16','13:25:00',3.59),('16273','2013-09-16','13:30:00',3.57),('16273','2013-09-16','13:35:00',3.64),('16273','2013-09-16','13:40:00',3.75),('16273','2013-09-16','13:45:00',3.87),('16273','2013-09-16','13:50:00',3.67),('16273','2013-09-16','13:55:00',3.42),('16273','2013-09-16','14:00:00',3.37),('16273','2013-09-16','14:05:00',3.33),('16273','2013-09-16','14:10:00',3.29),('16273','2013-09-16','14:15:00',3.24),('16273','2013-09-16','14:20:00',3.2),('16273','2013-09-16','14:25:00',3.17),('16273','2013-09-16','14:30:00',3.13),('16273','2013-09-16','14:35:00',3.05),('16273','2013-09-16','14:40:00',3.05),('16273','2013-09-16','14:45:00',3.04),('16273','2013-09-16','14:50:00',3),('16273','2013-09-16','14:55:00',2.93),('16273','2013-09-16','15:00:00',2.88),('16273','2013-09-16','15:05:00',2.83),('16273','2013-09-16','15:10:00',2.78),('16273','2013-09-16','15:15:00',2.71),('16273','2013-09-16','15:20:00',2.65),('16273','2013-09-16','15:25:00',2.59),('16273','2013-09-16','15:30:00',2.51),('16273','2013-09-16','15:35:00',2.46),('16273','2013-09-16','15:40:00',2.39),('16273','2013-09-16','15:45:00',2.15),('16273','2013-09-16','15:50:00',1.81),('16273','2013-09-16','15:55:00',2.36),('16273','2013-09-16','16:00:00',2.14),('16273','2013-09-16','16:05:00',2.05),('16273','2013-09-16','16:10:00',1.97),('16273','2013-09-16','16:15:00',1.89),('16273','2013-09-16','16:20:00',1.8),('16273','2013-09-16','16:25:00',1.75),('16273','2013-09-16','16:30:00',1.67),('16273','2013-09-16','16:35:00',1.6),('16273','2013-09-16','16:40:00',1.53),('16273','2013-09-16','16:45:00',1.44),('16273','2013-09-16','16:50:00',1.36),('16273','2013-09-16','16:55:00',1.1),('16273','2013-09-16','17:00:00',1.22),('16273','2013-09-16','17:05:00',1.14),('16273','2013-09-15','07:55:00',1.01),('16273','2013-09-15','08:00:00',1.12),('16273','2013-09-15','08:05:00',1.1),('16273','2013-09-15','08:10:00',1.36),('16273','2013-09-15','08:15:00',1.48),('16273','2013-09-15','08:20:00',1.59),('16273','2013-09-15','08:25:00',1.7),('16273','2013-09-15','08:30:00',1.79),('16273','2013-09-15','08:35:00',1.9),('16273','2013-09-15','08:40:00',2),('16273','2013-09-15','08:45:00',2.07),('16273','2013-09-15','08:50:00',1.98),('16273','2013-09-15','08:55:00',2.06),('16273','2013-09-15','09:00:00',2.08),('16273','2013-09-15','09:05:00',2.24),('16273','2013-09-15','09:10:00',2.38),('16273','2013-09-15','09:15:00',2.44),('16273','2013-09-15','09:20:00',2.42),('16273','2013-09-15','09:25:00',2.48),('16273','2013-09-15','09:30:00',2.62),('16273','2013-09-15','09:35:00',2.69),('16273','2013-09-15','09:40:00',2.71),('16273','2013-09-15','09:45:00',2.77),('16273','2013-09-15','09:50:00',2.8),('16273','2013-09-15','09:55:00',2.94),('16273','2013-09-15','10:00:00',2.97),('16273','2013-09-15','10:05:00',2.99),('16273','2013-09-15','10:10:00',2.9),('16273','2013-09-15','10:15:00',2.95),('16273','2013-09-15','10:20:00',3.03),('16273','2013-09-15','10:25:00',2.91),('16273','2013-09-15','10:30:00',2.82),('16273','2013-09-15','10:35:00',3.14),('16273','2013-09-15','10:40:00',3.34),('16273','2013-09-15','10:45:00',3.17),('16273','2013-09-15','10:50:00',3.49),('16273','2013-09-15','10:55:00',3.43),('16273','2013-09-15','11:00:00',1.73),('16273','2013-09-15','11:15:00',2.74),('16273','2013-09-15','11:20:00',2.69),('16273','2013-09-15','11:25:00',3.38),('16273','2013-09-15','11:30:00',1.52),('16273','2013-09-15','11:35:00',1.32),('16273','2013-09-15','11:40:00',3.55),('16273','2013-09-15','11:45:00',3.86),('16273','2013-09-15','11:50:00',4.07),('16273','2013-09-15','11:55:00',4.13),('16273','2013-09-15','12:00:00',4.36),('16273','2013-09-15','12:05:00',3.94),('16273','2013-09-15','12:10:00',2.6),('16273','2013-09-15','12:15:00',1.93),('16273','2013-09-15','12:20:00',1.79),('16273','2013-09-15','12:25:00',1.89),('16273','2013-09-15','12:30:00',1.75),('16273','2013-09-15','12:35:00',1.92),('16273','2013-09-15','12:40:00',1.81),('16273','2013-09-15','12:45:00',1.74),('16273','2013-09-15','12:50:00',1.99),('16273','2013-09-15','12:55:00',1.99),('16273','2013-09-15','13:00:00',1.85),('16273','2013-09-15','13:05:00',1.97),('16273','2013-09-15','13:10:00',2.76),('16273','2013-09-15','13:15:00',1.8),('16273','2013-09-15','13:20:00',1.29),('16273','2013-09-15','13:30:00',2.01),('16273','2013-09-15','13:35:00',2.08),('16273','2013-09-15','13:40:00',1.62),('16273','2013-09-15','13:45:00',2.92),('16273','2013-09-15','13:50:00',1.68),('16273','2013-09-15','13:55:00',2.13),('16273','2013-09-15','14:00:00',1.81),('16273','2013-09-15','14:05:00',1.75),('16273','2013-09-15','14:10:00',1.73),('16273','2013-09-15','14:15:00',1.48),('16273','2013-09-15','14:20:00',1.35),('16273','2013-09-15','14:25:00',1.27),('16273','2013-09-15','14:30:00',1.16),('16273','2013-09-15','14:35:00',1.15),('16273','2013-09-15','14:40:00',1.14),('16273','2013-09-15','14:45:00',1.14),('16273','2013-09-15','14:50:00',1.05),('16273','2013-09-15','14:55:00',1.02),('16273','2013-09-15','15:00:00',1.11),('16273','2013-09-15','15:05:00',1.07),('16273','2013-09-15','15:10:00',1.56),('16273','2013-09-15','15:15:00',1.65),('16273','2013-09-15','15:20:00',1.41),('16273','2013-09-14','08:00:00',1.05),('16273','2013-09-14','08:05:00',1.01),('16273','2013-09-14','08:10:00',1.28),('16273','2013-09-14','08:15:00',1.41),('16273','2013-09-14','08:20:00',1.5),('16273','2013-09-14','08:25:00',1.59),('16273','2013-09-14','08:30:00',1.7),('16273','2013-09-14','08:35:00',1.79),('16273','2013-09-14','08:40:00',1.88),('16273','2013-09-14','08:45:00',1.97),('16273','2013-09-14','08:50:00',2.05),('16273','2013-09-14','08:55:00',2.12),('16273','2013-09-14','09:00:00',2.21),('16273','2013-09-14','09:05:00',2.3),('16273','2013-09-14','09:10:00',2.37),('16273','2013-09-14','09:15:00',2.43),('16273','2013-09-14','09:20:00',2.5),('16273','2013-09-14','09:25:00',2.57),('16273','2013-09-14','09:30:00',2.64),('16273','2013-09-14','09:35:00',2.71),('16273','2013-09-14','09:40:00',2.76),('16273','2013-09-14','09:45:00',2.77),('16273','2013-09-14','09:50:00',2.86),('16273','2013-09-14','09:55:00',2.91),('16273','2013-09-14','10:00:00',2.93),('16273','2013-09-14','10:05:00',2.75),('16273','2013-09-14','10:10:00',2.8),('16273','2013-09-14','10:15:00',3.04),('16273','2013-09-14','10:20:00',3.04),('16273','2013-09-14','10:25:00',3.13),('16273','2013-09-14','10:30:00',3.24),('16273','2013-09-14','10:35:00',2.95),('16273','2013-09-14','10:40:00',2.46),('16273','2013-09-14','10:45:00',2.16),('16273','2013-09-14','10:50:00',2.11),('16273','2013-09-14','10:55:00',3.56),('16273','2013-09-14','11:00:00',3.65),('16273','2013-09-14','11:05:00',1.45),('16273','2013-09-14','11:10:00',3.72),('16273','2013-09-14','11:15:00',3.51),('16273','2013-09-14','11:20:00',3.59),('16273','2013-09-14','11:25:00',3.59),('16273','2013-09-14','11:30:00',2.77),('16273','2013-09-14','11:35:00',3.61),('16273','2013-09-14','11:40:00',3.64),('16273','2013-09-14','11:45:00',3.48),('16273','2013-09-14','11:50:00',3.7),('16273','2013-09-14','11:55:00',3.66),('16273','2013-09-14','12:00:00',3.57),('16273','2013-09-14','12:05:00',3.18),('16273','2013-09-14','12:10:00',3.73),('16273','2013-09-14','12:15:00',3.65),('16273','2013-09-14','12:20:00',2.57),('16273','2013-09-14','12:25:00',3.76),('16273','2013-09-14','12:30:00',3.71),('16273','2013-09-14','12:35:00',3.67),('16273','2013-09-14','12:40:00',3.72),('16273','2013-09-14','12:45:00',3.76),('16273','2013-09-14','12:50:00',3.71),('16273','2013-09-14','12:55:00',3.68),('16273','2013-09-14','13:00:00',3.7),('16273','2013-09-14','13:05:00',3.7),('16273','2013-09-14','13:10:00',3.67),('16273','2013-09-14','13:15:00',3.68),('16273','2013-09-14','13:20:00',3.63),('16273','2013-09-14','13:25:00',3.58),('16273','2013-09-14','13:30:00',3.44),('16273','2013-09-14','13:35:00',3.61),('16273','2013-09-14','13:40:00',4),('16273','2013-09-14','13:45:00',3.75),('16273','2013-09-14','13:50:00',3.94),('16273','2013-09-14','13:55:00',3.73),('16273','2013-09-14','14:00:00',3.42),('16273','2013-09-14','14:05:00',3.28),('16273','2013-09-14','14:10:00',3.31),('16273','2013-09-14','14:15:00',3.24),('16273','2013-09-14','14:20:00',3.19),('16273','2013-09-14','14:25:00',3.15),('16273','2013-09-14','14:30:00',3.11),('16273','2013-09-14','14:35:00',3.09),('16273','2013-09-14','14:40:00',3.03),('16273','2013-09-14','14:45:00',2.99),('16273','2013-09-14','14:50:00',2.95),('16273','2013-09-14','14:55:00',2.86),('16273','2013-09-14','15:00:00',2.83),('16273','2013-09-14','15:05:00',2.79),('16273','2013-09-14','15:10:00',2.74),('16273','2013-09-14','15:15:00',2.68),('16273','2013-09-14','15:20:00',2.63),('16273','2013-09-14','15:25:00',2.57),('16273','2013-09-14','15:30:00',2.51),('16273','2013-09-14','15:35:00',2.46),('16273','2013-09-14','15:40:00',2.38),('16273','2013-09-14','15:45:00',2.32),('16273','2013-09-14','15:50:00',2.25),('16273','2013-09-14','15:55:00',2.18),('16273','2013-09-14','16:00:00',2.12),('16273','2013-09-14','16:05:00',2.03),('16273','2013-09-14','16:10:00',1.96),('16273','2013-09-14','16:15:00',1.89),('16273','2013-09-14','16:20:00',1.83),('16273','2013-09-14','16:25:00',1.76),('16273','2013-09-14','16:30:00',1.68),('16273','2013-09-14','16:35:00',1.6),('16273','2013-09-14','16:40:00',1.52),('16273','2013-09-14','16:45:00',1.45),('16273','2013-09-14','16:50:00',1.39),('16273','2013-09-14','16:55:00',1.31),('16273','2013-09-14','17:00:00',1.23),('16273','2013-09-14','17:05:00',1.14),('16273','2013-09-14','17:10:00',1.12),('16273','2013-09-13','09:25:00',1.02),('16273','2013-09-13','09:30:00',1.11),('16273','2013-09-13','09:35:00',1.17),('16273','2013-09-13','09:40:00',1.31),('16273','2013-09-13','09:45:00',1.4),('16273','2013-09-13','09:50:00',1.3),('16273','2013-09-13','09:55:00',2.28),('16273','2013-09-13','10:00:00',3.34),('16273','2013-09-13','10:05:00',2.64),('16273','2013-09-13','10:10:00',3.38),('16273','2013-09-13','10:15:00',3.53),('16273','2013-09-13','10:20:00',2.37),('16273','2013-09-13','10:25:00',2.83),('16273','2013-09-13','10:30:00',3.36),('16273','2013-09-13','10:35:00',3.27),('16273','2013-09-13','10:40:00',3.31),('16273','2013-09-13','10:45:00',3.34),('16273','2013-09-13','10:50:00',3.34),('16273','2013-09-13','10:55:00',3.38),('16273','2013-09-13','11:00:00',3.4),('16273','2013-09-13','11:05:00',3.44),('16273','2013-09-13','11:10:00',3.47),('16273','2013-09-13','11:15:00',3.49),('16273','2013-09-13','11:20:00',3.52),('16273','2013-09-13','11:25:00',3.55),('16273','2013-09-13','11:30:00',3.55),('16273','2013-09-13','11:35:00',3.57),('16273','2013-09-13','11:40:00',3.55),('16273','2013-09-13','11:45:00',3.56),('16273','2013-09-13','11:50:00',3.5),('16273','2013-09-13','11:55:00',3.58),('16273','2013-09-13','12:00:00',2.76),('16273','2013-09-13','12:05:00',3.68),('16273','2013-09-13','12:10:00',1.72),('16273','2013-09-13','12:15:00',3.87),('16273','2013-09-13','12:20:00',3.82),('16273','2013-09-13','12:25:00',3.82),('16273','2013-09-13','12:30:00',3.81),('16273','2013-09-13','12:35:00',3.8),('16273','2013-09-13','12:40:00',3.8),('16273','2013-09-13','12:45:00',3.66),('16273','2013-09-13','12:50:00',3.67),('16273','2013-09-13','12:55:00',3.63),('16273','2013-09-13','13:00:00',3.6),('16273','2013-09-13','13:05:00',3.66),('16273','2013-09-13','13:10:00',3.62),('16273','2013-09-13','13:15:00',3.63),('16273','2013-09-13','13:20:00',3.59),('16273','2013-09-13','13:25:00',3.57),('16273','2013-09-13','13:30:00',3.48),('16273','2013-09-13','13:35:00',3.43),('16273','2013-09-13','13:40:00',3.46),('16273','2013-09-13','13:45:00',3.45),('16273','2013-09-13','13:50:00',3.42),('16273','2013-09-13','13:55:00',3.37),('16273','2013-09-13','14:00:00',3.32),('16273','2013-09-13','14:05:00',3.32),('16273','2013-09-13','14:10:00',3.26),('16273','2013-09-13','14:15:00',3.26),('16273','2013-09-13','14:20:00',3.23),('16273','2013-09-13','14:25:00',3.23),('16273','2013-09-13','14:30:00',3.18),('16273','2013-09-13','14:35:00',3.13),('16273','2013-09-13','14:40:00',3.07),('16273','2013-09-13','14:45:00',3.05),('16273','2013-09-13','14:50:00',2.97),('16273','2013-09-13','14:55:00',2.93),('16273','2013-09-13','15:00:00',2.9),('16273','2013-09-13','15:05:00',2.84),('16273','2013-09-13','15:10:00',2.78),('16273','2013-09-13','15:15:00',2.73),('16273','2013-09-13','15:20:00',2.66),('16273','2013-09-13','15:25:00',2.59),('16273','2013-09-13','15:30:00',2.55),('16273','2013-09-13','15:35:00',2.5),('16273','2013-09-13','15:40:00',2.43),('16273','2013-09-13','15:45:00',2.36),('16273','2013-09-13','15:50:00',2.3),('16273','2013-09-13','15:55:00',2.22),('16273','2013-09-13','16:00:00',2.16),('16273','2013-09-13','16:05:00',2.09),('16273','2013-09-13','16:10:00',2.02),('16273','2013-09-13','16:15:00',1.94),('16273','2013-09-13','16:20:00',1.86),('16273','2013-09-13','16:25:00',1.78),('16273','2013-09-13','16:30:00',1.71),('16273','2013-09-13','16:35:00',1.63),('16273','2013-09-13','16:40:00',1.55),('16273','2013-09-13','16:45:00',1.48),('16273','2013-09-13','16:50:00',1.4),('16273','2013-09-13','16:55:00',1.32),('16273','2013-09-13','17:00:00',1.25),('16273','2013-09-13','17:05:00',1.17),('16273','2013-09-13','17:10:00',1.09),('16273','2013-09-13','17:15:00',1.04),('16273','2013-09-12','08:15:00',1.35),('16273','2013-09-12','08:20:00',1.72),('16273','2013-09-12','08:25:00',1.26),('16273','2013-09-12','08:50:00',2.11),('16273','2013-09-12','08:55:00',2.1),('16273','2013-09-12','09:00:00',2.18),('16273','2013-09-12','09:05:00',1.79),('16273','2013-09-12','09:10:00',1.76),('16273','2013-09-12','09:15:00',1.83),('16273','2013-09-12','09:20:00',2.4),('16273','2013-09-12','09:25:00',2.9),('16273','2013-09-12','09:30:00',1.89),('16273','2013-09-12','09:35:00',1.35),('16273','2013-09-12','09:50:00',1.1),('16273','2013-09-12','09:55:00',1.17),('16273','2013-09-12','10:00:00',1.8),('16273','2013-09-12','10:05:00',2.57),('16273','2013-09-12','10:10:00',1.85),('16273','2013-09-12','10:15:00',1.37),('16273','2013-09-12','10:20:00',1.05),('16273','2013-09-12','10:25:00',2.48),('16273','2013-09-12','10:30:00',2.22),('16273','2013-09-12','10:35:00',1.61),('16273','2013-09-12','10:40:00',1.33),('16273','2013-09-12','10:45:00',2.12),('16273','2013-09-12','10:50:00',2.49),('16273','2013-09-12','10:55:00',3.82),('16273','2013-09-12','11:00:00',4.26),('16273','2013-09-12','11:05:00',3.86),('16273','2013-09-12','11:10:00',3.35),('16273','2013-09-12','11:30:00',2.14),('16273','2013-09-12','11:35:00',1.55),('16273','2013-09-12','11:40:00',1.54),('16273','2013-09-12','11:45:00',3.18),('16273','2013-09-12','11:50:00',3.33),('16273','2013-09-12','11:55:00',3.84),('16273','2013-09-12','12:00:00',3.77),('16273','2013-09-12','12:05:00',4.01),('16273','2013-09-12','12:10:00',2.45),('16273','2013-09-12','12:15:00',3.45),('16273','2013-09-12','12:20:00',4.29),('16273','2013-09-12','12:25:00',2.82),('16273','2013-09-12','12:30:00',3.99),('16273','2013-09-12','12:35:00',2.84),('16273','2013-09-12','12:40:00',4.11),('16273','2013-09-12','12:45:00',3.1),('16273','2013-09-12','12:50:00',3.8),('16273','2013-09-12','12:55:00',3.75),('16273','2013-09-12','13:00:00',3.53),('16273','2013-09-12','13:05:00',3.86),('16273','2013-09-12','13:10:00',3.62),('16273','2013-09-12','13:15:00',4.05),('16273','2013-09-12','13:20:00',3.37),('16273','2013-09-12','13:25:00',3.69),('16273','2013-09-12','13:30:00',3.76),('16273','2013-09-12','13:35:00',3.75),('16273','2013-09-12','13:40:00',3.6),('16273','2013-09-12','13:45:00',3.55),('16273','2013-09-12','13:50:00',3.44),('16273','2013-09-12','13:55:00',3.51),('16273','2013-09-12','14:00:00',3.49),('16273','2013-09-12','14:05:00',3.48),('16273','2013-09-12','14:10:00',3.47),('16273','2013-09-12','14:15:00',3.31),('16273','2013-09-12','14:20:00',3.08),('16273','2013-09-12','14:25:00',2.22),('16273','2013-09-12','14:30:00',3.21),('16273','2013-09-12','14:35:00',3.43),('16273','2013-09-12','14:40:00',2.41),('16273','2013-09-12','14:45:00',2.75),('16273','2013-09-12','14:50:00',2.89),('16273','2013-09-12','14:55:00',1.84),('16273','2013-09-12','15:00:00',3.06),('16273','2013-09-12','15:05:00',2.95),('16273','2013-09-12','15:10:00',2.87),('16273','2013-09-12','15:15:00',2.83),('16273','2013-09-12','15:20:00',2.77),('16273','2013-09-12','15:25:00',2.71),('16273','2013-09-12','15:30:00',2.64),('16273','2013-09-12','15:35:00',2.57),('16273','2013-09-12','15:40:00',2.51),('16273','2013-09-12','15:45:00',1.82),('16273','2013-09-12','15:50:00',2.27),('16273','2013-09-12','15:55:00',1.51),('16273','2013-09-12','16:00:00',2.37),('16273','2013-09-12','16:05:00',1.6),('16273','2013-09-12','16:10:00',2.1),('16273','2013-09-12','16:15:00',1.4),('16273','2013-09-12','16:20:00',2),('16273','2013-09-12','16:25:00',1.97),('16273','2013-09-12','16:35:00',1.66),('16273','2013-09-12','16:40:00',1.61),('16273','2013-09-12','16:50:00',1.6),('16273','2013-09-12','16:55:00',1.51),('16273','2013-09-12','17:00:00',1.34),('16273','2013-09-12','17:05:00',1.21),('16273','2013-09-12','17:20:00',1.06),('16273','2013-09-11','08:00:00',1.34),('16273','2013-09-11','08:55:00',1.17),('16273','2013-09-11','09:05:00',1.52),('16273','2013-09-11','09:10:00',2.6),('16273','2013-09-11','09:20:00',1.02),('16273','2013-09-11','09:25:00',1.63),('16273','2013-09-11','09:50:00',1.19),('16273','2013-09-11','09:55:00',2.23),('16273','2013-09-11','10:00:00',2.15),('16273','2013-09-11','10:05:00',1.81),('16273','2013-09-11','10:10:00',3.13),('16273','2013-09-11','10:15:00',3.16),('16273','2013-09-11','10:20:00',3.18),('16273','2013-09-11','10:25:00',3.28),('16273','2013-09-11','10:30:00',3.19),('16273','2013-09-11','10:35:00',3.39),('16273','2013-09-11','10:40:00',1.52),('16273','2013-09-11','10:45:00',2.8),('16273','2013-09-11','10:50:00',2.87),('16273','2013-09-11','10:55:00',2.75),('16273','2013-09-11','11:00:00',2.87),('16273','2013-09-11','11:05:00',3.65),('16273','2013-09-11','11:10:00',3.37),('16273','2013-09-11','11:15:00',3.48),('16273','2013-09-11','11:20:00',3.12),('16273','2013-09-11','11:25:00',3.85),('16273','2013-09-11','11:30:00',3.83),('16273','2013-09-11','11:35:00',3.87),('16273','2013-09-11','11:40:00',2.1),('16273','2013-09-11','11:45:00',2.67),('16273','2013-09-11','11:50:00',3.95),('16273','2013-09-11','11:55:00',3.8),('16273','2013-09-11','12:00:00',2.81),('16273','2013-09-11','12:05:00',4.09),('16273','2013-09-11','12:10:00',4.05),('16273','2013-09-11','12:15:00',4.2),('16273','2013-09-11','12:20:00',3.01),('16273','2013-09-11','12:25:00',3.66),('16273','2013-09-11','12:30:00',1.63),('16273','2013-09-11','12:35:00',2.66),('16273','2013-09-11','12:40:00',3.11),('16273','2013-09-11','12:45:00',3),('16273','2013-09-11','12:50:00',3.96),('16273','2013-09-11','12:55:00',3.41),('16273','2013-09-11','13:00:00',2.21),('16273','2013-09-11','13:05:00',2.46),('16273','2013-09-11','13:10:00',3.42),('16273','2013-09-11','13:15:00',4.04),('16273','2013-09-11','13:20:00',4.17),('16273','2013-09-11','13:25:00',3.24),('16273','2013-09-11','13:30:00',2.82),('16273','2013-09-11','13:35:00',4.11),('16273','2013-09-11','13:40:00',3.39),('16273','2013-09-11','13:45:00',3.98),('16273','2013-09-11','13:50:00',3.61),('16273','2013-09-11','13:55:00',3.69),('16273','2013-09-11','14:00:00',3.16),('16273','2013-09-11','14:05:00',3.48),('16273','2013-09-11','14:10:00',2.78),('16273','2013-09-11','14:15:00',2.53),('16273','2013-09-11','14:20:00',2.91),('16273','2013-09-11','14:25:00',2.68),('16273','2013-09-11','14:30:00',2.71),('16273','2013-09-11','14:35:00',2),('16273','2013-09-11','14:40:00',2.27),('16273','2013-09-11','14:45:00',3.44),('16273','2013-09-11','14:50:00',1.24),('16273','2013-09-11','14:55:00',2.89),('16273','2013-09-11','15:00:00',2.96),('16273','2013-09-11','15:05:00',2.53),('16273','2013-09-11','15:10:00',2.57),('16273','2013-09-11','15:15:00',1.45),('16273','2013-09-11','15:20:00',1.9),('16273','2013-09-11','15:25:00',1.35),('16273','2013-09-11','15:30:00',1.62),('16273','2013-09-11','15:35:00',1.59),('16273','2013-09-11','15:40:00',2.08),('16273','2013-09-11','15:45:00',1),('16273','2013-09-11','15:50:00',1.06),('16273','2013-09-11','15:55:00',1.88),('16273','2013-09-11','16:05:00',1.08),('16273','2013-09-11','16:10:00',2.18),('16273','2013-09-11','16:15:00',1.48),('16273','2013-09-11','16:20:00',1.21),('16273','2013-09-11','16:25:00',1.78),('16273','2013-09-11','16:30:00',1.53),('16273','2013-09-11','16:35:00',1.81),('16273','2013-09-11','16:40:00',1.64),('16273','2013-09-11','16:45:00',1.61),('16273','2013-09-11','16:50:00',1.51),('16273','2013-09-11','16:55:00',1.44),('16273','2013-09-11','17:00:00',1.33),('16273','2013-09-11','17:05:00',1.21),('16273','2013-09-11','17:10:00',1.15),('16273','2013-09-11','17:15:00',1.1),('16273','2013-09-11','17:20:00',1.06),('16273','2013-09-11','17:25:00',1.02),('16273','2013-09-11','17:30:00',1.01),('16273','2013-09-10','08:45:00',1.19),('16273','2013-09-10','08:50:00',1.88),('16273','2013-09-10','08:55:00',2.1),('16273','2013-09-10','09:00:00',2.08),('16273','2013-09-10','09:05:00',1.55),('16273','2013-09-10','09:10:00',1.75),('16273','2013-09-10','09:15:00',1.35),('16273','2013-09-10','10:40:00',1.43),('16273','2013-09-10','10:45:00',1.28),('16273','2013-09-10','10:50:00',1.19),('16273','2013-09-10','10:55:00',1.35),('16273','2013-09-10','11:00:00',1.53),('16273','2013-09-10','11:45:00',1.16),('16273','2013-09-10','11:50:00',1.11),('16273','2013-09-10','11:55:00',1.24),('16273','2013-09-10','12:10:00',1.39),('16273','2013-09-10','12:15:00',1.91),('16273','2013-09-10','12:20:00',1.47),('16273','2013-09-10','12:25:00',1.3),('16273','2013-09-10','13:35:00',1.39),('16273','2013-09-10','13:40:00',1.82),('16273','2013-09-10','13:45:00',1.72),('16273','2013-09-10','13:50:00',2.05),('16273','2013-09-10','13:55:00',1.3),('16273','2013-09-10','14:00:00',1.3),('16273','2013-09-10','14:05:00',1.16),('16273','2013-09-10','14:10:00',1.34),('16273','2013-09-10','14:15:00',1.51),('16273','2013-09-10','14:20:00',1.92),('16273','2013-09-10','14:25:00',2),('16273','2013-09-10','14:30:00',1.53),('16273','2013-09-10','14:35:00',1.42),('16273','2013-09-10','14:40:00',1.66),('16273','2013-09-10','14:45:00',2.03),('16273','2013-09-10','14:50:00',2.07),('16273','2013-09-10','14:55:00',1.96),('16273','2013-09-10','15:00:00',2.05),('16273','2013-09-10','15:05:00',2.3),('16273','2013-09-10','15:10:00',1.84),('16273','2013-09-10','15:15:00',1.33),('16273','2013-09-10','15:20:00',1.24),('16273','2013-09-10','15:25:00',1.48),('16273','2013-09-10','15:30:00',1.5),('16273','2013-09-10','15:35:00',1.27),('16273','2013-09-10','15:40:00',1.15),('16273','2013-09-10','15:45:00',1.09),('16273','2013-09-10','15:50:00',1.04),('16273','2013-09-10','16:10:00',1.04),('16273','2013-09-09','08:50:00',1.03),('16273','2013-09-09','08:55:00',1.16),('16273','2013-09-09','09:00:00',1.06),('16273','2013-09-09','09:15:00',1.08),('16273','2013-09-09','09:35:00',1.05),('16273','2013-09-09','09:40:00',1.12),('16273','2013-09-09','09:45:00',1.19),('16273','2013-09-09','09:50:00',1.06),('16273','2013-09-09','10:05:00',1.03),('16273','2013-09-09','10:10:00',1.29),('16273','2013-09-09','10:15:00',1.42),('16273','2013-09-09','10:20:00',1.36),('16273','2013-09-09','10:25:00',1.42),('16273','2013-09-09','10:30:00',1.34),('16273','2013-09-09','10:35:00',1.62),('16273','2013-09-09','10:40:00',1.95),('16273','2013-09-09','10:45:00',2.61),('16273','2013-09-09','10:50:00',2.53),('16273','2013-09-09','10:55:00',2.64),('16273','2013-09-09','11:00:00',2.32),('16273','2013-09-09','11:05:00',1.51),('16273','2013-09-09','11:10:00',1.56),('16273','2013-09-09','11:15:00',2.35),('16273','2013-09-09','11:20:00',2.81),('16273','2013-09-09','11:25:00',1.94),('16273','2013-09-09','11:30:00',1.69),('16273','2013-09-09','11:35:00',1.83),('16273','2013-09-09','11:40:00',3.33),('16273','2013-09-09','11:45:00',2.84),('16273','2013-09-09','11:50:00',2.3),('16273','2013-09-09','11:55:00',2.98),('16273','2013-09-09','12:00:00',1.77),('16273','2013-09-09','12:05:00',1.34),('16273','2013-09-09','12:10:00',1.17),('16273','2013-09-09','12:15:00',1.18),('16273','2013-09-09','12:20:00',1.21),('16273','2013-09-09','12:25:00',1.23),('16273','2013-09-09','12:30:00',1.56),('16273','2013-09-09','12:35:00',1.89),('16273','2013-09-09','12:40:00',1.86),('16273','2013-09-09','12:45:00',1.88),('16273','2013-09-09','12:50:00',2.14),('16273','2013-09-09','12:55:00',1.97),('16273','2013-09-09','13:00:00',2.36),('16273','2013-09-09','13:05:00',3.1),('16273','2013-09-09','13:10:00',3.38),('16273','2013-09-09','13:15:00',2.6),('16273','2013-09-09','13:20:00',2.64),('16273','2013-09-09','13:25:00',3.22),('16273','2013-09-09','13:30:00',3.4),('16273','2013-09-09','13:35:00',3.47),('16273','2013-09-09','13:40:00',2.23),('16273','2013-09-09','13:45:00',2.13),('16273','2013-09-09','13:50:00',3.75),('16273','2013-09-09','13:55:00',1.76),('16273','2013-09-09','14:00:00',3.25),('16273','2013-09-09','14:05:00',2.96),('16273','2013-09-09','14:10:00',2.92),('16273','2013-09-09','14:15:00',2.45),('16273','2013-09-09','14:20:00',1.41),('16273','2013-09-09','14:25:00',2.19),('16273','2013-09-09','14:30:00',2.78),('16273','2013-09-09','14:35:00',2.34),('16273','2013-09-09','14:40:00',2.78),('16273','2013-09-09','14:45:00',2.61),('16273','2013-09-09','14:50:00',2.41),('16273','2013-09-09','14:55:00',2.57),('16273','2013-09-09','15:00:00',2.96),('16273','2013-09-09','15:05:00',2.98),('16273','2013-09-09','15:10:00',2.82),('16273','2013-09-09','15:15:00',2.7),('16273','2013-09-09','15:20:00',2.11),('16273','2013-09-09','15:25:00',1.58),('16273','2013-09-09','15:30:00',1.74),('16273','2013-09-09','15:35:00',1.95),('16273','2013-09-09','15:40:00',1.59),('16273','2013-09-09','15:45:00',1.84),('16273','2013-09-09','15:50:00',1.78),('16273','2013-09-09','15:55:00',1.01),('16273','2013-09-09','16:00:00',1.16),('16273','2013-09-09','16:05:00',1.62),('16273','2013-09-09','16:10:00',2.17),('16273','2013-09-09','16:15:00',1.26),('16273','2013-09-09','16:20:00',1.18),('16273','2013-09-09','16:40:00',1.18),('16273','2013-09-09','16:45:00',1.13),('16273','2014-04-12','08:35:00',1.16),('16273','2014-04-12','08:40:00',1.44),('16273','2014-04-12','08:45:00',1.64),('16273','2014-04-12','08:50:00',1.8),('16273','2014-04-12','08:55:00',1.31),('16273','2014-04-12','09:00:00',1.6),('16273','2014-04-12','09:05:00',2.35),('16273','2014-04-12','09:10:00',2.21),('16273','2014-04-12','09:15:00',1.28),('16273','2014-04-12','09:20:00',1.32),('16273','2014-04-12','09:25:00',1.51),('16273','2014-04-12','09:30:00',1.55),('16273','2014-04-12','09:35:00',1.48),('16273','2014-04-12','09:40:00',1.77),('16273','2014-04-12','09:45:00',1.54),('16273','2014-04-12','09:50:00',1.53),('16273','2014-04-12','09:55:00',1.69),('16273','2014-04-12','10:00:00',1.88),('16273','2014-04-12','10:05:00',1.78),('16273','2014-04-12','10:10:00',1.46),('16273','2014-04-12','10:15:00',1.35),('16273','2014-04-12','10:20:00',1.46),('16273','2014-04-12','10:25:00',1.64),('16273','2014-04-12','10:30:00',1.81),('16273','2014-04-12','10:35:00',1.83),('16273','2014-04-12','10:40:00',2.22),('16273','2014-04-12','10:45:00',2.77),('16273','2014-04-12','10:50:00',2.92),('16273','2014-04-12','10:55:00',3.43),('16273','2014-04-12','11:00:00',3.09),('16273','2014-04-12','11:05:00',3.68),('16273','2014-04-12','11:10:00',3.88),('16273','2014-04-12','11:15:00',2.21),('16273','2014-04-12','11:20:00',2.21),('16273','2014-04-12','11:25:00',2.57),('16273','2014-04-12','11:30:00',2.12),('16273','2014-04-12','11:35:00',2.4),('16273','2014-04-12','11:40:00',2.66),('16273','2014-04-12','11:45:00',3.47),('16273','2014-04-12','11:50:00',2.32),('16273','2014-04-12','11:55:00',3.11),('16273','2014-04-12','12:00:00',1.38),('16273','2014-04-12','12:05:00',1.31),('16273','2014-04-12','12:10:00',1.41),('16273','2014-04-12','12:15:00',1.5),('16273','2014-04-12','12:20:00',2.24),('16273','2014-04-12','12:25:00',1.96),('16273','2014-04-12','12:30:00',1.92),('16273','2014-04-12','12:35:00',1.42),('16273','2014-04-12','12:40:00',2.18),('16273','2014-04-12','12:45:00',2.78),('16273','2014-04-12','12:50:00',2.9),('16273','2014-04-12','12:55:00',2.79),('16273','2014-04-12','13:00:00',3.23),('16273','2014-04-12','13:05:00',2.72),('16273','2014-04-12','13:10:00',4.08),('16273','2014-04-12','13:15:00',4.09),('16273','2014-04-12','13:20:00',3.61),('16273','2014-04-12','13:25:00',3.65),('16273','2014-04-12','13:30:00',3.97),('16273','2014-04-12','13:35:00',3.51),('16273','2014-04-12','13:40:00',3.8),('16273','2014-04-12','13:45:00',3.51),('16273','2014-04-12','13:50:00',2.72),('16273','2014-04-12','13:55:00',2.45),('16273','2014-04-12','14:00:00',2.33),('16273','2014-04-12','14:05:00',3.13),('16273','2014-04-12','14:10:00',3),('16273','2014-04-12','14:15:00',3.06),('16273','2014-04-12','14:20:00',3.28),('16273','2014-04-12','14:25:00',2.7),('16273','2014-04-12','14:30:00',2.61),('16273','2014-04-12','14:35:00',2.49),('16273','2014-04-12','14:40:00',3.11),('16273','2014-04-12','14:45:00',2.75),('16273','2014-04-12','14:50:00',2.82),('16273','2014-04-12','14:55:00',2.88),('16273','2014-04-12','15:00:00',3.06),('16273','2014-04-12','15:05:00',3.07),('16273','2014-04-12','15:10:00',2.76),('16273','2014-04-12','15:15:00',2.25),('16273','2014-04-12','15:20:00',2.69),('16273','2014-04-12','15:25:00',2.47),('16273','2014-04-12','15:30:00',2.2),('16273','2014-04-12','15:35:00',2.1),('16273','2014-04-12','15:40:00',2.53),('16273','2014-04-12','15:45:00',2.58),('16273','2014-04-12','15:50:00',2.71),('16273','2014-04-12','15:55:00',2.63),('16273','2014-04-12','16:00:00',2.49),('16273','2014-04-12','16:05:00',2.4),('16273','2014-04-12','16:10:00',2.34),('16273','2014-04-12','16:15:00',2.32),('16273','2014-04-12','16:20:00',2.03),('16273','2014-04-12','16:25:00',2.03),('16273','2014-04-12','16:30:00',1.82),('16273','2014-04-12','16:35:00',2.18),('16273','2014-04-12','16:40:00',2.07),('16273','2014-04-12','16:45:00',1.37),('16273','2014-04-12','16:50:00',2.03),('16273','2014-04-12','16:55:00',1.79),('16273','2014-04-12','17:00:00',1.53),('16273','2014-04-12','17:05:00',1.43),('16273','2014-04-12','17:10:00',1.38),('16273','2014-04-12','17:15:00',1.26),('16273','2014-04-12','17:20:00',1.13),('16273','2014-04-12','17:25:00',1.29),('16273','2014-04-12','17:30:00',1.19),('16273','2014-04-12','17:35:00',1.16),('16273','2014-04-12','17:40:00',1.19),('16273','2014-04-12','17:45:00',1.05),('16273','2014-04-12','17:50:00',1.05),('16273','2013-09-08','08:35:00',1.34),('16273','2013-09-08','08:40:00',1.59),('16273','2013-09-08','08:50:00',1.08),('16273','2013-09-08','08:55:00',1.6),('16273','2013-09-08','09:00:00',2.04),('16273','2013-09-08','09:05:00',2.02),('16273','2013-09-08','09:10:00',2.07),('16273','2013-09-08','09:15:00',2.24),('16273','2013-09-08','09:20:00',2.27),('16273','2013-09-08','09:25:00',2.3),('16273','2013-09-08','09:30:00',2.36),('16273','2013-09-08','09:35:00',2.43),('16273','2013-09-08','09:40:00',2.52),('16273','2013-09-08','09:45:00',2.53),('16273','2013-09-08','09:50:00',2.6),('16273','2013-09-08','09:55:00',2.67),('16273','2013-09-08','10:00:00',2.73),('16273','2013-09-08','10:05:00',2.81),('16273','2013-09-08','10:10:00',2.85),('16273','2013-09-08','10:15:00',2.84),('16273','2013-09-08','10:20:00',2.86),('16273','2013-09-08','10:25:00',2.98),('16273','2013-09-08','10:30:00',3.04),('16273','2013-09-08','10:35:00',3.07),('16273','2013-09-08','10:40:00',3.04),('16273','2013-09-08','10:45:00',3.1),('16273','2013-09-08','10:50:00',3.11),('16273','2013-09-08','10:55:00',3.16),('16273','2013-09-08','11:00:00',3.11),('16273','2013-09-08','11:05:00',3.19),('16273','2013-09-08','11:10:00',3.2),('16273','2013-09-08','11:15:00',3.2),('16273','2013-09-08','11:20:00',3.22),('16273','2013-09-08','11:25:00',3.26),('16273','2013-09-08','11:30:00',3.24),('16273','2013-09-08','11:35:00',3.19),('16273','2013-09-08','11:40:00',2.99),('16273','2013-09-08','11:45:00',3.22),('16273','2013-09-08','11:50:00',3.16),('16273','2013-09-08','11:55:00',2.74),('16273','2013-09-08','12:00:00',3.17),('16273','2013-09-08','12:05:00',3.33),('16273','2013-09-08','12:10:00',3.46),('16273','2013-09-08','12:15:00',3.43),('16273','2013-09-08','12:20:00',3.4),('16273','2013-09-08','12:25:00',3.43),('16273','2013-09-08','12:30:00',3.4),('16273','2013-09-08','12:35:00',3.29),('16273','2013-09-08','12:40:00',3.3),('16273','2013-09-08','12:45:00',3.31),('16273','2013-09-08','12:50:00',3.26),('16273','2013-09-08','12:55:00',3.25),('16273','2013-09-08','13:00:00',3.35),('16273','2013-09-08','13:05:00',3.35),('16273','2013-09-08','13:10:00',3.27),('16273','2013-09-08','13:15:00',3.24),('16273','2013-09-08','13:20:00',2.97),('16273','2013-09-08','13:25:00',2.98),('16273','2013-09-08','13:30:00',2.66),('16273','2013-09-08','13:35:00',1.85),('16273','2013-09-08','13:40:00',2.09),('16273','2013-09-08','13:45:00',3.05),('16273','2013-09-08','13:50:00',3.01),('16273','2013-09-08','13:55:00',3.2),('16273','2013-09-08','14:00:00',2.96),('16273','2013-09-08','14:05:00',3.32),('16273','2013-09-08','14:10:00',3.08),('16273','2013-09-08','14:15:00',3.52),('16273','2013-09-08','14:20:00',3.42),('16273','2013-09-08','14:25:00',3.14),('16273','2013-09-08','14:30:00',3.19),('16273','2013-09-08','14:35:00',3.08),('16273','2013-09-08','14:40:00',3.1),('16273','2013-09-08','14:45:00',2.89),('16273','2013-09-08','14:50:00',2.76),('16273','2013-09-08','14:55:00',2.91),('16273','2013-09-08','15:00:00',2.21),('16273','2013-09-08','15:05:00',1.46),('16273','2013-09-08','15:10:00',2.26),('16273','2013-09-08','15:15:00',2.69),('16273','2013-09-08','15:20:00',2.79),('16273','2013-09-08','15:25:00',2.69),('16273','2013-09-08','15:30:00',2.58),('16273','2013-09-08','15:35:00',2.34),('16273','2013-09-08','15:40:00',2.42),('16273','2013-09-08','15:45:00',2.12),('16273','2013-09-08','15:50:00',1.96),('16273','2013-09-08','15:55:00',2.05),('16273','2013-09-08','16:00:00',2.03),('16273','2013-09-08','16:05:00',1.68),('16273','2013-09-08','16:10:00',1.72),('16273','2013-09-08','16:15:00',1.91),('16273','2013-09-08','16:20:00',1.67),('16273','2013-09-08','16:25:00',1.66),('16273','2013-09-08','16:30:00',1.59),('16273','2013-09-08','16:35:00',1.19),('16273','2013-09-08','16:40:00',1.43),('16273','2013-09-08','16:55:00',1.39),('16273','2013-09-08','17:00:00',1.43),('16273','2013-09-08','17:05:00',1.36),('16273','2013-09-08','17:10:00',1.23),('16273','2013-09-08','17:15:00',1.04),('16273','2013-09-08','17:20:00',1.01),('16273','2013-09-07','08:05:00',1.19),('16273','2013-09-07','08:10:00',1.28),('16273','2013-09-07','08:15:00',1.38),('16273','2013-09-07','08:20:00',1.46),('16273','2013-09-07','08:25:00',1.57),('16273','2013-09-07','08:30:00',1.66),('16273','2013-09-07','08:35:00',1.73),('16273','2013-09-07','08:40:00',1.8),('16273','2013-09-07','08:45:00',1.88),('16273','2013-09-07','08:50:00',1.97),('16273','2013-09-07','08:55:00',2.04),('16273','2013-09-07','09:00:00',2.13),('16273','2013-09-07','09:05:00',2.2),('16273','2013-09-07','09:10:00',2.27),('16273','2013-09-07','09:15:00',2.35),('16273','2013-09-07','09:20:00',2.4),('16273','2013-09-07','09:25:00',2.45),('16273','2013-09-07','09:30:00',2.5),('16273','2013-09-07','09:35:00',2.52),('16273','2013-09-07','09:40:00',2.6),('16273','2013-09-07','09:45:00',2.66),('16273','2013-09-07','09:50:00',2.7),('16273','2013-09-07','09:55:00',2.76),('16273','2013-09-07','10:00:00',2.81),('16273','2013-09-07','10:05:00',2.87),('16273','2013-09-07','10:10:00',2.91),('16273','2013-09-07','10:15:00',2.95),('16273','2013-09-07','10:20:00',2.98),('16273','2013-09-07','10:25:00',3.03),('16273','2013-09-07','10:30:00',3.09),('16273','2013-09-07','10:35:00',3.11),('16273','2013-09-07','10:40:00',3.12),('16273','2013-09-07','10:45:00',3.15),('16273','2013-09-07','10:50:00',3.11),('16273','2013-09-07','10:55:00',3.16),('16273','2013-09-07','11:00:00',3.26),('16273','2013-09-07','11:05:00',3.29),('16273','2013-09-07','11:10:00',3.29),('16273','2013-09-07','11:15:00',3.28),('16273','2013-09-07','11:20:00',3.29),('16273','2013-09-07','11:25:00',3.33),('16273','2013-09-07','11:30:00',3.35),('16273','2013-09-07','11:35:00',3.36),('16273','2013-09-07','11:40:00',3.39),('16273','2013-09-07','11:45:00',3.42),('16273','2013-09-07','11:50:00',3.4),('16273','2013-09-07','11:55:00',3.39),('16273','2013-09-07','12:00:00',3.39),('16273','2013-09-07','12:05:00',3.36),('16273','2013-09-07','12:10:00',3.44),('16273','2013-09-07','12:15:00',3.43),('16273','2013-09-07','12:20:00',3.41),('16273','2013-09-07','12:25:00',3.37),('16273','2013-09-07','12:30:00',3.37),('16273','2013-09-07','12:35:00',3.35),('16273','2013-09-07','12:40:00',3.4),('16273','2013-09-07','12:45:00',3.46),('16273','2013-09-07','12:50:00',3.49),('16273','2013-09-07','12:55:00',3.43),('16273','2013-09-07','13:00:00',3.4),('16273','2013-09-07','13:05:00',3.42),('16273','2013-09-07','13:10:00',3.45),('16273','2013-09-07','13:15:00',3.43),('16273','2013-09-07','13:20:00',3.38),('16273','2013-09-07','13:25:00',3.27),('16273','2013-09-07','13:30:00',3.31),('16273','2013-09-07','13:35:00',3.36),('16273','2013-09-07','13:40:00',3.37),('16273','2013-09-07','13:45:00',3.34),('16273','2013-09-07','13:50:00',3.25),('16273','2013-09-07','13:55:00',3.28),('16273','2013-09-07','14:00:00',3.24),('16273','2013-09-07','14:05:00',3.23),('16273','2013-09-07','14:10:00',3.22),('16273','2013-09-07','14:15:00',3.2),('16273','2013-09-07','14:20:00',3.16),('16273','2013-09-07','14:25:00',3.13),('16273','2013-09-07','14:30:00',3.1),('16273','2013-09-07','14:35:00',3.06),('16273','2013-09-07','14:40:00',3.01),('16273','2013-09-07','14:45:00',2.97),('16273','2013-09-07','14:50:00',2.92),('16273','2013-09-07','14:55:00',2.87),('16273','2013-09-07','15:00:00',2.82),('16273','2013-09-07','15:05:00',2.78),('16273','2013-09-07','15:10:00',2.74),('16273','2013-09-07','15:15:00',2.69),('16273','2013-09-07','15:20:00',2.63),('16273','2013-09-07','15:25:00',2.58),('16273','2013-09-07','15:30:00',2.52),('16273','2013-09-07','15:35:00',2.45),('16273','2013-09-07','15:40:00',2.4),('16273','2013-09-07','15:45:00',2.34),('16273','2013-09-07','15:50:00',2.27),('16273','2013-09-07','15:55:00',2.2),('16273','2013-09-07','16:00:00',2.13),('16273','2013-09-07','16:05:00',2.05),('16273','2013-09-07','16:10:00',1.99),('16273','2013-09-07','16:15:00',1.91),('16273','2013-09-07','16:20:00',1.84),('16273','2013-09-07','16:25:00',1.76),('16273','2013-09-07','16:30:00',1.69),('16273','2013-09-07','16:35:00',1.63),('16273','2013-09-07','16:40:00',1.55),('16273','2013-09-07','16:45:00',1.49),('16273','2013-09-07','16:50:00',1.41),('16273','2013-09-07','16:55:00',1.33),('16273','2013-09-07','17:00:00',1.26),('16273','2013-09-07','17:05:00',1.19),('16273','2013-09-07','17:10:00',1.12),('16273','2013-09-07','17:15:00',1.06),('16273','2013-09-06','07:55:00',1),('16273','2013-09-06','08:05:00',1.23),('16273','2013-09-06','08:10:00',1.32),('16273','2013-09-06','08:15:00',1.42),('16273','2013-09-06','08:20:00',1.51),('16273','2013-09-06','08:25:00',1.61),('16273','2013-09-06','08:30:00',1.69),('16273','2013-09-06','08:35:00',1.76),('16273','2013-09-06','08:40:00',1.86),('16273','2013-09-06','08:45:00',1.92),('16273','2013-09-06','08:50:00',1.98),('16273','2013-09-06','08:55:00',2.07),('16273','2013-09-06','09:00:00',2.13),('16273','2013-09-06','09:05:00',2.21),('16273','2013-09-06','09:10:00',2.3),('16273','2013-09-06','09:15:00',2.38),('16273','2013-09-06','09:20:00',2.43),('16273','2013-09-06','09:25:00',2.49),('16273','2013-09-06','09:30:00',2.56),('16273','2013-09-06','09:35:00',2.61),('16273','2013-09-06','09:40:00',2.69),('16273','2013-09-06','09:45:00',2.73),('16273','2013-09-06','09:50:00',2.76),('16273','2013-09-06','09:55:00',2.83),('16273','2013-09-06','10:00:00',2.88),('16273','2013-09-06','10:05:00',2.93),('16273','2013-09-06','10:10:00',2.97),('16273','2013-09-06','10:15:00',3.01),('16273','2013-09-06','10:20:00',3.05),('16273','2013-09-06','10:25:00',3.11),('16273','2013-09-06','10:30:00',3.17),('16273','2013-09-06','10:35:00',3.21),('16273','2013-09-06','10:40:00',3.22),('16273','2013-09-06','10:45:00',3.26),('16273','2013-09-06','10:50:00',3.28),('16273','2013-09-06','10:55:00',3.31),('16273','2013-09-06','11:00:00',3.34),('16273','2013-09-06','11:05:00',3.37),('16273','2013-09-06','11:10:00',3.38),('16273','2013-09-06','11:15:00',3.39),('16273','2013-09-06','11:20:00',3.41),('16273','2013-09-06','11:25:00',3.43),('16273','2013-09-06','11:30:00',3.43),('16273','2013-09-06','11:35:00',3.43),('16273','2013-09-06','11:40:00',3.46),('16273','2013-09-06','11:45:00',3.48),('16273','2013-09-06','11:50:00',3.49),('16273','2013-09-06','11:55:00',3.52),('16273','2013-09-06','12:00:00',3.5),('16273','2013-09-06','12:05:00',3.48),('16273','2013-09-06','12:10:00',3.51),('16273','2013-09-06','12:15:00',3.51),('16273','2013-09-06','12:20:00',3.5),('16273','2013-09-06','12:25:00',3.49),('16273','2013-09-06','12:30:00',3.46),('16273','2013-09-06','12:35:00',3.48),('16273','2013-09-06','12:40:00',3.46),('16273','2013-09-06','12:45:00',3.45),('16273','2013-09-06','12:50:00',3.45),('16273','2013-09-06','12:55:00',3.44),('16273','2013-09-06','13:00:00',3.43),('16273','2013-09-06','13:05:00',3.38),('16273','2013-09-06','13:10:00',3.36),('16273','2013-09-06','13:15:00',3.34),('16273','2013-09-06','13:20:00',3.32),('16273','2013-09-06','13:25:00',3.29),('16273','2013-09-06','13:30:00',3.31),('16273','2013-09-06','13:35:00',3.32),('16273','2013-09-06','13:40:00',3.31),('16273','2013-09-06','13:45:00',3.27),('16273','2013-09-06','13:50:00',3.24),('16273','2013-09-06','13:55:00',3.22),('16273','2013-09-06','14:00:00',3.16),('16273','2013-09-06','14:05:00',3.13),('16273','2013-09-06','14:10:00',3.14),('16273','2013-09-06','14:15:00',3.13),('16273','2013-09-06','14:20:00',3.12),('16273','2013-09-06','14:25:00',3.1),('16273','2013-09-06','14:30:00',3.06),('16273','2013-09-06','14:35:00',2.96),('16273','2013-09-06','14:40:00',2.92),('16273','2013-09-06','14:45:00',2.93),('16273','2013-09-06','14:50:00',2.88),('16273','2013-09-06','14:55:00',2.85),('16273','2013-09-06','15:00:00',2.82),('16273','2013-09-06','15:05:00',2.77),('16273','2013-09-06','15:10:00',2.72),('16273','2013-09-06','15:15:00',2.68),('16273','2013-09-06','15:20:00',2.63),('16273','2013-09-06','15:25:00',2.56),('16273','2013-09-06','15:30:00',2.5),('16273','2013-09-06','15:35:00',2.45),('16273','2013-09-06','15:40:00',2.39),('16273','2013-09-06','15:45:00',2.33),('16273','2013-09-06','15:50:00',2.28),('16273','2013-09-06','15:55:00',2.22),('16273','2013-09-06','16:00:00',2.17),('16273','2013-09-06','16:05:00',2.1),('16273','2013-09-06','16:10:00',2.03),('16273','2013-09-06','16:15:00',1.97),('16273','2013-09-06','16:20:00',1.88),('16273','2013-09-06','16:25:00',1.8),('16273','2013-09-06','16:30:00',1.74),('16273','2013-09-06','16:35:00',1.66),('16273','2013-09-06','16:40:00',1.6),('16273','2013-09-06','16:45:00',1.52),('16273','2013-09-06','16:50:00',1.45),('16273','2013-09-06','16:55:00',1.37),('16273','2013-09-06','17:00:00',1.28),('16273','2013-09-06','17:05:00',1.2),('16273','2013-09-06','17:10:00',1.14),('16273','2013-09-06','17:15:00',1.06),('16273','2013-09-06','17:20:00',1),('16273','2013-09-05','07:50:00',1.1),('16273','2013-09-05','07:55:00',1.19),('16273','2013-09-05','08:00:00',1.09),('16273','2013-09-05','08:05:00',1.41),('16273','2013-09-05','08:10:00',1.52),('16273','2013-09-05','08:15:00',1.61),('16273','2013-09-05','08:20:00',1.71),('16273','2013-09-05','08:25:00',1.79),('16273','2013-09-05','08:30:00',1.87),('16273','2013-09-05','08:35:00',1.96),('16273','2013-09-05','08:40:00',2.03),('16273','2013-09-05','08:45:00',2.1),('16273','2013-09-05','08:50:00',2.19),('16273','2013-09-05','08:55:00',2.25),('16273','2013-09-05','09:00:00',2.33),('16273','2013-09-05','09:05:00',2.4),('16273','2013-09-05','09:10:00',2.46),('16273','2013-09-05','09:15:00',2.51),('16273','2013-09-05','09:20:00',2.58),('16273','2013-09-05','09:25:00',2.65),('16273','2013-09-05','09:30:00',2.71),('16273','2013-09-05','09:35:00',2.78),('16273','2013-09-05','09:40:00',2.83),('16273','2013-09-05','09:45:00',2.84),('16273','2013-09-05','09:50:00',2.93),('16273','2013-09-05','09:55:00',2.96),('16273','2013-09-05','10:00:00',3.01),('16273','2013-09-05','10:05:00',3.04),('16273','2013-09-05','10:10:00',3.09),('16273','2013-09-05','10:15:00',3.11),('16273','2013-09-05','10:20:00',3.14),('16273','2013-09-05','10:25:00',3.18),('16273','2013-09-05','10:30:00',3.2),('16273','2013-09-05','10:35:00',3.25),('16273','2013-09-05','10:40:00',3.27),('16273','2013-09-05','10:45:00',3.31),('16273','2013-09-05','10:50:00',3.34),('16273','2013-09-05','10:55:00',3.38),('16273','2013-09-05','11:00:00',3.4),('16273','2013-09-05','11:05:00',3.42),('16273','2013-09-05','11:10:00',3.46),('16273','2013-09-05','11:15:00',3.46),('16273','2013-09-05','11:20:00',3.47),('16273','2013-09-05','11:25:00',3.5),('16273','2013-09-05','11:30:00',3.5),('16273','2013-09-05','11:35:00',3.5),('16273','2013-09-05','11:40:00',3.53),('16273','2013-09-05','11:45:00',3.56),('16273','2013-09-05','11:50:00',3.57),('16273','2013-09-05','11:55:00',3.56),('16273','2013-09-05','12:00:00',3.57),('16273','2013-09-05','12:05:00',3.56),('16273','2013-09-05','12:10:00',3.58),('16273','2013-09-05','12:15:00',3.6),('16273','2013-09-05','12:20:00',3.59),('16273','2013-09-05','12:25:00',3.58),('16273','2013-09-05','12:30:00',3.59),('16273','2013-09-05','12:35:00',3.58),('16273','2013-09-05','12:40:00',3.56),('16273','2013-09-05','12:45:00',3.56),('16273','2013-09-05','12:50:00',3.55),('16273','2013-09-05','12:55:00',3.57),('16273','2013-09-05','13:00:00',3.57),('16273','2013-09-05','13:05:00',3.54),('16273','2013-09-05','13:10:00',3.5),('16273','2013-09-05','13:15:00',3.51),('16273','2013-09-05','13:20:00',3.5),('16273','2013-09-05','13:25:00',3.48),('16273','2013-09-05','13:30:00',3.45),('16273','2013-09-05','13:35:00',3.43),('16273','2013-09-05','13:40:00',3.39),('16273','2013-09-05','13:45:00',3.36),('16273','2013-09-05','13:50:00',3.36),('16273','2013-09-05','13:55:00',3.34),('16273','2013-09-05','14:00:00',3.3),('16273','2013-09-05','14:05:00',3.25),('16273','2013-09-05','14:10:00',3.21),('16273','2013-09-05','14:15:00',3.2),('16273','2013-09-05','14:20:00',3.17),('16273','2013-09-05','14:25:00',3.14),('16273','2013-09-05','14:30:00',3.14),('16273','2013-09-05','14:35:00',3.1),('16273','2013-09-05','14:40:00',3.06),('16273','2013-09-05','14:45:00',3.02),('16273','2013-09-05','14:50:00',2.98),('16273','2013-09-05','14:55:00',2.94),('16273','2013-09-05','15:00:00',2.88),('16273','2013-09-05','15:05:00',2.83),('16273','2013-09-05','15:10:00',2.78),('16273','2013-09-05','15:15:00',2.72),('16273','2013-09-05','15:20:00',2.67),('16273','2013-09-05','15:25:00',2.63),('16273','2013-09-05','15:30:00',2.59),('16273','2013-09-05','15:35:00',2.52),('16273','2013-09-05','15:40:00',2.46),('16273','2013-09-05','15:45:00',2.39),('16273','2013-09-05','15:50:00',2.33),('16273','2013-09-05','15:55:00',2.27),('16273','2013-09-05','16:00:00',2.21),('16273','2013-09-05','16:05:00',2.14),('16273','2013-09-05','16:10:00',2.08),('16273','2013-09-05','16:15:00',2.01),('16273','2013-09-05','16:20:00',1.96),('16273','2013-09-05','16:25:00',1.89),('16273','2013-09-05','16:30:00',1.83),('16273','2013-09-05','16:35:00',1.77),('16273','2013-09-05','16:40:00',1.7),('16273','2013-09-05','16:45:00',1.65),('16273','2013-09-05','16:50:00',1.36),('16273','2013-09-05','16:55:00',1.07),('16273','2013-09-05','17:05:00',1.02),('16273','2013-09-05','17:35:00',1.01),('16273','2013-09-05','17:40:00',1.02),('16273','2013-09-04','07:50:00',1.1),('16273','2013-09-04','07:55:00',1.12),('16273','2013-09-04','08:00:00',1.26),('16273','2013-09-04','08:05:00',1.42),('16273','2013-09-04','08:10:00',1.52),('16273','2013-09-04','08:15:00',1.62),('16273','2013-09-04','08:20:00',1.71),('16273','2013-09-04','08:25:00',1.8),('16273','2013-09-04','08:30:00',1.88),('16273','2013-09-04','08:35:00',1.96),('16273','2013-09-04','08:40:00',2.04),('16273','2013-09-04','08:45:00',2.11),('16273','2013-09-04','08:50:00',2.19),('16273','2013-09-04','08:55:00',2.26),('16273','2013-09-04','09:00:00',2.34),('16273','2013-09-04','09:05:00',2.4),('16273','2013-09-04','09:10:00',2.47),('16273','2013-09-04','09:15:00',2.53),('16273','2013-09-04','09:20:00',2.59),('16273','2013-09-04','09:25:00',2.65),('16273','2013-09-04','09:30:00',2.7),('16273','2013-09-04','09:35:00',2.76),('16273','2013-09-04','09:40:00',2.82),('16273','2013-09-04','09:45:00',2.87),('16273','2013-09-04','09:50:00',2.93),('16273','2013-09-04','09:55:00',2.99),('16273','2013-09-04','10:00:00',3.04),('16273','2013-09-04','10:05:00',3.07),('16273','2013-09-04','10:10:00',3.1),('16273','2013-09-04','10:15:00',3.15),('16273','2013-09-04','10:20:00',3.21),('16273','2013-09-04','10:25:00',3.26),('16273','2013-09-04','10:30:00',3.29),('16273','2013-09-04','10:35:00',3.31),('16273','2013-09-04','10:40:00',3.32),('16273','2013-09-04','10:45:00',3.33),('16273','2013-09-04','10:50:00',3.36),('16273','2013-09-04','10:55:00',3.43),('16273','2013-09-04','11:00:00',3.47),('16273','2013-09-04','11:05:00',3.51),('16273','2013-09-04','11:10:00',3.55),('16273','2013-09-04','11:15:00',3.58),('16273','2013-09-04','11:20:00',3.6),('16273','2013-09-04','11:25:00',3.62),('16273','2013-09-04','11:30:00',3.64),('16273','2013-09-04','11:35:00',3.65),('16273','2013-09-04','11:40:00',3.66),('16273','2013-09-04','11:45:00',3.63),('16273','2013-09-04','11:50:00',3.67),('16273','2013-09-04','11:55:00',3.7),('16273','2013-09-04','12:00:00',3.7),('16273','2013-09-04','12:05:00',3.72),('16273','2013-09-04','12:10:00',3.73),('16273','2013-09-04','12:15:00',3.72),('16273','2013-09-04','12:20:00',3.69),('16273','2013-09-04','12:25:00',3.73),('16273','2013-09-04','12:30:00',3.73),('16273','2013-09-04','12:35:00',3.72),('16273','2013-09-04','12:40:00',3.72),('16273','2013-09-04','12:45:00',3.71),('16273','2013-09-04','12:50:00',3.71),('16273','2013-09-04','12:55:00',3.69),('16273','2013-09-04','13:00:00',3.69),('16273','2013-09-04','13:05:00',3.67),('16273','2013-09-04','13:10:00',3.62),('16273','2013-09-04','13:15:00',3.6),('16273','2013-09-04','13:20:00',3.58),('16273','2013-09-04','13:25:00',3.58),('16273','2013-09-04','13:30:00',3.56),('16273','2013-09-04','13:35:00',3.51),('16273','2013-09-04','13:40:00',3.5),('16273','2013-09-04','13:45:00',3.46),('16273','2013-09-04','13:50:00',3.46),('16273','2013-09-04','13:55:00',3.42),('16273','2013-09-04','14:00:00',3.4),('16273','2013-09-04','14:05:00',3.35),('16273','2013-09-04','14:10:00',3.34),('16273','2013-09-04','14:15:00',3.31),('16273','2013-09-04','14:20:00',3.26),('16273','2013-09-04','14:25:00',3.23),('16273','2013-09-04','14:30:00',3.19),('16273','2013-09-04','14:35:00',3.12),('16273','2013-09-04','14:40:00',3.08),('16273','2013-09-04','14:45:00',3.05),('16273','2013-09-04','14:50:00',2.99),('16273','2013-09-04','14:55:00',2.91),('16273','2013-09-04','15:00:00',2.88),('16273','2013-09-04','15:05:00',2.85),('16273','2013-09-04','15:10:00',2.8),('16273','2013-09-04','15:15:00',2.76),('16273','2013-09-04','15:20:00',2.68),('16273','2013-09-04','15:25:00',2.67),('16273','2013-09-04','15:30:00',2.6),('16273','2013-09-04','15:35:00',2.54),('16273','2013-09-04','15:40:00',2.48),('16273','2013-09-04','15:45:00',2.42),('16273','2013-09-04','15:50:00',2.33),('16273','2013-09-04','15:55:00',2.26),('16273','2013-09-04','16:00:00',2.15),('16273','2013-09-04','16:05:00',2.15),('16273','2013-09-04','16:10:00',2.09),('16273','2013-09-04','16:15:00',1.62),('16273','2013-09-04','16:20:00',1.92),('16273','2013-09-04','16:25:00',1.9),('16273','2013-09-04','16:30:00',1.74),('16273','2013-09-04','16:35:00',1.71),('16273','2013-09-04','16:40:00',1.63),('16273','2013-09-04','16:45:00',1.54),('16273','2013-09-04','16:50:00',1.44),('16273','2013-09-04','16:55:00',1.39),('16273','2013-09-04','17:00:00',1.32),('16273','2013-09-04','17:05:00',1.24),('16273','2013-09-04','17:10:00',1.19),('16273','2013-09-04','17:15:00',1.13),('16273','2013-09-04','17:20:00',1.06),('16273','2013-09-03','07:55:00',1.01),('16273','2013-09-03','08:00:00',1.01),('16273','2013-09-03','08:05:00',1.23),('16273','2013-09-03','08:10:00',1.33),('16273','2013-09-03','08:15:00',1.42),('16273','2013-09-03','08:20:00',1.5),('16273','2013-09-03','08:25:00',1.59),('16273','2013-09-03','08:30:00',1.67),('16273','2013-09-03','08:35:00',1.75),('16273','2013-09-03','08:40:00',1.84),('16273','2013-09-03','08:45:00',1.91),('16273','2013-09-03','08:50:00',1.98),('16273','2013-09-03','08:55:00',2.05),('16273','2013-09-03','09:00:00',2.11),('16273','2013-09-03','09:05:00',2.19),('16273','2013-09-03','09:10:00',2.27),('16273','2013-09-03','09:15:00',2.36),('16273','2013-09-03','09:20:00',2.41),('16273','2013-09-03','09:25:00',2.46),('16273','2013-09-03','09:30:00',2.49),('16273','2013-09-03','09:35:00',2.59),('16273','2013-09-03','09:40:00',2.66),('16273','2013-09-03','09:45:00',2.71),('16273','2013-09-03','09:50:00',2.76),('16273','2013-09-03','09:55:00',2.82),('16273','2013-09-03','10:00:00',2.89),('16273','2013-09-03','10:05:00',2.95),('16273','2013-09-03','10:10:00',3.01),('16273','2013-09-03','10:15:00',3.06),('16273','2013-09-03','10:20:00',3.1),('16273','2013-09-03','10:25:00',3.16),('16273','2013-09-03','10:30:00',3.19),('16273','2013-09-03','10:35:00',3.24),('16273','2013-09-03','10:40:00',3.28),('16273','2013-09-03','10:45:00',3.3),('16273','2013-09-03','10:50:00',3.32),('16273','2013-09-03','10:55:00',3.37),('16273','2013-09-03','11:00:00',3.4),('16273','2013-09-03','11:05:00',3.41),('16273','2013-09-03','11:10:00',3.42),('16273','2013-09-03','11:15:00',3.43),('16273','2013-09-03','11:20:00',3.44),('16273','2013-09-03','11:25:00',3.44),('16273','2013-09-03','11:30:00',3.44),('16273','2013-09-03','11:35:00',3.46),('16273','2013-09-03','11:40:00',3.46),('16273','2013-09-03','11:45:00',3.47),('16273','2013-09-03','11:50:00',3.49),('16273','2013-09-03','11:55:00',3.57),('16273','2013-09-03','12:00:00',3.57),('16273','2013-09-03','12:05:00',3.57),('16273','2013-09-03','12:10:00',3.57),('16273','2013-09-03','12:15:00',3.58),('16273','2013-09-03','12:20:00',3.57),('16273','2013-09-03','12:25:00',3.57),('16273','2013-09-03','12:30:00',3.59),('16273','2013-09-03','12:35:00',3.6),('16273','2013-09-03','12:40:00',3.59),('16273','2013-09-03','12:45:00',3.57),('16273','2013-09-03','12:50:00',3.6),('16273','2013-09-03','12:55:00',3.57),('16273','2013-09-03','13:00:00',3.55),('16273','2013-09-03','13:05:00',3.57),('16273','2013-09-03','13:10:00',3.57),('16273','2013-09-03','13:15:00',3.55),('16273','2013-09-03','13:20:00',3.57),('16273','2013-09-03','13:25:00',3.52),('16273','2013-09-03','13:30:00',3.49),('16273','2013-09-03','13:35:00',3.44),('16273','2013-09-03','13:40:00',3.41),('16273','2013-09-03','13:45:00',3.39),('16273','2013-09-03','13:50:00',3.38),('16273','2013-09-03','13:55:00',3.35),('16273','2013-09-03','14:00:00',3.32),('16273','2013-09-03','14:05:00',3.31),('16273','2013-09-03','14:10:00',3.3),('16273','2013-09-03','14:15:00',3.25),('16273','2013-09-03','14:20:00',3.22),('16273','2013-09-03','14:25:00',3.17),('16273','2013-09-03','14:30:00',3.11),('16273','2013-09-03','14:35:00',3.08),('16273','2013-09-03','14:40:00',3.04),('16273','2013-09-03','14:45:00',3.01),('16273','2013-09-03','14:50:00',2.97),('16273','2013-09-03','14:55:00',2.95),('16273','2013-09-03','15:00:00',2.92),('16273','2013-09-03','15:05:00',2.83),('16273','2013-09-03','15:10:00',2.79),('16273','2013-09-03','15:15:00',2.74),('16273','2013-09-03','15:20:00',2.72),('16273','2013-09-03','15:25:00',2.65),('16273','2013-09-03','15:30:00',2.58),('16273','2013-09-03','15:35:00',2.51),('16273','2013-09-03','15:40:00',2.45),('16273','2013-09-03','15:45:00',2.4),('16273','2013-09-03','15:50:00',2.35),('16273','2013-09-03','15:55:00',2.28),('16273','2013-09-03','16:00:00',2.21),('16273','2013-09-03','16:05:00',2.12),('16273','2013-09-03','16:10:00',2.05),('16273','2013-09-03','16:15:00',1.98),('16273','2013-09-03','16:20:00',1.91),('16273','2013-09-03','16:25:00',1.84),('16273','2013-09-03','16:30:00',1.77),('16273','2013-09-03','16:35:00',1.69),('16273','2013-09-03','16:40:00',1.62),('16273','2013-09-03','16:45:00',1.56),('16273','2013-09-03','16:50:00',1.5),('16273','2013-09-03','16:55:00',1.42),('16273','2013-09-03','17:00:00',1.33),('16273','2013-09-03','17:05:00',1.23),('16273','2013-09-03','17:10:00',1.18),('16273','2013-09-03','17:15:00',1.1),('16273','2013-09-03','17:20:00',1.04),('16273','2013-09-02','08:00:00',1.17),('16273','2013-09-02','08:05:00',1.27),('16273','2013-09-02','08:10:00',1.38),('16273','2013-09-02','08:15:00',1.46),('16273','2013-09-02','08:20:00',1.56),('16273','2013-09-02','08:25:00',1.64),('16273','2013-09-02','08:30:00',1.73),('16273','2013-09-02','08:35:00',1.82),('16273','2013-09-02','08:40:00',1.88),('16273','2013-09-02','08:45:00',1.97),('16273','2013-09-02','08:50:00',2.05),('16273','2013-09-02','08:55:00',2.13),('16273','2013-09-02','09:00:00',2.21),('16273','2013-09-02','09:05:00',2.27),('16273','2013-09-02','09:10:00',2.35),('16273','2013-09-02','09:15:00',2.42),('16273','2013-09-02','09:20:00',2.49),('16273','2013-09-02','09:25:00',2.54),('16273','2013-09-02','09:30:00',2.59),('16273','2013-09-02','09:35:00',2.64),('16273','2013-09-02','09:40:00',2.7),('16273','2013-09-02','09:45:00',2.77),('16273','2013-09-02','09:50:00',2.83),('16273','2013-09-02','09:55:00',2.9),('16273','2013-09-02','10:00:00',2.93),('16273','2013-09-02','10:05:00',3),('16273','2013-09-02','10:10:00',3.05),('16273','2013-09-02','10:15:00',3.09),('16273','2013-09-02','10:20:00',3.12),('16273','2013-09-02','10:25:00',3.17),('16273','2013-09-02','10:30:00',3.2),('16273','2013-09-02','10:35:00',3.26),('16273','2013-09-02','10:40:00',3.29),('16273','2013-09-02','10:45:00',3.31),('16273','2013-09-02','10:50:00',3.33),('16273','2013-09-02','10:55:00',3.34),('16273','2013-09-02','11:00:00',3.38),('16273','2013-09-02','11:05:00',3.41),('16273','2013-09-02','11:10:00',3.43),('16273','2013-09-02','11:15:00',3.46),('16273','2013-09-02','11:20:00',3.51),('16273','2013-09-02','11:25:00',3.53),('16273','2013-09-02','11:30:00',3.51),('16273','2013-09-02','11:35:00',3.51),('16273','2013-09-02','11:40:00',3.55),('16273','2013-09-02','11:45:00',3.51),('16273','2013-09-02','11:50:00',3.55),('16273','2013-09-02','11:55:00',3.58),('16273','2013-09-02','12:00:00',3.61),('16273','2013-09-02','12:05:00',3.6),('16273','2013-09-02','12:10:00',3.58),('16273','2013-09-02','12:15:00',3.56),('16273','2013-09-02','12:20:00',3.56),('16273','2013-09-02','12:25:00',3.56),('16273','2013-09-02','12:30:00',3.57),('16273','2013-09-02','12:35:00',3.57),('16273','2013-09-02','12:40:00',3.55),('16273','2013-09-02','12:45:00',3.52),('16273','2013-09-02','12:50:00',3.56),('16273','2013-09-02','12:55:00',3.56),('16273','2013-09-02','13:00:00',3.5),('16273','2013-09-02','13:05:00',3.51),('16273','2013-09-02','13:10:00',3.51),('16273','2013-09-02','13:15:00',3.54),('16273','2013-09-02','13:20:00',3.52),('16273','2013-09-02','13:25:00',3.5),('16273','2013-09-02','13:30:00',3.47),('16273','2013-09-02','13:35:00',3.45),('16273','2013-09-02','13:40:00',3.4),('16273','2013-09-02','13:45:00',3.37),('16273','2013-09-02','13:50:00',3.38),('16273','2013-09-02','13:55:00',3.35),('16273','2013-09-02','14:00:00',3.02),('16273','2013-09-02','14:05:00',2.39),('16273','2013-09-02','14:10:00',1.86),('16273','2013-09-02','14:15:00',3.25),('16273','2013-09-02','14:20:00',3.21),('16273','2013-09-02','14:25:00',2.89),('16273','2013-09-02','14:30:00',2.96),('16273','2013-09-02','14:35:00',3.13),('16273','2013-09-02','14:40:00',3.05),('16273','2013-09-02','14:45:00',3.02),('16273','2013-09-02','14:50:00',3.07),('16273','2013-09-02','14:55:00',3.04),('16273','2013-09-02','15:00:00',2.96),('16273','2013-09-02','15:05:00',2.89),('16273','2013-09-02','15:10:00',2.82),('16273','2013-09-02','15:15:00',2.8),('16273','2013-09-02','15:20:00',2.76),('16273','2013-09-02','15:25:00',2.69),('16273','2013-09-02','15:30:00',2.65),('16273','2013-09-02','15:35:00',2.61),('16273','2013-09-02','15:40:00',2.53),('16273','2013-09-02','15:45:00',2.48),('16273','2013-09-02','15:50:00',2.41),('16273','2013-09-02','15:55:00',2.35),('16273','2013-09-02','16:00:00',2.27),('16273','2013-09-02','16:05:00',2.17),('16273','2013-09-02','16:10:00',2.12),('16273','2013-09-02','16:15:00',2.07),('16273','2013-09-02','16:20:00',1.98),('16273','2013-09-02','16:25:00',1.91),('16273','2013-09-02','16:30:00',1.83),('16273','2013-09-02','16:35:00',1.74),('16273','2013-09-02','16:40:00',1.67),('16273','2013-09-02','16:45:00',1.6),('16273','2013-09-02','16:50:00',1.54),('16273','2013-09-02','16:55:00',1.45),('16273','2013-09-02','17:00:00',1.37),('16273','2013-09-02','17:05:00',1.3),('16273','2013-09-02','17:10:00',1.23),('16273','2013-09-02','17:15:00',1.15),('16273','2013-09-02','17:20:00',1.07),('16273','2013-09-02','17:25:00',1.02),('16273','2013-09-01','07:50:00',1.04),('16273','2013-09-01','08:00:00',1.25),('16273','2013-09-01','08:05:00',1.37),('16273','2013-09-01','08:10:00',1.48),('16273','2013-09-01','08:15:00',1.57),('16273','2013-09-01','08:20:00',1.65),('16273','2013-09-01','08:25:00',1.7),('16273','2013-09-01','08:30:00',1.81),('16273','2013-09-01','08:35:00',1.89),('16273','2013-09-01','08:40:00',1.95),('16273','2013-09-01','08:45:00',2.03),('16273','2013-09-01','08:50:00',2.11),('16273','2013-09-01','08:55:00',2.18),('16273','2013-09-01','09:00:00',2.25),('16273','2013-09-01','09:05:00',2.31),('16273','2013-09-01','09:10:00',2.39),('16273','2013-09-01','09:15:00',2.47),('16273','2013-09-01','09:20:00',2.54),('16273','2013-09-01','09:25:00',2.6),('16273','2013-09-01','09:30:00',2.66),('16273','2013-09-01','09:35:00',2.72),('16273','2013-09-01','09:40:00',2.78),('16273','2013-09-01','09:45:00',2.83),('16273','2013-09-01','09:50:00',2.88),('16273','2013-09-01','09:55:00',2.92),('16273','2013-09-01','10:00:00',2.94),('16273','2013-09-01','10:05:00',3.02),('16273','2013-09-01','10:10:00',3.08),('16273','2013-09-01','10:15:00',3.1),('16273','2013-09-01','10:20:00',3.12),('16273','2013-09-01','10:25:00',3.17),('16273','2013-09-01','10:30:00',3.19),('16273','2013-09-01','10:35:00',3.25),('16273','2013-09-01','10:40:00',3.28),('16273','2013-09-01','10:45:00',3.33),('16273','2013-09-01','10:50:00',3.37),('16273','2013-09-01','10:55:00',3.42),('16273','2013-09-01','11:00:00',3.45),('16273','2013-09-01','11:05:00',3.48),('16273','2013-09-01','11:10:00',3.5),('16273','2013-09-01','11:15:00',3.54),('16273','2013-09-01','11:20:00',3.56),('16273','2013-09-01','11:25:00',3.6),('16273','2013-09-01','11:30:00',3.61),('16273','2013-09-01','11:35:00',3.59),('16273','2013-09-01','11:40:00',3.64),('16273','2013-09-01','11:45:00',3.65),('16273','2013-09-01','11:50:00',3.66),('16273','2013-09-01','11:55:00',3.61),('16273','2013-09-01','12:00:00',3.62),('16273','2013-09-01','12:05:00',3.62),('16273','2013-09-01','12:10:00',3.63),('16273','2013-09-01','12:15:00',3.64),('16273','2013-09-01','12:20:00',3.57),('16273','2013-09-01','12:25:00',3.63),('16273','2013-09-01','12:30:00',3.6),('16273','2013-09-01','12:35:00',3.61),('16273','2013-09-01','12:40:00',3.6),('16273','2013-09-01','12:45:00',3.59),('16273','2013-09-01','12:50:00',3.59),('16273','2013-09-01','12:55:00',3.56),('16273','2013-09-01','13:00:00',3.37),('16273','2013-09-01','13:05:00',3.27),('16273','2013-09-01','13:10:00',3.68),('16273','2013-09-01','13:15:00',3.41),('16273','2013-09-01','13:20:00',3.12),('16273','2013-09-01','13:25:00',3.27),('16273','2013-09-01','13:30:00',3.52),('16273','2013-09-01','13:35:00',3.57),('16273','2013-09-01','13:40:00',3.56),('16273','2013-09-01','13:45:00',3.53),('16273','2013-09-01','13:50:00',3.49),('16273','2013-09-01','13:55:00',3.39),('16273','2013-09-01','14:00:00',3.31),('16273','2013-09-01','14:05:00',3.04),('16273','2013-09-01','14:10:00',3.11),('16273','2013-09-01','14:15:00',2.9),('16273','2013-09-01','14:20:00',2.81),('16273','2013-09-01','14:25:00',2.79),('16273','2013-09-01','14:30:00',2.71),('16273','2013-09-01','14:35:00',2.75),('16273','2013-09-01','14:40:00',3.02),('16273','2013-09-01','14:45:00',2.9),('16273','2013-09-01','14:50:00',2.85),('16273','2013-09-01','14:55:00',2.86),('16273','2013-09-01','15:00:00',2.86),('16273','2013-09-01','15:05:00',2.76),('16273','2013-09-01','15:10:00',2.73),('16273','2013-09-01','15:15:00',2.67),('16273','2013-09-01','15:20:00',2.58),('16273','2013-09-01','15:25:00',2.32),('16273','2013-09-01','15:30:00',2.1),('16273','2013-09-01','15:35:00',1.97),('16273','2013-09-01','15:40:00',1.97),('16273','2013-09-01','15:45:00',2.13),('16273','2013-09-01','15:50:00',2.09),('16273','2013-09-01','15:55:00',2.07),('16273','2013-09-01','16:00:00',1.73),('16273','2013-09-01','16:05:00',2.09),('16273','2013-09-01','16:10:00',2.22),('16273','2013-09-01','16:15:00',2.01),('16273','2013-09-01','16:20:00',2.07),('16273','2013-09-01','16:25:00',1.86),('16273','2013-09-01','16:30:00',1.9),('16273','2013-09-01','16:35:00',1.74),('16273','2013-09-01','16:40:00',1.65),('16273','2013-09-01','16:45:00',1.57),('16273','2013-09-01','16:50:00',1.41),('16273','2013-09-01','16:55:00',1.34),('16273','2013-09-01','17:00:00',1.39),('16273','2013-09-01','17:05:00',1.34),('16273','2013-09-01','17:10:00',1.36),('16273','2013-09-01','17:15:00',1.29),('16273','2013-09-01','17:20:00',1.19),('16273','2013-09-01','17:25:00',1.15),('16273','2013-09-01','17:30:00',1.16),('16273','2013-08-31','08:15:00',1.33),('16273','2013-08-31','08:20:00',1.53),('16273','2013-08-31','08:25:00',1.8),('16273','2013-08-31','08:30:00',1.89),('16273','2013-08-31','08:35:00',1.94),('16273','2013-08-31','08:40:00',2.03),('16273','2013-08-31','08:45:00',2.21),('16273','2013-08-31','08:50:00',2.37),('16273','2013-08-31','08:55:00',2.52),('16273','2013-08-31','09:00:00',2.3),('16273','2013-08-31','09:05:00',1.88),('16273','2013-08-31','09:10:00',2),('16273','2013-08-31','09:15:00',2.47),('16273','2013-08-31','09:20:00',2.76),('16273','2013-08-31','09:25:00',2.81),('16273','2013-08-31','09:30:00',2.9),('16273','2013-08-31','09:35:00',2.95),('16273','2013-08-31','09:40:00',2.77),('16273','2013-08-31','09:45:00',2.8),('16273','2013-08-31','09:50:00',3.05),('16273','2013-08-31','09:55:00',3.1),('16273','2013-08-31','10:00:00',3.07),('16273','2013-08-31','10:05:00',3.15),('16273','2013-08-31','10:10:00',3.21),('16273','2013-08-31','10:15:00',3.24),('16273','2013-08-31','10:20:00',3.25),('16273','2013-08-31','10:25:00',3.29),('16273','2013-08-31','10:30:00',3.34),('16273','2013-08-31','10:35:00',3.34),('16273','2013-08-31','10:40:00',3.35),('16273','2013-08-31','10:45:00',3.42),('16273','2013-08-31','10:50:00',3.43),('16273','2013-08-31','10:55:00',3.51),('16273','2013-08-31','11:00:00',3.55),('16273','2013-08-31','11:05:00',3.57),('16273','2013-08-31','11:10:00',3.59),('16273','2013-08-31','11:15:00',3.59),('16273','2013-08-31','11:20:00',3.64),('16273','2013-08-31','11:25:00',3.67),('16273','2013-08-31','11:30:00',3.7),('16273','2013-08-31','11:35:00',3.71),('16273','2013-08-31','11:40:00',3.72),('16273','2013-08-31','11:45:00',3.73),('16273','2013-08-31','11:50:00',3.74),('16273','2013-08-31','11:55:00',3.75),('16273','2013-08-31','12:00:00',3.75),('16273','2013-08-31','12:05:00',3.79),('16273','2013-08-31','12:10:00',3.8),('16273','2013-08-31','12:15:00',3.78),('16273','2013-08-31','12:20:00',3.79),('16273','2013-08-31','12:25:00',3.74),('16273','2013-08-31','12:30:00',3.75),('16273','2013-08-31','12:35:00',3.77),('16273','2013-08-31','12:40:00',3.73),('16273','2013-08-31','12:45:00',3.71),('16273','2013-08-31','12:50:00',3.73),('16273','2013-08-31','12:55:00',3.74),('16273','2013-08-31','13:00:00',3.72),('16273','2013-08-31','13:05:00',3.67),('16273','2013-08-31','13:10:00',3.65),('16273','2013-08-31','13:15:00',3.66),('16273','2013-08-31','13:20:00',3.63),('16273','2013-08-31','13:25:00',3.58),('16273','2013-08-31','13:30:00',3.54),('16273','2013-08-31','13:35:00',3.5),('16273','2013-08-31','13:40:00',3.5),('16273','2013-08-31','13:45:00',3.5),('16273','2013-08-31','13:50:00',3.45),('16273','2013-08-31','13:55:00',3.42),('16273','2013-08-31','14:00:00',3.36),('16273','2013-08-31','14:05:00',3.33),('16273','2013-08-31','14:10:00',3.27),('16273','2013-08-31','14:15:00',3.25),('16273','2013-08-31','14:20:00',3.22),('16273','2013-08-31','14:25:00',3.18),('16273','2013-08-31','14:30:00',3.09),('16273','2013-08-31','14:35:00',3.1),('16273','2013-08-31','14:40:00',3.06),('16273','2013-08-31','14:45:00',3.02),('16273','2013-08-31','14:50:00',2.94),('16273','2013-08-31','14:55:00',2.91),('16273','2013-08-31','15:00:00',2.89),('16273','2013-08-31','15:05:00',2.86),('16273','2013-08-31','15:10:00',2.78),('16273','2013-08-31','15:15:00',2.71),('16273','2013-08-31','15:20:00',2.64),('16273','2013-08-31','15:25:00',2.59),('16273','2013-08-31','15:30:00',2.54),('16273','2013-08-31','15:35:00',2.48),('16273','2013-08-31','15:40:00',2.43),('16273','2013-08-31','15:45:00',2.38),('16273','2013-08-31','15:50:00',2.31),('16273','2013-08-31','15:55:00',2.26),('16273','2013-08-31','16:00:00',2.19),('16273','2013-08-31','16:05:00',2.1),('16273','2013-08-31','16:10:00',2.01),('16273','2013-08-31','16:15:00',1.96),('16273','2013-08-31','16:20:00',1.85),('16273','2013-08-31','16:25:00',1.88),('16273','2013-08-31','16:30:00',1.87),('16273','2013-08-31','16:35:00',1.78),('16273','2013-08-31','16:40:00',1.66),('16273','2013-08-31','16:45:00',1.61),('16273','2013-08-31','16:50:00',1.53),('16273','2013-08-31','16:55:00',1.48),('16273','2013-08-31','17:00:00',1.42),('16273','2013-08-31','17:05:00',1.35),('16273','2013-08-31','17:10:00',1.28),('16273','2013-08-31','17:15:00',1.21),('16273','2013-08-31','17:20:00',1.14),('16273','2013-08-31','17:25:00',1.04),('16273','2013-08-30','07:55:00',1.08),('16273','2013-08-30','08:00:00',1.33),('16273','2013-08-30','08:05:00',1.52),('16273','2013-08-30','08:10:00',1.49),('16273','2013-08-30','08:15:00',1.46),('16273','2013-08-30','08:20:00',1.54),('16273','2013-08-30','08:25:00',1.54),('16273','2013-08-30','08:30:00',1.56),('16273','2013-08-30','08:35:00',1.64),('16273','2013-08-30','08:40:00',1.52),('16273','2013-08-30','08:45:00',1.33),('16273','2013-08-30','08:50:00',1.27),('16273','2013-08-30','08:55:00',1.43),('16273','2013-08-30','09:00:00',1.6),('16273','2013-08-30','09:05:00',1.47),('16273','2013-08-30','09:10:00',1.33),('16273','2013-08-30','09:15:00',1.19),('16273','2013-08-30','09:20:00',1.17),('16273','2013-08-30','09:25:00',1.33),('16273','2013-08-30','09:30:00',1.49),('16273','2013-08-30','09:35:00',1.84),('16273','2013-08-30','09:40:00',1.79),('16273','2013-08-30','09:45:00',1.8),('16273','2013-08-30','09:50:00',1.85),('16273','2013-08-30','09:55:00',1.9),('16273','2013-08-30','10:00:00',1.78),('16273','2013-08-30','10:05:00',1.83),('16273','2013-08-30','10:10:00',1.95),('16273','2013-08-30','10:15:00',2.07),('16273','2013-08-30','10:20:00',1.93),('16273','2013-08-30','10:25:00',2.14),('16273','2013-08-30','10:30:00',2.09),('16273','2013-08-30','10:35:00',2.03),('16273','2013-08-30','10:40:00',1.88),('16273','2013-08-30','10:45:00',2.03),('16273','2013-08-30','10:50:00',1.99),('16273','2013-08-30','10:55:00',1.94),('16273','2013-08-30','11:00:00',2.06),('16273','2013-08-30','11:05:00',2.2),('16273','2013-08-30','11:10:00',2.36),('16273','2013-08-30','11:15:00',2.28),('16273','2013-08-30','11:20:00',2.44),('16273','2013-08-30','11:25:00',2.47),('16273','2013-08-30','11:30:00',2.48),('16273','2013-08-30','11:35:00',2.52),('16273','2013-08-30','11:40:00',2.67),('16273','2013-08-30','11:45:00',2.96),('16273','2013-08-30','11:50:00',2.75),('16273','2013-08-30','11:55:00',2.48),('16273','2013-08-30','12:00:00',2.01),('16273','2013-08-30','12:05:00',2.19),('16273','2013-08-30','12:10:00',2.32),('16273','2013-08-30','12:15:00',2.44),('16273','2013-08-30','12:20:00',2.75),('16273','2013-08-30','12:25:00',2.94),('16273','2013-08-30','12:30:00',3.1),('16273','2013-08-30','12:35:00',2.86),('16273','2013-08-30','12:40:00',2.97),('16273','2013-08-30','12:45:00',2.86),('16273','2013-08-30','12:50:00',2.7),('16273','2013-08-30','12:55:00',2.59),('16273','2013-08-30','13:00:00',2.5),('16273','2013-08-30','13:05:00',2.42),('16273','2013-08-30','13:10:00',2.3),('16273','2013-08-30','13:15:00',2.7),('16273','2013-08-30','13:20:00',3.38),('16273','2013-08-30','13:25:00',3.79),('16273','2013-08-30','13:30:00',3.44),('16273','2013-08-30','13:35:00',3.47),('16273','2013-08-30','13:40:00',3.54),('16273','2013-08-30','13:45:00',3.39),('16273','2013-08-30','13:50:00',3.27),('16273','2013-08-30','13:55:00',3.43),('16273','2013-08-30','14:00:00',3.46),('16273','2013-08-30','14:05:00',3.42),('16273','2013-08-30','14:10:00',3.46),('16273','2013-08-30','14:15:00',3.38),('16273','2013-08-30','14:20:00',3.23),('16273','2013-08-30','14:25:00',3.3),('16273','2013-08-30','14:30:00',3.34),('16273','2013-08-30','14:35:00',3.07),('16273','2013-08-30','14:40:00',2.9),('16273','2013-08-30','14:45:00',2.63),('16273','2013-08-30','14:50:00',2.81),('16273','2013-08-30','14:55:00',2.29),('16273','2013-08-30','15:00:00',2.08),('16273','2013-08-30','15:05:00',2.2),('16273','2013-08-30','15:10:00',2.32),('16273','2013-08-30','15:15:00',2.22),('16273','2013-08-30','15:20:00',2.14),('16273','2013-08-30','15:25:00',2.12),('16273','2013-08-30','15:30:00',1.87),('16273','2013-08-30','15:35:00',1.98),('16273','2013-08-30','15:40:00',2.21),('16273','2013-08-30','15:45:00',2.07),('16273','2013-08-30','15:50:00',1.83),('16273','2013-08-30','15:55:00',1.77),('16273','2013-08-30','16:00:00',1.58),('16273','2013-08-30','16:05:00',1.42),('16273','2013-08-30','16:10:00',1.51),('16273','2013-08-30','16:15:00',1.57),('16273','2013-08-30','16:20:00',1.53),('16273','2013-08-30','16:25:00',1.56),('16273','2013-08-30','16:30:00',1.76),('16273','2013-08-30','16:35:00',1.81),('16273','2013-08-30','16:40:00',1.86),('16273','2013-08-30','16:45:00',1.82),('16273','2013-08-30','16:50:00',1.31),('16273','2013-08-30','16:55:00',1.11),('16273','2013-08-30','17:10:00',1.18),('16273','2013-08-30','17:15:00',1.13),('16273','2013-08-30','17:20:00',1.12),('16273','2013-08-30','17:25:00',1.13),('16273','2013-08-30','17:30:00',1.11),('16273','2014-04-11','08:20:00',1.26),('16273','2014-04-11','08:30:00',1.15),('16273','2014-04-11','08:35:00',1.63),('16273','2014-04-11','08:40:00',2.15),('16273','2014-04-11','08:45:00',2.38),('16273','2014-04-11','08:50:00',2.54),('16273','2014-04-11','08:55:00',2.56),('16273','2014-04-11','09:00:00',2.51),('16273','2014-04-11','09:05:00',2.59),('16273','2014-04-11','09:10:00',2.65),('16273','2014-04-11','09:15:00',2.69),('16273','2014-04-11','09:20:00',2.66),('16273','2014-04-11','09:25:00',2.69),('16273','2014-04-11','09:30:00',2.79),('16273','2014-04-11','09:35:00',2.86),('16273','2014-04-11','09:40:00',2.91),('16273','2014-04-11','09:45:00',2.94),('16273','2014-04-11','09:50:00',3.06),('16273','2014-04-11','09:55:00',3.12),('16273','2014-04-11','10:00:00',3.19),('16273','2014-04-11','10:05:00',3.21),('16273','2014-04-11','10:10:00',3.23),('16273','2014-04-11','10:15:00',3.29),('16273','2014-04-11','10:20:00',3.32),('16273','2014-04-11','10:25:00',3.38),('16273','2014-04-11','10:30:00',3.45),('16273','2014-04-11','10:35:00',3.48),('16273','2014-04-11','10:40:00',3.52),('16273','2014-04-11','10:45:00',3.56),('16273','2014-04-11','10:50:00',3.62),('16273','2014-04-11','10:55:00',3.64),('16273','2014-04-11','11:00:00',3.67),('16273','2014-04-11','11:05:00',3.49),('16273','2014-04-11','11:10:00',3.71),('16273','2014-04-11','11:15:00',3.75),('16273','2014-04-11','11:20:00',3.8),('16273','2014-04-11','11:25:00',3.8),('16273','2014-04-11','11:30:00',3.83),('16273','2014-04-11','11:35:00',3.88),('16273','2014-04-11','11:40:00',3.78),('16273','2014-04-11','11:45:00',3.91),('16273','2014-04-11','11:50:00',3.19),('16273','2014-04-11','11:55:00',3.57),('16273','2014-04-11','12:00:00',4.14),('16273','2014-04-11','12:05:00',3.53),('16273','2014-04-11','12:10:00',4.13),('16273','2014-04-11','12:15:00',4.29),('16273','2014-04-11','12:20:00',3.91),('16273','2014-04-11','12:25:00',1.23),('16273','2014-04-11','12:30:00',1.94),('16273','2014-04-11','12:35:00',3.43),('16273','2014-04-11','12:40:00',3.71),('16273','2014-04-11','12:45:00',3.82),('16273','2014-04-11','12:50:00',3.83),('16273','2014-04-11','12:55:00',2.58),('16273','2014-04-11','13:00:00',4.51),('16273','2014-04-11','13:05:00',3.72),('16273','2014-04-11','13:10:00',4.23),('16273','2014-04-11','13:15:00',1.9),('16273','2014-04-11','13:20:00',2.25),('16273','2014-04-11','13:25:00',1.96),('16273','2014-04-11','13:30:00',2.64),('16273','2014-04-11','13:35:00',2.32),('16273','2014-04-11','13:40:00',3.16),('16273','2014-04-11','13:45:00',3.17),('16273','2014-04-11','13:50:00',2.32),('16273','2014-04-11','13:55:00',4.06),('16273','2014-04-11','14:00:00',2.65),('16273','2014-04-11','14:05:00',2.89),('16273','2014-04-11','14:10:00',3.46),('16273','2014-04-11','14:15:00',2.85),('16273','2014-04-11','14:20:00',3.23),('16273','2014-04-11','14:25:00',2.42),('16273','2014-04-11','14:30:00',3.46),('16273','2014-04-11','14:35:00',4),('16273','2014-04-11','14:40:00',3.11),('16273','2014-04-11','14:45:00',3.25),('16273','2014-04-11','14:50:00',2.79),('16273','2014-04-11','14:55:00',2.99),('16273','2014-04-11','15:00:00',2.87),('16273','2014-04-11','15:05:00',3.22),('16273','2014-04-11','15:10:00',3.21),('16273','2014-04-11','15:15:00',3),('16273','2014-04-11','15:20:00',3.04),('16273','2014-04-11','15:25:00',2.92),('16273','2014-04-11','15:30:00',2.85),('16273','2014-04-11','15:35:00',2.76),('16273','2014-04-11','15:40:00',2.74),('16273','2014-04-11','15:45:00',2.82),('16273','2014-04-11','15:50:00',2.11),('16273','2014-04-11','15:55:00',2.13),('16273','2014-04-11','16:00:00',1.23),('16273','2014-04-11','16:05:00',2.57),('16273','2014-04-11','16:10:00',2.43),('16273','2014-04-11','16:15:00',2.1),('16273','2014-04-11','16:20:00',1.76),('16273','2014-04-11','16:25:00',2.29),('16273','2014-04-11','16:30:00',2.16),('16273','2014-04-11','16:35:00',2.05),('16273','2014-04-11','16:40:00',2.05),('16273','2014-04-11','16:45:00',1.69),('16273','2014-04-11','16:50:00',1.41),('16273','2014-04-11','16:55:00',1.59),('16273','2014-04-11','17:00:00',1.53),('16273','2014-04-11','17:05:00',1.2),('16273','2014-04-11','17:10:00',1.09),('16273','2014-04-11','17:15:00',1.19),('16273','2014-04-11','17:20:00',1.11),('16273','2014-04-11','17:35:00',1.12),('16273','2013-08-29','07:45:00',1.05),('16273','2013-08-29','07:50:00',1.01),('16273','2013-08-29','07:55:00',1.24),('16273','2013-08-29','08:00:00',1.4),('16273','2013-08-29','08:05:00',1.43),('16273','2013-08-29','08:10:00',1.44),('16273','2013-08-29','08:15:00',1.69),('16273','2013-08-29','08:20:00',1.89),('16273','2013-08-29','08:25:00',2.09),('16273','2013-08-29','08:30:00',2.19),('16273','2013-08-29','08:35:00',1.53),('16273','2013-08-29','08:40:00',1.21),('16273','2013-08-29','08:45:00',1.15),('16273','2013-08-29','08:50:00',1.32),('16273','2013-08-29','08:55:00',1.59),('16273','2013-08-29','09:00:00',1.43),('16273','2013-08-29','09:05:00',1.42),('16273','2013-08-29','09:10:00',1.45),('16273','2013-08-29','09:15:00',1.43),('16273','2013-08-29','09:20:00',1.52),('16273','2013-08-29','09:25:00',1.47),('16273','2013-08-29','09:30:00',1.58),('16273','2013-08-29','09:35:00',1.73),('16273','2013-08-29','09:40:00',1.46),('16273','2013-08-29','09:45:00',1.33),('16273','2013-08-29','09:50:00',1.33),('16273','2013-08-29','09:55:00',1.33),('16273','2013-08-29','10:00:00',1.31),('16273','2013-08-29','10:05:00',1.32),('16273','2013-08-29','10:10:00',1.3),('16273','2013-08-29','10:15:00',1.34),('16273','2013-08-29','10:20:00',1.37),('16273','2013-08-29','10:25:00',1.4),('16273','2013-08-29','10:30:00',1.38),('16273','2013-08-29','10:35:00',1.22),('16273','2013-08-29','10:40:00',1.13),('16273','2013-08-29','10:45:00',1.13),('16273','2013-08-29','10:50:00',1.26),('16273','2013-08-29','10:55:00',1.42),('16273','2013-08-29','11:00:00',1.39),('16273','2013-08-29','11:05:00',1.58),('16273','2013-08-29','11:10:00',1.69),('16273','2013-08-29','11:15:00',1.75),('16273','2013-08-29','11:20:00',1.45),('16273','2013-08-29','11:25:00',1.23),('16273','2013-08-29','11:30:00',1.15),('16273','2013-08-29','11:35:00',1.3),('16273','2013-08-29','11:40:00',1.49),('16273','2013-08-29','11:45:00',1.6),('16273','2013-08-29','11:50:00',1.73),('16273','2013-08-29','11:55:00',1.7),('16273','2013-08-29','12:00:00',1.73),('16273','2013-08-29','12:05:00',2.33),('16273','2013-08-29','12:10:00',2.7),('16273','2013-08-29','12:15:00',2.81),('16273','2013-08-29','12:20:00',2.67),('16273','2013-08-29','12:25:00',2.35),('16273','2013-08-29','12:30:00',2.56),('16273','2013-08-29','12:35:00',2.83),('16273','2013-08-29','12:40:00',3.56),('16273','2013-08-29','12:45:00',2.73),('16273','2013-08-29','12:50:00',2.69),('16273','2013-08-29','12:55:00',2.29),('16273','2013-08-29','13:00:00',2.47),('16273','2013-08-29','13:05:00',2.07),('16273','2013-08-29','13:10:00',2),('16273','2013-08-29','13:15:00',2.03),('16273','2013-08-29','13:20:00',1.78),('16273','2013-08-29','13:25:00',1.6),('16273','2013-08-29','13:30:00',1.57),('16273','2013-08-29','13:35:00',1.53),('16273','2013-08-29','13:40:00',1.41),('16273','2013-08-29','13:45:00',1.43),('16273','2013-08-29','13:50:00',1.88),('16273','2013-08-29','13:55:00',2.37),('16273','2013-08-29','14:00:00',1.49),('16273','2013-08-29','14:05:00',1.31),('16273','2013-08-29','14:10:00',1.11),('16273','2013-08-29','14:40:00',1.08),('16273','2013-08-29','14:45:00',1.2),('16273','2013-08-29','14:50:00',1.39),('16273','2013-08-29','14:55:00',1.58),('16273','2013-08-29','15:00:00',2.13),('16273','2013-08-29','15:05:00',1.27),('16273','2013-08-29','15:10:00',1.13),('16273','2013-08-29','15:15:00',1.63),('16273','2013-08-29','15:20:00',1.94),('16273','2013-08-29','15:25:00',2.29),('16273','2013-08-29','15:30:00',1.9),('16273','2013-08-29','15:35:00',2.02),('16273','2013-08-29','15:40:00',1.71),('16273','2013-08-29','15:45:00',1.71),('16273','2013-08-29','15:50:00',1.89),('16273','2013-08-29','15:55:00',2.13),('16273','2013-08-29','16:00:00',2.8),('16273','2013-08-29','16:05:00',2.58),('16273','2013-08-29','16:10:00',2.33),('16273','2013-08-29','16:15:00',2.25),('16273','2013-08-29','16:20:00',2.09),('16273','2013-08-29','16:25:00',1.83),('16273','2013-08-29','16:30:00',1.94),('16273','2013-08-29','16:35:00',1.89),('16273','2013-08-29','16:40:00',1.79),('16273','2013-08-29','16:45:00',1.72),('16273','2013-08-29','16:50:00',1.64),('16273','2013-08-29','16:55:00',1.56),('16273','2013-08-29','17:00:00',1.48),('16273','2013-08-29','17:05:00',1.41),('16273','2013-08-29','17:10:00',1.33),('16273','2013-08-29','17:15:00',1.26),('16273','2013-08-29','17:20:00',1.17),('16273','2013-08-29','17:25:00',1.09),('16273','2013-08-29','17:30:00',1.03),('16273','2013-08-28','07:50:00',1.18),('16273','2013-08-28','07:55:00',1.11),('16273','2013-08-28','08:05:00',1.3),('16273','2013-08-28','08:10:00',1.65),('16273','2013-08-28','08:15:00',1.64),('16273','2013-08-28','08:20:00',1.62),('16273','2013-08-28','08:25:00',1.63),('16273','2013-08-28','08:30:00',1.86),('16273','2013-08-28','08:35:00',1.79),('16273','2013-08-28','08:55:00',2.16),('16273','2013-08-28','09:00:00',2.32),('16273','2013-08-28','09:05:00',2.39),('16273','2013-08-28','09:10:00',2.35),('16273','2013-08-28','09:15:00',1.36),('16273','2013-08-28','09:20:00',1.15),('16273','2013-08-28','09:25:00',1.39),('16273','2013-08-28','09:30:00',2.35),('16273','2013-08-28','09:35:00',2.49),('16273','2013-08-28','09:40:00',2.86),('16273','2013-08-28','09:45:00',2.82),('16273','2013-08-28','09:50:00',2.62),('16273','2013-08-28','09:55:00',2.9),('16273','2013-08-28','10:00:00',3.04),('16273','2013-08-28','10:05:00',2.21),('16273','2013-08-28','10:10:00',2.82),('16273','2013-08-28','10:15:00',3.24),('16273','2013-08-28','10:20:00',3.26),('16273','2013-08-28','10:25:00',3.31),('16273','2013-08-28','10:30:00',3.34),('16273','2013-08-28','10:35:00',3.26),('16273','2013-08-28','10:40:00',2.65),('16273','2013-08-28','10:45:00',3.63),('16273','2013-08-28','10:50:00',3.8),('16273','2013-08-28','10:55:00',3.8),('16273','2013-08-28','11:00:00',3.33),('16273','2013-08-28','11:05:00',1.25),('16273','2013-08-28','11:10:00',4.01),('16273','2013-08-28','11:15:00',1.86),('16273','2013-08-28','11:20:00',2.55),('16273','2013-08-28','11:25:00',1.73),('16273','2013-08-28','11:30:00',2.68),('16273','2013-08-28','11:35:00',3.5),('16273','2013-08-28','11:40:00',3.75),('16273','2013-08-28','11:45:00',3.46),('16273','2013-08-28','11:50:00',2.35),('16273','2013-08-28','11:55:00',4.01),('16273','2013-08-28','12:00:00',2.29),('16273','2013-08-28','12:05:00',3.15),('16273','2013-08-28','12:10:00',4),('16273','2013-08-28','12:15:00',3.9),('16273','2013-08-28','12:20:00',3.87),('16273','2013-08-28','12:25:00',3.96),('16273','2013-08-28','12:30:00',3.9),('16273','2013-08-28','12:35:00',3.85),('16273','2013-08-28','12:40:00',3.54),('16273','2013-08-28','12:45:00',3.75),('16273','2013-08-28','12:50:00',3.91),('16273','2013-08-28','12:55:00',3.92),('16273','2013-08-28','13:00:00',3.86),('16273','2013-08-28','13:05:00',3.83),('16273','2013-08-28','13:10:00',3.62),('16273','2013-08-28','13:15:00',3.85),('16273','2013-08-28','13:20:00',3.86),('16273','2013-08-28','13:25:00',3.9),('16273','2013-08-28','13:30:00',3.89),('16273','2013-08-28','13:35:00',3.93),('16273','2013-08-28','13:40:00',3.87),('16273','2013-08-28','13:45:00',3.74),('16273','2013-08-28','13:50:00',3.7),('16273','2013-08-28','13:55:00',3.59),('16273','2013-08-28','14:00:00',2.91),('16273','2013-08-28','14:05:00',3.62),('16273','2013-08-28','14:10:00',3.57),('16273','2013-08-28','14:15:00',3.54),('16273','2013-08-28','14:20:00',3.55),('16273','2013-08-28','14:25:00',3.61),('16273','2013-08-28','14:30:00',3.36),('16273','2013-08-28','14:35:00',3.14),('16273','2013-08-28','14:40:00',3.07),('16273','2013-08-28','14:45:00',3.42),('16273','2013-08-28','14:50:00',1.89),('16273','2013-08-28','14:55:00',2.36),('16273','2013-08-28','15:00:00',2.72),('16273','2013-08-28','15:05:00',3.23),('16273','2013-08-28','15:10:00',2.49),('16273','2013-08-28','15:15:00',2.65),('16273','2013-08-28','15:20:00',2.33),('16273','2013-08-28','15:25:00',3.15),('16273','2013-08-28','15:30:00',2.01),('16273','2013-08-28','15:35:00',2.33),('16273','2013-08-28','15:40:00',2.18),('16273','2013-08-28','15:45:00',2.34),('16273','2013-08-28','15:50:00',2.69),('16273','2013-08-28','15:55:00',2.6),('16273','2013-08-28','16:00:00',2.28),('16273','2013-08-28','16:05:00',2.25),('16273','2013-08-28','16:10:00',2.42),('16273','2013-08-28','16:15:00',2.29),('16273','2013-08-28','16:20:00',2.18),('16273','2013-08-28','16:25:00',2.09),('16273','2013-08-28','16:30:00',2.02),('16273','2013-08-28','16:35:00',1.92),('16273','2013-08-28','16:40:00',1.85),('16273','2013-08-28','16:45:00',1.77),('16273','2013-08-28','16:50:00',1.63),('16273','2013-08-28','16:55:00',1.03),('16273','2013-08-28','17:00:00',1.51),('16273','2013-08-28','17:05:00',1.51),('16273','2013-08-28','17:10:00',1.08),('16273','2013-08-28','17:15:00',1.3),('16273','2013-08-28','17:20:00',1.22),('16273','2013-08-28','17:25:00',1.35),('16273','2013-08-27','08:20:00',1.25),('16273','2013-08-27','08:25:00',1.22),('16273','2013-08-27','08:30:00',1.1),('16273','2013-08-27','08:35:00',1.02),('16273','2013-08-27','08:40:00',1.14),('16273','2013-08-27','08:45:00',1.16),('16273','2013-08-27','08:50:00',1.43),('16273','2013-08-27','08:55:00',1.17),('16273','2013-08-27','09:00:00',1.09),('16273','2013-08-27','09:05:00',1.56),('16273','2013-08-27','09:10:00',1.96),('16273','2013-08-27','09:15:00',1.85),('16273','2013-08-27','09:20:00',2.26),('16273','2013-08-27','09:25:00',2.62),('16273','2013-08-27','09:30:00',2.52),('16273','2013-08-27','09:35:00',1.47),('16273','2013-08-27','09:40:00',1.52),('16273','2013-08-27','09:45:00',1.59),('16273','2013-08-27','09:50:00',1.85),('16273','2013-08-27','09:55:00',1.73),('16273','2013-08-27','10:00:00',2.4),('16273','2013-08-27','10:05:00',2.93),('16273','2013-08-27','10:10:00',3.13),('16273','2013-08-27','10:15:00',3.11),('16273','2013-08-27','10:20:00',3.07),('16273','2013-08-27','10:25:00',3.11),('16273','2013-08-27','10:30:00',3.19),('16273','2013-08-27','10:35:00',3.17),('16273','2013-08-27','10:40:00',3.2),('16273','2013-08-27','10:45:00',3.14),('16273','2013-08-27','10:50:00',2.7),('16273','2013-08-27','10:55:00',3.31),('16273','2013-08-27','11:00:00',3.29),('16273','2013-08-27','11:05:00',3.37),('16273','2013-08-27','11:10:00',3.44),('16273','2013-08-27','11:15:00',3.29),('16273','2013-08-27','11:20:00',3.05),('16273','2013-08-27','11:25:00',3.17),('16273','2013-08-27','11:30:00',3.49),('16273','2013-08-27','11:35:00',3.53),('16273','2013-08-27','11:40:00',2.22),('16273','2013-08-27','11:45:00',2.23),('16273','2013-08-27','11:50:00',2.58),('16273','2013-08-27','11:55:00',2.1),('16273','2013-08-27','12:00:00',1.92),('16273','2013-08-27','12:05:00',2.62),('16273','2013-08-27','12:10:00',3.27),('16273','2013-08-27','12:15:00',3.59),('16273','2013-08-27','12:20:00',3.55),('16273','2013-08-27','12:25:00',3.73),('16273','2013-08-27','12:30:00',3.43),('16273','2013-08-27','12:35:00',3.67),('16273','2013-08-27','12:40:00',3.14),('16273','2013-08-27','12:45:00',2.36),('16273','2013-08-27','12:50:00',1.8),('16273','2013-08-27','12:55:00',1.36),('16273','2013-08-27','13:00:00',1.35),('16273','2013-08-27','13:05:00',1.85),('16273','2013-08-27','13:10:00',2.32),('16273','2013-08-27','13:15:00',1.98),('16273','2013-08-27','13:20:00',2.14),('16273','2013-08-27','13:25:00',2.4),('16273','2013-08-27','13:30:00',2.06),('16273','2013-08-27','13:35:00',1.88),('16273','2013-08-27','13:40:00',2.27),('16273','2013-08-27','13:45:00',3.08),('16273','2013-08-27','13:50:00',3.35),('16273','2013-08-27','13:55:00',3.56),('16273','2013-08-27','14:00:00',1.96),('16273','2013-08-27','14:05:00',2.64),('16273','2013-08-27','14:10:00',2.7),('16273','2013-08-27','14:15:00',1.93),('16273','2013-08-27','14:20:00',1.64),('16273','2013-08-27','14:25:00',1.26),('16273','2013-08-27','14:30:00',1.22),('16273','2013-08-27','14:35:00',1.31),('16273','2013-08-27','14:40:00',1.26),('16273','2013-08-27','14:45:00',1.06),('16273','2013-08-27','16:00:00',1.44),('16273','2013-08-27','16:05:00',2.53),('16273','2013-08-27','16:10:00',1.64),('16273','2013-08-27','16:15:00',1.23),('16273','2013-08-27','16:30:00',1.09),('16273','2013-08-27','16:40:00',1.45),('16273','2013-08-27','16:45:00',1.41),('16273','2013-08-27','16:55:00',1.79),('16273','2013-08-27','17:00:00',2.08),('16273','2013-08-27','17:05:00',1.38),('16273','2013-08-27','17:45:00',1.14),('16273','2013-08-26','08:00:00',1.13),('16273','2013-08-26','08:15:00',1.3),('16273','2013-08-26','08:20:00',1.4),('16273','2013-08-26','08:25:00',1.52),('16273','2013-08-26','08:30:00',1.8),('16273','2013-08-26','08:35:00',1.9),('16273','2013-08-26','08:40:00',1.98),('16273','2013-08-26','08:45:00',2.05),('16273','2013-08-26','08:50:00',2.14),('16273','2013-08-26','08:55:00',2.22),('16273','2013-08-26','09:00:00',2.28),('16273','2013-08-26','09:05:00',2.36),('16273','2013-08-26','09:10:00',2.44),('16273','2013-08-26','09:15:00',2.49),('16273','2013-08-26','09:20:00',2.54),('16273','2013-08-26','09:25:00',2.59),('16273','2013-08-26','09:30:00',2.67),('16273','2013-08-26','09:35:00',2.73),('16273','2013-08-26','09:40:00',2.78),('16273','2013-08-26','09:45:00',2.83),('16273','2013-08-26','09:50:00',2.88),('16273','2013-08-26','09:55:00',2.92),('16273','2013-08-26','10:00:00',2.97),('16273','2013-08-26','10:05:00',3.03),('16273','2013-08-26','10:10:00',3.05),('16273','2013-08-26','10:15:00',3.11),('16273','2013-08-26','10:20:00',3.21),('16273','2013-08-26','10:25:00',3.2),('16273','2013-08-26','10:30:00',3.25),('16273','2013-08-26','10:35:00',3.28),('16273','2013-08-26','10:40:00',3.32),('16273','2013-08-26','10:45:00',3.35),('16273','2013-08-26','10:50:00',3.36),('16273','2013-08-26','10:55:00',3.38),('16273','2013-08-26','11:00:00',3.42),('16273','2013-08-26','11:05:00',3.44),('16273','2013-08-26','11:10:00',3.48),('16273','2013-08-26','11:15:00',3.49),('16273','2013-08-26','11:20:00',3.51),('16273','2013-08-26','11:25:00',3.51),('16273','2013-08-26','11:30:00',3.54),('16273','2013-08-26','11:35:00',3.57),('16273','2013-08-26','11:40:00',3.55),('16273','2013-08-26','11:45:00',3.58),('16273','2013-08-26','11:50:00',3.6),('16273','2013-08-26','11:55:00',3.62),('16273','2013-08-26','12:00:00',3.6),('16273','2013-08-26','12:05:00',3.6),('16273','2013-08-26','12:10:00',3.58),('16273','2013-08-26','12:15:00',3.58),('16273','2013-08-26','12:20:00',3.58),('16273','2013-08-26','12:25:00',3.59),('16273','2013-08-26','12:30:00',3.62),('16273','2013-08-26','12:35:00',3.89),('16273','2013-08-26','12:40:00',3.84),('16273','2013-08-26','12:45:00',3.71),('16273','2013-08-26','12:50:00',3.69),('16273','2013-08-26','12:55:00',3.48),('16273','2013-08-26','13:00:00',2.23),('16273','2013-08-26','13:05:00',2.68),('16273','2013-08-26','13:10:00',2.37),('16273','2013-08-26','13:15:00',2.12),('16273','2013-08-26','13:20:00',2.77),('16273','2013-08-26','13:25:00',2.68),('16273','2013-08-26','13:30:00',2.86),('16273','2013-08-26','13:35:00',2.72),('16273','2013-08-26','13:40:00',3.43),('16273','2013-08-26','13:45:00',3.57),('16273','2013-08-26','13:50:00',2.68),('16273','2013-08-26','13:55:00',2.52),('16273','2013-08-26','14:00:00',2.76),('16273','2013-08-26','14:05:00',2.87),('16273','2013-08-26','14:10:00',3.33),('16273','2013-08-26','14:15:00',3.28),('16273','2013-08-26','14:20:00',3.25),('16273','2013-08-26','14:25:00',3.29),('16273','2013-08-26','14:30:00',3.25),('16273','2013-08-26','14:35:00',3.18),('16273','2013-08-26','14:40:00',2.62),('16273','2013-08-26','14:45:00',1.67),('16273','2013-08-26','14:50:00',1.53),('16273','2013-08-26','14:55:00',1.48),('16273','2013-08-26','15:00:00',1.51),('16273','2013-08-26','15:05:00',1.01),('16273','2013-08-26','15:35:00',1.15),('16273','2013-08-26','15:40:00',1.41),('16273','2013-08-26','15:45:00',1.3),('16273','2013-08-26','15:50:00',1.45),('16273','2013-08-26','15:55:00',2.15),('16273','2013-08-26','16:00:00',2.76),('16273','2013-08-26','16:05:00',2.46),('16273','2013-08-26','16:10:00',2.22),('16273','2013-08-26','16:15:00',2.13),('16273','2013-08-26','16:20:00',2.05),('16273','2013-08-26','16:25:00',1.95),('16273','2013-08-26','16:30:00',1.92),('16273','2013-08-26','16:35:00',1.85),('16273','2013-08-26','16:40:00',1.78),('16273','2013-08-26','16:45:00',1.67),('16273','2013-08-26','16:50:00',1.62),('16273','2013-08-26','16:55:00',1.54),('16273','2013-08-26','17:00:00',1.32),('16273','2013-08-26','17:05:00',1.39),('16273','2013-08-26','17:10:00',1.32),('16273','2013-08-26','17:45:00',1.08),('16273','2013-08-26','17:50:00',1.05),('16273','2013-08-25','07:55:00',1.03),('16273','2013-08-25','08:00:00',1.25),('16273','2013-08-25','08:05:00',1.13),('16273','2013-08-25','08:10:00',1.36),('16273','2013-08-25','08:20:00',1.53),('16273','2013-08-25','08:25:00',1.66),('16273','2013-08-25','08:30:00',1.67),('16273','2013-08-25','08:35:00',1.84),('16273','2013-08-25','08:55:00',1.35),('16273','2013-08-25','09:00:00',2.21),('16273','2013-08-25','09:05:00',1.84),('16273','2013-08-25','09:10:00',2.16),('16273','2013-08-25','09:15:00',2.39),('16273','2013-08-25','09:20:00',2.55),('16273','2013-08-25','09:25:00',2.67),('16273','2013-08-25','09:30:00',2.8),('16273','2013-08-25','09:35:00',2.97),('16273','2013-08-25','09:40:00',3.3),('16273','2013-08-25','09:45:00',2.4),('16273','2013-08-25','09:50:00',2.95),('16273','2013-08-25','09:55:00',1.76),('16273','2013-08-25','15:10:00',1.07),('16273','2013-08-25','15:15:00',1.26),('16273','2013-08-25','15:20:00',1.43),('16273','2013-08-25','15:25:00',2),('16273','2013-08-25','15:30:00',3.11),('16273','2013-08-25','15:35:00',1.97),('16273','2013-08-25','15:40:00',2.58),('16273','2013-08-25','15:45:00',1.65),('16273','2013-08-25','15:50:00',1.9),('16273','2013-08-25','15:55:00',1.84),('16273','2013-08-25','16:00:00',2.71),('16273','2013-08-25','16:05:00',2.46),('16273','2013-08-25','16:10:00',2.34),('16273','2013-08-25','16:15:00',2.21),('16273','2013-08-25','16:20:00',2.15),('16273','2013-08-25','16:25:00',2.04),('16273','2013-08-25','16:30:00',1.99),('16273','2013-08-25','16:35:00',1.68),('16273','2013-08-25','16:45:00',1.25),('16273','2013-08-25','16:50:00',1.99),('16273','2013-08-25','16:55:00',1.81),('16273','2013-08-25','17:00:00',1.66),('16273','2013-08-25','17:05:00',1.57),('16273','2013-08-25','17:10:00',1.44),('16273','2013-08-25','17:15:00',1.35),('16273','2013-08-25','17:20:00',1.26),('16273','2013-08-25','17:25:00',1.16),('16273','2013-08-25','17:30:00',1.03),('16273','2013-08-24','07:55:00',1.12),('16273','2013-08-24','08:00:00',1.21),('16273','2013-08-24','08:05:00',1.29),('16273','2013-08-24','08:10:00',1.35),('16273','2013-08-24','08:15:00',1.43),('16273','2013-08-24','08:20:00',1.52),('16273','2013-08-24','08:25:00',1.57),('16273','2013-08-24','08:30:00',1.67),('16273','2013-08-24','08:35:00',1.76),('16273','2013-08-24','08:40:00',1.87),('16273','2013-08-24','08:45:00',1.95),('16273','2013-08-24','08:50:00',1.99),('16273','2013-08-24','08:55:00',2.05),('16273','2013-08-24','09:00:00',2.17),('16273','2013-08-24','09:05:00',2.2),('16273','2013-08-24','09:10:00',2.27),('16273','2013-08-24','09:15:00',2.32),('16273','2013-08-24','09:20:00',2.41),('16273','2013-08-24','09:25:00',2.48),('16273','2013-08-24','09:30:00',2.58),('16273','2013-08-24','09:35:00',2.62),('16273','2013-08-24','09:40:00',2.7),('16273','2013-08-24','09:45:00',2.69),('16273','2013-08-24','09:50:00',2.81),('16273','2013-08-24','09:55:00',2.89),('16273','2013-08-24','10:00:00',2.94),('16273','2013-08-24','10:05:00',2.98),('16273','2013-08-24','10:10:00',3.03),('16273','2013-08-24','10:15:00',3.09),('16273','2013-08-24','10:20:00',3.12),('16273','2013-08-24','10:25:00',3.16),('16273','2013-08-24','10:30:00',3.2),('16273','2013-08-24','10:35:00',3.25),('16273','2013-08-24','10:40:00',3.29),('16273','2013-08-24','10:45:00',3.32),('16273','2013-08-24','10:50:00',3.36),('16273','2013-08-24','10:55:00',3.38),('16273','2013-08-24','11:00:00',3.41),('16273','2013-08-24','11:05:00',3.45),('16273','2013-08-24','11:10:00',3.47),('16273','2013-08-24','11:15:00',3.5),('16273','2013-08-24','11:20:00',3.52),('16273','2013-08-24','11:25:00',3.49),('16273','2013-08-24','11:30:00',3.52),('16273','2013-08-24','11:35:00',3.54),('16273','2013-08-24','11:40:00',3.59),('16273','2013-08-24','11:45:00',3.55),('16273','2013-08-24','11:50:00',3.57),('16273','2013-08-24','11:55:00',3.58),('16273','2013-08-24','12:00:00',3.63),('16273','2013-08-24','12:05:00',3.63),('16273','2013-08-24','12:10:00',3.61),('16273','2013-08-24','12:15:00',3.6),('16273','2013-08-24','12:20:00',3.63),('16273','2013-08-24','12:25:00',3.64),('16273','2013-08-24','12:30:00',3.67),('16273','2013-08-24','12:35:00',3.67),('16273','2013-08-24','12:40:00',3.65),('16273','2013-08-24','12:45:00',3.66),('16273','2013-08-24','12:50:00',3.63),('16273','2013-08-24','12:55:00',3.66),('16273','2013-08-24','13:00:00',3.63),('16273','2013-08-24','13:05:00',3.63),('16273','2013-08-24','13:10:00',3.58),('16273','2013-08-24','13:15:00',3.6),('16273','2013-08-24','13:20:00',3.58),('16273','2013-08-24','13:25:00',3.54),('16273','2013-08-24','13:30:00',3.54),('16273','2013-08-24','13:35:00',3.51),('16273','2013-08-24','13:40:00',3.5),('16273','2013-08-24','13:45:00',3.48),('16273','2013-08-24','13:50:00',3.47),('16273','2013-08-24','13:55:00',3.42),('16273','2013-08-24','14:00:00',3.41),('16273','2013-08-24','14:05:00',3.38),('16273','2013-08-24','14:10:00',3.35),('16273','2013-08-24','14:15:00',3.32),('16273','2013-08-24','14:20:00',3.28),('16273','2013-08-24','14:25:00',3.23),('16273','2013-08-24','14:30:00',3.22),('16273','2013-08-24','14:35:00',3.18),('16273','2013-08-24','14:40:00',3.14),('16273','2013-08-24','14:45:00',3.1),('16273','2013-08-24','14:50:00',3.06),('16273','2013-08-24','14:55:00',3.02),('16273','2013-08-24','15:00:00',2.96),('16273','2013-08-24','15:05:00',2.92),('16273','2013-08-24','15:10:00',2.87),('16273','2013-08-24','15:15:00',2.83),('16273','2013-08-24','15:20:00',2.77),('16273','2013-08-24','15:25:00',2.71),('16273','2013-08-24','15:30:00',2.66),('16273','2013-08-24','15:35:00',2.59),('16273','2013-08-24','15:40:00',2.53),('16273','2013-08-24','15:45:00',2.49),('16273','2013-08-24','15:50:00',2.44),('16273','2013-08-24','15:55:00',2.39),('16273','2013-08-24','16:00:00',2.32),('16273','2013-08-24','16:05:00',2.26),('16273','2013-08-24','16:10:00',2.19),('16273','2013-08-24','16:15:00',2.13),('16273','2013-08-24','16:20:00',2.06),('16273','2013-08-24','16:25:00',1.99),('16273','2013-08-24','16:30:00',1.92),('16273','2013-08-24','16:35:00',1.85),('16273','2013-08-24','16:40:00',1.77),('16273','2013-08-24','16:45:00',1.7),('16273','2013-08-24','16:50:00',1.63),('16273','2013-08-24','16:55:00',1.56),('16273','2013-08-24','17:00:00',1.49),('16273','2013-08-24','17:05:00',1.42),('16273','2013-08-24','17:10:00',1.34),('16273','2013-08-24','17:15:00',1.27),('16273','2013-08-24','17:20:00',1.2),('16273','2013-08-24','17:25:00',1.13),('16273','2013-08-24','17:30:00',1.06),('16273','2013-08-23','08:00:00',1.06),('16273','2013-08-23','08:05:00',1.14),('16273','2013-08-23','08:10:00',1.28),('16273','2013-08-23','08:15:00',1.24),('16273','2013-08-23','08:20:00',1.24),('16273','2013-08-23','08:25:00',1.45),('16273','2013-08-23','08:30:00',1.53),('16273','2013-08-23','08:35:00',1.65),('16273','2013-08-23','08:40:00',1.72),('16273','2013-08-23','08:45:00',1.72),('16273','2013-08-23','08:50:00',1.92),('16273','2013-08-23','08:55:00',1.92),('16273','2013-08-23','09:00:00',1.81),('16273','2013-08-23','09:05:00',2.05),('16273','2013-08-23','09:10:00',2.12),('16273','2013-08-23','09:15:00',2.17),('16273','2013-08-23','09:20:00',2.25),('16273','2013-08-23','09:25:00',2.33),('16273','2013-08-23','09:30:00',2.35),('16273','2013-08-23','09:35:00',2.38),('16273','2013-08-23','09:40:00',2.48),('16273','2013-08-23','09:45:00',2.52),('16273','2013-08-23','09:50:00',2.63),('16273','2013-08-23','09:55:00',2.65),('16273','2013-08-23','10:00:00',2.72),('16273','2013-08-23','10:05:00',2.73),('16273','2013-08-23','10:10:00',2.78),('16273','2013-08-23','10:15:00',2.71),('16273','2013-08-23','10:20:00',2.8),('16273','2013-08-23','10:25:00',2.86),('16273','2013-08-23','10:30:00',2.77),('16273','2013-08-23','10:35:00',2.74),('16273','2013-08-23','10:40:00',3.09),('16273','2013-08-23','10:45:00',3.28),('16273','2013-08-23','10:50:00',3.13),('16273','2013-08-23','10:55:00',2.62),('16273','2013-08-23','11:00:00',1.03),('16273','2013-08-23','11:05:00',2.21),('16273','2013-08-23','11:10:00',3.27),('16273','2013-08-23','11:15:00',2.55),('16273','2013-08-23','11:20:00',3.05),('16273','2013-08-23','11:25:00',3.4),('16273','2013-08-23','11:30:00',3.53),('16273','2013-08-23','11:35:00',3.11),('16273','2013-08-23','11:40:00',2.81),('16273','2013-08-23','11:45:00',2.17),('16273','2013-08-23','11:50:00',2.62),('16273','2013-08-23','11:55:00',1.89),('16273','2013-08-23','12:00:00',3.68),('16273','2013-08-23','12:05:00',3.73),('16273','2013-08-23','12:10:00',3.08),('16273','2013-08-23','12:15:00',2.03),('16273','2013-08-23','12:20:00',3.73),('16273','2013-08-23','12:25:00',3.33),('16273','2013-08-23','12:30:00',2.48),('16273','2013-08-23','12:35:00',3.72),('16273','2013-08-23','12:40:00',3.65),('16273','2013-08-23','12:45:00',3.64),('16273','2013-08-23','12:50:00',3.61),('16273','2013-08-23','12:55:00',3.59),('16273','2013-08-23','13:00:00',3.58),('16273','2013-08-23','13:05:00',3.57),('16273','2013-08-23','13:10:00',3.57),('16273','2013-08-23','13:15:00',3.56),('16273','2013-08-23','13:20:00',3.57),('16273','2013-08-23','13:25:00',3.56),('16273','2013-08-23','13:30:00',3.54),('16273','2013-08-23','13:35:00',3.53),('16273','2013-08-23','13:40:00',3.51),('16273','2013-08-23','13:45:00',3.49),('16273','2013-08-23','13:50:00',3.46),('16273','2013-08-23','13:55:00',3.43),('16273','2013-08-23','14:00:00',3.41),('16273','2013-08-23','14:05:00',3.38),('16273','2013-08-23','14:10:00',3.37),('16273','2013-08-23','14:15:00',3.35),('16273','2013-08-23','14:20:00',3.32),('16273','2013-08-23','14:25:00',3.26),('16273','2013-08-23','14:30:00',3.24),('16273','2013-08-23','14:35:00',3.2),('16273','2013-08-23','14:40:00',3.16),('16273','2013-08-23','14:45:00',3.02),('16273','2013-08-23','14:50:00',3.05),('16273','2013-08-23','14:55:00',2.92),('16273','2013-08-23','15:00:00',2.82),('16273','2013-08-23','15:05:00',2.88),('16273','2013-08-23','15:10:00',2.77),('16273','2013-08-23','15:15:00',2.75),('16273','2013-08-23','15:20:00',2.81),('16273','2013-08-23','15:25:00',2.8),('16273','2013-08-23','15:30:00',2.54),('16273','2013-08-23','15:35:00',2.62),('16273','2013-08-23','15:40:00',2.44),('16273','2013-08-23','15:45:00',2.4),('16273','2013-08-23','15:50:00',2.41),('16273','2013-08-23','15:55:00',2.3),('16273','2013-08-23','16:00:00',1.99),('16273','2013-08-23','16:05:00',1.89),('16273','2013-08-23','16:10:00',2.22),('16273','2013-08-23','16:15:00',2.24),('16273','2013-08-23','16:20:00',2.09),('16273','2013-08-23','16:25:00',1.99),('16273','2013-08-23','16:30:00',2.03),('16273','2013-08-23','16:35:00',1.95),('16273','2013-08-23','16:40:00',1.85),('16273','2013-08-23','16:45:00',1.74),('16273','2013-08-23','16:50:00',1.66),('16273','2013-08-23','16:55:00',1.6),('16273','2013-08-23','17:00:00',1.52),('16273','2013-08-23','17:05:00',1.43),('16273','2013-08-23','17:10:00',1.35),('16273','2013-08-23','17:15:00',1.27),('16273','2013-08-23','17:20:00',1.21),('16273','2013-08-23','17:25:00',1.15),('16273','2013-08-23','17:30:00',1.07),('16273','2013-08-22','07:55:00',1.13),('16273','2013-08-22','08:00:00',1.21),('16273','2013-08-22','08:05:00',1.27),('16273','2013-08-22','08:10:00',1.36),('16273','2013-08-22','08:15:00',1.45),('16273','2013-08-22','08:20:00',1.52),('16273','2013-08-22','08:25:00',1.59),('16273','2013-08-22','08:30:00',1.63),('16273','2013-08-22','08:35:00',1.73),('16273','2013-08-22','08:40:00',1.84),('16273','2013-08-22','08:45:00',1.92),('16273','2013-08-22','08:50:00',2.03),('16273','2013-08-22','08:55:00',2.13),('16273','2013-08-22','09:00:00',2.21),('16273','2013-08-22','09:05:00',1.62),('16273','2013-08-22','09:10:00',2.15),('16273','2013-08-22','09:15:00',2),('16273','2013-08-22','09:20:00',2.15),('16273','2013-08-22','09:25:00',1.81),('16273','2013-08-22','09:30:00',1.72),('16273','2013-08-22','09:35:00',2.33),('16273','2013-08-22','09:40:00',2.63),('16273','2013-08-22','09:45:00',2.89),('16273','2013-08-22','09:50:00',2.94),('16273','2013-08-22','09:55:00',3.06),('16273','2013-08-22','10:00:00',3.1),('16273','2013-08-22','10:05:00',3.05),('16273','2013-08-22','10:10:00',3.18),('16273','2013-08-22','10:15:00',3.22),('16273','2013-08-22','10:20:00',3.16),('16273','2013-08-22','10:25:00',3.2),('16273','2013-08-22','10:30:00',3.26),('16273','2013-08-22','10:35:00',3.27),('16273','2013-08-22','10:40:00',3.26),('16273','2013-08-22','10:45:00',3.28),('16273','2013-08-22','10:50:00',3.31),('16273','2013-08-22','10:55:00',3.33),('16273','2013-08-22','11:00:00',3.37),('16273','2013-08-22','11:05:00',3.4),('16273','2013-08-22','11:10:00',3.41),('16273','2013-08-22','11:15:00',3.46),('16273','2013-08-22','11:20:00',3.48),('16273','2013-08-22','11:25:00',3.51),('16273','2013-08-22','11:30:00',3.52),('16273','2013-08-22','11:35:00',3.53),('16273','2013-08-22','11:40:00',3.53),('16273','2013-08-22','11:45:00',3.55),('16273','2013-08-22','11:50:00',3.55),('16273','2013-08-22','11:55:00',3.56),('16273','2013-08-22','12:00:00',3.57),('16273','2013-08-22','12:05:00',3.57),('16273','2013-08-22','12:10:00',3.55),('16273','2013-08-22','12:15:00',3.57),('16273','2013-08-22','12:20:00',3.55),('16273','2013-08-22','12:25:00',3.55),('16273','2013-08-22','12:30:00',3.52),('16273','2013-08-22','12:35:00',3.51),('16273','2013-08-22','12:40:00',3.51),('16273','2013-08-22','12:45:00',3.5),('16273','2013-08-22','12:50:00',3.48),('16273','2013-08-22','12:55:00',3.48),('16273','2013-08-22','13:00:00',3.47),('16273','2013-08-22','13:05:00',3.45),('16273','2013-08-22','13:10:00',3.42),('16273','2013-08-22','13:15:00',3.42),('16273','2013-08-22','13:20:00',3.39),('16273','2013-08-22','13:25:00',3.38),('16273','2013-08-22','13:30:00',3.39),('16273','2013-08-22','13:35:00',3.38),('16273','2013-08-22','13:40:00',3.35),('16273','2013-08-22','13:45:00',3.33),('16273','2013-08-22','13:50:00',3.32),('16273','2013-08-22','13:55:00',3.29),('16273','2013-08-22','14:00:00',3.26),('16273','2013-08-22','14:05:00',3.26),('16273','2013-08-22','14:10:00',3.24),('16273','2013-08-22','14:15:00',3.18),('16273','2013-08-22','14:20:00',3.15),('16273','2013-08-22','14:25:00',3.13),('16273','2013-08-22','14:30:00',3.08),('16273','2013-08-22','14:35:00',3.12),('16273','2013-08-22','14:40:00',3.15),('16273','2013-08-22','14:45:00',3.04),('16273','2013-08-22','14:50:00',2.35),('16273','2013-08-22','14:55:00',2.96),('16273','2013-08-22','15:00:00',2.91),('16273','2013-08-22','15:05:00',2.86),('16273','2013-08-22','15:10:00',2.79),('16273','2013-08-22','15:15:00',2.75),('16273','2013-08-22','15:20:00',2.7),('16273','2013-08-22','15:25:00',2.67),('16273','2013-08-22','15:30:00',2.6),('16273','2013-08-22','15:35:00',2.55),('16273','2013-08-22','15:40:00',2.51),('16273','2013-08-22','15:45:00',2.45),('16273','2013-08-22','15:50:00',2.41),('16273','2013-08-22','15:55:00',2.34),('16273','2013-08-22','16:00:00',2.28),('16273','2013-08-22','16:05:00',2.21),('16273','2013-08-22','16:10:00',2.13),('16273','2013-08-22','16:15:00',2.05),('16273','2013-08-22','16:20:00',2),('16273','2013-08-22','16:25:00',1.93),('16273','2013-08-22','16:30:00',1.87),('16273','2013-08-22','16:35:00',1.79),('16273','2013-08-22','16:40:00',1.73),('16273','2013-08-22','16:45:00',1.66),('16273','2013-08-22','16:50:00',1.58),('16273','2013-08-22','16:55:00',1.5),('16273','2013-08-22','17:00:00',1.45),('16273','2013-08-22','17:05:00',1.39),('16273','2013-08-22','17:10:00',1.33),('16273','2013-08-22','17:15:00',1.26),('16273','2013-08-22','17:20:00',1.18),('16273','2013-08-22','17:25:00',1.12),('16273','2013-08-22','17:30:00',1.06),('16273','2013-08-21','09:10:00',2.14),('16273','2013-08-21','09:15:00',1.82),('16273','2013-08-21','09:20:00',1.61),('16273','2013-08-21','09:25:00',2.42),('16273','2013-08-21','09:30:00',2.02),('16273','2013-08-21','09:45:00',1.07),('16273','2013-08-21','09:50:00',1.31),('16273','2013-08-21','09:55:00',1.36),('16273','2013-08-21','10:00:00',1.2),('16273','2013-08-21','10:05:00',1.42),('16273','2013-08-21','10:10:00',1.71),('16273','2013-08-21','10:15:00',2.64),('16273','2013-08-21','10:20:00',3.13),('16273','2013-08-21','10:25:00',3.19),('16273','2013-08-21','10:30:00',2.64),('16273','2013-08-21','10:35:00',2.39),('16273','2013-08-21','10:40:00',3.31),('16273','2013-08-21','10:45:00',3.4),('16273','2013-08-21','10:50:00',2.96),('16273','2013-08-21','10:55:00',3.11),('16273','2013-08-21','11:00:00',2.27),('16273','2013-08-21','11:05:00',2.86),('16273','2013-08-21','11:10:00',1.62),('16273','2013-08-21','11:15:00',2.2),('16273','2013-08-21','11:20:00',2.4),('16273','2013-08-21','11:25:00',3.07),('16273','2013-08-21','11:30:00',2.9),('16273','2013-08-21','11:35:00',3.68),('16273','2013-08-21','11:40:00',3.72),('16273','2013-08-21','11:45:00',3.13),('16273','2013-08-21','11:50:00',3.87),('16273','2013-08-21','11:55:00',3.55),('16273','2013-08-21','12:00:00',3.87),('16273','2013-08-21','12:05:00',3.83),('16273','2013-08-21','12:10:00',3.88),('16273','2013-08-21','12:15:00',3.82),('16273','2013-08-21','12:20:00',3.69),('16273','2013-08-21','12:25:00',3.73),('16273','2013-08-21','12:30:00',3.2),('16273','2013-08-21','12:35:00',3.3),('16273','2013-08-21','12:40:00',2.46),('16273','2013-08-21','12:45:00',1.94),('16273','2013-08-21','12:50:00',3.19),('16273','2013-08-21','12:55:00',3.35),('16273','2013-08-21','13:00:00',3.4),('16273','2013-08-21','13:05:00',3.48),('16273','2013-08-21','13:10:00',3.37),('16273','2013-08-21','13:15:00',3.54),('16273','2013-08-21','13:20:00',3.41),('16273','2013-08-21','13:25:00',3.45),('16273','2013-08-21','13:30:00',3.38),('16273','2013-08-21','13:35:00',3.42),('16273','2013-08-21','13:40:00',3.52),('16273','2013-08-21','13:45:00',3.51),('16273','2013-08-21','13:50:00',3.54),('16273','2013-08-21','13:55:00',3.45),('16273','2013-08-21','14:00:00',3.32),('16273','2013-08-21','14:05:00',3.29),('16273','2013-08-21','14:10:00',3.22),('16273','2013-08-21','14:15:00',3.18),('16273','2013-08-21','14:20:00',2.95),('16273','2013-08-21','14:25:00',2.81),('16273','2013-08-21','14:30:00',3.04),('16273','2013-08-21','14:35:00',2.92),('16273','2013-08-21','14:40:00',2.92),('16273','2013-08-21','14:45:00',3.01),('16273','2013-08-21','14:50:00',3.03),('16273','2013-08-21','14:55:00',2.96),('16273','2013-08-21','15:00:00',2.82),('16273','2013-08-21','15:05:00',2.65),('16273','2013-08-21','15:10:00',2.61),('16273','2013-08-21','15:15:00',2.41),('16273','2013-08-21','15:20:00',2.31),('16273','2013-08-21','15:25:00',2.23),('16273','2013-08-21','15:30:00',2.4),('16273','2013-08-21','15:35:00',2.45),('16273','2013-08-21','15:40:00',2.37),('16273','2013-08-21','15:45:00',2.33),('16273','2013-08-21','15:50:00',2.27),('16273','2013-08-21','15:55:00',2.21),('16273','2013-08-21','16:00:00',2.14),('16273','2013-08-21','16:05:00',2.13),('16273','2013-08-21','16:10:00',2.03),('16273','2013-08-21','16:15:00',2.04),('16273','2013-08-21','16:20:00',2.02),('16273','2013-08-21','16:25:00',1.97),('16273','2013-08-21','16:30:00',1.93),('16273','2013-08-21','16:35:00',1.97),('16273','2013-08-21','16:40:00',1.89),('16273','2013-08-21','16:45:00',1.84),('16273','2013-08-21','16:50:00',1.78),('16273','2013-08-21','16:55:00',1.71),('16273','2013-08-21','17:00:00',1.62),('16273','2013-08-21','17:05:00',1.55),('16273','2013-08-21','17:10:00',1.5),('16273','2013-08-21','17:15:00',1.45),('16273','2013-08-21','17:20:00',1.41),('16273','2013-08-21','17:25:00',1.35),('16273','2013-08-21','17:30:00',1.3),('16273','2013-08-21','17:35:00',1.23),('16273','2013-08-21','17:40:00',1.17),('16273','2013-08-21','17:45:00',1.12),('16273','2013-08-21','17:50:00',1.07),('16273','2013-08-20','07:45:00',1.06),('16273','2013-08-20','07:50:00',1.33),('16273','2013-08-20','07:55:00',1.16),('16273','2013-08-20','08:45:00',1.11),('16273','2013-08-20','08:50:00',1.36),('16273','2013-08-20','09:10:00',1.22),('16273','2013-08-20','09:15:00',1.64),('16273','2013-08-20','09:20:00',2),('16273','2013-08-20','09:25:00',2.56),('16273','2013-08-20','09:30:00',3.02),('16273','2013-08-20','09:35:00',3.17),('16273','2013-08-20','09:50:00',1.66),('16273','2013-08-20','09:55:00',1.79),('16273','2013-08-20','10:00:00',2.92),('16273','2013-08-20','10:05:00',2.38),('16273','2013-08-20','10:10:00',1.15),('16273','2013-08-20','10:15:00',2.18),('16273','2013-08-20','10:20:00',2.52),('16273','2013-08-20','10:25:00',1.25),('16273','2013-08-20','10:40:00',1.28),('16273','2013-08-20','10:45:00',3.43),('16273','2013-08-20','10:50:00',2.96),('16273','2013-08-20','10:55:00',1.79),('16273','2013-08-20','11:00:00',1.31),('16273','2013-08-20','11:05:00',3.03),('16273','2013-08-20','11:10:00',2.58),('16273','2013-08-20','11:15:00',4.03),('16273','2013-08-20','11:20:00',3.19),('16273','2013-08-20','11:25:00',3.64),('16273','2013-08-20','11:30:00',4.11),('16273','2013-08-20','11:35:00',3.03),('16273','2013-08-20','11:40:00',2.83),('16273','2013-08-20','11:45:00',2.5),('16273','2013-08-20','11:50:00',3.33),('16273','2013-08-20','11:55:00',2.19),('16273','2013-08-20','12:00:00',1.97),('16273','2013-08-20','12:05:00',2.56),('16273','2013-08-20','12:10:00',1.68),('16273','2013-08-20','12:15:00',1.5),('16273','2013-08-20','12:20:00',1.65),('16273','2013-08-20','12:25:00',1.57),('16273','2013-08-20','12:30:00',1.73),('16273','2013-08-20','12:35:00',1.83),('16273','2013-08-20','12:40:00',1.51),('16273','2013-08-20','12:45:00',1.62),('16273','2013-08-20','12:50:00',1.87),('16273','2013-08-20','12:55:00',1.68),('16273','2013-08-20','13:00:00',1.51),('16273','2013-08-20','13:05:00',1.52),('16273','2013-08-20','13:10:00',1.74),('16273','2013-08-20','13:15:00',1.68),('16273','2013-08-20','13:20:00',1.74),('16273','2013-08-20','13:25:00',2.07),('16273','2013-08-20','13:30:00',2),('16273','2013-08-20','13:35:00',3.51),('16273','2013-08-20','13:40:00',4.31),('16273','2013-08-20','13:45:00',3.98),('16273','2013-08-20','13:50:00',3.69),('16273','2013-08-20','13:55:00',3.64),('16273','2013-08-20','14:00:00',2.63),('16273','2013-08-20','14:05:00',3.6),('16273','2013-08-20','14:10:00',3.56),('16273','2013-08-20','14:15:00',3.53),('16273','2013-08-20','14:20:00',2.25),('16273','2013-08-20','14:25:00',2.35),('16273','2013-08-20','14:30:00',3.46),('16273','2013-08-20','14:35:00',2.6),('16273','2013-08-20','14:40:00',2.12),('16273','2013-08-20','14:45:00',1.46),('16273','2013-08-20','14:50:00',3.41),('16273','2013-08-20','14:55:00',3.48),('16273','2013-08-20','15:00:00',3.15),('16273','2013-08-20','15:05:00',3.16),('16273','2013-08-20','15:10:00',3.18),('16273','2013-08-20','15:15:00',3.19),('16273','2013-08-20','15:20:00',3.2),('16273','2013-08-20','15:25:00',3),('16273','2013-08-20','15:30:00',3.03),('16273','2013-08-20','15:35:00',3.42),('16273','2013-08-20','15:40:00',2.89),('16273','2013-08-20','15:45:00',2.86),('16273','2013-08-20','15:50:00',2.76),('16273','2013-08-20','15:55:00',2.72),('16273','2013-08-20','16:00:00',2.73),('16273','2013-08-20','16:05:00',2.68),('16273','2013-08-20','16:10:00',2.67),('16273','2013-08-20','16:15:00',2.64),('16273','2013-08-20','16:20:00',2.61),('16273','2013-08-20','16:25:00',2.54),('16273','2013-08-20','16:30:00',2.44),('16273','2013-08-20','16:35:00',2.27),('16273','2013-08-20','16:40:00',2.04),('16273','2013-08-20','16:45:00',1.86),('16273','2013-08-20','16:50:00',1.78),('16273','2013-08-20','16:55:00',1.58),('16273','2013-08-20','17:00:00',1.21),('16273','2013-08-20','17:05:00',1.12),('16273','2013-08-20','17:15:00',1.24),('16273','2013-08-20','17:35:00',1.18),('16273','2013-08-20','17:40:00',1.07),('16273','2014-04-10','07:50:00',1.04),('16273','2014-04-10','07:55:00',1.17),('16273','2014-04-10','08:00:00',1.3),('16273','2014-04-10','08:05:00',1.51),('16273','2014-04-10','08:10:00',1.61),('16273','2014-04-10','08:15:00',1.72),('16273','2014-04-10','08:20:00',1.83),('16273','2014-04-10','08:25:00',1.92),('16273','2014-04-10','08:30:00',2),('16273','2014-04-10','08:35:00',2.1),('16273','2014-04-10','08:40:00',2.2),('16273','2014-04-10','08:45:00',2.28),('16273','2014-04-10','08:50:00',2.35),('16273','2014-04-10','08:55:00',2.41),('16273','2014-04-10','09:00:00',2.51),('16273','2014-04-10','09:05:00',2.58),('16273','2014-04-10','09:10:00',2.64),('16273','2014-04-10','09:15:00',2.72),('16273','2014-04-10','09:20:00',2.75),('16273','2014-04-10','09:25:00',2.83),('16273','2014-04-10','09:30:00',2.9),('16273','2014-04-10','09:35:00',2.94),('16273','2014-04-10','09:40:00',2.99),('16273','2014-04-10','09:45:00',3.02),('16273','2014-04-10','09:50:00',3.09),('16273','2014-04-10','09:55:00',3.15),('16273','2014-04-10','10:00:00',3.19),('16273','2014-04-10','10:05:00',3.25),('16273','2014-04-10','10:10:00',3.33),('16273','2014-04-10','10:15:00',3.29),('16273','2014-04-10','10:20:00',3.34),('16273','2014-04-10','10:25:00',3.38),('16273','2014-04-10','10:30:00',3.4),('16273','2014-04-10','10:35:00',3.56),('16273','2014-04-10','10:40:00',3.58),('16273','2014-04-10','10:45:00',3.53),('16273','2014-04-10','10:50:00',3.54),('16273','2014-04-10','10:55:00',3.61),('16273','2014-04-10','11:00:00',3.67),('16273','2014-04-10','11:05:00',3.74),('16273','2014-04-10','11:10:00',3.76),('16273','2014-04-10','11:15:00',3.77),('16273','2014-04-10','11:20:00',3.89),('16273','2014-04-10','11:25:00',3.91),('16273','2014-04-10','11:30:00',3.91),('16273','2014-04-10','11:35:00',3.81),('16273','2014-04-10','11:40:00',3.84),('16273','2014-04-10','11:45:00',3.86),('16273','2014-04-10','11:50:00',3.79),('16273','2014-04-10','11:55:00',3.79),('16273','2014-04-10','12:00:00',3.69),('16273','2014-04-10','12:05:00',3.57),('16273','2014-04-10','12:10:00',3.8),('16273','2014-04-10','12:15:00',3.85),('16273','2014-04-10','12:20:00',3.79),('16273','2014-04-10','12:25:00',3.78),('16273','2014-04-10','12:30:00',3.66),('16273','2014-04-10','12:35:00',3.87),('16273','2014-04-10','12:40:00',3.68),('16273','2014-04-10','12:45:00',3.84),('16273','2014-04-10','12:50:00',3.81),('16273','2014-04-10','12:55:00',3.86),('16273','2014-04-10','13:00:00',3.72),('16273','2014-04-10','13:05:00',3.41),('16273','2014-04-10','13:10:00',3.9),('16273','2014-04-10','13:15:00',3.8),('16273','2014-04-10','13:20:00',3.6),('16273','2014-04-10','13:25:00',3.69),('16273','2014-04-10','13:30:00',3.67),('16273','2014-04-10','13:35:00',3.7),('16273','2014-04-10','13:40:00',3.63),('16273','2014-04-10','13:45:00',3.67),('16273','2014-04-10','13:50:00',3.61),('16273','2014-04-10','13:55:00',3.57),('16273','2014-04-10','14:00:00',3.54),('16273','2014-04-10','14:05:00',3.49),('16273','2014-04-10','14:10:00',3.42),('16273','2014-04-10','14:15:00',3.5),('16273','2014-04-10','14:20:00',3.44),('16273','2014-04-10','14:25:00',3.41),('16273','2014-04-10','14:30:00',3.37),('16273','2014-04-10','14:35:00',3.25),('16273','2014-04-10','14:40:00',3.31),('16273','2014-04-10','14:45:00',2.89),('16273','2014-04-10','14:50:00',3),('16273','2014-04-10','14:55:00',3.1),('16273','2014-04-10','15:00:00',3.08),('16273','2014-04-10','15:05:00',2.98),('16273','2014-04-10','15:10:00',2.95),('16273','2014-04-10','15:15:00',2.9),('16273','2014-04-10','15:20:00',2.76),('16273','2014-04-10','15:25:00',2.72),('16273','2014-04-10','15:30:00',2.51),('16273','2014-04-10','15:35:00',2.39),('16273','2014-04-10','15:40:00',2.51),('16273','2014-04-10','15:45:00',2.45),('16273','2014-04-10','15:50:00',2.37),('16273','2014-04-10','15:55:00',2.55),('16273','2014-04-10','16:00:00',2.5),('16273','2014-04-10','16:05:00',2.35),('16273','2014-04-10','16:10:00',2.37),('16273','2014-04-10','16:15:00',2.3),('16273','2014-04-10','16:20:00',2.19),('16273','2014-04-10','16:25:00',2.05),('16273','2014-04-10','16:30:00',2.12),('16273','2014-04-10','16:35:00',1.92),('16273','2014-04-10','16:40:00',1.9),('16273','2014-04-10','16:45:00',1.81),('16273','2014-04-10','16:50:00',1.77),('16273','2014-04-10','16:55:00',1.65),('16273','2014-04-10','17:00:00',1.56),('16273','2014-04-10','17:05:00',1.49),('16273','2014-04-10','17:10:00',1.43),('16273','2014-04-10','17:15:00',1.32),('16273','2014-04-10','17:20:00',1.24),('16273','2014-04-10','17:25:00',1.15),('16273','2014-04-10','17:30:00',1.07),('16273','2013-08-19','07:50:00',1.09),('16273','2013-08-19','07:55:00',1.09),('16273','2013-08-19','08:00:00',1.24),('16273','2013-08-19','08:05:00',1.37),('16273','2013-08-19','08:10:00',1.45),('16273','2013-08-19','08:15:00',1.53),('16273','2013-08-19','08:20:00',1.61),('16273','2013-08-19','08:25:00',1.67),('16273','2013-08-19','08:30:00',1.76),('16273','2013-08-19','08:35:00',1.86),('16273','2013-08-19','08:40:00',1.95),('16273','2013-08-19','08:45:00',2.03),('16273','2013-08-19','08:50:00',2.09),('16273','2013-08-19','08:55:00',2.16),('16273','2013-08-19','09:00:00',2.22),('16273','2013-08-19','09:05:00',2.31),('16273','2013-08-19','09:10:00',2.37),('16273','2013-08-19','09:15:00',2.46),('16273','2013-08-19','09:20:00',2.5),('16273','2013-08-19','09:25:00',2.55),('16273','2013-08-19','09:30:00',2.61),('16273','2013-08-19','09:35:00',2.68),('16273','2013-08-19','09:40:00',2.72),('16273','2013-08-19','09:45:00',2.79),('16273','2013-08-19','09:50:00',2.85),('16273','2013-08-19','09:55:00',2.89),('16273','2013-08-19','10:00:00',2.95),('16273','2013-08-19','10:05:00',2.99),('16273','2013-08-19','10:10:00',3),('16273','2013-08-19','10:15:00',3.03),('16273','2013-08-19','10:20:00',3.09),('16273','2013-08-19','10:25:00',3.11),('16273','2013-08-19','10:30:00',3.12),('16273','2013-08-19','10:35:00',3.19),('16273','2013-08-19','10:40:00',3.26),('16273','2013-08-19','10:45:00',3.33),('16273','2013-08-19','10:50:00',3.34),('16273','2013-08-19','10:55:00',3.32),('16273','2013-08-19','11:00:00',3.34),('16273','2013-08-19','11:05:00',3.38),('16273','2013-08-19','11:10:00',3.4),('16273','2013-08-19','11:15:00',3.44),('16273','2013-08-19','11:20:00',3.48),('16273','2013-08-19','11:25:00',3.47),('16273','2013-08-19','11:30:00',3.49),('16273','2013-08-19','11:35:00',3.5),('16273','2013-08-19','11:40:00',3.53),('16273','2013-08-19','11:45:00',3.54),('16273','2013-08-19','11:50:00',3.58),('16273','2013-08-19','11:55:00',3.58),('16273','2013-08-19','12:00:00',3.62),('16273','2013-08-19','12:05:00',3.58),('16273','2013-08-19','12:10:00',3.63),('16273','2013-08-19','12:15:00',3.61),('16273','2013-08-19','12:20:00',3.65),('16273','2013-08-19','12:25:00',3.69),('16273','2013-08-19','12:30:00',3.7),('16273','2013-08-19','12:35:00',3.69),('16273','2013-08-19','12:40:00',3.7),('16273','2013-08-19','12:45:00',3.69),('16273','2013-08-19','12:50:00',3.68),('16273','2013-08-19','12:55:00',3.69),('16273','2013-08-19','13:00:00',3.68),('16273','2013-08-19','13:05:00',3.67),('16273','2013-08-19','13:10:00',3.68),('16273','2013-08-19','13:15:00',3.68),('16273','2013-08-19','13:20:00',3.64),('16273','2013-08-19','13:25:00',3.62),('16273','2013-08-19','13:30:00',3.61),('16273','2013-08-19','13:35:00',3.58),('16273','2013-08-19','13:40:00',3.59),('16273','2013-08-19','13:45:00',3.57),('16273','2013-08-19','13:50:00',3.51),('16273','2013-08-19','13:55:00',3.52),('16273','2013-08-19','14:00:00',3.47),('16273','2013-08-19','14:05:00',3.45),('16273','2013-08-19','14:10:00',3.45),('16273','2013-08-19','14:15:00',3.43),('16273','2013-08-19','14:20:00',3.4),('16273','2013-08-19','14:25:00',3.38),('16273','2013-08-19','14:30:00',3.33),('16273','2013-08-19','14:35:00',3.28),('16273','2013-08-19','14:40:00',3.25),('16273','2013-08-19','14:45:00',3.2),('16273','2013-08-19','14:50:00',3.16),('16273','2013-08-19','14:55:00',3.13),('16273','2013-08-19','15:00:00',3.08),('16273','2013-08-19','15:05:00',3.01),('16273','2013-08-19','15:10:00',3),('16273','2013-08-19','15:15:00',2.95),('16273','2013-08-19','15:20:00',2.91),('16273','2013-08-19','15:25:00',2.85),('16273','2013-08-19','15:30:00',2.78),('16273','2013-08-19','15:35:00',2.72),('16273','2013-08-19','15:40:00',2.66),('16273','2013-08-19','15:45:00',2.57),('16273','2013-08-19','15:50:00',2.53),('16273','2013-08-19','15:55:00',2.49),('16273','2013-08-19','16:00:00',2.42),('16273','2013-08-19','16:05:00',2.36),('16273','2013-08-19','16:10:00',2.3),('16273','2013-08-19','16:15:00',2.22),('16273','2013-08-19','16:20:00',2.14),('16273','2013-08-19','16:25:00',2.08),('16273','2013-08-19','16:30:00',2.02),('16273','2013-08-19','16:35:00',1.96),('16273','2013-08-19','16:40:00',1.88),('16273','2013-08-19','16:45:00',1.81),('16273','2013-08-19','16:50:00',1.73),('16273','2013-08-19','16:55:00',1.66),('16273','2013-08-19','17:00:00',1.59),('16273','2013-08-19','17:05:00',1.52),('16273','2013-08-19','17:10:00',1.44),('16273','2013-08-19','17:15:00',1.37),('16273','2013-08-19','17:20:00',1.29),('16273','2013-08-19','17:25:00',1.21),('16273','2013-08-19','17:30:00',1.15),('16273','2013-08-19','17:35:00',1.08),('16273','2013-08-18','07:45:00',1.09),('16273','2013-08-18','07:50:00',1.19),('16273','2013-08-18','07:55:00',1.28),('16273','2013-08-18','08:00:00',1.37),('16273','2013-08-18','08:05:00',1.45),('16273','2013-08-18','08:10:00',1.54),('16273','2013-08-18','08:15:00',1.62),('16273','2013-08-18','08:20:00',1.71),('16273','2013-08-18','08:25:00',1.79),('16273','2013-08-18','08:30:00',1.87),('16273','2013-08-18','08:35:00',1.94),('16273','2013-08-18','08:40:00',2.02),('16273','2013-08-18','08:45:00',2.08),('16273','2013-08-18','08:50:00',2.15),('16273','2013-08-18','08:55:00',2.22),('16273','2013-08-18','09:00:00',2.3),('16273','2013-08-18','09:05:00',2.38),('16273','2013-08-18','09:10:00',2.43),('16273','2013-08-18','09:15:00',2.49),('16273','2013-08-18','09:20:00',2.56),('16273','2013-08-18','09:25:00',2.62),('16273','2013-08-18','09:30:00',2.66),('16273','2013-08-18','09:35:00',2.42),('16273','2013-08-18','09:40:00',2.37),('16273','2013-08-18','09:45:00',2.78),('16273','2013-08-18','09:50:00',2.62),('16273','2013-08-18','09:55:00',2.88),('16273','2013-08-18','10:00:00',2.94),('16273','2013-08-18','10:05:00',2.99),('16273','2013-08-18','10:10:00',3.04),('16273','2013-08-18','10:15:00',3.08),('16273','2013-08-18','10:20:00',3.1),('16273','2013-08-18','10:25:00',3.14),('16273','2013-08-18','10:30:00',3.16),('16273','2013-08-18','10:35:00',3.19),('16273','2013-08-18','10:40:00',3.2),('16273','2013-08-18','10:45:00',3.23),('16273','2013-08-18','10:50:00',3.24),('16273','2013-08-18','10:55:00',3.3),('16273','2013-08-18','11:00:00',3.35),('16273','2013-08-18','11:05:00',3.37),('16273','2013-08-18','11:10:00',3.38),('16273','2013-08-18','11:15:00',3.36),('16273','2013-08-18','11:20:00',3.43),('16273','2013-08-18','11:25:00',3.41),('16273','2013-08-18','11:30:00',3.41),('16273','2013-08-18','11:35:00',3.46),('16273','2013-08-18','11:40:00',3.46),('16273','2013-08-18','11:45:00',3.52),('16273','2013-08-18','11:50:00',3.55),('16273','2013-08-18','11:55:00',3.61),('16273','2013-08-18','12:00:00',2.68),('16273','2013-08-18','12:05:00',3.67),('16273','2013-08-18','12:10:00',3.6),('16273','2013-08-18','12:15:00',3.52),('16273','2013-08-18','12:20:00',3.68),('16273','2013-08-18','12:25:00',3.62),('16273','2013-08-18','12:30:00',3.65),('16273','2013-08-18','12:35:00',3.61),('16273','2013-08-18','12:40:00',3.54),('16273','2013-08-18','12:45:00',3.61),('16273','2013-08-18','12:50:00',3.65),('16273','2013-08-18','12:55:00',3.62),('16273','2013-08-18','13:00:00',3.61),('16273','2013-08-18','13:05:00',3.62),('16273','2013-08-18','13:10:00',3.61),('16273','2013-08-18','13:15:00',3.61),('16273','2013-08-18','13:20:00',3.56),('16273','2013-08-18','13:25:00',3.59),('16273','2013-08-18','13:30:00',3.57),('16273','2013-08-18','13:35:00',3.57),('16273','2013-08-18','13:40:00',3.55),('16273','2013-08-18','13:45:00',3.52),('16273','2013-08-18','13:50:00',3.51),('16273','2013-08-18','13:55:00',3.48),('16273','2013-08-18','14:00:00',3.48),('16273','2013-08-18','14:05:00',3.46),('16273','2013-08-18','14:10:00',3.42),('16273','2013-08-18','14:15:00',3.39),('16273','2013-08-18','14:20:00',3.35),('16273','2013-08-18','14:25:00',3.34),('16273','2013-08-18','14:30:00',3.31),('16273','2013-08-18','14:35:00',3.28),('16273','2013-08-18','14:40:00',3.24),('16273','2013-08-18','14:45:00',3.2),('16273','2013-08-18','14:50:00',3.15),('16273','2013-08-18','14:55:00',3.13),('16273','2013-08-18','15:00:00',3.07),('16273','2013-08-18','15:05:00',3.03),('16273','2013-08-18','15:10:00',2.99),('16273','2013-08-18','15:15:00',2.92),('16273','2013-08-18','15:20:00',2.86),('16273','2013-08-18','15:25:00',2.83),('16273','2013-08-18','15:30:00',2.76),('16273','2013-08-18','15:35:00',2.7),('16273','2013-08-18','15:40:00',2.65),('16273','2013-08-18','15:45:00',2.6),('16273','2013-08-18','15:50:00',2.55),('16273','2013-08-18','15:55:00',2.49),('16273','2013-08-18','16:00:00',2.43),('16273','2013-08-18','16:05:00',2.35),('16273','2013-08-18','16:10:00',2.3),('16273','2013-08-18','16:15:00',2.24),('16273','2013-08-18','16:20:00',2.17),('16273','2013-08-18','16:25:00',2.1),('16273','2013-08-18','16:30:00',2.03),('16273','2013-08-18','16:35:00',1.96),('16273','2013-08-18','16:40:00',1.88),('16273','2013-08-18','16:45:00',1.82),('16273','2013-08-18','16:50:00',1.75),('16273','2013-08-18','16:55:00',1.68),('16273','2013-08-18','17:00:00',1.61),('16273','2013-08-18','17:05:00',1.53),('16273','2013-08-18','17:10:00',1.46),('16273','2013-08-18','17:15:00',1.39),('16273','2013-08-18','17:20:00',1.31),('16273','2013-08-18','17:25:00',1.25),('16273','2013-08-18','17:30:00',1.17),('16273','2013-08-18','17:35:00',1.1),('16273','2013-08-18','17:40:00',1.03),('16273','2013-08-17','07:45:00',1.08),('16273','2013-08-17','07:50:00',1.17),('16273','2013-08-17','07:55:00',1.25),('16273','2013-08-17','08:00:00',1.33),('16273','2013-08-17','08:05:00',1.41),('16273','2013-08-17','08:10:00',1.49),('16273','2013-08-17','08:15:00',1.57),('16273','2013-08-17','08:20:00',1.68),('16273','2013-08-17','08:25:00',1.77),('16273','2013-08-17','08:30:00',1.85),('16273','2013-08-17','08:35:00',1.94),('16273','2013-08-17','08:40:00',2.01),('16273','2013-08-17','08:45:00',2.1),('16273','2013-08-17','08:50:00',2.19),('16273','2013-08-17','08:55:00',2.25),('16273','2013-08-17','09:00:00',2.31),('16273','2013-08-17','09:05:00',2.38),('16273','2013-08-17','09:10:00',2.46),('16273','2013-08-17','09:15:00',2.5),('16273','2013-08-17','09:20:00',2.58),('16273','2013-08-17','09:25:00',2.63),('16273','2013-08-17','09:30:00',2.7),('16273','2013-08-17','09:35:00',2.74),('16273','2013-08-17','09:40:00',2.79),('16273','2013-08-17','09:45:00',2.84),('16273','2013-08-17','09:50:00',2.9),('16273','2013-08-17','09:55:00',2.94),('16273','2013-08-17','10:00:00',2.99),('16273','2013-08-17','10:05:00',3.04),('16273','2013-08-17','10:10:00',3.08),('16273','2013-08-17','10:15:00',3.13),('16273','2013-08-17','10:20:00',3.15),('16273','2013-08-17','10:25:00',3.17),('16273','2013-08-17','10:30:00',3.2),('16273','2013-08-17','10:35:00',3.25),('16273','2013-08-17','10:40:00',3.27),('16273','2013-08-17','10:45:00',3.31),('16273','2013-08-17','10:50:00',3.34),('16273','2013-08-17','10:55:00',3.36),('16273','2013-08-17','11:00:00',3.39),('16273','2013-08-17','11:05:00',3.39),('16273','2013-08-17','11:10:00',3.42),('16273','2013-08-17','11:15:00',3.45),('16273','2013-08-17','11:20:00',3.47),('16273','2013-08-17','11:25:00',3.48),('16273','2013-08-17','11:30:00',3.47),('16273','2013-08-17','11:35:00',3.53),('16273','2013-08-17','11:40:00',3.49),('16273','2013-08-17','11:45:00',3.5),('16273','2013-08-17','11:50:00',3.51),('16273','2013-08-17','11:55:00',3.59),('16273','2013-08-17','12:00:00',3.55),('16273','2013-08-17','12:05:00',3.57),('16273','2013-08-17','12:10:00',3.57),('16273','2013-08-17','12:15:00',3.46),('16273','2013-08-17','12:20:00',3.66),('16273','2013-08-17','12:25:00',3.66),('16273','2013-08-17','12:30:00',3.68),('16273','2013-08-17','12:35:00',3.66),('16273','2013-08-17','12:40:00',3.62),('16273','2013-08-17','12:45:00',3.43),('16273','2013-08-17','12:50:00',3.66),('16273','2013-08-17','12:55:00',3.64),('16273','2013-08-17','13:00:00',3.63),('16273','2013-08-17','13:05:00',3.66),('16273','2013-08-17','13:10:00',3.66),('16273','2013-08-17','13:15:00',3.6),('16273','2013-08-17','13:20:00',3.57),('16273','2013-08-17','13:25:00',3.67),('16273','2013-08-17','13:30:00',3.56),('16273','2013-08-17','13:35:00',3.48),('16273','2013-08-17','13:40:00',3.43),('16273','2013-08-17','13:45:00',3.57),('16273','2013-08-17','13:50:00',3.48),('16273','2013-08-17','13:55:00',3.4),('16273','2013-08-17','14:00:00',3.46),('16273','2013-08-17','14:05:00',3.46),('16273','2013-08-17','14:10:00',3.4),('16273','2013-08-17','14:15:00',3.41),('16273','2013-08-17','14:20:00',3.35),('16273','2013-08-17','14:25:00',3.33),('16273','2013-08-17','14:30:00',3.29),('16273','2013-08-17','14:35:00',3.27),('16273','2013-08-17','14:40:00',3.21),('16273','2013-08-17','14:45:00',3.19),('16273','2013-08-17','14:50:00',3.16),('16273','2013-08-17','14:55:00',3.12),('16273','2013-08-17','15:00:00',3.08),('16273','2013-08-17','15:05:00',3.03),('16273','2013-08-17','15:10:00',2.98),('16273','2013-08-17','15:15:00',2.92),('16273','2013-08-17','15:20:00',2.9),('16273','2013-08-17','15:25:00',2.85),('16273','2013-08-17','15:30:00',2.81),('16273','2013-08-17','15:35:00',2.75),('16273','2013-08-17','15:40:00',2.69),('16273','2013-08-17','15:45:00',2.63),('16273','2013-08-17','15:50:00',2.57),('16273','2013-08-17','15:55:00',2.51),('16273','2013-08-17','16:00:00',2.45),('16273','2013-08-17','16:05:00',2.4),('16273','2013-08-17','16:10:00',2.34),('16273','2013-08-17','16:15:00',2.27),('16273','2013-08-17','16:20:00',2.21),('16273','2013-08-17','16:25:00',2.15),('16273','2013-08-17','16:30:00',2.08),('16273','2013-08-17','16:35:00',2.02),('16273','2013-08-17','16:40:00',1.92),('16273','2013-08-17','16:45:00',1.87),('16273','2013-08-17','16:50:00',1.79),('16273','2013-08-17','16:55:00',1.73),('16273','2013-08-17','17:00:00',1.6),('16273','2013-08-17','17:05:00',1.57),('16273','2013-08-17','17:10:00',1.43),('16273','2013-08-17','17:15:00',1.46),('16273','2013-08-17','17:20:00',1.35),('16273','2013-08-17','17:25:00',1.33),('16273','2013-08-17','17:30:00',1.25),('16273','2013-08-17','17:35:00',1.19),('16273','2013-08-17','17:40:00',1.1),('16273','2013-08-17','17:45:00',1.02),('16273','2013-08-16','07:45:00',1.13),('16273','2013-08-16','07:50:00',1.22),('16273','2013-08-16','07:55:00',1.31),('16273','2013-08-16','08:00:00',1.4),('16273','2013-08-16','08:05:00',1.48),('16273','2013-08-16','08:10:00',1.56),('16273','2013-08-16','08:15:00',1.64),('16273','2013-08-16','08:20:00',1.73),('16273','2013-08-16','08:25:00',1.8),('16273','2013-08-16','08:30:00',1.88),('16273','2013-08-16','08:35:00',1.96),('16273','2013-08-16','08:40:00',2.04),('16273','2013-08-16','08:45:00',2.13),('16273','2013-08-16','08:50:00',2.21),('16273','2013-08-16','08:55:00',2.3),('16273','2013-08-16','09:00:00',2.38),('16273','2013-08-16','09:05:00',2.46),('16273','2013-08-16','09:10:00',2.53),('16273','2013-08-16','09:15:00',2.6),('16273','2013-08-16','09:20:00',2.66),('16273','2013-08-16','09:25:00',2.69),('16273','2013-08-16','09:30:00',2.79),('16273','2013-08-16','09:35:00',2.85),('16273','2013-08-16','09:40:00',2.89),('16273','2013-08-16','09:45:00',2.95),('16273','2013-08-16','09:50:00',3),('16273','2013-08-16','09:55:00',3.07),('16273','2013-08-16','10:00:00',3.11),('16273','2013-08-16','10:05:00',3.15),('16273','2013-08-16','10:10:00',3.19),('16273','2013-08-16','10:15:00',3.24),('16273','2013-08-16','10:20:00',3.28),('16273','2013-08-16','10:25:00',3.31),('16273','2013-08-16','10:30:00',3.35),('16273','2013-08-16','10:35:00',3.39),('16273','2013-08-16','10:40:00',3.41),('16273','2013-08-16','10:45:00',3.44),('16273','2013-08-16','10:50:00',3.48),('16273','2013-08-16','10:55:00',3.51),('16273','2013-08-16','11:00:00',3.53),('16273','2013-08-16','11:05:00',3.57),('16273','2013-08-16','11:10:00',3.57),('16273','2013-08-16','11:15:00',3.58),('16273','2013-08-16','11:20:00',3.63),('16273','2013-08-16','11:25:00',3.65),('16273','2013-08-16','11:30:00',3.65),('16273','2013-08-16','11:35:00',3.67),('16273','2013-08-16','11:40:00',3.66),('16273','2013-08-16','11:45:00',3.67),('16273','2013-08-16','11:50:00',3.67),('16273','2013-08-16','11:55:00',3.68),('16273','2013-08-16','12:00:00',3.68),('16273','2013-08-16','12:05:00',3.7),('16273','2013-08-16','12:10:00',3.69),('16273','2013-08-16','12:15:00',3.69),('16273','2013-08-16','12:20:00',3.71),('16273','2013-08-16','12:25:00',3.7),('16273','2013-08-16','12:30:00',3.64),('16273','2013-08-16','12:35:00',3.7),('16273','2013-08-16','12:40:00',3.68),('16273','2013-08-16','12:45:00',3.68),('16273','2013-08-16','12:50:00',3.66),('16273','2013-08-16','12:55:00',3.64),('16273','2013-08-16','13:00:00',3.62),('16273','2013-08-16','13:05:00',3.61),('16273','2013-08-16','13:10:00',3.58),('16273','2013-08-16','13:15:00',3.57),('16273','2013-08-16','13:20:00',3.54),('16273','2013-08-16','13:25:00',3.55),('16273','2013-08-16','13:30:00',3.54),('16273','2013-08-16','13:35:00',3.51),('16273','2013-08-16','13:40:00',3.47),('16273','2013-08-16','13:45:00',3.43),('16273','2013-08-16','13:50:00',3.43),('16273','2013-08-16','13:55:00',3.39),('16273','2013-08-16','14:00:00',3.37),('16273','2013-08-16','14:05:00',3.35),('16273','2013-08-16','14:10:00',3.33),('16273','2013-08-16','14:15:00',3.3),('16273','2013-08-16','14:20:00',3.27),('16273','2013-08-16','14:25:00',3.24),('16273','2013-08-16','14:30:00',3.17),('16273','2013-08-16','14:35:00',3.17),('16273','2013-08-16','14:40:00',3.19),('16273','2013-08-16','14:45:00',3.17),('16273','2013-08-16','14:50:00',3.14),('16273','2013-08-16','14:55:00',3.1),('16273','2013-08-16','15:00:00',3.06),('16273','2013-08-16','15:05:00',3.04),('16273','2013-08-16','15:10:00',2.99),('16273','2013-08-16','15:15:00',2.95),('16273','2013-08-16','15:20:00',2.91),('16273','2013-08-16','15:25:00',2.85),('16273','2013-08-16','15:30:00',2.78),('16273','2013-08-16','15:35:00',2.74),('16273','2013-08-16','15:40:00',2.68),('16273','2013-08-16','15:45:00',2.62),('16273','2013-08-16','15:50:00',2.56),('16273','2013-08-16','15:55:00',2.5),('16273','2013-08-16','16:00:00',2.43),('16273','2013-08-16','16:05:00',2.38),('16273','2013-08-16','16:10:00',2.31),('16273','2013-08-16','16:15:00',2.25),('16273','2013-08-16','16:20:00',2.18),('16273','2013-08-16','16:25:00',2.12),('16273','2013-08-16','16:30:00',2.05),('16273','2013-08-16','16:35:00',1.98),('16273','2013-08-16','16:40:00',1.91),('16273','2013-08-16','16:45:00',1.83),('16273','2013-08-16','16:50:00',1.77),('16273','2013-08-16','16:55:00',1.69),('16273','2013-08-16','17:00:00',1.61),('16273','2013-08-16','17:05:00',1.54),('16273','2013-08-16','17:10:00',1.47),('16273','2013-08-16','17:15:00',1.39),('16273','2013-08-16','17:20:00',1.33),('16273','2013-08-16','17:25:00',1.25),('16273','2013-08-16','17:30:00',1.18),('16273','2013-08-16','17:35:00',1.11),('16273','2013-08-16','17:40:00',1.04),('16273','2013-08-15','08:05:00',1.28),('16273','2013-08-15','08:10:00',1.77),('16273','2013-08-15','08:15:00',1.91),('16273','2013-08-15','08:20:00',1.93),('16273','2013-08-15','08:25:00',1.95),('16273','2013-08-15','08:30:00',1.98),('16273','2013-08-15','08:35:00',2.04),('16273','2013-08-15','08:40:00',2.1),('16273','2013-08-15','08:45:00',2.19),('16273','2013-08-15','08:50:00',2.26),('16273','2013-08-15','08:55:00',2.15),('16273','2013-08-15','09:00:00',2.44),('16273','2013-08-15','09:05:00',2.51),('16273','2013-08-15','09:10:00',2.6),('16273','2013-08-15','09:15:00',2.66),('16273','2013-08-15','09:20:00',2.72),('16273','2013-08-15','09:25:00',2.76),('16273','2013-08-15','09:30:00',2.81),('16273','2013-08-15','09:35:00',2.86),('16273','2013-08-15','09:40:00',2.9),('16273','2013-08-15','09:45:00',2.95),('16273','2013-08-15','09:50:00',3.03),('16273','2013-08-15','09:55:00',3.08),('16273','2013-08-15','10:00:00',3.14),('16273','2013-08-15','10:05:00',3.2),('16273','2013-08-15','10:10:00',3.25),('16273','2013-08-15','10:15:00',3.29),('16273','2013-08-15','10:20:00',3.32),('16273','2013-08-15','10:25:00',3.34),('16273','2013-08-15','10:30:00',3.37),('16273','2013-08-15','10:35:00',3.43),('16273','2013-08-15','10:40:00',3.48),('16273','2013-08-15','10:45:00',3.53),('16273','2013-08-15','10:50:00',3.56),('16273','2013-08-15','10:55:00',3.6),('16273','2013-08-15','11:00:00',3.64),('16273','2013-08-15','11:05:00',3.7),('16273','2013-08-15','11:10:00',3.6),('16273','2013-08-15','11:15:00',3.4),('16273','2013-08-15','11:20:00',3.49),('16273','2013-08-15','11:25:00',3.73),('16273','2013-08-15','11:30:00',3.58),('16273','2013-08-15','11:35:00',3.71),('16273','2013-08-15','11:40:00',3.79),('16273','2013-08-15','11:45:00',3.4),('16273','2013-08-15','11:50:00',2.77),('16273','2013-08-15','11:55:00',2.51),('16273','2013-08-15','12:00:00',2.58),('16273','2013-08-15','12:05:00',3.07),('16273','2013-08-15','12:10:00',3.4),('16273','2013-08-15','12:15:00',3.58),('16273','2013-08-15','12:20:00',3.48),('16273','2013-08-15','12:25:00',3.46),('16273','2013-08-15','12:30:00',3.65),('16273','2013-08-15','12:35:00',3.77),('16273','2013-08-15','12:40:00',3.84),('16273','2013-08-15','12:45:00',3.85),('16273','2013-08-15','12:50:00',3.84),('16273','2013-08-15','12:55:00',3.78),('16273','2013-08-15','13:00:00',3.77),('16273','2013-08-15','13:05:00',3.64),('16273','2013-08-15','13:10:00',3.53),('16273','2013-08-15','13:15:00',3.51),('16273','2013-08-15','13:20:00',3.41),('16273','2013-08-15','13:25:00',3.5),('16273','2013-08-15','13:30:00',3.52),('16273','2013-08-15','13:35:00',3.46),('16273','2013-08-15','13:40:00',3.37),('16273','2013-08-15','13:45:00',3.44),('16273','2013-08-15','13:50:00',3.48),('16273','2013-08-15','13:55:00',3.48),('16273','2013-08-15','14:00:00',3.4),('16273','2013-08-15','14:05:00',3.21),('16273','2013-08-15','14:10:00',3.35),('16273','2013-08-15','14:15:00',3.28),('16273','2013-08-15','14:20:00',2.85),('16273','2013-08-15','14:25:00',2.91),('16273','2013-08-15','14:30:00',3.26),('16273','2013-08-15','14:35:00',3.17),('16273','2013-08-15','14:40:00',3.17),('16273','2013-08-15','14:45:00',3.14),('16273','2013-08-15','14:50:00',3.08),('16273','2013-08-15','14:55:00',2.96),('16273','2013-08-15','15:00:00',2.94),('16273','2013-08-15','15:05:00',2.93),('16273','2013-08-15','15:10:00',2.88),('16273','2013-08-15','15:15:00',2.81),('16273','2013-08-15','15:20:00',2.73),('16273','2013-08-15','15:25:00',2.77),('16273','2013-08-15','15:30:00',2.71),('16273','2013-08-15','15:35:00',2.66),('16273','2013-08-15','15:40:00',2.62),('16273','2013-08-15','15:45:00',2.56),('16273','2013-08-15','15:50:00',2.03),('16273','2013-08-15','15:55:00',2.45),('16273','2013-08-15','16:00:00',2.37),('16273','2013-08-15','16:05:00',2.37),('16273','2013-08-15','16:10:00',2.32),('16273','2013-08-15','16:15:00',2.02),('16273','2013-08-15','16:20:00',1.97),('16273','2013-08-15','16:25:00',1.52),('16273','2013-08-15','16:35:00',1.43),('16273','2013-08-15','16:40:00',1.46),('16273','2013-08-15','16:45:00',1.25),('16273','2013-08-15','16:50:00',1.7),('16273','2013-08-15','16:55:00',1.09),('16273','2013-08-15','17:00:00',1.7),('16273','2013-08-15','17:05:00',1.64),('16273','2013-08-15','17:10:00',1.55),('16273','2013-08-15','17:15:00',1.47),('16273','2013-08-15','17:20:00',1.41),('16273','2013-08-15','17:25:00',1.3),('16273','2013-08-15','17:30:00',1.12),('16273','2013-08-15','17:35:00',1.16),('16273','2013-08-15','17:40:00',1.06),('16273','2013-08-14','07:50:00',1.08),('16273','2013-08-14','07:55:00',1.24),('16273','2013-08-14','08:00:00',1.34),('16273','2013-08-14','08:05:00',1.31),('16273','2013-08-14','08:10:00',1.51),('16273','2013-08-14','08:15:00',1.54),('16273','2013-08-14','08:20:00',1.58),('16273','2013-08-14','08:25:00',1.55),('16273','2013-08-14','08:35:00',1.83),('16273','2013-08-14','08:40:00',2.03),('16273','2013-08-14','08:45:00',2.25),('16273','2013-08-14','08:50:00',1.89),('16273','2013-08-14','08:55:00',1.22),('16273','2013-08-14','09:15:00',1.43),('16273','2013-08-14','09:20:00',1.25),('16273','2013-08-14','09:25:00',2.36),('16273','2013-08-14','09:30:00',2.54),('16273','2013-08-14','09:35:00',2.45),('16273','2013-08-14','09:40:00',2.12),('16273','2013-08-14','09:45:00',1.75),('16273','2013-08-14','09:50:00',2.76),('16273','2013-08-14','09:55:00',3.39),('16273','2013-08-14','10:00:00',3.06),('16273','2013-08-14','10:05:00',3.22),('16273','2013-08-14','10:10:00',2.56),('16273','2013-08-14','10:15:00',1.79),('16273','2013-08-14','10:20:00',1.05),('16273','2013-08-14','10:25:00',1.17),('16273','2013-08-14','10:30:00',1.38),('16273','2013-08-14','10:35:00',3.48),('16273','2013-08-14','10:40:00',3.35),('16273','2013-08-14','10:45:00',1.98),('16273','2013-08-14','10:50:00',2.19),('16273','2013-08-14','10:55:00',1.21),('16273','2013-08-14','11:00:00',1.21),('16273','2013-08-14','11:05:00',1.19),('16273','2013-08-14','11:10:00',1.27),('16273','2013-08-14','11:15:00',2.9),('16273','2013-08-14','11:20:00',3.9),('16273','2013-08-14','11:25:00',2.18),('16273','2013-08-14','11:30:00',1.24),('16273','2013-08-14','11:35:00',1.29),('16273','2013-08-14','11:40:00',3.34),('16273','2013-08-14','11:45:00',2.1),('16273','2013-08-14','11:50:00',1.82),('16273','2013-08-14','11:55:00',3.25),('16273','2013-08-14','12:00:00',3.7),('16273','2013-08-14','12:05:00',3.72),('16273','2013-08-14','12:10:00',3.89),('16273','2013-08-14','12:15:00',3.86),('16273','2013-08-14','12:20:00',3.91),('16273','2013-08-14','12:25:00',3.84),('16273','2013-08-14','12:30:00',3.57),('16273','2013-08-14','12:35:00',1.96),('16273','2013-08-14','12:40:00',1.67),('16273','2013-08-14','12:45:00',1.09),('16273','2013-08-14','12:50:00',1.26),('16273','2013-08-14','12:55:00',1.69),('16273','2013-08-14','13:00:00',2.61),('16273','2013-08-14','13:05:00',3.19),('16273','2013-08-14','13:10:00',3.33),('16273','2013-08-14','13:15:00',3.65),('16273','2013-08-14','13:20:00',3.67),('16273','2013-08-14','13:25:00',3.79),('16273','2013-08-14','13:30:00',3.62),('16273','2013-08-14','13:35:00',3.62),('16273','2013-08-14','13:40:00',3.66),('16273','2013-08-14','13:45:00',3.7),('16273','2013-08-14','13:50:00',3.65),('16273','2013-08-14','13:55:00',3.56),('16273','2013-08-14','14:00:00',3.55),('16273','2013-08-14','14:05:00',3.61),('16273','2013-08-14','14:10:00',3.49),('16273','2013-08-14','14:15:00',2.64),('16273','2013-08-14','14:20:00',3.61),('16273','2013-08-14','14:25:00',3.43),('16273','2013-08-14','14:30:00',3.35),('16273','2013-08-14','14:35:00',3.31),('16273','2013-08-14','14:40:00',3.29),('16273','2013-08-14','14:45:00',3.23),('16273','2013-08-14','14:50:00',3.21),('16273','2013-08-14','14:55:00',3.18),('16273','2013-08-14','15:00:00',3.12),('16273','2013-08-14','15:05:00',3.08),('16273','2013-08-14','15:10:00',3.03),('16273','2013-08-14','15:15:00',2.98),('16273','2013-08-14','15:20:00',2.93),('16273','2013-08-14','15:25:00',2.9),('16273','2013-08-14','15:30:00',2.82),('16273','2013-08-14','15:35:00',2.79),('16273','2013-08-14','15:40:00',2.74),('16273','2013-08-14','15:45:00',2.67),('16273','2013-08-14','15:50:00',2.63),('16273','2013-08-14','15:55:00',2.55),('16273','2013-08-14','16:00:00',2.49),('16273','2013-08-14','16:05:00',2.43),('16273','2013-08-14','16:10:00',2.36),('16273','2013-08-14','16:15:00',2.29),('16273','2013-08-14','16:20:00',2.23),('16273','2013-08-14','16:25:00',2.16),('16273','2013-08-14','16:30:00',2.09),('16273','2013-08-14','16:35:00',2.03),('16273','2013-08-14','16:40:00',1.94),('16273','2013-08-14','16:45:00',1.88),('16273','2013-08-14','16:50:00',1.82),('16273','2013-08-14','16:55:00',1.74),('16273','2013-08-14','17:00:00',1.65),('16273','2013-08-14','17:05:00',1.59),('16273','2013-08-14','17:10:00',1.51),('16273','2013-08-14','17:15:00',1.44),('16273','2013-08-14','17:20:00',1.37),('16273','2013-08-14','17:25:00',1.29),('16273','2013-08-14','17:30:00',1.21),('16273','2013-08-14','17:35:00',1.16),('16273','2013-08-14','17:40:00',1.08),('16273','2013-08-14','17:45:00',1.01),('16273','2013-08-13','07:40:00',1.04),('16273','2013-08-13','07:45:00',1.14),('16273','2013-08-13','07:50:00',1.23),('16273','2013-08-13','07:55:00',1.32),('16273','2013-08-13','08:00:00',1.38),('16273','2013-08-13','08:05:00',1.47),('16273','2013-08-13','08:10:00',1.54),('16273','2013-08-13','08:15:00',1.64),('16273','2013-08-13','08:20:00',1.71),('16273','2013-08-13','08:25:00',1.8),('16273','2013-08-13','08:30:00',1.89),('16273','2013-08-13','08:35:00',1.96),('16273','2013-08-13','08:40:00',2.07),('16273','2013-08-13','08:45:00',2.13),('16273','2013-08-13','08:50:00',2.21),('16273','2013-08-13','08:55:00',2.25),('16273','2013-08-13','09:00:00',2.31),('16273','2013-08-13','09:05:00',2.39),('16273','2013-08-13','09:10:00',2.46),('16273','2013-08-13','09:15:00',2.55),('16273','2013-08-13','09:20:00',2.59),('16273','2013-08-13','09:25:00',2.61),('16273','2013-08-13','09:30:00',2.73),('16273','2013-08-13','09:35:00',2.59),('16273','2013-08-13','09:40:00',2.62),('16273','2013-08-13','09:45:00',2.25),('16273','2013-08-13','09:50:00',2.98),('16273','2013-08-13','09:55:00',3.06),('16273','2013-08-13','10:00:00',3.15),('16273','2013-08-13','10:05:00',3.25),('16273','2013-08-13','10:10:00',3.23),('16273','2013-08-13','10:15:00',3.26),('16273','2013-08-13','10:20:00',3.12),('16273','2013-08-13','10:25:00',3.24),('16273','2013-08-13','10:30:00',3.41),('16273','2013-08-13','10:35:00',3.4),('16273','2013-08-13','10:40:00',3.36),('16273','2013-08-13','10:45:00',3.41),('16273','2013-08-13','10:50:00',3.54),('16273','2013-08-13','10:55:00',2.66),('16273','2013-08-13','11:00:00',2),('16273','2013-08-13','11:05:00',3.01),('16273','2013-08-13','11:10:00',3.49),('16273','2013-08-13','11:15:00',3.52),('16273','2013-08-13','11:20:00',3.59),('16273','2013-08-13','11:25:00',3.56),('16273','2013-08-13','11:30:00',3.58),('16273','2013-08-13','11:35:00',3.55),('16273','2013-08-13','11:40:00',3.67),('16273','2013-08-13','11:45:00',3.69),('16273','2013-08-13','11:50:00',3.82),('16273','2013-08-13','11:55:00',2.4),('16273','2013-08-13','12:00:00',3.36),('16273','2013-08-13','12:05:00',4.01),('16273','2013-08-13','12:10:00',3.92),('16273','2013-08-13','12:15:00',3.84),('16273','2013-08-13','12:20:00',3.91),('16273','2013-08-13','12:25:00',3.52),('16273','2013-08-13','12:30:00',3.82),('16273','2013-08-13','12:35:00',3.8),('16273','2013-08-13','12:40:00',3.87),('16273','2013-08-13','12:45:00',3.81),('16273','2013-08-13','12:50:00',3.79),('16273','2013-08-13','12:55:00',3.11),('16273','2013-08-13','13:00:00',3.73),('16273','2013-08-13','13:05:00',3.76),('16273','2013-08-13','13:10:00',3.66),('16273','2013-08-13','13:15:00',3.67),('16273','2013-08-13','13:20:00',3.7),('16273','2013-08-13','13:25:00',3.63),('16273','2013-08-13','13:30:00',3.63),('16273','2013-08-13','13:35:00',3.62),('16273','2013-08-13','13:40:00',3.6),('16273','2013-08-13','13:45:00',3.64),('16273','2013-08-13','13:50:00',3.1),('16273','2013-08-13','13:55:00',3.59),('16273','2013-08-13','14:00:00',3.59),('16273','2013-08-13','14:05:00',3.47),('16273','2013-08-13','14:10:00',3.47),('16273','2013-08-13','14:15:00',3.42),('16273','2013-08-13','14:20:00',3.4),('16273','2013-08-13','14:25:00',3.37),('16273','2013-08-13','14:30:00',3.37),('16273','2013-08-13','14:35:00',3.32),('16273','2013-08-13','14:40:00',3.31),('16273','2013-08-13','14:45:00',3.25),('16273','2013-08-13','14:50:00',3.21),('16273','2013-08-13','14:55:00',3.17),('16273','2013-08-13','15:00:00',3.1),('16273','2013-08-13','15:05:00',3.07),('16273','2013-08-13','15:10:00',3.04),('16273','2013-08-13','15:15:00',2.98),('16273','2013-08-13','15:20:00',2.95),('16273','2013-08-13','15:25:00',2.89),('16273','2013-08-13','15:30:00',2.84),('16273','2013-08-13','15:35:00',2.79),('16273','2013-08-13','15:40:00',2.74),('16273','2013-08-13','15:45:00',2.67),('16273','2013-08-13','15:50:00',2.51),('16273','2013-08-13','15:55:00',2.57),('16273','2013-08-13','16:00:00',2.49),('16273','2013-08-13','16:05:00',2.43),('16273','2013-08-13','16:10:00',2.36),('16273','2013-08-13','16:15:00',2.3),('16273','2013-08-13','16:20:00',2.23),('16273','2013-08-13','16:25:00',2.17),('16273','2013-08-13','16:30:00',2.09),('16273','2013-08-13','16:35:00',2.03),('16273','2013-08-13','16:40:00',1.97),('16273','2013-08-13','16:45:00',1.89),('16273','2013-08-13','16:50:00',1.83),('16273','2013-08-13','16:55:00',1.76),('16273','2013-08-13','17:00:00',1.68),('16273','2013-08-13','17:05:00',1.61),('16273','2013-08-13','17:10:00',1.53),('16273','2013-08-13','17:15:00',1.45),('16273','2013-08-13','17:20:00',1.38),('16273','2013-08-13','17:25:00',1.3),('16273','2013-08-13','17:30:00',1.23),('16273','2013-08-13','17:35:00',1.16),('16273','2013-08-13','17:40:00',1.08),('16273','2013-08-13','17:45:00',1.01),('16273','2013-08-12','07:45:00',1.02),('16273','2013-08-12','07:50:00',1.1),('16273','2013-08-12','07:55:00',1.19),('16273','2013-08-12','08:00:00',1.26),('16273','2013-08-12','08:05:00',1.31),('16273','2013-08-12','08:10:00',1.37),('16273','2013-08-12','08:15:00',1.47),('16273','2013-08-12','08:20:00',1.6),('16273','2013-08-12','08:25:00',1.68),('16273','2013-08-12','08:30:00',1.8),('16273','2013-08-12','08:35:00',1.91),('16273','2013-08-12','08:40:00',2.01),('16273','2013-08-12','08:45:00',2.09),('16273','2013-08-12','08:50:00',2.15),('16273','2013-08-12','08:55:00',2.21),('16273','2013-08-12','09:00:00',2.27),('16273','2013-08-12','09:05:00',2.34),('16273','2013-08-12','09:10:00',2.42),('16273','2013-08-12','09:15:00',2.48),('16273','2013-08-12','09:20:00',2.53),('16273','2013-08-12','09:25:00',2.58),('16273','2013-08-12','09:30:00',2.63),('16273','2013-08-12','09:35:00',2.69),('16273','2013-08-12','09:40:00',2.73),('16273','2013-08-12','09:45:00',2.81),('16273','2013-08-12','09:50:00',2.87),('16273','2013-08-12','09:55:00',2.91),('16273','2013-08-12','10:00:00',2.95),('16273','2013-08-12','10:05:00',2.99),('16273','2013-08-12','10:10:00',3),('16273','2013-08-12','10:15:00',3.06),('16273','2013-08-12','10:20:00',3.11),('16273','2013-08-12','10:25:00',3.14),('16273','2013-08-12','10:30:00',3.19),('16273','2013-08-12','10:35:00',3.23),('16273','2013-08-12','10:40:00',3.29),('16273','2013-08-12','10:45:00',3.31),('16273','2013-08-12','10:50:00',3.33),('16273','2013-08-12','10:55:00',3.32),('16273','2013-08-12','11:00:00',3.33),('16273','2013-08-12','11:05:00',3.36),('16273','2013-08-12','11:10:00',3.44),('16273','2013-08-12','11:15:00',3.43),('16273','2013-08-12','11:20:00',2.87),('16273','2013-08-12','11:25:00',3.56),('16273','2013-08-12','11:30:00',3.37),('16273','2013-08-12','11:35:00',3.69),('16273','2013-08-12','11:40:00',2.39),('16273','2013-08-12','11:45:00',1.12),('16273','2013-08-12','11:50:00',1.23),('16273','2013-08-12','11:55:00',3.95),('16273','2013-08-12','12:00:00',4.06),('16273','2013-08-12','12:05:00',3.96),('16273','2013-08-12','12:10:00',3.39),('16273','2013-08-12','12:15:00',3.84),('16273','2013-08-12','12:20:00',4),('16273','2013-08-12','12:25:00',1.86),('16273','2013-08-12','12:30:00',3.15),('16273','2013-08-12','12:35:00',3.56),('16273','2013-08-12','12:40:00',1.64),('16273','2013-08-12','12:45:00',3.79),('16273','2013-08-12','12:50:00',3.73),('16273','2013-08-12','12:55:00',2.89),('16273','2013-08-12','13:00:00',1.34),('16273','2013-08-12','13:05:00',2.63),('16273','2013-08-12','13:10:00',2.72),('16273','2013-08-12','13:15:00',3.21),('16273','2013-08-12','13:20:00',3.75),('16273','2013-08-12','13:25:00',3.61),('16273','2013-08-12','13:30:00',1.71),('16273','2013-08-12','13:35:00',3.31),('16273','2013-08-12','13:40:00',2.46),('16273','2013-08-12','13:45:00',3.86),('16273','2013-08-12','13:50:00',3.79),('16273','2013-08-12','13:55:00',3.75),('16273','2013-08-12','14:00:00',3.76),('16273','2013-08-12','14:05:00',3.31),('16273','2013-08-12','14:10:00',2.07),('16273','2013-08-12','14:15:00',2.41),('16273','2013-08-12','14:20:00',3.78),('16273','2013-08-12','14:25:00',3.56),('16273','2013-08-12','14:30:00',2.56),('16273','2013-08-12','14:35:00',3.1),('16273','2013-08-12','14:40:00',3.5),('16273','2013-08-12','14:45:00',3.47),('16273','2013-08-12','14:50:00',3.26),('16273','2013-08-12','14:55:00',3.23),('16273','2013-08-12','15:00:00',3.13),('16273','2013-08-12','15:05:00',3.11),('16273','2013-08-12','15:10:00',3.07),('16273','2013-08-12','15:15:00',2.98),('16273','2013-08-12','15:20:00',2.65),('16273','2013-08-12','15:25:00',2.92),('16273','2013-08-12','15:30:00',2.86),('16273','2013-08-12','15:35:00',2.82),('16273','2013-08-12','15:40:00',2.74),('16273','2013-08-12','15:45:00',2.2),('16273','2013-08-12','15:50:00',2.65),('16273','2013-08-12','15:55:00',2.57),('16273','2013-08-12','16:00:00',2.47),('16273','2013-08-12','16:05:00',2.41),('16273','2013-08-12','16:10:00',2.36),('16273','2013-08-12','16:15:00',2.3),('16273','2013-08-12','16:20:00',2.28),('16273','2013-08-12','16:25:00',2.2),('16273','2013-08-12','16:30:00',2.13),('16273','2013-08-12','16:35:00',2.04),('16273','2013-08-12','16:40:00',1.95),('16273','2013-08-12','16:45:00',1.86),('16273','2013-08-12','16:50:00',1.81),('16273','2013-08-12','16:55:00',1.72),('16273','2013-08-12','17:00:00',1.65),('16273','2013-08-12','17:05:00',1.59),('16273','2013-08-12','17:10:00',1.5),('16273','2013-08-12','17:15:00',1.44),('16273','2013-08-12','17:20:00',1.38),('16273','2013-08-12','17:25:00',1.3),('16273','2013-08-12','17:30:00',1.24),('16273','2013-08-12','17:35:00',1.17),('16273','2013-08-12','17:40:00',1.11),('16273','2013-08-12','17:45:00',1.04),('16273','2013-08-11','07:40:00',1.04),('16273','2013-08-11','07:45:00',1.15),('16273','2013-08-11','07:50:00',1.25),('16273','2013-08-11','07:55:00',1.33),('16273','2013-08-11','08:00:00',1.41),('16273','2013-08-11','08:05:00',1.5),('16273','2013-08-11','08:10:00',1.58),('16273','2013-08-11','08:15:00',1.67),('16273','2013-08-11','08:20:00',1.75),('16273','2013-08-11','08:25:00',1.83),('16273','2013-08-11','08:30:00',1.92),('16273','2013-08-11','08:35:00',2),('16273','2013-08-11','08:40:00',2.05),('16273','2013-08-11','08:45:00',2.15),('16273','2013-08-11','08:50:00',2.2),('16273','2013-08-11','08:55:00',2.27),('16273','2013-08-11','09:00:00',2.34),('16273','2013-08-11','09:05:00',2.42),('16273','2013-08-11','09:10:00',2.46),('16273','2013-08-11','09:15:00',2.54),('16273','2013-08-11','09:20:00',2.6),('16273','2013-08-11','09:25:00',2.65),('16273','2013-08-11','09:30:00',2.71),('16273','2013-08-11','09:35:00',2.77),('16273','2013-08-11','09:40:00',2.82),('16273','2013-08-11','09:45:00',2.87),('16273','2013-08-11','09:50:00',2.93),('16273','2013-08-11','09:55:00',2.95),('16273','2013-08-11','10:00:00',3.03),('16273','2013-08-11','10:05:00',3.06),('16273','2013-08-11','10:10:00',3.12),('16273','2013-08-11','10:15:00',3.16),('16273','2013-08-11','10:20:00',3.19),('16273','2013-08-11','10:25:00',3.23),('16273','2013-08-11','10:30:00',3.3),('16273','2013-08-11','10:35:00',3.33),('16273','2013-08-11','10:40:00',3.36),('16273','2013-08-11','10:45:00',3.4),('16273','2013-08-11','10:50:00',3.42),('16273','2013-08-11','10:55:00',3.44),('16273','2013-08-11','11:00:00',3.49),('16273','2013-08-11','11:05:00',3.49),('16273','2013-08-11','11:10:00',3.51),('16273','2013-08-11','11:15:00',3.54),('16273','2013-08-11','11:20:00',3.56),('16273','2013-08-11','11:25:00',3.58),('16273','2013-08-11','11:30:00',3.62),('16273','2013-08-11','11:35:00',3.6),('16273','2013-08-11','11:40:00',3.58),('16273','2013-08-11','11:45:00',3.59),('16273','2013-08-11','11:50:00',3.61),('16273','2013-08-11','11:55:00',3.64),('16273','2013-08-11','12:00:00',3.63),('16273','2013-08-11','12:05:00',3.63),('16273','2013-08-11','12:10:00',3.65),('16273','2013-08-11','12:15:00',3.66),('16273','2013-08-11','12:20:00',3.67),('16273','2013-08-11','12:25:00',3.65),('16273','2013-08-11','12:30:00',3.63),('16273','2013-08-11','12:35:00',3.64),('16273','2013-08-11','12:40:00',3.63),('16273','2013-08-11','12:45:00',3.64),('16273','2013-08-11','12:50:00',3.63),('16273','2013-08-11','12:55:00',3.61),('16273','2013-08-11','13:00:00',3.59),('16273','2013-08-11','13:05:00',3.6),('16273','2013-08-11','13:10:00',3.6),('16273','2013-08-11','13:15:00',3.59),('16273','2013-08-11','13:20:00',3.55),('16273','2013-08-11','13:25:00',3.52),('16273','2013-08-11','13:30:00',3.55),('16273','2013-08-11','13:35:00',3.55),('16273','2013-08-11','13:40:00',3.51),('16273','2013-08-11','13:45:00',3.46),('16273','2013-08-11','13:50:00',3.42),('16273','2013-08-11','13:55:00',3.42),('16273','2013-08-11','14:00:00',3.39),('16273','2013-08-11','14:05:00',3.37),('16273','2013-08-11','14:10:00',3.34),('16273','2013-08-11','14:15:00',3.31),('16273','2013-08-11','14:20:00',3.29),('16273','2013-08-11','14:25:00',3.2),('16273','2013-08-11','14:30:00',3.25),('16273','2013-08-11','14:35:00',3.21),('16273','2013-08-11','14:40:00',3.17),('16273','2013-08-11','14:45:00',3.14),('16273','2013-08-11','14:50:00',3.09),('16273','2013-08-11','14:55:00',3.05),('16273','2013-08-11','15:00:00',3.01),('16273','2013-08-11','15:05:00',2.99),('16273','2013-08-11','15:10:00',2.97),('16273','2013-08-11','15:15:00',2.93),('16273','2013-08-11','15:20:00',2.9),('16273','2013-08-11','15:25:00',2.86),('16273','2013-08-11','15:30:00',2.81),('16273','2013-08-11','15:35:00',2.77),('16273','2013-08-11','15:40:00',2.71),('16273','2013-08-11','15:45:00',2.67),('16273','2013-08-11','15:50:00',2.61),('16273','2013-08-11','15:55:00',2.53),('16273','2013-08-11','16:00:00',2.48),('16273','2013-08-11','16:05:00',2.42),('16273','2013-08-11','16:10:00',2.36),('16273','2013-08-11','16:15:00',2.3),('16273','2013-08-11','16:20:00',2.24),('16273','2013-08-11','16:25:00',2.17),('16273','2013-08-11','16:30:00',2.08),('16273','2013-08-11','16:35:00',2.03),('16273','2013-08-11','16:40:00',1.95),('16273','2013-08-11','16:45:00',1.88),('16273','2013-08-11','16:50:00',1.81),('16273','2013-08-11','16:55:00',1.74),('16273','2013-08-11','17:00:00',1.67),('16273','2013-08-11','17:05:00',1.6),('16273','2013-08-11','17:10:00',1.52),('16273','2013-08-11','17:15:00',1.44),('16273','2013-08-11','17:20:00',1.37),('16273','2013-08-11','17:25:00',1.31),('16273','2013-08-11','17:30:00',1.24),('16273','2013-08-11','17:35:00',1.17),('16273','2013-08-11','17:40:00',1.1),('16273','2013-08-11','17:45:00',1.02),('16273','2013-08-10','07:45:00',1.17),('16273','2013-08-10','07:50:00',1.28),('16273','2013-08-10','07:55:00',1.38),('16273','2013-08-10','08:00:00',1.47),('16273','2013-08-10','08:05:00',1.55),('16273','2013-08-10','08:10:00',1.63),('16273','2013-08-10','08:15:00',1.72),('16273','2013-08-10','08:20:00',1.81),('16273','2013-08-10','08:25:00',1.89),('16273','2013-08-10','08:30:00',1.95),('16273','2013-08-10','08:35:00',2.04),('16273','2013-08-10','08:40:00',2.1),('16273','2013-08-10','08:45:00',2.17),('16273','2013-08-10','08:50:00',2.25),('16273','2013-08-10','08:55:00',2.32),('16273','2013-08-10','09:00:00',2.38),('16273','2013-08-10','09:05:00',2.45),('16273','2013-08-10','09:10:00',2.51),('16273','2013-08-10','09:15:00',2.56),('16273','2013-08-10','09:20:00',2.62),('16273','2013-08-10','09:25:00',2.7),('16273','2013-08-10','09:30:00',2.73),('16273','2013-08-10','09:35:00',2.79),('16273','2013-08-10','09:40:00',2.85),('16273','2013-08-10','09:45:00',2.88),('16273','2013-08-10','09:50:00',2.95),('16273','2013-08-10','09:55:00',3),('16273','2013-08-10','10:00:00',3.04),('16273','2013-08-10','10:05:00',3.08),('16273','2013-08-10','10:10:00',3.12),('16273','2013-08-10','10:15:00',3.16),('16273','2013-08-10','10:20:00',3.21),('16273','2013-08-10','10:25:00',3.25),('16273','2013-08-10','10:30:00',3.3),('16273','2013-08-10','10:35:00',3.34),('16273','2013-08-10','10:40:00',3.37),('16273','2013-08-10','10:45:00',3.42),('16273','2013-08-10','10:50:00',3.48),('16273','2013-08-10','10:55:00',3.53),('16273','2013-08-10','11:00:00',3.54),('16273','2013-08-10','11:05:00',3.62),('16273','2013-08-10','11:10:00',3.67),('16273','2013-08-10','11:15:00',3.71),('16273','2013-08-10','11:20:00',3.69),('16273','2013-08-10','11:25:00',3.64),('16273','2013-08-10','11:30:00',3.62),('16273','2013-08-10','11:35:00',3.68),('16273','2013-08-10','11:40:00',3.68),('16273','2013-08-10','11:45:00',3.7),('16273','2013-08-10','11:50:00',3.7),('16273','2013-08-10','11:55:00',3.7),('16273','2013-08-10','12:00:00',1.98),('16273','2013-08-10','12:05:00',3),('16273','2013-08-10','12:10:00',3.8),('16273','2013-08-10','12:15:00',3.74),('16273','2013-08-10','12:20:00',3.76),('16273','2013-08-10','12:25:00',3.79),('16273','2013-08-10','12:30:00',3.79),('16273','2013-08-10','12:35:00',3.83),('16273','2013-08-10','12:40:00',3.8),('16273','2013-08-10','12:45:00',3.79),('16273','2013-08-10','12:50:00',1.95),('16273','2013-08-10','12:55:00',3.31),('16273','2013-08-10','13:00:00',3.81),('16273','2013-08-10','13:05:00',3.72),('16273','2013-08-10','13:10:00',3.71),('16273','2013-08-10','13:15:00',3.74),('16273','2013-08-10','13:20:00',3.87),('16273','2013-08-10','13:25:00',3.88),('16273','2013-08-10','13:30:00',3.66),('16273','2013-08-10','13:35:00',1.17),('16273','2013-08-10','13:40:00',2.69),('16273','2013-08-10','13:45:00',3.89),('16273','2013-08-10','13:50:00',3.06),('16273','2013-08-10','13:55:00',2.04),('16273','2013-08-10','14:00:00',1.35),('16273','2013-08-10','14:05:00',1.7),('16273','2013-08-10','14:10:00',2.84),('16273','2013-08-10','14:15:00',1.32),('16273','2013-08-10','15:40:00',1.07),('16273','2013-08-10','15:45:00',1.25),('16273','2013-08-10','15:50:00',1.39),('16273','2013-08-10','15:55:00',1.41),('16273','2013-08-10','16:00:00',1.55),('16273','2013-08-10','16:05:00',1.39),('16273','2013-08-10','16:10:00',1.36),('16273','2013-08-10','16:15:00',1.1),('16273','2013-08-10','16:20:00',2),('16273','2013-08-10','16:25:00',1.12),('16273','2013-08-10','16:55:00',1.04),('16273','2013-08-10','17:05:00',1.05),('16273','2014-04-09','08:00:00',1.09),('16273','2014-04-09','08:10:00',1.27),('16273','2014-04-09','08:15:00',1.2),('16273','2014-04-09','08:50:00',1.1),('16273','2014-04-09','08:55:00',1.15),('16273','2014-04-09','09:00:00',1.62),('16273','2014-04-09','09:05:00',1.16),('16273','2014-04-09','09:10:00',1),('16273','2014-04-09','09:40:00',2.18),('16273','2014-04-09','09:45:00',1.71),('16273','2014-04-09','09:50:00',2.67),('16273','2014-04-09','09:55:00',2.99),('16273','2014-04-09','10:00:00',2.8),('16273','2014-04-09','10:05:00',3.12),('16273','2014-04-09','10:10:00',1.37),('16273','2014-04-09','10:15:00',1.61),('16273','2014-04-09','10:20:00',2.75),('16273','2014-04-09','10:25:00',3.35),('16273','2014-04-09','10:30:00',3.44),('16273','2014-04-09','10:35:00',3.53),('16273','2014-04-09','10:40:00',2.55),('16273','2014-04-09','10:45:00',2.61),('16273','2014-04-09','10:50:00',1.36),('16273','2014-04-09','10:55:00',1.96),('16273','2014-04-09','11:00:00',3.84),('16273','2014-04-09','11:05:00',2.84),('16273','2014-04-09','11:10:00',3.92),('16273','2014-04-09','11:15:00',3.56),('16273','2014-04-09','11:20:00',1.39),('16273','2014-04-09','11:25:00',1.87),('16273','2014-04-09','11:30:00',2.72),('16273','2014-04-09','11:35:00',1.86),('16273','2014-04-09','11:40:00',4.21),('16273','2014-04-09','11:45:00',1.37),('16273','2014-04-09','11:50:00',2.49),('16273','2014-04-09','11:55:00',1.32),('16273','2014-04-09','12:00:00',3.09),('16273','2014-04-09','12:05:00',3.02),('16273','2014-04-09','12:10:00',1.77),('16273','2014-04-09','12:15:00',2.52),('16273','2014-04-09','12:20:00',2.06),('16273','2014-04-09','12:25:00',1.5),('16273','2014-04-09','12:30:00',1.37),('16273','2014-04-09','12:35:00',1.32),('16273','2014-04-09','12:40:00',1.11),('16273','2014-04-09','14:30:00',1.24),('16273','2014-04-09','14:35:00',1.51),('16273','2014-04-09','14:40:00',1.58),('16273','2014-04-09','14:45:00',1.84),('16273','2014-04-09','14:50:00',1.47),('16273','2014-04-09','14:55:00',1.3),('16273','2014-04-09','15:00:00',1.3),('16273','2014-04-09','15:05:00',1.05),('16273','2014-04-09','15:25:00',1.14),('16273','2014-04-09','15:30:00',1.28),('16273','2014-04-09','15:35:00',1.16),('16273','2014-04-09','15:40:00',2.12),('16273','2014-04-09','15:45:00',1.55),('16273','2014-04-09','15:50:00',2.27),('16273','2014-04-09','15:55:00',2.34),('16273','2014-04-09','16:00:00',1.77),('16273','2014-04-09','16:05:00',2.15),('16273','2014-04-09','16:10:00',2.35),('16273','2014-04-09','16:15:00',2.3),('16273','2014-04-09','16:20:00',2.27),('16273','2014-04-09','16:25:00',2.04),('16273','2014-04-09','16:30:00',1.99),('16273','2014-04-09','16:35:00',1.92),('16273','2014-04-09','16:40:00',1.81),('16273','2014-04-09','16:45:00',1.73),('16273','2014-04-09','16:50:00',1.66),('16273','2014-04-09','16:55:00',1.62),('16273','2014-04-09','17:00:00',1.58),('16273','2014-04-09','17:05:00',1.47),('16273','2014-04-09','17:10:00',1.27),('16273','2014-04-09','17:15:00',1.27),('16273','2014-04-09','17:20:00',1.18),('16273','2014-04-09','17:25:00',1.17),('16273','2014-04-09','17:30:00',1.26),('16273','2014-04-09','17:35:00',1.21),('16273','2014-04-09','17:40:00',1.28),('16273','2014-04-09','17:45:00',1.03),('16273','2014-04-09','17:50:00',1.03),('16273','2013-08-09','08:00:00',1.04),('16273','2013-08-09','08:25:00',1.08),('16273','2013-08-09','08:30:00',1.34),('16273','2013-08-09','08:35:00',1.34),('16273','2013-08-09','08:40:00',1.63),('16273','2013-08-09','08:45:00',1.88),('16273','2013-08-09','08:50:00',1.59),('16273','2013-08-09','08:55:00',1.16),('16273','2013-08-09','09:00:00',1.99),('16273','2013-08-09','09:05:00',2.34),('16273','2013-08-09','09:10:00',1.7),('16273','2013-08-09','09:15:00',1.09),('16273','2013-08-09','09:20:00',1.46),('16273','2013-08-09','09:25:00',2.04),('16273','2013-08-09','09:30:00',2.34),('16273','2013-08-09','09:35:00',1.35),('16273','2013-08-09','09:40:00',1.78),('16273','2013-08-09','09:45:00',2.67),('16273','2013-08-09','09:50:00',2.98),('16273','2013-08-09','09:55:00',2.81),('16273','2013-08-09','10:00:00',2.71),('16273','2013-08-09','10:05:00',2.79),('16273','2013-08-09','10:10:00',2.78),('16273','2013-08-09','10:15:00',2.88),('16273','2013-08-09','10:20:00',2.92),('16273','2013-08-09','10:25:00',2.88),('16273','2013-08-09','10:30:00',2.43),('16273','2013-08-09','10:35:00',2.97),('16273','2013-08-09','10:40:00',3.09),('16273','2013-08-09','10:45:00',3.16),('16273','2013-08-09','10:50:00',3.17),('16273','2013-08-09','10:55:00',3.19),('16273','2013-08-09','11:00:00',3.19),('16273','2013-08-09','11:05:00',3.22),('16273','2013-08-09','11:10:00',3.19),('16273','2013-08-09','11:15:00',3.16),('16273','2013-08-09','11:20:00',3.23),('16273','2013-08-09','11:25:00',3.29),('16273','2013-08-09','11:30:00',3.33),('16273','2013-08-09','11:35:00',3.34),('16273','2013-08-09','11:40:00',3.33),('16273','2013-08-09','11:45:00',3.39),('16273','2013-08-09','11:50:00',3.39),('16273','2013-08-09','11:55:00',3.4),('16273','2013-08-09','12:00:00',3.41),('16273','2013-08-09','12:05:00',3.48),('16273','2013-08-09','12:10:00',3.56),('16273','2013-08-09','12:15:00',3.72),('16273','2013-08-09','12:20:00',3.12),('16273','2013-08-09','12:25:00',2.5),('16273','2013-08-09','12:30:00',3.32),('16273','2013-08-09','12:35:00',2.03),('16273','2013-08-09','12:40:00',2.13),('16273','2013-08-09','12:45:00',1.18),('16273','2013-08-09','12:50:00',1.01),('16273','2013-08-09','13:10:00',1.02),('16273','2013-08-09','13:15:00',1.2),('16273','2013-08-09','13:20:00',1.34),('16273','2013-08-09','13:25:00',1.44),('16273','2013-08-09','13:30:00',1.38),('16273','2013-08-09','13:35:00',1.29),('16273','2013-08-09','13:40:00',1.09),('16273','2013-08-09','15:10:00',1.36),('16273','2013-08-09','15:15:00',1.55),('16273','2013-08-09','15:30:00',1.05),('16273','2013-08-09','15:35:00',1.25),('16273','2013-08-09','15:40:00',2.22),('16273','2013-08-09','15:45:00',2.13),('16273','2013-08-09','15:50:00',1.6),('16273','2013-08-09','16:50:00',1.07),('16273','2013-08-08','07:45:00',1.02),('16273','2013-08-08','07:50:00',1.09),('16273','2013-08-08','07:55:00',1.18),('16273','2013-08-08','08:00:00',1.26),('16273','2013-08-08','08:05:00',1.33),('16273','2013-08-08','08:10:00',1.4),('16273','2013-08-08','08:15:00',1.48),('16273','2013-08-08','08:20:00',1.55),('16273','2013-08-08','08:25:00',1.62),('16273','2013-08-08','08:30:00',1.69),('16273','2013-08-08','08:35:00',1.75),('16273','2013-08-08','08:40:00',1.84),('16273','2013-08-08','08:45:00',1.92),('16273','2013-08-08','08:50:00',1.99),('16273','2013-08-08','08:55:00',2.05),('16273','2013-08-08','09:00:00',2.1),('16273','2013-08-08','09:05:00',2.16),('16273','2013-08-08','09:10:00',2.22),('16273','2013-08-08','09:15:00',2.29),('16273','2013-08-08','09:20:00',2.36),('16273','2013-08-08','09:25:00',2.41),('16273','2013-08-08','09:30:00',2.47),('16273','2013-08-08','09:35:00',2.49),('16273','2013-08-08','09:40:00',2.56),('16273','2013-08-08','09:45:00',2.61),('16273','2013-08-08','09:50:00',2.67),('16273','2013-08-08','09:55:00',2.72),('16273','2013-08-08','10:00:00',2.76),('16273','2013-08-08','10:05:00',2.83),('16273','2013-08-08','10:10:00',2.87),('16273','2013-08-08','10:15:00',2.9),('16273','2013-08-08','10:20:00',2.95),('16273','2013-08-08','10:25:00',2.96),('16273','2013-08-08','10:30:00',3.02),('16273','2013-08-08','10:35:00',3.04),('16273','2013-08-08','10:40:00',3.05),('16273','2013-08-08','10:45:00',3.09),('16273','2013-08-08','10:50:00',3.13),('16273','2013-08-08','10:55:00',3.13),('16273','2013-08-08','11:00:00',3.19),('16273','2013-08-08','11:05:00',3.23),('16273','2013-08-08','11:10:00',3.25),('16273','2013-08-08','11:15:00',3.29),('16273','2013-08-08','11:20:00',3.29),('16273','2013-08-08','11:25:00',3.31),('16273','2013-08-08','11:30:00',3.33),('16273','2013-08-08','11:35:00',3.33),('16273','2013-08-08','11:40:00',3.34),('16273','2013-08-08','11:45:00',3.33),('16273','2013-08-08','11:50:00',3.33),('16273','2013-08-08','11:55:00',3.36),('16273','2013-08-08','12:00:00',3.42),('16273','2013-08-08','12:05:00',3.45),('16273','2013-08-08','12:10:00',3.47),('16273','2013-08-08','12:15:00',3.52),('16273','2013-08-08','12:20:00',3.52),('16273','2013-08-08','12:25:00',3.52),('16273','2013-08-08','12:30:00',3.52),('16273','2013-08-08','12:35:00',3.52),('16273','2013-08-08','12:40:00',3.53),('16273','2013-08-08','12:45:00',3.52),('16273','2013-08-08','12:50:00',3.52),('16273','2013-08-08','12:55:00',3.5),('16273','2013-08-08','13:00:00',3.48),('16273','2013-08-08','13:05:00',3.49),('16273','2013-08-08','13:10:00',3.49),('16273','2013-08-08','13:15:00',3.47),('16273','2013-08-08','13:20:00',3.47),('16273','2013-08-08','13:25:00',3.45),('16273','2013-08-08','13:30:00',3.43),('16273','2013-08-08','13:35:00',3.42),('16273','2013-08-08','13:40:00',3.35),('16273','2013-08-08','13:45:00',3.39),('16273','2013-08-08','13:50:00',3.36),('16273','2013-08-08','13:55:00',3.33),('16273','2013-08-08','14:00:00',3.31),('16273','2013-08-08','14:05:00',3.29),('16273','2013-08-08','14:10:00',3.26),('16273','2013-08-08','14:15:00',3.23),('16273','2013-08-08','14:20:00',3.21),('16273','2013-08-08','14:25:00',3.19),('16273','2013-08-08','14:30:00',3.15),('16273','2013-08-08','14:35:00',3.11),('16273','2013-08-08','14:40:00',3.08),('16273','2013-08-08','14:45:00',3.04),('16273','2013-08-08','14:50:00',3.01),('16273','2013-08-08','14:55:00',2.97),('16273','2013-08-08','15:00:00',2.92),('16273','2013-08-08','15:05:00',2.88),('16273','2013-08-08','15:10:00',2.83),('16273','2013-08-08','15:15:00',2.74),('16273','2013-08-08','15:20:00',2.75),('16273','2013-08-08','15:25:00',2.69),('16273','2013-08-08','15:30:00',2.57),('16273','2013-08-08','15:35:00',2.58),('16273','2013-08-08','15:40:00',2.52),('16273','2013-08-08','15:45:00',2.46),('16273','2013-08-08','15:50:00',2.43),('16273','2013-08-08','15:55:00',2.38),('16273','2013-08-08','16:00:00',2.34),('16273','2013-08-08','16:05:00',2.29),('16273','2013-08-08','16:10:00',2.23),('16273','2013-08-08','16:15:00',2.17),('16273','2013-08-08','16:20:00',2.11),('16273','2013-08-08','16:25:00',2.04),('16273','2013-08-08','16:30:00',1.98),('16273','2013-08-08','16:35:00',1.91),('16273','2013-08-08','16:40:00',1.84),('16273','2013-08-08','16:45:00',1.79),('16273','2013-08-08','16:50:00',1.72),('16273','2013-08-08','16:55:00',1.65),('16273','2013-08-08','17:00:00',1.58),('16273','2013-08-08','17:05:00',1.52),('16273','2013-08-08','17:10:00',1.45),('16273','2013-08-08','17:15:00',1.38),('16273','2013-08-08','17:20:00',1.31),('16273','2013-08-08','17:25:00',1.25),('16273','2013-08-08','17:30:00',1.19),('16273','2013-08-08','17:35:00',1.12),('16273','2013-08-08','17:40:00',1.05),('16273','2013-08-07','07:40:00',1.03),('16273','2013-08-07','07:45:00',1.12),('16273','2013-08-07','07:50:00',1.19),('16273','2013-08-07','07:55:00',1.27),('16273','2013-08-07','08:00:00',1.34),('16273','2013-08-07','08:05:00',1.42),('16273','2013-08-07','08:10:00',1.5),('16273','2013-08-07','08:15:00',1.57),('16273','2013-08-07','08:20:00',1.64),('16273','2013-08-07','08:25:00',1.72),('16273','2013-08-07','08:30:00',1.78),('16273','2013-08-07','08:35:00',1.85),('16273','2013-08-07','08:40:00',1.93),('16273','2013-08-07','08:45:00',2.01),('16273','2013-08-07','08:50:00',2.07),('16273','2013-08-07','08:55:00',2.14),('16273','2013-08-07','09:00:00',2.19),('16273','2013-08-07','09:05:00',2.25),('16273','2013-08-07','09:10:00',2.32),('16273','2013-08-07','09:15:00',2.35),('16273','2013-08-07','09:20:00',2.41),('16273','2013-08-07','09:25:00',2.46),('16273','2013-08-07','09:30:00',2.5),('16273','2013-08-07','09:35:00',2.52),('16273','2013-08-07','09:40:00',2.56),('16273','2013-08-07','09:45:00',2.67),('16273','2013-08-07','09:50:00',2.68),('16273','2013-08-07','09:55:00',2.72),('16273','2013-08-07','10:00:00',2.73),('16273','2013-08-07','10:05:00',2.78),('16273','2013-08-07','10:10:00',2.88),('16273','2013-08-07','10:15:00',2.9),('16273','2013-08-07','10:20:00',2.94),('16273','2013-08-07','10:25:00',2.98),('16273','2013-08-07','10:30:00',3.02),('16273','2013-08-07','10:35:00',3.05),('16273','2013-08-07','10:40:00',3.1),('16273','2013-08-07','10:45:00',3.1),('16273','2013-08-07','10:50:00',3.17),('16273','2013-08-07','10:55:00',3.19),('16273','2013-08-07','11:00:00',3.2),('16273','2013-08-07','11:05:00',3.23),('16273','2013-08-07','11:10:00',3.27),('16273','2013-08-07','11:15:00',3.25),('16273','2013-08-07','11:20:00',3.3),('16273','2013-08-07','11:25:00',3.35),('16273','2013-08-07','11:30:00',3.34),('16273','2013-08-07','11:35:00',3.34),('16273','2013-08-07','11:40:00',3.41),('16273','2013-08-07','11:45:00',3.4),('16273','2013-08-07','11:50:00',3.34),('16273','2013-08-07','11:55:00',3.42),('16273','2013-08-07','12:00:00',3.34),('16273','2013-08-07','12:05:00',3.38),('16273','2013-08-07','12:10:00',3.5),('16273','2013-08-07','12:15:00',3.47),('16273','2013-08-07','12:20:00',3.43),('16273','2013-08-07','12:25:00',3.49),('16273','2013-08-07','12:30:00',3.5),('16273','2013-08-07','12:35:00',3.51),('16273','2013-08-07','12:40:00',3.52),('16273','2013-08-07','12:45:00',3.49),('16273','2013-08-07','12:50:00',3.48),('16273','2013-08-07','12:55:00',3.52),('16273','2013-08-07','13:00:00',3.45),('16273','2013-08-07','13:05:00',3.45),('16273','2013-08-07','13:10:00',3.49),('16273','2013-08-07','13:15:00',3.48),('16273','2013-08-07','13:20:00',3.49),('16273','2013-08-07','13:25:00',3.46),('16273','2013-08-07','13:30:00',3.47),('16273','2013-08-07','13:35:00',3.45),('16273','2013-08-07','13:40:00',3.47),('16273','2013-08-07','13:45:00',3.43),('16273','2013-08-07','13:50:00',3.42),('16273','2013-08-07','13:55:00',3.39),('16273','2013-08-07','14:00:00',3.38),('16273','2013-08-07','14:05:00',3.36),('16273','2013-08-07','14:10:00',3.33),('16273','2013-08-07','14:15:00',3.29),('16273','2013-08-07','14:20:00',3.26),('16273','2013-08-07','14:25:00',3.23),('16273','2013-08-07','14:30:00',3.18),('16273','2013-08-07','14:35:00',3.18),('16273','2013-08-07','14:40:00',3.11),('16273','2013-08-07','14:45:00',3.11),('16273','2013-08-07','14:50:00',3.03),('16273','2013-08-07','14:55:00',3.04),('16273','2013-08-07','15:00:00',2.98),('16273','2013-08-07','15:05:00',2.95),('16273','2013-08-07','15:10:00',2.88),('16273','2013-08-07','15:15:00',2.85),('16273','2013-08-07','15:20:00',2.8),('16273','2013-08-07','15:25:00',2.74),('16273','2013-08-07','15:30:00',2.71),('16273','2013-08-07','15:35:00',2.66),('16273','2013-08-07','15:40:00',2.61),('16273','2013-08-07','15:45:00',2.56),('16273','2013-08-07','15:50:00',2.51),('16273','2013-08-07','15:55:00',2.44),('16273','2013-08-07','16:00:00',2.39),('16273','2013-08-07','16:05:00',2.34),('16273','2013-08-07','16:10:00',2.27),('16273','2013-08-07','16:15:00',2.22),('16273','2013-08-07','16:20:00',2.15),('16273','2013-08-07','16:25:00',2.08),('16273','2013-08-07','16:30:00',2.02),('16273','2013-08-07','16:35:00',1.95),('16273','2013-08-07','16:40:00',1.89),('16273','2013-08-07','16:45:00',1.82),('16273','2013-08-07','16:50:00',1.75),('16273','2013-08-07','16:55:00',1.69),('16273','2013-08-07','17:00:00',1.62),('16273','2013-08-07','17:05:00',1.56),('16273','2013-08-07','17:10:00',1.48),('16273','2013-08-07','17:15:00',1.42),('16273','2013-08-07','17:20:00',1.35),('16273','2013-08-07','17:25:00',1.27),('16273','2013-08-07','17:30:00',1.21),('16273','2013-08-07','17:35:00',1.15),('16273','2013-08-07','17:40:00',1.08),('16273','2013-08-07','17:45:00',1.01),('16273','2013-08-06','07:45:00',1.04),('16273','2013-08-06','07:50:00',1.13),('16273','2013-08-06','07:55:00',1.21),('16273','2013-08-06','08:00:00',1.29),('16273','2013-08-06','08:05:00',1.37),('16273','2013-08-06','08:10:00',1.45),('16273','2013-08-06','08:15:00',1.53),('16273','2013-08-06','08:20:00',1.6),('16273','2013-08-06','08:25:00',1.67),('16273','2013-08-06','08:30:00',1.75),('16273','2013-08-06','08:35:00',1.82),('16273','2013-08-06','08:40:00',1.88),('16273','2013-08-06','08:45:00',1.95),('16273','2013-08-06','08:50:00',2.02),('16273','2013-08-06','08:55:00',2.08),('16273','2013-08-06','09:00:00',2.16),('16273','2013-08-06','09:05:00',2.23),('16273','2013-08-06','09:10:00',2.27),('16273','2013-08-06','09:15:00',2.34),('16273','2013-08-06','09:20:00',2.38),('16273','2013-08-06','09:25:00',2.43),('16273','2013-08-06','09:30:00',2.49),('16273','2013-08-06','09:35:00',2.55),('16273','2013-08-06','09:40:00',2.62),('16273','2013-08-06','09:45:00',2.65),('16273','2013-08-06','09:50:00',2.72),('16273','2013-08-06','09:55:00',2.76),('16273','2013-08-06','10:00:00',2.82),('16273','2013-08-06','10:05:00',2.85),('16273','2013-08-06','10:10:00',2.91),('16273','2013-08-06','10:15:00',2.94),('16273','2013-08-06','10:20:00',2.98),('16273','2013-08-06','10:25:00',3.01),('16273','2013-08-06','10:30:00',3.03),('16273','2013-08-06','10:35:00',3.05),('16273','2013-08-06','10:40:00',3.09),('16273','2013-08-06','10:45:00',3.13),('16273','2013-08-06','10:50:00',3.16),('16273','2013-08-06','10:55:00',3.18),('16273','2013-08-06','11:00:00',3.19),('16273','2013-08-06','11:05:00',3.2),('16273','2013-08-06','11:10:00',3.21),('16273','2013-08-06','11:15:00',3.26),('16273','2013-08-06','11:20:00',3.27),('16273','2013-08-06','11:25:00',3.28),('16273','2013-08-06','11:30:00',3.31),('16273','2013-08-06','11:35:00',3.37),('16273','2013-08-06','11:40:00',3.34),('16273','2013-08-06','11:45:00',3.39),('16273','2013-08-06','11:50:00',3.39),('16273','2013-08-06','11:55:00',3.4),('16273','2013-08-06','12:00:00',3.43),('16273','2013-08-06','12:05:00',3.44),('16273','2013-08-06','12:10:00',3.46),('16273','2013-08-06','12:15:00',3.48),('16273','2013-08-06','12:20:00',3.45),('16273','2013-08-06','12:25:00',3.5),('16273','2013-08-06','12:30:00',3.51),('16273','2013-08-06','12:35:00',3.5),('16273','2013-08-06','12:40:00',3.54),('16273','2013-08-06','12:45:00',3.53),('16273','2013-08-06','12:50:00',3.52),('16273','2013-08-06','12:55:00',3.53),('16273','2013-08-06','14:00:00',2.79),('16273','2013-08-06','14:05:00',3.36),('16273','2013-08-06','14:10:00',3.35),('16273','2013-08-06','14:15:00',3.33),('16273','2013-08-06','14:20:00',2.1),('16273','2013-08-06','14:25:00',3.28),('16273','2013-08-06','14:30:00',3.25),('16273','2013-08-06','14:35:00',3.22),('16273','2013-08-06','14:40:00',2.12),('16273','2013-08-06','14:45:00',3.15),('16273','2013-08-06','14:50:00',3.12),('16273','2013-08-06','14:55:00',3.09),('16273','2013-08-06','15:00:00',2.03),('16273','2013-08-06','15:05:00',2.96),('16273','2013-08-06','15:10:00',2.97),('16273','2013-08-06','15:15:00',2.93),('16273','2013-08-06','15:20:00',2.23),('16273','2013-08-06','15:25:00',2.6),('16273','2013-08-06','15:30:00',2.76),('16273','2013-08-06','15:35:00',2.71),('16273','2013-08-06','15:40:00',2.65),('16273','2013-08-06','15:45:00',2.61),('16273','2013-08-06','15:50:00',2.55),('16273','2013-08-06','15:55:00',2.49),('16273','2013-08-06','16:00:00',2.44),('16273','2013-08-06','16:05:00',2.38),('16273','2013-08-06','16:10:00',2.32),('16273','2013-08-06','16:15:00',2.25),('16273','2013-08-06','16:20:00',2.18),('16273','2013-08-06','16:25:00',2.11),('16273','2013-08-06','16:30:00',2.05),('16273','2013-08-06','16:35:00',1.99),('16273','2013-08-06','16:40:00',1.92),('16273','2013-08-06','16:45:00',1.86),('16273','2013-08-06','17:10:00',1.42),('16273','2013-08-06','17:15:00',1.44),('16273','2013-08-06','17:20:00',1.38),('16273','2013-08-06','17:25:00',1.31),('16273','2013-08-06','17:30:00',1.09),('16273','2013-08-06','17:35:00',1.17),('16273','2013-08-06','17:40:00',1.11),('16273','2013-08-06','17:45:00',1.04),('16273','2013-08-05','07:40:00',1.01),('16273','2013-08-05','07:45:00',1.09),('16273','2013-08-05','07:50:00',1.17),('16273','2013-08-05','07:55:00',1.25),('16273','2013-08-05','08:00:00',1.32),('16273','2013-08-05','08:05:00',1.4),('16273','2013-08-05','08:10:00',1.49),('16273','2013-08-05','08:15:00',1.56),('16273','2013-08-05','08:20:00',1.65),('16273','2013-08-05','08:25:00',1.72),('16273','2013-08-05','08:30:00',1.81),('16273','2013-08-05','08:35:00',1.89),('16273','2013-08-05','08:40:00',1.96),('16273','2013-08-05','08:45:00',2.03),('16273','2013-08-05','08:50:00',2.1),('16273','2013-08-05','08:55:00',2.16),('16273','2013-08-05','09:00:00',2.22),('16273','2013-08-05','09:05:00',2.29),('16273','2013-08-05','09:10:00',2.36),('16273','2013-08-05','09:15:00',2.43),('16273','2013-08-05','09:20:00',2.46),('16273','2013-08-05','09:25:00',2.53),('16273','2013-08-05','09:30:00',2.59),('16273','2013-08-05','09:35:00',2.66),('16273','2013-08-05','09:40:00',2.7),('16273','2013-08-05','09:45:00',2.75),('16273','2013-08-05','09:50:00',2.79),('16273','2013-08-05','09:55:00',2.83),('16273','2013-08-05','10:00:00',2.86),('16273','2013-08-05','10:05:00',2.9),('16273','2013-08-05','10:10:00',2.96),('16273','2013-08-05','10:15:00',3.01),('16273','2013-08-05','10:20:00',3.04),('16273','2013-08-05','10:25:00',3.07),('16273','2013-08-05','10:30:00',3.11),('16273','2013-08-05','10:35:00',3.11),('16273','2013-08-05','10:40:00',3.17),('16273','2013-08-05','10:45:00',3.2),('16273','2013-08-05','10:50:00',3.27),('16273','2013-08-05','10:55:00',3.29),('16273','2013-08-05','11:00:00',3.3),('16273','2013-08-05','11:05:00',3.34),('16273','2013-08-05','11:10:00',3.38),('16273','2013-08-05','11:15:00',3.39),('16273','2013-08-05','11:20:00',3.44),('16273','2013-08-05','11:25:00',3.45),('16273','2013-08-05','11:30:00',3.45),('16273','2013-08-05','11:35:00',3.47),('16273','2013-08-05','11:40:00',3.5),('16273','2013-08-05','11:45:00',3.47),('16273','2013-08-05','11:50:00',3.49),('16273','2013-08-05','11:55:00',3.51),('16273','2013-08-05','12:00:00',3.52),('16273','2013-08-05','12:05:00',3.54),('16273','2013-08-05','12:10:00',3.49),('16273','2013-08-05','12:15:00',3.58),('16273','2013-08-05','12:20:00',3.52),('16273','2013-08-05','12:25:00',3.55),('16273','2013-08-05','12:30:00',3.56),('16273','2013-08-05','12:35:00',3.53),('16273','2013-08-05','12:40:00',3.56),('16273','2013-08-05','12:45:00',3.55),('16273','2013-08-05','12:50:00',3.52),('16273','2013-08-05','12:55:00',3.54),('16273','2013-08-05','13:00:00',3.53),('16273','2013-08-05','13:05:00',3.53),('16273','2013-08-05','13:10:00',3.5),('16273','2013-08-05','13:15:00',3.49),('16273','2013-08-05','13:20:00',3.5),('16273','2013-08-05','13:25:00',3.45),('16273','2013-08-05','13:30:00',3.42),('16273','2013-08-05','13:35:00',3.43),('16273','2013-08-05','13:40:00',3.42),('16273','2013-08-05','13:45:00',3.43),('16273','2013-08-05','13:50:00',3.4),('16273','2013-08-05','13:55:00',3.41),('16273','2013-08-05','14:00:00',3.39),('16273','2013-08-05','14:05:00',3.35),('16273','2013-08-05','14:10:00',3.32),('16273','2013-08-05','14:15:00',3.3),('16273','2013-08-05','14:20:00',3.27),('16273','2013-08-05','14:25:00',3.25),('16273','2013-08-05','14:30:00',3.22),('16273','2013-08-05','14:35:00',3.16),('16273','2013-08-05','14:40:00',3.14),('16273','2013-08-05','14:45:00',3.11),('16273','2013-08-05','14:50:00',3.08),('16273','2013-08-05','14:55:00',3.04),('16273','2013-08-05','15:00:00',3.01),('16273','2013-08-05','15:05:00',2.97),('16273','2013-08-05','15:10:00',2.93),('16273','2013-08-05','15:15:00',2.9),('16273','2013-08-05','15:20:00',2.83),('16273','2013-08-05','15:25:00',2.81),('16273','2013-08-05','15:30:00',2.76),('16273','2013-08-05','15:35:00',2.72),('16273','2013-08-05','15:40:00',2.67),('16273','2013-08-05','15:45:00',2.61),('16273','2013-08-05','15:50:00',2.55),('16273','2013-08-05','15:55:00',2.49),('16273','2013-08-05','16:00:00',2.44),('16273','2013-08-05','16:05:00',2.37),('16273','2013-08-05','16:10:00',2.31),('16273','2013-08-05','16:15:00',2.25),('16273','2013-08-05','16:20:00',2.19),('16273','2013-08-05','16:25:00',2.11),('16273','2013-08-05','16:30:00',2.06),('16273','2013-08-05','16:35:00',1.96),('16273','2013-08-05','16:40:00',1.92),('16273','2013-08-05','16:45:00',1.85),('16273','2013-08-05','16:50:00',1.78),('16273','2013-08-05','16:55:00',1.72),('16273','2013-08-05','17:00:00',1.64),('16273','2013-08-05','17:05:00',1.57),('16273','2013-08-05','17:10:00',1.51),('16273','2013-08-05','17:15:00',1.43),('16273','2013-08-05','17:20:00',1.37),('16273','2013-08-05','17:25:00',1.3),('16273','2013-08-05','17:30:00',1.23),('16273','2013-08-05','17:35:00',1.17),('16273','2013-08-05','17:40:00',1.1),('16273','2013-08-05','17:45:00',1.03),('16273','2013-08-04','07:35:00',1.08),('16273','2013-08-04','07:40:00',1.16),('16273','2013-08-04','07:45:00',1.24),('16273','2013-08-04','07:50:00',1.32),('16273','2013-08-04','07:55:00',1.39),('16273','2013-08-04','08:00:00',1.48),('16273','2013-08-04','08:05:00',1.57),('16273','2013-08-04','08:10:00',1.64),('16273','2013-08-04','08:15:00',1.71),('16273','2013-08-04','08:20:00',1.79),('16273','2013-08-04','08:25:00',1.87),('16273','2013-08-04','08:30:00',1.91),('16273','2013-08-04','08:35:00',1.98),('16273','2013-08-04','08:40:00',2.06),('16273','2013-08-04','08:45:00',2.12),('16273','2013-08-04','08:50:00',2.2),('16273','2013-08-04','08:55:00',2.27),('16273','2013-08-04','09:00:00',2.32),('16273','2013-08-04','09:05:00',2.38),('16273','2013-08-04','09:10:00',2.44),('16273','2013-08-04','09:15:00',2.5),('16273','2013-08-04','09:20:00',2.57),('16273','2013-08-04','09:25:00',2.62),('16273','2013-08-04','09:30:00',2.68),('16273','2013-08-04','09:35:00',2.71),('16273','2013-08-04','09:40:00',2.77),('16273','2013-08-04','09:45:00',2.82),('16273','2013-08-04','09:50:00',2.89),('16273','2013-08-04','09:55:00',2.92),('16273','2013-08-04','10:00:00',2.95),('16273','2013-08-04','10:05:00',2.98),('16273','2013-08-04','10:10:00',3.02),('16273','2013-08-04','10:15:00',3.07),('16273','2013-08-04','10:20:00',3.12),('16273','2013-08-04','10:25:00',3.17),('16273','2013-08-04','10:30:00',3.22),('16273','2013-08-04','10:35:00',3.24),('16273','2013-08-04','10:40:00',3.28),('16273','2013-08-04','10:45:00',3.3),('16273','2013-08-04','10:50:00',3.36),('16273','2013-08-04','10:55:00',3.4),('16273','2013-08-04','11:00:00',3.42),('16273','2013-08-04','11:05:00',3.44),('16273','2013-08-04','11:10:00',3.45),('16273','2013-08-04','11:15:00',3.46),('16273','2013-08-04','11:20:00',3.48),('16273','2013-08-04','11:25:00',3.5),('16273','2013-08-04','11:30:00',3.53),('16273','2013-08-04','11:35:00',3.53),('16273','2013-08-04','11:40:00',3.55),('16273','2013-08-04','11:45:00',3.54),('16273','2013-08-04','11:50:00',3.56),('16273','2013-08-04','11:55:00',3.58),('16273','2013-08-04','12:00:00',3.62),('16273','2013-08-04','12:05:00',3.62),('16273','2013-08-04','12:10:00',3.63),('16273','2013-08-04','12:15:00',3.63),('16273','2013-08-04','12:20:00',3.63),('16273','2013-08-04','12:25:00',3.63),('16273','2013-08-04','12:30:00',3.64),('16273','2013-08-04','12:35:00',3.64),('16273','2013-08-04','12:40:00',3.65),('16273','2013-08-04','12:45:00',3.64),('16273','2013-08-04','12:50:00',3.6),('16273','2013-08-04','12:55:00',3.62),('16273','2013-08-04','13:00:00',3.61),('16273','2013-08-04','13:05:00',3.61),('16273','2013-08-04','13:10:00',3.6),('16273','2013-08-04','13:15:00',3.6),('16273','2013-08-04','13:20:00',3.6),('16273','2013-08-04','13:25:00',3.59),('16273','2013-08-04','13:30:00',3.57),('16273','2013-08-04','13:35:00',3.53),('16273','2013-08-04','13:40:00',3.55),('16273','2013-08-04','13:45:00',3.52),('16273','2013-08-04','13:50:00',3.5),('16273','2013-08-04','13:55:00',3.49),('16273','2013-08-04','14:00:00',3.47),('16273','2013-08-04','14:05:00',3.46),('16273','2013-08-04','14:10:00',3.43),('16273','2013-08-04','14:15:00',3.41),('16273','2013-08-04','14:20:00',3.37),('16273','2013-08-04','14:25:00',3.35),('16273','2013-08-04','14:30:00',3.31),('16273','2013-08-04','14:35:00',3.29),('16273','2013-08-04','14:40:00',3.25),('16273','2013-08-04','14:45:00',3.21),('16273','2013-08-04','14:50:00',3.16),('16273','2013-08-04','14:55:00',3.13),('16273','2013-08-04','15:00:00',3.1),('16273','2013-08-04','15:05:00',3.06),('16273','2013-08-04','15:10:00',3.01),('16273','2013-08-04','15:15:00',2.98),('16273','2013-08-04','15:20:00',2.93),('16273','2013-08-04','15:25:00',2.88),('16273','2013-08-04','15:30:00',2.82),('16273','2013-08-04','15:35:00',2.77),('16273','2013-08-04','15:40:00',2.74),('16273','2013-08-04','15:45:00',2.7),('16273','2013-08-04','15:50:00',2.63),('16273','2013-08-04','15:55:00',2.57),('16273','2013-08-04','16:00:00',2.51),('16273','2013-08-04','16:05:00',2.45),('16273','2013-08-04','16:10:00',2.39),('16273','2013-08-04','16:15:00',2.33),('16273','2013-08-04','16:20:00',2.26),('16273','2013-08-04','16:25:00',2.2),('16273','2013-08-04','16:30:00',2.12),('16273','2013-08-04','16:35:00',2.05),('16273','2013-08-04','16:40:00',1.98),('16273','2013-08-04','16:45:00',1.91),('16273','2013-08-04','16:50:00',1.84),('16273','2013-08-04','16:55:00',1.77),('16273','2013-08-04','17:00:00',1.7),('16273','2013-08-04','17:05:00',1.63),('16273','2013-08-04','17:10:00',1.55),('16273','2013-08-04','17:15:00',1.47),('16273','2013-08-04','17:20:00',1.4),('16273','2013-08-04','17:25:00',1.33),('16273','2013-08-04','17:30:00',1.25),('16273','2013-08-04','17:35:00',1.18),('16273','2013-08-04','17:40:00',1.11),('16273','2013-08-04','17:45:00',1.04),('16273','2013-08-03','07:35:00',1.08),('16273','2013-08-03','07:40:00',1.15),('16273','2013-08-03','07:45:00',1.24),('16273','2013-08-03','07:50:00',1.3),('16273','2013-08-03','07:55:00',1.39),('16273','2013-08-03','08:00:00',1.46),('16273','2013-08-03','08:05:00',1.55),('16273','2013-08-03','08:10:00',1.63),('16273','2013-08-03','08:15:00',1.7),('16273','2013-08-03','08:20:00',1.78),('16273','2013-08-03','08:25:00',1.86),('16273','2013-08-03','08:30:00',1.94),('16273','2013-08-03','08:35:00',2),('16273','2013-08-03','08:40:00',2.08),('16273','2013-08-03','08:45:00',2.15),('16273','2013-08-03','08:50:00',2.22),('16273','2013-08-03','08:55:00',2.28),('16273','2013-08-03','09:00:00',2.32),('16273','2013-08-03','09:05:00',2.4),('16273','2013-08-03','09:10:00',2.46),('16273','2013-08-03','09:15:00',2.52),('16273','2013-08-03','09:20:00',2.57),('16273','2013-08-03','09:25:00',2.62),('16273','2013-08-03','09:30:00',2.68),('16273','2013-08-03','09:35:00',2.74),('16273','2013-08-03','09:40:00',2.78),('16273','2013-08-03','09:45:00',2.83),('16273','2013-08-03','09:50:00',2.87),('16273','2013-08-03','09:55:00',2.92),('16273','2013-08-03','10:00:00',2.96),('16273','2013-08-03','10:05:00',3.02),('16273','2013-08-03','10:10:00',3.06),('16273','2013-08-03','10:15:00',3.07),('16273','2013-08-03','10:20:00',3.13),('16273','2013-08-03','10:25:00',3.13),('16273','2013-08-03','10:30:00',3.2),('16273','2013-08-03','10:35:00',3.21),('16273','2013-08-03','10:40:00',3.28),('16273','2013-08-03','10:45:00',3.29),('16273','2013-08-03','10:50:00',3.32),('16273','2013-08-03','10:55:00',3.36),('16273','2013-08-03','11:00:00',3.37),('16273','2013-08-03','11:05:00',3.41),('16273','2013-08-03','11:10:00',3.43),('16273','2013-08-03','11:15:00',3.48),('16273','2013-08-03','11:20:00',3.51),('16273','2013-08-03','11:25:00',3.51),('16273','2013-08-03','11:30:00',3.51),('16273','2013-08-03','11:35:00',3.53),('16273','2013-08-03','11:40:00',3.53),('16273','2013-08-03','11:45:00',3.51),('16273','2013-08-03','11:50:00',3.54),('16273','2013-08-03','11:55:00',3.58),('16273','2013-08-03','12:00:00',3.61),('16273','2013-08-03','12:05:00',3.61),('16273','2013-08-03','12:10:00',3.57),('16273','2013-08-03','12:15:00',3.55),('16273','2013-08-03','12:20:00',3.54),('16273','2013-08-03','12:25:00',3.53),('16273','2013-08-03','12:30:00',3.5),('16273','2013-08-03','12:35:00',3.54),('16273','2013-08-03','12:40:00',3.56),('16273','2013-08-03','12:45:00',3.53),('16273','2013-08-03','12:50:00',3.55),('16273','2013-08-03','12:55:00',3.54),('16273','2013-08-03','13:00:00',3.56),('16273','2013-08-03','13:05:00',3.58),('16273','2013-08-03','13:10:00',3.57),('16273','2013-08-03','13:15:00',3.51),('16273','2013-08-03','13:20:00',3.52),('16273','2013-08-03','13:25:00',3.48),('16273','2013-08-03','13:30:00',3.49),('16273','2013-08-03','13:35:00',3.5),('16273','2013-08-03','13:40:00',3.49),('16273','2013-08-03','13:45:00',3.45),('16273','2013-08-03','13:50:00',3.42),('16273','2013-08-03','13:55:00',3.42),('16273','2013-08-03','14:00:00',3.4),('16273','2013-08-03','14:05:00',3.39),('16273','2013-08-03','14:10:00',3.39),('16273','2013-08-03','14:15:00',3.34),('16273','2013-08-03','14:20:00',3.32),('16273','2013-08-03','14:25:00',3.29),('16273','2013-08-03','14:30:00',3.28),('16273','2013-08-03','14:35:00',3.24),('16273','2013-08-03','14:40:00',3.2),('16273','2013-08-03','14:45:00',3.19),('16273','2013-08-03','14:50:00',3.17),('16273','2013-08-03','14:55:00',3.14),('16273','2013-08-03','15:00:00',3.07),('16273','2013-08-03','15:05:00',3.02),('16273','2013-08-03','15:10:00',2.98),('16273','2013-08-03','15:15:00',2.94),('16273','2013-08-03','15:20:00',2.9),('16273','2013-08-03','15:25:00',2.86),('16273','2013-08-03','15:30:00',2.82),('16273','2013-08-03','15:35:00',2.76),('16273','2013-08-03','15:40:00',2.71),('16273','2013-08-03','15:45:00',2.67),('16273','2013-08-03','15:50:00',2.6),('16273','2013-08-03','15:55:00',2.53),('16273','2013-08-03','16:00:00',2.49),('16273','2013-08-03','16:05:00',2.42),('16273','2013-08-03','16:10:00',2.37),('16273','2013-08-03','16:15:00',2.31),('16273','2013-08-03','16:20:00',2.25),('16273','2013-08-03','16:25:00',2.2),('16273','2013-08-03','16:30:00',2.12),('16273','2013-08-03','16:35:00',2.03),('16273','2013-08-03','16:40:00',1.96),('16273','2013-08-03','16:45:00',1.89),('16273','2013-08-03','16:50:00',1.82),('16273','2013-08-03','16:55:00',1.76),('16273','2013-08-03','17:00:00',1.69),('16273','2013-08-03','17:05:00',1.61),('16273','2013-08-03','17:10:00',1.55),('16273','2013-08-03','17:15:00',1.48),('16273','2013-08-03','17:20:00',1.41),('16273','2013-08-03','17:25:00',1.34),('16273','2013-08-03','17:30:00',1.26),('16273','2013-08-03','17:35:00',1.19),('16273','2013-08-03','17:40:00',1.13),('16273','2013-08-03','17:45:00',1.07),('16273','2013-08-02','07:30:00',1.08),('16273','2013-08-02','07:35:00',1.17),('16273','2013-08-02','07:40:00',1.26),('16273','2013-08-02','07:45:00',1.34),('16273','2013-08-02','07:50:00',1.42),('16273','2013-08-02','07:55:00',1.51),('16273','2013-08-02','08:00:00',1.59),('16273','2013-08-02','08:05:00',1.66),('16273','2013-08-02','08:10:00',1.74),('16273','2013-08-02','08:15:00',1.82),('16273','2013-08-02','08:20:00',1.89),('16273','2013-08-02','08:25:00',1.96),('16273','2013-08-02','08:30:00',2.04),('16273','2013-08-02','08:35:00',2.11),('16273','2013-08-02','08:40:00',2.18),('16273','2013-08-02','08:45:00',2.25),('16273','2013-08-02','08:50:00',2.31),('16273','2013-08-02','08:55:00',2.37),('16273','2013-08-02','09:00:00',2.41),('16273','2013-08-02','09:05:00',2.49),('16273','2013-08-02','09:10:00',2.54),('16273','2013-08-02','09:15:00',2.6),('16273','2013-08-02','09:20:00',2.66),('16273','2013-08-02','09:25:00',2.72),('16273','2013-08-02','09:30:00',2.78),('16273','2013-08-02','09:35:00',2.83),('16273','2013-08-02','09:40:00',2.88),('16273','2013-08-02','09:45:00',2.92),('16273','2013-08-02','09:50:00',2.95),('16273','2013-08-02','09:55:00',2.98),('16273','2013-08-02','10:00:00',3.02),('16273','2013-08-02','10:05:00',3.07),('16273','2013-08-02','10:10:00',3.12),('16273','2013-08-02','10:15:00',3.16),('16273','2013-08-02','10:20:00',3.21),('16273','2013-08-02','10:25:00',3.23),('16273','2013-08-02','10:30:00',3.27),('16273','2013-08-02','10:35:00',3.3),('16273','2013-08-02','10:40:00',3.33),('16273','2013-08-02','10:45:00',3.34),('16273','2013-08-02','10:50:00',3.38),('16273','2013-08-02','10:55:00',3.41),('16273','2013-08-02','11:00:00',3.43),('16273','2013-08-02','11:05:00',3.45),('16273','2013-08-02','11:10:00',3.46),('16273','2013-08-02','11:15:00',3.46),('16273','2013-08-02','11:20:00',3.51),('16273','2013-08-02','11:25:00',3.53),('16273','2013-08-02','11:30:00',3.54),('16273','2013-08-02','11:35:00',3.55),('16273','2013-08-02','11:40:00',3.55),('16273','2013-08-02','11:45:00',3.55),('16273','2013-08-02','11:50:00',3.58),('16273','2013-08-02','11:55:00',3.59),('16273','2013-08-02','12:00:00',3.59),('16273','2013-08-02','12:05:00',3.59),('16273','2013-08-02','12:10:00',3.61),('16273','2013-08-02','12:15:00',3.61),('16273','2013-08-02','12:20:00',3.62),('16273','2013-08-02','12:25:00',3.6),('16273','2013-08-02','12:30:00',3.62),('16273','2013-08-02','12:35:00',3.61),('16273','2013-08-02','12:40:00',3.59),('16273','2013-08-02','12:45:00',3.58),('16273','2013-08-02','12:50:00',3.59),('16273','2013-08-02','12:55:00',3.58),('16273','2013-08-02','13:00:00',3.57),('16273','2013-08-02','13:05:00',3.61),('16273','2013-08-02','13:10:00',3.6),('16273','2013-08-02','13:15:00',3.58),('16273','2013-08-02','13:20:00',3.57),('16273','2013-08-02','13:25:00',3.55),('16273','2013-08-02','13:30:00',3.53),('16273','2013-08-02','13:35:00',3.47),('16273','2013-08-02','13:40:00',3.47),('16273','2013-08-02','13:45:00',3.41),('16273','2013-08-02','13:50:00',3.44),('16273','2013-08-02','13:55:00',3.47),('16273','2013-08-02','14:00:00',3.47),('16273','2013-08-02','14:05:00',3.49),('16273','2013-08-02','14:10:00',3.46),('16273','2013-08-02','14:15:00',3.39),('16273','2013-08-02','14:20:00',3.36),('16273','2013-08-02','14:25:00',3.35),('16273','2013-08-02','14:30:00',3.29),('16273','2013-08-02','14:35:00',3.28),('16273','2013-08-02','14:40:00',3.26),('16273','2013-08-02','14:45:00',3.21),('16273','2013-08-02','14:50:00',3.19),('16273','2013-08-02','14:55:00',3.13),('16273','2013-08-02','15:00:00',3.09),('16273','2013-08-02','15:05:00',3.06),('16273','2013-08-02','15:10:00',3.03),('16273','2013-08-02','15:15:00',2.99),('16273','2013-08-02','15:20:00',2.96),('16273','2013-08-02','15:25:00',2.92),('16273','2013-08-02','15:30:00',2.88),('16273','2013-08-02','15:35:00',2.84),('16273','2013-08-02','15:40:00',2.77),('16273','2013-08-02','15:45:00',2.7),('16273','2013-08-02','15:50:00',2.64),('16273','2013-08-02','15:55:00',2.58),('16273','2013-08-02','16:00:00',2.52),('16273','2013-08-02','16:05:00',2.48),('16273','2013-08-02','16:10:00',2.41),('16273','2013-08-02','16:15:00',2.35),('16273','2013-08-02','16:20:00',2.3),('16273','2013-08-02','16:25:00',2.22),('16273','2013-08-02','16:30:00',2.15),('16273','2013-08-02','16:35:00',2.08),('16273','2013-08-02','16:40:00',2),('16273','2013-08-02','16:45:00',1.92),('16273','2013-08-02','16:50:00',1.87),('16273','2013-08-02','16:55:00',1.81),('16273','2013-08-02','17:00:00',1.75),('16273','2013-08-02','17:05:00',1.66),('16273','2013-08-02','17:10:00',1.59),('16273','2013-08-02','17:15:00',1.51),('16273','2013-08-02','17:20:00',1.43),('16273','2013-08-02','17:25:00',1.36),('16273','2013-08-02','17:30:00',1.3),('16273','2013-08-02','17:35:00',1.24),('16273','2013-08-02','17:40:00',1.17),('16273','2013-08-02','17:45:00',1.09),('16273','2013-08-02','17:50:00',1.02),('16273','2013-08-01','07:30:00',1.1),('16273','2013-08-01','07:35:00',1.19),('16273','2013-08-01','07:40:00',1.28),('16273','2013-08-01','07:45:00',1.36),('16273','2013-08-01','07:50:00',1.44),('16273','2013-08-01','07:55:00',1.53),('16273','2013-08-01','08:00:00',1.61),('16273','2013-08-01','08:05:00',1.69),('16273','2013-08-01','08:10:00',1.77),('16273','2013-08-01','08:15:00',1.83),('16273','2013-08-01','08:20:00',1.91),('16273','2013-08-01','08:25:00',1.98),('16273','2013-08-01','08:30:00',2.06),('16273','2013-08-01','08:35:00',2.12),('16273','2013-08-01','08:40:00',2.21),('16273','2013-08-01','08:45:00',2.27),('16273','2013-08-01','08:50:00',2.34),('16273','2013-08-01','08:55:00',2.42),('16273','2013-08-01','09:00:00',2.48),('16273','2013-08-01','09:05:00',2.55),('16273','2013-08-01','09:10:00',2.62),('16273','2013-08-01','09:15:00',2.7),('16273','2013-08-01','09:20:00',2.77),('16273','2013-08-01','09:25:00',2.84),('16273','2013-08-01','09:30:00',2.91),('16273','2013-08-01','09:35:00',2.98),('16273','2013-08-01','09:40:00',3.02),('16273','2013-08-01','09:45:00',3.08),('16273','2013-08-01','09:50:00',3.13),('16273','2013-08-01','09:55:00',3.2),('16273','2013-08-01','10:00:00',3.25),('16273','2013-08-01','10:05:00',3.3),('16273','2013-08-01','10:10:00',3.35),('16273','2013-08-01','10:15:00',3.4),('16273','2013-08-01','10:20:00',3.45),('16273','2013-08-01','10:25:00',3.49),('16273','2013-08-01','10:30:00',3.51),('16273','2013-08-01','10:35:00',3.56),('16273','2013-08-01','10:40:00',3.61),('16273','2013-08-01','10:45:00',3.63),('16273','2013-08-01','10:50:00',3.65),('16273','2013-08-01','10:55:00',3.67),('16273','2013-08-01','11:00:00',3.69),('16273','2013-08-01','11:05:00',3.71),('16273','2013-08-01','11:10:00',3.72),('16273','2013-08-01','11:15:00',3.78),('16273','2013-08-01','11:20:00',3.8),('16273','2013-08-01','11:25:00',3.81),('16273','2013-08-01','11:30:00',3.81),('16273','2013-08-01','11:35:00',3.83),('16273','2013-08-01','11:40:00',3.83),('16273','2013-08-01','11:45:00',3.82),('16273','2013-08-01','11:50:00',3.82),('16273','2013-08-01','11:55:00',3.86),('16273','2013-08-01','12:00:00',3.88),('16273','2013-08-01','12:05:00',3.88),('16273','2013-08-01','12:10:00',3.89),('16273','2013-08-01','12:15:00',3.92),('16273','2013-08-01','12:20:00',3.93),('16273','2013-08-01','12:25:00',3.89),('16273','2013-08-01','12:30:00',3.9),('16273','2013-08-01','12:35:00',3.88),('16273','2013-08-01','12:40:00',3.89),('16273','2013-08-01','12:45:00',3.88),('16273','2013-08-01','12:50:00',3.87),('16273','2013-08-01','12:55:00',3.86),('16273','2013-08-01','13:00:00',3.84),('16273','2013-08-01','13:05:00',3.85),('16273','2013-08-01','13:10:00',3.85),('16273','2013-08-01','13:15:00',3.83),('16273','2013-08-01','13:20:00',3.82),('16273','2013-08-01','13:25:00',3.79),('16273','2013-08-01','13:30:00',3.78),('16273','2013-08-01','13:35:00',3.75),('16273','2013-08-01','13:40:00',3.75),('16273','2013-08-01','13:45:00',3.72),('16273','2013-08-01','13:50:00',3.71),('16273','2013-08-01','13:55:00',3.68),('16273','2013-08-01','14:00:00',3.67),('16273','2013-08-01','14:05:00',3.63),('16273','2013-08-01','14:10:00',3.59),('16273','2013-08-01','14:15:00',3.52),('16273','2013-08-01','14:20:00',3.54),('16273','2013-08-01','14:25:00',3.51),('16273','2013-08-01','14:30:00',3.45),('16273','2013-08-01','14:35:00',3.4),('16273','2013-08-01','14:40:00',3.37),('16273','2013-08-01','14:45:00',3.34),('16273','2013-08-01','14:50:00',3.26),('16273','2013-08-01','14:55:00',3.25),('16273','2013-08-01','15:00:00',3.2),('16273','2013-08-01','15:05:00',3.17),('16273','2013-08-01','15:10:00',3.13),('16273','2013-08-01','15:15:00',3.08),('16273','2013-08-01','15:20:00',3.03),('16273','2013-08-01','15:25:00',2.97),('16273','2013-08-01','15:30:00',2.88),('16273','2013-08-01','15:35:00',2.86),('16273','2013-08-01','15:40:00',2.81),('16273','2013-08-01','15:45:00',2.76),('16273','2013-08-01','15:50:00',2.7),('16273','2013-08-01','15:55:00',2.6),('16273','2013-08-01','16:00:00',2.56),('16273','2013-08-01','16:05:00',2.5),('16273','2013-08-01','16:10:00',2.44),('16273','2013-08-01','16:15:00',2.38),('16273','2013-08-01','16:20:00',2.31),('16273','2013-08-01','16:25:00',2.25),('16273','2013-08-01','16:30:00',2.18),('16273','2013-08-01','16:35:00',2.11),('16273','2013-08-01','16:40:00',2.03),('16273','2013-08-01','16:45:00',1.96),('16273','2013-08-01','16:50:00',1.9),('16273','2013-08-01','16:55:00',1.82),('16273','2013-08-01','17:00:00',1.75),('16273','2013-08-01','17:05:00',1.68),('16273','2013-08-01','17:10:00',1.6),('16273','2013-08-01','17:15:00',1.52),('16273','2013-08-01','17:20:00',1.46),('16273','2013-08-01','17:25:00',1.38),('16273','2013-08-01','17:30:00',1.3),('16273','2013-08-01','17:35:00',1.23),('16273','2013-08-01','17:40:00',1.15),('16273','2013-08-01','17:45:00',1.07),('16273','2013-08-01','17:50:00',1),('16273','2013-07-31','07:30:00',1.1),('16273','2013-07-31','07:35:00',1.18),('16273','2013-07-31','07:40:00',1.3),('16273','2013-07-31','07:45:00',1.4),('16273','2013-07-31','07:50:00',1.48),('16273','2013-07-31','07:55:00',1.55),('16273','2013-07-31','08:00:00',1.63),('16273','2013-07-31','08:05:00',1.72),('16273','2013-07-31','08:10:00',1.8),('16273','2013-07-31','08:15:00',1.89),('16273','2013-07-31','08:20:00',1.95),('16273','2013-07-31','08:25:00',2.01),('16273','2013-07-31','08:30:00',2.08),('16273','2013-07-31','08:35:00',2.16),('16273','2013-07-31','08:40:00',2.23),('16273','2013-07-31','08:45:00',2.3),('16273','2013-07-31','08:50:00',2.36),('16273','2013-07-31','08:55:00',2.38),('16273','2013-07-31','09:00:00',2.47),('16273','2013-07-31','09:05:00',2.52),('16273','2013-07-31','09:10:00',2.58),('16273','2013-07-31','09:15:00',2.64),('16273','2013-07-31','09:20:00',2.7),('16273','2013-07-31','09:25:00',2.73),('16273','2013-07-31','09:30:00',2.79),('16273','2013-07-31','09:35:00',2.83),('16273','2013-07-31','09:40:00',2.92),('16273','2013-07-31','09:45:00',2.95),('16273','2013-07-31','09:50:00',3.01),('16273','2013-07-31','09:55:00',3.06),('16273','2013-07-31','10:00:00',3.11),('16273','2013-07-31','10:05:00',3.15),('16273','2013-07-31','10:10:00',3.19),('16273','2013-07-31','10:15:00',3.24),('16273','2013-07-31','10:20:00',3.3),('16273','2013-07-31','10:25:00',3.36),('16273','2013-07-31','10:30:00',3.39),('16273','2013-07-31','10:35:00',3.4),('16273','2013-07-31','10:40:00',3.46),('16273','2013-07-31','10:45:00',3.46),('16273','2013-07-31','10:50:00',3.56),('16273','2013-07-31','10:55:00',3.61),('16273','2013-07-31','11:00:00',3.62),('16273','2013-07-31','11:05:00',3.66),('16273','2013-07-31','11:10:00',3.67),('16273','2013-07-31','11:15:00',3.66),('16273','2013-07-31','11:20:00',3.64),('16273','2013-07-31','11:25:00',3.69),('16273','2013-07-31','11:30:00',3.73),('16273','2013-07-31','11:35:00',3.73),('16273','2013-07-31','11:40:00',3.72),('16273','2013-07-31','11:45:00',3.77),('16273','2013-07-31','11:50:00',3.8),('16273','2013-07-31','11:55:00',3.83),('16273','2013-07-31','12:00:00',3.78),('16273','2013-07-31','12:05:00',3.86),('16273','2013-07-31','12:10:00',3.85),('16273','2013-07-31','12:15:00',3.88),('16273','2013-07-31','12:20:00',3.9),('16273','2013-07-31','12:25:00',3.9),('16273','2013-07-31','12:30:00',3.93),('16273','2013-07-31','12:35:00',3.89),('16273','2013-07-31','12:40:00',3.88),('16273','2013-07-31','12:45:00',3.86),('16273','2013-07-31','12:50:00',3.85),('16273','2013-07-31','12:55:00',3.87),('16273','2013-07-31','13:00:00',3.86),('16273','2013-07-31','13:05:00',3.84),('16273','2013-07-31','13:10:00',3.86),('16273','2013-07-31','13:15:00',3.8),('16273','2013-07-31','13:20:00',3.76),('16273','2013-07-31','13:25:00',3.79),('16273','2013-07-31','13:30:00',3.76),('16273','2013-07-31','13:35:00',3.72),('16273','2013-07-31','13:40:00',3.68),('16273','2013-07-31','13:45:00',3.55),('16273','2013-07-31','13:50:00',3.65),('16273','2013-07-31','13:55:00',3.65),('16273','2013-07-31','14:00:00',2.65),('16273','2013-07-31','14:05:00',3.6),('16273','2013-07-31','14:10:00',2.22),('16273','2013-07-31','14:15:00',3.65),('16273','2013-07-31','14:20:00',3.22),('16273','2013-07-31','14:25:00',2.85),('16273','2013-07-31','14:30:00',3.5),('16273','2013-07-31','14:35:00',3.46),('16273','2013-07-31','14:40:00',3.4),('16273','2013-07-31','14:45:00',3.31),('16273','2013-07-31','14:50:00',3.28),('16273','2013-07-31','14:55:00',3.22),('16273','2013-07-31','15:00:00',3.14),('16273','2013-07-31','15:05:00',3.22),('16273','2013-07-31','15:10:00',3.13),('16273','2013-07-31','15:15:00',3.1),('16273','2013-07-31','15:20:00',3.02),('16273','2013-07-31','15:25:00',2.26),('16273','2013-07-31','15:30:00',2.9),('16273','2013-07-31','15:35:00',2.86),('16273','2013-07-31','15:40:00',2.82),('16273','2013-07-31','15:45:00',2.8),('16273','2013-07-31','15:50:00',2.69),('16273','2013-07-31','15:55:00',2.68),('16273','2013-07-31','16:00:00',2.67),('16273','2013-07-31','16:05:00',2.58),('16273','2013-07-31','16:10:00',2.28),('16273','2013-07-31','16:15:00',2.38),('16273','2013-07-31','16:20:00',2.41),('16273','2013-07-31','16:25:00',1.94),('16273','2013-07-31','16:30:00',1.82),('16273','2013-07-31','16:35:00',2.17),('16273','2013-07-31','16:40:00',1.58),('16273','2013-07-31','16:45:00',1.28),('16273','2013-07-31','16:50:00',1),('16273','2013-07-31','16:55:00',2.01),('16273','2013-07-31','17:00:00',1.06),('16273','2013-07-31','17:05:00',1.09),('16273','2013-07-31','17:10:00',1.87),('16273','2013-07-31','17:15:00',1.71),('16273','2013-07-31','17:20:00',1.58),('16273','2013-07-31','17:25:00',1.44),('16273','2013-07-31','17:30:00',1.34),('16273','2013-07-31','17:35:00',1.25),('16273','2013-07-31','17:40:00',1.16),('16273','2013-07-31','17:45:00',1.09),('16273','2013-07-31','17:50:00',1.03),('16273','2014-04-08','08:15:00',1.11),('16273','2014-04-08','08:30:00',1.7),('16273','2014-04-08','08:35:00',1.68),('16273','2014-04-08','08:40:00',1.42),('16273','2014-04-08','08:45:00',1.93),('16273','2014-04-08','08:50:00',2.06),('16273','2014-04-08','08:55:00',2.15),('16273','2014-04-08','09:00:00',2.22),('16273','2014-04-08','09:05:00',2.28),('16273','2014-04-08','09:10:00',2.35),('16273','2014-04-08','09:15:00',2.42),('16273','2014-04-08','09:20:00',2.47),('16273','2014-04-08','09:25:00',2.48),('16273','2014-04-08','09:30:00',2.5),('16273','2014-04-08','09:35:00',2.56),('16273','2014-04-08','09:40:00',2.63),('16273','2014-04-08','09:45:00',2.67),('16273','2014-04-08','09:50:00',2.62),('16273','2014-04-08','09:55:00',2.8),('16273','2014-04-08','10:00:00',2.93),('16273','2014-04-08','10:05:00',2.99),('16273','2014-04-08','10:10:00',3.02),('16273','2014-04-08','10:15:00',3.03),('16273','2014-04-08','10:20:00',3.1),('16273','2014-04-08','10:25:00',3.15),('16273','2014-04-08','10:30:00',3.21),('16273','2014-04-08','10:35:00',3.29),('16273','2014-04-08','10:40:00',3.29),('16273','2014-04-08','10:45:00',3.32),('16273','2014-04-08','10:50:00',3.35),('16273','2014-04-08','10:55:00',3.4),('16273','2014-04-08','11:00:00',3.41),('16273','2014-04-08','11:05:00',3.45),('16273','2014-04-08','11:10:00',3.44),('16273','2014-04-08','11:15:00',3.49),('16273','2014-04-08','11:20:00',3.57),('16273','2014-04-08','11:25:00',3.64),('16273','2014-04-08','11:30:00',3.51),('16273','2014-04-08','11:35:00',3.51),('16273','2014-04-08','11:40:00',3.56),('16273','2014-04-08','11:45:00',3.54),('16273','2014-04-08','11:50:00',3.57),('16273','2014-04-08','11:55:00',3.61),('16273','2014-04-08','12:00:00',3.54),('16273','2014-04-08','12:05:00',3.51),('16273','2014-04-08','12:10:00',3.35),('16273','2014-04-08','12:15:00',3.21),('16273','2014-04-08','12:20:00',3.74),('16273','2014-04-08','12:25:00',3.53),('16273','2014-04-08','12:30:00',3.53),('16273','2014-04-08','12:35:00',3.81),('16273','2014-04-08','12:40:00',3.58),('16273','2014-04-08','12:45:00',3.54),('16273','2014-04-08','12:50:00',3.55),('16273','2014-04-08','12:55:00',3.38),('16273','2014-04-08','13:00:00',3.39),('16273','2014-04-08','13:05:00',3.52),('16273','2014-04-08','13:10:00',3.73),('16273','2014-04-08','13:15:00',3.71),('16273','2014-04-08','13:20:00',3.71),('16273','2014-04-08','13:25:00',3.66),('16273','2014-04-08','13:30:00',3.64),('16273','2014-04-08','13:35:00',3.59),('16273','2014-04-08','13:40:00',3.58),('16273','2014-04-08','13:45:00',3.61),('16273','2014-04-08','13:50:00',3.38),('16273','2014-04-08','13:55:00',3.17),('16273','2014-04-08','14:00:00',3.19),('16273','2014-04-08','14:05:00',3.06),('16273','2014-04-08','14:10:00',3.45),('16273','2014-04-08','14:15:00',3.47),('16273','2014-04-08','14:20:00',3.42),('16273','2014-04-08','14:25:00',2.82),('16273','2014-04-08','14:30:00',3.38),('16273','2014-04-08','14:35:00',2.88),('16273','2014-04-08','14:40:00',2.78),('16273','2014-04-08','14:45:00',3.27),('16273','2014-04-08','14:50:00',3.2),('16273','2014-04-08','14:55:00',3.09),('16273','2014-04-08','15:00:00',3.03),('16273','2014-04-08','15:05:00',2.99),('16273','2014-04-08','15:10:00',2.9),('16273','2014-04-08','15:15:00',2.85),('16273','2014-04-08','15:20:00',2.82),('16273','2014-04-08','15:25:00',2.69),('16273','2014-04-08','15:30:00',2.69),('16273','2014-04-08','15:35:00',2.53),('16273','2014-04-08','15:40:00',2.51),('16273','2014-04-08','15:45:00',2.5),('16273','2014-04-08','15:50:00',2.43),('16273','2014-04-08','15:55:00',2.37),('16273','2014-04-08','16:00:00',2.37),('16273','2014-04-08','16:05:00',2.31),('16273','2014-04-08','16:10:00',2.17),('16273','2014-04-08','16:15:00',2.15),('16273','2014-04-08','16:20:00',1.96),('16273','2014-04-08','16:25:00',1.94),('16273','2014-04-08','16:30:00',1.92),('16273','2014-04-08','16:35:00',1.83),('16273','2014-04-08','16:40:00',1.74),('16273','2014-04-08','16:45:00',1.71),('16273','2014-04-08','16:50:00',1.52),('16273','2014-04-08','16:55:00',1.46),('16273','2014-04-08','17:00:00',1.47),('16273','2014-04-08','17:05:00',1.38),('16273','2014-04-08','17:10:00',1.29),('16273','2014-04-08','17:15:00',1.24),('16273','2014-04-08','17:20:00',1.15),('16273','2014-04-08','17:25:00',1),('16273','2013-07-30','07:40:00',1.15),('16273','2013-07-30','07:45:00',1.6),('16273','2013-07-30','07:50:00',1.52),('16273','2013-07-30','08:00:00',1.3),('16273','2013-07-30','08:05:00',1.66),('16273','2013-07-30','08:10:00',1.75),('16273','2013-07-30','08:15:00',1.81),('16273','2013-07-30','08:20:00',1.89),('16273','2013-07-30','08:25:00',1.98),('16273','2013-07-30','08:30:00',2.08),('16273','2013-07-30','08:35:00',2.08),('16273','2013-07-30','08:40:00',1.83),('16273','2013-07-30','08:45:00',1.44),('16273','2013-07-30','08:50:00',2.26),('16273','2013-07-30','08:55:00',2.22),('16273','2013-07-30','09:00:00',2.64),('16273','2013-07-30','09:05:00',1.84),('16273','2013-07-30','09:10:00',2.7),('16273','2013-07-30','09:15:00',2.85),('16273','2013-07-30','09:20:00',2.87),('16273','2013-07-30','09:25:00',2.84),('16273','2013-07-30','09:30:00',2.19),('16273','2013-07-30','09:35:00',3.03),('16273','2013-07-30','09:40:00',2.02),('16273','2013-07-30','09:50:00',1.1),('16273','2013-07-30','09:55:00',3.24),('16273','2013-07-30','10:00:00',2.85),('16273','2013-07-30','10:05:00',2.8),('16273','2013-07-30','10:10:00',2.13),('16273','2013-07-30','10:15:00',1.5),('16273','2013-07-30','10:20:00',1.41),('16273','2013-07-30','10:30:00',2),('16273','2013-07-30','10:35:00',3.67),('16273','2013-07-30','10:40:00',3.19),('16273','2013-07-30','10:45:00',3.29),('16273','2013-07-30','10:50:00',3.51),('16273','2013-07-30','10:55:00',3.55),('16273','2013-07-30','11:00:00',3.53),('16273','2013-07-30','11:05:00',2.66),('16273','2013-07-30','11:15:00',1.93),('16273','2013-07-30','11:20:00',1.98),('16273','2013-07-30','11:25:00',3.74),('16273','2013-07-30','11:30:00',3.8),('16273','2013-07-30','11:35:00',3.8),('16273','2013-07-30','11:40:00',3.83),('16273','2013-07-30','11:45:00',3.82),('16273','2013-07-30','11:50:00',2.85),('16273','2013-07-30','11:55:00',3.81),('16273','2013-07-30','12:00:00',3.76),('16273','2013-07-30','12:05:00',3.78),('16273','2013-07-30','12:10:00',3.81),('16273','2013-07-30','12:15:00',3.86),('16273','2013-07-30','12:20:00',3.75),('16273','2013-07-30','12:25:00',3.83),('16273','2013-07-30','12:30:00',3.84),('16273','2013-07-30','12:35:00',3.65),('16273','2013-07-30','12:40:00',3.93),('16273','2013-07-30','12:45:00',3.77),('16273','2013-07-30','12:50:00',3.79),('16273','2013-07-30','12:55:00',3.07),('16273','2013-07-30','13:00:00',3.99),('16273','2013-07-30','13:05:00',2.4),('16273','2013-07-30','13:10:00',2.64),('16273','2013-07-30','13:15:00',2.44),('16273','2013-07-30','13:20:00',3.93),('16273','2013-07-30','13:25:00',3.86),('16273','2013-07-30','13:30:00',3.81),('16273','2013-07-30','13:35:00',3.8),('16273','2013-07-30','13:40:00',3.73),('16273','2013-07-30','13:45:00',3.15),('16273','2013-07-30','13:50:00',3.69),('16273','2013-07-30','13:55:00',3.7),('16273','2013-07-30','14:00:00',3.68),('16273','2013-07-30','14:05:00',3.64),('16273','2013-07-30','14:10:00',3.46),('16273','2013-07-30','14:15:00',3.43),('16273','2013-07-30','14:20:00',3.47),('16273','2013-07-30','14:25:00',3.43),('16273','2013-07-30','14:30:00',3.4),('16273','2013-07-30','14:35:00',3.36),('16273','2013-07-30','14:40:00',3.28),('16273','2013-07-30','14:45:00',3.28),('16273','2013-07-30','14:50:00',3.25),('16273','2013-07-30','14:55:00',3.21),('16273','2013-07-30','15:00:00',3.15),('16273','2013-07-30','15:05:00',3.1),('16273','2013-07-30','15:10:00',3.07),('16273','2013-07-30','15:15:00',3.02),('16273','2013-07-30','15:20:00',2.98),('16273','2013-07-30','15:25:00',2.91),('16273','2013-07-30','15:30:00',2.86),('16273','2013-07-30','15:35:00',2.79),('16273','2013-07-30','15:40:00',2.76),('16273','2013-07-30','15:45:00',2.72),('16273','2013-07-30','15:50:00',2.65),('16273','2013-07-30','15:55:00',2.6),('16273','2013-07-30','16:00:00',2.54),('16273','2013-07-30','16:05:00',2.48),('16273','2013-07-30','16:10:00',2.42),('16273','2013-07-30','16:15:00',2.36),('16273','2013-07-30','16:20:00',2.3),('16273','2013-07-30','16:25:00',2.22),('16273','2013-07-30','16:30:00',2.14),('16273','2013-07-30','16:35:00',2.06),('16273','2013-07-30','16:40:00',1.99),('16273','2013-07-30','16:45:00',1.92),('16273','2013-07-30','16:50:00',1.87),('16273','2013-07-30','16:55:00',1.8),('16273','2013-07-30','17:00:00',1.72),('16273','2013-07-30','17:05:00',1.65),('16273','2013-07-30','17:10:00',1.57),('16273','2013-07-30','17:15:00',1.5),('16273','2013-07-30','17:20:00',1.43),('16273','2013-07-30','17:25:00',1.37),('16273','2013-07-30','17:30:00',1.3),('16273','2013-07-30','17:35:00',1.25),('16273','2013-07-30','17:40:00',1.18),('16273','2013-07-30','17:45:00',1.09),('16273','2013-07-30','17:50:00',1.02),('16273','2013-07-29','07:40:00',1.07),('16273','2013-07-29','07:45:00',1.16),('16273','2013-07-29','07:50:00',1.25),('16273','2013-07-29','07:55:00',1.32),('16273','2013-07-29','08:00:00',1.4),('16273','2013-07-29','08:05:00',1.47),('16273','2013-07-29','08:10:00',1.55),('16273','2013-07-29','08:15:00',1.61),('16273','2013-07-29','08:20:00',1.68),('16273','2013-07-29','08:25:00',1.76),('16273','2013-07-29','08:30:00',1.86),('16273','2013-07-29','08:35:00',1.93),('16273','2013-07-29','08:40:00',2.01),('16273','2013-07-29','08:45:00',2.07),('16273','2013-07-29','08:50:00',2.15),('16273','2013-07-29','08:55:00',2.21),('16273','2013-07-29','09:00:00',2.28),('16273','2013-07-29','09:05:00',2.35),('16273','2013-07-29','09:10:00',2.41),('16273','2013-07-29','09:15:00',2.47),('16273','2013-07-29','09:20:00',2.52),('16273','2013-07-29','09:25:00',2.59),('16273','2013-07-29','09:30:00',2.63),('16273','2013-07-29','09:35:00',2.68),('16273','2013-07-29','09:40:00',2.74),('16273','2013-07-29','09:45:00',2.81),('16273','2013-07-29','09:50:00',2.86),('16273','2013-07-29','09:55:00',2.9),('16273','2013-07-29','10:00:00',2.94),('16273','2013-07-29','10:05:00',2.96),('16273','2013-07-29','10:10:00',3.01),('16273','2013-07-29','10:15:00',3.06),('16273','2013-07-29','10:20:00',3.1),('16273','2013-07-29','10:25:00',3.12),('16273','2013-07-29','10:30:00',3.15),('16273','2013-07-29','10:35:00',3.18),('16273','2013-07-29','10:40:00',3.2),('16273','2013-07-29','10:45:00',3.25),('16273','2013-07-29','10:50:00',3.29),('16273','2013-07-29','10:55:00',3.3),('16273','2013-07-29','11:00:00',3.3),('16273','2013-07-29','11:05:00',3.34),('16273','2013-07-29','11:10:00',3.35),('16273','2013-07-29','11:15:00',3.35),('16273','2013-07-29','11:20:00',3.35),('16273','2013-07-29','11:25:00',3.39),('16273','2013-07-29','11:30:00',3.44),('16273','2013-07-29','11:35:00',3.46),('16273','2013-07-29','11:40:00',3.46),('16273','2013-07-29','11:45:00',3.41),('16273','2013-07-29','11:50:00',3.5),('16273','2013-07-29','11:55:00',3.52),('16273','2013-07-29','12:00:00',3.53),('16273','2013-07-29','12:05:00',3.55),('16273','2013-07-29','12:10:00',3.55),('16273','2013-07-29','12:15:00',3.55),('16273','2013-07-29','12:20:00',3.55),('16273','2013-07-29','12:25:00',3.53),('16273','2013-07-29','12:30:00',3.53),('16273','2013-07-29','12:35:00',3.52),('16273','2013-07-29','12:40:00',3.5),('16273','2013-07-29','12:45:00',3.5),('16273','2013-07-29','12:50:00',3.51),('16273','2013-07-29','12:55:00',3.57),('16273','2013-07-29','13:00:00',3.6),('16273','2013-07-29','13:05:00',3.6),('16273','2013-07-29','13:10:00',3.6),('16273','2013-07-29','13:15:00',3.6),('16273','2013-07-29','13:20:00',3.6),('16273','2013-07-29','13:25:00',3.57),('16273','2013-07-29','13:30:00',3.58),('16273','2013-07-29','13:35:00',3.57),('16273','2013-07-29','13:40:00',3.55),('16273','2013-07-29','13:45:00',3.53),('16273','2013-07-29','13:50:00',3.52),('16273','2013-07-29','13:55:00',3.49),('16273','2013-07-29','14:00:00',3.48),('16273','2013-07-29','14:05:00',3.44),('16273','2013-07-29','14:10:00',3.43),('16273','2013-07-29','14:15:00',3.4),('16273','2013-07-29','14:20:00',3.39),('16273','2013-07-29','14:25:00',3.34),('16273','2013-07-29','14:30:00',3.3),('16273','2013-07-29','14:35:00',3.28),('16273','2013-07-29','14:40:00',3.25),('16273','2013-07-29','14:45:00',3.21),('16273','2013-07-29','14:50:00',3.18),('16273','2013-07-29','14:55:00',3.14),('16273','2013-07-29','15:00:00',3.06),('16273','2013-07-29','15:05:00',3.05),('16273','2013-07-29','15:10:00',3.01),('16273','2013-07-29','15:15:00',2.96),('16273','2013-07-29','15:20:00',2.93),('16273','2013-07-29','15:25:00',2.89),('16273','2013-07-29','15:30:00',2.87),('16273','2013-07-29','15:35:00',2.87),('16273','2013-07-29','15:40:00',2.34),('16273','2013-07-29','15:45:00',2.43),('16273','2013-07-29','15:50:00',1.94),('16273','2013-07-29','15:55:00',1.85),('16273','2013-07-29','16:00:00',2.77),('16273','2013-07-29','16:05:00',2.24),('16273','2013-07-29','16:10:00',2.35),('16273','2013-07-29','16:15:00',1.74),('16273','2013-07-29','16:20:00',2),('16273','2013-07-29','16:25:00',2.43),('16273','2013-07-29','16:30:00',2.19),('16273','2013-07-29','16:35:00',2.21),('16273','2013-07-29','16:40:00',1.9),('16273','2013-07-29','16:45:00',1.79),('16273','2013-07-29','16:50:00',1.38),('16273','2013-07-29','16:55:00',1.02),('16273','2013-07-29','17:00:00',1.6),('16273','2013-07-29','17:05:00',1.62),('16273','2013-07-29','17:10:00',1.33),('16273','2013-07-29','17:15:00',1.81),('16273','2013-07-29','17:20:00',1.29),('16273','2013-07-29','17:40:00',1.46),('16273','2013-07-29','17:45:00',1.19),('16273','2013-07-28','07:40:00',1.07),('16273','2013-07-28','07:45:00',1.16),('16273','2013-07-28','07:50:00',1.23),('16273','2013-07-28','07:55:00',1.31),('16273','2013-07-28','08:00:00',1.4),('16273','2013-07-28','08:05:00',1.49),('16273','2013-07-28','08:10:00',1.57),('16273','2013-07-28','08:15:00',1.62),('16273','2013-07-28','08:20:00',1.74),('16273','2013-07-28','08:25:00',1.79),('16273','2013-07-28','08:30:00',1.86),('16273','2013-07-28','08:35:00',1.92),('16273','2013-07-28','08:40:00',1.99),('16273','2013-07-28','08:45:00',2.08),('16273','2013-07-28','08:50:00',2.16),('16273','2013-07-28','08:55:00',2.19),('16273','2013-07-28','09:00:00',2.23),('16273','2013-07-28','09:05:00',2.3),('16273','2013-07-28','09:10:00',2.35),('16273','2013-07-28','09:15:00',2.41),('16273','2013-07-28','09:20:00',2.46),('16273','2013-07-28','09:25:00',2.53),('16273','2013-07-28','09:30:00',2.58),('16273','2013-07-28','09:35:00',2.62),('16273','2013-07-28','09:40:00',2.67),('16273','2013-07-28','09:45:00',2.74),('16273','2013-07-28','09:50:00',2.8),('16273','2013-07-28','09:55:00',2.83),('16273','2013-07-28','10:00:00',2.84),('16273','2013-07-28','10:05:00',2.88),('16273','2013-07-28','10:10:00',2.93),('16273','2013-07-28','10:15:00',2.98),('16273','2013-07-28','10:20:00',3.03),('16273','2013-07-28','10:25:00',3.02),('16273','2013-07-28','10:30:00',3.06),('16273','2013-07-28','10:35:00',3.09),('16273','2013-07-28','10:40:00',3.16),('16273','2013-07-28','10:45:00',3.19),('16273','2013-07-28','10:50:00',3.22),('16273','2013-07-28','10:55:00',3.25),('16273','2013-07-28','11:00:00',3.27),('16273','2013-07-28','11:05:00',3.32),('16273','2013-07-28','11:10:00',3.35),('16273','2013-07-28','11:15:00',3.38),('16273','2013-07-28','11:20:00',3.42),('16273','2013-07-28','11:25:00',3.36),('16273','2013-07-28','11:30:00',3.43),('16273','2013-07-28','11:35:00',3.45),('16273','2013-07-28','11:40:00',3.47),('16273','2013-07-28','11:45:00',3.48),('16273','2013-07-28','11:50:00',3.51),('16273','2013-07-28','11:55:00',3.54),('16273','2013-07-28','12:00:00',3.57),('16273','2013-07-28','12:05:00',3.58),('16273','2013-07-28','12:10:00',3.6),('16273','2013-07-28','12:15:00',3.64),('16273','2013-07-28','12:20:00',3.61),('16273','2013-07-28','12:25:00',3.57),('16273','2013-07-28','12:30:00',3.61),('16273','2013-07-28','12:35:00',3.64),('16273','2013-07-28','12:40:00',3.64),('16273','2013-07-28','12:45:00',3.63),('16273','2013-07-28','12:50:00',3.61),('16273','2013-07-28','12:55:00',3.63),('16273','2013-07-28','13:00:00',3.61),('16273','2013-07-28','13:05:00',3.61),('16273','2013-07-28','13:10:00',3.61),('16273','2013-07-28','13:15:00',3.59),('16273','2013-07-28','13:20:00',3.58),('16273','2013-07-28','13:25:00',3.56),('16273','2013-07-28','13:30:00',3.53),('16273','2013-07-28','13:35:00',3.53),('16273','2013-07-28','13:40:00',3.51),('16273','2013-07-28','13:45:00',3.52),('16273','2013-07-28','13:50:00',3.51),('16273','2013-07-28','13:55:00',3.48),('16273','2013-07-28','14:00:00',3.46),('16273','2013-07-28','14:05:00',3.44),('16273','2013-07-28','14:10:00',3.4),('16273','2013-07-28','14:15:00',3.37),('16273','2013-07-28','14:20:00',3.33),('16273','2013-07-28','14:25:00',3.31),('16273','2013-07-28','14:30:00',3.23),('16273','2013-07-28','14:35:00',3.23),('16273','2013-07-28','14:40:00',3.22),('16273','2013-07-28','14:45:00',3.18),('16273','2013-07-28','14:50:00',3.13),('16273','2013-07-28','14:55:00',3.1),('16273','2013-07-28','15:00:00',3.02),('16273','2013-07-28','15:05:00',2.98),('16273','2013-07-28','15:10:00',2.95),('16273','2013-07-28','15:15:00',2.92),('16273','2013-07-28','15:20:00',2.88),('16273','2013-07-28','15:25:00',2.84),('16273','2013-07-28','15:30:00',2.82),('16273','2013-07-28','15:35:00',2.78),('16273','2013-07-28','15:40:00',2.74),('16273','2013-07-28','15:45:00',2.69),('16273','2013-07-28','15:50:00',2.63),('16273','2013-07-28','15:55:00',2.58),('16273','2013-07-28','16:00:00',2.52),('16273','2013-07-28','16:05:00',2.47),('16273','2013-07-28','16:10:00',2.41),('16273','2013-07-28','16:15:00',2.34),('16273','2013-07-28','16:20:00',2.29),('16273','2013-07-28','16:25:00',2.22),('16273','2013-07-28','16:30:00',2.17),('16273','2013-07-28','16:35:00',2.1),('16273','2013-07-28','16:40:00',2.04),('16273','2013-07-28','16:45:00',1.97),('16273','2013-07-28','16:50:00',1.9),('16273','2013-07-28','16:55:00',1.84),('16273','2013-07-28','17:00:00',1.77),('16273','2013-07-28','17:05:00',1.69),('16273','2013-07-28','17:10:00',1.62),('16273','2013-07-28','17:15:00',1.55),('16273','2013-07-28','17:20:00',1.47),('16273','2013-07-28','17:25:00',1.41),('16273','2013-07-28','17:30:00',1.33),('16273','2013-07-28','17:35:00',1.27),('16273','2013-07-28','17:40:00',1.2),('16273','2013-07-28','17:45:00',1.13),('16273','2013-07-28','17:50:00',1.06),('16273','2013-07-27','07:35:00',1.03),('16273','2013-07-27','07:40:00',1.12),('16273','2013-07-27','07:45:00',1.19),('16273','2013-07-27','07:50:00',1.27),('16273','2013-07-27','07:55:00',1.34),('16273','2013-07-27','08:00:00',1.42),('16273','2013-07-27','08:05:00',1.5),('16273','2013-07-27','08:10:00',1.57),('16273','2013-07-27','08:15:00',1.64),('16273','2013-07-27','08:20:00',1.72),('16273','2013-07-27','08:25:00',1.79),('16273','2013-07-27','08:30:00',1.87),('16273','2013-07-27','08:35:00',1.96),('16273','2013-07-27','08:40:00',2.06),('16273','2013-07-27','08:45:00',2.12),('16273','2013-07-27','08:50:00',2.19),('16273','2013-07-27','08:55:00',2.27),('16273','2013-07-27','09:00:00',2.31),('16273','2013-07-27','09:05:00',2.36),('16273','2013-07-27','09:10:00',2.41),('16273','2013-07-27','09:15:00',2.48),('16273','2013-07-27','09:20:00',2.51),('16273','2013-07-27','09:25:00',2.6),('16273','2013-07-27','09:30:00',2.67),('16273','2013-07-27','09:35:00',2.71),('16273','2013-07-27','09:40:00',2.77),('16273','2013-07-27','09:45:00',2.83),('16273','2013-07-27','09:50:00',2.86),('16273','2013-07-27','09:55:00',2.92),('16273','2013-07-27','10:00:00',2.98),('16273','2013-07-27','10:05:00',3.02),('16273','2013-07-27','10:10:00',3.04),('16273','2013-07-27','10:15:00',3.11),('16273','2013-07-27','10:20:00',3.15),('16273','2013-07-27','10:25:00',3.19),('16273','2013-07-27','10:30:00',3.23),('16273','2013-07-27','10:35:00',3.25),('16273','2013-07-27','10:40:00',3.27),('16273','2013-07-27','10:45:00',3.3),('16273','2013-07-27','10:50:00',3.32),('16273','2013-07-27','10:55:00',3.32),('16273','2013-07-27','11:00:00',3.34),('16273','2013-07-27','11:05:00',3.38),('16273','2013-07-27','11:10:00',3.43),('16273','2013-07-27','11:15:00',3.46),('16273','2013-07-27','11:20:00',3.48),('16273','2013-07-27','11:25:00',3.46),('16273','2013-07-27','11:30:00',3.46),('16273','2013-07-27','11:35:00',3.53),('16273','2013-07-27','11:40:00',3.54),('16273','2013-07-27','11:45:00',3.55),('16273','2013-07-27','11:50:00',3.56),('16273','2013-07-27','11:55:00',3.48),('16273','2013-07-27','12:00:00',3.54),('16273','2013-07-27','12:05:00',3.54),('16273','2013-07-27','12:10:00',3.56),('16273','2013-07-27','12:15:00',3.59),('16273','2013-07-27','12:20:00',3.61),('16273','2013-07-27','12:25:00',3.61),('16273','2013-07-27','12:30:00',3.63),('16273','2013-07-27','12:35:00',3.6),('16273','2013-07-27','12:40:00',3.57),('16273','2013-07-27','12:45:00',3.62),('16273','2013-07-27','12:50:00',3.58),('16273','2013-07-27','12:55:00',3.65),('16273','2013-07-27','13:00:00',3.67),('16273','2013-07-27','13:05:00',3.66),('16273','2013-07-27','13:10:00',3.65),('16273','2013-07-27','13:15:00',3.61),('16273','2013-07-27','13:20:00',3.6),('16273','2013-07-27','13:25:00',3.59),('16273','2013-07-27','13:30:00',3.59),('16273','2013-07-27','13:35:00',3.57),('16273','2013-07-27','13:40:00',3.58),('16273','2013-07-27','13:45:00',3.54),('16273','2013-07-27','13:50:00',3.51),('16273','2013-07-27','13:55:00',3.5),('16273','2013-07-27','14:00:00',3.48),('16273','2013-07-27','14:05:00',3.41),('16273','2013-07-27','14:10:00',3.42),('16273','2013-07-27','14:15:00',3.39),('16273','2013-07-27','14:20:00',3.39),('16273','2013-07-27','14:25:00',3.34),('16273','2013-07-27','14:30:00',3.31),('16273','2013-07-27','14:35:00',3.29),('16273','2013-07-27','14:40:00',3.24),('16273','2013-07-27','14:45:00',3.2),('16273','2013-07-27','14:50:00',3.16),('16273','2013-07-27','14:55:00',3.14),('16273','2013-07-27','15:00:00',3.11),('16273','2013-07-27','15:05:00',3.04),('16273','2013-07-27','15:10:00',3.01),('16273','2013-07-27','15:15:00',2.97),('16273','2013-07-27','15:20:00',2.95),('16273','2013-07-27','15:25:00',2.88),('16273','2013-07-27','15:30:00',2.83),('16273','2013-07-27','15:35:00',2.79),('16273','2013-07-27','15:40:00',2.74),('16273','2013-07-27','15:45:00',2.68),('16273','2013-07-27','15:50:00',2.64),('16273','2013-07-27','15:55:00',2.61),('16273','2013-07-27','16:00:00',2.54),('16273','2013-07-27','16:05:00',2.49),('16273','2013-07-27','16:10:00',2.41),('16273','2013-07-27','16:15:00',2.38),('16273','2013-07-27','16:20:00',2.33),('16273','2013-07-27','16:25:00',2.26),('16273','2013-07-27','16:30:00',2.19),('16273','2013-07-27','16:35:00',2.13),('16273','2013-07-27','16:40:00',2.06),('16273','2013-07-27','16:45:00',1.99),('16273','2013-07-27','16:50:00',1.92),('16273','2013-07-27','16:55:00',1.85),('16273','2013-07-27','17:00:00',1.78),('16273','2013-07-27','17:05:00',1.7),('16273','2013-07-27','17:10:00',1.63),('16273','2013-07-27','17:15:00',1.56),('16273','2013-07-27','17:20:00',1.48),('16273','2013-07-27','17:25:00',1.41),('16273','2013-07-27','17:30:00',1.35),('16273','2013-07-27','17:35:00',1.28),('16273','2013-07-27','17:40:00',1.2),('16273','2013-07-27','17:45:00',1.14),('16273','2013-07-27','17:50:00',1.08),('16273','2013-07-27','17:55:00',1.01),('16273','2013-07-26','07:50:00',1.06),('16273','2013-07-26','07:55:00',1.34),('16273','2013-07-26','08:00:00',1.32),('16273','2013-07-26','08:05:00',1.58),('16273','2013-07-26','08:10:00',1.48),('16273','2013-07-26','08:15:00',1.68),('16273','2013-07-26','08:20:00',1.65),('16273','2013-07-26','08:25:00',1.53),('16273','2013-07-26','08:30:00',1.86),('16273','2013-07-26','08:35:00',1.52),('16273','2013-07-26','08:40:00',1.42),('16273','2013-07-26','08:45:00',1.57),('16273','2013-07-26','08:50:00',1.13),('16273','2013-07-26','08:55:00',1.59),('16273','2013-07-26','09:00:00',2.3),('16273','2013-07-26','09:05:00',2.36),('16273','2013-07-26','09:10:00',2.43),('16273','2013-07-26','09:15:00',2.52),('16273','2013-07-26','09:20:00',2.57),('16273','2013-07-26','09:25:00',2.58),('16273','2013-07-26','09:30:00',2.69),('16273','2013-07-26','09:35:00',2.26),('16273','2013-07-26','09:40:00',2.68),('16273','2013-07-26','09:45:00',2.69),('16273','2013-07-26','09:50:00',2.87),('16273','2013-07-26','09:55:00',2.82),('16273','2013-07-26','10:00:00',2.84),('16273','2013-07-26','10:05:00',3.01),('16273','2013-07-26','10:10:00',3.07),('16273','2013-07-26','10:15:00',3.11),('16273','2013-07-26','10:20:00',3.17),('16273','2013-07-26','10:25:00',3.18),('16273','2013-07-26','10:30:00',3.18),('16273','2013-07-26','10:35:00',3.19),('16273','2013-07-26','10:40:00',3.32),('16273','2013-07-26','10:45:00',3.34),('16273','2013-07-26','10:50:00',3.36),('16273','2013-07-26','10:55:00',2.76),('16273','2013-07-26','11:00:00',3.53),('16273','2013-07-26','11:05:00',3.35),('16273','2013-07-26','11:10:00',3.53),('16273','2013-07-26','11:15:00',3.47),('16273','2013-07-26','11:20:00',3.49),('16273','2013-07-26','11:25:00',3.52),('16273','2013-07-26','11:30:00',3.53),('16273','2013-07-26','11:35:00',3.54),('16273','2013-07-26','11:40:00',3.49),('16273','2013-07-26','11:45:00',3.36),('16273','2013-07-26','11:50:00',3.76),('16273','2013-07-26','11:55:00',3.71),('16273','2013-07-26','12:00:00',2.7),('16273','2013-07-26','12:05:00',1.36),('16273','2013-07-26','12:10:00',3.27),('16273','2013-07-26','12:15:00',3.94),('16273','2013-07-26','12:20:00',3.8),('16273','2013-07-26','12:25:00',3.92),('16273','2013-07-26','12:30:00',3.01),('16273','2013-07-26','12:35:00',2.68),('16273','2013-07-26','12:40:00',3.98),('16273','2013-07-26','12:45:00',3.83),('16273','2013-07-26','12:50:00',3.51),('16273','2013-07-26','12:55:00',1.97),('16273','2013-07-26','13:00:00',3.06),('16273','2013-07-26','13:05:00',3.84),('16273','2013-07-26','13:10:00',3.78),('16273','2013-07-26','13:15:00',3.83),('16273','2013-07-26','13:20:00',3.64),('16273','2013-07-26','13:25:00',3.57),('16273','2013-07-26','13:30:00',3.64),('16273','2013-07-26','13:35:00',3.59),('16273','2013-07-26','13:40:00',3.55),('16273','2013-07-26','13:45:00',3.56),('16273','2013-07-26','13:50:00',3.56),('16273','2013-07-26','13:55:00',3.58),('16273','2013-07-26','14:00:00',3.53),('16273','2013-07-26','14:05:00',3.51),('16273','2013-07-26','14:10:00',3.53),('16273','2013-07-26','14:15:00',3.1),('16273','2013-07-26','14:20:00',3.42),('16273','2013-07-26','14:25:00',3.39),('16273','2013-07-26','14:30:00',3.35),('16273','2013-07-26','14:35:00',3.32),('16273','2013-07-26','14:40:00',3.28),('16273','2013-07-26','14:45:00',3.21),('16273','2013-07-26','14:50:00',3.19),('16273','2013-07-26','14:55:00',3.14),('16273','2013-07-26','15:00:00',3.11),('16273','2013-07-26','15:05:00',3.08),('16273','2013-07-26','15:10:00',3.02),('16273','2013-07-26','15:15:00',3.01),('16273','2013-07-26','15:20:00',2.97),('16273','2013-07-26','15:25:00',2.92),('16273','2013-07-26','15:30:00',2.87),('16273','2013-07-26','15:35:00',2.82),('16273','2013-07-26','15:40:00',2.74),('16273','2013-07-26','15:45:00',2.69),('16273','2013-07-26','15:50:00',2.67),('16273','2013-07-26','15:55:00',2.62),('16273','2013-07-26','16:00:00',2.56),('16273','2013-07-26','16:05:00',2.5),('16273','2013-07-26','16:10:00',2.45),('16273','2013-07-26','16:15:00',2.38),('16273','2013-07-26','16:20:00',2.31),('16273','2013-07-26','16:25:00',2.25),('16273','2013-07-26','16:30:00',2.16),('16273','2013-07-26','16:35:00',2.09),('16273','2013-07-26','16:40:00',2.02),('16273','2013-07-26','16:45:00',1.96),('16273','2013-07-26','16:50:00',1.9),('16273','2013-07-26','16:55:00',1.83),('16273','2013-07-26','17:00:00',1.77),('16273','2013-07-26','17:05:00',1.7),('16273','2013-07-26','17:10:00',1.64),('16273','2013-07-26','17:15:00',1.57),('16273','2013-07-26','17:20:00',1.5),('16273','2013-07-26','17:25:00',1.43),('16273','2013-07-26','17:30:00',1.35),('16273','2013-07-26','17:35:00',1.28),('16273','2013-07-26','17:40:00',1.21),('16273','2013-07-26','17:45:00',1.14),('16273','2013-07-26','17:50:00',1.06),('16273','2013-07-26','17:55:00',1.01),('16273','2013-07-25','07:35:00',1.03),('16273','2013-07-25','07:40:00',1.1),('16273','2013-07-25','07:45:00',1.18),('16273','2013-07-25','07:50:00',1.27),('16273','2013-07-25','07:55:00',1.34),('16273','2013-07-25','08:00:00',1.43),('16273','2013-07-25','08:05:00',1.49),('16273','2013-07-25','08:10:00',1.57),('16273','2013-07-25','08:15:00',1.61),('16273','2013-07-25','08:20:00',1.67),('16273','2013-07-25','08:25:00',1.71),('16273','2013-07-25','08:30:00',1.79),('16273','2013-07-25','08:35:00',1.9),('16273','2013-07-25','08:40:00',1.99),('16273','2013-07-25','08:45:00',2.05),('16273','2013-07-25','08:50:00',2.32),('16273','2013-07-25','08:55:00',2.47),('16273','2013-07-25','09:00:00',2.44),('16273','2013-07-25','09:20:00',2.67),('16273','2013-07-25','09:25:00',2.79),('16273','2013-07-25','09:30:00',1.86),('16273','2013-07-25','09:35:00',2.48),('16273','2013-07-25','09:40:00',2.22),('16273','2013-07-25','09:55:00',2.99),('16273','2013-07-25','10:00:00',3.22),('16273','2013-07-25','10:05:00',3.17),('16273','2013-07-25','10:10:00',3.23),('16273','2013-07-25','10:15:00',3.25),('16273','2013-07-25','10:20:00',3.21),('16273','2013-07-25','10:25:00',3.35),('16273','2013-07-25','10:30:00',3.35),('16273','2013-07-25','10:35:00',3.37),('16273','2013-07-25','10:40:00',3.38),('16273','2013-07-25','10:45:00',3.38),('16273','2013-07-25','10:50:00',3.32),('16273','2013-07-25','10:55:00',3.34),('16273','2013-07-25','11:00:00',3.55),('16273','2013-07-25','11:05:00',3.62),('16273','2013-07-25','11:10:00',2.75),('16273','2013-07-25','11:15:00',1.04),('16273','2013-07-25','11:20:00',3.61),('16273','2013-07-25','11:25:00',3.63),('16273','2013-07-25','11:30:00',3.7),('16273','2013-07-25','11:35:00',3.72),('16273','2013-07-25','11:40:00',3.74),('16273','2013-07-25','11:45:00',2.6),('16273','2013-07-25','11:55:00',2.89),('16273','2013-07-25','12:00:00',2.99),('16273','2013-07-25','12:05:00',3.53),('16273','2013-07-25','12:10:00',3.54),('16273','2013-07-25','12:15:00',3.2),('16273','2013-07-25','12:20:00',3.79),('16273','2013-07-25','12:25:00',3.74),('16273','2013-07-25','12:30:00',3.72),('16273','2013-07-25','12:35:00',3.73),('16273','2013-07-25','12:40:00',3.67),('16273','2013-07-25','12:45:00',3.64),('16273','2013-07-25','12:50:00',3.68),('16273','2013-07-25','12:55:00',3.73),('16273','2013-07-25','13:00:00',3.75),('16273','2013-07-25','13:05:00',3.79),('16273','2013-07-25','13:10:00',3.68),('16273','2013-07-25','13:15:00',3.74),('16273','2013-07-25','13:20:00',3.72),('16273','2013-07-25','13:25:00',3.73),('16273','2013-07-25','13:30:00',3.68),('16273','2013-07-25','13:35:00',3.68),('16273','2013-07-25','13:40:00',3.65),('16273','2013-07-25','13:45:00',3.64),('16273','2013-07-25','13:50:00',3.66),('16273','2013-07-25','13:55:00',3.62),('16273','2013-07-25','14:00:00',3.6),('16273','2013-07-25','14:05:00',3.59),('16273','2013-07-25','14:10:00',3.57),('16273','2013-07-25','14:15:00',3.52),('16273','2013-07-25','14:20:00',3.52),('16273','2013-07-25','14:25:00',3.49),('16273','2013-07-25','14:30:00',3.45),('16273','2013-07-25','14:35:00',3.4),('16273','2013-07-25','14:40:00',3.38),('16273','2013-07-25','14:45:00',3.35),('16273','2013-07-25','14:50:00',3.31),('16273','2013-07-25','14:55:00',3.27),('16273','2013-07-25','15:00:00',3.22),('16273','2013-07-25','15:05:00',3.22),('16273','2013-07-25','15:10:00',3.14),('16273','2013-07-25','15:15:00',3.1),('16273','2013-07-25','15:20:00',3.09),('16273','2013-07-25','15:25:00',3.01),('16273','2013-07-25','15:30:00',2.99),('16273','2013-07-25','15:35:00',2.92),('16273','2013-07-25','15:40:00',2.87),('16273','2013-07-25','15:45:00',2.82),('16273','2013-07-25','15:50:00',2.76),('16273','2013-07-25','15:55:00',2.71),('16273','2013-07-25','16:00:00',2.65),('16273','2013-07-25','16:05:00',2.58),('16273','2013-07-25','16:10:00',2.48),('16273','2013-07-25','16:15:00',2.46),('16273','2013-07-25','16:20:00',2.4),('16273','2013-07-25','16:25:00',2.33),('16273','2013-07-25','16:30:00',2.28),('16273','2013-07-25','16:35:00',2.19),('16273','2013-07-25','16:40:00',2.1),('16273','2013-07-25','16:45:00',2.07),('16273','2013-07-25','16:50:00',1.98),('16273','2013-07-25','16:55:00',1.93),('16273','2013-07-25','17:00:00',1.85),('16273','2013-07-25','17:05:00',1.79),('16273','2013-07-25','17:10:00',1.69),('16273','2013-07-25','17:15:00',1.62),('16273','2013-07-25','17:20:00',1.56),('16273','2013-07-25','17:25:00',1.47),('16273','2013-07-25','17:30:00',1.38),('16273','2013-07-25','17:35:00',1.32),('16273','2013-07-25','17:40:00',1.25),('16273','2013-07-25','17:45:00',1.18),('16273','2013-07-25','17:50:00',1.12),('16273','2013-07-25','17:55:00',1.03),('16273','2013-07-24','07:40:00',1.31),('16273','2013-07-24','07:45:00',1.13),('16273','2013-07-24','07:50:00',1.15),('16273','2013-07-24','07:55:00',1.62),('16273','2013-07-24','08:00:00',1.36),('16273','2013-07-24','08:05:00',1.14),('16273','2013-07-24','08:15:00',1),('16273','2013-07-24','08:20:00',1.04),('16273','2013-07-24','08:25:00',1.26),('16273','2013-07-24','08:30:00',1.22),('16273','2013-07-24','08:35:00',1.08),('16273','2013-07-24','08:40:00',1.04),('16273','2013-07-24','08:45:00',1.84),('16273','2013-07-24','08:50:00',2.43),('16273','2013-07-24','08:55:00',2.51),('16273','2013-07-24','09:00:00',1.94),('16273','2013-07-24','09:05:00',1.85),('16273','2013-07-24','09:10:00',1.39),('16273','2013-07-24','09:15:00',1.09),('16273','2013-07-24','09:30:00',2.09),('16273','2013-07-24','09:35:00',1.24),('16273','2013-07-24','09:40:00',1.12),('16273','2013-07-24','09:45:00',1.98),('16273','2013-07-24','09:50:00',1.97),('16273','2013-07-24','09:55:00',1.52),('16273','2013-07-24','10:15:00',1.89),('16273','2013-07-24','10:20:00',3.57),('16273','2013-07-24','10:25:00',3.29),('16273','2013-07-24','10:30:00',3.13),('16273','2013-07-24','10:35:00',1.96),('16273','2013-07-24','10:40:00',3.16),('16273','2013-07-24','10:45:00',3.59),('16273','2013-07-24','10:50:00',3.61),('16273','2013-07-24','10:55:00',3.47),('16273','2013-07-24','11:00:00',3.76),('16273','2013-07-24','11:05:00',3.54),('16273','2013-07-24','11:10:00',2.78),('16273','2013-07-24','11:15:00',1.14),('16273','2013-07-24','11:20:00',3.48),('16273','2013-07-24','11:25:00',3.91),('16273','2013-07-24','11:30:00',2.61),('16273','2013-07-24','11:35:00',3.79),('16273','2013-07-24','11:40:00',1.85),('16273','2013-07-24','11:45:00',3.81),('16273','2013-07-24','11:50:00',3.94),('16273','2013-07-24','11:55:00',3.88),('16273','2013-07-24','12:00:00',2.78),('16273','2013-07-24','12:05:00',1.53),('16273','2013-07-24','12:10:00',4.04),('16273','2013-07-24','12:15:00',3.77),('16273','2013-07-24','12:20:00',3.7),('16273','2013-07-24','12:25:00',3.9),('16273','2013-07-24','12:30:00',3.94),('16273','2013-07-24','12:35:00',3.87),('16273','2013-07-24','12:40:00',3.79),('16273','2013-07-24','12:45:00',3.78),('16273','2013-07-24','12:50:00',3.8),('16273','2013-07-24','12:55:00',3.53),('16273','2013-07-24','13:00:00',3.81),('16273','2013-07-24','13:05:00',3.72),('16273','2013-07-24','13:10:00',3.76),('16273','2013-07-24','13:15:00',3.68),('16273','2013-07-24','13:20:00',3.73),('16273','2013-07-24','13:25:00',3.67),('16273','2013-07-24','13:30:00',3.71),('16273','2013-07-24','13:35:00',3.69),('16273','2013-07-24','13:40:00',3.7),('16273','2013-07-24','13:45:00',3.67),('16273','2013-07-24','13:50:00',3.67),('16273','2013-07-24','13:55:00',3.63),('16273','2013-07-24','14:00:00',3.64),('16273','2013-07-24','14:05:00',3.6),('16273','2013-07-24','14:10:00',3.61),('16273','2013-07-24','14:15:00',3.55),('16273','2013-07-24','14:20:00',3.56),('16273','2013-07-24','14:25:00',3.57),('16273','2013-07-24','14:30:00',3.54),('16273','2013-07-24','14:35:00',3.46),('16273','2013-07-24','14:40:00',3.42),('16273','2013-07-24','14:45:00',3.43),('16273','2013-07-24','14:50:00',3.41),('16273','2013-07-24','14:55:00',3.36),('16273','2013-07-24','15:00:00',2.7),('16273','2013-07-24','15:05:00',3.29),('16273','2013-07-24','15:10:00',3.09),('16273','2013-07-24','15:15:00',3.11),('16273','2013-07-24','15:20:00',3.1),('16273','2013-07-24','15:25:00',2.71),('16273','2013-07-24','15:30:00',2.97),('16273','2013-07-24','15:35:00',3.03),('16273','2013-07-24','15:40:00',2.86),('16273','2013-07-24','15:45:00',2.9),('16273','2013-07-24','15:50:00',2.93),('16273','2013-07-24','15:55:00',2.86),('16273','2013-07-24','16:00:00',2.79),('16273','2013-07-24','16:05:00',2.71),('16273','2013-07-24','16:10:00',2.65),('16273','2013-07-24','16:15:00',2.57),('16273','2013-07-24','16:20:00',2.51),('16273','2013-07-24','16:25:00',2.45),('16273','2013-07-24','16:30:00',2.38),('16273','2013-07-24','16:35:00',2.28),('16273','2013-07-24','16:40:00',2.31),('16273','2013-07-24','16:45:00',2.31),('16273','2013-07-24','16:50:00',2.23),('16273','2013-07-24','16:55:00',2.14),('16273','2013-07-24','17:00:00',1.99),('16273','2013-07-24','17:05:00',1.89),('16273','2013-07-24','17:10:00',1.77),('16273','2013-07-24','17:15:00',1.72),('16273','2013-07-24','17:20:00',1.63),('16273','2013-07-24','17:25:00',1.55),('16273','2013-07-24','17:30:00',1.44),('16273','2013-07-24','17:35:00',1.35),('16273','2013-07-24','17:40:00',1.3),('16273','2013-07-24','17:45:00',1.22),('16273','2013-07-24','17:50:00',1.14),('16273','2013-07-24','17:55:00',1.06),('16273','2013-07-23','07:25:00',1.02),('16273','2013-07-23','07:30:00',1.11),('16273','2013-07-23','07:35:00',1.19),('16273','2013-07-23','07:40:00',1.26),('16273','2013-07-23','07:45:00',1.33),('16273','2013-07-23','07:50:00',1.41),('16273','2013-07-23','07:55:00',1.49),('16273','2013-07-23','08:00:00',1.57),('16273','2013-07-23','08:05:00',1.63),('16273','2013-07-23','08:10:00',1.72),('16273','2013-07-23','08:15:00',1.79),('16273','2013-07-23','08:20:00',1.86),('16273','2013-07-23','08:25:00',1.95),('16273','2013-07-23','08:30:00',2.05),('16273','2013-07-23','08:35:00',2.11),('16273','2013-07-23','08:40:00',2.16),('16273','2013-07-23','08:45:00',2.21),('16273','2013-07-23','08:50:00',2.23),('16273','2013-07-23','08:55:00',2.33),('16273','2013-07-23','09:00:00',2.4),('16273','2013-07-23','09:05:00',2.46),('16273','2013-07-23','09:10:00',2.53),('16273','2013-07-23','09:15:00',2.59),('16273','2013-07-23','09:20:00',2.65),('16273','2013-07-23','09:25:00',2.69),('16273','2013-07-23','09:30:00',2.74),('16273','2013-07-23','09:35:00',2.8),('16273','2013-07-23','09:40:00',2.83),('16273','2013-07-23','09:45:00',2.87),('16273','2013-07-23','09:50:00',2.92),('16273','2013-07-23','09:55:00',2.96),('16273','2013-07-23','10:00:00',3.01),('16273','2013-07-23','10:05:00',3.02),('16273','2013-07-23','10:10:00',3.06),('16273','2013-07-23','10:15:00',3.11),('16273','2013-07-23','10:20:00',3.12),('16273','2013-07-23','10:25:00',3.12),('16273','2013-07-23','10:30:00',3.16),('16273','2013-07-23','10:35:00',3.19),('16273','2013-07-23','10:40:00',3.25),('16273','2013-07-23','10:45:00',3.28),('16273','2013-07-23','10:50:00',3.29),('16273','2013-07-23','10:55:00',3.4),('16273','2013-07-23','11:00:00',3.45),('16273','2013-07-23','11:05:00',3.54),('16273','2013-07-23','11:10:00',3.62),('16273','2013-07-23','11:15:00',3.58),('16273','2013-07-23','11:20:00',2.61),('16273','2013-07-23','11:25:00',1.34),('16273','2013-07-23','11:30:00',1.01),('16273','2013-07-23','11:35:00',1.03),('16273','2013-07-23','11:40:00',3.05),('16273','2013-07-23','11:45:00',3.73),('16273','2013-07-23','11:50:00',3.82),('16273','2013-07-23','11:55:00',3.85),('16273','2013-07-23','12:00:00',2.49),('16273','2013-07-23','12:05:00',1.09),('16273','2013-07-23','12:10:00',2.01),('16273','2013-07-23','12:15:00',3.54),('16273','2013-07-23','12:20:00',3.51),('16273','2013-07-23','12:25:00',2.42),('16273','2013-07-23','12:30:00',3.93),('16273','2013-07-23','12:35:00',3.91),('16273','2013-07-23','12:40:00',3.32),('16273','2013-07-23','12:45:00',4),('16273','2013-07-23','12:50:00',3.96),('16273','2013-07-23','12:55:00',4),('16273','2013-07-23','13:00:00',3.88),('16273','2013-07-23','13:05:00',3.41),('16273','2013-07-23','13:10:00',3.32),('16273','2013-07-23','13:15:00',3.4),('16273','2013-07-23','13:20:00',3.8),('16273','2013-07-23','13:25:00',3.95),('16273','2013-07-23','13:30:00',3.93),('16273','2013-07-23','13:35:00',3.63),('16273','2013-07-23','13:40:00',3.83),('16273','2013-07-23','13:45:00',3.84),('16273','2013-07-23','13:50:00',3.82),('16273','2013-07-23','13:55:00',3.44),('16273','2013-07-23','14:00:00',2.58),('16273','2013-07-23','14:05:00',3.82),('16273','2013-07-23','14:10:00',3.7),('16273','2013-07-23','14:15:00',3.6),('16273','2013-07-23','14:20:00',3.46),('16273','2013-07-23','14:25:00',3.64),('16273','2013-07-23','14:30:00',3.63),('16273','2013-07-23','14:35:00',3.59),('16273','2013-07-23','14:40:00',3.53),('16273','2013-07-23','14:45:00',3.48),('16273','2013-07-23','14:50:00',3.38),('16273','2013-07-23','14:55:00',3.34),('16273','2013-07-23','15:00:00',3.29),('16273','2013-07-23','15:05:00',3.25),('16273','2013-07-23','15:10:00',3.2),('16273','2013-07-23','15:15:00',3.13),('16273','2013-07-23','15:20:00',3.02),('16273','2013-07-23','15:25:00',2.98),('16273','2013-07-23','15:30:00',2.93),('16273','2013-07-23','15:35:00',2.88),('16273','2013-07-23','15:40:00',2.85),('16273','2013-07-23','15:45:00',2.79),('16273','2013-07-23','15:50:00',2.73),('16273','2013-07-23','15:55:00',2.69),('16273','2013-07-23','16:00:00',2.63),('16273','2013-07-23','16:05:00',2.58),('16273','2013-07-23','16:10:00',2.51),('16273','2013-07-23','16:15:00',2.46),('16273','2013-07-23','16:20:00',2.4),('16273','2013-07-23','16:25:00',2.33),('16273','2013-07-23','16:30:00',2.28),('16273','2013-07-23','16:35:00',2.21),('16273','2013-07-23','16:40:00',2.13),('16273','2013-07-23','16:45:00',2.07),('16273','2013-07-23','16:50:00',1.99),('16273','2013-07-23','16:55:00',1.91),('16273','2013-07-23','17:00:00',1.85),('16273','2013-07-23','17:05:00',1.78),('16273','2013-07-23','17:10:00',1.69),('16273','2013-07-23','17:15:00',1.63),('16273','2013-07-23','17:20:00',1.56),('16273','2013-07-23','17:25:00',1.48),('16273','2013-07-23','17:30:00',1.42),('16273','2013-07-23','17:35:00',1.35),('16273','2013-07-23','17:40:00',1.28),('16273','2013-07-23','17:45:00',1.21),('16273','2013-07-23','17:50:00',1.14),('16273','2013-07-23','17:55:00',1.06),('16273','2013-07-22','07:30:00',1.04),('16273','2013-07-22','07:35:00',1.13),('16273','2013-07-22','07:40:00',1.21),('16273','2013-07-22','07:45:00',1.29),('16273','2013-07-22','07:50:00',1.37),('16273','2013-07-22','07:55:00',1.45),('16273','2013-07-22','08:00:00',1.54),('16273','2013-07-22','08:05:00',1.61),('16273','2013-07-22','08:10:00',1.7),('16273','2013-07-22','08:15:00',1.78),('16273','2013-07-22','08:20:00',1.87),('16273','2013-07-22','08:25:00',1.94),('16273','2013-07-22','08:30:00',2.01),('16273','2013-07-22','08:35:00',2.09),('16273','2013-07-22','08:40:00',2.16),('16273','2013-07-22','08:45:00',2.23),('16273','2013-07-22','08:50:00',2.29),('16273','2013-07-22','08:55:00',2.36),('16273','2013-07-22','09:00:00',2.43),('16273','2013-07-22','09:05:00',2.48),('16273','2013-07-22','09:10:00',2.54),('16273','2013-07-22','09:15:00',2.6),('16273','2013-07-22','09:20:00',2.66),('16273','2013-07-22','09:25:00',2.71),('16273','2013-07-22','09:30:00',2.77),('16273','2013-07-22','09:35:00',2.82),('16273','2013-07-22','09:40:00',2.87),('16273','2013-07-22','09:45:00',2.92),('16273','2013-07-22','09:50:00',2.96),('16273','2013-07-22','09:55:00',3.02),('16273','2013-07-22','10:00:00',3.04),('16273','2013-07-22','10:05:00',3.06),('16273','2013-07-22','10:10:00',3.13),('16273','2013-07-22','10:15:00',3.19),('16273','2013-07-22','10:20:00',3.24),('16273','2013-07-22','10:25:00',3.28),('16273','2013-07-22','10:30:00',3.31),('16273','2013-07-22','10:35:00',3.35),('16273','2013-07-22','10:40:00',3.37),('16273','2013-07-22','10:45:00',3.38),('16273','2013-07-22','10:50:00',3.43),('16273','2013-07-22','10:55:00',3.46),('16273','2013-07-22','11:00:00',3.48),('16273','2013-07-22','11:05:00',3.5),('16273','2013-07-22','11:10:00',3.53),('16273','2013-07-22','11:15:00',3.56),('16273','2013-07-22','11:20:00',3.58),('16273','2013-07-22','11:25:00',3.59),('16273','2013-07-22','11:30:00',3.61),('16273','2013-07-22','11:35:00',3.6),('16273','2013-07-22','11:40:00',3.64),('16273','2013-07-22','11:45:00',3.64),('16273','2013-07-22','11:50:00',3.65),('16273','2013-07-22','11:55:00',3.68),('16273','2013-07-22','12:00:00',3.67),('16273','2013-07-22','12:05:00',3.67),('16273','2013-07-22','12:10:00',3.69),('16273','2013-07-22','12:15:00',3.68),('16273','2013-07-22','12:20:00',3.67),('16273','2013-07-22','12:25:00',3.68),('16273','2013-07-22','12:30:00',3.7),('16273','2013-07-22','12:35:00',3.71),('16273','2013-07-22','12:40:00',3.69),('16273','2013-07-22','12:45:00',3.69),('16273','2013-07-22','12:50:00',3.67),('16273','2013-07-22','12:55:00',3.68),('16273','2013-07-22','13:00:00',3.65),('16273','2013-07-22','13:05:00',3.66),('16273','2013-07-22','13:10:00',3.67),('16273','2013-07-22','13:15:00',3.69),('16273','2013-07-22','13:20:00',3.67),('16273','2013-07-22','13:25:00',3.64),('16273','2013-07-22','13:30:00',3.61),('16273','2013-07-22','13:35:00',3.6),('16273','2013-07-22','13:40:00',3.61),('16273','2013-07-22','13:45:00',3.57),('16273','2013-07-22','13:50:00',3.5),('16273','2013-07-22','13:55:00',3.51),('16273','2013-07-22','14:00:00',3.49),('16273','2013-07-22','14:05:00',3.46),('16273','2013-07-22','14:10:00',3.44),('16273','2013-07-22','14:15:00',3.39),('16273','2013-07-22','14:20:00',3.37),('16273','2013-07-22','14:25:00',3.32),('16273','2013-07-22','14:30:00',3.25),('16273','2013-07-22','14:35:00',1.86),('16273','2013-07-22','14:40:00',3.31),('16273','2013-07-22','14:45:00',3.2),('16273','2013-07-22','14:50:00',3.21),('16273','2013-07-22','14:55:00',3.21),('16273','2013-07-22','15:00:00',3.22),('16273','2013-07-22','15:05:00',3.34),('16273','2013-07-22','15:10:00',3.31),('16273','2013-07-22','15:15:00',3.17),('16273','2013-07-22','15:20:00',2.64),('16273','2013-07-22','15:25:00',2.07),('16273','2013-07-22','15:40:00',2.08),('16273','2013-07-22','15:45:00',2.97),('16273','2013-07-22','15:50:00',1.48),('16273','2013-07-22','15:55:00',1.05),('16273','2013-07-22','16:00:00',2.28),('16273','2013-07-22','16:05:00',2.54),('16273','2013-07-22','16:10:00',2.55),('16273','2013-07-22','16:15:00',2.47),('16273','2013-07-22','16:20:00',2.34),('16273','2013-07-22','16:25:00',2.33),('16273','2013-07-22','16:30:00',2.22),('16273','2013-07-22','16:35:00',2.16),('16273','2013-07-22','16:40:00',2.1),('16273','2013-07-22','16:45:00',1.96),('16273','2013-07-22','16:50:00',1.91),('16273','2013-07-22','16:55:00',1.88),('16273','2013-07-22','17:00:00',1.8),('16273','2013-07-22','17:05:00',1.75),('16273','2013-07-22','17:10:00',1.65),('16273','2013-07-22','17:15:00',1.61),('16273','2013-07-22','17:20:00',1.51),('16273','2013-07-22','17:25:00',1.45),('16273','2013-07-22','17:30:00',1.4),('16273','2013-07-22','17:35:00',1.34),('16273','2013-07-22','17:40:00',1.25),('16273','2013-07-22','17:45:00',1.21),('16273','2013-07-22','17:50:00',1.15),('16273','2013-07-22','17:55:00',1.12),('16273','2013-07-22','18:00:00',1.03),('16273','2013-07-21','07:30:00',1.01),('16273','2013-07-21','07:35:00',1.1),('16273','2013-07-21','07:40:00',1.19),('16273','2013-07-21','07:45:00',1.27),('16273','2013-07-21','07:50:00',1.32),('16273','2013-07-21','07:55:00',1.37),('16273','2013-07-21','08:00:00',1.45),('16273','2013-07-21','08:05:00',1.52),('16273','2013-07-21','08:10:00',1.44),('16273','2013-07-21','08:15:00',1.69),('16273','2013-07-21','08:20:00',1.77),('16273','2013-07-21','08:25:00',1.85),('16273','2013-07-21','08:30:00',1.95),('16273','2013-07-21','08:35:00',2.03),('16273','2013-07-21','08:40:00',2.08),('16273','2013-07-21','08:45:00',2.13),('16273','2013-07-21','08:50:00',2.21),('16273','2013-07-21','08:55:00',2.28),('16273','2013-07-21','09:00:00',2.33),('16273','2013-07-21','09:05:00',2.4),('16273','2013-07-21','09:10:00',2.48),('16273','2013-07-21','09:15:00',2.54),('16273','2013-07-21','09:20:00',2.59),('16273','2013-07-21','09:25:00',2.66),('16273','2013-07-21','09:30:00',2.71),('16273','2013-07-21','09:35:00',2.73),('16273','2013-07-21','09:40:00',2.76),('16273','2013-07-21','09:45:00',2.82),('16273','2013-07-21','09:50:00',2.88),('16273','2013-07-21','09:55:00',2.95),('16273','2013-07-21','10:00:00',2.97),('16273','2013-07-21','10:05:00',3.05),('16273','2013-07-21','10:10:00',3.08),('16273','2013-07-21','10:15:00',3.13),('16273','2013-07-21','10:20:00',3.17),('16273','2013-07-21','10:25:00',3.19),('16273','2013-07-21','10:30:00',3.21),('16273','2013-07-21','10:35:00',3.26),('16273','2013-07-21','10:40:00',3.3),('16273','2013-07-21','10:45:00',3.35),('16273','2013-07-21','10:50:00',3.37),('16273','2013-07-21','10:55:00',3.39),('16273','2013-07-21','11:00:00',3.42),('16273','2013-07-21','11:05:00',3.4),('16273','2013-07-21','11:10:00',3.43),('16273','2013-07-21','11:15:00',3.49),('16273','2013-07-21','11:20:00',3.51),('16273','2013-07-21','11:25:00',3.53),('16273','2013-07-21','11:30:00',3.49),('16273','2013-07-21','11:35:00',3.51),('16273','2013-07-21','11:40:00',3.52),('16273','2013-07-21','11:45:00',3.53),('16273','2013-07-21','11:50:00',3.59),('16273','2013-07-21','11:55:00',3.64),('16273','2013-07-21','12:00:00',3.64),('16273','2013-07-21','12:05:00',3.64),('16273','2013-07-21','12:10:00',3.7),('16273','2013-07-21','12:15:00',3.83),('16273','2013-07-21','12:20:00',4),('16273','2013-07-21','12:25:00',3.06),('16273','2013-07-21','12:30:00',1.83),('16273','2013-07-21','12:35:00',1.82),('16273','2013-07-21','12:40:00',1.78),('16273','2013-07-21','12:45:00',1.73),('16273','2013-07-21','12:50:00',1.71),('16273','2013-07-21','12:55:00',1.81),('16273','2013-07-21','13:00:00',2.22),('16273','2013-07-21','13:05:00',4.64),('16273','2013-07-21','13:10:00',3.62),('16273','2013-07-21','13:15:00',2.25),('16273','2013-07-21','13:20:00',2.15),('16273','2013-07-21','13:25:00',1.81),('16273','2013-07-21','13:30:00',2.04),('16273','2013-07-21','13:35:00',3.63),('16273','2013-07-21','13:40:00',2.4),('16273','2013-07-21','13:45:00',2.33),('16273','2013-07-21','13:50:00',2.19),('16273','2013-07-21','13:55:00',3.61),('16273','2013-07-21','14:00:00',4.37),('16273','2013-07-21','14:05:00',2.87),('16273','2013-07-21','14:10:00',2.51),('16273','2013-07-21','14:15:00',1.66),('16273','2013-07-21','14:20:00',1.41),('16273','2013-07-21','14:25:00',1.33),('16273','2013-07-21','14:30:00',1.21),('16273','2013-07-21','14:35:00',1.07),('16273','2013-07-21','14:40:00',1.1),('16273','2013-07-21','14:45:00',1.27),('16273','2013-07-21','14:50:00',1.45),('16273','2013-07-21','14:55:00',1.86),('16273','2013-07-21','15:00:00',1.73),('16273','2013-07-21','15:05:00',1.31),('16273','2013-07-21','15:10:00',1.24),('16273','2013-07-21','15:15:00',1.25),('16273','2013-07-21','15:20:00',1.29),('16273','2013-07-21','15:25:00',1.16),('16273','2013-07-21','15:30:00',1.18),('16273','2013-07-21','15:35:00',1.25),('16273','2013-07-21','15:40:00',1.37),('16273','2013-07-21','15:45:00',1.57),('16273','2013-07-21','15:50:00',1.71),('16273','2013-07-21','15:55:00',1.67),('16273','2013-07-21','16:00:00',1.63),('16273','2013-07-21','16:05:00',1.56),('16273','2013-07-21','16:10:00',1.08),('16273','2013-07-21','16:35:00',1.06),('16273','2013-07-21','16:40:00',1.14),('16273','2013-07-21','16:45:00',1.15),('16273','2013-07-21','16:50:00',1.15),('16273','2013-07-21','16:55:00',1.05),('16273','2013-07-21','17:00:00',1.24),('16273','2013-07-21','17:05:00',1.84),('16273','2013-07-21','17:10:00',1.97),('16273','2013-07-21','17:15:00',1.29),('16273','2014-04-07','08:15:00',1.01),('16273','2014-04-07','08:20:00',1.51),('16273','2014-04-07','08:25:00',1.34),('16273','2014-04-07','08:30:00',1.5),('16273','2014-04-07','08:35:00',1.42),('16273','2014-04-07','08:40:00',1.11),('16273','2014-04-07','08:45:00',1.04),('16273','2014-04-07','09:30:00',1.01),('16273','2014-04-07','09:35:00',1.04),('16273','2014-04-07','09:40:00',1.07),('16273','2014-04-07','09:45:00',1.08),('16273','2014-04-07','09:50:00',1.08),('16273','2014-04-07','09:55:00',1.09),('16273','2014-04-07','10:00:00',1.12),('16273','2014-04-07','10:05:00',1.1),('16273','2014-04-07','10:10:00',1.1),('16273','2014-04-07','10:15:00',1.14),('16273','2014-04-07','10:20:00',1.16),('16273','2014-04-07','10:25:00',1.15),('16273','2014-04-07','10:30:00',1.14),('16273','2014-04-07','10:35:00',1.17),('16273','2014-04-07','10:40:00',1.23),('16273','2014-04-07','10:45:00',1.3),('16273','2014-04-07','10:50:00',1.34),('16273','2014-04-07','10:55:00',1.36),('16273','2014-04-07','11:00:00',1.38),('16273','2014-04-07','11:05:00',1.41),('16273','2014-04-07','11:10:00',1.43),('16273','2014-04-07','11:15:00',1.48),('16273','2014-04-07','11:20:00',1.5),('16273','2014-04-07','11:25:00',1.5),('16273','2014-04-07','11:30:00',1.56),('16273','2014-04-07','11:35:00',1.47),('16273','2014-04-07','11:40:00',1.42),('16273','2014-04-07','11:45:00',1.41),('16273','2014-04-07','11:50:00',1.43),('16273','2014-04-07','11:55:00',1.51),('16273','2014-04-07','12:00:00',1.81),('16273','2014-04-07','12:05:00',2.43),('16273','2014-04-07','12:10:00',3.43),('16273','2014-04-07','12:15:00',3.95),('16273','2014-04-07','12:20:00',3.46),('16273','2014-04-07','12:25:00',2.72),('16273','2014-04-07','12:30:00',1.63),('16273','2014-04-07','12:35:00',3.42),('16273','2014-04-07','12:40:00',3.87),('16273','2014-04-07','12:45:00',3.75),('16273','2014-04-07','12:50:00',3.65),('16273','2014-04-07','12:55:00',3.58),('16273','2014-04-07','13:00:00',3.55),('16273','2014-04-07','13:05:00',3.55),('16273','2014-04-07','13:10:00',3.51),('16273','2014-04-07','13:15:00',3.54),('16273','2014-04-07','13:20:00',3.52),('16273','2014-04-07','13:25:00',3.49),('16273','2014-04-07','13:30:00',3.46),('16273','2014-04-07','13:35:00',3.48),('16273','2014-04-07','13:40:00',3.47),('16273','2014-04-07','13:45:00',3.42),('16273','2014-04-07','13:50:00',3.38),('16273','2014-04-07','13:55:00',3.33),('16273','2014-04-07','14:00:00',3.3),('16273','2014-04-07','14:05:00',3.28),('16273','2014-04-07','14:10:00',3.3),('16273','2014-04-07','14:15:00',3.26),('16273','2014-04-07','14:20:00',3.21),('16273','2014-04-07','14:25:00',3.21),('16273','2014-04-07','14:30:00',3.17),('16273','2014-04-07','14:35:00',3.12),('16273','2014-04-07','14:40:00',3.06),('16273','2014-04-07','14:45:00',3.1),('16273','2014-04-07','14:50:00',3.07),('16273','2014-04-07','14:55:00',3.02),('16273','2014-04-07','15:00:00',2.99),('16273','2014-04-07','15:05:00',2.93),('16273','2014-04-07','15:10:00',2.88),('16273','2014-04-07','15:15:00',2.81),('16273','2014-04-07','15:20:00',2.72),('16273','2014-04-07','15:25:00',2.68),('16273','2014-04-07','15:30:00',2.66),('16273','2014-04-07','15:35:00',2.64),('16273','2014-04-07','15:40:00',2.57),('16273','2014-04-07','15:45:00',2.5),('16273','2014-04-07','15:50:00',2.44),('16273','2014-04-07','15:55:00',2.4),('16273','2014-04-07','16:00:00',2.36),('16273','2014-04-07','16:05:00',2.31),('16273','2014-04-07','16:10:00',2.23),('16273','2014-04-07','16:15:00',2.2),('16273','2014-04-07','16:20:00',1.24),('16273','2014-04-07','16:55:00',1.56),('16273','2014-04-07','17:00:00',1.55),('16273','2014-04-07','17:05:00',1.57),('16273','2014-04-07','17:10:00',1.6),('16273','2014-04-07','17:15:00',1.53),('16273','2014-04-07','17:20:00',1.55),('16273','2014-04-07','17:25:00',1.52),('16273','2014-04-07','17:30:00',1.39),('16273','2014-04-07','17:35:00',1.18),('16273','2014-04-07','17:40:00',1.33),('16273','2014-04-07','17:45:00',1.16),('16273','2013-07-20','07:25:00',1.01),('16273','2013-07-20','07:30:00',1.1),('16273','2013-07-20','07:35:00',1.19),('16273','2013-07-20','07:40:00',1.26),('16273','2013-07-20','07:45:00',1.32),('16273','2013-07-20','07:50:00',1.42),('16273','2013-07-20','07:55:00',1.51),('16273','2013-07-20','08:00:00',1.59),('16273','2013-07-20','08:05:00',1.68),('16273','2013-07-20','08:10:00',1.75),('16273','2013-07-20','08:15:00',1.82),('16273','2013-07-20','08:20:00',1.9),('16273','2013-07-20','08:25:00',1.98),('16273','2013-07-20','08:30:00',2.05),('16273','2013-07-20','08:35:00',2.14),('16273','2013-07-20','08:40:00',2.21),('16273','2013-07-20','08:45:00',2.23),('16273','2013-07-20','08:50:00',2.37),('16273','2013-07-20','08:55:00',2.38),('16273','2013-07-20','09:00:00',2.55),('16273','2013-07-20','09:05:00',2.65),('16273','2013-07-20','09:10:00',2.72),('16273','2013-07-20','09:15:00',2.69),('16273','2013-07-20','09:20:00',2.62),('16273','2013-07-20','09:25:00',2.43),('16273','2013-07-20','09:30:00',2.46),('16273','2013-07-20','09:35:00',2.8),('16273','2013-07-20','09:40:00',2.95),('16273','2013-07-20','09:45:00',2.84),('16273','2013-07-20','09:50:00',2.93),('16273','2013-07-20','09:55:00',2.97),('16273','2013-07-20','10:00:00',3.09),('16273','2013-07-20','10:05:00',3.1),('16273','2013-07-20','10:10:00',3.16),('16273','2013-07-20','10:15:00',3.21),('16273','2013-07-20','10:20:00',3.25),('16273','2013-07-20','10:25:00',3.29),('16273','2013-07-20','10:30:00',3.32),('16273','2013-07-20','10:35:00',3.35),('16273','2013-07-20','10:40:00',3.38),('16273','2013-07-20','10:45:00',3.42),('16273','2013-07-20','10:50:00',3.46),('16273','2013-07-20','10:55:00',3.46),('16273','2013-07-20','11:00:00',3.48),('16273','2013-07-20','11:05:00',3.5),('16273','2013-07-20','11:10:00',3.54),('16273','2013-07-20','11:15:00',3.56),('16273','2013-07-20','11:20:00',3.55),('16273','2013-07-20','11:25:00',3.5),('16273','2013-07-20','11:30:00',3.46),('16273','2013-07-20','11:35:00',3.63),('16273','2013-07-20','11:40:00',3.67),('16273','2013-07-20','11:45:00',3.68),('16273','2013-07-20','11:50:00',3.71),('16273','2013-07-20','11:55:00',3.7),('16273','2013-07-20','12:00:00',3.73),('16273','2013-07-20','12:05:00',3.73),('16273','2013-07-20','12:10:00',3.74),('16273','2013-07-20','12:15:00',3.76),('16273','2013-07-20','12:20:00',3.78),('16273','2013-07-20','12:25:00',3.77),('16273','2013-07-20','12:30:00',3.71),('16273','2013-07-20','12:35:00',3.74),('16273','2013-07-20','12:40:00',3.79),('16273','2013-07-20','12:45:00',3.8),('16273','2013-07-20','12:50:00',3.79),('16273','2013-07-20','12:55:00',3.78),('16273','2013-07-20','13:00:00',3.77),('16273','2013-07-20','13:05:00',3.81),('16273','2013-07-20','13:10:00',3.84),('16273','2013-07-20','13:15:00',3.8),('16273','2013-07-20','13:20:00',3.72),('16273','2013-07-20','13:25:00',3.73),('16273','2013-07-20','13:30:00',3.75),('16273','2013-07-20','13:35:00',3.74),('16273','2013-07-20','13:40:00',3.69),('16273','2013-07-20','13:45:00',3.67),('16273','2013-07-20','13:50:00',3.64),('16273','2013-07-20','13:55:00',3.6),('16273','2013-07-20','14:00:00',3.58),('16273','2013-07-20','14:05:00',3.56),('16273','2013-07-20','14:10:00',3.54),('16273','2013-07-20','14:15:00',3.52),('16273','2013-07-20','14:20:00',3.5),('16273','2013-07-20','14:25:00',3.47),('16273','2013-07-20','14:30:00',3.42),('16273','2013-07-20','14:35:00',3.41),('16273','2013-07-20','14:40:00',3.37),('16273','2013-07-20','14:45:00',3.32),('16273','2013-07-20','14:50:00',3.3),('16273','2013-07-20','14:55:00',3.26),('16273','2013-07-20','15:00:00',3.23),('16273','2013-07-20','15:05:00',3.2),('16273','2013-07-20','15:10:00',3.16),('16273','2013-07-20','15:15:00',3.11),('16273','2013-07-20','15:20:00',3.07),('16273','2013-07-20','15:25:00',3.02),('16273','2013-07-20','15:30:00',2.98),('16273','2013-07-20','15:35:00',2.89),('16273','2013-07-20','15:40:00',2.87),('16273','2013-07-20','15:45:00',2.82),('16273','2013-07-20','15:50:00',2.78),('16273','2013-07-20','15:55:00',2.71),('16273','2013-07-20','16:00:00',2.65),('16273','2013-07-20','16:05:00',2.58),('16273','2013-07-20','16:10:00',2.55),('16273','2013-07-20','16:15:00',2.5),('16273','2013-07-20','16:20:00',2.41),('16273','2013-07-20','16:25:00',2.35),('16273','2013-07-20','16:30:00',2.29),('16273','2013-07-20','16:35:00',2.22),('16273','2013-07-20','16:40:00',2.16),('16273','2013-07-20','16:45:00',2.09),('16273','2013-07-20','16:50:00',2.01),('16273','2013-07-20','16:55:00',1.94),('16273','2013-07-20','17:00:00',1.87),('16273','2013-07-20','17:05:00',1.79),('16273','2013-07-20','17:10:00',1.73),('16273','2013-07-20','17:15:00',1.65),('16273','2013-07-20','17:20:00',1.58),('16273','2013-07-20','17:25:00',1.51),('16273','2013-07-20','17:30:00',1.44),('16273','2013-07-20','17:35:00',1.37),('16273','2013-07-20','17:40:00',1.3),('16273','2013-07-20','17:45:00',1.23),('16273','2013-07-20','17:50:00',1.15),('16273','2013-07-20','17:55:00',1.1),('16273','2013-07-20','18:00:00',1.02),('16273','2013-07-19','07:30:00',1.02),('16273','2013-07-19','07:35:00',1.1),('16273','2013-07-19','07:40:00',1.17),('16273','2013-07-19','07:45:00',1.24),('16273','2013-07-19','07:50:00',1.31),('16273','2013-07-19','07:55:00',1.39),('16273','2013-07-19','08:00:00',1.47),('16273','2013-07-19','08:05:00',1.55),('16273','2013-07-19','08:10:00',1.62),('16273','2013-07-19','08:15:00',1.7),('16273','2013-07-19','08:20:00',1.78),('16273','2013-07-19','08:25:00',1.87),('16273','2013-07-19','08:30:00',1.94),('16273','2013-07-19','08:35:00',2.02),('16273','2013-07-19','08:40:00',2.09),('16273','2013-07-19','08:45:00',2.15),('16273','2013-07-19','08:50:00',2.21),('16273','2013-07-19','08:55:00',2.29),('16273','2013-07-19','09:00:00',2.32),('16273','2013-07-19','09:05:00',2.38),('16273','2013-07-19','09:10:00',2.49),('16273','2013-07-19','09:15:00',2.5),('16273','2013-07-19','09:20:00',2.54),('16273','2013-07-19','09:25:00',2.58),('16273','2013-07-19','09:30:00',2.64),('16273','2013-07-19','09:35:00',2.68),('16273','2013-07-19','09:40:00',2.71),('16273','2013-07-19','09:45:00',2.75),('16273','2013-07-19','09:50:00',2.8),('16273','2013-07-19','09:55:00',2.81),('16273','2013-07-19','10:00:00',2.9),('16273','2013-07-19','10:05:00',2.93),('16273','2013-07-19','10:10:00',2.99),('16273','2013-07-19','10:15:00',3.02),('16273','2013-07-19','10:20:00',3.09),('16273','2013-07-19','10:25:00',3.12),('16273','2013-07-19','10:30:00',3.19),('16273','2013-07-19','10:35:00',3.21),('16273','2013-07-19','10:40:00',3.22),('16273','2013-07-19','10:45:00',3.27),('16273','2013-07-19','10:50:00',3.29),('16273','2013-07-19','10:55:00',3.31),('16273','2013-07-19','11:00:00',3.33),('16273','2013-07-19','11:05:00',3.38),('16273','2013-07-19','11:10:00',3.44),('16273','2013-07-19','11:15:00',3.42),('16273','2013-07-19','11:20:00',3.34),('16273','2013-07-19','11:25:00',3.4),('16273','2013-07-19','11:30:00',3.38),('16273','2013-07-19','11:35:00',3.56),('16273','2013-07-19','11:40:00',3.62),('16273','2013-07-19','11:45:00',2.25),('16273','2013-07-19','11:50:00',3.1),('16273','2013-07-19','11:55:00',3.69),('16273','2013-07-19','12:00:00',3.76),('16273','2013-07-19','12:05:00',3.72),('16273','2013-07-19','12:10:00',3.74),('16273','2013-07-19','12:15:00',3.73),('16273','2013-07-19','12:20:00',3.76),('16273','2013-07-19','12:25:00',3.62),('16273','2013-07-19','12:30:00',3.73),('16273','2013-07-19','12:35:00',3.77),('16273','2013-07-19','12:40:00',3.75),('16273','2013-07-19','12:45:00',3.79),('16273','2013-07-19','12:50:00',3.71),('16273','2013-07-19','12:55:00',3.78),('16273','2013-07-19','13:00:00',3.77),('16273','2013-07-19','13:05:00',3.42),('16273','2013-07-19','13:10:00',3.81),('16273','2013-07-19','13:15:00',3.79),('16273','2013-07-19','13:20:00',3.8),('16273','2013-07-19','13:25:00',3.79),('16273','2013-07-19','13:30:00',3.75),('16273','2013-07-19','13:35:00',3.73),('16273','2013-07-19','13:40:00',3.73),('16273','2013-07-19','13:45:00',3.7),('16273','2013-07-19','13:50:00',3.7),('16273','2013-07-19','13:55:00',3.59),('16273','2013-07-19','14:00:00',3.65),('16273','2013-07-19','14:05:00',3.64),('16273','2013-07-19','14:10:00',3.61),('16273','2013-07-19','14:15:00',3.58),('16273','2013-07-19','14:20:00',3.56),('16273','2013-07-19','14:25:00',3.55),('16273','2013-07-19','14:30:00',3.51),('16273','2013-07-19','14:35:00',3.46),('16273','2013-07-19','14:40:00',3.35),('16273','2013-07-19','14:45:00',3.43),('16273','2013-07-19','14:50:00',2.59),('16273','2013-07-19','14:55:00',3.05),('16273','2013-07-19','15:00:00',3.44),('16273','2013-07-19','15:05:00',3.21),('16273','2013-07-19','15:10:00',3.24),('16273','2013-07-19','15:15:00',2.45),('16273','2013-07-19','15:20:00',1.95),('16273','2013-07-19','15:25:00',3.2),('16273','2013-07-19','15:30:00',3.2),('16273','2013-07-19','15:35:00',3.11),('16273','2013-07-19','15:40:00',3.02),('16273','2013-07-19','15:45:00',2.9),('16273','2013-07-19','15:50:00',2.82),('16273','2013-07-19','15:55:00',2.77),('16273','2013-07-19','16:00:00',2.68),('16273','2013-07-19','16:05:00',2.65),('16273','2013-07-19','16:10:00',2.61),('16273','2013-07-19','16:15:00',2.51),('16273','2013-07-19','16:20:00',2.46),('16273','2013-07-19','16:25:00',2.39),('16273','2013-07-19','16:30:00',2.34),('16273','2013-07-19','16:35:00',2.28),('16273','2013-07-19','16:40:00',2.03),('16273','2013-07-19','16:45:00',2.16),('16273','2013-07-19','16:50:00',2.15),('16273','2013-07-19','16:55:00',2.07),('16273','2013-07-19','17:00:00',2.01),('16273','2013-07-19','17:05:00',1.6),('16273','2013-07-19','17:10:00',1.15),('16273','2013-07-19','17:15:00',1.4),('16273','2013-07-19','17:20:00',1.3),('16273','2013-07-19','17:25:00',1.12),('16273','2013-07-19','17:30:00',1.39),('16273','2013-07-19','17:35:00',1.35),('16273','2013-07-19','17:40:00',1.13),('16273','2013-07-19','17:45:00',1.07),('16273','2013-07-18','07:25:00',1.04),('16273','2013-07-18','07:30:00',1.11),('16273','2013-07-18','07:35:00',1.2),('16273','2013-07-18','07:40:00',1.28),('16273','2013-07-18','07:45:00',1.35),('16273','2013-07-18','07:50:00',1.43),('16273','2013-07-18','07:55:00',1.5),('16273','2013-07-18','08:00:00',1.57),('16273','2013-07-18','08:05:00',1.65),('16273','2013-07-18','08:10:00',1.72),('16273','2013-07-18','08:15:00',1.8),('16273','2013-07-18','08:20:00',1.89),('16273','2013-07-18','08:25:00',1.97),('16273','2013-07-18','08:30:00',2.06),('16273','2013-07-18','08:35:00',2.13),('16273','2013-07-18','08:40:00',2.21),('16273','2013-07-18','08:45:00',2.27),('16273','2013-07-18','08:50:00',2.35),('16273','2013-07-18','08:55:00',2.42),('16273','2013-07-18','09:00:00',2.49),('16273','2013-07-18','09:05:00',2.54),('16273','2013-07-18','09:10:00',2.6),('16273','2013-07-18','09:15:00',2.66),('16273','2013-07-18','09:20:00',2.72),('16273','2013-07-18','09:25:00',2.78),('16273','2013-07-18','09:30:00',2.82),('16273','2013-07-18','09:35:00',2.87),('16273','2013-07-18','09:40:00',2.92),('16273','2013-07-18','09:45:00',2.97),('16273','2013-07-18','09:50:00',3.03),('16273','2013-07-18','09:55:00',3.07),('16273','2013-07-18','10:00:00',3.08),('16273','2013-07-18','10:05:00',3.15),('16273','2013-07-18','10:10:00',3.18),('16273','2013-07-18','10:15:00',3.22),('16273','2013-07-18','10:20:00',3.26),('16273','2013-07-18','10:25:00',3.29),('16273','2013-07-18','10:30:00',3.3),('16273','2013-07-18','10:35:00',3.28),('16273','2013-07-18','10:40:00',3.13),('16273','2013-07-18','10:45:00',3.32),('16273','2013-07-18','10:50:00',3.47),('16273','2013-07-18','10:55:00',3.49),('16273','2013-07-18','11:00:00',3.49),('16273','2013-07-18','11:05:00',3.52),('16273','2013-07-18','11:10:00',3.55),('16273','2013-07-18','11:15:00',3.59),('16273','2013-07-18','11:20:00',3.59),('16273','2013-07-18','11:25:00',3.6),('16273','2013-07-18','11:30:00',3.63),('16273','2013-07-18','11:35:00',3.65),('16273','2013-07-18','11:40:00',3.66),('16273','2013-07-18','11:45:00',3.6),('16273','2013-07-18','11:50:00',3.65),('16273','2013-07-18','11:55:00',3.67),('16273','2013-07-18','12:00:00',3.67),('16273','2013-07-18','12:05:00',3.68),('16273','2013-07-18','12:10:00',3.7),('16273','2013-07-18','12:15:00',3.73),('16273','2013-07-18','12:20:00',3.68),('16273','2013-07-18','12:25:00',3.7),('16273','2013-07-18','12:30:00',3.74),('16273','2013-07-18','12:35:00',3.74),('16273','2013-07-18','12:40:00',3.76),('16273','2013-07-18','12:45:00',3.8),('16273','2013-07-18','12:50:00',3.72),('16273','2013-07-18','12:55:00',3.71),('16273','2013-07-18','13:00:00',3.73),('16273','2013-07-18','13:05:00',3.72),('16273','2013-07-18','13:10:00',3.73),('16273','2013-07-18','13:15:00',3.72),('16273','2013-07-18','13:20:00',3.75),('16273','2013-07-18','13:25:00',3.71),('16273','2013-07-18','13:30:00',3.71),('16273','2013-07-18','13:35:00',3.68),('16273','2013-07-18','13:40:00',3.68),('16273','2013-07-18','13:45:00',3.67),('16273','2013-07-18','13:50:00',3.63),('16273','2013-07-18','13:55:00',3.61),('16273','2013-07-18','14:00:00',3.59),('16273','2013-07-18','14:05:00',3.56),('16273','2013-07-18','14:10:00',3.56),('16273','2013-07-18','14:15:00',3.55),('16273','2013-07-18','14:20:00',3.51),('16273','2013-07-18','14:25:00',3.5),('16273','2013-07-18','14:30:00',3.44),('16273','2013-07-18','14:35:00',3.4),('16273','2013-07-18','14:40:00',3.39),('16273','2013-07-18','14:45:00',3.33),('16273','2013-07-18','14:50:00',3.29),('16273','2013-07-18','14:55:00',3.29),('16273','2013-07-18','15:00:00',3.22),('16273','2013-07-18','15:05:00',3.15),('16273','2013-07-18','15:10:00',3.13),('16273','2013-07-18','15:15:00',3.1),('16273','2013-07-18','15:20:00',3.06),('16273','2013-07-18','15:25:00',2.99),('16273','2013-07-18','15:30:00',2.96),('16273','2013-07-18','15:35:00',2.9),('16273','2013-07-18','15:40:00',2.84),('16273','2013-07-18','15:45:00',2.79),('16273','2013-07-18','15:50:00',2.72),('16273','2013-07-18','15:55:00',2.69),('16273','2013-07-18','16:00:00',2.63),('16273','2013-07-18','16:05:00',2.56),('16273','2013-07-18','16:10:00',2.5),('16273','2013-07-18','16:15:00',2.42),('16273','2013-07-18','16:20:00',2.38),('16273','2013-07-18','16:25:00',2.31),('16273','2013-07-18','16:30:00',2.24),('16273','2013-07-18','16:35:00',2.16),('16273','2013-07-18','16:40:00',2.13),('16273','2013-07-18','16:45:00',2.04),('16273','2013-07-18','16:50:00',1.97),('16273','2013-07-18','16:55:00',1.89),('16273','2013-07-18','17:00:00',1.81),('16273','2013-07-18','17:05:00',1.74),('16273','2013-07-18','17:10:00',1.66),('16273','2013-07-18','17:15:00',1.49),('16273','2013-07-18','17:20:00',1.54),('16273','2013-07-18','17:25:00',1.25),('16273','2013-07-18','17:30:00',1.19),('16273','2013-07-18','17:35:00',1.33),('16273','2013-07-18','17:40:00',1.25),('16273','2013-07-18','17:45:00',1.21),('16273','2013-07-18','17:50:00',1.13),('16273','2013-07-18','17:55:00',1.05),('16273','2013-07-17','07:25:00',1.08),('16273','2013-07-17','07:30:00',1.16),('16273','2013-07-17','07:35:00',1.25),('16273','2013-07-17','07:40:00',1.33),('16273','2013-07-17','07:45:00',1.41),('16273','2013-07-17','07:50:00',1.5),('16273','2013-07-17','07:55:00',1.58),('16273','2013-07-17','08:00:00',1.64),('16273','2013-07-17','08:05:00',1.72),('16273','2013-07-17','08:10:00',1.79),('16273','2013-07-17','08:15:00',1.86),('16273','2013-07-17','08:20:00',1.97),('16273','2013-07-17','08:25:00',2.02),('16273','2013-07-17','08:30:00',2.08),('16273','2013-07-17','08:35:00',2.18),('16273','2013-07-17','08:40:00',2.27),('16273','2013-07-17','08:45:00',2.32),('16273','2013-07-17','08:50:00',2.39),('16273','2013-07-17','08:55:00',2.45),('16273','2013-07-17','09:00:00',2.52),('16273','2013-07-17','09:05:00',2.59),('16273','2013-07-17','09:10:00',2.66),('16273','2013-07-17','09:15:00',2.71),('16273','2013-07-17','09:20:00',2.77),('16273','2013-07-17','09:25:00',2.82),('16273','2013-07-17','09:30:00',2.88),('16273','2013-07-17','09:35:00',2.94),('16273','2013-07-17','09:40:00',2.98),('16273','2013-07-17','09:45:00',3.04),('16273','2013-07-17','09:50:00',3.09),('16273','2013-07-17','09:55:00',3.14),('16273','2013-07-17','10:00:00',3.18),('16273','2013-07-17','10:05:00',3.22),('16273','2013-07-17','10:10:00',3.26),('16273','2013-07-17','10:15:00',3.28),('16273','2013-07-17','10:20:00',3.34),('16273','2013-07-17','10:25:00',3.39),('16273','2013-07-17','10:30:00',3.41),('16273','2013-07-17','10:35:00',3.43),('16273','2013-07-17','10:40:00',3.47),('16273','2013-07-17','10:45:00',3.49),('16273','2013-07-17','10:50:00',3.54),('16273','2013-07-17','10:55:00',3.57),('16273','2013-07-17','11:00:00',3.61),('16273','2013-07-17','11:05:00',3.63),('16273','2013-07-17','11:10:00',3.68),('16273','2013-07-17','11:15:00',3.73),('16273','2013-07-17','11:20:00',3.72),('16273','2013-07-17','11:25:00',3.73),('16273','2013-07-17','11:30:00',3.79),('16273','2013-07-17','11:35:00',3.79),('16273','2013-07-17','11:40:00',3.8),('16273','2013-07-17','11:45:00',3.75),('16273','2013-07-17','11:50:00',3.78),('16273','2013-07-17','11:55:00',3.78),('16273','2013-07-17','12:00:00',3.83),('16273','2013-07-17','12:05:00',3.84),('16273','2013-07-17','12:10:00',3.84),('16273','2013-07-17','12:15:00',3.86),('16273','2013-07-17','12:20:00',3.88),('16273','2013-07-17','12:25:00',3.84),('16273','2013-07-17','12:30:00',3.84),('16273','2013-07-17','12:35:00',3.84),('16273','2013-07-17','12:40:00',3.83),('16273','2013-07-17','12:45:00',3.82),('16273','2013-07-17','12:50:00',3.81),('16273','2013-07-17','12:55:00',3.79),('16273','2013-07-17','13:00:00',3.77),('16273','2013-07-17','13:05:00',3.78),('16273','2013-07-17','13:10:00',3.8),('16273','2013-07-17','13:15:00',3.76),('16273','2013-07-17','13:20:00',3.75),('16273','2013-07-17','13:25:00',3.72),('16273','2013-07-17','13:30:00',3.7),('16273','2013-07-17','13:35:00',3.62),('16273','2013-07-17','13:40:00',3.66),('16273','2013-07-17','13:45:00',3.63),('16273','2013-07-17','13:50:00',3.62),('16273','2013-07-17','13:55:00',3.64),('16273','2013-07-17','14:00:00',3.6),('16273','2013-07-17','14:05:00',3.56),('16273','2013-07-17','14:10:00',3.54),('16273','2013-07-17','14:15:00',3.44),('16273','2013-07-17','14:20:00',3.47),('16273','2013-07-17','14:25:00',3.46),('16273','2013-07-17','14:30:00',3.42),('16273','2013-07-17','14:35:00',3.39),('16273','2013-07-17','14:40:00',3.34),('16273','2013-07-17','14:45:00',3.33),('16273','2013-07-17','14:50:00',3.27),('16273','2013-07-17','14:55:00',3.24),('16273','2013-07-17','15:00:00',3.22),('16273','2013-07-17','15:05:00',3.22),('16273','2013-07-17','15:10:00',3.14),('16273','2013-07-17','15:15:00',3.1),('16273','2013-07-17','15:20:00',3.04),('16273','2013-07-17','15:25:00',3.03),('16273','2013-07-17','15:30:00',2.99),('16273','2013-07-17','15:35:00',3.01),('16273','2013-07-17','15:40:00',3.08),('16273','2013-07-17','15:45:00',3.12),('16273','2013-07-17','15:50:00',2.93),('16273','2013-07-17','15:55:00',2.79),('16273','2013-07-17','16:00:00',2.75),('16273','2013-07-17','16:05:00',2.7),('16273','2013-07-17','16:10:00',2.68),('16273','2013-07-17','16:15:00',2.45),('16273','2013-07-17','16:20:00',2.5),('16273','2013-07-17','16:25:00',2.3),('16273','2013-07-17','16:30:00',2.28),('16273','2013-07-17','16:35:00',2.22),('16273','2013-07-17','16:40:00',2.14),('16273','2013-07-17','16:45:00',2.1),('16273','2013-07-17','16:50:00',2.01),('16273','2013-07-17','16:55:00',1.94),('16273','2013-07-17','17:00:00',1.86),('16273','2013-07-17','17:05:00',1.78),('16273','2013-07-17','17:10:00',1.72),('16273','2013-07-17','17:15:00',1.66),('16273','2013-07-17','17:20:00',1.58),('16273','2013-07-17','17:25:00',1.51),('16273','2013-07-17','17:30:00',1.44),('16273','2013-07-17','17:35:00',1.36),('16273','2013-07-17','17:40:00',1.3),('16273','2013-07-17','17:45:00',1.23),('16273','2013-07-17','17:50:00',1.15),('16273','2013-07-17','17:55:00',1.08),('16273','2013-07-17','18:00:00',1.01),('16273','2013-07-16','07:25:00',1.06),('16273','2013-07-16','07:30:00',1.13),('16273','2013-07-16','07:35:00',1.21),('16273','2013-07-16','07:40:00',1.29),('16273','2013-07-16','07:45:00',1.38),('16273','2013-07-16','07:50:00',1.46),('16273','2013-07-16','07:55:00',1.55),('16273','2013-07-16','08:00:00',1.62),('16273','2013-07-16','08:05:00',1.7),('16273','2013-07-16','08:10:00',1.75),('16273','2013-07-16','08:15:00',1.8),('16273','2013-07-16','08:20:00',1.89),('16273','2013-07-16','08:25:00',1.97),('16273','2013-07-16','08:30:00',2.03),('16273','2013-07-16','08:35:00',2.12),('16273','2013-07-16','08:40:00',2.19),('16273','2013-07-16','08:45:00',2.25),('16273','2013-07-16','08:50:00',2.32),('16273','2013-07-16','08:55:00',2.38),('16273','2013-07-16','09:00:00',2.42),('16273','2013-07-16','09:05:00',2.5),('16273','2013-07-16','09:10:00',2.56),('16273','2013-07-16','09:15:00',2.63),('16273','2013-07-16','09:20:00',2.7),('16273','2013-07-16','09:25:00',2.77),('16273','2013-07-16','09:30:00',2.81),('16273','2013-07-16','09:35:00',2.87),('16273','2013-07-16','09:40:00',2.94),('16273','2013-07-16','09:45:00',2.99),('16273','2013-07-16','09:50:00',3.05),('16273','2013-07-16','09:55:00',3.11),('16273','2013-07-16','10:00:00',3.16),('16273','2013-07-16','10:05:00',3.2),('16273','2013-07-16','10:10:00',3.22),('16273','2013-07-16','10:15:00',3.24),('16273','2013-07-16','10:20:00',3.29),('16273','2013-07-16','10:25:00',3.34),('16273','2013-07-16','10:30:00',3.37),('16273','2013-07-16','10:35:00',3.38),('16273','2013-07-16','10:40:00',3.41),('16273','2013-07-16','10:45:00',3.45),('16273','2013-07-16','10:50:00',3.49),('16273','2013-07-16','10:55:00',3.53),('16273','2013-07-16','11:00:00',3.57),('16273','2013-07-16','11:05:00',3.6),('16273','2013-07-16','11:10:00',3.61),('16273','2013-07-16','11:15:00',3.63),('16273','2013-07-16','11:20:00',3.65),('16273','2013-07-16','11:25:00',3.65),('16273','2013-07-16','11:30:00',3.65),('16273','2013-07-16','11:35:00',3.65),('16273','2013-07-16','11:40:00',3.67),('16273','2013-07-16','11:45:00',3.69),('16273','2013-07-16','11:50:00',3.69),('16273','2013-07-16','11:55:00',3.72),('16273','2013-07-16','12:00:00',3.7),('16273','2013-07-16','12:05:00',3.73),('16273','2013-07-16','12:10:00',3.74),('16273','2013-07-16','12:15:00',3.76),('16273','2013-07-16','12:20:00',3.8),('16273','2013-07-16','12:25:00',3.83),('16273','2013-07-16','12:30:00',3.85),('16273','2013-07-16','12:35:00',3.88),('16273','2013-07-16','12:40:00',3.87),('16273','2013-07-16','12:45:00',3.87),('16273','2013-07-16','12:50:00',3.86),('16273','2013-07-16','12:55:00',3.86),('16273','2013-07-16','13:00:00',3.83),('16273','2013-07-16','13:05:00',3.8),('16273','2013-07-16','13:10:00',3.8),('16273','2013-07-16','13:15:00',3.78),('16273','2013-07-16','13:20:00',3.7),('16273','2013-07-16','13:25:00',3.78),('16273','2013-07-16','13:30:00',3.74),('16273','2013-07-16','13:35:00',3.77),('16273','2013-07-16','13:40:00',3.7),('16273','2013-07-16','13:45:00',3.68),('16273','2013-07-16','13:50:00',3.64),('16273','2013-07-16','13:55:00',3.62),('16273','2013-07-16','14:00:00',3.61),('16273','2013-07-16','14:05:00',3.63),('16273','2013-07-16','14:10:00',3.55),('16273','2013-07-16','14:15:00',3.49),('16273','2013-07-16','14:20:00',2.93),('16273','2013-07-16','14:25:00',2.79),('16273','2013-07-16','14:30:00',3.49),('16273','2013-07-16','14:35:00',3.43),('16273','2013-07-16','14:40:00',3.44),('16273','2013-07-16','14:45:00',3.43),('16273','2013-07-16','14:50:00',2.52),('16273','2013-07-16','14:55:00',1.34),('16273','2013-07-16','15:00:00',3.06),('16273','2013-07-16','15:05:00',3.3),('16273','2013-07-16','15:10:00',3.23),('16273','2013-07-16','15:15:00',3.17),('16273','2013-07-16','15:20:00',2.54),('16273','2013-07-16','15:25:00',3.08),('16273','2013-07-16','15:30:00',2.98),('16273','2013-07-16','15:35:00',2.92),('16273','2013-07-16','15:40:00',2.85),('16273','2013-07-16','15:45:00',2.79),('16273','2013-07-16','15:50:00',2.69),('16273','2013-07-16','15:55:00',2.67),('16273','2013-07-16','16:00:00',2.65),('16273','2013-07-16','16:05:00',2.61),('16273','2013-07-16','16:10:00',2.58),('16273','2013-07-16','16:15:00',2.68),('16273','2013-07-16','16:20:00',2.62),('16273','2013-07-16','16:25:00',2.45),('16273','2013-07-16','16:30:00',2.35),('16273','2013-07-16','16:35:00',2.31),('16273','2013-07-16','16:40:00',2.26),('16273','2013-07-16','16:45:00',2.15),('16273','2013-07-16','16:50:00',2.09),('16273','2013-07-16','16:55:00',2.02),('16273','2013-07-16','17:00:00',1.97),('16273','2013-07-16','17:05:00',1.82),('16273','2013-07-16','17:10:00',1.75),('16273','2013-07-16','17:15:00',1.68),('16273','2013-07-16','17:20:00',1.61),('16273','2013-07-16','17:25:00',1.55),('16273','2013-07-16','17:30:00',1.42),('16273','2013-07-16','17:35:00',1.36),('16273','2013-07-16','17:40:00',1.3),('16273','2013-07-16','17:45:00',1.27),('16273','2013-07-16','17:50:00',1.28),('16273','2013-07-16','17:55:00',1.14),('16273','2013-07-15','07:20:00',1.04),('16273','2013-07-15','07:25:00',1.12),('16273','2013-07-15','07:30:00',1.2),('16273','2013-07-15','07:35:00',1.29),('16273','2013-07-15','07:40:00',1.37),('16273','2013-07-15','07:45:00',1.44),('16273','2013-07-15','07:50:00',1.53),('16273','2013-07-15','07:55:00',1.61),('16273','2013-07-15','08:00:00',1.68),('16273','2013-07-15','08:05:00',1.76),('16273','2013-07-15','08:10:00',1.85),('16273','2013-07-15','08:15:00',1.93),('16273','2013-07-15','08:20:00',2.01),('16273','2013-07-15','08:25:00',2.09),('16273','2013-07-15','08:30:00',2.15),('16273','2013-07-15','08:35:00',2.24),('16273','2013-07-15','08:40:00',2.33),('16273','2013-07-15','08:45:00',2.41),('16273','2013-07-15','08:50:00',2.46),('16273','2013-07-15','08:55:00',2.53),('16273','2013-07-15','09:00:00',2.61),('16273','2013-07-15','09:05:00',2.66),('16273','2013-07-15','09:10:00',2.71),('16273','2013-07-15','09:15:00',2.76),('16273','2013-07-15','09:20:00',2.81),('16273','2013-07-15','09:25:00',2.86),('16273','2013-07-15','09:30:00',2.93),('16273','2013-07-15','09:35:00',2.99),('16273','2013-07-15','09:40:00',3.03),('16273','2013-07-15','09:45:00',3.08),('16273','2013-07-15','09:50:00',3.14),('16273','2013-07-15','09:55:00',3.19),('16273','2013-07-15','10:00:00',3.23),('16273','2013-07-15','10:05:00',3.27),('16273','2013-07-15','10:10:00',3.29),('16273','2013-07-15','10:15:00',3.33),('16273','2013-07-15','10:20:00',3.35),('16273','2013-07-15','10:25:00',3.38),('16273','2013-07-15','10:30:00',3.38),('16273','2013-07-15','10:35:00',3.41),('16273','2013-07-15','10:40:00',3.45),('16273','2013-07-15','10:45:00',3.48),('16273','2013-07-15','10:50:00',3.49),('16273','2013-07-15','10:55:00',3.53),('16273','2013-07-15','11:00:00',3.57),('16273','2013-07-15','11:05:00',3.61),('16273','2013-07-15','11:10:00',3.64),('16273','2013-07-15','11:15:00',3.68),('16273','2013-07-15','11:20:00',3.69),('16273','2013-07-15','11:25:00',3.7),('16273','2013-07-15','11:30:00',3.72),('16273','2013-07-15','11:35:00',3.74),('16273','2013-07-15','11:40:00',3.74),('16273','2013-07-15','11:45:00',3.75),('16273','2013-07-15','11:50:00',3.76),('16273','2013-07-15','11:55:00',3.77),('16273','2013-07-15','12:00:00',3.77),('16273','2013-07-15','12:05:00',3.8),('16273','2013-07-15','12:10:00',3.77),('16273','2013-07-15','12:15:00',3.76),('16273','2013-07-15','12:20:00',3.74),('16273','2013-07-15','12:25:00',3.77),('16273','2013-07-15','12:30:00',3.76),('16273','2013-07-15','12:35:00',3.78),('16273','2013-07-15','12:40:00',3.76),('16273','2013-07-15','12:45:00',3.74),('16273','2013-07-15','12:50:00',3.75),('16273','2013-07-15','12:55:00',3.73),('16273','2013-07-15','13:00:00',3.72),('16273','2013-07-15','13:05:00',3.74),('16273','2013-07-15','13:10:00',3.74),('16273','2013-07-15','13:15:00',3.73),('16273','2013-07-15','13:20:00',3.7),('16273','2013-07-15','13:25:00',3.71),('16273','2013-07-15','13:30:00',3.78),('16273','2013-07-15','13:35:00',3.76),('16273','2013-07-15','13:40:00',3.72),('16273','2013-07-15','13:45:00',3.73),('16273','2013-07-15','13:50:00',3.74),('16273','2013-07-15','13:55:00',3.73),('16273','2013-07-15','14:00:00',3.81),('16273','2013-07-15','14:05:00',3.79),('16273','2013-07-15','14:10:00',3.83),('16273','2013-07-15','14:15:00',3.69),('16273','2013-07-15','14:20:00',3.65),('16273','2013-07-15','14:25:00',3.62),('16273','2013-07-15','14:30:00',3.48),('16273','2013-07-15','14:35:00',3.62),('16273','2013-07-15','14:40:00',3.42),('16273','2013-07-15','14:45:00',2.92),('16273','2013-07-15','14:50:00',3.3),('16273','2013-07-15','14:55:00',2.06),('16273','2013-07-15','15:00:00',3.37),('16273','2013-07-15','15:05:00',3.42),('16273','2013-07-15','15:10:00',3.16),('16273','2013-07-15','15:15:00',1.78),('16273','2013-07-15','15:20:00',1.05),('16273','2013-07-15','15:25:00',1.53),('16273','2013-07-15','15:30:00',3.16),('16273','2013-07-15','15:35:00',3.08),('16273','2013-07-15','15:40:00',2.83),('16273','2013-07-15','15:45:00',2.86),('16273','2013-07-15','15:50:00',2.78),('16273','2013-07-15','15:55:00',2.73),('16273','2013-07-15','16:00:00',2.68),('16273','2013-07-15','16:05:00',2.62),('16273','2013-07-15','16:10:00',2.53),('16273','2013-07-15','16:15:00',2.45),('16273','2013-07-15','16:20:00',2.4),('16273','2013-07-15','16:25:00',2.37),('16273','2013-07-15','16:30:00',2.32),('16273','2013-07-15','16:35:00',2.24),('16273','2013-07-15','16:40:00',2.18),('16273','2013-07-15','16:45:00',2.11),('16273','2013-07-15','16:50:00',2.04),('16273','2013-07-15','16:55:00',1.97),('16273','2013-07-15','17:00:00',1.89),('16273','2013-07-15','17:05:00',1.81),('16273','2013-07-15','17:10:00',1.74),('16273','2013-07-15','17:15:00',1.67),('16273','2013-07-15','17:20:00',1.6),('16273','2013-07-15','17:25:00',1.53),('16273','2013-07-15','17:30:00',1.45),('16273','2013-07-15','17:35:00',1.38),('16273','2013-07-15','17:40:00',1.3),('16273','2013-07-15','17:45:00',1.24),('16273','2013-07-15','17:50:00',1.17),('16273','2013-07-15','17:55:00',1.11),('16273','2013-07-15','18:00:00',1.05),('16273','2013-07-14','07:50:00',1.05),('16273','2013-07-14','07:55:00',1.23),('16273','2013-07-14','08:00:00',1.66),('16273','2013-07-14','08:05:00',1.13),('16273','2013-07-14','08:10:00',1.21),('16273','2013-07-14','08:15:00',1.34),('16273','2013-07-14','08:20:00',2.02),('16273','2013-07-14','08:25:00',1.47),('16273','2013-07-14','08:30:00',1.73),('16273','2013-07-14','08:35:00',1),('16273','2013-07-14','08:45:00',1.02),('16273','2013-07-14','08:50:00',1.37),('16273','2013-07-14','08:55:00',1.23),('16273','2013-07-14','09:00:00',1.24),('16273','2013-07-14','09:05:00',1.28),('16273','2013-07-14','09:10:00',1.17),('16273','2013-07-14','09:20:00',1.2),('16273','2013-07-14','09:25:00',1.94),('16273','2013-07-14','09:30:00',2.22),('16273','2013-07-14','09:35:00',1.68),('16273','2013-07-14','09:40:00',1.57),('16273','2013-07-14','09:45:00',1.53),('16273','2013-07-14','09:50:00',1.47),('16273','2013-07-14','09:55:00',1.46),('16273','2013-07-14','10:00:00',1.49),('16273','2013-07-14','10:05:00',1.68),('16273','2013-07-14','10:10:00',1.63),('16273','2013-07-14','10:15:00',2.05),('16273','2013-07-14','10:20:00',2.19),('16273','2013-07-14','10:25:00',2.5),('16273','2013-07-14','10:30:00',2.07),('16273','2013-07-14','10:35:00',2.11),('16273','2013-07-14','10:40:00',2.95),('16273','2013-07-14','10:45:00',3.03),('16273','2013-07-14','10:50:00',3.32),('16273','2013-07-14','10:55:00',3.93),('16273','2013-07-14','11:00:00',3.46),('16273','2013-07-14','11:05:00',1.97),('16273','2013-07-14','11:10:00',4.29),('16273','2013-07-14','11:15:00',3.69),('16273','2013-07-14','11:20:00',3.66),('16273','2013-07-14','11:25:00',3.73),('16273','2013-07-14','11:30:00',3.38),('16273','2013-07-14','11:35:00',3.24),('16273','2013-07-14','11:40:00',3.2),('16273','2013-07-14','11:45:00',1.76),('16273','2013-07-14','11:50:00',3.76),('16273','2013-07-14','11:55:00',3.79),('16273','2013-07-14','12:00:00',4.03),('16273','2013-07-14','12:05:00',4),('16273','2013-07-14','12:10:00',3.52),('16273','2013-07-14','12:15:00',2.28),('16273','2013-07-14','12:20:00',3.2),('16273','2013-07-14','12:25:00',1.35),('16273','2013-07-14','12:30:00',3.23),('16273','2013-07-14','12:35:00',3.92),('16273','2013-07-14','12:40:00',3.55),('16273','2013-07-14','12:45:00',3.63),('16273','2013-07-14','12:50:00',4.11),('16273','2013-07-14','12:55:00',3.94),('16273','2013-07-14','13:00:00',3.89),('16273','2013-07-14','13:05:00',3.83),('16273','2013-07-14','13:10:00',3.81),('16273','2013-07-14','13:15:00',3.8),('16273','2013-07-14','13:20:00',3.82),('16273','2013-07-14','13:25:00',3.83),('16273','2013-07-14','13:30:00',3.84),('16273','2013-07-14','13:35:00',3.83),('16273','2013-07-14','13:40:00',3.8),('16273','2013-07-14','13:45:00',3.74),('16273','2013-07-14','13:50:00',3.8),('16273','2013-07-14','13:55:00',3.81),('16273','2013-07-14','14:00:00',3.8),('16273','2013-07-14','14:05:00',3.78),('16273','2013-07-14','14:10:00',3.76),('16273','2013-07-14','14:15:00',3.73),('16273','2013-07-14','14:20:00',3.71),('16273','2013-07-14','14:25:00',3.67),('16273','2013-07-14','14:30:00',3.62),('16273','2013-07-14','14:35:00',3.57),('16273','2013-07-14','14:40:00',3.51),('16273','2013-07-14','14:45:00',3.49),('16273','2013-07-14','14:50:00',3.44),('16273','2013-07-14','14:55:00',3.39),('16273','2013-07-14','15:00:00',3.3),('16273','2013-07-14','15:05:00',3.32),('16273','2013-07-14','15:10:00',3.28),('16273','2013-07-14','15:15:00',3.23),('16273','2013-07-14','15:20:00',3.16),('16273','2013-07-14','15:25:00',3.09),('16273','2013-07-14','15:30:00',3.05),('16273','2013-07-14','15:35:00',3.01),('16273','2013-07-14','15:40:00',2.98),('16273','2013-07-14','15:45:00',2.92),('16273','2013-07-14','15:50:00',2.86),('16273','2013-07-14','15:55:00',2.65),('16273','2013-07-14','16:00:00',2.53),('16273','2013-07-14','16:05:00',2.29),('16273','2013-07-14','16:10:00',1.45),('16273','2013-07-14','16:15:00',1.84),('16273','2013-07-14','16:20:00',1.95),('16273','2013-07-14','16:25:00',1.49),('16273','2013-07-14','16:30:00',1.82),('16273','2013-07-14','16:35:00',2.06),('16273','2013-07-14','16:40:00',2.34),('16273','2013-07-14','16:45:00',2.28),('16273','2013-07-14','16:50:00',2.31),('16273','2013-07-14','16:55:00',1.44),('16273','2013-07-14','17:00:00',1.17),('16273','2013-07-14','17:05:00',1.7),('16273','2013-07-14','17:15:00',1.09),('16273','2013-07-14','17:20:00',1.78),('16273','2013-07-14','17:25:00',1.75),('16273','2013-07-14','17:30:00',1.6),('16273','2013-07-14','17:35:00',1.66),('16273','2013-07-14','17:40:00',1.12),('16273','2013-07-14','17:45:00',1.03),('16273','2013-07-13','07:45:00',1.17),('16273','2013-07-13','07:50:00',1.45),('16273','2013-07-13','07:55:00',1.49),('16273','2013-07-13','08:00:00',1.57),('16273','2013-07-13','08:05:00',1.65),('16273','2013-07-13','08:10:00',1.72),('16273','2013-07-13','08:15:00',1.79),('16273','2013-07-13','08:20:00',1.87),('16273','2013-07-13','08:25:00',1.95),('16273','2013-07-13','08:30:00',2.03),('16273','2013-07-13','08:35:00',2.12),('16273','2013-07-13','08:40:00',2.21),('16273','2013-07-13','08:45:00',2.26),('16273','2013-07-13','08:50:00',2.36),('16273','2013-07-13','08:55:00',2.43),('16273','2013-07-13','09:00:00',2.49),('16273','2013-07-13','09:05:00',2.55),('16273','2013-07-13','09:10:00',2.63),('16273','2013-07-13','09:15:00',2.67),('16273','2013-07-13','09:20:00',2.7),('16273','2013-07-13','09:25:00',2.77),('16273','2013-07-13','09:30:00',2.8),('16273','2013-07-13','09:35:00',2.9),('16273','2013-07-13','09:40:00',2.96),('16273','2013-07-13','09:45:00',3.01),('16273','2013-07-13','09:50:00',3.05),('16273','2013-07-13','09:55:00',3.06),('16273','2013-07-13','10:00:00',3.05),('16273','2013-07-13','10:05:00',3.15),('16273','2013-07-13','10:10:00',3.24),('16273','2013-07-13','10:15:00',2.89),('16273','2013-07-13','10:20:00',2.7),('16273','2013-07-13','10:25:00',3.52),('16273','2013-07-13','10:30:00',3.43),('16273','2013-07-13','10:35:00',2.9),('16273','2013-07-13','10:40:00',2.42),('16273','2013-07-13','10:45:00',3.23),('16273','2013-07-13','10:50:00',2.76),('16273','2013-07-13','10:55:00',1.56),('16273','2013-07-13','11:00:00',3.73),('16273','2013-07-13','11:05:00',2.14),('16273','2013-07-13','11:10:00',3.77),('16273','2013-07-13','11:15:00',3.82),('16273','2013-07-13','11:20:00',3.34),('16273','2013-07-13','11:25:00',3.82),('16273','2013-07-13','11:30:00',3.71),('16273','2013-07-13','11:35:00',3.85),('16273','2013-07-13','11:40:00',3.79),('16273','2013-07-13','11:45:00',3.79),('16273','2013-07-13','11:50:00',3.92),('16273','2013-07-13','11:55:00',3.76),('16273','2013-07-13','12:00:00',2.64),('16273','2013-07-13','12:05:00',3.57),('16273','2013-07-13','12:10:00',3.66),('16273','2013-07-13','12:15:00',3.95),('16273','2013-07-13','12:20:00',3.91),('16273','2013-07-13','12:25:00',3.97),('16273','2013-07-13','12:30:00',3.99),('16273','2013-07-13','12:35:00',3.49),('16273','2013-07-13','12:40:00',3.22),('16273','2013-07-13','12:45:00',4.1),('16273','2013-07-13','12:50:00',4.03),('16273','2013-07-13','12:55:00',3.64),('16273','2013-07-13','13:00:00',3.89),('16273','2013-07-13','13:05:00',3.89),('16273','2013-07-13','13:10:00',3.88),('16273','2013-07-13','13:15:00',3.86),('16273','2013-07-13','13:20:00',3.87),('16273','2013-07-13','13:25:00',3.85),('16273','2013-07-13','13:30:00',3.83),('16273','2013-07-13','13:35:00',3.83),('16273','2013-07-13','13:40:00',3.83),('16273','2013-07-13','13:45:00',3.78),('16273','2013-07-13','13:50:00',3.75),('16273','2013-07-13','13:55:00',3.77),('16273','2013-07-13','14:00:00',3.72),('16273','2013-07-13','14:05:00',3.74),('16273','2013-07-13','14:10:00',3.72),('16273','2013-07-13','14:15:00',3.68),('16273','2013-07-13','14:20:00',3.64),('16273','2013-07-13','14:25:00',3.62),('16273','2013-07-13','14:30:00',3.56),('16273','2013-07-13','14:35:00',3.57),('16273','2013-07-13','14:40:00',3.56),('16273','2013-07-13','14:45:00',3.48),('16273','2013-07-13','14:50:00',3.49),('16273','2013-07-13','14:55:00',3.45),('16273','2013-07-13','15:00:00',3.34),('16273','2013-07-13','15:05:00',3.37),('16273','2013-07-13','15:10:00',3.32),('16273','2013-07-13','15:15:00',3.25),('16273','2013-07-13','15:20:00',3.14),('16273','2013-07-13','15:25:00',3.19),('16273','2013-07-13','15:30:00',2.96),('16273','2013-07-13','15:35:00',3.09),('16273','2013-07-13','15:40:00',3.02),('16273','2013-07-13','15:45:00',2.97),('16273','2013-07-13','15:50:00',2.9),('16273','2013-07-13','15:55:00',2.87),('16273','2013-07-13','16:00:00',2.79),('16273','2013-07-13','16:05:00',2.73),('16273','2013-07-13','16:10:00',2.64),('16273','2013-07-13','16:15:00',2.56),('16273','2013-07-13','16:20:00',2.53),('16273','2013-07-13','16:25:00',2.47),('16273','2013-07-13','16:30:00',2.39),('16273','2013-07-13','16:35:00',2.34),('16273','2013-07-13','16:40:00',2.27),('16273','2013-07-13','16:45:00',2.18),('16273','2013-07-13','16:50:00',2.12),('16273','2013-07-13','16:55:00',2.02),('16273','2013-07-13','17:00:00',1.97),('16273','2013-07-13','17:05:00',1.83),('16273','2013-07-13','17:10:00',1.82),('16273','2013-07-13','17:15:00',1.72),('16273','2013-07-13','17:20:00',1.66),('16273','2013-07-13','17:25:00',1.6),('16273','2013-07-13','17:30:00',1.49),('16273','2013-07-13','17:35:00',1.45),('16273','2013-07-13','17:40:00',1.37),('16273','2013-07-13','17:45:00',1.32),('16273','2013-07-13','17:50:00',1.26),('16273','2013-07-13','17:55:00',1.19),('16273','2013-07-13','18:00:00',1.06),('16273','2013-07-13','18:05:00',1.04),('16273','2013-07-12','08:00:00',1.25),('16273','2013-07-12','08:05:00',1.78),('16273','2013-07-12','08:10:00',1.87),('16273','2013-07-12','08:15:00',1.49),('16273','2013-07-12','08:20:00',1.37),('16273','2013-07-12','08:25:00',1.96),('16273','2013-07-12','08:30:00',1.05),('16273','2013-07-12','08:55:00',1.01),('16273','2013-07-12','09:00:00',1.89),('16273','2013-07-12','09:05:00',2.07),('16273','2013-07-12','09:10:00',1.42),('16273','2013-07-12','09:15:00',1.38),('16273','2013-07-12','09:20:00',2.39),('16273','2013-07-12','09:25:00',2.23),('16273','2013-07-12','09:30:00',2.49),('16273','2013-07-12','09:35:00',2.57),('16273','2013-07-12','09:40:00',2.42),('16273','2013-07-12','09:45:00',1.94),('16273','2013-07-12','09:50:00',1.66),('16273','2013-07-12','09:55:00',1.88),('16273','2013-07-12','10:00:00',2.31),('16273','2013-07-12','10:05:00',3.08),('16273','2013-07-12','10:10:00',2.87),('16273','2013-07-12','10:15:00',3.35),('16273','2013-07-12','10:20:00',3.33),('16273','2013-07-12','10:25:00',3.56),('16273','2013-07-12','10:30:00',2.73),('16273','2013-07-12','10:35:00',1.05),('16273','2013-07-12','10:40:00',1.43),('16273','2013-07-12','10:45:00',3.36),('16273','2013-07-12','10:50:00',3.21),('16273','2013-07-12','10:55:00',1.12),('16273','2013-07-12','11:00:00',1.11),('16273','2013-07-12','11:05:00',1.17),('16273','2013-07-12','11:10:00',2.37),('16273','2013-07-12','11:15:00',1.59),('16273','2013-07-12','11:20:00',2.2),('16273','2013-07-12','11:25:00',2.74),('16273','2013-07-12','11:30:00',3.63),('16273','2013-07-12','11:35:00',3.04),('16273','2013-07-12','11:40:00',1.62),('16273','2013-07-12','11:45:00',3.6),('16273','2013-07-12','11:50:00',3.82),('16273','2013-07-12','11:55:00',3.97),('16273','2013-07-12','12:00:00',2.5),('16273','2013-07-12','12:05:00',3.94),('16273','2013-07-12','12:10:00',2.95),('16273','2013-07-12','12:15:00',4.16),('16273','2013-07-12','12:20:00',4.27),('16273','2013-07-12','12:25:00',4.03),('16273','2013-07-12','12:30:00',4.18),('16273','2013-07-12','12:35:00',3.62),('16273','2013-07-12','12:40:00',3.14),('16273','2013-07-12','12:45:00',3.76),('16273','2013-07-12','12:50:00',4.16),('16273','2013-07-12','12:55:00',4.19),('16273','2013-07-12','13:00:00',4),('16273','2013-07-12','13:05:00',3.05),('16273','2013-07-12','13:10:00',3.49),('16273','2013-07-12','13:15:00',3.6),('16273','2013-07-12','13:20:00',3.65),('16273','2013-07-12','13:25:00',3.1),('16273','2013-07-12','13:30:00',3.8),('16273','2013-07-12','13:35:00',3.93),('16273','2013-07-12','13:40:00',3.5),('16273','2013-07-12','13:45:00',4.07),('16273','2013-07-12','13:50:00',2.54),('16273','2013-07-12','13:55:00',3.58),('16273','2013-07-12','14:00:00',3.59),('16273','2013-07-12','14:05:00',3.33),('16273','2013-07-12','14:10:00',3.74),('16273','2013-07-12','14:15:00',4.09),('16273','2013-07-12','14:20:00',3.09),('16273','2013-07-12','14:25:00',3.85),('16273','2013-07-12','14:30:00',3.18),('16273','2013-07-12','14:35:00',3.57),('16273','2013-07-12','14:40:00',3.47),('16273','2013-07-12','14:45:00',3.42),('16273','2013-07-12','14:50:00',3.33),('16273','2013-07-12','14:55:00',3.26),('16273','2013-07-12','15:00:00',3.3),('16273','2013-07-12','15:05:00',3.24),('16273','2013-07-12','15:10:00',3.19),('16273','2013-07-12','15:15:00',3.08),('16273','2013-07-12','15:20:00',2.7),('16273','2013-07-12','15:25:00',3.13),('16273','2013-07-12','15:30:00',3.14),('16273','2013-07-12','15:35:00',3.04),('16273','2013-07-12','15:40:00',2.82),('16273','2013-07-12','15:45:00',2.81),('16273','2013-07-12','15:50:00',2.76),('16273','2013-07-12','15:55:00',2.74),('16273','2013-07-12','16:00:00',2.68),('16273','2013-07-12','16:05:00',2.65),('16273','2013-07-12','16:10:00',2.58),('16273','2013-07-12','16:15:00',2.53),('16273','2013-07-12','16:20:00',2.47),('16273','2013-07-12','16:25:00',2.41),('16273','2013-07-12','16:30:00',2.35),('16273','2013-07-12','16:35:00',2.29),('16273','2013-07-12','16:40:00',2.21),('16273','2013-07-12','16:45:00',2.14),('16273','2013-07-12','16:50:00',2.07),('16273','2013-07-12','16:55:00',1.98),('16273','2013-07-12','17:00:00',1.89),('16273','2013-07-12','17:05:00',1.84),('16273','2013-07-12','17:10:00',1.77),('16273','2013-07-12','17:15:00',1.7),('16273','2013-07-12','17:20:00',1.61),('16273','2013-07-12','17:25:00',1.56),('16273','2013-07-12','17:30:00',1.47),('16273','2013-07-12','17:35:00',1.41),('16273','2013-07-12','17:40:00',1.34),('16273','2013-07-12','17:45:00',1.26),('16273','2013-07-12','17:50:00',1.11),('16273','2013-07-12','17:55:00',1.05),('16273','2013-07-12','18:00:00',1.07),('16273','2013-07-12','18:05:00',1.02),('16273','2013-07-11','07:25:00',1.06),('16273','2013-07-11','07:30:00',1.13),('16273','2013-07-11','07:35:00',1.16),('16273','2013-07-11','07:40:00',1.22),('16273','2013-07-11','07:45:00',1.33),('16273','2013-07-11','07:50:00',1.43),('16273','2013-07-11','07:55:00',1.51),('16273','2013-07-11','08:00:00',1.6),('16273','2013-07-11','08:05:00',1.67),('16273','2013-07-11','08:10:00',1.72),('16273','2013-07-11','08:15:00',1.79),('16273','2013-07-11','08:20:00',1.89),('16273','2013-07-11','08:25:00',1.96),('16273','2013-07-11','08:30:00',2.05),('16273','2013-07-11','08:35:00',2.13),('16273','2013-07-11','08:40:00',2.17),('16273','2013-07-11','08:45:00',2.33),('16273','2013-07-11','08:50:00',2.32),('16273','2013-07-11','08:55:00',2.42),('16273','2013-07-11','09:00:00',2.47),('16273','2013-07-11','09:05:00',2.56),('16273','2013-07-11','09:10:00',2.65),('16273','2013-07-11','09:15:00',2.47),('16273','2013-07-11','09:20:00',2.69),('16273','2013-07-11','09:25:00',2.39),('16273','2013-07-11','09:30:00',2.91),('16273','2013-07-11','09:35:00',2.11),('16273','2013-07-11','09:40:00',3.13),('16273','2013-07-11','09:45:00',2.96),('16273','2013-07-11','09:50:00',2.92),('16273','2013-07-11','09:55:00',1.44),('16273','2013-07-11','10:00:00',1.22),('16273','2013-07-11','10:05:00',3.05),('16273','2013-07-11','10:10:00',3.34),('16273','2013-07-11','10:15:00',2.17),('16273','2013-07-11','10:20:00',1.23),('16273','2013-07-11','10:25:00',1.65),('16273','2013-07-11','10:30:00',3.47),('16273','2013-07-11','10:35:00',3.66),('16273','2013-07-11','10:40:00',3.27),('16273','2013-07-11','10:45:00',2.9),('16273','2013-07-11','10:50:00',3.38),('16273','2013-07-11','10:55:00',4.03),('16273','2013-07-11','11:00:00',2.09),('16273','2013-07-11','11:05:00',2.91),('16273','2013-07-11','11:10:00',4.07),('16273','2013-07-11','11:15:00',2.6),('16273','2013-07-11','11:20:00',1.96),('16273','2013-07-11','11:25:00',1.28),('16273','2013-07-11','11:30:00',2.06),('16273','2013-07-11','11:35:00',4.02),('16273','2013-07-11','11:40:00',4.33),('16273','2013-07-11','11:45:00',1.86),('16273','2013-07-11','11:50:00',4.22),('16273','2013-07-11','11:55:00',4.23),('16273','2013-07-11','12:00:00',4.05),('16273','2013-07-11','12:05:00',4.11),('16273','2013-07-11','12:10:00',4.07),('16273','2013-07-11','12:15:00',3.29),('16273','2013-07-11','12:20:00',3.14),('16273','2013-07-11','12:25:00',4.01),('16273','2013-07-11','12:30:00',4.03),('16273','2013-07-11','12:35:00',3.65),('16273','2013-07-11','12:40:00',3.99),('16273','2013-07-11','12:45:00',3.89),('16273','2013-07-11','12:50:00',3.89),('16273','2013-07-11','12:55:00',3.95),('16273','2013-07-11','13:00:00',3.57),('16273','2013-07-11','13:05:00',3.68),('16273','2013-07-11','13:10:00',3.97),('16273','2013-07-11','13:15:00',4.02),('16273','2013-07-11','13:20:00',3.99),('16273','2013-07-11','13:25:00',3.92),('16273','2013-07-11','13:30:00',3.89),('16273','2013-07-11','13:35:00',3.86),('16273','2013-07-11','13:40:00',3.84),('16273','2013-07-11','13:45:00',3.8),('16273','2013-07-11','13:50:00',3.74),('16273','2013-07-11','13:55:00',3.78),('16273','2013-07-11','14:00:00',3.75),('16273','2013-07-11','14:05:00',3.77),('16273','2013-07-11','14:10:00',3.22),('16273','2013-07-11','14:15:00',3.58),('16273','2013-07-11','14:20:00',3.67),('16273','2013-07-11','14:25:00',3.69),('16273','2013-07-11','14:30:00',3.59),('16273','2013-07-11','14:35:00',3.53),('16273','2013-07-11','14:40:00',3.55),('16273','2013-07-11','14:45:00',3.25),('16273','2013-07-11','14:50:00',3.5),('16273','2013-07-11','14:55:00',3.46),('16273','2013-07-11','15:00:00',3.27),('16273','2013-07-11','15:05:00',3.38),('16273','2013-07-11','15:10:00',3.35),('16273','2013-07-11','15:15:00',3.3),('16273','2013-07-11','15:20:00',3.2),('16273','2013-07-11','15:25:00',3.18),('16273','2013-07-11','15:30:00',3.13),('16273','2013-07-11','15:35:00',2.74),('16273','2013-07-11','15:40:00',3.05),('16273','2013-07-11','15:45:00',3.1),('16273','2013-07-11','15:50:00',2.93),('16273','2013-07-11','15:55:00',2.85),('16273','2013-07-11','16:00:00',2.9),('16273','2013-07-11','16:05:00',2.79),('16273','2013-07-11','16:10:00',2.74),('16273','2013-07-11','16:15:00',2.73),('16273','2013-07-11','16:20:00',1.68),('16273','2013-07-11','16:25:00',2.61),('16273','2013-07-11','16:30:00',2.4),('16273','2013-07-11','16:35:00',1.97),('16273','2013-07-11','16:40:00',2.34),('16273','2013-07-11','16:45:00',1.93),('16273','2013-07-11','16:50:00',1.85),('16273','2013-07-11','16:55:00',2.24),('16273','2013-07-11','17:00:00',1.94),('16273','2013-07-11','17:05:00',1.95),('16273','2013-07-11','17:10:00',1.88),('16273','2013-07-11','17:15:00',1.71),('16273','2013-07-11','17:20:00',1.13),('16273','2013-07-11','17:25:00',1.76),('16273','2013-07-11','17:30:00',1.32),('16273','2013-07-11','17:35:00',1.26),('16273','2013-07-11','17:40:00',1.05),('16273','2013-07-11','17:50:00',1.36),('16273','2013-07-11','18:00:00',1.09),('16273','2013-07-11','18:05:00',1.16),('16273','2013-07-11','18:15:00',1.05),('16273','2014-05-03','07:25:00',1.05),('16273','2014-05-03','07:30:00',1.11),('16273','2014-05-03','07:35:00',1.47),('16273','2014-05-03','07:40:00',1.49),('16273','2014-05-03','07:45:00',1.57),('16273','2014-05-03','07:50:00',1.66),('16273','2014-05-03','07:55:00',1.79),('16273','2014-05-03','08:00:00',1.44),('16273','2014-05-03','08:20:00',1.81),('16273','2014-05-03','08:25:00',2.47),('16273','2014-05-03','08:30:00',2.66),('16273','2014-05-03','08:35:00',2.79),('16273','2014-05-03','08:40:00',3.1),('16273','2014-05-03','08:45:00',2.55),('16273','2014-05-03','08:50:00',2.4),('16273','2014-05-03','08:55:00',2.27),('16273','2014-05-03','09:00:00',1.71),('16273','2014-05-03','09:05:00',1.49),('16273','2014-05-03','09:10:00',1.46),('16273','2014-05-03','09:15:00',2.38),('16273','2014-05-03','09:20:00',3.95),('16273','2014-05-03','09:25:00',3.59),('16273','2014-05-03','09:30:00',3.35),('16273','2014-05-03','09:35:00',1.27),('16273','2014-05-03','09:40:00',1.16),('16273','2014-05-03','09:45:00',1.31),('16273','2014-05-03','09:50:00',1.52),('16273','2014-05-03','09:55:00',1.95),('16273','2014-05-03','10:00:00',2.77),('16273','2014-05-03','10:05:00',3.65),('16273','2014-05-03','10:10:00',1.32),('16273','2014-05-03','10:15:00',1.27),('16273','2014-05-03','10:20:00',1.74),('16273','2014-05-03','10:25:00',1.45),('16273','2014-05-03','10:30:00',2.21),('16273','2014-05-03','10:35:00',4.52),('16273','2014-05-03','10:40:00',3.73),('16273','2014-05-03','10:45:00',1.8),('16273','2014-05-03','10:50:00',3.22),('16273','2014-05-03','10:55:00',2.29),('16273','2014-05-03','11:00:00',1.21),('16273','2014-05-03','11:05:00',1.34),('16273','2014-05-03','11:10:00',1.38),('16273','2014-05-03','11:40:00',1.95),('16273','2014-05-03','11:45:00',1.92),('16273','2014-05-03','11:50:00',1.68),('16273','2014-05-03','11:55:00',2.68),('16273','2014-05-03','12:00:00',2.43),('16273','2014-05-03','12:05:00',1.57),('16273','2014-05-03','12:10:00',1.44),('16273','2014-05-03','12:15:00',1.45),('16273','2014-05-03','12:20:00',1.3),('16273','2014-05-03','12:25:00',1.19),('16273','2014-05-03','12:30:00',1.14),('16273','2014-05-03','12:35:00',1.39),('16273','2014-05-03','12:40:00',1.6),('16273','2014-05-03','12:45:00',1.56),('16273','2014-05-03','12:50:00',1.33),('16273','2014-05-03','12:55:00',1.53),('16273','2014-05-03','13:00:00',1.85),('16273','2014-05-03','13:05:00',1.7),('16273','2014-05-03','13:10:00',1.54),('16273','2014-05-03','13:15:00',1.46),('16273','2014-05-03','13:20:00',1.45),('16273','2014-05-03','13:25:00',1.45),('16273','2014-05-03','13:30:00',1.38),('16273','2014-05-03','13:35:00',1.47),('16273','2014-05-03','13:40:00',1.62),('16273','2014-05-03','13:45:00',1.71),('16273','2014-05-03','13:50:00',1.74),('16273','2014-05-03','13:55:00',1.96),('16273','2014-05-03','14:00:00',2.1),('16273','2014-05-03','14:05:00',2.01),('16273','2014-05-03','14:10:00',2.16),('16273','2014-05-03','14:15:00',2.1),('16273','2014-05-03','14:20:00',2.2),('16273','2014-05-03','14:25:00',2.04),('16273','2014-05-03','14:30:00',1.63),('16273','2014-05-03','14:35:00',1.06),('16273','2014-05-03','17:40:00',1.08),('16273','2014-04-06','08:15:00',1.56),('16273','2014-04-06','08:20:00',1.65),('16273','2014-04-06','08:25:00',1.74),('16273','2014-04-06','08:30:00',1.82),('16273','2014-04-06','08:35:00',1.92),('16273','2014-04-06','08:40:00',2.01),('16273','2014-04-06','08:45:00',2.09),('16273','2014-04-06','08:50:00',2.18),('16273','2014-04-06','08:55:00',2.26),('16273','2014-04-06','09:00:00',2.35),('16273','2014-04-06','09:05:00',2.43),('16273','2014-04-06','09:10:00',2.55),('16273','2014-04-06','09:15:00',2.63),('16273','2014-04-06','09:20:00',1.94),('16273','2014-04-06','09:35:00',1.79),('16273','2014-04-06','09:40:00',1.9),('16273','2014-04-06','09:45:00',1.54),('16273','2014-04-06','09:50:00',1.7),('16273','2014-04-06','09:55:00',1.62),('16273','2014-04-06','10:00:00',2.39),('16273','2014-04-06','10:05:00',3.09),('16273','2014-04-06','10:10:00',3.45),('16273','2014-04-06','10:15:00',3.78),('16273','2014-04-06','10:20:00',3.58),('16273','2014-04-06','10:25:00',2.56),('16273','2014-04-06','10:30:00',3.02),('16273','2014-04-06','10:35:00',1.66),('16273','2014-04-06','10:40:00',1.48),('16273','2014-04-06','10:45:00',1.47),('16273','2014-04-06','10:50:00',1.76),('16273','2014-04-06','10:55:00',1.82),('16273','2014-04-06','11:00:00',3.28),('16273','2014-04-06','11:05:00',3.98),('16273','2014-04-06','11:10:00',3.93),('16273','2014-04-06','11:15:00',3.86),('16273','2014-04-06','11:20:00',3.95),('16273','2014-04-06','11:25:00',3.55),('16273','2014-04-06','11:30:00',4.02),('16273','2014-04-06','11:35:00',3.94),('16273','2014-04-06','11:40:00',3.88),('16273','2014-04-06','11:45:00',3.84),('16273','2014-04-06','11:50:00',3.91),('16273','2014-04-06','11:55:00',3.88),('16273','2014-04-06','12:00:00',3.88),('16273','2014-04-06','12:05:00',3.87),('16273','2014-04-06','12:10:00',3.49),('16273','2014-04-06','12:15:00',3.71),('16273','2014-04-06','12:20:00',3.73),('16273','2014-04-06','12:25:00',3.9),('16273','2014-04-06','12:30:00',3.96),('16273','2014-04-06','12:35:00',3.25),('16273','2014-04-06','12:40:00',3.24),('16273','2014-04-06','12:45:00',3.87),('16273','2014-04-06','12:50:00',3.97),('16273','2014-04-06','12:55:00',2.98),('16273','2014-04-06','13:00:00',3.9),('16273','2014-04-06','13:05:00',3.61),('16273','2014-04-06','13:10:00',3.91),('16273','2014-04-06','13:15:00',4.01),('16273','2014-04-06','13:20:00',3.94),('16273','2014-04-06','13:25:00',3.82),('16273','2014-04-06','13:30:00',3.75),('16273','2014-04-06','13:35:00',3.76),('16273','2014-04-06','13:40:00',3.72),('16273','2014-04-06','13:45:00',3.67),('16273','2014-04-06','13:50:00',3.76),('16273','2014-04-06','13:55:00',1.43),('16273','2014-04-06','14:00:00',3.36),('16273','2014-04-06','14:05:00',3.06),('16273','2014-04-06','14:10:00',3.42),('16273','2014-04-06','14:15:00',3.71),('16273','2014-04-06','14:20:00',3.58),('16273','2014-04-06','14:25:00',3.27),('16273','2014-04-06','14:30:00',3.29),('16273','2014-04-06','14:35:00',1.83),('16273','2014-04-06','14:40:00',3.42),('16273','2014-04-06','14:45:00',2.18),('16273','2014-04-06','14:50:00',2.49),('16273','2014-04-06','14:55:00',3.69),('16273','2014-04-06','15:00:00',3.29),('16273','2014-04-06','15:05:00',2.27),('16273','2014-04-06','16:10:00',2.22),('16273','2014-04-06','16:15:00',1.5),('16273','2014-04-06','16:50:00',1.85),('16273','2014-04-06','16:55:00',2.08),('16273','2014-04-06','17:00:00',2.07),('16273','2014-04-06','17:05:00',1.37),('16273','2014-04-06','17:30:00',1.18),('16273','2014-04-06','17:35:00',1.14),('16273','2014-04-06','17:40:00',1.04),('16273','2013-07-10','07:15:00',1.1),('16273','2013-07-10','07:20:00',1.24),('16273','2013-07-10','07:25:00',1.34),('16273','2013-07-10','07:30:00',1.45),('16273','2013-07-10','07:35:00',1.6),('16273','2013-07-10','07:40:00',1.45),('16273','2013-07-10','07:45:00',1.25),('16273','2013-07-10','07:50:00',1.03),('16273','2013-07-10','08:10:00',1.06),('16273','2013-07-10','08:15:00',1.23),('16273','2013-07-10','08:20:00',1.91),('16273','2013-07-10','08:25:00',2.39),('16273','2013-07-10','08:30:00',2.34),('16273','2013-07-10','08:35:00',2.54),('16273','2013-07-10','08:40:00',2.22),('16273','2013-07-10','08:45:00',1.71),('16273','2013-07-10','08:50:00',1.97),('16273','2013-07-10','08:55:00',2.68),('16273','2013-07-10','09:00:00',2.65),('16273','2013-07-10','09:05:00',2.73),('16273','2013-07-10','09:10:00',2.76),('16273','2013-07-10','09:15:00',2.8),('16273','2013-07-10','09:20:00',2.63),('16273','2013-07-10','09:25:00',2.88),('16273','2013-07-10','09:30:00',2.94),('16273','2013-07-10','09:35:00',3),('16273','2013-07-10','09:40:00',3.04),('16273','2013-07-10','09:45:00',3.1),('16273','2013-07-10','09:50:00',3.13),('16273','2013-07-10','09:55:00',3.14),('16273','2013-07-10','10:00:00',3.14),('16273','2013-07-10','10:05:00',3.18),('16273','2013-07-10','10:10:00',3.24),('16273','2013-07-10','10:15:00',3.3),('16273','2013-07-10','10:20:00',3.32),('16273','2013-07-10','10:25:00',3.35),('16273','2013-07-10','10:30:00',3.38),('16273','2013-07-10','10:35:00',3.43),('16273','2013-07-10','10:40:00',3.46),('16273','2013-07-10','10:45:00',3.47),('16273','2013-07-10','10:50:00',3.5),('16273','2013-07-10','10:55:00',3.55),('16273','2013-07-10','11:00:00',3.58),('16273','2013-07-10','11:05:00',3.6),('16273','2013-07-10','11:10:00',3.6),('16273','2013-07-10','11:15:00',3.61),('16273','2013-07-10','11:20:00',3.62),('16273','2013-07-10','11:25:00',3.64),('16273','2013-07-10','11:30:00',3.61),('16273','2013-07-10','11:35:00',3.69),('16273','2013-07-10','11:40:00',3.71),('16273','2013-07-10','11:45:00',3.69),('16273','2013-07-10','11:50:00',3.74),('16273','2013-07-10','11:55:00',3.72),('16273','2013-07-10','12:00:00',3.78),('16273','2013-07-10','12:05:00',3.83),('16273','2013-07-10','12:10:00',3.84),('16273','2013-07-10','12:15:00',3.85),('16273','2013-07-10','12:20:00',3.85),('16273','2013-07-10','12:25:00',3.82),('16273','2013-07-10','12:30:00',3.87),('16273','2013-07-10','12:35:00',3.88),('16273','2013-07-10','12:40:00',3.88),('16273','2013-07-10','12:45:00',3.87),('16273','2013-07-10','12:50:00',3.88),('16273','2013-07-10','12:55:00',3.81),('16273','2013-07-10','13:00:00',3.87),('16273','2013-07-10','13:05:00',3.86),('16273','2013-07-10','13:10:00',3.85),('16273','2013-07-10','13:15:00',3.85),('16273','2013-07-10','13:20:00',3.85),('16273','2013-07-10','13:25:00',3.86),('16273','2013-07-10','13:30:00',3.83),('16273','2013-07-10','13:35:00',3.85),('16273','2013-07-10','13:40:00',3.84),('16273','2013-07-10','13:45:00',3.82),('16273','2013-07-10','13:50:00',3.81),('16273','2013-07-10','13:55:00',3.79),('16273','2013-07-10','14:00:00',3.76),('16273','2013-07-10','14:05:00',3.73),('16273','2013-07-10','14:10:00',3.71),('16273','2013-07-10','14:15:00',3.67),('16273','2013-07-10','14:20:00',3.65),('16273','2013-07-10','14:25:00',3.6),('16273','2013-07-10','14:30:00',3.58),('16273','2013-07-10','14:35:00',3.54),('16273','2013-07-10','14:40:00',3.5),('16273','2013-07-10','14:45:00',3.47),('16273','2013-07-10','14:50:00',3.43),('16273','2013-07-10','14:55:00',3.4),('16273','2013-07-10','15:00:00',3.37),('16273','2013-07-10','15:05:00',3.33),('16273','2013-07-10','15:10:00',3.31),('16273','2013-07-10','15:15:00',3.26),('16273','2013-07-10','15:20:00',3.22),('16273','2013-07-10','15:25:00',3.17),('16273','2013-07-10','15:30:00',3.12),('16273','2013-07-10','15:35:00',3.06),('16273','2013-07-10','15:40:00',3),('16273','2013-07-10','15:45:00',2.94),('16273','2013-07-10','15:50:00',2.88),('16273','2013-07-10','15:55:00',2.84),('16273','2013-07-10','16:00:00',2.74),('16273','2013-07-10','16:05:00',2.71),('16273','2013-07-10','16:10:00',2.66),('16273','2013-07-10','16:15:00',2.58),('16273','2013-07-10','16:20:00',2.53),('16273','2013-07-10','16:25:00',2.46),('16273','2013-07-10','16:30:00',2.37),('16273','2013-07-10','16:35:00',2.32),('16273','2013-07-10','16:40:00',2.26),('16273','2013-07-10','16:45:00',2.2),('16273','2013-07-10','16:50:00',2.15),('16273','2013-07-10','16:55:00',2.11),('16273','2013-07-10','17:00:00',2.15),('16273','2013-07-10','17:05:00',2.27),('16273','2013-07-10','17:10:00',2.29),('16273','2013-07-10','17:15:00',2.12),('16273','2013-07-10','17:20:00',2.09),('16273','2013-07-10','17:25:00',2),('16273','2013-07-10','17:30:00',1.76),('16273','2013-07-10','17:35:00',1.73),('16273','2013-07-10','17:40:00',1.55),('16273','2013-07-10','17:45:00',1.42),('16273','2013-07-10','17:50:00',1.32),('16273','2013-07-10','17:55:00',1.25),('16273','2013-07-10','18:00:00',1.14),('16273','2013-07-09','07:20:00',1),('16273','2013-07-09','07:25:00',1.09),('16273','2013-07-09','07:30:00',1.2),('16273','2013-07-09','07:35:00',1.32),('16273','2013-07-09','07:40:00',1.45),('16273','2013-07-09','07:45:00',1.56),('16273','2013-07-09','07:50:00',1.64),('16273','2013-07-09','07:55:00',1.7),('16273','2013-07-09','08:00:00',1.78),('16273','2013-07-09','08:05:00',1.8),('16273','2013-07-09','08:10:00',1.83),('16273','2013-07-09','08:15:00',1.91),('16273','2013-07-09','08:20:00',1.99),('16273','2013-07-09','08:25:00',2.07),('16273','2013-07-09','08:30:00',2.13),('16273','2013-07-09','08:35:00',2.19),('16273','2013-07-09','08:40:00',2.27),('16273','2013-07-09','08:45:00',2.33),('16273','2013-07-09','08:50:00',2.4),('16273','2013-07-09','08:55:00',2.45),('16273','2013-07-09','09:00:00',2.51),('16273','2013-07-09','09:05:00',2.54),('16273','2013-07-09','09:10:00',2.64),('16273','2013-07-09','09:15:00',2.71),('16273','2013-07-09','09:20:00',2.76),('16273','2013-07-09','09:25:00',2.78),('16273','2013-07-09','09:30:00',2.85),('16273','2013-07-09','09:35:00',2.89),('16273','2013-07-09','09:40:00',2.95),('16273','2013-07-09','09:45:00',3.01),('16273','2013-07-09','09:50:00',3.06),('16273','2013-07-09','09:55:00',3.1),('16273','2013-07-09','10:00:00',3.13),('16273','2013-07-09','10:05:00',3.19),('16273','2013-07-09','10:10:00',3.21),('16273','2013-07-09','10:15:00',3.26),('16273','2013-07-09','10:20:00',3.31),('16273','2013-07-09','10:25:00',3.34),('16273','2013-07-09','10:30:00',3.35),('16273','2013-07-09','10:35:00',3.38),('16273','2013-07-09','10:40:00',3.43),('16273','2013-07-09','10:45:00',3.47),('16273','2013-07-09','10:50:00',3.48),('16273','2013-07-09','10:55:00',3.51),('16273','2013-07-09','11:00:00',3.54),('16273','2013-07-09','11:05:00',3.58),('16273','2013-07-09','11:10:00',3.62),('16273','2013-07-09','11:15:00',3.63),('16273','2013-07-09','11:20:00',3.64),('16273','2013-07-09','11:25:00',3.64),('16273','2013-07-09','11:30:00',3.71),('16273','2013-07-09','11:35:00',3.72),('16273','2013-07-09','11:40:00',3.76),('16273','2013-07-09','11:45:00',3.78),('16273','2013-07-09','11:50:00',3.76),('16273','2013-07-09','11:55:00',3.72),('16273','2013-07-09','12:00:00',3.63),('16273','2013-07-09','12:05:00',3.74),('16273','2013-07-09','12:10:00',3.76),('16273','2013-07-09','12:15:00',3.79),('16273','2013-07-09','12:20:00',3.74),('16273','2013-07-09','12:25:00',3.75),('16273','2013-07-09','12:30:00',3.77),('16273','2013-07-09','12:35:00',3.75),('16273','2013-07-09','12:40:00',3.77),('16273','2013-07-09','12:45:00',3.89),('16273','2013-07-09','12:50:00',4.01),('16273','2013-07-09','12:55:00',3.98),('16273','2013-07-09','13:00:00',3.87),('16273','2013-07-09','13:05:00',3.8),('16273','2013-07-09','13:10:00',3.85),('16273','2013-07-09','13:15:00',3.86),('16273','2013-07-09','13:20:00',3.86),('16273','2013-07-09','13:25:00',3.9),('16273','2013-07-09','13:30:00',3.87),('16273','2013-07-09','13:35:00',3.9),('16273','2013-07-09','13:40:00',3.87),('16273','2013-07-09','13:45:00',3.8),('16273','2013-07-09','13:50:00',3.3),('16273','2013-07-09','13:55:00',3.81),('16273','2013-07-09','14:00:00',3.83),('16273','2013-07-09','14:05:00',2.95),('16273','2013-07-09','14:10:00',3.26),('16273','2013-07-09','14:15:00',3.61),('16273','2013-07-09','14:20:00',3.84),('16273','2013-07-09','14:25:00',3.91),('16273','2013-07-09','14:30:00',1.85),('16273','2013-07-09','14:35:00',1.03),('16273','2013-07-08','07:40:00',1.41),('16273','2013-07-08','07:45:00',1.61),('16273','2013-07-08','07:50:00',1.67),('16273','2013-07-08','07:55:00',1.72),('16273','2013-07-08','08:00:00',1.77),('16273','2013-07-08','08:05:00',1.81),('16273','2013-07-08','08:10:00',1.86),('16273','2013-07-08','08:15:00',1.94),('16273','2013-07-08','08:20:00',2.03),('16273','2013-07-08','08:25:00',2.09),('16273','2013-07-08','08:30:00',2.17),('16273','2013-07-08','08:35:00',2.24),('16273','2013-07-08','08:40:00',2.28),('16273','2013-07-08','08:45:00',2.35),('16273','2013-07-08','08:50:00',2.41),('16273','2013-07-08','08:55:00',2.46),('16273','2013-07-08','09:00:00',2.52),('16273','2013-07-08','09:05:00',2.55),('16273','2013-07-08','09:10:00',2.61),('16273','2013-07-08','09:15:00',2.68),('16273','2013-07-08','09:20:00',2.75),('16273','2013-07-08','09:25:00',2.81),('16273','2013-07-08','09:30:00',2.86),('16273','2013-07-08','09:35:00',2.93),('16273','2013-07-08','09:40:00',2.97),('16273','2013-07-08','09:45:00',3.02),('16273','2013-07-08','09:50:00',3.07),('16273','2013-07-08','09:55:00',3.09),('16273','2013-07-08','10:00:00',3.16),('16273','2013-07-08','10:05:00',3.2),('16273','2013-07-08','10:10:00',3.22),('16273','2013-07-08','10:15:00',3.26),('16273','2013-07-08','10:20:00',3.3),('16273','2013-07-08','10:25:00',3.32),('16273','2013-07-08','10:30:00',3.27),('16273','2013-07-08','10:35:00',2.56),('16273','2013-07-08','10:40:00',3.49),('16273','2013-07-08','10:45:00',3.49),('16273','2013-07-08','10:50:00',3.5),('16273','2013-07-08','10:55:00',3.5),('16273','2013-07-08','11:00:00',3.53),('16273','2013-07-08','11:05:00',3.57),('16273','2013-07-08','11:10:00',3.59),('16273','2013-07-08','11:15:00',3.58),('16273','2013-07-08','11:20:00',3.63),('16273','2013-07-08','11:25:00',3.68),('16273','2013-07-08','11:30:00',3.72),('16273','2013-07-08','11:35:00',3.53),('16273','2013-07-08','11:40:00',3.56),('16273','2013-07-08','11:45:00',2.87),('16273','2013-07-08','11:50:00',2.44),('16273','2013-07-08','11:55:00',2.79),('16273','2013-07-08','12:00:00',4.03),('16273','2013-07-08','12:05:00',3.49),('16273','2013-07-08','12:10:00',2.92),('16273','2013-07-08','12:15:00',4),('16273','2013-07-08','12:20:00',3.9),('16273','2013-07-08','12:25:00',3.77),('16273','2013-07-08','12:30:00',3.47),('16273','2013-07-08','12:35:00',3.64),('16273','2013-07-08','12:40:00',3.82),('16273','2013-07-08','12:45:00',4.04),('16273','2013-07-08','12:50:00',3.97),('16273','2013-07-08','12:55:00',3.98),('16273','2013-07-08','13:00:00',2.97),('16273','2013-07-08','13:05:00',1.8),('16273','2013-07-08','13:10:00',4.23),('16273','2013-07-08','13:15:00',3.03),('16273','2013-07-08','13:20:00',3.64),('16273','2013-07-08','13:25:00',2.23),('16273','2013-07-08','14:15:00',1.06),('16273','2013-07-08','14:20:00',1.14),('16273','2013-07-08','14:25:00',1.14),('16273','2013-07-08','14:30:00',1.11),('16273','2013-07-08','14:35:00',1.16),('16273','2013-07-08','14:40:00',1.43),('16273','2013-07-08','14:45:00',1.96),('16273','2013-07-08','14:50:00',1.75),('16273','2013-07-08','14:55:00',1.6),('16273','2013-07-08','15:00:00',1.38),('16273','2013-07-08','15:05:00',1.32),('16273','2013-07-08','15:10:00',1.28),('16273','2013-07-08','15:15:00',1.14),('16273','2013-07-07','07:15:00',1.07),('16273','2013-07-07','07:20:00',1.15),('16273','2013-07-07','07:25:00',1.23),('16273','2013-07-07','07:30:00',1.31),('16273','2013-07-07','07:35:00',1.39),('16273','2013-07-07','07:40:00',1.47),('16273','2013-07-07','07:45:00',1.55),('16273','2013-07-07','07:50:00',1.63),('16273','2013-07-07','07:55:00',1.72),('16273','2013-07-07','08:00:00',1.8),('16273','2013-07-07','08:05:00',1.88),('16273','2013-07-07','08:10:00',1.96),('16273','2013-07-07','08:15:00',2.05),('16273','2013-07-07','08:20:00',2.13),('16273','2013-07-07','08:25:00',2.19),('16273','2013-07-07','08:30:00',2.26),('16273','2013-07-07','08:35:00',2.33),('16273','2013-07-07','08:40:00',2.24),('16273','2013-07-07','08:45:00',1.43),('16273','2013-07-07','08:50:00',2.09),('16273','2013-07-07','08:55:00',2.07),('16273','2013-07-07','09:00:00',2.75),('16273','2013-07-07','09:05:00',2.89),('16273','2013-07-07','09:10:00',2.97),('16273','2013-07-07','09:15:00',1.88),('16273','2013-07-07','09:20:00',1.48),('16273','2013-07-07','09:25:00',1.39),('16273','2013-07-07','09:30:00',1.45),('16273','2013-07-07','09:35:00',2.43),('16273','2013-07-07','09:40:00',3.27),('16273','2013-07-07','09:45:00',2.82),('16273','2013-07-07','09:50:00',3.29),('16273','2013-07-07','09:55:00',3.44),('16273','2013-07-07','10:00:00',3.49),('16273','2013-07-07','10:05:00',3.49),('16273','2013-07-07','10:10:00',3.41),('16273','2013-07-07','10:15:00',3.33),('16273','2013-07-07','10:20:00',2.84),('16273','2013-07-07','10:25:00',3.63),('16273','2013-07-07','10:30:00',3.68),('16273','2013-07-07','10:35:00',3.61),('16273','2013-07-07','10:40:00',3.13),('16273','2013-07-07','10:45:00',3.69),('16273','2013-07-07','10:50:00',3.62),('16273','2013-07-07','10:55:00',3.7),('16273','2013-07-07','11:00:00',3.71),('16273','2013-07-07','11:05:00',3.75),('16273','2013-07-07','11:10:00',3.74),('16273','2013-07-07','11:15:00',3.77),('16273','2013-07-07','11:20:00',3.8),('16273','2013-07-07','11:25:00',3.64),('16273','2013-07-07','11:30:00',3.38),('16273','2013-07-07','11:35:00',3.82),('16273','2013-07-07','11:40:00',3.4),('16273','2013-07-07','11:45:00',3.51),('16273','2013-07-07','11:50:00',3.68),('16273','2013-07-07','11:55:00',3.87),('16273','2013-07-07','12:00:00',3.71),('16273','2013-07-07','12:05:00',2.91),('16273','2013-07-07','12:10:00',2.91),('16273','2013-07-07','12:15:00',3.16),('16273','2013-07-07','12:20:00',2.87),('16273','2013-07-07','12:25:00',2.69),('16273','2013-07-07','12:30:00',3.64),('16273','2013-07-07','12:35:00',3.86),('16273','2013-07-07','12:40:00',3.8),('16273','2013-07-07','12:45:00',3.74),('16273','2013-07-07','12:50:00',3.82),('16273','2013-07-07','12:55:00',3.89),('16273','2013-07-07','13:00:00',3.98),('16273','2013-07-07','13:05:00',3.95),('16273','2013-07-07','13:10:00',3.81),('16273','2013-07-07','13:15:00',3.83),('16273','2013-07-07','13:20:00',3.86),('16273','2013-07-07','13:25:00',3.85),('16273','2013-07-07','13:30:00',3.85),('16273','2013-07-07','13:35:00',3.98),('16273','2013-07-07','13:40:00',3.99),('16273','2013-07-07','13:45:00',2.89),('16273','2013-07-07','13:50:00',3.82),('16273','2013-07-07','13:55:00',4.24),('16273','2013-07-07','14:00:00',2.8),('16273','2013-07-07','14:05:00',1.33),('16273','2013-07-07','14:10:00',1.19),('16273','2013-07-07','14:15:00',1.04),('16273','2013-07-07','14:20:00',1.1),('16273','2013-07-07','14:25:00',1.26),('16273','2013-07-07','14:30:00',1.42),('16273','2013-07-07','14:35:00',1.75),('16273','2013-07-07','14:40:00',1.29),('16273','2013-07-07','14:55:00',1.01),('16273','2013-07-07','15:00:00',1.07),('16273','2013-07-07','15:05:00',1.23),('16273','2013-07-07','15:10:00',1.93),('16273','2013-07-07','15:15:00',2.45),('16273','2013-07-07','15:20:00',1.58),('16273','2013-07-07','17:10:00',1.02),('16273','2013-07-07','17:15:00',1.06),('16273','2013-07-07','17:20:00',1.11),('16273','2013-07-07','17:25:00',1.16),('16273','2013-07-07','17:30:00',1.2),('16273','2013-07-07','17:35:00',1.1),('16273','2013-07-07','17:40:00',1.03),('16273','2013-07-07','17:45:00',1.02),('16273','2013-07-07','17:50:00',1.03),('16273','2013-07-06','07:15:00',1.03),('16273','2013-07-06','07:20:00',1.11),('16273','2013-07-06','07:25:00',1.19),('16273','2013-07-06','07:30:00',1.27),('16273','2013-07-06','07:35:00',1.35),('16273','2013-07-06','07:40:00',1.42),('16273','2013-07-06','07:45:00',1.49),('16273','2013-07-06','07:50:00',1.54),('16273','2013-07-06','07:55:00',1.62),('16273','2013-07-06','08:00:00',1.72),('16273','2013-07-06','08:05:00',1.81),('16273','2013-07-06','08:10:00',1.89),('16273','2013-07-06','08:15:00',1.96),('16273','2013-07-06','08:20:00',2.01),('16273','2013-07-06','08:25:00',2.08),('16273','2013-07-06','08:30:00',2.16),('16273','2013-07-06','08:35:00',2.23),('16273','2013-07-06','08:40:00',2.31),('16273','2013-07-06','08:45:00',2.38),('16273','2013-07-06','08:50:00',2.45),('16273','2013-07-06','08:55:00',2.51),('16273','2013-07-06','09:00:00',2.57),('16273','2013-07-06','09:05:00',2.64),('16273','2013-07-06','09:10:00',2.71),('16273','2013-07-06','09:15:00',2.77),('16273','2013-07-06','09:20:00',2.82),('16273','2013-07-06','09:25:00',2.89),('16273','2013-07-06','09:30:00',2.94),('16273','2013-07-06','09:35:00',2.98),('16273','2013-07-06','09:40:00',3.02),('16273','2013-07-06','09:45:00',3.06),('16273','2013-07-06','09:50:00',3.1),('16273','2013-07-06','09:55:00',3.16),('16273','2013-07-06','10:00:00',3.22),('16273','2013-07-06','10:05:00',3.24),('16273','2013-07-06','10:10:00',3.21),('16273','2013-07-06','10:15:00',3.26),('16273','2013-07-06','10:20:00',3.3),('16273','2013-07-06','10:25:00',3.37),('16273','2013-07-06','10:30:00',3.43),('16273','2013-07-06','10:35:00',3.46),('16273','2013-07-06','10:40:00',3.53),('16273','2013-07-06','10:45:00',3.56),('16273','2013-07-06','10:50:00',3.57),('16273','2013-07-06','10:55:00',3.62),('16273','2013-07-06','11:00:00',3.64),('16273','2013-07-06','11:05:00',3.67),('16273','2013-07-06','11:10:00',3.71),('16273','2013-07-06','11:15:00',3.71),('16273','2013-07-06','11:20:00',3.73),('16273','2013-07-06','11:25:00',3.73),('16273','2013-07-06','11:30:00',3.76),('16273','2013-07-06','11:35:00',3.76),('16273','2013-07-06','11:40:00',3.77),('16273','2013-07-06','11:45:00',3.82),('16273','2013-07-06','11:50:00',3.82),('16273','2013-07-06','11:55:00',3.79),('16273','2013-07-06','12:00:00',3.83),('16273','2013-07-06','12:05:00',3.85),('16273','2013-07-06','12:10:00',3.85),('16273','2013-07-06','12:15:00',3.86),('16273','2013-07-06','12:20:00',3.87),('16273','2013-07-06','12:25:00',3.9),('16273','2013-07-06','12:30:00',3.88),('16273','2013-07-06','12:35:00',3.88),('16273','2013-07-06','12:40:00',3.89),('16273','2013-07-06','12:45:00',3.91),('16273','2013-07-06','12:50:00',3.92),('16273','2013-07-06','12:55:00',3.91),('16273','2013-07-06','13:00:00',3.82),('16273','2013-07-06','13:05:00',3.81),('16273','2013-07-06','13:10:00',3.79),('16273','2013-07-06','13:15:00',3.83),('16273','2013-07-06','13:20:00',3.33),('16273','2013-07-06','13:25:00',3.34),('16273','2013-07-06','13:30:00',3.82),('16273','2013-07-06','13:35:00',3.83),('16273','2013-07-06','13:40:00',3.85),('16273','2013-07-06','13:45:00',3.74),('16273','2013-07-06','13:50:00',3.76),('16273','2013-07-06','13:55:00',3.71),('16273','2013-07-06','14:00:00',2.72),('16273','2013-07-06','14:05:00',3.05),('16273','2013-07-06','14:10:00',3.62),('16273','2013-07-06','14:15:00',3.57),('16273','2013-07-06','14:20:00',3.6),('16273','2013-07-06','14:25:00',3.58),('16273','2013-07-06','14:30:00',3.54),('16273','2013-07-06','14:35:00',3.44),('16273','2013-07-06','14:40:00',3.25),('16273','2013-07-06','14:45:00',2.26),('16273','2013-07-06','14:55:00',2.81),('16273','2013-07-06','15:00:00',1.73),('16273','2013-07-06','15:05:00',1.65),('16273','2013-07-06','15:10:00',1.99),('16273','2013-07-06','16:55:00',1.12),('16273','2013-07-06','17:00:00',1.11),('16273','2013-07-06','17:05:00',1.32),('16273','2013-07-06','17:10:00',1.51),('16273','2013-07-06','17:15:00',1.54),('16273','2013-07-06','17:20:00',1.28),('16273','2013-07-06','17:25:00',1.25),('16273','2013-07-06','17:30:00',1.23),('16273','2013-07-05','07:20:00',1.08),('16273','2013-07-05','07:25:00',1.17),('16273','2013-07-05','07:30:00',1.25),('16273','2013-07-05','07:35:00',1.31),('16273','2013-07-05','07:40:00',1.38),('16273','2013-07-05','07:45:00',1.44),('16273','2013-07-05','07:50:00',1.53),('16273','2013-07-05','07:55:00',1.62),('16273','2013-07-05','08:00:00',1.71),('16273','2013-07-05','08:05:00',1.78),('16273','2013-07-05','08:10:00',1.86),('16273','2013-07-05','08:15:00',1.95),('16273','2013-07-05','08:20:00',2.03),('16273','2013-07-05','08:25:00',2.1),('16273','2013-07-05','08:30:00',2.18),('16273','2013-07-05','08:35:00',2.27),('16273','2013-07-05','08:40:00',2.33),('16273','2013-07-05','08:45:00',2.38),('16273','2013-07-05','08:50:00',2.45),('16273','2013-07-05','08:55:00',2.51),('16273','2013-07-05','09:00:00',2.58),('16273','2013-07-05','09:05:00',2.63),('16273','2013-07-05','09:10:00',2.7),('16273','2013-07-05','09:15:00',2.76),('16273','2013-07-05','09:20:00',2.8),('16273','2013-07-05','09:25:00',2.86),('16273','2013-07-05','09:30:00',2.89),('16273','2013-07-05','09:35:00',2.93),('16273','2013-07-05','09:40:00',3),('16273','2013-07-05','09:45:00',3.05),('16273','2013-07-05','09:50:00',3.09),('16273','2013-07-05','09:55:00',3.16),('16273','2013-07-05','10:00:00',3.18),('16273','2013-07-05','10:05:00',3.24),('16273','2013-07-05','10:10:00',3.28),('16273','2013-07-05','10:15:00',3.29),('16273','2013-07-05','10:20:00',3.32),('16273','2013-07-05','10:25:00',3.37),('16273','2013-07-05','10:30:00',3.41),('16273','2013-07-05','10:35:00',3.44),('16273','2013-07-05','10:40:00',3.48),('16273','2013-07-05','10:45:00',3.5),('16273','2013-07-05','10:50:00',3.54),('16273','2013-07-05','10:55:00',3.57),('16273','2013-07-05','11:00:00',3.58),('16273','2013-07-05','11:05:00',3.61),('16273','2013-07-05','11:10:00',3.66),('16273','2013-07-05','11:15:00',3.69),('16273','2013-07-05','11:20:00',3.7),('16273','2013-07-05','11:25:00',3.69),('16273','2013-07-05','11:30:00',3.73),('16273','2013-07-05','11:35:00',3.76),('16273','2013-07-05','11:40:00',3.75),('16273','2013-07-05','11:45:00',3.74),('16273','2013-07-05','11:50:00',3.79),('16273','2013-07-05','11:55:00',3.75),('16273','2013-07-05','12:00:00',3.78),('16273','2013-07-05','12:05:00',3.79),('16273','2013-07-05','12:10:00',3.83),('16273','2013-07-05','12:15:00',3.85),('16273','2013-07-05','12:20:00',3.64),('16273','2013-07-05','12:25:00',3.59),('16273','2013-07-05','12:30:00',3.8),('16273','2013-07-05','12:35:00',3.65),('16273','2013-07-05','12:40:00',2.83),('16273','2013-07-05','12:45:00',2.18),('16273','2013-07-05','12:50:00',3.33),('16273','2013-07-05','12:55:00',3.19),('16273','2013-07-05','13:05:00',1.46),('16273','2013-07-05','13:10:00',4.22),('16273','2013-07-05','13:15:00',4.1),('16273','2013-07-05','13:20:00',4.07),('16273','2013-07-05','13:25:00',3.97),('16273','2013-07-05','13:30:00',3.92),('16273','2013-07-05','13:35:00',3.95),('16273','2013-07-05','13:40:00',3.85),('16273','2013-07-05','13:45:00',3.8),('16273','2013-07-05','13:50:00',3.72),('16273','2013-07-05','13:55:00',3.77),('16273','2013-07-05','14:00:00',3.75),('16273','2013-07-05','14:05:00',3.76),('16273','2013-07-05','14:10:00',3.76),('16273','2013-07-05','14:15:00',3.74),('16273','2013-07-05','14:20:00',3.67),('16273','2013-07-05','14:25:00',3.61),('16273','2013-07-05','14:30:00',3.6),('16273','2013-07-05','14:35:00',3.52),('16273','2013-07-05','14:40:00',3.52),('16273','2013-07-05','14:45:00',3.49),('16273','2013-07-05','14:50:00',3.43),('16273','2013-07-05','14:55:00',3.41),('16273','2013-07-05','15:00:00',3.36),('16273','2013-07-05','15:05:00',3.3),('16273','2013-07-05','15:10:00',3.4),('16273','2013-07-05','15:15:00',3.32),('16273','2013-07-05','15:20:00',3.07),('16273','2013-07-05','15:25:00',2.96),('16273','2013-07-05','15:30:00',2.48),('16273','2013-07-05','15:35:00',2.01),('16273','2013-07-05','15:40:00',2.05),('16273','2013-07-05','15:45:00',2.99),('16273','2013-07-05','15:50:00',2.93),('16273','2013-07-05','15:55:00',2.84),('16273','2013-07-05','16:00:00',2.75),('16273','2013-07-05','16:05:00',2.69),('16273','2013-07-05','16:10:00',2.32),('16273','2013-07-05','16:15:00',1.46),('16273','2013-07-05','16:20:00',1.92),('16273','2013-07-05','16:25:00',1.53),('16273','2013-07-05','16:30:00',2.38),('16273','2013-07-05','16:35:00',2.25),('16273','2013-07-05','16:40:00',2.21),('16273','2013-07-05','16:45:00',2.17),('16273','2013-07-05','16:50:00',2.11),('16273','2013-07-05','16:55:00',2.01),('16273','2013-07-05','17:00:00',1.63),('16273','2013-07-05','17:05:00',1.84),('16273','2013-07-05','17:10:00',1.51),('16273','2013-07-05','17:15:00',1.35),('16273','2013-07-05','17:20:00',1.13),('16273','2013-07-05','17:35:00',1.23),('16273','2013-07-05','17:40:00',1.32),('16273','2013-07-05','17:45:00',1.27),('16273','2013-07-05','17:50:00',1.19),('16273','2013-07-05','17:55:00',1.11),('16273','2013-07-05','18:00:00',1.06),('16273','2013-07-05','18:05:00',1.02),('16273','2013-07-05','18:10:00',1.03),('16273','2013-07-05','18:15:00',1.03),('16273','2013-07-04','11:00:00',1.03),('16273','2013-07-04','11:05:00',1.05),('16273','2013-07-04','11:10:00',1.1),('16273','2013-07-04','11:15:00',1.22),('16273','2013-07-04','11:20:00',1.36),('16273','2013-07-04','11:25:00',1.38),('16273','2013-07-04','11:30:00',1.37),('16273','2013-07-04','11:35:00',1.39),('16273','2013-07-04','11:40:00',1.41),('16273','2013-07-04','11:45:00',1.15),('16273','2013-07-04','11:50:00',1.19),('16273','2013-07-04','11:55:00',1.26),('16273','2013-07-04','12:00:00',1.39),('16273','2013-07-04','12:05:00',1.46),('16273','2013-07-04','12:10:00',1.3),('16273','2013-07-04','12:15:00',1.15),('16273','2013-07-04','12:20:00',1.04),('16273','2013-07-04','12:25:00',1.22),('16273','2013-07-04','12:30:00',1.08),('16273','2013-07-04','12:40:00',1.03),('16273','2013-07-04','12:45:00',1.04),('16273','2013-07-04','12:50:00',1.14),('16273','2013-07-04','12:55:00',1.28),('16273','2013-07-04','13:00:00',1.42),('16273','2013-07-04','13:05:00',1.94),('16273','2013-07-04','13:10:00',2.36),('16273','2013-07-04','13:15:00',2.37),('16273','2013-07-04','13:20:00',1.6),('16273','2013-07-04','13:25:00',1.42),('16273','2013-07-04','13:30:00',2.3),('16273','2013-07-04','13:35:00',4.15),('16273','2013-07-04','13:40:00',3),('16273','2013-07-04','13:45:00',3.14),('16273','2013-07-04','13:50:00',1.63),('16273','2013-07-04','13:55:00',1.66),('16273','2013-07-04','14:00:00',1.58),('16273','2013-07-04','14:05:00',1.39),('16273','2013-07-04','14:10:00',1.27),('16273','2013-07-04','14:15:00',1.22),('16273','2013-07-04','14:20:00',1.18),('16273','2013-07-04','14:25:00',1.22),('16273','2013-07-04','14:30:00',1.25),('16273','2013-07-04','14:35:00',1.29),('16273','2013-07-04','14:40:00',1.28),('16273','2013-07-04','14:45:00',1.39),('16273','2013-07-04','14:50:00',1.78),('16273','2013-07-04','14:55:00',1.26),('16273','2013-07-04','15:00:00',1.31),('16273','2013-07-04','15:05:00',1.34),('16273','2013-07-04','15:10:00',2.53),('16273','2013-07-04','15:15:00',1.97),('16273','2013-07-04','15:20:00',3.46),('16273','2013-07-04','15:25:00',3.2),('16273','2013-07-04','15:30:00',2.96),('16273','2013-07-04','15:35:00',2.54),('16273','2013-07-04','15:40:00',1.9),('16273','2013-07-04','15:45:00',1.63),('16273','2013-07-04','15:50:00',1.64),('16273','2013-07-04','15:55:00',1.82),('16273','2013-07-04','16:00:00',1.97),('16273','2013-07-04','16:05:00',1.77),('16273','2013-07-04','16:10:00',1.84),('16273','2013-07-04','16:15:00',1.61),('16273','2013-07-04','16:20:00',2.23),('16273','2013-07-04','16:25:00',1.99),('16273','2013-07-04','16:30:00',1.87),('16273','2013-07-04','16:35:00',1.64),('16273','2013-07-04','16:40:00',1.56),('16273','2013-07-04','16:45:00',1.46),('16273','2013-07-04','16:50:00',1.37),('16273','2013-07-04','16:55:00',1.63),('16273','2013-07-04','17:00:00',1.64),('16273','2013-07-04','17:05:00',1.29),('16273','2013-07-04','17:10:00',1.23),('16273','2013-07-04','17:15:00',1.43),('16273','2013-07-04','17:20:00',1.64),('16273','2013-07-04','17:25:00',1.94),('16273','2013-07-04','17:30:00',1.86),('16273','2013-07-04','17:35:00',1.58),('16273','2013-07-04','17:40:00',1.09),('16273','2013-07-04','17:45:00',1.07),('16273','2013-07-04','17:50:00',1.39),('16273','2013-07-04','17:55:00',1.3),('16273','2013-07-04','18:00:00',1.25),('16273','2013-07-04','18:05:00',1.02),('16273','2013-07-04','18:15:00',1.01),('16273','2013-07-03','07:10:00',1),('16273','2013-07-03','07:15:00',1.09),('16273','2013-07-03','07:20:00',1.16),('16273','2013-07-03','07:25:00',1.26),('16273','2013-07-03','07:30:00',1.31),('16273','2013-07-03','07:35:00',1.4),('16273','2013-07-03','07:40:00',1.49),('16273','2013-07-03','07:45:00',1.57),('16273','2013-07-03','07:50:00',1.66),('16273','2013-07-03','07:55:00',1.73),('16273','2013-07-03','08:00:00',1.82),('16273','2013-07-03','08:05:00',1.91),('16273','2013-07-03','08:10:00',1.98),('16273','2013-07-03','08:15:00',2.07),('16273','2013-07-03','08:20:00',2.14),('16273','2013-07-03','08:25:00',2.23),('16273','2013-07-03','08:30:00',2.28),('16273','2013-07-03','08:35:00',2.36),('16273','2013-07-03','08:40:00',2.41),('16273','2013-07-03','08:45:00',2.47),('16273','2013-07-03','08:50:00',2.5),('16273','2013-07-03','08:55:00',2.6),('16273','2013-07-03','09:00:00',2.67),('16273','2013-07-03','09:05:00',2.73),('16273','2013-07-03','09:10:00',2.75),('16273','2013-07-03','09:15:00',2.83),('16273','2013-07-03','09:20:00',2.9),('16273','2013-07-03','09:25:00',2.93),('16273','2013-07-03','09:30:00',2.96),('16273','2013-07-03','09:35:00',2.99),('16273','2013-07-03','09:40:00',3.03),('16273','2013-07-03','09:45:00',3.03),('16273','2013-07-03','09:50:00',3.13),('16273','2013-07-03','09:55:00',3.15),('16273','2013-07-03','10:00:00',3.28),('16273','2013-07-03','10:05:00',3.35),('16273','2013-07-03','10:10:00',3.41),('16273','2013-07-03','10:15:00',3.43),('16273','2013-07-03','10:20:00',3.48),('16273','2013-07-03','10:25:00',3.51),('16273','2013-07-03','10:30:00',3.51),('16273','2013-07-03','10:35:00',3.57),('16273','2013-07-03','10:40:00',3.6),('16273','2013-07-03','10:45:00',3.62),('16273','2013-07-03','10:50:00',3.67),('16273','2013-07-03','10:55:00',3.7),('16273','2013-07-03','11:00:00',3.74),('16273','2013-07-03','11:05:00',3.76),('16273','2013-07-03','11:10:00',3.81),('16273','2013-07-03','11:15:00',3.81),('16273','2013-07-03','11:20:00',3.83),('16273','2013-07-03','11:25:00',3.84),('16273','2013-07-03','11:30:00',3.88),('16273','2013-07-03','11:35:00',3.89),('16273','2013-07-03','11:40:00',3.91),('16273','2013-07-03','11:45:00',3.93),('16273','2013-07-03','11:50:00',3.94),('16273','2013-07-03','11:55:00',3.94),('16273','2013-07-03','12:00:00',3.93),('16273','2013-07-03','12:05:00',3.95),('16273','2013-07-03','12:10:00',3.97),('16273','2013-07-03','12:15:00',3.99),('16273','2013-07-03','12:20:00',4),('16273','2013-07-03','12:25:00',3.98),('16273','2013-07-03','12:30:00',4),('16273','2013-07-03','12:35:00',4.01),('16273','2013-07-03','12:40:00',4.01),('16273','2013-07-03','12:45:00',3.99),('16273','2013-07-03','12:50:00',3.96),('16273','2013-07-03','12:55:00',3.96),('16273','2013-07-03','13:00:00',3.95),('16273','2013-07-03','13:05:00',3.96),('16273','2013-07-03','13:10:00',3.96),('16273','2013-07-03','13:15:00',3.95),('16273','2013-07-03','13:20:00',3.93),('16273','2013-07-03','13:25:00',3.91),('16273','2013-07-03','13:30:00',3.9),('16273','2013-07-03','13:35:00',3.88),('16273','2013-07-03','13:40:00',3.88),('16273','2013-07-03','13:45:00',3.87),('16273','2013-07-03','13:50:00',3.86),('16273','2013-07-03','13:55:00',3.84),('16273','2013-07-03','14:00:00',3.81),('16273','2013-07-03','14:05:00',3.79),('16273','2013-07-03','14:10:00',3.75),('16273','2013-07-03','14:15:00',3.74),('16273','2013-07-03','14:20:00',3.71),('16273','2013-07-03','14:25:00',3.68),('16273','2013-07-03','14:30:00',3.64),('16273','2013-07-03','14:35:00',3.62),('16273','2013-07-03','14:40:00',3.57),('16273','2013-07-03','14:45:00',3.55),('16273','2013-07-03','14:50:00',3.53),('16273','2013-07-03','14:55:00',3.49),('16273','2013-07-03','15:00:00',3.44),('16273','2013-07-03','15:05:00',3.39),('16273','2013-07-03','15:10:00',3.33),('16273','2013-07-03','15:15:00',3.29),('16273','2013-07-03','15:20:00',3.23),('16273','2013-07-03','15:25:00',3.19),('16273','2013-07-03','15:30:00',3.14),('16273','2013-07-03','15:35:00',3.08),('16273','2013-07-03','15:40:00',3.02),('16273','2013-07-03','15:45:00',2.97),('16273','2013-07-03','15:50:00',2.93),('16273','2013-07-03','15:55:00',2.87),('16273','2013-07-03','16:00:00',2.81),('16273','2013-07-03','16:05:00',2.76),('16273','2013-07-03','16:10:00',2.7),('16273','2013-07-03','16:15:00',2.64),('16273','2013-07-03','16:20:00',2.57),('16273','2013-07-03','16:25:00',2.51),('16273','2013-07-03','16:30:00',2.45),('16273','2013-07-03','16:35:00',2.38),('16273','2013-07-03','16:40:00',2.29),('16273','2013-07-03','16:45:00',2.24),('16273','2013-07-03','16:50:00',2.17),('16273','2013-07-03','16:55:00',2.1),('16273','2013-07-03','17:00:00',2.03),('16273','2013-07-03','17:05:00',1.96),('16273','2013-07-03','17:10:00',1.88),('16273','2013-07-03','17:15:00',1.79),('16273','2013-07-03','17:20:00',1.72),('16273','2013-07-03','17:25:00',1.64),('16273','2013-07-03','17:30:00',1.57),('16273','2013-07-03','17:35:00',1.49),('16273','2013-07-03','17:40:00',1.4),('16273','2013-07-03','17:45:00',1.33),('16273','2013-07-03','17:50:00',1.26),('16273','2013-07-03','17:55:00',1.17),('16273','2013-07-03','18:00:00',1.1),('16273','2013-07-03','18:05:00',1.03),('16273','2013-07-02','07:15:00',1.05),('16273','2013-07-02','07:20:00',1.14),('16273','2013-07-02','07:25:00',1.23),('16273','2013-07-02','07:30:00',1.3),('16273','2013-07-02','07:35:00',1.37),('16273','2013-07-02','07:40:00',1.46),('16273','2013-07-02','07:45:00',1.54),('16273','2013-07-02','07:50:00',1.6),('16273','2013-07-02','07:55:00',1.69),('16273','2013-07-02','08:00:00',1.76),('16273','2013-07-02','08:05:00',1.83),('16273','2013-07-02','08:10:00',1.91),('16273','2013-07-02','08:15:00',2),('16273','2013-07-02','08:20:00',2.07),('16273','2013-07-02','08:25:00',2.15),('16273','2013-07-02','08:30:00',2.24),('16273','2013-07-02','08:35:00',2.31),('16273','2013-07-02','08:40:00',2.37),('16273','2013-07-02','08:45:00',2.43),('16273','2013-07-02','08:50:00',2.47),('16273','2013-07-02','08:55:00',2.55),('16273','2013-07-02','09:00:00',2.62),('16273','2013-07-02','09:05:00',2.67),('16273','2013-07-02','09:10:00',2.73),('16273','2013-07-02','09:15:00',2.79),('16273','2013-07-02','09:20:00',2.85),('16273','2013-07-02','09:25:00',2.89),('16273','2013-07-02','09:30:00',2.92),('16273','2013-07-02','09:35:00',2.98),('16273','2013-07-02','09:40:00',3.03),('16273','2013-07-02','09:45:00',3.07),('16273','2013-07-02','09:50:00',3.12),('16273','2013-07-02','09:55:00',3.15),('16273','2013-07-02','10:00:00',3.19),('16273','2013-07-02','10:05:00',3.25),('16273','2013-07-02','10:10:00',3.27),('16273','2013-07-02','10:15:00',3.32),('16273','2013-07-02','10:20:00',3.35),('16273','2013-07-02','10:25:00',3.38),('16273','2013-07-02','10:30:00',3.41),('16273','2013-07-02','10:35:00',3.43),('16273','2013-07-02','10:40:00',3.48),('16273','2013-07-02','10:45:00',3.51),('16273','2013-07-02','10:50:00',3.53),('16273','2013-07-02','10:55:00',3.57),('16273','2013-07-02','11:00:00',3.64),('16273','2013-07-02','11:05:00',3.63),('16273','2013-07-02','11:10:00',3.63),('16273','2013-07-02','11:15:00',3.64),('16273','2013-07-02','11:20:00',3.63),('16273','2013-07-02','11:25:00',3.65),('16273','2013-07-02','11:30:00',3.71),('16273','2013-07-02','11:35:00',3.72),('16273','2013-07-02','11:40:00',3.78),('16273','2013-07-02','11:45:00',3.78),('16273','2013-07-02','11:50:00',3.78),('16273','2013-07-02','11:55:00',3.62),('16273','2013-07-02','12:00:00',3.71),('16273','2013-07-02','12:05:00',3.95),('16273','2013-07-02','12:10:00',3.8),('16273','2013-07-02','12:15:00',3.83),('16273','2013-07-02','12:20:00',3.8),('16273','2013-07-02','12:25:00',3.85),('16273','2013-07-02','12:30:00',3.88),('16273','2013-07-02','12:35:00',3.89),('16273','2013-07-02','12:40:00',3.89),('16273','2013-07-02','12:45:00',3.89),('16273','2013-07-02','12:50:00',3.9),('16273','2013-07-02','12:55:00',3.92),('16273','2013-07-02','13:00:00',3.87),('16273','2013-07-02','13:05:00',3.84),('16273','2013-07-02','13:10:00',3.86),('16273','2013-07-02','13:15:00',3.82),('16273','2013-07-02','13:20:00',3.77),('16273','2013-07-02','13:25:00',3.81),('16273','2013-07-02','13:30:00',3.84),('16273','2013-07-02','13:35:00',3.76),('16273','2013-07-02','13:40:00',3.77),('16273','2013-07-02','13:45:00',3.75),('16273','2013-07-02','13:50:00',3.74),('16273','2013-07-02','13:55:00',3.71),('16273','2013-07-02','14:00:00',3.7),('16273','2013-07-02','14:05:00',3.66),('16273','2013-07-02','14:10:00',3.66),('16273','2013-07-02','14:15:00',3.63),('16273','2013-07-02','14:20:00',3.62),('16273','2013-07-02','14:25:00',3.6),('16273','2013-07-02','14:30:00',3.55),('16273','2013-07-02','14:35:00',3.53),('16273','2013-07-02','14:40:00',3.51),('16273','2013-07-02','14:45:00',3.47),('16273','2013-07-02','14:50:00',3.38),('16273','2013-07-02','14:55:00',3.39),('16273','2013-07-02','15:00:00',3.35),('16273','2013-07-02','15:05:00',3.32),('16273','2013-07-02','15:10:00',3.29),('16273','2013-07-02','15:15:00',3.25),('16273','2013-07-02','15:20:00',3.18),('16273','2013-07-02','15:25:00',3.13),('16273','2013-07-02','15:30:00',3.09),('16273','2013-07-02','15:35:00',3.05),('16273','2013-07-02','15:40:00',3),('16273','2013-07-02','15:45:00',2.95),('16273','2013-07-02','15:50:00',2.89),('16273','2013-07-02','15:55:00',2.83),('16273','2013-07-02','16:00:00',2.76),('16273','2013-07-02','16:05:00',2.71),('16273','2013-07-02','16:10:00',2.64),('16273','2013-07-02','16:15:00',2.59),('16273','2013-07-02','16:20:00',2.53),('16273','2013-07-02','16:25:00',2.46),('16273','2013-07-02','16:30:00',2.4),('16273','2013-07-02','16:35:00',2.33),('16273','2013-07-02','16:40:00',2.25),('16273','2013-07-02','16:45:00',2.19),('16273','2013-07-02','16:50:00',2.12),('16273','2013-07-02','16:55:00',2.05),('16273','2013-07-02','17:00:00',1.98),('16273','2013-07-02','17:05:00',1.9),('16273','2013-07-02','17:10:00',1.82),('16273','2013-07-02','17:15:00',1.75),('16273','2013-07-02','17:20:00',1.67),('16273','2013-07-02','17:25:00',1.59),('16273','2013-07-02','17:30:00',1.52),('16273','2013-07-02','17:35:00',1.45),('16273','2013-07-02','17:40:00',1.37),('16273','2013-07-02','17:45:00',1.3),('16273','2013-07-02','17:50:00',1.22),('16273','2013-07-02','17:55:00',1.14),('16273','2013-07-02','18:00:00',1.08),('16273','2013-07-02','18:05:00',1.01),('16273','2013-07-01','07:15:00',1.08),('16273','2013-07-01','07:20:00',1.17),('16273','2013-07-01','07:25:00',1.26),('16273','2013-07-01','07:30:00',1.32),('16273','2013-07-01','07:35:00',1.41),('16273','2013-07-01','07:40:00',1.5),('16273','2013-07-01','07:45:00',1.59),('16273','2013-07-01','07:50:00',1.68),('16273','2013-07-01','07:55:00',1.77),('16273','2013-07-01','08:00:00',1.85),('16273','2013-07-01','08:05:00',1.91),('16273','2013-07-01','08:10:00',1.98),('16273','2013-07-01','08:15:00',2.06),('16273','2013-07-01','08:20:00',2.11),('16273','2013-07-01','08:25:00',2.21),('16273','2013-07-01','08:30:00',2.28),('16273','2013-07-01','08:35:00',2.34),('16273','2013-07-01','08:40:00',2.41),('16273','2013-07-01','08:45:00',2.49),('16273','2013-07-01','08:50:00',2.55),('16273','2013-07-01','08:55:00',2.62),('16273','2013-07-01','09:00:00',2.7),('16273','2013-07-01','09:05:00',2.76),('16273','2013-07-01','09:10:00',2.83),('16273','2013-07-01','09:15:00',2.89),('16273','2013-07-01','09:20:00',2.94),('16273','2013-07-01','09:25:00',2.99),('16273','2013-07-01','09:30:00',3.04),('16273','2013-07-01','09:35:00',3.07),('16273','2013-07-01','09:40:00',3.14),('16273','2013-07-01','09:45:00',3.18),('16273','2013-07-01','09:50:00',3.22),('16273','2013-07-01','09:55:00',3.24),('16273','2013-07-01','10:00:00',3.28),('16273','2013-07-01','10:05:00',3.31),('16273','2013-07-01','10:10:00',3.39),('16273','2013-07-01','10:15:00',3.44),('16273','2013-07-01','10:20:00',3.52),('16273','2013-07-01','10:25:00',3.52),('16273','2013-07-01','10:30:00',3.55),('16273','2013-07-01','10:35:00',3.58),('16273','2013-07-01','10:40:00',3.64),('16273','2013-07-01','10:45:00',3.66),('16273','2013-07-01','10:50:00',3.69),('16273','2013-07-01','10:55:00',3.71),('16273','2013-07-01','11:00:00',3.75),('16273','2013-07-01','11:05:00',3.78),('16273','2013-07-01','11:10:00',3.79),('16273','2013-07-01','11:15:00',3.81),('16273','2013-07-01','11:20:00',3.79),('16273','2013-07-01','11:25:00',3.82),('16273','2013-07-01','11:30:00',3.82),('16273','2013-07-01','11:35:00',3.86),('16273','2013-07-01','11:40:00',3.86),('16273','2013-07-01','11:45:00',3.86),('16273','2013-07-01','11:50:00',3.87),('16273','2013-07-01','11:55:00',3.91),('16273','2013-07-01','12:00:00',3.9),('16273','2013-07-01','12:05:00',3.88),('16273','2013-07-01','12:10:00',3.86),('16273','2013-07-01','12:15:00',3.88),('16273','2013-07-01','12:20:00',3.87),('16273','2013-07-01','12:25:00',3.88),('16273','2013-07-01','12:30:00',3.91),('16273','2013-07-01','12:35:00',3.86),('16273','2013-07-01','12:40:00',3.91),('16273','2013-07-01','12:45:00',3.9),('16273','2013-07-01','12:50:00',3.94),('16273','2013-07-01','12:55:00',3.93),('16273','2013-07-01','13:00:00',3.92),('16273','2013-07-01','13:05:00',3.93),('16273','2013-07-01','13:10:00',3.91),('16273','2013-07-01','13:15:00',3.9),('16273','2013-07-01','13:20:00',3.91),('16273','2013-07-01','13:25:00',3.87),('16273','2013-07-01','13:30:00',3.79),('16273','2013-07-01','13:35:00',3.82),('16273','2013-07-01','13:40:00',3.8),('16273','2013-07-01','13:45:00',3.76),('16273','2013-07-01','13:50:00',3.73),('16273','2013-07-01','13:55:00',3.73),('16273','2013-07-01','14:00:00',3.7),('16273','2013-07-01','14:05:00',3.65),('16273','2013-07-01','14:10:00',3.64),('16273','2013-07-01','14:15:00',3.66),('16273','2013-07-01','14:20:00',3.65),('16273','2013-07-01','14:25:00',3.63),('16273','2013-07-01','14:30:00',3.59),('16273','2013-07-01','14:35:00',3.56),('16273','2013-07-01','14:40:00',3.51),('16273','2013-07-01','14:45:00',3.5),('16273','2013-07-01','14:50:00',3.45),('16273','2013-07-01','14:55:00',3.42),('16273','2013-07-01','15:00:00',3.37),('16273','2013-07-01','15:05:00',3.33),('16273','2013-07-01','15:10:00',3.27),('16273','2013-07-01','15:15:00',3.24),('16273','2013-07-01','15:20:00',3.2),('16273','2013-07-01','15:25:00',3.16),('16273','2013-07-01','15:30:00',3.1),('16273','2013-07-01','15:35:00',3.04),('16273','2013-07-01','15:40:00',2.98),('16273','2013-07-01','15:45:00',2.94),('16273','2013-07-01','15:50:00',2.88),('16273','2013-07-01','15:55:00',2.82),('16273','2013-07-01','16:00:00',2.75),('16273','2013-07-01','16:05:00',2.53),('16273','2013-07-01','16:10:00',2.53),('16273','2013-07-01','16:15:00',2.57),('16273','2013-07-01','16:20:00',2.49),('16273','2013-07-01','16:25:00',2.42),('16273','2013-07-01','16:30:00',2.38),('16273','2013-07-01','16:35:00',2.3),('16273','2013-07-01','16:40:00',2.24),('16273','2013-07-01','16:45:00',2.2),('16273','2013-07-01','16:50:00',2.12),('16273','2013-07-01','16:55:00',2.04),('16273','2013-07-01','17:00:00',1.97),('16273','2013-07-01','17:05:00',1.88),('16273','2013-07-01','17:10:00',1.8),('16273','2013-07-01','17:15:00',1.74),('16273','2013-07-01','17:20:00',1.66),('16273','2013-07-01','17:25:00',1.58),('16273','2013-07-01','17:30:00',1.52),('16273','2013-07-01','17:35:00',1.45),('16273','2013-07-01','17:40:00',1.38),('16273','2013-07-01','17:45:00',1.3),('16273','2013-07-01','17:50:00',1.23),('16273','2013-07-01','17:55:00',1.15),('16273','2013-07-01','18:00:00',1.06),('16273','2013-07-01','18:05:00',1),('16273','2014-04-05','08:40:00',1.46),('16273','2014-04-05','08:45:00',1.23),('16273','2014-04-05','08:50:00',1.21),('16273','2014-04-05','09:20:00',1.04),('16273','2014-04-05','09:25:00',1.33),('16273','2014-04-05','09:30:00',1.82),('16273','2014-04-05','09:35:00',1.72),('16273','2014-04-05','09:40:00',1.55),('16273','2014-04-05','09:45:00',1.7),('16273','2014-04-05','09:50:00',2.15),('16273','2014-04-05','09:55:00',2.84),('16273','2014-04-05','10:00:00',1.96),('16273','2014-04-05','10:05:00',1.66),('16273','2014-04-05','10:10:00',1.66),('16273','2014-04-05','10:15:00',1.77),('16273','2014-04-05','10:20:00',1.71),('16273','2014-04-05','10:25:00',2.11),('16273','2014-04-05','10:30:00',2.99),('16273','2014-04-05','10:35:00',3.2),('16273','2014-04-05','10:40:00',3.73),('16273','2014-04-05','10:45:00',3.81),('16273','2014-04-05','10:50:00',3.76),('16273','2014-04-05','10:55:00',3.7),('16273','2014-04-05','11:00:00',3.57),('16273','2014-04-05','11:05:00',3.54),('16273','2014-04-05','11:10:00',3.41),('16273','2014-04-05','11:15:00',3.24),('16273','2014-04-05','11:20:00',2.66),('16273','2014-04-05','11:25:00',2.46),('16273','2014-04-05','11:30:00',3.03),('16273','2014-04-05','11:35:00',3.39),('16273','2014-04-05','11:40:00',3.8),('16273','2014-04-05','11:45:00',4.06),('16273','2014-04-05','11:50:00',4.08),('16273','2014-04-05','11:55:00',3.57),('16273','2014-04-05','12:00:00',3.51),('16273','2014-04-05','12:05:00',3.2),('16273','2014-04-05','12:10:00',2.81),('16273','2014-04-05','12:15:00',2.87),('16273','2014-04-05','12:20:00',2.54),('16273','2014-04-05','12:25:00',2.33),('16273','2014-04-05','12:30:00',2.18),('16273','2014-04-05','12:35:00',2.09),('16273','2014-04-05','12:40:00',2.04),('16273','2014-04-05','12:45:00',1.94),('16273','2014-04-05','12:50:00',1.96),('16273','2014-04-05','12:55:00',1.78),('16273','2014-04-05','13:00:00',2.13),('16273','2014-04-05','13:05:00',2.47),('16273','2014-04-05','13:10:00',2.66),('16273','2014-04-05','13:15:00',2.54),('16273','2014-04-05','13:20:00',3.55),('16273','2014-04-05','13:25:00',2.18),('16273','2014-04-05','13:30:00',2.63),('16273','2014-04-05','13:35:00',2.95),('16273','2014-04-05','13:40:00',3.09),('16273','2014-04-05','13:45:00',2.89),('16273','2014-04-05','13:50:00',2.62),('16273','2014-04-05','13:55:00',3.72),('16273','2014-04-05','14:00:00',4.02),('16273','2014-04-05','14:05:00',4.3),('16273','2014-04-05','14:10:00',3.31),('16273','2014-04-05','14:15:00',1.5),('16273','2014-04-05','14:20:00',1.08),('16273','2014-04-05','15:00:00',1.43),('16273','2014-04-05','15:05:00',2.81),('16273','2014-04-05','15:10:00',3.71),('16273','2014-04-05','15:15:00',3.5),('16273','2014-04-05','15:20:00',3.14),('16273','2014-04-05','15:25:00',1.98),('16273','2014-04-05','15:30:00',2.24),('16273','2014-04-05','15:35:00',1.7),('16273','2014-04-05','15:40:00',2.96),('16273','2014-04-05','15:45:00',2.25),('16273','2014-04-05','15:50:00',1.69),('16273','2014-04-05','16:10:00',1.15),('16273','2014-04-05','16:15:00',1.29),('16273','2014-04-05','16:30:00',1.95),('16273','2014-04-05','16:35:00',1.93),('16273','2014-04-05','16:40:00',2.34),('16273','2014-04-05','16:45:00',1.1),('16273','2014-04-05','16:55:00',1.32),('16273','2014-04-05','17:00:00',1.91),('16273','2014-04-05','17:05:00',1.75),('16273','2014-04-05','17:10:00',1.65),('16273','2014-04-05','17:15:00',1.48),('16273','2014-04-05','17:20:00',1.41),('16273','2014-04-05','17:25:00',1.3),('16273','2014-04-05','17:30:00',1.21),('16273','2013-06-30','07:10:00',1.08),('16273','2013-06-30','07:15:00',1.16),('16273','2013-06-30','07:20:00',1.24),('16273','2013-06-30','07:25:00',1.32),('16273','2013-06-30','07:30:00',1.4),('16273','2013-06-30','07:35:00',1.48),('16273','2013-06-30','07:40:00',1.57),('16273','2013-06-30','07:45:00',1.65),('16273','2013-06-30','07:50:00',1.73),('16273','2013-06-30','07:55:00',1.82),('16273','2013-06-30','08:00:00',1.9),('16273','2013-06-30','08:05:00',1.99),('16273','2013-06-30','08:10:00',2.07),('16273','2013-06-30','08:15:00',2.14),('16273','2013-06-30','08:20:00',2.21),('16273','2013-06-30','08:25:00',2.3),('16273','2013-06-30','08:30:00',2.37),('16273','2013-06-30','08:35:00',2.43),('16273','2013-06-30','08:40:00',2.49),('16273','2013-06-30','08:45:00',2.56),('16273','2013-06-30','08:50:00',2.62),('16273','2013-06-30','08:55:00',2.69),('16273','2013-06-30','09:00:00',2.74),('16273','2013-06-30','09:05:00',2.81),('16273','2013-06-30','09:10:00',2.87),('16273','2013-06-30','09:15:00',2.94),('16273','2013-06-30','09:20:00',3),('16273','2013-06-30','09:25:00',3.05),('16273','2013-06-30','09:30:00',3.11),('16273','2013-06-30','09:35:00',3.15),('16273','2013-06-30','09:40:00',3.2),('16273','2013-06-30','09:45:00',3.26),('16273','2013-06-30','09:50:00',3.31),('16273','2013-06-30','09:55:00',3.33),('16273','2013-06-30','10:00:00',3.38),('16273','2013-06-30','10:05:00',3.41),('16273','2013-06-30','10:10:00',3.47),('16273','2013-06-30','10:15:00',3.5),('16273','2013-06-30','10:20:00',3.53),('16273','2013-06-30','10:25:00',3.57),('16273','2013-06-30','10:30:00',3.61),('16273','2013-06-30','10:35:00',3.64),('16273','2013-06-30','10:40:00',3.65),('16273','2013-06-30','10:45:00',3.68),('16273','2013-06-30','10:50:00',3.7),('16273','2013-06-30','10:55:00',3.74),('16273','2013-06-30','11:00:00',3.76),('16273','2013-06-30','11:05:00',3.79),('16273','2013-06-30','11:10:00',3.78),('16273','2013-06-30','11:15:00',3.79),('16273','2013-06-30','11:20:00',3.8),('16273','2013-06-30','11:25:00',3.83),('16273','2013-06-30','11:30:00',3.83),('16273','2013-06-30','11:35:00',3.84),('16273','2013-06-30','11:40:00',3.88),('16273','2013-06-30','11:45:00',3.9),('16273','2013-06-30','11:50:00',3.91),('16273','2013-06-30','11:55:00',3.87),('16273','2013-06-30','12:00:00',3.9),('16273','2013-06-30','12:05:00',3.96),('16273','2013-06-30','12:10:00',3.35),('16273','2013-06-30','12:15:00',3.49),('16273','2013-06-30','12:20:00',4.06),('16273','2013-06-30','12:25:00',4.04),('16273','2013-06-30','12:30:00',4.03),('16273','2013-06-30','12:35:00',4.03),('16273','2013-06-30','12:40:00',4.01),('16273','2013-06-30','12:45:00',4.18),('16273','2013-06-30','12:50:00',3.94),('16273','2013-06-30','12:55:00',4.17),('16273','2013-06-30','13:00:00',4.1),('16273','2013-06-30','13:05:00',4.29),('16273','2013-06-30','13:10:00',3.91),('16273','2013-06-30','13:15:00',3.87),('16273','2013-06-30','13:20:00',3.58),('16273','2013-06-30','13:25:00',4.25),('16273','2013-06-30','13:30:00',3.77),('16273','2013-06-30','13:35:00',2.57),('16273','2013-06-30','13:40:00',1.86),('16273','2013-06-30','13:45:00',3.96),('16273','2013-06-30','13:50:00',3.97),('16273','2013-06-30','13:55:00',3.86),('16273','2013-06-30','14:00:00',3.89),('16273','2013-06-30','14:05:00',3.82),('16273','2013-06-30','14:10:00',3.77),('16273','2013-06-30','14:15:00',3.7),('16273','2013-06-30','14:20:00',3.68),('16273','2013-06-30','14:25:00',3.66),('16273','2013-06-30','14:30:00',3.57),('16273','2013-06-30','14:35:00',3.56),('16273','2013-06-30','14:40:00',3.53),('16273','2013-06-30','14:45:00',3.51),('16273','2013-06-30','14:50:00',3.45),('16273','2013-06-30','14:55:00',3.47),('16273','2013-06-30','15:00:00',3.42),('16273','2013-06-30','15:05:00',3.38),('16273','2013-06-30','15:10:00',3.35),('16273','2013-06-30','15:15:00',3.31),('16273','2013-06-30','15:20:00',3.27),('16273','2013-06-30','15:25:00',3.22),('16273','2013-06-30','15:30:00',3.19),('16273','2013-06-30','15:35:00',3.14),('16273','2013-06-30','15:40:00',3.08),('16273','2013-06-30','15:45:00',2.99),('16273','2013-06-30','15:50:00',2.95),('16273','2013-06-30','15:55:00',2.77),('16273','2013-06-30','16:00:00',2.6),('16273','2013-06-30','16:05:00',2.74),('16273','2013-06-30','16:10:00',2.16),('16273','2013-06-30','16:15:00',2.72),('16273','2013-06-30','16:20:00',2.63),('16273','2013-06-30','16:25:00',2.55),('16273','2013-06-30','16:30:00',2.48),('16273','2013-06-30','16:35:00',2.38),('16273','2013-06-30','16:40:00',2.32),('16273','2013-06-30','16:45:00',2.22),('16273','2013-06-30','16:50:00',2.16),('16273','2013-06-30','16:55:00',2.07),('16273','2013-06-30','17:00:00',2.01),('16273','2013-06-30','17:05:00',1.92),('16273','2013-06-30','17:10:00',1.84),('16273','2013-06-30','17:15:00',1.76),('16273','2013-06-30','17:20:00',1.7),('16273','2013-06-30','17:25:00',1.59),('16273','2013-06-30','17:30:00',1.54),('16273','2013-06-30','17:35:00',1.47),('16273','2013-06-30','17:40:00',1.36),('16273','2013-06-30','17:45:00',1.32),('16273','2013-06-30','17:50:00',1.25),('16273','2013-06-30','17:55:00',1.16),('16273','2013-06-30','18:00:00',1.1),('16273','2013-06-30','18:05:00',1.04),('16273','2013-06-29','07:20:00',1.35),('16273','2013-06-29','07:25:00',1.18),('16273','2013-06-29','07:30:00',1.4),('16273','2013-06-29','07:45:00',1.22),('16273','2013-06-29','07:50:00',1.8),('16273','2013-06-29','07:55:00',1.79),('16273','2013-06-29','08:15:00',1.17),('16273','2013-06-29','08:20:00',2.24),('16273','2013-06-29','08:25:00',2.29),('16273','2013-06-29','08:30:00',2.43),('16273','2013-06-29','08:35:00',2.46),('16273','2013-06-29','08:40:00',2.53),('16273','2013-06-29','08:45:00',2.58),('16273','2013-06-29','08:50:00',2.64),('16273','2013-06-29','08:55:00',2.69),('16273','2013-06-29','09:00:00',2.74),('16273','2013-06-29','09:05:00',2.82),('16273','2013-06-29','09:10:00',2.89),('16273','2013-06-29','09:15:00',2.93),('16273','2013-06-29','09:20:00',2.95),('16273','2013-06-29','09:25:00',3.03),('16273','2013-06-29','09:30:00',3.04),('16273','2013-06-29','09:35:00',3.12),('16273','2013-06-29','09:40:00',3.19),('16273','2013-06-29','09:45:00',3.22),('16273','2013-06-29','09:50:00',3.27),('16273','2013-06-29','09:55:00',3.32),('16273','2013-06-29','10:00:00',3.36),('16273','2013-06-29','10:05:00',3.38),('16273','2013-06-29','10:10:00',3.44),('16273','2013-06-29','10:15:00',3.47),('16273','2013-06-29','10:20:00',3.54),('16273','2013-06-29','10:25:00',3.55),('16273','2013-06-29','10:30:00',3.52),('16273','2013-06-29','10:35:00',3.6),('16273','2013-06-29','10:40:00',3.72),('16273','2013-06-29','10:45:00',3.78),('16273','2013-06-29','10:50:00',3.86),('16273','2013-06-29','10:55:00',3.95),('16273','2013-06-29','11:00:00',3.93),('16273','2013-06-29','11:05:00',4.03),('16273','2013-06-29','11:10:00',2.76),('16273','2013-06-29','11:25:00',1.98),('16273','2013-06-29','11:30:00',1.83),('16273','2013-06-29','11:35:00',3.07),('16273','2013-06-29','11:40:00',4.27),('16273','2013-06-29','11:45:00',4.22),('16273','2013-06-29','11:50:00',3.57),('16273','2013-06-29','11:55:00',3.91),('16273','2013-06-29','12:00:00',4.08),('16273','2013-06-29','12:05:00',4.07),('16273','2013-06-29','12:10:00',4.12),('16273','2013-06-29','12:15:00',4.21),('16273','2013-06-29','12:20:00',3.27),('16273','2013-06-29','12:25:00',4.1),('16273','2013-06-29','12:30:00',1.16),('16273','2013-06-29','12:35:00',1.77),('16273','2013-06-29','12:40:00',2.86),('16273','2013-06-29','12:45:00',2.77),('16273','2013-06-29','12:50:00',1.38),('16273','2013-06-29','12:55:00',1.47),('16273','2013-06-29','13:00:00',2.68),('16273','2013-06-29','13:05:00',1.31),('16273','2013-06-29','13:10:00',4.37),('16273','2013-06-29','13:15:00',4.16),('16273','2013-06-29','13:20:00',3.98),('16273','2013-06-29','13:25:00',4.33),('16273','2013-06-29','13:30:00',4.37),('16273','2013-06-29','13:35:00',3.73),('16273','2013-06-29','13:40:00',4.06),('16273','2013-06-29','13:45:00',3.99),('16273','2013-06-29','13:50:00',3.98),('16273','2013-06-29','13:55:00',3.96),('16273','2013-06-29','14:00:00',3.9),('16273','2013-06-29','14:05:00',3.87),('16273','2013-06-29','14:10:00',3.87),('16273','2013-06-29','14:15:00',3.94),('16273','2013-06-29','14:20:00',3.94),('16273','2013-06-29','14:25:00',3.86),('16273','2013-06-29','14:30:00',3.86),('16273','2013-06-29','14:35:00',3.85),('16273','2013-06-29','14:40:00',3.79),('16273','2013-06-29','14:45:00',3.79),('16273','2013-06-29','14:50:00',3.77),('16273','2013-06-29','14:55:00',3.8),('16273','2013-06-29','15:00:00',3.72),('16273','2013-06-29','15:05:00',3.85),('16273','2013-06-29','15:10:00',3.9),('16273','2013-06-29','15:15:00',3.17),('16273','2013-06-29','15:20:00',2.57),('16273','2013-06-29','15:25:00',1.42),('16273','2013-06-29','15:30:00',1.43),('16273','2013-06-29','15:35:00',2.07),('16273','2013-06-29','15:40:00',2.25),('16273','2013-06-29','15:45:00',1.19),('16273','2013-06-29','16:15:00',1.06),('16273','2013-06-29','16:20:00',1.14),('16273','2013-06-29','16:25:00',1.3),('16273','2013-06-29','16:30:00',1.89),('16273','2013-06-29','16:35:00',2.41),('16273','2013-06-29','16:40:00',2.61),('16273','2013-06-29','16:45:00',1.98),('16273','2013-06-29','16:50:00',1.64),('16273','2013-06-29','16:55:00',1.84),('16273','2013-06-29','17:00:00',2.05),('16273','2013-06-29','17:05:00',2.61),('16273','2013-06-29','17:10:00',2.01),('16273','2013-06-29','17:15:00',2.43),('16273','2013-06-29','17:20:00',1.77),('16273','2013-06-29','17:25:00',1.23),('16273','2013-06-29','17:30:00',1.63),('16273','2013-06-29','17:35:00',1.09),('16273','2013-06-29','17:40:00',1.57),('16273','2013-06-29','17:45:00',1.49),('16273','2013-06-29','17:50:00',1.34),('16273','2013-06-29','17:55:00',1.22),('16273','2013-06-29','18:05:00',1.01),('16273','2013-06-29','18:10:00',1.03),('16273','2013-06-29','18:15:00',1.14),('16273','2013-06-28','07:10:00',1.12),('16273','2013-06-28','07:15:00',1.02),('16273','2013-06-28','07:25:00',1.38),('16273','2013-06-28','07:30:00',1.25),('16273','2013-06-28','07:35:00',1.55),('16273','2013-06-28','07:40:00',1.55),('16273','2013-06-28','07:45:00',1.53),('16273','2013-06-28','07:50:00',1.44),('16273','2013-06-28','07:55:00',1.51),('16273','2013-06-28','08:00:00',1.89),('16273','2013-06-28','08:05:00',1.93),('16273','2013-06-28','08:10:00',1.97),('16273','2013-06-28','08:15:00',2),('16273','2013-06-28','08:20:00',2.11),('16273','2013-06-28','08:25:00',2.33),('16273','2013-06-28','08:30:00',2.28),('16273','2013-06-28','08:35:00',2.19),('16273','2013-06-28','08:40:00',2.62),('16273','2013-06-28','08:45:00',2.42),('16273','2013-06-28','08:50:00',2.71),('16273','2013-06-28','08:55:00',2.68),('16273','2013-06-28','09:00:00',2.26),('16273','2013-06-28','09:05:00',2.86),('16273','2013-06-28','09:10:00',3),('16273','2013-06-28','09:15:00',3.15),('16273','2013-06-28','09:20:00',1.93),('16273','2013-06-28','09:25:00',2.39),('16273','2013-06-28','09:30:00',1.9),('16273','2013-06-28','09:35:00',2.09),('16273','2013-06-28','09:40:00',2.27),('16273','2013-06-28','09:45:00',3.5),('16273','2013-06-28','09:50:00',3.63),('16273','2013-06-28','09:55:00',3.45),('16273','2013-06-28','10:00:00',3.13),('16273','2013-06-28','10:05:00',3.41),('16273','2013-06-28','10:10:00',3.74),('16273','2013-06-28','10:15:00',3.7),('16273','2013-06-28','10:20:00',3.76),('16273','2013-06-28','10:25:00',3.83),('16273','2013-06-28','10:30:00',2.72),('16273','2013-06-28','10:35:00',2.37),('16273','2013-06-28','10:40:00',1.12),('16273','2013-06-28','10:45:00',3.12),('16273','2013-06-28','10:50:00',3.92),('16273','2013-06-28','10:55:00',3.95),('16273','2013-06-28','11:00:00',3.72),('16273','2013-06-28','11:05:00',3.75),('16273','2013-06-28','11:10:00',3.38),('16273','2013-06-28','11:15:00',3.32),('16273','2013-06-28','11:20:00',4.01),('16273','2013-06-28','11:25:00',3.71),('16273','2013-06-28','11:30:00',3.8),('16273','2013-06-28','11:35:00',3.84),('16273','2013-06-28','11:40:00',2.78),('16273','2013-06-28','11:45:00',3.28),('16273','2013-06-28','11:50:00',2.84),('16273','2013-06-28','11:55:00',2.69),('16273','2013-06-28','12:00:00',4.39),('16273','2013-06-28','12:05:00',2.95),('16273','2013-06-28','12:10:00',3.81),('16273','2013-06-28','12:15:00',3.7),('16273','2013-06-28','12:20:00',3.87),('16273','2013-06-28','12:25:00',4.31),('16273','2013-06-28','12:30:00',4.13),('16273','2013-06-28','12:35:00',4.17),('16273','2013-06-28','12:40:00',3.17),('16273','2013-06-28','12:45:00',3.65),('16273','2013-06-28','12:50:00',4.04),('16273','2013-06-28','12:55:00',4.25),('16273','2013-06-28','13:00:00',4.19),('16273','2013-06-28','13:05:00',3.85),('16273','2013-06-28','13:10:00',4.18),('16273','2013-06-28','13:15:00',3.57),('16273','2013-06-28','13:20:00',4.06),('16273','2013-06-28','13:25:00',4.11),('16273','2013-06-28','13:30:00',3.52),('16273','2013-06-28','13:35:00',4.09),('16273','2013-06-28','13:40:00',4.13),('16273','2013-06-28','13:45:00',3.24),('16273','2013-06-28','13:50:00',3.92),('16273','2013-06-28','13:55:00',4.05),('16273','2013-06-28','14:00:00',3.99),('16273','2013-06-28','14:05:00',4.07),('16273','2013-06-28','14:10:00',2.83),('16273','2013-06-28','14:15:00',4.2),('16273','2013-06-28','14:20:00',3.98),('16273','2013-06-28','14:25:00',4.04),('16273','2013-06-28','14:30:00',3.38),('16273','2013-06-28','14:35:00',3.95),('16273','2013-06-28','14:40:00',2.36),('16273','2013-06-28','14:45:00',3.78),('16273','2013-06-28','14:50:00',3.55),('16273','2013-06-28','14:55:00',2.99),('16273','2013-06-28','15:00:00',3.71),('16273','2013-06-28','15:05:00',3.35),('16273','2013-06-28','15:10:00',3.45),('16273','2013-06-28','15:15:00',3.15),('16273','2013-06-28','15:20:00',1.51),('16273','2013-06-28','15:25:00',3.65),('16273','2013-06-28','15:30:00',2.36),('16273','2013-06-28','15:35:00',3.62),('16273','2013-06-28','15:40:00',3.17),('16273','2013-06-28','15:45:00',2.52),('16273','2013-06-28','15:50:00',2.93),('16273','2013-06-28','15:55:00',3.19),('16273','2013-06-28','16:00:00',1.7),('16273','2013-06-28','16:05:00',2.16),('16273','2013-06-28','16:10:00',2.02),('16273','2013-06-28','16:15:00',2.66),('16273','2013-06-28','16:20:00',1.8),('16273','2013-06-28','16:25:00',1.78),('16273','2013-06-28','16:30:00',2.39),('16273','2013-06-28','16:35:00',2.66),('16273','2013-06-28','16:40:00',2.33),('16273','2013-06-28','16:45:00',2.26),('16273','2013-06-28','16:50:00',2.48),('16273','2013-06-28','16:55:00',1.8),('16273','2013-06-28','17:00:00',2.01),('16273','2013-06-28','17:05:00',1.79),('16273','2013-06-28','17:10:00',1.88),('16273','2013-06-28','17:15:00',1.79),('16273','2013-06-28','17:20:00',1.72),('16273','2013-06-28','17:25:00',1.63),('16273','2013-06-28','17:30:00',1.57),('16273','2013-06-28','17:35:00',1.5),('16273','2013-06-28','17:40:00',1.42),('16273','2013-06-28','17:45:00',1.35),('16273','2013-06-28','17:50:00',1.26),('16273','2013-06-28','17:55:00',1.19),('16273','2013-06-28','18:00:00',1.12),('16273','2013-06-28','18:05:00',1.09),('16273','2013-06-27','07:15:00',1.13),('16273','2013-06-27','07:20:00',1.22),('16273','2013-06-27','07:25:00',1.3),('16273','2013-06-27','07:30:00',1.4),('16273','2013-06-27','07:35:00',1.5),('16273','2013-06-27','07:40:00',1.58),('16273','2013-06-27','07:45:00',1.66),('16273','2013-06-27','07:50:00',1.74),('16273','2013-06-27','07:55:00',1.81),('16273','2013-06-27','08:00:00',1.91),('16273','2013-06-27','08:05:00',1.95),('16273','2013-06-27','08:10:00',2.02),('16273','2013-06-27','08:15:00',2.14),('16273','2013-06-27','08:20:00',2.23),('16273','2013-06-27','08:25:00',2.27),('16273','2013-06-27','08:30:00',2.31),('16273','2013-06-27','08:35:00',2.39),('16273','2013-06-27','08:40:00',2.44),('16273','2013-06-27','08:45:00',2.53),('16273','2013-06-27','08:50:00',2.67),('16273','2013-06-27','08:55:00',2.75),('16273','2013-06-27','09:00:00',2.76),('16273','2013-06-27','09:05:00',2.82),('16273','2013-06-27','09:10:00',2.89),('16273','2013-06-27','09:15:00',2.97),('16273','2013-06-27','09:20:00',3.06),('16273','2013-06-27','09:25:00',3.15),('16273','2013-06-27','09:30:00',3.18),('16273','2013-06-27','09:35:00',3.2),('16273','2013-06-27','09:40:00',3.2),('16273','2013-06-27','09:45:00',3.25),('16273','2013-06-27','09:50:00',3.31),('16273','2013-06-27','09:55:00',3.31),('16273','2013-06-27','10:00:00',3.37),('16273','2013-06-27','10:05:00',3.43),('16273','2013-06-27','10:10:00',3.44),('16273','2013-06-27','10:15:00',3.49),('16273','2013-06-27','10:20:00',3.64),('16273','2013-06-27','10:25:00',3.79),('16273','2013-06-27','10:30:00',3.94),('16273','2013-06-27','10:35:00',3.47),('16273','2013-06-27','10:40:00',3.77),('16273','2013-06-27','10:45:00',3.44),('16273','2013-06-27','10:50:00',3.97),('16273','2013-06-27','10:55:00',3.78),('16273','2013-06-27','11:00:00',1.58),('16273','2013-06-27','11:05:00',2.35),('16273','2013-06-27','11:10:00',3.38),('16273','2013-06-27','11:15:00',1.16),('16273','2013-06-27','11:20:00',1.36),('16273','2013-06-27','11:25:00',1.76),('16273','2013-06-27','11:30:00',1.92),('16273','2013-06-27','11:35:00',1.43),('16273','2013-06-27','11:40:00',1.41),('16273','2013-06-27','11:45:00',1.4),('16273','2013-06-27','11:50:00',4.03),('16273','2013-06-27','11:55:00',4.47),('16273','2013-06-27','12:00:00',4.42),('16273','2013-06-27','12:05:00',4.46),('16273','2013-06-27','12:10:00',3.39),('16273','2013-06-27','12:15:00',1.73),('16273','2013-06-27','12:20:00',3.28),('16273','2013-06-27','12:25:00',4.08),('16273','2013-06-27','12:30:00',2.22),('16273','2013-06-27','12:35:00',1.28),('16273','2013-06-27','12:40:00',1.47),('16273','2013-06-27','12:45:00',1.57),('16273','2013-06-27','12:50:00',1.64),('16273','2013-06-27','12:55:00',3.96),('16273','2013-06-27','13:00:00',3.86),('16273','2013-06-27','13:05:00',4.22),('16273','2013-06-27','13:10:00',4.15),('16273','2013-06-27','13:15:00',3.28),('16273','2013-06-27','13:20:00',2.86),('16273','2013-06-27','13:25:00',4.35),('16273','2013-06-27','13:30:00',4.34),('16273','2013-06-27','13:35:00',4.27),('16273','2013-06-27','13:40:00',4.16),('16273','2013-06-27','13:45:00',3.75),('16273','2013-06-27','13:50:00',3.92),('16273','2013-06-27','13:55:00',3.83),('16273','2013-06-27','14:00:00',3.76),('16273','2013-06-27','14:05:00',3.74),('16273','2013-06-27','14:10:00',3.7),('16273','2013-06-27','14:15:00',3.68),('16273','2013-06-27','14:20:00',3.69),('16273','2013-06-27','14:25:00',3.68),('16273','2013-06-27','14:30:00',3.69),('16273','2013-06-27','14:35:00',3.65),('16273','2013-06-27','14:40:00',3.69),('16273','2013-06-27','14:45:00',3.6),('16273','2013-06-27','14:50:00',3.44),('16273','2013-06-27','14:55:00',3.4),('16273','2013-06-27','15:00:00',3.37),('16273','2013-06-27','15:05:00',3.34),('16273','2013-06-27','15:10:00',3.3),('16273','2013-06-27','15:15:00',3.26),('16273','2013-06-27','15:20:00',3.24),('16273','2013-06-27','15:25:00',3.2),('16273','2013-06-27','15:30:00',3.14),('16273','2013-06-27','15:35:00',3.07),('16273','2013-06-27','15:40:00',2.98),('16273','2013-06-27','15:45:00',2.94),('16273','2013-06-27','15:50:00',2.86),('16273','2013-06-27','15:55:00',2.78),('16273','2013-06-27','16:00:00',2.72),('16273','2013-06-27','16:05:00',2.69),('16273','2013-06-27','16:10:00',2.65),('16273','2013-06-27','16:15:00',2.6),('16273','2013-06-27','16:20:00',2.55),('16273','2013-06-27','16:25:00',2.46),('16273','2013-06-27','16:30:00',2.34),('16273','2013-06-27','16:35:00',2.32),('16273','2013-06-27','16:40:00',2.27),('16273','2013-06-27','16:45:00',2.17),('16273','2013-06-27','16:50:00',2.14),('16273','2013-06-27','16:55:00',2.06),('16273','2013-06-27','17:00:00',1.95),('16273','2013-06-27','17:05:00',1.86),('16273','2013-06-27','17:10:00',1.8),('16273','2013-06-27','17:15:00',1.8),('16273','2013-06-27','17:20:00',1.73),('16273','2013-06-27','17:25:00',1.67),('16273','2013-06-27','17:30:00',1.57),('16273','2013-06-27','17:35:00',1.49),('16273','2013-06-27','17:40:00',1.42),('16273','2013-06-27','17:45:00',1.36),('16273','2013-06-27','17:50:00',1.26),('16273','2013-06-27','17:55:00',1.19),('16273','2013-06-27','18:00:00',1.13),('16273','2013-06-27','18:05:00',1.07),('16273','2013-06-26','07:05:00',1.01),('16273','2013-06-26','07:10:00',1.09),('16273','2013-06-26','07:15:00',1.17),('16273','2013-06-26','07:20:00',1.25),('16273','2013-06-26','07:25:00',1.32),('16273','2013-06-26','07:30:00',1.41),('16273','2013-06-26','07:35:00',1.48),('16273','2013-06-26','07:40:00',1.57),('16273','2013-06-26','07:45:00',1.66),('16273','2013-06-26','07:50:00',1.72),('16273','2013-06-26','07:55:00',1.78),('16273','2013-06-26','08:00:00',1.87),('16273','2013-06-26','08:05:00',1.97),('16273','2013-06-26','08:10:00',2.04),('16273','2013-06-26','08:15:00',2.11),('16273','2013-06-26','08:20:00',2.2),('16273','2013-06-26','08:25:00',2.27),('16273','2013-06-26','08:30:00',2.31),('16273','2013-06-26','08:35:00',2.39),('16273','2013-06-26','08:40:00',2.48),('16273','2013-06-26','08:45:00',2.53),('16273','2013-06-26','08:50:00',2.59),('16273','2013-06-26','08:55:00',2.66),('16273','2013-06-26','09:00:00',2.7),('16273','2013-06-26','09:05:00',2.76),('16273','2013-06-26','09:10:00',2.81),('16273','2013-06-26','09:15:00',2.87),('16273','2013-06-26','09:20:00',2.91),('16273','2013-06-26','09:25:00',2.99),('16273','2013-06-26','09:30:00',3.04),('16273','2013-06-26','09:35:00',3.07),('16273','2013-06-26','09:40:00',3.11),('16273','2013-06-26','09:45:00',3.14),('16273','2013-06-26','09:50:00',3.18),('16273','2013-06-26','09:55:00',3.25),('16273','2013-06-26','10:00:00',3.29),('16273','2013-06-26','10:05:00',3.37),('16273','2013-06-26','10:10:00',3.44),('16273','2013-06-26','10:15:00',3.46),('16273','2013-06-26','10:20:00',3.48),('16273','2013-06-26','10:25:00',3.52),('16273','2013-06-26','10:30:00',3.53),('16273','2013-06-26','10:35:00',3.55),('16273','2013-06-26','10:40:00',3.59),('16273','2013-06-26','10:45:00',3.63),('16273','2013-06-26','10:50:00',3.66),('16273','2013-06-26','10:55:00',3.68),('16273','2013-06-26','11:00:00',3.68),('16273','2013-06-26','11:05:00',3.71),('16273','2013-06-26','11:10:00',3.75),('16273','2013-06-26','11:15:00',3.78),('16273','2013-06-26','11:20:00',3.78),('16273','2013-06-26','11:25:00',3.81),('16273','2013-06-26','11:30:00',3.82),('16273','2013-06-26','11:35:00',3.83),('16273','2013-06-26','11:40:00',3.87),('16273','2013-06-26','11:45:00',3.91),('16273','2013-06-26','11:50:00',3.94),('16273','2013-06-26','11:55:00',3.9),('16273','2013-06-26','12:00:00',3.91),('16273','2013-06-26','12:05:00',3.95),('16273','2013-06-26','12:10:00',3.95),('16273','2013-06-26','12:15:00',3.98),('16273','2013-06-26','12:20:00',3.97),('16273','2013-06-26','12:25:00',4.04),('16273','2013-06-26','12:30:00',4.02),('16273','2013-06-26','12:35:00',4.03),('16273','2013-06-26','12:40:00',4.07),('16273','2013-06-26','12:45:00',4.11),('16273','2013-06-26','12:50:00',4.11),('16273','2013-06-26','12:55:00',4.14),('16273','2013-06-26','13:00:00',4.16),('16273','2013-06-26','13:05:00',4.22),('16273','2013-06-26','13:10:00',2.81),('16273','2013-06-26','13:15:00',1.05),('16273','2013-06-26','13:20:00',1.48),('16273','2013-06-26','13:25:00',4.41),('16273','2013-06-26','13:30:00',4.13),('16273','2013-06-26','13:35:00',4.01),('16273','2013-06-26','13:40:00',3.98),('16273','2013-06-26','13:45:00',3.93),('16273','2013-06-26','13:50:00',3.82),('16273','2013-06-26','13:55:00',3.8),('16273','2013-06-26','14:00:00',3.76),('16273','2013-06-26','14:05:00',3.72),('16273','2013-06-26','14:10:00',3.71),('16273','2013-06-26','14:15:00',3.66),('16273','2013-06-26','14:20:00',3.65),('16273','2013-06-26','14:25:00',3.63),('16273','2013-06-26','14:30:00',3.63),('16273','2013-06-26','14:35:00',3.6),('16273','2013-06-26','14:40:00',3.56),('16273','2013-06-26','14:45:00',3.52),('16273','2013-06-26','14:50:00',3.47),('16273','2013-06-26','14:55:00',3.44),('16273','2013-06-26','15:00:00',3.38),('16273','2013-06-26','15:05:00',3.34),('16273','2013-06-26','15:10:00',3.27),('16273','2013-06-26','15:15:00',3.25),('16273','2013-06-26','15:20:00',3.18),('16273','2013-06-26','15:25:00',3.16),('16273','2013-06-26','15:30:00',3.11),('16273','2013-06-26','15:35:00',3.06),('16273','2013-06-26','15:40:00',3.01),('16273','2013-06-26','15:45:00',2.95),('16273','2013-06-26','15:50:00',2.88),('16273','2013-06-26','15:55:00',2.83),('16273','2013-06-26','16:00:00',2.78),('16273','2013-06-26','16:05:00',2.73),('16273','2013-06-26','16:10:00',2.68),('16273','2013-06-26','16:15:00',2.62),('16273','2013-06-26','16:20:00',2.55),('16273','2013-06-26','16:25:00',2.48),('16273','2013-06-26','16:30:00',2.43),('16273','2013-06-26','16:35:00',2.34),('16273','2013-06-26','16:40:00',2.27),('16273','2013-06-26','16:45:00',2.22),('16273','2013-06-26','16:50:00',2.13),('16273','2013-06-26','16:55:00',2.06),('16273','2013-06-26','17:00:00',1.98),('16273','2013-06-26','17:05:00',1.91),('16273','2013-06-26','17:10:00',1.85),('16273','2013-06-26','17:15:00',1.77),('16273','2013-06-26','17:20:00',1.7),('16273','2013-06-26','17:25:00',1.63),('16273','2013-06-26','17:30:00',1.57),('16273','2013-06-26','17:35:00',1.48),('16273','2013-06-26','17:40:00',1.41),('16273','2013-06-26','17:45:00',1.33),('16273','2013-06-26','17:50:00',1.27),('16273','2013-06-26','17:55:00',1.19),('16273','2013-06-26','18:00:00',1.11),('16273','2013-06-26','18:05:00',1.04),('16273','2013-06-26','18:25:00',1.01),('16273','2013-06-25','07:10:00',1.04),('16273','2013-06-25','07:15:00',1.12),('16273','2013-06-25','07:20:00',1.03),('16273','2013-06-25','07:30:00',1.36),('16273','2013-06-25','07:35:00',1.46),('16273','2013-06-25','07:40:00',1.52),('16273','2013-06-25','07:45:00',1.63),('16273','2013-06-25','07:50:00',1.66),('16273','2013-06-25','07:55:00',1.65),('16273','2013-06-25','08:05:00',1.99),('16273','2013-06-25','08:10:00',2.08),('16273','2013-06-25','08:15:00',2.12),('16273','2013-06-25','08:20:00',2.22),('16273','2013-06-25','08:25:00',2.31),('16273','2013-06-25','08:30:00',2.34),('16273','2013-06-25','08:35:00',2.41),('16273','2013-06-25','08:40:00',2.52),('16273','2013-06-25','08:45:00',2.55),('16273','2013-06-25','08:50:00',2.63),('16273','2013-06-25','08:55:00',2.66),('16273','2013-06-25','09:00:00',2.65),('16273','2013-06-25','09:05:00',2.74),('16273','2013-06-25','09:10:00',2.91),('16273','2013-06-25','09:15:00',1.83),('16273','2013-06-25','09:20:00',1.06),('16273','2013-06-25','09:25:00',1.58),('16273','2013-06-25','09:30:00',1.1),('16273','2013-06-25','09:35:00',2.84),('16273','2013-06-25','09:40:00',3.53),('16273','2013-06-25','09:45:00',3.58),('16273','2013-06-25','09:50:00',3.55),('16273','2013-06-25','09:55:00',3.12),('16273','2013-06-25','10:00:00',2.18),('16273','2013-06-25','10:05:00',1.36),('16273','2013-06-25','10:10:00',1.04),('16273','2013-06-25','10:15:00',1.41),('16273','2013-06-25','10:20:00',2.37),('16273','2013-06-25','10:25:00',1.19),('16273','2013-06-25','10:30:00',2.02),('16273','2013-06-25','10:35:00',3.81),('16273','2013-06-25','10:40:00',3.9),('16273','2013-06-25','10:45:00',3.92),('16273','2013-06-25','10:50:00',3.87),('16273','2013-06-25','10:55:00',3.92),('16273','2013-06-25','11:00:00',3.99),('16273','2013-06-25','11:05:00',4.02),('16273','2013-06-25','11:10:00',4.07),('16273','2013-06-25','11:15:00',4.11),('16273','2013-06-25','11:20:00',3.6),('16273','2013-06-25','11:25:00',4.19),('16273','2013-06-25','11:30:00',4.3),('16273','2013-06-25','11:35:00',3.4),('16273','2013-06-25','11:40:00',2.92),('16273','2013-06-25','11:45:00',2.59),('16273','2013-06-25','11:50:00',3.22),('16273','2013-06-25','11:55:00',3.59),('16273','2013-06-25','12:00:00',4.48),('16273','2013-06-25','12:05:00',3.82),('16273','2013-06-25','12:10:00',3.61),('16273','2013-06-25','12:15:00',1.75),('16273','2013-06-25','12:20:00',2.86),('16273','2013-06-25','12:25:00',3.11),('16273','2013-06-25','12:30:00',3.99),('16273','2013-06-25','12:35:00',4.32),('16273','2013-06-25','12:40:00',3.47),('16273','2013-06-25','12:45:00',3.15),('16273','2013-06-25','12:50:00',2.54),('16273','2013-06-25','12:55:00',4.25),('16273','2013-06-25','13:00:00',4.15),('16273','2013-06-25','13:05:00',4.13),('16273','2013-06-25','13:10:00',4.04),('16273','2013-06-25','13:15:00',4.04),('16273','2013-06-25','13:20:00',3.99),('16273','2013-06-25','13:25:00',3.98),('16273','2013-06-25','13:30:00',3.97),('16273','2013-06-25','13:35:00',3.95),('16273','2013-06-25','13:40:00',3.92),('16273','2013-06-25','13:45:00',3.9),('16273','2013-06-25','13:50:00',3.87),('16273','2013-06-25','13:55:00',3.85),('16273','2013-06-25','14:00:00',3.83),('16273','2013-06-25','14:05:00',3.8),('16273','2013-06-25','14:10:00',3.75),('16273','2013-06-25','14:15:00',3.72),('16273','2013-06-25','14:20:00',3.7),('16273','2013-06-25','14:25:00',3.66),('16273','2013-06-25','14:30:00',3.64),('16273','2013-06-25','14:35:00',3.59),('16273','2013-06-25','14:40:00',3.55),('16273','2013-06-25','14:45:00',3.51),('16273','2013-06-25','14:50:00',3.5),('16273','2013-06-25','14:55:00',3.45),('16273','2013-06-25','15:00:00',3.41),('16273','2013-06-25','15:05:00',3.35),('16273','2013-06-25','15:10:00',3.33),('16273','2013-06-25','15:15:00',3.28),('16273','2013-06-25','15:20:00',3.22),('16273','2013-06-25','15:25:00',3.17),('16273','2013-06-25','15:30:00',3.12),('16273','2013-06-25','15:35:00',3.06),('16273','2013-06-25','15:40:00',3.01),('16273','2013-06-25','15:45:00',2.95),('16273','2013-06-25','15:50:00',2.89),('16273','2013-06-25','15:55:00',2.83),('16273','2013-06-25','16:00:00',2.76),('16273','2013-06-25','16:05:00',2.72),('16273','2013-06-25','16:10:00',2.65),('16273','2013-06-25','16:15:00',2.58),('16273','2013-06-25','16:20:00',2.5),('16273','2013-06-25','16:25:00',2.46),('16273','2013-06-25','16:30:00',2.38),('16273','2013-06-25','16:35:00',2.31),('16273','2013-06-25','16:40:00',2.25),('16273','2013-06-25','16:45:00',2.19),('16273','2013-06-25','16:50:00',2.11),('16273','2013-06-25','16:55:00',2.04),('16273','2013-06-25','17:00:00',1.97),('16273','2013-06-25','17:05:00',1.9),('16273','2013-06-25','17:10:00',1.82),('16273','2013-06-25','17:15:00',1.75),('16273','2013-06-25','17:20:00',1.68),('16273','2013-06-25','17:25:00',1.6),('16273','2013-06-25','17:30:00',1.52),('16273','2013-06-25','17:35:00',1.44),('16273','2013-06-25','17:40:00',1.37),('16273','2013-06-25','17:45:00',1.3),('16273','2013-06-25','17:50:00',1.23),('16273','2013-06-25','17:55:00',1.15),('16273','2013-06-25','18:00:00',1.08),('16273','2013-06-25','18:05:00',1.01),('16273','2013-06-24','07:05:00',1.01),('16273','2013-06-24','08:10:00',1.52),('16273','2013-06-24','08:15:00',2.32),('16273','2013-06-24','08:20:00',2.31),('16273','2013-06-24','08:25:00',2.27),('16273','2013-06-24','08:30:00',1.26),('16273','2013-06-24','08:35:00',2.33),('16273','2013-06-24','08:40:00',2.49),('16273','2013-06-24','08:45:00',2.65),('16273','2013-06-24','08:50:00',2.92),('16273','2013-06-24','08:55:00',2.48),('16273','2013-06-24','09:00:00',1.02),('16273','2013-06-24','09:05:00',1.24),('16273','2013-06-24','09:10:00',1.4),('16273','2013-06-24','09:15:00',2.33),('16273','2013-06-24','09:20:00',1.72),('16273','2013-06-24','09:25:00',3.25),('16273','2013-06-24','09:30:00',3.41),('16273','2013-06-24','09:35:00',3.12),('16273','2013-06-24','09:40:00',3.39),('16273','2013-06-24','09:45:00',3.41),('16273','2013-06-24','09:50:00',3.43),('16273','2013-06-24','09:55:00',3.51),('16273','2013-06-24','10:00:00',3.68),('16273','2013-06-24','10:05:00',2.26),('16273','2013-06-24','10:10:00',2.74),('16273','2013-06-24','10:15:00',3.66),('16273','2013-06-24','10:20:00',4.05),('16273','2013-06-24','10:25:00',3.33),('16273','2013-06-24','10:30:00',2.96),('16273','2013-06-24','10:35:00',4.22),('16273','2013-06-24','10:40:00',2.82),('16273','2013-06-24','10:45:00',1.79),('16273','2013-06-24','10:50:00',1.62),('16273','2013-06-24','10:55:00',2.23),('16273','2013-06-24','11:00:00',3.97),('16273','2013-06-24','11:05:00',1.76),('16273','2013-06-24','11:10:00',2.33),('16273','2013-06-24','11:15:00',1.63),('16273','2013-06-24','11:20:00',1.19),('16273','2013-06-24','11:25:00',1.16),('16273','2013-06-24','11:30:00',1.37),('16273','2013-06-24','11:35:00',1.38),('16273','2013-06-24','11:40:00',2.13),('16273','2013-06-24','11:45:00',1.97),('16273','2013-06-24','11:50:00',3.49),('16273','2013-06-24','11:55:00',2.68),('16273','2013-06-24','12:00:00',3.72),('16273','2013-06-24','12:05:00',3.69),('16273','2013-06-24','12:10:00',1.26),('16273','2013-06-24','12:15:00',4.09),('16273','2013-06-24','12:20:00',4.48),('16273','2013-06-24','12:25:00',3.9),('16273','2013-06-24','12:30:00',3.38),('16273','2013-06-24','12:35:00',2.48),('16273','2013-06-24','12:40:00',3.09),('16273','2013-06-24','12:45:00',3.71),('16273','2013-06-24','12:50:00',4.46),('16273','2013-06-24','12:55:00',1.97),('16273','2013-06-24','13:00:00',3.09),('16273','2013-06-24','13:05:00',3.9),('16273','2013-06-24','13:10:00',3.85),('16273','2013-06-24','13:15:00',2.6),('16273','2013-06-24','13:20:00',3.15),('16273','2013-06-24','13:25:00',3.09),('16273','2013-06-24','13:30:00',3.45),('16273','2013-06-24','13:35:00',4.06),('16273','2013-06-24','13:40:00',3.78),('16273','2013-06-24','13:45:00',3.44),('16273','2013-06-24','13:50:00',4.12),('16273','2013-06-24','13:55:00',4.14),('16273','2013-06-24','14:00:00',3.52),('16273','2013-06-24','14:05:00',3.88),('16273','2013-06-24','14:10:00',3.84),('16273','2013-06-24','14:15:00',3.94),('16273','2013-06-24','14:20:00',3.71),('16273','2013-06-24','14:25:00',3.1),('16273','2013-06-24','14:30:00',3.12),('16273','2013-06-24','14:35:00',4.14),('16273','2013-06-24','14:40:00',3.02),('16273','2013-06-24','14:45:00',3.31),('16273','2013-06-24','14:50:00',2.52),('16273','2013-06-24','14:55:00',3.14),('16273','2013-06-24','15:00:00',3.86),('16273','2013-06-24','15:05:00',2.38),('16273','2013-06-24','15:10:00',3.26),('16273','2013-06-24','15:15:00',2.61),('16273','2013-06-24','15:20:00',2.92),('16273','2013-06-24','15:25:00',2.9),('16273','2013-06-24','15:30:00',1.66),('16273','2013-06-24','15:35:00',3.44),('16273','2013-06-24','15:40:00',3.5),('16273','2013-06-24','15:45:00',3.42),('16273','2013-06-24','15:50:00',3.67),('16273','2013-06-24','15:55:00',1.71),('16273','2013-06-24','16:00:00',2.3),('16273','2013-06-24','16:05:00',1.69),('16273','2013-06-24','16:10:00',1.65),('16273','2013-06-24','16:15:00',2.84),('16273','2013-06-24','16:25:00',1.77),('16273','2013-06-24','16:30:00',1.51),('16273','2013-06-24','16:35:00',2.07),('16273','2013-06-24','16:40:00',1.71),('16273','2013-06-24','16:45:00',1.15),('16273','2013-06-24','16:50:00',1.09),('16273','2013-06-24','16:55:00',1.01),('16273','2013-06-24','17:00:00',1.16),('16273','2013-06-24','17:05:00',1.48),('16273','2013-06-24','17:10:00',1.97),('16273','2013-06-24','17:15:00',1.34),('16273','2013-06-24','17:20:00',1.95),('16273','2013-06-24','17:25:00',1.55),('16273','2013-06-24','17:35:00',1.71),('16273','2013-06-24','17:45:00',1.2),('16273','2013-06-24','18:00:00',1.03),('16273','2013-06-23','08:45:00',1.22),('16273','2013-06-23','08:50:00',1.16),('16273','2013-06-23','08:55:00',1.2),('16273','2013-06-23','09:05:00',1.03),('16273','2013-06-23','09:10:00',2.06),('16273','2013-06-23','09:15:00',2.85),('16273','2013-06-23','09:20:00',3.05),('16273','2013-06-23','09:25:00',2.71),('16273','2013-06-23','09:30:00',2.54),('16273','2013-06-23','09:35:00',3.13),('16273','2013-06-23','09:40:00',2.1),('16273','2013-06-23','09:45:00',3.42),('16273','2013-06-23','09:50:00',3.32),('16273','2013-06-23','09:55:00',3.37),('16273','2013-06-23','10:00:00',3.39),('16273','2013-06-23','10:05:00',3.41),('16273','2013-06-23','10:10:00',3.04),('16273','2013-06-23','10:15:00',3.14),('16273','2013-06-23','10:20:00',3.38),('16273','2013-06-23','10:25:00',3.49),('16273','2013-06-23','10:30:00',3.4),('16273','2013-06-23','10:35:00',3.48),('16273','2013-06-23','10:40:00',3.51),('16273','2013-06-23','10:45:00',3.6),('16273','2013-06-23','10:50:00',3.65),('16273','2013-06-23','10:55:00',3.69),('16273','2013-06-23','11:00:00',3.71),('16273','2013-06-23','11:05:00',3.69),('16273','2013-06-23','11:10:00',3.71),('16273','2013-06-23','11:15:00',3.74),('16273','2013-06-23','11:20:00',3.68),('16273','2013-06-23','11:25:00',3.75),('16273','2013-06-23','11:30:00',3.81),('16273','2013-06-23','11:35:00',3.82),('16273','2013-06-23','11:40:00',3.79),('16273','2013-06-23','11:45:00',3.84),('16273','2013-06-23','11:50:00',3.86),('16273','2013-06-23','11:55:00',3.86),('16273','2013-06-23','12:00:00',3.92),('16273','2013-06-23','12:05:00',3.94),('16273','2013-06-23','12:10:00',3.96),('16273','2013-06-23','12:15:00',3.91),('16273','2013-06-23','12:20:00',3.95),('16273','2013-06-23','12:25:00',3.97),('16273','2013-06-23','12:30:00',3.99),('16273','2013-06-23','12:35:00',3.98),('16273','2013-06-23','12:40:00',3.97),('16273','2013-06-23','12:45:00',3.98),('16273','2013-06-23','12:50:00',3.94),('16273','2013-06-23','12:55:00',3.94),('16273','2013-06-23','13:00:00',3.94),('16273','2013-06-23','13:05:00',3.96),('16273','2013-06-23','13:10:00',3.95),('16273','2013-06-23','13:15:00',3.93),('16273','2013-06-23','13:20:00',3.94),('16273','2013-06-23','13:25:00',3.9),('16273','2013-06-23','13:30:00',3.92),('16273','2013-06-23','13:35:00',3.9),('16273','2013-06-23','13:40:00',3.88),('16273','2013-06-23','13:45:00',3.9),('16273','2013-06-23','13:50:00',3.9),('16273','2013-06-23','13:55:00',3.87),('16273','2013-06-23','14:00:00',3.85),('16273','2013-06-23','14:05:00',3.82),('16273','2013-06-23','14:10:00',3.81),('16273','2013-06-23','14:15:00',3.79),('16273','2013-06-23','14:20:00',3.74),('16273','2013-06-23','14:25:00',3.7),('16273','2013-06-23','14:30:00',3.67),('16273','2013-06-23','14:35:00',3.65),('16273','2013-06-23','14:40:00',3.61),('16273','2013-06-23','14:45:00',3.56),('16273','2013-06-23','14:50:00',3.52),('16273','2013-06-23','14:55:00',3.49),('16273','2013-06-23','15:00:00',3.26),('16273','2013-06-23','15:05:00',3.41),('16273','2013-06-23','15:10:00',3.35),('16273','2013-06-23','15:15:00',3.32),('16273','2013-06-23','15:20:00',3.24),('16273','2013-06-23','15:25:00',3.22),('16273','2013-06-23','15:30:00',3.16),('16273','2013-06-23','15:35:00',3.1),('16273','2013-06-23','15:40:00',3.05),('16273','2013-06-23','15:45:00',2.99),('16273','2013-06-23','15:50:00',2.94),('16273','2013-06-23','15:55:00',2.88),('16273','2013-06-23','16:00:00',2.81),('16273','2013-06-23','16:05:00',2.74),('16273','2013-06-23','16:10:00',2.69),('16273','2013-06-23','16:15:00',2.64),('16273','2013-06-23','16:20:00',2.58),('16273','2013-06-23','16:25:00',2.51),('16273','2013-06-23','16:30:00',2.42),('16273','2013-06-23','16:35:00',2.37),('16273','2013-06-23','16:40:00',2.3),('16273','2013-06-23','16:45:00',2.22),('16273','2013-06-23','16:50:00',2.15),('16273','2013-06-23','16:55:00',2.08),('16273','2013-06-23','17:00:00',2.01),('16273','2013-06-23','17:05:00',1.88),('16273','2013-06-23','17:10:00',1.68),('16273','2013-06-23','17:15:00',1.73),('16273','2013-06-23','17:20:00',1.71),('16273','2013-06-23','17:25:00',1.64),('16273','2013-06-23','17:30:00',1.55),('16273','2013-06-23','17:35:00',1.48),('16273','2013-06-23','17:40:00',1.41),('16273','2013-06-23','17:45:00',1.32),('16273','2013-06-23','17:50:00',1.25),('16273','2013-06-23','17:55:00',1.2),('16273','2013-06-23','18:00:00',1.1),('16273','2013-06-23','18:05:00',1.01),('16273','2013-06-22','07:10:00',1.01),('16273','2013-06-22','07:15:00',1.08),('16273','2013-06-22','07:20:00',1.13),('16273','2013-06-22','07:25:00',1.21),('16273','2013-06-22','07:30:00',1.25),('16273','2013-06-22','07:35:00',1.33),('16273','2013-06-22','07:40:00',1.41),('16273','2013-06-22','07:45:00',1.51),('16273','2013-06-22','07:50:00',1.61),('16273','2013-06-22','07:55:00',1.68),('16273','2013-06-22','08:00:00',1.72),('16273','2013-06-22','08:05:00',1.79),('16273','2013-06-22','08:10:00',1.89),('16273','2013-06-22','08:15:00',1.96),('16273','2013-06-22','08:20:00',2.04),('16273','2013-06-22','08:25:00',2.08),('16273','2013-06-22','08:30:00',2.18),('16273','2013-06-22','08:35:00',2.26),('16273','2013-06-22','08:40:00',2.34),('16273','2013-06-22','08:45:00',2.41),('16273','2013-06-22','08:50:00',2.49),('16273','2013-06-22','08:55:00',2.55),('16273','2013-06-22','09:00:00',2.6),('16273','2013-06-22','09:05:00',2.64),('16273','2013-06-22','09:10:00',2.7),('16273','2013-06-22','09:15:00',2.74),('16273','2013-06-22','09:20:00',2.83),('16273','2013-06-22','09:25:00',2.89),('16273','2013-06-22','09:30:00',2.95),('16273','2013-06-22','09:35:00',3.01),('16273','2013-06-22','09:40:00',3.04),('16273','2013-06-22','09:45:00',3.1),('16273','2013-06-22','09:50:00',3.17),('16273','2013-06-22','09:55:00',3.2),('16273','2013-06-22','10:00:00',3.22),('16273','2013-06-22','10:05:00',3.29),('16273','2013-06-22','10:10:00',3.35),('16273','2013-06-22','10:15:00',3.39),('16273','2013-06-22','10:20:00',3.37),('16273','2013-06-22','10:25:00',3.42),('16273','2013-06-22','10:30:00',3.45),('16273','2013-06-22','10:35:00',3.52),('16273','2013-06-22','10:40:00',3.55),('16273','2013-06-22','10:45:00',3.56),('16273','2013-06-22','10:50:00',3.6),('16273','2013-06-22','10:55:00',3.62),('16273','2013-06-22','11:00:00',3.63),('16273','2013-06-22','11:05:00',3.66),('16273','2013-06-22','11:10:00',3.69),('16273','2013-06-22','11:15:00',3.7),('16273','2013-06-22','11:20:00',3.72),('16273','2013-06-22','11:25:00',3.76),('16273','2013-06-22','11:30:00',3.76),('16273','2013-06-22','11:35:00',3.81),('16273','2013-06-22','11:40:00',3.78),('16273','2013-06-22','11:45:00',3.8),('16273','2013-06-22','11:50:00',3.79),('16273','2013-06-22','11:55:00',3.9),('16273','2013-06-22','12:00:00',3.85),('16273','2013-06-22','12:05:00',3.85),('16273','2013-06-22','12:10:00',3.86),('16273','2013-06-22','12:15:00',3.85),('16273','2013-06-22','12:20:00',3.86),('16273','2013-06-22','12:25:00',3.86),('16273','2013-06-22','12:30:00',3.82),('16273','2013-06-22','12:35:00',3.87),('16273','2013-06-22','12:40:00',3.81),('16273','2013-06-22','12:45:00',3.81),('16273','2013-06-22','12:50:00',3.78),('16273','2013-06-22','12:55:00',3.74),('16273','2013-06-22','13:00:00',3.72),('16273','2013-06-22','13:05:00',3.68),('16273','2013-06-22','13:10:00',3.86),('16273','2013-06-22','13:15:00',3.86),('16273','2013-06-22','13:20:00',3.86),('16273','2013-06-22','13:25:00',3.88),('16273','2013-06-22','13:30:00',3.78),('16273','2013-06-22','13:35:00',3.54),('16273','2013-06-22','13:40:00',3.49),('16273','2013-06-22','13:45:00',3.83),('16273','2013-06-22','13:50:00',2.53),('16273','2013-06-22','13:55:00',3.85),('16273','2013-06-22','14:00:00',4.03),('16273','2013-06-22','14:05:00',3.87),('16273','2013-06-22','14:10:00',3.5),('16273','2013-06-22','14:15:00',2.17),('16273','2013-06-22','14:20:00',3.13),('16273','2013-06-22','14:25:00',2.17),('16273','2013-06-22','14:30:00',1.73),('16273','2013-06-22','14:35:00',1.97),('16273','2013-06-22','14:40:00',2.8),('16273','2013-06-22','14:45:00',3.44),('16273','2013-06-22','14:50:00',3.62),('16273','2013-06-22','14:55:00',3.53),('16273','2013-06-22','15:00:00',3.07),('16273','2013-06-22','15:05:00',3.35),('16273','2013-06-22','15:10:00',3.44),('16273','2013-06-22','15:15:00',3.37),('16273','2013-06-22','15:20:00',3.11),('16273','2013-06-22','15:25:00',3.03),('16273','2013-06-22','15:30:00',2.68),('16273','2013-06-22','15:35:00',2.14),('16273','2013-06-22','15:40:00',1.85),('16273','2013-06-22','15:45:00',1.55),('16273','2013-06-22','15:50:00',1.95),('16273','2013-06-22','15:55:00',1.5),('16273','2013-06-22','16:00:00',1.25),('16273','2013-06-22','16:05:00',1.21),('16273','2013-06-22','16:10:00',1.47),('16273','2013-06-22','16:15:00',1.44),('16273','2013-06-22','16:20:00',1.23),('16273','2013-06-22','16:25:00',1.12),('16273','2013-06-22','16:50:00',1.3),('16273','2013-06-22','16:55:00',1.76),('16273','2013-06-22','17:00:00',1.92),('16273','2013-06-22','17:05:00',1.91),('16273','2013-06-22','17:10:00',2.04),('16273','2013-06-22','17:15:00',2.03),('16273','2013-06-22','17:20:00',2.08),('16273','2013-06-22','17:25:00',1.81),('16273','2013-06-22','17:30:00',1.7),('16273','2013-06-22','17:35:00',1.54),('16273','2013-06-22','17:40:00',1.47),('16273','2013-06-22','17:45:00',1.32),('16273','2013-06-22','17:50:00',1.22),('16273','2013-06-22','17:55:00',1.15),('16273','2013-06-21','07:15:00',1.04),('16273','2013-06-21','07:20:00',1.11),('16273','2013-06-21','07:25:00',1.18),('16273','2013-06-21','07:30:00',1.25),('16273','2013-06-21','07:35:00',1.34),('16273','2013-06-21','07:40:00',1.42),('16273','2013-06-21','07:45:00',1.49),('16273','2013-06-21','07:50:00',1.58),('16273','2013-06-21','07:55:00',1.66),('16273','2013-06-21','08:00:00',1.72),('16273','2013-06-21','08:05:00',1.81),('16273','2013-06-21','08:10:00',1.88),('16273','2013-06-21','08:15:00',1.95),('16273','2013-06-21','08:20:00',2.01),('16273','2013-06-21','08:25:00',2.08),('16273','2013-06-21','08:30:00',2.12),('16273','2013-06-21','08:35:00',2.22),('16273','2013-06-21','08:40:00',2.27),('16273','2013-06-21','08:45:00',2.35),('16273','2013-06-21','08:50:00',2.43),('16273','2013-06-21','08:55:00',2.49),('16273','2013-06-21','09:00:00',2.55),('16273','2013-06-21','09:05:00',2.61),('16273','2013-06-21','09:10:00',2.65),('16273','2013-06-21','09:15:00',2.7),('16273','2013-06-21','09:20:00',2.71),('16273','2013-06-21','09:25:00',2.81),('16273','2013-06-21','09:30:00',2.87),('16273','2013-06-21','09:35:00',2.89),('16273','2013-06-21','09:40:00',2.97),('16273','2013-06-21','09:45:00',3.04),('16273','2013-06-21','09:50:00',3.07),('16273','2013-06-21','09:55:00',3.11),('16273','2013-06-21','10:00:00',3.11),('16273','2013-06-21','10:05:00',3.14),('16273','2013-06-21','10:10:00',3.21),('16273','2013-06-21','10:15:00',3.27),('16273','2013-06-21','10:20:00',3.29),('16273','2013-06-21','10:25:00',3.3),('16273','2013-06-21','10:30:00',3.29),('16273','2013-06-21','10:35:00',3.36),('16273','2013-06-21','10:40:00',3.39),('16273','2013-06-21','10:45:00',3.41),('16273','2013-06-21','10:50:00',3.45),('16273','2013-06-21','10:55:00',3.45),('16273','2013-06-21','11:00:00',3.48),('16273','2013-06-21','11:05:00',3.49),('16273','2013-06-21','11:10:00',3.53),('16273','2013-06-21','11:15:00',3.55),('16273','2013-06-21','11:20:00',3.55),('16273','2013-06-21','11:25:00',3.58),('16273','2013-06-21','11:30:00',3.61),('16273','2013-06-21','11:35:00',3.67),('16273','2013-06-21','11:40:00',3.69),('16273','2013-06-21','11:45:00',3.7),('16273','2013-06-21','11:50:00',3.71),('16273','2013-06-21','11:55:00',3.69),('16273','2013-06-21','12:00:00',3.69),('16273','2013-06-21','12:05:00',3.7),('16273','2013-06-21','12:10:00',3.69),('16273','2013-06-21','12:15:00',3.65),('16273','2013-06-21','12:20:00',3.66),('16273','2013-06-21','12:25:00',3.71),('16273','2013-06-21','12:30:00',3.76),('16273','2013-06-21','12:35:00',3.77),('16273','2013-06-21','12:40:00',3.74),('16273','2013-06-21','12:45:00',3.75),('16273','2013-06-21','12:50:00',3.74),('16273','2013-06-21','12:55:00',3.75),('16273','2013-06-21','13:00:00',3.74),('16273','2013-06-21','13:05:00',3.72),('16273','2013-06-21','13:10:00',3.71),('16273','2013-06-21','13:15:00',3.75),('16273','2013-06-21','13:20:00',3.71),('16273','2013-06-21','13:25:00',3.7),('16273','2013-06-21','13:30:00',3.72),('16273','2013-06-21','13:35:00',3.73),('16273','2013-06-21','13:40:00',3.73),('16273','2013-06-21','13:45:00',3.68),('16273','2013-06-21','13:50:00',3.66),('16273','2013-06-21','13:55:00',3.64),('16273','2013-06-21','14:00:00',3.63),('16273','2013-06-21','14:05:00',3.56),('16273','2013-06-21','14:10:00',3.6),('16273','2013-06-21','14:15:00',3.58),('16273','2013-06-21','14:20:00',3.55),('16273','2013-06-21','14:25:00',3.52),('16273','2013-06-21','14:30:00',3.47),('16273','2013-06-21','14:35:00',3.44),('16273','2013-06-21','14:40:00',3.43),('16273','2013-06-21','14:45:00',3.4),('16273','2013-06-21','14:50:00',3.35),('16273','2013-06-21','14:55:00',3.31),('16273','2013-06-21','15:00:00',3.28),('16273','2013-06-21','15:05:00',3.25),('16273','2013-06-21','15:10:00',3.19),('16273','2013-06-21','15:15:00',3.14),('16273','2013-06-21','15:20:00',3.08),('16273','2013-06-21','15:25:00',3.04),('16273','2013-06-21','15:30:00',2.98),('16273','2013-06-21','15:35:00',2.94),('16273','2013-06-21','15:40:00',2.89),('16273','2013-06-21','15:45:00',2.83),('16273','2013-06-21','15:50:00',2.77),('16273','2013-06-21','15:55:00',2.73),('16273','2013-06-21','16:00:00',2.67),('16273','2013-06-21','16:05:00',2.62),('16273','2013-06-21','16:10:00',2.55),('16273','2013-06-21','16:15:00',2.49),('16273','2013-06-21','16:20:00',2.42),('16273','2013-06-21','16:25:00',2.37),('16273','2013-06-21','16:30:00',2.32),('16273','2013-06-21','16:35:00',2.25),('16273','2013-06-21','16:40:00',2.18),('16273','2013-06-21','16:45:00',2.11),('16273','2013-06-21','16:50:00',2.04),('16273','2013-06-21','16:55:00',1.96),('16273','2013-06-21','17:00:00',1.9),('16273','2013-06-21','17:05:00',1.82),('16273','2013-06-21','17:10:00',1.76),('16273','2013-06-21','17:15:00',1.67),('16273','2013-06-21','17:20:00',1.6),('16273','2013-06-21','17:25:00',1.53),('16273','2013-06-21','17:30:00',1.46),('16273','2013-06-21','17:35:00',1.38),('16273','2013-06-21','17:40:00',1.31),('16273','2013-06-21','17:45:00',1.24),('16273','2013-06-21','17:50:00',1.16),('16273','2013-06-21','17:55:00',1.1),('16273','2013-06-21','18:00:00',1.02),('16273','2014-04-04','09:00:00',1.12),('16273','2014-04-04','09:05:00',1),('16273','2014-04-04','11:10:00',1.08),('16273','2014-04-04','13:00:00',1.5),('16273','2014-04-04','13:05:00',1.66),('16273','2014-04-04','13:10:00',3.14),('16273','2014-04-04','13:15:00',1.43),('16273','2014-04-04','13:20:00',2.1),('16273','2014-04-04','13:25:00',3.18),('16273','2014-04-04','13:30:00',2.99),('16273','2014-04-04','13:35:00',1.88),('16273','2014-04-04','13:40:00',2.44),('16273','2014-04-04','13:45:00',1.89),('16273','2014-04-04','13:50:00',2.37),('16273','2014-04-04','13:55:00',1.78),('16273','2014-04-04','14:00:00',1.75),('16273','2014-04-04','14:05:00',1.94),('16273','2014-04-04','14:10:00',1.43),('16273','2014-04-04','14:15:00',1.32),('16273','2014-04-04','14:20:00',2.32),('16273','2014-04-04','14:25:00',1.33),('16273','2014-04-04','14:30:00',1.86),('16273','2014-04-04','14:35:00',1.69),('16273','2014-04-04','14:40:00',1.48),('16273','2014-04-04','14:45:00',2),('16273','2014-04-04','14:50:00',1.44),('16273','2014-04-04','14:55:00',1.39),('16273','2014-04-04','15:00:00',1.21),('16273','2014-04-04','15:05:00',2.21),('16273','2014-04-04','15:10:00',1.93),('16273','2014-04-04','15:15:00',2.13),('16273','2014-04-04','15:20:00',2.25),('16273','2014-04-04','15:25:00',2.42),('16273','2014-04-04','15:30:00',3.2),('16273','2014-04-04','15:35:00',1.7),('16273','2014-04-04','15:40:00',1.26),('16273','2014-04-04','15:45:00',1.98),('16273','2014-04-04','15:50:00',2.18),('16273','2014-04-04','15:55:00',2.15),('16273','2014-04-04','16:00:00',2.33),('16273','2014-04-04','16:05:00',2.03),('16273','2014-04-04','16:10:00',2.56),('16273','2014-04-04','16:15:00',2.66),('16273','2014-04-04','16:20:00',2.13),('16273','2014-04-04','16:25:00',1.1),('16273','2014-04-04','16:30:00',1.3),('16273','2014-04-04','16:35:00',1.48),('16273','2014-04-04','16:40:00',2.72),('16273','2014-04-04','16:45:00',1.65),('16273','2014-04-04','16:50:00',2.13),('16273','2014-04-04','16:55:00',1.2),('16273','2014-04-04','17:00:00',2.08),('16273','2014-04-04','17:05:00',2.09),('16273','2014-04-04','17:10:00',1.23),('16273','2014-04-04','17:15:00',1.14),('16273','2014-04-04','17:25:00',1.31),('16273','2014-04-04','17:30:00',1.19),('16273','2014-04-04','17:40:00',1.08),('16273','2014-04-04','17:45:00',1.06),('16273','2013-06-20','07:15:00',1.03),('16273','2013-06-20','07:20:00',1.1),('16273','2013-06-20','07:25:00',1.18),('16273','2013-06-20','07:30:00',1.25),('16273','2013-06-20','07:35:00',1.33),('16273','2013-06-20','07:40:00',1.41),('16273','2013-06-20','07:45:00',1.49),('16273','2013-06-20','07:50:00',1.59),('16273','2013-06-20','07:55:00',1.65),('16273','2013-06-20','08:00:00',1.71),('16273','2013-06-20','08:05:00',1.79),('16273','2013-06-20','08:10:00',1.87),('16273','2013-06-20','08:15:00',1.97),('16273','2013-06-20','08:20:00',2.04),('16273','2013-06-20','08:25:00',2.12),('16273','2013-06-20','08:30:00',2.2),('16273','2013-06-20','08:35:00',2.25),('16273','2013-06-20','08:40:00',2.32),('16273','2013-06-20','08:45:00',2.39),('16273','2013-06-20','08:50:00',2.45),('16273','2013-06-20','08:55:00',2.51),('16273','2013-06-20','09:00:00',2.58),('16273','2013-06-20','09:05:00',2.62),('16273','2013-06-20','09:10:00',2.66),('16273','2013-06-20','09:15:00',2.71),('16273','2013-06-20','09:20:00',2.78),('16273','2013-06-20','09:25:00',2.79),('16273','2013-06-20','09:30:00',2.86),('16273','2013-06-20','09:35:00',2.93),('16273','2013-06-20','09:40:00',2.99),('16273','2013-06-20','09:45:00',3.05),('16273','2013-06-20','09:50:00',3.07),('16273','2013-06-20','09:55:00',3.14),('16273','2013-06-20','10:00:00',3.18),('16273','2013-06-20','10:05:00',3.2),('16273','2013-06-20','10:10:00',3.23),('16273','2013-06-20','10:15:00',3.29),('16273','2013-06-20','10:20:00',3.31),('16273','2013-06-20','10:25:00',3.34),('16273','2013-06-20','10:30:00',3.38),('16273','2013-06-20','10:35:00',3.4),('16273','2013-06-20','10:40:00',3.43),('16273','2013-06-20','10:45:00',3.44),('16273','2013-06-20','10:50:00',3.48),('16273','2013-06-20','10:55:00',3.52),('16273','2013-06-20','11:00:00',3.52),('16273','2013-06-20','11:05:00',3.51),('16273','2013-06-20','11:10:00',3.52),('16273','2013-06-20','11:15:00',3.52),('16273','2013-06-20','11:20:00',3.53),('16273','2013-06-20','11:25:00',3.54),('16273','2013-06-20','11:30:00',3.56),('16273','2013-06-20','11:35:00',3.62),('16273','2013-06-20','11:40:00',3.65),('16273','2013-06-20','11:45:00',3.64),('16273','2013-06-20','11:50:00',3.66),('16273','2013-06-20','11:55:00',3.67),('16273','2013-06-20','12:00:00',3.71),('16273','2013-06-20','12:05:00',3.74),('16273','2013-06-20','12:10:00',3.73),('16273','2013-06-20','12:15:00',3.73),('16273','2013-06-20','12:20:00',3.73),('16273','2013-06-20','12:25:00',3.77),('16273','2013-06-20','12:30:00',3.77),('16273','2013-06-20','12:35:00',3.77),('16273','2013-06-20','12:40:00',3.83),('16273','2013-06-20','12:45:00',3.85),('16273','2013-06-20','12:50:00',3.8),('16273','2013-06-20','12:55:00',3.79),('16273','2013-06-20','13:00:00',3.78),('16273','2013-06-20','13:05:00',3.8),('16273','2013-06-20','13:10:00',3.8),('16273','2013-06-20','13:15:00',3.79),('16273','2013-06-20','13:20:00',3.8),('16273','2013-06-20','13:25:00',3.82),('16273','2013-06-20','13:30:00',3.83),('16273','2013-06-20','13:35:00',3.81),('16273','2013-06-20','13:40:00',3.79),('16273','2013-06-20','13:45:00',3.76),('16273','2013-06-20','13:50:00',3.73),('16273','2013-06-20','13:55:00',3.72),('16273','2013-06-20','14:00:00',3.71),('16273','2013-06-20','14:05:00',3.66),('16273','2013-06-20','14:10:00',3.65),('16273','2013-06-20','14:15:00',3.64),('16273','2013-06-20','14:20:00',3.62),('16273','2013-06-20','14:25:00',3.57),('16273','2013-06-20','14:30:00',3.54),('16273','2013-06-20','14:35:00',3.5),('16273','2013-06-20','14:40:00',3.48),('16273','2013-06-20','14:45:00',3.45),('16273','2013-06-20','14:50:00',3.41),('16273','2013-06-20','14:55:00',3.36),('16273','2013-06-20','15:00:00',3.32),('16273','2013-06-20','15:05:00',3.27),('16273','2013-06-20','15:10:00',3.23),('16273','2013-06-20','15:15:00',3.17),('16273','2013-06-20','15:20:00',3.13),('16273','2013-06-20','15:25:00',3.09),('16273','2013-06-20','15:30:00',3.04),('16273','2013-06-20','15:35:00',2.98),('16273','2013-06-20','15:40:00',2.92),('16273','2013-06-20','15:45:00',2.87),('16273','2013-06-20','15:50:00',2.81),('16273','2013-06-20','15:55:00',2.75),('16273','2013-06-20','16:00:00',2.7),('16273','2013-06-20','16:05:00',2.65),('16273','2013-06-20','16:10:00',2.59),('16273','2013-06-20','16:15:00',2.52),('16273','2013-06-20','16:20:00',2.46),('16273','2013-06-20','16:25:00',2.4),('16273','2013-06-20','16:30:00',2.33),('16273','2013-06-20','16:35:00',2.24),('16273','2013-06-20','16:40:00',2.19),('16273','2013-06-20','16:45:00',2.1),('16273','2013-06-20','16:50:00',2.05),('16273','2013-06-20','16:55:00',1.98),('16273','2013-06-20','17:00:00',1.91),('16273','2013-06-20','17:05:00',1.82),('16273','2013-06-20','17:10:00',1.75),('16273','2013-06-20','17:15:00',1.67),('16273','2013-06-20','17:20:00',1.6),('16273','2013-06-20','17:25:00',1.53),('16273','2013-06-20','17:30:00',1.47),('16273','2013-06-20','17:35:00',1.4),('16273','2013-06-20','17:40:00',1.32),('16273','2013-06-20','17:45:00',1.25),('16273','2013-06-20','17:50:00',1.18),('16273','2013-06-20','17:55:00',1.1),('16273','2013-06-20','18:00:00',1.03),('16273','2013-06-19','07:15:00',1.06),('16273','2013-06-19','07:20:00',1.13),('16273','2013-06-19','07:25:00',1.21),('16273','2013-06-19','07:30:00',1.27),('16273','2013-06-19','07:35:00',1.34),('16273','2013-06-19','07:40:00',1.41),('16273','2013-06-19','07:45:00',1.48),('16273','2013-06-19','07:50:00',1.56),('16273','2013-06-19','07:55:00',1.63),('16273','2013-06-19','08:00:00',1.71),('16273','2013-06-19','08:05:00',1.79),('16273','2013-06-19','08:10:00',1.87),('16273','2013-06-19','08:15:00',1.93),('16273','2013-06-19','08:20:00',1.98),('16273','2013-06-19','08:25:00',2.05),('16273','2013-06-19','08:30:00',2.11),('16273','2013-06-19','08:35:00',2.17),('16273','2013-06-19','08:40:00',2.23),('16273','2013-06-19','08:45:00',2.31),('16273','2013-06-19','08:50:00',2.4),('16273','2013-06-19','08:55:00',2.47),('16273','2013-06-19','09:00:00',2.52),('16273','2013-06-19','09:05:00',2.57),('16273','2013-06-19','09:10:00',2.61),('16273','2013-06-19','09:15:00',2.65),('16273','2013-06-19','09:20:00',2.71),('16273','2013-06-19','09:25:00',2.75),('16273','2013-06-19','09:30:00',2.8),('16273','2013-06-19','09:35:00',2.83),('16273','2013-06-19','09:40:00',2.85),('16273','2013-06-19','09:45:00',2.9),('16273','2013-06-19','09:50:00',2.93),('16273','2013-06-19','09:55:00',3),('16273','2013-06-19','10:00:00',3.04),('16273','2013-06-19','10:05:00',3.08),('16273','2013-06-19','10:10:00',3.13),('16273','2013-06-19','10:15:00',3.17),('16273','2013-06-19','10:20:00',3.19),('16273','2013-06-19','10:25:00',3.22),('16273','2013-06-19','10:30:00',3.25),('16273','2013-06-19','10:35:00',3.26),('16273','2013-06-19','10:40:00',3.3),('16273','2013-06-19','10:45:00',3.31),('16273','2013-06-19','10:50:00',3.37),('16273','2013-06-19','10:55:00',3.39),('16273','2013-06-19','11:00:00',3.43),('16273','2013-06-19','11:05:00',3.45),('16273','2013-06-19','11:10:00',3.48),('16273','2013-06-19','11:15:00',3.49),('16273','2013-06-19','11:20:00',3.52),('16273','2013-06-19','11:25:00',3.54),('16273','2013-06-19','11:30:00',3.53),('16273','2013-06-19','11:35:00',3.57),('16273','2013-06-19','11:40:00',3.59),('16273','2013-06-19','11:45:00',3.62),('16273','2013-06-19','11:50:00',3.62),('16273','2013-06-19','11:55:00',3.66),('16273','2013-06-19','12:00:00',3.68),('16273','2013-06-19','12:05:00',3.7),('16273','2013-06-19','12:10:00',3.72),('16273','2013-06-19','12:15:00',3.65),('16273','2013-06-19','12:20:00',3.72),('16273','2013-06-19','12:25:00',3.71),('16273','2013-06-19','12:30:00',3.71),('16273','2013-06-19','12:35:00',3.71),('16273','2013-06-19','12:40:00',3.69),('16273','2013-06-19','12:45:00',3.68),('16273','2013-06-19','12:50:00',3.67),('16273','2013-06-19','12:55:00',3.69),('16273','2013-06-19','13:00:00',3.69),('16273','2013-06-19','13:05:00',3.7),('16273','2013-06-19','13:10:00',3.7),('16273','2013-06-19','13:15:00',3.7),('16273','2013-06-19','13:20:00',3.7),('16273','2013-06-19','13:25:00',3.7),('16273','2013-06-19','13:30:00',3.68),('16273','2013-06-19','13:35:00',3.67),('16273','2013-06-19','13:40:00',3.68),('16273','2013-06-19','13:45:00',3.64),('16273','2013-06-19','13:50:00',3.63),('16273','2013-06-19','13:55:00',3.61),('16273','2013-06-19','14:00:00',3.59),('16273','2013-06-19','14:05:00',3.57),('16273','2013-06-19','14:10:00',3.54),('16273','2013-06-19','14:15:00',3.52),('16273','2013-06-19','14:20:00',3.49),('16273','2013-06-19','14:25:00',3.46),('16273','2013-06-19','14:30:00',3.44),('16273','2013-06-19','14:35:00',3.4),('16273','2013-06-19','14:40:00',3.37),('16273','2013-06-19','14:45:00',3.33),('16273','2013-06-19','14:50:00',3.29),('16273','2013-06-19','14:55:00',3.26),('16273','2013-06-19','15:00:00',3.22),('16273','2013-06-19','15:05:00',3.17),('16273','2013-06-19','15:10:00',3.12),('16273','2013-06-19','15:15:00',3.08),('16273','2013-06-19','15:20:00',3.04),('16273','2013-06-19','15:25:00',3),('16273','2013-06-19','15:30:00',2.93),('16273','2013-06-19','15:35:00',2.88),('16273','2013-06-19','15:40:00',2.82),('16273','2013-06-19','15:45:00',2.78),('16273','2013-06-19','15:50:00',2.74),('16273','2013-06-19','15:55:00',2.68),('16273','2013-06-19','16:00:00',2.63),('16273','2013-06-19','16:05:00',2.57),('16273','2013-06-19','16:10:00',2.51),('16273','2013-06-19','16:15:00',2.46),('16273','2013-06-19','16:20:00',2.4),('16273','2013-06-19','16:25:00',2.33),('16273','2013-06-19','16:30:00',2.27),('16273','2013-06-19','16:35:00',2.17),('16273','2013-06-19','16:40:00',2.14),('16273','2013-06-19','16:45:00',2.07),('16273','2013-06-19','16:50:00',2.01),('16273','2013-06-19','16:55:00',1.95),('16273','2013-06-19','17:00:00',1.88),('16273','2013-06-19','17:05:00',1.81),('16273','2013-06-19','17:10:00',1.74),('16273','2013-06-19','17:15:00',1.67),('16273','2013-06-19','17:20:00',1.59),('16273','2013-06-19','17:25:00',1.52),('16273','2013-06-19','17:30:00',1.44),('16273','2013-06-19','17:35:00',1.37),('16273','2013-06-19','17:40:00',1.3),('16273','2013-06-19','17:45:00',1.23),('16273','2013-06-19','17:50:00',1.14),('16273','2013-06-19','17:55:00',1.08),('16273','2013-06-19','18:00:00',1.01),('16273','2013-06-18','07:15:00',1.02),('16273','2013-06-18','07:20:00',1.1),('16273','2013-06-18','07:25:00',1.17),('16273','2013-06-18','07:30:00',1.24),('16273','2013-06-18','07:35:00',1.32),('16273','2013-06-18','07:40:00',1.39),('16273','2013-06-18','07:45:00',1.48),('16273','2013-06-18','07:50:00',1.54),('16273','2013-06-18','07:55:00',1.62),('16273','2013-06-18','08:00:00',1.69),('16273','2013-06-18','08:05:00',1.77),('16273','2013-06-18','08:10:00',1.85),('16273','2013-06-18','08:15:00',1.93),('16273','2013-06-18','08:20:00',2.01),('16273','2013-06-18','08:25:00',2.08),('16273','2013-06-18','08:30:00',2.14),('16273','2013-06-18','08:35:00',2.2),('16273','2013-06-18','08:40:00',2.26),('16273','2013-06-18','08:45:00',2.31),('16273','2013-06-18','08:50:00',2.37),('16273','2013-06-18','08:55:00',2.43),('16273','2013-06-18','09:00:00',2.49),('16273','2013-06-18','09:05:00',2.54),('16273','2013-06-18','09:10:00',2.6),('16273','2013-06-18','09:15:00',2.65),('16273','2013-06-18','09:20:00',2.7),('16273','2013-06-18','09:25:00',2.75),('16273','2013-06-18','09:30:00',2.81),('16273','2013-06-18','09:35:00',2.86),('16273','2013-06-18','09:40:00',2.91),('16273','2013-06-18','09:45:00',2.95),('16273','2013-06-18','09:50:00',3),('16273','2013-06-18','09:55:00',3.03),('16273','2013-06-18','10:00:00',3.03),('16273','2013-06-18','10:05:00',3.1),('16273','2013-06-18','10:10:00',3.15),('16273','2013-06-18','10:15:00',3.2),('16273','2013-06-18','10:20:00',3.23),('16273','2013-06-18','10:25:00',3.24),('16273','2013-06-18','10:30:00',3.27),('16273','2013-06-18','10:35:00',3.31),('16273','2013-06-18','10:40:00',3.35),('16273','2013-06-18','10:45:00',3.36),('16273','2013-06-18','10:50:00',3.39),('16273','2013-06-18','10:55:00',3.41),('16273','2013-06-18','11:00:00',3.39),('16273','2013-06-18','11:05:00',3.46),('16273','2013-06-18','11:10:00',3.48),('16273','2013-06-18','11:15:00',3.47),('16273','2013-06-18','11:20:00',3.49),('16273','2013-06-18','11:25:00',3.52),('16273','2013-06-18','11:30:00',3.52),('16273','2013-06-18','11:35:00',3.52),('16273','2013-06-18','11:40:00',3.53),('16273','2013-06-18','11:45:00',3.56),('16273','2013-06-18','11:50:00',3.6),('16273','2013-06-18','11:55:00',3.61),('16273','2013-06-18','12:00:00',3.57),('16273','2013-06-18','12:05:00',3.58),('16273','2013-06-18','12:10:00',3.56),('16273','2013-06-18','12:15:00',3.59),('16273','2013-06-18','12:20:00',3.54),('16273','2013-06-18','12:25:00',3.57),('16273','2013-06-18','12:30:00',3.55),('16273','2013-06-18','12:35:00',3.6),('16273','2013-06-18','12:40:00',3.7),('16273','2013-06-18','12:45:00',3.68),('16273','2013-06-18','12:50:00',3.59),('16273','2013-06-18','12:55:00',3.59),('16273','2013-06-18','13:00:00',3.62),('16273','2013-06-18','13:05:00',3.57),('16273','2013-06-18','13:10:00',3.62),('16273','2013-06-18','13:15:00',3.58),('16273','2013-06-18','13:20:00',3.6),('16273','2013-06-18','13:25:00',3.58),('16273','2013-06-18','13:30:00',3.53),('16273','2013-06-18','13:35:00',3.48),('16273','2013-06-18','13:40:00',3.51),('16273','2013-06-18','13:45:00',3.56),('16273','2013-06-18','13:50:00',3.57),('16273','2013-06-18','13:55:00',3.55),('16273','2013-06-18','14:00:00',3.6),('16273','2013-06-18','14:05:00',3.63),('16273','2013-06-18','14:10:00',3.63),('16273','2013-06-18','14:15:00',3.6),('16273','2013-06-18','14:20:00',3.57),('16273','2013-06-18','14:25:00',3.55),('16273','2013-06-18','14:30:00',3.56),('16273','2013-06-18','14:35:00',3.64),('16273','2013-06-18','14:40:00',3.63),('16273','2013-06-18','14:45:00',3.56),('16273','2013-06-18','14:50:00',3.49),('16273','2013-06-18','14:55:00',3.42),('16273','2013-06-18','15:00:00',3.33),('16273','2013-06-18','15:05:00',3.25),('16273','2013-06-18','15:10:00',3.19),('16273','2013-06-18','15:15:00',3.11),('16273','2013-06-18','15:20:00',3.06),('16273','2013-06-18','15:25:00',3.02),('16273','2013-06-18','15:30:00',2.96),('16273','2013-06-18','15:35:00',2.91),('16273','2013-06-18','15:40:00',2.84),('16273','2013-06-18','15:45:00',2.79),('16273','2013-06-18','15:50:00',2.74),('16273','2013-06-18','15:55:00',2.71),('16273','2013-06-18','16:00:00',2.66),('16273','2013-06-18','16:05:00',2.62),('16273','2013-06-18','16:10:00',2.57),('16273','2013-06-18','16:15:00',2.52),('16273','2013-06-18','16:20:00',2.46),('16273','2013-06-18','16:25:00',2.42),('16273','2013-06-18','16:30:00',2.36),('16273','2013-06-18','16:35:00',2.27),('16273','2013-06-18','16:40:00',2.21),('16273','2013-06-18','16:45:00',2.14),('16273','2013-06-18','16:50:00',2.06),('16273','2013-06-18','16:55:00',1.98),('16273','2013-06-18','17:00:00',1.91),('16273','2013-06-18','17:05:00',1.83),('16273','2013-06-18','17:10:00',1.75),('16273','2013-06-18','17:15:00',1.67),('16273','2013-06-18','17:20:00',1.6),('16273','2013-06-18','17:25:00',1.51),('16273','2013-06-18','17:30:00',1.44),('16273','2013-06-18','17:35:00',1.37),('16273','2013-06-18','17:40:00',1.3),('16273','2013-06-18','17:45:00',1.23),('16273','2013-06-18','17:50:00',1.16),('16273','2013-06-18','17:55:00',1.1),('16273','2013-06-18','18:00:00',1.03),('16273','2013-06-17','07:10:00',1.02),('16273','2013-06-17','07:15:00',1.1),('16273','2013-06-17','07:20:00',1.18),('16273','2013-06-17','07:25:00',1.26),('16273','2013-06-17','07:30:00',1.32),('16273','2013-06-17','07:35:00',1.4),('16273','2013-06-17','07:40:00',1.48),('16273','2013-06-17','07:45:00',1.56),('16273','2013-06-17','07:50:00',1.64),('16273','2013-06-17','07:55:00',1.71),('16273','2013-06-17','08:00:00',1.78),('16273','2013-06-17','08:05:00',1.86),('16273','2013-06-17','08:10:00',1.94),('16273','2013-06-17','08:15:00',2.01),('16273','2013-06-17','08:20:00',2.08),('16273','2013-06-17','08:25:00',2.15),('16273','2013-06-17','08:30:00',2.22),('16273','2013-06-17','08:35:00',2.28),('16273','2013-06-17','08:40:00',2.36),('16273','2013-06-17','08:45:00',2.42),('16273','2013-06-17','08:50:00',2.47),('16273','2013-06-17','08:55:00',2.52),('16273','2013-06-17','09:00:00',2.58),('16273','2013-06-17','09:05:00',2.64),('16273','2013-06-17','09:10:00',2.69),('16273','2013-06-17','09:15:00',2.75),('16273','2013-06-17','09:20:00',2.8),('16273','2013-06-17','09:25:00',2.87),('16273','2013-06-17','09:30:00',2.92),('16273','2013-06-17','09:35:00',2.97),('16273','2013-06-17','09:40:00',3),('16273','2013-06-17','09:45:00',3.04),('16273','2013-06-17','09:50:00',3.09),('16273','2013-06-17','09:55:00',3.15),('16273','2013-06-17','10:00:00',3.18),('16273','2013-06-17','10:05:00',3.21),('16273','2013-06-17','10:10:00',3.25),('16273','2013-06-17','10:15:00',3.27),('16273','2013-06-17','10:20:00',3.32),('16273','2013-06-17','10:25:00',3.36),('16273','2013-06-17','10:30:00',3.39),('16273','2013-06-17','10:35:00',3.42),('16273','2013-06-17','10:40:00',3.44),('16273','2013-06-17','10:45:00',3.47),('16273','2013-06-17','10:50:00',3.51),('16273','2013-06-17','10:55:00',3.57),('16273','2013-06-17','11:00:00',3.55),('16273','2013-06-17','11:05:00',3.54),('16273','2013-06-17','11:10:00',3.61),('16273','2013-06-17','11:15:00',3.58),('16273','2013-06-17','11:20:00',3.64),('16273','2013-06-17','11:25:00',3.68),('16273','2013-06-17','11:30:00',3.7),('16273','2013-06-17','11:35:00',3.73),('16273','2013-06-17','11:40:00',3.72),('16273','2013-06-17','11:45:00',3.73),('16273','2013-06-17','11:50:00',3.75),('16273','2013-06-17','11:55:00',3.77),('16273','2013-06-17','12:00:00',3.79),('16273','2013-06-17','12:05:00',3.8),('16273','2013-06-17','12:10:00',3.82),('16273','2013-06-17','12:15:00',3.8),('16273','2013-06-17','12:20:00',3.82),('16273','2013-06-17','12:25:00',3.83),('16273','2013-06-17','12:30:00',3.84),('16273','2013-06-17','12:35:00',3.85),('16273','2013-06-17','12:40:00',3.84),('16273','2013-06-17','12:45:00',3.82),('16273','2013-06-17','12:50:00',3.83),('16273','2013-06-17','12:55:00',3.84),('16273','2013-06-17','13:00:00',3.84),('16273','2013-06-17','13:05:00',3.8),('16273','2013-06-17','13:10:00',3.8),('16273','2013-06-17','13:15:00',3.77),('16273','2013-06-17','13:20:00',3.71),('16273','2013-06-17','13:25:00',3.71),('16273','2013-06-17','13:30:00',3.71),('16273','2013-06-17','13:35:00',3.71),('16273','2013-06-17','13:40:00',3.69),('16273','2013-06-17','13:45:00',3.68),('16273','2013-06-17','13:50:00',3.66),('16273','2013-06-17','13:55:00',3.65),('16273','2013-06-17','14:00:00',3.63),('16273','2013-06-17','14:05:00',3.57),('16273','2013-06-17','14:10:00',3.58),('16273','2013-06-17','14:15:00',3.56),('16273','2013-06-17','14:20:00',3.52),('16273','2013-06-17','14:25:00',3.49),('16273','2013-06-17','14:30:00',3.44),('16273','2013-06-17','14:35:00',3.4),('16273','2013-06-17','14:40:00',3.38),('16273','2013-06-17','14:45:00',3.34),('16273','2013-06-17','14:50:00',3.31),('16273','2013-06-17','14:55:00',3.28),('16273','2013-06-17','15:00:00',3.25),('16273','2013-06-17','15:05:00',3.21),('16273','2013-06-17','15:10:00',3.18),('16273','2013-06-17','15:15:00',3.13),('16273','2013-06-17','15:20:00',3.09),('16273','2013-06-17','15:25:00',3.05),('16273','2013-06-17','15:30:00',3),('16273','2013-06-17','15:35:00',2.95),('16273','2013-06-17','15:40:00',2.89),('16273','2013-06-17','15:45:00',2.85),('16273','2013-06-17','15:50:00',2.77),('16273','2013-06-17','15:55:00',2.75),('16273','2013-06-17','16:00:00',2.69),('16273','2013-06-17','16:05:00',2.64),('16273','2013-06-17','16:10:00',2.57),('16273','2013-06-17','16:15:00',2.51),('16273','2013-06-17','16:20:00',2.45),('16273','2013-06-17','16:25:00',2.39),('16273','2013-06-17','16:30:00',2.33),('16273','2013-06-17','16:35:00',2.27),('16273','2013-06-17','16:40:00',2.2),('16273','2013-06-17','16:45:00',2.14),('16273','2013-06-17','16:50:00',2.08),('16273','2013-06-17','16:55:00',2.01),('16273','2013-06-17','17:00:00',1.94),('16273','2013-06-17','17:05:00',1.84),('16273','2013-06-17','17:10:00',1.79),('16273','2013-06-17','17:15:00',1.72),('16273','2013-06-17','17:20:00',1.65),('16273','2013-06-17','17:25:00',1.58),('16273','2013-06-17','17:30:00',1.52),('16273','2013-06-17','17:35:00',1.45),('16273','2013-06-17','17:40:00',1.38),('16273','2013-06-17','17:45:00',1.31),('16273','2013-06-17','17:50:00',1.24),('16273','2013-06-17','17:55:00',1.17),('16273','2013-06-17','18:00:00',1.1),('16273','2013-06-17','18:05:00',1.03),('16273','2013-06-16','07:10:00',1.07),('16273','2013-06-16','07:15:00',1.14),('16273','2013-06-16','07:20:00',1.21),('16273','2013-06-16','07:25:00',1.27),('16273','2013-06-16','07:30:00',1.33),('16273','2013-06-16','07:35:00',1.42),('16273','2013-06-16','07:40:00',1.49),('16273','2013-06-16','07:45:00',1.57),('16273','2013-06-16','07:50:00',1.65),('16273','2013-06-16','07:55:00',1.74),('16273','2013-06-16','08:00:00',1.81),('16273','2013-06-16','08:05:00',1.91),('16273','2013-06-16','08:10:00',1.99),('16273','2013-06-16','08:15:00',2.07),('16273','2013-06-16','08:20:00',2.11),('16273','2013-06-16','08:25:00',2.2),('16273','2013-06-16','08:30:00',2.28),('16273','2013-06-16','08:35:00',2.33),('16273','2013-06-16','08:40:00',2.39),('16273','2013-06-16','08:45:00',2.47),('16273','2013-06-16','08:50:00',2.53),('16273','2013-06-16','08:55:00',2.57),('16273','2013-06-16','09:00:00',2.62),('16273','2013-06-16','09:05:00',2.72),('16273','2013-06-16','09:10:00',2.75),('16273','2013-06-16','09:15:00',2.77),('16273','2013-06-16','09:20:00',2.9),('16273','2013-06-16','09:25:00',2.95),('16273','2013-06-16','09:30:00',3.01),('16273','2013-06-16','09:35:00',3.08),('16273','2013-06-16','09:40:00',3.13),('16273','2013-06-16','09:45:00',3.18),('16273','2013-06-16','09:50:00',3.24),('16273','2013-06-16','09:55:00',3.27),('16273','2013-06-16','10:00:00',3.32),('16273','2013-06-16','10:05:00',3.36),('16273','2013-06-16','10:10:00',3.36),('16273','2013-06-16','10:15:00',3.39),('16273','2013-06-16','10:20:00',3.42),('16273','2013-06-16','10:25:00',3.45),('16273','2013-06-16','10:30:00',3.48),('16273','2013-06-16','10:35:00',3.51),('16273','2013-06-16','10:40:00',3.54),('16273','2013-06-16','10:45:00',3.57),('16273','2013-06-16','10:50:00',3.6),('16273','2013-06-16','10:55:00',3.64),('16273','2013-06-16','11:00:00',3.66),('16273','2013-06-16','11:05:00',3.69),('16273','2013-06-16','11:10:00',3.69),('16273','2013-06-16','11:15:00',3.73),('16273','2013-06-16','11:20:00',3.73),('16273','2013-06-16','11:25:00',3.74),('16273','2013-06-16','11:30:00',3.76),('16273','2013-06-16','11:35:00',3.76),('16273','2013-06-16','11:40:00',3.78),('16273','2013-06-16','11:45:00',3.8),('16273','2013-06-16','11:50:00',3.8),('16273','2013-06-16','11:55:00',3.84),('16273','2013-06-16','12:00:00',3.83),('16273','2013-06-16','12:05:00',3.83),('16273','2013-06-16','12:10:00',3.87),('16273','2013-06-16','12:15:00',3.78),('16273','2013-06-16','12:20:00',3.88),('16273','2013-06-16','12:25:00',3.85),('16273','2013-06-16','12:30:00',3.89),('16273','2013-06-16','12:35:00',3.91),('16273','2013-06-16','12:40:00',3.87),('16273','2013-06-16','12:45:00',3.9),('16273','2013-06-16','12:50:00',3.88),('16273','2013-06-16','12:55:00',3.9),('16273','2013-06-16','13:00:00',3.91),('16273','2013-06-16','13:05:00',3.9),('16273','2013-06-16','13:10:00',3.89),('16273','2013-06-16','13:15:00',3.88),('16273','2013-06-16','13:20:00',3.87),('16273','2013-06-16','13:25:00',3.87),('16273','2013-06-16','13:30:00',3.84),('16273','2013-06-16','13:35:00',3.84),('16273','2013-06-16','13:40:00',3.82),('16273','2013-06-16','13:45:00',3.79),('16273','2013-06-16','13:50:00',3.78),('16273','2013-06-16','13:55:00',3.76),('16273','2013-06-16','14:00:00',3.73),('16273','2013-06-16','14:05:00',3.68),('16273','2013-06-16','14:10:00',3.66),('16273','2013-06-16','14:15:00',3.64),('16273','2013-06-16','14:20:00',3.62),('16273','2013-06-16','14:25:00',3.58),('16273','2013-06-16','14:30:00',3.55),('16273','2013-06-16','14:35:00',3.52),('16273','2013-06-16','14:40:00',3.47),('16273','2013-06-16','14:45:00',3.44),('16273','2013-06-16','14:50:00',3.4),('16273','2013-06-16','14:55:00',3.38),('16273','2013-06-16','15:00:00',3.35),('16273','2013-06-16','15:05:00',3.3),('16273','2013-06-16','15:10:00',3.25),('16273','2013-06-16','15:15:00',3.18),('16273','2013-06-16','15:20:00',3.15),('16273','2013-06-16','15:25:00',3.09),('16273','2013-06-16','15:30:00',3.05),('16273','2013-06-16','15:35:00',3),('16273','2013-06-16','15:40:00',2.96),('16273','2013-06-16','15:45:00',2.9),('16273','2013-06-16','15:50:00',2.84),('16273','2013-06-16','15:55:00',2.78),('16273','2013-06-16','16:00:00',2.72),('16273','2013-06-16','16:05:00',2.66),('16273','2013-06-16','16:10:00',2.61),('16273','2013-06-16','16:15:00',2.54),('16273','2013-06-16','16:20:00',2.47),('16273','2013-06-16','16:25:00',2.4),('16273','2013-06-16','16:30:00',2.33),('16273','2013-06-16','16:35:00',2.26),('16273','2013-06-16','16:40:00',2.2),('16273','2013-06-16','16:45:00',2.13),('16273','2013-06-16','16:50:00',2.06),('16273','2013-06-16','16:55:00',1.99),('16273','2013-06-16','17:00:00',1.91),('16273','2013-06-16','17:05:00',1.83),('16273','2013-06-16','17:10:00',1.76),('16273','2013-06-16','17:15:00',1.68),('16273','2013-06-16','17:20:00',1.61),('16273','2013-06-16','17:25:00',1.54),('16273','2013-06-16','17:30:00',1.46),('16273','2013-06-16','17:35:00',1.39),('16273','2013-06-16','17:40:00',1.31),('16273','2013-06-16','17:45:00',1.24),('16273','2013-06-16','17:50:00',1.16),('16273','2013-06-16','17:55:00',1.1),('16273','2013-06-16','18:00:00',1.02),('16273','2013-06-15','07:15:00',1.03),('16273','2013-06-15','07:20:00',1.11),('16273','2013-06-15','07:25:00',1.19),('16273','2013-06-15','07:30:00',1.27),('16273','2013-06-15','07:35:00',1.35),('16273','2013-06-15','07:40:00',1.44),('16273','2013-06-15','07:45:00',1.49),('16273','2013-06-15','07:50:00',1.61),('16273','2013-06-15','07:55:00',1.65),('16273','2013-06-15','08:00:00',1.59),('16273','2013-06-15','08:05:00',1.55),('16273','2013-06-15','08:10:00',1.69),('16273','2013-06-15','08:15:00',1.2),('16273','2013-06-15','08:20:00',1.21),('16273','2013-06-15','08:25:00',1.46),('16273','2013-06-15','08:30:00',1.36),('16273','2013-06-15','08:50:00',1.74),('16273','2013-06-15','08:55:00',2.63),('16273','2013-06-15','09:00:00',2.66),('16273','2013-06-15','09:05:00',2.79),('16273','2013-06-15','09:10:00',2.87),('16273','2013-06-15','09:15:00',2.92),('16273','2013-06-15','09:20:00',2.9),('16273','2013-06-15','09:25:00',3.02),('16273','2013-06-15','09:30:00',2.85),('16273','2013-06-15','09:35:00',2.8),('16273','2013-06-15','09:40:00',3.1),('16273','2013-06-15','09:45:00',3.11),('16273','2013-06-15','09:50:00',3.21),('16273','2013-06-15','09:55:00',3.24),('16273','2013-06-15','10:00:00',3.25),('16273','2013-06-15','10:05:00',3.35),('16273','2013-06-15','10:10:00',3.3),('16273','2013-06-15','10:15:00',3.4),('16273','2013-06-15','10:20:00',3.46),('16273','2013-06-15','10:25:00',3.48),('16273','2013-06-15','10:30:00',3.48),('16273','2013-06-15','10:35:00',3.04),('16273','2013-06-15','10:40:00',3.58),('16273','2013-06-15','10:45:00',3.62),('16273','2013-06-15','10:50:00',3.64),('16273','2013-06-15','10:55:00',3.57),('16273','2013-06-15','11:00:00',3.7),('16273','2013-06-15','11:05:00',3.71),('16273','2013-06-15','11:10:00',3.71),('16273','2013-06-15','11:15:00',3.69),('16273','2013-06-15','11:20:00',3.88),('16273','2013-06-15','11:25:00',3.85),('16273','2013-06-15','11:30:00',3.85),('16273','2013-06-15','11:35:00',3.83),('16273','2013-06-15','11:40:00',3.88),('16273','2013-06-15','11:45:00',3.85),('16273','2013-06-15','11:50:00',3.92),('16273','2013-06-15','11:55:00',3.87),('16273','2013-06-15','12:00:00',3.96),('16273','2013-06-15','12:05:00',3.96),('16273','2013-06-15','12:10:00',3.96),('16273','2013-06-15','12:15:00',3.94),('16273','2013-06-15','12:20:00',3.94),('16273','2013-06-15','12:25:00',3.9),('16273','2013-06-15','12:30:00',3.95),('16273','2013-06-15','12:35:00',3.96),('16273','2013-06-15','12:40:00',3.89),('16273','2013-06-15','12:45:00',3.94),('16273','2013-06-15','12:50:00',3.95),('16273','2013-06-15','12:55:00',3.92),('16273','2013-06-15','13:00:00',3.89),('16273','2013-06-15','13:05:00',3.88),('16273','2013-06-15','13:10:00',3.86),('16273','2013-06-15','13:15:00',3.85),('16273','2013-06-15','13:20:00',3.83),('16273','2013-06-15','13:25:00',3.86),('16273','2013-06-15','13:30:00',3.83),('16273','2013-06-15','13:35:00',3.83),('16273','2013-06-15','13:40:00',3.8),('16273','2013-06-15','13:45:00',3.77),('16273','2013-06-15','13:50:00',3.77),('16273','2013-06-15','13:55:00',3.76),('16273','2013-06-15','14:00:00',3.72),('16273','2013-06-15','14:05:00',3.69),('16273','2013-06-15','14:10:00',3.66),('16273','2013-06-15','14:15:00',3.63),('16273','2013-06-15','14:20:00',3.59),('16273','2013-06-15','14:25:00',3.57),('16273','2013-06-15','14:30:00',3.53),('16273','2013-06-15','14:35:00',3.52),('16273','2013-06-15','14:40:00',3.47),('16273','2013-06-15','14:45:00',3.44),('16273','2013-06-15','14:50:00',3.4),('16273','2013-06-15','14:55:00',3.37),('16273','2013-06-15','15:00:00',3.32),('16273','2013-06-15','15:05:00',3.29),('16273','2013-06-15','15:10:00',3.24),('16273','2013-06-15','15:15:00',3.21),('16273','2013-06-15','15:20:00',3.15),('16273','2013-06-15','15:25:00',3.11),('16273','2013-06-15','15:30:00',3.05),('16273','2013-06-15','15:35:00',2.99),('16273','2013-06-15','15:40:00',2.94),('16273','2013-06-15','15:45:00',2.89),('16273','2013-06-15','15:50:00',2.82),('16273','2013-06-15','15:55:00',2.77),('16273','2013-06-15','16:00:00',2.72),('16273','2013-06-15','16:05:00',2.66),('16273','2013-06-15','16:10:00',2.59),('16273','2013-06-15','16:15:00',2.53),('16273','2013-06-15','16:20:00',2.47),('16273','2013-06-15','16:25:00',2.38),('16273','2013-06-15','16:30:00',2.32),('16273','2013-06-15','16:35:00',2.27),('16273','2013-06-15','16:40:00',2.2),('16273','2013-06-15','16:45:00',2.12),('16273','2013-06-15','16:50:00',2.04),('16273','2013-06-15','16:55:00',1.99),('16273','2013-06-15','17:00:00',1.89),('16273','2013-06-15','17:05:00',1.81),('16273','2013-06-15','17:10:00',1.76),('16273','2013-06-15','17:15:00',1.68),('16273','2013-06-15','17:20:00',1.6),('16273','2013-06-15','17:25:00',1.53),('16273','2013-06-15','17:30:00',1.45),('16273','2013-06-15','17:35:00',1.37),('16273','2013-06-15','17:40:00',1.31),('16273','2013-06-15','17:45:00',1.25),('16273','2013-06-15','17:50:00',1.18),('16273','2013-06-15','17:55:00',1.11),('16273','2013-06-15','18:00:00',1.03),('16273','2013-06-14','07:05:00',1.06),('16273','2013-06-14','07:10:00',1.15),('16273','2013-06-14','07:15:00',1.24),('16273','2013-06-14','07:20:00',1.32),('16273','2013-06-14','07:25:00',1.4),('16273','2013-06-14','07:30:00',1.49),('16273','2013-06-14','07:35:00',1.57),('16273','2013-06-14','07:40:00',1.65),('16273','2013-06-14','07:45:00',1.73),('16273','2013-06-14','07:50:00',1.83),('16273','2013-06-14','07:55:00',1.9),('16273','2013-06-14','08:00:00',1.99),('16273','2013-06-14','08:05:00',2.07),('16273','2013-06-14','08:10:00',2.15),('16273','2013-06-14','08:15:00',2.2),('16273','2013-06-14','08:20:00',2.29),('16273','2013-06-14','08:25:00',2.36),('16273','2013-06-14','08:30:00',2.43),('16273','2013-06-14','08:35:00',2.49),('16273','2013-06-14','08:40:00',2.54),('16273','2013-06-14','08:45:00',2.61),('16273','2013-06-14','08:50:00',2.67),('16273','2013-06-14','08:55:00',2.73),('16273','2013-06-14','09:00:00',2.8),('16273','2013-06-14','09:05:00',2.84),('16273','2013-06-14','09:10:00',2.88),('16273','2013-06-14','09:15:00',2.92),('16273','2013-06-14','09:20:00',2.99),('16273','2013-06-14','09:25:00',3.04),('16273','2013-06-14','09:30:00',3.06),('16273','2013-06-14','09:35:00',3.14),('16273','2013-06-14','09:40:00',3.2),('16273','2013-06-14','09:45:00',3.24),('16273','2013-06-14','09:50:00',3.26),('16273','2013-06-14','09:55:00',3.27),('16273','2013-06-14','10:00:00',3.32),('16273','2013-06-14','10:05:00',3.38),('16273','2013-06-14','10:10:00',3.38),('16273','2013-06-14','10:15:00',3.37),('16273','2013-06-14','10:20:00',3.48),('16273','2013-06-14','10:25:00',3.49),('16273','2013-06-14','10:30:00',3.47),('16273','2013-06-14','10:35:00',3.35),('16273','2013-06-14','10:40:00',3.52),('16273','2013-06-14','10:45:00',3.62),('16273','2013-06-14','10:50:00',3.68),('16273','2013-06-14','10:55:00',3.7),('16273','2013-06-14','11:00:00',3.72),('16273','2013-06-14','11:05:00',3.74),('16273','2013-06-14','11:10:00',3.72),('16273','2013-06-14','11:15:00',3.73),('16273','2013-06-14','11:20:00',3.82),('16273','2013-06-14','11:25:00',3.85),('16273','2013-06-14','11:30:00',3.87),('16273','2013-06-14','11:35:00',3.91),('16273','2013-06-14','11:40:00',3.9),('16273','2013-06-14','11:45:00',3.91),('16273','2013-06-14','11:50:00',3.9),('16273','2013-06-14','11:55:00',3.9),('16273','2013-06-14','12:00:00',3.96),('16273','2013-06-14','12:05:00',4),('16273','2013-06-14','12:10:00',4.02),('16273','2013-06-14','12:15:00',4),('16273','2013-06-14','12:20:00',3.99),('16273','2013-06-14','12:25:00',3.96),('16273','2013-06-14','12:30:00',3.94),('16273','2013-06-14','12:35:00',3.96),('16273','2013-06-14','12:40:00',3.97),('16273','2013-06-14','12:45:00',3.95),('16273','2013-06-14','12:50:00',3.95),('16273','2013-06-14','12:55:00',3.92),('16273','2013-06-14','13:00:00',3.91),('16273','2013-06-14','13:05:00',3.94),('16273','2013-06-14','13:10:00',3.92),('16273','2013-06-14','13:15:00',3.92),('16273','2013-06-14','13:20:00',3.92),('16273','2013-06-14','13:25:00',3.93),('16273','2013-06-14','13:30:00',3.88),('16273','2013-06-14','13:35:00',3.87),('16273','2013-06-14','13:40:00',3.84),('16273','2013-06-14','13:45:00',3.81),('16273','2013-06-14','13:50:00',3.83),('16273','2013-06-14','13:55:00',3.77),('16273','2013-06-14','14:00:00',3.76),('16273','2013-06-14','14:05:00',3.74),('16273','2013-06-14','14:10:00',3.73),('16273','2013-06-14','14:15:00',3.71),('16273','2013-06-14','14:20:00',3.68),('16273','2013-06-14','14:25:00',3.67),('16273','2013-06-14','14:30:00',3.63),('16273','2013-06-14','14:35:00',3.59),('16273','2013-06-14','14:40:00',3.55),('16273','2013-06-14','14:45:00',3.43),('16273','2013-06-14','14:50:00',3.44),('16273','2013-06-14','14:55:00',3.4),('16273','2013-06-14','15:00:00',3.34),('16273','2013-06-14','15:05:00',3.32),('16273','2013-06-14','15:10:00',3.28),('16273','2013-06-14','15:15:00',3.22),('16273','2013-06-14','15:20:00',3.18),('16273','2013-06-14','15:25:00',3.09),('16273','2013-06-14','15:30:00',3.01),('16273','2013-06-14','15:35:00',3),('16273','2013-06-14','15:40:00',2.95),('16273','2013-06-14','15:45:00',2.94),('16273','2013-06-14','15:50:00',2.91),('16273','2013-06-14','15:55:00',2.84),('16273','2013-06-14','16:00:00',2.76),('16273','2013-06-14','16:05:00',2.71),('16273','2013-06-14','16:10:00',2.67),('16273','2013-06-14','16:15:00',2.6),('16273','2013-06-14','16:20:00',2.51),('16273','2013-06-14','16:25:00',2.47),('16273','2013-06-14','16:30:00',2.4),('16273','2013-06-14','16:35:00',2.33),('16273','2013-06-14','16:40:00',2.26),('16273','2013-06-14','16:45:00',2.18),('16273','2013-06-14','16:50:00',2.07),('16273','2013-06-14','16:55:00',1.98),('16273','2013-06-14','17:00:00',1.92),('16273','2013-06-14','17:05:00',1.86),('16273','2013-06-14','17:10:00',1.76),('16273','2013-06-14','17:15:00',1.72),('16273','2013-06-14','17:20:00',1.64),('16273','2013-06-14','17:25:00',1.56),('16273','2013-06-14','17:30:00',1.5),('16273','2013-06-14','17:35:00',1.43),('16273','2013-06-14','17:40:00',1.35),('16273','2013-06-14','17:45:00',1.27),('16273','2013-06-14','17:50:00',1.2),('16273','2013-06-14','17:55:00',1.12),('16273','2013-06-14','18:00:00',1.05),('16273','2013-06-13','07:05:00',1.07),('16273','2013-06-13','07:10:00',1.15),('16273','2013-06-13','07:15:00',1.24),('16273','2013-06-13','07:20:00',1.33),('16273','2013-06-13','07:25:00',1.41),('16273','2013-06-13','07:30:00',1.5),('16273','2013-06-13','07:35:00',1.58),('16273','2013-06-13','07:40:00',1.66),('16273','2013-06-13','07:45:00',1.74),('16273','2013-06-13','07:50:00',1.83),('16273','2013-06-13','07:55:00',1.91),('16273','2013-06-13','08:00:00',1.99),('16273','2013-06-13','08:05:00',2.07),('16273','2013-06-13','08:10:00',2.15),('16273','2013-06-13','08:15:00',2.22),('16273','2013-06-13','08:20:00',2.29),('16273','2013-06-13','08:25:00',2.36),('16273','2013-06-13','08:30:00',2.44),('16273','2013-06-13','08:35:00',2.5),('16273','2013-06-13','08:40:00',2.56),('16273','2013-06-13','08:45:00',2.63),('16273','2013-06-13','08:50:00',2.71),('16273','2013-06-13','08:55:00',2.77),('16273','2013-06-13','09:00:00',2.82),('16273','2013-06-13','09:05:00',2.86),('16273','2013-06-13','09:10:00',2.96),('16273','2013-06-13','09:15:00',3.03),('16273','2013-06-13','09:20:00',3.07),('16273','2013-06-13','09:25:00',3.11),('16273','2013-06-13','09:30:00',3.13),('16273','2013-06-13','09:35:00',3.24),('16273','2013-06-13','09:40:00',3.31),('16273','2013-06-13','09:45:00',3.36),('16273','2013-06-13','09:50:00',3.4),('16273','2013-06-13','09:55:00',3.43),('16273','2013-06-13','10:00:00',3.48),('16273','2013-06-13','10:05:00',3.49),('16273','2013-06-13','10:10:00',3.54),('16273','2013-06-13','10:15:00',3.58),('16273','2013-06-13','10:20:00',3.61),('16273','2013-06-13','10:25:00',3.64),('16273','2013-06-13','10:30:00',3.69),('16273','2013-06-13','10:35:00',3.72),('16273','2013-06-13','10:40:00',3.74),('16273','2013-06-13','10:45:00',3.72),('16273','2013-06-13','10:50:00',3.8),('16273','2013-06-13','10:55:00',3.79),('16273','2013-06-13','11:00:00',3.8),('16273','2013-06-13','11:05:00',3.84),('16273','2013-06-13','11:10:00',3.85),('16273','2013-06-13','11:15:00',3.87),('16273','2013-06-13','11:20:00',3.89),('16273','2013-06-13','11:25:00',3.9),('16273','2013-06-13','11:30:00',3.95),('16273','2013-06-13','11:35:00',3.94),('16273','2013-06-13','11:40:00',3.96),('16273','2013-06-13','11:45:00',3.98),('16273','2013-06-13','11:50:00',4),('16273','2013-06-13','11:55:00',4),('16273','2013-06-13','12:00:00',4.02),('16273','2013-06-13','12:05:00',4.04),('16273','2013-06-13','12:10:00',4.02),('16273','2013-06-13','12:15:00',4.01),('16273','2013-06-13','12:20:00',4.03),('16273','2013-06-13','12:25:00',4.03),('16273','2013-06-13','12:30:00',4.02),('16273','2013-06-13','12:35:00',4.05),('16273','2013-06-13','12:40:00',4.08),('16273','2013-06-13','12:45:00',4.04),('16273','2013-06-13','12:50:00',4.03),('16273','2013-06-13','12:55:00',4),('16273','2013-06-13','13:00:00',4),('16273','2013-06-13','13:05:00',3.98),('16273','2013-06-13','13:10:00',3.94),('16273','2013-06-13','13:15:00',3.92),('16273','2013-06-13','13:20:00',3.88),('16273','2013-06-13','13:25:00',3.87),('16273','2013-06-13','13:30:00',3.89),('16273','2013-06-13','13:35:00',3.9),('16273','2013-06-13','13:40:00',3.86),('16273','2013-06-13','13:45:00',3.85),('16273','2013-06-13','13:50:00',3.79),('16273','2013-06-13','13:55:00',3.82),('16273','2013-06-13','14:00:00',3.77),('16273','2013-06-13','14:05:00',3.73),('16273','2013-06-13','14:10:00',3.76),('16273','2013-06-13','14:15:00',3.75),('16273','2013-06-13','14:20:00',3.67),('16273','2013-06-13','14:25:00',3.65),('16273','2013-06-13','14:30:00',2.35),('16273','2013-06-13','14:35:00',3.42),('16273','2013-06-13','14:40:00',2.52),('16273','2013-06-13','14:45:00',3.05),('16273','2013-06-13','14:50:00',3.26),('16273','2013-06-13','14:55:00',2.27),('16273','2013-06-13','15:00:00',3.38),('16273','2013-06-13','15:05:00',3.29),('16273','2013-06-13','15:10:00',3.27),('16273','2013-06-13','15:15:00',3.23),('16273','2013-06-13','15:20:00',3.18),('16273','2013-06-13','15:25:00',3.09),('16273','2013-06-13','15:30:00',3.05),('16273','2013-06-13','15:35:00',2.99),('16273','2013-06-13','15:40:00',2.94),('16273','2013-06-13','15:45:00',2.93),('16273','2013-06-13','15:50:00',2.82),('16273','2013-06-13','15:55:00',2.75),('16273','2013-06-13','16:00:00',2.69),('16273','2013-06-13','16:05:00',2.62),('16273','2013-06-13','16:10:00',2.63),('16273','2013-06-13','16:15:00',2.56),('16273','2013-06-13','16:20:00',2.5),('16273','2013-06-13','16:25:00',2.44),('16273','2013-06-13','16:30:00',2.37),('16273','2013-06-13','16:35:00',2.28),('16273','2013-06-13','16:40:00',2.23),('16273','2013-06-13','16:45:00',2.15),('16273','2013-06-13','16:50:00',2.05),('16273','2013-06-13','16:55:00',2),('16273','2013-06-13','17:00:00',1.93),('16273','2013-06-13','17:05:00',1.86),('16273','2013-06-13','17:10:00',1.78),('16273','2013-06-13','17:15:00',1.71),('16273','2013-06-13','17:20:00',1.62),('16273','2013-06-13','17:25:00',1.54),('16273','2013-06-13','17:30:00',1.47),('16273','2013-06-13','17:35:00',1.39),('16273','2013-06-13','17:40:00',1.31),('16273','2013-06-13','17:45:00',1.24),('16273','2013-06-13','17:50:00',1.17),('16273','2013-06-13','17:55:00',1.11),('16273','2013-06-13','18:00:00',1.02),('16273','2013-06-12','07:05:00',1.11),('16273','2013-06-12','07:10:00',1.19),('16273','2013-06-12','07:15:00',1.27),('16273','2013-06-12','07:20:00',1.35),('16273','2013-06-12','07:25:00',1.43),('16273','2013-06-12','07:30:00',1.51),('16273','2013-06-12','07:35:00',1.6),('16273','2013-06-12','07:40:00',1.68),('16273','2013-06-12','07:45:00',1.77),('16273','2013-06-12','07:50:00',1.85),('16273','2013-06-12','07:55:00',1.93),('16273','2013-06-12','08:00:00',2),('16273','2013-06-12','08:05:00',2.08),('16273','2013-06-12','08:10:00',2.16),('16273','2013-06-12','08:15:00',2.25),('16273','2013-06-12','08:20:00',2.33),('16273','2013-06-12','08:25:00',2.4),('16273','2013-06-12','08:30:00',2.47),('16273','2013-06-12','08:35:00',2.55),('16273','2013-06-12','08:40:00',2.62),('16273','2013-06-12','08:45:00',2.68),('16273','2013-06-12','08:50:00',2.73),('16273','2013-06-12','08:55:00',2.8),('16273','2013-06-12','09:00:00',2.87),('16273','2013-06-12','09:05:00',2.93),('16273','2013-06-12','09:10:00',3),('16273','2013-06-12','09:15:00',3.05),('16273','2013-06-12','09:20:00',3.1),('16273','2013-06-12','09:25:00',3.16),('16273','2013-06-12','09:30:00',3.2),('16273','2013-06-12','09:35:00',3.26),('16273','2013-06-12','09:40:00',3.29),('16273','2013-06-12','09:45:00',3.29),('16273','2013-06-12','09:50:00',3.32),('16273','2013-06-12','09:55:00',3.38),('16273','2013-06-12','10:00:00',3.43),('16273','2013-06-12','10:05:00',3.46),('16273','2013-06-12','10:10:00',3.54),('16273','2013-06-12','10:15:00',3.59),('16273','2013-06-12','10:20:00',3.57),('16273','2013-06-12','10:25:00',3.63),('16273','2013-06-12','10:30:00',3.66),('16273','2013-06-12','10:35:00',3.74),('16273','2013-06-12','10:40:00',3.74),('16273','2013-06-12','10:45:00',3.76),('16273','2013-06-12','10:50:00',3.76),('16273','2013-06-12','10:55:00',3.84),('16273','2013-06-12','11:00:00',3.89),('16273','2013-06-12','11:05:00',3.92),('16273','2013-06-12','11:10:00',3.98),('16273','2013-06-12','11:15:00',3.95),('16273','2013-06-12','11:20:00',3.99),('16273','2013-06-12','11:25:00',4),('16273','2013-06-12','11:30:00',3.99),('16273','2013-06-12','11:35:00',4.03),('16273','2013-06-12','11:40:00',4.06),('16273','2013-06-12','11:45:00',4.03),('16273','2013-06-12','11:50:00',4),('16273','2013-06-12','11:55:00',3.34),('16273','2013-06-12','12:00:00',4.04),('16273','2013-06-12','12:05:00',4),('16273','2013-06-12','12:10:00',4),('16273','2013-06-12','12:15:00',4),('16273','2013-06-12','12:20:00',3.98),('16273','2013-06-12','12:25:00',4.04),('16273','2013-06-12','12:30:00',3.98),('16273','2013-06-12','12:35:00',3.42),('16273','2013-06-12','12:40:00',4.1),('16273','2013-06-12','12:45:00',4.08),('16273','2013-06-12','12:50:00',3.95),('16273','2013-06-12','12:55:00',4.05),('16273','2013-06-12','13:00:00',4.12),('16273','2013-06-12','13:05:00',4.02),('16273','2013-06-12','13:10:00',4),('16273','2013-06-12','13:15:00',4.05),('16273','2013-06-12','13:20:00',4.07),('16273','2013-06-12','13:25:00',3.93),('16273','2013-06-12','13:30:00',3.52),('16273','2013-06-12','13:35:00',3.26),('16273','2013-06-12','13:40:00',2.98),('16273','2013-06-12','13:45:00',2.51),('16273','2013-06-12','13:50:00',4),('16273','2013-06-12','13:55:00',4),('16273','2013-06-12','14:00:00',3.9),('16273','2013-06-12','14:05:00',3.83),('16273','2013-06-12','14:10:00',3.83),('16273','2013-06-12','14:15:00',3.8),('16273','2013-06-12','14:20:00',3.74),('16273','2013-06-12','14:25:00',3.72),('16273','2013-06-12','14:30:00',3.65),('16273','2013-06-12','14:35:00',3.6),('16273','2013-06-12','14:40:00',3.58),('16273','2013-06-12','14:45:00',3.54),('16273','2013-06-12','14:50:00',3.46),('16273','2013-06-12','14:55:00',3.35),('16273','2013-06-12','15:00:00',3.43),('16273','2013-06-12','15:05:00',3.35),('16273','2013-06-12','15:10:00',3.36),('16273','2013-06-12','15:15:00',3.31),('16273','2013-06-12','15:20:00',3.21),('16273','2013-06-12','15:25:00',3.21),('16273','2013-06-12','15:30:00',3.14),('16273','2013-06-12','15:35:00',3.01),('16273','2013-06-12','15:40:00',2.97),('16273','2013-06-12','15:45:00',2.96),('16273','2013-06-12','15:50:00',2.87),('16273','2013-06-12','15:55:00',2.88),('16273','2013-06-12','16:00:00',2.82),('16273','2013-06-12','16:05:00',2.77),('16273','2013-06-12','16:10:00',2.7),('16273','2013-06-12','16:15:00',2.63),('16273','2013-06-12','16:20:00',2.59),('16273','2013-06-12','16:25:00',2.54),('16273','2013-06-12','16:30:00',2.45),('16273','2013-06-12','16:35:00',2.35),('16273','2013-06-12','16:40:00',2.34),('16273','2013-06-12','16:45:00',2.31),('16273','2013-06-12','16:50:00',2.18),('16273','2013-06-12','16:55:00',2.07),('16273','2013-06-12','17:00:00',1.91),('16273','2013-06-12','17:15:00',1.45),('16273','2013-06-12','17:20:00',1.49),('16273','2013-06-12','17:25:00',1.61),('16273','2013-06-12','17:30:00',1.53),('16273','2013-06-12','17:35:00',1.45),('16273','2013-06-12','17:45:00',1.45),('16273','2013-06-12','17:50:00',1.33),('16273','2013-06-12','17:55:00',1.42),('16273','2013-06-12','18:00:00',1.34),('16273','2013-06-12','18:05:00',1.08),('16273','2013-06-11','07:25:00',1.17),('16273','2013-06-11','07:30:00',1.45),('16273','2013-06-11','07:35:00',1.35),('16273','2013-06-11','07:40:00',1.6),('16273','2013-06-11','07:45:00',1.71),('16273','2013-06-11','07:50:00',1.78),('16273','2013-06-11','07:55:00',1.86),('16273','2013-06-11','08:00:00',1.94),('16273','2013-06-11','08:05:00',2.02),('16273','2013-06-11','08:10:00',2.11),('16273','2013-06-11','08:15:00',2.17),('16273','2013-06-11','08:20:00',2.24),('16273','2013-06-11','08:25:00',2.33),('16273','2013-06-11','08:30:00',2.41),('16273','2013-06-11','08:35:00',2.45),('16273','2013-06-11','08:40:00',2.55),('16273','2013-06-11','08:45:00',2.63),('16273','2013-06-11','08:50:00',2.69),('16273','2013-06-11','08:55:00',2.75),('16273','2013-06-11','09:00:00',2.8),('16273','2013-06-11','09:05:00',2.87),('16273','2013-06-11','09:10:00',2.9),('16273','2013-06-11','09:15:00',2.99),('16273','2013-06-11','09:20:00',2.33),('16273','2013-06-11','09:25:00',2.83),('16273','2013-06-11','09:30:00',3.19),('16273','2013-06-11','09:35:00',3.05),('16273','2013-06-11','09:40:00',2.51),('16273','2013-06-11','09:45:00',3.39),('16273','2013-06-11','09:50:00',3.36),('16273','2013-06-11','09:55:00',3.42),('16273','2013-06-11','10:00:00',3.44),('16273','2013-06-11','10:05:00',3.52),('16273','2013-06-11','10:10:00',3.55),('16273','2013-06-11','10:15:00',3.61),('16273','2013-06-11','10:20:00',3.74),('16273','2013-06-11','10:25:00',3.84),('16273','2013-06-11','10:30:00',3.8),('16273','2013-06-11','10:35:00',2.91),('16273','2013-06-11','10:40:00',3.33),('16273','2013-06-11','10:45:00',2.37),('16273','2013-06-11','10:50:00',3.88),('16273','2013-06-11','10:55:00',3.93),('16273','2013-06-11','11:00:00',3.95),('16273','2013-06-11','11:05:00',3.91),('16273','2013-06-11','11:10:00',3.94),('16273','2013-06-11','11:15:00',3.99),('16273','2013-06-11','11:20:00',4.03),('16273','2013-06-11','11:25:00',4.01),('16273','2013-06-11','11:30:00',4.06),('16273','2013-06-11','11:35:00',4.05),('16273','2013-06-11','11:40:00',4.1),('16273','2013-06-11','11:45:00',4.06),('16273','2013-06-11','11:50:00',3.73),('16273','2013-06-11','11:55:00',3.84),('16273','2013-06-11','12:00:00',4.15),('16273','2013-06-11','12:05:00',4.14),('16273','2013-06-11','12:10:00',4.14),('16273','2013-06-11','12:15:00',4.14),('16273','2013-06-11','12:20:00',4.12),('16273','2013-06-11','12:25:00',4.14),('16273','2013-06-11','12:30:00',4.15),('16273','2013-06-11','12:35:00',4.14),('16273','2013-06-11','12:40:00',4.11),('16273','2013-06-11','12:45:00',4.13),('16273','2013-06-11','12:50:00',4.18),('16273','2013-06-11','12:55:00',4.14),('16273','2013-06-11','13:00:00',3.2),('16273','2013-06-11','13:05:00',4.22),('16273','2013-06-11','13:10:00',4.15),('16273','2013-06-11','13:15:00',4.13),('16273','2013-06-11','13:20:00',4.06),('16273','2013-06-11','13:25:00',4.13),('16273','2013-06-11','13:30:00',4.14),('16273','2013-06-11','13:35:00',3.77),('16273','2013-06-11','13:40:00',3.79),('16273','2013-06-11','13:45:00',4.08),('16273','2013-06-11','13:50:00',3.87),('16273','2013-06-11','13:55:00',3.96),('16273','2013-06-11','14:00:00',3.9),('16273','2013-06-11','14:05:00',3.94),('16273','2013-06-11','14:10:00',3.88),('16273','2013-06-11','14:15:00',3.85),('16273','2013-06-11','14:20:00',3.8),('16273','2013-06-11','14:25:00',3.78),('16273','2013-06-11','14:30:00',3.75),('16273','2013-06-11','14:35:00',3.7),('16273','2013-06-11','14:40:00',3.61),('16273','2013-06-11','14:45:00',3.65),('16273','2013-06-11','14:50:00',3.08),('16273','2013-06-11','14:55:00',3.58),('16273','2013-06-11','15:00:00',3.22),('16273','2013-06-11','15:05:00',3.39),('16273','2013-06-11','15:10:00',3.39),('16273','2013-06-11','15:15:00',2.89),('16273','2013-06-11','15:20:00',3.33),('16273','2013-06-11','15:25:00',3.38),('16273','2013-06-11','15:30:00',2.96),('16273','2013-06-11','15:35:00',3.22),('16273','2013-06-11','15:40:00',3.14),('16273','2013-06-11','15:45:00',2.88),('16273','2013-06-11','15:50:00',3.03),('16273','2013-06-11','15:55:00',2.57),('16273','2013-06-11','16:00:00',2.83),('16273','2013-06-11','16:05:00',2.79),('16273','2013-06-11','16:10:00',2.71),('16273','2013-06-11','16:15:00',2.67),('16273','2013-06-11','16:20:00',2.6),('16273','2013-06-11','16:25:00',2.51),('16273','2013-06-11','16:30:00',2.47),('16273','2013-06-11','16:35:00',2.43),('16273','2013-06-11','16:40:00',2.43),('16273','2013-06-11','16:45:00',2.42),('16273','2013-06-11','16:50:00',2.35),('16273','2013-06-11','16:55:00',2.2),('16273','2013-06-11','17:00:00',2.1),('16273','2013-06-11','17:05:00',1.24),('16273','2014-04-03','08:50:00',1.01),('16273','2014-04-03','08:55:00',1.11),('16273','2014-04-03','09:00:00',1.23),('16273','2014-04-03','09:05:00',1.29),('16273','2014-04-03','09:10:00',1.15),('16273','2014-04-03','09:15:00',1.12),('16273','2014-04-03','09:20:00',1.19),('16273','2014-04-03','09:25:00',1.33),('16273','2014-04-03','09:30:00',1.59),('16273','2014-04-03','09:35:00',1.7),('16273','2014-04-03','09:40:00',1.66),('16273','2014-04-03','09:45:00',1.66),('16273','2014-04-03','09:50:00',1.75),('16273','2014-04-03','09:55:00',2.01),('16273','2014-04-03','10:00:00',2.41),('16273','2014-04-03','10:05:00',2.56),('16273','2014-04-03','10:10:00',2.94),('16273','2014-04-03','10:15:00',3.09),('16273','2014-04-03','10:20:00',2.51),('16273','2014-04-03','10:25:00',1.99),('16273','2014-04-03','10:30:00',3.03),('16273','2014-04-03','10:35:00',2.51),('16273','2014-04-03','10:40:00',2.61),('16273','2014-04-03','10:45:00',2.64),('16273','2014-04-03','10:50:00',2.18),('16273','2014-04-03','10:55:00',1.91),('16273','2014-04-03','11:00:00',1.58),('16273','2014-04-03','11:05:00',1.51),('16273','2014-04-03','11:10:00',1.42),('16273','2014-04-03','11:15:00',1.32),('16273','2014-04-03','11:20:00',1.2),('16273','2014-04-03','11:25:00',1.16),('16273','2014-04-03','11:30:00',1.23),('16273','2014-04-03','11:35:00',1.37),('16273','2014-04-03','11:40:00',1.43),('16273','2014-04-03','11:45:00',1.62),('16273','2014-04-03','11:50:00',1.86),('16273','2014-04-03','11:55:00',1.99),('16273','2014-04-03','12:00:00',2.15),('16273','2014-04-03','12:05:00',2.04),('16273','2014-04-03','12:10:00',1.86),('16273','2014-04-03','12:15:00',2.03),('16273','2014-04-03','12:20:00',2.41),('16273','2014-04-03','12:25:00',3.31),('16273','2014-04-03','12:30:00',3.87),('16273','2014-04-03','12:35:00',2.71),('16273','2014-04-03','12:40:00',2.45),('16273','2014-04-03','12:45:00',2.01),('16273','2014-04-03','12:50:00',2.74),('16273','2014-04-03','12:55:00',2.18),('16273','2014-04-03','13:00:00',1.93),('16273','2014-04-03','13:05:00',2.31),('16273','2014-04-03','13:10:00',2.91),('16273','2014-04-03','13:15:00',2.54),('16273','2014-04-03','13:20:00',2.58),('16273','2014-04-03','13:25:00',2.83),('16273','2014-04-03','13:30:00',3.84),('16273','2014-04-03','13:35:00',3.26),('16273','2014-04-03','13:40:00',1.6),('16273','2014-04-03','13:45:00',1.84),('16273','2014-04-03','13:50:00',2.3),('16273','2014-04-03','13:55:00',2.08),('16273','2014-04-03','14:00:00',3.2),('16273','2014-04-03','14:05:00',3),('16273','2014-04-03','14:10:00',2.73),('16273','2014-04-03','14:15:00',3.37),('16273','2014-04-03','14:20:00',2.91),('16273','2014-04-03','14:25:00',3.06),('16273','2014-04-03','14:30:00',3.47),('16273','2014-04-03','14:35:00',3.31),('16273','2014-04-03','14:40:00',3.05),('16273','2014-04-03','14:45:00',3.05),('16273','2014-04-03','14:50:00',3.03),('16273','2014-04-03','14:55:00',2.99),('16273','2014-04-03','15:00:00',2.98),('16273','2014-04-03','15:05:00',2.92),('16273','2014-04-03','15:10:00',2.87),('16273','2014-04-03','15:15:00',2.82),('16273','2014-04-03','15:20:00',2.77),('16273','2014-04-03','15:25:00',2.73),('16273','2014-04-03','15:30:00',2.67),('16273','2014-04-03','15:35:00',2.64),('16273','2014-04-03','15:40:00',2.6),('16273','2014-04-03','15:45:00',2.52),('16273','2014-04-03','15:50:00',2.45),('16273','2014-04-03','15:55:00',2.42),('16273','2014-04-03','16:00:00',2.34),('16273','2014-04-03','16:05:00',2.23),('16273','2014-04-03','16:10:00',2.21),('16273','2014-04-03','16:15:00',2.14),('16273','2014-04-03','16:20:00',2.08),('16273','2014-04-03','16:25:00',1.98),('16273','2014-04-03','16:30:00',1.86),('16273','2014-04-03','16:35:00',1.82),('16273','2014-04-03','16:40:00',1.72),('16273','2014-04-03','16:45:00',1.71),('16273','2014-04-03','16:50:00',1.58),('16273','2014-04-03','16:55:00',1.33),('16273','2014-04-03','17:00:00',1.21),('16273','2014-04-03','17:05:00',1.09),('16273','2014-04-03','17:10:00',1.38),('16273','2014-04-03','17:15:00',1.57),('16273','2014-04-03','17:20:00',1.45),('16273','2014-04-03','17:25:00',1.29),('16273','2013-06-10','07:20:00',1.33),('16273','2013-06-10','07:25:00',1.48),('16273','2013-06-10','07:30:00',1.42),('16273','2013-06-10','07:55:00',1.12),('16273','2013-06-10','08:10:00',1.9),('16273','2013-06-10','08:15:00',1.13),('16273','2013-06-10','08:20:00',1.38),('16273','2013-06-10','08:25:00',1.41),('16273','2013-06-10','08:35:00',1.02),('16273','2013-06-10','08:45:00',2.45),('16273','2013-06-10','08:50:00',3.23),('16273','2013-06-10','08:55:00',1.48),('16273','2013-06-10','09:00:00',1.11),('16273','2013-06-10','09:05:00',1.08),('16273','2013-06-10','09:10:00',2.45),('16273','2013-06-10','09:15:00',3.37),('16273','2013-06-10','09:20:00',2.61),('16273','2013-06-10','09:25:00',1.97),('16273','2013-06-10','09:30:00',2.38),('16273','2013-06-10','09:35:00',1.35),('16273','2013-06-10','09:40:00',2.31),('16273','2013-06-10','09:45:00',2.34),('16273','2013-06-10','09:50:00',1.39),('16273','2013-06-10','09:55:00',1.72),('16273','2013-06-10','10:00:00',1.89),('16273','2013-06-10','10:05:00',1.79),('16273','2013-06-10','10:10:00',3.38),('16273','2013-06-10','10:15:00',2.37),('16273','2013-06-10','10:20:00',1.93),('16273','2013-06-10','10:25:00',3.02),('16273','2013-06-10','10:30:00',3.35),('16273','2013-06-10','10:35:00',2.73),('16273','2013-06-10','10:40:00',3.31),('16273','2013-06-10','10:45:00',3.55),('16273','2013-06-10','10:50:00',2.35),('16273','2013-06-10','10:55:00',3.14),('16273','2013-06-10','11:00:00',3.77),('16273','2013-06-10','11:05:00',2.51),('16273','2013-06-10','11:10:00',3.87),('16273','2013-06-10','11:15:00',4.07),('16273','2013-06-10','11:20:00',3.33),('16273','2013-06-10','11:25:00',1.88),('16273','2013-06-10','11:30:00',1.42),('16273','2013-06-10','11:35:00',1.28),('16273','2013-06-10','11:40:00',2.23),('16273','2013-06-10','11:45:00',1.41),('16273','2013-06-10','11:55:00',3.59),('16273','2013-06-10','12:00:00',3.45),('16273','2013-06-10','12:05:00',3.71),('16273','2013-06-10','12:10:00',4.21),('16273','2013-06-10','12:15:00',2.69),('16273','2013-06-10','12:20:00',2.27),('16273','2013-06-10','12:25:00',2.03),('16273','2013-06-10','12:30:00',4.86),('16273','2013-06-10','12:35:00',3.08),('16273','2013-06-10','12:40:00',2.06),('16273','2013-06-10','12:45:00',3),('16273','2013-06-10','12:50:00',1.39),('16273','2013-06-10','12:55:00',2.63),('16273','2013-06-10','13:00:00',3.49),('16273','2013-06-10','13:05:00',2.37),('16273','2013-06-10','13:10:00',3.22),('16273','2013-06-10','13:15:00',4.45),('16273','2013-06-10','13:20:00',2.98),('16273','2013-06-10','13:25:00',3.14),('16273','2013-06-10','13:30:00',1.75),('16273','2013-06-10','13:35:00',1.56),('16273','2013-06-10','13:40:00',4.35),('16273','2013-06-10','13:45:00',4.33),('16273','2013-06-10','13:50:00',3.37),('16273','2013-06-10','13:55:00',3.73),('16273','2013-06-10','14:00:00',4.01),('16273','2013-06-10','14:05:00',3.31),('16273','2013-06-10','14:10:00',3.4),('16273','2013-06-10','14:15:00',3.95),('16273','2013-06-10','14:20:00',3.78),('16273','2013-06-10','14:25:00',3.8),('16273','2013-06-10','14:30:00',3.76),('16273','2013-06-10','14:35:00',3.69),('16273','2013-06-10','14:40:00',3.65),('16273','2013-06-10','14:45:00',3.63),('16273','2013-06-10','14:50:00',3.59),('16273','2013-06-10','14:55:00',3.53),('16273','2013-06-10','15:00:00',3.5),('16273','2013-06-10','15:05:00',3.42),('16273','2013-06-10','15:10:00',3.41),('16273','2013-06-10','15:15:00',3.37),('16273','2013-06-10','15:20:00',3.33),('16273','2013-06-10','15:25:00',3.27),('16273','2013-06-10','15:30:00',3.22),('16273','2013-06-10','15:35:00',3.16),('16273','2013-06-10','15:40:00',3.14),('16273','2013-06-10','15:45:00',3.06),('16273','2013-06-10','15:50:00',2.99),('16273','2013-06-10','15:55:00',2.92),('16273','2013-06-10','16:00:00',2.88),('16273','2013-06-10','16:05:00',2.81),('16273','2013-06-10','16:10:00',2.75),('16273','2013-06-10','16:15:00',2.69),('16273','2013-06-10','16:20:00',2.6),('16273','2013-06-10','16:25:00',2.55),('16273','2013-06-10','16:30:00',2.46),('16273','2013-06-10','16:35:00',2.39),('16273','2013-06-10','16:40:00',2.32),('16273','2013-06-10','16:45:00',2.25),('16273','2013-06-10','16:50:00',2.16),('16273','2013-06-10','16:55:00',2.08),('16273','2013-06-10','17:00:00',2.01),('16273','2013-06-10','17:05:00',1.94),('16273','2013-06-10','17:10:00',1.84),('16273','2013-06-10','17:15:00',1.76),('16273','2013-06-10','17:20:00',1.68),('16273','2013-06-10','17:25:00',1.61),('16273','2013-06-10','17:30:00',1.53),('16273','2013-06-10','17:35:00',1.45),('16273','2013-06-10','17:40:00',1.36),('16273','2013-06-10','17:45:00',1.28),('16273','2013-06-10','17:50:00',1.2),('16273','2013-06-10','17:55:00',1.14),('16273','2013-06-10','18:00:00',1.06),('16273','2013-06-09','07:45:00',1.41),('16273','2013-06-09','07:50:00',1.16),('16273','2013-06-09','07:55:00',1.33),('16273','2013-06-09','08:00:00',1.78),('16273','2013-06-09','08:05:00',1.35),('16273','2013-06-09','08:10:00',1.46),('16273','2013-06-09','08:15:00',1.79),('16273','2013-06-09','08:20:00',2.14),('16273','2013-06-09','08:25:00',2.06),('16273','2013-06-09','08:30:00',2.29),('16273','2013-06-09','08:35:00',2.38),('16273','2013-06-09','08:40:00',2.37),('16273','2013-06-09','08:45:00',2.48),('16273','2013-06-09','08:50:00',2.62),('16273','2013-06-09','08:55:00',2.5),('16273','2013-06-09','09:00:00',2.7),('16273','2013-06-09','09:05:00',2.75),('16273','2013-06-09','09:10:00',2.76),('16273','2013-06-09','09:15:00',2.9),('16273','2013-06-09','09:20:00',2.94),('16273','2013-06-09','09:25:00',2.98),('16273','2013-06-09','09:30:00',3.04),('16273','2013-06-09','09:35:00',3.08),('16273','2013-06-09','09:40:00',3.09),('16273','2013-06-09','09:45:00',3.14),('16273','2013-06-09','09:50:00',3.21),('16273','2013-06-09','09:55:00',3.28),('16273','2013-06-09','10:00:00',3.3),('16273','2013-06-09','10:05:00',3.33),('16273','2013-06-09','10:10:00',3.37),('16273','2013-06-09','10:15:00',3.44),('16273','2013-06-09','10:20:00',3.42),('16273','2013-06-09','10:25:00',3.47),('16273','2013-06-09','10:30:00',3.5),('16273','2013-06-09','10:35:00',3.52),('16273','2013-06-09','10:40:00',3.55),('16273','2013-06-09','10:45:00',3.54),('16273','2013-06-09','10:50:00',3.48),('16273','2013-06-09','10:55:00',3.54),('16273','2013-06-09','11:00:00',3.62),('16273','2013-06-09','11:05:00',3.71),('16273','2013-06-09','11:10:00',3.73),('16273','2013-06-09','11:15:00',3.68),('16273','2013-06-09','11:20:00',3.73),('16273','2013-06-09','11:25:00',3.76),('16273','2013-06-09','11:30:00',3.85),('16273','2013-06-09','11:35:00',3.8),('16273','2013-06-09','11:40:00',3.72),('16273','2013-06-09','11:45:00',3.59),('16273','2013-06-09','11:50:00',2.78),('16273','2013-06-09','11:55:00',3.86),('16273','2013-06-09','12:00:00',3.95),('16273','2013-06-09','12:05:00',3.86),('16273','2013-06-09','12:10:00',3.91),('16273','2013-06-09','12:15:00',3.97),('16273','2013-06-09','12:20:00',3.83),('16273','2013-06-09','12:25:00',2.29),('16273','2013-06-09','12:30:00',3.24),('16273','2013-06-09','12:35:00',4.11),('16273','2013-06-09','12:40:00',3.89),('16273','2013-06-09','12:45:00',3.59),('16273','2013-06-09','12:50:00',3.37),('16273','2013-06-09','12:55:00',3.39),('16273','2013-06-09','13:00:00',3.66),('16273','2013-06-09','13:05:00',3.87),('16273','2013-06-09','13:10:00',3.75),('16273','2013-06-09','13:15:00',3.93),('16273','2013-06-09','13:20:00',3.68),('16273','2013-06-09','13:25:00',3.97),('16273','2013-06-09','13:30:00',4.02),('16273','2013-06-09','13:35:00',3.93),('16273','2013-06-09','13:40:00',3.36),('16273','2013-06-09','13:45:00',2.75),('16273','2013-06-09','13:50:00',2.77),('16273','2013-06-09','13:55:00',4.12),('16273','2013-06-09','14:00:00',4.07),('16273','2013-06-09','14:05:00',4.01),('16273','2013-06-09','14:10:00',3.81),('16273','2013-06-09','14:15:00',1.92),('16273','2013-06-09','14:20:00',1.06),('16273','2013-06-09','14:25:00',1.04),('16273','2013-06-09','14:30:00',2.04),('16273','2013-06-09','14:35:00',4.15),('16273','2013-06-09','14:40:00',3.38),('16273','2013-06-09','14:45:00',3.75),('16273','2013-06-09','14:50:00',3.56),('16273','2013-06-09','14:55:00',3.53),('16273','2013-06-09','15:00:00',3.02),('16273','2013-06-09','15:05:00',3.41),('16273','2013-06-09','15:10:00',3.36),('16273','2013-06-09','15:15:00',3.26),('16273','2013-06-09','15:20:00',3.18),('16273','2013-06-09','15:25:00',3.14),('16273','2013-06-09','15:30:00',3.01),('16273','2013-06-09','15:35:00',2.82),('16273','2013-06-09','15:40:00',2.27),('16273','2013-06-09','15:45:00',2.39),('16273','2013-06-09','15:50:00',2.95),('16273','2013-06-09','15:55:00',2.74),('16273','2013-06-09','16:00:00',2.92),('16273','2013-06-09','16:05:00',2.04),('16273','2013-06-09','16:10:00',2.34),('16273','2013-06-09','16:15:00',1.82),('16273','2013-06-09','16:20:00',1.9),('16273','2013-06-09','16:25:00',1.58),('16273','2013-06-09','18:05:00',1.2),('16273','2013-06-08','07:05:00',1.02),('16273','2013-06-08','07:10:00',1.09),('16273','2013-06-08','07:15:00',1.16),('16273','2013-06-08','07:20:00',1.23),('16273','2013-06-08','07:25:00',1.32),('16273','2013-06-08','07:30:00',1.36),('16273','2013-06-08','07:35:00',1.46),('16273','2013-06-08','07:40:00',1.52),('16273','2013-06-08','07:45:00',1.61),('16273','2013-06-08','07:50:00',1.71),('16273','2013-06-08','07:55:00',1.81),('16273','2013-06-08','08:00:00',1.88),('16273','2013-06-08','08:05:00',1.95),('16273','2013-06-08','08:10:00',2.02),('16273','2013-06-08','08:15:00',2.09),('16273','2013-06-08','08:20:00',2.18),('16273','2013-06-08','08:25:00',2.24),('16273','2013-06-08','08:30:00',2.32),('16273','2013-06-08','08:35:00',2.39),('16273','2013-06-08','08:40:00',2.48),('16273','2013-06-08','08:45:00',2.55),('16273','2013-06-08','08:50:00',2.59),('16273','2013-06-08','08:55:00',2.66),('16273','2013-06-08','09:00:00',2.69),('16273','2013-06-08','09:05:00',2.78),('16273','2013-06-08','09:10:00',2.92),('16273','2013-06-08','09:15:00',3.09),('16273','2013-06-08','09:20:00',3.27),('16273','2013-06-08','09:25:00',2.61),('16273','2013-06-08','09:30:00',1.74),('16273','2013-06-08','09:35:00',1.48),('16273','2013-06-08','09:40:00',1.3),('16273','2013-06-08','09:45:00',3.43),('16273','2013-06-08','09:50:00',3.28),('16273','2013-06-08','09:55:00',3.25),('16273','2013-06-08','10:00:00',1.28),('16273','2013-06-08','10:05:00',3.23),('16273','2013-06-08','10:10:00',2.2),('16273','2013-06-08','10:15:00',3.79),('16273','2013-06-08','10:20:00',3.76),('16273','2013-06-08','10:25:00',3.6),('16273','2013-06-08','10:30:00',3.67),('16273','2013-06-08','10:35:00',3.23),('16273','2013-06-08','10:40:00',2.58),('16273','2013-06-08','10:45:00',3.65),('16273','2013-06-08','10:50:00',4.02),('16273','2013-06-08','10:55:00',1.59),('16273','2013-06-08','11:00:00',1.24),('16273','2013-06-08','11:05:00',3.89),('16273','2013-06-08','11:10:00',4.25),('16273','2013-06-08','11:15:00',4.23),('16273','2013-06-08','11:20:00',4.1),('16273','2013-06-08','11:25:00',3.95),('16273','2013-06-08','11:30:00',3.87),('16273','2013-06-08','11:35:00',3.3),('16273','2013-06-08','11:40:00',4.07),('16273','2013-06-08','11:45:00',3.68),('16273','2013-06-08','11:50:00',4.08),('16273','2013-06-08','11:55:00',4.02),('16273','2013-06-08','12:00:00',4),('16273','2013-06-08','12:05:00',4.11),('16273','2013-06-08','12:10:00',3.76),('16273','2013-06-08','12:15:00',3.74),('16273','2013-06-08','12:20:00',3.95),('16273','2013-06-08','12:25:00',3.94),('16273','2013-06-08','12:30:00',3.91),('16273','2013-06-08','12:35:00',3.91),('16273','2013-06-08','12:40:00',4.01),('16273','2013-06-08','12:45:00',4.09),('16273','2013-06-08','12:50:00',4.02),('16273','2013-06-08','12:55:00',4.01),('16273','2013-06-08','13:00:00',4.01),('16273','2013-06-08','13:05:00',3.95),('16273','2013-06-08','13:10:00',4.01),('16273','2013-06-08','13:15:00',3.97),('16273','2013-06-08','13:20:00',3.99),('16273','2013-06-08','13:25:00',3.96),('16273','2013-06-08','13:30:00',3.9),('16273','2013-06-08','13:35:00',3.89),('16273','2013-06-08','13:40:00',3.87),('16273','2013-06-08','13:45:00',3.88),('16273','2013-06-08','13:50:00',3.89),('16273','2013-06-08','13:55:00',3.86),('16273','2013-06-08','14:00:00',3.84),('16273','2013-06-08','14:05:00',3.83),('16273','2013-06-08','14:10:00',3.83),('16273','2013-06-08','14:15:00',3.78),('16273','2013-06-08','14:20:00',3.76),('16273','2013-06-08','14:25:00',3.72),('16273','2013-06-08','14:30:00',3.68),('16273','2013-06-08','14:35:00',3.62),('16273','2013-06-08','14:40:00',3.61),('16273','2013-06-08','14:45:00',3.58),('16273','2013-06-08','14:50:00',3.53),('16273','2013-06-08','14:55:00',3.49),('16273','2013-06-08','15:00:00',3.38),('16273','2013-06-08','15:05:00',3.35),('16273','2013-06-08','15:10:00',3.22),('16273','2013-06-08','15:15:00',3.33),('16273','2013-06-08','15:20:00',3.25),('16273','2013-06-08','15:25:00',2.86),('16273','2013-06-08','15:30:00',2.79),('16273','2013-06-08','15:35:00',3.01),('16273','2013-06-08','15:40:00',3.15),('16273','2013-06-08','15:45:00',3.27),('16273','2013-06-08','15:50:00',2.93),('16273','2013-06-08','15:55:00',2.96),('16273','2013-06-08','16:00:00',2.88),('16273','2013-06-08','16:05:00',2.88),('16273','2013-06-08','16:10:00',2.85),('16273','2013-06-08','16:15:00',2.78),('16273','2013-06-08','16:20:00',2.66),('16273','2013-06-08','16:25:00',2.53),('16273','2013-06-08','16:30:00',2.44),('16273','2013-06-08','16:35:00',2.35),('16273','2013-06-08','16:40:00',2.29),('16273','2013-06-08','16:45:00',2),('16273','2013-06-08','16:50:00',1.95),('16273','2013-06-08','16:55:00',2.1),('16273','2013-06-08','17:00:00',2.06),('16273','2013-06-08','17:05:00',2.13),('16273','2013-06-08','17:10:00',2.06),('16273','2013-06-08','17:15:00',1.9),('16273','2013-06-08','17:20:00',1.75),('16273','2013-06-08','17:25:00',1.35),('16273','2013-06-08','17:30:00',1.19),('16273','2013-06-08','17:35:00',1.59),('16273','2013-06-08','17:40:00',1.51),('16273','2013-06-08','17:45:00',1.45),('16273','2013-06-08','17:50:00',1.35),('16273','2013-06-08','17:55:00',1.12),('16273','2013-06-07','07:05:00',1.07),('16273','2013-06-07','07:10:00',1.16),('16273','2013-06-07','07:15:00',1.25),('16273','2013-06-07','07:20:00',1.34),('16273','2013-06-07','07:25:00',1.42),('16273','2013-06-07','07:30:00',1.48),('16273','2013-06-07','07:35:00',1.59),('16273','2013-06-07','07:40:00',1.67),('16273','2013-06-07','07:45:00',1.75),('16273','2013-06-07','07:50:00',1.84),('16273','2013-06-07','07:55:00',1.93),('16273','2013-06-07','08:00:00',2.01),('16273','2013-06-07','08:05:00',2.09),('16273','2013-06-07','08:10:00',2.17),('16273','2013-06-07','08:15:00',2.25),('16273','2013-06-07','08:20:00',2.32),('16273','2013-06-07','08:25:00',2.39),('16273','2013-06-07','08:30:00',2.46),('16273','2013-06-07','08:35:00',2.53),('16273','2013-06-07','08:40:00',2.59),('16273','2013-06-07','08:45:00',2.67),('16273','2013-06-07','08:50:00',2.74),('16273','2013-06-07','08:55:00',2.8),('16273','2013-06-07','09:00:00',2.85),('16273','2013-06-07','09:05:00',2.9),('16273','2013-06-07','09:10:00',2.97),('16273','2013-06-07','09:15:00',2.99),('16273','2013-06-07','09:20:00',3.08),('16273','2013-06-07','09:25:00',3.12),('16273','2013-06-07','09:30:00',3.17),('16273','2013-06-07','09:35:00',3.23),('16273','2013-06-07','09:40:00',3.28),('16273','2013-06-07','09:45:00',3.32),('16273','2013-06-07','09:50:00',3.37),('16273','2013-06-07','09:55:00',3.43),('16273','2013-06-07','10:00:00',3.48),('16273','2013-06-07','10:05:00',3.52),('16273','2013-06-07','10:10:00',3.57),('16273','2013-06-07','10:15:00',3.61),('16273','2013-06-07','10:20:00',3.62),('16273','2013-06-07','10:25:00',3.66),('16273','2013-06-07','10:30:00',3.69),('16273','2013-06-07','10:35:00',3.72),('16273','2013-06-07','10:40:00',3.74),('16273','2013-06-07','10:45:00',3.76),('16273','2013-06-07','10:50:00',3.81),('16273','2013-06-07','10:55:00',3.84),('16273','2013-06-07','11:00:00',3.87),('16273','2013-06-07','11:05:00',3.87),('16273','2013-06-07','11:10:00',3.89),('16273','2013-06-07','11:15:00',3.91),('16273','2013-06-07','11:20:00',3.93),('16273','2013-06-07','11:25:00',3.94),('16273','2013-06-07','11:30:00',3.95),('16273','2013-06-07','11:35:00',3.96),('16273','2013-06-07','11:40:00',3.98),('16273','2013-06-07','11:45:00',4),('16273','2013-06-07','11:50:00',4.04),('16273','2013-06-07','11:55:00',4.03),('16273','2013-06-07','12:00:00',4.03),('16273','2013-06-07','12:05:00',4.04),('16273','2013-06-07','12:10:00',4.04),('16273','2013-06-07','12:15:00',4.05),('16273','2013-06-07','12:20:00',4.05),('16273','2013-06-07','12:25:00',4.03),('16273','2013-06-07','12:30:00',4.04),('16273','2013-06-07','12:35:00',4.02),('16273','2013-06-07','12:40:00',4.01),('16273','2013-06-07','12:45:00',4.02),('16273','2013-06-07','12:50:00',4),('16273','2013-06-07','12:55:00',3.97),('16273','2013-06-07','13:00:00',3.96),('16273','2013-06-07','13:05:00',3.95),('16273','2013-06-07','13:10:00',3.93),('16273','2013-06-07','13:15:00',3.91),('16273','2013-06-07','13:20:00',3.91),('16273','2013-06-07','13:25:00',3.87),('16273','2013-06-07','13:30:00',3.85),('16273','2013-06-07','13:35:00',3.84),('16273','2013-06-07','13:40:00',3.83),('16273','2013-06-07','13:45:00',3.82),('16273','2013-06-07','13:50:00',3.82),('16273','2013-06-07','13:55:00',3.8),('16273','2013-06-07','14:00:00',3.72),('16273','2013-06-07','14:05:00',3.7),('16273','2013-06-07','14:10:00',3.69),('16273','2013-06-07','14:15:00',3.67),('16273','2013-06-07','14:20:00',3.63),('16273','2013-06-07','14:25:00',3.59),('16273','2013-06-07','14:30:00',3.53),('16273','2013-06-07','14:35:00',3.45),('16273','2013-06-07','14:40:00',3.15),('16273','2013-06-07','14:45:00',3.41),('16273','2013-06-07','14:50:00',3.36),('16273','2013-06-07','14:55:00',3.38),('16273','2013-06-07','15:00:00',3.37),('16273','2013-06-07','15:05:00',3.36),('16273','2013-06-07','15:10:00',3.32),('16273','2013-06-07','15:15:00',3.3),('16273','2013-06-07','15:20:00',3.23),('16273','2013-06-07','15:25:00',3.21),('16273','2013-06-07','15:30:00',3.14),('16273','2013-06-07','15:35:00',3.08),('16273','2013-06-07','15:40:00',3.01),('16273','2013-06-07','15:45:00',2.96),('16273','2013-06-07','15:50:00',2.88),('16273','2013-06-07','15:55:00',2.73),('16273','2013-06-07','16:00:00',2.57),('16273','2013-06-07','16:05:00',2.7),('16273','2013-06-07','16:10:00',2.63),('16273','2013-06-07','16:15:00',2.53),('16273','2013-06-07','16:20:00',2.36),('16273','2013-06-07','16:25:00',2.47),('16273','2013-06-07','16:30:00',2.44),('16273','2013-06-07','16:35:00',2.35),('16273','2013-06-07','16:40:00',2.3),('16273','2013-06-07','16:45:00',2.2),('16273','2013-06-07','16:50:00',2.11),('16273','2013-06-07','16:55:00',2.05),('16273','2013-06-07','17:00:00',1.9),('16273','2013-06-07','17:05:00',1.83),('16273','2013-06-07','17:10:00',1.82),('16273','2013-06-07','17:15:00',1.76),('16273','2013-06-07','17:20:00',1.67),('16273','2013-06-07','17:25:00',1.57),('16273','2013-06-07','17:30:00',1.5),('16273','2013-06-07','17:35:00',1.44),('16273','2013-06-07','17:40:00',1.39),('16273','2013-06-07','17:45:00',1.33),('16273','2013-06-07','17:50:00',1.25),('16273','2013-06-07','17:55:00',1.2),('16273','2013-06-07','18:05:00',1.03),('16273','2013-06-06','07:00:00',1.19),('16273','2013-06-06','07:05:00',1.19),('16273','2013-06-06','07:45:00',1.62),('16273','2013-06-06','07:50:00',1.79),('16273','2013-06-06','07:55:00',1.84),('16273','2013-06-06','08:00:00',1.56),('16273','2013-06-06','08:05:00',1.82),('16273','2013-06-06','08:10:00',1.42),('16273','2013-06-06','08:15:00',2.01),('16273','2013-06-06','08:20:00',2.28),('16273','2013-06-06','08:25:00',2.34),('16273','2013-06-06','08:30:00',2.42),('16273','2013-06-06','08:35:00',2.47),('16273','2013-06-06','08:40:00',2.55),('16273','2013-06-06','08:45:00',2.5),('16273','2013-06-06','08:50:00',2.68),('16273','2013-06-06','08:55:00',2.63),('16273','2013-06-06','09:00:00',2.82),('16273','2013-06-06','09:05:00',2.84),('16273','2013-06-06','09:10:00',2.85),('16273','2013-06-06','09:15:00',2.95),('16273','2013-06-06','09:20:00',2.87),('16273','2013-06-06','09:25:00',3.04),('16273','2013-06-06','09:30:00',3.16),('16273','2013-06-06','09:35:00',3.24),('16273','2013-06-06','09:40:00',3.3),('16273','2013-06-06','09:45:00',3.25),('16273','2013-06-06','09:50:00',3.29),('16273','2013-06-06','09:55:00',3.29),('16273','2013-06-06','10:00:00',3.34),('16273','2013-06-06','10:05:00',3.44),('16273','2013-06-06','10:10:00',3.46),('16273','2013-06-06','10:15:00',3.54),('16273','2013-06-06','10:20:00',3.56),('16273','2013-06-06','10:25:00',3.61),('16273','2013-06-06','10:30:00',3.58),('16273','2013-06-06','10:35:00',3.64),('16273','2013-06-06','10:40:00',3.77),('16273','2013-06-06','10:45:00',3.79),('16273','2013-06-06','10:50:00',3.77),('16273','2013-06-06','10:55:00',3.86),('16273','2013-06-06','11:00:00',3.89),('16273','2013-06-06','11:05:00',3.83),('16273','2013-06-06','11:10:00',3.83),('16273','2013-06-06','11:15:00',3.9),('16273','2013-06-06','11:20:00',3.52),('16273','2013-06-06','11:25:00',3.87),('16273','2013-06-06','11:30:00',3.22),('16273','2013-06-06','11:35:00',3.98),('16273','2013-06-06','11:40:00',4),('16273','2013-06-06','11:45:00',3.99),('16273','2013-06-06','11:50:00',4.02),('16273','2013-06-06','11:55:00',4.03),('16273','2013-06-06','12:00:00',4.06),('16273','2013-06-06','12:05:00',4.08),('16273','2013-06-06','12:10:00',4.06),('16273','2013-06-06','12:15:00',4.04),('16273','2013-06-06','12:20:00',4),('16273','2013-06-06','12:25:00',3.98),('16273','2013-06-06','12:30:00',4.04),('16273','2013-06-06','12:35:00',4.05),('16273','2013-06-06','12:40:00',4),('16273','2013-06-06','12:45:00',4.01),('16273','2013-06-06','12:50:00',4.04),('16273','2013-06-06','12:55:00',4.23),('16273','2013-06-06','13:00:00',4.34),('16273','2013-06-06','13:05:00',4.31),('16273','2013-06-06','13:10:00',1.49),('16273','2013-06-06','13:15:00',1.17),('16273','2013-06-06','13:20:00',3.52),('16273','2013-06-06','13:25:00',4.21),('16273','2013-06-06','13:30:00',3.92),('16273','2013-06-06','13:35:00',3.96),('16273','2013-06-06','13:40:00',3.91),('16273','2013-06-06','13:45:00',3.89),('16273','2013-06-06','13:50:00',3.81),('16273','2013-06-06','13:55:00',3.76),('16273','2013-06-06','14:00:00',3.69),('16273','2013-06-06','14:05:00',3.76),('16273','2013-06-06','14:10:00',3.72),('16273','2013-06-06','14:15:00',3.7),('16273','2013-06-06','14:20:00',3.72),('16273','2013-06-06','14:25:00',3.69),('16273','2013-06-06','14:30:00',3.64),('16273','2013-06-06','14:35:00',3.6),('16273','2013-06-06','14:40:00',3.53),('16273','2013-06-06','14:45:00',3.49),('16273','2013-06-06','14:50:00',3.46),('16273','2013-06-06','14:55:00',3.41),('16273','2013-06-06','15:00:00',3.36),('16273','2013-06-06','15:05:00',3.32),('16273','2013-06-06','15:10:00',3.25),('16273','2013-06-06','15:15:00',3.2),('16273','2013-06-06','15:20:00',3.16),('16273','2013-06-06','15:25:00',3.09),('16273','2013-06-06','15:30:00',3.06),('16273','2013-06-06','15:35:00',3.01),('16273','2013-06-06','15:40:00',2.94),('16273','2013-06-06','15:45:00',2.87),('16273','2013-06-06','15:50:00',2.82),('16273','2013-06-06','15:55:00',2.78),('16273','2013-06-06','16:00:00',2.72),('16273','2013-06-06','16:05:00',2.68),('16273','2013-06-06','16:10:00',2.61),('16273','2013-06-06','16:15:00',2.55),('16273','2013-06-06','16:20:00',2.48),('16273','2013-06-06','16:25:00',2.44),('16273','2013-06-06','16:30:00',2.34),('16273','2013-06-06','16:35:00',2.29),('16273','2013-06-06','16:40:00',2.2),('16273','2013-06-06','16:45:00',2.13),('16273','2013-06-06','16:50:00',2.07),('16273','2013-06-06','16:55:00',2.01),('16273','2013-06-06','17:00:00',1.92),('16273','2013-06-06','17:05:00',1.85),('16273','2013-06-06','17:10:00',1.77),('16273','2013-06-06','17:15:00',1.68),('16273','2013-06-06','17:20:00',1.63),('16273','2013-06-06','17:25:00',1.56),('16273','2013-06-06','17:30:00',1.48),('16273','2013-06-06','17:35:00',1.41),('16273','2013-06-06','17:40:00',1.33),('16273','2013-06-06','17:45:00',1.24),('16273','2013-06-06','17:50:00',1.17),('16273','2013-06-06','17:55:00',1.09),('16273','2013-06-06','18:00:00',1.03),('16273','2013-06-05','07:10:00',1.16),('16273','2013-06-05','07:15:00',1.26),('16273','2013-06-05','07:20:00',1.47),('16273','2013-06-05','07:25:00',1.36),('16273','2013-06-05','07:45:00',1.33),('16273','2013-06-05','07:50:00',1.78),('16273','2013-06-05','07:55:00',1.85),('16273','2013-06-05','08:00:00',1.98),('16273','2013-06-05','08:05:00',2.08),('16273','2013-06-05','08:10:00',2.11),('16273','2013-06-05','08:15:00',2.19),('16273','2013-06-05','08:20:00',2.28),('16273','2013-06-05','08:25:00',2.33),('16273','2013-06-05','08:30:00',2.41),('16273','2013-06-05','08:35:00',2.5),('16273','2013-06-05','08:40:00',2.58),('16273','2013-06-05','08:45:00',2.58),('16273','2013-06-05','08:50:00',2.78),('16273','2013-06-05','08:55:00',2.88),('16273','2013-06-05','09:00:00',2.49),('16273','2013-06-05','09:05:00',1.22),('16273','2013-06-05','09:10:00',1.91),('16273','2013-06-05','09:15:00',3.19),('16273','2013-06-05','09:20:00',3.04),('16273','2013-06-05','09:25:00',2.89),('16273','2013-06-05','09:30:00',1.33),('16273','2013-06-05','09:35:00',1.42),('16273','2013-06-05','09:40:00',1.18),('16273','2013-06-05','09:45:00',2.02),('16273','2013-06-05','09:50:00',3.64),('16273','2013-06-05','09:55:00',3.66),('16273','2013-06-05','10:00:00',3.79),('16273','2013-06-05','10:05:00',3.8),('16273','2013-06-05','10:10:00',3.16),('16273','2013-06-05','10:15:00',1.65),('16273','2013-06-05','10:20:00',1.16),('16273','2013-06-05','10:25:00',1.13),('16273','2013-06-05','10:30:00',3.18),('16273','2013-06-05','10:35:00',4.01),('16273','2013-06-05','10:40:00',3.93),('16273','2013-06-05','10:45:00',2.12),('16273','2013-06-05','10:50:00',2.91),('16273','2013-06-05','10:55:00',4.05),('16273','2013-06-05','11:00:00',3.7),('16273','2013-06-05','11:05:00',4.51),('16273','2013-06-05','11:10:00',3.89),('16273','2013-06-05','11:15:00',4.41),('16273','2013-06-05','11:20:00',4.42),('16273','2013-06-05','11:25:00',4.4),('16273','2013-06-05','11:30:00',4.3),('16273','2013-06-05','11:35:00',4.26),('16273','2013-06-05','11:40:00',4.27),('16273','2013-06-05','11:45:00',4.31),('16273','2013-06-05','11:50:00',4.41),('16273','2013-06-05','11:55:00',3.48),('16273','2013-06-05','12:00:00',3.47),('16273','2013-06-05','12:05:00',1.6),('16273','2013-06-05','12:10:00',1.75),('16273','2013-06-05','12:15:00',4.51),('16273','2013-06-05','12:20:00',4.83),('16273','2013-06-05','12:25:00',3.78),('16273','2013-06-05','12:30:00',3.87),('16273','2013-06-05','12:35:00',2.37),('16273','2013-06-05','12:40:00',3.59),('16273','2013-06-05','12:45:00',1.78),('16273','2013-06-05','12:50:00',2.38),('16273','2013-06-05','12:55:00',3.93),('16273','2013-06-05','13:00:00',3.12),('16273','2013-06-05','13:05:00',3.85),('16273','2013-06-05','13:10:00',1.89),('16273','2013-06-05','13:15:00',2.82),('16273','2013-06-05','13:20:00',3.74),('16273','2013-06-05','13:25:00',4.04),('16273','2013-06-05','13:30:00',3.88),('16273','2013-06-05','13:35:00',3.17),('16273','2013-06-05','13:40:00',3.36),('16273','2013-06-05','13:45:00',2.84),('16273','2013-06-05','13:50:00',4.2),('16273','2013-06-05','13:55:00',3.84),('16273','2013-06-05','14:00:00',4),('16273','2013-06-05','14:05:00',3.98),('16273','2013-06-05','14:10:00',3.95),('16273','2013-06-05','14:15:00',3.45),('16273','2013-06-05','14:20:00',3.57),('16273','2013-06-05','14:25:00',3.86),('16273','2013-06-05','14:30:00',3.57),('16273','2013-06-05','14:35:00',3.03),('16273','2013-06-05','14:40:00',3.52),('16273','2013-06-05','14:45:00',3.71),('16273','2013-06-05','14:50:00',3.6),('16273','2013-06-05','14:55:00',3.54),('16273','2013-06-05','15:00:00',3.07),('16273','2013-06-05','15:05:00',3.49),('16273','2013-06-05','15:10:00',3.46),('16273','2013-06-05','15:15:00',3.11),('16273','2013-06-05','15:20:00',3.18),('16273','2013-06-05','15:25:00',3.48),('16273','2013-06-05','15:30:00',3.55),('16273','2013-06-05','15:35:00',2.38),('16273','2013-06-05','15:40:00',3.01),('16273','2013-06-05','15:45:00',2.36),('16273','2013-06-05','15:50:00',2.2),('16273','2013-06-05','15:55:00',2.35),('16273','2013-06-05','16:00:00',3.31),('16273','2013-06-05','16:05:00',2.7),('16273','2013-06-05','16:10:00',2.9),('16273','2013-06-05','16:15:00',2.09),('16273','2013-06-05','16:20:00',1.89),('16273','2013-06-05','16:25:00',1.47),('16273','2013-06-05','16:30:00',2.13),('16273','2013-06-05','16:35:00',2.77),('16273','2013-06-05','16:40:00',2.34),('16273','2013-06-05','16:45:00',1.44),('16273','2013-06-05','16:50:00',2.52),('16273','2013-06-05','16:55:00',1.86),('16273','2013-06-05','17:00:00',1.81),('16273','2013-06-05','17:05:00',1.44),('16273','2013-06-05','17:10:00',1.51),('16273','2013-06-05','17:15:00',1.61),('16273','2013-06-05','17:20:00',1.48),('16273','2013-06-05','17:25:00',1.1),('16273','2013-06-05','17:30:00',1.13),('16273','2013-06-05','17:35:00',1.06),('16273','2013-06-05','17:40:00',1.31),('16273','2013-06-05','17:45:00',1.3),('16273','2013-06-05','17:50:00',1.24),('16273','2013-06-05','17:55:00',1.11),('16273','2013-06-05','18:00:00',1.07),('16273','2013-06-05','18:20:00',1.1),('16273','2013-06-04','07:15:00',1.1),('16273','2013-06-04','07:20:00',1.35),('16273','2013-06-04','07:25:00',1.48),('16273','2013-06-04','07:30:00',1.7),('16273','2013-06-04','07:35:00',1.87),('16273','2013-06-04','07:40:00',2.05),('16273','2013-06-04','07:45:00',2.19),('16273','2013-06-04','07:50:00',2.14),('16273','2013-06-04','07:55:00',1.65),('16273','2013-06-04','08:00:00',1.5),('16273','2013-06-04','08:05:00',2.02),('16273','2013-06-04','08:10:00',2.34),('16273','2013-06-04','08:15:00',2.58),('16273','2013-06-04','08:20:00',2.92),('16273','2013-06-04','08:25:00',2.89),('16273','2013-06-04','08:30:00',2.33),('16273','2013-06-04','08:35:00',1.57),('16273','2013-06-04','08:40:00',1.55),('16273','2013-06-04','08:45:00',1.37),('16273','2013-06-04','08:50:00',1.37),('16273','2013-06-04','08:55:00',1.66),('16273','2013-06-04','09:00:00',1.45),('16273','2013-06-04','09:05:00',1.5),('16273','2013-06-04','09:10:00',2.2),('16273','2013-06-04','09:15:00',2.73),('16273','2013-06-04','09:20:00',3.07),('16273','2013-06-04','09:25:00',2.8),('16273','2013-06-04','09:30:00',2.99),('16273','2013-06-04','09:35:00',2.86),('16273','2013-06-04','09:40:00',2.48),('16273','2013-06-04','09:45:00',1.51),('16273','2013-06-04','09:50:00',1.26),('16273','2013-06-04','09:55:00',1.04),('16273','2013-06-04','10:00:00',1.21),('16273','2013-06-04','10:05:00',1.53),('16273','2013-06-04','10:10:00',2.41),('16273','2013-06-04','10:15:00',1.95),('16273','2013-06-04','10:20:00',1.7),('16273','2013-06-04','10:25:00',1.64),('16273','2013-06-04','10:30:00',1.83),('16273','2013-06-04','10:35:00',1.84),('16273','2013-06-04','10:40:00',2.13),('16273','2013-06-04','10:45:00',2.42),('16273','2013-06-04','10:50:00',2.81),('16273','2013-06-04','10:55:00',2.56),('16273','2013-06-04','11:00:00',2.54),('16273','2013-06-04','11:05:00',3.43),('16273','2013-06-04','11:10:00',2.8),('16273','2013-06-04','11:15:00',2.24),('16273','2013-06-04','11:20:00',2.34),('16273','2013-06-04','11:25:00',3.43),('16273','2013-06-04','11:30:00',3.21),('16273','2013-06-04','11:35:00',3.66),('16273','2013-06-04','11:40:00',3.06),('16273','2013-06-04','11:45:00',4.03),('16273','2013-06-04','11:50:00',4.47),('16273','2013-06-04','11:55:00',4.36),('16273','2013-06-04','12:00:00',4.6),('16273','2013-06-04','12:05:00',3.01),('16273','2013-06-04','12:10:00',2.05),('16273','2013-06-04','12:15:00',3.13),('16273','2013-06-04','12:20:00',2.59),('16273','2013-06-04','12:25:00',2.44),('16273','2013-06-04','12:30:00',2.96),('16273','2013-06-04','12:35:00',2.27),('16273','2013-06-04','12:40:00',2.52),('16273','2013-06-04','12:45:00',1.9),('16273','2013-06-04','12:50:00',2.67),('16273','2013-06-04','12:55:00',2.6),('16273','2013-06-04','13:00:00',1.66),('16273','2013-06-04','13:05:00',1.8),('16273','2013-06-04','13:10:00',2.88),('16273','2013-06-04','13:15:00',3.09),('16273','2013-06-04','13:20:00',3.6),('16273','2013-06-04','13:25:00',3.95),('16273','2013-06-04','13:30:00',2.76),('16273','2013-06-04','13:35:00',2.4),('16273','2013-06-04','13:40:00',2.87),('16273','2013-06-04','13:45:00',3.03),('16273','2013-06-04','13:50:00',2.24),('16273','2013-06-04','13:55:00',2.24),('16273','2013-06-04','14:00:00',2.39),('16273','2013-06-04','14:05:00',4.22),('16273','2013-06-04','14:10:00',2.88),('16273','2013-06-04','14:15:00',1.32),('16273','2013-06-04','14:20:00',1.04),('16273','2013-06-04','14:25:00',1.27),('16273','2013-06-04','14:30:00',2.51),('16273','2013-06-04','14:35:00',4.24),('16273','2013-06-04','14:40:00',4.47),('16273','2013-06-04','14:45:00',4.38),('16273','2013-06-04','14:50:00',3.98),('16273','2013-06-04','14:55:00',4.28),('16273','2013-06-04','15:00:00',3.45),('16273','2013-06-04','15:05:00',2.29),('16273','2013-06-04','15:10:00',3.84),('16273','2013-06-04','15:15:00',3.69),('16273','2013-06-04','15:20:00',1.91),('16273','2013-06-04','15:25:00',2.22),('16273','2013-06-04','15:30:00',2.13),('16273','2013-06-04','15:35:00',1.24),('16273','2013-06-04','15:40:00',1),('16273','2013-06-04','15:50:00',1.01),('16273','2013-06-04','15:55:00',1.08),('16273','2013-06-04','16:00:00',1.71),('16273','2013-06-04','16:05:00',1.6),('16273','2013-06-04','16:10:00',1.79),('16273','2013-06-04','16:15:00',1.88),('16273','2013-06-04','16:20:00',1.57),('16273','2013-06-04','16:25:00',1.87),('16273','2013-06-04','16:30:00',2.71),('16273','2013-06-04','16:35:00',3.25),('16273','2013-06-04','16:40:00',2.16),('16273','2013-06-04','16:45:00',1.48),('16273','2013-06-03','06:55:00',1.1),('16273','2013-06-03','07:05:00',1.19),('16273','2013-06-03','07:10:00',1.23),('16273','2013-06-03','07:15:00',1.19),('16273','2013-06-03','07:20:00',1.34),('16273','2013-06-03','07:25:00',1.38),('16273','2013-06-03','07:30:00',1.44),('16273','2013-06-03','07:35:00',1.51),('16273','2013-06-03','07:40:00',1.64),('16273','2013-06-03','07:45:00',1.72),('16273','2013-06-03','07:50:00',1.8),('16273','2013-06-03','07:55:00',1.9),('16273','2013-06-03','08:00:00',1.97),('16273','2013-06-03','08:05:00',2.04),('16273','2013-06-03','08:10:00',2.12),('16273','2013-06-03','08:15:00',2.18),('16273','2013-06-03','08:20:00',2.25),('16273','2013-06-03','08:25:00',2.36),('16273','2013-06-03','08:30:00',2.4),('16273','2013-06-03','08:35:00',2.29),('16273','2013-06-03','08:40:00',2.55),('16273','2013-06-03','08:45:00',2.74),('16273','2013-06-03','08:50:00',2.83),('16273','2013-06-03','08:55:00',2.15),('16273','2013-06-03','09:00:00',2.2),('16273','2013-06-03','09:05:00',1.75),('16273','2013-06-03','09:10:00',2.81),('16273','2013-06-03','09:15:00',3),('16273','2013-06-03','09:20:00',2.35),('16273','2013-06-03','09:25:00',1.7),('16273','2013-06-03','10:05:00',1.05),('16273','2013-06-03','10:10:00',1.21),('16273','2013-06-03','10:15:00',1.55),('16273','2013-06-03','10:20:00',2.77),('16273','2013-06-03','10:25:00',2.99),('16273','2013-06-03','10:30:00',3.26),('16273','2013-06-03','10:35:00',3.26),('16273','2013-06-03','10:40:00',2.24),('16273','2013-06-03','10:45:00',2.05),('16273','2013-06-03','10:50:00',2.18),('16273','2013-06-03','10:55:00',1.73),('16273','2013-06-03','11:00:00',2.68),('16273','2013-06-03','11:05:00',4.53),('16273','2013-06-03','11:10:00',2.74),('16273','2013-06-03','11:15:00',2.11),('16273','2013-06-03','11:20:00',1.75),('16273','2013-06-03','11:25:00',2),('16273','2013-06-03','11:30:00',3.32),('16273','2013-06-03','11:35:00',3.96),('16273','2013-06-03','11:40:00',4.46),('16273','2013-06-03','11:45:00',2.37),('16273','2013-06-03','11:50:00',1.52),('16273','2013-06-03','11:55:00',1.69),('16273','2013-06-03','12:00:00',2.08),('16273','2013-06-03','12:05:00',1.34),('16273','2013-06-03','12:10:00',1.04),('16273','2013-06-03','12:25:00',2.76),('16273','2013-06-03','12:30:00',1.3),('16273','2013-06-03','12:50:00',1.28),('16273','2013-06-03','12:55:00',2.43),('16273','2013-06-03','13:00:00',1.47),('16273','2013-06-03','13:05:00',1.51),('16273','2013-06-03','13:10:00',1.68),('16273','2013-06-03','13:15:00',2.98),('16273','2013-06-03','13:20:00',2.09),('16273','2013-06-03','13:25:00',2.82),('16273','2013-06-03','13:30:00',3),('16273','2013-06-03','13:35:00',3.17),('16273','2013-06-03','13:40:00',4.12),('16273','2013-06-03','13:45:00',4.55),('16273','2013-06-03','13:50:00',2.41),('16273','2013-06-03','13:55:00',3.91),('16273','2013-06-03','14:00:00',2.84),('16273','2013-06-03','14:05:00',4.21),('16273','2013-06-03','14:10:00',3.3),('16273','2013-06-03','14:15:00',2.71),('16273','2013-06-03','14:20:00',2.08),('16273','2013-06-03','14:25:00',2.7),('16273','2013-06-03','14:30:00',3.88),('16273','2013-06-03','14:35:00',3.88),('16273','2013-06-03','14:40:00',3.68),('16273','2013-06-03','14:45:00',3.12),('16273','2013-06-03','14:50:00',3.76),('16273','2013-06-03','14:55:00',2.77),('16273','2013-06-03','15:00:00',3.76),('16273','2013-06-03','15:05:00',3.56),('16273','2013-06-03','15:10:00',3.28),('16273','2013-06-03','15:15:00',3),('16273','2013-06-03','15:20:00',3.62),('16273','2013-06-03','15:25:00',3.25),('16273','2013-06-03','15:30:00',2.58),('16273','2013-06-03','15:35:00',2.97),('16273','2013-06-03','15:40:00',3.14),('16273','2013-06-03','15:45:00',3.11),('16273','2013-06-03','15:50:00',3.08),('16273','2013-06-03','15:55:00',3.01),('16273','2013-06-03','16:00:00',2.92),('16273','2013-06-03','16:05:00',2.84),('16273','2013-06-03','16:10:00',2.8),('16273','2013-06-03','16:15:00',2.66),('16273','2013-06-03','16:20:00',2.35),('16273','2013-06-03','16:25:00',2.39),('16273','2013-06-03','16:30:00',2.48),('16273','2013-06-03','16:35:00',2.09),('16273','2013-06-03','16:40:00',1.95),('16273','2013-06-03','16:45:00',1.74),('16273','2013-06-03','16:50:00',1.78),('16273','2013-06-03','16:55:00',2.5),('16273','2013-06-03','17:00:00',1.85),('16273','2013-06-03','17:05:00',1.7),('16273','2013-06-03','17:10:00',1.82),('16273','2013-06-03','17:15:00',1.56),('16273','2013-06-03','17:20:00',1.6),('16273','2013-06-03','17:25:00',1.6),('16273','2013-06-03','17:30:00',1.63),('16273','2013-06-03','17:35:00',1.27),('16273','2013-06-02','06:45:00',1.21),('16273','2013-06-02','06:50:00',1.29),('16273','2013-06-02','08:35:00',1.47),('16273','2013-06-02','08:40:00',1.24),('16273','2013-06-02','08:45:00',1.05),('16273','2013-06-02','09:10:00',2.93),('16273','2013-06-02','09:15:00',3.22),('16273','2013-06-02','09:20:00',3.3),('16273','2013-06-02','09:25:00',3.29),('16273','2013-06-02','09:30:00',3.27),('16273','2013-06-02','09:35:00',3.36),('16273','2013-06-02','09:40:00',3.37),('16273','2013-06-02','09:45:00',3.38),('16273','2013-06-02','09:50:00',3.28),('16273','2013-06-02','09:55:00',3.25),('16273','2013-06-02','10:00:00',3.59),('16273','2013-06-02','10:05:00',3.66),('16273','2013-06-02','10:10:00',3.79),('16273','2013-06-02','10:15:00',3.98),('16273','2013-06-02','10:20:00',3.89),('16273','2013-06-02','10:25:00',3.69),('16273','2013-06-02','10:30:00',3.16),('16273','2013-06-02','10:35:00',3.55),('16273','2013-06-02','10:40:00',4.2),('16273','2013-06-02','10:45:00',4.45),('16273','2013-06-02','10:50:00',3.81),('16273','2013-06-02','10:55:00',1.61),('16273','2013-06-02','11:00:00',2.98),('16273','2013-06-02','11:05:00',1.96),('16273','2013-06-02','11:10:00',1.92),('16273','2013-06-02','11:15:00',3.05),('16273','2013-06-02','11:20:00',4.76),('16273','2013-06-02','11:25:00',3.22),('16273','2013-06-02','11:30:00',1.6),('16273','2013-06-02','11:35:00',3.55),('16273','2013-06-02','11:40:00',2.81),('16273','2013-06-02','11:45:00',2.45),('16273','2013-06-02','11:50:00',3.09),('16273','2013-06-02','11:55:00',4.6),('16273','2013-06-02','12:00:00',3.87),('16273','2013-06-02','12:05:00',3.63),('16273','2013-06-02','12:10:00',2.94),('16273','2013-06-02','12:15:00',4.63),('16273','2013-06-02','12:20:00',4.45),('16273','2013-06-02','12:25:00',4.27),('16273','2013-06-02','12:30:00',4.15),('16273','2013-06-02','12:35:00',4.23),('16273','2013-06-02','12:40:00',2.68),('16273','2013-06-02','12:45:00',3.81),('16273','2013-06-02','12:50:00',4.07),('16273','2013-06-02','12:55:00',4.25),('16273','2013-06-02','13:00:00',3.97),('16273','2013-06-02','13:05:00',4.25),('16273','2013-06-02','13:10:00',4.14),('16273','2013-06-02','13:15:00',4.13),('16273','2013-06-02','13:20:00',4.13),('16273','2013-06-02','13:25:00',4.11),('16273','2013-06-02','13:30:00',4.07),('16273','2013-06-02','13:35:00',4.03),('16273','2013-06-02','13:40:00',3.82),('16273','2013-06-02','13:45:00',3.46),('16273','2013-06-02','13:50:00',4.06),('16273','2013-06-02','13:55:00',3.87),('16273','2013-06-02','14:00:00',3.87),('16273','2013-06-02','14:05:00',3.17),('16273','2013-06-02','14:10:00',4.04),('16273','2013-06-02','14:15:00',3.96),('16273','2013-06-02','14:20:00',3.97),('16273','2013-06-02','14:25:00',3.32),('16273','2013-06-02','14:30:00',3.85),('16273','2013-06-02','14:35:00',3.72),('16273','2013-06-02','14:40:00',3.27),('16273','2013-06-02','14:45:00',3.67),('16273','2013-06-02','14:50:00',2.36),('16273','2013-06-02','14:55:00',3.24),('16273','2013-06-02','15:00:00',3.57),('16273','2013-06-02','15:05:00',3.08),('16273','2013-06-02','15:10:00',3.22),('16273','2013-06-02','15:15:00',2.51),('16273','2013-06-02','15:20:00',3.07),('16273','2013-06-02','15:25:00',2.96),('16273','2013-06-02','15:30:00',1.69),('16273','2013-06-02','15:35:00',3.01),('16273','2013-06-02','15:40:00',3.35),('16273','2013-06-02','15:45:00',2.55),('16273','2013-06-02','15:50:00',3.13),('16273','2013-06-02','15:55:00',3.06),('16273','2013-06-02','16:00:00',1.68),('16273','2013-06-02','16:05:00',2.14),('16273','2013-06-02','16:10:00',2.01),('16273','2013-06-02','16:15:00',2.85),('16273','2013-06-02','16:20:00',2.27),('16273','2013-06-02','16:25:00',2.53),('16273','2013-06-02','16:30:00',2.17),('16273','2013-06-02','16:35:00',2.42),('16273','2013-06-02','16:40:00',2.3),('16273','2013-06-02','16:45:00',1.7),('16273','2013-06-02','16:50:00',2.21),('16273','2013-06-02','16:55:00',1.84),('16273','2013-06-02','17:00:00',1.88),('16273','2013-06-02','17:05:00',1.84),('16273','2013-06-02','17:10:00',1.77),('16273','2013-06-02','17:15:00',1.41),('16273','2013-06-02','17:20:00',1.76),('16273','2013-06-02','17:25:00',1.09),('16273','2013-06-02','17:30:00',1.25),('16273','2013-06-02','17:35:00',1.2),('16273','2013-06-02','17:40:00',1.25),('16273','2013-06-02','17:45:00',1.36),('16273','2013-06-02','17:50:00',1.22),('16273','2013-06-02','17:55:00',1.24),('16273','2013-06-02','18:00:00',1.03),('16273','2013-06-01','07:05:00',1.12),('16273','2013-06-01','07:10:00',1.22),('16273','2013-06-01','07:15:00',1.31),('16273','2013-06-01','07:20:00',1.4),('16273','2013-06-01','07:25:00',1.49),('16273','2013-06-01','07:30:00',1.58),('16273','2013-06-01','07:35:00',1.7),('16273','2013-06-01','07:40:00',1.92),('16273','2013-06-01','07:45:00',1.77),('16273','2013-06-01','07:50:00',1.14),('16273','2013-06-01','08:25:00',1.59),('16273','2013-06-01','08:30:00',1.27),('16273','2013-06-01','08:40:00',1.32),('16273','2013-06-01','08:55:00',2.13),('16273','2013-06-01','10:20:00',1.24),('16273','2013-06-01','10:25:00',1.13),('16273','2013-06-01','10:30:00',1.38),('16273','2013-06-01','10:35:00',1.63),('16273','2013-06-01','10:40:00',1.98),('16273','2013-06-01','10:45:00',2.41),('16273','2013-06-01','10:50:00',1.67),('16273','2013-06-01','10:55:00',1.15),('16273','2013-06-01','11:00:00',1.37),('16273','2013-06-01','11:10:00',1.01),('16273','2013-06-01','11:15:00',1.39),('16273','2013-06-01','11:20:00',1.27),('16273','2013-06-01','11:25:00',1.59),('16273','2013-06-01','11:30:00',1.23),('16273','2013-06-01','11:35:00',1.02),('16273','2013-06-01','11:40:00',1.37),('16273','2013-06-01','11:45:00',2.03),('16273','2013-06-01','11:50:00',1.82),('16273','2013-06-01','11:55:00',1.97),('16273','2013-06-01','12:00:00',1.16),('16273','2013-06-01','12:05:00',3.26),('16273','2013-06-01','12:10:00',1.09),('16273','2013-06-01','12:15:00',1.26),('16273','2013-06-01','12:20:00',2.64),('16273','2013-06-01','12:25:00',2.12),('16273','2013-06-01','12:30:00',1.78),('16273','2013-06-01','12:35:00',2.07),('16273','2013-06-01','12:40:00',1.82),('16273','2013-06-01','12:45:00',1.95),('16273','2013-06-01','12:50:00',2.13),('16273','2013-06-01','12:55:00',2.14),('16273','2013-06-01','13:00:00',2.02),('16273','2013-06-01','13:05:00',2.16),('16273','2013-06-01','13:10:00',2.35),('16273','2013-06-01','13:15:00',2.57),('16273','2013-06-01','13:20:00',2.29),('16273','2013-06-01','13:25:00',2.12),('16273','2013-06-01','13:30:00',1.72),('16273','2013-06-01','13:35:00',1.65),('16273','2013-06-01','13:40:00',2.04),('16273','2013-06-01','13:45:00',1.29),('16273','2013-06-01','13:50:00',1.72),('16273','2013-06-01','13:55:00',2.03),('16273','2013-06-01','14:00:00',2.62),('16273','2013-06-01','14:05:00',2.41),('16273','2013-06-01','14:10:00',2.19),('16273','2013-06-01','14:15:00',2.4),('16273','2013-06-01','14:20:00',1.65),('16273','2013-06-01','14:25:00',1.28),('16273','2013-06-01','14:30:00',1.06),('16273','2013-06-01','14:40:00',1.01),('16273','2013-06-01','14:45:00',1.16),('16273','2013-06-01','14:50:00',1.14),('16273','2013-06-01','15:30:00',1.05),('16273','2013-06-01','15:35:00',1.52),('16273','2013-06-01','15:40:00',1.78),('16273','2013-06-01','15:45:00',1.66),('16273','2013-06-01','15:50:00',2.14),('16273','2013-06-01','15:55:00',1.61),('16273','2013-06-01','16:00:00',1.05),('16273','2013-06-01','16:15:00',1.13),('16273','2013-06-01','16:20:00',1.12),('16273','2013-06-01','16:25:00',1.1),('16273','2013-06-01','16:35:00',1.09),('16273','2013-06-01','16:40:00',1.18),('16273','2013-06-01','16:45:00',1.06),('16273','2013-06-01','18:30:00',1.09),('16273','2014-04-02','08:10:00',1.31),('16273','2014-04-02','08:15:00',1.23),('16273','2014-04-02','09:00:00',1.23),('16273','2014-04-02','09:05:00',1.46),('16273','2014-04-02','09:10:00',1.6),('16273','2014-04-02','09:15:00',1.19),('16273','2014-04-02','09:20:00',2),('16273','2014-04-02','09:25:00',2.84),('16273','2014-04-02','09:30:00',2.56),('16273','2014-04-02','09:35:00',1.33),('16273','2014-04-02','09:55:00',1.02),('16273','2014-04-02','10:00:00',1.1),('16273','2014-04-02','10:05:00',1.06),('16273','2014-04-02','10:10:00',1.3),('16273','2014-04-02','10:15:00',2.18),('16273','2014-04-02','10:20:00',2.53),('16273','2014-04-02','10:25:00',2.98),('16273','2014-04-02','10:30:00',3.38),('16273','2014-04-02','10:35:00',3.3),('16273','2014-04-02','10:40:00',1.61),('16273','2014-04-02','10:45:00',1.04),('16273','2014-04-02','11:10:00',1.41),('16273','2014-04-02','11:15:00',2.85),('16273','2014-04-02','11:20:00',1.4),('16273','2014-04-02','11:25:00',1.44),('16273','2014-04-02','11:30:00',1.36),('16273','2014-04-02','11:35:00',1.41),('16273','2014-04-02','11:40:00',2.49),('16273','2014-04-02','11:45:00',4.06),('16273','2014-04-02','11:50:00',4),('16273','2014-04-02','11:55:00',3.38),('16273','2014-04-02','12:00:00',1.5),('16273','2014-04-02','12:05:00',1.23),('16273','2014-04-02','12:10:00',4.34),('16273','2014-04-02','12:15:00',4.29),('16273','2014-04-02','12:20:00',3.69),('16273','2014-04-02','12:25:00',4.32),('16273','2014-04-02','12:30:00',4.27),('16273','2014-04-02','12:35:00',2.23),('16273','2014-04-02','12:40:00',2.14),('16273','2014-04-02','12:45:00',1.22),('16273','2014-04-02','12:50:00',2.4),('16273','2014-04-02','12:55:00',2.21),('16273','2014-04-02','13:00:00',2.1),('16273','2014-04-02','13:05:00',1.99),('16273','2014-04-02','13:10:00',1.27),('16273','2014-04-02','13:15:00',1.07),('16273','2014-04-02','13:20:00',1.5),('16273','2014-04-02','13:25:00',1.8),('16273','2014-04-02','13:30:00',3.42),('16273','2014-04-02','13:35:00',3.03),('16273','2014-04-02','13:40:00',3.35),('16273','2014-04-02','13:45:00',3.22),('16273','2014-04-02','13:50:00',3.15),('16273','2014-04-02','13:55:00',1.51),('16273','2014-04-02','14:00:00',3.01),('16273','2014-04-02','14:05:00',2.81),('16273','2014-04-02','14:10:00',2.68),('16273','2014-04-02','14:15:00',3.01),('16273','2014-04-02','14:20:00',1.98),('16273','2014-04-02','14:25:00',3.6),('16273','2014-04-02','14:30:00',3.45),('16273','2014-04-02','14:35:00',3.42),('16273','2014-04-02','14:40:00',3.35),('16273','2014-04-02','14:45:00',3.24),('16273','2014-04-02','14:50:00',2.97),('16273','2014-04-02','14:55:00',3.05),('16273','2014-04-02','15:00:00',3.04),('16273','2014-04-02','15:05:00',2.87),('16273','2014-04-02','15:10:00',2.9),('16273','2014-04-02','15:15:00',2.9),('16273','2014-04-02','15:20:00',2.86),('16273','2014-04-02','15:25:00',2.78),('16273','2014-04-02','15:30:00',2.62),('16273','2014-04-02','15:35:00',2.59),('16273','2014-04-02','15:40:00',2.58),('16273','2014-04-02','15:45:00',2.54),('16273','2014-04-02','15:50:00',2.47),('16273','2014-04-02','15:55:00',2.3),('16273','2014-04-02','16:00:00',2.29),('16273','2014-04-02','16:05:00',2.18),('16273','2014-04-02','16:10:00',2.1),('16273','2014-04-02','16:15:00',2.02),('16273','2014-04-02','16:20:00',2.03),('16273','2014-04-02','16:25:00',1.88),('16273','2014-04-02','16:30:00',1.94),('16273','2014-04-02','16:35:00',1.82),('16273','2014-04-02','16:40:00',1.73),('16273','2014-04-02','16:45:00',1.63),('16273','2014-04-02','16:50:00',1.52),('16273','2014-04-02','16:55:00',1.53),('16273','2014-04-02','17:00:00',1.46),('16273','2014-04-02','17:05:00',1.28),('16273','2014-04-02','17:10:00',1.22),('16273','2014-04-02','17:15:00',1.08),('16273','2014-04-02','17:20:00',1.09),('16273','2014-04-02','17:25:00',1.01),('16273','2013-05-31','07:05:00',1.07),('16273','2013-05-31','07:10:00',1.18),('16273','2013-05-31','07:15:00',1.29),('16273','2013-05-31','07:20:00',1.39),('16273','2013-05-31','07:25:00',1.47),('16273','2013-05-31','07:30:00',1.56),('16273','2013-05-31','07:35:00',1.65),('16273','2013-05-31','07:40:00',1.73),('16273','2013-05-31','07:45:00',1.81),('16273','2013-05-31','07:50:00',1.92),('16273','2013-05-31','07:55:00',2.05),('16273','2013-05-31','08:00:00',2.04),('16273','2013-05-31','08:05:00',2.15),('16273','2013-05-31','08:10:00',2.24),('16273','2013-05-31','08:15:00',2.3),('16273','2013-05-31','08:20:00',2.38),('16273','2013-05-31','08:25:00',2.46),('16273','2013-05-31','08:30:00',2.3),('16273','2013-05-31','08:35:00',1.32),('16273','2013-05-31','08:40:00',2.81),('16273','2013-05-31','08:45:00',3.02),('16273','2013-05-31','08:50:00',1.99),('16273','2013-05-31','08:55:00',1.48),('16273','2013-05-31','09:00:00',2.56),('16273','2013-05-31','09:05:00',2.99),('16273','2013-05-31','09:10:00',1.39),('16273','2013-05-31','09:15:00',2.43),('16273','2013-05-31','09:20:00',1.22),('16273','2013-05-31','09:25:00',1.51),('16273','2013-05-31','09:30:00',2.69),('16273','2013-05-31','09:35:00',3.6),('16273','2013-05-31','09:40:00',3.63),('16273','2013-05-31','09:45:00',3.85),('16273','2013-05-31','09:50:00',2.31),('16273','2013-05-31','09:55:00',3.07),('16273','2013-05-31','10:00:00',3.78),('16273','2013-05-31','10:05:00',3.23),('16273','2013-05-31','10:10:00',2.33),('16273','2013-05-31','10:15:00',1.04),('16273','2013-05-31','10:20:00',2.47),('16273','2013-05-31','10:25:00',3.45),('16273','2013-05-31','10:30:00',2.35),('16273','2013-05-31','10:35:00',4.18),('16273','2013-05-31','10:40:00',4.45),('16273','2013-05-31','10:45:00',1.67),('16273','2013-05-31','10:50:00',1.94),('16273','2013-05-31','10:55:00',1.97),('16273','2013-05-31','11:00:00',2.26),('16273','2013-05-31','11:05:00',2.17),('16273','2013-05-31','11:10:00',2.93),('16273','2013-05-31','11:20:00',2.02),('16273','2013-05-31','11:25:00',2.4),('16273','2013-05-31','11:30:00',1.54),('16273','2013-05-31','11:35:00',2.67),('16273','2013-05-31','11:40:00',2.9),('16273','2013-05-31','11:45:00',2.56),('16273','2013-05-31','11:50:00',2.77),('16273','2013-05-31','11:55:00',3.52),('16273','2013-05-31','12:00:00',3.1),('16273','2013-05-31','12:05:00',2.07),('16273','2013-05-31','12:10:00',1.55),('16273','2013-05-31','12:15:00',2.09),('16273','2013-05-31','12:20:00',2.83),('16273','2013-05-31','12:25:00',1.55),('16273','2013-05-31','12:30:00',2.47),('16273','2013-05-31','12:35:00',3.68),('16273','2013-05-31','12:40:00',1.09),('16273','2013-05-31','12:45:00',1.64),('16273','2013-05-31','12:50:00',3.61),('16273','2013-05-31','12:55:00',2.64),('16273','2013-05-31','13:00:00',1.21),('16273','2013-05-31','13:10:00',1.25),('16273','2013-05-31','13:15:00',3.56),('16273','2013-05-31','13:20:00',2.18),('16273','2013-05-31','13:25:00',2.35),('16273','2013-05-31','13:30:00',1.23),('16273','2013-05-31','13:35:00',1.26),('16273','2013-05-31','13:40:00',3.11),('16273','2013-05-31','13:45:00',2.45),('16273','2013-05-31','13:50:00',1.97),('16273','2013-05-31','13:55:00',1.28),('16273','2013-05-31','14:25:00',1.83),('16273','2013-05-31','14:30:00',1.01),('16273','2013-05-31','14:50:00',2.05),('16273','2013-05-31','14:55:00',2.31),('16273','2013-05-31','15:00:00',1.25),('16273','2013-05-31','15:05:00',1.49),('16273','2013-05-31','15:10:00',2.23),('16273','2013-05-31','15:15:00',2.3),('16273','2013-05-31','15:20:00',1.69),('16273','2013-05-31','15:25:00',1.34),('16273','2013-05-31','15:30:00',1.47),('16273','2013-05-31','15:35:00',1.36),('16273','2013-05-31','15:40:00',1.63),('16273','2013-05-31','15:45:00',2.48),('16273','2013-05-31','15:50:00',2.11),('16273','2013-05-31','15:55:00',1.43),('16273','2013-05-31','16:00:00',1),('16273','2013-05-31','16:15:00',1.26),('16273','2013-05-31','16:20:00',1.3),('16273','2013-05-31','16:25:00',1.01),('16273','2013-05-31','16:35:00',1.06),('16273','2013-05-31','16:40:00',1.07),('16273','2013-05-30','07:35:00',1.65),('16273','2013-05-30','07:40:00',1.75),('16273','2013-05-30','07:45:00',1.42),('16273','2013-05-30','08:10:00',1.18),('16273','2013-05-30','08:20:00',1.15),('16273','2013-05-30','08:25:00',2.58),('16273','2013-05-30','08:30:00',2.66),('16273','2013-05-30','08:35:00',2.71),('16273','2013-05-30','08:40:00',2.77),('16273','2013-05-30','08:45:00',2.91),('16273','2013-05-30','08:50:00',3.13),('16273','2013-05-30','08:55:00',2.82),('16273','2013-05-30','09:00:00',3.19),('16273','2013-05-30','09:05:00',3.46),('16273','2013-05-30','09:10:00',2.91),('16273','2013-05-30','09:15:00',2.41),('16273','2013-05-30','09:20:00',3.29),('16273','2013-05-30','09:25:00',3.47),('16273','2013-05-30','09:30:00',3.05),('16273','2013-05-30','09:35:00',2.62),('16273','2013-05-30','09:40:00',3.2),('16273','2013-05-30','09:45:00',2.81),('16273','2013-05-30','09:50:00',2.1),('16273','2013-05-30','09:55:00',3.3),('16273','2013-05-30','10:00:00',3.41),('16273','2013-05-30','10:05:00',3.72),('16273','2013-05-30','10:10:00',2.01),('16273','2013-05-30','10:15:00',3.78),('16273','2013-05-30','10:20:00',3.21),('16273','2013-05-30','10:25:00',3.26),('16273','2013-05-30','10:30:00',4.27),('16273','2013-05-30','10:35:00',3.77),('16273','2013-05-30','10:40:00',2.89),('16273','2013-05-30','10:45:00',4.53),('16273','2013-05-30','10:50:00',3.53),('16273','2013-05-30','10:55:00',2.66),('16273','2013-05-30','11:00:00',4.25),('16273','2013-05-30','11:05:00',3.58),('16273','2013-05-30','11:10:00',4.68),('16273','2013-05-30','11:15:00',2.53),('16273','2013-05-30','11:20:00',4.47),('16273','2013-05-30','11:25:00',3.45),('16273','2013-05-30','11:30:00',3.87),('16273','2013-05-30','11:35:00',4.05),('16273','2013-05-30','11:40:00',2.45),('16273','2013-05-30','11:45:00',4.18),('16273','2013-05-30','11:50:00',4.3),('16273','2013-05-30','11:55:00',1.97),('16273','2013-05-30','12:00:00',2.55),('16273','2013-05-30','12:05:00',2.43),('16273','2013-05-30','12:10:00',4.21),('16273','2013-05-30','12:15:00',2.29),('16273','2013-05-30','12:20:00',3.08),('16273','2013-05-30','12:25:00',3.91),('16273','2013-05-30','12:30:00',4.03),('16273','2013-05-30','12:35:00',3.89),('16273','2013-05-30','12:40:00',2.48),('16273','2013-05-30','12:45:00',3.21),('16273','2013-05-30','12:50:00',2.77),('16273','2013-05-30','12:55:00',3.25),('16273','2013-05-30','13:00:00',3.29),('16273','2013-05-30','13:05:00',3.02),('16273','2013-05-30','13:10:00',2.45),('16273','2013-05-30','13:15:00',1.67),('16273','2013-05-30','13:20:00',1.53),('16273','2013-05-30','13:25:00',1.89),('16273','2013-05-30','13:30:00',2.38),('16273','2013-05-30','13:35:00',1.81),('16273','2013-05-30','13:40:00',1.8),('16273','2013-05-30','13:45:00',2.07),('16273','2013-05-30','13:50:00',4.56),('16273','2013-05-30','13:55:00',3.59),('16273','2013-05-30','14:00:00',4.75),('16273','2013-05-30','14:05:00',4.68),('16273','2013-05-30','14:10:00',4.12),('16273','2013-05-30','14:15:00',4.58),('16273','2013-05-30','14:20:00',4.54),('16273','2013-05-30','14:25:00',4.49),('16273','2013-05-30','14:30:00',3.65),('16273','2013-05-30','14:35:00',3.04),('16273','2013-05-30','14:40:00',3.14),('16273','2013-05-30','14:45:00',3.02),('16273','2013-05-30','14:50:00',3.36),('16273','2013-05-30','14:55:00',1.74),('16273','2013-05-30','15:00:00',3.25),('16273','2013-05-30','15:05:00',3.53),('16273','2013-05-30','15:10:00',3.85),('16273','2013-05-30','15:15:00',2.37),('16273','2013-05-30','15:20:00',2.3),('16273','2013-05-30','15:25:00',2.91),('16273','2013-05-30','15:30:00',2.9),('16273','2013-05-30','15:35:00',3.83),('16273','2013-05-30','15:40:00',2.61),('16273','2013-05-30','15:45:00',1.47),('16273','2013-05-30','15:50:00',2.3),('16273','2013-05-30','15:55:00',3.51),('16273','2013-05-30','16:00:00',3.19),('16273','2013-05-30','16:05:00',3.05),('16273','2013-05-30','16:10:00',1.73),('16273','2013-05-30','16:20:00',1.02),('16273','2013-05-30','16:25:00',1.25),('16273','2013-05-30','16:30:00',1.02),('16273','2013-05-30','16:35:00',2.29),('16273','2013-05-30','16:40:00',2.17),('16273','2013-05-30','16:45:00',1.4),('16273','2013-05-30','16:50:00',2.07),('16273','2013-05-30','16:55:00',2.65),('16273','2013-05-30','17:00:00',2.27),('16273','2013-05-30','17:55:00',1.01),('16273','2013-05-30','18:00:00',1.44),('16273','2013-05-30','18:25:00',1.02),('16273','2013-05-30','18:30:00',1.32),('16273','2013-05-30','18:35:00',1.25),('16273','2013-05-30','18:40:00',1.16),('16273','2013-05-29','07:05:00',1.06),('16273','2013-05-29','07:10:00',1.17),('16273','2013-05-29','07:15:00',1.27),('16273','2013-05-29','07:20:00',1.36),('16273','2013-05-29','07:25:00',1.45),('16273','2013-05-29','07:30:00',1.53),('16273','2013-05-29','07:35:00',1.6),('16273','2013-05-29','07:40:00',1.69),('16273','2013-05-29','07:45:00',1.77),('16273','2013-05-29','07:50:00',1.86),('16273','2013-05-29','07:55:00',1.93),('16273','2013-05-29','08:00:00',2.03),('16273','2013-05-29','08:05:00',2.11),('16273','2013-05-29','08:10:00',2.2),('16273','2013-05-29','08:15:00',2.28),('16273','2013-05-29','08:20:00',2.36),('16273','2013-05-29','08:25:00',2.42),('16273','2013-05-29','08:30:00',2.5),('16273','2013-05-29','08:35:00',2.58),('16273','2013-05-29','08:40:00',2.64),('16273','2013-05-29','08:45:00',2.71),('16273','2013-05-29','08:50:00',2.75),('16273','2013-05-29','08:55:00',2.85),('16273','2013-05-29','09:00:00',2.92),('16273','2013-05-29','09:05:00',2.99),('16273','2013-05-29','09:10:00',3.07),('16273','2013-05-29','09:15:00',3.12),('16273','2013-05-29','09:20:00',3.18),('16273','2013-05-29','09:25:00',3.25),('16273','2013-05-29','09:30:00',3.31),('16273','2013-05-29','09:35:00',3.35),('16273','2013-05-29','09:40:00',3.42),('16273','2013-05-29','09:45:00',3.47),('16273','2013-05-29','09:50:00',3.52),('16273','2013-05-29','09:55:00',3.55),('16273','2013-05-29','10:00:00',3.56),('16273','2013-05-29','10:05:00',3.6),('16273','2013-05-29','10:10:00',3.69),('16273','2013-05-29','10:15:00',3.72),('16273','2013-05-29','10:20:00',3.58),('16273','2013-05-29','10:25:00',3.74),('16273','2013-05-29','10:30:00',3.87),('16273','2013-05-29','10:35:00',3.89),('16273','2013-05-29','10:40:00',3.27),('16273','2013-05-29','10:45:00',3.53),('16273','2013-05-29','10:50:00',3.85),('16273','2013-05-29','10:55:00',3.68),('16273','2013-05-29','11:00:00',3.36),('16273','2013-05-29','11:05:00',1.85),('16273','2013-05-29','11:10:00',4.46),('16273','2013-05-29','11:15:00',2.33),('16273','2013-05-29','11:20:00',3.07),('16273','2013-05-29','11:25:00',2.57),('16273','2013-05-29','11:30:00',2.71),('16273','2013-05-29','11:35:00',3.64),('16273','2013-05-29','11:40:00',3.81),('16273','2013-05-29','11:45:00',3.93),('16273','2013-05-29','11:50:00',4.54),('16273','2013-05-29','11:55:00',4.51),('16273','2013-05-29','12:00:00',4.38),('16273','2013-05-29','12:05:00',4.35),('16273','2013-05-29','12:10:00',4.39),('16273','2013-05-29','12:15:00',4.44),('16273','2013-05-29','12:20:00',4.45),('16273','2013-05-29','12:25:00',4.4),('16273','2013-05-29','12:30:00',4.34),('16273','2013-05-29','12:35:00',4.34),('16273','2013-05-29','12:40:00',4.35),('16273','2013-05-29','12:45:00',4.34),('16273','2013-05-29','12:50:00',4.33),('16273','2013-05-29','12:55:00',4.34),('16273','2013-05-29','13:00:00',4.18),('16273','2013-05-29','13:05:00',4.41),('16273','2013-05-29','13:10:00',3.8),('16273','2013-05-29','13:15:00',2.19),('16273','2013-05-29','13:20:00',3.79),('16273','2013-05-29','13:25:00',3.51),('16273','2013-05-29','13:30:00',1.85),('16273','2013-05-29','13:35:00',2.54),('16273','2013-05-29','13:40:00',3.03),('16273','2013-05-29','13:45:00',2.98),('16273','2013-05-29','13:50:00',4.11),('16273','2013-05-29','13:55:00',4.27),('16273','2013-05-29','14:00:00',4.14),('16273','2013-05-29','14:05:00',3.98),('16273','2013-05-29','14:10:00',4.37),('16273','2013-05-29','14:15:00',2.71),('16273','2013-05-29','14:20:00',3.34),('16273','2013-05-29','14:25:00',3.55),('16273','2013-05-29','14:30:00',2.86),('16273','2013-05-29','14:35:00',3.79),('16273','2013-05-29','14:40:00',3.71),('16273','2013-05-29','14:45:00',2.6),('16273','2013-05-29','14:50:00',4),('16273','2013-05-29','14:55:00',3.81),('16273','2013-05-29','15:00:00',3.46),('16273','2013-05-29','15:05:00',2.45),('16273','2013-05-29','15:10:00',3.32),('16273','2013-05-29','15:15:00',3.92),('16273','2013-05-29','15:20:00',2.26),('16273','2013-05-29','15:25:00',2.53),('16273','2013-05-29','15:30:00',2.75),('16273','2013-05-29','15:35:00',3.05),('16273','2013-05-29','15:40:00',2.5),('16273','2013-05-29','15:45:00',2.81),('16273','2013-05-29','15:50:00',2.71),('16273','2013-05-29','15:55:00',2.81),('16273','2013-05-29','16:00:00',2.71),('16273','2013-05-29','16:05:00',2.52),('16273','2013-05-29','16:10:00',2.41),('16273','2013-05-29','16:15:00',2.66),('16273','2013-05-29','16:20:00',2.82),('16273','2013-05-29','16:25:00',2.84),('16273','2013-05-29','16:30:00',2.26),('16273','2013-05-29','16:35:00',1.75),('16273','2013-05-29','16:40:00',1.54),('16273','2013-05-29','16:45:00',1.31),('16273','2013-05-29','16:50:00',1.08),('16273','2013-05-29','17:30:00',1.37),('16273','2013-05-29','17:35:00',1.47),('16273','2013-05-29','17:40:00',1.08),('16273','2013-05-29','17:55:00',1.11),('16273','2013-05-29','18:00:00',1.11),('16273','2013-05-29','18:05:00',1.37),('16273','2013-05-29','18:10:00',1.17),('16273','2013-05-29','18:15:00',1.06),('16273','2013-05-28','07:15:00',1.23),('16273','2013-05-28','07:20:00',1.13),('16273','2013-05-28','07:25:00',1.35),('16273','2013-05-28','07:30:00',1.39),('16273','2013-05-28','07:35:00',1.23),('16273','2013-05-28','07:40:00',1.32),('16273','2013-05-28','07:45:00',1.41),('16273','2013-05-28','07:50:00',1.39),('16273','2013-05-28','07:55:00',1.21),('16273','2013-05-28','08:00:00',1.27),('16273','2013-05-28','08:05:00',1.49),('16273','2013-05-28','08:10:00',1.72),('16273','2013-05-28','08:15:00',1.96),('16273','2013-05-28','08:20:00',1.72),('16273','2013-05-28','08:25:00',1.83),('16273','2013-05-28','08:30:00',2.08),('16273','2013-05-28','08:35:00',1.9),('16273','2013-05-28','08:40:00',1.54),('16273','2013-05-28','08:45:00',1.61),('16273','2013-05-28','08:50:00',1.61),('16273','2013-05-28','08:55:00',1.7),('16273','2013-05-28','09:00:00',1.65),('16273','2013-05-28','09:05:00',1.93),('16273','2013-05-28','09:10:00',2.14),('16273','2013-05-28','09:15:00',2.2),('16273','2013-05-28','09:20:00',2.15),('16273','2013-05-28','09:25:00',2.34),('16273','2013-05-28','09:30:00',2.65),('16273','2013-05-28','09:35:00',2.76),('16273','2013-05-28','09:40:00',2.57),('16273','2013-05-28','09:45:00',2.51),('16273','2013-05-28','09:50:00',2.55),('16273','2013-05-28','09:55:00',2.28),('16273','2013-05-28','10:00:00',2.05),('16273','2013-05-28','10:05:00',2.21),('16273','2013-05-28','10:10:00',2.4),('16273','2013-05-28','10:15:00',2.54),('16273','2013-05-28','10:20:00',2.32),('16273','2013-05-28','10:25:00',2.46),('16273','2013-05-28','10:30:00',2.85),('16273','2013-05-28','10:35:00',3.05),('16273','2013-05-28','10:40:00',3.09),('16273','2013-05-28','10:45:00',2.44),('16273','2013-05-28','10:50:00',2.62),('16273','2013-05-28','10:55:00',2.46),('16273','2013-05-28','11:00:00',2.75),('16273','2013-05-28','11:05:00',3.28),('16273','2013-05-28','11:10:00',2.95),('16273','2013-05-28','11:15:00',2.18),('16273','2013-05-28','11:20:00',2.02),('16273','2013-05-28','11:25:00',3.91),('16273','2013-05-28','11:30:00',3.1),('16273','2013-05-28','11:35:00',3.65),('16273','2013-05-28','11:40:00',3.01),('16273','2013-05-28','11:45:00',1.04),('16273','2013-05-28','11:50:00',1.12),('16273','2013-05-28','11:55:00',1.3),('16273','2013-05-28','12:00:00',2.13),('16273','2013-05-28','12:05:00',2.25),('16273','2013-05-28','12:10:00',2.45),('16273','2013-05-28','12:15:00',2.34),('16273','2013-05-28','12:20:00',2.3),('16273','2013-05-28','12:25:00',2.66),('16273','2013-05-28','12:30:00',2.23),('16273','2013-05-28','12:35:00',2.19),('16273','2013-05-28','12:40:00',2.23),('16273','2013-05-28','12:45:00',2.13),('16273','2013-05-28','12:50:00',2.2),('16273','2013-05-28','12:55:00',2.48),('16273','2013-05-28','13:00:00',2.58),('16273','2013-05-28','13:05:00',2.61),('16273','2013-05-28','13:10:00',1.89),('16273','2013-05-28','13:15:00',1.68),('16273','2013-05-28','13:20:00',2.77),('16273','2013-05-28','13:25:00',2.83),('16273','2013-05-28','13:30:00',4.17),('16273','2013-05-28','13:35:00',2.34),('16273','2013-05-28','13:40:00',2.39),('16273','2013-05-28','13:45:00',1.93),('16273','2013-05-28','13:50:00',2.19),('16273','2013-05-28','13:55:00',1.74),('16273','2013-05-28','14:00:00',1.9),('16273','2013-05-28','14:05:00',2.41),('16273','2013-05-28','14:10:00',2.32),('16273','2013-05-28','14:15:00',2.91),('16273','2013-05-28','14:20:00',3.35),('16273','2013-05-28','14:25:00',2.47),('16273','2013-05-28','14:30:00',3.13),('16273','2013-05-28','14:35:00',2.52),('16273','2013-05-28','14:40:00',2.4),('16273','2013-05-28','14:45:00',2.63),('16273','2013-05-28','14:50:00',3.02),('16273','2013-05-28','14:55:00',3.26),('16273','2013-05-28','15:00:00',2.75),('16273','2013-05-28','15:05:00',1.55),('16273','2013-05-28','15:10:00',2.09),('16273','2013-05-28','15:15:00',2.19),('16273','2013-05-28','15:20:00',1.91),('16273','2013-05-28','15:25:00',1.53),('16273','2013-05-28','15:30:00',1.93),('16273','2013-05-28','15:35:00',1.69),('16273','2013-05-28','15:40:00',1.85),('16273','2013-05-28','15:45:00',1.91),('16273','2013-05-28','15:50:00',2.16),('16273','2013-05-28','15:55:00',2.4),('16273','2013-05-28','16:00:00',2.41),('16273','2013-05-28','16:05:00',1.98),('16273','2013-05-28','16:10:00',1.67),('16273','2013-05-28','16:15:00',1.84),('16273','2013-05-28','16:20:00',1.6),('16273','2013-05-28','16:25:00',1.15),('16273','2013-05-28','16:30:00',1.05),('16273','2013-05-28','16:35:00',1.07),('16273','2013-05-28','16:40:00',2.27),('16273','2013-05-28','16:45:00',2.1),('16273','2013-05-28','16:50:00',1.99),('16273','2013-05-28','16:55:00',1.91),('16273','2013-05-28','17:00:00',1.85),('16273','2013-05-28','17:05:00',1.78),('16273','2013-05-28','17:10:00',1.71),('16273','2013-05-28','17:15:00',1.62),('16273','2013-05-28','17:20:00',1.54),('16273','2013-05-28','17:25:00',1.46),('16273','2013-05-28','17:30:00',1.36),('16273','2013-05-28','17:35:00',1.32),('16273','2013-05-28','17:40:00',1.26),('16273','2013-05-28','17:45:00',1.19),('16273','2013-05-28','18:15:00',1.04),('16273','2013-05-27','07:10:00',1.22),('16273','2013-05-27','07:15:00',1.06),('16273','2013-05-27','07:20:00',1.17),('16273','2013-05-27','07:25:00',1.52),('16273','2013-05-27','07:30:00',1.6),('16273','2013-05-27','07:35:00',1.66),('16273','2013-05-27','07:40:00',1.73),('16273','2013-05-27','07:45:00',1.82),('16273','2013-05-27','07:50:00',2),('16273','2013-05-27','07:55:00',2.21),('16273','2013-05-27','08:00:00',2.49),('16273','2013-05-27','08:05:00',1.4),('16273','2013-05-27','08:10:00',1.34),('16273','2013-05-27','08:15:00',2.26),('16273','2013-05-27','08:20:00',2.32),('16273','2013-05-27','08:25:00',2.35),('16273','2013-05-27','08:30:00',2.09),('16273','2013-05-27','08:35:00',1.86),('16273','2013-05-27','08:40:00',2.8),('16273','2013-05-27','08:45:00',3.05),('16273','2013-05-27','08:50:00',3.33),('16273','2013-05-27','08:55:00',1.17),('16273','2013-05-27','09:00:00',2.74),('16273','2013-05-27','09:05:00',1.87),('16273','2013-05-27','09:15:00',2.25),('16273','2013-05-27','09:20:00',3.46),('16273','2013-05-27','09:25:00',3.44),('16273','2013-05-27','09:30:00',3.54),('16273','2013-05-27','09:35:00',3.77),('16273','2013-05-27','09:40:00',3.28),('16273','2013-05-27','09:45:00',2.33),('16273','2013-05-27','09:50:00',3.49),('16273','2013-05-27','09:55:00',3.67),('16273','2013-05-27','10:00:00',3.73),('16273','2013-05-27','10:05:00',3.78),('16273','2013-05-27','10:10:00',3.86),('16273','2013-05-27','10:15:00',3.94),('16273','2013-05-27','10:20:00',4.04),('16273','2013-05-27','10:25:00',4.09),('16273','2013-05-27','10:30:00',2.63),('16273','2013-05-27','10:35:00',4.25),('16273','2013-05-27','10:40:00',4.43),('16273','2013-05-27','10:45:00',3.64),('16273','2013-05-27','10:50:00',1.89),('16273','2013-05-27','10:55:00',4.59),('16273','2013-05-27','11:00:00',2.56),('16273','2013-05-27','11:05:00',3.98),('16273','2013-05-27','11:10:00',1.68),('16273','2013-05-27','11:15:00',3.8),('16273','2013-05-27','11:20:00',3.13),('16273','2013-05-27','11:25:00',3.5),('16273','2013-05-27','11:30:00',1.93),('16273','2013-05-27','11:35:00',4.37),('16273','2013-05-27','11:40:00',3.49),('16273','2013-05-27','11:45:00',2.96),('16273','2013-05-27','11:50:00',4.61),('16273','2013-05-27','11:55:00',4.57),('16273','2013-05-27','12:00:00',3.14),('16273','2013-05-27','12:05:00',3.77),('16273','2013-05-27','12:10:00',4.64),('16273','2013-05-27','12:15:00',4.54),('16273','2013-05-27','12:20:00',3.23),('16273','2013-05-27','12:25:00',4.59),('16273','2013-05-27','12:30:00',4.5),('16273','2013-05-27','12:35:00',3.99),('16273','2013-05-27','12:40:00',4.45),('16273','2013-05-27','12:45:00',2.73),('16273','2013-05-27','12:50:00',4.51),('16273','2013-05-27','12:55:00',4.62),('16273','2013-05-27','13:00:00',4.09),('16273','2013-05-27','13:05:00',4.29),('16273','2013-05-27','13:10:00',4.1),('16273','2013-05-27','13:15:00',1.92),('16273','2013-05-27','13:20:00',4.19),('16273','2013-05-27','13:25:00',4.23),('16273','2013-05-27','13:30:00',4.03),('16273','2013-05-27','13:35:00',3.93),('16273','2013-05-27','13:40:00',4.25),('16273','2013-05-27','13:45:00',4.17),('16273','2013-05-27','13:50:00',4.16),('16273','2013-05-27','13:55:00',4.06),('16273','2013-05-27','14:00:00',3.94),('16273','2013-05-27','14:05:00',4.01),('16273','2013-05-27','14:10:00',3.94),('16273','2013-05-27','14:15:00',3.94),('16273','2013-05-27','14:20:00',3.92),('16273','2013-05-27','14:25:00',3.88),('16273','2013-05-27','14:30:00',3.89),('16273','2013-05-27','14:35:00',3.87),('16273','2013-05-27','14:40:00',3.83),('16273','2013-05-27','14:45:00',3.77),('16273','2013-05-27','14:50:00',3.63),('16273','2013-05-27','14:55:00',2.95),('16273','2013-05-27','15:00:00',1.76),('16273','2013-05-27','15:05:00',3.55),('16273','2013-05-27','15:10:00',2.92),('16273','2013-05-27','15:15:00',3.06),('16273','2013-05-27','15:20:00',2.88),('16273','2013-05-27','15:25:00',2.98),('16273','2013-05-27','15:30:00',3.53),('16273','2013-05-27','15:35:00',3.23),('16273','2013-05-27','15:40:00',2.61),('16273','2013-05-27','15:45:00',3.09),('16273','2013-05-27','15:50:00',2.76),('16273','2013-05-27','15:55:00',2.01),('16273','2013-05-27','16:00:00',2.43),('16273','2013-05-27','16:05:00',2.22),('16273','2013-05-27','16:10:00',1.91),('16273','2013-05-27','16:15:00',2.62),('16273','2013-05-27','16:20:00',3.11),('16273','2013-05-27','16:25:00',2.72),('16273','2013-05-27','16:30:00',2.54),('16273','2013-05-27','16:35:00',1.53),('16273','2013-05-27','16:40:00',1.13),('16273','2013-05-27','16:45:00',1.15),('16273','2013-05-27','16:50:00',1.26),('16273','2013-05-27','16:55:00',1.3),('16273','2013-05-27','17:00:00',1.33),('16273','2013-05-27','17:05:00',1.56),('16273','2013-05-27','17:10:00',1.48),('16273','2013-05-27','17:15:00',1.25),('16273','2013-05-27','17:20:00',1.14),('16273','2013-05-27','17:25:00',1.1),('16273','2013-05-27','17:30:00',1.05),('16273','2013-05-27','18:20:00',1.27),('16273','2013-05-27','18:25:00',1.1),('16273','2013-05-26','07:35:00',1.66),('16273','2013-05-26','07:40:00',1.95),('16273','2013-05-26','07:45:00',1.42),('16273','2013-05-26','07:55:00',2),('16273','2013-05-26','08:00:00',2.01),('16273','2013-05-26','08:05:00',1.39),('16273','2013-05-26','08:10:00',1.84),('16273','2013-05-26','08:15:00',1.78),('16273','2013-05-26','08:20:00',1.49),('16273','2013-05-26','08:30:00',2.77),('16273','2013-05-26','08:35:00',2.5),('16273','2013-05-26','08:40:00',1.85),('16273','2013-05-26','08:50:00',3.43),('16273','2013-05-26','08:55:00',1.23),('16273','2013-05-26','09:05:00',3.3),('16273','2013-05-26','09:10:00',1.49),('16273','2013-05-26','09:20:00',1.23),('16273','2013-05-26','09:25:00',1.41),('16273','2013-05-26','09:35:00',2.3),('16273','2013-05-26','09:40:00',1.06),('16273','2013-05-26','09:50:00',1.93),('16273','2013-05-26','09:55:00',2.8),('16273','2013-05-26','10:00:00',4.04),('16273','2013-05-26','10:05:00',3.72),('16273','2013-05-26','10:10:00',3.56),('16273','2013-05-26','10:15:00',3.45),('16273','2013-05-26','10:20:00',3.75),('16273','2013-05-26','10:25:00',3.38),('16273','2013-05-26','10:30:00',3.85),('16273','2013-05-26','10:35:00',4.06),('16273','2013-05-26','10:40:00',3.86),('16273','2013-05-26','10:45:00',4.06),('16273','2013-05-26','10:50:00',4.21),('16273','2013-05-26','10:55:00',4.26),('16273','2013-05-26','11:00:00',4.26),('16273','2013-05-26','11:05:00',4.31),('16273','2013-05-26','11:10:00',3.98),('16273','2013-05-26','11:15:00',4.35),('16273','2013-05-26','11:20:00',4.34),('16273','2013-05-26','11:25:00',4.36),('16273','2013-05-26','11:30:00',4.41),('16273','2013-05-26','11:35:00',4.43),('16273','2013-05-26','11:40:00',4.43),('16273','2013-05-26','11:45:00',4.42),('16273','2013-05-26','11:50:00',4.12),('16273','2013-05-26','11:55:00',4.57),('16273','2013-05-26','12:00:00',4.47),('16273','2013-05-26','12:05:00',4.52),('16273','2013-05-26','12:10:00',4.51),('16273','2013-05-26','12:15:00',4.52),('16273','2013-05-26','12:20:00',4.27),('16273','2013-05-26','12:25:00',4.03),('16273','2013-05-26','12:30:00',3.64),('16273','2013-05-26','12:35:00',4.36),('16273','2013-05-26','12:40:00',4.39),('16273','2013-05-26','12:45:00',4.46),('16273','2013-05-26','12:50:00',4.48),('16273','2013-05-26','12:55:00',4.49),('16273','2013-05-26','13:00:00',4.16),('16273','2013-05-26','13:05:00',4.51),('16273','2013-05-26','13:10:00',4.11),('16273','2013-05-26','13:15:00',4.29),('16273','2013-05-26','13:20:00',4.37),('16273','2013-05-26','13:25:00',4.33),('16273','2013-05-26','13:30:00',4.3),('16273','2013-05-26','13:35:00',4.28),('16273','2013-05-26','13:40:00',4.27),('16273','2013-05-26','13:45:00',4.25),('16273','2013-05-26','13:50:00',4.21),('16273','2013-05-26','13:55:00',3.88),('16273','2013-05-26','14:00:00',4.22),('16273','2013-05-26','14:05:00',4.14),('16273','2013-05-26','14:10:00',4.1),('16273','2013-05-26','14:15:00',4.04),('16273','2013-05-26','14:20:00',4.01),('16273','2013-05-26','14:25:00',3.53),('16273','2013-05-26','14:30:00',3.95),('16273','2013-05-26','14:35:00',3.93),('16273','2013-05-26','14:40:00',3.88),('16273','2013-05-26','14:45:00',3.8),('16273','2013-05-26','14:50:00',3.74),('16273','2013-05-26','14:55:00',3.71),('16273','2013-05-26','15:00:00',3.69),('16273','2013-05-26','15:05:00',3.64),('16273','2013-05-26','15:10:00',3.58),('16273','2013-05-26','15:15:00',3.52),('16273','2013-05-26','15:20:00',3.47),('16273','2013-05-26','15:25:00',3.41),('16273','2013-05-26','15:30:00',3.33),('16273','2013-05-26','15:35:00',3.28),('16273','2013-05-26','15:40:00',3.23),('16273','2013-05-26','15:45:00',3.15),('16273','2013-05-26','15:50:00',3.09),('16273','2013-05-26','15:55:00',3.02),('16273','2013-05-26','16:00:00',2.95),('16273','2013-05-26','16:05:00',2.89),('16273','2013-05-26','16:10:00',2.83),('16273','2013-05-26','16:15:00',2.74),('16273','2013-05-26','16:20:00',2.67),('16273','2013-05-26','16:25:00',2.6),('16273','2013-05-26','16:30:00',2.52),('16273','2013-05-26','16:35:00',2.45),('16273','2013-05-26','16:40:00',2.37),('16273','2013-05-26','16:45:00',2.28),('16273','2013-05-26','16:50:00',2.21),('16273','2013-05-26','16:55:00',2.13),('16273','2013-05-26','17:00:00',2.05),('16273','2013-05-26','17:05:00',1.95),('16273','2013-05-26','17:10:00',1.86),('16273','2013-05-26','17:15:00',1.78),('16273','2013-05-26','17:20:00',1.7),('16273','2013-05-26','17:25:00',1.61),('16273','2013-05-26','17:30:00',1.5),('16273','2013-05-26','17:35:00',1.44),('16273','2013-05-26','17:40:00',1.35),('16273','2013-05-26','17:45:00',1.27),('16273','2013-05-26','17:50:00',1.19),('16273','2013-05-26','17:55:00',1.11),('16273','2013-05-26','18:00:00',1.02),('16273','2013-05-25','07:15:00',1.27),('16273','2013-05-25','07:20:00',1.5),('16273','2013-05-25','07:25:00',1.63),('16273','2013-05-25','07:30:00',1.26),('16273','2013-05-25','07:40:00',2.02),('16273','2013-05-25','07:45:00',1.64),('16273','2013-05-25','07:50:00',1.4),('16273','2013-05-25','08:10:00',2.08),('16273','2013-05-25','08:15:00',2.67),('16273','2013-05-25','08:20:00',1.72),('16273','2013-05-25','08:30:00',2.34),('16273','2013-05-25','08:35:00',2.09),('16273','2013-05-25','08:40:00',1.3),('16273','2013-05-25','08:45:00',2.72),('16273','2013-05-25','08:50:00',3.26),('16273','2013-05-25','08:55:00',3.31),('16273','2013-05-25','09:00:00',2.5),('16273','2013-05-25','09:05:00',1.91),('16273','2013-05-25','09:10:00',1.08),('16273','2013-05-25','09:15:00',1.84),('16273','2013-05-25','09:20:00',3.45),('16273','2013-05-25','09:25:00',2.53),('16273','2013-05-25','09:30:00',1.75),('16273','2013-05-25','09:35:00',3.8),('16273','2013-05-25','09:40:00',3.2),('16273','2013-05-25','09:45:00',3.28),('16273','2013-05-25','09:50:00',1.26),('16273','2013-05-25','10:00:00',1.14),('16273','2013-05-25','10:05:00',1.5),('16273','2013-05-25','10:30:00',1.47),('16273','2013-05-25','10:45:00',1.03),('16273','2013-05-25','10:50:00',1.05),('16273','2013-05-25','10:55:00',2.01),('16273','2013-05-25','11:00:00',3.08),('16273','2013-05-25','11:05:00',1.27),('16273','2013-05-25','11:10:00',2.41),('16273','2013-05-25','11:25:00',1.79),('16273','2013-05-25','11:30:00',1.04),('16273','2013-05-25','11:35:00',2.11),('16273','2013-05-25','11:40:00',2.55),('16273','2013-05-25','11:45:00',1.75),('16273','2013-05-25','11:50:00',2.19),('16273','2013-05-25','11:55:00',3.46),('16273','2013-05-25','12:00:00',4.16),('16273','2013-05-25','12:05:00',1.35),('16273','2013-05-25','12:10:00',1.86),('16273','2013-05-25','12:15:00',2.85),('16273','2013-05-25','12:20:00',1.5),('16273','2013-05-25','12:25:00',1.73),('16273','2013-05-25','12:30:00',1.15),('16273','2013-05-25','12:40:00',1.27),('16273','2013-05-25','12:45:00',1.62),('16273','2013-05-25','12:50:00',2.42),('16273','2013-05-25','12:55:00',4.09),('16273','2013-05-25','13:00:00',2.5),('16273','2013-05-25','13:05:00',1.94),('16273','2013-05-25','13:10:00',2.17),('16273','2013-05-25','13:15:00',2.25),('16273','2013-05-25','13:20:00',2.05),('16273','2013-05-25','13:25:00',2.33),('16273','2013-05-25','13:30:00',2.03),('16273','2013-05-25','13:35:00',3.16),('16273','2013-05-25','13:40:00',2.03),('16273','2013-05-25','13:45:00',2.11),('16273','2013-05-25','13:50:00',3),('16273','2013-05-25','13:55:00',4.42),('16273','2013-05-25','14:00:00',3.79),('16273','2013-05-25','14:05:00',4.5),('16273','2013-05-25','14:10:00',4.07),('16273','2013-05-25','14:15:00',4.57),('16273','2013-05-25','14:20:00',4.19),('16273','2013-05-25','14:25:00',2.64),('16273','2013-05-25','14:30:00',2.72),('16273','2013-05-25','14:35:00',3.91),('16273','2013-05-25','14:40:00',4.27),('16273','2013-05-25','14:45:00',3.68),('16273','2013-05-25','14:50:00',3.55),('16273','2013-05-25','14:55:00',2.82),('16273','2013-05-25','15:00:00',3.61),('16273','2013-05-25','15:05:00',2.81),('16273','2013-05-25','15:10:00',1.55),('16273','2013-05-25','15:15:00',1.44),('16273','2013-05-25','15:20:00',1.14),('16273','2013-05-25','15:25:00',2.03),('16273','2013-05-25','15:30:00',3.42),('16273','2013-05-25','15:35:00',1.82),('16273','2013-05-25','15:40:00',2.92),('16273','2013-05-25','15:45:00',2.61),('16273','2013-05-25','15:50:00',1.67),('16273','2013-05-25','15:55:00',1.29),('16273','2013-05-25','16:00:00',3.14),('16273','2013-05-25','16:05:00',2.23),('16273','2013-05-25','16:10:00',2.02),('16273','2013-05-25','16:15:00',1.62),('16273','2013-05-25','16:20:00',1.16),('16273','2013-05-25','16:25:00',1.24),('16273','2013-05-25','16:30:00',3.02),('16273','2013-05-25','16:35:00',3.05),('16273','2013-05-25','16:40:00',2.85),('16273','2013-05-25','16:45:00',2.44),('16273','2013-05-25','16:50:00',2.43),('16273','2013-05-25','16:55:00',2.16),('16273','2013-05-25','17:00:00',2.36),('16273','2013-05-25','17:05:00',2.23),('16273','2013-05-25','17:10:00',2.08),('16273','2013-05-25','17:15:00',1.96),('16273','2013-05-25','17:20:00',1.72),('16273','2013-05-25','17:25:00',1.32),('16273','2013-05-25','17:30:00',2.11),('16273','2013-05-25','17:35:00',1.65),('16273','2013-05-25','17:40:00',1.82),('16273','2013-05-25','17:45:00',1.66),('16273','2013-05-25','17:50:00',1.58),('16273','2013-05-25','17:55:00',1.28),('16273','2013-05-24','07:55:00',1.34),('16273','2013-05-24','08:00:00',1.61),('16273','2013-05-24','08:05:00',1.08),('16273','2013-05-24','08:10:00',1.44),('16273','2013-05-24','08:20:00',2.21),('16273','2013-05-24','08:25:00',2.46),('16273','2013-05-24','08:30:00',2.54),('16273','2013-05-24','08:35:00',2.58),('16273','2013-05-24','08:40:00',2.65),('16273','2013-05-24','08:45:00',2.78),('16273','2013-05-24','08:50:00',2.85),('16273','2013-05-24','08:55:00',3.1),('16273','2013-05-24','09:00:00',2.35),('16273','2013-05-24','09:10:00',2.38),('16273','2013-05-24','09:20:00',1.94),('16273','2013-05-24','09:25:00',1.98),('16273','2013-05-24','09:35:00',1.6),('16273','2013-05-24','09:45:00',1.15),('16273','2013-05-24','09:50:00',3.03),('16273','2013-05-24','09:55:00',3.24),('16273','2013-05-24','10:20:00',1.73),('16273','2013-05-24','10:25:00',4.37),('16273','2013-05-24','10:30:00',4.19),('16273','2013-05-24','10:35:00',3.74),('16273','2013-05-24','10:40:00',4.25),('16273','2013-05-24','10:45:00',4.26),('16273','2013-05-24','10:50:00',2.46),('16273','2013-05-24','10:55:00',3.98),('16273','2013-05-24','11:00:00',3.89),('16273','2013-05-24','11:05:00',4.13),('16273','2013-05-24','11:10:00',2.26),('16273','2013-05-24','11:15:00',4.47),('16273','2013-05-24','11:20:00',4.72),('16273','2013-05-24','11:25:00',3.24),('16273','2013-05-24','11:30:00',1.51),('16273','2013-05-24','11:40:00',1.61),('16273','2013-05-24','11:45:00',3.97),('16273','2013-05-24','11:50:00',1.98),('16273','2013-05-24','11:55:00',2.8),('16273','2013-05-24','12:00:00',3.13),('16273','2013-05-24','12:05:00',3.12),('16273','2013-05-24','12:10:00',2.15),('16273','2013-05-24','12:15:00',1.83),('16273','2013-05-24','12:20:00',2.36),('16273','2013-05-24','12:25:00',3.1),('16273','2013-05-24','12:30:00',2.68),('16273','2013-05-24','12:35:00',2.36),('16273','2013-05-24','12:40:00',2.44),('16273','2013-05-24','12:45:00',2.43),('16273','2013-05-24','12:50:00',2.47),('16273','2013-05-24','12:55:00',2.23),('16273','2013-05-24','13:00:00',4.08),('16273','2013-05-24','13:05:00',4.5),('16273','2013-05-24','13:10:00',3.5),('16273','2013-05-24','13:15:00',3.54),('16273','2013-05-24','13:20:00',3.92),('16273','2013-05-24','13:25:00',4.36),('16273','2013-05-24','13:30:00',3.11),('16273','2013-05-24','13:35:00',1.74),('16273','2013-05-24','13:40:00',1.08),('16273','2013-05-24','13:45:00',1.37),('16273','2013-05-24','13:50:00',3.6),('16273','2013-05-24','13:55:00',3.59),('16273','2013-05-24','14:00:00',2.18),('16273','2013-05-24','14:05:00',3.94),('16273','2013-05-24','14:10:00',1.93),('16273','2013-05-24','14:15:00',3.1),('16273','2013-05-24','14:20:00',3.55),('16273','2013-05-24','14:25:00',4.58),('16273','2013-05-24','14:30:00',4.49),('16273','2013-05-24','14:35:00',4.37),('16273','2013-05-24','14:40:00',3.57),('16273','2013-05-24','14:45:00',1.93),('16273','2013-05-24','14:50:00',1.96),('16273','2013-05-24','14:55:00',3.39),('16273','2013-05-24','15:00:00',3.47),('16273','2013-05-24','15:05:00',2.7),('16273','2013-05-24','15:10:00',2.78),('16273','2013-05-24','15:15:00',3.93),('16273','2013-05-24','15:20:00',3.96),('16273','2013-05-24','15:25:00',1.99),('16273','2013-05-24','15:30:00',1.53),('16273','2013-05-24','15:35:00',2.05),('16273','2013-05-24','15:40:00',2.32),('16273','2013-05-24','15:45:00',1.8),('16273','2013-05-24','15:50:00',1.69),('16273','2013-05-24','15:55:00',1.79),('16273','2013-05-24','16:00:00',1.76),('16273','2013-05-24','16:05:00',1.56),('16273','2013-05-24','16:10:00',1.22),('16273','2013-05-24','16:15:00',1.05),('16273','2013-05-24','16:20:00',1.21),('16273','2013-05-24','16:25:00',1.06),('16273','2013-05-24','16:40:00',1.01),('16273','2013-05-24','16:45:00',1.23),('16273','2013-05-24','16:50:00',1.19),('16273','2013-05-24','16:55:00',1.16),('16273','2013-05-24','17:00:00',1.03),('16273','2013-05-24','17:15:00',1.07),('16273','2013-05-24','17:20:00',1.03),('16273','2013-05-24','17:25:00',1.01),('16273','2013-05-23','07:40:00',1.02),('16273','2013-05-23','07:45:00',1.1),('16273','2013-05-23','08:15:00',1.51),('16273','2013-05-23','08:20:00',2.22),('16273','2013-05-23','08:25:00',2.21),('16273','2013-05-23','08:30:00',2.73),('16273','2013-05-23','08:35:00',2.3),('16273','2013-05-23','08:40:00',1.16),('16273','2013-05-23','09:05:00',1.72),('16273','2013-05-23','09:10:00',3.34),('16273','2013-05-23','09:15:00',3.51),('16273','2013-05-23','09:20:00',2.57),('16273','2013-05-23','09:25:00',1.52),('16273','2013-05-23','09:35:00',2.02),('16273','2013-05-23','09:40:00',1.59),('16273','2013-05-23','09:45:00',1.01),('16273','2013-05-23','09:50:00',2.11),('16273','2013-05-23','09:55:00',4.46),('16273','2013-05-23','10:00:00',1.64),('16273','2013-05-23','10:05:00',1.42),('16273','2013-05-23','10:10:00',1.45),('16273','2013-05-23','10:15:00',3.64),('16273','2013-05-23','10:20:00',1.35),('16273','2013-05-23','10:25:00',1.83),('16273','2013-05-23','10:30:00',2.54),('16273','2013-05-23','10:35:00',3.27),('16273','2013-05-23','10:40:00',2),('16273','2013-05-23','10:45:00',2.09),('16273','2013-05-23','10:50:00',1.52),('16273','2013-05-23','10:55:00',2.39),('16273','2013-05-23','11:00:00',4.08),('16273','2013-05-23','11:05:00',1.62),('16273','2013-05-23','11:10:00',1.94),('16273','2013-05-23','11:15:00',1.97),('16273','2013-05-23','11:20:00',1.85),('16273','2013-05-23','11:25:00',4.38),('16273','2013-05-23','11:30:00',4.72),('16273','2013-05-23','11:35:00',2.61),('16273','2013-05-23','11:40:00',3.44),('16273','2013-05-23','11:45:00',3.6),('16273','2013-05-23','11:50:00',4.09),('16273','2013-05-23','11:55:00',2.65),('16273','2013-05-23','12:00:00',2.87),('16273','2013-05-23','12:05:00',2.44),('16273','2013-05-23','12:10:00',3.65),('16273','2013-05-23','12:15:00',3.52),('16273','2013-05-23','12:20:00',3.38),('16273','2013-05-23','12:25:00',2.02),('16273','2013-05-23','12:30:00',1.54),('16273','2013-05-23','12:35:00',3.94),('16273','2013-05-23','12:40:00',4.74),('16273','2013-05-23','12:45:00',2.12),('16273','2013-05-23','12:50:00',3.49),('16273','2013-05-23','12:55:00',2.89),('16273','2013-05-23','13:00:00',4.49),('16273','2013-05-23','13:05:00',3.31),('16273','2013-05-23','13:10:00',4.27),('16273','2013-05-23','13:15:00',3.74),('16273','2013-05-23','13:20:00',2.09),('16273','2013-05-23','13:25:00',2.17),('16273','2013-05-23','13:30:00',3.08),('16273','2013-05-23','13:35:00',2.39),('16273','2013-05-23','13:40:00',3.65),('16273','2013-05-23','13:45:00',2.85),('16273','2013-05-23','13:50:00',4.03),('16273','2013-05-23','13:55:00',4.09),('16273','2013-05-23','14:00:00',3.89),('16273','2013-05-23','14:05:00',2.82),('16273','2013-05-23','14:10:00',3.87),('16273','2013-05-23','14:15:00',3.69),('16273','2013-05-23','14:20:00',2.89),('16273','2013-05-23','14:25:00',4.45),('16273','2013-05-23','14:30:00',4.17),('16273','2013-05-23','14:35:00',2.76),('16273','2013-05-23','14:40:00',1.25),('16273','2013-05-23','14:45:00',2.72),('16273','2013-05-23','14:50:00',2.73),('16273','2013-05-23','14:55:00',2.58),('16273','2013-05-23','15:00:00',2.47),('16273','2013-05-23','15:05:00',2.6),('16273','2013-05-23','15:10:00',2.41),('16273','2013-05-23','15:15:00',2.73),('16273','2013-05-23','15:20:00',2.55),('16273','2013-05-23','15:25:00',2.41),('16273','2013-05-23','15:30:00',1.79),('16273','2013-05-23','15:35:00',1.27),('16273','2013-05-23','15:40:00',1.65),('16273','2013-05-23','15:45:00',3.73),('16273','2013-05-23','15:50:00',2.92),('16273','2013-05-23','15:55:00',2.85),('16273','2013-05-23','16:00:00',2.92),('16273','2013-05-23','16:05:00',2.54),('16273','2013-05-23','16:10:00',2.63),('16273','2013-05-23','16:15:00',2.04),('16273','2013-05-23','16:20:00',2.27),('16273','2013-05-23','16:25:00',1.58),('16273','2013-05-23','16:30:00',1.54),('16273','2013-05-23','16:35:00',2.36),('16273','2013-05-23','16:40:00',1.21),('16273','2013-05-23','16:50:00',1.37),('16273','2013-05-23','16:55:00',1.42),('16273','2013-05-23','17:00:00',1.72),('16273','2013-05-23','17:05:00',1.72),('16273','2013-05-23','17:10:00',1.12),('16273','2013-05-23','17:45:00',1.52),('16273','2013-05-23','17:50:00',1.64),('16273','2013-05-23','17:55:00',1.36),('16273','2013-05-22','08:00:00',1.2),('16273','2013-05-22','08:05:00',1.92),('16273','2013-05-22','08:10:00',1.83),('16273','2013-05-22','08:15:00',1.07),('16273','2013-05-22','08:20:00',1.2),('16273','2013-05-22','08:25:00',2.03),('16273','2013-05-22','08:30:00',1.75),('16273','2013-05-22','09:20:00',1.19),('16273','2013-05-22','09:25:00',2.06),('16273','2013-05-22','09:30:00',3.17),('16273','2013-05-22','09:35:00',3.19),('16273','2013-05-22','09:40:00',3.22),('16273','2013-05-22','09:45:00',3.24),('16273','2013-05-22','09:50:00',3.29),('16273','2013-05-22','09:55:00',3.36),('16273','2013-05-22','10:00:00',3.41),('16273','2013-05-22','10:05:00',3.43),('16273','2013-05-22','10:10:00',3.42),('16273','2013-05-22','10:15:00',3.47),('16273','2013-05-22','10:20:00',3.61),('16273','2013-05-22','10:25:00',3.62),('16273','2013-05-22','10:30:00',3.59),('16273','2013-05-22','10:35:00',3.05),('16273','2013-05-22','10:40:00',3.01),('16273','2013-05-22','10:45:00',3.93),('16273','2013-05-22','10:50:00',3.8),('16273','2013-05-22','10:55:00',3.81),('16273','2013-05-22','11:00:00',3.84),('16273','2013-05-22','11:05:00',3.86),('16273','2013-05-22','11:10:00',3.85),('16273','2013-05-22','11:15:00',3.86),('16273','2013-05-22','11:20:00',3.92),('16273','2013-05-22','11:25:00',4.02),('16273','2013-05-22','11:30:00',3.69),('16273','2013-05-22','11:35:00',3.86),('16273','2013-05-22','11:40:00',2.69),('16273','2013-05-22','11:45:00',3.35),('16273','2013-05-22','11:50:00',2.77),('16273','2013-05-22','11:55:00',3.18),('16273','2013-05-22','12:00:00',2.19),('16273','2013-05-22','12:05:00',2.43),('16273','2013-05-22','12:30:00',1.91),('16273','2013-05-22','12:35:00',1.44),('16273','2013-05-22','12:40:00',1.19),('16273','2013-05-22','13:05:00',1.42),('16273','2013-05-22','13:10:00',1.51),('16273','2013-05-22','13:15:00',2.36),('16273','2013-05-22','13:20:00',2.11),('16273','2013-05-22','13:25:00',1.21),('16273','2013-05-22','13:30:00',2.25),('16273','2013-05-22','13:35:00',2.98),('16273','2013-05-22','13:40:00',3.5),('16273','2013-05-22','13:45:00',3.09),('16273','2013-05-22','13:50:00',2.4),('16273','2013-05-22','13:55:00',3.35),('16273','2013-05-22','14:00:00',2.86),('16273','2013-05-22','14:05:00',4.04),('16273','2013-05-22','14:10:00',3.85),('16273','2013-05-22','14:15:00',3.75),('16273','2013-05-22','14:20:00',3.71),('16273','2013-05-22','14:25:00',3.66),('16273','2013-05-22','14:30:00',3.63),('16273','2013-05-22','14:35:00',3.58),('16273','2013-05-22','14:40:00',3.52),('16273','2013-05-22','14:45:00',3.48),('16273','2013-05-22','14:50:00',3.4),('16273','2013-05-22','14:55:00',3.38),('16273','2013-05-22','15:00:00',3.16),('16273','2013-05-22','15:05:00',3.26),('16273','2013-05-22','15:10:00',2.71),('16273','2013-05-22','15:15:00',3.21),('16273','2013-05-22','15:20:00',3.14),('16273','2013-05-22','15:25:00',3.14),('16273','2013-05-22','15:30:00',2.9),('16273','2013-05-22','15:35:00',3),('16273','2013-05-22','15:40:00',2.85),('16273','2013-05-22','15:45:00',2.8),('16273','2013-05-22','15:50:00',2.78),('16273','2013-05-22','15:55:00',2.69),('16273','2013-05-22','16:00:00',2.63),('16273','2013-05-22','16:05:00',2.56),('16273','2013-05-22','16:10:00',2.51),('16273','2013-05-22','16:15:00',2.53),('16273','2013-05-22','16:20:00',2.43),('16273','2013-05-22','16:25:00',2.13),('16273','2013-05-22','16:30:00',1.97),('16273','2013-05-22','16:35:00',1.83),('16273','2013-05-22','16:40:00',1.45),('16273','2013-05-22','16:45:00',1.1),('16273','2013-05-22','16:50:00',1.08),('16273','2013-05-22','17:20:00',1.48),('16273','2013-05-22','17:25:00',1.1),('16273','2013-05-22','17:30:00',1.2),('16273','2013-05-22','17:35:00',1.52),('16273','2013-05-22','17:40:00',1.61),('16273','2013-05-22','18:00:00',1.13),('16273','2013-05-22','18:40:00',1.11),('16273','2014-04-01','08:10:00',1.21),('16273','2014-04-01','08:15:00',1.16),('16273','2014-04-01','08:20:00',1.38),('16273','2014-04-01','08:25:00',1.55),('16273','2014-04-01','08:30:00',1.65),('16273','2014-04-01','08:35:00',1.76),('16273','2014-04-01','08:40:00',1.84),('16273','2014-04-01','08:45:00',1.92),('16273','2014-04-01','08:50:00',1.97),('16273','2014-04-01','08:55:00',2.07),('16273','2014-04-01','09:00:00',2.15),('16273','2014-04-01','09:05:00',2.23),('16273','2014-04-01','09:10:00',2.3),('16273','2014-04-01','09:15:00',2.38),('16273','2014-04-01','09:20:00',2.41),('16273','2014-04-01','09:25:00',2.45),('16273','2014-04-01','09:30:00',2.49),('16273','2014-04-01','09:35:00',2.66),('16273','2014-04-01','09:40:00',2.77),('16273','2014-04-01','09:45:00',2.82),('16273','2014-04-01','09:50:00',2.89),('16273','2014-04-01','09:55:00',2.95),('16273','2014-04-01','10:00:00',3.03),('16273','2014-04-01','10:05:00',3.05),('16273','2014-04-01','10:10:00',3.13),('16273','2014-04-01','10:15:00',3.17),('16273','2014-04-01','10:20:00',3.21),('16273','2014-04-01','10:25:00',3.1),('16273','2014-04-01','10:30:00',3.31),('16273','2014-04-01','10:35:00',3.38),('16273','2014-04-01','10:40:00',3.24),('16273','2014-04-01','10:45:00',3.26),('16273','2014-04-01','10:50:00',3.16),('16273','2014-04-01','10:55:00',3.5),('16273','2014-04-01','11:00:00',3.5),('16273','2014-04-01','11:05:00',3.43),('16273','2014-04-01','11:10:00',3.57),('16273','2014-04-01','11:15:00',3.63),('16273','2014-04-01','11:20:00',3.65),('16273','2014-04-01','11:25:00',3.62),('16273','2014-04-01','11:30:00',3.67),('16273','2014-04-01','11:35:00',3.69),('16273','2014-04-01','11:40:00',3.76),('16273','2014-04-01','11:45:00',3.77),('16273','2014-04-01','11:50:00',3.78),('16273','2014-04-01','11:55:00',3.8),('16273','2014-04-01','12:00:00',3.84),('16273','2014-04-01','12:05:00',3.84),('16273','2014-04-01','12:10:00',3.87),('16273','2014-04-01','12:15:00',3.88),('16273','2014-04-01','12:20:00',3.92),('16273','2014-04-01','12:25:00',3.91),('16273','2014-04-01','12:30:00',3.95),('16273','2014-04-01','12:35:00',4.05),('16273','2014-04-01','12:40:00',3.99),('16273','2014-04-01','12:45:00',3.94),('16273','2014-04-01','12:50:00',4.03),('16273','2014-04-01','12:55:00',3.96),('16273','2014-04-01','13:00:00',3.93),('16273','2014-04-01','13:05:00',3.84),('16273','2014-04-01','13:10:00',3.82),('16273','2014-04-01','13:15:00',3.82),('16273','2014-04-01','13:20:00',3.88),('16273','2014-04-01','13:25:00',3.86),('16273','2014-04-01','13:30:00',3.93),('16273','2014-04-01','13:35:00',3.99),('16273','2014-04-01','13:40:00',3.96),('16273','2014-04-01','13:45:00',3.55),('16273','2014-04-01','13:50:00',3.27),('16273','2014-04-01','13:55:00',3.85),('16273','2014-04-01','14:00:00',3.72),('16273','2014-04-01','14:05:00',3.4),('16273','2014-04-01','14:10:00',3.44),('16273','2014-04-01','14:15:00',3.59),('16273','2014-04-01','14:20:00',3.63),('16273','2014-04-01','14:25:00',3.18),('16273','2014-04-01','14:30:00',3.12),('16273','2014-04-01','14:35:00',3.24),('16273','2014-04-01','14:40:00',3.51),('16273','2014-04-01','14:45:00',3.48),('16273','2014-04-01','14:50:00',3.25),('16273','2014-04-01','14:55:00',2.36),('16273','2014-04-01','15:00:00',2.6),('16273','2014-04-01','15:05:00',3.07),('16273','2014-04-01','15:10:00',3.16),('16273','2014-04-01','15:15:00',2.55),('16273','2014-04-01','15:20:00',3.1),('16273','2014-04-01','15:25:00',2.98),('16273','2014-04-01','15:30:00',2.81),('16273','2014-04-01','15:35:00',2.93),('16273','2014-04-01','15:40:00',2.29),('16273','2014-04-01','15:45:00',2.87),('16273','2014-04-01','15:50:00',2.74),('16273','2014-04-01','15:55:00',2.34),('16273','2014-04-01','16:00:00',1.86),('16273','2014-04-01','16:05:00',2.3),('16273','2014-04-01','16:10:00',1.69),('16273','2014-04-01','16:15:00',1.67),('16273','2014-04-01','16:20:00',2.05),('16273','2014-04-01','16:25:00',2.23),('16273','2014-04-01','16:30:00',1.64),('16273','2014-04-01','16:35:00',1.67),('16273','2014-04-01','16:40:00',1.81),('16273','2014-04-01','16:45:00',1.7),('16273','2014-04-01','16:50:00',1.58),('16273','2014-04-01','16:55:00',1.62),('16273','2014-04-01','17:00:00',1.53),('16273','2014-04-01','17:05:00',1.42),('16273','2014-04-01','17:10:00',1.34),('16273','2014-04-01','17:15:00',1.29),('16273','2014-04-01','17:20:00',1.17),('16273','2014-04-01','17:25:00',1.1),('16273','2014-04-01','17:30:00',1.04),('16273','2013-05-21','07:15:00',1.09),('16273','2013-05-21','07:20:00',1.18),('16273','2013-05-21','07:25:00',1.31),('16273','2013-05-21','07:30:00',1.53),('16273','2013-05-21','07:35:00',1.84),('16273','2013-05-21','07:40:00',1.71),('16273','2013-05-21','07:45:00',1.3),('16273','2013-05-21','07:50:00',1.35),('16273','2013-05-21','08:00:00',1.17),('16273','2013-05-21','08:05:00',2.14),('16273','2013-05-21','08:10:00',2.28),('16273','2013-05-21','08:15:00',1.57),('16273','2013-05-21','08:20:00',1.84),('16273','2013-05-21','08:25:00',1.34),('16273','2013-05-21','08:30:00',1.28),('16273','2013-05-21','08:35:00',1.62),('16273','2013-05-21','08:40:00',1.43),('16273','2013-05-21','08:45:00',1.23),('16273','2013-05-21','08:50:00',1.34),('16273','2013-05-21','08:55:00',1.37),('16273','2013-05-21','09:00:00',1.3),('16273','2013-05-21','09:05:00',1.39),('16273','2013-05-21','09:10:00',1.79),('16273','2013-05-21','09:15:00',1.84),('16273','2013-05-21','09:20:00',2.38),('16273','2013-05-21','09:25:00',1.91),('16273','2013-05-21','09:30:00',1.7),('16273','2013-05-21','09:35:00',1.87),('16273','2013-05-21','09:40:00',1.61),('16273','2013-05-21','09:45:00',1.64),('16273','2013-05-21','09:50:00',1.73),('16273','2013-05-21','09:55:00',2.13),('16273','2013-05-21','10:00:00',1.91),('16273','2013-05-21','10:05:00',1.97),('16273','2013-05-21','10:10:00',1.94),('16273','2013-05-21','10:15:00',1.68),('16273','2013-05-21','10:20:00',2.05),('16273','2013-05-21','10:25:00',2.28),('16273','2013-05-21','10:30:00',1.67),('16273','2013-05-21','10:35:00',1.99),('16273','2013-05-21','10:40:00',2.85),('16273','2013-05-21','10:45:00',2.63),('16273','2013-05-21','10:50:00',1.98),('16273','2013-05-21','10:55:00',1.73),('16273','2013-05-21','11:00:00',1.63),('16273','2013-05-21','11:05:00',2.56),('16273','2013-05-21','11:10:00',2.56),('16273','2013-05-21','11:15:00',2.52),('16273','2013-05-21','11:20:00',4.06),('16273','2013-05-21','11:25:00',2.89),('16273','2013-05-21','11:30:00',2.96),('16273','2013-05-21','11:35:00',2.18),('16273','2013-05-21','11:40:00',2.44),('16273','2013-05-21','11:45:00',2.59),('16273','2013-05-21','11:50:00',2.65),('16273','2013-05-21','11:55:00',2.3),('16273','2013-05-21','12:00:00',2.87),('16273','2013-05-21','12:05:00',3.5),('16273','2013-05-21','12:10:00',3.45),('16273','2013-05-21','12:15:00',2.72),('16273','2013-05-21','12:20:00',2.24),('16273','2013-05-21','12:25:00',2.86),('16273','2013-05-21','12:30:00',2.43),('16273','2013-05-21','12:35:00',2.19),('16273','2013-05-21','12:40:00',2.63),('16273','2013-05-21','12:45:00',2.91),('16273','2013-05-21','12:50:00',2.72),('16273','2013-05-21','12:55:00',2.72),('16273','2013-05-21','13:00:00',3.21),('16273','2013-05-21','13:05:00',2.44),('16273','2013-05-21','13:10:00',2.65),('16273','2013-05-21','13:15:00',3.22),('16273','2013-05-21','13:20:00',2.79),('16273','2013-05-21','13:25:00',2.3),('16273','2013-05-21','13:30:00',1.52),('16273','2013-05-21','13:35:00',1.11),('16273','2013-05-21','14:05:00',1.17),('16273','2013-05-21','14:10:00',2.22),('16273','2013-05-21','14:15:00',1.85),('16273','2013-05-21','14:20:00',2.72),('16273','2013-05-21','14:25:00',4.02),('16273','2013-05-21','14:30:00',3.49),('16273','2013-05-21','14:35:00',2.12),('16273','2013-05-21','14:40:00',1.59),('16273','2013-05-21','15:15:00',1.36),('16273','2013-05-21','15:20:00',1.59),('16273','2013-05-21','15:25:00',2.15),('16273','2013-05-21','15:30:00',2.55),('16273','2013-05-21','15:35:00',2.74),('16273','2013-05-21','15:40:00',2.06),('16273','2013-05-21','15:45:00',1.46),('16273','2013-05-21','16:05:00',1.23),('16273','2013-05-21','16:25:00',1.14),('16273','2013-05-21','16:30:00',1.53),('16273','2013-05-21','16:35:00',1.44),('16273','2013-05-21','16:40:00',1.17),('16273','2013-05-21','16:45:00',1),('16273','2013-05-20','07:15:00',1.29),('16273','2013-05-20','07:25:00',1.39),('16273','2013-05-20','07:35:00',1.34),('16273','2013-05-20','07:40:00',1.31),('16273','2013-05-20','07:45:00',1.75),('16273','2013-05-20','07:50:00',1.71),('16273','2013-05-20','07:55:00',2.11),('16273','2013-05-20','08:00:00',2.19),('16273','2013-05-20','08:05:00',2.16),('16273','2013-05-20','08:10:00',2.55),('16273','2013-05-20','08:15:00',2.38),('16273','2013-05-20','08:20:00',2.65),('16273','2013-05-20','08:25:00',2.84),('16273','2013-05-20','08:30:00',1.55),('16273','2013-05-20','08:35:00',1.56),('16273','2013-05-20','08:55:00',1.78),('16273','2013-05-20','09:00:00',2.98),('16273','2013-05-20','09:05:00',1.41),('16273','2013-05-20','09:15:00',3.09),('16273','2013-05-20','09:20:00',3.45),('16273','2013-05-20','09:25:00',3.25),('16273','2013-05-20','09:30:00',3.26),('16273','2013-05-20','09:35:00',3.69),('16273','2013-05-20','09:40:00',3.84),('16273','2013-05-20','09:45:00',3.41),('16273','2013-05-20','09:50:00',3.92),('16273','2013-05-20','09:55:00',3.79),('16273','2013-05-20','10:00:00',2.03),('16273','2013-05-20','10:05:00',2.71),('16273','2013-05-20','10:10:00',3.7),('16273','2013-05-20','10:15:00',1.43),('16273','2013-05-20','10:20:00',3.51),('16273','2013-05-20','10:25:00',3.01),('16273','2013-05-20','10:30:00',4.12),('16273','2013-05-20','10:35:00',4.2),('16273','2013-05-20','10:40:00',3.57),('16273','2013-05-20','10:45:00',2.93),('16273','2013-05-20','10:50:00',4.02),('16273','2013-05-20','10:55:00',3.54),('16273','2013-05-20','11:00:00',2.67),('16273','2013-05-20','11:05:00',3.65),('16273','2013-05-20','11:10:00',4.39),('16273','2013-05-20','11:15:00',4.01),('16273','2013-05-20','11:20:00',4.4),('16273','2013-05-20','11:25:00',4),('16273','2013-05-20','11:30:00',4.5),('16273','2013-05-20','11:35:00',4.55),('16273','2013-05-20','11:40:00',3.64),('16273','2013-05-20','11:45:00',3.43),('16273','2013-05-20','11:50:00',3.99),('16273','2013-05-20','11:55:00',4.34),('16273','2013-05-20','12:00:00',4.32),('16273','2013-05-20','12:05:00',4.38),('16273','2013-05-20','12:10:00',4.39),('16273','2013-05-20','12:15:00',3.53),('16273','2013-05-20','12:20:00',4.36),('16273','2013-05-20','12:25:00',4.34),('16273','2013-05-20','12:30:00',4.32),('16273','2013-05-20','12:35:00',4.33),('16273','2013-05-20','12:40:00',4.33),('16273','2013-05-20','12:45:00',4.3),('16273','2013-05-20','12:50:00',4.28),('16273','2013-05-20','12:55:00',4.29),('16273','2013-05-20','13:00:00',4.29),('16273','2013-05-20','13:05:00',4.27),('16273','2013-05-20','13:10:00',4.22),('16273','2013-05-20','13:15:00',4.24),('16273','2013-05-20','13:20:00',4.21),('16273','2013-05-20','13:25:00',4.15),('16273','2013-05-20','13:30:00',4.13),('16273','2013-05-20','13:35:00',4.1),('16273','2013-05-20','13:40:00',4.12),('16273','2013-05-20','13:45:00',4.11),('16273','2013-05-20','13:50:00',4.03),('16273','2013-05-20','13:55:00',4.04),('16273','2013-05-20','14:00:00',4.07),('16273','2013-05-20','14:05:00',4.04),('16273','2013-05-20','14:10:00',3.82),('16273','2013-05-20','14:15:00',2.72),('16273','2013-05-20','14:20:00',3.49),('16273','2013-05-20','14:25:00',3.55),('16273','2013-05-20','14:30:00',3.78),('16273','2013-05-20','14:35:00',3.72),('16273','2013-05-20','14:40:00',3.72),('16273','2013-05-20','14:45:00',3.63),('16273','2013-05-20','14:50:00',3.24),('16273','2013-05-20','14:55:00',3.61),('16273','2013-05-20','15:00:00',3.54),('16273','2013-05-20','15:05:00',3.49),('16273','2013-05-20','15:10:00',3.49),('16273','2013-05-20','15:15:00',3.41),('16273','2013-05-20','15:20:00',3.34),('16273','2013-05-20','15:25:00',3.29),('16273','2013-05-20','15:30:00',3.21),('16273','2013-05-20','15:35:00',3.17),('16273','2013-05-20','15:40:00',3.1),('16273','2013-05-20','15:45:00',3.06),('16273','2013-05-20','15:50:00',2.98),('16273','2013-05-20','15:55:00',2.93),('16273','2013-05-20','16:00:00',2.84),('16273','2013-05-20','16:05:00',2.77),('16273','2013-05-20','16:10:00',2.69),('16273','2013-05-20','16:15:00',2.61),('16273','2013-05-20','16:20:00',2.54),('16273','2013-05-20','16:25:00',2.48),('16273','2013-05-20','16:30:00',2.37),('16273','2013-05-20','16:35:00',2.25),('16273','2013-05-20','16:40:00',2.06),('16273','2013-05-20','16:45:00',2.07),('16273','2013-05-20','16:50:00',2.09),('16273','2013-05-20','16:55:00',1.55),('16273','2013-05-20','17:00:00',1.43),('16273','2013-05-20','17:05:00',1.6),('16273','2013-05-20','17:10:00',1.26),('16273','2013-05-20','17:15:00',1.51),('16273','2013-05-20','17:20:00',1.73),('16273','2013-05-20','17:25:00',1.73),('16273','2013-05-20','17:30:00',1.34),('16273','2013-05-20','17:35:00',1.35),('16273','2013-05-20','17:40:00',1.25),('16273','2013-05-20','17:45:00',1.18),('16273','2013-05-20','17:50:00',1.11),('16273','2013-05-20','17:55:00',1.04),('16273','2013-05-19','08:25:00',1.04),('16273','2013-05-19','08:30:00',1.43),('16273','2013-05-19','08:35:00',1.16),('16273','2013-05-19','08:40:00',1.36),('16273','2013-05-19','09:05:00',1.02),('16273','2013-05-19','09:25:00',1.21),('16273','2013-05-19','09:30:00',1.28),('16273','2013-05-19','09:35:00',1.25),('16273','2013-05-19','09:40:00',1.18),('16273','2013-05-19','09:45:00',1.41),('16273','2013-05-19','09:50:00',1.58),('16273','2013-05-19','09:55:00',1.97),('16273','2013-05-19','10:00:00',2.41),('16273','2013-05-19','10:05:00',2.44),('16273','2013-05-19','10:10:00',2.21),('16273','2013-05-19','10:15:00',2.27),('16273','2013-05-19','10:20:00',1.82),('16273','2013-05-19','10:25:00',2.87),('16273','2013-05-19','10:30:00',3.19),('16273','2013-05-19','10:35:00',2.6),('16273','2013-05-19','10:40:00',3.4),('16273','2013-05-19','10:45:00',3.45),('16273','2013-05-19','10:50:00',3.98),('16273','2013-05-19','10:55:00',3.59),('16273','2013-05-19','11:00:00',3.29),('16273','2013-05-19','11:05:00',3.01),('16273','2013-05-19','11:10:00',3.88),('16273','2013-05-19','11:15:00',4.26),('16273','2013-05-19','11:20:00',3.63),('16273','2013-05-19','11:25:00',4.32),('16273','2013-05-19','11:30:00',3.9),('16273','2013-05-19','11:35:00',4.35),('16273','2013-05-19','11:40:00',4.27),('16273','2013-05-19','11:45:00',4.27),('16273','2013-05-19','11:50:00',4.3),('16273','2013-05-19','11:55:00',4.34),('16273','2013-05-19','12:00:00',4.35),('16273','2013-05-19','12:05:00',4.34),('16273','2013-05-19','12:10:00',4.36),('16273','2013-05-19','12:15:00',4.38),('16273','2013-05-19','12:20:00',4.4),('16273','2013-05-19','12:25:00',4.42),('16273','2013-05-19','12:30:00',4.35),('16273','2013-05-19','12:35:00',4.35),('16273','2013-05-19','12:40:00',4.42),('16273','2013-05-19','12:45:00',4.39),('16273','2013-05-19','12:50:00',4.45),('16273','2013-05-19','12:55:00',4.37),('16273','2013-05-19','13:00:00',4.33),('16273','2013-05-19','13:05:00',4.33),('16273','2013-05-19','13:10:00',4.28),('16273','2013-05-19','13:15:00',4.23),('16273','2013-05-19','13:20:00',4.22),('16273','2013-05-19','13:25:00',4.19),('16273','2013-05-19','13:30:00',4.17),('16273','2013-05-19','13:35:00',4.16),('16273','2013-05-19','13:40:00',4.17),('16273','2013-05-19','13:45:00',4.14),('16273','2013-05-19','13:50:00',4.12),('16273','2013-05-19','13:55:00',4.05),('16273','2013-05-19','14:00:00',4.02),('16273','2013-05-19','14:05:00',4.01),('16273','2013-05-19','14:10:00',4.01),('16273','2013-05-19','14:15:00',3.96),('16273','2013-05-19','14:20:00',3.93),('16273','2013-05-19','14:25:00',3.89),('16273','2013-05-19','14:30:00',3.83),('16273','2013-05-19','14:35:00',3.77),('16273','2013-05-19','14:40:00',3.73),('16273','2013-05-19','14:45:00',3.69),('16273','2013-05-19','14:50:00',3.66),('16273','2013-05-19','14:55:00',3.64),('16273','2013-05-19','15:00:00',3.6),('16273','2013-05-19','15:05:00',3.53),('16273','2013-05-19','15:10:00',3.49),('16273','2013-05-19','15:15:00',3.45),('16273','2013-05-19','15:20:00',3.4),('16273','2013-05-19','15:25:00',3.32),('16273','2013-05-19','15:30:00',3.23),('16273','2013-05-19','15:35:00',3.19),('16273','2013-05-19','15:40:00',3.11),('16273','2013-05-19','15:45:00',3.08),('16273','2013-05-19','15:50:00',3.03),('16273','2013-05-19','15:55:00',2.95),('16273','2013-05-19','16:00:00',2.88),('16273','2013-05-19','16:05:00',2.81),('16273','2013-05-19','16:10:00',2.73),('16273','2013-05-19','16:15:00',2.65),('16273','2013-05-19','16:20:00',2.58),('16273','2013-05-19','16:25:00',2.51),('16273','2013-05-19','16:30:00',2.45),('16273','2013-05-19','16:35:00',2.38),('16273','2013-05-19','16:40:00',2.3),('16273','2013-05-19','16:45:00',2.19),('16273','2013-05-19','16:50:00',2.13),('16273','2013-05-19','16:55:00',2.06),('16273','2013-05-19','17:00:00',1.96),('16273','2013-05-19','17:05:00',1.87),('16273','2013-05-19','17:10:00',1.8),('16273','2013-05-19','17:15:00',1.72),('16273','2013-05-19','17:20:00',1.63),('16273','2013-05-19','17:25:00',1.54),('16273','2013-05-19','17:30:00',1.46),('16273','2013-05-19','17:35:00',1.37),('16273','2013-05-19','17:40:00',1.29),('16273','2013-05-19','17:45:00',1.21),('16273','2013-05-19','17:50:00',1.13),('16273','2013-05-19','17:55:00',1.06),('16273','2013-05-18','07:10:00',1.02),('16273','2013-05-18','07:15:00',1.16),('16273','2013-05-18','07:20:00',1.26),('16273','2013-05-18','07:25:00',1.34),('16273','2013-05-18','07:30:00',1.43),('16273','2013-05-18','07:35:00',1.53),('16273','2013-05-18','07:40:00',1.63),('16273','2013-05-18','07:45:00',1.59),('16273','2013-05-18','07:50:00',1.4),('16273','2013-05-18','07:55:00',1.33),('16273','2013-05-18','08:00:00',2.06),('16273','2013-05-18','08:05:00',1.03),('16273','2013-05-18','08:10:00',1.01),('16273','2013-05-18','08:15:00',1.16),('16273','2013-05-18','08:20:00',1.6),('16273','2013-05-18','08:25:00',1.78),('16273','2013-05-18','08:30:00',1.73),('16273','2013-05-18','08:35:00',1.92),('16273','2013-05-18','08:40:00',2.76),('16273','2013-05-18','08:45:00',2.75),('16273','2013-05-18','08:50:00',2.85),('16273','2013-05-18','08:55:00',2.76),('16273','2013-05-18','09:00:00',2.82),('16273','2013-05-18','09:05:00',2.98),('16273','2013-05-18','09:10:00',3.01),('16273','2013-05-18','09:15:00',3.06),('16273','2013-05-18','09:20:00',3.11),('16273','2013-05-18','09:25:00',3.16),('16273','2013-05-18','09:30:00',3.22),('16273','2013-05-18','09:35:00',3.26),('16273','2013-05-18','09:40:00',3.3),('16273','2013-05-18','09:45:00',3.36),('16273','2013-05-18','09:50:00',3.41),('16273','2013-05-18','09:55:00',3.45),('16273','2013-05-18','10:00:00',3.48),('16273','2013-05-18','10:05:00',3.54),('16273','2013-05-18','10:10:00',3.57),('16273','2013-05-18','10:15:00',3.6),('16273','2013-05-18','10:20:00',3.63),('16273','2013-05-18','10:25:00',3.67),('16273','2013-05-18','10:30:00',3.7),('16273','2013-05-18','10:35:00',3.72),('16273','2013-05-18','10:40:00',3.74),('16273','2013-05-18','10:45:00',3.78),('16273','2013-05-18','10:50:00',3.85),('16273','2013-05-18','10:55:00',3.95),('16273','2013-05-18','11:00:00',4.1),('16273','2013-05-18','11:05:00',3.12),('16273','2013-05-18','11:10:00',3.69),('16273','2013-05-18','11:15:00',3.73),('16273','2013-05-18','11:20:00',3.8),('16273','2013-05-18','11:25:00',3.36),('16273','2013-05-18','11:30:00',4.04),('16273','2013-05-18','11:35:00',3.9),('16273','2013-05-18','11:40:00',3.97),('16273','2013-05-18','11:45:00',3.97),('16273','2013-05-18','11:50:00',4),('16273','2013-05-18','11:55:00',3.97),('16273','2013-05-18','12:00:00',3.95),('16273','2013-05-18','12:05:00',3.92),('16273','2013-05-18','12:10:00',3.91),('16273','2013-05-18','12:15:00',3.94),('16273','2013-05-18','12:20:00',3.99),('16273','2013-05-18','12:25:00',3.55),('16273','2013-05-18','12:30:00',3.97),('16273','2013-05-18','12:35:00',3.98),('16273','2013-05-18','12:40:00',3.96),('16273','2013-05-18','12:45:00',2.92),('16273','2013-05-18','12:50:00',3.86),('16273','2013-05-18','12:55:00',3.93),('16273','2013-05-18','13:00:00',3.9),('16273','2013-05-18','13:05:00',3.88),('16273','2013-05-18','13:10:00',3.87),('16273','2013-05-18','13:15:00',3.85),('16273','2013-05-18','13:20:00',3.83),('16273','2013-05-18','13:25:00',3.84),('16273','2013-05-18','13:30:00',3.86),('16273','2013-05-18','13:35:00',3.83),('16273','2013-05-18','13:40:00',3.55),('16273','2013-05-18','13:45:00',3.84),('16273','2013-05-18','13:50:00',3.7),('16273','2013-05-18','13:55:00',3.96),('16273','2013-05-18','14:00:00',2.53),('16273','2013-05-18','14:05:00',2.59),('16273','2013-05-18','14:10:00',2.78),('16273','2013-05-18','14:15:00',3.63),('16273','2013-05-18','14:20:00',3.53),('16273','2013-05-18','14:25:00',3.62),('16273','2013-05-18','14:30:00',3.14),('16273','2013-05-18','14:35:00',3.58),('16273','2013-05-18','14:40:00',3.43),('16273','2013-05-18','14:45:00',3.24),('16273','2013-05-18','14:50:00',3.44),('16273','2013-05-18','14:55:00',3.27),('16273','2013-05-18','15:00:00',3.11),('16273','2013-05-18','15:05:00',3.11),('16273','2013-05-18','15:10:00',3.08),('16273','2013-05-18','15:15:00',3),('16273','2013-05-18','15:20:00',2.96),('16273','2013-05-18','15:25:00',2.91),('16273','2013-05-18','15:30:00',2.83),('16273','2013-05-18','15:35:00',2.84),('16273','2013-05-18','15:40:00',2.77),('16273','2013-05-18','15:45:00',2.7),('16273','2013-05-18','15:50:00',2.65),('16273','2013-05-18','15:55:00',2.59),('16273','2013-05-18','16:00:00',2.52),('16273','2013-05-18','16:05:00',2.46),('16273','2013-05-18','16:10:00',2.39),('16273','2013-05-18','16:15:00',2.31),('16273','2013-05-18','16:20:00',2.25),('16273','2013-05-18','16:25:00',2.18),('16273','2013-05-18','16:30:00',2.13),('16273','2013-05-18','16:35:00',2.06),('16273','2013-05-18','16:40:00',1.98),('16273','2013-05-18','16:45:00',1.9),('16273','2013-05-18','16:50:00',1.83),('16273','2013-05-18','16:55:00',1.76),('16273','2013-05-18','17:00:00',1.69),('16273','2013-05-18','17:05:00',1.63),('16273','2013-05-18','17:10:00',1.57),('16273','2013-05-18','17:15:00',1.49),('16273','2013-05-18','17:20:00',1.43),('16273','2013-05-18','17:25:00',1.37),('16273','2013-05-18','17:30:00',1.3),('16273','2013-05-18','17:35:00',1.24),('16273','2013-05-18','17:40:00',1.18),('16273','2013-05-18','17:45:00',1.12),('16273','2013-05-18','17:50:00',1.05),('16273','2013-05-17','07:25:00',1.15),('16273','2013-05-17','07:30:00',1.18),('16273','2013-05-17','07:35:00',1.43),('16273','2013-05-17','07:40:00',1.69),('16273','2013-05-17','07:45:00',1.57),('16273','2013-05-17','07:50:00',1.06),('16273','2013-05-17','08:00:00',1.18),('16273','2013-05-17','08:05:00',1.62),('16273','2013-05-17','08:10:00',2.16),('16273','2013-05-17','08:15:00',2.24),('16273','2013-05-17','08:20:00',1.54),('16273','2013-05-17','10:20:00',1.12),('16273','2013-05-17','10:25:00',1.27),('16273','2013-05-17','10:30:00',1.31),('16273','2013-05-17','10:35:00',1.27),('16273','2013-05-17','10:40:00',1.55),('16273','2013-05-17','10:45:00',3.35),('16273','2013-05-17','10:50:00',3.68),('16273','2013-05-17','10:55:00',2.91),('16273','2013-05-17','11:00:00',1.94),('16273','2013-05-17','11:05:00',1.69),('16273','2013-05-17','11:10:00',3.07),('16273','2013-05-17','11:15:00',3.2),('16273','2013-05-17','11:20:00',2.05),('16273','2013-05-17','11:25:00',2.13),('16273','2013-05-17','11:30:00',2.26),('16273','2013-05-17','11:35:00',2.14),('16273','2013-05-17','11:40:00',3.38),('16273','2013-05-17','11:45:00',4.31),('16273','2013-05-17','11:50:00',4.61),('16273','2013-05-17','11:55:00',3.85),('16273','2013-05-17','12:00:00',3.84),('16273','2013-05-17','12:05:00',4.25),('16273','2013-05-17','12:10:00',3.93),('16273','2013-05-17','12:15:00',3.93),('16273','2013-05-17','12:20:00',4.72),('16273','2013-05-17','12:25:00',4.36),('16273','2013-05-17','12:30:00',4.6),('16273','2013-05-17','12:35:00',3.1),('16273','2013-05-17','12:40:00',3.98),('16273','2013-05-17','12:45:00',3.65),('16273','2013-05-17','12:50:00',4.39),('16273','2013-05-17','12:55:00',1.82),('16273','2013-05-17','13:00:00',1.1),('16273','2013-05-17','13:05:00',1.03),('16273','2013-05-17','13:15:00',1.02),('16273','2013-05-17','13:20:00',1.21),('16273','2013-05-17','13:25:00',2.27),('16273','2013-05-17','13:30:00',4.27),('16273','2013-05-17','13:35:00',2.43),('16273','2013-05-17','13:40:00',1.95),('16273','2013-05-17','13:45:00',2.49),('16273','2013-05-17','13:50:00',3.27),('16273','2013-05-17','13:55:00',3.45),('16273','2013-05-17','14:00:00',3.7),('16273','2013-05-17','14:05:00',3.76),('16273','2013-05-17','14:10:00',3.57),('16273','2013-05-17','14:15:00',3.99),('16273','2013-05-17','14:20:00',3.36),('16273','2013-05-17','14:25:00',3.22),('16273','2013-05-17','14:30:00',3.6),('16273','2013-05-17','14:35:00',4.06),('16273','2013-05-17','14:40:00',3.07),('16273','2013-05-17','14:45:00',2.67),('16273','2013-05-17','14:50:00',2.78),('16273','2013-05-17','14:55:00',3.61),('16273','2013-05-17','15:00:00',3.21),('16273','2013-05-17','15:05:00',3.6),('16273','2013-05-17','15:10:00',3.53),('16273','2013-05-17','15:15:00',3.55),('16273','2013-05-17','15:20:00',3.49),('16273','2013-05-17','15:25:00',3.38),('16273','2013-05-17','15:30:00',2.89),('16273','2013-05-17','15:35:00',3.33),('16273','2013-05-17','15:40:00',2.66),('16273','2013-05-17','15:45:00',2.12),('16273','2013-05-17','15:50:00',3.02),('16273','2013-05-17','15:55:00',2.9),('16273','2013-05-17','16:00:00',2.87),('16273','2013-05-17','16:05:00',2.78),('16273','2013-05-17','16:10:00',2.72),('16273','2013-05-17','16:15:00',2.67),('16273','2013-05-17','16:20:00',2.6),('16273','2013-05-17','16:25:00',2.34),('16273','2013-05-17','16:30:00',2.56),('16273','2013-05-17','16:35:00',2.44),('16273','2013-05-17','16:40:00',2.36),('16273','2013-05-17','16:45:00',2.32),('16273','2013-05-17','16:50:00',2.33),('16273','2013-05-17','16:55:00',2.32),('16273','2013-05-17','17:00:00',2.3),('16273','2013-05-17','17:05:00',2.25),('16273','2013-05-17','17:10:00',2.05),('16273','2013-05-17','17:15:00',1.68),('16273','2013-05-17','17:20:00',1.61),('16273','2013-05-17','17:25:00',1.54),('16273','2013-05-17','17:30:00',1.5),('16273','2013-05-17','17:35:00',1.48),('16273','2013-05-17','17:40:00',1.33),('16273','2013-05-17','17:45:00',1.18),('16273','2013-05-17','17:50:00',1.08),('16273','2013-05-17','17:55:00',1.02),('16273','2013-05-16','09:20:00',1.38),('16273','2013-05-16','09:25:00',1.76),('16273','2013-05-16','09:30:00',1.63),('16273','2013-05-16','09:35:00',1.91),('16273','2013-05-16','09:40:00',2.41),('16273','2013-05-16','09:45:00',3.49),('16273','2013-05-16','09:50:00',2.1),('16273','2013-05-16','09:55:00',1.2),('16273','2013-05-16','10:00:00',2.95),('16273','2013-05-16','10:05:00',1.14),('16273','2013-05-16','10:10:00',1.52),('16273','2013-05-16','10:15:00',1.69),('16273','2013-05-16','10:20:00',2.5),('16273','2013-05-16','10:25:00',1.38),('16273','2013-05-16','10:30:00',1.3),('16273','2013-05-16','10:35:00',1.58),('16273','2013-05-16','10:40:00',2.15),('16273','2013-05-16','10:45:00',3.59),('16273','2013-05-16','10:50:00',2.84),('16273','2013-05-16','10:55:00',2.46),('16273','2013-05-16','11:00:00',4.23),('16273','2013-05-16','11:05:00',3.67),('16273','2013-05-16','11:10:00',4.18),('16273','2013-05-16','11:15:00',4.2),('16273','2013-05-16','11:20:00',3.44),('16273','2013-05-16','11:25:00',2.66),('16273','2013-05-16','11:30:00',2.55),('16273','2013-05-16','11:35:00',2.83),('16273','2013-05-16','11:40:00',3.26),('16273','2013-05-16','11:45:00',2.7),('16273','2013-05-16','11:50:00',3.27),('16273','2013-05-16','11:55:00',2.99),('16273','2013-05-16','12:00:00',1.95),('16273','2013-05-16','12:05:00',2.01),('16273','2013-05-16','12:10:00',1.65),('16273','2013-05-16','12:15:00',1.63),('16273','2013-05-16','12:20:00',1.7),('16273','2013-05-16','12:25:00',1.74),('16273','2013-05-16','12:30:00',2.34),('16273','2013-05-16','12:35:00',3.89),('16273','2013-05-16','12:40:00',3.27),('16273','2013-05-16','12:45:00',4.12),('16273','2013-05-16','12:50:00',3.96),('16273','2013-05-16','12:55:00',3.52),('16273','2013-05-16','13:00:00',3.86),('16273','2013-05-16','13:05:00',3.83),('16273','2013-05-16','13:10:00',3.76),('16273','2013-05-16','13:15:00',3.71),('16273','2013-05-16','13:20:00',3.73),('16273','2013-05-16','13:25:00',3.74),('16273','2013-05-16','13:30:00',3.71),('16273','2013-05-16','13:35:00',3.7),('16273','2013-05-16','13:40:00',3.69),('16273','2013-05-16','13:45:00',3.61),('16273','2013-05-16','13:50:00',3.59),('16273','2013-05-16','13:55:00',3.55),('16273','2013-05-16','14:00:00',3.54),('16273','2013-05-16','14:05:00',3.47),('16273','2013-05-16','14:10:00',3.49),('16273','2013-05-16','14:15:00',3.44),('16273','2013-05-16','14:20:00',3.38),('16273','2013-05-16','14:25:00',3.39),('16273','2013-05-16','14:30:00',3.28),('16273','2013-05-16','14:35:00',3.26),('16273','2013-05-16','14:40:00',3.24),('16273','2013-05-16','14:45:00',3.2),('16273','2013-05-16','14:50:00',3.16),('16273','2013-05-16','14:55:00',2.95),('16273','2013-05-16','15:00:00',3.05),('16273','2013-05-16','15:05:00',3.07),('16273','2013-05-16','15:10:00',3.08),('16273','2013-05-16','15:15:00',2.95),('16273','2013-05-16','15:20:00',2.93),('16273','2013-05-16','15:25:00',2.81),('16273','2013-05-16','15:30:00',2.74),('16273','2013-05-16','15:35:00',2.73),('16273','2013-05-16','15:40:00',2.69),('16273','2013-05-16','15:45:00',2.65),('16273','2013-05-16','15:50:00',2.6),('16273','2013-05-16','15:55:00',2.51),('16273','2013-05-16','16:00:00',2.42),('16273','2013-05-16','16:05:00',2.34),('16273','2013-05-16','16:10:00',2.34),('16273','2013-05-16','16:15:00',2.1),('16273','2013-05-16','16:20:00',2.14),('16273','2013-05-16','16:25:00',2.22),('16273','2013-05-16','16:30:00',2.06),('16273','2013-05-16','16:35:00',2.14),('16273','2013-05-16','16:40:00',2.12),('16273','2013-05-16','16:45:00',1.94),('16273','2013-05-16','16:50:00',1.69),('16273','2013-05-16','16:55:00',1.56),('16273','2013-05-16','17:00:00',1.12),('16273','2013-05-16','17:05:00',1.47),('16273','2013-05-16','17:10:00',1.14),('16273','2013-05-16','17:15:00',1.27),('16273','2013-05-16','17:20:00',1.41),('16273','2013-05-16','17:25:00',1.34),('16273','2013-05-16','17:30:00',1.35),('16273','2013-05-15','07:15:00',1.14),('16273','2013-05-15','07:20:00',1.25),('16273','2013-05-15','07:25:00',1.36),('16273','2013-05-15','07:30:00',1.46),('16273','2013-05-15','07:35:00',1.49),('16273','2013-05-15','07:40:00',1.61),('16273','2013-05-15','07:45:00',1.75),('16273','2013-05-15','07:50:00',1.73),('16273','2013-05-15','07:55:00',1.67),('16273','2013-05-15','08:00:00',1.58),('16273','2013-05-15','08:05:00',1.88),('16273','2013-05-15','08:10:00',2.08),('16273','2013-05-15','08:15:00',2.14),('16273','2013-05-15','08:20:00',2.2),('16273','2013-05-15','08:25:00',2.16),('16273','2013-05-15','08:30:00',2.29),('16273','2013-05-15','08:35:00',2.42),('16273','2013-05-15','08:40:00',2.5),('16273','2013-05-15','08:45:00',2.61),('16273','2013-05-15','08:50:00',2.69),('16273','2013-05-15','08:55:00',2.6),('16273','2013-05-15','09:00:00',2.72),('16273','2013-05-15','09:05:00',2.69),('16273','2013-05-15','09:10:00',2.77),('16273','2013-05-15','09:15:00',2.79),('16273','2013-05-15','09:20:00',2.84),('16273','2013-05-15','09:25:00',3),('16273','2013-05-15','09:30:00',3.14),('16273','2013-05-15','09:35:00',3.12),('16273','2013-05-15','09:40:00',3.13),('16273','2013-05-15','09:45:00',3.21),('16273','2013-05-15','09:50:00',3.25),('16273','2013-05-15','09:55:00',3.34),('16273','2013-05-15','10:00:00',3.39),('16273','2013-05-15','10:05:00',3.42),('16273','2013-05-15','10:10:00',3.33),('16273','2013-05-15','10:15:00',3.51),('16273','2013-05-15','10:20:00',3.6),('16273','2013-05-15','10:25:00',3.51),('16273','2013-05-15','10:30:00',3.56),('16273','2013-05-15','10:35:00',3.59),('16273','2013-05-15','10:40:00',3.66),('16273','2013-05-15','10:45:00',3.67),('16273','2013-05-15','10:50:00',3.76),('16273','2013-05-15','10:55:00',3.75),('16273','2013-05-15','11:00:00',3.73),('16273','2013-05-15','11:05:00',3.7),('16273','2013-05-15','11:10:00',3.87),('16273','2013-05-15','11:15:00',3.78),('16273','2013-05-15','11:20:00',3.79),('16273','2013-05-15','11:25:00',4.04),('16273','2013-05-15','11:30:00',3.93),('16273','2013-05-15','11:35:00',3.87),('16273','2013-05-15','11:40:00',3.97),('16273','2013-05-15','11:45:00',2.93),('16273','2013-05-15','11:50:00',1.96),('16273','2013-05-15','11:55:00',2.43),('16273','2013-05-15','12:00:00',3.12),('16273','2013-05-15','12:05:00',4.71),('16273','2013-05-15','12:10:00',4.07),('16273','2013-05-15','12:15:00',4.31),('16273','2013-05-15','12:20:00',3.78),('16273','2013-05-15','12:25:00',3.18),('16273','2013-05-15','12:30:00',3.18),('16273','2013-05-15','12:35:00',3.14),('16273','2013-05-15','12:40:00',2.44),('16273','2013-05-15','12:45:00',2.37),('16273','2013-05-15','12:50:00',2.3),('16273','2013-05-15','12:55:00',2.38),('16273','2013-05-15','13:00:00',2.45),('16273','2013-05-15','13:05:00',2.49),('16273','2013-05-15','13:10:00',2.34),('16273','2013-05-15','13:15:00',2.33),('16273','2013-05-15','13:20:00',2.41),('16273','2013-05-15','13:25:00',2.39),('16273','2013-05-15','13:30:00',2.59),('16273','2013-05-15','13:35:00',2.37),('16273','2013-05-15','13:40:00',2.24),('16273','2013-05-15','13:45:00',2.3),('16273','2013-05-15','13:50:00',2.24),('16273','2013-05-15','13:55:00',1.84),('16273','2013-05-15','14:00:00',1.85),('16273','2013-05-15','14:05:00',2.1),('16273','2013-05-15','14:10:00',2.23),('16273','2013-05-15','14:15:00',2.05),('16273','2013-05-15','14:20:00',1.93),('16273','2013-05-15','14:25:00',1.67),('16273','2013-05-15','14:30:00',1.44),('16273','2013-05-15','14:35:00',1.34),('16273','2013-05-15','14:40:00',1.28),('16273','2013-05-15','14:45:00',1.28),('16273','2013-05-15','14:50:00',1.27),('16273','2013-05-15','14:55:00',1.31),('16273','2013-05-15','15:00:00',1.22),('16273','2013-05-15','15:35:00',1.05),('16273','2013-05-15','15:40:00',1.36),('16273','2013-05-15','15:45:00',1.84),('16273','2013-05-15','15:50:00',2.03),('16273','2013-05-15','15:55:00',1.88),('16273','2013-05-15','16:00:00',1.92),('16273','2013-05-15','16:05:00',1.75),('16273','2013-05-15','16:10:00',1.56),('16273','2013-05-15','16:15:00',1.43),('16273','2013-05-15','16:20:00',1.39),('16273','2013-05-15','16:25:00',1.24),('16273','2013-05-15','16:30:00',1.19),('16273','2013-05-15','16:35:00',1.24),('16273','2013-05-15','16:40:00',1.21),('16273','2013-05-15','16:45:00',1.15),('16273','2013-05-15','16:50:00',1.16),('16273','2013-05-15','16:55:00',1.28),('16273','2013-05-15','17:00:00',1.45),('16273','2013-05-15','17:05:00',1.47),('16273','2013-05-15','17:10:00',1.46),('16273','2013-05-15','17:15:00',1.58),('16273','2013-05-15','17:20:00',1.28),('16273','2013-05-15','17:25:00',1.29),('16273','2013-05-15','17:30:00',1.06),('16273','2013-05-14','07:05:00',1.02),('16273','2013-05-14','07:15:00',1.2),('16273','2013-05-14','07:20:00',1.3),('16273','2013-05-14','07:25:00',1.4),('16273','2013-05-14','07:30:00',1.49),('16273','2013-05-14','07:35:00',1.57),('16273','2013-05-14','07:40:00',1.66),('16273','2013-05-14','07:45:00',1.74),('16273','2013-05-14','07:50:00',1.84),('16273','2013-05-14','07:55:00',1.95),('16273','2013-05-14','08:00:00',2.03),('16273','2013-05-14','08:05:00',2.12),('16273','2013-05-14','08:10:00',2.21),('16273','2013-05-14','08:15:00',2.28),('16273','2013-05-14','08:20:00',2.37),('16273','2013-05-14','08:25:00',2.46),('16273','2013-05-14','08:30:00',2.53),('16273','2013-05-14','08:35:00',2.6),('16273','2013-05-14','08:40:00',2.67),('16273','2013-05-14','08:45:00',2.73),('16273','2013-05-14','08:50:00',2.81),('16273','2013-05-14','08:55:00',2.87),('16273','2013-05-14','09:00:00',2.94),('16273','2013-05-14','09:05:00',3.01),('16273','2013-05-14','09:10:00',3.08),('16273','2013-05-14','09:15:00',3.13),('16273','2013-05-14','09:20:00',3.19),('16273','2013-05-14','09:25:00',3.24),('16273','2013-05-14','09:30:00',3.29),('16273','2013-05-14','09:35:00',3.34),('16273','2013-05-14','09:40:00',3.39),('16273','2013-05-14','09:45:00',3.44),('16273','2013-05-14','09:50:00',3.5),('16273','2013-05-14','09:55:00',3.54),('16273','2013-05-14','10:00:00',3.58),('16273','2013-05-14','10:05:00',3.59),('16273','2013-05-14','10:10:00',3.68),('16273','2013-05-14','10:15:00',3.71),('16273','2013-05-14','10:20:00',3.76),('16273','2013-05-14','10:25:00',3.8),('16273','2013-05-14','10:30:00',3.83),('16273','2013-05-14','10:35:00',3.87),('16273','2013-05-14','10:40:00',3.91),('16273','2013-05-14','10:45:00',3.89),('16273','2013-05-14','10:50:00',3.92),('16273','2013-05-14','10:55:00',3.96),('16273','2013-05-14','11:00:00',3.96),('16273','2013-05-14','11:05:00',3.98),('16273','2013-05-14','11:10:00',4),('16273','2013-05-14','11:15:00',4.01),('16273','2013-05-14','11:20:00',4),('16273','2013-05-14','11:25:00',4),('16273','2013-05-14','11:30:00',4.02),('16273','2013-05-14','11:35:00',4.03),('16273','2013-05-14','11:40:00',4.03),('16273','2013-05-14','11:45:00',4.04),('16273','2013-05-14','11:50:00',4.05),('16273','2013-05-14','11:55:00',4.06),('16273','2013-05-14','12:00:00',4.01),('16273','2013-05-14','12:05:00',4.05),('16273','2013-05-14','12:10:00',4.06),('16273','2013-05-14','12:15:00',4.08),('16273','2013-05-14','12:20:00',4.1),('16273','2013-05-14','12:25:00',4.08),('16273','2013-05-14','12:30:00',4.09),('16273','2013-05-14','12:35:00',4.1),('16273','2013-05-14','12:40:00',4.07),('16273','2013-05-14','12:45:00',4.06),('16273','2013-05-14','12:50:00',4.02),('16273','2013-05-14','12:55:00',4.03),('16273','2013-05-14','13:00:00',4.02),('16273','2013-05-14','13:05:00',4.01),('16273','2013-05-14','13:10:00',4),('16273','2013-05-14','13:15:00',3.96),('16273','2013-05-14','13:20:00',3.93),('16273','2013-05-14','13:25:00',3.92),('16273','2013-05-14','13:30:00',3.91),('16273','2013-05-14','13:35:00',3.91),('16273','2013-05-14','13:40:00',3.87),('16273','2013-05-14','13:45:00',3.81),('16273','2013-05-14','13:50:00',3.75),('16273','2013-05-14','13:55:00',3.78),('16273','2013-05-14','14:00:00',3.8),('16273','2013-05-14','14:05:00',3.79),('16273','2013-05-14','14:10:00',3.76),('16273','2013-05-14','14:15:00',3.74),('16273','2013-05-14','14:20:00',3.72),('16273','2013-05-14','14:25:00',3.71),('16273','2013-05-14','14:30:00',3.67),('16273','2013-05-14','14:35:00',3.63),('16273','2013-05-14','14:40:00',3.6),('16273','2013-05-14','14:45:00',3.57),('16273','2013-05-14','14:50:00',3.54),('16273','2013-05-14','14:55:00',3.49),('16273','2013-05-14','15:00:00',3.46),('16273','2013-05-14','15:05:00',3.34),('16273','2013-05-14','15:10:00',3.36),('16273','2013-05-14','15:15:00',3.31),('16273','2013-05-14','15:20:00',3.25),('16273','2013-05-14','15:25:00',3.18),('16273','2013-05-14','15:30:00',3.13),('16273','2013-05-14','15:35:00',3.07),('16273','2013-05-14','15:40:00',3.01),('16273','2013-05-14','15:45:00',2.94),('16273','2013-05-14','15:50:00',2.88),('16273','2013-05-14','15:55:00',2.82),('16273','2013-05-14','16:00:00',2.76),('16273','2013-05-14','16:05:00',2.69),('16273','2013-05-14','16:10:00',2.63),('16273','2013-05-14','16:15:00',2.55),('16273','2013-05-14','16:20:00',2.46),('16273','2013-05-14','16:25:00',2.41),('16273','2013-05-14','16:30:00',2.33),('16273','2013-05-14','16:35:00',2.25),('16273','2013-05-14','16:40:00',2.16),('16273','2013-05-14','16:45:00',2.09),('16273','2013-05-14','16:50:00',2.01),('16273','2013-05-14','16:55:00',1.93),('16273','2013-05-14','17:00:00',1.84),('16273','2013-05-14','17:05:00',1.76),('16273','2013-05-14','17:10:00',1.68),('16273','2013-05-14','17:15:00',1.6),('16273','2013-05-14','17:20:00',1.52),('16273','2013-05-14','17:25:00',1.44),('16273','2013-05-14','17:30:00',1.35),('16273','2013-05-14','17:35:00',1.26),('16273','2013-05-14','17:40:00',1.19),('16273','2013-05-14','17:45:00',1.12),('16273','2013-05-14','17:50:00',1.04),('16273','2013-05-13','07:25:00',1.34),('16273','2013-05-13','07:30:00',1.74),('16273','2013-05-13','07:35:00',1.85),('16273','2013-05-13','07:40:00',1.77),('16273','2013-05-13','07:45:00',1.42),('16273','2013-05-13','07:55:00',1.32),('16273','2013-05-13','08:00:00',1.86),('16273','2013-05-13','08:05:00',1.94),('16273','2013-05-13','08:10:00',2.01),('16273','2013-05-13','08:15:00',2.06),('16273','2013-05-13','08:20:00',2.18),('16273','2013-05-13','08:25:00',2.25),('16273','2013-05-13','08:30:00',2.35),('16273','2013-05-13','08:35:00',2.43),('16273','2013-05-13','08:40:00',2.51),('16273','2013-05-13','08:45:00',2.6),('16273','2013-05-13','08:50:00',2.66),('16273','2013-05-13','08:55:00',2.72),('16273','2013-05-13','09:00:00',2.79),('16273','2013-05-13','09:05:00',2.82),('16273','2013-05-13','09:10:00',2.9),('16273','2013-05-13','09:15:00',2.97),('16273','2013-05-13','09:20:00',3.03),('16273','2013-05-13','09:25:00',3.17),('16273','2013-05-13','09:30:00',2.98),('16273','2013-05-13','09:35:00',3.38),('16273','2013-05-13','09:40:00',3.53),('16273','2013-05-13','09:45:00',3.74),('16273','2013-05-13','09:50:00',3.7),('16273','2013-05-13','09:55:00',1.51),('16273','2013-05-13','10:00:00',1.9),('16273','2013-05-13','10:05:00',1.9),('16273','2013-05-13','10:10:00',1.94),('16273','2013-05-13','10:15:00',2.84),('16273','2013-05-13','10:20:00',2.59),('16273','2013-05-13','10:25:00',3.55),('16273','2013-05-13','10:30:00',3.03),('16273','2013-05-13','10:35:00',4.1),('16273','2013-05-13','10:40:00',4.07),('16273','2013-05-13','10:45:00',4.09),('16273','2013-05-13','10:50:00',4.12),('16273','2013-05-13','10:55:00',4.23),('16273','2013-05-13','11:00:00',4.27),('16273','2013-05-13','11:05:00',4.19),('16273','2013-05-13','11:10:00',1.57),('16273','2013-05-13','11:15:00',2.44),('16273','2013-05-13','11:20:00',1.41),('16273','2013-05-13','11:25:00',1.32),('16273','2013-05-13','11:30:00',1.06),('16273','2013-05-13','11:35:00',1.5),('16273','2013-05-13','11:40:00',1.23),('16273','2013-05-13','11:45:00',4.87),('16273','2013-05-13','11:50:00',4.82),('16273','2013-05-13','11:55:00',2.69),('16273','2013-05-13','12:35:00',2.3),('16273','2013-05-13','12:40:00',4.69),('16273','2013-05-13','12:45:00',4.42),('16273','2013-05-13','12:50:00',4.31),('16273','2013-05-13','12:55:00',4.06),('16273','2013-05-13','13:00:00',3.81),('16273','2013-05-13','13:05:00',1.69),('16273','2013-05-13','13:10:00',1.74),('16273','2013-05-13','13:15:00',1.07),('16273','2013-05-13','13:20:00',1.09),('16273','2013-05-13','13:25:00',1.25),('16273','2013-05-13','13:30:00',1.27),('16273','2013-05-13','13:35:00',2.43),('16273','2013-05-13','13:40:00',4.43),('16273','2013-05-13','13:45:00',2.61),('16273','2013-05-13','13:50:00',1),('16273','2013-05-13','14:10:00',3.56),('16273','2013-05-13','14:15:00',3.03),('16273','2013-05-13','14:45:00',1.65),('16273','2013-05-13','14:50:00',1.87),('16273','2013-05-13','14:55:00',1.3),('16273','2013-05-13','15:00:00',1.93),('16273','2013-05-13','15:20:00',1.31),('16273','2013-05-13','15:25:00',1.14),('16273','2013-05-13','15:30:00',2.81),('16273','2013-05-13','15:35:00',3.26),('16273','2013-05-13','15:40:00',2.04),('16273','2013-05-13','15:45:00',2.52),('16273','2013-05-13','15:50:00',1.95),('16273','2013-05-13','16:05:00',1.2),('16273','2013-05-13','16:10:00',1.42),('16273','2013-05-13','16:15:00',1.38),('16273','2013-05-13','16:20:00',1.13),('16273','2013-05-13','16:25:00',1.04),('16273','2013-05-13','17:00:00',1.79),('16273','2013-05-13','17:05:00',1.47),('16273','2013-05-13','17:10:00',2.03),('16273','2013-05-13','17:15:00',2.11),('16273','2013-05-13','17:20:00',1.76),('16273','2013-05-13','17:25:00',1.56),('16273','2013-05-13','17:30:00',1.45),('16273','2013-05-13','17:35:00',1.34),('16273','2013-05-13','17:40:00',1.23),('16273','2013-05-13','17:45:00',1.18),('16273','2013-05-13','17:50:00',1.14),('16273','2013-05-13','17:55:00',1.17),('16273','2013-05-13','18:00:00',1.09),('16273','2013-05-13','18:30:00',1.04),('16273','2013-05-12','07:25:00',1.23),('16273','2013-05-12','07:30:00',1.35),('16273','2013-05-12','07:35:00',1.22),('16273','2013-05-12','07:40:00',1.46),('16273','2013-05-12','07:45:00',1.8),('16273','2013-05-12','07:50:00',1.39),('16273','2013-05-12','07:55:00',1.47),('16273','2013-05-12','08:00:00',1.72),('16273','2013-05-12','08:05:00',1.94),('16273','2013-05-12','08:10:00',1.04),('16273','2013-05-12','08:35:00',1.04),('16273','2013-05-12','08:40:00',1.75),('16273','2013-05-12','08:45:00',1.7),('16273','2013-05-12','08:50:00',2.22),('16273','2013-05-12','08:55:00',3.18),('16273','2013-05-12','09:00:00',3.17),('16273','2013-05-12','09:05:00',2.78),('16273','2013-05-12','09:10:00',3.31),('16273','2013-05-12','09:15:00',3.3),('16273','2013-05-12','09:20:00',2.5),('16273','2013-05-12','09:25:00',1.16),('16273','2013-05-12','09:35:00',1.92),('16273','2013-05-12','09:40:00',3.74),('16273','2013-05-12','09:45:00',2.9),('16273','2013-05-12','09:50:00',1.56),('16273','2013-05-12','09:55:00',3.06),('16273','2013-05-12','10:00:00',2.96),('16273','2013-05-12','10:05:00',1.45),('16273','2013-05-12','10:10:00',2.87),('16273','2013-05-12','10:15:00',1.4),('16273','2013-05-12','10:20:00',1.98),('16273','2013-05-12','10:25:00',4),('16273','2013-05-12','10:30:00',4.26),('16273','2013-05-12','10:35:00',3.95),('16273','2013-05-12','10:40:00',4.18),('16273','2013-05-12','10:45:00',1.51),('16273','2013-05-12','10:50:00',3.54),('16273','2013-05-12','10:55:00',4.42),('16273','2013-05-12','11:00:00',3.71),('16273','2013-05-12','11:05:00',4.13),('16273','2013-05-12','11:10:00',4.17),('16273','2013-05-12','11:15:00',3.47),('16273','2013-05-12','11:20:00',3.55),('16273','2013-05-12','11:25:00',3.88),('16273','2013-05-12','11:30:00',1.52),('16273','2013-05-12','11:35:00',1.43),('16273','2013-05-12','11:40:00',3.22),('16273','2013-05-12','11:45:00',2.38),('16273','2013-05-12','11:50:00',4.56),('16273','2013-05-12','11:55:00',4.4),('16273','2013-05-12','12:00:00',4.42),('16273','2013-05-12','12:05:00',4.36),('16273','2013-05-12','12:10:00',4.38),('16273','2013-05-12','12:15:00',4.41),('16273','2013-05-12','12:20:00',4.48),('16273','2013-05-12','12:25:00',4.54),('16273','2013-05-12','12:30:00',1.58),('16273','2013-05-12','12:35:00',1.98),('16273','2013-05-12','12:40:00',2.56),('16273','2013-05-12','12:45:00',1.74),('16273','2013-05-12','12:50:00',3.29),('16273','2013-05-12','12:55:00',4.38),('16273','2013-05-12','13:00:00',3.73),('16273','2013-05-12','13:05:00',4.2),('16273','2013-05-12','13:10:00',4.2),('16273','2013-05-12','13:15:00',4.18),('16273','2013-05-12','13:20:00',4.17),('16273','2013-05-12','13:25:00',4.14),('16273','2013-05-12','13:30:00',4.16),('16273','2013-05-12','13:35:00',4),('16273','2013-05-12','13:40:00',4.21),('16273','2013-05-12','13:45:00',4.26),('16273','2013-05-12','13:50:00',3.59),('16273','2013-05-12','13:55:00',3.59),('16273','2013-05-12','14:00:00',4),('16273','2013-05-12','14:05:00',3.95),('16273','2013-05-12','14:10:00',2.68),('16273','2013-05-12','14:15:00',2.52),('16273','2013-05-12','14:20:00',3.62),('16273','2013-05-12','14:25:00',3.75),('16273','2013-05-12','14:30:00',2.96),('16273','2013-05-12','14:35:00',3.78),('16273','2013-05-12','14:40:00',2.15),('16273','2013-05-12','14:45:00',2.59),('16273','2013-05-12','14:50:00',3.39),('16273','2013-05-12','14:55:00',3.03),('16273','2013-05-12','15:00:00',2.84),('16273','2013-05-12','15:05:00',3.13),('16273','2013-05-12','15:10:00',3.65),('16273','2013-05-12','15:15:00',3.47),('16273','2013-05-12','15:20:00',3.32),('16273','2013-05-12','15:25:00',3.19),('16273','2013-05-12','15:30:00',3.14),('16273','2013-05-12','15:35:00',3.06),('16273','2013-05-12','15:40:00',3),('16273','2013-05-12','15:45:00',2.92),('16273','2013-05-12','15:50:00',2.88),('16273','2013-05-12','15:55:00',2.78),('16273','2013-05-12','16:00:00',2.72),('16273','2013-05-12','16:05:00',2.64),('16273','2013-05-12','16:10:00',2.57),('16273','2013-05-12','16:15:00',1.98),('16273','2013-05-12','16:20:00',2.1),('16273','2013-05-12','16:25:00',2.5),('16273','2013-05-12','16:30:00',2.13),('16273','2013-05-12','16:35:00',1.8),('16273','2013-05-12','16:40:00',2.43),('16273','2013-05-12','16:45:00',2.53),('16273','2013-05-12','16:50:00',1.47),('16273','2013-05-12','16:55:00',2.23),('16273','2013-05-12','17:00:00',1.42),('16273','2013-05-12','17:05:00',1.46),('16273','2013-05-12','17:10:00',2.25),('16273','2013-05-12','17:15:00',1.67),('16273','2013-05-12','17:20:00',1.85),('16273','2013-05-12','17:25:00',1.82),('16273','2013-05-12','17:30:00',1.52),('16273','2013-05-12','17:35:00',1.51),('16273','2013-05-12','17:40:00',1.75),('16273','2013-05-12','17:45:00',1.72),('16273','2013-05-12','17:50:00',1.51),('16273','2013-05-12','17:55:00',1.15),('16273','2013-05-12','18:00:00',1.31),('16273','2013-05-12','18:05:00',1.45),('16273','2013-05-12','18:10:00',1.2),('16273','2013-05-12','18:15:00',1.08),('16273','2013-05-12','18:20:00',1.23),('16273','2013-05-12','18:25:00',1.23),('16273','2013-05-12','18:30:00',1.04),('16273','2013-05-12','18:35:00',1.02),('16273','2014-03-31','08:05:00',1.08),('16273','2014-03-31','08:10:00',1.2),('16273','2014-03-31','08:15:00',1.15),('16273','2014-03-31','08:20:00',1.43),('16273','2014-03-31','08:25:00',1.54),('16273','2014-03-31','08:30:00',1.63),('16273','2014-03-31','08:35:00',1.72),('16273','2014-03-31','08:40:00',1.8),('16273','2014-03-31','08:45:00',1.87),('16273','2014-03-31','08:50:00',1.97),('16273','2014-03-31','08:55:00',2.07),('16273','2014-03-31','09:00:00',2.17),('16273','2014-03-31','09:05:00',2.24),('16273','2014-03-31','09:10:00',2.31),('16273','2014-03-31','09:15:00',2.39),('16273','2014-03-31','09:20:00',2.46),('16273','2014-03-31','09:25:00',2.54),('16273','2014-03-31','09:30:00',2.59),('16273','2014-03-31','09:35:00',2.67),('16273','2014-03-31','09:40:00',2.73),('16273','2014-03-31','09:45:00',2.8),('16273','2014-03-31','09:50:00',2.83),('16273','2014-03-31','09:55:00',2.89),('16273','2014-03-31','10:00:00',2.92),('16273','2014-03-31','10:05:00',3),('16273','2014-03-31','10:10:00',3.03),('16273','2014-03-31','10:15:00',3.07),('16273','2014-03-31','10:20:00',3.13),('16273','2014-03-31','10:25:00',3.15),('16273','2014-03-31','10:30:00',3.18),('16273','2014-03-31','10:35:00',3.23),('16273','2014-03-31','10:40:00',3.28),('16273','2014-03-31','10:45:00',3.31),('16273','2014-03-31','10:50:00',3.35),('16273','2014-03-31','10:55:00',3.4),('16273','2014-03-31','11:00:00',3.41),('16273','2014-03-31','11:05:00',3.41),('16273','2014-03-31','11:10:00',3.46),('16273','2014-03-31','11:15:00',3.49),('16273','2014-03-31','11:20:00',3.49),('16273','2014-03-31','11:25:00',3.53),('16273','2014-03-31','11:30:00',3.54),('16273','2014-03-31','11:35:00',3.56),('16273','2014-03-31','11:40:00',3.56),('16273','2014-03-31','11:45:00',3.57),('16273','2014-03-31','11:50:00',3.59),('16273','2014-03-31','11:55:00',3.58),('16273','2014-03-31','12:00:00',3.56),('16273','2014-03-31','12:05:00',3.61),('16273','2014-03-31','12:10:00',3.58),('16273','2014-03-31','12:15:00',3.62),('16273','2014-03-31','12:20:00',3.67),('16273','2014-03-31','12:25:00',3.7),('16273','2014-03-31','12:30:00',3.7),('16273','2014-03-31','12:35:00',3.68),('16273','2014-03-31','12:40:00',3.68),('16273','2014-03-31','12:45:00',3.67),('16273','2014-03-31','12:50:00',3.69),('16273','2014-03-31','12:55:00',3.69),('16273','2014-03-31','13:00:00',3.7),('16273','2014-03-31','13:05:00',3.69),('16273','2014-03-31','13:10:00',3.69),('16273','2014-03-31','13:15:00',3.68),('16273','2014-03-31','13:20:00',3.66),('16273','2014-03-31','13:25:00',3.63),('16273','2014-03-31','13:30:00',3.63),('16273','2014-03-31','13:35:00',3.61),('16273','2014-03-31','13:40:00',3.61),('16273','2014-03-31','13:45:00',3.59),('16273','2014-03-31','13:50:00',3.57),('16273','2014-03-31','13:55:00',3.53),('16273','2014-03-31','14:00:00',3.5),('16273','2014-03-31','14:05:00',3.47),('16273','2014-03-31','14:10:00',3.46),('16273','2014-03-31','14:15:00',3.43),('16273','2014-03-31','14:20:00',3.39),('16273','2014-03-31','14:25:00',3.35),('16273','2014-03-31','14:30:00',3.31),('16273','2014-03-31','14:35:00',3.28),('16273','2014-03-31','14:40:00',3.23),('16273','2014-03-31','14:45:00',3.19),('16273','2014-03-31','14:50:00',3.12),('16273','2014-03-31','14:55:00',3.08),('16273','2014-03-31','15:00:00',3.03),('16273','2014-03-31','15:05:00',2.99),('16273','2014-03-31','15:10:00',2.95),('16273','2014-03-31','15:15:00',2.89),('16273','2014-03-31','15:20:00',2.83),('16273','2014-03-31','15:25:00',2.78),('16273','2014-03-31','15:30:00',2.72),('16273','2014-03-31','15:35:00',2.66),('16273','2014-03-31','15:40:00',2.6),('16273','2014-03-31','15:45:00',2.53),('16273','2014-03-31','15:50:00',2.47),('16273','2014-03-31','15:55:00',2.37),('16273','2014-03-31','16:00:00',2.29),('16273','2014-03-31','16:05:00',2.21),('16273','2014-03-31','16:10:00',2.15),('16273','2014-03-31','16:15:00',2.07),('16273','2014-03-31','16:20:00',2.01),('16273','2014-03-31','16:25:00',1.95),('16273','2014-03-31','16:30:00',1.88),('16273','2014-03-31','16:35:00',1.8),('16273','2014-03-31','16:40:00',1.71),('16273','2014-03-31','16:45:00',1.64),('16273','2014-03-31','16:50:00',1.55),('16273','2014-03-31','16:55:00',1.47),('16273','2014-03-31','17:00:00',1.4),('16273','2014-03-31','17:05:00',1.32),('16273','2014-03-31','17:10:00',1.25),('16273','2014-03-31','17:15:00',1.17),('16273','2014-03-31','17:20:00',1.1),('16273','2014-03-31','17:25:00',1.04),('16273','2013-05-11','07:20:00',1.13),('16273','2013-05-11','07:25:00',1.23),('16273','2013-05-11','07:30:00',1.34),('16273','2013-05-11','07:35:00',1.49),('16273','2013-05-11','07:40:00',1.74),('16273','2013-05-11','07:45:00',1.76),('16273','2013-05-11','07:50:00',1.27),('16273','2013-05-11','07:55:00',1.45),('16273','2013-05-11','08:00:00',1.59),('16273','2013-05-11','08:05:00',1.17),('16273','2013-05-11','08:10:00',1.05),('16273','2013-05-11','08:30:00',2.04),('16273','2013-05-11','08:35:00',1.99),('16273','2013-05-11','08:40:00',1.27),('16273','2013-05-11','08:45:00',1.15),('16273','2013-05-11','08:50:00',2.42),('16273','2013-05-11','08:55:00',3.29),('16273','2013-05-11','09:00:00',1.87),('16273','2013-05-11','09:05:00',3.01),('16273','2013-05-11','09:10:00',1.74),('16273','2013-05-11','09:15:00',2.02),('16273','2013-05-11','09:20:00',1.25),('16273','2013-05-11','09:25:00',1.11),('16273','2013-05-11','09:30:00',1.44),('16273','2013-05-11','09:35:00',3.81),('16273','2013-05-11','09:40:00',3.24),('16273','2013-05-11','09:45:00',3.2),('16273','2013-05-11','09:50:00',1.36),('16273','2013-05-11','10:00:00',1.66),('16273','2013-05-11','10:05:00',1.61),('16273','2013-05-11','10:10:00',3.8),('16273','2013-05-11','10:15:00',2.75),('16273','2013-05-11','10:30:00',2.34),('16273','2013-05-11','10:35:00',1.83),('16273','2013-05-11','10:40:00',1.4),('16273','2013-05-11','10:45:00',3.48),('16273','2013-05-11','10:50:00',2.21),('16273','2013-05-11','10:55:00',1.53),('16273','2013-05-11','11:00:00',3.37),('16273','2013-05-11','11:05:00',1.6),('16273','2013-05-11','11:10:00',1.2),('16273','2013-05-11','11:15:00',3.93),('16273','2013-05-11','11:20:00',4.35),('16273','2013-05-11','11:25:00',2.93),('16273','2013-05-11','11:30:00',4.23),('16273','2013-05-11','11:35:00',2.39),('16273','2013-05-11','11:40:00',1.33),('16273','2013-05-11','11:45:00',2.87),('16273','2013-05-11','11:50:00',3.31),('16273','2013-05-11','11:55:00',3.13),('16273','2013-05-11','12:00:00',3.59),('16273','2013-05-11','12:05:00',4.02),('16273','2013-05-11','12:10:00',3.6),('16273','2013-05-11','12:15:00',1.6),('16273','2013-05-11','12:20:00',3.5),('16273','2013-05-11','12:25:00',2.67),('16273','2013-05-11','12:30:00',3.06),('16273','2013-05-11','12:35:00',2.27),('16273','2013-05-11','12:40:00',1.8),('16273','2013-05-11','12:45:00',2.14),('16273','2013-05-11','12:50:00',2.1),('16273','2013-05-11','12:55:00',1.83),('16273','2013-05-11','13:00:00',2.66),('16273','2013-05-11','13:05:00',1.97),('16273','2013-05-11','13:10:00',2.61),('16273','2013-05-11','13:15:00',2.52),('16273','2013-05-11','13:20:00',2.52),('16273','2013-05-11','13:25:00',1.86),('16273','2013-05-11','13:30:00',2.49),('16273','2013-05-11','13:35:00',2.44),('16273','2013-05-11','13:40:00',2.93),('16273','2013-05-11','13:45:00',3.25),('16273','2013-05-11','13:50:00',3.5),('16273','2013-05-11','13:55:00',4.14),('16273','2013-05-11','14:00:00',3.19),('16273','2013-05-11','14:05:00',3.35),('16273','2013-05-11','14:10:00',3.2),('16273','2013-05-11','14:15:00',2.51),('16273','2013-05-11','14:20:00',1.93),('16273','2013-05-11','14:25:00',2.85),('16273','2013-05-11','14:30:00',2.43),('16273','2013-05-11','14:35:00',2.87),('16273','2013-05-11','14:40:00',3.41),('16273','2013-05-11','14:45:00',2.44),('16273','2013-05-11','14:50:00',4.21),('16273','2013-05-11','14:55:00',3.54),('16273','2013-05-11','15:00:00',2.82),('16273','2013-05-11','15:05:00',3.65),('16273','2013-05-11','15:10:00',2.06),('16273','2013-05-11','15:15:00',2.26),('16273','2013-05-11','15:20:00',1.8),('16273','2013-05-11','15:25:00',3.29),('16273','2013-05-11','15:30:00',2.14),('16273','2013-05-11','15:35:00',2.31),('16273','2013-05-11','15:40:00',2.87),('16273','2013-05-11','15:45:00',2.51),('16273','2013-05-11','15:50:00',2.47),('16273','2013-05-11','15:55:00',3.18),('16273','2013-05-11','16:00:00',2.95),('16273','2013-05-11','16:05:00',2.74),('16273','2013-05-11','16:10:00',2.5),('16273','2013-05-11','16:15:00',2.74),('16273','2013-05-11','16:20:00',2.01),('16273','2013-05-11','16:25:00',2.17),('16273','2013-05-11','16:30:00',2.18),('16273','2013-05-11','16:35:00',2.32),('16273','2013-05-11','16:40:00',2.26),('16273','2013-05-11','16:45:00',2.21),('16273','2013-05-11','16:50:00',2.13),('16273','2013-05-11','16:55:00',2.05),('16273','2013-05-11','17:00:00',2.2),('16273','2013-05-11','17:05:00',2.01),('16273','2013-05-11','17:10:00',1.85),('16273','2013-05-11','17:15:00',1.53),('16273','2013-05-11','17:20:00',1.9),('16273','2013-05-11','17:25:00',1.46),('16273','2013-05-11','17:30:00',1.39),('16273','2013-05-11','17:35:00',1.11),('16273','2013-05-11','17:45:00',1.11),('16273','2013-05-10','07:20:00',1.02),('16273','2013-05-10','07:35:00',1.03),('16273','2013-05-10','07:40:00',1.31),('16273','2013-05-10','07:45:00',1.65),('16273','2013-05-10','07:50:00',1.86),('16273','2013-05-10','07:55:00',2.18),('16273','2013-05-10','08:00:00',1.89),('16273','2013-05-10','08:05:00',1.28),('16273','2013-05-10','08:10:00',1.63),('16273','2013-05-10','08:15:00',1.58),('16273','2013-05-10','08:20:00',1.42),('16273','2013-05-10','08:25:00',1.66),('16273','2013-05-10','08:50:00',1.28),('16273','2013-05-10','08:55:00',2.8),('16273','2013-05-10','09:00:00',2.73),('16273','2013-05-10','09:05:00',2.7),('16273','2013-05-10','09:10:00',2.63),('16273','2013-05-10','09:15:00',1.28),('16273','2013-05-10','09:20:00',2.72),('16273','2013-05-10','09:25:00',2.49),('16273','2013-05-10','09:30:00',1.95),('16273','2013-05-10','09:35:00',2.77),('16273','2013-05-10','09:40:00',3.66),('16273','2013-05-10','09:45:00',3.28),('16273','2013-05-10','09:50:00',3),('16273','2013-05-10','09:55:00',3.75),('16273','2013-05-10','10:00:00',3.54),('16273','2013-05-10','10:05:00',3.23),('16273','2013-05-10','10:10:00',2.72),('16273','2013-05-10','10:15:00',3.51),('16273','2013-05-10','10:20:00',3.65),('16273','2013-05-10','10:25:00',3.67),('16273','2013-05-10','10:30:00',3.69),('16273','2013-05-10','10:35:00',3.76),('16273','2013-05-10','10:40:00',3.83),('16273','2013-05-10','10:45:00',3.8),('16273','2013-05-10','10:50:00',3.76),('16273','2013-05-10','10:55:00',3.17),('16273','2013-05-10','11:00:00',3.37),('16273','2013-05-10','11:05:00',3.75),('16273','2013-05-10','11:10:00',3.63),('16273','2013-05-10','11:15:00',3.11),('16273','2013-05-10','11:20:00',3.24),('16273','2013-05-10','11:25:00',4.31),('16273','2013-05-10','11:30:00',1.38),('16273','2013-05-10','11:35:00',4.32),('16273','2013-05-10','11:40:00',3.9),('16273','2013-05-10','11:45:00',4.15),('16273','2013-05-10','11:50:00',2.74),('16273','2013-05-10','11:55:00',3.2),('16273','2013-05-10','12:00:00',3.04),('16273','2013-05-10','12:05:00',3.21),('16273','2013-05-10','12:10:00',2.82),('16273','2013-05-10','12:15:00',2.75),('16273','2013-05-10','12:20:00',3.04),('16273','2013-05-10','12:25:00',4.41),('16273','2013-05-10','12:30:00',4.82),('16273','2013-05-10','12:35:00',4.41),('16273','2013-05-10','12:40:00',3.7),('16273','2013-05-10','12:45:00',4.13),('16273','2013-05-10','12:50:00',3.89),('16273','2013-05-10','12:55:00',3.5),('16273','2013-05-10','13:00:00',4.57),('16273','2013-05-10','13:05:00',4.57),('16273','2013-05-10','13:10:00',2.62),('16273','2013-05-10','13:15:00',3.63),('16273','2013-05-10','13:20:00',4.53),('16273','2013-05-10','13:25:00',4.75),('16273','2013-05-10','13:30:00',4.18),('16273','2013-05-10','13:35:00',2.66),('16273','2013-05-10','13:40:00',2.05),('16273','2013-05-10','13:45:00',1.96),('16273','2013-05-10','13:50:00',2.02),('16273','2013-05-10','13:55:00',2.39),('16273','2013-05-10','14:00:00',2.75),('16273','2013-05-10','14:05:00',2.9),('16273','2013-05-10','14:10:00',2.74),('16273','2013-05-10','14:15:00',2.35),('16273','2013-05-10','14:20:00',2.2),('16273','2013-05-10','14:25:00',2.34),('16273','2013-05-10','14:30:00',1.94),('16273','2013-05-10','14:35:00',1.57),('16273','2013-05-10','14:40:00',1.33),('16273','2013-05-10','14:45:00',1.25),('16273','2013-05-10','14:50:00',1.46),('16273','2013-05-10','14:55:00',2.07),('16273','2013-05-10','15:00:00',3.12),('16273','2013-05-10','15:05:00',2.47),('16273','2013-05-10','15:10:00',2.07),('16273','2013-05-10','15:15:00',1.97),('16273','2013-05-10','15:20:00',2.08),('16273','2013-05-10','15:25:00',2.36),('16273','2013-05-10','15:30:00',2.38),('16273','2013-05-10','15:35:00',2.09),('16273','2013-05-10','15:40:00',1.86),('16273','2013-05-10','15:45:00',1.78),('16273','2013-05-10','15:50:00',1.73),('16273','2013-05-10','15:55:00',1.62),('16273','2013-05-10','16:00:00',1.55),('16273','2013-05-10','16:05:00',1.6),('16273','2013-05-10','16:10:00',1.6),('16273','2013-05-10','16:15:00',1.98),('16273','2013-05-10','16:20:00',1.74),('16273','2013-05-10','16:25:00',1.65),('16273','2013-05-10','16:30:00',1.6),('16273','2013-05-10','16:35:00',1.49),('16273','2013-05-10','16:40:00',1.24),('16273','2013-05-10','16:55:00',1.13),('16273','2013-05-10','17:00:00',1.6),('16273','2013-05-10','17:05:00',1.73),('16273','2013-05-10','17:10:00',2.07),('16273','2013-05-10','17:15:00',2.57),('16273','2013-05-10','17:20:00',2.26),('16273','2013-05-10','17:25:00',1.79),('16273','2013-05-10','17:35:00',1.22),('16273','2013-05-09','07:15:00',1.04),('16273','2013-05-09','07:20:00',1.01),('16273','2013-05-09','07:25:00',1.26),('16273','2013-05-09','07:30:00',1.35),('16273','2013-05-09','07:35:00',1.45),('16273','2013-05-09','07:40:00',1.53),('16273','2013-05-09','07:45:00',1.63),('16273','2013-05-09','07:50:00',1.71),('16273','2013-05-09','07:55:00',1.79),('16273','2013-05-09','08:00:00',1.87),('16273','2013-05-09','08:05:00',1.95),('16273','2013-05-09','08:10:00',2.05),('16273','2013-05-09','08:15:00',2.13),('16273','2013-05-09','08:20:00',2.21),('16273','2013-05-09','08:25:00',2.28),('16273','2013-05-09','08:30:00',2.36),('16273','2013-05-09','08:35:00',2.43),('16273','2013-05-09','08:40:00',2.5),('16273','2013-05-09','08:45:00',2.59),('16273','2013-05-09','08:50:00',2.66),('16273','2013-05-09','08:55:00',2.73),('16273','2013-05-09','09:00:00',2.79),('16273','2013-05-09','09:05:00',2.88),('16273','2013-05-09','09:10:00',2.94),('16273','2013-05-09','09:15:00',3),('16273','2013-05-09','09:20:00',3.06),('16273','2013-05-09','09:25:00',3.13),('16273','2013-05-09','09:30:00',3.19),('16273','2013-05-09','09:35:00',3.22),('16273','2013-05-09','09:40:00',3.31),('16273','2013-05-09','09:45:00',3.33),('16273','2013-05-09','09:50:00',3.39),('16273','2013-05-09','09:55:00',3.41),('16273','2013-05-09','10:00:00',3.48),('16273','2013-05-09','10:05:00',3.53),('16273','2013-05-09','10:10:00',3.58),('16273','2013-05-09','10:15:00',3.59),('16273','2013-05-09','10:20:00',3.62),('16273','2013-05-09','10:25:00',3.65),('16273','2013-05-09','10:30:00',3.69),('16273','2013-05-09','10:35:00',3.69),('16273','2013-05-09','10:40:00',3.72),('16273','2013-05-09','10:45:00',3.77),('16273','2013-05-09','10:50:00',3.79),('16273','2013-05-09','10:55:00',3.81),('16273','2013-05-09','11:00:00',3.83),('16273','2013-05-09','11:05:00',3.84),('16273','2013-05-09','11:10:00',3.85),('16273','2013-05-09','11:15:00',3.88),('16273','2013-05-09','11:20:00',3.87),('16273','2013-05-09','11:25:00',3.91),('16273','2013-05-09','11:30:00',3.96),('16273','2013-05-09','11:35:00',4.01),('16273','2013-05-09','11:40:00',3.99),('16273','2013-05-09','11:45:00',4),('16273','2013-05-09','11:50:00',3.96),('16273','2013-05-09','11:55:00',4.03),('16273','2013-05-09','12:00:00',4.17),('16273','2013-05-09','12:05:00',2.51),('16273','2013-05-09','12:10:00',1.79),('16273','2013-05-09','12:25:00',1.5),('16273','2013-05-09','12:30:00',4.51),('16273','2013-05-09','12:35:00',4.41),('16273','2013-05-09','12:40:00',4.28),('16273','2013-05-09','12:45:00',4.28),('16273','2013-05-09','12:50:00',4.18),('16273','2013-05-09','12:55:00',4.07),('16273','2013-05-09','13:00:00',3.53),('16273','2013-05-09','13:05:00',3.63),('16273','2013-05-09','13:10:00',2.13),('16273','2013-05-09','13:15:00',2.81),('16273','2013-05-09','13:20:00',1.75),('16273','2013-05-09','13:25:00',1.39),('16273','2013-05-09','13:30:00',4.05),('16273','2013-05-09','13:35:00',3.82),('16273','2013-05-09','13:40:00',4.3),('16273','2013-05-09','13:45:00',3.47),('16273','2013-05-09','13:50:00',2.23),('16273','2013-05-09','13:55:00',2.35),('16273','2013-05-09','14:00:00',2.75),('16273','2013-05-09','14:05:00',4.1),('16273','2013-05-09','14:10:00',3.88),('16273','2013-05-09','14:15:00',3.76),('16273','2013-05-09','14:20:00',3.72),('16273','2013-05-09','14:25:00',3.67),('16273','2013-05-09','14:30:00',3.6),('16273','2013-05-09','14:35:00',3.58),('16273','2013-05-09','14:40:00',3.36),('16273','2013-05-09','14:45:00',3.33),('16273','2013-05-09','14:50:00',3.45),('16273','2013-05-09','14:55:00',3.43),('16273','2013-05-09','15:00:00',3.39),('16273','2013-05-09','15:05:00',3.37),('16273','2013-05-09','15:10:00',3.32),('16273','2013-05-09','15:15:00',3.22),('16273','2013-05-09','15:20:00',3.19),('16273','2013-05-09','15:25:00',3.09),('16273','2013-05-09','15:30:00',3.04),('16273','2013-05-09','15:35:00',3.02),('16273','2013-05-09','15:40:00',2.95),('16273','2013-05-09','15:45:00',2.91),('16273','2013-05-09','15:50:00',2.83),('16273','2013-05-09','15:55:00',2.75),('16273','2013-05-09','16:00:00',2.68),('16273','2013-05-09','16:05:00',2.61),('16273','2013-05-09','16:10:00',2.53),('16273','2013-05-09','16:15:00',2.46),('16273','2013-05-09','16:20:00',2.39),('16273','2013-05-09','16:25:00',2.33),('16273','2013-05-09','16:30:00',2.25),('16273','2013-05-09','16:35:00',2.17),('16273','2013-05-09','16:40:00',2.08),('16273','2013-05-09','16:45:00',2.02),('16273','2013-05-09','16:50:00',1.95),('16273','2013-05-09','16:55:00',1.86),('16273','2013-05-09','17:00:00',1.78),('16273','2013-05-09','17:05:00',1.7),('16273','2013-05-09','17:10:00',1.62),('16273','2013-05-09','17:15:00',1.55),('16273','2013-05-09','17:20:00',1.47),('16273','2013-05-09','17:25:00',1.39),('16273','2013-05-09','17:30:00',1.3),('16273','2013-05-09','17:35:00',1.22),('16273','2013-05-09','17:40:00',1.14),('16273','2013-05-09','17:45:00',1.07),('16273','2013-05-09','17:50:00',1),('16273','2013-05-08','07:35:00',1.3),('16273','2013-05-08','07:45:00',1.55),('16273','2013-05-08','07:50:00',1.66),('16273','2013-05-08','07:55:00',1.72),('16273','2013-05-08','08:00:00',1.73),('16273','2013-05-08','08:05:00',1.84),('16273','2013-05-08','08:10:00',2),('16273','2013-05-08','08:15:00',2.1),('16273','2013-05-08','08:20:00',2.15),('16273','2013-05-08','08:25:00',2.17),('16273','2013-05-08','08:30:00',2.34),('16273','2013-05-08','08:35:00',2.24),('16273','2013-05-08','08:40:00',2.44),('16273','2013-05-08','08:50:00',2.56),('16273','2013-05-08','08:55:00',2.37),('16273','2013-05-08','09:00:00',1.57),('16273','2013-05-08','09:20:00',2.02),('16273','2013-05-08','09:25:00',3.56),('16273','2013-05-08','09:30:00',3.58),('16273','2013-05-08','09:35:00',3.67),('16273','2013-05-08','09:40:00',3.21),('16273','2013-05-08','09:45:00',3.64),('16273','2013-05-08','09:50:00',1.4),('16273','2013-05-08','10:25:00',1.47),('16273','2013-05-08','10:30:00',3.82),('16273','2013-05-08','10:35:00',3.83),('16273','2013-05-08','10:40:00',2.26),('16273','2013-05-08','10:45:00',2.96),('16273','2013-05-08','10:50:00',3.81),('16273','2013-05-08','10:55:00',4.45),('16273','2013-05-08','11:00:00',3.86),('16273','2013-05-08','11:05:00',4.14),('16273','2013-05-08','11:10:00',1.96),('16273','2013-05-08','11:15:00',1.08),('16273','2013-05-08','11:25:00',2.29),('16273','2013-05-08','11:30:00',4.7),('16273','2013-05-08','11:35:00',4.48),('16273','2013-05-08','11:40:00',4.74),('16273','2013-05-08','11:45:00',2.28),('16273','2013-05-08','11:50:00',3.69),('16273','2013-05-08','11:55:00',3.36),('16273','2013-05-08','12:00:00',2.63),('16273','2013-05-08','12:05:00',4),('16273','2013-05-08','12:10:00',1.84),('16273','2013-05-08','12:15:00',1.7),('16273','2013-05-08','12:20:00',2.64),('16273','2013-05-08','12:25:00',1.2),('16273','2013-05-08','12:30:00',2.69),('16273','2013-05-08','12:35:00',4.64),('16273','2013-05-08','12:40:00',2.97),('16273','2013-05-08','12:45:00',1.5),('16273','2013-05-08','12:50:00',1.86),('16273','2013-05-08','12:55:00',1.99),('16273','2013-05-08','13:00:00',1.84),('16273','2013-05-08','13:05:00',2.34),('16273','2013-05-08','13:10:00',1.68),('16273','2013-05-08','13:15:00',1.55),('16273','2013-05-08','13:20:00',2.83),('16273','2013-05-08','13:25:00',4.9),('16273','2013-05-08','13:30:00',2.07),('16273','2013-05-08','13:35:00',1.38),('16273','2013-05-08','13:40:00',1.59),('16273','2013-05-08','13:45:00',4.22),('16273','2013-05-08','13:50:00',3.6),('16273','2013-05-08','13:55:00',1.64),('16273','2013-05-08','14:00:00',3.67),('16273','2013-05-08','14:05:00',3.96),('16273','2013-05-08','14:10:00',3.52),('16273','2013-05-08','14:15:00',4.06),('16273','2013-05-08','14:20:00',3.98),('16273','2013-05-08','14:25:00',3.87),('16273','2013-05-08','14:30:00',2.42),('16273','2013-05-08','14:35:00',2.45),('16273','2013-05-08','14:40:00',2.63),('16273','2013-05-08','14:45:00',3.59),('16273','2013-05-08','14:50:00',3.93),('16273','2013-05-08','14:55:00',3.45),('16273','2013-05-08','15:00:00',2.41),('16273','2013-05-08','15:05:00',3.34),('16273','2013-05-08','15:10:00',1.95),('16273','2013-05-08','15:15:00',2.89),('16273','2013-05-08','15:20:00',3.36),('16273','2013-05-08','15:25:00',3.21),('16273','2013-05-08','15:30:00',3.12),('16273','2013-05-08','15:35:00',3.06),('16273','2013-05-08','15:40:00',2.99),('16273','2013-05-08','15:45:00',2.9),('16273','2013-05-08','15:50:00',2.85),('16273','2013-05-08','15:55:00',2.8),('16273','2013-05-08','16:00:00',2.72),('16273','2013-05-08','16:05:00',2.65),('16273','2013-05-08','16:10:00',2.57),('16273','2013-05-08','16:15:00',2.49),('16273','2013-05-08','16:20:00',2.44),('16273','2013-05-08','16:25:00',2.38),('16273','2013-05-08','16:30:00',2.33),('16273','2013-05-08','16:35:00',2.34),('16273','2013-05-08','16:40:00',2.13),('16273','2013-05-08','16:45:00',1.75),('16273','2013-05-08','16:50:00',2.23),('16273','2013-05-08','16:55:00',2.05),('16273','2013-05-08','17:00:00',1.92),('16273','2013-05-08','17:05:00',1.43),('16273','2013-05-08','17:10:00',1.56),('16273','2013-05-08','17:15:00',1.46),('16273','2013-05-08','17:20:00',1.09),('16273','2013-05-08','17:25:00',1.09),('16273','2013-05-08','17:30:00',1.18),('16273','2013-05-08','17:35:00',1.15),('16273','2013-05-08','17:40:00',1.3),('16273','2013-05-08','17:45:00',1.24),('16273','2013-05-08','17:50:00',1.27),('16273','2013-05-08','17:55:00',1.31),('16273','2013-05-08','18:00:00',1.34),('16273','2013-05-08','18:05:00',1.3),('16273','2013-05-08','18:10:00',1.15),('16273','2013-05-07','07:20:00',1.06),('16273','2013-05-07','07:25:00',1.25),('16273','2013-05-07','07:30:00',1.35),('16273','2013-05-07','07:35:00',1.46),('16273','2013-05-07','07:40:00',1.47),('16273','2013-05-07','07:45:00',1.55),('16273','2013-05-07','07:50:00',1.66),('16273','2013-05-07','07:55:00',1.75),('16273','2013-05-07','08:00:00',1.86),('16273','2013-05-07','08:05:00',1.96),('16273','2013-05-07','08:10:00',2.06),('16273','2013-05-07','08:15:00',2.13),('16273','2013-05-07','08:20:00',2.21),('16273','2013-05-07','08:25:00',2.31),('16273','2013-05-07','08:30:00',2.39),('16273','2013-05-07','08:35:00',2.51),('16273','2013-05-07','08:40:00',2.53),('16273','2013-05-07','08:45:00',2.7),('16273','2013-05-07','08:50:00',2.92),('16273','2013-05-07','08:55:00',3.01),('16273','2013-05-07','09:00:00',1.85),('16273','2013-05-07','09:05:00',3.14),('16273','2013-05-07','09:10:00',1.34),('16273','2013-05-07','09:50:00',2.74),('16273','2013-05-07','09:55:00',3.77),('16273','2013-05-07','10:00:00',3.77),('16273','2013-05-07','10:05:00',3.9),('16273','2013-05-07','10:10:00',2.64),('16273','2013-05-07','10:15:00',1.09),('16273','2013-05-07','10:20:00',1.05),('16273','2013-05-07','10:45:00',1.03),('16273','2013-05-07','10:50:00',1.11),('16273','2013-05-07','10:55:00',2.3),('16273','2013-05-07','11:00:00',1.93),('16273','2013-05-07','11:15:00',2.27),('16273','2013-05-07','11:20:00',4.58),('16273','2013-05-07','11:25:00',4.48),('16273','2013-05-07','11:30:00',4.56),('16273','2013-05-07','11:35:00',4.07),('16273','2013-05-07','11:40:00',4.37),('16273','2013-05-07','11:45:00',4.84),('16273','2013-05-07','11:50:00',4.05),('16273','2013-05-07','11:55:00',3.91),('16273','2013-05-07','12:00:00',2.84),('16273','2013-05-07','12:05:00',3.78),('16273','2013-05-07','12:10:00',4.94),('16273','2013-05-07','12:15:00',4.65),('16273','2013-05-07','12:20:00',4.76),('16273','2013-05-07','12:25:00',1.55),('16273','2013-05-07','12:30:00',2.13),('16273','2013-05-07','12:35:00',4.24),('16273','2013-05-07','12:40:00',2.65),('16273','2013-05-07','12:45:00',3.15),('16273','2013-05-07','12:50:00',4.47),('16273','2013-05-07','12:55:00',3.02),('16273','2013-05-07','13:00:00',3.98),('16273','2013-05-07','13:05:00',3.06),('16273','2013-05-07','13:10:00',3.75),('16273','2013-05-07','13:15:00',4.62),('16273','2013-05-07','13:20:00',4.16),('16273','2013-05-07','13:25:00',4.25),('16273','2013-05-07','13:30:00',3.12),('16273','2013-05-07','13:35:00',3.53),('16273','2013-05-07','13:40:00',3.09),('16273','2013-05-07','13:45:00',4.35),('16273','2013-05-07','13:50:00',3.12),('16273','2013-05-07','13:55:00',3.24),('16273','2013-05-07','14:00:00',3.42),('16273','2013-05-07','14:05:00',4.34),('16273','2013-05-07','14:10:00',3.74),('16273','2013-05-07','14:15:00',3.66),('16273','2013-05-07','14:20:00',3.32),('16273','2013-05-07','14:25:00',3.54),('16273','2013-05-07','14:30:00',3.99),('16273','2013-05-07','14:35:00',3.92),('16273','2013-05-07','14:40:00',3.88),('16273','2013-05-07','14:45:00',3.46),('16273','2013-05-07','14:50:00',3.54),('16273','2013-05-07','14:55:00',2.35),('16273','2013-05-07','15:00:00',1.22),('16273','2013-05-07','15:05:00',1.71),('16273','2013-05-07','15:10:00',1.06),('16273','2013-05-07','15:15:00',1.75),('16273','2013-05-07','15:20:00',2.51),('16273','2013-05-07','15:25:00',2.15),('16273','2013-05-07','15:30:00',3.93),('16273','2013-05-07','15:35:00',2.58),('16273','2013-05-07','15:40:00',2.91),('16273','2013-05-07','15:45:00',2.25),('16273','2013-05-07','15:50:00',3.45),('16273','2013-05-07','15:55:00',3.85),('16273','2013-05-07','16:00:00',3.21),('16273','2013-05-07','16:05:00',2.57),('16273','2013-05-07','16:10:00',2.41),('16273','2013-05-07','16:15:00',2.64),('16273','2013-05-07','16:20:00',2.86),('16273','2013-05-07','16:25:00',2.81),('16273','2013-05-07','16:30:00',2.8),('16273','2013-05-07','16:35:00',2.43),('16273','2013-05-07','16:40:00',2.3),('16273','2013-05-07','16:45:00',1.35),('16273','2013-05-07','16:50:00',1.98),('16273','2013-05-07','16:55:00',2.1),('16273','2013-05-07','17:00:00',1.16),('16273','2013-05-07','17:05:00',1.13),('16273','2013-05-07','17:10:00',1.24),('16273','2013-05-07','17:15:00',1.2),('16273','2013-05-07','17:20:00',1.24),('16273','2013-05-07','17:25:00',1.18),('16273','2013-05-06','08:20:00',1.22),('16273','2013-05-06','08:25:00',1.31),('16273','2013-05-06','08:30:00',1.2),('16273','2013-05-06','08:35:00',1.34),('16273','2013-05-06','08:40:00',1.37),('16273','2013-05-06','08:45:00',1.74),('16273','2013-05-06','08:50:00',1.42),('16273','2013-05-06','08:55:00',1.42),('16273','2013-05-06','09:00:00',1.53),('16273','2013-05-06','09:05:00',1.02),('16273','2013-05-06','09:25:00',1.08),('16273','2013-05-06','09:30:00',1.11),('16273','2013-05-06','09:35:00',1.03),('16273','2013-05-06','09:50:00',1.07),('16273','2013-05-06','09:55:00',1.24),('16273','2013-05-06','10:00:00',1.48),('16273','2013-05-06','10:05:00',1.7),('16273','2013-05-06','10:10:00',1.8),('16273','2013-05-06','10:15:00',1.92),('16273','2013-05-06','10:20:00',2.45),('16273','2013-05-06','10:25:00',1.91),('16273','2013-05-06','10:30:00',1.63),('16273','2013-05-06','10:35:00',1.43),('16273','2013-05-06','10:40:00',1.49),('16273','2013-05-06','10:45:00',1.57),('16273','2013-05-06','10:50:00',1.28),('16273','2013-05-06','11:05:00',1.28),('16273','2013-05-06','11:10:00',1.33),('16273','2013-05-06','11:20:00',1.44),('16273','2013-05-06','11:25:00',2.84),('16273','2013-05-06','11:30:00',1.38),('16273','2013-05-06','11:40:00',1.12),('16273','2013-05-06','11:45:00',1.01),('16273','2013-05-06','11:50:00',2.14),('16273','2013-05-06','11:55:00',1.9),('16273','2013-05-06','12:00:00',1.83),('16273','2013-05-06','12:05:00',2.52),('16273','2013-05-06','12:10:00',4),('16273','2013-05-06','12:15:00',2.05),('16273','2013-05-06','12:20:00',3.69),('16273','2013-05-06','12:25:00',3.73),('16273','2013-05-06','12:30:00',3.49),('16273','2013-05-06','12:35:00',3.97),('16273','2013-05-06','12:40:00',3.74),('16273','2013-05-06','12:45:00',4.64),('16273','2013-05-06','12:50:00',3.16),('16273','2013-05-06','12:55:00',3.52),('16273','2013-05-06','13:00:00',2.74),('16273','2013-05-06','13:05:00',3.37),('16273','2013-05-06','13:10:00',3.66),('16273','2013-05-06','13:15:00',2.75),('16273','2013-05-06','13:20:00',3.7),('16273','2013-05-06','13:25:00',3.66),('16273','2013-05-06','13:30:00',4.04),('16273','2013-05-06','13:35:00',1.64),('16273','2013-05-06','13:40:00',2.18),('16273','2013-05-06','13:45:00',1.73),('16273','2013-05-06','13:50:00',1.65),('16273','2013-05-06','13:55:00',4.34),('16273','2013-05-06','14:00:00',2.77),('16273','2013-05-06','14:05:00',3.22),('16273','2013-05-06','14:10:00',3.67),('16273','2013-05-06','14:15:00',4.37),('16273','2013-05-06','14:20:00',2.37),('16273','2013-05-06','14:25:00',3.07),('16273','2013-05-06','14:30:00',3.1),('16273','2013-05-06','14:35:00',2.27),('16273','2013-05-06','14:40:00',3.61),('16273','2013-05-06','14:45:00',3.05),('16273','2013-05-06','14:50:00',2.74),('16273','2013-05-06','14:55:00',2.65),('16273','2013-05-06','15:00:00',2.35),('16273','2013-05-06','15:05:00',2.55),('16273','2013-05-06','15:10:00',2.47),('16273','2013-05-06','15:15:00',3.35),('16273','2013-05-06','15:20:00',1.93),('16273','2013-05-06','15:25:00',1.92),('16273','2013-05-06','15:30:00',2.02),('16273','2013-05-06','15:35:00',2.22),('16273','2013-05-06','15:40:00',2.71),('16273','2013-05-06','15:45:00',2.6),('16273','2013-05-06','15:50:00',1.36),('16273','2013-05-06','15:55:00',2.13),('16273','2013-05-06','16:00:00',2.51),('16273','2013-05-06','16:05:00',2.05),('16273','2013-05-06','16:10:00',1.76),('16273','2013-05-06','16:15:00',1.78),('16273','2013-05-06','16:20:00',1.03),('16273','2013-05-06','16:25:00',1.08),('16273','2013-05-06','16:30:00',2.02),('16273','2013-05-06','16:35:00',2.69),('16273','2013-05-06','16:40:00',1.09),('16273','2013-05-06','16:45:00',1.13),('16273','2013-05-06','16:55:00',1.04),('16273','2013-05-06','17:00:00',1.38),('16273','2013-05-06','17:05:00',1.3),('16273','2013-05-06','17:15:00',1.17),('16273','2013-05-06','17:20:00',1.48),('16273','2013-05-06','17:25:00',2.11),('16273','2013-05-06','17:30:00',1.86),('16273','2013-05-06','17:35:00',1.44),('16273','2013-05-05','07:35:00',1.12),('16273','2013-05-05','07:40:00',1.29),('16273','2013-05-05','07:45:00',1.38),('16273','2013-05-05','07:50:00',1.42),('16273','2013-05-05','07:55:00',1.44),('16273','2013-05-05','08:00:00',1.55),('16273','2013-05-05','08:05:00',1.57),('16273','2013-05-05','08:10:00',1.79),('16273','2013-05-05','08:15:00',1.95),('16273','2013-05-05','08:20:00',1.84),('16273','2013-05-05','08:25:00',1.14),('16273','2013-05-05','08:30:00',1.1),('16273','2013-05-05','08:35:00',1.54),('16273','2013-05-05','08:40:00',2),('16273','2013-05-05','08:45:00',1.72),('16273','2013-05-05','08:50:00',1.82),('16273','2013-05-05','08:55:00',1.75),('16273','2013-05-05','09:00:00',1.65),('16273','2013-05-05','09:05:00',1.61),('16273','2013-05-05','09:10:00',1.5),('16273','2013-05-05','09:15:00',1.65),('16273','2013-05-05','09:20:00',2.11),('16273','2013-05-05','09:25:00',1.78),('16273','2013-05-05','09:30:00',2.18),('16273','2013-05-05','09:35:00',2.04),('16273','2013-05-05','09:40:00',2.3),('16273','2013-05-05','09:45:00',3.37),('16273','2013-05-05','09:50:00',1.67),('16273','2013-05-05','09:55:00',1.27),('16273','2013-05-05','10:00:00',1.15),('16273','2013-05-05','10:05:00',1.24),('16273','2013-05-05','10:10:00',1.41),('16273','2013-05-05','10:15:00',1.46),('16273','2013-05-05','10:20:00',1.81),('16273','2013-05-05','10:25:00',1.9),('16273','2013-05-05','10:30:00',1.52),('16273','2013-05-05','10:35:00',1.29),('16273','2013-05-05','10:40:00',1.16),('16273','2013-05-05','10:50:00',1.05),('16273','2013-05-05','10:55:00',1.24),('16273','2013-05-05','11:00:00',1.41),('16273','2013-05-05','11:05:00',2.5),('16273','2013-05-05','11:10:00',4.06),('16273','2013-05-05','11:15:00',2.36),('16273','2013-05-05','11:20:00',3.52),('16273','2013-05-05','11:25:00',3.47),('16273','2013-05-05','11:30:00',3.02),('16273','2013-05-05','11:35:00',2.47),('16273','2013-05-05','11:40:00',2.25),('16273','2013-05-05','11:45:00',2.79),('16273','2013-05-05','11:50:00',3.12),('16273','2013-05-05','11:55:00',3.74),('16273','2013-05-05','12:00:00',2.78),('16273','2013-05-05','12:05:00',4.53),('16273','2013-05-05','12:10:00',4.31),('16273','2013-05-05','12:15:00',4.18),('16273','2013-05-05','12:20:00',4.19),('16273','2013-05-05','12:25:00',3.93),('16273','2013-05-05','12:30:00',4.23),('16273','2013-05-05','12:35:00',3.92),('16273','2013-05-05','12:40:00',3.77),('16273','2013-05-05','12:45:00',2.38),('16273','2013-05-05','12:50:00',3.48),('16273','2013-05-05','12:55:00',1.87),('16273','2013-05-05','13:00:00',1.32),('16273','2013-05-05','13:05:00',2.45),('16273','2013-05-05','13:10:00',4.24),('16273','2013-05-05','13:15:00',3.07),('16273','2013-05-05','13:20:00',3.46),('16273','2013-05-05','13:25:00',4.08),('16273','2013-05-05','13:30:00',2.83),('16273','2013-05-05','13:35:00',2.98),('16273','2013-05-05','13:40:00',3.67),('16273','2013-05-05','13:45:00',2.96),('16273','2013-05-05','13:50:00',2.64),('16273','2013-05-05','13:55:00',2.76),('16273','2013-05-05','14:00:00',3.3),('16273','2013-05-05','14:05:00',3.61),('16273','2013-05-05','14:10:00',3.21),('16273','2013-05-05','14:15:00',3.82),('16273','2013-05-05','14:20:00',3.29),('16273','2013-05-05','14:25:00',3.41),('16273','2013-05-05','14:30:00',3.43),('16273','2013-05-05','14:35:00',3.4),('16273','2013-05-05','14:40:00',3.37),('16273','2013-05-05','14:45:00',3.31),('16273','2013-05-05','14:50:00',3.27),('16273','2013-05-05','14:55:00',3.25),('16273','2013-05-05','15:00:00',3.18),('16273','2013-05-05','15:05:00',3.15),('16273','2013-05-05','15:10:00',3.08),('16273','2013-05-05','15:15:00',3.03),('16273','2013-05-05','15:20:00',2.99),('16273','2013-05-05','15:25:00',2.94),('16273','2013-05-05','15:30:00',2.88),('16273','2013-05-05','15:35:00',2.8),('16273','2013-05-05','15:40:00',2.74),('16273','2013-05-05','15:45:00',2.68),('16273','2013-05-05','15:50:00',2.63),('16273','2013-05-05','15:55:00',2.56),('16273','2013-05-05','16:00:00',2.5),('16273','2013-05-05','16:05:00',2.45),('16273','2013-05-05','16:10:00',2.38),('16273','2013-05-05','16:15:00',2.33),('16273','2013-05-05','16:20:00',2.27),('16273','2013-05-05','16:25:00',2.21),('16273','2013-05-05','16:30:00',2.13),('16273','2013-05-05','16:35:00',2.07),('16273','2013-05-05','16:40:00',1.98),('16273','2013-05-05','16:45:00',1.91),('16273','2013-05-05','16:50:00',1.85),('16273','2013-05-05','16:55:00',1.76),('16273','2013-05-05','17:00:00',1.68),('16273','2013-05-05','17:05:00',1.6),('16273','2013-05-05','17:10:00',1.52),('16273','2013-05-05','17:15:00',1.46),('16273','2013-05-05','17:20:00',1.38),('16273','2013-05-05','17:25:00',1.29),('16273','2013-05-05','17:30:00',1.23),('16273','2013-05-05','17:35:00',1.16),('16273','2013-05-05','17:40:00',1.09),('16273','2013-05-05','17:45:00',1.02),('16273','2013-05-04','07:35:00',1.03),('16273','2013-05-04','07:40:00',1.35),('16273','2013-05-04','07:45:00',1.45),('16273','2013-05-04','07:50:00',1.5),('16273','2013-05-04','07:55:00',1.59),('16273','2013-05-04','08:00:00',1.69),('16273','2013-05-04','08:05:00',1.77),('16273','2013-05-04','08:10:00',1.84),('16273','2013-05-04','08:15:00',1.92),('16273','2013-05-04','08:20:00',1.99),('16273','2013-05-04','08:25:00',2.06),('16273','2013-05-04','08:30:00',2.15),('16273','2013-05-04','08:35:00',2.21),('16273','2013-05-04','08:40:00',2.3),('16273','2013-05-04','08:45:00',2.37),('16273','2013-05-04','08:50:00',2.45),('16273','2013-05-04','08:55:00',2.48),('16273','2013-05-04','09:00:00',2.58),('16273','2013-05-04','09:05:00',2.65),('16273','2013-05-04','09:10:00',2.62),('16273','2013-05-04','09:15:00',2.72),('16273','2013-05-04','09:20:00',2.77),('16273','2013-05-04','09:25:00',2.83),('16273','2013-05-04','09:30:00',2.89),('16273','2013-05-04','09:35:00',2.92),('16273','2013-05-04','09:40:00',2.98),('16273','2013-05-04','09:45:00',3.02),('16273','2013-05-04','09:50:00',3.11),('16273','2013-05-04','09:55:00',2.98),('16273','2013-05-04','10:00:00',3.21),('16273','2013-05-04','10:05:00',3.23),('16273','2013-05-04','10:10:00',3.29),('16273','2013-05-04','10:15:00',3.34),('16273','2013-05-04','10:20:00',3.4),('16273','2013-05-04','10:25:00',3.41),('16273','2013-05-04','10:30:00',3.43),('16273','2013-05-04','10:35:00',3.38),('16273','2013-05-04','10:40:00',3.31),('16273','2013-05-04','10:45:00',3.29),('16273','2013-05-04','10:50:00',3.46),('16273','2013-05-04','10:55:00',3.54),('16273','2013-05-04','11:00:00',3.61),('16273','2013-05-04','11:05:00',3.61),('16273','2013-05-04','11:10:00',3.41),('16273','2013-05-04','11:15:00',3.15),('16273','2013-05-04','11:20:00',3.5),('16273','2013-05-04','11:25:00',3.49),('16273','2013-05-04','11:30:00',3.33),('16273','2013-05-04','11:35:00',3.36),('16273','2013-05-04','11:40:00',3.38),('16273','2013-05-04','11:45:00',3.29),('16273','2013-05-04','11:50:00',3.25),('16273','2013-05-04','11:55:00',3.37),('16273','2013-05-04','12:00:00',3.39),('16273','2013-05-04','12:05:00',3.29),('16273','2013-05-04','12:10:00',3.57),('16273','2013-05-04','12:15:00',3.65),('16273','2013-05-04','12:20:00',3.7),('16273','2013-05-04','12:25:00',3.75),('16273','2013-05-04','12:30:00',3.75),('16273','2013-05-04','12:35:00',3.68),('16273','2013-05-04','12:40:00',3.65),('16273','2013-05-04','12:45:00',3.67),('16273','2013-05-04','12:50:00',3.61),('16273','2013-05-04','12:55:00',3.5),('16273','2013-05-04','13:00:00',3.53),('16273','2013-05-04','13:05:00',3.54),('16273','2013-05-04','13:10:00',3.47),('16273','2013-05-04','13:15:00',3.65),('16273','2013-05-04','13:20:00',3.7),('16273','2013-05-04','13:25:00',3.6),('16273','2013-05-04','13:30:00',3.27),('16273','2013-05-04','13:35:00',3.54),('16273','2013-05-04','13:40:00',3.41),('16273','2013-05-04','13:45:00',3.08),('16273','2013-05-04','13:50:00',2.93),('16273','2013-05-04','13:55:00',3.37),('16273','2013-05-04','14:00:00',3.27),('16273','2013-05-04','14:05:00',3.17),('16273','2013-05-04','14:10:00',3.35),('16273','2013-05-04','14:15:00',3.16),('16273','2013-05-04','14:20:00',3.16),('16273','2013-05-04','14:25:00',3.09),('16273','2013-05-04','14:30:00',3.09),('16273','2013-05-04','14:35:00',3.01),('16273','2013-05-04','14:40:00',3.11),('16273','2013-05-04','14:45:00',2.89),('16273','2013-05-04','14:50:00',2.87),('16273','2013-05-04','14:55:00',3),('16273','2013-05-04','15:00:00',2.94),('16273','2013-05-04','15:05:00',2.8),('16273','2013-05-04','15:10:00',2.91),('16273','2013-05-04','15:15:00',2.92),('16273','2013-05-04','15:20:00',2.96),('16273','2013-05-04','15:25:00',2.89),('16273','2013-05-04','15:30:00',2.83),('16273','2013-05-04','15:35:00',2.65),('16273','2013-05-04','15:40:00',2.74),('16273','2013-05-04','15:45:00',2.67),('16273','2013-05-04','15:50:00',2.6),('16273','2013-05-04','15:55:00',2.53),('16273','2013-05-04','16:00:00',2.47),('16273','2013-05-04','16:05:00',2.4),('16273','2013-05-04','16:10:00',2.34),('16273','2013-05-04','16:15:00',2.28),('16273','2013-05-04','16:20:00',2.22),('16273','2013-05-04','16:25:00',2.15),('16273','2013-05-04','16:30:00',2.08),('16273','2013-05-04','16:35:00',2),('16273','2013-05-04','16:40:00',1.92),('16273','2013-05-04','16:45:00',1.85),('16273','2013-05-04','16:50:00',1.79),('16273','2013-05-04','16:55:00',1.71),('16273','2013-05-04','17:00:00',1.64),('16273','2013-05-04','17:05:00',1.58),('16273','2013-05-04','17:10:00',1.39),('16273','2013-05-04','17:15:00',1.41),('16273','2013-05-04','17:20:00',1.36),('16273','2013-05-04','17:25:00',1.29),('16273','2013-05-04','17:30:00',1.18),('16273','2013-05-04','17:35:00',1.12),('16273','2013-05-03','08:00:00',1.03),('16273','2013-05-03','08:05:00',1.32),('16273','2013-05-03','08:10:00',1.53),('16273','2013-05-03','08:15:00',1.48),('16273','2013-05-03','08:20:00',1.85),('16273','2013-05-03','08:25:00',1.67),('16273','2013-05-03','08:30:00',1.54),('16273','2013-05-03','08:35:00',1.6),('16273','2013-05-03','08:40:00',1.83),('16273','2013-05-03','08:45:00',1.81),('16273','2013-05-03','08:50:00',1.81),('16273','2013-05-03','08:55:00',2.31),('16273','2013-05-03','09:00:00',2.52),('16273','2013-05-03','09:05:00',2.58),('16273','2013-05-03','09:10:00',2.64),('16273','2013-05-03','09:15:00',2.86),('16273','2013-05-03','09:20:00',2.97),('16273','2013-05-03','09:25:00',3.01),('16273','2013-05-03','09:30:00',3.04),('16273','2013-05-03','09:35:00',3.12),('16273','2013-05-03','09:40:00',3.16),('16273','2013-05-03','09:45:00',3.2),('16273','2013-05-03','09:50:00',3.28),('16273','2013-05-03','09:55:00',3.33),('16273','2013-05-03','10:00:00',3.36),('16273','2013-05-03','10:05:00',3.41),('16273','2013-05-03','10:10:00',3.46),('16273','2013-05-03','10:15:00',3.49),('16273','2013-05-03','10:20:00',3.52),('16273','2013-05-03','10:25:00',3.57),('16273','2013-05-03','10:30:00',3.58),('16273','2013-05-03','10:35:00',3.62),('16273','2013-05-03','10:40:00',3.65),('16273','2013-05-03','10:45:00',3.69),('16273','2013-05-03','10:50:00',3.7),('16273','2013-05-03','10:55:00',3.72),('16273','2013-05-03','11:00:00',3.75),('16273','2013-05-03','11:05:00',3.76),('16273','2013-05-03','11:10:00',3.78),('16273','2013-05-03','11:15:00',3.8),('16273','2013-05-03','11:20:00',3.8),('16273','2013-05-03','11:25:00',3.82),('16273','2013-05-03','11:30:00',3.82),('16273','2013-05-03','11:35:00',3.82),('16273','2013-05-03','11:40:00',3.84),('16273','2013-05-03','11:45:00',3.84),('16273','2013-05-03','11:50:00',3.82),('16273','2013-05-03','11:55:00',3.84),('16273','2013-05-03','12:00:00',3.91),('16273','2013-05-03','12:05:00',3.86),('16273','2013-05-03','12:10:00',3.87),('16273','2013-05-03','12:15:00',3.88),('16273','2013-05-03','12:20:00',3.87),('16273','2013-05-03','12:25:00',3.86),('16273','2013-05-03','12:30:00',3.85),('16273','2013-05-03','12:35:00',3.88),('16273','2013-05-03','12:40:00',3.86),('16273','2013-05-03','12:45:00',3.75),('16273','2013-05-03','12:50:00',3.88),('16273','2013-05-03','12:55:00',3.86),('16273','2013-05-03','13:00:00',3.85),('16273','2013-05-03','13:05:00',3.87),('16273','2013-05-03','13:10:00',3.87),('16273','2013-05-03','13:15:00',3.85),('16273','2013-05-03','13:20:00',3.81),('16273','2013-05-03','13:25:00',3.71),('16273','2013-05-03','13:30:00',3.61),('16273','2013-05-03','13:35:00',3.69),('16273','2013-05-03','13:40:00',3.73),('16273','2013-05-03','13:45:00',3.72),('16273','2013-05-03','13:50:00',3.66),('16273','2013-05-03','13:55:00',3.62),('16273','2013-05-03','14:00:00',3.6),('16273','2013-05-03','14:05:00',3.62),('16273','2013-05-03','14:10:00',3.62),('16273','2013-05-03','14:15:00',3.57),('16273','2013-05-03','14:20:00',3.53),('16273','2013-05-03','14:25:00',3.5),('16273','2013-05-03','14:30:00',3.45),('16273','2013-05-03','14:35:00',3.42),('16273','2013-05-03','14:40:00',3.37),('16273','2013-05-03','14:45:00',3.33),('16273','2013-05-03','14:50:00',3.25),('16273','2013-05-03','14:55:00',3.21),('16273','2013-05-03','15:00:00',3.18),('16273','2013-05-03','15:05:00',3.15),('16273','2013-05-03','15:10:00',3.09),('16273','2013-05-03','15:15:00',3.03),('16273','2013-05-03','15:20:00',2.98),('16273','2013-05-03','15:25:00',2.94),('16273','2013-05-03','15:30:00',2.89),('16273','2013-05-03','15:35:00',2.85),('16273','2013-05-03','15:40:00',2.78),('16273','2013-05-03','15:45:00',2.73),('16273','2013-05-03','15:50:00',2.66),('16273','2013-05-03','15:55:00',2.61),('16273','2013-05-03','16:00:00',2.55),('16273','2013-05-03','16:05:00',2.48),('16273','2013-05-03','16:10:00',2.4),('16273','2013-05-03','16:15:00',2.32),('16273','2013-05-03','16:20:00',2.28),('16273','2013-05-03','16:25:00',2.22),('16273','2013-05-03','16:30:00',2.14),('16273','2013-05-03','16:35:00',2.03),('16273','2013-05-03','16:40:00',1.98),('16273','2013-05-03','16:45:00',1.91),('16273','2013-05-03','16:50:00',1.82),('16273','2013-05-03','16:55:00',1.74),('16273','2013-05-03','17:00:00',1.66),('16273','2013-05-03','17:05:00',1.6),('16273','2013-05-03','17:10:00',1.52),('16273','2013-05-03','17:15:00',1.44),('16273','2013-05-03','17:20:00',1.36),('16273','2013-05-03','17:25:00',1.3),('16273','2013-05-03','17:30:00',1.22),('16273','2013-05-03','17:35:00',1.15),('16273','2013-05-03','17:40:00',1.08),('16273','2013-05-03','17:45:00',1.02),('16273','2013-05-02','08:45:00',1.22),('16273','2013-05-02','08:50:00',1.54),('16273','2013-05-02','08:55:00',1.22),('16273','2013-05-02','09:25:00',1.45),('16273','2013-05-02','09:30:00',2),('16273','2013-05-02','09:35:00',1.11),('16273','2013-05-02','09:45:00',1.27),('16273','2013-05-02','09:50:00',1.65),('16273','2013-05-02','09:55:00',1.01),('16273','2013-05-02','10:10:00',1.14),('16273','2013-05-02','10:15:00',1.98),('16273','2013-05-02','10:20:00',1.8),('16273','2013-05-02','10:25:00',1.86),('16273','2013-05-02','10:30:00',2.12),('16273','2013-05-02','10:35:00',4.09),('16273','2013-05-02','10:40:00',3.06),('16273','2013-05-02','10:45:00',2.52),('16273','2013-05-02','10:50:00',2.68),('16273','2013-05-02','10:55:00',3.22),('16273','2013-05-02','11:00:00',3.79),('16273','2013-05-02','11:05:00',2.84),('16273','2013-05-02','11:10:00',3.64),('16273','2013-05-02','11:15:00',3.81),('16273','2013-05-02','11:20:00',3.9),('16273','2013-05-02','11:25:00',3.88),('16273','2013-05-02','11:30:00',3.52),('16273','2013-05-02','11:35:00',3.76),('16273','2013-05-02','11:40:00',3.85),('16273','2013-05-02','11:45:00',3.83),('16273','2013-05-02','11:50:00',3.83),('16273','2013-05-02','11:55:00',3.76),('16273','2013-05-02','12:00:00',3.84),('16273','2013-05-02','12:05:00',3.81),('16273','2013-05-02','12:10:00',3.8),('16273','2013-05-02','12:15:00',3.8),('16273','2013-05-02','12:20:00',3.81),('16273','2013-05-02','12:25:00',3.8),('16273','2013-05-02','12:30:00',3.77),('16273','2013-05-02','12:35:00',3.83),('16273','2013-05-02','12:40:00',3.75),('16273','2013-05-02','12:45:00',3.81),('16273','2013-05-02','12:50:00',3.85),('16273','2013-05-02','12:55:00',3.75),('16273','2013-05-02','13:00:00',3.82),('16273','2013-05-02','13:05:00',3.84),('16273','2013-05-02','13:10:00',3.81),('16273','2013-05-02','13:15:00',3.82),('16273','2013-05-02','13:20:00',3.85),('16273','2013-05-02','13:25:00',3.82),('16273','2013-05-02','13:30:00',3.75),('16273','2013-05-02','13:35:00',3.73),('16273','2013-05-02','13:40:00',3.69),('16273','2013-05-02','13:45:00',3.73),('16273','2013-05-02','13:50:00',3.7),('16273','2013-05-02','13:55:00',3.66),('16273','2013-05-02','14:00:00',3.64),('16273','2013-05-02','14:05:00',3.63),('16273','2013-05-02','14:10:00',3.58),('16273','2013-05-02','14:15:00',3.53),('16273','2013-05-02','14:20:00',3.49),('16273','2013-05-02','14:25:00',3.43),('16273','2013-05-02','14:30:00',3.41),('16273','2013-05-02','14:35:00',3.37),('16273','2013-05-02','14:40:00',3.33),('16273','2013-05-02','14:45:00',3.31),('16273','2013-05-02','14:50:00',3.26),('16273','2013-05-02','14:55:00',3.19),('16273','2013-05-02','15:00:00',3.19),('16273','2013-05-02','15:05:00',3.15),('16273','2013-05-02','15:10:00',3.1),('16273','2013-05-02','15:15:00',3.06),('16273','2013-05-02','15:20:00',3.02),('16273','2013-05-02','15:25:00',2.98),('16273','2013-05-02','15:30:00',2.92),('16273','2013-05-02','15:35:00',2.88),('16273','2013-05-02','15:40:00',2.81),('16273','2013-05-02','15:45:00',2.76),('16273','2013-05-02','15:50:00',2.7),('16273','2013-05-02','15:55:00',2.63),('16273','2013-05-02','16:00:00',2.55),('16273','2013-05-02','16:05:00',2.49),('16273','2013-05-02','16:10:00',2.41),('16273','2013-05-02','16:15:00',2.35),('16273','2013-05-02','16:20:00',2.3),('16273','2013-05-02','16:25:00',2.22),('16273','2013-05-02','16:30:00',2.15),('16273','2013-05-02','16:35:00',2.07),('16273','2013-05-02','16:40:00',1.98),('16273','2013-05-02','16:45:00',1.92),('16273','2013-05-02','16:50:00',1.84),('16273','2013-05-02','16:55:00',1.76),('16273','2013-05-02','17:00:00',1.68),('16273','2013-05-02','17:05:00',1.6),('16273','2013-05-02','17:10:00',1.52),('16273','2013-05-02','17:15:00',1.45),('16273','2013-05-02','17:20:00',1.37),('16273','2013-05-02','17:25:00',1.29),('16273','2013-05-02','17:30:00',1.23),('16273','2013-05-02','17:35:00',1.15),('16273','2013-05-02','17:40:00',1.08),('16273','2013-05-02','17:45:00',1.02),('16273','2014-03-30','08:15:00',1.09),('16273','2014-03-30','08:20:00',1.23),('16273','2014-03-30','08:25:00',1.33),('16273','2014-03-30','08:30:00',1.35),('16273','2014-03-30','08:35:00',1.39),('16273','2014-03-30','08:40:00',1.36),('16273','2014-03-30','08:45:00',1.39),('16273','2014-03-30','08:50:00',1.45),('16273','2014-03-30','08:55:00',1.46),('16273','2014-03-30','09:00:00',1.52),('16273','2014-03-30','09:05:00',1.76),('16273','2014-03-30','09:10:00',1.85),('16273','2014-03-30','09:15:00',1.94),('16273','2014-03-30','09:20:00',2.02),('16273','2014-03-30','09:25:00',1.94),('16273','2014-03-30','09:30:00',2.19),('16273','2014-03-30','09:35:00',2.37),('16273','2014-03-30','09:40:00',2.36),('16273','2014-03-30','09:45:00',2.34),('16273','2014-03-30','09:50:00',2.36),('16273','2014-03-30','09:55:00',2.65),('16273','2014-03-30','10:00:00',2.96),('16273','2014-03-30','10:05:00',2.98),('16273','2014-03-30','10:10:00',2.96),('16273','2014-03-30','10:15:00',2.98),('16273','2014-03-30','10:20:00',3.03),('16273','2014-03-30','10:25:00',3.06),('16273','2014-03-30','10:30:00',3.08),('16273','2014-03-30','10:35:00',3.1),('16273','2014-03-30','10:40:00',3.06),('16273','2014-03-30','10:45:00',2.94),('16273','2014-03-30','10:50:00',2.96),('16273','2014-03-30','10:55:00',3.1),('16273','2014-03-30','11:00:00',3.25),('16273','2014-03-30','11:05:00',3.16),('16273','2014-03-30','11:10:00',3.16),('16273','2014-03-30','11:15:00',3.19),('16273','2014-03-30','11:20:00',3.2),('16273','2014-03-30','11:25:00',3.45),('16273','2014-03-30','11:30:00',3.61),('16273','2014-03-30','11:35:00',3.67),('16273','2014-03-30','11:40:00',3.63),('16273','2014-03-30','11:45:00',3.57),('16273','2014-03-30','11:50:00',3.51),('16273','2014-03-30','11:55:00',3.62),('16273','2014-03-30','12:00:00',3.59),('16273','2014-03-30','12:05:00',3.72),('16273','2014-03-30','12:10:00',3.79),('16273','2014-03-30','12:15:00',3.62),('16273','2014-03-30','12:20:00',3.65),('16273','2014-03-30','12:25:00',3.82),('16273','2014-03-30','12:30:00',3.83),('16273','2014-03-30','12:35:00',3.75),('16273','2014-03-30','12:40:00',3.63),('16273','2014-03-30','12:45:00',3.7),('16273','2014-03-30','12:50:00',3.73),('16273','2014-03-30','12:55:00',3.69),('16273','2014-03-30','13:00:00',3.64),('16273','2014-03-30','13:05:00',3.8),('16273','2014-03-30','13:10:00',3.83),('16273','2014-03-30','13:15:00',3.82),('16273','2014-03-30','13:20:00',3.76),('16273','2014-03-30','13:25:00',3.77),('16273','2014-03-30','13:30:00',3.72),('16273','2014-03-30','13:35:00',3.7),('16273','2014-03-30','13:40:00',3.71),('16273','2014-03-30','13:45:00',3.72),('16273','2014-03-30','13:50:00',3.65),('16273','2014-03-30','13:55:00',3.54),('16273','2014-03-30','14:00:00',3.25),('16273','2014-03-30','14:05:00',2.89),('16273','2014-03-30','14:10:00',2.56),('16273','2014-03-30','14:15:00',2.56),('16273','2014-03-30','14:20:00',2.46),('16273','2014-03-30','14:25:00',2.06),('16273','2014-03-30','14:30:00',2.06),('16273','2014-03-30','14:35:00',2.22),('16273','2014-03-30','14:40:00',2.36),('16273','2014-03-30','14:45:00',2.36),('16273','2014-03-30','14:50:00',2.38),('16273','2014-03-30','14:55:00',2.77),('16273','2014-03-30','15:00:00',3.03),('16273','2014-03-30','15:05:00',3.05),('16273','2014-03-30','15:10:00',2.98),('16273','2014-03-30','15:15:00',2.95),('16273','2014-03-30','15:20:00',2.89),('16273','2014-03-30','15:25:00',2.83),('16273','2014-03-30','15:30:00',2.71),('16273','2014-03-30','15:35:00',2.69),('16273','2014-03-30','15:40:00',2.74),('16273','2014-03-30','15:45:00',2.79),('16273','2014-03-30','15:50:00',2.65),('16273','2014-03-30','15:55:00',2.61),('16273','2014-03-30','16:00:00',2.35),('16273','2014-03-30','16:05:00',2.13),('16273','2014-03-30','16:10:00',2.05),('16273','2014-03-30','16:15:00',1.96),('16273','2014-03-30','16:20:00',1.86),('16273','2014-03-30','16:25:00',1.9),('16273','2014-03-30','16:30:00',1.86),('16273','2014-03-30','16:35:00',1.82),('16273','2014-03-30','16:40:00',1.63),('16273','2014-03-30','16:45:00',1.47),('16273','2014-03-30','16:50:00',1.44),('16273','2014-03-30','16:55:00',1.45),('16273','2014-03-30','17:00:00',1.39),('16273','2014-03-30','17:05:00',1.31),('16273','2014-03-30','17:10:00',1.3),('16273','2014-03-30','17:15:00',1.26),('16273','2014-03-30','17:20:00',1.22),('16273','2014-03-30','17:25:00',1.15),('16273','2014-03-30','17:30:00',1.05),('16273','2013-05-01','07:40:00',1.02),('16273','2013-05-01','07:45:00',1.13),('16273','2013-05-01','07:50:00',1.21),('16273','2013-05-01','07:55:00',1.27),('16273','2013-05-01','08:00:00',1.34),('16273','2013-05-01','08:05:00',1.44),('16273','2013-05-01','08:10:00',1.56),('16273','2013-05-01','08:15:00',1.66),('16273','2013-05-01','08:20:00',1.75),('16273','2013-05-01','08:25:00',1.84),('16273','2013-05-01','08:30:00',1.95),('16273','2013-05-01','08:35:00',2.03),('16273','2013-05-01','08:40:00',2.1),('16273','2013-05-01','08:45:00',2.19),('16273','2013-05-01','08:50:00',2.28),('16273','2013-05-01','08:55:00',2.36),('16273','2013-05-01','09:00:00',2.41),('16273','2013-05-01','09:05:00',2.44),('16273','2013-05-01','09:10:00',2.49),('16273','2013-05-01','09:15:00',2.54),('16273','2013-05-01','09:20:00',2.53),('16273','2013-05-01','09:25:00',2.63),('16273','2013-05-01','09:30:00',2.69),('16273','2013-05-01','09:35:00',2.75),('16273','2013-05-01','09:40:00',2.79),('16273','2013-05-01','09:45:00',2.85),('16273','2013-05-01','09:50:00',2.9),('16273','2013-05-01','09:55:00',2.95),('16273','2013-05-01','10:00:00',3),('16273','2013-05-01','10:05:00',3.07),('16273','2013-05-01','10:10:00',3.11),('16273','2013-05-01','10:15:00',3.14),('16273','2013-05-01','10:20:00',3.2),('16273','2013-05-01','10:25:00',3.31),('16273','2013-05-01','10:30:00',3.44),('16273','2013-05-01','10:35:00',3.47),('16273','2013-05-01','10:40:00',3.48),('16273','2013-05-01','10:45:00',3.47),('16273','2013-05-01','10:50:00',3.51),('16273','2013-05-01','10:55:00',3.52),('16273','2013-05-01','11:00:00',3.53),('16273','2013-05-01','11:05:00',3.48),('16273','2013-05-01','11:10:00',3.68),('16273','2013-05-01','11:15:00',3.61),('16273','2013-05-01','11:20:00',3.45),('16273','2013-05-01','11:25:00',3.7),('16273','2013-05-01','11:30:00',3.23),('16273','2013-05-01','11:35:00',2.96),('16273','2013-05-01','11:40:00',3),('16273','2013-05-01','11:45:00',3.89),('16273','2013-05-01','11:50:00',3.82),('16273','2013-05-01','11:55:00',3.75),('16273','2013-05-01','12:00:00',3.74),('16273','2013-05-01','12:05:00',3.7),('16273','2013-05-01','12:10:00',3.68),('16273','2013-05-01','12:15:00',3.67),('16273','2013-05-01','12:20:00',3.63),('16273','2013-05-01','12:25:00',3.65),('16273','2013-05-01','12:30:00',3.69),('16273','2013-05-01','12:35:00',3.59),('16273','2013-05-01','12:40:00',2.41),('16273','2013-05-01','12:45:00',1.6),('16273','2013-05-01','12:50:00',1.44),('16273','2013-05-01','12:55:00',1.46),('16273','2013-05-01','13:00:00',1.59),('16273','2013-05-01','13:05:00',2.13),('16273','2013-05-01','13:10:00',3.53),('16273','2013-05-01','13:15:00',4.14),('16273','2013-05-01','13:20:00',3.82),('16273','2013-05-01','13:25:00',3.21),('16273','2013-05-01','13:30:00',3.96),('16273','2013-05-01','13:35:00',3.79),('16273','2013-05-01','13:40:00',3.75),('16273','2013-05-01','13:45:00',3.73),('16273','2013-05-01','13:50:00',3.71),('16273','2013-05-01','13:55:00',3.64),('16273','2013-05-01','14:00:00',3.62),('16273','2013-05-01','14:05:00',3.19),('16273','2013-05-01','14:10:00',3.49),('16273','2013-05-01','14:15:00',3.28),('16273','2013-05-01','14:20:00',3.68),('16273','2013-05-01','14:25:00',3.47),('16273','2013-05-01','14:30:00',3.61),('16273','2013-05-01','14:35:00',3.37),('16273','2013-05-01','14:40:00',2.88),('16273','2013-05-01','14:45:00',3.13),('16273','2013-05-01','14:50:00',2.79),('16273','2013-05-01','14:55:00',2.95),('16273','2013-05-01','15:00:00',2.12),('16273','2013-05-01','15:05:00',2.86),('16273','2013-05-01','15:10:00',3.01),('16273','2013-05-01','15:15:00',2.41),('16273','2013-05-01','15:20:00',2.42),('16273','2013-05-01','15:25:00',2.17),('16273','2013-05-01','15:30:00',1.9),('16273','2013-05-01','15:35:00',1.87),('16273','2013-05-01','15:40:00',1.93),('16273','2013-05-01','15:45:00',1.71),('16273','2013-05-01','15:50:00',1.64),('16273','2013-05-01','15:55:00',1.66),('16273','2013-05-01','16:00:00',1.9),('16273','2013-05-01','16:05:00',1.71),('16273','2013-05-01','16:10:00',1.6),('16273','2013-05-01','16:15:00',1.51),('16273','2013-05-01','16:20:00',1.35),('16273','2013-05-01','16:25:00',1.15),('16273','2013-05-01','16:30:00',1.05),('16273','2013-05-01','16:35:00',1.08),('16273','2013-05-01','16:40:00',1.08),('16273','2013-04-30','08:45:00',1.27),('16273','2013-04-30','08:50:00',1.58),('16273','2013-04-30','08:55:00',2.45),('16273','2013-04-30','09:00:00',2.19),('16273','2013-04-30','09:05:00',1.54),('16273','2013-04-30','09:10:00',2.41),('16273','2013-04-30','09:15:00',2.73),('16273','2013-04-30','09:20:00',1.98),('16273','2013-04-30','09:25:00',2.1),('16273','2013-04-30','09:30:00',2.46),('16273','2013-04-30','09:35:00',2.53),('16273','2013-04-30','09:40:00',2.37),('16273','2013-04-30','09:45:00',2.59),('16273','2013-04-30','09:50:00',2.85),('16273','2013-04-30','09:55:00',2.51),('16273','2013-04-30','10:00:00',1.92),('16273','2013-04-30','10:05:00',1.65),('16273','2013-04-30','10:10:00',1.7),('16273','2013-04-30','10:15:00',2.38),('16273','2013-04-30','10:20:00',2.74),('16273','2013-04-30','10:25:00',1.9),('16273','2013-04-30','10:30:00',1.56),('16273','2013-04-30','10:35:00',1.37),('16273','2013-04-30','10:40:00',1.82),('16273','2013-04-30','10:45:00',1.74),('16273','2013-04-30','10:50:00',1.91),('16273','2013-04-30','10:55:00',2.34),('16273','2013-04-30','11:00:00',2.08),('16273','2013-04-30','11:05:00',2.12),('16273','2013-04-30','11:10:00',2.09),('16273','2013-04-30','11:15:00',2.01),('16273','2013-04-30','11:20:00',2.05),('16273','2013-04-30','11:25:00',1.94),('16273','2013-04-30','11:30:00',2.02),('16273','2013-04-30','11:35:00',2.3),('16273','2013-04-30','11:40:00',1.7),('16273','2013-04-30','11:45:00',1.42),('16273','2013-04-30','11:50:00',1.44),('16273','2013-04-30','11:55:00',1.73),('16273','2013-04-30','12:00:00',2.31),('16273','2013-04-30','12:05:00',1.88),('16273','2013-04-30','12:10:00',2.3),('16273','2013-04-30','12:15:00',2.9),('16273','2013-04-30','12:20:00',2.01),('16273','2013-04-30','12:25:00',1.44),('16273','2013-04-30','12:30:00',1.97),('16273','2013-04-30','12:35:00',4.2),('16273','2013-04-30','12:40:00',4.24),('16273','2013-04-30','12:45:00',4),('16273','2013-04-30','12:50:00',3.77),('16273','2013-04-30','12:55:00',3.58),('16273','2013-04-30','13:00:00',3.72),('16273','2013-04-30','13:05:00',3.82),('16273','2013-04-30','13:10:00',3.75),('16273','2013-04-30','13:15:00',3.7),('16273','2013-04-30','13:20:00',3.69),('16273','2013-04-30','13:25:00',3.65),('16273','2013-04-30','13:30:00',3.59),('16273','2013-04-30','13:35:00',3.58),('16273','2013-04-30','13:40:00',3.55),('16273','2013-04-30','13:45:00',3.5),('16273','2013-04-30','13:50:00',3.47),('16273','2013-04-30','13:55:00',3.43),('16273','2013-04-30','14:00:00',3.41),('16273','2013-04-30','14:05:00',3.37),('16273','2013-04-30','14:10:00',3.34),('16273','2013-04-30','14:15:00',3.29),('16273','2013-04-30','14:20:00',3.26),('16273','2013-04-30','14:25:00',3.23),('16273','2013-04-30','14:30:00',3.19),('16273','2013-04-30','14:35:00',3.14),('16273','2013-04-30','14:40:00',3.09),('16273','2013-04-30','14:45:00',3.02),('16273','2013-04-30','14:50:00',2.98),('16273','2013-04-30','14:55:00',2.93),('16273','2013-04-30','15:00:00',2.96),('16273','2013-04-30','15:05:00',2.93),('16273','2013-04-30','15:10:00',2.9),('16273','2013-04-30','15:15:00',2.84),('16273','2013-04-30','15:20:00',2.78),('16273','2013-04-30','15:25:00',2.73),('16273','2013-04-30','15:30:00',2.68),('16273','2013-04-30','15:35:00',2.62),('16273','2013-04-30','15:40:00',2.57),('16273','2013-04-30','15:45:00',2.52),('16273','2013-04-30','15:50:00',2.46),('16273','2013-04-30','15:55:00',2.4),('16273','2013-04-30','16:00:00',2.33),('16273','2013-04-30','16:05:00',2.28),('16273','2013-04-30','16:10:00',2.21),('16273','2013-04-30','16:15:00',2.14),('16273','2013-04-30','16:20:00',2.08),('16273','2013-04-30','16:25:00',2.02),('16273','2013-04-30','16:30:00',1.8),('16273','2013-04-30','16:35:00',1.84),('16273','2013-04-30','16:40:00',1.45),('16273','2013-04-30','16:45:00',1.21),('16273','2013-04-30','16:50:00',1.54),('16273','2013-04-30','16:55:00',1.63),('16273','2013-04-30','17:00:00',1.47),('16273','2013-04-30','17:10:00',1.09),('16273','2013-04-30','17:15:00',1.08),('16273','2013-04-30','17:20:00',1.24),('16273','2013-04-30','17:25:00',1.18),('16273','2013-04-30','17:30:00',1.12),('16273','2013-04-30','17:35:00',1.07),('16273','2013-04-30','17:40:00',1),('16273','2013-04-29','07:45:00',1.06),('16273','2013-04-29','07:50:00',1.22),('16273','2013-04-29','07:55:00',1.4),('16273','2013-04-29','08:00:00',1.43),('16273','2013-04-29','08:05:00',1.38),('16273','2013-04-29','08:10:00',1.31),('16273','2013-04-29','08:15:00',1.55),('16273','2013-04-29','08:20:00',1.8),('16273','2013-04-29','08:25:00',2.14),('16273','2013-04-29','08:30:00',2.37),('16273','2013-04-29','08:35:00',2.26),('16273','2013-04-29','08:40:00',2.15),('16273','2013-04-29','08:45:00',2.28),('16273','2013-04-29','08:50:00',2.41),('16273','2013-04-29','08:55:00',2.36),('16273','2013-04-29','09:00:00',2.48),('16273','2013-04-29','09:05:00',2.61),('16273','2013-04-29','09:10:00',2.55),('16273','2013-04-29','09:15:00',2.45),('16273','2013-04-29','09:20:00',2.65),('16273','2013-04-29','09:25:00',2.68),('16273','2013-04-29','09:30:00',2.59),('16273','2013-04-29','09:35:00',2.72),('16273','2013-04-29','09:40:00',2.61),('16273','2013-04-29','09:45:00',2.69),('16273','2013-04-29','09:50:00',2.59),('16273','2013-04-29','09:55:00',2.84),('16273','2013-04-29','10:00:00',3.05),('16273','2013-04-29','10:05:00',2.82),('16273','2013-04-29','10:10:00',2.46),('16273','2013-04-29','10:15:00',3.08),('16273','2013-04-29','10:20:00',3.51),('16273','2013-04-29','10:25:00',3.6),('16273','2013-04-29','10:30:00',3.22),('16273','2013-04-29','10:35:00',2.9),('16273','2013-04-29','10:40:00',2.99),('16273','2013-04-29','10:45:00',3.16),('16273','2013-04-29','10:50:00',3.25),('16273','2013-04-29','10:55:00',3.06),('16273','2013-04-29','11:00:00',3.06),('16273','2013-04-29','11:05:00',3.35),('16273','2013-04-29','11:10:00',3.55),('16273','2013-04-29','11:15:00',3.57),('16273','2013-04-29','11:20:00',3.58),('16273','2013-04-29','11:25:00',3.1),('16273','2013-04-29','11:30:00',3.38),('16273','2013-04-29','11:35:00',3.23),('16273','2013-04-29','11:40:00',3.81),('16273','2013-04-29','11:45:00',3.52),('16273','2013-04-29','11:50:00',3.62),('16273','2013-04-29','11:55:00',3.74),('16273','2013-04-29','12:00:00',3.72),('16273','2013-04-29','12:05:00',3.75),('16273','2013-04-29','12:10:00',3.73),('16273','2013-04-29','12:15:00',3.77),('16273','2013-04-29','12:20:00',3.69),('16273','2013-04-29','12:25:00',3.78),('16273','2013-04-29','12:30:00',3.78),('16273','2013-04-29','12:35:00',3.78),('16273','2013-04-29','12:40:00',3.7),('16273','2013-04-29','12:45:00',3.51),('16273','2013-04-29','12:50:00',3.45),('16273','2013-04-29','12:55:00',3.56),('16273','2013-04-29','13:00:00',3.43),('16273','2013-04-29','13:05:00',3.43),('16273','2013-04-29','13:10:00',3.18),('16273','2013-04-29','13:15:00',3.78),('16273','2013-04-29','13:20:00',3.71),('16273','2013-04-29','13:25:00',3.79),('16273','2013-04-29','13:30:00',3.69),('16273','2013-04-29','13:35:00',3.62),('16273','2013-04-29','13:40:00',3.52),('16273','2013-04-29','13:45:00',3.37),('16273','2013-04-29','13:50:00',3.47),('16273','2013-04-29','13:55:00',3.5),('16273','2013-04-29','14:00:00',3.37),('16273','2013-04-29','14:05:00',3.51),('16273','2013-04-29','14:10:00',3.49),('16273','2013-04-29','14:15:00',3.46),('16273','2013-04-29','14:20:00',3.35),('16273','2013-04-29','14:25:00',3.2),('16273','2013-04-29','14:30:00',2.88),('16273','2013-04-29','14:35:00',2.87),('16273','2013-04-29','14:40:00',2.85),('16273','2013-04-29','14:45:00',2.9),('16273','2013-04-29','14:50:00',2.74),('16273','2013-04-29','14:55:00',2.68),('16273','2013-04-29','15:00:00',2.45),('16273','2013-04-29','15:05:00',2.7),('16273','2013-04-29','15:10:00',3.07),('16273','2013-04-29','15:15:00',3.04),('16273','2013-04-29','15:20:00',2.95),('16273','2013-04-29','15:25:00',2.58),('16273','2013-04-29','15:30:00',2.4),('16273','2013-04-29','15:35:00',2.39),('16273','2013-04-29','15:40:00',2.21),('16273','2013-04-29','15:45:00',2.2),('16273','2013-04-29','15:50:00',2.31),('16273','2013-04-29','15:55:00',2.34),('16273','2013-04-29','16:00:00',2.57),('16273','2013-04-29','16:05:00',2.55),('16273','2013-04-29','16:10:00',2.6),('16273','2013-04-29','16:15:00',2.24),('16273','2013-04-29','16:20:00',2.05),('16273','2013-04-29','16:25:00',2.13),('16273','2013-04-29','16:30:00',2.17),('16273','2013-04-29','16:35:00',2.18),('16273','2013-04-29','16:40:00',2.13),('16273','2013-04-29','16:45:00',2.18),('16273','2013-04-29','16:50:00',2.11),('16273','2013-04-29','16:55:00',1.97),('16273','2013-04-29','17:00:00',1.86),('16273','2013-04-29','17:05:00',1.75),('16273','2013-04-29','17:10:00',1.49),('16273','2013-04-29','17:15:00',1.38),('16273','2013-04-29','17:20:00',1.42),('16273','2013-04-29','17:25:00',1.17),('16273','2013-04-29','17:30:00',1.35),('16273','2013-04-29','17:35:00',1.12),('16273','2013-04-29','17:50:00',1.17),('16273','2013-04-29','17:55:00',1.07),('16273','2013-04-29','18:00:00',1.13),('16273','2013-04-29','18:05:00',1.04),('16273','2013-04-28','07:35:00',1.14),('16273','2013-04-28','07:40:00',1.28),('16273','2013-04-28','07:45:00',1.39),('16273','2013-04-28','07:50:00',1.46),('16273','2013-04-28','07:55:00',1.54),('16273','2013-04-28','08:00:00',1.65),('16273','2013-04-28','08:05:00',1.76),('16273','2013-04-28','08:10:00',1.87),('16273','2013-04-28','08:15:00',1.96),('16273','2013-04-28','08:20:00',2.06),('16273','2013-04-28','08:25:00',2.16),('16273','2013-04-28','08:30:00',2.21),('16273','2013-04-28','08:35:00',2.31),('16273','2013-04-28','08:40:00',2.38),('16273','2013-04-28','08:45:00',2.46),('16273','2013-04-28','08:50:00',2.51),('16273','2013-04-28','08:55:00',2.59),('16273','2013-04-28','09:00:00',2.67),('16273','2013-04-28','09:05:00',2.73),('16273','2013-04-28','09:10:00',2.81),('16273','2013-04-28','09:15:00',2.88),('16273','2013-04-28','09:20:00',2.95),('16273','2013-04-28','09:25:00',3.02),('16273','2013-04-28','09:30:00',3.08),('16273','2013-04-28','09:35:00',3.11),('16273','2013-04-28','09:40:00',3.19),('16273','2013-04-28','09:45:00',3.24),('16273','2013-04-28','09:50:00',3.3),('16273','2013-04-28','09:55:00',3.33),('16273','2013-04-28','10:00:00',3.38),('16273','2013-04-28','10:05:00',3.39),('16273','2013-04-28','10:10:00',3.42),('16273','2013-04-28','10:15:00',3.51),('16273','2013-04-28','10:20:00',3.54),('16273','2013-04-28','10:25:00',3.37),('16273','2013-04-28','10:30:00',3.35),('16273','2013-04-28','10:35:00',3.55),('16273','2013-04-28','10:40:00',3.44),('16273','2013-04-28','10:45:00',3.55),('16273','2013-04-28','10:50:00',3.65),('16273','2013-04-28','10:55:00',3.68),('16273','2013-04-28','11:00:00',3.73),('16273','2013-04-28','11:05:00',3.75),('16273','2013-04-28','11:10:00',3.7),('16273','2013-04-28','11:15:00',3.76),('16273','2013-04-28','11:20:00',3.79),('16273','2013-04-28','11:25:00',3.83),('16273','2013-04-28','11:30:00',3.85),('16273','2013-04-28','11:35:00',3.71),('16273','2013-04-28','11:40:00',3.57),('16273','2013-04-28','11:45:00',3.62),('16273','2013-04-28','11:50:00',3.53),('16273','2013-04-28','11:55:00',3.14),('16273','2013-04-28','12:00:00',3.19),('16273','2013-04-28','12:05:00',3.46),('16273','2013-04-28','12:10:00',3.4),('16273','2013-04-28','12:15:00',3.41),('16273','2013-04-28','12:20:00',3.7),('16273','2013-04-28','12:25:00',3.54),('16273','2013-04-28','12:30:00',3.41),('16273','2013-04-28','12:35:00',3.28),('16273','2013-04-28','12:40:00',2.42),('16273','2013-04-28','12:45:00',3.71),('16273','2013-04-28','12:50:00',3.74),('16273','2013-04-28','12:55:00',3.67),('16273','2013-04-28','13:00:00',3.9),('16273','2013-04-28','13:05:00',3.92),('16273','2013-04-28','13:10:00',3.44),('16273','2013-04-28','13:15:00',3.67),('16273','2013-04-28','13:20:00',3.72),('16273','2013-04-28','13:25:00',3.36),('16273','2013-04-28','13:30:00',3.53),('16273','2013-04-28','13:35:00',3.86),('16273','2013-04-28','13:40:00',3.75),('16273','2013-04-28','13:45:00',3.62),('16273','2013-04-28','13:50:00',3.66),('16273','2013-04-28','13:55:00',3.62),('16273','2013-04-28','14:00:00',3.59),('16273','2013-04-28','14:05:00',3.38),('16273','2013-04-28','14:10:00',3.47),('16273','2013-04-28','14:15:00',3.48),('16273','2013-04-28','14:20:00',3.42),('16273','2013-04-28','14:25:00',3.38),('16273','2013-04-28','14:30:00',3.38),('16273','2013-04-28','14:35:00',3.36),('16273','2013-04-28','14:40:00',3.29),('16273','2013-04-28','14:45:00',3.28),('16273','2013-04-28','14:50:00',3.22),('16273','2013-04-28','14:55:00',3.18),('16273','2013-04-28','15:00:00',3.14),('16273','2013-04-28','15:05:00',3.08),('16273','2013-04-28','15:10:00',3.01),('16273','2013-04-28','15:15:00',2.97),('16273','2013-04-28','15:20:00',2.94),('16273','2013-04-28','15:25:00',2.89),('16273','2013-04-28','15:30:00',2.83),('16273','2013-04-28','15:35:00',2.77),('16273','2013-04-28','15:40:00',2.71),('16273','2013-04-28','15:45:00',2.66),('16273','2013-04-28','15:50:00',2.6),('16273','2013-04-28','15:55:00',2.52),('16273','2013-04-28','16:00:00',2.46),('16273','2013-04-28','16:05:00',2.38),('16273','2013-04-28','16:10:00',2.33),('16273','2013-04-28','16:15:00',2.27),('16273','2013-04-28','16:20:00',2.2),('16273','2013-04-28','16:25:00',2.12),('16273','2013-04-28','16:30:00',2.04),('16273','2013-04-28','16:35:00',1.97),('16273','2013-04-28','16:40:00',1.88),('16273','2013-04-28','16:45:00',1.82),('16273','2013-04-28','16:50:00',1.77),('16273','2013-04-28','16:55:00',1.68),('16273','2013-04-28','17:00:00',1.61),('16273','2013-04-28','17:05:00',1.44),('16273','2013-04-28','17:10:00',1.44),('16273','2013-04-28','17:15:00',1.39),('16273','2013-04-28','17:20:00',1.32),('16273','2013-04-28','17:25:00',1.25),('16273','2013-04-28','17:30:00',1.03),('16273','2013-04-28','17:35:00',1.06),('16273','2013-04-28','17:40:00',1.03),('16273','2013-04-28','17:45:00',1),('16273','2013-04-27','12:45:00',1.03),('16273','2013-04-27','12:50:00',1.19),('16273','2013-04-27','12:55:00',1.19),('16273','2013-04-27','13:10:00',1.29),('16273','2013-04-27','13:15:00',1.95),('16273','2013-04-27','13:20:00',1.28),('16273','2013-04-27','14:30:00',1.25),('16273','2013-04-27','14:35:00',1.55),('16273','2013-04-27','14:40:00',1.46),('16273','2013-04-27','16:45:00',1.1),('16273','2013-04-27','16:55:00',1.14),('16273','2013-04-26','08:00:00',1.19),('16273','2013-04-26','08:05:00',1.27),('16273','2013-04-26','08:10:00',1.48),('16273','2013-04-26','08:15:00',1.57),('16273','2013-04-26','08:20:00',1.56),('16273','2013-04-26','08:25:00',1.62),('16273','2013-04-26','08:30:00',1.72),('16273','2013-04-26','08:35:00',1.71),('16273','2013-04-26','08:40:00',1.94),('16273','2013-04-26','08:45:00',2.23),('16273','2013-04-26','08:50:00',2.38),('16273','2013-04-26','08:55:00',2.5),('16273','2013-04-26','09:00:00',2.56),('16273','2013-04-26','09:05:00',1.96),('16273','2013-04-26','09:10:00',2.66),('16273','2013-04-26','09:15:00',2.57),('16273','2013-04-26','09:20:00',1.99),('16273','2013-04-26','09:25:00',2.32),('16273','2013-04-26','09:30:00',2.8),('16273','2013-04-26','09:35:00',2.8),('16273','2013-04-26','09:40:00',2.89),('16273','2013-04-26','09:45:00',2.8),('16273','2013-04-26','09:50:00',2.66),('16273','2013-04-26','09:55:00',2.82),('16273','2013-04-26','10:00:00',3.14),('16273','2013-04-26','10:05:00',3.21),('16273','2013-04-26','10:10:00',3.23),('16273','2013-04-26','10:15:00',3.04),('16273','2013-04-26','10:20:00',3.39),('16273','2013-04-26','10:25:00',3.48),('16273','2013-04-26','10:30:00',3.47),('16273','2013-04-26','10:35:00',2.83),('16273','2013-04-26','10:40:00',3.21),('16273','2013-04-26','10:45:00',3.56),('16273','2013-04-26','10:50:00',3.66),('16273','2013-04-26','10:55:00',3.69),('16273','2013-04-26','11:00:00',3.59),('16273','2013-04-26','11:05:00',3.79),('16273','2013-04-26','11:10:00',3.74),('16273','2013-04-26','11:15:00',2.82),('16273','2013-04-26','11:20:00',2.86),('16273','2013-04-26','11:25:00',3.5),('16273','2013-04-26','11:30:00',3.28),('16273','2013-04-26','11:35:00',3.98),('16273','2013-04-26','11:40:00',3.34),('16273','2013-04-26','11:45:00',2.57),('16273','2013-04-26','11:50:00',2.36),('16273','2013-04-26','11:55:00',2.33),('16273','2013-04-26','12:00:00',2.23),('16273','2013-04-26','12:05:00',1.91),('16273','2013-04-26','12:10:00',2.04),('16273','2013-04-26','12:15:00',2.01),('16273','2013-04-26','12:20:00',1.71),('16273','2013-04-26','12:25:00',1.53),('16273','2013-04-26','12:30:00',1.73),('16273','2013-04-26','12:35:00',2.15),('16273','2013-04-26','12:40:00',2.19),('16273','2013-04-26','12:45:00',1.91),('16273','2013-04-26','12:50:00',1.58),('16273','2013-04-26','12:55:00',1.27),('16273','2013-04-26','13:00:00',1.29),('16273','2013-04-26','13:05:00',1.55),('16273','2013-04-26','13:10:00',3.58),('16273','2013-04-26','13:15:00',4.05),('16273','2013-04-26','13:20:00',4.32),('16273','2013-04-26','13:25:00',3.43),('16273','2013-04-26','13:30:00',2.5),('16273','2013-04-26','13:35:00',2.26),('16273','2013-04-26','13:40:00',2.69),('16273','2013-04-26','13:45:00',2.88),('16273','2013-04-26','13:50:00',2.46),('16273','2013-04-26','13:55:00',2.25),('16273','2013-04-26','14:00:00',2.83),('16273','2013-04-26','14:05:00',2.3),('16273','2013-04-26','14:10:00',2.4),('16273','2013-04-26','14:15:00',2.14),('16273','2013-04-26','14:20:00',2.96),('16273','2013-04-26','14:25:00',2.56),('16273','2013-04-26','14:30:00',1.76),('16273','2013-04-26','14:35:00',1.53),('16273','2013-04-26','14:40:00',1.64),('16273','2013-04-26','14:45:00',1.33),('16273','2013-04-26','14:50:00',1.24),('16273','2013-04-26','14:55:00',1.39),('16273','2013-04-26','15:00:00',1.67),('16273','2013-04-26','15:05:00',1.38),('16273','2013-04-26','15:10:00',3.03),('16273','2013-04-26','15:15:00',2.29),('16273','2013-04-26','15:20:00',2.03),('16273','2013-04-26','15:25:00',3.48),('16273','2013-04-26','15:30:00',3.35),('16273','2013-04-26','15:35:00',2.49),('16273','2013-04-26','15:40:00',1.98),('16273','2013-04-26','15:45:00',1.52),('16273','2013-04-26','15:50:00',1.06),('16273','2013-04-25','08:00:00',1.02),('16273','2013-04-25','08:05:00',1.06),('16273','2013-04-25','08:10:00',1.23),('16273','2013-04-25','08:30:00',1),('16273','2013-04-25','08:35:00',1.18),('16273','2013-04-25','08:40:00',1.93),('16273','2013-04-25','08:45:00',2.32),('16273','2013-04-25','08:50:00',1.88),('16273','2013-04-25','08:55:00',1.36),('16273','2013-04-25','09:00:00',1.58),('16273','2013-04-25','09:05:00',1.4),('16273','2013-04-25','09:10:00',1.41),('16273','2013-04-25','09:15:00',1.43),('16273','2013-04-25','09:20:00',1.41),('16273','2013-04-25','09:25:00',1.6),('16273','2013-04-25','09:30:00',2.04),('16273','2013-04-25','09:35:00',2.56),('16273','2013-04-25','09:40:00',3.03),('16273','2013-04-25','09:45:00',3.21),('16273','2013-04-25','09:50:00',3.19),('16273','2013-04-25','09:55:00',3.17),('16273','2013-04-25','10:00:00',3.04),('16273','2013-04-25','10:05:00',3.34),('16273','2013-04-25','10:10:00',3.44),('16273','2013-04-25','10:15:00',3.51),('16273','2013-04-25','10:20:00',3.43),('16273','2013-04-25','10:25:00',3.5),('16273','2013-04-25','10:30:00',3.48),('16273','2013-04-25','10:35:00',3.55),('16273','2013-04-25','10:40:00',3.62),('16273','2013-04-25','10:45:00',3.61),('16273','2013-04-25','10:50:00',3.65),('16273','2013-04-25','10:55:00',3.67),('16273','2013-04-25','11:00:00',3.71),('16273','2013-04-25','11:05:00',3.75),('16273','2013-04-25','11:10:00',3.79),('16273','2013-04-25','11:15:00',3.82),('16273','2013-04-25','11:20:00',3.83),('16273','2013-04-25','11:25:00',3.89),('16273','2013-04-25','11:30:00',3.9),('16273','2013-04-25','11:35:00',3.9),('16273','2013-04-25','11:40:00',3.91),('16273','2013-04-25','11:45:00',3.98),('16273','2013-04-25','11:50:00',4.01),('16273','2013-04-25','11:55:00',3.95),('16273','2013-04-25','12:00:00',3.68),('16273','2013-04-25','12:05:00',3.77),('16273','2013-04-25','12:10:00',3.92),('16273','2013-04-25','12:15:00',3.91),('16273','2013-04-25','12:20:00',3.85),('16273','2013-04-25','12:25:00',3.81),('16273','2013-04-25','12:30:00',3.82),('16273','2013-04-25','12:35:00',3.85),('16273','2013-04-25','12:40:00',3.84),('16273','2013-04-25','12:45:00',3.81),('16273','2013-04-25','12:50:00',3.81),('16273','2013-04-25','12:55:00',3.82),('16273','2013-04-25','13:00:00',3.84),('16273','2013-04-25','13:05:00',3.79),('16273','2013-04-25','13:10:00',3.88),('16273','2013-04-25','13:15:00',2.88),('16273','2013-04-25','13:20:00',2.84),('16273','2013-04-25','13:25:00',2.66),('16273','2013-04-25','13:30:00',2.36),('16273','2013-04-25','13:35:00',2.14),('16273','2013-04-25','13:40:00',2.08),('16273','2013-04-25','13:45:00',2.06),('16273','2013-04-25','13:50:00',2.03),('16273','2013-04-25','13:55:00',2.16),('16273','2013-04-25','14:00:00',2.01),('16273','2013-04-25','14:05:00',2.09),('16273','2013-04-25','14:10:00',2.13),('16273','2013-04-25','14:15:00',2.52),('16273','2013-04-25','14:20:00',3.02),('16273','2013-04-25','14:25:00',3.34),('16273','2013-04-25','14:30:00',3.47),('16273','2013-04-25','14:35:00',3.34),('16273','2013-04-25','14:40:00',3.26),('16273','2013-04-25','14:45:00',3.01),('16273','2013-04-25','14:50:00',2.67),('16273','2013-04-25','14:55:00',2.67),('16273','2013-04-25','15:00:00',2.74),('16273','2013-04-25','15:05:00',2.13),('16273','2013-04-25','15:10:00',2.4),('16273','2013-04-25','15:15:00',2.55),('16273','2013-04-25','15:20:00',2.77),('16273','2013-04-25','15:25:00',2.75),('16273','2013-04-25','15:30:00',2.38),('16273','2013-04-25','15:35:00',2.24),('16273','2013-04-25','15:40:00',2.19),('16273','2013-04-25','15:45:00',1.87),('16273','2013-04-25','15:50:00',1.91),('16273','2013-04-25','15:55:00',2.25),('16273','2013-04-25','16:00:00',2.43),('16273','2013-04-25','16:05:00',2.38),('16273','2013-04-25','16:10:00',1.94),('16273','2013-04-25','16:15:00',2.06),('16273','2013-04-25','16:20:00',2.27),('16273','2013-04-25','16:25:00',2.13),('16273','2013-04-25','16:30:00',1.83),('16273','2013-04-25','16:35:00',1.58),('16273','2013-04-25','16:40:00',1.79),('16273','2013-04-25','16:45:00',1.47),('16273','2013-04-25','16:50:00',1.42),('16273','2013-04-25','16:55:00',1.65),('16273','2013-04-25','17:00:00',1.7),('16273','2013-04-25','17:05:00',1.56),('16273','2013-04-25','17:10:00',1.2),('16273','2013-04-25','17:15:00',1.24),('16273','2013-04-25','17:20:00',1.32),('16273','2013-04-25','17:25:00',1.33),('16273','2013-04-25','17:30:00',1.3),('16273','2013-04-25','17:35:00',1.23),('16273','2013-04-25','17:40:00',1.12),('16273','2013-04-24','07:50:00',1.22),('16273','2013-04-24','07:55:00',1.38),('16273','2013-04-24','08:00:00',1.45),('16273','2013-04-24','08:05:00',1.57),('16273','2013-04-24','08:10:00',1.77),('16273','2013-04-24','08:15:00',1.86),('16273','2013-04-24','08:20:00',2.03),('16273','2013-04-24','08:25:00',2.03),('16273','2013-04-24','08:30:00',1.92),('16273','2013-04-24','08:35:00',1.89),('16273','2013-04-24','08:40:00',2.03),('16273','2013-04-24','08:45:00',2.18),('16273','2013-04-24','08:50:00',2.08),('16273','2013-04-24','08:55:00',2.49),('16273','2013-04-24','09:00:00',2.75),('16273','2013-04-24','09:05:00',2.9),('16273','2013-04-24','09:10:00',2.98),('16273','2013-04-24','09:15:00',2.47),('16273','2013-04-24','09:20:00',1.87),('16273','2013-04-24','09:25:00',2.1),('16273','2013-04-24','09:30:00',3.07),('16273','2013-04-24','09:35:00',2.31),('16273','2013-04-24','09:40:00',2.38),('16273','2013-04-24','09:45:00',2.58),('16273','2013-04-24','09:50:00',3.22),('16273','2013-04-24','09:55:00',3.67),('16273','2013-04-24','10:00:00',3.59),('16273','2013-04-24','10:05:00',3.45),('16273','2013-04-24','10:10:00',3.05),('16273','2013-04-24','10:15:00',3.37),('16273','2013-04-24','10:20:00',3.61),('16273','2013-04-24','10:25:00',3.52),('16273','2013-04-24','10:30:00',3.37),('16273','2013-04-24','10:35:00',3.46),('16273','2013-04-24','10:40:00',3.71),('16273','2013-04-24','10:45:00',3.7),('16273','2013-04-24','10:50:00',3.73),('16273','2013-04-24','10:55:00',3.71),('16273','2013-04-24','11:00:00',3.71),('16273','2013-04-24','11:05:00',3.97),('16273','2013-04-24','11:10:00',4),('16273','2013-04-24','11:15:00',4),('16273','2013-04-24','11:20:00',3.95),('16273','2013-04-24','11:25:00',3.28),('16273','2013-04-24','11:30:00',3.07),('16273','2013-04-24','11:35:00',2.75),('16273','2013-04-24','11:40:00',3.18),('16273','2013-04-24','11:45:00',2.47),('16273','2013-04-24','11:50:00',2.12),('16273','2013-04-24','11:55:00',2.82),('16273','2013-04-24','12:00:00',3.16),('16273','2013-04-24','12:05:00',3.31),('16273','2013-04-24','12:10:00',2.68),('16273','2013-04-24','12:15:00',4.03),('16273','2013-04-24','12:20:00',3.08),('16273','2013-04-24','12:25:00',3.49),('16273','2013-04-24','12:30:00',3.56),('16273','2013-04-24','12:35:00',3.49),('16273','2013-04-24','12:40:00',3.84),('16273','2013-04-24','12:45:00',3.83),('16273','2013-04-24','12:50:00',3.71),('16273','2013-04-24','12:55:00',3.48),('16273','2013-04-24','13:00:00',3.16),('16273','2013-04-24','13:05:00',4.12),('16273','2013-04-24','13:10:00',3.48),('16273','2013-04-24','13:15:00',3.53),('16273','2013-04-24','13:20:00',3.49),('16273','2013-04-24','13:25:00',3.37),('16273','2013-04-24','13:30:00',3.08),('16273','2013-04-24','13:35:00',4.03),('16273','2013-04-24','13:40:00',3.08),('16273','2013-04-24','13:45:00',2.59),('16273','2013-04-24','13:50:00',3.59),('16273','2013-04-24','13:55:00',3.38),('16273','2013-04-24','14:00:00',2.52),('16273','2013-04-24','14:05:00',2.8),('16273','2013-04-24','14:10:00',3.71),('16273','2013-04-24','14:15:00',3.33),('16273','2013-04-24','14:20:00',3.49),('16273','2013-04-24','14:25:00',3.24),('16273','2013-04-24','14:30:00',2.94),('16273','2013-04-24','14:35:00',2.63),('16273','2013-04-24','14:40:00',2.76),('16273','2013-04-24','14:45:00',2.27),('16273','2013-04-24','14:50:00',2.03),('16273','2013-04-24','14:55:00',2.21),('16273','2013-04-24','15:00:00',2.18),('16273','2013-04-24','15:05:00',1.91),('16273','2013-04-24','15:10:00',2.01),('16273','2013-04-24','15:15:00',2.11),('16273','2013-04-24','15:20:00',1.75),('16273','2013-04-24','15:25:00',1.62),('16273','2013-04-24','15:30:00',1.56),('16273','2013-04-24','15:35:00',1.53),('16273','2013-04-24','15:40:00',1.59),('16273','2013-04-24','15:45:00',1.67),('16273','2013-04-24','15:50:00',1.93),('16273','2013-04-24','15:55:00',2.11),('16273','2013-04-24','16:00:00',2.22),('16273','2013-04-24','16:05:00',2.31),('16273','2013-04-24','16:10:00',2.41),('16273','2013-04-24','16:15:00',2.88),('16273','2013-04-24','16:20:00',2.12),('16273','2013-04-24','16:25:00',1.61),('16273','2013-04-24','16:30:00',1.6),('16273','2013-04-24','16:35:00',1.93),('16273','2013-04-24','16:40:00',2.01),('16273','2013-04-24','16:45:00',1.94),('16273','2013-04-24','16:50:00',2.15),('16273','2013-04-24','16:55:00',2.02),('16273','2013-04-24','17:00:00',1.88),('16273','2013-04-24','17:05:00',1.79),('16273','2013-04-24','17:10:00',1.31),('16273','2013-04-24','17:15:00',1.38),('16273','2013-04-24','17:20:00',1.22),('16273','2013-04-23','07:30:00',1.11),('16273','2013-04-23','07:35:00',1.22),('16273','2013-04-23','07:40:00',1.14),('16273','2013-04-23','07:45:00',1.45),('16273','2013-04-23','07:50:00',1.54),('16273','2013-04-23','07:55:00',1.65),('16273','2013-04-23','08:00:00',1.74),('16273','2013-04-23','08:05:00',1.83),('16273','2013-04-23','08:10:00',1.93),('16273','2013-04-23','08:15:00',2),('16273','2013-04-23','08:20:00',2.12),('16273','2013-04-23','08:25:00',2.22),('16273','2013-04-23','08:30:00',2.3),('16273','2013-04-23','08:35:00',2.38),('16273','2013-04-23','08:40:00',2.46),('16273','2013-04-23','08:45:00',2.53),('16273','2013-04-23','08:50:00',2.63),('16273','2013-04-23','08:55:00',2.69),('16273','2013-04-23','09:00:00',2.76),('16273','2013-04-23','09:05:00',2.83),('16273','2013-04-23','09:10:00',2.89),('16273','2013-04-23','09:15:00',2.97),('16273','2013-04-23','09:20:00',3.02),('16273','2013-04-23','09:25:00',3.08),('16273','2013-04-23','09:30:00',3.17),('16273','2013-04-23','09:35:00',3.23),('16273','2013-04-23','09:40:00',3.12),('16273','2013-04-23','09:45:00',3.36),('16273','2013-04-23','09:50:00',3.32),('16273','2013-04-23','09:55:00',3.45),('16273','2013-04-23','10:00:00',3.5),('16273','2013-04-23','10:05:00',3.55),('16273','2013-04-23','10:10:00',3.58),('16273','2013-04-23','10:15:00',3.62),('16273','2013-04-23','10:20:00',3.67),('16273','2013-04-23','10:25:00',3.71),('16273','2013-04-23','10:30:00',3.68),('16273','2013-04-23','10:35:00',3.74),('16273','2013-04-23','10:40:00',3.8),('16273','2013-04-23','10:45:00',3.59),('16273','2013-04-23','10:50:00',3.84),('16273','2013-04-23','10:55:00',3.86),('16273','2013-04-23','11:00:00',3.88),('16273','2013-04-23','11:05:00',3.89),('16273','2013-04-23','11:10:00',3.92),('16273','2013-04-23','11:15:00',3.91),('16273','2013-04-23','11:20:00',3.94),('16273','2013-04-23','11:25:00',3.97),('16273','2013-04-23','11:30:00',3.96),('16273','2013-04-23','11:35:00',3.98),('16273','2013-04-23','11:40:00',4.04),('16273','2013-04-23','11:45:00',4.04),('16273','2013-04-23','11:50:00',4.05),('16273','2013-04-23','11:55:00',4.04),('16273','2013-04-23','12:00:00',4.02),('16273','2013-04-23','12:05:00',4.06),('16273','2013-04-23','12:10:00',4.12),('16273','2013-04-23','12:15:00',4.07),('16273','2013-04-23','12:20:00',4.06),('16273','2013-04-23','12:25:00',4.12),('16273','2013-04-23','12:30:00',4.08),('16273','2013-04-23','12:35:00',4.19),('16273','2013-04-23','12:40:00',4.37),('16273','2013-04-23','12:45:00',4.46),('16273','2013-04-23','12:50:00',4.35),('16273','2013-04-23','12:55:00',4.34),('16273','2013-04-23','13:00:00',3.97),('16273','2013-04-23','13:05:00',2.97),('16273','2013-04-23','13:10:00',3.88),('16273','2013-04-23','13:15:00',3.69),('16273','2013-04-23','13:20:00',3.39),('16273','2013-04-23','13:25:00',2.99),('16273','2013-04-23','13:30:00',4.06),('16273','2013-04-23','13:35:00',4.02),('16273','2013-04-23','13:40:00',3.68),('16273','2013-04-23','13:45:00',3.58),('16273','2013-04-23','13:50:00',3.41),('16273','2013-04-23','13:55:00',4.13),('16273','2013-04-23','14:00:00',3.99),('16273','2013-04-23','14:05:00',3.86),('16273','2013-04-23','14:10:00',3.9),('16273','2013-04-23','14:15:00',3.78),('16273','2013-04-23','14:20:00',3.12),('16273','2013-04-23','14:25:00',3.48),('16273','2013-04-23','14:30:00',2.96),('16273','2013-04-23','14:35:00',3.41),('16273','2013-04-23','14:40:00',3.54),('16273','2013-04-23','14:45:00',3.17),('16273','2013-04-23','14:50:00',1.54),('16273','2013-04-23','14:55:00',1.64),('16273','2013-04-23','15:00:00',1.76),('16273','2013-04-23','15:05:00',2.14),('16273','2013-04-23','15:10:00',2.49),('16273','2013-04-23','15:15:00',2.66),('16273','2013-04-23','15:20:00',2.65),('16273','2013-04-23','15:25:00',2.19),('16273','2013-04-23','15:30:00',2.23),('16273','2013-04-23','15:35:00',2.37),('16273','2013-04-23','15:40:00',2.11),('16273','2013-04-23','15:45:00',2.32),('16273','2013-04-23','15:50:00',2.44),('16273','2013-04-23','15:55:00',2.28),('16273','2013-04-23','16:00:00',2.18),('16273','2013-04-23','16:05:00',1.89),('16273','2013-04-23','16:10:00',1.64),('16273','2013-04-23','16:15:00',1.3),('16273','2013-04-23','16:20:00',1.43),('16273','2013-04-23','16:25:00',1.6),('16273','2013-04-23','16:30:00',1.32),('16273','2013-04-23','16:35:00',1.14),('16273','2013-04-23','16:40:00',1.14),('16273','2013-04-23','16:45:00',1.24),('16273','2013-04-23','16:50:00',1.18),('16273','2013-04-23','16:55:00',1.25),('16273','2013-04-23','17:00:00',1.67),('16273','2013-04-23','17:05:00',1.9),('16273','2013-04-23','17:10:00',1.95),('16273','2013-04-23','17:15:00',1.8),('16273','2013-04-23','17:20:00',1.37),('16273','2013-04-23','17:25:00',1.42),('16273','2013-04-23','17:30:00',1.21),('16273','2013-04-23','17:40:00',1.32),('16273','2013-04-23','17:45:00',1.11),('16273','2013-04-22','08:40:00',1.21),('16273','2013-04-22','09:20:00',1),('16273','2013-04-22','09:40:00',1.2),('16273','2013-04-22','10:35:00',1.97),('16273','2013-04-22','10:40:00',2.45),('16273','2013-04-22','10:45:00',4.09),('16273','2013-04-22','10:50:00',1.52),('16273','2013-04-22','11:05:00',1.01),('16273','2013-04-22','11:15:00',1.01),('16273','2013-04-22','11:20:00',1.78),('16273','2013-04-22','11:25:00',1.75),('16273','2013-04-22','11:30:00',1.11),('16273','2013-04-22','11:40:00',1.81),('16273','2013-04-22','11:45:00',4.64),('16273','2013-04-22','11:50:00',4.44),('16273','2013-04-22','11:55:00',4.41),('16273','2013-04-22','12:00:00',4.42),('16273','2013-04-22','12:05:00',4.51),('16273','2013-04-22','12:10:00',4.48),('16273','2013-04-22','12:15:00',4.32),('16273','2013-04-22','12:20:00',4.24),('16273','2013-04-22','12:25:00',4.39),('16273','2013-04-22','12:30:00',3.86),('16273','2013-04-22','12:35:00',3.24),('16273','2013-04-22','12:40:00',2.77),('16273','2013-04-22','12:45:00',2.52),('16273','2013-04-22','12:50:00',4.08),('16273','2013-04-22','12:55:00',3.93),('16273','2013-04-22','13:00:00',1.87),('16273','2013-04-22','13:05:00',1.98),('16273','2013-04-22','13:10:00',2.71),('16273','2013-04-22','13:15:00',1.8),('16273','2013-04-22','13:20:00',1.4),('16273','2013-04-22','13:30:00',1.25),('16273','2013-04-22','13:50:00',3.06),('16273','2013-04-22','13:55:00',2.16),('16273','2013-04-22','14:00:00',3.01),('16273','2013-04-22','14:05:00',3.99),('16273','2013-04-22','14:10:00',3.41),('16273','2013-04-22','14:15:00',2.5),('16273','2013-04-22','14:20:00',1.13),('16273','2013-04-22','14:25:00',1.08),('16273','2013-04-22','14:30:00',3.29),('16273','2013-04-22','14:35:00',3.21),('16273','2013-04-22','14:40:00',1.49),('16273','2013-04-22','14:45:00',2.25),('16273','2013-04-22','14:50:00',2.12),('16273','2013-04-22','14:55:00',1.27),('16273','2013-04-22','15:05:00',3.2),('16273','2013-04-22','15:10:00',2.05),('16273','2013-04-22','15:20:00',1.46),('16273','2013-04-22','15:25:00',1.63),('16273','2013-04-22','15:30:00',2.65),('16273','2013-04-22','15:35:00',1.3),('16273','2013-04-22','15:40:00',1.46),('16273','2013-04-22','15:45:00',2.14),('16273','2013-04-22','15:50:00',2.47),('16273','2013-04-22','17:00:00',1.07),('16273','2013-04-22','17:05:00',1.21),('16273','2013-04-22','17:10:00',1.41),('16273','2013-04-22','17:15:00',1.34),('16273','2013-04-22','17:20:00',1.54),('16273','2013-04-22','17:25:00',1.85),('16273','2013-04-22','17:30:00',1.31),('16273','2013-04-22','17:35:00',1.29),('16273','2013-04-22','17:40:00',1.55),('16273','2013-04-22','17:45:00',1.64),('16273','2013-04-22','17:50:00',1.71),('16273','2013-04-22','17:55:00',1.46),('16273','2014-03-29','07:10:00',1.09),('16273','2014-03-29','07:15:00',1.04),('16273','2014-03-29','07:20:00',1.3),('16273','2014-03-29','07:25:00',1.39),('16273','2014-03-29','07:30:00',1.47),('16273','2014-03-29','07:35:00',1.58),('16273','2014-03-29','07:40:00',1.7),('16273','2014-03-29','07:45:00',1.8),('16273','2014-03-29','07:50:00',1.9),('16273','2014-03-29','07:55:00',1.98),('16273','2014-03-29','08:00:00',2.05),('16273','2014-03-29','08:05:00',2.15),('16273','2014-03-29','08:10:00',2.24),('16273','2014-03-29','08:15:00',2.33),('16273','2014-03-29','08:20:00',2.42),('16273','2014-03-29','08:25:00',2.48),('16273','2014-03-29','08:30:00',2.54),('16273','2014-03-29','08:35:00',2.61),('16273','2014-03-29','08:40:00',2.69),('16273','2014-03-29','08:45:00',2.76),('16273','2014-03-29','08:50:00',2.79),('16273','2014-03-29','08:55:00',2.86),('16273','2014-03-29','09:00:00',2.92),('16273','2014-03-29','09:05:00',2.96),('16273','2014-03-29','09:10:00',3.02),('16273','2014-03-29','09:15:00',3.08),('16273','2014-03-29','09:20:00',3.12),('16273','2014-03-29','09:25:00',3.18),('16273','2014-03-29','09:30:00',3.21),('16273','2014-03-29','09:35:00',3.24),('16273','2014-03-29','09:40:00',3.26),('16273','2014-03-29','09:45:00',3.3),('16273','2014-03-29','09:50:00',3.35),('16273','2014-03-29','09:55:00',3.38),('16273','2014-03-29','10:00:00',3.41),('16273','2014-03-29','10:05:00',3.43),('16273','2014-03-29','10:10:00',3.49),('16273','2014-03-29','10:15:00',3.57),('16273','2014-03-29','10:20:00',3.58),('16273','2014-03-29','10:25:00',3.59),('16273','2014-03-29','10:30:00',3.58),('16273','2014-03-29','10:35:00',3.59),('16273','2014-03-29','10:40:00',3.67),('16273','2014-03-29','10:45:00',3.68),('16273','2014-03-29','10:50:00',3.7),('16273','2014-03-29','10:55:00',3.72),('16273','2014-03-29','11:00:00',3.75),('16273','2014-03-29','11:05:00',3.78),('16273','2014-03-29','11:10:00',3.76),('16273','2014-03-29','11:15:00',3.75),('16273','2014-03-29','11:20:00',3.74),('16273','2014-03-29','11:25:00',3.75),('16273','2014-03-29','11:30:00',3.74),('16273','2014-03-29','11:35:00',3.72),('16273','2014-03-29','11:40:00',3.74),('16273','2014-03-29','11:45:00',3.76),('16273','2014-03-29','11:50:00',3.71),('16273','2014-03-29','11:55:00',3.69),('16273','2014-03-29','12:00:00',3.65),('16273','2014-03-29','12:05:00',3.56),('16273','2014-03-29','12:10:00',3.59),('16273','2014-03-29','12:15:00',3.56),('16273','2014-03-29','12:20:00',3.54),('16273','2014-03-29','12:25:00',3.57),('16273','2014-03-29','12:30:00',3.59),('16273','2014-03-29','12:35:00',3.52),('16273','2014-03-29','12:40:00',3.52),('16273','2014-03-29','12:45:00',3.54),('16273','2014-03-29','12:50:00',3.55),('16273','2014-03-29','12:55:00',3.51),('16273','2014-03-29','13:00:00',3.08),('16273','2014-03-29','13:05:00',2.92),('16273','2014-03-29','13:10:00',2.72),('16273','2014-03-29','13:15:00',2.29),('16273','2014-03-29','13:20:00',2.54),('16273','2014-03-29','13:25:00',2.34),('16273','2014-03-29','13:30:00',2.37),('16273','2014-03-29','13:35:00',2.38),('16273','2014-03-29','13:40:00',2.98),('16273','2014-03-29','13:45:00',2.99),('16273','2014-03-29','13:50:00',3),('16273','2014-03-29','13:55:00',3.06),('16273','2014-03-29','14:00:00',2.99),('16273','2014-03-29','14:05:00',2.91),('16273','2014-03-29','14:10:00',2.9),('16273','2014-03-29','14:15:00',2.6),('16273','2014-03-29','14:20:00',2.56),('16273','2014-03-29','14:25:00',2.66),('16273','2014-03-29','14:30:00',2.65),('16273','2014-03-29','14:35:00',2.59),('16273','2014-03-29','14:40:00',2.54),('16273','2014-03-29','14:45:00',2.46),('16273','2014-03-29','14:50:00',2.24),('16273','2014-03-29','14:55:00',2.28),('16273','2014-03-29','15:00:00',2.25),('16273','2014-03-29','15:05:00',2.19),('16273','2014-03-29','15:10:00',2.11),('16273','2014-03-29','15:15:00',2.03),('16273','2014-03-29','15:20:00',1.95),('16273','2014-03-29','15:25:00',1.88),('16273','2014-03-29','15:30:00',1.8),('16273','2014-03-29','15:35:00',1.72),('16273','2014-03-29','15:40:00',1.65),('16273','2014-03-29','15:45:00',1.58),('16273','2014-03-29','15:50:00',1.51),('16273','2014-03-29','15:55:00',1.44),('16273','2014-03-29','16:00:00',1.36),('16273','2014-03-29','16:05:00',1.27),('16273','2014-03-29','16:10:00',1.21),('16273','2014-03-29','16:15:00',1.12),('16273','2014-03-29','16:20:00',1.05),('16273','2014-03-29','16:25:00',1),('16273','2013-04-21','08:45:00',1.2),('16273','2013-04-21','08:50:00',1.2),('16273','2013-04-21','08:55:00',1.07),('16273','2013-04-21','09:10:00',1.02),('16273','2013-04-21','09:20:00',1.04),('16273','2013-04-21','09:25:00',1.36),('16273','2013-04-21','09:30:00',1.93),('16273','2013-04-21','09:35:00',1.91),('16273','2013-04-21','09:40:00',2.02),('16273','2013-04-21','09:45:00',2.34),('16273','2013-04-21','09:50:00',2.35),('16273','2013-04-21','09:55:00',2.72),('16273','2013-04-21','10:00:00',1.62),('16273','2013-04-21','10:05:00',2.9),('16273','2013-04-21','10:10:00',2.93),('16273','2013-04-21','10:15:00',3.67),('16273','2013-04-21','10:20:00',3.73),('16273','2013-04-21','10:25:00',3.91),('16273','2013-04-21','10:30:00',3.65),('16273','2013-04-21','10:35:00',3.64),('16273','2013-04-21','10:40:00',2.77),('16273','2013-04-21','10:45:00',3.93),('16273','2013-04-21','10:50:00',3.86),('16273','2013-04-21','10:55:00',3.99),('16273','2013-04-21','11:00:00',3.59),('16273','2013-04-21','11:05:00',3.79),('16273','2013-04-21','11:10:00',3.98),('16273','2013-04-21','11:15:00',4.1),('16273','2013-04-21','11:20:00',3.57),('16273','2013-04-21','11:25:00',2.83),('16273','2013-04-21','11:30:00',2.7),('16273','2013-04-21','11:35:00',2.74),('16273','2013-04-21','11:40:00',2.63),('16273','2013-04-21','11:45:00',2.31),('16273','2013-04-21','11:50:00',2.42),('16273','2013-04-21','11:55:00',2.62),('16273','2013-04-21','12:00:00',2.51),('16273','2013-04-21','12:05:00',2.33),('16273','2013-04-21','12:10:00',2.09),('16273','2013-04-21','12:15:00',1.88),('16273','2013-04-21','12:20:00',1.89),('16273','2013-04-21','12:25:00',2.02),('16273','2013-04-21','12:30:00',2.02),('16273','2013-04-21','12:35:00',2.12),('16273','2013-04-21','12:40:00',2.17),('16273','2013-04-21','12:45:00',2.14),('16273','2013-04-21','12:50:00',2.24),('16273','2013-04-21','12:55:00',2.22),('16273','2013-04-21','13:00:00',2.36),('16273','2013-04-21','13:05:00',2.98),('16273','2013-04-21','13:10:00',2.42),('16273','2013-04-21','13:15:00',2.34),('16273','2013-04-21','13:20:00',2.4),('16273','2013-04-21','13:25:00',2.42),('16273','2013-04-21','13:30:00',2.85),('16273','2013-04-21','13:35:00',3.45),('16273','2013-04-21','13:40:00',3.21),('16273','2013-04-21','13:45:00',3.85),('16273','2013-04-21','13:50:00',3.09),('16273','2013-04-21','13:55:00',2.97),('16273','2013-04-21','14:00:00',2.92),('16273','2013-04-21','14:05:00',4.05),('16273','2013-04-21','14:10:00',3.72),('16273','2013-04-21','14:15:00',3.65),('16273','2013-04-21','14:20:00',4.06),('16273','2013-04-21','14:25:00',3.92),('16273','2013-04-21','14:30:00',3.63),('16273','2013-04-21','14:35:00',3.45),('16273','2013-04-21','14:40:00',3.62),('16273','2013-04-21','14:45:00',2.81),('16273','2013-04-21','14:50:00',2.36),('16273','2013-04-21','14:55:00',3.36),('16273','2013-04-21','15:00:00',3.5),('16273','2013-04-21','15:05:00',3.26),('16273','2013-04-21','15:10:00',3.1),('16273','2013-04-21','15:15:00',2.25),('16273','2013-04-21','15:20:00',2.31),('16273','2013-04-21','15:25:00',2.53),('16273','2013-04-21','15:30:00',2.28),('16273','2013-04-21','15:35:00',1.82),('16273','2013-04-21','15:40:00',2.12),('16273','2013-04-21','15:45:00',1.19),('16273','2013-04-21','15:50:00',1.01),('16273','2013-04-20','07:55:00',1.03),('16273','2013-04-20','08:00:00',1.17),('16273','2013-04-20','08:05:00',1.18),('16273','2013-04-20','08:15:00',1.19),('16273','2013-04-20','08:20:00',1.09),('16273','2013-04-20','08:25:00',1.4),('16273','2013-04-20','08:30:00',1.53),('16273','2013-04-20','08:35:00',2.14),('16273','2013-04-20','08:40:00',2.21),('16273','2013-04-20','08:45:00',2.37),('16273','2013-04-20','08:50:00',2.4),('16273','2013-04-20','08:55:00',2.42),('16273','2013-04-20','09:00:00',2.24),('16273','2013-04-20','09:05:00',2.62),('16273','2013-04-20','09:10:00',1.53),('16273','2013-04-20','09:15:00',1.61),('16273','2013-04-20','09:20:00',1.2),('16273','2013-04-20','09:25:00',1.09),('16273','2013-04-20','10:20:00',1.22),('16273','2013-04-20','10:25:00',1.64),('16273','2013-04-20','10:30:00',1.86),('16273','2013-04-20','10:35:00',2.47),('16273','2013-04-20','10:40:00',2.95),('16273','2013-04-20','10:45:00',4.11),('16273','2013-04-20','10:50:00',1.87),('16273','2013-04-20','10:55:00',3.63),('16273','2013-04-20','11:00:00',4.04),('16273','2013-04-20','11:05:00',3.56),('16273','2013-04-20','11:10:00',2.91),('16273','2013-04-20','11:15:00',4.31),('16273','2013-04-20','11:20:00',2.96),('16273','2013-04-20','11:25:00',1.68),('16273','2013-04-20','11:30:00',3.05),('16273','2013-04-20','11:35:00',2.61),('16273','2013-04-20','11:40:00',3.92),('16273','2013-04-20','11:45:00',3.31),('16273','2013-04-20','11:50:00',1.68),('16273','2013-04-20','11:55:00',3.73),('16273','2013-04-20','12:00:00',4.28),('16273','2013-04-20','12:05:00',4.11),('16273','2013-04-20','12:10:00',3.8),('16273','2013-04-20','12:15:00',1.71),('16273','2013-04-20','12:20:00',3.46),('16273','2013-04-20','12:25:00',4.36),('16273','2013-04-20','12:30:00',4.25),('16273','2013-04-20','12:35:00',3.76),('16273','2013-04-20','12:40:00',4.12),('16273','2013-04-20','12:45:00',4.13),('16273','2013-04-20','12:50:00',4.1),('16273','2013-04-20','12:55:00',4.1),('16273','2013-04-20','13:00:00',4.06),('16273','2013-04-20','13:05:00',3.71),('16273','2013-04-20','13:10:00',3.9),('16273','2013-04-20','13:15:00',4.01),('16273','2013-04-20','13:20:00',4),('16273','2013-04-20','13:25:00',3.64),('16273','2013-04-20','13:30:00',4.32),('16273','2013-04-20','13:35:00',3.22),('16273','2013-04-20','13:40:00',3.35),('16273','2013-04-20','13:45:00',2.34),('16273','2013-04-20','13:50:00',4.26),('16273','2013-04-20','13:55:00',4.1),('16273','2013-04-20','14:00:00',3.97),('16273','2013-04-20','14:05:00',3.82),('16273','2013-04-20','14:10:00',3.72),('16273','2013-04-20','14:15:00',3.72),('16273','2013-04-20','14:20:00',3.58),('16273','2013-04-20','14:25:00',3.52),('16273','2013-04-20','14:30:00',3.45),('16273','2013-04-20','14:35:00',3.49),('16273','2013-04-20','14:40:00',3.47),('16273','2013-04-20','14:45:00',3.36),('16273','2013-04-20','14:50:00',3.32),('16273','2013-04-20','14:55:00',3.36),('16273','2013-04-20','15:00:00',2.93),('16273','2013-04-20','15:05:00',1.52),('16273','2013-04-20','15:10:00',2.92),('16273','2013-04-20','15:15:00',3.13),('16273','2013-04-20','15:20:00',1.98),('16273','2013-04-20','15:25:00',1.17),('16273','2013-04-20','15:55:00',1.23),('16273','2013-04-20','16:00:00',2.18),('16273','2013-04-20','16:05:00',2.98),('16273','2013-04-20','16:10:00',3.01),('16273','2013-04-20','16:15:00',2.54),('16273','2013-04-20','16:20:00',2.53),('16273','2013-04-20','16:25:00',2.56),('16273','2013-04-20','16:30:00',2.46),('16273','2013-04-20','16:35:00',2.28),('16273','2013-04-20','16:40:00',2.1),('16273','2013-04-20','16:45:00',1.95),('16273','2013-04-20','16:50:00',1.84),('16273','2013-04-20','16:55:00',1.75),('16273','2013-04-20','17:00:00',1.65),('16273','2013-04-20','17:05:00',1.57),('16273','2013-04-20','17:10:00',1.48),('16273','2013-04-20','17:15:00',1.42),('16273','2013-04-20','17:20:00',1.38),('16273','2013-04-20','17:25:00',1.34),('16273','2013-04-20','17:30:00',1.31),('16273','2013-04-20','17:35:00',1.08),('16273','2013-04-19','08:05:00',1.13),('16273','2013-04-19','08:10:00',1.13),('16273','2013-04-19','08:15:00',1.33),('16273','2013-04-19','08:20:00',1.53),('16273','2013-04-19','08:25:00',1.8),('16273','2013-04-19','08:30:00',2.26),('16273','2013-04-19','08:35:00',1.6),('16273','2013-04-19','08:40:00',2.16),('16273','2013-04-19','08:45:00',1.73),('16273','2013-04-19','08:50:00',1.64),('16273','2013-04-19','08:55:00',2.39),('16273','2013-04-19','09:00:00',2.3),('16273','2013-04-19','09:05:00',2.66),('16273','2013-04-19','09:10:00',2.59),('16273','2013-04-19','09:15:00',2.69),('16273','2013-04-19','09:20:00',2.52),('16273','2013-04-19','09:25:00',2.63),('16273','2013-04-19','09:30:00',1.7),('16273','2013-04-19','09:35:00',2.48),('16273','2013-04-19','09:40:00',2.87),('16273','2013-04-19','09:45:00',2.83),('16273','2013-04-19','09:50:00',2.98),('16273','2013-04-19','09:55:00',3.04),('16273','2013-04-19','10:00:00',3.09),('16273','2013-04-19','10:05:00',3.14),('16273','2013-04-19','10:10:00',3.22),('16273','2013-04-19','10:15:00',3.27),('16273','2013-04-19','10:20:00',3.28),('16273','2013-04-19','10:25:00',3.29),('16273','2013-04-19','10:30:00',3.35),('16273','2013-04-19','10:35:00',3.36),('16273','2013-04-19','10:40:00',3.37),('16273','2013-04-19','10:45:00',3.45),('16273','2013-04-19','10:50:00',3),('16273','2013-04-19','10:55:00',3.54),('16273','2013-04-19','11:00:00',3.53),('16273','2013-04-19','11:05:00',3.44),('16273','2013-04-19','11:10:00',3.57),('16273','2013-04-19','11:15:00',3.61),('16273','2013-04-19','11:20:00',3.63),('16273','2013-04-19','11:25:00',3.7),('16273','2013-04-19','11:30:00',3.69),('16273','2013-04-19','11:35:00',3.7),('16273','2013-04-19','11:40:00',3.75),('16273','2013-04-19','11:45:00',3.77),('16273','2013-04-19','11:50:00',3.7),('16273','2013-04-19','11:55:00',3.72),('16273','2013-04-19','12:00:00',3.6),('16273','2013-04-19','12:05:00',3.78),('16273','2013-04-19','12:10:00',3.72),('16273','2013-04-19','12:15:00',3.71),('16273','2013-04-19','12:20:00',3.56),('16273','2013-04-19','12:25:00',3.75),('16273','2013-04-19','12:30:00',3.78),('16273','2013-04-19','12:35:00',3.74),('16273','2013-04-19','12:40:00',3.82),('16273','2013-04-19','12:45:00',3.84),('16273','2013-04-19','12:50:00',3.81),('16273','2013-04-19','12:55:00',3.82),('16273','2013-04-19','13:00:00',3.79),('16273','2013-04-19','13:05:00',3.79),('16273','2013-04-19','13:10:00',3.8),('16273','2013-04-19','13:15:00',3.75),('16273','2013-04-19','13:20:00',3.75),('16273','2013-04-19','13:25:00',3.73),('16273','2013-04-19','13:30:00',3.71),('16273','2013-04-19','13:35:00',3.67),('16273','2013-04-19','13:40:00',3.65),('16273','2013-04-19','13:45:00',3.64),('16273','2013-04-19','13:50:00',3.63),('16273','2013-04-19','13:55:00',3.6),('16273','2013-04-19','14:00:00',3.55),('16273','2013-04-19','14:05:00',3.53),('16273','2013-04-19','14:10:00',3.49),('16273','2013-04-19','14:15:00',3.46),('16273','2013-04-19','14:20:00',3.41),('16273','2013-04-19','14:25:00',3.4),('16273','2013-04-19','14:30:00',3.4),('16273','2013-04-19','14:35:00',3.35),('16273','2013-04-19','14:40:00',3.29),('16273','2013-04-19','14:45:00',3.24),('16273','2013-04-19','14:50:00',3.2),('16273','2013-04-19','14:55:00',3.17),('16273','2013-04-19','15:00:00',3.12),('16273','2013-04-19','15:05:00',3.06),('16273','2013-04-19','15:10:00',3.02),('16273','2013-04-19','15:15:00',2.97),('16273','2013-04-19','15:20:00',2.92),('16273','2013-04-19','15:25:00',2.86),('16273','2013-04-19','15:30:00',2.81),('16273','2013-04-19','15:35:00',2.74),('16273','2013-04-19','15:40:00',2.69),('16273','2013-04-19','15:45:00',2.64),('16273','2013-04-19','15:50:00',2.59),('16273','2013-04-19','15:55:00',2.5),('16273','2013-04-19','16:00:00',2.42),('16273','2013-04-19','16:05:00',2.36),('16273','2013-04-19','16:10:00',2.3),('16273','2013-04-19','16:15:00',2.22),('16273','2013-04-19','16:20:00',2.15),('16273','2013-04-19','16:25:00',2.07),('16273','2013-04-19','16:30:00',1.98),('16273','2013-04-19','16:35:00',1.91),('16273','2013-04-19','16:40:00',1.83),('16273','2013-04-19','16:45:00',1.76),('16273','2013-04-19','16:50:00',1.67),('16273','2013-04-19','16:55:00',1.58),('16273','2013-04-19','17:00:00',1.49),('16273','2013-04-19','17:05:00',1.43),('16273','2013-04-19','17:10:00',1.35),('16273','2013-04-19','17:15:00',1.29),('16273','2013-04-19','17:20:00',1.23),('16273','2013-04-19','17:25:00',1.16),('16273','2013-04-19','17:30:00',1.09),('16273','2013-04-19','17:35:00',1.02),('16273','2013-04-18','08:00:00',1.3),('16273','2013-04-18','08:05:00',1.34),('16273','2013-04-18','08:10:00',1.29),('16273','2013-04-18','08:15:00',1.52),('16273','2013-04-18','08:20:00',1.46),('16273','2013-04-18','08:25:00',1.46),('16273','2013-04-18','08:30:00',1.33),('16273','2013-04-18','08:35:00',1.23),('16273','2013-04-18','08:40:00',1.37),('16273','2013-04-18','08:45:00',1.43),('16273','2013-04-18','08:50:00',1.53),('16273','2013-04-18','08:55:00',1.67),('16273','2013-04-18','09:00:00',1.33),('16273','2013-04-18','09:05:00',1.56),('16273','2013-04-18','09:10:00',1.82),('16273','2013-04-18','09:15:00',1.87),('16273','2013-04-18','09:20:00',2.12),('16273','2013-04-18','09:25:00',2.4),('16273','2013-04-18','09:30:00',2.34),('16273','2013-04-18','09:35:00',2.02),('16273','2013-04-18','09:40:00',1.93),('16273','2013-04-18','09:45:00',1.99),('16273','2013-04-18','09:50:00',2.13),('16273','2013-04-18','09:55:00',2.88),('16273','2013-04-18','10:00:00',3.15),('16273','2013-04-18','10:05:00',3.16),('16273','2013-04-18','10:10:00',3.28),('16273','2013-04-18','10:15:00',3.28),('16273','2013-04-18','10:20:00',3.36),('16273','2013-04-18','10:25:00',3.42),('16273','2013-04-18','10:30:00',3.49),('16273','2013-04-18','10:35:00',3.52),('16273','2013-04-18','10:40:00',3.57),('16273','2013-04-18','10:45:00',3.58),('16273','2013-04-18','10:50:00',3.59),('16273','2013-04-18','10:55:00',3.61),('16273','2013-04-18','11:00:00',3.63),('16273','2013-04-18','11:05:00',3.69),('16273','2013-04-18','11:10:00',3.73),('16273','2013-04-18','11:15:00',3.75),('16273','2013-04-18','11:20:00',3.79),('16273','2013-04-18','11:25:00',3.85),('16273','2013-04-18','11:30:00',3.87),('16273','2013-04-18','11:35:00',3.85),('16273','2013-04-18','11:40:00',3.86),('16273','2013-04-18','11:45:00',3.88),('16273','2013-04-18','11:50:00',3.85),('16273','2013-04-18','11:55:00',3.92),('16273','2013-04-18','12:00:00',3.78),('16273','2013-04-18','12:05:00',3.94),('16273','2013-04-18','12:10:00',3.95),('16273','2013-04-18','12:15:00',3.93),('16273','2013-04-18','12:20:00',3.93),('16273','2013-04-18','12:25:00',3.95),('16273','2013-04-18','12:30:00',3.95),('16273','2013-04-18','12:35:00',3.93),('16273','2013-04-18','12:40:00',3.95),('16273','2013-04-18','12:45:00',3.94),('16273','2013-04-18','12:50:00',3.93),('16273','2013-04-18','12:55:00',3.91),('16273','2013-04-18','13:00:00',3.9),('16273','2013-04-18','13:05:00',3.89),('16273','2013-04-18','13:10:00',3.86),('16273','2013-04-18','13:15:00',3.87),('16273','2013-04-18','13:20:00',3.85),('16273','2013-04-18','13:25:00',3.84),('16273','2013-04-18','13:30:00',3.81),('16273','2013-04-18','13:35:00',3.77),('16273','2013-04-18','13:40:00',3.75),('16273','2013-04-18','13:45:00',3.74),('16273','2013-04-18','13:50:00',3.72),('16273','2013-04-18','13:55:00',3.69),('16273','2013-04-18','14:00:00',3.66),('16273','2013-04-18','14:05:00',3.65),('16273','2013-04-18','14:10:00',3.65),('16273','2013-04-18','14:15:00',3.61),('16273','2013-04-18','14:20:00',3.57),('16273','2013-04-18','14:25:00',3.53),('16273','2013-04-18','14:30:00',3.5),('16273','2013-04-18','14:35:00',3.45),('16273','2013-04-18','14:40:00',3.4),('16273','2013-04-18','14:45:00',3.36),('16273','2013-04-18','14:50:00',3.31),('16273','2013-04-18','14:55:00',3.26),('16273','2013-04-18','15:00:00',3.14),('16273','2013-04-18','15:05:00',3.14),('16273','2013-04-18','15:10:00',3.09),('16273','2013-04-18','15:15:00',3.02),('16273','2013-04-18','15:20:00',2.96),('16273','2013-04-18','15:25:00',2.91),('16273','2013-04-18','15:30:00',2.82),('16273','2013-04-18','15:35:00',2.77),('16273','2013-04-18','15:40:00',2.73),('16273','2013-04-18','15:45:00',2.65),('16273','2013-04-18','15:50:00',2.59),('16273','2013-04-18','15:55:00',2.53),('16273','2013-04-18','16:00:00',2.46),('16273','2013-04-18','16:05:00',2.4),('16273','2013-04-18','16:10:00',2.33),('16273','2013-04-18','16:15:00',2.22),('16273','2013-04-18','16:20:00',2.16),('16273','2013-04-18','16:25:00',2.08),('16273','2013-04-18','16:30:00',2.01),('16273','2013-04-18','16:35:00',1.94),('16273','2013-04-18','16:40:00',1.86),('16273','2013-04-18','16:45:00',1.78),('16273','2013-04-18','16:50:00',1.71),('16273','2013-04-18','16:55:00',1.62),('16273','2013-04-18','17:00:00',1.55),('16273','2013-04-18','17:05:00',1.47),('16273','2013-04-18','17:10:00',1.4),('16273','2013-04-18','17:15:00',1.33),('16273','2013-04-18','17:20:00',1.26),('16273','2013-04-18','17:25:00',1.2),('16273','2013-04-18','17:30:00',1.11),('16273','2013-04-18','17:35:00',1.04),('16273','2013-04-17','07:40:00',1.11),('16273','2013-04-17','07:45:00',1.04),('16273','2013-04-17','07:50:00',1.34),('16273','2013-04-17','07:55:00',1.46),('16273','2013-04-17','08:00:00',1.55),('16273','2013-04-17','08:05:00',1.64),('16273','2013-04-17','08:10:00',1.72),('16273','2013-04-17','08:15:00',1.81),('16273','2013-04-17','08:20:00',1.89),('16273','2013-04-17','08:25:00',1.99),('16273','2013-04-17','08:30:00',2.07),('16273','2013-04-17','08:35:00',2.14),('16273','2013-04-17','08:40:00',2.25),('16273','2013-04-17','08:45:00',2.32),('16273','2013-04-17','08:50:00',2.42),('16273','2013-04-17','08:55:00',2.49),('16273','2013-04-17','09:00:00',2.55),('16273','2013-04-17','09:05:00',2.61),('16273','2013-04-17','09:10:00',2.68),('16273','2013-04-17','09:15:00',2.75),('16273','2013-04-17','09:20:00',2.8),('16273','2013-04-17','09:25:00',2.87),('16273','2013-04-17','09:30:00',2.92),('16273','2013-04-17','09:35:00',2.98),('16273','2013-04-17','09:40:00',3.06),('16273','2013-04-17','09:45:00',3.11),('16273','2013-04-17','09:50:00',3.14),('16273','2013-04-17','09:55:00',3.23),('16273','2013-04-17','10:00:00',3.25),('16273','2013-04-17','10:05:00',3.33),('16273','2013-04-17','10:10:00',3.36),('16273','2013-04-17','10:15:00',3.41),('16273','2013-04-17','10:20:00',3.43),('16273','2013-04-17','10:25:00',3.47),('16273','2013-04-17','10:30:00',3.45),('16273','2013-04-17','10:35:00',3.54),('16273','2013-04-17','10:40:00',3.57),('16273','2013-04-17','10:45:00',3.63),('16273','2013-04-17','10:50:00',3.65),('16273','2013-04-17','10:55:00',3.67),('16273','2013-04-17','11:00:00',3.69),('16273','2013-04-17','11:05:00',3.72),('16273','2013-04-17','11:10:00',3.74),('16273','2013-04-17','11:15:00',3.78),('16273','2013-04-17','11:20:00',3.8),('16273','2013-04-17','11:25:00',3.82),('16273','2013-04-17','11:30:00',3.84),('16273','2013-04-17','11:35:00',3.83),('16273','2013-04-17','11:40:00',3.85),('16273','2013-04-17','11:45:00',3.86),('16273','2013-04-17','11:50:00',3.87),('16273','2013-04-17','11:55:00',3.88),('16273','2013-04-17','12:00:00',3.89),('16273','2013-04-17','12:05:00',3.88),('16273','2013-04-17','12:10:00',3.88),('16273','2013-04-17','12:15:00',3.89),('16273','2013-04-17','12:20:00',3.89),('16273','2013-04-17','12:25:00',3.89),('16273','2013-04-17','12:30:00',3.89),('16273','2013-04-17','12:35:00',3.89),('16273','2013-04-17','12:40:00',3.88),('16273','2013-04-17','12:45:00',3.9),('16273','2013-04-17','12:50:00',3.89),('16273','2013-04-17','12:55:00',3.92),('16273','2013-04-17','13:00:00',3.7),('16273','2013-04-17','13:05:00',3.35),('16273','2013-04-17','13:10:00',3.8),('16273','2013-04-17','13:15:00',3.89),('16273','2013-04-17','13:20:00',3.92),('16273','2013-04-17','13:25:00',3.84),('16273','2013-04-17','13:30:00',3.75),('16273','2013-04-17','13:35:00',3.84),('16273','2013-04-17','13:40:00',3.88),('16273','2013-04-17','13:45:00',3.82),('16273','2013-04-17','13:50:00',3.72),('16273','2013-04-17','13:55:00',3.45),('16273','2013-04-17','14:00:00',3.26),('16273','2013-04-17','14:05:00',2.57),('16273','2013-04-17','14:10:00',3.58),('16273','2013-04-17','14:15:00',3.17),('16273','2013-04-17','14:20:00',3.95),('16273','2013-04-17','14:25:00',3.78),('16273','2013-04-17','14:30:00',3.54),('16273','2013-04-17','14:35:00',3.67),('16273','2013-04-17','14:40:00',3.83),('16273','2013-04-17','14:45:00',2.53),('16273','2013-04-17','14:50:00',2.32),('16273','2013-04-17','14:55:00',1.75),('16273','2013-04-17','15:00:00',1.63),('16273','2013-04-17','15:05:00',2.24),('16273','2013-04-17','15:10:00',3.03),('16273','2013-04-17','15:15:00',2.08),('16273','2013-04-17','15:20:00',2.33),('16273','2013-04-17','15:25:00',1.19),('16273','2013-04-17','15:30:00',1.82),('16273','2013-04-17','15:35:00',2.53),('16273','2013-04-17','15:40:00',3.02),('16273','2013-04-17','15:45:00',2.82),('16273','2013-04-17','15:50:00',2.71),('16273','2013-04-17','15:55:00',2.33),('16273','2013-04-17','16:00:00',2.71),('16273','2013-04-17','16:05:00',2.61),('16273','2013-04-17','16:10:00',2.42),('16273','2013-04-17','16:15:00',2.38),('16273','2013-04-17','16:20:00',2.19),('16273','2013-04-17','16:25:00',2.18),('16273','2013-04-17','16:30:00',2.1),('16273','2013-04-17','16:35:00',2.06),('16273','2013-04-17','16:40:00',1.82),('16273','2013-04-17','16:45:00',1.78),('16273','2013-04-17','16:50:00',1.77),('16273','2013-04-17','16:55:00',1.67),('16273','2013-04-17','17:00:00',1.59),('16273','2013-04-17','17:05:00',1.5),('16273','2013-04-17','17:10:00',1.42),('16273','2013-04-17','17:15:00',1.35),('16273','2013-04-17','17:20:00',1.27),('16273','2013-04-17','17:25:00',1.19),('16273','2013-04-17','17:30:00',1.12),('16273','2013-04-17','17:35:00',1.04),('16273','2013-04-16','07:45:00',1.06),('16273','2013-04-16','07:50:00',1.02),('16273','2013-04-16','07:55:00',1.22),('16273','2013-04-16','08:00:00',1.32),('16273','2013-04-16','08:05:00',1.46),('16273','2013-04-16','08:10:00',1.42),('16273','2013-04-16','08:45:00',1.04),('16273','2013-04-16','09:00:00',2.26),('16273','2013-04-16','09:05:00',2.55),('16273','2013-04-16','09:10:00',2.59),('16273','2013-04-16','09:15:00',2.85),('16273','2013-04-16','09:20:00',2.09),('16273','2013-04-16','09:25:00',1.51),('16273','2013-04-16','09:30:00',1.86),('16273','2013-04-16','09:35:00',1.64),('16273','2013-04-16','09:40:00',1.83),('16273','2013-04-16','09:45:00',1.72),('16273','2013-04-16','09:50:00',1.64),('16273','2013-04-16','09:55:00',1.68),('16273','2013-04-16','10:00:00',1.66),('16273','2013-04-16','10:05:00',1.4),('16273','2013-04-16','10:10:00',1.29),('16273','2013-04-16','10:15:00',1.32),('16273','2013-04-16','10:20:00',1.32),('16273','2013-04-16','10:25:00',1.33),('16273','2013-04-16','10:30:00',1.3),('16273','2013-04-16','10:35:00',1.33),('16273','2013-04-16','10:40:00',1.4),('16273','2013-04-16','10:45:00',1.45),('16273','2013-04-16','10:50:00',1.44),('16273','2013-04-16','10:55:00',1.42),('16273','2013-04-16','11:00:00',1.5),('16273','2013-04-16','11:05:00',1.59),('16273','2013-04-16','11:10:00',1.66),('16273','2013-04-16','11:15:00',1.69),('16273','2013-04-16','11:20:00',1.7),('16273','2013-04-16','11:25:00',1.77),('16273','2013-04-16','11:30:00',1.74),('16273','2013-04-16','11:35:00',1.61),('16273','2013-04-16','11:40:00',1.83),('16273','2013-04-16','11:45:00',2.28),('16273','2013-04-16','11:50:00',2.36),('16273','2013-04-16','11:55:00',2.6),('16273','2013-04-16','12:00:00',2.69),('16273','2013-04-16','12:05:00',3.25),('16273','2013-04-16','12:10:00',3.41),('16273','2013-04-16','12:15:00',3.35),('16273','2013-04-16','12:20:00',3.48),('16273','2013-04-16','12:25:00',3.37),('16273','2013-04-16','12:30:00',3.68),('16273','2013-04-16','12:35:00',3.09),('16273','2013-04-16','12:40:00',3.52),('16273','2013-04-16','12:45:00',3.49),('16273','2013-04-16','12:50:00',3.5),('16273','2013-04-16','12:55:00',3.42),('16273','2013-04-16','13:00:00',3.76),('16273','2013-04-16','13:05:00',3.73),('16273','2013-04-16','13:10:00',3.68),('16273','2013-04-16','13:15:00',3.76),('16273','2013-04-16','13:20:00',3.77),('16273','2013-04-16','13:25:00',3.74),('16273','2013-04-16','13:30:00',3.75),('16273','2013-04-16','13:35:00',3.72),('16273','2013-04-16','13:40:00',3.71),('16273','2013-04-16','13:45:00',3.73),('16273','2013-04-16','13:50:00',3.68),('16273','2013-04-16','13:55:00',3.65),('16273','2013-04-16','14:00:00',3.62),('16273','2013-04-16','14:05:00',3.53),('16273','2013-04-16','14:10:00',3.56),('16273','2013-04-16','14:15:00',3.59),('16273','2013-04-16','14:20:00',3.3),('16273','2013-04-16','14:25:00',2.85),('16273','2013-04-16','14:30:00',3.04),('16273','2013-04-16','14:35:00',2.46),('16273','2013-04-16','14:40:00',3.19),('16273','2013-04-16','14:45:00',3.39),('16273','2013-04-16','14:50:00',3.34),('16273','2013-04-16','14:55:00',3.24),('16273','2013-04-16','15:00:00',3.21),('16273','2013-04-16','15:05:00',3.16),('16273','2013-04-16','15:10:00',2.76),('16273','2013-04-16','15:15:00',2.53),('16273','2013-04-16','15:20:00',2.47),('16273','2013-04-16','15:25:00',2.87),('16273','2013-04-16','15:30:00',2.89),('16273','2013-04-16','15:35:00',2.79),('16273','2013-04-16','15:40:00',2.74),('16273','2013-04-16','15:45:00',2.67),('16273','2013-04-16','15:50:00',2.6),('16273','2013-04-16','15:55:00',2.52),('16273','2013-04-16','16:00:00',2.45),('16273','2013-04-16','16:05:00',2.38),('16273','2013-04-16','16:10:00',2.31),('16273','2013-04-16','16:15:00',2.24),('16273','2013-04-16','16:20:00',2.17),('16273','2013-04-16','16:25:00',1.99),('16273','2013-04-16','16:30:00',1.94),('16273','2013-04-16','16:35:00',1.97),('16273','2013-04-16','16:40:00',1.91),('16273','2013-04-16','16:45:00',1.71),('16273','2013-04-16','16:50:00',1.77),('16273','2013-04-16','16:55:00',1.67),('16273','2013-04-16','17:00:00',1.58),('16273','2013-04-16','17:05:00',1.5),('16273','2013-04-16','17:10:00',1.34),('16273','2013-04-16','17:15:00',1.35),('16273','2013-04-16','17:20:00',1.29),('16273','2013-04-16','17:25:00',1.22),('16273','2013-04-16','17:30:00',1.17),('16273','2013-04-16','17:35:00',1.1),('16273','2013-04-16','17:40:00',1.02),('16273','2013-04-15','07:40:00',1.1),('16273','2013-04-15','07:45:00',1.18),('16273','2013-04-15','07:50:00',1.11),('16273','2013-04-15','07:55:00',1.4),('16273','2013-04-15','08:00:00',1.5),('16273','2013-04-15','08:05:00',1.61),('16273','2013-04-15','08:10:00',1.74),('16273','2013-04-15','08:15:00',1.84),('16273','2013-04-15','08:20:00',1.93),('16273','2013-04-15','08:25:00',2.02),('16273','2013-04-15','08:30:00',2.1),('16273','2013-04-15','08:35:00',2.18),('16273','2013-04-15','08:40:00',2.27),('16273','2013-04-15','08:45:00',2.35),('16273','2013-04-15','08:50:00',2.42),('16273','2013-04-15','08:55:00',2.51),('16273','2013-04-15','09:00:00',2.58),('16273','2013-04-15','09:05:00',2.66),('16273','2013-04-15','09:10:00',2.74),('16273','2013-04-15','09:15:00',2.81),('16273','2013-04-15','09:20:00',2.87),('16273','2013-04-15','09:25:00',2.92),('16273','2013-04-15','09:30:00',2.99),('16273','2013-04-15','09:35:00',3.05),('16273','2013-04-15','09:40:00',3.09),('16273','2013-04-15','09:45:00',3.14),('16273','2013-04-15','09:50:00',3.2),('16273','2013-04-15','09:55:00',3.24),('16273','2013-04-15','10:00:00',3.29),('16273','2013-04-15','10:05:00',3.33),('16273','2013-04-15','10:10:00',3.37),('16273','2013-04-15','10:15:00',3.43),('16273','2013-04-15','10:20:00',3.47),('16273','2013-04-15','10:25:00',3.49),('16273','2013-04-15','10:30:00',3.51),('16273','2013-04-15','10:35:00',3.55),('16273','2013-04-15','10:40:00',3.59),('16273','2013-04-15','10:45:00',3.62),('16273','2013-04-15','10:50:00',3.65),('16273','2013-04-15','10:55:00',3.68),('16273','2013-04-15','11:00:00',3.7),('16273','2013-04-15','11:05:00',3.73),('16273','2013-04-15','11:10:00',3.76),('16273','2013-04-15','11:15:00',3.78),('16273','2013-04-15','11:20:00',3.8),('16273','2013-04-15','11:25:00',3.82),('16273','2013-04-15','11:30:00',3.84),('16273','2013-04-15','11:35:00',3.85),('16273','2013-04-15','11:40:00',3.86),('16273','2013-04-15','11:45:00',3.88),('16273','2013-04-15','11:50:00',3.91),('16273','2013-04-15','11:55:00',3.91),('16273','2013-04-15','12:00:00',3.92),('16273','2013-04-15','12:05:00',3.92),('16273','2013-04-15','12:10:00',3.91),('16273','2013-04-15','12:15:00',3.91),('16273','2013-04-15','12:20:00',3.91),('16273','2013-04-15','12:25:00',3.93),('16273','2013-04-15','12:30:00',3.92),('16273','2013-04-15','12:35:00',3.91),('16273','2013-04-15','12:40:00',3.91),('16273','2013-04-15','12:45:00',3.9),('16273','2013-04-15','12:50:00',3.88),('16273','2013-04-15','12:55:00',3.86),('16273','2013-04-15','13:00:00',3.86),('16273','2013-04-15','13:05:00',3.85),('16273','2013-04-15','13:10:00',3.82),('16273','2013-04-15','13:15:00',3.81),('16273','2013-04-15','13:20:00',3.84),('16273','2013-04-15','13:25:00',3.88),('16273','2013-04-15','13:30:00',3.88),('16273','2013-04-15','13:35:00',3.86),('16273','2013-04-15','13:40:00',3.85),('16273','2013-04-15','13:45:00',3.86),('16273','2013-04-15','13:50:00',3.81),('16273','2013-04-15','13:55:00',3.79),('16273','2013-04-15','14:00:00',3.75),('16273','2013-04-15','14:05:00',3.72),('16273','2013-04-15','14:10:00',3.66),('16273','2013-04-15','14:15:00',3.63),('16273','2013-04-15','14:20:00',3.59),('16273','2013-04-15','14:25:00',3.54),('16273','2013-04-15','14:30:00',3.5),('16273','2013-04-15','14:35:00',3.46),('16273','2013-04-15','14:40:00',3.42),('16273','2013-04-15','14:45:00',3.38),('16273','2013-04-15','14:50:00',3.34),('16273','2013-04-15','14:55:00',3.27),('16273','2013-04-15','15:00:00',3.23),('16273','2013-04-15','15:05:00',3.2),('16273','2013-04-15','15:10:00',3.15),('16273','2013-04-15','15:15:00',3.09),('16273','2013-04-15','15:20:00',3.03),('16273','2013-04-15','15:25:00',2.97),('16273','2013-04-15','15:30:00',2.91),('16273','2013-04-15','15:35:00',2.85),('16273','2013-04-15','15:40:00',2.77),('16273','2013-04-15','15:45:00',2.7),('16273','2013-04-15','15:50:00',2.63),('16273','2013-04-15','15:55:00',2.56),('16273','2013-04-15','16:00:00',2.49),('16273','2013-04-15','16:05:00',2.4),('16273','2013-04-15','16:10:00',2.33),('16273','2013-04-15','16:15:00',2.26),('16273','2013-04-15','16:20:00',2.2),('16273','2013-04-15','16:25:00',2.12),('16273','2013-04-15','16:30:00',2.04),('16273','2013-04-15','16:35:00',1.97),('16273','2013-04-15','16:40:00',1.88),('16273','2013-04-15','16:45:00',1.81),('16273','2013-04-15','16:50:00',1.73),('16273','2013-04-15','16:55:00',1.65),('16273','2013-04-15','17:00:00',1.57),('16273','2013-04-15','17:05:00',1.48),('16273','2013-04-15','17:10:00',1.4),('16273','2013-04-15','17:15:00',1.32),('16273','2013-04-15','17:20:00',1.24),('16273','2013-04-15','17:25:00',1.17),('16273','2013-04-15','17:30:00',1.1),('16273','2013-04-15','17:35:00',1.03),('16273','2013-04-14','07:45:00',1.07),('16273','2013-04-14','07:50:00',1.06),('16273','2013-04-14','07:55:00',1.31),('16273','2013-04-14','08:00:00',1.4),('16273','2013-04-14','08:05:00',1.45),('16273','2013-04-14','08:10:00',1.61),('16273','2013-04-14','08:15:00',1.66),('16273','2013-04-14','08:20:00',1.74),('16273','2013-04-14','08:25:00',1.81),('16273','2013-04-14','08:30:00',1.86),('16273','2013-04-14','08:35:00',1.95),('16273','2013-04-14','08:40:00',2.04),('16273','2013-04-14','08:45:00',2.06),('16273','2013-04-14','08:50:00',2.24),('16273','2013-04-14','08:55:00',2.33),('16273','2013-04-14','09:00:00',2.39),('16273','2013-04-14','09:05:00',2.44),('16273','2013-04-14','09:10:00',2.51),('16273','2013-04-14','09:15:00',2.58),('16273','2013-04-14','09:20:00',2.64),('16273','2013-04-14','09:25:00',2.71),('16273','2013-04-14','09:30:00',2.79),('16273','2013-04-14','09:35:00',2.86),('16273','2013-04-14','09:40:00',2.94),('16273','2013-04-14','09:45:00',3),('16273','2013-04-14','09:50:00',3.06),('16273','2013-04-14','09:55:00',3.12),('16273','2013-04-14','10:00:00',3.18),('16273','2013-04-14','10:05:00',3.23),('16273','2013-04-14','10:10:00',3.28),('16273','2013-04-14','10:15:00',3.32),('16273','2013-04-14','10:20:00',3.36),('16273','2013-04-14','10:25:00',3.39),('16273','2013-04-14','10:30:00',3.43),('16273','2013-04-14','10:35:00',3.48),('16273','2013-04-14','10:40:00',3.46),('16273','2013-04-14','10:45:00',3.58),('16273','2013-04-14','10:50:00',3.59),('16273','2013-04-14','10:55:00',3.65),('16273','2013-04-14','11:00:00',3.7),('16273','2013-04-14','11:05:00',3.72),('16273','2013-04-14','11:10:00',3.73),('16273','2013-04-14','11:15:00',3.75),('16273','2013-04-14','11:20:00',3.77),('16273','2013-04-14','11:25:00',3.79),('16273','2013-04-14','11:30:00',3.79),('16273','2013-04-14','11:35:00',3.81),('16273','2013-04-14','11:40:00',3.79),('16273','2013-04-14','11:45:00',3.82),('16273','2013-04-14','11:50:00',3.81),('16273','2013-04-14','11:55:00',3.76),('16273','2013-04-14','12:00:00',3.86),('16273','2013-04-14','12:05:00',3.87),('16273','2013-04-14','12:10:00',3.84),('16273','2013-04-14','12:15:00',3.88),('16273','2013-04-14','12:20:00',3.85),('16273','2013-04-14','12:25:00',3.88),('16273','2013-04-14','12:30:00',3.88),('16273','2013-04-14','12:35:00',3.84),('16273','2013-04-14','12:40:00',3.89),('16273','2013-04-14','12:45:00',3.89),('16273','2013-04-14','12:50:00',3.86),('16273','2013-04-14','12:55:00',3.8),('16273','2013-04-14','13:00:00',3.75),('16273','2013-04-14','13:05:00',2.84),('16273','2013-04-14','13:10:00',3.95),('16273','2013-04-14','13:15:00',3.94),('16273','2013-04-14','13:20:00',3.94),('16273','2013-04-14','13:25:00',1.78),('16273','2013-04-14','13:30:00',3.75),('16273','2013-04-14','13:35:00',3.46),('16273','2013-04-14','13:40:00',3.74),('16273','2013-04-14','13:45:00',3.8),('16273','2013-04-14','13:50:00',3.73),('16273','2013-04-14','13:55:00',3.38),('16273','2013-04-14','14:00:00',3.41),('16273','2013-04-14','14:05:00',3.36),('16273','2013-04-14','14:10:00',3.47),('16273','2013-04-14','14:15:00',3.04),('16273','2013-04-14','14:20:00',3.47),('16273','2013-04-14','14:25:00',3.43),('16273','2013-04-14','14:30:00',3.32),('16273','2013-04-14','14:35:00',3.31),('16273','2013-04-14','14:40:00',3.27),('16273','2013-04-14','14:45:00',3.25),('16273','2013-04-14','14:50:00',3.26),('16273','2013-04-14','14:55:00',3.18),('16273','2013-04-14','15:00:00',3.14),('16273','2013-04-14','15:05:00',3.1),('16273','2013-04-14','15:10:00',3.05),('16273','2013-04-14','15:15:00',2.99),('16273','2013-04-14','15:20:00',2.89),('16273','2013-04-14','15:25:00',2.86),('16273','2013-04-14','15:30:00',2.84),('16273','2013-04-14','15:35:00',2.76),('16273','2013-04-14','15:40:00',2.69),('16273','2013-04-14','15:45:00',2.64),('16273','2013-04-14','15:50:00',2.59),('16273','2013-04-14','15:55:00',2.53),('16273','2013-04-14','16:00:00',2.45),('16273','2013-04-14','16:05:00',2.35),('16273','2013-04-14','16:10:00',2.26),('16273','2013-04-14','16:15:00',2.2),('16273','2013-04-14','16:20:00',2.14),('16273','2013-04-14','16:25:00',2.07),('16273','2013-04-14','16:30:00',2),('16273','2013-04-14','16:35:00',1.92),('16273','2013-04-14','16:40:00',1.84),('16273','2013-04-14','16:45:00',1.76),('16273','2013-04-14','16:50:00',1.67),('16273','2013-04-14','16:55:00',1.6),('16273','2013-04-14','17:00:00',1.52),('16273','2013-04-14','17:05:00',1.43),('16273','2013-04-14','17:10:00',1.37),('16273','2013-04-14','17:15:00',1.29),('16273','2013-04-14','17:20:00',1.22),('16273','2013-04-14','17:25:00',1.15),('16273','2013-04-14','17:30:00',1.08),('16273','2013-04-14','17:35:00',1.01),('16273','2013-04-13','07:50:00',1.1),('16273','2013-04-13','07:55:00',1.06),('16273','2013-04-13','08:00:00',1.36),('16273','2013-04-13','08:05:00',1.42),('16273','2013-04-13','08:55:00',1.64),('16273','2013-04-13','09:00:00',2.44),('16273','2013-04-13','09:05:00',2.49),('16273','2013-04-13','09:10:00',2.62),('16273','2013-04-13','09:15:00',2.59),('16273','2013-04-13','09:20:00',2.71),('16273','2013-04-13','09:25:00',2.76),('16273','2013-04-13','09:30:00',2.79),('16273','2013-04-13','09:35:00',2.14),('16273','2013-04-13','09:40:00',1.85),('16273','2013-04-13','09:45:00',2.16),('16273','2013-04-13','09:50:00',3.24),('16273','2013-04-13','09:55:00',2.43),('16273','2013-04-13','10:05:00',1.62),('16273','2013-04-13','10:10:00',1.34),('16273','2013-04-13','10:15:00',1.15),('16273','2013-04-13','10:20:00',1.57),('16273','2013-04-13','10:25:00',3.91),('16273','2013-04-13','10:30:00',3.68),('16273','2013-04-13','10:35:00',3.64),('16273','2013-04-13','10:40:00',3.72),('16273','2013-04-13','10:45:00',3.38),('16273','2013-04-13','10:50:00',3.37),('16273','2013-04-13','10:55:00',3.7),('16273','2013-04-13','11:00:00',4.04),('16273','2013-04-13','11:05:00',3.99),('16273','2013-04-13','11:10:00',4.1),('16273','2013-04-13','11:15:00',3.3),('16273','2013-04-13','11:20:00',2.3),('16273','2013-04-13','11:25:00',4.1),('16273','2013-04-13','11:30:00',4.07),('16273','2013-04-13','11:35:00',3.75),('16273','2013-04-13','11:40:00',3.28),('16273','2013-04-13','11:45:00',4.1),('16273','2013-04-13','11:50:00',3.5),('16273','2013-04-13','11:55:00',3.18),('16273','2013-04-13','12:00:00',4.13),('16273','2013-04-13','12:05:00',2.2),('16273','2013-04-13','12:10:00',3.88),('16273','2013-04-13','12:15:00',4.18),('16273','2013-04-13','12:20:00',4.24),('16273','2013-04-13','12:25:00',4.2),('16273','2013-04-13','12:30:00',4.12),('16273','2013-04-13','12:35:00',2.36),('16273','2013-04-13','12:40:00',4.29),('16273','2013-04-13','12:45:00',4.05),('16273','2013-04-13','12:50:00',3.89),('16273','2013-04-13','12:55:00',3.95),('16273','2013-04-13','13:00:00',3.94),('16273','2013-04-13','13:05:00',4.08),('16273','2013-04-13','13:10:00',3.97),('16273','2013-04-13','13:15:00',3.76),('16273','2013-04-13','13:20:00',3.81),('16273','2013-04-13','13:25:00',3.82),('16273','2013-04-13','13:30:00',3.48),('16273','2013-04-13','13:35:00',3.13),('16273','2013-04-13','13:40:00',2.95),('16273','2013-04-13','13:45:00',3.3),('16273','2013-04-13','13:50:00',3.25),('16273','2013-04-13','13:55:00',3.28),('16273','2013-04-13','14:00:00',3.13),('16273','2013-04-13','14:05:00',3.15),('16273','2013-04-13','14:10:00',3.12),('16273','2013-04-13','14:15:00',3.11),('16273','2013-04-13','14:20:00',3.16),('16273','2013-04-13','14:25:00',3.31),('16273','2013-04-13','14:30:00',3.42),('16273','2013-04-13','14:35:00',3.38),('16273','2013-04-13','14:40:00',3.33),('16273','2013-04-13','14:45:00',3.23),('16273','2013-04-13','14:50:00',3.18),('16273','2013-04-13','14:55:00',3.03),('16273','2013-04-13','15:00:00',2.84),('16273','2013-04-13','15:05:00',2.87),('16273','2013-04-13','15:10:00',2.66),('16273','2013-04-13','15:15:00',2.57),('16273','2013-04-13','15:20:00',2.42),('16273','2013-04-13','15:25:00',2.44),('16273','2013-04-13','15:30:00',2.36),('16273','2013-04-13','15:35:00',2.38),('16273','2013-04-13','15:40:00',2.42),('16273','2013-04-13','15:45:00',2.43),('16273','2013-04-13','15:50:00',2.37),('16273','2013-04-13','15:55:00',2.24),('16273','2013-04-13','16:00:00',2.25),('16273','2013-04-13','16:05:00',2.04),('16273','2013-04-13','16:10:00',2.03),('16273','2013-04-13','16:15:00',1.95),('16273','2013-04-13','16:20:00',1.92),('16273','2013-04-13','16:25:00',1.71),('16273','2013-04-13','16:30:00',1.69),('16273','2013-04-13','16:35:00',1.53),('16273','2013-04-13','16:40:00',1.47),('16273','2013-04-13','16:45:00',1.53),('16273','2013-04-13','16:50:00',1.34),('16273','2013-04-13','16:55:00',1.15),('16273','2013-04-13','17:00:00',1.16),('16273','2013-04-13','17:05:00',1.37),('16273','2013-04-13','17:10:00',1.57),('16273','2013-04-13','17:15:00',1.31),('16273','2013-04-13','17:20:00',1.3),('16273','2013-04-13','17:25:00',1.26),('16273','2013-04-13','17:30:00',1.13),('16273','2013-04-13','17:35:00',1.12),('16273','2013-04-12','08:10:00',1.12),('16273','2013-04-12','08:15:00',1.93),('16273','2013-04-12','08:20:00',1.67),('16273','2013-04-12','08:25:00',1.15),('16273','2013-04-12','08:30:00',1.51),('16273','2013-04-12','08:35:00',1.79),('16273','2013-04-12','08:40:00',1.38),('16273','2013-04-12','08:45:00',1.59),('16273','2013-04-12','08:50:00',1.28),('16273','2013-04-12','08:55:00',1.53),('16273','2013-04-12','09:00:00',1.3),('16273','2013-04-12','09:15:00',1.74),('16273','2013-04-12','09:21:00',1.76),('16273','2013-04-12','09:25:00',1.44),('16273','2013-04-12','09:30:00',2.1),('16273','2013-04-12','09:35:00',3.33),('16273','2013-04-12','09:40:00',1.65),('16273','2013-04-12','09:45:00',1.17),('16273','2013-04-12','09:50:00',1.33),('16273','2013-04-12','09:55:00',1.07),('16273','2013-04-12','10:00:00',1.03),('16273','2013-04-12','10:05:00',1.14),('16273','2013-04-12','10:10:00',1.22),('16273','2013-04-12','10:15:00',1.14),('16273','2013-04-12','10:20:00',1.19),('16273','2013-04-12','10:25:00',1.12),('16273','2013-04-12','10:30:00',1.14),('16273','2013-04-12','10:35:00',1.52),('16273','2013-04-12','10:40:00',1.86),('16273','2013-04-12','10:45:00',3.44),('16273','2013-04-12','10:50:00',2.78),('16273','2013-04-12','10:55:00',3),('16273','2013-04-12','11:01:00',4.37),('16273','2013-04-12','11:05:00',3.83),('16273','2013-04-12','11:10:00',3.34),('16273','2013-04-12','11:15:00',4.19),('16273','2013-04-12','11:20:00',2.92),('16273','2013-04-12','11:25:00',4.08),('16273','2013-04-12','11:30:00',4.17),('16273','2013-04-12','11:35:00',3.54),('16273','2013-04-12','11:40:00',2.75),('16273','2013-04-12','11:45:00',3.98),('16273','2013-04-12','11:50:00',3.07),('16273','2013-04-12','11:55:00',4.33),('16273','2013-04-12','12:00:00',3.97),('16273','2013-04-12','12:05:00',3.91),('16273','2013-04-12','12:10:00',4.08),('16273','2013-04-12','12:15:00',4.13),('16273','2013-04-12','12:20:00',4.12),('16273','2013-04-12','12:25:00',4.23),('16273','2013-04-12','12:30:00',4.12),('16273','2013-04-12','12:35:00',3.94),('16273','2013-04-12','12:40:00',3.93),('16273','2013-04-12','12:45:00',3.63),('16273','2013-04-12','12:50:00',4.03),('16273','2013-04-12','12:55:00',3.95),('16273','2013-04-12','13:00:00',4),('16273','2013-04-12','13:05:00',4.01),('16273','2013-04-12','13:10:00',3.99),('16273','2013-04-12','13:15:00',3.95),('16273','2013-04-12','13:20:00',3.92),('16273','2013-04-12','13:25:00',3.91),('16273','2013-04-12','13:30:00',3.88),('16273','2013-04-12','13:35:00',3.84),('16273','2013-04-12','13:40:00',3.85),('16273','2013-04-12','13:45:00',3.85),('16273','2013-04-12','13:50:00',3.8),('16273','2013-04-12','13:55:00',3.75),('16273','2013-04-12','14:00:00',3.72),('16273','2013-04-12','14:05:00',3.68),('16273','2013-04-12','14:10:00',3.62),('16273','2013-04-12','14:15:00',3.54),('16273','2013-04-12','14:20:00',3.56),('16273','2013-04-12','14:25:00',3.52),('16273','2013-04-12','14:30:00',3.47),('16273','2013-04-12','14:35:00',3.43),('16273','2013-04-12','14:40:00',3.39),('16273','2013-04-12','14:45:00',3.35),('16273','2013-04-12','14:50:00',3.29),('16273','2013-04-12','14:55:00',3.23),('16273','2013-04-12','15:00:00',3.19),('16273','2013-04-12','15:05:00',3.15),('16273','2013-04-12','15:10:00',3.1),('16273','2013-04-12','15:15:00',3.03),('16273','2013-04-12','15:20:00',2.98),('16273','2013-04-12','15:25:00',2.92),('16273','2013-04-12','15:30:00',2.85),('16273','2013-04-12','15:35:00',2.78),('16273','2013-04-12','15:40:00',2.72),('16273','2013-04-12','15:45:00',2.67),('16273','2013-04-12','15:50:00',2.6),('16273','2013-04-12','15:55:00',2.53),('16273','2013-04-12','16:00:00',2.46),('16273','2013-04-12','16:05:00',2.41),('16273','2013-04-12','16:10:00',2.3),('16273','2013-04-12','16:15:00',2.34),('16273','2013-04-12','16:20:00',2.18),('16273','2013-04-12','16:25:00',1.8),('16273','2013-04-12','16:30:00',2.24),('16273','2013-04-12','16:35:00',2.19),('16273','2013-04-12','16:40:00',1.96),('16273','2013-04-12','16:45:00',1.78),('16273','2013-04-12','16:50:00',1.7),('16273','2013-04-12','16:55:00',1.32),('16273','2013-04-12','17:05:00',1.45),('16273','2013-04-12','17:10:00',1.45),('16273','2013-04-12','17:20:00',1.44),('16273','2013-04-12','17:25:00',1.29),('16273','2013-04-12','17:30:00',1.07),('16273','2013-04-12','17:35:00',1.09),('16273','2014-03-28','07:05:00',1.04),('16273','2014-03-28','07:10:00',1.26),('16273','2014-03-28','07:15:00',1.34),('16273','2014-03-28','07:20:00',1.2),('16273','2014-03-28','07:25:00',1.4),('16273','2014-03-28','07:30:00',1.62),('16273','2014-03-28','07:35:00',1.79),('16273','2014-03-28','07:40:00',1.88),('16273','2014-03-28','07:45:00',1.95),('16273','2014-03-28','07:50:00',2.03),('16273','2014-03-28','07:55:00',2.1),('16273','2014-03-28','08:00:00',2.19),('16273','2014-03-28','08:05:00',2.29),('16273','2014-03-28','08:10:00',2.37),('16273','2014-03-28','08:15:00',2.43),('16273','2014-03-28','08:20:00',2.47),('16273','2014-03-28','08:25:00',2.54),('16273','2014-03-28','08:30:00',2.62),('16273','2014-03-28','08:35:00',2.68),('16273','2014-03-28','08:40:00',2.76),('16273','2014-03-28','08:45:00',2.83),('16273','2014-03-28','08:50:00',2.9),('16273','2014-03-28','08:55:00',3.02),('16273','2014-03-28','09:00:00',3.13),('16273','2014-03-28','09:05:00',3.27),('16273','2014-03-28','09:10:00',3.41),('16273','2014-03-28','09:15:00',3.01),('16273','2014-03-28','09:20:00',2.84),('16273','2014-03-28','09:25:00',3.72),('16273','2014-03-28','09:30:00',3.47),('16273','2014-03-28','09:35:00',2.15),('16273','2014-03-28','09:40:00',2.72),('16273','2014-03-28','09:45:00',2.61),('16273','2014-03-28','09:50:00',2.47),('16273','2014-03-28','09:55:00',3.18),('16273','2014-03-28','10:00:00',3.59),('16273','2014-03-28','10:05:00',3.62),('16273','2014-03-28','10:10:00',3.58),('16273','2014-03-28','10:15:00',3.48),('16273','2014-03-28','10:20:00',3.46),('16273','2014-03-28','10:25:00',3.66),('16273','2014-03-28','10:30:00',3.72),('16273','2014-03-28','10:35:00',3.79),('16273','2014-03-28','10:40:00',3.78),('16273','2014-03-28','10:45:00',3.7),('16273','2014-03-28','10:50:00',3.35),('16273','2014-03-28','10:55:00',3.75),('16273','2014-03-28','11:00:00',3.79),('16273','2014-03-28','11:05:00',3.82),('16273','2014-03-28','11:10:00',3.81),('16273','2014-03-28','11:15:00',3.83),('16273','2014-03-28','11:20:00',3.81),('16273','2014-03-28','11:25:00',3.67),('16273','2014-03-28','11:30:00',3.81),('16273','2014-03-28','11:35:00',3.87),('16273','2014-03-28','11:40:00',3.89),('16273','2014-03-28','11:45:00',3.88),('16273','2014-03-28','11:50:00',3.91),('16273','2014-03-28','11:55:00',4.03),('16273','2014-03-28','12:00:00',4.17),('16273','2014-03-28','12:05:00',3.17),('16273','2014-03-28','12:15:00',2.59),('16273','2014-03-28','12:20:00',4.17),('16273','2014-03-28','12:25:00',3.3),('16273','2014-03-28','12:30:00',3.73),('16273','2014-03-28','12:35:00',3.24),('16273','2014-03-28','12:40:00',2.46),('16273','2014-03-28','12:45:00',3.96),('16273','2014-03-28','12:50:00',3.89),('16273','2014-03-28','12:55:00',3.93),('16273','2014-03-28','13:00:00',3.87),('16273','2014-03-28','13:05:00',2.89),('16273','2014-03-28','13:10:00',2.91),('16273','2014-03-28','13:15:00',1.77),('16273','2014-03-28','13:20:00',2.77),('16273','2014-03-28','13:25:00',2.07),('16273','2014-03-28','13:30:00',1.43),('16273','2014-03-28','13:35:00',2.3),('16273','2014-03-28','13:40:00',3.23),('16273','2014-03-28','13:45:00',3.36),('16273','2014-03-28','13:50:00',3.27),('16273','2014-03-28','13:55:00',3.2),('16273','2014-03-28','14:00:00',3.13),('16273','2014-03-28','14:05:00',3.08),('16273','2014-03-28','14:10:00',3.01),('16273','2014-03-28','14:15:00',2.94),('16273','2014-03-28','14:20:00',2.89),('16273','2014-03-28','14:25:00',2.83),('16273','2014-03-28','14:30:00',2.78),('16273','2014-03-28','14:35:00',2.72),('16273','2014-03-28','14:40:00',2.66),('16273','2014-03-28','14:45:00',2.58),('16273','2014-03-28','14:50:00',2.52),('16273','2014-03-28','14:55:00',2.43),('16273','2014-03-28','15:00:00',2.37),('16273','2014-03-28','15:05:00',2.3),('16273','2014-03-28','15:10:00',2.22),('16273','2014-03-28','15:15:00',2.15),('16273','2014-03-28','15:20:00',2.06),('16273','2014-03-28','15:25:00',1.97),('16273','2014-03-28','15:30:00',1.9),('16273','2014-03-28','15:35:00',1.84),('16273','2014-03-28','15:40:00',1.75),('16273','2014-03-28','15:45:00',1.68),('16273','2014-03-28','15:50:00',1.62),('16273','2014-03-28','15:55:00',1.57),('16273','2014-03-28','16:00:00',1.52),('16273','2014-03-28','16:05:00',1.46),('16273','2014-03-28','16:10:00',1.33),('16273','2014-03-28','16:15:00',1.25),('16273','2014-03-28','16:20:00',1.19),('16273','2014-03-28','16:25:00',1.16),('16273','2014-03-28','16:30:00',1.16),('16273','2013-04-11','07:45:00',1.02),('16273','2013-04-11','07:50:00',1.15),('16273','2013-04-11','07:55:00',1.11),('16273','2013-04-11','08:00:00',1.39),('16273','2013-04-11','08:05:00',1.5),('16273','2013-04-11','08:10:00',1.59),('16273','2013-04-11','08:15:00',1.66),('16273','2013-04-11','08:20:00',1.78),('16273','2013-04-11','08:25:00',1.85),('16273','2013-04-11','08:30:00',1.95),('16273','2013-04-11','08:35:00',2.02),('16273','2013-04-11','08:40:00',2.11),('16273','2013-04-11','08:45:00',2.2),('16273','2013-04-11','08:50:00',2.31),('16273','2013-04-11','08:55:00',2.36),('16273','2013-04-11','09:00:00',2.39),('16273','2013-04-11','09:05:00',2.49),('16273','2013-04-11','09:10:00',2.57),('16273','2013-04-11','09:15:00',2.63),('16273','2013-04-11','09:20:00',2.74),('16273','2013-04-11','09:25:00',2.79),('16273','2013-04-11','09:30:00',2.88),('16273','2013-04-11','09:35:00',2.78),('16273','2013-04-11','09:40:00',3.25),('16273','2013-04-11','09:45:00',2.84),('16273','2013-04-11','09:50:00',2.79),('16273','2013-04-11','10:00:00',2.56),('16273','2013-04-11','10:05:00',3.39),('16273','2013-04-11','10:10:00',3.18),('16273','2013-04-11','10:15:00',2.82),('16273','2013-04-11','10:20:00',3.58),('16273','2013-04-11','10:25:00',3.61),('16273','2013-04-11','10:30:00',3.71),('16273','2013-04-11','10:35:00',3.87),('16273','2013-04-11','10:40:00',3.82),('16273','2013-04-11','10:45:00',2.5),('16273','2013-04-11','10:50:00',1.19),('16273','2013-04-11','10:55:00',1.95),('16273','2013-04-11','11:00:00',1.38),('16273','2013-04-11','11:05:00',1.02),('16273','2013-04-11','11:10:00',1.47),('16273','2013-04-11','11:15:00',1.32),('16273','2013-04-11','11:20:00',1.46),('16273','2013-04-11','11:25:00',4.5),('16273','2013-04-11','11:30:00',4.1),('16273','2013-04-11','11:35:00',1.57),('16273','2013-04-11','11:40:00',1.89),('16273','2013-04-11','11:45:00',4.6),('16273','2013-04-11','11:50:00',2.96),('16273','2013-04-11','11:55:00',2.51),('16273','2013-04-11','12:00:00',2.24),('16273','2013-04-11','12:05:00',3.67),('16273','2013-04-11','12:10:00',2.61),('16273','2013-04-11','12:15:00',4.44),('16273','2013-04-11','12:20:00',3.06),('16273','2013-04-11','12:25:00',3.91),('16273','2013-04-11','12:30:00',4.24),('16273','2013-04-11','12:35:00',2.59),('16273','2013-04-11','12:40:00',2.24),('16273','2013-04-11','12:45:00',3.41),('16273','2013-04-11','12:50:00',4.23),('16273','2013-04-11','12:55:00',2.98),('16273','2013-04-11','13:00:00',2.71),('16273','2013-04-11','13:05:00',3.28),('16273','2013-04-11','13:10:00',3.96),('16273','2013-04-11','13:15:00',1.75),('16273','2013-04-11','13:20:00',4.08),('16273','2013-04-11','13:25:00',4.24),('16273','2013-04-11','13:30:00',2.34),('16273','2013-04-11','13:35:00',4.06),('16273','2013-04-11','13:40:00',2.33),('16273','2013-04-11','13:45:00',3.16),('16273','2013-04-11','13:50:00',4.21),('16273','2013-04-11','13:55:00',4),('16273','2013-04-11','14:00:00',3.32),('16273','2013-04-11','14:05:00',2.1),('16273','2013-04-11','14:10:00',4.05),('16273','2013-04-11','14:20:00',3.91),('16273','2013-04-11','14:25:00',2.87),('16273','2013-04-11','14:30:00',3.01),('16273','2013-04-11','14:35:00',3.65),('16273','2013-04-11','14:40:00',3.52),('16273','2013-04-11','14:45:00',3.47),('16273','2013-04-11','14:50:00',3.47),('16273','2013-04-11','14:55:00',3.37),('16273','2013-04-11','15:00:00',3.27),('16273','2013-04-11','15:05:00',2.98),('16273','2013-04-11','15:10:00',3.2),('16273','2013-04-11','15:15:00',3.04),('16273','2013-04-11','15:20:00',3.01),('16273','2013-04-11','15:25:00',2.96),('16273','2013-04-11','15:30:00',2.91),('16273','2013-04-11','15:35:00',2.86),('16273','2013-04-11','15:40:00',2.81),('16273','2013-04-11','15:45:00',2.72),('16273','2013-04-11','15:50:00',2.62),('16273','2013-04-11','15:55:00',2.56),('16273','2013-04-11','16:00:00',2.49),('16273','2013-04-11','16:05:00',2.42),('16273','2013-04-11','16:10:00',2.34),('16273','2013-04-11','16:15:00',2.27),('16273','2013-04-11','16:20:00',2.2),('16273','2013-04-11','16:25:00',2.12),('16273','2013-04-11','16:30:00',2.04),('16273','2013-04-11','16:35:00',1.96),('16273','2013-04-11','16:40:00',1.88),('16273','2013-04-11','16:45:00',1.81),('16273','2013-04-11','16:50:00',1.73),('16273','2013-04-11','16:55:00',1.64),('16273','2013-04-11','17:00:00',1.56),('16273','2013-04-11','17:05:00',1.48),('16273','2013-04-11','17:10:00',1.4),('16273','2013-04-11','17:15:00',1.32),('16273','2013-04-11','17:20:00',1.25),('16273','2013-04-11','17:25:00',1.18),('16273','2013-04-11','17:30:00',1.1),('16273','2013-04-11','17:35:00',1.03),('16273','2013-04-10','08:25:00',1.12),('16273','2013-04-10','08:45:00',1.22),('16273','2013-04-10','08:50:00',1.31),('16273','2013-04-10','08:55:00',1.08),('16273','2013-04-10','09:00:00',1.56),('16273','2013-04-10','09:05:00',2.58),('16273','2013-04-10','09:10:00',2.47),('16273','2013-04-10','09:15:00',2.62),('16273','2013-04-10','09:20:00',2.77),('16273','2013-04-10','09:25:00',2.85),('16273','2013-04-10','09:30:00',2.91),('16273','2013-04-10','09:35:00',2.99),('16273','2013-04-10','09:40:00',3.09),('16273','2013-04-10','09:45:00',3.17),('16273','2013-04-10','09:50:00',3.12),('16273','2013-04-10','09:55:00',3.29),('16273','2013-04-10','10:00:00',3.31),('16273','2013-04-10','10:05:00',2.79),('16273','2013-04-10','10:10:00',2.35),('16273','2013-04-10','10:15:00',3.02),('16273','2013-04-10','10:20:00',3.62),('16273','2013-04-10','10:25:00',2.14),('16273','2013-04-10','10:30:00',2.44),('16273','2013-04-10','10:40:00',2.82),('16273','2013-04-10','10:45:00',3.41),('16273','2013-04-10','10:50:00',2.52),('16273','2013-04-10','10:55:00',3.89),('16273','2013-04-10','11:00:00',3.78),('16273','2013-04-10','11:05:00',3.63),('16273','2013-04-10','11:10:00',2.15),('16273','2013-04-10','11:15:00',3.31),('16273','2013-04-10','11:20:00',3.67),('16273','2013-04-10','11:25:00',4.2),('16273','2013-04-10','11:30:00',4.1),('16273','2013-04-10','11:35:00',3.5),('16273','2013-04-10','11:40:00',4.06),('16273','2013-04-10','11:45:00',4.1),('16273','2013-04-10','11:50:00',4.1),('16273','2013-04-10','11:55:00',4.13),('16273','2013-04-10','12:00:00',4.07),('16273','2013-04-10','12:05:00',4.3),('16273','2013-04-10','12:10:00',2.8),('16273','2013-04-10','12:15:00',2.37),('16273','2013-04-10','12:20:00',1.99),('16273','2013-04-10','12:25:00',3.15),('16273','2013-04-10','12:30:00',3.76),('16273','2013-04-10','12:35:00',3.51),('16273','2013-04-10','12:40:00',4.44),('16273','2013-04-10','12:45:00',1.29),('16273','2013-04-10','12:50:00',3.99),('16273','2013-04-10','12:55:00',4.27),('16273','2013-04-10','13:00:00',3.79),('16273','2013-04-10','13:05:00',4.24),('16273','2013-04-10','13:10:00',4.3),('16273','2013-04-10','13:15:00',4.17),('16273','2013-04-10','13:20:00',2.57),('16273','2013-04-10','13:25:00',2.08),('16273','2013-04-10','13:30:00',2.77),('16273','2013-04-10','13:35:00',3.62),('16273','2013-04-10','13:40:00',3.03),('16273','2013-04-10','13:45:00',2.79),('16273','2013-04-10','13:50:00',3.11),('16273','2013-04-10','13:55:00',2.42),('16273','2013-04-10','14:00:00',1.98),('16273','2013-04-10','14:05:00',2.31),('16273','2013-04-10','14:10:00',3.53),('16273','2013-04-10','14:15:00',3.48),('16273','2013-04-10','14:20:00',1.5),('16273','2013-04-10','14:25:00',3.18),('16273','2013-04-10','14:30:00',2.48),('16273','2013-04-10','14:35:00',3.06),('16273','2013-04-10','14:40:00',2.59),('16273','2013-04-10','14:45:00',2.59),('16273','2013-04-10','14:50:00',3.7),('16273','2013-04-10','14:55:00',2.76),('16273','2013-04-10','15:00:00',2.4),('16273','2013-04-10','15:05:00',2.52),('16273','2013-04-10','15:10:00',2.91),('16273','2013-04-10','15:15:00',2.43),('16273','2013-04-10','15:20:00',3.09),('16273','2013-04-10','15:25:00',3),('16273','2013-04-10','15:30:00',2.94),('16273','2013-04-10','15:35:00',2.83),('16273','2013-04-10','15:40:00',2.82),('16273','2013-04-10','15:45:00',2.52),('16273','2013-04-10','15:50:00',2.24),('16273','2013-04-10','15:55:00',2.56),('16273','2013-04-10','16:00:00',2.58),('16273','2013-04-10','16:05:00',2.01),('16273','2013-04-10','16:10:00',2.36),('16273','2013-04-10','16:15:00',1.98),('16273','2013-04-10','16:20:00',2.11),('16273','2013-04-10','16:25:00',1.53),('16273','2013-04-10','16:30:00',1.46),('16273','2013-04-10','16:35:00',1.91),('16273','2013-04-10','16:40:00',1.47),('16273','2013-04-10','16:45:00',1.12),('16273','2013-04-10','17:10:00',1.33),('16273','2013-04-10','17:15:00',1.01),('16273','2013-04-10','17:20:00',1.41),('16273','2013-04-10','17:25:00',1.54),('16273','2013-04-10','17:30:00',1.16),('16273','2013-04-10','17:35:00',1.23),('16273','2013-04-10','17:45:00',1.01),('16273','2013-04-09','08:05:00',1.4),('16273','2013-04-09','08:10:00',1.62),('16273','2013-04-09','08:15:00',1.88),('16273','2013-04-09','08:30:00',1.09),('16273','2013-04-09','08:35:00',2.1),('16273','2013-04-09','08:40:00',1.51),('16273','2013-04-09','08:45:00',2.11),('16273','2013-04-09','08:50:00',2.34),('16273','2013-04-09','08:55:00',2.47),('16273','2013-04-09','09:00:00',2.41),('16273','2013-04-09','09:05:00',1.48),('16273','2013-04-09','09:10:00',1.14),('16273','2013-04-09','09:15:00',1.39),('16273','2013-04-09','09:20:00',1.27),('16273','2013-04-09','09:25:00',1.04),('16273','2013-04-09','09:30:00',2.33),('16273','2013-04-09','09:35:00',2.04),('16273','2013-04-09','09:40:00',2.41),('16273','2013-04-09','09:45:00',2.09),('16273','2013-04-09','09:50:00',1.37),('16273','2013-04-09','09:55:00',1.26),('16273','2013-04-09','10:15:00',2.8),('16273','2013-04-09','10:20:00',3.91),('16273','2013-04-09','10:25:00',2.79),('16273','2013-04-09','10:30:00',1.95),('16273','2013-04-09','10:35:00',1.98),('16273','2013-04-09','10:40:00',2.7),('16273','2013-04-09','10:45:00',2.49),('16273','2013-04-09','10:50:00',2.59),('16273','2013-04-09','10:55:00',2.45),('16273','2013-04-09','11:00:00',1.06),('16273','2013-04-09','11:05:00',4.18),('16273','2013-04-09','11:10:00',3.51),('16273','2013-04-09','11:15:00',3.12),('16273','2013-04-09','11:20:00',4.25),('16273','2013-04-09','11:25:00',2.69),('16273','2013-04-09','11:30:00',3.26),('16273','2013-04-09','11:35:00',2.93),('16273','2013-04-09','11:40:00',3.65),('16273','2013-04-09','11:45:00',3.91),('16273','2013-04-09','11:50:00',2.06),('16273','2013-04-09','11:55:00',3.2),('16273','2013-04-09','12:00:00',4.57),('16273','2013-04-09','12:05:00',3.41),('16273','2013-04-09','12:10:00',1.43),('16273','2013-04-09','12:15:00',3.05),('16273','2013-04-09','12:20:00',3.48),('16273','2013-04-09','12:25:00',3.75),('16273','2013-04-09','12:30:00',4.28),('16273','2013-04-09','12:35:00',3.4),('16273','2013-04-09','12:40:00',2.44),('16273','2013-04-09','12:45:00',4.69),('16273','2013-04-09','12:50:00',4.65),('16273','2013-04-09','12:55:00',4.43),('16273','2013-04-09','13:00:00',4.04),('16273','2013-04-09','13:05:00',4.55),('16273','2013-04-09','13:10:00',4.37),('16273','2013-04-09','13:15:00',4.14),('16273','2013-04-09','13:20:00',3.92),('16273','2013-04-09','13:25:00',3),('16273','2013-04-09','13:30:00',4.17),('16273','2013-04-09','13:35:00',3.2),('16273','2013-04-09','13:40:00',3.92),('16273','2013-04-09','13:45:00',3.03),('16273','2013-04-09','13:50:00',3.93),('16273','2013-04-09','13:55:00',3.69),('16273','2013-04-09','14:00:00',3.37),('16273','2013-04-09','14:05:00',3.51),('16273','2013-04-09','14:10:00',3.13),('16273','2013-04-09','14:15:00',3.34),('16273','2013-04-09','14:20:00',3.04),('16273','2013-04-09','14:25:00',1.89),('16273','2013-04-09','14:30:00',2.66),('16273','2013-04-09','14:35:00',2.68),('16273','2013-04-09','14:40:00',3.05),('16273','2013-04-09','14:45:00',2.12),('16273','2013-04-09','14:50:00',3.46),('16273','2013-04-09','14:55:00',3.42),('16273','2013-04-09','15:00:00',3.42),('16273','2013-04-09','15:05:00',3.26),('16273','2013-04-09','15:10:00',3.21),('16273','2013-04-09','15:15:00',3.14),('16273','2013-04-09','15:20:00',3.17),('16273','2013-04-09','15:25:00',3.11),('16273','2013-04-09','15:30:00',3.03),('16273','2013-04-09','15:35:00',2.92),('16273','2013-04-09','15:40:00',2.89),('16273','2013-04-09','15:45:00',2.81),('16273','2013-04-09','15:50:00',2.59),('16273','2013-04-09','15:55:00',2.04),('16273','2013-04-09','16:00:00',2.25),('16273','2013-04-09','16:05:00',2.59),('16273','2013-04-09','16:10:00',2.39),('16273','2013-04-09','16:15:00',2.09),('16273','2013-04-09','16:20:00',2.22),('16273','2013-04-09','16:25:00',2.27),('16273','2013-04-09','16:30:00',2.02),('16273','2013-04-09','16:35:00',1.95),('16273','2013-04-09','16:40:00',1.86),('16273','2013-04-09','16:45:00',2.04),('16273','2013-04-09','16:50:00',1.95),('16273','2013-04-09','16:55:00',1.75),('16273','2013-04-09','17:00:00',1.88),('16273','2013-04-09','17:05:00',1.73),('16273','2013-04-09','17:10:00',1.62),('16273','2013-04-09','17:15:00',1.49),('16273','2013-04-09','17:20:00',1.42),('16273','2013-04-09','17:25:00',1.12),('16273','2013-04-09','17:30:00',1.1),('16273','2013-04-09','17:35:00',1.08),('16273','2013-04-09','17:40:00',1.02),('16273','2013-04-09','17:45:00',1.05),('16273','2013-04-08','08:00:00',1.07),('16273','2013-04-08','08:15:00',1.27),('16273','2013-04-08','08:25:00',1.14),('16273','2013-04-08','08:30:00',1.31),('16273','2013-04-08','08:35:00',1.87),('16273','2013-04-08','08:40:00',1.19),('16273','2013-04-08','08:45:00',1.53),('16273','2013-04-08','08:50:00',2.15),('16273','2013-04-08','08:55:00',2.57),('16273','2013-04-08','09:00:00',2.49),('16273','2013-04-08','09:05:00',2.53),('16273','2013-04-08','09:10:00',2.55),('16273','2013-04-08','09:15:00',2.86),('16273','2013-04-08','09:20:00',2.88),('16273','2013-04-08','09:25:00',2.94),('16273','2013-04-08','09:30:00',3.08),('16273','2013-04-08','09:35:00',3.2),('16273','2013-04-08','09:40:00',2.99),('16273','2013-04-08','09:45:00',1.87),('16273','2013-04-08','09:50:00',1.97),('16273','2013-04-08','09:55:00',3.22),('16273','2013-04-08','10:00:00',3.43),('16273','2013-04-08','10:05:00',3.37),('16273','2013-04-08','10:10:00',3.42),('16273','2013-04-08','10:15:00',3.46),('16273','2013-04-08','10:20:00',3.38),('16273','2013-04-08','10:25:00',3.42),('16273','2013-04-08','10:30:00',3.27),('16273','2013-04-08','10:35:00',3.63),('16273','2013-04-08','10:40:00',3.7),('16273','2013-04-08','10:45:00',3.62),('16273','2013-04-08','10:50:00',3.42),('16273','2013-04-08','10:55:00',3.54),('16273','2013-04-08','11:00:00',3.21),('16273','2013-04-08','11:05:00',2.91),('16273','2013-04-08','11:10:00',2.53),('16273','2013-04-08','11:15:00',2.12),('16273','2013-04-08','11:20:00',1.93),('16273','2013-04-08','11:25:00',2.51),('16273','2013-04-08','11:30:00',3.09),('16273','2013-04-08','11:35:00',2.81),('16273','2013-04-08','11:40:00',2.77),('16273','2013-04-08','11:45:00',2.33),('16273','2013-04-08','11:50:00',2.54),('16273','2013-04-08','11:55:00',2.21),('16273','2013-04-08','12:00:00',2.1),('16273','2013-04-08','12:05:00',2.48),('16273','2013-04-08','12:10:00',2.79),('16273','2013-04-08','12:15:00',2.85),('16273','2013-04-08','12:20:00',2.74),('16273','2013-04-08','12:25:00',2.81),('16273','2013-04-08','12:30:00',2.85),('16273','2013-04-08','12:35:00',3.46),('16273','2013-04-08','12:40:00',3.2),('16273','2013-04-08','12:45:00',3.34),('16273','2013-04-08','12:50:00',3.27),('16273','2013-04-08','12:55:00',3.29),('16273','2013-04-08','13:00:00',2.89),('16273','2013-04-08','13:05:00',3.41),('16273','2013-04-08','13:10:00',2.86),('16273','2013-04-08','13:15:00',3.31),('16273','2013-04-08','13:20:00',3.13),('16273','2013-04-08','13:25:00',3.25),('16273','2013-04-08','13:30:00',2.88),('16273','2013-04-08','13:35:00',3.06),('16273','2013-04-08','13:40:00',2.72),('16273','2013-04-08','13:45:00',3.59),('16273','2013-04-08','13:50:00',3.44),('16273','2013-04-08','13:55:00',2.57),('16273','2013-04-08','14:00:00',3.23),('16273','2013-04-08','14:05:00',3.32),('16273','2013-04-08','14:10:00',3.35),('16273','2013-04-08','14:15:00',2.84),('16273','2013-04-08','14:20:00',3.25),('16273','2013-04-08','14:25:00',3.32),('16273','2013-04-08','14:30:00',3.18),('16273','2013-04-08','14:35:00',3.2),('16273','2013-04-08','14:40:00',3.34),('16273','2013-04-08','14:45:00',3.37),('16273','2013-04-08','14:50:00',3.44),('16273','2013-04-08','14:55:00',2.58),('16273','2013-04-08','15:00:00',2.85),('16273','2013-04-08','15:05:00',2.86),('16273','2013-04-08','15:10:00',2.32),('16273','2013-04-08','15:15:00',2.91),('16273','2013-04-08','15:20:00',3.13),('16273','2013-04-08','15:25:00',3.03),('16273','2013-04-08','15:30:00',2.92),('16273','2013-04-08','15:35:00',2.87),('16273','2013-04-08','15:40:00',2.78),('16273','2013-04-08','15:45:00',2.71),('16273','2013-04-08','15:50:00',2.65),('16273','2013-04-08','15:55:00',2.58),('16273','2013-04-08','16:00:00',2.41),('16273','2013-04-08','16:05:00',2.28),('16273','2013-04-08','16:10:00',2.34),('16273','2013-04-08','16:15:00',2.33),('16273','2013-04-08','16:20:00',2.2),('16273','2013-04-08','16:25:00',2.11),('16273','2013-04-08','16:30:00',2.06),('16273','2013-04-08','16:35:00',1.97),('16273','2013-04-08','16:40:00',1.9),('16273','2013-04-08','16:45:00',1.8),('16273','2013-04-08','16:50:00',1.74),('16273','2013-04-08','16:55:00',1.67),('16273','2013-04-08','17:00:00',1.59),('16273','2013-04-08','17:05:00',1.46),('16273','2013-04-08','17:10:00',1.36),('16273','2013-04-08','17:15:00',1.28),('16273','2013-04-08','17:20:00',1.29),('16273','2013-04-08','17:25:00',1.16),('16273','2013-04-08','17:30:00',1.09),('16273','2013-04-07','08:15:00',1.05),('16273','2013-04-07','08:20:00',1.14),('16273','2013-04-07','08:25:00',1.26),('16273','2013-04-07','08:30:00',1.37),('16273','2013-04-07','08:35:00',1.42),('16273','2013-04-07','08:40:00',1.46),('16273','2013-04-07','08:45:00',1.56),('16273','2013-04-07','08:50:00',1.71),('16273','2013-04-07','08:55:00',1.78),('16273','2013-04-07','09:00:00',1.89),('16273','2013-04-07','09:05:00',1.96),('16273','2013-04-07','09:10:00',2.01),('16273','2013-04-07','09:15:00',2.04),('16273','2013-04-07','09:20:00',2.22),('16273','2013-04-07','09:25:00',2.08),('16273','2013-04-07','09:30:00',2.03),('16273','2013-04-07','09:35:00',2.13),('16273','2013-04-07','09:40:00',2.25),('16273','2013-04-07','09:45:00',2.27),('16273','2013-04-07','09:50:00',2.49),('16273','2013-04-07','09:55:00',2.51),('16273','2013-04-07','10:00:00',2.44),('16273','2013-04-07','10:05:00',2.14),('16273','2013-04-07','10:10:00',1.88),('16273','2013-04-07','10:15:00',2.33),('16273','2013-04-07','10:20:00',2.63),('16273','2013-04-07','10:25:00',2.91),('16273','2013-04-07','10:30:00',3.18),('16273','2013-04-07','10:35:00',3.26),('16273','2013-04-07','10:40:00',3.38),('16273','2013-04-07','10:45:00',3.36),('16273','2013-04-07','10:50:00',3.12),('16273','2013-04-07','10:55:00',3.07),('16273','2013-04-07','11:00:00',3.09),('16273','2013-04-07','11:05:00',2.79),('16273','2013-04-07','11:10:00',2.76),('16273','2013-04-07','11:15:00',2.41),('16273','2013-04-07','11:20:00',2.19),('16273','2013-04-07','11:25:00',2.17),('16273','2013-04-07','11:30:00',2.35),('16273','2013-04-07','11:35:00',2.74),('16273','2013-04-07','11:40:00',3.44),('16273','2013-04-07','11:45:00',3.76),('16273','2013-04-07','11:50:00',3.95),('16273','2013-04-07','11:55:00',3.69),('16273','2013-04-07','12:00:00',2.78),('16273','2013-04-07','12:05:00',2.81),('16273','2013-04-07','12:10:00',2.84),('16273','2013-04-07','12:15:00',2.82),('16273','2013-04-07','12:20:00',2.7),('16273','2013-04-07','12:25:00',2.89),('16273','2013-04-07','12:30:00',3.17),('16273','2013-04-07','12:35:00',3.22),('16273','2013-04-07','12:40:00',3.01),('16273','2013-04-07','12:45:00',3),('16273','2013-04-07','12:50:00',2.66),('16273','2013-04-07','12:55:00',3),('16273','2013-04-07','13:00:00',2.97),('16273','2013-04-07','13:05:00',2.82),('16273','2013-04-07','13:10:00',2.77),('16273','2013-04-07','13:15:00',2.96),('16273','2013-04-07','13:20:00',2.8),('16273','2013-04-07','13:25:00',2.54),('16273','2013-04-07','13:30:00',2.75),('16273','2013-04-07','13:35:00',2.91),('16273','2013-04-07','13:40:00',2.87),('16273','2013-04-07','13:45:00',2.59),('16273','2013-04-07','13:50:00',2.42),('16273','2013-04-07','13:55:00',2.49),('16273','2013-04-07','14:00:00',2.47),('16273','2013-04-07','14:05:00',2.27),('16273','2013-04-07','14:10:00',2.38),('16273','2013-04-07','14:15:00',2.51),('16273','2013-04-07','14:20:00',2.21),('16273','2013-04-07','14:25:00',2.2),('16273','2013-04-07','14:30:00',2.3),('16273','2013-04-07','14:35:00',2.36),('16273','2013-04-07','14:40:00',2.46),('16273','2013-04-07','14:45:00',2.38),('16273','2013-04-07','14:50:00',2.33),('16273','2013-04-07','14:55:00',2.27),('16273','2013-04-07','15:00:00',2.19),('16273','2013-04-07','15:05:00',2.21),('16273','2013-04-07','15:10:00',2.11),('16273','2013-04-07','15:15:00',2.02),('16273','2013-04-07','15:20:00',2.02),('16273','2013-04-07','15:25:00',1.55),('16273','2013-04-07','15:30:00',1.97),('16273','2013-04-07','15:35:00',2.04),('16273','2013-04-07','15:40:00',2.16),('16273','2013-04-07','15:45:00',1.83),('16273','2013-04-07','15:50:00',1.16),('16273','2013-04-07','15:55:00',1.19),('16273','2013-04-07','16:00:00',1.18),('16273','2013-04-07','16:05:00',1.29),('16273','2013-04-07','16:10:00',1.46),('16273','2013-04-07','16:15:00',1.6),('16273','2013-04-07','16:20:00',1.87),('16273','2013-04-07','16:25:00',2.03),('16273','2013-04-07','16:30:00',1.84),('16273','2013-04-07','17:10:00',1.15),('16273','2013-04-07','17:15:00',1.57),('16273','2013-04-07','17:20:00',1.47),('16273','2013-04-07','17:25:00',1.08),('16273','2013-04-07','17:30:00',1.25),('16273','2013-04-07','17:35:00',1.15),('16273','2013-04-07','17:40:00',1.14),('16273','2013-04-07','17:45:00',1.06),('16273','2013-04-06','07:55:00',1.15),('16273','2013-04-06','08:00:00',1.25),('16273','2013-04-06','08:05:00',1.18),('16273','2013-04-06','08:10:00',1.49),('16273','2013-04-06','08:15:00',1.58),('16273','2013-04-06','08:20:00',1.71),('16273','2013-04-06','08:25:00',1.82),('16273','2013-04-06','08:30:00',1.89),('16273','2013-04-06','08:35:00',1.97),('16273','2013-04-06','08:40:00',2.06),('16273','2013-04-06','08:45:00',2.15),('16273','2013-04-06','08:50:00',2.25),('16273','2013-04-06','08:55:00',2.33),('16273','2013-04-06','09:00:00',2.41),('16273','2013-04-06','09:05:00',2.49),('16273','2013-04-06','09:10:00',2.54),('16273','2013-04-06','09:15:00',2.59),('16273','2013-04-06','09:20:00',2.66),('16273','2013-04-06','09:25:00',2.73),('16273','2013-04-06','09:30:00',2.81),('16273','2013-04-06','09:35:00',2.82),('16273','2013-04-06','09:40:00',2.93),('16273','2013-04-06','09:45:00',3.01),('16273','2013-04-06','09:50:00',3.03),('16273','2013-04-06','09:55:00',3.08),('16273','2013-04-06','10:00:00',3.11),('16273','2013-04-06','10:05:00',3.17),('16273','2013-04-06','10:10:00',2.99),('16273','2013-04-06','10:15:00',3.22),('16273','2013-04-06','10:20:00',3.44),('16273','2013-04-06','10:25:00',3.4),('16273','2013-04-06','10:30:00',3.41),('16273','2013-04-06','10:35:00',3.53),('16273','2013-04-06','10:40:00',3.57),('16273','2013-04-06','10:45:00',3.62),('16273','2013-04-06','10:50:00',3.62),('16273','2013-04-06','10:55:00',3.61),('16273','2013-04-06','11:00:00',3.66),('16273','2013-04-06','11:05:00',3.73),('16273','2013-04-06','11:10:00',3.74),('16273','2013-04-06','11:15:00',3.78),('16273','2013-04-06','11:20:00',3.81),('16273','2013-04-06','11:25:00',3.9),('16273','2013-04-06','11:30:00',3.95),('16273','2013-04-06','11:35:00',3.91),('16273','2013-04-06','11:40:00',3.97),('16273','2013-04-06','11:45:00',4),('16273','2013-04-06','11:50:00',4),('16273','2013-04-06','11:55:00',3.97),('16273','2013-04-06','12:00:00',4),('16273','2013-04-06','12:05:00',3.96),('16273','2013-04-06','12:10:00',3.94),('16273','2013-04-06','12:15:00',3.97),('16273','2013-04-06','12:20:00',4.03),('16273','2013-04-06','12:25:00',3.97),('16273','2013-04-06','12:30:00',3.58),('16273','2013-04-06','12:35:00',2.7),('16273','2013-04-06','12:40:00',3.99),('16273','2013-04-06','12:45:00',3.58),('16273','2013-04-06','12:50:00',4.14),('16273','2013-04-06','12:55:00',3.51),('16273','2013-04-06','13:00:00',4.19),('16273','2013-04-06','13:05:00',4.13),('16273','2013-04-06','13:10:00',4.09),('16273','2013-04-06','13:15:00',4.05),('16273','2013-04-06','13:20:00',4.01),('16273','2013-04-06','13:25:00',3.99),('16273','2013-04-06','13:30:00',4),('16273','2013-04-06','13:35:00',3.91),('16273','2013-04-06','13:40:00',3.83),('16273','2013-04-06','13:45:00',3.88),('16273','2013-04-06','13:50:00',3.84),('16273','2013-04-06','13:55:00',3.8),('16273','2013-04-06','14:00:00',3.8),('16273','2013-04-06','14:05:00',3.74),('16273','2013-04-06','14:10:00',3.68),('16273','2013-04-06','14:15:00',3.65),('16273','2013-04-06','14:20:00',3.58),('16273','2013-04-06','14:25:00',3.54),('16273','2013-04-06','14:30:00',3.49),('16273','2013-04-06','14:35:00',3.45),('16273','2013-04-06','14:40:00',3.39),('16273','2013-04-06','14:45:00',3.34),('16273','2013-04-06','14:50:00',3.29),('16273','2013-04-06','14:55:00',3.23),('16273','2013-04-06','15:00:00',3.14),('16273','2013-04-06','15:05:00',3.11),('16273','2013-04-06','15:10:00',3.04),('16273','2013-04-06','15:15:00',2.99),('16273','2013-04-06','15:20:00',2.96),('16273','2013-04-06','15:25:00',2.84),('16273','2013-04-06','15:30:00',2.75),('16273','2013-04-06','15:35:00',2.73),('16273','2013-04-06','15:40:00',2.7),('16273','2013-04-06','15:45:00',2.71),('16273','2013-04-06','15:50:00',2.68),('16273','2013-04-06','15:55:00',2.17),('16273','2013-04-06','16:00:00',2.11),('16273','2013-04-06','16:05:00',1.95),('16273','2013-04-06','16:10:00',1.81),('16273','2013-04-06','16:15:00',1.87),('16273','2013-04-06','16:20:00',1.74),('16273','2013-04-06','16:25:00',1.4),('16273','2013-04-06','16:30:00',1.52),('16273','2013-04-06','16:35:00',1.93),('16273','2013-04-06','16:40:00',1.7),('16273','2013-04-06','16:45:00',1.87),('16273','2013-04-06','16:50:00',1.7),('16273','2013-04-06','16:55:00',1.37),('16273','2013-04-06','17:00:00',1.13),('16273','2013-04-06','17:05:00',1.1),('16273','2013-04-06','17:10:00',1.06),('16273','2013-04-05','08:40:00',1.37),('16273','2013-04-05','08:45:00',1.93),('16273','2013-04-05','08:50:00',1.36),('16273','2013-04-05','08:55:00',1.26),('16273','2013-04-05','09:05:00',1.06),('16273','2013-04-05','09:10:00',2.25),('16273','2013-04-05','09:15:00',1.13),('16273','2013-04-05','09:20:00',1.27),('16273','2013-04-05','09:25:00',1.6),('16273','2013-04-05','09:35:00',1.76),('16273','2013-04-05','09:40:00',1.63),('16273','2013-04-05','09:45:00',1.91),('16273','2013-04-05','09:50:00',2.52),('16273','2013-04-05','09:55:00',2.27),('16273','2013-04-05','10:00:00',2.97),('16273','2013-04-05','10:05:00',3.48),('16273','2013-04-05','10:10:00',2.68),('16273','2013-04-05','10:15:00',2.86),('16273','2013-04-05','10:20:00',3.47),('16273','2013-04-05','10:25:00',2.86),('16273','2013-04-05','10:30:00',2.74),('16273','2013-04-05','10:35:00',3.12),('16273','2013-04-05','10:40:00',1.42),('16273','2013-04-05','10:45:00',2.67),('16273','2013-04-05','10:50:00',2.38),('16273','2013-04-05','10:55:00',3.76),('16273','2013-04-05','11:00:00',3.7),('16273','2013-04-05','11:05:00',3.71),('16273','2013-04-05','11:10:00',3.8),('16273','2013-04-05','11:15:00',4.01),('16273','2013-04-05','11:20:00',3.68),('16273','2013-04-05','11:25:00',3.88),('16273','2013-04-05','11:30:00',4.29),('16273','2013-04-05','11:35:00',4),('16273','2013-04-05','11:40:00',4.08),('16273','2013-04-05','11:45:00',3.68),('16273','2013-04-05','11:50:00',4.05),('16273','2013-04-05','11:55:00',3.39),('16273','2013-04-05','12:00:00',3.67),('16273','2013-04-05','12:05:00',2.56),('16273','2013-04-05','12:10:00',1.69),('16273','2013-04-05','12:15:00',1.46),('16273','2013-04-05','12:25:00',1.93),('16273','2013-04-05','12:30:00',1.46),('16273','2013-04-05','12:35:00',2.26),('16273','2013-04-05','12:40:00',3.36),('16273','2013-04-05','12:45:00',3.14),('16273','2013-04-05','12:50:00',3.33),('16273','2013-04-05','12:55:00',4.01),('16273','2013-04-05','13:00:00',3.95),('16273','2013-04-05','13:05:00',2.85),('16273','2013-04-05','13:10:00',3.65),('16273','2013-04-05','13:15:00',3.71),('16273','2013-04-05','13:20:00',3.93),('16273','2013-04-05','13:25:00',4.01),('16273','2013-04-05','13:30:00',3.78),('16273','2013-04-05','13:35:00',2.2),('16273','2013-04-05','13:40:00',2.76),('16273','2013-04-05','13:45:00',2.76),('16273','2013-04-05','13:50:00',1.79),('16273','2013-04-05','13:55:00',3.57),('16273','2013-04-05','14:00:00',3.42),('16273','2013-04-05','14:05:00',4.16),('16273','2013-04-05','14:10:00',2.37),('16273','2013-04-05','14:15:00',3.19),('16273','2013-04-05','14:20:00',3.21),('16273','2013-04-05','14:25:00',3.93),('16273','2013-04-05','14:30:00',3.83),('16273','2013-04-05','14:35:00',3.08),('16273','2013-04-05','14:40:00',3),('16273','2013-04-05','14:45:00',2.28),('16273','2013-04-05','14:50:00',1.9),('16273','2013-04-05','14:55:00',2.15),('16273','2013-04-05','15:00:00',1.97),('16273','2013-04-05','15:05:00',1.53),('16273','2013-04-05','15:10:00',1.71),('16273','2013-04-05','15:15:00',1.66),('16273','2013-04-05','15:20:00',1.8),('16273','2013-04-05','15:25:00',1.37),('16273','2013-04-05','15:35:00',1.04),('16273','2013-04-05','15:55:00',1.09),('16273','2013-04-05','16:00:00',1.94),('16273','2013-04-05','16:05:00',2.19),('16273','2013-04-05','16:10:00',1.55),('16273','2013-04-05','16:15:00',1.76),('16273','2013-04-05','16:20:00',1.36),('16273','2013-04-05','16:25:00',1.59),('16273','2013-04-05','16:30:00',1.71),('16273','2013-04-05','16:35:00',2.16),('16273','2013-04-05','16:40:00',2.43),('16273','2013-04-05','16:45:00',1.47),('16273','2013-04-05','16:50:00',1.99),('16273','2013-04-05','16:55:00',2.34),('16273','2013-04-05','17:00:00',1.98),('16273','2013-04-05','17:15:00',1.36),('16273','2013-04-05','17:20:00',1.23),('16273','2013-04-05','17:25:00',1.31),('16273','2013-04-05','17:30:00',1.26),('16273','2013-04-05','17:40:00',1.28),('16273','2013-04-05','17:45:00',1.02),('16273','2013-04-04','08:50:00',1.3),('16273','2013-04-04','08:55:00',2.05),('16273','2013-04-04','09:00:00',1.31),('16273','2013-04-04','09:05:00',1.15),('16273','2013-04-04','09:10:00',1.33),('16273','2013-04-04','09:15:00',1.14),('16273','2013-04-04','09:25:00',1.32),('16273','2013-04-04','09:30:00',2.36),('16273','2013-04-04','09:35:00',2.45),('16273','2013-04-04','09:40:00',1.73),('16273','2013-04-04','09:45:00',1.06),('16273','2013-04-04','09:50:00',1.07),('16273','2013-04-04','09:55:00',1.65),('16273','2013-04-04','10:00:00',2.17),('16273','2013-04-04','10:05:00',1.73),('16273','2013-04-04','10:10:00',1.24),('16273','2013-04-04','10:15:00',1.48),('16273','2013-04-04','10:20:00',3.23),('16273','2013-04-04','10:25:00',2.84),('16273','2013-04-04','10:30:00',1.78),('16273','2013-04-04','10:35:00',3.84),('16273','2013-04-04','10:40:00',2.09),('16273','2013-04-04','10:45:00',2.25),('16273','2013-04-04','10:50:00',3.56),('16273','2013-04-04','10:55:00',2.32),('16273','2013-04-04','11:00:00',1.19),('16273','2013-04-04','11:05:00',1.02),('16273','2013-04-04','11:10:00',1.35),('16273','2013-04-04','11:15:00',1.35),('16273','2013-04-04','11:20:00',1.03),('16273','2013-04-04','11:25:00',1.07),('16273','2013-04-04','11:30:00',1.51),('16273','2013-04-04','11:35:00',2.6),('16273','2013-04-04','11:40:00',3.3),('16273','2013-04-04','11:45:00',3.6),('16273','2013-04-04','11:50:00',2.07),('16273','2013-04-04','11:55:00',2.5),('16273','2013-04-04','12:00:00',4.04),('16273','2013-04-04','12:05:00',4.02),('16273','2013-04-04','12:10:00',3.59),('16273','2013-04-04','12:15:00',3),('16273','2013-04-04','12:20:00',1.9),('16273','2013-04-04','12:25:00',3.07),('16273','2013-04-04','12:30:00',2.5),('16273','2013-04-04','12:35:00',2.67),('16273','2013-04-04','12:40:00',2.29),('16273','2013-04-04','12:45:00',3.25),('16273','2013-04-04','12:50:00',3.41),('16273','2013-04-04','12:55:00',3.63),('16273','2013-04-04','13:00:00',3.52),('16273','2013-04-04','13:05:00',3.72),('16273','2013-04-04','13:10:00',3.91),('16273','2013-04-04','13:15:00',3.83),('16273','2013-04-04','13:20:00',3.76),('16273','2013-04-04','13:25:00',3.77),('16273','2013-04-04','13:30:00',3.48),('16273','2013-04-04','13:35:00',3.31),('16273','2013-04-04','13:40:00',3.21),('16273','2013-04-04','13:45:00',3.1),('16273','2013-04-04','13:50:00',2.36),('16273','2013-04-04','13:55:00',2.29),('16273','2013-04-04','14:00:00',2.82),('16273','2013-04-04','14:05:00',3.72),('16273','2013-04-04','14:10:00',3.58),('16273','2013-04-04','14:15:00',3.45),('16273','2013-04-04','14:20:00',3.38),('16273','2013-04-04','14:25:00',3.37),('16273','2013-04-04','14:30:00',3.36),('16273','2013-04-04','14:35:00',3.28),('16273','2013-04-04','14:40:00',3.22),('16273','2013-04-04','14:45:00',3.16),('16273','2013-04-04','14:50:00',3.1),('16273','2013-04-04','14:55:00',3.09),('16273','2013-04-04','15:00:00',3.01),('16273','2013-04-04','15:05:00',2.83),('16273','2013-04-04','15:10:00',2.68),('16273','2013-04-04','15:15:00',2.76),('16273','2013-04-04','15:20:00',2.58),('16273','2013-04-04','15:25:00',2.74),('16273','2013-04-04','15:30:00',2.64),('16273','2013-04-04','15:35:00',2.57),('16273','2013-04-04','15:40:00',2.5),('16273','2013-04-04','15:45:00',2.43),('16273','2013-04-04','15:50:00',2.41),('16273','2013-04-04','15:55:00',2.35),('16273','2013-04-04','16:00:00',2.19),('16273','2013-04-04','16:05:00',2.22),('16273','2013-04-04','16:10:00',1.84),('16273','2013-04-04','16:15:00',1.8),('16273','2013-04-04','16:20:00',1.83),('16273','2013-04-04','16:25:00',2.08),('16273','2013-04-04','16:30:00',1.72),('16273','2013-04-04','16:35:00',1.49),('16273','2013-04-04','16:40:00',1.64),('16273','2013-04-04','16:45:00',1.27),('16273','2013-04-04','16:50:00',1.48),('16273','2013-04-04','16:55:00',1.22),('16273','2013-04-04','17:00:00',1.31),('16273','2013-04-04','17:05:00',1.27),('16273','2013-04-03','08:00:00',1.24),('16273','2013-04-03','08:05:00',1.51),('16273','2013-04-03','08:13:00',1.56),('16273','2013-04-03','08:20:00',1.11),('16273','2013-04-03','08:25:00',1.06),('16273','2013-04-03','08:30:00',1.41),('16273','2013-04-03','08:35:00',2.04),('16273','2013-04-03','08:40:00',2.11),('16273','2013-04-03','08:45:00',2.19),('16273','2013-04-03','08:50:00',2.4),('16273','2013-04-03','08:55:00',2.32),('16273','2013-04-03','09:00:00',2.46),('16273','2013-04-03','09:05:00',2.32),('16273','2013-04-03','09:10:00',2.56),('16273','2013-04-03','09:15:00',2.74),('16273','2013-04-03','09:20:00',2.89),('16273','2013-04-03','09:25:00',2.77),('16273','2013-04-03','09:30:00',3.03),('16273','2013-04-03','09:35:00',2.89),('16273','2013-04-03','09:40:00',2.93),('16273','2013-04-03','09:45:00',3.26),('16273','2013-04-03','09:50:00',2.04),('16273','2013-04-03','09:55:00',1.37),('16273','2013-04-03','10:00:00',1.98),('16273','2013-04-03','10:05:00',4.1),('16273','2013-04-03','10:10:00',3.68),('16273','2013-04-03','10:15:00',3.87),('16273','2013-04-03','10:20:00',3.13),('16273','2013-04-03','10:25:00',1.89),('16273','2013-04-03','10:30:00',1.68),('16273','2013-04-03','10:35:00',1.68),('16273','2013-04-03','10:40:00',2.42),('16273','2013-04-03','10:45:00',3.33),('16273','2013-04-03','10:50:00',2.35),('16273','2013-04-03','10:55:00',2.55),('16273','2013-04-03','11:00:00',2.33),('16273','2013-04-03','11:05:00',2.01),('16273','2013-04-03','11:10:00',1.96),('16273','2013-04-03','11:15:00',2.65),('16273','2013-04-03','11:20:00',1.91),('16273','2013-04-03','11:25:00',2.85),('16273','2013-04-03','11:30:00',2.47),('16273','2013-04-03','11:35:00',2.39),('16273','2013-04-03','11:40:00',3.75),('16273','2013-04-03','11:45:00',2.87),('16273','2013-04-03','11:50:00',3.07),('16273','2013-04-03','11:55:00',2.99),('16273','2013-04-03','12:00:00',4.11),('16273','2013-04-03','12:05:00',4.38),('16273','2013-04-03','12:10:00',2.88),('16273','2013-04-03','12:15:00',3.1),('16273','2013-04-03','12:20:00',3.61),('16273','2013-04-03','12:25:00',3.34),('16273','2013-04-03','12:30:00',4.56),('16273','2013-04-03','12:35:00',3.94),('16273','2013-04-03','12:40:00',2.98),('16273','2013-04-03','12:45:00',3.7),('16273','2013-04-03','12:50:00',3.24),('16273','2013-04-03','12:55:00',2.44),('16273','2013-04-03','13:00:00',3.36),('16273','2013-04-03','13:05:00',2.49),('16273','2013-04-03','13:10:00',2.95),('16273','2013-04-03','13:15:00',3.5),('16273','2013-04-03','13:20:00',3.23),('16273','2013-04-03','13:25:00',3.29),('16273','2013-04-03','13:30:00',3.22),('16273','2013-04-03','13:35:00',4.6),('16273','2013-04-03','13:40:00',4.25),('16273','2013-04-03','13:45:00',3.95),('16273','2013-04-03','13:50:00',4.65),('16273','2013-04-03','13:55:00',3.86),('16273','2013-04-03','14:00:00',4.46),('16273','2013-04-03','14:05:00',3.96),('16273','2013-04-03','14:10:00',4.31),('16273','2013-04-03','14:15:00',3.59),('16273','2013-04-03','14:20:00',3.93),('16273','2013-04-03','14:25:00',2.19),('16273','2013-04-03','14:30:00',3.8),('16273','2013-04-03','14:35:00',3.32),('16273','2013-04-03','14:40:00',3.32),('16273','2013-04-03','14:45:00',3.17),('16273','2013-04-03','14:50:00',3.51),('16273','2013-04-03','14:55:00',3.51),('16273','2013-04-03','15:00:00',3.52),('16273','2013-04-03','15:05:00',2.98),('16273','2013-04-03','15:10:00',3.02),('16273','2013-04-03','15:15:00',2.35),('16273','2013-04-03','15:20:00',2.92),('16273','2013-04-03','15:25:00',1.48),('16273','2013-04-03','15:30:00',3.3),('16273','2013-04-03','15:35:00',2.84),('16273','2013-04-03','15:40:00',2.91),('16273','2013-04-03','15:45:00',2.77),('16273','2013-04-03','15:50:00',2.92),('16273','2013-04-03','15:55:00',2.71),('16273','2013-04-03','16:00:00',2.66),('16273','2013-04-03','16:05:00',2.45),('16273','2013-04-03','16:10:00',2.18),('16273','2013-04-03','16:15:00',2.36),('16273','2013-04-03','16:20:00',2.3),('16273','2013-04-03','16:25:00',2.21),('16273','2013-04-03','16:30:00',2.12),('16273','2013-04-03','16:35:00',2.02),('16273','2013-04-03','16:40:00',1.94),('16273','2013-04-03','16:45:00',1.84),('16273','2013-04-03','16:50:00',1.76),('16273','2013-04-03','16:55:00',1.59),('16273','2013-04-03','17:00:00',1.62),('16273','2013-04-03','17:05:00',1.5),('16273','2013-04-03','17:10:00',1.41),('16273','2013-04-03','17:15:00',1.33),('16273','2013-04-03','17:20:00',1.25),('16273','2013-04-03','17:25:00',1.18),('16273','2013-04-03','17:30:00',1.09),('16273','2013-04-03','17:35:00',1.01),('16273','2013-04-02','08:35:00',1.68),('16273','2013-04-02','08:40:00',1.19),('16273','2013-04-02','08:50:00',1.01),('16273','2013-04-02','08:55:00',2.18),('16273','2013-04-02','09:00:00',2.38),('16273','2013-04-02','09:05:00',2.47),('16273','2013-04-02','09:10:00',2.42),('16273','2013-04-02','09:15:00',2.73),('16273','2013-04-02','09:20:00',2.87),('16273','2013-04-02','09:25:00',3.07),('16273','2013-04-02','09:30:00',2.95),('16273','2013-04-02','09:35:00',2.38),('16273','2013-04-02','09:40:00',1.79),('16273','2013-04-02','09:45:00',3.06),('16273','2013-04-02','09:50:00',2.98),('16273','2013-04-02','09:55:00',3.39),('16273','2013-04-02','10:00:00',3.81),('16273','2013-04-02','10:05:00',4.07),('16273','2013-04-02','10:10:00',3.83),('16273','2013-04-02','10:15:00',3.38),('16273','2013-04-02','10:20:00',4.04),('16273','2013-04-02','10:25:00',3.92),('16273','2013-04-02','10:30:00',3.66),('16273','2013-04-02','10:35:00',2.19),('16273','2013-04-02','10:40:00',3.31),('16273','2013-04-02','10:45:00',3.76),('16273','2013-04-02','10:50:00',3.45),('16273','2013-04-02','10:55:00',2.92),('16273','2013-04-02','11:00:00',4.05),('16273','2013-04-02','11:05:00',4.02),('16273','2013-04-02','11:10:00',2.47),('16273','2013-04-02','11:15:00',4.44),('16273','2013-04-02','11:20:00',3.52),('16273','2013-04-02','11:25:00',3.42),('16273','2013-04-02','11:30:00',4.55),('16273','2013-04-02','11:35:00',3.06),('16273','2013-04-02','11:40:00',3.36),('16273','2013-04-02','11:45:00',3.03),('16273','2013-04-02','11:50:00',1.01),('16273','2013-04-02','12:00:00',1.1),('16273','2013-04-02','12:05:00',1.52),('16273','2013-04-02','12:10:00',1.48),('16273','2013-04-02','12:15:00',1.61),('16273','2013-04-02','12:20:00',1.03),('16273','2013-04-02','12:25:00',1.63),('16273','2013-04-02','12:30:00',2),('16273','2013-04-02','12:35:00',1.79),('16273','2013-04-02','12:40:00',1.36),('16273','2013-04-02','12:45:00',1.47),('16273','2013-04-02','12:50:00',1.61),('16273','2013-04-02','12:55:00',1.6),('16273','2013-04-02','13:00:00',2.28),('16273','2013-04-02','13:05:00',2.49),('16273','2013-04-02','13:10:00',1.12),('16273','2013-04-02','13:15:00',1.18),('16273','2013-04-02','13:20:00',1.35),('16273','2013-04-02','13:25:00',1.42),('16273','2013-04-02','13:30:00',1.36),('16273','2013-04-02','13:35:00',1.15),('16273','2013-04-02','13:40:00',1.11),('16273','2013-04-02','13:45:00',1.48),('16273','2013-04-02','13:50:00',2.48),('16273','2013-04-02','13:55:00',2.93),('16273','2013-04-02','14:00:00',2.86),('16273','2013-04-02','14:05:00',4.22),('16273','2013-04-02','14:10:00',2.53),('16273','2013-04-02','14:15:00',1.21),('16273','2013-04-02','14:20:00',2.7),('16273','2013-04-02','14:25:00',2.28),('16273','2013-04-02','14:45:00',1.62),('16273','2013-04-02','15:15:00',1.36),('16273','2013-04-02','15:35:00',1.04),('16273','2013-04-02','15:50:00',1.53),('16273','2013-04-02','15:55:00',1.51),('16273','2013-04-02','16:00:00',1.18),('16273','2013-04-02','16:05:00',1.04),('16273','2013-04-02','16:25:00',1.1),('16273','2013-04-02','16:30:00',1.03),('16273','2013-04-02','17:40:00',1.42),('16273','2014-05-02','07:25:00',1.13),('16273','2014-05-02','07:30:00',1.12),('16273','2014-05-02','07:35:00',1.4),('16273','2014-05-02','07:40:00',1.52),('16273','2014-05-02','07:45:00',2.03),('16273','2014-05-02','07:50:00',1.68),('16273','2014-05-02','08:10:00',1.4),('16273','2014-05-02','08:15:00',1.32),('16273','2014-05-02','08:25:00',1.35),('16273','2014-05-02','08:30:00',1.13),('16273','2014-05-02','08:35:00',2.17),('16273','2014-05-02','08:40:00',1.07),('16273','2014-05-02','08:45:00',1.15),('16273','2014-05-02','08:50:00',1.23),('16273','2014-05-02','08:55:00',1.14),('16273','2014-05-02','09:00:00',1.02),('16273','2014-05-02','09:05:00',1.12),('16273','2014-05-02','09:10:00',1.91),('16273','2014-05-02','09:15:00',2.1),('16273','2014-05-02','09:20:00',1.5),('16273','2014-05-02','09:25:00',1.21),('16273','2014-05-02','09:30:00',1.55),('16273','2014-05-02','09:35:00',2.36),('16273','2014-05-02','09:40:00',2.32),('16273','2014-05-02','09:45:00',1.69),('16273','2014-05-02','09:50:00',1.18),('16273','2014-05-02','12:30:00',1.13),('16273','2014-05-02','12:35:00',1.68),('16273','2014-05-02','12:40:00',1.79),('16273','2014-05-02','12:45:00',2.22),('16273','2014-05-02','12:50:00',2.24),('16273','2014-05-02','12:55:00',1.85),('16273','2014-05-02','13:00:00',2.09),('16273','2014-05-02','13:05:00',2.14),('16273','2014-05-02','13:10:00',2.79),('16273','2014-05-02','13:15:00',3.19),('16273','2014-05-02','13:20:00',3.76),('16273','2014-05-02','13:25:00',2.56),('16273','2014-05-02','13:30:00',3.15),('16273','2014-05-02','13:35:00',2.12),('16273','2014-05-02','13:40:00',2.04),('16273','2014-05-02','13:45:00',1.61),('16273','2014-05-02','13:50:00',2.18),('16273','2014-05-02','13:55:00',2.77),('16273','2014-05-02','14:00:00',3.06),('16273','2014-05-02','14:05:00',3.5),('16273','2014-05-02','14:10:00',2.98),('16273','2014-05-02','14:15:00',2.62),('16273','2014-05-02','14:20:00',2.98),('16273','2014-05-02','14:25:00',1.3),('16273','2014-05-02','14:30:00',1.78),('16273','2014-05-02','15:05:00',1.19),('16273','2014-05-02','15:10:00',1.52),('16273','2014-05-02','15:15:00',1.3),('16273','2014-05-02','15:20:00',2.03),('16273','2014-05-02','15:25:00',2.91),('16273','2014-05-02','15:30:00',2.97),('16273','2014-05-02','15:35:00',2.22),('16273','2014-05-02','15:45:00',1.44),('16273','2014-05-02','15:50:00',1.51),('16273','2014-05-02','15:55:00',1.18),('16273','2014-05-02','16:00:00',1.08),('16273','2014-05-02','16:05:00',1.53),('16273','2014-05-02','16:10:00',1.08),('16273','2014-05-02','16:15:00',1.12),('16273','2014-05-02','16:20:00',1.38),('16273','2014-05-02','16:35:00',1.03),('16273','2014-05-02','16:40:00',1.38),('16273','2014-05-02','16:45:00',1.69),('16273','2014-05-02','16:50:00',1.2),('16273','2014-05-02','16:55:00',1.02),('16273','2014-03-27','09:10:00',1.07),('16273','2014-03-27','09:15:00',1.09),('16273','2014-03-27','09:20:00',1.18),('16273','2014-03-27','09:25:00',1.11),('16273','2014-03-27','10:00:00',1.05),('16273','2014-03-27','10:05:00',1.35),('16273','2014-03-27','10:10:00',1.44),('16273','2014-03-27','10:15:00',1.45),('16273','2014-03-27','10:20:00',1.32),('16273','2014-03-27','10:25:00',1.04),('16273','2014-03-27','10:30:00',1.36),('16273','2014-03-27','10:35:00',1.39),('16273','2014-03-27','10:40:00',2.78),('16273','2014-03-27','10:45:00',2.94),('16273','2014-03-27','10:50:00',1.42),('16273','2014-03-27','11:00:00',2.25),('16273','2014-03-27','11:05:00',1.78),('16273','2014-03-27','11:50:00',2.35),('16273','2014-03-27','11:55:00',1.25),('16273','2014-03-27','12:45:00',1.04),('16273','2014-03-27','12:50:00',1.28),('16273','2014-03-27','12:55:00',1.39),('16273','2014-03-27','13:00:00',1.55),('16273','2014-03-27','13:05:00',2.27),('16273','2014-03-27','13:10:00',2.64),('16273','2014-03-27','13:15:00',2.99),('16273','2014-03-27','13:20:00',2.95),('16273','2014-03-27','13:25:00',2.66),('16273','2014-03-27','13:30:00',2.33),('16273','2014-03-27','13:35:00',2.26),('16273','2014-03-27','13:40:00',2.2),('16273','2014-03-27','13:45:00',2.21),('16273','2014-03-27','13:50:00',1.43),('16273','2014-03-27','13:55:00',1.23),('16273','2014-03-27','14:00:00',1.85),('16273','2014-03-27','14:05:00',1.41),('16273','2014-03-27','14:15:00',1.27),('16273','2014-03-27','14:20:00',2.31),('16273','2014-03-27','14:25:00',1.33),('16273','2014-03-27','14:30:00',1.04),('16273','2014-03-27','15:35:00',1.72),('16273','2014-03-27','15:40:00',1.06),('16273','2014-03-27','15:45:00',1.15),('16273','2014-03-27','15:50:00',1.67),('16273','2014-03-27','16:20:00',1.14),('16273','2014-03-27','16:40:00',1.27),('16273','2013-04-01','08:05:00',1.01),('16273','2013-04-01','08:10:00',1.15),('16273','2013-04-01','08:15:00',1.21),('16273','2013-04-01','08:20:00',1.53),('16273','2013-04-01','08:25:00',1.19),('16273','2013-04-01','08:30:00',1.54),('16273','2013-04-01','08:35:00',1.44),('16273','2013-04-01','08:40:00',1.65),('16273','2013-04-01','08:45:00',2.31),('16273','2013-04-01','08:50:00',2.24),('16273','2013-04-01','08:55:00',2.32),('16273','2013-04-01','09:00:00',2.38),('16273','2013-04-01','09:05:00',2.39),('16273','2013-04-01','09:10:00',2.53),('16273','2013-04-01','09:15:00',2.35),('16273','2013-04-01','09:20:00',2.31),('16273','2013-04-01','09:25:00',2.25),('16273','2013-04-01','09:30:00',2.09),('16273','2013-04-01','09:35:00',1.64),('16273','2013-04-01','09:40:00',2.84),('16273','2013-04-01','09:45:00',3.16),('16273','2013-04-01','09:50:00',2.82),('16273','2013-04-01','09:55:00',3.03),('16273','2013-04-01','10:00:00',3.48),('16273','2013-04-01','10:05:00',2.08),('16273','2013-04-01','10:10:00',2.27),('16273','2013-04-01','10:15:00',2.9),('16273','2013-04-01','10:20:00',3.18),('16273','2013-04-01','10:25:00',3.09),('16273','2013-04-01','10:30:00',1.8),('16273','2013-04-01','10:35:00',1.94),('16273','2013-04-01','10:40:00',3.29),('16273','2013-04-01','10:45:00',2.87),('16273','2013-04-01','10:50:00',1.95),('16273','2013-04-01','10:55:00',1.44),('16273','2013-04-01','11:00:00',2.85),('16273','2013-04-01','11:05:00',1.95),('16273','2013-04-01','11:10:00',1.59),('16273','2013-04-01','11:15:00',2.8),('16273','2013-04-01','11:20:00',1.86),('16273','2013-04-01','11:25:00',3.54),('16273','2013-04-01','11:30:00',2.06),('16273','2013-04-01','11:35:00',2.76),('16273','2013-04-01','11:40:00',2.8),('16273','2013-04-01','11:45:00',2.12),('16273','2013-04-01','11:50:00',1.97),('16273','2013-04-01','11:55:00',2.42),('16273','2013-04-01','12:00:00',2.14),('16273','2013-04-01','12:05:00',2.16),('16273','2013-04-01','12:10:00',2.38),('16273','2013-04-01','12:15:00',1.95),('16273','2013-04-01','12:20:00',1.79),('16273','2013-04-01','12:25:00',2.29),('16273','2013-04-01','12:30:00',2.3),('16273','2013-04-01','12:35:00',2.17),('16273','2013-04-01','12:40:00',2.47),('16273','2013-04-01','12:45:00',2.54),('16273','2013-04-01','12:50:00',2.86),('16273','2013-04-01','12:55:00',2.6),('16273','2013-04-01','13:00:00',2.89),('16273','2013-04-01','13:05:00',2.95),('16273','2013-04-01','13:10:00',2.69),('16273','2013-04-01','13:15:00',2.55),('16273','2013-04-01','13:20:00',2.54),('16273','2013-04-01','13:25:00',2.66),('16273','2013-04-01','13:30:00',2.27),('16273','2013-04-01','13:35:00',2.43),('16273','2013-04-01','13:40:00',3.16),('16273','2013-04-01','13:45:00',3.3),('16273','2013-04-01','13:50:00',2.76),('16273','2013-04-01','13:55:00',2.35),('16273','2013-04-01','14:00:00',1.71),('16273','2013-04-01','14:05:00',1.9),('16273','2013-04-01','14:10:00',2.11),('16273','2013-04-01','14:15:00',2.15),('16273','2013-04-01','14:20:00',3.38),('16273','2013-04-01','14:25:00',3.35),('16273','2013-04-01','14:30:00',2.56),('16273','2013-04-01','14:35:00',2.09),('16273','2013-04-01','14:40:00',1.77),('16273','2013-04-01','14:45:00',2.17),('16273','2013-04-01','14:50:00',2.09),('16273','2013-04-01','14:55:00',1.79),('16273','2013-04-01','15:00:00',1.69),('16273','2013-04-01','15:05:00',1.8),('16273','2013-04-01','15:10:00',1.97),('16273','2013-04-01','15:15:00',1.91),('16273','2013-04-01','15:20:00',2.16),('16273','2013-04-01','15:25:00',1.85),('16273','2013-04-01','15:30:00',2.04),('16273','2013-04-01','15:35:00',1.82),('16273','2013-04-01','15:40:00',1.99),('16273','2013-04-01','15:45:00',2.56),('16273','2013-04-01','15:50:00',2.2),('16273','2013-04-01','15:55:00',1.83),('16273','2013-04-01','16:00:00',1.43),('16273','2013-04-01','16:05:00',1.25),('16273','2013-03-31','09:05:00',1.16),('16273','2013-03-31','09:15:00',1.12),('16273','2013-03-31','09:20:00',1.8),('16273','2013-03-31','09:25:00',2.05),('16273','2013-03-31','09:30:00',1.43),('16273','2013-03-31','09:35:00',1.1),('16273','2013-03-31','09:40:00',2.06),('16273','2013-03-31','10:05:00',1.05),('16273','2013-03-31','10:10:00',1.25),('16273','2013-03-31','10:15:00',1.63),('16273','2013-03-31','10:20:00',1.74),('16273','2013-03-31','10:25:00',1.32),('16273','2013-03-31','10:30:00',1.37),('16273','2013-03-31','10:45:00',1.13),('16273','2013-03-31','10:50:00',1.4),('16273','2013-03-31','11:00:00',2.88),('16273','2013-03-31','11:05:00',1.01),('16273','2013-03-31','11:20:00',1.12),('16273','2013-03-31','11:25:00',1.63),('16273','2013-03-31','11:30:00',2.6),('16273','2013-03-31','11:35:00',3.96),('16273','2013-03-31','11:40:00',3.23),('16273','2013-03-31','11:45:00',2.06),('16273','2013-03-31','11:50:00',1.14),('16273','2013-03-31','11:55:00',1.03),('16273','2013-03-31','12:25:00',1.16),('16273','2013-03-31','12:30:00',2.25),('16273','2013-03-31','12:35:00',2.74),('16273','2013-03-31','12:40:00',3.56),('16273','2013-03-31','12:45:00',2.8),('16273','2013-03-31','12:50:00',2.4),('16273','2013-03-31','12:55:00',2.71),('16273','2013-03-31','13:00:00',2),('16273','2013-03-31','13:05:00',1.47),('16273','2013-03-31','13:10:00',2.51),('16273','2013-03-31','13:15:00',3.66),('16273','2013-03-31','13:20:00',3.55),('16273','2013-03-31','13:25:00',1.24),('16273','2013-03-31','13:30:00',1.18),('16273','2013-03-31','13:35:00',2.24),('16273','2013-03-31','13:40:00',3.22),('16273','2013-03-31','13:45:00',2.95),('16273','2013-03-31','13:50:00',2.44),('16273','2013-03-31','13:55:00',3.05),('16273','2013-03-31','14:00:00',3.36),('16273','2013-03-31','14:05:00',3.41),('16273','2013-03-31','14:10:00',3.44),('16273','2013-03-31','14:15:00',2.52),('16273','2013-03-31','14:20:00',3.33),('16273','2013-03-31','14:25:00',2.61),('16273','2013-03-31','14:30:00',2.03),('16273','2013-03-31','14:35:00',3.64),('16273','2013-03-31','14:40:00',3.66),('16273','2013-03-31','14:45:00',3.49),('16273','2013-03-31','14:50:00',2.3),('16273','2013-03-31','14:55:00',3.57),('16273','2013-03-31','15:00:00',2.86),('16273','2013-03-31','15:05:00',3.3),('16273','2013-03-31','15:10:00',3.61),('16273','2013-03-31','15:15:00',3.41),('16273','2013-03-31','15:20:00',3.06),('16273','2013-03-31','15:25:00',2.59),('16273','2013-03-31','15:30:00',2.24),('16273','2013-03-31','15:35:00',2.15),('16273','2013-03-31','15:40:00',1.95),('16273','2013-03-31','15:45:00',1.12),('16273','2013-03-31','15:55:00',1.36),('16273','2013-03-31','16:10:00',1.45),('16273','2013-03-31','16:15:00',2.2),('16273','2013-03-31','16:20:00',1.1),('16273','2013-03-31','16:30:00',1.1),('16273','2013-03-31','16:35:00',1.04),('16273','2013-03-31','17:00:00',1.03),('16273','2013-03-31','17:30:00',1),('16273','2013-03-31','17:50:00',1.2),('16273','2013-03-30','09:35:00',1.82),('16273','2013-03-30','09:40:00',1.72),('16273','2013-03-30','09:45:00',1.78),('16273','2013-03-30','09:50:00',1.36),('16273','2013-03-30','09:55:00',1.73),('16273','2013-03-30','10:00:00',1.93),('16273','2013-03-30','10:05:00',1.71),('16273','2013-03-30','10:10:00',1.35),('16273','2013-03-30','10:15:00',1.38),('16273','2013-03-30','10:20:00',1.47),('16273','2013-03-30','10:25:00',1.63),('16273','2013-03-30','10:30:00',1.74),('16273','2013-03-30','10:35:00',1.48),('16273','2013-03-30','10:40:00',1.65),('16273','2013-03-30','10:45:00',1.67),('16273','2013-03-30','10:50:00',1.8),('16273','2013-03-30','10:55:00',1.6),('16273','2013-03-30','11:00:00',2.4),('16273','2013-03-30','11:05:00',2.35),('16273','2013-03-30','11:10:00',1.16),('16273','2013-03-30','11:15:00',1.13),('16273','2013-03-30','11:20:00',1.38),('16273','2013-03-30','11:25:00',1.97),('16273','2013-03-30','11:30:00',2.31),('16273','2013-03-30','11:35:00',3.02),('16273','2013-03-30','11:40:00',2.21),('16273','2013-03-30','11:45:00',2.36),('16273','2013-03-30','11:50:00',2.04),('16273','2013-03-30','11:55:00',2.17),('16273','2013-03-30','12:00:00',1.41),('16273','2013-03-30','12:55:00',1.95),('16273','2013-03-30','13:00:00',1.96),('16273','2013-03-30','13:05:00',1.62),('16273','2013-03-30','13:10:00',1.16),('16273','2013-03-30','13:15:00',1.26),('16273','2013-03-30','13:20:00',1.07),('16273','2013-03-30','13:40:00',2.27),('16273','2013-03-30','13:45:00',1.82),('16273','2013-03-30','13:50:00',1.92),('16273','2013-03-30','13:55:00',1.77),('16273','2013-03-30','14:00:00',2.1),('16273','2013-03-30','14:05:00',1.22),('16273','2013-03-30','14:10:00',1.36),('16273','2013-03-30','14:15:00',2.09),('16273','2013-03-30','14:20:00',2.4),('16273','2013-03-30','14:25:00',1.22),('16273','2013-03-30','14:30:00',1.31),('16273','2013-03-30','14:35:00',1.33),('16273','2013-03-30','14:40:00',1.42),('16273','2013-03-30','14:45:00',1.06),('16273','2013-03-30','14:55:00',1.15),('16273','2013-03-30','15:10:00',1.05),('16273','2013-03-30','15:15:00',1.03),('16273','2013-03-29','07:10:00',1.12),('16273','2013-03-29','07:15:00',1.28),('16273','2013-03-29','07:20:00',1.24),('16273','2013-03-29','07:25:00',1.46),('16273','2013-03-29','07:30:00',1.68),('16273','2013-03-29','07:35:00',1.78),('16273','2013-03-29','07:40:00',1.57),('16273','2013-03-29','07:45:00',1.92),('16273','2013-03-29','07:55:00',1.35),('16273','2013-03-29','08:00:00',2.27),('16273','2013-03-29','08:05:00',2.33),('16273','2013-03-29','08:10:00',1.74),('16273','2013-03-29','08:15:00',2.58),('16273','2013-03-29','08:20:00',2.49),('16273','2013-03-29','08:25:00',2.63),('16273','2013-03-29','08:30:00',2.75),('16273','2013-03-29','08:35:00',2.8),('16273','2013-03-29','08:40:00',2.68),('16273','2013-03-29','08:45:00',2.47),('16273','2013-03-29','08:50:00',2.24),('16273','2013-03-29','08:55:00',2.87),('16273','2013-03-29','09:00:00',3.05),('16273','2013-03-29','09:05:00',2.86),('16273','2013-03-29','09:10:00',3.28),('16273','2013-03-29','09:15:00',3.4),('16273','2013-03-29','09:20:00',3.3),('16273','2013-03-29','09:25:00',3.51),('16273','2013-03-29','09:30:00',3.53),('16273','2013-03-29','09:35:00',3.28),('16273','2013-03-29','09:40:00',3.25),('16273','2013-03-29','09:45:00',2.76),('16273','2013-03-29','09:50:00',3.52),('16273','2013-03-29','09:55:00',3.25),('16273','2013-03-29','10:00:00',2.86),('16273','2013-03-29','10:05:00',3.04),('16273','2013-03-29','10:10:00',3.03),('16273','2013-03-29','10:15:00',3.14),('16273','2013-03-29','10:20:00',2.82),('16273','2013-03-29','10:25:00',2.99),('16273','2013-03-29','10:30:00',3.21),('16273','2013-03-29','10:35:00',3.66),('16273','2013-03-29','10:40:00',3.45),('16273','2013-03-29','10:45:00',3.49),('16273','2013-03-29','10:50:00',3.49),('16273','2013-03-29','10:55:00',3.59),('16273','2013-03-29','11:00:00',3.95),('16273','2013-03-29','11:05:00',4.15),('16273','2013-03-29','11:10:00',3.06),('16273','2013-03-29','11:15:00',4.16),('16273','2013-03-29','11:20:00',3.54),('16273','2013-03-29','11:25:00',4.01),('16273','2013-03-29','11:30:00',3.96),('16273','2013-03-29','11:35:00',4.04),('16273','2013-03-29','11:40:00',4.04),('16273','2013-03-29','11:45:00',4.05),('16273','2013-03-29','11:50:00',4.04);
INSERT INTO `solarlogmod` VALUES ('16273','2013-03-29','11:55:00',4.06),('16273','2013-03-29','12:00:00',4.06),('16273','2013-03-29','12:05:00',4.07),('16273','2013-03-29','12:10:00',4.05),('16273','2013-03-29','12:15:00',4.03),('16273','2013-03-29','12:20:00',3.98),('16273','2013-03-29','12:25:00',3.87),('16273','2013-03-29','12:30:00',4.03),('16273','2013-03-29','12:35:00',3.99),('16273','2013-03-29','12:40:00',3.99),('16273','2013-03-29','12:45:00',4.01),('16273','2013-03-29','12:50:00',3.42),('16273','2013-03-29','12:55:00',3.64),('16273','2013-03-29','13:00:00',3.53),('16273','2013-03-29','13:05:00',3.67),('16273','2013-03-29','13:10:00',3.99),('16273','2013-03-29','13:15:00',3.95),('16273','2013-03-29','13:20:00',3.92),('16273','2013-03-29','13:25:00',3.54),('16273','2013-03-29','13:30:00',3.18),('16273','2013-03-29','13:35:00',2.67),('16273','2013-03-29','13:40:00',3.12),('16273','2013-03-29','13:45:00',3),('16273','2013-03-29','13:50:00',3.19),('16273','2013-03-29','13:55:00',3.34),('16273','2013-03-29','14:00:00',2.54),('16273','2013-03-29','14:05:00',2.2),('16273','2013-03-29','14:10:00',2.18),('16273','2013-03-29','14:15:00',2.1),('16273','2013-03-29','14:20:00',2.44),('16273','2013-03-29','14:25:00',1.98),('16273','2013-03-29','14:30:00',1.82),('16273','2013-03-29','14:35:00',1.78),('16273','2013-03-29','14:40:00',1.71),('16273','2013-03-29','14:45:00',1.61),('16273','2013-03-29','14:50:00',1.62),('16273','2013-03-29','14:55:00',1.46),('16273','2013-03-29','15:00:00',1.42),('16273','2013-03-29','15:05:00',1.38),('16273','2013-03-29','15:10:00',1.4),('16273','2013-03-29','15:15:00',1.27),('16273','2013-03-29','15:20:00',1.15),('16273','2013-03-29','15:25:00',1.08),('16273','2013-03-29','15:30:00',1.04),('16273','2013-03-29','15:45:00',1.1),('16273','2013-03-29','15:50:00',1.22),('16273','2013-03-29','15:55:00',1.5),('16273','2013-03-29','16:00:00',1.36),('16273','2013-03-29','16:05:00',1.03),('16273','2013-03-29','16:30:00',1.07),('16273','2013-03-29','16:35:00',1.52),('16273','2013-03-29','16:40:00',1.29),('16273','2013-03-29','16:45:00',1),('16273','2013-03-28','09:10:00',1.21),('16273','2013-03-28','09:15:00',1.7),('16273','2013-03-28','09:20:00',1.68),('16273','2013-03-28','09:25:00',1.11),('16273','2013-03-28','12:45:00',1.61),('16273','2013-03-28','12:50:00',1.37),('16273','2013-03-28','12:55:00',1.21),('16273','2013-03-28','13:00:00',1.37),('16273','2013-03-28','13:05:00',1.97),('16273','2013-03-28','13:10:00',1.63),('16273','2013-03-28','13:15:00',1.76),('16273','2013-03-28','13:20:00',2.03),('16273','2013-03-28','13:25:00',1.58),('16273','2013-03-28','13:30:00',1.51),('16273','2013-03-28','13:35:00',1.5),('16273','2013-03-28','13:40:00',1.02),('16273','2013-03-28','13:50:00',1.09),('16273','2013-03-28','13:55:00',1.52),('16273','2013-03-28','14:00:00',1.78),('16273','2013-03-28','14:05:00',1.67),('16273','2013-03-28','14:10:00',1.9),('16273','2013-03-28','14:15:00',1.93),('16273','2013-03-28','14:20:00',1.52),('16273','2013-03-28','14:25:00',1.19),('16273','2013-03-28','14:30:00',1.24),('16273','2013-03-28','14:35:00',1.24),('16273','2013-03-28','14:40:00',1.04),('16273','2013-03-28','15:00:00',1.07),('16273','2013-03-28','15:05:00',2.57),('16273','2013-03-28','15:10:00',3.28),('16273','2013-03-28','15:15:00',2.82),('16273','2013-03-28','15:20:00',1.33),('16273','2013-03-28','15:25:00',1.48),('16273','2013-03-28','15:30:00',1.27),('16273','2013-03-28','15:35:00',1.11),('16273','2013-03-28','15:40:00',1.78),('16273','2013-03-28','15:45:00',1.56),('16273','2013-03-28','15:50:00',1.79),('16273','2013-03-28','15:55:00',1.5),('16273','2013-03-28','16:00:00',1.21),('16273','2013-03-28','16:05:00',1.34),('16273','2013-03-28','16:10:00',1.59),('16273','2013-03-28','16:30:00',1.16),('16273','2013-03-28','16:55:00',1.1),('16273','2013-03-28','17:00:00',1.13),('16273','2013-03-28','17:05:00',1.03),('16273','2013-03-27','07:05:00',1.04),('16273','2013-03-27','07:15:00',1.17),('16273','2013-03-27','07:20:00',1.19),('16273','2013-03-27','07:25:00',1.47),('16273','2013-03-27','07:30:00',1.31),('16273','2013-03-27','07:35:00',1.53),('16273','2013-03-27','07:40:00',1.8),('16273','2013-03-27','07:45:00',2.12),('16273','2013-03-27','07:50:00',2.43),('16273','2013-03-27','07:55:00',1.55),('16273','2013-03-27','08:00:00',1.44),('16273','2013-03-27','08:05:00',1.16),('16273','2013-03-27','08:10:00',1.16),('16273','2013-03-27','08:15:00',1.14),('16273','2013-03-27','08:20:00',1.18),('16273','2013-03-27','08:25:00',1.5),('16273','2013-03-27','08:30:00',2.43),('16273','2013-03-27','08:35:00',1.99),('16273','2013-03-27','08:40:00',1.69),('16273','2013-03-27','08:45:00',1.97),('16273','2013-03-27','08:50:00',1.7),('16273','2013-03-27','08:55:00',1.08),('16273','2013-03-27','09:25:00',1.34),('16273','2013-03-27','09:30:00',1.78),('16273','2013-03-27','09:35:00',2.12),('16273','2013-03-27','09:40:00',3.26),('16273','2013-03-27','09:45:00',2.17),('16273','2013-03-27','09:50:00',3.63),('16273','2013-03-27','09:55:00',3.28),('16273','2013-03-27','10:00:00',2),('16273','2013-03-27','10:05:00',2.21),('16273','2013-03-27','10:10:00',3.16),('16273','2013-03-27','10:15:00',2.13),('16273','2013-03-27','10:20:00',2.93),('16273','2013-03-27','10:25:00',2.43),('16273','2013-03-27','10:30:00',2.32),('16273','2013-03-27','10:35:00',2.88),('16273','2013-03-27','10:40:00',2.7),('16273','2013-03-27','10:45:00',2.55),('16273','2013-03-27','10:50:00',1.99),('16273','2013-03-27','10:55:00',1.72),('16273','2013-03-27','11:00:00',1.68),('16273','2013-03-27','11:05:00',1.44),('16273','2013-03-27','11:10:00',1.03),('16273','2013-03-27','11:25:00',1.3),('16273','2013-03-27','11:30:00',1.69),('16273','2013-03-27','11:35:00',1.74),('16273','2013-03-27','11:40:00',1.6),('16273','2013-03-27','11:45:00',1.73),('16273','2013-03-27','11:50:00',2.83),('16273','2013-03-27','11:55:00',2.77),('16273','2013-03-27','12:00:00',2.3),('16273','2013-03-27','12:05:00',1.69),('16273','2013-03-27','12:10:00',1.99),('16273','2013-03-27','12:15:00',1.4),('16273','2013-03-27','12:20:00',1.13),('16273','2013-03-27','12:25:00',1.16),('16273','2013-03-27','12:30:00',1.61),('16273','2013-03-27','12:35:00',2.13),('16273','2013-03-27','12:40:00',2.99),('16273','2013-03-27','12:45:00',1.74),('16273','2013-03-27','12:50:00',2.17),('16273','2013-03-27','12:55:00',3.2),('16273','2013-03-27','13:00:00',3.13),('16273','2013-03-27','13:05:00',2.35),('16273','2013-03-27','13:10:00',2.11),('16273','2013-03-27','13:15:00',1.71),('16273','2013-03-27','13:20:00',1.65),('16273','2013-03-27','13:25:00',1.69),('16273','2013-03-27','13:30:00',1.81),('16273','2013-03-27','13:35:00',2.12),('16273','2013-03-27','13:40:00',2.36),('16273','2013-03-27','13:45:00',2.13),('16273','2013-03-27','13:50:00',1.73),('16273','2013-03-27','13:55:00',1.65),('16273','2013-03-27','14:00:00',1.5),('16273','2013-03-27','14:05:00',1.65),('16273','2013-03-27','14:10:00',1.9),('16273','2013-03-27','14:15:00',1.79),('16273','2013-03-27','14:20:00',1.57),('16273','2013-03-27','14:25:00',1.33),('16273','2013-03-27','14:30:00',1.49),('16273','2013-03-27','14:35:00',1.6),('16273','2013-03-27','14:40:00',1.32),('16273','2013-03-27','14:45:00',1.3),('16273','2013-03-27','15:20:00',1),('16273','2013-03-26','07:45:00',1.27),('16273','2013-03-26','08:25:00',1.02),('16273','2013-03-26','09:05:00',1.35),('16273','2013-03-26','09:10:00',1.43),('16273','2013-03-26','09:40:00',1.35),('16273','2013-03-26','09:45:00',1.55),('16273','2013-03-26','09:50:00',1.83),('16273','2013-03-26','10:45:00',1.06),('16273','2013-03-26','10:50:00',1.33),('16273','2013-03-26','10:55:00',2.14),('16273','2013-03-26','11:00:00',1.61),('16273','2013-03-26','11:40:00',1.07),('16273','2013-03-26','11:45:00',2.93),('16273','2013-03-26','11:50:00',3.06),('16273','2013-03-26','11:55:00',2.56),('16273','2013-03-26','12:00:00',1.57),('16273','2013-03-26','12:05:00',1.37),('16273','2013-03-26','12:10:00',1.32),('16273','2013-03-26','12:15:00',1.56),('16273','2013-03-26','12:20:00',2.81),('16273','2013-03-26','12:25:00',2.42),('16273','2013-03-26','12:30:00',2.2),('16273','2013-03-26','12:35:00',1.62),('16273','2013-03-26','12:40:00',2.18),('16273','2013-03-26','12:45:00',1.28),('16273','2013-03-26','12:50:00',1.13),('16273','2013-03-26','12:55:00',1.71),('16273','2013-03-26','13:00:00',1.65),('16273','2013-03-26','13:05:00',1.51),('16273','2013-03-26','13:10:00',1.12),('16273','2013-03-26','13:15:00',1.59),('16273','2013-03-26','13:20:00',1.82),('16273','2013-03-26','13:25:00',1.65),('16273','2013-03-26','13:30:00',2.15),('16273','2013-03-26','13:35:00',2.36),('16273','2013-03-26','13:40:00',1.81),('16273','2013-03-26','13:45:00',1.29),('16273','2013-03-26','13:50:00',1.41),('16273','2013-03-26','13:55:00',1.22),('16273','2013-03-26','14:00:00',1.45),('16273','2013-03-26','14:05:00',1.46),('16273','2013-03-26','14:10:00',1.32),('16273','2013-03-26','14:15:00',1.19),('16273','2013-03-26','14:20:00',1.05),('16273','2013-03-26','14:25:00',1.08),('16273','2013-03-26','14:30:00',1.09),('16273','2013-03-26','14:35:00',1.07),('16273','2013-03-25','08:15:00',2.54),('16273','2013-03-25','08:20:00',2.78),('16273','2013-03-25','08:25:00',2.91),('16273','2013-03-25','08:30:00',2.48),('16273','2013-03-25','08:40:00',1.73),('16273','2013-03-25','08:45:00',2.41),('16273','2013-03-25','08:50:00',1.49),('16273','2013-03-25','09:15:00',1.69),('16273','2013-03-25','09:20:00',3.16),('16273','2013-03-25','10:05:00',1.58),('16273','2013-03-25','10:10:00',1.37),('16273','2013-03-25','10:15:00',1.23),('16273','2013-03-25','10:20:00',1.11),('16273','2013-03-25','10:25:00',1.51),('16273','2013-03-25','10:30:00',1.52),('16273','2013-03-25','10:35:00',1.89),('16273','2013-03-25','10:40:00',1.68),('16273','2013-03-25','10:45:00',1.46),('16273','2013-03-25','10:50:00',1.66),('16273','2013-03-25','11:15:00',1.98),('16273','2013-03-25','11:20:00',1.3),('16273','2013-03-25','11:35:00',1.47),('16273','2013-03-25','11:40:00',2.69),('16273','2013-03-25','11:45:00',3.46),('16273','2013-03-25','11:50:00',3.77),('16273','2013-03-25','11:55:00',2.58),('16273','2013-03-25','12:00:00',2.13),('16273','2013-03-25','12:05:00',1.52),('16273','2013-03-25','12:10:00',3.75),('16273','2013-03-25','12:15:00',4.42),('16273','2013-03-25','12:20:00',3.52),('16273','2013-03-25','12:25:00',3.13),('16273','2013-03-25','12:30:00',3.34),('16273','2013-03-25','12:35:00',3.62),('16273','2013-03-25','12:40:00',4.34),('16273','2013-03-25','12:45:00',4.1),('16273','2013-03-25','12:50:00',1.34),('16273','2013-03-25','12:55:00',2.35),('16273','2013-03-25','13:00:00',1.35),('16273','2013-03-25','13:05:00',1.11),('16273','2013-03-25','13:10:00',1.18),('16273','2013-03-25','13:15:00',1.03),('16273','2013-03-25','13:20:00',2.82),('16273','2013-03-25','13:25:00',2.61),('16273','2013-03-25','13:30:00',2.66),('16273','2013-03-25','13:35:00',1.18),('16273','2013-03-25','13:40:00',1.62),('16273','2013-03-25','13:45:00',3.05),('16273','2013-03-25','13:50:00',2.35),('16273','2013-03-25','13:55:00',2.67),('16273','2013-03-25','14:00:00',2.73),('16273','2013-03-25','14:05:00',2.4),('16273','2013-03-25','14:10:00',2.15),('16273','2013-03-25','14:15:00',2.12),('16273','2013-03-25','14:20:00',2.36),('16273','2013-03-25','14:25:00',1.46),('16273','2013-03-25','14:30:00',2.25),('16273','2013-03-25','14:35:00',1.52),('16273','2013-03-25','14:40:00',1.55),('16273','2013-03-25','14:45:00',1.58),('16273','2013-03-25','14:50:00',2.32),('16273','2013-03-25','14:55:00',2.02),('16273','2013-03-25','15:00:00',2.31),('16273','2013-03-25','15:05:00',1.64),('16273','2013-03-25','15:10:00',2),('16273','2013-03-25','15:15:00',1.42),('16273','2013-03-25','15:20:00',1.99),('16273','2013-03-25','15:25:00',2.55),('16273','2013-03-25','15:30:00',1.65),('16273','2013-03-25','15:35:00',1.84),('16273','2013-03-25','15:40:00',2.08),('16273','2013-03-25','15:45:00',1.86),('16273','2013-03-25','15:50:00',1.71),('16273','2013-03-25','15:55:00',1.01),('16273','2013-03-25','16:00:00',1.41),('16273','2013-03-25','16:05:00',1.19),('16273','2013-03-25','16:20:00',1.43),('16273','2013-03-25','16:25:00',1.46),('16273','2013-03-25','16:30:00',1.37),('16273','2013-03-25','16:35:00',1.24),('16273','2013-03-24','07:20:00',1.01),('16273','2013-03-24','07:25:00',1.2),('16273','2013-03-24','07:35:00',1.18),('16273','2013-03-24','07:40:00',1.26),('16273','2013-03-24','07:45:00',1.5),('16273','2013-03-24','07:50:00',1.55),('16273','2013-03-24','07:55:00',1.71),('16273','2013-03-24','08:00:00',2.05),('16273','2013-03-24','08:05:00',2.21),('16273','2013-03-24','08:10:00',2.24),('16273','2013-03-24','08:15:00',2.37),('16273','2013-03-24','08:20:00',2.41),('16273','2013-03-24','08:25:00',2.46),('16273','2013-03-24','08:30:00',2.55),('16273','2013-03-24','08:35:00',2.63),('16273','2013-03-24','08:40:00',2.7),('16273','2013-03-24','08:45:00',2.76),('16273','2013-03-24','08:50:00',2.73),('16273','2013-03-24','08:55:00',2.82),('16273','2013-03-24','09:00:00',2.87),('16273','2013-03-24','09:05:00',2.92),('16273','2013-03-24','09:10:00',3.03),('16273','2013-03-24','09:15:00',3.1),('16273','2013-03-24','09:20:00',3.12),('16273','2013-03-24','09:25:00',3.17),('16273','2013-03-24','09:30:00',3.23),('16273','2013-03-24','09:35:00',3.28),('16273','2013-03-24','09:40:00',3.32),('16273','2013-03-24','09:45:00',3.37),('16273','2013-03-24','09:50:00',3.41),('16273','2013-03-24','09:55:00',3.44),('16273','2013-03-24','10:00:00',3.48),('16273','2013-03-24','10:05:00',3.46),('16273','2013-03-24','10:10:00',3.53),('16273','2013-03-24','10:15:00',3.57),('16273','2013-03-24','10:20:00',3.57),('16273','2013-03-24','10:25:00',3.56),('16273','2013-03-24','10:30:00',3.59),('16273','2013-03-24','10:35:00',3.62),('16273','2013-03-24','10:40:00',3.63),('16273','2013-03-24','10:45:00',3.65),('16273','2013-03-24','10:50:00',3.66),('16273','2013-03-24','10:55:00',3.7),('16273','2013-03-24','11:00:00',3.71),('16273','2013-03-24','11:05:00',3.7),('16273','2013-03-24','11:10:00',3.74),('16273','2013-03-24','11:15:00',3.79),('16273','2013-03-24','11:20:00',3.79),('16273','2013-03-24','11:25:00',3.8),('16273','2013-03-24','11:30:00',3.78),('16273','2013-03-24','11:35:00',3.76),('16273','2013-03-24','11:40:00',3.77),('16273','2013-03-24','11:45:00',3.78),('16273','2013-03-24','11:50:00',3.76),('16273','2013-03-24','11:55:00',3.76),('16273','2013-03-24','12:00:00',3.74),('16273','2013-03-24','12:05:00',3.72),('16273','2013-03-24','12:10:00',3.75),('16273','2013-03-24','12:15:00',3.79),('16273','2013-03-24','12:20:00',3.78),('16273','2013-03-24','12:25:00',3.78),('16273','2013-03-24','12:30:00',3.78),('16273','2013-03-24','12:35:00',3.77),('16273','2013-03-24','12:40:00',3.77),('16273','2013-03-24','12:45:00',3.75),('16273','2013-03-24','12:50:00',3.72),('16273','2013-03-24','12:55:00',3.69),('16273','2013-03-24','13:00:00',3.65),('16273','2013-03-24','13:05:00',3.55),('16273','2013-03-24','13:10:00',3.57),('16273','2013-03-24','13:15:00',3.56),('16273','2013-03-24','13:20:00',3.5),('16273','2013-03-24','13:25:00',3.47),('16273','2013-03-24','13:30:00',3.43),('16273','2013-03-24','13:35:00',3.39),('16273','2013-03-24','13:40:00',3.35),('16273','2013-03-24','13:45:00',3.29),('16273','2013-03-24','13:50:00',3.24),('16273','2013-03-24','13:55:00',3.18),('16273','2013-03-24','14:00:00',3.12),('16273','2013-03-24','14:05:00',3.06),('16273','2013-03-24','14:10:00',3.01),('16273','2013-03-24','14:15:00',2.93),('16273','2013-03-24','14:20:00',2.84),('16273','2013-03-24','14:25:00',2.73),('16273','2013-03-24','14:30:00',2.61),('16273','2013-03-24','14:35:00',2.58),('16273','2013-03-24','14:40:00',2.61),('16273','2013-03-24','14:45:00',2.52),('16273','2013-03-24','14:50:00',2.42),('16273','2013-03-24','14:55:00',2.37),('16273','2013-03-24','15:00:00',2.31),('16273','2013-03-24','15:05:00',2.27),('16273','2013-03-24','15:10:00',2.15),('16273','2013-03-24','15:15:00',2.16),('16273','2013-03-24','15:20:00',2.07),('16273','2013-03-24','15:25:00',1.91),('16273','2013-03-24','15:30:00',1.89),('16273','2013-03-24','15:35:00',1.86),('16273','2013-03-24','15:40:00',1.71),('16273','2013-03-24','15:45:00',1.06),('16273','2013-03-24','15:50:00',1.07),('16273','2013-03-24','15:55:00',1.03),('16273','2013-03-24','16:00:00',1.03),('16273','2013-03-24','16:15:00',1.24),('16273','2013-03-24','16:20:00',1.02),('16273','2013-03-23','07:15:00',1.09),('16273','2013-03-23','07:20:00',1.2),('16273','2013-03-23','07:25:00',1.01),('16273','2013-03-23','07:30:00',1.34),('16273','2013-03-23','07:35:00',1.41),('16273','2013-03-23','07:40:00',1.56),('16273','2013-03-23','07:45:00',1.61),('16273','2013-03-23','07:50:00',1.84),('16273','2013-03-23','07:55:00',2.02),('16273','2013-03-23','08:00:00',2.2),('16273','2013-03-23','08:05:00',2.27),('16273','2013-03-23','08:10:00',2.32),('16273','2013-03-23','08:15:00',2.39),('16273','2013-03-23','08:20:00',2.45),('16273','2013-03-23','08:25:00',2.5),('16273','2013-03-23','08:30:00',2.58),('16273','2013-03-23','08:35:00',2.66),('16273','2013-03-23','08:40:00',2.74),('16273','2013-03-23','08:45:00',2.77),('16273','2013-03-23','08:50:00',2.95),('16273','2013-03-23','08:55:00',2.96),('16273','2013-03-23','09:00:00',3.05),('16273','2013-03-23','09:05:00',3.13),('16273','2013-03-23','09:10:00',3.17),('16273','2013-03-23','09:15:00',3.18),('16273','2013-03-23','09:20:00',3.27),('16273','2013-03-23','09:25:00',3.31),('16273','2013-03-23','09:30:00',3.4),('16273','2013-03-23','09:35:00',3.28),('16273','2013-03-23','09:40:00',3.48),('16273','2013-03-23','09:45:00',3.46),('16273','2013-03-23','09:50:00',3.57),('16273','2013-03-23','09:55:00',3.59),('16273','2013-03-23','10:00:00',3.56),('16273','2013-03-23','10:05:00',3.51),('16273','2013-03-23','10:10:00',3.6),('16273','2013-03-23','10:15:00',3.59),('16273','2013-03-23','10:20:00',3.17),('16273','2013-03-23','10:25:00',3.38),('16273','2013-03-23','10:30:00',3.72),('16273','2013-03-23','10:35:00',3.63),('16273','2013-03-23','10:40:00',3.53),('16273','2013-03-23','10:45:00',3.56),('16273','2013-03-23','10:50:00',3.47),('16273','2013-03-23','10:55:00',3.14),('16273','2013-03-23','11:00:00',2.95),('16273','2013-03-23','11:05:00',1.96),('16273','2013-03-23','11:10:00',2.82),('16273','2013-03-23','11:15:00',3.5),('16273','2013-03-23','11:20:00',3.67),('16273','2013-03-23','11:25:00',3.53),('16273','2013-03-23','11:30:00',2.98),('16273','2013-03-23','11:35:00',3.9),('16273','2013-03-23','11:40:00',3.79),('16273','2013-03-23','11:45:00',3.52),('16273','2013-03-23','11:50:00',3.67),('16273','2013-03-23','11:55:00',3.67),('16273','2013-03-23','12:00:00',3.68),('16273','2013-03-23','12:05:00',3.68),('16273','2013-03-23','12:10:00',3.77),('16273','2013-03-23','12:15:00',3.71),('16273','2013-03-23','12:20:00',3.71),('16273','2013-03-23','12:25:00',3.65),('16273','2013-03-23','12:30:00',3.7),('16273','2013-03-23','12:35:00',3.57),('16273','2013-03-23','12:40:00',3.61),('16273','2013-03-23','12:45:00',3.71),('16273','2013-03-23','12:50:00',3.68),('16273','2013-03-23','12:55:00',2.9),('16273','2013-03-23','13:00:00',3.4),('16273','2013-03-23','13:05:00',3.57),('16273','2013-03-23','13:10:00',3.45),('16273','2013-03-23','13:15:00',3.52),('16273','2013-03-23','13:20:00',3.51),('16273','2013-03-23','13:25:00',3.41),('16273','2013-03-23','13:30:00',3.4),('16273','2013-03-23','13:35:00',3.37),('16273','2013-03-23','13:40:00',3.29),('16273','2013-03-23','13:45:00',3.23),('16273','2013-03-23','13:50:00',3.19),('16273','2013-03-23','13:55:00',3.17),('16273','2013-03-23','14:00:00',3.17),('16273','2013-03-23','14:05:00',3.04),('16273','2013-03-23','14:10:00',2.92),('16273','2013-03-23','14:15:00',2.91),('16273','2013-03-23','14:20:00',2.87),('16273','2013-03-23','14:25:00',2.87),('16273','2013-03-23','14:30:00',2.75),('16273','2013-03-23','14:35:00',2.66),('16273','2013-03-23','14:40:00',2.52),('16273','2013-03-23','14:45:00',2.43),('16273','2013-03-23','14:50:00',2.41),('16273','2013-03-23','14:55:00',2.32),('16273','2013-03-23','15:00:00',2.37),('16273','2013-03-23','15:05:00',2.2),('16273','2013-03-23','15:10:00',2.09),('16273','2013-03-23','15:15:00',2.03),('16273','2013-03-23','15:20:00',2.06),('16273','2013-03-23','15:25:00',1.95),('16273','2013-03-23','15:30:00',1.71),('16273','2013-03-23','15:35:00',1.72),('16273','2013-03-23','15:40:00',1.65),('16273','2013-03-23','15:45:00',1.35),('16273','2013-03-23','15:50:00',1.36),('16273','2013-03-23','15:55:00',1.26),('16273','2013-03-23','16:00:00',1.24),('16273','2013-03-23','16:05:00',1.38),('16273','2013-03-23','16:10:00',1.44),('16273','2013-03-23','16:15:00',1.28),('16273','2013-03-23','16:20:00',1.12),('16273','2014-03-26','07:10:00',1.13),('16273','2014-03-26','07:15:00',1.25),('16273','2014-03-26','07:20:00',1.49),('16273','2014-03-26','07:25:00',1.32),('16273','2014-03-26','07:30:00',1.74),('16273','2014-03-26','07:35:00',1.94),('16273','2014-03-26','07:40:00',1.84),('16273','2014-03-26','07:45:00',1.94),('16273','2014-03-26','07:50:00',2),('16273','2014-03-26','07:55:00',2.09),('16273','2014-03-26','08:00:00',2.19),('16273','2014-03-26','08:05:00',2.3),('16273','2014-03-26','08:10:00',2.45),('16273','2014-03-26','08:15:00',2.58),('16273','2014-03-26','08:40:00',1.04),('16273','2014-03-26','08:45:00',1.23),('16273','2014-03-26','08:50:00',1.44),('16273','2014-03-26','08:55:00',1.5),('16273','2014-03-26','09:00:00',2.11),('16273','2014-03-26','09:05:00',3.02),('16273','2014-03-26','09:10:00',2.88),('16273','2014-03-26','09:15:00',3.72),('16273','2014-03-26','09:20:00',3.48),('16273','2014-03-26','09:25:00',3.3),('16273','2014-03-26','09:30:00',3.31),('16273','2014-03-26','09:35:00',3.35),('16273','2014-03-26','09:40:00',3.38),('16273','2014-03-26','09:45:00',3.38),('16273','2014-03-26','09:50:00',3.42),('16273','2014-03-26','09:55:00',3.44),('16273','2014-03-26','10:00:00',3.5),('16273','2014-03-26','10:05:00',3.57),('16273','2014-03-26','10:10:00',3.62),('16273','2014-03-26','10:15:00',3.3),('16273','2014-03-26','10:20:00',1.39),('16273','2014-03-26','10:25:00',1.15),('16273','2014-03-26','10:30:00',1.08),('16273','2014-03-26','10:35:00',1.06),('16273','2014-03-26','10:40:00',1.32),('16273','2014-03-26','10:45:00',3.34),('16273','2014-03-26','10:50:00',3.56),('16273','2014-03-26','10:55:00',2.27),('16273','2014-03-26','11:00:00',1.24),('16273','2014-03-26','11:05:00',1.74),('16273','2014-03-26','11:10:00',1.26),('16273','2014-03-26','11:15:00',1.26),('16273','2014-03-26','11:20:00',1.04),('16273','2014-03-26','11:35:00',1.04),('16273','2014-03-26','11:40:00',1.84),('16273','2014-03-26','11:45:00',2.29),('16273','2014-03-26','11:50:00',2.7),('16273','2014-03-26','11:55:00',3.03),('16273','2014-03-26','12:00:00',3.22),('16273','2014-03-26','12:05:00',2.07),('16273','2014-03-26','12:10:00',1.13),('16273','2014-03-26','12:15:00',1.02),('16273','2014-03-26','12:20:00',1.47),('16273','2014-03-26','12:25:00',1.67),('16273','2014-03-26','12:30:00',2.07),('16273','2014-03-26','12:35:00',4.03),('16273','2014-03-26','12:40:00',4.35),('16273','2014-03-26','12:45:00',4.29),('16273','2014-03-26','12:50:00',3.85),('16273','2014-03-26','12:55:00',3.88),('16273','2014-03-26','13:00:00',1.59),('16273','2014-03-26','13:05:00',1.16),('16273','2014-03-26','13:10:00',1.1),('16273','2014-03-26','13:15:00',1.08),('16273','2014-03-26','13:20:00',1.9),('16273','2014-03-26','13:25:00',2.82),('16273','2014-03-26','13:30:00',3.77),('16273','2014-03-26','13:35:00',3),('16273','2014-03-26','13:40:00',2.14),('16273','2014-03-26','13:45:00',3.05),('16273','2014-03-26','13:50:00',3.31),('16273','2014-03-26','13:55:00',3.05),('16273','2014-03-26','14:00:00',3.08),('16273','2014-03-26','14:05:00',3.46),('16273','2014-03-26','14:10:00',3.36),('16273','2014-03-26','14:15:00',1.55),('16273','2014-03-26','14:20:00',1.05),('16273','2014-03-26','14:25:00',1.07),('16273','2014-03-26','14:45:00',1.09),('16273','2014-03-26','14:50:00',2.01),('16273','2014-03-26','14:55:00',2.26),('16273','2014-03-26','15:00:00',2.44),('16273','2014-03-26','15:05:00',2.4),('16273','2014-03-26','15:10:00',2.15),('16273','2014-03-26','15:15:00',2.28),('16273','2014-03-26','15:20:00',1.76),('16273','2014-03-26','15:25:00',2),('16273','2014-03-26','15:30:00',2.11),('16273','2014-03-26','15:35:00',1.91),('16273','2014-03-26','15:40:00',1.57),('16273','2014-03-26','15:50:00',1.12),('16273','2014-03-26','16:10:00',1.21),('16273','2014-03-26','16:15:00',1.49),('16273','2014-03-26','16:20:00',1.28),('16273','2013-03-22','07:15:00',1.1),('16273','2013-03-22','07:20:00',1.21),('16273','2013-03-22','07:25:00',1.26),('16273','2013-03-22','07:30:00',1.27),('16273','2013-03-22','07:35:00',1.58),('16273','2013-03-22','07:40:00',1.67),('16273','2013-03-22','07:45:00',1.78),('16273','2013-03-22','07:50:00',1.89),('16273','2013-03-22','07:55:00',1.98),('16273','2013-03-22','08:00:00',2.06),('16273','2013-03-22','08:05:00',2.19),('16273','2013-03-22','08:10:00',2.31),('16273','2013-03-22','08:15:00',2.41),('16273','2013-03-22','08:20:00',2.47),('16273','2013-03-22','08:25:00',2.53),('16273','2013-03-22','08:30:00',2.61),('16273','2013-03-22','08:35:00',2.71),('16273','2013-03-22','08:40:00',2.77),('16273','2013-03-22','08:45:00',2.82),('16273','2013-03-22','08:50:00',2.87),('16273','2013-03-22','08:55:00',2.94),('16273','2013-03-22','09:00:00',2.99),('16273','2013-03-22','09:05:00',3.03),('16273','2013-03-22','09:10:00',3.08),('16273','2013-03-22','09:15:00',3.15),('16273','2013-03-22','09:20:00',3.19),('16273','2013-03-22','09:25:00',3.28),('16273','2013-03-22','09:30:00',3.33),('16273','2013-03-22','09:35:00',3.34),('16273','2013-03-22','09:40:00',3.41),('16273','2013-03-22','09:45:00',3.46),('16273','2013-03-22','09:50:00',3.5),('16273','2013-03-22','09:55:00',3.55),('16273','2013-03-22','10:00:00',3.59),('16273','2013-03-22','10:05:00',3.62),('16273','2013-03-22','10:10:00',3.68),('16273','2013-03-22','10:15:00',3.71),('16273','2013-03-22','10:20:00',3.72),('16273','2013-03-22','10:25:00',3.75),('16273','2013-03-22','10:30:00',3.77),('16273','2013-03-22','10:35:00',3.78),('16273','2013-03-22','10:40:00',3.81),('16273','2013-03-22','10:45:00',3.84),('16273','2013-03-22','10:50:00',3.81),('16273','2013-03-22','10:55:00',3.85),('16273','2013-03-22','11:00:00',3.89),('16273','2013-03-22','11:05:00',3.9),('16273','2013-03-22','11:10:00',3.9),('16273','2013-03-22','11:15:00',3.88),('16273','2013-03-22','11:20:00',3.88),('16273','2013-03-22','11:25:00',3.91),('16273','2013-03-22','11:30:00',3.85),('16273','2013-03-22','11:35:00',3.96),('16273','2013-03-22','11:40:00',3.97),('16273','2013-03-22','11:45:00',3.97),('16273','2013-03-22','11:50:00',3.98),('16273','2013-03-22','11:55:00',3.98),('16273','2013-03-22','12:00:00',3.98),('16273','2013-03-22','12:05:00',3.97),('16273','2013-03-22','12:10:00',3.98),('16273','2013-03-22','12:15:00',3.93),('16273','2013-03-22','12:20:00',3.93),('16273','2013-03-22','12:25:00',3.93),('16273','2013-03-22','12:30:00',3.92),('16273','2013-03-22','12:35:00',3.88),('16273','2013-03-22','12:40:00',3.7),('16273','2013-03-22','12:45:00',3.86),('16273','2013-03-22','12:50:00',3.79),('16273','2013-03-22','12:55:00',3.81),('16273','2013-03-22','13:00:00',3.77),('16273','2013-03-22','13:05:00',3.75),('16273','2013-03-22','13:10:00',3.7),('16273','2013-03-22','13:15:00',3.64),('16273','2013-03-22','13:20:00',3.27),('16273','2013-03-22','13:25:00',3.05),('16273','2013-03-22','13:30:00',3.54),('16273','2013-03-22','13:35:00',3.47),('16273','2013-03-22','13:40:00',3.32),('16273','2013-03-22','13:45:00',3.46),('16273','2013-03-22','13:50:00',3.34),('16273','2013-03-22','13:55:00',3.27),('16273','2013-03-22','14:00:00',3.2),('16273','2013-03-22','14:05:00',3.17),('16273','2013-03-22','14:10:00',3.12),('16273','2013-03-22','14:15:00',3.06),('16273','2013-03-22','14:20:00',3),('16273','2013-03-22','14:25:00',2.94),('16273','2013-03-22','14:30:00',2.92),('16273','2013-03-22','14:35:00',2.79),('16273','2013-03-22','14:40:00',2.76),('16273','2013-03-22','14:45:00',2.66),('16273','2013-03-22','14:50:00',2.59),('16273','2013-03-22','14:55:00',2.61),('16273','2013-03-22','15:00:00',2.55),('16273','2013-03-22','15:05:00',2.31),('16273','2013-03-22','15:10:00',1.86),('16273','2013-03-22','15:15:00',1.47),('16273','2013-03-22','15:20:00',1.53),('16273','2013-03-22','15:25:00',1.63),('16273','2013-03-22','15:30:00',1.68),('16273','2013-03-22','15:35:00',1.6),('16273','2013-03-22','15:40:00',1.56),('16273','2013-03-22','15:45:00',1.45),('16273','2013-03-22','15:50:00',1.33),('16273','2013-03-22','15:55:00',1.35),('16273','2013-03-22','16:00:00',1.19),('16273','2013-03-22','16:05:00',1.39),('16273','2013-03-22','16:10:00',1.33),('16273','2013-03-22','16:15:00',1.31),('16273','2013-03-22','16:20:00',1.26),('16273','2013-03-22','16:25:00',1.3),('16273','2013-03-22','16:30:00',1.26),('16273','2013-03-22','16:35:00',1.19),('16273','2013-03-22','16:40:00',1.13),('16273','2013-03-22','16:45:00',1.02),('16273','2013-03-21','08:05:00',2.4),('16273','2013-03-21','08:10:00',2.28),('16273','2013-03-21','08:15:00',2.05),('16273','2013-03-21','08:20:00',2.16),('16273','2013-03-21','08:25:00',2.81),('16273','2013-03-21','08:30:00',2.17),('16273','2013-03-21','08:35:00',3.21),('16273','2013-03-21','08:40:00',2.49),('16273','2013-03-21','08:45:00',2.48),('16273','2013-03-21','08:55:00',1.14),('16273','2013-03-21','09:00:00',1.33),('16273','2013-03-21','09:05:00',2.93),('16273','2013-03-21','09:10:00',2.73),('16273','2013-03-21','09:15:00',1.94),('16273','2013-03-21','09:25:00',3.78),('16273','2013-03-21','09:30:00',3.5),('16273','2013-03-21','09:35:00',2.14),('16273','2013-03-21','09:40:00',3.48),('16273','2013-03-21','09:45:00',3.71),('16273','2013-03-21','09:50:00',3.72),('16273','2013-03-21','09:55:00',3.08),('16273','2013-03-21','10:00:00',2.08),('16273','2013-03-21','10:05:00',3.86),('16273','2013-03-21','10:10:00',3.84),('16273','2013-03-21','10:15:00',3.84),('16273','2013-03-21','10:20:00',3.83),('16273','2013-03-21','10:25:00',3.88),('16273','2013-03-21','10:30:00',3.89),('16273','2013-03-21','10:35:00',3.91),('16273','2013-03-21','10:40:00',3.89),('16273','2013-03-21','10:45:00',3.99),('16273','2013-03-21','10:50:00',4.03),('16273','2013-03-21','10:55:00',4.02),('16273','2013-03-21','11:00:00',4.07),('16273','2013-03-21','11:05:00',4.09),('16273','2013-03-21','11:10:00',4.11),('16273','2013-03-21','11:15:00',4.1),('16273','2013-03-21','11:20:00',4.14),('16273','2013-03-21','11:25:00',4.14),('16273','2013-03-21','11:30:00',4.14),('16273','2013-03-21','11:35:00',4.12),('16273','2013-03-21','11:40:00',4.16),('16273','2013-03-21','11:45:00',4.15),('16273','2013-03-21','11:50:00',4.16),('16273','2013-03-21','11:55:00',4.15),('16273','2013-03-21','12:00:00',4.16),('16273','2013-03-21','12:05:00',4.16),('16273','2013-03-21','12:10:00',4.13),('16273','2013-03-21','12:15:00',4.14),('16273','2013-03-21','12:20:00',4.12),('16273','2013-03-21','12:25:00',4.1),('16273','2013-03-21','12:30:00',4.08),('16273','2013-03-21','12:35:00',4.04),('16273','2013-03-21','12:40:00',4.01),('16273','2013-03-21','12:45:00',3.99),('16273','2013-03-21','12:50:00',3.93),('16273','2013-03-21','12:55:00',3.91),('16273','2013-03-21','13:00:00',3.88),('16273','2013-03-21','13:05:00',3.83),('16273','2013-03-21','13:10:00',3.8),('16273','2013-03-21','13:15:00',3.75),('16273','2013-03-21','13:20:00',3.69),('16273','2013-03-21','13:25:00',3.66),('16273','2013-03-21','13:30:00',3.61),('16273','2013-03-21','13:35:00',3.57),('16273','2013-03-21','13:40:00',3.51),('16273','2013-03-21','13:45:00',3.44),('16273','2013-03-21','13:50:00',3.39),('16273','2013-03-21','13:55:00',3.34),('16273','2013-03-21','14:00:00',3.27),('16273','2013-03-21','14:05:00',3.2),('16273','2013-03-21','14:10:00',3.16),('16273','2013-03-21','14:15:00',3.11),('16273','2013-03-21','14:20:00',3.04),('16273','2013-03-21','14:25:00',2.96),('16273','2013-03-21','14:30:00',2.9),('16273','2013-03-21','14:35:00',2.82),('16273','2013-03-21','14:40:00',2.76),('16273','2013-03-21','14:45:00',2.69),('16273','2013-03-21','14:50:00',2.61),('16273','2013-03-21','14:55:00',2.53),('16273','2013-03-21','15:00:00',2.45),('16273','2013-03-21','15:05:00',2.38),('16273','2013-03-21','15:10:00',2.31),('16273','2013-03-21','15:15:00',2.23),('16273','2013-03-21','15:20:00',2.15),('16273','2013-03-21','15:25:00',2.07),('16273','2013-03-21','15:30:00',1.98),('16273','2013-03-21','15:35:00',1.89),('16273','2013-03-21','15:40:00',1.79),('16273','2013-03-21','15:45:00',1.71),('16273','2013-03-21','15:50:00',1.63),('16273','2013-03-21','15:55:00',1.55),('16273','2013-03-21','16:00:00',1.46),('16273','2013-03-21','16:05:00',1.38),('16273','2013-03-21','16:10:00',1.3),('16273','2013-03-21','16:15:00',1.23),('16273','2013-03-21','16:20:00',1.14),('16273','2013-03-21','16:25:00',1.08),('16273','2013-03-20','07:15:00',1.08),('16273','2013-03-20','07:20:00',1.2),('16273','2013-03-20','07:25:00',1.35),('16273','2013-03-20','07:30:00',1.37),('16273','2013-03-20','07:35:00',1.49),('16273','2013-03-20','07:40:00',1.67),('16273','2013-03-20','07:45:00',1.84),('16273','2013-03-20','07:50:00',1.86),('16273','2013-03-20','08:00:00',1.06),('16273','2013-03-20','08:05:00',2.24),('16273','2013-03-20','08:10:00',2.28),('16273','2013-03-20','08:15:00',2.36),('16273','2013-03-20','08:20:00',2.44),('16273','2013-03-20','08:25:00',2.58),('16273','2013-03-20','08:30:00',2.24),('16273','2013-03-20','08:35:00',2.07),('16273','2013-03-20','08:40:00',2.6),('16273','2013-03-20','08:45:00',2.77),('16273','2013-03-20','08:50:00',2.75),('16273','2013-03-20','08:55:00',2.77),('16273','2013-03-20','09:00:00',2.65),('16273','2013-03-20','09:05:00',2.24),('16273','2013-03-20','09:10:00',2.76),('16273','2013-03-20','09:15:00',2.5),('16273','2013-03-20','09:20:00',3.33),('16273','2013-03-20','09:25:00',2.81),('16273','2013-03-20','09:30:00',3.32),('16273','2013-03-20','09:35:00',3.1),('16273','2013-03-20','09:40:00',3.27),('16273','2013-03-20','09:45:00',3.52),('16273','2013-03-20','09:50:00',3.68),('16273','2013-03-20','09:55:00',2.74),('16273','2013-03-20','10:00:00',3.36),('16273','2013-03-20','10:05:00',2.95),('16273','2013-03-20','10:10:00',2.6),('16273','2013-03-20','10:15:00',2),('16273','2013-03-20','10:20:00',2.78),('16273','2013-03-20','10:25:00',3.33),('16273','2013-03-20','10:30:00',3.2),('16273','2013-03-20','10:35:00',3.44),('16273','2013-03-20','10:40:00',3.11),('16273','2013-03-20','10:45:00',3.12),('16273','2013-03-20','10:50:00',2.88),('16273','2013-03-20','10:55:00',2.55),('16273','2013-03-20','11:00:00',3.66),('16273','2013-03-20','11:05:00',2.46),('16273','2013-03-20','11:10:00',2.13),('16273','2013-03-20','11:15:00',2.39),('16273','2013-03-20','11:20:00',2.59),('16273','2013-03-20','11:25:00',2.23),('16273','2013-03-20','11:30:00',2.37),('16273','2013-03-20','11:35:00',2.6),('16273','2013-03-20','11:40:00',2.14),('16273','2013-03-20','11:45:00',1.86),('16273','2013-03-20','11:50:00',1.98),('16273','2013-03-20','11:55:00',1.93),('16273','2013-03-20','12:00:00',2.15),('16273','2013-03-20','12:05:00',2.04),('16273','2013-03-20','12:10:00',1.65),('16273','2013-03-20','12:15:00',1.33),('16273','2013-03-20','12:20:00',1.19),('16273','2013-03-20','12:25:00',1.11),('16273','2013-03-20','12:30:00',1.28),('16273','2013-03-20','12:35:00',1.41),('16273','2013-03-20','12:40:00',1.08),('16273','2013-03-20','12:45:00',1.24),('16273','2013-03-20','12:50:00',1.67),('16273','2013-03-20','12:55:00',1.97),('16273','2013-03-20','13:00:00',1.24),('16273','2013-03-20','13:05:00',1.35),('16273','2013-03-20','13:10:00',1.18),('16273','2013-03-20','13:15:00',1.14),('16273','2013-03-20','13:20:00',1.21),('16273','2013-03-20','13:25:00',1.31),('16273','2013-03-20','13:30:00',1.41),('16273','2013-03-20','13:35:00',1.46),('16273','2013-03-20','13:40:00',1.88),('16273','2013-03-20','13:45:00',1.69),('16273','2013-03-20','13:50:00',1.49),('16273','2013-03-20','13:55:00',1.54),('16273','2013-03-20','14:00:00',1.36),('16273','2013-03-20','14:05:00',1.13),('16273','2013-03-20','14:10:00',1.34),('16273','2013-03-20','14:15:00',1.81),('16273','2013-03-20','14:20:00',1.82),('16273','2013-03-20','14:25:00',1.88),('16273','2013-03-20','14:30:00',1.56),('16273','2013-03-20','14:35:00',1.17),('16273','2013-03-20','14:40:00',1.03),('16273','2013-03-19','07:25:00',1.03),('16273','2013-03-19','07:35:00',1.46),('16273','2013-03-19','07:40:00',1.65),('16273','2013-03-19','07:45:00',1.71),('16273','2013-03-19','07:50:00',1.89),('16273','2013-03-19','07:55:00',1.53),('16273','2013-03-19','08:00:00',1.69),('16273','2013-03-19','08:05:00',1.98),('16273','2013-03-19','08:10:00',2.08),('16273','2013-03-19','08:15:00',2.24),('16273','2013-03-19','08:20:00',2.4),('16273','2013-03-19','08:25:00',2.51),('16273','2013-03-19','08:30:00',2.61),('16273','2013-03-19','08:35:00',2.71),('16273','2013-03-19','08:40:00',2.76),('16273','2013-03-19','08:45:00',2.85),('16273','2013-03-19','08:50:00',2.91),('16273','2013-03-19','08:55:00',2.97),('16273','2013-03-19','09:00:00',3.05),('16273','2013-03-19','09:05:00',3.09),('16273','2013-03-19','09:10:00',3.17),('16273','2013-03-19','09:15:00',3.26),('16273','2013-03-19','09:20:00',3.3),('16273','2013-03-19','09:25:00',3.37),('16273','2013-03-19','09:30:00',3.41),('16273','2013-03-19','09:35:00',3.49),('16273','2013-03-19','09:40:00',3.15),('16273','2013-03-19','09:45:00',3.33),('16273','2013-03-19','09:50:00',3.66),('16273','2013-03-19','09:55:00',2.71),('16273','2013-03-19','10:00:00',3.8),('16273','2013-03-19','10:05:00',3.78),('16273','2013-03-19','10:10:00',3.79),('16273','2013-03-19','10:15:00',3.85),('16273','2013-03-19','10:20:00',3.86),('16273','2013-03-19','10:25:00',3.88),('16273','2013-03-19','10:30:00',3.93),('16273','2013-03-19','10:35:00',3.95),('16273','2013-03-19','10:40:00',3.86),('16273','2013-03-19','10:45:00',4),('16273','2013-03-19','10:50:00',4.05),('16273','2013-03-19','10:55:00',4.07),('16273','2013-03-19','11:00:00',4.09),('16273','2013-03-19','11:05:00',4.08),('16273','2013-03-19','11:10:00',4.11),('16273','2013-03-19','11:15:00',4.19),('16273','2013-03-19','11:20:00',4.1),('16273','2013-03-19','11:25:00',4.15),('16273','2013-03-19','11:30:00',3.22),('16273','2013-03-19','11:35:00',2.87),('16273','2013-03-19','11:40:00',3.84),('16273','2013-03-19','11:45:00',3.61),('16273','2013-03-19','11:50:00',4.2),('16273','2013-03-19','11:55:00',4.14),('16273','2013-03-19','12:00:00',4.13),('16273','2013-03-19','12:05:00',4.01),('16273','2013-03-19','12:10:00',3.97),('16273','2013-03-19','12:15:00',4.05),('16273','2013-03-19','12:20:00',4.03),('16273','2013-03-19','12:25:00',3.58),('16273','2013-03-19','12:30:00',4.04),('16273','2013-03-19','12:35:00',3.96),('16273','2013-03-19','12:40:00',3.95),('16273','2013-03-19','12:45:00',3.93),('16273','2013-03-19','12:50:00',3.58),('16273','2013-03-19','12:55:00',3.74),('16273','2013-03-19','13:00:00',3.76),('16273','2013-03-19','13:05:00',3.74),('16273','2013-03-19','13:10:00',3.71),('16273','2013-03-19','13:15:00',3.7),('16273','2013-03-19','13:20:00',3.61),('16273','2013-03-19','13:25:00',3.6),('16273','2013-03-19','13:30:00',3.5),('16273','2013-03-19','13:35:00',3.49),('16273','2013-03-19','13:40:00',3.41),('16273','2013-03-19','13:45:00',3.41),('16273','2013-03-19','13:50:00',3.34),('16273','2013-03-19','13:55:00',3.27),('16273','2013-03-19','14:00:00',3.22),('16273','2013-03-19','14:05:00',3.16),('16273','2013-03-19','14:10:00',3.11),('16273','2013-03-19','14:15:00',3.06),('16273','2013-03-19','14:20:00',2.97),('16273','2013-03-19','14:25:00',2.91),('16273','2013-03-19','14:30:00',2.84),('16273','2013-03-19','14:35:00',2.78),('16273','2013-03-19','14:40:00',2.71),('16273','2013-03-19','14:45:00',2.64),('16273','2013-03-19','14:50:00',2.59),('16273','2013-03-19','14:55:00',2.5),('16273','2013-03-19','15:00:00',2.41),('16273','2013-03-19','15:05:00',2.34),('16273','2013-03-19','15:10:00',2.25),('16273','2013-03-19','15:15:00',2.18),('16273','2013-03-19','15:20:00',2.09),('16273','2013-03-19','15:25:00',2.02),('16273','2013-03-19','15:30:00',1.94),('16273','2013-03-19','15:35:00',1.86),('16273','2013-03-19','15:40:00',1.77),('16273','2013-03-19','15:45:00',1.69),('16273','2013-03-19','15:50:00',1.61),('16273','2013-03-19','15:55:00',1.52),('16273','2013-03-19','16:00:00',1.45),('16273','2013-03-19','16:05:00',1.36),('16273','2013-03-19','16:10:00',1.28),('16273','2013-03-19','16:15:00',1.21),('16273','2013-03-19','16:20:00',1.14),('16273','2013-03-19','16:25:00',1.08),('16273','2013-03-19','16:30:00',1.01),('16273','2013-03-18','08:40:00',1.12),('16273','2013-03-18','09:50:00',1.03),('16273','2013-03-18','09:55:00',1.22),('16273','2013-03-18','10:00:00',1.39),('16273','2013-03-18','10:05:00',1.43),('16273','2013-03-18','10:10:00',1.69),('16273','2013-03-18','10:15:00',2.2),('16273','2013-03-18','10:20:00',2.29),('16273','2013-03-18','10:25:00',2.25),('16273','2013-03-18','10:30:00',1.84),('16273','2013-03-18','10:35:00',1.5),('16273','2013-03-18','10:40:00',1.85),('16273','2013-03-18','10:45:00',1.39),('16273','2013-03-18','10:50:00',1),('16273','2013-03-18','10:55:00',1.04),('16273','2013-03-18','11:00:00',1.18),('16273','2013-03-18','11:05:00',1.4),('16273','2013-03-18','11:10:00',1.74),('16273','2013-03-18','11:15:00',1.95),('16273','2013-03-18','11:20:00',2.05),('16273','2013-03-18','11:25:00',2.37),('16273','2013-03-18','11:30:00',2.48),('16273','2013-03-18','11:35:00',1.72),('16273','2013-03-18','11:40:00',1.4),('16273','2013-03-18','11:45:00',1.09),('16273','2013-03-18','11:50:00',1.07),('16273','2013-03-18','11:55:00',1.16),('16273','2013-03-18','12:00:00',1.5),('16273','2013-03-18','12:05:00',1.88),('16273','2013-03-18','12:10:00',2.79),('16273','2013-03-18','12:15:00',4.02),('16273','2013-03-18','12:20:00',3.5),('16273','2013-03-18','12:25:00',3.48),('16273','2013-03-18','12:30:00',3.1),('16273','2013-03-18','12:35:00',2.07),('16273','2013-03-18','12:40:00',2.18),('16273','2013-03-18','12:45:00',3),('16273','2013-03-18','12:50:00',2.99),('16273','2013-03-18','12:55:00',2.54),('16273','2013-03-18','13:00:00',1.63),('16273','2013-03-18','13:05:00',1.71),('16273','2013-03-18','13:10:00',1.18),('16273','2013-03-18','13:15:00',1.22),('16273','2013-03-18','13:20:00',2.17),('16273','2013-03-18','13:25:00',1.46),('16273','2013-03-18','13:30:00',1.02),('16273','2013-03-18','13:35:00',1.66),('16273','2013-03-18','13:40:00',1.62),('16273','2013-03-18','13:45:00',1.44),('16273','2013-03-18','13:50:00',1.06),('16273','2013-03-18','13:55:00',1.06),('16273','2013-03-18','14:00:00',1.81),('16273','2013-03-18','14:05:00',1.88),('16273','2013-03-18','14:10:00',1.49),('16273','2013-03-18','14:20:00',1.1),('16273','2013-03-17','08:10:00',1.05),('16273','2013-03-17','08:15:00',1.02),('16273','2013-03-17','08:20:00',1.42),('16273','2013-03-17','08:25:00',1.51),('16273','2013-03-17','08:30:00',1.11),('16273','2013-03-17','08:35:00',1.16),('16273','2013-03-17','08:40:00',1.53),('16273','2013-03-17','08:45:00',1.32),('16273','2013-03-17','08:50:00',1.19),('16273','2013-03-17','08:55:00',1.13),('16273','2013-03-17','09:00:00',1.29),('16273','2013-03-17','09:05:00',1.71),('16273','2013-03-17','09:10:00',1.68),('16273','2013-03-17','09:15:00',1.42),('16273','2013-03-17','09:20:00',1.31),('16273','2013-03-17','09:25:00',1.22),('16273','2013-03-17','09:30:00',1.4),('16273','2013-03-17','09:35:00',1.39),('16273','2013-03-17','09:40:00',1.4),('16273','2013-03-17','09:45:00',1.56),('16273','2013-03-17','09:50:00',1.64),('16273','2013-03-17','09:55:00',1.82),('16273','2013-03-17','10:00:00',1.67),('16273','2013-03-17','10:05:00',1.54),('16273','2013-03-17','10:10:00',1.69),('16273','2013-03-17','10:15:00',1.8),('16273','2013-03-17','10:20:00',1.85),('16273','2013-03-17','10:25:00',1.77),('16273','2013-03-17','10:30:00',1.76),('16273','2013-03-17','10:35:00',1.72),('16273','2013-03-17','10:40:00',1.7),('16273','2013-03-17','10:45:00',1.66),('16273','2013-03-17','10:50:00',1.47),('16273','2013-03-17','10:55:00',1.32),('16273','2013-03-17','11:00:00',1.33),('16273','2013-03-17','11:05:00',1.47),('16273','2013-03-17','11:10:00',1.56),('16273','2013-03-17','11:15:00',1.84),('16273','2013-03-17','11:20:00',1.87),('16273','2013-03-17','11:25:00',1.6),('16273','2013-03-17','11:30:00',1.56),('16273','2013-03-17','11:35:00',1.47),('16273','2013-03-17','11:40:00',1.38),('16273','2013-03-17','11:45:00',1.25),('16273','2013-03-17','11:50:00',1.11),('16273','2013-03-17','11:55:00',1.04),('16273','2013-03-17','12:00:00',1.08),('16273','2013-03-17','12:05:00',1.36),('16273','2013-03-17','12:10:00',1.79),('16273','2013-03-17','12:15:00',2.51),('16273','2013-03-17','12:20:00',2.65),('16273','2013-03-17','12:25:00',2.93),('16273','2013-03-17','12:30:00',2.45),('16273','2013-03-17','12:35:00',2.68),('16273','2013-03-17','12:40:00',2.36),('16273','2013-03-17','12:45:00',2.07),('16273','2013-03-17','12:50:00',1.69),('16273','2013-03-17','12:55:00',2.06),('16273','2013-03-17','13:00:00',2.04),('16273','2013-03-17','13:05:00',2.18),('16273','2013-03-17','13:10:00',2.31),('16273','2013-03-17','13:15:00',1.9),('16273','2013-03-17','13:20:00',1.67),('16273','2013-03-17','13:25:00',2.44),('16273','2013-03-17','13:30:00',2.98),('16273','2013-03-17','13:35:00',2.22),('16273','2013-03-17','13:40:00',1.82),('16273','2013-03-17','13:45:00',1.44),('16273','2013-03-17','13:50:00',2.08),('16273','2013-03-17','13:55:00',1.93),('16273','2013-03-17','14:00:00',1.97),('16273','2013-03-17','14:05:00',2.09),('16273','2013-03-17','14:10:00',2.1),('16273','2013-03-17','14:15:00',2.15),('16273','2013-03-17','14:20:00',1.98),('16273','2013-03-17','14:25:00',1.94),('16273','2013-03-17','14:30:00',1.8),('16273','2013-03-17','14:35:00',1.61),('16273','2013-03-17','14:40:00',1.48),('16273','2013-03-17','14:45:00',1.29),('16273','2013-03-17','14:50:00',1.21),('16273','2013-03-17','14:55:00',1.66),('16273','2013-03-17','15:00:00',1.82),('16273','2013-03-17','15:05:00',2.52),('16273','2013-03-17','15:10:00',1.84),('16273','2013-03-17','15:15:00',1.96),('16273','2013-03-17','15:20:00',2.02),('16273','2013-03-17','15:25:00',1.27),('16273','2013-03-17','15:30:00',1.33),('16273','2013-03-17','15:35:00',1.06),('16273','2013-03-17','15:40:00',1.14),('16273','2013-03-16','08:00:00',1.09),('16273','2013-03-16','08:05:00',1.41),('16273','2013-03-16','08:15:00',1.11),('16273','2013-03-16','08:20:00',1.51),('16273','2013-03-16','08:25:00',2.39),('16273','2013-03-16','08:30:00',2.83),('16273','2013-03-16','08:35:00',2.69),('16273','2013-03-16','08:40:00',2.66),('16273','2013-03-16','08:45:00',3.37),('16273','2013-03-16','08:50:00',3.22),('16273','2013-03-16','08:55:00',3.39),('16273','2013-03-16','09:00:00',2.97),('16273','2013-03-16','09:05:00',3.34),('16273','2013-03-16','09:10:00',3.31),('16273','2013-03-16','09:15:00',3.22),('16273','2013-03-16','09:20:00',3.19),('16273','2013-03-16','09:25:00',3.57),('16273','2013-03-16','09:30:00',2.44),('16273','2013-03-16','09:35:00',3.58),('16273','2013-03-16','09:40:00',3.31),('16273','2013-03-16','09:45:00',3.66),('16273','2013-03-16','09:50:00',2.29),('16273','2013-03-16','09:55:00',2.6),('16273','2013-03-16','10:00:00',4.2),('16273','2013-03-16','10:05:00',3.29),('16273','2013-03-16','10:10:00',3.33),('16273','2013-03-16','10:15:00',3.58),('16273','2013-03-16','10:20:00',4.43),('16273','2013-03-16','10:25:00',4.03),('16273','2013-03-16','10:30:00',4.04),('16273','2013-03-16','10:35:00',4.02),('16273','2013-03-16','10:40:00',3.98),('16273','2013-03-16','10:45:00',4.09),('16273','2013-03-16','10:50:00',4.01),('16273','2013-03-16','10:55:00',4.01),('16273','2013-03-16','11:00:00',4.05),('16273','2013-03-16','11:05:00',4.04),('16273','2013-03-16','11:10:00',3.99),('16273','2013-03-16','11:15:00',4.02),('16273','2013-03-16','11:20:00',4.06),('16273','2013-03-16','11:25:00',4.06),('16273','2013-03-16','11:30:00',4.06),('16273','2013-03-16','11:35:00',4.03),('16273','2013-03-16','11:40:00',3.95),('16273','2013-03-16','11:45:00',3.99),('16273','2013-03-16','11:50:00',4.02),('16273','2013-03-16','11:55:00',4),('16273','2013-03-16','12:00:00',3.97),('16273','2013-03-16','12:05:00',4.02),('16273','2013-03-16','12:10:00',3.97),('16273','2013-03-16','12:15:00',3.92),('16273','2013-03-16','12:20:00',3.9),('16273','2013-03-16','12:25:00',3.34),('16273','2013-03-16','12:30:00',3.78),('16273','2013-03-16','12:35:00',3.98),('16273','2013-03-16','12:40:00',3.91),('16273','2013-03-16','12:45:00',3.86),('16273','2013-03-16','12:50:00',3.89),('16273','2013-03-16','12:55:00',3.89),('16273','2013-03-16','13:00:00',3.89),('16273','2013-03-16','13:05:00',3.83),('16273','2013-03-16','13:10:00',3.81),('16273','2013-03-16','13:15:00',3.83),('16273','2013-03-16','13:20:00',3.7),('16273','2013-03-16','13:25:00',3.63),('16273','2013-03-16','13:30:00',3.54),('16273','2013-03-16','13:35:00',3.62),('16273','2013-03-16','13:40:00',3.6),('16273','2013-03-16','13:45:00',3.31),('16273','2013-03-16','13:50:00',3.35),('16273','2013-03-16','13:55:00',3.37),('16273','2013-03-16','14:00:00',3.3),('16273','2013-03-16','14:05:00',3.37),('16273','2013-03-16','14:10:00',3.22),('16273','2013-03-16','14:15:00',3.24),('16273','2013-03-16','14:20:00',3.21),('16273','2013-03-16','14:25:00',3.34),('16273','2013-03-16','14:30:00',3.06),('16273','2013-03-16','14:35:00',2.7),('16273','2013-03-16','14:40:00',3.01),('16273','2013-03-16','14:45:00',2.97),('16273','2013-03-16','14:50:00',2.75),('16273','2013-03-16','14:55:00',2.8),('16273','2013-03-16','15:00:00',2.1),('16273','2013-03-16','15:05:00',1.67),('16273','2013-03-16','15:10:00',2.18),('16273','2013-03-16','15:15:00',2.35),('16273','2013-03-16','15:20:00',2.23),('16273','2013-03-16','15:25:00',2.11),('16273','2013-03-16','15:30:00',1.99),('16273','2013-03-16','15:35:00',1.9),('16273','2013-03-16','15:40:00',1.82),('16273','2013-03-16','15:45:00',1.76),('16273','2013-03-16','15:50:00',1.69),('16273','2013-03-16','15:55:00',1.56),('16273','2013-03-16','16:00:00',1.49),('16273','2013-03-16','16:05:00',1.42),('16273','2013-03-16','16:10:00',1.41),('16273','2013-03-16','16:15:00',1.46),('16273','2013-03-16','16:20:00',1.48),('16273','2013-03-16','16:25:00',1.44),('16273','2013-03-16','16:30:00',1.27),('16273','2013-03-16','16:35:00',1.19),('16273','2013-03-16','16:40:00',1.09),('16273','2013-03-15','10:25:00',1.12),('16273','2013-03-15','10:30:00',1.23),('16273','2013-03-15','10:35:00',1.28),('16273','2013-03-15','10:40:00',1.38),('16273','2013-03-15','10:45:00',1.34),('16273','2013-03-15','10:50:00',1.54),('16273','2013-03-15','10:55:00',1.69),('16273','2013-03-15','11:00:00',1.42),('16273','2013-03-15','11:05:00',1.2),('16273','2013-03-15','11:10:00',1),('16273','2013-03-15','11:15:00',1.06),('16273','2013-03-15','11:20:00',1.11),('16273','2013-03-15','11:25:00',1.22),('16273','2013-03-15','11:30:00',1.48),('16273','2013-03-15','11:35:00',1.57),('16273','2013-03-15','11:40:00',1.78),('16273','2013-03-15','11:45:00',1.79),('16273','2013-03-15','11:50:00',1.52),('16273','2013-03-15','11:55:00',1.59),('16273','2013-03-15','12:00:00',1.72),('16273','2013-03-15','12:05:00',1.58),('16273','2013-03-15','12:10:00',1.56),('16273','2013-03-15','12:15:00',1.87),('16273','2013-03-15','12:20:00',1.89),('16273','2013-03-15','12:25:00',1.81),('16273','2013-03-15','12:30:00',1.79),('16273','2013-03-15','12:35:00',1.59),('16273','2013-03-15','12:40:00',1.45),('16273','2013-03-15','12:45:00',1.39),('16273','2013-03-15','12:50:00',1.23),('16273','2013-03-15','12:55:00',1.23),('16273','2013-03-15','13:00:00',1.29),('16273','2013-03-15','13:05:00',1.31),('16273','2013-03-15','13:10:00',1.39),('16273','2013-03-15','13:15:00',1.56),('16273','2013-03-15','13:20:00',1.74),('16273','2013-03-15','13:25:00',1.58),('16273','2013-03-15','13:30:00',1.55),('16273','2013-03-15','13:35:00',1.17),('16273','2013-03-15','13:40:00',1.02),('16273','2013-03-15','13:50:00',1.07),('16273','2013-03-15','13:55:00',1.03),('16273','2013-03-15','14:40:00',1.03),('16273','2013-03-15','14:45:00',1.2),('16273','2013-03-15','14:50:00',1.25),('16273','2013-03-15','14:55:00',1.26),('16273','2013-03-15','15:00:00',1.25),('16273','2013-03-15','15:05:00',1.27),('16273','2013-03-15','15:10:00',1.34),('16273','2013-03-15','15:15:00',1.51),('16273','2013-03-15','15:20:00',1.33),('16273','2013-03-15','15:25:00',1.08),('16273','2013-03-14','12:35:00',1.01),('16273','2013-03-14','12:40:00',1.03),('16273','2013-03-14','12:45:00',1.07),('16273','2013-03-14','12:50:00',1.02),('16273','2013-03-14','12:55:00',1.2),('16273','2013-03-14','13:00:00',1.2),('16273','2013-03-14','13:05:00',1.09),('16273','2013-03-14','13:15:00',1.18),('16273','2013-03-14','13:20:00',1.43),('16273','2013-03-14','13:25:00',1.61),('16273','2013-03-14','13:30:00',1.74),('16273','2013-03-14','13:35:00',1.64),('16273','2013-03-14','13:40:00',1.3),('16273','2013-03-14','13:45:00',1.25),('16273','2013-03-14','13:50:00',1.18),('16273','2013-03-14','13:55:00',1.24),('16273','2013-03-14','14:00:00',1.34),('16273','2013-03-14','14:05:00',1.41),('16273','2013-03-14','14:10:00',1.2),('16273','2013-03-14','14:15:00',1.08),('16273','2013-03-13','09:10:00',1.29),('16273','2013-03-13','10:10:00',1.01),('16273','2013-03-13','10:30:00',1.25),('16273','2013-03-13','10:35:00',2.32),('16273','2013-03-13','10:40:00',3),('16273','2013-03-13','10:45:00',2.47),('16273','2013-03-13','10:50:00',1.53),('16273','2013-03-13','10:55:00',1.01),('16273','2013-03-13','11:00:00',1.31),('16273','2013-03-13','11:05:00',2.02),('16273','2013-03-13','11:10:00',1.75),('16273','2013-03-13','11:15:00',1.16),('16273','2013-03-13','11:20:00',1.08),('16273','2013-03-13','11:25:00',1.41),('16273','2013-03-13','11:30:00',1.55),('16273','2013-03-13','11:35:00',1.49),('16273','2013-03-13','11:40:00',1.46),('16273','2013-03-13','11:45:00',1.46),('16273','2013-03-13','11:50:00',1.22),('16273','2013-03-13','12:45:00',1.02),('16273','2013-03-13','12:50:00',1.07),('16273','2013-03-13','12:55:00',1.1),('16273','2013-03-13','13:00:00',1.04),('16273','2013-03-13','13:05:00',1.1),('16273','2013-03-13','13:30:00',1.15),('16273','2013-03-13','13:35:00',1.39),('16273','2013-03-13','13:40:00',1.52),('16273','2013-03-13','13:45:00',1.17),('16273','2014-03-25','07:10:00',1.25),('16273','2014-03-25','07:15:00',1.47),('16273','2014-03-25','07:20:00',1.35),('16273','2014-03-25','07:25:00',1.52),('16273','2014-03-25','07:30:00',1.23),('16273','2014-03-25','07:35:00',1.02),('16273','2014-03-25','07:40:00',1.18),('16273','2014-03-25','07:45:00',1.27),('16273','2014-03-25','07:50:00',1.28),('16273','2014-03-25','07:55:00',1.17),('16273','2014-03-25','08:00:00',1.17),('16273','2014-03-25','08:05:00',1.23),('16273','2014-03-25','08:10:00',1.35),('16273','2014-03-25','08:15:00',1.24),('16273','2014-03-25','08:20:00',1.09),('16273','2014-03-25','08:35:00',1.16),('16273','2014-03-25','08:40:00',1.62),('16273','2014-03-25','08:45:00',1.8),('16273','2014-03-25','08:50:00',1.92),('16273','2014-03-25','08:55:00',1.75),('16273','2014-03-25','09:00:00',1.65),('16273','2014-03-25','09:05:00',1.71),('16273','2014-03-25','09:10:00',2.13),('16273','2014-03-25','09:15:00',2.38),('16273','2014-03-25','09:20:00',2.22),('16273','2014-03-25','09:25:00',1.89),('16273','2014-03-25','09:30:00',1.7),('16273','2014-03-25','09:35:00',1.75),('16273','2014-03-25','09:40:00',1.63),('16273','2014-03-25','09:45:00',1.7),('16273','2014-03-25','09:50:00',1.94),('16273','2014-03-25','09:55:00',2.19),('16273','2014-03-25','10:00:00',2.48),('16273','2014-03-25','10:05:00',2.71),('16273','2014-03-25','10:10:00',2.93),('16273','2014-03-25','10:15:00',2.81),('16273','2014-03-25','10:20:00',2.9),('16273','2014-03-25','10:25:00',2.59),('16273','2014-03-25','10:30:00',2.13),('16273','2014-03-25','10:35:00',1.97),('16273','2014-03-25','10:40:00',1.8),('16273','2014-03-25','10:45:00',1.64),('16273','2014-03-25','10:50:00',1.73),('16273','2014-03-25','10:55:00',1.93),('16273','2014-03-25','11:00:00',2.17),('16273','2014-03-25','11:05:00',2.39),('16273','2014-03-25','11:10:00',2.44),('16273','2014-03-25','11:15:00',2.55),('16273','2014-03-25','11:20:00',2.69),('16273','2014-03-25','11:25:00',2.86),('16273','2014-03-25','11:30:00',2.94),('16273','2014-03-25','11:35:00',2.81),('16273','2014-03-25','11:40:00',2.27),('16273','2014-03-25','11:45:00',1.94),('16273','2014-03-25','11:50:00',1.68),('16273','2014-03-25','11:55:00',1.07),('16273','2014-03-25','12:10:00',1),('16273','2014-03-25','12:15:00',1.04),('16273','2014-03-25','12:20:00',1.15),('16273','2014-03-25','12:25:00',1.04),('16273','2014-03-25','12:30:00',1.05),('16273','2014-03-25','12:35:00',1.11),('16273','2014-03-25','12:40:00',1.15),('16273','2014-03-25','12:45:00',1.14),('16273','2014-03-25','12:50:00',1.06),('16273','2013-03-12','13:35:00',1.36),('16273','2013-03-12','13:40:00',2.79),('16273','2013-03-12','13:45:00',2.72),('16273','2013-03-12','13:50:00',3.01),('16273','2013-03-12','13:55:00',1.99),('16273','2013-03-12','14:00:00',2.2),('16273','2013-03-12','14:05:00',1.76),('16273','2013-03-12','14:10:00',2.06),('16273','2013-03-12','14:15:00',1.49),('16273','2013-03-12','14:20:00',1.32),('16273','2013-03-12','14:25:00',1.74),('16273','2013-03-12','14:50:00',1.4),('16273','2013-03-12','14:55:00',1.91),('16273','2013-03-12','15:00:00',1.06),('16273','2013-03-12','15:05:00',1.23),('16273','2013-03-12','15:10:00',1.84),('16273','2013-03-12','15:15:00',1.87),('16273','2013-03-12','15:20:00',1.64),('16273','2014-03-24','07:40:00',1.21),('16273','2014-03-24','08:30:00',1.38),('16273','2014-03-24','08:45:00',1.03),('16273','2014-03-24','08:50:00',1.93),('16273','2014-03-24','08:55:00',1.18),('16273','2014-03-24','09:15:00',3.38),('16273','2014-03-24','09:20:00',2.78),('16273','2014-03-24','09:25:00',1.51),('16273','2014-03-24','09:30:00',1.03),('16273','2014-03-24','09:35:00',2.57),('16273','2014-03-24','09:40:00',2.64),('16273','2014-03-24','09:45:00',1.35),('16273','2014-03-24','09:50:00',1.27),('16273','2014-03-24','09:55:00',3.28),('16273','2014-03-24','10:00:00',3.88),('16273','2014-03-24','10:05:00',4.7),('16273','2014-03-24','10:10:00',1.2),('16273','2014-03-24','10:15:00',1.64),('16273','2014-03-24','10:25:00',1.22),('16273','2014-03-24','10:30:00',1.48),('16273','2014-03-24','10:35:00',1),('16273','2014-03-24','10:40:00',1.51),('16273','2014-03-24','10:45:00',3.75),('16273','2014-03-24','10:50:00',4.24),('16273','2014-03-24','10:55:00',3.39),('16273','2014-03-24','11:00:00',2.51),('16273','2014-03-24','11:05:00',3.54),('16273','2014-03-24','11:10:00',3.1),('16273','2014-03-24','11:15:00',3.29),('16273','2014-03-24','11:20:00',4.25),('16273','2014-03-24','11:25:00',4.06),('16273','2014-03-24','11:30:00',1.72),('16273','2014-03-24','12:20:00',1.08),('16273','2014-03-24','12:25:00',1.49),('16273','2014-03-24','12:30:00',1.9),('16273','2014-03-24','12:35:00',1.73),('16273','2014-03-24','12:40:00',1.33),('16273','2014-03-24','12:45:00',1.25),('16273','2014-03-24','12:50:00',1.22),('16273','2014-03-24','12:55:00',1.17),('16273','2014-03-24','13:00:00',1.12),('16273','2014-03-24','13:05:00',1.02),('16273','2014-03-24','13:10:00',1.21),('16273','2014-03-24','13:15:00',1.16),('16273','2014-03-24','13:20:00',1.19),('16273','2014-03-24','13:25:00',1.32),('16273','2014-03-24','13:30:00',1.33),('16273','2014-03-24','13:35:00',1.33),('16273','2014-03-24','13:40:00',1.14),('16273','2014-03-24','13:45:00',1.14),('16273','2014-03-24','14:00:00',1.03),('16273','2014-03-24','14:05:00',1.16),('16273','2014-03-24','14:10:00',1.47),('16273','2014-03-24','14:15:00',2),('16273','2014-03-24','14:20:00',1.94),('16273','2014-03-24','14:25:00',1.9),('16273','2014-03-24','14:30:00',2.16),('16273','2014-03-24','14:35:00',2.4),('16273','2014-03-24','14:40:00',2.84),('16273','2014-03-24','14:45:00',2.87),('16273','2014-03-24','14:50:00',2.41),('16273','2014-03-24','14:55:00',2.16),('16273','2014-03-24','15:00:00',1.86),('16273','2014-03-24','15:05:00',1.66),('16273','2014-03-24','15:10:00',1.66),('16273','2014-03-24','15:15:00',1.46),('16273','2014-03-24','15:20:00',1.62),('16273','2014-03-24','15:25:00',1.82),('16273','2014-03-24','15:30:00',1.18),('16273','2014-03-24','15:40:00',1.34),('16273','2014-03-24','15:45:00',1.26),('16273','2014-03-24','15:50:00',1.62),('16273','2014-03-24','16:00:00',1.67),('16273','2014-03-23','08:25:00',1.1),('16273','2014-03-23','08:30:00',1.29),('16273','2014-03-23','08:45:00',1.29),('16273','2014-03-23','08:50:00',1.84),('16273','2014-03-23','08:55:00',1.58),('16273','2014-03-23','09:00:00',2.33),('16273','2014-03-23','09:05:00',2.83),('16273','2014-03-23','09:10:00',2.48),('16273','2014-03-23','09:15:00',1.65),('16273','2014-03-23','09:20:00',1.01),('16273','2014-03-23','09:25:00',1.11),('16273','2014-03-23','09:30:00',1.22),('16273','2014-03-23','09:55:00',1.03),('16273','2014-03-23','10:05:00',1.06),('16273','2014-03-23','10:20:00',1.65),('16273','2014-03-23','10:25:00',2.28),('16273','2014-03-23','10:30:00',1.09),('16273','2014-03-23','10:35:00',1.25),('16273','2014-03-23','10:40:00',1.36),('16273','2014-03-23','10:50:00',1.51),('16273','2014-03-23','10:55:00',1.11),('16273','2014-03-23','11:05:00',1.14),('16273','2014-03-23','11:20:00',1.08),('16273','2014-03-23','11:35:00',1.14),('16273','2014-03-23','13:35:00',1.63),('16273','2014-03-23','13:40:00',1.78),('16273','2014-03-23','13:45:00',1.11),('16273','2014-03-23','13:50:00',1.02),('16273','2014-03-23','15:05:00',1.32),('16273','2014-03-23','15:10:00',1.33),('16273','2014-03-23','15:15:00',1.43),('16273','2014-03-23','15:20:00',1.01),('16273','2014-03-22','07:45:00',1.36),('16273','2014-03-22','07:50:00',1.07),('16273','2014-03-22','08:00:00',1.1),('16273','2014-03-22','08:05:00',1.27),('16273','2014-03-22','08:10:00',1.79),('16273','2014-03-22','08:15:00',1.77),('16273','2014-03-22','08:20:00',1.72),('16273','2014-03-22','08:25:00',1.91),('16273','2014-03-22','08:30:00',1.85),('16273','2014-03-22','08:35:00',1.87),('16273','2014-03-22','08:40:00',2.24),('16273','2014-03-22','08:45:00',1.62),('16273','2014-03-22','08:50:00',1.97),('16273','2014-03-22','08:55:00',1.38),('16273','2014-03-22','09:00:00',1.44),('16273','2014-03-22','09:05:00',1.93),('16273','2014-03-22','09:10:00',1.26),('16273','2014-03-22','09:15:00',1.21),('16273','2014-03-22','09:20:00',1.65),('16273','2014-03-22','09:25:00',1.8),('16273','2014-03-22','09:30:00',2.21),('16273','2014-03-22','09:35:00',2.57),('16273','2014-03-22','09:40:00',2.96),('16273','2014-03-22','09:45:00',1.17),('16273','2014-03-22','09:50:00',2.23),('16273','2014-03-22','09:55:00',3.5),('16273','2014-03-22','10:00:00',2.79),('16273','2014-03-22','10:05:00',1.87),('16273','2014-03-22','10:10:00',1.08),('16273','2014-03-22','10:15:00',1.17),('16273','2014-03-22','10:20:00',1.33),('16273','2014-03-22','10:25:00',1.6),('16273','2014-03-22','10:30:00',1.64),('16273','2014-03-22','10:35:00',1.39),('16273','2014-03-22','10:40:00',1.47),('16273','2014-03-22','10:45:00',1.29),('16273','2014-03-22','10:50:00',1.14),('16273','2014-03-22','10:55:00',1.31),('16273','2014-03-22','11:00:00',1.77),('16273','2014-03-22','11:05:00',2.39),('16273','2014-03-22','11:10:00',2.21),('16273','2014-03-22','11:15:00',1.89),('16273','2014-03-22','11:20:00',2.19),('16273','2014-03-22','11:25:00',4.12),('16273','2014-03-22','11:30:00',3.16),('16273','2014-03-22','11:35:00',2.1),('16273','2014-03-22','11:40:00',3.42),('16273','2014-03-22','11:45:00',1.89),('16273','2014-03-22','11:50:00',3.74),('16273','2014-03-22','11:55:00',3.84),('16273','2014-03-22','12:00:00',2.52),('16273','2014-03-22','12:05:00',2.15),('16273','2014-03-22','12:10:00',2.81),('16273','2014-03-22','12:15:00',1.27),('16273','2014-03-22','12:20:00',3.71),('16273','2014-03-22','12:25:00',3.76),('16273','2014-03-22','12:30:00',2.72),('16273','2014-03-22','12:35:00',1.89),('16273','2014-03-22','12:40:00',2.5),('16273','2014-03-22','12:45:00',2.34),('16273','2014-03-22','12:50:00',1.34),('16273','2014-03-22','12:55:00',2.53),('16273','2014-03-22','13:00:00',2.57),('16273','2014-03-22','13:05:00',1.33),('16273','2014-03-22','13:10:00',2.93),('16273','2014-03-22','13:15:00',2.29),('16273','2014-03-22','13:20:00',3.44),('16273','2014-03-22','13:25:00',2.99),('16273','2014-03-22','13:30:00',3.3),('16273','2014-03-22','13:35:00',3.22),('16273','2014-03-22','13:40:00',3.14),('16273','2014-03-22','13:45:00',1.83),('16273','2014-03-22','13:50:00',2.07),('16273','2014-03-22','13:55:00',2.91),('16273','2014-03-22','14:00:00',2.88),('16273','2014-03-22','14:05:00',2.84),('16273','2014-03-22','14:10:00',2.79),('16273','2014-03-22','14:15:00',2.64),('16273','2014-03-22','14:20:00',1.74),('16273','2014-03-22','14:25:00',2.64),('16273','2014-03-22','14:30:00',2.53),('16273','2014-03-22','14:35:00',2.47),('16273','2014-03-22','14:40:00',2.4),('16273','2014-03-22','14:45:00',2.33),('16273','2014-03-22','14:50:00',2.12),('16273','2014-03-22','14:55:00',2.15),('16273','2014-03-22','15:00:00',2.11),('16273','2014-03-22','15:05:00',2.02),('16273','2014-03-22','15:10:00',1.74),('16273','2014-03-22','15:15:00',1.68),('16273','2014-03-22','15:20:00',1.87),('16273','2014-03-22','15:25:00',1.79),('16273','2014-03-22','15:30:00',1.92),('16273','2014-03-22','15:35:00',1.53),('16273','2014-03-22','15:40:00',1.46),('16273','2014-03-22','15:45:00',1.48),('16273','2014-03-22','15:50:00',1.17),('16273','2014-03-22','15:55:00',1.51),('16273','2014-03-22','16:00:00',1.41),('16273','2014-03-22','16:05:00',1.15),('16273','2014-03-22','16:20:00',1.11),('16273','2014-03-21','07:30:00',1.02),('16273','2014-03-21','07:35:00',1.24),('16273','2014-03-21','07:40:00',1.37),('16273','2014-03-21','07:45:00',1.53),('16273','2014-03-21','07:50:00',1.67),('16273','2014-03-21','07:55:00',1.74),('16273','2014-03-21','08:00:00',1.82),('16273','2014-03-21','08:05:00',1.88),('16273','2014-03-21','08:10:00',1.97),('16273','2014-03-21','08:15:00',1.98),('16273','2014-03-21','08:20:00',2.09),('16273','2014-03-21','08:25:00',2.2),('16273','2014-03-21','08:30:00',2.28),('16273','2014-03-21','08:35:00',2.34),('16273','2014-03-21','08:40:00',2.41),('16273','2014-03-21','08:45:00',2.46),('16273','2014-03-21','08:50:00',2.53),('16273','2014-03-21','08:55:00',2.57),('16273','2014-03-21','09:00:00',2.66),('16273','2014-03-21','09:05:00',2.65),('16273','2014-03-21','09:10:00',2.75),('16273','2014-03-21','09:15:00',2.76),('16273','2014-03-21','09:20:00',2.87),('16273','2014-03-21','09:25:00',2.79),('16273','2014-03-21','09:30:00',2.95),('16273','2014-03-21','09:35:00',3.06),('16273','2014-03-21','09:40:00',3.03),('16273','2014-03-21','09:45:00',3.07),('16273','2014-03-21','09:50:00',3.1),('16273','2014-03-21','09:55:00',3.16),('16273','2014-03-21','10:00:00',3.08),('16273','2014-03-21','10:05:00',3.13),('16273','2014-03-21','10:10:00',3.04),('16273','2014-03-21','10:15:00',3.16),('16273','2014-03-21','10:20:00',3.16),('16273','2014-03-21','10:25:00',3.25),('16273','2014-03-21','10:30:00',3.27),('16273','2014-03-21','10:35:00',3.34),('16273','2014-03-21','10:40:00',3.31),('16273','2014-03-21','10:45:00',3.34),('16273','2014-03-21','10:50:00',3.36),('16273','2014-03-21','10:55:00',3.46),('16273','2014-03-21','11:00:00',3.42),('16273','2014-03-21','11:05:00',3.42),('16273','2014-03-21','11:10:00',3.44),('16273','2014-03-21','11:15:00',3.43),('16273','2014-03-21','11:20:00',3.4),('16273','2014-03-21','11:25:00',3.45),('16273','2014-03-21','11:30:00',3.48),('16273','2014-03-21','11:35:00',3.52),('16273','2014-03-21','11:40:00',3.42),('16273','2014-03-21','11:45:00',3.32),('16273','2014-03-21','11:50:00',3.48),('16273','2014-03-21','11:55:00',3.45),('16273','2014-03-21','12:00:00',3.44),('16273','2014-03-21','12:05:00',3.48),('16273','2014-03-21','12:10:00',3.46),('16273','2014-03-21','12:15:00',3.5),('16273','2014-03-21','12:20:00',3.46),('16273','2014-03-21','12:25:00',3.43),('16273','2014-03-21','12:30:00',3.45),('16273','2014-03-21','12:35:00',3.45),('16273','2014-03-21','12:40:00',3.44),('16273','2014-03-21','12:45:00',3.43),('16273','2014-03-21','12:50:00',3.39),('16273','2014-03-21','12:55:00',3.36),('16273','2014-03-21','13:00:00',3.26),('16273','2014-03-21','13:05:00',3.29),('16273','2014-03-21','13:10:00',3.25),('16273','2014-03-21','13:15:00',3.23),('16273','2014-03-21','13:20:00',3.22),('16273','2014-03-21','13:25:00',3.18),('16273','2014-03-21','13:30:00',3.09),('16273','2014-03-21','13:35:00',3.09),('16273','2014-03-21','13:40:00',3.1),('16273','2014-03-21','13:45:00',3.02),('16273','2014-03-21','13:50:00',3),('16273','2014-03-21','13:55:00',2.97),('16273','2014-03-21','14:00:00',2.9),('16273','2014-03-21','14:05:00',2.84),('16273','2014-03-21','14:10:00',2.8),('16273','2014-03-21','14:15:00',2.75),('16273','2014-03-21','14:20:00',2.69),('16273','2014-03-21','14:25:00',2.61),('16273','2014-03-21','14:30:00',2.53),('16273','2014-03-21','14:35:00',1.96),('16273','2014-03-21','14:40:00',1.82),('16273','2014-03-21','14:45:00',1.05),('16273','2014-03-21','14:50:00',1.11),('16273','2014-03-21','14:55:00',2),('16273','2014-03-21','15:00:00',2.3),('16273','2014-03-21','15:05:00',2.39),('16273','2014-03-21','15:10:00',2.4),('16273','2014-03-21','15:15:00',1.83),('16273','2014-03-21','15:20:00',1.3),('16273','2014-03-21','15:25:00',2.17),('16273','2014-03-21','15:30:00',2.04),('16273','2014-03-21','15:35:00',1.98),('16273','2014-03-21','15:40:00',1.73),('16273','2014-03-21','15:45:00',1.83),('16273','2014-03-21','15:50:00',1.81),('16273','2014-03-21','15:55:00',1.72),('16273','2014-03-21','16:00:00',1.59),('16273','2014-03-21','16:05:00',1.42),('16273','2014-03-21','16:10:00',1.3),('16273','2014-03-21','16:15:00',1.18),('16273','2014-03-21','16:20:00',1.08),('16273','2014-03-20','07:30:00',1.07),('16273','2014-03-20','07:35:00',1.32),('16273','2014-03-20','07:40:00',1.45),('16273','2014-03-20','07:45:00',1.54),('16273','2014-03-20','07:50:00',1.59),('16273','2014-03-20','07:55:00',1.61),('16273','2014-03-20','08:00:00',1.69),('16273','2014-03-20','08:05:00',1.65),('16273','2014-03-20','08:10:00',1.62),('16273','2014-03-20','08:15:00',1.74),('16273','2014-03-20','08:20:00',1.87),('16273','2014-03-20','08:25:00',1.96),('16273','2014-03-20','08:30:00',2.1),('16273','2014-03-20','08:35:00',2.27),('16273','2014-03-20','08:40:00',2.37),('16273','2014-03-20','08:45:00',2.49),('16273','2014-03-20','08:50:00',2.51),('16273','2014-03-20','08:55:00',2.58),('16273','2014-03-20','09:00:00',2.62),('16273','2014-03-20','09:05:00',2.71),('16273','2014-03-20','09:10:00',2.75),('16273','2014-03-20','09:15:00',2.77),('16273','2014-03-20','09:20:00',2.87),('16273','2014-03-20','09:25:00',2.89),('16273','2014-03-20','09:30:00',2.91),('16273','2014-03-20','09:35:00',2.98),('16273','2014-03-20','09:40:00',2.96),('16273','2014-03-20','09:45:00',3.05),('16273','2014-03-20','09:50:00',3.14),('16273','2014-03-20','09:55:00',3.17),('16273','2014-03-20','10:00:00',3.25),('16273','2014-03-20','10:05:00',3.3),('16273','2014-03-20','10:10:00',3.25),('16273','2014-03-20','10:15:00',3.3),('16273','2014-03-20','10:20:00',3.41),('16273','2014-03-20','10:25:00',3.44),('16273','2014-03-20','10:30:00',3.43),('16273','2014-03-20','10:35:00',3.26),('16273','2014-03-20','10:40:00',3.17),('16273','2014-03-20','10:45:00',3.37),('16273','2014-03-20','10:50:00',3.49),('16273','2014-03-20','10:55:00',3.49),('16273','2014-03-20','11:00:00',3.5),('16273','2014-03-20','11:05:00',3.49),('16273','2014-03-20','11:10:00',3.26),('16273','2014-03-20','11:15:00',3.27),('16273','2014-03-20','11:20:00',3.4),('16273','2014-03-20','11:25:00',3.44),('16273','2014-03-20','11:30:00',3.34),('16273','2014-03-20','11:35:00',3.19),('16273','2014-03-20','11:40:00',3.14),('16273','2014-03-20','11:45:00',3.29),('16273','2014-03-20','11:50:00',3.36),('16273','2014-03-20','11:55:00',3.29),('16273','2014-03-20','12:00:00',2.96),('16273','2014-03-20','12:05:00',3.29),('16273','2014-03-20','12:10:00',3.44),('16273','2014-03-20','12:15:00',3.54),('16273','2014-03-20','12:20:00',3.28),('16273','2014-03-20','12:25:00',3.24),('16273','2014-03-20','12:30:00',3.43),('16273','2014-03-20','12:35:00',3.53),('16273','2014-03-20','12:40:00',3.51),('16273','2014-03-20','12:45:00',3.49),('16273','2014-03-20','12:50:00',3.42),('16273','2014-03-20','12:55:00',3.32),('16273','2014-03-20','13:00:00',3.24),('16273','2014-03-20','13:05:00',3.1),('16273','2014-03-20','13:10:00',3.12),('16273','2014-03-20','13:15:00',3.11),('16273','2014-03-20','13:20:00',3.07),('16273','2014-03-20','13:25:00',3.04),('16273','2014-03-20','13:30:00',2.96),('16273','2014-03-20','13:35:00',2.85),('16273','2014-03-20','13:40:00',2.71),('16273','2014-03-20','13:45:00',2.64),('16273','2014-03-20','13:50:00',2.69),('16273','2014-03-20','13:55:00',2.45),('16273','2014-03-20','14:00:00',2.5),('16273','2014-03-20','14:05:00',2.52),('16273','2014-03-20','14:10:00',2.47),('16273','2014-03-20','14:15:00',2.11),('16273','2014-03-20','14:20:00',2.04),('16273','2014-03-20','14:25:00',2.03),('16273','2014-03-20','14:30:00',2.08),('16273','2014-03-20','14:35:00',2.04),('16273','2014-03-20','14:40:00',2.08),('16273','2014-03-20','14:45:00',2.06),('16273','2014-03-20','14:50:00',2.04),('16273','2014-03-20','14:55:00',2),('16273','2014-03-20','15:00:00',1.84),('16273','2014-03-20','15:05:00',1.74),('16273','2014-03-20','15:10:00',1.77),('16273','2014-03-20','15:15:00',1.71),('16273','2014-03-20','15:20:00',1.62),('16273','2014-03-20','15:25:00',1.4),('16273','2014-03-20','15:30:00',1.34),('16273','2014-03-20','15:35:00',1.23),('16273','2014-03-20','15:40:00',1.12),('16273','2014-03-19','08:45:00',1),('16273','2014-03-19','09:00:00',1.06),('16273','2014-03-19','09:05:00',1.18),('16273','2014-03-19','09:10:00',1.15),('16273','2014-03-19','09:15:00',1.13),('16273','2014-03-19','09:20:00',1.31),('16273','2014-03-19','09:25:00',1.61),('16273','2014-03-19','09:30:00',1.6),('16273','2014-03-19','09:35:00',1.81),('16273','2014-03-19','09:40:00',1.73),('16273','2014-03-19','09:45:00',2.29),('16273','2014-03-19','09:50:00',2.03),('16273','2014-03-19','09:55:00',1.35),('16273','2014-03-19','10:00:00',1.3),('16273','2014-03-19','10:05:00',1.3),('16273','2014-03-19','10:10:00',1.32),('16273','2014-03-19','10:15:00',1.39),('16273','2014-03-19','10:20:00',3.61),('16273','2014-03-19','10:25:00',2.64),('16273','2014-03-19','10:30:00',1.35),('16273','2014-03-19','10:35:00',1.48),('16273','2014-03-19','10:40:00',1.96),('16273','2014-03-19','10:45:00',2.06),('16273','2014-03-19','10:50:00',1.5),('16273','2014-03-19','10:55:00',1.27),('16273','2014-03-19','11:00:00',1.08),('16273','2014-03-19','11:05:00',1.12),('16273','2014-03-19','11:10:00',1.19),('16273','2014-03-19','11:15:00',1.35),('16273','2014-03-19','11:20:00',1.47),('16273','2014-03-19','11:25:00',1.68),('16273','2014-03-19','11:30:00',1.89),('16273','2014-03-19','11:35:00',2.2),('16273','2014-03-19','11:40:00',1.95),('16273','2014-03-19','11:45:00',2.18),('16273','2014-03-19','11:50:00',1.55),('16273','2014-03-19','11:55:00',1.91),('16273','2014-03-19','12:00:00',3.17),('16273','2014-03-19','12:05:00',2.58),('16273','2014-03-19','12:10:00',3.61),('16273','2014-03-19','12:15:00',3.2),('16273','2014-03-19','12:20:00',3.23),('16273','2014-03-19','12:25:00',3.53),('16273','2014-03-19','12:30:00',3.52),('16273','2014-03-19','12:35:00',3.19),('16273','2014-03-19','12:40:00',3.22),('16273','2014-03-19','12:45:00',3.45),('16273','2014-03-19','12:50:00',3.47),('16273','2014-03-19','12:55:00',3.03),('16273','2014-03-19','13:00:00',3.29),('16273','2014-03-19','13:05:00',3.37),('16273','2014-03-19','13:10:00',3.08),('16273','2014-03-19','13:15:00',2.79),('16273','2014-03-19','13:20:00',2.93),('16273','2014-03-19','13:25:00',3.19),('16273','2014-03-19','13:30:00',3.07),('16273','2014-03-19','13:35:00',3.03),('16273','2014-03-19','13:40:00',3.09),('16273','2014-03-19','13:45:00',3),('16273','2014-03-19','13:50:00',2.96),('16273','2014-03-19','13:55:00',2.89),('16273','2014-03-19','14:00:00',2.85),('16273','2014-03-19','14:05:00',2.8),('16273','2014-03-19','14:10:00',2.75),('16273','2014-03-19','14:15:00',2.7),('16273','2014-03-19','14:20:00',2.58),('16273','2014-03-19','14:25:00',2.52),('16273','2014-03-19','14:30:00',2.49),('16273','2014-03-19','14:35:00',2.47),('16273','2014-03-19','14:40:00',2.38),('16273','2014-03-19','14:45:00',2.36),('16273','2014-03-19','14:50:00',2.3),('16273','2014-03-19','14:55:00',2.21),('16273','2014-03-19','15:00:00',2.13),('16273','2014-03-19','15:05:00',2.06),('16273','2014-03-19','15:10:00',2),('16273','2014-03-19','15:15:00',1.91),('16273','2014-03-19','15:20:00',1.85),('16273','2014-03-19','15:25:00',1.79),('16273','2014-03-19','15:30:00',1.68),('16273','2014-03-19','15:35:00',1.63),('16273','2014-03-19','15:40:00',1.57),('16273','2014-03-19','15:45:00',1.49),('16273','2014-03-19','15:50:00',1.43),('16273','2014-03-19','15:55:00',1.35),('16273','2014-03-19','16:00:00',1.28),('16273','2014-03-19','16:05:00',1.22),('16273','2014-03-19','16:10:00',1.15),('16273','2014-03-19','16:15:00',1.08),('16273','2014-03-18','07:45:00',1.25),('16273','2014-03-18','07:50:00',1.11),('16273','2014-03-18','07:55:00',1.13),('16273','2014-03-18','08:00:00',1.09),('16273','2014-03-18','08:15:00',1.03),('16273','2014-03-18','08:25:00',1.02),('16273','2014-03-18','08:30:00',1.83),('16273','2014-03-18','08:35:00',2.18),('16273','2014-03-18','08:40:00',1.16),('16273','2014-03-18','08:45:00',1.18),('16273','2014-03-18','08:50:00',1.22),('16273','2014-03-18','08:55:00',1.4),('16273','2014-03-18','09:00:00',2.99),('16273','2014-03-18','09:05:00',3.33),('16273','2014-03-18','09:10:00',3),('16273','2014-03-18','09:15:00',2.92),('16273','2014-03-18','09:20:00',3.29),('16273','2014-03-18','09:25:00',3.42),('16273','2014-03-18','09:30:00',3.46),('16273','2014-03-18','09:35:00',3.37),('16273','2014-03-18','09:40:00',1.47),('16273','2014-03-18','09:55:00',1.05),('16273','2014-03-18','10:00:00',1),('16273','2014-03-18','10:05:00',1.94),('16273','2014-03-18','10:10:00',2.14),('16273','2014-03-18','10:15:00',1.43),('16273','2014-03-18','10:20:00',3.03),('16273','2014-03-18','10:25:00',1.27),('16273','2014-03-18','10:30:00',2.2),('16273','2014-03-18','10:35:00',4.04),('16273','2014-03-18','10:40:00',3.74),('16273','2014-03-18','10:45:00',1.53),('16273','2014-03-18','10:50:00',1.37),('16273','2014-03-18','10:55:00',1.67),('16273','2014-03-18','11:00:00',3.79),('16273','2014-03-18','11:05:00',1.38),('16273','2014-03-18','11:10:00',1.45),('16273','2014-03-18','11:15:00',1.79),('16273','2014-03-18','11:20:00',2.43),('16273','2014-03-18','11:25:00',2.37),('16273','2014-03-18','11:30:00',3.29),('16273','2014-03-18','11:35:00',3.58),('16273','2014-03-18','11:40:00',3.48),('16273','2014-03-18','11:45:00',3.55),('16273','2014-03-18','11:50:00',3.18),('16273','2014-03-18','11:55:00',1.99),('16273','2014-03-18','12:00:00',2.09),('16273','2014-03-18','12:05:00',2.72),('16273','2014-03-18','12:10:00',2.05),('16273','2014-03-18','12:15:00',3.52),('16273','2014-03-18','12:20:00',2.59),('16273','2014-03-18','12:25:00',2.4),('16273','2014-03-18','12:30:00',2.95),('16273','2014-03-18','12:35:00',3.32),('16273','2014-03-18','12:40:00',3.11),('16273','2014-03-18','12:45:00',3.35),('16273','2014-03-18','12:50:00',2.57),('16273','2014-03-18','12:55:00',3.42),('16273','2014-03-18','13:00:00',3.37),('16273','2014-03-18','13:05:00',2.89),('16273','2014-03-18','13:10:00',3.29),('16273','2014-03-18','13:15:00',3.23),('16273','2014-03-18','13:20:00',3.22),('16273','2014-03-18','13:25:00',3.17),('16273','2014-03-18','13:30:00',3.18),('16273','2014-03-18','13:35:00',3.12),('16273','2014-03-18','13:40:00',3.06),('16273','2014-03-18','13:45:00',3.01),('16273','2014-03-18','13:50:00',2.99),('16273','2014-03-18','13:55:00',2.94),('16273','2014-03-18','14:00:00',2.92),('16273','2014-03-18','14:05:00',2.86),('16273','2014-03-18','14:10:00',2.74),('16273','2014-03-18','14:15:00',2.68),('16273','2014-03-18','14:20:00',2.65),('16273','2014-03-18','14:25:00',2.62),('16273','2014-03-18','14:30:00',2.49),('16273','2014-03-18','14:35:00',2.46),('16273','2014-03-18','14:40:00',2.42),('16273','2014-03-18','14:45:00',2.38),('16273','2014-03-18','14:50:00',2.29),('16273','2014-03-18','14:55:00',2.23),('16273','2014-03-18','15:00:00',2.14),('16273','2014-03-18','15:05:00',2.07),('16273','2014-03-18','15:10:00',2.01),('16273','2014-03-18','15:15:00',1.93),('16273','2014-03-18','15:20:00',1.85),('16273','2014-03-18','15:25:00',1.75),('16273','2014-03-18','15:30:00',1.69),('16273','2014-03-18','15:35:00',1.54),('16273','2014-03-18','15:40:00',1.52),('16273','2014-03-18','15:45:00',1.44),('16273','2014-03-18','15:50:00',1.37),('16273','2014-03-18','15:55:00',1.31),('16273','2014-03-18','16:00:00',1.25),('16273','2014-03-18','16:05:00',1.19),('16273','2014-03-18','16:10:00',1.04),('16273','2014-03-18','16:15:00',1.04),('16273','2014-05-01','07:40:00',1.45),('16273','2014-05-01','07:45:00',1.55),('16273','2014-05-01','07:50:00',1.61),('16273','2014-05-01','07:55:00',1.75),('16273','2014-05-01','08:00:00',1.87),('16273','2014-05-01','08:05:00',1.41),('16273','2014-05-01','08:10:00',1.92),('16273','2014-05-01','08:15:00',1.99),('16273','2014-05-01','08:20:00',2.06),('16273','2014-05-01','08:25:00',2.14),('16273','2014-05-01','08:30:00',2.23),('16273','2014-05-01','08:35:00',2.2),('16273','2014-05-01','08:40:00',1.68),('16273','2014-05-01','08:45:00',2.31),('16273','2014-05-01','08:50:00',1.78),('16273','2014-05-01','08:55:00',2.56),('16273','2014-05-01','09:00:00',2.48),('16273','2014-05-01','09:05:00',2.32),('16273','2014-05-01','09:10:00',1.62),('16273','2014-05-01','09:15:00',2.03),('16273','2014-05-01','09:20:00',1.02),('16273','2014-05-01','09:25:00',1.37),('16273','2014-05-01','09:30:00',2.5),('16273','2014-05-01','09:35:00',1.85),('16273','2014-05-01','09:40:00',1.31),('16273','2014-05-01','09:45:00',1.37),('16273','2014-05-01','09:50:00',2.25),('16273','2014-05-01','09:55:00',1.84),('16273','2014-05-01','10:00:00',2.94),('16273','2014-05-01','10:05:00',2.68),('16273','2014-05-01','10:10:00',1.43),('16273','2014-05-01','10:15:00',1.56),('16273','2014-05-01','10:20:00',2.15),('16273','2014-05-01','10:25:00',3.57),('16273','2014-05-01','10:30:00',2.88),('16273','2014-05-01','10:35:00',2.19),('16273','2014-05-01','10:40:00',2.87),('16273','2014-05-01','10:45:00',3.87),('16273','2014-05-01','10:50:00',3.56),('16273','2014-05-01','10:55:00',3.63),('16273','2014-05-01','11:00:00',4.03),('16273','2014-05-01','11:05:00',4.09),('16273','2014-05-01','11:10:00',2.33),('16273','2014-05-01','11:15:00',2.19),('16273','2014-05-01','11:20:00',3.23),('16273','2014-05-01','11:25:00',2.85),('16273','2014-05-01','11:30:00',1.86),('16273','2014-05-01','11:35:00',4.21),('16273','2014-05-01','11:40:00',4.32),('16273','2014-05-01','11:45:00',3.96),('16273','2014-05-01','11:50:00',4.29),('16273','2014-05-01','11:55:00',4.25),('16273','2014-05-01','12:00:00',4.17),('16273','2014-05-01','12:05:00',4.29),('16273','2014-05-01','12:10:00',3.04),('16273','2014-05-01','12:15:00',1.32),('16273','2014-05-01','12:20:00',1.44),('16273','2014-05-01','12:25:00',3.9),('16273','2014-05-01','12:30:00',2.74),('16273','2014-05-01','12:35:00',2.79),('16273','2014-05-01','12:40:00',4.51),('16273','2014-05-01','12:45:00',4.24),('16273','2014-05-01','12:50:00',2.93),('16273','2014-05-01','12:55:00',1.45),('16273','2014-05-01','13:00:00',3.29),('16273','2014-05-01','13:05:00',4.41),('16273','2014-05-01','13:10:00',4.29),('16273','2014-05-01','13:15:00',4.2),('16273','2014-05-01','13:20:00',4.05),('16273','2014-05-01','13:25:00',4.12),('16273','2014-05-01','13:30:00',4.21),('16273','2014-05-01','13:35:00',4),('16273','2014-05-01','13:40:00',3.94),('16273','2014-05-01','13:45:00',3.87),('16273','2014-05-01','13:50:00',3.49),('16273','2014-05-01','13:55:00',3.75),('16273','2014-05-01','14:00:00',3.74),('16273','2014-05-01','14:05:00',3.71),('16273','2014-05-01','14:10:00',3.66),('16273','2014-05-01','14:15:00',3.65),('16273','2014-05-01','14:20:00',3.61),('16273','2014-05-01','14:25:00',3.53),('16273','2014-05-01','14:30:00',3.43),('16273','2014-05-01','14:35:00',3.62),('16273','2014-05-01','14:40:00',3.43),('16273','2014-05-01','14:45:00',3.48),('16273','2014-05-01','14:50:00',3.33),('16273','2014-05-01','14:55:00',3.28),('16273','2014-05-01','15:00:00',3.32),('16273','2014-05-01','15:05:00',2.28),('16273','2014-05-01','15:10:00',3.35),('16273','2014-05-01','15:15:00',3.22),('16273','2014-05-01','15:20:00',3.07),('16273','2014-05-01','15:25:00',3.01),('16273','2014-05-01','15:30:00',2.99),('16273','2014-05-01','15:35:00',2.93),('16273','2014-05-01','15:40:00',2.81),('16273','2014-05-01','15:45:00',2.71),('16273','2014-05-01','15:50:00',2.66),('16273','2014-05-01','15:55:00',2.68),('16273','2014-05-01','16:00:00',2.72),('16273','2014-05-01','16:05:00',2.53),('16273','2014-05-01','16:10:00',2.42),('16273','2014-05-01','16:15:00',2.27),('16273','2014-05-01','16:20:00',2.15),('16273','2014-05-01','16:25:00',2.26),('16273','2014-05-01','16:30:00',2.2),('16273','2014-05-01','16:35:00',2.08),('16273','2014-05-01','16:40:00',1.8),('16273','2014-05-01','16:45:00',1.66),('16273','2014-05-01','16:50:00',1.59),('16273','2014-05-01','16:55:00',1.75),('16273','2014-05-01','17:00:00',1.51),('16273','2014-05-01','17:05:00',1.65),('16273','2014-05-01','17:10:00',1.57),('16273','2014-05-01','17:15:00',1.48),('16273','2014-05-01','17:20:00',1.26),('16273','2014-05-01','17:25:00',1.33),('16273','2014-05-01','17:30:00',1.29),('16273','2014-05-01','17:40:00',1.13),('16273','2014-03-17','10:25:00',1.19),('16273','2014-03-17','10:30:00',1.31),('16273','2014-03-17','10:35:00',1.63),('16273','2014-03-17','10:40:00',1.54),('16273','2014-03-17','10:45:00',2.42),('16273','2014-03-17','10:50:00',1.68),('16273','2014-03-17','10:55:00',1.84),('16273','2014-03-17','11:00:00',1.2),('16273','2014-03-17','11:05:00',1.29),('16273','2014-03-17','11:10:00',1.17),('16273','2014-03-17','11:20:00',1.17),('16273','2014-03-17','11:25:00',1.16),('16273','2014-03-17','11:35:00',1.14),('16273','2014-03-17','11:40:00',1.15),('16273','2014-03-17','11:45:00',1.25),('16273','2014-03-17','11:50:00',1.9),('16273','2014-03-17','11:55:00',2.3),('16273','2014-03-17','12:00:00',1.96),('16273','2014-03-17','12:05:00',3.97),('16273','2014-03-17','12:10:00',2.83),('16273','2014-03-17','12:15:00',2.87),('16273','2014-03-17','12:20:00',2.24),('16273','2014-03-17','12:25:00',2.68),('16273','2014-03-17','12:30:00',2.81),('16273','2014-03-17','12:35:00',3.64),('16273','2014-03-17','12:40:00',1.91),('16273','2014-03-17','12:45:00',2.57),('16273','2014-03-17','12:50:00',3.47),('16273','2014-03-17','12:55:00',3.55),('16273','2014-03-17','13:00:00',3.49),('16273','2014-03-17','13:05:00',3.28),('16273','2014-03-17','13:10:00',3.26),('16273','2014-03-17','13:15:00',3.29),('16273','2014-03-17','13:20:00',3.34),('16273','2014-03-17','13:25:00',3.15),('16273','2014-03-17','13:30:00',3.09),('16273','2014-03-17','13:35:00',2.73),('16273','2014-03-17','13:40:00',2.91),('16273','2014-03-17','13:45:00',2.7),('16273','2014-03-17','13:50:00',3.08),('16273','2014-03-17','13:55:00',2.3),('16273','2014-03-17','14:00:00',2.41),('16273','2014-03-17','14:05:00',2.84),('16273','2014-03-17','14:10:00',2.47),('16273','2014-03-17','14:15:00',1.65),('16273','2014-03-17','14:20:00',2.79),('16273','2014-03-17','14:25:00',2.18),('16273','2014-03-17','14:30:00',2.11),('16273','2014-03-17','14:35:00',2.17),('16273','2014-03-17','14:40:00',1.8),('16273','2014-03-17','14:45:00',2.43),('16273','2014-03-17','14:50:00',2.24),('16273','2014-03-17','14:55:00',2.07),('16273','2014-03-17','15:00:00',1.89),('16273','2014-03-17','15:05:00',2.03),('16273','2014-03-17','15:10:00',2.18),('16273','2014-03-17','15:15:00',1.26),('16273','2014-03-17','15:20:00',1.78),('16273','2014-03-17','15:25:00',1.76),('16273','2014-03-17','15:30:00',1.83),('16273','2014-03-17','15:35:00',1.57),('16273','2014-03-17','15:40:00',1.24),('16273','2014-03-17','15:45:00',1.42),('16273','2014-03-17','15:50:00',1.48),('16273','2014-03-17','15:55:00',1.19),('16273','2014-03-17','16:00:00',1.09),('16273','2014-03-17','16:05:00',1.17),('16273','2014-03-17','16:10:00',1.05),('16273','2014-03-17','16:15:00',1.02),('16273','2014-03-16','07:50:00',1.04),('16273','2014-03-16','07:55:00',1.07),('16273','2014-03-16','08:00:00',1.3),('16273','2014-03-16','08:05:00',1.47),('16273','2014-03-16','08:10:00',1.58),('16273','2014-03-16','08:15:00',1.57),('16273','2014-03-16','08:20:00',1.63),('16273','2014-03-16','08:25:00',1.78),('16273','2014-03-16','08:30:00',1.9),('16273','2014-03-16','08:35:00',2),('16273','2014-03-16','08:40:00',2.08),('16273','2014-03-16','08:45:00',2.11),('16273','2014-03-16','08:50:00',2.21),('16273','2014-03-16','08:55:00',2.26),('16273','2014-03-16','09:00:00',2.2),('16273','2014-03-16','09:05:00',2.25),('16273','2014-03-16','09:10:00',2.37),('16273','2014-03-16','09:15:00',2.56),('16273','2014-03-16','09:20:00',2.48),('16273','2014-03-16','09:25:00',2.56),('16273','2014-03-16','09:30:00',2.56),('16273','2014-03-16','09:35:00',2.52),('16273','2014-03-16','09:40:00',2.57),('16273','2014-03-16','09:45:00',2.69),('16273','2014-03-16','09:50:00',2.86),('16273','2014-03-16','09:55:00',2.8),('16273','2014-03-16','10:00:00',2.9),('16273','2014-03-16','10:05:00',2.83),('16273','2014-03-16','10:10:00',2.98),('16273','2014-03-16','10:15:00',3.07),('16273','2014-03-16','10:20:00',3.1),('16273','2014-03-16','10:25:00',3.06),('16273','2014-03-16','10:30:00',3.06),('16273','2014-03-16','10:35:00',3.1),('16273','2014-03-16','10:40:00',3.16),('16273','2014-03-16','10:45:00',3.21),('16273','2014-03-16','10:50:00',3.19),('16273','2014-03-16','10:55:00',3.21),('16273','2014-03-16','11:00:00',3.24),('16273','2014-03-16','11:05:00',3.3),('16273','2014-03-16','11:10:00',3.3),('16273','2014-03-16','11:15:00',3.3),('16273','2014-03-16','11:20:00',3.29),('16273','2014-03-16','11:25:00',3.31),('16273','2014-03-16','11:30:00',3.24),('16273','2014-03-16','11:35:00',3.3),('16273','2014-03-16','11:40:00',3.28),('16273','2014-03-16','11:45:00',3.37),('16273','2014-03-16','11:50:00',3.32),('16273','2014-03-16','11:55:00',3.34),('16273','2014-03-16','12:00:00',3.36),('16273','2014-03-16','12:05:00',3.34),('16273','2014-03-16','12:10:00',3.33),('16273','2014-03-16','12:15:00',3.29),('16273','2014-03-16','12:20:00',3.3),('16273','2014-03-16','12:25:00',3.26),('16273','2014-03-16','12:30:00',3.22),('16273','2014-03-16','12:35:00',3.21),('16273','2014-03-16','12:40:00',3.19),('16273','2014-03-16','12:45:00',3.19),('16273','2014-03-16','12:50:00',3.19),('16273','2014-03-16','12:55:00',3.19),('16273','2014-03-16','13:00:00',3.14),('16273','2014-03-16','13:05:00',3.09),('16273','2014-03-16','13:10:00',3.09),('16273','2014-03-16','13:15:00',3.03),('16273','2014-03-16','13:20:00',2.94),('16273','2014-03-16','13:25:00',2.98),('16273','2014-03-16','13:30:00',2.94),('16273','2014-03-16','13:35:00',2.93),('16273','2014-03-16','13:40:00',2.85),('16273','2014-03-16','13:45:00',2.88),('16273','2014-03-16','13:50:00',2.82),('16273','2014-03-16','13:55:00',2.78),('16273','2014-03-16','14:00:00',2.73),('16273','2014-03-16','14:05:00',2.66),('16273','2014-03-16','14:10:00',2.58),('16273','2014-03-16','14:15:00',2.56),('16273','2014-03-16','14:20:00',2.51),('16273','2014-03-16','14:25:00',2.46),('16273','2014-03-16','14:30:00',2.39),('16273','2014-03-16','14:35:00',2.31),('16273','2014-03-16','14:40:00',2.21),('16273','2014-03-16','14:45:00',2),('16273','2014-03-16','14:50:00',1.94),('16273','2014-03-16','14:55:00',2.21),('16273','2014-03-16','15:00:00',1.85),('16273','2014-03-16','15:05:00',1.77),('16273','2014-03-16','15:10:00',1.65),('16273','2014-03-16','15:15:00',1.39),('16273','2014-03-16','15:20:00',1.34),('16273','2014-03-16','15:25:00',1.41),('16273','2014-03-16','15:30:00',1.34),('16273','2014-03-16','15:35:00',1.07),('16273','2014-03-16','15:40:00',1.03),('16273','2014-03-16','15:45:00',1.27),('16273','2014-03-16','15:50:00',1.13),('16273','2014-03-16','16:05:00',1.1),('16273','2014-03-16','16:10:00',1.11),('16273','2014-03-16','16:15:00',1.06),('16273','2014-03-15','07:50:00',1.11),('16273','2014-03-15','07:55:00',1.21),('16273','2014-03-15','08:00:00',1.3),('16273','2014-03-15','08:05:00',1.38),('16273','2014-03-15','08:10:00',1.46),('16273','2014-03-15','08:15:00',1.55),('16273','2014-03-15','08:20:00',1.62),('16273','2014-03-15','08:25:00',1.69),('16273','2014-03-15','08:30:00',1.78),('16273','2014-03-15','08:35:00',1.86),('16273','2014-03-15','08:40:00',1.95),('16273','2014-03-15','08:45:00',2.04),('16273','2014-03-15','08:50:00',2.05),('16273','2014-03-15','08:55:00',2.17),('16273','2014-03-15','09:00:00',2.24),('16273','2014-03-15','09:05:00',2.3),('16273','2014-03-15','09:10:00',2.37),('16273','2014-03-15','09:15:00',2.45),('16273','2014-03-15','09:20:00',2.48),('16273','2014-03-15','09:25:00',2.52),('16273','2014-03-15','09:30:00',2.56),('16273','2014-03-15','09:35:00',2.6),('16273','2014-03-15','09:40:00',2.66),('16273','2014-03-15','09:45:00',2.69),('16273','2014-03-15','09:50:00',2.74),('16273','2014-03-15','09:55:00',2.81),('16273','2014-03-15','10:00:00',2.86),('16273','2014-03-15','10:05:00',2.9),('16273','2014-03-15','10:10:00',2.94),('16273','2014-03-15','10:15:00',2.97),('16273','2014-03-15','10:20:00',2.99),('16273','2014-03-15','10:25:00',3.01),('16273','2014-03-15','10:30:00',3.04),('16273','2014-03-15','10:35:00',3.09),('16273','2014-03-15','10:40:00',3.13),('16273','2014-03-15','10:45:00',3.16),('16273','2014-03-15','10:50:00',3.2),('16273','2014-03-15','10:55:00',3.19),('16273','2014-03-15','11:00:00',3.23),('16273','2014-03-15','11:05:00',3.15),('16273','2014-03-15','11:10:00',3.21),('16273','2014-03-15','11:15:00',3.23),('16273','2014-03-15','11:20:00',3.31),('16273','2014-03-15','11:25:00',3.23),('16273','2014-03-15','11:30:00',3.19),('16273','2014-03-15','11:35:00',3.3),('16273','2014-03-15','11:40:00',3.3),('16273','2014-03-15','11:45:00',3.29),('16273','2014-03-15','11:50:00',3.23),('16273','2014-03-15','11:55:00',3.28),('16273','2014-03-15','12:00:00',3.26),('16273','2014-03-15','12:05:00',3.27),('16273','2014-03-15','12:10:00',3.27),('16273','2014-03-15','12:15:00',3.29),('16273','2014-03-15','12:20:00',3.29),('16273','2014-03-15','12:25:00',3.3),('16273','2014-03-15','12:30:00',3.27),('16273','2014-03-15','12:35:00',3.28),('16273','2014-03-15','12:40:00',3.24),('16273','2014-03-15','12:45:00',3.24),('16273','2014-03-15','12:50:00',3.22),('16273','2014-03-15','12:55:00',3.16),('16273','2014-03-15','13:00:00',3.16),('16273','2014-03-15','13:05:00',3.14),('16273','2014-03-15','13:10:00',3.15),('16273','2014-03-15','13:15:00',3.13),('16273','2014-03-15','13:20:00',3.08),('16273','2014-03-15','13:25:00',3.05),('16273','2014-03-15','13:30:00',3.01),('16273','2014-03-15','13:35:00',2.97),('16273','2014-03-15','13:40:00',2.93),('16273','2014-03-15','13:45:00',2.89),('16273','2014-03-15','13:50:00',2.85),('16273','2014-03-15','13:55:00',2.8),('16273','2014-03-15','14:00:00',2.76),('16273','2014-03-15','14:05:00',2.72),('16273','2014-03-15','14:10:00',2.66),('16273','2014-03-15','14:15:00',2.6),('16273','2014-03-15','14:20:00',2.54),('16273','2014-03-15','14:25:00',2.48),('16273','2014-03-15','14:30:00',2.43),('16273','2014-03-15','14:35:00',2.33),('16273','2014-03-15','14:40:00',2.3),('16273','2014-03-15','14:45:00',2.23),('16273','2014-03-15','14:50:00',2.18),('16273','2014-03-15','14:55:00',2.09),('16273','2014-03-15','15:00:00',2.02),('16273','2014-03-15','15:05:00',1.95),('16273','2014-03-15','15:10:00',1.9),('16273','2014-03-15','15:15:00',1.83),('16273','2014-03-15','15:20:00',1.71),('16273','2014-03-15','15:25:00',1.66),('16273','2014-03-15','15:30:00',1.61),('16273','2014-03-15','15:35:00',1.53),('16273','2014-03-15','15:40:00',1.45),('16273','2014-03-15','15:45:00',1.36),('16273','2014-03-15','15:50:00',1.29),('16273','2014-03-15','15:55:00',1.22),('16273','2014-03-15','16:00:00',1.13),('16273','2014-03-15','16:05:00',1.08),('16273','2014-03-15','16:10:00',1.04),('16273','2014-03-14','08:25:00',1.04),('16273','2014-03-14','08:30:00',1.07),('16273','2014-03-14','08:55:00',1.01),('16273','2014-03-14','09:00:00',1.12),('16273','2014-03-14','09:05:00',1.26),('16273','2014-03-14','09:10:00',1.5),('16273','2014-03-14','09:15:00',1.8),('16273','2014-03-14','09:20:00',1.85),('16273','2014-03-14','09:25:00',1.68),('16273','2014-03-14','09:30:00',1.73),('16273','2014-03-14','09:35:00',1.62),('16273','2014-03-14','09:40:00',1.64),('16273','2014-03-14','09:45:00',1.99),('16273','2014-03-14','09:50:00',2.4),('16273','2014-03-14','09:55:00',2.7),('16273','2014-03-14','10:00:00',3.04),('16273','2014-03-14','10:05:00',3.33),('16273','2014-03-14','10:10:00',3.37),('16273','2014-03-14','10:15:00',3.27),('16273','2014-03-14','10:20:00',2.75),('16273','2014-03-14','10:25:00',3.17),('16273','2014-03-14','10:30:00',3.15),('16273','2014-03-14','10:35:00',3.19),('16273','2014-03-14','10:40:00',3.26),('16273','2014-03-14','10:45:00',3.26),('16273','2014-03-14','10:50:00',3.22),('16273','2014-03-14','10:55:00',2.38),('16273','2014-03-14','11:00:00',3.17),('16273','2014-03-14','11:05:00',3.24),('16273','2014-03-14','11:10:00',3.24),('16273','2014-03-14','11:15:00',3.47),('16273','2014-03-14','11:20:00',3.47),('16273','2014-03-14','11:25:00',3.26),('16273','2014-03-14','11:30:00',3.06),('16273','2014-03-14','11:35:00',3.27),('16273','2014-03-14','11:40:00',3.32),('16273','2014-03-14','11:45:00',3.36),('16273','2014-03-14','11:50:00',3.44),('16273','2014-03-14','11:55:00',3.53),('16273','2014-03-14','12:00:00',3.52),('16273','2014-03-14','12:05:00',3.48),('16273','2014-03-14','12:10:00',3.47),('16273','2014-03-14','12:15:00',3.44),('16273','2014-03-14','12:20:00',3.24),('16273','2014-03-14','12:25:00',3.05),('16273','2014-03-14','12:30:00',2.71),('16273','2014-03-14','12:35:00',2.08),('16273','2014-03-14','12:40:00',1.66),('16273','2014-03-14','12:45:00',1.67),('16273','2014-03-14','12:50:00',2.1),('16273','2014-03-14','12:55:00',2.37),('16273','2014-03-14','13:00:00',2.45),('16273','2014-03-14','13:05:00',2),('16273','2014-03-14','13:10:00',2.07),('16273','2014-03-14','13:15:00',2.46),('16273','2014-03-14','13:20:00',2.37),('16273','2014-03-14','13:25:00',1.98),('16273','2014-03-14','13:30:00',2.03),('16273','2014-03-14','13:35:00',1.89),('16273','2014-03-14','13:40:00',1.69),('16273','2014-03-14','13:45:00',1.84),('16273','2014-03-14','13:50:00',1.94),('16273','2014-03-14','13:55:00',2.01),('16273','2014-03-14','14:00:00',2.05),('16273','2014-03-14','14:05:00',1.97),('16273','2014-03-14','14:10:00',2.54),('16273','2014-03-14','14:15:00',2.34),('16273','2014-03-14','14:20:00',2.43),('16273','2014-03-14','14:25:00',2.66),('16273','2014-03-14','14:30:00',2.57),('16273','2014-03-14','14:35:00',2.01),('16273','2014-03-14','14:40:00',1.82),('16273','2014-03-14','14:45:00',1.56),('16273','2014-03-14','14:50:00',1.45),('16273','2014-03-14','14:55:00',1.41),('16273','2014-03-14','15:00:00',1.47),('16273','2014-03-14','15:05:00',1.18),('16273','2014-03-14','15:10:00',1.13),('16273','2014-03-14','15:15:00',1.17),('16273','2014-03-14','15:20:00',1.11),('16273','2014-03-14','15:25:00',1.15),('16273','2014-03-14','15:30:00',1.33),('16273','2014-03-14','15:35:00',1.38),('16273','2014-03-14','15:40:00',1.43),('16273','2014-03-14','15:45:00',1.31),('16273','2014-03-14','15:50:00',1.06),('16273','2014-03-14','15:55:00',1.04),('16273','2014-03-13','07:30:00',1.04),('16273','2014-03-13','07:35:00',1.18),('16273','2014-03-13','07:40:00',1.3),('16273','2014-03-13','07:45:00',1.22),('16273','2014-03-13','07:50:00',1.56),('16273','2014-03-13','07:55:00',1.66),('16273','2014-03-13','08:00:00',1.76),('16273','2014-03-13','08:05:00',1.84),('16273','2014-03-13','08:10:00',1.92),('16273','2014-03-13','08:15:00',2.01),('16273','2014-03-13','08:20:00',2.09),('16273','2014-03-13','08:25:00',2.16),('16273','2014-03-13','08:30:00',2.23),('16273','2014-03-13','08:35:00',2.31),('16273','2014-03-13','08:40:00',2.38),('16273','2014-03-13','08:45:00',2.46),('16273','2014-03-13','08:50:00',2.53),('16273','2014-03-13','08:55:00',2.59),('16273','2014-03-13','09:00:00',2.65),('16273','2014-03-13','09:05:00',2.7),('16273','2014-03-13','09:10:00',2.78),('16273','2014-03-13','09:15:00',2.84),('16273','2014-03-13','09:20:00',2.89),('16273','2014-03-13','09:25:00',2.94),('16273','2014-03-13','09:30:00',2.99),('16273','2014-03-13','09:35:00',3.04),('16273','2014-03-13','09:40:00',3.07),('16273','2014-03-13','09:45:00',3.11),('16273','2014-03-13','09:50:00',3.15),('16273','2014-03-13','09:55:00',3.17),('16273','2014-03-13','10:00:00',3.22),('16273','2014-03-13','10:05:00',3.24),('16273','2014-03-13','10:10:00',3.3),('16273','2014-03-13','10:15:00',3.33),('16273','2014-03-13','10:20:00',3.34),('16273','2014-03-13','10:25:00',3.33),('16273','2014-03-13','10:30:00',3.36),('16273','2014-03-13','10:35:00',3.39),('16273','2014-03-13','10:40:00',3.4),('16273','2014-03-13','10:45:00',3.42),('16273','2014-03-13','10:50:00',3.49),('16273','2014-03-13','10:55:00',3.51),('16273','2014-03-13','11:00:00',3.52),('16273','2014-03-13','11:05:00',3.53),('16273','2014-03-13','11:10:00',3.53),('16273','2014-03-13','11:15:00',3.56),('16273','2014-03-13','11:20:00',3.56),('16273','2014-03-13','11:25:00',3.56),('16273','2014-03-13','11:30:00',3.56),('16273','2014-03-13','11:35:00',3.57),('16273','2014-03-13','11:40:00',3.56),('16273','2014-03-13','11:45:00',3.54),('16273','2014-03-13','11:50:00',3.53),('16273','2014-03-13','11:55:00',3.5),('16273','2014-03-13','12:00:00',3.49),('16273','2014-03-13','12:05:00',3.44),('16273','2014-03-13','12:10:00',3.46),('16273','2014-03-13','12:15:00',3.44),('16273','2014-03-13','12:20:00',3.38),('16273','2014-03-13','12:25:00',3.35),('16273','2014-03-13','12:30:00',3.35),('16273','2014-03-13','12:35:00',3.32),('16273','2014-03-13','12:40:00',3.34),('16273','2014-03-13','12:45:00',3.32),('16273','2014-03-13','12:50:00',3.3),('16273','2014-03-13','12:55:00',3.28),('16273','2014-03-13','13:00:00',3.28),('16273','2014-03-13','13:05:00',3.25),('16273','2014-03-13','13:10:00',3.2),('16273','2014-03-13','13:15:00',3.18),('16273','2014-03-13','13:20:00',3.12),('16273','2014-03-13','13:25:00',3.12),('16273','2014-03-13','13:30:00',3.07),('16273','2014-03-13','13:35:00',3.03),('16273','2014-03-13','13:40:00',2.99),('16273','2014-03-13','13:45:00',2.95),('16273','2014-03-13','13:50:00',2.86),('16273','2014-03-13','13:55:00',2.83),('16273','2014-03-13','14:00:00',2.78),('16273','2014-03-13','14:05:00',2.73),('16273','2014-03-13','14:10:00',2.66),('16273','2014-03-13','14:15:00',2.61),('16273','2014-03-13','14:20:00',2.56),('16273','2014-03-13','14:25:00',2.51),('16273','2014-03-13','14:30:00',2.44),('16273','2014-03-13','14:35:00',2.38),('16273','2014-03-13','14:40:00',2.3),('16273','2014-03-13','14:45:00',2.23),('16273','2014-03-13','14:50:00',2.17),('16273','2014-03-13','14:55:00',2.09),('16273','2014-03-13','15:00:00',2.01),('16273','2014-03-13','15:05:00',1.93),('16273','2014-03-13','15:10:00',1.87),('16273','2014-03-13','15:15:00',1.8),('16273','2014-03-13','15:20:00',1.73),('16273','2014-03-13','15:25:00',1.66),('16273','2014-03-13','15:30:00',1.59),('16273','2014-03-13','15:35:00',1.51),('16273','2014-03-13','15:40:00',1.44),('16273','2014-03-13','15:45:00',1.37),('16273','2014-03-13','15:50:00',1.3),('16273','2014-03-13','15:55:00',1.23),('16273','2014-03-13','16:00:00',1.17),('16273','2014-03-13','16:05:00',1.09),('16273','2014-03-13','16:10:00',1.04),('16273','2014-03-12','07:35:00',1.12),('16273','2014-03-12','07:40:00',1.22),('16273','2014-03-12','07:45:00',1.16),('16273','2014-03-12','07:50:00',1.48),('16273','2014-03-12','07:55:00',1.59),('16273','2014-03-12','08:00:00',1.7),('16273','2014-03-12','08:05:00',1.79),('16273','2014-03-12','08:10:00',1.88),('16273','2014-03-12','08:15:00',1.97),('16273','2014-03-12','08:20:00',2.05),('16273','2014-03-12','08:25:00',2.14),('16273','2014-03-12','08:30:00',2.22),('16273','2014-03-12','08:35:00',2.3),('16273','2014-03-12','08:40:00',2.36),('16273','2014-03-12','08:45:00',2.43),('16273','2014-03-12','08:50:00',2.48),('16273','2014-03-12','08:55:00',2.56),('16273','2014-03-12','09:00:00',2.64),('16273','2014-03-12','09:05:00',2.69),('16273','2014-03-12','09:10:00',2.75),('16273','2014-03-12','09:15:00',2.79),('16273','2014-03-12','09:20:00',2.85),('16273','2014-03-12','09:25:00',2.89),('16273','2014-03-12','09:30:00',2.93),('16273','2014-03-12','09:35:00',2.98),('16273','2014-03-12','09:40:00',3.02),('16273','2014-03-12','09:45:00',3.06),('16273','2014-03-12','09:50:00',3.13),('16273','2014-03-12','09:55:00',3.17),('16273','2014-03-12','10:00:00',3.22),('16273','2014-03-12','10:05:00',3.25),('16273','2014-03-12','10:10:00',3.27),('16273','2014-03-12','10:15:00',3.3),('16273','2014-03-12','10:20:00',3.35),('16273','2014-03-12','10:25:00',3.38),('16273','2014-03-12','10:30:00',3.41),('16273','2014-03-12','10:35:00',3.4),('16273','2014-03-12','10:40:00',3.43),('16273','2014-03-12','10:45:00',3.44),('16273','2014-03-12','10:50:00',3.47),('16273','2014-03-12','10:55:00',3.48),('16273','2014-03-12','11:00:00',3.49),('16273','2014-03-12','11:05:00',3.51),('16273','2014-03-12','11:10:00',3.53),('16273','2014-03-12','11:15:00',3.56),('16273','2014-03-12','11:20:00',3.58),('16273','2014-03-12','11:25:00',3.56),('16273','2014-03-12','11:30:00',3.54),('16273','2014-03-12','11:35:00',3.55),('16273','2014-03-12','11:40:00',3.57),('16273','2014-03-12','11:45:00',3.55),('16273','2014-03-12','11:50:00',3.5),('16273','2014-03-12','11:55:00',3.53),('16273','2014-03-12','12:00:00',3.52),('16273','2014-03-12','12:05:00',3.54),('16273','2014-03-12','12:10:00',3.51),('16273','2014-03-12','12:15:00',3.48),('16273','2014-03-12','12:20:00',3.5),('16273','2014-03-12','12:25:00',3.48),('16273','2014-03-12','12:30:00',3.47),('16273','2014-03-12','12:35:00',3.45),('16273','2014-03-12','12:40:00',3.4),('16273','2014-03-12','12:45:00',3.38),('16273','2014-03-12','12:50:00',3.34),('16273','2014-03-12','12:55:00',3.33),('16273','2014-03-12','13:00:00',3.3),('16273','2014-03-12','13:05:00',3.26),('16273','2014-03-12','13:10:00',3.26),('16273','2014-03-12','13:15:00',3.21),('16273','2014-03-12','13:20:00',3.18),('16273','2014-03-12','13:25:00',3.12),('16273','2014-03-12','13:30:00',3.05),('16273','2014-03-12','13:35:00',2.98),('16273','2014-03-12','13:40:00',3),('16273','2014-03-12','13:45:00',2.95),('16273','2014-03-12','13:50:00',2.87),('16273','2014-03-12','13:55:00',2.81),('16273','2014-03-12','14:00:00',2.79),('16273','2014-03-12','14:05:00',2.76),('16273','2014-03-12','14:10:00',2.71),('16273','2014-03-12','14:15:00',2.62),('16273','2014-03-12','14:20:00',2.53),('16273','2014-03-12','14:25:00',2.46),('16273','2014-03-12','14:30:00',2.42),('16273','2014-03-12','14:35:00',2.37),('16273','2014-03-12','14:40:00',2.32),('16273','2014-03-12','14:45:00',2.25),('16273','2014-03-12','14:50:00',2.18),('16273','2014-03-12','14:55:00',2.13),('16273','2014-03-12','15:00:00',2.06),('16273','2014-03-12','15:05:00',1.96),('16273','2014-03-12','15:10:00',1.87),('16273','2014-03-12','15:15:00',1.81),('16273','2014-03-12','15:20:00',1.75),('16273','2014-03-12','15:25:00',1.67),('16273','2014-03-12','15:30:00',1.6),('16273','2014-03-12','15:35:00',1.52),('16273','2014-03-12','15:40:00',1.45),('16273','2014-03-12','15:45:00',1.4),('16273','2014-03-12','15:50:00',1.33),('16273','2014-03-12','15:55:00',1.25),('16273','2014-03-12','16:00:00',1.18),('16273','2014-03-12','16:05:00',1.1),('16273','2014-03-12','16:10:00',1.03),('16273','2014-03-11','11:20:00',1.04),('16273','2014-03-11','12:00:00',1.09),('16273','2014-03-11','12:05:00',1.1),('16273','2014-03-11','12:10:00',1.15),('16273','2014-03-11','12:15:00',1.33),('16273','2014-03-11','12:20:00',1.7),('16273','2014-03-11','12:25:00',1.65),('16273','2014-03-11','12:30:00',1.54),('16273','2014-03-11','12:35:00',1.44),('16273','2014-03-11','12:40:00',1.47),('16273','2014-03-11','12:45:00',1.68),('16273','2014-03-11','12:50:00',1.61),('16273','2014-03-11','12:55:00',1.58),('16273','2014-03-11','13:00:00',1.54),('16273','2014-03-11','13:05:00',1.42),('16273','2014-03-11','13:10:00',1.49),('16273','2014-03-11','13:15:00',1.66),('16273','2014-03-11','13:20:00',1.62),('16273','2014-03-11','13:25:00',1.38),('16273','2014-03-11','13:30:00',1.18),('16273','2014-03-11','13:35:00',1.16),('16273','2014-03-11','13:40:00',1.1),('16273','2014-03-11','13:45:00',1.16),('16273','2014-03-11','13:50:00',1.36),('16273','2014-03-11','13:55:00',1.77),('16273','2014-03-11','14:00:00',1.93),('16273','2014-03-11','14:05:00',1.71),('16273','2014-03-11','14:10:00',2.38),('16273','2014-03-11','14:15:00',2.68),('16273','2014-03-11','14:20:00',2.28),('16273','2014-03-11','14:25:00',1.83),('16273','2014-03-11','14:30:00',1.69),('16273','2014-03-11','14:35:00',1.66),('16273','2014-03-11','14:40:00',1.58),('16273','2014-03-11','14:45:00',1.47),('16273','2014-03-11','14:50:00',1.39),('16273','2014-03-11','14:55:00',1.38),('16273','2014-03-11','15:00:00',1.54),('16273','2014-03-11','15:05:00',1.61),('16273','2014-03-11','15:10:00',1.51),('16273','2014-03-11','15:15:00',1.41),('16273','2014-03-11','15:20:00',1.23),('16273','2014-03-11','15:25:00',1.1),('16273','2014-03-10','08:55:00',1.04),('16273','2014-03-10','09:00:00',1.08),('16273','2014-03-10','09:05:00',1.09),('16273','2014-03-10','09:10:00',1.09),('16273','2014-03-10','09:15:00',1.13),('16273','2014-03-10','09:20:00',1.08),('16273','2014-03-10','09:25:00',1.06),('16273','2014-03-10','09:30:00',1.11),('16273','2014-03-10','09:35:00',1.16),('16273','2014-03-10','09:40:00',1.31),('16273','2014-03-10','09:45:00',1.38),('16273','2014-03-10','09:50:00',1.32),('16273','2014-03-10','09:55:00',1.19),('16273','2014-03-10','10:00:00',1.03),('16273','2014-03-10','10:10:00',1.13),('16273','2014-03-10','10:15:00',1.31),('16273','2014-03-10','10:20:00',1.32),('16273','2014-03-10','10:25:00',1.29),('16273','2014-03-10','13:10:00',1.02),('16273','2014-03-10','13:15:00',1.05),('16273','2014-03-10','14:45:00',1),('16273','2014-03-10','14:50:00',1.11),('16273','2014-03-10','14:55:00',1.59),('16273','2014-03-10','15:00:00',1.5),('16273','2014-03-10','15:05:00',1.8),('16273','2014-03-10','15:10:00',2.27),('16273','2014-03-10','15:15:00',2.12),('16273','2014-03-10','15:20:00',2.06),('16273','2014-03-10','15:25:00',1.95),('16273','2014-03-10','15:30:00',1.85),('16273','2014-03-10','15:35:00',1.79),('16273','2014-03-10','15:40:00',1.65),('16273','2014-03-10','15:45:00',1.18),('16273','2014-03-10','15:50:00',1.12),('16273','2014-03-10','15:55:00',1.13),('16273','2014-03-09','07:40:00',1.08),('16273','2014-03-09','07:45:00',1.2),('16273','2014-03-09','07:50:00',1.15),('16273','2014-03-09','07:55:00',1.42),('16273','2014-03-09','08:00:00',1.59),('16273','2014-03-09','08:05:00',1.68),('16273','2014-03-09','08:10:00',1.78),('16273','2014-03-09','08:15:00',1.88),('16273','2014-03-09','08:20:00',1.96),('16273','2014-03-09','08:25:00',2.06),('16273','2014-03-09','08:30:00',2.05),('16273','2014-03-09','08:35:00',1.03),('16273','2014-03-09','08:40:00',2.34),('16273','2014-03-09','08:45:00',2.38),('16273','2014-03-09','08:50:00',2.38),('16273','2014-03-09','08:55:00',2.51),('16273','2014-03-09','09:00:00',2.58),('16273','2014-03-09','09:05:00',2.64),('16273','2014-03-09','09:10:00',2.64),('16273','2014-03-09','09:15:00',2.75),('16273','2014-03-09','09:20:00',2.84),('16273','2014-03-09','09:25:00',2.91),('16273','2014-03-09','09:30:00',2.97),('16273','2014-03-09','09:35:00',3.07),('16273','2014-03-09','09:40:00',3.13),('16273','2014-03-09','09:45:00',3.19),('16273','2014-03-09','09:50:00',3.23),('16273','2014-03-09','09:55:00',3.24),('16273','2014-03-09','10:00:00',3.25),('16273','2014-03-09','10:05:00',3.23),('16273','2014-03-09','10:10:00',3.39),('16273','2014-03-09','10:15:00',3.48),('16273','2014-03-09','10:20:00',3.48),('16273','2014-03-09','10:25:00',3.51),('16273','2014-03-09','10:30:00',3.63),('16273','2014-03-09','10:35:00',3.76),('16273','2014-03-09','10:40:00',3.75),('16273','2014-03-09','10:45:00',3.75),('16273','2014-03-09','10:50:00',3.71),('16273','2014-03-09','10:55:00',3.73),('16273','2014-03-09','11:00:00',3.81),('16273','2014-03-09','11:05:00',3.29),('16273','2014-03-09','11:10:00',2.13),('16273','2014-03-09','11:15:00',2.82),('16273','2014-03-09','11:20:00',3.02),('16273','2014-03-09','11:25:00',3.74),('16273','2014-03-09','11:30:00',2.52),('16273','2014-03-09','11:40:00',1.12),('16273','2014-03-09','11:45:00',2.18),('16273','2014-03-09','11:50:00',2.95),('16273','2014-03-09','11:55:00',4.08),('16273','2014-03-09','12:00:00',4.3),('16273','2014-03-09','12:05:00',2.72),('16273','2014-03-09','12:10:00',1.44),('16273','2014-03-09','12:15:00',3.65),('16273','2014-03-09','12:20:00',4.04),('16273','2014-03-09','12:25:00',3.89),('16273','2014-03-09','12:30:00',3.37),('16273','2014-03-09','12:35:00',3.54),('16273','2014-03-09','12:40:00',3.86),('16273','2014-03-09','12:45:00',3.84),('16273','2014-03-09','12:50:00',3.69),('16273','2014-03-09','12:55:00',3.58),('16273','2014-03-09','13:00:00',3.59),('16273','2014-03-09','13:05:00',3.52),('16273','2014-03-09','13:10:00',3.57),('16273','2014-03-09','13:15:00',3.58),('16273','2014-03-09','13:20:00',3.53),('16273','2014-03-09','13:25:00',3.56),('16273','2014-03-09','13:30:00',3.52),('16273','2014-03-09','13:35:00',3.43),('16273','2014-03-09','13:40:00',3.37),('16273','2014-03-09','13:45:00',3.27),('16273','2014-03-09','13:50:00',3.18),('16273','2014-03-09','13:55:00',2.18),('16273','2014-03-09','14:05:00',1.31),('16273','2014-03-09','14:10:00',1.48),('16273','2014-03-09','14:15:00',2.82),('16273','2014-03-09','14:20:00',2.38),('16273','2014-03-09','14:25:00',2.59),('16273','2014-03-09','14:30:00',2.57),('16273','2014-03-09','14:35:00',2.55),('16273','2014-03-09','14:40:00',2.55),('16273','2014-03-09','14:45:00',2.49),('16273','2014-03-09','14:50:00',1.94),('16273','2014-03-09','14:55:00',2.17),('16273','2014-03-09','15:00:00',1.46),('16273','2014-03-09','15:20:00',1.15),('16273','2014-03-09','15:35:00',1.25),('16273','2014-03-09','15:40:00',1.4),('16273','2014-03-09','15:50:00',1.09),('16273','2014-03-09','15:55:00',1.43),('16273','2014-03-09','16:05:00',1.12),('16273','2014-03-09','16:10:00',1.2),('16273','2014-03-09','16:15:00',1.14),('16273','2014-03-09','16:20:00',1.08),('16273','2014-03-08','07:35:00',1.03),('16273','2014-03-08','07:40:00',1.14),('16273','2014-03-08','07:45:00',1.25),('16273','2014-03-08','07:50:00',1.17),('16273','2014-03-08','07:55:00',1.49),('16273','2014-03-08','08:00:00',1.61),('16273','2014-03-08','08:05:00',1.71),('16273','2014-03-08','08:10:00',1.82),('16273','2014-03-08','08:15:00',1.91),('16273','2014-03-08','08:20:00',1.98),('16273','2014-03-08','08:25:00',2.05),('16273','2014-03-08','08:30:00',2.13),('16273','2014-03-08','08:35:00',2.21),('16273','2014-03-08','08:40:00',2.27),('16273','2014-03-08','08:45:00',2.37),('16273','2014-03-08','08:50:00',2.46),('16273','2014-03-08','08:55:00',2.53),('16273','2014-03-08','09:00:00',2.58),('16273','2014-03-08','09:05:00',2.65),('16273','2014-03-08','09:10:00',2.7),('16273','2014-03-08','09:15:00',2.76),('16273','2014-03-08','09:20:00',2.82),('16273','2014-03-08','09:25:00',2.88),('16273','2014-03-08','09:30:00',2.93),('16273','2014-03-08','09:35:00',2.96),('16273','2014-03-08','09:40:00',3),('16273','2014-03-08','09:45:00',3.04),('16273','2014-03-08','09:50:00',3.1),('16273','2014-03-08','09:55:00',3.1),('16273','2014-03-08','10:00:00',3.22),('16273','2014-03-08','10:05:00',3.26),('16273','2014-03-08','10:10:00',3.3),('16273','2014-03-08','10:15:00',3.31),('16273','2014-03-08','10:20:00',3.35),('16273','2014-03-08','10:25:00',3.38),('16273','2014-03-08','10:30:00',3.12),('16273','2014-03-08','10:35:00',3.43),('16273','2014-03-08','10:40:00',3.65),('16273','2014-03-08','10:45:00',3.56),('16273','2014-03-08','10:50:00',3.59),('16273','2014-03-08','10:55:00',3.53),('16273','2014-03-08','11:00:00',3.49),('16273','2014-03-08','11:05:00',3.54),('16273','2014-03-08','11:10:00',3.57),('16273','2014-03-08','11:15:00',3.65),('16273','2014-03-08','11:20:00',3.71),('16273','2014-03-08','11:25:00',3.03),('16273','2014-03-08','11:30:00',2.65),('16273','2014-03-08','11:35:00',1.39),('16273','2014-03-08','11:40:00',2.57),('16273','2014-03-08','11:45:00',3.53),('16273','2014-03-08','11:50:00',1.82),('16273','2014-03-08','11:55:00',2.25),('16273','2014-03-08','12:00:00',4.26),('16273','2014-03-08','12:05:00',4.29),('16273','2014-03-08','12:10:00',3.62),('16273','2014-03-08','12:15:00',1.57),('16273','2014-03-08','12:20:00',1.59),('16273','2014-03-08','12:25:00',1.34),('16273','2014-03-08','12:30:00',1.27),('16273','2014-03-08','12:35:00',1.29),('16273','2014-03-08','12:40:00',1.37),('16273','2014-03-08','12:45:00',1.51),('16273','2014-03-08','12:50:00',1.49),('16273','2014-03-08','12:55:00',1.36),('16273','2014-03-08','13:00:00',1.32),('16273','2014-03-08','13:05:00',1.64),('16273','2014-03-08','13:10:00',1.57),('16273','2014-03-08','13:15:00',1.59),('16273','2014-03-08','13:20:00',1.24),('16273','2014-03-08','13:25:00',1.03),('16273','2014-03-08','13:40:00',1.38),('16273','2014-03-08','13:45:00',1.37),('16273','2014-03-08','13:50:00',1.45),('16273','2014-03-08','13:55:00',1.6),('16273','2014-03-08','14:00:00',1.34),('16273','2014-03-08','14:05:00',1.19),('16273','2014-03-08','14:10:00',1.12),('16273','2014-03-08','14:15:00',1.03),('16273','2014-03-08','15:25:00',1.24),('16273','2014-03-08','15:30:00',1.06),('16273','2014-04-30','07:25:00',1),('16273','2014-04-30','07:30:00',1.07),('16273','2014-04-30','07:35:00',1.25),('16273','2014-04-30','07:40:00',1.37),('16273','2014-04-30','07:45:00',1.4),('16273','2014-04-30','07:50:00',1.54),('16273','2014-04-30','07:55:00',1.62),('16273','2014-04-30','08:00:00',1.68),('16273','2014-04-30','08:05:00',1.77),('16273','2014-04-30','08:10:00',1.84),('16273','2014-04-30','08:15:00',1.92),('16273','2014-04-30','08:20:00',2),('16273','2014-04-30','08:25:00',2.08),('16273','2014-04-30','08:30:00',2.13),('16273','2014-04-30','08:35:00',2.22),('16273','2014-04-30','08:40:00',2.32),('16273','2014-04-30','08:45:00',2.33),('16273','2014-04-30','08:50:00',2.42),('16273','2014-04-30','08:55:00',2.42),('16273','2014-04-30','09:00:00',2.47),('16273','2014-04-30','09:05:00',2.67),('16273','2014-04-30','09:10:00',2.74),('16273','2014-04-30','09:15:00',2.84),('16273','2014-04-30','09:20:00',2.84),('16273','2014-04-30','09:25:00',1.92),('16273','2014-04-30','09:30:00',3.08),('16273','2014-04-30','09:35:00',3.2),('16273','2014-04-30','09:40:00',3.28),('16273','2014-04-30','09:45:00',3.32),('16273','2014-04-30','09:50:00',2.5),('16273','2014-04-30','09:55:00',2.17),('16273','2014-04-30','10:00:00',3.01),('16273','2014-04-30','10:05:00',2.97),('16273','2014-04-30','10:10:00',2.67),('16273','2014-04-30','10:15:00',1.93),('16273','2014-04-30','10:20:00',1.4),('16273','2014-04-30','10:25:00',2.12),('16273','2014-04-30','10:30:00',3.09),('16273','2014-04-30','10:35:00',3.41),('16273','2014-04-30','10:40:00',3.32),('16273','2014-04-30','10:45:00',4.32),('16273','2014-04-30','10:50:00',2.13),('16273','2014-04-30','10:55:00',2.9),('16273','2014-04-30','11:00:00',2.37),('16273','2014-04-30','11:05:00',2.21),('16273','2014-04-30','11:10:00',2.11),('16273','2014-04-30','11:15:00',2.7),('16273','2014-04-30','11:20:00',1.56),('16273','2014-04-30','11:25:00',1.46),('16273','2014-04-30','11:30:00',1.29),('16273','2014-04-30','11:35:00',1.87),('16273','2014-04-30','11:40:00',3.87),('16273','2014-04-30','11:45:00',2.74),('16273','2014-04-30','11:50:00',2.76),('16273','2014-04-30','11:55:00',1.56),('16273','2014-04-30','12:00:00',1.27),('16273','2014-04-30','12:05:00',1.2),('16273','2014-04-30','12:10:00',2.19),('16273','2014-04-30','12:15:00',2.24),('16273','2014-04-30','12:20:00',2.68),('16273','2014-04-30','12:25:00',4.69),('16273','2014-04-30','12:30:00',4.29),('16273','2014-04-30','12:35:00',2.86),('16273','2014-04-30','12:40:00',2.63),('16273','2014-04-30','12:45:00',3.5),('16273','2014-04-30','12:50:00',2.49),('16273','2014-04-30','12:55:00',2.36),('16273','2014-04-30','13:00:00',3.05),('16273','2014-04-30','13:05:00',4.19),('16273','2014-04-30','13:10:00',2.19),('16273','2014-04-30','13:15:00',2.66),('16273','2014-04-30','13:20:00',4.67),('16273','2014-04-30','13:25:00',3.55),('16273','2014-04-30','13:30:00',2.35),('16273','2014-04-30','13:35:00',4),('16273','2014-04-30','13:40:00',2.61),('16273','2014-04-30','13:45:00',1.57),('16273','2014-04-30','13:50:00',1.65),('16273','2014-04-30','13:55:00',2.05),('16273','2014-04-30','14:00:00',2.52),('16273','2014-04-30','14:05:00',1.44),('16273','2014-04-30','14:10:00',1.41),('16273','2014-04-30','14:15:00',1.67),('16273','2014-04-30','14:20:00',1.58),('16273','2014-04-30','14:25:00',1.7),('16273','2014-04-30','14:30:00',2.37),('16273','2014-04-30','14:35:00',1.88),('16273','2014-04-30','14:40:00',1.37),('16273','2014-04-30','14:45:00',1.69),('16273','2014-04-30','14:50:00',1.61),('16273','2014-04-30','14:55:00',1.25),('16273','2014-04-30','15:00:00',1.62),('16273','2014-04-30','15:05:00',2.03),('16273','2014-04-30','15:10:00',1.34),('16273','2014-04-30','15:15:00',1.07),('16273','2014-04-30','15:20:00',1.3),('16273','2014-04-30','15:25:00',1.99),('16273','2014-04-30','15:30:00',2.47),('16273','2014-04-30','15:35:00',2),('16273','2014-04-30','15:40:00',3.23),('16273','2014-04-30','15:45:00',2.73),('16273','2014-04-30','15:50:00',2.7),('16273','2014-04-30','15:55:00',1.78),('16273','2014-04-30','16:00:00',1.03),('16273','2014-04-30','16:05:00',2.55),('16273','2014-04-30','16:10:00',1.83),('16273','2014-04-30','16:15:00',2.15),('16273','2014-04-30','16:20:00',1.67),('16273','2014-04-30','16:25:00',1.92),('16273','2014-04-30','16:30:00',1.72),('16273','2014-04-30','16:35:00',1.53),('16273','2014-04-30','16:40:00',1.26),('16273','2014-04-30','16:45:00',2),('16273','2014-04-30','16:50:00',1.48),('16273','2014-04-30','17:00:00',1.03),('16273','2014-04-30','17:15:00',1.36),('16273','2014-04-30','17:30:00',1.03),('16273','2014-04-30','17:35:00',1.2),('16273','2014-03-07','09:45:00',1.81),('16273','2014-03-07','09:50:00',3.17),('16273','2014-03-07','09:55:00',1.21),('16273','2014-03-07','10:05:00',2.89),('16273','2014-03-07','10:10:00',3.2),('16273','2014-03-07','10:15:00',3.79),('16273','2014-03-07','10:20:00',3.59),('16273','2014-03-07','10:25:00',3.36),('16273','2014-03-07','10:30:00',3.8),('16273','2014-03-07','10:35:00',3.81),('16273','2014-03-07','10:40:00',3.86),('16273','2014-03-07','10:45:00',2.03),('16273','2014-03-07','10:50:00',3.39),('16273','2014-03-07','10:55:00',2.02),('16273','2014-03-07','11:00:00',2.32),('16273','2014-03-07','11:10:00',1.06),('16273','2014-03-07','11:15:00',1.07),('16273','2014-03-07','12:00:00',1.26),('16273','2014-03-07','12:05:00',2.8),('16273','2014-03-07','12:10:00',3.63),('16273','2014-03-07','12:15:00',3.71),('16273','2014-03-07','12:20:00',3.68),('16273','2014-03-07','12:25:00',3.73),('16273','2014-03-07','12:30:00',3.58),('16273','2014-03-07','12:35:00',3.71),('16273','2014-03-07','12:40:00',3.95),('16273','2014-03-07','12:45:00',3.69),('16273','2014-03-07','12:50:00',3.6),('16273','2014-03-07','12:55:00',1.16),('16273','2014-03-07','13:05:00',1.07),('16273','2014-03-07','13:10:00',1.43),('16273','2014-03-07','13:15:00',2.6),('16273','2014-03-07','13:20:00',2.54),('16273','2014-03-07','13:25:00',2.29),('16273','2014-03-07','13:30:00',2.23),('16273','2014-03-07','13:35:00',1.98),('16273','2014-03-07','13:40:00',1.85),('16273','2014-03-07','13:45:00',1.81),('16273','2014-03-07','13:50:00',1.81),('16273','2014-03-07','13:55:00',1.53),('16273','2014-03-07','14:00:00',1.29),('16273','2014-03-07','14:05:00',1.19),('16273','2014-03-07','14:10:00',1.12),('16273','2014-03-07','14:15:00',1.09),('16273','2014-03-07','14:20:00',1.1),('16273','2014-03-07','14:25:00',1.17),('16273','2014-03-07','14:30:00',1.28),('16273','2014-03-07','14:35:00',1.51),('16273','2014-03-07','14:40:00',1.77),('16273','2014-03-07','14:45:00',1.96),('16273','2014-03-07','14:50:00',2.51),('16273','2014-03-07','14:55:00',2.49),('16273','2014-03-07','15:00:00',2.34),('16273','2014-03-07','15:05:00',2.55),('16273','2014-03-07','15:10:00',2.55),('16273','2014-03-07','15:15:00',2.4),('16273','2014-03-07','15:20:00',2.3),('16273','2014-03-07','15:25:00',2.07),('16273','2014-03-07','15:30:00',2.05),('16273','2014-03-07','15:35:00',1.55),('16273','2014-03-06','08:40:00',1.03),('16273','2014-03-06','08:55:00',1.96),('16273','2014-03-06','09:00:00',1.62),('16273','2014-03-06','09:05:00',1.87),('16273','2014-03-06','09:10:00',2.42),('16273','2014-03-06','09:15:00',2.79),('16273','2014-03-06','09:20:00',3.17),('16273','2014-03-06','09:25:00',3.21),('16273','2014-03-06','09:30:00',3.05),('16273','2014-03-06','09:35:00',2.67),('16273','2014-03-06','09:40:00',1.87),('16273','2014-03-06','09:45:00',1.78),('16273','2014-03-06','09:50:00',1.94),('16273','2014-03-06','09:55:00',2.24),('16273','2014-03-06','10:00:00',2.51),('16273','2014-03-06','10:05:00',2.6),('16273','2014-03-06','10:10:00',2.74),('16273','2014-03-06','10:15:00',2.66),('16273','2014-03-06','10:20:00',3.19),('16273','2014-03-06','10:25:00',3.05),('16273','2014-03-06','10:30:00',2.04),('16273','2014-03-06','10:35:00',2.76),('16273','2014-03-06','10:40:00',1.56),('16273','2014-03-06','10:45:00',3.23),('16273','2014-03-06','10:50:00',3.72),('16273','2014-03-06','10:55:00',2.97),('16273','2014-03-06','11:00:00',3.33),('16273','2014-03-06','11:05:00',3.6),('16273','2014-03-06','11:10:00',2.61),('16273','2014-03-06','11:15:00',3.55),('16273','2014-03-06','11:20:00',3.54),('16273','2014-03-06','11:25:00',2.17),('16273','2014-03-06','11:30:00',4.07),('16273','2014-03-06','11:35:00',4.05),('16273','2014-03-06','11:40:00',4.04),('16273','2014-03-06','11:45:00',3.01),('16273','2014-03-06','11:50:00',3.06),('16273','2014-03-06','11:55:00',2.9),('16273','2014-03-06','12:00:00',2.5),('16273','2014-03-06','12:05:00',2.17),('16273','2014-03-06','12:10:00',1.47),('16273','2014-03-06','12:15:00',3.44),('16273','2014-03-06','12:20:00',1.79),('16273','2014-03-06','12:25:00',1.06),('16273','2014-03-06','12:30:00',1.13),('16273','2014-03-06','12:35:00',1.35),('16273','2014-03-06','12:40:00',1.29),('16273','2014-03-06','12:45:00',1.34),('16273','2014-03-06','12:50:00',2.48),('16273','2014-03-06','12:55:00',2.63),('16273','2014-03-06','13:00:00',2.17),('16273','2014-03-06','13:05:00',1.83),('16273','2014-03-06','13:10:00',1.33),('16273','2014-03-06','13:15:00',1.36),('16273','2014-03-06','13:20:00',1.37),('16273','2014-03-06','13:25:00',1.24),('16273','2014-03-06','13:30:00',1.53),('16273','2014-03-06','13:35:00',1.15),('16273','2014-03-06','13:50:00',1.05),('16273','2014-03-06','13:55:00',1.06),('16273','2014-03-06','14:00:00',1.14),('16273','2014-03-06','14:05:00',1.11),('16273','2014-03-06','14:10:00',1.07),('16273','2014-03-06','14:15:00',1.13),('16273','2014-03-06','14:20:00',1.41),('16273','2014-03-06','14:25:00',1.48),('16273','2014-03-06','14:30:00',1.32),('16273','2014-03-06','14:35:00',1.15),('16273','2014-03-06','14:50:00',1.26),('16273','2014-03-06','15:00:00',1.04),('16273','2014-03-06','15:05:00',1.2),('16273','2014-03-06','15:10:00',1.21),('16273','2014-03-06','15:15:00',1.22),('16273','2014-03-06','15:20:00',2.34),('16273','2014-03-06','15:25:00',1.78),('16273','2014-03-06','15:30:00',1.03),('16273','2014-03-05','07:45:00',1.03),('16273','2014-03-05','07:50:00',1.57),('16273','2014-03-05','07:55:00',1.56),('16273','2014-03-05','08:00:00',1.63),('16273','2014-03-05','08:05:00',1.78),('16273','2014-03-05','08:10:00',1.14),('16273','2014-03-05','08:15:00',1.15),('16273','2014-03-05','08:20:00',1),('16273','2014-03-05','08:50:00',1.08),('16273','2014-03-05','08:55:00',1.35),('16273','2014-03-05','09:00:00',3.22),('16273','2014-03-05','09:05:00',3.05),('16273','2014-03-05','09:10:00',2.89),('16273','2014-03-05','09:15:00',2.88),('16273','2014-03-05','09:20:00',2.9),('16273','2014-03-05','09:25:00',2.93),('16273','2014-03-05','09:30:00',2.94),('16273','2014-03-05','09:35:00',3.01),('16273','2014-03-05','09:40:00',3.06),('16273','2014-03-05','09:45:00',3.1),('16273','2014-03-05','09:50:00',3.11),('16273','2014-03-05','09:55:00',3.15),('16273','2014-03-05','10:00:00',3.21),('16273','2014-03-05','10:05:00',3.25),('16273','2014-03-05','10:10:00',3.25),('16273','2014-03-05','10:15:00',3.29),('16273','2014-03-05','10:20:00',3.31),('16273','2014-03-05','10:25:00',3.34),('16273','2014-03-05','10:30:00',3.38),('16273','2014-03-05','10:35:00',3.43),('16273','2014-03-05','10:40:00',3.43),('16273','2014-03-05','10:45:00',3.44),('16273','2014-03-05','10:50:00',3.48),('16273','2014-03-05','10:55:00',3.49),('16273','2014-03-05','11:00:00',3.53),('16273','2014-03-05','11:05:00',3.56),('16273','2014-03-05','11:10:00',3.58),('16273','2014-03-05','11:15:00',3.61),('16273','2014-03-05','11:20:00',3.65),('16273','2014-03-05','11:25:00',3.69),('16273','2014-03-05','11:30:00',3.7),('16273','2014-03-05','11:35:00',2.12),('16273','2014-03-05','11:40:00',1.32),('16273','2014-03-05','11:45:00',1.86),('16273','2014-03-05','11:55:00',1.37),('16273','2014-03-05','12:00:00',3.5),('16273','2014-03-05','12:05:00',2.95),('16273','2014-03-05','12:10:00',2.66),('16273','2014-03-05','12:15:00',3.28),('16273','2014-03-05','12:20:00',2.76),('16273','2014-03-05','12:25:00',3.19),('16273','2014-03-05','12:30:00',2.28),('16273','2014-03-05','12:35:00',2.07),('16273','2014-03-05','12:40:00',2.4),('16273','2014-03-05','12:50:00',2.39),('16273','2014-03-05','12:55:00',2.46),('16273','2014-03-05','13:00:00',1.56),('16273','2014-03-05','13:05:00',2.83),('16273','2014-03-05','13:10:00',1.89),('16273','2014-03-05','13:15:00',2.44),('16273','2014-03-05','13:20:00',2.87),('16273','2014-03-05','13:25:00',1.38),('16273','2014-03-05','13:30:00',2.37),('16273','2014-03-05','13:35:00',2.97),('16273','2014-03-05','13:40:00',2.01),('16273','2014-03-05','13:45:00',3.48),('16273','2014-03-05','13:50:00',3.37),('16273','2014-03-05','13:55:00',2.58),('16273','2014-03-05','14:00:00',1.28),('16273','2014-03-05','14:05:00',1.05),('16273','2014-03-05','14:10:00',1.07),('16273','2014-03-05','14:15:00',1.71),('16273','2014-03-05','14:20:00',1.86),('16273','2014-03-05','14:25:00',1.29),('16273','2014-03-05','14:30:00',1.34),('16273','2014-03-05','14:35:00',1.64),('16273','2014-03-05','14:40:00',1.28),('16273','2014-03-05','14:50:00',1.1),('16273','2014-03-05','14:55:00',1.78),('16273','2014-03-05','15:00:00',2.1),('16273','2014-03-05','15:05:00',2.57),('16273','2014-03-05','15:10:00',1.32),('16273','2014-03-05','15:50:00',1.05),('16273','2014-03-05','15:55:00',1.56),('16273','2014-03-05','16:00:00',1.51),('16273','2014-03-05','16:05:00',1.65),('16273','2014-03-05','16:10:00',1.54),('16273','2014-03-04','09:05:00',1.33),('16273','2014-03-04','09:10:00',2.45),('16273','2014-03-04','09:15:00',1.31),('16273','2014-03-04','09:50:00',1.69),('16273','2014-03-04','09:55:00',2.88),('16273','2014-03-04','10:00:00',2.18),('16273','2014-03-04','10:05:00',1.14),('16273','2014-03-04','10:15:00',1.01),('16273','2014-03-04','10:25:00',1.11),('16273','2014-03-04','10:30:00',1.97),('16273','2014-03-04','10:35:00',1.34),('16273','2014-03-04','10:40:00',1.27),('16273','2014-03-04','10:45:00',2.04),('16273','2014-03-04','10:50:00',4.01),('16273','2014-03-04','10:55:00',2.69),('16273','2014-03-04','11:00:00',1.63),('16273','2014-03-04','11:05:00',1.53),('16273','2014-03-04','11:20:00',1.44),('16273','2014-03-04','11:25:00',3.52),('16273','2014-03-04','11:30:00',2.21),('16273','2014-03-04','11:35:00',1.36),('16273','2014-03-04','11:40:00',1.83),('16273','2014-03-04','11:45:00',2.82),('16273','2014-03-04','11:50:00',3.03),('16273','2014-03-04','11:55:00',1.99),('16273','2014-03-04','12:00:00',1.9),('16273','2014-03-04','12:05:00',3.91),('16273','2014-03-04','12:10:00',2.72),('16273','2014-03-04','12:15:00',1.78),('16273','2014-03-04','12:20:00',1.89),('16273','2014-03-04','12:25:00',3.16),('16273','2014-03-04','12:30:00',3.57),('16273','2014-03-04','12:35:00',3.5),('16273','2014-03-04','12:40:00',3.48),('16273','2014-03-04','12:45:00',3.5),('16273','2014-03-04','12:50:00',3.48),('16273','2014-03-04','12:55:00',2.84),('16273','2014-03-04','13:00:00',3.22),('16273','2014-03-04','13:05:00',3.38),('16273','2014-03-04','13:10:00',3.21),('16273','2014-03-04','13:15:00',2.66),('16273','2014-03-04','13:20:00',1.23),('16273','2014-03-04','13:45:00',2.17),('16273','2014-03-04','13:50:00',1.28),('16273','2014-03-04','13:55:00',2.69),('16273','2014-03-04','14:00:00',2.65),('16273','2014-03-04','14:05:00',3.23),('16273','2014-03-04','14:10:00',3.07),('16273','2014-03-04','14:15:00',2.52),('16273','2014-03-04','14:20:00',2.74),('16273','2014-03-04','14:25:00',2.72),('16273','2014-03-04','14:30:00',2.6),('16273','2014-03-04','14:35:00',2.52),('16273','2014-03-04','14:40:00',2.48),('16273','2014-03-04','14:45:00',2.41),('16273','2014-03-04','14:50:00',2.34),('16273','2014-03-04','14:55:00',2.23),('16273','2014-03-04','15:00:00',2.13),('16273','2014-03-04','15:05:00',2.05),('16273','2014-03-04','15:10:00',1.97),('16273','2014-03-04','15:15:00',1.78),('16273','2014-03-04','15:20:00',1.76),('16273','2014-03-04','15:25:00',1.79),('16273','2014-03-04','15:30:00',1.41),('16273','2014-03-04','15:35:00',1.44),('16273','2014-03-04','15:55:00',1.04),('16273','2014-03-04','16:00:00',1.06),('16273','2014-03-04','16:20:00',1.26),('16273','2014-03-04','16:25:00',1.08),('16273','2014-03-03','07:45:00',1.15),('16273','2014-03-03','07:50:00',1.16),('16273','2014-03-03','07:55:00',1.2),('16273','2014-03-03','08:00:00',1.6),('16273','2014-03-03','08:05:00',1.46),('16273','2014-03-03','08:10:00',1.84),('16273','2014-03-03','08:15:00',1.96),('16273','2014-03-03','08:20:00',2.03),('16273','2014-03-03','08:25:00',2.11),('16273','2014-03-03','08:30:00',2.17),('16273','2014-03-03','08:35:00',2.25),('16273','2014-03-03','08:40:00',2.32),('16273','2014-03-03','08:45:00',2.39),('16273','2014-03-03','08:50:00',2.39),('16273','2014-03-03','08:55:00',2.33),('16273','2014-03-03','09:00:00',2.19),('16273','2014-03-03','09:05:00',2.59),('16273','2014-03-03','09:10:00',2.9),('16273','2014-03-03','09:15:00',2.88),('16273','2014-03-03','09:20:00',2.75),('16273','2014-03-03','09:25:00',2.86),('16273','2014-03-03','09:30:00',2.9),('16273','2014-03-03','09:35:00',2.99),('16273','2014-03-03','09:40:00',2.83),('16273','2014-03-03','09:45:00',2.97),('16273','2014-03-03','09:50:00',3.06),('16273','2014-03-03','09:55:00',3.11),('16273','2014-03-03','10:00:00',3.04),('16273','2014-03-03','10:05:00',3.17),('16273','2014-03-03','10:10:00',3.22),('16273','2014-03-03','10:15:00',3.25),('16273','2014-03-03','10:20:00',3.29),('16273','2014-03-03','10:25:00',3.29),('16273','2014-03-03','10:30:00',3.31),('16273','2014-03-03','10:35:00',3.33),('16273','2014-03-03','10:40:00',3.35),('16273','2014-03-03','10:45:00',3.38),('16273','2014-03-03','10:50:00',3.39),('16273','2014-03-03','10:55:00',3.41),('16273','2014-03-03','11:00:00',3.42),('16273','2014-03-03','11:05:00',3.48),('16273','2014-03-03','11:10:00',3.5),('16273','2014-03-03','11:15:00',3.49),('16273','2014-03-03','11:20:00',3.52),('16273','2014-03-03','11:25:00',3.51),('16273','2014-03-03','11:30:00',3.55),('16273','2014-03-03','11:35:00',3.58),('16273','2014-03-03','11:40:00',3.58),('16273','2014-03-03','11:45:00',3.58),('16273','2014-03-03','11:50:00',3.57),('16273','2014-03-03','11:55:00',3.54),('16273','2014-03-03','12:00:00',3.57),('16273','2014-03-03','12:05:00',3.56),('16273','2014-03-03','12:10:00',3.55),('16273','2014-03-03','12:15:00',3.53),('16273','2014-03-03','12:20:00',3.52),('16273','2014-03-03','12:25:00',3.5),('16273','2014-03-03','12:30:00',3.5),('16273','2014-03-03','12:35:00',3.46),('16273','2014-03-03','12:40:00',3.45),('16273','2014-03-03','12:45:00',3.41),('16273','2014-03-03','12:50:00',3.39),('16273','2014-03-03','12:55:00',3.36),('16273','2014-03-03','13:00:00',3.33),('16273','2014-03-03','13:05:00',3.32),('16273','2014-03-03','13:10:00',3.26),('16273','2014-03-03','13:15:00',3.25),('16273','2014-03-03','13:20:00',3.22),('16273','2014-03-03','13:25:00',2.66),('16273','2014-03-03','13:30:00',2.91),('16273','2014-03-03','13:35:00',2.44),('16273','2014-03-03','13:40:00',3.19),('16273','2014-03-03','13:45:00',2.91),('16273','2014-03-03','13:50:00',2.97),('16273','2014-03-03','13:55:00',2.93),('16273','2014-03-03','14:00:00',2.88),('16273','2014-03-03','14:05:00',2.87),('16273','2014-03-03','14:10:00',1.69),('16273','2014-03-03','14:15:00',2.66),('16273','2014-03-03','14:20:00',2.51),('16273','2014-03-03','14:25:00',2.66),('16273','2014-03-03','14:30:00',2.5),('16273','2014-03-03','14:35:00',2.45),('16273','2014-03-03','14:40:00',2.37),('16273','2014-03-03','14:45:00',2.31),('16273','2014-03-03','14:50:00',2.22),('16273','2014-03-03','14:55:00',1.92),('16273','2014-03-03','15:00:00',2.12),('16273','2014-03-03','15:05:00',1.8),('16273','2014-03-03','15:10:00',1.45),('16273','2014-03-03','15:15:00',2.11),('16273','2014-03-03','15:20:00',1.91),('16273','2014-03-03','15:25:00',1.76),('16273','2014-03-03','15:30:00',1.6),('16273','2014-03-03','15:35:00',1.62),('16273','2014-03-03','15:40:00',1.55),('16273','2014-03-03','15:45:00',1.43),('16273','2014-03-03','15:50:00',1.37),('16273','2014-03-03','15:55:00',1.33),('16273','2014-03-03','16:00:00',1.18),('16273','2014-03-03','16:05:00',1.11),('16273','2014-03-03','16:10:00',1.03),('16273','2014-03-02','08:10:00',1.44),('16273','2014-03-02','08:15:00',2.16),('16273','2014-03-02','08:20:00',2.31),('16273','2014-03-02','08:25:00',2.09),('16273','2014-03-02','08:30:00',2.18),('16273','2014-03-02','08:35:00',2.28),('16273','2014-03-02','08:40:00',2.35),('16273','2014-03-02','08:45:00',2.44),('16273','2014-03-02','08:50:00',2.52),('16273','2014-03-02','08:55:00',2.58),('16273','2014-03-02','09:00:00',2.67),('16273','2014-03-02','09:05:00',2.75),('16273','2014-03-02','09:10:00',2.48),('16273','2014-03-02','09:15:00',2.79),('16273','2014-03-02','09:20:00',2.29),('16273','2014-03-02','09:25:00',1.82),('16273','2014-03-02','09:30:00',2.59),('16273','2014-03-02','10:10:00',1.21),('16273','2014-03-02','10:15:00',1.66),('16273','2014-03-02','10:20:00',3.12),('16273','2014-03-02','10:25:00',2.8),('16273','2014-03-02','10:30:00',4.44),('16273','2014-03-02','10:35:00',4.19),('16273','2014-03-02','10:40:00',4.03),('16273','2014-03-02','10:45:00',2.32),('16273','2014-03-02','10:50:00',1.26),('16273','2014-03-02','10:55:00',1.22),('16273','2014-03-02','11:00:00',1.74),('16273','2014-03-02','11:05:00',2.04),('16273','2014-03-02','11:10:00',3.36),('16273','2014-03-02','11:15:00',4.19),('16273','2014-03-02','11:20:00',3.31),('16273','2014-03-02','11:25:00',3.75),('16273','2014-03-02','11:30:00',2.78),('16273','2014-03-02','11:35:00',2.92),('16273','2014-03-02','11:40:00',1.89),('16273','2014-03-02','11:45:00',2.22),('16273','2014-03-02','11:50:00',3.66),('16273','2014-03-02','11:55:00',3.83),('16273','2014-03-02','12:00:00',3.26),('16273','2014-03-02','12:05:00',2.86),('16273','2014-03-02','12:10:00',1.47),('16273','2014-03-02','12:15:00',1.1),('16273','2014-03-02','12:20:00',1.03),('16273','2014-03-02','15:10:00',1.02),('16273','2014-03-02','15:15:00',1.04),('16273','2014-02-28','07:50:00',1.32),('16273','2014-02-28','07:55:00',1.09),('16273','2014-02-28','08:10:00',1.32),('16273','2014-02-28','08:15:00',1.22),('16273','2014-02-28','08:25:00',1.58),('16273','2014-02-28','09:05:00',1.31),('16273','2014-02-28','09:15:00',1.37),('16273','2014-02-28','09:20:00',2.57),('16273','2014-02-28','09:25:00',1.73),('16273','2014-02-28','09:30:00',3.28),('16273','2014-02-28','09:35:00',3.24),('16273','2014-02-28','09:40:00',1.69),('16273','2014-02-28','09:45:00',1.06),('16273','2014-02-28','09:50:00',1.21),('16273','2014-02-28','09:55:00',1.19),('16273','2014-02-28','10:00:00',1.18),('16273','2014-02-28','10:05:00',1.08),('16273','2014-02-28','10:10:00',2.29),('16273','2014-02-28','10:15:00',3.75),('16273','2014-02-28','10:20:00',2.74),('16273','2014-02-28','10:30:00',1.19),('16273','2014-02-28','10:35:00',1.23),('16273','2014-02-28','10:55:00',1),('16273','2014-02-28','11:00:00',1.65),('16273','2014-02-28','11:05:00',1.43),('16273','2014-02-28','11:10:00',1.24),('16273','2014-02-28','11:15:00',1.35),('16273','2014-02-28','11:20:00',1.41),('16273','2014-02-28','11:25:00',1.13),('16273','2014-02-28','11:45:00',1.18),('16273','2014-02-28','11:50:00',1.63),('16273','2014-02-28','11:55:00',2.27),('16273','2014-02-28','12:00:00',1.34),('16273','2014-02-28','12:15:00',1.3),('16273','2014-02-28','12:20:00',1.92),('16273','2014-02-28','12:25:00',2.64),('16273','2014-02-28','12:30:00',2.91),('16273','2014-02-28','12:35:00',1.11),('16273','2014-02-28','12:40:00',1.38),('16273','2014-02-28','12:45:00',1.45),('16273','2014-02-28','12:50:00',2.81),('16273','2014-02-28','12:55:00',2.05),('16273','2014-02-28','13:00:00',1.31),('16273','2014-02-28','13:05:00',1.19),('16273','2014-02-28','13:45:00',1.05),('16273','2014-02-28','13:50:00',1.04),('16273','2014-02-28','14:10:00',2.44),('16273','2014-02-28','14:15:00',2.49),('16273','2014-02-28','14:20:00',1.66),('16273','2014-02-28','14:25:00',1.52),('16273','2014-02-28','15:15:00',1.55),('16273','2014-02-28','15:20:00',1.04),('16273','2014-02-28','15:25:00',1.54),('16273','2014-02-28','15:30:00',2.24),('16273','2014-02-27','10:35:00',1.06),('16273','2014-02-27','10:40:00',1.17),('16273','2014-02-27','10:45:00',1.15),('16273','2014-02-27','10:50:00',1.27),('16273','2014-02-27','10:55:00',1.5),('16273','2014-02-27','11:00:00',1.56),('16273','2014-02-27','11:05:00',1.51),('16273','2014-02-27','11:10:00',1.48),('16273','2014-02-27','11:15:00',1.25),('16273','2014-02-27','11:20:00',1.41),('16273','2014-02-27','11:25:00',1.37),('16273','2014-02-27','11:30:00',1.25),('16273','2014-02-27','11:35:00',1.12),('16273','2014-02-27','11:40:00',1.1),('16273','2014-02-27','11:45:00',1.21),('16273','2014-02-27','11:50:00',1.25),('16273','2014-02-27','11:55:00',1.16),('16273','2014-02-27','12:00:00',1.17),('16273','2014-02-27','12:05:00',1.19),('16273','2014-02-27','12:10:00',1.22),('16273','2014-02-27','12:15:00',1.21),('16273','2014-02-27','12:20:00',1.15),('16273','2014-02-27','12:25:00',1.16),('16273','2014-02-27','12:30:00',1.15),('16273','2014-02-27','12:35:00',1.14),('16273','2014-02-27','12:40:00',1.15),('16273','2014-02-27','12:45:00',1.19),('16273','2014-02-27','12:50:00',1.2),('16273','2014-02-27','12:55:00',1.16),('16273','2014-02-27','13:00:00',1.1),('16273','2014-02-27','13:05:00',1.01),('16273','2014-02-27','13:10:00',1.02),('16273','2014-02-27','13:15:00',1.15),('16273','2014-02-27','13:20:00',1.28),('16273','2014-02-27','13:25:00',1.43),('16273','2014-02-27','13:30:00',1.54),('16273','2014-02-27','13:35:00',1.64),('16273','2014-02-27','13:40:00',1.63),('16273','2014-02-27','13:45:00',1.6),('16273','2014-02-27','13:50:00',1.49),('16273','2014-02-27','13:55:00',1.48),('16273','2014-02-27','14:00:00',1.68),('16273','2014-02-27','14:05:00',1.61),('16273','2014-02-27','14:10:00',1.33),('16273','2014-02-27','14:15:00',1.47),('16273','2014-02-27','14:20:00',1.38),('16273','2014-02-27','14:25:00',1.26),('16273','2014-02-27','14:30:00',1.2),('16273','2014-02-27','14:35:00',1.29),('16273','2014-02-27','14:40:00',1.43),('16273','2014-02-27','14:45:00',1.39),('16273','2014-02-27','14:50:00',1.35),('16273','2014-02-27','14:55:00',1.49),('16273','2014-02-27','15:00:00',1.82),('16273','2014-02-27','15:05:00',1.89),('16273','2014-02-27','15:10:00',1.76),('16273','2014-02-27','15:15:00',1.65),('16273','2014-02-27','15:20:00',1.66),('16273','2014-02-27','15:25:00',1.54),('16273','2014-02-27','15:30:00',1.02),('16273','2014-02-26','07:55:00',1.02),('16273','2014-02-26','08:00:00',1.27),('16273','2014-02-26','08:05:00',1.2),('16273','2014-02-26','08:10:00',1.54),('16273','2014-02-26','08:15:00',1.65),('16273','2014-02-26','08:20:00',1.76),('16273','2014-02-26','08:25:00',1.89),('16273','2014-02-26','08:30:00',1.98),('16273','2014-02-26','08:35:00',2.08),('16273','2014-02-26','08:40:00',2.18),('16273','2014-02-26','08:45:00',2.16),('16273','2014-02-26','08:50:00',2.18),('16273','2014-02-26','08:55:00',2.28),('16273','2014-02-26','09:00:00',2.32),('16273','2014-02-26','09:05:00',2.36),('16273','2014-02-26','09:10:00',2.35),('16273','2014-02-26','09:15:00',1.66),('16273','2014-02-26','09:20:00',1.61),('16273','2014-02-26','09:25:00',1.7),('16273','2014-02-26','09:30:00',1.92),('16273','2014-02-26','09:35:00',2.02),('16273','2014-02-26','09:40:00',1.27),('16273','2014-02-26','09:45:00',1.24),('16273','2014-02-26','09:50:00',1.24),('16273','2014-02-26','09:55:00',1.04),('16273','2014-02-26','12:20:00',1.43),('16273','2014-02-26','12:25:00',1.87),('16273','2014-02-26','12:30:00',3.65),('16273','2014-02-26','12:35:00',2.98),('16273','2014-02-26','12:40:00',2.48),('16273','2014-02-26','12:45:00',2.56),('16273','2014-02-26','12:50:00',3.28),('16273','2014-02-26','12:55:00',2.19),('16273','2014-02-26','13:00:00',1.59),('16273','2014-02-26','13:05:00',2.71),('16273','2014-02-26','13:10:00',2.53),('16273','2014-02-26','13:15:00',2.3),('16273','2014-02-26','13:20:00',3.23),('16273','2014-02-26','13:25:00',2.94),('16273','2014-02-26','13:30:00',2.72),('16273','2014-02-26','13:35:00',2.59),('16273','2014-02-26','13:40:00',2.43),('16273','2014-02-26','13:45:00',3.1),('16273','2014-02-26','13:50:00',1.8),('16273','2014-02-26','13:55:00',1.07),('16273','2014-02-26','14:00:00',1.05),('16273','2014-02-26','14:05:00',1.12),('16273','2014-02-26','14:10:00',2.96),('16273','2014-02-26','14:15:00',2.4),('16273','2014-02-26','14:20:00',3.12),('16273','2014-02-26','14:25:00',1.39),('16273','2014-02-26','14:30:00',1.93),('16273','2014-02-26','14:35:00',2.32),('16273','2014-02-26','14:40:00',1.03),('16273','2014-02-26','14:45:00',1.87),('16273','2014-02-26','14:50:00',2.31),('16273','2014-02-26','14:55:00',2.36),('16273','2014-02-26','15:00:00',2.15),('16273','2014-02-26','15:05:00',2),('16273','2014-02-26','15:10:00',1.7),('16273','2014-02-26','15:15:00',1.25),('16273','2014-02-26','15:20:00',1.05),('16273','2014-02-26','15:25:00',1.35),('16273','2014-02-26','15:30:00',1.28),('16273','2014-02-26','15:35:00',1.31),('16273','2014-02-26','15:40:00',1.42),('16273','2014-02-26','15:45:00',1.36),('16273','2014-02-26','15:50:00',1.38),('16273','2014-02-26','15:55:00',1.41),('16273','2014-02-26','16:00:00',1.2),('16273','2014-04-29','09:45:00',1.25),('16273','2014-04-29','09:50:00',2.34),('16273','2014-04-29','09:55:00',2.77),('16273','2014-04-29','10:00:00',3.35),('16273','2014-04-29','10:05:00',3.81),('16273','2014-04-29','10:10:00',3.56),('16273','2014-04-29','10:15:00',3.99),('16273','2014-04-29','10:20:00',3.92),('16273','2014-04-29','10:25:00',3.83),('16273','2014-04-29','10:30:00',3.83),('16273','2014-04-29','10:35:00',3.85),('16273','2014-04-29','10:40:00',3.25),('16273','2014-04-29','10:45:00',3.19),('16273','2014-04-29','10:50:00',3.72),('16273','2014-04-29','10:55:00',3.85),('16273','2014-04-29','11:00:00',3.83),('16273','2014-04-29','11:05:00',4.05),('16273','2014-04-29','11:10:00',4.04),('16273','2014-04-29','11:15:00',4.13),('16273','2014-04-29','11:20:00',3.71),('16273','2014-04-29','11:25:00',1.65),('16273','2014-04-29','11:30:00',1.16),('16273','2014-04-29','11:35:00',1.81),('16273','2014-04-29','11:40:00',1.63),('16273','2014-04-29','11:45:00',1.37),('16273','2014-04-29','11:50:00',1.4),('16273','2014-04-29','11:55:00',1.44),('16273','2014-04-29','12:00:00',2.48),('16273','2014-04-29','12:05:00',3.63),('16273','2014-04-29','12:10:00',3.14),('16273','2014-04-29','12:15:00',4.22),('16273','2014-04-29','12:20:00',3.58),('16273','2014-04-29','12:25:00',4.77),('16273','2014-04-29','12:30:00',3.42),('16273','2014-04-29','12:35:00',2.84),('16273','2014-04-29','12:40:00',4.71),('16273','2014-04-29','12:45:00',4.73),('16273','2014-04-29','12:50:00',3.56),('16273','2014-04-29','12:55:00',1.49),('16273','2014-04-29','13:00:00',4.29),('16273','2014-04-29','13:05:00',2.42),('16273','2014-04-29','13:10:00',4.19),('16273','2014-04-29','13:15:00',4.2),('16273','2014-04-29','13:20:00',1.26),('16273','2014-04-29','13:25:00',2.82),('16273','2014-04-29','13:30:00',3.71),('16273','2014-04-29','13:35:00',2.84),('16273','2014-04-29','13:40:00',1.44),('16273','2014-04-29','13:45:00',1.4),('16273','2014-04-29','13:50:00',1.51),('16273','2014-04-29','13:55:00',1.01),('16273','2014-04-29','14:40:00',1.08),('16273','2014-04-29','14:45:00',1.35),('16273','2014-04-29','14:50:00',1.97),('16273','2014-04-29','14:55:00',2.3),('16273','2014-04-29','15:00:00',3.77),('16273','2014-04-29','15:05:00',3.29),('16273','2014-04-29','15:10:00',2.39),('16273','2014-04-29','15:15:00',2.02),('16273','2014-04-29','15:20:00',3.97),('16273','2014-04-29','15:25:00',4.16),('16273','2014-04-29','15:30:00',3.79),('16273','2014-04-29','15:35:00',2.29),('16273','2014-04-29','15:40:00',1.61),('16273','2014-04-29','15:45:00',1.87),('16273','2014-04-29','15:50:00',3.25),('16273','2014-04-29','15:55:00',2.62),('16273','2014-04-29','16:00:00',2.14),('16273','2014-04-29','16:05:00',1.74),('16273','2014-04-29','16:10:00',1.71),('16273','2014-04-29','16:15:00',1.34),('16273','2014-04-29','16:20:00',1.06),('16273','2014-04-29','16:25:00',1.34),('16273','2014-04-29','16:30:00',1.36),('16273','2014-04-29','16:35:00',1.5),('16273','2014-04-29','16:40:00',1.05),('16273','2014-04-29','17:00:00',1.07),('16273','2014-04-29','17:05:00',1.34),('16273','2014-04-29','17:10:00',2.07),('16273','2014-04-29','17:15:00',2.2),('16273','2014-04-29','17:20:00',1.81),('16273','2014-04-29','17:25:00',1.59),('16273','2014-04-29','17:40:00',1.37),('16273','2014-04-29','17:45:00',1.03),('16273','2014-02-25','07:55:00',1.09),('16273','2014-02-25','08:00:00',1.23),('16273','2014-02-25','08:05:00',1.34),('16273','2014-02-25','08:10:00',1.26),('16273','2014-02-25','08:15:00',1.6),('16273','2014-02-25','08:20:00',1.69),('16273','2014-02-25','08:25:00',1.78),('16273','2014-02-25','08:30:00',1.88),('16273','2014-02-25','08:35:00',1.94),('16273','2014-02-25','08:40:00',2.03),('16273','2014-02-25','08:45:00',2.12),('16273','2014-02-25','08:50:00',2.19),('16273','2014-02-25','08:55:00',2.27),('16273','2014-02-25','09:00:00',2.33),('16273','2014-02-25','09:05:00',2.39),('16273','2014-02-25','09:10:00',2.45),('16273','2014-02-25','09:15:00',2.51),('16273','2014-02-25','09:20:00',2.55),('16273','2014-02-25','09:25:00',2.61),('16273','2014-02-25','09:30:00',2.66),('16273','2014-02-25','09:35:00',2.71),('16273','2014-02-25','09:40:00',2.75),('16273','2014-02-25','09:45:00',2.8),('16273','2014-02-25','09:50:00',2.85),('16273','2014-02-25','09:55:00',2.88),('16273','2014-02-25','10:00:00',2.9),('16273','2014-02-25','10:05:00',2.95),('16273','2014-02-25','10:10:00',3.01),('16273','2014-02-25','10:15:00',3.02),('16273','2014-02-25','10:20:00',3.06),('16273','2014-02-25','10:25:00',3.07),('16273','2014-02-25','10:30:00',3.08),('16273','2014-02-25','10:35:00',3.1),('16273','2014-02-25','10:40:00',3.15),('16273','2014-02-25','10:45:00',3.21),('16273','2014-02-25','10:50:00',3.18),('16273','2014-02-25','10:55:00',3.19),('16273','2014-02-25','11:00:00',3.16),('16273','2014-02-25','11:05:00',3.22),('16273','2014-02-25','11:10:00',3.26),('16273','2014-02-25','11:15:00',3.27),('16273','2014-02-25','11:20:00',3.25),('16273','2014-02-25','11:25:00',3.25),('16273','2014-02-25','11:30:00',3.25),('16273','2014-02-25','11:35:00',3.32),('16273','2014-02-25','11:40:00',3.33),('16273','2014-02-25','11:45:00',3.29),('16273','2014-02-25','11:50:00',3.29),('16273','2014-02-25','11:55:00',3.29),('16273','2014-02-25','12:00:00',3.28),('16273','2014-02-25','12:05:00',3.28),('16273','2014-02-25','12:10:00',3.24),('16273','2014-02-25','12:15:00',3.23),('16273','2014-02-25','12:20:00',3.28),('16273','2014-02-25','12:25:00',3.28),('16273','2014-02-25','12:30:00',3.25),('16273','2014-02-25','12:35:00',3.2),('16273','2014-02-25','12:40:00',3.18),('16273','2014-02-25','12:45:00',3.19),('16273','2014-02-25','12:50:00',3.2),('16273','2014-02-25','12:55:00',3.18),('16273','2014-02-25','13:00:00',3.13),('16273','2014-02-25','13:05:00',3.09),('16273','2014-02-25','13:10:00',3.05),('16273','2014-02-25','13:15:00',2.35),('16273','2014-02-25','13:20:00',3.06),('16273','2014-02-25','13:25:00',1.28),('16273','2014-02-25','13:40:00',1.44),('16273','2014-02-25','13:45:00',1.03),('16273','2014-02-25','13:50:00',1.05),('16273','2014-02-25','13:55:00',2.81),('16273','2014-02-25','14:00:00',2.95),('16273','2014-02-25','14:05:00',2.66),('16273','2014-02-25','14:10:00',2.36),('16273','2014-02-25','14:15:00',2.16),('16273','2014-02-25','14:20:00',2.08),('16273','2014-02-25','14:25:00',2.15),('16273','2014-02-25','14:30:00',2.15),('16273','2014-02-25','14:35:00',2.28),('16273','2014-02-25','14:40:00',2.26),('16273','2014-02-25','14:45:00',2.15),('16273','2014-02-25','14:50:00',2.15),('16273','2014-02-25','14:55:00',1.99),('16273','2014-02-25','15:00:00',1.96),('16273','2014-02-25','15:05:00',1.88),('16273','2014-02-25','15:10:00',1.78),('16273','2014-02-25','15:15:00',1.63),('16273','2014-02-25','15:20:00',1.51),('16273','2014-02-25','15:25:00',1.39),('16273','2014-02-25','15:30:00',1.31),('16273','2014-02-25','15:35:00',1.14),('16273','2014-02-24','07:55:00',1.08),('16273','2014-02-24','08:00:00',1.39),('16273','2014-02-24','08:05:00',1.57),('16273','2014-02-24','08:25:00',1.46),('16273','2014-02-24','08:30:00',1.01),('16273','2014-02-24','08:35:00',1.95),('16273','2014-02-24','08:40:00',1.19),('16273','2014-02-24','08:50:00',1.58),('16273','2014-02-24','08:55:00',2.57),('16273','2014-02-24','09:00:00',2.54),('16273','2014-02-24','09:05:00',2.44),('16273','2014-02-24','09:10:00',2.53),('16273','2014-02-24','09:15:00',2.57),('16273','2014-02-24','09:20:00',2.63),('16273','2014-02-24','09:25:00',2.66),('16273','2014-02-24','09:30:00',2.73),('16273','2014-02-24','09:35:00',2.79),('16273','2014-02-24','09:40:00',2.82),('16273','2014-02-24','09:45:00',2.86),('16273','2014-02-24','09:50:00',2.91),('16273','2014-02-24','09:55:00',2.95),('16273','2014-02-24','10:00:00',2.96),('16273','2014-02-24','10:05:00',3.06),('16273','2014-02-24','10:10:00',3.11),('16273','2014-02-24','10:15:00',3.15),('16273','2014-02-24','10:20:00',3.15),('16273','2014-02-24','10:25:00',3.18),('16273','2014-02-24','10:30:00',3.22),('16273','2014-02-24','10:35:00',3.23),('16273','2014-02-24','10:40:00',3.24),('16273','2014-02-24','10:45:00',3.25),('16273','2014-02-24','10:50:00',3.27),('16273','2014-02-24','10:55:00',3.3),('16273','2014-02-24','11:00:00',3.33),('16273','2014-02-24','11:05:00',3.33),('16273','2014-02-24','11:10:00',3.37),('16273','2014-02-24','11:15:00',3.32),('16273','2014-02-24','11:20:00',3.35),('16273','2014-02-24','11:25:00',3.46),('16273','2014-02-24','11:30:00',3.58),('16273','2014-02-24','11:35:00',2.48),('16273','2014-02-24','11:40:00',3.33),('16273','2014-02-24','11:45:00',1.95),('16273','2014-02-24','11:50:00',2.79),('16273','2014-02-24','11:55:00',3.46),('16273','2014-02-24','12:00:00',3.42),('16273','2014-02-24','12:05:00',3.39),('16273','2014-02-24','12:10:00',3.36),('16273','2014-02-24','12:15:00',3.33),('16273','2014-02-24','12:20:00',3.32),('16273','2014-02-24','12:25:00',3.29),('16273','2014-02-24','12:30:00',3.26),('16273','2014-02-24','12:35:00',3.23),('16273','2014-02-24','12:40:00',3.22),('16273','2014-02-24','12:45:00',3.2),('16273','2014-02-24','12:50:00',1.3),('16273','2014-02-24','13:00:00',1.33),('16273','2014-02-24','13:10:00',1),('16273','2014-02-24','13:15:00',1.45),('16273','2014-02-24','13:20:00',3.95),('16273','2014-02-24','13:25:00',1.57),('16273','2014-02-24','14:00:00',1.02),('16273','2014-02-24','14:05:00',1.1),('16273','2014-02-24','14:10:00',1.11),('16273','2014-02-24','14:15:00',1.05),('16273','2014-02-24','14:20:00',1.12),('16273','2014-02-24','14:25:00',1.14),('16273','2014-02-24','14:30:00',1.3),('16273','2014-02-24','14:35:00',1.18),('16273','2014-02-24','14:55:00',1.09),('16273','2014-02-24','15:00:00',1.72),('16273','2014-02-24','15:05:00',2.13),('16273','2014-02-24','15:10:00',2.41),('16273','2014-02-24','15:15:00',2.07),('16273','2014-02-24','15:20:00',1.84),('16273','2014-02-24','15:25:00',1.65),('16273','2014-02-24','15:30:00',1.48),('16273','2014-02-24','15:35:00',1.43),('16273','2014-02-24','15:40:00',1.34),('16273','2014-02-24','15:45:00',1.27),('16273','2014-02-24','15:55:00',1.01),('16273','2014-02-24','16:00:00',1.13),('16273','2014-02-24','16:05:00',1.09),('16273','2014-02-24','16:10:00',1.07),('16273','2014-02-24','16:15:00',1.09),('16273','2014-02-24','16:20:00',1.03),('16273','2014-02-23','08:00:00',1.12),('16273','2014-02-23','08:05:00',1.25),('16273','2014-02-23','08:10:00',1.37),('16273','2014-02-23','08:15:00',1.26),('16273','2014-02-23','08:20:00',1.62),('16273','2014-02-23','08:25:00',1.72),('16273','2014-02-23','08:30:00',1.82),('16273','2014-02-23','08:35:00',1.91),('16273','2014-02-23','08:40:00',1.99),('16273','2014-02-23','08:45:00',2.07),('16273','2014-02-23','08:50:00',2.17),('16273','2014-02-23','08:55:00',2.26),('16273','2014-02-23','09:00:00',2.33),('16273','2014-02-23','09:05:00',2.39),('16273','2014-02-23','09:10:00',2.5),('16273','2014-02-23','09:15:00',2.58),('16273','2014-02-23','09:20:00',2.2),('16273','2014-02-23','09:25:00',2.36),('16273','2014-02-23','09:30:00',2.66),('16273','2014-02-23','09:35:00',2.71),('16273','2014-02-23','09:40:00',2.71),('16273','2014-02-23','09:45:00',2.79),('16273','2014-02-23','09:50:00',2.85),('16273','2014-02-23','09:55:00',2.88),('16273','2014-02-23','10:00:00',2.91),('16273','2014-02-23','10:05:00',2.96),('16273','2014-02-23','10:10:00',3.01),('16273','2014-02-23','10:15:00',3.07),('16273','2014-02-23','10:20:00',3.05),('16273','2014-02-23','10:25:00',3.12),('16273','2014-02-23','10:30:00',3.14),('16273','2014-02-23','10:35:00',3.17),('16273','2014-02-23','10:40:00',3.19),('16273','2014-02-23','10:45:00',3.2),('16273','2014-02-23','10:50:00',3.21),('16273','2014-02-23','10:55:00',3.22),('16273','2014-02-23','11:00:00',3.28),('16273','2014-02-23','11:05:00',3.3),('16273','2014-02-23','11:10:00',3.32),('16273','2014-02-23','11:15:00',3.35),('16273','2014-02-23','11:20:00',3.37),('16273','2014-02-23','11:25:00',3.36),('16273','2014-02-23','11:30:00',3.38),('16273','2014-02-23','11:35:00',3.39),('16273','2014-02-23','11:40:00',3.39),('16273','2014-02-23','11:45:00',3.42),('16273','2014-02-23','11:50:00',3.47),('16273','2014-02-23','11:55:00',3.28),('16273','2014-02-23','12:00:00',3.34),('16273','2014-02-23','12:05:00',2.74),('16273','2014-02-23','12:10:00',3.29),('16273','2014-02-23','12:15:00',2.86),('16273','2014-02-23','12:20:00',1.48),('16273','2014-02-23','12:25:00',1.64),('16273','2014-02-23','12:30:00',1.64),('16273','2014-02-23','12:35:00',2.41),('16273','2014-02-23','12:40:00',2.59),('16273','2014-02-23','12:45:00',2.87),('16273','2014-02-23','12:50:00',2.98),('16273','2014-02-23','12:55:00',3.27),('16273','2014-02-23','13:00:00',3.26),('16273','2014-02-23','13:05:00',3.21),('16273','2014-02-23','13:10:00',3.2),('16273','2014-02-23','13:15:00',3.08),('16273','2014-02-23','13:20:00',2.86),('16273','2014-02-23','13:25:00',2.48),('16273','2014-02-23','13:30:00',2.52),('16273','2014-02-23','13:35:00',2.55),('16273','2014-02-23','13:40:00',2.77),('16273','2014-02-23','13:45:00',2.56),('16273','2014-02-23','13:50:00',2.28),('16273','2014-02-23','13:55:00',2.48),('16273','2014-02-23','14:00:00',2.78),('16273','2014-02-23','14:05:00',2.56),('16273','2014-02-23','14:10:00',1.46),('16273','2014-02-23','14:15:00',2.29),('16273','2014-02-23','14:20:00',2.09),('16273','2014-02-23','14:25:00',1.55),('16273','2014-02-23','14:30:00',2.28),('16273','2014-02-23','14:35:00',2.22),('16273','2014-02-23','14:40:00',2.53),('16273','2014-02-23','14:45:00',2.63),('16273','2014-02-23','14:50:00',2.34),('16273','2014-02-23','14:55:00',1.14),('16273','2014-02-23','15:00:00',1.2),('16273','2014-02-23','15:05:00',1.09),('16273','2014-02-23','15:15:00',1.29),('16273','2014-02-23','15:20:00',1.98),('16273','2014-02-23','15:25:00',1.83),('16273','2014-02-23','15:30:00',1.83),('16273','2014-02-23','15:40:00',1.7),('16273','2014-02-23','15:45:00',1.68),('16273','2014-02-23','15:50:00',1.82),('16273','2014-02-23','15:55:00',1.84),('16273','2014-02-23','16:00:00',1.55),('16273','2014-02-23','16:05:00',1.15),('16273','2014-02-22','09:15:00',1.04),('16273','2014-02-22','09:35:00',1.93),('16273','2014-02-22','09:40:00',2.77),('16273','2014-02-22','09:45:00',1.85),('16273','2014-02-22','09:50:00',1.37),('16273','2014-02-22','09:55:00',1.43),('16273','2014-02-22','10:00:00',2.23),('16273','2014-02-22','10:05:00',1.13),('16273','2014-02-22','10:20:00',1.58),('16273','2014-02-22','10:25:00',1.99),('16273','2014-02-22','10:30:00',2.53),('16273','2014-02-22','10:35:00',3.43),('16273','2014-02-22','10:40:00',2.31),('16273','2014-02-22','10:45:00',1.12),('16273','2014-02-22','11:55:00',1.1),('16273','2014-02-22','12:00:00',1.19),('16273','2014-02-22','12:05:00',1.15),('16273','2014-02-22','12:10:00',1.11),('16273','2014-02-22','12:15:00',1.15),('16273','2014-02-22','12:20:00',1.15),('16273','2014-02-22','12:25:00',1.06),('16273','2014-02-22','12:30:00',1.75),('16273','2014-02-22','12:35:00',3.05),('16273','2014-02-22','12:40:00',3.36),('16273','2014-02-22','12:45:00',3.22),('16273','2014-02-22','12:50:00',2.49),('16273','2014-02-22','12:55:00',3.82),('16273','2014-02-22','13:00:00',2),('16273','2014-02-22','13:10:00',1.3),('16273','2014-02-22','13:15:00',1.54),('16273','2014-02-22','13:30:00',1.81),('16273','2014-02-22','13:35:00',2.94),('16273','2014-02-22','13:40:00',1.48),('16273','2014-02-22','13:45:00',1.17),('16273','2014-02-22','13:50:00',1.37),('16273','2014-02-22','13:55:00',1.32),('16273','2014-02-22','14:00:00',1.41),('16273','2014-02-22','14:05:00',2.53),('16273','2014-02-22','14:10:00',1.21),('16273','2014-02-22','14:20:00',1.08),('16273','2014-02-22','14:25:00',2.42),('16273','2014-02-22','14:50:00',1.55),('16273','2014-02-22','14:55:00',1.89),('16273','2014-02-22','15:00:00',1.45),('16273','2014-02-22','15:05:00',1.31),('16273','2014-02-22','15:20:00',1.31),('16273','2014-02-22','15:25:00',1.95),('16273','2014-02-22','15:40:00',1.14),('16273','2014-02-22','15:45:00',1.42),('16273','2014-02-22','16:00:00',1.18),('16273','2014-02-21','09:15:00',1.03),('16273','2014-02-21','09:20:00',1.02),('16273','2014-02-21','09:25:00',1.02),('16273','2014-02-21','09:40:00',1.01),('16273','2014-02-21','09:45:00',1.06),('16273','2014-02-21','09:50:00',1.22),('16273','2014-02-21','09:55:00',1.52),('16273','2014-02-21','10:00:00',1.75),('16273','2014-02-21','10:05:00',2.13),('16273','2014-02-21','10:10:00',2.13),('16273','2014-02-21','10:15:00',1.8),('16273','2014-02-21','10:20:00',1.81),('16273','2014-02-21','10:25:00',1.57),('16273','2014-02-21','10:30:00',1.49),('16273','2014-02-21','10:35:00',1.65),('16273','2014-02-21','10:40:00',2.3),('16273','2014-02-21','10:45:00',3.54),('16273','2014-02-21','10:50:00',3.48),('16273','2014-02-21','10:55:00',3.4),('16273','2014-02-21','11:00:00',3.55),('16273','2014-02-21','11:05:00',3.49),('16273','2014-02-21','11:10:00',2.79),('16273','2014-02-21','11:15:00',1.56),('16273','2014-02-21','11:20:00',1.85),('16273','2014-02-21','11:25:00',2.98),('16273','2014-02-21','11:30:00',3.14),('16273','2014-02-21','11:35:00',2.4),('16273','2014-02-21','11:40:00',3.47),('16273','2014-02-21','11:45:00',3.01),('16273','2014-02-21','11:50:00',2.42),('16273','2014-02-21','11:55:00',2.59),('16273','2014-02-21','12:00:00',1.08),('16273','2014-02-21','12:05:00',1.13),('16273','2014-02-21','12:10:00',1.1),('16273','2014-02-21','14:10:00',1.26),('16273','2014-02-21','14:15:00',1.18),('16273','2014-02-21','14:20:00',1.31),('16273','2014-02-21','14:25:00',1.47),('16273','2014-02-21','14:30:00',2.21),('16273','2014-02-21','14:35:00',1.41),('16273','2014-02-21','14:40:00',1.59),('16273','2014-02-21','14:45:00',1.74),('16273','2014-02-21','14:50:00',2.03),('16273','2014-02-21','14:55:00',1.96),('16273','2014-02-21','15:00:00',1.42),('16273','2014-02-21','15:05:00',1.23),('16273','2014-02-21','15:10:00',2.29),('16273','2014-02-21','15:15:00',1.99),('16273','2014-02-21','15:20:00',1.66),('16273','2014-02-21','15:25:00',1.5),('16273','2014-02-21','15:30:00',1.39),('16273','2014-02-21','15:35:00',1.33),('16273','2014-02-21','15:40:00',1.26),('16273','2014-02-21','15:45:00',1.2),('16273','2014-02-21','15:50:00',1.14),('16273','2014-02-21','15:55:00',1.06),('16273','2014-02-21','16:00:00',1.05),('16273','2014-02-20','10:15:00',1.02),('16273','2014-02-20','10:20:00',1.06),('16273','2014-02-20','10:35:00',1.05),('16273','2014-02-20','10:40:00',1.14),('16273','2014-02-20','10:45:00',1.1),('16273','2014-02-20','10:50:00',1.05),('16273','2014-02-20','10:55:00',1.05),('16273','2014-02-20','11:20:00',1.13),('16273','2014-02-20','11:25:00',1.22),('16273','2014-02-20','11:30:00',1.26),('16273','2014-02-20','11:35:00',1.06),('16273','2014-02-20','11:40:00',1.07),('16273','2014-02-20','11:55:00',1.08),('16273','2014-02-20','12:00:00',1.05),('16273','2014-02-20','12:20:00',1.16),('16273','2014-02-20','12:30:00',1.03),('16273','2014-02-20','12:35:00',1.09),('16273','2014-02-20','12:40:00',1.2),('16273','2014-02-20','12:45:00',1.15),('16273','2014-02-20','12:50:00',1.01),('16273','2014-02-20','12:55:00',1.11),('16273','2014-02-20','13:00:00',1.27),('16273','2014-02-20','13:05:00',1.08),('16273','2014-02-20','13:10:00',1.32),('16273','2014-02-20','13:15:00',1.35),('16273','2014-02-20','13:20:00',1.14),('16273','2014-02-20','13:25:00',1.32),('16273','2014-02-20','13:30:00',1.23),('16273','2014-02-20','13:35:00',1.13),('16273','2014-02-20','13:40:00',1.22),('16273','2014-02-20','13:45:00',1.18),('16273','2014-02-20','13:50:00',1.23),('16273','2014-02-20','13:55:00',1.11),('16273','2014-02-20','14:00:00',1.26),('16273','2014-02-20','14:05:00',1.12),('16273','2014-02-19','09:40:00',1.16),('16273','2014-02-19','09:45:00',1.42),('16273','2014-02-19','09:50:00',1.31),('16273','2014-02-19','09:55:00',1.18),('16273','2014-02-19','10:00:00',1.24),('16273','2014-02-19','10:05:00',1.3),('16273','2014-02-19','10:10:00',1.36),('16273','2014-02-19','10:15:00',1.47),('16273','2014-02-19','10:20:00',1.37),('16273','2014-02-19','10:25:00',1.26),('16273','2014-02-19','10:30:00',1.14),('16273','2014-02-19','10:35:00',1.22),('16273','2014-02-19','10:40:00',1.41),('16273','2014-02-19','10:45:00',1.35),('16273','2014-02-19','10:50:00',1.49),('16273','2014-02-19','10:55:00',1.53),('16273','2014-02-19','11:00:00',1.23),('16273','2014-02-19','11:10:00',1.28),('16273','2014-02-19','11:15:00',1.4),('16273','2014-02-19','11:20:00',1.32),('16273','2014-02-19','11:25:00',1.03),('16273','2014-02-19','11:40:00',1.38),('16273','2014-02-19','11:45:00',1.47),('16273','2014-02-19','11:50:00',1.4),('16273','2014-02-19','11:55:00',1.13),('16273','2014-02-19','12:00:00',1.22),('16273','2014-02-19','12:05:00',1.31),('16273','2014-02-19','12:10:00',1.3),('16273','2014-02-19','12:15:00',1.04),('16273','2014-02-19','12:30:00',1.22),('16273','2014-02-19','12:35:00',1.02),('16273','2014-02-19','12:40:00',1.15),('16273','2014-02-19','12:45:00',1.42),('16273','2014-02-19','12:50:00',1.31),('16273','2014-02-19','12:55:00',1.37),('16273','2014-02-19','13:00:00',1.95),('16273','2014-02-19','13:05:00',1.79),('16273','2014-02-19','13:10:00',2.01),('16273','2014-02-19','13:15:00',1.8),('16273','2014-02-19','13:20:00',1.45),('16273','2014-02-19','13:25:00',1.43),('16273','2014-02-19','13:30:00',1.56),('16273','2014-02-19','13:35:00',1.68),('16273','2014-02-19','13:40:00',1.71),('16273','2014-02-19','13:45:00',1.84),('16273','2014-02-19','13:50:00',1.82),('16273','2014-02-19','13:55:00',1.87),('16273','2014-02-19','14:00:00',1.37),('16273','2014-02-19','14:05:00',1.13),('16273','2014-02-19','14:10:00',1.01),('16273','2014-02-19','14:15:00',1.12),('16273','2014-02-19','14:20:00',1.11),('16273','2014-02-19','14:25:00',1.3),('16273','2014-02-19','14:30:00',1.28),('16273','2014-02-19','14:35:00',1.12),('16273','2014-02-18','08:05:00',1.1),('16273','2014-02-18','08:10:00',1.24),('16273','2014-02-18','08:15:00',1.23),('16273','2014-02-18','08:20:00',1.37),('16273','2014-02-18','08:25:00',1.61),('16273','2014-02-18','08:30:00',1.7),('16273','2014-02-18','08:35:00',1.77),('16273','2014-02-18','08:40:00',1.85),('16273','2014-02-18','08:45:00',1.92),('16273','2014-02-18','08:50:00',1.98),('16273','2014-02-18','08:55:00',2.07),('16273','2014-02-18','09:00:00',2.14),('16273','2014-02-18','09:05:00',2.21),('16273','2014-02-18','09:10:00',2.28),('16273','2014-02-18','09:15:00',2.35),('16273','2014-02-18','09:20:00',2.39),('16273','2014-02-18','09:25:00',2.46),('16273','2014-02-18','09:30:00',2.5),('16273','2014-02-18','09:35:00',2.54),('16273','2014-02-18','09:40:00',2.61),('16273','2014-02-18','09:45:00',2.67),('16273','2014-02-18','09:50:00',2.7),('16273','2014-02-18','09:55:00',2.74),('16273','2014-02-18','10:00:00',2.79),('16273','2014-02-18','10:05:00',2.83),('16273','2014-02-18','10:10:00',2.84),('16273','2014-02-18','10:15:00',2.85),('16273','2014-02-18','10:20:00',2.89),('16273','2014-02-18','10:25:00',2.94),('16273','2014-02-18','10:30:00',2.96),('16273','2014-02-18','10:35:00',2.99),('16273','2014-02-18','10:40:00',3.03),('16273','2014-02-18','10:45:00',3.05),('16273','2014-02-18','10:50:00',3.1),('16273','2014-02-18','10:55:00',3.15),('16273','2014-02-18','11:00:00',3.16),('16273','2014-02-18','11:05:00',2.97),('16273','2014-02-18','11:10:00',2.76),('16273','2014-02-18','11:15:00',2.66),('16273','2014-02-18','11:20:00',3.14),('16273','2014-02-18','11:25:00',3.18),('16273','2014-02-18','11:30:00',2.53),('16273','2014-02-18','11:35:00',1.81),('16273','2014-02-18','11:40:00',1.76),('16273','2014-02-18','11:45:00',1.56),('16273','2014-02-18','11:50:00',1.33),('16273','2014-02-18','11:55:00',1.34),('16273','2014-02-18','12:00:00',1.37),('16273','2014-02-18','12:05:00',1.35),('16273','2014-02-18','12:10:00',1.44),('16273','2014-02-18','12:15:00',1.55),('16273','2014-02-18','12:20:00',1.7),('16273','2014-02-18','12:25:00',1.75),('16273','2014-02-18','12:30:00',1.58),('16273','2014-02-18','12:35:00',1.42),('16273','2014-02-18','12:40:00',1.38),('16273','2014-02-18','12:45:00',1.33),('16273','2014-02-18','12:50:00',1.31),('16273','2014-02-18','12:55:00',1.33),('16273','2014-02-18','13:00:00',1.26),('16273','2014-02-18','13:05:00',1.19),('16273','2014-02-18','13:10:00',1.28),('16273','2014-02-18','13:15:00',1.76),('16273','2014-02-18','13:20:00',2.44),('16273','2014-02-18','13:25:00',2.58),('16273','2014-02-18','13:30:00',1.66),('16273','2014-02-18','13:35:00',1.81),('16273','2014-02-18','13:40:00',2),('16273','2014-02-18','13:45:00',1.89),('16273','2014-02-18','13:50:00',1.53),('16273','2014-02-18','13:55:00',1.54),('16273','2014-02-18','14:00:00',1.49),('16273','2014-02-18','14:05:00',1.9),('16273','2014-02-18','14:10:00',1.45),('16273','2014-02-18','14:15:00',1.21),('16273','2014-02-18','14:20:00',1.06),('16273','2014-02-18','14:25:00',1.09),('16273','2014-02-18','14:30:00',1.22),('16273','2014-02-18','14:35:00',1.16),('16273','2014-02-18','14:40:00',1.01),('16273','2014-02-18','15:40:00',1.04),('16273','2014-02-17','08:15:00',1.09),('16273','2014-02-17','08:20:00',1.08),('16273','2014-02-17','08:25:00',1.35),('16273','2014-02-17','08:30:00',1.44),('16273','2014-02-17','08:35:00',1.56),('16273','2014-02-17','08:40:00',1.62),('16273','2014-02-17','08:45:00',1.66),('16273','2014-02-17','08:50:00',1.72),('16273','2014-02-17','08:55:00',1.78),('16273','2014-02-17','09:00:00',1.9),('16273','2014-02-17','09:05:00',1.98),('16273','2014-02-17','09:10:00',2.06),('16273','2014-02-17','09:15:00',2.13),('16273','2014-02-17','09:20:00',2.2),('16273','2014-02-17','09:25:00',2.25),('16273','2014-02-17','09:30:00',2.3),('16273','2014-02-17','09:35:00',2.35),('16273','2014-02-17','09:40:00',2.38),('16273','2014-02-17','09:45:00',2.4),('16273','2014-02-17','09:50:00',2.45),('16273','2014-02-17','09:55:00',2.5),('16273','2014-02-17','10:00:00',2.53),('16273','2014-02-17','10:05:00',2.57),('16273','2014-02-17','10:10:00',2.59),('16273','2014-02-17','10:15:00',2.62),('16273','2014-02-17','10:20:00',2.65),('16273','2014-02-17','10:25:00',2.68),('16273','2014-02-17','10:30:00',2.68),('16273','2014-02-17','10:35:00',2.68),('16273','2014-02-17','10:40:00',2.74),('16273','2014-02-17','10:45:00',2.79),('16273','2014-02-17','10:50:00',2.78),('16273','2014-02-17','10:55:00',2.79),('16273','2014-02-17','11:00:00',2.81),('16273','2014-02-17','11:05:00',2.81),('16273','2014-02-17','11:10:00',2.8),('16273','2014-02-17','11:15:00',2.85),('16273','2014-02-17','11:20:00',2.85),('16273','2014-02-17','11:25:00',2.9),('16273','2014-02-17','11:30:00',2.92),('16273','2014-02-17','11:35:00',2.96),('16273','2014-02-17','11:40:00',2.95),('16273','2014-02-17','11:45:00',2.96),('16273','2014-02-17','11:50:00',2.97),('16273','2014-02-17','11:55:00',2.97),('16273','2014-02-17','12:00:00',2.98),('16273','2014-02-17','12:05:00',3),('16273','2014-02-17','12:10:00',2.97),('16273','2014-02-17','12:15:00',2.96),('16273','2014-02-17','12:20:00',2.94),('16273','2014-02-17','12:25:00',2.89),('16273','2014-02-17','12:30:00',2.92),('16273','2014-02-17','12:35:00',2.9),('16273','2014-02-17','12:40:00',2.89),('16273','2014-02-17','12:45:00',2.86),('16273','2014-02-17','12:50:00',2.85),('16273','2014-02-17','12:55:00',2.82),('16273','2014-02-17','13:00:00',2.79),('16273','2014-02-17','13:05:00',2.75),('16273','2014-02-17','13:10:00',2.72),('16273','2014-02-17','13:15:00',2.69),('16273','2014-02-17','13:20:00',2.67),('16273','2014-02-17','13:25:00',2.63),('16273','2014-02-17','13:30:00',2.59),('16273','2014-02-17','13:35:00',2.55),('16273','2014-02-17','13:40:00',2.5),('16273','2014-02-17','13:45:00',2.45),('16273','2014-02-17','13:50:00',2.44),('16273','2014-02-17','13:55:00',2.39),('16273','2014-02-17','14:00:00',2.32),('16273','2014-02-17','14:05:00',2.29),('16273','2014-02-17','14:10:00',2.16),('16273','2014-02-17','14:15:00',2.23),('16273','2014-02-17','14:20:00',2.15),('16273','2014-02-17','14:25:00',2.07),('16273','2014-02-17','14:30:00',1.97),('16273','2014-02-17','14:35:00',1.9),('16273','2014-02-17','14:40:00',1.89),('16273','2014-02-17','14:45:00',1.85),('16273','2014-02-17','14:50:00',1.79),('16273','2014-02-17','14:55:00',1.73),('16273','2014-02-17','15:00:00',1.65),('16273','2014-02-17','15:05:00',1.51),('16273','2014-02-17','15:10:00',1.43),('16273','2014-02-17','15:15:00',1.48),('16273','2014-02-17','15:20:00',1.38),('16273','2014-02-17','15:25:00',1.34),('16273','2014-02-17','15:30:00',1.28),('16273','2014-02-17','15:35:00',1.18),('16273','2014-02-17','15:40:00',1.15),('16273','2014-02-17','15:45:00',1.09),('16273','2014-02-17','15:50:00',1.03),('16273','2014-02-16','08:05:00',1.05),('16273','2014-02-16','08:10:00',1.18),('16273','2014-02-16','08:15:00',1.3),('16273','2014-02-16','08:20:00',1.18),('16273','2014-02-16','08:25:00',1.56),('16273','2014-02-16','08:30:00',1.69),('16273','2014-02-16','08:35:00',1.61),('16273','2014-02-16','08:40:00',1.91),('16273','2014-02-16','08:45:00',1.79),('16273','2014-02-16','08:50:00',2.04),('16273','2014-02-16','08:55:00',2.13),('16273','2014-02-16','09:00:00',2.24),('16273','2014-02-16','09:05:00',2.25),('16273','2014-02-16','09:10:00',1.98),('16273','2014-02-16','09:15:00',2.24),('16273','2014-02-16','09:20:00',2.27),('16273','2014-02-16','09:25:00',2.24),('16273','2014-02-16','09:30:00',2.02),('16273','2014-02-16','09:35:00',2.56),('16273','2014-02-16','09:40:00',2.63),('16273','2014-02-16','09:45:00',2.66),('16273','2014-02-16','09:50:00',2.66),('16273','2014-02-16','09:55:00',2.53),('16273','2014-02-16','10:00:00',2.76),('16273','2014-02-16','10:05:00',2.84),('16273','2014-02-16','10:10:00',2.82),('16273','2014-02-16','10:15:00',2.86),('16273','2014-02-16','10:20:00',2.9),('16273','2014-02-16','10:25:00',3.01),('16273','2014-02-16','10:30:00',2.97),('16273','2014-02-16','10:35:00',2.91),('16273','2014-02-16','10:40:00',3.07),('16273','2014-02-16','10:45:00',2.59),('16273','2014-02-16','10:50:00',2.71),('16273','2014-02-16','10:55:00',3.04),('16273','2014-02-16','11:00:00',3.02),('16273','2014-02-16','11:05:00',2.93),('16273','2014-02-16','11:10:00',2.9),('16273','2014-02-16','11:15:00',2.75),('16273','2014-02-16','11:20:00',2.69),('16273','2014-02-16','11:25:00',2.91),('16273','2014-02-16','11:30:00',3.1),('16273','2014-02-16','11:35:00',2.99),('16273','2014-02-16','11:40:00',2.61),('16273','2014-02-16','11:45:00',2.99),('16273','2014-02-16','11:50:00',2.96),('16273','2014-02-16','11:55:00',3.06),('16273','2014-02-16','12:00:00',3.02),('16273','2014-02-16','12:05:00',3.05),('16273','2014-02-16','12:10:00',3.04),('16273','2014-02-16','12:15:00',3.01),('16273','2014-02-16','12:20:00',3),('16273','2014-02-16','12:25:00',3.01),('16273','2014-02-16','12:30:00',2.99),('16273','2014-02-16','12:35:00',3),('16273','2014-02-16','12:40:00',2.95),('16273','2014-02-16','12:45:00',2.94),('16273','2014-02-16','12:50:00',2.9),('16273','2014-02-16','12:55:00',2.85),('16273','2014-02-16','13:00:00',2.86),('16273','2014-02-16','13:05:00',2.76),('16273','2014-02-16','13:10:00',2.85),('16273','2014-02-16','13:15:00',2.8),('16273','2014-02-16','13:20:00',2.77),('16273','2014-02-16','13:25:00',2.73),('16273','2014-02-16','13:30:00',2.72),('16273','2014-02-16','13:35:00',2.7),('16273','2014-02-16','13:40:00',2.68),('16273','2014-02-16','13:45:00',2.52),('16273','2014-02-16','13:50:00',2.51),('16273','2014-02-16','13:55:00',2.49),('16273','2014-02-16','14:00:00',2.47),('16273','2014-02-16','14:05:00',2.42),('16273','2014-02-16','14:10:00',2.36),('16273','2014-02-16','14:15:00',2.28),('16273','2014-02-16','14:20:00',2.27),('16273','2014-02-16','14:25:00',2.21),('16273','2014-02-16','14:30:00',2.13),('16273','2014-02-16','14:35:00',2),('16273','2014-02-16','14:40:00',2.01),('16273','2014-02-16','14:45:00',1.94),('16273','2014-02-16','14:50:00',1.88),('16273','2014-02-16','14:55:00',1.51),('16273','2014-02-16','15:00:00',1.68),('16273','2014-02-16','15:05:00',1.69),('16273','2014-02-16','15:10:00',1.6),('16273','2014-02-16','15:15:00',1.54),('16273','2014-02-16','15:20:00',1.46),('16273','2014-02-16','15:25:00',1.36),('16273','2014-02-16','15:30:00',1.31),('16273','2014-02-16','15:35:00',1.18),('16273','2014-02-16','16:20:00',1.06),('16273','2014-04-28','08:00:00',1.19),('16273','2014-04-28','08:05:00',1.98),('16273','2014-04-28','08:10:00',2.27),('16273','2014-04-28','08:15:00',1.87),('16273','2014-04-28','08:20:00',1.29),('16273','2014-04-28','08:25:00',1.3),('16273','2014-04-28','08:30:00',1.36),('16273','2014-04-28','08:35:00',1.13),('16273','2014-04-28','08:40:00',1.1),('16273','2014-04-28','08:50:00',2.45),('16273','2014-04-28','08:55:00',2.74),('16273','2014-04-28','09:00:00',2.12),('16273','2014-04-28','09:05:00',2.9),('16273','2014-04-28','09:10:00',2.21),('16273','2014-04-28','09:15:00',2.32),('16273','2014-04-28','09:20:00',2.91),('16273','2014-04-28','09:25:00',2.73),('16273','2014-04-28','09:30:00',1.8),('16273','2014-04-28','09:35:00',1.55),('16273','2014-04-28','09:40:00',1.83),('16273','2014-04-28','09:45:00',1.66),('16273','2014-04-28','09:50:00',2),('16273','2014-04-28','09:55:00',1.95),('16273','2014-04-28','10:00:00',1.56),('16273','2014-04-28','10:05:00',1.03),('16273','2014-04-28','10:15:00',1.05),('16273','2014-04-28','10:20:00',1.35),('16273','2014-04-28','10:25:00',1.8),('16273','2014-04-28','10:30:00',1.7),('16273','2014-04-28','10:35:00',1.54),('16273','2014-04-28','10:40:00',1.65),('16273','2014-04-28','10:45:00',2.02),('16273','2014-04-28','10:50:00',2.16),('16273','2014-04-28','10:55:00',1.79),('16273','2014-04-28','11:00:00',2.01),('16273','2014-04-28','11:05:00',1.99),('16273','2014-04-28','11:10:00',1.65),('16273','2014-04-28','11:15:00',1.47),('16273','2014-04-28','11:20:00',1.15),('16273','2014-04-28','11:25:00',1.22),('16273','2014-04-28','11:35:00',1.09),('16273','2014-04-28','11:40:00',1.39),('16273','2014-04-28','11:45:00',1.55),('16273','2014-04-28','11:50:00',1.74),('16273','2014-04-28','11:55:00',1.68),('16273','2014-04-28','12:00:00',1.47),('16273','2014-04-28','12:05:00',1.29),('16273','2014-04-28','12:10:00',2.16),('16273','2014-04-28','12:15:00',2.24),('16273','2014-04-28','12:20:00',2.26),('16273','2014-04-28','12:25:00',2.6),('16273','2014-04-28','12:30:00',2.96),('16273','2014-04-28','12:35:00',2.48),('16273','2014-04-28','12:40:00',2.34),('16273','2014-04-28','12:45:00',2.09),('16273','2014-04-28','12:50:00',2.03),('16273','2014-04-28','12:55:00',1.92),('16273','2014-04-28','13:00:00',2.06),('16273','2014-04-28','13:05:00',2.95),('16273','2014-04-28','13:10:00',4.02),('16273','2014-04-28','13:15:00',4.22),('16273','2014-04-28','13:20:00',3.73),('16273','2014-04-28','13:25:00',4.23),('16273','2014-04-28','13:30:00',4.1),('16273','2014-04-28','13:35:00',2.82),('16273','2014-04-28','13:40:00',2.46),('16273','2014-04-28','13:45:00',2.58),('16273','2014-04-28','13:50:00',3.42),('16273','2014-04-28','13:55:00',3.85),('16273','2014-04-28','14:00:00',2.98),('16273','2014-04-28','14:05:00',4.05),('16273','2014-04-28','14:10:00',2.93),('16273','2014-04-28','14:15:00',3.28),('16273','2014-04-28','14:20:00',4.32),('16273','2014-04-28','14:25:00',3.19),('16273','2014-04-28','14:30:00',2.5),('16273','2014-04-28','14:35:00',1.84),('16273','2014-04-28','14:40:00',2.35),('16273','2014-04-28','14:45:00',3.44),('16273','2014-04-28','14:50:00',2.26),('16273','2014-04-28','14:55:00',2.75),('16273','2014-04-28','15:00:00',2.22),('16273','2014-04-28','15:05:00',2.51),('16273','2014-04-28','15:10:00',2.05),('16273','2014-04-28','15:15:00',1.7),('16273','2014-04-28','15:20:00',1.38),('16273','2014-04-28','15:25:00',1.43),('16273','2014-04-28','15:30:00',1.31),('16273','2014-04-28','15:35:00',2.06),('16273','2014-04-28','15:40:00',2.75),('16273','2014-04-28','15:45:00',3.27),('16273','2014-04-28','15:50:00',2.34),('16273','2014-04-28','15:55:00',1.93),('16273','2014-04-28','16:00:00',2),('16273','2014-04-28','16:05:00',1.91),('16273','2014-04-28','16:10:00',1.7),('16273','2014-04-28','16:15:00',1.55),('16273','2014-04-28','16:20:00',2.04),('16273','2014-04-28','16:25:00',1.07),('16273','2014-04-28','16:45:00',1.76),('16273','2014-04-28','16:50:00',1.1),('16273','2014-04-28','17:05:00',1.33),('16273','2014-04-28','17:15:00',1.16),('16273','2014-04-28','17:20:00',1.31),('16273','2014-04-28','17:25:00',1.42),('16273','2014-02-15','08:10:00',1.07),('16273','2014-02-15','08:15:00',1.21),('16273','2014-02-15','08:20:00',1.26),('16273','2014-02-15','08:25:00',1.34),('16273','2014-02-15','08:30:00',1.58),('16273','2014-02-15','08:35:00',1.68),('16273','2014-02-15','08:40:00',1.77),('16273','2014-02-15','08:45:00',1.82),('16273','2014-02-15','08:50:00',1.75),('16273','2014-02-15','08:55:00',2.01),('16273','2014-02-15','09:00:00',2.07),('16273','2014-02-15','09:05:00',2.13),('16273','2014-02-15','09:10:00',2.18),('16273','2014-02-15','09:15:00',2.23),('16273','2014-02-15','09:20:00',2.31),('16273','2014-02-15','09:25:00',2.34),('16273','2014-02-15','09:30:00',2.38),('16273','2014-02-15','09:35:00',2.41),('16273','2014-02-15','09:40:00',2.43),('16273','2014-02-15','09:45:00',2.5),('16273','2014-02-15','09:50:00',2.52),('16273','2014-02-15','09:55:00',2.55),('16273','2014-02-15','10:00:00',2.56),('16273','2014-02-15','10:05:00',2.6),('16273','2014-02-15','10:10:00',2.63),('16273','2014-02-15','10:15:00',2.67),('16273','2014-02-15','10:20:00',2.69),('16273','2014-02-15','10:25:00',2.7),('16273','2014-02-15','10:30:00',2.76),('16273','2014-02-15','10:35:00',2.79),('16273','2014-02-15','10:40:00',2.84),('16273','2014-02-15','10:45:00',2.86),('16273','2014-02-15','10:50:00',2.85),('16273','2014-02-15','10:55:00',2.87),('16273','2014-02-15','11:00:00',2.9),('16273','2014-02-15','11:05:00',2.93),('16273','2014-02-15','11:10:00',2.92),('16273','2014-02-15','11:15:00',2.99),('16273','2014-02-15','11:20:00',2.98),('16273','2014-02-15','11:25:00',3.03),('16273','2014-02-15','11:30:00',2.72),('16273','2014-02-15','11:35:00',2.98),('16273','2014-02-15','11:40:00',3.33),('16273','2014-02-15','11:45:00',3.16),('16273','2014-02-15','11:50:00',3.13),('16273','2014-02-15','11:55:00',3.23),('16273','2014-02-15','12:00:00',1.09),('16273','2014-02-15','12:05:00',2.95),('16273','2014-02-15','12:15:00',3.41),('16273','2014-02-15','12:20:00',3.36),('16273','2014-02-15','12:25:00',3.2),('16273','2014-02-15','12:30:00',3.15),('16273','2014-02-15','12:35:00',3.13),('16273','2014-02-15','12:40:00',1.82),('16273','2014-02-15','12:45:00',2.85),('16273','2014-02-15','12:50:00',3.07),('16273','2014-02-15','12:55:00',3.07),('16273','2014-02-15','13:00:00',3),('16273','2014-02-15','13:05:00',2.91),('16273','2014-02-15','13:10:00',2.95),('16273','2014-02-15','13:15:00',2.7),('16273','2014-02-15','13:20:00',2.78),('16273','2014-02-15','13:25:00',2.77),('16273','2014-02-15','13:30:00',2.71),('16273','2014-02-15','13:35:00',2.66),('16273','2014-02-15','13:40:00',2.62),('16273','2014-02-15','13:45:00',2.55),('16273','2014-02-15','13:50:00',2.49),('16273','2014-02-15','13:55:00',2.47),('16273','2014-02-15','14:00:00',2.41),('16273','2014-02-15','14:05:00',2.37),('16273','2014-02-15','14:10:00',2.31),('16273','2014-02-15','14:15:00',2.28),('16273','2014-02-15','14:20:00',2.2),('16273','2014-02-15','14:25:00',2.13),('16273','2014-02-15','14:30:00',2.04),('16273','2014-02-15','14:35:00',2.01),('16273','2014-02-15','14:40:00',1.97),('16273','2014-02-15','14:45:00',1.91),('16273','2014-02-15','14:50:00',1.83),('16273','2014-02-15','14:55:00',1.76),('16273','2014-02-15','15:00:00',1.69),('16273','2014-02-15','15:05:00',1.64),('16273','2014-02-15','15:10:00',1.58),('16273','2014-02-15','15:15:00',1.49),('16273','2014-02-15','15:20:00',1.42),('16273','2014-02-15','15:25:00',1.36),('16273','2014-02-15','15:30:00',1.3),('16273','2014-02-15','15:35:00',1.23),('16273','2014-02-15','15:40:00',1.17),('16273','2014-02-15','15:45:00',1.1),('16273','2014-02-15','15:50:00',1.05),('16273','2014-02-15','15:55:00',1),('16273','2014-02-14','08:30:00',1.43),('16273','2014-02-14','08:35:00',1.31),('16273','2014-02-14','08:40:00',1.76),('16273','2014-02-14','08:45:00',1.85),('16273','2014-02-14','08:50:00',1.92),('16273','2014-02-14','08:55:00',1.82),('16273','2014-02-14','09:00:00',1.81),('16273','2014-02-14','09:05:00',2.12),('16273','2014-02-14','09:10:00',2.2),('16273','2014-02-14','09:15:00',2.29),('16273','2014-02-14','09:20:00',2.27),('16273','2014-02-14','09:25:00',2.35),('16273','2014-02-14','09:30:00',2.16),('16273','2014-02-14','09:35:00',2.4),('16273','2014-02-14','09:40:00',2.65),('16273','2014-02-14','09:45:00',2.69),('16273','2014-02-14','09:50:00',2.75),('16273','2014-02-14','09:55:00',2.6),('16273','2014-02-14','10:00:00',2.83),('16273','2014-02-14','10:05:00',2.82),('16273','2014-02-14','10:10:00',2.8),('16273','2014-02-14','10:15:00',2.46),('16273','2014-02-14','10:20:00',3.04),('16273','2014-02-14','10:25:00',2.61),('16273','2014-02-14','10:30:00',2.85),('16273','2014-02-14','10:35:00',2.8),('16273','2014-02-14','10:40:00',3.1),('16273','2014-02-14','10:45:00',3.11),('16273','2014-02-14','10:50:00',3.16),('16273','2014-02-14','10:55:00',3.2),('16273','2014-02-14','11:00:00',3.21),('16273','2014-02-14','11:05:00',3.21),('16273','2014-02-14','11:10:00',3.18),('16273','2014-02-14','11:15:00',3.27),('16273','2014-02-14','11:20:00',3.25),('16273','2014-02-14','11:25:00',3.25),('16273','2014-02-14','11:30:00',3.23),('16273','2014-02-14','11:35:00',3.24),('16273','2014-02-14','11:40:00',3.24),('16273','2014-02-14','11:45:00',3.23),('16273','2014-02-14','11:50:00',3.22),('16273','2014-02-14','11:55:00',3.22),('16273','2014-02-14','12:00:00',3.14),('16273','2014-02-14','12:05:00',3.09),('16273','2014-02-14','12:10:00',3.21),('16273','2014-02-14','12:15:00',3.19),('16273','2014-02-14','12:20:00',3.2),('16273','2014-02-14','12:25:00',3.17),('16273','2014-02-14','12:30:00',3.14),('16273','2014-02-14','12:35:00',3.14),('16273','2014-02-14','12:40:00',3.09),('16273','2014-02-14','12:45:00',3.06),('16273','2014-02-14','12:50:00',3.03),('16273','2014-02-14','12:55:00',2.98),('16273','2014-02-14','13:00:00',2.98),('16273','2014-02-14','13:05:00',2.92),('16273','2014-02-14','13:10:00',2.91),('16273','2014-02-14','13:15:00',2.9),('16273','2014-02-14','13:20:00',2.82),('16273','2014-02-14','13:25:00',2.78),('16273','2014-02-14','13:30:00',2.79),('16273','2014-02-14','13:35:00',2.73),('16273','2014-02-14','13:40:00',2.67),('16273','2014-02-14','13:45:00',2.64),('16273','2014-02-14','13:50:00',2.59),('16273','2014-02-14','13:55:00',2.57),('16273','2014-02-14','14:00:00',2.52),('16273','2014-02-14','14:05:00',2.46),('16273','2014-02-14','14:10:00',2.39),('16273','2014-02-14','14:15:00',2.34),('16273','2014-02-14','14:20:00',2.28),('16273','2014-02-14','14:25:00',2.21),('16273','2014-02-14','14:30:00',2.15),('16273','2014-02-14','14:35:00',2.09),('16273','2014-02-14','14:40:00',2.01),('16273','2014-02-14','14:45:00',1.94),('16273','2014-02-14','14:50:00',1.88),('16273','2014-02-14','14:55:00',1.81),('16273','2014-02-14','15:00:00',1.75),('16273','2014-02-14','15:05:00',1.67),('16273','2014-02-14','15:10:00',1.6),('16273','2014-02-14','15:15:00',1.54),('16273','2014-02-14','15:20:00',1.47),('16273','2014-02-14','15:25:00',1.4),('16273','2014-02-14','15:30:00',1.32),('16273','2014-02-14','15:35:00',1.25),('16273','2014-02-14','15:40:00',1.19),('16273','2014-02-14','15:45:00',1.12),('16273','2014-02-14','15:50:00',1.06),('16273','2014-02-14','15:55:00',1.01),('16273','2014-02-13','08:10:00',1.03),('16273','2014-02-13','08:15:00',1.2),('16273','2014-02-13','08:20:00',1.3),('16273','2014-02-13','08:25:00',1.18),('16273','2014-02-13','08:30:00',1.55),('16273','2014-02-13','08:35:00',1.64),('16273','2014-02-13','08:40:00',1.75),('16273','2014-02-13','08:45:00',1.84),('16273','2014-02-13','08:50:00',1.91),('16273','2014-02-13','08:55:00',1.98),('16273','2014-02-13','09:00:00',2.05),('16273','2014-02-13','09:05:00',2.14),('16273','2014-02-13','09:10:00',2.2),('16273','2014-02-13','09:15:00',2.3),('16273','2014-02-13','09:20:00',2.36),('16273','2014-02-13','09:25:00',2.4),('16273','2014-02-13','09:30:00',2.42),('16273','2014-02-13','09:35:00',2.53),('16273','2014-02-13','09:40:00',2.58),('16273','2014-02-13','09:45:00',2.62),('16273','2014-02-13','09:50:00',2.66),('16273','2014-02-13','09:55:00',2.7),('16273','2014-02-13','10:00:00',2.72),('16273','2014-02-13','10:05:00',2.76),('16273','2014-02-13','10:10:00',2.8),('16273','2014-02-13','10:15:00',2.82),('16273','2014-02-13','10:20:00',2.87),('16273','2014-02-13','10:25:00',2.92),('16273','2014-02-13','10:30:00',2.95),('16273','2014-02-13','10:35:00',2.99),('16273','2014-02-13','10:40:00',3),('16273','2014-02-13','10:45:00',3.01),('16273','2014-02-13','10:50:00',3.04),('16273','2014-02-13','10:55:00',3.04),('16273','2014-02-13','11:00:00',2.89),('16273','2014-02-13','11:05:00',2.1),('16273','2014-02-13','11:10:00',3.26),('16273','2014-02-13','11:15:00',3.26),('16273','2014-02-13','11:20:00',3.38),('16273','2014-02-13','11:25:00',3.31),('16273','2014-02-13','11:30:00',3.43),('16273','2014-02-13','11:35:00',3.06),('16273','2014-02-13','11:40:00',3.31),('16273','2014-02-13','11:45:00',3.15),('16273','2014-02-13','11:50:00',3.17),('16273','2014-02-13','11:55:00',3.22),('16273','2014-02-13','12:00:00',3.27),('16273','2014-02-13','12:05:00',3.42),('16273','2014-02-13','12:10:00',3.47),('16273','2014-02-13','12:15:00',3.38),('16273','2014-02-13','12:20:00',3.29),('16273','2014-02-13','12:25:00',3.06),('16273','2014-02-13','12:30:00',3.2),('16273','2014-02-13','12:35:00',2.18),('16273','2014-02-13','12:40:00',3.11),('16273','2014-02-13','12:45:00',3.21),('16273','2014-02-13','12:50:00',2.17),('16273','2014-02-13','12:55:00',3.17),('16273','2014-02-13','13:00:00',3.05),('16273','2014-02-13','13:05:00',3.01),('16273','2014-02-13','13:10:00',2.96),('16273','2014-02-13','13:15:00',2.92),('16273','2014-02-13','13:20:00',2.88),('16273','2014-02-13','13:25:00',2.84),('16273','2014-02-13','13:30:00',2.81),('16273','2014-02-13','13:35:00',2.76),('16273','2014-02-13','13:40:00',2.7),('16273','2014-02-13','13:45:00',2.67),('16273','2014-02-13','13:50:00',2.61),('16273','2014-02-13','13:55:00',2.57),('16273','2014-02-13','14:00:00',2.52),('16273','2014-02-13','14:05:00',2.48),('16273','2014-02-13','14:10:00',2.41),('16273','2014-02-13','14:15:00',2.32),('16273','2014-02-13','14:20:00',2.3),('16273','2014-02-13','14:25:00',2.26),('16273','2014-02-13','14:30:00',2.32),('16273','2014-02-13','14:35:00',2.31),('16273','2014-02-13','14:40:00',2.27),('16273','2014-02-13','14:45:00',1.86),('16273','2014-02-13','14:50:00',1.1),('16273','2014-02-13','14:55:00',1.71),('16273','2014-02-13','15:00:00',1.94),('16273','2014-02-13','15:05:00',1.83),('16273','2014-02-13','15:10:00',1.73),('16273','2014-02-13','15:15:00',1.65),('16273','2014-02-13','15:20:00',1.36),('16273','2014-02-13','15:25:00',1.4),('16273','2014-02-13','15:30:00',1.41),('16273','2014-02-13','15:35:00',1.26),('16273','2014-02-13','15:40:00',1.32),('16273','2014-02-13','15:50:00',1.15),('16273','2014-02-13','15:55:00',1.07),('16273','2014-02-13','16:00:00',1.01),('16273','2014-02-12','08:35:00',1.63),('16273','2014-02-12','08:40:00',1.78),('16273','2014-02-12','08:45:00',1.86),('16273','2014-02-12','08:50:00',1.95),('16273','2014-02-12','08:55:00',2.03),('16273','2014-02-12','09:00:00',2.11),('16273','2014-02-12','09:05:00',2.13),('16273','2014-02-12','09:10:00',2.28),('16273','2014-02-12','09:15:00',2.37),('16273','2014-02-12','09:20:00',2.49),('16273','2014-02-12','09:25:00',1.99),('16273','2014-02-12','09:30:00',1.25),('16273','2014-02-12','09:35:00',1.66),('16273','2014-02-12','09:40:00',1.65),('16273','2014-02-12','09:45:00',1.05),('16273','2014-02-12','09:50:00',2.1),('16273','2014-02-12','09:55:00',2.95),('16273','2014-02-12','10:00:00',1.56),('16273','2014-02-12','10:05:00',1.24),('16273','2014-02-12','10:10:00',1.12),('16273','2014-02-12','10:15:00',1.06),('16273','2014-02-12','10:20:00',1.1),('16273','2014-02-12','10:25:00',1.03),('16273','2014-02-12','10:30:00',1.2),('16273','2014-02-12','10:35:00',1.15),('16273','2014-02-12','10:40:00',1.15),('16273','2014-02-12','10:45:00',1.03),('16273','2014-02-12','11:00:00',1.02),('16273','2014-02-12','11:05:00',1.16),('16273','2014-02-12','11:10:00',2.92),('16273','2014-02-12','11:15:00',2.39),('16273','2014-02-12','11:20:00',1.1),('16273','2014-02-12','11:25:00',1.19),('16273','2014-02-12','11:30:00',1.78),('16273','2014-02-12','11:35:00',3.2),('16273','2014-02-12','11:40:00',3.53),('16273','2014-02-12','11:45:00',1.83),('16273','2014-02-12','11:50:00',1.48),('16273','2014-02-12','11:55:00',1.51),('16273','2014-02-12','12:00:00',1.34),('16273','2014-02-12','12:10:00',1.11),('16273','2014-02-12','12:15:00',1.22),('16273','2014-02-12','12:20:00',1.23),('16273','2014-02-12','12:25:00',1.27),('16273','2014-02-12','12:30:00',1.3),('16273','2014-02-12','12:35:00',1.37),('16273','2014-02-12','12:40:00',1.46),('16273','2014-02-12','12:45:00',1.56),('16273','2014-02-12','12:50:00',1.5),('16273','2014-02-12','12:55:00',1.51),('16273','2014-02-12','13:00:00',1.62),('16273','2014-02-12','13:05:00',1.56),('16273','2014-02-12','13:10:00',1.71),('16273','2014-02-12','13:15:00',1.55),('16273','2014-02-12','13:20:00',1.59),('16273','2014-02-12','13:25:00',1.91),('16273','2014-02-12','13:30:00',1.37),('16273','2014-02-12','13:35:00',1.28),('16273','2014-02-12','13:40:00',1.3),('16273','2014-02-12','13:45:00',1.3),('16273','2014-02-12','13:50:00',1.36),('16273','2014-02-12','13:55:00',1.76),('16273','2014-02-12','14:00:00',2.01),('16273','2014-02-12','14:05:00',2.32),('16273','2014-02-12','14:10:00',1.69),('16273','2014-02-12','14:15:00',1.47),('16273','2014-02-12','14:20:00',1.89),('16273','2014-02-12','14:25:00',2.6),('16273','2014-02-12','14:30:00',2.53),('16273','2014-02-12','14:35:00',2.28),('16273','2014-02-12','14:40:00',2.14),('16273','2014-02-12','14:45:00',2.03),('16273','2014-02-12','14:50:00',1.95),('16273','2014-02-12','14:55:00',1.91),('16273','2014-02-12','15:00:00',1.9),('16273','2014-02-12','15:05:00',1.91),('16273','2014-02-12','15:10:00',1.53),('16273','2014-02-12','15:15:00',1.13),('16273','2014-02-12','15:20:00',1.4),('16273','2014-02-12','15:25:00',1.49),('16273','2014-02-12','15:30:00',1.83),('16273','2014-02-12','15:35:00',1.64),('16273','2014-02-12','15:40:00',1.31),('16273','2014-02-12','15:45:00',1.52),('16273','2014-02-12','15:50:00',1.42),('16273','2014-02-12','16:10:00',1.22),('16273','2014-02-11','09:25:00',1.22),('16273','2014-02-11','09:30:00',1.17),('16273','2014-02-11','09:40:00',1.09),('16273','2014-02-11','09:45:00',1.26),('16273','2014-02-11','09:50:00',1.26),('16273','2014-02-11','09:55:00',1.02),('16273','2014-02-11','10:15:00',1.52),('16273','2014-02-11','10:20:00',1.66),('16273','2014-02-11','10:25:00',1.98),('16273','2014-02-11','10:30:00',1.85),('16273','2014-02-11','10:35:00',1.89),('16273','2014-02-11','10:40:00',1.77),('16273','2014-02-11','10:45:00',1.68),('16273','2014-02-11','10:50:00',1.93),('16273','2014-02-11','10:55:00',1.76),('16273','2014-02-11','11:00:00',1.82),('16273','2014-02-11','11:05:00',2.36),('16273','2014-02-11','11:10:00',2.09),('16273','2014-02-11','11:15:00',2.19),('16273','2014-02-11','11:20:00',1.83),('16273','2014-02-11','11:25:00',1.55),('16273','2014-02-11','11:30:00',1.84),('16273','2014-02-11','11:35:00',2.41),('16273','2014-02-11','11:40:00',2.37),('16273','2014-02-11','11:45:00',2.45),('16273','2014-02-11','11:50:00',2.31),('16273','2014-02-11','11:55:00',1.52),('16273','2014-02-11','12:00:00',1.43),('16273','2014-02-11','12:05:00',1.75),('16273','2014-02-11','12:10:00',2.22),('16273','2014-02-11','12:15:00',1.58),('16273','2014-02-11','12:20:00',1.26),('16273','2014-02-11','12:25:00',1.79),('16273','2014-02-11','12:30:00',1.97),('16273','2014-02-11','12:35:00',2.12),('16273','2014-02-11','12:40:00',1.42),('16273','2014-02-11','12:45:00',1.82),('16273','2014-02-11','12:50:00',2.05),('16273','2014-02-11','12:55:00',1.66),('16273','2014-02-11','13:00:00',2.32),('16273','2014-02-11','13:05:00',1.78),('16273','2014-02-11','13:10:00',2.87),('16273','2014-02-11','13:15:00',2.86),('16273','2014-02-11','13:20:00',2.65),('16273','2014-02-11','13:25:00',2.32),('16273','2014-02-11','13:30:00',2.21),('16273','2014-02-11','13:35:00',2.26),('16273','2014-02-11','13:40:00',2.32),('16273','2014-02-11','13:45:00',1.69),('16273','2014-02-11','13:50:00',1.81),('16273','2014-02-11','13:55:00',1.62),('16273','2014-02-11','14:00:00',1.09),('16273','2014-02-11','14:05:00',1.24),('16273','2014-02-11','14:10:00',1.52),('16273','2014-02-11','14:15:00',1.26),('16273','2014-02-11','14:20:00',1.3),('16273','2014-02-11','14:25:00',1.31),('16273','2014-02-11','14:30:00',1.14),('16273','2014-02-11','14:35:00',1.1),('16273','2014-02-11','15:05:00',1.04),('16273','2014-02-11','15:10:00',1.13),('16273','2014-02-11','15:15:00',1.21),('16273','2014-02-11','15:20:00',1.23),('16273','2014-02-10','12:55:00',1.01),('16273','2014-02-10','13:00:00',1.01),('16273','2014-02-09','12:05:00',2.66),('16273','2014-02-09','12:10:00',1.1),('16273','2014-02-09','12:15:00',1.21),('16273','2014-02-09','12:20:00',1.78),('16273','2014-02-09','12:25:00',2.78),('16273','2014-02-09','12:35:00',1.33),('16273','2014-02-09','12:40:00',1.53),('16273','2014-02-09','12:50:00',1.36),('16273','2014-02-09','12:55:00',2.4),('16273','2014-02-09','13:00:00',1.17),('16273','2014-02-09','13:05:00',1.06),('16273','2014-02-09','13:10:00',1.18),('16273','2014-02-09','13:15:00',1.44),('16273','2014-02-09','13:20:00',1.15),('16273','2014-02-09','13:30:00',1.1),('16273','2014-02-09','13:35:00',1.67),('16273','2014-02-09','13:40:00',2.7),('16273','2014-02-09','13:45:00',1.12),('16273','2014-02-09','13:50:00',2.39),('16273','2014-02-09','13:55:00',2.17),('16273','2014-02-09','14:00:00',2.02),('16273','2014-02-09','14:05:00',1.43),('16273','2014-02-09','14:10:00',1.12),('16273','2014-02-09','14:15:00',1.09),('16273','2014-02-09','14:20:00',1.49),('16273','2014-02-09','14:25:00',2.14),('16273','2014-02-09','14:30:00',1.86),('16273','2014-02-09','14:35:00',1.28),('16273','2014-02-09','14:40:00',1.36),('16273','2014-02-09','14:45:00',1.26),('16273','2014-02-09','14:50:00',1.44),('16273','2014-02-09','14:55:00',1.69),('16273','2014-02-09','15:00:00',1.53),('16273','2014-02-09','15:05:00',1.4),('16273','2014-02-09','15:10:00',1.25),('16273','2014-02-09','15:15:00',1.02),('16273','2014-02-09','15:20:00',1.08),('16273','2014-02-09','15:25:00',1.35),('16273','2014-02-09','15:30:00',1.23),('16273','2014-02-09','15:35:00',1.2),('16273','2014-02-09','15:40:00',1.09),('16273','2014-02-09','15:45:00',1.04),('16273','2014-02-08','09:35:00',1.2),('16273','2014-02-08','09:40:00',1.31),('16273','2014-02-08','09:45:00',1.29),('16273','2014-02-08','09:50:00',2.04),('16273','2014-02-08','09:55:00',2.42),('16273','2014-02-08','10:00:00',2.61),('16273','2014-02-08','10:05:00',2.73),('16273','2014-02-08','10:10:00',2.63),('16273','2014-02-08','10:15:00',2.27),('16273','2014-02-08','10:20:00',2.48),('16273','2014-02-08','10:25:00',1.85),('16273','2014-02-08','10:35:00',1.11),('16273','2014-02-08','10:40:00',1.57),('16273','2014-02-08','10:45:00',1.06),('16273','2014-02-08','10:50:00',1.78),('16273','2014-02-08','10:55:00',2.17),('16273','2014-02-08','11:00:00',1.66),('16273','2014-02-08','11:05:00',1.1),('16273','2014-02-08','11:10:00',3.62),('16273','2014-02-08','11:15:00',1.53),('16273','2014-02-08','11:30:00',1.27),('16273','2014-02-08','11:35:00',1.19),('16273','2014-02-08','11:50:00',2.89),('16273','2014-02-08','11:55:00',1.4),('16273','2014-02-08','12:00:00',1.08),('16273','2014-02-08','12:05:00',1.18),('16273','2014-02-08','12:10:00',1.34),('16273','2014-02-08','12:15:00',1.69),('16273','2014-02-08','12:20:00',1.05),('16273','2014-02-08','12:25:00',1.68),('16273','2014-02-08','12:30:00',2.13),('16273','2014-02-08','12:35:00',1.82),('16273','2014-02-08','12:40:00',2.14),('16273','2014-02-08','12:45:00',3.41),('16273','2014-02-08','12:50:00',2.47),('16273','2014-02-08','12:55:00',3.11),('16273','2014-02-08','13:00:00',2.99),('16273','2014-02-08','13:05:00',2.26),('16273','2014-02-08','13:10:00',2.71),('16273','2014-02-08','13:15:00',2.26),('16273','2014-02-08','13:20:00',1.99),('16273','2014-02-08','13:25:00',2.35),('16273','2014-02-08','13:30:00',2.3),('16273','2014-02-08','13:35:00',1.96),('16273','2014-02-08','13:40:00',1.85),('16273','2014-02-08','13:45:00',2.53),('16273','2014-02-08','13:50:00',2.52),('16273','2014-02-08','13:55:00',2.12),('16273','2014-02-08','14:00:00',2.6),('16273','2014-02-08','14:05:00',2.65),('16273','2014-02-08','14:10:00',2.6),('16273','2014-02-08','14:15:00',2.46),('16273','2014-02-08','14:20:00',2.46),('16273','2014-02-08','14:25:00',1.8),('16273','2014-02-08','14:30:00',1.13),('16273','2014-02-08','14:35:00',1.87),('16273','2014-02-08','14:40:00',1.08),('16273','2014-02-08','14:45:00',2.3),('16273','2014-02-08','14:50:00',2.16),('16273','2014-02-08','14:55:00',2.09),('16273','2014-02-08','15:00:00',1.99),('16273','2014-02-08','15:05:00',1.49),('16273','2014-02-08','15:10:00',1.89),('16273','2014-02-08','15:15:00',1.34),('16273','2014-02-08','15:30:00',1.23),('16273','2014-02-08','15:35:00',1.57),('16273','2014-02-08','15:40:00',1.16),('16273','2014-02-08','15:45:00',1.24),('16273','2014-02-07','08:15:00',1.01),('16273','2014-02-07','08:20:00',1.04),('16273','2014-02-07','08:25:00',1.22),('16273','2014-02-07','08:30:00',1.21),('16273','2014-02-07','08:35:00',1.36),('16273','2014-02-07','08:40:00',1.59),('16273','2014-02-07','08:45:00',1.7),('16273','2014-02-07','08:50:00',1.79),('16273','2014-02-07','08:55:00',1.86),('16273','2014-02-07','09:00:00',1.93),('16273','2014-02-07','09:05:00',2.02),('16273','2014-02-07','09:10:00',2.06),('16273','2014-02-07','09:15:00',2.12),('16273','2014-02-07','09:20:00',2.18),('16273','2014-02-07','09:25:00',2.24),('16273','2014-02-07','09:30:00',2.28),('16273','2014-02-07','09:35:00',2.29),('16273','2014-02-07','09:40:00',2.34),('16273','2014-02-07','09:45:00',2.36),('16273','2014-02-07','09:50:00',2.2),('16273','2014-02-07','09:55:00',2.3),('16273','2014-02-07','10:00:00',2.4),('16273','2014-02-07','10:05:00',2.68),('16273','2014-02-07','10:10:00',2.81),('16273','2014-02-07','10:15:00',2.84),('16273','2014-02-07','10:20:00',2.8),('16273','2014-02-07','10:25:00',1.91),('16273','2014-02-07','10:30:00',2.98),('16273','2014-02-07','10:35:00',2.98),('16273','2014-02-07','10:40:00',3.03),('16273','2014-02-07','10:45:00',3.15),('16273','2014-02-07','10:50:00',2.66),('16273','2014-02-07','10:55:00',3.12),('16273','2014-02-07','11:00:00',1.89),('16273','2014-02-07','11:05:00',1.37),('16273','2014-02-07','11:10:00',1.59),('16273','2014-02-07','11:15:00',2.38),('16273','2014-02-07','11:20:00',3.08),('16273','2014-02-07','11:25:00',2.44),('16273','2014-02-07','11:30:00',2.78),('16273','2014-02-07','11:35:00',1.91),('16273','2014-02-07','11:40:00',2.92),('16273','2014-02-07','11:45:00',1.82),('16273','2014-02-07','11:50:00',1.59),('16273','2014-02-07','11:55:00',3.56),('16273','2014-02-07','12:00:00',3.44),('16273','2014-02-07','12:05:00',1.12),('16273','2014-02-07','12:10:00',2.03),('16273','2014-02-07','12:15:00',1.56),('16273','2014-02-07','12:20:00',2.83),('16273','2014-02-07','12:25:00',3.24),('16273','2014-02-07','12:30:00',3.34),('16273','2014-02-07','12:35:00',1.08),('16273','2014-02-07','12:40:00',1.15),('16273','2014-02-07','12:45:00',3.32),('16273','2014-02-07','12:50:00',2.63),('16273','2014-02-07','12:55:00',3.33),('16273','2014-02-07','13:00:00',2.26),('16273','2014-02-07','13:05:00',3.3),('16273','2014-02-07','13:10:00',3.03),('16273','2014-02-07','13:15:00',1.76),('16273','2014-02-07','13:20:00',3.19),('16273','2014-02-07','13:25:00',2.87),('16273','2014-02-07','13:30:00',2.76),('16273','2014-02-07','13:35:00',2.69),('16273','2014-02-07','13:40:00',2.43),('16273','2014-02-07','13:45:00',2.6),('16273','2014-02-07','13:50:00',2.53),('16273','2014-02-07','13:55:00',2.48),('16273','2014-02-07','14:00:00',2.41),('16273','2014-02-07','14:05:00',2.38),('16273','2014-02-07','14:10:00',2.33),('16273','2014-02-07','14:15:00',2.26),('16273','2014-02-07','14:20:00',2.19),('16273','2014-02-07','14:25:00',2.13),('16273','2014-02-07','14:30:00',2.07),('16273','2014-02-07','14:35:00',1.7),('16273','2014-02-07','14:40:00',1.74),('16273','2014-02-07','14:45:00',1.9),('16273','2014-02-07','14:50:00',1.89),('16273','2014-02-07','14:55:00',1.48),('16273','2014-02-07','15:00:00',1.73),('16273','2014-02-07','15:05:00',1.68),('16273','2014-02-07','15:10:00',1.53),('16273','2014-02-07','15:15:00',1.44),('16273','2014-02-07','15:20:00',1.36),('16273','2014-02-07','15:25:00',1.29),('16273','2014-02-07','15:30:00',1.22),('16273','2014-02-07','15:35:00',1.16),('16273','2014-02-07','15:40:00',1.09),('16273','2014-02-07','15:45:00',1.04),('16273','2014-02-06','08:30:00',1.18),('16273','2014-02-06','08:35:00',1.16),('16273','2014-02-06','08:40:00',1.58),('16273','2014-02-06','08:45:00',1.71),('16273','2014-02-06','08:50:00',1.84),('16273','2014-02-06','08:55:00',2.01),('16273','2014-02-06','09:00:00',2.16),('16273','2014-02-06','09:05:00',2.3),('16273','2014-02-06','09:10:00',2.16),('16273','2014-02-06','09:15:00',2.02),('16273','2014-02-06','09:20:00',2.27),('16273','2014-02-06','09:25:00',2.35),('16273','2014-02-06','09:30:00',2.11),('16273','2014-02-06','09:35:00',2.37),('16273','2014-02-06','09:40:00',2.44),('16273','2014-02-06','09:45:00',2.46),('16273','2014-02-06','09:50:00',2.52),('16273','2014-02-06','09:55:00',2.6),('16273','2014-02-06','10:00:00',2.69),('16273','2014-02-06','10:05:00',2.69),('16273','2014-02-06','10:10:00',2.68),('16273','2014-02-06','10:15:00',2.72),('16273','2014-02-06','10:20:00',2.79),('16273','2014-02-06','10:25:00',2.84),('16273','2014-02-06','10:30:00',2.6),('16273','2014-02-06','10:35:00',2.76),('16273','2014-02-06','10:40:00',2.45),('16273','2014-02-06','10:45:00',2.44),('16273','2014-02-06','10:50:00',2.71),('16273','2014-02-06','10:55:00',1.67),('16273','2014-02-06','11:00:00',2.34),('16273','2014-02-06','11:05:00',3.15),('16273','2014-02-06','11:10:00',3.15),('16273','2014-02-06','11:15:00',3.17),('16273','2014-02-06','11:20:00',3.2),('16273','2014-02-06','11:25:00',3.32),('16273','2014-02-06','11:30:00',3.27),('16273','2014-02-06','11:35:00',3.14),('16273','2014-02-06','11:40:00',3.14),('16273','2014-02-06','11:45:00',3.12),('16273','2014-02-06','11:50:00',3.15),('16273','2014-02-06','11:55:00',3.12),('16273','2014-02-06','12:00:00',3.11),('16273','2014-02-06','12:05:00',3.13),('16273','2014-02-06','12:10:00',3.13),('16273','2014-02-06','12:15:00',3.1),('16273','2014-02-06','12:20:00',3.09),('16273','2014-02-06','12:25:00',3.07),('16273','2014-02-06','12:30:00',3.05),('16273','2014-02-06','12:35:00',3.03),('16273','2014-02-06','12:40:00',3.01),('16273','2014-02-06','12:45:00',2.99),('16273','2014-02-06','12:50:00',2.96),('16273','2014-02-06','12:55:00',2.93),('16273','2014-02-06','13:00:00',2.9),('16273','2014-02-06','13:05:00',2.86),('16273','2014-02-06','13:10:00',2.79),('16273','2014-02-06','13:15:00',2.82),('16273','2014-02-06','13:20:00',2.85),('16273','2014-02-06','13:25:00',2.77),('16273','2014-02-06','13:30:00',2.69),('16273','2014-02-06','13:35:00',2.67),('16273','2014-02-06','13:40:00',2.6),('16273','2014-02-06','13:45:00',2.45),('16273','2014-02-06','13:50:00',2.52),('16273','2014-02-06','13:55:00',1.77),('16273','2014-02-06','14:00:00',2.42),('16273','2014-02-06','14:05:00',2.27),('16273','2014-02-06','14:10:00',1.45),('16273','2014-02-06','14:15:00',1.99),('16273','2014-02-06','14:20:00',2.17),('16273','2014-02-06','14:25:00',2.09),('16273','2014-02-06','14:30:00',2.04),('16273','2014-02-06','14:35:00',1.96),('16273','2014-02-06','14:40:00',1.88),('16273','2014-02-06','14:45:00',1.8),('16273','2014-02-06','14:50:00',1.74),('16273','2014-02-06','14:55:00',1.67),('16273','2014-02-06','15:00:00',1.61),('16273','2014-02-06','15:05:00',1.53),('16273','2014-02-06','15:10:00',1.47),('16273','2014-02-06','15:15:00',1.4),('16273','2014-02-06','15:20:00',1.33),('16273','2014-02-06','15:25:00',1.26),('16273','2014-02-06','15:30:00',1.2),('16273','2014-02-06','15:35:00',1.14),('16273','2014-02-06','15:40:00',1.07),('16273','2014-02-06','15:45:00',1.03),('16273','2014-04-27','08:30:00',1.03),('16273','2014-04-27','10:00:00',1.03),('16273','2014-04-27','10:05:00',1.2),('16273','2014-04-27','10:10:00',1.11),('16273','2014-04-27','10:30:00',1.74),('16273','2014-04-27','10:35:00',1.88),('16273','2014-04-27','10:45:00',1.14),('16273','2014-04-27','10:50:00',1.52),('16273','2014-04-27','10:55:00',1.26),('16273','2014-04-27','11:00:00',1.42),('16273','2014-04-27','11:05:00',1.45),('16273','2014-04-27','11:10:00',1.1),('16273','2014-04-27','11:15:00',1.27),('16273','2014-04-27','11:20:00',1.74),('16273','2014-04-27','11:25:00',2),('16273','2014-04-27','11:30:00',1.96),('16273','2014-04-27','11:35:00',2.45),('16273','2014-04-27','11:40:00',1.94),('16273','2014-04-27','11:45:00',2.46),('16273','2014-04-27','11:50:00',1.95),('16273','2014-04-27','11:55:00',1.37),('16273','2014-04-27','12:00:00',1.79),('16273','2014-04-27','12:05:00',1.42),('16273','2014-04-27','12:10:00',1.58),('16273','2014-04-27','12:15:00',1.58),('16273','2014-04-27','12:20:00',2.42),('16273','2014-04-27','12:25:00',3.63),('16273','2014-04-27','12:30:00',2.86),('16273','2014-04-27','12:35:00',2.87),('16273','2014-04-27','12:40:00',2.88),('16273','2014-04-27','12:45:00',2.22),('16273','2014-04-27','12:50:00',2.4),('16273','2014-04-27','12:55:00',1.99),('16273','2014-04-27','13:00:00',1.93),('16273','2014-04-27','13:05:00',2.27),('16273','2014-04-27','13:10:00',2.3),('16273','2014-04-27','13:15:00',2.13),('16273','2014-04-27','13:20:00',2.22),('16273','2014-04-27','13:25:00',1.81),('16273','2014-04-27','13:30:00',1.32),('16273','2014-04-27','13:35:00',1.23),('16273','2014-04-27','13:40:00',1.41),('16273','2014-04-27','13:45:00',1.72),('16273','2014-04-27','13:50:00',1.81),('16273','2014-04-27','13:55:00',2.42),('16273','2014-04-27','14:00:00',1.78),('16273','2014-04-27','14:05:00',1.32),('16273','2014-04-27','14:10:00',1.26),('16273','2014-04-27','14:15:00',1.65),('16273','2014-04-27','14:20:00',1.78),('16273','2014-04-27','14:25:00',1.59),('16273','2014-04-27','14:30:00',1.9),('16273','2014-04-27','14:35:00',2.1),('16273','2014-04-27','14:40:00',2.24),('16273','2014-04-27','14:45:00',1.68),('16273','2014-04-27','14:50:00',1.67),('16273','2014-04-27','14:55:00',1.99),('16273','2014-04-27','15:00:00',2.28),('16273','2014-04-27','15:05:00',2.18),('16273','2014-04-27','15:10:00',2.11),('16273','2014-04-27','15:15:00',1.6),('16273','2014-04-27','15:20:00',1.03),('16273','2014-04-27','15:30:00',1.08),('16273','2014-04-27','15:35:00',1.07),('16273','2014-02-05','10:10:00',1.59),('16273','2014-02-05','10:15:00',1.47),('16273','2014-02-05','10:20:00',1.36),('16273','2014-02-05','10:25:00',1.48),('16273','2014-02-05','10:30:00',2.09),('16273','2014-02-05','10:35:00',2.99),('16273','2014-02-05','10:40:00',2.94),('16273','2014-02-05','10:45:00',2.46),('16273','2014-02-05','10:55:00',1.34),('16273','2014-02-05','11:00:00',1.49),('16273','2014-02-05','11:05:00',3.03),('16273','2014-02-05','11:10:00',2.5),('16273','2014-02-05','12:30:00',1.04),('16273','2014-02-05','12:35:00',1.08),('16273','2014-02-05','12:40:00',1.96),('16273','2014-02-05','12:45:00',1.85),('16273','2014-02-05','12:50:00',1.97),('16273','2014-02-05','12:55:00',2.34),('16273','2014-02-05','13:00:00',1.95),('16273','2014-02-05','13:05:00',1.43),('16273','2014-02-05','13:25:00',1.02),('16273','2014-02-05','13:30:00',1.12),('16273','2014-02-05','13:35:00',1.42),('16273','2014-02-05','13:40:00',1.54),('16273','2014-02-05','13:45:00',1.5),('16273','2014-02-05','13:50:00',1.02),('16273','2014-02-05','14:10:00',1.11),('16273','2014-02-05','14:15:00',1.6),('16273','2014-02-05','14:20:00',1.97),('16273','2014-02-05','14:25:00',1.87),('16273','2014-02-05','14:30:00',1.08),('16273','2014-02-05','14:35:00',1.24),('16273','2014-02-05','14:40:00',1.19),('16273','2014-02-05','14:45:00',1.05),('16273','2014-02-04','09:20:00',1.14),('16273','2014-02-04','09:25:00',1.42),('16273','2014-02-04','09:30:00',2.07),('16273','2014-02-04','09:35:00',2.04),('16273','2014-02-04','09:40:00',1.72),('16273','2014-02-04','09:45:00',2.09),('16273','2014-02-04','09:50:00',1.47),('16273','2014-02-04','09:55:00',2.39),('16273','2014-02-04','10:00:00',2.72),('16273','2014-02-04','10:05:00',2.83),('16273','2014-02-04','10:10:00',2.32),('16273','2014-02-04','10:15:00',1.09),('16273','2014-02-04','10:20:00',2.01),('16273','2014-02-04','10:25:00',3.07),('16273','2014-02-04','10:30:00',2.75),('16273','2014-02-04','10:35:00',2.61),('16273','2014-02-04','10:40:00',2.98),('16273','2014-02-04','10:45:00',2.76),('16273','2014-02-04','10:50:00',1.49),('16273','2014-02-04','10:55:00',1.51),('16273','2014-02-04','11:00:00',1.12),('16273','2014-02-04','11:05:00',1.96),('16273','2014-02-04','11:10:00',2.21),('16273','2014-02-04','11:15:00',3.84),('16273','2014-02-04','11:20:00',2.02),('16273','2014-02-04','11:25:00',2.1),('16273','2014-02-04','11:30:00',1.32),('16273','2014-02-04','11:35:00',1.1),('16273','2014-02-04','11:40:00',1.18),('16273','2014-02-04','11:45:00',1.08),('16273','2014-02-04','11:50:00',2.11),('16273','2014-02-04','11:55:00',1.24),('16273','2014-02-04','12:00:00',1.41),('16273','2014-02-04','12:30:00',1.09),('16273','2014-02-04','12:35:00',1.06),('16273','2014-02-04','12:40:00',1.13),('16273','2014-02-04','12:45:00',1.45),('16273','2014-02-04','12:50:00',1.49),('16273','2014-02-04','12:55:00',1.37),('16273','2014-02-04','13:00:00',1.46),('16273','2014-02-04','13:05:00',1.48),('16273','2014-02-04','13:10:00',1.18),('16273','2014-02-04','13:15:00',1.1),('16273','2014-02-04','13:20:00',1.02),('16273','2014-02-03','09:55:00',1.06),('16273','2014-02-03','10:15:00',1.16),('16273','2014-02-03','10:20:00',1.61),('16273','2014-02-03','10:25:00',1.24),('16273','2014-02-03','10:40:00',1.03),('16273','2014-02-03','10:45:00',1.03),('16273','2014-02-01','11:00:00',1.19),('16273','2014-02-01','11:05:00',1.24),('16273','2014-02-01','11:10:00',1.41),('16273','2014-02-01','11:15:00',1.92),('16273','2014-02-01','11:20:00',2.03),('16273','2014-02-01','11:25:00',2),('16273','2014-02-01','11:30:00',1.95),('16273','2014-02-01','11:35:00',2.12),('16273','2014-02-01','11:40:00',2.1),('16273','2014-02-01','11:45:00',1.9),('16273','2014-02-01','11:50:00',1.64),('16273','2014-02-01','11:55:00',1.66),('16273','2014-02-01','12:00:00',1.65),('16273','2014-02-01','12:05:00',1.7),('16273','2014-02-01','12:10:00',1.94),('16273','2014-02-01','12:15:00',1.12),('16273','2014-02-01','12:30:00',1.17),('16273','2014-02-01','12:35:00',2.35),('16273','2014-02-01','12:40:00',1.55),('16273','2014-02-01','12:45:00',2.04),('16273','2014-02-01','12:50:00',1.94),('16273','2014-02-01','13:35:00',1.01),('16273','2014-01-31','10:30:00',1.23),('16273','2014-01-30','09:50:00',1.28),('16273','2014-01-30','09:55:00',1.72),('16273','2014-01-30','10:00:00',1.73),('16273','2014-01-30','10:05:00',1.73),('16273','2014-01-30','10:10:00',1.62),('16273','2014-01-30','10:15:00',1.29),('16273','2014-01-30','10:20:00',1.17),('16273','2014-01-30','10:25:00',1.57),('16273','2014-01-30','10:30:00',1.76),('16273','2014-01-30','10:35:00',2.54),('16273','2014-01-30','10:40:00',1.78),('16273','2014-01-30','10:45:00',2.47),('16273','2014-01-30','10:50:00',1.89),('16273','2014-01-30','10:55:00',1.43),('16273','2014-01-30','11:00:00',1.97),('16273','2014-01-30','11:05:00',3.05),('16273','2014-01-30','11:10:00',3.36),('16273','2014-01-30','11:15:00',3.23),('16273','2014-01-30','11:20:00',3.19),('16273','2014-01-30','11:25:00',2.94),('16273','2014-01-30','11:30:00',2.33),('16273','2014-01-30','11:35:00',2.23),('16273','2014-01-30','11:40:00',2.96),('16273','2014-01-30','11:45:00',3.01),('16273','2014-01-30','11:50:00',2.88),('16273','2014-01-30','11:55:00',2.79),('16273','2014-01-30','12:00:00',2.79),('16273','2014-01-30','12:05:00',2.61),('16273','2014-01-30','12:10:00',2.32),('16273','2014-01-30','12:15:00',2.47),('16273','2014-01-30','12:20:00',2.36),('16273','2014-01-30','12:25:00',2.29),('16273','2014-01-30','12:30:00',2.54),('16273','2014-01-30','12:35:00',2.8),('16273','2014-01-30','12:40:00',2.66),('16273','2014-01-30','12:45:00',2.67),('16273','2014-01-30','12:50:00',2.69),('16273','2014-01-30','12:55:00',2.61),('16273','2014-01-30','13:00:00',2.5),('16273','2014-01-30','13:05:00',2.61),('16273','2014-01-30','13:10:00',2.62),('16273','2014-01-30','13:15:00',2.58),('16273','2014-01-30','13:20:00',2.44),('16273','2014-01-30','13:25:00',1.95),('16273','2014-01-30','13:30:00',1.86),('16273','2014-01-30','13:35:00',1.79),('16273','2014-01-30','13:40:00',2.31),('16273','2014-01-30','13:45:00',2.55),('16273','2014-01-30','13:50:00',2.39),('16273','2014-01-30','13:55:00',1.98),('16273','2014-01-30','14:00:00',1.7),('16273','2014-01-30','14:05:00',1.76),('16273','2014-01-30','14:10:00',1.8),('16273','2014-01-30','14:15:00',1.48),('16273','2014-01-30','14:20:00',1.33),('16273','2014-01-30','14:25:00',1.44),('16273','2014-01-30','14:30:00',1.53),('16273','2014-01-30','14:35:00',1.25),('16273','2014-01-30','14:40:00',1.68),('16273','2014-01-30','14:45:00',1.83),('16273','2014-01-30','14:50:00',1.71),('16273','2014-01-30','14:55:00',1.59),('16273','2014-01-30','15:00:00',1.41),('16273','2014-01-30','15:05:00',1.34),('16273','2014-01-30','15:10:00',1.34),('16273','2014-01-30','15:15:00',1.32),('16273','2014-01-30','15:20:00',1.31),('16273','2014-01-30','15:25:00',1.19),('16273','2014-01-30','15:30:00',1.12),('16273','2014-01-30','15:35:00',1.07),('16273','2014-01-29','09:15:00',2.19),('16273','2014-01-29','09:20:00',1.57),('16273','2014-01-29','09:25:00',1.29),('16273','2014-01-29','09:30:00',1.37),('16273','2014-01-29','09:35:00',1.38),('16273','2014-01-29','09:40:00',1.57),('16273','2014-01-29','09:45:00',1.22),('16273','2014-01-29','10:00:00',1.25),('16273','2014-01-29','10:05:00',1.79),('16273','2014-01-29','10:10:00',1.75),('16273','2014-01-29','10:15:00',2.01),('16273','2014-01-29','10:20:00',2.82),('16273','2014-01-29','10:25:00',3.24),('16273','2014-01-29','10:30:00',2.77),('16273','2014-01-29','10:35:00',2.39),('16273','2014-01-29','10:40:00',1.61),('16273','2014-01-29','10:45:00',1.62),('16273','2014-01-29','10:50:00',1.6),('16273','2014-01-29','10:55:00',1.83),('16273','2014-01-29','11:00:00',2.2),('16273','2014-01-29','11:05:00',1.92),('16273','2014-01-29','11:10:00',1.99),('16273','2014-01-29','11:15:00',2.33),('16273','2014-01-29','11:20:00',2.38),('16273','2014-01-29','11:25:00',1.77),('16273','2014-01-29','11:30:00',1.99),('16273','2014-01-29','11:35:00',2.34),('16273','2014-01-29','11:40:00',1.53),('16273','2014-01-29','12:55:00',1.82),('16273','2014-01-29','13:00:00',1.81),('16273','2014-01-29','13:25:00',1.69),('16273','2014-01-29','13:30:00',2.54),('16273','2014-01-29','13:35:00',2.04),('16273','2014-01-29','13:40:00',2.71),('16273','2014-01-29','13:45:00',1.69),('16273','2014-01-29','13:50:00',2.23),('16273','2014-01-29','13:55:00',1.41),('16273','2014-01-29','15:15:00',1.06),('16273','2014-01-28','09:15:00',1.17),('16273','2014-01-28','09:20:00',1.43),('16273','2014-01-28','09:25:00',1.51),('16273','2014-01-28','09:30:00',1.33),('16273','2014-01-28','09:35:00',1.31),('16273','2014-01-28','09:40:00',1.53),('16273','2014-01-28','09:45:00',2.06),('16273','2014-01-28','09:50:00',2.12),('16273','2014-01-28','09:55:00',2.35),('16273','2014-01-28','10:00:00',2.62),('16273','2014-01-28','10:05:00',2.63),('16273','2014-01-28','10:10:00',2.61),('16273','2014-01-28','10:15:00',2.67),('16273','2014-01-28','10:20:00',2.76),('16273','2014-01-28','10:25:00',2.77),('16273','2014-01-28','10:30:00',2.8),('16273','2014-01-28','10:35:00',2.82),('16273','2014-01-28','10:40:00',2.94),('16273','2014-01-28','10:45:00',1.54),('16273','2014-01-28','10:50:00',2.12),('16273','2014-01-28','10:55:00',2.51),('16273','2014-01-28','11:00:00',1.55),('16273','2014-01-28','11:05:00',1.59),('16273','2014-01-28','11:10:00',2.44),('16273','2014-01-28','11:15:00',1.88),('16273','2014-01-28','11:20:00',2.24),('16273','2014-01-28','11:25:00',1.61),('16273','2014-01-28','11:30:00',3.51),('16273','2014-01-28','11:35:00',1.92),('16273','2014-01-28','11:40:00',2.47),('16273','2014-01-28','11:45:00',2.95),('16273','2014-01-28','11:50:00',2.3),('16273','2014-01-28','11:55:00',3.1),('16273','2014-01-28','12:00:00',1.81),('16273','2014-01-28','12:05:00',1.94),('16273','2014-01-28','12:10:00',1.48),('16273','2014-01-28','12:15:00',1.18),('16273','2014-01-28','12:20:00',1.11),('16273','2014-01-28','12:25:00',1.16),('16273','2014-01-28','12:30:00',1.48),('16273','2014-01-28','12:35:00',1.64),('16273','2014-01-28','12:40:00',3.08),('16273','2014-01-28','12:45:00',3.09),('16273','2014-01-28','12:50:00',1.94),('16273','2014-01-28','12:55:00',2.99),('16273','2014-01-28','13:00:00',2.46),('16273','2014-01-28','13:05:00',2.48),('16273','2014-01-28','13:10:00',2.76),('16273','2014-01-28','13:15:00',2.9),('16273','2014-01-28','13:20:00',2.43),('16273','2014-01-28','13:25:00',2.45),('16273','2014-01-28','13:30:00',2.76),('16273','2014-01-28','13:35:00',2.66),('16273','2014-01-28','13:40:00',2.54),('16273','2014-01-28','13:45:00',2.46),('16273','2014-01-28','13:50:00',2.39),('16273','2014-01-28','13:55:00',2.32),('16273','2014-01-28','14:00:00',2.26),('16273','2014-01-28','14:05:00',2.22),('16273','2014-01-28','14:10:00',2.16),('16273','2014-01-28','14:15:00',2.09),('16273','2014-01-28','14:20:00',2.02),('16273','2014-01-28','14:25:00',1.98),('16273','2014-01-28','14:30:00',1.91),('16273','2014-01-28','14:35:00',1.84),('16273','2014-01-28','14:40:00',1.76),('16273','2014-01-28','14:45:00',1.7),('16273','2014-01-28','14:50:00',1.62),('16273','2014-01-28','14:55:00',1.56),('16273','2014-01-28','15:00:00',1.48),('16273','2014-01-28','15:05:00',1.41),('16273','2014-01-28','15:10:00',1.33),('16273','2014-01-28','15:15:00',1.26),('16273','2014-01-28','15:20:00',1.2),('16273','2014-01-28','15:25:00',1.13),('16273','2014-01-28','15:30:00',1.07),('325','2014-05-05','08:25:00',1.04),('325','2014-05-05','08:30:00',1.09),('325','2014-05-05','08:35:00',1.14),('325','2014-05-05','08:40:00',1.19),('325','2014-05-05','08:45:00',1.24),('325','2014-05-05','08:50:00',1.31),('325','2014-05-05','08:55:00',1.36),('325','2014-05-05','09:00:00',1.41),('325','2014-05-05','09:05:00',1.54),('325','2014-05-05','09:10:00',2.33),('325','2014-05-05','09:15:00',2.4),('325','2014-05-05','09:20:00',2.52),('325','2014-05-05','09:25:00',2.59),('325','2014-05-05','09:30:00',2.76),('325','2014-05-05','09:35:00',2.83),('325','2014-05-05','09:40:00',2.92),('325','2014-05-05','09:45:00',3.02),('325','2014-05-05','09:50:00',3.2),('325','2014-05-05','09:55:00',3.31),('325','2014-05-05','10:00:00',3.38),('325','2014-05-05','10:05:00',3.48),('325','2014-05-05','10:10:00',3.58),('325','2014-05-05','10:15:00',3.64),('325','2014-05-05','10:20:00',3.66),('325','2014-05-05','10:25:00',3.75),('325','2014-05-05','10:30:00',3.83),('325','2014-05-05','10:35:00',3.9),('325','2014-05-05','10:40:00',3.97),('325','2014-05-05','10:45:00',4.04),('325','2014-05-05','10:50:00',4.08),('325','2014-05-05','10:55:00',4.12),('325','2014-05-05','11:00:00',4.17),('325','2014-05-05','11:05:00',4.21),('325','2014-05-05','11:10:00',4.13),('325','2014-05-05','11:15:00',4.37),('325','2014-05-05','11:20:00',4.34),('325','2014-05-05','11:25:00',4.38),('325','2014-05-05','11:30:00',4.42),('325','2014-05-05','11:35:00',4.41),('325','2014-05-05','11:40:00',4.44),('325','2014-05-05','11:45:00',4.54),('325','2014-05-05','11:50:00',4.59),('325','2014-05-05','11:55:00',4.06),('325','2014-05-05','12:00:00',4.56),('325','2014-05-05','12:05:00',4.41),('325','2014-05-05','12:10:00',2.1),('325','2014-05-05','12:15:00',3.39),('325','2014-05-05','12:20:00',2.66),('325','2014-05-05','12:25:00',2.72),('325','2014-05-05','12:30:00',4.96),('325','2014-05-05','12:35:00',3.9),('325','2014-05-05','12:40:00',1.56),('325','2014-05-05','12:45:00',2.16),('325','2014-05-05','12:50:00',4.66),('325','2014-05-05','12:55:00',2.42),('325','2014-05-05','13:00:00',1.73),('325','2014-05-05','13:05:00',3.07),('325','2014-05-05','13:10:00',5.25),('325','2014-05-05','13:15:00',5.08),('325','2014-05-05','13:20:00',4.94),('325','2014-05-05','13:25:00',4.85),('325','2014-05-05','13:30:00',4.83),('325','2014-05-05','13:35:00',4.82),('325','2014-05-05','13:40:00',4.82),('325','2014-05-05','13:45:00',4.85),('325','2014-05-05','13:50:00',4.84),('325','2014-05-05','13:55:00',4.82),('325','2014-05-05','14:00:00',4.71),('325','2014-05-05','14:05:00',4.11),('325','2014-05-05','14:10:00',2.98),('325','2014-05-05','14:15:00',4.96),('325','2014-05-05','14:20:00',5.25),('325','2014-05-05','14:25:00',5.13),('325','2014-05-05','14:30:00',4.16),('325','2014-05-05','14:35:00',2.97),('325','2014-05-05','14:40:00',2.36),('325','2014-05-05','14:45:00',1.65),('325','2014-05-05','14:50:00',1.58),('325','2014-05-05','14:55:00',1.76),('325','2014-05-05','15:00:00',2.55),('325','2014-05-05','15:05:00',4.64),('325','2014-05-05','15:10:00',3.26),('325','2014-05-05','15:15:00',1.45),('325','2014-05-05','15:20:00',1.44),('325','2014-05-05','15:25:00',1.77),('325','2014-05-05','15:30:00',4.12),('325','2014-05-05','15:35:00',3.06),('325','2014-05-05','15:40:00',1.42),('325','2014-05-05','15:45:00',3.65),('325','2014-05-05','15:50:00',1.59),('325','2014-05-05','15:55:00',1.24),('325','2014-05-05','16:00:00',2.58),('325','2014-05-05','16:05:00',1.94),('325','2014-05-05','16:10:00',2.21),('325','2014-05-05','16:15:00',1.4),('325','2014-05-05','16:20:00',1.64),('325','2014-05-05','16:25:00',1.83),('325','2014-05-05','16:30:00',1.78),('325','2014-05-05','16:35:00',3.62),('325','2014-05-05','16:40:00',3.32),('325','2014-05-05','16:45:00',3.07),('325','2014-05-05','16:50:00',2.95),('325','2014-05-05','16:55:00',2.71),('325','2014-05-05','17:00:00',2.52),('325','2014-05-05','17:05:00',2.47),('325','2014-05-05','17:10:00',2.43),('325','2014-05-05','17:15:00',2.33),('325','2014-05-05','17:20:00',2.24),('325','2014-05-05','17:25:00',2.12),('325','2014-05-05','17:30:00',2.08),('325','2014-05-05','17:35:00',1.92),('325','2014-05-05','17:40:00',1.86),('325','2014-05-05','17:45:00',1.78),('325','2014-05-05','17:50:00',1.67),('325','2014-05-05','17:55:00',1.58),('325','2014-05-05','18:00:00',1.47),('325','2014-05-05','18:05:00',1.39),('325','2014-05-05','18:10:00',1.31),('325','2014-05-05','18:15:00',1.2),('325','2014-05-05','18:20:00',1.09),('325','2014-05-04','08:20:00',1),('325','2014-05-04','08:25:00',1.01),('325','2014-05-04','08:30:00',1.08),('325','2014-05-04','08:35:00',1.31),('325','2014-05-04','08:40:00',1.13),('325','2014-05-04','08:45:00',1.01),('325','2014-05-04','08:50:00',1.07),('325','2014-05-04','08:55:00',1.03),('325','2014-05-04','09:00:00',1.21),('325','2014-05-04','09:05:00',1.77),('325','2014-05-04','09:10:00',1.85),('325','2014-05-04','09:15:00',1.94),('325','2014-05-04','09:20:00',2.47),('325','2014-05-04','09:25:00',3.27),('325','2014-05-04','09:30:00',1.94),('325','2014-05-04','09:35:00',1.2),('325','2014-05-04','09:40:00',1.36),('325','2014-05-04','09:45:00',2.28),('325','2014-05-04','09:50:00',2.64),('325','2014-05-04','09:55:00',1.98),('325','2014-05-04','10:00:00',3.68),('325','2014-05-04','10:05:00',3.92),('325','2014-05-04','10:10:00',2.42),('325','2014-05-04','10:15:00',2.55),('325','2014-05-04','10:20:00',1.94),('325','2014-05-04','10:25:00',1.97),('325','2014-05-04','10:30:00',2.21),('325','2014-05-04','10:35:00',2.18),('325','2014-05-04','10:40:00',2.42),('325','2014-05-04','10:45:00',3.02),('325','2014-05-04','10:50:00',2.64),('325','2014-05-04','10:55:00',2.61),('325','2014-05-04','11:00:00',2.55),('325','2014-05-04','11:05:00',2.75),('325','2014-05-04','11:10:00',4.39),('325','2014-05-04','11:15:00',3.9),('325','2014-05-04','11:20:00',4.69),('325','2014-05-04','11:25:00',4.57),('325','2014-05-04','11:30:00',4.2),('325','2014-05-04','11:35:00',3.94),('325','2014-05-04','11:40:00',3.07),('325','2014-05-04','11:45:00',3.96),('325','2014-05-04','11:50:00',3.58),('325','2014-05-04','11:55:00',4.57),('325','2014-05-04','12:00:00',2.45),('325','2014-05-04','12:05:00',2.39),('325','2014-05-04','12:10:00',1.91),('325','2014-05-04','12:15:00',1.8),('325','2014-05-04','12:20:00',1.65),('325','2014-05-04','12:25:00',1.78),('325','2014-05-04','12:30:00',3.48),('325','2014-05-04','12:35:00',5.66),('325','2014-05-04','12:40:00',4.88),('325','2014-05-04','12:45:00',2.42),('325','2014-05-04','12:50:00',1.84),('325','2014-05-04','12:55:00',1.91),('325','2014-05-04','13:00:00',2.16),('325','2014-05-04','13:05:00',1.64),('325','2014-05-04','13:10:00',1.73),('325','2014-05-04','13:15:00',1.73),('325','2014-05-04','13:20:00',1.61),('325','2014-05-04','13:25:00',1.74),('325','2014-05-04','13:30:00',1.61),('325','2014-05-04','13:35:00',1.55),('325','2014-05-04','13:40:00',1.55),('325','2014-05-04','13:45:00',1.37),('325','2014-05-04','13:50:00',1.28),('325','2014-05-04','13:55:00',1.34),('325','2014-05-04','14:00:00',1.35),('325','2014-05-04','14:05:00',1.38),('325','2014-05-04','14:10:00',1.37),('325','2014-05-04','14:15:00',1.28),('325','2014-05-04','14:50:00',1.12),('325','2014-05-04','14:55:00',1.77),('325','2014-05-04','15:00:00',2.04),('325','2014-05-04','15:05:00',2.31),('325','2014-05-04','15:10:00',3.07),('325','2014-05-04','15:15:00',2.38),('325','2014-05-04','15:20:00',2.22),('325','2014-05-04','15:25:00',1.78),('325','2014-05-04','15:30:00',1.53),('325','2014-05-04','15:50:00',1.15),('325','2014-05-04','15:55:00',1.22),('325','2014-05-04','16:00:00',1.13),('325','2014-05-04','16:05:00',1.18),('325','2014-05-04','16:10:00',1.37),('325','2014-05-04','16:15:00',1.29),('325','2014-05-04','16:20:00',1.09),('325','2014-05-04','17:35:00',1.05),('325','2014-05-04','17:40:00',1.08),('325','2014-04-25','08:30:00',1.04),('325','2014-04-25','08:35:00',1.07),('325','2014-04-25','08:40:00',1.13),('325','2014-04-25','08:45:00',1.24),('325','2014-04-25','08:50:00',1.44),('325','2014-04-25','08:55:00',1.53),('325','2014-04-25','09:00:00',1.07),('325','2014-04-25','09:05:00',1.11),('325','2014-04-25','09:25:00',1.46),('325','2014-04-25','09:30:00',1.11),('325','2014-04-25','09:35:00',1.03),('325','2014-04-25','09:55:00',1.09),('325','2014-04-25','10:00:00',1.27),('325','2014-04-25','10:05:00',1.27),('325','2014-04-25','10:10:00',1.38),('325','2014-04-25','10:15:00',1.26),('325','2014-04-25','10:20:00',1.46),('325','2014-04-25','10:25:00',1.48),('325','2014-04-25','10:30:00',3.12),('325','2014-04-25','10:35:00',3.58),('325','2014-04-25','10:40:00',2.98),('325','2014-04-25','10:45:00',3.03),('325','2014-04-25','10:50:00',1.74),('325','2014-04-25','10:55:00',3.4),('325','2014-04-25','11:00:00',2.39),('325','2014-04-25','11:05:00',2.56),('325','2014-04-25','11:10:00',4.31),('325','2014-04-25','11:15:00',4.42),('325','2014-04-25','11:20:00',4.27),('325','2014-04-25','11:25:00',4.19),('325','2014-04-25','11:30:00',2.98),('325','2014-04-25','11:35:00',4.29),('325','2014-04-25','11:40:00',1.98),('325','2014-04-25','11:45:00',1.41),('325','2014-04-25','11:50:00',2.11),('325','2014-04-25','11:55:00',4.36),('325','2014-04-25','12:00:00',2.82),('325','2014-04-25','12:05:00',5.15),('325','2014-04-25','12:10:00',3.17),('325','2014-04-25','12:15:00',1.72),('325','2014-04-25','12:20:00',2.7),('325','2014-04-25','12:25:00',4.48),('325','2014-04-25','12:30:00',4.81),('325','2014-04-25','12:35:00',4.87),('325','2014-04-25','12:40:00',4.96),('325','2014-04-25','12:45:00',4.97),('325','2014-04-25','12:50:00',2),('325','2014-04-25','12:55:00',2.28),('325','2014-04-25','13:00:00',2.57),('325','2014-04-25','13:05:00',2.98),('325','2014-04-25','13:10:00',3.85),('325','2014-04-25','13:15:00',2.22),('325','2014-04-25','13:20:00',2.39),('325','2014-04-25','13:25:00',2.79),('325','2014-04-25','13:30:00',1.45),('325','2014-04-25','13:35:00',1.16),('325','2014-04-25','13:40:00',1.79),('325','2014-04-25','13:45:00',1.32),('325','2014-04-25','13:50:00',2.84),('325','2014-04-25','13:55:00',2.3),('325','2014-04-25','14:00:00',1.49),('325','2014-04-25','14:05:00',1.58),('325','2014-04-25','14:10:00',1.23),('325','2014-04-25','14:15:00',1.52),('325','2014-04-25','14:20:00',4.22),('325','2014-04-25','14:25:00',2.26),('325','2014-04-25','14:30:00',2.49),('325','2014-04-25','14:35:00',4.52),('325','2014-04-25','14:40:00',4.44),('325','2014-04-25','14:45:00',4.3),('325','2014-04-25','14:50:00',4.23),('325','2014-04-25','14:55:00',4.2),('325','2014-04-25','15:00:00',4.14),('325','2014-04-25','15:05:00',4.11),('325','2014-04-25','15:10:00',4.07),('325','2014-04-25','15:15:00',4.03),('325','2014-04-25','15:20:00',3.82),('325','2014-04-25','15:25:00',3.84),('325','2014-04-25','15:30:00',3.73),('325','2014-04-25','15:35:00',3.79),('325','2014-04-25','15:40:00',3.73),('325','2014-04-25','15:45:00',3.63),('325','2014-04-25','15:50:00',3.59),('325','2014-04-25','15:55:00',3.52),('325','2014-04-25','16:00:00',3.47),('325','2014-04-25','16:05:00',3.37),('325','2014-04-25','16:10:00',3.25),('325','2014-04-25','16:15:00',3.07),('325','2014-04-25','16:20:00',2.88),('325','2014-04-25','16:25:00',2.97),('325','2014-04-25','16:30:00',3.02),('325','2014-04-25','16:35:00',3.03),('325','2014-04-25','16:40:00',3.02),('325','2014-04-25','16:45:00',2.85),('325','2014-04-25','16:50:00',2.53),('325','2014-04-25','16:55:00',2.16),('325','2014-04-25','17:00:00',2.18),('325','2014-04-25','17:05:00',2.36),('325','2014-04-25','17:10:00',1.98),('325','2014-04-25','17:15:00',2.03),('325','2014-04-25','17:20:00',1.39),('325','2014-04-25','17:25:00',1.08),('325','2014-04-25','17:30:00',1.14),('325','2014-04-25','17:35:00',1.14),('325','2014-04-25','17:40:00',1.09),('325','2014-01-25','09:05:00',1.25),('325','2014-01-25','09:10:00',1.1),('325','2014-01-25','09:20:00',1.04),('325','2014-01-25','09:50:00',1.39),('325','2014-01-25','09:55:00',1.61),('325','2014-01-25','10:00:00',1.18),('325','2014-01-25','10:05:00',1.94),('325','2014-01-25','10:10:00',2.25),('325','2014-01-25','10:15:00',3.1),('325','2014-01-25','10:20:00',3.06),('325','2014-01-25','10:25:00',1.97),('325','2014-01-25','10:30:00',1.87),('325','2014-01-25','10:35:00',1.68),('325','2014-01-25','10:40:00',2.19),('325','2014-01-25','10:45:00',1.81),('325','2014-01-25','10:50:00',2.41),('325','2014-01-25','10:55:00',2.08),('325','2014-01-25','11:00:00',1.3),('325','2014-01-25','11:05:00',1.21),('325','2014-01-25','11:10:00',1.11),('325','2014-01-25','11:15:00',1.13),('325','2014-01-25','11:20:00',1.2),('325','2014-01-25','11:25:00',1.85),('325','2014-01-25','11:30:00',4.01),('325','2014-01-25','11:35:00',4.5),('325','2014-01-25','11:40:00',1.88),('325','2014-01-25','11:45:00',1.39),('325','2014-01-25','11:50:00',1.61),('325','2014-01-25','11:55:00',1.73),('325','2014-01-25','12:00:00',1.68),('325','2014-01-25','12:05:00',1.89),('325','2014-01-25','12:10:00',2.03),('325','2014-01-25','12:15:00',1.87),('325','2014-01-25','12:20:00',2.06),('325','2014-01-25','12:25:00',2.25),('325','2014-01-25','12:30:00',2.12),('325','2014-01-25','12:35:00',1.85),('325','2014-01-25','12:40:00',2),('325','2014-01-25','12:45:00',2.43),('325','2014-01-25','12:50:00',2.47),('325','2014-01-25','12:55:00',3.05),('325','2014-01-25','13:00:00',3.17),('325','2014-01-25','13:05:00',2.99),('325','2014-01-25','13:10:00',3.53),('325','2014-01-25','13:15:00',2.74),('325','2014-01-25','13:20:00',1.59),('325','2014-01-25','13:25:00',2.18),('325','2014-01-25','13:30:00',1.83),('325','2014-01-25','13:35:00',2.32),('325','2014-01-25','13:40:00',1.16),('325','2014-01-25','13:45:00',1.52),('325','2014-01-25','13:50:00',1.51),('325','2014-01-25','14:00:00',1.61),('325','2014-01-25','14:05:00',1.96),('325','2014-01-25','14:10:00',2.86),('325','2014-01-25','14:15:00',2.65),('325','2014-01-25','14:20:00',2.87),('325','2014-01-25','14:25:00',2.9),('325','2014-01-25','14:30:00',3.11),('325','2014-01-25','14:35:00',3.2),('325','2014-01-25','14:40:00',2.9),('325','2014-01-25','14:45:00',3.07),('325','2014-01-25','14:50:00',2.85),('325','2014-01-25','14:55:00',2.67),('325','2014-01-25','15:00:00',2.41),('325','2014-01-25','15:05:00',2.26),('325','2014-01-25','15:10:00',2.14),('325','2014-01-25','15:15:00',2.03),('325','2014-01-25','15:20:00',1.9),('325','2014-01-25','15:25:00',1.8),('325','2014-01-25','15:30:00',1.7),('325','2014-01-25','15:35:00',1.58),('325','2014-01-25','15:40:00',1.48),('325','2014-01-25','15:45:00',1.39),('325','2014-01-25','15:50:00',1.29),('325','2014-01-25','15:55:00',1.2),('325','2014-01-25','16:00:00',1.11),('325','2014-01-25','16:05:00',1),('325','2014-01-24','10:05:00',1.02),('325','2014-01-24','10:10:00',1.11),('325','2014-01-24','10:15:00',2.08),('325','2014-01-24','10:25:00',1.46),('325','2014-01-24','10:30:00',1.97),('325','2014-01-24','10:35:00',1.73),('325','2014-01-24','10:40:00',2.8),('325','2014-01-24','10:45:00',2.31),('325','2014-01-24','10:50:00',1.38),('325','2014-01-24','10:55:00',1.09),('325','2014-01-24','11:00:00',1.16),('325','2014-01-24','11:25:00',1.21),('325','2014-01-24','11:30:00',1.7),('325','2014-01-24','11:35:00',1.49),('325','2014-01-24','11:45:00',2.19),('325','2014-01-24','11:50:00',3.71),('325','2014-01-24','11:55:00',3.13),('325','2014-01-24','12:00:00',2.04),('325','2014-01-24','12:05:00',1.83),('325','2014-01-24','12:10:00',1.24),('325','2014-01-24','12:25:00',2.29),('325','2014-01-24','12:30:00',1.51),('325','2014-01-24','12:35:00',3.24),('325','2014-01-24','12:40:00',3.43),('325','2014-01-24','12:45:00',1.66),('325','2014-01-24','12:50:00',1.28),('325','2014-01-24','12:55:00',1.97),('325','2014-01-24','13:00:00',1.87),('325','2014-01-24','13:05:00',2.29),('325','2014-01-24','13:10:00',1.31),('325','2014-01-24','13:30:00',1.28),('325','2014-01-24','13:35:00',1.94),('325','2014-01-24','13:40:00',1.7),('325','2014-01-24','13:45:00',1.2),('325','2014-01-24','13:50:00',1.22),('325','2014-01-24','13:55:00',1.77),('325','2014-01-24','14:00:00',1.41),('325','2014-01-24','14:10:00',3.53),('325','2014-01-24','14:15:00',3.32),('325','2014-01-24','14:20:00',2.9),('325','2014-01-24','14:25:00',2.41),('325','2014-01-24','14:35:00',1.02),('325','2014-01-24','14:40:00',1.15),('325','2014-01-24','14:45:00',1.22),('325','2014-01-23','11:00:00',1.12),('325','2014-01-23','11:05:00',1.11),('325','2014-01-23','11:10:00',1.08),('325','2014-01-23','11:15:00',1.07),('325','2014-01-23','11:20:00',1.02),('325','2014-01-23','12:30:00',1.05),('325','2014-01-22','11:10:00',1.02),('325','2014-01-22','13:10:00',1.1),('325','2014-01-22','13:15:00',1.52),('325','2014-01-22','13:20:00',1.02),('325','2014-01-22','16:05:00',1.27),('325','2014-01-22','16:10:00',1.28),('325','2014-01-21','10:00:00',1.22),('325','2014-01-21','10:05:00',1.18),('325','2014-01-21','10:55:00',1.69),('325','2014-01-21','11:00:00',2.42),('325','2014-01-21','11:50:00',1.09),('325','2014-01-21','12:00:00',1.08),('325','2014-01-21','12:05:00',1.93),('325','2014-01-21','12:10:00',1.96),('325','2014-01-21','12:15:00',1.37),('325','2014-01-21','12:20:00',1.2),('325','2014-01-21','12:25:00',1.52),('325','2014-01-21','12:30:00',1.84),('325','2014-01-21','12:35:00',1.61),('325','2014-01-21','12:40:00',1.38),('325','2014-01-21','12:45:00',1.28),('325','2014-01-21','12:50:00',2.06),('325','2014-01-21','13:20:00',1.06),('325','2014-01-21','14:00:00',1.19),('325','2014-01-21','14:05:00',1.43),('325','2014-01-21','14:10:00',1.25),('325','2014-01-21','14:15:00',1.02),('325','2014-01-21','15:35:00',1.09),('325','2014-01-20','11:15:00',1.06),('325','2014-01-20','11:20:00',1.85),('325','2014-01-20','11:25:00',2.19),('325','2014-01-20','11:30:00',2.2),('325','2014-01-20','11:35:00',2.26),('325','2014-01-20','11:40:00',3.31),('325','2014-01-20','11:45:00',3.59),('325','2014-01-20','11:50:00',1.92),('325','2014-01-20','11:55:00',1),('325','2014-01-20','12:00:00',1.08),('325','2014-01-20','12:05:00',1.19),('325','2014-01-20','12:30:00',1.09),('325','2014-01-20','13:15:00',1.03),('325','2014-01-20','13:20:00',4.36),('325','2014-01-20','13:25:00',3.99),('325','2014-01-20','13:30:00',3.66),('325','2014-01-20','13:35:00',3.46),('325','2014-01-20','13:40:00',2.92),('325','2014-01-20','13:45:00',2.61),('325','2014-01-20','13:50:00',1.13),('325','2014-01-20','13:55:00',1.61),('325','2014-01-20','14:00:00',3.43),('325','2014-01-20','14:05:00',1.8),('325','2014-01-20','14:10:00',1.33),('325','2014-01-19','11:55:00',1.05),('325','2014-01-19','12:00:00',1.06),('325','2014-01-19','12:05:00',1.11),('325','2014-01-19','12:10:00',1.03),('325','2014-01-19','13:05:00',1.07),('325','2014-01-19','13:10:00',1.18),('325','2014-01-19','14:20:00',1.58),('325','2014-01-19','14:25:00',1.83),('325','2014-01-19','14:30:00',2.2),('325','2014-01-19','14:35:00',1.25),('325','2014-01-19','14:40:00',1.02),('325','2014-01-18','09:55:00',1),('325','2014-01-18','10:00:00',1.25),('325','2014-01-18','10:05:00',1.67),('325','2014-01-18','10:10:00',1.95),('325','2014-01-18','10:15:00',2.8),('325','2014-01-18','10:20:00',2.2),('325','2014-01-18','10:25:00',1.77),('325','2014-01-18','10:30:00',1.83),('325','2014-01-18','10:35:00',1.2),('325','2014-01-18','10:40:00',1.25),('325','2014-01-18','10:45:00',1.4),('325','2014-01-18','10:50:00',1.36),('325','2014-01-18','10:55:00',1.17),('325','2014-01-18','11:05:00',1.61),('325','2014-01-18','11:10:00',3.04),('325','2014-01-18','11:15:00',3.35),('325','2014-01-18','11:20:00',3.2),('325','2014-01-18','11:25:00',3.07),('325','2014-01-18','11:30:00',3.12),('325','2014-01-18','11:35:00',3.18),('325','2014-01-18','11:40:00',3.31),('325','2014-01-18','11:45:00',3.55),('325','2014-01-18','11:50:00',3.32),('325','2014-01-18','11:55:00',3.62),('325','2014-01-18','12:00:00',3.6),('325','2014-01-18','12:05:00',2.89),('325','2014-01-18','12:10:00',3.4),('325','2014-01-18','12:15:00',3.23),('325','2014-01-18','12:20:00',3.25),('325','2014-01-18','12:25:00',3.23),('325','2014-01-18','12:30:00',3.28),('325','2014-01-18','12:35:00',3.27),('325','2014-01-18','12:40:00',3.33),('325','2014-01-18','12:45:00',3.24),('325','2014-01-18','12:50:00',2.87),('325','2014-01-18','12:55:00',3.4),('325','2014-01-18','13:00:00',2.41),('325','2014-01-18','13:05:00',2.04),('325','2014-01-18','13:10:00',2.76),('325','2014-01-18','13:15:00',3.31),('325','2014-01-18','13:20:00',2.23),('325','2014-01-18','13:25:00',1.69),('325','2014-01-18','13:30:00',2.9),('325','2014-01-18','13:35:00',1.97),('325','2014-01-18','13:40:00',2.68),('325','2014-01-18','13:45:00',3.05),('325','2014-01-18','13:50:00',2.39),('325','2014-01-18','13:55:00',2.98),('325','2014-01-18','14:00:00',2.9),('325','2014-01-18','14:05:00',2.76),('325','2014-01-18','14:10:00',2.6),('325','2014-01-18','14:15:00',2.48),('325','2014-01-18','14:20:00',2.57),('325','2014-01-18','14:25:00',2.45),('325','2014-01-18','14:30:00',2.36),('325','2014-01-18','14:35:00',2.29),('325','2014-01-18','14:40:00',2.22),('325','2014-01-18','14:45:00',2.15),('325','2014-01-18','14:50:00',2.07),('325','2014-01-18','14:55:00',1.35),('325','2014-01-18','15:55:00',1.02),('325','2014-01-17','09:25:00',1.03),('325','2014-01-17','09:30:00',1.13),('325','2014-01-17','09:35:00',1.23),('325','2014-01-17','09:40:00',1.34),('325','2014-01-17','09:45:00',1.44),('325','2014-01-17','11:25:00',1.21),('325','2014-01-17','11:30:00',1.89),('325','2014-01-17','11:35:00',2.49),('325','2014-01-17','11:40:00',1.93),('325','2014-01-17','11:55:00',1.3),('325','2014-01-17','12:00:00',1.62),('325','2014-01-17','12:05:00',1.69),('325','2014-01-17','12:10:00',1.22),('325','2014-01-17','12:40:00',1.04),('325','2014-01-17','12:45:00',1.19),('325','2014-01-16','09:20:00',1.14),('325','2014-01-16','09:25:00',1.26),('325','2014-01-16','09:30:00',1.36),('325','2014-01-16','09:35:00',1.46),('325','2014-01-16','09:40:00',1.6),('325','2014-01-16','09:45:00',1.51),('325','2014-01-16','09:50:00',1.25),('325','2014-01-16','09:55:00',1.05),('325','2014-01-16','10:05:00',1.03),('325','2014-01-16','10:10:00',1.16),('325','2014-01-16','10:15:00',1.46),('325','2014-01-16','10:20:00',1.39),('325','2014-01-16','10:25:00',1.65),('325','2014-01-16','10:30:00',2.41),('325','2014-01-16','10:35:00',3.09),('325','2014-01-16','10:40:00',2.62),('325','2014-01-16','10:45:00',1.99),('325','2014-01-16','10:50:00',2.19),('325','2014-01-16','10:55:00',2.41),('325','2014-01-16','11:00:00',2.43),('325','2014-01-16','11:05:00',2.44),('325','2014-01-16','11:10:00',2.54),('325','2014-01-16','11:15:00',2.41),('325','2014-01-16','11:20:00',2.19),('325','2014-01-16','11:25:00',2.25),('325','2014-01-16','11:30:00',2.04),('325','2014-01-16','11:35:00',1.95),('325','2014-01-16','11:40:00',1.9),('325','2014-01-16','11:45:00',1.94),('325','2014-01-16','11:50:00',1.46),('325','2014-01-16','11:55:00',1.59),('325','2014-01-16','12:00:00',1.68),('325','2014-01-16','12:05:00',1.76),('325','2014-01-16','12:10:00',2.05),('325','2014-01-16','12:15:00',1.87),('325','2014-01-16','12:20:00',1.69),('325','2014-01-16','12:25:00',1.6),('325','2014-01-16','12:30:00',1.76),('325','2014-01-16','12:35:00',2.16),('325','2014-01-16','12:40:00',2.18),('325','2014-01-16','12:45:00',2.23),('325','2014-01-16','12:50:00',2.46),('325','2014-01-16','12:55:00',2.47),('325','2014-01-16','13:00:00',2.61),('325','2014-01-16','13:05:00',2.38),('325','2014-01-16','13:10:00',2.67),('325','2014-01-16','13:15:00',2.47),('325','2014-01-16','13:20:00',2.25),('325','2014-01-16','13:25:00',2.08),('325','2014-01-16','13:30:00',1.23),('325','2014-01-16','13:35:00',1.11),('325','2014-01-16','13:40:00',1.87),('325','2014-01-16','13:45:00',2.54),('325','2014-01-16','13:50:00',2.31),('325','2014-01-16','13:55:00',2.05),('325','2014-01-16','14:00:00',1.17),('325','2014-01-16','14:05:00',1.15),('325','2014-01-16','14:10:00',1.05),('325','2014-01-16','14:25:00',1.02),('325','2014-01-16','14:30:00',1.04),('325','2014-01-16','15:05:00',1.07),('325','2014-01-16','15:10:00',1.04),('325','2014-04-24','08:35:00',1.01),('325','2014-04-24','08:40:00',1.05),('325','2014-04-24','08:45:00',1.1),('325','2014-04-24','08:50:00',1.15),('325','2014-04-24','08:55:00',1.19),('325','2014-04-24','09:00:00',1.39),('325','2014-04-24','09:05:00',1.93),('325','2014-04-24','09:10:00',2.08),('325','2014-04-24','09:15:00',2.19),('325','2014-04-24','09:20:00',2.32),('325','2014-04-24','09:25:00',2.43),('325','2014-04-24','09:30:00',2.52),('325','2014-04-24','09:35:00',2.67),('325','2014-04-24','09:40:00',2.79),('325','2014-04-24','09:45:00',2.88),('325','2014-04-24','09:50:00',3),('325','2014-04-24','09:55:00',3.05),('325','2014-04-24','10:00:00',3.11),('325','2014-04-24','10:05:00',3.04),('325','2014-04-24','10:10:00',3.1),('325','2014-04-24','10:15:00',3.29),('325','2014-04-24','10:20:00',3.36),('325','2014-04-24','10:25:00',3.44),('325','2014-04-24','10:30:00',3.51),('325','2014-04-24','10:35:00',3.58),('325','2014-04-24','10:40:00',3.62),('325','2014-04-24','10:45:00',3.74),('325','2014-04-24','10:50:00',3.83),('325','2014-04-24','10:55:00',3.85),('325','2014-04-24','11:00:00',3.8),('325','2014-04-24','11:05:00',3.9),('325','2014-04-24','11:10:00',3.95),('325','2014-04-24','11:15:00',3.99),('325','2014-04-24','11:20:00',4.02),('325','2014-04-24','11:25:00',4.04),('325','2014-04-24','11:30:00',4.05),('325','2014-04-24','11:35:00',4.08),('325','2014-04-24','11:40:00',4.13),('325','2014-04-24','11:45:00',4.19),('325','2014-04-24','11:50:00',4.23),('325','2014-04-24','11:55:00',4.23),('325','2014-04-24','12:00:00',4.27),('325','2014-04-24','12:05:00',4.38),('325','2014-04-24','12:10:00',4.35),('325','2014-04-24','12:15:00',4.47),('325','2014-04-24','12:20:00',4.43),('325','2014-04-24','12:25:00',4.46),('325','2014-04-24','12:30:00',4.53),('325','2014-04-24','12:35:00',4.49),('325','2014-04-24','12:40:00',4.49),('325','2014-04-24','12:45:00',4.48),('325','2014-04-24','12:50:00',4.47),('325','2014-04-24','12:55:00',4.53),('325','2014-04-24','13:00:00',4.53),('325','2014-04-24','13:05:00',4.46),('325','2014-04-24','13:10:00',4.56),('325','2014-04-24','13:15:00',4.63),('325','2014-04-24','13:20:00',4.56),('325','2014-04-24','13:25:00',4.58),('325','2014-04-24','13:30:00',3.55),('325','2014-04-24','13:35:00',1.08),('325','2014-04-24','13:40:00',2.43),('325','2014-04-24','13:45:00',3.26),('325','2014-04-24','13:50:00',4.27),('325','2014-04-24','13:55:00',4.79),('325','2014-04-24','14:00:00',4.68),('325','2014-04-24','14:05:00',5.01),('325','2014-04-24','14:10:00',4.25),('325','2014-04-24','14:15:00',4.21),('325','2014-04-24','14:20:00',4.74),('325','2014-04-24','14:25:00',4.77),('325','2014-04-24','14:30:00',3.86),('325','2014-04-24','14:35:00',3.77),('325','2014-04-24','14:40:00',3.22),('325','2014-04-24','14:45:00',2.37),('325','2014-04-24','14:50:00',2.6),('325','2014-04-24','14:55:00',5.12),('325','2014-04-24','15:00:00',4.73),('325','2014-04-24','15:05:00',4.65),('325','2014-04-24','15:10:00',4.87),('325','2014-04-24','15:15:00',4.57),('325','2014-04-24','15:20:00',3.08),('325','2014-04-24','15:25:00',2.29),('325','2014-04-24','15:30:00',2.84),('325','2014-04-24','15:35:00',2.73),('325','2014-04-24','15:40:00',2.59),('325','2014-04-24','15:45:00',2.41),('325','2014-04-24','15:50:00',2.64),('325','2014-04-24','15:55:00',3.21),('325','2014-04-24','16:00:00',4.21),('325','2014-04-24','16:05:00',3.85),('325','2014-04-24','16:10:00',3.2),('325','2014-04-24','16:15:00',3.98),('325','2014-04-24','16:20:00',3.49),('325','2014-04-24','16:25:00',2.65),('325','2014-04-24','16:30:00',2.83),('325','2014-04-24','16:35:00',2.04),('325','2014-04-24','16:40:00',2.07),('325','2014-04-24','16:45:00',1.65),('325','2014-04-24','16:50:00',1.43),('325','2014-04-24','16:55:00',1.38),('325','2014-04-24','17:00:00',1.42),('325','2014-04-24','17:05:00',1.31),('325','2014-04-24','17:10:00',1.23),('325','2014-04-24','17:15:00',1.11),('325','2014-04-24','17:20:00',1.1),('325','2014-04-24','17:25:00',1.1),('325','2014-04-24','17:30:00',1.12),('325','2014-04-24','17:35:00',1.01),('325','2014-01-15','10:15:00',1.85),('325','2014-01-15','10:20:00',2.48),('325','2014-01-15','10:25:00',2.71),('325','2014-01-15','10:30:00',2.44),('325','2014-01-15','10:35:00',1.88),('325','2014-01-15','10:40:00',2.4),('325','2014-01-15','10:45:00',1.71),('325','2014-01-15','10:50:00',1.27),('325','2014-01-15','10:55:00',1.2),('325','2014-01-15','11:00:00',1.73),('325','2014-01-15','11:05:00',2.21),('325','2014-01-15','11:10:00',2.93),('325','2014-01-15','11:15:00',3.08),('325','2014-01-15','11:20:00',2.9),('325','2014-01-15','11:25:00',2.7),('325','2014-01-15','11:30:00',2.09),('325','2014-01-15','11:35:00',1.22),('325','2014-01-15','11:40:00',2.46),('325','2014-01-15','11:45:00',2.56),('325','2014-01-15','11:50:00',2.72),('325','2014-01-15','11:55:00',2.4),('325','2014-01-15','12:00:00',2.27),('325','2014-01-15','12:05:00',1.88),('325','2014-01-15','12:10:00',1.79),('325','2014-01-15','12:15:00',2.12),('325','2014-01-15','12:20:00',2.82),('325','2014-01-15','12:25:00',2.15),('325','2014-01-15','12:30:00',1.6),('325','2014-01-15','12:35:00',1.85),('325','2014-01-15','12:40:00',1.62),('325','2014-01-15','12:45:00',1.79),('325','2014-01-15','12:50:00',1.82),('325','2014-01-15','12:55:00',1.53),('325','2014-01-15','13:00:00',1.51),('325','2014-01-15','13:05:00',1.67),('325','2014-01-15','13:10:00',2.54),('325','2014-01-15','13:15:00',3.51),('325','2014-01-15','13:20:00',3.47),('325','2014-01-15','13:25:00',3.3),('325','2014-01-15','13:30:00',3.17),('325','2014-01-15','13:35:00',2.7),('325','2014-01-15','13:40:00',2.69),('325','2014-01-15','13:45:00',2.9),('325','2014-01-15','13:50:00',2.14),('325','2014-01-15','13:55:00',1.59),('325','2014-01-15','14:00:00',2.64),('325','2014-01-15','14:05:00',2.62),('325','2014-01-15','14:10:00',2.56),('325','2014-01-15','14:15:00',2.48),('325','2014-01-15','14:20:00',2.46),('325','2014-01-15','14:25:00',2.4),('325','2014-01-15','14:30:00',2.37),('325','2014-01-15','14:35:00',2.34),('325','2014-01-15','14:40:00',2.36),('325','2014-01-15','14:45:00',2.33),('325','2014-01-15','14:50:00',2.18),('325','2014-01-15','14:55:00',2.09),('325','2014-01-15','15:00:00',2.02),('325','2014-01-15','15:05:00',1.93),('325','2014-01-15','15:10:00',1.86),('325','2014-01-15','15:15:00',1.74),('325','2014-01-15','15:20:00',1.44),('325','2014-01-15','15:25:00',1.5),('325','2014-01-15','15:30:00',1.37),('325','2014-01-15','15:35:00',1.34),('325','2014-01-15','15:40:00',1.25),('325','2014-01-15','15:45:00',1.15),('325','2014-01-14','10:25:00',1.97),('325','2014-01-14','10:30:00',3.22),('325','2014-01-14','10:35:00',3.27),('325','2014-01-14','10:40:00',2.8),('325','2014-01-14','10:45:00',2.55),('325','2014-01-14','10:50:00',1.48),('325','2014-01-14','10:55:00',1.31),('325','2014-01-14','11:00:00',1.69),('325','2014-01-14','11:05:00',1.18),('325','2014-01-14','11:20:00',1.01),('325','2014-01-14','11:30:00',1.04),('325','2014-01-14','11:35:00',1.21),('325','2014-01-14','11:40:00',1.34),('325','2014-01-13','09:10:00',1.04),('325','2014-01-13','09:15:00',1.02),('325','2014-01-13','09:20:00',1.03),('325','2014-01-13','09:25:00',1.04),('325','2014-01-13','09:30:00',1.07),('325','2014-01-13','09:35:00',1.12),('325','2014-01-13','09:40:00',1.16),('325','2014-01-13','09:45:00',1.19),('325','2014-01-13','09:50:00',1.23),('325','2014-01-13','09:55:00',1.26),('325','2014-01-13','10:00:00',1.3),('325','2014-01-13','10:05:00',1.32),('325','2014-01-13','10:10:00',1.49),('325','2014-01-13','10:15:00',2.15),('325','2014-01-13','10:20:00',2.33),('325','2014-01-13','10:25:00',2.38),('325','2014-01-13','10:30:00',2.46),('325','2014-01-13','10:35:00',2.51),('325','2014-01-13','10:40:00',2.56),('325','2014-01-13','10:45:00',2.6),('325','2014-01-13','10:50:00',2.62),('325','2014-01-13','10:55:00',2.66),('325','2014-01-13','11:00:00',2.71),('325','2014-01-13','11:05:00',2.73),('325','2014-01-13','11:10:00',2.76),('325','2014-01-13','11:15:00',2.81),('325','2014-01-13','11:20:00',2.84),('325','2014-01-13','11:25:00',2.88),('325','2014-01-13','11:30:00',2.9),('325','2014-01-13','11:35:00',2.92),('325','2014-01-13','11:40:00',2.92),('325','2014-01-13','11:45:00',2.93),('325','2014-01-13','11:50:00',2.92),('325','2014-01-13','11:55:00',2.94),('325','2014-01-13','12:00:00',2.91),('325','2014-01-13','12:05:00',2.85),('325','2014-01-13','12:10:00',2.87),('325','2014-01-13','12:15:00',2.89),('325','2014-01-13','12:20:00',2.92),('325','2014-01-13','12:25:00',2.92),('325','2014-01-13','12:30:00',2.95),('325','2014-01-13','12:35:00',2.88),('325','2014-01-13','12:40:00',2.86),('325','2014-01-13','12:45:00',2.87),('325','2014-01-13','12:50:00',2.75),('325','2014-01-13','12:55:00',2.67),('325','2014-01-13','13:00:00',2.67),('325','2014-01-13','13:05:00',2.71),('325','2014-01-13','13:10:00',2.65),('325','2014-01-13','13:15:00',2.64),('325','2014-01-13','13:20:00',2.66),('325','2014-01-13','13:25:00',2.65),('325','2014-01-13','13:30:00',2.55),('325','2014-01-13','13:35:00',2.51),('325','2014-01-13','13:40:00',2.45),('325','2014-01-13','13:45:00',2.44),('325','2014-01-13','13:50:00',2.4),('325','2014-01-13','13:55:00',2.37),('325','2014-01-13','14:00:00',2.34),('325','2014-01-13','14:05:00',2.22),('325','2014-01-13','14:10:00',2.24),('325','2014-01-13','14:15:00',2.19),('325','2014-01-13','14:20:00',2.18),('325','2014-01-13','14:25:00',2.11),('325','2014-01-13','14:30:00',2.04),('325','2014-01-13','14:35:00',1.96),('325','2014-01-13','14:40:00',1.93),('325','2014-01-13','14:45:00',1.89),('325','2014-01-13','14:50:00',1.79),('325','2014-01-13','14:55:00',1.71),('325','2014-01-13','15:00:00',1.67),('325','2014-01-13','15:05:00',1.61),('325','2014-01-13','15:10:00',1.52),('325','2014-01-13','15:15:00',1.43),('325','2014-01-13','15:20:00',1.35),('325','2014-01-13','15:25:00',1.26),('325','2014-01-13','15:30:00',1.17),('325','2014-01-13','15:35:00',1.07),('325','2014-01-12','09:50:00',1.02),('325','2014-01-12','09:55:00',1.01),('325','2014-01-12','10:20:00',1.15),('325','2014-01-12','10:25:00',1.11),('325','2014-01-12','10:30:00',1.14),('325','2014-01-12','10:35:00',1.31),('325','2014-01-12','10:40:00',1.48),('325','2014-01-12','10:45:00',1.44),('325','2014-01-12','10:50:00',1.59),('325','2014-01-12','10:55:00',1.72),('325','2014-01-12','11:00:00',1.62),('325','2014-01-12','11:05:00',1.73),('325','2014-01-12','11:10:00',2.03),('325','2014-01-12','11:15:00',1.8),('325','2014-01-12','11:20:00',1.57),('325','2014-01-12','11:25:00',1.56),('325','2014-01-12','11:30:00',1.7),('325','2014-01-12','11:35:00',1.47),('325','2014-01-12','11:40:00',2.06),('325','2014-01-12','11:45:00',2.52),('325','2014-01-12','11:50:00',2.37),('325','2014-01-12','11:55:00',2.09),('325','2014-01-12','12:00:00',1.56),('325','2014-01-12','12:05:00',1.57),('325','2014-01-12','12:10:00',1.3),('325','2014-01-12','12:20:00',1.27),('325','2014-01-12','12:25:00',1.23),('325','2014-01-12','12:30:00',1.28),('325','2014-01-12','12:35:00',1.34),('325','2014-01-12','12:40:00',1.47),('325','2014-01-12','12:45:00',1.42),('325','2014-01-12','12:50:00',1.48),('325','2014-01-12','12:55:00',1.43),('325','2014-01-12','13:00:00',1.46),('325','2014-01-12','13:05:00',1.35),('325','2014-01-12','13:10:00',1.22),('325','2014-01-12','13:15:00',1.12),('325','2014-01-12','13:20:00',1.05),('325','2014-01-12','13:25:00',1.35),('325','2014-01-12','13:30:00',1.55),('325','2014-01-12','13:35:00',1.41),('325','2014-01-12','13:40:00',1.24),('325','2014-01-12','13:45:00',1.09),('325','2014-01-11','09:55:00',1.34),('325','2014-01-11','10:00:00',1.42),('325','2014-01-11','10:05:00',1.19),('325','2014-01-11','10:10:00',1.22),('325','2014-01-11','10:15:00',1.53),('325','2014-01-11','10:20:00',1.67),('325','2014-01-11','10:25:00',1.98),('325','2014-01-11','10:30:00',1.98),('325','2014-01-11','10:35:00',2.07),('325','2014-01-11','10:40:00',2.61),('325','2014-01-11','10:45:00',2.75),('325','2014-01-11','10:50:00',2.78),('325','2014-01-11','10:55:00',2.77),('325','2014-01-11','11:00:00',2.67),('325','2014-01-11','11:05:00',2.6),('325','2014-01-11','11:10:00',2.75),('325','2014-01-11','11:15:00',2.46),('325','2014-01-11','11:20:00',2.32),('325','2014-01-11','11:25:00',2.33),('325','2014-01-11','11:30:00',2.34),('325','2014-01-11','11:35:00',2.08),('325','2014-01-11','11:40:00',1.88),('325','2014-01-11','11:45:00',1.92),('325','2014-01-11','11:50:00',2.13),('325','2014-01-11','11:55:00',2.13),('325','2014-01-11','12:00:00',2.22),('325','2014-01-11','12:05:00',2.48),('325','2014-01-11','12:10:00',2.26),('325','2014-01-11','12:15:00',2.27),('325','2014-01-11','12:20:00',2.29),('325','2014-01-11','12:25:00',2.09),('325','2014-01-11','12:30:00',1.97),('325','2014-01-11','12:35:00',1.82),('325','2014-01-11','12:40:00',1.72),('325','2014-01-11','12:45:00',1.94),('325','2014-01-11','12:50:00',2.34),('325','2014-01-11','12:55:00',2.41),('325','2014-01-11','13:00:00',2.2),('325','2014-01-11','13:05:00',2.04),('325','2014-01-11','13:10:00',1.86),('325','2014-01-11','13:15:00',2.34),('325','2014-01-11','13:20:00',2.01),('325','2014-01-11','13:25:00',1.68),('325','2014-01-11','13:30:00',1.37),('325','2014-01-11','13:35:00',1.4),('325','2014-01-11','13:40:00',1.32),('325','2014-01-11','13:45:00',1.43),('325','2014-01-11','13:50:00',1.03),('325','2014-01-11','13:55:00',1.21),('325','2014-01-11','14:00:00',1.6),('325','2014-01-11','14:05:00',1.7),('325','2014-01-11','14:10:00',1.36),('325','2014-01-10','13:05:00',1.01),('325','2014-01-09','09:30:00',1.18),('325','2014-01-09','09:35:00',1.04),('325','2014-01-09','09:40:00',1.25),('325','2014-01-09','09:45:00',1.68),('325','2014-01-09','09:50:00',1.78),('325','2014-01-09','09:55:00',1.76),('325','2014-01-09','10:00:00',1.8),('325','2014-01-09','10:05:00',1.74),('325','2014-01-09','10:10:00',1.62),('325','2014-01-09','10:15:00',1.81),('325','2014-01-09','10:20:00',1.88),('325','2014-01-09','10:25:00',2.07),('325','2014-01-09','10:30:00',2.13),('325','2014-01-09','10:35:00',2.2),('325','2014-01-09','10:40:00',2.48),('325','2014-01-09','10:45:00',1.91),('325','2014-01-09','10:50:00',1.22),('325','2014-01-09','10:55:00',1.33),('325','2014-01-09','11:00:00',1.6),('325','2014-01-09','11:05:00',1.42),('325','2014-01-09','11:10:00',1.14),('325','2014-01-09','11:15:00',1.34),('325','2014-01-09','11:20:00',1.83),('325','2014-01-09','11:25:00',1.49),('325','2014-01-09','11:30:00',1.48),('325','2014-01-09','11:35:00',1.8),('325','2014-01-09','11:40:00',1.61),('325','2014-01-09','11:45:00',1.11),('325','2014-01-09','13:05:00',1.04),('325','2014-01-09','13:10:00',1.08),('325','2014-01-09','13:15:00',1.12),('325','2014-01-09','13:20:00',1.06),('325','2014-01-09','13:25:00',1.02),('325','2014-01-08','09:25:00',1.05),('325','2014-01-08','09:30:00',1.05),('325','2014-01-08','09:35:00',1.05),('325','2014-01-08','09:40:00',1.17),('325','2014-01-08','09:45:00',1.2),('325','2014-01-08','09:50:00',1.24),('325','2014-01-08','09:55:00',1.32),('325','2014-01-08','10:00:00',1.38),('325','2014-01-08','10:05:00',1.33),('325','2014-01-08','10:10:00',1.59),('325','2014-01-08','10:15:00',2.16),('325','2014-01-08','10:20:00',2.24),('325','2014-01-08','10:25:00',2.42),('325','2014-01-08','10:30:00',2.51),('325','2014-01-08','10:35:00',2.43),('325','2014-01-08','10:40:00',2.4),('325','2014-01-08','10:45:00',2.62),('325','2014-01-08','10:50:00',2.69),('325','2014-01-08','10:55:00',2.72),('325','2014-01-08','11:00:00',2.74),('325','2014-01-08','11:05:00',2.79),('325','2014-01-08','11:10:00',2.81),('325','2014-01-08','11:15:00',2.84),('325','2014-01-08','11:20:00',2.86),('325','2014-01-08','11:25:00',2.86),('325','2014-01-08','11:30:00',2.88),('325','2014-01-08','11:35:00',2.97),('325','2014-01-08','11:40:00',3.03),('325','2014-01-08','11:45:00',2.99),('325','2014-01-08','11:50:00',2.99),('325','2014-01-08','11:55:00',2.94),('325','2014-01-08','12:00:00',2.92),('325','2014-01-08','12:05:00',2.88),('325','2014-01-08','12:10:00',2.91),('325','2014-01-08','12:15:00',2.9),('325','2014-01-08','12:20:00',2.9),('325','2014-01-08','12:25:00',2.91),('325','2014-01-08','12:30:00',2.95),('325','2014-01-08','12:35:00',2.94),('325','2014-01-08','12:40:00',2.8),('325','2014-01-08','12:45:00',2.71),('325','2014-01-08','12:50:00',2.66),('325','2014-01-08','12:55:00',2.76),('325','2014-01-08','13:00:00',2.75),('325','2014-01-08','13:05:00',2.81),('325','2014-01-08','13:10:00',2.74),('325','2014-01-08','13:15:00',2.67),('325','2014-01-08','13:20:00',2.68),('325','2014-01-08','13:25:00',2.61),('325','2014-01-08','13:30:00',2.59),('325','2014-01-08','13:35:00',2.53),('325','2014-01-08','13:40:00',2.48),('325','2014-01-08','13:45:00',2.45),('325','2014-01-08','13:50:00',2.43),('325','2014-01-08','13:55:00',2.4),('325','2014-01-08','14:00:00',2.35),('325','2014-01-08','14:05:00',2.34),('325','2014-01-08','14:10:00',2.29),('325','2014-01-08','14:15:00',2.22),('325','2014-01-08','14:20:00',2.25),('325','2014-01-08','14:25:00',2.21),('325','2014-01-08','14:30:00',2.22),('325','2014-01-08','14:35:00',2.11),('325','2014-01-08','14:40:00',1.91),('325','2014-01-08','14:45:00',1.81),('325','2014-01-08','14:50:00',1.77),('325','2014-01-08','14:55:00',1.43),('325','2014-01-08','15:00:00',1.4),('325','2014-01-08','15:05:00',1.27),('325','2014-01-08','15:10:00',1.15),('325','2014-01-08','15:15:00',1.21),('325','2014-01-08','15:20:00',1.33),('325','2014-01-08','15:25:00',1.17),('325','2014-01-08','15:30:00',1.05),('325','2014-01-07','09:30:00',1.04),('325','2014-01-07','09:35:00',1.08),('325','2014-01-07','09:40:00',1.12),('325','2014-01-07','09:45:00',1.16),('325','2014-01-07','09:50:00',1.2),('325','2014-01-07','09:55:00',1.24),('325','2014-01-07','10:00:00',1.27),('325','2014-01-07','10:05:00',1.74),('325','2014-01-07','10:10:00',2.16),('325','2014-01-07','10:15:00',2.35),('325','2014-01-07','10:20:00',2.47),('325','2014-01-07','10:25:00',2.55),('325','2014-01-07','10:30:00',2.59),('325','2014-01-07','10:35:00',2.63),('325','2014-01-07','10:40:00',2.68),('325','2014-01-07','10:45:00',2.74),('325','2014-01-07','10:50:00',2.79),('325','2014-01-07','10:55:00',2.84),('325','2014-01-07','11:00:00',2.87),('325','2014-01-07','11:05:00',2.92),('325','2014-01-07','11:10:00',2.94),('325','2014-01-07','11:15:00',2.97),('325','2014-01-07','11:20:00',2.99),('325','2014-01-07','11:25:00',3.01),('325','2014-01-07','11:30:00',3),('325','2014-01-07','11:35:00',3.02),('325','2014-01-07','11:40:00',3.04),('325','2014-01-07','11:45:00',3.06),('325','2014-01-07','11:50:00',3.08),('325','2014-01-07','11:55:00',3.06),('325','2014-01-07','12:00:00',3.06),('325','2014-01-07','12:05:00',3.06),('325','2014-01-07','12:10:00',3.07),('325','2014-01-07','12:15:00',3.02),('325','2014-01-07','12:20:00',3.02),('325','2014-01-07','12:25:00',3.04),('325','2014-01-07','12:30:00',2.98),('325','2014-01-07','12:35:00',2.97),('325','2014-01-07','12:40:00',2.94),('325','2014-01-07','12:45:00',2.96),('325','2014-01-07','12:50:00',2.89),('325','2014-01-07','12:55:00',2.88),('325','2014-01-07','13:00:00',2.78),('325','2014-01-07','13:05:00',2.74),('325','2014-01-07','13:10:00',2.75),('325','2014-01-07','13:15:00',2.79),('325','2014-01-07','13:20:00',2.78),('325','2014-01-07','13:25:00',2.65),('325','2014-01-07','13:30:00',2.59),('325','2014-01-07','13:35:00',2.62),('325','2014-01-07','13:40:00',2.6),('325','2014-01-07','13:45:00',2.67),('325','2014-01-07','13:50:00',2.66),('325','2014-01-07','13:55:00',2.55),('325','2014-01-07','14:00:00',2.51),('325','2014-01-07','14:05:00',2.39),('325','2014-01-07','14:10:00',2.33),('325','2014-01-07','14:15:00',2.3),('325','2014-01-07','14:20:00',2.26),('325','2014-01-07','14:25:00',2.17),('325','2014-01-07','14:30:00',2.11),('325','2014-01-07','14:35:00',2.08),('325','2014-01-07','14:40:00',2.03),('325','2014-01-07','14:45:00',1.91),('325','2014-01-07','14:50:00',1.93),('325','2014-01-07','14:55:00',1.79),('325','2014-01-07','15:00:00',1.76),('325','2014-01-07','15:05:00',1.72),('325','2014-01-07','15:10:00',1.62),('325','2014-01-07','15:15:00',1.51),('325','2014-01-07','15:20:00',1.43),('325','2014-01-07','15:25:00',1.31),('325','2014-01-07','15:30:00',1.17),('325','2014-01-07','15:35:00',1.02),('325','2014-01-06','11:15:00',1.24),('325','2014-01-06','11:20:00',1.02),('325','2014-01-06','11:25:00',1.08),('325','2014-01-06','11:35:00',1.54),('325','2014-01-06','11:40:00',3.45),('325','2014-01-06','11:45:00',2.89),('325','2014-01-06','11:50:00',3.24),('325','2014-01-06','11:55:00',3.27),('325','2014-01-06','12:00:00',3.25),('325','2014-01-06','12:05:00',3.22),('325','2014-01-06','12:10:00',3.08),('325','2014-01-06','12:15:00',3.09),('325','2014-01-06','12:20:00',3.09),('325','2014-01-06','12:25:00',3.05),('325','2014-01-06','12:30:00',3.05),('325','2014-01-06','12:35:00',3.03),('325','2014-01-06','12:40:00',3.01),('325','2014-01-06','12:45:00',3),('325','2014-01-06','12:50:00',2.99),('325','2014-01-06','12:55:00',2.94),('325','2014-01-06','13:00:00',2.9),('325','2014-01-06','13:05:00',2.86),('325','2014-01-06','13:10:00',2.88),('325','2014-01-06','13:15:00',2.97),('325','2014-01-06','13:20:00',2.85),('325','2014-01-06','13:25:00',2.83),('325','2014-01-06','13:30:00',2.74),('325','2014-01-06','13:35:00',2.69),('325','2014-01-06','13:40:00',2.65),('325','2014-01-06','13:45:00',2.52),('325','2014-01-06','13:50:00',2.47),('325','2014-01-06','13:55:00',2.5),('325','2014-01-06','14:00:00',2.28),('325','2014-01-06','14:05:00',1.02),('325','2014-01-06','14:10:00',1.14),('325','2014-01-06','14:15:00',2.36),('325','2014-01-06','14:20:00',2.09),('325','2014-01-06','14:35:00',1.91),('325','2014-01-06','14:40:00',2.27),('325','2014-01-06','14:45:00',2.4),('325','2014-01-06','14:50:00',1.89),('325','2014-01-06','14:55:00',1.9),('325','2014-01-06','15:00:00',1.72),('325','2014-01-06','15:05:00',1.64),('325','2014-01-06','15:10:00',1.58),('325','2014-01-06','15:15:00',1.35),('325','2014-01-06','15:20:00',1.35),('325','2014-01-06','15:25:00',1.31),('325','2014-01-06','15:30:00',1.22),('325','2014-04-23','13:10:00',1.01),('325','2014-04-23','13:15:00',1.19),('325','2014-04-23','13:20:00',1.33),('325','2014-04-23','13:25:00',1.39),('325','2014-04-23','13:30:00',1.5),('325','2014-04-23','13:35:00',1.55),('325','2014-04-23','13:40:00',1.64),('325','2014-04-23','13:45:00',1.66),('325','2014-04-23','13:50:00',1.64),('325','2014-04-23','13:55:00',1.64),('325','2014-04-23','14:00:00',1.57),('325','2014-04-23','14:05:00',1.56),('325','2014-04-23','14:10:00',1.51),('325','2014-04-23','14:15:00',1.27),('325','2014-04-23','14:20:00',1.07),('325','2014-04-23','14:45:00',1.04),('325','2014-04-23','14:50:00',1.26),('325','2014-04-23','14:55:00',1.46),('325','2014-04-23','15:00:00',1.66),('325','2014-04-23','15:05:00',1.77),('325','2014-04-23','15:10:00',1.74),('325','2014-04-23','15:15:00',1.81),('325','2014-04-23','15:20:00',1.57),('325','2014-04-23','15:25:00',1.42),('325','2014-04-23','15:30:00',1.34),('325','2014-04-23','15:35:00',1.28),('325','2014-04-23','15:40:00',1.27),('325','2014-04-23','15:45:00',1.43),('325','2014-04-23','15:50:00',1.15),('325','2014-04-23','15:55:00',1.05),('325','2014-01-03','09:30:00',1.03),('325','2014-01-03','09:35:00',1.27),('325','2014-01-03','09:40:00',1.58),('325','2014-01-03','09:45:00',1.56),('325','2014-01-03','09:50:00',1.12),('325','2014-01-03','09:55:00',1.16),('325','2014-01-03','10:00:00',1.55),('325','2014-01-03','10:05:00',1.25),('325','2014-01-03','10:10:00',2.01),('325','2014-01-03','10:15:00',1.71),('325','2014-01-03','10:20:00',1.81),('325','2014-01-03','10:25:00',1.02),('325','2014-01-03','10:35:00',1.03),('325','2014-01-03','10:40:00',1.09),('325','2014-01-03','10:45:00',1.3),('325','2014-01-03','10:50:00',1.2),('325','2014-01-03','11:30:00',1.1),('325','2014-01-03','11:35:00',1.27),('325','2014-01-03','11:40:00',1.52),('325','2014-01-03','11:45:00',1.5),('325','2014-01-03','11:50:00',1.38),('325','2014-01-03','11:55:00',1.42),('325','2014-01-03','12:00:00',1.95),('325','2014-01-03','12:05:00',2.07),('325','2014-01-03','12:10:00',2.36),('325','2014-01-03','12:15:00',3.35),('325','2014-01-03','12:20:00',3.24),('325','2014-01-03','12:25:00',2.79),('325','2014-01-03','12:30:00',2.46),('325','2014-01-03','12:35:00',2.02),('325','2014-01-03','12:40:00',2.05),('325','2014-01-03','12:45:00',2.07),('325','2014-01-03','12:50:00',1.91),('325','2014-01-03','12:55:00',1.49),('325','2014-01-03','13:00:00',1.22),('325','2014-01-03','13:05:00',1.96),('325','2014-01-03','13:10:00',1.44),('325','2014-01-03','13:15:00',1.29),('325','2014-01-03','13:20:00',1.11),('325','2014-01-03','13:25:00',1.19),('325','2014-01-03','13:30:00',1.63),('325','2014-01-03','13:35:00',1.83),('325','2014-01-03','13:40:00',1.49),('325','2014-01-03','13:45:00',1.2),('325','2014-01-02','09:30:00',1.02),('325','2014-01-02','09:35:00',1.06),('325','2014-01-02','09:40:00',1.1),('325','2014-01-02','09:45:00',1.16),('325','2014-01-02','09:50:00',1.19),('325','2014-01-02','09:55:00',1.23),('325','2014-01-02','10:00:00',1.27),('325','2014-01-02','10:05:00',1.56),('325','2014-01-02','10:10:00',2.17),('325','2014-01-02','10:15:00',2.36),('325','2014-01-02','10:20:00',2.5),('325','2014-01-02','10:25:00',2.51),('325','2014-01-02','10:30:00',2.57),('325','2014-01-02','10:35:00',2.59),('325','2014-01-02','10:40:00',2.6),('325','2014-01-02','10:45:00',2.66),('325','2014-01-02','10:50:00',2.73),('325','2014-01-02','10:55:00',2.9),('325','2014-01-02','11:00:00',2.8),('325','2014-01-02','11:05:00',2.79),('325','2014-01-02','11:10:00',2.15),('325','2014-01-02','11:15:00',1.8),('325','2014-01-02','11:20:00',1.8),('325','2014-01-02','11:25:00',1.86),('325','2014-01-02','11:30:00',1.97),('325','2014-01-02','11:35:00',2.62),('325','2014-01-02','11:40:00',2),('325','2014-01-02','11:45:00',1.86),('325','2014-01-02','11:50:00',1.38),('325','2014-01-02','11:55:00',1.28),('325','2014-01-02','12:00:00',1.11),('325','2014-01-02','12:05:00',1.16),('325','2014-01-02','12:10:00',1.07),('325','2014-01-02','12:45:00',1.06),('325','2014-01-02','12:50:00',1.69),('325','2014-01-02','12:55:00',1.52),('325','2014-01-02','13:30:00',1.2),('325','2014-01-02','13:35:00',2.63),('325','2014-01-02','13:40:00',2.16),('325','2014-01-02','13:45:00',1.21),('325','2014-01-01','09:05:00',1.11),('325','2014-01-01','09:30:00',1.12),('325','2014-01-01','09:35:00',1.33),('325','2014-01-01','09:40:00',1.23),('325','2014-01-01','09:45:00',1.52),('325','2014-01-01','09:50:00',1.91),('325','2014-01-01','09:55:00',1.77),('325','2014-01-01','10:00:00',1.39),('325','2014-01-01','10:05:00',1.17),('325','2014-01-01','11:25:00',1.03),('325','2014-01-01','11:30:00',1.04),('325','2014-01-01','11:35:00',1),('325','2014-01-01','11:55:00',1.03),('325','2014-01-01','12:00:00',1.14),('325','2014-01-01','12:05:00',1.21),('325','2014-01-01','12:10:00',1.28),('325','2014-01-01','12:15:00',1.32),('325','2014-01-01','12:20:00',1.35),('325','2014-01-01','12:25:00',1.36),('325','2014-01-01','12:30:00',1.35),('325','2014-01-01','12:35:00',1.35),('325','2014-01-01','12:40:00',1.25),('325','2014-01-01','12:45:00',1.28),('325','2014-01-01','12:50:00',1.31),('325','2014-01-01','12:55:00',1.3),('325','2014-01-01','13:00:00',1.28),('325','2014-01-01','13:05:00',1.18),('325','2014-01-01','13:10:00',1.13),('325','2014-01-01','13:15:00',1.12),('325','2014-01-01','13:20:00',1.24),('325','2014-01-01','13:25:00',1.33),('325','2014-01-01','13:30:00',1.41),('325','2014-01-01','13:35:00',1.59),('325','2014-01-01','13:40:00',1.46),('325','2014-01-01','13:45:00',1.31),('325','2014-01-01','13:50:00',1.78),('325','2014-01-01','13:55:00',2.24),('325','2014-01-01','14:00:00',1.79),('325','2014-01-01','14:05:00',1.23),('325','2014-01-01','14:10:00',1.2),('325','2014-01-01','14:15:00',1.36),('325','2014-01-01','14:20:00',1.12),('325','2014-01-01','15:00:00',1.01),('325','2014-01-01','15:05:00',1.49),('325','2014-01-01','15:10:00',1.77),('325','2014-01-01','15:15:00',1.53),('325','2014-01-01','15:20:00',1.37),('325','2014-01-01','15:25:00',1.23),('325','2014-01-01','15:30:00',1.09),('325','2013-12-31','09:20:00',1.03),('325','2013-12-31','09:25:00',1.09),('325','2013-12-31','09:30:00',1.22),('325','2013-12-31','09:35:00',1.29),('325','2013-12-31','09:40:00',1.09),('325','2013-12-31','09:50:00',1.54),('325','2013-12-31','09:55:00',1.27),('325','2013-12-31','10:00:00',1.35),('325','2013-12-31','10:05:00',1.15),('325','2013-12-31','10:45:00',1.06),('325','2013-12-31','10:50:00',1.47),('325','2013-12-31','10:55:00',1.71),('325','2013-12-31','11:00:00',1.36),('325','2013-12-31','11:05:00',1.41),('325','2013-12-31','11:10:00',1.43),('325','2013-12-31','11:15:00',2.15),('325','2013-12-31','11:20:00',1.46),('325','2013-12-31','11:25:00',2.38),('325','2013-12-31','11:30:00',3.61),('325','2013-12-31','11:35:00',2.3),('325','2013-12-31','11:40:00',2.75),('325','2013-12-31','11:50:00',1.36),('325','2013-12-31','11:55:00',1.91),('325','2013-12-31','12:00:00',3.41),('325','2013-12-31','12:05:00',3.27),('325','2013-12-31','12:10:00',3.23),('325','2013-12-31','12:15:00',3.2),('325','2013-12-31','12:20:00',3.17),('325','2013-12-31','12:25:00',3.14),('325','2013-12-31','12:30:00',3.11),('325','2013-12-31','12:35:00',3.06),('325','2013-12-31','12:40:00',3.04),('325','2013-12-31','12:45:00',3.03),('325','2013-12-31','12:50:00',3),('325','2013-12-31','12:55:00',2.97),('325','2013-12-31','13:00:00',2.97),('325','2013-12-31','13:05:00',2.94),('325','2013-12-31','13:10:00',2.91),('325','2013-12-31','13:15:00',2.88),('325','2013-12-31','13:20:00',2.86),('325','2013-12-31','13:25:00',2.82),('325','2013-12-31','13:30:00',2.78),('325','2013-12-31','13:35:00',2.73),('325','2013-12-31','13:40:00',2.68),('325','2013-12-31','13:45:00',2.63),('325','2013-12-31','13:50:00',2.58),('325','2013-12-31','13:55:00',2.53),('325','2013-12-31','14:00:00',2.46),('325','2013-12-31','14:05:00',2.41),('325','2013-12-31','14:10:00',2.35),('325','2013-12-31','14:15:00',2.29),('325','2013-12-31','14:20:00',2.23),('325','2013-12-31','14:25:00',2.17),('325','2013-12-31','14:30:00',2.1),('325','2013-12-31','14:35:00',2.02),('325','2013-12-31','14:40:00',1.95),('325','2013-12-31','14:45:00',1.86),('325','2013-12-31','14:50:00',1.78),('325','2013-12-31','14:55:00',1.69),('325','2013-12-31','15:00:00',1.62),('325','2013-12-31','15:05:00',1.53),('325','2013-12-31','15:10:00',1.43),('325','2013-12-31','15:15:00',1.36),('325','2013-12-31','15:20:00',1.26),('325','2013-12-31','15:25:00',1.17),('325','2013-12-31','15:30:00',1.09),('325','2013-12-30','11:25:00',1.09),('325','2013-12-30','11:30:00',1.07),('325','2013-12-30','11:35:00',1.01),('325','2013-12-29','09:15:00',1.06),('325','2013-12-29','09:20:00',1.1),('325','2013-12-29','09:25:00',1.07),('325','2013-12-29','09:30:00',1.12),('325','2013-12-29','09:35:00',1.15),('325','2013-12-29','09:40:00',1.22),('325','2013-12-29','09:45:00',1.28),('325','2013-12-29','09:50:00',1.26),('325','2013-12-29','09:55:00',1.16),('325','2013-12-29','10:00:00',1.21),('325','2013-12-29','10:05:00',1.49),('325','2013-12-29','10:10:00',2.28),('325','2013-12-29','10:15:00',2.33),('325','2013-12-29','10:20:00',2.62),('325','2013-12-29','10:25:00',2.29),('325','2013-12-29','10:30:00',3.11),('325','2013-12-29','10:35:00',3.29),('325','2013-12-29','10:40:00',1.63),('325','2013-12-29','10:45:00',1.36),('325','2013-12-29','10:50:00',1.05),('325','2013-12-29','10:55:00',1.41),('325','2013-12-29','11:05:00',1.07),('325','2013-12-28','09:25:00',1.01),('325','2013-12-28','09:30:00',1.05),('325','2013-12-28','09:35:00',1.09),('325','2013-12-28','09:40:00',1.13),('325','2013-12-28','09:45:00',1.18),('325','2013-12-28','09:50:00',1.21),('325','2013-12-28','09:55:00',1.25),('325','2013-12-28','10:00:00',1.29),('325','2013-12-28','10:05:00',1.82),('325','2013-12-28','10:10:00',2.32),('325','2013-12-28','10:15:00',2.44),('325','2013-12-28','10:20:00',2.51),('325','2013-12-28','10:25:00',2.58),('325','2013-12-28','10:30:00',2.62),('325','2013-12-28','10:35:00',2.68),('325','2013-12-28','10:40:00',2.72),('325','2013-12-28','10:45:00',2.75),('325','2013-12-28','10:50:00',2.8),('325','2013-12-28','10:55:00',2.84),('325','2013-12-28','11:00:00',2.88),('325','2013-12-28','11:05:00',2.91),('325','2013-12-28','11:10:00',2.94),('325','2013-12-28','11:15:00',2.96),('325','2013-12-28','11:20:00',3),('325','2013-12-28','11:25:00',3),('325','2013-12-28','11:30:00',3.02),('325','2013-12-28','11:35:00',3.02),('325','2013-12-28','11:40:00',3.02),('325','2013-12-28','11:45:00',3.04),('325','2013-12-28','11:50:00',3.05),('325','2013-12-28','11:55:00',3.05),('325','2013-12-28','12:00:00',3.03),('325','2013-12-28','12:05:00',3.03),('325','2013-12-28','12:10:00',3.05),('325','2013-12-28','12:15:00',3.02),('325','2013-12-28','12:20:00',3),('325','2013-12-28','12:25:00',2.97),('325','2013-12-28','12:30:00',2.96),('325','2013-12-28','12:35:00',2.97),('325','2013-12-28','12:40:00',2.94),('325','2013-12-28','12:45:00',2.92),('325','2013-12-28','12:50:00',2.85),('325','2013-12-28','12:55:00',2.86),('325','2013-12-28','13:00:00',2.82),('325','2013-12-28','13:05:00',2.77),('325','2013-12-28','13:10:00',2.75),('325','2013-12-28','13:15:00',2.74),('325','2013-12-28','13:20:00',2.66),('325','2013-12-28','13:25:00',2.56),('325','2013-12-28','13:30:00',2.51),('325','2013-12-28','13:35:00',2.49),('325','2013-12-28','13:40:00',2.45),('325','2013-12-28','13:45:00',2.43),('325','2013-12-28','13:50:00',2.4),('325','2013-12-28','13:55:00',2.34),('325','2013-12-28','14:00:00',2.25),('325','2013-12-28','14:05:00',2.19),('325','2013-12-28','14:10:00',2.12),('325','2013-12-28','14:15:00',2.01),('325','2013-12-28','14:20:00',1.99),('325','2013-12-28','14:25:00',1.96),('325','2013-12-28','14:30:00',1.9),('325','2013-12-28','14:35:00',1.85),('325','2013-12-28','14:40:00',1.81),('325','2013-12-28','14:45:00',1.45),('325','2013-12-28','14:50:00',1.14),('325','2013-12-28','15:00:00',1.27),('325','2013-12-28','15:05:00',1.5),('325','2013-12-28','15:10:00',1.36),('325','2013-12-28','15:15:00',1.27),('325','2013-12-28','15:20:00',1.18),('325','2013-12-28','15:25:00',1.08),('325','2013-12-27','12:05:00',1.09),('325','2013-12-27','12:10:00',2.23),('325','2013-12-27','12:15:00',1.67),('325','2013-12-27','12:20:00',2.08),('325','2013-12-27','12:25:00',1.39),('325','2013-12-27','12:30:00',1.12),('325','2013-12-27','12:35:00',1.43),('325','2013-12-27','12:40:00',1.77),('325','2013-12-27','12:45:00',2.36),('325','2013-12-27','12:50:00',2.75),('325','2013-12-27','12:55:00',2.79),('325','2013-12-27','13:00:00',2.81),('325','2013-12-27','13:05:00',2.64),('325','2013-12-27','13:10:00',1.65),('325','2013-12-27','13:15:00',1.64),('325','2013-12-27','13:20:00',2.35),('325','2013-12-27','13:25:00',2.1),('325','2013-12-27','13:30:00',2.87),('325','2013-12-27','13:35:00',2.38),('325','2013-12-27','13:40:00',1.45),('325','2013-12-27','13:45:00',1.28),('325','2013-12-27','13:50:00',1.1),('325','2013-12-27','14:05:00',1.11),('325','2013-12-27','14:10:00',1.3),('325','2013-12-27','14:15:00',1.35),('325','2013-12-27','14:20:00',1.28),('325','2013-12-27','14:25:00',1.23),('325','2013-12-27','14:30:00',1.28),('325','2013-12-27','14:35:00',1.36),('325','2013-12-27','14:40:00',1.43),('325','2013-12-27','14:45:00',1.33),('325','2014-04-22','08:25:00',1),('325','2014-04-22','08:30:00',1.07),('325','2014-04-22','08:35:00',1.14),('325','2014-04-22','08:40:00',1.21),('325','2014-04-22','08:45:00',1.27),('325','2014-04-22','08:50:00',1.36),('325','2014-04-22','08:55:00',1.46),('325','2014-04-22','09:00:00',1.53),('325','2014-04-22','09:05:00',1.95),('325','2014-04-22','09:10:00',1.88),('325','2014-04-22','09:15:00',1.86),('325','2014-04-22','09:20:00',2.21),('325','2014-04-22','09:25:00',2.55),('325','2014-04-22','09:30:00',2.55),('325','2014-04-22','09:35:00',2.72),('325','2014-04-22','09:40:00',2.75),('325','2014-04-22','09:45:00',3.03),('325','2014-04-22','09:50:00',2.34),('325','2014-04-22','09:55:00',1.45),('325','2014-04-22','10:00:00',1.38),('325','2014-04-22','10:05:00',1.48),('325','2014-04-22','10:10:00',1.95),('325','2014-04-22','10:15:00',2.03),('325','2014-04-22','10:20:00',3.22),('325','2014-04-22','10:25:00',2.19),('325','2014-04-22','10:30:00',3.54),('325','2014-04-22','10:35:00',3.63),('325','2014-04-22','10:40:00',3.55),('325','2014-04-22','10:45:00',3.93),('325','2014-04-22','10:50:00',4.14),('325','2014-04-22','10:55:00',3.06),('325','2014-04-22','11:00:00',2.05),('325','2014-04-22','11:05:00',2.44),('325','2014-04-22','11:10:00',1.72),('325','2014-04-22','11:15:00',1.46),('325','2014-04-22','11:20:00',1.28),('325','2014-04-22','11:25:00',1.29),('325','2014-04-22','11:30:00',1.17),('325','2014-04-22','11:35:00',1.21),('325','2014-04-22','11:40:00',1.05),('325','2014-04-22','12:00:00',1.01),('325','2014-04-22','12:05:00',1.22),('325','2014-04-22','12:10:00',1.19),('325','2014-04-22','12:15:00',1.22),('325','2014-04-22','12:20:00',1.27),('325','2014-04-22','12:25:00',1.39),('325','2014-04-22','12:30:00',1.6),('325','2014-04-22','12:35:00',1.34),('325','2014-04-22','12:40:00',1.01),('325','2014-04-22','13:15:00',1.55),('325','2014-04-22','13:20:00',2.27),('325','2014-04-22','13:25:00',2.74),('325','2014-04-22','13:30:00',2.85),('325','2014-04-22','13:35:00',2.77),('325','2014-04-22','13:40:00',3.32),('325','2014-04-22','13:45:00',3.36),('325','2014-04-22','13:50:00',2.73),('325','2014-04-22','13:55:00',1.54),('325','2014-04-22','14:00:00',1.38),('325','2014-04-22','14:05:00',2.1),('325','2014-04-22','14:10:00',3.71),('325','2014-04-22','14:15:00',3.54),('325','2014-04-22','14:20:00',4.42),('325','2014-04-22','14:25:00',2.54),('325','2014-04-22','14:30:00',2.23),('325','2014-04-22','14:35:00',2.63),('325','2014-04-22','14:40:00',3.46),('325','2014-04-22','14:45:00',4.5),('325','2014-04-22','14:50:00',3.95),('325','2014-04-22','14:55:00',2.99),('325','2014-04-22','15:00:00',1.34),('325','2014-04-22','15:05:00',1.23),('325','2014-04-22','15:10:00',1.15),('325','2014-04-22','15:15:00',1.19),('325','2014-04-22','15:20:00',1.34),('325','2014-04-22','15:25:00',1.51),('325','2014-04-22','15:30:00',1.95),('325','2014-04-22','15:35:00',2.67),('325','2014-04-22','15:40:00',2.27),('325','2014-04-22','15:45:00',2.08),('325','2014-04-22','15:50:00',2.37),('325','2014-04-22','15:55:00',1.91),('325','2014-04-22','16:00:00',2.3),('325','2014-04-22','16:05:00',1.55),('325','2014-04-22','16:10:00',1.48),('325','2014-04-22','16:15:00',1.4),('325','2014-04-22','16:20:00',1.64),('325','2014-04-22','16:25:00',1.55),('325','2014-04-22','16:30:00',1.3),('325','2014-04-22','16:35:00',1.55),('325','2014-04-22','16:40:00',1.93),('325','2014-04-22','16:45:00',1.7),('325','2014-04-22','16:50:00',1.33),('325','2014-04-22','16:55:00',1.15),('325','2014-04-22','17:00:00',1.35),('325','2014-04-22','17:05:00',1.5),('325','2014-04-22','17:10:00',1.13),('325','2013-12-25','10:25:00',1.08),('325','2013-12-25','10:30:00',1.65),('325','2013-12-25','10:35:00',1.6),('325','2013-12-25','10:40:00',1.45),('325','2013-12-25','10:45:00',1.64),('325','2013-12-25','10:50:00',1.39),('325','2013-12-25','11:10:00',1.04),('325','2013-12-25','11:15:00',1.48),('325','2013-12-25','11:20:00',2.14),('325','2013-12-25','11:25:00',1.96),('325','2013-12-25','11:30:00',1.84),('325','2013-12-25','11:40:00',2.23),('325','2013-12-25','11:45:00',2.64),('325','2013-12-25','11:50:00',1.53),('325','2013-12-25','11:55:00',2.94),('325','2013-12-25','12:00:00',1.49),('325','2013-12-25','12:05:00',1.31),('325','2013-12-25','12:10:00',1.12),('325','2013-12-25','12:15:00',1.14),('325','2013-12-25','12:20:00',1.28),('325','2013-12-25','12:25:00',1.85),('325','2013-12-25','12:30:00',1.77),('325','2013-12-25','12:45:00',1.19),('325','2013-12-25','12:50:00',1.55),('325','2013-12-25','13:10:00',1.01),('325','2013-12-25','13:25:00',1.15),('325','2013-12-25','13:30:00',1.08),('325','2013-12-25','13:35:00',1.05),('325','2013-12-25','13:40:00',1.27),('325','2013-12-25','13:45:00',1.3),('325','2013-12-25','13:50:00',1.5),('325','2013-12-25','13:55:00',1.18),('325','2013-12-25','14:00:00',1.05),('325','2013-12-25','15:15:00',1.02),('325','2013-12-24','09:30:00',1.04),('325','2013-12-24','09:35:00',1.1),('325','2013-12-24','09:40:00',1.14),('325','2013-12-24','09:45:00',1.17),('325','2013-12-24','09:50:00',1.2),('325','2013-12-24','09:55:00',1.34),('325','2013-12-24','10:00:00',1.84),('325','2013-12-24','10:05:00',1.98),('325','2013-12-24','10:10:00',2.14),('325','2013-12-24','10:15:00',2.24),('325','2013-12-24','10:20:00',2.34),('325','2013-12-24','10:25:00',2.39),('325','2013-12-24','10:30:00',2.42),('325','2013-12-24','10:35:00',2.49),('325','2013-12-24','10:40:00',2.53),('325','2013-12-24','10:45:00',2.51),('325','2013-12-24','10:50:00',2.56),('325','2013-12-24','10:55:00',2.59),('325','2013-12-24','11:00:00',2.57),('325','2013-12-24','11:05:00',2.64),('325','2013-12-24','11:10:00',2.68),('325','2013-12-24','11:15:00',2.64),('325','2013-12-24','11:20:00',2.64),('325','2013-12-24','11:25:00',2.67),('325','2013-12-24','11:30:00',2.72),('325','2013-12-24','11:35:00',2.74),('325','2013-12-24','11:40:00',2.76),('325','2013-12-24','11:45:00',2.79),('325','2013-12-24','11:50:00',2.79),('325','2013-12-24','11:55:00',2.78),('325','2013-12-24','12:00:00',2.76),('325','2013-12-24','12:05:00',2.72),('325','2013-12-24','12:10:00',2.73),('325','2013-12-24','12:15:00',2.75),('325','2013-12-24','12:20:00',2.74),('325','2013-12-24','12:25:00',2.71),('325','2013-12-24','12:30:00',2.65),('325','2013-12-24','12:35:00',2.6),('325','2013-12-24','12:40:00',2.56),('325','2013-12-24','12:45:00',2.53),('325','2013-12-24','12:50:00',2.56),('325','2013-12-24','12:55:00',2.56),('325','2013-12-24','13:00:00',2.51),('325','2013-12-24','13:05:00',2.5),('325','2013-12-24','13:10:00',2.48),('325','2013-12-24','13:15:00',2.43),('325','2013-12-24','13:20:00',2.39),('325','2013-12-24','13:25:00',2.32),('325','2013-12-24','13:30:00',2.34),('325','2013-12-24','13:35:00',2.3),('325','2013-12-24','13:40:00',2.18),('325','2013-12-24','13:45:00',2.12),('325','2013-12-24','13:50:00',2.06),('325','2013-12-24','13:55:00',1.98),('325','2013-12-24','14:00:00',1.92),('325','2013-12-24','14:05:00',1.87),('325','2013-12-24','14:10:00',1.84),('325','2013-12-24','14:15:00',1.79),('325','2013-12-24','14:20:00',1.7),('325','2013-12-24','14:25:00',1.62),('325','2013-12-24','14:30:00',1.56),('325','2013-12-24','14:35:00',1.44),('325','2013-12-24','14:40:00',1.3),('325','2013-12-24','14:45:00',1.17),('325','2013-12-24','14:50:00',1.12),('325','2013-12-24','14:55:00',1.03),('325','2013-12-23','09:40:00',1.02),('325','2013-12-23','09:45:00',1.03),('325','2013-12-23','09:50:00',1.2),('325','2013-12-23','09:55:00',1.37),('325','2013-12-23','10:00:00',1.6),('325','2013-12-23','10:05:00',1.79),('325','2013-12-23','10:10:00',2.28),('325','2013-12-23','10:15:00',2.39),('325','2013-12-23','10:20:00',2.46),('325','2013-12-23','10:25:00',2.37),('325','2013-12-23','10:30:00',2.3),('325','2013-12-23','10:35:00',2.3),('325','2013-12-23','10:40:00',2.36),('325','2013-12-23','10:45:00',2.37),('325','2013-12-23','10:50:00',2.5),('325','2013-12-23','10:55:00',2.66),('325','2013-12-23','11:00:00',2.87),('325','2013-12-23','11:05:00',2.95),('325','2013-12-23','11:10:00',2.97),('325','2013-12-23','11:15:00',2.92),('325','2013-12-23','11:20:00',2.91),('325','2013-12-23','11:25:00',2.81),('325','2013-12-23','11:30:00',2.9),('325','2013-12-23','11:35:00',3.04),('325','2013-12-23','11:40:00',2.73),('325','2013-12-23','11:45:00',2.53),('325','2013-12-23','11:50:00',2.78),('325','2013-12-23','11:55:00',2.81),('325','2013-12-23','12:00:00',2.9),('325','2013-12-23','12:05:00',2.93),('325','2013-12-23','12:10:00',2.93),('325','2013-12-23','12:15:00',2.9),('325','2013-12-23','12:20:00',2.78),('325','2013-12-23','12:25:00',2.76),('325','2013-12-23','12:30:00',2.78),('325','2013-12-23','12:35:00',2.88),('325','2013-12-23','12:40:00',2.91),('325','2013-12-23','12:45:00',2.87),('325','2013-12-23','12:50:00',2.86),('325','2013-12-23','12:55:00',2.86),('325','2013-12-23','13:00:00',2.84),('325','2013-12-23','13:05:00',2.82),('325','2013-12-23','13:10:00',2.77),('325','2013-12-23','13:15:00',2.69),('325','2013-12-23','13:20:00',2.16),('325','2013-12-23','13:25:00',2.49),('325','2013-12-23','13:30:00',2.13),('325','2013-12-23','13:35:00',1.08),('325','2013-12-23','13:40:00',2.17),('325','2013-12-23','13:45:00',1.3),('325','2013-12-23','13:50:00',2.01),('325','2013-12-23','13:55:00',2.14),('325','2013-12-23','14:00:00',2.33),('325','2013-12-23','14:05:00',2.28),('325','2013-12-23','14:10:00',2.2),('325','2013-12-23','14:15:00',2.11),('325','2013-12-23','14:20:00',2.05),('325','2013-12-23','14:25:00',1.99),('325','2013-12-23','14:30:00',1.74),('325','2013-12-23','14:35:00',1.84),('325','2013-12-23','14:40:00',1.74),('325','2013-12-23','14:45:00',1.63),('325','2013-12-23','14:50:00',1.56),('325','2013-12-23','14:55:00',1.47),('325','2013-12-23','15:00:00',1.38),('325','2013-12-23','15:05:00',1.29),('325','2013-12-23','15:10:00',1.19),('325','2013-12-23','15:15:00',1.1),('325','2013-12-22','09:20:00',1.07),('325','2013-12-22','09:25:00',1.08),('325','2013-12-22','09:30:00',1.15),('325','2013-12-22','09:35:00',1.46),('325','2013-12-22','09:40:00',1.71),('325','2013-12-22','09:45:00',1.75),('325','2013-12-22','09:50:00',1.81),('325','2013-12-22','09:55:00',1.79),('325','2013-12-22','10:00:00',1.76),('325','2013-12-22','10:05:00',2.03),('325','2013-12-22','10:10:00',2.59),('325','2013-12-22','10:15:00',2.58),('325','2013-12-22','10:20:00',2.52),('325','2013-12-22','10:25:00',2.57),('325','2013-12-22','10:30:00',2.69),('325','2013-12-22','10:35:00',2.5),('325','2013-12-22','10:40:00',2.35),('325','2013-12-22','10:45:00',2.57),('325','2013-12-22','10:50:00',2.58),('325','2013-12-22','10:55:00',2.35),('325','2013-12-22','11:00:00',2.15),('325','2013-12-22','11:05:00',2.21),('325','2013-12-22','11:10:00',2.92),('325','2013-12-22','11:15:00',2.77),('325','2013-12-22','11:20:00',2.58),('325','2013-12-22','11:25:00',2.62),('325','2013-12-22','11:30:00',2.43),('325','2013-12-22','11:35:00',2.5),('325','2013-12-22','11:40:00',2.61),('325','2013-12-22','11:45:00',2.39),('325','2013-12-22','11:50:00',1.81),('325','2013-12-22','11:55:00',1.32),('325','2013-12-22','12:00:00',1),('325','2013-12-22','12:10:00',1),('325','2013-12-22','12:15:00',1.05),('325','2013-12-22','12:20:00',1.31),('325','2013-12-22','12:25:00',1.38),('325','2013-12-22','12:30:00',1.73),('325','2013-12-22','12:35:00',1.95),('325','2013-12-22','12:40:00',1.89),('325','2013-12-22','12:45:00',1.83),('325','2013-12-22','12:50:00',2.22),('325','2013-12-22','12:55:00',2.77),('325','2013-12-22','13:00:00',2.66),('325','2013-12-22','13:05:00',3.27),('325','2013-12-22','13:10:00',3.26),('325','2013-12-22','13:15:00',2.41),('325','2013-12-22','13:20:00',2.34),('325','2013-12-22','13:25:00',2.42),('325','2013-12-22','13:30:00',2.18),('325','2013-12-22','13:35:00',2.11),('325','2013-12-22','13:40:00',1.74),('325','2013-12-22','13:45:00',2),('325','2013-12-22','13:50:00',1.75),('325','2013-12-22','13:55:00',1.62),('325','2013-12-22','14:00:00',1.42),('325','2013-12-22','14:05:00',1.68),('325','2013-12-22','14:10:00',1.78),('325','2013-12-22','14:15:00',1.3),('325','2013-12-22','14:20:00',1.4),('325','2013-12-22','14:25:00',1.12),('325','2013-12-22','14:30:00',1.13),('325','2013-12-22','14:35:00',1.44),('325','2013-12-22','14:40:00',1.46),('325','2013-12-22','14:45:00',1.39),('325','2013-12-21','09:25:00',1),('325','2013-12-21','09:30:00',1.04),('325','2013-12-21','09:35:00',1.08),('325','2013-12-21','09:40:00',1.12),('325','2013-12-21','09:45:00',1.17),('325','2013-12-21','09:50:00',1.2),('325','2013-12-21','09:55:00',1.24),('325','2013-12-21','10:00:00',1.73),('325','2013-12-21','10:05:00',2.12),('325','2013-12-21','10:10:00',2.28),('325','2013-12-21','10:15:00',2.39),('325','2013-12-21','10:20:00',2.44),('325','2013-12-21','10:25:00',2.49),('325','2013-12-21','10:30:00',2.54),('325','2013-12-21','10:35:00',2.59),('325','2013-12-21','10:40:00',2.63),('325','2013-12-21','10:45:00',2.67),('325','2013-12-21','10:50:00',2.7),('325','2013-12-21','10:55:00',2.74),('325','2013-12-21','11:00:00',2.78),('325','2013-12-21','11:05:00',2.83),('325','2013-12-21','11:10:00',2.86),('325','2013-12-21','11:15:00',2.88),('325','2013-12-21','11:20:00',2.91),('325','2013-12-21','11:25:00',2.95),('325','2013-12-21','11:30:00',2.98),('325','2013-12-21','11:35:00',2.99),('325','2013-12-21','11:40:00',3),('325','2013-12-21','11:45:00',3.01),('325','2013-12-21','11:50:00',3.01),('325','2013-12-21','11:55:00',3.02),('325','2013-12-21','12:00:00',3.02),('325','2013-12-21','12:05:00',3.03),('325','2013-12-21','12:10:00',3.03),('325','2013-12-21','12:15:00',3.02),('325','2013-12-21','12:20:00',3.01),('325','2013-12-21','12:25:00',3),('325','2013-12-21','12:30:00',2.99),('325','2013-12-21','12:35:00',2.98),('325','2013-12-21','12:40:00',2.97),('325','2013-12-21','12:45:00',2.93),('325','2013-12-21','12:50:00',2.92),('325','2013-12-21','12:55:00',2.9),('325','2013-12-21','13:00:00',2.87),('325','2013-12-21','13:05:00',2.82),('325','2013-12-21','13:10:00',2.79),('325','2013-12-21','13:15:00',2.77),('325','2013-12-21','13:20:00',2.71),('325','2013-12-21','13:25:00',2.66),('325','2013-12-21','13:30:00',2.62),('325','2013-12-21','13:35:00',2.56),('325','2013-12-21','13:40:00',2.52),('325','2013-12-21','13:45:00',2.48),('325','2013-12-21','13:50:00',2.42),('325','2013-12-21','13:55:00',2.37),('325','2013-12-21','14:00:00',2.32),('325','2013-12-21','14:05:00',2.25),('325','2013-12-21','14:10:00',2.19),('325','2013-12-21','14:15:00',2.12),('325','2013-12-21','14:20:00',2.1),('325','2013-12-21','14:25:00',2.02),('325','2013-12-21','14:30:00',1.95),('325','2013-12-21','14:35:00',1.89),('325','2013-12-21','14:40:00',1.81),('325','2013-12-21','14:45:00',1.74),('325','2013-12-21','14:50:00',1.64),('325','2013-12-21','14:55:00',1.54),('325','2013-12-21','15:00:00',1.46),('325','2013-12-21','15:05:00',1.36),('325','2013-12-21','15:10:00',1.28),('325','2013-12-21','15:15:00',1.2),('325','2013-12-21','15:20:00',1.12),('325','2013-12-21','15:25:00',1.03),('325','2013-12-20','09:30:00',1.04),('325','2013-12-20','09:35:00',1.08),('325','2013-12-20','09:40:00',1.12),('325','2013-12-20','09:45:00',1.17),('325','2013-12-20','09:50:00',1.21),('325','2013-12-20','09:55:00',1.24),('325','2013-12-20','10:00:00',1.47),('325','2013-12-20','10:05:00',2.04),('325','2013-12-20','10:10:00',2.19),('325','2013-12-20','10:15:00',2.29),('325','2013-12-20','10:20:00',2.32),('325','2013-12-20','10:25:00',2.36),('325','2013-12-20','10:30:00',2.42),('325','2013-12-20','10:35:00',2.45),('325','2013-12-20','10:40:00',2.49),('325','2013-12-20','10:45:00',2.55),('325','2013-12-20','10:50:00',2.59),('325','2013-12-20','10:55:00',2.62),('325','2013-12-20','11:00:00',2.66),('325','2013-12-20','11:05:00',2.7),('325','2013-12-20','11:10:00',2.73),('325','2013-12-20','11:15:00',2.75),('325','2013-12-20','11:20:00',2.77),('325','2013-12-20','11:25:00',2.77),('325','2013-12-20','11:30:00',2.8),('325','2013-12-20','11:35:00',2.83),('325','2013-12-20','11:40:00',2.82),('325','2013-12-20','11:45:00',2.85),('325','2013-12-20','11:50:00',2.84),('325','2013-12-20','11:55:00',2.82),('325','2013-12-20','12:00:00',2.86),('325','2013-12-20','12:05:00',2.84),('325','2013-12-20','12:10:00',2.82),('325','2013-12-20','12:15:00',2.8),('325','2013-12-20','12:20:00',2.82),('325','2013-12-20','12:25:00',2.79),('325','2013-12-20','12:30:00',2.79),('325','2013-12-20','12:35:00',2.78),('325','2013-12-20','12:40:00',2.73),('325','2013-12-20','12:45:00',2.72),('325','2013-12-20','12:50:00',2.67),('325','2013-12-20','12:55:00',2.64),('325','2013-12-20','13:00:00',2.63),('325','2013-12-20','13:05:00',2.56),('325','2013-12-20','13:10:00',2.54),('325','2013-12-20','13:15:00',2.5),('325','2013-12-20','13:20:00',2.43),('325','2013-12-20','13:25:00',2.36),('325','2013-12-20','13:30:00',2.3),('325','2013-12-20','13:35:00',2.27),('325','2013-12-20','13:40:00',2.18),('325','2013-12-20','13:45:00',2.1),('325','2013-12-20','13:50:00',2.09),('325','2013-12-20','13:55:00',2.07),('325','2013-12-20','14:00:00',1.46),('325','2013-12-20','14:05:00',1.02),('325','2013-12-20','14:10:00',1.36),('325','2013-12-19','09:00:00',1.09),('325','2013-12-19','09:05:00',1.13),('325','2013-12-19','09:10:00',1.07),('325','2013-12-19','09:20:00',1.39),('325','2013-12-19','09:25:00',1.14),('325','2013-12-19','09:30:00',1.4),('325','2013-12-19','09:35:00',1.03),('325','2013-12-19','09:50:00',1.25),('325','2013-12-19','09:55:00',1.39),('325','2013-12-19','10:00:00',1.51),('325','2013-12-19','10:05:00',2.05),('325','2013-12-19','10:10:00',2.56),('325','2013-12-19','10:15:00',2.33),('325','2013-12-19','10:20:00',1.77),('325','2013-12-19','10:25:00',1.39),('325','2013-12-19','10:35:00',1.04),('325','2013-12-19','10:40:00',1.75),('325','2013-12-19','10:45:00',2.74),('325','2013-12-19','10:50:00',1.71),('325','2013-12-19','11:15:00',1.3),('325','2013-12-19','11:20:00',1.08),('325','2013-12-19','14:25:00',1.77),('325','2013-12-19','14:30:00',2.24),('325','2013-12-19','14:35:00',1.98),('325','2013-12-19','14:40:00',1.78),('325','2013-12-19','14:45:00',1.02),('325','2013-12-18','09:25:00',1.03),('325','2013-12-18','09:30:00',1.08),('325','2013-12-18','09:35:00',1.12),('325','2013-12-18','09:40:00',1.17),('325','2013-12-18','09:45:00',1.21),('325','2013-12-18','09:50:00',1.25),('325','2013-12-18','09:55:00',1.27),('325','2013-12-18','10:00:00',1.9),('325','2013-12-18','10:05:00',2.19),('325','2013-12-18','10:10:00',2.35),('325','2013-12-18','10:15:00',2.45),('325','2013-12-18','10:20:00',2.53),('325','2013-12-18','10:25:00',2.56),('325','2013-12-18','10:30:00',2.62),('325','2013-12-18','10:35:00',2.65),('325','2013-12-18','10:40:00',2.66),('325','2013-12-18','10:45:00',2.71),('325','2013-12-18','10:50:00',2.75),('325','2013-12-18','10:55:00',2.77),('325','2013-12-18','11:00:00',2.82),('325','2013-12-18','11:05:00',2.85),('325','2013-12-18','11:10:00',2.9),('325','2013-12-18','11:15:00',2.9),('325','2013-12-18','11:20:00',2.9),('325','2013-12-18','11:25:00',2.89),('325','2013-12-18','11:30:00',2.9),('325','2013-12-18','11:35:00',2.91),('325','2013-12-18','11:40:00',2.93),('325','2013-12-18','11:45:00',2.92),('325','2013-12-18','11:50:00',2.93),('325','2013-12-18','11:55:00',2.92),('325','2013-12-18','12:00:00',2.94),('325','2013-12-18','12:05:00',2.92),('325','2013-12-18','12:10:00',2.94),('325','2013-12-18','12:15:00',2.96),('325','2013-12-18','12:20:00',2.93),('325','2013-12-18','12:25:00',2.93),('325','2013-12-18','12:30:00',2.91),('325','2013-12-18','12:35:00',2.88),('325','2013-12-18','12:40:00',2.88),('325','2013-12-18','12:45:00',2.85),('325','2013-12-18','12:50:00',2.83),('325','2013-12-18','12:55:00',2.79),('325','2013-12-18','13:00:00',2.71),('325','2013-12-18','13:05:00',2.75),('325','2013-12-18','13:10:00',2.7),('325','2013-12-18','13:15:00',2.62),('325','2013-12-18','13:20:00',2.59),('325','2013-12-18','13:25:00',2.56),('325','2013-12-18','13:30:00',2.51),('325','2013-12-18','13:35:00',2.46),('325','2013-12-18','13:40:00',2.36),('325','2013-12-18','13:45:00',2.32),('325','2013-12-18','13:50:00',2.23),('325','2013-12-18','13:55:00',2.21),('325','2013-12-18','14:00:00',2.19),('325','2013-12-18','14:05:00',2.05),('325','2013-12-18','14:10:00',2.04),('325','2013-12-18','14:15:00',2.03),('325','2013-12-18','14:20:00',1.98),('325','2013-12-18','14:25:00',1.93),('325','2013-12-18','14:30:00',1.83),('325','2013-12-18','14:35:00',1.8),('325','2013-12-18','14:40:00',1.74),('325','2013-12-18','14:45:00',1.63),('325','2013-12-18','14:50:00',1.57),('325','2013-12-18','14:55:00',1.51),('325','2013-12-18','15:00:00',1.42),('325','2013-12-18','15:05:00',1.31),('325','2013-12-18','15:10:00',1.26),('325','2013-12-18','15:15:00',1.16),('325','2013-12-18','15:20:00',1.05),('325','2013-12-17','09:25:00',1.03),('325','2013-12-17','09:30:00',1.08),('325','2013-12-17','09:35:00',1.12),('325','2013-12-17','09:40:00',1.16),('325','2013-12-17','09:45:00',1.2),('325','2013-12-17','09:50:00',1.23),('325','2013-12-17','09:55:00',1.27),('325','2013-12-17','10:00:00',2.11),('325','2013-12-17','10:05:00',2.34),('325','2013-12-17','10:10:00',2.48),('325','2013-12-17','10:15:00',2.56),('325','2013-12-17','10:20:00',2.61),('325','2013-12-17','10:25:00',2.66),('325','2013-12-17','10:30:00',2.69),('325','2013-12-17','10:35:00',2.72),('325','2013-12-17','10:40:00',2.77),('325','2013-12-17','10:45:00',2.8),('325','2013-12-17','10:50:00',2.83),('325','2013-12-17','10:55:00',2.87),('325','2013-12-17','11:00:00',2.89),('325','2013-12-17','11:05:00',2.92),('325','2013-12-17','11:10:00',2.95),('325','2013-12-17','11:15:00',2.98),('325','2013-12-17','11:20:00',3),('325','2013-12-17','11:25:00',3),('325','2013-12-17','11:30:00',3.01),('325','2013-12-17','11:35:00',3.04),('325','2013-12-17','11:40:00',3.05),('325','2013-12-17','11:45:00',3.07),('325','2013-12-17','11:50:00',3.1),('325','2013-12-17','11:55:00',3.1),('325','2013-12-17','12:00:00',3.1),('325','2013-12-17','12:05:00',3.09),('325','2013-12-17','12:10:00',3.07),('325','2013-12-17','12:15:00',3.1),('325','2013-12-17','12:20:00',3.09),('325','2013-12-17','12:25:00',3.09),('325','2013-12-17','12:30:00',3.09),('325','2013-12-17','12:35:00',3.06),('325','2013-12-17','12:40:00',3.02),('325','2013-12-17','12:45:00',3.01),('325','2013-12-17','12:50:00',2.99),('325','2013-12-17','12:55:00',2.96),('325','2013-12-17','13:00:00',2.93),('325','2013-12-17','13:05:00',2.89),('325','2013-12-17','13:10:00',2.87),('325','2013-12-17','13:15:00',2.83),('325','2013-12-17','13:20:00',2.78),('325','2013-12-17','13:25:00',2.73),('325','2013-12-17','13:30:00',2.7),('325','2013-12-17','13:35:00',2.64),('325','2013-12-17','13:40:00',2.59),('325','2013-12-17','13:45:00',2.54),('325','2013-12-17','13:50:00',2.51),('325','2013-12-17','13:55:00',2.45),('325','2013-12-17','14:00:00',2.36),('325','2013-12-17','14:05:00',2.3),('325','2013-12-17','14:10:00',2.24),('325','2013-12-17','14:15:00',2.16),('325','2013-12-17','14:20:00',2.1),('325','2013-12-17','14:25:00',2.02),('325','2013-12-17','14:30:00',1.94),('325','2013-12-17','14:35:00',1.85),('325','2013-12-17','14:40:00',1.8),('325','2013-12-17','14:45:00',1.72),('325','2013-12-17','14:50:00',1.63),('325','2013-12-17','14:55:00',1.54),('325','2013-12-17','15:00:00',1.44),('325','2013-12-17','15:05:00',1.34),('325','2013-12-17','15:10:00',1.27),('325','2013-12-17','15:15:00',1.21),('325','2013-12-17','15:20:00',1.16),('325','2013-12-17','15:25:00',1.08),('325','2014-04-21','09:20:00',1.39),('325','2014-04-21','09:25:00',1.21),('325','2014-04-21','09:55:00',1.06),('325','2014-04-21','10:00:00',1.4),('325','2014-04-21','10:05:00',2.63),('325','2014-04-21','10:10:00',3.05),('325','2014-04-21','10:15:00',3.37),('325','2014-04-21','10:20:00',3.43),('325','2014-04-21','10:25:00',3.47),('325','2014-04-21','10:30:00',3.5),('325','2014-04-21','10:35:00',3.53),('325','2014-04-21','10:40:00',3.57),('325','2014-04-21','10:45:00',3.64),('325','2014-04-21','10:50:00',3.71),('325','2014-04-21','10:55:00',3.75),('325','2014-04-21','11:00:00',3.79),('325','2014-04-21','11:05:00',3.83),('325','2014-04-21','11:10:00',3.87),('325','2014-04-21','11:15:00',3.89),('325','2014-04-21','11:20:00',3.96),('325','2014-04-21','11:25:00',4),('325','2014-04-21','11:30:00',4.03),('325','2014-04-21','11:35:00',4.06),('325','2014-04-21','11:40:00',4.12),('325','2014-04-21','11:45:00',4.14),('325','2014-04-21','11:50:00',4.21),('325','2014-04-21','11:55:00',4.25),('325','2014-04-21','12:00:00',4.29),('325','2014-04-21','12:05:00',4.32),('325','2014-04-21','12:10:00',4.35),('325','2014-04-21','12:15:00',4.38),('325','2014-04-21','12:20:00',4.41),('325','2014-04-21','12:25:00',4.42),('325','2014-04-21','12:30:00',4.44),('325','2014-04-21','12:35:00',4.45),('325','2014-04-21','12:40:00',4.48),('325','2014-04-21','12:45:00',4.51),('325','2014-04-21','12:50:00',4.53),('325','2014-04-21','12:55:00',4.52),('325','2014-04-21','13:00:00',4.53),('325','2014-04-21','13:05:00',4.54),('325','2014-04-21','13:10:00',4.51),('325','2014-04-21','13:15:00',4.53),('325','2014-04-21','13:20:00',4.53),('325','2014-04-21','13:25:00',4.52),('325','2014-04-21','13:30:00',4.49),('325','2014-04-21','13:35:00',4.47),('325','2014-04-21','13:40:00',4.49),('325','2014-04-21','13:45:00',4.51),('325','2014-04-21','13:50:00',4.54),('325','2014-04-21','13:55:00',4.54),('325','2014-04-21','14:00:00',4.52),('325','2014-04-21','14:05:00',4.53),('325','2014-04-21','14:10:00',4.51),('325','2014-04-21','14:15:00',4.48),('325','2014-04-21','14:20:00',4.47),('325','2014-04-21','14:25:00',4.43),('325','2014-04-21','14:30:00',4.41),('325','2014-04-21','14:35:00',4.35),('325','2014-04-21','14:40:00',4.3),('325','2014-04-21','14:45:00',4.29),('325','2014-04-21','14:50:00',4.26),('325','2014-04-21','14:55:00',4.22),('325','2014-04-21','15:00:00',4.18),('325','2014-04-21','15:05:00',4.14),('325','2014-04-21','15:10:00',4.06),('325','2014-04-21','15:15:00',4.02),('325','2014-04-21','15:20:00',3.97),('325','2014-04-21','15:25:00',3.92),('325','2014-04-21','15:30:00',3.85),('325','2014-04-21','15:35:00',3.8),('325','2014-04-21','15:40:00',3.74),('325','2014-04-21','15:45:00',3.68),('325','2014-04-21','15:50:00',3.62),('325','2014-04-21','15:55:00',3.55),('325','2014-04-21','16:00:00',3.51),('325','2014-04-21','16:05:00',3.45),('325','2014-04-21','16:10:00',3.39),('325','2014-04-21','16:15:00',3.53),('325','2014-04-21','16:20:00',3.24),('325','2014-04-21','16:25:00',2.94),('325','2014-04-21','16:30:00',3.06),('325','2014-04-21','16:35:00',3.02),('325','2014-04-21','16:40:00',2.93),('325','2014-04-21','16:45:00',2.82),('325','2014-04-21','16:50:00',2.68),('325','2014-04-21','16:55:00',2.53),('325','2014-04-21','17:00:00',2.43),('325','2014-04-21','17:05:00',2.44),('325','2014-04-21','17:10:00',2.34),('325','2014-04-21','17:15:00',2.23),('325','2014-04-21','17:20:00',2.13),('325','2014-04-21','17:25:00',2.06),('325','2014-04-21','17:30:00',1.97),('325','2014-04-21','17:35:00',1.88),('325','2014-04-21','17:40:00',1.67),('325','2014-04-21','17:45:00',1.69),('325','2014-04-21','17:50:00',1.58),('325','2014-04-21','17:55:00',1.49),('325','2014-04-21','18:00:00',1.38),('325','2014-04-21','18:05:00',1.28),('325','2014-04-21','18:10:00',1.18),('325','2014-04-21','18:15:00',1.06),('325','2013-12-16','09:25:00',1.04),('325','2013-12-16','09:30:00',1.08),('325','2013-12-16','09:35:00',1.13),('325','2013-12-16','09:40:00',1.17),('325','2013-12-16','09:45:00',1.2),('325','2013-12-16','09:50:00',1.24),('325','2013-12-16','09:55:00',1.27),('325','2013-12-16','10:00:00',2.08),('325','2013-12-16','10:05:00',2.31),('325','2013-12-16','10:10:00',2.45),('325','2013-12-16','10:15:00',2.51),('325','2013-12-16','10:20:00',2.54),('325','2013-12-16','10:25:00',2.55),('325','2013-12-16','10:30:00',2.58),('325','2013-12-16','10:35:00',2.63),('325','2013-12-16','10:40:00',2.69),('325','2013-12-16','10:45:00',2.73),('325','2013-12-16','10:50:00',2.75),('325','2013-12-16','10:55:00',2.76),('325','2013-12-16','11:00:00',2.81),('325','2013-12-16','11:05:00',2.85),('325','2013-12-16','11:10:00',2.83),('325','2013-12-16','11:15:00',2.85),('325','2013-12-16','11:20:00',2.88),('325','2013-12-16','11:25:00',2.92),('325','2013-12-16','11:30:00',2.94),('325','2013-12-16','11:35:00',2.95),('325','2013-12-16','11:40:00',2.98),('325','2013-12-16','11:45:00',3.03),('325','2013-12-16','11:50:00',3.04),('325','2013-12-16','11:55:00',3.05),('325','2013-12-16','12:00:00',3.07),('325','2013-12-16','12:05:00',3.07),('325','2013-12-16','12:10:00',3.07),('325','2013-12-16','12:15:00',3.07),('325','2013-12-16','12:20:00',3.06),('325','2013-12-16','12:25:00',3.06),('325','2013-12-16','12:30:00',3.06),('325','2013-12-16','12:35:00',3.02),('325','2013-12-16','12:40:00',2.99),('325','2013-12-16','12:45:00',2.97),('325','2013-12-16','12:50:00',2.96),('325','2013-12-16','12:55:00',2.93),('325','2013-12-16','13:00:00',2.9),('325','2013-12-16','13:05:00',2.9),('325','2013-12-16','13:10:00',2.86),('325','2013-12-16','13:15:00',2.8),('325','2013-12-16','13:20:00',2.74),('325','2013-12-16','13:25:00',2.69),('325','2013-12-16','13:30:00',2.65),('325','2013-12-16','13:35:00',2.57),('325','2013-12-16','13:40:00',2.54),('325','2013-12-16','13:45:00',2.49),('325','2013-12-16','13:50:00',2.45),('325','2013-12-16','13:55:00',2.39),('325','2013-12-16','14:00:00',2.31),('325','2013-12-16','14:05:00',2.27),('325','2013-12-16','14:10:00',2.22),('325','2013-12-16','14:15:00',2.15),('325','2013-12-16','14:20:00',2.1),('325','2013-12-16','14:25:00',2.03),('325','2013-12-16','14:30:00',1.93),('325','2013-12-16','14:35:00',1.86),('325','2013-12-16','14:40:00',1.79),('325','2013-12-16','14:45:00',1.7),('325','2013-12-16','14:50:00',1.59),('325','2013-12-16','14:55:00',1.51),('325','2013-12-16','15:00:00',1.42),('325','2013-12-16','15:05:00',1.33),('325','2013-12-16','15:10:00',1.28),('325','2013-12-16','15:15:00',1.22),('325','2013-12-16','15:20:00',1.13),('325','2013-12-16','15:25:00',1.04),('325','2013-12-15','10:20:00',1.31),('325','2013-12-15','10:25:00',1.28),('325','2013-12-15','10:30:00',1.19),('325','2013-12-15','10:35:00',1.28),('325','2013-12-15','10:40:00',1.28),('325','2013-12-15','10:45:00',1.29),('325','2013-12-15','10:50:00',1.02),('325','2013-12-14','09:20:00',1.04),('325','2013-12-14','09:25:00',1.07),('325','2013-12-14','09:30:00',1.11),('325','2013-12-14','09:35:00',1.16),('325','2013-12-14','09:40:00',1.2),('325','2013-12-14','09:45:00',1.24),('325','2013-12-14','09:50:00',1.28),('325','2013-12-14','09:55:00',1.31),('325','2013-12-14','10:00:00',2.05),('325','2013-12-14','10:05:00',2.26),('325','2013-12-14','10:10:00',2.38),('325','2013-12-14','10:15:00',2.44),('325','2013-12-14','10:20:00',2.49),('325','2013-12-14','10:25:00',2.54),('325','2013-12-14','10:30:00',2.58),('325','2013-12-14','10:35:00',2.62),('325','2013-12-14','10:40:00',2.64),('325','2013-12-14','10:45:00',2.68),('325','2013-12-14','10:50:00',2.7),('325','2013-12-14','10:55:00',2.71),('325','2013-12-14','11:00:00',2.74),('325','2013-12-14','11:05:00',2.76),('325','2013-12-14','11:10:00',2.79),('325','2013-12-14','11:15:00',2.8),('325','2013-12-14','11:20:00',2.83),('325','2013-12-14','11:25:00',2.84),('325','2013-12-14','11:30:00',2.88),('325','2013-12-14','11:35:00',2.86),('325','2013-12-14','11:40:00',2.88),('325','2013-12-14','11:45:00',2.86),('325','2013-12-14','11:50:00',2.81),('325','2013-12-14','11:55:00',2.84),('325','2013-12-14','12:00:00',2.82),('325','2013-12-14','12:05:00',2.85),('325','2013-12-14','12:10:00',2.87),('325','2013-12-14','12:15:00',2.86),('325','2013-12-14','12:20:00',2.82),('325','2013-12-14','12:25:00',2.81),('325','2013-12-14','12:30:00',2.43),('325','2013-12-14','12:35:00',2.83),('325','2013-12-14','12:40:00',2.53),('325','2013-12-14','12:45:00',2.56),('325','2013-12-14','12:50:00',2.8),('325','2013-12-14','12:55:00',2.7),('325','2013-12-14','13:00:00',2.69),('325','2013-12-14','13:05:00',2.73),('325','2013-12-14','13:10:00',2.64),('325','2013-12-14','13:15:00',2.62),('325','2013-12-14','13:20:00',2.64),('325','2013-12-14','13:25:00',2.62),('325','2013-12-14','13:30:00',2.58),('325','2013-12-14','13:35:00',2.54),('325','2013-12-14','13:40:00',2.51),('325','2013-12-14','13:45:00',2.44),('325','2013-12-14','13:50:00',2.38),('325','2013-12-14','13:55:00',2.32),('325','2013-12-14','14:00:00',2.27),('325','2013-12-14','14:05:00',2.25),('325','2013-12-14','14:10:00',2.15),('325','2013-12-14','14:15:00',2.08),('325','2013-12-14','14:20:00',2.02),('325','2013-12-14','14:25:00',1.93),('325','2013-12-14','14:30:00',1.86),('325','2013-12-14','14:35:00',1.76),('325','2013-12-14','14:40:00',1.7),('325','2013-12-14','14:45:00',1.3),('325','2013-12-14','14:50:00',1.51),('325','2013-12-14','14:55:00',1.45),('325','2013-12-14','15:00:00',1.37),('325','2013-12-14','15:05:00',1.25),('325','2013-12-14','15:10:00',1.22),('325','2013-12-14','15:15:00',1.15),('325','2013-12-14','15:20:00',1.09),('325','2013-12-14','15:25:00',1),('325','2013-12-13','09:20:00',1.02),('325','2013-12-13','09:25:00',1.06),('325','2013-12-13','09:30:00',1.1),('325','2013-12-13','09:35:00',1.15),('325','2013-12-13','09:40:00',1.2),('325','2013-12-13','09:45:00',1.24),('325','2013-12-13','09:50:00',1.28),('325','2013-12-13','09:55:00',1.31),('325','2013-12-13','10:00:00',1.9),('325','2013-12-13','10:05:00',2.07),('325','2013-12-13','10:10:00',2.16),('325','2013-12-13','10:15:00',2.23),('325','2013-12-13','10:20:00',2.28),('325','2013-12-13','10:25:00',2.3),('325','2013-12-13','10:30:00',2.34),('325','2013-12-13','10:35:00',2.42),('325','2013-12-13','10:40:00',2.45),('325','2013-12-13','10:45:00',2.49),('325','2013-12-13','10:50:00',2.53),('325','2013-12-13','10:55:00',2.58),('325','2013-12-13','11:00:00',2.63),('325','2013-12-13','11:05:00',2.69),('325','2013-12-13','11:10:00',2.72),('325','2013-12-13','11:15:00',2.75),('325','2013-12-13','11:20:00',2.72),('325','2013-12-13','11:25:00',2.73),('325','2013-12-13','11:30:00',2.71),('325','2013-12-13','11:35:00',2.73),('325','2013-12-13','11:40:00',2.79),('325','2013-12-13','11:45:00',2.82),('325','2013-12-13','11:50:00',2.84),('325','2013-12-13','11:55:00',2.83),('325','2013-12-13','12:00:00',2.84),('325','2013-12-13','12:05:00',2.83),('325','2013-12-13','12:10:00',2.82),('325','2013-12-13','12:15:00',2.78),('325','2013-12-13','12:20:00',2.79),('325','2013-12-13','12:25:00',2.81),('325','2013-12-13','12:30:00',2.76),('325','2013-12-13','12:35:00',2.62),('325','2013-12-13','12:40:00',2.81),('325','2013-12-13','12:45:00',2.72),('325','2013-12-13','12:50:00',2.69),('325','2013-12-13','12:55:00',2.67),('325','2013-12-13','13:00:00',2.69),('325','2013-12-13','13:05:00',2.65),('325','2013-12-13','13:10:00',2.69),('325','2013-12-13','13:15:00',2.6),('325','2013-12-13','13:20:00',2.63),('325','2013-12-13','13:25:00',2.63),('325','2013-12-13','13:30:00',2.59),('325','2013-12-13','13:35:00',2.53),('325','2013-12-13','13:40:00',2.46),('325','2013-12-13','13:45:00',2.39),('325','2013-12-13','13:50:00',2.31),('325','2013-12-13','13:55:00',2.3),('325','2013-12-13','14:00:00',2.26),('325','2013-12-13','14:05:00',2.23),('325','2013-12-13','14:10:00',2.13),('325','2013-12-13','14:15:00',2.07),('325','2013-12-13','14:20:00',2.02),('325','2013-12-13','14:25:00',1.95),('325','2013-12-13','14:30:00',1.89),('325','2013-12-13','14:35:00',1.83),('325','2013-12-13','14:40:00',1.78),('325','2013-12-13','14:45:00',1.7),('325','2013-12-13','14:50:00',1.6),('325','2013-12-13','14:55:00',1.45),('325','2013-12-13','15:00:00',1.39),('325','2013-12-13','15:05:00',1.24),('325','2013-12-13','15:10:00',1.15),('325','2013-12-13','15:15:00',1.1),('325','2013-12-13','15:20:00',1.04),('325','2013-12-12','09:20:00',1.03),('325','2013-12-12','09:25:00',1.07),('325','2013-12-12','09:30:00',1.12),('325','2013-12-12','09:35:00',1.18),('325','2013-12-12','09:40:00',1.22),('325','2013-12-12','09:45:00',1.25),('325','2013-12-12','09:50:00',1.28),('325','2013-12-12','09:55:00',1.48),('325','2013-12-12','10:00:00',2.1),('325','2013-12-12','10:05:00',2.26),('325','2013-12-12','10:10:00',2.37),('325','2013-12-12','10:15:00',2.42),('325','2013-12-12','10:20:00',2.47),('325','2013-12-12','10:25:00',2.51),('325','2013-12-12','10:30:00',2.55),('325','2013-12-12','10:35:00',2.61),('325','2013-12-12','10:40:00',2.64),('325','2013-12-12','10:45:00',2.68),('325','2013-12-12','10:50:00',2.72),('325','2013-12-12','10:55:00',2.74),('325','2013-12-12','11:00:00',2.76),('325','2013-12-12','11:05:00',2.77),('325','2013-12-12','11:10:00',2.8),('325','2013-12-12','11:15:00',2.82),('325','2013-12-12','11:20:00',2.83),('325','2013-12-12','11:25:00',2.84),('325','2013-12-12','11:30:00',2.85),('325','2013-12-12','11:35:00',2.84),('325','2013-12-12','11:40:00',2.85),('325','2013-12-12','11:45:00',2.91),('325','2013-12-12','11:50:00',2.89),('325','2013-12-12','11:55:00',2.88),('325','2013-12-12','12:00:00',2.9),('325','2013-12-12','12:05:00',2.89),('325','2013-12-12','12:10:00',2.87),('325','2013-12-12','12:15:00',2.88),('325','2013-12-12','12:20:00',2.89),('325','2013-12-12','12:25:00',2.91),('325','2013-12-12','12:30:00',2.89),('325','2013-12-12','12:35:00',2.87),('325','2013-12-12','12:40:00',2.79),('325','2013-12-12','12:45:00',2.76),('325','2013-12-12','12:50:00',2.74),('325','2013-12-12','12:55:00',2.75),('325','2013-12-12','13:00:00',2.67),('325','2013-12-12','13:05:00',2.65),('325','2013-12-12','13:10:00',2.65),('325','2013-12-12','13:15:00',2.57),('325','2013-12-12','13:20:00',2.55),('325','2013-12-12','13:25:00',2.61),('325','2013-12-12','13:30:00',2.52),('325','2013-12-12','13:35:00',2.47),('325','2013-12-12','13:40:00',2.42),('325','2013-12-12','13:45:00',2.41),('325','2013-12-12','13:50:00',2.35),('325','2013-12-12','13:55:00',2.31),('325','2013-12-12','14:00:00',2.25),('325','2013-12-12','14:05:00',2.17),('325','2013-12-12','14:10:00',2.09),('325','2013-12-12','14:15:00',2.02),('325','2013-12-12','14:20:00',1.93),('325','2013-12-12','14:25:00',1.87),('325','2013-12-12','14:30:00',1.79),('325','2013-12-12','14:35:00',1.7),('325','2013-12-12','14:40:00',1.61),('325','2013-12-12','14:45:00',1.55),('325','2013-12-12','14:50:00',1.48),('325','2013-12-12','14:55:00',1.39),('325','2013-12-12','15:00:00',1.29),('325','2013-12-12','15:05:00',1.18),('325','2013-12-12','15:10:00',1.11),('325','2013-12-12','15:15:00',1.03),('325','2013-12-11','09:20:00',1.01),('325','2013-12-11','09:25:00',1.06),('325','2013-12-11','09:30:00',1.1),('325','2013-12-11','09:35:00',1.14),('325','2013-12-11','09:40:00',1.18),('325','2013-12-11','09:45:00',1.23),('325','2013-12-11','09:50:00',1.26),('325','2013-12-11','09:55:00',1.92),('325','2013-12-11','10:00:00',2.19),('325','2013-12-11','10:05:00',2.32),('325','2013-12-11','10:10:00',2.45),('325','2013-12-11','10:15:00',2.52),('325','2013-12-11','10:20:00',2.59),('325','2013-12-11','10:25:00',2.65),('325','2013-12-11','10:30:00',2.68),('325','2013-12-11','10:35:00',2.75),('325','2013-12-11','10:40:00',2.78),('325','2013-12-11','10:45:00',2.79),('325','2013-12-11','10:50:00',2.78),('325','2013-12-11','10:55:00',2.84),('325','2013-12-11','11:00:00',2.88),('325','2013-12-11','11:05:00',2.94),('325','2013-12-11','11:10:00',2.97),('325','2013-12-11','11:15:00',2.97),('325','2013-12-11','11:20:00',3),('325','2013-12-11','11:25:00',3),('325','2013-12-11','11:30:00',2.92),('325','2013-12-11','11:35:00',2.98),('325','2013-12-11','11:40:00',2.99),('325','2013-12-11','11:45:00',3),('325','2013-12-11','11:50:00',3.04),('325','2013-12-11','11:55:00',3.07),('325','2013-12-11','12:00:00',3.07),('325','2013-12-11','12:05:00',3.06),('325','2013-12-11','12:10:00',3.07),('325','2013-12-11','12:15:00',3.02),('325','2013-12-11','12:20:00',3),('325','2013-12-11','12:25:00',2.97),('325','2013-12-11','12:30:00',2.89),('325','2013-12-11','12:35:00',2.91),('325','2013-12-11','12:40:00',2.93),('325','2013-12-11','12:45:00',2.91),('325','2013-12-11','12:50:00',2.91),('325','2013-12-11','12:55:00',2.88),('325','2013-12-11','13:00:00',2.88),('325','2013-12-11','13:05:00',2.86),('325','2013-12-11','13:10:00',2.78),('325','2013-12-11','13:15:00',2.75),('325','2013-12-11','13:20:00',2.72),('325','2013-12-11','13:25:00',2.68),('325','2013-12-11','13:30:00',2.65),('325','2013-12-11','13:35:00',2.61),('325','2013-12-11','13:40:00',2.55),('325','2013-12-11','13:45:00',2.47),('325','2013-12-11','13:50:00',2.4),('325','2013-12-11','13:55:00',2.34),('325','2013-12-11','14:00:00',2.31),('325','2013-12-11','14:05:00',2.26),('325','2013-12-11','14:10:00',2.19),('325','2013-12-11','14:15:00',2.13),('325','2013-12-11','14:20:00',2.07),('325','2013-12-11','14:25:00',2.01),('325','2013-12-11','14:30:00',1.94),('325','2013-12-11','14:35:00',1.87),('325','2013-12-11','14:40:00',1.78),('325','2013-12-11','14:45:00',1.68),('325','2013-12-11','14:50:00',1.61),('325','2013-12-11','14:55:00',1.52),('325','2013-12-11','15:00:00',1.42),('325','2013-12-11','15:05:00',1.34),('325','2013-12-11','15:10:00',1.24),('325','2013-12-11','15:15:00',1.14),('325','2013-12-11','15:20:00',1.06),('325','2013-12-10','09:20:00',1.04),('325','2013-12-10','09:25:00',1.08),('325','2013-12-10','09:30:00',1.11),('325','2013-12-10','09:35:00',1.15),('325','2013-12-10','09:40:00',1.2),('325','2013-12-10','09:45:00',1.23),('325','2013-12-10','09:50:00',1.27),('325','2013-12-10','09:55:00',1.66),('325','2013-12-10','10:00:00',2.26),('325','2013-12-10','10:05:00',2.39),('325','2013-12-10','10:10:00',2.51),('325','2013-12-10','10:15:00',2.57),('325','2013-12-10','10:20:00',2.61),('325','2013-12-10','10:25:00',2.66),('325','2013-12-10','10:30:00',2.7),('325','2013-12-10','10:35:00',2.74),('325','2013-12-10','10:40:00',2.77),('325','2013-12-10','10:45:00',2.79),('325','2013-12-10','10:50:00',2.81),('325','2013-12-10','10:55:00',2.86),('325','2013-12-10','11:00:00',2.9),('325','2013-12-10','11:05:00',2.94),('325','2013-12-10','11:10:00',2.96),('325','2013-12-10','11:15:00',2.99),('325','2013-12-10','11:20:00',3.01),('325','2013-12-10','11:25:00',3.03),('325','2013-12-10','11:30:00',3.06),('325','2013-12-10','11:35:00',3.07),('325','2013-12-10','11:40:00',3.08),('325','2013-12-10','11:45:00',3.09),('325','2013-12-10','11:50:00',3.09),('325','2013-12-10','11:55:00',3.09),('325','2013-12-10','12:00:00',3.08),('325','2013-12-10','12:05:00',3.07),('325','2013-12-10','12:10:00',3.06),('325','2013-12-10','12:15:00',3.05),('325','2013-12-10','12:20:00',3.02),('325','2013-12-10','12:25:00',3),('325','2013-12-10','12:30:00',2.95),('325','2013-12-10','12:35:00',2.92),('325','2013-12-10','12:40:00',2.86),('325','2013-12-10','12:45:00',2.85),('325','2013-12-10','12:50:00',2.86),('325','2013-12-10','12:55:00',2.8),('325','2013-12-10','13:00:00',2.77),('325','2013-12-10','13:05:00',2.71),('325','2013-12-10','13:10:00',2.73),('325','2013-12-10','13:15:00',2.66),('325','2013-12-10','13:20:00',2.64),('325','2013-12-10','13:25:00',2.59),('325','2013-12-10','13:30:00',2.56),('325','2013-12-10','13:35:00',2.57),('325','2013-12-10','13:40:00',2.54),('325','2013-12-10','13:45:00',2.51),('325','2013-12-10','13:50:00',2.47),('325','2013-12-10','13:55:00',2.43),('325','2013-12-10','14:00:00',2.36),('325','2013-12-10','14:05:00',2.31),('325','2013-12-10','14:10:00',2.24),('325','2013-12-10','14:15:00',2.18),('325','2013-12-10','14:20:00',2.11),('325','2013-12-10','14:25:00',2.06),('325','2013-12-10','14:30:00',2.01),('325','2013-12-10','14:35:00',1.94),('325','2013-12-10','14:40:00',1.86),('325','2013-12-10','14:45:00',1.73),('325','2013-12-10','14:50:00',1.69),('325','2013-12-10','14:55:00',1.59),('325','2013-12-10','15:00:00',1.48),('325','2013-12-10','15:05:00',1.39),('325','2013-12-10','15:10:00',1.3),('325','2013-12-10','15:15:00',1.21),('325','2013-12-10','15:20:00',1.12),('325','2013-12-10','15:25:00',1.02),('325','2013-12-09','09:30:00',1.14),('325','2013-12-09','09:35:00',1.21),('325','2013-12-09','09:40:00',1.26),('325','2013-12-09','09:45:00',1.3),('325','2013-12-09','09:50:00',1.34),('325','2013-12-09','09:55:00',1.78),('325','2013-12-09','10:00:00',2.23),('325','2013-12-09','10:05:00',2.54),('325','2013-12-09','10:10:00',2.66),('325','2013-12-09','10:15:00',3.17),('325','2013-12-09','10:20:00',3.25),('325','2013-12-09','10:25:00',1.46),('325','2013-12-09','12:25:00',1.11),('325','2013-12-09','12:30:00',2.46),('325','2013-12-09','12:35:00',1.25),('325','2013-12-09','12:40:00',1.54),('325','2013-12-09','12:45:00',1.99),('325','2013-12-09','12:50:00',1.74),('325','2013-12-09','12:55:00',2.4),('325','2013-12-09','13:00:00',2.73),('325','2013-12-09','13:05:00',1.56),('325','2013-12-09','13:10:00',2.44),('325','2013-12-09','13:15:00',1.56),('325','2013-12-09','13:20:00',1.94),('325','2013-12-09','13:25:00',1.15),('325','2013-12-09','13:45:00',1),('325','2013-12-09','13:50:00',1.13),('325','2013-12-09','13:55:00',1.16),('325','2013-12-09','14:00:00',1.01),('325','2013-12-08','10:35:00',1.01),('325','2013-12-08','10:40:00',1.11),('325','2013-12-08','10:45:00',1.14),('325','2013-12-08','10:50:00',1.22),('325','2013-12-08','10:55:00',1.45),('325','2013-12-08','11:00:00',1.5),('325','2013-12-08','11:05:00',1.24),('325','2013-12-08','11:10:00',1.29),('325','2013-12-08','11:15:00',2),('325','2013-12-08','11:20:00',1.19),('325','2013-12-08','12:55:00',1.72),('325','2013-12-08','13:00:00',1.65),('325','2013-12-08','13:05:00',1.7),('325','2013-12-08','13:10:00',2.52),('325','2013-12-08','13:15:00',1.85),('325','2013-12-08','13:20:00',1.02),('325','2013-12-08','13:25:00',2.23),('325','2013-12-08','13:30:00',1.54),('325','2013-12-08','15:30:00',1.04),('325','2013-12-07','09:15:00',1.04),('325','2013-12-07','09:20:00',1.09),('325','2013-12-07','09:25:00',1.14),('325','2013-12-07','09:30:00',1.19),('325','2013-12-07','09:35:00',1.23),('325','2013-12-07','09:40:00',1.27),('325','2013-12-07','09:45:00',1.31),('325','2013-12-07','09:50:00',1.61),('325','2013-12-07','09:55:00',2.19),('325','2013-12-07','10:00:00',2.33),('325','2013-12-07','10:05:00',2.42),('325','2013-12-07','10:10:00',2.48),('325','2013-12-07','10:15:00',2.51),('325','2013-12-07','10:20:00',2.56),('325','2013-12-07','10:25:00',2.61),('325','2013-12-07','10:30:00',2.64),('325','2013-12-07','10:35:00',2.7),('325','2013-12-07','10:40:00',2.76),('325','2013-12-07','10:45:00',2.79),('325','2013-12-07','10:50:00',2.78),('325','2013-12-07','10:55:00',2.76),('325','2013-12-07','11:00:00',2.79),('325','2013-12-07','11:05:00',2.83),('325','2013-12-07','11:10:00',2.86),('325','2013-12-07','11:15:00',2.88),('325','2013-12-07','11:20:00',2.89),('325','2013-12-07','11:25:00',2.9),('325','2013-12-07','11:30:00',2.9),('325','2013-12-07','11:35:00',2.89),('325','2013-12-07','11:40:00',2.88),('325','2013-12-07','11:45:00',2.89),('325','2013-12-07','11:50:00',2.88),('325','2013-12-07','11:55:00',2.88),('325','2013-12-07','12:00:00',2.88),('325','2013-12-07','12:05:00',2.87),('325','2013-12-07','12:10:00',2.89),('325','2013-12-07','12:15:00',2.9),('325','2013-12-07','12:20:00',2.88),('325','2013-12-07','12:25:00',2.86),('325','2013-12-07','12:30:00',2.85),('325','2013-12-07','12:35:00',2.83),('325','2013-12-07','12:40:00',2.81),('325','2013-12-07','12:45:00',2.79),('325','2013-12-07','12:50:00',2.77),('325','2013-12-07','12:55:00',2.6),('325','2013-12-07','13:00:00',2.29),('325','2013-12-07','13:05:00',2.72),('325','2013-12-07','13:10:00',2.7),('325','2013-12-07','13:15:00',2.68),('325','2013-12-07','13:20:00',2.66),('325','2013-12-07','13:25:00',2.6),('325','2013-12-07','13:30:00',2.56),('325','2013-12-07','13:35:00',2.54),('325','2013-12-07','13:40:00',2.51),('325','2013-12-07','13:45:00',2.47),('325','2013-12-07','13:50:00',2.4),('325','2013-12-07','13:55:00',2.34),('325','2013-12-07','14:00:00',2.26),('325','2013-12-07','14:05:00',2.23),('325','2013-12-07','14:10:00',2.17),('325','2013-12-07','14:15:00',2.08),('325','2013-12-07','14:20:00',1.94),('325','2013-12-07','14:25:00',1.89),('325','2013-12-07','14:30:00',1.83),('325','2013-12-07','14:35:00',1.73),('325','2013-12-07','14:40:00',1.64),('325','2013-12-07','14:45:00',1.55),('325','2013-12-07','14:50:00',1.49),('325','2013-12-07','14:55:00',1.41),('325','2013-12-07','15:00:00',1.31),('325','2013-12-07','15:05:00',1.22),('325','2013-12-07','15:10:00',1.16),('325','2013-12-07','15:15:00',1.06),('325','2014-04-20','08:20:00',1.29),('325','2014-04-20','08:25:00',1.35),('325','2014-04-20','08:30:00',1.49),('325','2014-04-20','08:35:00',1.19),('325','2014-04-20','08:45:00',1.4),('325','2014-04-20','08:50:00',1.03),('325','2014-04-20','08:55:00',1.14),('325','2014-04-20','09:00:00',1.98),('325','2014-04-20','09:05:00',1.49),('325','2014-04-20','09:10:00',2.07),('325','2014-04-20','09:15:00',2.45),('325','2014-04-20','09:20:00',2.32),('325','2014-04-20','09:25:00',3.1),('325','2014-04-20','09:30:00',3.61),('325','2014-04-20','09:35:00',3.16),('325','2014-04-20','09:40:00',2.03),('325','2014-04-20','09:45:00',1.46),('325','2014-04-20','09:50:00',1.65),('325','2014-04-20','09:55:00',1.87),('325','2014-04-20','10:00:00',2.18),('325','2014-04-20','10:05:00',2.85),('325','2014-04-20','10:10:00',2.66),('325','2014-04-20','10:15:00',3.2),('325','2014-04-20','10:20:00',3.17),('325','2014-04-20','10:25:00',2.95),('325','2014-04-20','10:30:00',2.64),('325','2014-04-20','10:35:00',2.88),('325','2014-04-20','10:40:00',2.71),('325','2014-04-20','10:45:00',2.75),('325','2014-04-20','10:50:00',3.1),('325','2014-04-20','10:55:00',3.06),('325','2014-04-20','11:00:00',3.65),('325','2014-04-20','11:05:00',3.67),('325','2014-04-20','11:10:00',3.8),('325','2014-04-20','11:15:00',3.36),('325','2014-04-20','11:20:00',3.64),('325','2014-04-20','11:25:00',4.48),('325','2014-04-20','11:30:00',4.55),('325','2014-04-20','11:35:00',4.58),('325','2014-04-20','11:40:00',3.47),('325','2014-04-20','11:45:00',4),('325','2014-04-20','11:50:00',4.26),('325','2014-04-20','11:55:00',4.65),('325','2014-04-20','12:00:00',4.67),('325','2014-04-20','12:05:00',4.68),('325','2014-04-20','12:10:00',3.6),('325','2014-04-20','12:15:00',1.36),('325','2014-04-20','12:20:00',4.08),('325','2014-04-20','12:25:00',3.88),('325','2014-04-20','12:30:00',4.98),('325','2014-04-20','12:35:00',4.74),('325','2014-04-20','12:40:00',4.74),('325','2014-04-20','12:45:00',4.72),('325','2014-04-20','12:50:00',4.75),('325','2014-04-20','12:55:00',4.76),('325','2014-04-20','13:00:00',4.77),('325','2014-04-20','13:05:00',4.81),('325','2014-04-20','13:10:00',4.75),('325','2014-04-20','13:15:00',4.94),('325','2014-04-20','13:20:00',4.72),('325','2014-04-20','13:25:00',4.72),('325','2014-04-20','13:30:00',4.74),('325','2014-04-20','13:35:00',4.74),('325','2014-04-20','13:40:00',4.75),('325','2014-04-20','13:45:00',4.74),('325','2014-04-20','13:50:00',4.73),('325','2014-04-20','13:55:00',4.69),('325','2014-04-20','14:00:00',4.63),('325','2014-04-20','14:05:00',4.63),('325','2014-04-20','14:10:00',4.62),('325','2014-04-20','14:15:00',4.82),('325','2014-04-20','14:20:00',3.52),('325','2014-04-20','14:25:00',3.47),('325','2014-04-20','14:30:00',3.29),('325','2014-04-20','14:35:00',2.68),('325','2014-04-20','14:40:00',2.64),('325','2014-04-20','14:45:00',2.9),('325','2014-04-20','14:50:00',2.81),('325','2014-04-20','14:55:00',3.19),('325','2014-04-20','15:00:00',4.33),('325','2014-04-20','15:05:00',3.81),('325','2014-04-20','15:10:00',4.28),('325','2014-04-20','15:15:00',4.18),('325','2014-04-20','15:20:00',4.07),('325','2014-04-20','15:25:00',4.02),('325','2014-04-20','15:30:00',3.99),('325','2014-04-20','15:35:00',3.93),('325','2014-04-20','15:40:00',4.01),('325','2014-04-20','15:45:00',3.12),('325','2014-04-20','15:50:00',2.96),('325','2014-04-20','15:55:00',3.81),('325','2014-04-20','16:00:00',3.67),('325','2014-04-20','16:05:00',3.6),('325','2014-04-20','16:10:00',3.55),('325','2014-04-20','16:15:00',3.51),('325','2014-04-20','16:20:00',3.47),('325','2014-04-20','16:25:00',3.13),('325','2014-04-20','16:30:00',3.41),('325','2014-04-20','16:35:00',3.13),('325','2014-04-20','16:40:00',2.56),('325','2014-04-20','16:45:00',2.21),('325','2014-04-20','16:50:00',2.77),('325','2014-04-20','16:55:00',2.86),('325','2014-04-20','17:00:00',2.69),('325','2014-04-20','17:05:00',2.55),('325','2014-04-20','17:10:00',2.4),('325','2014-04-20','17:15:00',2.27),('325','2014-04-20','17:20:00',2.16),('325','2014-04-20','17:25:00',2.07),('325','2014-04-20','17:30:00',1.96),('325','2014-04-20','17:35:00',1.88),('325','2014-04-20','17:40:00',1.78),('325','2014-04-20','17:45:00',1.68),('325','2014-04-20','17:50:00',1.57),('325','2014-04-20','17:55:00',1.49),('325','2014-04-20','18:00:00',1.38),('325','2014-04-20','18:05:00',1.28),('325','2014-04-20','18:10:00',1.18),('325','2014-04-20','18:15:00',1.02),('325','2013-12-06','10:10:00',1.27),('325','2013-12-06','10:15:00',1.06),('325','2013-12-06','11:05:00',1),('325','2013-12-06','11:25:00',1.03),('325','2013-12-06','11:30:00',1.17),('325','2013-12-06','11:35:00',1.43),('325','2013-12-06','11:40:00',2.3),('325','2013-12-06','11:45:00',1.9),('325','2013-12-06','11:50:00',2.29),('325','2013-12-06','11:55:00',2.24),('325','2013-12-06','12:00:00',2.06),('325','2013-12-06','12:05:00',1.81),('325','2013-12-06','12:10:00',2.52),('325','2013-12-06','12:15:00',1.69),('325','2013-12-06','12:20:00',2.04),('325','2013-12-06','12:25:00',1.24),('325','2013-12-06','12:30:00',1.5),('325','2013-12-06','12:35:00',1.65),('325','2013-12-06','12:40:00',2.37),('325','2013-12-06','12:45:00',1.22),('325','2013-12-06','12:50:00',1.09),('325','2013-12-06','13:45:00',1.02),('325','2013-12-06','14:35:00',1.04),('325','2013-12-06','14:40:00',1.09),('325','2013-12-06','14:45:00',1.17),('325','2013-12-06','14:50:00',1.02),('325','2013-12-05','09:10:00',1.04),('325','2013-12-05','09:15:00',1.08),('325','2013-12-05','09:20:00',1.12),('325','2013-12-05','09:25:00',1.17),('325','2013-12-05','09:30:00',1.21),('325','2013-12-05','09:35:00',1.26),('325','2013-12-05','09:40:00',1.29),('325','2013-12-05','09:45:00',1.32),('325','2013-12-05','09:50:00',1.42),('325','2013-12-05','09:55:00',2.14),('325','2013-12-05','10:00:00',2.32),('325','2013-12-05','10:05:00',2.44),('325','2013-12-05','10:10:00',2.52),('325','2013-12-05','10:15:00',2.57),('325','2013-12-05','10:20:00',2.62),('325','2013-12-05','10:25:00',2.69),('325','2013-12-05','10:30:00',2.72),('325','2013-12-05','10:35:00',2.76),('325','2013-12-05','10:40:00',2.76),('325','2013-12-05','10:45:00',2.79),('325','2013-12-05','10:50:00',2.86),('325','2013-12-05','10:55:00',2.88),('325','2013-12-05','11:00:00',2.92),('325','2013-12-05','11:05:00',2.93),('325','2013-12-05','11:10:00',2.97),('325','2013-12-05','11:15:00',2.98),('325','2013-12-05','11:20:00',2.99),('325','2013-12-05','11:25:00',3.03),('325','2013-12-05','11:30:00',3.06),('325','2013-12-05','11:35:00',3.09),('325','2013-12-05','11:40:00',3.06),('325','2013-12-05','11:45:00',3.01),('325','2013-12-05','11:50:00',3.02),('325','2013-12-05','11:55:00',3.03),('325','2013-12-05','12:00:00',3.03),('325','2013-12-05','12:05:00',3.01),('325','2013-12-05','12:10:00',2.92),('325','2013-12-05','12:15:00',2.98),('325','2013-12-05','12:20:00',2.99),('325','2013-12-05','12:25:00',2.89),('325','2013-12-05','12:30:00',2.89),('325','2013-12-05','12:35:00',2.96),('325','2013-12-05','12:40:00',2.88),('325','2013-12-05','12:45:00',2.71),('325','2013-12-05','12:50:00',2.76),('325','2013-12-05','12:55:00',2.19),('325','2013-12-05','13:00:00',2.94),('325','2013-12-05','13:05:00',2.94),('325','2013-12-05','13:10:00',2.85),('325','2013-12-05','13:15:00',2.77),('325','2013-12-05','13:20:00',2.74),('325','2013-12-05','13:25:00',2.59),('325','2013-12-05','13:30:00',2.5),('325','2013-12-05','13:35:00',2.54),('325','2013-12-05','13:40:00',2.47),('325','2013-12-05','13:45:00',2.41),('325','2013-12-05','13:50:00',2.36),('325','2013-12-05','13:55:00',2.26),('325','2013-12-05','14:00:00',2.25),('325','2013-12-05','14:05:00',2.19),('325','2013-12-05','14:10:00',2.14),('325','2013-12-05','14:15:00',2.07),('325','2013-12-05','14:20:00',2.03),('325','2013-12-05','14:25:00',1.91),('325','2013-12-05','14:30:00',1.86),('325','2013-12-05','14:35:00',1.77),('325','2013-12-05','14:40:00',1.71),('325','2013-12-05','14:45:00',1.66),('325','2013-12-05','14:50:00',1.59),('325','2013-12-05','14:55:00',1.49),('325','2013-12-05','15:00:00',1.38),('325','2013-12-05','15:05:00',1.31),('325','2013-12-05','15:10:00',1.18),('325','2013-12-05','15:15:00',1.12),('325','2013-12-05','15:20:00',1.02),('325','2013-12-04','09:10:00',1.04),('325','2013-12-04','09:15:00',1.08),('325','2013-12-04','09:20:00',1.12),('325','2013-12-04','09:25:00',1.17),('325','2013-12-04','09:30:00',1.21),('325','2013-12-04','09:35:00',1.26),('325','2013-12-04','09:40:00',1.29),('325','2013-12-04','09:45:00',1.32),('325','2013-12-04','09:50:00',2.17),('325','2013-12-04','09:55:00',2.45),('325','2013-12-04','10:00:00',2.58),('325','2013-12-04','10:05:00',2.65),('325','2013-12-04','10:10:00',2.72),('325','2013-12-04','10:15:00',2.77),('325','2013-12-04','10:20:00',2.82),('325','2013-12-04','10:25:00',2.87),('325','2013-12-04','10:30:00',2.91),('325','2013-12-04','10:35:00',2.94),('325','2013-12-04','10:40:00',2.98),('325','2013-12-04','10:45:00',3.02),('325','2013-12-04','10:50:00',3.04),('325','2013-12-04','10:55:00',3.07),('325','2013-12-04','11:00:00',3.1),('325','2013-12-04','11:05:00',3.12),('325','2013-12-04','11:10:00',3.14),('325','2013-12-04','11:15:00',3.16),('325','2013-12-04','11:20:00',3.19),('325','2013-12-04','11:25:00',3.19),('325','2013-12-04','11:30:00',3.2),('325','2013-12-04','11:35:00',3.21),('325','2013-12-04','11:40:00',3.21),('325','2013-12-04','11:45:00',3.2),('325','2013-12-04','11:50:00',3.2),('325','2013-12-04','11:55:00',3.2),('325','2013-12-04','12:00:00',3.21),('325','2013-12-04','12:05:00',3.21),('325','2013-12-04','12:10:00',3.2),('325','2013-12-04','12:15:00',3.18),('325','2013-12-04','12:20:00',3.17),('325','2013-12-04','12:25:00',3.16),('325','2013-12-04','12:30:00',3.14),('325','2013-12-04','12:35:00',3.13),('325','2013-12-04','12:40:00',3.11),('325','2013-12-04','12:45:00',3.09),('325','2013-12-04','12:50:00',3.05),('325','2013-12-04','12:55:00',3.02),('325','2013-12-04','13:00:00',2.99),('325','2013-12-04','13:05:00',2.98),('325','2013-12-04','13:10:00',2.94),('325','2013-12-04','13:15:00',2.9),('325','2013-12-04','13:20:00',2.87),('325','2013-12-04','13:25:00',2.8),('325','2013-12-04','13:30:00',2.76),('325','2013-12-04','13:35:00',2.72),('325','2013-12-04','13:40:00',2.67),('325','2013-12-04','13:45:00',2.63),('325','2013-12-04','13:50:00',2.58),('325','2013-12-04','13:55:00',2.54),('325','2013-12-04','14:00:00',2.45),('325','2013-12-04','14:05:00',2.41),('325','2013-12-04','14:10:00',2.35),('325','2013-12-04','14:15:00',2.28),('325','2013-12-04','14:20:00',2.19),('325','2013-12-04','14:25:00',2.1),('325','2013-12-04','14:30:00',2.06),('325','2013-12-04','14:35:00',1.99),('325','2013-12-04','14:40:00',1.91),('325','2013-12-04','14:45:00',1.82),('325','2013-12-04','14:50:00',1.73),('325','2013-12-04','14:55:00',1.64),('325','2013-12-04','15:00:00',1.54),('325','2013-12-04','15:05:00',1.44),('325','2013-12-04','15:10:00',1.35),('325','2013-12-04','15:15:00',1.27),('325','2013-12-04','15:20:00',1.18),('325','2013-12-04','15:25:00',1.09),('325','2013-12-03','09:40:00',1.09),('325','2013-12-03','09:45:00',1.2),('325','2013-12-03','09:50:00',1.29),('325','2013-12-03','09:55:00',1.76),('325','2013-12-03','10:00:00',2.52),('325','2013-12-03','10:05:00',2.61),('325','2013-12-03','10:10:00',2.67),('325','2013-12-03','10:15:00',2.72),('325','2013-12-03','10:20:00',2.75),('325','2013-12-03','10:25:00',2.81),('325','2013-12-03','10:30:00',2.85),('325','2013-12-03','10:35:00',2.9),('325','2013-12-03','10:40:00',2.93),('325','2013-12-03','10:45:00',2.98),('325','2013-12-03','10:50:00',3.03),('325','2013-12-03','10:55:00',3.09),('325','2013-12-03','11:00:00',3.12),('325','2013-12-03','11:05:00',3.15),('325','2013-12-03','11:10:00',3.18),('325','2013-12-03','11:15:00',3.21),('325','2013-12-03','11:20:00',3.21),('325','2013-12-03','11:25:00',3.21),('325','2013-12-03','11:30:00',3.21),('325','2013-12-03','11:35:00',3.22),('325','2013-12-03','11:40:00',3.22),('325','2013-12-03','11:45:00',3.23),('325','2013-12-03','11:50:00',3.26),('325','2013-12-03','11:55:00',3.25),('325','2013-12-03','12:00:00',3.24),('325','2013-12-03','12:05:00',3.27),('325','2013-12-03','12:10:00',3.28),('325','2013-12-03','12:15:00',3.29),('325','2013-12-03','12:20:00',3.31),('325','2013-12-03','12:25:00',3.32),('325','2013-12-03','12:30:00',3.34),('325','2013-12-03','12:35:00',3.37),('325','2013-12-03','12:40:00',3.39),('325','2013-12-03','12:45:00',3.44),('325','2013-12-03','12:50:00',3.54),('325','2013-12-03','12:55:00',3.62),('325','2013-12-03','13:00:00',3.67),('325','2013-12-03','13:05:00',3.71),('325','2013-12-03','13:10:00',3.71),('325','2013-12-03','13:15:00',3.62),('325','2013-12-03','13:20:00',3.54),('325','2013-12-03','13:25:00',3.42),('325','2013-12-03','13:30:00',3.33),('325','2013-12-03','13:35:00',3.2),('325','2013-12-03','13:40:00',3.05),('325','2013-12-03','13:45:00',2.95),('325','2013-12-03','13:50:00',2.82),('325','2013-12-03','13:55:00',2.67),('325','2013-12-03','14:00:00',2.57),('325','2013-12-03','14:05:00',2.34),('325','2013-12-03','14:10:00',2.28),('325','2013-12-03','14:15:00',2.2),('325','2013-12-03','14:20:00',1.96),('325','2013-12-03','14:25:00',1.78),('325','2013-12-03','14:30:00',1.87),('325','2013-12-03','14:35:00',1.95),('325','2013-12-03','14:40:00',1.88),('325','2013-12-03','14:45:00',1.8),('325','2013-12-03','14:50:00',1.7),('325','2013-12-03','14:55:00',1.58),('325','2013-12-03','15:00:00',1.49),('325','2013-12-03','15:05:00',1.41),('325','2013-12-03','15:10:00',1.32),('325','2013-12-03','15:15:00',1.23),('325','2013-12-03','15:20:00',1.14),('325','2013-12-03','15:25:00',1.04),('325','2013-12-01','11:35:00',1.15),('325','2013-12-01','11:40:00',1.15),('325','2013-12-01','11:55:00',1.34),('325','2013-12-01','12:00:00',1.17),('325','2013-12-01','12:05:00',1.42),('325','2013-12-01','12:10:00',1.73),('325','2013-12-01','12:15:00',1.17),('325','2013-11-30','09:10:00',1.24),('325','2013-11-30','09:15:00',1.35),('325','2013-11-30','09:20:00',1.51),('325','2013-11-30','09:25:00',1.52),('325','2013-11-30','09:30:00',1.73),('325','2013-11-30','09:35:00',1.83),('325','2013-11-30','09:40:00',1.89),('325','2013-11-30','09:45:00',1.54),('325','2013-11-30','09:50:00',1.26),('325','2013-11-30','09:55:00',1.19),('325','2013-11-30','10:00:00',1.18),('325','2013-11-30','10:05:00',1.09),('325','2013-11-30','10:10:00',1.03),('325','2013-11-30','10:15:00',1.14),('325','2013-11-30','10:20:00',1.27),('325','2013-11-30','10:25:00',1.23),('325','2013-11-30','10:30:00',1.3),('325','2013-11-30','10:35:00',1.47),('325','2013-11-30','10:40:00',1.66),('325','2013-11-30','10:45:00',1.53),('325','2013-11-30','10:50:00',1.33),('325','2013-11-30','10:55:00',1.2),('325','2013-11-30','11:00:00',1.11),('325','2013-11-30','11:05:00',1.61),('325','2013-11-30','11:10:00',1.41),('325','2013-11-30','11:15:00',1.37),('325','2013-11-30','11:20:00',1.31),('325','2013-11-30','11:25:00',1.38),('325','2013-11-30','11:30:00',1.18),('325','2013-11-30','11:35:00',1.1),('325','2013-11-30','11:40:00',1.01),('325','2013-11-29','09:05:00',1.02),('325','2013-11-29','09:10:00',1.07),('325','2013-11-29','09:15:00',1.11),('325','2013-11-29','09:20:00',1.16),('325','2013-11-29','09:25:00',1.2),('325','2013-11-29','09:30:00',1.25),('325','2013-11-29','09:35:00',1.28),('325','2013-11-29','09:40:00',1.32),('325','2013-11-29','09:45:00',1.45),('325','2013-11-29','09:50:00',2.37),('325','2013-11-29','09:55:00',2.53),('325','2013-11-29','10:00:00',2.61),('325','2013-11-29','10:05:00',2.67),('325','2013-11-29','10:10:00',2.73),('325','2013-11-29','10:15:00',2.8),('325','2013-11-29','10:20:00',2.85),('325','2013-11-29','10:25:00',2.91),('325','2013-11-29','10:30:00',2.95),('325','2013-11-29','10:35:00',3),('325','2013-11-29','10:40:00',3.03),('325','2013-11-29','10:45:00',3.07),('325','2013-11-29','10:50:00',3.1),('325','2013-11-29','10:55:00',3.12),('325','2013-11-29','11:00:00',3.15),('325','2013-11-29','11:05:00',3.18),('325','2013-11-29','11:10:00',3.21),('325','2013-11-29','11:15:00',3.22),('325','2013-11-29','11:20:00',3.24),('325','2013-11-29','11:25:00',3.27),('325','2013-11-29','11:30:00',3.29),('325','2013-11-29','11:35:00',3.3),('325','2013-11-29','11:40:00',3.3),('325','2013-11-29','11:45:00',3.3),('325','2013-11-29','11:50:00',3.31),('325','2013-11-29','11:55:00',3.31),('325','2013-11-29','12:00:00',3.32),('325','2013-11-29','12:05:00',3.3),('325','2013-11-29','12:10:00',3.28),('325','2013-11-29','12:15:00',3.27),('325','2013-11-29','12:20:00',3.27),('325','2013-11-29','12:25:00',3.25),('325','2013-11-29','12:30:00',3.21),('325','2013-11-29','12:35:00',3.2),('325','2013-11-29','12:40:00',3.18),('325','2013-11-29','12:45:00',3.17),('325','2013-11-29','12:50:00',3.16),('325','2013-11-29','12:55:00',3.13),('325','2013-11-29','13:00:00',3.08),('325','2013-11-29','13:05:00',3.05),('325','2013-11-29','13:10:00',3.02),('325','2013-11-29','13:15:00',2.97),('325','2013-11-29','13:20:00',2.91),('325','2013-11-29','13:25:00',2.87),('325','2013-11-29','13:30:00',2.81),('325','2013-11-29','13:35:00',2.77),('325','2013-11-29','13:40:00',2.72),('325','2013-11-29','13:45:00',2.66),('325','2013-11-29','13:50:00',2.6),('325','2013-11-29','13:55:00',2.53),('325','2013-11-29','14:00:00',2.47),('325','2013-11-29','14:05:00',2.4),('325','2013-11-29','14:10:00',2.33),('325','2013-11-29','14:15:00',2.28),('325','2013-11-29','14:20:00',2.2),('325','2013-11-29','14:25:00',2.12),('325','2013-11-29','14:30:00',2.05),('325','2013-11-29','14:35:00',1.96),('325','2013-11-29','14:40:00',1.87),('325','2013-11-29','14:45:00',1.79),('325','2013-11-29','14:50:00',1.71),('325','2013-11-29','14:55:00',1.58),('325','2013-11-29','15:00:00',1.51),('325','2013-11-29','15:05:00',1.43),('325','2013-11-29','15:10:00',1.34),('325','2013-11-29','15:15:00',1.24),('325','2013-11-29','15:20:00',1.16),('325','2013-11-29','15:25:00',1.07),('325','2013-11-28','12:55:00',1.08),('325','2013-11-27','09:35:00',1.04),('325','2013-11-27','09:40:00',1.03),('325','2013-11-27','09:50:00',1.31),('325','2013-11-27','09:55:00',1.55),('325','2013-11-27','10:00:00',1.29),('325','2013-11-27','10:05:00',1.3),('325','2013-11-27','10:10:00',1.29),('325','2013-11-27','10:15:00',1.4),('325','2013-11-27','10:20:00',1.19),('325','2013-11-27','10:25:00',1.12),('325','2013-11-27','10:30:00',1.18),('325','2013-11-27','10:35:00',1.24),('325','2013-11-27','10:40:00',1.37),('325','2013-11-27','10:45:00',1.53),('325','2013-11-27','10:50:00',1.38),('325','2013-11-27','10:55:00',1.42),('325','2013-11-27','11:00:00',1.51),('325','2013-11-27','11:05:00',1.58),('325','2013-11-27','11:10:00',2.01),('325','2013-11-27','11:15:00',1.5),('325','2013-11-27','11:20:00',1.48),('325','2013-11-27','11:25:00',1.68),('325','2013-11-27','11:30:00',2.72),('325','2013-11-27','11:35:00',2.59),('325','2013-11-27','11:40:00',1.68),('325','2013-11-27','11:45:00',1.85),('325','2013-11-27','11:50:00',3.15),('325','2013-11-27','11:55:00',3.41),('325','2013-11-27','12:00:00',3.72),('325','2013-11-27','12:05:00',2.3),('325','2013-11-27','12:10:00',1.67),('325','2013-11-27','12:15:00',2.6),('325','2013-11-27','12:20:00',3.67),('325','2013-11-27','12:25:00',2.6),('325','2013-11-27','12:30:00',1.38),('325','2013-11-27','12:35:00',3.45),('325','2013-11-27','12:40:00',1.65),('325','2013-11-27','12:45:00',1.06),('325','2013-11-27','12:50:00',1.05),('325','2013-11-27','12:55:00',1.04),('325','2013-11-27','13:00:00',1.08),('325','2013-11-27','13:05:00',1.06),('325','2013-11-27','13:10:00',1.06),('325','2013-11-27','13:15:00',1.04),('325','2013-11-27','13:20:00',1.03),('325','2013-11-27','13:25:00',1.01),('325','2013-11-27','13:30:00',1.03),('325','2013-11-27','13:40:00',1.01),('325','2014-04-19','07:55:00',1.43),('325','2014-04-19','08:00:00',1.14),('325','2014-04-19','08:10:00',1.2),('325','2014-04-19','08:15:00',1.05),('325','2014-04-19','08:20:00',1.19),('325','2014-04-19','08:25:00',1.47),('325','2014-04-19','08:30:00',1.67),('325','2014-04-19','08:35:00',1.62),('325','2014-04-19','08:40:00',1.75),('325','2014-04-19','08:45:00',1.65),('325','2014-04-19','08:50:00',1.32),('325','2014-04-19','09:20:00',1.14),('325','2014-04-19','09:25:00',1.6),('325','2014-04-19','09:30:00',2.07),('325','2014-04-19','09:35:00',1.81),('325','2014-04-19','09:40:00',1.1),('325','2014-04-19','10:35:00',1.04),('325','2014-04-19','10:40:00',1.28),('325','2014-04-19','10:45:00',1.19),('325','2014-04-19','10:50:00',1.31),('325','2014-04-19','10:55:00',1.69),('325','2014-04-19','11:00:00',1.63),('325','2014-04-19','11:05:00',1.31),('325','2014-04-19','11:10:00',1.35),('325','2014-04-19','11:15:00',2.12),('325','2014-04-19','11:20:00',3.36),('325','2014-04-19','11:25:00',2.75),('325','2014-04-19','11:30:00',2.6),('325','2014-04-19','11:35:00',2.75),('325','2014-04-19','11:40:00',2.55),('325','2014-04-19','11:45:00',2.11),('325','2014-04-19','11:50:00',1.59),('325','2014-04-19','11:55:00',1),('325','2014-04-19','13:15:00',1.61),('325','2014-04-19','13:20:00',1.32),('325','2014-04-19','14:30:00',1.5),('325','2014-04-19','14:35:00',1.59),('325','2014-04-19','14:40:00',2.07),('325','2014-04-19','14:45:00',2.08),('325','2014-04-19','14:50:00',1.21),('325','2014-04-19','14:55:00',1.2),('325','2014-04-19','15:00:00',1.56),('325','2014-04-19','15:05:00',1.12),('325','2014-04-19','15:25:00',1.23),('325','2014-04-19','15:30:00',1.07),('325','2014-04-19','15:45:00',1.13),('325','2014-04-19','15:50:00',3.57),('325','2014-04-19','15:55:00',2.64),('325','2014-04-19','16:00:00',2.7),('325','2014-04-19','16:05:00',2.32),('325','2014-04-19','16:10:00',2.02),('325','2014-04-19','16:15:00',2.01),('325','2014-04-19','16:20:00',2.21),('325','2014-04-19','16:25:00',2.04),('325','2014-04-19','16:30:00',3.51),('325','2014-04-19','16:35:00',1.64),('325','2014-04-19','16:40:00',1.14),('325','2014-04-19','16:45:00',1.06),('325','2014-04-19','17:05:00',1.07),('325','2014-04-19','17:10:00',1.02),('325','2014-04-19','17:15:00',1.3),('325','2014-04-19','17:20:00',1.97),('325','2014-04-19','17:25:00',1.4),('325','2014-04-19','17:30:00',1.24),('325','2014-04-19','17:35:00',1.04),('325','2013-11-26','09:10:00',1.25),('325','2013-11-26','09:15:00',1.18),('325','2013-11-26','09:20:00',1.14),('325','2013-11-26','09:25:00',1.11),('325','2013-11-26','09:30:00',1.19),('325','2013-11-26','09:35:00',1.27),('325','2013-11-26','09:40:00',1.41),('325','2013-11-26','09:45:00',1.15),('325','2013-11-26','09:50:00',1.29),('325','2013-11-26','09:55:00',2.25),('325','2013-11-26','10:00:00',1.61),('325','2013-11-26','10:05:00',1.69),('325','2013-11-26','10:10:00',1.55),('325','2013-11-26','10:15:00',1.1),('325','2013-11-26','10:20:00',2.25),('325','2013-11-26','10:25:00',2.32),('325','2013-11-26','10:30:00',2.29),('325','2013-11-26','10:35:00',3.29),('325','2013-11-26','10:40:00',3.3),('325','2013-11-26','10:45:00',3.34),('325','2013-11-26','10:50:00',3.32),('325','2013-11-26','10:55:00',3.37),('325','2013-11-26','11:00:00',3.43),('325','2013-11-26','11:05:00',3.22),('325','2013-11-26','11:10:00',3.91),('325','2013-11-26','11:15:00',4.03),('325','2013-11-26','11:20:00',2.93),('325','2013-11-26','11:25:00',3.87),('325','2013-11-26','11:30:00',3.9),('325','2013-11-26','11:35:00',2.97),('325','2013-11-26','11:40:00',3.31),('325','2013-11-26','11:45:00',3.9),('325','2013-11-26','11:50:00',3.01),('325','2013-11-26','11:55:00',2.12),('325','2013-11-26','12:00:00',1.28),('325','2013-11-26','12:05:00',1.9),('325','2013-11-26','12:15:00',1.86),('325','2013-11-26','12:20:00',3.64),('325','2013-11-26','12:25:00',3.54),('325','2013-11-26','12:30:00',3.47),('325','2013-11-26','12:35:00',3.48),('325','2013-11-26','12:40:00',3.47),('325','2013-11-26','12:45:00',3.43),('325','2013-11-26','12:50:00',3.41),('325','2013-11-26','12:55:00',3.38),('325','2013-11-26','13:00:00',3.35),('325','2013-11-26','13:05:00',3.32),('325','2013-11-26','13:10:00',3.28),('325','2013-11-26','13:15:00',3.23),('325','2013-11-26','13:20:00',3.18),('325','2013-11-26','13:25:00',3.13),('325','2013-11-26','13:30:00',3.09),('325','2013-11-26','13:35:00',3.05),('325','2013-11-26','13:40:00',2.99),('325','2013-11-26','13:45:00',2.94),('325','2013-11-26','13:50:00',2.94),('325','2013-11-26','13:55:00',2.85),('325','2013-11-26','14:00:00',3),('325','2013-11-26','14:05:00',3.27),('325','2013-11-26','14:10:00',3.15),('325','2013-11-26','14:15:00',3.53),('325','2013-11-26','14:20:00',3.23),('325','2013-11-26','14:25:00',2.08),('325','2013-11-26','14:30:00',1.62),('325','2013-11-26','14:35:00',1.9),('325','2013-11-26','14:40:00',1.85),('325','2013-11-26','14:45:00',2.2),('325','2013-11-26','14:50:00',2.12),('325','2013-11-26','14:55:00',2.32),('325','2013-11-26','15:00:00',2.18),('325','2013-11-26','15:05:00',1.95),('325','2013-11-26','15:10:00',1.72),('325','2013-11-26','15:15:00',1.56),('325','2013-11-26','15:20:00',1.43),('325','2013-11-26','15:25:00',1.31),('325','2013-11-26','15:30:00',1.2),('325','2013-11-26','15:35:00',1.08),('325','2013-11-25','08:40:00',1.05),('325','2013-11-25','08:45:00',1.17),('325','2013-11-25','08:50:00',1.31),('325','2013-11-25','08:55:00',1.52),('325','2013-11-25','09:00:00',1.68),('325','2013-11-25','09:05:00',1.76),('325','2013-11-25','09:10:00',1.74),('325','2013-11-25','09:15:00',1.83),('325','2013-11-25','09:20:00',2.09),('325','2013-11-25','09:25:00',1.81),('325','2013-11-25','09:30:00',1.8),('325','2013-11-25','09:35:00',1.67),('325','2013-11-25','09:40:00',1.82),('325','2013-11-25','09:45:00',1.25),('325','2013-11-25','09:50:00',2.12),('325','2013-11-25','09:55:00',1.53),('325','2013-11-25','10:00:00',1.86),('325','2013-11-25','10:05:00',1.98),('325','2013-11-25','10:10:00',1.72),('325','2013-11-25','10:15:00',2.35),('325','2013-11-25','10:20:00',1.27),('325','2013-11-25','10:25:00',1.66),('325','2013-11-25','10:30:00',2.1),('325','2013-11-25','10:35:00',2.74),('325','2013-11-25','10:40:00',3.82),('325','2013-11-25','10:45:00',3.37),('325','2013-11-25','10:50:00',2.71),('325','2013-11-25','10:55:00',2.74),('325','2013-11-25','11:00:00',3.35),('325','2013-11-25','11:05:00',3.51),('325','2013-11-25','11:10:00',3.94),('325','2013-11-25','11:15:00',3.17),('325','2013-11-25','11:20:00',1.28),('325','2013-11-25','11:25:00',1.33),('325','2013-11-25','11:30:00',1.83),('325','2013-11-25','11:35:00',1.4),('325','2013-11-25','11:40:00',1.24),('325','2013-11-25','11:45:00',1.42),('325','2013-11-25','11:50:00',1.82),('325','2013-11-25','11:55:00',1.54),('325','2013-11-25','12:00:00',1.97),('325','2013-11-25','12:05:00',2.06),('325','2013-11-25','12:10:00',2.85),('325','2013-11-25','12:15:00',2.08),('325','2013-11-25','12:20:00',1.71),('325','2013-11-25','12:25:00',1.73),('325','2013-11-25','12:30:00',1.53),('325','2013-11-25','12:35:00',1.53),('325','2013-11-25','12:40:00',2.99),('325','2013-11-25','12:45:00',2.78),('325','2013-11-25','12:50:00',2.85),('325','2013-11-25','12:55:00',3.14),('325','2013-11-25','13:00:00',3.77),('325','2013-11-25','13:05:00',3.31),('325','2013-11-25','13:10:00',2.38),('325','2013-11-25','13:15:00',1.94),('325','2013-11-25','13:20:00',4.05),('325','2013-11-25','13:25:00',3.96),('325','2013-11-25','13:30:00',1.69),('325','2013-11-25','13:35:00',1.16),('325','2013-11-24','09:55:00',1.27),('325','2013-11-24','10:00:00',1.47),('325','2013-11-24','10:05:00',1.52),('325','2013-11-24','10:10:00',1.58),('325','2013-11-24','10:15:00',1.49),('325','2013-11-24','10:20:00',1.28),('325','2013-11-24','10:25:00',1.86),('325','2013-11-24','10:30:00',1.71),('325','2013-11-24','10:35:00',1.43),('325','2013-11-24','10:40:00',1.12),('325','2013-11-24','10:45:00',1.09),('325','2013-11-24','10:50:00',1.12),('325','2013-11-24','10:55:00',1.22),('325','2013-11-24','11:00:00',1.25),('325','2013-11-24','11:05:00',1.29),('325','2013-11-24','11:10:00',1.36),('325','2013-11-24','11:15:00',1.43),('325','2013-11-24','11:20:00',1.6),('325','2013-11-24','11:25:00',1.58),('325','2013-11-24','11:30:00',1.53),('325','2013-11-24','11:35:00',1.26),('325','2013-11-24','11:40:00',1.17),('325','2013-11-24','11:45:00',1.19),('325','2013-11-24','11:50:00',1.29),('325','2013-11-24','11:55:00',1.14),('325','2013-11-24','12:25:00',1.05),('325','2013-11-24','12:30:00',1.01),('325','2013-11-24','12:35:00',1.01),('325','2013-11-24','12:40:00',1.08),('325','2013-11-24','12:45:00',1.09),('325','2013-11-24','12:50:00',1.09),('325','2013-11-24','12:55:00',1.04),('325','2013-11-24','13:00:00',1.25),('325','2013-11-24','13:05:00',1.69),('325','2013-11-24','13:10:00',1.81),('325','2013-11-24','13:15:00',1.66),('325','2013-11-24','13:20:00',1.34),('325','2013-11-24','13:25:00',1.05),('325','2013-11-23','10:15:00',1.26),('325','2013-11-23','10:20:00',1.3),('325','2013-11-23','10:25:00',1.81),('325','2013-11-23','10:30:00',2.18),('325','2013-11-23','10:35:00',1.19),('325','2013-11-23','10:40:00',2.79),('325','2013-11-23','13:20:00',1.52),('325','2013-11-23','13:25:00',1.55),('325','2013-11-23','13:30:00',1.17),('325','2013-11-23','13:35:00',1.78),('325','2013-11-23','13:40:00',1.29),('325','2013-11-23','13:55:00',1.14),('325','2013-11-23','14:00:00',1.09),('325','2013-11-21','09:20:00',1.02),('325','2013-11-21','09:25:00',1.07),('325','2013-11-21','09:40:00',1.36),('325','2013-11-21','09:45:00',1.8),('325','2013-11-21','09:50:00',1.35),('325','2013-11-21','09:55:00',2.16),('325','2013-11-21','10:00:00',1.89),('325','2013-11-21','10:05:00',2.29),('325','2013-11-21','10:10:00',2.57),('325','2013-11-21','10:15:00',2.88),('325','2013-11-21','10:20:00',2.44),('325','2013-11-21','10:25:00',1.82),('325','2013-11-21','10:30:00',2.81),('325','2013-11-21','10:35:00',2.96),('325','2013-11-21','10:40:00',3.23),('325','2013-11-21','10:45:00',1.83),('325','2013-11-21','11:15:00',1.63),('325','2013-11-21','11:20:00',1.92),('325','2013-11-21','11:25:00',2.23),('325','2013-11-21','11:30:00',2.47),('325','2013-11-21','11:35:00',2.33),('325','2013-11-21','11:40:00',2.47),('325','2013-11-21','11:45:00',3.14),('325','2013-11-21','11:50:00',3.01),('325','2013-11-21','11:55:00',3.41),('325','2013-11-21','12:00:00',1.57),('325','2013-11-21','12:05:00',3.32),('325','2013-11-21','12:10:00',3.32),('325','2013-11-21','12:15:00',3.3),('325','2013-11-21','12:20:00',3.34),('325','2013-11-21','12:25:00',3.41),('325','2013-11-21','12:30:00',3.57),('325','2013-11-21','12:35:00',3.56),('325','2013-11-21','12:40:00',3.68),('325','2013-11-21','12:45:00',3.61),('325','2013-11-21','12:50:00',3.57),('325','2013-11-21','12:55:00',3.46),('325','2013-11-21','13:00:00',3.56),('325','2013-11-21','13:05:00',3.3),('325','2013-11-21','13:10:00',2.77),('325','2013-11-21','13:15:00',3.48),('325','2013-11-21','13:20:00',3.2),('325','2013-11-21','13:25:00',2.3),('325','2013-11-21','13:40:00',2.02),('325','2013-11-21','13:45:00',2.95),('325','2013-11-21','13:50:00',1.54),('325','2013-11-21','13:55:00',2.88),('325','2013-11-21','14:00:00',2.44),('325','2013-11-21','14:05:00',1.05),('325','2013-11-21','14:10:00',1.44),('325','2013-11-21','14:25:00',1.65),('325','2013-11-21','14:35:00',1.1),('325','2013-11-21','14:40:00',1.93),('325','2013-11-21','14:45:00',1.83),('325','2013-11-21','14:50:00',1.58),('325','2013-11-21','14:55:00',1.2),('325','2013-11-21','15:00:00',1.53),('325','2013-11-21','15:05:00',1.45),('325','2013-11-21','15:10:00',1.34),('325','2013-11-21','15:25:00',1.07),('325','2013-11-20','09:10:00',1.04),('325','2013-11-20','09:15:00',1.2),('325','2013-11-20','09:20:00',1.22),('325','2013-11-20','09:25:00',1.33),('325','2013-11-20','09:30:00',1.43),('325','2013-11-20','10:00:00',1.93),('325','2013-11-20','10:10:00',1.55),('325','2013-11-20','10:15:00',2.04),('325','2013-11-20','11:20:00',1.08),('325','2013-11-20','11:25:00',1.23),('325','2013-11-20','11:30:00',1.05),('325','2013-11-20','11:35:00',1.1),('325','2013-11-20','11:40:00',1.39),('325','2013-11-20','11:45:00',4.69),('325','2013-11-20','11:50:00',3.73),('325','2013-11-20','11:55:00',1.58),('325','2013-11-20','12:15:00',1.14),('325','2013-11-20','12:20:00',2.08),('325','2013-11-20','12:25:00',1.49),('325','2013-11-20','12:35:00',1),('325','2013-11-20','12:45:00',1.28),('325','2013-11-20','12:50:00',2.35),('325','2013-11-20','12:55:00',2.65),('325','2013-11-20','13:00:00',1.87),('325','2013-11-20','13:05:00',1.8),('325','2013-11-20','13:15:00',1.06),('325','2013-11-20','13:20:00',1.43),('325','2013-11-20','13:25:00',1.38),('325','2013-11-20','13:35:00',1.77),('325','2013-11-20','13:45:00',1.56),('325','2013-11-20','13:50:00',1.87),('325','2013-11-20','14:20:00',1.27),('325','2013-11-20','14:25:00',1.83),('325','2013-11-20','14:40:00',1.21),('325','2013-11-20','14:45:00',1.32),('325','2013-11-20','15:05:00',1.63),('325','2013-11-20','15:10:00',1.52),('325','2013-11-20','15:15:00',1.2),('325','2013-11-20','15:20:00',1.1),('325','2013-11-19','09:35:00',1.1),('325','2013-11-19','09:40:00',1.56),('325','2013-11-19','09:45:00',1.88),('325','2013-11-19','09:55:00',1.03),('325','2013-11-19','10:00:00',1.63),('325','2013-11-19','10:05:00',1.21),('325','2013-11-19','10:50:00',1.32),('325','2013-11-19','11:20:00',2.66),('325','2013-11-19','11:25:00',2.49),('325','2013-11-19','11:30:00',2.71),('325','2013-11-19','11:35:00',3.26),('325','2013-11-19','11:40:00',2.89),('325','2013-11-19','11:45:00',3.05),('325','2013-11-19','11:50:00',3),('325','2013-11-19','11:55:00',2.64),('325','2013-11-19','12:00:00',2.24),('325','2013-11-19','12:05:00',3.08),('325','2013-11-19','12:10:00',2.66),('325','2013-11-19','12:15:00',2.95),('325','2013-11-19','12:20:00',1.06),('325','2013-11-19','12:25:00',1.13),('325','2013-11-19','12:30:00',1.56),('325','2013-11-19','12:40:00',1.4),('325','2013-11-19','12:45:00',2.51),('325','2013-11-19','12:50:00',2.52),('325','2013-11-19','12:55:00',3.23),('325','2013-11-19','13:00:00',1.11),('325','2013-11-19','13:10:00',1.15),('325','2013-11-19','13:15:00',2.19),('325','2013-11-19','13:20:00',1.54),('325','2013-11-19','15:25:00',1.46),('325','2013-11-19','15:30:00',1.72),('325','2013-11-19','15:35:00',1.26),('325','2013-11-19','15:40:00',1.03),('325','2013-11-18','09:15:00',1.13),('325','2013-11-18','09:20:00',1.32),('325','2013-11-18','09:25:00',1.4),('325','2013-11-18','09:30:00',1.3),('325','2013-11-18','09:35:00',1.63),('325','2013-11-18','09:40:00',1.35),('325','2013-11-18','09:45:00',1.32),('325','2013-11-18','09:50:00',1.07),('325','2013-11-18','09:55:00',1.1),('325','2013-11-18','10:00:00',1.25),('325','2013-11-18','10:05:00',1.41),('325','2013-11-18','10:10:00',1.82),('325','2013-11-18','10:15:00',1.88),('325','2013-11-18','10:20:00',1.5),('325','2013-11-18','10:25:00',1.41),('325','2013-11-18','10:30:00',1.24),('325','2013-11-18','10:35:00',1.24),('325','2013-11-18','10:40:00',1.28),('325','2013-11-18','10:45:00',1.33),('325','2013-11-18','10:50:00',1.23),('325','2013-11-18','10:55:00',1.07),('325','2013-11-18','11:25:00',1.01),('325','2013-11-18','11:30:00',1.13),('325','2013-11-18','11:35:00',1.19),('325','2013-11-18','11:40:00',1.23),('325','2013-11-18','11:45:00',1.27),('325','2013-11-18','11:50:00',1.34),('325','2013-11-18','11:55:00',1.44),('325','2013-11-18','12:00:00',1.52),('325','2013-11-18','12:05:00',1.6),('325','2013-11-18','12:10:00',1.57),('325','2013-11-18','12:15:00',1.68),('325','2013-11-18','12:20:00',1.78),('325','2013-11-18','12:25:00',1.82),('325','2013-11-18','12:30:00',1.61),('325','2013-11-18','12:35:00',1.39),('325','2013-11-18','12:40:00',1.15),('325','2013-11-18','12:45:00',1.02),('325','2013-11-18','13:05:00',1),('325','2013-11-18','13:10:00',1.13),('325','2013-11-18','13:15:00',1.03),('325','2013-11-18','13:35:00',1.23),('325','2013-11-18','13:40:00',1.27),('325','2013-11-18','13:45:00',1.15),('325','2013-11-18','13:50:00',1.04),('325','2013-11-17','08:45:00',1.02),('325','2013-11-17','08:50:00',1.41),('325','2013-11-17','08:55:00',1.45),('325','2013-11-17','09:00:00',1.22),('325','2013-11-17','09:05:00',1.13),('325','2013-11-17','09:10:00',1.17),('325','2013-11-17','09:20:00',1.13),('325','2013-11-17','09:25:00',1.44),('325','2013-11-17','09:30:00',1.47),('325','2013-11-17','09:35:00',1.32),('325','2013-11-17','09:40:00',1.71),('325','2013-11-17','09:45:00',2.25),('325','2013-11-17','09:50:00',2.38),('325','2013-11-17','09:55:00',2.45),('325','2013-11-17','10:00:00',2.5),('325','2013-11-17','10:05:00',2.57),('325','2013-11-17','10:10:00',2.64),('325','2013-11-17','10:15:00',2.72),('325','2013-11-17','10:20:00',2.78),('325','2013-11-17','10:25:00',2.82),('325','2013-11-17','10:30:00',2.84),('325','2013-11-17','10:35:00',2.87),('325','2013-11-17','10:40:00',2.89),('325','2013-11-17','10:45:00',2.91),('325','2013-11-17','10:50:00',2.94),('325','2013-11-17','10:55:00',2.97),('325','2013-11-17','11:00:00',2.99),('325','2013-11-17','11:05:00',3.01),('325','2013-11-17','11:10:00',3.02),('325','2013-11-17','11:15:00',3.04),('325','2013-11-17','11:20:00',3.06),('325','2013-11-17','11:25:00',3.07),('325','2013-11-17','11:30:00',3.07),('325','2013-11-17','11:35:00',3.06),('325','2013-11-17','11:40:00',3.07),('325','2013-11-17','11:45:00',3.08),('325','2013-11-17','11:50:00',3.09),('325','2013-11-17','11:55:00',3.09),('325','2013-11-17','12:00:00',3.09),('325','2013-11-17','12:05:00',3.06),('325','2013-11-17','12:10:00',3.03),('325','2013-11-17','12:15:00',3.03),('325','2013-11-17','12:20:00',3.01),('325','2013-11-17','12:25:00',2.98),('325','2013-11-17','12:30:00',2.99),('325','2013-11-17','12:35:00',2.97),('325','2013-11-17','12:40:00',2.93),('325','2013-11-17','12:45:00',2.87),('325','2013-11-17','12:50:00',2.85),('325','2013-11-17','12:55:00',2.84),('325','2013-11-17','13:00:00',2.85),('325','2013-11-17','13:05:00',2.83),('325','2013-11-17','13:10:00',2.79),('325','2013-11-17','13:15:00',2.77),('325','2013-11-17','13:20:00',2.75),('325','2013-11-17','13:25:00',2.68),('325','2013-11-17','13:30:00',2.69),('325','2013-11-17','13:35:00',2.68),('325','2013-11-17','13:40:00',2.6),('325','2013-11-17','13:45:00',1.29),('325','2013-11-17','14:00:00',1.17),('325','2013-11-17','14:05:00',1.13),('325','2013-11-17','14:10:00',2.27),('325','2013-11-17','14:15:00',2.16),('325','2013-11-17','14:20:00',2.04),('325','2013-11-17','14:25:00',1.97),('325','2013-11-17','14:30:00',1.83),('325','2013-11-17','14:35:00',1.8),('325','2013-11-17','14:40:00',1.7),('325','2013-11-17','14:45:00',1.47),('325','2013-11-17','15:20:00',1.26),('325','2013-11-17','15:25:00',1.03),('325','2013-11-17','15:30:00',1.02),('325','2014-04-18','08:05:00',1.12),('325','2014-04-18','08:10:00',1.2),('325','2014-04-18','08:40:00',1.16),('325','2014-04-18','08:45:00',1.28),('325','2014-04-18','08:50:00',1.06),('325','2014-04-18','08:55:00',1),('325','2014-04-18','09:00:00',1.11),('325','2014-04-18','09:05:00',1.84),('325','2014-04-18','09:10:00',2.74),('325','2014-04-18','09:15:00',2.79),('325','2014-04-18','09:20:00',2.66),('325','2014-04-18','09:25:00',1.47),('325','2014-04-18','09:30:00',3.01),('325','2014-04-18','09:35:00',1.79),('325','2014-04-18','09:40:00',1.01),('325','2014-04-18','09:45:00',1.78),('325','2014-04-18','09:50:00',2.43),('325','2014-04-18','09:55:00',2.74),('325','2014-04-18','10:00:00',2.34),('325','2014-04-18','10:05:00',1.64),('325','2014-04-18','10:10:00',1.49),('325','2014-04-18','10:15:00',1.54),('325','2014-04-18','10:20:00',1.51),('325','2014-04-18','10:25:00',1.57),('325','2014-04-18','10:30:00',1.32),('325','2014-04-18','10:35:00',1.21),('325','2014-04-18','10:40:00',1.39),('325','2014-04-18','10:45:00',2.54),('325','2014-04-18','10:50:00',3.05),('325','2014-04-18','10:55:00',3.31),('325','2014-04-18','11:00:00',2.01),('325','2014-04-18','11:05:00',1.73),('325','2014-04-18','11:10:00',1.91),('325','2014-04-18','11:15:00',3.22),('325','2014-04-18','11:20:00',2.05),('325','2014-04-18','11:25:00',1.48),('325','2014-04-18','11:30:00',1.67),('325','2014-04-18','11:35:00',1.69),('325','2014-04-18','11:40:00',1.75),('325','2014-04-18','11:45:00',1.66),('325','2014-04-18','11:50:00',2.04),('325','2014-04-18','11:55:00',1.81),('325','2014-04-18','12:00:00',1.95),('325','2014-04-18','12:05:00',3.81),('325','2014-04-18','12:10:00',3.71),('325','2014-04-18','12:15:00',4.1),('325','2014-04-18','12:20:00',4.42),('325','2014-04-18','12:25:00',3.03),('325','2014-04-18','12:30:00',4.95),('325','2014-04-18','12:35:00',4.81),('325','2014-04-18','12:40:00',4.89),('325','2014-04-18','12:45:00',4.12),('325','2014-04-18','12:50:00',4.03),('325','2014-04-18','12:55:00',3.19),('325','2014-04-18','13:00:00',4.75),('325','2014-04-18','13:05:00',2.81),('325','2014-04-18','13:10:00',2.8),('325','2014-04-18','13:15:00',2.53),('325','2014-04-18','13:20:00',2.39),('325','2014-04-18','13:25:00',1.72),('325','2014-04-18','13:30:00',1.35),('325','2014-04-18','13:35:00',1.4),('325','2014-04-18','13:40:00',1.4),('325','2014-04-18','13:45:00',1.19),('325','2014-04-18','13:50:00',1.35),('325','2014-04-18','13:55:00',2.44),('325','2014-04-18','14:00:00',2.11),('325','2014-04-18','14:05:00',1.88),('325','2014-04-18','14:10:00',1.6),('325','2014-04-18','14:15:00',1.41),('325','2014-04-18','14:20:00',1.6),('325','2014-04-18','14:25:00',2.12),('325','2014-04-18','14:30:00',2.48),('325','2014-04-18','14:35:00',2.86),('325','2014-04-18','14:40:00',2.55),('325','2014-04-18','14:45:00',2.95),('325','2014-04-18','14:50:00',3.61),('325','2014-04-18','14:55:00',3.05),('325','2014-04-18','15:00:00',4.85),('325','2014-04-18','15:05:00',3.01),('325','2014-04-18','15:10:00',1.94),('325','2014-04-18','15:15:00',2.24),('325','2014-04-18','15:20:00',2.09),('325','2014-04-18','15:25:00',2.66),('325','2014-04-18','15:30:00',3.16),('325','2014-04-18','15:35:00',3.81),('325','2014-04-18','15:40:00',3.96),('325','2014-04-18','15:45:00',2.47),('325','2014-04-18','15:50:00',2.78),('325','2014-04-18','15:55:00',3.39),('325','2014-04-18','16:00:00',2.73),('325','2014-04-18','16:05:00',2.03),('325','2014-04-18','16:10:00',1.59),('325','2014-04-18','16:15:00',1.38),('325','2014-04-18','16:20:00',1.49),('325','2014-04-18','16:25:00',2.44),('325','2014-04-18','16:30:00',2.86),('325','2014-04-18','16:35:00',3.3),('325','2014-04-18','16:40:00',3.36),('325','2014-04-18','16:45:00',3.04),('325','2014-04-18','16:50:00',2.96),('325','2014-04-18','16:55:00',2.96),('325','2014-04-18','17:00:00',3.17),('325','2014-04-18','17:05:00',2.97),('325','2014-04-18','17:10:00',2.52),('325','2014-04-18','17:15:00',2),('325','2014-04-18','17:20:00',2.23),('325','2014-04-18','17:25:00',2.18),('325','2014-04-18','17:30:00',1.94),('325','2014-04-18','17:35:00',1.85),('325','2014-04-18','17:40:00',1.77),('325','2014-04-18','17:45:00',1.67),('325','2014-04-18','17:50:00',1.59),('325','2014-04-18','17:55:00',1.49),('325','2014-04-18','18:00:00',1.41),('325','2014-04-18','18:05:00',1.25),('325','2014-04-18','18:10:00',1.15),('325','2013-11-16','13:05:00',1.08),('325','2013-11-15','09:10:00',1.1),('325','2013-11-15','09:15:00',1.28),('325','2013-11-15','09:20:00',1.07),('325','2013-11-15','09:25:00',1.01),('325','2013-11-15','09:30:00',1.25),('325','2013-11-15','09:35:00',1.35),('325','2013-11-15','09:40:00',1.11),('325','2013-11-15','10:10:00',1.18),('325','2013-11-15','10:15:00',1.46),('325','2013-11-15','10:20:00',1.32),('325','2013-11-15','10:25:00',1.04),('325','2013-11-15','10:50:00',1.1),('325','2013-11-15','10:55:00',1.36),('325','2013-11-15','11:00:00',1.33),('325','2013-11-15','11:05:00',1.32),('325','2013-11-15','11:10:00',1.28),('325','2013-11-15','11:15:00',1.37),('325','2013-11-15','11:20:00',1.86),('325','2013-11-15','11:25:00',1.83),('325','2013-11-15','11:30:00',1.89),('325','2013-11-15','11:35:00',1.88),('325','2013-11-15','11:40:00',2.04),('325','2013-11-15','11:45:00',1.6),('325','2013-11-15','11:50:00',1.35),('325','2013-11-15','11:55:00',1.23),('325','2013-11-15','12:00:00',1.24),('325','2013-11-15','12:05:00',1.5),('325','2013-11-15','12:10:00',1.16),('325','2013-11-15','12:15:00',1.32),('325','2013-11-15','12:20:00',1.65),('325','2013-11-15','12:25:00',1.82),('325','2013-11-15','12:30:00',1.45),('325','2013-11-15','12:35:00',1.26),('325','2013-11-15','12:40:00',1.18),('325','2013-11-15','12:45:00',1.16),('325','2013-11-15','12:50:00',1.25),('325','2013-11-15','12:55:00',1.49),('325','2013-11-15','13:00:00',1.61),('325','2013-11-15','13:05:00',1.35),('325','2013-11-15','13:10:00',1.2),('325','2013-11-15','13:25:00',1.05),('325','2013-11-15','13:30:00',1.21),('325','2013-11-15','13:35:00',1.42),('325','2013-11-15','13:40:00',1.56),('325','2013-11-15','13:45:00',2.08),('325','2013-11-15','13:50:00',2.21),('325','2013-11-15','13:55:00',1.43),('325','2013-11-15','14:00:00',1.14),('325','2013-11-15','14:05:00',1.01),('325','2013-11-14','09:00:00',1.33),('325','2013-11-14','09:05:00',1.34),('325','2013-11-14','09:10:00',1.14),('325','2013-11-14','09:15:00',1.07),('325','2013-11-14','09:20:00',1.35),('325','2013-11-14','09:25:00',1.34),('325','2013-11-14','09:30:00',1.37),('325','2013-11-14','09:35:00',1.4),('325','2013-11-14','09:40:00',1.86),('325','2013-11-14','09:45:00',2.28),('325','2013-11-14','09:50:00',2.04),('325','2013-11-14','09:55:00',1.51),('325','2013-11-14','10:00:00',1.1),('325','2013-11-14','10:05:00',2.02),('325','2013-11-14','10:10:00',2.36),('325','2013-11-14','10:15:00',2.73),('325','2013-11-14','10:20:00',2.8),('325','2013-11-14','10:25:00',2.78),('325','2013-11-14','10:30:00',2.81),('325','2013-11-14','10:35:00',2.82),('325','2013-11-14','10:40:00',2.78),('325','2013-11-14','10:45:00',2.8),('325','2013-11-14','10:50:00',2.88),('325','2013-11-14','10:55:00',2.89),('325','2013-11-14','11:00:00',2.92),('325','2013-11-14','11:05:00',3.06),('325','2013-11-14','11:10:00',3.12),('325','2013-11-14','11:15:00',3.18),('325','2013-11-14','11:20:00',3.25),('325','2013-11-14','11:25:00',3.29),('325','2013-11-14','11:30:00',3.28),('325','2013-11-14','11:35:00',2.9),('325','2013-11-14','11:40:00',2.78),('325','2013-11-14','11:45:00',2.07),('325','2013-11-14','11:50:00',2.31),('325','2013-11-14','11:55:00',2.7),('325','2013-11-14','12:00:00',3.24),('325','2013-11-14','12:05:00',2.04),('325','2013-11-14','12:10:00',1.5),('325','2013-11-14','12:15:00',1.48),('325','2013-11-14','12:20:00',1.37),('325','2013-11-14','12:25:00',1.17),('325','2013-11-14','12:30:00',1.16),('325','2013-11-14','12:35:00',1.2),('325','2013-11-14','12:40:00',1.17),('325','2013-11-14','12:45:00',1.19),('325','2013-11-14','12:50:00',1.21),('325','2013-11-14','12:55:00',1.17),('325','2013-11-14','13:00:00',1.15),('325','2013-11-14','13:05:00',1.01),('325','2013-11-14','13:30:00',1.01),('325','2013-11-14','13:55:00',1.25),('325','2013-11-12','11:25:00',1.57),('325','2013-11-12','11:35:00',1.11),('325','2013-11-12','11:40:00',1.87),('325','2013-11-12','11:45:00',1.14),('325','2013-11-12','11:50:00',2.02),('325','2013-11-12','11:55:00',1.07),('325','2013-11-12','12:00:00',2.74),('325','2013-11-12','12:05:00',1.69),('325','2013-11-12','12:25:00',1.03),('325','2013-11-12','12:30:00',4.16),('325','2013-11-12','12:35:00',3.79),('325','2013-11-12','12:40:00',2.16),('325','2013-11-12','12:45:00',2.04),('325','2013-11-12','12:50:00',2.14),('325','2013-11-12','12:55:00',2.6),('325','2013-11-12','13:00:00',2.09),('325','2013-11-12','13:05:00',2.16),('325','2013-11-12','13:10:00',2.93),('325','2013-11-12','13:15:00',2.65),('325','2013-11-12','13:20:00',2.09),('325','2013-11-12','13:25:00',2.26),('325','2013-11-12','13:30:00',1.95),('325','2013-11-12','13:35:00',2.02),('325','2013-11-12','13:40:00',2.22),('325','2013-11-12','13:45:00',1.83),('325','2013-11-12','13:50:00',1.46),('325','2013-11-12','13:55:00',1.6),('325','2013-11-12','14:00:00',1.43),('325','2013-11-12','14:05:00',1.5),('325','2013-11-12','14:10:00',3.14),('325','2013-11-12','14:15:00',3.14),('325','2013-11-12','14:20:00',2.67),('325','2013-11-12','14:25:00',1.24),('325','2013-11-12','14:30:00',1.73),('325','2013-11-12','14:35:00',2.05),('325','2013-11-12','14:40:00',2.09),('325','2013-11-12','14:45:00',1.71),('325','2013-11-12','14:50:00',1.38),('325','2013-11-11','09:50:00',1.16),('325','2013-11-11','09:55:00',1.16),('325','2013-11-11','10:05:00',1.12),('325','2013-11-11','10:10:00',1.27),('325','2013-11-11','10:15:00',2.06),('325','2013-11-11','10:20:00',2.6),('325','2013-11-11','10:25:00',1.53),('325','2013-11-11','11:05:00',1.65),('325','2013-11-11','11:10:00',3.75),('325','2013-11-11','11:15:00',3.19),('325','2013-11-11','11:20:00',2.51),('325','2013-11-11','11:25:00',2.19),('325','2013-11-11','11:30:00',4.14),('325','2013-11-11','11:35:00',2.55),('325','2013-11-11','11:40:00',4.16),('325','2013-11-11','11:45:00',2.62),('325','2013-11-11','11:50:00',4.19),('325','2013-11-11','11:55:00',3.97),('325','2013-11-11','12:00:00',3.72),('325','2013-11-11','12:05:00',3.55),('325','2013-11-11','12:10:00',3.48),('325','2013-11-11','12:15:00',3.19),('325','2013-11-11','12:20:00',3.52),('325','2013-11-11','12:25:00',3.59),('325','2013-11-11','12:30:00',1.77),('325','2013-11-11','12:40:00',1.88),('325','2013-11-11','12:45:00',2.69),('325','2013-11-11','12:50:00',1.39),('325','2013-11-11','13:00:00',1.24),('325','2013-11-11','13:05:00',1.1),('325','2013-11-11','13:10:00',1.79),('325','2013-11-11','13:15:00',2.33),('325','2013-11-11','13:35:00',1.29),('325','2013-11-11','13:40:00',1.84),('325','2013-11-11','14:00:00',2.73),('325','2013-11-11','14:05:00',2.03),('325','2013-11-11','14:20:00',1.52),('325','2013-11-11','14:25:00',2.62),('325','2013-11-11','14:30:00',2.36),('325','2013-11-11','14:35:00',2.24),('325','2013-11-11','14:40:00',1.97),('325','2013-11-11','14:45:00',1.12),('325','2013-11-10','08:35:00',1.16),('325','2013-11-10','08:40:00',1.24),('325','2013-11-10','08:45:00',1.01),('325','2013-11-10','08:50:00',1.39),('325','2013-11-10','08:55:00',1.36),('325','2013-11-10','09:00:00',1.36),('325','2013-11-10','09:05:00',1.03),('325','2013-11-10','09:10:00',1.01),('325','2013-11-10','09:15:00',1.27),('325','2013-11-10','09:20:00',1.48),('325','2013-11-10','09:25:00',1.58),('325','2013-11-10','09:30:00',1.36),('325','2013-11-10','09:35:00',1.35),('325','2013-11-10','09:40:00',1.81),('325','2013-11-10','09:45:00',2.37),('325','2013-11-10','09:50:00',2.52),('325','2013-11-10','09:55:00',2.51),('325','2013-11-10','10:00:00',2.59),('325','2013-11-10','10:05:00',2.8),('325','2013-11-10','10:10:00',2.96),('325','2013-11-10','10:15:00',2.93),('325','2013-11-10','10:20:00',2.64),('325','2013-11-10','10:25:00',3.25),('325','2013-11-10','10:30:00',3.01),('325','2013-11-10','10:35:00',2.11),('325','2013-11-10','10:40:00',3.22),('325','2013-11-10','10:45:00',2.54),('325','2013-11-10','10:50:00',3.34),('325','2013-11-10','10:55:00',3.36),('325','2013-11-10','11:00:00',2.47),('325','2013-11-10','11:05:00',1.86),('325','2013-11-10','11:10:00',1.04),('325','2013-11-10','11:20:00',1.11),('325','2013-11-10','11:25:00',1.26),('325','2013-11-10','11:35:00',1.55),('325','2013-11-10','11:40:00',2.3),('325','2013-11-10','11:45:00',2.54),('325','2013-11-10','11:55:00',1.75),('325','2013-11-10','12:05:00',1.61),('325','2013-11-10','12:10:00',2.19),('325','2013-11-10','12:15:00',3.38),('325','2013-11-10','12:20:00',3.31),('325','2013-11-10','12:25:00',3.05),('325','2013-11-10','12:30:00',1.6),('325','2013-11-10','12:35:00',2.94),('325','2013-11-10','12:40:00',3.54),('325','2013-11-10','12:45:00',3.57),('325','2013-11-10','12:50:00',3.44),('325','2013-11-10','12:55:00',1.58),('325','2013-11-10','13:00:00',1.26),('325','2013-11-10','13:45:00',1.05),('325','2013-11-10','13:50:00',2.73),('325','2013-11-10','13:55:00',1.89),('325','2013-11-10','14:30:00',1.06),('325','2013-11-09','09:40:00',1.85),('325','2013-11-09','09:45:00',1.58),('325','2013-11-09','09:50:00',3.1),('325','2013-11-09','09:55:00',2.9),('325','2013-11-09','10:00:00',2.87),('325','2013-11-09','10:05:00',2.46),('325','2013-11-09','10:10:00',2.48),('325','2013-11-09','10:15:00',2.53),('325','2013-11-09','10:20:00',2.44),('325','2013-11-09','10:25:00',1.57),('325','2013-11-09','10:30:00',1.22),('325','2013-11-09','10:35:00',1.38),('325','2013-11-09','10:40:00',1.41),('325','2013-11-09','10:45:00',1.52),('325','2013-11-09','10:50:00',1.82),('325','2013-11-09','10:55:00',2.1),('325','2013-11-09','11:00:00',2.19),('325','2013-11-09','11:05:00',2.52),('325','2013-11-09','11:10:00',2.47),('325','2013-11-09','11:15:00',2.52),('325','2013-11-09','11:20:00',2.12),('325','2013-11-09','11:25:00',2.86),('325','2013-11-09','11:30:00',2.16),('325','2013-11-09','11:35:00',2.28),('325','2013-11-09','11:40:00',3.31),('325','2013-11-09','11:45:00',3.66),('325','2013-11-09','11:50:00',2.97),('325','2013-11-09','11:55:00',3.76),('325','2013-11-09','12:00:00',4.07),('325','2013-11-09','12:05:00',3.79),('325','2013-11-09','12:10:00',1.98),('325','2013-11-09','12:15:00',2.32),('325','2013-11-09','12:20:00',1.2),('325','2013-11-09','12:25:00',1.94),('325','2013-11-09','12:30:00',2.23),('325','2013-11-09','12:35:00',3.92),('325','2013-11-09','12:40:00',3.82),('325','2013-11-09','12:45:00',2.17),('325','2013-11-09','12:50:00',1.96),('325','2013-11-09','12:55:00',1.93),('325','2013-11-09','13:00:00',3.12),('325','2013-11-09','13:05:00',2.52),('325','2013-11-09','13:10:00',3.38),('325','2013-11-09','13:15:00',3.08),('325','2013-11-09','13:25:00',3.03),('325','2013-11-09','13:30:00',2.97),('325','2013-11-09','13:35:00',2.49),('325','2013-11-09','13:40:00',2.78),('325','2013-11-09','13:45:00',2.72),('325','2013-11-09','13:50:00',2.71),('325','2013-11-09','13:55:00',2.65),('325','2013-11-09','14:00:00',2.44),('325','2013-11-09','14:05:00',2.23),('325','2013-11-09','14:10:00',1.3),('325','2013-11-09','14:15:00',1.59),('325','2013-11-09','14:20:00',2.5),('325','2013-11-09','14:25:00',1.71),('325','2013-11-09','14:35:00',1.47),('325','2013-11-09','14:40:00',1.35),('325','2013-11-09','14:45:00',1.01),('325','2013-11-09','14:50:00',1.76),('325','2013-11-09','15:30:00',1.11),('325','2013-11-09','15:35:00',1.02),('325','2013-11-08','09:05:00',1.03),('325','2013-11-08','09:10:00',1.18),('325','2013-11-08','09:15:00',1.04),('325','2013-11-08','09:20:00',1.06),('325','2013-11-08','09:25:00',1.52),('325','2013-11-08','09:30:00',2),('325','2013-11-08','09:35:00',1.39),('325','2013-11-08','09:40:00',1.11),('325','2013-11-08','09:45:00',1.55),('325','2013-11-08','09:50:00',2.64),('325','2013-11-08','09:55:00',1.73),('325','2013-11-08','10:00:00',2.71),('325','2013-11-08','10:05:00',1.92),('325','2013-11-08','10:10:00',1.32),('325','2013-11-08','10:40:00',1.51),('325','2013-11-08','10:45:00',2.28),('325','2013-11-08','10:50:00',2.53),('325','2013-11-08','10:55:00',1.11),('325','2013-11-08','11:00:00',1.08),('325','2013-11-08','11:20:00',2.52),('325','2013-11-08','11:25:00',1.26),('325','2013-11-08','11:35:00',3.18),('325','2013-11-08','11:40:00',3.63),('325','2013-11-08','11:45:00',3.06),('325','2013-11-08','11:50:00',3.66),('325','2013-11-08','11:55:00',3.51),('325','2013-11-08','12:00:00',2.97),('325','2013-11-08','12:05:00',3.24),('325','2013-11-08','12:10:00',2.83),('325','2013-11-08','12:15:00',1.3),('325','2013-11-08','12:20:00',2.03),('325','2013-11-08','12:35:00',2.89),('325','2013-11-08','12:40:00',2.5),('325','2013-11-08','12:45:00',3.44),('325','2013-11-08','12:50:00',3.47),('325','2013-11-08','12:55:00',3.4),('325','2013-11-08','13:00:00',3.25),('325','2013-11-08','13:05:00',3.25),('325','2013-11-08','13:10:00',3.33),('325','2013-11-08','13:15:00',1.85),('325','2013-11-08','13:20:00',2.03),('325','2013-11-08','13:25:00',1.36),('325','2013-11-08','13:30:00',2.16),('325','2013-11-08','13:35:00',2.95),('325','2013-11-08','13:40:00',2.84),('325','2013-11-08','13:45:00',2.74),('325','2013-11-08','13:50:00',2.71),('325','2013-11-08','13:55:00',2.68),('325','2013-11-08','14:00:00',2.58),('325','2013-11-08','14:05:00',2.48),('325','2013-11-08','14:10:00',2.43),('325','2013-11-08','14:20:00',2.31),('325','2013-11-08','14:25:00',2.14),('325','2013-11-08','14:30:00',2.26),('325','2013-11-08','14:35:00',2.11),('325','2013-11-08','14:40:00',2.04),('325','2013-11-08','14:45:00',1.91),('325','2013-11-08','14:50:00',1.03),('325','2013-11-08','15:00:00',1.57),('325','2013-11-08','15:05:00',1.62),('325','2013-11-08','15:10:00',1.49),('325','2013-11-08','15:25:00',1.04),('325','2013-11-07','08:50:00',1.02),('325','2013-11-07','08:55:00',1.06),('325','2013-11-07','09:00:00',1.1),('325','2013-11-07','09:05:00',1.14),('325','2013-11-07','09:10:00',1.18),('325','2013-11-07','09:15:00',1.22),('325','2013-11-07','09:20:00',1.25),('325','2013-11-07','09:25:00',1.28),('325','2013-11-07','09:30:00',1.31),('325','2013-11-07','09:35:00',1.95),('325','2013-11-07','09:40:00',2.36),('325','2013-11-07','09:45:00',2.47),('325','2013-11-07','09:50:00',2.51),('325','2013-11-07','09:55:00',2.56),('325','2013-11-07','10:00:00',2.62),('325','2013-11-07','10:05:00',2.67),('325','2013-11-07','10:10:00',2.7),('325','2013-11-07','10:15:00',2.72),('325','2013-11-07','10:20:00',2.75),('325','2013-11-07','10:25:00',2.83),('325','2013-11-07','10:30:00',2.86),('325','2013-11-07','10:35:00',2.89),('325','2013-11-07','10:40:00',2.9),('325','2013-11-07','10:45:00',2.95),('325','2013-11-07','10:50:00',2.93),('325','2013-11-07','10:55:00',2.95),('325','2013-11-07','11:00:00',2.97),('325','2013-11-07','11:05:00',2.99),('325','2013-11-07','11:10:00',2.97),('325','2013-11-07','11:15:00',3),('325','2013-11-07','11:20:00',2.98),('325','2013-11-07','11:25:00',2.98),('325','2013-11-07','11:30:00',3.04),('325','2013-11-07','11:35:00',3.06),('325','2013-11-07','11:40:00',3.05),('325','2013-11-07','11:45:00',3.04),('325','2013-11-07','11:50:00',3.06),('325','2013-11-07','11:55:00',3.04),('325','2013-11-07','12:00:00',3.02),('325','2013-11-07','12:15:00',2.95),('325','2013-11-07','12:20:00',2.94),('325','2013-11-07','12:25:00',2.99),('325','2013-11-07','12:30:00',3.01),('325','2013-11-07','12:35:00',2.99),('325','2013-11-07','12:40:00',2.99),('325','2013-11-07','12:45:00',2.92),('325','2013-11-07','12:50:00',2.86),('325','2013-11-07','12:55:00',2.88),('325','2013-11-07','13:00:00',2.97),('325','2013-11-07','13:05:00',2.25),('325','2013-11-07','13:10:00',1.18),('325','2013-11-07','13:15:00',1.19),('325','2013-11-07','13:20:00',1.27),('325','2013-11-07','13:25:00',2.76),('325','2013-11-07','13:30:00',3.07),('325','2013-11-07','13:35:00',2.96),('325','2013-11-07','13:40:00',1.92),('325','2013-11-07','13:45:00',2.17),('325','2013-11-07','13:50:00',2.53),('325','2013-11-07','13:55:00',2.06),('325','2013-11-07','14:00:00',1.55),('325','2013-11-07','14:05:00',1.64),('325','2013-11-07','14:10:00',2.05),('325','2013-11-07','14:20:00',2.1),('325','2013-11-07','14:25:00',1.69),('325','2013-11-07','14:30:00',1.89),('325','2013-11-07','14:35:00',2),('325','2013-11-07','14:40:00',2),('325','2013-11-07','14:45:00',1.9),('325','2013-11-07','14:50:00',1.84),('325','2013-11-07','14:55:00',1.74),('325','2013-11-07','15:00:00',1.63),('325','2013-11-07','15:05:00',1.56),('325','2013-11-07','15:10:00',1.45),('325','2013-11-07','15:15:00',1.37),('325','2013-11-07','15:20:00',1.28),('325','2013-11-07','15:25:00',1.2),('325','2013-11-07','15:30:00',1.12),('325','2013-11-07','15:35:00',1.02),('325','2014-04-17','08:40:00',1.05),('325','2014-04-17','08:45:00',1.1),('325','2014-04-17','08:50:00',1.18),('325','2014-04-17','08:55:00',1.26),('325','2014-04-17','09:00:00',1.55),('325','2014-04-17','09:05:00',1.96),('325','2014-04-17','09:10:00',2.19),('325','2014-04-17','09:15:00',2.37),('325','2014-04-17','09:20:00',2.55),('325','2014-04-17','09:25:00',2.61),('325','2014-04-17','09:30:00',2.75),('325','2014-04-17','09:35:00',2.66),('325','2014-04-17','09:40:00',2.47),('325','2014-04-17','09:45:00',2.61),('325','2014-04-17','09:50:00',3.06),('325','2014-04-17','09:55:00',3.19),('325','2014-04-17','10:00:00',3.35),('325','2014-04-17','10:05:00',3.61),('325','2014-04-17','10:10:00',3.43),('325','2014-04-17','10:15:00',2.61),('325','2014-04-17','10:20:00',3.78),('325','2014-04-17','10:25:00',3.91),('325','2014-04-17','10:30:00',4.23),('325','2014-04-17','10:35:00',4.47),('325','2014-04-17','10:40:00',4.19),('325','2014-04-17','10:45:00',3.82),('325','2014-04-17','10:50:00',2.81),('325','2014-04-17','10:55:00',2.51),('325','2014-04-17','11:00:00',2.91),('325','2014-04-17','11:05:00',3.18),('325','2014-04-17','11:10:00',3.14),('325','2014-04-17','11:15:00',2.34),('325','2014-04-17','11:20:00',3.1),('325','2014-04-17','11:25:00',4.19),('325','2014-04-17','11:30:00',2.68),('325','2014-04-17','11:35:00',2.31),('325','2014-04-17','11:40:00',2.54),('325','2014-04-17','11:45:00',4.29),('325','2014-04-17','11:50:00',3.38),('325','2014-04-17','11:55:00',2.46),('325','2014-04-17','12:00:00',3.31),('325','2014-04-17','12:05:00',3.14),('325','2014-04-17','12:10:00',2.71),('325','2014-04-17','12:15:00',2.36),('325','2014-04-17','12:20:00',2.71),('325','2014-04-17','12:25:00',3.16),('325','2014-04-17','12:30:00',3.62),('325','2014-04-17','12:35:00',4.12),('325','2014-04-17','12:40:00',4.79),('325','2014-04-17','12:45:00',4.54),('325','2014-04-17','12:50:00',3.01),('325','2014-04-17','12:55:00',2.64),('325','2014-04-17','13:00:00',5.08),('325','2014-04-17','13:05:00',5.07),('325','2014-04-17','13:10:00',4.47),('325','2014-04-17','13:15:00',4.12),('325','2014-04-17','13:20:00',1.99),('325','2014-04-17','13:25:00',4.6),('325','2014-04-17','13:30:00',4.59),('325','2014-04-17','13:35:00',1.82),('325','2014-04-17','13:40:00',1.01),('325','2014-04-17','13:50:00',2.73),('325','2014-04-17','13:55:00',1.67),('325','2014-04-17','14:00:00',1.06),('325','2014-04-17','14:05:00',1.2),('325','2014-04-17','14:10:00',2.95),('325','2014-04-17','14:15:00',4.49),('325','2014-04-17','14:20:00',1.53),('325','2014-04-17','14:25:00',2.25),('325','2014-04-17','14:30:00',1.91),('325','2014-04-17','14:35:00',2.57),('325','2014-04-17','14:40:00',3.67),('325','2014-04-17','14:45:00',1.45),('325','2014-04-17','15:25:00',1.14),('325','2014-04-17','15:30:00',2.19),('325','2014-04-17','15:35:00',2.81),('325','2014-04-17','15:40:00',2.06),('325','2014-04-17','15:45:00',1.49),('325','2014-04-17','15:50:00',1.25),('325','2014-04-17','15:55:00',1.4),('325','2014-04-17','16:00:00',1.15),('325','2014-04-17','16:10:00',1.09),('325','2014-04-17','16:15:00',1.09),('325','2014-04-17','16:20:00',1.03),('325','2014-04-17','16:25:00',1.17),('325','2014-04-17','16:30:00',1.19),('325','2014-04-17','16:35:00',1.08),('325','2014-04-17','16:40:00',1.3),('325','2014-04-17','16:45:00',1.9),('325','2014-04-17','16:50:00',1.8),('325','2014-04-17','16:55:00',1.35),('325','2014-04-17','17:00:00',1.1),('325','2014-04-17','17:15:00',1.02),('325','2014-04-17','17:20:00',1.17),('325','2014-04-17','17:30:00',1.02),('325','2014-04-17','17:35:00',1.08),('325','2014-04-17','17:40:00',1.02),('325','2013-11-06','08:45:00',1.02),('325','2013-11-06','08:50:00',1.13),('325','2013-11-06','08:55:00',1.13),('325','2013-11-06','09:15:00',1.11),('325','2013-11-06','09:20:00',1.12),('325','2013-11-06','09:25:00',1.31),('325','2013-11-06','09:30:00',1.53),('325','2013-11-06','09:35:00',2.31),('325','2013-11-06','09:40:00',2.46),('325','2013-11-06','09:45:00',2.58),('325','2013-11-06','09:50:00',2.61),('325','2013-11-06','09:55:00',2.66),('325','2013-11-06','10:00:00',2.72),('325','2013-11-06','10:05:00',2.79),('325','2013-11-06','10:10:00',2.84),('325','2013-11-06','10:15:00',2.89),('325','2013-11-06','10:20:00',2.93),('325','2013-11-06','10:25:00',2.98),('325','2013-11-06','10:30:00',3.01),('325','2013-11-06','10:35:00',3.05),('325','2013-11-06','10:40:00',3.08),('325','2013-11-06','10:45:00',3.12),('325','2013-11-06','10:50:00',3.16),('325','2013-11-06','10:55:00',3.17),('325','2013-11-06','11:00:00',3.19),('325','2013-11-06','11:05:00',3.21),('325','2013-11-06','11:10:00',3.23),('325','2013-11-06','11:15:00',3.25),('325','2013-11-06','11:20:00',3.27),('325','2013-11-06','11:25:00',3.28),('325','2013-11-06','11:30:00',3.28),('325','2013-11-06','11:35:00',3.26),('325','2013-11-06','11:40:00',3.28),('325','2013-11-06','11:45:00',3.31),('325','2013-11-06','11:50:00',3.28),('325','2013-11-06','11:55:00',3.3),('325','2013-11-06','12:00:00',3.3),('325','2013-11-06','12:05:00',3.28),('325','2013-11-06','12:10:00',3.27),('325','2013-11-06','12:15:00',3.25),('325','2013-11-06','12:20:00',3.25),('325','2013-11-06','12:25:00',3.24),('325','2013-11-06','12:30:00',3.23),('325','2013-11-06','12:35:00',3.22),('325','2013-11-06','12:40:00',3.18),('325','2013-11-06','12:45:00',3.17),('325','2013-11-06','12:50:00',3.13),('325','2013-11-06','12:55:00',3.09),('325','2013-11-06','13:00:00',3.07),('325','2013-11-06','13:05:00',3.04),('325','2013-11-06','13:10:00',2.98),('325','2013-11-06','13:15:00',2.96),('325','2013-11-06','13:20:00',2.93),('325','2013-11-06','13:25:00',2.89),('325','2013-11-06','13:30:00',2.84),('325','2013-11-06','13:35:00',2.8),('325','2013-11-06','13:40:00',2.75),('325','2013-11-06','13:45:00',2.69),('325','2013-11-06','13:50:00',2.64),('325','2013-11-06','13:55:00',2.59),('325','2013-11-06','14:00:00',2.52),('325','2013-11-06','14:05:00',2.49),('325','2013-11-06','14:10:00',2.45),('325','2013-11-06','14:15:00',2.39),('325','2013-11-06','14:20:00',2.33),('325','2013-11-06','14:25:00',2.25),('325','2013-11-06','14:30:00',2.19),('325','2013-11-06','14:35:00',2.12),('325','2013-11-06','14:40:00',2.04),('325','2013-11-06','14:45:00',1.96),('325','2013-11-06','14:50:00',1.87),('325','2013-11-06','14:55:00',1.77),('325','2013-11-06','15:00:00',1.68),('325','2013-11-06','15:05:00',1.6),('325','2013-11-06','15:10:00',1.52),('325','2013-11-06','15:15:00',1.44),('325','2013-11-06','15:20:00',1.35),('325','2013-11-06','15:25:00',1.24),('325','2013-11-06','15:30:00',1.16),('325','2013-11-06','15:35:00',1.06),('325','2013-11-05','08:30:00',1.11),('325','2013-11-05','08:35:00',1.35),('325','2013-11-05','08:40:00',1.33),('325','2013-11-05','10:15:00',1.07),('325','2013-11-05','10:20:00',1.76),('325','2013-11-05','10:25:00',2.37),('325','2013-11-05','10:30:00',1.61),('325','2013-11-05','10:35:00',2.55),('325','2013-11-05','10:40:00',1.66),('325','2013-11-05','10:45:00',1.84),('325','2013-11-05','10:50:00',1.4),('325','2013-11-05','10:55:00',1.2),('325','2013-11-05','11:35:00',1.2),('325','2013-11-05','11:40:00',1.55),('325','2013-11-05','11:45:00',1.44),('325','2013-11-05','11:50:00',1.35),('325','2013-11-05','11:55:00',1.18),('325','2013-11-05','12:00:00',1.05),('325','2013-11-05','12:05:00',1.38),('325','2013-11-05','12:10:00',1.64),('325','2013-11-05','12:15:00',1.62),('325','2013-11-05','12:20:00',1.68),('325','2013-11-05','12:25:00',1.68),('325','2013-11-05','12:30:00',1.61),('325','2013-11-05','12:35:00',1.12),('325','2013-11-05','13:30:00',1.3),('325','2013-11-05','13:35:00',2.61),('325','2013-11-05','13:40:00',2.83),('325','2013-11-05','13:45:00',2.32),('325','2013-11-05','13:50:00',1.24),('325','2013-11-05','13:55:00',2.02),('325','2013-11-05','14:00:00',1.36),('325','2013-11-05','14:05:00',3.18),('325','2013-11-05','14:10:00',2.49),('325','2013-11-05','14:20:00',1.27),('325','2013-11-05','14:25:00',1.55),('325','2013-11-05','14:30:00',2.07),('325','2013-11-05','14:35:00',1.59),('325','2013-11-05','14:45:00',1.68),('325','2013-11-05','15:15:00',1.07),('325','2013-11-05','15:30:00',1.29),('325','2013-11-05','15:35:00',1.06),('325','2013-11-04','09:10:00',1.42),('325','2013-11-04','09:15:00',1.73),('325','2013-11-04','09:20:00',1.92),('325','2013-11-04','09:25:00',2.07),('325','2013-11-04','10:00:00',2.31),('325','2013-11-04','10:05:00',2.92),('325','2013-11-04','10:10:00',2.96),('325','2013-11-04','10:15:00',3.03),('325','2013-11-04','10:20:00',2.84),('325','2013-11-04','10:25:00',3.43),('325','2013-11-04','10:30:00',3.52),('325','2013-11-04','10:35:00',2.69),('325','2013-11-04','10:40:00',3.91),('325','2013-11-04','10:45:00',2.32),('325','2013-11-04','10:50:00',3.39),('325','2013-11-04','10:55:00',3.35),('325','2013-11-04','11:00:00',2.58),('325','2013-11-04','11:05:00',3.65),('325','2013-11-04','11:10:00',1.38),('325','2013-11-04','11:15:00',1.97),('325','2013-11-04','11:20:00',1.85),('325','2013-11-04','11:25:00',1.52),('325','2013-11-04','11:30:00',2.78),('325','2013-11-04','11:35:00',2.7),('325','2013-11-04','11:40:00',2.41),('325','2013-11-04','11:45:00',2.75),('325','2013-11-04','11:50:00',4.34),('325','2013-11-04','11:55:00',3.76),('325','2013-11-04','12:00:00',3.56),('325','2013-11-04','12:05:00',3.56),('325','2013-11-04','12:10:00',3.52),('325','2013-11-04','12:15:00',3.48),('325','2013-11-04','12:20:00',3.48),('325','2013-11-04','12:25:00',3.45),('325','2013-11-04','12:30:00',3.44),('325','2013-11-04','12:35:00',3.48),('325','2013-11-04','12:40:00',3.43),('325','2013-11-04','12:45:00',3.4),('325','2013-11-04','12:50:00',3.32),('325','2013-11-04','12:55:00',3.26),('325','2013-11-04','13:00:00',3.24),('325','2013-11-04','13:05:00',3.22),('325','2013-11-04','13:10:00',3.16),('325','2013-11-04','13:15:00',3.14),('325','2013-11-04','13:20:00',2.8),('325','2013-11-04','13:25:00',2.84),('325','2013-11-04','13:30:00',3.02),('325','2013-11-04','13:35:00',3.02),('325','2013-11-04','13:40:00',2.57),('325','2013-11-04','13:45:00',2.99),('325','2013-11-04','13:50:00',2.85),('325','2013-11-04','13:55:00',1.71),('325','2013-11-04','14:00:00',1.24),('325','2013-11-04','14:05:00',2.61),('325','2013-11-04','14:10:00',2.7),('325','2013-11-04','14:15:00',1.95),('325','2013-11-04','14:20:00',1.62),('325','2013-11-04','14:25:00',1.24),('325','2013-11-04','14:30:00',1.23),('325','2013-11-04','14:35:00',2.54),('325','2013-11-04','14:40:00',2.2),('325','2013-11-04','14:45:00',2.16),('325','2013-11-04','14:50:00',2.05),('325','2013-11-04','14:55:00',1.96),('325','2013-11-04','15:00:00',1.79),('325','2013-11-04','15:10:00',1.4),('325','2013-11-04','15:15:00',1.46),('325','2013-11-04','15:20:00',1.4),('325','2013-11-04','15:25:00',1.39),('325','2013-11-04','15:30:00',1.27),('325','2013-11-04','15:35:00',1.18),('325','2013-11-04','15:45:00',1.1),('325','2013-11-03','08:50:00',1.39),('325','2013-11-03','09:35:00',1.15),('325','2013-11-03','09:40:00',2.86),('325','2013-11-03','09:45:00',1.19),('325','2013-11-03','10:05:00',1.32),('325','2013-11-03','10:10:00',1.36),('325','2013-11-03','10:20:00',2.85),('325','2013-11-03','10:25:00',1.82),('325','2013-11-03','10:30:00',3.17),('325','2013-11-03','10:35:00',2.29),('325','2013-11-03','11:15:00',1.12),('325','2013-11-03','11:20:00',2.38),('325','2013-11-03','11:25:00',1.51),('325','2013-11-03','11:30:00',2.81),('325','2013-11-03','11:35:00',3.21),('325','2013-11-03','11:40:00',3.63),('325','2013-11-03','11:45:00',3.69),('325','2013-11-03','11:50:00',3.43),('325','2013-11-03','11:55:00',2.65),('325','2013-11-03','12:00:00',2.24),('325','2013-11-03','12:05:00',3.87),('325','2013-11-03','12:10:00',2.57),('325','2013-11-03','12:15:00',2.11),('325','2013-11-03','12:20:00',1.23),('325','2013-11-03','12:25:00',2.23),('325','2013-11-03','12:30:00',1.11),('325','2013-11-03','12:35:00',1.32),('325','2013-11-03','12:40:00',1.37),('325','2013-11-03','12:45:00',1.06),('325','2013-11-03','12:50:00',1.13),('325','2013-11-03','13:25:00',1.05),('325','2013-11-03','13:30:00',1.05),('325','2013-11-03','13:35:00',1.2),('325','2013-11-03','13:40:00',1.68),('325','2013-11-03','13:45:00',2.12),('325','2013-11-03','13:55:00',1.58),('325','2013-11-03','14:00:00',1.33),('325','2013-11-03','14:05:00',2.16),('325','2013-11-03','14:10:00',2.57),('325','2013-11-03','14:15:00',2.58),('325','2013-11-03','14:20:00',1.94),('325','2013-11-03','14:25:00',1.87),('325','2013-11-03','14:30:00',1.33),('325','2013-11-03','14:35:00',1.74),('325','2013-11-03','14:40:00',2.15),('325','2013-11-03','14:45:00',1.85),('325','2013-11-03','14:50:00',1.43),('325','2013-11-03','14:55:00',1.06),('325','2013-11-03','15:05:00',1.2),('325','2013-11-02','08:45:00',1.02),('325','2013-11-02','08:50:00',1.07),('325','2013-11-02','08:55:00',1.13),('325','2013-11-02','09:00:00',1.21),('325','2013-11-02','09:05:00',1.41),('325','2013-11-02','09:10:00',1.4),('325','2013-11-02','09:15:00',1.36),('325','2013-11-02','09:20:00',1.35),('325','2013-11-02','09:25:00',1.49),('325','2013-11-02','09:30:00',1.5),('325','2013-11-02','09:35:00',2.07),('325','2013-11-02','09:40:00',2.28),('325','2013-11-02','09:45:00',2.4),('325','2013-11-02','09:50:00',2.56),('325','2013-11-02','09:55:00',2.42),('325','2013-11-02','10:00:00',2.91),('325','2013-11-02','10:05:00',2.77),('325','2013-11-02','10:10:00',1.33),('325','2013-11-02','10:15:00',1.25),('325','2013-11-02','10:55:00',1.03),('325','2013-11-02','11:00:00',1.28),('325','2013-11-02','11:05:00',1.41),('325','2013-11-02','11:10:00',1.15),('325','2013-11-02','11:45:00',1.05),('325','2013-11-02','11:50:00',1.48),('325','2013-11-02','11:55:00',2.61),('325','2013-11-02','12:00:00',3.65),('325','2013-11-02','12:05:00',3.81),('325','2013-11-02','12:10:00',3.5),('325','2013-11-02','12:15:00',3.15),('325','2013-11-02','12:20:00',3.78),('325','2013-11-02','12:25:00',3.41),('325','2013-11-02','12:30:00',3.95),('325','2013-11-02','12:35:00',3.36),('325','2013-11-02','12:40:00',3.47),('325','2013-11-02','12:45:00',2.21),('325','2013-11-02','12:50:00',3.27),('325','2013-11-02','12:55:00',3.48),('325','2013-11-02','13:00:00',1.69),('325','2013-11-02','13:05:00',3.08),('325','2013-11-02','13:10:00',3.72),('325','2013-11-02','13:15:00',1.39),('325','2013-11-02','13:20:00',1.09),('325','2013-11-02','13:30:00',1.09),('325','2013-11-02','13:35:00',2.96),('325','2013-11-02','13:40:00',2.94),('325','2013-11-02','13:45:00',3.52),('325','2013-11-02','13:50:00',3.54),('325','2013-11-02','13:55:00',3.35),('325','2013-11-02','14:00:00',3),('325','2013-11-02','14:05:00',2.68),('325','2013-11-02','14:10:00',2.5),('325','2013-11-02','14:15:00',2.43),('325','2013-11-02','14:20:00',2.35),('325','2013-11-02','14:25:00',2.28),('325','2013-11-02','14:30:00',2.22),('325','2013-11-02','14:35:00',2.13),('325','2013-11-02','14:40:00',2.05),('325','2013-11-02','14:45:00',1.97),('325','2013-11-02','14:50:00',1.93),('325','2013-11-02','14:55:00',1.41),('325','2013-11-02','15:00:00',1.47),('325','2013-11-02','15:15:00',1.01),('325','2013-11-01','08:40:00',1),('325','2013-11-01','08:50:00',1.01),('325','2013-11-01','08:55:00',1.04),('325','2013-11-01','09:00:00',1.1),('325','2013-11-01','09:05:00',1.22),('325','2013-11-01','09:10:00',1.26),('325','2013-11-01','09:15:00',1.3),('325','2013-11-01','09:20:00',1.35),('325','2013-11-01','09:25:00',1.39),('325','2013-11-01','09:30:00',1.43),('325','2013-11-01','09:35:00',2.23),('325','2013-11-01','09:40:00',2.38),('325','2013-11-01','09:45:00',2.46),('325','2013-11-01','09:50:00',2.51),('325','2013-11-01','09:55:00',2.58),('325','2013-11-01','10:00:00',2.66),('325','2013-11-01','10:05:00',2.73),('325','2013-11-01','10:10:00',2.78),('325','2013-11-01','10:15:00',2.82),('325','2013-11-01','10:20:00',2.86),('325','2013-11-01','10:25:00',2.9),('325','2013-11-01','10:30:00',2.85),('325','2013-11-01','10:35:00',2.94),('325','2013-11-01','10:40:00',2.96),('325','2013-11-01','10:45:00',2.94),('325','2013-11-01','10:50:00',2.9),('325','2013-11-01','10:55:00',2.97),('325','2013-11-01','11:00:00',3.03),('325','2013-11-01','11:05:00',2.67),('325','2013-11-01','11:10:00',2.44),('325','2013-11-01','11:15:00',2.71),('325','2013-11-01','11:20:00',3.22),('325','2013-11-01','11:25:00',3.35),('325','2013-11-01','11:30:00',3.35),('325','2013-11-01','11:35:00',3.09),('325','2013-11-01','11:40:00',2.73),('325','2013-11-01','11:45:00',3.1),('325','2013-11-01','11:50:00',3.34),('325','2013-11-01','11:55:00',3.34),('325','2013-11-01','12:00:00',3.18),('325','2013-11-01','12:05:00',3.12),('325','2013-11-01','12:10:00',2.98),('325','2013-11-01','12:15:00',2.69),('325','2013-11-01','12:20:00',2.83),('325','2013-11-01','12:25:00',2.93),('325','2013-11-01','12:30:00',1.61),('325','2013-11-01','13:10:00',1.39),('325','2013-11-01','13:15:00',1.39),('325','2013-11-01','13:20:00',1.37),('325','2013-11-01','13:25:00',1.16),('325','2013-11-01','13:30:00',1.25),('325','2013-11-01','13:35:00',1.32),('325','2013-11-01','13:40:00',1.27),('325','2013-10-31','08:35:00',1.01),('325','2013-10-31','08:40:00',1.22),('325','2013-10-31','08:45:00',1.24),('325','2013-10-31','08:50:00',1.31),('325','2013-10-31','08:55:00',1.25),('325','2013-10-31','09:00:00',1.21),('325','2013-10-31','09:05:00',1.1),('325','2013-10-31','09:20:00',1.26),('325','2013-10-31','09:25:00',1.28),('325','2013-10-31','09:30:00',1.39),('325','2013-10-31','09:35:00',1.82),('325','2013-10-31','09:40:00',1.87),('325','2013-10-31','09:45:00',1.84),('325','2013-10-31','09:50:00',1.87),('325','2013-10-31','09:55:00',1.95),('325','2013-10-31','10:00:00',2.04),('325','2013-10-31','10:05:00',1.98),('325','2013-10-31','10:10:00',1.88),('325','2013-10-31','10:15:00',1.72),('325','2013-10-31','10:20:00',1.57),('325','2013-10-31','10:25:00',1.79),('325','2013-10-31','10:30:00',1.82),('325','2013-10-31','10:35:00',2.13),('325','2013-10-31','10:40:00',2.12),('325','2013-10-31','10:45:00',1.94),('325','2013-10-31','10:50:00',2.02),('325','2013-10-31','10:55:00',2.21),('325','2013-10-31','11:00:00',2.55),('325','2013-10-31','11:05:00',3.02),('325','2013-10-31','11:10:00',2.91),('325','2013-10-31','11:15:00',2.92),('325','2013-10-31','11:20:00',2.9),('325','2013-10-31','11:25:00',2.63),('325','2013-10-31','11:30:00',2.92),('325','2013-10-31','11:35:00',2.76),('325','2013-10-31','11:40:00',3.05),('325','2013-10-31','11:45:00',3.21),('325','2013-10-31','11:50:00',3.13),('325','2013-10-31','11:55:00',3.1),('325','2013-10-31','12:00:00',3.03),('325','2013-10-31','12:05:00',3.02),('325','2013-10-31','12:10:00',3.09),('325','2013-10-31','12:15:00',3.06),('325','2013-10-31','12:20:00',3.03),('325','2013-10-31','12:25:00',3.05),('325','2013-10-31','12:30:00',2.99),('325','2013-10-31','12:35:00',2.84),('325','2013-10-31','12:40:00',2.96),('325','2013-10-31','12:45:00',3.03),('325','2013-10-31','12:50:00',3.11),('325','2013-10-31','12:55:00',3.12),('325','2013-10-31','13:00:00',3.05),('325','2013-10-31','13:05:00',2.99),('325','2013-10-31','13:10:00',2.9),('325','2013-10-31','13:15:00',2.86),('325','2013-10-31','13:20:00',2.84),('325','2013-10-31','13:25:00',2.79),('325','2013-10-31','13:30:00',2.7),('325','2013-10-31','13:35:00',2.65),('325','2013-10-31','13:40:00',2.52),('325','2013-10-31','13:45:00',2.42),('325','2013-10-31','13:50:00',1.83),('325','2013-10-31','13:55:00',1.71),('325','2013-10-31','14:00:00',2.4),('325','2013-10-31','14:05:00',2.31),('325','2013-10-31','14:10:00',2.11),('325','2013-10-31','14:15:00',1.93),('325','2013-10-31','14:45:00',1.01),('325','2013-10-31','14:55:00',1.22),('325','2013-10-31','15:00:00',1.28),('325','2013-10-31','15:05:00',1.15),('325','2013-10-31','15:10:00',1.08),('325','2013-10-31','15:15:00',1.01),('325','2013-10-30','08:35:00',1.04),('325','2013-10-30','08:40:00',1.1),('325','2013-10-30','08:45:00',1.16),('325','2013-10-30','08:50:00',1.21),('325','2013-10-30','08:55:00',1.19),('325','2013-10-30','09:00:00',1.25),('325','2013-10-30','09:05:00',1.31),('325','2013-10-30','09:10:00',1.4),('325','2013-10-30','09:15:00',1.44),('325','2013-10-30','09:20:00',1.48),('325','2013-10-30','09:25:00',1.54),('325','2013-10-30','09:30:00',1.65),('325','2013-10-30','09:35:00',2.16),('325','2013-10-30','09:40:00',2.22),('325','2013-10-30','09:45:00',2.35),('325','2013-10-30','09:50:00',2.39),('325','2013-10-30','09:55:00',2.21),('325','2013-10-30','10:00:00',1.94),('325','2013-10-30','10:05:00',1.82),('325','2013-10-30','10:10:00',2.5),('325','2013-10-30','10:15:00',2.74),('325','2013-10-30','10:20:00',2.58),('325','2013-10-30','10:25:00',2.57),('325','2013-10-30','10:30:00',2.71),('325','2013-10-30','10:35:00',2.58),('325','2013-10-30','10:40:00',2.78),('325','2013-10-30','10:45:00',2.86),('325','2013-10-30','10:50:00',2),('325','2013-10-30','10:55:00',2.07),('325','2013-10-30','11:00:00',2.55),('325','2013-10-30','11:05:00',2.63),('325','2013-10-30','11:10:00',3.09),('325','2013-10-30','11:15:00',3.03),('325','2013-10-30','11:20:00',2.53),('325','2013-10-30','11:25:00',1.38),('325','2013-10-30','11:30:00',1.17),('325','2013-10-30','11:40:00',1.25),('325','2013-10-30','11:45:00',1.59),('325','2013-10-30','11:50:00',1.48),('325','2013-10-30','12:00:00',1.2),('325','2013-10-30','12:05:00',1.19),('325','2013-10-30','12:10:00',1.26),('325','2013-10-30','12:15:00',2.48),('325','2013-10-30','12:20:00',3.61),('325','2013-10-30','12:25:00',1.63),('325','2013-10-30','12:30:00',1.65),('325','2013-10-30','12:35:00',1.22),('325','2013-10-30','12:40:00',1.24),('325','2013-10-30','12:45:00',1.25),('325','2013-10-30','12:50:00',2.03),('325','2013-10-30','12:55:00',2.74),('325','2013-10-30','13:00:00',1.97),('325','2013-10-30','13:05:00',3.11),('325','2013-10-30','13:10:00',2.98),('325','2013-10-30','13:15:00',3.3),('325','2013-10-30','13:20:00',3.19),('325','2013-10-30','13:25:00',2.83),('325','2013-10-30','13:30:00',1.44),('325','2013-10-30','13:35:00',2.57),('325','2013-10-30','13:40:00',2.82),('325','2013-10-30','13:45:00',1.76),('325','2013-10-30','13:50:00',1.46),('325','2013-10-30','13:55:00',2.74),('325','2013-10-30','14:00:00',2.82),('325','2013-10-30','14:05:00',2.16),('325','2013-10-30','14:10:00',1.7),('325','2013-10-30','14:20:00',1.02),('325','2013-10-30','14:30:00',1.41),('325','2013-10-30','14:35:00',2.01),('325','2013-10-30','14:40:00',1.98),('325','2013-10-30','14:45:00',1.17),('325','2013-10-30','15:05:00',1.09),('325','2013-10-30','15:10:00',1.18),('325','2013-10-30','15:15:00',1.35),('325','2013-10-30','15:20:00',1.34),('325','2013-10-30','15:25:00',1.18),('325','2013-10-29','08:45:00',1.15),('325','2013-10-29','08:50:00',1.17),('325','2013-10-29','08:55:00',1.22),('325','2013-10-29','09:00:00',1.26),('325','2013-10-29','09:05:00',1.3),('325','2013-10-29','09:10:00',1.34),('325','2013-10-29','09:15:00',1.38),('325','2013-10-29','09:20:00',1.42),('325','2013-10-29','09:25:00',1.45),('325','2013-10-29','09:30:00',1.66),('325','2013-10-29','09:35:00',2.29),('325','2013-10-29','09:40:00',2.53),('325','2013-10-29','09:45:00',2.59),('325','2013-10-29','09:50:00',2.01),('325','2013-10-29','09:55:00',2.2),('325','2013-10-29','10:00:00',1.98),('325','2013-10-29','10:05:00',2.67),('325','2013-10-29','10:10:00',2.62),('325','2013-10-29','10:15:00',1.47),('325','2013-10-29','10:20:00',1.07),('325','2013-10-29','10:25:00',1.52),('325','2013-10-29','10:30:00',1.6),('325','2013-10-29','10:35:00',1.92),('325','2013-10-29','10:40:00',3.19),('325','2013-10-29','10:45:00',3.43),('325','2013-10-29','10:50:00',3.5),('325','2013-10-29','10:55:00',3.55),('325','2013-10-29','11:00:00',3.47),('325','2013-10-29','11:05:00',3.54),('325','2013-10-29','11:10:00',3.41),('325','2013-10-29','11:15:00',3.29),('325','2013-10-29','11:20:00',3.27),('325','2013-10-29','11:25:00',3.29),('325','2013-10-29','11:30:00',3.35),('325','2013-10-29','11:35:00',3.32),('325','2013-10-29','11:40:00',3.31),('325','2013-10-29','11:45:00',3.32),('325','2013-10-29','11:50:00',3.34),('325','2013-10-29','11:55:00',3.23),('325','2013-10-29','12:00:00',3.16),('325','2013-10-29','12:05:00',3.19),('325','2013-10-29','12:10:00',3.16),('325','2013-10-29','12:15:00',3.16),('325','2013-10-29','12:20:00',3.11),('325','2013-10-29','12:25:00',2.81),('325','2013-10-29','12:30:00',2.96),('325','2013-10-29','12:35:00',3.08),('325','2013-10-29','12:40:00',3),('325','2013-10-29','12:45:00',2.52),('325','2013-10-29','12:50:00',2.99),('325','2013-10-29','12:55:00',2.84),('325','2013-10-29','13:00:00',2.89),('325','2013-10-29','13:05:00',2.78),('325','2013-10-29','13:10:00',2.9),('325','2013-10-29','13:15:00',2.88),('325','2013-10-29','13:20:00',2.83),('325','2013-10-29','13:25:00',2.78),('325','2013-10-29','13:30:00',2.77),('325','2013-10-29','13:35:00',2.67),('325','2013-10-29','13:40:00',2.51),('325','2013-10-29','13:45:00',2.55),('325','2013-10-29','13:50:00',2.51),('325','2013-10-29','13:55:00',2.18),('325','2013-10-29','14:00:00',2.39),('325','2013-10-29','14:05:00',2.33),('325','2013-10-29','14:10:00',2.27),('325','2013-10-29','14:15:00',2.24),('325','2013-10-29','14:20:00',2.2),('325','2013-10-29','14:25:00',2.09),('325','2013-10-29','14:30:00',2.03),('325','2013-10-29','14:35:00',1.96),('325','2013-10-29','14:40:00',1.89),('325','2013-10-29','14:45:00',1.8),('325','2013-10-29','14:50:00',1.72),('325','2013-10-29','14:55:00',1.63),('325','2013-10-29','15:00:00',1.57),('325','2013-10-29','15:05:00',1.49),('325','2013-10-29','15:10:00',1.44),('325','2013-10-29','15:15:00',1.36),('325','2013-10-29','15:20:00',1.24),('325','2013-10-29','15:25:00',1.15),('325','2013-10-29','15:30:00',1.08),('325','2013-10-28','08:50:00',1.04),('325','2013-10-28','08:55:00',1.27),('325','2013-10-28','09:00:00',1.38),('325','2013-10-28','09:05:00',1.55),('325','2013-10-28','09:10:00',1.64),('325','2013-10-28','09:15:00',1.54),('325','2013-10-28','09:20:00',1.46),('325','2013-10-28','09:25:00',1.72),('325','2013-10-28','09:30:00',1.64),('325','2013-10-28','09:35:00',1.81),('325','2013-10-28','09:40:00',2.65),('325','2013-10-28','09:45:00',2.65),('325','2013-10-28','09:50:00',1.51),('325','2013-10-28','09:55:00',1.15),('325','2013-10-28','10:45:00',1.46),('325','2013-10-28','10:50:00',3.27),('325','2013-10-28','10:55:00',3.22),('325','2013-10-28','11:00:00',3.24),('325','2013-10-28','11:05:00',3.24),('325','2013-10-28','11:10:00',3.27),('325','2013-10-28','11:15:00',3.27),('325','2013-10-28','11:20:00',3.26),('325','2013-10-28','11:25:00',3.26),('325','2013-10-28','11:30:00',3.29),('325','2013-10-28','11:35:00',3.28),('325','2013-10-28','11:40:00',3.31),('325','2013-10-28','11:45:00',3.27),('325','2013-10-28','11:50:00',3.33),('325','2013-10-28','11:55:00',2.59),('325','2013-10-28','12:00:00',2.89),('325','2013-10-28','12:05:00',3.09),('325','2013-10-28','12:10:00',3.4),('325','2013-10-28','12:15:00',3.4),('325','2013-10-28','12:20:00',2.96),('325','2013-10-28','12:25:00',2.16),('325','2013-10-28','12:30:00',3.77),('325','2013-10-28','12:35:00',3.68),('325','2013-10-28','12:40:00',3.36),('325','2013-10-28','12:45:00',3.49),('325','2013-10-28','12:50:00',3.38),('325','2013-10-28','12:55:00',3.22),('325','2013-10-28','13:00:00',3.17),('325','2013-10-28','13:05:00',3.14),('325','2013-10-28','13:10:00',3.07),('325','2013-10-28','13:15:00',3.05),('325','2013-10-28','13:20:00',2.96),('325','2013-10-28','13:25:00',2.92),('325','2013-10-28','13:30:00',2.89),('325','2013-10-28','13:35:00',2.87),('325','2013-10-28','13:40:00',2.87),('325','2013-10-28','13:45:00',2.78),('325','2013-10-28','13:50:00',2.75),('325','2013-10-28','13:55:00',2.78),('325','2013-10-28','14:00:00',2.71),('325','2013-10-28','14:05:00',2.82),('325','2013-10-28','14:10:00',2.67),('325','2013-10-28','14:15:00',2.55),('325','2013-10-28','14:20:00',2.56),('325','2013-10-28','14:25:00',2.43),('325','2013-10-28','14:30:00',1.5),('325','2013-10-28','14:35:00',2.08),('325','2013-10-28','14:40:00',1.4),('325','2013-10-28','14:45:00',2.12),('325','2013-10-28','14:50:00',1.92),('325','2013-10-28','14:55:00',1.87),('325','2013-10-28','15:00:00',1.82),('325','2013-10-28','15:05:00',1.66),('325','2013-10-28','15:10:00',1.6),('325','2013-10-28','15:15:00',1.22),('325','2013-10-28','15:40:00',1.28),('325','2013-10-28','15:45:00',1.2),('325','2014-04-16','08:45:00',1.08),('325','2014-04-16','08:50:00',1.32),('325','2014-04-16','08:55:00',1.76),('325','2014-04-16','09:00:00',1.95),('325','2014-04-16','09:05:00',2.07),('325','2014-04-16','09:10:00',2.2),('325','2014-04-16','09:15:00',2.39),('325','2014-04-16','09:20:00',2.48),('325','2014-04-16','09:25:00',2.68),('325','2014-04-16','09:30:00',1.47),('325','2014-04-16','09:35:00',1.05),('325','2014-04-16','09:50:00',1.06),('325','2014-04-16','09:55:00',2.13),('325','2014-04-16','10:00:00',2.31),('325','2014-04-16','10:05:00',3.42),('325','2014-04-16','10:10:00',3.54),('325','2014-04-16','10:15:00',3.67),('325','2014-04-16','10:20:00',3.75),('325','2014-04-16','10:25:00',3.81),('325','2014-04-16','10:30:00',3.89),('325','2014-04-16','10:35:00',3.97),('325','2014-04-16','10:40:00',4.03),('325','2014-04-16','10:45:00',4.08),('325','2014-04-16','10:50:00',4.26),('325','2014-04-16','10:55:00',3.93),('325','2014-04-16','11:00:00',4.13),('325','2014-04-16','11:05:00',2.07),('325','2014-04-16','11:10:00',1.78),('325','2014-04-16','11:15:00',2.04),('325','2014-04-16','11:20:00',4.03),('325','2014-04-16','11:25:00',3.84),('325','2014-04-16','11:30:00',4.35),('325','2014-04-16','11:35:00',3.11),('325','2014-04-16','11:40:00',3.77),('325','2014-04-16','11:45:00',4.65),('325','2014-04-16','11:50:00',5.32),('325','2014-04-16','11:55:00',5.32),('325','2014-04-16','12:00:00',5.27),('325','2014-04-16','12:05:00',4.6),('325','2014-04-16','12:10:00',4.57),('325','2014-04-16','12:15:00',5.35),('325','2014-04-16','12:20:00',2.12),('325','2014-04-16','12:25:00',1.28),('325','2014-04-16','12:30:00',1.85),('325','2014-04-16','12:35:00',5.18),('325','2014-04-16','12:40:00',4.71),('325','2014-04-16','12:45:00',5.04),('325','2014-04-16','12:50:00',4.88),('325','2014-04-16','12:55:00',1.23),('325','2014-04-16','13:00:00',2.94),('325','2014-04-16','13:05:00',1.81),('325','2014-04-16','13:20:00',1.44),('325','2014-04-16','13:25:00',1.18),('325','2014-04-16','13:35:00',1.62),('325','2014-04-16','13:40:00',3.06),('325','2014-04-16','13:45:00',5.79),('325','2014-04-16','13:50:00',5.25),('325','2014-04-16','13:55:00',4.78),('325','2014-04-16','14:00:00',1.92),('325','2014-04-16','14:05:00',4.36),('325','2014-04-16','14:10:00',5.04),('325','2014-04-16','14:15:00',5.55),('325','2014-04-16','14:20:00',4.27),('325','2014-04-16','14:25:00',4.43),('325','2014-04-16','14:30:00',5),('325','2014-04-16','14:35:00',4.77),('325','2014-04-16','14:40:00',4.67),('325','2014-04-16','14:45:00',4.92),('325','2014-04-16','14:50:00',5.05),('325','2014-04-16','14:55:00',1.97),('325','2014-04-16','15:00:00',1.37),('325','2014-04-16','15:05:00',3.43),('325','2014-04-16','15:10:00',5.05),('325','2014-04-16','15:15:00',3.39),('325','2014-04-16','15:25:00',1.2),('325','2014-04-16','15:30:00',2.45),('325','2014-04-16','15:35:00',4.63),('325','2014-04-16','15:40:00',4.43),('325','2014-04-16','15:45:00',4.25),('325','2014-04-16','15:50:00',4.02),('325','2014-04-16','15:55:00',3.98),('325','2014-04-16','16:00:00',3.88),('325','2014-04-16','16:05:00',3.76),('325','2014-04-16','16:10:00',3.67),('325','2014-04-16','16:15:00',3.6),('325','2014-04-16','16:20:00',3.57),('325','2014-04-16','16:25:00',3.45),('325','2014-04-16','16:30:00',3.36),('325','2014-04-16','16:35:00',3.25),('325','2014-04-16','16:40:00',3.18),('325','2014-04-16','16:45:00',3.07),('325','2014-04-16','16:50:00',2.89),('325','2014-04-16','16:55:00',2.82),('325','2014-04-16','17:00:00',2.75),('325','2014-04-16','17:05:00',2.64),('325','2014-04-16','17:10:00',2.54),('325','2014-04-16','17:15:00',2.44),('325','2014-04-16','17:20:00',2.32),('325','2014-04-16','17:25:00',2.19),('325','2014-04-16','17:30:00',2.06),('325','2014-04-16','17:35:00',2),('325','2014-04-16','17:40:00',1.87),('325','2014-04-16','17:45:00',1.79),('325','2014-04-16','17:50:00',1.77),('325','2014-04-16','17:55:00',1.76),('325','2014-04-16','18:00:00',1.58),('325','2014-04-16','18:05:00',1.4),('325','2014-04-16','18:10:00',1.15),('325','2014-04-16','18:20:00',1.15),('325','2013-10-27','09:55:00',1.04),('325','2013-10-27','10:00:00',1.07),('325','2013-10-27','10:05:00',1.09),('325','2013-10-27','10:10:00',1.19),('325','2013-10-27','10:15:00',1.29),('325','2013-10-27','10:20:00',1.36),('325','2013-10-27','10:25:00',1.31),('325','2013-10-27','10:30:00',1.3),('325','2013-10-27','10:35:00',1.33),('325','2013-10-27','10:40:00',1.39),('325','2013-10-27','10:45:00',1.54),('325','2013-10-27','10:50:00',1.46),('325','2013-10-27','10:55:00',1.33),('325','2013-10-27','11:00:00',1.12),('325','2013-10-27','11:30:00',1.19),('325','2013-10-27','11:35:00',1.96),('325','2013-10-27','11:40:00',2.35),('325','2013-10-27','11:45:00',2.7),('325','2013-10-27','11:50:00',1.28),('325','2013-10-27','11:55:00',1.11),('325','2013-10-27','12:00:00',1.26),('325','2013-10-27','12:05:00',1.33),('325','2013-10-27','12:10:00',1.22),('325','2013-10-27','12:15:00',1.81),('325','2013-10-27','12:20:00',2.84),('325','2013-10-27','12:25:00',2.98),('325','2013-10-27','12:30:00',2.81),('325','2013-10-27','12:35:00',3.56),('325','2013-10-27','12:40:00',2.23),('325','2013-10-27','12:45:00',3.24),('325','2013-10-27','12:50:00',3.17),('325','2013-10-27','12:55:00',2.51),('325','2013-10-27','13:00:00',1.11),('325','2013-10-27','13:05:00',1.66),('325','2013-10-27','13:10:00',1.9),('325','2013-10-27','13:15:00',1.05),('325','2013-10-27','13:20:00',1.1),('325','2013-10-27','13:25:00',2.99),('325','2013-10-27','13:30:00',2.89),('325','2013-10-27','13:35:00',2.23),('325','2013-10-27','13:40:00',1.12),('325','2013-10-27','13:55:00',1.01),('325','2013-10-27','14:00:00',1.16),('325','2013-10-27','14:10:00',1.69),('325','2013-10-27','14:15:00',1.58),('325','2013-10-27','14:20:00',1.15),('325','2013-10-27','14:25:00',1.97),('325','2013-10-27','14:30:00',2.13),('325','2013-10-27','14:35:00',1.72),('325','2013-10-27','14:40:00',1.54),('325','2013-10-27','14:45:00',1.09),('325','2013-10-27','14:55:00',1.33),('325','2013-10-27','15:00:00',1.56),('325','2013-10-27','15:05:00',1.48),('325','2013-10-27','15:10:00',1.57),('325','2013-10-27','15:15:00',1.5),('325','2013-10-27','15:20:00',1.41),('325','2013-10-27','15:25:00',1.19),('325','2013-10-26','09:35:00',1.02),('325','2013-10-26','09:40:00',1.07),('325','2013-10-26','09:45:00',1.11),('325','2013-10-26','09:50:00',1.14),('325','2013-10-26','09:55:00',1.19),('325','2013-10-26','10:00:00',1.24),('325','2013-10-26','10:05:00',1.29),('325','2013-10-26','10:10:00',1.32),('325','2013-10-26','10:15:00',1.36),('325','2013-10-26','10:20:00',1.4),('325','2013-10-26','10:25:00',1.44),('325','2013-10-26','10:30:00',1.9),('325','2013-10-26','10:35:00',2.36),('325','2013-10-26','10:40:00',2.46),('325','2013-10-26','10:45:00',2.51),('325','2013-10-26','10:50:00',2.58),('325','2013-10-26','10:55:00',2.65),('325','2013-10-26','11:00:00',2.7),('325','2013-10-26','11:05:00',2.77),('325','2013-10-26','11:10:00',2.82),('325','2013-10-26','11:15:00',2.84),('325','2013-10-26','11:20:00',2.89),('325','2013-10-26','11:25:00',2.94),('325','2013-10-26','11:30:00',2.95),('325','2013-10-26','11:35:00',3.02),('325','2013-10-26','11:40:00',3.04),('325','2013-10-26','11:45:00',3.06),('325','2013-10-26','11:50:00',3.09),('325','2013-10-26','11:55:00',3.12),('325','2013-10-26','12:00:00',3.11),('325','2013-10-26','12:05:00',3.14),('325','2013-10-26','12:10:00',3.17),('325','2013-10-26','12:15:00',3.16),('325','2013-10-26','12:20:00',3.15),('325','2013-10-26','12:25:00',3.14),('325','2013-10-26','12:30:00',3.14),('325','2013-10-26','12:35:00',3.24),('325','2013-10-26','12:40:00',2.98),('325','2013-10-26','12:45:00',3),('325','2013-10-26','12:50:00',3.02),('325','2013-10-26','12:55:00',2.94),('325','2013-10-26','13:00:00',3.21),('325','2013-10-26','13:05:00',3.03),('325','2013-10-26','13:10:00',3),('325','2013-10-26','13:15:00',3.24),('325','2013-10-26','13:20:00',2.97),('325','2013-10-26','13:25:00',3.1),('325','2013-10-26','13:30:00',3.22),('325','2013-10-26','13:35:00',3.26),('325','2013-10-26','13:40:00',3.24),('325','2013-10-26','13:45:00',2.87),('325','2013-10-26','13:50:00',2.97),('325','2013-10-26','13:55:00',2.79),('325','2013-10-26','14:00:00',2.81),('325','2013-10-26','14:05:00',2.79),('325','2013-10-26','14:10:00',2.27),('325','2013-10-26','14:15:00',2.03),('325','2013-10-26','14:20:00',2.02),('325','2013-10-26','14:25:00',2.05),('325','2013-10-26','14:30:00',2.56),('325','2013-10-26','14:35:00',2.37),('325','2013-10-26','14:40:00',2.27),('325','2013-10-26','14:45:00',1.41),('325','2013-10-26','14:50:00',1.84),('325','2013-10-26','14:55:00',2.52),('325','2013-10-26','15:00:00',2.42),('325','2013-10-26','15:05:00',2.32),('325','2013-10-26','15:10:00',2.32),('325','2013-10-26','15:15:00',2.08),('325','2013-10-26','15:20:00',2.01),('325','2013-10-26','15:25:00',2.17),('325','2013-10-26','15:30:00',2.13),('325','2013-10-26','15:35:00',2.04),('325','2013-10-26','15:40:00',1.93),('325','2013-10-26','15:45:00',1.86),('325','2013-10-26','15:50:00',1.65),('325','2013-10-26','15:55:00',1.6),('325','2013-10-26','16:00:00',1.54),('325','2013-10-26','16:05:00',1.49),('325','2013-10-26','16:10:00',1.4),('325','2013-10-26','16:15:00',1.31),('325','2013-10-26','16:20:00',1.27),('325','2013-10-26','16:25:00',1.15),('325','2013-10-26','16:30:00',1.12),('325','2013-10-25','09:35:00',1.01),('325','2013-10-25','09:40:00',1.05),('325','2013-10-25','09:45:00',1.1),('325','2013-10-25','09:50:00',1.15),('325','2013-10-25','09:55:00',1.18),('325','2013-10-25','10:00:00',1.23),('325','2013-10-25','10:05:00',1.27),('325','2013-10-25','10:10:00',1.3),('325','2013-10-25','10:15:00',1.34),('325','2013-10-25','10:20:00',1.38),('325','2013-10-25','10:25:00',1.77),('325','2013-10-25','10:30:00',2.31),('325','2013-10-25','10:35:00',2.45),('325','2013-10-25','10:40:00',2.53),('325','2013-10-25','10:45:00',2.59),('325','2013-10-25','10:50:00',2.63),('325','2013-10-25','10:55:00',2.68),('325','2013-10-25','11:00:00',2.71),('325','2013-10-25','11:05:00',2.8),('325','2013-10-25','11:10:00',2.86),('325','2013-10-25','11:15:00',2.84),('325','2013-10-25','11:20:00',2.88),('325','2013-10-25','11:25:00',2.92),('325','2013-10-25','11:30:00',2.96),('325','2013-10-25','11:35:00',3.07),('325','2013-10-25','11:40:00',3.15),('325','2013-10-25','11:45:00',3.18),('325','2013-10-25','11:50:00',3.2),('325','2013-10-25','11:55:00',3.23),('325','2013-10-25','12:00:00',3.26),('325','2013-10-25','12:05:00',3.29),('325','2013-10-25','12:10:00',3.3),('325','2013-10-25','12:15:00',3.3),('325','2013-10-25','12:20:00',3.31),('325','2013-10-25','12:25:00',3.31),('325','2013-10-25','12:30:00',3.3),('325','2013-10-25','12:35:00',3.31),('325','2013-10-25','12:40:00',3.35),('325','2013-10-25','12:45:00',3.36),('325','2013-10-25','12:50:00',3.35),('325','2013-10-25','12:55:00',3.33),('325','2013-10-25','13:00:00',3.32),('325','2013-10-25','13:05:00',3.31),('325','2013-10-25','13:10:00',3.29),('325','2013-10-25','13:15:00',3.28),('325','2013-10-25','13:20:00',3.27),('325','2013-10-25','13:25:00',3.25),('325','2013-10-25','13:30:00',3.22),('325','2013-10-25','13:35:00',3.19),('325','2013-10-25','13:40:00',3.16),('325','2013-10-25','13:45:00',3.14),('325','2013-10-25','13:50:00',3.12),('325','2013-10-25','13:55:00',3.08),('325','2013-10-25','14:00:00',3.07),('325','2013-10-25','14:05:00',3.03),('325','2013-10-25','14:10:00',2.98),('325','2013-10-25','14:15:00',2.98),('325','2013-10-25','14:20:00',2.96),('325','2013-10-25','14:25:00',2.93),('325','2013-10-25','14:30:00',2.88),('325','2013-10-25','14:35:00',2.78),('325','2013-10-25','14:40:00',2.76),('325','2013-10-25','14:45:00',2.74),('325','2013-10-25','14:50:00',2.72),('325','2013-10-25','14:55:00',2.63),('325','2013-10-25','15:00:00',2.56),('325','2013-10-25','15:05:00',2.51),('325','2013-10-25','15:10:00',2.42),('325','2013-10-25','15:15:00',2.36),('325','2013-10-25','15:20:00',2.34),('325','2013-10-25','15:25:00',2.25),('325','2013-10-25','15:30:00',2.15),('325','2013-10-25','15:35:00',2.07),('325','2013-10-25','15:40:00',2.06),('325','2013-10-25','15:45:00',1.96),('325','2013-10-25','15:50:00',1.89),('325','2013-10-25','15:55:00',1.82),('325','2013-10-25','16:00:00',1.75),('325','2013-10-25','16:05:00',1.66),('325','2013-10-25','16:10:00',1.59),('325','2013-10-25','16:15:00',1.52),('325','2013-10-25','16:20:00',1.45),('325','2013-10-25','16:25:00',1.37),('325','2013-10-25','16:30:00',1.29),('325','2013-10-25','16:35:00',1.2),('325','2013-10-25','16:40:00',1.11),('325','2013-10-25','16:45:00',1.01),('325','2013-10-24','09:05:00',1.02),('325','2013-10-24','09:10:00',1.06),('325','2013-10-24','09:15:00',1.27),('325','2013-10-24','09:35:00',1.01),('325','2013-10-24','09:40:00',1.08),('325','2013-10-24','09:45:00',1.11),('325','2013-10-24','09:50:00',1.11),('325','2013-10-24','09:55:00',1.09),('325','2013-10-24','10:00:00',1.06),('325','2013-10-24','10:05:00',1.01),('325','2013-10-24','10:20:00',1.23),('325','2013-10-24','10:35:00',1.89),('325','2013-10-24','10:40:00',1.12),('325','2013-10-24','10:45:00',2.21),('325','2013-10-24','10:50:00',1.71),('325','2013-10-24','10:55:00',2.07),('325','2013-10-24','11:00:00',3.24),('325','2013-10-24','11:05:00',3.42),('325','2013-10-24','11:10:00',2.26),('325','2013-10-24','11:15:00',1.96),('325','2013-10-24','11:20:00',1.77),('325','2013-10-24','11:25:00',1.62),('325','2013-10-24','11:30:00',1.22),('325','2013-10-24','11:35:00',1.22),('325','2013-10-24','11:40:00',1.16),('325','2013-10-24','11:45:00',1.26),('325','2013-10-24','11:50:00',2.21),('325','2013-10-24','11:55:00',2.9),('325','2013-10-24','12:00:00',1.71),('325','2013-10-24','12:05:00',1.38),('325','2013-10-24','12:10:00',1.32),('325','2013-10-24','12:15:00',1.35),('325','2013-10-24','12:20:00',1.44),('325','2013-10-24','12:25:00',1.59),('325','2013-10-24','12:30:00',1.68),('325','2013-10-24','12:35:00',1.87),('325','2013-10-24','12:40:00',2.25),('325','2013-10-24','12:45:00',2.37),('325','2013-10-24','12:50:00',2.05),('325','2013-10-24','12:55:00',3.07),('325','2013-10-24','13:00:00',3.65),('325','2013-10-24','13:05:00',3.53),('325','2013-10-24','13:10:00',2.74),('325','2013-10-24','13:15:00',2.35),('325','2013-10-24','13:20:00',2.72),('325','2013-10-24','13:25:00',1.89),('325','2013-10-24','13:30:00',1.4),('325','2013-10-24','13:35:00',1.36),('325','2013-10-24','13:40:00',1.41),('325','2013-10-24','13:45:00',1.52),('325','2013-10-24','13:50:00',1.91),('325','2013-10-24','13:55:00',2.67),('325','2013-10-24','14:00:00',2.34),('325','2013-10-24','14:05:00',1.55),('325','2013-10-24','14:10:00',1.47),('325','2013-10-24','14:15:00',1.4),('325','2013-10-24','14:20:00',1.53),('325','2013-10-24','14:25:00',1.57),('325','2013-10-24','14:30:00',1.65),('325','2013-10-24','14:35:00',1.97),('325','2013-10-24','14:40:00',2.35),('325','2013-10-24','14:45:00',2.44),('325','2013-10-24','14:50:00',1.8),('325','2013-10-24','15:00:00',1.06),('325','2013-10-24','15:05:00',1.61),('325','2013-10-24','15:10:00',2.08),('325','2013-10-24','15:15:00',1.21),('325','2013-10-24','15:20:00',1.51),('325','2013-10-24','15:25:00',1.09),('325','2013-10-24','15:30:00',1.59),('325','2013-10-24','15:35:00',2.4),('325','2013-10-24','15:40:00',2.15),('325','2013-10-24','15:45:00',2.15),('325','2013-10-24','15:50:00',1.26),('325','2013-10-23','10:20:00',1.12),('325','2013-10-23','10:25:00',1.2),('325','2013-10-23','10:30:00',1.07),('325','2013-10-23','10:40:00',1.37),('325','2013-10-23','10:45:00',1.28),('325','2013-10-23','10:50:00',1.38),('325','2013-10-23','10:55:00',1.51),('325','2013-10-23','11:00:00',1.54),('325','2013-10-23','11:05:00',1.79),('325','2013-10-23','11:10:00',1.62),('325','2013-10-23','11:15:00',2.05),('325','2013-10-23','11:20:00',2.66),('325','2013-10-23','11:25:00',3.05),('325','2013-10-23','11:30:00',3.03),('325','2013-10-23','11:35:00',2.77),('325','2013-10-23','11:40:00',3.05),('325','2013-10-23','11:45:00',3.05),('325','2013-10-23','11:50:00',3.13),('325','2013-10-23','11:55:00',3.15),('325','2013-10-23','12:00:00',3.14),('325','2013-10-23','12:05:00',2.88),('325','2013-10-23','12:10:00',2.95),('325','2013-10-23','12:15:00',2.81),('325','2013-10-23','12:20:00',3.05),('325','2013-10-23','12:25:00',3.08),('325','2013-10-23','12:30:00',3.12),('325','2013-10-23','12:35:00',3.22),('325','2013-10-23','12:40:00',2.88),('325','2013-10-23','12:45:00',3),('325','2013-10-23','12:50:00',1.97),('325','2013-10-23','12:55:00',2.56),('325','2013-10-23','13:00:00',2.99),('325','2013-10-23','13:05:00',3.09),('325','2013-10-23','13:10:00',3.08),('325','2013-10-23','13:15:00',3.04),('325','2013-10-23','13:20:00',3.12),('325','2013-10-23','13:25:00',3.14),('325','2013-10-23','13:30:00',3.07),('325','2013-10-23','13:35:00',3),('325','2013-10-23','13:40:00',3.02),('325','2013-10-23','13:45:00',2.88),('325','2013-10-23','13:50:00',2.75),('325','2013-10-23','13:55:00',2.64),('325','2013-10-23','14:00:00',2.78),('325','2013-10-23','14:05:00',2.91),('325','2013-10-23','14:10:00',2.78),('325','2013-10-23','14:15:00',2.6),('325','2013-10-23','14:20:00',2.65),('325','2013-10-23','14:25:00',2.6),('325','2013-10-23','14:30:00',2.52),('325','2013-10-23','14:35:00',2.54),('325','2013-10-23','14:40:00',2.59),('325','2013-10-23','14:45:00',2.53),('325','2013-10-23','14:50:00',2.46),('325','2013-10-23','14:55:00',2.54),('325','2013-10-23','15:00:00',2.56),('325','2013-10-23','15:05:00',2.56),('325','2013-10-23','15:10:00',2.45),('325','2013-10-23','15:15:00',2.38),('325','2013-10-23','15:20:00',2.39),('325','2013-10-23','15:25:00',2.33),('325','2013-10-23','15:30:00',2.09),('325','2013-10-23','15:35:00',1.93),('325','2013-10-23','15:40:00',2.18),('325','2013-10-23','15:45:00',2.16),('325','2013-10-23','15:50:00',1.96),('325','2013-10-23','15:55:00',1.57),('325','2013-10-23','16:00:00',1.22),('325','2013-10-23','16:05:00',1.02),('325','2013-10-23','16:15:00',1.05),('325','2013-10-23','16:35:00',1.11),('325','2013-10-23','16:40:00',1.16),('325','2013-10-23','16:45:00',1.01),('325','2013-10-22','09:30:00',1.02),('325','2013-10-22','09:35:00',1.08),('325','2013-10-22','09:40:00',1.12),('325','2013-10-22','09:45:00',1.17),('325','2013-10-22','09:50:00',1.22),('325','2013-10-22','09:55:00',1.26),('325','2013-10-22','10:00:00',1.31),('325','2013-10-22','10:05:00',1.36),('325','2013-10-22','10:10:00',1.4),('325','2013-10-22','10:15:00',1.44),('325','2013-10-22','10:20:00',1.48),('325','2013-10-22','10:25:00',1.97),('325','2013-10-22','10:30:00',2.28),('325','2013-10-22','10:35:00',2.4),('325','2013-10-22','10:40:00',2.49),('325','2013-10-22','10:45:00',2.52),('325','2013-10-22','10:50:00',2.56),('325','2013-10-22','10:55:00',2.62),('325','2013-10-22','11:00:00',2.71),('325','2013-10-22','11:05:00',2.76),('325','2013-10-22','11:10:00',2.78),('325','2013-10-22','11:15:00',2.77),('325','2013-10-22','11:20:00',2.8),('325','2013-10-22','11:25:00',2.85),('325','2013-10-22','11:30:00',2.88),('325','2013-10-22','11:35:00',2.9),('325','2013-10-22','11:40:00',2.96),('325','2013-10-22','11:45:00',2.94),('325','2013-10-22','11:50:00',3),('325','2013-10-22','11:55:00',3.07),('325','2013-10-22','12:00:00',3.05),('325','2013-10-22','12:05:00',3.04),('325','2013-10-22','12:10:00',3.1),('325','2013-10-22','12:15:00',3.06),('325','2013-10-22','12:20:00',3.02),('325','2013-10-22','12:25:00',3.1),('325','2013-10-22','12:30:00',3.15),('325','2013-10-22','12:35:00',3.15),('325','2013-10-22','12:40:00',3.13),('325','2013-10-22','12:45:00',3.14),('325','2013-10-22','12:50:00',3.15),('325','2013-10-22','12:55:00',3.06),('325','2013-10-22','13:00:00',3.1),('325','2013-10-22','13:05:00',3.07),('325','2013-10-22','13:10:00',3.06),('325','2013-10-22','13:15:00',3.18),('325','2013-10-22','13:20:00',3.17),('325','2013-10-22','13:25:00',3.17),('325','2013-10-22','13:30:00',3),('325','2013-10-22','13:35:00',3),('325','2013-10-22','13:40:00',2.78),('325','2013-10-22','13:45:00',2.93),('325','2013-10-22','13:50:00',2.99),('325','2013-10-22','13:55:00',2.65),('325','2013-10-22','14:00:00',2.9),('325','2013-10-22','14:05:00',3.06),('325','2013-10-22','14:10:00',2.99),('325','2013-10-22','14:15:00',3.09),('325','2013-10-22','14:20:00',3.16),('325','2013-10-22','14:25:00',3.19),('325','2013-10-22','14:30:00',2.99),('325','2013-10-22','14:35:00',2.77),('325','2013-10-22','14:40:00',2.71),('325','2013-10-22','14:45:00',2.65),('325','2013-10-22','14:50:00',2.61),('325','2013-10-22','14:55:00',2.53),('325','2013-10-22','15:00:00',2.44),('325','2013-10-22','15:05:00',2.38),('325','2013-10-22','15:10:00',2.35),('325','2013-10-22','15:15:00',2.29),('325','2013-10-22','15:20:00',2.24),('325','2013-10-22','15:25:00',2.13),('325','2013-10-22','15:30:00',2.11),('325','2013-10-22','15:35:00',2.11),('325','2013-10-22','15:40:00',1.97),('325','2013-10-22','15:45:00',1.87),('325','2013-10-22','15:50:00',1.83),('325','2013-10-22','15:55:00',1.7),('325','2013-10-22','16:00:00',1.63),('325','2013-10-22','16:05:00',1.57),('325','2013-10-22','16:10:00',1.32),('325','2013-10-22','16:15:00',1.39),('325','2013-10-22','16:20:00',1.29),('325','2013-10-22','16:25:00',1.29),('325','2013-10-22','16:30:00',1.22),('325','2013-10-22','16:35:00',1.15),('325','2013-10-22','16:40:00',1.07),('325','2013-10-21','09:20:00',1.04),('325','2013-10-21','09:25:00',1.06),('325','2013-10-21','09:40:00',1.12),('325','2013-10-21','09:45:00',1.07),('325','2013-10-21','09:50:00',1.16),('325','2013-10-21','09:55:00',1.28),('325','2013-10-21','10:00:00',1.24),('325','2013-10-21','10:05:00',1.47),('325','2013-10-21','10:10:00',1.48),('325','2013-10-21','10:15:00',1.54),('325','2013-10-21','10:20:00',1.54),('325','2013-10-21','10:25:00',1.62),('325','2013-10-21','10:30:00',2.2),('325','2013-10-21','10:35:00',2.41),('325','2013-10-21','10:40:00',2.39),('325','2013-10-21','10:45:00',2.45),('325','2013-10-21','10:50:00',2.62),('325','2013-10-21','10:55:00',2.6),('325','2013-10-21','11:00:00',2.86),('325','2013-10-21','11:05:00',2.41),('325','2013-10-21','11:10:00',2.71),('325','2013-10-21','11:15:00',3),('325','2013-10-21','11:20:00',2.93),('325','2013-10-21','11:25:00',2.96),('325','2013-10-21','11:30:00',3.09),('325','2013-10-21','11:35:00',3.05),('325','2013-10-21','11:40:00',3.07),('325','2013-10-21','11:45:00',3.18),('325','2013-10-21','11:50:00',3.21),('325','2013-10-21','11:55:00',3.24),('325','2013-10-21','12:00:00',3.32),('325','2013-10-21','12:05:00',3.36),('325','2013-10-21','12:10:00',3.36),('325','2013-10-21','12:15:00',3.31),('325','2013-10-21','12:20:00',3.3),('325','2013-10-21','12:25:00',3.28),('325','2013-10-21','12:30:00',3.19),('325','2013-10-21','12:35:00',3.35),('325','2013-10-21','12:40:00',3.38),('325','2013-10-21','12:45:00',3.37),('325','2013-10-21','12:50:00',3.36),('325','2013-10-21','12:55:00',3.35),('325','2013-10-21','13:00:00',3.29),('325','2013-10-21','13:05:00',3.23),('325','2013-10-21','13:10:00',3.2),('325','2013-10-21','13:15:00',3.23),('325','2013-10-21','13:20:00',3.17),('325','2013-10-21','13:25:00',3.28),('325','2013-10-21','13:30:00',3.31),('325','2013-10-21','13:35:00',3.27),('325','2013-10-21','13:40:00',3.23),('325','2013-10-21','13:45:00',3.2),('325','2013-10-21','13:50:00',3.08),('325','2013-10-21','13:55:00',3.05),('325','2013-10-21','14:00:00',3.05),('325','2013-10-21','14:05:00',3.06),('325','2013-10-21','14:10:00',3.01),('325','2013-10-21','14:15:00',2.97),('325','2013-10-21','14:20:00',2.96),('325','2013-10-21','14:25:00',2.86),('325','2013-10-21','14:30:00',2.9),('325','2013-10-21','14:35:00',2.82),('325','2013-10-21','14:40:00',2.66),('325','2013-10-21','14:45:00',2.65),('325','2013-10-21','14:50:00',2.55),('325','2013-10-21','14:55:00',2.57),('325','2013-10-21','15:00:00',2.55),('325','2013-10-21','15:05:00',2.51),('325','2013-10-21','15:10:00',2.47),('325','2013-10-21','15:15:00',2.41),('325','2013-10-21','15:20:00',2.36),('325','2013-10-21','15:25:00',2.31),('325','2013-10-21','15:30:00',2.17),('325','2013-10-21','15:35:00',2.13),('325','2013-10-21','15:40:00',2.11),('325','2013-10-21','15:45:00',2.02),('325','2013-10-21','15:50:00',1.93),('325','2013-10-21','15:55:00',1.89),('325','2013-10-21','16:00:00',1.83),('325','2013-10-21','16:05:00',1.73),('325','2013-10-21','16:10:00',1.65),('325','2013-10-21','16:15:00',1.55),('325','2013-10-21','16:20:00',1.47),('325','2013-10-21','16:25:00',1.38),('325','2013-10-21','16:30:00',1.31),('325','2013-10-21','16:35:00',1.22),('325','2013-10-21','16:40:00',1.14),('325','2013-10-21','16:45:00',1.05),('325','2013-10-20','09:30:00',1.07),('325','2013-10-20','09:35:00',1.11),('325','2013-10-20','09:40:00',1.16),('325','2013-10-20','09:45:00',1.2),('325','2013-10-20','09:50:00',1.23),('325','2013-10-20','09:55:00',1.28),('325','2013-10-20','10:00:00',1.33),('325','2013-10-20','10:05:00',1.37),('325','2013-10-20','10:10:00',1.41),('325','2013-10-20','10:15:00',1.45),('325','2013-10-20','10:20:00',1.49),('325','2013-10-20','10:25:00',2.27),('325','2013-10-20','10:30:00',2.47),('325','2013-10-20','10:35:00',2.59),('325','2013-10-20','10:40:00',2.66),('325','2013-10-20','10:45:00',2.71),('325','2013-10-20','10:50:00',2.77),('325','2013-10-20','10:55:00',2.83),('325','2013-10-20','11:00:00',2.91),('325','2013-10-20','11:05:00',2.96),('325','2013-10-20','11:10:00',2.99),('325','2013-10-20','11:15:00',3.03),('325','2013-10-20','11:20:00',3.07),('325','2013-10-20','11:25:00',3.12),('325','2013-10-20','11:30:00',3.16),('325','2013-10-20','11:35:00',3.22),('325','2013-10-20','11:40:00',3.28),('325','2013-10-20','11:45:00',3.29),('325','2013-10-20','11:50:00',3.28),('325','2013-10-20','11:55:00',3.29),('325','2013-10-20','12:00:00',3.27),('325','2013-10-20','12:05:00',3.38),('325','2013-10-20','12:10:00',3.41),('325','2013-10-20','12:15:00',2.78),('325','2013-10-20','12:20:00',2.75),('325','2013-10-20','12:25:00',2.97),('325','2013-10-20','12:30:00',3.68),('325','2013-10-20','12:35:00',2.53),('325','2013-10-20','12:40:00',1.31),('325','2013-10-20','12:45:00',1.92),('325','2013-10-20','12:50:00',2.01),('325','2013-10-20','12:55:00',2.22),('325','2013-10-20','13:00:00',3.81),('325','2013-10-20','13:05:00',2.85),('325','2013-10-20','13:10:00',1.82),('325','2013-10-20','13:15:00',1.24),('325','2013-10-20','13:20:00',2.36),('325','2013-10-20','13:25:00',1.69),('325','2013-10-20','13:30:00',1.07),('325','2013-10-20','13:35:00',1.2),('325','2013-10-20','13:40:00',2.38),('325','2013-10-20','13:45:00',1.41),('325','2013-10-20','13:50:00',1.17),('325','2013-10-20','13:55:00',1.3),('325','2013-10-20','14:10:00',1.02),('325','2013-10-20','16:30:00',1.01),('325','2013-10-20','16:35:00',1.17),('325','2013-10-20','16:40:00',1.46),('325','2013-10-20','16:45:00',1.15),('325','2013-10-20','16:50:00',1.44),('325','2013-10-20','16:55:00',1.4),('325','2013-10-20','17:00:00',1.24),('325','2013-10-20','17:05:00',1.08),('325','2013-10-19','09:15:00',1.13),('325','2013-10-19','09:20:00',1.15),('325','2013-10-19','09:25:00',1.17),('325','2013-10-19','09:30:00',1.19),('325','2013-10-19','09:35:00',1.24),('325','2013-10-19','09:40:00',1.3),('325','2013-10-19','09:45:00',1.35),('325','2013-10-19','09:50:00',1.4),('325','2013-10-19','09:55:00',1.47),('325','2013-10-19','10:00:00',1.46),('325','2013-10-19','10:05:00',1.45),('325','2013-10-19','10:10:00',1.54),('325','2013-10-19','10:15:00',1.51),('325','2013-10-19','10:20:00',1.73),('325','2013-10-19','10:25:00',2.63),('325','2013-10-19','10:30:00',2.78),('325','2013-10-19','10:35:00',2.88),('325','2013-10-19','10:40:00',2.94),('325','2013-10-19','10:45:00',2.92),('325','2013-10-19','10:50:00',3.03),('325','2013-10-19','10:55:00',3.17),('325','2013-10-19','11:00:00',2.96),('325','2013-10-19','11:05:00',2.96),('325','2013-10-19','11:10:00',1.18),('325','2013-10-19','11:15:00',1.43),('325','2013-10-19','11:20:00',3),('325','2013-10-19','11:25:00',3.55),('325','2013-10-19','11:30:00',3.59),('325','2013-10-19','11:35:00',3.52),('325','2013-10-19','11:40:00',3.41),('325','2013-10-19','11:45:00',3.6),('325','2013-10-19','11:50:00',3.21),('325','2013-10-19','11:55:00',3.58),('325','2013-10-19','12:00:00',3.66),('325','2013-10-19','12:05:00',3.67),('325','2013-10-19','12:10:00',3.62),('325','2013-10-19','12:15:00',3.64),('325','2013-10-19','12:20:00',3.56),('325','2013-10-19','12:25:00',3.32),('325','2013-10-19','12:30:00',3.61),('325','2013-10-19','12:35:00',3.7),('325','2013-10-19','12:40:00',3.79),('325','2013-10-19','12:45:00',3.88),('325','2013-10-19','12:50:00',3.86),('325','2013-10-19','12:55:00',4.01),('325','2013-10-19','13:00:00',4.04),('325','2013-10-19','13:05:00',3.3),('325','2013-10-19','13:10:00',3.71),('325','2013-10-19','13:15:00',3.47),('325','2013-10-19','13:20:00',3.49),('325','2013-10-19','13:25:00',3.67),('325','2013-10-19','13:30:00',3.99),('325','2013-10-19','13:35:00',2.71),('325','2013-10-19','13:40:00',2.48),('325','2013-10-19','13:45:00',2.58),('325','2013-10-19','13:50:00',3.33),('325','2013-10-19','13:55:00',3.89),('325','2013-10-19','14:00:00',3.25),('325','2013-10-19','14:05:00',2.63),('325','2013-10-19','14:10:00',2.25),('325','2013-10-19','14:15:00',2.87),('325','2013-10-19','14:20:00',2.06),('325','2013-10-19','14:25:00',2),('325','2013-10-19','14:30:00',2.96),('325','2013-10-19','14:35:00',3.27),('325','2013-10-19','14:40:00',2.89),('325','2013-10-19','14:45:00',2.49),('325','2013-10-19','14:50:00',3.33),('325','2013-10-19','14:55:00',3.17),('325','2013-10-19','15:00:00',3.06),('325','2013-10-19','15:05:00',2.97),('325','2013-10-19','15:10:00',2.92),('325','2013-10-19','15:15:00',2.84),('325','2013-10-19','15:20:00',2.65),('325','2013-10-19','15:25:00',2.54),('325','2013-10-19','15:30:00',2.41),('325','2013-10-19','15:35:00',2.43),('325','2013-10-19','15:40:00',2.21),('325','2013-10-19','15:45:00',1.87),('325','2013-10-19','15:50:00',2.16),('325','2013-10-19','15:55:00',2.24),('325','2013-10-19','16:00:00',1.81),('325','2013-10-19','16:05:00',1.97),('325','2013-10-19','16:10:00',1.82),('325','2013-10-19','16:15:00',2),('325','2013-10-19','16:20:00',1.67),('325','2013-10-19','16:25:00',1.36),('325','2013-10-19','16:30:00',1.74),('325','2013-10-19','16:35:00',1.68),('325','2013-10-19','16:40:00',1.61),('325','2013-10-19','16:45:00',1.45),('325','2013-10-19','16:50:00',1.31),('325','2013-10-18','09:20:00',1.01),('325','2013-10-18','09:25:00',1.05),('325','2013-10-18','09:30:00',1.1),('325','2013-10-18','09:35:00',1.15),('325','2013-10-18','09:40:00',1.2),('325','2013-10-18','09:45:00',1.24),('325','2013-10-18','09:50:00',1.29),('325','2013-10-18','09:55:00',1.33),('325','2013-10-18','10:00:00',1.37),('325','2013-10-18','10:05:00',1.42),('325','2013-10-18','10:10:00',1.46),('325','2013-10-18','10:15:00',1.51),('325','2013-10-18','10:20:00',1.7),('325','2013-10-18','10:25:00',2.59),('325','2013-10-18','10:30:00',2.76),('325','2013-10-18','10:35:00',2.87),('325','2013-10-18','10:40:00',2.93),('325','2013-10-18','10:45:00',2.95),('325','2013-10-18','10:50:00',3.03),('325','2013-10-18','10:55:00',3.07),('325','2013-10-18','11:00:00',3.11),('325','2013-10-18','11:05:00',2.99),('325','2013-10-18','11:10:00',3.09),('325','2013-10-18','11:15:00',3.14),('325','2013-10-18','11:20:00',3.35),('325','2013-10-18','11:25:00',3.33),('325','2013-10-18','11:30:00',3.31),('325','2013-10-18','11:35:00',3.42),('325','2013-10-18','11:40:00',3.55),('325','2013-10-18','11:45:00',3.44),('325','2013-10-18','11:50:00',3.4),('325','2013-10-18','11:55:00',3.59),('325','2013-10-18','12:00:00',3.54),('325','2013-10-18','12:05:00',3.55),('325','2013-10-18','12:10:00',3.58),('325','2013-10-18','12:15:00',3.54),('325','2013-10-18','12:20:00',3.5),('325','2013-10-18','12:25:00',3.55),('325','2013-10-18','12:30:00',3.59),('325','2013-10-18','12:35:00',3.54),('325','2013-10-18','12:40:00',3.57),('325','2013-10-18','12:45:00',3.5),('325','2013-10-18','12:50:00',3.49),('325','2013-10-18','12:55:00',3.52),('325','2013-10-18','13:00:00',3.53),('325','2013-10-18','13:05:00',3.48),('325','2013-10-18','13:10:00',3.33),('325','2013-10-18','13:15:00',3.43),('325','2013-10-18','13:20:00',3.53),('325','2013-10-18','13:25:00',3.55),('325','2013-10-18','13:30:00',3.58),('325','2013-10-18','13:35:00',3.53),('325','2013-10-18','13:40:00',3.49),('325','2013-10-18','13:45:00',3.41),('325','2013-10-18','13:50:00',3.4),('325','2013-10-18','13:55:00',3.37),('325','2013-10-18','14:00:00',3.2),('325','2013-10-18','14:05:00',3.17),('325','2013-10-18','14:10:00',3.14),('325','2013-10-18','14:15:00',3.21),('325','2013-10-18','14:20:00',3.18),('325','2013-10-18','14:25:00',3.18),('325','2013-10-18','14:30:00',3.15),('325','2013-10-18','14:35:00',3.01),('325','2013-10-18','14:40:00',3.02),('325','2013-10-18','14:45:00',2.92),('325','2013-10-18','14:50:00',2.86),('325','2013-10-18','14:55:00',2.9),('325','2013-10-18','15:00:00',2.45),('325','2013-10-18','15:05:00',2.31),('325','2013-10-18','15:10:00',2.55),('325','2013-10-18','15:15:00',2.55),('325','2013-10-18','15:20:00',2.63),('325','2013-10-18','15:25:00',2.48),('325','2013-10-18','15:30:00',2.38),('325','2013-10-18','15:35:00',2.37),('325','2013-10-18','15:40:00',2.24),('325','2013-10-18','15:45:00',2.06),('325','2013-10-18','15:50:00',1.97),('325','2013-10-18','15:55:00',1.81),('325','2013-10-18','16:00:00',1.94),('325','2013-10-18','16:05:00',1.79),('325','2013-10-18','16:10:00',1.71),('325','2013-10-18','16:15:00',1.55),('325','2013-10-18','16:20:00',1.49),('325','2013-10-18','16:25:00',1.28),('325','2013-10-18','16:30:00',1.17),('325','2013-10-18','16:35:00',1.11),('325','2014-05-03','08:10:00',1.23),('325','2014-05-03','08:15:00',1.28),('325','2014-05-03','08:25:00',1.03),('325','2014-05-03','08:30:00',1.24),('325','2014-05-03','08:45:00',1.04),('325','2014-05-03','08:50:00',1.69),('325','2014-05-03','08:55:00',1.73),('325','2014-05-03','09:00:00',1.58),('325','2014-05-03','09:05:00',1.77),('325','2014-05-03','09:10:00',1.07),('325','2014-05-03','09:15:00',1.7),('325','2014-05-03','09:20:00',2.65),('325','2014-05-03','09:25:00',1.72),('325','2014-05-03','09:30:00',1.53),('325','2014-05-03','09:35:00',3.03),('325','2014-05-03','09:40:00',2.5),('325','2014-05-03','09:45:00',3.67),('325','2014-05-03','09:50:00',2.62),('325','2014-05-03','09:55:00',3.67),('325','2014-05-03','10:00:00',3.68),('325','2014-05-03','10:05:00',3.69),('325','2014-05-03','10:10:00',3.6),('325','2014-05-03','10:15:00',4.37),('325','2014-05-03','10:20:00',1.45),('325','2014-05-03','10:25:00',1.31),('325','2014-05-03','10:30:00',1.84),('325','2014-05-03','10:35:00',1.76),('325','2014-05-03','10:40:00',1.71),('325','2014-05-03','10:45:00',1.21),('325','2014-05-03','10:50:00',1.14),('325','2014-05-03','10:55:00',1.86),('325','2014-05-03','11:00:00',2.03),('325','2014-05-03','11:05:00',5.02),('325','2014-05-03','11:10:00',5.82),('325','2014-05-03','11:15:00',5.15),('325','2014-05-03','11:20:00',5.08),('325','2014-05-03','11:25:00',4.14),('325','2014-05-03','11:30:00',5.1),('325','2014-05-03','11:35:00',3.07),('325','2014-05-03','11:40:00',3.33),('325','2014-05-03','11:45:00',2.99),('325','2014-05-03','11:50:00',2.52),('325','2014-05-03','11:55:00',2.66),('325','2014-05-03','12:00:00',1.86),('325','2014-05-03','12:05:00',1.36),('325','2014-05-03','12:10:00',1.19),('325','2014-05-03','12:15:00',1.13),('325','2014-05-03','12:20:00',1.1),('325','2014-05-03','12:25:00',1.2),('325','2014-05-03','12:30:00',1.7),('325','2014-05-03','12:35:00',2.27),('325','2014-05-03','12:40:00',2.22),('325','2014-05-03','12:45:00',2.1),('325','2014-05-03','12:50:00',1.71),('325','2014-05-03','12:55:00',1.69),('325','2014-05-03','13:00:00',1.99),('325','2014-05-03','13:05:00',2.63),('325','2014-05-03','13:10:00',2.94),('325','2014-05-03','13:15:00',3.13),('325','2014-05-03','13:20:00',2.78),('325','2014-05-03','13:25:00',2.8),('325','2014-05-03','13:30:00',3.52),('325','2014-05-03','13:35:00',3.64),('325','2014-05-03','13:40:00',2.4),('325','2014-05-03','13:45:00',1.96),('325','2014-05-03','13:50:00',1.92),('325','2014-05-03','13:55:00',1.93),('325','2014-05-03','14:00:00',1.91),('325','2014-05-03','14:05:00',1.98),('325','2014-05-03','14:10:00',2.21),('325','2014-05-03','14:15:00',2.79),('325','2014-05-03','14:20:00',3.06),('325','2014-05-03','14:25:00',3.69),('325','2014-05-03','14:30:00',2.06),('325','2014-05-03','14:35:00',1.46),('325','2014-05-03','14:40:00',1.02),('325','2014-05-03','14:55:00',3.3),('325','2014-05-03','15:00:00',2.74),('325','2014-05-03','15:05:00',1.38),('325','2014-05-03','15:10:00',1.09),('325','2014-05-03','17:05:00',1),('325','2014-05-03','17:10:00',1.01),('325','2014-05-03','17:15:00',1),('325','2014-05-03','17:50:00',1.12),('325','2014-05-03','17:55:00',1.18),('325','2014-04-15','09:00:00',1.24),('325','2014-04-15','09:05:00',1.5),('325','2014-04-15','09:10:00',1.85),('325','2014-04-15','09:15:00',2.14),('325','2014-04-15','09:20:00',2.38),('325','2014-04-15','09:25:00',2.79),('325','2014-04-15','09:30:00',1.85),('325','2014-04-15','09:45:00',1.21),('325','2014-04-15','09:50:00',1.79),('325','2014-04-15','09:55:00',1.05),('325','2014-04-15','10:00:00',1.45),('325','2014-04-15','10:05:00',1.72),('325','2014-04-15','10:10:00',2.38),('325','2014-04-15','10:15:00',1.84),('325','2014-04-15','10:20:00',2.03),('325','2014-04-15','10:25:00',2.53),('325','2014-04-15','10:30:00',3.86),('325','2014-04-15','10:35:00',2.16),('325','2014-04-15','10:40:00',2.8),('325','2014-04-15','10:45:00',2.92),('325','2014-04-15','10:50:00',2.48),('325','2014-04-15','10:55:00',1.86),('325','2014-04-15','11:00:00',2.18),('325','2014-04-15','11:05:00',3.03),('325','2014-04-15','11:10:00',1.82),('325','2014-04-15','11:15:00',1.62),('325','2014-04-15','11:20:00',1.21),('325','2014-04-15','11:25:00',1.8),('325','2014-04-15','11:30:00',1.22),('325','2014-04-15','11:45:00',1.28),('325','2014-04-15','11:50:00',1.41),('325','2014-04-15','12:15:00',1.77),('325','2014-04-15','12:20:00',2),('325','2014-04-15','13:05:00',1.15),('325','2014-04-15','13:10:00',1.32),('325','2014-04-15','13:15:00',2.73),('325','2014-04-15','13:20:00',2.73),('325','2014-04-15','13:25:00',2.18),('325','2014-04-15','13:30:00',2.65),('325','2014-04-15','13:35:00',2.73),('325','2014-04-15','13:40:00',1.5),('325','2014-04-15','14:00:00',3.57),('325','2014-04-15','14:05:00',1.54),('325','2014-04-15','14:10:00',2.37),('325','2014-04-15','14:15:00',4.44),('325','2014-04-15','14:20:00',3.87),('325','2014-04-15','14:25:00',3.1),('325','2014-04-15','14:30:00',1.83),('325','2014-04-15','14:35:00',1.64),('325','2014-04-15','14:40:00',3.85),('325','2014-04-15','14:45:00',2.51),('325','2014-04-15','14:50:00',2.9),('325','2014-04-15','14:55:00',1.89),('325','2014-04-15','15:05:00',1.23),('325','2014-04-15','15:10:00',1.21),('325','2014-04-15','15:15:00',2.59),('325','2014-04-15','15:20:00',2.03),('325','2014-04-15','15:25:00',2.21),('325','2014-04-15','15:30:00',1.65),('325','2014-04-15','15:35:00',1.5),('325','2014-04-15','15:40:00',1.52),('325','2014-04-15','15:45:00',1.44),('325','2014-04-15','15:50:00',1.44),('325','2014-04-15','15:55:00',1.54),('325','2014-04-15','16:00:00',1.69),('325','2014-04-15','16:05:00',1.71),('325','2013-10-17','09:20:00',1.02),('325','2013-10-17','09:25:00',1.07),('325','2013-10-17','09:30:00',1.12),('325','2013-10-17','09:35:00',1.16),('325','2013-10-17','09:40:00',1.2),('325','2013-10-17','09:45:00',1.25),('325','2013-10-17','09:50:00',1.29),('325','2013-10-17','09:55:00',1.33),('325','2013-10-17','10:00:00',1.36),('325','2013-10-17','10:05:00',1.4),('325','2013-10-17','10:10:00',1.45),('325','2013-10-17','10:15:00',1.49),('325','2013-10-17','10:20:00',2.5),('325','2013-10-17','10:25:00',2.63),('325','2013-10-17','10:30:00',2.75),('325','2013-10-17','10:35:00',2.86),('325','2013-10-17','10:40:00',2.93),('325','2013-10-17','10:45:00',3.01),('325','2013-10-17','10:50:00',3.1),('325','2013-10-17','10:55:00',3.16),('325','2013-10-17','11:00:00',3.23),('325','2013-10-17','11:05:00',3.28),('325','2013-10-17','11:10:00',3.33),('325','2013-10-17','11:15:00',3.37),('325','2013-10-17','11:20:00',3.4),('325','2013-10-17','11:25:00',3.43),('325','2013-10-17','11:30:00',3.48),('325','2013-10-17','11:35:00',3.52),('325','2013-10-17','11:40:00',3.6),('325','2013-10-17','11:45:00',3.59),('325','2013-10-17','11:50:00',3.59),('325','2013-10-17','11:55:00',3.62),('325','2013-10-17','12:00:00',3.63),('325','2013-10-17','12:05:00',3.66),('325','2013-10-17','12:10:00',3.66),('325','2013-10-17','12:15:00',3.67),('325','2013-10-17','12:20:00',3.7),('325','2013-10-17','12:25:00',3.71),('325','2013-10-17','12:30:00',3.72),('325','2013-10-17','12:35:00',3.75),('325','2013-10-17','12:40:00',3.77),('325','2013-10-17','12:45:00',3.78),('325','2013-10-17','12:50:00',3.77),('325','2013-10-17','12:55:00',3.75),('325','2013-10-17','13:00:00',3.75),('325','2013-10-17','13:05:00',3.73),('325','2013-10-17','13:10:00',3.72),('325','2013-10-17','13:15:00',3.69),('325','2013-10-17','13:20:00',3.67),('325','2013-10-17','13:25:00',3.65),('325','2013-10-17','13:30:00',3.64),('325','2013-10-17','13:35:00',3.64),('325','2013-10-17','13:40:00',3.62),('325','2013-10-17','13:45:00',3.61),('325','2013-10-17','13:50:00',3.59),('325','2013-10-17','13:55:00',3.55),('325','2013-10-17','14:00:00',3.53),('325','2013-10-17','14:05:00',3.49),('325','2013-10-17','14:10:00',3.48),('325','2013-10-17','14:15:00',3.47),('325','2013-10-17','14:20:00',3.42),('325','2013-10-17','14:25:00',3.36),('325','2013-10-17','14:30:00',3.31),('325','2013-10-17','14:35:00',3.27),('325','2013-10-17','14:40:00',3.23),('325','2013-10-17','14:45:00',3.19),('325','2013-10-17','14:50:00',3.12),('325','2013-10-17','14:55:00',3.04),('325','2013-10-17','15:00:00',2.99),('325','2013-10-17','15:05:00',2.96),('325','2013-10-17','15:10:00',2.91),('325','2013-10-17','15:15:00',2.85),('325','2013-10-17','15:20:00',2.78),('325','2013-10-17','15:25:00',2.71),('325','2013-10-17','15:30:00',2.64),('325','2013-10-17','15:35:00',2.57),('325','2013-10-17','15:40:00',2.51),('325','2013-10-17','15:45:00',2.42),('325','2013-10-17','15:50:00',2.33),('325','2013-10-17','15:55:00',2.25),('325','2013-10-17','16:00:00',2.16),('325','2013-10-17','16:05:00',2.09),('325','2013-10-17','16:10:00',1.99),('325','2013-10-17','16:15:00',1.9),('325','2013-10-17','16:20:00',1.83),('325','2013-10-17','16:25:00',1.74),('325','2013-10-17','16:30:00',1.65),('325','2013-10-17','16:35:00',1.56),('325','2013-10-17','16:40:00',1.47),('325','2013-10-17','16:45:00',1.35),('325','2013-10-17','16:50:00',1.26),('325','2013-10-17','16:55:00',1.17),('325','2013-10-17','17:00:00',1.08),('325','2013-10-16','09:45:00',1.53),('325','2013-10-16','09:50:00',1.22),('325','2013-10-16','11:15:00',1.3),('325','2013-10-16','11:55:00',1.21),('325','2013-10-16','12:10:00',1.71),('325','2013-10-16','12:15:00',3.56),('325','2013-10-16','12:20:00',1.71),('325','2013-10-16','12:30:00',1.53),('325','2013-10-16','12:35:00',1.4),('325','2013-10-16','12:40:00',4.27),('325','2013-10-16','12:45:00',2.82),('325','2013-10-16','12:50:00',3.56),('325','2013-10-16','12:55:00',1.94),('325','2013-10-16','13:00:00',2.54),('325','2013-10-16','13:05:00',3.85),('325','2013-10-16','13:10:00',2.5),('325','2013-10-16','13:15:00',3.8),('325','2013-10-16','13:20:00',4.08),('325','2013-10-16','13:25:00',3.99),('325','2013-10-16','13:30:00',3.8),('325','2013-10-16','13:35:00',3.69),('325','2013-10-16','13:40:00',3.72),('325','2013-10-16','13:45:00',3.68),('325','2013-10-16','13:50:00',3.38),('325','2013-10-16','13:55:00',3.86),('325','2013-10-16','14:00:00',2.97),('325','2013-10-16','14:05:00',2.49),('325','2013-10-16','14:10:00',3.84),('325','2013-10-16','14:15:00',3.1),('325','2013-10-16','14:20:00',3.31),('325','2013-10-16','14:25:00',3.86),('325','2013-10-16','14:30:00',3.48),('325','2013-10-16','14:35:00',2.82),('325','2013-10-16','14:40:00',3.35),('325','2013-10-16','14:45:00',2.39),('325','2013-10-16','14:50:00',3.09),('325','2013-10-16','14:55:00',2.88),('325','2013-10-16','15:00:00',3.07),('325','2013-10-16','15:05:00',2.04),('325','2013-10-16','15:10:00',2.63),('325','2013-10-16','15:15:00',2.6),('325','2013-10-16','15:20:00',2.28),('325','2013-10-16','15:25:00',1.69),('325','2013-10-16','15:35:00',1.87),('325','2013-10-16','15:40:00',2.62),('325','2013-10-16','15:45:00',2.44),('325','2013-10-16','15:50:00',2.35),('325','2013-10-16','15:55:00',2.29),('325','2013-10-16','16:00:00',2.2),('325','2013-10-16','16:05:00',2.12),('325','2013-10-16','16:10:00',1.93),('325','2013-10-16','16:15:00',1.89),('325','2013-10-16','16:20:00',1.81),('325','2013-10-16','16:25:00',1.71),('325','2013-10-16','16:30:00',1.61),('325','2013-10-16','16:35:00',1.32),('325','2013-10-16','16:40:00',1.47),('325','2013-10-16','16:45:00',1.36),('325','2013-10-16','16:50:00',1.26),('325','2013-10-16','16:55:00',1.17),('325','2013-10-16','17:00:00',1.07),('325','2013-10-15','09:30:00',1.12),('325','2013-10-15','09:40:00',1.03),('325','2013-10-15','09:45:00',1.34),('325','2013-10-15','09:50:00',1.47),('325','2013-10-15','09:55:00',1.58),('325','2013-10-15','10:00:00',1.62),('325','2013-10-15','10:05:00',1.8),('325','2013-10-15','10:10:00',1.45),('325','2013-10-15','10:15:00',1.03),('325','2013-10-15','10:20:00',1.03),('325','2013-10-15','10:25:00',1.32),('325','2013-10-15','10:30:00',1.56),('325','2013-10-15','10:35:00',1.42),('325','2013-10-15','10:40:00',1.7),('325','2013-10-15','10:45:00',1.93),('325','2013-10-15','10:50:00',1.94),('325','2013-10-15','10:55:00',1.94),('325','2013-10-15','11:00:00',1.95),('325','2013-10-15','11:05:00',2.14),('325','2013-10-15','11:10:00',2.78),('325','2013-10-15','11:15:00',3.01),('325','2013-10-15','11:20:00',3.05),('325','2013-10-15','11:25:00',2.84),('325','2013-10-15','11:30:00',2.96),('325','2013-10-15','11:35:00',2.46),('325','2013-10-15','11:40:00',1.92),('325','2013-10-15','11:45:00',1.55),('325','2013-10-15','11:50:00',1.49),('325','2013-10-15','11:55:00',1.49),('325','2013-10-15','12:00:00',1.55),('325','2013-10-15','12:05:00',1.54),('325','2013-10-15','12:10:00',1.56),('325','2013-10-15','12:15:00',1.52),('325','2013-10-15','12:20:00',1.62),('325','2013-10-15','12:25:00',1.41),('325','2013-10-15','12:30:00',1.32),('325','2013-10-15','12:35:00',1.27),('325','2013-10-15','12:40:00',1.3),('325','2013-10-15','12:45:00',1.46),('325','2013-10-15','12:50:00',1.37),('325','2013-10-15','12:55:00',1.22),('325','2013-10-15','13:00:00',1.24),('325','2013-10-15','13:05:00',1.74),('325','2013-10-15','13:10:00',1.95),('325','2013-10-15','13:15:00',2.02),('325','2013-10-15','13:20:00',3.03),('325','2013-10-15','13:25:00',3.35),('325','2013-10-15','13:30:00',2.06),('325','2013-10-15','13:35:00',1.71),('325','2013-10-15','13:40:00',1.59),('325','2013-10-15','13:45:00',1.67),('325','2013-10-15','13:50:00',1.54),('325','2013-10-15','13:55:00',1.31),('325','2013-10-15','14:00:00',1.18),('325','2013-10-15','14:05:00',1.18),('325','2013-10-15','14:10:00',1.35),('325','2013-10-15','14:15:00',1.94),('325','2013-10-15','14:20:00',2.09),('325','2013-10-15','14:25:00',2.49),('325','2013-10-15','14:30:00',2.17),('325','2013-10-15','14:35:00',1.52),('325','2013-10-15','14:40:00',2.26),('325','2013-10-15','14:45:00',2.28),('325','2013-10-15','14:50:00',2.74),('325','2013-10-15','14:55:00',2.05),('325','2013-10-15','15:00:00',1.38),('325','2013-10-15','15:05:00',1.43),('325','2013-10-15','15:10:00',1.46),('325','2013-10-15','15:15:00',1.34),('325','2013-10-15','15:20:00',1.19),('325','2013-10-15','15:25:00',1.05),('325','2013-10-15','15:30:00',1.01),('325','2013-10-15','15:35:00',1.06),('325','2013-10-15','15:40:00',1.11),('325','2013-10-15','15:45:00',1.05),('325','2013-10-15','16:30:00',1.23),('325','2013-10-15','16:35:00',1.22),('325','2013-10-14','09:25:00',1.12),('325','2013-10-14','09:30:00',1.25),('325','2013-10-14','09:35:00',1.22),('325','2013-10-14','09:40:00',1.12),('325','2013-10-14','09:50:00',1.16),('325','2013-10-14','09:55:00',1.31),('325','2013-10-14','10:00:00',1.32),('325','2013-10-14','10:05:00',1.41),('325','2013-10-14','10:10:00',1.5),('325','2013-10-14','10:15:00',1.57),('325','2013-10-14','10:20:00',1.97),('325','2013-10-14','10:25:00',2.48),('325','2013-10-14','10:30:00',2.61),('325','2013-10-14','10:35:00',2.68),('325','2013-10-14','10:40:00',2.64),('325','2013-10-14','10:45:00',2.73),('325','2013-10-14','10:50:00',2.84),('325','2013-10-14','10:55:00',2.93),('325','2013-10-14','11:00:00',3),('325','2013-10-14','11:05:00',3),('325','2013-10-14','11:10:00',3.16),('325','2013-10-14','11:15:00',3.11),('325','2013-10-14','11:20:00',3.13),('325','2013-10-14','11:25:00',3.22),('325','2013-10-14','11:30:00',3.3),('325','2013-10-14','11:35:00',3.26),('325','2013-10-14','11:40:00',3.31),('325','2013-10-14','11:45:00',3.27),('325','2013-10-14','11:50:00',3.34),('325','2013-10-14','11:55:00',3.35),('325','2013-10-14','12:00:00',3.37),('325','2013-10-14','12:05:00',3.41),('325','2013-10-14','12:10:00',3.46),('325','2013-10-14','12:15:00',3.39),('325','2013-10-14','12:20:00',3.18),('325','2013-10-14','12:25:00',3.42),('325','2013-10-14','12:30:00',3.54),('325','2013-10-14','12:35:00',3.51),('325','2013-10-14','12:40:00',3.52),('325','2013-10-14','12:45:00',3.53),('325','2013-10-14','12:50:00',3.5),('325','2013-10-14','12:55:00',3.49),('325','2013-10-14','13:00:00',3.49),('325','2013-10-14','13:05:00',3.48),('325','2013-10-14','13:10:00',3.47),('325','2013-10-14','13:15:00',3.46),('325','2013-10-14','13:20:00',3.47),('325','2013-10-14','13:25:00',3.46),('325','2013-10-14','13:30:00',3.43),('325','2013-10-14','13:35:00',3.41),('325','2013-10-14','13:40:00',3.39),('325','2013-10-14','13:45:00',3.39),('325','2013-10-14','13:50:00',3.36),('325','2013-10-14','13:55:00',3.34),('325','2013-10-14','14:00:00',3.31),('325','2013-10-14','14:05:00',3.28),('325','2013-10-14','14:10:00',3.26),('325','2013-10-14','14:15:00',3.22),('325','2013-10-14','14:20:00',3.18),('325','2013-10-14','14:25:00',3.15),('325','2013-10-14','14:30:00',3.13),('325','2013-10-14','14:35:00',3.08),('325','2013-10-14','14:40:00',3.05),('325','2013-10-14','14:45:00',2.99),('325','2013-10-14','14:50:00',2.93),('325','2013-10-14','14:55:00',2.88),('325','2013-10-14','15:00:00',2.82),('325','2013-10-14','15:05:00',2.75),('325','2013-10-14','15:10:00',2.68),('325','2013-10-14','15:15:00',2.6),('325','2013-10-14','15:20:00',2.56),('325','2013-10-14','15:25:00',2.49),('325','2013-10-14','15:30:00',2.41),('325','2013-10-14','15:35:00',2.31),('325','2013-10-14','15:40:00',2),('325','2013-10-14','15:45:00',1.64),('325','2013-10-14','15:50:00',1.72),('325','2013-10-14','15:55:00',1.2),('325','2013-10-14','16:00:00',1.5),('325','2013-10-14','16:05:00',1.25),('325','2013-10-14','16:10:00',1.04),('325','2013-10-14','16:25:00',1.06),('325','2013-10-14','16:30:00',1.05),('325','2013-10-13','09:15:00',1.25),('325','2013-10-13','09:20:00',1.31),('325','2013-10-13','09:25:00',1.17),('325','2013-10-13','09:35:00',1.23),('325','2013-10-13','09:40:00',1.66),('325','2013-10-13','09:45:00',2.05),('325','2013-10-13','09:50:00',2.03),('325','2013-10-13','09:55:00',2.08),('325','2013-10-13','10:00:00',1.56),('325','2013-10-13','10:05:00',1.38),('325','2013-10-13','10:10:00',1.9),('325','2013-10-13','10:15:00',1.95),('325','2013-10-13','10:20:00',1.7),('325','2013-10-13','10:25:00',1.82),('325','2013-10-13','10:30:00',2.77),('325','2013-10-13','10:35:00',3.23),('325','2013-10-13','10:40:00',3.33),('325','2013-10-13','10:45:00',3.41),('325','2013-10-13','10:50:00',2.86),('325','2013-10-13','10:55:00',2.35),('325','2013-10-13','11:00:00',3.07),('325','2013-10-13','11:05:00',2.98),('325','2013-10-13','11:10:00',2.95),('325','2013-10-13','11:15:00',3.41),('325','2013-10-13','11:20:00',3.29),('325','2013-10-13','11:25:00',3.24),('325','2013-10-13','11:30:00',3.34),('325','2013-10-13','11:35:00',3.3),('325','2013-10-13','11:40:00',3.35),('325','2013-10-13','11:45:00',3.38),('325','2013-10-13','11:50:00',3.42),('325','2013-10-13','11:55:00',3.44),('325','2013-10-13','12:00:00',3.46),('325','2013-10-13','12:05:00',3.48),('325','2013-10-13','12:10:00',3.47),('325','2013-10-13','12:15:00',3.53),('325','2013-10-13','12:20:00',3.45),('325','2013-10-13','12:25:00',3.41),('325','2013-10-13','12:30:00',3.52),('325','2013-10-13','12:35:00',3.58),('325','2013-10-13','12:40:00',3.58),('325','2013-10-13','12:45:00',3.53),('325','2013-10-13','12:50:00',3.49),('325','2013-10-13','12:55:00',3.49),('325','2013-10-13','13:00:00',3.51),('325','2013-10-13','13:05:00',3.5),('325','2013-10-13','13:10:00',3.52),('325','2013-10-13','13:15:00',3.57),('325','2013-10-13','13:20:00',3.61),('325','2013-10-13','13:25:00',3.14),('325','2013-10-13','13:30:00',2.67),('325','2013-10-13','13:35:00',2.97),('325','2013-10-13','13:40:00',2.04),('325','2013-10-13','13:45:00',2.42),('325','2013-10-13','13:50:00',2.65),('325','2013-10-13','13:55:00',2.76),('325','2013-10-13','14:00:00',3.37),('325','2013-10-13','14:05:00',3.35),('325','2013-10-13','14:10:00',3.41),('325','2013-10-13','14:15:00',3.14),('325','2013-10-13','14:20:00',3.4),('325','2013-10-13','14:25:00',3.41),('325','2013-10-13','14:30:00',2.83),('325','2013-10-13','14:35:00',2.63),('325','2013-10-13','14:40:00',2.95),('325','2013-10-13','14:45:00',2.28),('325','2013-10-13','14:50:00',1.88),('325','2013-10-13','14:55:00',2.32),('325','2013-10-13','15:00:00',2.89),('325','2013-10-13','15:05:00',2.41),('325','2013-10-13','15:10:00',1.67),('325','2013-10-13','15:15:00',2.02),('325','2013-10-13','15:20:00',2.34),('325','2013-10-13','15:25:00',2.42),('325','2013-10-13','15:30:00',1.8),('325','2013-10-13','15:35:00',1.65),('325','2013-10-13','15:40:00',1.61),('325','2013-10-13','15:45:00',1.51),('325','2013-10-13','15:50:00',1.42),('325','2013-10-13','15:55:00',1.35),('325','2013-10-13','16:00:00',1.56),('325','2013-10-13','16:05:00',1.86),('325','2013-10-13','16:10:00',1.53),('325','2013-10-13','16:15:00',1.38),('325','2013-10-13','16:20:00',1.42),('325','2013-10-13','16:25:00',1.92),('325','2013-10-13','16:30:00',1.84),('325','2013-10-13','16:35:00',1.54),('325','2013-10-13','16:40:00',1.23),('325','2013-10-13','16:50:00',1.01),('325','2013-10-12','11:20:00',1.09),('325','2013-10-12','11:25:00',1.17),('325','2013-10-12','11:30:00',1.42),('325','2013-10-12','11:35:00',2.06),('325','2013-10-12','11:40:00',3.11),('325','2013-10-12','11:45:00',1.53),('325','2013-10-12','11:50:00',1.47),('325','2013-10-12','11:55:00',1.2),('325','2013-10-12','12:15:00',1.2),('325','2013-10-12','12:20:00',2.35),('325','2013-10-12','12:25:00',3.83),('325','2013-10-12','12:30:00',2.83),('325','2013-10-12','12:35:00',3.43),('325','2013-10-12','12:40:00',3.54),('325','2013-10-12','12:45:00',3.1),('325','2013-10-12','12:50:00',3.25),('325','2013-10-12','12:55:00',2.74),('325','2013-10-12','13:00:00',2.09),('325','2013-10-12','13:05:00',1.01),('325','2013-10-12','13:15:00',1.4),('325','2013-10-12','13:20:00',1.43),('325','2013-10-12','13:25:00',1.7),('325','2013-10-12','13:30:00',3.73),('325','2013-10-12','13:35:00',1.41),('325','2013-10-12','15:55:00',1.02),('325','2013-10-12','16:00:00',1.18),('325','2013-10-12','16:05:00',1.12),('325','2013-10-12','16:10:00',1.21),('325','2013-10-12','16:15:00',1.89),('325','2013-10-12','16:20:00',2.07),('325','2013-10-12','16:25:00',1.13),('325','2013-10-11','09:45:00',1.33),('325','2013-10-11','09:50:00',1.36),('325','2013-10-11','09:55:00',1.38),('325','2013-10-11','10:00:00',1.45),('325','2013-10-11','10:05:00',1.52),('325','2013-10-11','10:10:00',1.57),('325','2013-10-11','10:15:00',1.51),('325','2013-10-11','10:20:00',2.24),('325','2013-10-11','10:25:00',2.77),('325','2013-10-11','10:30:00',2.98),('325','2013-10-11','10:35:00',3.17),('325','2013-10-11','10:40:00',1.81),('325','2013-10-11','11:05:00',2.67),('325','2013-10-11','11:10:00',2.19),('325','2013-10-11','11:15:00',1.01),('325','2013-10-11','11:20:00',1.08),('325','2013-10-11','11:25:00',1.07),('325','2013-10-11','11:35:00',1.09),('325','2013-10-11','11:40:00',2.03),('325','2013-10-11','11:45:00',1.88),('325','2013-10-11','11:50:00',2.23),('325','2013-10-11','11:55:00',1.89),('325','2013-10-11','12:00:00',2.57),('325','2013-10-11','12:05:00',3.14),('325','2013-10-11','12:10:00',1.51),('325','2013-10-11','12:15:00',1.1),('325','2013-10-11','12:25:00',1.91),('325','2013-10-11','12:30:00',1.37),('325','2013-10-11','13:05:00',1.9),('325','2013-10-11','13:10:00',2.04),('325','2013-10-11','13:15:00',1.66),('325','2013-10-11','13:20:00',3.43),('325','2013-10-11','13:25:00',4.58),('325','2013-10-11','13:30:00',1.56),('325','2013-10-11','13:40:00',3.08),('325','2013-10-11','13:45:00',3.73),('325','2013-10-11','13:50:00',1.26),('325','2013-10-11','15:35:00',1.3),('325','2013-10-11','15:40:00',1.6),('325','2013-10-11','15:45:00',1.02),('325','2013-10-11','15:55:00',1.31),('325','2013-10-11','16:00:00',2.52),('325','2013-10-11','16:05:00',1.05),('325','2013-10-11','16:30:00',1.05),('325','2013-10-11','17:00:00',1.21),('325','2013-10-10','09:10:00',1.01),('325','2013-10-10','09:15:00',1.08),('325','2013-10-10','09:20:00',1.09),('325','2013-10-10','09:25:00',1.1),('325','2013-10-10','09:30:00',1.15),('325','2013-10-10','09:40:00',1.21),('325','2013-10-10','09:45:00',1.34),('325','2013-10-10','09:50:00',1.38),('325','2013-10-10','09:55:00',1.24),('325','2013-10-10','10:10:00',1.31),('325','2013-10-10','10:15:00',1.61),('325','2013-10-10','10:20:00',2.45),('325','2013-10-10','10:25:00',2),('325','2013-10-10','10:30:00',1.61),('325','2013-10-10','10:35:00',2.17),('325','2013-10-10','10:40:00',2.49),('325','2013-10-10','10:45:00',3.04),('325','2013-10-10','10:50:00',2.64),('325','2013-10-10','10:55:00',2.63),('325','2013-10-10','11:05:00',1.33),('325','2013-10-10','11:20:00',2.4),('325','2013-10-10','11:25:00',3.73),('325','2013-10-10','11:30:00',1.06),('325','2013-10-10','11:35:00',2.12),('325','2013-10-10','11:40:00',2.44),('325','2013-10-10','11:50:00',3),('325','2013-10-10','11:55:00',2.88),('325','2013-10-10','12:00:00',4.07),('325','2013-10-10','12:05:00',4.14),('325','2013-10-10','12:10:00',1.47),('325','2013-10-10','12:20:00',3),('325','2013-10-10','12:25:00',3.69),('325','2013-10-10','12:35:00',3.72),('325','2013-10-10','12:40:00',4.31),('325','2013-10-10','12:45:00',3.05),('325','2013-10-10','12:50:00',2.49),('325','2013-10-10','12:55:00',4.45),('325','2013-10-10','13:00:00',4.3),('325','2013-10-10','13:05:00',4.48),('325','2013-10-10','13:10:00',3.14),('325','2013-10-10','13:15:00',2.34),('325','2013-10-10','13:20:00',1.15),('325','2013-10-10','13:25:00',3.74),('325','2013-10-10','13:30:00',4.73),('325','2013-10-10','13:35:00',4.45),('325','2013-10-10','13:40:00',3.68),('325','2013-10-10','13:45:00',2.45),('325','2013-10-10','13:50:00',4.19),('325','2013-10-10','13:55:00',4.05),('325','2013-10-10','14:00:00',3.93),('325','2013-10-10','14:05:00',3.63),('325','2013-10-10','14:10:00',4.15),('325','2013-10-10','14:15:00',2.8),('325','2013-10-10','14:20:00',3.18),('325','2013-10-10','14:25:00',3.67),('325','2013-10-10','14:30:00',4.04),('325','2013-10-10','14:35:00',4.03),('325','2013-10-10','14:40:00',3.78),('325','2013-10-10','14:45:00',3.65),('325','2013-10-10','14:50:00',3.5),('325','2013-10-10','14:55:00',3.1),('325','2013-10-10','15:00:00',3.11),('325','2013-10-10','15:05:00',2.84),('325','2013-10-10','15:10:00',3.41),('325','2013-10-10','15:15:00',2.24),('325','2013-10-10','15:20:00',2.2),('325','2013-10-10','15:25:00',1.77),('325','2013-10-10','15:30:00',2.32),('325','2013-10-10','15:35:00',1.14),('325','2013-10-10','15:40:00',2.81),('325','2013-10-10','15:45:00',2.19),('325','2013-10-10','15:50:00',1.84),('325','2013-10-10','15:55:00',3.04),('325','2013-10-10','16:00:00',2.61),('325','2013-10-10','16:05:00',1.03),('325','2013-10-10','16:10:00',1.29),('325','2013-10-10','16:15:00',1.01),('325','2013-10-10','16:20:00',1.05),('325','2013-10-10','16:25:00',1.56),('325','2013-10-10','16:45:00',1.16),('325','2013-10-10','16:50:00',1.22),('325','2013-10-10','16:55:00',1.4),('325','2013-10-10','17:00:00',1.11),('325','2013-10-10','17:15:00',1.03),('325','2013-10-10','17:20:00',1.02),('325','2013-10-09','09:10:00',1.03),('325','2013-10-09','09:20:00',1.03),('325','2013-10-09','09:25:00',1.18),('325','2013-10-09','09:30:00',1.24),('325','2013-10-09','09:35:00',1.3),('325','2013-10-09','09:40:00',1.39),('325','2013-10-09','09:45:00',1.43),('325','2013-10-09','09:50:00',1.48),('325','2013-10-09','09:55:00',1.58),('325','2013-10-09','10:00:00',1.74),('325','2013-10-09','10:05:00',1.95),('325','2013-10-09','10:10:00',1.69),('325','2013-10-09','10:15:00',1.15),('325','2013-10-09','10:30:00',1.13),('325','2013-10-09','10:35:00',1.07),('325','2013-10-09','10:40:00',1.23),('325','2013-10-09','10:45:00',2.43),('325','2013-10-09','10:50:00',3.85),('325','2013-10-09','10:55:00',3.01),('325','2013-10-09','11:00:00',3.34),('325','2013-10-09','11:05:00',4.19),('325','2013-10-09','11:10:00',4.29),('325','2013-10-09','11:15:00',3.47),('325','2013-10-09','11:20:00',3.23),('325','2013-10-09','11:25:00',3.78),('325','2013-10-09','11:30:00',4.36),('325','2013-10-09','11:35:00',4.48),('325','2013-10-09','11:40:00',4.41),('325','2013-10-09','11:45:00',3.92),('325','2013-10-09','11:50:00',3.75),('325','2013-10-09','11:55:00',3.42),('325','2013-10-09','12:00:00',1.26),('325','2013-10-09','12:05:00',2.41),('325','2013-10-09','12:10:00',2.37),('325','2013-10-09','12:15:00',4.69),('325','2013-10-09','12:20:00',3.98),('325','2013-10-09','12:25:00',2.48),('325','2013-10-09','12:30:00',1.94),('325','2013-10-09','12:35:00',3.05),('325','2013-10-09','12:40:00',1.31),('325','2013-10-09','12:55:00',1.18),('325','2013-10-09','13:10:00',1.07),('325','2013-10-09','13:15:00',1.4),('325','2013-10-09','13:20:00',2.84),('325','2013-10-09','13:25:00',4.73),('325','2013-10-09','13:30:00',4.11),('325','2013-10-09','13:35:00',3.94),('325','2013-10-09','13:40:00',2.52),('325','2013-10-09','13:45:00',2.53),('325','2013-10-09','13:50:00',2.68),('325','2013-10-09','13:55:00',3.99),('325','2013-10-09','14:00:00',2.77),('325','2013-10-09','14:05:00',2.7),('325','2013-10-09','14:50:00',1.5),('325','2013-10-09','14:55:00',2.35),('325','2013-10-09','15:00:00',1.61),('325','2013-10-09','15:05:00',3.72),('325','2013-10-09','15:10:00',3.36),('325','2013-10-09','15:15:00',3.27),('325','2013-10-09','15:20:00',2.99),('325','2013-10-09','15:25:00',3.27),('325','2013-10-09','15:30:00',2.36),('325','2013-10-09','15:35:00',2.16),('325','2013-10-09','15:40:00',2.06),('325','2013-10-09','15:45:00',1.54),('325','2013-10-09','16:10:00',1.1),('325','2013-10-09','16:15:00',1.3),('325','2013-10-09','16:20:00',1.82),('325','2013-10-09','16:25:00',1.87),('325','2013-10-09','16:30:00',2.47),('325','2013-10-09','16:35:00',1.58),('325','2013-10-09','16:40:00',1.28),('325','2013-10-09','17:30:00',1.06),('325','2013-10-09','17:35:00',1.15),('325','2013-10-08','10:05:00',1.01),('325','2013-10-08','10:55:00',1.17),('325','2013-10-08','11:00:00',1.77),('325','2013-10-08','11:05:00',1.14),('325','2013-10-08','11:10:00',1.45),('325','2013-10-08','11:15:00',2.75),('325','2013-10-08','11:20:00',4.04),('325','2013-10-08','11:25:00',2.56),('325','2013-10-08','11:30:00',2.5),('325','2013-10-08','11:35:00',2.17),('325','2013-10-08','11:40:00',1.56),('325','2013-10-08','11:45:00',1.33),('325','2013-10-08','12:20:00',1.12),('325','2013-10-08','12:25:00',1.56),('325','2013-10-08','12:30:00',2.15),('325','2013-10-08','12:35:00',2.23),('325','2013-10-08','12:40:00',4.8),('325','2013-10-08','12:45:00',4.14),('325','2013-10-08','12:50:00',3.57),('325','2013-10-08','12:55:00',4.32),('325','2013-10-08','13:00:00',4.26),('325','2013-10-08','13:05:00',2.18),('325','2013-10-08','13:10:00',1.59),('325','2013-10-08','13:15:00',3.23),('325','2013-10-08','13:20:00',1.53),('325','2013-10-08','13:25:00',2.8),('325','2013-10-08','13:30:00',2.61),('325','2013-10-08','13:35:00',1.59),('325','2013-10-08','13:40:00',1.07),('325','2013-10-08','14:05:00',1.31),('325','2013-10-08','14:10:00',1.79),('325','2013-10-08','14:15:00',2.48),('325','2013-10-08','14:20:00',2.79),('325','2013-10-08','14:25:00',3.03),('325','2013-10-08','14:30:00',2.59),('325','2013-10-08','14:35:00',1.36),('325','2013-10-08','14:40:00',1.71),('325','2013-10-08','14:45:00',3.27),('325','2013-10-08','14:50:00',3.62),('325','2013-10-08','14:55:00',3.44),('325','2013-10-08','15:00:00',3.34),('325','2013-10-08','15:05:00',3.27),('325','2013-10-08','15:10:00',3.29),('325','2013-10-08','15:15:00',3.04),('325','2013-10-08','15:20:00',3.19),('325','2013-10-08','15:25:00',3.49),('325','2013-10-08','15:30:00',3.63),('325','2013-10-08','15:35:00',3.18),('325','2013-10-08','15:40:00',2),('325','2013-10-08','15:45:00',1.37),('325','2013-10-08','15:50:00',2.23),('325','2013-10-08','15:55:00',1.36),('325','2013-10-08','16:00:00',1.44),('325','2013-10-08','16:30:00',1.07),('325','2014-04-14','08:40:00',1.02),('325','2014-04-14','08:45:00',1.09),('325','2014-04-14','08:50:00',1.16),('325','2014-04-14','08:55:00',1.22),('325','2014-04-14','09:00:00',1.29),('325','2014-04-14','09:05:00',1.54),('325','2014-04-14','09:10:00',2.13),('325','2014-04-14','09:15:00',2.24),('325','2014-04-14','09:20:00',2.22),('325','2014-04-14','09:25:00',2.08),('325','2014-04-14','09:30:00',2.18),('325','2014-04-14','09:35:00',2.49),('325','2014-04-14','09:40:00',2.63),('325','2014-04-14','09:45:00',2.74),('325','2014-04-14','09:50:00',2.89),('325','2014-04-14','09:55:00',2.96),('325','2014-04-14','10:00:00',3.04),('325','2014-04-14','10:05:00',3.15),('325','2014-04-14','10:10:00',3.23),('325','2014-04-14','10:15:00',3.35),('325','2014-04-14','10:20:00',3.44),('325','2014-04-14','10:25:00',3.5),('325','2014-04-14','10:30:00',3.56),('325','2014-04-14','10:35:00',3.66),('325','2014-04-14','10:40:00',3.72),('325','2014-04-14','10:45:00',3.75),('325','2014-04-14','10:50:00',3.82),('325','2014-04-14','10:55:00',3.89),('325','2014-04-14','11:00:00',3.93),('325','2014-04-14','11:05:00',3.98),('325','2014-04-14','11:10:00',4.03),('325','2014-04-14','11:15:00',4.07),('325','2014-04-14','11:20:00',4.14),('325','2014-04-14','11:25:00',4.17),('325','2014-04-14','11:30:00',4.22),('325','2014-04-14','11:35:00',4.25),('325','2014-04-14','11:40:00',4.27),('325','2014-04-14','11:45:00',4.3),('325','2014-04-14','11:50:00',4.33),('325','2014-04-14','11:55:00',4.41),('325','2014-04-14','12:00:00',4.43),('325','2014-04-14','12:05:00',4.47),('325','2014-04-14','12:10:00',4.49),('325','2014-04-14','12:15:00',4.51),('325','2014-04-14','12:20:00',4.53),('325','2014-04-14','12:25:00',4.54),('325','2014-04-14','12:30:00',4.53),('325','2014-04-14','12:35:00',4.57),('325','2014-04-14','12:40:00',4.59),('325','2014-04-14','12:45:00',4.59),('325','2014-04-14','12:50:00',4.61),('325','2014-04-14','12:55:00',4.64),('325','2014-04-14','13:00:00',4.64),('325','2014-04-14','13:05:00',4.61),('325','2014-04-14','13:10:00',4.59),('325','2014-04-14','13:15:00',4.65),('325','2014-04-14','13:20:00',4.62),('325','2014-04-14','13:25:00',4.63),('325','2014-04-14','13:30:00',4.65),('325','2014-04-14','13:35:00',4.66),('325','2014-04-14','13:40:00',4.67),('325','2014-04-14','13:45:00',4.65),('325','2014-04-14','13:50:00',4.62),('325','2014-04-14','13:55:00',4.61),('325','2014-04-14','14:00:00',4.59),('325','2014-04-14','14:05:00',4.6),('325','2014-04-14','14:10:00',4.58),('325','2014-04-14','14:15:00',4.58),('325','2014-04-14','14:20:00',4.57),('325','2014-04-14','14:25:00',4.55),('325','2014-04-14','14:30:00',4.52),('325','2014-04-14','14:35:00',4.47),('325','2014-04-14','14:40:00',4.44),('325','2014-04-14','14:45:00',4.39),('325','2014-04-14','14:50:00',4.37),('325','2014-04-14','14:55:00',4.34),('325','2014-04-14','15:00:00',4.3),('325','2014-04-14','15:05:00',4.26),('325','2014-04-14','15:10:00',4.2),('325','2014-04-14','15:15:00',4.15),('325','2014-04-14','15:20:00',4.1),('325','2014-04-14','15:25:00',4.06),('325','2014-04-14','15:30:00',4.01),('325','2014-04-14','15:35:00',3.94),('325','2014-04-14','15:40:00',3.89),('325','2014-04-14','15:45:00',3.82),('325','2014-04-14','15:50:00',3.76),('325','2014-04-14','15:55:00',3.69),('325','2014-04-14','16:00:00',3.6),('325','2014-04-14','16:05:00',3.52),('325','2014-04-14','16:10:00',3.44),('325','2014-04-14','16:15:00',3.37),('325','2014-04-14','16:20:00',3.31),('325','2014-04-14','16:25:00',3.23),('325','2014-04-14','16:30:00',3.15),('325','2014-04-14','16:35:00',3.06),('325','2014-04-14','16:40:00',2.96),('325','2014-04-14','16:45:00',2.85),('325','2014-04-14','16:50:00',2.7),('325','2014-04-14','16:55:00',2.66),('325','2014-04-14','17:00:00',2.56),('325','2014-04-14','17:05:00',2.47),('325','2014-04-14','17:10:00',2.37),('325','2014-04-14','17:15:00',2.27),('325','2014-04-14','17:20:00',2.18),('325','2014-04-14','17:25:00',2.08),('325','2014-04-14','17:30:00',1.92),('325','2014-04-14','17:35:00',1.82),('325','2014-04-14','17:40:00',1.71),('325','2014-04-14','17:45:00',1.62),('325','2014-04-14','17:50:00',1.51),('325','2014-04-14','17:55:00',1.41),('325','2014-04-14','18:00:00',1.3),('325','2014-04-14','18:05:00',1.19),('325','2014-04-14','18:10:00',1.08),('325','2013-10-07','09:00:00',1.18),('325','2013-10-07','09:05:00',1.1),('325','2013-10-07','09:10:00',1.06),('325','2013-10-07','09:15:00',1.09),('325','2013-10-07','09:20:00',1.1),('325','2013-10-07','09:25:00',1.16),('325','2013-10-07','09:30:00',1.2),('325','2013-10-07','09:35:00',1.24),('325','2013-10-07','09:40:00',1.28),('325','2013-10-07','09:45:00',1.32),('325','2013-10-07','09:50:00',1.37),('325','2013-10-07','09:55:00',1.41),('325','2013-10-07','10:00:00',1.44),('325','2013-10-07','10:05:00',1.5),('325','2013-10-07','10:10:00',1.54),('325','2013-10-07','10:15:00',1.74),('325','2013-10-07','10:20:00',2.63),('325','2013-10-07','10:25:00',2.76),('325','2013-10-07','10:30:00',2.89),('325','2013-10-07','10:35:00',3.21),('325','2013-10-07','10:40:00',3.05),('325','2013-10-07','10:45:00',3.1),('325','2013-10-07','10:50:00',3.18),('325','2013-10-07','10:55:00',2.68),('325','2013-10-07','11:00:00',2.74),('325','2013-10-07','11:05:00',3.5),('325','2013-10-07','11:10:00',3.25),('325','2013-10-07','11:15:00',3.35),('325','2013-10-07','11:20:00',3.36),('325','2013-10-07','11:25:00',3.51),('325','2013-10-07','11:30:00',3.53),('325','2013-10-07','11:35:00',3.56),('325','2013-10-07','11:40:00',3.61),('325','2013-10-07','11:45:00',3.68),('325','2013-10-07','11:50:00',3.71),('325','2013-10-07','11:55:00',3.74),('325','2013-10-07','12:00:00',3.74),('325','2013-10-07','12:05:00',3.89),('325','2013-10-06','09:05:00',1.01),('325','2013-10-06','09:30:00',1.06),('325','2013-10-06','09:35:00',1.23),('325','2013-10-06','09:40:00',1.1),('325','2013-10-06','09:45:00',1.05),('325','2013-10-06','09:50:00',1.61),('325','2013-10-06','09:55:00',1.83),('325','2013-10-06','10:00:00',2.11),('325','2013-10-06','10:05:00',2.15),('325','2013-10-06','10:10:00',2.11),('325','2013-10-06','10:15:00',1.97),('325','2013-10-06','10:20:00',2.03),('325','2013-10-06','10:25:00',2.22),('325','2013-10-06','10:30:00',2.24),('325','2013-10-06','10:35:00',2.23),('325','2013-10-06','10:40:00',2.02),('325','2013-10-06','10:45:00',1.73),('325','2013-10-06','10:50:00',2.29),('325','2013-10-06','10:55:00',2.37),('325','2013-10-06','11:00:00',2.69),('325','2013-10-06','11:05:00',2.94),('325','2013-10-06','11:10:00',3.06),('325','2013-10-06','11:15:00',3.04),('325','2013-10-06','11:20:00',3.14),('325','2013-10-06','11:25:00',3.14),('325','2013-10-06','11:30:00',3.06),('325','2013-10-06','11:35:00',3.01),('325','2013-10-06','11:40:00',2.14),('325','2013-10-06','11:45:00',2.3),('325','2013-10-06','11:50:00',2.42),('325','2013-10-06','11:55:00',2.92),('325','2013-10-06','12:00:00',2.85),('325','2013-10-06','12:05:00',2.88),('325','2013-10-06','12:10:00',3.66),('325','2013-10-06','12:15:00',3.53),('325','2013-10-06','12:20:00',3.4),('325','2013-10-06','12:25:00',2.58),('325','2013-10-06','12:30:00',2.8),('325','2013-10-06','12:35:00',3.01),('325','2013-10-06','12:40:00',2.87),('325','2013-10-06','12:45:00',2.95),('325','2013-10-06','12:50:00',3.16),('325','2013-10-06','12:55:00',3.55),('325','2013-10-06','13:00:00',3.48),('325','2013-10-06','13:05:00',3.36),('325','2013-10-06','13:10:00',3.4),('325','2013-10-06','13:15:00',3.33),('325','2013-10-06','13:20:00',1.53),('325','2013-10-06','13:25:00',1.08),('325','2013-10-06','13:45:00',2.11),('325','2013-10-06','13:50:00',4.16),('325','2013-10-06','13:55:00',3.89),('325','2013-10-06','14:00:00',2.92),('325','2013-10-06','14:05:00',2.02),('325','2013-10-06','14:10:00',1.66),('325','2013-10-06','14:15:00',1.52),('325','2013-10-06','14:20:00',1.71),('325','2013-10-06','14:25:00',1.74),('325','2013-10-06','14:30:00',2.55),('325','2013-10-06','14:35:00',2.42),('325','2013-10-06','14:40:00',2.44),('325','2013-10-06','14:45:00',1.78),('325','2013-10-06','14:50:00',2.15),('325','2013-10-06','14:55:00',2.8),('325','2013-10-06','15:00:00',2.03),('325','2013-10-06','15:05:00',1.5),('325','2013-10-06','15:10:00',1.22),('325','2013-10-06','15:15:00',1.21),('325','2013-10-06','15:55:00',1.02),('325','2013-10-06','16:00:00',1.1),('325','2013-10-06','17:15:00',1.04),('325','2013-10-05','16:00:00',1.06),('325','2013-10-05','16:05:00',1.32),('325','2013-10-05','16:10:00',1.25),('325','2013-10-05','16:15:00',1.14),('325','2013-10-05','16:20:00',1.19),('325','2013-10-05','16:25:00',1.13),('325','2013-10-05','16:40:00',1.01),('325','2013-10-05','16:50:00',1.02),('325','2013-10-04','09:25:00',1.03),('325','2013-10-04','09:30:00',1.09),('325','2013-10-04','09:35:00',1.15),('325','2013-10-04','09:40:00',1.14),('325','2013-10-04','09:45:00',1.19),('325','2013-10-04','09:50:00',1.38),('325','2013-10-04','09:55:00',2.19),('325','2013-10-04','10:00:00',1.87),('325','2013-10-04','10:05:00',1.42),('325','2013-10-04','10:10:00',1.49),('325','2013-10-04','10:15:00',1.68),('325','2013-10-04','10:20:00',1.56),('325','2013-10-04','10:25:00',1.7),('325','2013-10-04','10:30:00',2.06),('325','2013-10-04','10:35:00',1.91),('325','2013-10-04','10:40:00',2.63),('325','2013-10-04','10:45:00',2.72),('325','2013-10-04','10:50:00',2.17),('325','2013-10-04','10:55:00',2.53),('325','2013-10-04','11:00:00',1.98),('325','2013-10-04','11:05:00',1.73),('325','2013-10-04','11:10:00',1.96),('325','2013-10-04','11:15:00',3.23),('325','2013-10-04','11:20:00',2.95),('325','2013-10-04','11:25:00',2.94),('325','2013-10-04','11:30:00',4),('325','2013-10-04','11:35:00',3.58),('325','2013-10-04','11:40:00',3.88),('325','2013-10-04','11:45:00',3.89),('325','2013-10-04','11:50:00',3.85),('325','2013-10-04','11:55:00',3.83),('325','2013-10-04','12:00:00',3.86),('325','2013-10-04','12:05:00',3.89),('325','2013-10-04','12:10:00',3.89),('325','2013-10-04','12:15:00',3.77),('325','2013-10-04','12:20:00',3.82),('325','2013-10-04','12:25:00',3.97),('325','2013-10-04','12:30:00',4.1),('325','2013-10-04','12:35:00',3.82),('325','2013-10-04','12:40:00',3.86),('325','2013-10-04','12:45:00',3.89),('325','2013-10-04','12:50:00',3.81),('325','2013-10-04','12:55:00',3.79),('325','2013-10-04','13:00:00',3.84),('325','2013-10-04','13:05:00',3.9),('325','2013-10-04','13:10:00',3.89),('325','2013-10-04','13:15:00',4.04),('325','2013-10-04','13:20:00',3.93),('325','2013-10-04','13:25:00',3.69),('325','2013-10-04','13:30:00',3.97),('325','2013-10-04','13:35:00',3.99),('325','2013-10-04','13:40:00',3.77),('325','2013-10-04','13:45:00',3.75),('325','2013-10-04','13:50:00',3.73),('325','2013-10-04','13:55:00',3.69),('325','2013-10-04','14:00:00',3.66),('325','2013-10-04','14:05:00',3.65),('325','2013-10-04','14:10:00',3.3),('325','2013-10-04','14:15:00',2.78),('325','2013-10-04','14:20:00',3.4),('325','2013-10-04','14:25:00',3.49),('325','2013-10-04','14:30:00',3.02),('325','2013-10-04','14:35:00',2.09),('325','2013-10-04','14:40:00',1.77),('325','2013-10-04','14:45:00',2.17),('325','2013-10-04','14:50:00',2.79),('325','2013-10-04','14:55:00',2.71),('325','2013-10-04','15:00:00',2.34),('325','2013-10-04','15:05:00',2.65),('325','2013-10-04','15:10:00',2.17),('325','2013-10-04','15:15:00',1.76),('325','2013-10-04','15:20:00',1.53),('325','2013-10-04','15:25:00',2.87),('325','2013-10-04','15:30:00',2.27),('325','2013-10-04','15:35:00',1.28),('325','2013-10-04','16:00:00',1.11),('325','2013-10-04','16:05:00',1.2),('325','2013-10-04','16:10:00',1.08),('325','2013-10-03','09:05:00',1.03),('325','2013-10-03','09:10:00',1.08),('325','2013-10-03','09:15:00',1.14),('325','2013-10-03','09:20:00',1.19),('325','2013-10-03','09:25:00',1.23),('325','2013-10-03','09:30:00',1.28),('325','2013-10-03','09:35:00',1.34),('325','2013-10-03','09:40:00',1.38),('325','2013-10-03','09:45:00',1.43),('325','2013-10-03','09:50:00',1.48),('325','2013-10-03','09:55:00',1.52),('325','2013-10-03','10:00:00',1.57),('325','2013-10-03','10:05:00',1.63),('325','2013-10-03','10:10:00',1.68),('325','2013-10-03','10:15:00',2.75),('325','2013-10-03','10:20:00',2.91),('325','2013-10-03','10:25:00',3.05),('325','2013-10-03','10:30:00',3.18),('325','2013-10-03','10:35:00',3.24),('325','2013-10-03','10:40:00',3.3),('325','2013-10-03','10:45:00',3.4),('325','2013-10-03','10:50:00',3.46),('325','2013-10-03','10:55:00',3.54),('325','2013-10-03','11:00:00',3.58),('325','2013-10-03','11:05:00',3.63),('325','2013-10-03','11:10:00',3.69),('325','2013-10-03','11:15:00',3.73),('325','2013-10-03','11:20:00',3.79),('325','2013-10-03','11:25:00',3.82),('325','2013-10-03','11:30:00',3.85),('325','2013-10-03','11:35:00',3.9),('325','2013-10-03','11:40:00',3.94),('325','2013-10-03','11:45:00',4.02),('325','2013-10-03','11:50:00',4.06),('325','2013-10-03','11:55:00',4.09),('325','2013-10-03','12:00:00',4.09),('325','2013-10-03','12:05:00',4.12),('325','2013-10-03','12:10:00',4.12),('325','2013-10-03','12:15:00',4.12),('325','2013-10-03','12:20:00',4.12),('325','2013-10-03','12:25:00',4.14),('325','2013-10-03','12:30:00',4.14),('325','2013-10-03','12:35:00',4.16),('325','2013-10-03','12:40:00',4.16),('325','2013-10-03','12:45:00',4.16),('325','2013-10-03','12:50:00',4.18),('325','2013-10-03','12:55:00',4.17),('325','2013-10-03','13:00:00',4.14),('325','2013-10-03','13:05:00',4.07),('325','2013-10-03','13:10:00',4.13),('325','2013-10-03','13:15:00',4.1),('325','2013-10-03','13:20:00',4.09),('325','2013-10-03','13:25:00',4.07),('325','2013-10-03','13:30:00',4.09),('325','2013-10-03','13:35:00',4.08),('325','2013-10-03','13:40:00',4.05),('325','2013-10-03','13:45:00',4.02),('325','2013-10-03','13:50:00',4),('325','2013-10-03','13:55:00',3.99),('325','2013-10-03','14:00:00',3.98),('325','2013-10-03','14:05:00',3.97),('325','2013-10-03','14:10:00',3.94),('325','2013-10-03','14:15:00',3.9),('325','2013-10-03','14:20:00',3.86),('325','2013-10-03','14:25:00',3.81),('325','2013-10-03','14:30:00',3.77),('325','2013-10-03','14:35:00',3.72),('325','2013-10-03','14:40:00',3.68),('325','2013-10-03','14:45:00',3.63),('325','2013-10-03','14:50:00',3.59),('325','2013-10-03','14:55:00',3.54),('325','2013-10-03','15:00:00',3.48),('325','2013-10-03','15:05:00',3.41),('325','2013-10-03','15:10:00',3.35),('325','2013-10-03','15:15:00',3.3),('325','2013-10-03','15:20:00',3.23),('325','2013-10-03','15:25:00',3.17),('325','2013-10-03','15:30:00',3.09),('325','2013-10-03','15:35:00',3.02),('325','2013-10-03','15:40:00',2.94),('325','2013-10-03','15:45:00',2.87),('325','2013-10-03','15:50:00',2.79),('325','2013-10-03','15:55:00',2.71),('325','2013-10-03','16:00:00',2.63),('325','2013-10-03','16:05:00',2.54),('325','2013-10-03','16:10:00',2.46),('325','2013-10-03','16:15:00',2.36),('325','2013-10-03','16:20:00',2.23),('325','2013-10-03','16:25:00',2.16),('325','2013-10-03','16:30:00',2.07),('325','2013-10-03','16:35:00',1.99),('325','2013-10-03','16:40:00',1.88),('325','2013-10-03','16:45:00',1.79),('325','2013-10-03','16:50:00',1.69),('325','2013-10-03','16:55:00',1.59),('325','2013-10-03','17:00:00',1.47),('325','2013-10-03','17:05:00',1.37),('325','2013-10-03','17:10:00',1.27),('325','2013-10-03','17:15:00',1.17),('325','2013-10-03','17:20:00',1.07),('325','2013-10-02','09:10:00',1.04),('325','2013-10-02','09:15:00',1.09),('325','2013-10-02','09:20:00',1.14),('325','2013-10-02','09:25:00',1.19),('325','2013-10-02','09:30:00',1.24),('325','2013-10-02','09:35:00',1.28),('325','2013-10-02','09:40:00',1.33),('325','2013-10-02','09:45:00',1.36),('325','2013-10-02','09:50:00',1.41),('325','2013-10-02','09:55:00',1.45),('325','2013-10-02','10:00:00',1.2),('325','2013-10-02','10:05:00',1.54),('325','2013-10-02','10:10:00',1.58),('325','2013-10-02','10:15:00',2.19),('325','2013-10-02','10:20:00',2.72),('325','2013-10-02','10:25:00',2.87),('325','2013-10-02','10:30:00',2.99),('325','2013-10-02','10:35:00',3.05),('325','2013-10-02','10:40:00',3.13),('325','2013-10-02','10:45:00',3.23),('325','2013-10-02','10:50:00',3.3),('325','2013-10-02','10:55:00',3.4),('325','2013-10-02','11:00:00',3.45),('325','2013-10-02','11:05:00',3.5),('325','2013-10-02','11:10:00',3.55),('325','2013-10-02','11:15:00',3.58),('325','2013-10-02','11:20:00',3.62),('325','2013-10-02','11:25:00',3.66),('325','2013-10-02','11:30:00',3.69),('325','2013-10-02','11:35:00',3.72),('325','2013-10-02','11:40:00',3.75),('325','2013-10-02','11:45:00',3.83),('325','2013-10-02','11:50:00',3.87),('325','2013-10-02','11:55:00',3.89),('325','2013-10-02','12:00:00',3.9),('325','2013-10-02','12:05:00',3.92),('325','2013-10-02','12:10:00',3.95),('325','2013-10-02','12:15:00',3.97),('325','2013-10-02','12:20:00',3.98),('325','2013-10-02','12:25:00',3.97),('325','2013-10-02','12:30:00',3.97),('325','2013-10-02','12:35:00',3.98),('325','2013-10-02','12:40:00',4.01),('325','2013-10-02','12:45:00',4),('325','2013-10-02','12:50:00',4.01),('325','2013-10-02','12:55:00',4.02),('325','2013-10-02','13:00:00',4.01),('325','2013-10-02','13:05:00',4.02),('325','2013-10-02','13:10:00',4.02),('325','2013-10-02','13:15:00',4.01),('325','2013-10-02','13:20:00',4),('325','2013-10-02','13:25:00',3.99),('325','2013-10-02','13:30:00',3.99),('325','2013-10-02','13:35:00',3.96),('325','2013-10-02','13:40:00',3.93),('325','2013-10-02','13:45:00',3.92),('325','2013-10-02','13:50:00',3.89),('325','2013-10-02','13:55:00',3.86),('325','2013-10-02','14:00:00',3.84),('325','2013-10-02','14:05:00',3.84),('325','2013-10-02','14:10:00',3.81),('325','2013-10-02','14:15:00',3.76),('325','2013-10-02','14:20:00',3.73),('325','2013-10-02','14:25:00',3.7),('325','2013-10-02','14:30:00',3.67),('325','2013-10-02','14:35:00',3.63),('325','2013-10-02','14:40:00',3.58),('325','2013-10-02','14:45:00',3.53),('325','2013-10-02','14:50:00',3.49),('325','2013-10-02','14:55:00',3.45),('325','2013-10-02','15:00:00',3.4),('325','2013-10-02','15:05:00',3.34),('325','2013-10-02','15:10:00',3.28),('325','2013-10-02','15:15:00',3.21),('325','2013-10-02','15:20:00',3.15),('325','2013-10-02','15:25:00',3.08),('325','2013-10-02','15:30:00',3.01),('325','2013-10-02','15:35:00',2.93),('325','2013-10-02','15:40:00',2.88),('325','2013-10-02','15:45:00',2.81),('325','2013-10-02','15:50:00',2.74),('325','2013-10-02','15:55:00',2.67),('325','2013-10-02','16:00:00',2.57),('325','2013-10-02','16:05:00',2.49),('325','2013-10-02','16:10:00',2.4),('325','2013-10-02','16:15:00',2.32),('325','2013-10-02','16:20:00',2.19),('325','2013-10-02','16:25:00',2.1),('325','2013-10-02','16:30:00',2.02),('325','2013-10-02','16:35:00',1.93),('325','2013-10-02','16:40:00',1.84),('325','2013-10-02','16:45:00',1.75),('325','2013-10-02','16:50:00',1.65),('325','2013-10-02','16:55:00',1.56),('325','2013-10-02','17:00:00',1.45),('325','2013-10-02','17:05:00',1.35),('325','2013-10-02','17:10:00',1.25),('325','2013-10-02','17:15:00',1.14),('325','2013-10-02','17:20:00',1.05),('325','2013-10-01','09:05:00',1),('325','2013-10-01','09:10:00',1.05),('325','2013-10-01','09:15:00',1.09),('325','2013-10-01','09:20:00',1.14),('325','2013-10-01','09:25:00',1.18),('325','2013-10-01','09:30:00',1.21),('325','2013-10-01','09:35:00',1.27),('325','2013-10-01','09:40:00',1.31),('325','2013-10-01','09:45:00',1.34),('325','2013-10-01','09:50:00',1.4),('325','2013-10-01','09:55:00',1.42),('325','2013-10-01','10:00:00',1.47),('325','2013-10-01','10:05:00',1.54),('325','2013-10-01','10:10:00',2.51),('325','2013-10-01','10:15:00',2.6),('325','2013-10-01','10:20:00',2.74),('325','2013-10-01','10:25:00',2.87),('325','2013-10-01','10:30:00',2.98),('325','2013-10-01','10:35:00',3.01),('325','2013-10-01','10:40:00',3.06),('325','2013-10-01','10:45:00',3.17),('325','2013-10-01','10:50:00',3.28),('325','2013-10-01','10:55:00',3.39),('325','2013-10-01','11:00:00',3.43),('325','2013-10-01','11:05:00',3.36),('325','2013-10-01','11:10:00',3.86),('325','2013-10-01','11:15:00',3.67),('325','2013-10-01','11:30:00',2.26),('325','2013-10-01','11:35:00',3.88),('325','2013-10-01','11:40:00',3.87),('325','2013-10-01','11:45:00',3.94),('325','2013-10-01','11:50:00',2.1),('325','2013-10-01','11:55:00',1.69),('325','2013-10-01','12:00:00',4.07),('325','2013-10-01','12:05:00',3.99),('325','2013-10-01','12:10:00',3.97),('325','2013-10-01','12:15:00',4.11),('325','2013-10-01','12:20:00',4.14),('325','2013-10-01','12:25:00',3.26),('325','2013-10-01','12:30:00',3.46),('325','2013-10-01','12:40:00',1.06),('325','2013-10-01','12:45:00',3.98),('325','2013-10-01','12:55:00',2.89),('325','2013-10-01','13:00:00',4.34),('325','2013-10-01','13:05:00',3.21),('325','2013-10-01','13:10:00',1.05),('325','2013-10-01','13:15:00',2.97),('325','2013-10-01','13:20:00',4.39),('325','2013-10-01','13:25:00',2.93),('325','2013-10-01','13:30:00',4.33),('325','2013-10-01','13:35:00',4.35),('325','2013-10-01','13:40:00',4.2),('325','2013-10-01','13:45:00',4.15),('325','2013-10-01','13:50:00',4.03),('325','2013-10-01','13:55:00',3.81),('325','2013-10-01','14:00:00',3.79),('325','2013-10-01','14:05:00',3.78),('325','2013-10-01','14:10:00',3.69),('325','2013-10-01','14:15:00',3.64),('325','2013-10-01','14:20:00',3.67),('325','2013-10-01','14:25:00',3.63),('325','2013-10-01','14:30:00',3.59),('325','2013-10-01','14:35:00',2.74),('325','2013-10-01','14:40:00',3.27),('325','2013-10-01','14:45:00',3.56),('325','2013-10-01','14:50:00',3.52),('325','2013-10-01','14:55:00',3.56),('325','2013-10-01','15:00:00',3.43),('325','2013-10-01','15:05:00',3.34),('325','2013-10-01','15:10:00',3.26),('325','2013-10-01','15:15:00',3.22),('325','2013-10-01','15:20:00',3.16),('325','2013-10-01','15:25:00',3.11),('325','2013-10-01','15:30:00',3.03),('325','2013-10-01','15:35:00',2.97),('325','2013-10-01','15:40:00',2.89),('325','2013-10-01','15:45:00',2.82),('325','2013-10-01','15:50:00',2.73),('325','2013-10-01','15:55:00',2.66),('325','2013-10-01','16:00:00',2.58),('325','2013-10-01','16:05:00',2.51),('325','2013-10-01','16:10:00',2.42),('325','2013-10-01','16:15:00',2.33),('325','2013-10-01','16:20:00',2.2),('325','2013-10-01','16:25:00',2.13),('325','2013-10-01','16:30:00',2.05),('325','2013-10-01','16:35:00',1.95),('325','2013-10-01','16:40:00',1.85),('325','2013-10-01','16:45:00',1.77),('325','2013-10-01','16:50:00',1.68),('325','2013-10-01','16:55:00',1.59),('325','2013-10-01','17:00:00',1.47),('325','2013-10-01','17:05:00',1.37),('325','2013-10-01','17:10:00',1.29),('325','2013-10-01','17:15:00',1.17),('325','2013-10-01','17:20:00',1.1),('325','2013-10-01','17:25:00',1.01),('325','2013-09-30','09:50:00',1.18),('325','2013-09-30','09:55:00',1.03),('325','2013-09-30','10:10:00',1.09),('325','2013-09-30','10:15:00',1.1),('325','2013-09-30','10:20:00',1.11),('325','2013-09-30','10:25:00',1.21),('325','2013-09-30','10:30:00',1.31),('325','2013-09-30','10:35:00',1.47),('325','2013-09-30','10:40:00',2.25),('325','2013-09-30','10:45:00',3.39),('325','2013-09-30','10:50:00',3.47),('325','2013-09-30','10:55:00',3.16),('325','2013-09-30','11:00:00',2.53),('325','2013-09-30','11:05:00',2.37),('325','2013-09-30','11:10:00',3.63),('325','2013-09-30','11:15:00',2.96),('325','2013-09-30','11:20:00',3),('325','2013-09-30','11:25:00',2.22),('325','2013-09-30','11:30:00',2.25),('325','2013-09-30','11:35:00',2.39),('325','2013-09-30','11:40:00',4.2),('325','2013-09-30','11:45:00',1.89),('325','2013-09-30','11:50:00',1.47),('325','2013-09-30','11:55:00',1.39),('325','2013-09-30','12:00:00',1.48),('325','2013-09-30','12:10:00',2.81),('325','2013-09-30','12:15:00',4.28),('325','2013-09-30','12:20:00',4.3),('325','2013-09-30','12:25:00',4.21),('325','2013-09-30','12:30:00',4.14),('325','2013-09-30','12:35:00',4.16),('325','2013-09-30','12:40:00',3.96),('325','2013-09-30','12:45:00',3.63),('325','2013-09-30','12:50:00',4.31),('325','2013-09-30','12:55:00',4.23),('325','2013-09-30','13:00:00',4.24),('325','2013-09-30','13:05:00',4.35),('325','2013-09-30','13:10:00',4.11),('325','2013-09-30','13:15:00',4.28),('325','2013-09-30','13:20:00',4.66),('325','2013-09-30','13:25:00',4.65),('325','2013-09-30','13:30:00',4.44),('325','2013-09-30','13:35:00',3.9),('325','2013-09-30','13:40:00',3.36),('325','2013-09-30','13:45:00',1.55),('325','2013-09-30','13:50:00',4.05),('325','2013-09-30','13:55:00',3.07),('325','2013-09-30','14:00:00',1.84),('325','2013-09-30','14:05:00',1.37),('325','2013-09-30','14:10:00',1.32),('325','2013-09-30','14:15:00',1.23),('325','2013-09-30','14:20:00',1.07),('325','2013-09-30','14:25:00',1.3),('325','2013-09-30','14:30:00',3.11),('325','2013-09-30','14:35:00',2.75),('325','2013-09-30','14:40:00',4),('325','2013-09-30','14:45:00',3.8),('325','2013-09-30','14:50:00',3.31),('325','2013-09-30','14:55:00',2.28),('325','2013-09-30','15:00:00',2.22),('325','2013-09-30','15:05:00',3.4),('325','2013-09-30','15:10:00',4.06),('325','2013-09-30','15:15:00',1.66),('325','2013-09-30','15:20:00',2.11),('325','2013-09-30','15:25:00',3.01),('325','2013-09-30','15:30:00',1.56),('325','2013-09-30','15:35:00',3.64),('325','2013-09-30','15:40:00',3.51),('325','2013-09-30','15:45:00',1.85),('325','2013-09-30','16:10:00',1.57),('325','2013-09-30','16:15:00',1.85),('325','2013-09-30','16:20:00',1.57),('325','2013-09-30','16:45:00',1.31),('325','2013-09-30','16:55:00',1.01),('325','2013-09-30','17:00:00',1.05),('325','2013-09-30','17:25:00',1.01),('325','2013-09-29','08:50:00',1.11),('325','2013-09-29','09:15:00',1.07),('325','2013-09-29','09:55:00',1.01),('325','2013-09-29','10:00:00',1.15),('325','2013-09-29','10:05:00',1.43),('325','2013-09-29','10:10:00',1.63),('325','2013-09-29','10:15:00',2.01),('325','2013-09-29','10:20:00',1.61),('325','2013-09-29','10:25:00',1.56),('325','2013-09-29','10:30:00',1.75),('325','2013-09-29','10:35:00',1.87),('325','2013-09-29','10:40:00',1.93),('325','2013-09-29','10:45:00',2.37),('325','2013-09-29','10:50:00',2.86),('325','2013-09-29','10:55:00',2.91),('325','2013-09-29','11:00:00',2.96),('325','2013-09-29','11:05:00',2.85),('325','2013-09-29','11:10:00',2.86),('325','2013-09-29','11:15:00',3.09),('325','2013-09-29','11:20:00',3.07),('325','2013-09-29','11:25:00',2.92),('325','2013-09-29','11:30:00',3.15),('325','2013-09-29','11:35:00',3.09),('325','2013-09-29','11:40:00',3.1),('325','2013-09-29','11:45:00',3.33),('325','2013-09-29','11:50:00',3.46),('325','2013-09-29','11:55:00',3.54),('325','2013-09-29','12:00:00',3.14),('325','2013-09-29','12:05:00',2.82),('325','2013-09-29','12:10:00',3.55),('325','2013-09-29','12:15:00',3.93),('325','2013-09-29','12:20:00',2.13),('325','2013-09-29','12:25:00',1.75),('325','2013-09-29','12:30:00',1.94),('325','2013-09-29','12:35:00',1.84),('325','2013-09-29','12:40:00',1.54),('325','2013-09-29','12:45:00',1.33),('325','2013-09-29','12:50:00',1.32),('325','2013-09-29','12:55:00',1.19),('325','2013-09-29','13:00:00',1.14),('325','2013-09-29','13:05:00',1.04),('325','2013-09-29','13:10:00',1.03),('325','2013-09-29','13:25:00',1.47),('325','2013-09-29','13:30:00',1.71),('325','2013-09-29','13:35:00',2.11),('325','2013-09-29','13:40:00',1.81),('325','2013-09-29','13:45:00',1.64),('325','2013-09-29','13:50:00',1.82),('325','2013-09-29','13:55:00',2.02),('325','2013-09-29','14:00:00',2.03),('325','2013-09-29','14:05:00',2.28),('325','2013-09-29','14:10:00',1.31),('325','2013-09-29','14:15:00',1.75),('325','2013-09-29','14:20:00',2.53),('325','2013-09-29','14:25:00',1.47),('325','2013-09-29','14:30:00',1.53),('325','2013-09-29','14:35:00',1.22),('325','2013-09-29','15:00:00',1.09),('325','2013-09-29','16:00:00',1.18),('325','2013-09-29','16:30:00',1.14),('325','2013-09-29','16:35:00',1.05),('325','2013-09-28','09:05:00',1.02),('325','2013-09-28','09:10:00',1.09),('325','2013-09-28','09:15:00',1.15),('325','2013-09-28','09:20:00',1.19),('325','2013-09-28','09:25:00',1.26),('325','2013-09-28','09:30:00',1.32),('325','2013-09-28','09:35:00',1.37),('325','2013-09-28','09:40:00',1.37),('325','2013-09-28','09:45:00',1.43),('325','2013-09-28','09:50:00',1.58),('325','2013-09-28','09:55:00',1.43),('325','2013-09-28','10:00:00',1.61),('325','2013-09-28','10:05:00',1.41),('325','2013-09-28','10:10:00',1.55),('325','2013-09-28','10:15:00',2.13),('325','2013-09-28','10:20:00',1.44),('325','2013-09-28','10:25:00',1.06),('325','2013-09-28','10:30:00',1.57),('325','2013-09-28','10:35:00',1.91),('325','2013-09-28','10:40:00',2.29),('325','2013-09-28','10:45:00',3.11),('325','2013-09-28','10:50:00',3.57),('325','2013-09-28','10:55:00',1.8),('325','2013-09-28','11:10:00',2.16),('325','2013-09-28','11:15:00',3.93),('325','2013-09-28','11:20:00',3.98),('325','2013-09-28','11:25:00',3.93),('325','2013-09-28','11:30:00',3.85),('325','2013-09-28','11:35:00',2.62),('325','2013-09-28','11:50:00',1.57),('325','2013-09-28','11:55:00',1.58),('325','2013-09-28','12:00:00',3.36),('325','2013-09-28','12:05:00',3.14),('325','2013-09-28','12:10:00',2.75),('325','2013-09-28','12:15:00',1.71),('325','2013-09-28','12:20:00',3.85),('325','2013-09-28','12:25:00',4.18),('325','2013-09-28','12:30:00',3.8),('325','2013-09-28','12:35:00',3.74),('325','2013-09-28','12:40:00',4.11),('325','2013-09-28','12:45:00',2.74),('325','2013-09-28','12:50:00',3.44),('325','2013-09-28','12:55:00',3.96),('325','2013-09-28','13:00:00',3.33),('325','2013-09-28','13:05:00',1.96),('325','2013-09-28','13:10:00',3.68),('325','2013-09-28','13:15:00',4.08),('325','2013-09-28','13:20:00',4.15),('325','2013-09-28','13:25:00',4.28),('325','2013-09-28','13:30:00',1.81),('325','2013-09-28','13:35:00',1.88),('325','2013-09-28','13:40:00',2.94),('325','2013-09-28','13:45:00',3.38),('325','2013-09-28','13:50:00',2.38),('325','2013-09-28','13:55:00',1.82),('325','2013-09-28','14:00:00',2.15),('325','2013-09-28','14:05:00',1.85),('325','2013-09-28','14:10:00',2.46),('325','2013-09-28','14:15:00',4.09),('325','2013-09-28','14:20:00',4.2),('325','2013-09-28','14:25:00',3.95),('325','2013-09-28','14:30:00',3.89),('325','2013-09-28','14:35:00',3.85),('325','2013-09-28','14:40:00',3.77),('325','2013-09-28','14:45:00',3.69),('325','2013-09-28','14:50:00',3.58),('325','2013-09-28','14:55:00',3.58),('325','2013-09-28','15:00:00',3.51),('325','2013-09-28','15:05:00',3.27),('325','2013-09-28','15:10:00',2.69),('325','2013-09-28','15:15:00',3.29),('325','2013-09-28','15:20:00',3.27),('325','2013-09-28','15:25:00',3.07),('325','2013-09-28','15:30:00',2.97),('325','2013-09-28','15:35:00',2.96),('325','2013-09-28','15:40:00',2.88),('325','2013-09-28','15:45:00',2.93),('325','2013-09-28','15:50:00',2.56),('325','2013-09-28','15:55:00',2.44),('325','2013-09-28','16:00:00',2.65),('325','2013-09-28','16:05:00',2.59),('325','2013-09-28','16:10:00',2.47),('325','2013-09-28','16:15:00',1.96),('325','2013-09-28','16:20:00',1.69),('325','2013-09-28','16:25:00',1.95),('325','2013-09-28','16:30:00',1.92),('325','2013-09-28','16:35:00',1.94),('325','2013-09-28','16:40:00',1.83),('325','2013-09-28','16:45:00',1.73),('325','2013-09-28','16:50:00',1.65),('325','2013-09-28','16:55:00',1.55),('325','2013-09-28','17:00:00',1.47),('325','2013-09-28','17:05:00',1.35),('325','2013-09-28','17:10:00',1.26),('325','2013-09-28','17:15:00',1.17),('325','2013-09-28','17:20:00',1.08),('325','2013-09-28','17:25:00',1),('325','2014-04-13','09:05:00',1.25),('325','2014-04-13','09:10:00',1.38),('325','2014-04-13','09:15:00',1.23),('325','2014-04-13','09:20:00',1.33),('325','2014-04-13','09:25:00',1.48),('325','2014-04-13','09:30:00',1.91),('325','2014-04-13','09:35:00',1.69),('325','2014-04-13','09:40:00',2.06),('325','2014-04-13','09:45:00',1.74),('325','2014-04-13','09:50:00',1.42),('325','2014-04-13','09:55:00',1.49),('325','2014-04-13','10:00:00',2.43),('325','2014-04-13','10:05:00',2.87),('325','2014-04-13','10:10:00',2.59),('325','2014-04-13','10:15:00',2.52),('325','2014-04-13','10:20:00',2.79),('325','2014-04-13','10:25:00',2.04),('325','2014-04-13','10:30:00',3.49),('325','2014-04-13','10:35:00',3.62),('325','2014-04-13','10:40:00',3.66),('325','2014-04-13','10:45:00',3.67),('325','2014-04-13','10:50:00',3.86),('325','2014-04-13','10:55:00',3.91),('325','2014-04-13','11:00:00',3.74),('325','2014-04-13','11:05:00',4.01),('325','2014-04-13','11:10:00',3.96),('325','2014-04-13','11:15:00',4.16),('325','2014-04-13','11:20:00',4.93),('325','2014-04-13','11:25:00',2.8),('325','2014-04-13','11:30:00',2.42),('325','2014-04-13','11:35:00',3.13),('325','2014-04-13','11:40:00',4.09),('325','2014-04-13','11:45:00',4.12),('325','2014-04-13','11:50:00',3.95),('325','2014-04-13','11:55:00',2.7),('325','2014-04-13','12:00:00',2.27),('325','2014-04-13','12:05:00',1.76),('325','2014-04-13','12:10:00',1.55),('325','2014-04-13','12:15:00',1.49),('325','2014-04-13','12:20:00',1.41),('325','2014-04-13','12:25:00',1.04),('325','2014-04-13','13:05:00',1.39),('325','2014-04-13','13:10:00',2.09),('325','2014-04-13','13:15:00',2.18),('325','2014-04-13','13:20:00',3.37),('325','2014-04-13','13:25:00',3.86),('325','2014-04-13','13:30:00',4.89),('325','2014-04-13','13:35:00',4.49),('325','2014-04-13','13:40:00',3.64),('325','2014-04-13','13:45:00',2.15),('325','2014-04-13','13:50:00',3.32),('325','2014-04-13','13:55:00',3.05),('325','2014-04-13','14:00:00',4.73),('325','2014-04-13','14:05:00',4.13),('325','2014-04-13','14:10:00',4.03),('325','2014-04-13','14:15:00',5.05),('325','2014-04-13','14:20:00',2.07),('325','2014-04-13','14:25:00',1.8),('325','2014-04-13','14:30:00',1.84),('325','2014-04-13','14:35:00',1.74),('325','2014-04-13','14:40:00',1.53),('325','2014-04-13','14:45:00',2.76),('325','2014-04-13','14:50:00',4.6),('325','2014-04-13','14:55:00',4.47),('325','2014-04-13','15:00:00',3.46),('325','2014-04-13','15:05:00',4.14),('325','2014-04-13','15:10:00',4.21),('325','2014-04-13','15:15:00',3.56),('325','2014-04-13','15:20:00',3.54),('325','2014-04-13','15:25:00',3.91),('325','2014-04-13','15:30:00',3.56),('325','2014-04-13','15:35:00',2.41),('325','2014-04-13','15:40:00',1.6),('325','2014-04-13','15:45:00',1.63),('325','2014-04-13','15:50:00',2.22),('325','2014-04-13','15:55:00',2.04),('325','2014-04-13','16:00:00',3.63),('325','2014-04-13','16:05:00',2.81),('325','2014-04-13','16:10:00',1.26),('325','2014-04-13','16:15:00',1.51),('325','2014-04-13','16:20:00',1.46),('325','2014-04-13','16:25:00',1.91),('325','2014-04-13','16:30:00',1.44),('325','2014-04-13','16:35:00',1.54),('325','2014-04-13','16:40:00',2.97),('325','2014-04-13','16:45:00',2.79),('325','2014-04-13','16:50:00',2.66),('325','2014-04-13','16:55:00',2.26),('325','2014-04-13','17:00:00',1.75),('325','2014-04-13','17:05:00',1.69),('325','2014-04-13','17:10:00',1.07),('325','2014-04-13','17:15:00',1.09),('325','2014-04-13','17:20:00',1.65),('325','2014-04-13','17:25:00',1.44),('325','2014-04-13','17:50:00',1.02),('325','2014-04-13','17:55:00',1.1),('325','2014-04-13','18:00:00',1.01),('325','2014-04-13','18:05:00',1.16),('325','2013-09-27','08:55:00',1.18),('325','2013-09-27','09:00:00',1.12),('325','2013-09-27','09:15:00',1),('325','2013-09-27','09:50:00',1.82),('325','2013-09-27','09:55:00',1.72),('325','2013-09-27','10:00:00',1.89),('325','2013-09-27','10:05:00',1.45),('325','2013-09-27','10:10:00',1.9),('325','2013-09-27','10:15:00',1.55),('325','2013-09-27','10:20:00',2.12),('325','2013-09-27','10:25:00',1.46),('325','2013-09-27','10:30:00',1.33),('325','2013-09-27','10:35:00',1.14),('325','2013-09-27','10:40:00',1.19),('325','2013-09-27','10:45:00',1.13),('325','2013-09-27','10:50:00',1.88),('325','2013-09-27','10:55:00',3.04),('325','2013-09-27','11:00:00',3.05),('325','2013-09-27','11:05:00',2.4),('325','2013-09-27','11:10:00',2.69),('325','2013-09-27','11:15:00',2.53),('325','2013-09-27','11:20:00',3.45),('325','2013-09-27','11:25:00',2.51),('325','2013-09-27','11:30:00',1.98),('325','2013-09-27','11:35:00',1.15),('325','2013-09-27','11:40:00',1.15),('325','2013-09-27','11:45:00',1.25),('325','2013-09-27','11:50:00',1.45),('325','2013-09-27','11:55:00',2.53),('325','2013-09-27','12:00:00',3.02),('325','2013-09-27','12:05:00',2.05),('325','2013-09-27','12:10:00',3.41),('325','2013-09-27','12:40:00',1.79),('325','2013-09-27','12:45:00',2.54),('325','2013-09-27','12:50:00',3.88),('325','2013-09-27','12:55:00',3.91),('325','2013-09-27','13:00:00',3.73),('325','2013-09-27','13:05:00',2.95),('325','2013-09-27','13:10:00',3.36),('325','2013-09-27','13:15:00',1.6),('325','2013-09-27','13:20:00',1.98),('325','2013-09-27','13:25:00',1.18),('325','2013-09-27','13:40:00',3.08),('325','2013-09-27','13:45:00',1.04),('325','2013-09-27','13:50:00',1.14),('325','2013-09-27','13:55:00',1.74),('325','2013-09-27','14:00:00',3.98),('325','2013-09-27','14:05:00',3.59),('325','2013-09-27','14:10:00',3.94),('325','2013-09-27','14:15:00',3.92),('325','2013-09-27','14:20:00',3.87),('325','2013-09-27','14:25:00',3.28),('325','2013-09-27','14:30:00',3.57),('325','2013-09-27','14:35:00',3.66),('325','2013-09-27','14:40:00',3.63),('325','2013-09-27','14:45:00',3.51),('325','2013-09-27','14:50:00',3.37),('325','2013-09-27','14:55:00',3.36),('325','2013-09-27','15:00:00',2.9),('325','2013-09-27','15:05:00',1.67),('325','2013-09-27','15:10:00',3.32),('325','2013-09-27','15:15:00',3.13),('325','2013-09-27','15:20:00',2.8),('325','2013-09-27','15:25:00',2.62),('325','2013-09-27','15:30:00',3.13),('325','2013-09-27','15:35:00',3.05),('325','2013-09-27','15:40:00',1.35),('325','2013-09-27','15:45:00',2.22),('325','2013-09-27','15:50:00',2.98),('325','2013-09-27','15:55:00',2.72),('325','2013-09-27','16:00:00',1.91),('325','2013-09-27','16:05:00',1.21),('325','2013-09-27','16:10:00',1.58),('325','2013-09-27','16:15:00',2.21),('325','2013-09-27','16:20:00',2.3),('325','2013-09-27','16:25:00',1.78),('325','2013-09-27','16:30:00',2.09),('325','2013-09-27','16:35:00',1.97),('325','2013-09-27','16:40:00',1.88),('325','2013-09-27','16:45:00',1.84),('325','2013-09-27','16:50:00',1.65),('325','2013-09-27','16:55:00',1.07),('325','2013-09-27','17:10:00',1.47),('325','2013-09-27','17:15:00',1.34),('325','2013-09-27','17:20:00',1.18),('325','2013-09-27','17:25:00',1.08),('325','2013-09-26','09:00:00',1.02),('325','2013-09-26','09:05:00',1.07),('325','2013-09-26','09:10:00',1.11),('325','2013-09-26','09:15:00',1.16),('325','2013-09-26','09:20:00',1.21),('325','2013-09-26','09:25:00',1.25),('325','2013-09-26','09:30:00',1.3),('325','2013-09-26','09:35:00',1.34),('325','2013-09-26','09:40:00',1.38),('325','2013-09-26','09:45:00',1.43),('325','2013-09-26','09:50:00',1.47),('325','2013-09-26','09:55:00',1.51),('325','2013-09-26','10:00:00',1.59),('325','2013-09-26','10:05:00',2.3),('325','2013-09-26','10:10:00',2.34),('325','2013-09-26','10:15:00',2.54),('325','2013-09-26','10:20:00',2.72),('325','2013-09-26','10:25:00',2.79),('325','2013-09-26','10:30:00',2.92),('325','2013-09-26','10:35:00',2.99),('325','2013-09-26','10:40:00',3.03),('325','2013-09-26','10:45:00',3.07),('325','2013-09-26','10:50:00',3.15),('325','2013-09-26','10:55:00',3.2),('325','2013-09-26','11:00:00',3.22),('325','2013-09-26','11:05:00',3.32),('325','2013-09-26','11:10:00',3.35),('325','2013-09-26','11:15:00',3.35),('325','2013-09-26','11:20:00',3.3),('325','2013-09-26','11:25:00',3.33),('325','2013-09-26','11:30:00',2.44),('325','2013-09-26','11:35:00',2.84),('325','2013-09-26','11:40:00',3.64),('325','2013-09-26','11:45:00',3.57),('325','2013-09-26','11:50:00',3.91),('325','2013-09-26','11:55:00',3.98),('325','2013-09-26','12:00:00',3.72),('325','2013-09-26','12:05:00',4),('325','2013-09-26','12:10:00',1.25),('325','2013-09-26','12:15:00',1.41),('325','2013-09-26','12:20:00',1.79),('325','2013-09-26','12:25:00',1.29),('325','2013-09-26','12:30:00',1.49),('325','2013-09-26','12:35:00',1.81),('325','2013-09-26','12:40:00',1.64),('325','2013-09-26','12:45:00',1.64),('325','2013-09-26','12:50:00',1.72),('325','2013-09-26','12:55:00',3.93),('325','2013-09-26','13:00:00',2.84),('325','2013-09-26','13:05:00',2.29),('325','2013-09-26','13:10:00',2.76),('325','2013-09-26','13:15:00',4.41),('325','2013-09-26','13:20:00',4.38),('325','2013-09-26','13:25:00',2.69),('325','2013-09-26','13:30:00',2.82),('325','2013-09-26','13:35:00',2.07),('325','2013-09-26','13:40:00',1.69),('325','2013-09-26','13:45:00',1.52),('325','2013-09-26','13:50:00',2.14),('325','2013-09-26','13:55:00',2.23),('325','2013-09-26','14:00:00',2.76),('325','2013-09-26','14:05:00',4.19),('325','2013-09-26','14:10:00',3.43),('325','2013-09-26','14:15:00',3.01),('325','2013-09-26','14:20:00',1.32),('325','2013-09-26','14:30:00',1.91),('325','2013-09-26','14:35:00',1.1),('325','2013-09-26','14:40:00',2.76),('325','2013-09-26','14:45:00',4.14),('325','2013-09-26','14:50:00',3.1),('325','2013-09-26','14:55:00',1.47),('325','2013-09-26','15:00:00',1.3),('325','2013-09-26','15:05:00',1.83),('325','2013-09-26','15:10:00',1.09),('325','2013-09-26','15:15:00',1.13),('325','2013-09-26','15:20:00',2.97),('325','2013-09-26','15:25:00',1.02),('325','2013-09-26','15:35:00',2.27),('325','2013-09-26','15:40:00',1.03),('325','2013-09-26','15:45:00',1.12),('325','2013-09-26','15:50:00',2.54),('325','2013-09-26','15:55:00',2.8),('325','2013-09-26','16:00:00',2.49),('325','2013-09-26','16:05:00',1.16),('325','2013-09-26','16:10:00',2.29),('325','2013-09-26','16:15:00',2.39),('325','2013-09-26','16:20:00',2.33),('325','2013-09-26','16:25:00',2.26),('325','2013-09-26','16:30:00',2.13),('325','2013-09-26','16:35:00',2.04),('325','2013-09-26','16:40:00',1.93),('325','2013-09-26','16:45:00',1.83),('325','2013-09-26','16:50:00',1.74),('325','2013-09-26','16:55:00',1.66),('325','2013-09-26','17:00:00',1.52),('325','2013-09-26','17:05:00',1.43),('325','2013-09-26','17:10:00',1.39),('325','2013-09-26','17:15:00',1.06),('325','2013-09-26','17:20:00',1.18),('325','2013-09-26','17:25:00',1.09),('325','2013-09-26','17:30:00',1.04),('325','2013-09-25','09:05:00',1.42),('325','2013-09-25','09:10:00',1.7),('325','2013-09-25','09:15:00',1.01),('325','2013-09-25','09:20:00',1.05),('325','2013-09-25','09:25:00',1.54),('325','2013-09-25','09:30:00',1.16),('325','2013-09-25','09:35:00',1.58),('325','2013-09-25','09:40:00',1.63),('325','2013-09-25','09:50:00',1.36),('325','2013-09-25','09:55:00',1.09),('325','2013-09-25','10:00:00',1.63),('325','2013-09-25','10:10:00',1),('325','2013-09-25','10:20:00',1.58),('325','2013-09-25','10:25:00',1.5),('325','2013-09-25','10:30:00',1.76),('325','2013-09-25','10:35:00',1.4),('325','2013-09-25','10:40:00',2.12),('325','2013-09-25','10:45:00',3.8),('325','2013-09-25','10:50:00',3.63),('325','2013-09-25','10:55:00',3.23),('325','2013-09-25','11:00:00',1.72),('325','2013-09-25','11:10:00',1.05),('325','2013-09-25','11:15:00',3.51),('325','2013-09-25','11:20:00',3.55),('325','2013-09-25','11:25:00',3.57),('325','2013-09-25','11:30:00',3.63),('325','2013-09-25','11:35:00',3.57),('325','2013-09-25','11:40:00',3.17),('325','2013-09-25','11:45:00',2.03),('325','2013-09-25','11:50:00',1.01),('325','2013-09-25','12:10:00',2.68),('325','2013-09-25','12:15:00',3.66),('325','2013-09-25','12:20:00',1.62),('325','2013-09-25','12:25:00',2.52),('325','2013-09-25','12:30:00',4.46),('325','2013-09-25','12:35:00',3.34),('325','2013-09-25','12:40:00',1.06),('325','2013-09-25','12:45:00',2.94),('325','2013-09-25','12:50:00',2.61),('325','2013-09-25','12:55:00',1.22),('325','2013-09-25','13:00:00',3.05),('325','2013-09-25','13:10:00',1.78),('325','2013-09-25','13:15:00',1.67),('325','2013-09-25','13:20:00',1.56),('325','2013-09-25','13:25:00',2.49),('325','2013-09-25','13:30:00',2.01),('325','2013-09-25','13:35:00',4.77),('325','2013-09-25','13:40:00',4.61),('325','2013-09-25','13:45:00',4.57),('325','2013-09-25','13:50:00',4.05),('325','2013-09-25','13:55:00',1.33),('325','2013-09-25','14:05:00',1.17),('325','2013-09-25','14:10:00',1.14),('325','2013-09-25','14:15:00',1.01),('325','2013-09-25','14:20:00',1.28),('325','2013-09-25','14:25:00',1.52),('325','2013-09-25','14:30:00',2.68),('325','2013-09-25','14:35:00',3.56),('325','2013-09-25','14:40:00',3.6),('325','2013-09-25','14:45:00',1.94),('325','2013-09-25','14:50:00',3.5),('325','2013-09-25','14:55:00',3.37),('325','2013-09-25','15:00:00',3.94),('325','2013-09-25','15:05:00',3.72),('325','2013-09-25','15:10:00',3.51),('325','2013-09-25','15:15:00',2.78),('325','2013-09-25','15:20:00',3.46),('325','2013-09-25','15:25:00',3.27),('325','2013-09-25','15:30:00',3.34),('325','2013-09-25','15:35:00',3.43),('325','2013-09-25','15:40:00',3.28),('325','2013-09-25','15:45:00',3),('325','2013-09-25','15:50:00',3.03),('325','2013-09-25','15:55:00',2.99),('325','2013-09-25','16:00:00',2.91),('325','2013-09-25','16:05:00',2.76),('325','2013-09-25','16:10:00',2.67),('325','2013-09-25','16:15:00',2.58),('325','2013-09-25','16:20:00',2.13),('325','2013-09-25','16:25:00',1.79),('325','2013-09-25','16:30:00',2.34),('325','2013-09-25','16:35:00',2.07),('325','2013-09-25','16:40:00',2.01),('325','2013-09-25','16:45:00',1.98),('325','2013-09-25','16:50:00',1.88),('325','2013-09-25','16:55:00',1.78),('325','2013-09-25','17:00:00',1.7),('325','2013-09-25','17:05:00',1.57),('325','2013-09-25','17:10:00',1.48),('325','2013-09-25','17:15:00',1.37),('325','2013-09-25','17:20:00',1.27),('325','2013-09-25','17:25:00',1.18),('325','2013-09-25','17:30:00',1.09),('325','2013-09-24','09:00:00',1.02),('325','2013-09-24','09:05:00',1.07),('325','2013-09-24','09:10:00',1.12),('325','2013-09-24','09:15:00',1.17),('325','2013-09-24','09:20:00',1.21),('325','2013-09-24','09:25:00',1.27),('325','2013-09-24','09:30:00',1.31),('325','2013-09-24','09:35:00',1.36),('325','2013-09-24','09:40:00',1.39),('325','2013-09-24','09:45:00',1.44),('325','2013-09-24','09:50:00',1.47),('325','2013-09-24','09:55:00',1.75),('325','2013-09-24','10:00:00',2.58),('325','2013-09-24','10:05:00',2.68),('325','2013-09-24','10:10:00',2.74),('325','2013-09-24','10:15:00',2.85),('325','2013-09-24','10:20:00',2.94),('325','2013-09-24','10:25:00',3.05),('325','2013-09-24','10:30:00',3.12),('325','2013-09-24','10:35:00',3.17),('325','2013-09-24','10:40:00',3.23),('325','2013-09-24','10:45:00',3.3),('325','2013-09-24','10:50:00',3.39),('325','2013-09-24','10:55:00',3.45),('325','2013-09-24','11:00:00',3.49),('325','2013-09-24','11:05:00',3.52),('325','2013-09-24','11:10:00',3.54),('325','2013-09-24','11:15:00',3.57),('325','2013-09-24','11:20:00',3.61),('325','2013-09-24','11:25:00',3.68),('325','2013-09-24','11:30:00',3.68),('325','2013-09-24','11:35:00',3.68),('325','2013-09-24','11:40:00',3.7),('325','2013-09-24','11:45:00',3.76),('325','2013-09-24','11:50:00',3.84),('325','2013-09-24','11:55:00',3.82),('325','2013-09-24','12:00:00',3.84),('325','2013-09-24','12:05:00',3.87),('325','2013-09-24','12:10:00',3.91),('325','2013-09-24','12:15:00',3.91),('325','2013-09-24','12:20:00',3.92),('325','2013-09-24','12:25:00',3.95),('325','2013-09-24','12:30:00',4),('325','2013-09-24','12:35:00',4.01),('325','2013-09-24','12:40:00',4.03),('325','2013-09-24','12:45:00',4.02),('325','2013-09-24','12:50:00',4.01),('325','2013-09-24','12:55:00',4.02),('325','2013-09-24','13:00:00',4.04),('325','2013-09-24','13:05:00',4.05),('325','2013-09-24','13:10:00',4.06),('325','2013-09-24','13:15:00',4.02),('325','2013-09-24','13:20:00',4.02),('325','2013-09-24','13:25:00',3.98),('325','2013-09-24','13:30:00',4.02),('325','2013-09-24','13:35:00',3.99),('325','2013-09-24','13:40:00',4.03),('325','2013-09-24','13:45:00',3.95),('325','2013-09-24','13:50:00',3.93),('325','2013-09-24','13:55:00',3.91),('325','2013-09-24','14:00:00',3.93),('325','2013-09-24','14:05:00',3.89),('325','2013-09-24','14:10:00',3.89),('325','2013-09-24','14:15:00',3.84),('325','2013-09-24','14:20:00',3.8),('325','2013-09-24','14:25:00',3.78),('325','2013-09-24','14:30:00',3.74),('325','2013-09-24','14:35:00',3.72),('325','2013-09-24','14:40:00',3.69),('325','2013-09-24','14:45:00',3.62),('325','2013-09-24','14:50:00',3.59),('325','2013-09-24','14:55:00',3.55),('325','2013-09-24','15:00:00',3.51),('325','2013-09-24','15:05:00',3.45),('325','2013-09-24','15:10:00',3.42),('325','2013-09-24','15:15:00',3.35),('325','2013-09-24','15:20:00',3.33),('325','2013-09-24','15:25:00',3.27),('325','2013-09-24','15:30:00',3.21),('325','2013-09-24','15:35:00',3.16),('325','2013-09-24','15:40:00',3.09),('325','2013-09-24','15:45:00',3.05),('325','2013-09-24','15:50:00',2.96),('325','2013-09-24','15:55:00',2.89),('325','2013-09-24','16:00:00',2.82),('325','2013-09-24','16:05:00',2.73),('325','2013-09-24','16:10:00',2.66),('325','2013-09-24','16:15:00',2.6),('325','2013-09-24','16:20:00',2.5),('325','2013-09-24','16:25:00',2.36),('325','2013-09-24','16:30:00',2.27),('325','2013-09-24','16:35:00',2.19),('325','2013-09-24','16:40:00',2.12),('325','2013-09-24','16:45:00',2.03),('325','2013-09-24','16:50:00',1.96),('325','2013-09-24','16:55:00',1.85),('325','2013-09-24','17:00:00',1.74),('325','2013-09-24','17:05:00',1.63),('325','2013-09-24','17:10:00',1.52),('325','2013-09-24','17:15:00',1.43),('325','2013-09-24','17:20:00',1.32),('325','2013-09-24','17:25:00',1.22),('325','2013-09-24','17:30:00',1.09),('325','2013-09-23','09:00:00',1.04),('325','2013-09-23','09:05:00',1.09),('325','2013-09-23','09:10:00',1.14),('325','2013-09-23','09:15:00',1.19),('325','2013-09-23','09:20:00',1.24),('325','2013-09-23','09:25:00',1.28),('325','2013-09-23','09:30:00',1.33),('325','2013-09-23','09:35:00',1.37),('325','2013-09-23','09:40:00',1.41),('325','2013-09-23','09:45:00',1.45),('325','2013-09-23','09:50:00',1.49),('325','2013-09-23','09:55:00',1.54),('325','2013-09-23','10:00:00',1.59),('325','2013-09-23','10:05:00',2.4),('325','2013-09-23','10:10:00',2.78),('325','2013-09-23','10:15:00',2.89),('325','2013-09-23','10:20:00',2.97),('325','2013-09-23','10:25:00',3.08),('325','2013-09-23','10:30:00',3.16),('325','2013-09-23','10:35:00',3.22),('325','2013-09-23','10:40:00',3.31),('325','2013-09-23','10:45:00',3.38),('325','2013-09-23','10:50:00',3.45),('325','2013-09-23','10:55:00',3.52),('325','2013-09-23','11:00:00',3.54),('325','2013-09-23','11:05:00',3.58),('325','2013-09-23','11:10:00',3.62),('325','2013-09-23','11:15:00',3.71),('325','2013-09-23','11:20:00',3.76),('325','2013-09-23','11:25:00',3.79),('325','2013-09-23','11:30:00',3.82),('325','2013-09-23','11:35:00',3.86),('325','2013-09-23','11:40:00',3.88),('325','2013-09-23','11:45:00',3.94),('325','2013-09-23','11:50:00',4),('325','2013-09-23','11:55:00',4.03),('325','2013-09-23','12:00:00',4.05),('325','2013-09-23','12:05:00',4.07),('325','2013-09-23','12:10:00',4.09),('325','2013-09-23','12:15:00',4.11),('325','2013-09-23','12:20:00',4.12),('325','2013-09-23','12:25:00',4.14),('325','2013-09-23','12:30:00',4.13),('325','2013-09-23','12:35:00',4.12),('325','2013-09-23','12:40:00',4.13),('325','2013-09-23','12:45:00',4.12),('325','2013-09-23','12:50:00',4.1),('325','2013-09-23','12:55:00',4.08),('325','2013-09-23','13:00:00',4.1),('325','2013-09-23','13:05:00',4.09),('325','2013-09-23','13:10:00',4.05),('325','2013-09-23','13:15:00',4.02),('325','2013-09-23','13:20:00',4.04),('325','2013-09-23','13:25:00',3.95),('325','2013-09-23','13:30:00',3.97),('325','2013-09-23','13:35:00',3.99),('325','2013-09-23','13:40:00',4),('325','2013-09-23','13:45:00',4),('325','2013-09-23','13:50:00',3.96),('325','2013-09-23','13:55:00',3.95),('325','2013-09-23','14:00:00',3.91),('325','2013-09-23','14:05:00',3.85),('325','2013-09-23','14:10:00',3.81),('325','2013-09-23','14:15:00',3.87),('325','2013-09-23','14:20:00',3.82),('325','2013-09-23','14:25:00',3.78),('325','2013-09-23','14:30:00',3.78),('325','2013-09-23','14:35:00',3.69),('325','2013-09-23','14:40:00',3.61),('325','2013-09-23','14:45:00',3.6),('325','2013-09-23','14:50:00',3.39),('325','2013-09-23','14:55:00',3.38),('325','2013-09-23','15:00:00',3.54),('325','2013-09-23','15:05:00',3.53),('325','2013-09-23','15:10:00',2.74),('325','2013-09-23','15:15:00',2.41),('325','2013-09-23','15:20:00',2.71),('325','2013-09-23','15:25:00',2.46),('325','2013-09-23','15:30:00',3.2),('325','2013-09-23','15:35:00',3.16),('325','2013-09-23','15:40:00',3.11),('325','2013-09-23','15:45:00',3.02),('325','2013-09-23','15:50:00',2.93),('325','2013-09-23','15:55:00',2.84),('325','2013-09-23','16:00:00',2.74),('325','2013-09-23','16:05:00',2.69),('325','2013-09-23','16:10:00',2.62),('325','2013-09-23','16:15:00',2.55),('325','2013-09-23','16:20:00',2.47),('325','2013-09-23','16:25:00',2.33),('325','2013-09-23','16:30:00',2.17),('325','2013-09-23','16:35:00',1.97),('325','2013-09-23','16:40:00',2.03),('325','2013-09-23','16:45:00',1.98),('325','2013-09-23','16:50:00',1.86),('325','2013-09-23','16:55:00',1.78),('325','2013-09-23','17:00:00',1.69),('325','2013-09-23','17:05:00',1.57),('325','2013-09-23','17:10:00',1.48),('325','2013-09-23','17:15:00',1.4),('325','2013-09-23','17:20:00',1.3),('325','2013-09-23','17:25:00',1.21),('325','2013-09-23','17:30:00',1.12),('325','2013-09-23','17:35:00',1.03),('325','2013-09-22','09:00:00',1.04),('325','2013-09-22','09:05:00',1.09),('325','2013-09-22','09:10:00',1.15),('325','2013-09-22','09:15:00',1.2),('325','2013-09-22','09:20:00',1.25),('325','2013-09-22','09:25:00',1.29),('325','2013-09-22','09:30:00',1.34),('325','2013-09-22','09:35:00',1.38),('325','2013-09-22','09:40:00',1.42),('325','2013-09-22','09:45:00',1.47),('325','2013-09-22','09:50:00',1.52),('325','2013-09-22','09:55:00',1.56),('325','2013-09-22','10:00:00',1.61),('325','2013-09-22','10:05:00',2.52),('325','2013-09-22','10:10:00',2.81),('325','2013-09-22','10:15:00',2.92),('325','2013-09-22','10:20:00',3.01),('325','2013-09-22','10:25:00',3.1),('325','2013-09-22','10:30:00',3.19),('325','2013-09-22','10:35:00',3.26),('325','2013-09-22','10:40:00',3.32),('325','2013-09-22','10:45:00',3.38),('325','2013-09-22','10:50:00',3.47),('325','2013-09-22','10:55:00',3.53),('325','2013-09-22','11:00:00',3.57),('325','2013-09-22','11:05:00',3.6),('325','2013-09-22','11:10:00',3.65),('325','2013-09-22','11:15:00',3.67),('325','2013-09-22','11:20:00',3.74),('325','2013-09-22','11:25:00',3.8),('325','2013-09-22','11:30:00',3.84),('325','2013-09-22','11:35:00',3.89),('325','2013-09-22','11:40:00',3.92),('325','2013-09-22','11:45:00',3.98),('325','2013-09-22','11:50:00',4.05),('325','2013-09-22','11:55:00',4.07),('325','2013-09-22','12:00:00',4.1),('325','2013-09-22','12:05:00',4.13),('325','2013-09-22','12:10:00',4.13),('325','2013-09-22','12:15:00',4.15),('325','2013-09-22','12:20:00',4.17),('325','2013-09-22','12:25:00',4.2),('325','2013-09-22','12:30:00',4.2),('325','2013-09-22','12:35:00',4.2),('325','2013-09-22','12:40:00',4.22),('325','2013-09-22','12:45:00',4.22),('325','2013-09-22','12:50:00',4.23),('325','2013-09-22','12:55:00',4.25),('325','2013-09-22','13:00:00',4.22),('325','2013-09-22','13:05:00',4.2),('325','2013-09-22','13:10:00',4.22),('325','2013-09-22','13:15:00',4.21),('325','2013-09-22','13:20:00',4.18),('325','2013-09-22','13:25:00',4.14),('325','2013-09-22','13:30:00',4.15),('325','2013-09-22','13:35:00',4.13),('325','2013-09-22','13:40:00',4.07),('325','2013-09-22','13:45:00',4.1),('325','2013-09-22','13:50:00',4.1),('325','2013-09-22','13:55:00',4.09),('325','2013-09-22','14:00:00',4.06),('325','2013-09-22','14:05:00',4.08),('325','2013-09-22','14:10:00',3.89),('325','2013-09-22','14:15:00',3.84),('325','2013-09-22','14:20:00',3.8),('325','2013-09-22','14:25:00',3.84),('325','2013-09-22','14:30:00',1.18),('325','2013-09-22','14:35:00',3.82),('325','2013-09-22','14:40:00',3.97),('325','2013-09-22','14:45:00',3.2),('325','2013-09-22','14:50:00',3.78),('325','2013-09-22','14:55:00',3.73),('325','2013-09-22','15:00:00',3.77),('325','2013-09-22','15:05:00',3.82),('325','2013-09-22','15:10:00',3.7),('325','2013-09-22','15:15:00',3.86),('325','2013-09-22','15:20:00',4.01),('325','2013-09-22','15:25:00',2.03),('325','2013-09-22','15:30:00',1.41),('325','2013-09-22','15:35:00',1.24),('325','2013-09-22','15:40:00',3.41),('325','2013-09-22','15:45:00',3.26),('325','2013-09-22','15:50:00',3.07),('325','2013-09-22','15:55:00',3.05),('325','2013-09-22','16:00:00',3.2),('325','2013-09-22','16:05:00',3.22),('325','2013-09-22','16:10:00',3.46),('325','2013-09-22','16:15:00',2.93),('325','2013-09-22','16:20:00',2.13),('325','2013-09-22','16:25:00',1.45),('325','2013-09-22','16:30:00',1.68),('325','2013-09-22','16:35:00',1.33),('325','2013-09-22','16:40:00',1.06),('325','2013-09-22','16:45:00',1.68),('325','2013-09-22','16:50:00',2.31),('325','2013-09-22','16:55:00',1.68),('325','2013-09-22','17:00:00',1.79),('325','2013-09-22','17:05:00',1.9),('325','2013-09-22','17:10:00',1.61),('325','2013-09-21','09:00:00',1.04),('325','2013-09-21','09:05:00',1.09),('325','2013-09-21','09:10:00',1.14),('325','2013-09-21','09:15:00',1.18),('325','2013-09-21','09:20:00',1.23),('325','2013-09-21','09:25:00',1.27),('325','2013-09-21','09:30:00',1.32),('325','2013-09-21','09:35:00',1.36),('325','2013-09-21','09:40:00',1.39),('325','2013-09-21','09:45:00',1.44),('325','2013-09-21','09:50:00',1.49),('325','2013-09-21','09:55:00',1.53),('325','2013-09-21','10:00:00',1.74),('325','2013-09-21','10:05:00',2.66),('325','2013-09-21','10:10:00',2.74),('325','2013-09-21','10:15:00',2.84),('325','2013-09-21','10:20:00',2.94),('325','2013-09-21','10:25:00',3.05),('325','2013-09-21','10:30:00',3.13),('325','2013-09-21','10:35:00',3.19),('325','2013-09-21','10:40:00',3.26),('325','2013-09-21','10:45:00',3.32),('325','2013-09-21','10:50:00',3.4),('325','2013-09-21','10:55:00',3.47),('325','2013-09-21','11:00:00',3.52),('325','2013-09-21','11:05:00',3.55),('325','2013-09-21','11:10:00',3.57),('325','2013-09-21','11:15:00',3.62),('325','2013-09-21','11:20:00',3.67),('325','2013-09-21','11:25:00',3.71),('325','2013-09-21','11:30:00',3.73),('325','2013-09-21','11:35:00',3.8),('325','2013-09-21','11:40:00',3.83),('325','2013-09-21','11:45:00',3.87),('325','2013-09-21','11:50:00',3.94),('325','2013-09-21','11:55:00',3.88),('325','2013-09-21','12:00:00',3.96),('325','2013-09-21','12:05:00',4.03),('325','2013-09-21','12:10:00',4.03),('325','2013-09-21','12:15:00',4.08),('325','2013-09-21','12:20:00',3.9),('325','2013-09-21','12:25:00',3.8),('325','2013-09-21','12:30:00',4.16),('325','2013-09-21','12:35:00',4.06),('325','2013-09-21','12:40:00',3.91),('325','2013-09-21','12:45:00',4),('325','2013-09-21','12:50:00',4.06),('325','2013-09-21','12:55:00',4.13),('325','2013-09-21','13:00:00',4.13),('325','2013-09-21','13:05:00',4.03),('325','2013-09-21','13:10:00',4.11),('325','2013-09-21','13:15:00',4.2),('325','2013-09-21','13:20:00',3.43),('325','2013-09-21','13:25:00',3.92),('325','2013-09-21','13:30:00',3.94),('325','2013-09-21','13:35:00',3.95),('325','2013-09-21','13:40:00',3.48),('325','2013-09-21','13:45:00',3.5),('325','2013-09-21','13:50:00',3.6),('325','2013-09-21','13:55:00',3.51),('325','2013-09-21','14:00:00',3.79),('325','2013-09-21','14:05:00',3.89),('325','2013-09-21','14:10:00',3.76),('325','2013-09-21','14:15:00',3.9),('325','2013-09-21','14:20:00',3.88),('325','2013-09-21','14:25:00',3.84),('325','2013-09-21','14:30:00',3.78),('325','2013-09-21','14:35:00',3.72),('325','2013-09-21','14:40:00',3.69),('325','2013-09-21','14:45:00',3.62),('325','2013-09-21','14:50:00',3.6),('325','2013-09-21','14:55:00',3.55),('325','2013-09-21','15:00:00',3.51),('325','2013-09-21','15:05:00',3.48),('325','2013-09-21','15:10:00',3.36),('325','2013-09-21','15:15:00',3.31),('325','2013-09-21','15:20:00',3.32),('325','2013-09-21','15:25:00',3.24),('325','2013-09-21','15:30:00',3.18),('325','2013-09-21','15:35:00',3.12),('325','2013-09-21','15:40:00',2.78),('325','2013-09-21','15:45:00',2.06),('325','2013-09-21','15:50:00',2.95),('325','2013-09-21','15:55:00',2.75),('325','2013-09-21','16:00:00',2.09),('325','2013-09-21','16:05:00',1.44),('325','2013-09-21','16:10:00',1.73),('325','2013-09-21','16:15:00',1.57),('325','2013-09-21','16:20:00',1.73),('325','2013-09-21','16:30:00',1.31),('325','2013-09-21','16:35:00',1.52),('325','2013-09-21','16:40:00',1.06),('325','2013-09-21','16:55:00',1.22),('325','2013-09-21','17:05:00',1.09),('325','2013-09-21','17:15:00',1.08),('325','2013-09-21','17:40:00',1.01),('325','2013-09-20','08:40:00',1.09),('325','2013-09-20','08:45:00',1.1),('325','2013-09-20','09:00:00',1.01),('325','2013-09-20','09:05:00',1.11),('325','2013-09-20','09:15:00',1.11),('325','2013-09-20','09:20:00',1.22),('325','2013-09-20','09:25:00',1.27),('325','2013-09-20','09:30:00',1.13),('325','2013-09-20','09:35:00',1.17),('325','2013-09-20','09:40:00',1.21),('325','2013-09-20','09:45:00',1.34),('325','2013-09-20','09:50:00',1.31),('325','2013-09-20','09:55:00',1.47),('325','2013-09-20','10:00:00',1.68),('325','2013-09-20','10:05:00',1.82),('325','2013-09-20','10:10:00',1.99),('325','2013-09-20','10:15:00',2.99),('325','2013-09-20','10:20:00',2.24),('325','2013-09-20','10:25:00',1.93),('325','2013-09-20','10:30:00',1.91),('325','2013-09-20','10:35:00',2.3),('325','2013-09-20','10:40:00',2.41),('325','2013-09-20','10:45:00',2.39),('325','2013-09-20','10:50:00',2.61),('325','2013-09-20','10:55:00',2.16),('325','2013-09-20','11:00:00',1.94),('325','2013-09-20','11:05:00',2.04),('325','2013-09-20','11:10:00',2.18),('325','2013-09-20','11:15:00',2.37),('325','2013-09-20','11:20:00',2.76),('325','2013-09-20','11:25:00',2.42),('325','2013-09-20','11:30:00',2.98),('325','2013-09-20','11:35:00',3.24),('325','2013-09-20','11:40:00',3.37),('325','2013-09-20','11:45:00',4.33),('325','2013-09-20','11:50:00',4.23),('325','2013-09-20','11:55:00',4.12),('325','2013-09-20','12:00:00',4.07),('325','2013-09-20','12:05:00',4.08),('325','2013-09-20','12:10:00',4.13),('325','2013-09-20','12:15:00',4.21),('325','2013-09-20','12:20:00',4.29),('325','2013-09-20','12:25:00',3.33),('325','2013-09-20','12:30:00',3.96),('325','2013-09-20','12:35:00',2.61),('325','2013-09-20','12:40:00',4.23),('325','2013-09-20','12:45:00',3.01),('325','2013-09-20','12:50:00',4.37),('325','2013-09-20','12:55:00',4.2),('325','2013-09-20','13:00:00',3.11),('325','2013-09-20','13:05:00',4.14),('325','2013-09-20','13:10:00',3.83),('325','2013-09-20','13:15:00',2.76),('325','2013-09-20','13:20:00',4.1),('325','2013-09-20','13:25:00',2.83),('325','2013-09-20','13:30:00',3.79),('325','2013-09-20','13:35:00',3.48),('325','2013-09-20','13:40:00',3.71),('325','2013-09-20','13:45:00',4.17),('325','2013-09-20','13:50:00',3.92),('325','2013-09-20','13:55:00',3.69),('325','2013-09-20','14:00:00',4.07),('325','2013-09-20','14:05:00',3.1),('325','2013-09-20','14:10:00',1.66),('325','2013-09-20','14:15:00',3.02),('325','2013-09-20','14:20:00',3.56),('325','2013-09-20','14:25:00',4.14),('325','2013-09-20','14:30:00',3.82),('325','2013-09-20','14:35:00',3.08),('325','2013-09-20','14:40:00',3.91),('325','2013-09-20','14:45:00',3.9),('325','2013-09-20','14:50:00',3.84),('325','2013-09-20','14:55:00',3.83),('325','2013-09-20','15:00:00',3.45),('325','2013-09-20','15:05:00',4.01),('325','2013-09-20','15:10:00',2.14),('325','2013-09-20','15:15:00',1.85),('325','2013-09-20','15:20:00',1.89),('325','2013-09-20','15:30:00',1.34),('325','2013-09-20','15:35:00',3.03),('325','2013-09-20','15:40:00',3.45),('325','2013-09-20','15:45:00',3.22),('325','2013-09-20','15:50:00',3.2),('325','2013-09-20','15:55:00',3.25),('325','2013-09-20','16:00:00',3.4),('325','2013-09-20','16:05:00',2.34),('325','2013-09-20','16:10:00',1.68),('325','2013-09-20','16:15:00',2.31),('325','2013-09-20','16:20:00',2.04),('325','2013-09-20','16:25:00',1.29),('325','2013-09-20','16:30:00',1.02),('325','2013-09-20','16:45:00',1.31),('325','2013-09-20','16:50:00',1.98),('325','2013-09-20','16:55:00',2.38),('325','2013-09-20','17:00:00',2.18),('325','2013-09-20','17:05:00',2.28),('325','2013-09-20','17:10:00',2.32),('325','2013-09-20','17:15:00',2.07),('325','2013-09-20','17:20:00',2.08),('325','2013-09-20','17:25:00',1.84),('325','2013-09-20','17:30:00',1.53),('325','2013-09-20','17:35:00',1.35),('325','2013-09-20','17:40:00',1.34),('325','2013-09-20','17:45:00',1.24),('325','2013-09-20','17:50:00',1.1),('325','2013-09-20','17:55:00',1.04),('325','2013-09-20','18:00:00',1.03),('325','2013-09-20','18:05:00',1.03),('325','2013-09-19','09:10:00',1.44),('325','2013-09-19','09:15:00',1.4),('325','2013-09-19','09:20:00',1.16),('325','2013-09-19','10:05:00',2.28),('325','2013-09-19','10:10:00',1.72),('325','2013-09-19','10:20:00',1.03),('325','2013-09-19','10:25:00',1.15),('325','2013-09-19','10:30:00',1.26),('325','2013-09-19','10:35:00',2.6),('325','2013-09-19','10:40:00',2.19),('325','2013-09-19','10:45:00',2.33),('325','2013-09-19','10:50:00',1.58),('325','2013-09-19','10:55:00',3.92),('325','2013-09-19','11:00:00',3.16),('325','2013-09-19','11:05:00',2.71),('325','2013-09-19','11:10:00',2.5),('325','2013-09-19','11:15:00',1.73),('325','2013-09-19','11:20:00',2.37),('325','2013-09-19','11:25:00',3.18),('325','2013-09-19','11:30:00',3.38),('325','2013-09-19','11:35:00',4.25),('325','2013-09-19','11:40:00',2.41),('325','2013-09-19','11:45:00',3.65),('325','2013-09-19','11:50:00',3.6),('325','2013-09-19','11:55:00',4.02),('325','2013-09-19','12:00:00',3.16),('325','2013-09-19','12:05:00',2.39),('325','2013-09-19','12:10:00',3.07),('325','2013-09-19','12:15:00',2.34),('325','2013-09-19','12:20:00',4.49),('325','2013-09-19','12:25:00',4.46),('325','2013-09-19','12:30:00',4.47),('325','2013-09-19','12:35:00',4.41),('325','2013-09-19','12:40:00',3.8),('325','2013-09-19','12:45:00',2.89),('325','2013-09-19','12:50:00',4.63),('325','2013-09-19','12:55:00',4.54),('325','2013-09-19','13:00:00',4.54),('325','2013-09-19','13:05:00',4.63),('325','2013-09-19','13:10:00',4.81),('325','2013-09-19','13:15:00',4.77),('325','2013-09-19','13:20:00',3.78),('325','2013-09-19','13:25:00',3.34),('325','2013-09-19','13:30:00',4.44),('325','2013-09-19','13:35:00',4.5),('325','2013-09-19','13:40:00',4.8),('325','2013-09-19','13:45:00',4.87),('325','2013-09-19','13:50:00',3.38),('325','2013-09-19','13:55:00',1.37),('325','2013-09-19','14:00:00',1.61),('325','2013-09-19','14:05:00',4.47),('325','2013-09-19','14:10:00',4.27),('325','2013-09-19','14:15:00',4.18),('325','2013-09-19','14:20:00',4.09),('325','2013-09-19','14:25:00',3.99),('325','2013-09-19','14:30:00',4),('325','2013-09-19','14:35:00',3.98),('325','2013-09-19','14:40:00',3.8),('325','2013-09-19','14:45:00',3.71),('325','2013-09-19','14:50:00',3.57),('325','2013-09-19','14:55:00',3.91),('325','2013-09-19','15:00:00',3.5),('325','2013-09-19','15:05:00',3.21),('325','2013-09-19','15:10:00',2.94),('325','2013-09-19','15:15:00',2.88),('325','2013-09-19','15:20:00',3.64),('325','2013-09-19','15:25:00',3.19),('325','2013-09-19','15:30:00',1.84),('325','2013-09-19','15:35:00',2.39),('325','2013-09-19','15:40:00',3.42),('325','2013-09-19','15:45:00',3.4),('325','2013-09-19','15:50:00',3.18),('325','2013-09-19','15:55:00',2.86),('325','2013-09-19','16:00:00',2.97),('325','2013-09-19','16:05:00',2.9),('325','2013-09-19','16:10:00',2.24),('325','2013-09-19','16:15:00',2.71),('325','2013-09-19','16:20:00',2.81),('325','2013-09-19','16:25:00',2.05),('325','2013-09-19','16:30:00',2.26),('325','2013-09-19','16:35:00',2.04),('325','2013-09-19','16:40:00',1.01),('325','2013-09-19','16:45:00',1.65),('325','2013-09-19','16:50:00',1.68),('325','2013-09-19','16:55:00',2.15),('325','2013-09-19','17:00:00',1.74),('325','2013-09-19','17:05:00',1.79),('325','2013-09-19','17:10:00',1.65),('325','2013-09-19','17:15:00',1.57),('325','2013-09-19','17:20:00',1.36),('325','2013-09-19','17:25:00',1.28),('325','2013-09-19','17:30:00',1.2),('325','2013-09-19','17:35:00',1.03),('325','2013-09-18','08:55:00',1.25),('325','2013-09-18','09:00:00',1.3),('325','2013-09-18','09:05:00',1.12),('325','2013-09-18','09:15:00',1.28),('325','2013-09-18','09:20:00',1.79),('325','2013-09-18','09:25:00',1.62),('325','2013-09-18','09:35:00',1.63),('325','2013-09-18','09:40:00',1.48),('325','2013-09-18','09:50:00',1.02),('325','2013-09-18','09:55:00',1.61),('325','2013-09-18','10:00:00',1.74),('325','2013-09-18','10:05:00',1.97),('325','2013-09-18','10:10:00',1.91),('325','2013-09-18','10:15:00',1.81),('325','2013-09-18','10:20:00',1.84),('325','2013-09-18','10:25:00',1.88),('325','2013-09-18','10:30:00',1.93),('325','2013-09-18','10:35:00',3.11),('325','2013-09-18','10:40:00',3.17),('325','2013-09-18','10:45:00',3.23),('325','2013-09-18','10:50:00',3.04),('325','2013-09-18','10:55:00',3.53),('325','2013-09-18','11:00:00',3.61),('325','2013-09-18','11:05:00',3.75),('325','2013-09-18','11:10:00',3.82),('325','2013-09-18','11:15:00',2.96),('325','2013-09-18','11:20:00',3.73),('325','2013-09-18','11:25:00',3.96),('325','2013-09-18','11:30:00',3.29),('325','2013-09-18','11:35:00',4.21),('325','2013-09-18','11:40:00',3.35),('325','2013-09-18','11:45:00',4.02),('325','2013-09-18','11:50:00',4.08),('325','2013-09-18','11:55:00',4.1),('325','2013-09-18','12:00:00',4.12),('325','2013-09-18','12:05:00',4.29),('325','2013-09-18','12:10:00',4.33),('325','2013-09-18','12:15:00',4.41),('325','2013-09-18','12:20:00',3.71),('325','2013-09-18','12:25:00',1.4),('325','2013-09-18','12:30:00',3.05),('325','2013-09-18','12:35:00',4.55),('325','2013-09-18','12:40:00',2.28),('325','2013-09-18','12:45:00',4.1),('325','2013-09-18','12:50:00',4.38),('325','2013-09-18','12:55:00',3.48),('325','2013-09-18','13:00:00',1.73),('325','2013-09-18','13:05:00',4.66),('325','2013-09-18','13:10:00',4.52),('325','2013-09-18','13:15:00',4.43),('325','2013-09-18','13:20:00',4.36),('325','2013-09-18','13:25:00',4.41),('325','2013-09-18','13:30:00',4.35),('325','2013-09-18','13:35:00',4.33),('325','2013-09-18','13:40:00',4.36),('325','2013-09-18','13:45:00',3.03),('325','2013-09-18','13:50:00',4.07),('325','2013-09-18','13:55:00',4.34),('325','2013-09-18','14:00:00',4.15),('325','2013-09-18','14:05:00',2.27),('325','2013-09-18','14:10:00',4),('325','2013-09-18','14:15:00',2.44),('325','2013-09-18','14:20:00',4.19),('325','2013-09-18','14:25:00',4.12),('325','2013-09-18','14:30:00',4),('325','2013-09-18','14:35:00',3.98),('325','2013-09-18','14:40:00',3.98),('325','2013-09-18','14:45:00',3.88),('325','2013-09-18','14:50:00',3.13),('325','2013-09-18','14:55:00',3.01),('325','2013-09-18','15:00:00',3.85),('325','2013-09-18','15:05:00',2.57),('325','2013-09-18','15:10:00',1.4),('325','2013-09-18','15:15:00',3.05),('325','2013-09-18','15:20:00',1.7),('325','2013-09-18','15:25:00',3.75),('325','2013-09-18','15:30:00',3.01),('325','2013-09-18','15:35:00',3.62),('325','2013-09-18','15:40:00',3.41),('325','2013-09-18','15:45:00',3.14),('325','2013-09-18','15:50:00',2.27),('325','2013-09-18','15:55:00',3.15),('325','2013-09-18','16:00:00',3.28),('325','2013-09-18','16:05:00',3.06),('325','2013-09-18','16:10:00',3.02),('325','2013-09-18','16:15:00',2.88),('325','2013-09-18','16:20:00',2.69),('325','2013-09-18','16:25:00',2.36),('325','2013-09-18','16:30:00',2.22),('325','2013-09-18','16:35:00',2.1),('325','2013-09-18','16:40:00',2.19),('325','2013-09-18','16:45:00',2.1),('325','2013-09-18','16:50:00',1.87),('325','2013-09-18','16:55:00',1.84),('325','2013-09-18','17:00:00',1.94),('325','2013-09-18','17:05:00',1.72),('325','2013-09-18','17:10:00',1.7),('325','2013-09-18','17:15:00',1.63),('325','2013-09-18','17:20:00',1.3),('325','2013-09-18','17:25:00',1.37),('325','2013-09-18','17:30:00',1.36),('325','2013-09-18','17:35:00',1.22),('325','2013-09-18','17:40:00',1.12),('325','2013-09-18','17:45:00',1.02),('325','2014-04-12','09:10:00',1.07),('325','2014-04-12','09:15:00',1.53),('325','2014-04-12','09:20:00',2.09),('325','2014-04-12','09:25:00',2.15),('325','2014-04-12','09:30:00',1.65),('325','2014-04-12','09:35:00',1.45),('325','2014-04-12','09:40:00',1.28),('325','2014-04-12','09:45:00',1.28),('325','2014-04-12','09:50:00',1.46),('325','2014-04-12','09:55:00',1.46),('325','2014-04-12','10:00:00',1.49),('325','2014-04-12','10:05:00',1.51),('325','2014-04-12','10:10:00',1.65),('325','2014-04-12','10:15:00',1.82),('325','2014-04-12','10:20:00',1.88),('325','2014-04-12','10:25:00',1.97),('325','2014-04-12','10:30:00',2.15),('325','2014-04-12','10:35:00',2.33),('325','2014-04-12','10:40:00',2.44),('325','2014-04-12','10:45:00',2.72),('325','2014-04-12','10:50:00',2.61),('325','2014-04-12','10:55:00',3.07),('325','2014-04-12','11:00:00',3.2),('325','2014-04-12','11:05:00',2.49),('325','2014-04-12','11:10:00',2.59),('325','2014-04-12','11:15:00',3.24),('325','2014-04-12','11:20:00',4.32),('325','2014-04-12','11:25:00',2.88),('325','2014-04-12','11:30:00',3.79),('325','2014-04-12','11:35:00',4.15),('325','2014-04-12','11:40:00',3.84),('325','2014-04-12','11:45:00',3.47),('325','2014-04-12','11:50:00',3.27),('325','2014-04-12','11:55:00',3.48),('325','2014-04-12','12:00:00',2.86),('325','2014-04-12','12:05:00',1.66),('325','2014-04-12','12:10:00',1.95),('325','2014-04-12','12:15:00',2.06),('325','2014-04-12','12:20:00',4.03),('325','2014-04-12','12:25:00',3.53),('325','2014-04-12','12:30:00',3.2),('325','2014-04-12','12:35:00',2.9),('325','2014-04-12','12:40:00',3.33),('325','2014-04-12','12:45:00',2.28),('325','2014-04-12','12:50:00',3.37),('325','2014-04-12','12:55:00',2.92),('325','2014-04-12','13:00:00',2.29),('325','2014-04-12','13:05:00',3.6),('325','2014-04-12','13:10:00',3.35),('325','2014-04-12','13:15:00',3.77),('325','2014-04-12','13:20:00',3.24),('325','2014-04-12','13:25:00',4.83),('325','2014-04-12','13:30:00',2.99),('325','2014-04-12','13:35:00',1.61),('325','2014-04-12','13:40:00',2.27),('325','2014-04-12','13:45:00',4.29),('325','2014-04-12','13:50:00',1.87),('325','2014-04-12','13:55:00',3.22),('325','2014-04-12','14:00:00',4.3),('325','2014-04-12','14:05:00',4.65),('325','2014-04-12','14:10:00',4.32),('325','2014-04-12','14:15:00',2.33),('325','2014-04-12','14:20:00',3.28),('325','2014-04-12','14:25:00',2.04),('325','2014-04-12','14:30:00',2.75),('325','2014-04-12','14:35:00',1.47),('325','2014-04-12','14:40:00',2.02),('325','2014-04-12','14:45:00',3.87),('325','2014-04-12','14:50:00',3.73),('325','2014-04-12','14:55:00',3.83),('325','2014-04-12','15:00:00',2.54),('325','2014-04-12','15:05:00',3.99),('325','2014-04-12','15:10:00',4.06),('325','2014-04-12','15:15:00',3.89),('325','2014-04-12','15:20:00',2.5),('325','2014-04-12','15:25:00',2.52),('325','2014-04-12','15:30:00',2.61),('325','2014-04-12','15:35:00',2.33),('325','2014-04-12','15:40:00',3.02),('325','2014-04-12','15:45:00',3.43),('325','2014-04-12','15:50:00',3.82),('325','2014-04-12','15:55:00',3.65),('325','2014-04-12','16:00:00',3.71),('325','2014-04-12','16:05:00',3.63),('325','2014-04-12','16:10:00',3.45),('325','2014-04-12','16:15:00',3.57),('325','2014-04-12','16:20:00',3.53),('325','2014-04-12','16:25:00',3.16),('325','2014-04-12','16:30:00',2.84),('325','2014-04-12','16:35:00',2.68),('325','2014-04-12','16:40:00',2.59),('325','2014-04-12','16:45:00',2.56),('325','2014-04-12','16:50:00',1.84),('325','2014-04-12','16:55:00',2.6),('325','2014-04-12','17:00:00',2.46),('325','2014-04-12','17:05:00',2.36),('325','2014-04-12','17:10:00',2.31),('325','2014-04-12','17:15:00',2.19),('325','2014-04-12','17:20:00',1.75),('325','2014-04-12','17:25:00',2.06),('325','2014-04-12','17:30:00',1.76),('325','2014-04-12','17:35:00',1.54),('325','2014-04-12','17:40:00',1.95),('325','2014-04-12','17:45:00',1.91),('325','2014-04-12','17:50:00',1.75),('325','2014-04-12','17:55:00',1.35),('325','2014-04-12','18:00:00',1.21),('325','2013-09-17','09:20:00',1.2),('325','2013-09-17','09:30:00',1.07),('325','2013-09-17','09:40:00',1.18),('325','2013-09-17','09:45:00',1.7),('325','2013-09-17','09:50:00',1.04),('325','2013-09-17','09:55:00',1.55),('325','2013-09-17','10:00:00',1.61),('325','2013-09-17','10:05:00',1.46),('325','2013-09-17','10:10:00',1.58),('325','2013-09-17','10:20:00',1.53),('325','2013-09-17','10:25:00',2.07),('325','2013-09-17','10:30:00',2.86),('325','2013-09-17','10:35:00',1.82),('325','2013-09-17','10:40:00',1.84),('325','2013-09-17','10:45:00',2.61),('325','2013-09-17','10:50:00',3.78),('325','2013-09-17','10:55:00',3.13),('325','2013-09-17','11:00:00',2.42),('325','2013-09-17','11:05:00',1.84),('325','2013-09-17','11:10:00',3.81),('325','2013-09-17','11:15:00',2.86),('325','2013-09-17','11:20:00',2.53),('325','2013-09-17','11:25:00',1.78),('325','2013-09-17','11:30:00',2.01),('325','2013-09-17','11:35:00',3.36),('325','2013-09-17','11:40:00',3.35),('325','2013-09-17','11:45:00',3.12),('325','2013-09-17','11:50:00',3.66),('325','2013-09-17','11:55:00',3.35),('325','2013-09-17','12:00:00',3.63),('325','2013-09-17','12:05:00',3.84),('325','2013-09-17','12:10:00',1.92),('325','2013-09-17','12:15:00',2.34),('325','2013-09-17','12:20:00',2.71),('325','2013-09-17','12:25:00',4.38),('325','2013-09-17','12:30:00',2.89),('325','2013-09-17','12:35:00',2.3),('325','2013-09-17','12:40:00',3.48),('325','2013-09-17','12:45:00',4.02),('325','2013-09-17','12:50:00',3.05),('325','2013-09-17','12:55:00',3.37),('325','2013-09-17','13:00:00',2.2),('325','2013-09-17','13:05:00',1.59),('325','2013-09-17','13:10:00',3.39),('325','2013-09-17','13:15:00',3.01),('325','2013-09-17','13:20:00',2.72),('325','2013-09-17','13:25:00',2.34),('325','2013-09-17','13:30:00',1.83),('325','2013-09-17','13:35:00',2.19),('325','2013-09-17','13:40:00',2.31),('325','2013-09-17','13:45:00',1.66),('325','2013-09-17','13:55:00',1.39),('325','2013-09-17','14:00:00',1.83),('325','2013-09-17','14:05:00',1.29),('325','2013-09-17','14:15:00',1.29),('325','2013-09-17','14:25:00',1.8),('325','2013-09-17','14:35:00',1.22),('325','2013-09-17','14:50:00',1.54),('325','2013-09-17','14:55:00',3.86),('325','2013-09-17','15:00:00',3.62),('325','2013-09-17','15:05:00',3.01),('325','2013-09-17','15:10:00',2.67),('325','2013-09-17','15:15:00',3.28),('325','2013-09-17','15:20:00',3.29),('325','2013-09-17','15:25:00',2.97),('325','2013-09-17','15:30:00',2.35),('325','2013-09-17','15:35:00',1.18),('325','2013-09-17','15:45:00',1.63),('325','2013-09-17','15:50:00',1.93),('325','2013-09-17','15:55:00',2.09),('325','2013-09-17','16:00:00',1.42),('325','2013-09-17','16:05:00',1.94),('325','2013-09-17','16:10:00',1.9),('325','2013-09-17','16:15:00',1.76),('325','2013-09-17','16:20:00',1.07),('325','2013-09-17','16:40:00',1.38),('325','2013-09-17','16:45:00',1.69),('325','2013-09-17','16:50:00',1.31),('325','2013-09-17','16:55:00',1.11),('325','2013-09-17','17:00:00',1.67),('325','2013-09-17','17:05:00',1.86),('325','2013-09-17','17:10:00',1.71),('325','2013-09-17','17:15:00',1.69),('325','2013-09-17','17:20:00',1.31),('325','2013-09-17','17:25:00',1.43),('325','2013-09-17','17:30:00',1.32),('325','2013-09-17','17:35:00',1.02),('325','2013-09-17','17:40:00',1.02),('325','2013-09-16','09:05:00',1.38),('325','2013-09-16','09:10:00',1.31),('325','2013-09-16','09:15:00',1.36),('325','2013-09-16','09:20:00',1.35),('325','2013-09-16','09:25:00',1.25),('325','2013-09-16','09:30:00',1.33),('325','2013-09-16','09:35:00',1.44),('325','2013-09-16','09:40:00',1.5),('325','2013-09-16','09:45:00',1.58),('325','2013-09-16','09:50:00',1.62),('325','2013-09-16','09:55:00',2.06),('325','2013-09-16','10:00:00',2.34),('325','2013-09-16','10:05:00',2.94),('325','2013-09-16','10:10:00',1.58),('325','2013-09-16','10:15:00',1.35),('325','2013-09-16','10:20:00',1.92),('325','2013-09-16','10:25:00',2.78),('325','2013-09-16','10:30:00',3.4),('325','2013-09-16','10:35:00',3.62),('325','2013-09-16','10:40:00',3.87),('325','2013-09-16','10:45:00',4.12),('325','2013-09-16','10:50:00',3.94),('325','2013-09-16','10:55:00',1.05),('325','2013-09-16','11:00:00',1.71),('325','2013-09-16','11:05:00',1.56),('325','2013-09-16','11:25:00',4.47),('325','2013-09-16','11:30:00',4.18),('325','2013-09-16','11:35:00',4.15),('325','2013-09-16','11:40:00',4.13),('325','2013-09-16','11:45:00',3),('325','2013-09-16','11:50:00',4.31),('325','2013-09-16','11:55:00',4.26),('325','2013-09-16','12:00:00',4.43),('325','2013-09-16','12:05:00',4.06),('325','2013-09-16','12:10:00',4.57),('325','2013-09-16','12:15:00',4.47),('325','2013-09-16','12:20:00',4.33),('325','2013-09-16','12:25:00',4.33),('325','2013-09-16','12:30:00',4.22),('325','2013-09-16','12:35:00',4.39),('325','2013-09-16','12:40:00',4.62),('325','2013-09-16','12:45:00',3.43),('325','2013-09-16','12:50:00',4.95),('325','2013-09-16','12:55:00',3.06),('325','2013-09-16','13:00:00',2.88),('325','2013-09-16','13:05:00',3.58),('325','2013-09-16','13:10:00',4.65),('325','2013-09-16','13:15:00',3.97),('325','2013-09-16','13:20:00',4.37),('325','2013-09-16','13:25:00',4.35),('325','2013-09-16','13:30:00',4.31),('325','2013-09-16','13:35:00',4.33),('325','2013-09-16','13:40:00',4.32),('325','2013-09-16','13:45:00',4.3),('325','2013-09-16','13:50:00',4.36),('325','2013-09-16','13:55:00',4.41),('325','2013-09-16','14:00:00',3.34),('325','2013-09-16','14:05:00',4.25),('325','2013-09-16','14:10:00',4.14),('325','2013-09-16','14:15:00',4.1),('325','2013-09-16','14:20:00',4.05),('325','2013-09-16','14:25:00',4.04),('325','2013-09-16','14:30:00',3.99),('325','2013-09-16','14:35:00',3.95),('325','2013-09-16','14:40:00',3.89),('325','2013-09-16','14:45:00',3.87),('325','2013-09-16','14:50:00',3.57),('325','2013-09-16','14:55:00',3.81),('325','2013-09-16','15:00:00',3.78),('325','2013-09-16','15:05:00',3.73),('325','2013-09-16','15:10:00',3.69),('325','2013-09-16','15:15:00',3.64),('325','2013-09-16','15:20:00',3.59),('325','2013-09-16','15:25:00',3.52),('325','2013-09-16','15:30:00',3.46),('325','2013-09-16','15:35:00',3.41),('325','2013-09-16','15:40:00',3.37),('325','2013-09-16','15:45:00',3.28),('325','2013-09-16','15:50:00',3.22),('325','2013-09-16','15:55:00',3.15),('325','2013-09-16','16:00:00',3.02),('325','2013-09-16','16:05:00',2.34),('325','2013-09-16','16:10:00',2.98),('325','2013-09-16','16:15:00',2.86),('325','2013-09-16','16:20:00',2.76),('325','2013-09-16','16:25:00',2.69),('325','2013-09-16','16:30:00',2.55),('325','2013-09-16','16:35:00',2.47),('325','2013-09-16','16:40:00',2.4),('325','2013-09-16','16:45:00',2.31),('325','2013-09-16','16:50:00',2.21),('325','2013-09-16','16:55:00',2.12),('325','2013-09-16','17:00:00',2.02),('325','2013-09-16','17:05:00',1.93),('325','2013-09-16','17:10:00',1.8),('325','2013-09-16','17:15:00',1.69),('325','2013-09-16','17:20:00',1.6),('325','2013-09-16','17:25:00',1.51),('325','2013-09-16','17:30:00',1.44),('325','2013-09-16','17:35:00',1.01),('325','2013-09-16','17:45:00',1.14),('325','2013-09-15','08:45:00',1.01),('325','2013-09-15','08:50:00',1.03),('325','2013-09-15','08:55:00',1.01),('325','2013-09-15','09:00:00',1.08),('325','2013-09-15','09:05:00',1.1),('325','2013-09-15','09:10:00',1.21),('325','2013-09-15','09:15:00',1.32),('325','2013-09-15','09:20:00',1.3),('325','2013-09-15','09:25:00',1.36),('325','2013-09-15','09:30:00',1.37),('325','2013-09-15','09:35:00',1.46),('325','2013-09-15','09:40:00',1.49),('325','2013-09-15','09:45:00',1.52),('325','2013-09-15','09:50:00',1.58),('325','2013-09-15','09:55:00',2.48),('325','2013-09-15','10:00:00',2.69),('325','2013-09-15','10:05:00',2.78),('325','2013-09-15','10:10:00',2.8),('325','2013-09-15','10:15:00',2.82),('325','2013-09-15','10:20:00',2.91),('325','2013-09-15','10:25:00',3.01),('325','2013-09-15','10:30:00',2.9),('325','2013-09-15','10:35:00',2.01),('325','2013-09-15','10:40:00',1.35),('325','2013-09-15','10:50:00',1.64),('325','2013-09-15','10:55:00',3.57),('325','2013-09-15','11:00:00',4.05),('325','2013-09-15','11:05:00',4.02),('325','2013-09-15','11:10:00',2.58),('325','2013-09-15','11:15:00',1.74),('325','2013-09-15','11:20:00',1.76),('325','2013-09-15','11:30:00',2.33),('325','2013-09-15','11:35:00',2.04),('325','2013-09-15','11:40:00',1.5),('325','2013-09-15','11:45:00',3.19),('325','2013-09-15','11:50:00',2.91),('325','2013-09-15','11:55:00',1.49),('325','2013-09-15','12:00:00',1.26),('325','2013-09-15','12:05:00',1.18),('325','2013-09-15','12:10:00',1.21),('325','2013-09-15','12:15:00',1.34),('325','2013-09-15','12:20:00',1.71),('325','2013-09-15','12:25:00',1.9),('325','2013-09-15','12:30:00',1.71),('325','2013-09-15','12:35:00',1.5),('325','2013-09-15','12:40:00',1.45),('325','2013-09-15','12:45:00',1.25),('325','2013-09-15','12:50:00',1.41),('325','2013-09-15','12:55:00',1.43),('325','2013-09-15','13:00:00',1.28),('325','2013-09-15','13:25:00',1.26),('325','2013-09-15','13:30:00',1.18),('325','2013-09-15','13:35:00',1.19),('325','2013-09-15','13:40:00',1.4),('325','2013-09-15','13:45:00',2.25),('325','2013-09-15','13:50:00',1.75),('325','2013-09-15','13:55:00',1.24),('325','2013-09-15','14:00:00',2.01),('325','2013-09-15','14:05:00',1.79),('325','2013-09-15','14:10:00',1.63),('325','2013-09-15','14:15:00',1.61),('325','2013-09-15','14:20:00',1.5),('325','2013-09-15','14:25:00',1.42),('325','2013-09-15','14:30:00',1.29),('325','2013-09-15','14:35:00',1.11),('325','2013-09-15','14:40:00',1.14),('325','2013-09-15','14:45:00',1.05),('325','2013-09-15','14:50:00',1.09),('325','2013-09-15','14:55:00',1.07),('325','2013-09-15','15:00:00',1.1),('325','2013-09-15','15:05:00',1.19),('325','2013-09-15','15:10:00',1.45),('325','2013-09-15','15:15:00',2.97),('325','2013-09-15','15:20:00',2.12),('325','2013-09-15','15:25:00',1.52),('325','2013-09-15','15:30:00',1.11),('325','2013-09-15','15:35:00',1.11),('325','2013-09-15','15:40:00',1.03),('325','2013-09-15','15:45:00',1.02),('325','2013-09-14','08:55:00',1.04),('325','2013-09-14','09:00:00',1.08),('325','2013-09-14','09:05:00',1.12),('325','2013-09-14','09:10:00',1.19),('325','2013-09-14','09:15:00',1.25),('325','2013-09-14','09:20:00',1.3),('325','2013-09-14','09:25:00',1.36),('325','2013-09-14','09:30:00',1.41),('325','2013-09-14','09:35:00',1.46),('325','2013-09-14','09:40:00',1.5),('325','2013-09-14','09:45:00',1.55),('325','2013-09-14','09:50:00',1.6),('325','2013-09-14','09:55:00',1.86),('325','2013-09-14','10:00:00',2.64),('325','2013-09-14','10:05:00',2.66),('325','2013-09-14','10:10:00',2.57),('325','2013-09-14','10:15:00',2.64),('325','2013-09-14','10:20:00',2.89),('325','2013-09-14','10:25:00',3.04),('325','2013-09-14','10:30:00',3.17),('325','2013-09-14','10:35:00',3.4),('325','2013-09-14','10:40:00',3.44),('325','2013-09-14','10:45:00',2.38),('325','2013-09-14','10:50:00',4.02),('325','2013-09-14','10:55:00',2.19),('325','2013-09-14','11:00:00',1.86),('325','2013-09-14','11:05:00',2.12),('325','2013-09-14','11:10:00',3.22),('325','2013-09-14','11:15:00',1.39),('325','2013-09-14','11:25:00',3.84),('325','2013-09-14','11:30:00',4.02),('325','2013-09-14','11:35:00',4.18),('325','2013-09-14','11:40:00',4.13),('325','2013-09-14','11:45:00',4.19),('325','2013-09-14','11:50:00',3.04),('325','2013-09-14','12:30:00',1.59),('325','2013-09-14','12:35:00',2.35),('325','2013-09-14','12:40:00',1.11),('325','2013-09-14','12:45:00',1.02),('325','2013-09-14','12:55:00',1.91),('325','2013-09-14','13:00:00',1.63),('325','2013-09-14','13:05:00',1.54),('325','2013-09-14','13:10:00',3.67),('325','2013-09-14','13:15:00',4.81),('325','2013-09-14','13:20:00',3.03),('325','2013-09-14','13:25:00',4.78),('325','2013-09-14','13:30:00',4.39),('325','2013-09-14','13:35:00',4.45),('325','2013-09-14','13:40:00',4.59),('325','2013-09-14','13:45:00',3.1),('325','2013-09-14','13:50:00',2.94),('325','2013-09-14','13:55:00',4.52),('325','2013-09-14','14:00:00',4.52),('325','2013-09-14','14:05:00',4.3),('325','2013-09-14','14:10:00',4.2),('325','2013-09-14','14:15:00',4.17),('325','2013-09-14','14:20:00',4.08),('325','2013-09-14','14:25:00',4.09),('325','2013-09-14','14:30:00',4.06),('325','2013-09-14','14:35:00',4.01),('325','2013-09-14','14:40:00',4),('325','2013-09-14','14:45:00',3.91),('325','2013-09-14','14:50:00',3.89),('325','2013-09-14','14:55:00',3.84),('325','2013-09-14','15:00:00',3.76),('325','2013-09-14','15:05:00',3.71),('325','2013-09-14','15:10:00',3.69),('325','2013-09-14','15:15:00',3.62),('325','2013-09-14','15:20:00',3.57),('325','2013-09-14','15:25:00',3.53),('325','2013-09-14','15:30:00',3.51),('325','2013-09-14','15:35:00',3.41),('325','2013-09-14','15:40:00',3.34),('325','2013-09-14','15:45:00',3.28),('325','2013-09-14','15:50:00',3.2),('325','2013-09-14','15:55:00',3.13),('325','2013-09-14','16:00:00',3.07),('325','2013-09-14','16:05:00',2.98),('325','2013-09-14','16:10:00',2.87),('325','2013-09-14','16:15:00',2.83),('325','2013-09-14','16:20:00',2.72),('325','2013-09-14','16:25:00',2.7),('325','2013-09-14','16:30:00',2.59),('325','2013-09-14','16:35:00',2.44),('325','2013-09-14','16:40:00',2.4),('325','2013-09-14','16:45:00',2.3),('325','2013-09-14','16:50:00',2.24),('325','2013-09-14','16:55:00',2.13),('325','2013-09-14','17:00:00',2.07),('325','2013-09-14','17:05:00',1.93),('325','2013-09-14','17:10:00',1.88),('325','2013-09-14','17:15:00',1.73),('325','2013-09-14','17:20:00',1.38),('325','2013-09-14','17:25:00',1.51),('325','2013-09-14','17:30:00',1.43),('325','2013-09-14','17:35:00',1.16),('325','2013-09-14','17:40:00',1.22),('325','2013-09-14','17:45:00',1.14),('325','2013-09-14','17:50:00',1.05),('325','2013-09-13','08:55:00',1.01),('325','2013-09-13','09:20:00',1.02),('325','2013-09-13','09:25:00',1.14),('325','2013-09-13','09:30:00',1.21),('325','2013-09-13','09:35:00',1.3),('325','2013-09-13','09:40:00',1.38),('325','2013-09-13','09:45:00',1.33),('325','2013-09-13','09:50:00',1.53),('325','2013-09-13','09:55:00',2.1),('325','2013-09-13','10:00:00',1.83),('325','2013-09-13','10:05:00',1.24),('325','2013-09-13','10:10:00',2.07),('325','2013-09-13','10:15:00',3.68),('325','2013-09-13','10:20:00',3.1),('325','2013-09-13','10:25:00',1.48),('325','2013-09-13','10:30:00',2.98),('325','2013-09-13','10:35:00',3.38),('325','2013-09-13','10:40:00',3.39),('325','2013-09-13','10:45:00',3.42),('325','2013-09-13','10:50:00',3.5),('325','2013-09-13','10:55:00',3.58),('325','2013-09-13','11:00:00',3.61),('325','2013-09-13','11:05:00',3.64),('325','2013-09-13','11:10:00',3.72),('325','2013-09-13','11:15:00',3.77),('325','2013-09-13','11:20:00',3.79),('325','2013-09-13','11:25:00',3.83),('325','2013-09-13','11:30:00',3.89),('325','2013-09-13','11:35:00',3.92),('325','2013-09-13','11:40:00',3.93),('325','2013-09-13','11:45:00',3.94),('325','2013-09-13','11:50:00',3.98),('325','2013-09-13','11:55:00',4.04),('325','2013-09-13','12:00:00',4.09),('325','2013-09-13','12:05:00',4.12),('325','2013-09-13','12:10:00',4.16),('325','2013-09-13','12:15:00',4.2),('325','2013-09-13','12:20:00',4.18),('325','2013-09-13','12:25:00',4.22),('325','2013-09-13','12:30:00',4.29),('325','2013-09-13','12:35:00',4.33),('325','2013-09-13','12:40:00',4.38),('325','2013-09-13','12:45:00',4.37),('325','2013-09-13','12:50:00',4.36),('325','2013-09-13','12:55:00',4.33),('325','2013-09-13','13:00:00',4.25),('325','2013-09-13','13:05:00',4.23),('325','2013-09-13','13:10:00',4.2),('325','2013-09-13','13:15:00',4.17),('325','2013-09-13','13:20:00',4.17),('325','2013-09-13','13:25:00',4.13),('325','2013-09-13','13:30:00',4.13),('325','2013-09-13','13:35:00',4.14),('325','2013-09-13','13:40:00',4.13),('325','2013-09-13','13:45:00',4.18),('325','2013-09-13','13:50:00',4.14),('325','2013-09-13','13:55:00',4.11),('325','2013-09-13','14:00:00',4.07),('325','2013-09-13','14:05:00',4.06),('325','2013-09-13','14:10:00',4.06),('325','2013-09-13','14:15:00',4.02),('325','2013-09-13','14:20:00',4.06),('325','2013-09-13','14:25:00',1.2),('325','2013-09-13','14:35:00',4.12),('325','2013-09-13','14:40:00',3.79),('325','2013-09-13','14:45:00',3.77),('325','2013-09-13','14:50:00',3.31),('325','2013-09-13','14:55:00',3.81),('325','2013-09-13','15:00:00',3.8),('325','2013-09-13','15:05:00',3.77),('325','2013-09-13','15:10:00',3.72),('325','2013-09-13','15:15:00',3.65),('325','2013-09-13','15:20:00',3.62),('325','2013-09-13','15:25:00',3.54),('325','2013-09-13','15:30:00',3.49),('325','2013-09-13','15:35:00',3.43),('325','2013-09-13','15:40:00',3.37),('325','2013-09-13','15:45:00',3.31),('325','2013-09-13','15:50:00',3.25),('325','2013-09-13','15:55:00',3.17),('325','2013-09-13','16:00:00',3.09),('325','2013-09-13','16:05:00',3.03),('325','2013-09-13','16:10:00',2.96),('325','2013-09-13','16:15:00',2.88),('325','2013-09-13','16:20:00',2.8),('325','2013-09-13','16:25:00',2.72),('325','2013-09-13','16:30:00',2.63),('325','2013-09-13','16:35:00',2.48),('325','2013-09-13','16:40:00',2.41),('325','2013-09-13','16:45:00',2.32),('325','2013-09-13','16:50:00',2.23),('325','2013-09-13','16:55:00',2.13),('325','2013-09-13','17:00:00',2.04),('325','2013-09-13','17:05:00',1.94),('325','2013-09-13','17:10:00',1.83),('325','2013-09-13','17:15:00',1.72),('325','2013-09-13','17:20:00',1.63),('325','2013-09-13','17:25:00',1.53),('325','2013-09-13','17:30:00',1.42),('325','2013-09-13','17:35:00',1.33),('325','2013-09-13','17:40:00',1.23),('325','2013-09-13','17:45:00',1.14),('325','2013-09-13','17:50:00',1.05),('325','2013-09-12','08:25:00',1.06),('325','2013-09-12','08:30:00',1.15),('325','2013-09-12','08:35:00',1.15),('325','2013-09-12','09:00:00',1.16),('325','2013-09-12','09:05:00',1.18),('325','2013-09-12','09:10:00',1.02),('325','2013-09-12','09:15:00',1.46),('325','2013-09-12','09:20:00',1.51),('325','2013-09-12','09:25:00',1.63),('325','2013-09-12','09:30:00',1.8),('325','2013-09-12','09:35:00',1.79),('325','2013-09-12','09:40:00',1.62),('325','2013-09-12','09:45:00',2),('325','2013-09-12','09:50:00',1.65),('325','2013-09-12','09:55:00',1.06),('325','2013-09-12','10:00:00',1.06),('325','2013-09-12','10:05:00',1.49),('325','2013-09-12','10:10:00',1.76),('325','2013-09-12','10:15:00',1.68),('325','2013-09-12','10:20:00',1.08),('325','2013-09-12','10:25:00',1.42),('325','2013-09-12','10:30:00',2.44),('325','2013-09-12','10:35:00',1.8),('325','2013-09-12','10:55:00',2.15),('325','2013-09-12','11:00:00',2.53),('325','2013-09-12','11:05:00',3.78),('325','2013-09-12','11:10:00',3.06),('325','2013-09-12','11:15:00',2.6),('325','2013-09-12','11:20:00',1.43),('325','2013-09-12','11:40:00',1.43),('325','2013-09-12','11:45:00',2),('325','2013-09-12','11:50:00',1.67),('325','2013-09-12','11:55:00',3.27),('325','2013-09-12','12:00:00',3.12),('325','2013-09-12','12:05:00',3.84),('325','2013-09-12','12:10:00',3.17),('325','2013-09-12','12:15:00',2.84),('325','2013-09-12','12:20:00',1.4),('325','2013-09-12','12:25:00',2.07),('325','2013-09-12','12:30:00',1.52),('325','2013-09-12','12:35:00',3.62),('325','2013-09-12','12:40:00',3.58),('325','2013-09-12','12:45:00',1.08),('325','2013-09-12','12:50:00',2.22),('325','2013-09-12','12:55:00',2.8),('325','2013-09-12','13:00:00',4.03),('325','2013-09-12','13:05:00',2.67),('325','2013-09-12','13:10:00',2.86),('325','2013-09-12','13:15:00',4.81),('325','2013-09-12','13:20:00',4.98),('325','2013-09-12','13:25:00',4.32),('325','2013-09-12','13:30:00',3.86),('325','2013-09-12','13:35:00',2.2),('325','2013-09-12','13:40:00',3.7),('325','2013-09-12','13:45:00',2.94),('325','2013-09-12','13:50:00',4.28),('325','2013-09-12','13:55:00',4.33),('325','2013-09-12','14:00:00',3.92),('325','2013-09-12','14:05:00',4.04),('325','2013-09-12','14:10:00',3.95),('325','2013-09-12','14:15:00',4.1),('325','2013-09-12','14:20:00',4.24),('325','2013-09-12','14:25:00',3.89),('325','2013-09-12','14:30:00',4.38),('325','2013-09-12','14:35:00',2.2),('325','2013-09-12','14:40:00',3.52),('325','2013-09-12','14:45:00',3.97),('325','2013-09-12','14:50:00',4.06),('325','2013-09-12','14:55:00',3.94),('325','2013-09-12','15:00:00',3.53),('325','2013-09-12','15:05:00',2.27),('325','2013-09-12','15:10:00',2.82),('325','2013-09-12','15:15:00',3.85),('325','2013-09-12','15:20:00',3.68),('325','2013-09-12','15:25:00',3.22),('325','2013-09-12','15:30:00',3.61),('325','2013-09-12','15:35:00',3.49),('325','2013-09-12','15:40:00',3.45),('325','2013-09-12','15:45:00',3.4),('325','2013-09-12','15:50:00',3.34),('325','2013-09-12','15:55:00',3.3),('325','2013-09-12','16:00:00',3.2),('325','2013-09-12','16:05:00',1.45),('325','2013-09-12','16:10:00',3.3),('325','2013-09-12','16:15:00',2.21),('325','2013-09-12','16:20:00',2.24),('325','2013-09-12','16:25:00',1.85),('325','2013-09-12','16:30:00',2.19),('325','2013-09-12','16:40:00',2.78),('325','2013-09-12','16:45:00',2.49),('325','2013-09-12','16:50:00',1.15),('325','2013-09-12','16:55:00',1.32),('325','2013-09-12','17:00:00',2.32),('325','2013-09-12','17:05:00',2.11),('325','2013-09-12','17:10:00',1.9),('325','2013-09-12','17:15:00',1.41),('325','2013-09-12','17:20:00',1.15),('325','2013-09-12','17:30:00',1.67),('325','2013-09-12','17:35:00',1.49),('325','2013-09-12','17:40:00',1.37),('325','2013-09-12','17:45:00',1.25),('325','2013-09-12','17:50:00',1.1),('325','2013-09-12','17:55:00',1.02),('325','2013-09-11','08:55:00',1.06),('325','2013-09-11','09:00:00',1.47),('325','2013-09-11','09:05:00',1.4),('325','2013-09-11','09:10:00',1.4),('325','2013-09-11','09:15:00',1.54),('325','2013-09-11','09:20:00',1.88),('325','2013-09-11','09:25:00',1.32),('325','2013-09-11','09:30:00',1.16),('325','2013-09-11','09:35:00',1.68),('325','2013-09-11','09:40:00',1.25),('325','2013-09-11','10:00:00',1.11),('325','2013-09-11','10:05:00',1.64),('325','2013-09-11','10:15:00',2.84),('325','2013-09-11','10:20:00',2.82),('325','2013-09-11','10:25:00',2.83),('325','2013-09-11','10:30:00',2.95),('325','2013-09-11','10:35:00',2.43),('325','2013-09-11','10:40:00',1.96),('325','2013-09-11','10:45:00',2.47),('325','2013-09-11','10:50:00',2.48),('325','2013-09-11','10:55:00',1.6),('325','2013-09-11','11:00:00',1.69),('325','2013-09-11','11:05:00',2.18),('325','2013-09-11','11:10:00',3),('325','2013-09-11','11:15:00',4.25),('325','2013-09-11','11:20:00',3.29),('325','2013-09-11','11:25:00',1.83),('325','2013-09-11','11:30:00',2.47),('325','2013-09-11','11:35:00',2.37),('325','2013-09-11','11:40:00',4.26),('325','2013-09-11','11:45:00',4.2),('325','2013-09-11','11:50:00',3.89),('325','2013-09-11','11:55:00',3.02),('325','2013-09-11','12:00:00',4.25),('325','2013-09-11','12:05:00',3.54),('325','2013-09-11','12:10:00',2.81),('325','2013-09-11','12:15:00',1.7),('325','2013-09-11','12:20:00',2.19),('325','2013-09-11','12:25:00',3.92),('325','2013-09-11','12:30:00',2.23),('325','2013-09-11','12:35:00',2.84),('325','2013-09-11','12:40:00',1.76),('325','2013-09-11','12:45:00',3.25),('325','2013-09-11','12:50:00',5.08),('325','2013-09-11','13:00:00',4.21),('325','2013-09-11','13:05:00',3.67),('325','2013-09-11','13:10:00',4.64),('325','2013-09-11','13:15:00',4.73),('325','2013-09-11','13:20:00',4.34),('325','2013-09-11','13:25:00',2.35),('325','2013-09-11','13:30:00',2.72),('325','2013-09-11','13:35:00',4.19),('325','2013-09-11','13:40:00',2.53),('325','2013-09-11','13:45:00',4.32),('325','2013-09-11','13:50:00',3.51),('325','2013-09-11','13:55:00',2.71),('325','2013-09-11','14:00:00',4.38),('325','2013-09-11','14:05:00',3.66),('325','2013-09-11','14:10:00',3.73),('325','2013-09-11','14:15:00',4.03),('325','2013-09-11','14:20:00',3.52),('325','2013-09-11','14:25:00',3.44),('325','2013-09-11','14:30:00',2.86),('325','2013-09-11','14:35:00',2.74),('325','2013-09-11','14:40:00',2.68),('325','2013-09-11','14:45:00',3.55),('325','2013-09-11','14:50:00',4.42),('325','2013-09-11','14:55:00',1.85),('325','2013-09-11','15:00:00',3.95),('325','2013-09-11','15:05:00',2.99),('325','2013-09-11','15:10:00',2.57),('325','2013-09-11','15:15:00',3.6),('325','2013-09-11','15:20:00',4.13),('325','2013-09-11','15:25:00',1.85),('325','2013-09-11','15:30:00',3.24),('325','2013-09-11','15:35:00',1.02),('325','2013-09-11','15:40:00',1.78),('325','2013-09-11','15:45:00',3.12),('325','2013-09-11','15:50:00',3.45),('325','2013-09-11','15:55:00',2.82),('325','2013-09-11','16:00:00',2.92),('325','2013-09-11','16:05:00',3.28),('325','2013-09-11','16:10:00',3.11),('325','2013-09-11','16:15:00',2.99),('325','2013-09-11','16:20:00',2.77),('325','2013-09-11','16:25:00',2.69),('325','2013-09-11','16:30:00',1.43),('325','2013-09-11','16:40:00',1.88),('325','2013-09-11','16:45:00',2.52),('325','2013-09-11','16:50:00',2.34),('325','2013-09-11','16:55:00',1.31),('325','2013-09-11','17:00:00',2.16),('325','2013-09-11','17:05:00',2.03),('325','2013-09-11','17:10:00',1.94),('325','2013-09-11','17:15:00',1.81),('325','2013-09-11','17:20:00',1.7),('325','2013-09-11','17:25:00',1.59),('325','2013-09-11','17:30:00',1.5),('325','2013-09-11','17:35:00',1.42),('325','2013-09-11','17:40:00',1.19),('325','2013-09-11','17:45:00',1.25),('325','2013-09-10','08:55:00',1.15),('325','2013-09-10','09:00:00',1.19),('325','2013-09-10','09:05:00',1.24),('325','2013-09-10','09:10:00',1.7),('325','2013-09-10','09:15:00',1.5),('325','2013-09-10','09:20:00',1.29),('325','2013-09-10','09:25:00',1.33),('325','2013-09-10','09:30:00',2.09),('325','2013-09-10','09:35:00',2.23),('325','2013-09-10','09:40:00',1.54),('325','2013-09-10','09:45:00',1.32),('325','2013-09-10','09:50:00',1.2),('325','2013-09-10','09:55:00',1.06),('325','2013-09-10','10:25:00',1.03),('325','2013-09-10','10:30:00',1.01),('325','2013-09-10','10:35:00',1.19),('325','2013-09-10','10:40:00',1.59),('325','2013-09-10','10:45:00',2.13),('325','2013-09-10','10:50:00',1.23),('325','2013-09-10','10:55:00',1.38),('325','2013-09-10','11:00:00',1.69),('325','2013-09-10','11:05:00',1.45),('325','2013-09-10','11:10:00',1.38),('325','2013-09-10','11:15:00',1.19),('325','2013-09-10','11:20:00',1.31),('325','2013-09-10','11:25:00',1.38),('325','2013-09-10','11:30:00',1.05),('325','2013-09-10','11:45:00',1.29),('325','2013-09-10','11:50:00',1.26),('325','2013-09-10','11:55:00',1.56),('325','2013-09-10','12:00:00',1.35),('325','2013-09-10','12:05:00',1.02),('325','2013-09-10','12:10:00',1.03),('325','2013-09-10','12:15:00',1.08),('325','2013-09-10','13:25:00',1.06),('325','2013-09-10','13:35:00',1.1),('325','2013-09-10','13:40:00',1.89),('325','2013-09-10','13:45:00',2.85),('325','2013-09-10','13:50:00',1.88),('325','2013-09-10','13:55:00',1.6),('325','2013-09-10','14:00:00',1.16),('325','2013-09-10','14:05:00',1.32),('325','2013-09-10','14:10:00',1.37),('325','2013-09-10','14:15:00',1.68),('325','2013-09-10','14:20:00',1.68),('325','2013-09-10','14:25:00',2.4),('325','2013-09-10','14:30:00',2.03),('325','2013-09-10','14:35:00',1.54),('325','2013-09-10','14:40:00',1.87),('325','2013-09-10','14:45:00',1.97),('325','2013-09-10','14:50:00',2.35),('325','2013-09-10','14:55:00',2.03),('325','2013-09-10','15:00:00',2.65),('325','2013-09-10','15:05:00',2.42),('325','2013-09-10','15:10:00',1.83),('325','2013-09-10','15:15:00',1.71),('325','2013-09-10','15:20:00',2.17),('325','2013-09-10','15:25:00',1.91),('325','2013-09-10','15:30:00',2.25),('325','2013-09-10','15:35:00',1.82),('325','2013-09-10','15:40:00',1.23),('325','2013-09-10','15:45:00',1.04),('325','2013-09-10','15:50:00',1.11),('325','2013-09-10','15:55:00',1.01),('325','2013-09-10','16:00:00',1.07),('325','2013-09-10','16:05:00',1.11),('325','2013-09-10','16:10:00',1.43),('325','2013-09-10','16:15:00',1.52),('325','2013-09-10','16:20:00',1.04),('325','2013-09-09','08:55:00',1.13),('325','2013-09-09','09:00:00',1.15),('325','2013-09-09','09:05:00',1.07),('325','2013-09-09','09:35:00',1.17),('325','2013-09-09','10:00:00',1.46),('325','2013-09-09','10:05:00',1.75),('325','2013-09-09','10:10:00',1.69),('325','2013-09-09','10:15:00',1.63),('325','2013-09-09','10:20:00',1.64),('325','2013-09-09','10:25:00',1.58),('325','2013-09-09','10:30:00',1.53),('325','2013-09-09','10:35:00',1.59),('325','2013-09-09','10:40:00',1.71),('325','2013-09-09','10:45:00',2.09),('325','2013-09-09','10:50:00',2.71),('325','2013-09-09','10:55:00',2.55),('325','2013-09-09','11:00:00',2.8),('325','2013-09-09','11:05:00',2.39),('325','2013-09-09','11:10:00',2.16),('325','2013-09-09','11:15:00',2.23),('325','2013-09-09','11:20:00',2.15),('325','2013-09-09','11:25:00',2.17),('325','2013-09-09','11:30:00',2.22),('325','2013-09-09','11:35:00',2.38),('325','2013-09-09','11:40:00',3.25),('325','2013-09-09','11:45:00',3.21),('325','2013-09-09','11:50:00',3.39),('325','2013-09-09','11:55:00',2.11),('325','2013-09-09','12:00:00',2.87),('325','2013-09-09','12:05:00',3.37),('325','2013-09-09','12:10:00',3.13),('325','2013-09-09','12:15:00',2.37),('325','2013-09-09','12:20:00',1.38),('325','2013-09-09','12:25:00',1.11),('325','2013-09-09','12:30:00',1.09),('325','2013-09-09','12:35:00',1.11),('325','2013-09-09','12:40:00',1.53),('325','2013-09-09','12:45:00',1.42),('325','2013-09-09','12:50:00',1.21),('325','2013-09-09','12:55:00',1.7),('325','2013-09-09','13:00:00',1.87),('325','2013-09-09','13:05:00',2.3),('325','2013-09-09','13:10:00',2.17),('325','2013-09-09','13:15:00',2.8),('325','2013-09-09','13:20:00',3.39),('325','2013-09-09','13:25:00',3.41),('325','2013-09-09','13:30:00',3.98),('325','2013-09-09','13:35:00',3.76),('325','2013-09-09','13:40:00',3.72),('325','2013-09-09','13:45:00',4.21),('325','2013-09-09','13:50:00',4.05),('325','2013-09-09','13:55:00',4.26),('325','2013-09-09','14:00:00',3.91),('325','2013-09-09','14:05:00',3.85),('325','2013-09-09','14:10:00',4.16),('325','2013-09-09','14:15:00',2.54),('325','2013-09-09','14:20:00',2.04),('325','2013-09-09','14:25:00',1.57),('325','2013-09-09','14:30:00',2.23),('325','2013-09-09','14:35:00',3.65),('325','2013-09-09','14:40:00',4.15),('325','2013-09-09','14:45:00',3.28),('325','2013-09-09','14:50:00',3.68),('325','2013-09-09','14:55:00',2.37),('325','2013-09-09','15:00:00',2.62),('325','2013-09-09','15:05:00',2.45),('325','2013-09-09','15:10:00',2.29),('325','2013-09-09','15:15:00',1.45),('325','2013-09-09','15:20:00',2.61),('325','2013-09-09','15:25:00',1.47),('325','2013-09-09','15:30:00',3.1),('325','2013-09-09','15:35:00',2.52),('325','2013-09-09','15:40:00',2.38),('325','2013-09-09','15:45:00',1.51),('325','2013-09-09','15:50:00',1.54),('325','2013-09-09','15:55:00',1.62),('325','2013-09-09','16:00:00',1.83),('325','2013-09-09','16:05:00',1.4),('325','2013-09-09','16:10:00',1.94),('325','2013-09-09','16:15:00',2.19),('325','2013-09-09','16:20:00',1.93),('325','2013-09-09','16:25:00',1.23),('325','2013-09-09','16:30:00',1.14),('325','2013-09-09','16:35:00',1.29),('325','2013-09-09','16:40:00',1.42),('325','2013-09-09','16:45:00',1.93),('325','2013-09-09','17:00:00',1.04),('325','2013-09-08','09:05:00',1.03),('325','2013-09-08','09:10:00',1.05),('325','2013-09-08','09:15:00',1.08),('325','2013-09-08','09:20:00',1.03),('325','2013-09-08','09:25:00',1.17),('325','2013-09-08','09:30:00',1.41),('325','2013-09-08','09:35:00',1.39),('325','2013-09-08','09:40:00',1.49),('325','2013-09-08','09:45:00',1.66),('325','2013-09-08','09:50:00',1.58),('325','2013-09-08','09:55:00',1.71),('325','2013-09-08','10:00:00',2.36),('325','2013-09-08','10:05:00',2.55),('325','2013-09-08','10:10:00',2.66),('325','2013-09-08','10:15:00',2.74),('325','2013-09-08','10:20:00',2.79),('325','2013-09-08','10:25:00',2.91),('325','2013-09-08','10:30:00',2.92),('325','2013-09-08','10:35:00',3.02),('325','2013-09-08','10:40:00',3.12),('325','2013-09-08','10:45:00',3.17),('325','2013-09-08','10:50:00',3.22),('325','2013-09-08','10:55:00',3.19),('325','2013-09-08','11:00:00',3.25),('325','2013-09-08','11:05:00',3.36),('325','2013-09-08','11:10:00',3.4),('325','2013-09-08','11:15:00',3.45),('325','2013-09-08','11:20:00',3.49),('325','2013-09-08','11:25:00',3.47),('325','2013-09-08','11:30:00',3.5),('325','2013-09-08','11:35:00',3.5),('325','2013-09-08','11:40:00',3.59),('325','2013-09-08','11:45:00',3.6),('325','2013-09-08','11:50:00',3.53),('325','2013-09-08','11:55:00',3.6),('325','2013-09-08','12:00:00',3.53),('325','2013-09-08','12:05:00',3.49),('325','2013-09-08','12:10:00',3.62),('325','2013-09-08','12:15:00',3.83),('325','2013-09-08','12:20:00',3.76),('325','2013-09-08','12:25:00',3.76),('325','2013-09-08','12:30:00',3.75),('325','2013-09-08','12:35:00',3.76),('325','2013-09-08','12:40:00',3.71),('325','2013-09-08','12:45:00',3.84),('325','2013-09-08','12:50:00',3.81),('325','2013-09-08','12:55:00',3.83),('325','2013-09-08','13:00:00',3.78),('325','2013-09-08','13:05:00',3.89),('325','2013-09-08','13:10:00',3.75),('325','2013-09-08','13:15:00',3.78),('325','2013-09-08','13:20:00',3.8),('325','2013-09-08','13:25:00',3.41),('325','2013-09-08','13:30:00',3.49),('325','2013-09-08','13:35:00',3.33),('325','2013-09-08','13:40:00',2.42),('325','2013-09-08','13:45:00',2.31),('325','2013-09-08','13:50:00',3.13),('325','2013-09-08','13:55:00',3.17),('325','2013-09-08','14:00:00',3.69),('325','2013-09-08','14:05:00',3.58),('325','2013-09-08','14:10:00',3.94),('325','2013-09-08','14:15:00',3.52),('325','2013-09-08','14:20:00',3.97),('325','2013-09-08','14:25:00',4.16),('325','2013-09-08','14:30:00',3.68),('325','2013-09-08','14:35:00',3.91),('325','2013-09-08','14:40:00',3.78),('325','2013-09-08','14:45:00',3.68),('325','2013-09-08','14:50:00',3.69),('325','2013-09-08','14:55:00',3.69),('325','2013-09-08','15:00:00',3.67),('325','2013-09-08','15:05:00',2.84),('325','2013-09-08','15:10:00',2.03),('325','2013-09-08','15:15:00',2.74),('325','2013-09-08','15:20:00',3.44),('325','2013-09-08','15:25:00',3.5),('325','2013-09-08','15:30:00',3.51),('325','2013-09-08','15:35:00',3.37),('325','2013-09-08','15:40:00',3.12),('325','2013-09-08','15:45:00',3.2),('325','2013-09-08','15:50:00',3.03),('325','2013-09-08','15:55:00',2.56),('325','2013-09-08','16:00:00',2.68),('325','2013-09-08','16:05:00',2.66),('325','2013-09-08','16:10:00',2.38),('325','2013-09-08','16:15:00',2.76),('325','2013-09-08','16:20:00',2.44),('325','2013-09-08','16:25:00',2.35),('325','2013-09-08','16:30:00',2.47),('325','2013-09-08','16:35:00',2.23),('325','2013-09-08','16:40:00',1.8),('325','2013-09-08','16:45:00',1.39),('325','2013-09-08','16:50:00',1.33),('325','2013-09-08','16:55:00',1.23),('325','2013-09-08','17:00:00',1.59),('325','2013-09-08','17:05:00',2.09),('325','2013-09-08','17:10:00',1.95),('325','2013-09-08','17:15:00',1.78),('325','2013-09-08','17:20:00',1.51),('325','2013-09-08','17:25:00',1.48),('325','2013-09-08','17:30:00',1.34),('325','2013-09-08','17:45:00',1.06),('325','2013-09-08','17:50:00',1.05),('325','2014-04-11','08:35:00',1.22),('325','2014-04-11','08:40:00',1.32),('325','2014-04-11','08:45:00',1.38),('325','2014-04-11','08:50:00',1.37),('325','2014-04-11','08:55:00',1.37),('325','2014-04-11','09:00:00',1.33),('325','2014-04-11','09:05:00',1.41),('325','2014-04-11','09:10:00',1.75),('325','2014-04-11','09:15:00',1.65),('325','2014-04-11','09:20:00',1.54),('325','2014-04-11','09:25:00',1.58),('325','2014-04-11','09:30:00',1.63),('325','2014-04-11','09:35:00',1.66),('325','2014-04-11','09:40:00',1.71),('325','2014-04-11','09:45:00',1.75),('325','2014-04-11','09:50:00',1.8),('325','2014-04-11','09:55:00',1.85),('325','2014-04-11','10:00:00',1.89),('325','2014-04-11','10:05:00',1.94),('325','2014-04-11','10:10:00',1.97),('325','2014-04-11','10:15:00',3.2),('325','2014-04-11','10:20:00',3.4),('325','2014-04-11','10:25:00',3.48),('325','2014-04-11','10:30:00',3.54),('325','2014-04-11','10:35:00',3.6),('325','2014-04-11','10:40:00',3.69),('325','2014-04-11','10:45:00',3.77),('325','2014-04-11','10:50:00',3.83),('325','2014-04-11','10:55:00',3.92),('325','2014-04-11','11:00:00',4),('325','2014-04-11','11:05:00',4.04),('325','2014-04-11','11:10:00',4.06),('325','2014-04-11','11:15:00',4.1),('325','2014-04-11','11:20:00',4.17),('325','2014-04-11','11:25:00',4.22),('325','2014-04-11','11:30:00',4.28),('325','2014-04-11','11:35:00',4.33),('325','2014-04-11','11:40:00',4.34),('325','2014-04-11','11:45:00',4.41),('325','2014-04-11','11:50:00',4.48),('325','2014-04-11','11:55:00',4.69),('325','2014-04-11','12:00:00',4.69),('325','2014-04-11','12:05:00',4.59),('325','2014-04-11','12:10:00',4.52),('325','2014-04-11','12:15:00',4.4),('325','2014-04-11','12:20:00',4.64),('325','2014-04-11','12:25:00',4.73),('325','2014-04-11','12:30:00',4.82),('325','2014-04-11','12:35:00',4.76),('325','2014-04-11','12:40:00',4.79),('325','2014-04-11','12:45:00',4.45),('325','2014-04-11','12:50:00',5.18),('325','2014-04-11','12:55:00',4.91),('325','2014-04-11','13:00:00',3.35),('325','2014-04-11','13:05:00',4.3),('325','2014-04-11','13:10:00',3.54),('325','2014-04-11','13:15:00',4.02),('325','2014-04-11','13:20:00',4.03),('325','2014-04-11','13:25:00',4.17),('325','2014-04-11','13:30:00',2.46),('325','2014-04-11','13:35:00',4.68),('325','2014-04-11','13:40:00',3.6),('325','2014-04-11','13:45:00',4.81),('325','2014-04-11','13:50:00',3.3),('325','2014-04-11','13:55:00',5.12),('325','2014-04-11','14:00:00',2.2),('325','2014-04-11','14:05:00',4.94),('325','2014-04-11','14:10:00',3.24),('325','2014-04-11','14:15:00',3.24),('325','2014-04-11','14:20:00',3.08),('325','2014-04-11','14:25:00',4.15),('325','2014-04-11','14:30:00',4.7),('325','2014-04-11','14:35:00',4.78),('325','2014-04-11','14:40:00',2.53),('325','2014-04-11','14:45:00',3.88),('325','2014-04-11','14:50:00',4.69),('325','2014-04-11','14:55:00',4.29),('325','2014-04-11','15:00:00',5.05),('325','2014-04-11','15:05:00',4.35),('325','2014-04-11','15:10:00',4.3),('325','2014-04-11','15:15:00',3.55),('325','2014-04-11','15:20:00',3.97),('325','2014-04-11','15:25:00',3.83),('325','2014-04-11','15:30:00',3.9),('325','2014-04-11','15:35:00',2.23),('325','2014-04-11','15:40:00',3.91),('325','2014-04-11','15:45:00',3.66),('325','2014-04-11','15:50:00',3.63),('325','2014-04-11','15:55:00',3.64),('325','2014-04-11','16:00:00',3.51),('325','2014-04-11','16:05:00',3.4),('325','2014-04-11','16:10:00',3.21),('325','2014-04-11','16:15:00',3.25),('325','2014-04-11','16:20:00',3.04),('325','2014-04-11','16:25:00',3.09),('325','2014-04-11','16:30:00',3.02),('325','2014-04-11','16:35:00',2.55),('325','2014-04-11','16:40:00',2.59),('325','2014-04-11','16:45:00',2.3),('325','2014-04-11','16:50:00',1.64),('325','2014-04-11','16:55:00',2.44),('325','2014-04-11','17:00:00',2.38),('325','2014-04-11','17:05:00',2.43),('325','2014-04-11','17:10:00',2.3),('325','2014-04-11','17:15:00',1.93),('325','2014-04-11','17:20:00',2.15),('325','2014-04-11','17:25:00',2.04),('325','2014-04-11','17:30:00',2),('325','2014-04-11','17:35:00',1.92),('325','2014-04-11','17:40:00',1.81),('325','2014-04-11','17:45:00',1.62),('325','2014-04-11','17:50:00',1.48),('325','2014-04-11','17:55:00',1.36),('325','2014-04-11','18:00:00',1.25),('325','2014-04-11','18:05:00',1.15),('325','2014-04-11','18:10:00',1.05),('325','2013-09-07','09:05:00',1.02),('325','2013-09-07','09:10:00',1.09),('325','2013-09-07','09:15:00',1.14),('325','2013-09-07','09:20:00',1.19),('325','2013-09-07','09:25:00',1.25),('325','2013-09-07','09:30:00',1.31),('325','2013-09-07','09:35:00',1.36),('325','2013-09-07','09:40:00',1.39),('325','2013-09-07','09:45:00',1.42),('325','2013-09-07','09:50:00',1.47),('325','2013-09-07','09:55:00',1.52),('325','2013-09-07','10:00:00',2.34),('325','2013-09-07','10:05:00',2.61),('325','2013-09-07','10:10:00',2.71),('325','2013-09-07','10:15:00',2.78),('325','2013-09-07','10:20:00',2.89),('325','2013-09-07','10:25:00',2.95),('325','2013-09-07','10:30:00',2.99),('325','2013-09-07','10:35:00',3.08),('325','2013-09-07','10:40:00',3.17),('325','2013-09-07','10:45:00',3.21),('325','2013-09-07','10:50:00',3.28),('325','2013-09-07','10:55:00',3.36),('325','2013-09-07','11:00:00',3.39),('325','2013-09-07','11:05:00',3.42),('325','2013-09-07','11:10:00',3.47),('325','2013-09-07','11:15:00',3.51),('325','2013-09-07','11:20:00',3.54),('325','2013-09-07','11:25:00',3.59),('325','2013-09-07','11:30:00',3.65),('325','2013-09-07','11:35:00',3.7),('325','2013-09-07','11:40:00',3.73),('325','2013-09-07','11:45:00',3.74),('325','2013-09-07','11:50:00',3.78),('325','2013-09-07','11:55:00',3.84),('325','2013-09-07','12:00:00',3.85),('325','2013-09-07','12:05:00',3.89),('325','2013-09-07','12:10:00',3.91),('325','2013-09-07','12:15:00',3.93),('325','2013-09-07','12:20:00',3.95),('325','2013-09-07','12:25:00',3.95),('325','2013-09-07','12:30:00',3.96),('325','2013-09-07','12:35:00',3.98),('325','2013-09-07','12:40:00',3.94),('325','2013-09-07','12:45:00',3.94),('325','2013-09-07','12:50:00',3.96),('325','2013-09-07','12:55:00',3.9),('325','2013-09-07','13:00:00',3.99),('325','2013-09-07','13:05:00',4.02),('325','2013-09-07','13:10:00',3.99),('325','2013-09-07','13:15:00',3.97),('325','2013-09-07','13:20:00',3.99),('325','2013-09-07','13:25:00',4.06),('325','2013-09-07','13:30:00',4.06),('325','2013-09-07','13:35:00',3.99),('325','2013-09-07','13:40:00',3.95),('325','2013-09-07','13:45:00',3.98),('325','2013-09-07','13:50:00',4),('325','2013-09-07','13:55:00',3.81),('325','2013-09-07','14:00:00',4.03),('325','2013-09-07','14:05:00',4.01),('325','2013-09-07','14:10:00',3.99),('325','2013-09-07','14:15:00',3.95),('325','2013-09-07','14:20:00',3.87),('325','2013-09-07','14:25:00',3.81),('325','2013-09-07','14:30:00',3.86),('325','2013-09-07','14:35:00',3.84),('325','2013-09-07','14:40:00',3.8),('325','2013-09-07','14:45:00',3.8),('325','2013-09-07','14:50:00',3.74),('325','2013-09-07','14:55:00',3.73),('325','2013-09-07','15:00:00',3.67),('325','2013-09-07','15:05:00',3.62),('325','2013-09-07','15:10:00',3.58),('325','2013-09-07','15:15:00',3.55),('325','2013-09-07','15:20:00',3.53),('325','2013-09-07','15:25:00',3.49),('325','2013-09-07','15:30:00',3.42),('325','2013-09-07','15:35:00',3.34),('325','2013-09-07','15:40:00',3.24),('325','2013-09-07','15:45:00',3.19),('325','2013-09-07','15:50:00',3.13),('325','2013-09-07','15:55:00',3.05),('325','2013-09-07','16:00:00',3),('325','2013-09-07','16:05:00',2.92),('325','2013-09-07','16:10:00',2.86),('325','2013-09-07','16:15:00',2.78),('325','2013-09-07','16:20:00',2.69),('325','2013-09-07','16:25:00',2.6),('325','2013-09-07','16:30:00',2.53),('325','2013-09-07','16:35:00',2.45),('325','2013-09-07','16:40:00',2.32),('325','2013-09-07','16:45:00',2.24),('325','2013-09-07','16:50:00',2.17),('325','2013-09-07','16:55:00',2.09),('325','2013-09-07','17:00:00',1.99),('325','2013-09-07','17:05:00',1.9),('325','2013-09-07','17:10:00',1.82),('325','2013-09-07','17:15:00',1.73),('325','2013-09-07','17:20:00',1.64),('325','2013-09-07','17:25:00',1.51),('325','2013-09-07','17:30:00',1.4),('325','2013-09-07','17:35:00',1.33),('325','2013-09-07','17:40:00',1.26),('325','2013-09-07','17:45:00',1.17),('325','2013-09-07','17:50:00',1.08),('325','2013-09-06','09:05:00',1.04),('325','2013-09-06','09:10:00',1.15),('325','2013-09-06','09:15:00',1.19),('325','2013-09-06','09:20:00',1.24),('325','2013-09-06','09:25:00',1.27),('325','2013-09-06','09:30:00',1.32),('325','2013-09-06','09:35:00',1.34),('325','2013-09-06','09:40:00',1.37),('325','2013-09-06','09:45:00',1.4),('325','2013-09-06','09:50:00',1.45),('325','2013-09-06','09:55:00',1.5),('325','2013-09-06','10:00:00',1.74),('325','2013-09-06','10:05:00',2.62),('325','2013-09-06','10:10:00',2.74),('325','2013-09-06','10:15:00',2.84),('325','2013-09-06','10:20:00',2.9),('325','2013-09-06','10:25:00',2.98),('325','2013-09-06','10:30:00',3.05),('325','2013-09-06','10:35:00',3.15),('325','2013-09-06','10:40:00',3.27),('325','2013-09-06','10:45:00',3.32),('325','2013-09-06','10:50:00',3.36),('325','2013-09-06','10:55:00',3.42),('325','2013-09-06','11:00:00',3.48),('325','2013-09-06','11:05:00',3.51),('325','2013-09-06','11:10:00',3.57),('325','2013-09-06','11:15:00',3.62),('325','2013-09-06','11:20:00',3.64),('325','2013-09-06','11:25:00',3.67),('325','2013-09-06','11:30:00',3.71),('325','2013-09-06','11:35:00',3.77),('325','2013-09-06','11:40:00',3.81),('325','2013-09-06','11:45:00',3.83),('325','2013-09-06','11:50:00',3.84),('325','2013-09-06','11:55:00',3.91),('325','2013-09-06','12:00:00',3.89),('325','2013-09-06','12:05:00',3.87),('325','2013-09-06','12:10:00',3.87),('325','2013-09-06','12:15:00',3.96),('325','2013-09-06','12:20:00',4),('325','2013-09-06','12:25:00',3.98),('325','2013-09-06','12:30:00',3.99),('325','2013-09-06','12:35:00',4.02),('325','2013-09-06','12:40:00',4.05),('325','2013-09-06','12:45:00',4.09),('325','2013-09-06','12:50:00',4.06),('325','2013-09-06','12:55:00',4.03),('325','2013-09-06','13:00:00',4.03),('325','2013-09-06','13:05:00',4.02),('325','2013-09-06','13:10:00',4.03),('325','2013-09-06','13:15:00',4.04),('325','2013-09-06','13:20:00',4.03),('325','2013-09-06','13:25:00',4),('325','2013-09-06','13:30:00',4),('325','2013-09-06','13:35:00',3.97),('325','2013-09-06','13:40:00',3.97),('325','2013-09-06','13:45:00',3.95),('325','2013-09-06','13:50:00',3.93),('325','2013-09-06','13:55:00',3.87),('325','2013-09-06','14:00:00',3.84),('325','2013-09-06','14:05:00',3.85),('325','2013-09-06','14:10:00',3.84),('325','2013-09-06','14:15:00',3.84),('325','2013-09-06','14:20:00',3.81),('325','2013-09-06','14:25:00',3.81),('325','2013-09-06','14:30:00',3.7),('325','2013-09-06','14:35:00',3.6),('325','2013-09-06','14:40:00',3.69),('325','2013-09-06','14:45:00',3.6),('325','2013-09-06','14:50:00',3.65),('325','2013-09-06','14:55:00',3.72),('325','2013-09-06','15:00:00',3.66),('325','2013-09-06','15:05:00',3.59),('325','2013-09-06','15:10:00',3.5),('325','2013-09-06','15:15:00',3.48),('325','2013-09-06','15:20:00',3.46),('325','2013-09-06','15:25:00',3.4),('325','2013-09-06','15:30:00',3.33),('325','2013-09-06','15:35:00',3.21),('325','2013-09-06','15:40:00',3.21),('325','2013-09-06','15:45:00',3.18),('325','2013-09-06','15:50:00',3.12),('325','2013-09-06','15:55:00',3.06),('325','2013-09-06','16:00:00',2.97),('325','2013-09-06','16:05:00',2.9),('325','2013-09-06','16:10:00',2.83),('325','2013-09-06','16:15:00',2.76),('325','2013-09-06','16:20:00',2.69),('325','2013-09-06','16:25:00',2.64),('325','2013-09-06','16:30:00',2.59),('325','2013-09-06','16:35:00',2.5),('325','2013-09-06','16:40:00',2.39),('325','2013-09-06','16:45:00',2.22),('325','2013-09-06','16:50:00',2.22),('325','2013-09-06','16:55:00',2.11),('325','2013-09-06','17:00:00',2.05),('325','2013-09-06','17:05:00',1.93),('325','2013-09-06','17:10:00',1.83),('325','2013-09-06','17:15:00',1.78),('325','2013-09-06','17:20:00',1.66),('325','2013-09-06','17:25:00',1.52),('325','2013-09-06','17:30:00',1.43),('325','2013-09-06','17:35:00',1.35),('325','2013-09-06','17:40:00',1.29),('325','2013-09-06','17:45:00',1.19),('325','2013-09-06','17:50:00',1.08),('325','2013-09-05','08:50:00',1),('325','2013-09-05','08:55:00',1.05),('325','2013-09-05','09:00:00',1.08),('325','2013-09-05','09:05:00',1.12),('325','2013-09-05','09:10:00',1.18),('325','2013-09-05','09:15:00',1.24),('325','2013-09-05','09:20:00',1.27),('325','2013-09-05','09:25:00',1.3),('325','2013-09-05','09:30:00',1.34),('325','2013-09-05','09:35:00',1.37),('325','2013-09-05','09:40:00',1.38),('325','2013-09-05','09:45:00',1.41),('325','2013-09-05','09:50:00',1.45),('325','2013-09-05','09:55:00',1.51),('325','2013-09-05','10:00:00',1.56),('325','2013-09-05','10:05:00',1.62),('325','2013-09-05','10:10:00',1.67),('325','2013-09-05','10:15:00',2.84),('325','2013-09-05','10:20:00',3.03),('325','2013-09-05','10:25:00',3.1),('325','2013-09-05','10:30:00',3.16),('325','2013-09-05','10:35:00',3.24),('325','2013-09-05','10:40:00',3.33),('325','2013-09-05','10:45:00',3.41),('325','2013-09-05','10:50:00',3.46),('325','2013-09-05','10:55:00',3.56),('325','2013-09-05','11:00:00',3.61),('325','2013-09-05','11:05:00',3.66),('325','2013-09-05','11:10:00',3.69),('325','2013-09-05','11:15:00',3.71),('325','2013-09-05','11:20:00',3.72),('325','2013-09-05','11:25:00',3.82),('325','2013-09-05','11:30:00',3.79),('325','2013-09-05','11:35:00',3.77),('325','2013-09-05','11:40:00',3.8),('325','2013-09-05','11:45:00',3.82),('325','2013-09-05','11:50:00',3.88),('325','2013-09-05','11:55:00',3.99),('325','2013-09-05','12:00:00',3.99),('325','2013-09-05','12:05:00',4.03),('325','2013-09-05','12:10:00',4.07),('325','2013-09-05','12:15:00',4.09),('325','2013-09-05','12:20:00',4.1),('325','2013-09-05','12:25:00',4.13),('325','2013-09-05','12:30:00',4.13),('325','2013-09-05','12:35:00',4.15),('325','2013-09-05','12:40:00',4.14),('325','2013-09-05','12:45:00',4.18),('325','2013-09-05','12:50:00',4.2),('325','2013-09-05','12:55:00',4.18),('325','2013-09-05','13:00:00',4.15),('325','2013-09-05','13:05:00',4.16),('325','2013-09-05','13:10:00',4.16),('325','2013-09-05','13:15:00',4.14),('325','2013-09-05','13:20:00',4.15),('325','2013-09-05','13:25:00',4.17),('325','2013-09-05','13:30:00',4.15),('325','2013-09-05','13:35:00',4.11),('325','2013-09-05','13:40:00',4.08),('325','2013-09-05','13:45:00',4.03),('325','2013-09-05','13:50:00',4.01),('325','2013-09-05','13:55:00',4.04),('325','2013-09-05','14:00:00',4.05),('325','2013-09-05','14:05:00',4.06),('325','2013-09-05','14:10:00',4.07),('325','2013-09-05','14:15:00',4.02),('325','2013-09-05','14:20:00',3.95),('325','2013-09-05','14:25:00',3.91),('325','2013-09-05','14:30:00',3.88),('325','2013-09-05','14:35:00',3.82),('325','2013-09-05','14:40:00',3.83),('325','2013-09-05','14:45:00',3.8),('325','2013-09-05','14:50:00',3.78),('325','2013-09-05','14:55:00',3.78),('325','2013-09-05','15:00:00',3.77),('325','2013-09-05','15:05:00',3.75),('325','2013-09-05','15:10:00',3.65),('325','2013-09-05','15:15:00',3.63),('325','2013-09-05','15:20:00',3.58),('325','2013-09-05','15:25:00',3.51),('325','2013-09-05','15:30:00',3.45),('325','2013-09-05','15:35:00',3.41),('325','2013-09-05','15:40:00',3.35),('325','2013-09-05','15:45:00',3.29),('325','2013-09-05','15:50:00',3.24),('325','2013-09-05','15:55:00',3.2),('325','2013-09-05','16:00:00',3.12),('325','2013-09-05','16:05:00',3.07),('325','2013-09-05','16:10:00',3),('325','2013-09-05','16:15:00',2.93),('325','2013-09-05','16:20:00',2.86),('325','2013-09-05','16:25:00',2.79),('325','2013-09-05','16:30:00',2.75),('325','2013-09-05','16:35:00',2.72),('325','2013-09-05','16:40:00',2.62),('325','2013-09-05','16:45:00',2.51),('325','2013-09-05','16:50:00',2.15),('325','2013-09-05','16:55:00',1.74),('325','2013-09-05','17:00:00',1.39),('325','2013-09-05','17:05:00',1.52),('325','2013-09-05','17:10:00',1.52),('325','2013-09-05','17:15:00',1.34),('325','2013-09-05','17:20:00',1.5),('325','2013-09-05','17:25:00',1.49),('325','2013-09-05','17:30:00',1.41),('325','2013-09-05','17:35:00',1.51),('325','2013-09-05','17:40:00',1.61),('325','2013-09-05','17:45:00',1.4),('325','2013-09-05','17:50:00',1.29),('325','2013-09-05','17:55:00',1.08),('325','2013-09-04','08:55:00',1.03),('325','2013-09-04','09:00:00',1.08),('325','2013-09-04','09:05:00',1.11),('325','2013-09-04','09:10:00',1.16),('325','2013-09-04','09:15:00',1.23),('325','2013-09-04','09:20:00',1.27),('325','2013-09-04','09:25:00',1.3),('325','2013-09-04','09:30:00',1.33),('325','2013-09-04','09:35:00',1.36),('325','2013-09-04','09:40:00',1.37),('325','2013-09-04','09:45:00',1.46),('325','2013-09-04','09:50:00',1.54),('325','2013-09-04','09:55:00',1.6),('325','2013-09-04','10:00:00',1.63),('325','2013-09-04','10:05:00',1.66),('325','2013-09-04','10:10:00',1.69),('325','2013-09-04','10:15:00',2.44),('325','2013-09-04','10:20:00',3.09),('325','2013-09-04','10:25:00',3.15),('325','2013-09-04','10:30:00',3.21),('325','2013-09-04','10:35:00',3.31),('325','2013-09-04','10:40:00',3.43),('325','2013-09-04','10:45:00',3.5),('325','2013-09-04','10:50:00',3.59),('325','2013-09-04','10:55:00',3.67),('325','2013-09-04','11:00:00',3.72),('325','2013-09-04','11:05:00',3.76),('325','2013-09-04','11:10:00',3.8),('325','2013-09-04','11:15:00',3.83),('325','2013-09-04','11:20:00',3.88),('325','2013-09-04','11:25:00',3.92),('325','2013-09-04','11:30:00',3.96),('325','2013-09-04','11:35:00',3.98),('325','2013-09-04','11:40:00',4.01),('325','2013-09-04','11:45:00',4.05),('325','2013-09-04','11:50:00',4.09),('325','2013-09-04','11:55:00',4.16),('325','2013-09-04','12:00:00',4.19),('325','2013-09-04','12:05:00',4.19),('325','2013-09-04','12:10:00',4.21),('325','2013-09-04','12:15:00',4.2),('325','2013-09-04','12:20:00',4.22),('325','2013-09-04','12:25:00',4.26),('325','2013-09-04','12:30:00',4.26),('325','2013-09-04','12:35:00',4.28),('325','2013-09-04','12:40:00',4.3),('325','2013-09-04','12:45:00',4.29),('325','2013-09-04','12:50:00',4.28),('325','2013-09-04','12:55:00',4.29),('325','2013-09-04','13:00:00',4.29),('325','2013-09-04','13:05:00',4.27),('325','2013-09-04','13:10:00',4.28),('325','2013-09-04','13:15:00',4.29),('325','2013-09-04','13:20:00',4.27),('325','2013-09-04','13:25:00',4.27),('325','2013-09-04','13:30:00',4.27),('325','2013-09-04','13:35:00',4.27),('325','2013-09-04','13:40:00',4.26),('325','2013-09-04','13:45:00',4.22),('325','2013-09-04','13:50:00',4.18),('325','2013-09-04','13:55:00',4.17),('325','2013-09-04','14:00:00',4.15),('325','2013-09-04','14:05:00',4.15),('325','2013-09-04','14:10:00',4.15),('325','2013-09-04','14:15:00',4.13),('325','2013-09-04','14:20:00',4.09),('325','2013-09-04','14:25:00',4.08),('325','2013-09-04','14:30:00',4.05),('325','2013-09-04','14:35:00',4.01),('325','2013-09-04','14:40:00',3.96),('325','2013-09-04','14:45:00',3.94),('325','2013-09-04','14:50:00',3.91),('325','2013-09-04','14:55:00',3.87),('325','2013-09-04','15:00:00',3.82),('325','2013-09-04','15:05:00',3.77),('325','2013-09-04','15:10:00',3.72),('325','2013-09-04','15:15:00',3.67),('325','2013-09-04','15:20:00',3.64),('325','2013-09-04','15:25:00',3.58),('325','2013-09-04','15:30:00',3.53),('325','2013-09-04','15:35:00',3.47),('325','2013-09-04','15:40:00',3.42),('325','2013-09-04','15:45:00',3.36),('325','2013-09-04','15:50:00',3.3),('325','2013-09-04','15:55:00',3.22),('325','2013-09-04','16:00:00',3.14),('325','2013-09-04','16:05:00',3.06),('325','2013-09-04','16:10:00',2.99),('325','2013-09-04','16:15:00',2.94),('325','2013-09-04','16:20:00',2.87),('325','2013-09-04','16:25:00',2.78),('325','2013-09-04','16:30:00',2.71),('325','2013-09-04','16:35:00',2.64),('325','2013-09-04','16:40:00',2.54),('325','2013-09-04','16:45:00',2.37),('325','2013-09-04','16:50:00',2.28),('325','2013-09-04','16:55:00',2.26),('325','2013-09-04','17:00:00',2.17),('325','2013-09-04','17:05:00',2.08),('325','2013-09-04','17:10:00',2),('325','2013-09-04','17:15:00',1.91),('325','2013-09-04','17:20:00',1.82),('325','2013-09-04','17:25:00',1.7),('325','2013-09-04','17:30:00',1.61),('325','2013-09-04','17:35:00',1.51),('325','2013-09-04','17:40:00',1.4),('325','2013-09-04','17:45:00',1.29),('325','2013-09-04','17:50:00',1.19),('325','2013-09-04','17:55:00',1.1),('325','2013-09-04','18:00:00',1),('325','2013-09-03','08:55:00',1.01),('325','2013-09-03','09:00:00',1.05),('325','2013-09-03','09:05:00',1.1),('325','2013-09-03','09:10:00',1.13),('325','2013-09-03','09:15:00',1.19),('325','2013-09-03','09:20:00',1.24),('325','2013-09-03','09:25:00',1.31),('325','2013-09-03','09:30:00',1.38),('325','2013-09-03','09:35:00',1.41),('325','2013-09-03','09:40:00',1.44),('325','2013-09-03','09:45:00',1.48),('325','2013-09-03','09:50:00',1.57),('325','2013-09-03','09:55:00',1.63),('325','2013-09-03','10:00:00',1.67),('325','2013-09-03','10:05:00',1.7),('325','2013-09-03','10:10:00',2.4),('325','2013-09-03','10:15:00',2.83),('325','2013-09-03','10:20:00',2.96),('325','2013-09-03','10:25:00',3.01),('325','2013-09-03','10:30:00',3.06),('325','2013-09-03','10:35:00',3.18),('325','2013-09-03','10:40:00',3.31),('325','2013-09-03','10:45:00',3.4),('325','2013-09-03','10:50:00',3.49),('325','2013-09-03','10:55:00',3.54),('325','2013-09-03','11:00:00',3.57),('325','2013-09-03','11:05:00',3.6),('325','2013-09-03','11:10:00',3.63),('325','2013-09-03','11:15:00',3.67),('325','2013-09-03','11:20:00',3.72),('325','2013-09-03','11:25:00',3.76),('325','2013-09-03','11:30:00',3.8),('325','2013-09-03','11:35:00',3.83),('325','2013-09-03','11:40:00',3.85),('325','2013-09-03','11:45:00',3.87),('325','2013-09-03','11:50:00',3.91),('325','2013-09-03','11:55:00',4),('325','2013-09-03','12:00:00',4.03),('325','2013-09-03','12:05:00',4.06),('325','2013-09-03','12:10:00',4.07),('325','2013-09-03','12:15:00',4.09),('325','2013-09-03','12:20:00',4.12),('325','2013-09-03','12:25:00',4.16),('325','2013-09-03','12:30:00',4.18),('325','2013-09-03','12:35:00',4.19),('325','2013-09-03','12:40:00',4.2),('325','2013-09-03','12:45:00',4.21),('325','2013-09-03','12:50:00',4.2),('325','2013-09-03','12:55:00',4.2),('325','2013-09-03','13:00:00',4.21),('325','2013-09-03','13:05:00',4.2),('325','2013-09-03','13:10:00',4.2),('325','2013-09-03','13:15:00',4.21),('325','2013-09-03','13:20:00',4.24),('325','2013-09-03','13:25:00',4.18),('325','2013-09-03','13:30:00',4.15),('325','2013-09-03','13:35:00',4.15),('325','2013-09-03','13:40:00',4.18),('325','2013-09-03','13:45:00',4.11),('325','2013-09-03','13:50:00',4.14),('325','2013-09-03','13:55:00',4.15),('325','2013-09-03','14:00:00',4.1),('325','2013-09-03','14:05:00',4.01),('325','2013-09-03','14:10:00',4.02),('325','2013-09-03','14:15:00',3.99),('325','2013-09-03','14:20:00',3.97),('325','2013-09-03','14:25:00',3.94),('325','2013-09-03','14:30:00',3.92),('325','2013-09-03','14:35:00',3.93),('325','2013-09-03','14:40:00',3.92),('325','2013-09-03','14:45:00',3.87),('325','2013-09-03','14:50:00',3.85),('325','2013-09-03','14:55:00',3.82),('325','2013-09-03','15:00:00',3.78),('325','2013-09-03','15:05:00',3.7),('325','2013-09-03','15:10:00',3.64),('325','2013-09-03','15:15:00',3.62),('325','2013-09-03','15:20:00',3.58),('325','2013-09-03','15:25:00',3.53),('325','2013-09-03','15:30:00',3.48),('325','2013-09-03','15:35:00',3.39),('325','2013-09-03','15:40:00',3.32),('325','2013-09-03','15:45:00',3.25),('325','2013-09-03','15:50:00',3.22),('325','2013-09-03','15:55:00',3.17),('325','2013-09-03','16:00:00',3.12),('325','2013-09-03','16:05:00',3.07),('325','2013-09-03','16:10:00',3),('325','2013-09-03','16:15:00',2.9),('325','2013-09-03','16:20:00',2.82),('325','2013-09-03','16:25:00',2.75),('325','2013-09-03','16:30:00',2.69),('325','2013-09-03','16:35:00',2.62),('325','2013-09-03','16:40:00',2.53),('325','2013-09-03','16:45:00',2.39),('325','2013-09-03','16:50:00',2.3),('325','2013-09-03','16:55:00',2.27),('325','2013-09-03','17:00:00',2.19),('325','2013-09-03','17:05:00',2.08),('325','2013-09-03','17:10:00',2),('325','2013-09-03','17:15:00',1.91),('325','2013-09-03','17:20:00',1.82),('325','2013-09-03','17:25:00',1.72),('325','2013-09-03','17:30:00',1.61),('325','2013-09-03','17:35:00',1.53),('325','2013-09-03','17:40:00',1.43),('325','2013-09-03','17:45:00',1.34),('325','2013-09-03','17:50:00',1.24),('325','2013-09-03','17:55:00',1.09),('325','2013-09-02','08:55:00',1.01),('325','2013-09-02','09:00:00',1.05),('325','2013-09-02','09:05:00',1.1),('325','2013-09-02','09:10:00',1.27),('325','2013-09-02','09:15:00',1.23),('325','2013-09-02','09:20:00',1.24),('325','2013-09-02','09:25:00',1.3),('325','2013-09-02','09:30:00',1.36),('325','2013-09-02','09:35:00',1.41),('325','2013-09-02','09:40:00',1.44),('325','2013-09-02','09:45:00',1.47),('325','2013-09-02','09:50:00',1.52),('325','2013-09-02','09:55:00',1.57),('325','2013-09-02','10:00:00',1.62),('325','2013-09-02','10:05:00',2.38),('325','2013-09-02','10:10:00',2.79),('325','2013-09-02','10:15:00',2.91),('325','2013-09-02','10:20:00',3),('325','2013-09-02','10:25:00',3.05),('325','2013-09-02','10:30:00',3.11),('325','2013-09-02','10:35:00',3.21),('325','2013-09-02','10:40:00',3.29),('325','2013-09-02','10:45:00',3.38),('325','2013-09-02','10:50:00',3.48),('325','2013-09-02','10:55:00',3.54),('325','2013-09-02','11:00:00',3.57),('325','2013-09-02','11:05:00',3.61),('325','2013-09-02','11:10:00',3.65),('325','2013-09-02','11:15:00',3.7),('325','2013-09-02','11:20:00',3.71),('325','2013-09-02','11:25:00',3.75),('325','2013-09-02','11:30:00',3.81),('325','2013-09-02','11:35:00',3.84),('325','2013-09-02','11:40:00',3.87),('325','2013-09-02','11:45:00',3.87),('325','2013-09-02','11:50:00',3.89),('325','2013-09-02','11:55:00',3.95),('325','2013-09-02','12:00:00',3.97),('325','2013-09-02','12:05:00',3.99),('325','2013-09-02','12:10:00',4.05),('325','2013-09-02','12:15:00',4.09),('325','2013-09-02','12:20:00',4.07),('325','2013-09-02','12:25:00',4.07),('325','2013-09-02','12:30:00',4.03),('325','2013-09-02','12:35:00',4.07),('325','2013-09-02','12:40:00',4.08),('325','2013-09-02','12:45:00',4.08),('325','2013-09-02','12:50:00',4.14),('325','2013-09-02','12:55:00',4.15),('325','2013-09-02','13:00:00',4.15),('325','2013-09-02','13:05:00',4.13),('325','2013-09-02','13:10:00',4.15),('325','2013-09-02','13:15:00',4.14),('325','2013-09-02','13:20:00',4.1),('325','2013-09-02','13:25:00',4.1),('325','2013-09-02','13:30:00',4.06),('325','2013-09-02','13:35:00',4.01),('325','2013-09-02','13:40:00',4.04),('325','2013-09-02','13:45:00',4.12),('325','2013-09-02','13:50:00',3.61),('325','2013-09-02','13:55:00',1.41),('325','2013-09-02','14:00:00',4.3),('325','2013-09-02','14:05:00',4.25),('325','2013-09-02','14:10:00',4.14),('325','2013-09-02','14:15:00',4.08),('325','2013-09-02','14:20:00',3.36),('325','2013-09-02','14:25:00',4.01),('325','2013-09-02','14:30:00',4.01),('325','2013-09-02','14:35:00',3.91),('325','2013-09-02','14:40:00',3.93),('325','2013-09-02','14:45:00',4.02),('325','2013-09-02','14:50:00',3.17),('325','2013-09-02','14:55:00',1.43),('325','2013-09-02','15:00:00',2.82),('325','2013-09-02','15:05:00',2.94),('325','2013-09-02','15:10:00',1.17),('325','2013-09-02','15:15:00',1.46),('325','2013-09-02','15:20:00',1.39),('325','2013-09-02','15:25:00',2.32),('325','2013-09-02','15:30:00',3.62),('325','2013-09-02','15:35:00',3.56),('325','2013-09-02','15:40:00',3.25),('325','2013-09-02','15:45:00',3.26),('325','2013-09-02','15:50:00',3.31),('325','2013-09-02','15:55:00',3.25),('325','2013-09-02','16:00:00',3.19),('325','2013-09-02','16:05:00',3.09),('325','2013-09-02','16:10:00',3.04),('325','2013-09-02','16:15:00',3),('325','2013-09-02','16:20:00',2.93),('325','2013-09-02','16:25:00',2.81),('325','2013-09-02','16:30:00',2.72),('325','2013-09-02','16:35:00',2.64),('325','2013-09-02','16:40:00',2.55),('325','2013-09-02','16:45:00',2.39),('325','2013-09-02','16:50:00',2.26),('325','2013-09-02','16:55:00',2.19),('325','2013-09-02','17:00:00',2.11),('325','2013-09-02','17:05:00',2.01),('325','2013-09-02','17:10:00',1.93),('325','2013-09-02','17:15:00',1.85),('325','2013-09-02','17:20:00',1.77),('325','2013-09-02','17:25:00',1.69),('325','2013-09-02','17:30:00',1.56),('325','2013-09-02','17:35:00',1.48),('325','2013-09-02','17:40:00',1.39),('325','2013-09-02','17:45:00',1.31),('325','2013-09-02','17:50:00',1.21),('325','2013-09-02','17:55:00',1.12),('325','2013-09-02','18:00:00',1.04),('325','2013-09-01','08:55:00',1.04),('325','2013-09-01','09:00:00',1.1),('325','2013-09-01','09:05:00',1.25),('325','2013-09-01','09:10:00',1.49),('325','2013-09-01','09:15:00',1.48),('325','2013-09-01','09:20:00',1.42),('325','2013-09-01','09:25:00',1.77),('325','2013-09-01','09:30:00',2.05),('325','2013-09-01','09:35:00',2.15),('325','2013-09-01','09:40:00',2.23),('325','2013-09-01','09:45:00',2.32),('325','2013-09-01','09:50:00',2.44),('325','2013-09-01','09:55:00',2.55),('325','2013-09-01','10:00:00',2.63),('325','2013-09-01','10:05:00',2.73),('325','2013-09-01','10:10:00',2.84),('325','2013-09-01','10:15:00',2.93),('325','2013-09-01','10:20:00',2.99),('325','2013-09-01','10:25:00',3.05),('325','2013-09-01','10:30:00',3.1),('325','2013-09-01','10:35:00',3.21),('325','2013-09-01','10:40:00',3.29),('325','2013-09-01','10:45:00',3.36),('325','2013-09-01','10:50:00',3.46),('325','2013-09-01','10:55:00',3.57),('325','2013-09-01','11:00:00',3.62),('325','2013-09-01','11:05:00',3.66),('325','2013-09-01','11:10:00',3.69),('325','2013-09-01','11:15:00',3.7),('325','2013-09-01','11:20:00',3.71),('325','2013-09-01','11:25:00',3.78),('325','2013-09-01','11:30:00',3.82),('325','2013-09-01','11:35:00',3.84),('325','2013-09-01','11:40:00',3.89),('325','2013-09-01','11:45:00',3.95),('325','2013-09-01','11:50:00',3.97),('325','2013-09-01','11:55:00',4.01),('325','2013-09-01','12:00:00',4.02),('325','2013-09-01','12:05:00',3.96),('325','2013-09-01','12:10:00',4.05),('325','2013-09-01','12:15:00',4.1),('325','2013-09-01','12:20:00',4.13),('325','2013-09-01','12:25:00',4),('325','2013-09-01','12:30:00',4.14),('325','2013-09-01','12:35:00',4.13),('325','2013-09-01','12:40:00',4.15),('325','2013-09-01','12:45:00',4.14),('325','2013-09-01','12:50:00',4.18),('325','2013-09-01','12:55:00',4.18),('325','2013-09-01','13:00:00',4.27),('325','2013-09-01','13:05:00',4.16),('325','2013-09-01','13:10:00',4.23),('325','2013-09-01','13:15:00',4.08),('325','2013-09-01','13:20:00',4.25),('325','2013-09-01','13:25:00',4.22),('325','2013-09-01','13:30:00',4.27),('325','2013-09-01','13:35:00',4.17),('325','2013-09-01','13:40:00',4.18),('325','2013-09-01','13:45:00',3.92),('325','2013-09-01','13:50:00',3.45),('325','2013-09-01','13:55:00',3.66),('325','2013-09-01','14:00:00',3.27),('325','2013-09-01','14:05:00',3.37),('325','2013-09-01','14:10:00',3.8),('325','2013-09-01','14:15:00',3.66),('325','2013-09-01','14:20:00',3.42),('325','2013-09-01','14:25:00',3.51),('325','2013-09-01','14:30:00',3.51),('325','2013-09-01','14:35:00',3.51),('325','2013-09-01','14:40:00',3.54),('325','2013-09-01','14:45:00',3.59),('325','2013-09-01','14:50:00',3.54),('325','2013-09-01','14:55:00',3.42),('325','2013-09-01','15:00:00',3.47),('325','2013-09-01','15:05:00',3.38),('325','2013-09-01','15:10:00',3.44),('325','2013-09-01','15:15:00',3.36),('325','2013-09-01','15:20:00',3.21),('325','2013-09-01','15:25:00',2.72),('325','2013-09-01','15:30:00',2.47),('325','2013-09-01','15:35:00',2.62),('325','2013-09-01','15:40:00',3.05),('325','2013-09-01','15:45:00',2.8),('325','2013-09-01','15:50:00',2.11),('325','2013-09-01','15:55:00',2.34),('325','2013-09-01','16:00:00',2.84),('325','2013-09-01','16:05:00',3),('325','2013-09-01','16:10:00',2.93),('325','2013-09-01','16:15:00',2.92),('325','2013-09-01','16:20:00',2.63),('325','2013-09-01','16:25:00',2.78),('325','2013-09-01','16:30:00',2.93),('325','2013-09-01','16:35:00',2.84),('325','2013-09-01','16:40:00',2.68),('325','2013-09-01','16:45:00',2.42),('325','2013-09-01','16:50:00',2.31),('325','2013-09-01','16:55:00',2.04),('325','2013-09-01','17:00:00',1.73),('325','2013-09-01','17:05:00',1.82),('325','2013-09-01','17:10:00',1.43),('325','2013-09-01','17:15:00',1.52),('325','2013-09-01','17:20:00',1.63),('325','2013-09-01','17:25:00',1.56),('325','2013-09-01','17:30:00',1.34),('325','2013-09-01','17:35:00',1.35),('325','2013-09-01','17:40:00',1.41),('325','2013-09-01','17:45:00',1.17),('325','2013-09-01','17:50:00',1.04),('325','2013-09-01','17:55:00',1.02),('325','2013-09-01','18:00:00',1.01),('325','2013-09-01','18:05:00',1),('325','2013-09-01','18:10:00',1.04),('325','2013-08-31','08:45:00',1.01),('325','2013-08-31','08:50:00',1.15),('325','2013-08-31','08:55:00',1.29),('325','2013-08-31','09:00:00',1.38),('325','2013-08-31','09:05:00',1.52),('325','2013-08-31','09:10:00',1.32),('325','2013-08-31','09:15:00',1.52),('325','2013-08-31','09:20:00',1.51),('325','2013-08-31','09:25:00',1.87),('325','2013-08-31','09:30:00',2.14),('325','2013-08-31','09:35:00',2.29),('325','2013-08-31','09:40:00',2.33),('325','2013-08-31','09:45:00',2.25),('325','2013-08-31','09:50:00',2.32),('325','2013-08-31','09:55:00',2.55),('325','2013-08-31','10:00:00',2.74),('325','2013-08-31','10:05:00',2.8),('325','2013-08-31','10:10:00',2.93),('325','2013-08-31','10:15:00',3),('325','2013-08-31','10:20:00',3.05),('325','2013-08-31','10:25:00',3.11),('325','2013-08-31','10:30:00',3.18),('325','2013-08-31','10:35:00',3.29),('325','2013-08-31','10:40:00',3.41),('325','2013-08-31','10:45:00',3.5),('325','2013-08-31','10:50:00',3.63),('325','2013-08-31','10:55:00',3.72),('325','2013-08-31','11:00:00',3.78),('325','2013-08-31','11:05:00',3.8),('325','2013-08-31','11:10:00',3.82),('325','2013-08-31','11:15:00',3.86),('325','2013-08-31','11:20:00',3.9),('325','2013-08-31','11:25:00',3.93),('325','2013-08-31','11:30:00',4.01),('325','2013-08-31','11:35:00',4.07),('325','2013-08-31','11:40:00',4.11),('325','2013-08-31','11:45:00',4.14),('325','2013-08-31','11:50:00',4.18),('325','2013-08-31','11:55:00',4.23),('325','2013-08-31','12:00:00',4.11),('325','2013-08-31','12:05:00',3.84),('325','2013-08-31','12:10:00',3.5),('325','2013-08-31','12:15:00',4),('325','2013-08-31','12:20:00',4.27),('325','2013-08-31','12:25:00',4.21),('325','2013-08-31','12:30:00',4.26),('325','2013-08-31','12:35:00',4.28),('325','2013-08-31','12:40:00',4.28),('325','2013-08-31','12:45:00',4.28),('325','2013-08-31','12:50:00',4.25),('325','2013-08-31','12:55:00',4.28),('325','2013-08-31','13:00:00',4.26),('325','2013-08-31','13:05:00',4.3),('325','2013-08-31','13:10:00',4.25),('325','2013-08-31','13:15:00',4.3),('325','2013-08-31','13:20:00',4.24),('325','2013-08-31','13:25:00',4.22),('325','2013-08-31','13:30:00',4.27),('325','2013-08-31','13:35:00',4.23),('325','2013-08-31','13:40:00',4.21),('325','2013-08-31','13:45:00',4.15),('325','2013-08-31','13:50:00',4.19),('325','2013-08-31','13:55:00',4.17),('325','2013-08-31','14:00:00',4.15),('325','2013-08-31','14:05:00',4.14),('325','2013-08-31','14:10:00',4.1),('325','2013-08-31','14:15:00',4.06),('325','2013-08-31','14:20:00',4.03),('325','2013-08-31','14:25:00',3.98),('325','2013-08-31','14:30:00',3.93),('325','2013-08-31','14:35:00',3.77),('325','2013-08-31','14:40:00',3.83),('325','2013-08-31','14:45:00',3.83),('325','2013-08-31','14:50:00',3.82),('325','2013-08-31','14:55:00',3.72),('325','2013-08-31','15:00:00',3.71),('325','2013-08-31','15:05:00',3.67),('325','2013-08-31','15:10:00',3.64),('325','2013-08-31','15:15:00',3.58),('325','2013-08-31','15:20:00',3.53),('325','2013-08-31','15:25:00',3.48),('325','2013-08-31','15:30:00',3.44),('325','2013-08-31','15:35:00',3.34),('325','2013-08-31','15:40:00',3.31),('325','2013-08-31','15:45:00',3.25),('325','2013-08-31','15:50:00',3.18),('325','2013-08-31','15:55:00',3.11),('325','2013-08-31','16:00:00',3.08),('325','2013-08-31','16:05:00',3.02),('325','2013-08-31','16:10:00',2.97),('325','2013-08-31','16:15:00',2.89),('325','2013-08-31','16:20:00',2.85),('325','2013-08-31','16:25:00',2.73),('325','2013-08-31','16:30:00',2.68),('325','2013-08-31','16:35:00',2.66),('325','2013-08-31','16:40:00',2.55),('325','2013-08-31','16:45:00',2.39),('325','2013-08-31','16:50:00',2.24),('325','2013-08-31','16:55:00',2.21),('325','2013-08-31','17:00:00',2.13),('325','2013-08-31','17:05:00',2.1),('325','2013-08-31','17:10:00',2.01),('325','2013-08-31','17:15:00',1.91),('325','2013-08-31','17:20:00',1.85),('325','2013-08-31','17:25:00',1.75),('325','2013-08-31','17:30:00',1.62),('325','2013-08-31','17:35:00',1.48),('325','2013-08-31','17:40:00',1.43),('325','2013-08-31','17:45:00',1.3),('325','2013-08-31','17:50:00',1.23),('325','2013-08-31','17:55:00',1.05),('325','2013-08-30','08:25:00',1.02),('325','2013-08-30','08:30:00',1.09),('325','2013-08-30','08:35:00',1.21),('325','2013-08-30','08:40:00',1.26),('325','2013-08-30','08:45:00',1.18),('325','2013-08-30','08:50:00',1.12),('325','2013-08-30','08:55:00',1.15),('325','2013-08-30','09:00:00',1.33),('325','2013-08-30','09:05:00',1.45),('325','2013-08-30','09:10:00',1.34),('325','2013-08-30','09:15:00',1.26),('325','2013-08-30','09:20:00',1.15),('325','2013-08-30','09:25:00',1.23),('325','2013-08-30','09:30:00',1.49),('325','2013-08-30','09:35:00',1.62),('325','2013-08-30','09:40:00',1.57),('325','2013-08-30','09:45:00',1.6),('325','2013-08-30','09:50:00',1.65),('325','2013-08-30','09:55:00',1.73),('325','2013-08-30','10:00:00',1.78),('325','2013-08-30','10:05:00',1.79),('325','2013-08-30','10:10:00',1.8),('325','2013-08-30','10:15:00',1.92),('325','2013-08-30','10:20:00',1.97),('325','2013-08-30','10:25:00',1.9),('325','2013-08-30','10:30:00',2.06),('325','2013-08-30','10:35:00',2.03),('325','2013-08-30','10:40:00',1.99),('325','2013-08-30','10:45:00',2),('325','2013-08-30','10:50:00',2.14),('325','2013-08-30','10:55:00',2.03),('325','2013-08-30','11:00:00',2.15),('325','2013-08-30','11:05:00',2.27),('325','2013-08-30','11:10:00',2.42),('325','2013-08-30','11:15:00',2.42),('325','2013-08-30','11:20:00',2.45),('325','2013-08-30','11:25:00',2.52),('325','2013-08-30','11:30:00',2.69),('325','2013-08-30','11:35:00',2.54),('325','2013-08-30','11:40:00',2.8),('325','2013-08-30','11:45:00',2.8),('325','2013-08-30','11:50:00',3.18),('325','2013-08-30','11:55:00',2.77),('325','2013-08-30','12:00:00',2.45),('325','2013-08-30','12:05:00',2.11),('325','2013-08-30','12:10:00',2.34),('325','2013-08-30','12:15:00',2.58),('325','2013-08-30','12:20:00',2.78),('325','2013-08-30','12:25:00',3.19),('325','2013-08-30','12:30:00',3.53),('325','2013-08-30','12:35:00',3.35),('325','2013-08-30','12:40:00',3.26),('325','2013-08-30','12:45:00',3.39),('325','2013-08-30','12:50:00',3.28),('325','2013-08-30','12:55:00',3.04),('325','2013-08-30','13:00:00',3.01),('325','2013-08-30','13:05:00',2.99),('325','2013-08-30','13:10:00',3),('325','2013-08-30','13:15:00',2.86),('325','2013-08-30','13:20:00',3.5),('325','2013-08-30','13:25:00',3.9),('325','2013-08-30','13:30:00',4.22),('325','2013-08-30','13:35:00',3.92),('325','2013-08-30','13:40:00',4.18),('325','2013-08-30','13:45:00',3.78),('325','2013-08-30','13:50:00',3.81),('325','2013-08-30','13:55:00',4.1),('325','2013-08-30','14:00:00',4.26),('325','2013-08-30','14:05:00',4.07),('325','2013-08-30','14:10:00',4.15),('325','2013-08-30','14:15:00',4.04),('325','2013-08-30','14:20:00',4.18),('325','2013-08-30','14:25:00',4.07),('325','2013-08-30','14:30:00',4.05),('325','2013-08-30','14:35:00',4.12),('325','2013-08-30','14:40:00',3.9),('325','2013-08-30','14:45:00',3.18),('325','2013-08-30','14:50:00',2.8),('325','2013-08-30','14:55:00',3.08),('325','2013-08-30','15:00:00',2.62),('325','2013-08-30','15:05:00',2.43),('325','2013-08-30','15:10:00',2.46),('325','2013-08-30','15:15:00',3.1),('325','2013-08-30','15:20:00',2.6),('325','2013-08-30','15:25:00',2.39),('325','2013-08-30','15:30:00',2.23),('325','2013-08-30','15:35:00',1.85),('325','2013-08-30','15:40:00',2.02),('325','2013-08-30','15:45:00',2.39),('325','2013-08-30','15:50:00',2.54),('325','2013-08-30','15:55:00',2.45),('325','2013-08-30','16:00:00',2.31),('325','2013-08-30','16:05:00',2.01),('325','2013-08-30','16:10:00',1.66),('325','2013-08-30','16:15:00',1.54),('325','2013-08-30','16:20:00',1.79),('325','2013-08-30','16:25:00',1.72),('325','2013-08-30','16:30:00',1.98),('325','2013-08-30','16:35:00',1.61),('325','2013-08-30','16:40:00',2.34),('325','2013-08-30','16:45:00',2.65),('325','2013-08-30','16:50:00',2.45),('325','2013-08-30','16:55:00',1.71),('325','2013-08-30','17:00:00',2.03),('325','2013-08-30','17:05:00',1.41),('325','2013-08-30','17:10:00',1.61),('325','2013-08-30','17:15:00',1.47),('325','2013-08-30','17:20:00',1.26),('325','2013-08-30','17:25:00',1.36),('325','2013-08-30','17:30:00',1.34),('325','2013-08-30','17:35:00',1.57),('325','2013-08-30','17:40:00',1.25),('325','2013-08-30','17:45:00',1.35),('325','2013-08-30','17:50:00',1.21),('325','2013-08-30','17:55:00',1.26),('325','2013-08-30','18:00:00',1.1),('325','2013-08-29','08:30:00',1.23),('325','2013-08-29','08:35:00',1.29),('325','2013-08-29','08:40:00',1.13),('325','2013-08-29','08:45:00',1),('325','2013-08-29','08:50:00',1.17),('325','2013-08-29','08:55:00',1.42),('325','2013-08-29','09:00:00',1.43),('325','2013-08-29','09:05:00',1.45),('325','2013-08-29','09:10:00',1.45),('325','2013-08-29','09:15:00',1.57),('325','2013-08-29','09:20:00',1.54),('325','2013-08-29','09:25:00',1.45),('325','2013-08-29','09:30:00',1.5),('325','2013-08-29','09:35:00',1.62),('325','2013-08-29','09:40:00',1.65),('325','2013-08-29','09:45:00',1.48),('325','2013-08-29','09:50:00',1.46),('325','2013-08-29','09:55:00',1.52),('325','2013-08-29','10:00:00',1.58),('325','2013-08-29','10:05:00',1.53),('325','2013-08-29','10:10:00',1.51),('325','2013-08-29','10:15:00',1.51),('325','2013-08-29','10:20:00',1.54),('325','2013-08-29','10:25:00',1.54),('325','2013-08-29','10:30:00',1.58),('325','2013-08-29','10:35:00',1.48),('325','2013-08-29','10:40:00',1.36),('325','2013-08-29','10:45:00',1.27),('325','2013-08-29','10:50:00',1.27),('325','2013-08-29','10:55:00',1.42),('325','2013-08-29','11:00:00',1.5),('325','2013-08-29','11:05:00',1.53),('325','2013-08-29','11:10:00',2.34),('325','2013-08-29','11:15:00',2.54),('325','2013-08-29','11:20:00',2.34),('325','2013-08-29','11:25:00',1.83),('325','2013-08-29','11:30:00',1.57),('325','2013-08-29','11:35:00',1.41),('325','2013-08-29','11:40:00',1.6),('325','2013-08-29','11:45:00',1.9),('325','2013-08-29','11:50:00',1.97),('325','2013-08-29','11:55:00',1.9),('325','2013-08-29','12:00:00',1.89),('325','2013-08-29','12:05:00',2.22),('325','2013-08-29','12:10:00',2.77),('325','2013-08-29','12:15:00',3.14),('325','2013-08-29','12:20:00',2.85),('325','2013-08-29','12:25:00',2.88),('325','2013-08-29','12:30:00',2.87),('325','2013-08-29','12:35:00',3.54),('325','2013-08-29','12:40:00',4.95),('325','2013-08-29','12:45:00',4.78),('325','2013-08-29','12:50:00',2.62),('325','2013-08-29','12:55:00',3.85),('325','2013-08-29','13:00:00',2.86),('325','2013-08-29','13:05:00',2.67),('325','2013-08-29','13:10:00',2.58),('325','2013-08-29','13:15:00',2.47),('325','2013-08-29','13:20:00',2.38),('325','2013-08-29','13:25:00',2.03),('325','2013-08-29','13:30:00',1.86),('325','2013-08-29','13:35:00',1.72),('325','2013-08-29','13:40:00',1.65),('325','2013-08-29','13:45:00',1.54),('325','2013-08-29','13:50:00',1.52),('325','2013-08-29','13:55:00',1.89),('325','2013-08-29','14:00:00',2.4),('325','2013-08-29','14:05:00',1.72),('325','2013-08-29','14:10:00',1.54),('325','2013-08-29','14:15:00',1.25),('325','2013-08-29','14:20:00',1.03),('325','2013-08-29','14:45:00',1),('325','2013-08-29','14:50:00',1.19),('325','2013-08-29','14:55:00',1.4),('325','2013-08-29','15:00:00',1.57),('325','2013-08-29','15:05:00',1.85),('325','2013-08-29','15:10:00',1.42),('325','2013-08-29','15:15:00',1.23),('325','2013-08-29','15:20:00',1.36),('325','2013-08-29','15:25:00',1.57),('325','2013-08-29','15:30:00',2.72),('325','2013-08-29','15:35:00',2.36),('325','2013-08-29','15:40:00',2.37),('325','2013-08-29','15:45:00',2.52),('325','2013-08-29','15:50:00',3.1),('325','2013-08-29','15:55:00',3.62),('325','2013-08-29','16:00:00',3.19),('325','2013-08-29','16:05:00',3.64),('325','2013-08-29','16:10:00',3.46),('325','2013-08-29','16:15:00',3.23),('325','2013-08-29','16:20:00',3.1),('325','2013-08-29','16:25:00',2.94),('325','2013-08-29','16:30:00',2.84),('325','2013-08-29','16:35:00',2.79),('325','2013-08-29','16:40:00',2.72),('325','2013-08-29','16:45:00',2.62),('325','2013-08-29','16:50:00',2.48),('325','2013-08-29','16:55:00',2.41),('325','2013-08-29','17:00:00',2.36),('325','2013-08-29','17:05:00',2.28),('325','2013-08-29','17:10:00',2.16),('325','2013-08-29','17:15:00',2.07),('325','2013-08-29','17:20:00',1.97),('325','2013-08-29','17:25:00',1.87),('325','2013-08-29','17:30:00',1.78),('325','2013-08-29','17:35:00',1.64),('325','2013-08-29','17:40:00',1.55),('325','2013-08-29','17:45:00',1.45),('325','2013-08-29','17:50:00',1.36),('325','2013-08-29','17:55:00',1.26),('325','2013-08-29','18:00:00',1.16),('325','2013-08-29','18:05:00',1.07),('325','2014-04-10','08:35:00',1.02),('325','2014-04-10','08:40:00',1.09),('325','2014-04-10','08:45:00',1.15),('325','2014-04-10','08:50:00',1.2),('325','2014-04-10','08:55:00',1.26),('325','2014-04-10','09:00:00',1.27),('325','2014-04-10','09:05:00',1.38),('325','2014-04-10','09:10:00',1.57),('325','2014-04-10','09:15:00',1.64),('325','2014-04-10','09:20:00',1.95),('325','2014-04-10','09:25:00',2.29),('325','2014-04-10','09:30:00',2.4),('325','2014-04-10','09:35:00',2.52),('325','2014-04-10','09:40:00',2.58),('325','2014-04-10','09:45:00',2.73),('325','2014-04-10','09:50:00',2.87),('325','2014-04-10','09:55:00',2.99),('325','2014-04-10','10:00:00',3.06),('325','2014-04-10','10:05:00',3.14),('325','2014-04-10','10:10:00',3.27),('325','2014-04-10','10:15:00',3.29),('325','2014-04-10','10:20:00',3.43),('325','2014-04-10','10:25:00',3.49),('325','2014-04-10','10:30:00',3.54),('325','2014-04-10','10:35:00',3.68),('325','2014-04-10','10:40:00',3.76),('325','2014-04-10','10:45:00',3.77),('325','2014-04-10','10:50:00',3.72),('325','2014-04-10','10:55:00',3.88),('325','2014-04-10','11:00:00',3.9),('325','2014-04-10','11:05:00',4.04),('325','2014-04-10','11:10:00',3.96),('325','2014-04-10','11:15:00',4.1),('325','2014-04-10','11:20:00',4.22),('325','2014-04-10','11:25:00',4.3),('325','2014-04-10','11:30:00',4.3),('325','2014-04-10','11:35:00',4.37),('325','2014-04-10','11:40:00',4.18),('325','2014-04-10','11:45:00',4.34),('325','2014-04-10','11:50:00',4.21),('325','2014-04-10','11:55:00',4.44),('325','2014-04-10','12:00:00',4.36),('325','2014-04-10','12:05:00',4.14),('325','2014-04-10','12:10:00',4.34),('325','2014-04-10','12:15:00',4.4),('325','2014-04-10','12:20:00',4.47),('325','2014-04-10','12:25:00',4.19),('325','2014-04-10','12:30:00',4.33),('325','2014-04-10','12:35:00',4.62),('325','2014-04-10','12:40:00',4.4),('325','2014-04-10','12:45:00',4.47),('325','2014-04-10','12:50:00',4.46),('325','2014-04-10','12:55:00',4.43),('325','2014-04-10','13:00:00',4.31),('325','2014-04-10','13:05:00',4.26),('325','2014-04-10','13:10:00',4.44),('325','2014-04-10','13:15:00',4.37),('325','2014-04-10','13:20:00',4.25),('325','2014-04-10','13:25:00',4.56),('325','2014-04-10','13:30:00',4.52),('325','2014-04-10','13:35:00',4.62),('325','2014-04-10','13:40:00',4.35),('325','2014-04-10','13:45:00',4.58),('325','2014-04-10','13:50:00',4.57),('325','2014-04-10','13:55:00',4.54),('325','2014-04-10','14:00:00',4.49),('325','2014-04-10','14:05:00',4.4),('325','2014-04-10','14:10:00',4.36),('325','2014-04-10','14:15:00',4.39),('325','2014-04-10','14:20:00',4.46),('325','2014-04-10','14:25:00',4.41),('325','2014-04-10','14:30:00',4.34),('325','2014-04-10','14:35:00',4.32),('325','2014-04-10','14:40:00',4.28),('325','2014-04-10','14:45:00',3.87),('325','2014-04-10','14:50:00',4.31),('325','2014-04-10','14:55:00',4.23),('325','2014-04-10','15:00:00',4.17),('325','2014-04-10','15:05:00',4.12),('325','2014-04-10','15:10:00',4),('325','2014-04-10','15:15:00',3.98),('325','2014-04-10','15:20:00',3.94),('325','2014-04-10','15:25:00',3.88),('325','2014-04-10','15:30:00',3.58),('325','2014-04-10','15:35:00',3.45),('325','2014-04-10','15:40:00',3.46),('325','2014-04-10','15:45:00',3.54),('325','2014-04-10','15:50:00',3.52),('325','2014-04-10','15:55:00',3.47),('325','2014-04-10','16:00:00',3.4),('325','2014-04-10','16:05:00',3.44),('325','2014-04-10','16:10:00',3.44),('325','2014-04-10','16:15:00',3.5),('325','2014-04-10','16:20:00',3.34),('325','2014-04-10','16:25:00',3.3),('325','2014-04-10','16:30:00',3.26),('325','2014-04-10','16:35:00',3.1),('325','2014-04-10','16:40:00',3.06),('325','2014-04-10','16:45:00',3.02),('325','2014-04-10','16:50:00',2.78),('325','2014-04-10','16:55:00',2.74),('325','2014-04-10','17:00:00',2.61),('325','2014-04-10','17:05:00',2.53),('325','2014-04-10','17:10:00',2.4),('325','2014-04-10','17:15:00',2.26),('325','2014-04-10','17:20:00',2.21),('325','2014-04-10','17:25:00',2.07),('325','2014-04-10','17:30:00',1.91),('325','2014-04-10','17:35:00',1.81),('325','2014-04-10','17:40:00',1.7),('325','2014-04-10','17:45:00',1.6),('325','2014-04-10','17:50:00',1.49),('325','2014-04-10','17:55:00',1.38),('325','2014-04-10','18:00:00',1.27),('325','2014-04-10','18:05:00',1.16),('325','2014-04-10','18:10:00',1.05),('325','2013-08-28','08:40:00',1.15),('325','2013-08-28','08:45:00',1.15),('325','2013-08-28','09:00:00',1.4),('325','2013-08-28','09:10:00',1.16),('325','2013-08-28','09:15:00',1.67),('325','2013-08-28','09:20:00',1.11),('325','2013-08-28','09:30:00',1.2),('325','2013-08-28','09:35:00',1.98),('325','2013-08-28','09:40:00',2.34),('325','2013-08-28','09:45:00',2.47),('325','2013-08-28','09:50:00',2.62),('325','2013-08-28','09:55:00',2.66),('325','2013-08-28','10:00:00',2.68),('325','2013-08-28','10:05:00',2.79),('325','2013-08-28','10:10:00',2.89),('325','2013-08-28','10:15:00',3.14),('325','2013-08-28','10:20:00',3.14),('325','2013-08-28','10:25:00',1.03),('325','2013-08-28','10:30:00',2.85),('325','2013-08-28','10:35:00',1.26),('325','2013-08-28','10:40:00',2.48),('325','2013-08-28','10:45:00',3.57),('325','2013-08-28','10:50:00',3.07),('325','2013-08-28','10:55:00',3.72),('325','2013-08-28','11:00:00',2.29),('325','2013-08-28','11:05:00',3.32),('325','2013-08-28','11:10:00',1.77),('325','2013-08-28','11:15:00',3.1),('325','2013-08-28','11:20:00',4.04),('325','2013-08-28','11:25:00',4.27),('325','2013-08-28','11:30:00',4.31),('325','2013-08-28','11:35:00',4.39),('325','2013-08-28','11:40:00',4.04),('325','2013-08-28','11:45:00',3.15),('325','2013-08-28','11:50:00',3.39),('325','2013-08-28','11:55:00',1.79),('325','2013-08-28','12:00:00',3.85),('325','2013-08-28','12:05:00',2.56),('325','2013-08-28','12:10:00',4.63),('325','2013-08-28','12:15:00',4.57),('325','2013-08-28','12:20:00',4.36),('325','2013-08-28','12:25:00',4.49),('325','2013-08-28','12:30:00',4.43),('325','2013-08-28','12:35:00',4.43),('325','2013-08-28','12:40:00',4.53),('325','2013-08-28','12:45:00',4.61),('325','2013-08-28','12:50:00',4.54),('325','2013-08-28','12:55:00',4.54),('325','2013-08-28','13:00:00',4.65),('325','2013-08-28','13:05:00',4.22),('325','2013-08-28','13:10:00',4.64),('325','2013-08-28','13:15:00',4.61),('325','2013-08-28','13:20:00',4.6),('325','2013-08-28','13:25:00',4.64),('325','2013-08-28','13:30:00',4.65),('325','2013-08-28','13:35:00',4.48),('325','2013-08-28','13:40:00',3.73),('325','2013-08-28','13:45:00',3.52),('325','2013-08-28','13:50:00',4.57),('325','2013-08-28','13:55:00',4.28),('325','2013-08-28','14:00:00',4.54),('325','2013-08-28','14:05:00',4.47),('325','2013-08-28','14:10:00',4.47),('325','2013-08-28','14:15:00',4.42),('325','2013-08-28','14:20:00',4.36),('325','2013-08-28','14:25:00',4.37),('325','2013-08-28','14:30:00',3.58),('325','2013-08-28','14:35:00',3.74),('325','2013-08-28','14:40:00',4.36),('325','2013-08-28','14:45:00',4.22),('325','2013-08-28','14:50:00',4.18),('325','2013-08-28','14:55:00',4.14),('325','2013-08-28','15:00:00',4.05),('325','2013-08-28','15:05:00',4.11),('325','2013-08-28','15:10:00',4.12),('325','2013-08-28','15:15:00',4.05),('325','2013-08-28','15:20:00',3.6),('325','2013-08-28','15:25:00',2.77),('325','2013-08-28','15:30:00',3.76),('325','2013-08-28','15:35:00',2.13),('325','2013-08-28','15:45:00',2.39),('325','2013-08-28','15:50:00',2.1),('325','2013-08-28','15:55:00',3.68),('325','2013-08-28','16:00:00',3.7),('325','2013-08-28','16:05:00',3.63),('325','2013-08-28','16:10:00',2.14),('325','2013-08-28','16:15:00',2.35),('325','2013-08-28','16:20:00',3),('325','2013-08-28','16:25:00',3.27),('325','2013-08-28','16:30:00',3.09),('325','2013-08-28','16:35:00',3.01),('325','2013-08-28','16:40:00',2.92),('325','2013-08-28','16:45:00',2.75),('325','2013-08-28','16:50:00',2.55),('325','2013-08-28','16:55:00',2.53),('325','2013-08-28','17:00:00',2.46),('325','2013-08-28','17:05:00',2.34),('325','2013-08-28','17:10:00',1.68),('325','2013-08-28','17:15:00',1.94),('325','2013-08-28','17:20:00',1.48),('325','2013-08-28','17:25:00',1.56),('325','2013-08-28','17:30:00',1.11),('325','2013-08-28','17:35:00',1.68),('325','2013-08-28','17:40:00',1.71),('325','2013-08-28','17:55:00',1.19),('325','2013-08-27','08:25:00',1.1),('325','2013-08-27','08:30:00',1.08),('325','2013-08-27','09:15:00',1.22),('325','2013-08-27','09:20:00',1.5),('325','2013-08-27','09:25:00',1.85),('325','2013-08-27','09:30:00',1.95),('325','2013-08-27','09:35:00',1.14),('325','2013-08-27','09:45:00',1.01),('325','2013-08-27','09:50:00',1.05),('325','2013-08-27','09:55:00',1.23),('325','2013-08-27','10:00:00',1.54),('325','2013-08-27','10:05:00',2.26),('325','2013-08-27','10:10:00',2.77),('325','2013-08-27','10:15:00',2.84),('325','2013-08-27','10:20:00',2.99),('325','2013-08-27','10:25:00',3.04),('325','2013-08-27','10:30:00',3.06),('325','2013-08-27','10:35:00',3.18),('325','2013-08-27','10:40:00',3.13),('325','2013-08-27','10:45:00',3.27),('325','2013-08-27','10:50:00',3.39),('325','2013-08-27','10:55:00',3.44),('325','2013-08-27','11:00:00',3.54),('325','2013-08-27','11:05:00',3.65),('325','2013-08-27','11:10:00',3.69),('325','2013-08-27','11:15:00',3.67),('325','2013-08-27','11:20:00',3.2),('325','2013-08-27','11:25:00',3.48),('325','2013-08-27','11:30:00',3.64),('325','2013-08-27','11:35:00',3.74),('325','2013-08-27','11:40:00',3.5),('325','2013-08-27','11:45:00',4.28),('325','2013-08-27','11:50:00',3.22),('325','2013-08-27','11:55:00',4.2),('325','2013-08-27','12:00:00',4.51),('325','2013-08-27','12:05:00',4.06),('325','2013-08-27','12:10:00',3.33),('325','2013-08-27','12:15:00',4.18),('325','2013-08-27','12:20:00',4.26),('325','2013-08-27','12:25:00',3.74),('325','2013-08-27','12:30:00',3.16),('325','2013-08-27','12:35:00',4.62),('325','2013-08-27','12:40:00',3.11),('325','2013-08-27','12:45:00',3.06),('325','2013-08-27','12:50:00',1.91),('325','2013-08-27','12:55:00',1.5),('325','2013-08-27','13:00:00',1.23),('325','2013-08-27','13:05:00',1.46),('325','2013-08-27','13:10:00',1.77),('325','2013-08-27','13:15:00',1.94),('325','2013-08-27','13:20:00',2.35),('325','2013-08-27','13:25:00',2.45),('325','2013-08-27','13:30:00',2.54),('325','2013-08-27','13:35:00',1.92),('325','2013-08-27','13:40:00',1.83),('325','2013-08-27','13:45:00',2.57),('325','2013-08-27','13:50:00',3.81),('325','2013-08-27','13:55:00',2.92),('325','2013-08-27','14:00:00',3.75),('325','2013-08-27','14:05:00',2.24),('325','2013-08-27','14:10:00',2.92),('325','2013-08-27','14:15:00',3.23),('325','2013-08-27','14:20:00',2.26),('325','2013-08-27','14:25:00',1.29),('325','2013-08-27','14:30:00',1.25),('325','2013-08-27','14:35:00',1.05),('325','2013-08-27','14:40:00',1.22),('325','2013-08-27','14:45:00',1.22),('325','2013-08-27','15:55:00',1.63),('325','2013-08-27','16:00:00',1.66),('325','2013-08-27','16:05:00',1.98),('325','2013-08-27','16:10:00',3.82),('325','2013-08-27','16:15:00',3.62),('325','2013-08-27','16:20:00',2.41),('325','2013-08-27','16:25:00',2.37),('325','2013-08-27','16:35:00',1.21),('325','2013-08-27','16:40:00',2.08),('325','2013-08-27','16:45:00',1.87),('325','2013-08-27','16:50:00',2.52),('325','2013-08-27','16:55:00',2.29),('325','2013-08-27','17:05:00',1.4),('325','2013-08-27','17:10:00',2.79),('325','2013-08-27','17:15:00',1.36),('325','2013-08-27','17:45:00',1.25),('325','2013-08-27','17:50:00',1.51),('325','2013-08-27','17:55:00',1.53),('325','2013-08-27','18:00:00',1.27),('325','2013-08-26','08:45:00',1.01),('325','2013-08-26','08:50:00',1.07),('325','2013-08-26','08:55:00',1.13),('325','2013-08-26','09:00:00',1.18),('325','2013-08-26','09:05:00',1.54),('325','2013-08-26','09:10:00',1.8),('325','2013-08-26','09:15:00',1.99),('325','2013-08-26','09:20:00',2.09),('325','2013-08-26','09:25:00',2.18),('325','2013-08-26','09:30:00',2.15),('325','2013-08-26','09:35:00',2.03),('325','2013-08-26','09:40:00',1.88),('325','2013-08-26','09:45:00',2.1),('325','2013-08-26','09:50:00',2.39),('325','2013-08-26','09:55:00',2.5),('325','2013-08-26','10:00:00',2.63),('325','2013-08-26','10:05:00',2.73),('325','2013-08-26','10:10:00',2.78),('325','2013-08-26','10:15:00',2.84),('325','2013-08-26','10:20:00',2.98),('325','2013-08-26','10:25:00',3.01),('325','2013-08-26','10:30:00',3.05),('325','2013-08-26','10:35:00',3.15),('325','2013-08-26','10:40:00',3.24),('325','2013-08-26','10:45:00',3.35),('325','2013-08-26','10:50:00',3.44),('325','2013-08-26','10:55:00',3.56),('325','2013-08-26','11:00:00',3.61),('325','2013-08-26','11:05:00',3.62),('325','2013-08-26','11:10:00',3.67),('325','2013-08-26','11:15:00',3.71),('325','2013-08-26','11:20:00',3.72),('325','2013-08-26','11:25:00',3.78),('325','2013-08-26','11:30:00',3.86),('325','2013-08-26','11:35:00',3.92),('325','2013-08-26','11:40:00',3.93),('325','2013-08-26','11:45:00',3.96),('325','2013-08-26','11:50:00',3.19),('325','2013-08-26','11:55:00',4.05),('325','2013-08-26','12:00:00',4.06),('325','2013-08-26','12:05:00',4.1),('325','2013-08-26','12:10:00',4.11),('325','2013-08-26','12:15:00',4.12),('325','2013-08-26','12:20:00',4.1),('325','2013-08-26','12:25:00',4.11),('325','2013-08-26','12:30:00',4.1),('325','2013-08-26','12:35:00',4.12),('325','2013-08-26','12:40:00',4.17),('325','2013-08-26','12:45:00',4.2),('325','2013-08-26','12:50:00',4.2),('325','2013-08-26','12:55:00',4.26),('325','2013-08-26','13:00:00',4.35),('325','2013-08-26','13:05:00',4.92),('325','2013-08-26','13:10:00',4.15),('325','2013-08-26','13:15:00',4.03),('325','2013-08-26','13:20:00',3.38),('325','2013-08-26','13:25:00',3.12),('325','2013-08-26','13:30:00',3.07),('325','2013-08-26','13:35:00',4.09),('325','2013-08-26','13:40:00',4.25),('325','2013-08-26','13:45:00',4.27),('325','2013-08-26','13:50:00',4.16),('325','2013-08-26','13:55:00',3.07),('325','2013-08-26','14:00:00',2.95),('325','2013-08-26','14:05:00',3.66),('325','2013-08-26','14:10:00',3.08),('325','2013-08-26','14:15:00',4.01),('325','2013-08-26','14:20:00',4.14),('325','2013-08-26','14:25:00',4.08),('325','2013-08-26','14:30:00',4.05),('325','2013-08-26','14:35:00',3.87),('325','2013-08-26','14:40:00',3.53),('325','2013-08-26','14:45:00',2.62),('325','2013-08-26','14:50:00',2.32),('325','2013-08-26','14:55:00',2.17),('325','2013-08-26','15:00:00',2.02),('325','2013-08-26','15:05:00',1.44),('325','2013-08-26','15:10:00',1.13),('325','2013-08-26','15:35:00',1.08),('325','2013-08-26','15:40:00',1.69),('325','2013-08-26','15:45:00',1.78),('325','2013-08-26','15:50:00',1.83),('325','2013-08-26','15:55:00',1.65),('325','2013-08-26','16:00:00',2.6),('325','2013-08-26','16:05:00',3.57),('325','2013-08-26','16:10:00',3.15),('325','2013-08-26','16:15:00',3.01),('325','2013-08-26','16:20:00',2.94),('325','2013-08-26','16:25:00',2.85),('325','2013-08-26','16:30:00',2.77),('325','2013-08-26','16:35:00',2.71),('325','2013-08-26','16:40:00',2.64),('325','2013-08-26','16:45:00',2.58),('325','2013-08-26','16:50:00',2.34),('325','2013-08-26','16:55:00',2.25),('325','2013-08-26','17:00:00',2.22),('325','2013-08-26','17:05:00',2.05),('325','2013-08-26','17:10:00',2.07),('325','2013-08-26','17:15:00',1.98),('325','2013-08-26','17:20:00',1.42),('325','2013-08-26','17:30:00',1.45),('325','2013-08-26','17:35:00',1.09),('325','2013-08-26','17:40:00',1.12),('325','2013-08-26','17:45:00',1.32),('325','2013-08-26','17:50:00',1.49),('325','2013-08-26','17:55:00',1.43),('325','2013-08-26','18:00:00',1.25),('325','2013-08-26','18:05:00',1.08),('325','2013-08-25','08:40:00',1.14),('325','2013-08-25','08:45:00',1.08),('325','2013-08-25','09:15:00',1.01),('325','2013-08-25','09:20:00',2.07),('325','2013-08-25','09:25:00',2.16),('325','2013-08-25','09:30:00',1.86),('325','2013-08-25','09:40:00',2.2),('325','2013-08-25','09:45:00',2.99),('325','2013-08-25','09:50:00',2.45),('325','2013-08-25','09:55:00',2.29),('325','2013-08-25','10:00:00',1.96),('325','2013-08-25','10:05:00',1.26),('325','2013-08-25','15:15:00',1.17),('325','2013-08-25','15:20:00',1.43),('325','2013-08-25','15:25:00',1.59),('325','2013-08-25','15:30:00',2.28),('325','2013-08-25','15:35:00',3.63),('325','2013-08-25','15:40:00',3.69),('325','2013-08-25','15:45:00',3.87),('325','2013-08-25','15:50:00',2.56),('325','2013-08-25','15:55:00',2.91),('325','2013-08-25','16:00:00',3.78),('325','2013-08-25','16:05:00',3.52),('325','2013-08-25','16:10:00',3.34),('325','2013-08-25','16:15:00',3.21),('325','2013-08-25','16:20:00',3.11),('325','2013-08-25','16:25:00',3.06),('325','2013-08-25','16:30:00',2.97),('325','2013-08-25','16:35:00',2.85),('325','2013-08-25','16:40:00',2),('325','2013-08-25','16:45:00',1.38),('325','2013-08-25','16:50:00',2.13),('325','2013-08-25','16:55:00',2.22),('325','2013-08-25','17:00:00',2.52),('325','2013-08-25','17:05:00',2.45),('325','2013-08-25','17:10:00',2.3),('325','2013-08-25','17:15:00',2.12),('325','2013-08-25','17:20:00',2.01),('325','2013-08-25','17:25:00',1.91),('325','2013-08-25','17:30:00',1.81),('325','2013-08-25','17:35:00',1.53),('325','2013-08-25','17:40:00',1.41),('325','2013-08-25','17:45:00',1.55),('325','2013-08-25','17:50:00',1.37),('325','2013-08-25','17:55:00',1.17),('325','2013-08-24','08:45:00',1.14),('325','2013-08-24','08:50:00',1.19),('325','2013-08-24','08:55:00',1.28),('325','2013-08-24','09:00:00',1.32),('325','2013-08-24','09:05:00',1.49),('325','2013-08-24','09:15:00',1.76),('325','2013-08-24','09:25:00',2.28),('325','2013-08-24','09:30:00',2.28),('325','2013-08-24','09:35:00',1.84),('325','2013-08-24','09:40:00',1.59),('325','2013-08-24','09:45:00',2.01),('325','2013-08-24','09:50:00',2.42),('325','2013-08-24','09:55:00',2.67),('325','2013-08-24','10:00:00',2.68),('325','2013-08-24','10:05:00',2.74),('325','2013-08-24','10:10:00',2.82),('325','2013-08-24','10:15:00',2.86),('325','2013-08-24','10:20:00',2.97),('325','2013-08-24','10:25:00',2.97),('325','2013-08-24','10:30:00',3.02),('325','2013-08-24','10:35:00',3.14),('325','2013-08-24','10:40:00',3.15),('325','2013-08-24','10:45:00',2.47),('325','2013-08-24','10:50:00',2.63),('325','2013-08-24','10:55:00',3.61),('325','2013-08-24','11:00:00',3.62),('325','2013-08-24','11:05:00',3.72),('325','2013-08-24','11:10:00',3.71),('325','2013-08-24','11:15:00',3.71),('325','2013-08-24','11:20:00',3.78),('325','2013-08-24','11:25:00',3.73),('325','2013-08-24','11:30:00',3.82),('325','2013-08-24','11:35:00',3.89),('325','2013-08-24','11:40:00',3.93),('325','2013-08-24','11:45:00',3.98),('325','2013-08-24','11:50:00',3.96),('325','2013-08-24','11:55:00',4.07),('325','2013-08-24','12:00:00',4.06),('325','2013-08-24','12:05:00',4.12),('325','2013-08-24','12:10:00',4.19),('325','2013-08-24','12:15:00',4.13),('325','2013-08-24','12:20:00',4.22),('325','2013-08-24','12:25:00',4.2),('325','2013-08-24','12:30:00',4.21),('325','2013-08-24','12:35:00',4.21),('325','2013-08-24','12:40:00',4.24),('325','2013-08-24','12:45:00',4.23),('325','2013-08-24','12:50:00',4.26),('325','2013-08-24','12:55:00',4.2),('325','2013-08-24','13:00:00',4.22),('325','2013-08-24','13:05:00',4.25),('325','2013-08-24','13:10:00',4.26),('325','2013-08-24','13:15:00',4.26),('325','2013-08-24','13:20:00',4.3),('325','2013-08-24','13:25:00',4.3),('325','2013-08-24','13:30:00',4.3),('325','2013-08-24','13:35:00',4.28),('325','2013-08-24','13:40:00',4.23),('325','2013-08-24','13:45:00',4.26),('325','2013-08-24','13:50:00',4.26),('325','2013-08-24','13:55:00',4.24),('325','2013-08-24','14:00:00',4.23),('325','2013-08-24','14:05:00',4.22),('325','2013-08-24','14:10:00',4.16),('325','2013-08-24','14:15:00',4.14),('325','2013-08-24','14:20:00',4.09),('325','2013-08-24','14:25:00',4.04),('325','2013-08-24','14:30:00',4.03),('325','2013-08-24','14:35:00',4.02),('325','2013-08-24','14:40:00',3.99),('325','2013-08-24','14:45:00',3.94),('325','2013-08-24','14:50:00',3.9),('325','2013-08-24','14:55:00',3.88),('325','2013-08-24','15:00:00',3.86),('325','2013-08-24','15:05:00',3.84),('325','2013-08-24','15:10:00',3.78),('325','2013-08-24','15:15:00',3.75),('325','2013-08-24','15:20:00',3.7),('325','2013-08-24','15:25:00',3.65),('325','2013-08-24','15:30:00',3.61),('325','2013-08-24','15:35:00',3.56),('325','2013-08-24','15:40:00',3.49),('325','2013-08-24','15:45:00',3.43),('325','2013-08-24','15:50:00',3.38),('325','2013-08-24','15:55:00',3.31),('325','2013-08-24','16:00:00',3.24),('325','2013-08-24','16:05:00',3.17),('325','2013-08-24','16:10:00',3.12),('325','2013-08-24','16:15:00',3.06),('325','2013-08-24','16:20:00',2.99),('325','2013-08-24','16:25:00',2.93),('325','2013-08-24','16:30:00',2.84),('325','2013-08-24','16:35:00',2.75),('325','2013-08-24','16:40:00',2.67),('325','2013-08-24','16:45:00',2.59),('325','2013-08-24','16:50:00',2.51),('325','2013-08-24','16:55:00',2.36),('325','2013-08-24','17:00:00',2.28),('325','2013-08-24','17:05:00',2.23),('325','2013-08-24','17:10:00',2.15),('325','2013-08-24','17:15:00',2.08),('325','2013-08-24','17:20:00',1.98),('325','2013-08-24','17:25:00',1.9),('325','2013-08-24','17:30:00',1.81),('325','2013-08-24','17:35:00',1.68),('325','2013-08-24','17:40:00',1.59),('325','2013-08-24','17:45:00',1.5),('325','2013-08-24','17:50:00',1.41),('325','2013-08-24','17:55:00',1.31),('325','2013-08-24','18:00:00',1.23),('325','2013-08-24','18:05:00',1.13),('325','2013-08-24','18:10:00',1.04),('325','2013-08-23','08:45:00',1.04),('325','2013-08-23','08:50:00',1.11),('325','2013-08-23','08:55:00',1.19),('325','2013-08-23','09:00:00',1.25),('325','2013-08-23','09:05:00',1.26),('325','2013-08-23','09:10:00',1.53),('325','2013-08-23','09:15:00',1.74),('325','2013-08-23','09:20:00',1.81),('325','2013-08-23','09:25:00',1.92),('325','2013-08-23','09:30:00',1.95),('325','2013-08-23','09:35:00',1.99),('325','2013-08-23','09:40:00',2.06),('325','2013-08-23','09:45:00',2.14),('325','2013-08-23','09:50:00',2.08),('325','2013-08-23','09:55:00',2.02),('325','2013-08-23','10:00:00',1.94),('325','2013-08-23','10:05:00',2.04),('325','2013-08-23','10:10:00',2.55),('325','2013-08-23','10:15:00',2.63),('325','2013-08-23','10:20:00',2.68),('325','2013-08-23','10:25:00',2.73),('325','2013-08-23','10:30:00',2.81),('325','2013-08-23','10:35:00',2.87),('325','2013-08-23','10:40:00',2.93),('325','2013-08-23','10:45:00',2.98),('325','2013-08-23','10:50:00',3.12),('325','2013-08-23','10:55:00',3.19),('325','2013-08-23','11:00:00',3.26),('325','2013-08-23','11:05:00',3.26),('325','2013-08-23','11:10:00',2.58),('325','2013-08-23','11:15:00',1.23),('325','2013-08-23','11:20:00',1.53),('325','2013-08-23','11:25:00',3.47),('325','2013-08-23','11:30:00',3.8),('325','2013-08-23','11:35:00',3.93),('325','2013-08-23','11:40:00',3.86),('325','2013-08-23','11:45:00',3.87),('325','2013-08-23','11:50:00',2.82),('325','2013-08-23','11:55:00',1.19),('325','2013-08-23','12:00:00',1.53),('325','2013-08-23','12:05:00',3.19),('325','2013-08-23','12:10:00',2.81),('325','2013-08-23','12:15:00',1.05),('325','2013-08-23','12:20:00',1.07),('325','2013-08-23','12:25:00',1.15),('325','2013-08-23','12:30:00',2.1),('325','2013-08-23','12:35:00',2.72),('325','2013-08-23','12:40:00',1.34),('325','2013-08-23','12:45:00',3.35),('325','2013-08-23','12:50:00',3.28),('325','2013-08-23','12:55:00',1.09),('325','2013-08-23','13:00:00',3.17),('325','2013-08-23','13:05:00',3.38),('325','2013-08-23','13:10:00',2.14),('325','2013-08-23','13:15:00',1.94),('325','2013-08-23','13:20:00',3.66),('325','2013-08-23','13:25:00',3.76),('325','2013-08-23','13:30:00',4.45),('325','2013-08-23','13:35:00',2.96),('325','2013-08-23','13:40:00',2.62),('325','2013-08-23','13:45:00',2.81),('325','2013-08-23','13:50:00',2.52),('325','2013-08-23','13:55:00',4.61),('325','2013-08-23','14:00:00',4.26),('325','2013-08-23','14:05:00',3.63),('325','2013-08-23','14:10:00',4.26),('325','2013-08-23','14:15:00',4.15),('325','2013-08-23','14:20:00',3.99),('325','2013-08-23','14:25:00',3.97),('325','2013-08-23','14:30:00',4.02),('325','2013-08-23','14:35:00',3.92),('325','2013-08-23','14:40:00',3.95),('325','2013-08-23','14:45:00',3.94),('325','2013-08-23','14:50:00',3.86),('325','2013-08-23','14:55:00',3.82),('325','2013-08-23','15:00:00',3.75),('325','2013-08-23','15:05:00',3.63),('325','2013-08-23','15:10:00',3.82),('325','2013-08-23','15:15:00',3.63),('325','2013-08-23','15:20:00',3.66),('325','2013-08-23','15:25:00',3.65),('325','2013-08-23','15:30:00',3.72),('325','2013-08-23','15:35:00',3.44),('325','2013-08-23','15:40:00',3.43),('325','2013-08-23','15:45:00',3.4),('325','2013-08-23','15:50:00',3.13),('325','2013-08-23','15:55:00',3.31),('325','2013-08-23','16:00:00',3.14),('325','2013-08-23','16:05:00',2.97),('325','2013-08-23','16:10:00',2.71),('325','2013-08-23','16:15:00',2.96),('325','2013-08-23','16:20:00',3.1),('325','2013-08-23','16:25:00',3),('325','2013-08-23','16:30:00',2.92),('325','2013-08-23','16:35:00',2.88),('325','2013-08-23','16:40:00',2.8),('325','2013-08-23','16:45:00',2.74),('325','2013-08-23','16:50:00',2.6),('325','2013-08-23','16:55:00',2.44),('325','2013-08-23','17:00:00',2.28),('325','2013-08-23','17:05:00',2.21),('325','2013-08-23','17:10:00',2.12),('325','2013-08-23','17:15:00',2.03),('325','2013-08-23','17:20:00',1.94),('325','2013-08-23','17:25:00',1.84),('325','2013-08-23','17:30:00',1.75),('325','2013-08-23','17:35:00',1.64),('325','2013-08-23','17:40:00',1.51),('325','2013-08-23','17:45:00',1.45),('325','2013-08-23','17:50:00',1.37),('325','2013-08-23','17:55:00',1.28),('325','2013-08-23','18:00:00',1.19),('325','2013-08-23','18:05:00',1.1),('325','2013-08-22','08:45:00',1.05),('325','2013-08-22','08:50:00',1.12),('325','2013-08-22','08:55:00',1.21),('325','2013-08-22','09:00:00',1.29),('325','2013-08-22','09:05:00',1.43),('325','2013-08-22','09:10:00',1.62),('325','2013-08-22','09:15:00',2),('325','2013-08-22','09:20:00',2.2),('325','2013-08-22','09:25:00',2.26),('325','2013-08-22','09:30:00',2.41),('325','2013-08-22','09:35:00',1.62),('325','2013-08-22','09:40:00',2.06),('325','2013-08-22','09:45:00',2.36),('325','2013-08-22','09:50:00',2.46),('325','2013-08-22','09:55:00',2.11),('325','2013-08-22','10:00:00',2.4),('325','2013-08-22','10:05:00',2.28),('325','2013-08-22','10:10:00',2.73),('325','2013-08-22','10:15:00',2.82),('325','2013-08-22','10:20:00',2.86),('325','2013-08-22','10:25:00',2.9),('325','2013-08-22','10:30:00',2.97),('325','2013-08-22','10:35:00',3.03),('325','2013-08-22','10:40:00',3.09),('325','2013-08-22','10:45:00',3.15),('325','2013-08-22','10:50:00',3.26),('325','2013-08-22','10:55:00',3.36),('325','2013-08-22','11:00:00',3.47),('325','2013-08-22','11:05:00',3.5),('325','2013-08-22','11:10:00',3.51),('325','2013-08-22','11:15:00',3.54),('325','2013-08-22','11:20:00',3.6),('325','2013-08-22','11:25:00',3.64),('325','2013-08-22','11:30:00',3.68),('325','2013-08-22','11:35:00',3.71),('325','2013-08-22','11:40:00',3.78),('325','2013-08-22','11:45:00',3.81),('325','2013-08-22','11:50:00',3.83),('325','2013-08-22','11:55:00',3.91),('325','2013-08-22','12:00:00',3.92),('325','2013-08-22','12:05:00',3.94),('325','2013-08-22','12:10:00',3.96),('325','2013-08-22','12:15:00',3.95),('325','2013-08-22','12:20:00',3.99),('325','2013-08-22','12:25:00',4),('325','2013-08-22','12:30:00',4),('325','2013-08-22','12:35:00',3.99),('325','2013-08-22','12:40:00',4.01),('325','2013-08-22','12:45:00',4.03),('325','2013-08-22','12:50:00',4.03),('325','2013-08-22','12:55:00',4.03),('325','2013-08-22','13:00:00',4.02),('325','2013-08-22','13:05:00',4.05),('325','2013-08-22','13:10:00',4.02),('325','2013-08-22','13:15:00',4.02),('325','2013-08-22','13:20:00',3.99),('325','2013-08-22','13:25:00',4),('325','2013-08-22','13:30:00',3.98),('325','2013-08-22','13:35:00',3.95),('325','2013-08-22','13:40:00',3.93),('325','2013-08-22','13:45:00',3.98),('325','2013-08-22','13:50:00',3.98),('325','2013-08-22','13:55:00',3.95),('325','2013-08-22','14:00:00',3.93),('325','2013-08-22','14:05:00',3.93),('325','2013-08-22','14:10:00',3.89),('325','2013-08-22','14:15:00',3.88),('325','2013-08-22','14:20:00',3.88),('325','2013-08-22','14:25:00',3.88),('325','2013-08-22','14:30:00',3.88),('325','2013-08-22','14:35:00',3.9),('325','2013-08-22','14:40:00',3.74),('325','2013-08-22','14:45:00',3.74),('325','2013-08-22','14:50:00',3.8),('325','2013-08-22','14:55:00',3.77),('325','2013-08-22','15:00:00',3.68),('325','2013-08-22','15:05:00',3.71),('325','2013-08-22','15:10:00',3.67),('325','2013-08-22','15:15:00',3.57),('325','2013-08-22','15:20:00',3.55),('325','2013-08-22','15:25:00',3.54),('325','2013-08-22','15:30:00',3.47),('325','2013-08-22','15:35:00',3.4),('325','2013-08-22','15:40:00',3.38),('325','2013-08-22','15:45:00',3.34),('325','2013-08-22','15:50:00',3.29),('325','2013-08-22','15:55:00',3.2),('325','2013-08-22','16:00:00',3.12),('325','2013-08-22','16:05:00',3.03),('325','2013-08-22','16:10:00',2.98),('325','2013-08-22','16:15:00',2.93),('325','2013-08-22','16:20:00',2.87),('325','2013-08-22','16:25:00',2.81),('325','2013-08-22','16:30:00',2.73),('325','2013-08-22','16:35:00',2.64),('325','2013-08-22','16:40:00',2.56),('325','2013-08-22','16:45:00',2.48),('325','2013-08-22','16:50:00',2.36),('325','2013-08-22','16:55:00',2.28),('325','2013-08-22','17:00:00',2.16),('325','2013-08-22','17:05:00',2.1),('325','2013-08-22','17:10:00',2.03),('325','2013-08-22','17:15:00',1.94),('325','2013-08-22','17:20:00',1.84),('325','2013-08-22','17:25:00',1.78),('325','2013-08-22','17:30:00',1.69),('325','2013-08-22','17:35:00',1.6),('325','2013-08-22','17:40:00',1.48),('325','2013-08-22','17:45:00',1.4),('325','2013-08-22','17:50:00',1.3),('325','2013-08-22','17:55:00',1.24),('325','2013-08-22','18:00:00',1.16),('325','2013-08-22','18:05:00',1.09),('325','2013-08-22','18:10:00',1.04),('325','2013-08-22','18:15:00',1.04),('325','2013-08-21','09:05:00',1.3),('325','2013-08-21','09:10:00',1.34),('325','2013-08-21','09:15:00',1.81),('325','2013-08-21','09:20:00',1.84),('325','2013-08-21','09:25:00',1.13),('325','2013-08-21','09:40:00',1.03),('325','2013-08-21','09:45:00',1.21),('325','2013-08-21','09:50:00',1.95),('325','2013-08-21','09:55:00',3.18),('325','2013-08-21','10:00:00',3.17),('325','2013-08-21','10:05:00',2.81),('325','2013-08-21','10:10:00',2.55),('325','2013-08-21','10:15:00',2.39),('325','2013-08-21','10:20:00',2.26),('325','2013-08-21','10:25:00',1.8),('325','2013-08-21','10:30:00',2.39),('325','2013-08-21','10:35:00',2.96),('325','2013-08-21','10:40:00',1.94),('325','2013-08-21','10:45:00',2.16),('325','2013-08-21','10:50:00',2.34),('325','2013-08-21','10:55:00',1.91),('325','2013-08-21','11:00:00',2.7),('325','2013-08-21','11:05:00',2.06),('325','2013-08-21','11:10:00',1.81),('325','2013-08-21','11:15:00',2.14),('325','2013-08-21','11:20:00',2.77),('325','2013-08-21','11:25:00',2.69),('325','2013-08-21','11:30:00',3.42),('325','2013-08-21','11:35:00',4.48),('325','2013-08-21','11:40:00',4.27),('325','2013-08-21','11:45:00',4.24),('325','2013-08-21','11:50:00',4.16),('325','2013-08-21','11:55:00',4.15),('325','2013-08-21','12:00:00',4.27),('325','2013-08-21','12:05:00',4.27),('325','2013-08-21','12:10:00',4.26),('325','2013-08-21','12:15:00',4.3),('325','2013-08-21','12:20:00',4.29),('325','2013-08-21','12:25:00',3),('325','2013-08-21','12:30:00',2.62),('325','2013-08-21','12:35:00',2.09),('325','2013-08-21','12:40:00',3.87),('325','2013-08-21','12:45:00',4.17),('325','2013-08-21','12:50:00',3.98),('325','2013-08-21','12:55:00',3.95),('325','2013-08-21','13:00:00',4.08),('325','2013-08-21','13:05:00',4.1),('325','2013-08-21','13:10:00',4.17),('325','2013-08-21','13:15:00',4.23),('325','2013-08-21','13:20:00',4.23),('325','2013-08-21','13:25:00',4.2),('325','2013-08-21','13:30:00',4.08),('325','2013-08-21','13:35:00',4.06),('325','2013-08-21','13:40:00',4.08),('325','2013-08-21','13:45:00',4.18),('325','2013-08-21','13:50:00',4.04),('325','2013-08-21','13:55:00',3.94),('325','2013-08-21','14:00:00',3.91),('325','2013-08-21','14:05:00',3.94),('325','2013-08-21','14:10:00',4.05),('325','2013-08-21','14:15:00',2.77),('325','2013-08-21','14:20:00',1.69),('325','2013-08-21','14:25:00',2.02),('325','2013-08-21','14:30:00',3.6),('325','2013-08-21','14:35:00',3.72),('325','2013-08-21','14:40:00',3.72),('325','2013-08-21','14:45:00',3.62),('325','2013-08-21','14:50:00',3.53),('325','2013-08-21','14:55:00',3.57),('325','2013-08-21','15:00:00',3.63),('325','2013-08-21','15:05:00',3.58),('325','2013-08-21','15:10:00',3.52),('325','2013-08-21','15:15:00',3.43),('325','2013-08-21','15:20:00',3.38),('325','2013-08-21','15:25:00',3.2),('325','2013-08-21','15:30:00',3.14),('325','2013-08-21','15:35:00',3.03),('325','2013-08-21','15:40:00',2.85),('325','2013-08-21','15:45:00',2.92),('325','2013-08-21','15:50:00',2.94),('325','2013-08-21','15:55:00',2.92),('325','2013-08-21','16:00:00',2.74),('325','2013-08-21','16:05:00',2.61),('325','2013-08-21','16:10:00',2.54),('325','2013-08-21','16:15:00',2.55),('325','2013-08-21','16:20:00',2.72),('325','2013-08-21','16:25:00',2.72),('325','2013-08-21','16:30:00',2.86),('325','2013-08-21','16:35:00',2.8),('325','2013-08-21','16:40:00',2.7),('325','2013-08-21','16:45:00',2.6),('325','2013-08-21','16:50:00',2.52),('325','2013-08-21','16:55:00',2.42),('325','2013-08-21','17:00:00',2.33),('325','2013-08-21','17:05:00',2.23),('325','2013-08-21','17:10:00',2.22),('325','2013-08-21','17:15:00',2.15),('325','2013-08-21','17:20:00',2.13),('325','2013-08-21','17:25:00',2.04),('325','2013-08-21','17:30:00',1.93),('325','2013-08-21','17:35:00',1.88),('325','2013-08-21','17:40:00',1.79),('325','2013-08-21','17:45:00',1.69),('325','2013-08-21','17:50:00',1.66),('325','2013-08-21','17:55:00',1.59),('325','2013-08-21','18:00:00',1.5),('325','2013-08-21','18:05:00',1.41),('325','2013-08-21','18:10:00',1.28),('325','2013-08-21','18:15:00',1.21),('325','2013-08-21','18:20:00',1.08),('325','2013-08-20','09:20:00',1.22),('325','2013-08-20','09:25:00',1.73),('325','2013-08-20','09:30:00',2.31),('325','2013-08-20','09:35:00',2.48),('325','2013-08-20','09:40:00',3.18),('325','2013-08-20','09:45:00',2.62),('325','2013-08-20','09:50:00',1.85),('325','2013-08-20','09:55:00',3.4),('325','2013-08-20','10:00:00',2.85),('325','2013-08-20','10:05:00',1.37),('325','2013-08-20','10:10:00',1.11),('325','2013-08-20','10:15:00',1.55),('325','2013-08-20','10:20:00',1.26),('325','2013-08-20','10:25:00',1.01),('325','2013-08-20','10:30:00',1.05),('325','2013-08-20','10:35:00',1.11),('325','2013-08-20','10:40:00',1.9),('325','2013-08-20','10:45:00',3.73),('325','2013-08-20','10:50:00',3.53),('325','2013-08-20','10:55:00',2.03),('325','2013-08-20','11:00:00',1.07),('325','2013-08-20','11:05:00',1.05),('325','2013-08-20','11:10:00',3.72),('325','2013-08-20','11:15:00',4.02),('325','2013-08-20','11:20:00',4.09),('325','2013-08-20','11:25:00',2.28),('325','2013-08-20','11:30:00',3.47),('325','2013-08-20','11:35:00',3.99),('325','2013-08-20','11:40:00',4.33),('325','2013-08-20','11:45:00',4.5),('325','2013-08-20','11:50:00',4.78),('325','2013-08-20','11:55:00',4.45),('325','2013-08-20','12:00:00',2.57),('325','2013-08-20','12:05:00',1.46),('325','2013-08-20','12:10:00',1.79),('325','2013-08-20','12:25:00',1.27),('325','2013-08-20','12:30:00',1.57),('325','2013-08-20','12:35:00',1.69),('325','2013-08-20','12:40:00',1.73),('325','2013-08-20','12:45:00',1.74),('325','2013-08-20','12:50:00',1.77),('325','2013-08-20','12:55:00',1.81),('325','2013-08-20','13:00:00',1.77),('325','2013-08-20','13:05:00',1.65),('325','2013-08-20','13:10:00',1.67),('325','2013-08-20','13:15:00',1.74),('325','2013-08-20','13:20:00',1.8),('325','2013-08-20','13:25:00',1.84),('325','2013-08-20','13:30:00',2.03),('325','2013-08-20','13:35:00',2.94),('325','2013-08-20','13:40:00',4.36),('325','2013-08-20','13:45:00',3.96),('325','2013-08-20','13:50:00',4.63),('325','2013-08-20','13:55:00',4.46),('325','2013-08-20','14:00:00',4.42),('325','2013-08-20','14:05:00',4.06),('325','2013-08-20','14:10:00',4.03),('325','2013-08-20','14:15:00',4.24),('325','2013-08-20','14:20:00',4.21),('325','2013-08-20','14:25:00',3.85),('325','2013-08-20','14:30:00',3.69),('325','2013-08-20','14:35:00',3.99),('325','2013-08-20','14:40:00',4.22),('325','2013-08-20','14:45:00',3.4),('325','2013-08-20','14:50:00',3.93),('325','2013-08-20','14:55:00',3.7),('325','2013-08-20','15:00:00',3.51),('325','2013-08-20','15:05:00',4.24),('325','2013-08-20','15:10:00',4.1),('325','2013-08-20','15:15:00',4.09),('325','2013-08-20','15:20:00',3.99),('325','2013-08-20','15:25:00',3.96),('325','2013-08-20','15:30:00',3.96),('325','2013-08-20','15:35:00',3.93),('325','2013-08-20','15:40:00',3.99),('325','2013-08-20','15:45:00',4.09),('325','2013-08-20','15:50:00',4.28),('325','2013-08-20','15:55:00',4.26),('325','2013-08-20','16:00:00',4.04),('325','2013-08-20','16:05:00',3.98),('325','2013-08-20','16:10:00',3.88),('325','2013-08-20','16:15:00',3.85),('325','2013-08-20','16:20:00',3.79),('325','2013-08-20','16:25:00',3.67),('325','2013-08-20','16:30:00',3.37),('325','2013-08-20','16:35:00',3.34),('325','2013-08-20','16:40:00',3.38),('325','2013-08-20','16:45:00',3.25),('325','2013-08-20','16:50:00',3.07),('325','2013-08-20','16:55:00',2.85),('325','2013-08-20','17:00:00',2.57),('325','2013-08-20','17:05:00',2.42),('325','2013-08-20','17:10:00',2.36),('325','2013-08-20','17:15:00',2.21),('325','2013-08-20','17:20:00',2.13),('325','2013-08-20','17:25:00',2.04),('325','2013-08-20','17:30:00',1.99),('325','2013-08-20','17:35:00',1.91),('325','2013-08-20','17:40:00',1.8),('325','2013-08-20','17:45:00',1.74),('325','2013-08-20','17:50:00',1.56),('325','2013-08-20','17:55:00',1.42),('325','2013-08-20','18:00:00',1.27),('325','2013-08-20','18:05:00',1.22),('325','2013-08-20','18:10:00',1.25),('325','2013-08-20','18:15:00',1.25),('325','2013-08-20','18:20:00',1.17),('325','2013-08-20','18:25:00',1.11),('325','2013-08-20','18:30:00',1.12),('325','2013-08-19','08:45:00',1.01),('325','2013-08-19','08:50:00',1.06),('325','2013-08-19','08:55:00',1.11),('325','2013-08-19','09:00:00',1.16),('325','2013-08-19','09:05:00',1.22),('325','2013-08-19','09:10:00',1.53),('325','2013-08-19','09:15:00',1.76),('325','2013-08-19','09:20:00',1.83),('325','2013-08-19','09:25:00',2.04),('325','2013-08-19','09:30:00',2.15),('325','2013-08-19','09:35:00',2.22),('325','2013-08-19','09:40:00',2.29),('325','2013-08-19','09:45:00',2.39),('325','2013-08-19','09:50:00',2.51),('325','2013-08-19','09:55:00',2.58),('325','2013-08-19','10:00:00',2.68),('325','2013-08-19','10:05:00',2.64),('325','2013-08-19','10:10:00',2.48),('325','2013-08-19','10:15:00',2.61),('325','2013-08-19','10:20:00',2.86),('325','2013-08-19','10:25:00',2.9),('325','2013-08-19','10:30:00',2.99),('325','2013-08-19','10:35:00',3.04),('325','2013-08-19','10:40:00',3.08),('325','2013-08-19','10:45:00',3.15),('325','2013-08-19','10:50:00',3.28),('325','2013-08-19','10:55:00',3.36),('325','2013-08-19','11:00:00',3.46),('325','2013-08-19','11:05:00',3.54),('325','2013-08-19','11:10:00',3.55),('325','2013-08-19','11:15:00',3.57),('325','2013-08-19','11:20:00',3.6),('325','2013-08-19','11:25:00',3.65),('325','2013-08-19','11:30:00',3.69),('325','2013-08-19','11:35:00',3.7),('325','2013-08-19','11:40:00',3.75),('325','2013-08-19','11:45:00',3.76),('325','2013-08-19','11:50:00',3.85),('325','2013-08-19','11:55:00',3.95),('325','2013-08-19','12:00:00',4.02),('325','2013-08-19','12:05:00',4.03),('325','2013-08-19','12:10:00',4.07),('325','2013-08-19','12:15:00',4.11),('325','2013-08-19','12:20:00',4.09),('325','2013-08-19','12:25:00',4.11),('325','2013-08-19','12:30:00',4.13),('325','2013-08-19','12:35:00',4.13),('325','2013-08-19','12:40:00',4.16),('325','2013-08-19','12:45:00',4.18),('325','2013-08-19','12:50:00',4.2),('325','2013-08-19','12:55:00',4.25),('325','2013-08-19','13:00:00',4.26),('325','2013-08-19','13:05:00',4.27),('325','2013-08-19','13:10:00',4.25),('325','2013-08-19','13:15:00',4.26),('325','2013-08-19','13:20:00',4.24),('325','2013-08-19','13:25:00',4.25),('325','2013-08-19','13:30:00',4.22),('325','2013-08-19','13:35:00',4.2),('325','2013-08-19','13:40:00',4.21),('325','2013-08-19','13:45:00',4.22),('325','2013-08-19','13:50:00',4.24),('325','2013-08-19','13:55:00',4.22),('325','2013-08-19','14:00:00',4.21),('325','2013-08-19','14:05:00',4.19),('325','2013-08-19','14:10:00',4.17),('325','2013-08-19','14:15:00',4.12),('325','2013-08-19','14:20:00',4.07),('325','2013-08-19','14:25:00',4.03),('325','2013-08-19','14:30:00',4.03),('325','2013-08-19','14:35:00',3.98),('325','2013-08-19','14:40:00',3.99),('325','2013-08-19','14:45:00',3.99),('325','2013-08-19','14:50:00',3.97),('325','2013-08-19','14:55:00',3.95),('325','2013-08-19','15:00:00',3.91),('325','2013-08-19','15:05:00',3.88),('325','2013-08-19','15:10:00',3.86),('325','2013-08-19','15:15:00',3.84),('325','2013-08-19','15:20:00',3.83),('325','2013-08-19','15:25:00',3.76),('325','2013-08-19','15:30:00',3.73),('325','2013-08-19','15:35:00',3.71),('325','2013-08-19','15:40:00',3.63),('325','2013-08-19','15:45:00',3.57),('325','2013-08-19','15:50:00',3.51),('325','2013-08-19','15:55:00',3.44),('325','2013-08-19','16:00:00',3.38),('325','2013-08-19','16:05:00',3.33),('325','2013-08-19','16:10:00',3.27),('325','2013-08-19','16:15:00',3.2),('325','2013-08-19','16:20:00',3.13),('325','2013-08-19','16:25:00',3.05),('325','2013-08-19','16:30:00',2.98),('325','2013-08-19','16:35:00',2.9),('325','2013-08-19','16:40:00',2.82),('325','2013-08-19','16:45:00',2.75),('325','2013-08-19','16:50:00',2.68),('325','2013-08-19','16:55:00',2.59),('325','2013-08-19','17:00:00',2.43),('325','2013-08-19','17:05:00',2.25),('325','2013-08-19','17:10:00',2.24),('325','2013-08-19','17:15:00',2.22),('325','2013-08-19','17:20:00',2.13),('325','2013-08-19','17:25:00',2.03),('325','2013-08-19','17:30:00',1.94),('325','2013-08-19','17:35:00',1.85),('325','2013-08-19','17:40:00',1.72),('325','2013-08-19','17:45:00',1.65),('325','2013-08-19','17:50:00',1.56),('325','2013-08-19','17:55:00',1.47),('325','2013-08-19','18:00:00',1.38),('325','2013-08-19','18:05:00',1.29),('325','2013-08-19','18:10:00',1.19),('325','2013-08-19','18:15:00',1.1),('325','2014-04-09','09:50:00',1.71),('325','2014-04-09','09:55:00',2.02),('325','2014-04-09','10:00:00',2.01),('325','2014-04-09','10:05:00',2.02),('325','2014-04-09','10:10:00',2.03),('325','2014-04-09','10:15:00',2.6),('325','2014-04-09','10:20:00',3.33),('325','2014-04-09','10:25:00',3.61),('325','2014-04-09','10:30:00',3.84),('325','2014-04-09','10:35:00',2.17),('325','2014-04-09','10:40:00',1.5),('325','2014-04-09','10:45:00',2.01),('325','2014-04-09','10:50:00',1.58),('325','2014-04-09','10:55:00',4.26),('325','2014-04-09','11:00:00',4.33),('325','2014-04-09','11:05:00',4.47),('325','2014-04-09','11:10:00',4.58),('325','2014-04-09','11:15:00',4.68),('325','2014-04-09','11:20:00',2.92),('325','2014-04-09','11:25:00',1.6),('325','2014-04-09','11:30:00',2.05),('325','2014-04-09','11:35:00',4.73),('325','2014-04-09','11:40:00',4.12),('325','2014-04-09','11:45:00',2.3),('325','2014-04-09','11:50:00',3.51),('325','2014-04-09','11:55:00',4.81),('325','2014-04-09','12:00:00',4.96),('325','2014-04-09','12:05:00',5.21),('325','2014-04-09','12:10:00',4.7),('325','2014-04-09','12:15:00',1.88),('325','2014-04-09','12:20:00',1.57),('325','2014-04-09','12:25:00',1.15),('325','2014-04-09','12:30:00',1.01),('325','2014-04-09','13:15:00',1.16),('325','2014-04-09','13:20:00',1.34),('325','2014-04-09','13:25:00',1.35),('325','2014-04-09','13:30:00',1.06),('325','2014-04-09','13:35:00',1.1),('325','2014-04-09','14:00:00',1.1),('325','2014-04-09','14:05:00',1.47),('325','2014-04-09','14:10:00',1.53),('325','2014-04-09','14:15:00',1.46),('325','2014-04-09','14:20:00',1.33),('325','2014-04-09','14:25:00',1.54),('325','2014-04-09','14:30:00',1.61),('325','2014-04-09','14:35:00',2.7),('325','2014-04-09','14:40:00',2.72),('325','2014-04-09','14:45:00',2.12),('325','2014-04-09','14:50:00',2.48),('325','2014-04-09','14:55:00',2.68),('325','2014-04-09','15:00:00',1.96),('325','2014-04-09','15:05:00',4.05),('325','2014-04-09','15:10:00',4.73),('325','2014-04-09','15:15:00',3.92),('325','2014-04-09','15:20:00',4.33),('325','2014-04-09','15:25:00',3.45),('325','2014-04-09','15:30:00',2.07),('325','2014-04-09','15:35:00',2.99),('325','2014-04-09','15:40:00',2.98),('325','2014-04-09','15:45:00',1.66),('325','2014-04-09','15:50:00',1.32),('325','2014-04-09','15:55:00',1.32),('325','2014-04-09','16:00:00',2.08),('325','2014-04-09','16:05:00',1.8),('325','2014-04-09','16:10:00',3.1),('325','2014-04-09','16:15:00',3.4),('325','2014-04-09','16:20:00',3.09),('325','2014-04-09','16:25:00',3.11),('325','2014-04-09','16:30:00',3.5),('325','2014-04-09','16:35:00',3.59),('325','2014-04-09','16:40:00',2.62),('325','2014-04-09','16:45:00',3),('325','2014-04-09','16:50:00',2.01),('325','2014-04-09','16:55:00',2.39),('325','2014-04-09','17:00:00',2.4),('325','2014-04-09','17:05:00',2.88),('325','2014-04-09','17:10:00',2.36),('325','2014-04-09','17:15:00',2.1),('325','2014-04-09','17:20:00',2.01),('325','2014-04-09','17:25:00',1.93),('325','2014-04-09','17:30:00',1.54),('325','2014-04-09','17:45:00',1.23),('325','2014-04-09','17:50:00',1.25),('325','2014-04-09','17:55:00',1.21),('325','2014-04-09','18:00:00',1.04),('325','2013-08-18','08:50:00',1.05),('325','2013-08-18','08:55:00',1.1),('325','2013-08-18','09:00:00',1.14),('325','2013-08-18','09:05:00',1.19),('325','2013-08-18','09:10:00',1.58),('325','2013-08-18','09:15:00',1.85),('325','2013-08-18','09:20:00',2.01),('325','2013-08-18','09:25:00',2.07),('325','2013-08-18','09:30:00',2.26),('325','2013-08-18','09:35:00',2.32),('325','2013-08-18','09:40:00',2.36),('325','2013-08-18','09:45:00',2.42),('325','2013-08-18','09:50:00',2.45),('325','2013-08-18','09:55:00',2.15),('325','2013-08-18','10:00:00',2.67),('325','2013-08-18','10:05:00',2.32),('325','2013-08-18','10:10:00',2.83),('325','2013-08-18','10:15:00',2.65),('325','2013-08-18','10:20:00',2.64),('325','2013-08-18','10:25:00',2.95),('325','2013-08-18','10:30:00',3.01),('325','2013-08-18','10:35:00',3.06),('325','2013-08-18','10:40:00',3.09),('325','2013-08-18','10:45:00',3.15),('325','2013-08-18','10:50:00',3.27),('325','2013-08-18','10:55:00',3.22),('325','2013-08-18','11:00:00',3.46),('325','2013-08-18','11:05:00',3.54),('325','2013-08-18','11:10:00',3.53),('325','2013-08-18','11:15:00',3.57),('325','2013-08-18','11:20:00',3.59),('325','2013-08-18','11:25:00',3.64),('325','2013-08-18','11:30:00',3.63),('325','2013-08-18','11:35:00',3.71),('325','2013-08-18','11:40:00',3.76),('325','2013-08-18','11:45:00',3.81),('325','2013-08-18','11:50:00',3.83),('325','2013-08-18','11:55:00',3.94),('325','2013-08-18','12:00:00',4.02),('325','2013-08-18','12:05:00',4.09),('325','2013-08-18','12:10:00',4.22),('325','2013-08-18','12:15:00',4.25),('325','2013-08-18','12:20:00',3.78),('325','2013-08-18','12:25:00',2.4),('325','2013-08-18','12:30:00',1.39),('325','2013-08-18','12:35:00',1.01),('325','2013-08-18','12:45:00',1.17),('325','2013-08-18','12:50:00',1.37),('325','2013-08-18','12:55:00',2.83),('325','2013-08-18','13:00:00',3.72),('325','2013-08-18','13:05:00',3.25),('325','2013-08-18','13:10:00',4.42),('325','2013-08-18','13:15:00',4.32),('325','2013-08-18','13:20:00',4.34),('325','2013-08-18','13:25:00',4.24),('325','2013-08-18','13:30:00',4.22),('325','2013-08-18','13:35:00',4.22),('325','2013-08-18','13:40:00',4.24),('325','2013-08-18','13:45:00',4.24),('325','2013-08-18','13:50:00',4.17),('325','2013-08-18','13:55:00',4.21),('325','2013-08-18','14:00:00',4.26),('325','2013-08-18','14:05:00',4.17),('325','2013-08-18','14:10:00',4.15),('325','2013-08-18','14:15:00',4.11),('325','2013-08-18','14:20:00',4.08),('325','2013-08-18','14:25:00',4.04),('325','2013-08-18','14:30:00',4.01),('325','2013-08-18','14:35:00',3.98),('325','2013-08-18','14:40:00',3.97),('325','2013-08-18','14:45:00',4),('325','2013-08-18','14:50:00',3.97),('325','2013-08-18','14:55:00',3.93),('325','2013-08-18','15:00:00',3.93),('325','2013-08-18','15:05:00',3.91),('325','2013-08-18','15:10:00',3.86),('325','2013-08-18','15:15:00',3.81),('325','2013-08-18','15:20:00',3.79),('325','2013-08-18','15:25:00',3.75),('325','2013-08-18','15:30:00',3.72),('325','2013-08-18','15:35:00',3.68),('325','2013-08-18','15:40:00',3.63),('325','2013-08-18','15:45:00',3.57),('325','2013-08-18','15:50:00',3.49),('325','2013-08-18','15:55:00',3.44),('325','2013-08-18','16:00:00',3.38),('325','2013-08-18','16:05:00',3.33),('325','2013-08-18','16:10:00',3.26),('325','2013-08-18','16:15:00',3.19),('325','2013-08-18','16:20:00',3.12),('325','2013-08-18','16:25:00',3.06),('325','2013-08-18','16:30:00',2.99),('325','2013-08-18','16:35:00',2.92),('325','2013-08-18','16:40:00',2.84),('325','2013-08-18','16:45:00',2.77),('325','2013-08-18','16:50:00',2.69),('325','2013-08-18','16:55:00',2.58),('325','2013-08-18','17:00:00',2.45),('325','2013-08-18','17:05:00',2.29),('325','2013-08-18','17:10:00',2.11),('325','2013-08-18','17:15:00',2.21),('325','2013-08-18','17:20:00',2.17),('325','2013-08-18','17:25:00',2.08),('325','2013-08-18','17:30:00',1.98),('325','2013-08-18','17:35:00',1.88),('325','2013-08-18','17:40:00',1.74),('325','2013-08-18','17:45:00',1.67),('325','2013-08-18','17:50:00',1.58),('325','2013-08-18','17:55:00',1.48),('325','2013-08-18','18:00:00',1.39),('325','2013-08-18','18:05:00',1.3),('325','2013-08-18','18:10:00',1.21),('325','2013-08-18','18:15:00',1.13),('325','2013-08-18','18:20:00',1.02),('325','2013-08-17','08:50:00',1.02),('325','2013-08-17','08:55:00',1.07),('325','2013-08-17','09:00:00',1.12),('325','2013-08-17','09:05:00',1.16),('325','2013-08-17','09:10:00',1.34),('325','2013-08-17','09:15:00',1.98),('325','2013-08-17','09:20:00',2.07),('325','2013-08-17','09:25:00',2.13),('325','2013-08-17','09:30:00',2.19),('325','2013-08-17','09:35:00',2.3),('325','2013-08-17','09:40:00',2.38),('325','2013-08-17','09:45:00',2.49),('325','2013-08-17','09:50:00',2.61),('325','2013-08-17','09:55:00',2.78),('325','2013-08-17','10:00:00',2.85),('325','2013-08-17','10:05:00',2.87),('325','2013-08-17','10:10:00',2.91),('325','2013-08-17','10:15:00',2.87),('325','2013-08-17','10:20:00',2.68),('325','2013-08-17','10:25:00',2.64),('325','2013-08-17','10:30:00',3),('325','2013-08-17','10:35:00',3.05),('325','2013-08-17','10:40:00',3.11),('325','2013-08-17','10:45:00',3.17),('325','2013-08-17','10:50:00',3.27),('325','2013-08-17','10:55:00',3.37),('325','2013-08-17','11:00:00',3.48),('325','2013-08-17','11:05:00',3.57),('325','2013-08-17','11:10:00',3.56),('325','2013-08-17','11:15:00',3.57),('325','2013-08-17','11:20:00',3.62),('325','2013-08-17','11:25:00',3.65),('325','2013-08-17','11:30:00',3.68),('325','2013-08-17','11:35:00',3.74),('325','2013-08-17','11:40:00',3.82),('325','2013-08-17','11:45:00',3.91),('325','2013-08-17','11:50:00',3.88),('325','2013-08-17','11:55:00',3.87),('325','2013-08-17','12:00:00',4.06),('325','2013-08-17','12:05:00',4.09),('325','2013-08-17','12:10:00',4.07),('325','2013-08-17','12:15:00',4.04),('325','2013-08-17','12:20:00',4.01),('325','2013-08-17','12:25:00',4.21),('325','2013-08-17','12:30:00',4.22),('325','2013-08-17','12:35:00',4.23),('325','2013-08-17','12:40:00',4.03),('325','2013-08-17','12:45:00',4.17),('325','2013-08-17','12:50:00',4.24),('325','2013-08-17','12:55:00',4.29),('325','2013-08-17','13:00:00',4.29),('325','2013-08-17','13:05:00',3.6),('325','2013-08-17','13:10:00',2.02),('325','2013-08-17','13:15:00',4.36),('325','2013-08-17','13:20:00',4.43),('325','2013-08-17','13:25:00',4.37),('325','2013-08-17','13:30:00',4.36),('325','2013-08-17','13:35:00',3.3),('325','2013-08-17','13:40:00',1.71),('325','2013-08-17','13:45:00',3.53),('325','2013-08-17','13:50:00',1.81),('325','2013-08-17','13:55:00',3.72),('325','2013-08-17','14:00:00',1.34),('325','2013-08-17','14:05:00',4.17),('325','2013-08-17','14:10:00',4.23),('325','2013-08-17','14:15:00',4.13),('325','2013-08-17','14:20:00',3.49),('325','2013-08-17','14:25:00',4.07),('325','2013-08-17','14:30:00',4.07),('325','2013-08-17','14:35:00',3.94),('325','2013-08-17','14:40:00',3.88),('325','2013-08-17','14:45:00',3.95),('325','2013-08-17','14:50:00',3.96),('325','2013-08-17','14:55:00',3.94),('325','2013-08-17','15:00:00',3.89),('325','2013-08-17','15:05:00',3.9),('325','2013-08-17','15:10:00',3.84),('325','2013-08-17','15:15:00',3.81),('325','2013-08-17','15:20:00',3.83),('325','2013-08-17','15:25:00',3.73),('325','2013-08-17','15:30:00',3.74),('325','2013-08-17','15:35:00',3.69),('325','2013-08-17','15:40:00',3.64),('325','2013-08-17','15:45:00',3.57),('325','2013-08-17','15:50:00',3.52),('325','2013-08-17','15:55:00',3.49),('325','2013-08-17','16:00:00',3.42),('325','2013-08-17','16:05:00',3.34),('325','2013-08-17','16:10:00',3.27),('325','2013-08-17','16:15:00',3.24),('325','2013-08-17','16:20:00',3.18),('325','2013-08-17','16:25:00',3.12),('325','2013-08-17','16:30:00',3.08),('325','2013-08-17','16:35:00',3),('325','2013-08-17','16:40:00',2.92),('325','2013-08-17','16:45:00',2.78),('325','2013-08-17','16:50:00',2.72),('325','2013-08-17','16:55:00',2.66),('325','2013-08-17','17:00:00',2.51),('325','2013-08-17','17:05:00',2.34),('325','2013-08-17','17:10:00',2.08),('325','2013-08-17','17:15:00',1.84),('325','2013-08-17','17:20:00',1.8),('325','2013-08-17','17:25:00',2.17),('325','2013-08-17','17:30:00',2.11),('325','2013-08-17','17:35:00',2.02),('325','2013-08-17','17:40:00',1.87),('325','2013-08-17','17:45:00',1.8),('325','2013-08-17','17:50:00',1.69),('325','2013-08-17','17:55:00',1.59),('325','2013-08-17','18:00:00',1.49),('325','2013-08-17','18:05:00',1.38),('325','2013-08-17','18:10:00',1.29),('325','2013-08-17','18:15:00',1.19),('325','2013-08-17','18:20:00',1.09),('325','2013-08-16','08:50:00',1.03),('325','2013-08-16','08:55:00',1.08),('325','2013-08-16','09:00:00',1.13),('325','2013-08-16','09:05:00',1.18),('325','2013-08-16','09:10:00',1.25),('325','2013-08-16','09:15:00',1.86),('325','2013-08-16','09:20:00',2.04),('325','2013-08-16','09:25:00',2.11),('325','2013-08-16','09:30:00',2.18),('325','2013-08-16','09:35:00',2.31),('325','2013-08-16','09:40:00',2.48),('325','2013-08-16','09:45:00',2.56),('325','2013-08-16','09:50:00',2.62),('325','2013-08-16','09:55:00',2.7),('325','2013-08-16','10:00:00',2.79),('325','2013-08-16','10:05:00',2.86),('325','2013-08-16','10:10:00',3.01),('325','2013-08-16','10:15:00',3.02),('325','2013-08-16','10:20:00',2.99),('325','2013-08-16','10:25:00',3.12),('325','2013-08-16','10:30:00',3.33),('325','2013-08-16','10:35:00',3.39),('325','2013-08-16','10:40:00',3.45),('325','2013-08-16','10:45:00',3.53),('325','2013-08-16','10:50:00',3.63),('325','2013-08-16','10:55:00',3.68),('325','2013-08-16','11:00:00',3.72),('325','2013-08-16','11:05:00',3.75),('325','2013-08-16','11:10:00',3.79),('325','2013-08-16','11:15:00',3.83),('325','2013-08-16','11:20:00',3.85),('325','2013-08-16','11:25:00',3.88),('325','2013-08-16','11:30:00',3.89),('325','2013-08-16','11:35:00',3.91),('325','2013-08-16','11:40:00',3.94),('325','2013-08-16','11:45:00',3.96),('325','2013-08-16','11:50:00',4.02),('325','2013-08-16','11:55:00',4.09),('325','2013-08-16','12:00:00',4.1),('325','2013-08-16','12:05:00',4.14),('325','2013-08-16','12:10:00',4.16),('325','2013-08-16','12:15:00',4.16),('325','2013-08-16','12:20:00',4.16),('325','2013-08-16','12:25:00',4.16),('325','2013-08-16','12:30:00',4.18),('325','2013-08-16','12:35:00',4.2),('325','2013-08-16','12:40:00',4.2),('325','2013-08-16','12:45:00',4.18),('325','2013-08-16','12:50:00',4.21),('325','2013-08-16','12:55:00',4.24),('325','2013-08-16','13:00:00',4.24),('325','2013-08-16','13:05:00',4.22),('325','2013-08-16','13:10:00',4.2),('325','2013-08-16','13:15:00',4.18),('325','2013-08-16','13:20:00',4.15),('325','2013-08-16','13:25:00',4.14),('325','2013-08-16','13:30:00',4.12),('325','2013-08-16','13:35:00',4.09),('325','2013-08-16','13:40:00',4.08),('325','2013-08-16','13:45:00',4.08),('325','2013-08-16','13:50:00',4.11),('325','2013-08-16','13:55:00',4.14),('325','2013-08-16','14:00:00',4.13),('325','2013-08-16','14:05:00',4.08),('325','2013-08-16','14:10:00',4.03),('325','2013-08-16','14:15:00',3.98),('325','2013-08-16','14:20:00',3.9),('325','2013-08-16','14:25:00',3.85),('325','2013-08-16','14:30:00',3.8),('325','2013-08-16','14:35:00',3.82),('325','2013-08-16','14:40:00',3.85),('325','2013-08-16','14:45:00',3.85),('325','2013-08-16','14:50:00',3.8),('325','2013-08-16','14:55:00',3.79),('325','2013-08-16','15:00:00',3.73),('325','2013-08-16','15:05:00',3.77),('325','2013-08-16','15:10:00',3.77),('325','2013-08-16','15:15:00',3.73),('325','2013-08-16','15:20:00',3.76),('325','2013-08-16','15:25:00',3.74),('325','2013-08-16','15:30:00',3.71),('325','2013-08-16','15:35:00',3.66),('325','2013-08-16','15:40:00',3.61),('325','2013-08-16','15:45:00',3.57),('325','2013-08-16','15:50:00',3.54),('325','2013-08-16','15:55:00',3.48),('325','2013-08-16','16:00:00',3.4),('325','2013-08-16','16:05:00',3.34),('325','2013-08-16','16:10:00',3.28),('325','2013-08-16','16:15:00',3.21),('325','2013-08-16','16:20:00',3.13),('325','2013-08-16','16:25:00',3.07),('325','2013-08-16','16:30:00',3.02),('325','2013-08-16','16:35:00',2.97),('325','2013-08-16','16:40:00',2.88),('325','2013-08-16','16:45:00',2.81),('325','2013-08-16','16:50:00',2.72),('325','2013-08-16','16:55:00',2.61),('325','2013-08-16','17:00:00',2.47),('325','2013-08-16','17:05:00',2.42),('325','2013-08-16','17:10:00',2.34),('325','2013-08-16','17:15:00',2.25),('325','2013-08-16','17:20:00',2.17),('325','2013-08-16','17:25:00',2.07),('325','2013-08-16','17:30:00',1.98),('325','2013-08-16','17:35:00',1.89),('325','2013-08-16','17:40:00',1.78),('325','2013-08-16','17:45:00',1.69),('325','2013-08-16','17:50:00',1.59),('325','2013-08-16','17:55:00',1.49),('325','2013-08-16','18:00:00',1.4),('325','2013-08-16','18:05:00',1.31),('325','2013-08-16','18:10:00',1.23),('325','2013-08-16','18:15:00',1.14),('325','2013-08-16','18:20:00',1.05),('325','2013-08-15','08:50:00',1.05),('325','2013-08-15','08:55:00',1.11),('325','2013-08-15','09:00:00',1.23),('325','2013-08-15','09:05:00',1.24),('325','2013-08-15','09:10:00',1.11),('325','2013-08-15','09:15:00',1.87),('325','2013-08-15','09:20:00',2.18),('325','2013-08-15','09:25:00',2.18),('325','2013-08-15','09:30:00',2.23),('325','2013-08-15','09:35:00',2.29),('325','2013-08-15','09:40:00',2.46),('325','2013-08-15','09:45:00',2.54),('325','2013-08-15','09:50:00',2.64),('325','2013-08-15','09:55:00',2.71),('325','2013-08-15','10:00:00',2.8),('325','2013-08-15','10:05:00',2.87),('325','2013-08-15','10:10:00',2.91),('325','2013-08-15','10:15:00',2.93),('325','2013-08-15','10:20:00',3.04),('325','2013-08-15','10:25:00',3.25),('325','2013-08-15','10:30:00',3.35),('325','2013-08-15','10:35:00',3.4),('325','2013-08-15','10:40:00',3.45),('325','2013-08-15','10:45:00',3.54),('325','2013-08-15','10:50:00',3.63),('325','2013-08-15','10:55:00',3.42),('325','2013-08-15','11:00:00',3.22),('325','2013-08-15','11:05:00',3.44),('325','2013-08-15','11:10:00',2.7),('325','2013-08-15','11:15:00',2.33),('325','2013-08-15','11:20:00',2.66),('325','2013-08-15','11:25:00',3.02),('325','2013-08-15','11:30:00',3.45),('325','2013-08-15','11:35:00',3.9),('325','2013-08-15','11:40:00',4.12),('325','2013-08-15','11:45:00',4.27),('325','2013-08-15','11:50:00',4.34),('325','2013-08-15','11:55:00',4.42),('325','2013-08-15','12:00:00',4.44),('325','2013-08-15','12:05:00',4.43),('325','2013-08-15','12:10:00',4.39),('325','2013-08-15','12:15:00',4.32),('325','2013-08-15','12:20:00',4.37),('325','2013-08-15','12:25:00',4.35),('325','2013-08-15','12:30:00',4.34),('325','2013-08-15','12:35:00',4.32),('325','2013-08-15','12:40:00',4.34),('325','2013-08-15','12:45:00',4.3),('325','2013-08-15','12:50:00',4.34),('325','2013-08-15','12:55:00',4.29),('325','2013-08-15','13:00:00',4.16),('325','2013-08-15','13:05:00',4.18),('325','2013-08-15','13:10:00',4.2),('325','2013-08-15','13:15:00',4.13),('325','2013-08-15','13:20:00',4.01),('325','2013-08-15','13:25:00',4.1),('325','2013-08-15','13:30:00',4.11),('325','2013-08-15','13:35:00',4.14),('325','2013-08-15','13:40:00',4.19),('325','2013-08-15','13:45:00',4.18),('325','2013-08-15','13:50:00',4.18),('325','2013-08-15','13:55:00',4.16),('325','2013-08-15','14:00:00',4.11),('325','2013-08-15','14:05:00',4.11),('325','2013-08-15','14:10:00',4.07),('325','2013-08-15','14:15:00',4.03),('325','2013-08-15','14:20:00',4.02),('325','2013-08-15','14:25:00',3.97),('325','2013-08-15','14:30:00',4.01),('325','2013-08-15','14:35:00',3.96),('325','2013-08-15','14:40:00',3.97),('325','2013-08-15','14:45:00',3.93),('325','2013-08-15','14:50:00',3.88),('325','2013-08-15','14:55:00',3.82),('325','2013-08-15','15:00:00',3.76),('325','2013-08-15','15:05:00',3.73),('325','2013-08-15','15:10:00',3.72),('325','2013-08-15','15:15:00',3.68),('325','2013-08-15','15:20:00',3.64),('325','2013-08-15','15:25:00',3.62),('325','2013-08-15','15:30:00',3.57),('325','2013-08-15','15:35:00',3.52),('325','2013-08-15','15:40:00',3.49),('325','2013-08-15','15:45:00',3.46),('325','2013-08-15','15:50:00',3.4),('325','2013-08-15','15:55:00',3.33),('325','2013-08-15','16:00:00',3.26),('325','2013-08-15','16:05:00',3.24),('325','2013-08-15','16:10:00',3.19),('325','2013-08-15','16:15:00',3.02),('325','2013-08-15','16:20:00',2.96),('325','2013-08-15','16:25:00',2.91),('325','2013-08-15','16:30:00',2.88),('325','2013-08-15','16:35:00',2.74),('325','2013-08-15','16:40:00',2.57),('325','2013-08-15','16:45:00',2.59),('325','2013-08-15','16:50:00',2.51),('325','2013-08-15','16:55:00',2.5),('325','2013-08-15','17:00:00',2.39),('325','2013-08-15','17:05:00',2.25),('325','2013-08-15','17:10:00',2.23),('325','2013-08-15','17:15:00',2.15),('325','2013-08-15','17:20:00',2.06),('325','2013-08-15','17:25:00',1.98),('325','2013-08-15','17:30:00',1.76),('325','2013-08-15','17:35:00',1.84),('325','2013-08-15','17:40:00',1.72),('325','2013-08-15','17:45:00',1.64),('325','2013-08-15','17:50:00',1.54),('325','2013-08-15','17:55:00',1.47),('325','2013-08-15','18:00:00',1.39),('325','2013-08-15','18:05:00',1.29),('325','2013-08-15','18:10:00',1.18),('325','2013-08-15','18:15:00',1.12),('325','2013-08-15','18:20:00',1.05),('325','2013-08-14','08:45:00',1.07),('325','2013-08-14','08:50:00',1.14),('325','2013-08-14','08:55:00',1.26),('325','2013-08-14','09:00:00',1.36),('325','2013-08-14','09:05:00',1.23),('325','2013-08-14','09:10:00',1.8),('325','2013-08-14','09:15:00',2.05),('325','2013-08-14','09:20:00',2.13),('325','2013-08-14','09:25:00',2.11),('325','2013-08-14','09:30:00',2.34),('325','2013-08-14','09:35:00',2.45),('325','2013-08-14','09:40:00',1.74),('325','2013-08-14','09:45:00',2.52),('325','2013-08-14','09:50:00',1.66),('325','2013-08-14','09:55:00',2.61),('325','2013-08-14','10:00:00',2.99),('325','2013-08-14','10:05:00',2.76),('325','2013-08-14','10:10:00',2.67),('325','2013-08-14','10:15:00',1.61),('325','2013-08-14','10:20:00',2.44),('325','2013-08-14','10:25:00',3.42),('325','2013-08-14','10:30:00',2.83),('325','2013-08-14','10:35:00',2.06),('325','2013-08-14','10:40:00',1.22),('325','2013-08-14','10:45:00',1.01),('325','2013-08-14','10:50:00',1.04),('325','2013-08-14','10:55:00',1.26),('325','2013-08-14','11:00:00',3.7),('325','2013-08-14','11:05:00',3.75),('325','2013-08-14','11:10:00',3.61),('325','2013-08-14','11:15:00',3.7),('325','2013-08-14','11:20:00',3.48),('325','2013-08-14','11:25:00',3.68),('325','2013-08-14','11:30:00',4.07),('325','2013-08-14','11:35:00',2.57),('325','2013-08-14','11:40:00',1.65),('325','2013-08-14','11:45:00',1.48),('325','2013-08-14','11:50:00',2.17),('325','2013-08-14','11:55:00',3.79),('325','2013-08-14','12:00:00',4.08),('325','2013-08-14','12:05:00',2.05),('325','2013-08-14','12:10:00',1.49),('325','2013-08-14','12:15:00',1.34),('325','2013-08-14','12:20:00',1.23),('325','2013-08-14','12:25:00',1.59),('325','2013-08-14','12:30:00',1.24),('325','2013-08-14','12:35:00',1.34),('325','2013-08-14','12:40:00',1.63),('325','2013-08-14','12:45:00',2.03),('325','2013-08-14','12:50:00',2.87),('325','2013-08-14','12:55:00',3.26),('325','2013-08-14','13:00:00',2.27),('325','2013-08-14','13:05:00',1.11),('325','2013-08-14','13:10:00',1.22),('325','2013-08-14','13:15:00',1.59),('325','2013-08-14','13:20:00',1.41),('325','2013-08-14','13:25:00',3.3),('325','2013-08-14','13:30:00',4.46),('325','2013-08-14','13:35:00',2.21),('325','2013-08-14','13:40:00',3.03),('325','2013-08-14','13:45:00',4.71),('325','2013-08-14','13:50:00',3.77),('325','2013-08-14','13:55:00',3.04),('325','2013-08-14','14:00:00',4.65),('325','2013-08-14','14:05:00',3.57),('325','2013-08-14','14:10:00',4.39),('325','2013-08-14','14:15:00',4.44),('325','2013-08-14','14:20:00',3.5),('325','2013-08-14','14:25:00',4.33),('325','2013-08-14','14:30:00',3.8),('325','2013-08-14','14:35:00',4.26),('325','2013-08-14','14:40:00',4.19),('325','2013-08-14','14:45:00',4.11),('325','2013-08-14','14:50:00',4.14),('325','2013-08-14','14:55:00',4.11),('325','2013-08-14','15:00:00',3.97),('325','2013-08-14','15:05:00',3.91),('325','2013-08-14','15:10:00',3.75),('325','2013-08-14','15:15:00',3.96),('325','2013-08-14','15:20:00',3.91),('325','2013-08-14','15:25:00',3.83),('325','2013-08-14','15:30:00',3.72),('325','2013-08-14','15:35:00',3.69),('325','2013-08-14','15:40:00',3.67),('325','2013-08-14','15:45:00',3.61),('325','2013-08-14','15:50:00',3.55),('325','2013-08-14','15:55:00',3.52),('325','2013-08-14','16:00:00',3.43),('325','2013-08-14','16:05:00',3.37),('325','2013-08-14','16:10:00',3.35),('325','2013-08-14','16:15:00',3.32),('325','2013-08-14','16:20:00',3.24),('325','2013-08-14','16:25:00',3.16),('325','2013-08-14','16:30:00',3.09),('325','2013-08-14','16:35:00',3.02),('325','2013-08-14','16:40:00',2.96),('325','2013-08-14','16:45:00',2.88),('325','2013-08-14','16:50:00',2.78),('325','2013-08-14','16:55:00',2.69),('325','2013-08-14','17:00:00',2.56),('325','2013-08-14','17:05:00',2.5),('325','2013-08-14','17:10:00',2.39),('325','2013-08-14','17:15:00',2.32),('325','2013-08-14','17:20:00',2.21),('325','2013-08-14','17:25:00',2.12),('325','2013-08-14','17:30:00',2.02),('325','2013-08-14','17:35:00',1.95),('325','2013-08-14','17:40:00',1.84),('325','2013-08-14','17:45:00',1.75),('325','2013-08-14','17:50:00',1.66),('325','2013-08-14','17:55:00',1.56),('325','2013-08-14','18:00:00',1.46),('325','2013-08-14','18:05:00',1.39),('325','2013-08-14','18:10:00',1.3),('325','2013-08-14','18:15:00',1.21),('325','2013-08-14','18:20:00',1.16),('325','2013-08-14','18:25:00',1.11),('325','2013-08-14','18:30:00',1.01),('325','2013-08-13','08:45:00',1.03),('325','2013-08-13','08:50:00',1.07),('325','2013-08-13','08:55:00',1.09),('325','2013-08-13','09:00:00',1.14),('325','2013-08-13','09:05:00',1.19),('325','2013-08-13','09:10:00',1.26),('325','2013-08-13','09:15:00',1.41),('325','2013-08-13','09:20:00',2),('325','2013-08-13','09:25:00',2.09),('325','2013-08-13','09:30:00',2.16),('325','2013-08-13','09:35:00',2.23),('325','2013-08-13','09:40:00',2.24),('325','2013-08-13','09:45:00',2.39),('325','2013-08-13','09:50:00',2.48),('325','2013-08-13','09:55:00',2.58),('325','2013-08-13','10:00:00',2.74),('325','2013-08-13','10:05:00',2.62),('325','2013-08-13','10:10:00',2.77),('325','2013-08-13','10:15:00',3.04),('325','2013-08-13','10:20:00',3.13),('325','2013-08-13','10:25:00',3.23),('325','2013-08-13','10:30:00',3.31),('325','2013-08-13','10:35:00',3.28),('325','2013-08-13','10:40:00',3.31),('325','2013-08-13','10:45:00',3.41),('325','2013-08-13','10:50:00',3.54),('325','2013-08-13','10:55:00',3.55),('325','2013-08-13','11:00:00',3.63),('325','2013-08-13','11:05:00',3.67),('325','2013-08-13','11:10:00',3.7),('325','2013-08-13','11:15:00',3.75),('325','2013-08-13','11:20:00',3.76),('325','2013-08-13','11:25:00',3.81),('325','2013-08-13','11:30:00',3.82),('325','2013-08-13','11:35:00',3.82),('325','2013-08-13','11:40:00',3.83),('325','2013-08-13','11:45:00',3.87),('325','2013-08-13','11:50:00',3.95),('325','2013-08-13','11:55:00',4.05),('325','2013-08-13','12:00:00',2.51),('325','2013-08-13','12:05:00',4.2),('325','2013-08-13','12:10:00',4.34),('325','2013-08-13','12:15:00',4.38),('325','2013-08-13','12:20:00',4.29),('325','2013-08-13','12:25:00',4.39),('325','2013-08-13','12:30:00',4.45),('325','2013-08-13','12:35:00',2.27),('325','2013-08-13','12:40:00',2.3),('325','2013-08-13','12:45:00',2.33),('325','2013-08-13','12:50:00',1.65),('325','2013-08-13','12:55:00',1.6),('325','2013-08-13','13:00:00',1.41),('325','2013-08-13','13:05:00',3.72),('325','2013-08-13','13:10:00',4.6),('325','2013-08-13','13:15:00',4.66),('325','2013-08-13','13:20:00',1.71),('325','2013-08-13','13:25:00',1.37),('325','2013-08-13','13:30:00',2.23),('325','2013-08-13','13:35:00',4.79),('325','2013-08-13','13:40:00',2.72),('325','2013-08-13','13:45:00',1.48),('325','2013-08-13','13:50:00',1.53),('325','2013-08-13','13:55:00',3.24),('325','2013-08-13','14:00:00',4.79),('325','2013-08-13','14:05:00',4.64),('325','2013-08-13','14:10:00',4.53),('325','2013-08-13','14:15:00',4.2),('325','2013-08-13','14:20:00',4.35),('325','2013-08-13','14:25:00',3.68),('325','2013-08-13','14:30:00',3.93),('325','2013-08-13','14:35:00',2.71),('325','2013-08-13','14:40:00',3.68),('325','2013-08-13','14:45:00',2.96),('325','2013-08-13','14:50:00',3.29),('325','2013-08-13','14:55:00',3.88),('325','2013-08-13','15:00:00',4.01),('325','2013-08-13','15:05:00',3.61),('325','2013-08-13','15:10:00',4.1),('325','2013-08-13','15:15:00',3.94),('325','2013-08-13','15:20:00',3.9),('325','2013-08-13','15:25:00',3.86),('325','2013-08-13','15:30:00',3.84),('325','2013-08-13','15:35:00',3.82),('325','2013-08-13','15:40:00',3.74),('325','2013-08-13','15:45:00',3.66),('325','2013-08-13','15:50:00',3.57),('325','2013-08-13','15:55:00',3.49),('325','2013-08-13','16:00:00',3.45),('325','2013-08-13','16:05:00',3.4),('325','2013-08-13','16:10:00',3.33),('325','2013-08-13','16:15:00',3.26),('325','2013-08-13','16:20:00',3.21),('325','2013-08-13','16:25:00',3.15),('325','2013-08-13','16:30:00',3.09),('325','2013-08-13','16:35:00',3.01),('325','2013-08-13','16:40:00',2.95),('325','2013-08-13','16:45:00',2.85),('325','2013-08-13','16:50:00',2.77),('325','2013-08-13','16:55:00',2.67),('325','2013-08-13','17:00:00',2.54),('325','2013-08-13','17:05:00',2.48),('325','2013-08-13','17:10:00',2.42),('325','2013-08-13','17:15:00',2.33),('325','2013-08-13','17:20:00',2.24),('325','2013-08-13','17:25:00',2.14),('325','2013-08-13','17:30:00',2.04),('325','2013-08-13','17:35:00',1.96),('325','2013-08-13','17:40:00',1.84),('325','2013-08-13','17:45:00',1.75),('325','2013-08-13','17:50:00',1.66),('325','2013-08-13','17:55:00',1.57),('325','2013-08-13','18:00:00',1.47),('325','2013-08-13','18:05:00',1.38),('325','2013-08-13','18:10:00',1.28),('325','2013-08-13','18:15:00',1.19),('325','2013-08-13','18:20:00',1.11),('325','2013-08-13','18:25:00',1),('325','2013-08-12','08:45:00',1.02),('325','2013-08-12','08:50:00',1.06),('325','2013-08-12','08:55:00',1.09),('325','2013-08-12','09:00:00',1.14),('325','2013-08-12','09:05:00',1.2),('325','2013-08-12','09:10:00',1.26),('325','2013-08-12','09:15:00',1.31),('325','2013-08-12','09:20:00',1.75),('325','2013-08-12','09:25:00',2.06),('325','2013-08-12','09:30:00',2.12),('325','2013-08-12','09:35:00',2.21),('325','2013-08-12','09:40:00',2.26),('325','2013-08-12','09:45:00',2.36),('325','2013-08-12','09:50:00',2.56),('325','2013-08-12','09:55:00',2.65),('325','2013-08-12','10:00:00',2.72),('325','2013-08-12','10:05:00',2.79),('325','2013-08-12','10:10:00',2.82),('325','2013-08-12','10:15:00',2.84),('325','2013-08-12','10:20:00',2.88),('325','2013-08-12','10:25:00',2.93),('325','2013-08-12','10:30:00',3.02),('325','2013-08-12','10:35:00',3.05),('325','2013-08-12','10:40:00',3.09),('325','2013-08-12','10:45:00',3.12),('325','2013-08-12','10:50:00',3.2),('325','2013-08-12','10:55:00',3.3),('325','2013-08-12','11:00:00',3.37),('325','2013-08-12','11:05:00',3.5),('325','2013-08-12','11:10:00',3.56),('325','2013-08-12','11:15:00',3.57),('325','2013-08-12','11:20:00',3.6),('325','2013-08-12','11:25:00',3.66),('325','2013-08-12','11:30:00',3.69),('325','2013-08-12','11:35:00',3.74),('325','2013-08-12','11:40:00',3.78),('325','2013-08-12','11:45:00',3.83),('325','2013-08-12','11:50:00',3.7),('325','2013-08-12','11:55:00',3.74),('325','2013-08-12','12:00:00',4.23),('325','2013-08-12','12:05:00',4.28),('325','2013-08-12','12:10:00',3.44),('325','2013-08-12','12:15:00',1.27),('325','2013-08-12','12:20:00',1.98),('325','2013-08-12','12:25:00',1.71),('325','2013-08-12','12:30:00',3.57),('325','2013-08-12','12:35:00',4.54),('325','2013-08-12','12:40:00',2.27),('325','2013-08-12','12:45:00',1.19),('325','2013-08-12','12:50:00',1.1),('325','2013-08-12','12:55:00',1.1),('325','2013-08-12','13:15:00',1.19),('325','2013-08-12','13:20:00',1.63),('325','2013-08-12','13:25:00',1.56),('325','2013-08-12','13:30:00',1.34),('325','2013-08-12','13:35:00',1.49),('325','2013-08-12','13:40:00',1.27),('325','2013-08-12','13:45:00',1.59),('325','2013-08-12','13:50:00',4.97),('325','2013-08-12','13:55:00',3.39),('325','2013-08-12','14:00:00',2.8),('325','2013-08-12','14:05:00',4.27),('325','2013-08-12','14:10:00',1.24),('325','2013-08-12','14:15:00',1.01),('325','2013-08-12','14:30:00',1),('325','2013-08-12','14:35:00',1.27),('325','2013-08-12','14:40:00',1.3),('325','2013-08-12','14:45:00',2.47),('325','2013-08-12','14:50:00',1.88),('325','2013-08-12','14:55:00',3.17),('325','2013-08-12','15:00:00',4.47),('325','2013-08-12','15:05:00',3.37),('325','2013-08-12','15:10:00',3.38),('325','2013-08-12','15:15:00',3.32),('325','2013-08-12','15:20:00',3.38),('325','2013-08-12','15:25:00',3.95),('325','2013-08-12','15:30:00',3.83),('325','2013-08-12','15:35:00',3.72),('325','2013-08-12','15:40:00',3.73),('325','2013-08-12','15:45:00',3.68),('325','2013-08-12','15:50:00',3.61),('325','2013-08-12','15:55:00',3.53),('325','2013-08-12','16:00:00',3.47),('325','2013-08-12','16:05:00',3.38),('325','2013-08-12','16:10:00',3.3),('325','2013-08-12','16:15:00',3.23),('325','2013-08-12','16:20:00',3.21),('325','2013-08-12','16:25:00',3.15),('325','2013-08-12','16:30:00',3.06),('325','2013-08-12','16:35:00',3),('325','2013-08-12','16:40:00',2.86),('325','2013-08-12','16:45:00',2.81),('325','2013-08-12','16:50:00',2.74),('325','2013-08-12','16:55:00',2.7),('325','2013-08-12','17:00:00',2.53),('325','2013-08-12','17:05:00',2.43),('325','2013-08-12','17:10:00',2.37),('325','2013-08-12','17:15:00',2.3),('325','2013-08-12','17:20:00',2.21),('325','2013-08-12','17:25:00',2.13),('325','2013-08-12','17:30:00',2.04),('325','2013-08-12','17:35:00',1.96),('325','2013-08-12','17:40:00',1.83),('325','2013-08-12','17:45:00',1.71),('325','2013-08-12','17:50:00',1.66),('325','2013-08-12','17:55:00',1.58),('325','2013-08-12','18:00:00',1.49),('325','2013-08-12','18:05:00',1.39),('325','2013-08-12','18:10:00',1.3),('325','2013-08-12','18:15:00',1.21),('325','2013-08-12','18:20:00',1.13),('325','2013-08-12','18:25:00',1.05),('325','2013-08-11','08:40:00',1.03),('325','2013-08-11','08:45:00',1.1),('325','2013-08-11','08:50:00',1.15),('325','2013-08-11','08:55:00',1.23),('325','2013-08-11','09:00:00',1.28),('325','2013-08-11','09:05:00',1.32),('325','2013-08-11','09:10:00',1.35),('325','2013-08-11','09:15:00',1.38),('325','2013-08-11','09:20:00',1.46),('325','2013-08-11','09:25:00',2.16),('325','2013-08-11','09:30:00',2.23),('325','2013-08-11','09:35:00',2.29),('325','2013-08-11','09:40:00',2.35),('325','2013-08-11','09:45:00',2.41),('325','2013-08-11','09:50:00',2.59),('325','2013-08-11','09:55:00',2.72),('325','2013-08-11','10:00:00',2.8),('325','2013-08-11','10:05:00',2.87),('325','2013-08-11','10:10:00',2.92),('325','2013-08-11','10:15:00',2.94),('325','2013-08-11','10:20:00',2.96),('325','2013-08-11','10:25:00',3.05),('325','2013-08-11','10:30:00',3.13),('325','2013-08-11','10:35:00',3.17),('325','2013-08-11','10:40:00',3.18),('325','2013-08-11','10:45:00',3.22),('325','2013-08-11','10:50:00',3.3),('325','2013-08-11','10:55:00',3.4),('325','2013-08-11','11:00:00',3.51),('325','2013-08-11','11:05:00',3.62),('325','2013-08-11','11:10:00',3.68),('325','2013-08-11','11:15:00',3.67),('325','2013-08-11','11:20:00',3.68),('325','2013-08-11','11:25:00',3.7),('325','2013-08-11','11:30:00',3.74),('325','2013-08-11','11:35:00',3.78),('325','2013-08-11','11:40:00',3.82),('325','2013-08-11','11:45:00',3.89),('325','2013-08-11','11:50:00',3.96),('325','2013-08-11','11:55:00',4.05),('325','2013-08-11','12:00:00',4.11),('325','2013-08-11','12:05:00',4.16),('325','2013-08-11','12:10:00',4.18),('325','2013-08-11','12:15:00',4.18),('325','2013-08-11','12:20:00',4.17),('325','2013-08-11','12:25:00',4.16),('325','2013-08-11','12:30:00',4.17),('325','2013-08-11','12:35:00',4.17),('325','2013-08-11','12:40:00',4.19),('325','2013-08-11','12:45:00',4.18),('325','2013-08-11','12:50:00',4.19),('325','2013-08-11','12:55:00',4.26),('325','2013-08-11','13:00:00',4.28),('325','2013-08-11','13:05:00',4.29),('325','2013-08-11','13:10:00',4.28),('325','2013-08-11','13:15:00',4.23),('325','2013-08-11','13:20:00',4.13),('325','2013-08-11','13:25:00',4.14),('325','2013-08-11','13:30:00',4.1),('325','2013-08-11','13:35:00',4.07),('325','2013-08-11','13:40:00',4.1),('325','2013-08-11','13:45:00',4.16),('325','2013-08-11','13:50:00',4.15),('325','2013-08-11','13:55:00',4.13),('325','2013-08-11','14:00:00',4.12),('325','2013-08-11','14:05:00',4.09),('325','2013-08-11','14:10:00',4.03),('325','2013-08-11','14:15:00',4),('325','2013-08-11','14:20:00',3.95),('325','2013-08-11','14:25:00',3.9),('325','2013-08-11','14:30:00',3.86),('325','2013-08-11','14:35:00',3.76),('325','2013-08-11','14:40:00',3.78),('325','2013-08-11','14:45:00',3.8),('325','2013-08-11','14:50:00',3.78),('325','2013-08-11','14:55:00',3.73),('325','2013-08-11','15:00:00',3.53),('325','2013-08-11','15:05:00',3.58),('325','2013-08-11','15:10:00',3.71),('325','2013-08-11','15:15:00',3.62),('325','2013-08-11','15:20:00',3.3),('325','2013-08-11','15:25:00',2.77),('325','2013-08-11','15:30:00',3.11),('325','2013-08-11','15:35:00',3.53),('325','2013-08-11','15:40:00',3.54),('325','2013-08-11','15:45:00',3.54),('325','2013-08-11','15:50:00',3.49),('325','2013-08-11','15:55:00',3.49),('325','2013-08-11','16:00:00',3.4),('325','2013-08-11','16:05:00',3.36),('325','2013-08-11','16:10:00',3.31),('325','2013-08-11','16:15:00',3.24),('325','2013-08-11','16:20:00',3.16),('325','2013-08-11','16:25:00',3.09),('325','2013-08-11','16:30:00',3.02),('325','2013-08-11','16:35:00',2.97),('325','2013-08-11','16:40:00',2.88),('325','2013-08-11','16:45:00',2.8),('325','2013-08-11','16:50:00',2.73),('325','2013-08-11','16:55:00',2.64),('325','2013-08-11','17:00:00',2.52),('325','2013-08-11','17:05:00',2.43),('325','2013-08-11','17:10:00',2.38),('325','2013-08-11','17:15:00',2.3),('325','2013-08-11','17:20:00',2.22),('325','2013-08-11','17:25:00',2.13),('325','2013-08-11','17:30:00',2.04),('325','2013-08-11','17:35:00',1.96),('325','2013-08-11','17:40:00',1.85),('325','2013-08-11','17:45:00',1.72),('325','2013-08-11','17:50:00',1.66),('325','2013-08-11','17:55:00',1.56),('325','2013-08-11','18:00:00',1.46),('325','2013-08-11','18:05:00',1.37),('325','2013-08-11','18:10:00',1.24),('325','2013-08-11','18:15:00',1.18),('325','2013-08-11','18:20:00',1.11),('325','2013-08-11','18:25:00',1.03),('325','2013-08-10','08:40:00',1.02),('325','2013-08-10','08:45:00',1.08),('325','2013-08-10','08:50:00',1.14),('325','2013-08-10','08:55:00',1.21),('325','2013-08-10','09:00:00',1.25),('325','2013-08-10','09:05:00',1.29),('325','2013-08-10','09:10:00',1.33),('325','2013-08-10','09:15:00',1.82),('325','2013-08-10','09:20:00',2.13),('325','2013-08-10','09:25:00',2.2),('325','2013-08-10','09:30:00',2.27),('325','2013-08-10','09:35:00',2.33),('325','2013-08-10','09:40:00',2.38),('325','2013-08-10','09:45:00',2.41),('325','2013-08-10','09:50:00',2.58),('325','2013-08-10','09:55:00',2.73),('325','2013-08-10','10:00:00',2.8),('325','2013-08-10','10:05:00',2.88),('325','2013-08-10','10:10:00',2.64),('325','2013-08-10','10:15:00',2.49),('325','2013-08-10','10:20:00',2.95),('325','2013-08-10','10:25:00',3.01),('325','2013-08-10','10:30:00',3.1),('325','2013-08-10','10:35:00',3.16),('325','2013-08-10','10:40:00',3.18),('325','2013-08-10','10:45:00',3.44),('325','2013-08-10','10:50:00',3.57),('325','2013-08-10','10:55:00',3.65),('325','2013-08-10','11:00:00',3.74),('325','2013-08-10','11:05:00',3.79),('325','2013-08-10','11:10:00',3.86),('325','2013-08-10','11:15:00',3.95),('325','2013-08-10','11:20:00',3.36),('325','2013-08-10','11:25:00',3.19),('325','2013-08-10','11:30:00',4.05),('325','2013-08-10','11:35:00',3.85),('325','2013-08-10','11:40:00',4.01),('325','2013-08-10','11:45:00',4.02),('325','2013-08-10','11:50:00',4.07),('325','2013-08-10','11:55:00',4.14),('325','2013-08-10','12:00:00',4.18),('325','2013-08-10','12:05:00',4.22),('325','2013-08-10','12:10:00',4.24),('325','2013-08-10','12:15:00',4.24),('325','2013-08-10','12:20:00',4.2),('325','2013-08-10','12:25:00',4.2),('325','2013-08-10','12:30:00',4.2),('325','2013-08-10','12:35:00',4.21),('325','2013-08-10','12:40:00',4.25),('325','2013-08-10','12:45:00',4.27),('325','2013-08-10','12:50:00',4.41),('325','2013-08-10','12:55:00',4.07),('325','2013-08-10','13:00:00',4.41),('325','2013-08-10','13:05:00',4.34),('325','2013-08-10','13:10:00',4.3),('325','2013-08-10','13:15:00',4.43),('325','2013-08-10','13:20:00',4.45),('325','2013-08-10','13:25:00',4.56),('325','2013-08-10','13:30:00',4.61),('325','2013-08-10','13:35:00',3.66),('325','2013-08-10','13:40:00',1.33),('325','2013-08-10','13:50:00',1.27),('325','2013-08-10','13:55:00',4.41),('325','2013-08-10','14:00:00',4.69),('325','2013-08-10','14:05:00',4.58),('325','2013-08-10','14:10:00',2.34),('325','2013-08-10','14:15:00',4.06),('325','2013-08-10','14:20:00',2.65),('325','2013-08-10','14:25:00',1.33),('325','2013-08-10','14:30:00',1.22),('325','2013-08-10','14:35:00',1.06),('325','2013-08-10','15:00:00',1.02),('325','2013-08-10','15:05:00',1.05),('325','2013-08-10','15:10:00',1.09),('325','2013-08-10','15:15:00',1.19),('325','2013-08-10','15:20:00',1.22),('325','2013-08-10','15:25:00',1.11),('325','2013-08-10','15:30:00',1.07),('325','2013-08-10','15:35:00',1.34),('325','2013-08-10','15:40:00',1.3),('325','2013-08-10','15:45:00',1.5),('325','2013-08-10','15:50:00',2.16),('325','2013-08-10','15:55:00',2.41),('325','2013-08-10','16:00:00',2.52),('325','2013-08-10','16:05:00',4.64),('325','2013-08-10','16:10:00',2.65),('325','2013-08-10','16:15:00',2.36),('325','2013-08-10','16:20:00',2.58),('325','2013-08-10','16:25:00',1.19),('325','2013-08-10','16:30:00',2.34),('325','2013-08-10','16:35:00',2.23),('325','2013-08-10','16:40:00',2.72),('325','2013-08-10','16:45:00',3.15),('325','2013-08-10','16:50:00',2.94),('325','2013-08-10','16:55:00',2.71),('325','2013-08-10','17:00:00',1.75),('325','2013-08-10','17:05:00',1.76),('325','2013-08-10','17:10:00',1.06),('325','2013-08-10','17:15:00',1.22),('325','2013-08-10','17:20:00',1.36),('325','2013-08-10','17:25:00',1.85),('325','2013-08-10','17:30:00',1.41),('325','2013-08-09','08:40:00',1.06),('325','2013-08-09','08:45:00',1.13),('325','2013-08-09','08:50:00',1.15),('325','2013-08-09','08:55:00',1.29),('325','2013-08-09','09:00:00',1.3),('325','2013-08-09','09:05:00',1.41),('325','2013-08-09','09:10:00',1.59),('325','2013-08-09','09:15:00',1.73),('325','2013-08-09','09:20:00',1.33),('325','2013-08-09','09:25:00',1.43),('325','2013-08-09','09:30:00',1.36),('325','2013-08-09','09:35:00',2.05),('325','2013-08-09','09:40:00',1.78),('325','2013-08-09','09:45:00',2.31),('325','2013-08-09','09:50:00',1.82),('325','2013-08-09','09:55:00',1.72),('325','2013-08-09','10:00:00',1.79),('325','2013-08-09','10:05:00',1.86),('325','2013-08-09','10:10:00',2.55),('325','2013-08-09','10:15:00',2.8),('325','2013-08-09','10:20:00',2.77),('325','2013-08-09','10:25:00',2.73),('325','2013-08-09','10:30:00',2.83),('325','2013-08-09','10:35:00',2.92),('325','2013-08-09','10:40:00',2.64),('325','2013-08-09','10:45:00',3.07),('325','2013-08-09','10:50:00',3.02),('325','2013-08-09','10:55:00',3.13),('325','2013-08-09','11:00:00',3.33),('325','2013-08-09','11:05:00',3.39),('325','2013-08-09','11:10:00',3.43),('325','2013-08-09','11:15:00',3.52),('325','2013-08-09','11:20:00',3.57),('325','2013-08-09','11:25:00',3.57),('325','2013-08-09','11:30:00',3.61),('325','2013-08-09','11:35:00',3.6),('325','2013-08-09','11:40:00',3.68),('325','2013-08-09','11:45:00',3.7),('325','2013-08-09','11:50:00',3.71),('325','2013-08-09','11:55:00',3.76),('325','2013-08-09','12:00:00',3.82),('325','2013-08-09','12:05:00',3.88),('325','2013-08-09','12:10:00',3.82),('325','2013-08-09','12:15:00',3.89),('325','2013-08-09','12:20:00',4.07),('325','2013-08-09','12:25:00',3.31),('325','2013-08-09','12:30:00',2.99),('325','2013-08-09','12:35:00',3.19),('325','2013-08-09','12:40:00',4.15),('325','2013-08-09','12:45:00',3.59),('325','2013-08-09','12:50:00',2.83),('325','2013-08-09','12:55:00',3.02),('325','2013-08-09','13:00:00',1.34),('325','2013-08-09','13:15:00',1.24),('325','2013-08-09','13:20:00',1.7),('325','2013-08-09','13:25:00',2.26),('325','2013-08-09','13:30:00',1.87),('325','2013-08-09','13:35:00',1.5),('325','2013-08-09','13:40:00',1.44),('325','2013-08-09','13:45:00',1.37),('325','2013-08-09','13:50:00',1.47),('325','2013-08-09','13:55:00',1.32),('325','2013-08-09','14:00:00',1.37),('325','2013-08-09','14:05:00',1.23),('325','2013-08-09','14:10:00',1.58),('325','2013-08-09','14:25:00',1.02),('325','2013-08-09','15:05:00',1.37),('325','2013-08-09','15:10:00',3.01),('325','2013-08-09','15:15:00',2.76),('325','2013-08-09','15:20:00',1.66),('325','2013-08-09','15:25:00',1.26),('325','2013-08-09','15:30:00',1.33),('325','2013-08-09','15:35:00',2.35),('325','2013-08-09','15:40:00',1.75),('325','2013-08-09','15:45:00',3.14),('325','2013-08-09','15:50:00',2.14),('325','2013-08-09','15:55:00',1.89),('325','2013-08-09','16:00:00',1.28),('325','2013-08-09','16:50:00',1.67),('325','2013-08-09','16:55:00',2.59),('325','2013-08-09','17:00:00',1.47),('325','2013-08-09','17:05:00',1.8),('325','2013-08-09','19:20:00',1.03),('325','2013-08-09','19:25:00',1.01),('325','2014-04-08','08:20:00',1.05),('325','2014-04-08','08:30:00',1.04),('325','2014-04-08','08:45:00',1.12),('325','2014-04-08','08:50:00',1.15),('325','2014-04-08','08:55:00',1.24),('325','2014-04-08','09:00:00',1.29),('325','2014-04-08','09:05:00',1.34),('325','2014-04-08','09:10:00',1.38),('325','2014-04-08','09:15:00',1.43),('325','2014-04-08','09:20:00',1.48),('325','2014-04-08','09:25:00',1.54),('325','2014-04-08','09:30:00',1.59),('325','2014-04-08','09:35:00',1.62),('325','2014-04-08','09:40:00',1.65),('325','2014-04-08','09:45:00',1.71),('325','2014-04-08','09:50:00',1.76),('325','2014-04-08','09:55:00',1.78),('325','2014-04-08','10:00:00',1.81),('325','2014-04-08','10:05:00',1.81),('325','2014-04-08','10:10:00',1.9),('325','2014-04-08','10:15:00',2.23),('325','2014-04-08','10:20:00',3.08),('325','2014-04-08','10:25:00',3.18),('325','2014-04-08','10:30:00',3.25),('325','2014-04-08','10:35:00',3.33),('325','2014-04-08','10:40:00',3.43),('325','2014-04-08','10:45:00',3.45),('325','2014-04-08','10:50:00',3.54),('325','2014-04-08','10:55:00',3.65),('325','2014-04-08','11:00:00',3.71),('325','2014-04-08','11:05:00',3.61),('325','2014-04-08','11:10:00',3.7),('325','2014-04-08','11:15:00',3.75),('325','2014-04-08','11:20:00',3.85),('325','2014-04-08','11:25:00',3.75),('325','2014-04-08','11:30:00',3.83),('325','2014-04-08','11:35:00',3.76),('325','2014-04-08','11:40:00',3.96),('325','2014-04-08','11:45:00',4.03),('325','2014-04-08','11:50:00',4.02),('325','2014-04-08','11:55:00',4.01),('325','2014-04-08','12:00:00',4.08),('325','2014-04-08','12:05:00',4.06),('325','2014-04-08','12:10:00',3.98),('325','2014-04-08','12:15:00',3.74),('325','2014-04-08','12:20:00',3.77),('325','2014-04-08','12:25:00',3.76),('325','2014-04-08','12:30:00',4.44),('325','2014-04-08','12:35:00',4.37),('325','2014-04-08','12:40:00',3.65),('325','2014-04-08','12:45:00',2.83),('325','2014-04-08','12:50:00',3.9),('325','2014-04-08','12:55:00',4.35),('325','2014-04-08','13:00:00',4.17),('325','2014-04-08','13:05:00',4.32),('325','2014-04-08','13:10:00',4.43),('325','2014-04-08','13:15:00',4.53),('325','2014-04-08','13:20:00',4.49),('325','2014-04-08','13:25:00',4.55),('325','2014-04-08','13:30:00',4.5),('325','2014-04-08','13:35:00',4.52),('325','2014-04-08','13:40:00',4.46),('325','2014-04-08','13:45:00',4.41),('325','2014-04-08','13:50:00',4.43),('325','2014-04-08','13:55:00',4.46),('325','2014-04-08','14:00:00',4.43),('325','2014-04-08','14:05:00',4.42),('325','2014-04-08','14:10:00',4.4),('325','2014-04-08','14:15:00',4.36),('325','2014-04-08','14:20:00',4.04),('325','2014-04-08','14:25:00',4.07),('325','2014-04-08','14:30:00',4.36),('325','2014-04-08','14:35:00',4.16),('325','2014-04-08','14:40:00',3.7),('325','2014-04-08','14:45:00',3.82),('325','2014-04-08','14:50:00',4.11),('325','2014-04-08','14:55:00',4.21),('325','2014-04-08','15:00:00',4.1),('325','2014-04-08','15:05:00',4),('325','2014-04-08','15:10:00',3.99),('325','2014-04-08','15:15:00',3.92),('325','2014-04-08','15:20:00',3.83),('325','2014-04-08','15:25:00',3.66),('325','2014-04-08','15:30:00',3.55),('325','2014-04-08','15:35:00',3.74),('325','2014-04-08','15:40:00',3.64),('325','2014-04-08','15:45:00',3.46),('325','2014-04-08','15:50:00',3.53),('325','2014-04-08','15:55:00',3.46),('325','2014-04-08','16:00:00',3.3),('325','2014-04-08','16:05:00',3.25),('325','2014-04-08','16:10:00',3.12),('325','2014-04-08','16:15:00',2.94),('325','2014-04-08','16:20:00',2.69),('325','2014-04-08','16:25:00',2.85),('325','2014-04-08','16:30:00',3.01),('325','2014-04-08','16:35:00',2.88),('325','2014-04-08','16:40:00',2.73),('325','2014-04-08','16:45:00',2.55),('325','2014-04-08','16:50:00',2.52),('325','2014-04-08','16:55:00',2.39),('325','2014-04-08','17:00:00',2.24),('325','2014-04-08','17:05:00',2.3),('325','2014-04-08','17:10:00',2.15),('325','2014-04-08','17:15:00',2.04),('325','2014-04-08','17:20:00',1.95),('325','2014-04-08','17:25:00',1.74),('325','2014-04-08','17:30:00',1.59),('325','2014-04-08','17:35:00',1.47),('325','2014-04-08','17:40:00',1.45),('325','2014-04-08','17:45:00',1.39),('325','2014-04-08','17:50:00',1.31),('325','2014-04-08','17:55:00',1.16),('325','2014-04-08','18:00:00',1.13),('325','2014-04-08','18:05:00',1.09),('325','2013-08-08','08:45:00',1),('325','2013-08-08','08:50:00',1.05),('325','2013-08-08','08:55:00',1.07),('325','2013-08-08','09:00:00',1.1),('325','2013-08-08','09:05:00',1.2),('325','2013-08-08','09:10:00',1.28),('325','2013-08-08','09:15:00',1.34),('325','2013-08-08','09:20:00',1.92),('325','2013-08-08','09:25:00',2),('325','2013-08-08','09:30:00',2.07),('325','2013-08-08','09:35:00',2.13),('325','2013-08-08','09:40:00',2.2),('325','2013-08-08','09:45:00',2.25),('325','2013-08-08','09:50:00',2.35),('325','2013-08-08','09:55:00',2.45),('325','2013-08-08','10:00:00',2.59),('325','2013-08-08','10:05:00',2.68),('325','2013-08-08','10:10:00',2.74),('325','2013-08-08','10:15:00',2.77),('325','2013-08-08','10:20:00',2.78),('325','2013-08-08','10:25:00',2.8),('325','2013-08-08','10:30:00',2.86),('325','2013-08-08','10:35:00',2.95),('325','2013-08-08','10:40:00',2.99),('325','2013-08-08','10:45:00',3.01),('325','2013-08-08','10:50:00',3.08),('325','2013-08-08','10:55:00',3.14),('325','2013-08-08','11:00:00',3.22),('325','2013-08-08','11:05:00',3.32),('325','2013-08-08','11:10:00',3.41),('325','2013-08-08','11:15:00',3.38),('325','2013-08-08','11:20:00',3.38),('325','2013-08-08','11:25:00',3.42),('325','2013-08-08','11:30:00',3.48),('325','2013-08-08','11:35:00',3.59),('325','2013-08-08','11:40:00',3.63),('325','2013-08-08','11:45:00',3.67),('325','2013-08-08','11:50:00',3.73),('325','2013-08-08','11:55:00',3.74),('325','2013-08-08','12:00:00',3.78),('325','2013-08-08','12:05:00',3.87),('325','2013-08-08','12:10:00',3.88),('325','2013-08-08','12:15:00',3.86),('325','2013-08-08','12:20:00',3.87),('325','2013-08-08','12:25:00',3.83),('325','2013-08-08','12:30:00',3.81),('325','2013-08-08','12:35:00',3.99),('325','2013-08-08','12:40:00',3.96),('325','2013-08-08','12:45:00',3.94),('325','2013-08-08','12:50:00',3.96),('325','2013-08-08','12:55:00',4.03),('325','2013-08-08','13:00:00',4.06),('325','2013-08-08','13:05:00',4.12),('325','2013-08-08','13:10:00',4.06),('325','2013-08-08','13:15:00',4.04),('325','2013-08-08','13:20:00',4.01),('325','2013-08-08','13:25:00',3.97),('325','2013-08-08','13:30:00',3.94),('325','2013-08-08','13:35:00',3.88),('325','2013-08-08','13:40:00',3.86),('325','2013-08-08','13:45:00',3.91),('325','2013-08-08','13:50:00',4.01),('325','2013-08-08','13:55:00',4.01),('325','2013-08-08','14:00:00',4),('325','2013-08-08','14:05:00',3.96),('325','2013-08-08','14:10:00',3.86),('325','2013-08-08','14:15:00',3.79),('325','2013-08-08','14:20:00',3.74),('325','2013-08-08','14:25:00',3.87),('325','2013-08-08','14:30:00',3.87),('325','2013-08-08','14:35:00',3.83),('325','2013-08-08','14:40:00',3.81),('325','2013-08-08','14:45:00',3.75),('325','2013-08-08','14:50:00',3.72),('325','2013-08-08','14:55:00',3.68),('325','2013-08-08','15:00:00',3.66),('325','2013-08-08','15:05:00',3.64),('325','2013-08-08','15:10:00',3.63),('325','2013-08-08','15:15:00',3.54),('325','2013-08-08','15:20:00',3.5),('325','2013-08-08','15:25:00',3.45),('325','2013-08-08','15:30:00',3.41),('325','2013-08-08','15:35:00',3.39),('325','2013-08-08','15:40:00',3.36),('325','2013-08-08','15:45:00',3.32),('325','2013-08-08','15:50:00',3.27),('325','2013-08-08','15:55:00',3.24),('325','2013-08-08','16:00:00',3.19),('325','2013-08-08','16:05:00',3.16),('325','2013-08-08','16:10:00',3.13),('325','2013-08-08','16:15:00',3.07),('325','2013-08-08','16:20:00',3.03),('325','2013-08-08','16:25:00',2.98),('325','2013-08-08','16:30:00',2.93),('325','2013-08-08','16:35:00',2.84),('325','2013-08-08','16:40:00',2.77),('325','2013-08-08','16:45:00',2.69),('325','2013-08-08','16:50:00',2.6),('325','2013-08-08','16:55:00',2.52),('325','2013-08-08','17:00:00',2.4),('325','2013-08-08','17:05:00',2.26),('325','2013-08-08','17:10:00',2.25),('325','2013-08-08','17:15:00',2.16),('325','2013-08-08','17:20:00',2.08),('325','2013-08-08','17:25:00',2),('325','2013-08-08','17:30:00',1.91),('325','2013-08-08','17:35:00',1.82),('325','2013-08-08','17:40:00',1.74),('325','2013-08-08','17:45:00',1.61),('325','2013-08-08','17:50:00',1.56),('325','2013-08-08','17:55:00',1.48),('325','2013-08-08','18:00:00',1.41),('325','2013-08-08','18:05:00',1.32),('325','2013-08-08','18:10:00',1.23),('325','2013-08-08','18:15:00',1.15),('325','2013-08-08','18:20:00',1.07),('325','2013-08-07','08:50:00',1.05),('325','2013-08-07','08:55:00',1.08),('325','2013-08-07','09:00:00',1.11),('325','2013-08-07','09:05:00',1.19),('325','2013-08-07','09:10:00',1.27),('325','2013-08-07','09:15:00',1.45),('325','2013-08-07','09:20:00',1.94),('325','2013-08-07','09:25:00',2.02),('325','2013-08-07','09:30:00',2.11),('325','2013-08-07','09:35:00',2.16),('325','2013-08-07','09:40:00',2.22),('325','2013-08-07','09:45:00',2.26),('325','2013-08-07','09:50:00',2.38),('325','2013-08-07','09:55:00',2.48),('325','2013-08-07','10:00:00',2.61),('325','2013-08-07','10:05:00',2.72),('325','2013-08-07','10:10:00',2.8),('325','2013-08-07','10:15:00',2.82),('325','2013-08-07','10:20:00',2.79),('325','2013-08-07','10:25:00',2.83),('325','2013-08-07','10:30:00',2.9),('325','2013-08-07','10:35:00',2.97),('325','2013-08-07','10:40:00',3.01),('325','2013-08-07','10:45:00',3.02),('325','2013-08-07','10:50:00',3.11),('325','2013-08-07','10:55:00',3.16),('325','2013-08-07','11:00:00',3.24),('325','2013-08-07','11:05:00',3.34),('325','2013-08-07','11:10:00',3.43),('325','2013-08-07','11:15:00',3.45),('325','2013-08-07','11:20:00',3.44),('325','2013-08-07','11:25:00',3.44),('325','2013-08-07','11:30:00',3.48),('325','2013-08-07','11:35:00',3.5),('325','2013-08-07','11:40:00',3.53),('325','2013-08-07','11:45:00',3.58),('325','2013-08-07','11:50:00',3.68),('325','2013-08-07','11:55:00',3.77),('325','2013-08-07','12:00:00',3.85),('325','2013-08-07','12:05:00',3.89),('325','2013-08-07','12:10:00',3.82),('325','2013-08-07','12:15:00',3.86),('325','2013-08-07','12:20:00',3.81),('325','2013-08-07','12:25:00',3.84),('325','2013-08-07','12:30:00',3.85),('325','2013-08-07','12:35:00',3.81),('325','2013-08-07','12:40:00',3.91),('325','2013-08-07','12:45:00',3.83),('325','2013-08-07','12:50:00',3.89),('325','2013-08-07','12:55:00',3.95),('325','2013-08-07','13:00:00',4.06),('325','2013-08-07','13:05:00',4.13),('325','2013-08-07','13:10:00',4.07),('325','2013-08-07','13:15:00',4.03),('325','2013-08-07','13:20:00',3.98),('325','2013-08-07','13:25:00',4.01),('325','2013-08-07','13:30:00',3.94),('325','2013-08-07','13:35:00',3.91),('325','2013-08-07','13:40:00',3.95),('325','2013-08-07','13:45:00',3.95),('325','2013-08-07','13:50:00',3.98),('325','2013-08-07','13:55:00',3.98),('325','2013-08-07','14:00:00',4.01),('325','2013-08-07','14:05:00',3.96),('325','2013-08-07','14:10:00',3.89),('325','2013-08-07','14:15:00',3.78),('325','2013-08-07','14:20:00',3.69),('325','2013-08-07','14:25:00',3.64),('325','2013-08-07','14:30:00',3.56),('325','2013-08-07','14:35:00',3.56),('325','2013-08-07','14:40:00',3.6),('325','2013-08-07','14:45:00',3.6),('325','2013-08-07','14:50:00',3.63),('325','2013-08-07','14:55:00',3.63),('325','2013-08-07','15:00:00',3.63),('325','2013-08-07','15:05:00',3.57),('325','2013-08-07','15:10:00',3.58),('325','2013-08-07','15:15:00',3.58),('325','2013-08-07','15:20:00',3.57),('325','2013-08-07','15:25:00',3.49),('325','2013-08-07','15:30:00',3.48),('325','2013-08-07','15:35:00',3.46),('325','2013-08-07','15:40:00',3.45),('325','2013-08-07','15:45:00',3.4),('325','2013-08-07','15:50:00',3.35),('325','2013-08-07','15:55:00',3.26),('325','2013-08-07','16:00:00',3.19),('325','2013-08-07','16:05:00',3.16),('325','2013-08-07','16:10:00',3.1),('325','2013-08-07','16:15:00',3.07),('325','2013-08-07','16:20:00',3.01),('325','2013-08-07','16:25:00',2.98),('325','2013-08-07','16:30:00',2.92),('325','2013-08-07','16:35:00',2.86),('325','2013-08-07','16:40:00',2.77),('325','2013-08-07','16:45:00',2.72),('325','2013-08-07','16:50:00',2.65),('325','2013-08-07','16:55:00',2.59),('325','2013-08-07','17:00:00',2.47),('325','2013-08-07','17:05:00',2.33),('325','2013-08-07','17:10:00',2.3),('325','2013-08-07','17:15:00',2.23),('325','2013-08-07','17:20:00',2.16),('325','2013-08-07','17:25:00',2.02),('325','2013-08-07','17:30:00',1.95),('325','2013-08-07','17:35:00',1.88),('325','2013-08-07','17:40:00',1.78),('325','2013-08-07','17:45:00',1.65),('325','2013-08-07','17:50:00',1.6),('325','2013-08-07','17:55:00',1.52),('325','2013-08-07','18:00:00',1.43),('325','2013-08-07','18:05:00',1.32),('325','2013-08-07','18:10:00',1.23),('325','2013-08-07','18:15:00',1.16),('325','2013-08-07','18:20:00',1.07),('325','2013-08-07','18:25:00',1),('325','2013-08-06','08:45:00',1.01),('325','2013-08-06','08:50:00',1.06),('325','2013-08-06','08:55:00',1.08),('325','2013-08-06','09:00:00',1.12),('325','2013-08-06','09:05:00',1.17),('325','2013-08-06','09:10:00',1.24),('325','2013-08-06','09:15:00',1.32),('325','2013-08-06','09:20:00',1.48),('325','2013-08-06','09:25:00',2),('325','2013-08-06','09:30:00',2.09),('325','2013-08-06','09:35:00',2.16),('325','2013-08-06','09:40:00',2.22),('325','2013-08-06','09:45:00',2.25),('325','2013-08-06','09:50:00',2.33),('325','2013-08-06','09:55:00',2.44),('325','2013-08-06','10:00:00',2.64),('325','2013-08-06','10:05:00',2.77),('325','2013-08-06','10:10:00',2.83),('325','2013-08-06','10:15:00',2.89),('325','2013-08-06','10:20:00',2.9),('325','2013-08-06','10:25:00',2.92),('325','2013-08-06','10:30:00',2.96),('325','2013-08-06','10:35:00',2.99),('325','2013-08-06','10:40:00',3.01),('325','2013-08-06','10:45:00',3.02),('325','2013-08-06','10:50:00',3.09),('325','2013-08-06','10:55:00',3.17),('325','2013-08-06','11:00:00',3.23),('325','2013-08-06','11:05:00',3.29),('325','2013-08-06','11:10:00',3.39),('325','2013-08-06','11:15:00',3.43),('325','2013-08-06','11:20:00',3.46),('325','2013-08-06','11:25:00',3.48),('325','2013-08-06','11:30:00',3.5),('325','2013-08-06','11:35:00',3.51),('325','2013-08-06','11:40:00',3.54),('325','2013-08-06','11:45:00',3.59),('325','2013-08-06','11:50:00',3.65),('325','2013-08-06','11:55:00',3.75),('325','2013-08-06','12:00:00',3.78),('325','2013-08-06','12:05:00',3.85),('325','2013-08-06','12:10:00',3.86),('325','2013-08-06','12:15:00',3.84),('325','2013-08-06','12:20:00',3.84),('325','2013-08-06','12:25:00',3.85),('325','2013-08-06','12:30:00',3.85),('325','2013-08-06','12:35:00',3.85),('325','2013-08-06','12:40:00',3.88),('325','2013-08-06','12:45:00',3.88),('325','2013-08-06','12:50:00',3.88),('325','2013-08-06','12:55:00',3.93),('325','2013-08-06','13:00:00',3.99),('325','2013-08-06','13:05:00',4.06),('325','2013-08-06','13:10:00',4.05),('325','2013-08-06','13:15:00',4.02),('325','2013-08-06','13:20:00',3.98),('325','2013-08-06','13:25:00',3.92),('325','2013-08-06','13:30:00',3.95),('325','2013-08-06','13:35:00',3.88),('325','2013-08-06','13:40:00',3.93),('325','2013-08-06','13:45:00',4.07),('325','2013-08-06','13:50:00',4.12),('325','2013-08-06','13:55:00',4.09),('325','2013-08-06','14:00:00',4.07),('325','2013-08-06','14:05:00',4.05),('325','2013-08-06','14:10:00',3.99),('325','2013-08-06','14:15:00',3.94),('325','2013-08-06','14:20:00',3.87),('325','2013-08-06','14:25:00',3.84),('325','2013-08-06','14:30:00',3.8),('325','2013-08-06','14:35:00',3.78),('325','2013-08-06','14:40:00',3.85),('325','2013-08-06','14:45:00',3.97),('325','2013-08-06','14:50:00',3.95),('325','2013-08-06','14:55:00',3.93),('325','2013-08-06','15:00:00',3.89),('325','2013-08-06','15:05:00',3.85),('325','2013-08-06','15:10:00',3.81),('325','2013-08-06','15:15:00',3.79),('325','2013-08-06','15:20:00',3.76),('325','2013-08-06','15:25:00',3.72),('325','2013-08-06','15:30:00',3.67),('325','2013-08-06','15:35:00',3.63),('325','2013-08-06','15:40:00',3.59),('325','2013-08-06','15:45:00',3.55),('325','2013-08-06','15:50:00',3.49),('325','2013-08-06','15:55:00',3.43),('325','2013-08-06','16:00:00',3.39),('325','2013-08-06','16:05:00',3.33),('325','2013-08-06','16:10:00',3.27),('325','2013-08-06','16:15:00',3.21),('325','2013-08-06','16:20:00',3.14),('325','2013-08-06','16:25:00',3.08),('325','2013-08-06','16:30:00',3.02),('325','2013-08-06','16:35:00',2.95),('325','2013-08-06','16:40:00',2.87),('325','2013-08-06','16:45:00',2.79),('325','2013-08-06','16:50:00',2.72),('325','2013-08-06','16:55:00',2.64),('325','2013-08-06','17:00:00',2.54),('325','2013-08-06','17:05:00',2.4),('325','2013-08-06','17:10:00',2.36),('325','2013-08-06','17:15:00',2.3),('325','2013-08-06','17:20:00',2.22),('325','2013-08-06','17:25:00',2.12),('325','2013-08-06','17:30:00',2.05),('325','2013-08-06','17:35:00',1.95),('325','2013-08-06','17:40:00',1.85),('325','2013-08-06','17:45:00',1.72),('325','2013-08-06','17:50:00',1.66),('325','2013-08-06','17:55:00',1.57),('325','2013-08-06','18:00:00',1.48),('325','2013-08-06','18:05:00',1.4),('325','2013-08-06','18:10:00',1.31),('325','2013-08-06','18:15:00',1.23),('325','2013-08-06','18:20:00',1.15),('325','2013-08-06','18:25:00',1.06),('325','2013-08-05','08:45:00',1.03),('325','2013-08-05','08:50:00',1.07),('325','2013-08-05','08:55:00',1.1),('325','2013-08-05','09:00:00',1.12),('325','2013-08-05','09:05:00',1.25),('325','2013-08-05','09:10:00',1.29),('325','2013-08-05','09:15:00',1.31),('325','2013-08-05','09:20:00',1.36),('325','2013-08-05','09:25:00',1.41),('325','2013-08-05','09:30:00',1.71),('325','2013-08-05','09:35:00',2.18),('325','2013-08-05','09:40:00',2.23),('325','2013-08-05','09:45:00',2.27),('325','2013-08-05','09:50:00',2.36),('325','2013-08-05','09:55:00',2.45),('325','2013-08-05','10:00:00',2.57),('325','2013-08-05','10:05:00',2.63),('325','2013-08-05','10:10:00',2.78),('325','2013-08-05','10:15:00',2.83),('325','2013-08-05','10:20:00',2.84),('325','2013-08-05','10:25:00',2.85),('325','2013-08-05','10:30:00',2.89),('325','2013-08-05','10:35:00',2.99),('325','2013-08-05','10:40:00',3.05),('325','2013-08-05','10:45:00',3.09),('325','2013-08-05','10:50:00',3.16),('325','2013-08-05','10:55:00',3.22),('325','2013-08-05','11:00:00',3.29),('325','2013-08-05','11:05:00',3.38),('325','2013-08-05','11:10:00',3.47),('325','2013-08-05','11:15:00',3.55),('325','2013-08-05','11:20:00',3.51),('325','2013-08-05','11:25:00',3.53),('325','2013-08-05','11:30:00',3.54),('325','2013-08-05','11:35:00',3.58),('325','2013-08-05','11:40:00',3.61),('325','2013-08-05','11:45:00',3.63),('325','2013-08-05','11:50:00',3.72),('325','2013-08-05','11:55:00',3.89),('325','2013-08-05','12:00:00',3.93),('325','2013-08-05','12:05:00',4),('325','2013-08-05','12:10:00',4),('325','2013-08-05','12:15:00',3.98),('325','2013-08-05','12:20:00',3.94),('325','2013-08-05','12:25:00',3.96),('325','2013-08-05','12:30:00',3.97),('325','2013-08-05','12:35:00',3.96),('325','2013-08-05','12:40:00',3.99),('325','2013-08-05','12:45:00',3.96),('325','2013-08-05','12:50:00',3.96),('325','2013-08-05','12:55:00',4.02),('325','2013-08-05','13:00:00',4.05),('325','2013-08-05','13:05:00',4.09),('325','2013-08-05','13:10:00',4.05),('325','2013-08-05','13:15:00',4.02),('325','2013-08-05','13:20:00',4),('325','2013-08-05','13:25:00',3.99),('325','2013-08-05','13:30:00',3.93),('325','2013-08-05','13:35:00',3.86),('325','2013-08-05','13:40:00',3.85),('325','2013-08-05','13:45:00',3.83),('325','2013-08-05','13:50:00',3.91),('325','2013-08-05','13:55:00',3.91),('325','2013-08-05','14:00:00',4),('325','2013-08-05','14:05:00',3.99),('325','2013-08-05','14:10:00',3.88),('325','2013-08-05','14:15:00',3.81),('325','2013-08-05','14:20:00',3.74),('325','2013-08-05','14:25:00',3.71),('325','2013-08-05','14:30:00',3.66),('325','2013-08-05','14:35:00',3.63),('325','2013-08-05','14:40:00',3.65),('325','2013-08-05','14:45:00',3.61),('325','2013-08-05','14:50:00',3.61),('325','2013-08-05','14:55:00',3.6),('325','2013-08-05','15:00:00',3.62),('325','2013-08-05','15:05:00',3.68),('325','2013-08-05','15:10:00',3.75),('325','2013-08-05','15:15:00',3.71),('325','2013-08-05','15:20:00',3.69),('325','2013-08-05','15:25:00',3.66),('325','2013-08-05','15:30:00',3.62),('325','2013-08-05','15:35:00',3.59),('325','2013-08-05','15:40:00',3.55),('325','2013-08-05','15:45:00',3.5),('325','2013-08-05','15:50:00',3.44),('325','2013-08-05','15:55:00',3.39),('325','2013-08-05','16:00:00',3.37),('325','2013-08-05','16:05:00',3.32),('325','2013-08-05','16:10:00',3.26),('325','2013-08-05','16:15:00',3.19),('325','2013-08-05','16:20:00',3.11),('325','2013-08-05','16:25:00',3.04),('325','2013-08-05','16:30:00',2.98),('325','2013-08-05','16:35:00',2.93),('325','2013-08-05','16:40:00',2.86),('325','2013-08-05','16:45:00',2.77),('325','2013-08-05','16:50:00',2.7),('325','2013-08-05','16:55:00',2.62),('325','2013-08-05','17:00:00',2.5),('325','2013-08-05','17:05:00',2.37),('325','2013-08-05','17:10:00',2.34),('325','2013-08-05','17:15:00',2.26),('325','2013-08-05','17:20:00',2.18),('325','2013-08-05','17:25:00',2.1),('325','2013-08-05','17:30:00',2.02),('325','2013-08-05','17:35:00',1.95),('325','2013-08-05','17:40:00',1.86),('325','2013-08-05','17:45:00',1.72),('325','2013-08-05','17:50:00',1.63),('325','2013-08-05','17:55:00',1.55),('325','2013-08-05','18:00:00',1.46),('325','2013-08-05','18:05:00',1.36),('325','2013-08-05','18:10:00',1.28),('325','2013-08-05','18:15:00',1.19),('325','2013-08-05','18:20:00',1.11),('325','2013-08-05','18:25:00',1.03),('325','2013-08-04','08:40:00',1.01),('325','2013-08-04','08:45:00',1.07),('325','2013-08-04','08:50:00',1.12),('325','2013-08-04','08:55:00',1.18),('325','2013-08-04','09:00:00',1.23),('325','2013-08-04','09:05:00',1.24),('325','2013-08-04','09:10:00',1.25),('325','2013-08-04','09:15:00',1.26),('325','2013-08-04','09:20:00',1.98),('325','2013-08-04','09:25:00',2.13),('325','2013-08-04','09:30:00',2.22),('325','2013-08-04','09:35:00',2.31),('325','2013-08-04','09:40:00',2.37),('325','2013-08-04','09:45:00',2.42),('325','2013-08-04','09:50:00',2.5),('325','2013-08-04','09:55:00',2.58),('325','2013-08-04','10:00:00',2.67),('325','2013-08-04','10:05:00',2.74),('325','2013-08-04','10:10:00',2.87),('325','2013-08-04','10:15:00',2.93),('325','2013-08-04','10:20:00',2.93),('325','2013-08-04','10:25:00',2.93),('325','2013-08-04','10:30:00',2.96),('325','2013-08-04','10:35:00',3.05),('325','2013-08-04','10:40:00',3.15),('325','2013-08-04','10:45:00',3.14),('325','2013-08-04','10:50:00',3.2),('325','2013-08-04','10:55:00',3.26),('325','2013-08-04','11:00:00',3.32),('325','2013-08-04','11:05:00',3.4),('325','2013-08-04','11:10:00',3.49),('325','2013-08-04','11:15:00',3.56),('325','2013-08-04','11:20:00',3.57),('325','2013-08-04','11:25:00',3.6),('325','2013-08-04','11:30:00',3.64),('325','2013-08-04','11:35:00',3.64),('325','2013-08-04','11:40:00',3.68),('325','2013-08-04','11:45:00',3.73),('325','2013-08-04','11:50:00',3.84),('325','2013-08-04','11:55:00',3.97),('325','2013-08-04','12:00:00',4),('325','2013-08-04','12:05:00',4.05),('325','2013-08-04','12:10:00',4.13),('325','2013-08-04','12:15:00',4.1),('325','2013-08-04','12:20:00',4.09),('325','2013-08-04','12:25:00',4.07),('325','2013-08-04','12:30:00',4.06),('325','2013-08-04','12:35:00',4.02),('325','2013-08-04','12:40:00',4.07),('325','2013-08-04','12:45:00',4.04),('325','2013-08-04','12:50:00',4.06),('325','2013-08-04','12:55:00',4.09),('325','2013-08-04','13:00:00',4.08),('325','2013-08-04','13:05:00',4.16),('325','2013-08-04','13:10:00',4.12),('325','2013-08-04','13:15:00',4.05),('325','2013-08-04','13:20:00',4.08),('325','2013-08-04','13:25:00',4.06),('325','2013-08-04','13:30:00',4.01),('325','2013-08-04','13:35:00',4),('325','2013-08-04','13:40:00',4.02),('325','2013-08-04','13:45:00',4.05),('325','2013-08-04','13:50:00',4.09),('325','2013-08-04','13:55:00',4.17),('325','2013-08-04','14:00:00',4.19),('325','2013-08-04','14:05:00',4.15),('325','2013-08-04','14:10:00',4.06),('325','2013-08-04','14:15:00',3.96),('325','2013-08-04','14:20:00',3.86),('325','2013-08-04','14:25:00',3.83),('325','2013-08-04','14:30:00',3.77),('325','2013-08-04','14:35:00',3.82),('325','2013-08-04','14:40:00',4.04),('325','2013-08-04','14:45:00',4.01),('325','2013-08-04','14:50:00',3.99),('325','2013-08-04','14:55:00',3.96),('325','2013-08-04','15:00:00',3.91),('325','2013-08-04','15:05:00',3.92),('325','2013-08-04','15:10:00',3.87),('325','2013-08-04','15:15:00',3.81),('325','2013-08-04','15:20:00',3.79),('325','2013-08-04','15:25:00',3.73),('325','2013-08-04','15:30:00',3.68),('325','2013-08-04','15:35:00',3.69),('325','2013-08-04','15:40:00',3.63),('325','2013-08-04','15:45:00',3.55),('325','2013-08-04','15:50:00',3.49),('325','2013-08-04','15:55:00',3.48),('325','2013-08-04','16:00:00',3.39),('325','2013-08-04','16:05:00',3.4),('325','2013-08-04','16:10:00',3.35),('325','2013-08-04','16:15:00',3.3),('325','2013-08-04','16:20:00',3.23),('325','2013-08-04','16:25:00',3.17),('325','2013-08-04','16:30:00',3.09),('325','2013-08-04','16:35:00',3.02),('325','2013-08-04','16:40:00',2.96),('325','2013-08-04','16:45:00',2.86),('325','2013-08-04','16:50:00',2.77),('325','2013-08-04','16:55:00',2.7),('325','2013-08-04','17:00:00',2.63),('325','2013-08-04','17:05:00',2.55),('325','2013-08-04','17:10:00',2.47),('325','2013-08-04','17:15:00',2.38),('325','2013-08-04','17:20:00',2.29),('325','2013-08-04','17:25:00',2.2),('325','2013-08-04','17:30:00',2.11),('325','2013-08-04','17:35:00',2.01),('325','2013-08-04','17:40:00',1.93),('325','2013-08-04','17:45:00',1.81),('325','2013-08-04','17:50:00',1.72),('325','2013-08-04','17:55:00',1.62),('325','2013-08-04','18:00:00',1.54),('325','2013-08-04','18:05:00',1.43),('325','2013-08-04','18:10:00',1.34),('325','2013-08-04','18:15:00',1.26),('325','2013-08-04','18:20:00',1.18),('325','2013-08-04','18:25:00',1.08),('325','2013-08-03','08:40:00',1.01),('325','2013-08-03','08:45:00',1.06),('325','2013-08-03','08:50:00',1.11),('325','2013-08-03','08:55:00',1.17),('325','2013-08-03','09:00:00',1.21),('325','2013-08-03','09:05:00',1.22),('325','2013-08-03','09:10:00',1.23),('325','2013-08-03','09:15:00',1.24),('325','2013-08-03','09:20:00',1.84),('325','2013-08-03','09:25:00',2.1),('325','2013-08-03','09:30:00',2.18),('325','2013-08-03','09:35:00',2.27),('325','2013-08-03','09:40:00',2.33),('325','2013-08-03','09:45:00',2.38),('325','2013-08-03','09:50:00',2.49),('325','2013-08-03','09:55:00',2.65),('325','2013-08-03','10:00:00',2.78),('325','2013-08-03','10:05:00',2.82),('325','2013-08-03','10:10:00',2.88),('325','2013-08-03','10:15:00',3.01),('325','2013-08-03','10:20:00',3.05),('325','2013-08-03','10:25:00',3.05),('325','2013-08-03','10:30:00',3.05),('325','2013-08-03','10:35:00',3.09),('325','2013-08-03','10:40:00',3.15),('325','2013-08-03','10:45:00',3.16),('325','2013-08-03','10:50:00',3.22),('325','2013-08-03','10:55:00',3.27),('325','2013-08-03','11:00:00',3.35),('325','2013-08-03','11:05:00',3.43),('325','2013-08-03','11:10:00',3.53),('325','2013-08-03','11:15:00',3.62),('325','2013-08-03','11:20:00',3.61),('325','2013-08-03','11:25:00',3.62),('325','2013-08-03','11:30:00',3.58),('325','2013-08-03','11:35:00',3.61),('325','2013-08-03','11:40:00',3.65),('325','2013-08-03','11:45:00',3.69),('325','2013-08-03','11:50:00',3.76),('325','2013-08-03','11:55:00',3.85),('325','2013-08-03','12:00:00',3.9),('325','2013-08-03','12:05:00',3.97),('325','2013-08-03','12:10:00',3.98),('325','2013-08-03','12:15:00',3.98),('325','2013-08-03','12:20:00',3.96),('325','2013-08-03','12:25:00',3.87),('325','2013-08-03','12:30:00',3.91),('325','2013-08-03','12:35:00',3.91),('325','2013-08-03','12:40:00',3.9),('325','2013-08-03','12:45:00',3.93),('325','2013-08-03','12:50:00',3.93),('325','2013-08-03','12:55:00',4),('325','2013-08-03','13:00:00',4.06),('325','2013-08-03','13:05:00',4.08),('325','2013-08-03','13:10:00',4.02),('325','2013-08-03','13:15:00',4),('325','2013-08-03','13:20:00',4.04),('325','2013-08-03','13:25:00',4.03),('325','2013-08-03','13:30:00',3.96),('325','2013-08-03','13:35:00',4.07),('325','2013-08-03','13:40:00',4.08),('325','2013-08-03','13:45:00',4.05),('325','2013-08-03','13:50:00',4.07),('325','2013-08-03','13:55:00',4.02),('325','2013-08-03','14:00:00',3.93),('325','2013-08-03','14:05:00',3.88),('325','2013-08-03','14:10:00',3.8),('325','2013-08-03','14:15:00',3.72),('325','2013-08-03','14:20:00',3.69),('325','2013-08-03','14:25:00',3.8),('325','2013-08-03','14:30:00',3.97),('325','2013-08-03','14:35:00',4.01),('325','2013-08-03','14:40:00',4.03),('325','2013-08-03','14:45:00',4.01),('325','2013-08-03','14:50:00',4),('325','2013-08-03','14:55:00',3.97),('325','2013-08-03','15:00:00',3.94),('325','2013-08-03','15:05:00',3.87),('325','2013-08-03','15:10:00',3.83),('325','2013-08-03','15:15:00',3.79),('325','2013-08-03','15:20:00',3.76),('325','2013-08-03','15:25:00',3.72),('325','2013-08-03','15:30:00',3.7),('325','2013-08-03','15:35:00',3.64),('325','2013-08-03','15:40:00',3.59),('325','2013-08-03','15:45:00',3.58),('325','2013-08-03','15:50:00',3.56),('325','2013-08-03','15:55:00',3.5),('325','2013-08-03','16:00:00',3.43),('325','2013-08-03','16:05:00',3.34),('325','2013-08-03','16:10:00',3.29),('325','2013-08-03','16:15:00',3.21),('325','2013-08-03','16:20:00',3.14),('325','2013-08-03','16:25:00',3.09),('325','2013-08-03','16:30:00',3.04),('325','2013-08-03','16:35:00',2.97),('325','2013-08-03','16:40:00',2.91),('325','2013-08-03','16:45:00',2.84),('325','2013-08-03','16:50:00',2.78),('325','2013-08-03','16:55:00',2.7),('325','2013-08-03','17:00:00',2.58),('325','2013-08-03','17:05:00',2.43),('325','2013-08-03','17:10:00',2.42),('325','2013-08-03','17:15:00',2.34),('325','2013-08-03','17:20:00',2.26),('325','2013-08-03','17:25:00',2.16),('325','2013-08-03','17:30:00',2.09),('325','2013-08-03','17:35:00',2.02),('325','2013-08-03','17:40:00',1.93),('325','2013-08-03','17:45:00',1.81),('325','2013-08-03','17:50:00',1.68),('325','2013-08-03','17:55:00',1.63),('325','2013-08-03','18:00:00',1.54),('325','2013-08-03','18:05:00',1.45),('325','2013-08-03','18:10:00',1.36),('325','2013-08-03','18:15:00',1.27),('325','2013-08-03','18:20:00',1.2),('325','2013-08-03','18:25:00',1.11),('325','2013-08-03','18:30:00',1.03),('325','2013-08-02','08:40:00',1.03),('325','2013-08-02','08:45:00',1.08),('325','2013-08-02','08:50:00',1.14),('325','2013-08-02','08:55:00',1.19),('325','2013-08-02','09:00:00',1.23),('325','2013-08-02','09:05:00',1.23),('325','2013-08-02','09:10:00',1.25),('325','2013-08-02','09:15:00',1.26),('325','2013-08-02','09:20:00',1.76),('325','2013-08-02','09:25:00',2.18),('325','2013-08-02','09:30:00',2.35),('325','2013-08-02','09:35:00',2.47),('325','2013-08-02','09:40:00',2.54),('325','2013-08-02','09:45:00',2.58),('325','2013-08-02','09:50:00',2.66),('325','2013-08-02','09:55:00',2.7),('325','2013-08-02','10:00:00',2.83),('325','2013-08-02','10:05:00',2.89),('325','2013-08-02','10:10:00',2.92),('325','2013-08-02','10:15:00',3.01),('325','2013-08-02','10:20:00',3.09),('325','2013-08-02','10:25:00',3.11),('325','2013-08-02','10:30:00',3.13),('325','2013-08-02','10:35:00',3.16),('325','2013-08-02','10:40:00',3.21),('325','2013-08-02','10:45:00',3.22),('325','2013-08-02','10:50:00',3.27),('325','2013-08-02','10:55:00',3.28),('325','2013-08-02','11:00:00',3.35),('325','2013-08-02','11:05:00',3.45),('325','2013-08-02','11:10:00',3.56),('325','2013-08-02','11:15:00',3.65),('325','2013-08-02','11:20:00',3.67),('325','2013-08-02','11:25:00',3.67),('325','2013-08-02','11:30:00',3.68),('325','2013-08-02','11:35:00',3.68),('325','2013-08-02','11:40:00',3.71),('325','2013-08-02','11:45:00',3.75),('325','2013-08-02','11:50:00',3.83),('325','2013-08-02','11:55:00',3.95),('325','2013-08-02','12:00:00',4),('325','2013-08-02','12:05:00',4.09),('325','2013-08-02','12:10:00',4.15),('325','2013-08-02','12:15:00',4.12),('325','2013-08-02','12:20:00',4.08),('325','2013-08-02','12:25:00',4.06),('325','2013-08-02','12:30:00',4.03),('325','2013-08-02','12:35:00',4.02),('325','2013-08-02','12:40:00',4.03),('325','2013-08-02','12:45:00',3.99),('325','2013-08-02','12:50:00',4),('325','2013-08-02','12:55:00',4.11),('325','2013-08-02','13:00:00',4.13),('325','2013-08-02','13:05:00',4.18),('325','2013-08-02','13:10:00',4.16),('325','2013-08-02','13:15:00',4.15),('325','2013-08-02','13:20:00',4.08),('325','2013-08-02','13:25:00',4.03),('325','2013-08-02','13:30:00',3.97),('325','2013-08-02','13:35:00',3.92),('325','2013-08-02','13:40:00',3.96),('325','2013-08-02','13:45:00',3.95),('325','2013-08-02','13:50:00',4),('325','2013-08-02','13:55:00',4.04),('325','2013-08-02','14:00:00',4.04),('325','2013-08-02','14:05:00',4.03),('325','2013-08-02','14:10:00',3.96),('325','2013-08-02','14:15:00',3.82),('325','2013-08-02','14:20:00',3.73),('325','2013-08-02','14:25:00',3.82),('325','2013-08-02','14:30:00',3.99),('325','2013-08-02','14:35:00',4.09),('325','2013-08-02','14:40:00',4.1),('325','2013-08-02','14:45:00',4.08),('325','2013-08-02','14:50:00',4.05),('325','2013-08-02','14:55:00',4.02),('325','2013-08-02','15:00:00',3.98),('325','2013-08-02','15:05:00',3.95),('325','2013-08-02','15:10:00',3.87),('325','2013-08-02','15:15:00',3.84),('325','2013-08-02','15:20:00',3.84),('325','2013-08-02','15:25:00',3.83),('325','2013-08-02','15:30:00',3.76),('325','2013-08-02','15:35:00',3.72),('325','2013-08-02','15:40:00',3.67),('325','2013-08-02','15:45:00',3.63),('325','2013-08-02','15:50:00',3.58),('325','2013-08-02','15:55:00',3.55),('325','2013-08-02','16:00:00',3.52),('325','2013-08-02','16:05:00',3.44),('325','2013-08-02','16:10:00',3.37),('325','2013-08-02','16:15:00',3.34),('325','2013-08-02','16:20:00',3.28),('325','2013-08-02','16:25:00',3.2),('325','2013-08-02','16:30:00',3.14),('325','2013-08-02','16:35:00',3.08),('325','2013-08-02','16:40:00',3),('325','2013-08-02','16:45:00',2.92),('325','2013-08-02','16:50:00',2.84),('325','2013-08-02','16:55:00',2.76),('325','2013-08-02','17:00:00',2.65),('325','2013-08-02','17:05:00',2.51),('325','2013-08-02','17:10:00',2.48),('325','2013-08-02','17:15:00',2.43),('325','2013-08-02','17:20:00',2.35),('325','2013-08-02','17:25:00',2.26),('325','2013-08-02','17:30:00',2.16),('325','2013-08-02','17:35:00',2.09),('325','2013-08-02','17:40:00',2),('325','2013-08-02','17:45:00',1.88),('325','2013-08-02','17:50:00',1.73),('325','2013-08-02','17:55:00',1.68),('325','2013-08-02','18:00:00',1.59),('325','2013-08-02','18:05:00',1.51),('325','2013-08-02','18:10:00',1.42),('325','2013-08-02','18:15:00',1.33),('325','2013-08-02','18:20:00',1.24),('325','2013-08-02','18:25:00',1.15),('325','2013-08-02','18:30:00',1.06),('325','2013-08-01','08:40:00',1.05),('325','2013-08-01','08:45:00',1.1),('325','2013-08-01','08:50:00',1.16),('325','2013-08-01','08:55:00',1.22),('325','2013-08-01','09:00:00',1.25),('325','2013-08-01','09:05:00',1.25),('325','2013-08-01','09:10:00',1.27),('325','2013-08-01','09:15:00',1.35),('325','2013-08-01','09:20:00',1.7),('325','2013-08-01','09:25:00',2.31),('325','2013-08-01','09:30:00',2.42),('325','2013-08-01','09:35:00',2.53),('325','2013-08-01','09:40:00',2.6),('325','2013-08-01','09:45:00',2.67),('325','2013-08-01','09:50:00',2.75),('325','2013-08-01','09:55:00',2.79),('325','2013-08-01','10:00:00',2.94),('325','2013-08-01','10:05:00',2.99),('325','2013-08-01','10:10:00',3.04),('325','2013-08-01','10:15:00',3.11),('325','2013-08-01','10:20:00',3.27),('325','2013-08-01','10:25:00',3.42),('325','2013-08-01','10:30:00',3.47),('325','2013-08-01','10:35:00',3.52),('325','2013-08-01','10:40:00',3.57),('325','2013-08-01','10:45:00',3.62),('325','2013-08-01','10:50:00',3.71),('325','2013-08-01','10:55:00',3.79),('325','2013-08-01','11:00:00',3.85),('325','2013-08-01','11:05:00',3.91),('325','2013-08-01','11:10:00',3.95),('325','2013-08-01','11:15:00',3.99),('325','2013-08-01','11:20:00',4.02),('325','2013-08-01','11:25:00',4.06),('325','2013-08-01','11:30:00',4.08),('325','2013-08-01','11:35:00',4.11),('325','2013-08-01','11:40:00',4.14),('325','2013-08-01','11:45:00',4.18),('325','2013-08-01','11:50:00',4.23),('325','2013-08-01','11:55:00',4.29),('325','2013-08-01','12:00:00',4.3),('325','2013-08-01','12:05:00',4.32),('325','2013-08-01','12:10:00',4.33),('325','2013-08-01','12:15:00',4.33),('325','2013-08-01','12:20:00',4.36),('325','2013-08-01','12:25:00',4.38),('325','2013-08-01','12:30:00',4.4),('325','2013-08-01','12:35:00',4.41),('325','2013-08-01','12:40:00',4.4),('325','2013-08-01','12:45:00',4.4),('325','2013-08-01','12:50:00',4.42),('325','2013-08-01','12:55:00',4.37),('325','2013-08-01','13:00:00',4.43),('325','2013-08-01','13:05:00',4.4),('325','2013-08-01','13:10:00',4.43),('325','2013-08-01','13:15:00',4.09),('325','2013-08-01','13:20:00',4.45),('325','2013-08-01','13:25:00',4.45),('325','2013-08-01','13:30:00',4.36),('325','2013-08-01','13:35:00',4.2),('325','2013-08-01','13:40:00',4.43),('325','2013-08-01','13:45:00',4.41),('325','2013-08-01','13:50:00',4.46),('325','2013-08-01','13:55:00',4.1),('325','2013-08-01','14:00:00',4.23),('325','2013-08-01','14:05:00',4.29),('325','2013-08-01','14:10:00',4.28),('325','2013-08-01','14:15:00',4.23),('325','2013-08-01','14:20:00',4.19),('325','2013-08-01','14:25:00',4.21),('325','2013-08-01','14:30:00',4.18),('325','2013-08-01','14:35:00',3.8),('325','2013-08-01','14:40:00',4),('325','2013-08-01','14:45:00',4.16),('325','2013-08-01','14:50:00',3.05),('325','2013-08-01','14:55:00',4.11),('325','2013-08-01','15:00:00',4),('325','2013-08-01','15:05:00',4.01),('325','2013-08-01','15:10:00',4.03),('325','2013-08-01','15:15:00',3.65),('325','2013-08-01','15:20:00',3.94),('325','2013-08-01','15:25:00',3.89),('325','2013-08-01','15:30:00',3.77),('325','2013-08-01','15:35:00',3.66),('325','2013-08-01','15:40:00',2.94),('325','2013-08-01','15:45:00',3.67),('325','2013-08-01','15:50:00',3.62),('325','2013-08-01','15:55:00',3.61),('325','2013-08-01','16:00:00',3.58),('325','2013-08-01','16:05:00',3.57),('325','2013-08-01','16:10:00',3.47),('325','2013-08-01','16:15:00',3.36),('325','2013-08-01','16:20:00',3.32),('325','2013-08-01','16:25:00',3.27),('325','2013-08-01','16:30:00',3.18),('325','2013-08-01','16:35:00',3.12),('325','2013-08-01','16:40:00',3.04),('325','2013-08-01','16:45:00',2.96),('325','2013-08-01','16:50:00',2.88),('325','2013-08-01','16:55:00',2.81),('325','2013-08-01','17:00:00',2.69),('325','2013-08-01','17:05:00',2.56),('325','2013-08-01','17:10:00',2.5),('325','2013-08-01','17:15:00',2.45),('325','2013-08-01','17:20:00',2.37),('325','2013-08-01','17:25:00',2.28),('325','2013-08-01','17:30:00',2.21),('325','2013-08-01','17:35:00',2.12),('325','2013-08-01','17:40:00',2.03),('325','2013-08-01','17:45:00',1.91),('325','2013-08-01','17:50:00',1.78),('325','2013-08-01','17:55:00',1.74),('325','2013-08-01','18:00:00',1.65),('325','2013-08-01','18:05:00',1.55),('325','2013-08-01','18:10:00',1.46),('325','2013-08-01','18:15:00',1.37),('325','2013-08-01','18:20:00',1.29),('325','2013-08-01','18:25:00',1.19),('325','2013-08-01','18:30:00',1.1),('325','2013-07-31','08:40:00',1.05),('325','2013-07-31','08:45:00',1.1),('325','2013-07-31','08:50:00',1.17),('325','2013-07-31','08:55:00',1.22),('325','2013-07-31','09:00:00',1.24),('325','2013-07-31','09:05:00',1.25),('325','2013-07-31','09:10:00',1.31),('325','2013-07-31','09:15:00',1.35),('325','2013-07-31','09:20:00',1.39),('325','2013-07-31','09:25:00',2.31),('325','2013-07-31','09:30:00',2.43),('325','2013-07-31','09:35:00',2.56),('325','2013-07-31','09:40:00',2.63),('325','2013-07-31','09:45:00',2.68),('325','2013-07-31','09:50:00',2.77),('325','2013-07-31','09:55:00',2.81),('325','2013-07-31','10:00:00',2.92),('325','2013-07-31','10:05:00',3.02),('325','2013-07-31','10:10:00',3.07),('325','2013-07-31','10:15:00',3.14),('325','2013-07-31','10:20:00',3.26),('325','2013-07-31','10:25:00',3.4),('325','2013-07-31','10:30:00',3.45),('325','2013-07-31','10:35:00',3.49),('325','2013-07-31','10:40:00',3.59),('325','2013-07-31','10:45:00',3.65),('325','2013-07-31','10:50:00',3.74),('325','2013-07-31','10:55:00',3.82),('325','2013-07-31','11:00:00',3.9),('325','2013-07-31','11:05:00',3.94),('325','2013-07-31','11:10:00',3.98),('325','2013-07-31','11:15:00',4),('325','2013-07-31','11:20:00',4.03),('325','2013-07-31','11:25:00',4.08),('325','2013-07-31','11:30:00',4.1),('325','2013-07-31','11:35:00',4.13),('325','2013-07-31','11:40:00',4.15),('325','2013-07-31','11:45:00',4.17),('325','2013-07-31','11:50:00',4.24),('325','2013-07-31','11:55:00',4.32),('325','2013-07-31','12:00:00',4.3),('325','2013-07-31','12:05:00',4.31),('325','2013-07-31','12:10:00',4.37),('325','2013-07-31','12:15:00',4.42),('325','2013-07-31','12:20:00',4.39),('325','2013-07-31','12:25:00',4.46),('325','2013-07-31','12:30:00',4.45),('325','2013-07-31','12:35:00',4.42),('325','2013-07-31','12:40:00',4.5),('325','2013-07-31','12:45:00',3.47),('325','2013-07-31','12:50:00',1.99),('325','2013-07-31','12:55:00',4.12),('325','2013-07-31','13:00:00',1.83),('325','2013-07-31','13:05:00',3.97),('325','2013-07-31','13:10:00',3.3),('325','2013-07-31','13:15:00',4.65),('325','2013-07-31','13:20:00',4.6),('325','2013-07-31','13:25:00',3.85),('325','2013-07-31','13:30:00',4.29),('325','2013-07-31','13:35:00',4.53),('325','2013-07-31','13:40:00',4.5),('325','2013-07-31','13:45:00',4.57),('325','2013-07-31','13:50:00',4.58),('325','2013-07-31','13:55:00',2.9),('325','2013-07-31','14:00:00',3.11),('325','2013-07-31','14:05:00',4.46),('325','2013-07-31','14:10:00',4.32),('325','2013-07-31','14:15:00',2.97),('325','2013-07-31','14:20:00',3.62),('325','2013-07-31','14:25:00',2.71),('325','2013-07-31','14:30:00',4.43),('325','2013-07-31','14:35:00',4.28),('325','2013-07-31','14:40:00',4.1),('325','2013-07-31','14:45:00',4.19),('325','2013-07-31','14:50:00',4.39),('325','2013-07-31','14:55:00',3.08),('325','2013-07-31','15:00:00',1.28),('325','2013-07-31','15:05:00',4.03),('325','2013-07-31','15:10:00',4.13),('325','2013-07-31','15:15:00',3.43),('325','2013-07-31','15:20:00',3.9),('325','2013-07-31','15:25:00',4.05),('325','2013-07-31','15:30:00',3.89),('325','2013-07-31','15:35:00',3.9),('325','2013-07-31','15:40:00',3.87),('325','2013-07-31','15:45:00',3.73),('325','2013-07-31','15:50:00',3.65),('325','2013-07-31','15:55:00',3.6),('325','2013-07-31','16:00:00',3.51),('325','2013-07-31','16:05:00',3.54),('325','2013-07-31','16:10:00',3.51),('325','2013-07-31','16:15:00',3.43),('325','2013-07-31','16:20:00',3.44),('325','2013-07-31','16:25:00',3.46),('325','2013-07-31','16:30:00',3.37),('325','2013-07-31','16:35:00',3.19),('325','2013-07-31','16:40:00',3.05),('325','2013-07-31','16:45:00',2.94),('325','2013-07-31','16:50:00',2.91),('325','2013-07-31','16:55:00',2.83),('325','2013-07-31','17:00:00',2.65),('325','2013-07-31','17:05:00',2.55),('325','2013-07-31','17:10:00',2.36),('325','2013-07-31','17:15:00',2.54),('325','2013-07-31','17:20:00',1.56),('325','2013-07-31','17:25:00',2.3),('325','2013-07-31','17:30:00',2.18),('325','2013-07-31','17:35:00',2.07),('325','2013-07-31','17:40:00',1.97),('325','2013-07-31','17:45:00',1.92),('325','2013-07-31','17:50:00',1.77),('325','2013-07-31','17:55:00',1.73),('325','2013-07-31','18:00:00',1.65),('325','2013-07-31','18:05:00',1.54),('325','2013-07-31','18:10:00',1.45),('325','2013-07-31','18:15:00',1.38),('325','2013-07-31','18:20:00',1.3),('325','2013-07-31','18:25:00',1.22),('325','2013-07-31','18:30:00',1.13),('325','2013-07-31','18:35:00',1.02),('325','2013-07-30','08:20:00',1.08),('325','2013-07-30','08:35:00',1.04),('325','2013-07-30','08:40:00',1.05),('325','2013-07-30','08:45:00',1.1),('325','2013-07-30','08:50:00',1.15),('325','2013-07-30','08:55:00',1.21),('325','2013-07-30','09:00:00',1.22),('325','2013-07-30','09:05:00',1.28),('325','2013-07-30','09:10:00',1.34),('325','2013-07-30','09:15:00',1.44),('325','2013-07-30','09:20:00',1.44),('325','2013-07-30','09:25:00',1.4),('325','2013-07-30','09:30:00',2),('325','2013-07-30','09:35:00',2.19),('325','2013-07-30','09:55:00',1.89),('325','2013-07-30','10:00:00',3.05),('325','2013-07-30','10:05:00',3.21),('325','2013-07-30','10:10:00',3.18),('325','2013-07-30','10:15:00',3.19),('325','2013-07-30','10:20:00',3.3),('325','2013-07-30','10:25:00',3.43),('325','2013-07-30','10:30:00',3.47),('325','2013-07-30','10:35:00',3.42),('325','2013-07-30','10:40:00',3.41),('325','2013-07-30','10:45:00',3.46),('325','2013-07-30','10:50:00',3.39),('325','2013-07-30','10:55:00',3.34),('325','2013-07-30','11:00:00',3.07),('325','2013-07-30','11:05:00',3.42),('325','2013-07-30','11:10:00',3.15),('325','2013-07-30','11:15:00',3.75),('325','2013-07-30','11:20:00',4.13),('325','2013-07-30','11:25:00',4.03),('325','2013-07-30','11:30:00',4.05),('325','2013-07-30','11:35:00',4.18),('325','2013-07-30','11:40:00',4.08),('325','2013-07-30','11:45:00',2.95),('325','2013-07-30','11:50:00',2.36),('325','2013-07-30','11:55:00',3.63),('325','2013-07-30','12:00:00',4.23),('325','2013-07-30','12:05:00',4.2),('325','2013-07-30','12:10:00',4.09),('325','2013-07-30','12:15:00',4.22),('325','2013-07-30','12:20:00',4.28),('325','2013-07-30','12:25:00',4.28),('325','2013-07-30','12:30:00',4.2),('325','2013-07-30','12:35:00',2.38),('325','2013-07-30','12:40:00',1.03),('325','2013-07-30','12:45:00',3.79),('325','2013-07-30','12:50:00',4.19),('325','2013-07-30','12:55:00',3.43),('325','2013-07-30','13:00:00',3.31),('325','2013-07-30','13:05:00',1.55),('325','2013-07-30','13:10:00',2.7),('325','2013-07-30','13:15:00',3.18),('325','2013-07-30','13:20:00',4.65),('325','2013-07-30','13:25:00',4.53),('325','2013-07-30','13:30:00',4.39),('325','2013-07-30','13:35:00',4.27),('325','2013-07-30','13:40:00',4.36),('325','2013-07-30','13:45:00',4.35),('325','2013-07-30','13:50:00',4.36),('325','2013-07-30','13:55:00',4.53),('325','2013-07-30','14:00:00',4.44),('325','2013-07-30','14:05:00',3.68),('325','2013-07-30','14:10:00',4.48),('325','2013-07-30','14:15:00',4.2),('325','2013-07-30','14:20:00',4.07),('325','2013-07-30','14:25:00',4.22),('325','2013-07-30','14:30:00',4.3),('325','2013-07-30','14:35:00',4.31),('325','2013-07-30','14:40:00',4.15),('325','2013-07-30','14:45:00',4.17),('325','2013-07-30','14:50:00',4.14),('325','2013-07-30','14:55:00',4.03),('325','2013-07-30','15:00:00',4.1),('325','2013-07-30','15:05:00',3.95),('325','2013-07-30','15:10:00',3.85),('325','2013-07-30','15:15:00',3.82),('325','2013-07-30','15:20:00',3.82),('325','2013-07-30','15:25:00',3.85),('325','2013-07-30','15:30:00',3.8),('325','2013-07-30','15:35:00',3.73),('325','2013-07-30','15:40:00',3.69),('325','2013-07-30','15:45:00',3.63),('325','2013-07-30','15:50:00',3.58),('325','2013-07-30','15:55:00',3.54),('325','2013-07-30','16:00:00',3.53),('325','2013-07-30','16:05:00',3.44),('325','2013-07-30','16:10:00',3.39),('325','2013-07-30','16:15:00',3.33),('325','2013-07-30','16:20:00',3.26),('325','2013-07-30','16:25:00',3.22),('325','2013-07-30','16:30:00',3.11),('325','2013-07-30','16:35:00',3.06),('325','2013-07-30','16:40:00',3.01),('325','2013-07-30','16:45:00',2.95),('325','2013-07-30','16:50:00',2.86),('325','2013-07-30','16:55:00',2.78),('325','2013-07-30','17:00:00',2.68),('325','2013-07-30','17:05:00',2.57),('325','2013-07-30','17:10:00',2.49),('325','2013-07-30','17:15:00',2.4),('325','2013-07-30','17:20:00',2.34),('325','2013-07-30','17:25:00',2.28),('325','2013-07-30','17:30:00',2.19),('325','2013-07-30','17:35:00',2.08),('325','2013-07-30','17:40:00',2),('325','2013-07-30','17:45:00',1.91),('325','2013-07-30','17:50:00',1.79),('325','2013-07-30','17:55:00',1.68),('325','2013-07-30','18:00:00',1.59),('325','2013-07-30','18:05:00',1.51),('325','2013-07-30','18:10:00',1.42),('325','2013-07-30','18:15:00',1.34),('325','2013-07-30','18:20:00',1.26),('325','2013-07-30','18:25:00',1.19),('325','2013-07-30','18:30:00',1.09),('325','2014-04-07','08:30:00',1.06),('325','2014-04-07','08:35:00',1.3),('325','2014-04-07','08:40:00',1.37),('325','2014-04-07','08:45:00',1.28),('325','2014-04-07','08:50:00',1.24),('325','2014-04-07','08:55:00',1.17),('325','2014-04-07','09:00:00',1.13),('325','2014-04-07','09:05:00',1.15),('325','2014-04-07','09:10:00',1.33),('325','2014-04-07','09:15:00',1.41),('325','2014-04-07','09:20:00',1.22),('325','2014-04-07','09:25:00',1.18),('325','2014-04-07','09:30:00',1.17),('325','2014-04-07','09:35:00',1.15),('325','2014-04-07','09:40:00',1.19),('325','2014-04-07','09:45:00',1.25),('325','2014-04-07','09:50:00',1.32),('325','2014-04-07','09:55:00',1.37),('325','2014-04-07','10:00:00',1.38),('325','2014-04-07','10:05:00',1.39),('325','2014-04-07','10:10:00',1.39),('325','2014-04-07','10:15:00',1.32),('325','2014-04-07','10:20:00',1.32),('325','2014-04-07','10:25:00',1.36),('325','2014-04-07','10:30:00',1.38),('325','2014-04-07','10:35:00',1.47),('325','2014-04-07','10:40:00',1.49),('325','2014-04-07','10:45:00',1.54),('325','2014-04-07','10:50:00',1.62),('325','2014-04-07','10:55:00',1.77),('325','2014-04-07','11:00:00',1.92),('325','2014-04-07','11:05:00',1.95),('325','2014-04-07','11:10:00',2.2),('325','2014-04-07','11:15:00',2.32),('325','2014-04-07','11:20:00',2.34),('325','2014-04-07','11:25:00',2.08),('325','2014-04-07','11:30:00',2.04),('325','2014-04-07','11:35:00',2.05),('325','2014-04-07','11:40:00',2.01),('325','2014-04-07','11:45:00',1.9),('325','2014-04-07','11:50:00',1.81),('325','2014-04-07','11:55:00',1.77),('325','2014-04-07','12:00:00',2),('325','2014-04-07','12:05:00',2.53),('325','2014-04-07','12:10:00',2.7),('325','2014-04-07','12:15:00',3.59),('325','2014-04-07','12:20:00',4.19),('325','2014-04-07','12:25:00',3.83),('325','2014-04-07','12:30:00',2.61),('325','2014-04-07','12:35:00',2.35),('325','2014-04-07','12:40:00',2.98),('325','2014-04-07','12:45:00',4.39),('325','2014-04-07','12:50:00',4.43),('325','2014-04-07','12:55:00',4.34),('325','2014-04-07','13:00:00',4.37),('325','2014-04-07','13:05:00',4.36),('325','2014-04-07','13:10:00',4.32),('325','2014-04-07','13:15:00',4.3),('325','2014-04-07','13:20:00',4.29),('325','2014-04-07','13:25:00',4.29),('325','2014-04-07','13:30:00',4.28),('325','2014-04-07','13:35:00',4.24),('325','2014-04-07','13:40:00',4.23),('325','2014-04-07','13:45:00',4.23),('325','2014-04-07','13:50:00',4.26),('325','2014-04-07','13:55:00',4.23),('325','2014-04-07','14:00:00',4.23),('325','2014-04-07','14:05:00',4.22),('325','2014-04-07','14:10:00',4.18),('325','2014-04-07','14:15:00',4.1),('325','2014-04-07','14:20:00',4.11),('325','2014-04-07','14:25:00',4.19),('325','2014-04-07','14:30:00',4.17),('325','2014-04-07','14:35:00',4.04),('325','2014-04-07','14:40:00',4.02),('325','2014-04-07','14:45:00',4.01),('325','2014-04-07','14:50:00',3.96),('325','2014-04-07','14:55:00',3.97),('325','2014-04-07','15:00:00',3.88),('325','2014-04-07','15:05:00',3.91),('325','2014-04-07','15:10:00',3.84),('325','2014-04-07','15:15:00',3.93),('325','2014-04-07','15:20:00',4.09),('325','2014-04-07','15:25:00',4.07),('325','2014-04-07','15:30:00',3.77),('325','2014-04-07','15:35:00',3.76),('325','2014-04-07','15:40:00',3.71),('325','2014-04-07','15:45:00',3.75),('325','2014-04-07','15:50:00',3.91),('325','2014-04-07','15:55:00',3.88),('325','2014-04-07','16:00:00',3.06),('325','2014-04-07','16:05:00',2.4),('325','2014-04-07','16:10:00',3.23),('325','2014-04-07','16:15:00',3.2),('325','2014-04-07','16:20:00',2.97),('325','2014-04-07','16:25:00',2.86),('325','2014-04-07','16:30:00',2.69),('325','2014-04-07','16:35:00',1.45),('325','2014-04-07','16:40:00',1.45),('325','2014-04-07','16:45:00',1.78),('325','2014-04-07','16:50:00',2.54),('325','2014-04-07','16:55:00',2.66),('325','2014-04-07','17:00:00',2.7),('325','2014-04-07','17:05:00',2.57),('325','2014-04-07','17:10:00',1.7),('325','2014-04-07','17:15:00',2.13),('325','2014-04-07','17:20:00',1.65),('325','2014-04-07','17:25:00',1.07),('325','2014-04-07','17:45:00',1),('325','2014-04-07','17:55:00',1.19),('325','2014-04-07','18:00:00',1.07),('325','2013-07-29','08:40:00',1.03),('325','2013-07-29','08:45:00',1.06),('325','2013-07-29','08:50:00',1.13),('325','2013-07-29','08:55:00',1.15),('325','2013-07-29','09:00:00',1.19),('325','2013-07-29','09:05:00',1.26),('325','2013-07-29','09:10:00',1.33),('325','2013-07-29','09:15:00',1.38),('325','2013-07-29','09:20:00',1.4),('325','2013-07-29','09:25:00',1.44),('325','2013-07-29','09:30:00',1.52),('325','2013-07-29','09:35:00',2.15),('325','2013-07-29','09:40:00',2.28),('325','2013-07-29','09:45:00',2.36),('325','2013-07-29','09:50:00',2.47),('325','2013-07-29','09:55:00',2.55),('325','2013-07-29','10:00:00',2.63),('325','2013-07-29','10:05:00',2.68),('325','2013-07-29','10:10:00',2.74),('325','2013-07-29','10:15:00',2.78),('325','2013-07-29','10:20:00',2.81),('325','2013-07-29','10:25:00',2.86),('325','2013-07-29','10:30:00',2.99),('325','2013-07-29','10:35:00',3.04),('325','2013-07-29','10:40:00',3.14),('325','2013-07-29','10:45:00',3.18),('325','2013-07-29','10:50:00',3.24),('325','2013-07-29','10:55:00',3.27),('325','2013-07-29','11:00:00',3.31),('325','2013-07-29','11:05:00',3.4),('325','2013-07-29','11:10:00',3.44),('325','2013-07-29','11:15:00',3.5),('325','2013-07-29','11:20:00',3.62),('325','2013-07-29','11:25:00',3.73),('325','2013-07-29','11:30:00',3.73),('325','2013-07-29','11:35:00',3.76),('325','2013-07-29','11:40:00',3.77),('325','2013-07-29','11:45:00',3.78),('325','2013-07-29','11:50:00',3.82),('325','2013-07-29','11:55:00',3.89),('325','2013-07-29','12:00:00',3.99),('325','2013-07-29','12:05:00',4),('325','2013-07-29','12:10:00',4.06),('325','2013-07-29','12:15:00',4),('325','2013-07-29','12:20:00',4),('325','2013-07-29','12:25:00',4),('325','2013-07-29','12:30:00',3.97),('325','2013-07-29','12:35:00',3.95),('325','2013-07-29','12:40:00',3.94),('325','2013-07-29','12:45:00',3.94),('325','2013-07-29','12:50:00',3.92),('325','2013-07-29','12:55:00',3.98),('325','2013-07-29','13:00:00',4.09),('325','2013-07-29','13:05:00',4.06),('325','2013-07-29','13:10:00',4.13),('325','2013-07-29','13:15:00',4.13),('325','2013-07-29','13:20:00',4.14),('325','2013-07-29','13:25:00',4.12),('325','2013-07-29','13:30:00',4.07),('325','2013-07-29','13:35:00',4.01),('325','2013-07-29','13:40:00',4.04),('325','2013-07-29','13:45:00',4.25),('325','2013-07-29','13:50:00',4.27),('325','2013-07-29','13:55:00',4.22),('325','2013-07-29','14:00:00',4.15),('325','2013-07-29','14:05:00',4.12),('325','2013-07-29','14:10:00',4.04),('325','2013-07-29','14:15:00',3.97),('325','2013-07-29','14:20:00',4.12),('325','2013-07-29','14:25:00',4.12),('325','2013-07-29','14:30:00',4.1),('325','2013-07-29','14:35:00',4.09),('325','2013-07-29','14:40:00',4.06),('325','2013-07-29','14:45:00',4.01),('325','2013-07-29','14:50:00',4),('325','2013-07-29','14:55:00',3.98),('325','2013-07-29','15:00:00',3.94),('325','2013-07-29','15:05:00',3.92),('325','2013-07-29','15:10:00',3.9),('325','2013-07-29','15:15:00',3.83),('325','2013-07-29','15:20:00',3.79),('325','2013-07-29','15:25:00',3.78),('325','2013-07-29','15:30:00',3.74),('325','2013-07-29','15:35:00',3.71),('325','2013-07-29','15:40:00',3.76),('325','2013-07-29','15:45:00',3.74),('325','2013-07-29','15:50:00',2.91),('325','2013-07-29','15:55:00',2.02),('325','2013-07-29','16:00:00',1.96),('325','2013-07-29','16:05:00',3.13),('325','2013-07-29','16:10:00',3.27),('325','2013-07-29','16:15:00',2.59),('325','2013-07-29','16:20:00',2.58),('325','2013-07-29','16:25:00',2.84),('325','2013-07-29','16:30:00',3.26),('325','2013-07-29','16:35:00',2.71),('325','2013-07-29','16:40:00',2.84),('325','2013-07-29','16:45:00',3.19),('325','2013-07-29','16:50:00',2.69),('325','2013-07-29','16:55:00',2.05),('325','2013-07-29','17:00:00',1.46),('325','2013-07-29','17:05:00',2.23),('325','2013-07-29','17:10:00',1.33),('325','2013-07-29','17:15:00',1.31),('325','2013-07-29','17:20:00',2.38),('325','2013-07-29','17:25:00',2.08),('325','2013-07-29','17:30:00',1.38),('325','2013-07-29','17:40:00',1.24),('325','2013-07-29','17:45:00',1.89),('325','2013-07-29','17:50:00',1.76),('325','2013-07-29','17:55:00',1.61),('325','2013-07-29','18:00:00',1.1),('325','2013-07-29','18:10:00',1.4),('325','2013-07-29','18:15:00',1.11),('325','2013-07-29','18:20:00',1.24),('325','2013-07-29','18:25:00',1.22),('325','2013-07-29','18:30:00',1.12),('325','2013-07-28','08:40:00',1.06),('325','2013-07-28','08:45:00',1.11),('325','2013-07-28','08:50:00',1.18),('325','2013-07-28','08:55:00',1.21),('325','2013-07-28','09:00:00',1.24),('325','2013-07-28','09:05:00',1.26),('325','2013-07-28','09:10:00',1.28),('325','2013-07-28','09:15:00',1.32),('325','2013-07-28','09:20:00',1.35),('325','2013-07-28','09:25:00',1.39),('325','2013-07-28','09:30:00',1.45),('325','2013-07-28','09:35:00',2.2),('325','2013-07-28','09:40:00',2.28),('325','2013-07-28','09:45:00',2.36),('325','2013-07-28','09:50:00',2.44),('325','2013-07-28','09:55:00',2.54),('325','2013-07-28','10:00:00',2.64),('325','2013-07-28','10:05:00',2.7),('325','2013-07-28','10:10:00',2.75),('325','2013-07-28','10:15:00',2.8),('325','2013-07-28','10:20:00',2.8),('325','2013-07-28','10:25:00',2.82),('325','2013-07-28','10:30:00',2.92),('325','2013-07-28','10:35:00',3.05),('325','2013-07-28','10:40:00',3.14),('325','2013-07-28','10:45:00',3.17),('325','2013-07-28','10:50:00',3.21),('325','2013-07-28','10:55:00',3.22),('325','2013-07-28','11:00:00',3.31),('325','2013-07-28','11:05:00',3.36),('325','2013-07-28','11:10:00',3.42),('325','2013-07-28','11:15:00',3.52),('325','2013-07-28','11:20:00',3.56),('325','2013-07-28','11:25:00',3.55),('325','2013-07-28','11:30:00',3.58),('325','2013-07-28','11:35:00',3.61),('325','2013-07-28','11:40:00',3.6),('325','2013-07-28','11:45:00',3.59),('325','2013-07-28','11:50:00',3.69),('325','2013-07-28','11:55:00',3.77),('325','2013-07-28','12:00:00',3.81),('325','2013-07-28','12:05:00',3.84),('325','2013-07-28','12:10:00',3.87),('325','2013-07-28','12:15:00',3.95),('325','2013-07-28','12:20:00',3.94),('325','2013-07-28','12:25:00',3.97),('325','2013-07-28','12:30:00',4.01),('325','2013-07-28','12:35:00',3.96),('325','2013-07-28','12:40:00',3.93),('325','2013-07-28','12:45:00',3.87),('325','2013-07-28','12:50:00',3.92),('325','2013-07-28','12:55:00',3.99),('325','2013-07-28','13:00:00',4.03),('325','2013-07-28','13:05:00',4.22),('325','2013-07-28','13:10:00',4.01),('325','2013-07-28','13:15:00',3.63),('325','2013-07-28','13:20:00',4.14),('325','2013-07-28','13:25:00',4.05),('325','2013-07-28','13:30:00',4.01),('325','2013-07-28','13:35:00',3.98),('325','2013-07-28','13:40:00',4.01),('325','2013-07-28','13:45:00',4.06),('325','2013-07-28','13:50:00',3.98),('325','2013-07-28','13:55:00',3.97),('325','2013-07-28','14:00:00',4.02),('325','2013-07-28','14:05:00',4.05),('325','2013-07-28','14:10:00',4),('325','2013-07-28','14:15:00',3.87),('325','2013-07-28','14:20:00',3.79),('325','2013-07-28','14:25:00',3.78),('325','2013-07-28','14:30:00',3.73),('325','2013-07-28','14:35:00',3.74),('325','2013-07-28','14:40:00',3.99),('325','2013-07-28','14:45:00',3.95),('325','2013-07-28','14:50:00',3.98),('325','2013-07-28','14:55:00',3.92),('325','2013-07-28','15:00:00',3.9),('325','2013-07-28','15:05:00',3.85),('325','2013-07-28','15:10:00',3.83),('325','2013-07-28','15:15:00',3.75),('325','2013-07-28','15:20:00',3.71),('325','2013-07-28','15:25:00',3.7),('325','2013-07-28','15:30:00',3.65),('325','2013-07-28','15:35:00',3.61),('325','2013-07-28','15:40:00',3.56),('325','2013-07-28','15:45:00',3.56),('325','2013-07-28','15:50:00',3.51),('325','2013-07-28','15:55:00',3.49),('325','2013-07-28','16:00:00',3.44),('325','2013-07-28','16:05:00',3.43),('325','2013-07-28','16:10:00',3.38),('325','2013-07-28','16:15:00',3.35),('325','2013-07-28','16:20:00',3.28),('325','2013-07-28','16:25:00',3.23),('325','2013-07-28','16:30:00',3.16),('325','2013-07-28','16:35:00',3.09),('325','2013-07-28','16:40:00',3.02),('325','2013-07-28','16:45:00',2.96),('325','2013-07-28','16:50:00',2.89),('325','2013-07-28','16:55:00',2.81),('325','2013-07-28','17:00:00',2.71),('325','2013-07-28','17:05:00',2.58),('325','2013-07-28','17:10:00',2.5),('325','2013-07-28','17:15:00',2.47),('325','2013-07-28','17:20:00',2.38),('325','2013-07-28','17:25:00',2.29),('325','2013-07-28','17:30:00',2.2),('325','2013-07-28','17:35:00',2.12),('325','2013-07-28','17:40:00',2.05),('325','2013-07-28','17:45:00',1.95),('325','2013-07-28','17:50:00',1.8),('325','2013-07-28','17:55:00',1.72),('325','2013-07-28','18:00:00',1.65),('325','2013-07-28','18:05:00',1.56),('325','2013-07-28','18:10:00',1.46),('325','2013-07-28','18:15:00',1.38),('325','2013-07-28','18:20:00',1.3),('325','2013-07-28','18:25:00',1.22),('325','2013-07-28','18:30:00',1.12),('325','2013-07-28','18:35:00',1),('325','2013-07-27','08:40:00',1.03),('325','2013-07-27','08:45:00',1.08),('325','2013-07-27','08:50:00',1.12),('325','2013-07-27','08:55:00',1.15),('325','2013-07-27','09:00:00',1.18),('325','2013-07-27','09:05:00',1.24),('325','2013-07-27','09:10:00',1.31),('325','2013-07-27','09:15:00',1.35),('325','2013-07-27','09:20:00',1.38),('325','2013-07-27','09:25:00',1.4),('325','2013-07-27','09:30:00',1.43),('325','2013-07-27','09:35:00',2.06),('325','2013-07-27','09:40:00',2.37),('325','2013-07-27','09:45:00',2.42),('325','2013-07-27','09:50:00',2.49),('325','2013-07-27','09:55:00',2.6),('325','2013-07-27','10:00:00',2.71),('325','2013-07-27','10:05:00',2.78),('325','2013-07-27','10:10:00',2.83),('325','2013-07-27','10:15:00',2.89),('325','2013-07-27','10:20:00',2.87),('325','2013-07-27','10:25:00',2.89),('325','2013-07-27','10:30:00',2.93),('325','2013-07-27','10:35:00',3.05),('325','2013-07-27','10:40:00',3.15),('325','2013-07-27','10:45:00',3.24),('325','2013-07-27','10:50:00',3.25),('325','2013-07-27','10:55:00',3.3),('325','2013-07-27','11:00:00',3.35),('325','2013-07-27','11:05:00',3.43),('325','2013-07-27','11:10:00',3.54),('325','2013-07-27','11:15:00',3.65),('325','2013-07-27','11:20:00',3.7),('325','2013-07-27','11:25:00',3.7),('325','2013-07-27','11:30:00',3.67),('325','2013-07-27','11:35:00',3.67),('325','2013-07-27','11:40:00',3.65),('325','2013-07-27','11:45:00',3.68),('325','2013-07-27','11:50:00',3.75),('325','2013-07-27','11:55:00',3.83),('325','2013-07-27','12:00:00',3.9),('325','2013-07-27','12:05:00',4.01),('325','2013-07-27','12:10:00',3.99),('325','2013-07-27','12:15:00',4.03),('325','2013-07-27','12:20:00',3.97),('325','2013-07-27','12:25:00',4.02),('325','2013-07-27','12:30:00',3.92),('325','2013-07-27','12:35:00',3.98),('325','2013-07-27','12:40:00',3.93),('325','2013-07-27','12:45:00',4),('325','2013-07-27','12:50:00',4.01),('325','2013-07-27','12:55:00',4.1),('325','2013-07-27','13:00:00',3.36),('325','2013-07-27','13:05:00',1.06),('325','2013-07-27','13:10:00',2.59),('325','2013-07-27','13:15:00',4.29),('325','2013-07-27','13:20:00',4.18),('325','2013-07-27','13:25:00',4.11),('325','2013-07-27','13:30:00',4.06),('325','2013-07-27','13:35:00',3.99),('325','2013-07-27','13:40:00',4.06),('325','2013-07-27','13:45:00',4.06),('325','2013-07-27','13:50:00',4.03),('325','2013-07-27','13:55:00',4.06),('325','2013-07-27','14:00:00',4.04),('325','2013-07-27','14:05:00',4.18),('325','2013-07-27','14:10:00',4.17),('325','2013-07-27','14:15:00',3.96),('325','2013-07-27','14:20:00',3.85),('325','2013-07-27','14:25:00',3.86),('325','2013-07-27','14:30:00',3.81),('325','2013-07-27','14:35:00',3.79),('325','2013-07-27','14:40:00',3.76),('325','2013-07-27','14:45:00',3.77),('325','2013-07-27','14:50:00',3.79),('325','2013-07-27','14:55:00',3.75),('325','2013-07-27','15:00:00',3.72),('325','2013-07-27','15:05:00',3.74),('325','2013-07-27','15:10:00',3.69),('325','2013-07-27','15:15:00',3.72),('325','2013-07-27','15:20:00',3.71),('325','2013-07-27','15:25:00',3.78),('325','2013-07-27','15:30:00',3.76),('325','2013-07-27','15:35:00',3.72),('325','2013-07-27','15:40:00',3.67),('325','2013-07-27','15:45:00',3.65),('325','2013-07-27','15:50:00',3.59),('325','2013-07-27','15:55:00',3.54),('325','2013-07-27','16:00:00',3.48),('325','2013-07-27','16:05:00',3.43),('325','2013-07-27','16:10:00',3.38),('325','2013-07-27','16:15:00',3.32),('325','2013-07-27','16:20:00',3.27),('325','2013-07-27','16:25:00',3.23),('325','2013-07-27','16:30:00',3.18),('325','2013-07-27','16:35:00',3.11),('325','2013-07-27','16:40:00',3.06),('325','2013-07-27','16:45:00',2.97),('325','2013-07-27','16:50:00',2.89),('325','2013-07-27','16:55:00',2.8),('325','2013-07-27','17:00:00',2.69),('325','2013-07-27','17:05:00',2.6),('325','2013-07-27','17:10:00',2.53),('325','2013-07-27','17:15:00',2.47),('325','2013-07-27','17:20:00',2.38),('325','2013-07-27','17:25:00',2.29),('325','2013-07-27','17:30:00',2.2),('325','2013-07-27','17:35:00',2.12),('325','2013-07-27','17:40:00',2.03),('325','2013-07-27','17:45:00',1.95),('325','2013-07-27','17:50:00',1.82),('325','2013-07-27','17:55:00',1.72),('325','2013-07-27','18:00:00',1.67),('325','2013-07-27','18:05:00',1.58),('325','2013-07-27','18:10:00',1.5),('325','2013-07-27','18:15:00',1.4),('325','2013-07-27','18:20:00',1.31),('325','2013-07-27','18:25:00',1.23),('325','2013-07-27','18:30:00',1.15),('325','2013-07-27','18:35:00',1.03),('325','2013-07-26','08:35:00',1.04),('325','2013-07-26','08:40:00',1.07),('325','2013-07-26','08:45:00',1.12),('325','2013-07-26','08:50:00',1.18),('325','2013-07-26','08:55:00',1.21),('325','2013-07-26','09:00:00',1.21),('325','2013-07-26','09:05:00',1.24),('325','2013-07-26','09:10:00',1.32),('325','2013-07-26','09:15:00',1.39),('325','2013-07-26','09:20:00',1.4),('325','2013-07-26','09:25:00',1.46),('325','2013-07-26','09:30:00',1.51),('325','2013-07-26','09:35:00',1.73),('325','2013-07-26','09:40:00',2.21),('325','2013-07-26','09:45:00',2.32),('325','2013-07-26','09:50:00',2.4),('325','2013-07-26','09:55:00',2.53),('325','2013-07-26','10:00:00',2.66),('325','2013-07-26','10:05:00',2.74),('325','2013-07-26','10:10:00',2.75),('325','2013-07-26','10:15:00',2.83),('325','2013-07-26','10:20:00',2.89),('325','2013-07-26','10:25:00',2.95),('325','2013-07-26','10:30:00',2.99),('325','2013-07-26','10:35:00',3.08),('325','2013-07-26','10:40:00',3.19),('325','2013-07-26','10:45:00',3.23),('325','2013-07-26','10:50:00',3.25),('325','2013-07-26','10:55:00',3.28),('325','2013-07-26','11:00:00',3.29),('325','2013-07-26','11:05:00',3.5),('325','2013-07-26','11:10:00',3.55),('325','2013-07-26','11:15:00',3.63),('325','2013-07-26','11:20:00',3.75),('325','2013-07-26','11:25:00',3.69),('325','2013-07-26','11:30:00',3.69),('325','2013-07-26','11:35:00',3.72),('325','2013-07-26','11:40:00',3.71),('325','2013-07-26','11:45:00',3.7),('325','2013-07-26','11:50:00',3.83),('325','2013-07-26','11:55:00',2.99),('325','2013-07-26','12:00:00',1.88),('325','2013-07-26','12:05:00',3.2),('325','2013-07-26','12:10:00',4.32),('325','2013-07-26','12:15:00',4.25),('325','2013-07-26','12:20:00',4.29),('325','2013-07-26','12:25:00',4.27),('325','2013-07-26','12:30:00',4.25),('325','2013-07-26','12:35:00',4.19),('325','2013-07-26','12:40:00',4.23),('325','2013-07-26','12:45:00',4.25),('325','2013-07-26','12:50:00',2.61),('325','2013-07-26','12:55:00',1.67),('325','2013-07-26','13:00:00',1.91),('325','2013-07-26','13:05:00',1.48),('325','2013-07-26','13:10:00',2.23),('325','2013-07-26','13:15:00',1.77),('325','2013-07-26','13:20:00',1.47),('325','2013-07-26','13:25:00',1.41),('325','2013-07-26','13:30:00',4.35),('325','2013-07-26','13:35:00',4.56),('325','2013-07-26','13:40:00',4.38),('325','2013-07-26','13:45:00',4.51),('325','2013-07-26','13:50:00',4.38),('325','2013-07-26','13:55:00',4.39),('325','2013-07-26','14:00:00',3.58),('325','2013-07-26','14:05:00',3.12),('325','2013-07-26','14:10:00',4.33),('325','2013-07-26','14:15:00',4.15),('325','2013-07-26','14:20:00',3.99),('325','2013-07-26','14:25:00',3.98),('325','2013-07-26','14:30:00',3.97),('325','2013-07-26','14:35:00',3.93),('325','2013-07-26','14:40:00',3.82),('325','2013-07-26','14:45:00',3.86),('325','2013-07-26','14:50:00',3.83),('325','2013-07-26','14:55:00',3.83),('325','2013-07-26','15:00:00',3.83),('325','2013-07-26','15:05:00',3.78),('325','2013-07-26','15:10:00',3.78),('325','2013-07-26','15:15:00',3.8),('325','2013-07-26','15:20:00',3.74),('325','2013-07-26','15:25:00',3.69),('325','2013-07-26','15:30:00',3.68),('325','2013-07-26','15:35:00',3.66),('325','2013-07-26','15:40:00',3.7),('325','2013-07-26','15:45:00',3.67),('325','2013-07-26','15:50:00',3.6),('325','2013-07-26','15:55:00',3.57),('325','2013-07-26','16:00:00',3.5),('325','2013-07-26','16:05:00',3.47),('325','2013-07-26','16:10:00',3.41),('325','2013-07-26','16:15:00',3.38),('325','2013-07-26','16:20:00',3.31),('325','2013-07-26','16:25:00',3.28),('325','2013-07-26','16:30:00',3.2),('325','2013-07-26','16:35:00',3.11),('325','2013-07-26','16:40:00',3.05),('325','2013-07-26','16:45:00',2.98),('325','2013-07-26','16:50:00',2.9),('325','2013-07-26','16:55:00',2.8),('325','2013-07-26','17:00:00',2.73),('325','2013-07-26','17:05:00',2.59),('325','2013-07-26','17:10:00',2.54),('325','2013-07-26','17:15:00',2.45),('325','2013-07-26','17:20:00',2.36),('325','2013-07-26','17:25:00',2.29),('325','2013-07-26','17:30:00',2.19),('325','2013-07-26','17:35:00',2.1),('325','2013-07-26','17:40:00',2.02),('325','2013-07-26','17:45:00',1.92),('325','2013-07-26','17:50:00',1.77),('325','2013-07-26','17:55:00',1.62),('325','2013-07-26','18:00:00',1.57),('325','2013-07-26','18:05:00',1.52),('325','2013-07-26','18:10:00',1.43),('325','2013-07-26','18:15:00',1.31),('325','2013-07-26','18:20:00',1.25),('325','2013-07-26','18:25:00',1.2),('325','2013-07-26','18:30:00',1.1),('325','2013-07-25','08:35:00',1.03),('325','2013-07-25','08:40:00',1.07),('325','2013-07-25','08:45:00',1.14),('325','2013-07-25','08:50:00',1.18),('325','2013-07-25','08:55:00',1.24),('325','2013-07-25','09:00:00',1.25),('325','2013-07-25','09:05:00',1.28),('325','2013-07-25','09:10:00',1.41),('325','2013-07-25','09:15:00',1.58),('325','2013-07-25','09:20:00',1.48),('325','2013-07-25','09:25:00',1.46),('325','2013-07-25','09:30:00',1.72),('325','2013-07-25','09:35:00',1.36),('325','2013-07-25','09:40:00',1.11),('325','2013-07-25','09:45:00',1.03),('325','2013-07-25','09:55:00',1.25),('325','2013-07-25','10:00:00',2.61),('325','2013-07-25','10:05:00',2.79),('325','2013-07-25','10:10:00',2.86),('325','2013-07-25','10:15:00',2.83),('325','2013-07-25','10:20:00',2.42),('325','2013-07-25','10:25:00',1.73),('325','2013-07-25','10:30:00',1.34),('325','2013-07-25','10:35:00',2.45),('325','2013-07-25','10:40:00',3.26),('325','2013-07-25','10:45:00',3.64),('325','2013-07-25','10:50:00',3.65),('325','2013-07-25','10:55:00',3.67),('325','2013-07-25','11:00:00',3.81),('325','2013-07-25','11:05:00',3.79),('325','2013-07-25','11:10:00',3.9),('325','2013-07-25','11:15:00',3.88),('325','2013-07-25','11:20:00',3.85),('325','2013-07-25','11:25:00',3.9),('325','2013-07-25','11:30:00',3.99),('325','2013-07-25','11:35:00',2.67),('325','2013-07-25','11:40:00',3.29),('325','2013-07-25','11:45:00',3.42),('325','2013-07-25','11:50:00',4.29),('325','2013-07-25','11:55:00',3.8),('325','2013-07-25','12:00:00',4.31),('325','2013-07-25','12:05:00',1.68),('325','2013-07-25','12:10:00',3.48),('325','2013-07-25','12:15:00',2.44),('325','2013-07-25','12:20:00',4.62),('325','2013-07-25','12:25:00',3.7),('325','2013-07-25','12:30:00',4.42),('325','2013-07-25','12:35:00',3.95),('325','2013-07-25','12:40:00',3.06),('325','2013-07-25','12:45:00',2.62),('325','2013-07-25','12:50:00',4.6),('325','2013-07-25','12:55:00',4.59),('325','2013-07-25','13:00:00',4.37),('325','2013-07-25','13:05:00',4.58),('325','2013-07-25','13:10:00',4.59),('325','2013-07-25','13:15:00',4.43),('325','2013-07-25','13:20:00',4.36),('325','2013-07-25','13:25:00',4.19),('325','2013-07-25','13:30:00',4.2),('325','2013-07-25','13:35:00',4.18),('325','2013-07-25','13:40:00',4.39),('325','2013-07-25','13:45:00',4.44),('325','2013-07-25','13:50:00',4.43),('325','2013-07-25','13:55:00',4.41),('325','2013-07-25','14:00:00',4.34),('325','2013-07-25','14:05:00',4.32),('325','2013-07-25','14:10:00',4.29),('325','2013-07-25','14:15:00',4.28),('325','2013-07-25','14:20:00',4.29),('325','2013-07-25','14:25:00',4.29),('325','2013-07-25','14:30:00',4.33),('325','2013-07-25','14:35:00',4.29),('325','2013-07-25','14:40:00',4.28),('325','2013-07-25','14:45:00',4.26),('325','2013-07-25','14:50:00',4.24),('325','2013-07-25','14:55:00',4.21),('325','2013-07-25','15:00:00',4.2),('325','2013-07-25','15:05:00',4.15),('325','2013-07-25','15:10:00',4.09),('325','2013-07-25','15:15:00',4.05),('325','2013-07-25','15:20:00',4),('325','2013-07-25','15:25:00',3.94),('325','2013-07-25','15:30:00',3.91),('325','2013-07-25','15:35:00',3.88),('325','2013-07-25','15:40:00',3.84),('325','2013-07-25','15:45:00',3.81),('325','2013-07-25','15:50:00',3.73),('325','2013-07-25','15:55:00',3.68),('325','2013-07-25','16:00:00',3.64),('325','2013-07-25','16:05:00',3.61),('325','2013-07-25','16:10:00',3.57),('325','2013-07-25','16:15:00',3.52),('325','2013-07-25','16:20:00',3.45),('325','2013-07-25','16:25:00',3.35),('325','2013-07-25','16:30:00',3.28),('325','2013-07-25','16:35:00',3.24),('325','2013-07-25','16:40:00',3.17),('325','2013-07-25','16:45:00',3.1),('325','2013-07-25','16:50:00',3.03),('325','2013-07-25','16:55:00',2.95),('325','2013-07-25','17:00:00',2.87),('325','2013-07-25','17:05:00',2.72),('325','2013-07-25','17:10:00',2.61),('325','2013-07-25','17:15:00',2.58),('325','2013-07-25','17:20:00',2.49),('325','2013-07-25','17:25:00',2.43),('325','2013-07-25','17:30:00',2.34),('325','2013-07-25','17:35:00',2.25),('325','2013-07-25','17:40:00',2.16),('325','2013-07-25','17:45:00',2.05),('325','2013-07-25','17:50:00',1.93),('325','2013-07-25','17:55:00',1.84),('325','2013-07-25','18:00:00',1.76),('325','2013-07-25','18:05:00',1.66),('325','2013-07-25','18:10:00',1.56),('325','2013-07-25','18:15:00',1.45),('325','2013-07-25','18:20:00',1.37),('325','2013-07-25','18:25:00',1.2),('325','2013-07-25','18:30:00',1.17),('325','2013-07-25','18:35:00',1.04),('325','2013-07-24','08:15:00',1.09),('325','2013-07-24','08:25:00',1.07),('325','2013-07-24','08:45:00',1.19),('325','2013-07-24','08:50:00',1.32),('325','2013-07-24','08:55:00',1.28),('325','2013-07-24','09:00:00',1.18),('325','2013-07-24','09:05:00',1.24),('325','2013-07-24','09:10:00',1.82),('325','2013-07-24','09:15:00',1.44),('325','2013-07-24','09:20:00',1.48),('325','2013-07-24','09:25:00',1.46),('325','2013-07-24','09:30:00',1.78),('325','2013-07-24','09:35:00',1.54),('325','2013-07-24','09:40:00',1.25),('325','2013-07-24','09:45:00',1.43),('325','2013-07-24','09:50:00',1.29),('325','2013-07-24','09:55:00',1.11),('325','2013-07-24','10:10:00',1.5),('325','2013-07-24','10:15:00',2.93),('325','2013-07-24','10:20:00',3.24),('325','2013-07-24','10:25:00',3.36),('325','2013-07-24','10:30:00',3.38),('325','2013-07-24','10:35:00',3.42),('325','2013-07-24','10:40:00',2.41),('325','2013-07-24','10:45:00',2.22),('325','2013-07-24','10:50:00',1.41),('325','2013-07-24','10:55:00',1.4),('325','2013-07-24','11:00:00',2.42),('325','2013-07-24','11:05:00',3.65),('325','2013-07-24','11:10:00',4.01),('325','2013-07-24','11:15:00',4.05),('325','2013-07-24','11:20:00',2.96),('325','2013-07-24','11:25:00',4.08),('325','2013-07-24','11:30:00',4.14),('325','2013-07-24','11:35:00',3.98),('325','2013-07-24','11:40:00',4.04),('325','2013-07-24','11:45:00',4.12),('325','2013-07-24','11:50:00',3.88),('325','2013-07-24','11:55:00',4.1),('325','2013-07-24','12:00:00',4.04),('325','2013-07-24','12:05:00',2.56),('325','2013-07-24','12:10:00',4.75),('325','2013-07-24','12:15:00',3.59),('325','2013-07-24','12:20:00',1.52),('325','2013-07-24','12:25:00',1.92),('325','2013-07-24','12:30:00',2),('325','2013-07-24','12:35:00',1.33),('325','2013-07-24','12:40:00',3.19),('325','2013-07-24','12:45:00',3.62),('325','2013-07-24','12:50:00',3.6),('325','2013-07-24','12:55:00',4.57),('325','2013-07-24','13:00:00',2.88),('325','2013-07-24','13:05:00',4.55),('325','2013-07-24','13:10:00',3.64),('325','2013-07-24','13:15:00',4.18),('325','2013-07-24','13:20:00',2.21),('325','2013-07-24','13:25:00',3.95),('325','2013-07-24','13:30:00',4.47),('325','2013-07-24','13:35:00',3.1),('325','2013-07-24','13:40:00',4.73),('325','2013-07-24','13:45:00',4.64),('325','2013-07-24','13:50:00',4.44),('325','2013-07-24','13:55:00',3.78),('325','2013-07-24','14:00:00',4.56),('325','2013-07-24','14:05:00',4.56),('325','2013-07-24','14:10:00',4.45),('325','2013-07-24','14:15:00',4.33),('325','2013-07-24','14:20:00',4.5),('325','2013-07-24','14:25:00',4.51),('325','2013-07-24','14:30:00',3.8),('325','2013-07-24','14:35:00',4.56),('325','2013-07-24','14:40:00',4.38),('325','2013-07-24','14:45:00',4.39),('325','2013-07-24','14:50:00',4.34),('325','2013-07-24','14:55:00',4.26),('325','2013-07-24','15:00:00',4.23),('325','2013-07-24','15:05:00',4.17),('325','2013-07-24','15:10:00',4.11),('325','2013-07-24','15:15:00',4.11),('325','2013-07-24','15:20:00',4.09),('325','2013-07-24','15:25:00',4.06),('325','2013-07-24','15:30:00',3.85),('325','2013-07-24','15:35:00',3.78),('325','2013-07-24','15:40:00',3.9),('325','2013-07-24','15:45:00',3.77),('325','2013-07-24','15:50:00',3.67),('325','2013-07-24','15:55:00',3.68),('325','2013-07-24','16:00:00',3.65),('325','2013-07-24','16:05:00',3.58),('325','2013-07-24','16:10:00',3.53),('325','2013-07-24','16:15:00',3.54),('325','2013-07-24','16:20:00',3.53),('325','2013-07-24','16:25:00',3.51),('325','2013-07-24','16:30:00',3.42),('325','2013-07-24','16:35:00',3.38),('325','2013-07-24','16:40:00',3.3),('325','2013-07-24','16:45:00',3.19),('325','2013-07-24','16:50:00',3.17),('325','2013-07-24','16:55:00',3.19),('325','2013-07-24','17:00:00',3.07),('325','2013-07-24','17:05:00',2.94),('325','2013-07-24','17:10:00',2.63),('325','2013-07-24','17:15:00',2.69),('325','2013-07-24','17:20:00',2.57),('325','2013-07-24','17:25:00',2.46),('325','2013-07-24','17:30:00',2.37),('325','2013-07-24','17:35:00',2.22),('325','2013-07-24','17:40:00',2.15),('325','2013-07-24','17:45:00',2.04),('325','2013-07-24','17:50:00',1.94),('325','2013-07-24','17:55:00',1.79),('325','2013-07-24','18:00:00',1.7),('325','2013-07-24','18:05:00',1.62),('325','2013-07-24','18:10:00',1.47),('325','2013-07-24','18:15:00',1.4),('325','2013-07-24','18:20:00',1.33),('325','2013-07-24','18:25:00',1.27),('325','2013-07-24','18:30:00',1.17),('325','2013-07-24','18:35:00',1.05),('325','2013-07-23','08:40:00',1.03),('325','2013-07-23','08:45:00',1.16),('325','2013-07-23','08:50:00',1.24),('325','2013-07-23','08:55:00',1.29),('325','2013-07-23','09:00:00',1.3),('325','2013-07-23','09:05:00',1.29),('325','2013-07-23','09:10:00',1.32),('325','2013-07-23','09:15:00',1.35),('325','2013-07-23','09:20:00',1.38),('325','2013-07-23','09:25:00',1.4),('325','2013-07-23','09:30:00',1.42),('325','2013-07-23','09:35:00',1.79),('325','2013-07-23','09:40:00',2.48),('325','2013-07-23','09:45:00',2.54),('325','2013-07-23','09:50:00',2.58),('325','2013-07-23','09:55:00',2.68),('325','2013-07-23','10:00:00',2.73),('325','2013-07-23','10:05:00',2.81),('325','2013-07-23','10:10:00',2.85),('325','2013-07-23','10:15:00',2.88),('325','2013-07-23','10:20:00',2.97),('325','2013-07-23','10:25:00',3.07),('325','2013-07-23','10:30:00',3.14),('325','2013-07-23','10:35:00',3.2),('325','2013-07-23','10:40:00',3.26),('325','2013-07-23','10:45:00',3.36),('325','2013-07-23','10:50:00',3.4),('325','2013-07-23','10:55:00',3.44),('325','2013-07-23','11:00:00',3.46),('325','2013-07-23','11:05:00',3.53),('325','2013-07-23','11:10:00',3.64),('325','2013-07-23','11:15:00',3.78),('325','2013-07-23','11:20:00',3.88),('325','2013-07-23','11:25:00',3.85),('325','2013-07-23','11:30:00',3.81),('325','2013-07-23','11:35:00',3.82),('325','2013-07-23','11:40:00',3.9),('325','2013-07-23','11:45:00',3.89),('325','2013-07-23','11:50:00',3.95),('325','2013-07-23','11:55:00',4.08),('325','2013-07-23','12:00:00',4.12),('325','2013-07-23','12:05:00',4.25),('325','2013-07-23','12:10:00',4.32),('325','2013-07-23','12:15:00',4.38),('325','2013-07-23','12:20:00',4.35),('325','2013-07-23','12:25:00',4.28),('325','2013-07-23','12:30:00',3.14),('325','2013-07-23','12:35:00',1.05),('325','2013-07-23','12:45:00',3.09),('325','2013-07-23','12:50:00',2.18),('325','2013-07-23','12:55:00',3.34),('325','2013-07-23','13:00:00',1.09),('325','2013-07-23','13:30:00',2.64),('325','2013-07-23','13:35:00',4.29),('325','2013-07-23','13:40:00',2.39),('325','2013-07-23','13:55:00',1.3),('325','2013-07-23','14:00:00',4.12),('325','2013-07-23','14:05:00',4.6),('325','2013-07-23','14:10:00',1.52),('325','2013-07-23','14:25:00',1.73),('325','2013-07-23','14:30:00',2.63),('325','2013-07-23','14:35:00',3.6),('325','2013-07-23','14:40:00',1.84),('325','2013-07-23','14:45:00',3.39),('325','2013-07-23','14:50:00',2.22),('325','2013-07-23','14:55:00',3.5),('325','2013-07-23','15:00:00',4.76),('325','2013-07-23','15:05:00',4.36),('325','2013-07-23','15:10:00',4.22),('325','2013-07-23','15:15:00',4.22),('325','2013-07-23','15:20:00',4.05),('325','2013-07-23','15:25:00',4),('325','2013-07-23','15:30:00',3.9),('325','2013-07-23','15:35:00',3.94),('325','2013-07-23','15:40:00',3.75),('325','2013-07-23','15:45:00',3.7),('325','2013-07-23','15:50:00',3.67),('325','2013-07-23','15:55:00',3.64),('325','2013-07-23','16:00:00',3.59),('325','2013-07-23','16:05:00',3.57),('325','2013-07-23','16:10:00',3.49),('325','2013-07-23','16:15:00',3.42),('325','2013-07-23','16:20:00',3.37),('325','2013-07-23','16:25:00',3.32),('325','2013-07-23','16:30:00',3.25),('325','2013-07-23','16:35:00',3.18),('325','2013-07-23','16:40:00',3.1),('325','2013-07-23','16:45:00',3.03),('325','2013-07-23','16:50:00',2.97),('325','2013-07-23','16:55:00',2.91),('325','2013-07-23','17:00:00',2.82),('325','2013-07-23','17:05:00',2.7),('325','2013-07-23','17:10:00',2.58),('325','2013-07-23','17:15:00',2.57),('325','2013-07-23','17:20:00',2.49),('325','2013-07-23','17:25:00',2.4),('325','2013-07-23','17:30:00',2.32),('325','2013-07-23','17:35:00',2.26),('325','2013-07-23','17:40:00',2.17),('325','2013-07-23','17:45:00',2.07),('325','2013-07-23','17:50:00',1.96),('325','2013-07-23','17:55:00',1.83),('325','2013-07-23','18:00:00',1.79),('325','2013-07-23','18:05:00',1.69),('325','2013-07-23','18:10:00',1.6),('325','2013-07-23','18:15:00',1.51),('325','2013-07-23','18:20:00',1.43),('325','2013-07-23','18:25:00',1.32),('325','2013-07-23','18:30:00',1.22),('325','2013-07-23','18:35:00',1.05),('325','2013-07-22','08:35:00',1.03),('325','2013-07-22','08:40:00',1.08),('325','2013-07-22','08:45:00',1.2),('325','2013-07-22','08:50:00',1.27),('325','2013-07-22','08:55:00',1.31),('325','2013-07-22','09:00:00',1.32),('325','2013-07-22','09:05:00',1.32),('325','2013-07-22','09:10:00',1.36),('325','2013-07-22','09:15:00',1.4),('325','2013-07-22','09:20:00',1.41),('325','2013-07-22','09:25:00',1.44),('325','2013-07-22','09:30:00',1.47),('325','2013-07-22','09:35:00',1.51),('325','2013-07-22','09:40:00',2.32),('325','2013-07-22','09:45:00',2.51),('325','2013-07-22','09:50:00',2.59),('325','2013-07-22','09:55:00',2.7),('325','2013-07-22','10:00:00',2.77),('325','2013-07-22','10:05:00',2.86),('325','2013-07-22','10:10:00',2.91),('325','2013-07-22','10:15:00',2.97),('325','2013-07-22','10:20:00',2.98),('325','2013-07-22','10:25:00',2.99),('325','2013-07-22','10:30:00',3.01),('325','2013-07-22','10:35:00',3.08),('325','2013-07-22','10:40:00',3.16),('325','2013-07-22','10:45:00',3.34),('325','2013-07-22','10:50:00',3.4),('325','2013-07-22','10:55:00',3.41),('325','2013-07-22','11:00:00',3.44),('325','2013-07-22','11:05:00',3.51),('325','2013-07-22','11:10:00',3.78),('325','2013-07-22','11:15:00',3.83),('325','2013-07-22','11:20:00',3.89),('325','2013-07-22','11:25:00',3.92),('325','2013-07-22','11:30:00',3.93),('325','2013-07-22','11:35:00',3.96),('325','2013-07-22','11:40:00',3.99),('325','2013-07-22','11:45:00',4.01),('325','2013-07-22','11:50:00',4.05),('325','2013-07-22','11:55:00',4.08),('325','2013-07-22','12:00:00',4.16),('325','2013-07-22','12:05:00',4.19),('325','2013-07-22','12:10:00',4.18),('325','2013-07-22','12:15:00',4.23),('325','2013-07-22','12:20:00',4.22),('325','2013-07-22','12:25:00',4.16),('325','2013-07-22','12:30:00',4.12),('325','2013-07-22','12:35:00',4.1),('325','2013-07-22','12:40:00',4.08),('325','2013-07-22','12:45:00',4.05),('325','2013-07-22','12:50:00',4.06),('325','2013-07-22','12:55:00',4.14),('325','2013-07-22','13:00:00',4.23),('325','2013-07-22','13:05:00',4.28),('325','2013-07-22','13:10:00',4.27),('325','2013-07-22','13:15:00',4.23),('325','2013-07-22','13:20:00',4.19),('325','2013-07-22','13:25:00',4.18),('325','2013-07-22','13:30:00',4.08),('325','2013-07-22','13:35:00',4.02),('325','2013-07-22','13:40:00',4.02),('325','2013-07-22','13:45:00',4.06),('325','2013-07-22','13:50:00',4.05),('325','2013-07-22','13:55:00',4.06),('325','2013-07-22','14:00:00',4.07),('325','2013-07-22','14:05:00',4.12),('325','2013-07-22','14:10:00',4.06),('325','2013-07-22','14:15:00',4.05),('325','2013-07-22','14:20:00',4.08),('325','2013-07-22','14:25:00',4.04),('325','2013-07-22','14:30:00',4.13),('325','2013-07-22','14:35:00',4.12),('325','2013-07-22','14:40:00',4.08),('325','2013-07-22','14:45:00',4.08),('325','2013-07-22','14:50:00',4.06),('325','2013-07-22','14:55:00',4.03),('325','2013-07-22','15:00:00',3.97),('325','2013-07-22','15:05:00',3.89),('325','2013-07-22','15:10:00',3.94),('325','2013-07-22','15:15:00',3.86),('325','2013-07-22','15:20:00',3.6),('325','2013-07-22','15:25:00',3.5),('325','2013-07-22','15:30:00',3.02),('325','2013-07-22','15:45:00',2.07),('325','2013-07-22','15:50:00',4),('325','2013-07-22','15:55:00',4.07),('325','2013-07-22','16:00:00',4.03),('325','2013-07-22','16:05:00',3.94),('325','2013-07-22','16:10:00',3.8),('325','2013-07-22','16:15:00',3.73),('325','2013-07-22','16:20:00',3.64),('325','2013-07-22','16:25:00',3.5),('325','2013-07-22','16:30:00',3.3),('325','2013-07-22','16:35:00',3.27),('325','2013-07-22','16:40:00',3.04),('325','2013-07-22','16:45:00',2.94),('325','2013-07-22','16:50:00',2.89),('325','2013-07-22','16:55:00',2.85),('325','2013-07-22','17:00:00',2.77),('325','2013-07-22','17:05:00',2.67),('325','2013-07-22','17:10:00',2.53),('325','2013-07-22','17:15:00',2.51),('325','2013-07-22','17:20:00',2.44),('325','2013-07-22','17:25:00',2.34),('325','2013-07-22','17:30:00',2.21),('325','2013-07-22','17:35:00',2.19),('325','2013-07-22','17:40:00',2.15),('325','2013-07-22','17:45:00',1.85),('325','2013-07-22','17:50:00',1.76),('325','2013-07-22','17:55:00',1.74),('325','2013-07-22','18:00:00',1.75),('325','2013-07-22','18:05:00',1.65),('325','2013-07-22','18:10:00',1.5),('325','2013-07-22','18:15:00',1.36),('325','2013-07-22','18:20:00',1.29),('325','2013-07-22','18:25:00',1.25),('325','2013-07-22','18:30:00',1.11),('325','2013-07-21','08:35:00',1.04),('325','2013-07-21','08:40:00',1.11),('325','2013-07-21','08:45:00',1.2),('325','2013-07-21','08:50:00',1.27),('325','2013-07-21','08:55:00',1.31),('325','2013-07-21','09:00:00',1.33),('325','2013-07-21','09:05:00',1.34),('325','2013-07-21','09:10:00',1.38),('325','2013-07-21','09:15:00',1.42),('325','2013-07-21','09:20:00',1.45),('325','2013-07-21','09:25:00',1.47),('325','2013-07-21','09:30:00',1.52),('325','2013-07-21','09:35:00',1.56),('325','2013-07-21','09:40:00',1.82),('325','2013-07-21','09:45:00',2.44),('325','2013-07-21','09:50:00',2.52),('325','2013-07-21','09:55:00',2.63),('325','2013-07-21','10:00:00',2.72),('325','2013-07-21','10:05:00',2.79),('325','2013-07-21','10:10:00',2.83),('325','2013-07-21','10:15:00',2.88),('325','2013-07-21','10:20:00',2.92),('325','2013-07-21','10:25:00',2.91),('325','2013-07-21','10:30:00',2.92),('325','2013-07-21','10:35:00',2.98),('325','2013-07-21','10:40:00',3.07),('325','2013-07-21','10:45:00',3.19),('325','2013-07-21','10:50:00',3.33),('325','2013-07-21','10:55:00',3.35),('325','2013-07-21','11:00:00',3.4),('325','2013-07-21','11:05:00',3.47),('325','2013-07-21','11:10:00',3.51),('325','2013-07-21','11:15:00',3.57),('325','2013-07-21','11:20:00',3.65),('325','2013-07-21','11:25:00',3.72),('325','2013-07-21','11:30:00',3.73),('325','2013-07-21','11:35:00',3.72),('325','2013-07-21','11:40:00',3.82),('325','2013-07-21','11:45:00',3.82),('325','2013-07-21','11:50:00',3.8),('325','2013-07-21','11:55:00',3.86),('325','2013-07-21','12:00:00',3.97),('325','2013-07-21','12:05:00',3.82),('325','2013-07-21','12:10:00',3.7),('325','2013-07-21','12:15:00',4.23),('325','2013-07-21','12:20:00',4.08),('325','2013-07-21','12:25:00',4.62),('325','2013-07-21','12:30:00',4.12),('325','2013-07-21','12:35:00',4.91),('325','2013-07-21','12:40:00',4.93),('325','2013-07-21','12:45:00',4.79),('325','2013-07-21','12:50:00',4.3),('325','2013-07-21','12:55:00',4.98),('325','2013-07-21','13:00:00',5.05),('325','2013-07-21','13:05:00',4.29),('325','2013-07-21','13:10:00',3.28),('325','2013-07-21','13:15:00',2.53),('325','2013-07-21','13:20:00',3.01),('325','2013-07-21','13:25:00',4.09),('325','2013-07-21','13:30:00',4.59),('325','2013-07-21','13:35:00',4.55),('325','2013-07-21','13:40:00',3.9),('325','2013-07-21','13:45:00',4.53),('325','2013-07-21','13:50:00',2.49),('325','2013-07-21','13:55:00',1.02),('325','2013-07-21','14:00:00',1.02),('325','2013-07-21','14:05:00',1.17),('325','2013-07-21','14:10:00',1.11),('325','2013-07-21','14:15:00',1.11),('325','2013-07-21','14:20:00',1.39),('325','2013-07-21','14:25:00',1.56),('325','2013-07-21','14:30:00',1.23),('325','2013-07-21','14:35:00',1.21),('325','2013-07-21','14:40:00',1.26),('325','2013-07-21','14:45:00',1.42),('325','2013-07-21','14:50:00',1.68),('325','2013-07-21','14:55:00',1.75),('325','2013-07-21','15:00:00',1.83),('325','2013-07-21','15:05:00',1.72),('325','2013-07-21','15:10:00',1.83),('325','2013-07-21','15:15:00',4.35),('325','2013-07-21','15:20:00',4.08),('325','2013-07-21','15:25:00',1.72),('325','2013-07-21','15:30:00',1.52),('325','2013-07-21','15:35:00',1.7),('325','2013-07-21','15:40:00',2.81),('325','2013-07-21','15:45:00',3.51),('325','2013-07-21','15:50:00',2.91),('325','2013-07-21','15:55:00',2.12),('325','2013-07-21','16:00:00',1.59),('325','2013-07-21','16:05:00',1.13),('325','2013-07-21','16:55:00',1.07),('325','2013-07-21','17:00:00',1.2),('325','2013-07-21','17:05:00',1.38),('325','2013-07-21','17:10:00',1.46),('325','2013-07-21','17:15:00',1.19),('325','2013-07-21','17:20:00',1.05),('325','2013-07-20','08:35:00',1.03),('325','2013-07-20','08:40:00',1.1),('325','2013-07-20','08:45:00',1.25),('325','2013-07-20','08:50:00',1.31),('325','2013-07-20','08:55:00',1.38),('325','2013-07-20','09:00:00',1.4),('325','2013-07-20','09:05:00',1.44),('325','2013-07-20','09:10:00',1.53),('325','2013-07-20','09:15:00',1.61),('325','2013-07-20','09:20:00',1.62),('325','2013-07-20','09:25:00',1.57),('325','2013-07-20','09:30:00',1.55),('325','2013-07-20','09:35:00',1.58),('325','2013-07-20','09:40:00',1.95),('325','2013-07-20','09:45:00',2.57),('325','2013-07-20','09:50:00',2.55),('325','2013-07-20','09:55:00',2.58),('325','2013-07-20','10:00:00',2.77),('325','2013-07-20','10:05:00',2.83),('325','2013-07-20','10:10:00',2.92),('325','2013-07-20','10:15:00',2.96),('325','2013-07-20','10:20:00',2.97),('325','2013-07-20','10:25:00',2.97),('325','2013-07-20','10:30:00',2.98),('325','2013-07-20','10:35:00',3.04),('325','2013-07-20','10:40:00',3.11),('325','2013-07-20','10:45:00',3.24),('325','2013-07-20','10:50:00',3.35),('325','2013-07-20','10:55:00',3.4),('325','2013-07-20','11:00:00',3.44),('325','2013-07-20','11:05:00',3.48),('325','2013-07-20','11:10:00',3.54),('325','2013-07-20','11:15:00',3.6),('325','2013-07-20','11:20:00',3.64),('325','2013-07-20','11:25:00',3.71),('325','2013-07-20','11:30:00',3.8),('325','2013-07-20','11:35:00',3.78),('325','2013-07-20','11:40:00',3.79),('325','2013-07-20','11:45:00',3.83),('325','2013-07-20','11:50:00',3.88),('325','2013-07-20','11:55:00',3.99),('325','2013-07-20','12:00:00',4.03),('325','2013-07-20','12:05:00',4.21),('325','2013-07-20','12:10:00',4.28),('325','2013-07-20','12:15:00',4.32),('325','2013-07-20','12:20:00',4.27),('325','2013-07-20','12:25:00',4.16),('325','2013-07-20','12:30:00',4.17),('325','2013-07-20','12:35:00',4.2),('325','2013-07-20','12:40:00',4.21),('325','2013-07-20','12:45:00',4.26),('325','2013-07-20','12:50:00',4.2),('325','2013-07-20','12:55:00',4.25),('325','2013-07-20','13:00:00',4.47),('325','2013-07-20','13:05:00',4.3),('325','2013-07-20','13:10:00',1.18),('325','2013-07-20','13:15:00',1.6),('325','2013-07-20','13:20:00',4.16),('325','2013-07-20','13:25:00',4.64),('325','2013-07-20','13:30:00',4.64),('325','2013-07-20','13:35:00',4.57),('325','2013-07-20','13:40:00',4.64),('325','2013-07-20','13:45:00',4.03),('325','2013-07-20','13:50:00',1.23),('325','2013-07-20','13:55:00',1.46),('325','2013-07-20','14:00:00',4.58),('325','2013-07-20','14:05:00',4.44),('325','2013-07-20','14:10:00',4.47),('325','2013-07-20','14:15:00',4.48),('325','2013-07-20','14:20:00',4.41),('325','2013-07-20','14:25:00',4.19),('325','2013-07-20','14:30:00',3.88),('325','2013-07-20','14:35:00',4.11),('325','2013-07-20','14:40:00',3.97),('325','2013-07-20','14:45:00',4.3),('325','2013-07-20','14:50:00',4.39),('325','2013-07-20','14:55:00',4.15),('325','2013-07-20','15:00:00',4.3),('325','2013-07-20','15:05:00',4.12),('325','2013-07-20','15:10:00',4.11),('325','2013-07-20','15:15:00',4.04),('325','2013-07-20','15:20:00',3.95),('325','2013-07-20','15:25:00',3.95),('325','2013-07-20','15:30:00',3.92),('325','2013-07-20','15:35:00',3.85),('325','2013-07-20','15:40:00',3.79),('325','2013-07-20','15:45:00',3.74),('325','2013-07-20','15:50:00',3.68),('325','2013-07-20','15:55:00',3.6),('325','2013-07-20','16:00:00',3.57),('325','2013-07-20','16:05:00',3.53),('325','2013-07-20','16:10:00',3.46),('325','2013-07-20','16:15:00',3.47),('325','2013-07-20','16:20:00',3.4),('325','2013-07-20','16:25:00',3.34),('325','2013-07-20','16:30:00',3.27),('325','2013-07-20','16:35:00',3.17),('325','2013-07-20','16:40:00',3.13),('325','2013-07-20','16:45:00',3.07),('325','2013-07-20','16:50:00',3),('325','2013-07-20','16:55:00',2.87),('325','2013-07-20','17:00:00',2.78),('325','2013-07-20','17:05:00',2.68),('325','2013-07-20','17:10:00',2.54),('325','2013-07-20','17:15:00',2.52),('325','2013-07-20','17:20:00',2.45),('325','2013-07-20','17:25:00',2.36),('325','2013-07-20','17:30:00',2.28),('325','2013-07-20','17:35:00',2.21),('325','2013-07-20','17:40:00',2.14),('325','2013-07-20','17:45:00',2.04),('325','2013-07-20','17:50:00',1.96),('325','2013-07-20','17:55:00',1.81),('325','2013-07-20','18:00:00',1.74),('325','2013-07-20','18:05:00',1.65),('325','2013-07-20','18:10:00',1.56),('325','2013-07-20','18:15:00',1.46),('325','2013-07-20','18:20:00',1.38),('325','2013-07-20','18:25:00',1.29),('325','2013-07-20','18:30:00',1.15),('325','2014-04-06','08:40:00',1.05),('325','2014-04-06','08:45:00',1.09),('325','2014-04-06','09:10:00',1.18),('325','2014-04-06','09:15:00',1.54),('325','2014-04-06','09:20:00',1.47),('325','2014-04-06','09:25:00',1.47),('325','2014-04-06','09:30:00',1.32),('325','2014-04-06','09:35:00',1.64),('325','2014-04-06','09:40:00',1.88),('325','2014-04-06','09:45:00',2.25),('325','2014-04-06','09:50:00',2.64),('325','2014-04-06','09:55:00',2.64),('325','2014-04-06','10:00:00',2.62),('325','2014-04-06','10:05:00',2.04),('325','2014-04-06','10:10:00',1.65),('325','2014-04-06','10:15:00',1.96),('325','2014-04-06','10:20:00',1.62),('325','2014-04-06','10:25:00',1.28),('325','2014-04-06','10:30:00',1.36),('325','2014-04-06','10:35:00',1.52),('325','2014-04-06','10:40:00',1.69),('325','2014-04-06','10:45:00',2.56),('325','2014-04-06','10:50:00',2.34),('325','2014-04-06','10:55:00',1.52),('325','2014-04-06','11:00:00',2.4),('325','2014-04-06','11:05:00',3.74),('325','2014-04-06','11:10:00',4.59),('325','2014-04-06','11:15:00',3.2),('325','2014-04-06','11:20:00',4.03),('325','2014-04-06','11:25:00',4.37),('325','2014-04-06','11:30:00',4.57),('325','2014-04-06','11:35:00',4.36),('325','2014-04-06','11:40:00',3.61),('325','2014-04-06','11:45:00',4.77),('325','2014-04-06','11:50:00',3.88),('325','2014-04-06','11:55:00',4.01),('325','2014-04-06','12:00:00',4.81),('325','2014-04-06','12:05:00',4.6),('325','2014-04-06','12:10:00',4.65),('325','2014-04-06','12:15:00',4.25),('325','2014-04-06','12:20:00',4.05),('325','2014-04-06','12:25:00',2.15),('325','2014-04-06','12:30:00',2.22),('325','2014-04-06','12:35:00',2.16),('325','2014-04-06','12:40:00',1.37),('325','2014-04-06','12:45:00',1.09),('325','2014-04-06','12:50:00',1.16),('325','2014-04-06','12:55:00',1.33),('325','2014-04-06','13:00:00',4.82),('325','2014-04-06','13:05:00',4.27),('325','2014-04-06','13:10:00',5.13),('325','2014-04-06','13:15:00',3.8),('325','2014-04-06','13:20:00',2.53),('325','2014-04-06','13:25:00',1.67),('325','2014-04-06','13:30:00',3.84),('325','2014-04-06','13:35:00',5.18),('325','2014-04-06','13:40:00',2.11),('325','2014-04-06','13:45:00',2.71),('325','2014-04-06','13:50:00',4.52),('325','2014-04-06','13:55:00',4.89),('325','2014-04-06','14:00:00',4.67),('325','2014-04-06','14:05:00',4.26),('325','2014-04-06','14:10:00',4.68),('325','2014-04-06','14:15:00',4.34),('325','2014-04-06','14:20:00',2.4),('325','2014-04-06','14:25:00',1.53),('325','2014-04-06','14:30:00',1.14),('325','2014-04-06','14:35:00',1.31),('325','2014-04-06','14:40:00',1.69),('325','2014-04-06','14:45:00',4.98),('325','2014-04-06','14:50:00',4.29),('325','2014-04-06','14:55:00',3.58),('325','2014-04-06','15:00:00',2.88),('325','2014-04-06','15:05:00',1.32),('325','2014-04-06','15:10:00',3.16),('325','2014-04-06','15:15:00',3.54),('325','2014-04-06','15:20:00',3.17),('325','2014-04-06','15:25:00',2.05),('325','2014-04-06','15:30:00',1.72),('325','2014-04-06','15:50:00',1.28),('325','2014-04-06','15:55:00',3.96),('325','2014-04-06','16:00:00',3.25),('325','2014-04-06','16:05:00',1.99),('325','2014-04-06','16:10:00',3.03),('325','2014-04-06','16:15:00',1.54),('325','2014-04-06','16:35:00',1.34),('325','2014-04-06','16:40:00',2.47),('325','2014-04-06','16:45:00',3.28),('325','2014-04-06','16:50:00',3.32),('325','2014-04-06','16:55:00',2.41),('325','2014-04-06','17:00:00',1.07),('325','2014-04-06','17:25:00',2.03),('325','2014-04-06','17:30:00',1.97),('325','2014-04-06','17:35:00',1.36),('325','2014-04-06','17:45:00',1.2),('325','2014-04-06','17:50:00',1.57),('325','2014-04-06','17:55:00',1.41),('325','2014-04-06','18:00:00',1.28),('325','2014-04-06','18:05:00',1.17),('325','2014-04-06','18:10:00',1.07),('325','2014-04-06','18:15:00',1.02),('325','2014-04-06','18:20:00',1),('325','2013-07-19','08:30:00',1.01),('325','2013-07-19','08:35:00',1.1),('325','2013-07-19','08:40:00',1.16),('325','2013-07-19','08:45:00',1.23),('325','2013-07-19','08:50:00',1.29),('325','2013-07-19','08:55:00',1.32),('325','2013-07-19','09:00:00',1.33),('325','2013-07-19','09:05:00',1.34),('325','2013-07-19','09:10:00',1.39),('325','2013-07-19','09:15:00',1.43),('325','2013-07-19','09:20:00',1.45),('325','2013-07-19','09:25:00',1.48),('325','2013-07-19','09:30:00',1.53),('325','2013-07-19','09:35:00',1.58),('325','2013-07-19','09:40:00',1.62),('325','2013-07-19','09:45:00',2.24),('325','2013-07-19','09:50:00',2.48),('325','2013-07-19','09:55:00',2.54),('325','2013-07-19','10:00:00',2.57),('325','2013-07-19','10:05:00',2.62),('325','2013-07-19','10:10:00',2.74),('325','2013-07-19','10:15:00',2.84),('325','2013-07-19','10:20:00',2.86),('325','2013-07-19','10:25:00',2.88),('325','2013-07-19','10:30:00',2.86),('325','2013-07-19','10:35:00',2.99),('325','2013-07-19','10:40:00',3.1),('325','2013-07-19','10:45:00',3.18),('325','2013-07-19','10:50:00',3.2),('325','2013-07-19','10:55:00',3.25),('325','2013-07-19','11:00:00',3.33),('325','2013-07-19','11:05:00',3.4),('325','2013-07-19','11:10:00',3.47),('325','2013-07-19','11:15:00',3.6),('325','2013-07-19','11:20:00',3.7),('325','2013-07-19','11:25:00',3.7),('325','2013-07-19','11:30:00',3.68),('325','2013-07-19','11:35:00',3.74),('325','2013-07-19','11:40:00',3.68),('325','2013-07-19','11:45:00',3.74),('325','2013-07-19','11:50:00',3.71),('325','2013-07-19','11:55:00',3.79),('325','2013-07-19','12:00:00',3.9),('325','2013-07-19','12:05:00',4.05),('325','2013-07-19','12:10:00',4.16),('325','2013-07-19','12:15:00',4.3),('325','2013-07-19','12:20:00',4.29),('325','2013-07-19','12:25:00',4.22),('325','2013-07-19','12:30:00',4.13),('325','2013-07-19','12:35:00',4.08),('325','2013-07-19','12:40:00',4.06),('325','2013-07-19','12:45:00',4),('325','2013-07-19','12:50:00',4.31),('325','2013-07-19','12:55:00',4.34),('325','2013-07-19','13:00:00',4.15),('325','2013-07-19','13:05:00',4.45),('325','2013-07-19','13:10:00',3.25),('325','2013-07-19','13:15:00',1.92),('325','2013-07-19','13:20:00',3.02),('325','2013-07-19','13:25:00',4.64),('325','2013-07-19','13:30:00',4.44),('325','2013-07-19','13:35:00',4.32),('325','2013-07-19','13:40:00',4.32),('325','2013-07-19','13:45:00',4.34),('325','2013-07-19','13:50:00',4.36),('325','2013-07-19','13:55:00',4.41),('325','2013-07-19','14:00:00',4.4),('325','2013-07-19','14:05:00',4.36),('325','2013-07-19','14:10:00',4.39),('325','2013-07-19','14:15:00',4.3),('325','2013-07-19','14:20:00',4.43),('325','2013-07-19','14:25:00',4.12),('325','2013-07-19','14:30:00',4.12),('325','2013-07-19','14:35:00',3.94),('325','2013-07-19','14:40:00',4.25),('325','2013-07-19','14:45:00',4.13),('325','2013-07-19','14:50:00',4.17),('325','2013-07-19','14:55:00',4.24),('325','2013-07-19','15:00:00',4.23),('325','2013-07-19','15:05:00',4.21),('325','2013-07-19','15:10:00',4.12),('325','2013-07-19','15:15:00',2.62),('325','2013-07-19','15:20:00',2.85),('325','2013-07-19','15:25:00',3.75),('325','2013-07-19','15:30:00',4.19),('325','2013-07-19','15:35:00',4.03),('325','2013-07-19','15:40:00',3.94),('325','2013-07-19','15:45:00',3.93),('325','2013-07-19','15:50:00',3.84),('325','2013-07-19','15:55:00',3.76),('325','2013-07-19','16:00:00',3.67),('325','2013-07-19','16:05:00',3.64),('325','2013-07-19','16:10:00',3.62),('325','2013-07-19','16:15:00',3.55),('325','2013-07-19','16:20:00',3.51),('325','2013-07-19','16:25:00',3.45),('325','2013-07-19','16:30:00',3.42),('325','2013-07-19','16:35:00',3.36),('325','2013-07-19','16:40:00',3.3),('325','2013-07-19','16:45:00',3.23),('325','2013-07-19','16:50:00',3.19),('325','2013-07-19','16:55:00',3.19),('325','2013-07-19','17:00:00',2.58),('325','2013-07-19','17:05:00',3.08),('325','2013-07-19','17:10:00',2.75),('325','2013-07-19','17:15:00',2.74),('325','2013-07-19','17:20:00',2.41),('325','2013-07-19','17:25:00',1.93),('325','2013-07-19','17:30:00',2.34),('325','2013-07-19','17:35:00',2.56),('325','2013-07-19','17:40:00',2.05),('325','2013-07-19','17:45:00',1.45),('325','2013-07-19','17:50:00',1.02),('325','2013-07-18','08:30:00',1.04),('325','2013-07-18','08:35:00',1.11),('325','2013-07-18','08:40:00',1.16),('325','2013-07-18','08:45:00',1.22),('325','2013-07-18','08:50:00',1.28),('325','2013-07-18','08:55:00',1.31),('325','2013-07-18','09:00:00',1.32),('325','2013-07-18','09:05:00',1.32),('325','2013-07-18','09:10:00',1.35),('325','2013-07-18','09:15:00',1.39),('325','2013-07-18','09:20:00',1.41),('325','2013-07-18','09:25:00',1.44),('325','2013-07-18','09:30:00',1.48),('325','2013-07-18','09:35:00',1.52),('325','2013-07-18','09:40:00',1.55),('325','2013-07-18','09:45:00',2.42),('325','2013-07-18','09:50:00',2.56),('325','2013-07-18','09:55:00',2.63),('325','2013-07-18','10:00:00',2.65),('325','2013-07-18','10:05:00',2.82),('325','2013-07-18','10:10:00',2.89),('325','2013-07-18','10:15:00',2.97),('325','2013-07-18','10:20:00',2.99),('325','2013-07-18','10:25:00',2.99),('325','2013-07-18','10:30:00',3),('325','2013-07-18','10:35:00',3.09),('325','2013-07-18','10:40:00',3.16),('325','2013-07-18','10:45:00',3.3),('325','2013-07-18','10:50:00',3.32),('325','2013-07-18','10:55:00',3.39),('325','2013-07-18','11:00:00',3.44),('325','2013-07-18','11:05:00',3.47),('325','2013-07-18','11:10:00',3.54),('325','2013-07-18','11:15:00',3.62),('325','2013-07-18','11:20:00',3.73),('325','2013-07-18','11:25:00',3.77),('325','2013-07-18','11:30:00',3.76),('325','2013-07-18','11:35:00',3.76),('325','2013-07-18','11:40:00',3.74),('325','2013-07-18','11:45:00',3.76),('325','2013-07-18','11:50:00',3.81),('325','2013-07-18','11:55:00',3.87),('325','2013-07-18','12:00:00',3.9),('325','2013-07-18','12:05:00',3.99),('325','2013-07-18','12:10:00',4),('325','2013-07-18','12:15:00',4.11),('325','2013-07-18','12:20:00',4.02),('325','2013-07-18','12:25:00',4.12),('325','2013-07-18','12:30:00',4.32),('325','2013-07-18','12:35:00',4.35),('325','2013-07-18','12:40:00',4.49),('325','2013-07-18','12:45:00',4.46),('325','2013-07-18','12:50:00',2.74),('325','2013-07-18','12:55:00',4.42),('325','2013-07-18','13:00:00',4.41),('325','2013-07-18','13:05:00',4.26),('325','2013-07-18','13:10:00',4.38),('325','2013-07-18','13:15:00',4.41),('325','2013-07-18','13:20:00',4.45),('325','2013-07-18','13:25:00',4.25),('325','2013-07-18','13:30:00',4.2),('325','2013-07-18','13:35:00',4.47),('325','2013-07-18','13:40:00',4.4),('325','2013-07-18','13:45:00',4.41),('325','2013-07-18','13:50:00',4.43),('325','2013-07-18','13:55:00',4.31),('325','2013-07-18','14:00:00',4.26),('325','2013-07-18','14:05:00',4.27),('325','2013-07-18','14:10:00',4.32),('325','2013-07-18','14:15:00',4.34),('325','2013-07-18','14:20:00',4.28),('325','2013-07-18','14:25:00',4.15),('325','2013-07-18','14:30:00',4.22),('325','2013-07-18','14:35:00',4.21),('325','2013-07-18','14:40:00',4.21),('325','2013-07-18','14:45:00',4.17),('325','2013-07-18','14:50:00',4.08),('325','2013-07-18','14:55:00',4.08),('325','2013-07-18','15:00:00',4.09),('325','2013-07-18','15:05:00',4.05),('325','2013-07-18','15:10:00',4),('325','2013-07-18','15:15:00',3.98),('325','2013-07-18','15:20:00',3.98),('325','2013-07-18','15:25:00',3.96),('325','2013-07-18','15:30:00',3.9),('325','2013-07-18','15:35:00',3.87),('325','2013-07-18','15:40:00',3.79),('325','2013-07-18','15:45:00',3.76),('325','2013-07-18','15:50:00',3.7),('325','2013-07-18','15:55:00',3.62),('325','2013-07-18','16:00:00',3.59),('325','2013-07-18','16:05:00',3.53),('325','2013-07-18','16:10:00',3.48),('325','2013-07-18','16:15:00',3.4),('325','2013-07-18','16:20:00',3.37),('325','2013-07-18','16:25:00',3.31),('325','2013-07-18','16:30:00',3.23),('325','2013-07-18','16:35:00',3.17),('325','2013-07-18','16:40:00',3.1),('325','2013-07-18','16:45:00',3.04),('325','2013-07-18','16:50:00',2.93),('325','2013-07-18','16:55:00',2.84),('325','2013-07-18','17:00:00',2.75),('325','2013-07-18','17:05:00',2.65),('325','2013-07-18','17:10:00',2.54),('325','2013-07-18','17:15:00',2.44),('325','2013-07-18','17:20:00',2.44),('325','2013-07-18','17:25:00',2.32),('325','2013-07-18','17:30:00',2.21),('325','2013-07-18','17:35:00',2.11),('325','2013-07-18','17:40:00',1.84),('325','2013-07-18','17:45:00',1.85),('325','2013-07-18','17:50:00',1.86),('325','2013-07-18','17:55:00',1.68),('325','2013-07-18','18:00:00',1.57),('325','2013-07-18','18:05:00',1.31),('325','2013-07-18','18:10:00',1.41),('325','2013-07-18','18:15:00',1.29),('325','2013-07-18','18:20:00',1.21),('325','2013-07-18','18:25:00',1.11),('325','2013-07-17','08:25:00',1.02),('325','2013-07-17','08:30:00',1.08),('325','2013-07-17','08:35:00',1.16),('325','2013-07-17','08:40:00',1.2),('325','2013-07-17','08:45:00',1.27),('325','2013-07-17','08:50:00',1.32),('325','2013-07-17','08:55:00',1.35),('325','2013-07-17','09:00:00',1.36),('325','2013-07-17','09:05:00',1.36),('325','2013-07-17','09:10:00',1.4),('325','2013-07-17','09:15:00',1.43),('325','2013-07-17','09:20:00',1.46),('325','2013-07-17','09:25:00',1.48),('325','2013-07-17','09:30:00',1.51),('325','2013-07-17','09:35:00',1.55),('325','2013-07-17','09:40:00',1.61),('325','2013-07-17','09:45:00',2.6),('325','2013-07-17','09:50:00',2.66),('325','2013-07-17','09:55:00',2.8),('325','2013-07-17','10:00:00',2.85),('325','2013-07-17','10:05:00',2.92),('325','2013-07-17','10:10:00',2.99),('325','2013-07-17','10:15:00',3.07),('325','2013-07-17','10:20:00',3.08),('325','2013-07-17','10:25:00',3.08),('325','2013-07-17','10:30:00',3.16),('325','2013-07-17','10:35:00',3.27),('325','2013-07-17','10:40:00',3.29),('325','2013-07-17','10:45:00',3.38),('325','2013-07-17','10:50:00',3.43),('325','2013-07-17','10:55:00',3.46),('325','2013-07-17','11:00:00',3.52),('325','2013-07-17','11:05:00',3.59),('325','2013-07-17','11:10:00',3.68),('325','2013-07-17','11:15:00',3.74),('325','2013-07-17','11:20:00',3.85),('325','2013-07-17','11:25:00',3.9),('325','2013-07-17','11:30:00',3.91),('325','2013-07-17','11:35:00',3.86),('325','2013-07-17','11:40:00',3.85),('325','2013-07-17','11:45:00',3.85),('325','2013-07-17','11:50:00',3.92),('325','2013-07-17','11:55:00',3.95),('325','2013-07-17','12:00:00',4.24),('325','2013-07-17','12:05:00',4.32),('325','2013-07-17','12:10:00',4.3),('325','2013-07-17','12:15:00',4.32),('325','2013-07-17','12:20:00',4.27),('325','2013-07-17','12:25:00',4.24),('325','2013-07-17','12:30:00',4.24),('325','2013-07-17','12:35:00',4.36),('325','2013-07-17','12:40:00',4.37),('325','2013-07-17','12:45:00',4.37),('325','2013-07-17','12:50:00',4.35),('325','2013-07-17','12:55:00',4.36),('325','2013-07-17','13:00:00',4.4),('325','2013-07-17','13:05:00',4.4),('325','2013-07-17','13:10:00',4.38),('325','2013-07-17','13:15:00',4.4),('325','2013-07-17','13:20:00',4.39),('325','2013-07-17','13:25:00',4.32),('325','2013-07-17','13:30:00',4.37),('325','2013-07-17','13:35:00',4.34),('325','2013-07-17','13:40:00',4.31),('325','2013-07-17','13:45:00',4.31),('325','2013-07-17','13:50:00',4.27),('325','2013-07-17','13:55:00',4.21),('325','2013-07-17','14:00:00',4.19),('325','2013-07-17','14:05:00',4.16),('325','2013-07-17','14:10:00',4.11),('325','2013-07-17','14:15:00',4.03),('325','2013-07-17','14:20:00',3.95),('325','2013-07-17','14:25:00',3.9),('325','2013-07-17','14:30:00',4.09),('325','2013-07-17','14:35:00',4.13),('325','2013-07-17','14:40:00',4.23),('325','2013-07-17','14:45:00',4.21),('325','2013-07-17','14:50:00',4.09),('325','2013-07-17','14:55:00',3.92),('325','2013-07-17','15:00:00',4.07),('325','2013-07-17','15:05:00',4.06),('325','2013-07-17','15:10:00',3.95),('325','2013-07-17','15:15:00',3.97),('325','2013-07-17','15:20:00',3.96),('325','2013-07-17','15:25:00',3.93),('325','2013-07-17','15:30:00',3.89),('325','2013-07-17','15:35:00',3.9),('325','2013-07-17','15:40:00',3.85),('325','2013-07-17','15:45:00',3.7),('325','2013-07-17','15:50:00',2.9),('325','2013-07-17','15:55:00',2.9),('325','2013-07-17','16:00:00',3.66),('325','2013-07-17','16:05:00',3.56),('325','2013-07-17','16:10:00',3.53),('325','2013-07-17','16:15:00',3.48),('325','2013-07-17','16:20:00',3),('325','2013-07-17','16:25:00',3.26),('325','2013-07-17','16:30:00',3.17),('325','2013-07-17','16:35:00',3.18),('325','2013-07-17','16:40:00',3.05),('325','2013-07-17','16:45:00',3.06),('325','2013-07-17','16:50:00',2.96),('325','2013-07-17','16:55:00',2.93),('325','2013-07-17','17:00:00',2.87),('325','2013-07-17','17:05:00',2.74),('325','2013-07-17','17:10:00',2.61),('325','2013-07-17','17:15:00',2.59),('325','2013-07-17','17:20:00',2.51),('325','2013-07-17','17:25:00',2.42),('325','2013-07-17','17:30:00',2.31),('325','2013-07-17','17:35:00',2.24),('325','2013-07-17','17:40:00',2.1),('325','2013-07-17','17:45:00',2.05),('325','2013-07-17','17:50:00',1.98),('325','2013-07-17','17:55:00',1.84),('325','2013-07-17','18:00:00',1.72),('325','2013-07-17','18:05:00',1.68),('325','2013-07-17','18:10:00',1.59),('325','2013-07-17','18:15:00',1.51),('325','2013-07-17','18:20:00',1.4),('325','2013-07-17','18:25:00',1.3),('325','2013-07-17','18:30:00',1.14),('325','2013-07-16','08:30:00',1.08),('325','2013-07-16','08:35:00',1.15),('325','2013-07-16','08:40:00',1.19),('325','2013-07-16','08:45:00',1.25),('325','2013-07-16','08:50:00',1.31),('325','2013-07-16','08:55:00',1.34),('325','2013-07-16','09:00:00',1.34),('325','2013-07-16','09:05:00',1.35),('325','2013-07-16','09:10:00',1.4),('325','2013-07-16','09:15:00',1.43),('325','2013-07-16','09:20:00',1.46),('325','2013-07-16','09:25:00',1.49),('325','2013-07-16','09:30:00',1.52),('325','2013-07-16','09:35:00',1.58),('325','2013-07-16','09:40:00',1.62),('325','2013-07-16','09:45:00',2.48),('325','2013-07-16','09:50:00',2.61),('325','2013-07-16','09:55:00',2.73),('325','2013-07-16','10:00:00',2.79),('325','2013-07-16','10:05:00',2.85),('325','2013-07-16','10:10:00',2.93),('325','2013-07-16','10:15:00',3.02),('325','2013-07-16','10:20:00',3.05),('325','2013-07-16','10:25:00',3.05),('325','2013-07-16','10:30:00',3.07),('325','2013-07-16','10:35:00',3.12),('325','2013-07-16','10:40:00',3.22),('325','2013-07-16','10:45:00',3.35),('325','2013-07-16','10:50:00',3.38),('325','2013-07-16','10:55:00',3.4),('325','2013-07-16','11:00:00',3.47),('325','2013-07-16','11:05:00',3.54),('325','2013-07-16','11:10:00',3.62),('325','2013-07-16','11:15:00',3.69),('325','2013-07-16','11:20:00',3.81),('325','2013-07-16','11:25:00',3.87),('325','2013-07-16','11:30:00',3.85),('325','2013-07-16','11:35:00',3.82),('325','2013-07-16','11:40:00',3.79),('325','2013-07-16','11:45:00',3.82),('325','2013-07-16','11:50:00',3.91),('325','2013-07-16','11:55:00',3.98),('325','2013-07-16','12:00:00',4.02),('325','2013-07-16','12:05:00',4.11),('325','2013-07-16','12:10:00',4.22),('325','2013-07-16','12:15:00',4.31),('325','2013-07-16','12:20:00',4.29),('325','2013-07-16','12:25:00',4.22),('325','2013-07-16','12:30:00',4.19),('325','2013-07-16','12:35:00',4.14),('325','2013-07-16','12:40:00',4.12),('325','2013-07-16','12:45:00',4.1),('325','2013-07-16','12:50:00',4.09),('325','2013-07-16','12:55:00',4.18),('325','2013-07-16','13:00:00',4.31),('325','2013-07-16','13:05:00',4.37),('325','2013-07-16','13:10:00',4.36),('325','2013-07-16','13:15:00',4.37),('325','2013-07-16','13:20:00',4.38),('325','2013-07-16','13:25:00',4.39),('325','2013-07-16','13:30:00',4.41),('325','2013-07-16','13:35:00',4.35),('325','2013-07-16','13:40:00',4.4),('325','2013-07-16','13:45:00',4.45),('325','2013-07-16','13:50:00',4.56),('325','2013-07-16','13:55:00',3.89),('325','2013-07-16','14:00:00',4.25),('325','2013-07-16','14:05:00',4.19),('325','2013-07-16','14:10:00',1.63),('325','2013-07-16','14:15:00',3.57),('325','2013-07-16','14:20:00',1.42),('325','2013-07-16','14:25:00',4.17),('325','2013-07-16','14:30:00',4.35),('325','2013-07-16','14:35:00',4.28),('325','2013-07-16','14:40:00',4.23),('325','2013-07-16','14:45:00',4.18),('325','2013-07-16','14:50:00',4.17),('325','2013-07-16','14:55:00',4.18),('325','2013-07-16','15:00:00',4.12),('325','2013-07-16','15:05:00',4.05),('325','2013-07-16','15:10:00',4.02),('325','2013-07-16','15:15:00',3.96),('325','2013-07-16','15:20:00',3.91),('325','2013-07-16','15:25:00',3.9),('325','2013-07-16','15:30:00',3.89),('325','2013-07-16','15:35:00',2.82),('325','2013-07-16','15:40:00',3.72),('325','2013-07-16','15:45:00',2.63),('325','2013-07-16','15:50:00',3.62),('325','2013-07-16','15:55:00',3.6),('325','2013-07-16','16:00:00',3.31),('325','2013-07-16','16:05:00',2.82),('325','2013-07-16','16:10:00',3.02),('325','2013-07-16','16:15:00',2.05),('325','2013-07-16','16:20:00',1.5),('325','2013-07-16','16:25:00',1.53),('325','2013-07-16','16:30:00',1.11),('325','2013-07-16','16:45:00',1.05),('325','2013-07-16','16:50:00',1.63),('325','2013-07-16','16:55:00',1.9),('325','2013-07-16','17:00:00',2.78),('325','2013-07-16','17:05:00',3.23),('325','2013-07-16','17:10:00',2.96),('325','2013-07-16','17:15:00',2.61),('325','2013-07-16','17:20:00',1.6),('325','2013-07-16','17:25:00',2.32),('325','2013-07-16','17:30:00',2),('325','2013-07-16','17:35:00',2),('325','2013-07-16','17:40:00',2.29),('325','2013-07-16','17:45:00',2.34),('325','2013-07-16','17:50:00',1.83),('325','2013-07-16','17:55:00',1.23),('325','2013-07-16','18:05:00',1.46),('325','2013-07-16','18:10:00',1.24),('325','2013-07-16','18:15:00',1.47),('325','2013-07-16','18:20:00',1.34),('325','2013-07-16','18:25:00',1.28),('325','2013-07-16','18:30:00',1.12),('325','2013-07-15','08:25:00',1.04),('325','2013-07-15','08:30:00',1.09),('325','2013-07-15','08:35:00',1.16),('325','2013-07-15','08:40:00',1.21),('325','2013-07-15','08:45:00',1.28),('325','2013-07-15','08:50:00',1.33),('325','2013-07-15','08:55:00',1.35),('325','2013-07-15','09:00:00',1.35),('325','2013-07-15','09:05:00',1.36),('325','2013-07-15','09:10:00',1.39),('325','2013-07-15','09:15:00',1.42),('325','2013-07-15','09:20:00',1.46),('325','2013-07-15','09:25:00',1.49),('325','2013-07-15','09:30:00',1.51),('325','2013-07-15','09:35:00',1.56),('325','2013-07-15','09:40:00',1.68),('325','2013-07-15','09:45:00',2.57),('325','2013-07-15','09:50:00',2.65),('325','2013-07-15','09:55:00',2.78),('325','2013-07-15','10:00:00',2.83),('325','2013-07-15','10:05:00',2.89),('325','2013-07-15','10:10:00',2.98),('325','2013-07-15','10:15:00',3.06),('325','2013-07-15','10:20:00',3.08),('325','2013-07-15','10:25:00',3.06),('325','2013-07-15','10:30:00',3.05),('325','2013-07-15','10:35:00',3.12),('325','2013-07-15','10:40:00',3.18),('325','2013-07-15','10:45:00',3.31),('325','2013-07-15','10:50:00',3.37),('325','2013-07-15','10:55:00',3.39),('325','2013-07-15','11:00:00',3.48),('325','2013-07-15','11:05:00',3.55),('325','2013-07-15','11:10:00',3.6),('325','2013-07-15','11:15:00',3.67),('325','2013-07-15','11:20:00',3.77),('325','2013-07-15','11:25:00',3.86),('325','2013-07-15','11:30:00',3.83),('325','2013-07-15','11:35:00',3.8),('325','2013-07-15','11:40:00',3.79),('325','2013-07-15','11:45:00',3.83),('325','2013-07-15','11:50:00',3.86),('325','2013-07-15','11:55:00',3.9),('325','2013-07-15','12:00:00',4.03),('325','2013-07-15','12:05:00',4.1),('325','2013-07-15','12:10:00',4.15),('325','2013-07-15','12:15:00',4.25),('325','2013-07-15','12:20:00',4.3),('325','2013-07-15','12:25:00',4.25),('325','2013-07-15','12:30:00',4.18),('325','2013-07-15','12:35:00',4.14),('325','2013-07-15','12:40:00',4.07),('325','2013-07-15','12:45:00',4.03),('325','2013-07-15','12:50:00',4.02),('325','2013-07-15','12:55:00',4.1),('325','2013-07-15','13:00:00',4.36),('325','2013-07-15','13:05:00',4.38),('325','2013-07-15','13:10:00',2.34),('325','2013-07-15','13:15:00',4.5),('325','2013-07-15','13:20:00',4.43),('325','2013-07-15','13:25:00',4.58),('325','2013-07-15','13:30:00',4.66),('325','2013-07-15','13:35:00',4.68),('325','2013-07-15','13:40:00',3.23),('325','2013-07-15','13:45:00',1.73),('325','2013-07-15','13:50:00',2.52),('325','2013-07-15','13:55:00',3.44),('325','2013-07-15','14:00:00',4.6),('325','2013-07-15','14:05:00',4.57),('325','2013-07-15','14:10:00',3.38),('325','2013-07-15','14:15:00',1.03),('325','2013-07-15','14:20:00',1.87),('325','2013-07-15','14:25:00',4.64),('325','2013-07-15','14:30:00',4.48),('325','2013-07-15','14:35:00',4.48),('325','2013-07-15','14:40:00',4.21),('325','2013-07-15','14:45:00',4.33),('325','2013-07-15','14:50:00',4.3),('325','2013-07-15','14:55:00',4.3),('325','2013-07-15','15:00:00',4.24),('325','2013-07-15','15:05:00',4.14),('325','2013-07-15','15:10:00',4.09),('325','2013-07-15','15:15:00',4.03),('325','2013-07-15','15:20:00',3.79),('325','2013-07-15','15:25:00',1.01),('325','2013-07-15','15:30:00',4.05),('325','2013-07-15','15:35:00',4.04),('325','2013-07-15','15:40:00',3.97),('325','2013-07-15','15:45:00',3.78),('325','2013-07-15','15:50:00',3.82),('325','2013-07-15','15:55:00',3.75),('325','2013-07-15','16:00:00',3.63),('325','2013-07-15','16:05:00',3.6),('325','2013-07-15','16:10:00',3.54),('325','2013-07-15','16:15:00',3.48),('325','2013-07-15','16:20:00',3.36),('325','2013-07-15','16:25:00',3.32),('325','2013-07-15','16:30:00',3.27),('325','2013-07-15','16:35:00',3.18),('325','2013-07-15','16:40:00',3.12),('325','2013-07-15','16:45:00',3.05),('325','2013-07-15','16:50:00',2.98),('325','2013-07-15','16:55:00',2.91),('325','2013-07-15','17:00:00',2.83),('325','2013-07-15','17:05:00',2.73),('325','2013-07-15','17:10:00',2.58),('325','2013-07-15','17:15:00',2.56),('325','2013-07-15','17:20:00',2.47),('325','2013-07-15','17:25:00',2.41),('325','2013-07-15','17:30:00',2.33),('325','2013-07-15','17:35:00',2.21),('325','2013-07-15','17:40:00',2.12),('325','2013-07-15','17:45:00',2.03),('325','2013-07-15','17:50:00',1.92),('325','2013-07-15','17:55:00',1.81),('325','2013-07-15','18:00:00',1.69),('325','2013-07-15','18:05:00',1.63),('325','2013-07-15','18:10:00',1.56),('325','2013-07-15','18:15:00',1.46),('325','2013-07-15','18:20:00',1.36),('325','2013-07-15','18:25:00',1.25),('325','2013-07-15','18:30:00',1.11),('325','2013-07-14','07:50:00',1.06),('325','2013-07-14','07:55:00',1.15),('325','2013-07-14','08:00:00',1.23),('325','2013-07-14','08:05:00',1.17),('325','2013-07-14','08:10:00',1.24),('325','2013-07-14','08:15:00',1.08),('325','2013-07-14','08:20:00',1.43),('325','2013-07-14','08:25:00',1.1),('325','2013-07-14','08:35:00',1.06),('325','2013-07-14','08:55:00',1.06),('325','2013-07-14','09:00:00',1.09),('325','2013-07-14','09:05:00',1.13),('325','2013-07-14','09:10:00',1.34),('325','2013-07-14','09:15:00',1.18),('325','2013-07-14','09:20:00',1.43),('325','2013-07-14','09:25:00',1.55),('325','2013-07-14','09:30:00',1.83),('325','2013-07-14','09:35:00',1.93),('325','2013-07-14','09:40:00',1.72),('325','2013-07-14','09:45:00',1.69),('325','2013-07-14','09:50:00',1.63),('325','2013-07-14','09:55:00',1.64),('325','2013-07-14','10:00:00',1.64),('325','2013-07-14','10:05:00',1.81),('325','2013-07-14','10:10:00',1.76),('325','2013-07-14','10:15:00',1.74),('325','2013-07-14','10:20:00',2.24),('325','2013-07-14','10:25:00',2.95),('325','2013-07-14','10:30:00',2.99),('325','2013-07-14','10:35:00',3.41),('325','2013-07-14','10:40:00',2.96),('325','2013-07-14','10:45:00',2.96),('325','2013-07-14','10:50:00',3.71),('325','2013-07-14','10:55:00',3.56),('325','2013-07-14','11:00:00',3.01),('325','2013-07-14','11:05:00',1.3),('325','2013-07-14','11:10:00',1.89),('325','2013-07-14','11:15:00',2.02),('325','2013-07-14','11:20:00',2.53),('325','2013-07-14','11:25:00',1.59),('325','2013-07-14','11:30:00',1.47),('325','2013-07-14','11:35:00',1.73),('325','2013-07-14','11:40:00',1.56),('325','2013-07-14','11:45:00',1.5),('325','2013-07-14','11:50:00',2.11),('325','2013-07-14','11:55:00',4.8),('325','2013-07-14','12:00:00',4.39),('325','2013-07-14','12:05:00',4.26),('325','2013-07-14','12:10:00',4.77),('325','2013-07-14','12:15:00',4.48),('325','2013-07-14','12:20:00',4.63),('325','2013-07-14','12:25:00',4.54),('325','2013-07-14','12:30:00',4.41),('325','2013-07-14','12:35:00',4.72),('325','2013-07-14','12:40:00',3.91),('325','2013-07-14','12:45:00',3.85),('325','2013-07-14','12:50:00',4.16),('325','2013-07-14','12:55:00',4.68),('325','2013-07-14','13:00:00',2.29),('325','2013-07-14','13:05:00',4.44),('325','2013-07-14','13:10:00',4.92),('325','2013-07-14','13:15:00',4.69),('325','2013-07-14','13:20:00',4.42),('325','2013-07-14','13:25:00',4.58),('325','2013-07-14','13:30:00',4.53),('325','2013-07-14','13:35:00',4.53),('325','2013-07-14','13:40:00',4.55),('325','2013-07-14','13:45:00',4.54),('325','2013-07-14','13:50:00',4.56),('325','2013-07-14','13:55:00',4.5),('325','2013-07-14','14:00:00',4.46),('325','2013-07-14','14:05:00',4.43),('325','2013-07-14','14:10:00',4.38),('325','2013-07-14','14:15:00',4.37),('325','2013-07-14','14:20:00',4.42),('325','2013-07-14','14:25:00',4.41),('325','2013-07-14','14:30:00',4.39),('325','2013-07-14','14:35:00',4.35),('325','2013-07-14','14:40:00',4.34),('325','2013-07-14','14:45:00',4.33),('325','2013-07-14','14:50:00',4.24),('325','2013-07-14','14:55:00',4.19),('325','2013-07-14','15:00:00',4.16),('325','2013-07-14','15:05:00',4.16),('325','2013-07-14','15:10:00',4.13),('325','2013-07-14','15:15:00',4.08),('325','2013-07-14','15:20:00',4),('325','2013-07-14','15:25:00',3.99),('325','2013-07-14','15:30:00',3.95),('325','2013-07-14','15:35:00',3.92),('325','2013-07-14','15:40:00',3.83),('325','2013-07-14','15:45:00',3.79),('325','2013-07-14','15:50:00',3.7),('325','2013-07-14','15:55:00',3.71),('325','2013-07-14','16:00:00',3.57),('325','2013-07-14','16:05:00',3.56),('325','2013-07-14','16:10:00',3.54),('325','2013-07-14','16:15:00',3.53),('325','2013-07-14','16:20:00',3.56),('325','2013-07-14','16:25:00',2.54),('325','2013-07-14','16:30:00',3.39),('325','2013-07-14','16:35:00',3.45),('325','2013-07-14','16:40:00',3.17),('325','2013-07-14','16:45:00',2.77),('325','2013-07-14','16:50:00',3.02),('325','2013-07-14','16:55:00',2.61),('325','2013-07-14','17:00:00',3.06),('325','2013-07-14','17:05:00',1.43),('325','2013-07-14','17:10:00',2.68),('325','2013-07-14','17:15:00',2.2),('325','2013-07-14','17:20:00',1.33),('325','2013-07-14','17:25:00',2.21),('325','2013-07-14','17:30:00',2.73),('325','2013-07-14','17:35:00',2.19),('325','2013-07-14','17:40:00',1.87),('325','2013-07-14','17:45:00',1.61),('325','2013-07-14','17:50:00',1.92),('325','2013-07-14','17:55:00',1.76),('325','2013-07-14','18:00:00',1.16),('325','2013-07-14','18:05:00',1.45),('325','2013-07-13','08:30:00',1.03),('325','2013-07-13','08:35:00',1.11),('325','2013-07-13','08:40:00',1.19),('325','2013-07-13','08:45:00',1.29),('325','2013-07-13','08:50:00',1.29),('325','2013-07-13','08:55:00',1.34),('325','2013-07-13','09:00:00',1.35),('325','2013-07-13','09:05:00',1.38),('325','2013-07-13','09:10:00',1.41),('325','2013-07-13','09:15:00',1.45),('325','2013-07-13','09:20:00',1.48),('325','2013-07-13','09:25:00',1.49),('325','2013-07-13','09:30:00',1.5),('325','2013-07-13','09:35:00',1.57),('325','2013-07-13','09:40:00',1.87),('325','2013-07-13','09:45:00',2.48),('325','2013-07-13','09:50:00',2.58),('325','2013-07-13','09:55:00',2.66),('325','2013-07-13','10:00:00',2.76),('325','2013-07-13','10:05:00',2.82),('325','2013-07-13','10:10:00',2.92),('325','2013-07-13','10:15:00',3.03),('325','2013-07-13','10:20:00',3.05),('325','2013-07-13','10:25:00',2.1),('325','2013-07-13','10:30:00',3.31),('325','2013-07-13','10:35:00',3.38),('325','2013-07-13','10:40:00',3.41),('325','2013-07-13','10:45:00',3),('325','2013-07-13','10:50:00',3.67),('325','2013-07-13','10:55:00',3.84),('325','2013-07-13','11:00:00',3.4),('325','2013-07-13','11:05:00',2.85),('325','2013-07-13','11:10:00',4.04),('325','2013-07-13','11:15:00',2.96),('325','2013-07-13','11:20:00',1.48),('325','2013-07-13','11:25:00',2.67),('325','2013-07-13','11:30:00',4.44),('325','2013-07-13','11:35:00',3.84),('325','2013-07-13','11:40:00',1.04),('325','2013-07-13','11:45:00',2.08),('325','2013-07-13','11:50:00',4.65),('325','2013-07-13','11:55:00',2.09),('325','2013-07-13','12:00:00',3.4),('325','2013-07-13','12:05:00',4.65),('325','2013-07-13','12:10:00',4.61),('325','2013-07-13','12:15:00',4.6),('325','2013-07-13','12:20:00',4.44),('325','2013-07-13','12:25:00',3.5),('325','2013-07-13','12:30:00',2.96),('325','2013-07-13','12:35:00',4.13),('325','2013-07-13','12:40:00',3.52),('325','2013-07-13','12:45:00',3.09),('325','2013-07-13','12:50:00',2.55),('325','2013-07-13','12:55:00',4.48),('325','2013-07-13','13:00:00',4.75),('325','2013-07-13','13:05:00',4.07),('325','2013-07-13','13:10:00',4.13),('325','2013-07-13','13:15:00',4.51),('325','2013-07-13','13:20:00',4.57),('325','2013-07-13','13:25:00',4.49),('325','2013-07-13','13:30:00',4.52),('325','2013-07-13','13:35:00',4.56),('325','2013-07-13','13:40:00',4.5),('325','2013-07-13','13:45:00',4.5),('325','2013-07-13','13:50:00',4.47),('325','2013-07-13','13:55:00',4.37),('325','2013-07-13','14:00:00',4.31),('325','2013-07-13','14:05:00',4.28),('325','2013-07-13','14:10:00',4.21),('325','2013-07-13','14:15:00',4.13),('325','2013-07-13','14:20:00',4.12),('325','2013-07-13','14:25:00',4.08),('325','2013-07-13','14:30:00',4.03),('325','2013-07-13','14:35:00',4.26),('325','2013-07-13','14:40:00',4.3),('325','2013-07-13','14:45:00',4.31),('325','2013-07-13','14:50:00',4.3),('325','2013-07-13','14:55:00',4.25),('325','2013-07-13','15:00:00',4.25),('325','2013-07-13','15:05:00',4.26),('325','2013-07-13','15:10:00',4.23),('325','2013-07-13','15:15:00',4.22),('325','2013-07-13','15:20:00',3.99),('325','2013-07-13','15:25:00',4.15),('325','2013-07-13','15:30:00',4.02),('325','2013-07-13','15:35:00',4.07),('325','2013-07-13','15:40:00',4),('325','2013-07-13','15:45:00',3.92),('325','2013-07-13','15:50:00',3.87),('325','2013-07-13','15:55:00',3.83),('325','2013-07-13','16:00:00',3.77),('325','2013-07-13','16:05:00',3.72),('325','2013-07-13','16:10:00',3.65),('325','2013-07-13','16:15:00',3.6),('325','2013-07-13','16:20:00',3.56),('325','2013-07-13','16:25:00',3.53),('325','2013-07-13','16:30:00',3.45),('325','2013-07-13','16:35:00',3.4),('325','2013-07-13','16:40:00',3.3),('325','2013-07-13','16:45:00',3.2),('325','2013-07-13','16:50:00',3.13),('325','2013-07-13','16:55:00',3.06),('325','2013-07-13','17:00:00',2.95),('325','2013-07-13','17:05:00',2.79),('325','2013-07-13','17:10:00',2.74),('325','2013-07-13','17:15:00',2.69),('325','2013-07-13','17:20:00',2.51),('325','2013-07-13','17:25:00',2.55),('325','2013-07-13','17:30:00',2.38),('325','2013-07-13','17:35:00',2.29),('325','2013-07-13','17:40:00',2.25),('325','2013-07-13','17:45:00',2.18),('325','2013-07-13','17:50:00',2.04),('325','2013-07-13','17:55:00',2.02),('325','2013-07-13','18:00:00',1.8),('325','2013-07-13','18:05:00',1.68),('325','2013-07-13','18:10:00',1.68),('325','2013-07-13','18:15:00',1.59),('325','2013-07-13','18:20:00',1.48),('325','2013-07-13','18:25:00',1.33),('325','2013-07-13','18:30:00',1.16),('325','2013-07-13','18:35:00',1.03),('325','2013-07-12','08:10:00',1.03),('325','2013-07-12','08:15:00',1.03),('325','2013-07-12','08:45:00',1.04),('325','2013-07-12','09:10:00',1.34),('325','2013-07-12','09:15:00',1.58),('325','2013-07-12','09:20:00',2.23),('325','2013-07-12','09:25:00',2.02),('325','2013-07-12','09:30:00',1.41),('325','2013-07-12','09:35:00',1.96),('325','2013-07-12','09:40:00',2.06),('325','2013-07-12','09:45:00',2.57),('325','2013-07-12','09:50:00',2.68),('325','2013-07-12','09:55:00',2.73),('325','2013-07-12','10:00:00',2.83),('325','2013-07-12','10:05:00',3.04),('325','2013-07-12','10:10:00',2.97),('325','2013-07-12','10:15:00',3.21),('325','2013-07-12','10:20:00',3.15),('325','2013-07-12','10:25:00',1.67),('325','2013-07-12','10:40:00',1.3),('325','2013-07-12','10:45:00',1.83),('325','2013-07-12','10:50:00',3.51),('325','2013-07-12','10:55:00',3.32),('325','2013-07-12','11:00:00',1.39),('325','2013-07-12','11:05:00',1.2),('325','2013-07-12','11:10:00',1.39),('325','2013-07-12','11:15:00',4.24),('325','2013-07-12','11:20:00',4.38),('325','2013-07-12','11:25:00',2.36),('325','2013-07-12','11:30:00',3.23),('325','2013-07-12','11:35:00',3.4),('325','2013-07-12','11:40:00',4.45),('325','2013-07-12','11:45:00',1.59),('325','2013-07-12','11:50:00',3.67),('325','2013-07-12','11:55:00',4.34),('325','2013-07-12','12:00:00',4.66),('325','2013-07-12','12:05:00',3.84),('325','2013-07-12','12:10:00',4.37),('325','2013-07-12','12:15:00',3.44),('325','2013-07-12','12:20:00',3.51),('325','2013-07-12','12:25:00',4.71),('325','2013-07-12','12:30:00',4.84),('325','2013-07-12','12:35:00',3.15),('325','2013-07-12','12:40:00',4.71),('325','2013-07-12','12:45:00',4.23),('325','2013-07-12','12:50:00',2.53),('325','2013-07-12','12:55:00',4.32),('325','2013-07-12','13:00:00',4.52),('325','2013-07-12','13:05:00',4.67),('325','2013-07-12','13:10:00',4.7),('325','2013-07-12','13:15:00',4.62),('325','2013-07-12','13:20:00',4.59),('325','2013-07-12','13:25:00',4.64),('325','2013-07-12','13:30:00',4.57),('325','2013-07-12','13:35:00',4.61),('325','2013-07-12','13:40:00',4.01),('325','2013-07-12','13:45:00',3.94),('325','2013-07-12','13:50:00',4.69),('325','2013-07-12','13:55:00',4.45),('325','2013-07-12','14:00:00',3.98),('325','2013-07-12','14:05:00',2.8),('325','2013-07-12','14:10:00',3.64),('325','2013-07-12','14:15:00',4.77),('325','2013-07-12','14:20:00',4.47),('325','2013-07-12','14:25:00',4.59),('325','2013-07-12','14:30:00',4.54),('325','2013-07-12','14:35:00',4.33),('325','2013-07-12','14:40:00',4.23),('325','2013-07-12','14:45:00',4.29),('325','2013-07-12','14:50:00',4.23),('325','2013-07-12','14:55:00',4.19),('325','2013-07-12','15:00:00',4.2),('325','2013-07-12','15:05:00',4.19),('325','2013-07-12','15:10:00',3.86),('325','2013-07-12','15:15:00',4.06),('325','2013-07-12','15:20:00',4.06),('325','2013-07-12','15:25:00',4.03),('325','2013-07-12','15:30:00',3.96),('325','2013-07-12','15:35:00',3.9),('325','2013-07-12','15:40:00',3.8),('325','2013-07-12','15:45:00',3.8),('325','2013-07-12','15:50:00',3.74),('325','2013-07-12','15:55:00',3.71),('325','2013-07-12','16:00:00',3.64),('325','2013-07-12','16:05:00',3.57),('325','2013-07-12','16:10:00',3.52),('325','2013-07-12','16:15:00',3.47),('325','2013-07-12','16:20:00',3.39),('325','2013-07-12','16:25:00',3.35),('325','2013-07-12','16:30:00',3.3),('325','2013-07-12','16:35:00',3.25),('325','2013-07-12','16:40:00',3.2),('325','2013-07-12','16:45:00',3.14),('325','2013-07-12','16:50:00',3.04),('325','2013-07-12','16:55:00',2.96),('325','2013-07-12','17:00:00',2.84),('325','2013-07-12','17:05:00',2.74),('325','2013-07-12','17:10:00',2.6),('325','2013-07-12','17:15:00',2.56),('325','2013-07-12','17:20:00',2.46),('325','2013-07-12','17:25:00',2.39),('325','2013-07-12','17:30:00',2.31),('325','2013-07-12','17:35:00',2.24),('325','2013-07-12','17:40:00',2.14),('325','2013-07-12','17:45:00',2.05),('325','2013-07-12','17:50:00',1.98),('325','2013-07-12','17:55:00',1.86),('325','2013-07-12','18:00:00',1.76),('325','2013-07-12','18:05:00',1.68),('325','2013-07-12','18:10:00',1.6),('325','2013-07-12','18:15:00',1.51),('325','2013-07-12','18:20:00',1.32),('325','2013-07-12','18:25:00',1.25),('325','2013-07-12','18:30:00',1.12),('325','2013-07-12','18:35:00',1.01),('325','2013-07-11','08:30:00',1.03),('325','2013-07-11','08:35:00',1.12),('325','2013-07-11','08:40:00',1.19),('325','2013-07-11','08:45:00',1.28),('325','2013-07-11','08:50:00',1.29),('325','2013-07-11','08:55:00',1.34),('325','2013-07-11','09:00:00',1.36),('325','2013-07-11','09:05:00',1.36),('325','2013-07-11','09:10:00',1.41),('325','2013-07-11','09:15:00',1.58),('325','2013-07-11','09:20:00',1.56),('325','2013-07-11','09:25:00',1.29),('325','2013-07-11','09:30:00',2.02),('325','2013-07-11','09:35:00',2.35),('325','2013-07-11','09:40:00',2.67),('325','2013-07-11','09:45:00',2.58),('325','2013-07-11','09:50:00',1.92),('325','2013-07-11','09:55:00',1.5),('325','2013-07-11','10:00:00',1.49),('325','2013-07-11','10:05:00',2.21),('325','2013-07-11','10:10:00',3.31),('325','2013-07-11','10:15:00',3.33),('325','2013-07-11','10:20:00',3.63),('325','2013-07-11','10:25:00',3.34),('325','2013-07-11','10:30:00',2.24),('325','2013-07-11','10:35:00',1.26),('325','2013-07-11','10:40:00',2.58),('325','2013-07-11','10:45:00',3.73),('325','2013-07-11','10:50:00',3.73),('325','2013-07-11','10:55:00',3.94),('325','2013-07-11','11:00:00',3.94),('325','2013-07-11','11:05:00',2.7),('325','2013-07-11','11:10:00',3.88),('325','2013-07-11','11:15:00',3.61),('325','2013-07-11','11:20:00',3.3),('325','2013-07-11','11:25:00',2.18),('325','2013-07-11','11:30:00',2.34),('325','2013-07-11','11:35:00',4.23),('325','2013-07-11','11:40:00',4.5),('325','2013-07-11','11:45:00',2.21),('325','2013-07-11','11:50:00',4.64),('325','2013-07-11','11:55:00',4.61),('325','2013-07-11','12:00:00',2.02),('325','2013-07-11','12:05:00',2.72),('325','2013-07-11','12:10:00',1.72),('325','2013-07-11','12:15:00',4.76),('325','2013-07-11','12:20:00',4.72),('325','2013-07-11','12:25:00',4.78),('325','2013-07-11','12:30:00',4.66),('325','2013-07-11','12:35:00',4.59),('325','2013-07-11','12:40:00',4.65),('325','2013-07-11','12:45:00',4.46),('325','2013-07-11','12:50:00',3.25),('325','2013-07-11','12:55:00',3.78),('325','2013-07-11','13:00:00',4.71),('325','2013-07-11','13:05:00',4.76),('325','2013-07-11','13:10:00',4.14),('325','2013-07-11','13:15:00',4.63),('325','2013-07-11','13:20:00',4.48),('325','2013-07-11','13:25:00',4.3),('325','2013-07-11','13:30:00',4.26),('325','2013-07-11','13:35:00',3.1),('325','2013-07-11','13:40:00',3.74),('325','2013-07-11','13:45:00',4.22),('325','2013-07-11','13:50:00',3.54),('325','2013-07-11','13:55:00',4.29),('325','2013-07-11','14:00:00',4.52),('325','2013-07-11','14:05:00',4.54),('325','2013-07-11','14:10:00',4.3),('325','2013-07-11','14:15:00',4.18),('325','2013-07-11','14:20:00',4.51),('325','2013-07-11','14:25:00',4.47),('325','2013-07-11','14:30:00',4.23),('325','2013-07-11','14:35:00',4.45),('325','2013-07-11','14:40:00',4.29),('325','2013-07-11','14:45:00',4.46),('325','2013-07-11','14:50:00',4.44),('325','2013-07-11','14:55:00',4.5),('325','2013-07-11','15:00:00',3.82),('325','2013-07-11','15:05:00',4),('325','2013-07-11','15:10:00',3.65),('325','2013-07-11','15:15:00',2.42),('325','2013-07-11','15:20:00',3.1),('325','2013-07-11','15:25:00',4.34),('325','2013-07-11','15:30:00',4.11),('325','2013-07-11','15:35:00',3.01),('325','2013-07-11','15:40:00',4.01),('325','2013-07-11','15:45:00',3.93),('325','2013-07-11','15:50:00',2.24),('325','2013-07-11','15:55:00',2.82),('325','2013-07-11','16:00:00',2.92),('325','2013-07-11','16:05:00',2.97),('325','2013-07-11','16:10:00',1.93),('325','2013-07-11','16:15:00',1.76),('325','2013-07-11','16:20:00',3.06),('325','2013-07-11','16:25:00',2.92),('325','2013-07-11','16:30:00',3.39),('325','2013-07-11','16:35:00',1.34),('325','2013-07-11','16:40:00',3.33),('325','2013-07-11','16:45:00',3.53),('325','2013-07-11','16:50:00',2.84),('325','2013-07-11','16:55:00',2.75),('325','2013-07-11','17:00:00',1.85),('325','2013-07-11','17:05:00',2.65),('325','2013-07-11','17:10:00',2.23),('325','2013-07-11','17:15:00',2.23),('325','2013-07-11','17:20:00',2.06),('325','2013-07-11','17:25:00',2.64),('325','2013-07-11','17:30:00',2.6),('325','2013-07-11','17:35:00',2.46),('325','2013-07-11','17:40:00',2.25),('325','2013-07-11','17:45:00',1.77),('325','2013-07-11','17:50:00',2.06),('325','2013-07-11','17:55:00',1.91),('325','2013-07-11','18:00:00',1.74),('325','2013-07-11','18:05:00',1.55),('325','2013-07-11','18:10:00',1.74),('325','2013-07-11','18:15:00',1.67),('325','2013-07-11','18:20:00',1.29),('325','2013-07-11','18:25:00',1.24),('325','2013-07-11','18:30:00',1.15),('325','2013-07-10','07:40:00',1.02),('325','2013-07-10','07:45:00',1.11),('325','2013-07-10','07:50:00',1.16),('325','2013-07-10','07:55:00',1.22),('325','2013-07-10','08:00:00',1.14),('325','2013-07-10','08:05:00',1.14),('325','2013-07-10','08:10:00',1.31),('325','2013-07-10','08:15:00',1.33),('325','2013-07-10','08:20:00',1.38),('325','2013-07-10','08:25:00',1.33),('325','2013-07-10','08:30:00',1.32),('325','2013-07-10','08:35:00',1.47),('325','2013-07-10','08:40:00',1.51),('325','2013-07-10','08:45:00',1.48),('325','2013-07-10','08:50:00',1.44),('325','2013-07-10','08:55:00',1.37),('325','2013-07-10','09:00:00',1.37),('325','2013-07-10','09:05:00',1.49),('325','2013-07-10','09:10:00',1.56),('325','2013-07-10','09:15:00',1.88),('325','2013-07-10','09:20:00',1.84),('325','2013-07-10','09:25:00',1.48),('325','2013-07-10','09:30:00',2.2),('325','2013-07-10','09:35:00',2.44),('325','2013-07-10','09:40:00',2.5),('325','2013-07-10','09:45:00',2.58),('325','2013-07-10','09:50:00',2.61),('325','2013-07-10','09:55:00',2.1),('325','2013-07-10','10:00:00',2.78),('325','2013-07-10','10:05:00',2.84),('325','2013-07-10','10:10:00',2.91),('325','2013-07-10','10:15:00',3.02),('325','2013-07-10','10:20:00',3.07),('325','2013-07-10','10:25:00',3.08),('325','2013-07-10','10:30:00',3.07),('325','2013-07-10','10:35:00',3.13),('325','2013-07-10','10:40:00',3.2),('325','2013-07-10','10:45:00',3.33),('325','2013-07-10','10:50:00',3.39),('325','2013-07-10','10:55:00',3.38),('325','2013-07-10','11:00:00',3.44),('325','2013-07-10','11:05:00',3.51),('325','2013-07-10','11:10:00',3.54),('325','2013-07-10','11:15:00',3.64),('325','2013-07-10','11:20:00',3.75),('325','2013-07-10','11:25:00',3.81),('325','2013-07-10','11:30:00',3.76),('325','2013-07-10','11:35:00',3.79),('325','2013-07-10','11:40:00',3.81),('325','2013-07-10','11:45:00',3.82),('325','2013-07-10','11:50:00',3.85),('325','2013-07-10','11:55:00',3.92),('325','2013-07-10','12:00:00',3.97),('325','2013-07-10','12:05:00',4.09),('325','2013-07-10','12:10:00',4.17),('325','2013-07-10','12:15:00',4.23),('325','2013-07-10','12:20:00',4.23),('325','2013-07-10','12:25:00',4.26),('325','2013-07-10','12:30:00',4.2),('325','2013-07-10','12:35:00',4.2),('325','2013-07-10','12:40:00',4.16),('325','2013-07-10','12:45:00',4.13),('325','2013-07-10','12:50:00',4.26),('325','2013-07-10','12:55:00',4.44),('325','2013-07-10','13:00:00',4.46),('325','2013-07-10','13:05:00',4.51),('325','2013-07-10','13:10:00',4.49),('325','2013-07-10','13:15:00',4.47),('325','2013-07-10','13:20:00',4.46),('325','2013-07-10','13:25:00',4.51),('325','2013-07-10','13:30:00',4.5),('325','2013-07-10','13:35:00',4.5),('325','2013-07-10','13:40:00',4.52),('325','2013-07-10','13:45:00',4.52),('325','2013-07-10','13:50:00',4.43),('325','2013-07-10','13:55:00',4.38),('325','2013-07-10','14:00:00',4.33),('325','2013-07-10','14:05:00',4.31),('325','2013-07-10','14:10:00',4.26),('325','2013-07-10','14:15:00',4.2),('325','2013-07-10','14:20:00',4.17),('325','2013-07-10','14:25:00',4.31),('325','2013-07-10','14:30:00',4.36),('325','2013-07-10','14:35:00',4.35),('325','2013-07-10','14:40:00',4.35),('325','2013-07-10','14:45:00',4.31),('325','2013-07-10','14:50:00',4.29),('325','2013-07-10','14:55:00',4.29),('325','2013-07-10','15:00:00',4.27),('325','2013-07-10','15:05:00',4.24),('325','2013-07-10','15:10:00',4.19),('325','2013-07-10','15:15:00',4.14),('325','2013-07-10','15:20:00',4.1),('325','2013-07-10','15:25:00',4.07),('325','2013-07-10','15:30:00',4.05),('325','2013-07-10','15:35:00',4),('325','2013-07-10','15:40:00',3.07),('325','2013-07-10','15:45:00',3.77),('325','2013-07-10','15:50:00',3.72),('325','2013-07-10','15:55:00',3.72),('325','2013-07-10','16:00:00',3.68),('325','2013-07-10','16:05:00',3.63),('325','2013-07-10','16:10:00',3.58),('325','2013-07-10','16:15:00',3.53),('325','2013-07-10','16:20:00',3.49),('325','2013-07-10','16:25:00',3.4),('325','2013-07-10','16:30:00',3.35),('325','2013-07-10','16:35:00',3.24),('325','2013-07-10','16:40:00',3.18),('325','2013-07-10','16:45:00',3.13),('325','2013-07-10','16:50:00',3.08),('325','2013-07-10','16:55:00',3.03),('325','2013-07-10','17:00:00',3.05),('325','2013-07-10','17:05:00',2.37),('325','2013-07-10','17:10:00',2.19),('325','2013-07-10','17:15:00',1.53),('325','2013-07-10','17:20:00',1.7),('325','2013-07-10','17:35:00',1.48),('325','2013-07-10','17:40:00',1.45),('325','2013-07-10','17:45:00',1.94),('325','2013-07-10','17:50:00',2.06),('325','2013-07-10','17:55:00',1.89),('325','2013-07-10','18:00:00',1.88),('325','2013-07-10','18:05:00',1.71),('325','2013-07-10','18:20:00',1.19),('325','2014-05-02','08:15:00',1.79),('325','2014-05-02','08:20:00',1.6),('325','2014-05-02','08:45:00',1.32),('325','2014-05-02','08:50:00',1.24),('325','2014-05-02','09:15:00',1.3),('325','2014-05-02','09:20:00',1.55),('325','2014-05-02','09:25:00',1.77),('325','2014-05-02','09:30:00',1.93),('325','2014-05-02','09:35:00',1.92),('325','2014-05-02','09:40:00',1.8),('325','2014-05-02','09:45:00',1.67),('325','2014-05-02','09:50:00',1.58),('325','2014-05-02','09:55:00',1.57),('325','2014-05-02','10:00:00',1.92),('325','2014-05-02','10:05:00',2.14),('325','2014-05-02','10:10:00',1.71),('325','2014-05-02','10:15:00',1.6),('325','2014-05-02','10:20:00',1.51),('325','2014-05-02','10:25:00',1.31),('325','2014-05-02','10:40:00',1.1),('325','2014-05-02','10:45:00',1.4),('325','2014-05-02','10:50:00',1.09),('325','2014-05-02','12:30:00',1.09),('325','2014-05-02','12:35:00',1.17),('325','2014-05-02','12:40:00',1.24),('325','2014-05-02','12:45:00',1.7),('325','2014-05-02','12:50:00',1.99),('325','2014-05-02','12:55:00',1.44),('325','2014-05-02','13:00:00',1.68),('325','2014-05-02','13:05:00',1.91),('325','2014-05-02','13:10:00',1.9),('325','2014-05-02','13:15:00',2.71),('325','2014-05-02','13:20:00',3.57),('325','2014-05-02','13:25:00',3.99),('325','2014-05-02','13:30:00',3.38),('325','2014-05-02','13:35:00',3.45),('325','2014-05-02','13:40:00',2.83),('325','2014-05-02','13:45:00',2.17),('325','2014-05-02','13:50:00',1.91),('325','2014-05-02','13:55:00',1.41),('325','2014-05-02','14:00:00',1.48),('325','2014-05-02','14:05:00',2.84),('325','2014-05-02','14:30:00',1.16),('325','2014-05-02','14:35:00',1.84),('325','2014-05-02','14:40:00',3.24),('325','2014-05-02','14:45:00',1.64),('325','2014-05-02','14:50:00',1.51),('325','2014-05-02','14:55:00',2.17),('325','2014-05-02','15:00:00',2.43),('325','2014-05-02','15:05:00',2.24),('325','2014-05-02','15:10:00',4.86),('325','2014-05-02','15:15:00',3.41),('325','2014-05-02','15:20:00',3.07),('325','2014-05-02','15:25:00',1.56),('325','2014-05-02','15:30:00',1.41),('325','2014-05-02','15:35:00',2.69),('325','2014-05-02','15:40:00',3.56),('325','2014-05-02','15:45:00',1.25),('325','2014-05-02','16:00:00',1.68),('325','2014-05-02','16:05:00',1.81),('325','2014-05-02','16:10:00',1.08),('325','2014-05-02','16:15:00',1.25),('325','2014-05-02','16:20:00',2.06),('325','2014-05-02','17:15:00',1.01),('325','2014-05-02','17:20:00',1.06),('325','2014-05-02','17:25:00',1.25),('325','2014-04-05','09:15:00',1.04),('325','2014-04-05','09:20:00',1.5),('325','2014-04-05','09:25:00',1.71),('325','2014-04-05','09:30:00',2.75),('325','2014-04-05','09:35:00',2.84),('325','2014-04-05','09:40:00',2.82),('325','2014-04-05','09:45:00',2.57),('325','2014-04-05','09:50:00',1.7),('325','2014-04-05','09:55:00',1.5),('325','2014-04-05','10:00:00',1.9),('325','2014-04-05','10:05:00',1.91),('325','2014-04-05','10:10:00',2.08),('325','2014-04-05','10:15:00',1.69),('325','2014-04-05','10:20:00',2.12),('325','2014-04-05','10:25:00',3.04),('325','2014-04-05','10:30:00',2.63),('325','2014-04-05','10:35:00',2.82),('325','2014-04-05','10:40:00',2.8),('325','2014-04-05','10:45:00',3.49),('325','2014-04-05','10:50:00',2.93),('325','2014-04-05','10:55:00',2.91),('325','2014-04-05','11:00:00',3.45),('325','2014-04-05','11:05:00',3.63),('325','2014-04-05','11:10:00',3.88),('325','2014-04-05','11:15:00',4.17),('325','2014-04-05','11:20:00',4.49),('325','2014-04-05','11:25:00',3.79),('325','2014-04-05','11:30:00',2.98),('325','2014-04-05','11:35:00',2.34),('325','2014-04-05','11:40:00',2.76),('325','2014-04-05','11:45:00',3.93),('325','2014-04-05','11:50:00',4.25),('325','2014-04-05','11:55:00',3.93),('325','2014-04-05','12:00:00',4.52),('325','2014-04-05','12:05:00',3.53),('325','2014-04-05','12:10:00',3.34),('325','2014-04-05','12:15:00',3.75),('325','2014-04-05','12:20:00',3.09),('325','2014-04-05','12:25:00',4.06),('325','2014-04-05','12:30:00',3.37),('325','2014-04-05','12:35:00',2.5),('325','2014-04-05','12:40:00',2.96),('325','2014-04-05','12:45:00',4.26),('325','2014-04-05','12:50:00',4.48),('325','2014-04-05','12:55:00',4.91),('325','2014-04-05','13:00:00',3.85),('325','2014-04-05','13:05:00',3.11),('325','2014-04-05','13:10:00',2.42),('325','2014-04-05','13:15:00',2.36),('325','2014-04-05','13:20:00',2.76),('325','2014-04-05','13:25:00',4.89),('325','2014-04-05','13:30:00',4.28),('325','2014-04-05','13:35:00',4.37),('325','2014-04-05','13:40:00',3.91),('325','2014-04-05','13:45:00',4.75),('325','2014-04-05','13:50:00',5.08),('325','2014-04-05','13:55:00',4.15),('325','2014-04-05','14:00:00',3.71),('325','2014-04-05','14:05:00',5.28),('325','2014-04-05','14:10:00',3.69),('325','2014-04-05','14:25:00',1.06),('325','2014-04-05','14:30:00',1.51),('325','2014-04-05','14:35:00',1.11),('325','2014-04-05','14:55:00',4.6),('325','2014-04-05','15:00:00',4.62),('325','2014-04-05','15:05:00',4.54),('325','2014-04-05','15:10:00',3.6),('325','2014-04-05','15:15:00',2.41),('325','2014-04-05','15:20:00',3.78),('325','2014-04-05','15:25:00',3.1),('325','2014-04-05','15:30:00',1.88),('325','2014-04-05','15:35:00',1.53),('325','2014-04-05','15:40:00',1.99),('325','2014-04-05','15:45:00',2.42),('325','2014-04-05','15:50:00',2.88),('325','2014-04-05','15:55:00',1.43),('325','2014-04-05','16:00:00',1.26),('325','2014-04-05','16:05:00',1.29),('325','2014-04-05','16:10:00',1.25),('325','2014-04-05','16:15:00',1.71),('325','2014-04-05','16:20:00',4.32),('325','2014-04-05','16:25:00',3.78),('325','2014-04-05','16:30:00',2.24),('325','2014-04-05','16:35:00',3.11),('325','2014-04-05','16:40:00',1.63),('325','2014-04-05','16:45:00',2.26),('325','2014-04-05','16:50:00',1.6),('325','2014-04-05','16:55:00',2.81),('325','2014-04-05','17:00:00',1.79),('325','2014-04-05','17:05:00',2.24),('325','2014-04-05','17:10:00',1.86),('325','2014-04-05','17:20:00',1.35),('325','2014-04-05','17:25:00',1.28),('325','2014-04-05','17:30:00',1.39),('325','2014-04-05','17:35:00',1.16),('325','2013-07-09','08:25:00',1.04),('325','2013-07-09','08:30:00',1.11),('325','2013-07-09','08:35:00',1.16),('325','2013-07-09','08:40:00',1.22),('325','2013-07-09','08:45:00',1.27),('325','2013-07-09','08:50:00',1.31),('325','2013-07-09','08:55:00',1.34),('325','2013-07-09','09:00:00',1.37),('325','2013-07-09','09:05:00',1.41),('325','2013-07-09','09:10:00',1.45),('325','2013-07-09','09:15:00',1.5),('325','2013-07-09','09:20:00',1.54),('325','2013-07-09','09:25:00',1.6),('325','2013-07-09','09:30:00',1.65),('325','2013-07-09','09:35:00',1.66),('325','2013-07-09','09:40:00',2.23),('325','2013-07-09','09:45:00',2.6),('325','2013-07-09','09:50:00',2.69),('325','2013-07-09','09:55:00',2.76),('325','2013-07-09','10:00:00',2.66),('325','2013-07-09','10:05:00',2.66),('325','2013-07-09','10:10:00',2.9),('325','2013-07-09','10:15:00',2.99),('325','2013-07-09','10:20:00',3.02),('325','2013-07-09','10:25:00',3.02),('325','2013-07-09','10:30:00',3.03),('325','2013-07-09','10:35:00',3.1),('325','2013-07-09','10:40:00',3.17),('325','2013-07-09','10:45:00',3.32),('325','2013-07-09','10:50:00',3.37),('325','2013-07-09','10:55:00',3.4),('325','2013-07-09','11:00:00',3.46),('325','2013-07-09','11:05:00',3.53),('325','2013-07-09','11:10:00',3.58),('325','2013-07-09','11:15:00',3.61),('325','2013-07-09','11:20:00',3.59),('325','2013-07-09','11:25:00',3.37),('325','2013-07-09','11:30:00',2.51),('325','2013-07-09','11:35:00',2.66),('325','2013-07-09','11:40:00',3.35),('325','2013-07-09','11:45:00',4.05),('325','2013-07-09','11:50:00',4.52),('325','2013-07-09','11:55:00',4.45),('325','2013-07-09','12:00:00',4.46),('325','2013-07-09','12:05:00',4.46),('325','2013-07-09','12:10:00',4.4),('325','2013-07-09','12:15:00',4.38),('325','2013-07-09','12:20:00',4.3),('325','2013-07-09','12:25:00',4.21),('325','2013-07-09','12:30:00',4.15),('325','2013-07-09','12:35:00',4.15),('325','2013-07-09','12:40:00',4.17),('325','2013-07-09','12:45:00',4.18),('325','2013-07-09','12:50:00',4.15),('325','2013-07-09','12:55:00',4.23),('325','2013-07-09','13:00:00',4.32),('325','2013-07-09','13:05:00',4.45),('325','2013-07-09','13:10:00',4.52),('325','2013-07-09','13:15:00',4.41),('325','2013-07-09','13:20:00',4.3),('325','2013-07-09','13:25:00',4.32),('325','2013-07-09','13:30:00',4.6),('325','2013-07-09','13:35:00',4.48),('325','2013-07-09','13:40:00',4.51),('325','2013-07-09','13:45:00',4),('325','2013-07-09','13:50:00',3.35),('325','2013-07-09','13:55:00',3.62),('325','2013-07-09','14:00:00',3.63),('325','2013-07-09','14:05:00',3.41),('325','2013-07-09','14:10:00',3.71),('325','2013-07-09','14:15:00',3.81),('325','2013-07-09','14:20:00',2.91),('325','2013-07-09','14:25:00',2.81),('325','2013-07-09','14:30:00',1.89),('325','2013-07-09','14:35:00',1.14),('325','2013-07-09','14:40:00',1.01),('325','2013-07-08','08:25:00',1.05),('325','2013-07-08','08:30:00',1.13),('325','2013-07-08','08:35:00',1.18),('325','2013-07-08','08:40:00',1.24),('325','2013-07-08','08:45:00',1.29),('325','2013-07-08','08:50:00',1.33),('325','2013-07-08','08:55:00',1.34),('325','2013-07-08','09:00:00',1.35),('325','2013-07-08','09:05:00',1.37),('325','2013-07-08','09:10:00',1.41),('325','2013-07-08','09:15:00',1.43),('325','2013-07-08','09:20:00',1.47),('325','2013-07-08','09:25:00',1.47),('325','2013-07-08','09:30:00',1.52),('325','2013-07-08','09:35:00',1.62),('325','2013-07-08','09:40:00',2.19),('325','2013-07-08','09:45:00',2.6),('325','2013-07-08','09:50:00',2.66),('325','2013-07-08','09:55:00',2.68),('325','2013-07-08','10:00:00',2.75),('325','2013-07-08','10:05:00',2.85),('325','2013-07-08','10:10:00',2.9),('325','2013-07-08','10:15:00',3.01),('325','2013-07-08','10:20:00',3.07),('325','2013-07-08','10:25:00',3.07),('325','2013-07-08','10:30:00',3.05),('325','2013-07-08','10:35:00',3.15),('325','2013-07-08','10:40:00',3.19),('325','2013-07-08','10:45:00',3.32),('325','2013-07-08','10:50:00',3.36),('325','2013-07-08','10:55:00',3.37),('325','2013-07-08','11:00:00',3.4),('325','2013-07-08','11:05:00',3.48),('325','2013-07-08','11:10:00',3.82),('325','2013-07-08','11:15:00',3.92),('325','2013-07-08','11:20:00',3.97),('325','2013-07-08','11:25:00',4.04),('325','2013-07-08','11:30:00',4.09),('325','2013-07-08','11:35:00',4.12),('325','2013-07-08','11:40:00',3.94),('325','2013-07-08','11:45:00',4.1),('325','2013-07-08','11:50:00',4.22),('325','2013-07-08','11:55:00',4.21),('325','2013-07-08','12:00:00',4.21),('325','2013-07-08','12:05:00',4.29),('325','2013-07-08','12:10:00',4.41),('325','2013-07-08','12:15:00',4.52),('325','2013-07-08','12:20:00',4.53),('325','2013-07-08','12:25:00',4.49),('325','2013-07-08','12:30:00',3.92),('325','2013-07-08','12:35:00',4.39),('325','2013-07-08','12:40:00',4.39),('325','2013-07-08','12:45:00',4.35),('325','2013-07-08','12:50:00',4.39),('325','2013-07-08','12:55:00',4.46),('325','2013-07-08','13:00:00',4.57),('325','2013-07-08','13:05:00',4.5),('325','2013-07-08','13:10:00',3.58),('325','2013-07-08','13:15:00',4.62),('325','2013-07-08','13:20:00',2.93),('325','2013-07-08','13:25:00',1.32),('325','2013-07-08','14:35:00',1.15),('325','2013-07-08','14:40:00',1.22),('325','2013-07-08','14:45:00',1.16),('325','2013-07-08','14:50:00',1.11),('325','2013-07-08','14:55:00',1.09),('325','2013-07-08','15:00:00',1.01),('325','2013-07-08','17:35:00',1.02),('325','2013-07-08','17:40:00',1.06),('325','2013-07-08','17:45:00',1.07),('325','2013-07-08','17:50:00',1.09),('325','2013-07-08','17:55:00',1.07),('325','2013-07-08','18:40:00',1.14),('325','2013-07-08','18:45:00',1.07),('325','2013-07-07','08:30:00',1.01),('325','2013-07-07','08:35:00',1.21),('325','2013-07-07','08:50:00',1.04),('325','2013-07-07','08:55:00',1.44),('325','2013-07-07','09:00:00',1.45),('325','2013-07-07','09:05:00',1.3),('325','2013-07-07','09:10:00',1.38),('325','2013-07-07','09:15:00',1.53),('325','2013-07-07','09:20:00',1.43),('325','2013-07-07','09:25:00',1.76),('325','2013-07-07','09:30:00',2.4),('325','2013-07-07','09:35:00',2.53),('325','2013-07-07','09:40:00',2.51),('325','2013-07-07','09:45:00',2.71),('325','2013-07-07','09:50:00',2.83),('325','2013-07-07','09:55:00',2.94),('325','2013-07-07','10:00:00',2.98),('325','2013-07-07','10:05:00',2.79),('325','2013-07-07','10:10:00',2.88),('325','2013-07-07','10:15:00',2.94),('325','2013-07-07','10:20:00',2.87),('325','2013-07-07','10:25:00',3.15),('325','2013-07-07','10:30:00',2.72),('325','2013-07-07','10:35:00',3.33),('325','2013-07-07','10:40:00',3.27),('325','2013-07-07','10:45:00',3.38),('325','2013-07-07','10:50:00',3.54),('325','2013-07-07','10:55:00',3.5),('325','2013-07-07','11:00:00',3.56),('325','2013-07-07','11:05:00',3.6),('325','2013-07-07','11:10:00',3.7),('325','2013-07-07','11:15:00',3.8),('325','2013-07-07','11:20:00',3.55),('325','2013-07-07','11:25:00',3.46),('325','2013-07-07','11:30:00',3.46),('325','2013-07-07','11:35:00',3.34),('325','2013-07-07','11:40:00',3.49),('325','2013-07-07','11:45:00',2.87),('325','2013-07-07','11:50:00',3.05),('325','2013-07-07','11:55:00',2.33),('325','2013-07-07','12:00:00',2.4),('325','2013-07-07','12:05:00',4.06),('325','2013-07-07','12:10:00',4.18),('325','2013-07-07','12:15:00',4.29),('325','2013-07-07','12:20:00',4.37),('325','2013-07-07','12:25:00',4.15),('325','2013-07-07','12:30:00',4.01),('325','2013-07-07','12:35:00',4.15),('325','2013-07-07','12:40:00',4.25),('325','2013-07-07','12:45:00',4.28),('325','2013-07-07','12:50:00',4.25),('325','2013-07-07','12:55:00',4.61),('325','2013-07-07','13:00:00',4.48),('325','2013-07-07','13:05:00',4.54),('325','2013-07-07','13:10:00',4.51),('325','2013-07-07','13:15:00',4.54),('325','2013-07-07','13:20:00',4.46),('325','2013-07-07','13:25:00',4.07),('325','2013-07-07','13:30:00',3.51),('325','2013-07-07','13:35:00',4.5),('325','2013-07-07','13:40:00',4.42),('325','2013-07-07','13:45:00',2.74),('325','2013-07-07','13:50:00',4.94),('325','2013-07-07','13:55:00',3.83),('325','2013-07-07','14:00:00',3.27),('325','2013-07-07','14:05:00',3.28),('325','2013-07-07','14:10:00',2.83),('325','2013-07-07','14:15:00',1.56),('325','2013-07-07','14:20:00',1.3),('325','2013-07-07','14:25:00',1.11),('325','2013-07-07','14:30:00',1.05),('325','2013-07-07','15:05:00',1.13),('325','2013-07-07','17:10:00',1.04),('325','2013-07-07','17:15:00',1.09),('325','2013-07-07','17:20:00',1.1),('325','2013-07-07','17:25:00',1.09),('325','2013-07-07','17:30:00',1.05),('325','2013-07-06','08:25:00',1.04),('325','2013-07-06','08:30:00',1.11),('325','2013-07-06','08:35:00',1.16),('325','2013-07-06','08:40:00',1.22),('325','2013-07-06','08:45:00',1.27),('325','2013-07-06','08:50:00',1.31),('325','2013-07-06','08:55:00',1.32),('325','2013-07-06','09:00:00',1.31),('325','2013-07-06','09:05:00',1.33),('325','2013-07-06','09:10:00',1.38),('325','2013-07-06','09:15:00',1.41),('325','2013-07-06','09:20:00',1.43),('325','2013-07-06','09:25:00',1.47),('325','2013-07-06','09:30:00',1.49),('325','2013-07-06','09:35:00',1.53),('325','2013-07-06','09:40:00',2.26),('325','2013-07-06','09:45:00',2.6),('325','2013-07-06','09:50:00',2.7),('325','2013-07-06','09:55:00',2.74),('325','2013-07-06','10:00:00',2.8),('325','2013-07-06','10:05:00',2.87),('325','2013-07-06','10:10:00',2.95),('325','2013-07-06','10:15:00',3.05),('325','2013-07-06','10:20:00',3.09),('325','2013-07-06','10:25:00',3.1),('325','2013-07-06','10:30:00',3.09),('325','2013-07-06','10:35:00',3.13),('325','2013-07-06','10:40:00',3.25),('325','2013-07-06','10:45:00',3.37),('325','2013-07-06','10:50:00',3.4),('325','2013-07-06','10:55:00',3.43),('325','2013-07-06','11:00:00',3.5),('325','2013-07-06','11:05:00',3.53),('325','2013-07-06','11:10:00',3.65),('325','2013-07-06','11:15:00',3.96),('325','2013-07-06','11:20:00',3.97),('325','2013-07-06','11:25:00',3.99),('325','2013-07-06','11:30:00',4.03),('325','2013-07-06','11:35:00',4.06),('325','2013-07-06','11:40:00',4.09),('325','2013-07-06','11:45:00',4.15),('325','2013-07-06','11:50:00',4.23),('325','2013-07-06','11:55:00',4.21),('325','2013-07-06','12:00:00',4.22),('325','2013-07-06','12:05:00',4.3),('325','2013-07-06','12:10:00',4.37),('325','2013-07-06','12:15:00',4.36),('325','2013-07-06','12:20:00',4.37),('325','2013-07-06','12:25:00',4.41),('325','2013-07-06','12:30:00',4.43),('325','2013-07-06','12:35:00',4.44),('325','2013-07-06','12:40:00',4.43),('325','2013-07-06','12:45:00',4.45),('325','2013-07-06','12:50:00',4.45),('325','2013-07-06','12:55:00',4.42),('325','2013-07-06','13:00:00',4.47),('325','2013-07-06','13:05:00',4.46),('325','2013-07-06','13:10:00',4.46),('325','2013-07-06','13:15:00',4.47),('325','2013-07-06','13:20:00',4.48),('325','2013-07-06','13:25:00',4.45),('325','2013-07-06','13:30:00',4.49),('325','2013-07-06','13:35:00',4.43),('325','2013-07-06','13:40:00',4.49),('325','2013-07-06','13:45:00',4.47),('325','2013-07-06','13:50:00',4.38),('325','2013-07-06','13:55:00',4.29),('325','2013-07-06','14:00:00',4.32),('325','2013-07-06','14:05:00',4.38),('325','2013-07-06','14:10:00',4.34),('325','2013-07-06','14:15:00',4.34),('325','2013-07-06','14:20:00',4.43),('325','2013-07-06','14:25:00',4.34),('325','2013-07-06','14:30:00',4.24),('325','2013-07-06','14:35:00',4.24),('325','2013-07-06','14:40:00',4.23),('325','2013-07-06','14:45:00',4.18),('325','2013-07-06','14:50:00',4.18),('325','2013-07-06','14:55:00',4),('325','2013-07-06','15:00:00',4.28),('325','2013-07-06','15:05:00',4.27),('325','2013-07-06','15:10:00',4.13),('325','2013-07-06','15:15:00',4.04),('325','2013-07-06','15:20:00',4),('325','2013-07-06','15:25:00',4.03),('325','2013-07-06','15:30:00',3.15),('325','2013-07-06','15:35:00',2.11),('325','2013-07-06','16:45:00',1.06),('325','2013-07-06','16:50:00',1.82),('325','2013-07-06','16:55:00',1.81),('325','2013-07-06','17:00:00',1.18),('325','2013-07-06','17:05:00',1.12),('325','2013-07-06','17:10:00',1.18),('325','2013-07-06','17:15:00',2.17),('325','2013-07-06','17:20:00',1.23),('325','2013-07-06','17:25:00',1.07),('325','2013-07-06','17:30:00',1.26),('325','2013-07-06','17:35:00',1.23),('325','2013-07-06','17:40:00',1.06),('325','2013-07-06','17:45:00',1),('325','2013-07-05','08:20:00',1),('325','2013-07-05','08:25:00',1.06),('325','2013-07-05','08:30:00',1.12),('325','2013-07-05','08:35:00',1.17),('325','2013-07-05','08:40:00',1.24),('325','2013-07-05','08:45:00',1.28),('325','2013-07-05','08:50:00',1.32),('325','2013-07-05','08:55:00',1.33),('325','2013-07-05','09:00:00',1.33),('325','2013-07-05','09:05:00',1.36),('325','2013-07-05','09:10:00',1.42),('325','2013-07-05','09:15:00',1.45),('325','2013-07-05','09:20:00',1.49),('325','2013-07-05','09:25:00',1.53),('325','2013-07-05','09:30:00',1.56),('325','2013-07-05','09:35:00',1.6),('325','2013-07-05','09:40:00',2.34),('325','2013-07-05','09:45:00',2.63),('325','2013-07-05','09:50:00',2.72),('325','2013-07-05','09:55:00',2.73),('325','2013-07-05','10:00:00',2.8),('325','2013-07-05','10:05:00',2.86),('325','2013-07-05','10:10:00',2.95),('325','2013-07-05','10:15:00',3.04),('325','2013-07-05','10:20:00',3.09),('325','2013-07-05','10:25:00',3.15),('325','2013-07-05','10:30:00',3.21),('325','2013-07-05','10:35:00',3.27),('325','2013-07-05','10:40:00',3.34),('325','2013-07-05','10:45:00',3.39),('325','2013-07-05','10:50:00',3.39),('325','2013-07-05','10:55:00',3.39),('325','2013-07-05','11:00:00',3.55),('325','2013-07-05','11:05:00',3.8),('325','2013-07-05','11:10:00',3.84),('325','2013-07-05','11:15:00',3.9),('325','2013-07-05','11:20:00',3.94),('325','2013-07-05','11:25:00',3.98),('325','2013-07-05','11:30:00',4.04),('325','2013-07-05','11:35:00',4.06),('325','2013-07-05','11:40:00',4.1),('325','2013-07-05','11:45:00',4.08),('325','2013-07-05','11:50:00',4.11),('325','2013-07-05','11:55:00',4.19),('325','2013-07-05','12:00:00',4.18),('325','2013-07-05','12:05:00',4.23),('325','2013-07-05','12:10:00',4.23),('325','2013-07-05','12:15:00',4.25),('325','2013-07-05','12:20:00',4.28),('325','2013-07-05','12:25:00',3.67),('325','2013-07-05','12:30:00',4.2),('325','2013-07-05','12:35:00',2.87),('325','2013-07-05','12:40:00',4.04),('325','2013-07-05','12:45:00',4.17),('325','2013-07-05','12:50:00',4.38),('325','2013-07-05','12:55:00',4.48),('325','2013-07-05','13:00:00',3.27),('325','2013-07-05','13:05:00',3.21),('325','2013-07-05','13:10:00',4.68),('325','2013-07-05','13:15:00',4.6),('325','2013-07-05','13:20:00',2.59),('325','2013-07-05','13:25:00',4.7),('325','2013-07-05','13:30:00',4.34),('325','2013-07-05','13:35:00',4.29),('325','2013-07-05','13:40:00',4.52),('325','2013-07-05','13:45:00',4.49),('325','2013-07-05','13:50:00',4.43),('325','2013-07-05','13:55:00',4.38),('325','2013-07-05','14:00:00',4.34),('325','2013-07-05','14:05:00',4.34),('325','2013-07-05','14:10:00',2.45),('325','2013-07-05','14:15:00',4.35),('325','2013-07-05','14:20:00',4.27),('325','2013-07-05','14:25:00',4.26),('325','2013-07-05','14:30:00',4.25),('325','2013-07-05','14:35:00',4.3),('325','2013-07-05','14:40:00',4.12),('325','2013-07-05','14:45:00',3.11),('325','2013-07-05','14:50:00',3.6),('325','2013-07-05','14:55:00',4.19),('325','2013-07-05','15:00:00',4.19),('325','2013-07-05','15:05:00',2.85),('325','2013-07-05','15:10:00',4.25),('325','2013-07-05','15:15:00',4.17),('325','2013-07-05','15:20:00',2.6),('325','2013-07-05','15:25:00',4.22),('325','2013-07-05','15:30:00',4.06),('325','2013-07-05','15:35:00',3.97),('325','2013-07-05','15:40:00',3.84),('325','2013-07-05','15:45:00',3.85),('325','2013-07-05','15:50:00',3.83),('325','2013-07-05','15:55:00',3.73),('325','2013-07-05','16:00:00',3.64),('325','2013-07-05','16:05:00',3.62),('325','2013-07-05','16:10:00',3.54),('325','2013-07-05','16:15:00',3.44),('325','2013-07-05','16:20:00',3.45),('325','2013-07-05','16:25:00',3.4),('325','2013-07-05','16:30:00',3.34),('325','2013-07-05','16:35:00',3.28),('325','2013-07-05','16:40:00',3.19),('325','2013-07-05','16:45:00',3.13),('325','2013-07-05','16:50:00',3.03),('325','2013-07-05','16:55:00',2.9),('325','2013-07-05','17:00:00',2.83),('325','2013-07-05','17:05:00',2.73),('325','2013-07-05','17:10:00',2.63),('325','2013-07-05','17:15:00',2.57),('325','2013-07-05','17:20:00',2.6),('325','2013-07-05','17:25:00',2.44),('325','2013-07-05','17:30:00',2.4),('325','2013-07-05','17:35:00',2.3),('325','2013-07-05','17:40:00',2.15),('325','2013-07-05','17:45:00',2.05),('325','2013-07-05','17:50:00',1.93),('325','2013-07-05','17:55:00',1.86),('325','2013-07-05','18:00:00',1.77),('325','2013-07-05','18:05:00',1.7),('325','2013-07-05','18:10:00',1.53),('325','2013-07-05','18:15:00',1.34),('325','2013-07-05','18:20:00',1.22),('325','2013-07-04','11:10:00',1.07),('325','2013-07-04','11:15:00',1.11),('325','2013-07-04','11:20:00',1.1),('325','2013-07-04','11:25:00',1.21),('325','2013-07-04','11:30:00',1.34),('325','2013-07-04','11:35:00',1.53),('325','2013-07-04','11:40:00',1.65),('325','2013-07-04','11:45:00',1.69),('325','2013-07-04','11:50:00',1.69),('325','2013-07-04','11:55:00',1.51),('325','2013-07-04','12:00:00',1.43),('325','2013-07-04','12:05:00',2.05),('325','2013-07-04','12:10:00',2.74),('325','2013-07-04','12:15:00',2.55),('325','2013-07-04','12:20:00',2.44),('325','2013-07-04','12:25:00',3.49),('325','2013-07-04','12:30:00',2.77),('325','2013-07-04','12:35:00',2.22),('325','2013-07-04','12:40:00',1.66),('325','2013-07-04','12:45:00',1.34),('325','2013-07-04','12:50:00',1.07),('325','2013-07-04','13:00:00',1.15),('325','2013-07-04','13:05:00',1.46),('325','2013-07-04','13:10:00',1.96),('325','2013-07-04','13:15:00',2.31),('325','2013-07-04','13:20:00',2.27),('325','2013-07-04','13:25:00',3.04),('325','2013-07-04','13:30:00',2.56),('325','2013-07-04','13:35:00',2.54),('325','2013-07-04','13:40:00',3.04),('325','2013-07-04','13:45:00',4.37),('325','2013-07-04','13:50:00',5.59),('325','2013-07-04','13:55:00',4.51),('325','2013-07-04','14:00:00',3.31),('325','2013-07-04','14:05:00',2.45),('325','2013-07-04','14:10:00',2.29),('325','2013-07-04','14:15:00',2.37),('325','2013-07-04','14:20:00',2.32),('325','2013-07-04','14:25:00',2.1),('325','2013-07-04','14:30:00',2.07),('325','2013-07-04','14:35:00',2.18),('325','2013-07-04','14:40:00',2.65),('325','2013-07-04','14:45:00',3.11),('325','2013-07-04','14:50:00',2.79),('325','2013-07-04','14:55:00',2.31),('325','2013-07-04','15:00:00',1.94),('325','2013-07-04','15:05:00',2.48),('325','2013-07-04','15:10:00',3.8),('325','2013-07-04','15:15:00',3.02),('325','2013-07-04','15:20:00',3.2),('325','2013-07-04','15:25:00',2.84),('325','2013-07-04','15:30:00',2.79),('325','2013-07-04','15:35:00',2.63),('325','2013-07-04','15:40:00',2.82),('325','2013-07-04','15:45:00',3.69),('325','2013-07-04','15:50:00',2.25),('325','2013-07-04','15:55:00',2.57),('325','2013-07-04','16:00:00',2.71),('325','2013-07-04','16:05:00',2.63),('325','2013-07-04','16:10:00',2),('325','2013-07-04','16:15:00',1.95),('325','2013-07-04','16:20:00',1.99),('325','2013-07-04','16:25:00',2.44),('325','2013-07-04','16:30:00',2.28),('325','2013-07-04','16:35:00',2.43),('325','2013-07-04','16:40:00',1.96),('325','2013-07-04','16:45:00',1.68),('325','2013-07-04','16:50:00',1.63),('325','2013-07-04','16:55:00',1.53),('325','2013-07-04','17:00:00',1.33),('325','2013-07-04','17:05:00',1.34),('325','2013-07-04','17:10:00',2.03),('325','2013-07-04','17:15:00',2.6),('325','2013-07-04','17:20:00',2.45),('325','2013-07-04','17:25:00',2.91),('325','2013-07-04','17:30:00',2.69),('325','2013-07-04','17:35:00',2),('325','2013-07-04','17:40:00',2.35),('325','2013-07-04','17:45:00',2.34),('325','2013-07-04','17:50:00',2.29),('325','2013-07-04','17:55:00',1.89),('325','2013-07-04','18:00:00',2.1),('325','2013-07-04','18:05:00',1.98),('325','2013-07-04','18:10:00',1.91),('325','2013-07-04','18:15:00',1.8),('325','2013-07-04','18:20:00',1.59),('325','2013-07-04','18:25:00',1.25),('325','2013-07-03','08:20:00',1.01),('325','2013-07-03','08:25:00',1.07),('325','2013-07-03','08:30:00',1.12),('325','2013-07-03','08:35:00',1.16),('325','2013-07-03','08:40:00',1.24),('325','2013-07-03','08:45:00',1.29),('325','2013-07-03','08:50:00',1.33),('325','2013-07-03','08:55:00',1.33),('325','2013-07-03','09:00:00',1.33),('325','2013-07-03','09:05:00',1.34),('325','2013-07-03','09:10:00',1.39),('325','2013-07-03','09:15:00',1.42),('325','2013-07-03','09:20:00',1.43),('325','2013-07-03','09:25:00',1.44),('325','2013-07-03','09:30:00',1.49),('325','2013-07-03','09:35:00',1.59),('325','2013-07-03','09:40:00',2.46),('325','2013-07-03','09:45:00',2.62),('325','2013-07-03','09:50:00',2.74),('325','2013-07-03','09:55:00',2.75),('325','2013-07-03','10:00:00',2.79),('325','2013-07-03','10:05:00',2.86),('325','2013-07-03','10:10:00',2.97),('325','2013-07-03','10:15:00',3.02),('325','2013-07-03','10:20:00',3.08),('325','2013-07-03','10:25:00',3.08),('325','2013-07-03','10:30:00',3.11),('325','2013-07-03','10:35:00',3.21),('325','2013-07-03','10:40:00',3.28),('325','2013-07-03','10:45:00',3.37),('325','2013-07-03','10:50:00',3.4),('325','2013-07-03','10:55:00',3.43),('325','2013-07-03','11:00:00',3.52),('325','2013-07-03','11:05:00',3.6),('325','2013-07-03','11:10:00',3.68),('325','2013-07-03','11:15:00',3.78),('325','2013-07-03','11:20:00',3.83),('325','2013-07-03','11:25:00',3.89),('325','2013-07-03','11:30:00',3.9),('325','2013-07-03','11:35:00',3.88),('325','2013-07-03','11:40:00',3.92),('325','2013-07-03','11:45:00',3.89),('325','2013-07-03','11:50:00',3.93),('325','2013-07-03','11:55:00',4.03),('325','2013-07-03','12:00:00',4.06),('325','2013-07-03','12:05:00',4.16),('325','2013-07-03','12:10:00',4.28),('325','2013-07-03','12:15:00',4.36),('325','2013-07-03','12:20:00',4.36),('325','2013-07-03','12:25:00',4.35),('325','2013-07-03','12:30:00',4.32),('325','2013-07-03','12:35:00',4.26),('325','2013-07-03','12:40:00',4.22),('325','2013-07-03','12:45:00',4.2),('325','2013-07-03','12:50:00',4.52),('325','2013-07-03','12:55:00',4.6),('325','2013-07-03','13:00:00',4.62),('325','2013-07-03','13:05:00',4.62),('325','2013-07-03','13:10:00',4.64),('325','2013-07-03','13:15:00',4.63),('325','2013-07-03','13:20:00',4.61),('325','2013-07-03','13:25:00',4.63),('325','2013-07-03','13:30:00',4.62),('325','2013-07-03','13:35:00',4.63),('325','2013-07-03','13:40:00',4.61),('325','2013-07-03','13:45:00',4.59),('325','2013-07-03','13:50:00',4.51),('325','2013-07-03','13:55:00',4.43),('325','2013-07-03','14:00:00',4.36),('325','2013-07-03','14:05:00',4.33),('325','2013-07-03','14:10:00',4.22),('325','2013-07-03','14:15:00',4.21),('325','2013-07-03','14:20:00',4.16),('325','2013-07-03','14:25:00',4.25),('325','2013-07-03','14:30:00',4.36),('325','2013-07-03','14:35:00',4.38),('325','2013-07-03','14:40:00',4.37),('325','2013-07-03','14:45:00',4.4),('325','2013-07-03','14:50:00',4.37),('325','2013-07-03','14:55:00',4.35),('325','2013-07-03','15:00:00',4.36),('325','2013-07-03','15:05:00',4.3),('325','2013-07-03','15:10:00',4.29),('325','2013-07-03','15:15:00',4.25),('325','2013-07-03','15:20:00',4.2),('325','2013-07-03','15:25:00',4.14),('325','2013-07-03','15:30:00',4.11),('325','2013-07-03','15:35:00',4.07),('325','2013-07-03','15:40:00',4.01),('325','2013-07-03','15:45:00',3.96),('325','2013-07-03','15:50:00',3.91),('325','2013-07-03','15:55:00',3.84),('325','2013-07-03','16:00:00',3.77),('325','2013-07-03','16:05:00',3.74),('325','2013-07-03','16:10:00',3.67),('325','2013-07-03','16:15:00',3.62),('325','2013-07-03','16:20:00',3.58),('325','2013-07-03','16:25:00',3.51),('325','2013-07-03','16:30:00',3.47),('325','2013-07-03','16:35:00',3.39),('325','2013-07-03','16:40:00',3.32),('325','2013-07-03','16:45:00',3.22),('325','2013-07-03','16:50:00',3.18),('325','2013-07-03','16:55:00',3.11),('325','2013-07-03','17:00:00',3.03),('325','2013-07-03','17:05:00',2.9),('325','2013-07-03','17:10:00',2.78),('325','2013-07-03','17:15:00',2.75),('325','2013-07-03','17:20:00',2.68),('325','2013-07-03','17:25:00',2.6),('325','2013-07-03','17:30:00',2.52),('325','2013-07-03','17:35:00',2.44),('325','2013-07-03','17:40:00',2.35),('325','2013-07-03','17:45:00',2.27),('325','2013-07-03','17:50:00',2.17),('325','2013-07-03','17:55:00',2.05),('325','2013-07-03','18:00:00',1.96),('325','2013-07-03','18:05:00',1.82),('325','2013-07-03','18:10:00',1.74),('325','2013-07-03','18:15:00',1.65),('325','2013-07-03','18:20:00',1.45),('325','2013-07-03','18:25:00',1.27),('325','2013-07-03','18:30:00',1.17),('325','2013-07-03','18:35:00',1.08),('325','2013-07-03','18:40:00',1.03),('325','2013-07-02','08:20:00',1.01),('325','2013-07-02','08:25:00',1.07),('325','2013-07-02','08:30:00',1.14),('325','2013-07-02','08:35:00',1.18),('325','2013-07-02','08:40:00',1.25),('325','2013-07-02','08:45:00',1.29),('325','2013-07-02','08:50:00',1.31),('325','2013-07-02','08:55:00',1.32),('325','2013-07-02','09:00:00',1.32),('325','2013-07-02','09:05:00',1.34),('325','2013-07-02','09:10:00',1.39),('325','2013-07-02','09:15:00',1.41),('325','2013-07-02','09:20:00',1.43),('325','2013-07-02','09:25:00',1.46),('325','2013-07-02','09:30:00',1.49),('325','2013-07-02','09:35:00',1.74),('325','2013-07-02','09:40:00',2.55),('325','2013-07-02','09:45:00',2.64),('325','2013-07-02','09:50:00',2.73),('325','2013-07-02','09:55:00',2.75),('325','2013-07-02','10:00:00',2.75),('325','2013-07-02','10:05:00',2.86),('325','2013-07-02','10:10:00',2.93),('325','2013-07-02','10:15:00',3.02),('325','2013-07-02','10:20:00',3.09),('325','2013-07-02','10:25:00',3.13),('325','2013-07-02','10:30:00',3.2),('325','2013-07-02','10:35:00',3.24),('325','2013-07-02','10:40:00',3.3),('325','2013-07-02','10:45:00',3.37),('325','2013-07-02','10:50:00',3.38),('325','2013-07-02','10:55:00',3.37),('325','2013-07-02','11:00:00',3.43),('325','2013-07-02','11:05:00',3.47),('325','2013-07-02','11:10:00',3.51),('325','2013-07-02','11:15:00',3.63),('325','2013-07-02','11:20:00',3.76),('325','2013-07-02','11:25:00',3.85),('325','2013-07-02','11:30:00',3.8),('325','2013-07-02','11:35:00',3.79),('325','2013-07-02','11:40:00',3.76),('325','2013-07-02','11:45:00',3.77),('325','2013-07-02','11:50:00',3.84),('325','2013-07-02','11:55:00',3.81),('325','2013-07-02','12:00:00',3.96),('325','2013-07-02','12:05:00',4.08),('325','2013-07-02','12:10:00',4.19),('325','2013-07-02','12:15:00',4.18),('325','2013-07-02','12:20:00',4.19),('325','2013-07-02','12:25:00',4.18),('325','2013-07-02','12:30:00',4.29),('325','2013-07-02','12:35:00',4.32),('325','2013-07-02','12:40:00',4.27),('325','2013-07-02','12:45:00',4.29),('325','2013-07-02','12:50:00',4.71),('325','2013-07-02','12:55:00',4.16),('325','2013-07-02','13:00:00',1.47),('325','2013-07-02','13:05:00',4.6),('325','2013-07-02','13:10:00',4.65),('325','2013-07-02','13:15:00',3.57),('325','2013-07-02','13:20:00',4.58),('325','2013-07-02','13:25:00',4.46),('325','2013-07-02','13:30:00',4.57),('325','2013-07-02','13:35:00',4.54),('325','2013-07-02','13:40:00',4.43),('325','2013-07-02','13:45:00',4.39),('325','2013-07-02','13:50:00',4.34),('325','2013-07-02','13:55:00',4.32),('325','2013-07-02','14:00:00',4.27),('325','2013-07-02','14:05:00',4.31),('325','2013-07-02','14:10:00',4.34),('325','2013-07-02','14:15:00',4.35),('325','2013-07-02','14:20:00',4.34),('325','2013-07-02','14:25:00',4.31),('325','2013-07-02','14:30:00',4.3),('325','2013-07-02','14:35:00',4.26),('325','2013-07-02','14:40:00',4.27),('325','2013-07-02','14:45:00',4.25),('325','2013-07-02','14:50:00',4.22),('325','2013-07-02','14:55:00',4.21),('325','2013-07-02','15:00:00',4.22),('325','2013-07-02','15:05:00',4.19),('325','2013-07-02','15:10:00',4.15),('325','2013-07-02','15:15:00',4.1),('325','2013-07-02','15:20:00',4.06),('325','2013-07-02','15:25:00',4.05),('325','2013-07-02','15:30:00',4.02),('325','2013-07-02','15:35:00',3.98),('325','2013-07-02','15:40:00',3.92),('325','2013-07-02','15:45:00',3.87),('325','2013-07-02','15:50:00',3.83),('325','2013-07-02','15:55:00',3.77),('325','2013-07-02','16:00:00',3.71),('325','2013-07-02','16:05:00',3.68),('325','2013-07-02','16:10:00',3.61),('325','2013-07-02','16:15:00',3.55),('325','2013-07-02','16:20:00',3.5),('325','2013-07-02','16:25:00',3.45),('325','2013-07-02','16:30:00',3.38),('325','2013-07-02','16:35:00',3.32),('325','2013-07-02','16:40:00',3.25),('325','2013-07-02','16:45:00',3.17),('325','2013-07-02','16:50:00',3.09),('325','2013-07-02','16:55:00',3.04),('325','2013-07-02','17:00:00',2.97),('325','2013-07-02','17:05:00',2.84),('325','2013-07-02','17:10:00',2.68),('325','2013-07-02','17:15:00',2.67),('325','2013-07-02','17:20:00',2.6),('325','2013-07-02','17:25:00',2.52),('325','2013-07-02','17:30:00',2.43),('325','2013-07-02','17:35:00',2.34),('325','2013-07-02','17:40:00',2.24),('325','2013-07-02','17:45:00',2.14),('325','2013-07-02','17:50:00',2.06),('325','2013-07-02','17:55:00',1.96),('325','2013-07-02','18:00:00',1.83),('325','2013-07-02','18:05:00',1.76),('325','2013-07-02','18:10:00',1.67),('325','2013-07-02','18:15:00',1.56),('325','2013-07-02','18:20:00',1.39),('325','2013-07-02','18:25:00',1.21),('325','2013-07-02','18:30:00',1.14),('325','2013-07-02','18:35:00',1.02),('325','2013-07-01','08:15:00',1),('325','2013-07-01','08:20:00',1.05),('325','2013-07-01','08:25:00',1.11),('325','2013-07-01','08:30:00',1.16),('325','2013-07-01','08:35:00',1.21),('325','2013-07-01','08:40:00',1.29),('325','2013-07-01','08:45:00',1.33),('325','2013-07-01','08:50:00',1.36),('325','2013-07-01','08:55:00',1.36),('325','2013-07-01','09:00:00',1.36),('325','2013-07-01','09:05:00',1.37),('325','2013-07-01','09:10:00',1.42),('325','2013-07-01','09:15:00',1.45),('325','2013-07-01','09:20:00',1.47),('325','2013-07-01','09:25:00',1.51),('325','2013-07-01','09:30:00',1.56),('325','2013-07-01','09:35:00',1.75),('325','2013-07-01','09:40:00',2.59),('325','2013-07-01','09:45:00',2.74),('325','2013-07-01','09:50:00',2.83),('325','2013-07-01','09:55:00',2.82),('325','2013-07-01','10:00:00',2.85),('325','2013-07-01','10:05:00',2.91),('325','2013-07-01','10:10:00',3),('325','2013-07-01','10:15:00',3.09),('325','2013-07-01','10:20:00',3.15),('325','2013-07-01','10:25:00',3.15),('325','2013-07-01','10:30:00',3.19),('325','2013-07-01','10:35:00',3.26),('325','2013-07-01','10:40:00',3.36),('325','2013-07-01','10:45:00',3.48),('325','2013-07-01','10:50:00',3.6),('325','2013-07-01','10:55:00',3.76),('325','2013-07-01','11:00:00',3.94),('325','2013-07-01','11:05:00',4),('325','2013-07-01','11:10:00',4),('325','2013-07-01','11:15:00',4.11),('325','2013-07-01','11:20:00',4.17),('325','2013-07-01','11:25:00',4.21),('325','2013-07-01','11:30:00',4.22),('325','2013-07-01','11:35:00',4.22),('325','2013-07-01','11:40:00',4.24),('325','2013-07-01','11:45:00',4.32),('325','2013-07-01','11:50:00',4.37),('325','2013-07-01','11:55:00',4.36),('325','2013-07-01','12:00:00',4.34),('325','2013-07-01','12:05:00',4.36),('325','2013-07-01','12:10:00',4.36),('325','2013-07-01','12:15:00',4.37),('325','2013-07-01','12:20:00',4.36),('325','2013-07-01','12:25:00',4.45),('325','2013-07-01','12:30:00',4.46),('325','2013-07-01','12:35:00',4.5),('325','2013-07-01','12:40:00',4.45),('325','2013-07-01','12:45:00',4.46),('325','2013-07-01','12:50:00',4.49),('325','2013-07-01','12:55:00',4.49),('325','2013-07-01','13:00:00',4.49),('325','2013-07-01','13:05:00',4.5),('325','2013-07-01','13:10:00',4.54),('325','2013-07-01','13:15:00',4.51),('325','2013-07-01','13:20:00',4.54),('325','2013-07-01','13:25:00',4.51),('325','2013-07-01','13:30:00',4.53),('325','2013-07-01','13:35:00',4.54),('325','2013-07-01','13:40:00',4.52),('325','2013-07-01','13:45:00',4.46),('325','2013-07-01','13:50:00',4.45),('325','2013-07-01','13:55:00',4.4),('325','2013-07-01','14:00:00',4.36),('325','2013-07-01','14:05:00',4.35),('325','2013-07-01','14:10:00',4.27),('325','2013-07-01','14:15:00',4.2),('325','2013-07-01','14:20:00',4.18),('325','2013-07-01','14:25:00',4.14),('325','2013-07-01','14:30:00',4.23),('325','2013-07-01','14:35:00',4.3),('325','2013-07-01','14:40:00',4.29),('325','2013-07-01','14:45:00',4.29),('325','2013-07-01','14:50:00',4.27),('325','2013-07-01','14:55:00',4.23),('325','2013-07-01','15:00:00',4.21),('325','2013-07-01','15:05:00',4.15),('325','2013-07-01','15:10:00',4.15),('325','2013-07-01','15:15:00',4.11),('325','2013-07-01','15:20:00',4.06),('325','2013-07-01','15:25:00',4.02),('325','2013-07-01','15:30:00',3.97),('325','2013-07-01','15:35:00',3.89),('325','2013-07-01','15:40:00',3.84),('325','2013-07-01','15:45:00',3.84),('325','2013-07-01','15:50:00',3.8),('325','2013-07-01','15:55:00',3.7),('325','2013-07-01','16:00:00',3.68),('325','2013-07-01','16:05:00',3.61),('325','2013-07-01','16:10:00',3.56),('325','2013-07-01','16:15:00',3.49),('325','2013-07-01','16:20:00',3.41),('325','2013-07-01','16:25:00',3.37),('325','2013-07-01','16:30:00',3.3),('325','2013-07-01','16:35:00',3.22),('325','2013-07-01','16:40:00',3.16),('325','2013-07-01','16:45:00',3.12),('325','2013-07-01','16:50:00',3.06),('325','2013-07-01','16:55:00',3),('325','2013-07-01','17:00:00',2.92),('325','2013-07-01','17:05:00',2.81),('325','2013-07-01','17:10:00',2.67),('325','2013-07-01','17:15:00',2.66),('325','2013-07-01','17:20:00',2.55),('325','2013-07-01','17:25:00',2.47),('325','2013-07-01','17:30:00',2.37),('325','2013-07-01','17:35:00',2.28),('325','2013-07-01','17:40:00',2.2),('325','2013-07-01','17:45:00',2.13),('325','2013-07-01','17:50:00',2.06),('325','2013-07-01','17:55:00',1.96),('325','2013-07-01','18:00:00',1.67),('325','2013-07-01','18:05:00',1.74),('325','2013-07-01','18:10:00',1.64),('325','2013-07-01','18:15:00',1.29),('325','2013-07-01','18:20:00',1.3),('325','2013-07-01','18:25:00',1.27),('325','2013-07-01','18:30:00',1.18),('325','2013-07-01','18:35:00',1.05),('325','2013-06-30','08:15:00',1.01),('325','2013-06-30','08:20:00',1.06),('325','2013-06-30','08:25:00',1.12),('325','2013-06-30','08:30:00',1.18),('325','2013-06-30','08:35:00',1.22),('325','2013-06-30','08:40:00',1.29),('325','2013-06-30','08:45:00',1.33),('325','2013-06-30','08:50:00',1.36),('325','2013-06-30','08:55:00',1.36),('325','2013-06-30','09:00:00',1.35),('325','2013-06-30','09:05:00',1.36),('325','2013-06-30','09:10:00',1.42),('325','2013-06-30','09:15:00',1.44),('325','2013-06-30','09:20:00',1.46),('325','2013-06-30','09:25:00',1.5),('325','2013-06-30','09:30:00',1.63),('325','2013-06-30','09:35:00',2.37),('325','2013-06-30','09:40:00',2.84),('325','2013-06-30','09:45:00',2.96),('325','2013-06-30','09:50:00',3.05),('325','2013-06-30','09:55:00',3.1),('325','2013-06-30','10:00:00',3.18),('325','2013-06-30','10:05:00',3.24),('325','2013-06-30','10:10:00',3.31),('325','2013-06-30','10:15:00',3.37),('325','2013-06-30','10:20:00',3.44),('325','2013-06-30','10:25:00',3.52),('325','2013-06-30','10:30:00',3.58),('325','2013-06-30','10:35:00',3.65),('325','2013-06-30','10:40:00',3.73),('325','2013-06-30','10:45:00',3.78),('325','2013-06-30','10:50:00',3.82),('325','2013-06-30','10:55:00',3.86),('325','2013-06-30','11:00:00',3.97),('325','2013-06-30','11:05:00',4.01),('325','2013-06-30','11:10:00',4.05),('325','2013-06-30','11:15:00',4.12),('325','2013-06-30','11:20:00',4.14),('325','2013-06-30','11:25:00',4.16),('325','2013-06-30','11:30:00',4.2),('325','2013-06-30','11:35:00',4.22),('325','2013-06-30','11:40:00',4.25),('325','2013-06-30','11:45:00',4.3),('325','2013-06-30','11:50:00',4.38),('325','2013-06-30','11:55:00',4.41),('325','2013-06-30','12:00:00',4.37),('325','2013-06-30','12:05:00',4.36),('325','2013-06-30','12:10:00',4.47),('325','2013-06-30','12:15:00',4.47),('325','2013-06-30','12:20:00',4.43),('325','2013-06-30','12:25:00',4.35),('325','2013-06-30','12:30:00',4.31),('325','2013-06-30','12:35:00',4.28),('325','2013-06-30','12:40:00',4.24),('325','2013-06-30','12:45:00',4.19),('325','2013-06-30','12:50:00',4.31),('325','2013-06-30','12:55:00',4.42),('325','2013-06-30','13:00:00',4.46),('325','2013-06-30','13:05:00',4.49),('325','2013-06-30','13:10:00',4.5),('325','2013-06-30','13:15:00',4.47),('325','2013-06-30','13:20:00',4.41),('325','2013-06-30','13:25:00',4.38),('325','2013-06-30','13:30:00',4.29),('325','2013-06-30','13:35:00',4.37),('325','2013-06-30','13:40:00',3.13),('325','2013-06-30','13:45:00',4.68),('325','2013-06-30','13:50:00',4.65),('325','2013-06-30','13:55:00',4.58),('325','2013-06-30','14:00:00',4.55),('325','2013-06-30','14:05:00',4.46),('325','2013-06-30','14:10:00',4.3),('325','2013-06-30','14:15:00',4.21),('325','2013-06-30','14:20:00',4.2),('325','2013-06-30','14:25:00',4.16),('325','2013-06-30','14:30:00',4.21),('325','2013-06-30','14:35:00',4.28),('325','2013-06-30','14:40:00',4.34),('325','2013-06-30','14:45:00',4.34),('325','2013-06-30','14:50:00',4.29),('325','2013-06-30','14:55:00',4.25),('325','2013-06-30','15:00:00',4.2),('325','2013-06-30','15:05:00',4.15),('325','2013-06-30','15:10:00',4.16),('325','2013-06-30','15:15:00',4.14),('325','2013-06-30','15:20:00',4.17),('325','2013-06-30','15:25:00',4.12),('325','2013-06-30','15:30:00',4.07),('325','2013-06-30','15:35:00',4.05),('325','2013-06-30','15:40:00',4.03),('325','2013-06-30','15:45:00',3.96),('325','2013-06-30','15:50:00',3.93),('325','2013-06-30','15:55:00',3.85),('325','2013-06-30','16:00:00',3.8),('325','2013-06-30','16:05:00',3.75),('325','2013-06-30','16:10:00',3.73),('325','2013-06-30','16:15:00',3.46),('325','2013-06-30','16:20:00',3.54),('325','2013-06-30','16:25:00',3.69),('325','2013-06-30','16:30:00',3.58),('325','2013-06-30','16:35:00',3.49),('325','2013-06-30','16:40:00',3.31),('325','2013-06-30','16:45:00',3.26),('325','2013-06-30','16:50:00',3.19),('325','2013-06-30','16:55:00',3.08),('325','2013-06-30','17:00:00',2.95),('325','2013-06-30','17:05:00',2.81),('325','2013-06-30','17:10:00',2.7),('325','2013-06-30','17:15:00',2.69),('325','2013-06-30','17:20:00',2.6),('325','2013-06-30','17:25:00',2.51),('325','2013-06-30','17:30:00',2.41),('325','2013-06-30','17:35:00',2.32),('325','2013-06-30','17:40:00',2.25),('325','2013-06-30','17:45:00',2.15),('325','2013-06-30','17:50:00',2.06),('325','2013-06-30','17:55:00',1.97),('325','2013-06-30','18:00:00',1.81),('325','2013-06-30','18:05:00',1.71),('325','2013-06-30','18:10:00',1.67),('325','2013-06-30','18:15:00',1.55),('325','2013-06-30','18:20:00',1.39),('325','2013-06-30','18:25:00',1.23),('325','2013-06-30','18:30:00',1.12),('325','2013-06-30','18:35:00',1.03),('325','2014-04-04','09:05:00',1.43),('325','2014-04-04','09:10:00',1.76),('325','2014-04-04','09:15:00',1.69),('325','2014-04-04','09:20:00',1.22),('325','2014-04-04','13:10:00',1.29),('325','2014-04-04','13:20:00',1.93),('325','2014-04-04','13:25:00',2.26),('325','2014-04-04','13:30:00',2.39),('325','2014-04-04','13:35:00',3.11),('325','2014-04-04','13:40:00',5.17),('325','2014-04-04','13:45:00',3.37),('325','2014-04-04','13:50:00',4.5),('325','2014-04-04','13:55:00',2),('325','2014-04-04','14:00:00',3.65),('325','2014-04-04','14:05:00',4.65),('325','2014-04-04','14:10:00',4.95),('325','2014-04-04','14:15:00',3.19),('325','2014-04-04','14:20:00',3.39),('325','2014-04-04','14:25:00',2.76),('325','2014-04-04','14:30:00',1.31),('325','2014-04-04','14:35:00',1.81),('325','2014-04-04','14:40:00',1.48),('325','2014-04-04','14:45:00',1.81),('325','2014-04-04','14:50:00',3.45),('325','2014-04-04','14:55:00',4.71),('325','2014-04-04','15:00:00',4.46),('325','2014-04-04','15:05:00',3.47),('325','2014-04-04','15:10:00',3.05),('325','2014-04-04','15:15:00',3.02),('325','2014-04-04','15:20:00',2.21),('325','2014-04-04','15:25:00',2.25),('325','2014-04-04','15:30:00',1.61),('325','2014-04-04','15:35:00',1.36),('325','2014-04-04','15:40:00',2.53),('325','2014-04-04','15:45:00',2.02),('325','2014-04-04','15:50:00',1.88),('325','2014-04-04','15:55:00',3.52),('325','2014-04-04','16:00:00',3.7),('325','2014-04-04','16:05:00',2.96),('325','2014-04-04','16:10:00',3.74),('325','2014-04-04','16:15:00',1.71),('325','2014-04-04','16:20:00',1.24),('325','2014-04-04','16:25:00',1.13),('325','2014-04-04','16:30:00',2.02),('325','2014-04-04','16:35:00',1.64),('325','2014-04-04','16:40:00',1.51),('325','2014-04-04','16:45:00',2.85),('325','2014-04-04','16:50:00',2.61),('325','2014-04-04','16:55:00',2.66),('325','2014-04-04','17:00:00',2.25),('325','2014-04-04','17:05:00',2.01),('325','2014-04-04','17:10:00',2.35),('325','2014-04-04','17:15:00',1.89),('325','2014-04-04','17:20:00',2.37),('325','2014-04-04','17:25:00',2.12),('325','2014-04-04','17:30:00',2.36),('325','2014-04-04','17:35:00',1.76),('325','2014-04-04','17:40:00',1.2),('325','2014-04-04','17:45:00',1.71),('325','2014-04-04','17:50:00',1.61),('325','2014-04-04','17:55:00',1.38),('325','2014-04-04','18:00:00',1.25),('325','2014-04-04','18:05:00',1.11),('325','2013-06-29','07:55:00',1.1),('325','2013-06-29','08:00:00',1.3),('325','2013-06-29','08:05:00',1.44),('325','2013-06-29','08:10:00',1.43),('325','2013-06-29','08:15:00',1.26),('325','2013-06-29','08:25:00',1.26),('325','2013-06-29','08:30:00',1.22),('325','2013-06-29','08:35:00',1.32),('325','2013-06-29','08:45:00',1.29),('325','2013-06-29','08:50:00',1.42),('325','2013-06-29','08:55:00',1.4),('325','2013-06-29','09:00:00',1.46),('325','2013-06-29','09:05:00',1.5),('325','2013-06-29','09:10:00',1.54),('325','2013-06-29','09:15:00',1.58),('325','2013-06-29','09:20:00',1.62),('325','2013-06-29','09:25:00',1.67),('325','2013-06-29','09:30:00',1.69),('325','2013-06-29','09:35:00',2.1),('325','2013-06-29','09:40:00',2.77),('325','2013-06-29','09:45:00',2.91),('325','2013-06-29','09:50:00',2.99),('325','2013-06-29','09:55:00',3.05),('325','2013-06-29','10:00:00',3.13),('325','2013-06-29','10:05:00',3.22),('325','2013-06-29','10:10:00',3.28),('325','2013-06-29','10:15:00',3.32),('325','2013-06-29','10:20:00',3.37),('325','2013-06-29','10:25:00',3.47),('325','2013-06-29','10:30:00',3.54),('325','2013-06-29','10:35:00',3.61),('325','2013-06-29','10:40:00',3.71),('325','2013-06-29','10:45:00',3.71),('325','2013-06-29','10:50:00',1.06),('325','2013-06-29','10:55:00',3.52),('325','2013-06-29','11:00:00',4.14),('325','2013-06-29','11:05:00',4.14),('325','2013-06-29','11:10:00',4.19),('325','2013-06-29','11:15:00',4.32),('325','2013-06-29','11:20:00',3.9),('325','2013-06-29','11:25:00',4.68),('325','2013-06-29','11:30:00',3.69),('325','2013-06-29','11:35:00',2.98),('325','2013-06-29','11:40:00',2.76),('325','2013-06-29','11:45:00',5.08),('325','2013-06-29','11:50:00',5.12),('325','2013-06-29','11:55:00',3.66),('325','2013-06-29','12:00:00',4.06),('325','2013-06-29','12:05:00',4.26),('325','2013-06-29','12:10:00',4.76),('325','2013-06-29','12:15:00',4.57),('325','2013-06-29','12:20:00',2.74),('325','2013-06-29','12:25:00',4.44),('325','2013-06-29','12:30:00',4.82),('325','2013-06-29','12:35:00',1.95),('325','2013-06-29','12:40:00',3.28),('325','2013-06-29','12:45:00',5.26),('325','2013-06-29','12:50:00',3.81),('325','2013-06-29','12:55:00',5.14),('325','2013-06-29','13:00:00',3.22),('325','2013-06-29','13:05:00',4.55),('325','2013-06-29','13:10:00',4.71),('325','2013-06-29','13:15:00',4),('325','2013-06-29','13:20:00',2.26),('325','2013-06-29','13:25:00',3.37),('325','2013-06-29','13:30:00',1.11),('325','2013-06-29','13:40:00',1.07),('325','2013-06-29','13:45:00',1.79),('325','2013-06-29','13:50:00',1.94),('325','2013-06-29','13:55:00',4.39),('325','2013-06-29','14:00:00',5.09),('325','2013-06-29','14:05:00',5.03),('325','2013-06-29','14:10:00',4.83),('325','2013-06-29','14:15:00',4.81),('325','2013-06-29','14:20:00',5.04),('325','2013-06-29','14:25:00',4.95),('325','2013-06-29','14:30:00',4.7),('325','2013-06-29','14:35:00',4.76),('325','2013-06-29','14:40:00',4.83),('325','2013-06-29','14:45:00',4.93),('325','2013-06-29','14:50:00',5.15),('325','2013-06-29','14:55:00',4),('325','2013-06-29','15:00:00',4.39),('325','2013-06-29','15:05:00',5.29),('325','2013-06-29','15:10:00',3.34),('325','2013-06-29','15:15:00',3.59),('325','2013-06-29','15:20:00',1.72),('325','2013-06-29','15:25:00',1.36),('325','2013-06-29','16:40:00',1.28),('325','2013-06-29','16:45:00',1.75),('325','2013-06-29','16:50:00',2.88),('325','2013-06-29','16:55:00',1.3),('325','2013-06-29','17:00:00',1.32),('325','2013-06-29','17:05:00',1.62),('325','2013-06-29','17:10:00',1.17),('325','2013-06-29','17:15:00',1.12),('325','2013-06-29','17:20:00',1.4),('325','2013-06-29','17:25:00',1.66),('325','2013-06-29','17:30:00',3.09),('325','2013-06-29','17:35:00',1.88),('325','2013-06-29','17:40:00',1.4),('325','2013-06-29','17:45:00',2.26),('325','2013-06-29','17:50:00',1.97),('325','2013-06-29','17:55:00',2.03),('325','2013-06-29','18:00:00',1.85),('325','2013-06-29','18:05:00',1.68),('325','2013-06-29','18:20:00',1.35),('325','2013-06-28','08:20:00',1.03),('325','2013-06-28','08:25:00',1.06),('325','2013-06-28','08:30:00',1.17),('325','2013-06-28','08:35:00',1.25),('325','2013-06-28','08:40:00',1.31),('325','2013-06-28','08:45:00',1.37),('325','2013-06-28','08:50:00',1.43),('325','2013-06-28','08:55:00',1.47),('325','2013-06-28','09:00:00',1.5),('325','2013-06-28','09:05:00',1.6),('325','2013-06-28','09:10:00',1.75),('325','2013-06-28','09:15:00',1.99),('325','2013-06-28','09:25:00',1.02),('325','2013-06-28','09:30:00',2.65),('325','2013-06-28','09:35:00',2.81),('325','2013-06-28','09:40:00',2.98),('325','2013-06-28','09:45:00',3.11),('325','2013-06-28','09:50:00',2.52),('325','2013-06-28','09:55:00',2.44),('325','2013-06-28','10:00:00',1.8),('325','2013-06-28','10:05:00',3.42),('325','2013-06-28','10:10:00',3.53),('325','2013-06-28','10:15:00',2.97),('325','2013-06-28','10:20:00',1.44),('325','2013-06-28','10:25:00',1.45),('325','2013-06-28','10:30:00',4.35),('325','2013-06-28','10:35:00',4.56),('325','2013-06-28','10:40:00',2.9),('325','2013-06-28','10:45:00',3.33),('325','2013-06-28','10:50:00',2.28),('325','2013-06-28','10:55:00',2.4),('325','2013-06-28','11:00:00',2.26),('325','2013-06-28','11:05:00',2.17),('325','2013-06-28','11:10:00',1.76),('325','2013-06-28','11:15:00',2.24),('325','2013-06-28','11:20:00',2.11),('325','2013-06-28','11:25:00',4.4),('325','2013-06-28','11:30:00',4.61),('325','2013-06-28','11:35:00',3.84),('325','2013-06-28','11:40:00',4.34),('325','2013-06-28','11:45:00',4.46),('325','2013-06-28','11:50:00',3.97),('325','2013-06-28','11:55:00',2.71),('325','2013-06-28','12:00:00',2.47),('325','2013-06-28','12:05:00',2.91),('325','2013-06-28','12:10:00',4.08),('325','2013-06-28','12:15:00',5.06),('325','2013-06-28','12:20:00',4.74),('325','2013-06-28','12:25:00',3.68),('325','2013-06-28','12:30:00',4.87),('325','2013-06-28','12:35:00',3.55),('325','2013-06-28','12:40:00',2.54),('325','2013-06-28','12:45:00',5),('325','2013-06-28','12:50:00',4.94),('325','2013-06-28','12:55:00',4.82),('325','2013-06-28','13:00:00',4.85),('325','2013-06-28','13:05:00',3.91),('325','2013-06-28','13:10:00',3.64),('325','2013-06-28','13:15:00',4.98),('325','2013-06-28','13:20:00',4.82),('325','2013-06-28','13:25:00',4.82),('325','2013-06-28','13:30:00',4.8),('325','2013-06-28','13:35:00',4.89),('325','2013-06-28','13:40:00',4.62),('325','2013-06-28','13:45:00',4.89),('325','2013-06-28','13:50:00',4.5),('325','2013-06-28','13:55:00',4.33),('325','2013-06-28','14:00:00',3.96),('325','2013-06-28','14:05:00',4.98),('325','2013-06-28','14:10:00',4.26),('325','2013-06-28','14:15:00',4),('325','2013-06-28','14:20:00',4.34),('325','2013-06-28','14:25:00',2.02),('325','2013-06-28','14:30:00',2.74),('325','2013-06-28','14:35:00',4.51),('325','2013-06-28','14:40:00',4.9),('325','2013-06-28','14:45:00',4.87),('325','2013-06-28','14:50:00',4.45),('325','2013-06-28','14:55:00',4.53),('325','2013-06-28','15:00:00',3.41),('325','2013-06-28','15:05:00',4.49),('325','2013-06-28','15:10:00',4.54),('325','2013-06-28','15:15:00',4.6),('325','2013-06-28','15:20:00',4.55),('325','2013-06-28','15:25:00',4.45),('325','2013-06-28','15:30:00',3.91),('325','2013-06-28','15:35:00',3.64),('325','2013-06-28','15:40:00',2.77),('325','2013-06-28','15:45:00',2.72),('325','2013-06-28','15:50:00',3.09),('325','2013-06-28','15:55:00',3.9),('325','2013-06-28','16:00:00',3.89),('325','2013-06-28','16:05:00',2.89),('325','2013-06-28','16:10:00',1.03),('325','2013-06-28','16:15:00',2.52),('325','2013-06-28','16:20:00',3.34),('325','2013-06-28','16:25:00',2.26),('325','2013-06-28','16:30:00',3.97),('325','2013-06-28','16:35:00',1.16),('325','2013-06-28','16:40:00',2.4),('325','2013-06-28','16:45:00',3.04),('325','2013-06-28','16:50:00',3.72),('325','2013-06-28','16:55:00',3.27),('325','2013-06-28','17:00:00',3.11),('325','2013-06-28','17:05:00',2.31),('325','2013-06-28','17:10:00',2.46),('325','2013-06-28','17:15:00',2.68),('325','2013-06-28','17:20:00',2.65),('325','2013-06-28','17:25:00',2.64),('325','2013-06-28','17:30:00',2.55),('325','2013-06-28','17:35:00',2.43),('325','2013-06-28','17:40:00',2.3),('325','2013-06-28','17:45:00',2.23),('325','2013-06-28','17:50:00',2.15),('325','2013-06-28','17:55:00',2.06),('325','2013-06-28','18:00:00',1.93),('325','2013-06-28','18:05:00',1.84),('325','2013-06-28','18:10:00',1.75),('325','2013-06-28','18:15:00',1.63),('325','2013-06-28','18:20:00',1.45),('325','2013-06-28','18:25:00',1.04),('325','2013-06-27','08:15:00',1.02),('325','2013-06-27','08:20:00',1.07),('325','2013-06-27','08:25:00',1.13),('325','2013-06-27','08:30:00',1.18),('325','2013-06-27','08:35:00',1.23),('325','2013-06-27','08:40:00',1.29),('325','2013-06-27','08:45:00',1.33),('325','2013-06-27','08:50:00',1.36),('325','2013-06-27','08:55:00',1.4),('325','2013-06-27','09:00:00',1.41),('325','2013-06-27','09:05:00',1.42),('325','2013-06-27','09:10:00',1.47),('325','2013-06-27','09:15:00',1.49),('325','2013-06-27','09:20:00',1.57),('325','2013-06-27','09:25:00',1.61),('325','2013-06-27','09:30:00',1.66),('325','2013-06-27','09:35:00',2.03),('325','2013-06-27','09:40:00',2.71),('325','2013-06-27','09:45:00',2.79),('325','2013-06-27','09:50:00',2.93),('325','2013-06-27','09:55:00',3.02),('325','2013-06-27','10:00:00',2.86),('325','2013-06-27','10:05:00',2.93),('325','2013-06-27','10:10:00',2.99),('325','2013-06-27','10:15:00',2.96),('325','2013-06-27','10:20:00',3.02),('325','2013-06-27','10:25:00',3.25),('325','2013-06-27','10:30:00',3.44),('325','2013-06-27','10:35:00',3.09),('325','2013-06-27','10:40:00',3.52),('325','2013-06-27','10:45:00',4.03),('325','2013-06-27','10:50:00',3.3),('325','2013-06-27','10:55:00',4.06),('325','2013-06-27','11:00:00',4.16),('325','2013-06-27','11:05:00',4.27),('325','2013-06-27','11:10:00',4.33),('325','2013-06-27','11:15:00',4.37),('325','2013-06-27','11:20:00',4.38),('325','2013-06-27','11:25:00',4.44),('325','2013-06-27','11:30:00',4.4),('325','2013-06-27','11:35:00',4.42),('325','2013-06-27','11:40:00',4.61),('325','2013-06-27','11:45:00',4.64),('325','2013-06-27','11:50:00',4.56),('325','2013-06-27','11:55:00',1.51),('325','2013-06-27','12:00:00',1.57),('325','2013-06-27','12:05:00',1.29),('325','2013-06-27','12:10:00',1.24),('325','2013-06-27','12:15:00',1.08),('325','2013-06-27','12:20:00',1.17),('325','2013-06-27','12:25:00',2.66),('325','2013-06-27','12:30:00',3.06),('325','2013-06-27','12:35:00',4.23),('325','2013-06-27','12:40:00',1.9),('325','2013-06-27','12:45:00',1.82),('325','2013-06-27','12:50:00',1.72),('325','2013-06-27','12:55:00',1.2),('325','2013-06-27','13:00:00',1.06),('325','2013-06-27','13:05:00',1.41),('325','2013-06-27','13:10:00',1.5),('325','2013-06-27','13:15:00',1.61),('325','2013-06-27','13:20:00',1.59),('325','2013-06-27','13:25:00',1.69),('325','2013-06-27','13:30:00',1.48),('325','2013-06-27','13:35:00',1.41),('325','2013-06-27','13:40:00',1.34),('325','2013-06-27','13:45:00',1.55),('325','2013-06-27','13:50:00',1.83),('325','2013-06-27','13:55:00',1.55),('325','2013-06-27','14:00:00',1.54),('325','2013-06-27','14:05:00',1.5),('325','2013-06-27','14:10:00',2.14),('325','2013-06-27','14:15:00',4.56),('325','2013-06-27','14:20:00',2.83),('325','2013-06-27','14:25:00',2.7),('325','2013-06-27','14:30:00',4.04),('325','2013-06-27','14:35:00',3.14),('325','2013-06-27','14:40:00',4.62),('325','2013-06-27','14:45:00',3.92),('325','2013-06-27','14:50:00',1.89),('325','2013-06-27','14:55:00',4.41),('325','2013-06-27','15:00:00',4.28),('325','2013-06-27','15:05:00',4.2),('325','2013-06-27','15:10:00',4.16),('325','2013-06-27','15:15:00',4.11),('325','2013-06-27','15:20:00',4.08),('325','2013-06-27','15:25:00',4.09),('325','2013-06-27','15:30:00',4.02),('325','2013-06-27','15:35:00',3.97),('325','2013-06-27','15:40:00',3.94),('325','2013-06-27','15:45:00',3.87),('325','2013-06-27','15:50:00',3.85),('325','2013-06-27','15:55:00',3.75),('325','2013-06-27','16:00:00',3.65),('325','2013-06-27','16:05:00',3.56),('325','2013-06-27','16:10:00',3.53),('325','2013-06-27','16:15:00',3.51),('325','2013-06-27','16:20:00',3.47),('325','2013-06-27','16:25:00',3.43),('325','2013-06-27','16:30:00',3.37),('325','2013-06-27','16:35:00',3.1),('325','2013-06-27','16:40:00',3.18),('325','2013-06-27','16:45:00',3.17),('325','2013-06-27','16:50:00',3.06),('325','2013-06-27','16:55:00',2.96),('325','2013-06-27','17:00:00',2.9),('325','2013-06-27','17:05:00',2.76),('325','2013-06-27','17:10:00',2.62),('325','2013-06-27','17:15:00',2.54),('325','2013-06-27','17:20:00',2.61),('325','2013-06-27','17:25:00',2.51),('325','2013-06-27','17:30:00',2.45),('325','2013-06-27','17:35:00',2.34),('325','2013-06-27','17:40:00',1.65),('325','2013-06-27','17:45:00',1.11),('325','2013-06-27','17:50:00',2),('325','2013-06-27','17:55:00',1.93),('325','2013-06-27','18:00:00',1.79),('325','2013-06-27','18:05:00',1.72),('325','2013-06-27','18:10:00',1.61),('325','2013-06-27','18:15:00',1.45),('325','2013-06-27','18:20:00',1.3),('325','2013-06-27','18:25:00',1.23),('325','2013-06-27','18:30:00',1.14),('325','2013-06-27','18:35:00',1.02),('325','2013-06-26','08:15:00',1.01),('325','2013-06-26','08:20:00',1.05),('325','2013-06-26','08:25:00',1.12),('325','2013-06-26','08:30:00',1.17),('325','2013-06-26','08:35:00',1.23),('325','2013-06-26','08:40:00',1.29),('325','2013-06-26','08:45:00',1.33),('325','2013-06-26','08:50:00',1.35),('325','2013-06-26','08:55:00',1.35),('325','2013-06-26','09:00:00',1.35),('325','2013-06-26','09:05:00',1.38),('325','2013-06-26','09:10:00',1.44),('325','2013-06-26','09:15:00',1.45),('325','2013-06-26','09:20:00',1.47),('325','2013-06-26','09:25:00',1.77),('325','2013-06-26','09:30:00',2.5),('325','2013-06-26','09:35:00',2.55),('325','2013-06-26','09:40:00',2.63),('325','2013-06-26','09:45:00',2.73),('325','2013-06-26','09:50:00',2.8),('325','2013-06-26','09:55:00',2.81),('325','2013-06-26','10:00:00',2.85),('325','2013-06-26','10:05:00',2.93),('325','2013-06-26','10:10:00',3.04),('325','2013-06-26','10:15:00',3.17),('325','2013-06-26','10:20:00',3.2),('325','2013-06-26','10:25:00',3.19),('325','2013-06-26','10:30:00',3.21),('325','2013-06-26','10:35:00',3.36),('325','2013-06-26','10:40:00',3.45),('325','2013-06-26','10:45:00',3.5),('325','2013-06-26','10:50:00',3.51),('325','2013-06-26','10:55:00',3.52),('325','2013-06-26','11:00:00',3.62),('325','2013-06-26','11:05:00',3.64),('325','2013-06-26','11:10:00',3.71),('325','2013-06-26','11:15:00',3.81),('325','2013-06-26','11:20:00',3.92),('325','2013-06-26','11:25:00',3.99),('325','2013-06-26','11:30:00',3.95),('325','2013-06-26','11:35:00',3.92),('325','2013-06-26','11:40:00',3.87),('325','2013-06-26','11:45:00',3.9),('325','2013-06-26','11:50:00',3.94),('325','2013-06-26','11:55:00',4),('325','2013-06-26','12:00:00',4.1),('325','2013-06-26','12:05:00',4.27),('325','2013-06-26','12:10:00',4.32),('325','2013-06-26','12:15:00',4.41),('325','2013-06-26','12:20:00',4.34),('325','2013-06-26','12:25:00',4.2),('325','2013-06-26','12:30:00',4.16),('325','2013-06-26','12:40:00',3.13),('325','2013-06-26','12:45:00',2.48),('325','2013-06-26','12:50:00',1.09),('325','2013-06-26','12:55:00',1.07),('325','2013-06-26','13:00:00',1.22),('325','2013-06-26','13:05:00',1.16),('325','2013-06-26','13:10:00',2.4),('325','2013-06-26','13:15:00',3.98),('325','2013-06-26','13:20:00',1.13),('325','2013-06-26','13:25:00',1.62),('325','2013-06-26','13:30:00',5.34),('325','2013-06-26','13:35:00',2.49),('325','2013-06-26','13:40:00',1.17),('325','2013-06-26','13:45:00',1.84),('325','2013-06-26','13:50:00',5.32),('325','2013-06-26','13:55:00',1.66),('325','2013-06-26','14:00:00',4.15),('325','2013-06-26','14:05:00',4.67),('325','2013-06-26','14:10:00',4.66),('325','2013-06-26','14:15:00',4.54),('325','2013-06-26','14:20:00',4.51),('325','2013-06-26','14:25:00',4.62),('325','2013-06-26','14:30:00',4.66),('325','2013-06-26','14:35:00',4.41),('325','2013-06-26','14:40:00',4.58),('325','2013-06-26','14:45:00',3.37),('325','2013-06-26','14:50:00',4.59),('325','2013-06-26','14:55:00',4.48),('325','2013-06-26','15:00:00',4.28),('325','2013-06-26','15:05:00',4.28),('325','2013-06-26','15:10:00',4.21),('325','2013-06-26','15:15:00',4.17),('325','2013-06-26','15:20:00',4.16),('325','2013-06-26','15:25:00',4.09),('325','2013-06-26','15:30:00',4.04),('325','2013-06-26','15:35:00',4.04),('325','2013-06-26','15:40:00',3.98),('325','2013-06-26','15:45:00',3.88),('325','2013-06-26','15:50:00',3.88),('325','2013-06-26','15:55:00',3.78),('325','2013-06-26','16:00:00',3.74),('325','2013-06-26','16:05:00',3.71),('325','2013-06-26','16:10:00',3.63),('325','2013-06-26','16:15:00',3.57),('325','2013-06-26','16:20:00',3.51),('325','2013-06-26','16:25:00',3.46),('325','2013-06-26','16:30:00',3.39),('325','2013-06-26','16:35:00',3.31),('325','2013-06-26','16:40:00',3.22),('325','2013-06-26','16:45:00',3.16),('325','2013-06-26','16:50:00',3.08),('325','2013-06-26','16:55:00',3.03),('325','2013-06-26','17:00:00',2.97),('325','2013-06-26','17:05:00',2.85),('325','2013-06-26','17:10:00',2.75),('325','2013-06-26','17:15:00',2.69),('325','2013-06-26','17:20:00',2.59),('325','2013-06-26','17:25:00',2.5),('325','2013-06-26','17:30:00',2.42),('325','2013-06-26','17:35:00',2.34),('325','2013-06-26','17:40:00',2.24),('325','2013-06-26','17:45:00',2.15),('325','2013-06-26','17:50:00',2.05),('325','2013-06-26','17:55:00',1.96),('325','2013-06-26','18:00:00',1.82),('325','2013-06-26','18:05:00',1.81),('325','2013-06-26','18:10:00',2.01),('325','2013-06-26','18:15:00',1.49),('325','2013-06-25','08:25:00',1.14),('325','2013-06-25','08:30:00',1.22),('325','2013-06-25','08:35:00',1.26),('325','2013-06-25','08:40:00',1.32),('325','2013-06-25','08:45:00',1.35),('325','2013-06-25','08:50:00',1.36),('325','2013-06-25','08:55:00',1.37),('325','2013-06-25','09:00:00',1.37),('325','2013-06-25','09:05:00',1.4),('325','2013-06-25','09:10:00',1.45),('325','2013-06-25','09:15:00',1.75),('325','2013-06-25','09:20:00',2.19),('325','2013-06-25','09:25:00',2.14),('325','2013-06-25','09:30:00',2.71),('325','2013-06-25','09:35:00',2.85),('325','2013-06-25','09:40:00',2.94),('325','2013-06-25','09:45:00',2.45),('325','2013-06-25','09:50:00',1.19),('325','2013-06-25','09:55:00',2.22),('325','2013-06-25','10:00:00',2.35),('325','2013-06-25','10:05:00',3.33),('325','2013-06-25','10:10:00',3.67),('325','2013-06-25','10:15:00',3.76),('325','2013-06-25','10:20:00',2.66),('325','2013-06-25','10:30:00',3.74),('325','2013-06-25','10:35:00',4.06),('325','2013-06-25','10:40:00',4.01),('325','2013-06-25','10:45:00',3.68),('325','2013-06-25','10:55:00',3.53),('325','2013-06-25','11:00:00',1.85),('325','2013-06-25','11:05:00',2.65),('325','2013-06-25','11:10:00',2.03),('325','2013-06-25','11:15:00',2.3),('325','2013-06-25','11:20:00',1.11),('325','2013-06-25','11:25:00',1.1),('325','2013-06-25','11:30:00',1.13),('325','2013-06-25','11:35:00',2.93),('325','2013-06-25','11:40:00',5.34),('325','2013-06-25','11:45:00',4.32),('325','2013-06-25','11:50:00',4.67),('325','2013-06-25','11:55:00',1.6),('325','2013-06-25','12:00:00',1.12),('325','2013-06-25','12:05:00',1.01),('325','2013-06-25','12:10:00',1.1),('325','2013-06-25','12:15:00',1.1),('325','2013-06-25','12:20:00',1.34),('325','2013-06-25','12:25:00',1.41),('325','2013-06-25','12:30:00',1.58),('325','2013-06-25','12:35:00',3.8),('325','2013-06-25','12:40:00',2.09),('325','2013-06-25','12:45:00',5.07),('325','2013-06-25','12:50:00',2.02),('325','2013-06-25','12:55:00',1.96),('325','2013-06-25','13:00:00',4.49),('325','2013-06-25','13:05:00',3.21),('325','2013-06-25','13:10:00',3.41),('325','2013-06-25','13:15:00',4.76),('325','2013-06-25','13:20:00',4.32),('325','2013-06-25','13:25:00',3.72),('325','2013-06-25','13:30:00',4.15),('325','2013-06-25','13:35:00',4.04),('325','2013-06-25','13:40:00',5.03),('325','2013-06-25','13:45:00',4.69),('325','2013-06-25','13:50:00',3.95),('325','2013-06-25','13:55:00',4.43),('325','2013-06-25','14:00:00',4.1),('325','2013-06-25','14:05:00',4.7),('325','2013-06-25','14:10:00',4.71),('325','2013-06-25','14:15:00',4.71),('325','2013-06-25','14:20:00',4.43),('325','2013-06-25','14:25:00',4.49),('325','2013-06-25','14:30:00',4.39),('325','2013-06-25','14:35:00',4.29),('325','2013-06-25','14:40:00',4.45),('325','2013-06-25','14:45:00',4.44),('325','2013-06-25','14:50:00',4.41),('325','2013-06-25','14:55:00',4.36),('325','2013-06-25','15:00:00',4.31),('325','2013-06-25','15:05:00',4.29),('325','2013-06-25','15:10:00',4.24),('325','2013-06-25','15:15:00',4.21),('325','2013-06-25','15:20:00',4.16),('325','2013-06-25','15:25:00',4.1),('325','2013-06-25','15:30:00',4.05),('325','2013-06-25','15:35:00',4.01),('325','2013-06-25','15:40:00',3.96),('325','2013-06-25','15:45:00',3.88),('325','2013-06-25','15:50:00',3.84),('325','2013-06-25','15:55:00',3.78),('325','2013-06-25','16:00:00',3.72),('325','2013-06-25','16:05:00',3.67),('325','2013-06-25','16:10:00',3.61),('325','2013-06-25','16:15:00',3.55),('325','2013-06-25','16:20:00',3.5),('325','2013-06-25','16:25:00',3.44),('325','2013-06-25','16:30:00',3.4),('325','2013-06-25','16:35:00',3.32),('325','2013-06-25','16:40:00',3.24),('325','2013-06-25','16:45:00',3.16),('325','2013-06-25','16:50:00',3.09),('325','2013-06-25','16:55:00',3.02),('325','2013-06-25','17:00:00',2.93),('325','2013-06-25','17:05:00',2.81),('325','2013-06-25','17:10:00',2.68),('325','2013-06-25','17:15:00',2.66),('325','2013-06-25','17:20:00',2.6),('325','2013-06-25','17:25:00',2.5),('325','2013-06-25','17:30:00',2.42),('325','2013-06-25','17:35:00',2.33),('325','2013-06-25','17:40:00',2.24),('325','2013-06-25','17:45:00',2.14),('325','2013-06-25','17:50:00',2.05),('325','2013-06-25','17:55:00',1.95),('325','2013-06-25','18:00:00',1.82),('325','2013-06-25','18:05:00',1.75),('325','2013-06-25','18:10:00',1.64),('325','2013-06-25','18:15:00',1.48),('325','2013-06-25','18:20:00',1.32),('325','2013-06-25','18:25:00',1.21),('325','2013-06-25','18:30:00',1.12),('325','2013-06-25','18:35:00',1.01),('325','2013-06-24','08:40:00',1.27),('325','2013-06-24','08:45:00',1.45),('325','2013-06-24','08:50:00',1.46),('325','2013-06-24','08:55:00',1.43),('325','2013-06-24','09:00:00',1.47),('325','2013-06-24','09:05:00',1.47),('325','2013-06-24','09:10:00',1.42),('325','2013-06-24','09:15:00',2.25),('325','2013-06-24','09:20:00',2.42),('325','2013-06-24','09:25:00',3.31),('325','2013-06-24','09:30:00',1.79),('325','2013-06-24','09:35:00',2.21),('325','2013-06-24','09:40:00',3.19),('325','2013-06-24','09:45:00',2.84),('325','2013-06-24','09:50:00',3.31),('325','2013-06-24','09:55:00',3.25),('325','2013-06-24','10:00:00',3.32),('325','2013-06-24','10:05:00',3.43),('325','2013-06-24','10:10:00',3.57),('325','2013-06-24','10:15:00',3.16),('325','2013-06-24','10:20:00',3.85),('325','2013-06-24','10:25:00',4.09),('325','2013-06-24','10:30:00',3.56),('325','2013-06-24','10:35:00',3.22),('325','2013-06-24','10:40:00',1.55),('325','2013-06-24','10:45:00',1.97),('325','2013-06-24','10:50:00',4.05),('325','2013-06-24','10:55:00',2.81),('325','2013-06-24','11:00:00',3.37),('325','2013-06-24','11:05:00',4.21),('325','2013-06-24','11:10:00',1.42),('325','2013-06-24','11:15:00',4.99),('325','2013-06-24','11:20:00',3.35),('325','2013-06-24','11:25:00',1.91),('325','2013-06-24','11:30:00',2.29),('325','2013-06-24','11:35:00',1.44),('325','2013-06-24','11:40:00',1.29),('325','2013-06-24','11:45:00',2.76),('325','2013-06-24','11:50:00',2.02),('325','2013-06-24','11:55:00',5.02),('325','2013-06-24','12:00:00',2.67),('325','2013-06-24','12:05:00',3.91),('325','2013-06-24','12:10:00',5.11),('325','2013-06-24','12:15:00',2.43),('325','2013-06-24','12:20:00',5.65),('325','2013-06-24','12:25:00',3.92),('325','2013-06-24','12:30:00',3.42),('325','2013-06-24','12:35:00',5.45),('325','2013-06-24','12:40:00',3.79),('325','2013-06-24','12:45:00',3.88),('325','2013-06-24','12:50:00',4.27),('325','2013-06-24','12:55:00',5.11),('325','2013-06-24','13:00:00',5.06),('325','2013-06-24','13:05:00',5.44),('325','2013-06-24','13:10:00',3.68),('325','2013-06-24','13:15:00',3.7),('325','2013-06-24','13:20:00',2.26),('325','2013-06-24','13:25:00',4.68),('325','2013-06-24','13:30:00',4.83),('325','2013-06-24','13:35:00',3.74),('325','2013-06-24','13:40:00',4.46),('325','2013-06-24','13:45:00',4.98),('325','2013-06-24','13:50:00',4.85),('325','2013-06-24','13:55:00',4.73),('325','2013-06-24','14:00:00',4.18),('325','2013-06-24','14:05:00',4.74),('325','2013-06-24','14:10:00',4.72),('325','2013-06-24','14:15:00',4.72),('325','2013-06-24','14:20:00',4.66),('325','2013-06-24','14:25:00',4.7),('325','2013-06-24','14:30:00',4.68),('325','2013-06-24','14:35:00',4.69),('325','2013-06-24','14:40:00',4.7),('325','2013-06-24','14:45:00',4.79),('325','2013-06-24','14:50:00',4.29),('325','2013-06-24','14:55:00',3.2),('325','2013-06-24','15:00:00',4.2),('325','2013-06-24','15:05:00',2.33),('325','2013-06-24','15:10:00',3.57),('325','2013-06-24','15:15:00',4.4),('325','2013-06-24','15:20:00',3.83),('325','2013-06-24','15:25:00',4.17),('325','2013-06-24','15:30:00',3.59),('325','2013-06-24','15:35:00',1.78),('325','2013-06-24','15:40:00',3.25),('325','2013-06-24','15:45:00',2.88),('325','2013-06-24','15:50:00',3.69),('325','2013-06-24','15:55:00',3.66),('325','2013-06-24','16:00:00',4.4),('325','2013-06-24','16:05:00',4),('325','2013-06-24','16:10:00',2.82),('325','2013-06-24','16:15:00',3.74),('325','2013-06-24','16:20:00',3.01),('325','2013-06-24','16:25:00',2.81),('325','2013-06-24','16:30:00',3.71),('325','2013-06-24','16:35:00',2.65),('325','2013-06-24','16:40:00',2.62),('325','2013-06-24','16:45:00',2.04),('325','2013-06-24','16:50:00',2.22),('325','2013-06-24','16:55:00',1.54),('325','2013-06-24','17:00:00',1.65),('325','2013-06-24','17:05:00',2.56),('325','2013-06-24','17:10:00',3.32),('325','2013-06-24','17:15:00',2.93),('325','2013-06-24','17:20:00',2.15),('325','2013-06-24','17:25:00',2.39),('325','2013-06-24','17:30:00',1.9),('325','2013-06-24','17:50:00',1.74),('325','2013-06-24','17:55:00',1.43),('325','2013-06-24','18:00:00',2.22),('325','2013-06-24','18:05:00',1.73),('325','2013-06-24','18:10:00',1.62),('325','2013-06-24','18:15:00',1.67),('325','2013-06-24','18:20:00',1.5),('325','2013-06-24','18:25:00',1.43),('325','2013-06-24','18:35:00',1.03),('325','2013-06-23','08:50:00',1.09),('325','2013-06-23','08:55:00',1.05),('325','2013-06-23','09:00:00',1.51),('325','2013-06-23','09:05:00',1.16),('325','2013-06-23','09:20:00',1.23),('325','2013-06-23','09:25:00',2.45),('325','2013-06-23','09:30:00',2.68),('325','2013-06-23','09:35:00',2.8),('325','2013-06-23','09:40:00',3.29),('325','2013-06-23','09:45:00',1.72),('325','2013-06-23','09:50:00',1.15),('325','2013-06-23','09:55:00',2.14),('325','2013-06-23','10:00:00',2.43),('325','2013-06-23','10:05:00',1.87),('325','2013-06-23','10:10:00',1.94),('325','2013-06-23','10:15:00',2.63),('325','2013-06-23','10:20:00',1.84),('325','2013-06-23','10:25:00',3.21),('325','2013-06-23','10:30:00',3.16),('325','2013-06-23','10:35:00',3.56),('325','2013-06-23','10:40:00',3.76),('325','2013-06-23','10:45:00',3.67),('325','2013-06-23','10:50:00',3.69),('325','2013-06-23','10:55:00',3.79),('325','2013-06-23','11:00:00',3.86),('325','2013-06-23','11:05:00',3.92),('325','2013-06-23','11:10:00',3.94),('325','2013-06-23','11:15:00',2.81),('325','2013-06-23','11:20:00',4.2),('325','2013-06-23','11:25:00',4.22),('325','2013-06-23','11:30:00',4.09),('325','2013-06-23','11:35:00',4.17),('325','2013-06-23','11:40:00',4.17),('325','2013-06-23','11:45:00',4.31),('325','2013-06-23','11:50:00',4.23),('325','2013-06-23','11:55:00',4.31),('325','2013-06-23','12:00:00',4.44),('325','2013-06-23','12:05:00',4.45),('325','2013-06-23','12:10:00',4.48),('325','2013-06-23','12:15:00',4.45),('325','2013-06-23','12:20:00',4.41),('325','2013-06-23','12:25:00',4.54),('325','2013-06-23','12:30:00',4.53),('325','2013-06-23','12:35:00',4.56),('325','2013-06-23','12:40:00',4.6),('325','2013-06-23','12:45:00',4.61),('325','2013-06-23','12:50:00',4.62),('325','2013-06-23','12:55:00',4.59),('325','2013-06-23','13:00:00',4.6),('325','2013-06-23','13:05:00',4.63),('325','2013-06-23','13:10:00',4.62),('325','2013-06-23','13:15:00',4.61),('325','2013-06-23','13:20:00',4.64),('325','2013-06-23','13:25:00',4.64),('325','2013-06-23','13:30:00',4.64),('325','2013-06-23','13:35:00',4.67),('325','2013-06-23','13:40:00',4.65),('325','2013-06-23','13:45:00',4.63),('325','2013-06-23','13:50:00',4.57),('325','2013-06-23','13:55:00',4.55),('325','2013-06-23','14:00:00',4.54),('325','2013-06-23','14:05:00',4.51),('325','2013-06-23','14:10:00',4.5),('325','2013-06-23','14:15:00',4.48),('325','2013-06-23','14:20:00',4.47),('325','2013-06-23','14:25:00',4.47),('325','2013-06-23','14:30:00',4.44),('325','2013-06-23','14:35:00',4.42),('325','2013-06-23','14:40:00',4.41),('325','2013-06-23','14:45:00',4.41),('325','2013-06-23','14:50:00',4.4),('325','2013-06-23','14:55:00',4.39),('325','2013-06-23','15:00:00',4.38),('325','2013-06-23','15:05:00',4.34),('325','2013-06-23','15:10:00',4.3),('325','2013-06-23','15:15:00',4.26),('325','2013-06-23','15:20:00',4.22),('325','2013-06-23','15:25:00',4.15),('325','2013-06-23','15:30:00',4.08),('325','2013-06-23','15:35:00',4.04),('325','2013-06-23','15:40:00',4),('325','2013-06-23','15:45:00',3.98),('325','2013-06-23','15:50:00',3.91),('325','2013-06-23','15:55:00',3.85),('325','2013-06-23','16:00:00',3.8),('325','2013-06-23','16:05:00',3.74),('325','2013-06-23','16:10:00',3.66),('325','2013-06-23','16:15:00',3.6),('325','2013-06-23','16:20:00',3.53),('325','2013-06-23','16:25:00',3.5),('325','2013-06-23','16:30:00',3.42),('325','2013-06-23','16:35:00',3.4),('325','2013-06-23','16:40:00',3.32),('325','2013-06-23','16:45:00',3.24),('325','2013-06-23','16:50:00',3.17),('325','2013-06-23','16:55:00',3.08),('325','2013-06-23','17:00:00',2.98),('325','2013-06-23','17:05:00',2.86),('325','2013-06-23','17:10:00',2.81),('325','2013-06-23','17:15:00',2.74),('325','2013-06-23','17:20:00',2.56),('325','2013-06-23','17:25:00',2.51),('325','2013-06-23','17:30:00',2.49),('325','2013-06-23','17:35:00',2.39),('325','2013-06-23','17:40:00',2.31),('325','2013-06-23','17:45:00',2.22),('325','2013-06-23','17:50:00',2.16),('325','2013-06-23','17:55:00',2.02),('325','2013-06-23','18:00:00',1.91),('325','2013-06-23','18:05:00',1.84),('325','2013-06-23','18:10:00',1.72),('325','2013-06-23','18:15:00',1.51),('325','2013-06-23','18:20:00',1.36),('325','2013-06-23','18:25:00',1.28),('325','2013-06-23','18:30:00',1.15),('325','2013-06-23','18:35:00',1.07),('325','2013-06-23','18:40:00',1.03),('325','2013-06-22','08:20:00',1.02),('325','2013-06-22','08:25:00',1.09),('325','2013-06-22','08:30:00',1.14),('325','2013-06-22','08:35:00',1.21),('325','2013-06-22','08:40:00',1.27),('325','2013-06-22','08:45:00',1.3),('325','2013-06-22','08:50:00',1.33),('325','2013-06-22','08:55:00',1.34),('325','2013-06-22','09:00:00',1.39),('325','2013-06-22','09:05:00',1.44),('325','2013-06-22','09:10:00',1.48),('325','2013-06-22','09:15:00',1.53),('325','2013-06-22','09:20:00',1.58),('325','2013-06-22','09:25:00',2.03),('325','2013-06-22','09:30:00',2.48),('325','2013-06-22','09:35:00',2.52),('325','2013-06-22','09:40:00',2.57),('325','2013-06-22','09:45:00',2.64),('325','2013-06-22','09:50:00',2.74),('325','2013-06-22','09:55:00',2.74),('325','2013-06-22','10:00:00',2.78),('325','2013-06-22','10:05:00',2.88),('325','2013-06-22','10:10:00',2.94),('325','2013-06-22','10:15:00',3.04),('325','2013-06-22','10:20:00',3.09),('325','2013-06-22','10:25:00',3.08),('325','2013-06-22','10:30:00',3.11),('325','2013-06-22','10:35:00',3.17),('325','2013-06-22','10:40:00',3.29),('325','2013-06-22','10:45:00',3.41),('325','2013-06-22','10:50:00',3.45),('325','2013-06-22','10:55:00',3.44),('325','2013-06-22','11:00:00',3.52),('325','2013-06-22','11:05:00',3.56),('325','2013-06-22','11:10:00',3.65),('325','2013-06-22','11:15:00',3.75),('325','2013-06-22','11:20:00',3.87),('325','2013-06-22','11:25:00',3.91),('325','2013-06-22','11:30:00',3.91),('325','2013-06-22','11:35:00',3.88),('325','2013-06-22','11:40:00',3.85),('325','2013-06-22','11:45:00',3.89),('325','2013-06-22','11:50:00',3.89),('325','2013-06-22','11:55:00',3.93),('325','2013-06-22','12:00:00',4.05),('325','2013-06-22','12:05:00',4.07),('325','2013-06-22','12:10:00',4.1),('325','2013-06-22','12:15:00',4.3),('325','2013-06-22','12:20:00',4.23),('325','2013-06-22','12:25:00',4.19),('325','2013-06-22','12:30:00',4.14),('325','2013-06-22','12:35:00',4.14),('325','2013-06-22','12:40:00',4.1),('325','2013-06-22','12:45:00',4.33),('325','2013-06-22','12:50:00',4.31),('325','2013-06-22','12:55:00',4.29),('325','2013-06-22','13:00:00',4.22),('325','2013-06-22','13:05:00',4.25),('325','2013-06-22','13:10:00',4.26),('325','2013-06-22','13:15:00',4.21),('325','2013-06-22','13:20:00',4.19),('325','2013-06-22','13:25:00',4.51),('325','2013-06-22','13:30:00',4.64),('325','2013-06-22','13:35:00',4.64),('325','2013-06-22','13:40:00',4.1),('325','2013-06-22','13:45:00',4.46),('325','2013-06-22','13:50:00',4.44),('325','2013-06-22','13:55:00',3.03),('325','2013-06-22','14:00:00',3.01),('325','2013-06-22','14:05:00',4.7),('325','2013-06-22','14:10:00',4.47),('325','2013-06-22','14:15:00',4.34),('325','2013-06-22','14:20:00',3.69),('325','2013-06-22','14:25:00',4.39),('325','2013-06-22','14:30:00',3.06),('325','2013-06-22','14:35:00',2.45),('325','2013-06-22','14:40:00',1.83),('325','2013-06-22','14:45:00',2.52),('325','2013-06-22','14:50:00',3.69),('325','2013-06-22','14:55:00',4.14),('325','2013-06-22','15:00:00',4.02),('325','2013-06-22','15:05:00',3.13),('325','2013-06-22','15:10:00',4.09),('325','2013-06-22','15:15:00',4.18),('325','2013-06-22','15:20:00',3.82),('325','2013-06-22','15:25:00',3.59),('325','2013-06-22','15:30:00',2.67),('325','2013-06-22','15:35:00',2.04),('325','2013-06-22','15:40:00',2.62),('325','2013-06-22','15:45:00',3.19),('325','2013-06-22','15:50:00',2.74),('325','2013-06-22','15:55:00',2.76),('325','2013-06-22','16:00:00',1.9),('325','2013-06-22','16:05:00',1.27),('325','2013-06-22','16:10:00',1.34),('325','2013-06-22','16:15:00',1.73),('325','2013-06-22','16:20:00',1.92),('325','2013-06-22','16:25:00',1.29),('325','2013-06-22','16:30:00',1.03),('325','2013-06-22','16:55:00',1.38),('325','2013-06-22','17:00:00',1.65),('325','2013-06-22','17:05:00',1.55),('325','2013-06-22','17:10:00',2.25),('325','2013-06-22','17:15:00',3.09),('325','2013-06-22','17:20:00',2.86),('325','2013-06-22','17:25:00',2.94),('325','2013-06-22','17:30:00',2.43),('325','2013-06-22','17:35:00',2.01),('325','2013-06-22','17:40:00',2.32),('325','2013-06-22','17:45:00',2.31),('325','2013-06-22','17:50:00',2.06),('325','2013-06-22','17:55:00',2.04),('325','2013-06-22','18:00:00',1.8),('325','2013-06-22','18:05:00',1.49),('325','2013-06-22','18:10:00',1.02),('325','2013-06-22','18:15:00',1.04),('325','2013-06-21','08:20:00',1.01),('325','2013-06-21','08:25:00',1.08),('325','2013-06-21','08:30:00',1.13),('325','2013-06-21','08:35:00',1.2),('325','2013-06-21','08:40:00',1.24),('325','2013-06-21','08:45:00',1.28),('325','2013-06-21','08:50:00',1.31),('325','2013-06-21','08:55:00',1.33),('325','2013-06-21','09:00:00',1.38),('325','2013-06-21','09:05:00',1.41),('325','2013-06-21','09:10:00',1.46),('325','2013-06-21','09:15:00',1.82),('325','2013-06-21','09:20:00',2.22),('325','2013-06-21','09:25:00',2.32),('325','2013-06-21','09:30:00',2.39),('325','2013-06-21','09:35:00',2.42),('325','2013-06-21','09:40:00',2.47),('325','2013-06-21','09:45:00',2.56),('325','2013-06-21','09:50:00',2.61),('325','2013-06-21','09:55:00',2.64),('325','2013-06-21','10:00:00',2.65),('325','2013-06-21','10:05:00',2.72),('325','2013-06-21','10:10:00',2.8),('325','2013-06-21','10:15:00',2.9),('325','2013-06-21','10:20:00',2.9),('325','2013-06-21','10:25:00',2.92),('325','2013-06-21','10:30:00',2.97),('325','2013-06-21','10:35:00',3.01),('325','2013-06-21','10:40:00',3.09),('325','2013-06-21','10:45:00',3.2),('325','2013-06-21','10:50:00',3.22),('325','2013-06-21','10:55:00',3.21),('325','2013-06-21','11:00:00',3.25),('325','2013-06-21','11:05:00',3.31),('325','2013-06-21','11:10:00',3.38),('325','2013-06-21','11:15:00',3.51),('325','2013-06-21','11:20:00',3.62),('325','2013-06-21','11:25:00',3.7),('325','2013-06-21','11:30:00',3.69),('325','2013-06-21','11:35:00',3.66),('325','2013-06-21','11:40:00',3.63),('325','2013-06-21','11:45:00',3.64),('325','2013-06-21','11:50:00',3.66),('325','2013-06-21','11:55:00',3.73),('325','2013-06-21','12:00:00',3.77),('325','2013-06-21','12:05:00',3.88),('325','2013-06-21','12:10:00',3.97),('325','2013-06-21','12:15:00',4),('325','2013-06-21','12:20:00',4),('325','2013-06-21','12:25:00',3.92),('325','2013-06-21','12:30:00',3.85),('325','2013-06-21','12:35:00',3.82),('325','2013-06-21','12:40:00',3.81),('325','2013-06-21','12:45:00',3.81),('325','2013-06-21','12:50:00',3.86),('325','2013-06-21','12:55:00',3.91),('325','2013-06-21','13:00:00',3.92),('325','2013-06-21','13:05:00',3.97),('325','2013-06-21','13:10:00',4.01),('325','2013-06-21','13:15:00',4),('325','2013-06-21','13:20:00',4),('325','2013-06-21','13:25:00',3.93),('325','2013-06-21','13:30:00',3.96),('325','2013-06-21','13:35:00',3.96),('325','2013-06-21','13:40:00',3.98),('325','2013-06-21','13:45:00',3.99),('325','2013-06-21','13:50:00',4),('325','2013-06-21','13:55:00',4.1),('325','2013-06-21','14:00:00',4.08),('325','2013-06-21','14:05:00',4.05),('325','2013-06-21','14:10:00',3.98),('325','2013-06-21','14:15:00',3.96),('325','2013-06-21','14:20:00',3.97),('325','2013-06-21','14:25:00',3.97),('325','2013-06-21','14:30:00',3.93),('325','2013-06-21','14:35:00',3.97),('325','2013-06-21','14:40:00',4.14),('325','2013-06-21','14:45:00',4.13),('325','2013-06-21','14:50:00',4.13),('325','2013-06-21','14:55:00',4.12),('325','2013-06-21','15:00:00',4.09),('325','2013-06-21','15:05:00',4.06),('325','2013-06-21','15:10:00',4.03),('325','2013-06-21','15:15:00',4.01),('325','2013-06-21','15:20:00',3.96),('325','2013-06-21','15:25:00',3.91),('325','2013-06-21','15:30:00',3.88),('325','2013-06-21','15:35:00',3.83),('325','2013-06-21','15:40:00',3.79),('325','2013-06-21','15:45:00',3.73),('325','2013-06-21','15:50:00',3.66),('325','2013-06-21','15:55:00',3.62),('325','2013-06-21','16:00:00',3.56),('325','2013-06-21','16:05:00',3.51),('325','2013-06-21','16:10:00',3.47),('325','2013-06-21','16:15:00',3.41),('325','2013-06-21','16:20:00',3.38),('325','2013-06-21','16:25:00',3.33),('325','2013-06-21','16:30:00',3.27),('325','2013-06-21','16:35:00',3.21),('325','2013-06-21','16:40:00',3.13),('325','2013-06-21','16:45:00',3.07),('325','2013-06-21','16:50:00',3),('325','2013-06-21','16:55:00',2.93),('325','2013-06-21','17:00:00',2.84),('325','2013-06-21','17:05:00',2.72),('325','2013-06-21','17:10:00',2.61),('325','2013-06-21','17:15:00',2.59),('325','2013-06-21','17:20:00',2.5),('325','2013-06-21','17:25:00',2.42),('325','2013-06-21','17:30:00',2.34),('325','2013-06-21','17:35:00',2.25),('325','2013-06-21','17:40:00',2.17),('325','2013-06-21','17:45:00',2.08),('325','2013-06-21','17:50:00',1.99),('325','2013-06-21','17:55:00',1.88),('325','2013-06-21','18:00:00',1.77),('325','2013-06-21','18:05:00',1.71),('325','2013-06-21','18:10:00',1.6),('325','2013-06-21','18:15:00',1.41),('325','2013-06-21','18:20:00',1.25),('325','2013-06-21','18:25:00',1.16),('325','2013-06-21','18:30:00',1.05),('325','2013-06-20','08:20:00',1),('325','2013-06-20','08:25:00',1.06),('325','2013-06-20','08:30:00',1.11),('325','2013-06-20','08:35:00',1.18),('325','2013-06-20','08:40:00',1.22),('325','2013-06-20','08:45:00',1.26),('325','2013-06-20','08:50:00',1.27),('325','2013-06-20','08:55:00',1.29),('325','2013-06-20','09:00:00',1.35),('325','2013-06-20','09:05:00',1.39),('325','2013-06-20','09:10:00',1.43),('325','2013-06-20','09:15:00',1.46),('325','2013-06-20','09:20:00',1.5),('325','2013-06-20','09:25:00',2.08),('325','2013-06-20','09:30:00',2.43),('325','2013-06-20','09:35:00',2.46),('325','2013-06-20','09:40:00',2.54),('325','2013-06-20','09:45:00',2.61),('325','2013-06-20','09:50:00',2.66),('325','2013-06-20','09:55:00',2.69),('325','2013-06-20','10:00:00',2.71),('325','2013-06-20','10:05:00',2.78),('325','2013-06-20','10:10:00',2.86),('325','2013-06-20','10:15:00',2.95),('325','2013-06-20','10:20:00',2.99),('325','2013-06-20','10:25:00',3.03),('325','2013-06-20','10:30:00',3.15),('325','2013-06-20','10:35:00',3.22),('325','2013-06-20','10:40:00',3.27),('325','2013-06-20','10:45:00',3.29),('325','2013-06-20','10:50:00',3.27),('325','2013-06-20','10:55:00',3.29),('325','2013-06-20','11:00:00',3.39),('325','2013-06-20','11:05:00',3.46),('325','2013-06-20','11:10:00',3.51),('325','2013-06-20','11:15:00',3.53),('325','2013-06-20','11:20:00',3.58),('325','2013-06-20','11:25:00',3.62),('325','2013-06-20','11:30:00',3.63),('325','2013-06-20','11:35:00',3.68),('325','2013-06-20','11:40:00',3.68),('325','2013-06-20','11:45:00',3.67),('325','2013-06-20','11:50:00',3.6),('325','2013-06-20','11:55:00',3.61),('325','2013-06-20','12:00:00',3.61),('325','2013-06-20','12:05:00',3.79),('325','2013-06-20','12:10:00',3.6),('325','2013-06-20','12:15:00',3.76),('325','2013-06-20','12:20:00',3.22),('325','2013-06-20','12:25:00',3.86),('325','2013-06-20','12:30:00',4.23),('325','2013-06-20','12:35:00',4.26),('325','2013-06-20','12:40:00',4.18),('325','2013-06-20','12:45:00',3.43),('325','2013-06-20','12:50:00',3.97),('325','2013-06-20','12:55:00',4.17),('325','2013-06-20','13:00:00',4.38),('325','2013-06-20','13:05:00',4.31),('325','2013-06-20','13:10:00',3.78),('325','2013-06-20','13:15:00',1.94),('325','2013-06-20','13:20:00',4.35),('325','2013-06-20','13:25:00',4.23),('325','2013-06-20','13:30:00',3.88),('325','2013-06-20','13:35:00',4.29),('325','2013-06-20','13:40:00',4.29),('325','2013-06-20','13:45:00',4.33),('325','2013-06-20','13:50:00',4.31),('325','2013-06-20','13:55:00',4.18),('325','2013-06-20','14:00:00',4.17),('325','2013-06-20','14:05:00',4.1),('325','2013-06-20','14:10:00',4.11),('325','2013-06-20','14:15:00',4.29),('325','2013-06-20','14:20:00',4.31),('325','2013-06-20','14:25:00',4.3),('325','2013-06-20','14:30:00',4.32),('325','2013-06-20','14:35:00',4.33),('325','2013-06-20','14:40:00',4.33),('325','2013-06-20','14:45:00',4.3),('325','2013-06-20','14:50:00',4.28),('325','2013-06-20','14:55:00',4.25),('325','2013-06-20','15:00:00',4.22),('325','2013-06-20','15:05:00',4.16),('325','2013-06-20','15:10:00',4.12),('325','2013-06-20','15:15:00',4.09),('325','2013-06-20','15:20:00',4.03),('325','2013-06-20','15:25:00',4),('325','2013-06-20','15:30:00',3.93),('325','2013-06-20','15:35:00',3.89),('325','2013-06-20','15:40:00',3.86),('325','2013-06-20','15:45:00',3.81),('325','2013-06-20','15:50:00',3.76),('325','2013-06-20','15:55:00',3.68),('325','2013-06-20','16:00:00',3.64),('325','2013-06-20','16:05:00',3.59),('325','2013-06-20','16:10:00',3.54),('325','2013-06-20','16:15:00',3.49),('325','2013-06-20','16:20:00',3.43),('325','2013-06-20','16:25:00',3.39),('325','2013-06-20','16:30:00',3.32),('325','2013-06-20','16:35:00',3.25),('325','2013-06-20','16:40:00',3.16),('325','2013-06-20','16:45:00',3.09),('325','2013-06-20','16:50:00',3.03),('325','2013-06-20','16:55:00',2.97),('325','2013-06-20','17:00:00',2.88),('325','2013-06-20','17:05:00',2.73),('325','2013-06-20','17:10:00',2.59),('325','2013-06-20','17:15:00',2.59),('325','2013-06-20','17:20:00',2.52),('325','2013-06-20','17:25:00',2.43),('325','2013-06-20','17:30:00',2.36),('325','2013-06-20','17:35:00',2.28),('325','2013-06-20','17:40:00',2.21),('325','2013-06-20','17:45:00',2.12),('325','2013-06-20','17:50:00',2.03),('325','2013-06-20','17:55:00',1.91),('325','2013-06-20','18:00:00',1.79),('325','2013-06-20','18:05:00',1.73),('325','2013-06-20','18:10:00',1.62),('325','2013-06-20','18:15:00',1.44),('325','2013-06-20','18:20:00',1.27),('325','2013-06-20','18:25:00',1.17),('325','2013-06-20','18:30:00',1.07),('325','2013-06-20','18:35:00',1),('325','2014-04-03','08:55:00',1.04),('325','2014-04-03','09:00:00',1.15),('325','2014-04-03','09:05:00',1.25),('325','2014-04-03','09:10:00',1.21),('325','2014-04-03','09:15:00',1.15),('325','2014-04-03','09:20:00',1.17),('325','2014-04-03','09:25:00',1.25),('325','2014-04-03','09:30:00',1.43),('325','2014-04-03','09:35:00',1.63),('325','2014-04-03','09:40:00',1.69),('325','2014-04-03','09:45:00',1.66),('325','2014-04-03','09:50:00',1.57),('325','2014-04-03','09:55:00',1.63),('325','2014-04-03','10:00:00',1.84),('325','2014-04-03','10:05:00',2.05),('325','2014-04-03','10:10:00',2.13),('325','2014-04-03','10:15:00',2.4),('325','2014-04-03','10:20:00',2.48),('325','2014-04-03','10:25:00',2.35),('325','2014-04-03','10:30:00',2.32),('325','2014-04-03','10:35:00',2.5),('325','2014-04-03','10:40:00',2.26),('325','2014-04-03','10:45:00',2.49),('325','2014-04-03','10:50:00',2.14),('325','2014-04-03','10:55:00',2.24),('325','2014-04-03','11:00:00',2.07),('325','2014-04-03','11:05:00',1.72),('325','2014-04-03','11:10:00',1.62),('325','2014-04-03','11:15:00',1.5),('325','2014-04-03','11:20:00',1.42),('325','2014-04-03','11:25:00',1.32),('325','2014-04-03','11:30:00',1.34),('325','2014-04-03','11:35:00',1.45),('325','2014-04-03','11:40:00',1.6),('325','2014-04-03','11:45:00',1.86),('325','2014-04-03','11:50:00',2.3),('325','2014-04-03','11:55:00',2.51),('325','2014-04-03','12:00:00',2.37),('325','2014-04-03','12:05:00',2.4),('325','2014-04-03','12:10:00',2.3),('325','2014-04-03','12:15:00',2.25),('325','2014-04-03','12:20:00',2.57),('325','2014-04-03','12:25:00',3.25),('325','2014-04-03','12:30:00',4.2),('325','2014-04-03','12:35:00',4.04),('325','2014-04-03','12:40:00',4.44),('325','2014-04-03','12:45:00',2.45),('325','2014-04-03','12:50:00',3.03),('325','2014-04-03','12:55:00',2.88),('325','2014-04-03','13:00:00',2.71),('325','2014-04-03','13:05:00',3.59),('325','2014-04-03','13:10:00',2.74),('325','2014-04-03','13:15:00',4.78),('325','2014-04-03','13:20:00',2.83),('325','2014-04-03','13:25:00',2.97),('325','2014-04-03','13:30:00',3.13),('325','2014-04-03','13:35:00',5.01),('325','2014-04-03','13:40:00',4.2),('325','2014-04-03','13:45:00',2.31),('325','2014-04-03','13:50:00',2.33),('325','2014-04-03','13:55:00',2.84),('325','2014-04-03','14:00:00',4),('325','2014-04-03','14:05:00',3.76),('325','2014-04-03','14:10:00',2.95),('325','2014-04-03','14:15:00',3.93),('325','2014-04-03','14:20:00',4.06),('325','2014-04-03','14:25:00',4.24),('325','2014-04-03','14:30:00',4.32),('325','2014-04-03','14:35:00',4.35),('325','2014-04-03','14:40:00',4.2),('325','2014-04-03','14:45:00',4.09),('325','2014-04-03','14:50:00',4.02),('325','2014-04-03','14:55:00',3.95),('325','2014-04-03','15:00:00',3.88),('325','2014-04-03','15:05:00',3.84),('325','2014-04-03','15:10:00',3.81),('325','2014-04-03','15:15:00',3.81),('325','2014-04-03','15:20:00',3.82),('325','2014-04-03','15:25:00',3.79),('325','2014-04-03','15:30:00',3.73),('325','2014-04-03','15:35:00',3.69),('325','2014-04-03','15:40:00',3.66),('325','2014-04-03','15:45:00',3.6),('325','2014-04-03','15:50:00',3.55),('325','2014-04-03','15:55:00',3.5),('325','2014-04-03','16:00:00',3.47),('325','2014-04-03','16:05:00',3.36),('325','2014-04-03','16:10:00',3.36),('325','2014-04-03','16:15:00',3.25),('325','2014-04-03','16:20:00',3.19),('325','2014-04-03','16:25:00',3.08),('325','2014-04-03','16:30:00',2.98),('325','2014-04-03','16:35:00',2.9),('325','2014-04-03','16:40:00',2.8),('325','2014-04-03','16:45:00',2.55),('325','2014-04-03','16:50:00',1.87),('325','2014-04-03','16:55:00',1.69),('325','2014-04-03','17:00:00',1.26),('325','2014-04-03','17:05:00',1.12),('325','2014-04-03','17:10:00',1.03),('325','2014-04-03','17:20:00',1.11),('325','2014-04-03','17:25:00',1.14),('325','2014-04-03','17:30:00',1.1),('325','2014-04-03','17:45:00',1.23),('325','2014-04-03','17:50:00',1.46),('325','2014-04-03','17:55:00',1.28),('325','2014-04-03','18:00:00',1.16),('325','2014-04-03','18:05:00',1.04),('325','2013-06-19','08:25:00',1.05),('325','2013-06-19','08:30:00',1.1),('325','2013-06-19','08:35:00',1.16),('325','2013-06-19','08:40:00',1.21),('325','2013-06-19','08:45:00',1.24),('325','2013-06-19','08:50:00',1.26),('325','2013-06-19','08:55:00',1.27),('325','2013-06-19','09:00:00',1.28),('325','2013-06-19','09:05:00',1.31),('325','2013-06-19','09:10:00',1.36),('325','2013-06-19','09:15:00',1.39),('325','2013-06-19','09:20:00',1.41),('325','2013-06-19','09:25:00',1.44),('325','2013-06-19','09:30:00',1.48),('325','2013-06-19','09:35:00',2.37),('325','2013-06-19','09:40:00',2.48),('325','2013-06-19','09:45:00',2.57),('325','2013-06-19','09:50:00',2.63),('325','2013-06-19','09:55:00',2.63),('325','2013-06-19','10:00:00',2.68),('325','2013-06-19','10:05:00',2.75),('325','2013-06-19','10:10:00',2.82),('325','2013-06-19','10:15:00',2.89),('325','2013-06-19','10:20:00',2.91),('325','2013-06-19','10:25:00',2.92),('325','2013-06-19','10:30:00',2.97),('325','2013-06-19','10:35:00',3.03),('325','2013-06-19','10:40:00',3.11),('325','2013-06-19','10:45:00',3.2),('325','2013-06-19','10:50:00',3.2),('325','2013-06-19','10:55:00',3.26),('325','2013-06-19','11:00:00',3.3),('325','2013-06-19','11:05:00',3.33),('325','2013-06-19','11:10:00',3.37),('325','2013-06-19','11:15:00',3.46),('325','2013-06-19','11:20:00',3.61),('325','2013-06-19','11:25:00',3.63),('325','2013-06-19','11:30:00',3.76),('325','2013-06-19','11:35:00',3.77),('325','2013-06-19','11:40:00',3.85),('325','2013-06-19','11:45:00',3.91),('325','2013-06-19','11:50:00',3.95),('325','2013-06-19','11:55:00',3.95),('325','2013-06-19','12:00:00',4.01),('325','2013-06-19','12:05:00',3.95),('325','2013-06-19','12:10:00',3.95),('325','2013-06-19','12:15:00',3.93),('325','2013-06-19','12:20:00',3.82),('325','2013-06-19','12:25:00',3.9),('325','2013-06-19','12:30:00',3.89),('325','2013-06-19','12:35:00',3.97),('325','2013-06-19','12:40:00',3.94),('325','2013-06-19','12:45:00',3.9),('325','2013-06-19','12:50:00',4.03),('325','2013-06-19','12:55:00',4.07),('325','2013-06-19','13:00:00',4.09),('325','2013-06-19','13:05:00',4.13),('325','2013-06-19','13:10:00',4.11),('325','2013-06-19','13:15:00',4.03),('325','2013-06-19','13:20:00',4.04),('325','2013-06-19','13:25:00',3.99),('325','2013-06-19','13:30:00',4.02),('325','2013-06-19','13:35:00',4.28),('325','2013-06-19','13:40:00',4.27),('325','2013-06-19','13:45:00',4.25),('325','2013-06-19','13:50:00',4.2),('325','2013-06-19','13:55:00',4.14),('325','2013-06-19','14:00:00',4.08),('325','2013-06-19','14:05:00',4.04),('325','2013-06-19','14:10:00',3.97),('325','2013-06-19','14:15:00',3.92),('325','2013-06-19','14:20:00',3.92),('325','2013-06-19','14:25:00',3.9),('325','2013-06-19','14:30:00',3.87),('325','2013-06-19','14:35:00',3.87),('325','2013-06-19','14:40:00',4.04),('325','2013-06-19','14:45:00',4.02),('325','2013-06-19','14:50:00',4.01),('325','2013-06-19','14:55:00',4.01),('325','2013-06-19','15:00:00',3.97),('325','2013-06-19','15:05:00',3.93),('325','2013-06-19','15:10:00',3.89),('325','2013-06-19','15:15:00',3.87),('325','2013-06-19','15:20:00',3.84),('325','2013-06-19','15:25:00',3.81),('325','2013-06-19','15:30:00',3.78),('325','2013-06-19','15:35:00',3.74),('325','2013-06-19','15:40:00',3.65),('325','2013-06-19','15:45:00',3.62),('325','2013-06-19','15:50:00',3.55),('325','2013-06-19','15:55:00',3.5),('325','2013-06-19','16:00:00',3.44),('325','2013-06-19','16:05:00',3.39),('325','2013-06-19','16:10:00',3.33),('325','2013-06-19','16:15:00',3.28),('325','2013-06-19','16:20:00',3.23),('325','2013-06-19','16:25:00',3.18),('325','2013-06-19','16:30:00',3.12),('325','2013-06-19','16:35:00',3.06),('325','2013-06-19','16:40:00',3.01),('325','2013-06-19','16:45:00',2.94),('325','2013-06-19','16:50:00',2.89),('325','2013-06-19','16:55:00',2.82),('325','2013-06-19','17:00:00',2.73),('325','2013-06-19','17:05:00',2.59),('325','2013-06-19','17:10:00',2.51),('325','2013-06-19','17:15:00',2.48),('325','2013-06-19','17:20:00',2.44),('325','2013-06-19','17:25:00',2.39),('325','2013-06-19','17:30:00',2.31),('325','2013-06-19','17:35:00',2.22),('325','2013-06-19','17:40:00',2.14),('325','2013-06-19','17:45:00',2.06),('325','2013-06-19','17:50:00',1.96),('325','2013-06-19','17:55:00',1.85),('325','2013-06-19','18:00:00',1.74),('325','2013-06-19','18:05:00',1.66),('325','2013-06-19','18:10:00',1.54),('325','2013-06-19','18:15:00',1.36),('325','2013-06-19','18:20:00',1.2),('325','2013-06-19','18:25:00',1.1),('325','2013-06-18','08:25:00',1.06),('325','2013-06-18','08:30:00',1.09),('325','2013-06-18','08:35:00',1.16),('325','2013-06-18','08:40:00',1.21),('325','2013-06-18','08:45:00',1.25),('325','2013-06-18','08:50:00',1.26),('325','2013-06-18','08:55:00',1.27),('325','2013-06-18','09:00:00',1.28),('325','2013-06-18','09:05:00',1.32),('325','2013-06-18','09:10:00',1.37),('325','2013-06-18','09:15:00',1.39),('325','2013-06-18','09:20:00',1.41),('325','2013-06-18','09:25:00',2.05),('325','2013-06-18','09:30:00',2.29),('325','2013-06-18','09:35:00',2.34),('325','2013-06-18','09:40:00',2.44),('325','2013-06-18','09:45:00',2.52),('325','2013-06-18','09:50:00',2.17),('325','2013-06-18','09:55:00',2.63),('325','2013-06-18','10:00:00',2.67),('325','2013-06-18','10:05:00',2.71),('325','2013-06-18','10:10:00',2.82),('325','2013-06-18','10:15:00',2.88),('325','2013-06-18','10:20:00',2.9),('325','2013-06-18','10:25:00',2.93),('325','2013-06-18','10:30:00',2.98),('325','2013-06-18','10:35:00',3.04),('325','2013-06-18','10:40:00',3.13),('325','2013-06-18','10:45:00',3.19),('325','2013-06-18','10:50:00',3.22),('325','2013-06-18','10:55:00',3.24),('325','2013-06-18','11:00:00',3.3),('325','2013-06-18','11:05:00',3.35),('325','2013-06-18','11:10:00',3.41),('325','2013-06-18','11:15:00',3.64),('325','2013-06-18','11:20:00',3.75),('325','2013-06-18','11:25:00',3.78),('325','2013-06-18','11:30:00',3.78),('325','2013-06-18','11:35:00',3.76),('325','2013-06-18','11:40:00',3.74),('325','2013-06-18','11:45:00',3.82),('325','2013-06-18','11:50:00',3.88),('325','2013-06-18','11:55:00',3.88),('325','2013-06-18','12:00:00',3.9),('325','2013-06-18','12:05:00',3.94),('325','2013-06-18','12:10:00',3.95),('325','2013-06-18','12:15:00',3.78),('325','2013-06-18','12:20:00',3.93),('325','2013-06-18','12:25:00',3.88),('325','2013-06-18','12:30:00',3.74),('325','2013-06-18','12:35:00',3.7),('325','2013-06-18','12:40:00',3.53),('325','2013-06-18','12:45:00',3.27),('325','2013-06-18','12:50:00',1.7),('325','2013-06-18','12:55:00',3.06),('325','2013-06-18','13:00:00',2.81),('325','2013-06-18','13:05:00',1.76),('325','2013-06-18','13:10:00',4.1),('325','2013-06-18','13:15:00',4.22),('325','2013-06-18','13:20:00',4.31),('325','2013-06-18','13:25:00',4.15),('325','2013-06-18','13:30:00',2.18),('325','2013-06-18','13:35:00',3.88),('325','2013-06-18','13:40:00',4.12),('325','2013-06-18','13:45:00',4.09),('325','2013-06-18','13:50:00',4.01),('325','2013-06-18','13:55:00',3.94),('325','2013-06-18','14:00:00',4),('325','2013-06-18','14:05:00',4.28),('325','2013-06-18','14:10:00',4.21),('325','2013-06-18','14:15:00',4.13),('325','2013-06-18','14:20:00',4.13),('325','2013-06-18','14:25:00',4.08),('325','2013-06-18','14:30:00',4.08),('325','2013-06-18','14:35:00',4.17),('325','2013-06-18','14:40:00',4.23),('325','2013-06-18','14:45:00',4.21),('325','2013-06-18','14:50:00',4.16),('325','2013-06-18','14:55:00',4.15),('325','2013-06-18','15:00:00',4.07),('325','2013-06-18','15:05:00',4),('325','2013-06-18','15:10:00',4),('325','2013-06-18','15:15:00',3.93),('325','2013-06-18','15:20:00',3.86),('325','2013-06-18','15:25:00',3.83),('325','2013-06-18','15:30:00',3.79),('325','2013-06-18','15:35:00',3.78),('325','2013-06-18','15:40:00',3.78),('325','2013-06-18','15:45:00',3.7),('325','2013-06-18','15:50:00',3.66),('325','2013-06-18','15:55:00',3.62),('325','2013-06-18','16:00:00',3.58),('325','2013-06-18','16:05:00',3.53),('325','2013-06-18','16:10:00',3.5),('325','2013-06-18','16:15:00',3.49),('325','2013-06-18','16:20:00',3.45),('325','2013-06-18','16:25:00',3.36),('325','2013-06-18','16:30:00',3.29),('325','2013-06-18','16:35:00',3.08),('325','2013-06-18','16:40:00',3.11),('325','2013-06-18','16:45:00',3.01),('325','2013-06-18','16:50:00',2.93),('325','2013-06-18','16:55:00',2.87),('325','2013-06-18','17:00:00',2.77),('325','2013-06-18','17:05:00',2.65),('325','2013-06-18','17:10:00',2.52),('325','2013-06-18','17:15:00',2.53),('325','2013-06-18','17:20:00',2.47),('325','2013-06-18','17:25:00',2.39),('325','2013-06-18','17:30:00',2.3),('325','2013-06-18','17:35:00',2.2),('325','2013-06-18','17:40:00',2.13),('325','2013-06-18','17:45:00',2.03),('325','2013-06-18','17:50:00',1.95),('325','2013-06-18','17:55:00',1.84),('325','2013-06-18','18:00:00',1.75),('325','2013-06-18','18:05:00',1.67),('325','2013-06-18','18:10:00',1.56),('325','2013-06-18','18:15:00',1.38),('325','2013-06-18','18:20:00',1.26),('325','2013-06-18','18:25:00',1.18),('325','2013-06-18','18:30:00',1.04),('325','2013-06-17','08:20:00',1.02),('325','2013-06-17','08:25:00',1.08),('325','2013-06-17','08:30:00',1.12),('325','2013-06-17','08:35:00',1.19),('325','2013-06-17','08:40:00',1.24),('325','2013-06-17','08:45:00',1.27),('325','2013-06-17','08:50:00',1.26),('325','2013-06-17','08:55:00',1.26),('325','2013-06-17','09:00:00',1.29),('325','2013-06-17','09:05:00',1.33),('325','2013-06-17','09:10:00',1.38),('325','2013-06-17','09:15:00',1.4),('325','2013-06-17','09:20:00',1.52),('325','2013-06-17','09:25:00',2.33),('325','2013-06-17','09:30:00',2.44),('325','2013-06-17','09:35:00',2.49),('325','2013-06-17','09:40:00',2.56),('325','2013-06-17','09:45:00',2.65),('325','2013-06-17','09:50:00',2.71),('325','2013-06-17','09:55:00',2.71),('325','2013-06-17','10:00:00',2.76),('325','2013-06-17','10:05:00',2.82),('325','2013-06-17','10:10:00',2.9),('325','2013-06-17','10:15:00',2.99),('325','2013-06-17','10:20:00',3.01),('325','2013-06-17','10:25:00',3),('325','2013-06-17','10:30:00',3.06),('325','2013-06-17','10:35:00',3.13),('325','2013-06-17','10:40:00',3.22),('325','2013-06-17','10:45:00',3.29),('325','2013-06-17','10:50:00',3.29),('325','2013-06-17','10:55:00',3.3),('325','2013-06-17','11:00:00',3.38),('325','2013-06-17','11:05:00',3.45),('325','2013-06-17','11:10:00',3.5),('325','2013-06-17','11:15:00',3.6),('325','2013-06-17','11:20:00',3.72),('325','2013-06-17','11:25:00',3.76),('325','2013-06-17','11:30:00',3.74),('325','2013-06-17','11:35:00',3.72),('325','2013-06-17','11:40:00',3.67),('325','2013-06-17','11:45:00',3.74),('325','2013-06-17','11:50:00',3.72),('325','2013-06-17','11:55:00',3.77),('325','2013-06-17','12:00:00',3.87),('325','2013-06-17','12:05:00',3.99),('325','2013-06-17','12:10:00',4),('325','2013-06-17','12:15:00',3.99),('325','2013-06-17','12:20:00',4.03),('325','2013-06-17','12:25:00',3.97),('325','2013-06-17','12:30:00',3.92),('325','2013-06-17','12:35:00',3.9),('325','2013-06-17','12:40:00',3.86),('325','2013-06-17','12:45:00',3.92),('325','2013-06-17','12:50:00',4.08),('325','2013-06-17','12:55:00',4.16),('325','2013-06-17','13:00:00',4.19),('325','2013-06-17','13:05:00',4.25),('325','2013-06-17','13:10:00',4.19),('325','2013-06-17','13:15:00',4.13),('325','2013-06-17','13:20:00',4.08),('325','2013-06-17','13:25:00',3.99),('325','2013-06-17','13:30:00',3.98),('325','2013-06-17','13:35:00',4.01),('325','2013-06-17','13:40:00',4.02),('325','2013-06-17','13:45:00',4),('325','2013-06-17','13:50:00',4.01),('325','2013-06-17','13:55:00',3.99),('325','2013-06-17','14:00:00',4.03),('325','2013-06-17','14:05:00',4),('325','2013-06-17','14:10:00',4.17),('325','2013-06-17','14:15:00',4.12),('325','2013-06-17','14:20:00',4.12),('325','2013-06-17','14:25:00',4.12),('325','2013-06-17','14:30:00',4.11),('325','2013-06-17','14:35:00',4.1),('325','2013-06-17','14:40:00',4.1),('325','2013-06-17','14:45:00',4.08),('325','2013-06-17','14:50:00',4.06),('325','2013-06-17','14:55:00',4.04),('325','2013-06-17','15:00:00',3.99),('325','2013-06-17','15:05:00',3.97),('325','2013-06-17','15:20:00',3.88),('325','2013-06-17','15:25:00',3.84),('325','2013-06-17','15:30:00',3.8),('325','2013-06-17','15:35:00',3.76),('325','2013-06-17','15:40:00',3.71),('325','2013-06-17','15:45:00',3.66),('325','2013-06-17','15:50:00',3.6),('325','2013-06-17','15:55:00',3.55),('325','2013-06-17','16:00:00',3.51),('325','2013-06-17','16:05:00',3.46),('325','2013-06-17','16:10:00',3.41),('325','2013-06-17','16:15:00',3.37),('325','2013-06-17','16:20:00',3.32),('325','2013-06-17','16:25:00',3.27),('325','2013-06-17','16:30:00',3.19),('325','2013-06-17','16:35:00',3.13),('325','2013-06-17','16:40:00',3.07),('325','2013-06-17','16:45:00',2.99),('325','2013-06-17','16:50:00',2.94),('325','2013-06-17','16:55:00',2.89),('325','2013-06-17','17:00:00',2.79),('325','2013-06-17','17:05:00',2.66),('325','2013-06-17','17:10:00',2.52),('325','2013-06-17','17:15:00',2.53),('325','2013-06-17','17:20:00',2.49),('325','2013-06-17','17:25:00',2.41),('325','2013-06-17','17:30:00',2.35),('325','2013-06-17','17:35:00',2.27),('325','2013-06-17','17:40:00',2.19),('325','2013-06-17','17:45:00',2.09),('325','2013-06-17','17:50:00',2),('325','2013-06-17','17:55:00',1.89),('325','2013-06-17','18:00:00',1.78),('325','2013-06-17','18:05:00',1.73),('325','2013-06-17','18:10:00',1.62),('325','2013-06-17','18:15:00',1.43),('325','2013-06-17','18:20:00',1.29),('325','2013-06-17','18:25:00',1.14),('325','2013-06-17','18:30:00',1.07),('325','2013-06-16','08:20:00',1.03),('325','2013-06-16','08:25:00',1.09),('325','2013-06-16','08:30:00',1.14),('325','2013-06-16','08:35:00',1.2),('325','2013-06-16','08:40:00',1.24),('325','2013-06-16','08:45:00',1.3),('325','2013-06-16','08:50:00',1.31),('325','2013-06-16','08:55:00',1.32),('325','2013-06-16','09:00:00',1.31),('325','2013-06-16','09:05:00',1.34),('325','2013-06-16','09:10:00',1.38),('325','2013-06-16','09:15:00',1.4),('325','2013-06-16','09:20:00',1.43),('325','2013-06-16','09:25:00',1.49),('325','2013-06-16','09:30:00',1.6),('325','2013-06-16','09:35:00',2.52),('325','2013-06-16','09:40:00',2.6),('325','2013-06-16','09:45:00',2.68),('325','2013-06-16','09:50:00',2.74),('325','2013-06-16','09:55:00',2.75),('325','2013-06-16','10:00:00',2.81),('325','2013-06-16','10:05:00',2.9),('325','2013-06-16','10:10:00',2.99),('325','2013-06-16','10:15:00',3.03),('325','2013-06-16','10:20:00',3.05),('325','2013-06-16','10:25:00',3.09),('325','2013-06-16','10:30:00',3.13),('325','2013-06-16','10:35:00',3.2),('325','2013-06-16','10:40:00',3.29),('325','2013-06-16','10:45:00',3.39),('325','2013-06-16','10:50:00',3.41),('325','2013-06-16','10:55:00',3.58),('325','2013-06-16','11:00:00',3.74),('325','2013-06-16','11:05:00',3.8),('325','2013-06-16','11:10:00',3.89),('325','2013-06-16','11:15:00',3.96),('325','2013-06-16','11:20:00',3.98),('325','2013-06-16','11:25:00',4.05),('325','2013-06-16','11:30:00',3.99),('325','2013-06-16','11:35:00',4.04),('325','2013-06-16','11:40:00',4.12),('325','2013-06-16','11:45:00',4.17),('325','2013-06-16','11:50:00',4.2),('325','2013-06-16','11:55:00',4.24),('325','2013-06-16','12:00:00',4.28),('325','2013-06-16','12:05:00',4.32),('325','2013-06-16','12:10:00',4.28),('325','2013-06-16','12:15:00',4.28),('325','2013-06-16','12:20:00',4.25),('325','2013-06-16','12:25:00',4.15),('325','2013-06-16','12:30:00',4.08),('325','2013-06-16','12:35:00',4.02),('325','2013-06-16','12:40:00',3.97),('325','2013-06-16','12:45:00',4.02),('325','2013-06-16','12:50:00',4.1),('325','2013-06-16','12:55:00',4.18),('325','2013-06-16','13:00:00',4.29),('325','2013-06-16','13:05:00',4.39),('325','2013-06-16','13:10:00',4.51),('325','2013-06-16','13:15:00',4.48),('325','2013-06-16','13:20:00',4.47),('325','2013-06-16','13:25:00',4.48),('325','2013-06-16','13:30:00',4.48),('325','2013-06-16','13:35:00',4.5),('325','2013-06-16','13:40:00',4.5),('325','2013-06-16','13:45:00',4.43),('325','2013-06-16','13:50:00',4.38),('325','2013-06-16','13:55:00',4.3),('325','2013-06-16','14:00:00',4.24),('325','2013-06-16','14:05:00',4.15),('325','2013-06-16','14:10:00',4.13),('325','2013-06-16','14:15:00',4.1),('325','2013-06-16','14:20:00',4.09),('325','2013-06-16','14:25:00',4.13),('325','2013-06-16','14:30:00',4.21),('325','2013-06-16','14:35:00',4.2),('325','2013-06-16','14:40:00',4.22),('325','2013-06-16','14:45:00',4.21),('325','2013-06-16','14:50:00',4.19),('325','2013-06-16','14:55:00',4.17),('325','2013-06-16','15:00:00',4.15),('325','2013-06-16','15:05:00',4.12),('325','2013-06-16','15:10:00',4.08),('325','2013-06-16','15:15:00',4.04),('325','2013-06-16','15:20:00',4.02),('325','2013-06-16','15:25:00',3.97),('325','2013-06-16','15:30:00',3.94),('325','2013-06-16','15:35:00',3.91),('325','2013-06-16','15:40:00',3.86),('325','2013-06-16','15:45:00',3.8),('325','2013-06-16','15:50:00',3.74),('325','2013-06-16','15:55:00',3.69),('325','2013-06-16','16:00:00',3.64),('325','2013-06-16','16:05:00',3.58),('325','2013-06-16','16:10:00',3.53),('325','2013-06-16','16:15:00',3.48),('325','2013-06-16','16:20:00',3.43),('325','2013-06-16','16:25:00',3.36),('325','2013-06-16','16:30:00',3.29),('325','2013-06-16','16:35:00',3.23),('325','2013-06-16','16:40:00',3.18),('325','2013-06-16','16:45:00',3.09),('325','2013-06-16','16:50:00',3.01),('325','2013-06-16','16:55:00',2.93),('325','2013-06-16','17:00:00',2.83),('325','2013-06-16','17:05:00',2.69),('325','2013-06-16','17:10:00',2.61),('325','2013-06-16','17:15:00',2.58),('325','2013-06-16','17:20:00',2.49),('325','2013-06-16','17:25:00',2.41),('325','2013-06-16','17:30:00',2.33),('325','2013-06-16','17:35:00',2.24),('325','2013-06-16','17:40:00',2.15),('325','2013-06-16','17:45:00',2.07),('325','2013-06-16','17:50:00',1.96),('325','2013-06-16','17:55:00',1.83),('325','2013-06-16','18:00:00',1.76),('325','2013-06-16','18:05:00',1.68),('325','2013-06-16','18:10:00',1.57),('325','2013-06-16','18:15:00',1.39),('325','2013-06-16','18:20:00',1.22),('325','2013-06-16','18:25:00',1.16),('325','2013-06-16','18:30:00',1.03),('325','2013-06-15','08:15:00',1.02),('325','2013-06-15','08:20:00',1.04),('325','2013-06-15','08:25:00',1.13),('325','2013-06-15','08:30:00',1.18),('325','2013-06-15','08:35:00',1.27),('325','2013-06-15','08:40:00',1.29),('325','2013-06-15','08:45:00',1.37),('325','2013-06-15','08:50:00',1.4),('325','2013-06-15','08:55:00',1.39),('325','2013-06-15','09:00:00',1.36),('325','2013-06-15','09:05:00',1.52),('325','2013-06-15','09:10:00',1.54),('325','2013-06-15','09:15:00',1.63),('325','2013-06-15','09:20:00',1.24),('325','2013-06-15','09:25:00',1.61),('325','2013-06-15','09:30:00',1.76),('325','2013-06-15','09:35:00',2.42),('325','2013-06-15','09:40:00',2.73),('325','2013-06-15','09:45:00',2.65),('325','2013-06-15','09:50:00',2.73),('325','2013-06-15','09:55:00',2.76),('325','2013-06-15','10:00:00',2.87),('325','2013-06-15','10:05:00',2.92),('325','2013-06-15','10:10:00',2.99),('325','2013-06-15','10:15:00',3.13),('325','2013-06-15','10:20:00',3.17),('325','2013-06-15','10:25:00',3.11),('325','2013-06-15','10:30:00',3.26),('325','2013-06-15','10:35:00',3.12),('325','2013-06-15','10:40:00',3.01),('325','2013-06-15','10:45:00',3.26),('325','2013-06-15','10:50:00',3.24),('325','2013-06-15','10:55:00',3.75),('325','2013-06-15','11:00:00',3.83),('325','2013-06-15','11:05:00',3.7),('325','2013-06-15','11:10:00',3.9),('325','2013-06-15','11:15:00',2.69),('325','2013-06-15','11:20:00',3.72),('325','2013-06-15','11:25:00',4.23),('325','2013-06-15','11:30:00',3.56),('325','2013-06-15','11:35:00',4.09),('325','2013-06-15','11:40:00',4.06),('325','2013-06-15','11:45:00',3.59),('325','2013-06-15','11:50:00',4.39),('325','2013-06-15','11:55:00',4),('325','2013-06-15','12:00:00',4.15),('325','2013-06-15','12:05:00',4.41),('325','2013-06-15','12:10:00',4.45),('325','2013-06-15','12:15:00',4.44),('325','2013-06-15','12:20:00',4.37),('325','2013-06-15','12:25:00',4.24),('325','2013-06-15','12:30:00',4.24),('325','2013-06-15','12:35:00',4.2),('325','2013-06-15','12:40:00',4.14),('325','2013-06-15','12:45:00',4.18),('325','2013-06-15','12:50:00',4.52),('325','2013-06-15','12:55:00',4.53),('325','2013-06-15','13:00:00',4.52),('325','2013-06-15','13:05:00',4.53),('325','2013-06-15','13:10:00',4.52),('325','2013-06-15','13:15:00',4.54),('325','2013-06-15','13:20:00',4.52),('325','2013-06-15','13:25:00',4.51),('325','2013-06-15','13:30:00',4.48),('325','2013-06-15','13:35:00',4.49),('325','2013-06-15','13:40:00',4.48),('325','2013-06-15','13:45:00',4.43),('325','2013-06-15','13:50:00',4.37),('325','2013-06-15','13:55:00',4.29),('325','2013-06-15','14:00:00',4.2),('325','2013-06-15','14:05:00',4.15),('325','2013-06-15','14:10:00',4.09),('325','2013-06-15','14:15:00',4.06),('325','2013-06-15','14:20:00',4.06),('325','2013-06-15','14:25:00',3.97),('325','2013-06-15','14:30:00',4.07),('325','2013-06-15','14:35:00',4.16),('325','2013-06-15','14:40:00',4.23),('325','2013-06-15','14:45:00',4.19),('325','2013-06-15','14:50:00',4.14),('325','2013-06-15','14:55:00',4.18),('325','2013-06-15','15:00:00',4.14),('325','2013-06-15','15:05:00',4.15),('325','2013-06-15','15:10:00',4.11),('325','2013-06-15','15:15:00',4.06),('325','2013-06-15','15:20:00',4.03),('325','2013-06-15','15:25:00',4.01),('325','2013-06-15','15:30:00',3.96),('325','2013-06-15','15:35:00',3.91),('325','2013-06-15','15:40:00',3.85),('325','2013-06-15','15:45:00',3.79),('325','2013-06-15','15:50:00',3.74),('325','2013-06-15','15:55:00',3.69),('325','2013-06-15','16:00:00',3.62),('325','2013-06-15','16:05:00',3.56),('325','2013-06-15','16:10:00',3.51),('325','2013-06-15','16:15:00',3.47),('325','2013-06-15','16:20:00',3.41),('325','2013-06-15','16:25:00',3.35),('325','2013-06-15','16:30:00',3.3),('325','2013-06-15','16:35:00',3.23),('325','2013-06-15','16:40:00',3.15),('325','2013-06-15','16:45:00',3.08),('325','2013-06-15','16:50:00',3.03),('325','2013-06-15','16:55:00',2.92),('325','2013-06-15','17:00:00',2.83),('325','2013-06-15','17:05:00',2.69),('325','2013-06-15','17:10:00',2.61),('325','2013-06-15','17:15:00',2.58),('325','2013-06-15','17:20:00',2.48),('325','2013-06-15','17:25:00',2.4),('325','2013-06-15','17:30:00',2.29),('325','2013-06-15','17:35:00',2.2),('325','2013-06-15','17:40:00',2.11),('325','2013-06-15','17:45:00',1.99),('325','2013-06-15','17:50:00',1.92),('325','2013-06-15','17:55:00',1.79),('325','2013-06-15','18:00:00',1.72),('325','2013-06-15','18:05:00',1.64),('325','2013-06-15','18:10:00',1.52),('325','2013-06-15','18:15:00',1.35),('325','2013-06-15','18:20:00',1.2),('325','2013-06-15','18:25:00',1.05),('325','2013-06-15','18:30:00',1.01),('325','2013-06-14','08:20:00',1.05),('325','2013-06-14','08:25:00',1.12),('325','2013-06-14','08:30:00',1.16),('325','2013-06-14','08:35:00',1.23),('325','2013-06-14','08:40:00',1.28),('325','2013-06-14','08:45:00',1.31),('325','2013-06-14','08:50:00',1.32),('325','2013-06-14','08:55:00',1.36),('325','2013-06-14','09:00:00',1.4),('325','2013-06-14','09:05:00',1.43),('325','2013-06-14','09:10:00',1.47),('325','2013-06-14','09:15:00',1.5),('325','2013-06-14','09:20:00',1.55),('325','2013-06-14','09:25:00',1.58),('325','2013-06-14','09:30:00',1.84),('325','2013-06-14','09:35:00',2.67),('325','2013-06-14','09:40:00',2.76),('325','2013-06-14','09:45:00',2.84),('325','2013-06-14','09:50:00',2.86),('325','2013-06-14','09:55:00',2.86),('325','2013-06-14','10:00:00',2.91),('325','2013-06-14','10:05:00',2.97),('325','2013-06-14','10:10:00',3.08),('325','2013-06-14','10:15:00',3.15),('325','2013-06-14','10:20:00',3.16),('325','2013-06-14','10:25:00',3.17),('325','2013-06-14','10:30:00',3.16),('325','2013-06-14','10:35:00',3.38),('325','2013-06-14','10:40:00',3.49),('325','2013-06-14','10:45:00',3.55),('325','2013-06-14','10:50:00',3.51),('325','2013-06-14','10:55:00',3.51),('325','2013-06-14','11:00:00',3.52),('325','2013-06-14','11:05:00',3.58),('325','2013-06-14','11:10:00',3.71),('325','2013-06-14','11:15:00',3.82),('325','2013-06-14','11:20:00',3.92),('325','2013-06-14','11:25:00',3.81),('325','2013-06-14','11:30:00',3.95),('325','2013-06-14','11:35:00',3.91),('325','2013-06-14','11:40:00',3.9),('325','2013-06-14','11:45:00',3.93),('325','2013-06-14','11:50:00',3.96),('325','2013-06-14','11:55:00',4),('325','2013-06-14','12:00:00',4.09),('325','2013-06-14','12:05:00',4.17),('325','2013-06-14','12:10:00',4.23),('325','2013-06-14','12:15:00',4.26),('325','2013-06-14','12:20:00',4.23),('325','2013-06-14','12:25:00',4.12),('325','2013-06-14','12:30:00',4.12),('325','2013-06-14','12:35:00',4.05),('325','2013-06-14','12:40:00',4.08),('325','2013-06-14','12:45:00',4.13),('325','2013-06-14','12:50:00',4.23),('325','2013-06-14','12:55:00',4.5),('325','2013-06-14','13:00:00',4.5),('325','2013-06-14','13:05:00',4.55),('325','2013-06-14','13:10:00',4.56),('325','2013-06-14','13:15:00',4.54),('325','2013-06-14','13:20:00',4.55),('325','2013-06-14','13:25:00',4.58),('325','2013-06-14','13:30:00',4.49),('325','2013-06-14','13:35:00',4.47),('325','2013-06-14','13:40:00',4.49),('325','2013-06-14','13:45:00',4.4),('325','2013-06-14','13:50:00',4.4),('325','2013-06-14','13:55:00',4.27),('325','2013-06-14','14:00:00',4.21),('325','2013-06-14','14:05:00',4.19),('325','2013-06-14','14:10:00',4.14),('325','2013-06-14','14:15:00',4.11),('325','2013-06-14','14:20:00',4.01),('325','2013-06-14','14:25:00',4),('325','2013-06-14','14:30:00',3.99),('325','2013-06-14','14:35:00',3.96),('325','2013-06-14','14:40:00',3.92),('325','2013-06-14','14:45:00',4.12),('325','2013-06-14','14:50:00',4.24),('325','2013-06-14','14:55:00',4.24),('325','2013-06-14','15:00:00',4.2),('325','2013-06-14','15:05:00',4.17),('325','2013-06-14','15:10:00',4.12),('325','2013-06-14','15:15:00',4.09),('325','2013-06-14','15:20:00',4.07),('325','2013-06-14','15:25:00',4.04),('325','2013-06-14','15:30:00',4.01),('325','2013-06-14','15:35:00',3.97),('325','2013-06-14','15:40:00',3.92),('325','2013-06-14','15:45:00',3.88),('325','2013-06-14','15:50:00',3.84),('325','2013-06-14','15:55:00',3.77),('325','2013-06-14','16:00:00',3.71),('325','2013-06-14','16:05:00',3.66),('325','2013-06-14','16:10:00',3.59),('325','2013-06-14','16:15:00',3.54),('325','2013-06-14','16:20:00',3.49),('325','2013-06-14','16:25:00',3.4),('325','2013-06-14','16:30:00',3.35),('325','2013-06-14','16:35:00',3.28),('325','2013-06-14','16:40:00',3.2),('325','2013-06-14','16:45:00',3.15),('325','2013-06-14','16:50:00',3.07),('325','2013-06-14','16:55:00',2.98),('325','2013-06-14','17:00:00',2.9),('325','2013-06-14','17:05:00',2.7),('325','2013-06-14','17:10:00',2.63),('325','2013-06-14','17:15:00',2.66),('325','2013-06-14','17:20:00',2.55),('325','2013-06-14','17:25:00',2.46),('325','2013-06-14','17:30:00',2.3),('325','2013-06-14','17:35:00',2.27),('325','2013-06-14','17:40:00',2.23),('325','2013-06-14','17:45:00',2.14),('325','2013-06-14','17:50:00',2.04),('325','2013-06-14','17:55:00',1.89),('325','2013-06-14','18:00:00',1.78),('325','2013-06-14','18:05:00',1.74),('325','2013-06-14','18:10:00',1.62),('325','2013-06-14','18:15:00',1.43),('325','2013-06-14','18:20:00',1.25),('325','2013-06-14','18:25:00',1.11),('325','2013-06-14','18:30:00',1.08),('325','2013-06-14','18:35:00',1.03),('325','2013-06-13','08:15:00',1.02),('325','2013-06-13','08:20:00',1.07),('325','2013-06-13','08:25:00',1.12),('325','2013-06-13','08:30:00',1.15),('325','2013-06-13','08:35:00',1.22),('325','2013-06-13','08:40:00',1.27),('325','2013-06-13','08:45:00',1.3),('325','2013-06-13','08:50:00',1.3),('325','2013-06-13','08:55:00',1.29),('325','2013-06-13','09:00:00',1.29),('325','2013-06-13','09:05:00',1.34),('325','2013-06-13','09:10:00',1.38),('325','2013-06-13','09:15:00',1.39),('325','2013-06-13','09:20:00',1.42),('325','2013-06-13','09:25:00',1.68),('325','2013-06-13','09:30:00',2.6),('325','2013-06-13','09:35:00',2.67),('325','2013-06-13','09:40:00',2.77),('325','2013-06-13','09:45:00',2.88),('325','2013-06-13','09:50:00',2.93),('325','2013-06-13','09:55:00',2.95),('325','2013-06-13','10:00:00',3),('325','2013-06-13','10:05:00',3.09),('325','2013-06-13','10:10:00',3.17),('325','2013-06-13','10:15:00',3.22),('325','2013-06-13','10:20:00',3.28),('325','2013-06-13','10:25:00',3.35),('325','2013-06-13','10:30:00',3.41),('325','2013-06-13','10:35:00',3.48),('325','2013-06-13','10:40:00',3.51),('325','2013-06-13','10:45:00',3.63),('325','2013-06-13','10:50:00',3.86),('325','2013-06-13','10:55:00',3.95),('325','2013-06-13','11:00:00',4.05),('325','2013-06-13','11:05:00',4.08),('325','2013-06-13','11:10:00',4.14),('325','2013-06-13','11:15:00',4.18),('325','2013-06-13','11:20:00',4.2),('325','2013-06-13','11:25:00',4.25),('325','2013-06-13','11:30:00',4.29),('325','2013-06-13','11:35:00',4.31),('325','2013-06-13','11:40:00',4.37),('325','2013-06-13','11:45:00',4.42),('325','2013-06-13','11:50:00',4.47),('325','2013-06-13','11:55:00',4.48),('325','2013-06-13','12:00:00',4.48),('325','2013-06-13','12:05:00',4.51),('325','2013-06-13','12:10:00',4.52),('325','2013-06-13','12:15:00',4.5),('325','2013-06-13','12:20:00',4.56),('325','2013-06-13','12:25:00',4.59),('325','2013-06-13','12:30:00',4.59),('325','2013-06-13','12:35:00',4.58),('325','2013-06-13','12:40:00',4.6),('325','2013-06-13','12:45:00',4.6),('325','2013-06-13','12:50:00',4.61),('325','2013-06-13','12:55:00',4.57),('325','2013-06-13','13:00:00',4.57),('325','2013-06-13','13:05:00',4.57),('325','2013-06-13','13:10:00',4.59),('325','2013-06-13','13:15:00',4.61),('325','2013-06-13','13:20:00',4.56),('325','2013-06-13','13:25:00',4.57),('325','2013-06-13','13:30:00',4.55),('325','2013-06-13','13:35:00',4.58),('325','2013-06-13','13:40:00',4.56),('325','2013-06-13','13:45:00',4.44),('325','2013-06-13','13:50:00',4.39),('325','2013-06-13','13:55:00',4.32),('325','2013-06-13','14:00:00',4.26),('325','2013-06-13','14:05:00',4.2),('325','2013-06-13','14:10:00',4.17),('325','2013-06-13','14:15:00',4.25),('325','2013-06-13','14:20:00',4.32),('325','2013-06-13','14:25:00',4.33),('325','2013-06-13','14:30:00',4),('325','2013-06-13','14:35:00',4.28),('325','2013-06-13','14:40:00',4.43),('325','2013-06-13','14:45:00',4.36),('325','2013-06-13','14:50:00',4.26),('325','2013-06-13','14:55:00',4.23),('325','2013-06-13','15:00:00',4.24),('325','2013-06-13','15:05:00',4.19),('325','2013-06-13','15:10:00',4.12),('325','2013-06-13','15:15:00',4.09),('325','2013-06-13','15:20:00',4.03),('325','2013-06-13','15:25:00',4),('325','2013-06-13','15:30:00',3.95),('325','2013-06-13','15:35:00',3.91),('325','2013-06-13','15:40:00',3.88),('325','2013-06-13','15:45:00',3.83),('325','2013-06-13','15:50:00',3.78),('325','2013-06-13','15:55:00',3.72),('325','2013-06-13','16:00:00',3.66),('325','2013-06-13','16:05:00',3.59),('325','2013-06-13','16:10:00',3.51),('325','2013-06-13','16:15:00',3.47),('325','2013-06-13','16:20:00',3.41),('325','2013-06-13','16:25:00',3.36),('325','2013-06-13','16:30:00',3.29),('325','2013-06-13','16:35:00',3.24),('325','2013-06-13','16:40:00',3.16),('325','2013-06-13','16:45:00',3.04),('325','2013-06-13','16:50:00',2.94),('325','2013-06-13','16:55:00',2.91),('325','2013-06-13','17:00:00',2.82),('325','2013-06-13','17:05:00',2.7),('325','2013-06-13','17:10:00',2.69),('325','2013-06-13','17:15:00',2.6),('325','2013-06-13','17:20:00',2.54),('325','2013-06-13','17:25:00',2.45),('325','2013-06-13','17:30:00',2.37),('325','2013-06-13','17:35:00',2.28),('325','2013-06-13','17:40:00',2.18),('325','2013-06-13','17:45:00',2.11),('325','2013-06-13','17:50:00',2.01),('325','2013-06-13','17:55:00',1.86),('325','2013-06-13','18:00:00',1.77),('325','2013-06-13','18:05:00',1.69),('325','2013-06-13','18:10:00',1.57),('325','2013-06-13','18:15:00',1.4),('325','2013-06-13','18:20:00',1.23),('325','2013-06-13','18:25:00',1.13),('325','2013-06-13','18:30:00',1.05),('325','2013-06-13','18:35:00',1.01),('325','2013-06-12','08:15:00',1.03),('325','2013-06-12','08:20:00',1.08),('325','2013-06-12','08:25:00',1.15),('325','2013-06-12','08:30:00',1.19),('325','2013-06-12','08:35:00',1.26),('325','2013-06-12','08:40:00',1.31),('325','2013-06-12','08:45:00',1.34),('325','2013-06-12','08:50:00',1.34),('325','2013-06-12','08:55:00',1.33),('325','2013-06-12','09:00:00',1.33),('325','2013-06-12','09:05:00',1.37),('325','2013-06-12','09:10:00',1.4),('325','2013-06-12','09:15:00',1.43),('325','2013-06-12','09:20:00',1.5),('325','2013-06-12','09:25:00',2.55),('325','2013-06-12','09:30:00',2.64),('325','2013-06-12','09:35:00',2.7),('325','2013-06-12','09:40:00',2.8),('325','2013-06-12','09:45:00',2.9),('325','2013-06-12','09:50:00',2.91),('325','2013-06-12','09:55:00',2.91),('325','2013-06-12','10:00:00',2.98),('325','2013-06-12','10:05:00',3.06),('325','2013-06-12','10:10:00',3.15),('325','2013-06-12','10:15:00',3.22),('325','2013-06-12','10:20:00',3.27),('325','2013-06-12','10:25:00',3.28),('325','2013-06-12','10:30:00',3.44),('325','2013-06-12','10:35:00',3.49),('325','2013-06-12','10:40:00',3.55),('325','2013-06-12','10:45:00',3.59),('325','2013-06-12','10:50:00',3.61),('325','2013-06-12','10:55:00',3.66),('325','2013-06-12','11:00:00',4.03),('325','2013-06-12','11:05:00',4.16),('325','2013-06-12','11:10:00',4.22),('325','2013-06-12','11:15:00',4.27),('325','2013-06-12','11:20:00',4.29),('325','2013-06-12','11:25:00',4.27),('325','2013-06-12','11:30:00',4.31),('325','2013-06-12','11:35:00',4.32),('325','2013-06-12','11:40:00',4.39),('325','2013-06-12','11:45:00',4.47),('325','2013-06-12','11:50:00',4.45),('325','2013-06-12','11:55:00',4.48),('325','2013-06-12','12:00:00',4.47),('325','2013-06-12','12:05:00',4.32),('325','2013-06-12','12:10:00',4.48),('325','2013-06-12','12:15:00',4.49),('325','2013-06-12','12:20:00',4.6),('325','2013-06-12','12:25:00',3.44),('325','2013-06-12','12:30:00',2.77),('325','2013-06-12','12:35:00',4.93),('325','2013-06-12','12:40:00',4.99),('325','2013-06-12','12:45:00',1.43),('325','2013-06-12','12:50:00',2.01),('325','2013-06-12','12:55:00',3.01),('325','2013-06-12','13:00:00',4.39),('325','2013-06-12','13:05:00',3.02),('325','2013-06-12','13:10:00',4.86),('325','2013-06-12','13:15:00',4.75),('325','2013-06-12','13:20:00',4.69),('325','2013-06-12','13:25:00',4.63),('325','2013-06-12','13:30:00',4.59),('325','2013-06-12','13:35:00',4.61),('325','2013-06-12','13:40:00',4.64),('325','2013-06-12','13:45:00',4.11),('325','2013-06-12','13:50:00',4.54),('325','2013-06-12','13:55:00',4.52),('325','2013-06-12','14:00:00',3.31),('325','2013-06-12','14:05:00',2.33),('325','2013-06-12','14:10:00',1.52),('325','2013-06-12','14:15:00',4.59),('325','2013-06-12','14:20:00',2.56),('325','2013-06-12','14:25:00',2.35),('325','2013-06-12','14:30:00',4.27),('325','2013-06-12','14:35:00',4.02),('325','2013-06-12','14:40:00',4.6),('325','2013-06-12','14:45:00',4.61),('325','2013-06-12','14:50:00',4.61),('325','2013-06-12','14:55:00',4.56),('325','2013-06-12','15:00:00',4.5),('325','2013-06-12','15:05:00',4.43),('325','2013-06-12','15:10:00',4.32),('325','2013-06-12','15:15:00',4.04),('325','2013-06-12','15:20:00',4.3),('325','2013-06-12','15:25:00',4.12),('325','2013-06-12','15:30:00',3.98),('325','2013-06-12','15:35:00',3.95),('325','2013-06-12','15:40:00',3.95),('325','2013-06-12','15:45:00',3.93),('325','2013-06-12','15:50:00',3.94),('325','2013-06-12','15:55:00',3.95),('325','2013-06-12','16:00:00',3.96),('325','2013-06-12','16:05:00',3.76),('325','2013-06-12','16:10:00',3.71),('325','2013-06-12','16:15:00',3.66),('325','2013-06-12','16:20:00',3.57),('325','2013-06-12','16:25:00',3.58),('325','2013-06-12','16:30:00',2.77),('325','2013-06-12','16:35:00',3.16),('325','2013-06-12','16:40:00',3.39),('325','2013-06-12','16:45:00',2.06),('325','2013-06-12','16:50:00',2.8),('325','2013-06-12','16:55:00',2.54),('325','2013-06-12','17:00:00',2.93),('325','2013-06-12','17:05:00',2.86),('325','2013-06-12','17:10:00',2.8),('325','2013-06-12','17:15:00',2.71),('325','2013-06-12','17:20:00',2.62),('325','2013-06-12','17:25:00',2.52),('325','2013-06-12','17:30:00',2.45),('325','2013-06-12','17:35:00',2.4),('325','2013-06-12','17:40:00',2.33),('325','2013-06-12','18:05:00',1.52),('325','2013-06-12','18:10:00',1.64),('325','2013-06-12','18:15:00',1.48),('325','2013-06-12','18:20:00',1.31),('325','2013-06-12','18:25:00',1.17),('325','2013-06-12','18:30:00',1.08),('325','2013-06-12','18:35:00',1.02),('325','2013-06-11','08:05:00',1.05),('325','2013-06-11','08:15:00',1.06),('325','2013-06-11','08:20:00',1.35),('325','2013-06-11','08:25:00',1.47),('325','2013-06-11','08:30:00',1.46),('325','2013-06-11','08:35:00',1.52),('325','2013-06-11','08:40:00',1.58),('325','2013-06-11','08:45:00',1.39),('325','2013-06-11','08:50:00',1.38),('325','2013-06-11','08:55:00',1.58),('325','2013-06-11','09:00:00',1.57),('325','2013-06-11','09:05:00',1.71),('325','2013-06-11','09:10:00',1.73),('325','2013-06-11','09:15:00',1.75),('325','2013-06-11','09:20:00',1.77),('325','2013-06-11','09:25:00',2.05),('325','2013-06-11','09:30:00',2.38),('325','2013-06-11','09:40:00',2.99),('325','2013-06-11','09:45:00',3.21),('325','2013-06-11','09:50:00',3.23),('325','2013-06-11','09:55:00',3),('325','2013-06-11','10:00:00',1.15),('325','2013-06-11','10:05:00',2.3),('325','2013-06-11','10:10:00',3.57),('325','2013-06-11','10:15:00',3.64),('325','2013-06-11','10:20:00',3.74),('325','2013-06-11','10:25:00',3.72),('325','2013-06-11','10:30:00',3.8),('325','2013-06-11','10:35:00',3.91),('325','2013-06-11','10:40:00',3.93),('325','2013-06-11','10:45:00',3.99),('325','2013-06-11','10:50:00',2.2),('325','2013-06-11','10:55:00',2.27),('325','2013-06-11','11:00:00',4.44),('325','2013-06-11','11:05:00',2.18),('325','2013-06-11','11:10:00',3.91),('325','2013-06-11','11:15:00',4.55),('325','2013-06-11','11:20:00',4.41),('325','2013-06-11','11:25:00',4.44),('325','2013-06-11','11:30:00',4.44),('325','2013-06-11','11:35:00',4.49),('325','2013-06-11','11:40:00',4.47),('325','2013-06-11','11:45:00',4.58),('325','2013-06-11','11:50:00',4.65),('325','2013-06-11','11:55:00',4.68),('325','2013-06-11','12:00:00',4.33),('325','2013-06-11','12:05:00',4.77),('325','2013-06-11','12:10:00',4.68),('325','2013-06-11','12:15:00',4.64),('325','2013-06-11','12:20:00',4.57),('325','2013-06-11','12:25:00',4.74),('325','2013-06-11','12:30:00',4.77),('325','2013-06-11','12:35:00',4.8),('325','2013-06-11','12:40:00',4.8),('325','2013-06-11','12:45:00',4.79),('325','2013-06-11','12:50:00',4.86),('325','2013-06-11','12:55:00',4.84),('325','2013-06-11','13:00:00',4.87),('325','2013-06-11','13:05:00',4.88),('325','2013-06-11','13:10:00',4.88),('325','2013-06-11','13:15:00',4.91),('325','2013-06-11','13:20:00',4.88),('325','2013-06-11','13:25:00',4.87),('325','2013-06-11','13:30:00',4.89),('325','2013-06-11','13:35:00',4.87),('325','2013-06-11','13:40:00',4.86),('325','2013-06-11','13:45:00',4.03),('325','2013-06-11','13:50:00',5),('325','2013-06-11','13:55:00',4.78),('325','2013-06-11','14:00:00',4.76),('325','2013-06-11','14:05:00',4.69),('325','2013-06-11','14:10:00',4.66),('325','2013-06-11','14:15:00',4.64),('325','2013-06-11','14:20:00',4.61),('325','2013-06-11','14:25:00',4.62),('325','2013-06-11','14:30:00',4.6),('325','2013-06-11','14:35:00',4.57),('325','2013-06-11','14:40:00',4.56),('325','2013-06-11','14:45:00',4.53),('325','2013-06-11','14:50:00',4.5),('325','2013-06-11','14:55:00',4.46),('325','2013-06-11','15:00:00',4.46),('325','2013-06-11','15:05:00',4.41),('325','2013-06-11','15:10:00',4.38),('325','2013-06-11','15:15:00',4.31),('325','2013-06-11','15:20:00',4.26),('325','2013-06-11','15:25:00',4.2),('325','2013-06-11','15:30:00',4.18),('325','2013-06-11','15:35:00',4.16),('325','2013-06-11','15:40:00',4.03),('325','2013-06-11','15:45:00',4.17),('325','2013-06-11','15:50:00',3.99),('325','2013-06-11','15:55:00',3.98),('325','2013-06-11','16:00:00',3.63),('325','2013-06-11','16:05:00',3.85),('325','2013-06-11','16:10:00',3.76),('325','2013-06-11','16:15:00',3.7),('325','2013-06-11','16:20:00',3.66),('325','2013-06-11','16:25:00',3.6),('325','2013-06-11','16:30:00',3.54),('325','2013-06-11','16:35:00',3.47),('325','2013-06-11','16:40:00',3.47),('325','2013-06-11','16:45:00',3.6),('325','2013-06-11','16:50:00',3.6),('325','2013-06-11','16:55:00',3.43),('325','2013-06-11','17:00:00',2.69),('325','2013-06-11','17:05:00',1.83),('325','2013-06-10','07:35:00',1.1),('325','2013-06-10','08:05:00',1.12),('325','2013-06-10','08:10:00',1.47),('325','2013-06-10','08:15:00',1.38),('325','2013-06-10','08:20:00',1.18),('325','2013-06-10','08:25:00',1.2),('325','2013-06-10','08:30:00',1.08),('325','2013-06-10','08:35:00',1.02),('325','2013-06-10','08:40:00',1.35),('325','2013-06-10','08:55:00',1.09),('325','2013-06-10','09:00:00',1.09),('325','2013-06-10','09:05:00',1.16),('325','2013-06-10','09:10:00',1.17),('325','2013-06-10','09:15:00',1.4),('325','2013-06-10','09:20:00',2.69),('325','2013-06-10','09:25:00',2.88),('325','2013-06-10','09:30:00',2.24),('325','2013-06-10','09:35:00',3.26),('325','2013-06-10','09:40:00',2.2),('325','2013-06-10','09:45:00',3.49),('325','2013-06-10','09:50:00',1.76),('325','2013-06-10','09:55:00',1.59),('325','2013-06-10','10:00:00',1.99),('325','2013-06-10','10:05:00',2.07),('325','2013-06-10','10:10:00',1.95),('325','2013-06-10','10:15:00',1.99),('325','2013-06-10','10:20:00',1.86),('325','2013-06-10','10:25:00',1.94),('325','2013-06-10','10:30:00',1.57),('325','2013-06-10','10:35:00',2.4),('325','2013-06-10','10:40:00',1.52),('325','2013-06-10','10:45:00',1.25),('325','2013-06-10','10:50:00',2.06),('325','2013-06-10','10:55:00',3.72),('325','2013-06-10','11:00:00',2.87),('325','2013-06-10','11:05:00',2.67),('325','2013-06-10','11:10:00',1.86),('325','2013-06-10','11:15:00',3.88),('325','2013-06-10','11:20:00',4.37),('325','2013-06-10','11:25:00',4.66),('325','2013-06-10','11:30:00',4.81),('325','2013-06-10','11:35:00',3.69),('325','2013-06-10','11:40:00',2.83),('325','2013-06-10','11:45:00',2.78),('325','2013-06-10','11:50:00',2.35),('325','2013-06-10','11:55:00',4.89),('325','2013-06-10','12:00:00',3.31),('325','2013-06-10','12:05:00',1.66),('325','2013-06-10','12:10:00',4.11),('325','2013-06-10','12:15:00',4.72),('325','2013-06-10','12:20:00',5.05),('325','2013-06-10','12:25:00',4.59),('325','2013-06-10','12:30:00',5.25),('325','2013-06-10','12:35:00',4.46),('325','2013-06-10','12:40:00',5.44),('325','2013-06-10','12:45:00',2.41),('325','2013-06-10','12:50:00',2.34),('325','2013-06-10','12:55:00',4.93),('325','2013-06-10','13:00:00',5.3),('325','2013-06-10','13:05:00',4.56),('325','2013-06-10','13:10:00',2.17),('325','2013-06-10','13:15:00',3.98),('325','2013-06-10','13:20:00',3.63),('325','2013-06-10','13:25:00',2.63),('325','2013-06-10','13:30:00',3.13),('325','2013-06-10','13:35:00',5.34),('325','2013-06-10','13:40:00',5.18),('325','2013-06-10','13:45:00',4.9),('325','2013-06-10','13:50:00',4.91),('325','2013-06-10','13:55:00',4.69),('325','2013-06-10','14:00:00',4.3),('325','2013-06-10','14:05:00',5.07),('325','2013-06-10','14:10:00',3.76),('325','2013-06-10','14:15:00',4.77),('325','2013-06-10','14:20:00',4.76),('325','2013-06-10','14:25:00',4.69),('325','2013-06-10','14:30:00',4.6),('325','2013-06-10','14:35:00',4.55),('325','2013-06-10','14:40:00',4.07),('325','2013-06-10','14:45:00',4.59),('325','2013-06-10','14:50:00',4.53),('325','2013-06-10','14:55:00',4.5),('325','2013-06-10','15:00:00',4.47),('325','2013-06-10','15:05:00',4.44),('325','2013-06-10','15:10:00',4.39),('325','2013-06-10','15:15:00',4.37),('325','2013-06-10','15:20:00',4.33),('325','2013-06-10','15:25:00',4.3),('325','2013-06-10','15:30:00',4.28),('325','2013-06-10','15:35:00',4.23),('325','2013-06-10','15:40:00',4.17),('325','2013-06-10','15:45:00',4.11),('325','2013-06-10','15:50:00',4.04),('325','2013-06-10','15:55:00',3.99),('325','2013-06-10','16:00:00',3.9),('325','2013-06-10','16:05:00',3.84),('325','2013-06-10','16:10:00',3.78),('325','2013-06-10','16:15:00',3.74),('325','2013-06-10','16:20:00',3.68),('325','2013-06-10','16:25:00',3.63),('325','2013-06-10','16:30:00',3.55),('325','2013-06-10','16:35:00',3.47),('325','2013-06-10','16:40:00',3.41),('325','2013-06-10','16:45:00',3.34),('325','2013-06-10','16:50:00',3.27),('325','2013-06-10','16:55:00',3.18),('325','2013-06-10','17:00:00',3.05),('325','2013-06-10','17:05:00',2.9),('325','2013-06-10','17:10:00',2.9),('325','2013-06-10','17:15:00',2.83),('325','2013-06-10','17:20:00',2.74),('325','2013-06-10','17:25:00',2.64),('325','2013-06-10','17:30:00',2.54),('325','2013-06-10','17:35:00',2.44),('325','2013-06-10','17:40:00',2.34),('325','2013-06-10','17:45:00',2.25),('325','2013-06-10','17:50:00',2.15),('325','2013-06-10','17:55:00',2.02),('325','2013-06-10','18:00:00',1.93),('325','2013-06-10','18:05:00',1.83),('325','2013-06-10','18:10:00',1.7),('325','2013-06-10','18:15:00',1.49),('325','2013-06-10','18:20:00',1.31),('325','2013-06-10','18:25:00',1.21),('325','2013-06-10','18:30:00',1.11),('325','2013-06-10','18:35:00',1.08),('325','2014-04-02','08:50:00',1.13),('325','2014-04-02','09:50:00',1.63),('325','2014-04-02','09:55:00',2.3),('325','2014-04-02','10:00:00',1.93),('325','2014-04-02','10:05:00',2.45),('325','2014-04-02','10:10:00',2.72),('325','2014-04-02','10:15:00',2.88),('325','2014-04-02','10:20:00',2.27),('325','2014-04-02','10:25:00',2.02),('325','2014-04-02','10:30:00',1.21),('325','2014-04-02','10:35:00',1.37),('325','2014-04-02','10:40:00',1.46),('325','2014-04-02','10:45:00',2.31),('325','2014-04-02','10:50:00',3.71),('325','2014-04-02','10:55:00',4.18),('325','2014-04-02','11:00:00',3.43),('325','2014-04-02','11:05:00',1.39),('325','2014-04-02','11:10:00',1.7),('325','2014-04-02','11:15:00',4.03),('325','2014-04-02','11:20:00',4.15),('325','2014-04-02','11:25:00',4.69),('325','2014-04-02','11:30:00',3.22),('325','2014-04-02','11:35:00',1.2),('325','2014-04-02','11:40:00',1.2),('325','2014-04-02','11:45:00',3.21),('325','2014-04-02','11:50:00',4.58),('325','2014-04-02','11:55:00',4.69),('325','2014-04-02','12:00:00',4.21),('325','2014-04-02','12:05:00',1.5),('325','2014-04-02','12:10:00',2.33),('325','2014-04-02','12:15:00',4.7),('325','2014-04-02','12:20:00',4.14),('325','2014-04-02','12:25:00',2.57),('325','2014-04-02','12:30:00',4.88),('325','2014-04-02','12:35:00',4.91),('325','2014-04-02','12:40:00',4.9),('325','2014-04-02','12:45:00',3.67),('325','2014-04-02','12:50:00',4.35),('325','2014-04-02','12:55:00',1.98),('325','2014-04-02','13:00:00',3.48),('325','2014-04-02','13:05:00',5.29),('325','2014-04-02','13:10:00',4.34),('325','2014-04-02','13:15:00',4.23),('325','2014-04-02','13:20:00',4.68),('325','2014-04-02','13:25:00',4.76),('325','2014-04-02','13:30:00',4.76),('325','2014-04-02','13:35:00',3.9),('325','2014-04-02','13:40:00',4.84),('325','2014-04-02','13:45:00',4.63),('325','2014-04-02','13:50:00',4.65),('325','2014-04-02','13:55:00',4.64),('325','2014-04-02','14:00:00',4.56),('325','2014-04-02','14:05:00',4.54),('325','2014-04-02','14:10:00',4.54),('325','2014-04-02','14:15:00',4.47),('325','2014-04-02','14:20:00',4.38),('325','2014-04-02','14:25:00',4.48),('325','2014-04-02','14:30:00',4.41),('325','2014-04-02','14:35:00',4.35),('325','2014-04-02','14:40:00',4.28),('325','2014-04-02','14:45:00',4.07),('325','2014-04-02','14:50:00',4.14),('325','2014-04-02','14:55:00',3.82),('325','2014-04-02','15:00:00',4.03),('325','2014-04-02','15:05:00',4.05),('325','2014-04-02','15:10:00',3.75),('325','2014-04-02','15:15:00',3.85),('325','2014-04-02','15:20:00',3.85),('325','2014-04-02','15:25:00',3.78),('325','2014-04-02','15:30:00',3.56),('325','2014-04-02','15:35:00',3.47),('325','2014-04-02','15:40:00',3.53),('325','2014-04-02','15:45:00',3.63),('325','2014-04-02','15:50:00',3.58),('325','2014-04-02','15:55:00',3.11),('325','2014-04-02','16:00:00',3.27),('325','2014-04-02','16:05:00',3.24),('325','2014-04-02','16:10:00',3.2),('325','2014-04-02','16:15:00',3.1),('325','2014-04-02','16:20:00',3.01),('325','2014-04-02','16:25:00',2.89),('325','2014-04-02','16:30:00',2.94),('325','2014-04-02','16:35:00',2.87),('325','2014-04-02','16:40:00',2.73),('325','2014-04-02','16:45:00',2.54),('325','2014-04-02','16:50:00',2.37),('325','2014-04-02','16:55:00',2.37),('325','2014-04-02','17:00:00',2.41),('325','2014-04-02','17:05:00',2.17),('325','2014-04-02','17:10:00',2.08),('325','2014-04-02','17:15:00',1.85),('325','2014-04-02','17:20:00',1.85),('325','2014-04-02','17:25:00',1.72),('325','2014-04-02','17:30:00',1.54),('325','2014-04-02','17:35:00',1.51),('325','2014-04-02','17:40:00',1.12),('325','2014-04-02','17:45:00',1.14),('325','2014-04-02','17:50:00',1.38),('325','2014-04-02','17:55:00',1.18),('325','2014-04-02','18:00:00',1.07),('325','2013-06-09','07:35:00',1.01),('325','2013-06-09','08:20:00',1.14),('325','2013-06-09','08:25:00',1.2),('325','2013-06-09','08:30:00',1.28),('325','2013-06-09','08:35:00',1.35),('325','2013-06-09','08:40:00',1.37),('325','2013-06-09','08:45:00',1.39),('325','2013-06-09','08:50:00',1.43),('325','2013-06-09','08:55:00',1.44),('325','2013-06-09','09:00:00',1.46),('325','2013-06-09','09:05:00',1.5),('325','2013-06-09','09:10:00',1.53),('325','2013-06-09','09:15:00',1.56),('325','2013-06-09','09:20:00',1.75),('325','2013-06-09','09:25:00',2.46),('325','2013-06-09','09:30:00',2.56),('325','2013-06-09','09:35:00',2.67),('325','2013-06-09','09:40:00',2.68),('325','2013-06-09','09:45:00',2.71),('325','2013-06-09','09:50:00',2.83),('325','2013-06-09','09:55:00',2.85),('325','2013-06-09','10:00:00',2.92),('325','2013-06-09','10:05:00',3.02),('325','2013-06-09','10:10:00',3.11),('325','2013-06-09','10:15:00',3.14),('325','2013-06-09','10:20:00',3.18),('325','2013-06-09','10:25:00',3.28),('325','2013-06-09','10:30:00',3.34),('325','2013-06-09','10:35:00',3.37),('325','2013-06-09','10:40:00',3.45),('325','2013-06-09','10:45:00',3.44),('325','2013-06-09','10:50:00',3.45),('325','2013-06-09','10:55:00',3.53),('325','2013-06-09','11:00:00',3.56),('325','2013-06-09','11:05:00',3.56),('325','2013-06-09','11:10:00',3.76),('325','2013-06-09','11:15:00',3.92),('325','2013-06-09','11:20:00',4.03),('325','2013-06-09','11:25:00',4),('325','2013-06-09','11:30:00',4.05),('325','2013-06-09','11:35:00',4.13),('325','2013-06-09','11:40:00',4.19),('325','2013-06-09','11:45:00',4.26),('325','2013-06-09','11:50:00',4.21),('325','2013-06-09','11:55:00',4.2),('325','2013-06-09','12:00:00',4.2),('325','2013-06-09','12:05:00',4.3),('325','2013-06-09','12:10:00',3.8),('325','2013-06-09','12:15:00',4.14),('325','2013-06-09','12:20:00',4.37),('325','2013-06-09','12:25:00',4.45),('325','2013-06-09','12:30:00',4.4),('325','2013-06-09','12:35:00',4.32),('325','2013-06-09','12:40:00',4.38),('325','2013-06-09','12:45:00',4.23),('325','2013-06-09','12:50:00',4.53),('325','2013-06-09','12:55:00',3.9),('325','2013-06-09','13:00:00',4.03),('325','2013-06-09','13:05:00',2.62),('325','2013-06-09','13:10:00',2.08),('325','2013-06-09','13:15:00',2.51),('325','2013-06-09','13:20:00',2.81),('325','2013-06-09','13:25:00',4.96),('325','2013-06-09','13:30:00',4.69),('325','2013-06-09','13:35:00',4.7),('325','2013-06-09','13:40:00',4.83),('325','2013-06-09','13:45:00',4.84),('325','2013-06-09','13:50:00',4.99),('325','2013-06-09','13:55:00',4.49),('325','2013-06-09','14:00:00',4.79),('325','2013-06-09','14:05:00',4.66),('325','2013-06-09','14:10:00',4.75),('325','2013-06-09','14:15:00',3.23),('325','2013-06-09','14:20:00',2.06),('325','2013-06-09','14:25:00',1.21),('325','2013-06-09','14:30:00',1.74),('325','2013-06-09','14:35:00',4.2),('325','2013-06-09','14:40:00',4.14),('325','2013-06-09','14:45:00',4.31),('325','2013-06-09','14:50:00',4.41),('325','2013-06-09','14:55:00',4.42),('325','2013-06-09','15:00:00',4.33),('325','2013-06-09','15:05:00',4.16),('325','2013-06-09','15:10:00',4.22),('325','2013-06-09','15:15:00',4.14),('325','2013-06-09','15:20:00',4.1),('325','2013-06-09','15:25:00',4.11),('325','2013-06-09','15:30:00',3.99),('325','2013-06-09','15:35:00',3.98),('325','2013-06-09','15:40:00',3.11),('325','2013-06-09','15:45:00',3.17),('325','2013-06-09','15:50:00',3.66),('325','2013-06-09','15:55:00',3.89),('325','2013-06-09','16:00:00',2.8),('325','2013-06-09','16:05:00',3.64),('325','2013-06-09','16:10:00',3.35),('325','2013-06-09','16:15:00',1.92),('325','2013-06-09','16:20:00',1.83),('325','2013-06-09','16:25:00',2.32),('325','2013-06-09','16:30:00',1.44),('325','2013-06-09','16:35:00',1.03),('325','2013-06-09','17:05:00',1),('325','2013-06-09','18:00:00',1.08),('325','2013-06-09','18:10:00',1.41),('325','2013-06-08','08:15:00',1.01),('325','2013-06-08','08:20:00',1.07),('325','2013-06-08','08:25:00',1.13),('325','2013-06-08','08:30:00',1.18),('325','2013-06-08','08:35:00',1.25),('325','2013-06-08','08:40:00',1.29),('325','2013-06-08','08:45:00',1.34),('325','2013-06-08','08:50:00',1.34),('325','2013-06-08','08:55:00',1.33),('325','2013-06-08','09:00:00',1.35),('325','2013-06-08','09:05:00',1.4),('325','2013-06-08','09:10:00',1.41),('325','2013-06-08','09:15:00',1.45),('325','2013-06-08','09:20:00',1.5),('325','2013-06-08','09:25:00',1.53),('325','2013-06-08','09:30:00',1.84),('325','2013-06-08','09:35:00',2.63),('325','2013-06-08','09:40:00',2.71),('325','2013-06-08','09:45:00',2.8),('325','2013-06-08','09:50:00',2.8),('325','2013-06-08','09:55:00',2.87),('325','2013-06-08','10:00:00',2.93),('325','2013-06-08','10:05:00',2.23),('325','2013-06-08','10:10:00',2.4),('325','2013-06-08','10:15:00',2.66),('325','2013-06-08','10:20:00',3.44),('325','2013-06-08','10:25:00',3.46),('325','2013-06-08','10:30:00',3.32),('325','2013-06-08','10:35:00',3.69),('325','2013-06-08','10:40:00',3.81),('325','2013-06-08','10:45:00',3.75),('325','2013-06-08','10:50:00',4.03),('325','2013-06-08','10:55:00',2.23),('325','2013-06-08','11:00:00',1.37),('325','2013-06-08','11:05:00',3.02),('325','2013-06-08','11:10:00',3.87),('325','2013-06-08','11:15:00',4.73),('325','2013-06-08','11:20:00',4),('325','2013-06-08','11:25:00',3.35),('325','2013-06-08','11:30:00',1.05),('325','2013-06-08','11:35:00',3.25),('325','2013-06-08','11:40:00',3.74),('325','2013-06-08','11:45:00',3.46),('325','2013-06-08','11:50:00',4.27),('325','2013-06-08','11:55:00',4.95),('325','2013-06-08','12:00:00',3.66),('325','2013-06-08','12:05:00',1.19),('325','2013-06-08','12:10:00',3.46),('325','2013-06-08','12:15:00',3.8),('325','2013-06-08','12:20:00',2.13),('325','2013-06-08','12:25:00',4.8),('325','2013-06-08','12:30:00',4.76),('325','2013-06-08','12:35:00',4.7),('325','2013-06-08','12:40:00',4.26),('325','2013-06-08','12:45:00',4.72),('325','2013-06-08','12:50:00',4.75),('325','2013-06-08','12:55:00',4.69),('325','2013-06-08','13:00:00',4.73),('325','2013-06-08','13:05:00',4.7),('325','2013-06-08','13:10:00',4.72),('325','2013-06-08','13:15:00',4.72),('325','2013-06-08','13:20:00',4.78),('325','2013-06-08','13:25:00',4.77),('325','2013-06-08','13:30:00',4.85),('325','2013-06-08','13:35:00',4.77),('325','2013-06-08','13:40:00',4.71),('325','2013-06-08','13:45:00',4.62),('325','2013-06-08','13:50:00',4.56),('325','2013-06-08','13:55:00',4.51),('325','2013-06-08','14:00:00',4.48),('325','2013-06-08','14:05:00',4.38),('325','2013-06-08','14:10:00',4.32),('325','2013-06-08','14:15:00',4.27),('325','2013-06-08','14:20:00',4.24),('325','2013-06-08','14:25:00',4.32),('325','2013-06-08','14:30:00',4.46),('325','2013-06-08','14:35:00',4.48),('325','2013-06-08','14:40:00',4.49),('325','2013-06-08','14:45:00',4.46),('325','2013-06-08','14:50:00',4.46),('325','2013-06-08','14:55:00',4.43),('325','2013-06-08','15:00:00',4.39),('325','2013-06-08','15:05:00',4.24),('325','2013-06-08','15:10:00',3.96),('325','2013-06-08','15:15:00',4.16),('325','2013-06-08','15:20:00',4.31),('325','2013-06-08','15:25:00',4.03),('325','2013-06-08','15:30:00',4.11),('325','2013-06-08','15:35:00',4.05),('325','2013-06-08','15:40:00',3.13),('325','2013-06-08','15:45:00',4.31),('325','2013-06-08','15:50:00',4.24),('325','2013-06-08','15:55:00',3.87),('325','2013-06-08','16:00:00',3.93),('325','2013-06-08','16:05:00',3.85),('325','2013-06-08','16:10:00',3.84),('325','2013-06-08','16:15:00',3.85),('325','2013-06-08','16:20:00',3.74),('325','2013-06-08','16:25:00',3.61),('325','2013-06-08','16:30:00',3.46),('325','2013-06-08','16:35:00',3.39),('325','2013-06-08','16:40:00',3.3),('325','2013-06-08','16:45:00',3.23),('325','2013-06-08','16:50:00',2.72),('325','2013-06-08','16:55:00',2.79),('325','2013-06-08','17:00:00',2.97),('325','2013-06-08','17:05:00',2.83),('325','2013-06-08','17:10:00',3.08),('325','2013-06-08','17:15:00',3),('325','2013-06-08','17:20:00',2.84),('325','2013-06-08','17:25:00',2.64),('325','2013-06-08','17:30:00',1.9),('325','2013-06-08','17:35:00',1.45),('325','2013-06-08','17:40:00',2.25),('325','2013-06-08','17:45:00',2.29),('325','2013-06-08','17:50:00',2.13),('325','2013-06-08','17:55:00',2.07),('325','2013-06-08','18:00:00',1.7),('325','2013-06-08','18:05:00',1.48),('325','2013-06-08','18:10:00',1.21),('325','2013-06-08','18:15:00',1.18),('325','2013-06-08','18:20:00',1.08),('325','2013-06-07','08:15:00',1.03),('325','2013-06-07','08:20:00',1.07),('325','2013-06-07','08:25:00',1.15),('325','2013-06-07','08:30:00',1.19),('325','2013-06-07','08:35:00',1.27),('325','2013-06-07','08:40:00',1.31),('325','2013-06-07','08:45:00',1.35),('325','2013-06-07','08:50:00',1.34),('325','2013-06-07','08:55:00',1.32),('325','2013-06-07','09:00:00',1.34),('325','2013-06-07','09:05:00',1.38),('325','2013-06-07','09:10:00',1.4),('325','2013-06-07','09:15:00',1.43),('325','2013-06-07','09:20:00',1.52),('325','2013-06-07','09:25:00',2.68),('325','2013-06-07','09:30:00',2.76),('325','2013-06-07','09:35:00',2.84),('325','2013-06-07','09:40:00',2.88),('325','2013-06-07','09:45:00',2.97),('325','2013-06-07','09:50:00',3),('325','2013-06-07','09:55:00',3.05),('325','2013-06-07','10:00:00',3.13),('325','2013-06-07','10:05:00',3.32),('325','2013-06-07','10:10:00',3.46),('325','2013-06-07','10:15:00',3.53),('325','2013-06-07','10:20:00',3.62),('325','2013-06-07','10:25:00',3.69),('325','2013-06-07','10:30:00',3.77),('325','2013-06-07','10:35:00',3.85),('325','2013-06-07','10:40:00',3.91),('325','2013-06-07','10:45:00',3.93),('325','2013-06-07','10:50:00',3.97),('325','2013-06-07','10:55:00',4.08),('325','2013-06-07','11:00:00',4.15),('325','2013-06-07','11:05:00',4.21),('325','2013-06-07','11:10:00',4.29),('325','2013-06-07','11:15:00',4.3),('325','2013-06-07','11:20:00',4.32),('325','2013-06-07','11:25:00',4.36),('325','2013-06-07','11:30:00',4.4),('325','2013-06-07','11:35:00',4.41),('325','2013-06-07','11:40:00',4.46),('325','2013-06-07','11:45:00',4.51),('325','2013-06-07','11:50:00',4.52),('325','2013-06-07','11:55:00',4.56),('325','2013-06-07','12:00:00',4.57),('325','2013-06-07','12:05:00',4.57),('325','2013-06-07','12:10:00',4.56),('325','2013-06-07','12:15:00',4.56),('325','2013-06-07','12:20:00',4.64),('325','2013-06-07','12:25:00',4.63),('325','2013-06-07','12:30:00',4.66),('325','2013-06-07','12:35:00',4.65),('325','2013-06-07','12:40:00',4.65),('325','2013-06-07','12:45:00',4.69),('325','2013-06-07','12:50:00',4.69),('325','2013-06-07','12:55:00',4.68),('325','2013-06-07','13:00:00',4.67),('325','2013-06-07','13:05:00',4.64),('325','2013-06-07','13:10:00',4.63),('325','2013-06-07','13:15:00',4.62),('325','2013-06-07','13:20:00',4.62),('325','2013-06-07','13:25:00',4.63),('325','2013-06-07','13:30:00',4.6),('325','2013-06-07','13:35:00',4.59),('325','2013-06-07','13:40:00',4.55),('325','2013-06-07','13:45:00',4.48),('325','2013-06-07','13:50:00',4.4),('325','2013-06-07','13:55:00',4.43),('325','2013-06-07','14:00:00',4.4),('325','2013-06-07','14:05:00',4.37),('325','2013-06-07','14:10:00',4.35),('325','2013-06-07','14:15:00',4.34),('325','2013-06-07','14:20:00',4.27),('325','2013-06-07','14:25:00',4.28),('325','2013-06-07','14:30:00',4.21),('325','2013-06-07','14:35:00',4.19),('325','2013-06-07','14:40:00',4.22),('325','2013-06-07','14:45:00',4.24),('325','2013-06-07','14:50:00',4.22),('325','2013-06-07','14:55:00',4.18),('325','2013-06-07','15:00:00',4.19),('325','2013-06-07','15:05:00',4.22),('325','2013-06-07','15:10:00',4.16),('325','2013-06-07','15:15:00',4.13),('325','2013-06-07','15:20:00',4.14),('325','2013-06-07','15:25:00',4.14),('325','2013-06-07','15:30:00',4.1),('325','2013-06-07','15:35:00',4.05),('325','2013-06-07','15:40:00',3.97),('325','2013-06-07','15:45:00',3.94),('325','2013-06-07','15:50:00',3.88),('325','2013-06-07','15:55:00',3.81),('325','2013-06-07','16:00:00',3.75),('325','2013-06-07','16:05:00',3.67),('325','2013-06-07','16:10:00',3.52),('325','2013-06-07','16:15:00',3.36),('325','2013-06-07','16:20:00',3.42),('325','2013-06-07','16:25:00',3.46),('325','2013-06-07','16:30:00',3.42),('325','2013-06-07','16:35:00',3.35),('325','2013-06-07','16:40:00',3.28),('325','2013-06-07','16:45:00',3.22),('325','2013-06-07','16:50:00',3.15),('325','2013-06-07','16:55:00',3.06),('325','2013-06-07','17:00:00',2.91),('325','2013-06-07','17:05:00',2.77);
INSERT INTO `solarlogmod` VALUES ('325','2013-06-07','17:10:00',2.78),('325','2013-06-07','17:15:00',2.62),('325','2013-06-07','17:20:00',2.54),('325','2013-06-07','17:25:00',2.48),('325','2013-06-07','17:30:00',2.39),('325','2013-06-07','17:35:00',2.31),('325','2013-06-07','17:40:00',2.22),('325','2013-06-07','17:45:00',2.19),('325','2013-06-07','17:50:00',2.1),('325','2013-06-07','17:55:00',1.94),('325','2013-06-07','18:00:00',1.85),('325','2013-06-07','18:05:00',1.77),('325','2013-06-07','18:10:00',1.62),('325','2013-06-07','18:15:00',1.42),('325','2013-06-07','18:20:00',1.24),('325','2013-06-07','18:25:00',1.09),('325','2013-06-07','18:30:00',1.01),('325','2013-06-06','08:20:00',1.07),('325','2013-06-06','08:25:00',1.24),('325','2013-06-06','08:30:00',1.27),('325','2013-06-06','08:35:00',1.33),('325','2013-06-06','08:40:00',1.37),('325','2013-06-06','08:45:00',1.38),('325','2013-06-06','08:50:00',1.43),('325','2013-06-06','08:55:00',1.46),('325','2013-06-06','09:00:00',1.5),('325','2013-06-06','09:05:00',1.55),('325','2013-06-06','09:10:00',1.58),('325','2013-06-06','09:15:00',1.62),('325','2013-06-06','09:20:00',1.67),('325','2013-06-06','09:25:00',2.49),('325','2013-06-06','09:30:00',2.74),('325','2013-06-06','09:35:00',2.78),('325','2013-06-06','09:40:00',2.83),('325','2013-06-06','09:45:00',3.01),('325','2013-06-06','09:50:00',3.1),('325','2013-06-06','09:55:00',3.2),('325','2013-06-06','10:00:00',3.18),('325','2013-06-06','10:05:00',3.21),('325','2013-06-06','10:10:00',3.27),('325','2013-06-06','10:15:00',3.44),('325','2013-06-06','10:20:00',3.52),('325','2013-06-06','10:25:00',3.63),('325','2013-06-06','10:30:00',3.66),('325','2013-06-06','10:35:00',3.72),('325','2013-06-06','10:40:00',3.81),('325','2013-06-06','10:45:00',3.83),('325','2013-06-06','10:50:00',3.89),('325','2013-06-06','10:55:00',4.01),('325','2013-06-06','11:00:00',4.06),('325','2013-06-06','11:05:00',4.12),('325','2013-06-06','11:10:00',4.13),('325','2013-06-06','11:15:00',4.18),('325','2013-06-06','11:20:00',4.23),('325','2013-06-06','11:25:00',4.28),('325','2013-06-06','11:30:00',4.28),('325','2013-06-06','11:35:00',4.29),('325','2013-06-06','11:40:00',4.28),('325','2013-06-06','11:45:00',4.42),('325','2013-06-06','11:50:00',4.43),('325','2013-06-06','11:55:00',4.47),('325','2013-06-06','12:00:00',4.47),('325','2013-06-06','12:05:00',4.46),('325','2013-06-06','12:10:00',4.5),('325','2013-06-06','12:15:00',4.44),('325','2013-06-06','12:20:00',4.46),('325','2013-06-06','12:25:00',4.5),('325','2013-06-06','12:30:00',4.48),('325','2013-06-06','12:35:00',4.44),('325','2013-06-06','12:40:00',4.55),('325','2013-06-06','12:45:00',4.58),('325','2013-06-06','12:50:00',4.62),('325','2013-06-06','12:55:00',4.64),('325','2013-06-06','13:00:00',4.68),('325','2013-06-06','13:05:00',4.67),('325','2013-06-06','13:10:00',4.68),('325','2013-06-06','13:15:00',4.63),('325','2013-06-06','13:20:00',4.59),('325','2013-06-06','13:25:00',4.57),('325','2013-06-06','13:30:00',4.71),('325','2013-06-06','13:35:00',4.05),('325','2013-06-06','13:45:00',1.06),('325','2013-06-06','13:50:00',2.89),('325','2013-06-06','13:55:00',4.47),('325','2013-06-06','14:00:00',4.38),('325','2013-06-06','14:05:00',1.53),('325','2013-06-06','14:10:00',2.73),('325','2013-06-06','14:15:00',1.62),('325','2013-06-06','14:20:00',3.38),('325','2013-06-06','14:25:00',4.68),('325','2013-06-06','14:30:00',4.53),('325','2013-06-06','14:35:00',4.46),('325','2013-06-06','14:40:00',4.46),('325','2013-06-06','14:45:00',3.75),('325','2013-06-06','14:50:00',4.66),('325','2013-06-06','14:55:00',4.46),('325','2013-06-06','15:00:00',4.32),('325','2013-06-06','15:05:00',4.39),('325','2013-06-06','15:10:00',4.37),('325','2013-06-06','15:15:00',4.21),('325','2013-06-06','15:20:00',4.19),('325','2013-06-06','15:25:00',3.78),('325','2013-06-06','15:30:00',3.96),('325','2013-06-06','15:35:00',3.91),('325','2013-06-06','15:40:00',3.97),('325','2013-06-06','15:45:00',3.94),('325','2013-06-06','15:50:00',3.85),('325','2013-06-06','15:55:00',3.77),('325','2013-06-06','16:00:00',3.88),('325','2013-06-06','16:05:00',3.8),('325','2013-06-06','16:10:00',3.68),('325','2013-06-06','16:15:00',3.42),('325','2013-06-06','16:20:00',3.45),('325','2013-06-06','16:25:00',3.35),('325','2013-06-06','16:30:00',3.31),('325','2013-06-06','16:35:00',3.32),('325','2013-06-06','16:40:00',3.24),('325','2013-06-06','16:45:00',3.11),('325','2013-06-06','16:50:00',3.04),('325','2013-06-06','16:55:00',2.93),('325','2013-06-06','17:00:00',2.77),('325','2013-06-06','17:05:00',2.7),('325','2013-06-06','17:10:00',2.66),('325','2013-06-06','17:15:00',2.55),('325','2013-06-06','17:20:00',2.47),('325','2013-06-06','17:25:00',2.43),('325','2013-06-06','17:30:00',2.33),('325','2013-06-06','17:35:00',2.25),('325','2013-06-06','17:40:00',2.15),('325','2013-06-06','17:45:00',2.06),('325','2013-06-06','17:50:00',1.93),('325','2013-06-06','17:55:00',1.79),('325','2013-06-06','18:00:00',1.75),('325','2013-06-06','18:05:00',1.69),('325','2013-06-06','18:10:00',1.56),('325','2013-06-06','18:15:00',1.38),('325','2013-06-06','18:20:00',1.2),('325','2013-06-06','18:25:00',1.07),('325','2013-06-05','07:50:00',1.15),('325','2013-06-05','07:55:00',1.23),('325','2013-06-05','08:00:00',1.14),('325','2013-06-05','08:05:00',1.03),('325','2013-06-05','08:15:00',1.03),('325','2013-06-05','08:20:00',1.04),('325','2013-06-05','08:25:00',1.19),('325','2013-06-05','08:30:00',1.24),('325','2013-06-05','08:35:00',1.31),('325','2013-06-05','08:40:00',1.36),('325','2013-06-05','08:45:00',1.4),('325','2013-06-05','08:50:00',1.4),('325','2013-06-05','08:55:00',1.42),('325','2013-06-05','09:00:00',1.49),('325','2013-06-05','09:05:00',1.61),('325','2013-06-05','09:10:00',1.7),('325','2013-06-05','09:15:00',1.74),('325','2013-06-05','09:20:00',1.3),('325','2013-06-05','09:25:00',2.17),('325','2013-06-05','09:30:00',3.14),('325','2013-06-05','09:35:00',3.33),('325','2013-06-05','09:40:00',3.11),('325','2013-06-05','09:45:00',1.43),('325','2013-06-05','09:50:00',2),('325','2013-06-05','09:55:00',2.81),('325','2013-06-05','10:00:00',2.84),('325','2013-06-05','10:05:00',2.99),('325','2013-06-05','10:10:00',3.43),('325','2013-06-05','10:15:00',2.82),('325','2013-06-05','10:20:00',3.39),('325','2013-06-05','10:25:00',1.58),('325','2013-06-05','10:30:00',1.29),('325','2013-06-05','10:35:00',2.12),('325','2013-06-05','10:40:00',3.15),('325','2013-06-05','10:45:00',4.28),('325','2013-06-05','10:50:00',4.38),('325','2013-06-05','10:55:00',4.02),('325','2013-06-05','11:00:00',1.31),('325','2013-06-05','11:05:00',1.25),('325','2013-06-05','11:10:00',1.11),('325','2013-06-05','11:15:00',1.15),('325','2013-06-05','11:20:00',1.13),('325','2013-06-05','11:25:00',1.22),('325','2013-06-05','11:30:00',2.62),('325','2013-06-05','11:35:00',5.12),('325','2013-06-05','11:40:00',2.25),('325','2013-06-05','11:45:00',1.46),('325','2013-06-05','11:50:00',3.13),('325','2013-06-05','11:55:00',5.17),('325','2013-06-05','12:00:00',5.13),('325','2013-06-05','12:05:00',5.06),('325','2013-06-05','12:10:00',5.09),('325','2013-06-05','12:15:00',5.02),('325','2013-06-05','12:20:00',5.17),('325','2013-06-05','12:25:00',4.48),('325','2013-06-05','12:30:00',4.48),('325','2013-06-05','12:35:00',2.07),('325','2013-06-05','12:40:00',5.56),('325','2013-06-05','12:45:00',4.17),('325','2013-06-05','12:50:00',2.59),('325','2013-06-05','12:55:00',3.35),('325','2013-06-05','13:00:00',4.43),('325','2013-06-05','13:05:00',3.27),('325','2013-06-05','13:10:00',4.7),('325','2013-06-05','13:15:00',4.34),('325','2013-06-05','13:20:00',3.27),('325','2013-06-05','13:25:00',3.96),('325','2013-06-05','13:30:00',5.44),('325','2013-06-05','13:35:00',5.2),('325','2013-06-05','13:40:00',4.96),('325','2013-06-05','13:45:00',4.9),('325','2013-06-05','13:50:00',4.86),('325','2013-06-05','13:55:00',4.84),('325','2013-06-05','14:00:00',4.81),('325','2013-06-05','14:05:00',4.78),('325','2013-06-05','14:10:00',4.74),('325','2013-06-05','14:15:00',4.71),('325','2013-06-05','14:20:00',4.68),('325','2013-06-05','14:25:00',4.64),('325','2013-06-05','14:30:00',4.62),('325','2013-06-05','14:35:00',4.47),('325','2013-06-05','14:40:00',4.61),('325','2013-06-05','14:45:00',4.6),('325','2013-06-05','14:50:00',4.53),('325','2013-06-05','14:55:00',4.51),('325','2013-06-05','15:00:00',4.45),('325','2013-06-05','15:05:00',4.39),('325','2013-06-05','15:10:00',4.36),('325','2013-06-05','15:15:00',4.32),('325','2013-06-05','15:20:00',4.3),('325','2013-06-05','15:25:00',4.25),('325','2013-06-05','15:30:00',4.3),('325','2013-06-05','15:35:00',4.27),('325','2013-06-05','15:40:00',4.02),('325','2013-06-05','15:45:00',4.11),('325','2013-06-05','15:50:00',4.05),('325','2013-06-05','15:55:00',4.01),('325','2013-06-05','16:00:00',3.96),('325','2013-06-05','16:05:00',3.55),('325','2013-06-05','16:10:00',3.84),('325','2013-06-05','16:15:00',3.78),('325','2013-06-05','16:20:00',3.67),('325','2013-06-05','16:25:00',3.6),('325','2013-06-05','16:30:00',3.51),('325','2013-06-05','16:35:00',3.44),('325','2013-06-05','16:40:00',3.38),('325','2013-06-05','16:45:00',3.34),('325','2013-06-05','16:50:00',2.87),('325','2013-06-05','16:55:00',2.87),('325','2013-06-05','17:00:00',1.62),('325','2013-06-05','17:05:00',2.34),('325','2013-06-05','17:10:00',1.72),('325','2013-06-05','17:15:00',1.77),('325','2013-06-05','17:20:00',2.58),('325','2013-06-05','17:25:00',2.62),('325','2013-06-05','17:30:00',1.97),('325','2013-06-05','17:35:00',1.87),('325','2013-06-05','17:40:00',2.33),('325','2013-06-05','17:45:00',2.15),('325','2013-06-05','17:50:00',2),('325','2013-06-05','17:55:00',1.83),('325','2013-06-05','18:00:00',1.39),('325','2013-06-05','18:05:00',1.49),('325','2013-06-05','18:10:00',1.44),('325','2013-06-05','18:25:00',1.07),('325','2013-06-05','18:30:00',1.09),('325','2013-06-05','18:35:00',1.08),('325','2013-06-04','07:50:00',1.07),('325','2013-06-04','07:55:00',1.21),('325','2013-06-04','08:00:00',1.42),('325','2013-06-04','08:05:00',1.54),('325','2013-06-04','08:10:00',1.5),('325','2013-06-04','08:15:00',1.52),('325','2013-06-04','08:20:00',1.52),('325','2013-06-04','08:25:00',1.54),('325','2013-06-04','08:30:00',1.71),('325','2013-06-04','08:35:00',1.81),('325','2013-06-04','08:40:00',1.79),('325','2013-06-04','08:45:00',1.61),('325','2013-06-04','08:50:00',1.41),('325','2013-06-04','08:55:00',1.42),('325','2013-06-04','09:00:00',1.6),('325','2013-06-04','09:05:00',1.7),('325','2013-06-04','09:10:00',2.09),('325','2013-06-04','09:15:00',2.59),('325','2013-06-04','09:20:00',2.67),('325','2013-06-04','09:25:00',2.19),('325','2013-06-04','09:30:00',2.63),('325','2013-06-04','09:35:00',1.9),('325','2013-06-04','09:40:00',1.97),('325','2013-06-04','09:45:00',1.98),('325','2013-06-04','09:50:00',2.04),('325','2013-06-04','09:55:00',1.9),('325','2013-06-04','10:00:00',2.09),('325','2013-06-04','10:05:00',2.9),('325','2013-06-04','10:10:00',2.18),('325','2013-06-04','10:15:00',1.77),('325','2013-06-04','10:20:00',1.97),('325','2013-06-04','10:25:00',1.89),('325','2013-06-04','10:30:00',1.7),('325','2013-06-04','10:35:00',1.74),('325','2013-06-04','10:40:00',1.96),('325','2013-06-04','10:45:00',2.42),('325','2013-06-04','10:50:00',2.99),('325','2013-06-04','10:55:00',2.91),('325','2013-06-04','11:00:00',2.29),('325','2013-06-04','11:05:00',3.01),('325','2013-06-04','11:10:00',3.85),('325','2013-06-04','11:15:00',3.31),('325','2013-06-04','11:20:00',2.43),('325','2013-06-04','11:25:00',3.04),('325','2013-06-04','11:30:00',3.48),('325','2013-06-04','11:35:00',3.08),('325','2013-06-04','11:40:00',3.45),('325','2013-06-04','11:45:00',3.98),('325','2013-06-04','11:50:00',4.72),('325','2013-06-04','11:55:00',3.05),('325','2013-06-04','12:00:00',3.02),('325','2013-06-04','12:05:00',4.25),('325','2013-06-04','12:10:00',2.79),('325','2013-06-04','12:15:00',2.05),('325','2013-06-04','12:20:00',2.41),('325','2013-06-04','12:25:00',2.38),('325','2013-06-04','12:30:00',3.5),('325','2013-06-04','12:35:00',3.97),('325','2013-06-04','12:40:00',2.58),('325','2013-06-04','12:45:00',3.1),('325','2013-06-04','12:50:00',1.96),('325','2013-06-04','12:55:00',1.79),('325','2013-06-04','13:00:00',1.8),('325','2013-06-04','13:05:00',1.62),('325','2013-06-04','13:10:00',1.58),('325','2013-06-04','13:15:00',1.12),('325','2013-06-04','13:20:00',1.23),('325','2013-06-04','13:25:00',1.47),('325','2013-06-04','13:30:00',2.79),('325','2013-06-04','13:35:00',4.52),('325','2013-06-04','13:40:00',3.66),('325','2013-06-04','13:45:00',3.26),('325','2013-06-04','13:50:00',5.1),('325','2013-06-04','13:55:00',3.04),('325','2013-06-04','14:00:00',2.43),('325','2013-06-04','14:05:00',5.02),('325','2013-06-04','14:10:00',5.06),('325','2013-06-04','14:15:00',2.93),('325','2013-06-04','14:20:00',5.04),('325','2013-06-04','14:25:00',1.45),('325','2013-06-04','14:30:00',1.24),('325','2013-06-04','14:35:00',1.55),('325','2013-06-04','14:40:00',2.63),('325','2013-06-04','14:45:00',1.4),('325','2013-06-04','14:50:00',1.4),('325','2013-06-04','14:55:00',3.86),('325','2013-06-04','15:00:00',5.43),('325','2013-06-04','15:05:00',2.41),('325','2013-06-04','15:10:00',1.88),('325','2013-06-04','15:15:00',2.4),('325','2013-06-04','15:20:00',1.26),('325','2013-06-04','17:40:00',1.03),('325','2013-06-03','08:15:00',1.03),('325','2013-06-03','08:20:00',1.13),('325','2013-06-03','08:25:00',1.22),('325','2013-06-03','08:30:00',1.26),('325','2013-06-03','08:35:00',1.34),('325','2013-06-03','08:40:00',1.4),('325','2013-06-03','08:45:00',1.42),('325','2013-06-03','08:50:00',1.44),('325','2013-06-03','08:55:00',1.48),('325','2013-06-03','09:00:00',1.58),('325','2013-06-03','09:05:00',1.64),('325','2013-06-03','09:10:00',1.76),('325','2013-06-03','09:15:00',2.03),('325','2013-06-03','09:20:00',2.4),('325','2013-06-03','09:25:00',2.01),('325','2013-06-03','09:30:00',1.7),('325','2013-06-03','09:35:00',1.75),('325','2013-06-03','09:40:00',2.14),('325','2013-06-03','09:45:00',3.35),('325','2013-06-03','09:50:00',3.68),('325','2013-06-03','09:55:00',3.11),('325','2013-06-03','10:00:00',3.14),('325','2013-06-03','10:05:00',3.58),('325','2013-06-03','10:10:00',2.8),('325','2013-06-03','10:15:00',1.13),('325','2013-06-03','10:30:00',1.1),('325','2013-06-03','10:35:00',1.27),('325','2013-06-03','10:40:00',1.42),('325','2013-06-03','10:45:00',2),('325','2013-06-03','10:50:00',2.32),('325','2013-06-03','10:55:00',2.5),('325','2013-06-03','11:00:00',4.65),('325','2013-06-03','11:05:00',3.28),('325','2013-06-03','11:10:00',1.72),('325','2013-06-03','11:15:00',1.53),('325','2013-06-03','11:20:00',1.79),('325','2013-06-03','11:25:00',1.79),('325','2013-06-03','11:30:00',2.78),('325','2013-06-03','11:35:00',1.52),('325','2013-06-03','11:40:00',1.51),('325','2013-06-03','11:45:00',1.56),('325','2013-06-03','11:50:00',1.74),('325','2013-06-03','11:55:00',1.7),('325','2013-06-03','12:00:00',1.8),('325','2013-06-03','12:05:00',1.33),('325','2013-06-03','12:10:00',1.36),('325','2013-06-03','12:15:00',1.27),('325','2013-06-03','12:20:00',1.4),('325','2013-06-03','12:25:00',1.23),('325','2013-06-03','12:30:00',1.38),('325','2013-06-03','12:35:00',2.47),('325','2013-06-03','12:40:00',5.64),('325','2013-06-03','12:45:00',4.42),('325','2013-06-03','12:50:00',2.48),('325','2013-06-03','12:55:00',3.83),('325','2013-06-03','13:00:00',3.28),('325','2013-06-03','13:05:00',2.33),('325','2013-06-03','13:10:00',2.24),('325','2013-06-03','13:15:00',4.78),('325','2013-06-03','13:20:00',5.68),('325','2013-06-03','13:25:00',5.43),('325','2013-06-03','13:30:00',4.92),('325','2013-06-03','13:35:00',5.02),('325','2013-06-03','13:40:00',5.04),('325','2013-06-03','13:45:00',5.07),('325','2013-06-03','13:50:00',5.13),('325','2013-06-03','13:55:00',2.35),('325','2013-06-03','14:00:00',2.9),('325','2013-06-03','14:05:00',3.94),('325','2013-06-03','14:10:00',2.75),('325','2013-06-03','14:15:00',3.06),('325','2013-06-03','14:20:00',3.55),('325','2013-06-03','14:25:00',2.75),('325','2013-06-03','14:30:00',5.14),('325','2013-06-03','14:35:00',5.25),('325','2013-06-03','14:40:00',3.71),('325','2013-06-03','14:45:00',3.41),('325','2013-06-03','14:50:00',3.03),('325','2013-06-03','14:55:00',3.89),('325','2013-06-03','15:00:00',4.17),('325','2013-06-03','15:05:00',4.73),('325','2013-06-03','15:10:00',4.13),('325','2013-06-03','15:15:00',4.88),('325','2013-06-03','15:20:00',3.55),('325','2013-06-03','15:25:00',4.17),('325','2013-06-03','15:30:00',4.3),('325','2013-06-03','15:35:00',4.28),('325','2013-06-03','15:40:00',4.2),('325','2013-06-03','15:45:00',4.12),('325','2013-06-03','15:50:00',4.1),('325','2013-06-03','15:55:00',4.04),('325','2013-06-03','16:00:00',3.96),('325','2013-06-03','16:05:00',3.9),('325','2013-06-03','16:10:00',3.89),('325','2013-06-03','16:15:00',3.75),('325','2013-06-03','16:20:00',3.4),('325','2013-06-03','16:25:00',3.73),('325','2013-06-03','16:30:00',3.75),('325','2013-06-03','16:35:00',3.63),('325','2013-06-03','16:40:00',3.57),('325','2013-06-03','16:45:00',3.06),('325','2013-06-03','16:50:00',2.53),('325','2013-06-03','16:55:00',2.12),('325','2013-06-03','17:00:00',2.87),('325','2013-06-03','17:05:00',3.32),('325','2013-06-03','17:10:00',2.74),('325','2013-06-03','17:15:00',2.75),('325','2013-06-03','17:20:00',2.37),('325','2013-06-03','17:25:00',1.65),('325','2013-06-02','08:45:00',1.03),('325','2013-06-02','08:50:00',1.05),('325','2013-06-02','09:10:00',1.06),('325','2013-06-02','09:15:00',1.24),('325','2013-06-02','09:20:00',2.15),('325','2013-06-02','09:25:00',3.15),('325','2013-06-02','09:30:00',2.99),('325','2013-06-02','09:35:00',3),('325','2013-06-02','09:40:00',2.94),('325','2013-06-02','09:45:00',2.99),('325','2013-06-02','09:50:00',3.06),('325','2013-06-02','09:55:00',3.1),('325','2013-06-02','10:00:00',3.17),('325','2013-06-02','10:05:00',3.24),('325','2013-06-02','10:10:00',3.34),('325','2013-06-02','10:15:00',3.39),('325','2013-06-02','10:20:00',3.4),('325','2013-06-02','10:25:00',3.36),('325','2013-06-02','10:30:00',3.7),('325','2013-06-02','10:35:00',1.27),('325','2013-06-02','10:40:00',1.23),('325','2013-06-02','10:45:00',4.16),('325','2013-06-02','10:50:00',4.71),('325','2013-06-02','10:55:00',4.72),('325','2013-06-02','11:00:00',4.91),('325','2013-06-02','11:05:00',3.76),('325','2013-06-02','11:10:00',1.63),('325','2013-06-02','11:15:00',4.18),('325','2013-06-02','11:20:00',4.55),('325','2013-06-02','11:25:00',3.31),('325','2013-06-02','11:30:00',2.98),('325','2013-06-02','11:35:00',2.96),('325','2013-06-02','11:40:00',2.15),('325','2013-06-02','11:45:00',1.79),('325','2013-06-02','11:50:00',1.68),('325','2013-06-02','11:55:00',3.41),('325','2013-06-02','12:00:00',1.64),('325','2013-06-02','12:05:00',1.47),('325','2013-06-02','12:10:00',3.87),('325','2013-06-02','12:15:00',2.17),('325','2013-06-02','12:20:00',2.86),('325','2013-06-02','12:25:00',3.39),('325','2013-06-02','12:30:00',4.17),('325','2013-06-02','12:35:00',3.36),('325','2013-06-02','12:40:00',4.43),('325','2013-06-02','12:45:00',2.9),('325','2013-06-02','12:50:00',2.99),('325','2013-06-02','12:55:00',4.86),('325','2013-06-02','13:00:00',4.77),('325','2013-06-02','13:05:00',4.15),('325','2013-06-02','13:10:00',5.09),('325','2013-06-02','13:15:00',5.02),('325','2013-06-02','13:20:00',4.96),('325','2013-06-02','13:25:00',4.9),('325','2013-06-02','13:30:00',4.88),('325','2013-06-02','13:35:00',4.86),('325','2013-06-02','13:40:00',4.82),('325','2013-06-02','13:45:00',4.75),('325','2013-06-02','13:50:00',4.67),('325','2013-06-02','13:55:00',4.6),('325','2013-06-02','14:00:00',4.5),('325','2013-06-02','14:05:00',4.69),('325','2013-06-02','14:10:00',4.73),('325','2013-06-02','14:15:00',4.64),('325','2013-06-02','14:20:00',4.64),('325','2013-06-02','14:25:00',4.67),('325','2013-06-02','14:30:00',4.64),('325','2013-06-02','14:35:00',4.64),('325','2013-06-02','14:40:00',4.6),('325','2013-06-02','14:45:00',4.54),('325','2013-06-02','14:50:00',4.54),('325','2013-06-02','14:55:00',4.45),('325','2013-06-02','15:00:00',4.47),('325','2013-06-02','15:05:00',4.4),('325','2013-06-02','15:10:00',4.4),('325','2013-06-02','15:15:00',4.37),('325','2013-06-02','15:20:00',3.43),('325','2013-06-02','15:25:00',3.73),('325','2013-06-02','15:30:00',3.81),('325','2013-06-02','15:35:00',3.64),('325','2013-06-02','15:40:00',3.39),('325','2013-06-02','15:45:00',3.92),('325','2013-06-02','15:50:00',3.33),('325','2013-06-02','15:55:00',4.22),('325','2013-06-02','16:00:00',4.04),('325','2013-06-02','16:05:00',3.81),('325','2013-06-02','16:10:00',4.07),('325','2013-06-02','16:15:00',3.77),('325','2013-06-02','16:20:00',2.93),('325','2013-06-02','16:25:00',3.71),('325','2013-06-02','16:30:00',3.53),('325','2013-06-02','16:35:00',3.48),('325','2013-06-02','16:40:00',3.47),('325','2013-06-02','16:45:00',2.93),('325','2013-06-02','16:50:00',3.29),('325','2013-06-02','16:55:00',3.16),('325','2013-06-02','17:00:00',2.41),('325','2013-06-02','17:05:00',2.96),('325','2013-06-02','17:10:00',2.88),('325','2013-06-02','17:15:00',2.82),('325','2013-06-02','17:20:00',2.58),('325','2013-06-02','17:25:00',2.55),('325','2013-06-02','17:30:00',2.22),('325','2013-06-02','17:35:00',1.42),('325','2013-06-02','17:40:00',1.11),('325','2013-06-02','17:45:00',1.28),('325','2013-06-02','17:50:00',1.46),('325','2013-06-01','07:55:00',1.05),('325','2013-06-01','08:15:00',1.23),('325','2013-06-01','08:30:00',1.2),('325','2013-06-01','08:35:00',1.08),('325','2013-06-01','10:30:00',1.08),('325','2013-06-01','10:35:00',1.38),('325','2013-06-01','10:40:00',1.05),('325','2013-06-01','10:50:00',2.6),('325','2013-06-01','10:55:00',2.57),('325','2013-06-01','11:50:00',1.53),('325','2013-06-01','11:55:00',1.84),('325','2013-06-01','12:00:00',4.6),('325','2013-06-01','12:05:00',2.97),('325','2013-06-01','12:10:00',2.81),('325','2013-06-01','12:15:00',1.27),('325','2013-06-01','12:20:00',1.07),('325','2013-06-01','12:25:00',1.33),('325','2013-06-01','12:30:00',1.16),('325','2013-06-01','12:40:00',1.32),('325','2013-06-01','12:45:00',1.97),('325','2013-06-01','12:50:00',2.05),('325','2013-06-01','12:55:00',2.19),('325','2013-06-01','13:00:00',2.27),('325','2013-06-01','13:05:00',2.36),('325','2013-06-01','13:10:00',2.6),('325','2013-06-01','13:15:00',2.74),('325','2013-06-01','13:20:00',2.2),('325','2013-06-01','13:25:00',1.87),('325','2013-06-01','13:30:00',1.51),('325','2013-06-01','13:35:00',1.18),('325','2013-06-01','13:40:00',1.07),('325','2013-06-01','13:45:00',1.22),('325','2013-06-01','13:50:00',1.41),('325','2013-06-01','13:55:00',1.64),('325','2013-06-01','14:00:00',2.33),('325','2013-06-01','14:05:00',2.43),('325','2013-06-01','14:10:00',2.4),('325','2013-06-01','14:15:00',2.79),('325','2013-06-01','14:20:00',2.56),('325','2013-06-01','14:25:00',1.56),('325','2013-06-01','14:30:00',1.35),('325','2013-06-01','14:35:00',1.34),('325','2013-06-01','14:40:00',1.25),('325','2013-06-01','14:45:00',1.22),('325','2013-06-01','14:50:00',1.14),('325','2013-06-01','18:30:00',1.01),('325','2013-06-01','18:35:00',1.02),('325','2013-06-01','19:00:00',1.16),('325','2013-05-31','08:05:00',1.02),('325','2013-05-31','08:10:00',1.06),('325','2013-05-31','08:15:00',1.1),('325','2013-05-31','08:20:00',1.15),('325','2013-05-31','08:25:00',1.27),('325','2013-05-31','08:30:00',1.1),('325','2013-05-31','08:35:00',1.32),('325','2013-05-31','08:40:00',1.06),('325','2013-05-31','08:45:00',1.59),('325','2013-05-31','08:50:00',1.73),('325','2013-05-31','08:55:00',1.1),('325','2013-05-31','09:15:00',1.24),('325','2013-05-31','09:25:00',1.03),('325','2013-05-31','09:30:00',1.31),('325','2013-05-31','09:35:00',1.54),('325','2013-05-31','09:40:00',3.15),('325','2013-05-31','09:45:00',3.36),('325','2013-05-31','09:50:00',3.64),('325','2013-05-31','09:55:00',3.29),('325','2013-05-31','10:00:00',3.59),('325','2013-05-31','10:05:00',2.74),('325','2013-05-31','10:10:00',2.15),('325','2013-05-31','10:15:00',3.36),('325','2013-05-31','10:20:00',3.3),('325','2013-05-31','10:25:00',1.35),('325','2013-05-31','10:30:00',2.97),('325','2013-05-31','10:35:00',2.06),('325','2013-05-31','10:40:00',4.47),('325','2013-05-31','10:45:00',4.49),('325','2013-05-31','10:50:00',1.74),('325','2013-05-31','10:55:00',4.06),('325','2013-05-31','11:00:00',1.52),('325','2013-05-31','11:05:00',2.58),('325','2013-05-31','11:10:00',5.47),('325','2013-05-31','11:15:00',4.22),('325','2013-05-31','11:20:00',1.38),('325','2013-05-31','11:25:00',4.08),('325','2013-05-31','11:30:00',3.51),('325','2013-05-31','11:35:00',2.62),('325','2013-05-31','11:45:00',5.29),('325','2013-05-31','11:50:00',3.3),('325','2013-05-31','11:55:00',3.71),('325','2013-05-31','12:00:00',1.76),('325','2013-05-31','12:05:00',5.72),('325','2013-05-31','12:10:00',3.53),('325','2013-05-31','12:15:00',1.73),('325','2013-05-31','12:20:00',2.12),('325','2013-05-31','12:25:00',4.19),('325','2013-05-31','12:30:00',1.78),('325','2013-05-31','12:35:00',2.62),('325','2013-05-31','12:40:00',4.77),('325','2013-05-31','12:45:00',1.78),('325','2013-05-31','12:55:00',1.77),('325','2013-05-31','13:00:00',5.71),('325','2013-05-31','13:05:00',1.59),('325','2013-05-31','13:20:00',1.34),('325','2013-05-31','13:25:00',2.01),('325','2013-05-31','13:30:00',3.93),('325','2013-05-31','13:35:00',5.05),('325','2013-05-31','13:40:00',3),('325','2013-05-31','13:45:00',1.25),('325','2013-05-31','13:55:00',1.67),('325','2013-05-31','14:00:00',1.98),('325','2013-05-31','14:25:00',1.05),('325','2013-05-31','15:00:00',1.08),('325','2013-05-31','15:05:00',1.61),('325','2013-05-31','15:10:00',1.9),('325','2013-05-31','15:15:00',3.12),('325','2013-05-31','15:20:00',5.23),('325','2013-05-31','15:25:00',4.03),('325','2013-05-31','15:30:00',2.61),('325','2013-05-31','15:35:00',2.11),('325','2013-05-31','15:40:00',1.72),('325','2013-05-31','15:45:00',1.66),('325','2013-05-31','15:50:00',2.63),('325','2013-05-31','15:55:00',2.33),('325','2013-05-31','16:00:00',1.49),('325','2013-05-31','16:05:00',1.31),('325','2013-05-31','16:10:00',1),('325','2013-05-31','16:20:00',1.21),('325','2013-05-31','16:25:00',1.44),('325','2013-05-31','16:30:00',1.27),('325','2013-05-31','16:35:00',1.13),('325','2013-05-31','16:40:00',1.32),('325','2013-05-31','16:45:00',1.25),('325','2014-04-01','08:50:00',1.05),('325','2014-04-01','08:55:00',1.12),('325','2014-04-01','09:00:00',1.17),('325','2014-04-01','09:05:00',1.23),('325','2014-04-01','09:10:00',1.28),('325','2014-04-01','09:15:00',1.34),('325','2014-04-01','09:20:00',1.39),('325','2014-04-01','09:25:00',1.45),('325','2014-04-01','09:30:00',1.48),('325','2014-04-01','09:35:00',1.54),('325','2014-04-01','09:40:00',1.6),('325','2014-04-01','09:45:00',1.64),('325','2014-04-01','09:50:00',1.71),('325','2014-04-01','09:55:00',1.76),('325','2014-04-01','10:00:00',1.83),('325','2014-04-01','10:05:00',1.86),('325','2014-04-01','10:10:00',1.92),('325','2014-04-01','10:15:00',2.11),('325','2014-04-01','10:20:00',1.84),('325','2014-04-01','10:25:00',2.88),('325','2014-04-01','10:30:00',3.25),('325','2014-04-01','10:35:00',3.26),('325','2014-04-01','10:40:00',1.08),('325','2014-04-01','10:45:00',3.14),('325','2014-04-01','10:50:00',3.72),('325','2014-04-01','10:55:00',3.73),('325','2014-04-01','11:00:00',3.82),('325','2014-04-01','11:05:00',3.88),('325','2014-04-01','11:10:00',3.91),('325','2014-04-01','11:15:00',3.91),('325','2014-04-01','11:20:00',4.01),('325','2014-04-01','11:25:00',4.12),('325','2014-04-01','11:30:00',4.15),('325','2014-04-01','11:35:00',4.17),('325','2014-04-01','11:40:00',4.21),('325','2014-04-01','11:45:00',4.27),('325','2014-04-01','11:50:00',4.24),('325','2014-04-01','11:55:00',4.33),('325','2014-04-01','12:00:00',4.35),('325','2014-04-01','12:05:00',4.45),('325','2014-04-01','12:10:00',4.48),('325','2014-04-01','12:15:00',4.52),('325','2014-04-01','12:20:00',4.58),('325','2014-04-01','12:25:00',4.62),('325','2014-04-01','12:30:00',4.64),('325','2014-04-01','12:35:00',4.66),('325','2014-04-01','12:40:00',4.68),('325','2014-04-01','12:45:00',4.7),('325','2014-04-01','12:50:00',4.72),('325','2014-04-01','12:55:00',4.68),('325','2014-04-01','13:00:00',4.72),('325','2014-04-01','13:05:00',4.56),('325','2014-04-01','13:10:00',4.74),('325','2014-04-01','13:15:00',4.18),('325','2014-04-01','13:20:00',4.06),('325','2014-04-01','13:25:00',4.69),('325','2014-04-01','13:30:00',4.69),('325','2014-04-01','13:35:00',4.7),('325','2014-04-01','13:40:00',4.83),('325','2014-04-01','13:45:00',4.69),('325','2014-04-01','13:50:00',4.63),('325','2014-04-01','13:55:00',4.65),('325','2014-04-01','14:00:00',4.62),('325','2014-04-01','14:05:00',4.64),('325','2014-04-01','14:10:00',4),('325','2014-04-01','14:15:00',4.67),('325','2014-04-01','14:20:00',3.04),('325','2014-04-01','14:25:00',3.92),('325','2014-04-01','14:30:00',4.08),('325','2014-04-01','14:35:00',4.43),('325','2014-04-01','14:40:00',3.95),('325','2014-04-01','14:45:00',4.7),('325','2014-04-01','14:50:00',4.1),('325','2014-04-01','14:55:00',3.63),('325','2014-04-01','15:00:00',4.4),('325','2014-04-01','15:05:00',4.17),('325','2014-04-01','15:10:00',4.4),('325','2014-04-01','15:15:00',3.25),('325','2014-04-01','15:20:00',1.59),('325','2014-04-01','15:25:00',4.17),('325','2014-04-01','15:30:00',3.8),('325','2014-04-01','15:35:00',2.62),('325','2014-04-01','15:40:00',3.81),('325','2014-04-01','15:45:00',3.11),('325','2014-04-01','15:50:00',3.5),('325','2014-04-01','15:55:00',3.54),('325','2014-04-01','16:00:00',1.64),('325','2014-04-01','16:05:00',3.2),('325','2014-04-01','16:10:00',2.82),('325','2014-04-01','16:15:00',1.97),('325','2014-04-01','16:20:00',2.46),('325','2014-04-01','16:25:00',1.98),('325','2014-04-01','16:30:00',2.93),('325','2014-04-01','16:35:00',3.03),('325','2014-04-01','16:40:00',2.89),('325','2014-04-01','16:45:00',1.47),('325','2014-04-01','16:50:00',1.63),('325','2014-04-01','16:55:00',2.25),('325','2014-04-01','17:00:00',2.52),('325','2014-04-01','17:05:00',2.29),('325','2014-04-01','17:10:00',2.14),('325','2014-04-01','17:15:00',2.2),('325','2014-04-01','17:20:00',2.05),('325','2014-04-01','17:25:00',1.68),('325','2014-04-01','17:30:00',1.8),('325','2014-04-01','17:35:00',1.68),('325','2014-04-01','17:40:00',1.58),('325','2014-04-01','17:45:00',1.37),('325','2014-04-01','17:50:00',1.38),('325','2014-04-01','17:55:00',1.25),('325','2014-04-01','18:00:00',1.14),('325','2014-04-01','18:05:00',1.04),('325','2013-05-30','08:25:00',1.09),('325','2013-05-30','08:40:00',1.45),('325','2013-05-30','08:45:00',1.43),('325','2013-05-30','08:50:00',1.4),('325','2013-05-30','08:55:00',1.39),('325','2013-05-30','09:00:00',1.4),('325','2013-05-30','09:05:00',1.46),('325','2013-05-30','09:10:00',1.62),('325','2013-05-30','09:15:00',1.7),('325','2013-05-30','09:20:00',2.68),('325','2013-05-30','09:25:00',2.96),('325','2013-05-30','09:30:00',3),('325','2013-05-30','09:35:00',3.06),('325','2013-05-30','09:40:00',3.26),('325','2013-05-30','09:45:00',2.58),('325','2013-05-30','09:50:00',3.74),('325','2013-05-30','09:55:00',1.35),('325','2013-05-30','10:00:00',1.29),('325','2013-05-30','10:05:00',1.73),('325','2013-05-30','10:10:00',2.88),('325','2013-05-30','10:15:00',2.59),('325','2013-05-30','10:20:00',3.63),('325','2013-05-30','10:25:00',1.18),('325','2013-05-30','10:30:00',1.8),('325','2013-05-30','10:35:00',2.03),('325','2013-05-30','10:40:00',3.04),('325','2013-05-30','10:45:00',4.84),('325','2013-05-30','10:50:00',3.95),('325','2013-05-30','10:55:00',4),('325','2013-05-30','11:00:00',5.13),('325','2013-05-30','11:05:00',4.6),('325','2013-05-30','11:15:00',2.92),('325','2013-05-30','11:20:00',3.53),('325','2013-05-30','11:25:00',1.7),('325','2013-05-30','11:30:00',4.67),('325','2013-05-30','11:35:00',5.03),('325','2013-05-30','11:40:00',4.8),('325','2013-05-30','11:45:00',4.44),('325','2013-05-30','11:50:00',4.52),('325','2013-05-30','11:55:00',1.89),('325','2013-05-30','12:00:00',5.51),('325','2013-05-30','12:05:00',5.35),('325','2013-05-30','12:10:00',2.55),('325','2013-05-30','12:15:00',4.17),('325','2013-05-30','12:20:00',4.17),('325','2013-05-30','12:25:00',5.82),('325','2013-05-30','12:30:00',3.63),('325','2013-05-30','12:35:00',3.63),('325','2013-05-30','12:40:00',4.88),('325','2013-05-30','12:45:00',3.33),('325','2013-05-30','12:50:00',4.13),('325','2013-05-30','12:55:00',5.77),('325','2013-05-30','13:00:00',4.01),('325','2013-05-30','13:05:00',4.1),('325','2013-05-30','13:10:00',2.73),('325','2013-05-30','13:15:00',2.54),('325','2013-05-30','13:20:00',2.29),('325','2013-05-30','13:25:00',1.87),('325','2013-05-30','13:30:00',2.23),('325','2013-05-30','13:35:00',2.56),('325','2013-05-30','13:40:00',4.72),('325','2013-05-30','13:45:00',4.54),('325','2013-05-30','13:50:00',1.93),('325','2013-05-30','13:55:00',2.39),('325','2013-05-30','14:00:00',5.63),('325','2013-05-30','14:05:00',5.44),('325','2013-05-30','14:10:00',3.62),('325','2013-05-30','14:15:00',4.2),('325','2013-05-30','14:20:00',4.1),('325','2013-05-30','14:25:00',3.69),('325','2013-05-30','14:30:00',4.69),('325','2013-05-30','14:35:00',4.19),('325','2013-05-30','14:40:00',5.14),('325','2013-05-30','14:45:00',5.02),('325','2013-05-30','14:50:00',5.07),('325','2013-05-30','14:55:00',4.59),('325','2013-05-30','15:00:00',5.01),('325','2013-05-30','15:05:00',3.15),('325','2013-05-30','15:10:00',2.04),('325','2013-05-30','15:15:00',4.47),('325','2013-05-30','15:20:00',4.87),('325','2013-05-30','15:25:00',4.45),('325','2013-05-30','15:30:00',4.79),('325','2013-05-30','15:35:00',4.87),('325','2013-05-30','15:40:00',4.52),('325','2013-05-30','15:45:00',4.96),('325','2013-05-30','15:50:00',3.18),('325','2013-05-30','15:55:00',4.43),('325','2013-05-30','16:00:00',3.78),('325','2013-05-30','16:05:00',4.65),('325','2013-05-30','16:10:00',4.32),('325','2013-05-30','16:15:00',4.06),('325','2013-05-30','16:20:00',3.57),('325','2013-05-30','16:25:00',1.91),('325','2013-05-30','16:30:00',1.3),('325','2013-05-30','16:35:00',2.52),('325','2013-05-30','16:40:00',1.04),('325','2013-05-30','16:45:00',3.27),('325','2013-05-30','16:50:00',2.99),('325','2013-05-30','16:55:00',2.17),('325','2013-05-30','17:00:00',1.63),('325','2013-05-30','17:05:00',2.13),('325','2013-05-30','17:15:00',1.04),('325','2013-05-30','17:20:00',1.35),('325','2013-05-30','17:30:00',1.07),('325','2013-05-30','18:00:00',1.05),('325','2013-05-30','18:05:00',1.08),('325','2013-05-30','18:10:00',1.28),('325','2013-05-30','18:35:00',1.23),('325','2013-05-30','18:40:00',1.19),('325','2013-05-30','18:45:00',1.37),('325','2013-05-30','18:50:00',1.22),('325','2013-05-29','08:10:00',1),('325','2013-05-29','08:15:00',1.05),('325','2013-05-29','08:20:00',1.1),('325','2013-05-29','08:25:00',1.17),('325','2013-05-29','08:30:00',1.22),('325','2013-05-29','08:35:00',1.29),('325','2013-05-29','08:40:00',1.35),('325','2013-05-29','08:45:00',1.37),('325','2013-05-29','08:50:00',1.36),('325','2013-05-29','08:55:00',1.36),('325','2013-05-29','09:00:00',1.38),('325','2013-05-29','09:05:00',1.41),('325','2013-05-29','09:10:00',1.44),('325','2013-05-29','09:15:00',1.46),('325','2013-05-29','09:20:00',1.48),('325','2013-05-29','09:25:00',2.61),('325','2013-05-29','09:30:00',2.85),('325','2013-05-29','09:35:00',2.94),('325','2013-05-29','09:40:00',2.97),('325','2013-05-29','09:45:00',3.07),('325','2013-05-29','09:50:00',3.16),('325','2013-05-29','09:55:00',3.19),('325','2013-05-29','10:00:00',3.24),('325','2013-05-29','10:05:00',3.33),('325','2013-05-29','10:10:00',3.4),('325','2013-05-29','10:15:00',3.48),('325','2013-05-29','10:20:00',3.54),('325','2013-05-29','10:25:00',3.58),('325','2013-05-29','10:30:00',3.65),('325','2013-05-29','10:35:00',3.75),('325','2013-05-29','10:40:00',3.94),('325','2013-05-29','10:45:00',4.15),('325','2013-05-29','10:50:00',4.25),('325','2013-05-29','10:55:00',4.25),('325','2013-05-29','11:00:00',4.45),('325','2013-05-29','11:05:00',4.46),('325','2013-05-29','11:10:00',4.26),('325','2013-05-29','11:15:00',3.62),('325','2013-05-29','11:20:00',4.85),('325','2013-05-29','11:25:00',4.61),('325','2013-05-29','11:30:00',5.29),('325','2013-05-29','11:35:00',4.93),('325','2013-05-29','11:40:00',4.58),('325','2013-05-29','11:45:00',3.61),('325','2013-05-29','11:50:00',3.97),('325','2013-05-29','11:55:00',5.04),('325','2013-05-29','12:00:00',2.91),('325','2013-05-29','12:05:00',3.3),('325','2013-05-29','12:10:00',5.41),('325','2013-05-29','12:15:00',4.39),('325','2013-05-29','12:20:00',5.22),('325','2013-05-29','12:25:00',5.18),('325','2013-05-29','12:30:00',5.11),('325','2013-05-29','12:35:00',4.98),('325','2013-05-29','12:40:00',3.78),('325','2013-05-29','12:45:00',5.15),('325','2013-05-29','12:50:00',4.88),('325','2013-05-29','12:55:00',5.07),('325','2013-05-29','13:00:00',5.1),('325','2013-05-29','13:05:00',4.73),('325','2013-05-29','13:10:00',4.59),('325','2013-05-29','13:15:00',4.16),('325','2013-05-29','13:20:00',4.89),('325','2013-05-29','13:25:00',5.67),('325','2013-05-29','13:30:00',5.29),('325','2013-05-29','13:35:00',3.84),('325','2013-05-29','13:40:00',4.98),('325','2013-05-29','13:45:00',4.75),('325','2013-05-29','13:50:00',4.58),('325','2013-05-29','13:55:00',4.32),('325','2013-05-29','14:00:00',4.86),('325','2013-05-29','14:05:00',4.66),('325','2013-05-29','14:10:00',4.75),('325','2013-05-29','14:15:00',4.87),('325','2013-05-29','14:20:00',4.92),('325','2013-05-29','14:25:00',4.39),('325','2013-05-29','14:30:00',4.91),('325','2013-05-29','14:35:00',3.85),('325','2013-05-29','14:40:00',5.01),('325','2013-05-29','14:45:00',4.92),('325','2013-05-29','14:50:00',3.92),('325','2013-05-29','14:55:00',4.57),('325','2013-05-29','15:00:00',4.73),('325','2013-05-29','15:05:00',4.6),('325','2013-05-29','15:10:00',3.35),('325','2013-05-29','15:15:00',3.88),('325','2013-05-29','15:20:00',3.95),('325','2013-05-29','15:25:00',2.88),('325','2013-05-29','15:30:00',3.63),('325','2013-05-29','15:35:00',3.46),('325','2013-05-29','15:40:00',2.95),('325','2013-05-29','15:45:00',3.15),('325','2013-05-29','15:50:00',3.28),('325','2013-05-29','15:55:00',3.09),('325','2013-05-29','16:00:00',2.93),('325','2013-05-29','16:05:00',2.97),('325','2013-05-29','16:10:00',2.54),('325','2013-05-29','16:15:00',2.45),('325','2013-05-29','16:20:00',2.35),('325','2013-05-29','16:25:00',2.53),('325','2013-05-29','16:30:00',2.02),('325','2013-05-29','16:35:00',2.13),('325','2013-05-29','16:40:00',2.6),('325','2013-05-29','16:45:00',2.26),('325','2013-05-29','16:50:00',1.75),('325','2013-05-29','16:55:00',1.56),('325','2013-05-29','17:00:00',1.37),('325','2013-05-29','17:35:00',1.3),('325','2013-05-29','17:40:00',1.8),('325','2013-05-29','17:45:00',1.14),('325','2013-05-29','18:00:00',1.09),('325','2013-05-29','18:05:00',1.34),('325','2013-05-29','18:10:00',1.47),('325','2013-05-29','18:15:00',2.07),('325','2013-05-29','18:20:00',1.47),('325','2013-05-28','08:10:00',1.07),('325','2013-05-28','08:15:00',1.2),('325','2013-05-28','08:20:00',1.29),('325','2013-05-28','08:25:00',1.23),('325','2013-05-28','08:30:00',1.45),('325','2013-05-28','08:35:00',1.43),('325','2013-05-28','08:40:00',1.36),('325','2013-05-28','08:45:00',1.39),('325','2013-05-28','08:50:00',1.54),('325','2013-05-28','08:55:00',1.48),('325','2013-05-28','09:00:00',1.5),('325','2013-05-28','09:05:00',1.64),('325','2013-05-28','09:10:00',1.53),('325','2013-05-28','09:15:00',1.5),('325','2013-05-28','09:20:00',1.63),('325','2013-05-28','09:25:00',1.72),('325','2013-05-28','09:30:00',1.81),('325','2013-05-28','09:35:00',1.96),('325','2013-05-28','09:40:00',1.93),('325','2013-05-28','09:45:00',1.95),('325','2013-05-28','09:50:00',2.16),('325','2013-05-28','09:55:00',2.34),('325','2013-05-28','10:00:00',2.15),('325','2013-05-28','10:05:00',2.3),('325','2013-05-28','10:10:00',2.56),('325','2013-05-28','10:15:00',2.67),('325','2013-05-28','10:20:00',2.78),('325','2013-05-28','10:25:00',2.72),('325','2013-05-28','10:30:00',2.91),('325','2013-05-28','10:35:00',3.11),('325','2013-05-28','10:40:00',2.83),('325','2013-05-28','10:45:00',2.84),('325','2013-05-28','10:50:00',2.88),('325','2013-05-28','10:55:00',2.61),('325','2013-05-28','11:00:00',2.6),('325','2013-05-28','11:05:00',2.55),('325','2013-05-28','11:10:00',2.55),('325','2013-05-28','11:15:00',2.59),('325','2013-05-28','11:20:00',2.34),('325','2013-05-28','11:25:00',2.63),('325','2013-05-28','11:30:00',4.57),('325','2013-05-28','11:35:00',3.29),('325','2013-05-28','11:40:00',4.31),('325','2013-05-28','11:45:00',3.74),('325','2013-05-28','11:50:00',1.15),('325','2013-05-28','11:55:00',1.85),('325','2013-05-28','12:00:00',1.64),('325','2013-05-28','12:05:00',2.11),('325','2013-05-28','12:10:00',2.95),('325','2013-05-28','12:15:00',2.72),('325','2013-05-28','12:20:00',2.44),('325','2013-05-28','12:25:00',2.57),('325','2013-05-28','12:30:00',2.81),('325','2013-05-28','12:35:00',2.73),('325','2013-05-28','12:40:00',2.8),('325','2013-05-28','12:45:00',3.14),('325','2013-05-28','12:50:00',2.81),('325','2013-05-28','12:55:00',2.9),('325','2013-05-28','13:00:00',2.94),('325','2013-05-28','13:05:00',3.22),('325','2013-05-28','13:10:00',3.29),('325','2013-05-28','13:15:00',2.85),('325','2013-05-28','13:20:00',2.99),('325','2013-05-28','13:25:00',1.83),('325','2013-05-28','13:30:00',2.36),('325','2013-05-28','13:35:00',1.96),('325','2013-05-28','13:40:00',2.22),('325','2013-05-28','13:45:00',2.07),('325','2013-05-28','13:50:00',2.63),('325','2013-05-28','13:55:00',2.68),('325','2013-05-28','14:00:00',2.79),('325','2013-05-28','14:05:00',3),('325','2013-05-28','14:10:00',3.87),('325','2013-05-28','14:15:00',4.28),('325','2013-05-28','14:20:00',2.68),('325','2013-05-28','14:25:00',2.92),('325','2013-05-28','14:30:00',3.6),('325','2013-05-28','14:35:00',3.06),('325','2013-05-28','14:40:00',3.45),('325','2013-05-28','14:45:00',4.17),('325','2013-05-28','14:50:00',3.28),('325','2013-05-28','14:55:00',3.14),('325','2013-05-28','15:00:00',2.78),('325','2013-05-28','15:05:00',3.74),('325','2013-05-28','15:10:00',1.85),('325','2013-05-28','15:15:00',2.81),('325','2013-05-28','15:20:00',3.36),('325','2013-05-28','15:25:00',2.47),('325','2013-05-28','15:30:00',1.62),('325','2013-05-28','15:35:00',1.64),('325','2013-05-28','15:40:00',2.97),('325','2013-05-28','15:45:00',3.99),('325','2013-05-28','15:50:00',3.36),('325','2013-05-28','15:55:00',2.27),('325','2013-05-28','16:00:00',1.76),('325','2013-05-28','16:05:00',1.41),('325','2013-05-28','16:10:00',1.48),('325','2013-05-28','16:15:00',1.75),('325','2013-05-28','16:20:00',2.68),('325','2013-05-28','16:25:00',2.34),('325','2013-05-28','16:30:00',2.99),('325','2013-05-28','16:35:00',3.42),('325','2013-05-28','16:40:00',3.19),('325','2013-05-28','16:45:00',3.07),('325','2013-05-28','16:50:00',2.99),('325','2013-05-28','16:55:00',2.89),('325','2013-05-28','17:00:00',2.73),('325','2013-05-28','17:05:00',2.65),('325','2013-05-28','17:10:00',2.61),('325','2013-05-28','17:15:00',2.54),('325','2013-05-28','17:20:00',2.46),('325','2013-05-28','17:25:00',2.32),('325','2013-05-28','17:30:00',2.26),('325','2013-05-28','17:35:00',2.13),('325','2013-05-28','17:40:00',2.04),('325','2013-05-28','17:45:00',1.9),('325','2013-05-28','17:50:00',1.81),('325','2013-05-28','17:55:00',1.76),('325','2013-05-28','18:00:00',1.73),('325','2013-05-28','18:05:00',1.62),('325','2013-05-27','08:05:00',1.08),('325','2013-05-27','08:10:00',1.19),('325','2013-05-27','08:15:00',1.26),('325','2013-05-27','08:25:00',1.17),('325','2013-05-27','08:30:00',1.27),('325','2013-05-27','08:35:00',1.34),('325','2013-05-27','08:40:00',1.42),('325','2013-05-27','08:45:00',1.67),('325','2013-05-27','08:50:00',1.42),('325','2013-05-27','08:55:00',1.43),('325','2013-05-27','09:00:00',1.93),('325','2013-05-27','09:05:00',2.08),('325','2013-05-27','09:10:00',1.92),('325','2013-05-27','09:15:00',1.73),('325','2013-05-27','09:20:00',1.64),('325','2013-05-27','09:25:00',2.54),('325','2013-05-27','09:30:00',3.08),('325','2013-05-27','09:35:00',3.15),('325','2013-05-27','09:40:00',3.23),('325','2013-05-27','09:45:00',2.93),('325','2013-05-27','09:50:00',3.2),('325','2013-05-27','09:55:00',3.72),('325','2013-05-27','10:00:00',3.65),('325','2013-05-27','10:05:00',3.5),('325','2013-05-27','10:10:00',3.8),('325','2013-05-27','10:15:00',3.2),('325','2013-05-27','10:20:00',2.77),('325','2013-05-27','10:25:00',4.22),('325','2013-05-27','10:30:00',1.36),('325','2013-05-27','10:35:00',1.67),('325','2013-05-27','10:40:00',3.13),('325','2013-05-27','10:45:00',2.26),('325','2013-05-27','10:50:00',2.97),('325','2013-05-27','10:55:00',2.05),('325','2013-05-27','11:00:00',4.79),('325','2013-05-27','11:05:00',2.74),('325','2013-05-27','11:10:00',3.48),('325','2013-05-27','11:15:00',1.9),('325','2013-05-27','11:20:00',4.46),('325','2013-05-27','11:25:00',3.06),('325','2013-05-27','11:30:00',3.3),('325','2013-05-27','11:35:00',2),('325','2013-05-27','11:40:00',5.26),('325','2013-05-27','11:45:00',1.71),('325','2013-05-27','11:50:00',1.92),('325','2013-05-27','11:55:00',3.16),('325','2013-05-27','12:00:00',4.94),('325','2013-05-27','12:05:00',2.14),('325','2013-05-27','12:10:00',4.89),('325','2013-05-27','12:15:00',4.37),('325','2013-05-27','12:20:00',5.48),('325','2013-05-27','12:25:00',3.78),('325','2013-05-27','12:30:00',4.77),('325','2013-05-27','12:35:00',4.2),('325','2013-05-27','12:40:00',5.64),('325','2013-05-27','12:45:00',2.6),('325','2013-05-27','12:50:00',5.5),('325','2013-05-27','12:55:00',3.12),('325','2013-05-27','13:00:00',2.09),('325','2013-05-27','13:05:00',3.67),('325','2013-05-27','13:10:00',4.77),('325','2013-05-27','13:15:00',2.63),('325','2013-05-27','13:20:00',5.12),('325','2013-05-27','13:25:00',4.47),('325','2013-05-27','13:30:00',4.88),('325','2013-05-27','13:35:00',4.02),('325','2013-05-27','13:40:00',5.43),('325','2013-05-27','13:45:00',4.61),('325','2013-05-27','13:50:00',5.06),('325','2013-05-27','13:55:00',4.99),('325','2013-05-27','14:00:00',4.86),('325','2013-05-27','14:05:00',4.49),('325','2013-05-27','14:10:00',4.53),('325','2013-05-27','14:15:00',4.18),('325','2013-05-27','14:20:00',3.24),('325','2013-05-27','14:25:00',4.87),('325','2013-05-27','14:30:00',4.47),('325','2013-05-27','14:35:00',2.89),('325','2013-05-27','14:40:00',3.4),('325','2013-05-27','14:45:00',5.05),('325','2013-05-27','14:50:00',4.98),('325','2013-05-27','14:55:00',4.14),('325','2013-05-27','15:00:00',3.13),('325','2013-05-27','15:05:00',3.09),('325','2013-05-27','15:10:00',4.68),('325','2013-05-27','15:15:00',3.28),('325','2013-05-27','15:20:00',4.05),('325','2013-05-27','15:25:00',3.66),('325','2013-05-27','15:30:00',4.17),('325','2013-05-27','15:35:00',4.58),('325','2013-05-27','15:40:00',3.79),('325','2013-05-27','15:45:00',3.42),('325','2013-05-27','15:50:00',4.22),('325','2013-05-27','15:55:00',2.8),('325','2013-05-27','16:00:00',3.45),('325','2013-05-27','16:05:00',2.49),('325','2013-05-27','16:10:00',2.81),('325','2013-05-27','16:15:00',2.65),('325','2013-05-27','16:20:00',4.3),('325','2013-05-27','16:25:00',4.04),('325','2013-05-27','16:30:00',3.72),('325','2013-05-27','16:35:00',3.13),('325','2013-05-27','16:40:00',1.57),('325','2013-05-27','16:45:00',1.41),('325','2013-05-27','16:50:00',1.41),('325','2013-05-27','16:55:00',1.48),('325','2013-05-27','17:00:00',1.56),('325','2013-05-27','17:05:00',1.62),('325','2013-05-27','17:10:00',2.05),('325','2013-05-27','17:15:00',1.58),('325','2013-05-27','17:20:00',1.35),('325','2013-05-27','17:25:00',1.22),('325','2013-05-27','17:30:00',1.19),('325','2013-05-27','17:35:00',1.09),('325','2013-05-27','17:40:00',1.01),('325','2013-05-27','18:20:00',1.3),('325','2013-05-27','18:25:00',1.65),('325','2013-05-27','18:30:00',1.21),('325','2013-05-26','07:50:00',1.44),('325','2013-05-26','08:05:00',1.51),('325','2013-05-26','08:10:00',1.2),('325','2013-05-26','08:20:00',1.03),('325','2013-05-26','08:25:00',1.18),('325','2013-05-26','08:30:00',1.61),('325','2013-05-26','08:35:00',1.34),('325','2013-05-26','08:40:00',1.55),('325','2013-05-26','08:45:00',1.83),('325','2013-05-26','08:50:00',1.9),('325','2013-05-26','08:55:00',1.1),('325','2013-05-26','09:00:00',1.52),('325','2013-05-26','09:10:00',1.91),('325','2013-05-26','09:15:00',1.12),('325','2013-05-26','09:25:00',1.41),('325','2013-05-26','09:40:00',1.57),('325','2013-05-26','09:45:00',1.84),('325','2013-05-26','09:55:00',1.4),('325','2013-05-26','10:05:00',3.44),('325','2013-05-26','10:10:00',3.64),('325','2013-05-26','10:15:00',2.02),('325','2013-05-26','10:20:00',2.52),('325','2013-05-26','10:25:00',3.52),('325','2013-05-26','10:30:00',3.86),('325','2013-05-26','10:35:00',4.26),('325','2013-05-26','10:40:00',4.22),('325','2013-05-26','10:45:00',4.35),('325','2013-05-26','10:50:00',4.6),('325','2013-05-26','10:55:00',4.12),('325','2013-05-26','11:00:00',4.65),('325','2013-05-26','11:05:00',4.71),('325','2013-05-26','11:10:00',4.75),('325','2013-05-26','11:15:00',4.8),('325','2013-05-26','11:20:00',4.84),('325','2013-05-26','11:25:00',4.88),('325','2013-05-26','11:30:00',4.99),('325','2013-05-26','11:35:00',4.86),('325','2013-05-26','11:40:00',4.85),('325','2013-05-26','11:45:00',4.97),('325','2013-05-26','11:50:00',5.1),('325','2013-05-26','11:55:00',5.18),('325','2013-05-26','12:00:00',5.07),('325','2013-05-26','12:05:00',5.15),('325','2013-05-26','12:10:00',4.94),('325','2013-05-26','12:15:00',3.57),('325','2013-05-26','12:20:00',4.65),('325','2013-05-26','12:25:00',4.67),('325','2013-05-26','12:30:00',5.36),('325','2013-05-26','12:35:00',5.3),('325','2013-05-26','12:40:00',4.67),('325','2013-05-26','12:45:00',4.76),('325','2013-05-26','12:50:00',5.21),('325','2013-05-26','12:55:00',5.32),('325','2013-05-26','13:00:00',4.39),('325','2013-05-26','13:05:00',5.2),('325','2013-05-26','13:10:00',5.4),('325','2013-05-26','13:15:00',5.28),('325','2013-05-26','13:20:00',5.32),('325','2013-05-26','13:25:00',5.28),('325','2013-05-26','13:30:00',5.39),('325','2013-05-26','13:35:00',5.27),('325','2013-05-26','13:40:00',5.17),('325','2013-05-26','13:45:00',5.17),('325','2013-05-26','13:50:00',5.17),('325','2013-05-26','13:55:00',5),('325','2013-05-26','14:00:00',5.07),('325','2013-05-26','14:05:00',5.01),('325','2013-05-26','14:10:00',4.98),('325','2013-05-26','14:15:00',4.97),('325','2013-05-26','14:20:00',4.94),('325','2013-05-26','14:25:00',4.92),('325','2013-05-26','14:30:00',4.91),('325','2013-05-26','14:35:00',4.86),('325','2013-05-26','14:40:00',4.86),('325','2013-05-26','14:45:00',4.82),('325','2013-05-26','14:50:00',4.77),('325','2013-05-26','14:55:00',4.75),('325','2013-05-26','15:00:00',4.71),('325','2013-05-26','15:05:00',4.69),('325','2013-05-26','15:10:00',4.62),('325','2013-05-26','15:15:00',4.61),('325','2013-05-26','15:20:00',4.57),('325','2013-05-26','15:25:00',4.52),('325','2013-05-26','15:30:00',4.46),('325','2013-05-26','15:35:00',4.4),('325','2013-05-26','15:40:00',4.34),('325','2013-05-26','15:45:00',4.27),('325','2013-05-26','15:50:00',4.21),('325','2013-05-26','15:55:00',4.17),('325','2013-05-26','16:00:00',4.12),('325','2013-05-26','16:05:00',4.06),('325','2013-05-26','16:10:00',4.02),('325','2013-05-26','16:15:00',3.95),('325','2013-05-26','16:20:00',3.88),('325','2013-05-26','16:25:00',3.81),('325','2013-05-26','16:30:00',3.72),('325','2013-05-26','16:35:00',3.62),('325','2013-05-26','16:40:00',3.54),('325','2013-05-26','16:45:00',3.46),('325','2013-05-26','16:50:00',3.37),('325','2013-05-26','16:55:00',3.22),('325','2013-05-26','17:00:00',3.08),('325','2013-05-26','17:05:00',3.06),('325','2013-05-26','17:10:00',2.96),('325','2013-05-26','17:15:00',2.86),('325','2013-05-26','17:20:00',2.77),('325','2013-05-26','17:25:00',2.68),('325','2013-05-26','17:30:00',2.56),('325','2013-05-26','17:35:00',2.46),('325','2013-05-26','17:40:00',2.37),('325','2013-05-26','17:45:00',2.21),('325','2013-05-26','17:50:00',2.13),('325','2013-05-26','17:55:00',2.03),('325','2013-05-26','18:00:00',1.92),('325','2013-05-26','18:05:00',1.81),('325','2013-05-26','18:10:00',1.71),('325','2013-05-26','18:15:00',1.58),('325','2013-05-26','18:20:00',1.38),('325','2013-05-26','18:25:00',1.2),('325','2013-05-26','18:30:00',1.11),('325','2013-05-25','07:35:00',1.1),('325','2013-05-25','07:55:00',1.08),('325','2013-05-25','08:00:00',1.34),('325','2013-05-25','08:05:00',1.45),('325','2013-05-25','08:10:00',1.01),('325','2013-05-25','08:25:00',1.62),('325','2013-05-25','08:30:00',1.85),('325','2013-05-25','08:35:00',1.09),('325','2013-05-25','08:40:00',1.2),('325','2013-05-25','08:45:00',1.16),('325','2013-05-25','08:50:00',1.48),('325','2013-05-25','08:55:00',1.56),('325','2013-05-25','09:00:00',1.66),('325','2013-05-25','09:05:00',1.82),('325','2013-05-25','09:10:00',1.87),('325','2013-05-25','09:15:00',2.44),('325','2013-05-25','09:20:00',1.46),('325','2013-05-25','09:25:00',1.49),('325','2013-05-25','09:30:00',1.02),('325','2013-05-25','09:35:00',2.24),('325','2013-05-25','09:40:00',3.25),('325','2013-05-25','09:45:00',2.14),('325','2013-05-25','09:50:00',3.41),('325','2013-05-25','09:55:00',2),('325','2013-05-25','10:10:00',1.3),('325','2013-05-25','10:40:00',1.74),('325','2013-05-25','10:45:00',1.45),('325','2013-05-25','10:50:00',1.39),('325','2013-05-25','11:00:00',1.27),('325','2013-05-25','11:05:00',2.29),('325','2013-05-25','11:10:00',4.05),('325','2013-05-25','11:15:00',4.46),('325','2013-05-25','11:20:00',2.67),('325','2013-05-25','11:35:00',2.06),('325','2013-05-25','11:40:00',2.38),('325','2013-05-25','11:45:00',2.7),('325','2013-05-25','11:50:00',1.84),('325','2013-05-25','11:55:00',2),('325','2013-05-25','12:00:00',2.09),('325','2013-05-25','12:05:00',1.5),('325','2013-05-25','12:10:00',1.83),('325','2013-05-25','12:15:00',1.3),('325','2013-05-25','12:20:00',1.78),('325','2013-05-25','12:25:00',2.18),('325','2013-05-25','12:30:00',1.33),('325','2013-05-25','12:35:00',1.74),('325','2013-05-25','12:40:00',2.08),('325','2013-05-25','12:45:00',1.88),('325','2013-05-25','12:50:00',1.42),('325','2013-05-25','12:55:00',1.98),('325','2013-05-25','13:00:00',1.13),('325','2013-05-25','13:05:00',1.93),('325','2013-05-25','13:10:00',1.5),('325','2013-05-25','13:15:00',2.08),('325','2013-05-25','13:20:00',2.23),('325','2013-05-25','13:25:00',4.01),('325','2013-05-25','13:30:00',1.54),('325','2013-05-25','13:35:00',1.55),('325','2013-05-25','13:40:00',2.28),('325','2013-05-25','13:45:00',2.18),('325','2013-05-25','13:50:00',2.69),('325','2013-05-25','13:55:00',4.04),('325','2013-05-25','14:00:00',4.77),('325','2013-05-25','14:05:00',4.14),('325','2013-05-25','14:10:00',5.19),('325','2013-05-25','14:15:00',4.28),('325','2013-05-25','14:20:00',3.87),('325','2013-05-25','14:25:00',2.97),('325','2013-05-25','14:30:00',2.46),('325','2013-05-25','14:35:00',3.06),('325','2013-05-25','14:40:00',1.56),('325','2013-05-25','14:45:00',2.71),('325','2013-05-25','14:50:00',1.78),('325','2013-05-25','14:55:00',2.1),('325','2013-05-25','15:00:00',4.47),('325','2013-05-25','15:05:00',3),('325','2013-05-25','15:10:00',2.63),('325','2013-05-25','15:15:00',2.79),('325','2013-05-25','15:20:00',1.93),('325','2013-05-25','15:25:00',2.08),('325','2013-05-25','15:30:00',3.82),('325','2013-05-25','15:35:00',4.73),('325','2013-05-25','15:40:00',4.62),('325','2013-05-25','15:45:00',4.38),('325','2013-05-25','15:50:00',4.76),('325','2013-05-25','15:55:00',4.16),('325','2013-05-25','16:00:00',2.6),('325','2013-05-25','16:05:00',3.07),('325','2013-05-25','16:10:00',2.09),('325','2013-05-25','16:15:00',1.45),('325','2013-05-25','16:20:00',1.72),('325','2013-05-25','16:25:00',2.3),('325','2013-05-25','16:30:00',3),('325','2013-05-25','16:35:00',3.75),('325','2013-05-25','16:40:00',3.48),('325','2013-05-25','16:45:00',2.62),('325','2013-05-25','16:50:00',1.83),('325','2013-05-25','16:55:00',1.11),('325','2013-05-25','17:05:00',1.9),('325','2013-05-25','17:10:00',3.27),('325','2013-05-25','17:15:00',2.76),('325','2013-05-25','17:20:00',2.11),('325','2013-05-25','17:35:00',1.89),('325','2013-05-25','17:40:00',1.36),('325','2013-05-25','17:45:00',1.27),('325','2013-05-25','17:50:00',1.57),('325','2013-05-25','18:00:00',1),('325','2013-05-24','08:05:00',1.18),('325','2013-05-24','08:10:00',1.49),('325','2013-05-24','08:15:00',1.28),('325','2013-05-24','08:25:00',1.09),('325','2013-05-24','08:30:00',1.56),('325','2013-05-24','08:35:00',1.1),('325','2013-05-24','08:40:00',1),('325','2013-05-24','08:45:00',1.6),('325','2013-05-24','08:50:00',1.57),('325','2013-05-24','08:55:00',1.65),('325','2013-05-24','09:00:00',1.86),('325','2013-05-24','09:05:00',2.01),('325','2013-05-24','09:20:00',1.96),('325','2013-05-24','09:25:00',1.38),('325','2013-05-24','09:30:00',1.57),('325','2013-05-24','09:40:00',1.73),('325','2013-05-24','09:45:00',1.13),('325','2013-05-24','09:50:00',1.41),('325','2013-05-24','09:55:00',3.29),('325','2013-05-24','10:00:00',1.63),('325','2013-05-24','10:20:00',1.53),('325','2013-05-24','10:25:00',2.78),('325','2013-05-24','10:30:00',4.14),('325','2013-05-24','10:35:00',4.09),('325','2013-05-24','10:40:00',3.99),('325','2013-05-24','10:45:00',3.84),('325','2013-05-24','10:50:00',3.51),('325','2013-05-24','10:55:00',4.93),('325','2013-05-24','11:00:00',3.48),('325','2013-05-24','11:05:00',3.78),('325','2013-05-24','11:10:00',4.45),('325','2013-05-24','11:15:00',3.55),('325','2013-05-24','11:20:00',4.97),('325','2013-05-24','11:25:00',5.07),('325','2013-05-24','11:30:00',2.89),('325','2013-05-24','11:35:00',1.43),('325','2013-05-24','11:40:00',1),('325','2013-05-24','11:45:00',4.01),('325','2013-05-24','11:50:00',5.44),('325','2013-05-24','11:55:00',3.14),('325','2013-05-24','12:00:00',3.3),('325','2013-05-24','12:05:00',2.7),('325','2013-05-24','12:10:00',4.16),('325','2013-05-24','12:15:00',2.9),('325','2013-05-24','12:20:00',2.47),('325','2013-05-24','12:25:00',4.11),('325','2013-05-24','12:30:00',5.17),('325','2013-05-24','12:35:00',2.55),('325','2013-05-24','12:40:00',3.08),('325','2013-05-24','12:45:00',3.57),('325','2013-05-24','12:50:00',3.47),('325','2013-05-24','12:55:00',3.08),('325','2013-05-24','13:00:00',2.91),('325','2013-05-24','13:05:00',2.32),('325','2013-05-24','13:10:00',2.76),('325','2013-05-24','13:15:00',3.19),('325','2013-05-24','13:20:00',3.26),('325','2013-05-24','13:25:00',2.38),('325','2013-05-24','13:30:00',2.24),('325','2013-05-24','13:35:00',2.81),('325','2013-05-24','13:40:00',2.21),('325','2013-05-24','13:45:00',1.19),('325','2013-05-24','13:50:00',1.41),('325','2013-05-24','13:55:00',2.6),('325','2013-05-24','14:00:00',2.38),('325','2013-05-24','14:05:00',1.91),('325','2013-05-24','14:10:00',1.79),('325','2013-05-24','14:15:00',4.4),('325','2013-05-24','14:20:00',3.82),('325','2013-05-24','14:25:00',3.28),('325','2013-05-24','14:30:00',2.61),('325','2013-05-24','14:35:00',4.13),('325','2013-05-24','14:40:00',3.57),('325','2013-05-24','14:45:00',2.89),('325','2013-05-24','14:50:00',1.54),('325','2013-05-24','14:55:00',1.82),('325','2013-05-24','15:00:00',3.04),('325','2013-05-24','15:05:00',3.79),('325','2013-05-24','15:10:00',2.39),('325','2013-05-24','15:15:00',4.07),('325','2013-05-24','15:20:00',5.1),('325','2013-05-24','15:25:00',3.95),('325','2013-05-24','15:30:00',5.36),('325','2013-05-24','15:35:00',4.27),('325','2013-05-24','15:40:00',3.66),('325','2013-05-24','15:45:00',4.54),('325','2013-05-24','15:50:00',5.08),('325','2013-05-24','15:55:00',4.25),('325','2013-05-24','16:00:00',2.44),('325','2013-05-24','16:05:00',2.38),('325','2013-05-24','16:10:00',2.54),('325','2013-05-24','16:15:00',2.94),('325','2013-05-24','16:20:00',2.59),('325','2013-05-24','16:25:00',3.57),('325','2013-05-24','16:30:00',3.11),('325','2013-05-24','16:35:00',1.68),('325','2013-05-24','16:50:00',1.58),('325','2013-05-24','16:55:00',1.86),('325','2013-05-24','17:00:00',1.42),('325','2013-05-24','17:05:00',1.02),('325','2013-05-24','17:20:00',1.04),('325','2013-05-24','17:25:00',1.06),('325','2013-05-24','17:30:00',1.15),('325','2013-05-24','17:35:00',1.15),('325','2013-05-23','08:00:00',1.16),('325','2013-05-23','08:05:00',1.25),('325','2013-05-23','08:30:00',1.54),('325','2013-05-23','08:35:00',1.44),('325','2013-05-23','08:40:00',1.76),('325','2013-05-23','08:45:00',1.57),('325','2013-05-23','08:55:00',1.02),('325','2013-05-23','09:00:00',2.16),('325','2013-05-23','09:15:00',1.1),('325','2013-05-23','09:20:00',2.39),('325','2013-05-23','09:25:00',3.19),('325','2013-05-23','09:30:00',2.85),('325','2013-05-23','09:35:00',2.57),('325','2013-05-23','09:40:00',2.28),('325','2013-05-23','09:45:00',2.09),('325','2013-05-23','09:50:00',2.89),('325','2013-05-23','09:55:00',1.61),('325','2013-05-23','10:00:00',1.5),('325','2013-05-23','10:05:00',4.15),('325','2013-05-23','10:10:00',2.69),('325','2013-05-23','10:15:00',4.09),('325','2013-05-23','10:20:00',2.29),('325','2013-05-23','10:25:00',3.87),('325','2013-05-23','10:30:00',3.62),('325','2013-05-23','10:35:00',3.7),('325','2013-05-23','10:40:00',3.83),('325','2013-05-23','10:45:00',4.55),('325','2013-05-23','10:50:00',2.32),('325','2013-05-23','10:55:00',4.33),('325','2013-05-23','11:00:00',2.51),('325','2013-05-23','11:05:00',4.1),('325','2013-05-23','11:10:00',3.41),('325','2013-05-23','11:15:00',2.21),('325','2013-05-23','11:20:00',1.57),('325','2013-05-23','11:25:00',3.58),('325','2013-05-23','11:30:00',3.16),('325','2013-05-23','11:35:00',3.49),('325','2013-05-23','11:40:00',5.37),('325','2013-05-23','11:45:00',2.69),('325','2013-05-23','11:50:00',2.97),('325','2013-05-23','11:55:00',4.64),('325','2013-05-23','12:00:00',5.09),('325','2013-05-23','12:05:00',5.23),('325','2013-05-23','12:10:00',5.32),('325','2013-05-23','12:15:00',3.85),('325','2013-05-23','12:20:00',3.77),('325','2013-05-23','12:25:00',3.23),('325','2013-05-23','12:30:00',3.92),('325','2013-05-23','12:35:00',1.76),('325','2013-05-23','12:40:00',5.49),('325','2013-05-23','12:45:00',3.35),('325','2013-05-23','12:50:00',4.88),('325','2013-05-23','12:55:00',4.55),('325','2013-05-23','13:00:00',4.97),('325','2013-05-23','13:05:00',4.32),('325','2013-05-23','13:10:00',5.4),('325','2013-05-23','13:15:00',4.67),('325','2013-05-23','13:20:00',4.3),('325','2013-05-23','13:25:00',5.54),('325','2013-05-23','13:30:00',4.6),('325','2013-05-23','13:35:00',3.08),('325','2013-05-23','13:40:00',3.33),('325','2013-05-23','13:45:00',3.25),('325','2013-05-23','13:50:00',3.99),('325','2013-05-23','13:55:00',4.23),('325','2013-05-23','14:00:00',4.66),('325','2013-05-23','14:05:00',4.36),('325','2013-05-23','14:10:00',4.72),('325','2013-05-23','14:15:00',4.14),('325','2013-05-23','14:20:00',4.05),('325','2013-05-23','14:25:00',2.75),('325','2013-05-23','14:30:00',2.88),('325','2013-05-23','14:35:00',5.51),('325','2013-05-23','14:40:00',3.15),('325','2013-05-23','14:45:00',2.59),('325','2013-05-23','14:50:00',3.06),('325','2013-05-23','14:55:00',4.05),('325','2013-05-23','15:00:00',4.59),('325','2013-05-23','15:05:00',3.01),('325','2013-05-23','15:10:00',1.55),('325','2013-05-23','15:15:00',1.76),('325','2013-05-23','15:20:00',4.12),('325','2013-05-23','15:25:00',1.79),('325','2013-05-23','15:30:00',4.46),('325','2013-05-23','15:35:00',3.86),('325','2013-05-23','15:40:00',1.83),('325','2013-05-23','15:45:00',3.08),('325','2013-05-23','15:50:00',1.3),('325','2013-05-23','15:55:00',2.3),('325','2013-05-23','16:00:00',3.3),('325','2013-05-23','16:05:00',4.5),('325','2013-05-23','16:10:00',2.2),('325','2013-05-23','16:15:00',3.22),('325','2013-05-23','16:20:00',3.14),('325','2013-05-23','16:25:00',3.34),('325','2013-05-23','16:30:00',3.25),('325','2013-05-23','16:35:00',2.13),('325','2013-05-23','16:40:00',1.45),('325','2013-05-23','16:45:00',2.55),('325','2013-05-23','17:05:00',1.3),('325','2013-05-23','17:10:00',2.69),('325','2013-05-23','17:15:00',1.77),('325','2013-05-23','17:20:00',1.61),('325','2013-05-23','17:25:00',1.04),('325','2013-05-23','17:35:00',1.76),('325','2013-05-23','17:40:00',1.08),('325','2013-05-23','17:50:00',1.05),('325','2013-05-23','17:55:00',1.61),('325','2013-05-23','18:00:00',2.14),('325','2013-05-23','18:05:00',2.55),('325','2013-05-23','18:50:00',1.09),('325','2013-05-22','08:05:00',1.02),('325','2013-05-22','08:10:00',1.06),('325','2013-05-22','08:15:00',1.49),('325','2013-05-22','08:20:00',1.35),('325','2013-05-22','08:25:00',1.33),('325','2013-05-22','08:30:00',1.84),('325','2013-05-22','08:35:00',2),('325','2013-05-22','08:40:00',1.39),('325','2013-05-22','08:45:00',1.43),('325','2013-05-22','09:25:00',1.12),('325','2013-05-22','09:30:00',2.44),('325','2013-05-22','09:35:00',2.73),('325','2013-05-22','09:40:00',2.74),('325','2013-05-22','09:45:00',2.82),('325','2013-05-22','09:50:00',2.91),('325','2013-05-22','09:55:00',2.97),('325','2013-05-22','10:00:00',3.04),('325','2013-05-22','10:05:00',3.09),('325','2013-05-22','10:10:00',3.14),('325','2013-05-22','10:15:00',3.17),('325','2013-05-22','10:20:00',3),('325','2013-05-22','10:25:00',3.45),('325','2013-05-22','10:30:00',3.58),('325','2013-05-22','10:35:00',3.7),('325','2013-05-22','10:40:00',3.91),('325','2013-05-22','10:45:00',3.94),('325','2013-05-22','10:50:00',3.93),('325','2013-05-22','10:55:00',3.98),('325','2013-05-22','11:00:00',4.07),('325','2013-05-22','11:05:00',4.16),('325','2013-05-22','11:10:00',3.48),('325','2013-05-22','11:15:00',4.11),('325','2013-05-22','11:20:00',4.26),('325','2013-05-22','11:25:00',4.13),('325','2013-05-22','11:30:00',3.36),('325','2013-05-22','11:35:00',3.1),('325','2013-05-22','11:40:00',3.94),('325','2013-05-22','11:45:00',4.3),('325','2013-05-22','11:50:00',2.52),('325','2013-05-22','11:55:00',2.24),('325','2013-05-22','12:00:00',3.15),('325','2013-05-22','12:05:00',2.49),('325','2013-05-22','12:10:00',2.44),('325','2013-05-22','12:15:00',3.55),('325','2013-05-22','12:20:00',4.05),('325','2013-05-22','12:25:00',3.44),('325','2013-05-22','12:30:00',2.4),('325','2013-05-22','12:35:00',2.46),('325','2013-05-22','12:40:00',1.61),('325','2013-05-22','13:00:00',1.07),('325','2013-05-22','13:05:00',4.44),('325','2013-05-22','13:10:00',2.88),('325','2013-05-22','13:15:00',3.21),('325','2013-05-22','13:20:00',3.08),('325','2013-05-22','13:25:00',1.17),('325','2013-05-22','13:30:00',2.02),('325','2013-05-22','13:35:00',4.14),('325','2013-05-22','13:40:00',3.13),('325','2013-05-22','13:45:00',2.67),('325','2013-05-22','13:50:00',1.77),('325','2013-05-22','13:55:00',2.23),('325','2013-05-22','14:00:00',3),('325','2013-05-22','14:05:00',3.3),('325','2013-05-22','14:10:00',4.49),('325','2013-05-22','14:15:00',4.61),('325','2013-05-22','14:20:00',4.49),('325','2013-05-22','14:25:00',4.4),('325','2013-05-22','14:30:00',4.37),('325','2013-05-22','14:35:00',4.4),('325','2013-05-22','14:40:00',4.38),('325','2013-05-22','14:45:00',4.35),('325','2013-05-22','14:50:00',4.32),('325','2013-05-22','14:55:00',4.27),('325','2013-05-22','15:00:00',4.23),('325','2013-05-22','15:05:00',4.15),('325','2013-05-22','15:10:00',4.13),('325','2013-05-22','15:15:00',3.79),('325','2013-05-22','15:20:00',3.37),('325','2013-05-22','15:25:00',2.31),('325','2013-05-22','15:30:00',2.16),('325','2013-05-22','15:35:00',2.25),('325','2013-05-22','15:40:00',3.81),('325','2013-05-22','15:45:00',3.04),('325','2013-05-22','15:50:00',3.77),('325','2013-05-22','15:55:00',3.67),('325','2013-05-22','16:00:00',3.61),('325','2013-05-22','16:05:00',3.53),('325','2013-05-22','16:10:00',3.48),('325','2013-05-22','16:15:00',3.42),('325','2013-05-22','16:20:00',3.33),('325','2013-05-22','16:25:00',3.26),('325','2013-05-22','16:30:00',3.14),('325','2013-05-22','16:35:00',2.98),('325','2013-05-22','16:40:00',2.99),('325','2013-05-22','16:45:00',2.9),('325','2013-05-22','16:50:00',1.07),('325','2013-05-22','17:15:00',1.19),('325','2013-05-22','17:20:00',1.42),('325','2013-05-22','17:25:00',1.6),('325','2013-05-22','17:30:00',1.36),('325','2013-05-22','17:35:00',1.82),('325','2013-05-22','17:55:00',1.74),('325','2013-05-22','18:00:00',1.72),('325','2013-05-21','07:40:00',1.04),('325','2013-05-21','08:10:00',1.18),('325','2013-05-21','08:15:00',1.43),('325','2013-05-21','08:20:00',1.41),('325','2013-05-21','08:25:00',1.61),('325','2013-05-21','08:30:00',1.26),('325','2013-05-21','08:35:00',1.29),('325','2013-05-21','08:40:00',1.46),('325','2013-05-21','08:45:00',1.29),('325','2013-05-21','08:50:00',1.44),('325','2013-05-21','08:55:00',1.72),('325','2013-05-21','09:00:00',1.5),('325','2013-05-21','09:05:00',1.37),('325','2013-05-21','09:10:00',1.48),('325','2013-05-21','09:15:00',1.56),('325','2013-05-21','09:20:00',1.95),('325','2013-05-21','09:25:00',2.1),('325','2013-05-21','09:30:00',1.86),('325','2013-05-21','09:35:00',2),('325','2013-05-21','09:40:00',1.96),('325','2013-05-21','09:45:00',1.71),('325','2013-05-21','09:50:00',1.7),('325','2013-05-21','09:55:00',1.89),('325','2013-05-21','10:00:00',2.12),('325','2013-05-21','10:05:00',2.2),('325','2013-05-21','10:10:00',2.29),('325','2013-05-21','10:15:00',2.5),('325','2013-05-21','10:20:00',2.05),('325','2013-05-21','10:25:00',2.03),('325','2013-05-21','10:30:00',1.9),('325','2013-05-21','10:35:00',1.97),('325','2013-05-21','10:40:00',2.2),('325','2013-05-21','10:45:00',3.15),('325','2013-05-21','10:50:00',2.14),('325','2013-05-21','10:55:00',1.71),('325','2013-05-21','11:00:00',2.06),('325','2013-05-21','11:05:00',1.96),('325','2013-05-21','11:10:00',3.17),('325','2013-05-21','11:15:00',3.86),('325','2013-05-21','11:20:00',3.9),('325','2013-05-21','11:25:00',4.1),('325','2013-05-21','11:30:00',3.59),('325','2013-05-21','11:35:00',2.81),('325','2013-05-21','11:40:00',3.03),('325','2013-05-21','11:45:00',3.42),('325','2013-05-21','11:50:00',3.32),('325','2013-05-21','11:55:00',3.69),('325','2013-05-21','12:00:00',3.53),('325','2013-05-21','12:05:00',4.39),('325','2013-05-21','12:10:00',2.98),('325','2013-05-21','12:15:00',3.63),('325','2013-05-21','12:20:00',2.54),('325','2013-05-21','12:25:00',3.45),('325','2013-05-21','12:30:00',4.45),('325','2013-05-21','12:35:00',2.88),('325','2013-05-21','12:40:00',4.62),('325','2013-05-21','12:45:00',4.15),('325','2013-05-21','12:50:00',3.08),('325','2013-05-21','12:55:00',4.91),('325','2013-05-21','13:00:00',4.22),('325','2013-05-21','13:05:00',4.39),('325','2013-05-21','13:10:00',2.84),('325','2013-05-21','13:15:00',3.76),('325','2013-05-21','13:20:00',3.11),('325','2013-05-21','13:25:00',3.14),('325','2013-05-21','13:30:00',3.13),('325','2013-05-21','13:35:00',1.41),('325','2013-05-21','14:05:00',1.21),('325','2013-05-21','14:10:00',1.8),('325','2013-05-21','14:15:00',2.09),('325','2013-05-21','14:20:00',1.76),('325','2013-05-21','14:25:00',2.98),('325','2013-05-21','14:30:00',2.95),('325','2013-05-21','14:35:00',2.21),('325','2013-05-21','14:40:00',1.99),('325','2013-05-21','14:45:00',1.56),('325','2013-05-21','15:15:00',1.23),('325','2013-05-21','15:20:00',1.57),('325','2013-05-21','15:25:00',1.6),('325','2013-05-21','15:30:00',2.67),('325','2013-05-21','15:35:00',1.77),('325','2013-05-21','15:40:00',1.41),('325','2013-05-21','15:45:00',1.44),('325','2013-05-21','15:50:00',1.24),('325','2013-05-21','15:55:00',1.21),('325','2013-05-21','16:00:00',1.2),('325','2013-05-21','16:05:00',1.24),('325','2013-05-21','16:10:00',1.33),('325','2013-05-21','16:15:00',1.11),('325','2013-05-21','16:25:00',1.39),('325','2013-05-21','16:30:00',1.93),('325','2013-05-21','16:35:00',2.22),('325','2013-05-21','16:40:00',2.05),('325','2013-05-21','16:45:00',1.88),('325','2013-05-21','16:50:00',1.12),('325','2014-03-31','08:50:00',1.06),('325','2014-03-31','08:55:00',1.12),('325','2014-03-31','09:00:00',1.17),('325','2014-03-31','09:05:00',1.23),('325','2014-03-31','09:10:00',1.28),('325','2014-03-31','09:15:00',1.32),('325','2014-03-31','09:20:00',1.38),('325','2014-03-31','09:25:00',1.43),('325','2014-03-31','09:30:00',1.47),('325','2014-03-31','09:35:00',1.51),('325','2014-03-31','09:40:00',1.56),('325','2014-03-31','09:45:00',1.6),('325','2014-03-31','09:50:00',1.65),('325','2014-03-31','09:55:00',1.69),('325','2014-03-31','10:00:00',1.72),('325','2014-03-31','10:05:00',1.76),('325','2014-03-31','10:10:00',1.8),('325','2014-03-31','10:15:00',1.84),('325','2014-03-31','10:20:00',1.9),('325','2014-03-31','10:25:00',2.88),('325','2014-03-31','10:30:00',3.26),('325','2014-03-31','10:35:00',3.33),('325','2014-03-31','10:40:00',3.39),('325','2014-03-31','10:45:00',3.48),('325','2014-03-31','10:50:00',3.57),('325','2014-03-31','10:55:00',3.59),('325','2014-03-31','11:00:00',3.65),('325','2014-03-31','11:05:00',3.74),('325','2014-03-31','11:10:00',3.79),('325','2014-03-31','11:15:00',3.83),('325','2014-03-31','11:20:00',3.87),('325','2014-03-31','11:25:00',3.93),('325','2014-03-31','11:30:00',3.93),('325','2014-03-31','11:35:00',3.96),('325','2014-03-31','11:40:00',4),('325','2014-03-31','11:45:00',4.06),('325','2014-03-31','11:50:00',4.12),('325','2014-03-31','11:55:00',4.14),('325','2014-03-31','12:00:00',4.16),('325','2014-03-31','12:05:00',4.18),('325','2014-03-31','12:10:00',4.23),('325','2014-03-31','12:15:00',4.29),('325','2014-03-31','12:20:00',4.29),('325','2014-03-31','12:25:00',4.32),('325','2014-03-31','12:30:00',4.38),('325','2014-03-31','12:35:00',4.4),('325','2014-03-31','12:40:00',4.37),('325','2014-03-31','12:45:00',4.33),('325','2014-03-31','12:50:00',4.35),('325','2014-03-31','12:55:00',4.36),('325','2014-03-31','13:00:00',4.41),('325','2014-03-31','13:05:00',4.44),('325','2014-03-31','13:10:00',4.44),('325','2014-03-31','13:15:00',4.42),('325','2014-03-31','13:20:00',4.42),('325','2014-03-31','13:25:00',4.41),('325','2014-03-31','13:30:00',4.43),('325','2014-03-31','13:35:00',4.43),('325','2014-03-31','13:40:00',4.42),('325','2014-03-31','13:45:00',4.42),('325','2014-03-31','13:50:00',4.41),('325','2014-03-31','13:55:00',4.41),('325','2014-03-31','14:00:00',4.41),('325','2014-03-31','14:05:00',4.4),('325','2014-03-31','14:10:00',4.38),('325','2014-03-31','14:15:00',4.36),('325','2014-03-31','14:20:00',4.33),('325','2014-03-31','14:25:00',4.3),('325','2014-03-31','14:30:00',4.26),('325','2014-03-31','14:35:00',4.24),('325','2014-03-31','14:40:00',4.22),('325','2014-03-31','14:45:00',4.2),('325','2014-03-31','14:50:00',4.15),('325','2014-03-31','14:55:00',4.1),('325','2014-03-31','15:00:00',4.08),('325','2014-03-31','15:05:00',4.03),('325','2014-03-31','15:10:00',3.98),('325','2014-03-31','15:15:00',3.95),('325','2014-03-31','15:20:00',3.89),('325','2014-03-31','15:25:00',3.83),('325','2014-03-31','15:30:00',3.78),('325','2014-03-31','15:35:00',3.72),('325','2014-03-31','15:40:00',3.65),('325','2014-03-31','15:45:00',3.61),('325','2014-03-31','15:50:00',3.51),('325','2014-03-31','15:55:00',3.42),('325','2014-03-31','16:00:00',3.35),('325','2014-03-31','16:05:00',3.25),('325','2014-03-31','16:10:00',3.2),('325','2014-03-31','16:15:00',3.11),('325','2014-03-31','16:20:00',3.04),('325','2014-03-31','16:25:00',2.94),('325','2014-03-31','16:30:00',2.87),('325','2014-03-31','16:35:00',2.78),('325','2014-03-31','16:40:00',2.64),('325','2014-03-31','16:45:00',2.54),('325','2014-03-31','16:50:00',2.49),('325','2014-03-31','16:55:00',2.39),('325','2014-03-31','17:00:00',2.29),('325','2014-03-31','17:05:00',2.2),('325','2014-03-31','17:10:00',2.11),('325','2014-03-31','17:15:00',2),('325','2014-03-31','17:20:00',1.88),('325','2014-03-31','17:25:00',1.76),('325','2014-03-31','17:30:00',1.68),('325','2014-03-31','17:35:00',1.59),('325','2014-03-31','17:40:00',1.49),('325','2014-03-31','17:45:00',1.39),('325','2014-03-31','17:50:00',1.29),('325','2014-03-31','17:55:00',1.19),('325','2014-03-31','18:00:00',1.08),('325','2013-05-20','08:20:00',1.19),('325','2013-05-20','08:45:00',1.95),('325','2013-05-20','08:50:00',1.98),('325','2013-05-20','08:55:00',1.44),('325','2013-05-20','09:00:00',1.74),('325','2013-05-20','09:05:00',1.8),('325','2013-05-20','09:10:00',2.33),('325','2013-05-20','09:15:00',1.15),('325','2013-05-20','09:20:00',1.28),('325','2013-05-20','09:25:00',1.04),('325','2013-05-20','09:30:00',1.35),('325','2013-05-20','09:35:00',1.99),('325','2013-05-20','09:45:00',2.16),('325','2013-05-20','09:50:00',2.37),('325','2013-05-20','10:00:00',1.27),('325','2013-05-20','10:05:00',1.82),('325','2013-05-20','10:10:00',3.08),('325','2013-05-20','10:25:00',2.63),('325','2013-05-20','10:30:00',3.63),('325','2013-05-20','10:35:00',2.5),('325','2013-05-20','10:40:00',2.18),('325','2013-05-20','10:45:00',1.5),('325','2013-05-20','10:50:00',1.55),('325','2013-05-20','10:55:00',1.1),('325','2013-05-20','11:00:00',4.94),('325','2013-05-20','11:05:00',3.29),('325','2013-05-20','11:10:00',4.45),('325','2013-05-20','11:15:00',2.8),('325','2013-05-20','11:20:00',2.89),('325','2013-05-20','11:25:00',3.94),('325','2013-05-20','11:30:00',5.17),('325','2013-05-20','11:35:00',4.37),('325','2013-05-20','11:40:00',2.19),('325','2013-05-20','11:45:00',2.78),('325','2013-05-20','11:50:00',2.22),('325','2013-05-20','11:55:00',4.77),('325','2013-05-20','12:00:00',3.31),('325','2013-05-20','12:05:00',4.62),('325','2013-05-20','12:10:00',2.3),('325','2013-05-20','12:15:00',4.33),('325','2013-05-20','12:20:00',3.5),('325','2013-05-20','12:25:00',2.24),('325','2013-05-20','12:30:00',4.09),('325','2013-05-20','12:35:00',3.19),('325','2013-05-20','12:40:00',4.46),('325','2013-05-20','12:45:00',3.15),('325','2013-05-20','12:50:00',2.3),('325','2013-05-20','12:55:00',3.55),('325','2013-05-20','13:00:00',2.2),('325','2013-05-20','13:05:00',3.92),('325','2013-05-20','13:10:00',3.02),('325','2013-05-20','13:15:00',3.43),('325','2013-05-20','13:20:00',4.46),('325','2013-05-20','13:25:00',5.67),('325','2013-05-20','13:30:00',1.45),('325','2013-05-20','13:35:00',4.91),('325','2013-05-20','13:40:00',1.64),('325','2013-05-20','13:45:00',5.16),('325','2013-05-20','13:50:00',3.51),('325','2013-05-20','13:55:00',5.1),('325','2013-05-20','14:00:00',4.42),('325','2013-05-20','14:05:00',1.11),('325','2013-05-20','14:10:00',4.05),('325','2013-05-20','14:15:00',3.85),('325','2013-05-20','14:20:00',3.03),('325','2013-05-20','14:25:00',4.6),('325','2013-05-20','14:30:00',5.06),('325','2013-05-20','14:35:00',3.93),('325','2013-05-20','14:40:00',2.58),('325','2013-05-20','14:45:00',4.86),('325','2013-05-20','14:50:00',4.4),('325','2013-05-20','14:55:00',5.14),('325','2013-05-20','15:00:00',2.19),('325','2013-05-20','15:05:00',2.94),('325','2013-05-20','15:10:00',4.94),('325','2013-05-20','15:15:00',2.73),('325','2013-05-20','15:20:00',4.9),('325','2013-05-20','15:25:00',4.81),('325','2013-05-20','15:30:00',4.74),('325','2013-05-20','15:35:00',4.46),('325','2013-05-20','15:40:00',2.09),('325','2013-05-20','15:45:00',2.33),('325','2013-05-20','15:50:00',3.02),('325','2013-05-20','15:55:00',3.05),('325','2013-05-20','16:00:00',3.01),('325','2013-05-20','16:05:00',4.32),('325','2013-05-20','16:10:00',4.21),('325','2013-05-20','16:15:00',4.04),('325','2013-05-20','16:20:00',3.84),('325','2013-05-20','16:25:00',3.79),('325','2013-05-20','16:30:00',3.64),('325','2013-05-20','16:35:00',3.51),('325','2013-05-20','16:40:00',3.42),('325','2013-05-20','16:45:00',3.18),('325','2013-05-20','16:50:00',3.13),('325','2013-05-20','16:55:00',2.92),('325','2013-05-20','17:00:00',2.92),('325','2013-05-20','17:05:00',2.84),('325','2013-05-20','17:10:00',2.2),('325','2013-05-20','17:15:00',1.37),('325','2013-05-20','17:20:00',2.32),('325','2013-05-20','17:25:00',2.8),('325','2013-05-20','17:30:00',2.78),('325','2013-05-20','17:35:00',2.31),('325','2013-05-20','17:40:00',2.16),('325','2013-05-20','17:45:00',2.01),('325','2013-05-20','17:50:00',1.94),('325','2013-05-20','17:55:00',1.85),('325','2013-05-20','18:00:00',1.78),('325','2013-05-20','18:05:00',1.78),('325','2013-05-20','18:10:00',1.42),('325','2013-05-20','18:15:00',1.65),('325','2013-05-20','18:20:00',1.39),('325','2013-05-20','18:25:00',1.16),('325','2013-05-19','08:35:00',1.2),('325','2013-05-19','08:45:00',1.12),('325','2013-05-19','08:50:00',1.3),('325','2013-05-19','08:55:00',1.33),('325','2013-05-19','09:00:00',1.29),('325','2013-05-19','09:05:00',1.23),('325','2013-05-19','09:10:00',1.4),('325','2013-05-19','09:15:00',1.36),('325','2013-05-19','09:40:00',1.18),('325','2013-05-19','09:45:00',1.29),('325','2013-05-19','09:55:00',1.21),('325','2013-05-19','10:00:00',1.41),('325','2013-05-19','10:05:00',1.75),('325','2013-05-19','10:10:00',2.38),('325','2013-05-19','10:15:00',2.76),('325','2013-05-19','10:20:00',2.99),('325','2013-05-19','10:25:00',2.67),('325','2013-05-19','10:30:00',3.22),('325','2013-05-19','10:35:00',4.04),('325','2013-05-19','10:40:00',4.13),('325','2013-05-19','10:45:00',4.28),('325','2013-05-19','10:50:00',4.16),('325','2013-05-19','10:55:00',4.44),('325','2013-05-19','11:00:00',4.22),('325','2013-05-19','11:05:00',2.05),('325','2013-05-19','11:10:00',3.69),('325','2013-05-19','11:15:00',4.76),('325','2013-05-19','11:20:00',4.66),('325','2013-05-19','11:25:00',4.76),('325','2013-05-19','11:30:00',4.78),('325','2013-05-19','11:35:00',4.78),('325','2013-05-19','11:40:00',4.85),('325','2013-05-19','11:45:00',4.93),('325','2013-05-19','11:50:00',4.91),('325','2013-05-19','11:55:00',5),('325','2013-05-19','12:00:00',4.94),('325','2013-05-19','12:05:00',4.93),('325','2013-05-19','12:10:00',4.96),('325','2013-05-19','12:15:00',5.16),('325','2013-05-19','12:20:00',4.84),('325','2013-05-19','12:25:00',3.37),('325','2013-05-19','12:30:00',3.18),('325','2013-05-19','12:35:00',3.26),('325','2013-05-19','12:40:00',4.22),('325','2013-05-19','12:45:00',4.51),('325','2013-05-19','12:50:00',3.65),('325','2013-05-19','12:55:00',3.07),('325','2013-05-19','13:00:00',4),('325','2013-05-19','13:05:00',4.38),('325','2013-05-19','13:10:00',3.8),('325','2013-05-19','13:15:00',4.3),('325','2013-05-19','13:20:00',4.02),('325','2013-05-19','13:25:00',5),('325','2013-05-19','13:30:00',4.91),('325','2013-05-19','13:35:00',4.97),('325','2013-05-19','13:40:00',4.91),('325','2013-05-19','13:45:00',4.88),('325','2013-05-19','13:50:00',4.88),('325','2013-05-19','13:55:00',4.83),('325','2013-05-19','14:00:00',4.83),('325','2013-05-19','14:05:00',4.81),('325','2013-05-19','14:10:00',4.81),('325','2013-05-19','14:15:00',4.82),('325','2013-05-19','14:20:00',4.8),('325','2013-05-19','14:25:00',4.81),('325','2013-05-19','14:30:00',4.78),('325','2013-05-19','14:35:00',4.77),('325','2013-05-19','14:40:00',4.77),('325','2013-05-19','14:45:00',4.71),('325','2013-05-19','14:50:00',4.65),('325','2013-05-19','14:55:00',4.64),('325','2013-05-19','15:00:00',4.63),('325','2013-05-19','15:05:00',4.58),('325','2013-05-19','15:10:00',4.49),('325','2013-05-19','15:15:00',4.44),('325','2013-05-19','15:20:00',4.42),('325','2013-05-19','15:25:00',4.4),('325','2013-05-19','15:30:00',4.36),('325','2013-05-19','15:35:00',4.25),('325','2013-05-19','15:40:00',4.19),('325','2013-05-19','15:45:00',4.15),('325','2013-05-19','15:50:00',4.12),('325','2013-05-19','15:55:00',4.07),('325','2013-05-19','16:00:00',4.03),('325','2013-05-19','16:05:00',3.97),('325','2013-05-19','16:10:00',3.86),('325','2013-05-19','16:15:00',3.79),('325','2013-05-19','16:20:00',3.73),('325','2013-05-19','16:25:00',3.67),('325','2013-05-19','16:30:00',3.58),('325','2013-05-19','16:35:00',3.51),('325','2013-05-19','16:40:00',3.44),('325','2013-05-19','16:45:00',3.37),('325','2013-05-19','16:50:00',3.24),('325','2013-05-19','16:55:00',3.12),('325','2013-05-19','17:00:00',3.07),('325','2013-05-19','17:05:00',2.97),('325','2013-05-19','17:10:00',2.87),('325','2013-05-19','17:15:00',2.78),('325','2013-05-19','17:20:00',2.7),('325','2013-05-19','17:25:00',2.57),('325','2013-05-19','17:30:00',2.46),('325','2013-05-19','17:35:00',2.39),('325','2013-05-19','17:40:00',2.25),('325','2013-05-19','17:45:00',2.16),('325','2013-05-19','17:50:00',2.05),('325','2013-05-19','17:55:00',1.94),('325','2013-05-19','18:00:00',1.85),('325','2013-05-19','18:05:00',1.75),('325','2013-05-19','18:10:00',1.65),('325','2013-05-19','18:15:00',1.54),('325','2013-05-19','18:20:00',1.41),('325','2013-05-19','18:25:00',1.22),('325','2013-05-19','18:30:00',1.03),('325','2013-05-18','07:55:00',1.18),('325','2013-05-18','08:00:00',1.35),('325','2013-05-18','08:05:00',1.26),('325','2013-05-18','08:20:00',1.19),('325','2013-05-18','08:25:00',1.68),('325','2013-05-18','08:30:00',1.44),('325','2013-05-18','08:35:00',1.37),('325','2013-05-18','08:40:00',1.9),('325','2013-05-18','08:45:00',1.96),('325','2013-05-18','08:50:00',2.02),('325','2013-05-18','08:55:00',2.18),('325','2013-05-18','09:00:00',2.29),('325','2013-05-18','09:05:00',2.26),('325','2013-05-18','09:10:00',2.46),('325','2013-05-18','09:15:00',2.52),('325','2013-05-18','09:20:00',2.62),('325','2013-05-18','09:25:00',2.73),('325','2013-05-18','09:30:00',2.78),('325','2013-05-18','09:35:00',2.84),('325','2013-05-18','09:40:00',2.91),('325','2013-05-18','09:45:00',2.98),('325','2013-05-18','09:50:00',3.06),('325','2013-05-18','09:55:00',3.12),('325','2013-05-18','10:00:00',3.16),('325','2013-05-18','10:05:00',3.24),('325','2013-05-18','10:10:00',3.28),('325','2013-05-18','10:15:00',3.29),('325','2013-05-18','10:20:00',3.33),('325','2013-05-18','10:25:00',3.4),('325','2013-05-18','10:30:00',3.47),('325','2013-05-18','10:35:00',3.76),('325','2013-05-18','10:40:00',3.87),('325','2013-05-18','10:45:00',3.96),('325','2013-05-18','10:50:00',4.06),('325','2013-05-18','10:55:00',3.87),('325','2013-05-18','11:00:00',4.33),('325','2013-05-18','11:05:00',4.04),('325','2013-05-18','11:10:00',3.84),('325','2013-05-18','11:15:00',4.4),('325','2013-05-18','11:20:00',4.47),('325','2013-05-18','11:25:00',4.5),('325','2013-05-18','11:30:00',3.79),('325','2013-05-18','11:35:00',4.21),('325','2013-05-18','11:40:00',4.38),('325','2013-05-18','11:45:00',4.41),('325','2013-05-18','11:50:00',4.28),('325','2013-05-18','11:55:00',4.08),('325','2013-05-18','12:00:00',4.13),('325','2013-05-18','12:05:00',4.41),('325','2013-05-18','12:10:00',4.34),('325','2013-05-18','12:15:00',4.31),('325','2013-05-18','12:20:00',4.31),('325','2013-05-18','12:25:00',4.39),('325','2013-05-18','12:30:00',3.27),('325','2013-05-18','12:35:00',4.55),('325','2013-05-18','12:40:00',4.51),('325','2013-05-18','12:45:00',4.09),('325','2013-05-18','12:50:00',4.51),('325','2013-05-18','12:55:00',4.3),('325','2013-05-18','13:00:00',4.5),('325','2013-05-18','13:05:00',4.49),('325','2013-05-18','13:10:00',3.59),('325','2013-05-18','13:15:00',4.42),('325','2013-05-18','13:20:00',4.49),('325','2013-05-18','13:25:00',4.5),('325','2013-05-18','13:30:00',4.37),('325','2013-05-18','13:35:00',4.26),('325','2013-05-18','13:40:00',4.52),('325','2013-05-18','13:45:00',4.59),('325','2013-05-18','13:50:00',4.27),('325','2013-05-18','13:55:00',3.48),('325','2013-05-18','14:00:00',3.54),('325','2013-05-18','14:05:00',3.85),('325','2013-05-18','14:10:00',4.69),('325','2013-05-18','14:15:00',4.51),('325','2013-05-18','14:20:00',4.56),('325','2013-05-18','14:25:00',4.36),('325','2013-05-18','14:30:00',4.42),('325','2013-05-18','14:35:00',4.27),('325','2013-05-18','14:40:00',4.61),('325','2013-05-18','14:45:00',4.33),('325','2013-05-18','14:50:00',4.32),('325','2013-05-18','14:55:00',3.72),('325','2013-05-18','15:00:00',4.01),('325','2013-05-18','15:05:00',3.93),('325','2013-05-18','15:10:00',3.85),('325','2013-05-18','15:15:00',3.81),('325','2013-05-18','15:20:00',3.73),('325','2013-05-18','15:25:00',3.68),('325','2013-05-18','15:30:00',3.64),('325','2013-05-18','15:35:00',3.6),('325','2013-05-18','15:40:00',3.56),('325','2013-05-18','15:45:00',3.49),('325','2013-05-18','15:50:00',3.45),('325','2013-05-18','15:55:00',3.4),('325','2013-05-18','16:00:00',3.33),('325','2013-05-18','16:05:00',3.28),('325','2013-05-18','16:10:00',3.21),('325','2013-05-18','16:15:00',3.17),('325','2013-05-18','16:20:00',3.12),('325','2013-05-18','16:25:00',3.05),('325','2013-05-18','16:30:00',2.98),('325','2013-05-18','16:35:00',2.9),('325','2013-05-18','16:40:00',2.83),('325','2013-05-18','16:45:00',2.75),('325','2013-05-18','16:50:00',2.64),('325','2013-05-18','16:55:00',2.53),('325','2013-05-18','17:00:00',2.39),('325','2013-05-18','17:05:00',2.4),('325','2013-05-18','17:10:00',2.33),('325','2013-05-18','17:15:00',2.26),('325','2013-05-18','17:20:00',2.18),('325','2013-05-18','17:25:00',2.09),('325','2013-05-18','17:30:00',1.99),('325','2013-05-18','17:35:00',1.9),('325','2013-05-18','17:40:00',1.8),('325','2013-05-18','17:45:00',1.68),('325','2013-05-18','17:50:00',1.64),('325','2013-05-18','17:55:00',1.56),('325','2013-05-18','18:00:00',1.47),('325','2013-05-18','18:05:00',1.37),('325','2013-05-18','18:10:00',1.3),('325','2013-05-18','18:15:00',1.21),('325','2013-05-18','18:20:00',1.1),('325','2013-05-17','08:05:00',1.03),('325','2013-05-17','08:10:00',1.13),('325','2013-05-17','08:15:00',1.47),('325','2013-05-17','08:20:00',1.85),('325','2013-05-17','08:25:00',1.61),('325','2013-05-17','10:20:00',1),('325','2013-05-17','10:25:00',1.44),('325','2013-05-17','10:30:00',1.66),('325','2013-05-17','10:35:00',1.27),('325','2013-05-17','10:40:00',1.49),('325','2013-05-17','10:45:00',1.61),('325','2013-05-17','10:50:00',2.58),('325','2013-05-17','10:55:00',2.94),('325','2013-05-17','11:00:00',2.27),('325','2013-05-17','11:05:00',2.09),('325','2013-05-17','11:10:00',1.5),('325','2013-05-17','11:15:00',2.46),('325','2013-05-17','11:20:00',2.09),('325','2013-05-17','11:25:00',1.78),('325','2013-05-17','11:30:00',1.82),('325','2013-05-17','11:35:00',2.37),('325','2013-05-17','11:40:00',2.27),('325','2013-05-17','11:45:00',4.87),('325','2013-05-17','11:50:00',4.28),('325','2013-05-17','11:55:00',4.05),('325','2013-05-17','12:00:00',4.2),('325','2013-05-17','12:05:00',4.11),('325','2013-05-17','12:10:00',3.69),('325','2013-05-17','12:15:00',2.84),('325','2013-05-17','12:20:00',4.25),('325','2013-05-17','12:25:00',4.03),('325','2013-05-17','12:30:00',2.35),('325','2013-05-17','12:35:00',3.43),('325','2013-05-17','12:40:00',5.28),('325','2013-05-17','12:45:00',5.33),('325','2013-05-17','12:50:00',5.12),('325','2013-05-17','12:55:00',4.58),('325','2013-05-17','13:00:00',4.45),('325','2013-05-17','13:05:00',4.44),('325','2013-05-17','13:10:00',4.09),('325','2013-05-17','13:15:00',5.07),('325','2013-05-17','13:20:00',4.91),('325','2013-05-17','13:25:00',5),('325','2013-05-17','13:30:00',3.72),('325','2013-05-17','13:35:00',4.98),('325','2013-05-17','13:40:00',4.47),('325','2013-05-17','13:45:00',4.42),('325','2013-05-17','13:50:00',4.57),('325','2013-05-17','13:55:00',5.19),('325','2013-05-17','14:00:00',4.73),('325','2013-05-17','14:05:00',4.59),('325','2013-05-17','14:10:00',4.26),('325','2013-05-17','14:15:00',4.66),('325','2013-05-17','14:20:00',4.95),('325','2013-05-17','14:25:00',4.41),('325','2013-05-17','14:30:00',4.25),('325','2013-05-17','14:35:00',4.52),('325','2013-05-17','14:40:00',2.89),('325','2013-05-17','14:45:00',3.66),('325','2013-05-17','14:50:00',4.82),('325','2013-05-17','14:55:00',2.74),('325','2013-05-17','15:00:00',5.1),('325','2013-05-17','15:05:00',2.28),('325','2013-05-17','15:10:00',1.48),('325','2013-05-17','15:15:00',3.94),('325','2013-05-17','15:20:00',3.29),('325','2013-05-17','15:25:00',1.74),('325','2013-05-17','15:30:00',2.17),('325','2013-05-17','15:35:00',2.57),('325','2013-05-17','15:40:00',2),('325','2013-05-17','15:45:00',2.27),('325','2013-05-17','15:50:00',4.89),('325','2013-05-17','15:55:00',4.64),('325','2013-05-17','16:00:00',4.56),('325','2013-05-17','16:05:00',4.18),('325','2013-05-17','16:10:00',4.27),('325','2013-05-17','16:15:00',3.54),('325','2013-05-17','16:20:00',3.45),('325','2013-05-17','16:25:00',3.73),('325','2013-05-17','16:30:00',3.66),('325','2013-05-17','16:35:00',3.83),('325','2013-05-17','16:40:00',3.77),('325','2013-05-17','16:45:00',3.43),('325','2013-05-17','16:50:00',3.15),('325','2013-05-17','16:55:00',2.96),('325','2013-05-17','17:00:00',2.94),('325','2013-05-17','17:05:00',2.84),('325','2013-05-17','17:10:00',2.75),('325','2013-05-17','17:15:00',2.66),('325','2013-05-17','17:20:00',2.59),('325','2013-05-17','17:25:00',2.51),('325','2013-05-17','17:30:00',2.42),('325','2013-05-17','17:35:00',2.31),('325','2013-05-17','17:40:00',2.19),('325','2013-05-17','17:45:00',2.08),('325','2013-05-17','17:50:00',2.01),('325','2013-05-17','17:55:00',1.88),('325','2013-05-17','18:00:00',1.79),('325','2013-05-17','18:05:00',1.69),('325','2013-05-17','18:10:00',1.58),('325','2013-05-17','18:15:00',1.47),('325','2013-05-17','18:20:00',1.36),('325','2013-05-17','18:25:00',1.19),('325','2013-05-17','18:30:00',1.01),('325','2013-05-16','09:20:00',1.19),('325','2013-05-16','09:25:00',1.52),('325','2013-05-16','09:30:00',1.48),('325','2013-05-16','09:35:00',1.73),('325','2013-05-16','09:40:00',2.02),('325','2013-05-16','09:45:00',2.45),('325','2013-05-16','09:50:00',1.36),('325','2013-05-16','09:55:00',1.35),('325','2013-05-16','10:00:00',1.67),('325','2013-05-16','10:05:00',1.31),('325','2013-05-16','10:10:00',1.29),('325','2013-05-16','10:15:00',1.61),('325','2013-05-16','10:20:00',2.06),('325','2013-05-16','10:25:00',1.85),('325','2013-05-16','10:30:00',2.09),('325','2013-05-16','10:35:00',1.49),('325','2013-05-16','10:40:00',1.44),('325','2013-05-16','10:45:00',1.27),('325','2013-05-16','10:50:00',1.46),('325','2013-05-16','10:55:00',1.67),('325','2013-05-16','11:00:00',4.3),('325','2013-05-16','11:05:00',3.76),('325','2013-05-16','11:10:00',3.26),('325','2013-05-16','11:15:00',2.35),('325','2013-05-16','11:20:00',1.23),('325','2013-05-16','11:25:00',1.26),('325','2013-05-16','11:30:00',1.59),('325','2013-05-16','11:35:00',2.99),('325','2013-05-16','11:40:00',3.87),('325','2013-05-16','11:45:00',3.65),('325','2013-05-16','11:50:00',3.98),('325','2013-05-16','11:55:00',2.8),('325','2013-05-16','12:00:00',1.94),('325','2013-05-16','12:05:00',1.87),('325','2013-05-16','12:10:00',1.86),('325','2013-05-16','12:15:00',2.65),('325','2013-05-16','12:20:00',2.06),('325','2013-05-16','12:25:00',2.18),('325','2013-05-16','12:30:00',3.44),('325','2013-05-16','12:35:00',3.75),('325','2013-05-16','12:40:00',4.92),('325','2013-05-16','12:45:00',3.46),('325','2013-05-16','12:50:00',3.16),('325','2013-05-16','12:55:00',4.27),('325','2013-05-16','13:00:00',4.6),('325','2013-05-16','13:05:00',4.52),('325','2013-05-16','13:10:00',4.36),('325','2013-05-16','13:15:00',4.39),('325','2013-05-16','13:20:00',3.52),('325','2013-05-16','13:25:00',4.48),('325','2013-05-16','13:30:00',4.4),('325','2013-05-16','13:35:00',4.37),('325','2013-05-16','13:40:00',4.31),('325','2013-05-16','13:45:00',4.26),('325','2013-05-16','13:50:00',4.28),('325','2013-05-16','13:55:00',4.23),('325','2013-05-16','14:00:00',4.15),('325','2013-05-16','14:05:00',4.12),('325','2013-05-16','14:10:00',4.11),('325','2013-05-16','14:15:00',4.21),('325','2013-05-16','14:20:00',4.17),('325','2013-05-16','14:25:00',4.1),('325','2013-05-16','14:30:00',4.08),('325','2013-05-16','14:35:00',4.03),('325','2013-05-16','14:40:00',3.98),('325','2013-05-16','14:45:00',3.97),('325','2013-05-16','14:50:00',3.57),('325','2013-05-16','14:55:00',3.59),('325','2013-05-16','15:00:00',3.92),('325','2013-05-16','15:05:00',3.91),('325','2013-05-16','15:10:00',3.58),('325','2013-05-16','15:15:00',3.49),('325','2013-05-16','15:20:00',3.71),('325','2013-05-16','15:25:00',3.65),('325','2013-05-16','15:30:00',3.56),('325','2013-05-16','15:35:00',3.47),('325','2013-05-16','15:40:00',3.56),('325','2013-05-16','15:45:00',3.46),('325','2013-05-16','15:50:00',3.43),('325','2013-05-16','15:55:00',3.4),('325','2013-05-16','16:00:00',3.36),('325','2013-05-16','16:05:00',3.18),('325','2013-05-16','16:10:00',3.22),('325','2013-05-16','16:15:00',2.96),('325','2013-05-16','16:20:00',3.17),('325','2013-05-16','16:25:00',3.04),('325','2013-05-16','16:30:00',3.01),('325','2013-05-16','16:35:00',2.87),('325','2013-05-16','16:40:00',1.77),('325','2013-05-16','16:45:00',1.52),('325','2013-05-16','16:50:00',2.07),('325','2013-05-16','16:55:00',1.95),('325','2013-05-16','17:00:00',1.69),('325','2013-05-16','17:15:00',1.48),('325','2013-05-16','17:20:00',1.63),('325','2013-05-16','17:25:00',1.71),('325','2013-05-16','17:30:00',2.07),('325','2013-05-16','17:35:00',1.89),('325','2013-05-16','17:40:00',1.55),('325','2013-05-16','17:45:00',1.07),('325','2013-05-16','18:50:00',1.02),('325','2013-05-16','18:55:00',1.01),('325','2013-05-16','19:00:00',1.04),('325','2013-05-15','08:35:00',1.1),('325','2013-05-15','08:40:00',1.14),('325','2013-05-15','08:45:00',1.17),('325','2013-05-15','08:50:00',1.25),('325','2013-05-15','08:55:00',1.34),('325','2013-05-15','09:00:00',1.31),('325','2013-05-15','09:05:00',1.41),('325','2013-05-15','09:10:00',1.42),('325','2013-05-15','09:15:00',1.45),('325','2013-05-15','09:20:00',2.05),('325','2013-05-15','09:25:00',2.55),('325','2013-05-15','09:30:00',2.7),('325','2013-05-15','09:35:00',2.76),('325','2013-05-15','09:40:00',2.77),('325','2013-05-15','09:45:00',2.87),('325','2013-05-15','09:50:00',2.98),('325','2013-05-15','09:55:00',3),('325','2013-05-15','10:00:00',3.1),('325','2013-05-15','10:05:00',3.16),('325','2013-05-15','10:10:00',3.23),('325','2013-05-15','10:15:00',3.31),('325','2013-05-15','10:20:00',3.5),('325','2013-05-15','10:25:00',3.64),('325','2013-05-15','10:30:00',3.52),('325','2013-05-15','10:35:00',3.68),('325','2013-05-15','10:40:00',3.82),('325','2013-05-15','10:45:00',3.95),('325','2013-05-15','10:50:00',3.96),('325','2013-05-15','10:55:00',3.84),('325','2013-05-15','11:00:00',3.83),('325','2013-05-15','11:05:00',4.07),('325','2013-05-15','11:10:00',4.1),('325','2013-05-15','11:15:00',4.16),('325','2013-05-15','11:20:00',3.95),('325','2013-05-15','11:25:00',4.18),('325','2013-05-15','11:30:00',4.04),('325','2013-05-15','11:35:00',3.99),('325','2013-05-15','11:40:00',3.34),('325','2013-05-15','11:45:00',3.09),('325','2013-05-15','11:50:00',2.85),('325','2013-05-15','11:55:00',2.09),('325','2013-05-15','12:00:00',2.43),('325','2013-05-15','12:05:00',3.48),('325','2013-05-15','12:10:00',5.1),('325','2013-05-15','12:15:00',4.93),('325','2013-05-15','12:20:00',3.87),('325','2013-05-15','12:25:00',4.15),('325','2013-05-15','12:30:00',3.06),('325','2013-05-15','12:35:00',3.84),('325','2013-05-15','12:40:00',4.89),('325','2013-05-15','12:45:00',2.68),('325','2013-05-15','12:50:00',2.65),('325','2013-05-15','12:55:00',2.96),('325','2013-05-15','13:00:00',2.91),('325','2013-05-15','13:05:00',4.03),('325','2013-05-15','13:10:00',2.94),('325','2013-05-15','13:15:00',2.74),('325','2013-05-15','13:20:00',2.92),('325','2013-05-15','13:25:00',3.01),('325','2013-05-15','13:30:00',2.91),('325','2013-05-15','13:35:00',2.55),('325','2013-05-15','13:40:00',2.81),('325','2013-05-15','13:45:00',2.7),('325','2013-05-15','13:50:00',2.27),('325','2013-05-15','13:55:00',2.24),('325','2013-05-15','14:00:00',1.9),('325','2013-05-15','14:05:00',1.68),('325','2013-05-15','14:10:00',1.81),('325','2013-05-15','14:15:00',1.76),('325','2013-05-15','14:20:00',1.92),('325','2013-05-15','14:25:00',1.72),('325','2013-05-15','14:30:00',1.52),('325','2013-05-15','14:35:00',1.54),('325','2013-05-15','14:40:00',1.71),('325','2013-05-15','14:45:00',1.56),('325','2013-05-15','14:50:00',1.53),('325','2013-05-15','14:55:00',1.55),('325','2013-05-15','15:00:00',1.48),('325','2013-05-15','15:05:00',1.15),('325','2013-05-15','15:45:00',1.26),('325','2013-05-15','15:50:00',1.71),('325','2013-05-15','15:55:00',2.19),('325','2013-05-15','16:00:00',2.03),('325','2013-05-15','16:05:00',1.91),('325','2013-05-15','16:10:00',1.67),('325','2013-05-15','16:15:00',1.48),('325','2013-05-15','16:20:00',1.62),('325','2013-05-15','16:25:00',1.63),('325','2013-05-15','16:30:00',1.41),('325','2013-05-15','16:35:00',1.31),('325','2013-05-15','16:40:00',1.25),('325','2013-05-15','16:45:00',1.22),('325','2013-05-15','16:50:00',1.27),('325','2013-05-15','16:55:00',1.48),('325','2013-05-15','17:00:00',1.84),('325','2013-05-15','17:05:00',2.08),('325','2013-05-15','17:10:00',2.8),('325','2013-05-15','17:15:00',2.91),('325','2013-05-15','17:20:00',1.68),('325','2013-05-15','17:25:00',1.02),('325','2013-05-15','17:30:00',1.09),('325','2013-05-14','08:15:00',1.01),('325','2013-05-14','08:20:00',1.06),('325','2013-05-14','08:25:00',1.11),('325','2013-05-14','08:30:00',1.18),('325','2013-05-14','08:35:00',1.24),('325','2013-05-14','08:40:00',1.3),('325','2013-05-14','08:45:00',1.34),('325','2013-05-14','08:50:00',1.34),('325','2013-05-14','08:55:00',1.33),('325','2013-05-14','09:00:00',1.34),('325','2013-05-14','09:05:00',1.36),('325','2013-05-14','09:10:00',1.38),('325','2013-05-14','09:15:00',1.45),('325','2013-05-14','09:20:00',2.55),('325','2013-05-14','09:25:00',2.81),('325','2013-05-14','09:30:00',2.87),('325','2013-05-14','09:35:00',2.93),('325','2013-05-14','09:40:00',3),('325','2013-05-14','09:45:00',3.07),('325','2013-05-14','09:50:00',3.18),('325','2013-05-14','09:55:00',3.22),('325','2013-05-14','10:00:00',3.3),('325','2013-05-14','10:05:00',3.36),('325','2013-05-14','10:10:00',3.53),('325','2013-05-14','10:15:00',3.64),('325','2013-05-14','10:20:00',3.78),('325','2013-05-14','10:25:00',3.81),('325','2013-05-14','10:30:00',3.83),('325','2013-05-14','10:35:00',3.92),('325','2013-05-14','10:40:00',3.98),('325','2013-05-14','10:45:00',4.11),('325','2013-05-14','10:50:00',4.14),('325','2013-05-14','10:55:00',4.16),('325','2013-05-14','11:00:00',4.21),('325','2013-05-14','11:05:00',4.27),('325','2013-05-14','11:10:00',4.3),('325','2013-05-14','11:15:00',4.29),('325','2013-05-14','11:20:00',4.31),('325','2013-05-14','11:25:00',4.35),('325','2013-05-14','11:30:00',4.36),('325','2013-05-14','11:35:00',4.38),('325','2013-05-14','11:40:00',4.42),('325','2013-05-14','11:45:00',4.46),('325','2013-05-14','11:50:00',4.5),('325','2013-05-14','11:55:00',4.56),('325','2013-05-14','12:00:00',4.56),('325','2013-05-14','12:05:00',4.52),('325','2013-05-14','12:10:00',4.59),('325','2013-05-14','12:15:00',4.63),('325','2013-05-14','12:20:00',4.67),('325','2013-05-14','12:25:00',4.65),('325','2013-05-14','12:30:00',4.64),('325','2013-05-14','12:35:00',4.68),('325','2013-05-14','12:40:00',4.71),('325','2013-05-14','12:45:00',4.71),('325','2013-05-14','12:50:00',4.69),('325','2013-05-14','12:55:00',4.71),('325','2013-05-14','13:00:00',4.69),('325','2013-05-14','13:05:00',4.68),('325','2013-05-14','13:10:00',4.68),('325','2013-05-14','13:15:00',4.69),('325','2013-05-14','13:20:00',4.67),('325','2013-05-14','13:25:00',4.67),('325','2013-05-14','13:30:00',4.64),('325','2013-05-14','13:35:00',4.63),('325','2013-05-14','13:40:00',4.59),('325','2013-05-14','13:45:00',4.53),('325','2013-05-14','13:50:00',4.45),('325','2013-05-14','13:55:00',4.41),('325','2013-05-14','14:00:00',4.31),('325','2013-05-14','14:05:00',4.21),('325','2013-05-14','14:10:00',4.13),('325','2013-05-14','14:15:00',4.45),('325','2013-05-14','14:20:00',4.42),('325','2013-05-14','14:25:00',4.4),('325','2013-05-14','14:30:00',4.37),('325','2013-05-14','14:35:00',4.38),('325','2013-05-14','14:40:00',4.42),('325','2013-05-14','14:45:00',4.47),('325','2013-05-14','14:50:00',4.46),('325','2013-05-14','14:55:00',4.44),('325','2013-05-14','15:00:00',4.41),('325','2013-05-14','15:05:00',4.39),('325','2013-05-14','15:10:00',4.35),('325','2013-05-14','15:15:00',4.33),('325','2013-05-14','15:20:00',4.27),('325','2013-05-14','15:25:00',4.23),('325','2013-05-14','15:30:00',4.19),('325','2013-05-14','15:35:00',4.13),('325','2013-05-14','15:40:00',4.08),('325','2013-05-14','15:45:00',4.03),('325','2013-05-14','15:50:00',3.98),('325','2013-05-14','15:55:00',3.91),('325','2013-05-14','16:00:00',3.86),('325','2013-05-14','16:05:00',3.8),('325','2013-05-14','16:10:00',3.73),('325','2013-05-14','16:15:00',3.65),('325','2013-05-14','16:20:00',3.57),('325','2013-05-14','16:25:00',3.5),('325','2013-05-14','16:30:00',3.42),('325','2013-05-14','16:35:00',3.35),('325','2013-05-14','16:40:00',3.27),('325','2013-05-14','16:45:00',3.18),('325','2013-05-14','16:50:00',3.07),('325','2013-05-14','16:55:00',2.98),('325','2013-05-14','17:00:00',2.89),('325','2013-05-14','17:05:00',2.79),('325','2013-05-14','17:10:00',2.7),('325','2013-05-14','17:15:00',2.61),('325','2013-05-14','17:20:00',2.51),('325','2013-05-14','17:25:00',2.42),('325','2013-05-14','17:30:00',2.32),('325','2013-05-14','17:35:00',2.21),('325','2013-05-14','17:40:00',2.1),('325','2013-05-14','17:45:00',2),('325','2013-05-14','17:50:00',1.89),('325','2013-05-14','17:55:00',1.79),('325','2013-05-14','18:00:00',1.68),('325','2013-05-14','18:05:00',1.58),('325','2013-05-14','18:10:00',1.48),('325','2013-05-14','18:15:00',1.38),('325','2013-05-14','18:20:00',1.27),('325','2013-05-14','18:25:00',1.15),('325','2013-05-13','08:25:00',1.03),('325','2013-05-13','08:30:00',1.08),('325','2013-05-13','08:35:00',1.16),('325','2013-05-13','08:40:00',1.2),('325','2013-05-13','08:45:00',1.22),('325','2013-05-13','08:50:00',1.25),('325','2013-05-13','08:55:00',1.34),('325','2013-05-13','09:00:00',1.47),('325','2013-05-13','09:05:00',1.5),('325','2013-05-13','09:10:00',1.58),('325','2013-05-13','09:15:00',1.68),('325','2013-05-13','09:20:00',2.43),('325','2013-05-13','09:25:00',2.64),('325','2013-05-13','09:30:00',2.68),('325','2013-05-13','09:35:00',2.81),('325','2013-05-13','09:40:00',2.9),('325','2013-05-13','09:45:00',3.07),('325','2013-05-13','09:50:00',3.1),('325','2013-05-13','09:55:00',3.24),('325','2013-05-13','10:00:00',2.56),('325','2013-05-13','10:05:00',3.46),('325','2013-05-13','10:10:00',3.41),('325','2013-05-13','10:15:00',3.47),('325','2013-05-13','10:20:00',3.68),('325','2013-05-13','10:25:00',3.75),('325','2013-05-13','10:30:00',4.01),('325','2013-05-13','10:35:00',2.22),('325','2013-05-13','10:40:00',1.89),('325','2013-05-13','10:50:00',1.86),('325','2013-05-13','10:55:00',1.87),('325','2013-05-13','11:00:00',4.92),('325','2013-05-13','11:05:00',2.55),('325','2013-05-13','11:10:00',2.74),('325','2013-05-13','11:15:00',1.94),('325','2013-05-13','11:20:00',1.67),('325','2013-05-13','11:25:00',1.75),('325','2013-05-13','11:30:00',1.71),('325','2013-05-13','11:35:00',2.91),('325','2013-05-13','11:40:00',4.32),('325','2013-05-13','11:45:00',2.34),('325','2013-05-13','11:50:00',3.3),('325','2013-05-13','11:55:00',1.97),('325','2013-05-13','12:00:00',2.13),('325','2013-05-13','12:05:00',2.2),('325','2013-05-13','12:10:00',4.58),('325','2013-05-13','12:15:00',1.93),('325','2013-05-13','12:20:00',1.29),('325','2013-05-13','12:25:00',1.13),('325','2013-05-13','12:30:00',1.45),('325','2013-05-13','12:35:00',5.67),('325','2013-05-13','12:40:00',5.26),('325','2013-05-13','12:45:00',5.09),('325','2013-05-13','12:50:00',4.74),('325','2013-05-13','12:55:00',3.87),('325','2013-05-13','13:00:00',3.91),('325','2013-05-13','13:05:00',5.42),('325','2013-05-13','13:10:00',4.04),('325','2013-05-13','13:15:00',4.18),('325','2013-05-13','13:20:00',4.79),('325','2013-05-13','13:25:00',4.43),('325','2013-05-13','13:30:00',3.51),('325','2013-05-13','13:35:00',4.49),('325','2013-05-13','13:40:00',4.8),('325','2013-05-13','13:45:00',4.2),('325','2013-05-13','13:50:00',2.93),('325','2013-05-13','13:55:00',3.61),('325','2013-05-13','14:00:00',5.09),('325','2013-05-13','14:05:00',4.91),('325','2013-05-13','14:10:00',4.93),('325','2013-05-13','14:15:00',4.88),('325','2013-05-13','14:20:00',4.76),('325','2013-05-13','14:25:00',4.72),('325','2013-05-13','14:30:00',3.24),('325','2013-05-13','14:35:00',3.94),('325','2013-05-13','14:40:00',2.99),('325','2013-05-13','14:45:00',2.92),('325','2013-05-13','14:50:00',4.93),('325','2013-05-13','14:55:00',4.83),('325','2013-05-13','15:00:00',4.47),('325','2013-05-13','15:05:00',1.57),('325','2013-05-13','15:10:00',1.28),('325','2013-05-13','15:20:00',1.22),('325','2013-05-13','15:40:00',1.31),('325','2013-05-13','15:45:00',1.01),('325','2013-05-13','15:50:00',1.1),('325','2013-05-13','16:00:00',2.31),('325','2013-05-13','16:05:00',2.91),('325','2013-05-13','16:10:00',1.99),('325','2013-05-13','16:15:00',1.32),('325','2013-05-13','16:20:00',1.41),('325','2013-05-13','16:25:00',1.5),('325','2013-05-13','16:30:00',2.5),('325','2013-05-13','16:35:00',1.23),('325','2013-05-13','16:40:00',1.46),('325','2013-05-13','16:45:00',2.81),('325','2013-05-13','16:50:00',3.38),('325','2013-05-13','16:55:00',3.28),('325','2013-05-13','17:00:00',3.14),('325','2013-05-13','17:05:00',3.08),('325','2013-05-13','17:10:00',1.22),('325','2013-05-13','17:15:00',2.53),('325','2013-05-13','17:20:00',3.39),('325','2013-05-13','17:25:00',3.24),('325','2013-05-13','17:30:00',3.11),('325','2013-05-13','17:35:00',2.91),('325','2013-05-13','17:40:00',2.67),('325','2013-05-13','17:45:00',2.46),('325','2013-05-13','17:50:00',2.15),('325','2013-05-13','17:55:00',1.43),('325','2013-05-13','18:00:00',1.99),('325','2013-05-13','18:05:00',1.8),('325','2013-05-13','18:10:00',1.18),('325','2013-05-13','18:15:00',1.6),('325','2013-05-13','18:20:00',1.3),('325','2013-05-12','08:15:00',1.25),('325','2013-05-12','08:20:00',1.17),('325','2013-05-12','08:25:00',1.19),('325','2013-05-12','08:40:00',1.2),('325','2013-05-12','08:45:00',1.69),('325','2013-05-12','08:50:00',1.18),('325','2013-05-12','08:55:00',1.17),('325','2013-05-12','09:00:00',1.48),('325','2013-05-12','09:05:00',1.78),('325','2013-05-12','09:10:00',1.33),('325','2013-05-12','09:15:00',1.21),('325','2013-05-12','09:20:00',1.54),('325','2013-05-12','09:25:00',1.39),('325','2013-05-12','09:30:00',1.24),('325','2013-05-12','09:35:00',1.17),('325','2013-05-12','09:40:00',1.15),('325','2013-05-12','09:45:00',2.55),('325','2013-05-12','09:50:00',3.58),('325','2013-05-12','09:55:00',3.65),('325','2013-05-12','10:00:00',3.33),('325','2013-05-12','10:05:00',1.29),('325','2013-05-12','10:10:00',3.78),('325','2013-05-12','10:15:00',3.87),('325','2013-05-12','10:20:00',3.69),('325','2013-05-12','10:25:00',4.2),('325','2013-05-12','10:30:00',2.59),('325','2013-05-12','10:35:00',1.54),('325','2013-05-12','10:40:00',1.11),('325','2013-05-12','10:45:00',2.94),('325','2013-05-12','10:50:00',2.85),('325','2013-05-12','10:55:00',3.37),('325','2013-05-12','11:00:00',4.22),('325','2013-05-12','11:05:00',4.16),('325','2013-05-12','11:10:00',4.61),('325','2013-05-12','11:15:00',4.47),('325','2013-05-12','11:20:00',4.62),('325','2013-05-12','11:25:00',3.98),('325','2013-05-12','11:30:00',3.06),('325','2013-05-12','11:35:00',4.09),('325','2013-05-12','11:40:00',3.07),('325','2013-05-12','11:45:00',2.2),('325','2013-05-12','11:50:00',1.76),('325','2013-05-12','11:55:00',1.53),('325','2013-05-12','12:00:00',2.97),('325','2013-05-12','12:05:00',3.43),('325','2013-05-12','12:10:00',1.44),('325','2013-05-12','12:15:00',1.26),('325','2013-05-12','12:20:00',1.23),('325','2013-05-12','12:25:00',1.29),('325','2013-05-12','12:30:00',2.15),('325','2013-05-12','12:35:00',5.47),('325','2013-05-12','12:40:00',3.32),('325','2013-05-12','12:45:00',3.24),('325','2013-05-12','12:50:00',5.48),('325','2013-05-12','12:55:00',3.65),('325','2013-05-12','13:00:00',1.6),('325','2013-05-12','13:05:00',4.05),('325','2013-05-12','13:10:00',4.32),('325','2013-05-12','13:15:00',2.05),('325','2013-05-12','13:20:00',4.02),('325','2013-05-12','13:25:00',4.55),('325','2013-05-12','13:30:00',4.48),('325','2013-05-12','13:35:00',4.13),('325','2013-05-12','13:40:00',4.39),('325','2013-05-12','13:45:00',5.41),('325','2013-05-12','13:50:00',5.45),('325','2013-05-12','13:55:00',2.56),('325','2013-05-12','14:00:00',4.79),('325','2013-05-12','14:05:00',5.09),('325','2013-05-12','14:10:00',5.01),('325','2013-05-12','14:15:00',4),('325','2013-05-12','14:20:00',4.37),('325','2013-05-12','14:25:00',3.57),('325','2013-05-12','14:30:00',4.92),('325','2013-05-12','14:35:00',4.92),('325','2013-05-12','14:40:00',4.77),('325','2013-05-12','14:45:00',3.98),('325','2013-05-12','14:50:00',4.49),('325','2013-05-12','14:55:00',3.82),('325','2013-05-12','15:00:00',4.7),('325','2013-05-12','15:05:00',4.67),('325','2013-05-12','15:10:00',3.16),('325','2013-05-12','15:15:00',3.97),('325','2013-05-12','15:20:00',2.52),('325','2013-05-12','15:25:00',4.38),('325','2013-05-12','15:30:00',4.24),('325','2013-05-12','15:35:00',4.15),('325','2013-05-12','15:40:00',4.12),('325','2013-05-12','15:45:00',4.06),('325','2013-05-12','15:50:00',3.98),('325','2013-05-12','15:55:00',3.88),('325','2013-05-12','16:00:00',3.6),('325','2013-05-12','16:05:00',3.73),('325','2013-05-12','16:10:00',3.69),('325','2013-05-12','16:15:00',3.64),('325','2013-05-12','16:20:00',3.54),('325','2013-05-12','16:25:00',3.44),('325','2013-05-12','16:30:00',3.38),('325','2013-05-12','16:35:00',3.33),('325','2013-05-12','16:40:00',3.4),('325','2013-05-12','16:45:00',3.33),('325','2013-05-12','16:50:00',3.1),('325','2013-05-12','16:55:00',3.74),('325','2013-05-12','17:00:00',3.53),('325','2013-05-12','17:05:00',2.99),('325','2013-05-12','17:10:00',3.49),('325','2013-05-12','17:15:00',2.86),('325','2013-05-12','17:20:00',3.16),('325','2013-05-12','17:25:00',2.29),('325','2013-05-12','17:30:00',2.13),('325','2013-05-12','17:35:00',2.98),('325','2013-05-12','17:40:00',1.75),('325','2013-05-12','17:45:00',1.86),('325','2013-05-12','17:50:00',1.39),('325','2013-05-12','18:00:00',2.15),('325','2013-05-12','18:05:00',1.99),('325','2013-05-12','18:10:00',1.99),('325','2013-05-12','18:15:00',1.52),('325','2013-05-12','18:20:00',1.19),('325','2013-05-12','18:25:00',1.39),('325','2013-05-12','18:30:00',1.29),('325','2013-05-12','18:35:00',1.3),('325','2013-05-12','18:40:00',1.06),('325','2013-05-11','08:05:00',1.01),('325','2013-05-11','08:15:00',1.26),('325','2013-05-11','08:20:00',1.11),('325','2013-05-11','09:00:00',1.04),('325','2013-05-11','09:05:00',1.45),('325','2013-05-11','09:10:00',1.22),('325','2013-05-11','09:15:00',1.42),('325','2013-05-11','09:20:00',1.5),('325','2013-05-11','09:25:00',1.64),('325','2013-05-11','09:30:00',2),('325','2013-05-11','09:35:00',1.75),('325','2013-05-11','09:40:00',1.51),('325','2013-05-11','09:45:00',1.57),('325','2013-05-11','09:50:00',2.38),('325','2013-05-11','09:55:00',3.12),('325','2013-05-11','10:00:00',1.64),('325','2013-05-11','10:05:00',1.08),('325','2013-05-11','10:20:00',1.2),('325','2013-05-11','10:25:00',1.06),('325','2013-05-11','10:30:00',1.51),('325','2013-05-11','10:35:00',1.22),('325','2013-05-11','10:45:00',1.18),('325','2013-05-11','10:50:00',1.79),('325','2013-05-11','10:55:00',4.66),('325','2013-05-11','11:00:00',4.83),('325','2013-05-11','11:05:00',1.88),('325','2013-05-11','11:10:00',1.21),('325','2013-05-11','11:25:00',1.24),('325','2013-05-11','11:30:00',3.48),('325','2013-05-11','11:35:00',2.51),('325','2013-05-11','11:40:00',3.7),('325','2013-05-11','11:45:00',5.04),('325','2013-05-11','11:50:00',1.64),('325','2013-05-11','11:55:00',1.16),('325','2013-05-11','12:00:00',1.97),('325','2013-05-11','12:05:00',2.1),('325','2013-05-11','12:10:00',1.47),('325','2013-05-11','12:15:00',1.38),('325','2013-05-11','12:20:00',4.1),('325','2013-05-11','12:25:00',5.5),('325','2013-05-11','12:30:00',1.94),('325','2013-05-11','12:35:00',2.25),('325','2013-05-11','12:40:00',1.97),('325','2013-05-11','12:45:00',1.57),('325','2013-05-11','12:50:00',1.62),('325','2013-05-11','12:55:00',1.56),('325','2013-05-11','13:00:00',2.1),('325','2013-05-11','13:05:00',1.43),('325','2013-05-11','13:25:00',1.07),('325','2013-05-11','13:30:00',1.15),('325','2013-05-11','13:35:00',1.15),('325','2013-05-11','13:50:00',1.12),('325','2013-05-11','13:55:00',1.59),('325','2013-05-11','14:00:00',2.53),('325','2013-05-11','14:05:00',4.04),('325','2013-05-11','14:10:00',2.41),('325','2013-05-11','14:15:00',3.59),('325','2013-05-11','14:20:00',4.68),('325','2013-05-11','14:25:00',3.43),('325','2013-05-11','14:30:00',2.2),('325','2013-05-11','14:35:00',3.2),('325','2013-05-11','14:40:00',3.82),('325','2013-05-11','14:45:00',5.29),('325','2013-05-11','14:50:00',4.67),('325','2013-05-11','14:55:00',4.1),('325','2013-05-11','15:00:00',4.74),('325','2013-05-11','15:05:00',4.38),('325','2013-05-11','15:10:00',4.64),('325','2013-05-11','15:15:00',4.31),('325','2013-05-11','15:20:00',4.46),('325','2013-05-11','15:25:00',4.24),('325','2013-05-11','15:30:00',4.01),('325','2013-05-11','15:35:00',4.17),('325','2013-05-11','15:40:00',4.3),('325','2013-05-11','15:45:00',3.09),('325','2013-05-11','15:50:00',3.95),('325','2013-05-11','15:55:00',4.16),('325','2013-05-11','16:00:00',3.5),('325','2013-05-11','16:05:00',4.05),('325','2013-05-11','16:10:00',3.64),('325','2013-05-11','16:15:00',3.81),('325','2013-05-11','16:20:00',3.82),('325','2013-05-11','16:25:00',3.68),('325','2013-05-11','16:30:00',3.15),('325','2013-05-11','16:35:00',2.49),('325','2013-05-11','16:40:00',3.36),('325','2013-05-11','16:45:00',3.25),('325','2013-05-11','16:50:00',2.86),('325','2013-05-11','16:55:00',3.04),('325','2013-05-11','17:00:00',3.04),('325','2013-05-11','17:05:00',2),('325','2013-05-11','17:10:00',2.47),('325','2013-05-11','17:15:00',1.16),('325','2013-05-11','17:20:00',2.29),('325','2013-05-11','17:25:00',1.89),('325','2013-05-11','17:30:00',2.2),('325','2013-05-11','17:35:00',1.91),('325','2013-05-11','17:40:00',2.11),('325','2013-05-11','17:45:00',2.01),('325','2013-05-11','17:50:00',1.09),('325','2013-05-11','17:55:00',1.32),('325','2013-05-11','18:05:00',1.82),('325','2013-05-11','18:10:00',1.83),('325','2013-05-11','18:20:00',1.14),('325','2013-05-11','18:25:00',1.09),('325','2013-05-11','18:30:00',1.17),('325','2014-03-30','08:30:00',1.02),('325','2014-03-30','08:35:00',1.05),('325','2014-03-30','08:40:00',1.09),('325','2014-03-30','08:45:00',1.09),('325','2014-03-30','08:50:00',1.11),('325','2014-03-30','08:55:00',1.16),('325','2014-03-30','09:00:00',1.2),('325','2014-03-30','09:05:00',1.19),('325','2014-03-30','09:10:00',1.17),('325','2014-03-30','09:15:00',1.25),('325','2014-03-30','09:20:00',1.37),('325','2014-03-30','09:25:00',1.48),('325','2014-03-30','09:30:00',1.6),('325','2014-03-30','09:35:00',1.65),('325','2014-03-30','09:40:00',1.7),('325','2014-03-30','09:45:00',1.77),('325','2014-03-30','09:50:00',1.79),('325','2014-03-30','09:55:00',1.75),('325','2014-03-30','10:00:00',1.83),('325','2014-03-30','10:05:00',1.97),('325','2014-03-30','10:10:00',2),('325','2014-03-30','10:15:00',1.96),('325','2014-03-30','10:20:00',2.01),('325','2014-03-30','10:25:00',2.15),('325','2014-03-30','10:30:00',2.2),('325','2014-03-30','10:35:00',2.25),('325','2014-03-30','10:40:00',2.83),('325','2014-03-30','10:45:00',3.27),('325','2014-03-30','10:50:00',3.3),('325','2014-03-30','10:55:00',3.28),('325','2014-03-30','11:00:00',3.28),('325','2014-03-30','11:05:00',3.32),('325','2014-03-30','11:10:00',3.36),('325','2014-03-30','11:15:00',3.23),('325','2014-03-30','11:20:00',3.22),('325','2014-03-30','11:25:00',3.34),('325','2014-03-30','11:30:00',3.71),('325','2014-03-30','11:35:00',3.65),('325','2014-03-30','11:40:00',3.82),('325','2014-03-30','11:45:00',3.96),('325','2014-03-30','11:50:00',3.97),('325','2014-03-30','11:55:00',4.07),('325','2014-03-30','12:00:00',4.16),('325','2014-03-30','12:05:00',4.35),('325','2014-03-30','12:10:00',4.4),('325','2014-03-30','12:15:00',4.47),('325','2014-03-30','12:20:00',4.4),('325','2014-03-30','12:25:00',4.41),('325','2014-03-30','12:30:00',4.12),('325','2014-03-30','12:35:00',4.08),('325','2014-03-30','12:40:00',4.3),('325','2014-03-30','12:45:00',4.22),('325','2014-03-30','12:50:00',4.28),('325','2014-03-30','12:55:00',4.36),('325','2014-03-30','13:00:00',4.44),('325','2014-03-30','13:05:00',4.52),('325','2014-03-30','13:10:00',4.45),('325','2014-03-30','13:15:00',4.48),('325','2014-03-30','13:20:00',4.49),('325','2014-03-30','13:25:00',4.48),('325','2014-03-30','13:30:00',4.46),('325','2014-03-30','13:35:00',4.5),('325','2014-03-30','13:40:00',4.53),('325','2014-03-30','13:45:00',4.55),('325','2014-03-30','13:50:00',4.49),('325','2014-03-30','13:55:00',4.37),('325','2014-03-30','14:00:00',4.39),('325','2014-03-30','14:05:00',4.29),('325','2014-03-30','14:10:00',4.2),('325','2014-03-30','14:15:00',4.2),('325','2014-03-30','14:20:00',4.3),('325','2014-03-30','14:25:00',4.42),('325','2014-03-30','14:30:00',4.26),('325','2014-03-30','14:35:00',3.64),('325','2014-03-30','14:40:00',3.56),('325','2014-03-30','14:45:00',3.38),('325','2014-03-30','14:50:00',2.53),('325','2014-03-30','14:55:00',1.68),('325','2014-03-30','15:00:00',2.35),('325','2014-03-30','15:05:00',2.62),('325','2014-03-30','15:10:00',2.44),('325','2014-03-30','15:15:00',3.23),('325','2014-03-30','15:20:00',3.38),('325','2014-03-30','15:25:00',3.55),('325','2014-03-30','15:30:00',3.56),('325','2014-03-30','15:35:00',3.46),('325','2014-03-30','15:40:00',3.5),('325','2014-03-30','15:45:00',3.51),('325','2014-03-30','15:50:00',3.46),('325','2014-03-30','15:55:00',3.29),('325','2014-03-30','16:00:00',2.86),('325','2014-03-30','16:05:00',2.89),('325','2014-03-30','16:10:00',2.76),('325','2014-03-30','16:15:00',3.02),('325','2014-03-30','16:20:00',3.08),('325','2014-03-30','16:25:00',3),('325','2014-03-30','16:30:00',2.92),('325','2014-03-30','16:35:00',2.94),('325','2014-03-30','16:40:00',2.67),('325','2014-03-30','16:45:00',2.43),('325','2014-03-30','16:50:00',2.13),('325','2014-03-30','16:55:00',2.03),('325','2014-03-30','17:00:00',2.21),('325','2014-03-30','17:05:00',2.28),('325','2014-03-30','17:10:00',2.33),('325','2014-03-30','17:15:00',2.24),('325','2014-03-30','17:20:00',2.1),('325','2014-03-30','17:25:00',1.83),('325','2014-03-30','17:30:00',1.82),('325','2014-03-30','17:35:00',1.71),('325','2014-03-30','17:40:00',1.53),('325','2014-03-30','17:45:00',1.51),('325','2014-03-30','17:50:00',1.3),('325','2013-05-10','08:00:00',1.09),('325','2013-05-10','08:05:00',1.4),('325','2013-05-10','08:10:00',1.49),('325','2013-05-10','08:15:00',1.55),('325','2013-05-10','08:20:00',1.47),('325','2013-05-10','08:25:00',1.41),('325','2013-05-10','08:30:00',1.39),('325','2013-05-10','08:35:00',1.31),('325','2013-05-10','09:00:00',1.1),('325','2013-05-10','09:05:00',1.53),('325','2013-05-10','09:10:00',1.7),('325','2013-05-10','09:15:00',2.34),('325','2013-05-10','09:20:00',2.37),('325','2013-05-10','09:25:00',2.27),('325','2013-05-10','09:30:00',2.37),('325','2013-05-10','09:35:00',2.72),('325','2013-05-10','09:40:00',2.5),('325','2013-05-10','09:45:00',2.49),('325','2013-05-10','09:50:00',2.87),('325','2013-05-10','09:55:00',1.69),('325','2013-05-10','10:00:00',1.4),('325','2013-05-10','10:05:00',1.41),('325','2013-05-10','10:10:00',1.04),('325','2013-05-10','10:15:00',1.61),('325','2013-05-10','10:20:00',3.95),('325','2013-05-10','10:25:00',3.69),('325','2013-05-10','10:30:00',3.97),('325','2013-05-10','10:35:00',4.03),('325','2013-05-10','10:40:00',4.03),('325','2013-05-10','10:45:00',4.02),('325','2013-05-10','10:50:00',4.12),('325','2013-05-10','10:55:00',4.26),('325','2013-05-10','11:00:00',4.21),('325','2013-05-10','11:05:00',4.15),('325','2013-05-10','11:10:00',4.3),('325','2013-05-10','11:15:00',4.44),('325','2013-05-10','11:20:00',4.59),('325','2013-05-10','11:25:00',3.79),('325','2013-05-10','11:30:00',3.94),('325','2013-05-10','11:35:00',3.01),('325','2013-05-10','11:40:00',4.24),('325','2013-05-10','11:45:00',3.4),('325','2013-05-10','11:50:00',4.09),('325','2013-05-10','11:55:00',3.86),('325','2013-05-10','12:00:00',1.99),('325','2013-05-10','12:05:00',1.96),('325','2013-05-10','12:10:00',2.12),('325','2013-05-10','12:15:00',3.15),('325','2013-05-10','12:20:00',3.06),('325','2013-05-10','12:25:00',2.22),('325','2013-05-10','12:30:00',2.3),('325','2013-05-10','12:35:00',2.62),('325','2013-05-10','12:40:00',4.2),('325','2013-05-10','12:45:00',4.91),('325','2013-05-10','12:50:00',3.14),('325','2013-05-10','12:55:00',4.18),('325','2013-05-10','13:00:00',4.3),('325','2013-05-10','13:05:00',4.85),('325','2013-05-10','13:10:00',5.67),('325','2013-05-10','13:15:00',4.54),('325','2013-05-10','13:20:00',3.53),('325','2013-05-10','13:25:00',3.11),('325','2013-05-10','13:30:00',4.04),('325','2013-05-10','13:35:00',4.12),('325','2013-05-10','13:40:00',4.27),('325','2013-05-10','13:45:00',4.09),('325','2013-05-10','13:50:00',2.34),('325','2013-05-10','13:55:00',2.22),('325','2013-05-10','14:00:00',2.06),('325','2013-05-10','14:05:00',2.29),('325','2013-05-10','14:10:00',2.82),('325','2013-05-10','14:15:00',2.91),('325','2013-05-10','14:20:00',2.71),('325','2013-05-10','14:25:00',2.82),('325','2013-05-10','14:30:00',2.82),('325','2013-05-10','14:35:00',3.32),('325','2013-05-10','14:40:00',2.87),('325','2013-05-10','14:45:00',1.9),('325','2013-05-10','14:50:00',1.43),('325','2013-05-10','14:55:00',1.31),('325','2013-05-10','15:00:00',1.29),('325','2013-05-10','15:05:00',1.53),('325','2013-05-10','15:10:00',2.3),('325','2013-05-10','15:15:00',3.7),('325','2013-05-10','15:20:00',2.58),('325','2013-05-10','15:25:00',2.12),('325','2013-05-10','15:30:00',2.11),('325','2013-05-10','15:35:00',2.18),('325','2013-05-10','15:40:00',2.27),('325','2013-05-10','15:45:00',2.1),('325','2013-05-10','15:50:00',1.88),('325','2013-05-10','15:55:00',1.78),('325','2013-05-10','16:00:00',1.75),('325','2013-05-10','16:05:00',1.68),('325','2013-05-10','16:10:00',1.62),('325','2013-05-10','16:15:00',1.47),('325','2013-05-10','16:20:00',1.38),('325','2013-05-10','16:25:00',1.43),('325','2013-05-10','16:30:00',1.6),('325','2013-05-10','16:35:00',1.64),('325','2013-05-10','16:40:00',1.53),('325','2013-05-10','16:45:00',1.56),('325','2013-05-10','16:50:00',1.39),('325','2013-05-10','16:55:00',1.11),('325','2013-05-10','17:05:00',1.05),('325','2013-05-10','17:10:00',1.48),('325','2013-05-10','17:15:00',1.73),('325','2013-05-10','17:20:00',2.62),('325','2013-05-10','17:25:00',2.42),('325','2013-05-10','17:30:00',2.23),('325','2013-05-10','17:35:00',2.33),('325','2013-05-10','17:40:00',1.47),('325','2013-05-10','17:45:00',1.53),('325','2013-05-10','17:50:00',1.18),('325','2013-05-10','17:55:00',1.07),('325','2013-05-09','08:20:00',1.01),('325','2013-05-09','08:25:00',1.06),('325','2013-05-09','08:30:00',1.12),('325','2013-05-09','08:35:00',1.18),('325','2013-05-09','08:40:00',1.24),('325','2013-05-09','08:45:00',1.3),('325','2013-05-09','08:50:00',1.33),('325','2013-05-09','08:55:00',1.34),('325','2013-05-09','09:00:00',1.35),('325','2013-05-09','09:05:00',1.36),('325','2013-05-09','09:10:00',2.18),('325','2013-05-09','09:15:00',2.35),('325','2013-05-09','09:20:00',2.45),('325','2013-05-09','09:25:00',2.53),('325','2013-05-09','09:30:00',2.62),('325','2013-05-09','09:35:00',2.67),('325','2013-05-09','09:40:00',2.76),('325','2013-05-09','09:45:00',2.84),('325','2013-05-09','09:50:00',3.09),('325','2013-05-09','09:55:00',3.16),('325','2013-05-09','10:00:00',3.2),('325','2013-05-09','10:05:00',3.33),('325','2013-05-09','10:10:00',3.37),('325','2013-05-09','10:15:00',3.4),('325','2013-05-09','10:20:00',3.42),('325','2013-05-09','10:25:00',3.43),('325','2013-05-09','10:30:00',3.51),('325','2013-05-09','10:35:00',3.68),('325','2013-05-09','10:40:00',3.88),('325','2013-05-09','10:45:00',3.97),('325','2013-05-09','10:50:00',4.01),('325','2013-05-09','10:55:00',4.07),('325','2013-05-09','11:00:00',4.1),('325','2013-05-09','11:05:00',4.13),('325','2013-05-09','11:10:00',4.17),('325','2013-05-09','11:15:00',4.22),('325','2013-05-09','11:20:00',4.23),('325','2013-05-09','11:25:00',4.27),('325','2013-05-09','11:30:00',4.31),('325','2013-05-09','11:35:00',4.33),('325','2013-05-09','11:40:00',4.34),('325','2013-05-09','11:45:00',4.44),('325','2013-05-09','11:50:00',4.46),('325','2013-05-09','11:55:00',4.49),('325','2013-05-09','12:00:00',4.52),('325','2013-05-09','12:05:00',4.52),('325','2013-05-09','12:10:00',4.47),('325','2013-05-09','12:15:00',4.46),('325','2013-05-09','12:20:00',4.46),('325','2013-05-09','12:25:00',4.5),('325','2013-05-09','12:30:00',4.52),('325','2013-05-09','12:35:00',4.52),('325','2013-05-09','12:40:00',4.53),('325','2013-05-09','12:45:00',4.65),('325','2013-05-09','12:50:00',4.69),('325','2013-05-09','12:55:00',4.69),('325','2013-05-09','13:00:00',4.61),('325','2013-05-09','13:05:00',4.55),('325','2013-05-09','13:10:00',4.47),('325','2013-05-09','13:15:00',4.46),('325','2013-05-09','13:20:00',4.41),('325','2013-05-09','13:25:00',4.34),('325','2013-05-09','13:30:00',4.39),('325','2013-05-09','13:35:00',4.44),('325','2013-05-09','13:40:00',4.48),('325','2013-05-09','13:45:00',4.65),('325','2013-05-09','13:50:00',4.63),('325','2013-05-09','13:55:00',4.66),('325','2013-05-09','14:00:00',4.23),('325','2013-05-09','14:05:00',1.95),('325','2013-05-09','14:10:00',4.95),('325','2013-05-09','14:15:00',3.78),('325','2013-05-09','14:20:00',2.79),('325','2013-05-09','14:25:00',4.19),('325','2013-05-09','14:30:00',4.64),('325','2013-05-09','14:35:00',4.56),('325','2013-05-09','14:40:00',4.46),('325','2013-05-09','14:45:00',4.42),('325','2013-05-09','14:50:00',4.37),('325','2013-05-09','14:55:00',4.43),('325','2013-05-09','15:00:00',4.36),('325','2013-05-09','15:05:00',4.32),('325','2013-05-09','15:10:00',4.26),('325','2013-05-09','15:15:00',4.2),('325','2013-05-09','15:20:00',4.15),('325','2013-05-09','15:25:00',4.11),('325','2013-05-09','15:30:00',4.05),('325','2013-05-09','15:35:00',4.02),('325','2013-05-09','15:40:00',3.98),('325','2013-05-09','15:45:00',3.95),('325','2013-05-09','15:50:00',3.9),('325','2013-05-09','15:55:00',3.83),('325','2013-05-09','16:00:00',3.76),('325','2013-05-09','16:05:00',3.72),('325','2013-05-09','16:10:00',3.63),('325','2013-05-09','16:15:00',3.53),('325','2013-05-09','16:20:00',3.47),('325','2013-05-09','16:25:00',3.39),('325','2013-05-09','16:30:00',3.33),('325','2013-05-09','16:35:00',3.25),('325','2013-05-09','16:40:00',3.14),('325','2013-05-09','16:45:00',3.04),('325','2013-05-09','16:50:00',2.91),('325','2013-05-09','16:55:00',2.8),('325','2013-05-09','17:00:00',2.76),('325','2013-05-09','17:05:00',2.65),('325','2013-05-09','17:10:00',2.57),('325','2013-05-09','17:15:00',2.49),('325','2013-05-09','17:20:00',2.41),('325','2013-05-09','17:25:00',2.31),('325','2013-05-09','17:30:00',2.21),('325','2013-05-09','17:35:00',2.06),('325','2013-05-09','17:40:00',1.98),('325','2013-05-09','17:45:00',1.89),('325','2013-05-09','17:50:00',1.78),('325','2013-05-09','17:55:00',1.7),('325','2013-05-09','18:00:00',1.58),('325','2013-05-09','18:05:00',1.48),('325','2013-05-09','18:10:00',1.38),('325','2013-05-09','18:15:00',1.3),('325','2013-05-09','18:20:00',1.2),('325','2013-05-09','18:25:00',1.08),('325','2013-05-08','08:20:00',1.03),('325','2013-05-08','08:25:00',1.05),('325','2013-05-08','08:30:00',1.07),('325','2013-05-08','08:35:00',1.22),('325','2013-05-08','08:40:00',1.39),('325','2013-05-08','08:45:00',1.58),('325','2013-05-08','08:50:00',1.39),('325','2013-05-08','08:55:00',1.14),('325','2013-05-08','09:35:00',2.48),('325','2013-05-08','09:40:00',3.03),('325','2013-05-08','09:45:00',2.99),('325','2013-05-08','09:50:00',3.04),('325','2013-05-08','09:55:00',1.95),('325','2013-05-08','10:00:00',1.62),('325','2013-05-08','10:05:00',3.98),('325','2013-05-08','10:10:00',1.91),('325','2013-05-08','10:20:00',1.04),('325','2013-05-08','10:30:00',1.01),('325','2013-05-08','10:35:00',1.01),('325','2013-05-08','10:40:00',1.02),('325','2013-05-08','10:50:00',1.9),('325','2013-05-08','10:55:00',3.13),('325','2013-05-08','11:00:00',2.38),('325','2013-05-08','11:05:00',3.76),('325','2013-05-08','11:10:00',2.61),('325','2013-05-08','11:15:00',1.54),('325','2013-05-08','11:20:00',3.73),('325','2013-05-08','11:25:00',4.67),('325','2013-05-08','11:30:00',4.01),('325','2013-05-08','11:35:00',4.35),('325','2013-05-08','11:40:00',1.92),('325','2013-05-08','11:45:00',2.54),('325','2013-05-08','11:50:00',1.93),('325','2013-05-08','11:55:00',5.08),('325','2013-05-08','12:00:00',1.72),('325','2013-05-08','12:15:00',1.32),('325','2013-05-08','12:20:00',3.21),('325','2013-05-08','12:25:00',2.23),('325','2013-05-08','12:30:00',1.35),('325','2013-05-08','12:35:00',1.92),('325','2013-05-08','12:40:00',1.28),('325','2013-05-08','12:45:00',1.21),('325','2013-05-08','12:50:00',2.85),('325','2013-05-08','12:55:00',2.35),('325','2013-05-08','13:00:00',1.7),('325','2013-05-08','13:05:00',2.22),('325','2013-05-08','13:10:00',5.63),('325','2013-05-08','13:15:00',1.9),('325','2013-05-08','13:20:00',1.3),('325','2013-05-08','13:25:00',2.82),('325','2013-05-08','13:30:00',1.23),('325','2013-05-08','13:35:00',1.15),('325','2013-05-08','13:40:00',3.58),('325','2013-05-08','13:45:00',5.32),('325','2013-05-08','13:50:00',5.45),('325','2013-05-08','13:55:00',4.85),('325','2013-05-08','14:00:00',4.54),('325','2013-05-08','14:05:00',4.49),('325','2013-05-08','14:10:00',1.73),('325','2013-05-08','14:15:00',2.56),('325','2013-05-08','14:20:00',1.88),('325','2013-05-08','14:25:00',2.06),('325','2013-05-08','14:30:00',4.28),('325','2013-05-08','14:35:00',3.21),('325','2013-05-08','14:40:00',4.65),('325','2013-05-08','14:45:00',2.17),('325','2013-05-08','14:50:00',4.68),('325','2013-05-08','14:55:00',3.75),('325','2013-05-08','15:00:00',4.35),('325','2013-05-08','15:05:00',4.45),('325','2013-05-08','15:10:00',4.35),('325','2013-05-08','15:15:00',4.31),('325','2013-05-08','15:20:00',4.23),('325','2013-05-08','15:25:00',4.21),('325','2013-05-08','15:30:00',4.15),('325','2013-05-08','15:35:00',4.08),('325','2013-05-08','15:40:00',4),('325','2013-05-08','15:45:00',3.95),('325','2013-05-08','15:50:00',3.93),('325','2013-05-08','15:55:00',3.87),('325','2013-05-08','16:00:00',3.86),('325','2013-05-08','16:05:00',3.76),('325','2013-05-08','16:10:00',3.29),('325','2013-05-08','16:15:00',3.65),('325','2013-05-08','16:20:00',3.53),('325','2013-05-08','16:25:00',3.49),('325','2013-05-08','16:30:00',3.48),('325','2013-05-08','16:35:00',3.42),('325','2013-05-08','16:40:00',2.36),('325','2013-05-08','16:45:00',3.17),('325','2013-05-08','16:50:00',2.07),('325','2013-05-08','16:55:00',2.79),('325','2013-05-08','17:00:00',3.06),('325','2013-05-08','17:05:00',2.99),('325','2013-05-08','17:10:00',2.87),('325','2013-05-08','17:15:00',2.64),('325','2013-05-08','17:20:00',2.06),('325','2013-05-08','17:25:00',2.46),('325','2013-05-08','17:30:00',2.51),('325','2013-05-08','17:35:00',2.33),('325','2013-05-08','17:40:00',2.13),('325','2013-05-08','17:45:00',2.41),('325','2013-05-08','17:50:00',2.41),('325','2013-05-08','17:55:00',2.31),('325','2013-05-08','18:00:00',1.25),('325','2013-05-08','18:10:00',1.04),('325','2013-05-08','18:15:00',1.69),('325','2013-05-08','18:20:00',1.58),('325','2013-05-08','18:25:00',1.38),('325','2013-05-08','18:30:00',1.15),('325','2013-05-07','08:20:00',1.02),('325','2013-05-07','08:25:00',1.07),('325','2013-05-07','08:30:00',1.12),('325','2013-05-07','08:35:00',1.21),('325','2013-05-07','08:40:00',1.28),('325','2013-05-07','08:45:00',1.37),('325','2013-05-07','08:50:00',1.29),('325','2013-05-07','08:55:00',1.03),('325','2013-05-07','09:05:00',1.13),('325','2013-05-07','09:10:00',1.22),('325','2013-05-07','09:15:00',1.06),('325','2013-05-07','09:20:00',1.6),('325','2013-05-07','09:30:00',1.63),('325','2013-05-07','09:35:00',1.67),('325','2013-05-07','09:40:00',2.08),('325','2013-05-07','09:45:00',1.99),('325','2013-05-07','09:50:00',1.43),('325','2013-05-07','09:55:00',1.19),('325','2013-05-07','10:50:00',1.18),('325','2013-05-07','10:55:00',1.42),('325','2013-05-07','11:00:00',1.54),('325','2013-05-07','11:05:00',1.54),('325','2013-05-07','11:10:00',2.26),('325','2013-05-07','11:15:00',1.52),('325','2013-05-07','11:20:00',3.23),('325','2013-05-07','11:55:00',4.05),('325','2013-05-07','12:00:00',4.48),('325','2013-05-07','12:05:00',5.32),('325','2013-05-07','12:10:00',5.3),('325','2013-05-07','12:15:00',5.32),('325','2013-05-07','12:20:00',5.17),('325','2013-05-07','12:25:00',1.55),('325','2013-05-07','12:30:00',1.02),('325','2013-05-07','13:05:00',1.17),('325','2013-05-07','13:10:00',1.47),('325','2013-05-07','13:15:00',1.55),('325','2013-05-07','13:20:00',1.5),('325','2013-05-07','13:25:00',2.66),('325','2013-05-07','13:30:00',3.25),('325','2013-05-07','13:35:00',5.86),('325','2013-05-07','13:40:00',5.65),('325','2013-05-07','13:45:00',5.34),('325','2013-05-07','13:50:00',5.1),('325','2013-05-07','13:55:00',2.03),('325','2013-05-07','14:00:00',4.53),('325','2013-05-07','14:05:00',4.53),('325','2013-05-07','14:10:00',3.52),('325','2013-05-07','14:15:00',5),('325','2013-05-07','14:20:00',1.63),('325','2013-05-07','14:25:00',3.69),('325','2013-05-07','14:30:00',3.03),('325','2013-05-07','14:35:00',3.14),('325','2013-05-07','14:40:00',4.04),('325','2013-05-07','14:45:00',2.14),('325','2013-05-07','14:50:00',5.15),('325','2013-05-07','14:55:00',3.27),('325','2013-05-07','15:00:00',3.7),('325','2013-05-07','15:05:00',4.56),('325','2013-05-07','15:10:00',4.32),('325','2013-05-07','15:15:00',4.35),('325','2013-05-07','15:20:00',4.79),('325','2013-05-07','15:25:00',3.24),('325','2013-05-07','15:30:00',2.56),('325','2013-05-07','15:35:00',3.95),('325','2013-05-07','15:40:00',3.18),('325','2013-05-07','15:45:00',3.45),('325','2013-05-07','15:50:00',2.04),('325','2013-05-07','15:55:00',2.63),('325','2013-05-07','16:00:00',4.42),('325','2013-05-07','16:05:00',1.44),('325','2013-05-07','16:10:00',2.07),('325','2013-05-07','16:15:00',3.81),('325','2013-05-07','16:20:00',4.46),('325','2013-05-07','16:25:00',4.33),('325','2013-05-07','16:30:00',4.07),('325','2013-05-07','16:35:00',3.99),('325','2013-05-07','16:40:00',3.56),('325','2013-05-07','16:45:00',3.63),('325','2013-05-07','16:50:00',2.85),('325','2013-05-07','16:55:00',2.72),('325','2013-05-07','17:00:00',3.03),('325','2013-05-07','17:05:00',2.85),('325','2013-05-07','17:10:00',1.34),('325','2013-05-07','17:15:00',1.26),('325','2013-05-07','17:20:00',1.36),('325','2013-05-07','17:25:00',1.29),('325','2013-05-07','17:30:00',1.17),('325','2013-05-07','17:35:00',1.07),('325','2013-05-06','08:25:00',1.22),('325','2013-05-06','08:30:00',1.22),('325','2013-05-06','08:35:00',1.15),('325','2013-05-06','08:40:00',1.06),('325','2013-05-06','08:50:00',1.46),('325','2013-05-06','08:55:00',2.09),('325','2013-05-06','09:00:00',2.06),('325','2013-05-06','09:05:00',1.54),('325','2013-05-06','09:10:00',1.36),('325','2013-05-06','09:15:00',1.35),('325','2013-05-06','09:20:00',1.61),('325','2013-05-06','09:25:00',1.3),('325','2013-05-06','09:55:00',1.2),('325','2013-05-06','10:00:00',1.58),('325','2013-05-06','10:05:00',1.14),('325','2013-05-06','10:10:00',1.07),('325','2013-05-06','10:15:00',1.47),('325','2013-05-06','10:20:00',2.66),('325','2013-05-06','10:25:00',2.11),('325','2013-05-06','10:30:00',2.08),('325','2013-05-06','10:35:00',2.09),('325','2013-05-06','10:40:00',1.99),('325','2013-05-06','10:45:00',2.52),('325','2013-05-06','10:50:00',2.08),('325','2013-05-06','10:55:00',1.88),('325','2013-05-06','11:00:00',1.79),('325','2013-05-06','11:05:00',2.04),('325','2013-05-06','11:10:00',2.06),('325','2013-05-06','11:15:00',1.81),('325','2013-05-06','11:20:00',2.25),('325','2013-05-06','11:25:00',2.13),('325','2013-05-06','11:30:00',1.31),('325','2013-05-06','11:35:00',2.09),('325','2013-05-06','11:40:00',2.35),('325','2013-05-06','11:45:00',3.97),('325','2013-05-06','11:50:00',1.97),('325','2013-05-06','11:55:00',1.78),('325','2013-05-06','12:00:00',2.52),('325','2013-05-06','12:05:00',2.2),('325','2013-05-06','12:10:00',2.66),('325','2013-05-06','12:15:00',2.59),('325','2013-05-06','12:20:00',2.52),('325','2013-05-06','12:25:00',4.14),('325','2013-05-06','12:30:00',4.4),('325','2013-05-06','12:35:00',4.08),('325','2013-05-06','12:40:00',2.06),('325','2013-05-06','12:45:00',2.85),('325','2013-05-06','12:50:00',4.63),('325','2013-05-06','12:55:00',2.66),('325','2013-05-06','13:00:00',2.28),('325','2013-05-06','13:05:00',4.7),('325','2013-05-06','13:10:00',3.93),('325','2013-05-06','13:15:00',4.32),('325','2013-05-06','13:20:00',3.68),('325','2013-05-06','13:25:00',4.09),('325','2013-05-06','13:30:00',2.71),('325','2013-05-06','13:35:00',4.01),('325','2013-05-06','13:40:00',3.7),('325','2013-05-06','13:45:00',4.47),('325','2013-05-06','13:50:00',4.9),('325','2013-05-06','13:55:00',5.05),('325','2013-05-06','14:00:00',3.83),('325','2013-05-06','14:05:00',3.86),('325','2013-05-06','14:10:00',2.91),('325','2013-05-06','14:15:00',4.27),('325','2013-05-06','14:20:00',4.99),('325','2013-05-06','14:25:00',2.84),('325','2013-05-06','14:30:00',4.43),('325','2013-05-06','14:35:00',4.51),('325','2013-05-06','14:40:00',3.1),('325','2013-05-06','14:45:00',2.7),('325','2013-05-06','14:50:00',2.71),('325','2013-05-06','14:55:00',5.06),('325','2013-05-06','15:00:00',3.63),('325','2013-05-06','15:05:00',2.92),('325','2013-05-06','15:10:00',3.94),('325','2013-05-06','15:15:00',3.03),('325','2013-05-06','15:20:00',2.48),('325','2013-05-06','15:25:00',2.55),('325','2013-05-06','15:30:00',2.28),('325','2013-05-06','15:35:00',2.59),('325','2013-05-06','15:40:00',1.36),('325','2013-05-06','15:45:00',1.74),('325','2013-05-06','15:50:00',2.42),('325','2013-05-06','15:55:00',1.34),('325','2013-05-06','16:00:00',2.41),('325','2013-05-06','16:05:00',1.65),('325','2013-05-06','16:10:00',1.5),('325','2013-05-06','16:15:00',1.85),('325','2013-05-06','16:20:00',2.39),('325','2013-05-06','16:25:00',2.49),('325','2013-05-06','16:30:00',1.81),('325','2013-05-06','16:35:00',2.57),('325','2013-05-06','16:40:00',2.39),('325','2013-05-06','16:45:00',2.36),('325','2013-05-06','16:50:00',3.32),('325','2013-05-06','16:55:00',2.4),('325','2013-05-06','17:15:00',1.57),('325','2013-05-06','17:20:00',1.02),('325','2013-05-06','17:25:00',1.03),('325','2013-05-06','17:35:00',1.62),('325','2013-05-06','17:40:00',1.8),('325','2013-05-06','17:45:00',1.36),('325','2013-05-06','17:50:00',1.16),('325','2013-05-06','17:55:00',1.58),('325','2013-05-06','18:00:00',1.56),('325','2013-05-06','18:05:00',1.76),('325','2013-05-06','18:15:00',1.46),('325','2013-05-06','18:20:00',1.67),('325','2013-05-06','18:25:00',1.26),('325','2013-05-05','08:15:00',1.03),('325','2013-05-05','08:20:00',1.3),('325','2013-05-05','08:25:00',1.67),('325','2013-05-05','08:30:00',1.79),('325','2013-05-05','08:35:00',1.62),('325','2013-05-05','08:40:00',1.65),('325','2013-05-05','08:45:00',1.39),('325','2013-05-05','08:50:00',1.2),('325','2013-05-05','08:55:00',1.32),('325','2013-05-05','09:00:00',1.36),('325','2013-05-05','09:05:00',1.32),('325','2013-05-05','09:10:00',1.32),('325','2013-05-05','09:15:00',1.23),('325','2013-05-05','09:20:00',1.19),('325','2013-05-05','09:25:00',1.42),('325','2013-05-05','09:30:00',1.8),('325','2013-05-05','09:35:00',1.64),('325','2013-05-05','09:40:00',2.26),('325','2013-05-05','09:45:00',3.06),('325','2013-05-05','09:50:00',3.13),('325','2013-05-05','09:55:00',3.36),('325','2013-05-05','10:00:00',3.25),('325','2013-05-05','10:05:00',2.53),('325','2013-05-05','10:10:00',2.28),('325','2013-05-05','10:15:00',3.22),('325','2013-05-05','10:20:00',3.6),('325','2013-05-05','10:25:00',2.38),('325','2013-05-05','10:30:00',2.81),('325','2013-05-05','10:35:00',3.06),('325','2013-05-05','10:40:00',3.4),('325','2013-05-05','10:45:00',3.21),('325','2013-05-05','10:50:00',1.75),('325','2013-05-05','10:55:00',1.52),('325','2013-05-05','11:00:00',1.58),('325','2013-05-05','11:05:00',1.79),('325','2013-05-05','11:10:00',1.58),('325','2013-05-05','11:15:00',1.83),('325','2013-05-05','11:20:00',3.04),('325','2013-05-05','11:25:00',3.49),('325','2013-05-05','11:30:00',2.84),('325','2013-05-05','11:35:00',3.73),('325','2013-05-05','11:40:00',3.34),('325','2013-05-05','11:45:00',2.78),('325','2013-05-05','11:50:00',3.36),('325','2013-05-05','11:55:00',4.39),('325','2013-05-05','12:00:00',3.29),('325','2013-05-05','12:05:00',3.36),('325','2013-05-05','12:10:00',3.63),('325','2013-05-05','12:15:00',3.67),('325','2013-05-05','12:20:00',3.71),('325','2013-05-05','12:25:00',4.5),('325','2013-05-05','12:30:00',4.04),('325','2013-05-05','12:35:00',4.47),('325','2013-05-05','12:40:00',5.05),('325','2013-05-05','12:45:00',5.11),('325','2013-05-05','12:50:00',4.71),('325','2013-05-05','12:55:00',4.94),('325','2013-05-05','13:00:00',4.9),('325','2013-05-05','13:05:00',4.72),('325','2013-05-05','13:10:00',4.82),('325','2013-05-05','13:15:00',3.3),('325','2013-05-05','13:20:00',3.5),('325','2013-05-05','13:25:00',2.22),('325','2013-05-05','13:30:00',2.1),('325','2013-05-05','13:35:00',4.86),('325','2013-05-05','13:40:00',4.85),('325','2013-05-05','13:45:00',4.75),('325','2013-05-05','13:50:00',4.88),('325','2013-05-05','13:55:00',4.89),('325','2013-05-05','14:00:00',4.44),('325','2013-05-05','14:05:00',4.23),('325','2013-05-05','14:10:00',3.73),('325','2013-05-05','14:15:00',4.25),('325','2013-05-05','14:20:00',4.56),('325','2013-05-05','14:25:00',4.36),('325','2013-05-05','14:30:00',4.24),('325','2013-05-05','14:35:00',4.19),('325','2013-05-05','14:40:00',4.17),('325','2013-05-05','14:45:00',4.17),('325','2013-05-05','14:50:00',4.12),('325','2013-05-05','14:55:00',4.07),('325','2013-05-05','15:00:00',4.02),('325','2013-05-05','15:05:00',3.97),('325','2013-05-05','15:10:00',3.96),('325','2013-05-05','15:15:00',3.93),('325','2013-05-05','15:20:00',3.87),('325','2013-05-05','15:25:00',3.84),('325','2013-05-05','15:30:00',3.81),('325','2013-05-05','15:35:00',3.77),('325','2013-05-05','15:40:00',3.75),('325','2013-05-05','15:45:00',3.7),('325','2013-05-05','15:50:00',3.67),('325','2013-05-05','15:55:00',3.6),('325','2013-05-05','16:00:00',3.54),('325','2013-05-05','16:05:00',3.48),('325','2013-05-05','16:10:00',3.42),('325','2013-05-05','16:15:00',3.35),('325','2013-05-05','16:20:00',3.29),('325','2013-05-05','16:25:00',3.23),('325','2013-05-05','16:30:00',3.15),('325','2013-05-05','16:35:00',3.07),('325','2013-05-05','16:40:00',3),('325','2013-05-05','16:45:00',2.9),('325','2013-05-05','16:50:00',2.77),('325','2013-05-05','16:55:00',2.63),('325','2013-05-05','17:00:00',2.59),('325','2013-05-05','17:05:00',2.51),('325','2013-05-05','17:10:00',2.42),('325','2013-05-05','17:15:00',2.33),('325','2013-05-05','17:20:00',2.24),('325','2013-05-05','17:25:00',2.13),('325','2013-05-05','17:30:00',2.03),('325','2013-05-05','17:35:00',1.88),('325','2013-05-05','17:40:00',1.83),('325','2013-05-05','17:45:00',1.74),('325','2013-05-05','17:50:00',1.64),('325','2013-05-05','17:55:00',1.53),('325','2013-05-05','18:00:00',1.44),('325','2013-05-05','18:05:00',1.34),('325','2013-05-05','18:10:00',1.25),('325','2013-05-05','18:15:00',1.16),('325','2013-05-05','18:20:00',1.08),('325','2013-05-04','08:30:00',1.05),('325','2013-05-04','08:35:00',1.1),('325','2013-05-04','08:40:00',1.16),('325','2013-05-04','08:45:00',1.2),('325','2013-05-04','08:50:00',1.22),('325','2013-05-04','08:55:00',1.33),('325','2013-05-04','09:00:00',1.42),('325','2013-05-04','09:05:00',1.46),('325','2013-05-04','09:10:00',1.78),('325','2013-05-04','09:15:00',2.16),('325','2013-05-04','09:20:00',2.25),('325','2013-05-04','09:25:00',2.34),('325','2013-05-04','09:30:00',2.36),('325','2013-05-04','09:35:00',2.47),('325','2013-05-04','09:40:00',2.6),('325','2013-05-04','09:45:00',2.7),('325','2013-05-04','09:50:00',2.89),('325','2013-05-04','09:55:00',2.97),('325','2013-05-04','10:00:00',3.05),('325','2013-05-04','10:05:00',3.04),('325','2013-05-04','10:10:00',3.1),('325','2013-05-04','10:15:00',3.21),('325','2013-05-04','10:20:00',3.28),('325','2013-05-04','10:25:00',3.32),('325','2013-05-04','10:30:00',3.35),('325','2013-05-04','10:35:00',3.37),('325','2013-05-04','10:40:00',3.37),('325','2013-05-04','10:45:00',3.43),('325','2013-05-04','10:50:00',3.4),('325','2013-05-04','10:55:00',3.57),('325','2013-05-04','11:00:00',3.57),('325','2013-05-04','11:05:00',3.54),('325','2013-05-04','11:10:00',3.36),('325','2013-05-04','11:15:00',3.36),('325','2013-05-04','11:20:00',3.61),('325','2013-05-04','11:25:00',3.61),('325','2013-05-04','11:30:00',3.53),('325','2013-05-04','11:35:00',3.64),('325','2013-05-04','11:40:00',3.59),('325','2013-05-04','11:45:00',3.73),('325','2013-05-04','11:50:00',3.79),('325','2013-05-04','11:55:00',3.84),('325','2013-05-04','12:00:00',3.8),('325','2013-05-04','12:05:00',3.85),('325','2013-05-04','12:10:00',3.88),('325','2013-05-04','12:15:00',3.96),('325','2013-05-04','12:20:00',4.03),('325','2013-05-04','12:25:00',4.07),('325','2013-05-04','12:30:00',4.11),('325','2013-05-04','12:35:00',4.1),('325','2013-05-04','12:40:00',4.12),('325','2013-05-04','12:45:00',4.2),('325','2013-05-04','12:50:00',4.07),('325','2013-05-04','12:55:00',4.07),('325','2013-05-04','13:00:00',3.96),('325','2013-05-04','13:05:00',3.57),('325','2013-05-04','13:10:00',3.88),('325','2013-05-04','13:15:00',4.27),('325','2013-05-04','13:20:00',4.24),('325','2013-05-04','13:25:00',4.03),('325','2013-05-04','13:30:00',4.13),('325','2013-05-04','13:35:00',3.86),('325','2013-05-04','13:40:00',4.02),('325','2013-05-04','13:45:00',4.04),('325','2013-05-04','13:50:00',3.63),('325','2013-05-04','13:55:00',3.69),('325','2013-05-04','14:00:00',4.03),('325','2013-05-04','14:05:00',3.89),('325','2013-05-04','14:10:00',3.72),('325','2013-05-04','14:15:00',3.81),('325','2013-05-04','14:20:00',3.73),('325','2013-05-04','14:25:00',3.5),('325','2013-05-04','14:30:00',3.7),('325','2013-05-04','14:35:00',3.45),('325','2013-05-04','14:40:00',3.64),('325','2013-05-04','14:45:00',3.59),('325','2013-05-04','14:50:00',3.49),('325','2013-05-04','14:55:00',3.6),('325','2013-05-04','15:00:00',3.68),('325','2013-05-04','15:05:00',3.75),('325','2013-05-04','15:10:00',3.54),('325','2013-05-04','15:15:00',3.61),('325','2013-05-04','15:20:00',3.59),('325','2013-05-04','15:25:00',3.61),('325','2013-05-04','15:30:00',3.62),('325','2013-05-04','15:35:00',3.49),('325','2013-05-04','15:40:00',3.61),('325','2013-05-04','15:45:00',3.55),('325','2013-05-04','15:50:00',3.48),('325','2013-05-04','15:55:00',3.42),('325','2013-05-04','16:00:00',3.35),('325','2013-05-04','16:05:00',3.28),('325','2013-05-04','16:10:00',3.23),('325','2013-05-04','16:15:00',3.17),('325','2013-05-04','16:20:00',3.08),('325','2013-05-04','16:25:00',3.03),('325','2013-05-04','16:30:00',2.93),('325','2013-05-04','16:35:00',2.87),('325','2013-05-04','16:40:00',2.81),('325','2013-05-04','16:45:00',2.71),('325','2013-05-04','16:50:00',2.58),('325','2013-05-04','16:55:00',2.45),('325','2013-05-04','17:00:00',2.43),('325','2013-05-04','17:05:00',2.35),('325','2013-05-04','17:10:00',1.81),('325','2013-05-04','17:15:00',2.11),('325','2013-05-04','17:20:00',2.16),('325','2013-05-04','17:25:00',2.06),('325','2013-05-04','17:30:00',1.93),('325','2013-05-04','17:35:00',1.73),('325','2013-05-04','17:40:00',1.62),('325','2013-05-04','17:45:00',1.61),('325','2013-05-04','17:50:00',1.59),('325','2013-05-04','17:55:00',1.51),('325','2013-05-04','18:00:00',1.43),('325','2013-05-04','18:05:00',1.34),('325','2013-05-04','18:10:00',1.12),('325','2013-05-03','08:10:00',1.04),('325','2013-05-03','08:15:00',1.15),('325','2013-05-03','08:20:00',1.17),('325','2013-05-03','08:25:00',1.26),('325','2013-05-03','08:30:00',1.29),('325','2013-05-03','08:35:00',1.27),('325','2013-05-03','08:40:00',1.28),('325','2013-05-03','08:45:00',1.28),('325','2013-05-03','08:50:00',1.22),('325','2013-05-03','08:55:00',1.26),('325','2013-05-03','09:00:00',1.35),('325','2013-05-03','09:05:00',2.04),('325','2013-05-03','09:10:00',2.15),('325','2013-05-03','09:15:00',2.23),('325','2013-05-03','09:20:00',2.32),('325','2013-05-03','09:25:00',2.39),('325','2013-05-03','09:30:00',2.47),('325','2013-05-03','09:35:00',2.52),('325','2013-05-03','09:40:00',2.62),('325','2013-05-03','09:45:00',2.86),('325','2013-05-03','09:50:00',3.08),('325','2013-05-03','09:55:00',3.12),('325','2013-05-03','10:00:00',3.17),('325','2013-05-03','10:05:00',3.23),('325','2013-05-03','10:10:00',3.4),('325','2013-05-03','10:15:00',3.45),('325','2013-05-03','10:20:00',3.5),('325','2013-05-03','10:25:00',3.55),('325','2013-05-03','10:30:00',3.58),('325','2013-05-03','10:35:00',3.65),('325','2013-05-03','10:40:00',3.76),('325','2013-05-03','10:45:00',3.84),('325','2013-05-03','10:50:00',3.88),('325','2013-05-03','10:55:00',3.91),('325','2013-05-03','11:00:00',3.95),('325','2013-05-03','11:05:00',3.97),('325','2013-05-03','11:10:00',3.99),('325','2013-05-03','11:15:00',4.05),('325','2013-05-03','11:20:00',4.1),('325','2013-05-03','11:25:00',4.13),('325','2013-05-03','11:30:00',4.12),('325','2013-05-03','11:35:00',4.18),('325','2013-05-03','11:40:00',4.2),('325','2013-05-03','11:45:00',4.24),('325','2013-05-03','11:50:00',4.3),('325','2013-05-03','11:55:00',4.37),('325','2013-05-03','12:00:00',4.35),('325','2013-05-03','12:05:00',4.29),('325','2013-05-03','12:10:00',4.3),('325','2013-05-03','12:15:00',4.31),('325','2013-05-03','12:20:00',4.32),('325','2013-05-03','12:25:00',4.36),('325','2013-05-03','12:30:00',4.34),('325','2013-05-03','12:35:00',4.34),('325','2013-05-03','12:40:00',4.35),('325','2013-05-03','12:45:00',4.36),('325','2013-05-03','12:50:00',4.49),('325','2013-05-03','12:55:00',4.52),('325','2013-05-03','13:00:00',4.48),('325','2013-05-03','13:05:00',4.41),('325','2013-05-03','13:10:00',4.38),('325','2013-05-03','13:15:00',4.34),('325','2013-05-03','13:20:00',4.26),('325','2013-05-03','13:25:00',4.24),('325','2013-05-03','13:30:00',4.23),('325','2013-05-03','13:35:00',4.2),('325','2013-05-03','13:40:00',4.11),('325','2013-05-03','13:45:00',4.15),('325','2013-05-03','13:50:00',4.2),('325','2013-05-03','13:55:00',4.21),('325','2013-05-03','14:00:00',4.17),('325','2013-05-03','14:05:00',4.07),('325','2013-05-03','14:10:00',4.06),('325','2013-05-03','14:15:00',4.04),('325','2013-05-03','14:20:00',4.18),('325','2013-05-03','14:25:00',4.14),('325','2013-05-03','14:30:00',4.14),('325','2013-05-03','14:35:00',4.14),('325','2013-05-03','14:40:00',4.07),('325','2013-05-03','14:45:00',4.05),('325','2013-05-03','14:50:00',3.98),('325','2013-05-03','14:55:00',4),('325','2013-05-03','15:00:00',4.01),('325','2013-05-03','15:05:00',3.97),('325','2013-05-03','15:10:00',3.95),('325','2013-05-03','15:15:00',3.94),('325','2013-05-03','15:20:00',3.91),('325','2013-05-03','15:25:00',3.87),('325','2013-05-03','15:30:00',3.86),('325','2013-05-03','15:35:00',3.79),('325','2013-05-03','15:40:00',3.75),('325','2013-05-03','15:45:00',3.71),('325','2013-05-03','15:50:00',3.63),('325','2013-05-03','15:55:00',3.57),('325','2013-05-03','16:00:00',3.53),('325','2013-05-03','16:05:00',3.46),('325','2013-05-03','16:10:00',3.42),('325','2013-05-03','16:15:00',3.3),('325','2013-05-03','16:20:00',3.15),('325','2013-05-03','16:25:00',3.14),('325','2013-05-03','16:30:00',3.11),('325','2013-05-03','16:35:00',3.03),('325','2013-05-03','16:40:00',2.95),('325','2013-05-03','16:45:00',2.84),('325','2013-05-03','16:50:00',2.72),('325','2013-05-03','16:55:00',2.62),('325','2013-05-03','17:00:00',2.53),('325','2013-05-03','17:05:00',2.46),('325','2013-05-03','17:10:00',2.34),('325','2013-05-03','17:15:00',2.25),('325','2013-05-03','17:20:00',2.13),('325','2013-05-03','17:25:00',2.02),('325','2013-05-03','17:30:00',1.91),('325','2013-05-03','17:35:00',1.76),('325','2013-05-03','17:40:00',1.68),('325','2013-05-03','17:45:00',1.59),('325','2013-05-03','17:50:00',1.47),('325','2013-05-03','17:55:00',1.4),('325','2013-05-03','18:00:00',1.35),('325','2013-05-03','18:05:00',1.28),('325','2013-05-03','18:10:00',1.19),('325','2013-05-03','18:15:00',1.1),('325','2013-05-03','18:20:00',1.01),('325','2013-05-02','08:55:00',1.29),('325','2013-05-02','09:00:00',1.43),('325','2013-05-02','09:05:00',1.22),('325','2013-05-02','09:25:00',1.75),('325','2013-05-02','09:30:00',2.05),('325','2013-05-02','09:35:00',1.94),('325','2013-05-02','09:40:00',1.56),('325','2013-05-02','09:45:00',2.73),('325','2013-05-02','09:50:00',1.38),('325','2013-05-02','09:55:00',1.09),('325','2013-05-02','10:00:00',1.11),('325','2013-05-02','10:05:00',1.55),('325','2013-05-02','10:10:00',1.4),('325','2013-05-02','10:15:00',1.49),('325','2013-05-02','10:20:00',1.56),('325','2013-05-02','10:25:00',1.84),('325','2013-05-02','10:30:00',2.85),('325','2013-05-02','10:35:00',3.12),('325','2013-05-02','10:40:00',3.56),('325','2013-05-02','10:45:00',3.28),('325','2013-05-02','10:50:00',3.98),('325','2013-05-02','10:55:00',4.3),('325','2013-05-02','11:00:00',4.19),('325','2013-05-02','11:05:00',3.59),('325','2013-05-02','11:10:00',3.39),('325','2013-05-02','11:15:00',3.08),('325','2013-05-02','11:20:00',3.54),('325','2013-05-02','11:25:00',3.98),('325','2013-05-02','11:30:00',4.13),('325','2013-05-02','11:35:00',3.9),('325','2013-05-02','11:40:00',4.14),('325','2013-05-02','11:45:00',4.19),('325','2013-05-02','11:50:00',4.24),('325','2013-05-02','11:55:00',4.26),('325','2013-05-02','12:00:00',4.27),('325','2013-05-02','12:05:00',4.23),('325','2013-05-02','12:10:00',4.22),('325','2013-05-02','12:15:00',4.25),('325','2013-05-02','12:20:00',4.24),('325','2013-05-02','12:25:00',4.25),('325','2013-05-02','12:30:00',4.33),('325','2013-05-02','12:35:00',4.41),('325','2013-05-02','12:40:00',4.47),('325','2013-05-02','12:45:00',4.54),('325','2013-05-02','12:50:00',4.58),('325','2013-05-02','12:55:00',4.64),('325','2013-05-02','13:00:00',4.67),('325','2013-05-02','13:05:00',4.65),('325','2013-05-02','13:10:00',4.69),('325','2013-05-02','13:15:00',4.71),('325','2013-05-02','13:20:00',4.69),('325','2013-05-02','13:25:00',4.7),('325','2013-05-02','13:30:00',4.7),('325','2013-05-02','13:35:00',4.66),('325','2013-05-02','13:40:00',4.64),('325','2013-05-02','13:45:00',4.58),('325','2013-05-02','13:50:00',4.57),('325','2013-05-02','13:55:00',4.51),('325','2013-05-02','14:00:00',4.45),('325','2013-05-02','14:05:00',4.34),('325','2013-05-02','14:10:00',4.35),('325','2013-05-02','14:15:00',4.42),('325','2013-05-02','14:20:00',4.38),('325','2013-05-02','14:25:00',4.37),('325','2013-05-02','14:30:00',4.34),('325','2013-05-02','14:35:00',4.29),('325','2013-05-02','14:40:00',4.25),('325','2013-05-02','14:45:00',4.21),('325','2013-05-02','14:50:00',4.17),('325','2013-05-02','14:55:00',4.13),('325','2013-05-02','15:00:00',4.1),('325','2013-05-02','15:05:00',4.06),('325','2013-05-02','15:10:00',4.01),('325','2013-05-02','15:15:00',3.96),('325','2013-05-02','15:20:00',3.88),('325','2013-05-02','15:25:00',3.84),('325','2013-05-02','15:30:00',3.8),('325','2013-05-02','15:35:00',3.78),('325','2013-05-02','15:40:00',3.73),('325','2013-05-02','15:45:00',3.69),('325','2013-05-02','15:50:00',3.61),('325','2013-05-02','15:55:00',3.56),('325','2013-05-02','16:00:00',3.5),('325','2013-05-02','16:05:00',3.46),('325','2013-05-02','16:10:00',3.38),('325','2013-05-02','16:15:00',3.31),('325','2013-05-02','16:20:00',3.23),('325','2013-05-02','16:25:00',3.16),('325','2013-05-02','16:30:00',3.06),('325','2013-05-02','16:35:00',2.98),('325','2013-05-02','16:40:00',2.92),('325','2013-05-02','16:45:00',2.82),('325','2013-05-02','16:50:00',2.7),('325','2013-05-02','16:55:00',2.56),('325','2013-05-02','17:00:00',2.54),('325','2013-05-02','17:05:00',2.48),('325','2013-05-02','17:10:00',2.4),('325','2013-05-02','17:15:00',2.31),('325','2013-05-02','17:20:00',2.22),('325','2013-05-02','17:25:00',2.13),('325','2013-05-02','17:30:00',2.03),('325','2013-05-02','17:35:00',1.88),('325','2013-05-02','17:40:00',1.82),('325','2013-05-02','17:45:00',1.73),('325','2013-05-02','17:50:00',1.63),('325','2013-05-02','17:55:00',1.53),('325','2013-05-02','18:00:00',1.44),('325','2013-05-02','18:05:00',1.35),('325','2013-05-02','18:10:00',1.25),('325','2013-05-02','18:15:00',1.16),('325','2013-05-02','18:20:00',1.05),('325','2013-05-01','08:25:00',1.05),('325','2013-05-01','08:30:00',1.11),('325','2013-05-01','08:35:00',1.16),('325','2013-05-01','08:40:00',1.21),('325','2013-05-01','08:45:00',1.26),('325','2013-05-01','08:50:00',1.31),('325','2013-05-01','08:55:00',1.39),('325','2013-05-01','09:00:00',1.47),('325','2013-05-01','09:05:00',1.51),('325','2013-05-01','09:10:00',1.61),('325','2013-05-01','09:15:00',1.71),('325','2013-05-01','09:20:00',1.84),('325','2013-05-01','09:25:00',2.02),('325','2013-05-01','09:30:00',2.15),('325','2013-05-01','09:35:00',2.33),('325','2013-05-01','09:40:00',2.46),('325','2013-05-01','09:45:00',2.56),('325','2013-05-01','09:50:00',2.69),('325','2013-05-01','09:55:00',2.76),('325','2013-05-01','10:00:00',2.81),('325','2013-05-01','10:05:00',2.83),('325','2013-05-01','10:10:00',2.96),('325','2013-05-01','10:15:00',3.05),('325','2013-05-01','10:20:00',3.09),('325','2013-05-01','10:25:00',3.15),('325','2013-05-01','10:30:00',3.17),('325','2013-05-01','10:35:00',3.23),('325','2013-05-01','10:40:00',3.39),('325','2013-05-01','10:45:00',3.52),('325','2013-05-01','10:50:00',3.62),('325','2013-05-01','10:55:00',3.7),('325','2013-05-01','11:00:00',3.75),('325','2013-05-01','11:05:00',3.74),('325','2013-05-01','11:10:00',3.79),('325','2013-05-01','11:15:00',3.49),('325','2013-05-01','11:20:00',3.67),('325','2013-05-01','11:25:00',3.61),('325','2013-05-01','11:30:00',3.56),('325','2013-05-01','11:35:00',3.63),('325','2013-05-01','11:40:00',2.8),('325','2013-05-01','11:45:00',2.78),('325','2013-05-01','11:50:00',3.75),('325','2013-05-01','11:55:00',4.28),('325','2013-05-01','12:00:00',4.21),('325','2013-05-01','12:05:00',4.15),('325','2013-05-01','12:10:00',4.17),('325','2013-05-01','12:15:00',4.14),('325','2013-05-01','12:20:00',4.15),('325','2013-05-01','12:25:00',4.18),('325','2013-05-01','12:30:00',4.3),('325','2013-05-01','12:35:00',4.36),('325','2013-05-01','12:40:00',4.48),('325','2013-05-01','12:45:00',4.09),('325','2013-05-01','12:50:00',2.51),('325','2013-05-01','12:55:00',1.67),('325','2013-05-01','13:00:00',1.74),('325','2013-05-01','13:05:00',2.11),('325','2013-05-01','13:10:00',2.45),('325','2013-05-01','13:15:00',4.52),('325','2013-05-01','13:20:00',4.94),('325','2013-05-01','13:25:00',4.46),('325','2013-05-01','13:30:00',3.91),('325','2013-05-01','13:35:00',4.5),('325','2013-05-01','13:40:00',4.8),('325','2013-05-01','13:45:00',4.64),('325','2013-05-01','13:50:00',4.44),('325','2013-05-01','13:55:00',4.31),('325','2013-05-01','14:00:00',4.17),('325','2013-05-01','14:05:00',4.13),('325','2013-05-01','14:10:00',4.07),('325','2013-05-01','14:15:00',3.63),('325','2013-05-01','14:20:00',4.26),('325','2013-05-01','14:25:00',4.27),('325','2013-05-01','14:30:00',4.28),('325','2013-05-01','14:35:00',4.07),('325','2013-05-01','14:40:00',3.85),('325','2013-05-01','14:45:00',3.82),('325','2013-05-01','14:50:00',3.54),('325','2013-05-01','14:55:00',3.17),('325','2013-05-01','15:00:00',3.36),('325','2013-05-01','15:05:00',3.83),('325','2013-05-01','15:10:00',3.84),('325','2013-05-01','15:15:00',3.68),('325','2013-05-01','15:20:00',3.68),('325','2013-05-01','15:25:00',3.59),('325','2013-05-01','15:30:00',2.93),('325','2013-05-01','15:35:00',2.62),('325','2013-05-01','15:40:00',2.62),('325','2013-05-01','15:45:00',2.54),('325','2013-05-01','15:50:00',1.87),('325','2013-05-01','15:55:00',1.89),('325','2013-05-01','16:00:00',2.25),('325','2013-05-01','16:05:00',2.08),('325','2013-05-01','16:10:00',1.89),('325','2013-05-01','16:15:00',1.75),('325','2013-05-01','16:20:00',1.51),('325','2013-05-01','16:25:00',1.21),('325','2013-05-01','16:30:00',1.13),('325','2013-05-01','16:35:00',1.21),('325','2013-05-01','16:40:00',1.28),('325','2013-05-01','16:45:00',1.17),('325','2013-05-01','16:50:00',1.02),('325','2014-03-29','07:50:00',1.05),('325','2014-03-29','07:55:00',1.1),('325','2014-03-29','08:00:00',1.17),('325','2014-03-29','08:05:00',1.23),('325','2014-03-29','08:10:00',1.29),('325','2014-03-29','08:15:00',1.34),('325','2014-03-29','08:20:00',1.38),('325','2014-03-29','08:25:00',1.44),('325','2014-03-29','08:30:00',1.48),('325','2014-03-29','08:35:00',1.52),('325','2014-03-29','08:40:00',1.57),('325','2014-03-29','08:45:00',1.62),('325','2014-03-29','08:50:00',1.67),('325','2014-03-29','08:55:00',1.71),('325','2014-03-29','09:00:00',1.75),('325','2014-03-29','09:05:00',1.79),('325','2014-03-29','09:10:00',1.84),('325','2014-03-29','09:15:00',1.9),('325','2014-03-29','09:20:00',1.95),('325','2014-03-29','09:25:00',2.43),('325','2014-03-29','09:30:00',3.21),('325','2014-03-29','09:35:00',3.29),('325','2014-03-29','09:40:00',3.38),('325','2014-03-29','09:45:00',3.43),('325','2014-03-29','09:50:00',3.53),('325','2014-03-29','09:55:00',3.62),('325','2014-03-29','10:00:00',3.69),('325','2014-03-29','10:05:00',3.78),('325','2014-03-29','10:10:00',3.84),('325','2014-03-29','10:15:00',3.93),('325','2014-03-29','10:20:00',3.94),('325','2014-03-29','10:25:00',4),('325','2014-03-29','10:30:00',4.03),('325','2014-03-29','10:35:00',4.03),('325','2014-03-29','10:40:00',4.07),('325','2014-03-29','10:45:00',4.08),('325','2014-03-29','10:50:00',4.17),('325','2014-03-29','10:55:00',4.2),('325','2014-03-29','11:00:00',4.26),('325','2014-03-29','11:05:00',4.28),('325','2014-03-29','11:10:00',4.29),('325','2014-03-29','11:15:00',4.33),('325','2014-03-29','11:20:00',4.34),('325','2014-03-29','11:25:00',4.38),('325','2014-03-29','11:30:00',4.38),('325','2014-03-29','11:35:00',4.36),('325','2014-03-29','11:40:00',4.24),('325','2014-03-29','11:45:00',4.46),('325','2014-03-29','11:50:00',4.46),('325','2014-03-29','11:55:00',4.44),('325','2014-03-29','12:00:00',4.45),('325','2014-03-29','12:05:00',4.46),('325','2014-03-29','12:10:00',4.44),('325','2014-03-29','12:15:00',4.42),('325','2014-03-29','12:20:00',4.45),('325','2014-03-29','12:25:00',4.46),('325','2014-03-29','12:30:00',4.45),('325','2014-03-29','12:35:00',4.42),('325','2014-03-29','12:40:00',4.4),('325','2014-03-29','12:45:00',4.41),('325','2014-03-29','12:50:00',4.42),('325','2014-03-29','12:55:00',4.35),('325','2014-03-29','13:00:00',4.3),('325','2014-03-29','13:05:00',4.34),('325','2014-03-29','13:10:00',4.27),('325','2014-03-29','13:15:00',4.27),('325','2014-03-29','13:20:00',4.27),('325','2014-03-29','13:25:00',4.19),('325','2014-03-29','13:30:00',4.17),('325','2014-03-29','13:35:00',4.1),('325','2014-03-29','13:40:00',4.06),('325','2014-03-29','13:45:00',4.01),('325','2014-03-29','13:50:00',3.93),('325','2014-03-29','13:55:00',3.91),('325','2014-03-29','14:00:00',3.89),('325','2014-03-29','14:05:00',3.84),('325','2014-03-29','14:10:00',3.83),('325','2014-03-29','14:15:00',3.77),('325','2014-03-29','14:20:00',3.72),('325','2014-03-29','14:25:00',3.62),('325','2014-03-29','14:30:00',3.57),('325','2014-03-29','14:35:00',3.27),('325','2014-03-29','14:40:00',2.2),('325','2014-03-29','14:45:00',3.44),('325','2014-03-29','14:50:00',3.4),('325','2014-03-29','14:55:00',3.34),('325','2014-03-29','15:00:00',3.31),('325','2014-03-29','15:05:00',3.18),('325','2014-03-29','15:10:00',3.1),('325','2014-03-29','15:15:00',3.04),('325','2014-03-29','15:20:00',2.97),('325','2014-03-29','15:25:00',2.83),('325','2014-03-29','15:30:00',2.69),('325','2014-03-29','15:35:00',2.6),('325','2014-03-29','15:40:00',2.52),('325','2014-03-29','15:45:00',2.44),('325','2014-03-29','15:50:00',2.37),('325','2014-03-29','15:55:00',2.27),('325','2014-03-29','16:00:00',2.2),('325','2014-03-29','16:05:00',2.1),('325','2014-03-29','16:10:00',1.97),('325','2014-03-29','16:15:00',1.89),('325','2014-03-29','16:20:00',1.7),('325','2014-03-29','16:25:00',1.66),('325','2014-03-29','16:30:00',1.59),('325','2014-03-29','16:35:00',1.42),('325','2014-03-29','16:40:00',1.24),('325','2014-03-29','16:50:00',1.08),('325','2014-03-29','16:55:00',1.1),('325','2014-03-29','17:00:00',1.01),('325','2013-04-30','08:50:00',1.16),('325','2013-04-30','08:55:00',1.55),('325','2013-04-30','09:00:00',1.46),('325','2013-04-30','09:05:00',1.34),('325','2013-04-30','09:10:00',1.71),('325','2013-04-30','09:15:00',2.02),('325','2013-04-30','09:20:00',2.3),('325','2013-04-30','09:25:00',2.53),('325','2013-04-30','09:30:00',2.5),('325','2013-04-30','09:35:00',2.16),('325','2013-04-30','09:40:00',1.47),('325','2013-04-30','09:45:00',2.2),('325','2013-04-30','09:50:00',2.62),('325','2013-04-30','09:55:00',2.98),('325','2013-04-30','10:00:00',3.41),('325','2013-04-30','10:05:00',2.99),('325','2013-04-30','10:10:00',3.04),('325','2013-04-30','10:15:00',2.15),('325','2013-04-30','10:20:00',2.19),('325','2013-04-30','10:25:00',3.54),('325','2013-04-30','10:30:00',2.64),('325','2013-04-30','10:35:00',1.89),('325','2013-04-30','10:40:00',1.7),('325','2013-04-30','10:45:00',1.38),('325','2013-04-30','10:50:00',1.5),('325','2013-04-30','10:55:00',1.6),('325','2013-04-30','11:00:00',1.71),('325','2013-04-30','11:05:00',1.95),('325','2013-04-30','11:10:00',1.91),('325','2013-04-30','11:15:00',2.06),('325','2013-04-30','11:20:00',2.4),('325','2013-04-30','11:25:00',2.09),('325','2013-04-30','11:30:00',2.17),('325','2013-04-30','11:35:00',2.36),('325','2013-04-30','11:40:00',2.04),('325','2013-04-30','11:45:00',1.7),('325','2013-04-30','11:50:00',1.73),('325','2013-04-30','11:55:00',1.79),('325','2013-04-30','12:00:00',1.83),('325','2013-04-30','12:05:00',1.89),('325','2013-04-30','12:10:00',1.76),('325','2013-04-30','12:15:00',1.61),('325','2013-04-30','12:20:00',1.49),('325','2013-04-30','12:25:00',1.4),('325','2013-04-30','12:30:00',1.5),('325','2013-04-30','12:35:00',3.08),('325','2013-04-30','12:40:00',4.79),('325','2013-04-30','12:45:00',4.85),('325','2013-04-30','12:50:00',4.72),('325','2013-04-30','12:55:00',4.22),('325','2013-04-30','13:00:00',4.5),('325','2013-04-30','13:05:00',4.41),('325','2013-04-30','13:10:00',4.39),('325','2013-04-30','13:15:00',4.3),('325','2013-04-30','13:20:00',4.24),('325','2013-04-30','13:25:00',4.23),('325','2013-04-30','13:30:00',4.26),('325','2013-04-30','13:35:00',4.24),('325','2013-04-30','13:40:00',4.21),('325','2013-04-30','13:45:00',4.16),('325','2013-04-30','13:50:00',4.16),('325','2013-04-30','13:55:00',4.12),('325','2013-04-30','14:00:00',4.07),('325','2013-04-30','14:05:00',4.03),('325','2013-04-30','14:10:00',3.98),('325','2013-04-30','14:15:00',3.93),('325','2013-04-30','14:20:00',3.88),('325','2013-04-30','14:25:00',3.88),('325','2013-04-30','14:30:00',3.86),('325','2013-04-30','14:35:00',3.84),('325','2013-04-30','14:40:00',3.82),('325','2013-04-30','14:45:00',3.8),('325','2013-04-30','14:50:00',3.76),('325','2013-04-30','14:55:00',3.71),('325','2013-04-30','15:00:00',3.67),('325','2013-04-30','15:05:00',3.63),('325','2013-04-30','15:10:00',3.6),('325','2013-04-30','15:15:00',3.59),('325','2013-04-30','15:20:00',3.55),('325','2013-04-30','15:25:00',3.48),('325','2013-04-30','15:30:00',3.48),('325','2013-04-30','15:35:00',3.45),('325','2013-04-30','15:40:00',3.39),('325','2013-04-30','15:45:00',3.34),('325','2013-04-30','15:50:00',3.28),('325','2013-04-30','15:55:00',3.21),('325','2013-04-30','16:00:00',3.14),('325','2013-04-30','16:05:00',3.07),('325','2013-04-30','16:10:00',3.01),('325','2013-04-30','16:15:00',2.94),('325','2013-04-30','16:20:00',2.89),('325','2013-04-30','16:25:00',2.82),('325','2013-04-30','16:30:00',2.73),('325','2013-04-30','16:35:00',2.59),('325','2013-04-30','16:40:00',2.12),('325','2013-04-30','16:45:00',2.31),('325','2013-04-30','16:50:00',2.11),('325','2013-04-30','16:55:00',2.12),('325','2013-04-30','17:00:00',2.13),('325','2013-04-30','17:05:00',1.99),('325','2013-04-30','17:10:00',1.72),('325','2013-04-30','17:20:00',1.61),('325','2013-04-30','17:25:00',1.72),('325','2013-04-30','17:30:00',1.65),('325','2013-04-30','17:35:00',1.57),('325','2013-04-30','17:40:00',1.48),('325','2013-04-30','17:45:00',1.42),('325','2013-04-30','17:50:00',1.33),('325','2013-04-30','17:55:00',1.25),('325','2013-04-30','18:00:00',1.17),('325','2013-04-30','18:05:00',1.08),('325','2013-04-30','18:10:00',1.01),('325','2013-04-29','08:20:00',1.07),('325','2013-04-29','08:25:00',1.22),('325','2013-04-29','08:30:00',1.37),('325','2013-04-29','08:35:00',1.49),('325','2013-04-29','08:40:00',1.46),('325','2013-04-29','08:45:00',1.48),('325','2013-04-29','08:50:00',1.54),('325','2013-04-29','08:55:00',1.52),('325','2013-04-29','09:00:00',1.37),('325','2013-04-29','09:05:00',1.74),('325','2013-04-29','09:10:00',1.89),('325','2013-04-29','09:15:00',2.04),('325','2013-04-29','09:20:00',2.06),('325','2013-04-29','09:25:00',2.13),('325','2013-04-29','09:30:00',2.31),('325','2013-04-29','09:35:00',2.52),('325','2013-04-29','09:40:00',2.56),('325','2013-04-29','09:45:00',2.62),('325','2013-04-29','09:50:00',2.77),('325','2013-04-29','09:55:00',2.69),('325','2013-04-29','10:00:00',2.81),('325','2013-04-29','10:05:00',2.81),('325','2013-04-29','10:10:00',2.71),('325','2013-04-29','10:15:00',2.25),('325','2013-04-29','10:20:00',2.41),('325','2013-04-29','10:25:00',2.82),('325','2013-04-29','10:30:00',3),('325','2013-04-29','10:35:00',3.28),('325','2013-04-29','10:40:00',3.31),('325','2013-04-29','10:45:00',3.33),('325','2013-04-29','10:50:00',3.32),('325','2013-04-29','10:55:00',3.16),('325','2013-04-29','11:00:00',3.56),('325','2013-04-29','11:05:00',3.33),('325','2013-04-29','11:10:00',3.21),('325','2013-04-29','11:15:00',3.11),('325','2013-04-29','11:20:00',3.67),('325','2013-04-29','11:25:00',3.72),('325','2013-04-29','11:30:00',3.84),('325','2013-04-29','11:35:00',3.78),('325','2013-04-29','11:40:00',3.95),('325','2013-04-29','11:45:00',3.72),('325','2013-04-29','11:50:00',4.27),('325','2013-04-29','11:55:00',4.15),('325','2013-04-29','12:00:00',4.33),('325','2013-04-29','12:05:00',4.23),('325','2013-04-29','12:10:00',4.16),('325','2013-04-29','12:15:00',4.2),('325','2013-04-29','12:20:00',4.15),('325','2013-04-29','12:25:00',4.07),('325','2013-04-29','12:30:00',4.23),('325','2013-04-29','12:35:00',4.29),('325','2013-04-29','12:40:00',4.34),('325','2013-04-29','12:45:00',4.37),('325','2013-04-29','12:50:00',4.32),('325','2013-04-29','12:55:00',4.32),('325','2013-04-29','13:00:00',4.41),('325','2013-04-29','13:05:00',4.33),('325','2013-04-29','13:10:00',4.21),('325','2013-04-29','13:15:00',3.75),('325','2013-04-29','13:20:00',4.28),('325','2013-04-29','13:25:00',4.45),('325','2013-04-29','13:30:00',4.31),('325','2013-04-29','13:35:00',4.23),('325','2013-04-29','13:40:00',4.32),('325','2013-04-29','13:45:00',4.27),('325','2013-04-29','13:50:00',4.22),('325','2013-04-29','13:55:00',4.63),('325','2013-04-29','14:00:00',4.2),('325','2013-04-29','14:05:00',4.17),('325','2013-04-29','14:10:00',4.21),('325','2013-04-29','14:15:00',4.3),('325','2013-04-29','14:20:00',4.31),('325','2013-04-29','14:25:00',4.04),('325','2013-04-29','14:30:00',3.91),('325','2013-04-29','14:35:00',3.91),('325','2013-04-29','14:40:00',3.66),('325','2013-04-29','14:45:00',3.89),('325','2013-04-29','14:50:00',3.93),('325','2013-04-29','14:55:00',3.96),('325','2013-04-29','15:00:00',3.8),('325','2013-04-29','15:05:00',3.84),('325','2013-04-29','15:10:00',3.38),('325','2013-04-29','15:15:00',3.57),('325','2013-04-29','15:20:00',3.81),('325','2013-04-29','15:25:00',3.9),('325','2013-04-29','15:30:00',3.76),('325','2013-04-29','15:35:00',3.32),('325','2013-04-29','15:40:00',3.06),('325','2013-04-29','15:45:00',3),('325','2013-04-29','15:50:00',3.12),('325','2013-04-29','15:55:00',3.24),('325','2013-04-29','16:00:00',3.18),('325','2013-04-29','16:05:00',3.42),('325','2013-04-29','16:10:00',3.28),('325','2013-04-29','16:15:00',3.82),('325','2013-04-29','16:20:00',3.47),('325','2013-04-29','16:25:00',2.81),('325','2013-04-29','16:30:00',2.88),('325','2013-04-29','16:35:00',2.94),('325','2013-04-29','16:40:00',3.03),('325','2013-04-29','16:45:00',2.99),('325','2013-04-29','16:50:00',3.07),('325','2013-04-29','16:55:00',3.07),('325','2013-04-29','17:00:00',2.85),('325','2013-04-29','17:05:00',2.52),('325','2013-04-29','17:10:00',2.57),('325','2013-04-29','17:15:00',2.15),('325','2013-04-29','17:20:00',1.77),('325','2013-04-29','17:25:00',1.7),('325','2013-04-29','17:30:00',1.67),('325','2013-04-29','17:35:00',1.54),('325','2013-04-29','17:40:00',1.29),('325','2013-04-29','17:45:00',1.17),('325','2013-04-29','17:50:00',1.47),('325','2013-04-29','17:55:00',1.63),('325','2013-04-29','18:00:00',1.57),('325','2013-04-29','18:05:00',1.75),('325','2013-04-29','18:10:00',1.53),('325','2013-04-29','18:15:00',1.43),('325','2013-04-29','18:20:00',1.18),('325','2013-04-29','18:25:00',1.15),('325','2013-04-29','18:30:00',1.02),('325','2013-04-28','08:30:00',1.01),('325','2013-04-28','08:35:00',1.06),('325','2013-04-28','08:40:00',1.1),('325','2013-04-28','08:45:00',1.13),('325','2013-04-28','08:50:00',1.18),('325','2013-04-28','08:55:00',1.24),('325','2013-04-28','09:00:00',1.49),('325','2013-04-28','09:05:00',2.02),('325','2013-04-28','09:10:00',2.11),('325','2013-04-28','09:15:00',2.24),('325','2013-04-28','09:20:00',2.33),('325','2013-04-28','09:25:00',2.38),('325','2013-04-28','09:30:00',2.48),('325','2013-04-28','09:35:00',2.66),('325','2013-04-28','09:40:00',2.8),('325','2013-04-28','09:45:00',2.97),('325','2013-04-28','09:50:00',3.09),('325','2013-04-28','09:55:00',3.14),('325','2013-04-28','10:00:00',3.21),('325','2013-04-28','10:05:00',3.26),('325','2013-04-28','10:10:00',3.33),('325','2013-04-28','10:15:00',3.39),('325','2013-04-28','10:20:00',3.48),('325','2013-04-28','10:25:00',3.58),('325','2013-04-28','10:30:00',3.47),('325','2013-04-28','10:35:00',3.66),('325','2013-04-28','10:40:00',3.41),('325','2013-04-28','10:45:00',3.84),('325','2013-04-28','10:50:00',3.87),('325','2013-04-28','10:55:00',3.91),('325','2013-04-28','11:00:00',3.95),('325','2013-04-28','11:05:00',3.99),('325','2013-04-28','11:10:00',4.03),('325','2013-04-28','11:15:00',4.08),('325','2013-04-28','11:20:00',4.06),('325','2013-04-28','11:25:00',4.12),('325','2013-04-28','11:30:00',4.13),('325','2013-04-28','11:35:00',4.09),('325','2013-04-28','11:40:00',4.16),('325','2013-04-28','11:45:00',4.04),('325','2013-04-28','11:50:00',4.06),('325','2013-04-28','11:55:00',4.26),('325','2013-04-28','12:00:00',3.76),('325','2013-04-28','12:05:00',3.7),('325','2013-04-28','12:10:00',4.08),('325','2013-04-28','12:15:00',4.16),('325','2013-04-28','12:20:00',4.14),('325','2013-04-28','12:25:00',3.75),('325','2013-04-28','12:30:00',3.65),('325','2013-04-28','12:35:00',3.48),('325','2013-04-28','12:40:00',3.37),('325','2013-04-28','12:45:00',4.37),('325','2013-04-28','12:50:00',4.41),('325','2013-04-28','12:55:00',4.2),('325','2013-04-28','13:00:00',4.26),('325','2013-04-28','13:05:00',4.53),('325','2013-04-28','13:10:00',4.44),('325','2013-04-28','13:15:00',4.13),('325','2013-04-28','13:20:00',4.24),('325','2013-04-28','13:25:00',4.02),('325','2013-04-28','13:30:00',4.09),('325','2013-04-28','13:35:00',3.85),('325','2013-04-28','13:40:00',3.05),('325','2013-04-28','13:45:00',2.14),('325','2013-04-28','13:50:00',1.61),('325','2013-04-28','13:55:00',2.48),('325','2013-04-28','14:00:00',2.86),('325','2013-04-28','14:05:00',3.02),('325','2013-04-28','14:10:00',4.41),('325','2013-04-28','14:15:00',4.37),('325','2013-04-28','14:20:00',3.66),('325','2013-04-28','14:25:00',3.76),('325','2013-04-28','14:30:00',4.13),('325','2013-04-28','14:35:00',4.25),('325','2013-04-28','14:40:00',4.21),('325','2013-04-28','14:45:00',4.15),('325','2013-04-28','14:50:00',4.1),('325','2013-04-28','14:55:00',4.04),('325','2013-04-28','15:00:00',4.01),('325','2013-04-28','15:05:00',4.01),('325','2013-04-28','15:10:00',3.97),('325','2013-04-28','15:15:00',3.88),('325','2013-04-28','15:20:00',3.83),('325','2013-04-28','15:25:00',3.78),('325','2013-04-28','15:30:00',3.74),('325','2013-04-28','15:35:00',3.69),('325','2013-04-28','15:40:00',3.63),('325','2013-04-28','15:45:00',3.61),('325','2013-04-28','15:50:00',3.58),('325','2013-04-28','15:55:00',3.5),('325','2013-04-28','16:00:00',3.45),('325','2013-04-28','16:05:00',3.39),('325','2013-04-28','16:10:00',3.33),('325','2013-04-28','16:15:00',3.25),('325','2013-04-28','16:20:00',3.16),('325','2013-04-28','16:25:00',3.09),('325','2013-04-28','16:30:00',3.02),('325','2013-04-28','16:35:00',2.94),('325','2013-04-28','16:40:00',2.86),('325','2013-04-28','16:45:00',2.77),('325','2013-04-28','16:50:00',2.66),('325','2013-04-28','16:55:00',2.5),('325','2013-04-28','17:00:00',2.49),('325','2013-04-28','17:05:00',2.3),('325','2013-04-28','17:10:00',2.22),('325','2013-04-28','17:15:00',2.27),('325','2013-04-28','17:20:00',2.14),('325','2013-04-28','17:25:00',2.09),('325','2013-04-28','17:30:00',1.76),('325','2013-04-28','17:35:00',1.71),('325','2013-04-28','17:40:00',1.64),('325','2013-04-28','17:45:00',1.66),('325','2013-04-28','17:50:00',1.56),('325','2013-04-28','17:55:00',1.36),('325','2013-04-28','18:00:00',1.35),('325','2013-04-28','18:05:00',1.25),('325','2013-04-28','18:20:00',1.04),('325','2013-04-27','12:50:00',1.09),('325','2013-04-27','12:55:00',1.4),('325','2013-04-27','13:00:00',1.42),('325','2013-04-27','13:05:00',1.04),('325','2013-04-27','13:10:00',1.2),('325','2013-04-27','13:15:00',1.57),('325','2013-04-27','13:20:00',1.61),('325','2013-04-27','13:25:00',1.13),('325','2013-04-27','13:30:00',1.32),('325','2013-04-27','13:35:00',1.64),('325','2013-04-27','13:40:00',1.75),('325','2013-04-27','13:45:00',1.21),('325','2013-04-27','13:50:00',1.16),('325','2013-04-27','14:25:00',1.41),('325','2013-04-27','14:30:00',2.34),('325','2013-04-27','14:35:00',1.87),('325','2013-04-27','14:40:00',1.33),('325','2013-04-27','14:45:00',1.1),('325','2013-04-27','15:00:00',1.18),('325','2013-04-27','15:05:00',1.84),('325','2013-04-27','15:10:00',1.38),('325','2013-04-27','16:40:00',1.12),('325','2013-04-27','16:45:00',1.54),('325','2013-04-27','16:50:00',2.41),('325','2013-04-27','16:55:00',2.2),('325','2013-04-27','17:00:00',2.62),('325','2013-04-27','17:05:00',1.69),('325','2013-04-27','17:20:00',1.25),('325','2013-04-27','17:40:00',1.28),('325','2013-04-27','17:45:00',1.01),('325','2013-04-26','08:25:00',1.02),('325','2013-04-26','08:30:00',1.08),('325','2013-04-26','08:35:00',1.14),('325','2013-04-26','08:40:00',1.22),('325','2013-04-26','08:45:00',1.3),('325','2013-04-26','08:50:00',1.2),('325','2013-04-26','08:55:00',1.18),('325','2013-04-26','09:00:00',1.27),('325','2013-04-26','09:05:00',1.57),('325','2013-04-26','09:10:00',1.47),('325','2013-04-26','09:15:00',1.16),('325','2013-04-26','09:20:00',1.19),('325','2013-04-26','09:25:00',1.75),('325','2013-04-26','09:30:00',1.9),('325','2013-04-26','09:35:00',1.73),('325','2013-04-26','09:40:00',1.82),('325','2013-04-26','09:45:00',2.12),('325','2013-04-26','09:50:00',2.55),('325','2013-04-26','09:55:00',1.63),('325','2013-04-26','10:00:00',2.83),('325','2013-04-26','10:05:00',3.16),('325','2013-04-26','10:10:00',3.15),('325','2013-04-26','10:15:00',3.25),('325','2013-04-26','10:20:00',3.14),('325','2013-04-26','10:25:00',3.16),('325','2013-04-26','10:30:00',3.3),('325','2013-04-26','10:35:00',3.61),('325','2013-04-26','10:40:00',3.72),('325','2013-04-26','10:45:00',3.5),('325','2013-04-26','10:50:00',2.62),('325','2013-04-26','10:55:00',2),('325','2013-04-26','11:00:00',3.58),('325','2013-04-26','11:05:00',3.63),('325','2013-04-26','11:10:00',3.66),('325','2013-04-26','11:15:00',3.09),('325','2013-04-26','11:20:00',2.68),('325','2013-04-26','11:25:00',3.34),('325','2013-04-26','11:30:00',3.38),('325','2013-04-26','11:35:00',3.98),('325','2013-04-26','11:40:00',3.18),('325','2013-04-26','11:45:00',3.54),('325','2013-04-26','11:50:00',2.77),('325','2013-04-26','11:55:00',2.69),('325','2013-04-26','12:00:00',3.36),('325','2013-04-26','12:05:00',2.97),('325','2013-04-26','12:10:00',2.6),('325','2013-04-26','12:15:00',2.79),('325','2013-04-26','12:20:00',3.11),('325','2013-04-26','12:25:00',1.82),('325','2013-04-26','12:30:00',1.86),('325','2013-04-26','12:35:00',2.6),('325','2013-04-26','12:40:00',3.15),('325','2013-04-26','12:45:00',3.08),('325','2013-04-26','12:50:00',2.25),('325','2013-04-26','12:55:00',2.01),('325','2013-04-26','13:00:00',1.39),('325','2013-04-26','13:05:00',1.38),('325','2013-04-26','13:10:00',1.78),('325','2013-04-26','13:15:00',3.07),('325','2013-04-26','13:20:00',1.94),('325','2013-04-26','13:25:00',2.32),('325','2013-04-26','13:30:00',3.68),('325','2013-04-26','13:35:00',2.61),('325','2013-04-26','13:40:00',2.9),('325','2013-04-26','13:45:00',2.68),('325','2013-04-26','13:50:00',3.47),('325','2013-04-26','13:55:00',3.78),('325','2013-04-26','14:00:00',3.42),('325','2013-04-26','14:05:00',3.89),('325','2013-04-26','14:10:00',3.3),('325','2013-04-26','14:15:00',3.67),('325','2013-04-26','14:20:00',3.67),('325','2013-04-26','14:25:00',4.34),('325','2013-04-26','14:30:00',4.24),('325','2013-04-26','14:35:00',2.76),('325','2013-04-26','14:40:00',1.92),('325','2013-04-26','14:45:00',1.67),('325','2013-04-26','14:50:00',4.19),('325','2013-04-26','14:55:00',4.41),('325','2013-04-26','15:00:00',3.96),('325','2013-04-26','15:05:00',2.48),('325','2013-04-26','15:10:00',1.92),('325','2013-04-26','15:15:00',2.29),('325','2013-04-26','15:20:00',1.57),('325','2013-04-26','15:25:00',1.79),('325','2013-04-26','15:30:00',2.64),('325','2013-04-26','15:35:00',1.99),('325','2013-04-26','15:40:00',2.33),('325','2013-04-26','15:45:00',2.71),('325','2013-04-26','15:50:00',2.11),('325','2013-04-26','15:55:00',1.08),('325','2013-04-25','08:15:00',1.07),('325','2013-04-25','08:40:00',1.07),('325','2013-04-25','08:45:00',1.34),('325','2013-04-25','08:50:00',1.69),('325','2013-04-25','08:55:00',1.73),('325','2013-04-25','09:00:00',1.5),('325','2013-04-25','09:05:00',1.26),('325','2013-04-25','09:10:00',1.25),('325','2013-04-25','09:15:00',1.16),('325','2013-04-25','09:20:00',1.21),('325','2013-04-25','09:25:00',1.29),('325','2013-04-25','09:30:00',1.35),('325','2013-04-25','09:35:00',1.58),('325','2013-04-25','09:40:00',2.18),('325','2013-04-25','09:45:00',2.73),('325','2013-04-25','09:50:00',3.11),('325','2013-04-25','09:55:00',3.13),('325','2013-04-25','10:00:00',3.12),('325','2013-04-25','10:05:00',2.86),('325','2013-04-25','10:10:00',2.57),('325','2013-04-25','10:15:00',2.83),('325','2013-04-25','10:20:00',3.06),('325','2013-04-25','10:25:00',3.44),('325','2013-04-25','10:30:00',3.57),('325','2013-04-25','10:35:00',3.62),('325','2013-04-25','10:40:00',3.65),('325','2013-04-25','10:45:00',3.59),('325','2013-04-25','10:50:00',3.73),('325','2013-04-25','10:55:00',3.81),('325','2013-04-25','11:00:00',3.91),('325','2013-04-25','11:05:00',3.95),('325','2013-04-25','11:10:00',4),('325','2013-04-25','11:15:00',4.02),('325','2013-04-25','11:20:00',4.06),('325','2013-04-25','11:25:00',4.11),('325','2013-04-25','11:30:00',4.14),('325','2013-04-25','11:35:00',4.09),('325','2013-04-25','11:40:00',4.23),('325','2013-04-25','11:45:00',4.29),('325','2013-04-25','11:50:00',4.37),('325','2013-04-25','11:55:00',4.36),('325','2013-04-25','12:00:00',4.27),('325','2013-04-25','12:05:00',4.29),('325','2013-04-25','12:10:00',4.37),('325','2013-04-25','12:15:00',4.39),('325','2013-04-25','12:20:00',4.39),('325','2013-04-25','12:25:00',4.38),('325','2013-04-25','12:30:00',4.4),('325','2013-04-25','12:35:00',4.42),('325','2013-04-25','12:40:00',4.43),('325','2013-04-25','12:45:00',4.46),('325','2013-04-25','12:50:00',4.45),('325','2013-04-25','12:55:00',4.46),('325','2013-04-25','13:00:00',4.49),('325','2013-04-25','13:05:00',4.52),('325','2013-04-25','13:10:00',4.41),('325','2013-04-25','13:15:00',4.42),('325','2013-04-25','13:20:00',3.98),('325','2013-04-25','13:25:00',3.64),('325','2013-04-25','13:30:00',2.83),('325','2013-04-25','13:35:00',2.74),('325','2013-04-25','13:40:00',2.48),('325','2013-04-25','13:45:00',2.29),('325','2013-04-25','13:50:00',2.22),('325','2013-04-25','13:55:00',2.44),('325','2013-04-25','14:00:00',2.5),('325','2013-04-25','14:05:00',2.27),('325','2013-04-25','14:10:00',2.5),('325','2013-04-25','14:15:00',2.67),('325','2013-04-25','14:20:00',2.72),('325','2013-04-25','14:25:00',2.76),('325','2013-04-25','14:30:00',3.37),('325','2013-04-25','14:35:00',3.83),('325','2013-04-25','14:40:00',3.62),('325','2013-04-25','14:45:00',3.72),('325','2013-04-25','14:50:00',3.43),('325','2013-04-25','14:55:00',3.55),('325','2013-04-25','15:00:00',3.39),('325','2013-04-25','15:05:00',3.08),('325','2013-04-25','15:10:00',3.14),('325','2013-04-25','15:15:00',3.54),('325','2013-04-25','15:20:00',3.78),('325','2013-04-25','15:25:00',3.8),('325','2013-04-25','15:30:00',3.72),('325','2013-04-25','15:35:00',3.55),('325','2013-04-25','15:40:00',3.25),('325','2013-04-25','15:45:00',3.21),('325','2013-04-25','15:50:00',2.97),('325','2013-04-25','15:55:00',2.91),('325','2013-04-25','16:00:00',2.87),('325','2013-04-25','16:05:00',2.46),('325','2013-04-25','16:10:00',2.47),('325','2013-04-25','16:15:00',2.42),('325','2013-04-25','16:20:00',2.57),('325','2013-04-25','16:25:00',2.23),('325','2013-04-25','16:30:00',2.18),('325','2013-04-25','16:35:00',2.62),('325','2013-04-25','16:40:00',2.29),('325','2013-04-25','16:45:00',2.36),('325','2013-04-25','16:50:00',1.97),('325','2013-04-25','16:55:00',2.02),('325','2013-04-25','17:00:00',1.98),('325','2013-04-25','17:05:00',2.31),('325','2013-04-25','17:10:00',2.38),('325','2013-04-25','17:15:00',2.28),('325','2013-04-25','17:20:00',2.28),('325','2013-04-25','17:25:00',1.87),('325','2013-04-25','17:30:00',1.54),('325','2013-04-25','17:35:00',1.46),('325','2013-04-25','17:40:00',1.44),('325','2013-04-25','17:45:00',1.23),('325','2013-04-25','17:50:00',1.02),('325','2013-04-24','08:25:00',1.04),('325','2013-04-24','08:30:00',1.04),('325','2013-04-24','08:35:00',1.04),('325','2013-04-24','08:40:00',1.08),('325','2013-04-24','08:45:00',1.13),('325','2013-04-24','08:50:00',1.17),('325','2013-04-24','08:55:00',1.25),('325','2013-04-24','09:00:00',1.39),('325','2013-04-24','09:05:00',1.95),('325','2013-04-24','09:10:00',2.27),('325','2013-04-24','09:15:00',1.87),('325','2013-04-24','09:20:00',1.77),('325','2013-04-24','09:25:00',2.45),('325','2013-04-24','09:30:00',2.28),('325','2013-04-24','09:35:00',2.68),('325','2013-04-24','09:40:00',2.58),('325','2013-04-24','09:45:00',2.6),('325','2013-04-24','09:50:00',2.73),('325','2013-04-24','09:55:00',3.03),('325','2013-04-24','10:00:00',3.13),('325','2013-04-24','10:05:00',3.19),('325','2013-04-24','10:10:00',3.44),('325','2013-04-24','10:15:00',3.42),('325','2013-04-24','10:20:00',3.37),('325','2013-04-24','10:25:00',3.36),('325','2013-04-24','10:30:00',3.33),('325','2013-04-24','10:35:00',3.36),('325','2013-04-24','10:40:00',3.79),('325','2013-04-24','10:45:00',3.83),('325','2013-04-24','10:50:00',3.93),('325','2013-04-24','10:55:00',4.04),('325','2013-04-24','11:00:00',4.02),('325','2013-04-24','11:05:00',3.97),('325','2013-04-24','11:10:00',4.28),('325','2013-04-24','11:15:00',4.32),('325','2013-04-24','11:20:00',4.44),('325','2013-04-24','11:25:00',4.3),('325','2013-04-24','11:30:00',4.29),('325','2013-04-24','11:35:00',3.83),('325','2013-04-24','11:40:00',3.2),('325','2013-04-24','11:45:00',2.85),('325','2013-04-24','11:50:00',2.19),('325','2013-04-24','11:55:00',3.4),('325','2013-04-24','12:00:00',3.71),('325','2013-04-24','12:05:00',2.62),('325','2013-04-24','12:10:00',3.22),('325','2013-04-24','12:15:00',4.3),('325','2013-04-24','12:20:00',4.98),('325','2013-04-24','12:25:00',4.2),('325','2013-04-24','12:30:00',4.2),('325','2013-04-24','12:35:00',4.34),('325','2013-04-24','12:40:00',4.1),('325','2013-04-24','12:45:00',4.3),('325','2013-04-24','12:50:00',4.52),('325','2013-04-24','12:55:00',4.35),('325','2013-04-24','13:00:00',4.23),('325','2013-04-24','13:05:00',3.76),('325','2013-04-24','13:10:00',4.84),('325','2013-04-24','13:15:00',4.43),('325','2013-04-24','13:20:00',4.18),('325','2013-04-24','13:25:00',4.38),('325','2013-04-24','13:30:00',3.98),('325','2013-04-24','13:35:00',4.27),('325','2013-04-24','13:40:00',4.77),('325','2013-04-24','13:45:00',3.86),('325','2013-04-24','13:50:00',3.13),('325','2013-04-24','13:55:00',4.58),('325','2013-04-24','14:00:00',4.34),('325','2013-04-24','14:05:00',3.13),('325','2013-04-24','14:10:00',3.33),('325','2013-04-24','14:15:00',4.42),('325','2013-04-24','14:20:00',4.04),('325','2013-04-24','14:25:00',4.12),('325','2013-04-24','14:30:00',3.85),('325','2013-04-24','14:35:00',3.51),('325','2013-04-24','14:40:00',3.32),('325','2013-04-24','14:45:00',3.28),('325','2013-04-24','14:50:00',2.93),('325','2013-04-24','14:55:00',2.58),('325','2013-04-24','15:00:00',2.82),('325','2013-04-24','15:05:00',2.6),('325','2013-04-24','15:10:00',2.37),('325','2013-04-24','15:15:00',2.52),('325','2013-04-24','15:20:00',2.74),('325','2013-04-24','15:25:00',2.19),('325','2013-04-24','15:30:00',1.9),('325','2013-04-24','15:35:00',1.85),('325','2013-04-24','15:40:00',1.83),('325','2013-04-24','15:45:00',1.84),('325','2013-04-24','15:50:00',1.89),('325','2013-04-24','15:55:00',2.5),('325','2013-04-24','16:00:00',2.97),('325','2013-04-24','16:05:00',3.12),('325','2013-04-24','16:10:00',3),('325','2013-04-24','16:15:00',2.89),('325','2013-04-24','16:20:00',3.63),('325','2013-04-24','16:25:00',2.73),('325','2013-04-24','16:30:00',2.3),('325','2013-04-24','16:35:00',2.11),('325','2013-04-24','16:40:00',2.77),('325','2013-04-24','16:45:00',2.78),('325','2013-04-24','16:50:00',2.55),('325','2013-04-24','16:55:00',2.95),('325','2013-04-24','17:00:00',2.86),('325','2013-04-24','17:05:00',2.69),('325','2013-04-24','17:10:00',2.63),('325','2013-04-24','17:15:00',1.84),('325','2013-04-24','17:20:00',1.95),('325','2013-04-24','17:25:00',1.62),('325','2013-04-24','17:30:00',1.08),('325','2013-04-24','17:50:00',1.18),('325','2013-04-24','17:55:00',1.52),('325','2013-04-24','18:00:00',1.15),('325','2013-04-24','18:05:00',1.25),('325','2013-04-23','09:00:00',1.86),('325','2013-04-23','09:05:00',2.03),('325','2013-04-23','09:10:00',2.32),('325','2013-04-23','09:15:00',2.41),('325','2013-04-23','09:20:00',2.53),('325','2013-04-23','09:25:00',2.64),('325','2013-04-23','09:30:00',2.69),('325','2013-04-23','09:35:00',2.71),('325','2013-04-23','09:40:00',2.56),('325','2013-04-23','09:45:00',2.83),('325','2013-04-23','09:50:00',3.27),('325','2013-04-23','09:55:00',3.34),('325','2013-04-23','10:00:00',3.29),('325','2013-04-23','10:05:00',3.39),('325','2013-04-23','10:10:00',3.51),('325','2013-04-23','10:15:00',3.56),('325','2013-04-23','10:20:00',3.59),('325','2013-04-23','10:25:00',3.68),('325','2013-04-23','10:30:00',3.74),('325','2013-04-23','10:35:00',3.85),('325','2013-04-23','10:40:00',3.9),('325','2013-04-23','10:45:00',3.89),('325','2013-04-23','10:50:00',4.05),('325','2013-04-23','10:55:00',4.11),('325','2013-04-23','11:00:00',4.16),('325','2013-04-23','11:05:00',4.16),('325','2013-04-23','11:10:00',4.22),('325','2013-04-23','11:15:00',4.24),('325','2013-04-23','11:20:00',4.28),('325','2013-04-23','11:25:00',4.31),('325','2013-04-23','11:30:00',4.33),('325','2013-04-23','11:35:00',4.35),('325','2013-04-23','11:40:00',4.44),('325','2013-04-23','11:45:00',4.48),('325','2013-04-23','11:50:00',4.51),('325','2013-04-23','11:55:00',4.5),('325','2013-04-23','12:00:00',4.52),('325','2013-04-23','12:05:00',4.52),('325','2013-04-23','12:10:00',4.53),('325','2013-04-23','12:15:00',4.53),('325','2013-04-23','12:20:00',4.55),('325','2013-04-23','12:25:00',4.63),('325','2013-04-23','12:30:00',4.8),('325','2013-04-23','12:35:00',5.03),('325','2013-04-23','12:40:00',5.11),('325','2013-04-23','12:45:00',4.29),('325','2013-04-23','12:50:00',3.08),('325','2013-04-23','12:55:00',3.26),('325','2013-04-23','13:00:00',4.57),('325','2013-04-23','13:05:00',4.57),('325','2013-04-23','13:10:00',3.81),('325','2013-04-23','13:15:00',4.4),('325','2013-04-23','13:20:00',4.14),('325','2013-04-23','13:25:00',3.74),('325','2013-04-23','13:30:00',4.83),('325','2013-04-23','13:35:00',4.9),('325','2013-04-23','13:40:00',4.84),('325','2013-04-23','13:45:00',3.53),('325','2013-04-23','13:50:00',4.46),('325','2013-04-23','13:55:00',4.82),('325','2013-04-23','14:00:00',4.39),('325','2013-04-23','14:05:00',4.89),('325','2013-04-23','14:10:00',4.4),('325','2013-04-23','14:15:00',4.31),('325','2013-04-23','14:20:00',4.2),('325','2013-04-23','14:25:00',3.9),('325','2013-04-23','14:30:00',4.54),('325','2013-04-23','14:35:00',4.27),('325','2013-04-23','14:40:00',4.43),('325','2013-04-23','14:45:00',3.84),('325','2013-04-23','14:50:00',2.38),('325','2013-04-23','14:55:00',2.52),('325','2013-04-23','15:00:00',2.66),('325','2013-04-23','15:05:00',2.82),('325','2013-04-23','15:10:00',3.4),('325','2013-04-23','15:15:00',3.31),('325','2013-04-23','15:20:00',3.08),('325','2013-04-23','15:25:00',2.75),('325','2013-04-23','15:30:00',2.74),('325','2013-04-23','15:35:00',2.59),('325','2013-04-23','15:40:00',2.4),('325','2013-04-23','15:45:00',3.01),('325','2013-04-23','15:50:00',2.13),('325','2013-04-23','15:55:00',2.21),('325','2013-04-23','16:00:00',2.53),('325','2013-04-23','16:05:00',2.9),('325','2013-04-23','16:10:00',2.88),('325','2013-04-23','16:15:00',2.36),('325','2013-04-23','16:20:00',1.58),('325','2013-04-23','16:25:00',1.5),('325','2013-04-23','16:30:00',1.25),('325','2013-04-23','16:35:00',1.18),('325','2013-04-23','16:40:00',1.16),('325','2013-04-23','16:45:00',1.23),('325','2013-04-23','16:50:00',1.09),('325','2013-04-23','16:55:00',1.14),('325','2013-04-23','17:00:00',1.21),('325','2013-04-23','17:05:00',1.26),('325','2013-04-23','17:10:00',1.56),('325','2013-04-23','17:15:00',1.4),('325','2013-04-23','17:20:00',1.03),('325','2013-04-23','17:25:00',1.89),('325','2013-04-23','17:30:00',1.55),('325','2013-04-23','17:35:00',1.12),('325','2014-03-28','07:50:00',1.01),('325','2014-03-28','07:55:00',1.06),('325','2014-03-28','08:00:00',1.1),('325','2014-03-28','08:05:00',1.17),('325','2014-03-28','08:10:00',1.23),('325','2014-03-28','08:15:00',1.28),('325','2014-03-28','08:20:00',1.34),('325','2014-03-28','08:25:00',1.38),('325','2014-03-28','08:30:00',1.43),('325','2014-03-28','08:35:00',1.49),('325','2014-03-28','08:40:00',1.54),('325','2014-03-28','08:45:00',1.58),('325','2014-03-28','08:50:00',1.64),('325','2014-03-28','08:55:00',1.7),('325','2014-03-28','09:00:00',1.76),('325','2014-03-28','09:05:00',1.87),('325','2014-03-28','09:10:00',2),('325','2014-03-28','09:15:00',2.02),('325','2014-03-28','09:20:00',2.03),('325','2014-03-28','09:25:00',2.51),('325','2014-03-28','09:30:00',3.65),('325','2014-03-28','09:35:00',3.28),('325','2014-03-28','09:40:00',1.92),('325','2014-03-28','09:45:00',2.04),('325','2014-03-28','09:50:00',2.71),('325','2014-03-28','09:55:00',4.01),('325','2014-03-28','10:00:00',3.81),('325','2014-03-28','10:05:00',3.96),('325','2014-03-28','10:10:00',3.75),('325','2014-03-28','10:15:00',2.83),('325','2014-03-28','10:20:00',2.79),('325','2014-03-28','10:25:00',3.86),('325','2014-03-28','10:30:00',3.91),('325','2014-03-28','10:35:00',4.01),('325','2014-03-28','10:40:00',3.81),('325','2014-03-28','10:45:00',3.34),('325','2014-03-28','10:50:00',3.7),('325','2014-03-28','10:55:00',4.39),('325','2014-03-28','11:00:00',4.38),('325','2014-03-28','11:05:00',4.14),('325','2014-03-28','11:10:00',2.83),('325','2014-03-28','11:15:00',2.17),('325','2014-03-28','11:20:00',3.21),('325','2014-03-28','11:25:00',2.8),('325','2014-03-28','11:30:00',2.79),('325','2014-03-28','11:35:00',3.23),('325','2014-03-28','11:40:00',1.57),('325','2014-03-28','11:45:00',3.58),('325','2014-03-28','11:50:00',1.67),('325','2014-03-28','11:55:00',1.43),('325','2014-03-28','12:00:00',1.17),('325','2014-03-28','12:05:00',4.84),('325','2014-03-28','12:10:00',4.99),('325','2014-03-28','12:15:00',5.16),('325','2014-03-28','12:20:00',5.17),('325','2014-03-28','12:25:00',1.06),('325','2014-03-28','12:30:00',1.19),('325','2014-03-28','12:35:00',4.46),('325','2014-03-28','12:40:00',4.69),('325','2014-03-28','12:45:00',4.79),('325','2014-03-28','12:50:00',3.59),('325','2014-03-28','12:55:00',1.68),('325','2014-03-28','13:00:00',4.74),('325','2014-03-28','13:05:00',3.18),('325','2014-03-28','13:10:00',1.81),('325','2014-03-28','13:15:00',2.19),('325','2014-03-28','13:20:00',1.96),('325','2014-03-28','13:25:00',1.57),('325','2014-03-28','13:30:00',1.69),('325','2014-03-28','13:35:00',4.78),('325','2014-03-28','13:40:00',4.4),('325','2014-03-28','13:45:00',4.5),('325','2014-03-28','13:50:00',4.27),('325','2014-03-28','13:55:00',4.25),('325','2014-03-28','14:00:00',4.21),('325','2014-03-28','14:05:00',4.13),('325','2014-03-28','14:10:00',4.09),('325','2014-03-28','14:15:00',4.05),('325','2014-03-28','14:20:00',3.99),('325','2014-03-28','14:25:00',3.95),('325','2014-03-28','14:30:00',3.88),('325','2014-03-28','14:35:00',3.83),('325','2014-03-28','14:40:00',3.78),('325','2014-03-28','14:45:00',3.71),('325','2014-03-28','14:50:00',3.65),('325','2014-03-28','14:55:00',3.59),('325','2014-03-28','15:00:00',3.54),('325','2014-03-28','15:05:00',3.45),('325','2014-03-28','15:10:00',3.35),('325','2014-03-28','15:15:00',3.28),('325','2014-03-28','15:20:00',3.19),('325','2014-03-28','15:25:00',3.1),('325','2014-03-28','15:30:00',3.03),('325','2014-03-28','15:35:00',2.94),('325','2014-03-28','15:40:00',2.79),('325','2014-03-28','15:45:00',2.78),('325','2014-03-28','15:50:00',2.76),('325','2014-03-28','15:55:00',2.63),('325','2014-03-28','16:00:00',2.67),('325','2014-03-28','16:05:00',2.7),('325','2014-03-28','16:10:00',2.62),('325','2014-03-28','16:15:00',2.5),('325','2014-03-28','16:20:00',2.16),('325','2014-03-28','16:25:00',1.91),('325','2014-03-28','16:30:00',1.81),('325','2014-03-28','16:45:00',1.27),('325','2014-03-28','16:50:00',1.36),('325','2014-03-28','17:00:00',1.09),('325','2014-03-27','07:55:00',1.1),('325','2014-03-27','08:00:00',1.38),('325','2014-03-27','08:05:00',1.44),('325','2014-03-27','09:15:00',1.01),('325','2014-03-27','10:05:00',1.21),('325','2014-03-27','10:10:00',1.28),('325','2014-03-27','10:15:00',1.3),('325','2014-03-27','10:20:00',1.79),('325','2014-03-27','10:25:00',2.58),('325','2014-03-27','10:30:00',2.22),('325','2014-03-27','10:35:00',1.91),('325','2014-03-27','10:40:00',1.99),('325','2014-03-27','10:45:00',1.05),('325','2014-03-27','11:10:00',2.38),('325','2014-03-27','11:15:00',1.91),('325','2014-03-27','11:20:00',1.01),('325','2014-03-27','11:50:00',1.25),('325','2014-03-27','11:55:00',1.44),('325','2014-03-27','12:00:00',1.1),('325','2014-03-27','12:05:00',1.04),('325','2014-03-27','12:10:00',1.14),('325','2014-03-27','12:20:00',1.05),('325','2014-03-27','13:00:00',1.06),('325','2014-03-27','13:05:00',1.33),('325','2014-03-27','13:10:00',1.82),('325','2014-03-27','13:15:00',2.4),('325','2014-03-27','13:20:00',2.52),('325','2014-03-27','13:25:00',2.52),('325','2014-03-27','13:30:00',2.14),('325','2014-03-27','13:35:00',1.94),('325','2014-03-27','13:40:00',1.84),('325','2014-03-27','13:45:00',1.69),('325','2014-03-27','13:50:00',2.48),('325','2014-03-27','13:55:00',3.1),('325','2014-03-27','14:00:00',2.31),('325','2014-03-27','14:05:00',1),('325','2014-03-27','14:15:00',3.25),('325','2014-03-27','14:20:00',4),('325','2014-03-27','14:25:00',4.6),('325','2014-03-27','14:30:00',3.91),('325','2014-03-27','14:35:00',2.31),('325','2014-03-27','14:40:00',2.04),('325','2014-03-27','14:45:00',1.81),('325','2014-03-27','14:50:00',2.07),('325','2014-03-27','14:55:00',1.83),('325','2014-03-27','15:00:00',4.02),('325','2014-03-27','15:05:00',1.16),('325','2014-03-27','15:20:00',1.07),('325','2014-03-27','15:25:00',2.87),('325','2014-03-27','15:30:00',4.02),('325','2014-03-27','15:35:00',3.37),('325','2014-03-27','15:40:00',1.4),('325','2014-03-27','16:05:00',1.06),('325','2014-03-27','16:10:00',1.23),('325','2014-03-27','16:15:00',1.03),('325','2014-03-27','16:25:00',1.23),('325','2014-03-27','16:30:00',1.37),('325','2014-03-27','16:55:00',1.01),('325','2014-05-01','08:25:00',1),('325','2014-05-01','08:30:00',1.05),('325','2014-05-01','08:35:00',1.1),('325','2014-05-01','08:40:00',1.15),('325','2014-05-01','08:45:00',1.21),('325','2014-05-01','08:50:00',1.45),('325','2014-05-01','08:55:00',1.76),('325','2014-05-01','09:00:00',1.26),('325','2014-05-01','09:10:00',1.85),('325','2014-05-01','09:15:00',1.7),('325','2014-05-01','09:20:00',1.62),('325','2014-05-01','09:25:00',2.6),('325','2014-05-01','09:30:00',2.64),('325','2014-05-01','09:35:00',2.99),('325','2014-05-01','09:40:00',3.26),('325','2014-05-01','09:45:00',2.67),('325','2014-05-01','09:50:00',2.47),('325','2014-05-01','09:55:00',2.25),('325','2014-05-01','10:00:00',1.54),('325','2014-05-01','10:05:00',1.71),('325','2014-05-01','10:10:00',2.23),('325','2014-05-01','10:15:00',3.03),('325','2014-05-01','10:20:00',1.53),('325','2014-05-01','10:25:00',1.35),('325','2014-05-01','10:30:00',3.83),('325','2014-05-01','10:35:00',3.01),('325','2014-05-01','10:40:00',1.65),('325','2014-05-01','10:45:00',4.12),('325','2014-05-01','10:50:00',4.21),('325','2014-05-01','10:55:00',3.84),('325','2014-05-01','11:00:00',2.32),('325','2014-05-01','11:05:00',4.7),('325','2014-05-01','11:10:00',2.92),('325','2014-05-01','11:20:00',3.76),('325','2014-05-01','11:25:00',4.69),('325','2014-05-01','11:30:00',4.8),('325','2014-05-01','11:35:00',4.63),('325','2014-05-01','11:40:00',4.56),('325','2014-05-01','11:45:00',4.91),('325','2014-05-01','11:50:00',5.03),('325','2014-05-01','11:55:00',1.57),('325','2014-05-01','12:00:00',1.68),('325','2014-05-01','12:05:00',5.4),('325','2014-05-01','12:10:00',3.04),('325','2014-05-01','12:15:00',4.67),('325','2014-05-01','12:20:00',5.06),('325','2014-05-01','12:25:00',5.08),('325','2014-05-01','12:30:00',3.79),('325','2014-05-01','12:35:00',5.13),('325','2014-05-01','12:40:00',4.13),('325','2014-05-01','12:45:00',2.08),('325','2014-05-01','12:50:00',4.73),('325','2014-05-01','12:55:00',5.38),('325','2014-05-01','13:00:00',5.32),('325','2014-05-01','13:05:00',5.12),('325','2014-05-01','13:10:00',3.43),('325','2014-05-01','13:15:00',4.45),('325','2014-05-01','13:20:00',4.42),('325','2014-05-01','13:25:00',1.71),('325','2014-05-01','13:30:00',2.13),('325','2014-05-01','13:35:00',2.19),('325','2014-05-01','13:40:00',5.36),('325','2014-05-01','13:45:00',5.32),('325','2014-05-01','13:50:00',4.67),('325','2014-05-01','13:55:00',2.83),('325','2014-05-01','14:00:00',2.7),('325','2014-05-01','14:05:00',5.13),('325','2014-05-01','14:10:00',4.92),('325','2014-05-01','14:15:00',4.81),('325','2014-05-01','14:20:00',4.71),('325','2014-05-01','14:25:00',4.7),('325','2014-05-01','14:30:00',4.49),('325','2014-05-01','14:35:00',4.46),('325','2014-05-01','14:40:00',4.78),('325','2014-05-01','14:45:00',4.79),('325','2014-05-01','14:50:00',4.74),('325','2014-05-01','14:55:00',4.6),('325','2014-05-01','15:00:00',4.42),('325','2014-05-01','15:05:00',4.69),('325','2014-05-01','15:10:00',4.26),('325','2014-05-01','15:15:00',4.36),('325','2014-05-01','15:20:00',4.28),('325','2014-05-01','15:25:00',4.23),('325','2014-05-01','15:30:00',4.13),('325','2014-05-01','15:35:00',4.06),('325','2014-05-01','15:40:00',3.95),('325','2014-05-01','15:45:00',3.77),('325','2014-05-01','15:50:00',3.89),('325','2014-05-01','15:55:00',3.71),('325','2014-05-01','16:00:00',3.72),('325','2014-05-01','16:05:00',3.66),('325','2014-05-01','16:10:00',3.49),('325','2014-05-01','16:15:00',3.46),('325','2014-05-01','16:20:00',3.29),('325','2014-05-01','16:25:00',3),('325','2014-05-01','16:30:00',3.13),('325','2014-05-01','16:35:00',3.19),('325','2014-05-01','16:40:00',2.98),('325','2014-05-01','16:45:00',2.45),('325','2014-05-01','16:50:00',2.26),('325','2014-05-01','16:55:00',2.53),('325','2014-05-01','17:00:00',2.52),('325','2014-05-01','17:05:00',2.39),('325','2014-05-01','17:10:00',2.57),('325','2014-05-01','17:15:00',2.42),('325','2014-05-01','17:20:00',2.33),('325','2014-05-01','17:25:00',2.22),('325','2014-05-01','17:30:00',2.12),('325','2014-05-01','17:35:00',2),('325','2014-05-01','17:40:00',1.9),('325','2014-05-01','17:45:00',1.81),('325','2014-05-01','17:50:00',1.72),('325','2014-05-01','17:55:00',1.64),('325','2014-05-01','18:00:00',1.6),('325','2014-05-01','18:05:00',1.46),('325','2014-05-01','18:10:00',1.31),('325','2014-05-01','18:15:00',1.23),('325','2014-05-01','18:20:00',1.11),('325','2014-05-01','18:25:00',1.02),('325','2014-03-26','07:55:00',1.04),('325','2014-03-26','08:00:00',1.1),('325','2014-03-26','08:05:00',1.18),('325','2014-03-26','08:10:00',1.27),('325','2014-03-26','08:15:00',1.48),('325','2014-03-26','08:20:00',1.6),('325','2014-03-26','08:25:00',1.24),('325','2014-03-26','08:30:00',1.02),('325','2014-03-26','08:40:00',1.07),('325','2014-03-26','08:45:00',1.16),('325','2014-03-26','08:50:00',1.34),('325','2014-03-26','08:55:00',1.2),('325','2014-03-26','09:00:00',1.34),('325','2014-03-26','09:05:00',1.28),('325','2014-03-26','09:10:00',1.51),('325','2014-03-26','09:15:00',1.23),('325','2014-03-26','09:25:00',1.48),('325','2014-03-26','09:30:00',3.01),('325','2014-03-26','09:35:00',3.45),('325','2014-03-26','09:40:00',3.5),('325','2014-03-26','09:45:00',3.54),('325','2014-03-26','09:50:00',3.62),('325','2014-03-26','09:55:00',3.68),('325','2014-03-26','10:00:00',3.58),('325','2014-03-26','10:05:00',2.73),('325','2014-03-26','10:10:00',2.7),('325','2014-03-26','10:15:00',4.27),('325','2014-03-26','10:20:00',2.76),('325','2014-03-26','10:25:00',4.07),('325','2014-03-26','10:30:00',4.14),('325','2014-03-26','10:35:00',1.22),('325','2014-03-26','10:45:00',1.16),('325','2014-03-26','10:50:00',2.34),('325','2014-03-26','10:55:00',5.38),('325','2014-03-26','11:00:00',2.85),('325','2014-03-26','11:05:00',1.2),('325','2014-03-26','11:10:00',1.97),('325','2014-03-26','11:15:00',5.2),('325','2014-03-26','11:20:00',2.14),('325','2014-03-26','11:25:00',1.29),('325','2014-03-26','11:30:00',1.82),('325','2014-03-26','11:35:00',1.79),('325','2014-03-26','11:40:00',2.14),('325','2014-03-26','11:45:00',5.33),('325','2014-03-26','11:50:00',5.17),('325','2014-03-26','11:55:00',5.36),('325','2014-03-26','12:00:00',4.78),('325','2014-03-26','12:05:00',5.13),('325','2014-03-26','12:10:00',4.47),('325','2014-03-26','12:15:00',1.78),('325','2014-03-26','12:20:00',1.95),('325','2014-03-26','12:25:00',1.74),('325','2014-03-26','12:30:00',1.74),('325','2014-03-26','12:35:00',1.61),('325','2014-03-26','12:40:00',2.32),('325','2014-03-26','12:45:00',2.25),('325','2014-03-26','12:50:00',1.6),('325','2014-03-26','12:55:00',1.22),('325','2014-03-26','13:00:00',1.37),('325','2014-03-26','13:05:00',1.72),('325','2014-03-26','13:10:00',1.11),('325','2014-03-26','13:20:00',4.41),('325','2014-03-26','13:25:00',4.92),('325','2014-03-26','13:30:00',2.84),('325','2014-03-26','13:35:00',2.74),('325','2014-03-26','13:40:00',1.28),('325','2014-03-26','13:45:00',1.07),('325','2014-03-26','13:50:00',1.14),('325','2014-03-26','13:55:00',1.53),('325','2014-03-26','14:00:00',3.15),('325','2014-03-26','14:05:00',5.06),('325','2014-03-26','14:10:00',2.56),('325','2014-03-26','14:15:00',1.11),('325','2014-03-26','14:20:00',1.02),('325','2014-03-26','14:40:00',1.18),('325','2014-03-26','14:45:00',2.71),('325','2014-03-26','14:50:00',3.58),('325','2014-03-26','14:55:00',3.82),('325','2014-03-26','15:00:00',3.49),('325','2014-03-26','15:05:00',3.37),('325','2014-03-26','15:10:00',3.48),('325','2014-03-26','15:15:00',3.59),('325','2014-03-26','15:20:00',3.5),('325','2014-03-26','15:25:00',3.49),('325','2014-03-26','15:30:00',3.45),('325','2014-03-26','15:35:00',3.24),('325','2014-03-26','15:40:00',2.67),('325','2014-03-26','15:45:00',2.67),('325','2014-03-26','15:50:00',1.78),('325','2014-03-26','15:55:00',1.59),('325','2014-03-26','16:00:00',1.44),('325','2014-03-26','16:05:00',1.38),('325','2014-03-26','16:10:00',1.58),('325','2014-03-26','16:15:00',1.68),('325','2014-03-26','16:20:00',1.16),('325','2014-03-25','07:25:00',1.08),('325','2014-03-25','07:30:00',1.14),('325','2014-03-25','07:45:00',1.04),('325','2014-03-25','07:50:00',1.13),('325','2014-03-25','07:55:00',1.15),('325','2014-03-25','08:00:00',1.13),('325','2014-03-25','08:05:00',1.17),('325','2014-03-25','08:10:00',1.26),('325','2014-03-25','08:15:00',1.32),('325','2014-03-25','08:20:00',1.24),('325','2014-03-25','08:25:00',1.15),('325','2014-03-25','08:30:00',1.06),('325','2014-03-25','08:35:00',1.1),('325','2014-03-25','08:40:00',1.29),('325','2014-03-25','08:45:00',1.64),('325','2014-03-25','08:50:00',1.71),('325','2014-03-25','08:55:00',1.78),('325','2014-03-25','09:00:00',1.65),('325','2014-03-25','09:05:00',1.66),('325','2014-03-25','09:10:00',1.63),('325','2014-03-25','09:15:00',2.01),('325','2014-03-25','09:20:00',2.22),('325','2014-03-25','09:25:00',2.02),('325','2014-03-25','09:30:00',1.89),('325','2014-03-25','09:35:00',1.8),('325','2014-03-25','09:40:00',1.81),('325','2014-03-25','09:45:00',1.72),('325','2014-03-25','09:50:00',1.8),('325','2014-03-25','09:55:00',2.05),('325','2014-03-25','10:00:00',2.48),('325','2014-03-25','10:05:00',2.71),('325','2014-03-25','10:10:00',2.86),('325','2014-03-25','10:15:00',3.08),('325','2014-03-25','10:20:00',3.06),('325','2014-03-25','10:25:00',3.06),('325','2014-03-25','10:30:00',3.24),('325','2014-03-25','10:35:00',2.64),('325','2014-03-25','10:40:00',2.16),('325','2014-03-25','10:45:00',2),('325','2014-03-25','10:50:00',1.94),('325','2014-03-25','10:55:00',1.95),('325','2014-03-25','11:00:00',2.12),('325','2014-03-25','11:05:00',2.41),('325','2014-03-25','11:10:00',2.69),('325','2014-03-25','11:15:00',3),('325','2014-03-25','11:20:00',3.03),('325','2014-03-25','11:25:00',2.92),('325','2014-03-25','11:30:00',2.85),('325','2014-03-25','11:35:00',2.5),('325','2014-03-25','11:40:00',2.77),('325','2014-03-25','11:45:00',2.11),('325','2014-03-25','11:50:00',2.52),('325','2014-03-25','11:55:00',1.62),('325','2014-03-25','12:00:00',1.08),('325','2014-03-25','12:20:00',1.18),('325','2014-03-25','12:25:00',1.23),('325','2014-03-24','07:45:00',1.13),('325','2014-03-24','08:55:00',1.49),('325','2014-03-24','09:00:00',1.53),('325','2014-03-24','09:20:00',1.14),('325','2014-03-24','09:30:00',1.22),('325','2014-03-24','09:40:00',1.55),('325','2014-03-24','09:45:00',1.02),('325','2014-03-24','10:00:00',2.67),('325','2014-03-24','10:05:00',3.01),('325','2014-03-24','10:10:00',3.8),('325','2014-03-24','10:15:00',2.4),('325','2014-03-24','10:35:00',1.52),('325','2014-03-24','10:40:00',1.06),('325','2014-03-24','10:45:00',2.18),('325','2014-03-24','10:50:00',5.09),('325','2014-03-24','10:55:00',3.84),('325','2014-03-24','11:00:00',2.19),('325','2014-03-24','11:05:00',2.54),('325','2014-03-24','11:10:00',3.28),('325','2014-03-24','11:15:00',3.81),('325','2014-03-24','11:20:00',3.29),('325','2014-03-24','11:25:00',3.57),('325','2014-03-24','11:30:00',3.97),('325','2014-03-24','11:35:00',1.4),('325','2014-03-24','12:30:00',1.21),('325','2014-03-24','12:35:00',2.02),('325','2014-03-24','12:40:00',2.09),('325','2014-03-24','12:45:00',1.75),('325','2014-03-24','12:50:00',1.42),('325','2014-03-24','12:55:00',1.38),('325','2014-03-24','13:00:00',1.41),('325','2014-03-24','13:05:00',1.38),('325','2014-03-24','13:10:00',1.18),('325','2014-03-24','13:15:00',1.03),('325','2014-03-24','13:20:00',1.07),('325','2014-03-24','13:25:00',1.28),('325','2014-03-24','13:30:00',1.47),('325','2014-03-24','13:35:00',1.15),('325','2014-03-24','13:45:00',1.2),('325','2014-03-24','13:50:00',1.34),('325','2014-03-24','13:55:00',1.31),('325','2014-03-24','14:00:00',1.13),('325','2014-03-24','14:05:00',1.06),('325','2014-03-24','14:10:00',1.33),('325','2014-03-24','14:15:00',1.8),('325','2014-03-24','14:20:00',2.28),('325','2014-03-24','14:25:00',2.14),('325','2014-03-24','14:30:00',2.06),('325','2014-03-24','14:35:00',2.6),('325','2014-03-24','14:40:00',3.31),('325','2014-03-24','14:45:00',3.73),('325','2014-03-24','14:50:00',3.76),('325','2014-03-24','14:55:00',3.29),('325','2014-03-24','15:00:00',2.75),('325','2014-03-24','15:05:00',2.6),('325','2014-03-24','15:10:00',2.22),('325','2014-03-24','15:15:00',1.63),('325','2014-03-24','15:20:00',1.83),('325','2014-03-24','15:25:00',1.76),('325','2014-03-24','15:30:00',1.81),('325','2014-03-24','15:35:00',1.66),('325','2014-03-24','15:40:00',1.34),('325','2014-03-24','15:45:00',1.23),('325','2014-03-24','15:50:00',1.4),('325','2014-03-24','15:55:00',1.81),('325','2014-03-24','16:00:00',2.71),('325','2014-03-24','16:05:00',1.45),('325','2014-03-24','16:10:00',1.14),('325','2014-03-23','08:50:00',1.14),('325','2014-03-23','08:55:00',1.33),('325','2014-03-23','09:05:00',1.55),('325','2014-03-23','09:10:00',2.2),('325','2014-03-23','09:15:00',2.19),('325','2014-03-23','09:20:00',1.64),('325','2014-03-23','09:25:00',1.09),('325','2014-03-23','09:30:00',1.47),('325','2014-03-23','09:35:00',1.52),('325','2014-03-23','09:40:00',1.3),('325','2014-03-23','10:25:00',1.25),('325','2014-03-23','10:40:00',1.28),('325','2014-03-23','10:45:00',1.16),('325','2014-03-23','10:50:00',1.36),('325','2014-03-23','10:55:00',1.74),('325','2014-03-23','11:00:00',1.26),('325','2014-03-23','11:05:00',1.1),('325','2014-03-23','11:10:00',1.38),('325','2014-03-23','11:25:00',1.01),('325','2014-03-23','11:35:00',2.01),('325','2014-03-23','11:40:00',3.31),('325','2014-03-23','13:40:00',1.15),('325','2014-03-23','13:45:00',2.5),('325','2014-03-23','13:50:00',1.59),('325','2014-03-23','13:55:00',1.24),('325','2014-03-23','15:05:00',1.05),('325','2014-03-23','15:10:00',1.29),('325','2014-03-23','15:15:00',1.82),('325','2014-03-23','15:20:00',1.76),('325','2014-03-23','15:25:00',1.59),('325','2014-03-23','15:30:00',1.39),('325','2014-03-22','07:40:00',1.12),('325','2014-03-22','07:45:00',1.07),('325','2014-03-22','08:15:00',1.09),('325','2014-03-22','08:20:00',1.27),('325','2014-03-22','08:25:00',1.32),('325','2014-03-22','08:30:00',1.22),('325','2014-03-22','08:40:00',1.75),('325','2014-03-22','08:45:00',1.68),('325','2014-03-22','08:50:00',1.53),('325','2014-03-22','08:55:00',1.72),('325','2014-03-22','09:00:00',1.66),('325','2014-03-22','09:05:00',1.35),('325','2014-03-22','09:10:00',1.46),('325','2014-03-22','09:15:00',1.28),('325','2014-03-22','09:20:00',1.39),('325','2014-03-22','09:25:00',1.67),('325','2014-03-22','09:30:00',1.96),('325','2014-03-22','09:35:00',1.43),('325','2014-03-22','09:40:00',2.71),('325','2014-03-22','09:45:00',3.16),('325','2014-03-22','09:50:00',3.25),('325','2014-03-22','09:55:00',3.42),('325','2014-03-22','10:00:00',3.18),('325','2014-03-22','10:05:00',2.29),('325','2014-03-22','10:10:00',2.25),('325','2014-03-22','10:15:00',1.84),('325','2014-03-22','10:20:00',1.1),('325','2014-03-22','10:30:00',1.08),('325','2014-03-22','10:35:00',1.63),('325','2014-03-22','10:40:00',1.93),('325','2014-03-22','10:45:00',2.84),('325','2014-03-22','10:50:00',1.98),('325','2014-03-22','10:55:00',1.38),('325','2014-03-22','11:00:00',1.05),('325','2014-03-22','11:05:00',1.21),('325','2014-03-22','11:10:00',1.57),('325','2014-03-22','11:15:00',2.14),('325','2014-03-22','11:20:00',4.35),('325','2014-03-22','11:25:00',4.89),('325','2014-03-22','11:30:00',2.52),('325','2014-03-22','11:35:00',2.71),('325','2014-03-22','11:40:00',2.59),('325','2014-03-22','11:45:00',1.62),('325','2014-03-22','11:50:00',2.27),('325','2014-03-22','11:55:00',4.39),('325','2014-03-22','12:00:00',1.76),('325','2014-03-22','12:05:00',1.69),('325','2014-03-22','12:10:00',1.43),('325','2014-03-22','12:15:00',2.36),('325','2014-03-22','12:20:00',4.11),('325','2014-03-22','12:25:00',2.35),('325','2014-03-22','12:30:00',2.42),('325','2014-03-22','12:35:00',3.8),('325','2014-03-22','12:40:00',4.69),('325','2014-03-22','12:45:00',3.55),('325','2014-03-22','12:50:00',3.74),('325','2014-03-22','12:55:00',3.13),('325','2014-03-22','13:00:00',1.74),('325','2014-03-22','13:05:00',4.44),('325','2014-03-22','13:10:00',4.51),('325','2014-03-22','13:15:00',3.6),('325','2014-03-22','13:20:00',4.54),('325','2014-03-22','13:25:00',4),('325','2014-03-22','13:30:00',3.52),('325','2014-03-22','13:35:00',3.87),('325','2014-03-22','13:40:00',3.79),('325','2014-03-22','13:45:00',2.98),('325','2014-03-22','13:50:00',3.61),('325','2014-03-22','13:55:00',3.1),('325','2014-03-22','14:00:00',3.7),('325','2014-03-22','14:05:00',2.97),('325','2014-03-22','14:10:00',3.48),('325','2014-03-22','14:15:00',2.4),('325','2014-03-22','14:20:00',3.51),('325','2014-03-22','14:25:00',3.64),('325','2014-03-22','14:30:00',3.57),('325','2014-03-22','14:35:00',3.51),('325','2014-03-22','14:40:00',3.41),('325','2014-03-22','14:45:00',3.3),('325','2014-03-22','14:50:00',3.26),('325','2014-03-22','14:55:00',3.15),('325','2014-03-22','15:00:00',3.07),('325','2014-03-22','15:05:00',3.06),('325','2014-03-22','15:10:00',2.92),('325','2014-03-22','15:15:00',2.87),('325','2014-03-22','15:20:00',2.81),('325','2014-03-22','15:25:00',1.99),('325','2014-03-22','15:30:00',1.54),('325','2014-03-22','15:35:00',3.1),('325','2014-03-22','15:40:00',3.18),('325','2014-03-22','15:45:00',2.95),('325','2014-03-22','15:50:00',2.84),('325','2014-03-22','15:55:00',2.6),('325','2014-03-22','16:00:00',2.29),('325','2014-03-22','16:05:00',2.05),('325','2014-03-22','16:10:00',1.96),('325','2014-03-22','16:15:00',1.87),('325','2014-03-22','16:20:00',1.75),('325','2014-03-22','16:25:00',1.22),('325','2014-03-21','08:05:00',1.02),('325','2014-03-21','08:10:00',1.08),('325','2014-03-21','08:15:00',1.12),('325','2014-03-21','08:20:00',1.16),('325','2014-03-21','08:25:00',1.23),('325','2014-03-21','08:30:00',1.3),('325','2014-03-21','08:35:00',1.35),('325','2014-03-21','08:40:00',1.39),('325','2014-03-21','08:45:00',1.42),('325','2014-03-21','08:50:00',1.46),('325','2014-03-21','08:55:00',1.52),('325','2014-03-21','09:00:00',1.56),('325','2014-03-21','09:05:00',1.6),('325','2014-03-21','09:10:00',1.67),('325','2014-03-21','09:15:00',1.71),('325','2014-03-21','09:20:00',1.77),('325','2014-03-21','09:25:00',1.75),('325','2014-03-21','09:30:00',1.85),('325','2014-03-21','09:35:00',2.69),('325','2014-03-21','09:40:00',3.06),('325','2014-03-21','09:45:00',3.12),('325','2014-03-21','09:50:00',3.17),('325','2014-03-21','09:55:00',3.17),('325','2014-03-21','10:00:00',3.22),('325','2014-03-21','10:05:00',3.33),('325','2014-03-21','10:10:00',3.43),('325','2014-03-21','10:15:00',3.5),('325','2014-03-21','10:20:00',3.52),('325','2014-03-21','10:25:00',3.6),('325','2014-03-21','10:30:00',3.65),('325','2014-03-21','10:35:00',3.7),('325','2014-03-21','10:40:00',3.68),('325','2014-03-21','10:45:00',3.64),('325','2014-03-21','10:50:00',3.67),('325','2014-03-21','10:55:00',3.72),('325','2014-03-21','11:00:00',3.77),('325','2014-03-21','11:05:00',3.77),('325','2014-03-21','11:10:00',3.89),('325','2014-03-21','11:15:00',3.93),('325','2014-03-21','11:20:00',3.94),('325','2014-03-21','11:25:00',3.89),('325','2014-03-21','11:30:00',2.18),('325','2014-03-21','11:35:00',3.6),('325','2014-03-21','11:40:00',3.92),('325','2014-03-21','11:45:00',4.03),('325','2014-03-21','11:50:00',4.36),('325','2014-03-21','11:55:00',4.23),('325','2014-03-21','12:00:00',3.16),('325','2014-03-21','12:05:00',3.98),('325','2014-03-21','12:10:00',4.16),('325','2014-03-21','12:15:00',4.19),('325','2014-03-21','12:20:00',4.15),('325','2014-03-21','12:25:00',4.1),('325','2014-03-21','12:30:00',4.13),('325','2014-03-21','12:35:00',4.14),('325','2014-03-21','12:40:00',4.2),('325','2014-03-21','12:45:00',4.23),('325','2014-03-21','12:50:00',4.17),('325','2014-03-21','12:55:00',4.13),('325','2014-03-21','13:00:00',4.17),('325','2014-03-21','13:05:00',4.12),('325','2014-03-21','13:10:00',4.13),('325','2014-03-21','13:15:00',4.11),('325','2014-03-21','13:20:00',4.04),('325','2014-03-21','13:25:00',4.01),('325','2014-03-21','13:30:00',4.02),('325','2014-03-21','13:35:00',3.95),('325','2014-03-21','13:40:00',3.94),('325','2014-03-21','13:45:00',3.94),('325','2014-03-21','13:50:00',3.9),('325','2014-03-21','13:55:00',3.88),('325','2014-03-21','14:00:00',3.88),('325','2014-03-21','14:05:00',3.84),('325','2014-03-21','14:10:00',3.78),('325','2014-03-21','14:15:00',3.75),('325','2014-03-21','14:20:00',3.65),('325','2014-03-21','14:25:00',3.6),('325','2014-03-21','14:30:00',3.5),('325','2014-03-21','14:35:00',3.36),('325','2014-03-21','14:40:00',3.34),('325','2014-03-21','14:45:00',3.18),('325','2014-03-21','14:50:00',2.69),('325','2014-03-21','14:55:00',1.13),('325','2014-03-21','15:00:00',1.07),('325','2014-03-21','15:05:00',2.17),('325','2014-03-21','15:10:00',3.45),('325','2014-03-21','15:15:00',3.37),('325','2014-03-21','15:20:00',2.76),('325','2014-03-21','15:25:00',3.33),('325','2014-03-21','15:30:00',3.15),('325','2014-03-21','15:35:00',2.92),('325','2014-03-21','15:40:00',2.91),('325','2014-03-21','15:45:00',2.77),('325','2014-03-21','15:50:00',2.76),('325','2014-03-21','15:55:00',2.71),('325','2014-03-21','16:00:00',2.5),('325','2014-03-21','16:05:00',2.33),('325','2014-03-21','16:10:00',2.16),('325','2014-03-21','16:15:00',1.99),('325','2014-03-21','16:20:00',1.78),('325','2014-03-21','16:25:00',1.64),('325','2014-03-21','16:30:00',1.53),('325','2014-03-21','16:35:00',1.41),('325','2014-03-21','16:40:00',1.32),('325','2014-03-21','16:45:00',1.23),('325','2014-03-21','16:50:00',1.12),('325','2014-03-21','16:55:00',1.01),('325','2014-03-20','07:55:00',1),('325','2014-03-20','08:00:00',1.07),('325','2014-03-20','08:05:00',1.11),('325','2014-03-20','08:10:00',1.14),('325','2014-03-20','08:15:00',1.17),('325','2014-03-20','08:20:00',1.2),('325','2014-03-20','08:25:00',1.26),('325','2014-03-20','08:30:00',1.32),('325','2014-03-20','08:35:00',1.38),('325','2014-03-20','08:40:00',1.45),('325','2014-03-20','08:45:00',1.51),('325','2014-03-20','08:50:00',1.55),('325','2014-03-20','08:55:00',1.59),('325','2014-03-20','09:00:00',1.62),('325','2014-03-20','09:05:00',1.7),('325','2014-03-20','09:10:00',1.76),('325','2014-03-20','09:15:00',1.79),('325','2014-03-20','09:20:00',1.85),('325','2014-03-20','09:25:00',1.87),('325','2014-03-20','09:30:00',1.91),('325','2014-03-20','09:35:00',2.54),('325','2014-03-20','09:40:00',3),('325','2014-03-20','09:45:00',3.05),('325','2014-03-20','09:50:00',3.05),('325','2014-03-20','09:55:00',3.13),('325','2014-03-20','10:00:00',3.32),('325','2014-03-20','10:05:00',3.44),('325','2014-03-20','10:10:00',3.49),('325','2014-03-20','10:15:00',3.49),('325','2014-03-20','10:20:00',3.5),('325','2014-03-20','10:25:00',3.56),('325','2014-03-20','10:30:00',3.58),('325','2014-03-20','10:35:00',3.47),('325','2014-03-20','10:40:00',3.43),('325','2014-03-20','10:45:00',3.52),('325','2014-03-20','10:50:00',3.72),('325','2014-03-20','10:55:00',3.91),('325','2014-03-20','11:00:00',3.94),('325','2014-03-20','11:05:00',3.93),('325','2014-03-20','11:10:00',3.9),('325','2014-03-20','11:15:00',3.71),('325','2014-03-20','11:20:00',3.88),('325','2014-03-20','11:25:00',3.93),('325','2014-03-20','11:30:00',4.02),('325','2014-03-20','11:35:00',4.1),('325','2014-03-20','11:40:00',4.06),('325','2014-03-20','11:45:00',4.02),('325','2014-03-20','11:50:00',4.11),('325','2014-03-20','11:55:00',3.82),('325','2014-03-20','12:00:00',3.62),('325','2014-03-20','12:05:00',3.98),('325','2014-03-20','12:10:00',4.11),('325','2014-03-20','12:15:00',4.13),('325','2014-03-20','12:20:00',4.04),('325','2014-03-20','12:25:00',3.88),('325','2014-03-20','12:30:00',4.02),('325','2014-03-20','12:35:00',4.08),('325','2014-03-20','12:40:00',4.08),('325','2014-03-20','12:45:00',4.16),('325','2014-03-20','12:50:00',4.08),('325','2014-03-20','12:55:00',4.1),('325','2014-03-20','13:00:00',4.05),('325','2014-03-20','13:05:00',4.01),('325','2014-03-20','13:10:00',3.92),('325','2014-03-20','13:15:00',3.87),('325','2014-03-20','13:20:00',3.91),('325','2014-03-20','13:25:00',3.79),('325','2014-03-20','13:30:00',3.88),('325','2014-03-20','13:35:00',3.78),('325','2014-03-20','13:40:00',3.61),('325','2014-03-20','13:45:00',3.47),('325','2014-03-20','13:50:00',3.34),('325','2014-03-20','13:55:00',3.09),('325','2014-03-20','14:00:00',3.29),('325','2014-03-20','14:05:00',3.48),('325','2014-03-20','14:10:00',3.34),('325','2014-03-20','14:15:00',3.19),('325','2014-03-20','14:20:00',3.12),('325','2014-03-20','14:25:00',3.07),('325','2014-03-20','14:30:00',2.64),('325','2014-03-20','14:35:00',2.47),('325','2014-03-20','14:40:00',2.74),('325','2014-03-20','14:45:00',2.68),('325','2014-03-20','14:50:00',2.57),('325','2014-03-20','14:55:00',2.48),('325','2014-03-20','15:00:00',2.27),('325','2014-03-20','15:05:00',2.3),('325','2014-03-20','15:10:00',2.34),('325','2014-03-20','15:15:00',2.23),('325','2014-03-20','15:20:00',2.41),('325','2014-03-20','15:25:00',2.16),('325','2014-03-20','15:30:00',2.05),('325','2014-03-20','15:35:00',1.97),('325','2014-03-20','15:40:00',1.77),('325','2014-03-20','15:45:00',1.77),('325','2014-03-20','15:50:00',1.53),('325','2014-03-20','15:55:00',1.42),('325','2014-03-20','16:00:00',1.22),('325','2014-03-20','16:05:00',1.1),('325','2014-03-20','16:10:00',1.12),('325','2014-03-20','16:15:00',1.07),('325','2014-03-20','16:20:00',1.11),('325','2014-03-20','16:25:00',1.12),('325','2014-03-20','16:30:00',1.04),('325','2014-03-19','09:00:00',1.02),('325','2014-03-19','09:05:00',1.26),('325','2014-03-19','09:10:00',1.37),('325','2014-03-19','09:15:00',1.57),('325','2014-03-19','09:20:00',1.69),('325','2014-03-19','09:25:00',2.49),('325','2014-03-19','09:30:00',2.95),('325','2014-03-19','09:35:00',2.38),('325','2014-03-19','09:40:00',2.55),('325','2014-03-19','09:45:00',2.46),('325','2014-03-19','09:50:00',2.24),('325','2014-03-19','09:55:00',1.7),('325','2014-03-19','10:00:00',1.33),('325','2014-03-19','10:25:00',1.07),('325','2014-03-19','10:30:00',1.39),('325','2014-03-19','10:35:00',2.31),('325','2014-03-19','10:40:00',1.76),('325','2014-03-19','10:45:00',1.73),('325','2014-03-19','10:50:00',1.54),('325','2014-03-19','10:55:00',3.93),('325','2014-03-19','11:00:00',3.68),('325','2014-03-19','11:05:00',3.26),('325','2014-03-19','11:10:00',1.72),('325','2014-03-19','11:15:00',1.77),('325','2014-03-19','11:20:00',1.59),('325','2014-03-19','11:25:00',1.73),('325','2014-03-19','11:30:00',1.79),('325','2014-03-19','11:35:00',2.19),('325','2014-03-19','11:40:00',2),('325','2014-03-19','11:45:00',2.01),('325','2014-03-19','11:50:00',2.22),('325','2014-03-19','11:55:00',2.12),('325','2014-03-19','12:00:00',4.16),('325','2014-03-19','12:05:00',4.64),('325','2014-03-19','12:10:00',4.49),('325','2014-03-19','12:15:00',4.63),('325','2014-03-19','12:20:00',4.53),('325','2014-03-19','12:25:00',2.99),('325','2014-03-19','12:30:00',4.02),('325','2014-03-19','12:35:00',1.73),('325','2014-03-19','12:40:00',2.99),('325','2014-03-19','12:45:00',3.53),('325','2014-03-19','12:50:00',3.98),('325','2014-03-19','12:55:00',3.7),('325','2014-03-19','13:00:00',4.14),('325','2014-03-19','13:05:00',4.03),('325','2014-03-19','13:10:00',3.61),('325','2014-03-19','13:15:00',3.45),('325','2014-03-19','13:20:00',3.66),('325','2014-03-19','13:25:00',3.59),('325','2014-03-19','13:30:00',4.02),('325','2014-03-19','13:35:00',4),('325','2014-03-19','13:40:00',3.88),('325','2014-03-19','13:45:00',3.8),('325','2014-03-19','13:50:00',3.63),('325','2014-03-19','13:55:00',3.78),('325','2014-03-19','14:00:00',3.74),('325','2014-03-19','14:05:00',3.76),('325','2014-03-19','14:10:00',3.66),('325','2014-03-19','14:15:00',3.64),('325','2014-03-19','14:20:00',3.48),('325','2014-03-19','14:25:00',3.49),('325','2014-03-19','14:30:00',3.35),('325','2014-03-19','14:35:00',3.43),('325','2014-03-19','14:40:00',3.36),('325','2014-03-19','14:45:00',3.3),('325','2014-03-19','14:50:00',3.2),('325','2014-03-19','14:55:00',3.14),('325','2014-03-19','15:00:00',3.06),('325','2014-03-19','15:05:00',2.98),('325','2014-03-19','15:10:00',2.93),('325','2014-03-19','15:15:00',2.89),('325','2014-03-19','15:20:00',2.77),('325','2014-03-19','15:25:00',2.74),('325','2014-03-19','15:30:00',2.64),('325','2014-03-19','15:35:00',2.47),('325','2014-03-19','15:40:00',2.41),('325','2014-03-19','15:45:00',2.34),('325','2014-03-19','15:50:00',2.24),('325','2014-03-19','15:55:00',2.2),('325','2014-03-19','16:00:00',2.07),('325','2014-03-19','16:05:00',2.01),('325','2014-03-19','16:10:00',1.93),('325','2014-03-19','16:15:00',1.8),('325','2014-03-19','16:20:00',1.66),('325','2014-03-19','16:25:00',1.54),('325','2014-03-19','16:30:00',1.45),('325','2014-03-19','16:35:00',1.3),('325','2014-03-19','16:40:00',1.2),('325','2014-03-19','16:45:00',1.12),('325','2014-03-18','08:20:00',1.39),('325','2014-03-18','08:25:00',1.07),('325','2014-03-18','08:30:00',1.12),('325','2014-03-18','08:50:00',1.66),('325','2014-03-18','08:55:00',2.18),('325','2014-03-18','09:00:00',1.55),('325','2014-03-18','09:05:00',1.42),('325','2014-03-18','09:10:00',1.51),('325','2014-03-18','09:15:00',1.63),('325','2014-03-18','09:20:00',1.99),('325','2014-03-18','09:25:00',2.32),('325','2014-03-18','09:30:00',1.63),('325','2014-03-18','09:35:00',1.75),('325','2014-03-18','09:40:00',1.06),('325','2014-03-18','09:45:00',1.49),('325','2014-03-18','09:50:00',2.02),('325','2014-03-18','09:55:00',1.57),('325','2014-03-18','10:00:00',3.26),('325','2014-03-18','10:05:00',3.62),('325','2014-03-18','10:10:00',3.84),('325','2014-03-18','10:15:00',3.77),('325','2014-03-18','10:20:00',2.92),('325','2014-03-18','10:25:00',1.93),('325','2014-03-18','10:30:00',3.56),('325','2014-03-18','10:35:00',3.47),('325','2014-03-18','10:40:00',2),('325','2014-03-18','10:45:00',3.17),('325','2014-03-18','10:50:00',4.3),('325','2014-03-18','10:55:00',2.43),('325','2014-03-18','11:00:00',1.8),('325','2014-03-18','11:05:00',2.07),('325','2014-03-18','11:10:00',1.5),('325','2014-03-18','11:15:00',3.16),('325','2014-03-18','11:20:00',4.59),('325','2014-03-18','11:25:00',3.62),('325','2014-03-18','11:30:00',3.98),('325','2014-03-18','11:35:00',5.01),('325','2014-03-18','11:40:00',4.41),('325','2014-03-18','11:45:00',3.75),('325','2014-03-18','11:50:00',2.56),('325','2014-03-18','11:55:00',1.83),('325','2014-03-18','12:00:00',2.36),('325','2014-03-18','12:05:00',3.9),('325','2014-03-18','12:10:00',4.18),('325','2014-03-18','12:15:00',2.09),('325','2014-03-18','12:20:00',1.58),('325','2014-03-18','12:25:00',1.95),('325','2014-03-18','12:30:00',2.61),('325','2014-03-18','12:35:00',2.08),('325','2014-03-18','12:40:00',3.77),('325','2014-03-18','12:45:00',4.57),('325','2014-03-18','12:50:00',4.45),('325','2014-03-18','12:55:00',4.37),('325','2014-03-18','13:00:00',4.27),('325','2014-03-18','13:05:00',4.28),('325','2014-03-18','13:10:00',4.17),('325','2014-03-18','13:15:00',3.95),('325','2014-03-18','13:20:00',3.89),('325','2014-03-18','13:25:00',3.1),('325','2014-03-18','13:30:00',4.1),('325','2014-03-18','13:35:00',4.01),('325','2014-03-18','13:40:00',3.96),('325','2014-03-18','13:45:00',3.91),('325','2014-03-18','13:50:00',3.9),('325','2014-03-18','13:55:00',3.92),('325','2014-03-18','14:00:00',3.85),('325','2014-03-18','14:05:00',3.84),('325','2014-03-18','14:10:00',3.75),('325','2014-03-18','14:15:00',3.7),('325','2014-03-18','14:20:00',3.67),('325','2014-03-18','14:25:00',3.58),('325','2014-03-18','14:30:00',3.54),('325','2014-03-18','14:35:00',3.48),('325','2014-03-18','14:40:00',3.42),('325','2014-03-18','14:45:00',3.35),('325','2014-03-18','14:50:00',3.3),('325','2014-03-18','14:55:00',3.2),('325','2014-03-18','15:00:00',3.14),('325','2014-03-18','15:05:00',3.07),('325','2014-03-18','15:10:00',3.02),('325','2014-03-18','15:15:00',2.93),('325','2014-03-18','15:20:00',2.83),('325','2014-03-18','15:25:00',2.74),('325','2014-03-18','15:30:00',2.68),('325','2014-03-18','15:35:00',2.57),('325','2014-03-18','15:40:00',2.42),('325','2014-03-18','15:45:00',2.34),('325','2014-03-18','15:50:00',2.23),('325','2014-03-18','15:55:00',2.18),('325','2014-03-18','16:00:00',2.08),('325','2014-03-18','16:05:00',2),('325','2014-03-18','16:10:00',1.91),('325','2014-03-18','16:15:00',1.79),('325','2014-03-18','16:20:00',1.65),('325','2014-03-18','16:25:00',1.59),('325','2014-03-18','16:30:00',1.49),('325','2014-03-18','16:35:00',1.39),('325','2014-03-18','16:40:00',1.26),('325','2014-03-18','16:45:00',1.16),('325','2014-03-18','16:50:00',1.03),('325','2014-03-17','09:15:00',1.13),('325','2014-03-17','09:20:00',1.21),('325','2014-03-17','09:25:00',1.54),('325','2014-03-17','09:30:00',1.74),('325','2014-03-17','09:35:00',1.32),('325','2014-03-17','09:40:00',1.23),('325','2014-03-17','09:45:00',1.34),('325','2014-03-17','09:50:00',2.12),('325','2014-03-17','09:55:00',1.79),('325','2014-03-17','10:00:00',1.94),('325','2014-03-17','10:05:00',1.83),('325','2014-03-17','10:10:00',1.58),('325','2014-03-17','10:15:00',1.85),('325','2014-03-17','10:20:00',1.81),('325','2014-03-17','10:25:00',1.67),('325','2014-03-17','10:30:00',1.44),('325','2014-03-17','10:35:00',1.31),('325','2014-03-17','10:40:00',1.5),('325','2014-03-17','10:45:00',1.84),('325','2014-03-17','10:50:00',1.48),('325','2014-03-17','10:55:00',1.43),('325','2014-03-17','11:00:00',1.56),('325','2014-03-17','11:05:00',1.36),('325','2014-03-17','11:10:00',1.91),('325','2014-03-17','11:15:00',1.66),('325','2014-03-17','11:20:00',1.42),('325','2014-03-17','11:25:00',1.92),('325','2014-03-17','11:30:00',1.42),('325','2014-03-17','11:35:00',1.49),('325','2014-03-17','11:40:00',1.33),('325','2014-03-17','11:45:00',1.76),('325','2014-03-17','11:50:00',1.61),('325','2014-03-17','11:55:00',1.75),('325','2014-03-17','12:00:00',1.7),('325','2014-03-17','12:05:00',1.71),('325','2014-03-17','12:10:00',1.43),('325','2014-03-17','12:15:00',2.16),('325','2014-03-17','12:20:00',3.78),('325','2014-03-17','12:25:00',1.5),('325','2014-03-17','12:30:00',2.14),('325','2014-03-17','12:35:00',2.14),('325','2014-03-17','12:40:00',4.63),('325','2014-03-17','12:45:00',4.61),('325','2014-03-17','12:50:00',4.37),('325','2014-03-17','12:55:00',3.54),('325','2014-03-17','13:00:00',1.47),('325','2014-03-17','13:05:00',2.89),('325','2014-03-17','13:10:00',4.3),('325','2014-03-17','13:15:00',4.24),('325','2014-03-17','13:20:00',4.11),('325','2014-03-17','13:25:00',4.19),('325','2014-03-17','13:30:00',3.79),('325','2014-03-17','13:35:00',4.2),('325','2014-03-17','13:40:00',3.42),('325','2014-03-17','13:45:00',1.8),('325','2014-03-17','13:50:00',3.84),('325','2014-03-17','13:55:00',1.98),('325','2014-03-17','14:00:00',4.06),('325','2014-03-17','14:05:00',2.84),('325','2014-03-17','14:10:00',1.69),('325','2014-03-17','14:15:00',3.33),('325','2014-03-17','14:20:00',2.3),('325','2014-03-17','14:25:00',2.73),('325','2014-03-17','14:30:00',1.7),('325','2014-03-17','14:35:00',3.58),('325','2014-03-17','14:40:00',3.3),('325','2014-03-17','14:45:00',1.56),('325','2014-03-17','14:50:00',3.31),('325','2014-03-17','14:55:00',2.57),('325','2014-03-17','15:00:00',2.77),('325','2014-03-17','15:05:00',1.81),('325','2014-03-17','15:10:00',2.46),('325','2014-03-17','15:15:00',2.32),('325','2014-03-17','15:20:00',2.81),('325','2014-03-17','15:25:00',2.7),('325','2014-03-17','15:30:00',2.66),('325','2014-03-17','15:35:00',2.4),('325','2014-03-17','15:40:00',2.12),('325','2014-03-17','15:45:00',2.05),('325','2014-03-17','15:50:00',1.99),('325','2014-03-17','15:55:00',2.07),('325','2014-03-17','16:00:00',2.01),('325','2014-03-17','16:05:00',1.2),('325','2014-03-17','16:15:00',1.32),('325','2014-03-17','16:20:00',1.61),('325','2014-03-17','16:25:00',1.55),('325','2014-03-17','16:30:00',1.44),('325','2014-03-17','16:35:00',1.49),('325','2014-03-17','16:40:00',1.2),('325','2014-03-17','16:45:00',1.2),('325','2014-03-17','16:50:00',1.07),('325','2014-04-30','08:30:00',1.03),('325','2014-04-30','08:35:00',1.09),('325','2014-04-30','08:40:00',1.15),('325','2014-04-30','08:45:00',1.22),('325','2014-04-30','08:50:00',1.3),('325','2014-04-30','08:55:00',1.32),('325','2014-04-30','09:00:00',1.19),('325','2014-04-30','09:05:00',2.09),('325','2014-04-30','09:10:00',1.57),('325','2014-04-30','09:20:00',1.23),('325','2014-04-30','09:25:00',1.88),('325','2014-04-30','09:30:00',2),('325','2014-04-30','09:35:00',2.93),('325','2014-04-30','09:40:00',3.13),('325','2014-04-30','09:45:00',2.88),('325','2014-04-30','09:50:00',2.35),('325','2014-04-30','09:55:00',3.28),('325','2014-04-30','10:00:00',3.61),('325','2014-04-30','10:05:00',3.54),('325','2014-04-30','10:10:00',2.88),('325','2014-04-30','10:15:00',2.45),('325','2014-04-30','10:20:00',1.79),('325','2014-04-30','10:25:00',1.74),('325','2014-04-30','10:30:00',2.12),('325','2014-04-30','10:35:00',2.2),('325','2014-04-30','10:40:00',2.29),('325','2014-04-30','10:45:00',1.7),('325','2014-04-30','10:50:00',2.23),('325','2014-04-30','10:55:00',4.18),('325','2014-04-30','11:00:00',4.75),('325','2014-04-30','11:05:00',3.75),('325','2014-04-30','11:10:00',3.06),('325','2014-04-30','11:15:00',2.09),('325','2014-04-30','11:20:00',2.4),('325','2014-04-30','11:25:00',2.46),('325','2014-04-30','11:30:00',2.43),('325','2014-04-30','11:35:00',3.93),('325','2014-04-30','11:40:00',2.83),('325','2014-04-30','11:45:00',3.83),('325','2014-04-30','11:50:00',4.45),('325','2014-04-30','11:55:00',3.36),('325','2014-04-30','12:00:00',2.5),('325','2014-04-30','12:05:00',1.47),('325','2014-04-30','12:10:00',1.47),('325','2014-04-30','12:15:00',1.86),('325','2014-04-30','12:20:00',1.83),('325','2014-04-30','12:25:00',1.59),('325','2014-04-30','12:30:00',1.97),('325','2014-04-30','12:35:00',1.95),('325','2014-04-30','12:40:00',1.37),('325','2014-04-30','12:45:00',1.43),('325','2014-04-30','12:50:00',2.8),('325','2014-04-30','12:55:00',4.95),('325','2014-04-30','13:00:00',3.85),('325','2014-04-30','13:05:00',3.34),('325','2014-04-30','13:10:00',3.99),('325','2014-04-30','13:15:00',2.44),('325','2014-04-30','13:20:00',2.57),('325','2014-04-30','13:25:00',4.16),('325','2014-04-30','13:30:00',1.87),('325','2014-04-30','13:35:00',2.57),('325','2014-04-30','13:40:00',3.95),('325','2014-04-30','13:45:00',4.32),('325','2014-04-30','13:50:00',3.76),('325','2014-04-30','13:55:00',3.49),('325','2014-04-30','14:00:00',2.15),('325','2014-04-30','14:05:00',1.84),('325','2014-04-30','14:10:00',1.66),('325','2014-04-30','14:15:00',2.08),('325','2014-04-30','14:20:00',4.22),('325','2014-04-30','14:25:00',4.48),('325','2014-04-30','14:30:00',5.28),('325','2014-04-30','14:35:00',3.75),('325','2014-04-30','14:40:00',2.01),('325','2014-04-30','14:45:00',1.52),('325','2014-04-30','14:50:00',1.79),('325','2014-04-30','14:55:00',1.9),('325','2014-04-30','15:00:00',1.62),('325','2014-04-30','15:05:00',1.6),('325','2014-04-30','15:10:00',1.85),('325','2014-04-30','15:15:00',1.39),('325','2014-04-30','15:20:00',1.26),('325','2014-04-30','15:25:00',1.45),('325','2014-04-30','15:30:00',1.82),('325','2014-04-30','15:35:00',3.48),('325','2014-04-30','15:40:00',5.01),('325','2014-04-30','15:45:00',3.58),('325','2014-04-30','15:50:00',4.12),('325','2014-04-30','15:55:00',2.16),('325','2014-04-30','16:00:00',1.36),('325','2014-04-30','16:05:00',2.06),('325','2014-04-30','16:10:00',2.03),('325','2014-04-30','16:15:00',2.53),('325','2014-04-30','16:20:00',1.7),('325','2014-04-30','16:25:00',2.16),('325','2014-04-30','16:30:00',1.94),('325','2014-04-30','16:35:00',1.76),('325','2014-04-30','16:40:00',2.5),('325','2014-04-30','16:45:00',2.6),('325','2014-04-30','16:50:00',3.3),('325','2014-04-30','16:55:00',2.61),('325','2014-04-30','17:00:00',2.21),('325','2014-04-30','17:05:00',1.73),('325','2014-04-30','17:20:00',1.2),('325','2014-04-30','17:35:00',1.1),('325','2014-04-30','17:40:00',1.09),('325','2014-03-16','08:05:00',1.02),('325','2014-03-16','08:10:00',1.05),('325','2014-03-16','08:15:00',1.08),('325','2014-03-16','08:20:00',1.14),('325','2014-03-16','08:25:00',1.2),('325','2014-03-16','08:30:00',1.25),('325','2014-03-16','08:35:00',1.3),('325','2014-03-16','08:40:00',1.34),('325','2014-03-16','08:45:00',1.41),('325','2014-03-16','08:50:00',1.46),('325','2014-03-16','08:55:00',1.51),('325','2014-03-16','09:00:00',1.49),('325','2014-03-16','09:05:00',1.55),('325','2014-03-16','09:10:00',1.64),('325','2014-03-16','09:15:00',1.76),('325','2014-03-16','09:20:00',1.81),('325','2014-03-16','09:25:00',1.8),('325','2014-03-16','09:30:00',1.85),('325','2014-03-16','09:35:00',1.98),('325','2014-03-16','09:40:00',2.58),('325','2014-03-16','09:45:00',2.77),('325','2014-03-16','09:50:00',2.98),('325','2014-03-16','09:55:00',2.97),('325','2014-03-16','10:00:00',2.91),('325','2014-03-16','10:05:00',3.06),('325','2014-03-16','10:10:00',3.14),('325','2014-03-16','10:15:00',3.28),('325','2014-03-16','10:20:00',3.33),('325','2014-03-16','10:25:00',3.29),('325','2014-03-16','10:30:00',3.35),('325','2014-03-16','10:35:00',3.4),('325','2014-03-16','10:40:00',3.43),('325','2014-03-16','10:45:00',3.54),('325','2014-03-16','10:50:00',3.65),('325','2014-03-16','10:55:00',3.69),('325','2014-03-16','11:00:00',3.71),('325','2014-03-16','11:05:00',3.72),('325','2014-03-16','11:10:00',3.71),('325','2014-03-16','11:15:00',3.71),('325','2014-03-16','11:20:00',3.72),('325','2014-03-16','11:25:00',3.84),('325','2014-03-16','11:30:00',3.9),('325','2014-03-16','11:35:00',3.9),('325','2014-03-16','11:40:00',3.91),('325','2014-03-16','11:45:00',3.83),('325','2014-03-16','11:50:00',3.79),('325','2014-03-16','11:55:00',3.79),('325','2014-03-16','12:00:00',3.94),('325','2014-03-16','12:05:00',3.9),('325','2014-03-16','12:10:00',3.84),('325','2014-03-16','12:15:00',3.61),('325','2014-03-16','12:20:00',3.81),('325','2014-03-16','12:25:00',3.92),('325','2014-03-16','12:30:00',3.93),('325','2014-03-16','12:35:00',3.92),('325','2014-03-16','12:40:00',3.9),('325','2014-03-16','12:45:00',3.91),('325','2014-03-16','12:50:00',3.91),('325','2014-03-16','12:55:00',3.87),('325','2014-03-16','13:00:00',3.78),('325','2014-03-16','13:05:00',3.75),('325','2014-03-16','13:10:00',3.67),('325','2014-03-16','13:15:00',3.79),('325','2014-03-16','13:20:00',3.67),('325','2014-03-16','13:25:00',3.79),('325','2014-03-16','13:30:00',3.71),('325','2014-03-16','13:35:00',3.64),('325','2014-03-16','13:40:00',3.77),('325','2014-03-16','13:45:00',3.7),('325','2014-03-16','13:50:00',3.66),('325','2014-03-16','13:55:00',3.64),('325','2014-03-16','14:00:00',3.57),('325','2014-03-16','14:05:00',3.48),('325','2014-03-16','14:10:00',3.42),('325','2014-03-16','14:15:00',3.32),('325','2014-03-16','14:20:00',3.35),('325','2014-03-16','14:25:00',3.29),('325','2014-03-16','14:30:00',3.27),('325','2014-03-16','14:35:00',3.18),('325','2014-03-16','14:40:00',3.12),('325','2014-03-16','14:45:00',3.04),('325','2014-03-16','14:50:00',2.85),('325','2014-03-16','14:55:00',2.84),('325','2014-03-16','15:00:00',2.91),('325','2014-03-16','15:05:00',2.79),('325','2014-03-16','15:10:00',2.54),('325','2014-03-16','15:15:00',2.43),('325','2014-03-16','15:20:00',2.05),('325','2014-03-16','15:25:00',2.35),('325','2014-03-16','15:30:00',2.12),('325','2014-03-16','15:35:00',1.96),('325','2014-03-16','15:40:00',1.56),('325','2014-03-16','15:45:00',1.49),('325','2014-03-16','15:50:00',1.69),('325','2014-03-16','15:55:00',1.57),('325','2014-03-16','16:00:00',1.35),('325','2014-03-16','16:05:00',1.62),('325','2014-03-16','16:10:00',1.7),('325','2014-03-16','16:15:00',1.67),('325','2014-03-16','16:20:00',1.5),('325','2014-03-16','16:25:00',1.44),('325','2014-03-16','16:30:00',1.47),('325','2014-03-16','16:35:00',1.34),('325','2014-03-16','16:40:00',1.16),('325','2014-03-16','16:45:00',1.02),('325','2014-03-15','08:15:00',1.03),('325','2014-03-15','08:20:00',1.09),('325','2014-03-15','08:25:00',1.14),('325','2014-03-15','08:30:00',1.19),('325','2014-03-15','08:35:00',1.25),('325','2014-03-15','08:40:00',1.33),('325','2014-03-15','08:45:00',1.38),('325','2014-03-15','08:50:00',1.44),('325','2014-03-15','08:55:00',1.48),('325','2014-03-15','09:00:00',1.54),('325','2014-03-15','09:05:00',1.59),('325','2014-03-15','09:10:00',1.65),('325','2014-03-15','09:15:00',1.7),('325','2014-03-15','09:20:00',1.75),('325','2014-03-15','09:25:00',1.8),('325','2014-03-15','09:30:00',1.85),('325','2014-03-15','09:35:00',1.88),('325','2014-03-15','09:40:00',2.35),('325','2014-03-15','09:45:00',2.73),('325','2014-03-15','09:50:00',2.8),('325','2014-03-15','09:55:00',2.85),('325','2014-03-15','10:00:00',2.9),('325','2014-03-15','10:05:00',3),('325','2014-03-15','10:10:00',3.08),('325','2014-03-15','10:15:00',3.15),('325','2014-03-15','10:20:00',3.21),('325','2014-03-15','10:25:00',3.2),('325','2014-03-15','10:30:00',3.23),('325','2014-03-15','10:35:00',3.25),('325','2014-03-15','10:40:00',3.37),('325','2014-03-15','10:45:00',3.37),('325','2014-03-15','10:50:00',3.39),('325','2014-03-15','10:55:00',3.43),('325','2014-03-15','11:00:00',3.49),('325','2014-03-15','11:05:00',3.59),('325','2014-03-15','11:10:00',3.62),('325','2014-03-15','11:15:00',3.71),('325','2014-03-15','11:20:00',3.78),('325','2014-03-15','11:25:00',3.83),('325','2014-03-15','11:30:00',3.76),('325','2014-03-15','11:35:00',3.86),('325','2014-03-15','11:40:00',3.85),('325','2014-03-15','11:45:00',3.92),('325','2014-03-15','11:50:00',3.82),('325','2014-03-15','11:55:00',3.83),('325','2014-03-15','12:00:00',3.8),('325','2014-03-15','12:05:00',3.86),('325','2014-03-15','12:10:00',3.92),('325','2014-03-15','12:15:00',3.92),('325','2014-03-15','12:20:00',3.86),('325','2014-03-15','12:25:00',3.95),('325','2014-03-15','12:30:00',4.04),('325','2014-03-15','12:35:00',4.08),('325','2014-03-15','12:40:00',4.01),('325','2014-03-15','12:45:00',3.99),('325','2014-03-15','12:50:00',3.99),('325','2014-03-15','12:55:00',3.92),('325','2014-03-15','13:00:00',3.93),('325','2014-03-15','13:05:00',3.97),('325','2014-03-15','13:10:00',3.93),('325','2014-03-15','13:15:00',3.91),('325','2014-03-15','13:20:00',3.88),('325','2014-03-15','13:25:00',3.86),('325','2014-03-15','13:30:00',3.85),('325','2014-03-15','13:35:00',3.85),('325','2014-03-15','13:40:00',3.82),('325','2014-03-15','13:45:00',3.8),('325','2014-03-15','13:50:00',3.76),('325','2014-03-15','13:55:00',3.74),('325','2014-03-15','14:00:00',3.71),('325','2014-03-15','14:05:00',3.69),('325','2014-03-15','14:10:00',3.62),('325','2014-03-15','14:15:00',3.55),('325','2014-03-15','14:20:00',3.49),('325','2014-03-15','14:25:00',3.43),('325','2014-03-15','14:30:00',3.37),('325','2014-03-15','14:35:00',3.3),('325','2014-03-15','14:40:00',3.21),('325','2014-03-15','14:45:00',3.15),('325','2014-03-15','14:50:00',3.07),('325','2014-03-15','14:55:00',3.05),('325','2014-03-15','15:00:00',2.99),('325','2014-03-15','15:05:00',2.9),('325','2014-03-15','15:10:00',2.81),('325','2014-03-15','15:15:00',2.73),('325','2014-03-15','15:20:00',2.63),('325','2014-03-15','15:25:00',2.55),('325','2014-03-15','15:30:00',2.47),('325','2014-03-15','15:35:00',2.34),('325','2014-03-15','15:40:00',2.21),('325','2014-03-15','15:45:00',2.15),('325','2014-03-15','15:50:00',2.07),('325','2014-03-15','15:55:00',1.97),('325','2014-03-15','16:00:00',1.84),('325','2014-03-15','16:05:00',1.73),('325','2014-03-15','16:10:00',1.63),('325','2014-03-15','16:15:00',1.52),('325','2014-03-15','16:20:00',1.42),('325','2014-03-15','16:25:00',1.29),('325','2014-03-15','16:30:00',1.22),('325','2014-03-15','16:35:00',1.15),('325','2014-03-15','16:40:00',1.04),('325','2014-03-14','08:20:00',1.03),('325','2014-03-14','08:25:00',1.08),('325','2014-03-14','08:30:00',1.14),('325','2014-03-14','08:35:00',1.15),('325','2014-03-14','08:40:00',1.14),('325','2014-03-14','08:45:00',1.04),('325','2014-03-14','08:50:00',1.03),('325','2014-03-14','08:55:00',1.08),('325','2014-03-14','09:00:00',1.17),('325','2014-03-14','09:05:00',1.31),('325','2014-03-14','09:10:00',1.43),('325','2014-03-14','09:15:00',1.48),('325','2014-03-14','09:20:00',1.44),('325','2014-03-14','09:25:00',1.47),('325','2014-03-14','09:30:00',1.47),('325','2014-03-14','09:35:00',1.64),('325','2014-03-14','09:40:00',1.96),('325','2014-03-14','09:45:00',2.18),('325','2014-03-14','09:50:00',2.44),('325','2014-03-14','09:55:00',2.98),('325','2014-03-14','10:00:00',3.56),('325','2014-03-14','10:05:00',3.65),('325','2014-03-14','10:10:00',3.63),('325','2014-03-14','10:15:00',3.59),('325','2014-03-14','10:20:00',3.52),('325','2014-03-14','10:25:00',3.34),('325','2014-03-14','10:30:00',3.35),('325','2014-03-14','10:35:00',3.51),('325','2014-03-14','10:40:00',3.65),('325','2014-03-14','10:45:00',3.19),('325','2014-03-14','10:50:00',2.1),('325','2014-03-14','10:55:00',2.82),('325','2014-03-14','11:00:00',3.42),('325','2014-03-14','11:05:00',3.6),('325','2014-03-14','11:10:00',3.99),('325','2014-03-14','11:15:00',4.1),('325','2014-03-14','11:20:00',3.92),('325','2014-03-14','11:25:00',3.79),('325','2014-03-14','11:30:00',3.81),('325','2014-03-14','11:35:00',3.85),('325','2014-03-14','11:40:00',3.94),('325','2014-03-14','11:45:00',4.02),('325','2014-03-14','11:50:00',4.13),('325','2014-03-14','11:55:00',4.11),('325','2014-03-14','12:00:00',4.13),('325','2014-03-14','12:05:00',4.05),('325','2014-03-14','12:10:00',3.86),('325','2014-03-14','12:15:00',3.78),('325','2014-03-14','12:20:00',3.18),('325','2014-03-14','12:25:00',2.61),('325','2014-03-14','12:30:00',2.47),('325','2014-03-14','12:35:00',2.06),('325','2014-03-14','12:40:00',2.4),('325','2014-03-14','12:45:00',2.63),('325','2014-03-14','12:50:00',3.09),('325','2014-03-14','12:55:00',3.46),('325','2014-03-14','13:00:00',2.27),('325','2014-03-14','13:05:00',2.06),('325','2014-03-14','13:10:00',2.47),('325','2014-03-14','13:15:00',2.64),('325','2014-03-14','13:20:00',3.08),('325','2014-03-14','13:25:00',2.79),('325','2014-03-14','13:30:00',2.56),('325','2014-03-14','13:35:00',2.26),('325','2014-03-14','13:40:00',2.22),('325','2014-03-14','13:45:00',2.31),('325','2014-03-14','13:50:00',2.38),('325','2014-03-14','13:55:00',2.2),('325','2014-03-14','14:00:00',2.58),('325','2014-03-14','14:05:00',2.97),('325','2014-03-14','14:10:00',2.83),('325','2014-03-14','14:15:00',3.12),('325','2014-03-14','14:20:00',3.08),('325','2014-03-14','14:25:00',2.79),('325','2014-03-14','14:30:00',2.74),('325','2014-03-14','14:35:00',2.64),('325','2014-03-14','14:40:00',2.14),('325','2014-03-14','14:45:00',1.74),('325','2014-03-14','14:50:00',1.59),('325','2014-03-14','14:55:00',1.45),('325','2014-03-14','15:00:00',1.34),('325','2014-03-14','15:05:00',1.34),('325','2014-03-14','15:10:00',1.27),('325','2014-03-14','15:15:00',1.23),('325','2014-03-14','15:20:00',1.34),('325','2014-03-14','15:25:00',1.41),('325','2014-03-14','15:30:00',1.45),('325','2014-03-14','15:35:00',1.78),('325','2014-03-14','15:40:00',1.63),('325','2014-03-14','15:45:00',1.36),('325','2014-03-14','15:50:00',1.18),('325','2014-03-14','15:55:00',1.19),('325','2014-03-14','16:00:00',1.1),('325','2014-03-14','16:05:00',1.1),('325','2014-03-13','08:15:00',1.04),('325','2014-03-13','08:20:00',1.09),('325','2014-03-13','08:25:00',1.15),('325','2014-03-13','08:30:00',1.19),('325','2014-03-13','08:35:00',1.24),('325','2014-03-13','08:40:00',1.3),('325','2014-03-13','08:45:00',1.35),('325','2014-03-13','08:50:00',1.39),('325','2014-03-13','08:55:00',1.44),('325','2014-03-13','09:00:00',1.49),('325','2014-03-13','09:05:00',1.53),('325','2014-03-13','09:10:00',1.57),('325','2014-03-13','09:15:00',1.61),('325','2014-03-13','09:20:00',1.65),('325','2014-03-13','09:25:00',1.69),('325','2014-03-13','09:30:00',1.73),('325','2014-03-13','09:35:00',1.78),('325','2014-03-13','09:40:00',2.66),('325','2014-03-13','09:45:00',3.1),('325','2014-03-13','09:50:00',3.23),('325','2014-03-13','09:55:00',3.29),('325','2014-03-13','10:00:00',3.38),('325','2014-03-13','10:05:00',3.46),('325','2014-03-13','10:10:00',3.52),('325','2014-03-13','10:15:00',3.6),('325','2014-03-13','10:20:00',3.64),('325','2014-03-13','10:25:00',3.67),('325','2014-03-13','10:30:00',3.71),('325','2014-03-13','10:35:00',3.76),('325','2014-03-13','10:40:00',3.78),('325','2014-03-13','10:45:00',3.82),('325','2014-03-13','10:50:00',3.87),('325','2014-03-13','10:55:00',3.91),('325','2014-03-13','11:00:00',3.93),('325','2014-03-13','11:05:00',3.97),('325','2014-03-13','11:10:00',4.01),('325','2014-03-13','11:15:00',4.01),('325','2014-03-13','11:20:00',4.07),('325','2014-03-13','11:25:00',4.08),('325','2014-03-13','11:30:00',4.11),('325','2014-03-13','11:35:00',4.1),('325','2014-03-13','11:40:00',4.11),('325','2014-03-13','11:45:00',4.13),('325','2014-03-13','11:50:00',4.13),('325','2014-03-13','11:55:00',4.18),('325','2014-03-13','12:00:00',4.18),('325','2014-03-13','12:05:00',4.19),('325','2014-03-13','12:10:00',4.16),('325','2014-03-13','12:15:00',4.16),('325','2014-03-13','12:20:00',4.13),('325','2014-03-13','12:25:00',4.1),('325','2014-03-13','12:30:00',4.07),('325','2014-03-13','12:35:00',4.08),('325','2014-03-13','12:40:00',4.07),('325','2014-03-13','12:45:00',4.06),('325','2014-03-13','12:50:00',4.03),('325','2014-03-13','12:55:00',4.02),('325','2014-03-13','13:00:00',4),('325','2014-03-13','13:05:00',3.96),('325','2014-03-13','13:10:00',3.93),('325','2014-03-13','13:15:00',3.95),('325','2014-03-13','13:20:00',3.96),('325','2014-03-13','13:25:00',3.96),('325','2014-03-13','13:30:00',3.94),('325','2014-03-13','13:35:00',3.93),('325','2014-03-13','13:40:00',3.88),('325','2014-03-13','13:45:00',3.84),('325','2014-03-13','13:50:00',3.78),('325','2014-03-13','13:55:00',3.73),('325','2014-03-13','14:00:00',3.65),('325','2014-03-13','14:05:00',3.6),('325','2014-03-13','14:10:00',3.56),('325','2014-03-13','14:15:00',3.56),('325','2014-03-13','14:20:00',3.5),('325','2014-03-13','14:25:00',3.43),('325','2014-03-13','14:30:00',3.36),('325','2014-03-13','14:35:00',3.31),('325','2014-03-13','14:40:00',3.25),('325','2014-03-13','14:45:00',3.19),('325','2014-03-13','14:50:00',3.11),('325','2014-03-13','14:55:00',3.03),('325','2014-03-13','15:00:00',2.95),('325','2014-03-13','15:05:00',2.87),('325','2014-03-13','15:10:00',2.8),('325','2014-03-13','15:15:00',2.74),('325','2014-03-13','15:20:00',2.67),('325','2014-03-13','15:25:00',2.59),('325','2014-03-13','15:30:00',2.49),('325','2014-03-13','15:35:00',2.38),('325','2014-03-13','15:40:00',2.29),('325','2014-03-13','15:45:00',2.2),('325','2014-03-13','15:50:00',2.12),('325','2014-03-13','15:55:00',2.02),('325','2014-03-13','16:00:00',1.91),('325','2014-03-13','16:05:00',1.79),('325','2014-03-13','16:10:00',1.7),('325','2014-03-13','16:15:00',1.6),('325','2014-03-13','16:20:00',1.49),('325','2014-03-13','16:25:00',1.41),('325','2014-03-13','16:30:00',1.31),('325','2014-03-13','16:35:00',1.21),('325','2014-03-13','16:40:00',1.12),('325','2014-03-13','16:45:00',1.03),('325','2014-03-12','08:20:00',1.05),('325','2014-03-12','08:25:00',1.11),('325','2014-03-12','08:30:00',1.17),('325','2014-03-12','08:35:00',1.23),('325','2014-03-12','08:40:00',1.28),('325','2014-03-12','08:45:00',1.33),('325','2014-03-12','08:50:00',1.38),('325','2014-03-12','08:55:00',1.43),('325','2014-03-12','09:00:00',1.47),('325','2014-03-12','09:05:00',1.53),('325','2014-03-12','09:10:00',1.57),('325','2014-03-12','09:15:00',1.62),('325','2014-03-12','09:20:00',1.67),('325','2014-03-12','09:25:00',1.72),('325','2014-03-12','09:30:00',1.76),('325','2014-03-12','09:35:00',1.8),('325','2014-03-12','09:40:00',2.53),('325','2014-03-12','09:45:00',3.06),('325','2014-03-12','09:50:00',3.17),('325','2014-03-12','09:55:00',3.24),('325','2014-03-12','10:00:00',3.31),('325','2014-03-12','10:05:00',3.39),('325','2014-03-12','10:10:00',3.47),('325','2014-03-12','10:15:00',3.57),('325','2014-03-12','10:20:00',3.61),('325','2014-03-12','10:25:00',3.66),('325','2014-03-12','10:30:00',3.71),('325','2014-03-12','10:35:00',3.76),('325','2014-03-12','10:40:00',3.82),('325','2014-03-12','10:45:00',3.86),('325','2014-03-12','10:50:00',3.92),('325','2014-03-12','10:55:00',3.95),('325','2014-03-12','11:00:00',3.99),('325','2014-03-12','11:05:00',4.06),('325','2014-03-12','11:10:00',4.13),('325','2014-03-12','11:15:00',4.17),('325','2014-03-12','11:20:00',4.2),('325','2014-03-12','11:25:00',4.21),('325','2014-03-12','11:30:00',4.23),('325','2014-03-12','11:35:00',4.24),('325','2014-03-12','11:40:00',4.26),('325','2014-03-12','11:45:00',4.26),('325','2014-03-12','11:50:00',4.25),('325','2014-03-12','11:55:00',4.25),('325','2014-03-12','12:00:00',4.26),('325','2014-03-12','12:05:00',4.26),('325','2014-03-12','12:10:00',4.24),('325','2014-03-12','12:15:00',4.24),('325','2014-03-12','12:20:00',4.23),('325','2014-03-12','12:25:00',4.23),('325','2014-03-12','12:30:00',4.23),('325','2014-03-12','12:35:00',4.19),('325','2014-03-12','12:40:00',4.2),('325','2014-03-12','12:45:00',4.19),('325','2014-03-12','12:50:00',4.18),('325','2014-03-12','12:55:00',4.16),('325','2014-03-12','13:00:00',4.14),('325','2014-03-12','13:05:00',4.13),('325','2014-03-12','13:10:00',4.11),('325','2014-03-12','13:15:00',4.07),('325','2014-03-12','13:20:00',4.07),('325','2014-03-12','13:25:00',4.01),('325','2014-03-12','13:30:00',3.99),('325','2014-03-12','13:35:00',3.92),('325','2014-03-12','13:40:00',3.89),('325','2014-03-12','13:45:00',3.88),('325','2014-03-12','13:50:00',3.82),('325','2014-03-12','13:55:00',3.76),('325','2014-03-12','14:00:00',3.75),('325','2014-03-12','14:05:00',3.72),('325','2014-03-12','14:10:00',3.68),('325','2014-03-12','14:15:00',3.63),('325','2014-03-12','14:20:00',3.56),('325','2014-03-12','14:25:00',3.49),('325','2014-03-12','14:30:00',3.45),('325','2014-03-12','14:35:00',3.28),('325','2014-03-12','14:40:00',3.22),('325','2014-03-12','14:45:00',3.15),('325','2014-03-12','14:50:00',3.09),('325','2014-03-12','14:55:00',3.05),('325','2014-03-12','15:00:00',2.82),('325','2014-03-12','15:05:00',2.83),('325','2014-03-12','15:10:00',2.76),('325','2014-03-12','15:15:00',2.68),('325','2014-03-12','15:20:00',2.62),('325','2014-03-12','15:25:00',2.52),('325','2014-03-12','15:30:00',2.44),('325','2014-03-12','15:35:00',2.34),('325','2014-03-12','15:40:00',2.23),('325','2014-03-12','15:45:00',2.21),('325','2014-03-12','15:50:00',2.13),('325','2014-03-12','15:55:00',2.03),('325','2014-03-12','16:00:00',1.97),('325','2014-03-12','16:05:00',1.86),('325','2014-03-12','16:10:00',1.74),('325','2014-03-12','16:15:00',1.64),('325','2014-03-12','16:20:00',1.51),('325','2014-03-12','16:25:00',1.41),('325','2014-03-12','16:30:00',1.31),('325','2014-03-12','16:35:00',1.23),('325','2014-03-12','16:40:00',1.14),('325','2014-03-12','16:45:00',1.03),('325','2014-03-11','11:00:00',1.02),('325','2014-03-11','11:05:00',1.07),('325','2014-03-11','11:10:00',1.03),('325','2014-03-11','11:15:00',1.05),('325','2014-03-11','11:45:00',1.02),('325','2014-03-11','12:00:00',1.04),('325','2014-03-11','12:05:00',1.03),('325','2014-03-11','12:10:00',1.07),('325','2014-03-11','12:15:00',1.21),('325','2014-03-11','12:20:00',1.33),('325','2014-03-11','12:25:00',1.22),('325','2014-03-11','12:30:00',1.2),('325','2014-03-11','12:35:00',1.29),('325','2014-03-11','12:40:00',1.42),('325','2014-03-11','12:45:00',1.41),('325','2014-03-11','12:50:00',1.33),('325','2014-03-11','12:55:00',1.24),('325','2014-03-11','13:00:00',1.22),('325','2014-03-11','13:05:00',1.39),('325','2014-03-11','13:10:00',1.35),('325','2014-03-11','13:15:00',1.26),('325','2014-03-11','13:20:00',1.32),('325','2014-03-11','13:25:00',1.17),('325','2014-03-11','13:30:00',1.16),('325','2014-03-11','13:35:00',1.1),('325','2014-03-11','13:40:00',1.11),('325','2014-03-11','13:45:00',1.36),('325','2014-03-11','13:50:00',1.63),('325','2014-03-11','13:55:00',1.95),('325','2014-03-11','14:00:00',2.11),('325','2014-03-11','14:05:00',2.13),('325','2014-03-11','14:10:00',2.74),('325','2014-03-11','14:15:00',2.73),('325','2014-03-11','14:20:00',2.76),('325','2014-03-11','14:25:00',1.96),('325','2014-03-11','14:30:00',1.44),('325','2014-03-11','14:35:00',1.56),('325','2014-03-11','14:40:00',1.46),('325','2014-03-11','14:45:00',1.58),('325','2014-03-11','14:50:00',1.4),('325','2014-03-11','14:55:00',1.38),('325','2014-03-11','15:00:00',1.63),('325','2014-03-11','15:05:00',1.75),('325','2014-03-11','15:10:00',2.02),('325','2014-03-11','15:15:00',1.91),('325','2014-03-11','15:20:00',1.91),('325','2014-03-11','15:25:00',1.48),('325','2014-03-11','15:30:00',1.35),('325','2014-03-11','15:35:00',1.19),('325','2014-03-11','15:40:00',1.11),('325','2014-03-11','15:45:00',1.04),('325','2014-03-11','15:50:00',1.07),('325','2014-03-10','09:05:00',1.07),('325','2014-03-10','09:10:00',1.06),('325','2014-03-10','09:15:00',1),('325','2014-03-10','09:30:00',1),('325','2014-03-10','09:35:00',1.04),('325','2014-03-10','09:40:00',1.11),('325','2014-03-10','09:45:00',1.03),('325','2014-03-10','10:10:00',1),('325','2014-03-10','10:15:00',1.15),('325','2014-03-10','10:30:00',1.02),('325','2014-03-10','10:35:00',1.28),('325','2014-03-10','11:20:00',1.01),('325','2014-03-10','12:50:00',1.1),('325','2014-03-10','12:55:00',1.18),('325','2014-03-10','13:00:00',1.25),('325','2014-03-10','13:05:00',1.29),('325','2014-03-10','13:10:00',1.36),('325','2014-03-10','13:15:00',1.51),('325','2014-03-10','13:20:00',1.53),('325','2014-03-10','13:25:00',1.38),('325','2014-03-10','13:30:00',1.18),('325','2014-03-10','13:50:00',1.19),('325','2014-03-10','13:55:00',1.34),('325','2014-03-10','14:00:00',1.16),('325','2014-03-10','14:05:00',1.85),('325','2014-03-10','14:10:00',2.24),('325','2014-03-10','14:15:00',3.3),('325','2014-03-10','14:20:00',2.28),('325','2014-03-10','14:25:00',1.61),('325','2014-03-10','14:30:00',1.43),('325','2014-03-10','14:35:00',2.06),('325','2014-03-10','14:40:00',2.91),('325','2014-03-10','14:45:00',3.09),('325','2014-03-10','14:50:00',2.99),('325','2014-03-10','14:55:00',1.47),('325','2014-03-10','15:00:00',1.73),('325','2014-03-10','15:05:00',1.73),('325','2014-03-10','15:10:00',1.08),('325','2014-03-10','15:15:00',1.75),('325','2014-03-10','15:20:00',2.04),('325','2014-03-10','15:25:00',2.81),('325','2014-03-10','15:30:00',2.1),('325','2014-03-10','15:35:00',1.58),('325','2014-03-10','15:40:00',1.14),('325','2014-03-10','16:00:00',1.04),('325','2014-03-10','16:05:00',1.12),('325','2014-03-10','16:30:00',1.05),('325','2014-03-09','08:25:00',1.02),('325','2014-03-09','08:55:00',1.15),('325','2014-03-09','09:00:00',1.44),('325','2014-03-09','09:05:00',1.38),('325','2014-03-09','09:15:00',1.64),('325','2014-03-09','09:20:00',1.72),('325','2014-03-09','09:25:00',1.73),('325','2014-03-09','09:30:00',1.87),('325','2014-03-09','09:35:00',2.04),('325','2014-03-09','09:40:00',2.09),('325','2014-03-09','09:45:00',2.59),('325','2014-03-09','09:50:00',3.33),('325','2014-03-09','09:55:00',3.37),('325','2014-03-09','10:00:00',3.4),('325','2014-03-09','10:05:00',3.46),('325','2014-03-09','10:10:00',3.58),('325','2014-03-09','10:15:00',3.66),('325','2014-03-09','10:20:00',3.67),('325','2014-03-09','10:25:00',3.7),('325','2014-03-09','10:30:00',3.78),('325','2014-03-09','10:35:00',3.84),('325','2014-03-09','10:40:00',3.86),('325','2014-03-09','10:45:00',3.91),('325','2014-03-09','10:50:00',4.01),('325','2014-03-09','10:55:00',4.1),('325','2014-03-09','11:00:00',4.31),('325','2014-03-09','11:05:00',4.2),('325','2014-03-09','11:10:00',4.51),('325','2014-03-09','11:15:00',4.64),('325','2014-03-09','11:20:00',3.27),('325','2014-03-09','11:25:00',1.93),('325','2014-03-09','11:30:00',1.37),('325','2014-03-09','11:35:00',2.07),('325','2014-03-09','11:40:00',1.91),('325','2014-03-09','11:45:00',1.75),('325','2014-03-09','11:50:00',3.43),('325','2014-03-09','11:55:00',3.16),('325','2014-03-09','12:00:00',4.27),('325','2014-03-09','12:05:00',4.6),('325','2014-03-09','12:10:00',4.93),('325','2014-03-09','12:15:00',4.84),('325','2014-03-09','12:20:00',4.77),('325','2014-03-09','12:25:00',4.68),('325','2014-03-09','12:30:00',4.73),('325','2014-03-09','12:35:00',4.86),('325','2014-03-09','12:40:00',4.61),('325','2014-03-09','12:45:00',4.5),('325','2014-03-09','12:50:00',4.52),('325','2014-03-09','12:55:00',4.57),('325','2014-03-09','13:00:00',4.65),('325','2014-03-09','13:05:00',4.64),('325','2014-03-09','13:10:00',4.25),('325','2014-03-09','13:15:00',4.41),('325','2014-03-09','13:20:00',4.38),('325','2014-03-09','13:25:00',3.99),('325','2014-03-09','13:30:00',4),('325','2014-03-09','13:35:00',3.8),('325','2014-03-09','13:40:00',1.46),('325','2014-03-09','13:45:00',2.19),('325','2014-03-09','13:50:00',2.64),('325','2014-03-09','13:55:00',1.47),('325','2014-03-09','14:00:00',1.68),('325','2014-03-09','14:05:00',3.67),('325','2014-03-09','14:10:00',3.93),('325','2014-03-09','14:15:00',3.8),('325','2014-03-09','14:20:00',1.89),('325','2014-03-09','14:25:00',3.66),('325','2014-03-09','14:30:00',1.52),('325','2014-03-09','14:35:00',1),('325','2014-03-09','14:45:00',2.26),('325','2014-03-09','14:50:00',1.49),('325','2014-03-09','14:55:00',3.35),('325','2014-03-09','15:00:00',3.13),('325','2014-03-09','15:05:00',2.87),('325','2014-03-09','15:10:00',3.05),('325','2014-03-09','15:15:00',2.92),('325','2014-03-09','15:20:00',2.86),('325','2014-03-09','15:25:00',2.84),('325','2014-03-09','15:30:00',2.76),('325','2014-03-09','15:35:00',2.6),('325','2014-03-09','15:40:00',2.39),('325','2014-03-09','15:45:00',2.29),('325','2014-03-09','15:55:00',1.51),('325','2014-03-09','16:00:00',2.16),('325','2014-03-09','16:05:00',1.96),('325','2014-03-09','16:10:00',1.51),('325','2014-03-09','16:15:00',1.47),('325','2014-03-09','16:20:00',1.05),('325','2014-03-09','16:25:00',1.44),('325','2014-03-09','16:30:00',1.35),('325','2014-03-09','16:35:00',1.3),('325','2014-03-09','16:40:00',1.27),('325','2014-03-09','16:45:00',1.09),('325','2014-03-08','08:25:00',1.06),('325','2014-03-08','08:30:00',1.11),('325','2014-03-08','08:35:00',1.16),('325','2014-03-08','08:40:00',1.23),('325','2014-03-08','08:45:00',1.28),('325','2014-03-08','08:50:00',1.34),('325','2014-03-08','08:55:00',1.38),('325','2014-03-08','09:00:00',1.43),('325','2014-03-08','09:05:00',1.49),('325','2014-03-08','09:10:00',1.54),('325','2014-03-08','09:15:00',1.58),('325','2014-03-08','09:20:00',1.63),('325','2014-03-08','09:25:00',1.68),('325','2014-03-08','09:30:00',1.73),('325','2014-03-08','09:35:00',1.77),('325','2014-03-08','09:40:00',1.82),('325','2014-03-08','09:45:00',2.19),('325','2014-03-08','09:50:00',3.11),('325','2014-03-08','09:55:00',3.21),('325','2014-03-08','10:00:00',3.28),('325','2014-03-08','10:05:00',3.34),('325','2014-03-08','10:10:00',3.42),('325','2014-03-08','10:15:00',3.5),('325','2014-03-08','10:20:00',3.58),('325','2014-03-08','10:25:00',3.63),('325','2014-03-08','10:30:00',3.72),('325','2014-03-08','10:35:00',3.77),('325','2014-03-08','10:40:00',3.8),('325','2014-03-08','10:45:00',3.84),('325','2014-03-08','10:50:00',3.87),('325','2014-03-08','10:55:00',3.92),('325','2014-03-08','11:00:00',3.95),('325','2014-03-08','11:05:00',4.01),('325','2014-03-08','11:10:00',4.07),('325','2014-03-08','11:15:00',4.13),('325','2014-03-08','11:20:00',4.19),('325','2014-03-08','11:25:00',4.3),('325','2014-03-08','11:30:00',4.48),('325','2014-03-08','11:35:00',4.56),('325','2014-03-08','11:40:00',2.4),('325','2014-03-08','11:45:00',2.4),('325','2014-03-08','11:50:00',1.65),('325','2014-03-08','11:55:00',3.16),('325','2014-03-08','12:00:00',2.39),('325','2014-03-08','12:15:00',1.08),('325','2014-03-08','12:20:00',1.27),('325','2014-03-08','12:25:00',1.44),('325','2014-03-08','12:30:00',1.57),('325','2014-03-08','12:35:00',3.64),('325','2014-03-08','12:40:00',2.11),('325','2014-03-08','12:45:00',2.37),('325','2014-03-08','12:50:00',2.02),('325','2014-03-08','12:55:00',3.12),('325','2014-03-08','13:00:00',2.31),('325','2014-03-08','13:05:00',1.75),('325','2014-03-08','13:10:00',1.54),('325','2014-03-08','13:15:00',1.23),('325','2014-03-08','13:20:00',1.03),('325','2014-03-08','13:25:00',1.05),('325','2014-03-08','13:30:00',1.62),('325','2014-03-08','13:35:00',1.8),('325','2014-03-08','13:40:00',2.28),('325','2014-03-08','13:45:00',2.83),('325','2014-03-08','13:50:00',2.68),('325','2014-03-08','13:55:00',1.45),('325','2014-03-08','14:00:00',1.12),('325','2014-03-08','14:05:00',1.09),('325','2014-03-08','14:10:00',1.03),('325','2014-03-08','14:40:00',1.02),('325','2014-03-08','14:55:00',1.05),('325','2014-03-08','15:15:00',1.37),('325','2014-03-08','15:20:00',1.8),('325','2014-03-08','15:25:00',1.51),('325','2014-03-08','15:30:00',1.94),('325','2014-03-08','16:30:00',1.02),('325','2014-03-08','16:35:00',1.41),('325','2014-03-08','16:40:00',1.21),('325','2014-03-08','16:45:00',1.11),('325','2014-03-08','16:50:00',1.01),('325','2014-03-07','11:00:00',1.07),('325','2014-03-07','11:20:00',1.1),('325','2014-03-07','11:25:00',1.09),('325','2014-03-07','11:30:00',1.2),('325','2014-03-07','11:35:00',1.16),('325','2014-03-07','11:45:00',1.74),('325','2014-03-07','11:50:00',4.08),('325','2014-03-07','11:55:00',4.2),('325','2014-03-07','12:00:00',5.13),('325','2014-03-07','12:05:00',4.79),('325','2014-03-07','12:10:00',4.69),('325','2014-03-07','12:15:00',4.56),('325','2014-03-07','12:20:00',4.56),('325','2014-03-07','12:25:00',4.6),('325','2014-03-07','12:30:00',2.13),('325','2014-03-07','12:35:00',3.76),('325','2014-03-07','12:40:00',2.98),('325','2014-03-07','12:50:00',1.58),('325','2014-03-07','13:00:00',3.45),('325','2014-03-07','13:05:00',3.87),('325','2014-03-07','13:10:00',2.07),('325','2014-03-07','13:15:00',1.24),('325','2014-03-07','13:20:00',2.86),('325','2014-03-07','13:25:00',3.72),('325','2014-03-07','13:30:00',3.4),('325','2014-03-07','13:35:00',2.74),('325','2014-03-07','13:40:00',2.65),('325','2014-03-07','13:45:00',2.36),('325','2014-03-07','13:50:00',1.64),('325','2014-03-07','13:55:00',1.28),('325','2014-03-07','14:00:00',1.22),('325','2014-03-07','14:05:00',1.18),('325','2014-03-07','14:10:00',1.19),('325','2014-03-07','14:15:00',1.17),('325','2014-03-07','14:20:00',1.16),('325','2014-03-07','14:25:00',1.13),('325','2014-03-07','14:30:00',1.19),('325','2014-03-07','14:35:00',1.28),('325','2014-03-07','14:40:00',1.39),('325','2014-03-07','14:45:00',1.46),('325','2014-03-07','14:50:00',1.88),('325','2014-03-07','14:55:00',2.69),('325','2014-03-07','15:00:00',3.21),('325','2014-03-07','15:05:00',3.52),('325','2014-03-07','15:10:00',3.61),('325','2014-03-07','15:15:00',3.6),('325','2014-03-07','15:20:00',3.59),('325','2014-03-07','15:25:00',3.42),('325','2014-03-07','15:30:00',3.27),('325','2014-03-07','15:35:00',3.04),('325','2014-03-07','15:40:00',2.65),('325','2014-03-07','15:45:00',2.61),('325','2014-03-07','15:50:00',2.14),('325','2014-03-07','15:55:00',1.81),('325','2014-03-07','16:00:00',2.22),('325','2014-03-07','16:05:00',2.02),('325','2014-03-07','16:10:00',1.93),('325','2014-03-07','16:15:00',1.92),('325','2014-03-07','16:20:00',1.73),('325','2014-03-07','16:25:00',1.6),('325','2014-03-07','16:30:00',1.5),('325','2014-03-07','16:35:00',1.43),('325','2014-03-07','16:40:00',1.45),('325','2014-03-07','16:45:00',1.38),('325','2014-03-07','16:50:00',1.27),('325','2014-03-07','16:55:00',1.18),('325','2014-03-07','17:00:00',1.08),('325','2014-04-29','09:50:00',1.08),('325','2014-04-29','09:55:00',1.2),('325','2014-04-29','10:00:00',1.29),('325','2014-04-29','10:05:00',2.5),('325','2014-04-29','10:10:00',4.1),('325','2014-04-29','10:15:00',3.31),('325','2014-04-29','10:20:00',3.31),('325','2014-04-29','10:25:00',4.24),('325','2014-04-29','10:30:00',4),('325','2014-04-29','10:35:00',4.06),('325','2014-04-29','10:40:00',4.15),('325','2014-04-29','10:45:00',4.23),('325','2014-04-29','10:50:00',4.34),('325','2014-04-29','10:55:00',4.05),('325','2014-04-29','11:00:00',4.32),('325','2014-04-29','11:05:00',4.35),('325','2014-04-29','11:10:00',3.93),('325','2014-04-29','11:15:00',4.96),('325','2014-04-29','11:20:00',2.87),('325','2014-04-29','11:25:00',4.56),('325','2014-04-29','11:30:00',1.82),('325','2014-04-29','11:35:00',2.63),('325','2014-04-29','11:40:00',3.35),('325','2014-04-29','11:45:00',1.44),('325','2014-04-29','11:50:00',1.14),('325','2014-04-29','11:55:00',1.22),('325','2014-04-29','12:00:00',1.67),('325','2014-04-29','12:05:00',1.73),('325','2014-04-29','12:10:00',1.78),('325','2014-04-29','12:15:00',1.68),('325','2014-04-29','12:20:00',2.09),('325','2014-04-29','12:25:00',1.66),('325','2014-04-29','12:30:00',1.49),('325','2014-04-29','12:35:00',1.79),('325','2014-04-29','12:40:00',1.93),('325','2014-04-29','12:45:00',5.72),('325','2014-04-29','12:50:00',2.01),('325','2014-04-29','12:55:00',1.88),('325','2014-04-29','13:00:00',2.74),('325','2014-04-29','13:05:00',3.15),('325','2014-04-29','13:10:00',2.91),('325','2014-04-29','13:15:00',4.51),('325','2014-04-29','13:20:00',3.9),('325','2014-04-29','13:25:00',3.29),('325','2014-04-29','13:30:00',4.34),('325','2014-04-29','13:35:00',2.48),('325','2014-04-29','13:40:00',1.72),('325','2014-04-29','13:45:00',3.03),('325','2014-04-29','13:50:00',3.16),('325','2014-04-29','17:05:00',1.21),('325','2014-04-29','17:10:00',1.12),('325','2014-04-29','17:20:00',1.43),('325','2014-04-29','17:25:00',1.39),('325','2014-04-29','17:30:00',1.91),('325','2014-04-29','17:35:00',1.55),('325','2014-04-29','17:40:00',1.98),('325','2014-04-29','17:45:00',1.53),('325','2014-03-06','08:00:00',1.07),('325','2014-03-06','08:10:00',1.18),('325','2014-03-06','08:15:00',1.51),('325','2014-03-06','08:20:00',1.36),('325','2014-03-06','08:25:00',1.14),('325','2014-03-06','09:15:00',1.04),('325','2014-03-06','09:20:00',1.17),('325','2014-03-06','09:35:00',1.15),('325','2014-03-06','09:40:00',1.26),('325','2014-03-06','09:45:00',1.39),('325','2014-03-06','09:50:00',1.55),('325','2014-03-06','09:55:00',1.85),('325','2014-03-06','10:00:00',2.01),('325','2014-03-06','10:05:00',2.91),('325','2014-03-06','10:10:00',2.89),('325','2014-03-06','10:15:00',3.17),('325','2014-03-06','10:20:00',3.45),('325','2014-03-06','10:25:00',2.79),('325','2014-03-06','10:30:00',1.01),('325','2014-03-06','10:35:00',1.81),('325','2014-03-06','10:40:00',2.74),('325','2014-03-06','10:45:00',1.16),('325','2014-03-06','10:50:00',1.89),('325','2014-03-06','10:55:00',1.81),('325','2014-03-06','11:00:00',3.16),('325','2014-03-06','11:05:00',3.74),('325','2014-03-06','11:10:00',3.17),('325','2014-03-06','11:15:00',2.54),('325','2014-03-06','11:20:00',3.23),('325','2014-03-06','11:25:00',2.21),('325','2014-03-06','11:30:00',1.62),('325','2014-03-06','11:35:00',1.41),('325','2014-03-06','11:40:00',1.82),('325','2014-03-06','11:45:00',4.03),('325','2014-03-06','11:50:00',3.09),('325','2014-03-06','11:55:00',3.34),('325','2014-03-06','12:00:00',1.57),('325','2014-03-06','12:05:00',2.49),('325','2014-03-06','12:10:00',4.77),('325','2014-03-06','12:15:00',3.41),('325','2014-03-06','12:20:00',1.36),('325','2014-03-06','12:25:00',2.27),('325','2014-03-06','12:30:00',2.89),('325','2014-03-06','12:35:00',2.92),('325','2014-03-06','12:40:00',1.47),('325','2014-03-06','12:45:00',1.04),('325','2014-03-06','12:50:00',1.06),('325','2014-03-06','12:55:00',1.36),('325','2014-03-06','13:00:00',1.99),('325','2014-03-06','13:05:00',1.48),('325','2014-03-06','13:10:00',1.31),('325','2014-03-06','13:15:00',1.34),('325','2014-03-06','13:20:00',1.14),('325','2014-03-06','13:25:00',1.03),('325','2014-03-06','13:30:00',1.15),('325','2014-03-06','13:35:00',1.11),('325','2014-03-06','13:40:00',1.19),('325','2014-03-06','13:45:00',1.09),('325','2014-03-06','13:50:00',1.02),('325','2014-03-06','14:05:00',1.12),('325','2014-03-06','14:10:00',1.16),('325','2014-03-06','14:15:00',1.1),('325','2014-03-06','14:20:00',1.35),('325','2014-03-06','14:25:00',1.23),('325','2014-03-06','14:30:00',1.15),('325','2014-03-06','14:35:00',1.71),('325','2014-03-06','14:40:00',1.57),('325','2014-03-06','15:00:00',1.13),('325','2014-03-06','15:05:00',1.41),('325','2014-03-06','15:10:00',1.35),('325','2014-03-05','08:10:00',1.02),('325','2014-03-05','08:15:00',1.15),('325','2014-03-05','08:35:00',1.77),('325','2014-03-05','08:40:00',1.61),('325','2014-03-05','08:45:00',1.66),('325','2014-03-05','08:50:00',1.36),('325','2014-03-05','09:00:00',1.38),('325','2014-03-05','09:05:00',1.69),('325','2014-03-05','09:15:00',1.69),('325','2014-03-05','09:20:00',1.66),('325','2014-03-05','09:25:00',1.65),('325','2014-03-05','09:30:00',1.68),('325','2014-03-05','09:35:00',1.54),('325','2014-03-05','09:40:00',1.79),('325','2014-03-05','09:45:00',1.83),('325','2014-03-05','09:50:00',2.8),('325','2014-03-05','09:55:00',3.24),('325','2014-03-05','10:00:00',3.33),('325','2014-03-05','10:05:00',3.39),('325','2014-03-05','10:10:00',3.49),('325','2014-03-05','10:15:00',3.54),('325','2014-03-05','10:20:00',3.61),('325','2014-03-05','10:25:00',3.66),('325','2014-03-05','10:30:00',3.71),('325','2014-03-05','10:35:00',3.75),('325','2014-03-05','10:40:00',3.78),('325','2014-03-05','10:45:00',3.81),('325','2014-03-05','10:50:00',3.86),('325','2014-03-05','10:55:00',3.9),('325','2014-03-05','11:00:00',3.94),('325','2014-03-05','11:05:00',3.99),('325','2014-03-05','11:10:00',4.05),('325','2014-03-05','11:15:00',4.13),('325','2014-03-05','11:20:00',4.18),('325','2014-03-05','11:25:00',4.19),('325','2014-03-05','11:30:00',4.26),('325','2014-03-05','11:35:00',4.42),('325','2014-03-05','11:40:00',4.33),('325','2014-03-05','11:45:00',4.38),('325','2014-03-05','11:50:00',4.31),('325','2014-03-05','11:55:00',3.67),('325','2014-03-05','12:00:00',3.77),('325','2014-03-05','12:05:00',3.39),('325','2014-03-05','12:10:00',3.22),('325','2014-03-05','12:15:00',1.15),('325','2014-03-05','12:20:00',1.05),('325','2014-03-05','12:25:00',1.15),('325','2014-03-05','12:30:00',1.32),('325','2014-03-05','12:35:00',2.56),('325','2014-03-05','12:40:00',2.17),('325','2014-03-05','12:45:00',1.21),('325','2014-03-05','12:50:00',1.52),('325','2014-03-05','12:55:00',1.63),('325','2014-03-05','13:00:00',2.05),('325','2014-03-05','13:05:00',2.73),('325','2014-03-05','13:10:00',3.87),('325','2014-03-05','13:15:00',2.59),('325','2014-03-05','13:20:00',2.61),('325','2014-03-05','13:25:00',1.84),('325','2014-03-05','13:30:00',1.42),('325','2014-03-05','13:35:00',1.29),('325','2014-03-05','13:40:00',1.65),('325','2014-03-05','13:45:00',1.59),('325','2014-03-05','13:50:00',1.36),('325','2014-03-05','13:55:00',1.17),('325','2014-03-05','14:00:00',1.09),('325','2014-03-05','14:05:00',1.17),('325','2014-03-05','14:10:00',1.07),('325','2014-03-05','14:15:00',1.18),('325','2014-03-05','14:20:00',1.29),('325','2014-03-05','14:25:00',1.5),('325','2014-03-05','14:30:00',1.54),('325','2014-03-05','14:35:00',1.29),('325','2014-03-05','14:40:00',1.89),('325','2014-03-05','14:45:00',3.32),('325','2014-03-05','14:50:00',3.07),('325','2014-03-05','14:55:00',2.37),('325','2014-03-05','15:00:00',1.08),('325','2014-03-05','15:35:00',1.24),('325','2014-03-05','15:40:00',1.71),('325','2014-03-05','15:45:00',2.25),('325','2014-03-05','15:50:00',1.41),('325','2014-03-05','15:55:00',2.03),('325','2014-03-05','16:00:00',3.08),('325','2014-03-05','16:05:00',2.82),('325','2014-03-05','16:10:00',2.42),('325','2014-03-05','16:15:00',1.69),('325','2014-03-04','09:05:00',1.07),('325','2014-03-04','09:10:00',1.35),('325','2014-03-04','09:15:00',1.91),('325','2014-03-04','09:20:00',1.78),('325','2014-03-04','09:30:00',1.01),('325','2014-03-04','09:40:00',1.11),('325','2014-03-04','09:55:00',1.79),('325','2014-03-04','10:00:00',1.26),('325','2014-03-04','10:20:00',1.09),('325','2014-03-04','10:25:00',2.88),('325','2014-03-04','10:30:00',1.77),('325','2014-03-04','10:35:00',4.32),('325','2014-03-04','10:40:00',4.7),('325','2014-03-04','10:45:00',4.45),('325','2014-03-04','10:50:00',1.36),('325','2014-03-04','10:55:00',3.9),('325','2014-03-04','11:00:00',2.28),('325','2014-03-04','11:05:00',2.85),('325','2014-03-04','11:10:00',4.88),('325','2014-03-04','11:15:00',5.16),('325','2014-03-04','11:20:00',2.66),('325','2014-03-04','11:40:00',1.01),('325','2014-03-04','11:45:00',1.98),('325','2014-03-04','11:50:00',5.34),('325','2014-03-04','11:55:00',4.64),('325','2014-03-04','12:00:00',4.49),('325','2014-03-04','12:05:00',4.4),('325','2014-03-04','12:10:00',4.42),('325','2014-03-04','12:15:00',4.38),('325','2014-03-04','12:20:00',4.42),('325','2014-03-04','12:25:00',4.41),('325','2014-03-04','12:30:00',4.32),('325','2014-03-04','12:35:00',4.3),('325','2014-03-04','12:40:00',4.33),('325','2014-03-04','12:45:00',2.37),('325','2014-03-04','12:50:00',3.63),('325','2014-03-04','12:55:00',3.96),('325','2014-03-04','13:00:00',4.32),('325','2014-03-04','13:05:00',2.9),('325','2014-03-04','13:10:00',4.65),('325','2014-03-04','13:15:00',1.96),('325','2014-03-04','13:20:00',1.91),('325','2014-03-04','13:25:00',1.03),('325','2014-03-04','13:30:00',1.08),('325','2014-03-04','13:45:00',1.36),('325','2014-03-04','13:50:00',1.49),('325','2014-03-04','13:55:00',1.1),('325','2014-03-04','14:05:00',2.66),('325','2014-03-04','14:10:00',3.22),('325','2014-03-04','14:15:00',3.63),('325','2014-03-04','14:20:00',2.58),('325','2014-03-04','14:25:00',4),('325','2014-03-04','14:30:00',3.71),('325','2014-03-04','14:35:00',3.52),('325','2014-03-04','14:40:00',3.53),('325','2014-03-04','14:45:00',3.46),('325','2014-03-04','14:50:00',3.68),('325','2014-03-04','14:55:00',2.81),('325','2014-03-04','15:00:00',3.51),('325','2014-03-04','15:05:00',3.2),('325','2014-03-04','15:10:00',2.96),('325','2014-03-04','15:15:00',2.99),('325','2014-03-04','15:20:00',1.4),('325','2014-03-04','15:25:00',2.53),('325','2014-03-04','15:30:00',1.1),('325','2014-03-04','15:35:00',3.07),('325','2014-03-04','15:40:00',2.55),('325','2014-03-04','15:45:00',2.34),('325','2014-03-04','15:50:00',1.9),('325','2014-03-04','16:05:00',1.18),('325','2014-03-04','16:10:00',1.01),('325','2014-03-04','16:20:00',1.12),('325','2014-03-04','16:25:00',1.42),('325','2014-03-04','16:30:00',1.01),('325','2014-03-04','16:40:00',1.12),('325','2014-03-04','16:45:00',1.17),('325','2014-03-04','16:50:00',1.05),('325','2014-03-03','08:25:00',1),('325','2014-03-03','08:30:00',1.05),('325','2014-03-03','08:35:00',1.1),('325','2014-03-03','08:40:00',1.17),('325','2014-03-03','08:45:00',1.23),('325','2014-03-03','08:50:00',1.23),('325','2014-03-03','08:55:00',1.4),('325','2014-03-03','09:00:00',1.44),('325','2014-03-03','09:05:00',1.43),('325','2014-03-03','09:10:00',1.3),('325','2014-03-03','09:15:00',1.42),('325','2014-03-03','09:20:00',1.54),('325','2014-03-03','09:25:00',1.62),('325','2014-03-03','09:30:00',1.67),('325','2014-03-03','09:35:00',1.56),('325','2014-03-03','09:40:00',1.42),('325','2014-03-03','09:45:00',2.01),('325','2014-03-03','09:50:00',2.54),('325','2014-03-03','09:55:00',2.84),('325','2014-03-03','10:00:00',3.1),('325','2014-03-03','10:05:00',3.33),('325','2014-03-03','10:10:00',3.37),('325','2014-03-03','10:15:00',3.42),('325','2014-03-03','10:20:00',3.52),('325','2014-03-03','10:25:00',3.56),('325','2014-03-03','10:30:00',3.6),('325','2014-03-03','10:35:00',3.65),('325','2014-03-03','10:40:00',3.7),('325','2014-03-03','10:45:00',3.75),('325','2014-03-03','10:50:00',3.75),('325','2014-03-03','10:55:00',3.78),('325','2014-03-03','11:00:00',3.86),('325','2014-03-03','11:05:00',3.87),('325','2014-03-03','11:10:00',3.94),('325','2014-03-03','11:15:00',3.98),('325','2014-03-03','11:20:00',4.04),('325','2014-03-03','11:25:00',4.09),('325','2014-03-03','11:30:00',4.12),('325','2014-03-03','11:35:00',2.52),('325','2014-03-03','11:40:00',4.27),('325','2014-03-03','11:45:00',4.23),('325','2014-03-03','11:50:00',4.31),('325','2014-03-03','11:55:00',4.28),('325','2014-03-03','12:00:00',4.28),('325','2014-03-03','12:05:00',4.31),('325','2014-03-03','12:10:00',4.32),('325','2014-03-03','12:15:00',4.31),('325','2014-03-03','12:20:00',4.32),('325','2014-03-03','12:25:00',4.31),('325','2014-03-03','12:30:00',4.31),('325','2014-03-03','12:35:00',4.32),('325','2014-03-03','12:40:00',4.3),('325','2014-03-03','12:45:00',4.29),('325','2014-03-03','12:50:00',4.27),('325','2014-03-03','12:55:00',4.27),('325','2014-03-03','13:00:00',4.22),('325','2014-03-03','13:05:00',4.2),('325','2014-03-03','13:10:00',4.17),('325','2014-03-03','13:15:00',4.16),('325','2014-03-03','13:20:00',4.15),('325','2014-03-03','13:25:00',4.09),('325','2014-03-03','13:30:00',4.11),('325','2014-03-03','13:35:00',4.07),('325','2014-03-03','13:40:00',4.02),('325','2014-03-03','13:45:00',3.98),('325','2014-03-03','13:50:00',3.98),('325','2014-03-03','13:55:00',3.92),('325','2014-03-03','14:00:00',3.87),('325','2014-03-03','14:05:00',3.87),('325','2014-03-03','14:10:00',3.86),('325','2014-03-03','14:15:00',3.81),('325','2014-03-03','14:20:00',3.23),('325','2014-03-03','14:25:00',3.58),('325','2014-03-03','14:30:00',3.59),('325','2014-03-03','14:35:00',3.55),('325','2014-03-03','14:40:00',3.46),('325','2014-03-03','14:45:00',3.36),('325','2014-03-03','14:50:00',3.29),('325','2014-03-03','14:55:00',3.22),('325','2014-03-03','15:00:00',2.71),('325','2014-03-03','15:05:00',3.06),('325','2014-03-03','15:10:00',2.99),('325','2014-03-03','15:15:00',2.91),('325','2014-03-03','15:20:00',2.83),('325','2014-03-03','15:25:00',2.75),('325','2014-03-03','15:30:00',2.66),('325','2014-03-03','15:35:00',2.53),('325','2014-03-03','15:40:00',2.39),('325','2014-03-03','15:45:00',2.33),('325','2014-03-03','15:50:00',2.23),('325','2014-03-03','15:55:00',2.12),('325','2014-03-03','16:00:00',2),('325','2014-03-03','16:05:00',1.91),('325','2014-03-03','16:10:00',1.8),('325','2014-03-03','16:15:00',1.7),('325','2014-03-03','16:20:00',1.57),('325','2014-03-03','16:25:00',1.47),('325','2014-03-03','16:30:00',1.37),('325','2014-03-03','16:35:00',1.27),('325','2014-03-03','16:40:00',1.15),('325','2014-03-03','16:45:00',1.03),('325','2014-03-02','08:10:00',1.37),('325','2014-03-02','08:15:00',1.23),('325','2014-03-02','08:20:00',1.21),('325','2014-03-02','08:25:00',1.09),('325','2014-03-02','08:30:00',1.06),('325','2014-03-02','08:35:00',1.11),('325','2014-03-02','08:40:00',1.18),('325','2014-03-02','08:45:00',1.24),('325','2014-03-02','08:50:00',1.31),('325','2014-03-02','08:55:00',1.36),('325','2014-03-02','09:00:00',1.42),('325','2014-03-02','09:05:00',1.5),('325','2014-03-02','09:10:00',1.62),('325','2014-03-02','09:15:00',1.68),('325','2014-03-02','09:20:00',1.37),('325','2014-03-02','09:25:00',1.91),('325','2014-03-02','09:30:00',2.02),('325','2014-03-02','09:35:00',2.03),('325','2014-03-02','09:40:00',1.79),('325','2014-03-02','09:55:00',1.32),('325','2014-03-02','10:00:00',1.6),('325','2014-03-02','10:05:00',1.66),('325','2014-03-02','10:10:00',1.35),('325','2014-03-02','10:15:00',1.33),('325','2014-03-02','10:20:00',1.39),('325','2014-03-02','10:25:00',1.73),('325','2014-03-02','10:30:00',1.84),('325','2014-03-02','10:35:00',3.43),('325','2014-03-02','10:40:00',3.13),('325','2014-03-02','10:45:00',1.06),('325','2014-03-02','10:50:00',2.22),('325','2014-03-02','10:55:00',2.01),('325','2014-03-02','11:00:00',3.51),('325','2014-03-02','11:05:00',3.35),('325','2014-03-02','11:10:00',1.63),('325','2014-03-02','11:15:00',1.37),('325','2014-03-02','11:20:00',1.93),('325','2014-03-02','11:25:00',2.05),('325','2014-03-02','11:30:00',2.64),('325','2014-03-02','11:35:00',2.96),('325','2014-03-02','11:40:00',2.56),('325','2014-03-02','11:45:00',5.33),('325','2014-03-02','11:50:00',5.05),('325','2014-03-02','11:55:00',4.76),('325','2014-03-02','12:00:00',4.05),('325','2014-03-02','12:05:00',2.43),('325','2014-03-02','12:10:00',1.82),('325','2014-03-02','12:15:00',2.7),('325','2014-03-02','12:20:00',2.37),('325','2014-03-02','12:25:00',2.41),('325','2014-03-02','12:30:00',1.41),('325','2014-03-02','12:35:00',1.14),('325','2014-03-02','12:50:00',1.09),('325','2014-03-02','12:55:00',1.3),('325','2014-03-02','13:00:00',1.42),('325','2014-03-02','13:05:00',1.47),('325','2014-03-02','13:10:00',1.39),('325','2014-03-02','13:15:00',1.2),('325','2014-03-02','13:20:00',1.11),('325','2014-03-02','13:25:00',1.08),('325','2014-03-02','13:30:00',1.06),('325','2014-03-02','13:50:00',1.02),('325','2014-03-02','13:55:00',1.1),('325','2014-03-02','14:00:00',1.3),('325','2014-03-02','14:05:00',1.38),('325','2014-03-02','14:10:00',1.29),('325','2014-03-02','14:15:00',1.24),('325','2014-03-02','14:20:00',1.14),('325','2014-03-02','14:25:00',1.15),('325','2014-03-02','14:30:00',1.21),('325','2014-03-02','14:35:00',1.23),('325','2014-03-02','14:40:00',1.23),('325','2014-03-02','14:45:00',1.29),('325','2014-03-02','14:50:00',1.31),('325','2014-03-02','14:55:00',1.28),('325','2014-03-02','15:00:00',1.34),('325','2014-03-02','15:05:00',1.43),('325','2014-03-02','15:10:00',1.51),('325','2014-03-02','15:15:00',1.5),('325','2014-03-02','15:20:00',1.5),('325','2014-03-02','15:25:00',1.47),('325','2014-03-02','15:30:00',1.53),('325','2014-03-02','15:35:00',1.44),('325','2014-03-02','15:40:00',1.51),('325','2014-03-02','15:45:00',1.25),('325','2014-03-02','15:50:00',1.09),('325','2014-02-28','08:20:00',1.34),('325','2014-02-28','08:35:00',1.54),('325','2014-02-28','09:15:00',1.16),('325','2014-02-28','09:20:00',1.12),('325','2014-02-28','09:25:00',1.35),('325','2014-02-28','09:30:00',1.46),('325','2014-02-28','09:40:00',1.88),('325','2014-02-28','09:45:00',2.16),('325','2014-02-28','09:50:00',2.57),('325','2014-02-28','09:55:00',1.83),('325','2014-02-28','10:00:00',1.13),('325','2014-02-28','10:05:00',1.26),('325','2014-02-28','10:10:00',1.6),('325','2014-02-28','10:15:00',1.26),('325','2014-02-28','10:20:00',2.42),('325','2014-02-28','10:25:00',3.43),('325','2014-02-28','10:30:00',4.2),('325','2014-02-28','10:35:00',2.58),('325','2014-02-28','10:40:00',1.27),('325','2014-02-28','11:15:00',1.12),('325','2014-02-28','11:20:00',1.41),('325','2014-02-28','11:25:00',1.34),('325','2014-02-28','11:30:00',1.07),('325','2014-02-28','11:50:00',1.12),('325','2014-02-28','11:55:00',1.24),('325','2014-02-28','12:00:00',1.61),('325','2014-02-28','12:05:00',2.35),('325','2014-02-28','12:10:00',1.91),('325','2014-02-28','12:15:00',1.07),('325','2014-02-28','12:20:00',1.04),('325','2014-02-28','12:25:00',2.37),('325','2014-02-28','12:30:00',2.26),('325','2014-02-28','12:35:00',4.85),('325','2014-02-28','12:40:00',2.88),('325','2014-02-28','12:45:00',1.49),('325','2014-02-28','12:50:00',3.94),('325','2014-02-28','12:55:00',1.73),('325','2014-02-28','13:00:00',2.9),('325','2014-02-28','13:05:00',1.81),('325','2014-02-28','13:10:00',1.54),('325','2014-02-28','13:45:00',1.39),('325','2014-02-28','13:50:00',5.13),('325','2014-02-28','13:55:00',2.47),('325','2014-02-28','14:00:00',1.42),('325','2014-02-28','14:15:00',1.23),('325','2014-02-28','14:20:00',1.61),('325','2014-02-28','14:25:00',2.39),('325','2014-02-28','14:30:00',2.06),('325','2014-02-28','14:35:00',1.58),('325','2014-02-28','14:40:00',1.45),('325','2014-02-28','14:45:00',1.4),('325','2014-02-28','14:50:00',1.51),('325','2014-02-28','14:55:00',1.65),('325','2014-02-28','15:00:00',2.34),('325','2014-02-28','15:05:00',1.85),('325','2014-02-28','15:25:00',2.92),('325','2014-02-28','15:30:00',2.05),('325','2014-02-28','15:35:00',1.9),('325','2014-02-28','15:40:00',1.98),('325','2014-02-28','15:45:00',1.34),('325','2014-02-28','16:10:00',1.44),('325','2014-02-28','16:15:00',2.29),('325','2014-02-28','16:20:00',1.63),('325','2014-02-28','16:35:00',1.11),('325','2014-02-28','16:40:00',1.45),('325','2014-02-28','16:45:00',1.56),('325','2014-02-28','16:50:00',1.28),('325','2014-02-27','10:40:00',1.19),('325','2014-02-27','10:45:00',1.27),('325','2014-02-27','10:50:00',1.32),('325','2014-02-27','10:55:00',1.44),('325','2014-02-27','11:00:00',1.65),('325','2014-02-27','11:05:00',1.8),('325','2014-02-27','11:10:00',1.67),('325','2014-02-27','11:15:00',1.65),('325','2014-02-27','11:20:00',1.45),('325','2014-02-27','11:25:00',1.76),('325','2014-02-27','11:30:00',2.09),('325','2014-02-27','11:35:00',1.81),('325','2014-02-27','11:40:00',1.49),('325','2014-02-27','11:45:00',1.24),('325','2014-02-27','11:50:00',1.28),('325','2014-02-27','11:55:00',1.32),('325','2014-02-27','12:00:00',1.28),('325','2014-02-27','12:05:00',1.23),('325','2014-02-27','12:10:00',1.14),('325','2014-02-27','12:15:00',1.24),('325','2014-02-27','12:20:00',1.3),('325','2014-02-27','12:25:00',1.31),('325','2014-02-27','12:30:00',1.22),('325','2014-02-27','12:35:00',1.18),('325','2014-02-27','12:40:00',1.16),('325','2014-02-27','12:45:00',1.15),('325','2014-02-27','12:50:00',1.15),('325','2014-02-27','12:55:00',1.2),('325','2014-02-27','13:00:00',1.27),('325','2014-02-27','13:05:00',1.17),('325','2014-02-27','13:10:00',1.24),('325','2014-02-27','13:15:00',1.33),('325','2014-02-27','13:20:00',1.32),('325','2014-02-27','13:25:00',1.4),('325','2014-02-27','13:30:00',1.66),('325','2014-02-27','13:35:00',1.78),('325','2014-02-27','13:40:00',1.84),('325','2014-02-27','13:45:00',1.85),('325','2014-02-27','13:50:00',1.87),('325','2014-02-27','13:55:00',2.18),('325','2014-02-27','14:00:00',2.23),('325','2014-02-27','14:05:00',1.88),('325','2014-02-27','14:10:00',1.72),('325','2014-02-27','14:15:00',1.56),('325','2014-02-27','14:20:00',1.53),('325','2014-02-27','14:25:00',1.51),('325','2014-02-27','14:30:00',1.64),('325','2014-02-27','14:35:00',1.44),('325','2014-02-27','14:40:00',1.27),('325','2014-02-27','14:45:00',1.37),('325','2014-02-27','14:50:00',1.3),('325','2014-02-27','14:55:00',1.21),('325','2014-02-27','15:00:00',1.29),('325','2014-02-27','15:05:00',1.28),('325','2014-02-27','15:10:00',1.35),('325','2014-02-27','15:15:00',1.58),('325','2014-02-27','15:20:00',1.69),('325','2014-02-27','15:25:00',1.45),('325','2014-02-27','15:30:00',1.45),('325','2014-02-27','15:35:00',1.42),('325','2014-02-27','15:40:00',1.08),('325','2014-02-27','16:40:00',1.16),('325','2014-02-27','16:45:00',1.31),('325','2014-02-27','16:50:00',1.33),('325','2014-02-27','16:55:00',1.19),('325','2014-02-26','08:30:00',1.03),('325','2014-02-26','08:35:00',1.12),('325','2014-02-26','08:40:00',1.21),('325','2014-02-26','08:45:00',1.43),('325','2014-02-26','08:50:00',1.19),('325','2014-02-26','08:55:00',1.36),('325','2014-02-26','09:00:00',1.38),('325','2014-02-26','09:05:00',1.38),('325','2014-02-26','09:10:00',1.47),('325','2014-02-26','09:15:00',1.56),('325','2014-02-26','09:20:00',1.68),('325','2014-02-26','09:25:00',1.97),('325','2014-02-26','09:30:00',1.97),('325','2014-02-26','09:35:00',1.8),('325','2014-02-26','09:40:00',1.62),('325','2014-02-26','09:45:00',1.56),('325','2014-02-26','09:50:00',1.74),('325','2014-02-26','09:55:00',1.32),('325','2014-02-26','10:00:00',1.28),('325','2014-02-26','11:00:00',1.06),('325','2014-02-26','11:05:00',1.08),('325','2014-02-26','11:10:00',1.05),('325','2014-02-26','11:50:00',1.22),('325','2014-02-26','11:55:00',1.33),('325','2014-02-26','12:00:00',1.49),('325','2014-02-26','12:05:00',1.36),('325','2014-02-26','12:10:00',1.39),('325','2014-02-26','12:15:00',1.26),('325','2014-02-26','12:20:00',1.97),('325','2014-02-26','12:25:00',3.33),('325','2014-02-26','12:30:00',3.05),('325','2014-02-26','12:35:00',3.2),('325','2014-02-26','12:40:00',4.27),('325','2014-02-26','12:45:00',4.32),('325','2014-02-26','12:50:00',3.76),('325','2014-02-26','12:55:00',4.11),('325','2014-02-26','13:00:00',3.19),('325','2014-02-26','13:05:00',3.26),('325','2014-02-26','13:10:00',3.45),('325','2014-02-26','13:15:00',3.11),('325','2014-02-26','13:20:00',3.06),('325','2014-02-26','13:25:00',2.29),('325','2014-02-26','13:30:00',2.82),('325','2014-02-26','13:35:00',3.31),('325','2014-02-26','13:40:00',2.7),('325','2014-02-26','13:45:00',1.53),('325','2014-02-26','13:50:00',1.45),('325','2014-02-26','13:55:00',3.55),('325','2014-02-26','14:00:00',3.95),('325','2014-02-26','14:05:00',2),('325','2014-02-26','14:10:00',1.28),('325','2014-02-26','14:15:00',2.73),('325','2014-02-26','14:20:00',2.69),('325','2014-02-26','14:25:00',2.82),('325','2014-02-26','14:35:00',3.19),('325','2014-02-26','14:40:00',3.52),('325','2014-02-26','14:45:00',3.4),('325','2014-02-26','14:50:00',3.44),('325','2014-02-26','14:55:00',3.34),('325','2014-02-26','15:00:00',2.82),('325','2014-02-26','15:05:00',2.93),('325','2014-02-26','15:10:00',2.26),('325','2014-02-26','15:15:00',2.41),('325','2014-02-26','15:20:00',1.58),('325','2014-02-26','15:25:00',1.24),('325','2014-02-26','15:30:00',1.47),('325','2014-02-26','15:35:00',1.92),('325','2014-02-26','15:40:00',1.96),('325','2014-02-26','15:45:00',1.43),('325','2014-02-26','15:50:00',1.51),('325','2014-02-26','15:55:00',1.71),('325','2014-02-26','16:00:00',1.96),('325','2014-02-26','16:05:00',1.77),('325','2014-02-26','16:10:00',1.04),('325','2014-02-26','16:15:00',1.07),('325','2014-02-25','08:40:00',1.05),('325','2014-02-25','08:45:00',1.11),('325','2014-02-25','08:50:00',1.16),('325','2014-02-25','08:55:00',1.21),('325','2014-02-25','09:00:00',1.26),('325','2014-02-25','09:05:00',1.32),('325','2014-02-25','09:10:00',1.36),('325','2014-02-25','09:15:00',1.4),('325','2014-02-25','09:20:00',1.44),('325','2014-02-25','09:25:00',1.49),('325','2014-02-25','09:30:00',1.53),('325','2014-02-25','09:35:00',1.57),('325','2014-02-25','09:40:00',1.61),('325','2014-02-25','09:45:00',1.65),('325','2014-02-25','09:50:00',1.69),('325','2014-02-25','09:55:00',2.64),('325','2014-02-25','10:00:00',2.96),('325','2014-02-25','10:05:00',3.05),('325','2014-02-25','10:10:00',3.09),('325','2014-02-25','10:15:00',3.16),('325','2014-02-25','10:20:00',3.23),('325','2014-02-25','10:25:00',3.33),('325','2014-02-25','10:30:00',3.39),('325','2014-02-25','10:35:00',3.42),('325','2014-02-25','10:40:00',3.45),('325','2014-02-25','10:45:00',3.52),('325','2014-02-25','10:50:00',3.55),('325','2014-02-25','10:55:00',3.56),('325','2014-02-25','11:00:00',3.56),('325','2014-02-25','11:05:00',3.59),('325','2014-02-25','11:10:00',3.65),('325','2014-02-25','11:15:00',3.71),('325','2014-02-25','11:20:00',3.71),('325','2014-02-25','11:25:00',3.73),('325','2014-02-25','11:30:00',3.74),('325','2014-02-25','11:35:00',3.76),('325','2014-02-25','11:40:00',3.8),('325','2014-02-25','11:45:00',3.83),('325','2014-02-25','11:50:00',3.84),('325','2014-02-25','11:55:00',3.85),('325','2014-02-25','12:00:00',3.86),('325','2014-02-25','12:05:00',3.87),('325','2014-02-25','12:10:00',3.92),('325','2014-02-25','12:15:00',3.94),('325','2014-02-25','12:20:00',3.95),('325','2014-02-25','12:25:00',3.98),('325','2014-02-25','12:30:00',3.94),('325','2014-02-25','12:35:00',3.92),('325','2014-02-25','12:40:00',3.91),('325','2014-02-25','12:45:00',3.86),('325','2014-02-25','12:50:00',3.86),('325','2014-02-25','12:55:00',3.87),('325','2014-02-25','13:00:00',3.8),('325','2014-02-25','13:05:00',3.57),('325','2014-02-25','13:10:00',3.41),('325','2014-02-25','13:15:00',1.5),('325','2014-02-25','13:25:00',1.08),('325','2014-02-25','13:35:00',1.26),('325','2014-02-25','13:40:00',1.78),('325','2014-02-25','13:45:00',1.34),('325','2014-02-25','13:50:00',1.21),('325','2014-02-25','13:55:00',1.36),('325','2014-02-25','14:00:00',1.46),('325','2014-02-25','14:05:00',1.28),('325','2014-02-25','14:10:00',1.24),('325','2014-02-25','14:15:00',1.3),('325','2014-02-25','14:20:00',1.32),('325','2014-02-25','14:25:00',2.46),('325','2014-02-25','14:30:00',2.2),('325','2014-02-25','14:35:00',2.7),('325','2014-02-25','14:40:00',3.31),('325','2014-02-25','14:45:00',3.28),('325','2014-02-25','14:50:00',2.71),('325','2014-02-25','14:55:00',2.43),('325','2014-02-25','15:00:00',2.61),('325','2014-02-25','15:05:00',2.79),('325','2014-02-25','15:10:00',2.7),('325','2014-02-25','15:15:00',2.57),('325','2014-02-25','15:20:00',2.47),('325','2014-02-25','15:25:00',2.11),('325','2014-02-25','15:30:00',1.98),('325','2014-02-25','15:35:00',1.81),('325','2014-02-25','15:40:00',1.8),('325','2014-02-25','15:45:00',1.23),('325','2014-02-25','15:50:00',1.02),('325','2014-02-25','15:55:00',1.22),('325','2014-02-25','16:05:00',1.16),('325','2014-02-25','16:10:00',1.09),('325','2014-02-25','16:15:00',1.19),('325','2014-02-25','16:20:00',1.21),('325','2014-04-28','08:20:00',1.22),('325','2014-04-28','08:25:00',1.46),('325','2014-04-28','08:30:00',1.09),('325','2014-04-28','08:35:00',1.13),('325','2014-04-28','08:40:00',1.09),('325','2014-04-28','08:45:00',1.03),('325','2014-04-28','08:50:00',1.12),('325','2014-04-28','08:55:00',1.13),('325','2014-04-28','09:05:00',1.49),('325','2014-04-28','09:10:00',2.01),('325','2014-04-28','09:15:00',1.96),('325','2014-04-28','09:20:00',2.04),('325','2014-04-28','09:25:00',1.8),('325','2014-04-28','09:30:00',2.92),('325','2014-04-28','09:35:00',2.63),('325','2014-04-28','09:40:00',2.04),('325','2014-04-28','09:45:00',1.82),('325','2014-04-28','09:50:00',1.4),('325','2014-04-28','09:55:00',1.39),('325','2014-04-28','10:00:00',2.3),('325','2014-04-28','10:05:00',2.42),('325','2014-04-28','10:10:00',2.31),('325','2014-04-28','10:15:00',1.87),('325','2014-04-28','10:20:00',1.42),('325','2014-04-28','10:40:00',1.26),('325','2014-04-28','10:45:00',1.76),('325','2014-04-28','10:50:00',1.91),('325','2014-04-28','10:55:00',1.89),('325','2014-04-28','11:00:00',2.13),('325','2014-04-28','11:05:00',2.61),('325','2014-04-28','11:10:00',2.9),('325','2014-04-28','11:15:00',2.69),('325','2014-04-28','11:20:00',2.32),('325','2014-04-28','11:25:00',1.95),('325','2014-04-28','11:30:00',1.91),('325','2014-04-28','11:35:00',1.63),('325','2014-04-28','11:40:00',1.51),('325','2014-04-28','11:45:00',1.72),('325','2014-04-28','11:50:00',2.07),('325','2014-04-28','11:55:00',2.13),('325','2014-04-28','12:00:00',1.87),('325','2014-04-28','12:05:00',1.57),('325','2014-04-28','12:10:00',2.34),('325','2014-04-28','12:15:00',3.01),('325','2014-04-28','12:20:00',3),('325','2014-04-28','12:25:00',2.95),('325','2014-04-28','12:30:00',3.05),('325','2014-04-28','12:35:00',2.57),('325','2014-04-28','12:40:00',2.15),('325','2014-04-28','12:45:00',2.08),('325','2014-04-28','12:50:00',2.35),('325','2014-04-28','12:55:00',2.34),('325','2014-04-28','13:00:00',2.44),('325','2014-04-28','13:05:00',4.16),('325','2014-04-28','13:10:00',3.08),('325','2014-04-28','13:15:00',2.31),('325','2014-04-28','13:20:00',3.07),('325','2014-04-28','13:25:00',4.2),('325','2014-04-28','13:30:00',5.23),('325','2014-04-28','13:35:00',5.14),('325','2014-04-28','13:40:00',2.53),('325','2014-04-28','13:45:00',5.4),('325','2014-04-28','13:50:00',5),('325','2014-04-28','13:55:00',2.71),('325','2014-04-28','14:00:00',2.55),('325','2014-04-28','14:05:00',5.72),('325','2014-04-28','14:10:00',4.87),('325','2014-04-28','14:15:00',2.96),('325','2014-04-28','14:20:00',4.71),('325','2014-04-28','14:25:00',3.19),('325','2014-04-28','14:30:00',4.33),('325','2014-04-28','14:35:00',2.39),('325','2014-04-28','14:40:00',4.47),('325','2014-04-28','14:45:00',4.28),('325','2014-04-28','14:50:00',4.55),('325','2014-04-28','14:55:00',3.55),('325','2014-04-28','15:00:00',2.47),('325','2014-04-28','15:05:00',3.49),('325','2014-04-28','15:10:00',2.16),('325','2014-04-28','15:15:00',3.16),('325','2014-04-28','15:20:00',2.21),('325','2014-04-28','15:25:00',1.78),('325','2014-04-28','15:30:00',2.08),('325','2014-04-28','15:35:00',3.65),('325','2014-04-28','15:40:00',1.95),('325','2014-04-28','15:45:00',3.43),('325','2014-04-28','15:50:00',2.67),('325','2014-04-28','15:55:00',1.51),('325','2014-04-28','16:00:00',2.73),('325','2014-04-28','16:05:00',3.12),('325','2014-04-28','16:10:00',4.02),('325','2014-04-28','16:15:00',2.25),('325','2014-04-28','16:20:00',1.99),('325','2014-04-28','16:25:00',2.27),('325','2014-04-28','16:30:00',3.11),('325','2014-04-28','16:35:00',2.99),('325','2014-04-28','16:50:00',1.47),('325','2014-04-28','16:55:00',1.95),('325','2014-04-28','17:25:00',1.02),('325','2014-04-28','17:35:00',1.3),('325','2014-04-28','17:40:00',1.33),('325','2014-02-24','08:10:00',1.02),('325','2014-02-24','08:15:00',1.12),('325','2014-02-24','08:20:00',1.17),('325','2014-02-24','08:25:00',1.22),('325','2014-02-24','08:30:00',1.18),('325','2014-02-24','08:35:00',1.19),('325','2014-02-24','08:45:00',1.05),('325','2014-02-24','08:50:00',1.25),('325','2014-02-24','08:55:00',1.29),('325','2014-02-24','09:00:00',1.26),('325','2014-02-24','09:05:00',1.29),('325','2014-02-24','09:10:00',1.33),('325','2014-02-24','09:15:00',1.37),('325','2014-02-24','09:20:00',1.41),('325','2014-02-24','09:25:00',1.46),('325','2014-02-24','09:30:00',1.5),('325','2014-02-24','09:35:00',1.54),('325','2014-02-24','09:40:00',1.57),('325','2014-02-24','09:45:00',1.61),('325','2014-02-24','09:50:00',1.65),('325','2014-02-24','09:55:00',1.9),('325','2014-02-24','10:00:00',2.98),('325','2014-02-24','10:05:00',3.08),('325','2014-02-24','10:10:00',3.15),('325','2014-02-24','10:15:00',3.23),('325','2014-02-24','10:20:00',3.31),('325','2014-02-24','10:25:00',3.41),('325','2014-02-24','10:30:00',3.47),('325','2014-02-24','10:35:00',3.51),('325','2014-02-24','10:40:00',3.54),('325','2014-02-24','10:45:00',3.57),('325','2014-02-24','10:50:00',3.63),('325','2014-02-24','10:55:00',3.66),('325','2014-02-24','11:00:00',3.69),('325','2014-02-24','11:05:00',3.74),('325','2014-02-24','11:10:00',3.79),('325','2014-02-24','11:15:00',3.72),('325','2014-02-24','11:20:00',3.85),('325','2014-02-24','11:25:00',3.95),('325','2014-02-24','11:30:00',4.26),('325','2014-02-24','11:35:00',3.01),('325','2014-02-24','11:40:00',3.02),('325','2014-02-24','11:45:00',3.42),('325','2014-02-24','11:50:00',3.74),('325','2014-02-24','11:55:00',2.82),('325','2014-02-24','12:00:00',2.81),('325','2014-02-24','12:05:00',3.97),('325','2014-02-24','12:10:00',3.93),('325','2014-02-24','12:15:00',3.89),('325','2014-02-24','12:20:00',4.09),('325','2014-02-24','12:25:00',4.06),('325','2014-02-24','12:35:00',3.97),('325','2014-02-24','12:40:00',4.45),('325','2014-02-24','12:45:00',4.37),('325','2014-02-24','12:50:00',4.18),('325','2014-02-24','12:55:00',1.78),('325','2014-02-24','13:00:00',2.41),('325','2014-02-24','13:05:00',1.4),('325','2014-02-24','13:10:00',4.85),('325','2014-02-24','13:15:00',2.03),('325','2014-02-24','13:20:00',1.14),('325','2014-02-24','14:10:00',1.01),('325','2014-02-24','14:15:00',1.03),('325','2014-02-24','14:20:00',1.01),('325','2014-02-24','14:25:00',1.03),('325','2014-02-24','14:30:00',1.08),('325','2014-02-24','14:35:00',1.05),('325','2014-02-24','14:40:00',1.02),('325','2014-02-24','14:45:00',1.08),('325','2014-02-24','14:50:00',1.08),('325','2014-02-24','15:15:00',1.09),('325','2014-02-24','15:20:00',1.27),('325','2014-02-24','15:25:00',1.3),('325','2014-02-24','15:30:00',1.32),('325','2014-02-24','15:35:00',2.69),('325','2014-02-24','15:40:00',2.7),('325','2014-02-24','15:45:00',2.58),('325','2014-02-24','15:50:00',2.55),('325','2014-02-24','15:55:00',2.08),('325','2014-02-24','16:00:00',1.96),('325','2014-02-24','16:05:00',2.33),('325','2014-02-24','16:10:00',2.19),('325','2014-02-24','16:15:00',1.92),('325','2014-02-24','16:20:00',1.65),('325','2014-02-24','16:25:00',1.38),('325','2014-02-23','08:40:00',1.03),('325','2014-02-23','08:45:00',1.08),('325','2014-02-23','08:50:00',1.14),('325','2014-02-23','08:55:00',1.19),('325','2014-02-23','09:00:00',1.26),('325','2014-02-23','09:05:00',1.32),('325','2014-02-23','09:10:00',1.39),('325','2014-02-23','09:15:00',1.46),('325','2014-02-23','09:20:00',1.52),('325','2014-02-23','09:25:00',1.41),('325','2014-02-23','09:30:00',1.42),('325','2014-02-23','09:35:00',1.62),('325','2014-02-23','09:40:00',1.68),('325','2014-02-23','09:45:00',1.72),('325','2014-02-23','09:50:00',1.76),('325','2014-02-23','09:55:00',1.79),('325','2014-02-23','10:00:00',2.82),('325','2014-02-23','10:05:00',2.99),('325','2014-02-23','10:10:00',3.03),('325','2014-02-23','10:15:00',3.1),('325','2014-02-23','10:20:00',3.16),('325','2014-02-23','10:25:00',3.26),('325','2014-02-23','10:30:00',3.36),('325','2014-02-23','10:35:00',3.42),('325','2014-02-23','10:40:00',3.47),('325','2014-02-23','10:45:00',3.51),('325','2014-02-23','10:50:00',3.52),('325','2014-02-23','10:55:00',3.62),('325','2014-02-23','11:00:00',3.64),('325','2014-02-23','11:05:00',3.69),('325','2014-02-23','11:10:00',3.8),('325','2014-02-23','11:15:00',3.84),('325','2014-02-23','11:20:00',3.89),('325','2014-02-23','11:25:00',3.89),('325','2014-02-23','11:30:00',3.91),('325','2014-02-23','11:35:00',3.92),('325','2014-02-23','11:40:00',3.99),('325','2014-02-23','11:45:00',3.99),('325','2014-02-23','11:50:00',3.99),('325','2014-02-23','11:55:00',4.08),('325','2014-02-23','12:00:00',3.5),('325','2014-02-23','12:05:00',2.17),('325','2014-02-23','12:10:00',2.59),('325','2014-02-23','12:15:00',4.55),('325','2014-02-23','12:20:00',3.78),('325','2014-02-23','12:25:00',2.54),('325','2014-02-23','12:30:00',3.42),('325','2014-02-23','12:35:00',4.22),('325','2014-02-23','12:40:00',2.37),('325','2014-02-23','12:45:00',2.71),('325','2014-02-23','12:50:00',2.26),('325','2014-02-23','12:55:00',2.38),('325','2014-02-23','13:00:00',3.12),('325','2014-02-23','13:05:00',4.17),('325','2014-02-23','13:10:00',4.03),('325','2014-02-23','13:15:00',3.96),('325','2014-02-23','13:20:00',3.93),('325','2014-02-23','13:25:00',3.94),('325','2014-02-23','13:30:00',3.84),('325','2014-02-23','13:35:00',3.74),('325','2014-02-23','13:40:00',3.4),('325','2014-02-23','13:45:00',2.88),('325','2014-02-23','13:50:00',1.84),('325','2014-02-23','13:55:00',1.01),('325','2014-02-23','14:00:00',1.98),('325','2014-02-23','14:05:00',3.28),('325','2014-02-23','14:10:00',3.8),('325','2014-02-23','14:15:00',2.48),('325','2014-02-23','14:20:00',2.22),('325','2014-02-23','14:25:00',3.49),('325','2014-02-23','14:30:00',3.97),('325','2014-02-23','14:35:00',3.14),('325','2014-02-23','14:40:00',2.39),('325','2014-02-23','14:45:00',1.6),('325','2014-02-23','14:50:00',1.71),('325','2014-02-23','14:55:00',1.27),('325','2014-02-23','15:00:00',1.35),('325','2014-02-22','09:55:00',1.01),('325','2014-02-22','10:00:00',1.61),('325','2014-02-22','10:05:00',1.54),('325','2014-02-22','10:10:00',2.39),('325','2014-02-22','10:15:00',1.72),('325','2014-02-22','10:20:00',1.43),('325','2014-02-22','10:25:00',2.54),('325','2014-02-22','10:30:00',2.39),('325','2014-02-22','10:35:00',1.85),('325','2014-02-22','10:40:00',1.59),('325','2014-02-22','10:45:00',4.14),('325','2014-02-22','10:50:00',3.58),('325','2014-02-22','10:55:00',1.04),('325','2014-02-22','12:05:00',1.41),('325','2014-02-22','12:10:00',1.66),('325','2014-02-22','12:15:00',1.8),('325','2014-02-22','12:20:00',1.85),('325','2014-02-22','12:25:00',1.57),('325','2014-02-22','12:30:00',1.07),('325','2014-02-22','12:35:00',1.26),('325','2014-02-22','12:40:00',1.58),('325','2014-02-22','12:45:00',3.92),('325','2014-02-22','12:50:00',3.98),('325','2014-02-22','12:55:00',1.72),('325','2014-02-22','13:00:00',1.57),('325','2014-02-22','13:05:00',3.29),('325','2014-02-22','13:10:00',5.29),('325','2014-02-22','13:15:00',3.04),('325','2014-02-22','13:20:00',1.54),('325','2014-02-22','13:30:00',1.47),('325','2014-02-22','13:35:00',2.58),('325','2014-02-22','13:40:00',2.55),('325','2014-02-22','13:45:00',2.1),('325','2014-02-22','13:50:00',2.44),('325','2014-02-22','13:55:00',4.16),('325','2014-02-22','14:00:00',3.99),('325','2014-02-22','14:05:00',3.49),('325','2014-02-22','14:10:00',3.76),('325','2014-02-22','14:15:00',3.73),('325','2014-02-22','14:20:00',3.59),('325','2014-02-22','14:25:00',2.62),('325','2014-02-22','14:30:00',2.68),('325','2014-02-22','14:35:00',2.97),('325','2014-02-22','14:40:00',3.1),('325','2014-02-22','14:45:00',3.45),('325','2014-02-22','14:50:00',2.52),('325','2014-02-22','14:55:00',1.07),('325','2014-02-22','15:00:00',1.9),('325','2014-02-22','15:05:00',2.67),('325','2014-02-22','15:10:00',1.37),('325','2014-02-22','15:15:00',1.93),('325','2014-02-22','15:20:00',1.27),('325','2014-02-22','15:25:00',1.87),('325','2014-02-22','15:30:00',1.85),('325','2014-02-22','15:40:00',1.33),('325','2014-02-22','15:45:00',2.24),('325','2014-02-22','15:50:00',1.86),('325','2014-02-22','16:00:00',1.47),('325','2014-02-22','16:10:00',1.46),('325','2014-02-22','16:15:00',1.47),('325','2014-02-22','16:20:00',1.38),('325','2014-02-22','16:25:00',1.24),('325','2014-02-21','09:40:00',1.05),('325','2014-02-21','09:45:00',1.17),('325','2014-02-21','09:50:00',1.23),('325','2014-02-21','09:55:00',1.17),('325','2014-02-21','10:00:00',1.24),('325','2014-02-21','10:05:00',1.44),('325','2014-02-21','10:10:00',1.31),('325','2014-02-21','10:15:00',1.54),('325','2014-02-21','10:20:00',1.98),('325','2014-02-21','10:25:00',2.52),('325','2014-02-21','10:30:00',2.77),('325','2014-02-21','10:35:00',1.91),('325','2014-02-21','10:40:00',1.85),('325','2014-02-21','10:45:00',1.68),('325','2014-02-21','10:50:00',1.9),('325','2014-02-21','10:55:00',2.62),('325','2014-02-21','11:00:00',2.1),('325','2014-02-21','11:05:00',1.77),('325','2014-02-21','11:10:00',1.64),('325','2014-02-21','11:15:00',1.75),('325','2014-02-21','11:20:00',1.57),('325','2014-02-21','11:25:00',1.6),('325','2014-02-21','11:30:00',1.67),('325','2014-02-21','11:35:00',1.72),('325','2014-02-21','11:40:00',1.91),('325','2014-02-21','11:45:00',1.87),('325','2014-02-21','11:50:00',1.65),('325','2014-02-21','11:55:00',1.62),('325','2014-02-21','12:00:00',3.31),('325','2014-02-21','12:05:00',4.41),('325','2014-02-21','12:10:00',4.23),('325','2014-02-21','12:15:00',4.61),('325','2014-02-21','12:20:00',4.02),('325','2014-02-21','12:25:00',2.66),('325','2014-02-21','12:30:00',1.41),('325','2014-02-21','12:35:00',1.24),('325','2014-02-21','14:45:00',1.03),('325','2014-02-21','14:50:00',1.05),('325','2014-02-21','14:55:00',1.14),('325','2014-02-21','15:00:00',1.31),('325','2014-02-21','15:05:00',1.47),('325','2014-02-21','15:10:00',1.02),('325','2014-02-21','15:25:00',1.05),('325','2014-02-21','15:30:00',1.19),('325','2014-02-21','15:35:00',1.91),('325','2014-02-21','15:40:00',2.06),('325','2014-02-21','15:45:00',1.96),('325','2014-02-21','15:50:00',1.81),('325','2014-02-21','15:55:00',1.71),('325','2014-02-21','16:00:00',1.61),('325','2014-02-21','16:05:00',1.52),('325','2014-02-21','16:10:00',1.41),('325','2014-02-21','16:15:00',1.29),('325','2014-02-21','16:20:00',1.19),('325','2014-02-21','16:25:00',1.09),('325','2014-02-20','11:20:00',1.14),('325','2014-02-20','11:25:00',1.22),('325','2014-02-20','11:30:00',1.22),('325','2014-02-20','12:25:00',1.14),('325','2014-02-20','12:30:00',1.05),('325','2014-02-20','12:35:00',1.11),('325','2014-02-20','12:40:00',1.26),('325','2014-02-20','12:45:00',1.14),('325','2014-02-20','12:50:00',1.12),('325','2014-02-20','12:55:00',1.29),('325','2014-02-20','13:00:00',1.5),('325','2014-02-20','13:15:00',1.26),('325','2014-02-20','13:30:00',1.29),('325','2014-02-20','13:35:00',1.07),('325','2014-02-20','14:00:00',1.01),('325','2014-02-19','09:25:00',1.03),('325','2014-02-19','09:30:00',1.06),('325','2014-02-19','09:35:00',1.19),('325','2014-02-19','09:40:00',1.3),('325','2014-02-19','09:45:00',1.52),('325','2014-02-19','09:50:00',1.42),('325','2014-02-19','09:55:00',1.34),('325','2014-02-19','10:00:00',1.3),('325','2014-02-19','10:05:00',1.31),('325','2014-02-19','10:10:00',1.43),('325','2014-02-19','10:15:00',1.49),('325','2014-02-19','10:20:00',1.35),('325','2014-02-19','10:25:00',1.42),('325','2014-02-19','10:30:00',1.51),('325','2014-02-19','10:35:00',1.6),('325','2014-02-19','10:40:00',1.84),('325','2014-02-19','10:45:00',2),('325','2014-02-19','10:50:00',1.87),('325','2014-02-19','10:55:00',1.64),('325','2014-02-19','11:00:00',1.5),('325','2014-02-19','11:05:00',1.54),('325','2014-02-19','11:10:00',1.74),('325','2014-02-19','11:15:00',1.72),('325','2014-02-19','11:20:00',1.88),('325','2014-02-19','11:25:00',1.72),('325','2014-02-19','11:30:00',1.6),('325','2014-02-19','11:35:00',1.64),('325','2014-02-19','11:40:00',1.53),('325','2014-02-19','11:45:00',1.49),('325','2014-02-19','11:50:00',1.51),('325','2014-02-19','11:55:00',1.35),('325','2014-02-19','12:00:00',1.37),('325','2014-02-19','12:05:00',1.44),('325','2014-02-19','12:10:00',1.42),('325','2014-02-19','12:15:00',1.37),('325','2014-02-19','12:20:00',1.19),('325','2014-02-19','12:25:00',1.47),('325','2014-02-19','12:30:00',1.6),('325','2014-02-19','12:35:00',1.23),('325','2014-02-19','12:40:00',1.18),('325','2014-02-19','12:45:00',1.19),('325','2014-02-19','13:05:00',1.01),('325','2014-02-19','13:10:00',1.02),('325','2014-02-19','13:15:00',1.19),('325','2014-02-19','13:20:00',1.15),('325','2014-02-19','13:25:00',1.66),('325','2014-02-19','13:30:00',1.64),('325','2014-02-19','13:35:00',1.79),('325','2014-02-19','13:40:00',1.67),('325','2014-02-19','13:45:00',2.27),('325','2014-02-19','13:50:00',2.33),('325','2014-02-19','13:55:00',2.06),('325','2014-02-19','14:00:00',1.96),('325','2014-02-19','14:05:00',2.01),('325','2014-02-19','14:10:00',1.53),('325','2014-02-19','14:15:00',1.4),('325','2014-02-19','14:20:00',2.29),('325','2014-02-19','14:25:00',1.75),('325','2014-02-19','14:30:00',1.66),('325','2014-02-19','14:35:00',1.82),('325','2014-02-19','14:40:00',1.46),('325','2014-02-19','14:45:00',1.39),('325','2014-02-19','14:50:00',1.77),('325','2014-02-19','14:55:00',1.47),('325','2014-02-19','15:00:00',1.16),('325','2014-02-19','15:05:00',1.17),('325','2014-02-19','15:10:00',1.21),('325','2014-02-19','15:15:00',1.43),('325','2014-02-19','15:20:00',1.11),('325','2014-02-19','15:25:00',1.24),('325','2014-02-19','15:30:00',1.07),('325','2014-02-19','15:40:00',1.01),('325','2014-02-19','15:45:00',1.07),('325','2014-02-19','15:50:00',1.28),('325','2014-02-19','15:55:00',1.04),('325','2014-02-18','08:55:00',1.06),('325','2014-02-18','09:00:00',1.11),('325','2014-02-18','09:05:00',1.16),('325','2014-02-18','09:10:00',1.21),('325','2014-02-18','09:15:00',1.26),('325','2014-02-18','09:20:00',1.3),('325','2014-02-18','09:25:00',1.34),('325','2014-02-18','09:30:00',1.39),('325','2014-02-18','09:35:00',1.43),('325','2014-02-18','09:40:00',1.47),('325','2014-02-18','09:45:00',1.51),('325','2014-02-18','09:50:00',1.55),('325','2014-02-18','09:55:00',1.58),('325','2014-02-18','10:00:00',1.91),('325','2014-02-18','10:05:00',2.83),('325','2014-02-18','10:10:00',2.9),('325','2014-02-18','10:15:00',2.95),('325','2014-02-18','10:20:00',3.02),('325','2014-02-18','10:25:00',3.1),('325','2014-02-18','10:30:00',3.18),('325','2014-02-18','10:35:00',3.22),('325','2014-02-18','10:40:00',3.27),('325','2014-02-18','10:45:00',3.3),('325','2014-02-18','10:50:00',3.36),('325','2014-02-18','10:55:00',3.42),('325','2014-02-18','11:00:00',3.46),('325','2014-02-18','11:05:00',3.01),('325','2014-02-18','11:10:00',2.93),('325','2014-02-18','11:15:00',2.84),('325','2014-02-18','11:20:00',3.18),('325','2014-02-18','11:25:00',3.55),('325','2014-02-18','11:30:00',3.17),('325','2014-02-18','11:35:00',3.06),('325','2014-02-18','11:40:00',2.43),('325','2014-02-18','11:45:00',2.34),('325','2014-02-18','11:50:00',1.94),('325','2014-02-18','11:55:00',1.65),('325','2014-02-18','12:00:00',1.57),('325','2014-02-18','12:05:00',1.57),('325','2014-02-18','12:10:00',1.85),('325','2014-02-18','12:15:00',1.98),('325','2014-02-18','12:20:00',2),('325','2014-02-18','12:25:00',2.31),('325','2014-02-18','12:30:00',2.51),('325','2014-02-18','12:35:00',1.88),('325','2014-02-18','12:40:00',1.69),('325','2014-02-18','12:45:00',1.6),('325','2014-02-18','12:50:00',1.79),('325','2014-02-18','12:55:00',1.93),('325','2014-02-18','13:00:00',1.44),('325','2014-02-18','13:05:00',1.39),('325','2014-02-18','13:10:00',1.51),('325','2014-02-18','13:15:00',2.06),('325','2014-02-18','13:20:00',2.26),('325','2014-02-18','13:25:00',2.81),('325','2014-02-18','13:30:00',1.94),('325','2014-02-18','13:35:00',1.62),('325','2014-02-18','13:40:00',2.14),('325','2014-02-18','13:45:00',2.39),('325','2014-02-18','13:50:00',1.9),('325','2014-02-18','13:55:00',1.88),('325','2014-02-18','14:00:00',2.07),('325','2014-02-18','14:05:00',3.02),('325','2014-02-18','14:10:00',1.75),('325','2014-02-18','14:15:00',1.36),('325','2014-02-18','14:20:00',1.2),('325','2014-02-18','14:25:00',1.24),('325','2014-02-18','14:30:00',1.58),('325','2014-02-18','14:35:00',1.46),('325','2014-02-18','14:40:00',1.21),('325','2014-02-18','14:45:00',1.12),('325','2014-02-18','14:50:00',1.04),('325','2014-02-18','15:35:00',1.18),('325','2014-02-18','15:40:00',1.41),('325','2014-02-18','15:45:00',1.46),('325','2014-02-18','15:50:00',1.17),('325','2014-02-18','15:55:00',1.05),('325','2014-02-18','16:00:00',1.09),('325','2014-02-18','16:05:00',1.24),('325','2014-02-18','16:10:00',1.02),('325','2014-02-17','08:50:00',1.02),('325','2014-02-17','08:55:00',1.08),('325','2014-02-17','09:00:00',1.13),('325','2014-02-17','09:05:00',1.19),('325','2014-02-17','09:10:00',1.25),('325','2014-02-17','09:15:00',1.31),('325','2014-02-17','09:20:00',1.37),('325','2014-02-17','09:25:00',1.43),('325','2014-02-17','09:30:00',1.49),('325','2014-02-17','09:35:00',1.55),('325','2014-02-17','09:40:00',1.58),('325','2014-02-17','09:45:00',1.62),('325','2014-02-17','09:50:00',1.65),('325','2014-02-17','09:55:00',1.69),('325','2014-02-17','10:00:00',1.74),('325','2014-02-17','10:05:00',2.6),('325','2014-02-17','10:10:00',2.69),('325','2014-02-17','10:15:00',2.72),('325','2014-02-17','10:20:00',2.73),('325','2014-02-17','10:25:00',2.79),('325','2014-02-17','10:30:00',2.87),('325','2014-02-17','10:35:00',2.89),('325','2014-02-17','10:40:00',2.91),('325','2014-02-17','10:45:00',2.93),('325','2014-02-17','10:50:00',2.98),('325','2014-02-17','10:55:00',3.02),('325','2014-02-17','11:00:00',3.04),('325','2014-02-17','11:05:00',3.09),('325','2014-02-17','11:10:00',3.15),('325','2014-02-17','11:15:00',3.21),('325','2014-02-17','11:20:00',3.28),('325','2014-02-17','11:25:00',3.38),('325','2014-02-17','11:30:00',3.44),('325','2014-02-17','11:35:00',3.51),('325','2014-02-17','11:40:00',3.52),('325','2014-02-17','11:45:00',3.54),('325','2014-02-17','11:50:00',3.56),('325','2014-02-17','11:55:00',3.57),('325','2014-02-17','12:00:00',3.59),('325','2014-02-17','12:05:00',3.59),('325','2014-02-17','12:10:00',3.59),('325','2014-02-17','12:15:00',3.57),('325','2014-02-17','12:20:00',3.57),('325','2014-02-17','12:25:00',3.58),('325','2014-02-17','12:30:00',3.58),('325','2014-02-17','12:35:00',3.57),('325','2014-02-17','12:40:00',3.54),('325','2014-02-17','12:45:00',3.53),('325','2014-02-17','12:50:00',3.5),('325','2014-02-17','12:55:00',3.49),('325','2014-02-17','13:00:00',3.48),('325','2014-02-17','13:05:00',3.45),('325','2014-02-17','13:10:00',3.45),('325','2014-02-17','13:15:00',3.44),('325','2014-02-17','13:20:00',3.41),('325','2014-02-17','13:25:00',3.4),('325','2014-02-17','13:30:00',3.39),('325','2014-02-17','13:35:00',3.36),('325','2014-02-17','13:40:00',3.33),('325','2014-02-17','13:45:00',3.24),('325','2014-02-17','13:50:00',3.24),('325','2014-02-17','13:55:00',3.18),('325','2014-02-17','14:00:00',3.12),('325','2014-02-17','14:05:00',3.09),('325','2014-02-17','14:10:00',2.98),('325','2014-02-17','14:15:00',2.87),('325','2014-02-17','14:20:00',2.99),('325','2014-02-17','14:25:00',2.86),('325','2014-02-17','14:30:00',2.76),('325','2014-02-17','14:35:00',2.69),('325','2014-02-17','14:40:00',2.51),('325','2014-02-17','14:45:00',2.68),('325','2014-02-17','14:50:00',2.55),('325','2014-02-17','14:55:00',2.49),('325','2014-02-17','15:00:00',2.34),('325','2014-02-17','15:05:00',2.31),('325','2014-02-17','15:10:00',2.25),('325','2014-02-17','15:15:00',2.27),('325','2014-02-17','15:20:00',2.21),('325','2014-02-17','15:25:00',2.06),('325','2014-02-17','15:30:00',2),('325','2014-02-17','15:35:00',1.86),('325','2014-02-17','15:40:00',1.74),('325','2014-02-17','15:45:00',1.73),('325','2014-02-17','15:50:00',1.62),('325','2014-02-17','15:55:00',1.52),('325','2014-02-17','16:00:00',1.39),('325','2014-02-17','16:05:00',1.33),('325','2014-02-17','16:10:00',1.22),('325','2014-02-17','16:15:00',1.1),('325','2014-02-17','16:20:00',1.02),('325','2014-02-16','08:45:00',1.01),('325','2014-02-16','08:55:00',1.12),('325','2014-02-16','09:00:00',1.18),('325','2014-02-16','09:05:00',1.22),('325','2014-02-16','09:10:00',1.2),('325','2014-02-16','09:15:00',1),('325','2014-02-16','09:20:00',1.32),('325','2014-02-16','09:25:00',1.3),('325','2014-02-16','09:30:00',1.33),('325','2014-02-16','09:35:00',1.16),('325','2014-02-16','09:40:00',1.44),('325','2014-02-16','09:45:00',1.52),('325','2014-02-16','09:50:00',1.58),('325','2014-02-16','09:55:00',1.55),('325','2014-02-16','10:00:00',2.14),('325','2014-02-16','10:05:00',2.79),('325','2014-02-16','10:10:00',2.91),('325','2014-02-16','10:15:00',2.92),('325','2014-02-16','10:20:00',3.03),('325','2014-02-16','10:25:00',3.1),('325','2014-02-16','10:30:00',3.2),('325','2014-02-16','10:35:00',3.31),('325','2014-02-16','10:40:00',3.4),('325','2014-02-16','10:45:00',3.35),('325','2014-02-16','10:50:00',2.87),('325','2014-02-16','10:55:00',3.01),('325','2014-02-16','11:00:00',3.45),('325','2014-02-16','11:05:00',3.52),('325','2014-02-16','11:10:00',3.4),('325','2014-02-16','11:15:00',3.51),('325','2014-02-16','11:20:00',3.36),('325','2014-02-16','11:25:00',3.4),('325','2014-02-16','11:30:00',3.44),('325','2014-02-16','11:35:00',3.62),('325','2014-02-16','11:40:00',3.58),('325','2014-02-16','11:45:00',3.28),('325','2014-02-16','11:50:00',3.61),('325','2014-02-16','11:55:00',3.2),('325','2014-02-16','12:00:00',3.72),('325','2014-02-16','12:05:00',3.69),('325','2014-02-16','12:10:00',3.7),('325','2014-02-16','12:15:00',3.69),('325','2014-02-16','12:20:00',3.7),('325','2014-02-16','12:25:00',3.57),('325','2014-02-16','12:30:00',3.65),('325','2014-02-16','12:35:00',3.62),('325','2014-02-16','12:40:00',3.58),('325','2014-02-16','12:45:00',3.57),('325','2014-02-16','12:50:00',3.59),('325','2014-02-16','12:55:00',3.57),('325','2014-02-16','13:00:00',3.57),('325','2014-02-16','13:05:00',3.57),('325','2014-02-16','13:10:00',3.46),('325','2014-02-16','13:15:00',3.57),('325','2014-02-16','13:20:00',3.48),('325','2014-02-16','13:25:00',3.4),('325','2014-02-16','13:30:00',3.36),('325','2014-02-16','13:35:00',3.33),('325','2014-02-16','13:40:00',3.39),('325','2014-02-16','13:45:00',3.42),('325','2014-02-16','13:50:00',3.39),('325','2014-02-16','13:55:00',3.4),('325','2014-02-16','14:00:00',3.38),('325','2014-02-16','14:05:00',3.34),('325','2014-02-16','14:10:00',3.29),('325','2014-02-16','14:15:00',3.23),('325','2014-02-16','14:20:00',3.21),('325','2014-02-16','14:25:00',3.17),('325','2014-02-16','14:30:00',3.11),('325','2014-02-16','14:35:00',3.04),('325','2014-02-16','14:40:00',2.92),('325','2014-02-16','14:45:00',2.88),('325','2014-02-16','14:50:00',2.81),('325','2014-02-16','14:55:00',2.7),('325','2014-02-16','15:00:00',2.62),('325','2014-02-16','15:05:00',2.61),('325','2014-02-16','15:10:00',2.53),('325','2014-02-16','15:15:00',2.44),('325','2014-02-16','15:20:00',2.33),('325','2014-02-16','15:25:00',2.25),('325','2014-02-16','15:30:00',2.13),('325','2014-02-16','15:35:00',1.84),('325','2014-02-16','15:40:00',1.64),('325','2014-02-16','15:45:00',1.9),('325','2014-02-16','15:50:00',1.46),('325','2014-02-16','16:15:00',1.08),('325','2014-02-16','16:20:00',1.25),('325','2014-02-16','16:25:00',1.4),('325','2014-02-16','16:30:00',1.34),('325','2014-02-16','16:35:00',1.09),('325','2014-02-15','09:00:00',1.08),('325','2014-02-15','09:05:00',1.12),('325','2014-02-15','09:10:00',1.17),('325','2014-02-15','09:15:00',1.21),('325','2014-02-15','09:20:00',1.27),('325','2014-02-15','09:25:00',1.32),('325','2014-02-15','09:30:00',1.35),('325','2014-02-15','09:35:00',1.4),('325','2014-02-15','09:40:00',1.44),('325','2014-02-15','09:45:00',1.48),('325','2014-02-15','09:50:00',1.53),('325','2014-02-15','09:55:00',1.57),('325','2014-02-15','10:00:00',2.13),('325','2014-02-15','10:05:00',2.67),('325','2014-02-15','10:10:00',2.8),('325','2014-02-15','10:15:00',2.85),('325','2014-02-15','10:20:00',2.88),('325','2014-02-15','10:25:00',2.94),('325','2014-02-15','10:30:00',2.99),('325','2014-02-15','10:35:00',3.05),('325','2014-02-15','10:40:00',3.07),('325','2014-02-15','10:45:00',3.17),('325','2014-02-15','10:50:00',3.24),('325','2014-02-15','10:55:00',3.26),('325','2014-02-15','11:00:00',3.27),('325','2014-02-15','11:05:00',3.4),('325','2014-02-15','11:10:00',3.4),('325','2014-02-15','11:15:00',1.58),('325','2014-02-15','11:20:00',1.71),('325','2014-02-15','11:25:00',3.84),('325','2014-02-15','11:30:00',3.78),('325','2014-02-15','11:35:00',2.35),('325','2014-02-15','11:40:00',4.01),('325','2014-02-15','11:45:00',3.36),('325','2014-02-15','11:50:00',3.01),('325','2014-02-15','11:55:00',1.95),('325','2014-02-15','12:00:00',2.36),('325','2014-02-15','12:05:00',1.69),('325','2014-02-15','12:10:00',3.84),('325','2014-02-15','12:15:00',3.09),('325','2014-02-15','12:20:00',3.62),('325','2014-02-15','12:25:00',1.23),('325','2014-02-15','12:30:00',2.82),('325','2014-02-15','12:35:00',4.02),('325','2014-02-15','12:40:00',3.07),('325','2014-02-15','12:45:00',4.27),('325','2014-02-15','12:50:00',4.15),('325','2014-02-15','12:55:00',2.31),('325','2014-02-15','13:00:00',3.92),('325','2014-02-15','13:05:00',3.76),('325','2014-02-15','13:10:00',4.08),('325','2014-02-15','13:15:00',3.54),('325','2014-02-15','13:20:00',3.76),('325','2014-02-15','13:25:00',3.47),('325','2014-02-15','13:30:00',3.63),('325','2014-02-15','13:35:00',3.59),('325','2014-02-15','13:40:00',3.51),('325','2014-02-15','13:45:00',3.46),('325','2014-02-15','13:50:00',3.52),('325','2014-02-15','13:55:00',3.39),('325','2014-02-15','14:00:00',3.31),('325','2014-02-15','14:05:00',3.29),('325','2014-02-15','14:10:00',3.2),('325','2014-02-15','14:15:00',3.15),('325','2014-02-15','14:20:00',3.14),('325','2014-02-15','14:25:00',3.03),('325','2014-02-15','14:30:00',2.53),('325','2014-02-15','14:35:00',2.91),('325','2014-02-15','14:40:00',2.83),('325','2014-02-15','14:45:00',2.79),('325','2014-02-15','14:50:00',2.69),('325','2014-02-15','14:55:00',2.66),('325','2014-02-15','15:00:00',2.6),('325','2014-02-15','15:05:00',2.53),('325','2014-02-15','15:10:00',2.45),('325','2014-02-15','15:15:00',2.36),('325','2014-02-15','15:20:00',2.28),('325','2014-02-15','15:25:00',2.2),('325','2014-02-15','15:30:00',2.08),('325','2014-02-15','15:35:00',1.99),('325','2014-02-15','15:40:00',1.9),('325','2014-02-15','15:45:00',1.83),('325','2014-02-15','15:50:00',1.73),('325','2014-02-15','15:55:00',1.65),('325','2014-02-15','16:00:00',1.55),('325','2014-02-15','16:05:00',1.46),('325','2014-02-15','16:10:00',1.33),('325','2014-02-15','16:15:00',1.24),('325','2014-02-15','16:20:00',1.15),('325','2014-02-15','16:25:00',1.05),('325','2014-04-27','10:00:00',1.23),('325','2014-04-27','10:05:00',1.3),('325','2014-04-27','10:10:00',1.19),('325','2014-04-27','10:15:00',1.2),('325','2014-04-27','10:20:00',1.21),('325','2014-04-27','10:25:00',1.09),('325','2014-04-27','11:00:00',1.02),('325','2014-04-27','11:05:00',1.19),('325','2014-04-27','11:10:00',1.14),('325','2014-04-27','11:15:00',1.16),('325','2014-04-27','11:35:00',1.5),('325','2014-04-27','11:40:00',1.83),('325','2014-04-27','11:45:00',4.14),('325','2014-04-27','11:50:00',3.65),('325','2014-04-27','11:55:00',2.97),('325','2014-04-27','12:00:00',2.68),('325','2014-04-27','12:05:00',3),('325','2014-04-27','12:10:00',3.19),('325','2014-04-27','12:15:00',3.46),('325','2014-04-27','12:20:00',3.08),('325','2014-04-27','12:25:00',2.99),('325','2014-04-27','12:30:00',2.6),('325','2014-04-27','12:35:00',2.77),('325','2014-04-27','12:40:00',2.47),('325','2014-04-27','12:45:00',2.88),('325','2014-04-27','12:50:00',2.16),('325','2014-04-27','12:55:00',2.38),('325','2014-04-27','13:00:00',2.74),('325','2014-04-27','13:05:00',2.2),('325','2014-04-27','13:10:00',1.91),('325','2014-04-27','13:15:00',2),('325','2014-04-27','13:20:00',2.44),('325','2014-04-27','13:25:00',2.21),('325','2014-04-27','13:30:00',2.06),('325','2014-04-27','13:35:00',1.77),('325','2014-04-27','13:40:00',1.72),('325','2014-04-27','13:45:00',1.75),('325','2014-04-27','13:50:00',1.74),('325','2014-04-27','13:55:00',1.69),('325','2014-04-27','14:00:00',2.29),('325','2014-04-27','14:05:00',2.34),('325','2014-04-27','14:10:00',1.57),('325','2014-04-27','14:15:00',1.57),('325','2014-04-27','14:20:00',1.96),('325','2014-04-27','14:25:00',2.32),('325','2014-04-27','14:30:00',2.36),('325','2014-04-27','14:35:00',2.42),('325','2014-04-27','14:40:00',2.56),('325','2014-04-27','14:45:00',2.05),('325','2014-04-27','14:50:00',1.96),('325','2014-04-27','14:55:00',2.14),('325','2014-04-27','15:00:00',2.36),('325','2014-04-27','15:05:00',3.62),('325','2014-04-27','15:10:00',4.3),('325','2014-04-27','15:15:00',3.05),('325','2014-04-27','15:20:00',1.92),('325','2014-04-27','15:25:00',1.13),('325','2014-04-27','15:35:00',1.08),('325','2014-04-27','15:40:00',1.12),('325','2014-02-14','08:50:00',1.01),('325','2014-02-14','08:55:00',1.05),('325','2014-02-14','09:00:00',1.09),('325','2014-02-14','09:05:00',1.13),('325','2014-02-14','09:15:00',1.17),('325','2014-02-14','09:20:00',1.36),('325','2014-02-14','09:25:00',1.57),('325','2014-02-14','09:30:00',1.28),('325','2014-02-14','09:35:00',1.15),('325','2014-02-14','09:45:00',1.07),('325','2014-02-14','09:50:00',1.89),('325','2014-02-14','09:55:00',1.75),('325','2014-02-14','10:00:00',1.77),('325','2014-02-14','10:05:00',2.86),('325','2014-02-14','10:10:00',3),('325','2014-02-14','10:15:00',2.18),('325','2014-02-14','10:20:00',3.23),('325','2014-02-14','10:25:00',3.19),('325','2014-02-14','10:30:00',3.24),('325','2014-02-14','10:35:00',3.04),('325','2014-02-14','10:40:00',3.29),('325','2014-02-14','10:45:00',3.48),('325','2014-02-14','10:50:00',3.48),('325','2014-02-14','10:55:00',3.48),('325','2014-02-14','11:00:00',3.53),('325','2014-02-14','11:05:00',3.58),('325','2014-02-14','11:10:00',3.62),('325','2014-02-14','11:15:00',3.65),('325','2014-02-14','11:20:00',3.71),('325','2014-02-14','11:25:00',3.75),('325','2014-02-14','11:30:00',3.8),('325','2014-02-14','11:35:00',3.79),('325','2014-02-14','11:40:00',3.82),('325','2014-02-14','11:45:00',3.83),('325','2014-02-14','11:50:00',3.83),('325','2014-02-14','11:55:00',3.87),('325','2014-02-14','12:00:00',3.43),('325','2014-02-14','12:05:00',3.9),('325','2014-02-14','12:10:00',3.94),('325','2014-02-14','12:15:00',3.87),('325','2014-02-14','12:20:00',3.9),('325','2014-02-14','12:25:00',3.89),('325','2014-02-14','12:30:00',3.88),('325','2014-02-14','12:35:00',3.89),('325','2014-02-14','12:40:00',3.85),('325','2014-02-14','12:45:00',3.83),('325','2014-02-14','12:50:00',3.8),('325','2014-02-14','12:55:00',3.79),('325','2014-02-14','13:00:00',3.8),('325','2014-02-14','13:05:00',3.79),('325','2014-02-14','13:10:00',3.77),('325','2014-02-14','13:15:00',3.76),('325','2014-02-14','13:20:00',3.71),('325','2014-02-14','13:25:00',3.69),('325','2014-02-14','13:30:00',3.63),('325','2014-02-14','13:35:00',3.62),('325','2014-02-14','13:40:00',3.55),('325','2014-02-14','13:45:00',3.52),('325','2014-02-14','13:50:00',3.49),('325','2014-02-14','13:55:00',3.45),('325','2014-02-14','14:00:00',3.41),('325','2014-02-14','14:05:00',3.36),('325','2014-02-14','14:10:00',3.31),('325','2014-02-14','14:15:00',3.22),('325','2014-02-14','14:20:00',3.16),('325','2014-02-14','14:25:00',3.11),('325','2014-02-14','14:30:00',3.06),('325','2014-02-14','14:35:00',3.01),('325','2014-02-14','14:40:00',2.94),('325','2014-02-14','14:45:00',2.84),('325','2014-02-14','14:50:00',2.77),('325','2014-02-14','14:55:00',2.68),('325','2014-02-14','15:00:00',2.59),('325','2014-02-14','15:05:00',2.55),('325','2014-02-14','15:10:00',2.48),('325','2014-02-14','15:15:00',2.4),('325','2014-02-14','15:20:00',2.31),('325','2014-02-14','15:25:00',2.22),('325','2014-02-14','15:30:00',2.09),('325','2014-02-14','15:35:00',2.01),('325','2014-02-14','15:40:00',1.9),('325','2014-02-14','15:45:00',1.8),('325','2014-02-14','15:50:00',1.7),('325','2014-02-14','15:55:00',1.59),('325','2014-02-14','16:00:00',1.53),('325','2014-02-14','16:05:00',1.43),('325','2014-02-14','16:10:00',1.27),('325','2014-02-14','16:15:00',1.19),('325','2014-02-14','16:20:00',1.1),('325','2014-02-13','08:55:00',1.03),('325','2014-02-13','09:00:00',1.08),('325','2014-02-13','09:05:00',1.15),('325','2014-02-13','09:10:00',1.19),('325','2014-02-13','09:15:00',1.22),('325','2014-02-13','09:20:00',1.28),('325','2014-02-13','09:25:00',1.33),('325','2014-02-13','09:30:00',1.38),('325','2014-02-13','09:35:00',1.42),('325','2014-02-13','09:40:00',1.47),('325','2014-02-13','09:45:00',1.51),('325','2014-02-13','09:50:00',1.53),('325','2014-02-13','09:55:00',1.57),('325','2014-02-13','10:00:00',1.91),('325','2014-02-13','10:05:00',2.71),('325','2014-02-13','10:10:00',2.84),('325','2014-02-13','10:15:00',2.87),('325','2014-02-13','10:20:00',2.93),('325','2014-02-13','10:25:00',3.01),('325','2014-02-13','10:30:00',3.09),('325','2014-02-13','10:35:00',3.15),('325','2014-02-13','10:40:00',3.14),('325','2014-02-13','10:45:00',3.2),('325','2014-02-13','10:50:00',3.28),('325','2014-02-13','10:55:00',3.32),('325','2014-02-13','11:00:00',3.33),('325','2014-02-13','11:05:00',3.36),('325','2014-02-13','11:10:00',3.4),('325','2014-02-13','11:15:00',3.55),('325','2014-02-13','11:20:00',3.71),('325','2014-02-13','11:25:00',3.66),('325','2014-02-13','11:30:00',3.72),('325','2014-02-13','11:35:00',3.89),('325','2014-02-13','11:40:00',2.4),('325','2014-02-13','11:45:00',1.81),('325','2014-02-13','11:50:00',3.52),('325','2014-02-13','11:55:00',3.67),('325','2014-02-13','12:00:00',3.43),('325','2014-02-13','12:05:00',2.35),('325','2014-02-13','12:10:00',1.58),('325','2014-02-13','12:15:00',2.92),('325','2014-02-13','12:20:00',1.77),('325','2014-02-13','12:25:00',3.82),('325','2014-02-13','12:30:00',4.14),('325','2014-02-13','12:35:00',4.31),('325','2014-02-13','12:40:00',2.23),('325','2014-02-13','12:45:00',2.09),('325','2014-02-13','12:50:00',3.05),('325','2014-02-13','12:55:00',4.02),('325','2014-02-13','13:00:00',3.94),('325','2014-02-13','13:05:00',3.86),('325','2014-02-13','13:10:00',3.83),('325','2014-02-13','13:15:00',3.78),('325','2014-02-13','13:20:00',3.76),('325','2014-02-13','13:25:00',3.72),('325','2014-02-13','13:30:00',3.69),('325','2014-02-13','13:35:00',3.64),('325','2014-02-13','13:40:00',3.61),('325','2014-02-13','13:45:00',3.57),('325','2014-02-13','13:50:00',3.56),('325','2014-02-13','13:55:00',3.5),('325','2014-02-13','14:00:00',3.45),('325','2014-02-13','14:05:00',3.4),('325','2014-02-13','14:10:00',3.34),('325','2014-02-13','14:15:00',3.28),('325','2014-02-13','14:20:00',3.25),('325','2014-02-13','14:25:00',3.17),('325','2014-02-13','14:30:00',3.11),('325','2014-02-13','14:35:00',3.09),('325','2014-02-13','14:40:00',1.74),('325','2014-02-13','14:45:00',2.65),('325','2014-02-13','14:50:00',2.79),('325','2014-02-13','14:55:00',2.78),('325','2014-02-13','15:00:00',1.9),('325','2014-02-13','15:05:00',2.81),('325','2014-02-13','15:10:00',2.75),('325','2014-02-13','15:15:00',2.37),('325','2014-02-13','15:20:00',2.53),('325','2014-02-13','15:25:00',1.04),('325','2014-02-13','15:35:00',1.26),('325','2014-02-13','15:40:00',2.15),('325','2014-02-13','15:45:00',1.98),('325','2014-02-13','15:50:00',1.58),('325','2014-02-13','16:10:00',1.4),('325','2014-02-12','09:10:00',1.09),('325','2014-02-12','09:15:00',1.26),('325','2014-02-12','09:20:00',1.14),('325','2014-02-12','09:25:00',1.27),('325','2014-02-12','09:40:00',1.6),('325','2014-02-12','09:45:00',1.79),('325','2014-02-12','09:50:00',2.03),('325','2014-02-12','09:55:00',1.03),('325','2014-02-12','10:00:00',1.18),('325','2014-02-12','10:05:00',1.6),('325','2014-02-12','10:10:00',1.4),('325','2014-02-12','10:15:00',1.16),('325','2014-02-12','10:20:00',1.13),('325','2014-02-12','10:25:00',1.22),('325','2014-02-12','10:30:00',1.52),('325','2014-02-12','10:35:00',1.54),('325','2014-02-12','10:40:00',1.58),('325','2014-02-12','10:45:00',1.88),('325','2014-02-12','10:50:00',1.47),('325','2014-02-12','10:55:00',1.49),('325','2014-02-12','11:00:00',1.6),('325','2014-02-12','11:05:00',2.25),('325','2014-02-12','11:10:00',1.65),('325','2014-02-12','11:15:00',1.54),('325','2014-02-12','11:20:00',1.55),('325','2014-02-12','11:25:00',1.71),('325','2014-02-12','11:30:00',1.93),('325','2014-02-12','11:35:00',2.51),('325','2014-02-12','11:40:00',1.27),('325','2014-02-12','12:05:00',1.06),('325','2014-02-12','12:10:00',1.3),('325','2014-02-12','12:15:00',1.41),('325','2014-02-12','12:20:00',1.4),('325','2014-02-12','12:25:00',1.43),('325','2014-02-12','12:30:00',1.46),('325','2014-02-12','12:35:00',1.4),('325','2014-02-12','12:40:00',1.39),('325','2014-02-12','12:45:00',1.57),('325','2014-02-12','12:50:00',1.73),('325','2014-02-12','12:55:00',1.88),('325','2014-02-12','13:00:00',2.35),('325','2014-02-12','13:05:00',2.35),('325','2014-02-12','13:10:00',2.3),('325','2014-02-12','13:15:00',1.48),('325','2014-02-12','13:20:00',1.47),('325','2014-02-12','13:25:00',2.12),('325','2014-02-12','13:30:00',3.06),('325','2014-02-12','13:35:00',3.41),('325','2014-02-12','13:40:00',4.01),('325','2014-02-12','13:45:00',2.74),('325','2014-02-12','13:50:00',2.37),('325','2014-02-12','13:55:00',3.34),('325','2014-02-12','14:00:00',4.11),('325','2014-02-12','14:05:00',3.74),('325','2014-02-12','14:10:00',3.51),('325','2014-02-12','14:15:00',3.53),('325','2014-02-12','14:20:00',2.58),('325','2014-02-12','14:25:00',1.83),('325','2014-02-12','14:30:00',2.19),('325','2014-02-12','14:35:00',2.74),('325','2014-02-12','14:40:00',1.96),('325','2014-02-12','14:45:00',3.37),('325','2014-02-12','14:50:00',3.13),('325','2014-02-12','14:55:00',2.76),('325','2014-02-12','15:00:00',1.99),('325','2014-02-12','15:10:00',1.69),('325','2014-02-12','15:15:00',2.08),('325','2014-02-12','15:20:00',2.37),('325','2014-02-12','15:25:00',1.62),('325','2014-02-12','15:30:00',2.4),('325','2014-02-12','15:35:00',1.95),('325','2014-02-12','15:40:00',2.03),('325','2014-02-12','15:45:00',1.3),('325','2014-02-12','15:50:00',2.06),('325','2014-02-12','16:00:00',1.26),('325','2014-02-11','09:20:00',1.08),('325','2014-02-11','09:25:00',1.19),('325','2014-02-11','09:30:00',1.2),('325','2014-02-11','09:35:00',1.24),('325','2014-02-11','09:40:00',1.19),('325','2014-02-11','09:45:00',1.21),('325','2014-02-11','09:50:00',1.26),('325','2014-02-11','09:55:00',1.23),('325','2014-02-11','10:00:00',1.12),('325','2014-02-11','10:10:00',1.35),('325','2014-02-11','10:15:00',1.55),('325','2014-02-11','10:20:00',1.83),('325','2014-02-11','10:25:00',1.9),('325','2014-02-11','10:30:00',2.25),('325','2014-02-11','10:35:00',2.62),('325','2014-02-11','10:40:00',2.42),('325','2014-02-11','10:45:00',2.38),('325','2014-02-11','10:50:00',2.52),('325','2014-02-11','10:55:00',2.26),('325','2014-02-11','11:00:00',2.36),('325','2014-02-11','11:05:00',2.14),('325','2014-02-11','11:10:00',2.37),('325','2014-02-11','11:15:00',2.26),('325','2014-02-11','11:20:00',1.51),('325','2014-02-11','11:25:00',1.84),('325','2014-02-11','11:30:00',2.2),('325','2014-02-11','11:35:00',2.15),('325','2014-02-11','11:40:00',1.9),('325','2014-02-11','11:45:00',2.4),('325','2014-02-11','11:50:00',1.39),('325','2014-02-11','11:55:00',1.27),('325','2014-02-11','12:00:00',1.38),('325','2014-02-11','12:05:00',1.83),('325','2014-02-11','12:10:00',1.83),('325','2014-02-11','12:15:00',1.78),('325','2014-02-11','12:20:00',1.86),('325','2014-02-11','12:25:00',2.53),('325','2014-02-11','12:30:00',2.43),('325','2014-02-11','12:35:00',2.18),('325','2014-02-11','12:40:00',1.54),('325','2014-02-11','12:45:00',1.85),('325','2014-02-11','12:50:00',1.42),('325','2014-02-11','12:55:00',1.85),('325','2014-02-11','13:00:00',1.88),('325','2014-02-11','13:05:00',2.47),('325','2014-02-11','13:10:00',3.16),('325','2014-02-11','13:15:00',3.06),('325','2014-02-11','13:20:00',3.53),('325','2014-02-11','13:25:00',3.14),('325','2014-02-11','13:30:00',2.88),('325','2014-02-11','13:35:00',2.69),('325','2014-02-11','13:40:00',3.16),('325','2014-02-11','13:45:00',2.39),('325','2014-02-11','13:50:00',1.83),('325','2014-02-11','13:55:00',1.43),('325','2014-02-11','14:00:00',2.02),('325','2014-02-11','14:05:00',2.49),('325','2014-02-11','14:10:00',1.64),('325','2014-02-11','14:15:00',2.36),('325','2014-02-11','14:20:00',1.72),('325','2014-02-11','14:25:00',1.55),('325','2014-02-11','14:30:00',1.53),('325','2014-02-11','14:35:00',1.44),('325','2014-02-11','14:40:00',1.14),('325','2014-02-11','14:45:00',1.19),('325','2014-02-11','15:10:00',1.03),('325','2014-02-11','15:15:00',1.51),('325','2014-02-11','15:20:00',1.5),('325','2014-02-11','15:25:00',1.22),('325','2014-02-11','16:05:00',1.03),('325','2014-02-11','16:10:00',1.05),('325','2014-02-10','12:55:00',1.02),('325','2014-02-10','13:00:00',1.3),('325','2014-02-10','13:05:00',1.04),('325','2014-02-10','13:55:00',1),('325','2014-02-10','14:00:00',1.01),('325','2014-02-10','14:30:00',1.05),('325','2014-02-10','14:35:00',1.12),('325','2014-02-10','14:40:00',1.16),('325','2014-02-10','14:45:00',1.02),('325','2014-02-09','11:25:00',1.02),('325','2014-02-09','11:30:00',1.13),('325','2014-02-09','11:35:00',1.46),('325','2014-02-09','12:25:00',1.39),('325','2014-02-09','12:30:00',1.5),('325','2014-02-09','12:45:00',2.11),('325','2014-02-09','12:55:00',2.52),('325','2014-02-09','13:00:00',2.26),('325','2014-02-09','13:05:00',3.78),('325','2014-02-09','13:10:00',2),('325','2014-02-09','13:15:00',1.5),('325','2014-02-09','13:25:00',1.06),('325','2014-02-09','13:40:00',1.92),('325','2014-02-09','13:45:00',3.61),('325','2014-02-09','13:50:00',1.68),('325','2014-02-09','13:55:00',2.44),('325','2014-02-09','14:00:00',2.01),('325','2014-02-09','14:05:00',2.55),('325','2014-02-09','14:10:00',1.98),('325','2014-02-09','14:15:00',1.39),('325','2014-02-09','14:20:00',1.16),('325','2014-02-09','14:25:00',1.93),('325','2014-02-09','14:30:00',2.15),('325','2014-02-09','14:35:00',1.98),('325','2014-02-09','14:40:00',1.28),('325','2014-02-09','14:50:00',2.11),('325','2014-02-09','14:55:00',1.05),('325','2014-02-09','15:10:00',1.15),('325','2014-02-09','15:15:00',1.7),('325','2014-02-09','15:20:00',1.94),('325','2014-02-09','15:25:00',1.87),('325','2014-02-09','15:30:00',1.06),('325','2014-02-09','15:35:00',1.36),('325','2014-02-09','15:40:00',1.27),('325','2014-02-09','15:45:00',1.49),('325','2014-02-09','15:50:00',1.49),('325','2014-02-09','15:55:00',1.31),('325','2014-02-09','16:05:00',1.13),('325','2014-02-09','16:10:00',1),('325','2014-02-08','09:45:00',1.06),('325','2014-02-08','09:50:00',1.98),('325','2014-02-08','10:15:00',1.71),('325','2014-02-08','10:20:00',1.11),('325','2014-02-08','10:25:00',1.18),('325','2014-02-08','10:30:00',2.53),('325','2014-02-08','10:35:00',2.46),('325','2014-02-08','10:40:00',1.11),('325','2014-02-08','10:45:00',1.81),('325','2014-02-08','10:50:00',2.52),('325','2014-02-08','10:55:00',2.06),('325','2014-02-08','11:00:00',2.42),('325','2014-02-08','11:05:00',3.68),('325','2014-02-08','11:10:00',2.08),('325','2014-02-08','11:15:00',2.84),('325','2014-02-08','11:30:00',2.74),('325','2014-02-08','11:35:00',3.73),('325','2014-02-08','11:40:00',1.47),('325','2014-02-08','11:50:00',2.68),('325','2014-02-08','11:55:00',3.58),('325','2014-02-08','12:05:00',1.88),('325','2014-02-08','12:10:00',3.27),('325','2014-02-08','12:15:00',2.76),('325','2014-02-08','12:25:00',4.03),('325','2014-02-08','12:30:00',3.28),('325','2014-02-08','12:35:00',3.01),('325','2014-02-08','12:40:00',1.94),('325','2014-02-08','12:45:00',3.93),('325','2014-02-08','12:50:00',3.33),('325','2014-02-08','12:55:00',3.23),('325','2014-02-08','13:00:00',2.31),('325','2014-02-08','13:10:00',3.19),('325','2014-02-08','13:15:00',4.58),('325','2014-02-08','13:20:00',3.87),('325','2014-02-08','13:25:00',2.84),('325','2014-02-08','13:30:00',2.16),('325','2014-02-08','13:35:00',3.01),('325','2014-02-08','13:40:00',3.28),('325','2014-02-08','13:45:00',3.77),('325','2014-02-08','13:50:00',3.39),('325','2014-02-08','13:55:00',3.5),('325','2014-02-08','14:00:00',3.48),('325','2014-02-08','14:05:00',3.46),('325','2014-02-08','14:10:00',3.19),('325','2014-02-08','14:15:00',2.29),('325','2014-02-08','14:20:00',2.36),('325','2014-02-08','14:25:00',2.61),('325','2014-02-08','14:30:00',2.45),('325','2014-02-08','14:35:00',1.57),('325','2014-02-08','14:40:00',1.64),('325','2014-02-08','14:45:00',1.17),('325','2014-02-08','14:50:00',2.95),('325','2014-02-08','14:55:00',2.67),('325','2014-02-08','15:00:00',1.22),('325','2014-02-08','15:15:00',1.27),('325','2014-02-08','15:20:00',2.2),('325','2014-02-08','15:40:00',1.77),('325','2014-02-08','15:45:00',1.99),('325','2014-02-08','15:50:00',1.36),('325','2014-02-08','16:00:00',1.24),('325','2014-02-07','09:05:00',1.04),('325','2014-02-07','09:10:00',1.09),('325','2014-02-07','09:15:00',1.14),('325','2014-02-07','09:20:00',1.18),('325','2014-02-07','09:25:00',1.23),('325','2014-02-07','09:30:00',1.27),('325','2014-02-07','09:35:00',1.31),('325','2014-02-07','09:40:00',1.34),('325','2014-02-07','09:45:00',1.38),('325','2014-02-07','09:50:00',1.42),('325','2014-02-07','09:55:00',1.46),('325','2014-02-07','10:00:00',1.52),('325','2014-02-07','10:05:00',1.62),('325','2014-02-07','10:10:00',2.64),('325','2014-02-07','10:15:00',2.88),('325','2014-02-07','10:20:00',2.93),('325','2014-02-07','10:25:00',2.36),('325','2014-02-07','10:30:00',2.49),('325','2014-02-07','10:35:00',3.24),('325','2014-02-07','10:40:00',1.92),('325','2014-02-07','10:45:00',3.15),('325','2014-02-07','10:50:00',3.09),('325','2014-02-07','10:55:00',2.7),('325','2014-02-07','11:00:00',3.73),('325','2014-02-07','11:05:00',2.84),('325','2014-02-07','11:10:00',3.87),('325','2014-02-07','11:15:00',3.91),('325','2014-02-07','11:20:00',3.67),('325','2014-02-07','11:25:00',1.59),('325','2014-02-07','11:30:00',3.8),('325','2014-02-07','11:35:00',3.79),('325','2014-02-07','11:40:00',3.81),('325','2014-02-07','11:45:00',3.27),('325','2014-02-07','11:50:00',3.63),('325','2014-02-07','11:55:00',3.56),('325','2014-02-07','12:00:00',2.5),('325','2014-02-07','12:05:00',2.79),('325','2014-02-07','12:10:00',2.17),('325','2014-02-07','12:15:00',3.95),('325','2014-02-07','12:20:00',2.86),('325','2014-02-07','12:25:00',1.25),('325','2014-02-07','12:30:00',1.58),('325','2014-02-07','12:40:00',1.85),('325','2014-02-07','12:45:00',2.63),('325','2014-02-07','12:50:00',4.37),('325','2014-02-07','12:55:00',3.79),('325','2014-02-07','13:00:00',1.22),('325','2014-02-07','13:05:00',3.46),('325','2014-02-07','13:10:00',3.31),('325','2014-02-07','13:15:00',1.12),('325','2014-02-07','13:20:00',2.13),('325','2014-02-07','13:25:00',1.01),('325','2014-02-07','13:30:00',1.42),('325','2014-02-07','13:35:00',2.57),('325','2014-02-07','13:40:00',1.4),('325','2014-02-07','13:45:00',3.58),('325','2014-02-07','13:50:00',3.85),('325','2014-02-07','13:55:00',3.73),('325','2014-02-07','14:00:00',3.49),('325','2014-02-07','14:05:00',3.46),('325','2014-02-07','14:10:00',3.39),('325','2014-02-07','14:15:00',3.33),('325','2014-02-07','14:20:00',2.6),('325','2014-02-07','14:25:00',1.42),('325','2014-02-07','14:30:00',1.9),('325','2014-02-07','14:35:00',3.33),('325','2014-02-07','14:40:00',3.05),('325','2014-02-07','14:45:00',2.74),('325','2014-02-07','14:50:00',2.84),('325','2014-02-07','14:55:00',2.72),('325','2014-02-07','15:00:00',2.59),('325','2014-02-07','15:05:00',2.5),('325','2014-02-07','15:10:00',2.39),('325','2014-02-07','15:15:00',2.28),('325','2014-02-07','15:20:00',2.26),('325','2014-02-07','15:25:00',2.02),('325','2014-02-07','15:30:00',1.64),('325','2014-02-07','15:35:00',1.94),('325','2014-02-07','15:40:00',1.84),('325','2014-02-07','15:45:00',1.73),('325','2014-02-07','15:50:00',1.63),('325','2014-02-07','15:55:00',1.53),('325','2014-02-07','16:00:00',1.42),('325','2014-02-07','16:05:00',1.3),('325','2014-02-07','16:10:00',1.21),('325','2014-02-07','16:15:00',1.12),('325','2014-02-07','16:20:00',1.01),('325','2014-02-06','08:55:00',1.15),('325','2014-02-06','09:00:00',1.42),('325','2014-02-06','09:05:00',1.59),('325','2014-02-06','09:10:00',1.48),('325','2014-02-06','09:15:00',1.36),('325','2014-02-06','09:30:00',1.1),('325','2014-02-06','09:35:00',1.4),('325','2014-02-06','09:40:00',1.37),('325','2014-02-06','09:45:00',1.44),('325','2014-02-06','09:50:00',1.47),('325','2014-02-06','09:55:00',1.51),('325','2014-02-06','10:00:00',1.54),('325','2014-02-06','10:05:00',1.59),('325','2014-02-06','10:10:00',2.66),('325','2014-02-06','10:15:00',2.83),('325','2014-02-06','10:20:00',2.88),('325','2014-02-06','10:25:00',2.82),('325','2014-02-06','10:30:00',3.04),('325','2014-02-06','10:35:00',2.62),('325','2014-02-06','10:40:00',2.8),('325','2014-02-06','10:45:00',2.52),('325','2014-02-06','10:50:00',2.43),('325','2014-02-06','10:55:00',3.06),('325','2014-02-06','11:00:00',2.48),('325','2014-02-06','11:05:00',2.24),('325','2014-02-06','11:10:00',1.73),('325','2014-02-06','11:15:00',1.76),('325','2014-02-06','11:20:00',3.86),('325','2014-02-06','11:25:00',2.17),('325','2014-02-06','11:30:00',3.91),('325','2014-02-06','11:35:00',3.73),('325','2014-02-06','11:40:00',3.69),('325','2014-02-06','11:45:00',3.71),('325','2014-02-06','11:50:00',3.74),('325','2014-02-06','11:55:00',3.76),('325','2014-02-06','12:00:00',3.77),('325','2014-02-06','12:05:00',3.84),('325','2014-02-06','12:10:00',3.81),('325','2014-02-06','12:15:00',3.8),('325','2014-02-06','12:20:00',3.8),('325','2014-02-06','12:25:00',3.76),('325','2014-02-06','12:30:00',3.76),('325','2014-02-06','12:35:00',3.38),('325','2014-02-06','12:40:00',3.83),('325','2014-02-06','12:45:00',3.78),('325','2014-02-06','12:50:00',3.73),('325','2014-02-06','12:55:00',3.72),('325','2014-02-06','13:00:00',3.72),('325','2014-02-06','13:05:00',3.06),('325','2014-02-06','13:10:00',3.79),('325','2014-02-06','13:15:00',3.71),('325','2014-02-06','13:20:00',3.69),('325','2014-02-06','13:25:00',1.87),('325','2014-02-06','13:30:00',3.42),('325','2014-02-06','13:35:00',3.58),('325','2014-02-06','13:40:00',3.55),('325','2014-02-06','13:45:00',3.47),('325','2014-02-06','13:50:00',3.48),('325','2014-02-06','13:55:00',3.43),('325','2014-02-06','14:00:00',3.3),('325','2014-02-06','14:05:00',3.03),('325','2014-02-06','14:10:00',2.67),('325','2014-02-06','14:15:00',3.12),('325','2014-02-06','14:20:00',3.1),('325','2014-02-06','14:25:00',3.11),('325','2014-02-06','14:30:00',3.05),('325','2014-02-06','14:35:00',2.96),('325','2014-02-06','14:40:00',2.58),('325','2014-02-06','14:45:00',2.97),('325','2014-02-06','14:50:00',2.8),('325','2014-02-06','14:55:00',2.64),('325','2014-02-06','15:00:00',2.58),('325','2014-02-06','15:05:00',2.49),('325','2014-02-06','15:10:00',2.39),('325','2014-02-06','15:15:00',2.29),('325','2014-02-06','15:20:00',2.24),('325','2014-02-06','15:25:00',2.04),('325','2014-02-06','15:30:00',1.93),('325','2014-02-06','15:35:00',1.86),('325','2014-02-06','15:40:00',1.76),('325','2014-02-06','15:45:00',1.67),('325','2014-02-06','15:50:00',1.57),('325','2014-02-06','15:55:00',1.46),('325','2014-02-06','16:00:00',1.36),('325','2014-02-06','16:05:00',1.25),('325','2014-02-06','16:10:00',1.16),('325','2014-02-06','16:15:00',1.06),('325','2014-02-05','10:10:00',1.01),('325','2014-02-05','10:15:00',1.88),('325','2014-02-05','10:20:00',2.6),('325','2014-02-05','10:25:00',3.17),('325','2014-02-05','10:35:00',1.12),('325','2014-02-05','10:40:00',2.15),('325','2014-02-05','10:45:00',1.44),('325','2014-02-05','10:55:00',1.13),('325','2014-02-05','11:15:00',2.73),('325','2014-02-05','11:20:00',4.3),('325','2014-02-05','11:25:00',2.84),('325','2014-02-05','11:30:00',1.31),('325','2014-02-05','12:55:00',1.39),('325','2014-02-05','13:00:00',1.11),('325','2014-02-05','13:05:00',1.36),('325','2014-02-05','13:10:00',1.86),('325','2014-02-05','13:15:00',1.5),('325','2014-02-05','13:20:00',1.8),('325','2014-02-05','13:25:00',1.91),('325','2014-02-05','13:30:00',1.84),('325','2014-02-05','13:35:00',2.17),('325','2014-02-05','13:40:00',2.26),('325','2014-02-05','13:45:00',2.04),('325','2014-02-05','13:50:00',1.8),('325','2014-02-05','13:55:00',1.21),('325','2014-02-05','14:25:00',1.21),('325','2014-02-05','14:30:00',3.36),('325','2014-02-05','14:35:00',1.85),('325','2014-04-26','09:05:00',1.01),('325','2014-04-26','09:55:00',1.32),('325','2014-04-26','10:00:00',1.44),('325','2014-04-26','10:05:00',1.34),('325','2014-04-26','10:10:00',1.29),('325','2014-04-26','10:15:00',1.34),('325','2014-04-26','10:20:00',1.59),('325','2014-04-26','10:25:00',1.7),('325','2014-04-26','10:30:00',1.92),('325','2014-04-26','10:35:00',2.35),('325','2014-04-26','10:40:00',2.09),('325','2014-04-26','10:45:00',2.21),('325','2014-04-26','10:50:00',2.41),('325','2014-04-26','10:55:00',4.09),('325','2014-04-26','11:00:00',3.95),('325','2014-04-26','11:05:00',3.8),('325','2014-04-26','11:10:00',3.54),('325','2014-04-26','11:15:00',3.12),('325','2014-04-26','11:20:00',3.43),('325','2014-04-26','11:25:00',3.29),('325','2014-04-26','11:30:00',3.41),('325','2014-04-26','11:35:00',3.33),('325','2014-04-26','11:40:00',3.17),('325','2014-04-26','11:45:00',3.39),('325','2014-04-26','11:50:00',3.44),('325','2014-04-26','11:55:00',3.24),('325','2014-04-26','12:00:00',3.28),('325','2014-04-26','12:05:00',3.55),('325','2014-04-26','12:10:00',3.25),('325','2014-04-26','12:15:00',2.17),('325','2014-04-26','12:20:00',2.96),('325','2014-04-26','12:25:00',2.94),('325','2014-04-26','12:30:00',2.56),('325','2014-04-26','12:35:00',3.86),('325','2014-04-26','12:40:00',3.83),('325','2014-04-26','12:45:00',3.18),('325','2014-04-26','12:50:00',3.85),('325','2014-04-26','12:55:00',4.72),('325','2014-04-26','13:00:00',4.71),('325','2014-04-26','13:05:00',3.31),('325','2014-04-26','13:10:00',3.64),('325','2014-04-26','13:15:00',4.66),('325','2014-04-26','13:20:00',4.86),('325','2014-04-26','13:25:00',3.47),('325','2014-04-26','13:30:00',1.72),('325','2014-04-26','13:35:00',2.34),('325','2014-04-26','13:40:00',4.95),('325','2014-04-26','13:45:00',4.76),('325','2014-04-26','13:50:00',4.59),('325','2014-04-26','13:55:00',4.69),('325','2014-04-26','14:00:00',3.38),('325','2014-04-26','14:10:00',1.09),('325','2014-04-26','14:15:00',1.14),('325','2014-04-26','14:35:00',1.54),('325','2014-04-26','14:40:00',2.17),('325','2014-02-04','09:15:00',1.03),('325','2014-02-04','09:20:00',1.14),('325','2014-02-04','09:25:00',1.28),('325','2014-02-04','09:30:00',1.44),('325','2014-02-04','09:35:00',1.2),('325','2014-02-04','09:40:00',1.64),('325','2014-02-04','09:45:00',1.5),('325','2014-02-04','09:50:00',1.54),('325','2014-02-04','09:55:00',1.08),('325','2014-02-04','10:00:00',1.55),('325','2014-02-04','10:05:00',1.85),('325','2014-02-04','10:10:00',2.33),('325','2014-02-04','10:15:00',1.75),('325','2014-02-04','10:20:00',1.38),('325','2014-02-04','10:35:00',1.02),('325','2014-02-04','10:40:00',1.28),('325','2014-02-04','10:45:00',1.53),('325','2014-02-04','10:50:00',2.43),('325','2014-02-04','10:55:00',2.85),('325','2014-02-04','11:00:00',3.79),('325','2014-02-04','11:05:00',2.06),('325','2014-02-04','11:10:00',1.33),('325','2014-02-04','11:15:00',1.16),('325','2014-02-04','11:20:00',1.46),('325','2014-02-04','11:25:00',1.2),('325','2014-02-04','11:30:00',1.25),('325','2014-02-04','11:35:00',1.09),('325','2014-02-04','11:50:00',1.86),('325','2014-02-04','11:55:00',3.09),('325','2014-02-04','12:00:00',3.11),('325','2014-02-04','12:05:00',2.11),('325','2014-02-04','12:10:00',2.36),('325','2014-02-04','12:15:00',1.64),('325','2014-02-04','12:20:00',1.7),('325','2014-02-04','12:25:00',1.31),('325','2014-02-04','12:45:00',1.21),('325','2014-02-04','12:50:00',1.12),('325','2014-02-04','12:55:00',1.12),('325','2014-02-04','13:00:00',1.3),('325','2014-02-04','13:05:00',1.29),('325','2014-02-04','13:10:00',1.24),('325','2014-02-04','13:15:00',1.41),('325','2014-02-04','13:20:00',2.78),('325','2014-02-04','13:25:00',1.91),('325','2014-02-04','13:30:00',1.29),('325','2014-02-04','13:35:00',1.11),('325','2014-02-04','13:40:00',1.04),('325','2014-02-03','09:50:00',1.02),('325','2014-02-03','10:15:00',1.11),('325','2014-02-03','10:20:00',1.03),('325','2014-02-03','10:25:00',1.06),('325','2014-02-03','10:30:00',1.07),('325','2014-02-03','10:35:00',1.08),('325','2014-02-03','10:40:00',1.15),('325','2014-02-03','10:45:00',1.19),('325','2014-02-03','10:50:00',1.16),('325','2014-02-03','10:55:00',1.13),('325','2014-02-03','11:00:00',1.04),('325','2014-02-03','11:10:00',1.01),('325','2014-02-03','11:20:00',1.05),('325','2014-02-03','11:25:00',1.19),('325','2014-02-03','11:30:00',1.32),('325','2014-02-03','11:35:00',1.37),('325','2014-02-03','11:40:00',1.39),('325','2014-02-03','11:45:00',1.43),('325','2014-02-03','11:50:00',1.38),('325','2014-02-03','11:55:00',1.27),('325','2014-02-03','12:00:00',1.13),('325','2014-02-03','12:05:00',1.05),('325','2014-02-03','12:10:00',1.03),('325','2014-02-03','12:15:00',1.11),('325','2014-02-03','12:20:00',1.12),('325','2014-02-03','12:25:00',1.03),('325','2014-02-02','12:00:00',1.02),('325','2014-02-02','12:05:00',1.03),('325','2014-02-01','11:00:00',1.23),('325','2014-02-01','11:05:00',1.05),('325','2014-02-01','11:15:00',1.01),('325','2014-02-01','11:20:00',1.82),('325','2014-02-01','11:25:00',1.37),('325','2014-02-01','11:30:00',1.48),('325','2014-02-01','11:35:00',1.82),('325','2014-02-01','11:55:00',1.63),('325','2014-02-01','12:00:00',1.37),('325','2014-02-01','12:05:00',1.28),('325','2014-02-01','12:10:00',2.32),('325','2014-02-01','12:15:00',1.67),('325','2014-02-01','12:20:00',2.74),('325','2014-02-01','12:25:00',2.16),('325','2014-02-01','12:35:00',1.17),('325','2014-02-01','12:40:00',1.48),('325','2014-02-01','12:45:00',2.36),('325','2014-02-01','12:50:00',2.53),('325','2014-02-01','12:55:00',2.12),('325','2014-02-01','13:00:00',2.01),('325','2014-02-01','13:05:00',1.41),('325','2014-01-30','09:50:00',1.23),('325','2014-01-30','09:55:00',1.65),('325','2014-01-30','10:00:00',1.47),('325','2014-01-30','10:05:00',1.24),('325','2014-01-30','10:10:00',1.69),('325','2014-01-30','10:15:00',2.52),('325','2014-01-30','10:20:00',2.15),('325','2014-01-30','10:25:00',2.57),('325','2014-01-30','10:30:00',2.81),('325','2014-01-30','10:35:00',2.88),('325','2014-01-30','10:40:00',2.95),('325','2014-01-30','10:45:00',2.59),('325','2014-01-30','10:50:00',3.16),('325','2014-01-30','10:55:00',3.64),('325','2014-01-30','11:00:00',3.7),('325','2014-01-30','11:05:00',3.33),('325','2014-01-30','11:10:00',2.88),('325','2014-01-30','11:15:00',3.06),('325','2014-01-30','11:20:00',2.03),('325','2014-01-30','11:25:00',3.15),('325','2014-01-30','11:30:00',2.62),('325','2014-01-30','11:35:00',3.08),('325','2014-01-30','11:40:00',2.6),('325','2014-01-30','11:45:00',3.37),('325','2014-01-30','11:50:00',3.45),('325','2014-01-30','11:55:00',3.43),('325','2014-01-30','12:00:00',2.92),('325','2014-01-30','12:05:00',3.65),('325','2014-01-30','12:10:00',3.81),('325','2014-01-30','12:15:00',3.44),('325','2014-01-30','12:20:00',3.79),('325','2014-01-30','12:25:00',3.11),('325','2014-01-30','12:30:00',2.93),('325','2014-01-30','12:35:00',3.04),('325','2014-01-30','12:40:00',2.94),('325','2014-01-30','12:45:00',3.51),('325','2014-01-30','12:50:00',3.5),('325','2014-01-30','12:55:00',3.41),('325','2014-01-30','13:00:00',3.58),('325','2014-01-30','13:05:00',3.75),('325','2014-01-30','13:10:00',3.22),('325','2014-01-30','13:15:00',3.51),('325','2014-01-30','13:20:00',3.08),('325','2014-01-30','13:25:00',3.27),('325','2014-01-30','13:30:00',2.66),('325','2014-01-30','13:35:00',2.39),('325','2014-01-30','13:40:00',3.03),('325','2014-01-30','13:45:00',3.4),('325','2014-01-30','13:50:00',3.13),('325','2014-01-30','13:55:00',2.77),('325','2014-01-30','14:00:00',2.75),('325','2014-01-30','14:05:00',2.55),('325','2014-01-30','14:10:00',2.56),('325','2014-01-30','14:15:00',2.26),('325','2014-01-30','14:20:00',2.02),('325','2014-01-30','14:25:00',2.17),('325','2014-01-30','14:30:00',2.26),('325','2014-01-30','14:35:00',2.13),('325','2014-01-30','14:40:00',2.47),('325','2014-01-30','14:45:00',2.34),('325','2014-01-30','14:50:00',2.48),('325','2014-01-30','14:55:00',2.37),('325','2014-01-30','15:00:00',2.27),('325','2014-01-30','15:05:00',2.21),('325','2014-01-30','15:10:00',2.11),('325','2014-01-30','15:15:00',2.03),('325','2014-01-30','15:20:00',2.04),('325','2014-01-30','15:25:00',1.97),('325','2014-01-30','15:30:00',1.78),('325','2014-01-30','15:35:00',1.75),('325','2014-01-30','15:40:00',1.54),('325','2014-01-29','09:20:00',1.19),('325','2014-01-29','09:30:00',1.27),('325','2014-01-29','09:35:00',1.77),('325','2014-01-29','09:40:00',1.54),('325','2014-01-29','09:45:00',1.71),('325','2014-01-29','09:50:00',1.59),('325','2014-01-29','09:55:00',1.62),('325','2014-01-29','10:00:00',1.28),('325','2014-01-29','10:05:00',1.31),('325','2014-01-29','10:10:00',1.76),('325','2014-01-29','10:15:00',1.76),('325','2014-01-29','10:20:00',1.33),('325','2014-01-29','10:25:00',2.81),('325','2014-01-29','10:30:00',3.4),('325','2014-01-29','10:35:00',2.62),('325','2014-01-29','10:40:00',2.43),('325','2014-01-29','10:45:00',2.19),('325','2014-01-29','10:50:00',2.26),('325','2014-01-29','10:55:00',1.95),('325','2014-01-29','11:00:00',2.07),('325','2014-01-29','11:05:00',2.35),('325','2014-01-29','11:10:00',1.95),('325','2014-01-29','11:15:00',2.01),('325','2014-01-29','11:20:00',2.2),('325','2014-01-29','11:25:00',2.36),('325','2014-01-29','11:30:00',3.21),('325','2014-01-29','11:35:00',2.32),('325','2014-01-29','11:40:00',1.15),('325','2014-01-29','11:45:00',1.13),('325','2014-01-29','12:45:00',1.37),('325','2014-01-29','12:50:00',3.33),('325','2014-01-29','12:55:00',3.69),('325','2014-01-29','13:00:00',2.41),('325','2014-01-29','13:05:00',1.57),('325','2014-01-29','13:35:00',1.96),('325','2014-01-29','13:40:00',2.96),('325','2014-01-29','13:45:00',3.23),('325','2014-01-29','13:50:00',3.29),('325','2014-01-29','13:55:00',3.19),('325','2014-01-29','14:00:00',1.44),('325','2014-01-29','15:10:00',1.07),('325','2014-01-29','15:15:00',2),('325','2014-01-29','15:20:00',1.1),('325','2014-01-28','09:10:00',1.02),('325','2014-01-28','09:15:00',1.11),('325','2014-01-28','09:20:00',1.13),('325','2014-01-28','09:25:00',1.16),('325','2014-01-28','09:30:00',1.18),('325','2014-01-28','09:35:00',1.28),('325','2014-01-28','09:40:00',1.17),('325','2014-01-28','09:45:00',1.36),('325','2014-01-28','09:50:00',1.51),('325','2014-01-28','09:55:00',1.59),('325','2014-01-28','10:00:00',1.56),('325','2014-01-28','10:05:00',1.48),('325','2014-01-28','10:10:00',1.77),('325','2014-01-28','10:15:00',2.41),('325','2014-01-28','10:20:00',2.62),('325','2014-01-28','10:25:00',2.77),('325','2014-01-28','10:30:00',2.83),('325','2014-01-28','10:35:00',2.97),('325','2014-01-28','10:40:00',3.01),('325','2014-01-28','10:45:00',2.87),('325','2014-01-28','10:50:00',2.45),('325','2014-01-28','10:55:00',2.62),('325','2014-01-28','11:00:00',2.93),('325','2014-01-28','11:05:00',1.78),('325','2014-01-28','11:10:00',2.71),('325','2014-01-28','11:15:00',1.19),('325','2014-01-28','11:25:00',2.83),('325','2014-01-28','11:30:00',1.16),('325','2014-01-28','11:35:00',2.93),('325','2014-01-28','11:40:00',3.88),('325','2014-01-28','11:45:00',2.81),('325','2014-01-28','11:55:00',1.34),('325','2014-01-28','12:00:00',3.18),('325','2014-01-28','12:05:00',3.48),('325','2014-01-28','12:10:00',2.43),('325','2014-01-28','12:15:00',3.04),('325','2014-01-28','12:20:00',1.78),('325','2014-01-28','12:25:00',1.29),('325','2014-01-28','12:30:00',1.26),('325','2014-01-28','12:35:00',1.7),('325','2014-01-28','12:40:00',1.83),('325','2014-01-28','12:45:00',2.94),('325','2014-01-28','12:50:00',2.99),('325','2014-01-28','12:55:00',3.84),('325','2014-01-28','13:00:00',3.96),('325','2014-01-28','13:05:00',3.99),('325','2014-01-28','13:10:00',2.8),('325','2014-01-28','13:15:00',3.34),('325','2014-01-28','13:20:00',3.01),('325','2014-01-28','13:25:00',3.42),('325','2014-01-28','13:30:00',3.45),('325','2014-01-28','13:35:00',3.61),('325','2014-01-28','13:40:00',3.49),('325','2014-01-28','13:45:00',3.38),('325','2014-01-28','13:50:00',3.3),('325','2014-01-28','13:55:00',3.22),('325','2014-01-28','14:00:00',3.16),('325','2014-01-28','14:05:00',3.1),('325','2014-01-28','14:10:00',3.04),('325','2014-01-28','14:15:00',3.02),('325','2014-01-28','14:20:00',2.95),('325','2014-01-28','14:25:00',2.97),('325','2014-01-28','14:30:00',2.92),('325','2014-01-28','14:35:00',2.74),('325','2014-01-28','14:40:00',2.67),('325','2014-01-28','14:45:00',2.62),('325','2014-01-28','14:50:00',2.5),('325','2014-01-28','14:55:00',2.42),('325','2014-01-28','15:00:00',2.33),('325','2014-01-28','15:05:00',2.24),('325','2014-01-28','15:10:00',2.14),('325','2014-01-28','15:15:00',2.05),('325','2014-01-28','15:20:00',1.95),('325','2014-01-28','15:25:00',1.84),('325','2014-01-28','15:30:00',1.75),('325','2014-01-28','15:35:00',1.64),('325','2014-01-28','15:40:00',1.54),('325','2014-01-28','15:45:00',1.45),('325','2014-01-28','15:50:00',1.35),('325','2014-01-28','15:55:00',1.26),('325','2014-01-28','16:00:00',1.17),('325','2014-01-28','16:05:00',1.03),('325','2014-01-27','11:05:00',1.11),('325','2014-01-27','11:20:00',1.07),('325','2014-01-27','11:25:00',1.05),('325','2014-01-26','09:05:00',1.21),('325','2014-01-26','09:30:00',1.41),('325','2014-01-26','09:35:00',1.37),('325','2014-01-26','09:45:00',1.16),('325','2014-01-26','09:50:00',1.36),('325','2014-01-26','09:55:00',1.06),('325','2014-01-26','10:10:00',1.72),('325','2014-01-26','10:15:00',2.01),('325','2014-01-26','10:20:00',1.17),('325','2014-01-26','10:25:00',1.04),('325','2014-01-26','11:25:00',1.15),('325','2014-01-26','12:15:00',1.25),('325','2014-01-26','12:20:00',1.34),('325','2014-01-26','12:25:00',1.49),('325','2014-01-26','12:30:00',3.08),('325','2014-01-26','12:35:00',2.06),('325','2014-01-26','12:40:00',1.3),('325','2014-01-26','12:45:00',1.12),('325','2014-01-26','13:00:00',1.04),('325','2014-01-26','13:05:00',1.2),('325','2014-01-26','13:10:00',1.34),('325','2014-01-26','13:15:00',1.52),('325','2014-01-26','13:20:00',1.63),('325','2014-01-26','13:25:00',1.3),('325','2014-01-26','13:50:00',1.12),('325','2014-01-26','15:45:00',1.49),('3355','2014-05-05','08:40:00',1.02),('3355','2014-05-05','08:45:00',1.07),('3355','2014-05-05','08:50:00',1.12),('3355','2014-05-05','08:55:00',1.16),('3355','2014-05-05','09:00:00',1.2),('3355','2014-05-05','09:05:00',1.25),('3355','2014-05-05','09:10:00',1.29),('3355','2014-05-05','09:15:00',1.34),('3355','2014-05-05','09:20:00',1.39),('3355','2014-05-05','09:25:00',1.44),('3355','2014-05-05','09:30:00',1.49),('3355','2014-05-05','09:35:00',1.54),('3355','2014-05-05','09:40:00',1.58),('3355','2014-05-05','09:45:00',1.62),('3355','2014-05-05','09:50:00',1.67),('3355','2014-05-05','09:55:00',1.71),('3355','2014-05-05','10:00:00',1.75),('3355','2014-05-05','10:05:00',1.79),('3355','2014-05-05','10:10:00',1.82),('3355','2014-05-05','10:15:00',1.85),('3355','2014-05-05','10:20:00',1.87),('3355','2014-05-05','10:25:00',1.91),('3355','2014-05-05','10:30:00',1.94),('3355','2014-05-05','10:35:00',1.98),('3355','2014-05-05','10:40:00',2),('3355','2014-05-05','10:45:00',2.01),('3355','2014-05-05','10:50:00',2.04),('3355','2014-05-05','10:55:00',2.07),('3355','2014-05-05','11:00:00',2.1),('3355','2014-05-05','11:05:00',2.12),('3355','2014-05-05','11:10:00',2.14),('3355','2014-05-05','11:15:00',2.17),('3355','2014-05-05','11:20:00',2.18),('3355','2014-05-05','11:25:00',2.2),('3355','2014-05-05','11:30:00',2.2),('3355','2014-05-05','11:35:00',2.23),('3355','2014-05-05','11:40:00',2.26),('3355','2014-05-05','11:45:00',2.29),('3355','2014-05-05','11:50:00',2.31),('3355','2014-05-05','11:55:00',2.36),('3355','2014-05-05','12:00:00',1.72),('3355','2014-05-05','12:05:00',1.09),('3355','2014-05-05','12:10:00',1.41),('3355','2014-05-05','12:15:00',2.27),('3355','2014-05-05','12:20:00',1.2),('3355','2014-05-05','12:25:00',2.07),('3355','2014-05-05','12:30:00',1.81),('3355','2014-05-05','12:35:00',1.06),('3355','2014-05-05','12:40:00',1.3),('3355','2014-05-05','12:45:00',2.43),('3355','2014-05-05','12:50:00',1.98),('3355','2014-05-05','12:55:00',1.27),('3355','2014-05-05','13:00:00',2.27),('3355','2014-05-05','13:05:00',1.89),('3355','2014-05-05','13:10:00',2.6),('3355','2014-05-05','13:15:00',2.5),('3355','2014-05-05','13:20:00',2.43),('3355','2014-05-05','13:25:00',2.4),('3355','2014-05-05','13:30:00',2.25),('3355','2014-05-05','13:35:00',2.24),('3355','2014-05-05','13:40:00',2.43),('3355','2014-05-05','13:45:00',2.43),('3355','2014-05-05','13:50:00',2.44),('3355','2014-05-05','13:55:00',2.42),('3355','2014-05-05','14:00:00',2.44),('3355','2014-05-05','14:05:00',2.51),('3355','2014-05-05','14:10:00',2.51),('3355','2014-05-05','14:15:00',2.55),('3355','2014-05-05','14:20:00',2.14),('3355','2014-05-05','14:25:00',1.47),('3355','2014-05-05','14:30:00',1.5),('3355','2014-05-05','15:05:00',1.61),('3355','2014-05-05','15:25:00',1.13),('3355','2014-05-05','15:30:00',2.45),('3355','2014-05-05','15:35:00',2.34),('3355','2014-05-05','15:40:00',2.2),('3355','2014-05-05','16:45:00',1.12),('3355','2014-05-05','16:55:00',1.34),('3355','2014-05-05','17:00:00',1.53),('3355','2014-05-05','17:05:00',1.46),('3355','2014-05-05','17:10:00',1.47),('3355','2014-05-05','17:15:00',1.43),('3355','2014-05-05','17:20:00',1.37),('3355','2014-05-05','17:25:00',1.3),('3355','2014-05-05','17:30:00',1.21),('3355','2014-05-05','17:35:00',1.15),('3355','2014-05-05','17:40:00',1.1),('3355','2014-05-05','17:45:00',1.04),('3355','2014-04-26','10:35:00',1.04),('3355','2014-04-26','10:40:00',1.07),('3355','2014-04-26','10:45:00',1.12),('3355','2014-04-26','10:50:00',1.38),('3355','2014-04-26','10:55:00',1.97),('3355','2014-04-26','11:00:00',1.96),('3355','2014-04-26','11:05:00',1.9),('3355','2014-04-26','11:10:00',1.72),('3355','2014-04-26','11:15:00',1.8),('3355','2014-04-26','11:20:00',1.6),('3355','2014-04-26','11:25:00',1.62),('3355','2014-04-26','11:30:00',1.54),('3355','2014-04-26','11:35:00',1.68),('3355','2014-04-26','11:40:00',1.6),('3355','2014-04-26','11:45:00',1.71),('3355','2014-04-26','11:50:00',1.69),('3355','2014-04-26','11:55:00',1.56),('3355','2014-04-26','12:00:00',1.71),('3355','2014-04-26','12:05:00',1.83),('3355','2014-04-26','12:10:00',1.8),('3355','2014-04-26','12:15:00',1.53),('3355','2014-04-26','12:20:00',1.63),('3355','2014-04-26','12:25:00',1.17),('3355','2014-04-26','12:30:00',1.47),('3355','2014-04-26','12:35:00',1.87),('3355','2014-04-26','12:40:00',2),('3355','2014-04-26','12:45:00',2.05),('3355','2014-04-26','12:50:00',2.1),('3355','2014-04-26','12:55:00',2.39),('3355','2014-04-26','13:00:00',2.14),('3355','2014-04-26','13:05:00',1.6),('3355','2014-04-26','13:10:00',1.98),('3355','2014-04-26','13:15:00',2.34),('3355','2014-04-26','13:20:00',2.19),('3355','2014-04-26','13:25:00',1.36),('3355','2014-04-26','13:35:00',1.07),('3355','2014-04-26','13:40:00',2.06),('3355','2014-04-26','13:45:00',2.4),('3355','2014-04-26','13:50:00',2.39),('3355','2014-04-26','13:55:00',2.45),('3355','2014-04-26','14:00:00',2.15),('3355','2014-04-26','14:10:00',1.62),('3355','2014-04-26','14:35:00',1.28),('3355','2014-04-26','14:40:00',1.55),('3355','2014-01-26','09:35:00',1.04),('3355','2014-01-26','10:10:00',1.16),('3355','2014-01-26','10:15:00',1.58),('3355','2014-01-26','12:30:00',1.38),('3355','2014-01-26','12:35:00',1.38),('3355','2014-01-25','09:05:00',1.03),('3355','2014-01-25','09:55:00',1.13),('3355','2014-01-25','10:05:00',1.48),('3355','2014-01-25','10:10:00',1.64),('3355','2014-01-25','10:15:00',1.63),('3355','2014-01-25','10:20:00',1.62),('3355','2014-01-25','10:30:00',1.13),('3355','2014-01-25','10:40:00',1),('3355','2014-01-25','11:30:00',1.57),('3355','2014-01-25','11:35:00',2.2),('3355','2014-01-25','11:40:00',1.05),('3355','2014-01-25','12:10:00',1.01),('3355','2014-01-25','12:15:00',1),('3355','2014-01-25','12:20:00',1.03),('3355','2014-01-25','12:25:00',1.06),('3355','2014-01-25','12:30:00',1.1),('3355','2014-01-25','12:40:00',1),('3355','2014-01-25','12:45:00',1.19),('3355','2014-01-25','12:50:00',1.31),('3355','2014-01-25','12:55:00',1.6),('3355','2014-01-25','13:00:00',1.62),('3355','2014-01-25','13:05:00',1.83),('3355','2014-01-25','13:10:00',1.89),('3355','2014-01-25','13:15:00',1.37),('3355','2014-01-25','13:30:00',1.09),('3355','2014-01-25','13:45:00',1.33),('3355','2014-01-25','14:00:00',1.08),('3355','2014-01-25','14:05:00',1.3),('3355','2014-01-25','14:10:00',1.41),('3355','2014-01-25','14:15:00',1.44),('3355','2014-01-25','14:20:00',1.65),('3355','2014-01-25','14:25:00',1.65),('3355','2014-01-25','14:30:00',1.78),('3355','2014-01-25','14:35:00',1.27),('3355','2014-01-25','14:40:00',1.7),('3355','2014-01-25','14:45:00',1.71),('3355','2014-01-25','14:50:00',1.65),('3355','2014-01-25','14:55:00',1.55),('3355','2014-01-25','15:00:00',1.41),('3355','2014-01-25','15:05:00',1.32),('3355','2014-01-25','15:10:00',1.2),('3355','2014-01-25','15:15:00',1.08),('3355','2014-01-25','15:20:00',1.04),('3355','2014-01-24','10:40:00',1.01),('3355','2014-01-24','10:45:00',1.01),('3355','2014-01-24','11:50:00',2.04),('3355','2014-01-24','11:55:00',2.04),('3355','2014-01-24','12:00:00',1.54),('3355','2014-01-24','12:35:00',1.55),('3355','2014-01-24','12:40:00',1.43),('3355','2014-01-24','12:45:00',1.22),('3355','2014-01-24','13:00:00',1.01),('3355','2014-01-24','13:05:00',1.12),('3355','2014-01-24','13:45:00',1.09),('3355','2014-01-24','13:50:00',1.39),('3355','2014-01-24','13:55:00',1.26),('3355','2014-01-24','14:00:00',1.53),('3355','2014-01-24','14:10:00',1.89),('3355','2014-01-24','14:15:00',1.72),('3355','2014-01-24','14:20:00',1.7),('3355','2014-01-24','14:25:00',1.52),('3355','2014-01-21','11:00:00',1.2),('3355','2014-01-21','12:10:00',1.16),('3355','2014-01-21','12:30:00',1.04),('3355','2014-01-21','12:50:00',1.05),('3355','2014-01-20','11:25:00',1.08),('3355','2014-01-20','11:30:00',1.1),('3355','2014-01-20','11:35:00',1.08),('3355','2014-01-20','11:40:00',1.79),('3355','2014-01-20','11:45:00',1.73),('3355','2014-01-20','11:50:00',1.07),('3355','2014-01-20','13:20:00',2.21),('3355','2014-01-20','13:25:00',2.11),('3355','2014-01-20','13:30:00',1.87),('3355','2014-01-20','13:35:00',1.78),('3355','2014-01-20','13:40:00',1.63),('3355','2014-01-20','13:45:00',1.53),('3355','2014-01-20','14:00:00',1.53),('3355','2014-01-20','14:05:00',1.22),('3355','2014-01-19','14:30:00',1.1),('3355','2014-01-18','10:10:00',1.44),('3355','2014-01-18','10:15:00',1.51),('3355','2014-01-18','10:20:00',1.39),('3355','2014-01-18','11:10:00',1.25),('3355','2014-01-18','11:15:00',1.68),('3355','2014-01-18','11:20:00',1.64),('3355','2014-01-18','11:25:00',1.55),('3355','2014-01-18','11:30:00',1.58),('3355','2014-01-18','11:35:00',1.61),('3355','2014-01-18','11:40:00',1.44),('3355','2014-01-18','11:45:00',1.86),('3355','2014-01-18','11:50:00',2),('3355','2014-01-18','11:55:00',1.97),('3355','2014-01-18','12:00:00',1.87),('3355','2014-01-18','12:05:00',1.46),('3355','2014-01-18','12:10:00',1.74),('3355','2014-01-18','12:15:00',1.67),('3355','2014-01-18','12:20:00',1.66),('3355','2014-01-18','12:25:00',1.7),('3355','2014-01-18','12:30:00',1.71),('3355','2014-01-18','12:35:00',1.7),('3355','2014-01-18','12:40:00',1.73),('3355','2014-01-18','12:45:00',1.71),('3355','2014-01-18','12:50:00',1.64),('3355','2014-01-18','12:55:00',1.81),('3355','2014-01-18','13:00:00',1.18),('3355','2014-01-18','13:05:00',1.08),('3355','2014-01-18','13:10:00',1.4),('3355','2014-01-18','13:15:00',1.73),('3355','2014-01-18','13:20:00',1.05),('3355','2014-01-18','13:30:00',1.56),('3355','2014-01-18','13:40:00',1.33),('3355','2014-01-18','13:45:00',1.65),('3355','2014-01-18','13:50:00',1.04),('3355','2014-01-18','13:55:00',1.59),('3355','2014-01-18','14:00:00',1.51),('3355','2014-01-18','14:05:00',1.35),('3355','2014-01-18','14:10:00',1.38),('3355','2014-01-18','14:15:00',1.33),('3355','2014-01-18','14:20:00',1.41),('3355','2014-01-18','14:25:00',1.35),('3355','2014-01-18','14:30:00',1.3),('3355','2014-01-18','14:35:00',1.28),('3355','2014-01-18','14:40:00',1.24),('3355','2014-01-18','14:45:00',1.21),('3355','2014-01-18','14:50:00',1.11),('3355','2014-01-17','09:40:00',1.06),('3355','2014-01-17','09:45:00',1.05),('3355','2014-01-17','11:30:00',1.33),('3355','2014-01-17','11:35:00',1.03),('3355','2014-01-17','12:05:00',1.14),('3355','2014-04-25','08:55:00',1.02),('3355','2014-04-25','09:00:00',1.19),('3355','2014-04-25','09:05:00',1.22),('3355','2014-04-25','09:10:00',1.29),('3355','2014-04-25','09:15:00',1.39),('3355','2014-04-25','09:20:00',1.48),('3355','2014-04-25','09:25:00',1.51),('3355','2014-04-25','09:30:00',1.43),('3355','2014-04-25','10:40:00',1.2),('3355','2014-04-25','10:45:00',1.77),('3355','2014-04-25','10:50:00',2.04),('3355','2014-04-25','10:55:00',1.97),('3355','2014-04-25','11:00:00',1.98),('3355','2014-04-25','11:05:00',1.9),('3355','2014-04-25','11:10:00',1.62),('3355','2014-04-25','11:15:00',1.45),('3355','2014-04-25','11:20:00',1.95),('3355','2014-04-25','12:05:00',1.21),('3355','2014-04-25','12:10:00',1.03),('3355','2014-04-25','12:20:00',1.36),('3355','2014-04-25','12:25:00',2.22),('3355','2014-04-25','12:30:00',2.44),('3355','2014-04-25','12:35:00',2.3),('3355','2014-04-25','12:40:00',2.34),('3355','2014-04-25','12:45:00',2.51),('3355','2014-04-25','12:50:00',2.29),('3355','2014-04-25','13:05:00',1.66),('3355','2014-04-25','13:15:00',1.81),('3355','2014-04-25','13:45:00',1.11),('3355','2014-04-25','14:20:00',2.13),('3355','2014-04-25','14:25:00',2.75),('3355','2014-04-25','14:30:00',2.38),('3355','2014-04-25','14:35:00',2.33),('3355','2014-04-25','14:40:00',2.08),('3355','2014-04-25','14:45:00',2.28),('3355','2014-04-25','14:50:00',2.18),('3355','2014-04-25','14:55:00',2.2),('3355','2014-04-25','15:00:00',2.2),('3355','2014-04-25','15:05:00',2.15),('3355','2014-04-25','15:10:00',2.14),('3355','2014-04-25','15:15:00',2.11),('3355','2014-04-25','15:20:00',2.04),('3355','2014-04-25','15:25:00',2.03),('3355','2014-04-25','15:30:00',1.92),('3355','2014-04-25','15:35:00',2.02),('3355','2014-04-25','15:40:00',1.99),('3355','2014-04-25','15:45:00',1.93),('3355','2014-04-25','15:50:00',1.9),('3355','2014-04-25','15:55:00',1.88),('3355','2014-04-25','16:00:00',1.88),('3355','2014-04-25','16:05:00',1.82),('3355','2014-04-25','16:10:00',1.72),('3355','2014-04-25','16:15:00',1.69),('3355','2014-04-25','16:20:00',1.57),('3355','2014-04-25','16:25:00',1.57),('3355','2014-04-25','16:30:00',1.63),('3355','2014-04-25','16:35:00',1.61),('3355','2014-04-25','16:40:00',1.61),('3355','2014-04-25','16:45:00',1.56),('3355','2014-04-25','16:50:00',1.47),('3355','2014-04-25','16:55:00',1.26),('3355','2014-04-25','17:00:00',1.14),('3355','2014-04-25','17:05:00',1.29),('3355','2014-04-25','17:10:00',1.14),('3355','2014-04-25','17:15:00',1.17),('3355','2014-01-16','09:30:00',1.05),('3355','2014-01-16','09:35:00',1.07),('3355','2014-01-16','09:40:00',1.14),('3355','2014-01-16','09:45:00',1.03),('3355','2014-01-16','10:30:00',1.09),('3355','2014-01-16','10:35:00',1.45),('3355','2014-01-16','10:40:00',1.45),('3355','2014-01-16','10:45:00',1.01),('3355','2014-01-16','10:50:00',1.08),('3355','2014-01-16','10:55:00',1.23),('3355','2014-01-16','11:00:00',1.23),('3355','2014-01-16','11:05:00',1.24),('3355','2014-01-16','11:10:00',1.28),('3355','2014-01-16','11:15:00',1.32),('3355','2014-01-16','11:20:00',1.17),('3355','2014-01-16','11:25:00',1.2),('3355','2014-01-16','11:30:00',1.06),('3355','2014-01-16','11:35:00',1.04),('3355','2014-01-16','11:50:00',1.02),('3355','2014-01-16','12:10:00',1.03),('3355','2014-01-16','12:35:00',1.05),('3355','2014-01-16','12:40:00',1.12),('3355','2014-01-16','12:45:00',1.16),('3355','2014-01-16','12:50:00',1.25),('3355','2014-01-16','12:55:00',1.31),('3355','2014-01-16','13:00:00',1.32),('3355','2014-01-16','13:05:00',1.42),('3355','2014-01-16','13:10:00',1.34),('3355','2014-01-16','13:15:00',1.29),('3355','2014-01-16','13:25:00',1.34),('3355','2014-01-16','13:30:00',1.38),('3355','2014-01-16','13:35:00',1.28),('3355','2014-01-16','13:50:00',1.17),('3355','2014-01-16','13:55:00',1),('3355','2014-01-15','10:20:00',1.14),('3355','2014-01-15','10:25:00',1.28),('3355','2014-01-15','10:30:00',1.32),('3355','2014-01-15','10:45:00',1.18),('3355','2014-01-15','11:10:00',1.82),('3355','2014-01-15','11:15:00',1.49),('3355','2014-01-15','11:20:00',1.5),('3355','2014-01-15','11:25:00',1.49),('3355','2014-01-15','11:30:00',1.4),('3355','2014-01-15','11:35:00',1.72),('3355','2014-01-15','11:40:00',1.26),('3355','2014-01-15','11:45:00',1.34),('3355','2014-01-15','11:50:00',1.52),('3355','2014-01-15','11:55:00',1.23),('3355','2014-01-15','12:15:00',1.27),('3355','2014-01-15','12:20:00',1.63),('3355','2014-01-15','12:25:00',1.46),('3355','2014-01-15','12:50:00',1.01),('3355','2014-01-15','13:10:00',1.02),('3355','2014-01-15','13:15:00',1.73),('3355','2014-01-15','13:20:00',1.82),('3355','2014-01-15','13:25:00',1.82),('3355','2014-01-15','13:30:00',1.76),('3355','2014-01-15','13:35:00',1.7),('3355','2014-01-15','13:40:00',1.62),('3355','2014-01-15','13:45:00',1.58),('3355','2014-01-15','13:50:00',1.14),('3355','2014-01-15','14:10:00',1.4),('3355','2014-01-15','14:15:00',1.38),('3355','2014-01-15','14:20:00',1.35),('3355','2014-01-15','14:25:00',1.35),('3355','2014-01-15','14:30:00',1.33),('3355','2014-01-15','14:35:00',1.29),('3355','2014-01-15','14:40:00',1.29),('3355','2014-01-15','14:45:00',1.17),('3355','2014-01-15','14:50:00',1.06),('3355','2014-01-15','14:55:00',1.09),('3355','2014-01-14','10:30:00',1.63),('3355','2014-01-14','10:35:00',1.76),('3355','2014-01-14','10:40:00',1.51),('3355','2014-01-14','10:45:00',1.41),('3355','2014-01-13','09:50:00',1.02),('3355','2014-01-13','09:55:00',1.05),('3355','2014-01-13','10:00:00',1.09),('3355','2014-01-13','10:05:00',1.11),('3355','2014-01-13','10:10:00',1.14),('3355','2014-01-13','10:15:00',1.16),('3355','2014-01-13','10:20:00',1.21),('3355','2014-01-13','10:25:00',1.24),('3355','2014-01-13','10:30:00',1.27),('3355','2014-01-13','10:35:00',1.28),('3355','2014-01-13','10:40:00',1.31),('3355','2014-01-13','10:45:00',1.34),('3355','2014-01-13','10:50:00',1.37),('3355','2014-01-13','10:55:00',1.4),('3355','2014-01-13','11:00:00',1.41),('3355','2014-01-13','11:05:00',1.42),('3355','2014-01-13','11:10:00',1.45),('3355','2014-01-13','11:15:00',1.47),('3355','2014-01-13','11:20:00',1.49),('3355','2014-01-13','11:25:00',1.5),('3355','2014-01-13','11:30:00',1.51),('3355','2014-01-13','11:35:00',1.51),('3355','2014-01-13','11:40:00',1.52),('3355','2014-01-13','11:45:00',1.53),('3355','2014-01-13','11:50:00',1.52),('3355','2014-01-13','11:55:00',1.53),('3355','2014-01-13','12:00:00',1.5),('3355','2014-01-13','12:05:00',1.48),('3355','2014-01-13','12:10:00',1.49),('3355','2014-01-13','12:15:00',1.53),('3355','2014-01-13','12:20:00',1.53),('3355','2014-01-13','12:25:00',1.53),('3355','2014-01-13','12:30:00',1.51),('3355','2014-01-13','12:35:00',1.5),('3355','2014-01-13','12:40:00',1.49),('3355','2014-01-13','12:45:00',1.49),('3355','2014-01-13','12:50:00',1.45),('3355','2014-01-13','12:55:00',1.38),('3355','2014-01-13','13:00:00',1.43),('3355','2014-01-13','13:05:00',1.42),('3355','2014-01-13','13:10:00',1.42),('3355','2014-01-13','13:15:00',1.39),('3355','2014-01-13','13:20:00',1.39),('3355','2014-01-13','13:25:00',1.35),('3355','2014-01-13','13:30:00',1.35),('3355','2014-01-13','13:35:00',1.38),('3355','2014-01-13','13:40:00',1.27),('3355','2014-01-13','13:45:00',1.2),('3355','2014-01-13','13:50:00',1.14),('3355','2014-01-13','13:55:00',1.09),('3355','2014-01-13','14:00:00',1.02),('3355','2014-01-13','14:05:00',1.18),('3355','2014-01-13','14:10:00',1.14),('3355','2014-01-13','14:15:00',1.17),('3355','2014-01-13','14:20:00',1.18),('3355','2014-01-13','14:25:00',1.15),('3355','2014-01-13','14:30:00',1.12),('3355','2014-01-13','14:35:00',1.1),('3355','2014-01-13','14:40:00',1.02),('3355','2014-01-12','11:10:00',1.05),('3355','2014-01-12','11:50:00',1.07),('3355','2014-01-12','11:55:00',1.08),('3355','2014-01-11','10:25:00',1.03),('3355','2014-01-11','10:35:00',1.05),('3355','2014-01-11','10:40:00',1.31),('3355','2014-01-11','10:45:00',1.4),('3355','2014-01-11','10:50:00',1.41),('3355','2014-01-11','10:55:00',1.42),('3355','2014-01-11','11:00:00',1.39),('3355','2014-01-11','11:05:00',1.32),('3355','2014-01-11','11:10:00',1.42),('3355','2014-01-11','11:15:00',1.31),('3355','2014-01-11','11:20:00',1.19),('3355','2014-01-11','11:25:00',1.21),('3355','2014-01-11','11:30:00',1.21),('3355','2014-01-11','11:35:00',1.08),('3355','2014-01-11','11:45:00',1),('3355','2014-01-11','11:50:00',1.08),('3355','2014-01-11','11:55:00',1.1),('3355','2014-01-11','12:00:00',1.11),('3355','2014-01-11','12:05:00',1.29),('3355','2014-01-11','12:10:00',1.19),('3355','2014-01-11','12:15:00',1.2),('3355','2014-01-11','12:20:00',1.12),('3355','2014-01-11','12:25:00',1.07),('3355','2014-01-11','12:50:00',1),('3355','2014-01-11','12:55:00',1.26),('3355','2014-01-11','13:00:00',1.19),('3355','2014-01-11','13:05:00',1.15),('3355','2014-01-11','13:10:00',1.19),('3355','2014-01-11','13:15:00',1.34),('3355','2014-01-11','13:20:00',1.15),('3355','2014-01-09','09:50:00',1),('3355','2014-01-09','09:55:00',1.06),('3355','2014-01-09','10:00:00',1.07),('3355','2014-01-09','10:05:00',1.09),('3355','2014-01-09','10:25:00',1.02),('3355','2014-01-09','10:30:00',1.06),('3355','2014-01-09','10:35:00',1.06),('3355','2014-01-09','10:40:00',1.06),('3355','2014-01-09','10:45:00',1.12),('3355','2014-01-09','10:50:00',1.19),('3355','2014-01-08','09:55:00',1.04),('3355','2014-01-08','10:00:00',1.04),('3355','2014-01-08','10:05:00',1.04),('3355','2014-01-08','10:10:00',1.09),('3355','2014-01-08','10:15:00',1.14),('3355','2014-01-08','10:20:00',1.2),('3355','2014-01-08','10:25:00',1.19),('3355','2014-01-08','10:30:00',1.25),('3355','2014-01-08','10:35:00',1.23),('3355','2014-01-08','10:40:00',1.2),('3355','2014-01-08','10:45:00',1.31),('3355','2014-01-08','10:50:00',1.37),('3355','2014-01-08','10:55:00',1.41),('3355','2014-01-08','11:00:00',1.43),('3355','2014-01-08','11:05:00',1.45),('3355','2014-01-08','11:10:00',1.47),('3355','2014-01-08','11:15:00',1.49),('3355','2014-01-08','11:20:00',1.5),('3355','2014-01-08','11:25:00',1.49),('3355','2014-01-08','11:30:00',1.49),('3355','2014-01-08','11:35:00',1.55),('3355','2014-01-08','11:40:00',1.57),('3355','2014-01-08','11:45:00',1.56),('3355','2014-01-08','11:50:00',1.54),('3355','2014-01-08','11:55:00',1.55),('3355','2014-01-08','12:00:00',1.53),('3355','2014-01-08','12:05:00',1.51),('3355','2014-01-08','12:10:00',1.53),('3355','2014-01-08','12:15:00',1.56),('3355','2014-01-08','12:20:00',1.56),('3355','2014-01-08','12:25:00',1.57),('3355','2014-01-08','12:30:00',1.57),('3355','2014-01-08','12:35:00',1.52),('3355','2014-01-08','12:40:00',1.51),('3355','2014-01-08','12:45:00',1.47),('3355','2014-01-08','12:50:00',1.44),('3355','2014-01-08','12:55:00',1.46),('3355','2014-01-08','13:00:00',1.45),('3355','2014-01-08','13:05:00',1.44),('3355','2014-01-08','13:10:00',1.44),('3355','2014-01-08','13:15:00',1.44),('3355','2014-01-08','13:20:00',1.43),('3355','2014-01-08','13:25:00',1.4),('3355','2014-01-08','13:30:00',1.34),('3355','2014-01-08','13:35:00',1.19),('3355','2014-01-08','13:40:00',1.18),('3355','2014-01-08','13:45:00',1.2),('3355','2014-01-08','13:50:00',1.11),('3355','2014-01-08','13:55:00',1.14),('3355','2014-01-08','14:00:00',1.14),('3355','2014-01-08','14:05:00',1.16),('3355','2014-01-08','14:10:00',1.18),('3355','2014-01-08','14:15:00',1.18),('3355','2014-01-08','14:20:00',1.19),('3355','2014-01-08','14:25:00',1.17),('3355','2014-01-08','14:30:00',1.06),('3355','2014-01-07','09:40:00',1.02),('3355','2014-01-07','09:45:00',1.05),('3355','2014-01-07','09:50:00',1.09),('3355','2014-01-07','09:55:00',1.13),('3355','2014-01-07','10:00:00',1.16),('3355','2014-01-07','10:05:00',1.19),('3355','2014-01-07','10:10:00',1.22),('3355','2014-01-07','10:15:00',1.25),('3355','2014-01-07','10:20:00',1.27),('3355','2014-01-07','10:25:00',1.3),('3355','2014-01-07','10:30:00',1.32),('3355','2014-01-07','10:35:00',1.35),('3355','2014-01-07','10:40:00',1.38),('3355','2014-01-07','10:45:00',1.41),('3355','2014-01-07','10:50:00',1.44),('3355','2014-01-07','10:55:00',1.46),('3355','2014-01-07','11:00:00',1.48),('3355','2014-01-07','11:05:00',1.5),('3355','2014-01-07','11:10:00',1.51),('3355','2014-01-07','11:15:00',1.53),('3355','2014-01-07','11:20:00',1.55),('3355','2014-01-07','11:25:00',1.56),('3355','2014-01-07','11:30:00',1.57),('3355','2014-01-07','11:35:00',1.59),('3355','2014-01-07','11:40:00',1.6),('3355','2014-01-07','11:45:00',1.62),('3355','2014-01-07','11:50:00',1.62),('3355','2014-01-07','11:55:00',1.63),('3355','2014-01-07','12:00:00',1.62),('3355','2014-01-07','12:05:00',1.64),('3355','2014-01-07','12:10:00',1.64),('3355','2014-01-07','12:15:00',1.63),('3355','2014-01-07','12:20:00',1.64),('3355','2014-01-07','12:25:00',1.63),('3355','2014-01-07','12:30:00',1.6),('3355','2014-01-07','12:35:00',1.61),('3355','2014-01-07','12:40:00',1.56),('3355','2014-01-07','12:45:00',1.52),('3355','2014-01-07','12:50:00',1.59),('3355','2014-01-07','12:55:00',1.62),('3355','2014-01-07','13:00:00',1.52),('3355','2014-01-07','13:05:00',1.46),('3355','2014-01-07','13:10:00',1.49),('3355','2014-01-07','13:15:00',1.5),('3355','2014-01-07','13:20:00',1.44),('3355','2014-01-07','13:25:00',1.41),('3355','2014-01-07','13:30:00',1.28),('3355','2014-01-07','13:35:00',1.2),('3355','2014-01-07','13:40:00',1.15),('3355','2014-01-07','13:45:00',1.3),('3355','2014-01-07','13:50:00',1.23),('3355','2014-01-07','13:55:00',1.25),('3355','2014-01-07','14:00:00',1.29),('3355','2014-01-07','14:05:00',1.26),('3355','2014-01-07','14:10:00',1.26),('3355','2014-01-07','14:15:00',1.26),('3355','2014-01-07','14:20:00',1.28),('3355','2014-01-07','14:25:00',1.17),('3355','2014-01-07','14:30:00',1.01),('3355','2014-01-07','14:35:00',1.02),('3355','2014-04-24','08:55:00',1.03),('3355','2014-04-24','09:00:00',1.08),('3355','2014-04-24','09:05:00',1.12),('3355','2014-04-24','09:10:00',1.17),('3355','2014-04-24','09:15:00',1.21),('3355','2014-04-24','09:20:00',1.26),('3355','2014-04-24','09:25:00',1.3),('3355','2014-04-24','09:30:00',1.34),('3355','2014-04-24','09:35:00',1.39),('3355','2014-04-24','09:40:00',1.43),('3355','2014-04-24','09:45:00',1.47),('3355','2014-04-24','09:50:00',1.51),('3355','2014-04-24','09:55:00',1.55),('3355','2014-04-24','10:00:00',1.59),('3355','2014-04-24','10:05:00',1.62),('3355','2014-04-24','10:10:00',1.64),('3355','2014-04-24','10:15:00',1.67),('3355','2014-04-24','10:20:00',1.7),('3355','2014-04-24','10:25:00',1.74),('3355','2014-04-24','10:30:00',1.77),('3355','2014-04-24','10:35:00',1.79),('3355','2014-04-24','10:40:00',1.84),('3355','2014-04-24','10:45:00',1.87),('3355','2014-04-24','10:50:00',1.91),('3355','2014-04-24','10:55:00',1.94),('3355','2014-04-24','11:00:00',1.96),('3355','2014-04-24','11:05:00',1.97),('3355','2014-04-24','11:10:00',1.97),('3355','2014-04-24','11:15:00',2.01),('3355','2014-04-24','11:20:00',2.02),('3355','2014-04-24','11:25:00',2.04),('3355','2014-04-24','11:30:00',2.04),('3355','2014-04-24','11:35:00',2.06),('3355','2014-04-24','11:40:00',2.1),('3355','2014-04-24','11:45:00',2.11),('3355','2014-04-24','11:50:00',2),('3355','2014-04-24','11:55:00',2.19),('3355','2014-04-24','12:00:00',2.12),('3355','2014-04-24','12:05:00',2.15),('3355','2014-04-24','12:10:00',2.25),('3355','2014-04-24','12:15:00',1.44),('3355','2014-04-24','12:20:00',1.99),('3355','2014-04-24','12:25:00',2.3),('3355','2014-04-24','12:30:00',2.23),('3355','2014-04-24','12:35:00',1.43),('3355','2014-04-24','12:40:00',2.34),('3355','2014-04-24','12:45:00',1.58),('3355','2014-04-24','12:50:00',2.38),('3355','2014-04-24','12:55:00',2.32),('3355','2014-04-24','13:00:00',2.28),('3355','2014-04-24','13:05:00',2.31),('3355','2014-04-24','13:10:00',2.04),('3355','2014-04-24','13:20:00',2.34),('3355','2014-04-24','13:25:00',2.44),('3355','2014-04-24','13:30:00',2.41),('3355','2014-04-24','13:35:00',2.33),('3355','2014-04-24','13:40:00',1.52),('3355','2014-04-24','13:50:00',2.33),('3355','2014-04-24','13:55:00',2.48),('3355','2014-04-24','14:00:00',2),('3355','2014-04-24','14:05:00',1.72),('3355','2014-04-24','14:10:00',2.13),('3355','2014-04-24','14:15:00',1.74),('3355','2014-04-24','14:20:00',1.77),('3355','2014-04-24','14:25:00',2.27),('3355','2014-04-24','14:30:00',2.52),('3355','2014-04-24','14:35:00',2.41),('3355','2014-04-24','14:40:00',1.78),('3355','2014-04-24','14:45:00',1.95),('3355','2014-04-24','14:55:00',1.88),('3355','2014-04-24','15:00:00',2.63),('3355','2014-04-24','15:05:00',2.56),('3355','2014-04-24','15:10:00',2.37),('3355','2014-04-24','15:15:00',2.12),('3355','2014-04-24','15:20:00',1.59),('3355','2014-04-24','15:25:00',1.27),('3355','2014-04-24','15:30:00',1.33),('3355','2014-04-24','15:35:00',1.61),('3355','2014-04-24','15:40:00',1.25),('3355','2014-04-24','15:45:00',1.13),('3355','2014-04-24','15:50:00',1.39),('3355','2014-04-24','15:55:00',1.52),('3355','2014-04-24','16:00:00',2.09),('3355','2014-04-24','16:05:00',2.14),('3355','2014-04-24','16:10:00',1.79),('3355','2014-04-24','16:15:00',1.92),('3355','2014-04-24','16:20:00',1.72),('3355','2014-04-24','16:25:00',1.3),('3355','2014-04-24','16:30:00',1.72),('3355','2014-04-24','16:35:00',1.01),('3355','2014-04-24','16:40:00',1.2),('3355','2014-04-24','16:45:00',1.32),('3355','2014-01-06','11:40:00',1.59),('3355','2014-01-06','11:45:00',1.69),('3355','2014-01-06','11:50:00',1.42),('3355','2014-01-06','11:55:00',1.3),('3355','2014-01-06','12:05:00',1.6),('3355','2014-01-06','12:10:00',1.66),('3355','2014-01-06','12:15:00',1.62),('3355','2014-01-06','12:20:00',1.63),('3355','2014-01-06','12:25:00',1.62),('3355','2014-01-06','12:30:00',1.6),('3355','2014-01-06','12:35:00',1.6),('3355','2014-01-06','12:40:00',1.61),('3355','2014-01-06','12:45:00',1.62),('3355','2014-01-06','12:50:00',1.61),('3355','2014-01-06','12:55:00',1.6),('3355','2014-01-06','13:00:00',1.59),('3355','2014-01-06','13:05:00',1.57),('3355','2014-01-06','13:10:00',1.57),('3355','2014-01-06','13:15:00',1.61),('3355','2014-01-06','13:20:00',1.6),('3355','2014-01-06','13:25:00',1.53),('3355','2014-01-06','13:30:00',1.31),('3355','2014-01-06','13:35:00',1.26),('3355','2014-01-06','13:40:00',1.14),('3355','2014-01-06','13:45:00',1.27),('3355','2014-01-06','13:50:00',1.29),('3355','2014-01-06','13:55:00',1.26),('3355','2014-01-06','14:20:00',1.26),('3355','2014-01-06','14:40:00',1.13),('3355','2014-01-06','14:45:00',1.21),('3355','2014-01-03','09:40:00',1.13),('3355','2014-01-03','10:20:00',1.46),('3355','2014-01-03','12:55:00',1.21),('3355','2014-01-03','13:35:00',1.04),('3355','2014-01-02','09:50:00',1.01),('3355','2014-01-02','09:55:00',1.06),('3355','2014-01-02','10:00:00',1.12),('3355','2014-01-02','10:05:00',1.16),('3355','2014-01-02','10:10:00',1.17),('3355','2014-01-02','10:15:00',1.19),('3355','2014-01-02','10:20:00',1.21),('3355','2014-01-02','10:25:00',1.26),('3355','2014-01-02','10:30:00',1.29),('3355','2014-01-02','10:35:00',1.27),('3355','2014-01-02','10:40:00',1.3),('3355','2014-01-02','10:45:00',1.32),('3355','2014-01-02','10:50:00',1.36),('3355','2014-01-02','10:55:00',1.42),('3355','2014-01-02','11:00:00',1.3),('3355','2014-01-02','11:05:00',1.41),('3355','2014-01-02','12:55:00',1.84),('3355','2014-01-02','13:00:00',1.36),('3355','2014-01-01','09:30:00',1.08),('3355','2014-01-01','09:50:00',1.28),('3355','2014-01-01','13:35:00',1.09),('3355','2014-01-01','14:00:00',1.13),('3355','2013-12-31','09:30:00',1.01),('3355','2013-12-31','09:35:00',1.06),('3355','2013-12-31','09:40:00',1.13),('3355','2013-12-31','11:25:00',1.09),('3355','2013-12-31','11:30:00',1.38),('3355','2013-12-31','11:40:00',1.03),('3355','2013-12-31','11:50:00',1.38),('3355','2013-12-31','11:55:00',1.32),('3355','2013-12-31','12:00:00',1.74),('3355','2013-12-31','12:05:00',1.7),('3355','2013-12-31','12:10:00',1.69),('3355','2013-12-31','12:15:00',1.68),('3355','2013-12-31','12:20:00',1.68),('3355','2013-12-31','12:25:00',1.66),('3355','2013-12-31','12:30:00',1.63),('3355','2013-12-31','12:35:00',1.64),('3355','2013-12-31','12:40:00',1.64),('3355','2013-12-31','12:45:00',1.63),('3355','2013-12-31','12:50:00',1.61),('3355','2013-12-31','12:55:00',1.61),('3355','2013-12-31','13:00:00',1.6),('3355','2013-12-31','13:05:00',1.59),('3355','2013-12-31','13:10:00',1.56),('3355','2013-12-31','13:15:00',1.48),('3355','2013-12-31','13:20:00',1.4),('3355','2013-12-31','13:25:00',1.31),('3355','2013-12-31','13:30:00',1.36),('3355','2013-12-31','13:35:00',1.39),('3355','2013-12-31','13:40:00',1.35),('3355','2013-12-31','13:45:00',1.32),('3355','2013-12-31','13:50:00',1.26),('3355','2013-12-31','13:55:00',1.28),('3355','2013-12-31','14:00:00',1.28),('3355','2013-12-31','14:05:00',1.29),('3355','2013-12-31','14:10:00',1.29),('3355','2013-12-31','14:15:00',1.21),('3355','2013-12-31','14:20:00',1.04),('3355','2013-12-31','14:25:00',1.12),('3355','2013-12-31','14:30:00',1.06),('3355','2013-12-31','14:35:00',1.05),('3355','2013-12-29','09:40:00',1.03),('3355','2013-12-29','09:45:00',1.06),('3355','2013-12-29','09:50:00',1.03),('3355','2013-12-29','10:15:00',1.24),('3355','2013-12-29','10:20:00',1.35),('3355','2013-12-29','10:25:00',1.13),('3355','2013-12-29','10:30:00',1.4),('3355','2013-12-29','10:40:00',1.6),('3355','2013-12-28','09:40:00',1.02),('3355','2013-12-28','09:45:00',1.06),('3355','2013-12-28','09:50:00',1.1),('3355','2013-12-28','09:55:00',1.14),('3355','2013-12-28','10:00:00',1.18),('3355','2013-12-28','10:05:00',1.21),('3355','2013-12-28','10:10:00',1.24),('3355','2013-12-28','10:15:00',1.27),('3355','2013-12-28','10:20:00',1.29),('3355','2013-12-28','10:25:00',1.32),('3355','2013-12-28','10:30:00',1.35),('3355','2013-12-28','10:35:00',1.39),('3355','2013-12-28','10:40:00',1.4),('3355','2013-12-28','10:45:00',1.42),('3355','2013-12-28','10:50:00',1.44),('3355','2013-12-28','10:55:00',1.46),('3355','2013-12-28','11:00:00',1.48),('3355','2013-12-28','11:05:00',1.5),('3355','2013-12-28','11:10:00',1.52),('3355','2013-12-28','11:15:00',1.54),('3355','2013-12-28','11:20:00',1.55),('3355','2013-12-28','11:25:00',1.57),('3355','2013-12-28','11:30:00',1.57),('3355','2013-12-28','11:35:00',1.59),('3355','2013-12-28','11:40:00',1.6),('3355','2013-12-28','11:45:00',1.61),('3355','2013-12-28','11:50:00',1.62),('3355','2013-12-28','11:55:00',1.62),('3355','2013-12-28','12:00:00',1.62),('3355','2013-12-28','12:05:00',1.61),('3355','2013-12-28','12:10:00',1.6),('3355','2013-12-28','12:15:00',1.61),('3355','2013-12-28','12:20:00',1.61),('3355','2013-12-28','12:25:00',1.59),('3355','2013-12-28','12:30:00',1.58),('3355','2013-12-28','12:35:00',1.58),('3355','2013-12-28','12:40:00',1.58),('3355','2013-12-28','12:45:00',1.56),('3355','2013-12-28','12:50:00',1.56),('3355','2013-12-28','12:55:00',1.54),('3355','2013-12-28','13:00:00',1.54),('3355','2013-12-28','13:05:00',1.5),('3355','2013-12-28','13:10:00',1.34),('3355','2013-12-28','13:15:00',1.29),('3355','2013-12-28','13:20:00',1.29),('3355','2013-12-28','13:25:00',1.27),('3355','2013-12-28','13:30:00',1.28),('3355','2013-12-28','13:35:00',1.22),('3355','2013-12-28','13:40:00',1.02),('3355','2013-12-28','13:45:00',1.01),('3355','2013-12-28','13:55:00',1.18),('3355','2013-12-28','14:00:00',1.17),('3355','2013-12-28','14:05:00',1.16),('3355','2013-12-28','14:10:00',1.13),('3355','2013-12-28','14:15:00',1.02),('3355','2013-12-27','12:15:00',1.25),('3355','2013-12-27','12:45:00',1.23),('3355','2013-12-27','12:50:00',1.42),('3355','2013-12-27','12:55:00',1.5),('3355','2013-12-27','13:00:00',1.51),('3355','2013-12-27','13:05:00',1.35),('3355','2013-12-27','13:30:00',1.18),('3355','2013-12-27','13:35:00',1.41),('3355','2013-12-23','10:00:00',1.05),('3355','2013-12-23','10:05:00',1.13),('3355','2013-12-23','10:10:00',1.12),('3355','2013-12-23','10:15:00',1.08),('3355','2013-12-23','10:20:00',1.21),('3355','2013-12-23','10:25:00',1.2),('3355','2013-12-23','10:30:00',1.12),('3355','2013-12-22','09:40:00',1.18),('3355','2013-12-22','09:45:00',1.23),('3355','2013-12-22','09:50:00',1.32),('3355','2013-12-22','09:55:00',1.33),('3355','2013-12-22','10:00:00',1.33),('3355','2013-12-22','10:05:00',1.35),('3355','2013-12-22','10:10:00',1.37),('3355','2013-12-22','10:15:00',1.35),('3355','2013-12-22','10:20:00',1.31),('3355','2013-12-22','10:25:00',1.31),('3355','2013-12-22','10:30:00',1.38),('3355','2013-12-22','10:35:00',1.3),('3355','2013-12-22','10:40:00',1.21),('3355','2013-12-22','10:45:00',1.29),('3355','2013-12-22','10:50:00',1.28),('3355','2013-12-22','10:55:00',1.21),('3355','2013-12-22','11:00:00',1.06),('3355','2013-12-22','11:05:00',1.12),('3355','2013-12-22','11:10:00',1.48),('3355','2013-12-22','11:15:00',1.46),('3355','2013-12-22','11:20:00',1.31),('3355','2013-12-22','11:25:00',1.36),('3355','2013-12-22','11:30:00',1.29),('3355','2013-12-22','11:35:00',1.26),('3355','2013-12-22','11:40:00',1.36),('3355','2013-12-22','11:45:00',1.28),('3355','2013-12-22','12:35:00',1.02),('3355','2013-12-22','12:50:00',1.13),('3355','2013-12-22','12:55:00',1.44),('3355','2013-12-22','13:00:00',1.43),('3355','2013-12-22','13:05:00',1.58),('3355','2013-12-22','13:10:00',1.55),('3355','2013-12-22','13:15:00',1.11),('3355','2013-12-22','13:30:00',1.02),('3355','2013-12-21','09:45:00',1.01),('3355','2013-12-21','09:50:00',1.05),('3355','2013-12-21','09:55:00',1.09),('3355','2013-12-21','10:00:00',1.12),('3355','2013-12-21','10:05:00',1.15),('3355','2013-12-21','10:10:00',1.18),('3355','2013-12-21','10:15:00',1.22),('3355','2013-12-21','10:20:00',1.24),('3355','2013-12-21','10:25:00',1.27),('3355','2013-12-21','10:30:00',1.3),('3355','2013-12-21','10:35:00',1.33),('3355','2013-12-21','10:40:00',1.35),('3355','2013-12-21','10:45:00',1.37),('3355','2013-12-21','10:50:00',1.39),('3355','2013-12-21','10:55:00',1.41),('3355','2013-12-21','11:00:00',1.44),('3355','2013-12-21','11:05:00',1.46),('3355','2013-12-21','11:10:00',1.48),('3355','2013-12-21','11:15:00',1.5),('3355','2013-12-21','11:20:00',1.51),('3355','2013-12-21','11:25:00',1.53),('3355','2013-12-21','11:30:00',1.55),('3355','2013-12-21','11:35:00',1.56),('3355','2013-12-21','11:40:00',1.57),('3355','2013-12-21','11:45:00',1.58),('3355','2013-12-21','11:50:00',1.58),('3355','2013-12-21','11:55:00',1.6),('3355','2013-12-21','12:00:00',1.6),('3355','2013-12-21','12:05:00',1.6),('3355','2013-12-21','12:10:00',1.61),('3355','2013-12-21','12:15:00',1.6),('3355','2013-12-21','12:20:00',1.6),('3355','2013-12-21','12:25:00',1.6),('3355','2013-12-21','12:30:00',1.6),('3355','2013-12-21','12:35:00',1.59),('3355','2013-12-21','12:40:00',1.58),('3355','2013-12-21','12:45:00',1.57),('3355','2013-12-21','12:50:00',1.57),('3355','2013-12-21','12:55:00',1.56),('3355','2013-12-21','13:00:00',1.52),('3355','2013-12-21','13:05:00',1.32),('3355','2013-12-21','13:10:00',1.29),('3355','2013-12-21','13:15:00',1.25),('3355','2013-12-21','13:20:00',1.36),('3355','2013-12-21','13:25:00',1.35),('3355','2013-12-21','13:30:00',1.3),('3355','2013-12-21','13:35:00',1.22),('3355','2013-12-21','13:40:00',1.19),('3355','2013-12-21','13:45:00',1.24),('3355','2013-12-21','13:50:00',1.23),('3355','2013-12-21','13:55:00',1.23),('3355','2013-12-21','14:00:00',1.23),('3355','2013-12-21','14:05:00',1.18),('3355','2013-12-21','14:10:00',1.09),('3355','2013-12-21','14:15:00',1.05),('3355','2013-12-21','14:20:00',1.06),('3355','2013-12-20','09:50:00',1.01),('3355','2013-12-20','09:55:00',1.03),('3355','2013-12-20','10:00:00',1.06),('3355','2013-12-20','10:05:00',1.11),('3355','2013-12-20','10:10:00',1.14),('3355','2013-12-20','10:15:00',1.15),('3355','2013-12-20','10:20:00',1.18),('3355','2013-12-20','10:25:00',1.22),('3355','2013-12-20','10:30:00',1.23),('3355','2013-12-20','10:35:00',1.25),('3355','2013-12-20','10:40:00',1.29),('3355','2013-12-20','10:45:00',1.31),('3355','2013-12-20','10:50:00',1.32),('3355','2013-12-20','10:55:00',1.35),('3355','2013-12-20','11:00:00',1.37),('3355','2013-12-20','11:05:00',1.39),('3355','2013-12-20','11:10:00',1.39),('3355','2013-12-20','11:15:00',1.41),('3355','2013-12-20','11:20:00',1.43),('3355','2013-12-20','11:25:00',1.45),('3355','2013-12-20','11:30:00',1.46),('3355','2013-12-20','11:35:00',1.47),('3355','2013-12-20','11:40:00',1.48),('3355','2013-12-20','11:45:00',1.49),('3355','2013-12-20','11:50:00',1.48),('3355','2013-12-20','11:55:00',1.5),('3355','2013-12-20','12:00:00',1.5),('3355','2013-12-20','12:05:00',1.49),('3355','2013-12-20','12:10:00',1.5),('3355','2013-12-20','12:15:00',1.5),('3355','2013-12-20','12:20:00',1.49),('3355','2013-12-20','12:25:00',1.48),('3355','2013-12-20','12:30:00',1.5),('3355','2013-12-20','12:35:00',1.48),('3355','2013-12-20','12:40:00',1.46),('3355','2013-12-20','12:45:00',1.46),('3355','2013-12-20','12:50:00',1.43),('3355','2013-12-20','12:55:00',1.41),('3355','2013-12-20','13:00:00',1.39),('3355','2013-12-20','13:05:00',1.24),('3355','2013-12-20','13:10:00',1.21),('3355','2013-12-20','13:15:00',1.13),('3355','2013-12-20','13:20:00',1.12),('3355','2013-12-20','13:25:00',1.17),('3355','2013-12-20','13:30:00',1.12),('3355','2013-12-20','13:35:00',1.04),('3355','2013-12-20','13:50:00',1.06),('3355','2013-12-20','13:55:00',1.03),('3355','2013-12-20','14:00:00',1.02),('3355','2013-12-19','09:55:00',1.25),('3355','2013-12-19','10:00:00',1.17),('3355','2013-12-19','10:05:00',1.11),('3355','2013-12-19','10:10:00',1.16),('3355','2013-12-19','10:15:00',1.18),('3355','2013-12-19','10:50:00',1.45),('3355','2013-12-19','10:55:00',1.04),('3355','2013-12-18','09:45:00',1.04),('3355','2013-12-18','09:50:00',1.08),('3355','2013-12-18','09:55:00',1.12),('3355','2013-12-18','10:00:00',1.15),('3355','2013-12-18','10:05:00',1.18),('3355','2013-12-18','10:10:00',1.22),('3355','2013-12-18','10:15:00',1.26),('3355','2013-12-18','10:20:00',1.29),('3355','2013-12-18','10:25:00',1.32),('3355','2013-12-18','10:30:00',1.34),('3355','2013-12-18','10:35:00',1.37),('3355','2013-12-18','10:40:00',1.38),('3355','2013-12-18','10:45:00',1.4),('3355','2013-12-18','10:50:00',1.41),('3355','2013-12-18','10:55:00',1.43),('3355','2013-12-18','11:00:00',1.45),('3355','2013-12-18','11:05:00',1.47),('3355','2013-12-18','11:10:00',1.49),('3355','2013-12-18','11:15:00',1.5),('3355','2013-12-18','11:20:00',1.5),('3355','2013-12-18','11:25:00',1.51),('3355','2013-12-18','11:30:00',1.51),('3355','2013-12-18','11:35:00',1.53),('3355','2013-12-18','11:40:00',1.54),('3355','2013-12-18','11:45:00',1.54),('3355','2013-12-18','11:50:00',1.55),('3355','2013-12-18','11:55:00',1.55),('3355','2013-12-18','12:00:00',1.55),('3355','2013-12-18','12:05:00',1.55),('3355','2013-12-18','12:10:00',1.55),('3355','2013-12-18','12:15:00',1.55),('3355','2013-12-18','12:20:00',1.56),('3355','2013-12-18','12:25:00',1.55),('3355','2013-12-18','12:30:00',1.56),('3355','2013-12-18','12:35:00',1.55),('3355','2013-12-18','12:40:00',1.54),('3355','2013-12-18','12:45:00',1.51),('3355','2013-12-18','12:50:00',1.51),('3355','2013-12-18','12:55:00',1.52),('3355','2013-12-18','13:00:00',1.45),('3355','2013-12-18','13:05:00',1.29),('3355','2013-12-18','13:10:00',1.23),('3355','2013-12-18','13:15:00',1.27),('3355','2013-12-18','13:20:00',1.2),('3355','2013-12-18','13:25:00',1.29),('3355','2013-12-18','13:30:00',1.23),('3355','2013-12-18','13:35:00',1.07),('3355','2013-12-18','13:40:00',1.04),('3355','2013-12-18','13:50:00',1.15),('3355','2013-12-18','13:55:00',1.13),('3355','2013-12-18','14:00:00',1.16),('3355','2013-12-18','14:05:00',1.1),('3355','2014-04-22','09:00:00',1.03),('3355','2014-04-22','09:05:00',1.16),('3355','2014-04-22','09:10:00',1.12),('3355','2014-04-22','09:15:00',1.08),('3355','2014-04-22','09:20:00',1.21),('3355','2014-04-22','09:25:00',1.31),('3355','2014-04-22','09:30:00',1.35),('3355','2014-04-22','09:35:00',1.44),('3355','2014-04-22','09:40:00',1.4),('3355','2014-04-22','09:45:00',1.5),('3355','2014-04-22','09:50:00',1.32),('3355','2014-04-22','10:15:00',1.13),('3355','2014-04-22','10:20:00',1.64),('3355','2014-04-22','10:25:00',1.16),('3355','2014-04-22','10:30:00',1.81),('3355','2014-04-22','10:35:00',1.96),('3355','2014-04-22','10:40:00',1.8),('3355','2014-04-22','10:45:00',1.86),('3355','2014-04-22','10:50:00',1.97),('3355','2014-04-22','10:55:00',1.65),('3355','2014-04-22','11:00:00',1.05),('3355','2014-04-22','11:05:00',1.3),('3355','2014-04-22','13:20:00',1.26),('3355','2014-04-22','13:25:00',1.44),('3355','2014-04-22','13:30:00',1.62),('3355','2014-04-22','13:35:00',1.42),('3355','2014-04-22','13:40:00',1.82),('3355','2014-04-22','13:45:00',1.83),('3355','2014-04-22','13:50:00',1.58),('3355','2014-04-22','14:10:00',1.81),('3355','2014-04-22','14:15:00',1.89),('3355','2014-04-22','14:20:00',2.1),('3355','2014-04-22','14:25:00',1.5),('3355','2014-04-22','14:30:00',1.1),('3355','2014-04-22','14:35:00',1.3),('3355','2014-04-22','14:40:00',1.76),('3355','2014-04-22','14:45:00',2.26),('3355','2014-04-22','14:50:00',1.78),('3355','2014-04-22','14:55:00',1.54),('3355','2014-04-22','15:35:00',1.44),('3355','2014-04-22','15:40:00',1.31),('3355','2014-04-22','15:45:00',1),('3355','2014-04-22','15:50:00',1.22),('3355','2014-04-22','16:00:00',1.17),('3355','2013-12-17','09:35:00',1.03),('3355','2013-12-17','09:40:00',1.06),('3355','2013-12-17','09:45:00',1.1),('3355','2013-12-17','09:50:00',1.14),('3355','2013-12-17','09:55:00',1.18),('3355','2013-12-17','10:00:00',1.21),('3355','2013-12-17','10:05:00',1.24),('3355','2013-12-17','10:10:00',1.28),('3355','2013-12-17','10:15:00',1.31),('3355','2013-12-17','10:20:00',1.34),('3355','2013-12-17','10:25:00',1.37),('3355','2013-12-17','10:30:00',1.41),('3355','2013-12-17','10:35:00',1.42),('3355','2013-12-17','10:40:00',1.44),('3355','2013-12-17','10:45:00',1.47),('3355','2013-12-17','10:50:00',1.48),('3355','2013-12-17','10:55:00',1.5),('3355','2013-12-17','11:00:00',1.52),('3355','2013-12-17','11:05:00',1.54),('3355','2013-12-17','11:10:00',1.55),('3355','2013-12-17','11:15:00',1.56),('3355','2013-12-17','11:20:00',1.58),('3355','2013-12-17','11:25:00',1.59),('3355','2013-12-17','11:30:00',1.6),('3355','2013-12-17','11:35:00',1.6),('3355','2013-12-17','11:40:00',1.61),('3355','2013-12-17','11:45:00',1.63),('3355','2013-12-17','11:50:00',1.65),('3355','2013-12-17','11:55:00',1.63),('3355','2013-12-17','12:00:00',1.64),('3355','2013-12-17','12:05:00',1.65),('3355','2013-12-17','12:10:00',1.64),('3355','2013-12-17','12:15:00',1.63),('3355','2013-12-17','12:20:00',1.64),('3355','2013-12-17','12:25:00',1.63),('3355','2013-12-17','12:30:00',1.63),('3355','2013-12-17','12:35:00',1.63),('3355','2013-12-17','12:40:00',1.63),('3355','2013-12-17','12:45:00',1.62),('3355','2013-12-17','12:50:00',1.6),('3355','2013-12-17','12:55:00',1.59),('3355','2013-12-17','13:00:00',1.51),('3355','2013-12-17','13:05:00',1.34),('3355','2013-12-17','13:10:00',1.28),('3355','2013-12-17','13:15:00',1.19),('3355','2013-12-17','13:20:00',1.25),('3355','2013-12-17','13:25:00',1.34),('3355','2013-12-17','13:30:00',1.31),('3355','2013-12-17','13:35:00',1.18),('3355','2013-12-17','13:40:00',1.06),('3355','2013-12-17','13:45:00',1.07),('3355','2013-12-17','13:50:00',1.26),('3355','2013-12-17','13:55:00',1.28),('3355','2013-12-17','14:00:00',1.28),('3355','2013-12-17','14:05:00',1.22),('3355','2013-12-17','14:10:00',1.05),('3355','2013-12-16','09:35:00',1.02),('3355','2013-12-16','09:40:00',1.06),('3355','2013-12-16','09:45:00',1.1),('3355','2013-12-16','09:50:00',1.13),('3355','2013-12-16','09:55:00',1.16),('3355','2013-12-16','10:00:00',1.19),('3355','2013-12-16','10:05:00',1.22),('3355','2013-12-16','10:10:00',1.25),('3355','2013-12-16','10:15:00',1.28),('3355','2013-12-16','10:20:00',1.29),('3355','2013-12-16','10:25:00',1.31),('3355','2013-12-16','10:30:00',1.34),('3355','2013-12-16','10:35:00',1.35),('3355','2013-12-16','10:40:00',1.38),('3355','2013-12-16','10:45:00',1.4),('3355','2013-12-16','10:50:00',1.42),('3355','2013-12-16','10:55:00',1.45),('3355','2013-12-16','11:00:00',1.47),('3355','2013-12-16','11:05:00',1.49),('3355','2013-12-16','11:10:00',1.49),('3355','2013-12-16','11:15:00',1.5),('3355','2013-12-16','11:20:00',1.51),('3355','2013-12-16','11:25:00',1.52),('3355','2013-12-16','11:30:00',1.54),('3355','2013-12-16','11:35:00',1.55),('3355','2013-12-16','11:40:00',1.57),('3355','2013-12-16','11:45:00',1.57),('3355','2013-12-16','11:50:00',1.58),('3355','2013-12-16','11:55:00',1.59),('3355','2013-12-16','12:00:00',1.62),('3355','2013-12-16','12:05:00',1.62),('3355','2013-12-16','12:10:00',1.62),('3355','2013-12-16','12:15:00',1.63),('3355','2013-12-16','12:20:00',1.65),('3355','2013-12-16','12:25:00',1.64),('3355','2013-12-16','12:30:00',1.63),('3355','2013-12-16','12:35:00',1.61),('3355','2013-12-16','12:40:00',1.61),('3355','2013-12-16','12:45:00',1.6),('3355','2013-12-16','12:50:00',1.6),('3355','2013-12-16','12:55:00',1.59),('3355','2013-12-16','13:00:00',1.52),('3355','2013-12-16','13:05:00',1.42),('3355','2013-12-16','13:10:00',1.31),('3355','2013-12-16','13:15:00',1.22),('3355','2013-12-16','13:20:00',1.26),('3355','2013-12-16','13:25:00',1.32),('3355','2013-12-16','13:30:00',1.29),('3355','2013-12-16','13:35:00',1.13),('3355','2013-12-16','13:45:00',1.1),('3355','2013-12-16','13:50:00',1.25),('3355','2013-12-16','13:55:00',1.26),('3355','2013-12-16','14:00:00',1.24),('3355','2013-12-16','14:05:00',1.19),('3355','2013-12-16','14:10:00',1.01),('3355','2013-12-16','14:20:00',1.01),('3355','2013-12-14','09:40:00',1.02),('3355','2013-12-14','09:45:00',1.05),('3355','2013-12-14','09:50:00',1.09),('3355','2013-12-14','09:55:00',1.12),('3355','2013-12-14','10:00:00',1.15),('3355','2013-12-14','10:05:00',1.18),('3355','2013-12-14','10:10:00',1.21),('3355','2013-12-14','10:15:00',1.24),('3355','2013-12-14','10:20:00',1.28),('3355','2013-12-14','10:25:00',1.3),('3355','2013-12-14','10:30:00',1.31),('3355','2013-12-14','10:35:00',1.34),('3355','2013-12-14','10:40:00',1.36),('3355','2013-12-14','10:45:00',1.37),('3355','2013-12-14','10:50:00',1.38),('3355','2013-12-14','10:55:00',1.39),('3355','2013-12-14','11:00:00',1.41),('3355','2013-12-14','11:05:00',1.43),('3355','2013-12-14','11:10:00',1.44),('3355','2013-12-14','11:15:00',1.48),('3355','2013-12-14','11:20:00',1.48),('3355','2013-12-14','11:25:00',1.51),('3355','2013-12-14','11:30:00',1.51),('3355','2013-12-14','11:35:00',1.5),('3355','2013-12-14','11:40:00',1.5),('3355','2013-12-14','11:45:00',1.49),('3355','2013-12-14','11:50:00',1.48),('3355','2013-12-14','11:55:00',1.49),('3355','2013-12-14','12:00:00',1.47),('3355','2013-12-14','12:05:00',1.48),('3355','2013-12-14','12:10:00',1.46),('3355','2013-12-14','12:15:00',1.49),('3355','2013-12-14','12:20:00',1.49),('3355','2013-12-14','12:25:00',1.47),('3355','2013-12-14','12:30:00',1.42),('3355','2013-12-14','12:35:00',1.46),('3355','2013-12-14','12:40:00',1.46),('3355','2013-12-14','12:45:00',1.44),('3355','2013-12-14','12:50:00',1.49),('3355','2013-12-14','12:55:00',1.46),('3355','2013-12-14','13:00:00',1.39),('3355','2013-12-14','13:05:00',1.25),('3355','2013-12-14','13:10:00',1.25),('3355','2013-12-14','13:15:00',1.14),('3355','2013-12-14','13:20:00',1.16),('3355','2013-12-14','13:25:00',1.27),('3355','2013-12-14','13:30:00',1.23),('3355','2013-12-14','13:35:00',1.07),('3355','2013-12-14','13:45:00',1.21),('3355','2013-12-14','13:50:00',1.22),('3355','2013-12-14','13:55:00',1.21),('3355','2013-12-14','14:00:00',1.22),('3355','2013-12-14','14:05:00',1.16),('3355','2013-12-13','09:55:00',1.02),('3355','2013-12-13','10:00:00',1.05),('3355','2013-12-13','10:05:00',1.09),('3355','2013-12-13','10:10:00',1.11),('3355','2013-12-13','10:15:00',1.14),('3355','2013-12-13','10:20:00',1.16),('3355','2013-12-13','10:25:00',1.18),('3355','2013-12-13','10:30:00',1.22),('3355','2013-12-13','10:35:00',1.24),('3355','2013-12-13','10:40:00',1.26),('3355','2013-12-13','10:45:00',1.28),('3355','2013-12-13','10:50:00',1.31),('3355','2013-12-13','10:55:00',1.33),('3355','2013-12-13','11:00:00',1.34),('3355','2013-12-13','11:05:00',1.36),('3355','2013-12-13','11:10:00',1.36),('3355','2013-12-13','11:15:00',1.4),('3355','2013-12-13','11:20:00',1.41),('3355','2013-12-13','11:25:00',1.42),('3355','2013-12-13','11:30:00',1.43),('3355','2013-12-13','11:35:00',1.43),('3355','2013-12-13','11:40:00',1.46),('3355','2013-12-13','11:45:00',1.44),('3355','2013-12-13','11:50:00',1.44),('3355','2013-12-13','11:55:00',1.46),('3355','2013-12-13','12:00:00',1.45),('3355','2013-12-13','12:05:00',1.46),('3355','2013-12-13','12:10:00',1.46),('3355','2013-12-13','12:15:00',1.43),('3355','2013-12-13','12:20:00',1.42),('3355','2013-12-13','12:25:00',1.44),('3355','2013-12-13','12:30:00',1.43),('3355','2013-12-13','12:35:00',1.45),('3355','2013-12-13','12:40:00',1.4),('3355','2013-12-13','12:45:00',1.48),('3355','2013-12-13','12:50:00',1.44),('3355','2013-12-13','12:55:00',1.41),('3355','2013-12-13','13:00:00',1.37),('3355','2013-12-13','13:05:00',1.25),('3355','2013-12-13','13:10:00',1.22),('3355','2013-12-13','13:15:00',1.11),('3355','2013-12-13','13:20:00',1.07),('3355','2013-12-13','13:25:00',1.22),('3355','2013-12-13','13:30:00',1.2),('3355','2013-12-13','13:35:00',1.08),('3355','2013-12-13','13:45:00',1.14),('3355','2013-12-13','13:50:00',1.17),('3355','2013-12-13','13:55:00',1.17),('3355','2013-12-13','14:00:00',1.19),('3355','2013-12-13','14:05:00',1.15),('3355','2013-12-12','09:40:00',1.01),('3355','2013-12-12','09:45:00',1.04),('3355','2013-12-12','09:50:00',1.08),('3355','2013-12-12','09:55:00',1.11),('3355','2013-12-12','10:00:00',1.15),('3355','2013-12-12','10:05:00',1.18),('3355','2013-12-12','10:10:00',1.22),('3355','2013-12-12','10:15:00',1.24),('3355','2013-12-12','10:20:00',1.27),('3355','2013-12-12','10:25:00',1.29),('3355','2013-12-12','10:30:00',1.31),('3355','2013-12-12','10:35:00',1.34),('3355','2013-12-12','10:40:00',1.36),('3355','2013-12-12','10:45:00',1.38),('3355','2013-12-12','10:50:00',1.4),('3355','2013-12-12','10:55:00',1.41),('3355','2013-12-12','11:00:00',1.43),('3355','2013-12-12','11:05:00',1.43),('3355','2013-12-12','11:10:00',1.43),('3355','2013-12-12','11:15:00',1.45),('3355','2013-12-12','11:20:00',1.46),('3355','2013-12-12','11:25:00',1.47),('3355','2013-12-12','11:30:00',1.47),('3355','2013-12-12','11:35:00',1.49),('3355','2013-12-12','11:40:00',1.51),('3355','2013-12-12','11:45:00',1.51),('3355','2013-12-12','11:50:00',1.52),('3355','2013-12-12','11:55:00',1.52),('3355','2013-12-12','12:00:00',1.5),('3355','2013-12-12','12:05:00',1.52),('3355','2013-12-12','12:10:00',1.53),('3355','2013-12-12','12:15:00',1.53),('3355','2013-12-12','12:20:00',1.54),('3355','2013-12-12','12:25:00',1.52),('3355','2013-12-12','12:30:00',1.53),('3355','2013-12-12','12:35:00',1.52),('3355','2013-12-12','12:40:00',1.49),('3355','2013-12-12','12:45:00',1.47),('3355','2013-12-12','12:50:00',1.5),('3355','2013-12-12','12:55:00',1.47),('3355','2013-12-12','13:00:00',1.42),('3355','2013-12-12','13:05:00',1.27),('3355','2013-12-12','13:10:00',1.2),('3355','2013-12-12','13:15:00',1.12),('3355','2013-12-12','13:20:00',1.21),('3355','2013-12-12','13:25:00',1.27),('3355','2013-12-12','13:30:00',1.15),('3355','2013-12-12','13:35:00',1.04),('3355','2013-12-12','13:40:00',1.19),('3355','2013-12-12','13:45:00',1.18),('3355','2013-12-12','13:50:00',1.17),('3355','2013-12-12','13:55:00',1.19),('3355','2013-12-12','14:00:00',1.19),('3355','2013-12-12','14:05:00',1.14),('3355','2013-12-11','09:40:00',1.04),('3355','2013-12-11','09:45:00',1.08),('3355','2013-12-11','09:50:00',1.12),('3355','2013-12-11','09:55:00',1.15),('3355','2013-12-11','10:00:00',1.18),('3355','2013-12-11','10:05:00',1.22),('3355','2013-12-11','10:10:00',1.25),('3355','2013-12-11','10:15:00',1.28),('3355','2013-12-11','10:20:00',1.31),('3355','2013-12-11','10:25:00',1.34),('3355','2013-12-11','10:30:00',1.38),('3355','2013-12-11','10:35:00',1.42),('3355','2013-12-11','10:40:00',1.43),('3355','2013-12-11','10:45:00',1.43),('3355','2013-12-11','10:50:00',1.44),('3355','2013-12-11','10:55:00',1.45),('3355','2013-12-11','11:00:00',1.5),('3355','2013-12-11','11:05:00',1.52),('3355','2013-12-11','11:10:00',1.54),('3355','2013-12-11','11:15:00',1.53),('3355','2013-12-11','11:20:00',1.55),('3355','2013-12-11','11:25:00',1.52),('3355','2013-12-11','11:30:00',1.51),('3355','2013-12-11','11:35:00',1.55),('3355','2013-12-11','11:40:00',1.58),('3355','2013-12-11','11:45:00',1.58),('3355','2013-12-11','11:50:00',1.6),('3355','2013-12-11','11:55:00',1.6),('3355','2013-12-11','12:00:00',1.61),('3355','2013-12-11','12:05:00',1.62),('3355','2013-12-11','12:10:00',1.61),('3355','2013-12-11','12:15:00',1.61),('3355','2013-12-11','12:20:00',1.6),('3355','2013-12-11','12:25:00',1.56),('3355','2013-12-11','12:30:00',1.55),('3355','2013-12-11','12:35:00',1.56),('3355','2013-12-11','12:40:00',1.56),('3355','2013-12-11','12:45:00',1.57),('3355','2013-12-11','12:50:00',1.54),('3355','2013-12-11','12:55:00',1.55),('3355','2013-12-11','13:00:00',1.55),('3355','2013-12-11','13:05:00',1.4),('3355','2013-12-11','13:10:00',1.3),('3355','2013-12-11','13:15:00',1.24),('3355','2013-12-11','13:20:00',1.23),('3355','2013-12-11','13:25:00',1.33),('3355','2013-12-11','13:30:00',1.23),('3355','2013-12-11','13:35:00',1.18),('3355','2013-12-11','13:40:00',1.22),('3355','2013-12-11','13:45:00',1.24),('3355','2013-12-11','13:50:00',1.24),('3355','2013-12-11','13:55:00',1.25),('3355','2013-12-11','14:00:00',1.25),('3355','2013-12-11','14:05:00',1.21),('3355','2013-12-11','14:10:00',1.01),('3355','2013-12-10','09:35:00',1.02),('3355','2013-12-10','09:40:00',1.06),('3355','2013-12-10','09:45:00',1.09),('3355','2013-12-10','09:50:00',1.14),('3355','2013-12-10','09:55:00',1.18),('3355','2013-12-10','10:00:00',1.22),('3355','2013-12-10','10:05:00',1.25),('3355','2013-12-10','10:10:00',1.28),('3355','2013-12-10','10:15:00',1.3),('3355','2013-12-10','10:20:00',1.33),('3355','2013-12-10','10:25:00',1.35),('3355','2013-12-10','10:30:00',1.38),('3355','2013-12-10','10:35:00',1.4),('3355','2013-12-10','10:40:00',1.41),('3355','2013-12-10','10:45:00',1.44),('3355','2013-12-10','10:50:00',1.48),('3355','2013-12-10','10:55:00',1.49),('3355','2013-12-10','11:00:00',1.51),('3355','2013-12-10','11:05:00',1.53),('3355','2013-12-10','11:10:00',1.54),('3355','2013-12-10','11:15:00',1.56),('3355','2013-12-10','11:20:00',1.58),('3355','2013-12-10','11:25:00',1.6),('3355','2013-12-10','11:30:00',1.61),('3355','2013-12-10','11:35:00',1.62),('3355','2013-12-10','11:40:00',1.63),('3355','2013-12-10','11:45:00',1.62),('3355','2013-12-10','11:50:00',1.63),('3355','2013-12-10','11:55:00',1.63),('3355','2013-12-10','12:00:00',1.64),('3355','2013-12-10','12:05:00',1.64),('3355','2013-12-10','12:10:00',1.62),('3355','2013-12-10','12:15:00',1.62),('3355','2013-12-10','12:20:00',1.61),('3355','2013-12-10','12:25:00',1.6),('3355','2013-12-10','12:30:00',1.59),('3355','2013-12-10','12:35:00',1.58),('3355','2013-12-10','12:40:00',1.56),('3355','2013-12-10','12:45:00',1.55),('3355','2013-12-10','12:50:00',1.53),('3355','2013-12-10','12:55:00',1.5),('3355','2013-12-10','13:00:00',1.49),('3355','2013-12-10','13:05:00',1.39),('3355','2013-12-10','13:10:00',1.27),('3355','2013-12-10','13:15:00',1.19),('3355','2013-12-10','13:20:00',1.22),('3355','2013-12-10','13:25:00',1.3),('3355','2013-12-10','13:30:00',1.25),('3355','2013-12-10','13:35:00',1.31),('3355','2013-12-10','13:40:00',1.21),('3355','2013-12-10','13:45:00',1.27),('3355','2013-12-10','13:50:00',1.28),('3355','2013-12-10','13:55:00',1.3),('3355','2013-12-10','14:00:00',1.3),('3355','2013-12-10','14:05:00',1.21),('3355','2013-12-10','14:10:00',1.04),('3355','2013-12-10','14:15:00',1),('3355','2013-12-10','14:20:00',1.07),('3355','2013-12-10','14:25:00',1.06),('3355','2013-12-09','09:40:00',1.04),('3355','2013-12-09','09:45:00',1.07),('3355','2013-12-09','09:50:00',1.1),('3355','2013-12-09','09:55:00',1.14),('3355','2013-12-09','10:00:00',1.18),('3355','2013-12-09','10:05:00',1.23),('3355','2013-12-09','10:10:00',1.44),('3355','2013-12-09','10:15:00',1.51),('3355','2013-12-09','10:20:00',1.66),('3355','2013-12-09','10:25:00',1.39),('3355','2013-12-09','12:30:00',1.14),('3355','2013-12-09','12:45:00',1),('3355','2013-12-09','12:55:00',1.06),('3355','2013-12-09','13:00:00',1.38),('3355','2013-12-09','13:05:00',1.22),('3355','2013-12-09','13:15:00',1.07),('3355','2014-04-21','10:05:00',1.25),('3355','2014-04-21','10:10:00',1.8),('3355','2014-04-21','10:15:00',1.77),('3355','2014-04-21','10:20:00',1.73),('3355','2014-04-21','10:25:00',1.75),('3355','2014-04-21','10:30:00',1.76),('3355','2014-04-21','10:35:00',1.77),('3355','2014-04-21','10:40:00',1.81),('3355','2014-04-21','10:45:00',1.83),('3355','2014-04-21','10:50:00',1.86),('3355','2014-04-21','10:55:00',1.88),('3355','2014-04-21','11:00:00',1.9),('3355','2014-04-21','11:05:00',1.93),('3355','2014-04-21','11:10:00',1.95),('3355','2014-04-21','11:15:00',1.97),('3355','2014-04-21','11:20:00',2),('3355','2014-04-21','11:25:00',2.02),('3355','2014-04-21','11:30:00',2.03),('3355','2014-04-21','11:35:00',2.06),('3355','2014-04-21','11:40:00',2.09),('3355','2014-04-21','11:45:00',2.1),('3355','2014-04-21','11:50:00',2.12),('3355','2014-04-21','11:55:00',2.12),('3355','2014-04-21','12:00:00',2.14),('3355','2014-04-21','12:05:00',2.16),('3355','2014-04-21','12:10:00',2.18),('3355','2014-04-21','12:15:00',2.2),('3355','2014-04-21','12:20:00',2.22),('3355','2014-04-21','12:25:00',2.23),('3355','2014-04-21','12:30:00',2.24),('3355','2014-04-21','12:35:00',2.25),('3355','2014-04-21','12:40:00',2.25),('3355','2014-04-21','12:45:00',2.27),('3355','2014-04-21','12:50:00',2.28),('3355','2014-04-21','12:55:00',2.29),('3355','2014-04-21','13:00:00',2.28),('3355','2014-04-21','13:05:00',2.28),('3355','2014-04-21','13:10:00',2.3),('3355','2014-04-21','13:15:00',2.28),('3355','2014-04-21','13:20:00',2.28),('3355','2014-04-21','13:25:00',2.28),('3355','2014-04-21','13:30:00',2.29),('3355','2014-04-21','13:35:00',2.29),('3355','2014-04-21','13:40:00',2.29),('3355','2014-04-21','13:45:00',2.31),('3355','2014-04-21','13:50:00',2.32),('3355','2014-04-21','13:55:00',2.33),('3355','2014-04-21','14:00:00',2.32),('3355','2014-04-21','14:05:00',2.33),('3355','2014-04-21','14:10:00',2.32),('3355','2014-04-21','14:15:00',2.3),('3355','2014-04-21','14:20:00',2.29),('3355','2014-04-21','14:25:00',2.28),('3355','2014-04-21','14:30:00',2.27),('3355','2014-04-21','14:35:00',2.26),('3355','2014-04-21','14:40:00',2.24),('3355','2014-04-21','14:45:00',2.21),('3355','2014-04-21','14:50:00',2.2),('3355','2014-04-21','14:55:00',2.19),('3355','2014-04-21','15:00:00',2.18),('3355','2014-04-21','15:05:00',2.17),('3355','2014-04-21','15:10:00',2.12),('3355','2014-04-21','15:15:00',2.1),('3355','2014-04-21','15:20:00',2.08),('3355','2014-04-21','15:25:00',2.06),('3355','2014-04-21','15:30:00',2.03),('3355','2014-04-21','15:35:00',2),('3355','2014-04-21','15:40:00',1.96),('3355','2014-04-21','15:45:00',1.94),('3355','2014-04-21','15:50:00',1.91),('3355','2014-04-21','15:55:00',1.88),('3355','2014-04-21','16:00:00',1.86),('3355','2014-04-21','16:05:00',1.83),('3355','2014-04-21','16:10:00',1.74),('3355','2014-04-21','16:15:00',1.33),('3355','2014-04-21','16:20:00',1.77),('3355','2014-04-21','16:25:00',1.7),('3355','2014-04-21','16:30:00',1.6),('3355','2014-04-21','16:35:00',1.63),('3355','2014-04-21','16:40:00',1.6),('3355','2014-04-21','16:45:00',1.56),('3355','2014-04-21','16:50:00',1.52),('3355','2014-04-21','16:55:00',1.47),('3355','2014-04-21','17:00:00',1.42),('3355','2014-04-21','17:05:00',1.38),('3355','2014-04-21','17:10:00',1.34),('3355','2014-04-21','17:15:00',1.29),('3355','2014-04-21','17:20:00',1.25),('3355','2014-04-21','17:25:00',1.21),('3355','2014-04-21','17:30:00',1.16),('3355','2014-04-21','17:35:00',1.11),('3355','2014-04-21','17:40:00',1.01),('3355','2014-04-21','17:45:00',1.02),('3355','2013-12-07','09:35:00',1.04),('3355','2013-12-07','09:40:00',1.08),('3355','2013-12-07','09:45:00',1.1),('3355','2013-12-07','09:50:00',1.13),('3355','2013-12-07','09:55:00',1.16),('3355','2013-12-07','10:00:00',1.18),('3355','2013-12-07','10:05:00',1.21),('3355','2013-12-07','10:10:00',1.23),('3355','2013-12-07','10:15:00',1.26),('3355','2013-12-07','10:20:00',1.28),('3355','2013-12-07','10:25:00',1.31),('3355','2013-12-07','10:30:00',1.33),('3355','2013-12-07','10:35:00',1.38),('3355','2013-12-07','10:40:00',1.4),('3355','2013-12-07','10:45:00',1.41),('3355','2013-12-07','10:50:00',1.4),('3355','2013-12-07','10:55:00',1.41),('3355','2013-12-07','11:00:00',1.43),('3355','2013-12-07','11:05:00',1.44),('3355','2013-12-07','11:10:00',1.46),('3355','2013-12-07','11:15:00',1.47),('3355','2013-12-07','11:20:00',1.49),('3355','2013-12-07','11:25:00',1.49),('3355','2013-12-07','11:30:00',1.5),('3355','2013-12-07','11:35:00',1.51),('3355','2013-12-07','11:40:00',1.51),('3355','2013-12-07','11:45:00',1.5),('3355','2013-12-07','11:50:00',1.51),('3355','2013-12-07','11:55:00',1.51),('3355','2013-12-07','12:00:00',1.51),('3355','2013-12-07','12:05:00',1.51),('3355','2013-12-07','12:10:00',1.52),('3355','2013-12-07','12:15:00',1.51),('3355','2013-12-07','12:20:00',1.51),('3355','2013-12-07','12:25:00',1.51),('3355','2013-12-07','12:30:00',1.5),('3355','2013-12-07','12:35:00',1.51),('3355','2013-12-07','12:40:00',1.49),('3355','2013-12-07','12:45:00',1.48),('3355','2013-12-07','12:50:00',1.48),('3355','2013-12-07','12:55:00',1.46),('3355','2013-12-07','13:00:00',1.48),('3355','2013-12-07','13:05:00',1.46),('3355','2013-12-07','13:10:00',1.38),('3355','2013-12-07','13:15:00',1.35),('3355','2013-12-07','13:20:00',1.26),('3355','2013-12-07','13:25:00',1.3),('3355','2013-12-07','13:30:00',1.24),('3355','2013-12-07','13:35:00',1.28),('3355','2013-12-07','13:40:00',1.25),('3355','2013-12-07','13:45:00',1.24),('3355','2013-12-07','13:50:00',1.26),('3355','2013-12-07','13:55:00',1.25),('3355','2013-12-07','14:00:00',1.25),('3355','2013-12-07','14:05:00',1.24),('3355','2013-12-07','14:10:00',1.06),('3355','2013-12-06','11:50:00',1.12),('3355','2013-12-06','11:55:00',1.17),('3355','2013-12-06','12:00:00',1.1),('3355','2013-12-06','12:20:00',1.33),('3355','2013-12-06','12:40:00',1.15),('3355','2013-12-05','09:30:00',1.04),('3355','2013-12-05','09:35:00',1.07),('3355','2013-12-05','09:40:00',1.11),('3355','2013-12-05','09:45:00',1.14),('3355','2013-12-05','09:50:00',1.17),('3355','2013-12-05','09:55:00',1.21),('3355','2013-12-05','10:00:00',1.24),('3355','2013-12-05','10:05:00',1.28),('3355','2013-12-05','10:10:00',1.31),('3355','2013-12-05','10:15:00',1.34),('3355','2013-12-05','10:20:00',1.36),('3355','2013-12-05','10:25:00',1.38),('3355','2013-12-05','10:30:00',1.4),('3355','2013-12-05','10:35:00',1.43),('3355','2013-12-05','10:40:00',1.44),('3355','2013-12-05','10:45:00',1.47),('3355','2013-12-05','10:50:00',1.48),('3355','2013-12-05','10:55:00',1.49),('3355','2013-12-05','11:00:00',1.51),('3355','2013-12-05','11:05:00',1.53),('3355','2013-12-05','11:10:00',1.52),('3355','2013-12-05','11:15:00',1.55),('3355','2013-12-05','11:20:00',1.55),('3355','2013-12-05','11:25:00',1.56),('3355','2013-12-05','11:30:00',1.55),('3355','2013-12-05','11:35:00',1.58),('3355','2013-12-05','11:40:00',1.58),('3355','2013-12-05','11:45:00',1.58),('3355','2013-12-05','11:50:00',1.59),('3355','2013-12-05','11:55:00',1.58),('3355','2013-12-05','12:00:00',1.55),('3355','2013-12-05','12:05:00',1.58),('3355','2013-12-05','12:10:00',1.56),('3355','2013-12-05','12:15:00',1.58),('3355','2013-12-05','12:20:00',1.57),('3355','2013-12-05','12:25:00',1.54),('3355','2013-12-05','12:30:00',1.52),('3355','2013-12-05','12:35:00',1.46),('3355','2013-12-05','12:40:00',1.55),('3355','2013-12-05','12:45:00',1.51),('3355','2013-12-05','12:50:00',1.41),('3355','2013-12-05','12:55:00',1.3),('3355','2013-12-05','13:00:00',1.18),('3355','2013-12-05','13:05:00',1.47),('3355','2013-12-05','13:10:00',1.42),('3355','2013-12-05','13:15:00',1.36),('3355','2013-12-05','13:20:00',1.33),('3355','2013-12-05','13:25:00',1.12),('3355','2013-12-05','13:30:00',1.14),('3355','2013-12-05','13:35:00',1.22),('3355','2013-12-05','13:40:00',1.2),('3355','2013-12-05','13:45:00',1.26),('3355','2013-12-05','13:50:00',1.22),('3355','2013-12-05','13:55:00',1.22),('3355','2013-12-05','14:00:00',1.21),('3355','2013-12-05','14:05:00',1.2),('3355','2013-12-05','14:10:00',1.08),('3355','2013-12-04','09:20:00',1.03),('3355','2013-12-04','09:25:00',1.07),('3355','2013-12-04','09:30:00',1.11),('3355','2013-12-04','09:35:00',1.15),('3355','2013-12-04','09:40:00',1.19),('3355','2013-12-04','09:45:00',1.23),('3355','2013-12-04','09:50:00',1.26),('3355','2013-12-04','09:55:00',1.29),('3355','2013-12-04','10:00:00',1.33),('3355','2013-12-04','10:05:00',1.36),('3355','2013-12-04','10:10:00',1.38),('3355','2013-12-04','10:15:00',1.41),('3355','2013-12-04','10:20:00',1.43),('3355','2013-12-04','10:25:00',1.46),('3355','2013-12-04','10:30:00',1.49),('3355','2013-12-04','10:35:00',1.51),('3355','2013-12-04','10:40:00',1.54),('3355','2013-12-04','10:45:00',1.56),('3355','2013-12-04','10:50:00',1.57),('3355','2013-12-04','10:55:00',1.59),('3355','2013-12-04','11:00:00',1.61),('3355','2013-12-04','11:05:00',1.62),('3355','2013-12-04','11:10:00',1.63),('3355','2013-12-04','11:15:00',1.64),('3355','2013-12-04','11:20:00',1.65),('3355','2013-12-04','11:25:00',1.66),('3355','2013-12-04','11:30:00',1.67),('3355','2013-12-04','11:35:00',1.68),('3355','2013-12-04','11:40:00',1.67),('3355','2013-12-04','11:45:00',1.69),('3355','2013-12-04','11:50:00',1.69),('3355','2013-12-04','11:55:00',1.69),('3355','2013-12-04','12:00:00',1.7),('3355','2013-12-04','12:05:00',1.69),('3355','2013-12-04','12:10:00',1.7),('3355','2013-12-04','12:15:00',1.68),('3355','2013-12-04','12:20:00',1.68),('3355','2013-12-04','12:25:00',1.68),('3355','2013-12-04','12:30:00',1.68),('3355','2013-12-04','12:35:00',1.67),('3355','2013-12-04','12:40:00',1.65),('3355','2013-12-04','12:45:00',1.66),('3355','2013-12-04','12:50:00',1.65),('3355','2013-12-04','12:55:00',1.64),('3355','2013-12-04','13:00:00',1.62),('3355','2013-12-04','13:05:00',1.61),('3355','2013-12-04','13:10:00',1.59),('3355','2013-12-04','13:15:00',1.42),('3355','2013-12-04','13:20:00',1.36),('3355','2013-12-04','13:25:00',1.27),('3355','2013-12-04','13:30:00',1.38),('3355','2013-12-04','13:35:00',1.32),('3355','2013-12-04','13:40:00',1.33),('3355','2013-12-04','13:45:00',1.35),('3355','2013-12-04','13:50:00',1.36),('3355','2013-12-04','13:55:00',1.36),('3355','2013-12-04','14:00:00',1.37),('3355','2013-12-04','14:05:00',1.35),('3355','2013-12-04','14:10:00',1.23),('3355','2013-12-04','14:15:00',1.04),('3355','2013-12-04','14:20:00',1.08),('3355','2013-12-04','14:25:00',1.01),('3355','2013-12-03','09:50:00',1.03),('3355','2013-12-03','10:00:00',1.32),('3355','2013-12-03','10:05:00',1.35),('3355','2013-12-03','10:10:00',1.37),('3355','2013-12-03','10:15:00',1.4),('3355','2013-12-03','10:20:00',1.42),('3355','2013-12-03','10:25:00',1.45),('3355','2013-12-03','10:30:00',1.47),('3355','2013-12-03','10:35:00',1.49),('3355','2013-12-03','10:40:00',1.51),('3355','2013-12-03','10:45:00',1.53),('3355','2013-12-03','10:50:00',1.56),('3355','2013-12-03','10:55:00',1.59),('3355','2013-12-03','11:00:00',1.62),('3355','2013-12-03','11:05:00',1.64),('3355','2013-12-03','11:10:00',1.65),('3355','2013-12-03','11:15:00',1.67),('3355','2013-12-03','11:20:00',1.68),('3355','2013-12-03','11:25:00',1.68),('3355','2013-12-03','11:30:00',1.67),('3355','2013-12-03','11:35:00',1.69),('3355','2013-12-03','11:40:00',1.69),('3355','2013-12-03','11:45:00',1.7),('3355','2013-12-03','11:50:00',1.72),('3355','2013-12-03','11:55:00',1.72),('3355','2013-12-03','12:00:00',1.72),('3355','2013-12-03','12:05:00',1.73),('3355','2013-12-03','12:10:00',1.74),('3355','2013-12-03','12:15:00',1.75),('3355','2013-12-03','12:20:00',1.76),('3355','2013-12-03','12:25:00',1.78),('3355','2013-12-03','12:30:00',1.79),('3355','2013-12-03','12:35:00',1.8),('3355','2013-12-03','12:40:00',1.82),('3355','2013-12-03','12:45:00',1.85),('3355','2013-12-03','12:50:00',1.9),('3355','2013-12-03','12:55:00',1.94),('3355','2013-12-03','13:00:00',1.97),('3355','2013-12-03','13:05:00',2),('3355','2013-12-03','13:10:00',2),('3355','2013-12-03','13:15:00',1.87),('3355','2013-12-03','13:20:00',1.78),('3355','2013-12-03','13:25:00',1.68),('3355','2013-12-03','13:30:00',1.5),('3355','2013-12-03','13:35:00',1.61),('3355','2013-12-03','13:40:00',1.55),('3355','2013-12-03','13:45:00',1.5),('3355','2013-12-03','13:50:00',1.47),('3355','2013-12-03','13:55:00',1.47),('3355','2013-12-03','14:00:00',1.47),('3355','2013-12-03','14:05:00',1.39),('3355','2013-12-03','14:10:00',1.31),('3355','2013-12-03','14:15:00',1.13),('3355','2013-12-03','14:20:00',1),('3355','2013-11-30','09:20:00',1.05),('3355','2013-11-30','09:25:00',1.05),('3355','2013-11-30','09:30:00',1.06),('3355','2013-11-30','09:35:00',1.31),('3355','2013-11-30','09:40:00',1.23),('3355','2013-11-30','09:45:00',1.09),('3355','2013-11-29','09:20:00',1.04),('3355','2013-11-29','09:25:00',1.08),('3355','2013-11-29','09:30:00',1.12),('3355','2013-11-29','09:35:00',1.16),('3355','2013-11-29','09:40:00',1.21),('3355','2013-11-29','09:45:00',1.24),('3355','2013-11-29','09:50:00',1.28),('3355','2013-11-29','09:55:00',1.32),('3355','2013-11-29','10:00:00',1.35),('3355','2013-11-29','10:05:00',1.38),('3355','2013-11-29','10:10:00',1.41),('3355','2013-11-29','10:15:00',1.43),('3355','2013-11-29','10:20:00',1.46),('3355','2013-11-29','10:25:00',1.48),('3355','2013-11-29','10:30:00',1.51),('3355','2013-11-29','10:35:00',1.53),('3355','2013-11-29','10:40:00',1.56),('3355','2013-11-29','10:45:00',1.58),('3355','2013-11-29','10:50:00',1.6),('3355','2013-11-29','10:55:00',1.62),('3355','2013-11-29','11:00:00',1.63),('3355','2013-11-29','11:05:00',1.65),('3355','2013-11-29','11:10:00',1.67),('3355','2013-11-29','11:15:00',1.68),('3355','2013-11-29','11:20:00',1.7),('3355','2013-11-29','11:25:00',1.71),('3355','2013-11-29','11:30:00',1.71),('3355','2013-11-29','11:35:00',1.72),('3355','2013-11-29','11:40:00',1.73),('3355','2013-11-29','11:45:00',1.73),('3355','2013-11-29','11:50:00',1.74),('3355','2013-11-29','11:55:00',1.75),('3355','2013-11-29','12:00:00',1.74),('3355','2013-11-29','12:05:00',1.74),('3355','2013-11-29','12:10:00',1.75),('3355','2013-11-29','12:15:00',1.74),('3355','2013-11-29','12:20:00',1.73),('3355','2013-11-29','12:25:00',1.72),('3355','2013-11-29','12:30:00',1.71),('3355','2013-11-29','12:35:00',1.71),('3355','2013-11-29','12:40:00',1.71),('3355','2013-11-29','12:45:00',1.7),('3355','2013-11-29','12:50:00',1.69),('3355','2013-11-29','12:55:00',1.68),('3355','2013-11-29','13:00:00',1.66),('3355','2013-11-29','13:05:00',1.64),('3355','2013-11-29','13:10:00',1.62),('3355','2013-11-29','13:15:00',1.61),('3355','2013-11-29','13:20:00',1.53),('3355','2013-11-29','13:25:00',1.31),('3355','2013-11-29','13:30:00',1.31),('3355','2013-11-29','13:35:00',1.31),('3355','2013-11-29','13:40:00',1.39),('3355','2013-11-29','13:45:00',1.39),('3355','2013-11-29','13:50:00',1.39),('3355','2013-11-29','13:55:00',1.4),('3355','2013-11-29','14:00:00',1.38),('3355','2013-11-29','14:05:00',1.35),('3355','2013-11-29','14:10:00',1.32),('3355','2013-11-29','14:15:00',1.23),('3355','2013-11-29','14:20:00',1.01),('3355','2013-11-29','14:25:00',1.1),('3355','2013-11-29','14:30:00',1.06),('3355','2013-11-29','14:35:00',1.01),('3355','2014-04-20','08:30:00',1.16),('3355','2014-04-20','08:35:00',1.09),('3355','2014-04-20','08:40:00',1.13),('3355','2014-04-20','09:15:00',1.25),('3355','2014-04-20','09:20:00',1.39),('3355','2014-04-20','09:25:00',1.46),('3355','2014-04-20','09:30:00',1.68),('3355','2014-04-20','09:35:00',1.36),('3355','2014-04-20','09:40:00',1.02),('3355','2014-04-20','10:00:00',1.16),('3355','2014-04-20','10:05:00',1.41),('3355','2014-04-20','10:10:00',1.36),('3355','2014-04-20','10:15:00',1.65),('3355','2014-04-20','10:20:00',1.62),('3355','2014-04-20','10:25:00',1.39),('3355','2014-04-20','10:30:00',1.33),('3355','2014-04-20','10:35:00',1.43),('3355','2014-04-20','10:40:00',1.41),('3355','2014-04-20','10:45:00',1.4),('3355','2014-04-20','10:50:00',1.55),('3355','2014-04-20','10:55:00',1.58),('3355','2014-04-20','11:00:00',1.45),('3355','2014-04-20','11:05:00',1.83),('3355','2014-04-20','11:10:00',1.66),('3355','2014-04-20','11:15:00',1.85),('3355','2014-04-20','11:20:00',2.01),('3355','2014-04-20','11:25:00',1.95),('3355','2014-04-20','11:30:00',2.13),('3355','2014-04-20','11:35:00',2.18),('3355','2014-04-20','11:40:00',1.01),('3355','2014-04-20','11:45:00',1.87),('3355','2014-04-20','11:50:00',1.72),('3355','2014-04-20','11:55:00',1.22),('3355','2014-04-20','12:00:00',1.55),('3355','2014-04-20','12:05:00',2.27),('3355','2014-04-20','12:10:00',1.72),('3355','2014-04-20','12:15:00',1.82),('3355','2014-04-20','12:20:00',1.19),('3355','2014-04-20','12:25:00',2.61),('3355','2014-04-20','12:30:00',2.41),('3355','2014-04-20','12:35:00',2.34),('3355','2014-04-20','12:40:00',2.33),('3355','2014-04-20','12:45:00',2.37),('3355','2014-04-20','12:50:00',2.39),('3355','2014-04-20','12:55:00',2.4),('3355','2014-04-20','13:00:00',2.41),('3355','2014-04-20','13:05:00',2.42),('3355','2014-04-20','13:10:00',2.44),('3355','2014-04-20','13:15:00',2.46),('3355','2014-04-20','13:20:00',2.39),('3355','2014-04-20','13:25:00',2.39),('3355','2014-04-20','13:30:00',2.4),('3355','2014-04-20','13:35:00',2.39),('3355','2014-04-20','13:40:00',2.4),('3355','2014-04-20','13:45:00',2.4),('3355','2014-04-20','13:50:00',2.38),('3355','2014-04-20','13:55:00',2.38),('3355','2014-04-20','14:00:00',2.37),('3355','2014-04-20','14:05:00',2.38),('3355','2014-04-20','14:10:00',2.37),('3355','2014-04-20','14:15:00',2.44),('3355','2014-04-20','14:20:00',1.93),('3355','2014-04-20','14:25:00',1.78),('3355','2014-04-20','14:30:00',1.73),('3355','2014-04-20','14:35:00',1.37),('3355','2014-04-20','14:40:00',1.34),('3355','2014-04-20','14:45:00',1.45),('3355','2014-04-20','14:50:00',1.4),('3355','2014-04-20','14:55:00',1.58),('3355','2014-04-20','15:00:00',1.98),('3355','2014-04-20','15:05:00',2.06),('3355','2014-04-20','15:10:00',2.08),('3355','2014-04-20','15:15:00',2.2),('3355','2014-04-20','15:20:00',2.07),('3355','2014-04-20','15:25:00',2.11),('3355','2014-04-20','15:30:00',2.07),('3355','2014-04-20','15:35:00',2.03),('3355','2014-04-20','15:40:00',2.07),('3355','2014-04-20','15:45:00',1.78),('3355','2014-04-20','15:50:00',1.3),('3355','2014-04-20','15:55:00',2),('3355','2014-04-20','16:00:00',1.92),('3355','2014-04-20','16:05:00',1.89),('3355','2014-04-20','16:10:00',1.86),('3355','2014-04-20','16:15:00',1.85),('3355','2014-04-20','16:20:00',1.86),('3355','2014-04-20','16:25:00',1.49),('3355','2014-04-20','16:30:00',1.82),('3355','2014-04-20','16:35:00',1.67),('3355','2014-04-20','16:40:00',1.75),('3355','2014-04-20','16:45:00',1.47),('3355','2014-04-20','16:50:00',1.51),('3355','2014-04-20','16:55:00',1.59),('3355','2014-04-20','17:00:00',1.5),('3355','2014-04-20','17:05:00',1.43),('3355','2014-04-20','17:10:00',1.36),('3355','2014-04-20','17:15:00',1.3),('3355','2014-04-20','17:20:00',1.26),('3355','2014-04-20','17:25:00',1.21),('3355','2014-04-20','17:30:00',1.16),('3355','2014-04-20','17:35:00',1.11),('3355','2014-04-20','17:40:00',1.06),('3355','2014-04-20','17:45:00',1),('3355','2013-11-27','11:10:00',1.25),('3355','2013-11-27','11:30:00',1.41),('3355','2013-11-27','11:35:00',1.08),('3355','2013-11-27','11:50:00',1.23),('3355','2013-11-27','11:55:00',1.99),('3355','2013-11-27','12:00:00',1.93),('3355','2013-11-27','12:05:00',1.66),('3355','2013-11-27','12:15:00',1.22),('3355','2013-11-27','12:20:00',1.29),('3355','2013-11-27','12:30:00',1.64),('3355','2013-11-27','12:35:00',1.19),('3355','2013-11-26','09:40:00',1.17),('3355','2013-11-26','09:55:00',1.13),('3355','2013-11-26','10:00:00',1.38),('3355','2013-11-26','10:05:00',1.31),('3355','2013-11-26','10:25:00',1.09),('3355','2013-11-26','10:30:00',1.52),('3355','2013-11-26','10:35:00',1.69),('3355','2013-11-26','10:40:00',1.68),('3355','2013-11-26','10:45:00',1.72),('3355','2013-11-26','10:50:00',1.74),('3355','2013-11-26','10:55:00',1.77),('3355','2013-11-26','11:00:00',1.88),('3355','2013-11-26','11:05:00',1.64),('3355','2013-11-26','11:10:00',1.96),('3355','2013-11-26','11:15:00',2.09),('3355','2013-11-26','11:20:00',1.97),('3355','2013-11-26','11:25:00',2),('3355','2013-11-26','11:30:00',2.03),('3355','2013-11-26','11:35:00',2.12),('3355','2013-11-26','11:40:00',2),('3355','2013-11-26','11:45:00',1.93),('3355','2013-11-26','11:50:00',1.78),('3355','2013-11-26','12:20:00',1.92),('3355','2013-11-26','12:25:00',1.89),('3355','2013-11-26','12:30:00',1.85),('3355','2013-11-26','12:35:00',1.84),('3355','2013-11-26','12:40:00',1.84),('3355','2013-11-26','12:45:00',1.83),('3355','2013-11-26','12:50:00',1.82),('3355','2013-11-26','12:55:00',1.82),('3355','2013-11-26','13:00:00',1.81),('3355','2013-11-26','13:05:00',1.8),('3355','2013-11-26','13:10:00',1.78),('3355','2013-11-26','13:15:00',1.77),('3355','2013-11-26','13:20:00',1.75),('3355','2013-11-26','13:25:00',1.73),('3355','2013-11-26','13:30:00',1.53),('3355','2013-11-26','13:35:00',1.43),('3355','2013-11-26','13:40:00',1.46),('3355','2013-11-26','13:45:00',1.56),('3355','2013-11-26','13:50:00',1.59),('3355','2013-11-26','13:55:00',1.62),('3355','2013-11-26','14:00:00',1.54),('3355','2013-11-26','14:05:00',1.02),('3355','2013-11-26','14:10:00',1.86),('3355','2013-11-26','14:15:00',1.9),('3355','2013-11-26','14:20:00',1.49),('3355','2013-11-26','14:40:00',1.06),('3355','2013-11-26','14:45:00',1.09),('3355','2013-11-26','14:50:00',1.19),('3355','2013-11-26','14:55:00',1.21),('3355','2013-11-26','15:00:00',1.09),('3355','2013-11-25','08:55:00',1.06),('3355','2013-11-25','09:00:00',1.17),('3355','2013-11-25','09:05:00',1.22),('3355','2013-11-25','09:10:00',1.24),('3355','2013-11-25','09:15:00',1.31),('3355','2013-11-25','09:20:00',1.33),('3355','2013-11-25','09:25:00',1.07),('3355','2013-11-25','09:30:00',1.09),('3355','2013-11-25','09:35:00',1.36),('3355','2013-11-25','09:40:00',1.48),('3355','2013-11-25','10:00:00',1.01),('3355','2013-11-25','10:05:00',1.02),('3355','2013-11-25','10:10:00',1.07),('3355','2013-11-25','10:15:00',1.08),('3355','2013-11-25','10:25:00',1.14),('3355','2013-11-25','10:30:00',1.17),('3355','2013-11-25','10:35:00',1.15),('3355','2013-11-25','10:40:00',2.01),('3355','2013-11-25','10:45:00',1.75),('3355','2013-11-25','10:50:00',1.75),('3355','2013-11-25','10:55:00',1.32),('3355','2013-11-25','11:00:00',1.74),('3355','2013-11-25','11:05:00',1.8),('3355','2013-11-25','11:10:00',2.04),('3355','2013-11-25','11:15:00',1.47),('3355','2013-11-25','11:20:00',1.03),('3355','2013-11-25','11:55:00',1.05),('3355','2013-11-25','12:10:00',1.03),('3355','2013-11-25','12:40:00',1.61),('3355','2013-11-25','12:45:00',1.86),('3355','2013-11-25','12:50:00',1.42),('3355','2013-11-25','12:55:00',1.55),('3355','2013-11-25','13:00:00',2.04),('3355','2013-11-25','13:05:00',2.15),('3355','2013-11-25','13:10:00',1.53),('3355','2013-11-25','13:15:00',1.33),('3355','2013-11-25','13:20:00',1.45),('3355','2013-11-23','10:40:00',1.66),('3355','2013-11-21','09:45:00',1.31),('3355','2013-11-21','09:50:00',1.13),('3355','2013-11-21','09:55:00',1.01),('3355','2013-11-21','10:05:00',1.55),('3355','2013-11-21','10:10:00',1.36),('3355','2013-11-21','10:15:00',1.51),('3355','2013-11-21','10:20:00',1.49),('3355','2013-11-21','10:25:00',1),('3355','2013-11-21','10:30:00',1.09),('3355','2013-11-21','10:35:00',1.42),('3355','2013-11-21','10:40:00',1.51),('3355','2013-11-21','10:45:00',1.41),('3355','2013-11-21','11:30:00',1.34),('3355','2013-11-21','11:35:00',1.47),('3355','2013-11-21','11:40:00',1.77),('3355','2013-11-21','11:50:00',1.84),('3355','2013-11-21','11:55:00',1.66),('3355','2013-11-21','12:00:00',1.21),('3355','2013-11-21','12:05:00',1.42),('3355','2013-11-21','12:10:00',1.82),('3355','2013-11-21','12:15:00',1.81),('3355','2013-11-21','12:20:00',1.81),('3355','2013-11-21','12:25:00',1.84),('3355','2013-11-21','12:30:00',1.93),('3355','2013-11-21','12:35:00',1.94),('3355','2013-11-21','12:40:00',1.99),('3355','2013-11-21','12:45:00',1.99),('3355','2013-11-21','12:50:00',1.82),('3355','2013-11-21','12:55:00',1.99),('3355','2013-11-21','13:00:00',1.95),('3355','2013-11-21','13:05:00',1.97),('3355','2013-11-21','13:10:00',1.78),('3355','2013-11-21','13:15:00',1.82),('3355','2013-11-21','13:20:00',1.85),('3355','2013-11-21','13:25:00',1.67),('3355','2013-11-21','13:40:00',1.32),('3355','2013-11-21','13:45:00',1.66),('3355','2013-11-21','14:00:00',1.64),('3355','2013-11-21','14:05:00',1.18),('3355','2013-11-20','09:15:00',1.03),('3355','2013-11-20','09:25:00',1.18),('3355','2013-11-20','09:30:00',1.26),('3355','2013-11-20','10:15:00',1.05),('3355','2013-11-20','11:45:00',1.72),('3355','2013-11-20','11:50:00',2.33),('3355','2013-11-20','11:55:00',1.23),('3355','2013-11-20','12:55:00',1.26),('3355','2013-11-20','13:00:00',1.66),('3355','2013-11-20','13:05:00',1.21),('3355','2013-11-20','13:20:00',1.01),('3355','2013-11-20','13:40:00',1.05),('3355','2013-11-19','09:40:00',1.24),('3355','2013-11-19','09:45:00',1.21),('3355','2013-11-19','11:20:00',1.56),('3355','2013-11-19','11:25:00',1.4),('3355','2013-11-19','11:30:00',1.75),('3355','2013-11-19','11:35:00',1.73),('3355','2013-11-19','11:40:00',1.4),('3355','2013-11-19','11:45:00',1.6),('3355','2013-11-19','11:50:00',1.63),('3355','2013-11-19','11:55:00',1.63),('3355','2013-11-19','12:00:00',1.47),('3355','2013-11-19','12:05:00',1.42),('3355','2013-11-19','12:10:00',1.59),('3355','2013-11-19','12:15:00',1.64),('3355','2013-11-19','12:45:00',1.1),('3355','2013-11-19','12:55:00',1.82),('3355','2013-11-19','13:00:00',1.75),('3355','2013-11-19','13:15:00',1.19),('3355','2013-11-19','13:20:00',1.5),('3355','2013-11-19','15:30:00',1.06),('3355','2013-11-18','09:35:00',1.17),('3355','2013-11-18','10:15:00',1.03),('3355','2014-04-19','08:35:00',1.17),('3355','2014-04-19','08:45:00',1.02),('3355','2014-04-19','09:30:00',1.08),('3355','2014-04-19','09:35:00',1.12),('3355','2014-04-19','11:20:00',1.56),('3355','2014-04-19','11:25:00',1.38),('3355','2014-04-19','11:30:00',1.44),('3355','2014-04-19','11:35:00',1.28),('3355','2014-04-19','11:40:00',1.2),('3355','2014-04-19','11:45:00',1.26),('3355','2014-04-19','11:50:00',1.01),('3355','2014-04-19','14:45:00',1.02),('3355','2014-04-19','15:50:00',1.86),('3355','2014-04-19','15:55:00',1.91),('3355','2014-04-19','16:20:00',1.16),('3355','2014-04-19','16:25:00',1.14),('3355','2014-04-19','16:30:00',1.8),('3355','2013-11-17','08:50:00',1.07),('3355','2013-11-17','08:55:00',1.18),('3355','2013-11-17','09:05:00',1.03),('3355','2013-11-17','09:10:00',1.06),('3355','2013-11-17','09:15:00',1.12),('3355','2013-11-17','09:20:00',1.15),('3355','2013-11-17','09:25:00',1.17),('3355','2013-11-17','09:30:00',1.21),('3355','2013-11-17','09:35:00',1.22),('3355','2013-11-17','09:40:00',1.25),('3355','2013-11-17','09:45:00',1.28),('3355','2013-11-17','09:50:00',1.31),('3355','2013-11-17','09:55:00',1.34),('3355','2013-11-17','10:00:00',1.37),('3355','2013-11-17','10:05:00',1.4),('3355','2013-11-17','10:10:00',1.43),('3355','2013-11-17','10:15:00',1.45),('3355','2013-11-17','10:20:00',1.48),('3355','2013-11-17','10:25:00',1.49),('3355','2013-11-17','10:30:00',1.52),('3355','2013-11-17','10:35:00',1.53),('3355','2013-11-17','10:40:00',1.54),('3355','2013-11-17','10:45:00',1.56),('3355','2013-11-17','10:50:00',1.58),('3355','2013-11-17','10:55:00',1.6),('3355','2013-11-17','11:00:00',1.61),('3355','2013-11-17','11:05:00',1.62),('3355','2013-11-17','11:10:00',1.62),('3355','2013-11-17','11:15:00',1.64),('3355','2013-11-17','11:20:00',1.64),('3355','2013-11-17','11:25:00',1.66),('3355','2013-11-17','11:30:00',1.66),('3355','2013-11-17','11:35:00',1.66),('3355','2013-11-17','11:40:00',1.66),('3355','2013-11-17','11:45:00',1.68),('3355','2013-11-17','11:50:00',1.67),('3355','2013-11-17','11:55:00',1.67),('3355','2013-11-17','12:00:00',1.67),('3355','2013-11-17','12:05:00',1.67),('3355','2013-11-17','12:10:00',1.66),('3355','2013-11-17','12:15:00',1.67),('3355','2013-11-17','12:20:00',1.67),('3355','2013-11-17','12:25:00',1.67),('3355','2013-11-17','12:30:00',1.67),('3355','2013-11-17','12:35:00',1.67),('3355','2013-11-17','12:40:00',1.65),('3355','2013-11-17','12:45:00',1.63),('3355','2013-11-17','12:50:00',1.62),('3355','2013-11-17','12:55:00',1.6),('3355','2013-11-17','13:00:00',1.59),('3355','2013-11-17','13:05:00',1.57),('3355','2013-11-17','13:10:00',1.56),('3355','2013-11-17','13:15:00',1.55),('3355','2013-11-17','13:20:00',1.53),('3355','2013-11-17','13:25:00',1.53),('3355','2013-11-17','13:30:00',1.52),('3355','2013-11-17','13:35:00',1.1),('3355','2013-11-17','13:40:00',1.33),('3355','2013-11-17','14:00:00',1.35),('3355','2013-11-17','14:05:00',1.3),('3355','2013-11-17','14:10:00',1.27),('3355','2013-11-17','14:15:00',1.26),('3355','2013-11-17','14:20:00',1.23),('3355','2013-11-17','14:25:00',1.18),('3355','2013-11-17','14:30:00',1.07),('3355','2013-11-17','14:35:00',1.05),('3355','2013-11-15','10:55:00',1.16),('3355','2013-11-15','11:20:00',1.05),('3355','2013-11-15','11:25:00',1.67),('3355','2013-11-15','11:35:00',1.01),('3355','2013-11-15','11:40:00',1.1),('3355','2013-11-15','12:25:00',1.15),('3355','2013-11-15','13:45:00',1.08),('3355','2013-11-15','13:50:00',1.13),('3355','2013-11-14','09:05:00',1.01),('3355','2013-11-14','09:15:00',1.03),('3355','2013-11-14','09:20:00',1.15),('3355','2013-11-14','09:25:00',1.15),('3355','2013-11-14','09:30:00',1.19),('3355','2013-11-14','09:35:00',1.22),('3355','2013-11-14','09:40:00',1.24),('3355','2013-11-14','09:45:00',1.17),('3355','2013-11-14','10:05:00',1.01),('3355','2013-11-14','10:15:00',1.48),('3355','2013-11-14','10:20:00',1.5),('3355','2013-11-14','10:25:00',1.5),('3355','2013-11-14','10:30:00',1.5),('3355','2013-11-14','10:35:00',1.49),('3355','2013-11-14','10:40:00',1.51),('3355','2013-11-14','10:45:00',1.54),('3355','2013-11-14','10:50:00',1.56),('3355','2013-11-14','10:55:00',1.57),('3355','2013-11-14','11:00:00',1.56),('3355','2013-11-14','11:05:00',1.62),('3355','2013-11-14','11:10:00',1.65),('3355','2013-11-14','11:15:00',1.7),('3355','2013-11-14','11:20:00',1.72),('3355','2013-11-14','11:25:00',1.74),('3355','2013-11-14','11:30:00',1.75),('3355','2013-11-14','11:35:00',1.73),('3355','2013-11-14','11:40:00',1.49),('3355','2013-11-14','11:50:00',1.08),('3355','2013-11-14','12:00:00',1.86),('3355','2013-11-14','12:05:00',1.03),('3355','2013-11-13','10:20:00',1.02),('3355','2013-11-13','10:30:00',1.33),('3355','2013-11-13','10:35:00',2.09),('3355','2013-11-13','10:40:00',1.12),('3355','2013-11-13','10:45:00',1.64),('3355','2013-11-13','10:50:00',2.09),('3355','2013-11-13','10:55:00',2.04),('3355','2013-11-13','11:00:00',1.85),('3355','2013-11-13','13:55:00',1.13),('3355','2013-11-13','14:00:00',1.21),('3355','2013-11-13','14:05:00',1.2),('3355','2013-11-13','14:10:00',1.03),('3355','2013-11-13','14:15:00',1.13),('3355','2013-11-13','14:25:00',1.05),('3355','2013-11-12','11:40:00',1.59),('3355','2013-11-12','11:50:00',1),('3355','2013-11-12','12:00:00',1.68),('3355','2013-11-12','12:30:00',2.31),('3355','2013-11-12','12:35:00',1.89),('3355','2013-11-12','12:40:00',1.13),('3355','2013-11-12','12:45:00',1.08),('3355','2013-11-12','12:55:00',1.07),('3355','2013-11-12','13:00:00',1.03),('3355','2013-11-12','13:05:00',1.22),('3355','2013-11-12','13:10:00',1.91),('3355','2013-11-12','13:15:00',2.22),('3355','2013-11-12','13:20:00',1.54),('3355','2013-11-12','13:25:00',1.32),('3355','2013-11-12','13:35:00',1.17),('3355','2013-11-12','13:40:00',1.77),('3355','2013-11-12','13:45:00',1.12),('3355','2013-11-12','14:15:00',1.78),('3355','2013-11-12','14:20:00',1.74),('3355','2013-11-12','14:25:00',1.7),('3355','2013-11-12','14:30:00',1.5),('3355','2013-11-12','14:40:00',1.24),('3355','2013-11-12','14:45:00',1.03),('3355','2013-11-12','14:50:00',1.02),('3355','2013-11-11','10:15:00',1.29),('3355','2013-11-11','10:20:00',1.84),('3355','2013-11-11','11:10:00',1.49),('3355','2013-11-11','11:15:00',1.13),('3355','2013-11-11','11:25:00',1.75),('3355','2013-11-11','11:35:00',1.95),('3355','2013-11-11','11:40:00',2.36),('3355','2013-11-11','11:45:00',2.15),('3355','2013-11-11','11:50:00',2.22),('3355','2013-11-11','11:55:00',2.04),('3355','2013-11-11','12:00:00',1.96),('3355','2013-11-11','12:05:00',1.92),('3355','2013-11-11','12:10:00',1.84),('3355','2013-11-11','12:15:00',1.85),('3355','2013-11-11','12:20:00',1.97),('3355','2013-11-11','12:25:00',1.63),('3355','2013-11-11','12:30:00',1.63),('3355','2013-11-11','12:40:00',1.4),('3355','2013-11-11','13:10:00',1.92),('3355','2013-11-11','14:20:00',1.49),('3355','2013-11-11','14:25:00',1.48),('3355','2013-11-11','14:30:00',1.4),('3355','2013-11-11','14:35:00',1.36),('3355','2013-11-11','14:40:00',1.13),('3355','2013-11-10','08:55:00',1.08),('3355','2013-11-10','09:20:00',1.1),('3355','2013-11-10','09:25:00',1.25),('3355','2013-11-10','09:30:00',1.11),('3355','2013-11-10','09:35:00',1.1),('3355','2013-11-10','09:40:00',1.19),('3355','2013-11-10','09:45:00',1.31),('3355','2013-11-10','09:50:00',1.37),('3355','2013-11-10','09:55:00',1.36),('3355','2013-11-10','10:00:00',1.27),('3355','2013-11-10','10:05:00',1.48),('3355','2013-11-10','10:10:00',1.6),('3355','2013-11-10','10:15:00',1.6),('3355','2013-11-10','10:20:00',1.44),('3355','2013-11-10','10:25:00',1.67),('3355','2013-11-10','10:30:00',1.83),('3355','2013-11-10','10:35:00',1.62),('3355','2013-11-10','10:40:00',1.07),('3355','2013-11-10','10:45:00',1.77),('3355','2013-11-10','10:50:00',1.59),('3355','2013-11-10','10:55:00',1.76),('3355','2013-11-10','11:00:00',1.41),('3355','2013-11-10','11:40:00',1.14),('3355','2013-11-10','11:45:00',1.29),('3355','2013-11-10','12:15:00',1.88),('3355','2013-11-10','12:20:00',1.48),('3355','2013-11-10','12:25:00',1.84),('3355','2013-11-10','12:30:00',1.28),('3355','2013-11-10','12:35:00',1.02),('3355','2013-11-10','12:40:00',1.92),('3355','2013-11-10','12:45:00',2.04),('3355','2013-11-10','12:50:00',2.05),('3355','2013-11-10','12:55:00',1.35),('3355','2013-11-10','13:50:00',1.13),('3355','2013-11-10','13:55:00',1.27),('3355','2013-11-09','09:40:00',1.11),('3355','2013-11-09','09:45:00',1.25),('3355','2013-11-09','09:55:00',1.61),('3355','2013-11-09','10:00:00',1.56),('3355','2013-11-09','10:05:00',1.53),('3355','2013-11-09','10:10:00',1.44),('3355','2013-11-09','10:15:00',1.34),('3355','2013-11-09','10:20:00',1.48),('3355','2013-11-09','10:25:00',1.56),('3355','2013-11-09','10:55:00',1.05),('3355','2013-11-09','11:00:00',1.4),('3355','2013-11-09','11:05:00',1.9),('3355','2013-11-09','11:10:00',1.68),('3355','2013-11-09','11:15:00',1.83),('3355','2013-11-09','11:20:00',1.4),('3355','2013-11-09','11:30:00',1.78),('3355','2013-11-09','11:35:00',1.76),('3355','2013-11-09','11:45:00',1.23),('3355','2013-11-09','11:55:00',1.52),('3355','2013-11-09','12:00:00',1.49),('3355','2013-11-09','12:05:00',2.1),('3355','2013-11-09','12:15:00',1.18),('3355','2013-11-09','12:30:00',1.23),('3355','2013-11-09','12:35:00',1.93),('3355','2013-11-09','12:40:00',1.05),('3355','2013-11-09','12:50:00',1.23),('3355','2013-11-09','12:55:00',1.14),('3355','2013-11-09','13:00:00',1.86),('3355','2013-11-09','13:05:00',1.63),('3355','2013-11-09','13:10:00',1.88),('3355','2013-11-09','13:15:00',1.85),('3355','2013-11-09','13:20:00',1.25),('3355','2013-11-09','13:25:00',1.32),('3355','2013-11-09','13:30:00',1.65),('3355','2013-11-09','13:35:00',1.59),('3355','2013-11-09','13:40:00',1.54),('3355','2013-11-09','13:45:00',1.52),('3355','2013-11-09','13:50:00',1.53),('3355','2013-11-09','13:55:00',1.51),('3355','2013-11-09','14:00:00',1.48),('3355','2013-11-09','14:05:00',1.3),('3355','2013-11-09','14:20:00',1.42),('3355','2013-11-09','14:25:00',1.04),('3355','2013-11-09','14:50:00',1.03),('3355','2013-11-08','09:40:00',1),('3355','2013-11-08','09:50:00',1.27),('3355','2013-11-08','10:10:00',1.32),('3355','2013-11-08','10:15:00',1.29),('3355','2013-11-08','10:55:00',1.29),('3355','2013-11-08','11:00:00',1.15),('3355','2013-11-08','11:30:00',1.48),('3355','2013-11-08','11:35:00',1.6),('3355','2013-11-08','11:40:00',1.98),('3355','2013-11-08','11:45:00',1.94),('3355','2013-11-08','11:50:00',1.9),('3355','2013-11-08','11:55:00',1.97),('3355','2013-11-08','12:00:00',1.86),('3355','2013-11-08','12:05:00',1.13),('3355','2013-11-08','12:10:00',1.8),('3355','2013-11-08','12:15:00',1.5),('3355','2013-11-08','12:40:00',1.92),('3355','2013-11-08','12:45:00',1.86),('3355','2013-11-08','12:50:00',1.44),('3355','2013-11-08','12:55:00',1.93),('3355','2013-11-08','13:00:00',1.83),('3355','2013-11-08','13:05:00',1.76),('3355','2013-11-08','13:10:00',1.78),('3355','2013-11-08','13:15:00',1.68),('3355','2013-11-08','13:25:00',1.16),('3355','2013-11-08','13:35:00',1.29),('3355','2013-11-08','13:40:00',1.66),('3355','2013-11-08','13:45:00',1.59),('3355','2013-11-08','13:50:00',1.33),('3355','2013-11-08','13:55:00',1.51),('3355','2013-11-08','14:00:00',1.48),('3355','2013-11-08','14:05:00',1.46),('3355','2013-11-08','14:10:00',1.43),('3355','2013-11-08','14:15:00',1.41),('3355','2013-11-08','14:20:00',1.34),('3355','2013-11-08','14:25:00',1.13),('3355','2013-11-08','14:30:00',1.31),('3355','2013-11-08','14:35:00',1.29),('3355','2013-11-08','14:40:00',1.22),('3355','2013-11-08','14:45:00',1.19),('3355','2013-11-08','14:50:00',1.16),('3355','2014-04-18','09:05:00',1.32),('3355','2014-04-18','09:10:00',1.63),('3355','2014-04-18','09:15:00',1.49),('3355','2014-04-18','09:20:00',1.39),('3355','2014-04-18','09:30:00',1.59),('3355','2014-04-18','09:50:00',1.55),('3355','2014-04-18','09:55:00',1.4),('3355','2014-04-18','10:00:00',1.39),('3355','2014-04-18','10:45:00',1.48),('3355','2014-04-18','10:50:00',1.5),('3355','2014-04-18','10:55:00',1.58),('3355','2014-04-18','11:10:00',1.2),('3355','2014-04-18','11:15:00',1.56),('3355','2014-04-18','11:20:00',1.01),('3355','2014-04-18','11:50:00',1.02),('3355','2014-04-18','12:05:00',1.51),('3355','2014-04-18','12:10:00',1.64),('3355','2014-04-18','12:15:00',1.8),('3355','2014-04-18','12:20:00',2.22),('3355','2014-04-18','12:25:00',1.8),('3355','2014-04-18','12:30:00',2.49),('3355','2014-04-18','12:35:00',2.35),('3355','2014-04-18','12:40:00',2.49),('3355','2014-04-18','12:45:00',1.91),('3355','2014-04-18','12:50:00',2.09),('3355','2014-04-18','12:55:00',1.42),('3355','2014-04-18','13:00:00',2.58),('3355','2014-04-18','13:05:00',1.78),('3355','2014-04-18','13:10:00',1.37),('3355','2014-04-18','13:15:00',1.33),('3355','2014-04-18','13:20:00',1.2),('3355','2014-04-18','13:55:00',1.13),('3355','2014-04-18','14:00:00',1.04),('3355','2014-04-18','14:25:00',1.09),('3355','2014-04-18','14:30:00',1.22),('3355','2014-04-18','14:35:00',1.37),('3355','2014-04-18','14:40:00',1.25),('3355','2014-04-18','14:45:00',1.52),('3355','2014-04-18','14:50:00',1.78),('3355','2014-04-18','14:55:00',1.22),('3355','2014-04-18','15:00:00',1.86),('3355','2014-04-18','15:05:00',1.6),('3355','2014-04-18','15:10:00',1.23),('3355','2014-04-18','15:15:00',1.4),('3355','2014-04-18','15:20:00',1.09),('3355','2014-04-18','15:25:00',1.16),('3355','2014-04-18','15:30:00',1.68),('3355','2014-04-18','15:35:00',2.52),('3355','2014-04-18','15:40:00',1),('3355','2014-04-18','15:45:00',1.32),('3355','2014-04-18','15:50:00',1.69),('3355','2014-04-18','15:55:00',1.42),('3355','2014-04-18','16:00:00',1.23),('3355','2014-04-18','16:25:00',1.18),('3355','2014-04-18','16:30:00',1.19),('3355','2014-04-18','16:35:00',1.73),('3355','2014-04-18','16:40:00',1.72),('3355','2014-04-18','16:45:00',1.7),('3355','2014-04-18','16:50:00',1.41),('3355','2014-04-18','17:00:00',1.15),('3355','2014-04-18','17:05:00',1.64),('3355','2014-04-18','17:10:00',1.08),('3355','2014-04-18','17:15:00',1.38),('3355','2014-04-18','17:20:00',1.26),('3355','2014-04-18','17:25:00',1.27),('3355','2014-04-18','17:30:00',1.17),('3355','2014-04-18','17:35:00',1.11),('3355','2014-04-18','17:40:00',1.07),('3355','2014-04-18','17:45:00',1.01),('3355','2013-11-07','08:55:00',1.02),('3355','2013-11-07','09:00:00',1.06),('3355','2013-11-07','09:05:00',1.1),('3355','2013-11-07','09:10:00',1.13),('3355','2013-11-07','09:15:00',1.16),('3355','2013-11-07','09:20:00',1.2),('3355','2013-11-07','09:25:00',1.23),('3355','2013-11-07','09:30:00',1.26),('3355','2013-11-07','09:35:00',1.29),('3355','2013-11-07','09:40:00',1.33),('3355','2013-11-07','09:45:00',1.35),('3355','2013-11-07','09:50:00',1.39),('3355','2013-11-07','09:55:00',1.41),('3355','2013-11-07','10:00:00',1.43),('3355','2013-11-07','10:05:00',1.44),('3355','2013-11-07','10:10:00',1.46),('3355','2013-11-07','10:15:00',1.48),('3355','2013-11-07','10:20:00',1.49),('3355','2013-11-07','10:25:00',1.51),('3355','2013-11-07','10:30:00',1.53),('3355','2013-11-07','10:35:00',1.55),('3355','2013-11-07','10:40:00',1.57),('3355','2013-11-07','10:45:00',1.58),('3355','2013-11-07','10:50:00',1.59),('3355','2013-11-07','10:55:00',1.59),('3355','2013-11-07','11:00:00',1.61),('3355','2013-11-07','11:05:00',1.61),('3355','2013-11-07','11:10:00',1.63),('3355','2013-11-07','11:15:00',1.62),('3355','2013-11-07','11:20:00',1.63),('3355','2013-11-07','11:25:00',1.63),('3355','2013-11-07','11:30:00',1.61),('3355','2013-11-07','11:35:00',1.63),('3355','2013-11-07','11:40:00',1.64),('3355','2013-11-07','11:45:00',1.65),('3355','2013-11-07','11:50:00',1.63),('3355','2013-11-07','11:55:00',1.63),('3355','2013-11-07','12:00:00',1.63),('3355','2013-11-07','12:05:00',1.64),('3355','2013-11-07','12:10:00',1.64),('3355','2013-11-07','12:15:00',1.63),('3355','2013-11-07','12:20:00',1.63),('3355','2013-11-07','12:25:00',1.61),('3355','2013-11-07','12:30:00',1.59),('3355','2013-11-07','12:35:00',1.61),('3355','2013-11-07','12:40:00',1.59),('3355','2013-11-07','12:45:00',1.54),('3355','2013-11-07','12:50:00',1.57),('3355','2013-11-07','12:55:00',1.61),('3355','2013-11-07','13:00:00',1.6),('3355','2013-11-07','13:05:00',1.7),('3355','2013-11-07','13:10:00',1.53),('3355','2013-11-07','13:15:00',1.66),('3355','2013-11-07','13:20:00',1.27),('3355','2013-11-07','13:35:00',1.02),('3355','2013-11-07','13:40:00',1.65),('3355','2013-11-07','13:50:00',1.36),('3355','2013-11-07','13:55:00',1.38),('3355','2013-11-07','14:35:00',1.12),('3355','2013-11-07','14:40:00',1.29),('3355','2013-11-07','14:45:00',1.17),('3355','2013-11-07','14:50:00',1.12),('3355','2013-11-07','14:55:00',1.1),('3355','2013-11-07','15:00:00',1),('3355','2013-11-06','08:50:00',1.04),('3355','2013-11-06','09:20:00',1.16),('3355','2013-11-06','09:25:00',1.23),('3355','2013-11-06','09:30:00',1.32),('3355','2013-11-06','09:35:00',1.35),('3355','2013-11-06','09:40:00',1.38),('3355','2013-11-06','09:45:00',1.4),('3355','2013-11-06','09:50:00',1.42),('3355','2013-11-06','09:55:00',1.45),('3355','2013-11-06','10:00:00',1.48),('3355','2013-11-06','10:05:00',1.5),('3355','2013-11-06','10:10:00',1.53),('3355','2013-11-06','10:15:00',1.55),('3355','2013-11-06','10:20:00',1.57),('3355','2013-11-06','10:25:00',1.6),('3355','2013-11-06','10:30:00',1.64),('3355','2013-11-06','10:35:00',1.65),('3355','2013-11-06','10:40:00',1.67),('3355','2013-11-06','10:45:00',1.68),('3355','2013-11-06','10:50:00',1.71),('3355','2013-11-06','10:55:00',1.72),('3355','2013-11-06','11:00:00',1.72),('3355','2013-11-06','11:05:00',1.73),('3355','2013-11-06','11:10:00',1.74),('3355','2013-11-06','11:15:00',1.74),('3355','2013-11-06','11:20:00',1.76),('3355','2013-11-06','11:25:00',1.77),('3355','2013-11-06','11:30:00',1.78),('3355','2013-11-06','11:35:00',1.77),('3355','2013-11-06','11:40:00',1.77),('3355','2013-11-06','11:45:00',1.79),('3355','2013-11-06','11:50:00',1.8),('3355','2013-11-06','11:55:00',1.79),('3355','2013-11-06','12:00:00',1.79),('3355','2013-11-06','12:05:00',1.8),('3355','2013-11-06','12:10:00',1.8),('3355','2013-11-06','12:15:00',1.8),('3355','2013-11-06','12:20:00',1.8),('3355','2013-11-06','12:25:00',1.8),('3355','2013-11-06','12:30:00',1.79),('3355','2013-11-06','12:35:00',1.78),('3355','2013-11-06','12:40:00',1.76),('3355','2013-11-06','12:45:00',1.75),('3355','2013-11-06','12:50:00',1.74),('3355','2013-11-06','12:55:00',1.74),('3355','2013-11-06','13:00:00',1.72),('3355','2013-11-06','13:05:00',1.7),('3355','2013-11-06','13:10:00',1.69),('3355','2013-11-06','13:15:00',1.66),('3355','2013-11-06','13:20:00',1.66),('3355','2013-11-06','13:25:00',1.64),('3355','2013-11-06','13:30:00',1.63),('3355','2013-11-06','13:35:00',1.61),('3355','2013-11-06','13:40:00',1.58),('3355','2013-11-06','13:45:00',1.55),('3355','2013-11-06','13:50:00',1.53),('3355','2013-11-06','13:55:00',1.52),('3355','2013-11-06','14:00:00',1.5),('3355','2013-11-06','14:05:00',1.47),('3355','2013-11-06','14:10:00',1.44),('3355','2013-11-06','14:15:00',1.42),('3355','2013-11-06','14:20:00',1.39),('3355','2013-11-06','14:25:00',1.36),('3355','2013-11-06','14:30:00',1.32),('3355','2013-11-06','14:35:00',1.29),('3355','2013-11-06','14:40:00',1.26),('3355','2013-11-06','14:45:00',1.22),('3355','2013-11-06','14:50:00',1.17),('3355','2013-11-06','14:55:00',1.12),('3355','2013-11-06','15:00:00',1.08),('3355','2013-11-05','08:35:00',1.02),('3355','2013-11-05','08:40:00',1.05),('3355','2013-11-05','10:25:00',1.21),('3355','2013-11-05','10:30:00',1.09),('3355','2013-11-05','10:35:00',1.07),('3355','2013-11-05','10:45:00',1.33),('3355','2013-11-05','12:20:00',1.03),('3355','2013-11-05','12:25:00',1.1),('3355','2013-11-05','13:35:00',1.3),('3355','2013-11-05','13:40:00',1.42),('3355','2013-11-05','13:45:00',1.27),('3355','2013-11-05','14:10:00',1.55),('3355','2013-11-05','14:25:00',1.38),('3355','2013-11-05','14:30:00',1.24),('3355','2013-11-04','09:15:00',1.22),('3355','2013-11-04','09:20:00',1.45),('3355','2013-11-04','09:25:00',1.57),('3355','2013-11-04','10:05:00',1.36),('3355','2013-11-04','10:10:00',1.6),('3355','2013-11-04','10:15:00',1.61),('3355','2013-11-04','10:20:00',1.65),('3355','2013-11-04','10:25:00',1.75),('3355','2013-11-04','10:30:00',1.42),('3355','2013-11-04','10:35:00',1.37),('3355','2013-11-04','10:40:00',1.85),('3355','2013-11-04','10:45:00',1.18),('3355','2013-11-04','11:00:00',1.49),('3355','2013-11-04','11:05:00',2.28),('3355','2013-11-04','11:10:00',1.92),('3355','2013-11-04','11:15:00',2.25),('3355','2013-11-04','11:20:00',1.72),('3355','2013-11-04','11:30:00',1.12),('3355','2013-11-04','11:35:00',1.48),('3355','2013-11-04','11:40:00',1.1),('3355','2013-11-04','11:45:00',1.27),('3355','2013-11-04','11:50:00',2.19),('3355','2013-11-04','11:55:00',1.98),('3355','2013-11-04','12:00:00',1.99),('3355','2013-11-04','12:05:00',1.9),('3355','2013-11-04','12:10:00',1.75),('3355','2013-11-04','12:15:00',1.91),('3355','2013-11-04','12:20:00',1.89),('3355','2013-11-04','12:25:00',1.9),('3355','2013-11-04','12:30:00',1.82),('3355','2013-11-04','12:35:00',1.72),('3355','2013-11-04','12:40:00',1.37),('3355','2013-11-04','12:45:00',1.77),('3355','2013-11-04','12:50:00',1.81),('3355','2013-11-04','12:55:00',1.79),('3355','2013-11-04','13:00:00',1.79),('3355','2013-11-04','13:05:00',1.77),('3355','2013-11-04','13:10:00',1.67),('3355','2013-11-04','13:15:00',1.72),('3355','2013-11-04','13:20:00',1.74),('3355','2013-11-04','13:25:00',1.74),('3355','2013-11-04','13:30:00',1.7),('3355','2013-11-04','13:35:00',1.62),('3355','2013-11-04','13:40:00',1.72),('3355','2013-11-04','13:45:00',1.29),('3355','2013-11-04','13:50:00',1.67),('3355','2013-11-04','13:55:00',1.65),('3355','2013-11-04','14:00:00',1.11),('3355','2013-11-04','14:05:00',1.71),('3355','2013-11-04','14:15:00',1.42),('3355','2013-11-04','14:20:00',1.41),('3355','2013-11-04','14:25:00',1.55),('3355','2013-11-04','14:30:00',1.4),('3355','2013-11-04','14:35:00',1.08),('3355','2013-11-04','14:40:00',1.32),('3355','2013-11-04','14:55:00',1.15),('3355','2013-11-04','15:00:00',1.18),('3355','2013-11-03','09:40:00',1.21),('3355','2013-11-03','09:45:00',1.16),('3355','2013-11-03','10:10:00',1.05),('3355','2013-11-03','10:25:00',1.41),('3355','2013-11-03','10:35:00',1.05),('3355','2013-11-03','11:25:00',1.1),('3355','2013-11-03','11:30:00',1.11),('3355','2013-11-03','11:35:00',1.7),('3355','2013-11-03','11:40:00',1.84),('3355','2013-11-03','11:45:00',1.9),('3355','2013-11-03','11:50:00',1.94),('3355','2013-11-03','11:55:00',2.06),('3355','2013-11-03','12:00:00',1.33),('3355','2013-11-03','12:05:00',2.04),('3355','2013-11-03','12:10:00',2.29),('3355','2013-11-03','12:25:00',1.01),('3355','2013-11-03','12:30:00',1.02),('3355','2013-11-03','13:50:00',1.26),('3355','2013-11-03','14:05:00',1.17),('3355','2013-11-03','14:10:00',1.02),('3355','2013-11-03','14:40:00',1.26),('3355','2013-11-02','09:00:00',1.02),('3355','2013-11-02','09:05:00',1.1),('3355','2013-11-02','09:10:00',1.21),('3355','2013-11-02','09:20:00',1.03),('3355','2013-11-02','09:25:00',1.16),('3355','2013-11-02','09:30:00',1.28),('3355','2013-11-02','09:35:00',1.27),('3355','2013-11-02','09:40:00',1.2),('3355','2013-11-02','09:45:00',1.06),('3355','2013-11-02','09:50:00',1.45),('3355','2013-11-02','09:55:00',1.47),('3355','2013-11-02','10:00:00',1.58),('3355','2013-11-02','10:05:00',1.79),('3355','2013-11-02','11:55:00',1.08),('3355','2013-11-02','12:00:00',1.77),('3355','2013-11-02','12:05:00',2),('3355','2013-11-02','12:10:00',1.77),('3355','2013-11-02','12:15:00',1.56),('3355','2013-11-02','12:20:00',2.14),('3355','2013-11-02','12:25:00',2.05),('3355','2013-11-02','12:30:00',2.11),('3355','2013-11-02','12:35:00',2.05),('3355','2013-11-02','12:40:00',1.84),('3355','2013-11-02','12:45:00',1.59),('3355','2013-11-02','12:50:00',1.63),('3355','2013-11-02','12:55:00',1.86),('3355','2013-11-02','13:00:00',1.8),('3355','2013-11-02','13:05:00',1.85),('3355','2013-11-02','13:10:00',1.94),('3355','2013-11-02','13:15:00',1.9),('3355','2013-11-02','13:30:00',1.12),('3355','2013-11-02','13:35:00',1.9),('3355','2013-11-02','13:40:00',1.88),('3355','2013-11-02','13:45:00',1.54),('3355','2013-11-02','13:50:00',1.94),('3355','2013-11-02','13:55:00',1.87),('3355','2013-11-02','14:00:00',1.74),('3355','2013-11-02','14:05:00',1.53),('3355','2013-11-02','14:10:00',1.46),('3355','2013-11-02','14:15:00',1.41),('3355','2013-11-02','14:20:00',1.36),('3355','2013-11-02','14:25:00',1.32),('3355','2013-11-02','14:30:00',1.3),('3355','2013-11-02','14:35:00',1.27),('3355','2013-11-02','14:40:00',1.23),('3355','2013-11-02','14:45:00',1.18),('3355','2013-11-02','14:50:00',1.15),('3355','2013-11-02','14:55:00',1.12),('3355','2013-11-02','15:00:00',1.01),('3355','2013-11-01','09:05:00',1.05),('3355','2013-11-01','09:10:00',1.1),('3355','2013-11-01','09:15:00',1.13),('3355','2013-11-01','09:20:00',1.16),('3355','2013-11-01','09:25:00',1.2),('3355','2013-11-01','09:30:00',1.23),('3355','2013-11-01','09:35:00',1.26),('3355','2013-11-01','09:40:00',1.3),('3355','2013-11-01','09:45:00',1.33),('3355','2013-11-01','09:50:00',1.37),('3355','2013-11-01','09:55:00',1.4),('3355','2013-11-01','10:00:00',1.42),('3355','2013-11-01','10:05:00',1.46),('3355','2013-11-01','10:10:00',1.49),('3355','2013-11-01','10:15:00',1.49),('3355','2013-11-01','10:20:00',1.52),('3355','2013-11-01','10:25:00',1.55),('3355','2013-11-01','10:30:00',1.54),('3355','2013-11-01','10:35:00',1.55),('3355','2013-11-01','10:40:00',1.6),('3355','2013-11-01','10:45:00',1.56),('3355','2013-11-01','10:50:00',1.56),('3355','2013-11-01','10:55:00',1.56),('3355','2013-11-01','11:00:00',1.6),('3355','2013-11-01','11:05:00',1.55),('3355','2013-11-01','11:10:00',1.38),('3355','2013-11-01','11:15:00',1.47),('3355','2013-11-01','11:20:00',1.68),('3355','2013-11-01','11:25:00',1.78),('3355','2013-11-01','11:30:00',1.8),('3355','2013-11-01','11:35:00',1.75),('3355','2013-11-01','11:40:00',1.67),('3355','2013-11-01','11:45:00',1.48),('3355','2013-11-01','11:50:00',1.73),('3355','2013-11-01','11:55:00',1.81),('3355','2013-11-01','12:00:00',1.82),('3355','2013-11-01','12:05:00',1.79),('3355','2013-11-01','12:10:00',1.64),('3355','2013-11-01','12:15:00',1.67),('3355','2013-11-01','12:30:00',1.57),('3355','2013-11-01','12:35:00',1.24),('3355','2013-10-31','09:55:00',1.1),('3355','2013-10-31','10:00:00',1.01),('3355','2013-10-31','10:20:00',1.01),('3355','2013-10-31','10:25:00',1),('3355','2013-10-31','10:35:00',1),('3355','2013-10-31','10:40:00',1.02),('3355','2013-10-31','10:50:00',1.05),('3355','2013-10-31','10:55:00',1.28),('3355','2013-10-31','11:00:00',1.58),('3355','2013-10-31','11:05:00',1.67),('3355','2013-10-31','11:10:00',1.62),('3355','2013-10-31','11:15:00',1.33),('3355','2013-10-31','11:20:00',1.49),('3355','2013-10-31','11:25:00',1.46),('3355','2013-10-31','11:30:00',1.51),('3355','2013-10-31','11:35:00',1.45),('3355','2013-10-31','11:40:00',1.55),('3355','2013-10-31','11:45:00',1.66),('3355','2013-10-31','11:50:00',1.68),('3355','2013-10-31','11:55:00',1.68),('3355','2013-10-31','12:00:00',1.66),('3355','2013-10-31','12:05:00',1.63),('3355','2013-10-31','12:10:00',1.61),('3355','2013-10-31','12:15:00',1.63),('3355','2013-10-31','12:20:00',1.62),('3355','2013-10-31','12:25:00',1.63),('3355','2013-10-31','12:30:00',1.59),('3355','2013-10-31','12:35:00',1.59),('3355','2013-10-31','12:40:00',1.61),('3355','2013-10-31','12:45:00',1.67),('3355','2013-10-31','12:50:00',1.68),('3355','2013-10-31','12:55:00',1.7),('3355','2013-10-31','13:00:00',1.65),('3355','2013-10-31','13:05:00',1.63),('3355','2013-10-31','13:10:00',1.62),('3355','2013-10-31','13:15:00',1.6),('3355','2013-10-31','13:20:00',1.6),('3355','2013-10-31','13:25:00',1.57),('3355','2013-10-31','13:30:00',1.54),('3355','2013-10-31','13:35:00',1.45),('3355','2013-10-31','13:40:00',1.23),('3355','2013-10-31','13:45:00',1.33),('3355','2013-10-31','13:55:00',1.1),('3355','2013-10-31','14:00:00',1.4),('3355','2013-10-31','14:05:00',1.39),('3355','2013-10-31','14:10:00',1.3),('3355','2013-10-31','14:15:00',1.17),('3355','2013-10-31','14:25:00',1.2),('3355','2013-10-30','09:10:00',1.07),('3355','2013-10-30','09:15:00',1.1),('3355','2013-10-30','09:20:00',1.13),('3355','2013-10-30','09:25:00',1.17),('3355','2013-10-30','09:30:00',1.19),('3355','2013-10-30','09:35:00',1.24),('3355','2013-10-30','09:40:00',1.27),('3355','2013-10-30','09:45:00',1.3),('3355','2013-10-30','09:50:00',1.32),('3355','2013-10-30','09:55:00',1.32),('3355','2013-10-30','10:00:00',1.26),('3355','2013-10-30','10:05:00',1.33),('3355','2013-10-30','10:10:00',1.31),('3355','2013-10-30','10:15:00',1.41),('3355','2013-10-30','10:20:00',1.39),('3355','2013-10-30','10:25:00',1.35),('3355','2013-10-30','10:30:00',1.43),('3355','2013-10-30','10:35:00',1.41),('3355','2013-10-30','10:40:00',1.25),('3355','2013-10-30','10:45:00',1.37),('3355','2013-10-30','11:05:00',1.15),('3355','2013-10-30','11:10:00',1.33),('3355','2013-10-30','11:15:00',1.46),('3355','2013-10-30','11:20:00',1.57),('3355','2013-10-30','11:50:00',1.06),('3355','2013-10-30','12:30:00',1.47),('3355','2013-10-30','12:45:00',1.19),('3355','2013-10-30','12:50:00',1.39),('3355','2013-10-30','12:55:00',1.16),('3355','2013-10-30','13:00:00',1.37),('3355','2013-10-30','13:05:00',1.22),('3355','2013-10-30','13:20:00',1.23),('3355','2013-10-30','13:35:00',1.23),('3355','2013-10-30','13:40:00',1.34),('3355','2013-10-30','13:45:00',1.34),('3355','2013-10-30','13:50:00',1.41),('3355','2013-10-30','13:55:00',1.14),('3355','2013-10-30','14:05:00',1.45),('3355','2013-10-30','14:10:00',1.54),('3355','2013-10-30','14:45:00',1.1),('3355','2013-10-30','14:50:00',1.05),('3355','2013-10-29','08:55:00',1.01),('3355','2013-10-29','09:00:00',1.04),('3355','2013-10-29','09:05:00',1.08),('3355','2013-10-29','09:10:00',1.1),('3355','2013-10-29','09:15:00',1.11),('3355','2013-10-29','09:20:00',1.17),('3355','2013-10-29','09:25:00',1.19),('3355','2013-10-29','09:30:00',1.24),('3355','2013-10-29','09:35:00',1.3),('3355','2013-10-29','09:40:00',1.37),('3355','2013-10-29','09:45:00',1.38),('3355','2013-10-29','09:50:00',1.41),('3355','2013-10-29','09:55:00',1.41),('3355','2013-10-29','10:00:00',1.19),('3355','2013-10-29','10:05:00',1.08),('3355','2013-10-29','10:10:00',1.27),('3355','2013-10-29','10:15:00',1.31),('3355','2013-10-29','10:20:00',1.34),('3355','2013-10-29','10:25:00',1.15),('3355','2013-10-29','10:30:00',1.28),('3355','2013-10-29','10:35:00',1.76),('3355','2013-10-29','10:40:00',1.74),('3355','2013-10-29','10:45:00',1.71),('3355','2013-10-29','10:50:00',1.72),('3355','2013-10-29','10:55:00',1.81),('3355','2013-10-29','11:00:00',1.81),('3355','2013-10-29','11:05:00',1.8),('3355','2013-10-29','11:10:00',1.46),('3355','2013-10-29','11:15:00',1.57),('3355','2013-10-29','11:30:00',1.25),('3355','2013-10-29','11:35:00',1.78),('3355','2013-10-29','11:40:00',1.72),('3355','2013-10-29','11:45:00',1.78),('3355','2013-10-29','11:50:00',1.74),('3355','2013-10-29','11:55:00',1.7),('3355','2013-10-29','12:00:00',1.64),('3355','2013-10-29','12:05:00',1.69),('3355','2013-10-29','12:10:00',1.69),('3355','2013-10-29','12:15:00',1.69),('3355','2013-10-29','12:20:00',1.69),('3355','2013-10-29','12:25:00',1.68),('3355','2013-10-29','12:30:00',1.66),('3355','2013-10-29','12:35:00',1.59),('3355','2013-10-29','12:40:00',1.61),('3355','2013-10-29','12:45:00',1.65),('3355','2013-10-29','12:50:00',1.66),('3355','2013-10-29','12:55:00',1.6),('3355','2013-10-29','13:00:00',1.58),('3355','2013-10-29','13:05:00',1.52),('3355','2013-10-29','13:10:00',1.54),('3355','2013-10-29','13:15:00',1.54),('3355','2013-10-29','13:20:00',1.5),('3355','2013-10-29','13:25:00',1.5),('3355','2013-10-29','13:30:00',1.46),('3355','2013-10-29','13:35:00',1.42),('3355','2013-10-29','13:40:00',1.47),('3355','2013-10-29','13:45:00',1.46),('3355','2013-10-29','13:50:00',1.43),('3355','2013-10-29','13:55:00',1.36),('3355','2013-10-29','14:00:00',1.32),('3355','2013-10-29','14:05:00',1.27),('3355','2013-10-29','14:10:00',1.32),('3355','2013-10-29','14:15:00',1.29),('3355','2013-10-29','14:20:00',1.26),('3355','2013-10-29','14:25:00',1.21),('3355','2013-10-29','14:30:00',1.17),('3355','2013-10-29','14:35:00',1.12),('3355','2013-10-29','14:40:00',1.09),('3355','2013-10-29','14:45:00',1.07),('3355','2013-10-29','14:50:00',1.03),('3355','2014-04-17','09:05:00',1.05),('3355','2014-04-17','09:10:00',1.19),('3355','2014-04-17','09:15:00',1.2),('3355','2014-04-17','09:20:00',1.29),('3355','2014-04-17','09:25:00',1.37),('3355','2014-04-17','09:30:00',1.42),('3355','2014-04-17','09:35:00',1.46),('3355','2014-04-17','09:40:00',1.51),('3355','2014-04-17','09:45:00',1.57),('3355','2014-04-17','09:50:00',1.61),('3355','2014-04-17','09:55:00',1.67),('3355','2014-04-17','10:00:00',1.75),('3355','2014-04-17','10:05:00',1.89),('3355','2014-04-17','10:10:00',1.81),('3355','2014-04-17','10:15:00',1.52),('3355','2014-04-17','10:20:00',1.85),('3355','2014-04-17','10:25:00',2.08),('3355','2014-04-17','10:30:00',2.21),('3355','2014-04-17','10:35:00',2.25),('3355','2014-04-17','10:40:00',2.16),('3355','2014-04-17','10:45:00',1.76),('3355','2014-04-17','10:50:00',1.38),('3355','2014-04-17','10:55:00',1.35),('3355','2014-04-17','11:00:00',1.34),('3355','2014-04-17','11:05:00',2.12),('3355','2014-04-17','11:10:00',1.83),('3355','2014-04-17','11:15:00',1.67),('3355','2014-04-17','11:20:00',1.74),('3355','2014-04-17','11:25:00',1.95),('3355','2014-04-17','11:30:00',1.36),('3355','2014-04-17','11:35:00',1.66),('3355','2014-04-17','11:40:00',1.49),('3355','2014-04-17','11:45:00',1.79),('3355','2014-04-17','11:50:00',1.34),('3355','2014-04-17','11:55:00',1.09),('3355','2014-04-17','12:00:00',1.14),('3355','2014-04-17','12:05:00',1.56),('3355','2014-04-17','12:10:00',1.54),('3355','2014-04-17','12:15:00',1.35),('3355','2014-04-17','12:20:00',1.3),('3355','2014-04-17','12:25:00',1.41),('3355','2014-04-17','12:30:00',1.74),('3355','2014-04-17','12:35:00',2.17),('3355','2014-04-17','12:40:00',2.47),('3355','2014-04-17','12:45:00',2.36),('3355','2014-04-17','12:50:00',2.44),('3355','2014-04-17','12:55:00',2.5),('3355','2014-04-17','13:00:00',2.51),('3355','2014-04-17','13:05:00',1.27),('3355','2014-04-17','13:20:00',1.1),('3355','2014-04-17','13:25:00',2.82),('3355','2014-04-17','13:30:00',2.35),('3355','2014-04-17','14:10:00',1.15),('3355','2014-04-17','14:40:00',1.7),('3355','2014-04-17','15:35:00',1.18),('3355','2013-10-28','09:00:00',1.07),('3355','2013-10-28','09:05:00',1.18),('3355','2013-10-28','09:10:00',1.27),('3355','2013-10-28','09:15:00',1.24),('3355','2013-10-28','09:20:00',1.17),('3355','2013-10-28','09:25:00',1.12),('3355','2013-10-28','09:30:00',1.36),('3355','2013-10-28','09:35:00',1.24),('3355','2013-10-28','09:50:00',1.36),('3355','2013-10-28','10:50:00',1.76),('3355','2013-10-28','10:55:00',1.72),('3355','2013-10-28','11:00:00',1.69),('3355','2013-10-28','11:05:00',1.74),('3355','2013-10-28','11:10:00',1.73),('3355','2013-10-28','11:15:00',1.74),('3355','2013-10-28','11:20:00',1.75),('3355','2013-10-28','11:25:00',1.76),('3355','2013-10-28','11:30:00',1.75),('3355','2013-10-28','11:35:00',1.75),('3355','2013-10-28','11:40:00',1.74),('3355','2013-10-28','11:45:00',1.74),('3355','2013-10-28','11:50:00',1.78),('3355','2013-10-28','11:55:00',1.67),('3355','2013-10-28','12:00:00',1.02),('3355','2013-10-28','12:05:00',1.61),('3355','2013-10-28','12:10:00',1.73),('3355','2013-10-28','12:15:00',1.87),('3355','2013-10-28','12:20:00',1.92),('3355','2013-10-28','12:25:00',1.59),('3355','2013-10-28','12:30:00',1.52),('3355','2013-10-28','12:35:00',2.05),('3355','2013-10-28','12:40:00',1.92),('3355','2013-10-28','12:45:00',1.9),('3355','2013-10-28','12:50:00',1.95),('3355','2013-10-28','12:55:00',1.88),('3355','2013-10-28','13:00:00',1.76),('3355','2013-10-28','13:05:00',1.73),('3355','2013-10-28','13:10:00',1.74),('3355','2013-10-28','13:15:00',1.65),('3355','2013-10-28','13:20:00',1.68),('3355','2013-10-28','13:25:00',1.42),('3355','2013-10-28','13:30:00',1.65),('3355','2013-10-28','13:35:00',1.62),('3355','2013-10-28','13:40:00',1.6),('3355','2013-10-28','13:45:00',1.6),('3355','2013-10-28','13:50:00',1.42),('3355','2013-10-28','13:55:00',1.5),('3355','2013-10-28','14:00:00',1.51),('3355','2013-10-28','14:05:00',1.54),('3355','2013-10-28','14:10:00',1.58),('3355','2013-10-28','14:15:00',1.49),('3355','2013-10-28','14:20:00',1.46),('3355','2013-10-28','14:25:00',1.5),('3355','2013-10-28','14:30:00',1.16),('3355','2013-10-28','14:35:00',1.12),('3355','2013-10-28','14:50:00',1.2),('3355','2013-10-28','14:55:00',1.11),('3355','2013-10-28','15:00:00',1.12),('3355','2013-10-28','15:05:00',1.07),('3355','2013-10-27','11:45:00',1.1),('3355','2013-10-27','11:50:00',1.5),('3355','2013-10-27','12:20:00',1.29),('3355','2013-10-27','12:25:00',1.77),('3355','2013-10-27','12:30:00',1.24),('3355','2013-10-27','12:35:00',1.63),('3355','2013-10-27','12:40:00',1.63),('3355','2013-10-27','12:45:00',1.47),('3355','2013-10-27','12:50:00',1.5),('3355','2013-10-27','12:55:00',1.75),('3355','2013-10-27','13:00:00',1.57),('3355','2013-10-27','13:10:00',1),('3355','2013-10-27','13:30:00',1.47),('3355','2013-10-27','13:35:00',1.52),('3355','2013-10-27','14:40:00',1.24),('3355','2013-10-27','14:45:00',1.19),('3355','2013-10-27','14:50:00',1.02),('3355','2013-10-27','14:55:00',1.12),('3355','2013-10-27','15:00:00',1.1),('3355','2013-10-26','09:55:00',1.02),('3355','2013-10-26','10:00:00',1.05),('3355','2013-10-26','10:05:00',1.09),('3355','2013-10-26','10:10:00',1.13),('3355','2013-10-26','10:15:00',1.17),('3355','2013-10-26','10:20:00',1.2),('3355','2013-10-26','10:25:00',1.24),('3355','2013-10-26','10:30:00',1.26),('3355','2013-10-26','10:35:00',1.3),('3355','2013-10-26','10:40:00',1.33),('3355','2013-10-26','10:45:00',1.35),('3355','2013-10-26','10:50:00',1.39),('3355','2013-10-26','10:55:00',1.42),('3355','2013-10-26','11:00:00',1.45),('3355','2013-10-26','11:05:00',1.48),('3355','2013-10-26','11:10:00',1.49),('3355','2013-10-26','11:15:00',1.53),('3355','2013-10-26','11:20:00',1.54),('3355','2013-10-26','11:25:00',1.56),('3355','2013-10-26','11:30:00',1.58),('3355','2013-10-26','11:35:00',1.6),('3355','2013-10-26','11:40:00',1.61),('3355','2013-10-26','11:45:00',1.63),('3355','2013-10-26','11:50:00',1.64),('3355','2013-10-26','11:55:00',1.65),('3355','2013-10-26','12:00:00',1.67),('3355','2013-10-26','12:05:00',1.66),('3355','2013-10-26','12:10:00',1.66),('3355','2013-10-26','12:15:00',1.64),('3355','2013-10-26','12:20:00',1.7),('3355','2013-10-26','12:25:00',1.7),('3355','2013-10-26','12:30:00',1.73),('3355','2013-10-26','12:35:00',1.65),('3355','2013-10-26','12:40:00',1.69),('3355','2013-10-26','12:45:00',1.68),('3355','2013-10-26','12:50:00',1.72),('3355','2013-10-26','12:55:00',1.19),('3355','2013-10-26','13:00:00',1.6),('3355','2013-10-26','13:05:00',1.67),('3355','2013-10-26','13:10:00',1.72),('3355','2013-10-26','13:15:00',1.64),('3355','2013-10-26','13:20:00',1.59),('3355','2013-10-26','13:25:00',1.66),('3355','2013-10-26','13:30:00',1.3),('3355','2013-10-26','13:35:00',1.54),('3355','2013-10-26','13:40:00',1.68),('3355','2013-10-26','13:45:00',1.64),('3355','2013-10-26','13:50:00',1.64),('3355','2013-10-26','13:55:00',1.64),('3355','2013-10-26','14:00:00',1.56),('3355','2013-10-26','14:05:00',1.47),('3355','2013-10-26','14:10:00',1.54),('3355','2013-10-26','14:15:00',1.44),('3355','2013-10-26','14:35:00',1.12),('3355','2013-10-26','14:40:00',1.42),('3355','2013-10-26','14:45:00',1.33),('3355','2013-10-26','14:50:00',1.35),('3355','2013-10-26','14:55:00',1.28),('3355','2013-10-26','15:00:00',1.31),('3355','2013-10-26','15:05:00',1.33),('3355','2013-10-26','15:10:00',1.28),('3355','2013-10-26','15:15:00',1.21),('3355','2013-10-26','15:20:00',1.2),('3355','2013-10-26','15:25:00',1.16),('3355','2013-10-26','15:30:00',1.1),('3355','2013-10-26','15:35:00',1.1),('3355','2013-10-26','15:40:00',1.1),('3355','2013-10-26','15:45:00',1.03),('3355','2013-10-26','15:50:00',1.06),('3355','2013-10-25','09:55:00',1.04),('3355','2013-10-25','10:00:00',1.08),('3355','2013-10-25','10:05:00',1.12),('3355','2013-10-25','10:10:00',1.15),('3355','2013-10-25','10:15:00',1.19),('3355','2013-10-25','10:20:00',1.23),('3355','2013-10-25','10:25:00',1.26),('3355','2013-10-25','10:30:00',1.3),('3355','2013-10-25','10:35:00',1.33),('3355','2013-10-25','10:40:00',1.36),('3355','2013-10-25','10:45:00',1.39),('3355','2013-10-25','10:50:00',1.42),('3355','2013-10-25','10:55:00',1.43),('3355','2013-10-25','11:00:00',1.48),('3355','2013-10-25','11:05:00',1.48),('3355','2013-10-25','11:10:00',1.49),('3355','2013-10-25','11:15:00',1.54),('3355','2013-10-25','11:20:00',1.57),('3355','2013-10-25','11:25:00',1.6),('3355','2013-10-25','11:30:00',1.58),('3355','2013-10-25','11:35:00',1.59),('3355','2013-10-25','11:40:00',1.65),('3355','2013-10-25','11:45:00',1.65),('3355','2013-10-25','11:50:00',1.66),('3355','2013-10-25','11:55:00',1.69),('3355','2013-10-25','12:00:00',1.73),('3355','2013-10-25','12:05:00',1.74),('3355','2013-10-25','12:10:00',1.74),('3355','2013-10-25','12:15:00',1.74),('3355','2013-10-25','12:20:00',1.75),('3355','2013-10-25','12:25:00',1.77),('3355','2013-10-25','12:30:00',1.78),('3355','2013-10-25','12:35:00',1.78),('3355','2013-10-25','12:40:00',1.78),('3355','2013-10-25','12:45:00',1.78),('3355','2013-10-25','12:50:00',1.77),('3355','2013-10-25','12:55:00',1.76),('3355','2013-10-25','13:00:00',1.76),('3355','2013-10-25','13:05:00',1.76),('3355','2013-10-25','13:10:00',1.77),('3355','2013-10-25','13:15:00',1.76),('3355','2013-10-25','13:20:00',1.77),('3355','2013-10-25','13:25:00',1.76),('3355','2013-10-25','13:30:00',1.72),('3355','2013-10-25','13:35:00',1.71),('3355','2013-10-25','13:40:00',1.72),('3355','2013-10-25','13:45:00',1.72),('3355','2013-10-25','13:50:00',1.68),('3355','2013-10-25','13:55:00',1.69),('3355','2013-10-25','14:00:00',1.69),('3355','2013-10-25','14:05:00',1.66),('3355','2013-10-25','14:10:00',1.66),('3355','2013-10-25','14:15:00',1.65),('3355','2013-10-25','14:20:00',1.64),('3355','2013-10-25','14:25:00',1.62),('3355','2013-10-25','14:30:00',1.6),('3355','2013-10-25','14:35:00',1.58),('3355','2013-10-25','14:40:00',1.54),('3355','2013-10-25','14:45:00',1.53),('3355','2013-10-25','14:50:00',1.53),('3355','2013-10-25','14:55:00',1.5),('3355','2013-10-25','15:00:00',1.47),('3355','2013-10-25','15:05:00',1.44),('3355','2013-10-25','15:10:00',1.42),('3355','2013-10-25','15:15:00',1.39),('3355','2013-10-25','15:20:00',1.33),('3355','2013-10-25','15:25:00',1.31),('3355','2013-10-25','15:30:00',1.27),('3355','2013-10-25','15:35:00',1.22),('3355','2013-10-25','15:40:00',1.19),('3355','2013-10-25','15:45:00',1.14),('3355','2013-10-25','15:50:00',1.11),('3355','2013-10-25','15:55:00',1.07),('3355','2013-10-25','16:00:00',1.05),('3355','2013-10-25','16:05:00',1.01),('3355','2013-10-24','10:45:00',1.18),('3355','2013-10-24','10:50:00',1.01),('3355','2013-10-24','10:55:00',1.27),('3355','2013-10-24','11:00:00',1.47),('3355','2013-10-24','11:05:00',1.74),('3355','2013-10-24','11:10:00',1.86),('3355','2013-10-24','11:15:00',1.36),('3355','2013-10-24','11:25:00',1.2),('3355','2013-10-24','11:30:00',1.04),('3355','2013-10-24','11:55:00',1.52),('3355','2013-10-24','12:00:00',1.08),('3355','2013-10-24','12:40:00',1.03),('3355','2013-10-24','12:45:00',1.31),('3355','2013-10-24','12:50:00',1.45),('3355','2013-10-24','12:55:00',1.35),('3355','2013-10-24','13:00:00',1.93),('3355','2013-10-24','13:05:00',2.12),('3355','2013-10-24','13:10:00',1.85),('3355','2013-10-24','13:15:00',1.38),('3355','2013-10-24','13:20:00',1.58),('3355','2013-10-24','13:25:00',1.16),('3355','2013-10-24','13:50:00',1.08),('3355','2013-10-24','13:55:00',1.03),('3355','2013-10-24','14:00:00',1.26),('3355','2013-10-24','14:05:00',1.15),('3355','2013-10-24','14:50:00',1.37),('3355','2013-10-24','15:10:00',1.36),('3355','2013-10-24','15:35:00',1.57),('3355','2013-10-24','15:40:00',1.4),('3355','2013-10-23','11:05:00',1.29),('3355','2013-10-23','11:10:00',1.15),('3355','2013-10-23','11:15:00',1.07),('3355','2013-10-23','11:20:00',1.27),('3355','2013-10-23','11:25:00',1.64),('3355','2013-10-23','11:30:00',1.6),('3355','2013-10-23','11:35:00',1.51),('3355','2013-10-23','11:40:00',1.28),('3355','2013-10-23','11:45:00',1.67),('3355','2013-10-23','11:50:00',1.66),('3355','2013-10-23','11:55:00',1.6),('3355','2013-10-23','12:00:00',1.69),('3355','2013-10-23','12:05:00',1.67),('3355','2013-10-23','12:10:00',1.66),('3355','2013-10-23','12:15:00',1.68),('3355','2013-10-23','12:20:00',1.54),('3355','2013-10-23','12:25:00',1.64),('3355','2013-10-23','12:30:00',1.65),('3355','2013-10-23','12:35:00',1.65),('3355','2013-10-23','12:40:00',1.61),('3355','2013-10-23','12:45:00',1.64),('3355','2013-10-23','12:50:00',1.52),('3355','2013-10-23','12:55:00',1.15),('3355','2013-10-23','13:00:00',1.58),('3355','2013-10-23','13:05:00',1.56),('3355','2013-10-23','13:10:00',1.59),('3355','2013-10-23','13:15:00',1.59),('3355','2013-10-23','13:20:00',1.67),('3355','2013-10-23','13:25:00',1.66),('3355','2013-10-23','13:30:00',1.61),('3355','2013-10-23','13:35:00',1.6),('3355','2013-10-23','13:40:00',1.63),('3355','2013-10-23','13:45:00',1.64),('3355','2013-10-23','13:50:00',1.25),('3355','2013-10-23','13:55:00',1.1),('3355','2013-10-23','14:05:00',1.22),('3355','2013-10-23','14:10:00',1.6),('3355','2013-10-23','14:15:00',1.49),('3355','2013-10-23','14:20:00',1.57),('3355','2013-10-23','14:25:00',1.52),('3355','2013-10-23','14:30:00',1.49),('3355','2013-10-23','14:35:00',1.39),('3355','2013-10-23','14:40:00',1.34),('3355','2013-10-23','14:45:00',1.37),('3355','2013-10-23','14:50:00',1.19),('3355','2013-10-23','14:55:00',1.47),('3355','2013-10-23','15:00:00',1.38),('3355','2013-10-23','15:05:00',1.39),('3355','2013-10-23','15:10:00',1.33),('3355','2013-10-23','15:15:00',1.35),('3355','2013-10-23','15:20:00',1.35),('3355','2013-10-23','15:25:00',1.35),('3355','2013-10-23','15:30:00',1.31),('3355','2013-10-23','15:35:00',1.23),('3355','2013-10-23','15:40:00',1.28),('3355','2013-10-23','15:45:00',1.26),('3355','2013-10-23','15:50:00',1.12),('3355','2013-10-22','09:55:00',1.03),('3355','2013-10-22','10:00:00',1.06),('3355','2013-10-22','10:05:00',1.1),('3355','2013-10-22','10:10:00',1.13),('3355','2013-10-22','10:15:00',1.16),('3355','2013-10-22','10:20:00',1.21),('3355','2013-10-22','10:25:00',1.25),('3355','2013-10-22','10:30:00',1.28),('3355','2013-10-22','10:35:00',1.31),('3355','2013-10-22','10:40:00',1.33),('3355','2013-10-22','10:45:00',1.36),('3355','2013-10-22','10:50:00',1.4),('3355','2013-10-22','10:55:00',1.43),('3355','2013-10-22','11:00:00',1.45),('3355','2013-10-22','11:05:00',1.46),('3355','2013-10-22','11:10:00',1.48),('3355','2013-10-22','11:15:00',1.51),('3355','2013-10-22','11:20:00',1.52),('3355','2013-10-22','11:25:00',1.52),('3355','2013-10-22','11:30:00',1.54),('3355','2013-10-22','11:35:00',1.56),('3355','2013-10-22','11:40:00',1.58),('3355','2013-10-22','11:45:00',1.61),('3355','2013-10-22','11:50:00',1.63),('3355','2013-10-22','11:55:00',1.6),('3355','2013-10-22','12:00:00',1.62),('3355','2013-10-22','12:05:00',1.63),('3355','2013-10-22','12:10:00',1.64),('3355','2013-10-22','12:15:00',1.64),('3355','2013-10-22','12:20:00',1.64),('3355','2013-10-22','12:25:00',1.64),('3355','2013-10-22','12:30:00',1.62),('3355','2013-10-22','12:35:00',1.62),('3355','2013-10-22','12:40:00',1.48),('3355','2013-10-22','12:45:00',1.57),('3355','2013-10-22','12:50:00',1.68),('3355','2013-10-22','12:55:00',1.68),('3355','2013-10-22','13:00:00',1.67),('3355','2013-10-22','13:05:00',1.73),('3355','2013-10-22','13:10:00',1.7),('3355','2013-10-22','13:15:00',1.68),('3355','2013-10-22','13:20:00',1.57),('3355','2013-10-22','13:25:00',1.7),('3355','2013-10-22','13:30:00',1.59),('3355','2013-10-22','13:35:00',1.51),('3355','2013-10-22','13:40:00',1.62),('3355','2013-10-22','13:45:00',1.54),('3355','2013-10-22','13:50:00',1.67),('3355','2013-10-22','13:55:00',1.56),('3355','2013-10-22','14:00:00',1.52),('3355','2013-10-22','14:05:00',1.3),('3355','2013-10-22','14:15:00',1.18),('3355','2013-10-22','14:20:00',1.63),('3355','2013-10-22','14:45:00',1.04),('3355','2013-10-22','14:50:00',1.32),('3355','2013-10-22','14:55:00',1.35),('3355','2013-10-22','15:00:00',1.34),('3355','2013-10-22','15:05:00',1.35),('3355','2013-10-22','15:10:00',1.33),('3355','2013-10-22','15:15:00',1.27),('3355','2013-10-22','15:20:00',1.22),('3355','2013-10-22','15:25:00',1.22),('3355','2013-10-22','15:30:00',1.18),('3355','2013-10-22','15:35:00',1.18),('3355','2013-10-22','15:40:00',1.14),('3355','2013-10-22','15:45:00',1.06),('3355','2013-10-22','15:55:00',1.03),('3355','2013-10-21','10:05:00',1.09),('3355','2013-10-21','10:10:00',1.2),('3355','2013-10-21','10:15:00',1.23),('3355','2013-10-21','10:20:00',1.24),('3355','2013-10-21','10:25:00',1.29),('3355','2013-10-21','10:30:00',1.29),('3355','2013-10-21','10:35:00',1.3),('3355','2013-10-21','10:40:00',1.28),('3355','2013-10-21','10:45:00',1.3),('3355','2013-10-21','10:50:00',1.39),('3355','2013-10-21','10:55:00',1.39),('3355','2013-10-21','11:00:00',1.49),('3355','2013-10-21','11:05:00',1.46),('3355','2013-10-21','11:10:00',1.24),('3355','2013-10-21','11:15:00',1.62),('3355','2013-10-21','11:20:00',1.57),('3355','2013-10-21','11:25:00',1.61),('3355','2013-10-21','11:30:00',1.64),('3355','2013-10-21','11:35:00',1.65),('3355','2013-10-21','11:40:00',1.63),('3355','2013-10-21','11:45:00',1.7),('3355','2013-10-21','11:50:00',1.71),('3355','2013-10-21','11:55:00',1.71),('3355','2013-10-21','12:00:00',1.73),('3355','2013-10-21','12:05:00',1.75),('3355','2013-10-21','12:10:00',1.78),('3355','2013-10-21','12:15:00',1.77),('3355','2013-10-21','12:20:00',1.76),('3355','2013-10-21','12:25:00',1.79),('3355','2013-10-21','12:30:00',1.72),('3355','2013-10-21','12:35:00',1.72),('3355','2013-10-21','12:40:00',1.79),('3355','2013-10-21','12:45:00',1.8),('3355','2013-10-21','12:50:00',1.8),('3355','2013-10-21','12:55:00',1.79),('3355','2013-10-21','13:00:00',1.78),('3355','2013-10-21','13:05:00',1.77),('3355','2013-10-21','13:10:00',1.67),('3355','2013-10-21','13:15:00',1.73),('3355','2013-10-21','13:20:00',1.73),('3355','2013-10-21','13:25:00',1.74),('3355','2013-10-21','13:30:00',1.78),('3355','2013-10-21','13:35:00',1.78),('3355','2013-10-21','13:40:00',1.75),('3355','2013-10-21','13:45:00',1.75),('3355','2013-10-21','13:50:00',1.72),('3355','2013-10-21','13:55:00',1.66),('3355','2013-10-21','14:00:00',1.63),('3355','2013-10-21','14:05:00',1.68),('3355','2013-10-21','14:10:00',1.67),('3355','2013-10-21','14:15:00',1.67),('3355','2013-10-21','14:20:00',1.64),('3355','2013-10-21','14:25:00',1.63),('3355','2013-10-21','14:30:00',1.58),('3355','2013-10-21','14:35:00',1.57),('3355','2013-10-21','14:40:00',1.48),('3355','2013-10-21','14:45:00',1.46),('3355','2013-10-21','14:50:00',1.42),('3355','2013-10-21','14:55:00',1.41),('3355','2013-10-21','15:00:00',1.44),('3355','2013-10-21','15:05:00',1.44),('3355','2013-10-21','15:10:00',1.39),('3355','2013-10-21','15:15:00',1.38),('3355','2013-10-21','15:20:00',1.37),('3355','2013-10-21','15:25:00',1.32),('3355','2013-10-21','15:30:00',1.28),('3355','2013-10-21','15:35:00',1.19),('3355','2013-10-21','15:40:00',1.22),('3355','2013-10-21','15:45:00',1.18),('3355','2013-10-21','15:50:00',1.13),('3355','2013-10-21','15:55:00',1.1),('3355','2013-10-21','16:00:00',1.07),('3355','2013-10-21','16:05:00',1.02),('3355','2013-10-21','16:10:00',1),('3355','2013-10-20','09:45:00',1.02),('3355','2013-10-20','09:50:00',1.05),('3355','2013-10-20','09:55:00',1.07),('3355','2013-10-20','10:00:00',1.14),('3355','2013-10-20','10:05:00',1.18),('3355','2013-10-20','10:10:00',1.22),('3355','2013-10-20','10:15:00',1.26),('3355','2013-10-20','10:20:00',1.3),('3355','2013-10-20','10:25:00',1.33),('3355','2013-10-20','10:30:00',1.36),('3355','2013-10-20','10:35:00',1.39),('3355','2013-10-20','10:40:00',1.43),('3355','2013-10-20','10:45:00',1.46),('3355','2013-10-20','10:50:00',1.48),('3355','2013-10-20','10:55:00',1.51),('3355','2013-10-20','11:00:00',1.53),('3355','2013-10-20','11:05:00',1.56),('3355','2013-10-20','11:10:00',1.59),('3355','2013-10-20','11:15:00',1.61),('3355','2013-10-20','11:20:00',1.64),('3355','2013-10-20','11:25:00',1.67),('3355','2013-10-20','11:30:00',1.67),('3355','2013-10-20','11:35:00',1.7),('3355','2013-10-20','11:40:00',1.72),('3355','2013-10-20','11:45:00',1.71),('3355','2013-10-20','11:50:00',1.74),('3355','2013-10-20','11:55:00',1.73),('3355','2013-10-20','12:00:00',1.74),('3355','2013-10-20','12:05:00',1.78),('3355','2013-10-20','12:10:00',1.79),('3355','2013-10-20','12:25:00',1.26),('3355','2013-10-20','12:35:00',2.11),('3355','2013-10-20','12:40:00',1.73),('3355','2013-10-20','12:45:00',1.46),('3355','2013-10-20','12:50:00',1.6),('3355','2013-10-20','12:55:00',1.57),('3355','2013-10-20','13:00:00',1.38),('3355','2013-10-20','13:05:00',1.35),('3355','2013-10-20','13:10:00',1.92),('3355','2013-10-20','13:25:00',1.02),('3355','2013-10-20','13:30:00',1.53),('3355','2013-10-20','13:35:00',1.18),('3355','2013-10-20','13:45:00',1.33),('3355','2013-10-19','09:30:00',1.02),('3355','2013-10-19','09:35:00',1.06),('3355','2013-10-19','09:40:00',1.11),('3355','2013-10-19','09:45:00',1.16),('3355','2013-10-19','09:50:00',1.2),('3355','2013-10-19','09:55:00',1.29),('3355','2013-10-19','10:00:00',1.22),('3355','2013-10-19','10:05:00',1.23),('3355','2013-10-19','10:10:00',1.35),('3355','2013-10-19','10:15:00',1.29),('3355','2013-10-19','10:20:00',1.42),('3355','2013-10-19','10:25:00',1.54),('3355','2013-10-19','10:30:00',1.57),('3355','2013-10-19','10:35:00',1.57),('3355','2013-10-19','10:40:00',1.58),('3355','2013-10-19','10:45:00',1.56),('3355','2013-10-19','10:50:00',1.61),('3355','2013-10-19','10:55:00',1.66),('3355','2013-10-19','11:00:00',1.7),('3355','2013-10-19','11:05:00',1.56),('3355','2013-10-19','11:20:00',1.26),('3355','2013-10-19','11:25:00',1.86),('3355','2013-10-19','11:30:00',1.87),('3355','2013-10-19','11:35:00',1.9),('3355','2013-10-19','11:40:00',1.81),('3355','2013-10-19','11:45:00',1.89),('3355','2013-10-19','11:50:00',1.88),('3355','2013-10-19','11:55:00',1.84),('3355','2013-10-19','12:00:00',1.93),('3355','2013-10-19','12:05:00',1.93),('3355','2013-10-19','12:10:00',1.9),('3355','2013-10-19','12:15:00',1.91),('3355','2013-10-19','12:20:00',1.94),('3355','2013-10-19','12:25:00',1.75),('3355','2013-10-19','12:30:00',1.9),('3355','2013-10-19','12:35:00',1.97),('3355','2013-10-19','12:40:00',2.03),('3355','2013-10-19','12:45:00',2.05),('3355','2013-10-19','12:50:00',2.1),('3355','2013-10-19','12:55:00',2.06),('3355','2013-10-19','13:00:00',2.23),('3355','2013-10-19','13:05:00',1.89),('3355','2013-10-19','13:10:00',1.77),('3355','2013-10-19','13:15:00',1.8),('3355','2013-10-19','13:20:00',1.88),('3355','2013-10-19','13:25:00',2.02),('3355','2013-10-19','13:30:00',2.2),('3355','2013-10-19','13:35:00',1.65),('3355','2013-10-19','13:40:00',1.32),('3355','2013-10-19','13:45:00',1.29),('3355','2013-10-19','13:50:00',1.52),('3355','2013-10-19','13:55:00',1.93),('3355','2013-10-19','14:00:00',1.72),('3355','2013-10-19','14:05:00',1.46),('3355','2013-10-19','14:10:00',1.07),('3355','2013-10-19','14:15:00',1.42),('3355','2013-10-19','14:20:00',1.32),('3355','2013-10-19','14:25:00',1.1),('3355','2013-10-19','14:30:00',1.21),('3355','2013-10-19','14:35:00',2.04),('3355','2013-10-19','14:40:00',1.54),('3355','2013-10-19','14:45:00',1.19),('3355','2013-10-19','14:50:00',1.81),('3355','2013-10-19','14:55:00',1.77),('3355','2013-10-19','15:00:00',1.72),('3355','2013-10-19','15:05:00',1.66),('3355','2013-10-19','15:10:00',1.65),('3355','2013-10-19','15:15:00',1.63),('3355','2013-10-19','15:20:00',1.52),('3355','2013-10-19','15:25:00',1.46),('3355','2013-10-19','15:30:00',1.4),('3355','2013-10-19','15:35:00',1.38),('3355','2013-10-19','15:40:00',1.31),('3355','2013-10-19','15:45:00',1.13),('3355','2013-10-19','15:50:00',1.13),('3355','2013-10-19','15:55:00',1.31),('3355','2013-10-19','16:00:00',1.1),('3355','2013-10-19','16:05:00',1.16),('3355','2013-10-19','16:10:00',1.13),('3355','2013-10-19','16:15:00',1.17),('3355','2013-10-19','16:20:00',1.16),('3355','2013-10-19','16:30:00',1.03),('3355','2013-10-19','16:35:00',1.06),('3355','2013-10-19','16:40:00',1.02),('3355','2014-05-04','08:30:00',1.01),('3355','2014-05-04','09:05:00',1.38),('3355','2014-05-04','09:10:00',1.22),('3355','2014-05-04','09:15:00',1.3),('3355','2014-05-04','09:20:00',1.93),('3355','2014-05-04','09:25:00',1.46),('3355','2014-05-04','09:45:00',1.15),('3355','2014-05-04','09:50:00',1.35),('3355','2014-05-04','09:55:00',1.4),('3355','2014-05-04','10:00:00',1.97),('3355','2014-05-04','10:05:00',2.07),('3355','2014-05-04','10:10:00',1.79),('3355','2014-05-04','10:15:00',1.51),('3355','2014-05-04','10:20:00',1.07),('3355','2014-05-04','10:25:00',1.05),('3355','2014-05-04','10:30:00',1.09),('3355','2014-05-04','10:35:00',1.14),('3355','2014-05-04','10:40:00',1.22),('3355','2014-05-04','10:45:00',1.48),('3355','2014-05-04','10:50:00',1.39),('3355','2014-05-04','10:55:00',1.78),('3355','2014-05-04','11:00:00',1.65),('3355','2014-05-04','11:05:00',2.15),('3355','2014-05-04','11:10:00',2.04),('3355','2014-05-04','11:15:00',2.17),('3355','2014-05-04','11:20:00',2.35),('3355','2014-05-04','11:25:00',2),('3355','2014-05-04','11:30:00',2.27),('3355','2014-05-04','11:35:00',2.16),('3355','2014-05-04','11:40:00',1.65),('3355','2014-05-04','11:45:00',2.15),('3355','2014-05-04','11:50:00',1.85),('3355','2014-05-04','11:55:00',1.97),('3355','2014-05-04','12:00:00',1.88),('3355','2014-05-04','12:05:00',1.43),('3355','2014-05-04','12:10:00',1.02),('3355','2014-05-04','12:20:00',1.02),('3355','2014-05-04','12:25:00',1.02),('3355','2014-05-04','12:30:00',2.77),('3355','2014-05-04','12:35:00',2.27),('3355','2014-05-04','12:40:00',2.16),('3355','2014-05-04','12:45:00',1.33),('3355','2014-05-04','12:50:00',1.9),('3355','2014-05-04','12:55:00',1.44),('3355','2014-05-04','13:00:00',1.12),('3355','2014-05-04','13:05:00',1.1),('3355','2014-05-04','13:10:00',1.11),('3355','2014-05-04','13:15:00',1.06),('3355','2014-05-04','13:20:00',1),('3355','2014-05-04','15:00:00',1.01),('3355','2014-05-04','15:05:00',1.61),('3355','2014-05-04','15:10:00',2.23),('3355','2014-05-04','15:15:00',1.7),('3355','2014-04-16','08:55:00',1.06),('3355','2014-04-16','09:00:00',1.11),('3355','2014-04-16','09:05:00',1.17),('3355','2014-04-16','09:10:00',1.22),('3355','2014-04-16','09:15:00',1.25),('3355','2014-04-16','09:20:00',1.31),('3355','2014-04-16','09:25:00',1.38),('3355','2014-04-16','09:30:00',1.27),('3355','2014-04-16','09:50:00',1.2),('3355','2014-04-16','09:55:00',1.8),('3355','2014-04-16','10:00:00',1.74),('3355','2014-04-16','10:05:00',1.77),('3355','2014-04-16','10:10:00',1.82),('3355','2014-04-16','10:15:00',1.86),('3355','2014-04-16','10:20:00',1.9),('3355','2014-04-16','10:25:00',1.93),('3355','2014-04-16','10:30:00',1.97),('3355','2014-04-16','10:35:00',2),('3355','2014-04-16','10:40:00',2.03),('3355','2014-04-16','10:45:00',2.07),('3355','2014-04-16','10:50:00',2.15),('3355','2014-04-16','10:55:00',1.97),('3355','2014-04-16','11:00:00',2.08),('3355','2014-04-16','11:05:00',1.85),('3355','2014-04-16','11:15:00',1.17),('3355','2014-04-16','11:20:00',2.36),('3355','2014-04-16','11:25:00',1.88),('3355','2014-04-16','11:30:00',2.08),('3355','2014-04-16','11:35:00',1.64),('3355','2014-04-16','11:40:00',2.03),('3355','2014-04-16','11:45:00',2.22),('3355','2014-04-16','11:50:00',2.53),('3355','2014-04-16','11:55:00',2.58),('3355','2014-04-16','12:00:00',2.65),('3355','2014-04-16','12:05:00',1.52),('3355','2014-04-16','12:10:00',1.87),('3355','2014-04-16','12:20:00',2.36),('3355','2014-04-16','12:25:00',1.03),('3355','2014-04-16','12:30:00',1.33),('3355','2014-04-16','12:35:00',2.63),('3355','2014-04-16','12:40:00',2.68),('3355','2014-04-16','12:45:00',2.6),('3355','2014-04-16','12:50:00',2.41),('3355','2014-04-16','12:55:00',1.89),('3355','2014-04-16','13:00:00',1.53),('3355','2014-04-16','13:40:00',1.27),('3355','2014-04-16','13:45:00',2.34),('3355','2014-04-16','13:50:00',2.26),('3355','2014-04-16','13:55:00',1.5),('3355','2014-04-16','14:05:00',1.31),('3355','2014-04-16','14:10:00',2.73),('3355','2014-04-16','14:15:00',2.86),('3355','2014-04-16','14:20:00',2.64),('3355','2014-04-16','14:25:00',1.98),('3355','2014-04-16','14:30:00',2.06),('3355','2014-04-16','14:35:00',2.52),('3355','2014-04-16','14:40:00',2.44),('3355','2014-04-16','14:45:00',1.72),('3355','2014-04-16','14:50:00',1.91),('3355','2014-04-16','15:00:00',1.18),('3355','2014-04-16','15:05:00',1.68),('3355','2014-04-16','15:10:00',2.79),('3355','2014-04-16','15:15:00',1.57),('3355','2014-04-16','15:30:00',1.8),('3355','2014-04-16','15:35:00',2.44),('3355','2014-04-16','15:40:00',2.36),('3355','2014-04-16','15:45:00',2.25),('3355','2014-04-16','15:50:00',2.18),('3355','2014-04-16','15:55:00',2.13),('3355','2014-04-16','16:00:00',2.07),('3355','2014-04-16','16:05:00',2.02),('3355','2014-04-16','16:10:00',1.97),('3355','2014-04-16','16:15:00',1.94),('3355','2014-04-16','16:20:00',1.88),('3355','2014-04-16','16:25:00',1.87),('3355','2014-04-16','16:30:00',1.84),('3355','2014-04-16','16:35:00',1.8),('3355','2014-04-16','16:40:00',1.77),('3355','2014-04-16','16:45:00',1.73),('3355','2014-04-16','16:50:00',1.66),('3355','2014-04-16','16:55:00',1.61),('3355','2014-04-16','17:00:00',1.56),('3355','2014-04-16','17:05:00',1.51),('3355','2014-04-16','17:10:00',1.46),('3355','2014-04-16','17:15:00',1.43),('3355','2014-04-16','17:20:00',1.35),('3355','2014-04-16','17:25:00',1.29),('3355','2014-04-16','17:30:00',1.24),('3355','2014-04-16','17:35:00',1.21),('3355','2014-04-16','17:40:00',1.14),('3355','2014-04-16','17:45:00',1.1),('3355','2014-04-16','17:50:00',1.11),('3355','2014-04-16','17:55:00',1.1),('3355','2014-04-16','18:00:00',1),('3355','2013-10-18','09:30:00',1.01),('3355','2013-10-18','09:35:00',1.06),('3355','2013-10-18','09:40:00',1.11),('3355','2013-10-18','09:45:00',1.16),('3355','2013-10-18','09:50:00',1.2),('3355','2013-10-18','09:55:00',1.24),('3355','2013-10-18','10:00:00',1.28),('3355','2013-10-18','10:05:00',1.33),('3355','2013-10-18','10:10:00',1.36),('3355','2013-10-18','10:15:00',1.39),('3355','2013-10-18','10:20:00',1.41),('3355','2013-10-18','10:25:00',1.47),('3355','2013-10-18','10:30:00',1.5),('3355','2013-10-18','10:35:00',1.54),('3355','2013-10-18','10:40:00',1.57),('3355','2013-10-18','10:45:00',1.6),('3355','2013-10-18','10:50:00',1.62),('3355','2013-10-18','10:55:00',1.65),('3355','2013-10-18','11:00:00',1.65),('3355','2013-10-18','11:05:00',1.64),('3355','2013-10-18','11:10:00',1.61),('3355','2013-10-18','11:15:00',1.6),('3355','2013-10-18','11:20:00',1.75),('3355','2013-10-18','11:25:00',1.66),('3355','2013-10-18','11:30:00',1.78),('3355','2013-10-18','11:35:00',1.81),('3355','2013-10-18','11:40:00',1.86),('3355','2013-10-18','11:45:00',1.45),('3355','2013-10-18','11:50:00',1.81),('3355','2013-10-18','11:55:00',1.89),('3355','2013-10-18','12:00:00',1.82),('3355','2013-10-18','12:05:00',1.89),('3355','2013-10-18','12:10:00',1.89),('3355','2013-10-18','12:15:00',1.87),('3355','2013-10-18','12:20:00',1.86),('3355','2013-10-18','12:25:00',1.89),('3355','2013-10-18','12:30:00',1.91),('3355','2013-10-18','12:35:00',1.88),('3355','2013-10-18','12:40:00',1.91),('3355','2013-10-18','12:45:00',1.86),('3355','2013-10-18','12:50:00',1.87),('3355','2013-10-18','12:55:00',1.92),('3355','2013-10-18','13:00:00',1.91),('3355','2013-10-18','13:05:00',1.85),('3355','2013-10-18','13:10:00',1.78),('3355','2013-10-18','13:15:00',1.86),('3355','2013-10-18','13:20:00',1.86),('3355','2013-10-18','13:25:00',1.92),('3355','2013-10-18','13:30:00',1.91),('3355','2013-10-18','13:35:00',1.9),('3355','2013-10-18','13:40:00',1.9),('3355','2013-10-18','13:45:00',1.86),('3355','2013-10-18','13:50:00',1.85),('3355','2013-10-18','13:55:00',1.86),('3355','2013-10-18','14:00:00',1.72),('3355','2013-10-18','14:05:00',1.76),('3355','2013-10-18','14:10:00',1.74),('3355','2013-10-18','14:15:00',1.78),('3355','2013-10-18','14:20:00',1.78),('3355','2013-10-18','14:25:00',1.76),('3355','2013-10-18','14:30:00',1.75),('3355','2013-10-18','14:35:00',1.68),('3355','2013-10-18','14:40:00',1.7),('3355','2013-10-18','14:45:00',1.65),('3355','2013-10-18','14:50:00',1.59),('3355','2013-10-18','14:55:00',1.62),('3355','2013-10-18','15:00:00',1.41),('3355','2013-10-18','15:05:00',1.28),('3355','2013-10-18','15:10:00',1.42),('3355','2013-10-18','15:15:00',1.43),('3355','2013-10-18','15:20:00',1.49),('3355','2013-10-18','15:25:00',1.42),('3355','2013-10-18','15:30:00',1.34),('3355','2013-10-18','15:35:00',1.35),('3355','2013-10-18','15:40:00',1.3),('3355','2013-10-18','15:45:00',1.2),('3355','2013-10-18','15:50:00',1.18),('3355','2013-10-18','15:55:00',1.08),('3355','2013-10-18','16:00:00',1.15),('3355','2013-10-18','16:05:00',1.09),('3355','2013-10-18','16:10:00',1.05),('3355','2013-10-17','09:30:00',1.01),('3355','2013-10-17','09:35:00',1.06),('3355','2013-10-17','09:40:00',1.11),('3355','2013-10-17','09:45:00',1.15),('3355','2013-10-17','09:50:00',1.2),('3355','2013-10-17','09:55:00',1.23),('3355','2013-10-17','10:00:00',1.27),('3355','2013-10-17','10:05:00',1.31),('3355','2013-10-17','10:10:00',1.35),('3355','2013-10-17','10:15:00',1.39),('3355','2013-10-17','10:20:00',1.44),('3355','2013-10-17','10:25:00',1.47),('3355','2013-10-17','10:30:00',1.51),('3355','2013-10-17','10:35:00',1.55),('3355','2013-10-17','10:40:00',1.58),('3355','2013-10-17','10:45:00',1.62),('3355','2013-10-17','10:50:00',1.64),('3355','2013-10-17','10:55:00',1.67),('3355','2013-10-17','11:00:00',1.71),('3355','2013-10-17','11:05:00',1.73),('3355','2013-10-17','11:10:00',1.75),('3355','2013-10-17','11:15:00',1.77),('3355','2013-10-17','11:20:00',1.79),('3355','2013-10-17','11:25:00',1.81),('3355','2013-10-17','11:30:00',1.83),('3355','2013-10-17','11:35:00',1.86),('3355','2013-10-17','11:40:00',1.88),('3355','2013-10-17','11:45:00',1.88),('3355','2013-10-17','11:50:00',1.89),('3355','2013-10-17','11:55:00',1.91),('3355','2013-10-17','12:00:00',1.91),('3355','2013-10-17','12:05:00',1.93),('3355','2013-10-17','12:10:00',1.94),('3355','2013-10-17','12:15:00',1.95),('3355','2013-10-17','12:20:00',1.96),('3355','2013-10-17','12:25:00',1.98),('3355','2013-10-17','12:30:00',1.96),('3355','2013-10-17','12:35:00',1.97),('3355','2013-10-17','12:40:00',1.98),('3355','2013-10-17','12:45:00',2),('3355','2013-10-17','12:50:00',2),('3355','2013-10-17','12:55:00',2.01),('3355','2013-10-17','13:00:00',2.02),('3355','2013-10-17','13:05:00',2.01),('3355','2013-10-17','13:10:00',2),('3355','2013-10-17','13:15:00',1.99),('3355','2013-10-17','13:20:00',2),('3355','2013-10-17','13:25:00',1.99),('3355','2013-10-17','13:30:00',1.98),('3355','2013-10-17','13:35:00',1.97),('3355','2013-10-17','13:40:00',1.95),('3355','2013-10-17','13:45:00',1.94),('3355','2013-10-17','13:50:00',1.94),('3355','2013-10-17','13:55:00',1.93),('3355','2013-10-17','14:00:00',1.93),('3355','2013-10-17','14:05:00',1.92),('3355','2013-10-17','14:10:00',1.9),('3355','2013-10-17','14:15:00',1.89),('3355','2013-10-17','14:20:00',1.87),('3355','2013-10-17','14:25:00',1.86),('3355','2013-10-17','14:30:00',1.84),('3355','2013-10-17','14:35:00',1.8),('3355','2013-10-17','14:40:00',1.78),('3355','2013-10-17','14:45:00',1.78),('3355','2013-10-17','14:50:00',1.75),('3355','2013-10-17','14:55:00',1.72),('3355','2013-10-17','15:00:00',1.7),('3355','2013-10-17','15:05:00',1.67),('3355','2013-10-17','15:10:00',1.65),('3355','2013-10-17','15:15:00',1.62),('3355','2013-10-17','15:20:00',1.59),('3355','2013-10-17','15:25:00',1.56),('3355','2013-10-17','15:30:00',1.53),('3355','2013-10-17','15:35:00',1.49),('3355','2013-10-17','15:40:00',1.45),('3355','2013-10-17','15:45:00',1.41),('3355','2013-10-17','15:50:00',1.38),('3355','2013-10-17','15:55:00',1.34),('3355','2013-10-17','16:00:00',1.3),('3355','2013-10-17','16:05:00',1.24),('3355','2013-10-17','16:10:00',1.21),('3355','2013-10-17','16:15:00',1.17),('3355','2013-10-17','16:20:00',1.14),('3355','2013-10-17','16:25:00',1.1),('3355','2013-10-17','16:30:00',1.05),('3355','2013-10-17','16:35:00',1),('3355','2013-10-16','09:50:00',1.08),('3355','2013-10-16','12:15:00',1.05),('3355','2013-10-16','12:20:00',2.03),('3355','2013-10-16','12:35:00',1.13),('3355','2013-10-16','12:40:00',1.98),('3355','2013-10-16','12:45:00',2.07),('3355','2013-10-16','12:50:00',1.71),('3355','2013-10-16','12:55:00',1.73),('3355','2013-10-16','13:00:00',1.71),('3355','2013-10-16','13:05:00',1.78),('3355','2013-10-16','13:10:00',1.61),('3355','2013-10-16','13:15:00',1.89),('3355','2013-10-16','13:20:00',1.76),('3355','2013-10-16','13:25:00',1.86),('3355','2013-10-16','13:30:00',2.13),('3355','2013-10-16','13:35:00',2),('3355','2013-10-16','13:40:00',2),('3355','2013-10-16','13:45:00',1.98),('3355','2013-10-16','13:50:00',1.96),('3355','2013-10-16','13:55:00',2.06),('3355','2013-10-16','14:00:00',1.72),('3355','2013-10-16','14:05:00',1.22),('3355','2013-10-16','14:10:00',2.14),('3355','2013-10-16','14:15:00',2.02),('3355','2013-10-16','14:20:00',1.56),('3355','2013-10-16','14:25:00',2.03),('3355','2013-10-16','14:30:00',1.95),('3355','2013-10-16','14:35:00',1.79),('3355','2013-10-16','14:40:00',1.47),('3355','2013-10-16','14:45:00',1.89),('3355','2013-10-16','14:50:00',1.57),('3355','2013-10-16','14:55:00',1.62),('3355','2013-10-16','15:00:00',1.6),('3355','2013-10-16','15:05:00',1.66),('3355','2013-10-16','15:10:00',1.62),('3355','2013-10-16','15:15:00',1.67),('3355','2013-10-16','15:20:00',1.57),('3355','2013-10-16','15:25:00',1.49),('3355','2013-10-16','15:40:00',1.58),('3355','2013-10-16','15:45:00',1.45),('3355','2013-10-16','15:50:00',1.37),('3355','2013-10-16','15:55:00',1.35),('3355','2013-10-16','16:00:00',1.3),('3355','2013-10-16','16:05:00',1.27),('3355','2013-10-16','16:10:00',1.05),('3355','2013-10-16','16:15:00',1.18),('3355','2013-10-16','16:20:00',1.13),('3355','2013-10-16','16:25:00',1.08),('3355','2013-10-16','16:30:00',1.01),('3355','2013-10-15','09:45:00',1.01),('3355','2013-10-15','09:50:00',1.16),('3355','2013-10-15','09:55:00',1.22),('3355','2013-10-15','10:00:00',1.23),('3355','2013-10-15','10:05:00',1.33),('3355','2013-10-15','10:10:00',1.06),('3355','2013-10-15','10:30:00',1.09),('3355','2013-10-15','10:40:00',1.05),('3355','2013-10-15','10:45:00',1.23),('3355','2013-10-15','10:50:00',1.25),('3355','2013-10-15','10:55:00',1.05),('3355','2013-10-15','11:00:00',1.04),('3355','2013-10-15','11:05:00',1.08),('3355','2013-10-15','11:10:00',1.45),('3355','2013-10-15','11:15:00',1.58),('3355','2013-10-15','11:20:00',1.6),('3355','2013-10-15','11:25:00',1.51),('3355','2013-10-15','11:30:00',1.57),('3355','2013-10-15','11:35:00',1.36),('3355','2013-10-15','11:40:00',1.06),('3355','2013-10-15','13:10:00',1.02),('3355','2013-10-15','13:15:00',1.02),('3355','2013-10-15','13:20:00',1.49),('3355','2013-10-15','13:25:00',1.79),('3355','2013-10-15','13:30:00',1.14),('3355','2013-10-15','14:20:00',1.15),('3355','2013-10-15','14:25:00',1.24),('3355','2013-10-15','14:30:00',1.31),('3355','2013-10-15','14:45:00',1.1),('3355','2013-10-15','14:50:00',1.38),('3355','2013-10-15','14:55:00',1.24),('3355','2013-10-14','09:35:00',1.01),('3355','2013-10-14','09:55:00',1.09),('3355','2013-10-14','10:00:00',1.06),('3355','2013-10-14','10:05:00',1.18),('3355','2013-10-14','10:10:00',1.22),('3355','2013-10-14','10:15:00',1.33),('3355','2013-10-14','10:20:00',1.35),('3355','2013-10-14','10:25:00',1.38),('3355','2013-10-14','10:30:00',1.41),('3355','2013-10-14','10:35:00',1.43),('3355','2013-10-14','10:40:00',1.42),('3355','2013-10-14','10:45:00',1.46),('3355','2013-10-14','10:50:00',1.53),('3355','2013-10-14','10:55:00',1.56),('3355','2013-10-14','11:00:00',1.6),('3355','2013-10-14','11:05:00',1.59),('3355','2013-10-14','11:10:00',1.66),('3355','2013-10-14','11:15:00',1.66),('3355','2013-10-14','11:20:00',1.66),('3355','2013-10-14','11:25:00',1.69),('3355','2013-10-14','11:30:00',1.74),('3355','2013-10-14','11:35:00',1.7),('3355','2013-10-14','11:40:00',1.72),('3355','2013-10-14','11:45:00',1.73),('3355','2013-10-14','11:50:00',1.74),('3355','2013-10-14','11:55:00',1.76),('3355','2013-10-14','12:00:00',1.78),('3355','2013-10-14','12:05:00',1.79),('3355','2013-10-14','12:10:00',1.83),('3355','2013-10-14','12:15:00',1.82),('3355','2013-10-14','12:20:00',1.7),('3355','2013-10-14','12:25:00',1.77),('3355','2013-10-14','12:30:00',1.87),('3355','2013-10-14','12:35:00',1.86),('3355','2013-10-14','12:40:00',1.85),('3355','2013-10-14','12:45:00',1.87),('3355','2013-10-14','12:50:00',1.86),('3355','2013-10-14','12:55:00',1.87),('3355','2013-10-14','13:00:00',1.87),('3355','2013-10-14','13:05:00',1.87),('3355','2013-10-14','13:10:00',1.86),('3355','2013-10-14','13:15:00',1.85),('3355','2013-10-14','13:20:00',1.86),('3355','2013-10-14','13:25:00',1.85),('3355','2013-10-14','13:30:00',1.84),('3355','2013-10-14','13:35:00',1.83),('3355','2013-10-14','13:40:00',1.82),('3355','2013-10-14','13:45:00',1.81),('3355','2013-10-14','13:50:00',1.8),('3355','2013-10-14','13:55:00',1.8),('3355','2013-10-14','14:00:00',1.79),('3355','2013-10-14','14:05:00',1.78),('3355','2013-10-14','14:10:00',1.77),('3355','2013-10-14','14:15:00',1.76),('3355','2013-10-14','14:20:00',1.74),('3355','2013-10-14','14:25:00',1.73),('3355','2013-10-14','14:30:00',1.72),('3355','2013-10-14','14:35:00',1.7),('3355','2013-10-14','14:40:00',1.66),('3355','2013-10-14','14:45:00',1.65),('3355','2013-10-14','14:50:00',1.64),('3355','2013-10-14','14:55:00',1.61),('3355','2013-10-14','15:00:00',1.59),('3355','2013-10-14','15:05:00',1.57),('3355','2013-10-14','15:10:00',1.52),('3355','2013-10-14','15:15:00',1.48),('3355','2013-10-14','15:20:00',1.46),('3355','2013-10-14','15:25:00',1.42),('3355','2013-10-14','15:30:00',1.38),('3355','2013-10-14','15:35:00',1.33),('3355','2013-10-14','15:40:00',1.23),('3355','2013-10-14','15:45:00',1),('3355','2013-10-13','09:40:00',1.15),('3355','2013-10-13','09:45:00',1.44),('3355','2013-10-13','09:50:00',1.42),('3355','2013-10-13','09:55:00',1.48),('3355','2013-10-13','10:00:00',1.17),('3355','2013-10-13','10:10:00',1.08),('3355','2013-10-13','10:15:00',1.29),('3355','2013-10-13','10:20:00',1.06),('3355','2013-10-13','10:25:00',1.16),('3355','2013-10-13','10:30:00',1.46),('3355','2013-10-13','10:35:00',1.71),('3355','2013-10-13','10:40:00',1.78),('3355','2013-10-13','10:45:00',1.82),('3355','2013-10-13','10:50:00',1.49),('3355','2013-10-13','10:55:00',1.2),('3355','2013-10-13','11:00:00',1.55),('3355','2013-10-13','11:05:00',1.69),('3355','2013-10-13','11:10:00',1.63),('3355','2013-10-13','11:15:00',1.8),('3355','2013-10-13','11:20:00',1.73),('3355','2013-10-13','11:25:00',1.7),('3355','2013-10-13','11:30:00',1.75),('3355','2013-10-13','11:35:00',1.75),('3355','2013-10-13','11:40:00',1.76),('3355','2013-10-13','11:45:00',1.77),('3355','2013-10-13','11:50:00',1.79),('3355','2013-10-13','11:55:00',1.79),('3355','2013-10-13','12:00:00',1.81),('3355','2013-10-13','12:05:00',1.82),('3355','2013-10-13','12:10:00',1.83),('3355','2013-10-13','12:15:00',1.85),('3355','2013-10-13','12:20:00',1.81),('3355','2013-10-13','12:25:00',1.75),('3355','2013-10-13','12:30:00',1.87),('3355','2013-10-13','12:35:00',1.9),('3355','2013-10-13','12:40:00',1.9),('3355','2013-10-13','12:45:00',1.87),('3355','2013-10-13','12:50:00',1.85),('3355','2013-10-13','12:55:00',1.86),('3355','2013-10-13','13:00:00',1.87),('3355','2013-10-13','13:05:00',1.87),('3355','2013-10-13','13:10:00',1.88),('3355','2013-10-13','13:15:00',1.91),('3355','2013-10-13','13:20:00',1.92),('3355','2013-10-13','13:25:00',1.67),('3355','2013-10-13','13:30:00',1.39),('3355','2013-10-13','13:35:00',1.59),('3355','2013-10-13','13:40:00',1.03),('3355','2013-10-13','13:45:00',1.1),('3355','2013-10-13','13:50:00',1.22),('3355','2013-10-13','13:55:00',1.41),('3355','2013-10-13','14:00:00',1.85),('3355','2013-10-13','14:05:00',1.84),('3355','2013-10-13','14:10:00',1.8),('3355','2013-10-13','14:15:00',1.68),('3355','2013-10-13','14:20:00',1.83),('3355','2013-10-13','14:25:00',1.85),('3355','2013-10-13','14:30:00',1.67),('3355','2013-10-13','14:35:00',1.37),('3355','2013-10-13','14:40:00',1.62),('3355','2013-10-13','14:45:00',1.29),('3355','2013-10-13','14:50:00',1),('3355','2013-10-13','14:55:00',1.23),('3355','2013-10-13','15:00:00',1.47),('3355','2013-10-13','15:05:00',1.36),('3355','2013-10-13','15:15:00',1.08),('3355','2013-10-13','15:20:00',1.24),('3355','2013-10-13','15:25:00',1.41),('3355','2013-10-13','15:30:00',1),('3355','2013-10-13','16:05:00',1.04),('3355','2013-10-13','16:25:00',1.14),('3355','2013-10-13','16:30:00',1.12),('3355','2013-10-12','11:40:00',1.64),('3355','2013-10-12','12:25:00',2.1),('3355','2013-10-12','12:30:00',1.59),('3355','2013-10-12','12:35:00',1.84),('3355','2013-10-12','12:40:00',1.83),('3355','2013-10-12','12:45:00',1.72),('3355','2013-10-12','12:50:00',1.57),('3355','2013-10-12','12:55:00',1.39),('3355','2013-10-12','13:00:00',1.04),('3355','2013-10-12','13:30:00',2.25),('3355','2013-10-11','09:45:00',1.22),('3355','2013-10-11','09:50:00',1.03),('3355','2013-10-11','09:55:00',1.27),('3355','2013-10-11','10:00:00',1.3),('3355','2013-10-11','10:05:00',1.33),('3355','2013-10-11','10:10:00',1.38),('3355','2013-10-11','10:15:00',1.03),('3355','2013-10-11','10:20:00',1.11),('3355','2013-10-11','10:35:00',1.32),('3355','2013-10-11','11:05:00',1.49),('3355','2013-10-11','11:10:00',1.41),('3355','2013-10-11','11:50:00',1.39),('3355','2013-10-11','12:00:00',1.6),('3355','2013-10-11','12:05:00',2.35),('3355','2013-10-11','12:10:00',1.11),('3355','2013-10-11','13:05:00',1.35),('3355','2013-10-11','13:10:00',1.15),('3355','2013-10-11','13:20:00',1.4),('3355','2013-10-11','13:25:00',2.45),('3355','2013-10-11','13:45:00',2.02),('3355','2013-10-11','16:00:00',1.02),('3355','2013-10-11','16:35:00',1.07),('3355','2013-10-10','09:35:00',1.06),('3355','2013-10-10','10:20:00',1.47),('3355','2013-10-10','10:25:00',1.39),('3355','2013-10-10','10:30:00',1.26),('3355','2013-10-10','10:45:00',1.33),('3355','2013-10-10','11:20:00',1.08),('3355','2013-10-10','11:25:00',2.15),('3355','2013-10-10','11:30:00',1.16),('3355','2013-10-10','11:40:00',1.26),('3355','2013-10-10','11:45:00',1.73),('3355','2013-10-10','11:55:00',2.02),('3355','2013-10-10','12:25:00',1.39),('3355','2013-10-10','12:30:00',1.49),('3355','2013-10-10','12:35:00',2.41),('3355','2013-10-10','12:40:00',2.05),('3355','2013-10-10','12:45:00',2.05),('3355','2013-10-10','12:50:00',1.39),('3355','2013-10-10','13:00:00',1.42),('3355','2013-10-10','13:05:00',2),('3355','2013-10-10','13:20:00',1.18),('3355','2013-10-10','13:25:00',1.01),('3355','2013-10-10','13:40:00',1.7),('3355','2013-10-10','13:45:00',1.69),('3355','2013-10-10','13:50:00',2.05),('3355','2013-10-10','13:55:00',2.09),('3355','2013-10-10','14:00:00',1.95),('3355','2013-10-10','14:05:00',1.03),('3355','2013-10-10','14:10:00',1.64),('3355','2013-10-10','14:15:00',1.33),('3355','2013-10-10','14:20:00',2.21),('3355','2013-10-10','14:25:00',1.5),('3355','2013-10-10','14:30:00',1.45),('3355','2013-10-10','14:35:00',1.46),('3355','2013-10-10','14:40:00',2.08),('3355','2013-10-10','14:45:00',1.44),('3355','2013-10-10','14:50:00',1.66),('3355','2013-10-10','14:55:00',1.94),('3355','2013-10-10','15:00:00',1.89),('3355','2013-10-10','15:05:00',1.87),('3355','2013-10-10','15:10:00',1.84),('3355','2013-10-10','15:15:00',1.45),('3355','2013-10-10','15:20:00',1.39),('3355','2013-10-10','15:30:00',1.24),('3355','2013-10-10','16:15:00',1.44),('3355','2013-10-10','16:20:00',1.02),('3355','2013-10-10','16:25:00',1.17),('3355','2013-10-10','16:45:00',1.06),('3355','2013-10-09','09:25:00',1.02),('3355','2013-10-09','09:30:00',1.06),('3355','2013-10-09','09:35:00',1.1),('3355','2013-10-09','09:40:00',1.16),('3355','2013-10-09','09:45:00',1.22),('3355','2013-10-09','09:50:00',1.27),('3355','2013-10-09','09:55:00',1.33),('3355','2013-10-09','10:00:00',1.41),('3355','2013-10-09','10:05:00',1.53),('3355','2013-10-09','10:10:00',1.61),('3355','2013-10-09','10:15:00',1.05),('3355','2013-10-09','10:40:00',1.29),('3355','2013-10-09','10:45:00',1.37),('3355','2013-10-09','10:50:00',1.32),('3355','2013-10-09','10:55:00',1.11),('3355','2013-10-09','11:00:00',1.38),('3355','2013-10-09','11:05:00',1.94),('3355','2013-10-09','11:10:00',2.14),('3355','2013-10-09','11:15:00',2.13),('3355','2013-10-09','11:20:00',1.93),('3355','2013-10-09','11:25:00',1.78),('3355','2013-10-09','11:30:00',2.05),('3355','2013-10-09','11:35:00',2.17),('3355','2013-10-09','11:40:00',1.44),('3355','2013-10-09','11:45:00',1.57),('3355','2013-10-09','11:50:00',1.85),('3355','2013-10-09','11:55:00',1.84),('3355','2013-10-09','12:00:00',1.58),('3355','2013-10-09','12:10:00',1.27),('3355','2013-10-09','12:20:00',1.22),('3355','2013-10-09','12:25:00',1.95),('3355','2013-10-09','12:30:00',1.68),('3355','2013-10-09','12:35:00',1.33),('3355','2013-10-09','13:15:00',1.12),('3355','2013-10-09','13:20:00',1.23),('3355','2013-10-09','13:25:00',1.24),('3355','2013-10-09','13:30:00',1.12),('3355','2013-10-09','13:40:00',1.71),('3355','2013-10-09','13:45:00',1.8),('3355','2013-10-09','13:50:00',1.42),('3355','2013-10-09','13:55:00',2.41),('3355','2013-10-09','14:00:00',1.75),('3355','2013-10-09','15:05:00',1.81),('3355','2013-10-09','15:10:00',1.79),('3355','2013-10-09','15:15:00',1.94),('3355','2013-10-09','15:20:00',1.66),('3355','2013-10-09','15:30:00',1.37),('3355','2013-10-09','15:40:00',1.62),('3355','2013-10-09','15:50:00',1.37),('3355','2013-10-09','16:40:00',1.27),('3355','2014-04-15','09:25:00',1.07),('3355','2014-04-15','09:50:00',1.4),('3355','2014-04-15','10:30:00',1.75),('3355','2014-04-15','10:35:00',1.65),('3355','2014-04-15','10:40:00',1.21),('3355','2014-04-15','10:45:00',1.82),('3355','2014-04-15','10:50:00',1.42),('3355','2014-04-15','11:05:00',2.02),('3355','2014-04-15','11:10:00',1.65),('3355','2014-04-15','11:15:00',1.04),('3355','2014-04-15','12:20:00',1.17),('3355','2014-04-15','13:20:00',1.72),('3355','2014-04-15','13:25:00',1.06),('3355','2014-04-15','13:30:00',1.29),('3355','2014-04-15','13:35:00',1.38),('3355','2014-04-15','13:40:00',1.84),('3355','2014-04-15','14:05:00',2.04),('3355','2014-04-15','14:10:00',1.92),('3355','2014-04-15','14:15:00',2.18),('3355','2014-04-15','14:20:00',1.29),('3355','2014-04-15','14:25:00',2.28),('3355','2014-04-15','14:30:00',1.08),('3355','2014-04-15','14:35:00',1.43),('3355','2014-04-15','15:25:00',1.04),('3355','2013-10-08','11:10:00',1.56),('3355','2013-10-08','11:15:00',2.32),('3355','2013-10-08','11:20:00',1.97),('3355','2013-10-08','11:25:00',1.15),('3355','2013-10-08','11:30:00',1.69),('3355','2013-10-08','11:35:00',1.42),('3355','2013-10-08','12:30:00',1.71),('3355','2013-10-08','12:35:00',1.08),('3355','2013-10-08','12:40:00',2.27),('3355','2013-10-08','12:45:00',1.76),('3355','2013-10-08','12:50:00',2.33),('3355','2013-10-08','12:55:00',2.24),('3355','2013-10-08','13:00:00',1.95),('3355','2013-10-08','13:05:00',2.24),('3355','2013-10-08','13:10:00',1.39),('3355','2013-10-08','13:15:00',1.94),('3355','2013-10-08','13:20:00',1.01),('3355','2013-10-08','13:25:00',2.25),('3355','2013-10-08','13:30:00',1.3),('3355','2013-10-08','14:10:00',1.33),('3355','2013-10-08','14:15:00',1.44),('3355','2013-10-08','14:20:00',1.62),('3355','2013-10-08','14:25:00',1.62),('3355','2013-10-08','14:30:00',1.64),('3355','2013-10-08','14:45:00',1.83),('3355','2013-10-08','14:50:00',1.98),('3355','2013-10-08','14:55:00',1.87),('3355','2013-10-08','15:00:00',1.84),('3355','2013-10-08','15:05:00',1.9),('3355','2013-10-08','15:10:00',1.84),('3355','2013-10-08','15:15:00',1.76),('3355','2013-10-08','15:20:00',1.58),('3355','2013-10-08','15:25:00',1.16),('3355','2013-10-08','15:30:00',2.05),('3355','2013-10-08','15:35:00',1.84),('3355','2013-10-08','15:40:00',1.44),('3355','2013-10-08','15:45:00',1.01),('3355','2013-10-08','15:50:00',1.58),('3355','2013-10-08','16:05:00',1.12),('3355','2013-10-07','09:25:00',1.02),('3355','2013-10-07','09:30:00',1.06),('3355','2013-10-07','09:35:00',1.11),('3355','2013-10-07','09:40:00',1.15),('3355','2013-10-07','09:45:00',1.19),('3355','2013-10-07','09:50:00',1.23),('3355','2013-10-07','09:55:00',1.28),('3355','2013-10-07','10:00:00',1.32),('3355','2013-10-07','10:05:00',1.36),('3355','2013-10-07','10:10:00',1.39),('3355','2013-10-07','10:15:00',1.43),('3355','2013-10-07','10:20:00',1.46),('3355','2013-10-07','10:25:00',1.52),('3355','2013-10-07','10:30:00',1.56),('3355','2013-10-07','10:35:00',1.62),('3355','2013-10-07','10:40:00',1.62),('3355','2013-10-07','10:45:00',1.6),('3355','2013-10-07','10:50:00',1.61),('3355','2013-10-07','10:55:00',1.69),('3355','2013-10-07','11:00:00',1.29),('3355','2013-10-07','11:05:00',1.76),('3355','2013-10-07','11:10:00',1.43),('3355','2013-10-07','11:15:00',1.75),('3355','2013-10-07','11:20:00',1.81),('3355','2013-10-07','11:25:00',1.84),('3355','2013-10-07','11:30:00',1.85),('3355','2013-10-07','11:35:00',1.87),('3355','2013-10-07','11:40:00',1.89),('3355','2013-10-07','11:45:00',1.9),('3355','2013-10-07','11:50:00',1.92),('3355','2013-10-07','11:55:00',1.95),('3355','2013-10-07','12:00:00',1.95),('3355','2013-10-07','12:05:00',2.03),('3355','2013-10-07','12:10:00',2.09),('3355','2013-10-07','12:15:00',2.22),('3355','2013-10-07','12:20:00',1.17),('3355','2013-10-07','12:25:00',2.28),('3355','2013-10-07','12:30:00',2.16),('3355','2013-10-07','12:35:00',1.9),('3355','2013-10-07','12:40:00',2.15),('3355','2013-10-07','12:45:00',2.14),('3355','2013-10-07','12:50:00',2.12),('3355','2013-10-07','12:55:00',2.16),('3355','2013-10-07','13:00:00',2.17),('3355','2013-10-07','13:05:00',2.12),('3355','2013-10-07','13:10:00',2.14),('3355','2013-10-07','13:15:00',2.13),('3355','2013-10-07','13:20:00',2.05),('3355','2013-10-07','13:25:00',1.3),('3355','2013-10-07','13:30:00',1.63),('3355','2013-10-07','13:35:00',2.04),('3355','2013-10-07','13:50:00',1.21),('3355','2013-10-07','13:55:00',2.53),('3355','2013-10-07','14:00:00',2.41),('3355','2013-10-07','14:10:00',1.08),('3355','2013-10-07','14:25:00',2.05),('3355','2013-10-07','14:30:00',1.01),('3355','2013-10-07','14:40:00',1.37),('3355','2013-10-07','14:45:00',2.15),('3355','2013-10-07','14:50:00',2.14),('3355','2013-10-07','14:55:00',2.09),('3355','2013-10-07','15:00:00',1.18),('3355','2013-10-07','15:10:00',1.8),('3355','2013-10-07','15:30:00',1.77),('3355','2013-10-07','15:35:00',1.96),('3355','2013-10-07','15:50:00',1.21),('3355','2013-10-07','15:55:00',1.47),('3355','2013-10-07','16:10:00',1.08),('3355','2013-10-07','16:15:00',1.45),('3355','2013-10-07','16:20:00',1.41),('3355','2013-10-07','16:25:00',1.33),('3355','2013-10-07','16:30:00',1.29),('3355','2013-10-07','16:35:00',1.24),('3355','2013-10-07','16:40:00',1.21),('3355','2013-10-07','16:45:00',1.17),('3355','2013-10-07','16:50:00',1.09),('3355','2013-10-07','16:55:00',1),('3355','2013-10-06','09:50:00',1.11),('3355','2013-10-06','09:55:00',1.33),('3355','2013-10-06','10:00:00',1.57),('3355','2013-10-06','10:05:00',1.61),('3355','2013-10-06','10:10:00',1.59),('3355','2013-10-06','10:15:00',1.46),('3355','2013-10-06','10:20:00',1.46),('3355','2013-10-06','10:25:00',1.64),('3355','2013-10-06','10:30:00',1.61),('3355','2013-10-06','10:35:00',1.61),('3355','2013-10-06','10:40:00',1.39),('3355','2013-10-06','10:45:00',1.15),('3355','2013-10-06','10:50:00',1.22),('3355','2013-10-06','10:55:00',1.4),('3355','2013-10-06','11:00:00',1.44),('3355','2013-10-06','11:05:00',1.54),('3355','2013-10-06','11:10:00',1.59),('3355','2013-10-06','11:15:00',1.45),('3355','2013-10-06','11:20:00',1.49),('3355','2013-10-06','11:25:00',1.67),('3355','2013-10-06','11:30:00',1.63),('3355','2013-10-06','11:35:00',1.6),('3355','2013-10-06','11:40:00',1.6),('3355','2013-10-06','11:45:00',1.17),('3355','2013-10-06','11:50:00',1.25),('3355','2013-10-06','11:55:00',1.44),('3355','2013-10-06','12:00:00',1.48),('3355','2013-10-06','12:05:00',1.5),('3355','2013-10-06','12:10:00',1.9),('3355','2013-10-06','12:15:00',1.84),('3355','2013-10-06','12:20:00',1.48),('3355','2013-10-06','12:25:00',1.48),('3355','2013-10-06','12:30:00',1.52),('3355','2013-10-06','12:35:00',1.57),('3355','2013-10-06','12:40:00',1.38),('3355','2013-10-06','12:45:00',1.43),('3355','2013-10-06','12:50:00',1.63),('3355','2013-10-06','12:55:00',1.88),('3355','2013-10-06','13:00:00',1.92),('3355','2013-10-06','13:05:00',1.87),('3355','2013-10-06','13:10:00',1.54),('3355','2013-10-06','13:15:00',1.19),('3355','2013-10-06','13:20:00',1.94),('3355','2013-10-06','13:50:00',2.12),('3355','2013-10-06','13:55:00',1.29),('3355','2013-10-06','14:05:00',1.04),('3355','2013-10-06','14:10:00',1.22),('3355','2013-10-06','14:15:00',1.18),('3355','2013-10-06','14:35:00',1.05),('3355','2013-10-06','14:40:00',1.02),('3355','2013-10-06','14:50:00',1.1),('3355','2013-10-06','14:55:00',1.38),('3355','2013-10-06','15:00:00',1.07),('3355','2013-10-04','09:55:00',1.43),('3355','2013-10-04','10:00:00',1.11),('3355','2013-10-04','10:25:00',1.12),('3355','2013-10-04','10:30:00',1.06),('3355','2013-10-04','10:40:00',1.43),('3355','2013-10-04','10:45:00',1.14),('3355','2013-10-04','10:55:00',1.54),('3355','2013-10-04','11:00:00',1.28),('3355','2013-10-04','11:15:00',1.78),('3355','2013-10-04','11:20:00',1.58),('3355','2013-10-04','11:25:00',1.63),('3355','2013-10-04','11:30:00',2.1),('3355','2013-10-04','11:35:00',2),('3355','2013-10-04','11:40:00',2.05),('3355','2013-10-04','11:45:00',2.02),('3355','2013-10-04','11:50:00',2),('3355','2013-10-04','11:55:00',1.99),('3355','2013-10-04','12:00:00',2),('3355','2013-10-04','12:05:00',2.02),('3355','2013-10-04','12:10:00',2.04),('3355','2013-10-04','12:15:00',1.97),('3355','2013-10-04','12:20:00',1.9),('3355','2013-10-04','12:25:00',2.07),('3355','2013-10-04','12:30:00',2.04),('3355','2013-10-04','12:35:00',1.79),('3355','2013-10-04','12:40:00',2.05),('3355','2013-10-04','12:45:00',2.06),('3355','2013-10-04','12:50:00',1.97),('3355','2013-10-04','12:55:00',2),('3355','2013-10-04','13:00:00',2.02),('3355','2013-10-04','13:05:00',2.05),('3355','2013-10-04','13:10:00',2.05),('3355','2013-10-04','13:15:00',2.18),('3355','2013-10-04','13:20:00',2.12),('3355','2013-10-04','13:25:00',1.99),('3355','2013-10-04','13:30:00',2.11),('3355','2013-10-04','13:35:00',1.73),('3355','2013-10-04','13:40:00',2.05),('3355','2013-10-04','13:45:00',1.99),('3355','2013-10-04','13:50:00',1.98),('3355','2013-10-04','13:55:00',1.98),('3355','2013-10-04','14:00:00',1.98),('3355','2013-10-04','14:05:00',1.97),('3355','2013-10-04','14:10:00',1.81),('3355','2013-10-04','14:15:00',1.65),('3355','2013-10-04','14:20:00',1.74),('3355','2013-10-04','14:25:00',1.91),('3355','2013-10-04','14:30:00',1.69),('3355','2013-10-04','14:35:00',1.22),('3355','2013-10-04','14:45:00',1.06),('3355','2013-10-04','14:50:00',1.43),('3355','2013-10-04','14:55:00',1.5),('3355','2013-10-04','15:00:00',1.28),('3355','2013-10-04','15:05:00',1.47),('3355','2013-10-04','15:10:00',1.27),('3355','2013-10-04','15:25:00',1.22),('3355','2013-10-04','15:30:00',1.63),('3355','2013-10-03','09:20:00',1.05),('3355','2013-10-03','09:25:00',1.1),('3355','2013-10-03','09:30:00',1.15),('3355','2013-10-03','09:35:00',1.2),('3355','2013-10-03','09:40:00',1.25),('3355','2013-10-03','09:45:00',1.3),('3355','2013-10-03','09:50:00',1.35),('3355','2013-10-03','09:55:00',1.39),('3355','2013-10-03','10:00:00',1.44),('3355','2013-10-03','10:05:00',1.49),('3355','2013-10-03','10:10:00',1.52),('3355','2013-10-03','10:15:00',1.57),('3355','2013-10-03','10:20:00',1.61),('3355','2013-10-03','10:25:00',1.64),('3355','2013-10-03','10:30:00',1.68),('3355','2013-10-03','10:35:00',1.71),('3355','2013-10-03','10:40:00',1.75),('3355','2013-10-03','10:45:00',1.79),('3355','2013-10-03','10:50:00',1.81),('3355','2013-10-03','10:55:00',1.84),('3355','2013-10-03','11:00:00',1.86),('3355','2013-10-03','11:05:00',1.89),('3355','2013-10-03','11:10:00',1.92),('3355','2013-10-03','11:15:00',1.95),('3355','2013-10-03','11:20:00',1.97),('3355','2013-10-03','11:25:00',1.99),('3355','2013-10-03','11:30:00',2),('3355','2013-10-03','11:35:00',2.04),('3355','2013-10-03','11:40:00',2.06),('3355','2013-10-03','11:45:00',2.07),('3355','2013-10-03','11:50:00',2.09),('3355','2013-10-03','11:55:00',2.11),('3355','2013-10-03','12:00:00',2.12),('3355','2013-10-03','12:05:00',2.14),('3355','2013-10-03','12:10:00',2.15),('3355','2013-10-03','12:15:00',2.14),('3355','2013-10-03','12:20:00',2.15),('3355','2013-10-03','12:25:00',2.16),('3355','2013-10-03','12:30:00',2.17),('3355','2013-10-03','12:35:00',2.17),('3355','2013-10-03','12:40:00',2.17),('3355','2013-10-03','12:45:00',2.17),('3355','2013-10-03','12:50:00',2.17),('3355','2013-10-03','12:55:00',2.18),('3355','2013-10-03','13:00:00',2.15),('3355','2013-10-03','13:05:00',2.13),('3355','2013-10-03','13:10:00',2.18),('3355','2013-10-03','13:15:00',2.17),('3355','2013-10-03','13:20:00',2.17),('3355','2013-10-03','13:25:00',2.17),('3355','2013-10-03','13:30:00',2.17),('3355','2013-10-03','13:35:00',2.17),('3355','2013-10-03','13:40:00',2.16),('3355','2013-10-03','13:45:00',2.13),('3355','2013-10-03','13:50:00',2.13),('3355','2013-10-03','13:55:00',2.14),('3355','2013-10-03','14:00:00',2.14),('3355','2013-10-03','14:05:00',2.13),('3355','2013-10-03','14:10:00',2.11),('3355','2013-10-03','14:15:00',2.09),('3355','2013-10-03','14:20:00',2.08),('3355','2013-10-03','14:25:00',2.07),('3355','2013-10-03','14:30:00',2.05),('3355','2013-10-03','14:35:00',2.04),('3355','2013-10-03','14:40:00',2.01),('3355','2013-10-03','14:45:00',1.99),('3355','2013-10-03','14:50:00',1.98),('3355','2013-10-03','14:55:00',1.95),('3355','2013-10-03','15:00:00',1.93),('3355','2013-10-03','15:05:00',1.89),('3355','2013-10-03','15:10:00',1.86),('3355','2013-10-03','15:15:00',1.84),('3355','2013-10-03','15:20:00',1.81),('3355','2013-10-03','15:25:00',1.77),('3355','2013-10-03','15:30:00',1.75),('3355','2013-10-03','15:35:00',1.72),('3355','2013-10-03','15:40:00',1.67),('3355','2013-10-03','15:45:00',1.64),('3355','2013-10-03','15:50:00',1.61),('3355','2013-10-03','15:55:00',1.57),('3355','2013-10-03','16:00:00',1.53),('3355','2013-10-03','16:05:00',1.49),('3355','2013-10-03','16:10:00',1.45),('3355','2013-10-03','16:15:00',1.4),('3355','2013-10-03','16:20:00',1.36),('3355','2013-10-03','16:25:00',1.31),('3355','2013-10-03','16:30:00',1.27),('3355','2013-10-03','16:35:00',1.23),('3355','2013-10-03','16:40:00',1.17),('3355','2013-10-03','16:45:00',1.13),('3355','2013-10-03','16:50:00',1.07),('3355','2013-10-03','16:55:00',1.02),('3355','2013-10-02','09:25:00',1.04),('3355','2013-10-02','09:30:00',1.09),('3355','2013-10-02','09:35:00',1.14),('3355','2013-10-02','09:40:00',1.18),('3355','2013-10-02','09:45:00',1.23),('3355','2013-10-02','09:50:00',1.27),('3355','2013-10-02','09:55:00',1.31),('3355','2013-10-02','10:00:00',1.35),('3355','2013-10-02','10:05:00',1.38),('3355','2013-10-02','10:10:00',1.42),('3355','2013-10-02','10:15:00',1.46),('3355','2013-10-02','10:20:00',1.5),('3355','2013-10-02','10:25:00',1.54),('3355','2013-10-02','10:30:00',1.58),('3355','2013-10-02','10:35:00',1.61),('3355','2013-10-02','10:40:00',1.66),('3355','2013-10-02','10:45:00',1.7),('3355','2013-10-02','10:50:00',1.73),('3355','2013-10-02','10:55:00',1.76),('3355','2013-10-02','11:00:00',1.79),('3355','2013-10-02','11:05:00',1.82),('3355','2013-10-02','11:10:00',1.84),('3355','2013-10-02','11:15:00',1.87),('3355','2013-10-02','11:20:00',1.89),('3355','2013-10-02','11:25:00',1.91),('3355','2013-10-02','11:30:00',1.93),('3355','2013-10-02','11:35:00',1.95),('3355','2013-10-02','11:40:00',1.97),('3355','2013-10-02','11:45:00',1.98),('3355','2013-10-02','11:50:00',2),('3355','2013-10-02','11:55:00',2.01),('3355','2013-10-02','12:00:00',2.02),('3355','2013-10-02','12:05:00',2.03),('3355','2013-10-02','12:10:00',2.05),('3355','2013-10-02','12:15:00',2.07),('3355','2013-10-02','12:20:00',2.07),('3355','2013-10-02','12:25:00',2.07),('3355','2013-10-02','12:30:00',2.08),('3355','2013-10-02','12:35:00',2.09),('3355','2013-10-02','12:40:00',2.09),('3355','2013-10-02','12:45:00',2.1),('3355','2013-10-02','12:50:00',2.12),('3355','2013-10-02','12:55:00',2.12),('3355','2013-10-02','13:00:00',2.12),('3355','2013-10-02','13:05:00',2.13),('3355','2013-10-02','13:10:00',2.12),('3355','2013-10-02','13:15:00',2.12),('3355','2013-10-02','13:20:00',2.13),('3355','2013-10-02','13:25:00',2.13),('3355','2013-10-02','13:30:00',2.12),('3355','2013-10-02','13:35:00',2.11),('3355','2013-10-02','13:40:00',2.09),('3355','2013-10-02','13:45:00',2.08),('3355','2013-10-02','13:50:00',2.08),('3355','2013-10-02','13:55:00',2.08),('3355','2013-10-02','14:00:00',2.08),('3355','2013-10-02','14:05:00',2.07),('3355','2013-10-02','14:10:00',2.05),('3355','2013-10-02','14:15:00',2.03),('3355','2013-10-02','14:20:00',2.01),('3355','2013-10-02','14:25:00',2),('3355','2013-10-02','14:30:00',1.99),('3355','2013-10-02','14:35:00',1.97),('3355','2013-10-02','14:40:00',1.94),('3355','2013-10-02','14:45:00',1.93),('3355','2013-10-02','14:50:00',1.92),('3355','2013-10-02','14:55:00',1.9),('3355','2013-10-02','15:00:00',1.87),('3355','2013-10-02','15:05:00',1.84),('3355','2013-10-02','15:10:00',1.82),('3355','2013-10-02','15:15:00',1.79),('3355','2013-10-02','15:20:00',1.76),('3355','2013-10-02','15:25:00',1.72),('3355','2013-10-02','15:30:00',1.69),('3355','2013-10-02','15:35:00',1.67),('3355','2013-10-02','15:40:00',1.64),('3355','2013-10-02','15:45:00',1.61),('3355','2013-10-02','15:50:00',1.57),('3355','2013-10-02','15:55:00',1.52),('3355','2013-10-02','16:00:00',1.49),('3355','2013-10-02','16:05:00',1.45),('3355','2013-10-02','16:10:00',1.4),('3355','2013-10-02','16:15:00',1.36),('3355','2013-10-02','16:20:00',1.32),('3355','2013-10-02','16:25:00',1.28),('3355','2013-10-02','16:30:00',1.24),('3355','2013-10-02','16:35:00',1.2),('3355','2013-10-02','16:40:00',1.15),('3355','2013-10-02','16:45:00',1.09),('3355','2013-10-02','16:50:00',1.04),('3355','2013-10-01','09:25:00',1.04),('3355','2013-10-01','09:30:00',1.09),('3355','2013-10-01','09:35:00',1.12),('3355','2013-10-01','09:40:00',1.16),('3355','2013-10-01','09:45:00',1.21),('3355','2013-10-01','09:50:00',1.25),('3355','2013-10-01','09:55:00',1.29),('3355','2013-10-01','10:00:00',1.32),('3355','2013-10-01','10:05:00',1.37),('3355','2013-10-01','10:10:00',1.41),('3355','2013-10-01','10:15:00',1.45),('3355','2013-10-01','10:20:00',1.49),('3355','2013-10-01','10:25:00',1.52),('3355','2013-10-01','10:30:00',1.58),('3355','2013-10-01','10:35:00',1.6),('3355','2013-10-01','10:40:00',1.63),('3355','2013-10-01','10:45:00',1.66),('3355','2013-10-01','10:50:00',1.69),('3355','2013-10-01','10:55:00',1.72),('3355','2013-10-01','11:00:00',1.73),('3355','2013-10-01','11:05:00',1.82),('3355','2013-10-01','11:10:00',1.96),('3355','2013-10-01','11:15:00',1.56),('3355','2013-10-01','11:30:00',2.05),('3355','2013-10-01','11:35:00',1.62),('3355','2013-10-01','11:40:00',1.72),('3355','2013-10-01','11:45:00',2.07),('3355','2013-10-01','11:50:00',2.07),('3355','2013-10-01','11:55:00',2.09),('3355','2013-10-01','12:00:00',2.04),('3355','2013-10-01','12:05:00',2.03),('3355','2013-10-01','12:10:00',1.95),('3355','2013-10-01','12:15:00',2.04),('3355','2013-10-01','12:20:00',2.1),('3355','2013-10-01','12:25:00',2.17),('3355','2013-10-01','12:30:00',2.2),('3355','2013-10-01','12:35:00',2.22),('3355','2013-10-01','12:40:00',1.14),('3355','2013-10-01','12:45:00',1.69),('3355','2013-10-01','12:50:00',2.17),('3355','2013-10-01','12:55:00',2.16),('3355','2013-10-01','13:00:00',2.15),('3355','2013-10-01','13:05:00',2.16),('3355','2013-10-01','13:20:00',1.61),('3355','2013-10-01','13:25:00',2.31),('3355','2013-10-01','13:30:00',2.35),('3355','2013-10-01','13:35:00',2.13),('3355','2013-10-01','13:40:00',2.13),('3355','2013-10-01','13:45:00',1.29),('3355','2013-10-01','13:50:00',1.34),('3355','2013-10-01','13:55:00',1.67),('3355','2013-10-01','14:00:00',2.11),('3355','2013-10-01','14:05:00',2.06),('3355','2013-10-01','14:10:00',2.03),('3355','2013-10-01','14:15:00',2),('3355','2013-10-01','14:20:00',1.98),('3355','2013-10-01','14:25:00',1.96),('3355','2013-10-01','14:30:00',1.96),('3355','2013-10-01','14:35:00',1.92),('3355','2013-10-01','14:40:00',1.94),('3355','2013-10-01','14:45:00',1.92),('3355','2013-10-01','14:50:00',1.94),('3355','2013-10-01','14:55:00',1.91),('3355','2013-10-01','15:00:00',1.88),('3355','2013-10-01','15:05:00',1.83),('3355','2013-10-01','15:10:00',1.8),('3355','2013-10-01','15:15:00',1.77),('3355','2013-10-01','15:20:00',1.76),('3355','2013-10-01','15:25:00',1.73),('3355','2013-10-01','15:30:00',1.71),('3355','2013-10-01','15:35:00',1.67),('3355','2013-10-01','15:40:00',1.64),('3355','2013-10-01','15:45:00',1.6),('3355','2013-10-01','15:50:00',1.57),('3355','2013-10-01','15:55:00',1.54),('3355','2013-10-01','16:00:00',1.48),('3355','2013-10-01','16:05:00',1.46),('3355','2013-10-01','16:10:00',1.41),('3355','2013-10-01','16:15:00',1.37),('3355','2013-10-01','16:20:00',1.33),('3355','2013-10-01','16:25:00',1.28),('3355','2013-10-01','16:30:00',1.24),('3355','2013-10-01','16:35:00',1.19),('3355','2013-10-01','16:40:00',1.15),('3355','2013-10-01','16:45:00',1.09),('3355','2013-10-01','16:50:00',1.04),('3355','2013-10-01','16:55:00',1.01),('3355','2013-09-30','10:40:00',1.14),('3355','2013-09-30','10:45:00',1.74),('3355','2013-09-30','10:50:00',1.83),('3355','2013-09-30','10:55:00',1.68),('3355','2013-09-30','11:00:00',1.11),('3355','2013-09-30','11:05:00',1.62),('3355','2013-09-30','11:10:00',1.18),('3355','2013-09-30','11:15:00',1.67),('3355','2013-09-30','11:20:00',1.4),('3355','2013-09-30','11:25:00',1.52),('3355','2013-09-30','11:40:00',1.39),('3355','2013-09-30','11:45:00',1.17),('3355','2013-09-30','12:15:00',2.12),('3355','2013-09-30','12:20:00',2.23),('3355','2013-09-30','12:25:00',2.22),('3355','2013-09-30','12:30:00',2.16),('3355','2013-09-30','12:35:00',2.16),('3355','2013-09-30','12:40:00',2.25),('3355','2013-09-30','12:45:00',1.72),('3355','2013-09-30','12:50:00',2.27),('3355','2013-09-30','12:55:00',2.2),('3355','2013-09-30','13:00:00',2.22),('3355','2013-09-30','13:05:00',2.24),('3355','2013-09-30','13:10:00',2.29),('3355','2013-09-30','13:15:00',2.24),('3355','2013-09-30','13:20:00',2.32),('3355','2013-09-30','13:25:00',2.44),('3355','2013-09-30','13:30:00',2.45),('3355','2013-09-30','13:35:00',2.04),('3355','2013-09-30','13:40:00',2.11),('3355','2013-09-30','13:45:00',2.05),('3355','2013-09-30','13:50:00',1.54),('3355','2013-09-30','13:55:00',1.17),('3355','2013-09-30','14:00:00',1.11),('3355','2013-09-30','14:30:00',1.35),('3355','2013-09-30','14:35:00',1.57),('3355','2013-09-30','14:40:00',2.17),('3355','2013-09-30','14:45:00',2.07),('3355','2013-09-30','14:50:00',1.68),('3355','2013-09-30','14:55:00',1.66),('3355','2013-09-30','15:05:00',1),('3355','2013-09-30','15:10:00',2.22),('3355','2013-09-30','15:15:00',1.59),('3355','2013-09-30','15:25:00',1.39),('3355','2013-09-30','15:30:00',1.54),('3355','2013-09-30','15:35:00',1.36),('3355','2013-09-30','15:40:00',1.95),('3355','2013-09-30','15:45:00',1.46),('3355','2013-09-30','16:20:00',1.3),('3355','2013-09-30','16:40:00',1.05),('3355','2013-09-30','16:45:00',1.11),('3355','2013-09-29','10:10:00',1.03),('3355','2013-09-29','10:15:00',1.32),('3355','2013-09-29','10:20:00',1.2),('3355','2013-09-29','10:25:00',1.07),('3355','2013-09-29','10:30:00',1.21),('3355','2013-09-29','10:35:00',1.34),('3355','2013-09-29','10:40:00',1.43),('3355','2013-09-29','10:45:00',1.49),('3355','2013-09-29','10:50:00',1.55),('3355','2013-09-29','10:55:00',1.53),('3355','2013-09-29','11:00:00',1.55),('3355','2013-09-29','11:05:00',1.52),('3355','2013-09-29','11:10:00',1.51),('3355','2013-09-29','11:15:00',1.63),('3355','2013-09-29','11:20:00',1.64),('3355','2013-09-29','11:25:00',1.51),('3355','2013-09-29','11:30:00',1.65),('3355','2013-09-29','11:35:00',1.64),('3355','2013-09-29','11:40:00',1.7),('3355','2013-09-29','11:45:00',1.74),('3355','2013-09-29','11:50:00',1.85),('3355','2013-09-29','11:55:00',1.83),('3355','2013-09-29','12:00:00',1.79),('3355','2013-09-29','12:05:00',1.86),('3355','2013-09-29','12:10:00',1.77),('3355','2013-09-29','12:15:00',1.98),('3355','2013-09-29','12:20:00',1.7),('3355','2013-09-29','12:25:00',1.01),('3355','2013-09-29','12:30:00',1.07),('3355','2013-09-29','12:35:00',1.08),('3355','2013-09-29','13:30:00',1.3),('3355','2013-09-29','13:55:00',1.23),('3355','2013-09-29','14:00:00',1.22),('3355','2013-09-29','14:05:00',1.56),('3355','2013-09-29','14:20:00',1.15),('3355','2014-04-14','09:00:00',1.03),('3355','2014-04-14','09:05:00',1.09),('3355','2014-04-14','09:10:00',1.14),('3355','2014-04-14','09:15:00',1.19),('3355','2014-04-14','09:20:00',1.23),('3355','2014-04-14','09:25:00',1.28),('3355','2014-04-14','09:30:00',1.33),('3355','2014-04-14','09:35:00',1.37),('3355','2014-04-14','09:40:00',1.42),('3355','2014-04-14','09:45:00',1.45),('3355','2014-04-14','09:50:00',1.5),('3355','2014-04-14','09:55:00',1.54),('3355','2014-04-14','10:00:00',1.58),('3355','2014-04-14','10:05:00',1.63),('3355','2014-04-14','10:10:00',1.68),('3355','2014-04-14','10:15:00',1.72),('3355','2014-04-14','10:20:00',1.75),('3355','2014-04-14','10:25:00',1.78),('3355','2014-04-14','10:30:00',1.82),('3355','2014-04-14','10:35:00',1.85),('3355','2014-04-14','10:40:00',1.88),('3355','2014-04-14','10:45:00',1.91),('3355','2014-04-14','10:50:00',1.94),('3355','2014-04-14','10:55:00',1.97),('3355','2014-04-14','11:00:00',1.99),('3355','2014-04-14','11:05:00',2.03),('3355','2014-04-14','11:10:00',2.04),('3355','2014-04-14','11:15:00',2.07),('3355','2014-04-14','11:20:00',2.09),('3355','2014-04-14','11:25:00',2.1),('3355','2014-04-14','11:30:00',2.12),('3355','2014-04-14','11:35:00',2.16),('3355','2014-04-14','11:40:00',2.18),('3355','2014-04-14','11:45:00',2.18),('3355','2014-04-14','11:50:00',2.2),('3355','2014-04-14','11:55:00',2.22),('3355','2014-04-14','12:00:00',2.23),('3355','2014-04-14','12:05:00',2.24),('3355','2014-04-14','12:10:00',2.25),('3355','2014-04-14','12:15:00',2.27),('3355','2014-04-14','12:20:00',2.29),('3355','2014-04-14','12:25:00',2.29),('3355','2014-04-14','12:30:00',2.3),('3355','2014-04-14','12:35:00',2.31),('3355','2014-04-14','12:40:00',2.32),('3355','2014-04-14','12:45:00',2.34),('3355','2014-04-14','12:50:00',2.34),('3355','2014-04-14','12:55:00',2.35),('3355','2014-04-14','13:00:00',2.36),('3355','2014-04-14','13:05:00',2.36),('3355','2014-04-14','13:10:00',2.37),('3355','2014-04-14','13:15:00',2.34),('3355','2014-04-14','13:20:00',2.37),('3355','2014-04-14','13:25:00',2.36),('3355','2014-04-14','13:30:00',2.37),('3355','2014-04-14','13:35:00',2.37),('3355','2014-04-14','13:40:00',2.38),('3355','2014-04-14','13:45:00',2.37),('3355','2014-04-14','13:50:00',2.36),('3355','2014-04-14','13:55:00',2.36),('3355','2014-04-14','14:00:00',2.35),('3355','2014-04-14','14:05:00',2.34),('3355','2014-04-14','14:10:00',2.34),('3355','2014-04-14','14:15:00',2.34),('3355','2014-04-14','14:20:00',2.35),('3355','2014-04-14','14:25:00',2.34),('3355','2014-04-14','14:30:00',2.33),('3355','2014-04-14','14:35:00',2.3),('3355','2014-04-14','14:40:00',2.29),('3355','2014-04-14','14:45:00',2.28),('3355','2014-04-14','14:50:00',2.27),('3355','2014-04-14','14:55:00',2.26),('3355','2014-04-14','15:00:00',2.23),('3355','2014-04-14','15:05:00',2.22),('3355','2014-04-14','15:10:00',2.2),('3355','2014-04-14','15:15:00',2.17),('3355','2014-04-14','15:20:00',2.15),('3355','2014-04-14','15:25:00',2.13),('3355','2014-04-14','15:30:00',2.11),('3355','2014-04-14','15:35:00',2.08),('3355','2014-04-14','15:40:00',2.06),('3355','2014-04-14','15:45:00',2.03),('3355','2014-04-14','15:50:00',2),('3355','2014-04-14','15:55:00',1.96),('3355','2014-04-14','16:00:00',1.94),('3355','2014-04-14','16:05:00',1.9),('3355','2014-04-14','16:10:00',1.86),('3355','2014-04-14','16:15:00',1.82),('3355','2014-04-14','16:20:00',1.79),('3355','2014-04-14','16:25:00',1.75),('3355','2014-04-14','16:30:00',1.71),('3355','2014-04-14','16:35:00',1.67),('3355','2014-04-14','16:40:00',1.63),('3355','2014-04-14','16:45:00',1.59),('3355','2014-04-14','16:50:00',1.54),('3355','2014-04-14','16:55:00',1.5),('3355','2014-04-14','17:00:00',1.45),('3355','2014-04-14','17:05:00',1.39),('3355','2014-04-14','17:10:00',1.35),('3355','2014-04-14','17:15:00',1.3),('3355','2014-04-14','17:20:00',1.25),('3355','2014-04-14','17:25:00',1.21),('3355','2014-04-14','17:30:00',1.14),('3355','2014-04-14','17:35:00',1.08),('3355','2014-04-14','17:40:00',1.02),('3355','2013-09-28','09:25:00',1.01),('3355','2013-09-28','09:30:00',1.05),('3355','2013-09-28','09:40:00',1.14),('3355','2013-09-28','09:45:00',1.15),('3355','2013-09-28','09:50:00',1),('3355','2013-09-28','09:55:00',1.08),('3355','2013-09-28','10:00:00',1.42),('3355','2013-09-28','10:05:00',1.2),('3355','2013-09-28','10:10:00',1.06),('3355','2013-09-28','10:35:00',1.16),('3355','2013-09-28','10:40:00',1.63),('3355','2013-09-28','10:45:00',1.23),('3355','2013-09-28','10:50:00',1.29),('3355','2013-09-28','11:00:00',1.99),('3355','2013-09-28','11:05:00',1.44),('3355','2013-09-28','11:10:00',1.08),('3355','2013-09-28','11:15:00',1.91),('3355','2013-09-28','11:25:00',1.77),('3355','2013-09-28','11:30:00',1.97),('3355','2013-09-28','11:35:00',2.03),('3355','2013-09-28','11:40:00',2),('3355','2013-09-28','12:00:00',1.55),('3355','2013-09-28','12:05:00',2.15),('3355','2013-09-28','12:10:00',1.75),('3355','2013-09-28','12:15:00',1.16),('3355','2013-09-28','12:20:00',1.63),('3355','2013-09-28','12:25:00',1.3),('3355','2013-09-28','12:35:00',1.32),('3355','2013-09-28','12:50:00',1.95),('3355','2013-09-28','12:55:00',2.36),('3355','2013-09-28','13:00:00',2.29),('3355','2013-09-28','13:05:00',2.16),('3355','2013-09-28','13:10:00',1.14),('3355','2013-09-28','13:25:00',1.56),('3355','2013-09-28','13:30:00',2.08),('3355','2013-09-28','13:35:00',1.09),('3355','2013-09-28','13:40:00',1.04),('3355','2013-09-28','13:45:00',1.07),('3355','2013-09-28','13:50:00',1.21),('3355','2013-09-28','14:00:00',1.17),('3355','2013-09-28','14:05:00',1.27),('3355','2013-09-28','14:20:00',1.7),('3355','2013-09-28','14:25:00',2.24),('3355','2013-09-28','14:30:00',1.94),('3355','2013-09-28','14:35:00',1.92),('3355','2013-09-28','14:40:00',2.15),('3355','2013-09-28','14:45:00',2.13),('3355','2013-09-28','14:50:00',2),('3355','2013-09-28','14:55:00',1.88),('3355','2013-09-28','15:00:00',1.98),('3355','2013-09-28','15:05:00',2.04),('3355','2013-09-28','15:10:00',1.92),('3355','2013-09-28','15:15:00',1.86),('3355','2013-09-28','15:20:00',1.93),('3355','2013-09-28','15:25:00',1.9),('3355','2013-09-28','15:30:00',1.85),('3355','2013-09-28','15:35:00',1.71),('3355','2013-09-28','15:40:00',1.72),('3355','2013-09-28','15:45:00',1.54),('3355','2013-09-28','15:55:00',1.11),('3355','2013-09-28','16:00:00',1.53),('3355','2013-09-28','16:05:00',1.45),('3355','2013-09-28','16:10:00',1.55),('3355','2013-09-28','16:15:00',1.51),('3355','2013-09-28','16:20:00',1.39),('3355','2013-09-28','16:25:00',1.23),('3355','2013-09-28','16:30:00',1.15),('3355','2013-09-28','16:35:00',1.15),('3355','2013-09-28','16:40:00',1.12),('3355','2013-09-28','16:45:00',1.05),('3355','2013-09-28','16:50:00',1),('3355','2013-09-27','09:55:00',1.26),('3355','2013-09-27','10:05:00',1.19),('3355','2013-09-27','10:15:00',1.01),('3355','2013-09-27','10:20:00',1.38),('3355','2013-09-27','10:25:00',1.11),('3355','2013-09-27','10:55:00',1.24),('3355','2013-09-27','11:00:00',1.65),('3355','2013-09-27','11:05:00',1.45),('3355','2013-09-27','11:10:00',1.58),('3355','2013-09-27','11:20:00',1.04),('3355','2013-09-27','12:00:00',1.7),('3355','2013-09-27','12:05:00',1.53),('3355','2013-09-27','12:10:00',2),('3355','2013-09-27','12:15:00',1.65),('3355','2013-09-27','12:50:00',1.04),('3355','2013-09-27','12:55:00',2.06),('3355','2013-09-27','13:00:00',2.05),('3355','2013-09-27','13:05:00',2.02),('3355','2013-09-27','13:10:00',2.15),('3355','2013-09-27','13:15:00',1.91),('3355','2013-09-27','13:20:00',1.78),('3355','2013-09-27','13:25:00',1.48),('3355','2013-09-27','14:00:00',1.43),('3355','2013-09-27','14:10:00',1.4),('3355','2013-09-27','14:15:00',2),('3355','2013-09-27','14:20:00',1.4),('3355','2013-09-27','14:25:00',2),('3355','2013-09-27','14:30:00',1.88),('3355','2013-09-27','14:35:00',1.89),('3355','2013-09-27','14:40:00',1.92),('3355','2013-09-27','14:45:00',1.9),('3355','2013-09-27','14:50:00',1.88),('3355','2013-09-27','14:55:00',1.54),('3355','2013-09-27','15:00:00',1.87),('3355','2013-09-27','15:05:00',1.52),('3355','2013-09-27','15:10:00',1.14),('3355','2013-09-27','15:15:00',1.78),('3355','2013-09-27','15:20:00',1.59),('3355','2013-09-27','15:25:00',1.64),('3355','2013-09-27','15:30:00',1.69),('3355','2013-09-27','15:35:00',1.65),('3355','2013-09-27','15:40:00',1.63),('3355','2013-09-27','15:45:00',1.48),('3355','2013-09-27','15:50:00',1.62),('3355','2013-09-27','15:55:00',1.54),('3355','2013-09-27','16:00:00',1.38),('3355','2013-09-27','16:05:00',1.24),('3355','2013-09-27','16:15:00',1.26),('3355','2013-09-27','16:20:00',1.15),('3355','2013-09-27','16:25:00',1.27),('3355','2013-09-27','16:30:00',1.22),('3355','2013-09-27','16:35:00',1.15),('3355','2013-09-27','16:40:00',1.15),('3355','2013-09-27','16:45:00',1.12),('3355','2013-09-26','09:20:00',1.01),('3355','2013-09-26','09:25:00',1.05),('3355','2013-09-26','09:30:00',1.09),('3355','2013-09-26','09:35:00',1.13),('3355','2013-09-26','09:40:00',1.18),('3355','2013-09-26','09:45:00',1.23),('3355','2013-09-26','09:50:00',1.27),('3355','2013-09-26','09:55:00',1.29),('3355','2013-09-26','10:00:00',1.34),('3355','2013-09-26','10:05:00',1.39),('3355','2013-09-26','10:10:00',1.42),('3355','2013-09-26','10:15:00',1.43),('3355','2013-09-26','10:20:00',1.48),('3355','2013-09-26','10:25:00',1.47),('3355','2013-09-26','10:30:00',1.51),('3355','2013-09-26','10:35:00',1.54),('3355','2013-09-26','10:40:00',1.55),('3355','2013-09-26','10:45:00',1.66),('3355','2013-09-26','10:50:00',1.65),('3355','2013-09-26','10:55:00',1.68),('3355','2013-09-26','11:00:00',1.68),('3355','2013-09-26','11:05:00',1.68),('3355','2013-09-26','11:10:00',1.72),('3355','2013-09-26','11:15:00',1.59),('3355','2013-09-26','11:20:00',1.64),('3355','2013-09-26','11:25:00',1.81),('3355','2013-09-26','11:30:00',1.84),('3355','2013-09-26','11:35:00',1.89),('3355','2013-09-26','11:40:00',1.59),('3355','2013-09-26','11:45:00',1.85),('3355','2013-09-26','11:50:00',1.91),('3355','2013-09-26','11:55:00',1.52),('3355','2013-09-26','12:00:00',1.82),('3355','2013-09-26','12:05:00',1.58),('3355','2013-09-26','12:10:00',1.01),('3355','2013-09-26','12:55:00',1.12),('3355','2013-09-26','13:00:00',1.69),('3355','2013-09-26','13:05:00',1.55),('3355','2013-09-26','13:15:00',1.4),('3355','2013-09-26','13:20:00',1.98),('3355','2013-09-26','13:25:00',2.28),('3355','2013-09-26','13:30:00',1.07),('3355','2013-09-26','13:35:00',1.01),('3355','2013-09-26','13:55:00',1.19),('3355','2013-09-26','14:00:00',1.24),('3355','2013-09-26','14:05:00',1.55),('3355','2013-09-26','14:10:00',1.93),('3355','2013-09-26','14:15:00',2.07),('3355','2013-09-26','14:20:00',1.66),('3355','2013-09-26','14:35:00',1.49),('3355','2013-09-26','14:40:00',1),('3355','2013-09-26','14:45:00',1.41),('3355','2013-09-26','14:50:00',2.24),('3355','2013-09-26','14:55:00',2.01),('3355','2013-09-26','15:10:00',1.21),('3355','2013-09-26','15:20:00',1),('3355','2013-09-26','15:25:00',1.7),('3355','2013-09-26','15:40:00',1.17),('3355','2013-09-26','15:50:00',1.25),('3355','2013-09-26','15:55:00',1.62),('3355','2013-09-26','16:00:00',1.51),('3355','2013-09-26','16:05:00',1.45),('3355','2013-09-26','16:10:00',1.45),('3355','2013-09-26','16:15:00',1.38),('3355','2013-09-26','16:20:00',1.34),('3355','2013-09-26','16:25:00',1.28),('3355','2013-09-26','16:30:00',1.26),('3355','2013-09-26','16:35:00',1.2),('3355','2013-09-26','16:40:00',1.16),('3355','2013-09-26','16:45:00',1.1),('3355','2013-09-26','16:50:00',1.05),('3355','2013-09-26','16:55:00',1.01),('3355','2013-09-25','09:35:00',1.08),('3355','2013-09-25','09:40:00',1.1),('3355','2013-09-25','09:50:00',1.16),('3355','2013-09-25','09:55:00',1.17),('3355','2013-09-25','10:00:00',1.39),('3355','2013-09-25','10:50:00',1.42),('3355','2013-09-25','10:55:00',2.03),('3355','2013-09-25','11:00:00',1.92),('3355','2013-09-25','11:05:00',1.84),('3355','2013-09-25','11:10:00',1.61),('3355','2013-09-25','11:30:00',2.03),('3355','2013-09-25','11:35:00',2.01),('3355','2013-09-25','11:40:00',1.98),('3355','2013-09-25','11:45:00',1.96),('3355','2013-09-25','11:50:00',1.24),('3355','2013-09-25','12:20:00',1.31),('3355','2013-09-25','12:35:00',1.08),('3355','2013-09-25','12:40:00',1.74),('3355','2013-09-25','12:45:00',1.06),('3355','2013-09-25','13:40:00',2.2),('3355','2013-09-25','13:45:00',2.36),('3355','2013-09-25','13:50:00',2.44),('3355','2013-09-25','13:55:00',2.4),('3355','2013-09-25','14:30:00',1.72),('3355','2013-09-25','14:35:00',2.21),('3355','2013-09-25','14:40:00',2.34),('3355','2013-09-25','14:45:00',1.28),('3355','2013-09-25','14:50:00',1.6),('3355','2013-09-25','14:55:00',2.22),('3355','2013-09-25','15:00:00',1.96),('3355','2013-09-25','15:05:00',1.81),('3355','2013-09-25','15:10:00',1.98),('3355','2013-09-25','15:15:00',1.96),('3355','2013-09-25','15:20:00',1.9),('3355','2013-09-25','15:25:00',1.72),('3355','2013-09-25','15:30:00',1.85),('3355','2013-09-25','15:35:00',1.64),('3355','2013-09-25','15:40:00',1.88),('3355','2013-09-25','15:45:00',1.68),('3355','2013-09-25','15:50:00',1.68),('3355','2013-09-25','15:55:00',1.67),('3355','2013-09-25','16:00:00',1.62),('3355','2013-09-25','16:05:00',1.57),('3355','2013-09-25','16:10:00',1.53),('3355','2013-09-25','16:15:00',1.43),('3355','2013-09-25','16:20:00',1.44),('3355','2013-09-25','16:25:00',1.35),('3355','2013-09-25','16:30:00',1.35),('3355','2013-09-25','16:35:00',1.3),('3355','2013-09-25','16:40:00',1.26),('3355','2013-09-25','16:45:00',1.21),('3355','2013-09-25','16:50:00',1.16),('3355','2013-09-25','16:55:00',1.09),('3355','2013-09-25','17:00:00',1.05),('3355','2013-09-25','17:05:00',1),('3355','2013-09-24','09:15:00',1.01),('3355','2013-09-24','09:20:00',1.06),('3355','2013-09-24','09:25:00',1.11),('3355','2013-09-24','09:30:00',1.16),('3355','2013-09-24','09:35:00',1.2),('3355','2013-09-24','09:40:00',1.24),('3355','2013-09-24','09:45:00',1.28),('3355','2013-09-24','09:50:00',1.32),('3355','2013-09-24','09:55:00',1.36),('3355','2013-09-24','10:00:00',1.4),('3355','2013-09-24','10:05:00',1.43),('3355','2013-09-24','10:10:00',1.47),('3355','2013-09-24','10:15:00',1.52),('3355','2013-09-24','10:20:00',1.56),('3355','2013-09-24','10:25:00',1.59),('3355','2013-09-24','10:30:00',1.63),('3355','2013-09-24','10:35:00',1.66),('3355','2013-09-24','10:40:00',1.69),('3355','2013-09-24','10:45:00',1.71),('3355','2013-09-24','10:50:00',1.74),('3355','2013-09-24','10:55:00',1.77),('3355','2013-09-24','11:00:00',1.79),('3355','2013-09-24','11:05:00',1.81),('3355','2013-09-24','11:10:00',1.83),('3355','2013-09-24','11:15:00',1.85),('3355','2013-09-24','11:20:00',1.87),('3355','2013-09-24','11:25:00',1.9),('3355','2013-09-24','11:30:00',1.91),('3355','2013-09-24','11:35:00',1.92),('3355','2013-09-24','11:40:00',1.93),('3355','2013-09-24','11:45:00',1.95),('3355','2013-09-24','11:50:00',1.97),('3355','2013-09-24','11:55:00',1.99),('3355','2013-09-24','12:00:00',2.01),('3355','2013-09-24','12:05:00',2.01),('3355','2013-09-24','12:10:00',2.01),('3355','2013-09-24','12:15:00',2.03),('3355','2013-09-24','12:20:00',2.02),('3355','2013-09-24','12:25:00',2.02),('3355','2013-09-24','12:30:00',2.01),('3355','2013-09-24','12:35:00',2),('3355','2013-09-24','12:40:00',2.07),('3355','2013-09-24','12:45:00',2.07),('3355','2013-09-24','12:50:00',2.08),('3355','2013-09-24','12:55:00',2.09),('3355','2013-09-24','13:00:00',2.08),('3355','2013-09-24','13:05:00',2.09),('3355','2013-09-24','13:10:00',2.09),('3355','2013-09-24','13:15:00',2.09),('3355','2013-09-24','13:20:00',2.09),('3355','2013-09-24','13:25:00',2.08),('3355','2013-09-24','13:30:00',2.08),('3355','2013-09-24','13:35:00',2.07),('3355','2013-09-24','13:40:00',2.09),('3355','2013-09-24','13:45:00',2.09),('3355','2013-09-24','13:50:00',2.07),('3355','2013-09-24','13:55:00',2.07),('3355','2013-09-24','14:00:00',2.05),('3355','2013-09-24','14:05:00',2.04),('3355','2013-09-24','14:10:00',2.03),('3355','2013-09-24','14:15:00',2.02),('3355','2013-09-24','14:20:00',2.02),('3355','2013-09-24','14:25:00',2.01),('3355','2013-09-24','14:30:00',1.99),('3355','2013-09-24','14:35:00',1.96),('3355','2013-09-24','14:40:00',1.95),('3355','2013-09-24','14:45:00',1.93),('3355','2013-09-24','14:50:00',1.92),('3355','2013-09-24','14:55:00',1.91),('3355','2013-09-24','15:00:00',1.86),('3355','2013-09-24','15:05:00',1.86),('3355','2013-09-24','15:10:00',1.84),('3355','2013-09-24','15:15:00',1.8),('3355','2013-09-24','15:20:00',1.8),('3355','2013-09-24','15:25:00',1.79),('3355','2013-09-24','15:30:00',1.76),('3355','2013-09-24','15:35:00',1.73),('3355','2013-09-24','15:40:00',1.7),('3355','2013-09-24','15:45:00',1.68),('3355','2013-09-24','15:50:00',1.65),('3355','2013-09-24','15:55:00',1.61),('3355','2013-09-24','16:00:00',1.57),('3355','2013-09-24','16:05:00',1.54),('3355','2013-09-24','16:10:00',1.49),('3355','2013-09-24','16:15:00',1.46),('3355','2013-09-24','16:20:00',1.44),('3355','2013-09-24','16:25:00',1.37),('3355','2013-09-24','16:30:00',1.34),('3355','2013-09-24','16:35:00',1.29),('3355','2013-09-24','16:40:00',1.24),('3355','2013-09-24','16:45:00',1.21),('3355','2013-09-24','16:50:00',1.17),('3355','2013-09-24','16:55:00',1.13),('3355','2013-09-24','17:00:00',1.09),('3355','2013-09-24','17:05:00',1.03),('3355','2013-09-23','09:15:00',1.03),('3355','2013-09-23','09:20:00',1.08),('3355','2013-09-23','09:25:00',1.13),('3355','2013-09-23','09:30:00',1.17),('3355','2013-09-23','09:35:00',1.22),('3355','2013-09-23','09:40:00',1.27),('3355','2013-09-23','09:45:00',1.31),('3355','2013-09-23','09:50:00',1.35),('3355','2013-09-23','09:55:00',1.39),('3355','2013-09-23','10:00:00',1.43),('3355','2013-09-23','10:05:00',1.46),('3355','2013-09-23','10:10:00',1.5),('3355','2013-09-23','10:15:00',1.54),('3355','2013-09-23','10:20:00',1.57),('3355','2013-09-23','10:25:00',1.6),('3355','2013-09-23','10:30:00',1.64),('3355','2013-09-23','10:35:00',1.67),('3355','2013-09-23','10:40:00',1.7),('3355','2013-09-23','10:45:00',1.73),('3355','2013-09-23','10:50:00',1.76),('3355','2013-09-23','10:55:00',1.78),('3355','2013-09-23','11:00:00',1.81),('3355','2013-09-23','11:05:00',1.85),('3355','2013-09-23','11:10:00',1.88),('3355','2013-09-23','11:15:00',1.91),('3355','2013-09-23','11:20:00',1.93),('3355','2013-09-23','11:25:00',1.96),('3355','2013-09-23','11:30:00',1.98),('3355','2013-09-23','11:35:00',2),('3355','2013-09-23','11:40:00',2.02),('3355','2013-09-23','11:45:00',2.03),('3355','2013-09-23','11:50:00',2.04),('3355','2013-09-23','11:55:00',2.06),('3355','2013-09-23','12:00:00',2.09),('3355','2013-09-23','12:05:00',2.12),('3355','2013-09-23','12:10:00',2.14),('3355','2013-09-23','12:15:00',2.14),('3355','2013-09-23','12:20:00',2.13),('3355','2013-09-23','12:25:00',2.13),('3355','2013-09-23','12:30:00',2.12),('3355','2013-09-23','12:35:00',2.12),('3355','2013-09-23','12:40:00',2.13),('3355','2013-09-23','12:45:00',2.13),('3355','2013-09-23','12:50:00',2.12),('3355','2013-09-23','12:55:00',2.15),('3355','2013-09-23','13:00:00',2.15),('3355','2013-09-23','13:05:00',2.14),('3355','2013-09-23','13:10:00',2.13),('3355','2013-09-23','13:15:00',2.13),('3355','2013-09-23','13:20:00',2.11),('3355','2013-09-23','13:25:00',2.13),('3355','2013-09-23','13:30:00',2.14),('3355','2013-09-23','13:35:00',2.13),('3355','2013-09-23','13:40:00',2.13),('3355','2013-09-23','13:45:00',2.12),('3355','2013-09-23','13:50:00',2.11),('3355','2013-09-23','13:55:00',2.09),('3355','2013-09-23','14:00:00',2.06),('3355','2013-09-23','14:05:00',2.04),('3355','2013-09-23','14:10:00',2.05),('3355','2013-09-23','14:15:00',2.05),('3355','2013-09-23','14:20:00',2.01),('3355','2013-09-23','14:25:00',2.02),('3355','2013-09-23','14:30:00',2.07),('3355','2013-09-23','14:35:00',1.91),('3355','2013-09-23','14:40:00',1.99),('3355','2013-09-23','14:45:00',1.94),('3355','2013-09-23','14:50:00',1.93),('3355','2013-09-23','14:55:00',1.92),('3355','2013-09-23','15:00:00',1.86),('3355','2013-09-23','15:05:00',1.9),('3355','2013-09-23','15:10:00',1.66),('3355','2013-09-23','15:15:00',1.85),('3355','2013-09-23','15:20:00',1.79),('3355','2013-09-23','15:25:00',1.76),('3355','2013-09-23','15:30:00',1.74),('3355','2013-09-23','15:35:00',1.7),('3355','2013-09-23','15:40:00',1.66),('3355','2013-09-23','15:45:00',1.62),('3355','2013-09-23','15:50:00',1.62),('3355','2013-09-23','15:55:00',1.5),('3355','2013-09-23','16:00:00',1.37),('3355','2013-09-23','16:05:00',1.51),('3355','2013-09-23','16:15:00',1.47),('3355','2013-09-23','16:25:00',1.41),('3355','2013-09-23','16:35:00',1.12),('3355','2013-09-23','16:40:00',1.21),('3355','2013-09-23','16:45:00',1.18),('3355','2013-09-23','16:50:00',1.11),('3355','2013-09-23','16:55:00',1.08),('3355','2013-09-23','17:00:00',1.04),('3355','2013-09-22','09:15:00',1.02),('3355','2013-09-22','09:20:00',1.07),('3355','2013-09-22','09:25:00',1.12),('3355','2013-09-22','09:30:00',1.17),('3355','2013-09-22','09:35:00',1.21),('3355','2013-09-22','09:40:00',1.25),('3355','2013-09-22','09:45:00',1.3),('3355','2013-09-22','09:50:00',1.34),('3355','2013-09-22','09:55:00',1.39),('3355','2013-09-22','10:00:00',1.43),('3355','2013-09-22','10:05:00',1.47),('3355','2013-09-22','10:10:00',1.51),('3355','2013-09-22','10:15:00',1.55),('3355','2013-09-22','10:20:00',1.58),('3355','2013-09-22','10:25:00',1.62),('3355','2013-09-22','10:30:00',1.66),('3355','2013-09-22','10:35:00',1.7),('3355','2013-09-22','10:40:00',1.72),('3355','2013-09-22','10:45:00',1.75),('3355','2013-09-22','10:50:00',1.78),('3355','2013-09-22','10:55:00',1.8),('3355','2013-09-22','11:00:00',1.83),('3355','2013-09-22','11:05:00',1.86),('3355','2013-09-22','11:10:00',1.87),('3355','2013-09-22','11:15:00',1.9),('3355','2013-09-22','11:20:00',1.92),('3355','2013-09-22','11:25:00',1.94),('3355','2013-09-22','11:30:00',1.97),('3355','2013-09-22','11:35:00',2),('3355','2013-09-22','11:40:00',2.03),('3355','2013-09-22','11:45:00',2.05),('3355','2013-09-22','11:50:00',2.07),('3355','2013-09-22','11:55:00',2.1),('3355','2013-09-22','12:00:00',2.11),('3355','2013-09-22','12:05:00',2.12),('3355','2013-09-22','12:10:00',2.14),('3355','2013-09-22','12:15:00',2.14),('3355','2013-09-22','12:20:00',2.15),('3355','2013-09-22','12:25:00',2.16),('3355','2013-09-22','12:30:00',2.16),('3355','2013-09-22','12:35:00',2.16),('3355','2013-09-22','12:40:00',2.19),('3355','2013-09-22','12:45:00',2.16),('3355','2013-09-22','12:50:00',2.2),('3355','2013-09-22','12:55:00',2.23),('3355','2013-09-22','13:00:00',2.21),('3355','2013-09-22','13:05:00',2.21),('3355','2013-09-22','13:10:00',2.15),('3355','2013-09-22','13:15:00',2.03),('3355','2013-09-22','13:20:00',2.18),('3355','2013-09-22','13:25:00',2.16),('3355','2013-09-22','13:30:00',2.15),('3355','2013-09-22','13:35:00',2.16),('3355','2013-09-22','13:40:00',2.16),('3355','2013-09-22','13:45:00',2.15),('3355','2013-09-22','13:50:00',2.16),('3355','2013-09-22','13:55:00',2.09),('3355','2013-09-22','14:00:00',2.12),('3355','2013-09-22','14:05:00',2.14),('3355','2013-09-22','14:10:00',2.15),('3355','2013-09-22','14:15:00',2.14),('3355','2013-09-22','14:20:00',1.74),('3355','2013-09-22','14:25:00',2.01),('3355','2013-09-22','14:30:00',2.22),('3355','2013-09-22','14:35:00',2.09),('3355','2013-09-22','14:40:00',1.4),('3355','2013-09-22','14:45:00',1.88),('3355','2013-09-22','14:50:00',2.04),('3355','2013-09-22','14:55:00',2.01),('3355','2013-09-22','15:00:00',2.02),('3355','2013-09-22','15:05:00',2.06),('3355','2013-09-22','15:10:00',2.02),('3355','2013-09-22','15:15:00',2.06),('3355','2013-09-22','15:20:00',2.13),('3355','2013-09-22','15:25:00',1.27),('3355','2013-09-22','15:40:00',1.43),('3355','2013-09-22','15:45:00',1.79),('3355','2013-09-22','15:50:00',1.75),('3355','2013-09-22','15:55:00',1.72),('3355','2013-09-22','16:00:00',1.83),('3355','2013-09-22','16:05:00',1.82),('3355','2013-09-22','16:10:00',1.79),('3355','2013-09-22','16:15:00',1.78),('3355','2013-09-22','16:20:00',1.11),('3355','2013-09-22','16:45:00',1.17),('3355','2013-09-22','17:05:00',1.1),('3355','2013-09-21','09:20:00',1.04),('3355','2013-09-21','09:25:00',1.09),('3355','2013-09-21','09:30:00',1.14),('3355','2013-09-21','09:35:00',1.19),('3355','2013-09-21','09:40:00',1.23),('3355','2013-09-21','09:45:00',1.28),('3355','2013-09-21','09:50:00',1.32),('3355','2013-09-21','09:55:00',1.35),('3355','2013-09-21','10:00:00',1.4),('3355','2013-09-21','10:05:00',1.44),('3355','2013-09-21','10:10:00',1.48),('3355','2013-09-21','10:15:00',1.52),('3355','2013-09-21','10:20:00',1.56),('3355','2013-09-21','10:25:00',1.59),('3355','2013-09-21','10:30:00',1.61),('3355','2013-09-21','10:35:00',1.64),('3355','2013-09-21','10:40:00',1.67),('3355','2013-09-21','10:45:00',1.7),('3355','2013-09-21','10:50:00',1.73),('3355','2013-09-21','10:55:00',1.77),('3355','2013-09-21','11:00:00',1.8),('3355','2013-09-21','11:05:00',1.82),('3355','2013-09-21','11:10:00',1.84),('3355','2013-09-21','11:15:00',1.87),('3355','2013-09-21','11:20:00',1.9),('3355','2013-09-21','11:25:00',1.92),('3355','2013-09-21','11:30:00',1.94),('3355','2013-09-21','11:35:00',1.95),('3355','2013-09-21','11:40:00',1.97),('3355','2013-09-21','11:45:00',1.99),('3355','2013-09-21','11:50:00',2.01),('3355','2013-09-21','11:55:00',1.98),('3355','2013-09-21','12:00:00',2.02),('3355','2013-09-21','12:05:00',2.05),('3355','2013-09-21','12:10:00',2.06),('3355','2013-09-21','12:15:00',2.06),('3355','2013-09-21','12:20:00',2.08),('3355','2013-09-21','12:25:00',1.86),('3355','2013-09-21','12:30:00',2.14),('3355','2013-09-21','12:35:00',2.11),('3355','2013-09-21','12:40:00',1.97),('3355','2013-09-21','12:45:00',2.05),('3355','2013-09-21','12:50:00',2.1),('3355','2013-09-21','12:55:00',2.12),('3355','2013-09-21','13:00:00',2.13),('3355','2013-09-21','13:05:00',2.08),('3355','2013-09-21','13:10:00',2.14),('3355','2013-09-21','13:15:00',2.17),('3355','2013-09-21','13:20:00',1.81),('3355','2013-09-21','13:25:00',2.02),('3355','2013-09-21','13:30:00',2.06),('3355','2013-09-21','13:35:00',2.09),('3355','2013-09-21','13:40:00',1.85),('3355','2013-09-21','13:45:00',1.84),('3355','2013-09-21','13:50:00',1.91),('3355','2013-09-21','13:55:00',1.94),('3355','2013-09-21','14:00:00',1.95),('3355','2013-09-21','14:05:00',2.07),('3355','2013-09-21','14:10:00',1.98),('3355','2013-09-21','14:15:00',2.08),('3355','2013-09-21','14:20:00',2.07),('3355','2013-09-21','14:25:00',2.04),('3355','2013-09-21','14:30:00',2.02),('3355','2013-09-21','14:35:00',2),('3355','2013-09-21','14:40:00',1.98),('3355','2013-09-21','14:45:00',1.95),('3355','2013-09-21','14:50:00',1.94),('3355','2013-09-21','14:55:00',1.91),('3355','2013-09-21','15:00:00',1.89),('3355','2013-09-21','15:05:00',1.88),('3355','2013-09-21','15:10:00',1.83),('3355','2013-09-21','15:15:00',1.82),('3355','2013-09-21','15:20:00',1.81),('3355','2013-09-21','15:25:00',1.78),('3355','2013-09-21','15:30:00',1.75),('3355','2013-09-21','15:35:00',1.73),('3355','2013-09-21','15:40:00',1.59),('3355','2013-09-21','15:45:00',1.17),('3355','2013-09-21','15:50:00',1.55),('3355','2013-09-21','15:55:00',1.61),('3355','2013-09-21','16:00:00',1.25),('3355','2013-09-21','16:20:00',1.06),('3355','2013-09-20','10:05:00',1.32),('3355','2013-09-20','10:10:00',1.24),('3355','2013-09-20','10:15:00',1.44),('3355','2013-09-20','10:20:00',1.87),('3355','2013-09-20','10:25:00',1.47),('3355','2013-09-20','10:30:00',1.39),('3355','2013-09-20','10:35:00',1.84),('3355','2013-09-20','10:40:00',1.76),('3355','2013-09-20','10:45:00',2.15),('3355','2013-09-20','10:50:00',1.85),('3355','2013-09-20','10:55:00',1.45),('3355','2013-09-20','11:00:00',1.05),('3355','2013-09-20','11:05:00',1.03),('3355','2013-09-20','11:10:00',1.05),('3355','2013-09-20','11:15:00',1.72),('3355','2013-09-20','11:20:00',1.34),('3355','2013-09-20','11:25:00',1.35),('3355','2013-09-20','11:30:00',1.17),('3355','2013-09-20','11:35:00',1.85),('3355','2013-09-20','11:40:00',1.45),('3355','2013-09-20','11:45:00',2.34),('3355','2013-09-20','11:50:00',2.19),('3355','2013-09-20','11:55:00',2.1),('3355','2013-09-20','12:00:00',2.09),('3355','2013-09-20','12:05:00',2.09),('3355','2013-09-20','12:10:00',2.12),('3355','2013-09-20','12:15:00',2.16),('3355','2013-09-20','12:20:00',2.22),('3355','2013-09-20','12:25:00',2.12),('3355','2013-09-20','12:30:00',2.26),('3355','2013-09-20','12:35:00',1.62),('3355','2013-09-20','12:40:00',1.81),('3355','2013-09-20','12:45:00',1.36),('3355','2013-09-20','12:50:00',1.77),('3355','2013-09-20','12:55:00',2.25),('3355','2013-09-20','13:00:00',2.07),('3355','2013-09-20','13:05:00',1.91),('3355','2013-09-20','13:10:00',2.14),('3355','2013-09-20','13:15:00',1.59),('3355','2013-09-20','13:20:00',1.36),('3355','2013-09-20','13:25:00',2.06),('3355','2013-09-20','13:30:00',2.27),('3355','2013-09-20','13:35:00',1.49),('3355','2013-09-20','13:40:00',2.02),('3355','2013-09-20','13:45:00',2.17),('3355','2013-09-20','13:50:00',2.12),('3355','2013-09-20','13:55:00',1.95),('3355','2013-09-20','14:00:00',2.11),('3355','2013-09-20','14:05:00',2.15),('3355','2013-09-20','14:10:00',2.06),('3355','2013-09-20','14:15:00',1.25),('3355','2013-09-20','14:25:00',1.77),('3355','2013-09-20','14:30:00',2.23),('3355','2013-09-20','14:35:00',2.2),('3355','2013-09-20','14:40:00',2.13),('3355','2013-09-20','14:46:00',2.12),('3355','2013-09-20','14:50:00',2.14),('3355','2013-09-20','14:55:00',2.11),('3355','2013-09-20','15:00:00',1.51),('3355','2013-09-20','15:05:00',1.04),('3355','2013-09-20','15:10:00',1.72),('3355','2013-09-20','15:15:00',1.87),('3355','2013-09-20','15:20:00',1.72),('3355','2013-09-20','15:25:00',1.32),('3355','2013-09-20','15:30:00',1.66),('3355','2013-09-20','15:35:00',1.07),('3355','2013-09-20','15:40:00',1.37),('3355','2013-09-20','15:45:00',1.83),('3355','2013-09-20','15:50:00',1.79),('3355','2013-09-20','15:55:00',1.82),('3355','2013-09-20','16:00:00',1.09),('3355','2013-09-20','16:10:00',1.18),('3355','2013-09-20','16:15:00',1.55),('3355','2013-09-20','16:50:00',1.36),('3355','2013-09-20','16:55:00',1.39),('3355','2013-09-20','17:00:00',1.26),('3355','2013-09-20','17:05:00',1.37),('3355','2013-09-20','17:10:00',1.33),('3355','2013-09-20','17:15:00',1.27),('3355','2013-09-20','17:20:00',1.21),('3355','2013-09-20','17:25:00',1.04),('3355','2013-09-19','10:10:00',1.23),('3355','2013-09-19','10:15:00',1.18),('3355','2013-09-19','10:35:00',1.3),('3355','2013-09-19','10:40:00',1.29),('3355','2013-09-19','10:45:00',1.6),('3355','2013-09-19','10:50:00',1),('3355','2013-09-19','10:55:00',1.39),('3355','2013-09-19','11:00:00',2.05),('3355','2013-09-19','11:05:00',2.28),('3355','2013-09-19','11:10:00',1.28),('3355','2013-09-19','11:20:00',1.3),('3355','2013-09-19','11:30:00',1.7),('3355','2013-09-19','11:35:00',1.22),('3355','2013-09-19','11:40:00',1.49),('3355','2013-09-19','11:45:00',1.51),('3355','2013-09-19','11:50:00',2.08),('3355','2013-09-19','11:55:00',2.2),('3355','2013-09-19','12:10:00',1.19),('3355','2013-09-19','12:15:00',1.4),('3355','2013-09-19','12:20:00',1.89),('3355','2013-09-19','12:25:00',2.47),('3355','2013-09-19','12:30:00',2.26),('3355','2013-09-19','12:35:00',2.25),('3355','2013-09-19','12:40:00',2.27),('3355','2013-09-19','12:45:00',1.74),('3355','2013-09-19','12:50:00',2.38),('3355','2013-09-19','12:55:00',2.31),('3355','2013-09-19','13:00:00',2.31),('3355','2013-09-19','13:05:00',2.32),('3355','2013-09-19','13:10:00',2.41),('3355','2013-09-19','13:15:00',2.44),('3355','2013-09-19','13:20:00',2.34),('3355','2013-09-19','13:25:00',1.69),('3355','2013-09-19','13:30:00',2.21),('3355','2013-09-19','13:35:00',2.36),('3355','2013-09-19','13:40:00',2.46),('3355','2013-09-19','13:45:00',2.51),('3355','2013-09-19','13:50:00',2.34),('3355','2013-09-19','13:55:00',1.11),('3355','2013-09-19','14:05:00',1.55),('3355','2013-09-19','14:10:00',2.31),('3355','2013-09-19','14:15:00',2.21),('3355','2013-09-19','14:20:00',2.17),('3355','2013-09-19','14:25:00',2.13),('3355','2013-09-19','14:30:00',2.12),('3355','2013-09-19','14:35:00',2.1),('3355','2013-09-19','14:40:00',2.05),('3355','2013-09-19','14:45:00',1.99),('3355','2013-09-19','14:50:00',2.03),('3355','2013-09-19','14:55:00',1.97),('3355','2013-09-19','15:00:00',2.06),('3355','2013-09-19','15:05:00',1.83),('3355','2013-09-19','15:10:00',1.66),('3355','2013-09-19','15:15:00',1.8),('3355','2013-09-19','15:20:00',1.88),('3355','2013-09-19','15:25:00',1.87),('3355','2013-09-19','15:30:00',1.8),('3355','2013-09-19','15:35:00',1.15),('3355','2013-09-19','15:40:00',1.55),('3355','2013-09-19','15:45:00',1.88),('3355','2013-09-19','15:50:00',1.76),('3355','2013-09-19','15:55:00',1.6),('3355','2013-09-19','16:00:00',1.63),('3355','2013-09-19','16:05:00',1.62),('3355','2013-09-19','16:10:00',1.29),('3355','2013-09-19','16:15:00',1.42),('3355','2013-09-19','16:20:00',1.58),('3355','2013-09-19','16:25:00',1.55),('3355','2013-09-19','16:30:00',1.2),('3355','2013-09-19','16:35:00',1.08),('3355','2013-09-19','16:50:00',1.17),('3355','2013-09-19','16:55:00',1.25),('3355','2013-09-19','17:00:00',1.1),('3355','2013-09-19','17:05:00',1.04),('3355','2013-09-19','17:10:00',1.03),('3355','2014-04-13','09:30:00',1.02),('3355','2014-04-13','10:00:00',1.38),('3355','2014-04-13','10:05:00',1.93),('3355','2014-04-13','10:10:00',1.08),('3355','2014-04-13','10:15:00',1.2),('3355','2014-04-13','10:20:00',1.53),('3355','2014-04-13','10:30:00',1.73),('3355','2014-04-13','10:35:00',1.92),('3355','2014-04-13','10:40:00',1.86),('3355','2014-04-13','10:45:00',1.95),('3355','2014-04-13','10:50:00',1.94),('3355','2014-04-13','10:55:00',1.96),('3355','2014-04-13','11:00:00',1.99),('3355','2014-04-13','11:05:00',2.02),('3355','2014-04-13','11:10:00',1.97),('3355','2014-04-13','11:15:00',1.8),('3355','2014-04-13','11:20:00',2.47),('3355','2014-04-13','11:25:00',1.51),('3355','2014-04-13','11:30:00',1.01),('3355','2014-04-13','11:35:00',1.35),('3355','2014-04-13','11:40:00',1.84),('3355','2014-04-13','11:45:00',1.78),('3355','2014-04-13','11:50:00',2.02),('3355','2014-04-13','11:55:00',1.59),('3355','2014-04-13','12:00:00',1.23),('3355','2014-04-13','13:10:00',1.11),('3355','2014-04-13','13:15:00',1.03),('3355','2014-04-13','13:20:00',1.25),('3355','2014-04-13','13:25:00',1.65),('3355','2014-04-13','13:30:00',2.16),('3355','2014-04-13','13:35:00',2.26),('3355','2014-04-13','13:40:00',2.42),('3355','2014-04-13','13:45:00',1.2),('3355','2014-04-13','13:50:00',1.84),('3355','2014-04-13','13:55:00',1.79),('3355','2014-04-13','14:00:00',2.22),('3355','2014-04-13','14:05:00',1.75),('3355','2014-04-13','14:10:00',1.96),('3355','2014-04-13','14:15:00',2.13),('3355','2014-04-13','14:45:00',1),('3355','2014-04-13','14:50:00',2.2),('3355','2014-04-13','15:00:00',1.84),('3355','2014-04-13','15:05:00',2.11),('3355','2014-04-13','15:10:00',2.17),('3355','2014-04-13','15:15:00',1.97),('3355','2014-04-13','15:20:00',1.92),('3355','2014-04-13','15:25:00',2.01),('3355','2014-04-13','15:30:00',2),('3355','2014-04-13','15:35:00',1.31),('3355','2014-04-13','15:50:00',1.13),('3355','2014-04-13','15:55:00',1.21),('3355','2014-04-13','16:00:00',2.07),('3355','2014-04-13','16:05:00',1.66),('3355','2014-04-13','16:40:00',1.66),('3355','2014-04-13','16:45:00',1.89),('3355','2014-04-13','16:50:00',1.36),('3355','2014-04-13','16:55:00',1.48),('3355','2014-04-13','17:00:00',1.44),('3355','2014-04-13','17:05:00',1.01),('3355','2013-09-18','09:20:00',1.13),('3355','2013-09-18','09:35:00',1.1),('3355','2013-09-18','09:55:00',1.21),('3355','2013-09-18','10:00:00',1.4),('3355','2013-09-18','10:05:00',1.65),('3355','2013-09-18','10:10:00',1.55),('3355','2013-09-18','10:15:00',1.56),('3355','2013-09-18','10:20:00',1.55),('3355','2013-09-18','10:25:00',1.58),('3355','2013-09-18','10:30:00',1.61),('3355','2013-09-18','10:35:00',1.63),('3355','2013-09-18','10:40:00',1.67),('3355','2013-09-18','10:45:00',1.69),('3355','2013-09-18','10:50:00',1.37),('3355','2013-09-18','10:55:00',1.55),('3355','2013-09-18','11:00:00',1.73),('3355','2013-09-18','11:05:00',1.7),('3355','2013-09-18','11:10:00',1.83),('3355','2013-09-18','11:15:00',1.12),('3355','2013-09-18','11:25:00',1.28),('3355','2013-09-18','11:30:00',2.18),('3355','2013-09-18','11:35:00',2.04),('3355','2013-09-18','11:40:00',1.5),('3355','2013-09-18','11:45:00',1.37),('3355','2013-09-18','11:50:00',2.12),('3355','2013-09-18','11:55:00',2.13),('3355','2013-09-18','12:00:00',2.14),('3355','2013-09-18','12:05:00',2.13),('3355','2013-09-18','12:10:00',2.23),('3355','2013-09-18','12:15:00',2.22),('3355','2013-09-18','12:20:00',2.23),('3355','2013-09-18','12:25:00',2.28),('3355','2013-09-18','12:30:00',1.44),('3355','2013-09-18','12:35:00',1.88),('3355','2013-09-18','12:40:00',2.4),('3355','2013-09-18','12:45:00',1.63),('3355','2013-09-18','12:50:00',1.32),('3355','2013-09-18','12:55:00',2.29),('3355','2013-09-18','13:00:00',1.63),('3355','2013-09-18','13:05:00',1.72),('3355','2013-09-18','13:10:00',2.31),('3355','2013-09-18','13:15:00',2.3),('3355','2013-09-18','13:20:00',2.3),('3355','2013-09-18','13:25:00',2.2),('3355','2013-09-18','13:30:00',2.3),('3355','2013-09-18','13:35:00',2.25),('3355','2013-09-18','13:40:00',2.25),('3355','2013-09-18','13:45:00',2.26),('3355','2013-09-18','13:50:00',2.29),('3355','2013-09-18','13:55:00',2.11),('3355','2013-09-18','14:00:00',2.03),('3355','2013-09-18','14:05:00',2.15),('3355','2013-09-18','14:10:00',1.89),('3355','2013-09-18','14:15:00',2.19),('3355','2013-09-18','14:20:00',2.18),('3355','2013-09-18','14:25:00',2.15),('3355','2013-09-18','14:30:00',2.12),('3355','2013-09-18','14:35:00',2.1),('3355','2013-09-18','14:40:00',2.08),('3355','2013-09-18','14:45:00',2.06),('3355','2013-09-18','14:50:00',1.28),('3355','2013-09-18','14:55:00',2.05),('3355','2013-09-18','15:00:00',2.03),('3355','2013-09-18','15:05:00',1.99),('3355','2013-09-18','15:15:00',1.13),('3355','2013-09-18','15:20:00',1.63),('3355','2013-09-18','15:25:00',1.45),('3355','2013-09-18','15:30:00',1.97),('3355','2013-09-18','15:35:00',1.91),('3355','2013-09-18','15:40:00',1.89),('3355','2013-09-18','15:45:00',1.78),('3355','2013-09-18','15:50:00',1.55),('3355','2013-09-18','15:55:00',1.06),('3355','2013-09-18','16:00:00',1.8),('3355','2013-09-18','16:05:00',1.8),('3355','2013-09-18','16:10:00',1.71),('3355','2013-09-18','16:15:00',1.6),('3355','2013-09-18','16:20:00',1.55),('3355','2013-09-18','16:25:00',1.37),('3355','2013-09-18','16:30:00',1.33),('3355','2013-09-18','16:35:00',1.25),('3355','2013-09-18','16:40:00',1.24),('3355','2013-09-18','16:45:00',1.26),('3355','2013-09-18','16:50:00',1.14),('3355','2013-09-18','16:55:00',1.07),('3355','2013-09-18','17:00:00',1.16),('3355','2013-09-18','17:05:00',1.02),('3355','2013-09-18','17:10:00',1.04),('3355','2013-09-17','09:45:00',1.22),('3355','2013-09-17','10:00:00',1.19),('3355','2013-09-17','10:25:00',1.41),('3355','2013-09-17','10:30:00',1.83),('3355','2013-09-17','10:35:00',1.06),('3355','2013-09-17','10:40:00',1.13),('3355','2013-09-17','10:50:00',2.07),('3355','2013-09-17','10:55:00',1.56),('3355','2013-09-17','11:00:00',1.2),('3355','2013-09-17','11:05:00',1.22),('3355','2013-09-17','11:10:00',1.76),('3355','2013-09-17','11:15:00',1.6),('3355','2013-09-17','11:20:00',1.31),('3355','2013-09-17','11:35:00',1.74),('3355','2013-09-17','11:40:00',1.97),('3355','2013-09-17','11:45:00',1.83),('3355','2013-09-17','11:50:00',1.76),('3355','2013-09-17','11:55:00',1.41),('3355','2013-09-17','12:00:00',2.05),('3355','2013-09-17','12:05:00',1.44),('3355','2013-09-17','12:15:00',1.23),('3355','2013-09-17','12:25:00',2.05),('3355','2013-09-17','12:30:00',1.81),('3355','2013-09-17','12:35:00',1.29),('3355','2013-09-17','12:40:00',1.81),('3355','2013-09-17','12:45:00',1.91),('3355','2013-09-17','12:50:00',1.77),('3355','2013-09-17','12:55:00',1.33),('3355','2013-09-17','13:00:00',1.35),('3355','2013-09-17','13:10:00',1.34),('3355','2013-09-17','13:15:00',1.92),('3355','2013-09-17','13:20:00',1.33),('3355','2013-09-17','13:25:00',1.23),('3355','2013-09-17','13:30:00',1.03),('3355','2013-09-17','13:40:00',1.27),('3355','2013-09-17','14:00:00',1.1),('3355','2013-09-17','14:25:00',1.06),('3355','2013-09-17','14:55:00',1.86),('3355','2013-09-17','15:00:00',2.03),('3355','2013-09-17','15:05:00',1.55),('3355','2013-09-17','15:10:00',1.53),('3355','2013-09-17','15:15:00',1.59),('3355','2013-09-17','15:20:00',1.75),('3355','2013-09-17','15:25:00',1.64),('3355','2013-09-17','15:30:00',1.45),('3355','2013-09-17','15:50:00',1.09),('3355','2013-09-17','15:55:00',1.29),('3355','2013-09-17','16:05:00',1.11),('3355','2013-09-17','17:05:00',1.01),('3355','2013-09-16','09:15:00',1.11),('3355','2013-09-16','09:25:00',1.11),('3355','2013-09-16','09:35:00',1.02),('3355','2013-09-16','09:40:00',1.29),('3355','2013-09-16','09:45:00',1.32),('3355','2013-09-16','09:50:00',1.34),('3355','2013-09-16','09:55:00',1.42),('3355','2013-09-16','10:00:00',1.45),('3355','2013-09-16','10:05:00',1.51),('3355','2013-09-16','10:10:00',1.64),('3355','2013-09-16','10:25:00',1.06),('3355','2013-09-16','10:30:00',1.46),('3355','2013-09-16','10:35:00',1.87),('3355','2013-09-16','10:40:00',1.99),('3355','2013-09-16','10:45:00',2.12),('3355','2013-09-16','10:50:00',1.59),('3355','2013-09-16','11:20:00',1.8),('3355','2013-09-16','11:25:00',1.39),('3355','2013-09-16','11:30:00',2.15),('3355','2013-09-16','11:35:00',2.11),('3355','2013-09-16','11:40:00',2.13),('3355','2013-09-16','11:45:00',2),('3355','2013-09-16','11:50:00',1.27),('3355','2013-09-16','11:55:00',2.23),('3355','2013-09-16','12:00:00',2.27),('3355','2013-09-16','12:05:00',2.35),('3355','2013-09-16','12:10:00',2.49),('3355','2013-09-16','12:15:00',2.23),('3355','2013-09-16','12:20:00',2.22),('3355','2013-09-16','12:25:00',2.2),('3355','2013-09-16','12:30:00',2.21),('3355','2013-09-16','12:35:00',2.23),('3355','2013-09-16','12:40:00',2.29),('3355','2013-09-16','12:45:00',2.42),('3355','2013-09-16','12:50:00',1.22),('3355','2013-09-16','12:55:00',1.95),('3355','2013-09-16','13:00:00',1.94),('3355','2013-09-16','13:05:00',1.87),('3355','2013-09-16','13:10:00',2.29),('3355','2013-09-16','13:15:00',2.02),('3355','2013-09-16','13:20:00',2.26),('3355','2013-09-16','13:25:00',2.25),('3355','2013-09-16','13:30:00',2.22),('3355','2013-09-16','13:35:00',2.23),('3355','2013-09-16','13:40:00',2.23),('3355','2013-09-16','13:45:00',2.22),('3355','2013-09-16','13:50:00',2.24),('3355','2013-09-16','13:55:00',2.29),('3355','2013-09-16','14:00:00',2.27),('3355','2013-09-16','14:05:00',2.15),('3355','2013-09-16','14:10:00',2.19),('3355','2013-09-16','14:15:00',2.16),('3355','2013-09-16','14:20:00',2.14),('3355','2013-09-16','14:25:00',2.13),('3355','2013-09-16','14:30:00',2.12),('3355','2013-09-16','14:35:00',2.11),('3355','2013-09-16','14:40:00',2.08),('3355','2013-09-16','14:45:00',2.05),('3355','2013-09-16','14:50:00',1.98),('3355','2013-09-16','14:55:00',1.96),('3355','2013-09-16','15:00:00',2.01),('3355','2013-09-16','15:05:00',2.01),('3355','2013-09-16','15:10:00',1.99),('3355','2013-09-16','15:15:00',1.96),('3355','2013-09-16','15:20:00',1.93),('3355','2013-09-16','15:25:00',1.91),('3355','2013-09-16','15:30:00',1.89),('3355','2013-09-16','15:35:00',1.86),('3355','2013-09-16','15:40:00',1.84),('3355','2013-09-16','15:45:00',1.82),('3355','2013-09-16','15:50:00',1.78),('3355','2013-09-16','15:55:00',1.74),('3355','2013-09-16','16:00:00',1.73),('3355','2013-09-16','16:05:00',1.32),('3355','2013-09-16','16:10:00',1.65),('3355','2013-09-16','16:15:00',1.61),('3355','2013-09-16','16:20:00',1.58),('3355','2013-09-16','16:25:00',1.53),('3355','2013-09-16','16:30:00',1.48),('3355','2013-09-16','16:35:00',1.44),('3355','2013-09-16','16:40:00',1.41),('3355','2013-09-16','16:45:00',1.37),('3355','2013-09-16','16:50:00',1.32),('3355','2013-09-16','16:55:00',1.27),('3355','2013-09-16','17:00:00',1.22),('3355','2013-09-16','17:05:00',1.18),('3355','2013-09-16','17:10:00',1.12),('3355','2013-09-16','17:15:00',1.07),('3355','2013-09-16','17:20:00',1.01),('3355','2013-09-15','09:15:00',1.07),('3355','2013-09-15','09:20:00',1.06),('3355','2013-09-15','09:25:00',1.11),('3355','2013-09-15','09:30:00',1.14),('3355','2013-09-15','09:35:00',1.23),('3355','2013-09-15','09:40:00',1.27),('3355','2013-09-15','09:45:00',1.29),('3355','2013-09-15','09:50:00',1.34),('3355','2013-09-15','09:55:00',1.38),('3355','2013-09-15','10:00:00',1.45),('3355','2013-09-15','10:05:00',1.49),('3355','2013-09-15','10:10:00',1.5),('3355','2013-09-15','10:15:00',1.47),('3355','2013-09-15','10:20:00',1.51),('3355','2013-09-15','10:25:00',1.58),('3355','2013-09-15','10:30:00',1.49),('3355','2013-09-15','10:35:00',1.22),('3355','2013-09-15','11:05:00',2.08),('3355','2013-09-15','11:10:00',2.04),('3355','2013-09-15','11:35:00',1.86),('3355','2013-09-15','11:40:00',1.06),('3355','2013-09-15','11:50:00',1.15),('3355','2013-09-15','13:50:00',1.07),('3355','2013-09-15','15:15:00',1.53),('3355','2013-09-15','15:20:00',1.26),('3355','2013-09-14','09:15:00',1.04),('3355','2013-09-14','09:20:00',1.08),('3355','2013-09-14','09:25:00',1.13),('3355','2013-09-14','09:30:00',1.18),('3355','2013-09-14','09:35:00',1.21),('3355','2013-09-14','09:40:00',1.25),('3355','2013-09-14','09:45:00',1.3),('3355','2013-09-14','09:50:00',1.28),('3355','2013-09-14','09:55:00',1.34),('3355','2013-09-14','10:00:00',1.38),('3355','2013-09-14','10:05:00',1.45),('3355','2013-09-14','10:10:00',1.36),('3355','2013-09-14','10:15:00',1.42),('3355','2013-09-14','10:20:00',1.53),('3355','2013-09-14','10:25:00',1.6),('3355','2013-09-14','10:30:00',1.6),('3355','2013-09-14','10:35:00',1.62),('3355','2013-09-14','10:40:00',1.75),('3355','2013-09-14','10:45:00',1.91),('3355','2013-09-14','10:50:00',1.81),('3355','2013-09-14','10:55:00',1.98),('3355','2013-09-14','11:00:00',2.06),('3355','2013-09-14','11:05:00',1.53),('3355','2013-09-14','11:30:00',2.1),('3355','2013-09-14','11:35:00',1.87),('3355','2013-09-14','11:40:00',1.25),('3355','2013-09-14','11:45:00',1.93),('3355','2013-09-14','11:50:00',1.81),('3355','2013-09-14','11:55:00',2.26),('3355','2013-09-14','12:00:00',1.92),('3355','2013-09-14','12:05:00',2.18),('3355','2013-09-14','12:10:00',1.28),('3355','2013-09-14','12:15:00',1.87),('3355','2013-09-14','12:40:00',2.07),('3355','2013-09-14','13:15:00',1.29),('3355','2013-09-14','13:20:00',2.39),('3355','2013-09-14','13:25:00',1.41),('3355','2013-09-14','13:30:00',2.49),('3355','2013-09-14','13:35:00',1.27),('3355','2013-09-14','13:45:00',1.05),('3355','2013-09-14','13:50:00',1.28),('3355','2013-09-14','13:55:00',2.52),('3355','2013-09-14','14:00:00',2.45),('3355','2013-09-14','14:05:00',2.26),('3355','2013-09-14','14:10:00',2.23),('3355','2013-09-14','14:15:00',2.2),('3355','2013-09-14','14:20:00',2.04),('3355','2013-09-14','14:25:00',2.13),('3355','2013-09-14','14:30:00',2.18),('3355','2013-09-14','14:35:00',2.06),('3355','2013-09-14','14:40:00',2.11),('3355','2013-09-14','14:45:00',2.04),('3355','2013-09-14','14:50:00',2.07),('3355','2013-09-14','14:55:00',2.04),('3355','2013-09-14','15:00:00',2.03),('3355','2013-09-14','15:05:00',1.98),('3355','2013-09-14','15:10:00',1.96),('3355','2013-09-14','15:15:00',1.94),('3355','2013-09-14','15:20:00',1.93),('3355','2013-09-14','15:25:00',1.93),('3355','2013-09-14','15:30:00',1.64),('3355','2013-09-14','15:35:00',1.86),('3355','2013-09-14','15:40:00',1.81),('3355','2013-09-14','15:45:00',1.79),('3355','2013-09-14','15:50:00',1.76),('3355','2013-09-14','15:55:00',1.72),('3355','2013-09-14','16:00:00',1.69),('3355','2013-09-14','16:05:00',1.64),('3355','2013-09-14','16:10:00',1.6),('3355','2013-09-14','16:15:00',1.58),('3355','2013-09-14','16:20:00',1.55),('3355','2013-09-14','16:25:00',1.49),('3355','2013-09-14','16:30:00',1.48),('3355','2013-09-14','16:35:00',1.43),('3355','2013-09-14','16:40:00',1.38),('3355','2013-09-14','16:45:00',1.34),('3355','2013-09-14','16:50:00',1.3),('3355','2013-09-14','16:55:00',1.25),('3355','2013-09-14','17:00:00',1.1),('3355','2013-09-14','17:05:00',1.17),('3355','2013-09-14','17:10:00',1.04),('3355','2013-09-14','17:15:00',1),('3355','2013-09-13','09:55:00',1.43),('3355','2013-09-13','10:00:00',1.42),('3355','2013-09-13','10:15:00',1.81),('3355','2013-09-13','10:20:00',1.94),('3355','2013-09-13','10:25:00',1.2),('3355','2013-09-13','10:35:00',1.8),('3355','2013-09-13','10:40:00',1.74),('3355','2013-09-13','10:45:00',1.77),('3355','2013-09-13','10:50:00',1.79),('3355','2013-09-13','10:55:00',1.81),('3355','2013-09-13','11:00:00',1.84),('3355','2013-09-13','11:05:00',1.87),('3355','2013-09-13','11:10:00',1.89),('3355','2013-09-13','11:15:00',1.92),('3355','2013-09-13','11:20:00',1.95),('3355','2013-09-13','11:25:00',1.96),('3355','2013-09-13','11:30:00',1.98),('3355','2013-09-13','11:35:00',2),('3355','2013-09-13','11:40:00',2.02),('3355','2013-09-13','11:45:00',2.05),('3355','2013-09-13','11:50:00',2.06),('3355','2013-09-13','11:55:00',2.07),('3355','2013-09-13','12:00:00',2.08),('3355','2013-09-13','12:05:00',2.12),('3355','2013-09-13','12:10:00',2.13),('3355','2013-09-13','12:15:00',2.13),('3355','2013-09-13','12:20:00',2.15),('3355','2013-09-13','12:25:00',2.19),('3355','2013-09-13','12:30:00',2.23),('3355','2013-09-13','12:35:00',2.2),('3355','2013-09-13','12:40:00',2.21),('3355','2013-09-13','12:45:00',2.2),('3355','2013-09-13','12:50:00',2.22),('3355','2013-09-13','12:55:00',2.22),('3355','2013-09-13','13:00:00',2.2),('3355','2013-09-13','13:05:00',2.19),('3355','2013-09-13','13:10:00',2.18),('3355','2013-09-13','13:15:00',2.17),('3355','2013-09-13','13:20:00',2.18),('3355','2013-09-13','13:25:00',2.18),('3355','2013-09-13','13:30:00',2.18),('3355','2013-09-13','13:35:00',2.17),('3355','2013-09-13','13:40:00',2.17),('3355','2013-09-13','13:45:00',2.17),('3355','2013-09-13','13:50:00',2.16),('3355','2013-09-13','13:55:00',2.15),('3355','2013-09-13','14:00:00',2.14),('3355','2013-09-13','14:05:00',2.15),('3355','2013-09-13','14:10:00',2.13),('3355','2013-09-13','14:15:00',2.1),('3355','2013-09-13','14:20:00',2.08),('3355','2013-09-13','14:25:00',2.09),('3355','2013-09-13','14:30:00',2.1),('3355','2013-09-13','14:35:00',2.08),('3355','2013-09-13','14:40:00',2.07),('3355','2013-09-13','14:45:00',2.05),('3355','2013-09-13','14:50:00',2.08),('3355','2013-09-13','14:55:00',1.75),('3355','2013-09-13','15:00:00',1.98),('3355','2013-09-13','15:05:00',1.96),('3355','2013-09-13','15:10:00',1.97),('3355','2013-09-13','15:15:00',1.97),('3355','2013-09-13','15:20:00',1.93),('3355','2013-09-13','15:25:00',1.89),('3355','2013-09-13','15:30:00',1.88),('3355','2013-09-13','15:35:00',1.86),('3355','2013-09-13','15:40:00',1.83),('3355','2013-09-13','15:45:00',1.8),('3355','2013-09-13','15:50:00',1.77),('3355','2013-09-13','15:55:00',1.73),('3355','2013-09-13','16:00:00',1.7),('3355','2013-09-13','16:05:00',1.67),('3355','2013-09-13','16:10:00',1.64),('3355','2013-09-13','16:15:00',1.6),('3355','2013-09-13','16:20:00',1.56),('3355','2013-09-13','16:25:00',1.53),('3355','2013-09-13','16:30:00',1.48),('3355','2013-09-13','16:35:00',1.45),('3355','2013-09-13','16:40:00',1.4),('3355','2013-09-13','16:45:00',1.35),('3355','2013-09-13','16:50:00',1.31),('3355','2013-09-13','16:55:00',1.26),('3355','2013-09-13','17:00:00',1.2),('3355','2013-09-13','17:05:00',1.16),('3355','2013-09-13','17:10:00',1.11),('3355','2013-09-13','17:15:00',1.06),('3355','2013-09-13','17:20:00',1.01),('3355','2013-09-12','09:15:00',1.04),('3355','2013-09-12','09:20:00',1.03),('3355','2013-09-12','09:25:00',1.15),('3355','2013-09-12','09:30:00',1.24),('3355','2013-09-12','09:35:00',1.04),('3355','2013-09-12','09:45:00',1.07),('3355','2013-09-12','09:50:00',1.29),('3355','2013-09-12','10:55:00',1.06),('3355','2013-09-12','11:00:00',1.2),('3355','2013-09-12','11:05:00',1.67),('3355','2013-09-12','11:10:00',1.26),('3355','2013-09-12','11:15:00',1.49),('3355','2013-09-12','11:45:00',1.38),('3355','2013-09-12','11:55:00',1.33),('3355','2013-09-12','12:00:00',1.78),('3355','2013-09-12','12:05:00',2.15),('3355','2013-09-12','12:10:00',1.78),('3355','2013-09-12','12:15:00',1.5),('3355','2013-09-12','12:35:00',1.5),('3355','2013-09-12','12:40:00',1.98),('3355','2013-09-12','12:50:00',1.05),('3355','2013-09-12','12:55:00',1.1),('3355','2013-09-12','13:00:00',2.27),('3355','2013-09-12','13:05:00',1.52),('3355','2013-09-12','13:10:00',1.85),('3355','2013-09-12','13:15:00',2.32),('3355','2013-09-12','13:20:00',2.56),('3355','2013-09-12','13:25:00',2.58),('3355','2013-09-12','13:30:00',2.03),('3355','2013-09-12','13:35:00',1.84),('3355','2013-09-12','13:40:00',1.44),('3355','2013-09-12','13:45:00',1.91),('3355','2013-09-12','13:50:00',2.33),('3355','2013-09-12','13:55:00',2.28),('3355','2013-09-12','14:00:00',2.31),('3355','2013-09-12','14:05:00',2.17),('3355','2013-09-12','14:10:00',1.77),('3355','2013-09-12','14:15:00',2.25),('3355','2013-09-12','14:20:00',2.21),('3355','2013-09-12','14:25:00',2.28),('3355','2013-09-12','14:30:00',2.22),('3355','2013-09-12','14:35:00',1.82),('3355','2013-09-12','14:40:00',1.52),('3355','2013-09-12','14:45:00',2.2),('3355','2013-09-12','14:50:00',2.13),('3355','2013-09-12','14:55:00',2.1),('3355','2013-09-12','15:00:00',2.08),('3355','2013-09-12','15:05:00',1.64),('3355','2013-09-12','15:10:00',1.79),('3355','2013-09-12','15:15:00',1.74),('3355','2013-09-12','15:20:00',1.98),('3355','2013-09-12','15:25:00',1.86),('3355','2013-09-12','15:30:00',1.94),('3355','2013-09-12','15:35:00',1.9),('3355','2013-09-12','15:40:00',1.86),('3355','2013-09-12','15:45:00',1.87),('3355','2013-09-12','15:50:00',1.83),('3355','2013-09-12','15:55:00',1.79),('3355','2013-09-12','16:00:00',1.8),('3355','2013-09-12','16:05:00',1.56),('3355','2013-09-12','16:10:00',1.36),('3355','2013-09-12','16:15:00',1.22),('3355','2013-09-12','16:20:00',1.22),('3355','2013-09-12','16:25:00',1.27),('3355','2013-09-12','16:40:00',1.06),('3355','2013-09-12','16:45:00',1.56),('3355','2013-09-12','16:55:00',1.05),('3355','2013-09-12','17:05:00',1.16),('3355','2013-09-12','17:15:00',1.19),('3355','2013-09-11','09:00:00',1.02),('3355','2013-09-11','09:10:00',1.04),('3355','2013-09-11','09:15:00',1.02),('3355','2013-09-11','09:20:00',1.08),('3355','2013-09-11','09:25:00',1.09),('3355','2013-09-11','10:05:00',1.48),('3355','2013-09-11','10:20:00',1.66),('3355','2013-09-11','10:25:00',1.34),('3355','2013-09-11','10:30:00',1.24),('3355','2013-09-11','10:35:00',1.66),('3355','2013-09-11','10:40:00',1.94),('3355','2013-09-11','10:45:00',1.51),('3355','2013-09-11','10:50:00',1.61),('3355','2013-09-11','10:55:00',1.05),('3355','2013-09-11','11:05:00',1.53),('3355','2013-09-11','11:10:00',2.06),('3355','2013-09-11','11:15:00',1.44),('3355','2013-09-11','11:20:00',2.15),('3355','2013-09-11','11:25:00',1.89),('3355','2013-09-11','11:35:00',1.6),('3355','2013-09-11','11:40:00',1.27),('3355','2013-09-11','11:45:00',2.17),('3355','2013-09-11','11:50:00',2.17),('3355','2013-09-11','11:55:00',2.02),('3355','2013-09-11','12:00:00',1.53),('3355','2013-09-11','12:05:00',2.04),('3355','2013-09-11','12:10:00',1.2),('3355','2013-09-11','12:15:00',1.42),('3355','2013-09-11','12:20:00',1.37),('3355','2013-09-11','12:25:00',1.18),('3355','2013-09-11','12:30:00',2.27),('3355','2013-09-11','12:35:00',1.27),('3355','2013-09-11','12:45:00',1.62),('3355','2013-09-11','12:50:00',2.2),('3355','2013-09-11','12:55:00',2.19),('3355','2013-09-11','13:00:00',1.96),('3355','2013-09-11','13:05:00',2.33),('3355','2013-09-11','13:10:00',2.32),('3355','2013-09-11','13:15:00',2.38),('3355','2013-09-11','13:20:00',2.43),('3355','2013-09-11','13:25:00',2.31),('3355','2013-09-11','13:30:00',2.17),('3355','2013-09-11','13:35:00',1.08),('3355','2013-09-11','13:40:00',2.09),('3355','2013-09-11','13:45:00',1.25),('3355','2013-09-11','13:50:00',2.38),('3355','2013-09-11','13:55:00',1.49),('3355','2013-09-11','14:00:00',1.76),('3355','2013-09-11','14:05:00',2.31),('3355','2013-09-11','14:10:00',1.25),('3355','2013-09-11','14:15:00',2.1),('3355','2013-09-11','14:20:00',1.61),('3355','2013-09-11','14:25:00',2.23),('3355','2013-09-11','14:30:00',2.2),('3355','2013-09-11','14:35:00',1.89),('3355','2013-09-11','14:40:00',1.01),('3355','2013-09-11','14:45:00',2.07),('3355','2013-09-11','14:50:00',1.83),('3355','2013-09-11','14:55:00',1.57),('3355','2013-09-11','15:00:00',1.75),('3355','2013-09-11','15:05:00',2.07),('3355','2013-09-11','15:10:00',1.47),('3355','2013-09-11','15:15:00',1.91),('3355','2013-09-11','15:20:00',2.23),('3355','2013-09-11','15:25:00',1.18),('3355','2013-09-11','15:30:00',1.35),('3355','2013-09-11','15:45:00',1.45),('3355','2013-09-11','15:50:00',1.73),('3355','2013-09-11','15:55:00',1.75),('3355','2013-09-11','16:00:00',1.78),('3355','2013-09-11','16:05:00',1.39),('3355','2013-09-11','16:10:00',1.77),('3355','2013-09-11','16:15:00',1.72),('3355','2013-09-11','16:20:00',1.62),('3355','2013-09-11','16:25:00',1.17),('3355','2013-09-11','16:30:00',1.44),('3355','2013-09-11','16:35:00',1.15),('3355','2013-09-11','16:45:00',1.48),('3355','2013-09-11','16:50:00',1.37),('3355','2013-09-11','16:55:00',1.19),('3355','2013-09-11','17:05:00',1.23),('3355','2013-09-11','17:10:00',1.17),('3355','2013-09-11','17:15:00',1.1),('3355','2013-09-11','17:20:00',1.06),('3355','2013-09-11','17:25:00',1.01),('3355','2013-09-10','09:05:00',1.02),('3355','2013-09-10','09:10:00',1.19),('3355','2013-09-10','09:15:00',1.02),('3355','2013-09-10','09:30:00',1.3),('3355','2013-09-10','09:35:00',1.52),('3355','2013-09-10','10:45:00',1.07),('3355','2013-09-10','13:45:00',1.55),('3355','2013-09-10','13:50:00',1),('3355','2013-09-10','14:25:00',1.18),('3355','2013-09-10','14:30:00',1.09),('3355','2013-09-10','14:45:00',1.01),('3355','2013-09-10','14:50:00',1.17),('3355','2013-09-10','14:55:00',1.09),('3355','2013-09-10','15:00:00',1.34),('3355','2013-09-10','15:05:00',1.3),('3355','2013-09-10','15:20:00',1.14),('3355','2013-09-10','15:25:00',1),('3355','2013-09-10','15:30:00',1.15),('3355','2013-09-10','15:35:00',1.04),('3355','2013-09-09','10:50:00',1.33),('3355','2013-09-09','10:55:00',1.31),('3355','2013-09-09','11:00:00',1.45),('3355','2013-09-09','11:05:00',1.17),('3355','2013-09-09','11:15:00',1.03),('3355','2013-09-09','11:20:00',1.12),('3355','2013-09-09','11:25:00',1.47),('3355','2013-09-09','11:30:00',1.18),('3355','2013-09-09','11:35:00',1.09),('3355','2013-09-09','11:40:00',1.37),('3355','2013-09-09','11:45:00',1.88),('3355','2013-09-09','11:50:00',1.92),('3355','2013-09-09','11:55:00',1.38),('3355','2013-09-09','12:00:00',1.46),('3355','2013-09-09','12:05:00',1.8),('3355','2013-09-09','12:10:00',1.41),('3355','2013-09-09','13:05:00',1.27),('3355','2013-09-09','13:10:00',1.72),('3355','2013-09-09','13:15:00',1.69),('3355','2013-09-09','13:25:00',1.22),('3355','2013-09-09','13:30:00',1.26),('3355','2013-09-09','13:35:00',2.2),('3355','2013-09-09','13:40:00',2.09),('3355','2013-09-09','13:45:00',2.11),('3355','2013-09-09','13:50:00',2.11),('3355','2013-09-09','13:55:00',2.21),('3355','2013-09-09','14:00:00',2.05),('3355','2013-09-09','14:05:00',1.92),('3355','2013-09-09','14:10:00',1.71),('3355','2013-09-09','14:15:00',1.47),('3355','2013-09-09','14:20:00',1.23),('3355','2013-09-09','14:35:00',2.07),('3355','2013-09-09','14:40:00',1.59),('3355','2013-09-09','14:50:00',1.63),('3355','2013-09-09','14:55:00',1.78),('3355','2013-09-09','15:00:00',1.55),('3355','2013-09-09','15:05:00',1.35),('3355','2013-09-09','15:10:00',1.83),('3355','2013-09-09','15:20:00',1.07),('3355','2013-09-09','15:30:00',1.55),('3355','2013-09-09','15:35:00',1.3),('3355','2013-09-09','15:40:00',1.23),('3355','2013-09-09','16:15:00',1.23),('3355','2013-09-09','16:20:00',1.06),('3355','2013-09-09','16:45:00',1.27),('3355','2014-04-12','09:25:00',1.22),('3355','2014-04-12','10:30:00',1.06),('3355','2014-04-12','10:35:00',1.18),('3355','2014-04-12','10:40:00',1.38),('3355','2014-04-12','10:45:00',1.38),('3355','2014-04-12','10:50:00',1.34),('3355','2014-04-12','10:55:00',1.02),('3355','2014-04-12','11:00:00',1.46),('3355','2014-04-12','11:05:00',1.71),('3355','2014-04-12','11:10:00',2.11),('3355','2014-04-12','11:15:00',2.25),('3355','2014-04-12','11:20:00',2.14),('3355','2014-04-12','11:25:00',2.01),('3355','2014-04-12','11:30:00',1.77),('3355','2014-04-12','11:35:00',1.9),('3355','2014-04-12','11:40:00',2.05),('3355','2014-04-12','11:45:00',2.09),('3355','2014-04-12','11:50:00',1.81),('3355','2014-04-12','11:55:00',1.06),('3355','2014-04-12','12:00:00',1.04),('3355','2014-04-12','12:05:00',1.1),('3355','2014-04-12','12:30:00',1.51),('3355','2014-04-12','12:35:00',1.38),('3355','2014-04-12','12:40:00',1.57),('3355','2014-04-12','12:45:00',1.77),('3355','2014-04-12','12:50:00',1.74),('3355','2014-04-12','12:55:00',1.11),('3355','2014-04-12','13:10:00',1.52),('3355','2014-04-12','13:15:00',2.2),('3355','2014-04-12','13:20:00',2.38),('3355','2014-04-12','13:25:00',2.38),('3355','2014-04-12','13:30:00',1.85),('3355','2014-04-12','14:05:00',1.07),('3355','2014-04-12','14:10:00',1.72),('3355','2014-04-12','14:15:00',2.25),('3355','2014-04-12','14:20:00',1.59),('3355','2014-04-12','14:25:00',2.31),('3355','2014-04-12','14:30:00',1.89),('3355','2014-04-12','14:35:00',1.53),('3355','2014-04-12','14:40:00',1.52),('3355','2014-04-12','14:45:00',1.58),('3355','2014-04-12','14:50:00',2.17),('3355','2014-04-12','14:55:00',2.12),('3355','2014-04-12','15:00:00',1.96),('3355','2014-04-12','15:05:00',2.03),('3355','2014-04-12','15:10:00',2.04),('3355','2014-04-12','15:15:00',2.07),('3355','2014-04-12','15:20:00',1.76),('3355','2014-04-12','15:25:00',1.62),('3355','2014-04-12','15:30:00',1.12),('3355','2014-04-12','15:35:00',1.47),('3355','2014-04-12','15:40:00',1.71),('3355','2014-04-12','15:45:00',1.79),('3355','2014-04-12','15:50:00',2.03),('3355','2014-04-12','15:55:00',1.96),('3355','2014-04-12','16:00:00',1.95),('3355','2014-04-12','16:05:00',1.94),('3355','2014-04-12','16:10:00',1.92),('3355','2014-04-12','16:15:00',1.77),('3355','2014-04-12','16:20:00',1.9),('3355','2014-04-12','16:25:00',1.73),('3355','2014-04-12','16:30:00',1.67),('3355','2014-04-12','16:35:00',1.62),('3355','2014-04-12','16:40:00',1.1),('3355','2014-04-12','16:45:00',1.02),('3355','2014-04-12','16:55:00',1.07),('3355','2014-04-12','17:00:00',1.43),('3355','2014-04-12','17:05:00',1.32),('3355','2014-04-12','17:10:00',1.3),('3355','2014-04-12','17:15:00',1.22),('3355','2014-04-12','17:25:00',1.03),('3355','2014-04-12','17:50:00',1.01),('3355','2013-09-08','09:35:00',1.21),('3355','2013-09-08','09:45:00',1.13),('3355','2013-09-08','09:50:00',1.25),('3355','2013-09-08','09:55:00',1.28),('3355','2013-09-08','10:00:00',1.33),('3355','2013-09-08','10:05:00',1.37),('3355','2013-09-08','10:10:00',1.36),('3355','2013-09-08','10:15:00',1.42),('3355','2013-09-08','10:20:00',1.46),('3355','2013-09-08','10:25:00',1.49),('3355','2013-09-08','10:30:00',1.48),('3355','2013-09-08','10:35:00',1.54),('3355','2013-09-08','10:40:00',1.58),('3355','2013-09-08','10:45:00',1.61),('3355','2013-09-08','10:50:00',1.65),('3355','2013-09-08','10:55:00',1.68),('3355','2013-09-08','11:00:00',1.71),('3355','2013-09-08','11:05:00',1.7),('3355','2013-09-08','11:10:00',1.7),('3355','2013-09-08','11:15:00',1.73),('3355','2013-09-08','11:20:00',1.51),('3355','2013-09-08','11:25:00',1.72),('3355','2013-09-08','11:30:00',1.81),('3355','2013-09-08','11:35:00',1.84),('3355','2013-09-08','11:40:00',1.85),('3355','2013-09-08','11:45:00',1.87),('3355','2013-09-08','11:50:00',1.84),('3355','2013-09-08','11:55:00',1.86),('3355','2013-09-08','12:00:00',1.83),('3355','2013-09-08','12:05:00',1.82),('3355','2013-09-08','12:10:00',1.84),('3355','2013-09-08','12:15:00',1.9),('3355','2013-09-08','12:20:00',1.91),('3355','2013-09-08','12:25:00',1.92),('3355','2013-09-08','12:30:00',1.93),('3355','2013-09-08','12:35:00',1.98),('3355','2013-09-08','12:40:00',1.88),('3355','2013-09-08','12:45:00',1.82),('3355','2013-09-08','12:50:00',1.93),('3355','2013-09-08','12:55:00',1.96),('3355','2013-09-08','13:00:00',1.96),('3355','2013-09-08','13:05:00',1.99),('3355','2013-09-08','13:10:00',1.99),('3355','2013-09-08','13:15:00',1.95),('3355','2013-09-08','13:20:00',1.93),('3355','2013-09-08','13:25:00',1.89),('3355','2013-09-08','13:30:00',1.78),('3355','2013-09-08','13:35:00',1.75),('3355','2013-09-08','13:40:00',1.38),('3355','2013-09-08','13:45:00',1.13),('3355','2013-09-08','13:50:00',1.4),('3355','2013-09-08','13:55:00',1.51),('3355','2013-09-08','14:00:00',1.8),('3355','2013-09-08','14:05:00',1.86),('3355','2013-09-08','14:10:00',1.98),('3355','2013-09-08','14:15:00',1.81),('3355','2013-09-08','14:20:00',1.82),('3355','2013-09-08','14:25:00',2.16),('3355','2013-09-08','14:30:00',1.91),('3355','2013-09-08','14:35:00',2.03),('3355','2013-09-08','14:40:00',1.98),('3355','2013-09-08','14:45:00',1.96),('3355','2013-09-08','14:50:00',1.95),('3355','2013-09-08','14:55:00',1.91),('3355','2013-09-08','15:00:00',1.92),('3355','2013-09-08','15:05:00',1.68),('3355','2013-09-08','15:10:00',1.01),('3355','2013-09-08','15:15:00',1.4),('3355','2013-09-08','15:20:00',1.82),('3355','2013-09-08','15:25:00',1.84),('3355','2013-09-08','15:30:00',1.88),('3355','2013-09-08','15:35:00',1.81),('3355','2013-09-08','15:40:00',1.69),('3355','2013-09-08','15:45:00',1.7),('3355','2013-09-08','15:50:00',1.73),('3355','2013-09-08','15:55:00',1.39),('3355','2013-09-08','16:00:00',1.42),('3355','2013-09-08','16:05:00',1.44),('3355','2013-09-08','16:10:00',1.36),('3355','2013-09-08','16:15:00',1.39),('3355','2013-09-08','16:20:00',1.39),('3355','2013-09-08','16:25:00',1.38),('3355','2013-09-08','16:30:00',1.29),('3355','2013-09-08','16:35:00',1.31),('3355','2013-09-08','16:40:00',1.14),('3355','2013-09-08','17:05:00',1.17),('3355','2013-09-08','17:10:00',1.16),('3355','2013-09-08','17:15:00',1.05),('3355','2013-09-07','09:20:00',1.03),('3355','2013-09-07','09:25:00',1.08),('3355','2013-09-07','09:30:00',1.13),('3355','2013-09-07','09:35:00',1.16),('3355','2013-09-07','09:40:00',1.19),('3355','2013-09-07','09:45:00',1.23),('3355','2013-09-07','09:50:00',1.28),('3355','2013-09-07','09:55:00',1.32),('3355','2013-09-07','10:00:00',1.36),('3355','2013-09-07','10:05:00',1.39),('3355','2013-09-07','10:10:00',1.43),('3355','2013-09-07','10:15:00',1.46),('3355','2013-09-07','10:20:00',1.5),('3355','2013-09-07','10:25:00',1.54),('3355','2013-09-07','10:30:00',1.57),('3355','2013-09-07','10:35:00',1.58),('3355','2013-09-07','10:40:00',1.59),('3355','2013-09-07','10:45:00',1.61),('3355','2013-09-07','10:50:00',1.65),('3355','2013-09-07','10:55:00',1.67),('3355','2013-09-07','11:00:00',1.71),('3355','2013-09-07','11:05:00',1.73),('3355','2013-09-07','11:10:00',1.74),('3355','2013-09-07','11:15:00',1.79),('3355','2013-09-07','11:20:00',1.82),('3355','2013-09-07','11:25:00',1.84),('3355','2013-09-07','11:30:00',1.85),('3355','2013-09-07','11:35:00',1.88),('3355','2013-09-07','11:40:00',1.91),('3355','2013-09-07','11:45:00',1.91),('3355','2013-09-07','11:50:00',1.93),('3355','2013-09-07','11:55:00',1.94),('3355','2013-09-07','12:00:00',1.96),('3355','2013-09-07','12:05:00',1.97),('3355','2013-09-07','12:10:00',1.97),('3355','2013-09-07','12:15:00',1.98),('3355','2013-09-07','12:20:00',1.99),('3355','2013-09-07','12:25:00',2),('3355','2013-09-07','12:30:00',2),('3355','2013-09-07','12:35:00',2.02),('3355','2013-09-07','12:40:00',1.99),('3355','2013-09-07','12:45:00',1.99),('3355','2013-09-07','12:50:00',2.03),('3355','2013-09-07','12:55:00',2.05),('3355','2013-09-07','13:00:00',2.05),('3355','2013-09-07','13:05:00',2.03),('3355','2013-09-07','13:10:00',2.04),('3355','2013-09-07','13:15:00',1.95),('3355','2013-09-07','13:20:00',2.02),('3355','2013-09-07','13:25:00',2.03),('3355','2013-09-07','13:30:00',2.06),('3355','2013-09-07','13:35:00',2.08),('3355','2013-09-07','13:40:00',2.09),('3355','2013-09-07','13:45:00',1.84),('3355','2013-09-07','13:55:00',1.99),('3355','2013-09-07','14:00:00',2.09),('3355','2013-09-07','14:05:00',1.92),('3355','2013-09-07','14:10:00',2.07),('3355','2013-09-07','14:15:00',2.06),('3355','2013-09-07','14:20:00',2.05),('3355','2013-09-07','14:25:00',1.99),('3355','2013-09-07','14:30:00',1.92),('3355','2013-09-07','14:35:00',1.99),('3355','2013-09-07','14:40:00',1.97),('3355','2013-09-07','14:45:00',1.98),('3355','2013-09-07','14:50:00',1.96),('3355','2013-09-07','14:55:00',1.94),('3355','2013-09-07','15:00:00',1.93),('3355','2013-09-07','15:05:00',1.91),('3355','2013-09-07','15:10:00',1.87),('3355','2013-09-07','15:15:00',1.88),('3355','2013-09-07','15:20:00',1.84),('3355','2013-09-07','15:25:00',1.83),('3355','2013-09-07','15:30:00',1.81),('3355','2013-09-07','15:35:00',1.78),('3355','2013-09-07','15:40:00',1.74),('3355','2013-09-07','15:45:00',1.71),('3355','2013-09-07','15:50:00',1.68),('3355','2013-09-07','15:55:00',1.65),('3355','2013-09-07','16:00:00',1.62),('3355','2013-09-07','16:05:00',1.59),('3355','2013-09-07','16:10:00',1.55),('3355','2013-09-07','16:15:00',1.51),('3355','2013-09-07','16:20:00',1.47),('3355','2013-09-07','16:25:00',1.43),('3355','2013-09-07','16:30:00',1.39),('3355','2013-09-07','16:35:00',1.35),('3355','2013-09-07','16:40:00',1.32),('3355','2013-09-07','16:45:00',1.29),('3355','2013-09-07','16:50:00',1.24),('3355','2013-09-07','16:55:00',1.2),('3355','2013-09-07','17:00:00',1.15),('3355','2013-09-07','17:05:00',1.11),('3355','2013-09-07','17:10:00',1.05),('3355','2013-09-06','09:15:00',1.01),('3355','2013-09-06','09:20:00',1.06),('3355','2013-09-06','09:25:00',1.1),('3355','2013-09-06','09:30:00',1.14),('3355','2013-09-06','09:35:00',1.17),('3355','2013-09-06','09:40:00',1.22),('3355','2013-09-06','09:45:00',1.27),('3355','2013-09-06','09:50:00',1.31),('3355','2013-09-06','09:55:00',1.34),('3355','2013-09-06','10:00:00',1.38),('3355','2013-09-06','10:05:00',1.41),('3355','2013-09-06','10:10:00',1.44),('3355','2013-09-06','10:15:00',1.48),('3355','2013-09-06','10:20:00',1.51),('3355','2013-09-06','10:25:00',1.55),('3355','2013-09-06','10:30:00',1.59),('3355','2013-09-06','10:35:00',1.61),('3355','2013-09-06','10:40:00',1.66),('3355','2013-09-06','10:45:00',1.67),('3355','2013-09-06','10:50:00',1.7),('3355','2013-09-06','10:55:00',1.74),('3355','2013-09-06','11:00:00',1.76),('3355','2013-09-06','11:05:00',1.78),('3355','2013-09-06','11:10:00',1.8),('3355','2013-09-06','11:15:00',1.83),('3355','2013-09-06','11:20:00',1.87),('3355','2013-09-06','11:25:00',1.88),('3355','2013-09-06','11:30:00',1.89),('3355','2013-09-06','11:35:00',1.9),('3355','2013-09-06','11:40:00',1.92),('3355','2013-09-06','11:45:00',1.93),('3355','2013-09-06','11:50:00',1.95),('3355','2013-09-06','11:55:00',1.96),('3355','2013-09-06','12:00:00',1.96),('3355','2013-09-06','12:05:00',1.98),('3355','2013-09-06','12:10:00',1.99),('3355','2013-09-06','12:15:00',2.01),('3355','2013-09-06','12:20:00',2.05),('3355','2013-09-06','12:25:00',2.06),('3355','2013-09-06','12:30:00',2.07),('3355','2013-09-06','12:35:00',2.05),('3355','2013-09-06','12:40:00',2.02),('3355','2013-09-06','12:45:00',2.03),('3355','2013-09-06','12:50:00',2.04),('3355','2013-09-06','12:55:00',2.05),('3355','2013-09-06','13:00:00',2.07),('3355','2013-09-06','13:05:00',2.08),('3355','2013-09-06','13:10:00',2.07),('3355','2013-09-06','13:15:00',2.06),('3355','2013-09-06','13:20:00',2.07),('3355','2013-09-06','13:25:00',2.06),('3355','2013-09-06','13:30:00',2.02),('3355','2013-09-06','16:20:00',1.45),('3355','2013-09-06','16:25:00',1.44),('3355','2013-09-06','16:30:00',1.41),('3355','2013-09-06','16:35:00',1.38),('3355','2013-09-06','16:40:00',1.34),('3355','2013-09-06','16:45:00',1.29),('3355','2013-09-06','16:50:00',1.23),('3355','2013-09-06','16:55:00',1.21),('3355','2013-09-06','17:00:00',1.16),('3355','2013-09-06','17:05:00',1.1),('3355','2013-09-06','17:10:00',1.07),('3355','2013-09-06','17:15:00',1.02),('3355','2013-09-05','09:10:00',1.04),('3355','2013-09-05','09:15:00',1.08),('3355','2013-09-05','09:20:00',1.13),('3355','2013-09-05','09:25:00',1.18),('3355','2013-09-05','09:30:00',1.21),('3355','2013-09-05','09:35:00',1.26),('3355','2013-09-05','09:40:00',1.29),('3355','2013-09-05','09:45:00',1.34),('3355','2013-09-05','09:50:00',1.38),('3355','2013-09-05','09:55:00',1.42),('3355','2013-09-05','10:00:00',1.46),('3355','2013-09-05','10:05:00',1.49),('3355','2013-09-05','10:10:00',1.53),('3355','2013-09-05','10:15:00',1.56),('3355','2013-09-05','10:20:00',1.59),('3355','2013-09-05','10:25:00',1.62),('3355','2013-09-05','10:30:00',1.66),('3355','2013-09-05','10:35:00',1.68),('3355','2013-09-05','10:40:00',1.71),('3355','2013-09-05','10:45:00',1.74),('3355','2013-09-05','10:50:00',1.76),('3355','2013-09-05','10:55:00',1.78),('3355','2013-09-05','11:00:00',1.81),('3355','2013-09-05','11:05:00',1.84),('3355','2013-09-05','11:10:00',1.86),('3355','2013-09-05','11:15:00',1.88),('3355','2013-09-05','11:20:00',1.9),('3355','2013-09-05','11:25:00',1.92),('3355','2013-09-05','11:30:00',1.93),('3355','2013-09-05','11:35:00',1.94),('3355','2013-09-05','11:40:00',1.94),('3355','2013-09-05','11:45:00',1.94),('3355','2013-09-05','11:50:00',2),('3355','2013-09-05','11:55:00',2.02),('3355','2013-09-05','12:00:00',2.02),('3355','2013-09-05','12:05:00',2.04),('3355','2013-09-05','12:10:00',2.05),('3355','2013-09-05','12:15:00',2.07),('3355','2013-09-05','12:20:00',2.08),('3355','2013-09-05','12:25:00',2.07),('3355','2013-09-05','12:30:00',2.07),('3355','2013-09-05','12:35:00',2.09),('3355','2013-09-05','12:40:00',2.09),('3355','2013-09-05','12:45:00',2.1),('3355','2013-09-05','12:50:00',2.1),('3355','2013-09-05','12:55:00',2.1),('3355','2013-09-05','13:00:00',2.11),('3355','2013-09-05','13:05:00',2.12),('3355','2013-09-05','13:10:00',2.12),('3355','2013-09-05','13:15:00',2.11),('3355','2013-09-05','13:20:00',2.11),('3355','2013-09-05','13:25:00',2.13),('3355','2013-09-05','13:30:00',2.13),('3355','2013-09-05','13:35:00',2.13),('3355','2013-09-05','13:40:00',2.13),('3355','2013-09-05','13:45:00',2.13),('3355','2013-09-05','13:50:00',2.12),('3355','2013-09-05','13:55:00',2.09),('3355','2013-09-05','14:00:00',2.08),('3355','2013-09-05','14:05:00',2.08),('3355','2013-09-05','14:10:00',2.07),('3355','2013-09-05','14:15:00',2.05),('3355','2013-09-05','14:20:00',2.05),('3355','2013-09-05','14:25:00',2.03),('3355','2013-09-05','14:30:00',2.02),('3355','2013-09-05','14:35:00',1.99),('3355','2013-09-05','14:40:00',1.96),('3355','2013-09-05','14:45:00',1.94),('3355','2013-09-05','14:50:00',1.95),('3355','2013-09-05','14:55:00',1.94),('3355','2013-09-05','15:00:00',1.95),('3355','2013-09-05','15:05:00',1.95),('3355','2013-09-05','15:10:00',1.93),('3355','2013-09-05','15:15:00',1.89),('3355','2013-09-05','15:20:00',1.87),('3355','2013-09-05','15:25:00',1.85),('3355','2013-09-05','15:30:00',1.82),('3355','2013-09-05','15:35:00',1.79),('3355','2013-09-05','15:40:00',1.77),('3355','2013-09-05','15:45:00',1.73),('3355','2013-09-05','15:50:00',1.71),('3355','2013-09-05','15:55:00',1.7),('3355','2013-09-05','16:00:00',1.68),('3355','2013-09-05','16:05:00',1.64),('3355','2013-09-05','16:10:00',1.62),('3355','2013-09-05','16:15:00',1.6),('3355','2013-09-05','16:20:00',1.57),('3355','2013-09-05','16:25:00',1.53),('3355','2013-09-05','16:30:00',1.51),('3355','2013-09-05','16:35:00',1.49),('3355','2013-09-05','16:40:00',1.48),('3355','2013-09-05','16:45:00',1.45),('3355','2013-09-05','16:50:00',1.26),('3355','2013-09-04','09:10:00',1.04),('3355','2013-09-04','09:15:00',1.09),('3355','2013-09-04','09:20:00',1.15),('3355','2013-09-04','09:25:00',1.19),('3355','2013-09-04','09:30:00',1.23),('3355','2013-09-04','09:35:00',1.28),('3355','2013-09-04','09:40:00',1.33),('3355','2013-09-04','09:45:00',1.38),('3355','2013-09-04','09:50:00',1.42),('3355','2013-09-04','09:55:00',1.46),('3355','2013-09-04','10:00:00',1.49),('3355','2013-09-04','10:05:00',1.53),('3355','2013-09-04','10:10:00',1.57),('3355','2013-09-04','10:15:00',1.6),('3355','2013-09-04','10:20:00',1.64),('3355','2013-09-04','10:25:00',1.66),('3355','2013-09-04','10:30:00',1.7),('3355','2013-09-04','10:35:00',1.73),('3355','2013-09-04','10:40:00',1.76),('3355','2013-09-04','10:45:00',1.78),('3355','2013-09-04','10:50:00',1.81),('3355','2013-09-04','10:55:00',1.85),('3355','2013-09-04','11:00:00',1.87),('3355','2013-09-04','11:05:00',1.91),('3355','2013-09-04','11:10:00',1.92),('3355','2013-09-04','11:15:00',1.94),('3355','2013-09-04','11:20:00',1.96),('3355','2013-09-04','11:25:00',1.98),('3355','2013-09-04','11:30:00',2),('3355','2013-09-04','11:35:00',2.02),('3355','2013-09-04','11:40:00',2.04),('3355','2013-09-04','11:45:00',2.06),('3355','2013-09-04','11:50:00',2.09),('3355','2013-09-04','11:55:00',2.11),('3355','2013-09-04','12:00:00',2.11),('3355','2013-09-04','12:05:00',2.11),('3355','2013-09-04','12:10:00',2.12),('3355','2013-09-04','12:15:00',2.13),('3355','2013-09-04','12:20:00',2.15),('3355','2013-09-04','12:25:00',2.15),('3355','2013-09-04','12:30:00',2.17),('3355','2013-09-04','12:35:00',2.19),('3355','2013-09-04','12:40:00',2.2),('3355','2013-09-04','12:45:00',2.2),('3355','2013-09-04','12:50:00',2.19),('3355','2013-09-04','12:55:00',2.21),('3355','2013-09-04','13:00:00',2.2),('3355','2013-09-04','13:05:00',2.21),('3355','2013-09-04','13:10:00',2.2),('3355','2013-09-04','13:15:00',2.19),('3355','2013-09-04','13:20:00',2.19),('3355','2013-09-04','13:25:00',2.2),('3355','2013-09-04','13:30:00',2.2),('3355','2013-09-04','13:35:00',2.2),('3355','2013-09-04','13:40:00',2.2),('3355','2013-09-04','13:45:00',2.19),('3355','2013-09-04','13:50:00',2.19),('3355','2013-09-04','13:55:00',2.17),('3355','2013-09-04','14:00:00',2.17),('3355','2013-09-04','14:05:00',2.17),('3355','2013-09-04','14:10:00',2.16),('3355','2013-09-04','14:15:00',2.15),('3355','2013-09-04','14:20:00',2.13),('3355','2013-09-04','14:25:00',2.13),('3355','2013-09-04','14:30:00',2.12),('3355','2013-09-04','14:35:00',2.1),('3355','2013-09-04','14:40:00',2.09),('3355','2013-09-04','14:45:00',2.07),('3355','2013-09-04','14:50:00',2.06),('3355','2013-09-04','14:55:00',2.04),('3355','2013-09-04','15:00:00',2.02),('3355','2013-09-04','15:05:00',2.01),('3355','2013-09-04','15:10:00',1.98),('3355','2013-09-04','15:15:00',1.97),('3355','2013-09-04','15:20:00',1.95),('3355','2013-09-04','15:25:00',1.92),('3355','2013-09-04','15:30:00',1.89),('3355','2013-09-04','15:35:00',1.85),('3355','2013-09-04','15:40:00',1.84),('3355','2013-09-04','15:45:00',1.82),('3355','2013-09-04','15:50:00',1.78),('3355','2013-09-04','15:55:00',1.74),('3355','2013-09-04','16:00:00',1.71),('3355','2013-09-04','16:05:00',1.67),('3355','2013-09-04','16:10:00',1.63),('3355','2013-09-04','16:15:00',1.61),('3355','2013-09-04','16:20:00',1.57),('3355','2013-09-04','16:25:00',1.55),('3355','2013-09-04','16:30:00',1.51),('3355','2013-09-04','16:35:00',1.47),('3355','2013-09-04','16:40:00',1.42),('3355','2013-09-04','16:45:00',1.39),('3355','2013-09-04','16:50:00',1.35),('3355','2013-09-04','16:55:00',1.31),('3355','2013-09-04','17:00:00',1.26),('3355','2013-09-04','17:05:00',1.22),('3355','2013-09-04','17:10:00',1.18),('3355','2013-09-04','17:15:00',1.13),('3355','2013-09-04','17:20:00',1.09),('3355','2013-09-04','17:25:00',1.04),('3355','2013-09-03','09:15:00',1.01),('3355','2013-09-03','09:20:00',1.06),('3355','2013-09-03','09:25:00',1.11),('3355','2013-09-03','09:30:00',1.15),('3355','2013-09-03','09:35:00',1.19),('3355','2013-09-03','09:40:00',1.23),('3355','2013-09-03','09:45:00',1.28),('3355','2013-09-03','09:50:00',1.32),('3355','2013-09-03','09:55:00',1.35),('3355','2013-09-03','10:00:00',1.38),('3355','2013-09-03','10:05:00',1.42),('3355','2013-09-03','10:10:00',1.45),('3355','2013-09-03','10:15:00',1.49),('3355','2013-09-03','10:20:00',1.53),('3355','2013-09-03','10:25:00',1.57),('3355','2013-09-03','10:30:00',1.6),('3355','2013-09-03','10:35:00',1.65),('3355','2013-09-03','10:40:00',1.7),('3355','2013-09-03','10:45:00',1.74),('3355','2013-09-03','10:50:00',1.75),('3355','2013-09-03','10:55:00',1.77),('3355','2013-09-03','11:00:00',1.79),('3355','2013-09-03','11:05:00',1.81),('3355','2013-09-03','11:10:00',1.84),('3355','2013-09-03','11:15:00',1.86),('3355','2013-09-03','11:20:00',1.88),('3355','2013-09-03','11:25:00',1.91),('3355','2013-09-03','11:30:00',1.92),('3355','2013-09-03','11:35:00',1.93),('3355','2013-09-03','11:40:00',1.95),('3355','2013-09-03','11:45:00',1.96),('3355','2013-09-03','11:50:00',1.98),('3355','2013-09-03','11:55:00',2.01),('3355','2013-09-03','12:00:00',2.02),('3355','2013-09-03','12:05:00',2.05),('3355','2013-09-03','12:10:00',2.07),('3355','2013-09-03','12:15:00',2.08),('3355','2013-09-03','12:20:00',2.09),('3355','2013-09-03','12:25:00',2.11),('3355','2013-09-03','12:30:00',2.12),('3355','2013-09-03','12:35:00',2.12),('3355','2013-09-03','12:40:00',2.13),('3355','2013-09-03','12:45:00',2.14),('3355','2013-09-03','12:50:00',2.13),('3355','2013-09-03','12:55:00',2.14),('3355','2013-09-03','13:00:00',2.15),('3355','2013-09-03','13:05:00',2.15),('3355','2013-09-03','13:10:00',2.14),('3355','2013-09-03','13:15:00',2.14),('3355','2013-09-03','13:20:00',2.14),('3355','2013-09-03','13:25:00',2.12),('3355','2013-09-03','13:30:00',2.14),('3355','2013-09-03','13:35:00',2.14),('3355','2013-09-03','13:40:00',2.11),('3355','2013-09-03','13:45:00',2.13),('3355','2013-09-03','13:50:00',2.13),('3355','2013-09-03','13:55:00',2.11),('3355','2013-09-03','14:00:00',2.07),('3355','2013-09-03','14:05:00',2.06),('3355','2013-09-03','14:10:00',2.06),('3355','2013-09-03','14:15:00',2.07),('3355','2013-09-03','14:20:00',2.06),('3355','2013-09-03','14:25:00',2.05),('3355','2013-09-03','14:30:00',2.04),('3355','2013-09-03','14:35:00',2.05),('3355','2013-09-03','14:40:00',2.04),('3355','2013-09-03','14:45:00',2.03),('3355','2013-09-03','14:50:00',2.02),('3355','2013-09-03','14:55:00',1.99),('3355','2013-09-03','15:00:00',1.97),('3355','2013-09-03','15:05:00',1.93),('3355','2013-09-03','15:10:00',1.93),('3355','2013-09-03','15:15:00',1.92),('3355','2013-09-03','15:20:00',1.88),('3355','2013-09-03','15:25:00',1.86),('3355','2013-09-03','15:30:00',1.82),('3355','2013-09-03','15:35:00',1.79),('3355','2013-09-03','15:40:00',1.77),('3355','2013-09-03','15:45:00',1.76),('3355','2013-09-03','15:50:00',1.74),('3355','2013-09-03','15:55:00',1.72),('3355','2013-09-03','16:00:00',1.69),('3355','2013-09-03','16:05:00',1.65),('3355','2013-09-03','16:10:00',1.61),('3355','2013-09-03','16:15:00',1.58),('3355','2013-09-03','16:20:00',1.55),('3355','2013-09-03','16:25:00',1.52),('3355','2013-09-03','16:30:00',1.49),('3355','2013-09-03','16:35:00',1.45),('3355','2013-09-03','16:40:00',1.41),('3355','2013-09-03','16:45:00',1.37),('3355','2013-09-03','16:50:00',1.34),('3355','2013-09-03','16:55:00',1.31),('3355','2013-09-03','17:00:00',1.26),('3355','2013-09-03','17:05:00',1.22),('3355','2013-09-03','17:10:00',1.17),('3355','2013-09-03','17:15:00',1.12),('3355','2013-09-03','17:20:00',1.09),('3355','2013-09-03','17:25:00',1.03),('3355','2013-09-02','09:15:00',1.04),('3355','2013-09-02','09:20:00',1.09),('3355','2013-09-02','09:25:00',1.14),('3355','2013-09-02','09:30:00',1.18),('3355','2013-09-02','09:35:00',1.23),('3355','2013-09-02','09:40:00',1.27),('3355','2013-09-02','09:45:00',1.3),('3355','2013-09-02','09:50:00',1.35),('3355','2013-09-02','09:55:00',1.38),('3355','2013-09-02','10:00:00',1.42),('3355','2013-09-02','10:05:00',1.46),('3355','2013-09-02','10:10:00',1.5),('3355','2013-09-02','10:15:00',1.54),('3355','2013-09-02','10:20:00',1.58),('3355','2013-09-02','10:25:00',1.6),('3355','2013-09-02','10:30:00',1.63),('3355','2013-09-02','10:35:00',1.66),('3355','2013-09-02','10:40:00',1.69),('3355','2013-09-02','10:45:00',1.72),('3355','2013-09-02','10:50:00',1.74),('3355','2013-09-02','10:55:00',1.78),('3355','2013-09-02','11:00:00',1.8),('3355','2013-09-02','11:05:00',1.83),('3355','2013-09-02','11:10:00',1.85),('3355','2013-09-02','11:15:00',1.87),('3355','2013-09-02','11:20:00',1.89),('3355','2013-09-02','11:25:00',1.92),('3355','2013-09-02','11:30:00',1.94),('3355','2013-09-02','11:35:00',1.96),('3355','2013-09-02','11:40:00',1.97),('3355','2013-09-02','11:45:00',1.98),('3355','2013-09-02','11:50:00',2.01),('3355','2013-09-02','11:55:00',2.01),('3355','2013-09-02','12:00:00',2.02),('3355','2013-09-02','12:05:00',2.04),('3355','2013-09-02','12:10:00',2.05),('3355','2013-09-02','12:15:00',2.07),('3355','2013-09-02','12:20:00',2.08),('3355','2013-09-02','12:25:00',2.07),('3355','2013-09-02','12:30:00',2.07),('3355','2013-09-02','12:35:00',2.08),('3355','2013-09-02','12:40:00',2.09),('3355','2013-09-02','12:45:00',2.08),('3355','2013-09-02','12:50:00',2.09),('3355','2013-09-02','12:55:00',2.09),('3355','2013-09-02','13:00:00',2.12),('3355','2013-09-02','13:05:00',2.12),('3355','2013-09-02','13:10:00',2.11),('3355','2013-09-02','13:15:00',2.13),('3355','2013-09-02','13:20:00',2.14),('3355','2013-09-02','13:25:00',2.13),('3355','2013-09-02','13:30:00',2.12),('3355','2013-09-02','13:35:00',2.1),('3355','2013-09-02','13:40:00',2.09),('3355','2013-09-02','13:45:00',1.91),('3355','2013-09-02','14:00:00',2.24),('3355','2013-09-02','14:05:00',2.15),('3355','2013-09-02','14:10:00',2.01),('3355','2013-09-02','14:15:00',2.09),('3355','2013-09-02','14:20:00',2.08),('3355','2013-09-02','14:25:00',2.07),('3355','2013-09-02','14:30:00',2.1),('3355','2013-09-02','14:35:00',2.06),('3355','2013-09-02','14:40:00',2.06),('3355','2013-09-02','14:45:00',2.08),('3355','2013-09-02','14:50:00',2.09),('3355','2013-09-02','14:55:00',2),('3355','2013-09-02','15:00:00',1.78),('3355','2013-09-02','15:05:00',1.78),('3355','2013-09-02','15:10:00',1.38),('3355','2013-09-02','15:15:00',1.97),('3355','2013-09-02','15:20:00',1.89),('3355','2013-09-02','15:25:00',1.51),('3355','2013-09-02','15:35:00',1.79),('3355','2013-09-02','15:40:00',1.85),('3355','2013-09-02','15:45:00',1.83),('3355','2013-09-02','15:50:00',1.79),('3355','2013-09-02','15:55:00',1.77),('3355','2013-09-02','16:00:00',1.71),('3355','2013-09-02','16:05:00',1.65),('3355','2013-09-02','16:10:00',1.63),('3355','2013-09-02','16:15:00',1.63),('3355','2013-09-02','16:20:00',1.61),('3355','2013-09-02','16:25:00',1.56),('3355','2013-09-02','16:30:00',1.51),('3355','2013-09-02','16:35:00',1.44),('3355','2013-09-02','16:40:00',1.38),('3355','2013-09-02','16:45:00',1.34),('3355','2013-09-02','16:50:00',1.3),('3355','2013-09-02','16:55:00',1.23),('3355','2013-09-02','17:00:00',1.18),('3355','2013-09-02','17:05:00',1.16),('3355','2013-09-02','17:10:00',1.11),('3355','2013-09-02','17:15:00',1.08),('3355','2013-09-02','17:20:00',1.02),('3355','2013-09-01','09:10:00',1.02),('3355','2013-09-01','09:15:00',1.07),('3355','2013-09-01','09:20:00',1.11),('3355','2013-09-01','09:25:00',1.16),('3355','2013-09-01','09:30:00',1.21),('3355','2013-09-01','09:35:00',1.25),('3355','2013-09-01','09:40:00',1.29),('3355','2013-09-01','09:45:00',1.33),('3355','2013-09-01','09:50:00',1.37),('3355','2013-09-01','09:55:00',1.4),('3355','2013-09-01','10:00:00',1.44),('3355','2013-09-01','10:05:00',1.47),('3355','2013-09-01','10:10:00',1.51),('3355','2013-09-01','10:15:00',1.54),('3355','2013-09-01','10:20:00',1.58),('3355','2013-09-01','10:25:00',1.61),('3355','2013-09-01','10:30:00',1.64),('3355','2013-09-01','10:35:00',1.67),('3355','2013-09-01','10:40:00',1.7),('3355','2013-09-01','10:45:00',1.73),('3355','2013-09-01','10:50:00',1.74),('3355','2013-09-01','10:55:00',1.77),('3355','2013-09-01','11:00:00',1.81),('3355','2013-09-01','11:05:00',1.85),('3355','2013-09-01','11:10:00',1.86),('3355','2013-09-01','11:15:00',1.87),('3355','2013-09-01','11:20:00',1.89),('3355','2013-09-01','11:25:00',1.91),('3355','2013-09-01','11:30:00',1.93),('3355','2013-09-01','11:35:00',1.97),('3355','2013-09-01','11:40:00',1.99),('3355','2013-09-01','11:45:00',2.01),('3355','2013-09-01','11:50:00',2.02),('3355','2013-09-01','11:55:00',2.04),('3355','2013-09-01','12:00:00',2.04),('3355','2013-09-01','12:05:00',1.97),('3355','2013-09-01','12:10:00',2.05),('3355','2013-09-01','12:15:00',2.06),('3355','2013-09-01','12:20:00',2.09),('3355','2013-09-01','12:25:00',2.04),('3355','2013-09-01','12:30:00',2.09),('3355','2013-09-01','12:35:00',2.1),('3355','2013-09-01','12:40:00',2.11),('3355','2013-09-01','12:45:00',2.1),('3355','2013-09-01','12:50:00',2.11),('3355','2013-09-01','12:55:00',2.11),('3355','2013-09-01','13:00:00',2.14),('3355','2013-09-01','13:05:00',2.14),('3355','2013-09-01','13:10:00',2.15),('3355','2013-09-01','13:15:00',1.85),('3355','2013-09-01','13:20:00',2.17),('3355','2013-09-01','13:25:00',2.18),('3355','2013-09-01','13:30:00',2.17),('3355','2013-09-01','13:35:00',2.16),('3355','2013-09-01','13:40:00',2.15),('3355','2013-09-01','13:45:00',2.14),('3355','2013-09-01','13:50:00',1.88),('3355','2013-09-01','13:55:00',1.9),('3355','2013-09-01','14:00:00',1.72),('3355','2013-09-01','14:05:00',1.64),('3355','2013-09-01','14:10:00',1.93),('3355','2013-09-01','14:15:00',1.98),('3355','2013-09-01','14:20:00',1.87),('3355','2013-09-01','14:25:00',1.8),('3355','2013-09-01','14:30:00',1.87),('3355','2013-09-01','14:35:00',1.82),('3355','2013-09-01','14:40:00',1.84),('3355','2013-09-01','14:45:00',1.87),('3355','2013-09-01','14:50:00',1.89),('3355','2013-09-01','14:55:00',1.83),('3355','2013-09-01','15:00:00',1.83),('3355','2013-09-01','15:05:00',1.82),('3355','2013-09-01','15:10:00',1.76),('3355','2013-09-01','15:15:00',1.7),('3355','2013-09-01','15:20:00',1.63),('3355','2013-09-01','15:25:00',1.48),('3355','2013-09-01','15:30:00',1.18),('3355','2013-09-01','15:35:00',1.36),('3355','2013-09-01','15:40:00',1.58),('3355','2013-09-01','15:45:00',1.35),('3355','2013-09-01','15:50:00',1.02),('3355','2013-09-01','15:55:00',1.3),('3355','2013-09-01','16:00:00',1.39),('3355','2013-09-01','16:05:00',1.54),('3355','2013-09-01','16:10:00',1.65),('3355','2013-09-01','16:15:00',1.54),('3355','2013-09-01','16:20:00',1.48),('3355','2013-09-01','16:25:00',1.4),('3355','2013-09-01','16:30:00',1.58),('3355','2013-09-01','16:35:00',1.48),('3355','2013-09-01','16:40:00',1.45),('3355','2013-09-01','16:45:00',1.38),('3355','2013-09-01','16:50:00',1.28),('3355','2013-09-01','16:55:00',1.19),('3355','2013-08-31','09:00:00',1.05),('3355','2013-08-31','09:20:00',1.11),('3355','2013-08-31','09:25:00',1.23),('3355','2013-08-31','09:30:00',1.27),('3355','2013-08-31','09:35:00',1.33),('3355','2013-08-31','09:40:00',1.37),('3355','2013-08-31','09:45:00',1.3),('3355','2013-08-31','09:50:00',1.32),('3355','2013-08-31','09:55:00',1.41),('3355','2013-08-31','10:00:00',1.51),('3355','2013-08-31','10:05:00',1.51),('3355','2013-08-31','10:10:00',1.59),('3355','2013-08-31','10:15:00',1.59),('3355','2013-08-31','10:20:00',1.62),('3355','2013-08-31','10:25:00',1.64),('3355','2013-08-31','10:30:00',1.69),('3355','2013-08-31','10:35:00',1.75),('3355','2013-08-31','10:40:00',1.76),('3355','2013-08-31','10:45:00',1.79),('3355','2013-08-31','10:50:00',1.85),('3355','2013-08-31','10:55:00',1.87),('3355','2013-08-31','11:00:00',1.91),('3355','2013-08-31','11:05:00',1.93),('3355','2013-08-31','11:10:00',1.95),('3355','2013-08-31','11:15:00',1.98),('3355','2013-08-31','11:20:00',2),('3355','2013-08-31','11:25:00',2.02),('3355','2013-08-31','11:30:00',2.03),('3355','2013-08-31','11:35:00',2.06),('3355','2013-08-31','11:40:00',2.09),('3355','2013-08-31','11:45:00',2.12),('3355','2013-08-31','11:50:00',2.13),('3355','2013-08-31','11:55:00',2.13),('3355','2013-08-31','12:00:00',1.81),('3355','2013-08-31','12:05:00',1.46),('3355','2013-08-31','12:10:00',1.82),('3355','2013-08-31','12:15:00',2.14),('3355','2013-08-31','12:20:00',2.14),('3355','2013-08-31','12:25:00',2.12),('3355','2013-08-31','12:30:00',2.15),('3355','2013-08-31','12:35:00',2.14),('3355','2013-08-31','12:40:00',2.17),('3355','2013-08-31','12:45:00',2.15),('3355','2013-08-31','12:50:00',2.15),('3355','2013-08-31','12:55:00',2.17),('3355','2013-08-31','13:00:00',2.18),('3355','2013-08-31','13:05:00',2.2),('3355','2013-08-31','13:10:00',2.18),('3355','2013-08-31','13:15:00',2.18),('3355','2013-08-31','13:20:00',2.19),('3355','2013-08-31','13:25:00',2.18),('3355','2013-08-31','13:30:00',2.18),('3355','2013-08-31','13:35:00',2.17),('3355','2013-08-31','13:40:00',2.15),('3355','2013-08-31','13:45:00',2.15),('3355','2013-08-31','13:50:00',2.15),('3355','2013-08-31','13:55:00',2.13),('3355','2013-08-31','14:00:00',2.15),('3355','2013-08-31','14:05:00',2.14),('3355','2013-08-31','14:10:00',2.12),('3355','2013-08-31','14:15:00',2.1),('3355','2013-08-31','14:20:00',2.08),('3355','2013-08-31','14:25:00',2.06),('3355','2013-08-31','14:30:00',2.05),('3355','2013-08-31','14:35:00',1.97),('3355','2013-08-31','14:40:00',1.98),('3355','2013-08-31','14:45:00',1.98),('3355','2013-08-31','14:50:00',1.99),('3355','2013-08-31','14:55:00',1.94),('3355','2013-08-31','15:00:00',1.93),('3355','2013-08-31','15:05:00',1.94),('3355','2013-08-31','15:10:00',1.92),('3355','2013-08-31','15:15:00',1.89),('3355','2013-08-31','15:20:00',1.85),('3355','2013-08-31','15:25:00',1.82),('3355','2013-08-31','15:30:00',1.81),('3355','2013-08-31','15:35:00',1.77),('3355','2013-08-31','15:40:00',1.78),('3355','2013-08-31','15:45:00',1.75),('3355','2013-08-31','15:50:00',1.71),('3355','2013-08-31','15:55:00',1.68),('3355','2013-08-31','16:00:00',1.65),('3355','2013-08-31','16:05:00',1.62),('3355','2013-08-31','16:10:00',1.61),('3355','2013-08-31','16:15:00',1.58),('3355','2013-08-31','16:20:00',1.54),('3355','2013-08-31','16:25:00',1.51),('3355','2013-08-31','16:30:00',1.44),('3355','2013-08-31','16:35:00',1.45),('3355','2013-08-31','16:40:00',1.41),('3355','2013-08-31','16:45:00',1.34),('3355','2013-08-31','16:50:00',1.3),('3355','2013-08-31','16:55:00',1.27),('3355','2013-08-31','17:00:00',1.21),('3355','2013-08-31','17:05:00',1.21),('3355','2013-08-31','17:10:00',1.18),('3355','2013-08-31','17:15:00',1.13),('3355','2013-08-31','17:20:00',1.06),('3355','2013-08-31','17:25:00',1.01),('3355','2013-08-30','10:00:00',1.01),('3355','2013-08-30','10:05:00',1.02),('3355','2013-08-30','10:10:00',1.01),('3355','2013-08-30','10:15:00',1.06),('3355','2013-08-30','10:20:00',1.14),('3355','2013-08-30','10:25:00',1.05),('3355','2013-08-30','10:30:00',1.17),('3355','2013-08-30','10:35:00',1.12),('3355','2013-08-30','10:40:00',1.06),('3355','2013-08-30','10:45:00',1.03),('3355','2013-08-30','10:50:00',1.09),('3355','2013-08-30','10:55:00',1.04),('3355','2013-08-30','11:00:00',1.09),('3355','2013-08-30','11:05:00',1.17),('3355','2013-08-30','11:10:00',1.22),('3355','2013-08-30','11:15:00',1.25),('3355','2013-08-30','11:20:00',1.24),('3355','2013-08-30','11:25:00',1.28),('3355','2013-08-30','11:30:00',1.37),('3355','2013-08-30','11:35:00',1.31),('3355','2013-08-30','11:40:00',1.42),('3355','2013-08-30','11:45:00',1.38),('3355','2013-08-30','11:50:00',1.62),('3355','2013-08-30','11:55:00',1.43),('3355','2013-08-30','12:00:00',1.29),('3355','2013-08-30','12:05:00',1.09),('3355','2013-08-30','12:10:00',1.18),('3355','2013-08-30','12:15:00',1.3),('3355','2013-08-30','12:20:00',1.41),('3355','2013-08-30','12:25:00',1.6),('3355','2013-08-30','12:30:00',1.76),('3355','2013-08-30','12:35:00',1.7),('3355','2013-08-30','12:40:00',1.64),('3355','2013-08-30','12:45:00',1.71),('3355','2013-08-30','12:50:00',1.69),('3355','2013-08-30','12:55:00',1.58),('3355','2013-08-30','13:00:00',1.53),('3355','2013-08-30','13:05:00',1.52),('3355','2013-08-30','13:10:00',1.54),('3355','2013-08-30','13:15:00',1.48),('3355','2013-08-30','13:20:00',1.72),('3355','2013-08-30','13:25:00',2),('3355','2013-08-30','13:30:00',2.15),('3355','2013-08-30','13:35:00',2),('3355','2013-08-30','13:40:00',2.14),('3355','2013-08-30','13:45:00',1.93),('3355','2013-08-30','13:50:00',1.94),('3355','2013-08-30','13:55:00',2.11),('3355','2013-08-30','14:00:00',2.18),('3355','2013-08-30','14:05:00',2.11),('3355','2013-08-30','14:10:00',2.13),('3355','2013-08-30','14:15:00',2.14),('3355','2013-08-30','14:20:00',2.09),('3355','2013-08-30','14:25:00',2.14),('3355','2013-08-30','14:30:00',2.1),('3355','2013-08-30','14:35:00',2.13),('3355','2013-08-30','14:40:00',2.07),('3355','2013-08-30','14:45:00',1.68),('3355','2013-08-30','14:50:00',1.37),('3355','2013-08-30','14:55:00',1.6),('3355','2013-08-30','15:00:00',1.4),('3355','2013-08-30','15:05:00',1.27),('3355','2013-08-30','15:10:00',1.28),('3355','2013-08-30','15:15:00',1.57),('3355','2013-08-30','15:20:00',1.37),('3355','2013-08-30','15:25:00',1.21),('3355','2013-08-30','15:30:00',1.17),('3355','2013-08-30','15:40:00',1.01),('3355','2013-08-30','15:45:00',1.2),('3355','2013-08-30','15:50:00',1.31),('3355','2013-08-30','15:55:00',1.32),('3355','2013-08-30','16:00:00',1.24),('3355','2013-08-30','16:05:00',1.09),('3355','2013-08-30','16:40:00',1.38),('3355','2013-08-30','16:45:00',1.42),('3355','2013-08-30','16:50:00',1.33),('3355','2014-04-11','09:00:00',1.01),('3355','2014-04-11','09:05:00',1.05),('3355','2014-04-11','09:10:00',1.08),('3355','2014-04-11','09:15:00',1.13),('3355','2014-04-11','09:20:00',1.17),('3355','2014-04-11','09:25:00',1.23),('3355','2014-04-11','09:30:00',1.28),('3355','2014-04-11','09:35:00',1.32),('3355','2014-04-11','09:40:00',1.37),('3355','2014-04-11','09:45:00',1.41),('3355','2014-04-11','09:50:00',1.45),('3355','2014-04-11','09:55:00',1.48),('3355','2014-04-11','10:00:00',1.53),('3355','2014-04-11','10:05:00',1.58),('3355','2014-04-11','10:10:00',1.64),('3355','2014-04-11','10:15:00',1.69),('3355','2014-04-11','10:20:00',1.71),('3355','2014-04-11','10:25:00',1.75),('3355','2014-04-11','10:30:00',1.78),('3355','2014-04-11','10:35:00',1.81),('3355','2014-04-11','10:40:00',1.82),('3355','2014-04-11','10:45:00',1.88),('3355','2014-04-11','10:50:00',1.93),('3355','2014-04-11','10:55:00',1.97),('3355','2014-04-11','11:00:00',2.01),('3355','2014-04-11','11:05:00',2.03),('3355','2014-04-11','11:10:00',2.06),('3355','2014-04-11','11:15:00',2.07),('3355','2014-04-11','11:20:00',2.06),('3355','2014-04-11','11:25:00',2.1),('3355','2014-04-11','11:30:00',2.12),('3355','2014-04-11','11:35:00',2.13),('3355','2014-04-11','11:40:00',2.13),('3355','2014-04-11','11:45:00',2.22),('3355','2014-04-11','11:50:00',2.24),('3355','2014-04-11','11:55:00',2.3),('3355','2014-04-11','12:00:00',2.37),('3355','2014-04-11','12:05:00',2.28),('3355','2014-04-11','12:10:00',2.41),('3355','2014-04-11','12:15:00',2.38),('3355','2014-04-11','12:20:00',2.27),('3355','2014-04-11','12:25:00',1.61),('3355','2014-04-11','12:30:00',2.4),('3355','2014-04-11','12:35:00',2.42),('3355','2014-04-11','12:40:00',2.48),('3355','2014-04-11','12:45:00',2.57),('3355','2014-04-11','12:50:00',2.25),('3355','2014-04-11','12:55:00',2.46),('3355','2014-04-11','13:00:00',2.46),('3355','2014-04-11','13:05:00',1.56),('3355','2014-04-11','13:10:00',2.4),('3355','2014-04-11','13:15:00',2.05),('3355','2014-04-11','13:20:00',1.26),('3355','2014-04-11','13:25:00',2.09),('3355','2014-04-11','13:30:00',2.22),('3355','2014-04-11','13:35:00',1.31),('3355','2014-04-11','13:40:00',1.97),('3355','2014-04-11','13:45:00',1.65),('3355','2014-04-11','13:50:00',2.3),('3355','2014-04-11','13:55:00',1.85),('3355','2014-04-11','14:00:00',2.11),('3355','2014-04-11','14:05:00',1.78),('3355','2014-04-11','14:10:00',1.67),('3355','2014-04-11','14:15:00',1.6),('3355','2014-04-11','14:20:00',1),('3355','2014-04-11','14:25:00',1.58),('3355','2014-04-11','14:30:00',2.42),('3355','2014-04-11','14:35:00',2.58),('3355','2014-04-11','14:40:00',2.54),('3355','2014-04-11','14:45:00',2.15),('3355','2014-04-11','14:50:00',2.17),('3355','2014-04-11','14:55:00',1.49),('3355','2014-04-11','15:00:00',1.25),('3355','2014-04-11','15:05:00',1.38),('3355','2014-04-11','15:10:00',1.91),('3355','2014-04-11','15:15:00',2.24),('3355','2014-04-11','15:20:00',2.05),('3355','2014-04-11','15:25:00',1.88),('3355','2014-04-11','15:30:00',2.11),('3355','2014-04-11','15:35:00',2.09),('3355','2014-04-11','15:40:00',2.04),('3355','2014-04-11','15:45:00',1.99),('3355','2014-04-11','15:50:00',1.96),('3355','2014-04-11','15:55:00',1.69),('3355','2014-04-11','16:00:00',1.91),('3355','2014-04-11','16:05:00',1.86),('3355','2014-04-11','16:10:00',1.83),('3355','2014-04-11','16:15:00',1.77),('3355','2014-04-11','16:20:00',1.72),('3355','2014-04-11','16:25:00',1.7),('3355','2014-04-11','16:30:00',1.67),('3355','2014-04-11','16:35:00',1.58),('3355','2014-04-11','16:40:00',1.43),('3355','2014-04-11','16:45:00',1.56),('3355','2014-04-11','16:50:00',1.55),('3355','2014-04-11','17:00:00',1.45),('3355','2014-04-11','17:10:00',1.34),('3355','2014-04-11','17:25:00',1.17),('3355','2014-04-11','17:30:00',1.17),('3355','2014-04-11','17:35:00',1.14),('3355','2014-04-11','17:40:00',1.08),('3355','2013-08-29','11:10:00',1.16),('3355','2013-08-29','11:15:00',1.48),('3355','2013-08-29','11:20:00',1.36),('3355','2013-08-29','11:50:00',1.03),('3355','2013-08-29','12:05:00',1.14),('3355','2013-08-29','12:10:00',1.35),('3355','2013-08-29','12:15:00',1.68),('3355','2013-08-29','12:20:00',1.41),('3355','2013-08-29','12:25:00',1.47),('3355','2013-08-29','12:30:00',1.47),('3355','2013-08-29','12:35:00',1.81),('3355','2013-08-29','12:40:00',2.39),('3355','2013-08-29','12:45:00',2.45),('3355','2013-08-29','12:50:00',1.56),('3355','2013-08-29','12:55:00',2.07),('3355','2013-08-29','13:00:00',1.55),('3355','2013-08-29','13:05:00',1.34),('3355','2013-08-29','13:10:00',1.34),('3355','2013-08-29','13:15:00',1.3),('3355','2013-08-29','13:20:00',1.28),('3355','2013-08-29','13:25:00',1.1),('3355','2013-08-29','14:00:00',1.26),('3355','2013-08-29','15:30:00',1.2),('3355','2013-08-29','15:35:00',1.39),('3355','2013-08-29','15:40:00',1.17),('3355','2013-08-29','15:45:00',1.41),('3355','2013-08-29','15:50:00',1.67),('3355','2013-08-29','15:55:00',1.7),('3355','2013-08-29','16:00:00',1.96),('3355','2013-08-29','16:05:00',1.88),('3355','2013-08-29','16:10:00',1.89),('3355','2013-08-29','16:15:00',1.76),('3355','2013-08-29','16:20:00',1.68),('3355','2013-08-29','16:25:00',1.62),('3355','2013-08-29','16:30:00',1.57),('3355','2013-08-29','16:35:00',1.54),('3355','2013-08-29','16:40:00',1.5),('3355','2013-08-29','16:45:00',1.46),('3355','2013-08-29','16:50:00',1.42),('3355','2013-08-29','16:55:00',1.37),('3355','2013-08-29','17:00:00',1.34),('3355','2013-08-29','17:05:00',1.29),('3355','2013-08-29','17:10:00',1.25),('3355','2013-08-29','17:15:00',1.2),('3355','2013-08-29','17:20:00',1.15),('3355','2013-08-29','17:25:00',1.1),('3355','2013-08-29','17:30:00',1.05),('3355','2013-08-29','17:35:00',1),('3355','2013-08-28','09:35:00',1.1),('3355','2013-08-28','09:40:00',1.26),('3355','2013-08-28','09:45:00',1.38),('3355','2013-08-28','09:50:00',1.42),('3355','2013-08-28','09:55:00',1.43),('3355','2013-08-28','10:00:00',1.45),('3355','2013-08-28','10:05:00',1.5),('3355','2013-08-28','10:10:00',1.58),('3355','2013-08-28','10:15:00',1.29),('3355','2013-08-28','10:20:00',1.74),('3355','2013-08-28','10:25:00',1.65),('3355','2013-08-28','10:40:00',1.2),('3355','2013-08-28','10:45:00',1.05),('3355','2013-08-28','10:50:00',1.89),('3355','2013-08-28','10:55:00',1.96),('3355','2013-08-28','11:00:00',1.41),('3355','2013-08-28','11:05:00',1.03),('3355','2013-08-28','11:10:00',1.97),('3355','2013-08-28','11:15:00',1.23),('3355','2013-08-28','11:20:00',2.15),('3355','2013-08-28','11:25:00',2.08),('3355','2013-08-28','11:30:00',2.11),('3355','2013-08-28','11:35:00',2.13),('3355','2013-08-28','11:40:00',2.22),('3355','2013-08-28','11:45:00',2.13),('3355','2013-08-28','11:50:00',1.29),('3355','2013-08-28','11:55:00',1.89),('3355','2013-08-28','12:05:00',2.22),('3355','2013-08-28','12:10:00',2.32),('3355','2013-08-28','12:15:00',1.13),('3355','2013-08-28','12:20:00',2.31),('3355','2013-08-28','12:25:00',2.28),('3355','2013-08-28','12:30:00',2.26),('3355','2013-08-28','12:35:00',2.24),('3355','2013-08-28','12:40:00',2.26),('3355','2013-08-28','12:45:00',2.34),('3355','2013-08-28','12:50:00',2.31),('3355','2013-08-28','12:55:00',2.3),('3355','2013-08-28','13:00:00',2.32),('3355','2013-08-28','13:05:00',2.17),('3355','2013-08-28','13:10:00',2.36),('3355','2013-08-28','13:15:00',2.37),('3355','2013-08-28','13:20:00',2.32),('3355','2013-08-28','13:25:00',2.32),('3355','2013-08-28','13:30:00',2.28),('3355','2013-08-28','13:35:00',2.31),('3355','2013-08-28','13:40:00',2.35),('3355','2013-08-28','13:45:00',2.34),('3355','2013-08-28','13:50:00',2.34),('3355','2013-08-28','13:55:00',2.17),('3355','2013-08-28','14:00:00',2.04),('3355','2013-08-28','14:05:00',2.29),('3355','2013-08-28','14:10:00',1.96),('3355','2013-08-28','14:15:00',2.32),('3355','2013-08-28','14:20:00',2.26),('3355','2013-08-28','14:25:00',2.2),('3355','2013-08-28','14:30:00',2),('3355','2013-08-28','14:35:00',1.86),('3355','2013-08-28','14:40:00',2.32),('3355','2013-08-28','14:45:00',2.22),('3355','2013-08-28','14:50:00',2.19),('3355','2013-08-28','14:55:00',2.17),('3355','2013-08-28','15:00:00',2.15),('3355','2013-08-28','15:05:00',1.95),('3355','2013-08-28','15:10:00',1.93),('3355','2013-08-28','15:15:00',2.15),('3355','2013-08-28','15:20:00',2.11),('3355','2013-08-28','15:25:00',2.07),('3355','2013-08-28','15:30:00',1.34),('3355','2013-08-28','15:35:00',2.14),('3355','2013-08-28','15:40:00',1.44),('3355','2013-08-28','15:55:00',1.02),('3355','2013-08-28','16:00:00',1.97),('3355','2013-08-28','16:05:00',1.76),('3355','2013-08-28','16:10:00',1.76),('3355','2013-08-28','16:15:00',1.58),('3355','2013-08-28','16:25:00',1.85),('3355','2013-08-28','16:30:00',1.7),('3355','2013-08-28','16:35:00',1.66),('3355','2013-08-28','16:40:00',1.62),('3355','2013-08-28','16:45:00',1.55),('3355','2013-08-28','16:50:00',1.47),('3355','2013-08-28','16:55:00',1.26),('3355','2013-08-28','17:00:00',1.41),('3355','2013-08-28','17:05:00',1.33),('3355','2013-08-28','17:10:00',1.13),('3355','2013-08-28','17:15:00',1.11),('3355','2013-08-27','09:25:00',1.01),('3355','2013-08-27','09:30:00',1.13),('3355','2013-08-27','10:05:00',1.21),('3355','2013-08-27','10:10:00',1.48),('3355','2013-08-27','10:15:00',1.54),('3355','2013-08-27','10:20:00',1.6),('3355','2013-08-27','10:25:00',1.6),('3355','2013-08-27','10:30:00',1.64),('3355','2013-08-27','10:35:00',1.67),('3355','2013-08-27','10:40:00',1.64),('3355','2013-08-27','10:45:00',1.72),('3355','2013-08-27','10:50:00',1.71),('3355','2013-08-27','10:55:00',1.79),('3355','2013-08-27','11:00:00',1.78),('3355','2013-08-27','11:05:00',1.82),('3355','2013-08-27','11:10:00',1.85),('3355','2013-08-27','11:15:00',1.84),('3355','2013-08-27','11:20:00',1.83),('3355','2013-08-27','11:25:00',1.81),('3355','2013-08-27','11:30:00',1.87),('3355','2013-08-27','11:35:00',1.93),('3355','2013-08-27','11:40:00',1.81),('3355','2013-08-27','11:45:00',2.25),('3355','2013-08-27','11:50:00',1.74),('3355','2013-08-27','11:55:00',1.99),('3355','2013-08-27','12:00:00',2.16),('3355','2013-08-27','12:05:00',2.02),('3355','2013-08-27','12:10:00',1.82),('3355','2013-08-27','12:15:00',1.84),('3355','2013-08-27','12:20:00',2.06),('3355','2013-08-27','12:25:00',1.54),('3355','2013-08-27','12:30:00',1.87),('3355','2013-08-27','12:35:00',1.48),('3355','2013-08-27','12:40:00',2.3),('3355','2013-08-27','12:45:00',1.73),('3355','2013-08-27','12:50:00',1.29),('3355','2013-08-27','12:55:00',1.24),('3355','2013-08-27','13:10:00',1.38),('3355','2013-08-27','13:15:00',1.36),('3355','2013-08-27','13:20:00',1.12),('3355','2013-08-27','13:30:00',1.24),('3355','2013-08-27','13:35:00',1.01),('3355','2013-08-27','13:40:00',1.18),('3355','2013-08-27','13:45:00',1.43),('3355','2013-08-27','13:50:00',2.23),('3355','2013-08-27','13:55:00',1.77),('3355','2013-08-27','14:00:00',2.37),('3355','2013-08-27','14:05:00',1.64),('3355','2013-08-27','14:15:00',1.38),('3355','2013-08-27','14:20:00',1.41),('3355','2013-08-27','16:10:00',1.61),('3355','2013-08-27','16:15:00',1.78),('3355','2013-08-27','16:20:00',1.06),('3355','2013-08-27','17:10:00',1.42),('3355','2013-08-26','09:10:00',1.02),('3355','2013-08-26','09:15:00',1.06),('3355','2013-08-26','09:20:00',1.11),('3355','2013-08-26','09:25:00',1.13),('3355','2013-08-26','09:30:00',1.19),('3355','2013-08-26','09:35:00',1.23),('3355','2013-08-26','09:40:00',1.29),('3355','2013-08-26','09:45:00',1.33),('3355','2013-08-26','09:50:00',1.36),('3355','2013-08-26','09:55:00',1.41),('3355','2013-08-26','10:00:00',1.44),('3355','2013-08-26','10:05:00',1.47),('3355','2013-08-26','10:10:00',1.51),('3355','2013-08-26','10:15:00',1.54),('3355','2013-08-26','10:20:00',1.57),('3355','2013-08-26','10:25:00',1.61),('3355','2013-08-26','10:30:00',1.66),('3355','2013-08-26','10:35:00',1.67),('3355','2013-08-26','10:40:00',1.69),('3355','2013-08-26','10:45:00',1.74),('3355','2013-08-26','10:50:00',1.76),('3355','2013-08-26','10:55:00',1.81),('3355','2013-08-26','11:00:00',1.83),('3355','2013-08-26','11:05:00',1.85),('3355','2013-08-26','11:10:00',1.86),('3355','2013-08-26','11:15:00',1.89),('3355','2013-08-26','11:20:00',1.91),('3355','2013-08-26','11:25:00',1.91),('3355','2013-08-26','11:30:00',1.93),('3355','2013-08-26','11:35:00',1.99),('3355','2013-08-26','11:40:00',1.99),('3355','2013-08-26','11:45:00',1.99),('3355','2013-08-26','11:50:00',2.01),('3355','2013-08-26','11:55:00',2.04),('3355','2013-08-26','12:00:00',2.04),('3355','2013-08-26','12:05:00',2.05),('3355','2013-08-26','12:10:00',2.07),('3355','2013-08-26','12:15:00',2.08),('3355','2013-08-26','12:20:00',2.07),('3355','2013-08-26','12:25:00',2.08),('3355','2013-08-26','12:30:00',2.07),('3355','2013-08-26','12:35:00',2.08),('3355','2013-08-26','12:40:00',2.11),('3355','2013-08-26','12:45:00',2.14),('3355','2013-08-26','12:50:00',2.15),('3355','2013-08-26','12:55:00',2.15),('3355','2013-08-26','13:00:00',2.23),('3355','2013-08-26','13:05:00',2.37),('3355','2013-08-26','13:10:00',2.29),('3355','2013-08-26','13:15:00',1.19),('3355','2013-08-26','13:20:00',1.3),('3355','2013-08-26','13:25:00',1.6),('3355','2013-08-26','13:30:00',1.52),('3355','2013-08-26','13:35:00',2.19),('3355','2013-08-26','13:40:00',2.18),('3355','2013-08-26','13:45:00',2.19),('3355','2013-08-26','13:50:00',2.23),('3355','2013-08-26','13:55:00',1.72),('3355','2013-08-26','14:00:00',1.41),('3355','2013-08-26','14:05:00',1.92),('3355','2013-08-26','14:10:00',1.36),('3355','2013-08-26','14:15:00',2.08),('3355','2013-08-26','14:20:00',2.11),('3355','2013-08-26','14:25:00',2.08),('3355','2013-08-26','14:30:00',2.11),('3355','2013-08-26','14:35:00',2.01),('3355','2013-08-26','14:40:00',1.82),('3355','2013-08-26','14:45:00',1.43),('3355','2013-08-26','14:50:00',1.23),('3355','2013-08-26','14:55:00',1.1),('3355','2013-08-26','15:00:00',1.05),('3355','2013-08-26','16:00:00',1.36),('3355','2013-08-26','16:05:00',1.86),('3355','2013-08-26','16:10:00',1.68),('3355','2013-08-26','16:15:00',1.58),('3355','2013-08-26','16:20:00',1.56),('3355','2013-08-26','16:25:00',1.51),('3355','2013-08-26','16:30:00',1.47),('3355','2013-08-26','16:35:00',1.44),('3355','2013-08-26','16:40:00',1.41),('3355','2013-08-26','16:45:00',1.4),('3355','2013-08-26','16:50:00',1.3),('3355','2013-08-26','16:55:00',1.26),('3355','2013-08-26','17:00:00',1.25),('3355','2013-08-26','17:05:00',1.12),('3355','2013-08-26','17:10:00',1.15),('3355','2013-08-26','17:15:00',1.11),('3355','2013-08-25','09:20:00',1.01),('3355','2013-08-25','09:25:00',1.06),('3355','2013-08-25','09:35:00',1.16),('3355','2013-08-25','09:40:00',1.54),('3355','2013-08-25','09:45:00',1.62),('3355','2013-08-25','09:50:00',1.51),('3355','2013-08-25','09:55:00',1.62),('3355','2013-08-25','10:00:00',1.29),('3355','2013-08-25','15:30:00',1.16),('3355','2013-08-25','15:35:00',1.74),('3355','2013-08-25','15:40:00',1.92),('3355','2013-08-25','15:45:00',2.15),('3355','2013-08-25','15:50:00',1.62),('3355','2013-08-25','15:55:00',1.38),('3355','2013-08-25','16:00:00',1.94),('3355','2013-08-25','16:05:00',1.86),('3355','2013-08-25','16:10:00',1.78),('3355','2013-08-25','16:15:00',1.73),('3355','2013-08-25','16:20:00',1.67),('3355','2013-08-25','16:25:00',1.64),('3355','2013-08-25','16:30:00',1.61),('3355','2013-08-25','16:35:00',1.33),('3355','2013-08-25','16:40:00',1.19),('3355','2013-08-25','16:50:00',1.1),('3355','2013-08-25','16:55:00',1.58),('3355','2013-08-25','17:00:00',1.45),('3355','2013-08-25','17:05:00',1.36),('3355','2013-08-25','17:10:00',1.3),('3355','2013-08-25','17:15:00',1.2),('3355','2013-08-25','17:20:00',1.14),('3355','2013-08-25','17:25:00',1.09),('3355','2013-08-25','17:30:00',1.03),('3355','2013-08-24','09:20:00',1.18),('3355','2013-08-24','09:25:00',1.08),('3355','2013-08-24','09:35:00',1.31),('3355','2013-08-24','09:40:00',1.34),('3355','2013-08-24','09:45:00',1.35),('3355','2013-08-24','09:50:00',1.39),('3355','2013-08-24','10:10:00',1.45),('3355','2013-08-24','10:15:00',1.56),('3355','2013-08-24','10:20:00',1.59),('3355','2013-08-24','10:25:00',1.62),('3355','2013-08-24','10:30:00',1.64),('3355','2013-08-24','10:35:00',1.67),('3355','2013-08-24','10:40:00',1.71),('3355','2013-08-24','10:45:00',1.74),('3355','2013-08-24','10:50:00',1.69),('3355','2013-08-24','10:55:00',1.82),('3355','2013-08-24','11:00:00',1.81),('3355','2013-08-24','11:05:00',1.8),('3355','2013-08-24','11:10:00',1.89),('3355','2013-08-24','11:15:00',1.89),('3355','2013-08-24','11:20:00',1.89),('3355','2013-08-24','11:25:00',1.92),('3355','2013-08-24','11:30:00',1.92),('3355','2013-08-24','11:35:00',1.97),('3355','2013-08-24','11:40:00',1.97),('3355','2013-08-24','11:45:00',1.99),('3355','2013-08-24','11:50:00',2.02),('3355','2013-08-24','11:55:00',2),('3355','2013-08-24','12:00:00',2.05),('3355','2013-08-24','12:05:00',2.06),('3355','2013-08-24','12:10:00',2.08),('3355','2013-08-24','12:15:00',2.1),('3355','2013-08-24','12:20:00',2.1),('3355','2013-08-24','12:25:00',2.12),('3355','2013-08-24','12:30:00',2.09),('3355','2013-08-24','12:35:00',2.12),('3355','2013-08-24','12:40:00',2.12),('3355','2013-08-24','12:45:00',2.1),('3355','2013-08-24','12:50:00',2.12),('3355','2013-08-24','12:55:00',2.14),('3355','2013-08-24','13:00:00',2.12),('3355','2013-08-24','13:05:00',2.13),('3355','2013-08-24','13:10:00',2.14),('3355','2013-08-24','13:15:00',2.15),('3355','2013-08-24','13:20:00',2.17),('3355','2013-08-24','13:25:00',2.17),('3355','2013-08-24','13:30:00',2.17),('3355','2013-08-24','13:35:00',2.18),('3355','2013-08-24','13:40:00',2.18),('3355','2013-08-24','13:45:00',2.17),('3355','2013-08-24','13:50:00',2.16),('3355','2013-08-24','13:55:00',2.14),('3355','2013-08-24','14:00:00',2.14),('3355','2013-08-24','14:05:00',2.14),('3355','2013-08-24','14:10:00',2.14),('3355','2013-08-24','14:15:00',2.11),('3355','2013-08-24','14:20:00',2.12),('3355','2013-08-24','14:25:00',2.1),('3355','2013-08-24','14:30:00',2.1),('3355','2013-08-24','14:35:00',2.1),('3355','2013-08-24','14:40:00',2.08),('3355','2013-08-24','14:45:00',2.06),('3355','2013-08-24','14:50:00',2.04),('3355','2013-08-24','14:55:00',2.02),('3355','2013-08-24','15:00:00',2.01),('3355','2013-08-24','15:05:00',1.99),('3355','2013-08-24','15:10:00',1.96),('3355','2013-08-24','15:15:00',1.93),('3355','2013-08-24','15:20:00',1.91),('3355','2013-08-24','15:25:00',1.91),('3355','2013-08-24','15:30:00',1.89),('3355','2013-08-24','15:35:00',1.85),('3355','2013-08-24','15:40:00',1.83),('3355','2013-08-24','15:45:00',1.79),('3355','2013-08-24','15:50:00',1.78),('3355','2013-08-24','15:55:00',1.75),('3355','2013-08-24','16:00:00',1.72),('3355','2013-08-24','16:05:00',1.7),('3355','2013-08-24','16:10:00',1.67),('3355','2013-08-24','16:15:00',1.64),('3355','2013-08-24','16:20:00',1.61),('3355','2013-08-24','16:25:00',1.58),('3355','2013-08-24','16:30:00',1.54),('3355','2013-08-24','16:35:00',1.49),('3355','2013-08-24','16:40:00',1.46),('3355','2013-08-24','16:45:00',1.42),('3355','2013-08-24','16:50:00',1.38),('3355','2013-08-24','16:55:00',1.34),('3355','2013-08-24','17:00:00',1.31),('3355','2013-08-24','17:05:00',1.27),('3355','2013-08-24','17:10:00',1.23),('3355','2013-08-24','17:15:00',1.19),('3355','2013-08-24','17:20:00',1.15),('3355','2013-08-24','17:25:00',1.1),('3355','2013-08-24','17:30:00',1.05),('3355','2013-08-24','17:35:00',1.01),('3355','2013-08-23','09:20:00',1.02),('3355','2013-08-23','09:25:00',1.05),('3355','2013-08-23','09:30:00',1.09),('3355','2013-08-23','09:35:00',1.12),('3355','2013-08-23','09:40:00',1.15),('3355','2013-08-23','09:45:00',1.19),('3355','2013-08-23','09:50:00',1.22),('3355','2013-08-23','09:55:00',1.27),('3355','2013-08-23','10:00:00',1.31),('3355','2013-08-23','10:05:00',1.33),('3355','2013-08-23','10:10:00',1.37),('3355','2013-08-23','10:15:00',1.4),('3355','2013-08-23','10:20:00',1.44),('3355','2013-08-23','10:25:00',1.47),('3355','2013-08-23','10:30:00',1.48),('3355','2013-08-23','10:35:00',1.5),('3355','2013-08-23','10:40:00',1.49),('3355','2013-08-23','10:45:00',1.58),('3355','2013-08-23','10:50:00',1.61),('3355','2013-08-23','10:55:00',1.58),('3355','2013-08-23','11:00:00',1.64),('3355','2013-08-23','11:05:00',1.7),('3355','2013-08-23','11:10:00',1.7),('3355','2013-08-23','11:15:00',1.66),('3355','2013-08-23','11:20:00',1.5),('3355','2013-08-23','11:25:00',1.86),('3355','2013-08-23','11:30:00',1.25),('3355','2013-08-23','11:35:00',1.36),('3355','2013-08-23','11:40:00',1.69),('3355','2013-08-23','11:45:00',1.25),('3355','2013-08-23','11:50:00',2),('3355','2013-08-23','11:55:00',1.98),('3355','2013-08-23','12:00:00',2.06),('3355','2013-08-23','12:05:00',1.69),('3355','2013-08-23','13:15:00',1.63),('3355','2013-08-23','13:25:00',1.81),('3355','2013-08-23','13:30:00',2.26),('3355','2013-08-23','13:35:00',2.25),('3355','2013-08-23','13:40:00',2.23),('3355','2013-08-23','13:45:00',2.19),('3355','2013-08-23','13:50:00',2.2),('3355','2013-08-23','13:55:00',2.07),('3355','2013-08-23','14:00:00',1.5),('3355','2013-08-23','14:05:00',2.1),('3355','2013-08-23','14:10:00',2.24),('3355','2013-08-23','14:15:00',2.2),('3355','2013-08-23','14:20:00',1.88),('3355','2013-08-23','14:25:00',1.96),('3355','2013-08-23','14:30:00',2.12),('3355','2013-08-23','14:35:00',2.08),('3355','2013-08-23','14:40:00',2.06),('3355','2013-08-23','14:45:00',2.05),('3355','2013-08-23','14:50:00',2.02),('3355','2013-08-23','14:55:00',2),('3355','2013-08-23','15:00:00',1.95),('3355','2013-08-23','15:05:00',1.84),('3355','2013-08-23','15:10:00',1.93),('3355','2013-08-23','15:15:00',1.9),('3355','2013-08-23','15:20:00',1.88),('3355','2013-08-23','15:25:00',1.88),('3355','2013-08-23','15:30:00',1.93),('3355','2013-08-23','15:35:00',1.81),('3355','2013-08-23','15:40:00',1.79),('3355','2013-08-23','15:45:00',1.8),('3355','2013-08-23','15:50:00',1.67),('3355','2013-08-23','15:55:00',1.74),('3355','2013-08-23','16:00:00',1.67),('3355','2013-08-23','16:05:00',1.58),('3355','2013-08-23','16:10:00',1.46),('3355','2013-08-23','16:15:00',1.45),('3355','2013-08-23','16:20:00',1.66),('3355','2013-08-23','16:25:00',1.6),('3355','2013-08-23','16:30:00',1.56),('3355','2013-08-23','16:35:00',1.54),('3355','2013-08-23','16:40:00',1.51),('3355','2013-08-23','16:45:00',1.47),('3355','2013-08-23','16:50:00',1.43),('3355','2013-08-23','16:55:00',1.37),('3355','2013-08-23','17:00:00',1.31),('3355','2013-08-23','17:05:00',1.26),('3355','2013-08-23','17:10:00',1.21),('3355','2013-08-23','17:15:00',1.16),('3355','2013-08-23','17:20:00',1.1),('3355','2013-08-23','17:25:00',1.07),('3355','2013-08-23','17:30:00',1),('3355','2013-08-22','09:10:00',1.06),('3355','2013-08-22','09:15:00',1.12),('3355','2013-08-22','09:20:00',1.2),('3355','2013-08-22','09:25:00',1.17),('3355','2013-08-22','09:50:00',1.09),('3355','2013-08-22','09:55:00',1.38),('3355','2013-08-22','10:00:00',1.51),('3355','2013-08-22','10:05:00',1.51),('3355','2013-08-22','10:10:00',1.53),('3355','2013-08-22','10:15:00',1.52),('3355','2013-08-22','10:20:00',1.54),('3355','2013-08-22','10:25:00',1.56),('3355','2013-08-22','10:30:00',1.6),('3355','2013-08-22','10:35:00',1.62),('3355','2013-08-22','10:40:00',1.65),('3355','2013-08-22','10:45:00',1.67),('3355','2013-08-22','10:50:00',1.7),('3355','2013-08-22','10:55:00',1.72),('3355','2013-08-22','11:00:00',1.75),('3355','2013-08-22','11:05:00',1.78),('3355','2013-08-22','11:10:00',1.78),('3355','2013-08-22','11:15:00',1.8),('3355','2013-08-22','11:20:00',1.81),('3355','2013-08-22','11:25:00',1.83),('3355','2013-08-22','11:30:00',1.86),('3355','2013-08-22','11:35:00',1.88),('3355','2013-08-22','11:40:00',1.89),('3355','2013-08-22','11:45:00',1.91),('3355','2013-08-22','11:50:00',1.93),('3355','2013-08-22','11:55:00',1.94),('3355','2013-08-22','12:00:00',1.96),('3355','2013-08-22','12:05:00',1.97),('3355','2013-08-22','12:10:00',1.99),('3355','2013-08-22','12:15:00',1.99),('3355','2013-08-22','12:20:00',2),('3355','2013-08-22','12:25:00',2.01),('3355','2013-08-22','12:30:00',2.02),('3355','2013-08-22','12:35:00',2.02),('3355','2013-08-22','12:40:00',2.03),('3355','2013-08-22','12:45:00',2.03),('3355','2013-08-22','12:50:00',2.04),('3355','2013-08-22','12:55:00',2.04),('3355','2013-08-22','13:00:00',2.03),('3355','2013-08-22','13:05:00',1.97),('3355','2013-08-22','13:10:00',1.97),('3355','2013-08-22','13:15:00',2),('3355','2013-08-22','13:20:00',2.02),('3355','2013-08-22','13:25:00',1.98),('3355','2013-08-22','13:30:00',2.01),('3355','2013-08-22','13:35:00',2.01),('3355','2013-08-22','13:40:00',2.02),('3355','2013-08-22','13:45:00',2.04),('3355','2013-08-22','13:50:00',2.03),('3355','2013-08-22','13:55:00',2.01),('3355','2013-08-22','14:00:00',2),('3355','2013-08-22','14:05:00',2),('3355','2013-08-22','14:10:00',1.99),('3355','2013-08-22','14:15:00',2),('3355','2013-08-22','14:20:00',2),('3355','2013-08-22','14:25:00',2.03),('3355','2013-08-22','14:30:00',2.03),('3355','2013-08-22','14:35:00',1.99),('3355','2013-08-22','14:40:00',1.97),('3355','2013-08-22','14:45:00',1.93),('3355','2013-08-22','14:50:00',1.92),('3355','2013-08-22','14:55:00',1.23),('3355','2013-08-22','15:00:00',1.93),('3355','2013-08-22','15:05:00',1.94),('3355','2013-08-22','15:10:00',1.9),('3355','2013-08-22','15:15:00',1.89),('3355','2013-08-22','15:20:00',1.86),('3355','2013-08-22','15:25:00',1.82),('3355','2013-08-22','15:30:00',1.8),('3355','2013-08-22','15:35:00',1.78),('3355','2013-08-22','15:40:00',1.76),('3355','2013-08-22','15:45:00',1.74),('3355','2013-08-22','15:50:00',1.72),('3355','2013-08-22','15:55:00',1.69),('3355','2013-08-22','16:00:00',1.65),('3355','2013-08-22','16:05:00',1.6),('3355','2013-08-22','16:10:00',1.57),('3355','2013-08-22','16:15:00',1.55),('3355','2013-08-22','16:20:00',1.52),('3355','2013-08-22','16:25:00',1.5),('3355','2013-08-22','16:30:00',1.47),('3355','2013-08-22','16:35:00',1.42),('3355','2013-08-22','16:40:00',1.38),('3355','2013-08-22','16:45:00',1.33),('3355','2013-08-22','16:50:00',1.3),('3355','2013-08-22','16:55:00',1.27),('3355','2013-08-22','17:00:00',1.2),('3355','2013-08-22','17:05:00',1.17),('3355','2013-08-22','17:10:00',1.13),('3355','2013-08-22','17:15:00',1.08),('3355','2013-08-22','17:20:00',1.03),('3355','2013-08-21','09:15:00',1.25),('3355','2013-08-21','09:20:00',1.21),('3355','2013-08-21','09:50:00',1.64),('3355','2013-08-21','09:55:00',1.78),('3355','2013-08-21','10:00:00',1.66),('3355','2013-08-21','10:05:00',1.43),('3355','2013-08-21','10:10:00',1.07),('3355','2013-08-21','10:15:00',1.1),('3355','2013-08-21','10:30:00',1.08),('3355','2013-08-21','10:35:00',1.76),('3355','2013-08-21','10:40:00',1.51),('3355','2013-08-21','10:45:00',1.24),('3355','2013-08-21','10:50:00',1.12),('3355','2013-08-21','11:00:00',1.16),('3355','2013-08-21','11:15:00',1.21),('3355','2013-08-21','11:20:00',2.11),('3355','2013-08-21','11:25:00',1.36),('3355','2013-08-21','11:30:00',1.46),('3355','2013-08-21','11:35:00',2.11),('3355','2013-08-21','11:40:00',2.14),('3355','2013-08-21','11:45:00',2.1),('3355','2013-08-21','11:50:00',1.6),('3355','2013-08-21','11:55:00',2.04),('3355','2013-08-21','12:00:00',2.15),('3355','2013-08-21','12:05:00',2.15),('3355','2013-08-21','12:10:00',2.16),('3355','2013-08-21','12:15:00',2.17),('3355','2013-08-21','12:20:00',1.98),('3355','2013-08-21','12:25:00',1.58),('3355','2013-08-21','12:30:00',1.95),('3355','2013-08-21','12:35:00',1.78),('3355','2013-08-21','12:40:00',1.92),('3355','2013-08-21','12:45:00',2.08),('3355','2013-08-21','12:50:00',2.03),('3355','2013-08-21','12:55:00',1.95),('3355','2013-08-21','13:00:00',2.04),('3355','2013-08-21','13:05:00',2.09),('3355','2013-08-21','13:10:00',2.12),('3355','2013-08-21','13:15:00',2.15),('3355','2013-08-21','13:20:00',2.14),('3355','2013-08-21','13:25:00',2.15),('3355','2013-08-21','13:30:00',2.16),('3355','2013-08-21','13:35:00',2.13),('3355','2013-08-21','13:40:00',2.09),('3355','2013-08-21','13:45:00',2.01),('3355','2013-08-21','13:50:00',2.01),('3355','2013-08-21','13:55:00',2.01),('3355','2013-08-21','14:00:00',2.01),('3355','2013-08-21','14:05:00',2.09),('3355','2013-08-21','14:10:00',2.1),('3355','2013-08-21','14:15:00',2.11),('3355','2013-08-21','14:20:00',1.81),('3355','2013-08-21','14:25:00',1.6),('3355','2013-08-21','14:30:00',1.89),('3355','2013-08-21','14:35:00',1.84),('3355','2013-08-21','14:40:00',1.9),('3355','2013-08-21','14:45:00',1.9),('3355','2013-08-21','14:50:00',1.8),('3355','2013-08-21','14:55:00',1.81),('3355','2013-08-21','15:00:00',1.88),('3355','2013-08-21','15:05:00',1.89),('3355','2013-08-21','15:10:00',1.83),('3355','2013-08-21','15:15:00',1.82),('3355','2013-08-21','15:20:00',1.77),('3355','2013-08-21','15:25:00',1.76),('3355','2013-08-21','15:30:00',1.71),('3355','2013-08-21','15:35:00',1.65),('3355','2013-08-21','15:40:00',1.58),('3355','2013-08-21','15:45:00',1.59),('3355','2013-08-21','15:50:00',1.62),('3355','2013-08-21','15:55:00',1.54),('3355','2013-08-21','16:00:00',1.43),('3355','2013-08-21','16:05:00',1.38),('3355','2013-08-21','16:10:00',1.37),('3355','2013-08-21','16:15:00',1.4),('3355','2013-08-21','16:20:00',1.51),('3355','2013-08-21','16:25:00',1.44),('3355','2013-08-21','16:30:00',1.51),('3355','2013-08-21','16:35:00',1.49),('3355','2013-08-21','16:40:00',1.44),('3355','2013-08-21','16:45:00',1.39),('3355','2013-08-21','16:50:00',1.36),('3355','2013-08-21','16:55:00',1.32),('3355','2013-08-21','17:00:00',1.29),('3355','2013-08-21','17:05:00',1.27),('3355','2013-08-21','17:10:00',1.24),('3355','2013-08-21','17:15:00',1.23),('3355','2013-08-21','17:20:00',1.2),('3355','2013-08-21','17:25:00',1.16),('3355','2013-08-21','17:30:00',1.1),('3355','2013-08-21','17:35:00',1.07),('3355','2013-08-21','17:40:00',1.03),('3355','2013-08-20','09:30:00',1.15),('3355','2013-08-20','09:35:00',1.1),('3355','2013-08-20','09:40:00',1.44),('3355','2013-08-20','09:45:00',1.49),('3355','2013-08-20','09:50:00',1.19),('3355','2013-08-20','09:55:00',1.23),('3355','2013-08-20','10:10:00',1.61),('3355','2013-08-20','10:20:00',1.09),('3355','2013-08-20','10:50:00',1.35),('3355','2013-08-20','10:55:00',1.45),('3355','2013-08-20','11:20:00',2.12),('3355','2013-08-20','11:25:00',2.03),('3355','2013-08-20','11:40:00',2.18),('3355','2013-08-20','11:45:00',2.09),('3355','2013-08-20','11:50:00',2.44),('3355','2013-08-20','11:55:00',2.35),('3355','2013-08-20','13:30:00',1.05),('3355','2013-08-20','13:35:00',1.3),('3355','2013-08-20','13:40:00',2.17),('3355','2013-08-20','13:45:00',2.38),('3355','2013-08-20','13:50:00',2.35),('3355','2013-08-20','13:55:00',2.28),('3355','2013-08-20','14:00:00',2.22),('3355','2013-08-20','14:05:00',2.23),('3355','2013-08-20','14:10:00',2.24),('3355','2013-08-20','14:15:00',2.21),('3355','2013-08-20','14:20:00',2.16),('3355','2013-08-20','14:25:00',2.11),('3355','2013-08-20','14:30:00',1.6),('3355','2013-08-20','14:35:00',2.32),('3355','2013-08-20','14:40:00',2.32),('3355','2013-08-20','14:45:00',2.12),('3355','2013-08-20','14:50:00',2.18),('3355','2013-08-20','14:55:00',1.64),('3355','2013-08-20','15:00:00',1.77),('3355','2013-08-20','15:05:00',2.01),('3355','2013-08-20','15:10:00',2.18),('3355','2013-08-20','15:15:00',2.14),('3355','2013-08-20','15:20:00',2.09),('3355','2013-08-20','15:25:00',2.03),('3355','2013-08-20','15:30:00',2.09),('3355','2013-08-20','15:35:00',2.08),('3355','2013-08-20','15:40:00',2.1),('3355','2013-08-20','15:45:00',2.19),('3355','2013-08-20','15:50:00',1.87),('3355','2013-08-20','15:55:00',2.23),('3355','2013-08-20','16:00:00',1.92),('3355','2013-08-20','16:05:00',1.97),('3355','2013-08-20','16:10:00',2.07),('3355','2013-08-20','16:15:00',2.03),('3355','2013-08-20','16:20:00',2),('3355','2013-08-20','16:25:00',1.91),('3355','2013-08-20','16:30:00',1.76),('3355','2013-08-20','16:35:00',1.81),('3355','2013-08-20','16:40:00',1.85),('3355','2013-08-20','16:45:00',1.77),('3355','2013-08-20','16:50:00',1.62),('3355','2013-08-20','16:55:00',1.56),('3355','2013-08-20','17:00:00',1.45),('3355','2013-08-20','17:05:00',1.37),('3355','2013-08-20','17:10:00',1.31),('3355','2013-08-20','17:15:00',1.24),('3355','2013-08-20','17:20:00',1.21),('3355','2013-08-20','17:25:00',1.17),('3355','2013-08-20','17:30:00',1.11),('3355','2013-08-20','17:35:00',1.08),('3355','2014-04-10','09:00:00',1.03),('3355','2014-04-10','09:05:00',1.09),('3355','2014-04-10','09:10:00',1.14),('3355','2014-04-10','09:15:00',1.18),('3355','2014-04-10','09:20:00',1.19),('3355','2014-04-10','09:25:00',1.29),('3355','2014-04-10','09:30:00',1.35),('3355','2014-04-10','09:35:00',1.4),('3355','2014-04-10','09:40:00',1.43),('3355','2014-04-10','09:45:00',1.47),('3355','2014-04-10','09:50:00',1.53),('3355','2014-04-10','09:55:00',1.57),('3355','2014-04-10','10:00:00',1.61),('3355','2014-04-10','10:05:00',1.65),('3355','2014-04-10','10:10:00',1.7),('3355','2014-04-10','10:15:00',1.7),('3355','2014-04-10','10:20:00',1.75),('3355','2014-04-10','10:25:00',1.78),('3355','2014-04-10','10:30:00',1.81),('3355','2014-04-10','10:35:00',1.88),('3355','2014-04-10','10:40:00',1.91),('3355','2014-04-10','10:45:00',1.92),('3355','2014-04-10','10:50:00',1.9),('3355','2014-04-10','10:55:00',1.94),('3355','2014-04-10','11:00:00',1.98),('3355','2014-04-10','11:05:00',2.04),('3355','2014-04-10','11:10:00',2),('3355','2014-04-10','11:15:00',2.09),('3355','2014-04-10','11:20:00',2.12),('3355','2014-04-10','11:25:00',2.17),('3355','2014-04-10','11:30:00',2.18),('3355','2014-04-10','11:35:00',2.22),('3355','2014-04-10','11:40:00',2.16),('3355','2014-04-10','11:45:00',2.21),('3355','2014-04-10','11:50:00',2.14),('3355','2014-04-10','11:55:00',2.24),('3355','2014-04-10','12:00:00',2.21),('3355','2014-04-10','12:05:00',2.09),('3355','2014-04-10','12:10:00',2.18),('3355','2014-04-10','12:15:00',2.21),('3355','2014-04-10','12:20:00',2.22),('3355','2014-04-10','12:25:00',2.19),('3355','2014-04-10','12:30:00',2.22),('3355','2014-04-10','12:35:00',2.32),('3355','2014-04-10','12:40:00',2.31),('3355','2014-04-10','12:45:00',2.31),('3355','2014-04-10','12:50:00',2.26),('3355','2014-04-10','12:55:00',2.24),('3355','2014-04-10','13:00:00',2.24),('3355','2014-04-10','13:05:00',2.15),('3355','2014-04-10','13:10:00',2.16),('3355','2014-04-10','13:15:00',2.25),('3355','2014-04-10','13:20:00',2.21),('3355','2014-04-10','13:25:00',2.38),('3355','2014-04-10','13:30:00',2.31),('3355','2014-04-10','13:35:00',2.37),('3355','2014-04-10','13:40:00',2.28),('3355','2014-04-10','13:45:00',2.37),('3355','2014-04-10','13:50:00',2.34),('3355','2014-04-10','13:55:00',2.32),('3355','2014-04-10','14:00:00',2.32),('3355','2014-04-10','14:05:00',2.32),('3355','2014-04-10','14:10:00',2.31),('3355','2014-04-10','14:15:00',2.29),('3355','2014-04-10','14:20:00',2.3),('3355','2014-04-10','14:25:00',2.3),('3355','2014-04-10','14:30:00',2.3),('3355','2014-04-10','14:35:00',2.29),('3355','2014-04-10','14:40:00',2.28),('3355','2014-04-10','14:45:00',2.07),('3355','2014-04-10','14:50:00',2.28),('3355','2014-04-10','14:55:00',2.22),('3355','2014-04-10','15:00:00',2.2),('3355','2014-04-10','15:05:00',2.17),('3355','2014-04-10','15:10:00',2.15),('3355','2014-04-10','15:15:00',2.14),('3355','2014-04-10','15:20:00',2.12),('3355','2014-04-10','15:25:00',2.08),('3355','2014-04-10','15:30:00',1.91),('3355','2014-04-10','15:35:00',1.88),('3355','2014-04-10','15:40:00',1.94),('3355','2014-04-10','15:45:00',1.88),('3355','2014-04-10','15:50:00',1.91),('3355','2014-04-10','15:55:00',1.86),('3355','2014-04-10','16:00:00',1.79),('3355','2014-04-10','16:05:00',1.84),('3355','2014-04-10','16:10:00',1.82),('3355','2014-04-10','16:15:00',1.88),('3355','2014-04-10','16:20:00',1.75),('3355','2014-04-10','16:25:00',1.8),('3355','2014-04-10','16:30:00',1.74),('3355','2014-04-10','16:35:00',1.72),('3355','2014-04-10','16:40:00',1.68),('3355','2014-04-10','16:45:00',1.68),('3355','2014-04-10','16:50:00',1.59),('3355','2014-04-10','16:55:00',1.54),('3355','2014-04-10','17:00:00',1.48),('3355','2014-04-10','17:05:00',1.44),('3355','2014-04-10','17:10:00',1.36),('3355','2014-04-10','17:15:00',1.29),('3355','2014-04-10','17:20:00',1.28),('3355','2014-04-10','17:25:00',1.21),('3355','2014-04-10','17:30:00',1.15),('3355','2014-04-10','17:35:00',1.08),('3355','2014-04-10','17:40:00',1.02),('3355','2013-08-19','09:10:00',1.04),('3355','2013-08-19','09:15:00',1.07),('3355','2013-08-19','09:20:00',1.12),('3355','2013-08-19','09:25:00',1.15),('3355','2013-08-19','09:30:00',1.2),('3355','2013-08-19','09:35:00',1.24),('3355','2013-08-19','09:40:00',1.28),('3355','2013-08-19','09:45:00',1.32),('3355','2013-08-19','09:50:00',1.36),('3355','2013-08-19','09:55:00',1.4),('3355','2013-08-19','10:00:00',1.44),('3355','2013-08-19','10:05:00',1.46),('3355','2013-08-19','10:10:00',1.5),('3355','2013-08-19','10:15:00',1.53),('3355','2013-08-19','10:20:00',1.56),('3355','2013-08-19','10:25:00',1.59),('3355','2013-08-19','10:30:00',1.62),('3355','2013-08-19','10:35:00',1.66),('3355','2013-08-19','10:40:00',1.69),('3355','2013-08-19','10:45:00',1.71),('3355','2013-08-19','10:50:00',1.72),('3355','2013-08-19','10:55:00',1.75),('3355','2013-08-19','11:00:00',1.79),('3355','2013-08-19','11:05:00',1.8),('3355','2013-08-19','11:10:00',1.81),('3355','2013-08-19','11:15:00',1.83),('3355','2013-08-19','11:20:00',1.85),('3355','2013-08-19','11:25:00',1.86),('3355','2013-08-19','11:30:00',1.9),('3355','2013-08-19','11:35:00',1.87),('3355','2013-08-19','11:40:00',1.92),('3355','2013-08-19','11:45:00',1.95),('3355','2013-08-19','11:50:00',1.95),('3355','2013-08-19','11:55:00',1.96),('3355','2013-08-19','12:00:00',1.98),('3355','2013-08-19','12:05:00',1.98),('3355','2013-08-19','12:10:00',2.02),('3355','2013-08-19','12:15:00',2.03),('3355','2013-08-19','12:20:00',2.06),('3355','2013-08-19','12:25:00',2.05),('3355','2013-08-19','12:30:00',2.04),('3355','2013-08-19','12:35:00',2.08),('3355','2013-08-19','12:40:00',2.09),('3355','2013-08-19','12:45:00',2.08),('3355','2013-08-19','12:50:00',2.13),('3355','2013-08-19','12:55:00',2.12),('3355','2013-08-19','13:00:00',2.12),('3355','2013-08-19','13:05:00',2.14),('3355','2013-08-19','13:10:00',2.15),('3355','2013-08-19','13:15:00',2.16),('3355','2013-08-19','13:20:00',2.17),('3355','2013-08-19','13:25:00',2.15),('3355','2013-08-19','13:30:00',2.16),('3355','2013-08-19','13:35:00',2.16),('3355','2013-08-19','13:40:00',2.16),('3355','2013-08-19','13:45:00',2.15),('3355','2013-08-19','13:50:00',2.15),('3355','2013-08-19','13:55:00',2.16),('3355','2013-08-19','14:00:00',2.15),('3355','2013-08-19','14:05:00',2.14),('3355','2013-08-19','14:10:00',2.14),('3355','2013-08-19','14:15:00',2.14),('3355','2013-08-19','14:20:00',2.14),('3355','2013-08-19','14:25:00',2.13),('3355','2013-08-19','14:30:00',2.11),('3355','2013-08-19','14:35:00',2.11),('3355','2013-08-19','14:40:00',2.1),('3355','2013-08-19','14:45:00',2.1),('3355','2013-08-19','14:50:00',2.09),('3355','2013-08-19','14:55:00',2.07),('3355','2013-08-19','15:00:00',2.03),('3355','2013-08-19','15:05:00',2.02),('3355','2013-08-19','15:10:00',2),('3355','2013-08-19','15:15:00',1.99),('3355','2013-08-19','15:20:00',1.97),('3355','2013-08-19','15:25:00',1.97),('3355','2013-08-19','15:30:00',1.93),('3355','2013-08-19','15:35:00',1.91),('3355','2013-08-19','15:40:00',1.89),('3355','2013-08-19','15:45:00',1.86),('3355','2013-08-19','15:50:00',1.84),('3355','2013-08-19','15:55:00',1.81),('3355','2013-08-19','16:00:00',1.77),('3355','2013-08-19','16:05:00',1.75),('3355','2013-08-19','16:10:00',1.73),('3355','2013-08-19','16:15:00',1.69),('3355','2013-08-19','16:20:00',1.65),('3355','2013-08-19','16:25:00',1.61),('3355','2013-08-19','16:30:00',1.58),('3355','2013-08-19','16:35:00',1.56),('3355','2013-08-19','16:40:00',1.53),('3355','2013-08-19','16:45:00',1.49),('3355','2013-08-19','16:50:00',1.46),('3355','2013-08-19','16:55:00',1.42),('3355','2013-08-19','17:00:00',1.38),('3355','2013-08-19','17:05:00',1.33),('3355','2013-08-19','17:10:00',1.29),('3355','2013-08-19','17:15:00',1.24),('3355','2013-08-19','17:20:00',1.2),('3355','2013-08-19','17:25:00',1.15),('3355','2013-08-19','17:30:00',1.1),('3355','2013-08-19','17:35:00',1.07),('3355','2013-08-19','17:40:00',1.02),('3355','2013-08-18','09:05:00',1),('3355','2013-08-18','09:10:00',1.05),('3355','2013-08-18','09:15:00',1.1),('3355','2013-08-18','09:20:00',1.14),('3355','2013-08-18','09:25:00',1.19),('3355','2013-08-18','09:30:00',1.23),('3355','2013-08-18','09:35:00',1.27),('3355','2013-08-18','09:40:00',1.34),('3355','2013-08-18','09:45:00',1.29),('3355','2013-08-18','09:50:00',1.35),('3355','2013-08-18','09:55:00',1.04),('3355','2013-08-18','10:00:00',1.46),('3355','2013-08-18','10:05:00',1.3),('3355','2013-08-18','10:10:00',1.36),('3355','2013-08-18','10:15:00',1.56),('3355','2013-08-18','10:20:00',1.58),('3355','2013-08-18','10:25:00',1.61),('3355','2013-08-18','10:30:00',1.62),('3355','2013-08-18','10:35:00',1.65),('3355','2013-08-18','10:40:00',1.67),('3355','2013-08-18','10:45:00',1.69),('3355','2013-08-18','10:50:00',1.71),('3355','2013-08-18','10:55:00',1.74),('3355','2013-08-18','11:00:00',1.77),('3355','2013-08-18','11:05:00',1.79),('3355','2013-08-18','11:10:00',1.8),('3355','2013-08-18','11:15:00',1.81),('3355','2013-08-18','11:20:00',1.85),('3355','2013-08-18','11:25:00',1.87),('3355','2013-08-18','11:30:00',1.87),('3355','2013-08-18','11:35:00',1.9),('3355','2013-08-18','11:40:00',1.94),('3355','2013-08-18','11:45:00',1.95),('3355','2013-08-18','11:50:00',1.96),('3355','2013-08-18','11:55:00',1.97),('3355','2013-08-18','12:00:00',1.98),('3355','2013-08-18','12:05:00',2.03),('3355','2013-08-18','12:10:00',2.05),('3355','2013-08-18','12:15:00',2),('3355','2013-08-18','12:20:00',2.07),('3355','2013-08-18','12:25:00',2.11),('3355','2013-08-18','12:30:00',2.15),('3355','2013-08-18','12:35:00',2),('3355','2013-08-18','13:00:00',1.29),('3355','2013-08-18','13:05:00',2.04),('3355','2013-08-18','13:10:00',1.96),('3355','2013-08-18','13:15:00',1.95),('3355','2013-08-18','13:20:00',2.1),('3355','2013-08-18','13:25:00',2.13),('3355','2013-08-18','13:30:00',2.15),('3355','2013-08-18','13:35:00',2.16),('3355','2013-08-18','13:40:00',2.17),('3355','2013-08-18','13:45:00',2.15),('3355','2013-08-18','13:50:00',2.15),('3355','2013-08-18','13:55:00',2.13),('3355','2013-08-18','14:00:00',2.14),('3355','2013-08-18','14:05:00',2.16),('3355','2013-08-18','14:10:00',2.11),('3355','2013-08-18','14:15:00',2.1),('3355','2013-08-18','14:20:00',2.1),('3355','2013-08-18','14:25:00',2.09),('3355','2013-08-18','14:30:00',2.1),('3355','2013-08-18','14:35:00',2.11),('3355','2013-08-18','14:40:00',2.08),('3355','2013-08-18','14:45:00',2.08),('3355','2013-08-18','14:50:00',2.05),('3355','2013-08-18','14:55:00',2.04),('3355','2013-08-18','15:00:00',2.03),('3355','2013-08-18','15:05:00',2.01),('3355','2013-08-18','15:10:00',1.98),('3355','2013-08-18','15:15:00',1.97),('3355','2013-08-18','15:20:00',1.95),('3355','2013-08-18','15:25:00',1.93),('3355','2013-08-18','15:30:00',1.91),('3355','2013-08-18','15:35:00',1.89),('3355','2013-08-18','15:40:00',1.87),('3355','2013-08-18','15:45:00',1.85),('3355','2013-08-18','15:50:00',1.82),('3355','2013-08-18','15:55:00',1.79),('3355','2013-08-18','16:00:00',1.76),('3355','2013-08-18','16:05:00',1.74),('3355','2013-08-18','16:10:00',1.71),('3355','2013-08-18','16:15:00',1.68),('3355','2013-08-18','16:20:00',1.65),('3355','2013-08-18','16:25:00',1.62),('3355','2013-08-18','16:30:00',1.58),('3355','2013-08-18','16:35:00',1.56),('3355','2013-08-18','16:40:00',1.51),('3355','2013-08-18','16:45:00',1.48),('3355','2013-08-18','16:50:00',1.45),('3355','2013-08-18','16:55:00',1.41),('3355','2013-08-18','17:00:00',1.37),('3355','2013-08-18','17:05:00',1.33),('3355','2013-08-18','17:10:00',1.29),('3355','2013-08-18','17:15:00',1.25),('3355','2013-08-18','17:20:00',1.21),('3355','2013-08-18','17:25:00',1.17),('3355','2013-08-18','17:30:00',1.13),('3355','2013-08-18','17:35:00',1.08),('3355','2013-08-18','17:40:00',1.03),('3355','2013-08-17','09:10:00',1.04),('3355','2013-08-17','09:15:00',1.08),('3355','2013-08-17','09:20:00',1.13),('3355','2013-08-17','09:25:00',1.17),('3355','2013-08-17','09:30:00',1.22),('3355','2013-08-17','09:35:00',1.26),('3355','2013-08-17','09:40:00',1.3),('3355','2013-08-17','09:45:00',1.34),('3355','2013-08-17','09:50:00',1.37),('3355','2013-08-17','09:55:00',1.41),('3355','2013-08-17','10:00:00',1.44),('3355','2013-08-17','10:05:00',1.48),('3355','2013-08-17','10:10:00',1.51),('3355','2013-08-17','10:15:00',1.55),('3355','2013-08-17','10:20:00',1.58),('3355','2013-08-17','10:25:00',1.6),('3355','2013-08-17','10:30:00',1.62),('3355','2013-08-17','10:35:00',1.67),('3355','2013-08-17','10:40:00',1.69),('3355','2013-08-17','10:45:00',1.71),('3355','2013-08-17','10:50:00',1.74),('3355','2013-08-17','10:55:00',1.77),('3355','2013-08-17','11:00:00',1.79),('3355','2013-08-17','11:05:00',1.81),('3355','2013-08-17','11:10:00',1.84),('3355','2013-08-17','11:15:00',1.86),('3355','2013-08-17','11:20:00',1.87),('3355','2013-08-17','11:25:00',1.88),('3355','2013-08-17','11:30:00',1.91),('3355','2013-08-17','11:35:00',1.92),('3355','2013-08-17','11:40:00',1.92),('3355','2013-08-17','11:45:00',1.95),('3355','2013-08-17','11:50:00',1.99),('3355','2013-08-17','11:55:00',2.03),('3355','2013-08-17','12:00:00',1.99),('3355','2013-08-17','12:05:00',2),('3355','2013-08-17','12:10:00',1.98),('3355','2013-08-17','12:15:00',2.03),('3355','2013-08-17','12:20:00',2.08),('3355','2013-08-17','12:25:00',1.78),('3355','2013-08-17','12:30:00',1.82),('3355','2013-08-17','12:40:00',2.05),('3355','2013-08-17','12:45:00',2.13),('3355','2013-08-17','12:50:00',2.12),('3355','2013-08-17','12:55:00',2.13),('3355','2013-08-17','13:00:00',2.14),('3355','2013-08-17','13:05:00',2.12),('3355','2013-08-17','13:10:00',2.15),('3355','2013-08-17','13:15:00',2.19),('3355','2013-08-17','13:20:00',2.18),('3355','2013-08-17','13:25:00',2.2),('3355','2013-08-17','13:30:00',2.21),('3355','2013-08-17','13:35:00',2.15),('3355','2013-08-17','13:40:00',1.5),('3355','2013-08-17','13:50:00',2.14),('3355','2013-08-17','14:05:00',2.07),('3355','2013-08-17','14:10:00',2.19),('3355','2013-08-17','14:20:00',1.75),('3355','2013-08-17','14:25:00',2.22),('3355','2013-08-17','14:30:00',2.15),('3355','2013-08-17','14:35:00',2.09),('3355','2013-08-17','14:40:00',2.11),('3355','2013-08-17','14:45:00',2.07),('3355','2013-08-17','14:50:00',2.05),('3355','2013-08-17','14:55:00',2.03),('3355','2013-08-17','15:00:00',2.04),('3355','2013-08-17','15:05:00',2.01),('3355','2013-08-17','15:10:00',1.99),('3355','2013-08-17','15:15:00',1.96),('3355','2013-08-17','15:20:00',1.95),('3355','2013-08-17','15:25:00',1.93),('3355','2013-08-17','15:30:00',1.91),('3355','2013-08-17','15:35:00',1.89),('3355','2013-08-17','15:40:00',1.87),('3355','2013-08-17','15:45:00',1.84),('3355','2013-08-17','15:50:00',1.83),('3355','2013-08-17','15:55:00',1.81),('3355','2013-08-17','16:00:00',1.77),('3355','2013-08-17','16:05:00',1.74),('3355','2013-08-17','16:10:00',1.73),('3355','2013-08-17','16:15:00',1.71),('3355','2013-08-17','16:20:00',1.66),('3355','2013-08-17','16:25:00',1.64),('3355','2013-08-17','16:30:00',1.58),('3355','2013-08-17','16:35:00',1.57),('3355','2013-08-17','16:40:00',1.56),('3355','2013-08-17','16:45:00',1.52),('3355','2013-08-17','16:50:00',1.44),('3355','2013-08-17','16:55:00',1.43),('3355','2013-08-17','17:00:00',1.4),('3355','2013-08-17','17:05:00',1.34),('3355','2013-08-17','17:10:00',1.31),('3355','2013-08-17','17:15:00',1.11),('3355','2013-08-17','17:20:00',1.19),('3355','2013-08-17','17:25:00',1.18),('3355','2013-08-17','17:30:00',1.18),('3355','2013-08-17','17:35:00',1.14),('3355','2013-08-17','17:40:00',1.1),('3355','2013-08-17','17:45:00',1.05),('3355','2013-08-16','09:05:00',1.02),('3355','2013-08-16','09:10:00',1.07),('3355','2013-08-16','09:15:00',1.11),('3355','2013-08-16','09:20:00',1.16),('3355','2013-08-16','09:25:00',1.2),('3355','2013-08-16','09:30:00',1.25),('3355','2013-08-16','09:35:00',1.29),('3355','2013-08-16','09:40:00',1.33),('3355','2013-08-16','09:45:00',1.38),('3355','2013-08-16','09:50:00',1.42),('3355','2013-08-16','09:55:00',1.45),('3355','2013-08-16','10:00:00',1.49),('3355','2013-08-16','10:05:00',1.53),('3355','2013-08-16','10:10:00',1.56),('3355','2013-08-16','10:15:00',1.59),('3355','2013-08-16','10:20:00',1.62),('3355','2013-08-16','10:25:00',1.66),('3355','2013-08-16','10:30:00',1.69),('3355','2013-08-16','10:35:00',1.72),('3355','2013-08-16','10:40:00',1.74),('3355','2013-08-16','10:45:00',1.76),('3355','2013-08-16','10:50:00',1.79),('3355','2013-08-16','10:55:00',1.82),('3355','2013-08-16','11:00:00',1.84),('3355','2013-08-16','11:05:00',1.87),('3355','2013-08-16','11:10:00',1.89),('3355','2013-08-16','11:15:00',1.92),('3355','2013-08-16','11:20:00',1.92),('3355','2013-08-16','11:25:00',1.94),('3355','2013-08-16','11:30:00',1.96),('3355','2013-08-16','11:35:00',1.99),('3355','2013-08-16','11:40:00',2),('3355','2013-08-16','11:45:00',2.01),('3355','2013-08-16','11:50:00',2.02),('3355','2013-08-16','11:55:00',2.03),('3355','2013-08-16','12:00:00',2.05),('3355','2013-08-16','12:05:00',2.05),('3355','2013-08-16','12:10:00',2.06),('3355','2013-08-16','12:15:00',2.08),('3355','2013-08-16','12:20:00',2.09),('3355','2013-08-16','12:25:00',2.1),('3355','2013-08-16','12:30:00',2.11),('3355','2013-08-16','12:35:00',2.11),('3355','2013-08-16','12:40:00',2.12),('3355','2013-08-16','12:45:00',2.13),('3355','2013-08-16','12:50:00',2.13),('3355','2013-08-16','12:55:00',2.13),('3355','2013-08-16','13:00:00',2.13),('3355','2013-08-16','13:05:00',2.13),('3355','2013-08-16','13:10:00',2.15),('3355','2013-08-16','13:15:00',2.14),('3355','2013-08-16','13:20:00',2.13),('3355','2013-08-16','13:25:00',2.12),('3355','2013-08-16','13:30:00',2.12),('3355','2013-08-16','13:35:00',2.12),('3355','2013-08-16','13:40:00',2.11),('3355','2013-08-16','13:45:00',2.11),('3355','2013-08-16','13:50:00',2.11),('3355','2013-08-16','13:55:00',2.11),('3355','2013-08-16','14:00:00',2.11),('3355','2013-08-16','14:05:00',2.12),('3355','2013-08-16','14:10:00',2.1),('3355','2013-08-16','14:15:00',2.1),('3355','2013-08-16','14:20:00',2.1),('3355','2013-08-16','14:25:00',2.08),('3355','2013-08-16','14:30:00',2.07),('3355','2013-08-16','14:35:00',2.07),('3355','2013-08-16','14:40:00',2.04),('3355','2013-08-16','14:45:00',2.01),('3355','2013-08-16','14:50:00',2),('3355','2013-08-16','14:55:00',1.99),('3355','2013-08-16','15:00:00',1.98),('3355','2013-08-16','15:05:00',1.95),('3355','2013-08-16','15:10:00',1.95),('3355','2013-08-16','15:15:00',1.95),('3355','2013-08-16','15:20:00',1.91),('3355','2013-08-16','15:25:00',1.91),('3355','2013-08-16','15:30:00',1.9),('3355','2013-08-16','15:35:00',1.88),('3355','2013-08-16','15:40:00',1.86),('3355','2013-08-16','15:45:00',1.83),('3355','2013-08-16','15:50:00',1.82),('3355','2013-08-16','15:55:00',1.79),('3355','2013-08-16','16:00:00',1.77),('3355','2013-08-16','16:05:00',1.74),('3355','2013-08-16','16:10:00',1.71),('3355','2013-08-16','16:15:00',1.69),('3355','2013-08-16','16:20:00',1.66),('3355','2013-08-16','16:25:00',1.63),('3355','2013-08-16','16:30:00',1.6),('3355','2013-08-16','16:35:00',1.56),('3355','2013-08-16','16:40:00',1.53),('3355','2013-08-16','16:45:00',1.49),('3355','2013-08-16','16:50:00',1.45),('3355','2013-08-16','16:55:00',1.41),('3355','2013-08-16','17:00:00',1.37),('3355','2013-08-16','17:05:00',1.34),('3355','2013-08-16','17:10:00',1.3),('3355','2013-08-16','17:15:00',1.25),('3355','2013-08-16','17:20:00',1.21),('3355','2013-08-16','17:25:00',1.16),('3355','2013-08-16','17:30:00',1.12),('3355','2013-08-16','17:35:00',1.07),('3355','2013-08-16','17:40:00',1.02),('3355','2013-08-15','09:20:00',1.24),('3355','2013-08-15','09:25:00',1.22),('3355','2013-08-15','09:30:00',1.25),('3355','2013-08-15','09:35:00',1.29),('3355','2013-08-15','09:40:00',1.33),('3355','2013-08-15','09:45:00',1.37),('3355','2013-08-15','09:50:00',1.42),('3355','2013-08-15','09:55:00',1.46),('3355','2013-08-15','10:00:00',1.49),('3355','2013-08-15','10:05:00',1.53),('3355','2013-08-15','10:10:00',1.56),('3355','2013-08-15','10:15:00',1.6),('3355','2013-08-15','10:20:00',1.64),('3355','2013-08-15','10:25:00',1.68),('3355','2013-08-15','10:30:00',1.71),('3355','2013-08-15','10:35:00',1.72),('3355','2013-08-15','10:40:00',1.75),('3355','2013-08-15','10:45:00',1.75),('3355','2013-08-15','10:50:00',1.72),('3355','2013-08-15','10:55:00',1.71),('3355','2013-08-15','11:00:00',1.57),('3355','2013-08-15','11:05:00',1.3),('3355','2013-08-15','11:10:00',1.37),('3355','2013-08-15','11:15:00',1.54),('3355','2013-08-15','11:20:00',1.67),('3355','2013-08-15','11:25:00',1.84),('3355','2013-08-15','11:30:00',1.96),('3355','2013-08-15','11:35:00',2.05),('3355','2013-08-15','11:40:00',2.1),('3355','2013-08-15','11:45:00',2.18),('3355','2013-08-15','11:50:00',2.2),('3355','2013-08-15','11:55:00',2.18),('3355','2013-08-15','12:00:00',2.2),('3355','2013-08-15','12:05:00',2.19),('3355','2013-08-15','12:10:00',2.17),('3355','2013-08-15','12:15:00',2.18),('3355','2013-08-15','12:20:00',2.18),('3355','2013-08-15','12:25:00',2.19),('3355','2013-08-15','12:30:00',2.18),('3355','2013-08-15','12:35:00',2.2),('3355','2013-08-15','12:40:00',2.18),('3355','2013-08-15','12:45:00',2.19),('3355','2013-08-15','12:50:00',2.16),('3355','2013-08-15','12:55:00',2.1),('3355','2013-08-15','13:00:00',2.15),('3355','2013-08-15','13:05:00',2.08),('3355','2013-08-15','13:10:00',2.07),('3355','2013-08-15','13:15:00',2.03),('3355','2013-08-15','13:20:00',2.14),('3355','2013-08-15','13:25:00',2.18),('3355','2013-08-15','13:30:00',2.18),('3355','2013-08-15','13:35:00',2.18),('3355','2013-08-15','13:40:00',2.16),('3355','2013-08-15','13:45:00',2.14),('3355','2013-08-15','13:50:00',2.13),('3355','2013-08-15','13:55:00',2.14),('3355','2013-08-15','14:00:00',2.16),('3355','2013-08-15','14:05:00',2.14),('3355','2013-08-15','14:10:00',2.12),('3355','2013-08-15','14:15:00',2.13),('3355','2013-08-15','14:20:00',2.11),('3355','2013-08-15','14:25:00',2.03),('3355','2013-08-15','14:30:00',2.03),('3355','2013-08-15','14:35:00',2.08),('3355','2013-08-15','14:40:00',2.05),('3355','2013-08-15','14:45:00',2.02),('3355','2013-08-15','14:50:00',2.02),('3355','2013-08-15','14:55:00',2),('3355','2013-08-15','15:00:00',1.99),('3355','2013-08-15','15:05:00',1.96),('3355','2013-08-15','15:10:00',1.94),('3355','2013-08-15','15:15:00',1.92),('3355','2013-08-15','15:20:00',1.89),('3355','2013-08-15','15:25:00',1.86),('3355','2013-08-15','15:30:00',1.85),('3355','2013-08-15','15:35:00',1.85),('3355','2013-08-15','15:40:00',1.81),('3355','2013-08-15','15:45:00',1.78),('3355','2013-08-15','15:50:00',1.75),('3355','2013-08-15','15:55:00',1.75),('3355','2013-08-15','16:00:00',1.71),('3355','2013-08-15','16:05:00',1.67),('3355','2013-08-15','16:10:00',1.64),('3355','2013-08-15','16:15:00',1.62),('3355','2013-08-15','16:20:00',1.6),('3355','2013-08-15','16:25:00',1.54),('3355','2013-08-15','16:30:00',1.46),('3355','2013-08-15','16:35:00',1.46),('3355','2013-08-15','16:40:00',1.46),('3355','2013-08-15','16:45:00',1.41),('3355','2013-08-15','16:50:00',1.39),('3355','2013-08-15','16:55:00',1.34),('3355','2013-08-15','17:00:00',1.31),('3355','2013-08-15','17:05:00',1.27),('3355','2013-08-15','17:10:00',1.22),('3355','2013-08-15','17:15:00',1.22),('3355','2013-08-15','17:20:00',1.16),('3355','2013-08-15','17:25:00',1.1),('3355','2013-08-15','17:30:00',1.08),('3355','2013-08-15','17:35:00',1.03),('3355','2013-08-14','09:05:00',1.02),('3355','2013-08-14','09:10:00',1.07),('3355','2013-08-14','09:15:00',1.11),('3355','2013-08-14','09:20:00',1.17),('3355','2013-08-14','09:25:00',1.14),('3355','2013-08-14','09:30:00',1.27),('3355','2013-08-14','09:35:00',1.3),('3355','2013-08-14','09:40:00',1.06),('3355','2013-08-14','10:05:00',1.25),('3355','2013-08-14','10:10:00',1.46),('3355','2013-08-14','10:15:00',1.25),('3355','2013-08-14','10:30:00',1.24),('3355','2013-08-14','10:35:00',1.84),('3355','2013-08-14','10:40:00',1.89),('3355','2013-08-14','10:45:00',1.83),('3355','2013-08-14','10:50:00',1.55),('3355','2013-08-14','10:55:00',1.6),('3355','2013-08-14','11:00:00',1.83),('3355','2013-08-14','11:05:00',1.95),('3355','2013-08-14','11:10:00',1.44),('3355','2013-08-14','11:15:00',1.88),('3355','2013-08-14','11:20:00',1.73),('3355','2013-08-14','11:25:00',1.34),('3355','2013-08-14','11:30:00',1.94),('3355','2013-08-14','11:35:00',2),('3355','2013-08-14','11:40:00',2.02),('3355','2013-08-14','11:45:00',1.89),('3355','2013-08-14','11:50:00',1.97),('3355','2013-08-14','11:55:00',1.02),('3355','2013-08-14','12:05:00',1.41),('3355','2013-08-14','12:10:00',1.83),('3355','2013-08-14','12:15:00',1.7),('3355','2013-08-14','12:55:00',1.26),('3355','2013-08-14','13:30:00',1.54),('3355','2013-08-14','13:35:00',1.01),('3355','2013-08-14','13:40:00',1.24),('3355','2013-08-14','13:45:00',2.44),('3355','2013-08-14','13:50:00',2.06),('3355','2013-08-14','13:55:00',2.17),('3355','2013-08-14','14:00:00',1.11),('3355','2013-08-14','14:05:00',2.46),('3355','2013-08-14','14:10:00',2.34),('3355','2013-08-14','14:15:00',2.26),('3355','2013-08-14','14:20:00',2.23),('3355','2013-08-14','14:25:00',2.25),('3355','2013-08-14','14:30:00',2.08),('3355','2013-08-14','14:35:00',2.21),('3355','2013-08-14','14:40:00',2.16),('3355','2013-08-14','14:45:00',2.12),('3355','2013-08-14','14:50:00',2.08),('3355','2013-08-14','14:55:00',2.08),('3355','2013-08-14','15:00:00',2.07),('3355','2013-08-14','15:05:00',2.05),('3355','2013-08-14','15:10:00',2.04),('3355','2013-08-14','15:15:00',2.08),('3355','2013-08-14','15:20:00',2.05),('3355','2013-08-14','15:25:00',1.98),('3355','2013-08-14','15:30:00',1.93),('3355','2013-08-14','15:35:00',1.91),('3355','2013-08-14','15:40:00',1.9),('3355','2013-08-14','15:45:00',1.87),('3355','2013-08-14','15:50:00',1.85),('3355','2013-08-14','15:55:00',1.81),('3355','2013-08-14','16:00:00',1.78),('3355','2013-08-14','16:05:00',1.77),('3355','2013-08-14','16:10:00',1.76),('3355','2013-08-14','16:15:00',1.72),('3355','2013-08-14','16:20:00',1.72),('3355','2013-08-14','16:25:00',1.66),('3355','2013-08-14','16:30:00',1.64),('3355','2013-08-14','16:35:00',1.61),('3355','2013-08-14','16:40:00',1.57),('3355','2013-08-14','16:45:00',1.53),('3355','2013-08-14','16:50:00',1.5),('3355','2013-08-14','16:55:00',1.46),('3355','2013-08-14','17:00:00',1.41),('3355','2013-08-14','17:05:00',1.37),('3355','2013-08-14','17:10:00',1.33),('3355','2013-08-14','17:15:00',1.29),('3355','2013-08-14','17:20:00',1.24),('3355','2013-08-14','17:25:00',1.19),('3355','2013-08-14','17:30:00',1.16),('3355','2013-08-14','17:35:00',1.1),('3355','2013-08-14','17:40:00',1.06),('3355','2013-08-14','17:45:00',1.01),('3355','2013-08-13','09:05:00',1.02),('3355','2013-08-13','09:10:00',1.06),('3355','2013-08-13','09:15:00',1.1),('3355','2013-08-13','09:20:00',1.13),('3355','2013-08-13','09:25:00',1.2),('3355','2013-08-13','09:30:00',1.25),('3355','2013-08-13','09:35:00',1.26),('3355','2013-08-13','09:40:00',1.25),('3355','2013-08-13','09:45:00',1.32),('3355','2013-08-13','09:50:00',1.37),('3355','2013-08-13','09:55:00',1.41),('3355','2013-08-13','10:00:00',1.42),('3355','2013-08-13','10:05:00',1.46),('3355','2013-08-13','10:10:00',1.28),('3355','2013-08-13','10:15:00',1.5),('3355','2013-08-13','10:20:00',1.58),('3355','2013-08-13','10:25:00',1.61),('3355','2013-08-13','10:30:00',1.63),('3355','2013-08-13','10:35:00',1.64),('3355','2013-08-13','10:40:00',1.71),('3355','2013-08-13','10:45:00',1.74),('3355','2013-08-13','10:50:00',1.76),('3355','2013-08-13','10:55:00',1.79),('3355','2013-08-13','11:00:00',1.82),('3355','2013-08-13','11:05:00',1.85),('3355','2013-08-13','11:10:00',1.87),('3355','2013-08-13','11:15:00',1.85),('3355','2013-08-13','11:20:00',1.87),('3355','2013-08-13','11:25:00',1.91),('3355','2013-08-13','11:30:00',1.94),('3355','2013-08-13','11:35:00',1.93),('3355','2013-08-13','11:40:00',1.96),('3355','2013-08-13','11:45:00',1.95),('3355','2013-08-13','11:50:00',2),('3355','2013-08-13','11:55:00',2.06),('3355','2013-08-13','12:00:00',2.05),('3355','2013-08-13','12:05:00',2.09),('3355','2013-08-13','12:10:00',2.14),('3355','2013-08-13','12:15:00',2.08),('3355','2013-08-13','12:20:00',2.08),('3355','2013-08-13','12:25:00',2.22),('3355','2013-08-13','12:30:00',2.22),('3355','2013-08-13','12:35:00',2.19),('3355','2013-08-13','12:40:00',2.25),('3355','2013-08-13','12:45:00',1.79),('3355','2013-08-13','12:55:00',2.08),('3355','2013-08-13','13:00:00',1.67),('3355','2013-08-13','13:15:00',1.29),('3355','2013-08-13','13:20:00',2.49),('3355','2013-08-13','13:25:00',2.41),('3355','2013-08-13','13:30:00',2.34),('3355','2013-08-13','13:35:00',2.3),('3355','2013-08-13','13:40:00',1.8),('3355','2013-08-13','13:50:00',1.17),('3355','2013-08-13','13:55:00',2.13),('3355','2013-08-13','14:00:00',1.99),('3355','2013-08-13','14:05:00',1.22),('3355','2013-08-13','14:10:00',2.42),('3355','2013-08-13','14:15:00',2.41),('3355','2013-08-13','14:20:00',2.25),('3355','2013-08-13','14:25:00',1.21),('3355','2013-08-13','14:30:00',1.01),('3355','2013-08-13','14:35:00',2.36),('3355','2013-08-13','14:50:00',2),('3355','2013-08-13','14:55:00',2.36),('3355','2013-08-13','15:00:00',2.08),('3355','2013-08-13','15:05:00',1.98),('3355','2013-08-13','15:10:00',1.82),('3355','2013-08-13','15:15:00',1.66),('3355','2013-08-13','15:20:00',2.07),('3355','2013-08-13','15:25:00',2.02),('3355','2013-08-13','15:30:00',1.91),('3355','2013-08-13','15:35:00',1.97),('3355','2013-08-13','15:40:00',1.99),('3355','2013-08-13','15:45:00',1.9),('3355','2013-08-13','15:50:00',1.86),('3355','2013-08-13','15:55:00',1.82),('3355','2013-08-13','16:00:00',1.79),('3355','2013-08-13','16:05:00',1.77),('3355','2013-08-13','16:10:00',1.74),('3355','2013-08-13','16:15:00',1.71),('3355','2013-08-13','16:20:00',1.68),('3355','2013-08-13','16:25:00',1.65),('3355','2013-08-13','16:30:00',1.62),('3355','2013-08-13','16:35:00',1.59),('3355','2013-08-13','16:40:00',1.55),('3355','2013-08-13','16:45:00',1.51),('3355','2013-08-13','16:50:00',1.47),('3355','2013-08-13','16:55:00',1.44),('3355','2013-08-13','17:00:00',1.4),('3355','2013-08-13','17:05:00',1.37),('3355','2013-08-13','17:10:00',1.33),('3355','2013-08-13','17:15:00',1.29),('3355','2013-08-13','17:20:00',1.24),('3355','2013-08-13','17:25:00',1.2),('3355','2013-08-13','17:30:00',1.15),('3355','2013-08-13','17:35:00',1.11),('3355','2013-08-13','17:40:00',1.06),('3355','2013-08-13','17:45:00',1.01),('3355','2013-08-12','09:10:00',1.04),('3355','2013-08-12','09:15:00',1.09),('3355','2013-08-12','09:20:00',1.14),('3355','2013-08-12','09:25:00',1.17),('3355','2013-08-12','09:30:00',1.22),('3355','2013-08-12','09:35:00',1.25),('3355','2013-08-12','09:40:00',1.29),('3355','2013-08-12','09:45:00',1.33),('3355','2013-08-12','09:50:00',1.37),('3355','2013-08-12','09:55:00',1.4),('3355','2013-08-12','10:00:00',1.44),('3355','2013-08-12','10:05:00',1.47),('3355','2013-08-12','10:10:00',1.5),('3355','2013-08-12','10:15:00',1.53),('3355','2013-08-12','10:20:00',1.57),('3355','2013-08-12','10:25:00',1.6),('3355','2013-08-12','10:30:00',1.63),('3355','2013-08-12','10:35:00',1.66),('3355','2013-08-12','10:40:00',1.69),('3355','2013-08-12','10:45:00',1.72),('3355','2013-08-12','10:50:00',1.74),('3355','2013-08-12','10:55:00',1.76),('3355','2013-08-12','11:00:00',1.78),('3355','2013-08-12','11:05:00',1.8),('3355','2013-08-12','11:10:00',1.82),('3355','2013-08-12','11:15:00',1.86),('3355','2013-08-12','11:20:00',1.84),('3355','2013-08-12','11:25:00',1.85),('3355','2013-08-12','11:30:00',1.85),('3355','2013-08-12','11:35:00',1.92),('3355','2013-08-12','11:40:00',1.97),('3355','2013-08-12','11:45:00',1.98),('3355','2013-08-12','11:50:00',2.01),('3355','2013-08-12','11:55:00',1.99),('3355','2013-08-12','12:00:00',2.08),('3355','2013-08-12','12:05:00',2.1),('3355','2013-08-12','12:10:00',2.13),('3355','2013-08-12','12:15:00',2.01),('3355','2013-08-12','12:20:00',1.77),('3355','2013-08-12','12:25:00',1.25),('3355','2013-08-12','12:50:00',1.49),('3355','2013-08-12','12:55:00',1.09),('3355','2013-08-12','13:50:00',1.47),('3355','2013-08-12','13:55:00',1.41),('3355','2013-08-12','14:10:00',1.12),('3355','2013-08-12','14:50:00',1.16),('3355','2013-08-12','14:55:00',2.38),('3355','2013-08-12','15:00:00',2.27),('3355','2013-08-12','15:05:00',2.18),('3355','2013-08-12','15:10:00',2.12),('3355','2013-08-12','15:15:00',2.06),('3355','2013-08-12','15:20:00',1.97),('3355','2013-08-12','15:25:00',2.02),('3355','2013-08-12','15:30:00',1.96),('3355','2013-08-12','15:35:00',1.9),('3355','2013-08-12','15:40:00',1.91),('3355','2013-08-12','15:45:00',1.85),('3355','2013-08-12','15:50:00',1.86),('3355','2013-08-12','15:55:00',1.84),('3355','2013-08-12','16:00:00',1.79),('3355','2013-08-12','16:05:00',1.77),('3355','2013-08-12','16:10:00',1.75),('3355','2013-08-12','16:15:00',1.71),('3355','2013-08-12','16:20:00',1.65),('3355','2013-08-12','16:25:00',1.62),('3355','2013-08-12','16:30:00',1.59),('3355','2013-08-12','16:35:00',1.56),('3355','2013-08-12','16:40:00',1.53),('3355','2013-08-12','16:45:00',1.48),('3355','2013-08-12','16:50:00',1.47),('3355','2013-08-12','16:55:00',1.37),('3355','2013-08-12','17:00:00',1.36),('3355','2013-08-12','17:05:00',1.34),('3355','2013-08-12','17:10:00',1.3),('3355','2013-08-12','17:15:00',1.25),('3355','2013-08-12','17:20:00',1.21),('3355','2013-08-12','17:25:00',1.17),('3355','2013-08-12','17:30:00',1.13),('3355','2013-08-12','17:35:00',1.09),('3355','2013-08-12','17:40:00',1.04),('3355','2013-08-11','09:05:00',1.02),('3355','2013-08-11','09:10:00',1.07),('3355','2013-08-11','09:15:00',1.1),('3355','2013-08-11','09:20:00',1.16),('3355','2013-08-11','09:25:00',1.2),('3355','2013-08-11','09:30:00',1.24),('3355','2013-08-11','09:35:00',1.28),('3355','2013-08-11','09:40:00',1.32),('3355','2013-08-11','09:45:00',1.37),('3355','2013-08-11','09:50:00',1.4),('3355','2013-08-11','09:55:00',1.44),('3355','2013-08-11','10:00:00',1.48),('3355','2013-08-11','10:05:00',1.52),('3355','2013-08-11','10:10:00',1.56),('3355','2013-08-11','10:15:00',1.6),('3355','2013-08-11','10:20:00',1.63),('3355','2013-08-11','10:25:00',1.66),('3355','2013-08-11','10:30:00',1.7),('3355','2013-08-11','10:35:00',1.71),('3355','2013-08-11','10:40:00',1.74),('3355','2013-08-11','10:45:00',1.77),('3355','2013-08-11','10:50:00',1.8),('3355','2013-08-11','10:55:00',1.82),('3355','2013-08-11','11:00:00',1.85),('3355','2013-08-11','11:05:00',1.87),('3355','2013-08-11','11:10:00',1.9),('3355','2013-08-11','11:15:00',1.91),('3355','2013-08-11','11:20:00',1.94),('3355','2013-08-11','11:25:00',1.96),('3355','2013-08-11','11:30:00',1.97),('3355','2013-08-11','11:35:00',1.99),('3355','2013-08-11','11:40:00',2.01),('3355','2013-08-11','11:45:00',2.01),('3355','2013-08-11','11:50:00',2.04),('3355','2013-08-11','11:55:00',2.04),('3355','2013-08-11','12:00:00',2.05),('3355','2013-08-11','12:05:00',2.07),('3355','2013-08-11','12:10:00',2.08),('3355','2013-08-11','12:15:00',2.08),('3355','2013-08-11','12:20:00',2.09),('3355','2013-08-11','12:25:00',2.1),('3355','2013-08-11','12:30:00',2.12),('3355','2013-08-11','12:35:00',2.13),('3355','2013-08-11','12:40:00',2.12),('3355','2013-08-11','12:45:00',2.11),('3355','2013-08-11','12:50:00',2.12),('3355','2013-08-11','12:55:00',2.15),('3355','2013-08-11','13:00:00',2.16),('3355','2013-08-11','13:05:00',2.14),('3355','2013-08-11','13:10:00',2.14),('3355','2013-08-11','13:15:00',2.16),('3355','2013-08-11','13:20:00',2.15),('3355','2013-08-11','13:25:00',2.16),('3355','2013-08-11','13:30:00',2.16),('3355','2013-08-11','13:35:00',2.14),('3355','2013-08-11','13:40:00',2.13),('3355','2013-08-11','13:45:00',2.13),('3355','2013-08-11','13:50:00',2.12),('3355','2013-08-11','13:55:00',2.12),('3355','2013-08-11','14:00:00',2.12),('3355','2013-08-11','14:05:00',2.11),('3355','2013-08-11','14:10:00',2.11),('3355','2013-08-11','14:15:00',2.05),('3355','2013-08-11','14:20:00',2.04),('3355','2013-08-11','14:25:00',2.04),('3355','2013-08-11','14:30:00',2.05),('3355','2013-08-11','14:35:00',2.05),('3355','2013-08-11','14:40:00',2.06),('3355','2013-08-11','14:45:00',2.04),('3355','2013-08-11','14:50:00',2),('3355','2013-08-11','14:55:00',1.98),('3355','2013-08-11','15:00:00',2.02),('3355','2013-08-11','15:05:00',2),('3355','2013-08-11','15:10:00',1.97),('3355','2013-08-11','15:15:00',1.93),('3355','2013-08-11','15:20:00',1.92),('3355','2013-08-11','15:25:00',1.91),('3355','2013-08-11','15:30:00',1.9),('3355','2013-08-11','15:35:00',1.84),('3355','2013-08-11','15:40:00',1.85),('3355','2013-08-11','15:45:00',1.82),('3355','2013-08-11','15:50:00',1.82),('3355','2013-08-11','15:55:00',1.8),('3355','2013-08-11','16:00:00',1.77),('3355','2013-08-11','16:05:00',1.74),('3355','2013-08-11','16:10:00',1.71),('3355','2013-08-11','16:15:00',1.68),('3355','2013-08-11','16:20:00',1.65),('3355','2013-08-11','16:25:00',1.61),('3355','2013-08-11','16:30:00',1.59),('3355','2013-08-11','16:35:00',1.56),('3355','2013-08-11','16:40:00',1.52),('3355','2013-08-11','16:45:00',1.48),('3355','2013-08-11','16:50:00',1.45),('3355','2013-08-11','16:55:00',1.41),('3355','2013-08-11','17:00:00',1.37),('3355','2013-08-11','17:05:00',1.33),('3355','2013-08-11','17:10:00',1.29),('3355','2013-08-11','17:15:00',1.25),('3355','2013-08-11','17:20:00',1.21),('3355','2013-08-11','17:25:00',1.17),('3355','2013-08-11','17:30:00',1.13),('3355','2013-08-11','17:35:00',1.09),('3355','2013-08-11','17:40:00',1.04),('3355','2013-08-10','09:05:00',1.04),('3355','2013-08-10','09:10:00',1.09),('3355','2013-08-10','09:15:00',1.14),('3355','2013-08-10','09:20:00',1.18),('3355','2013-08-10','09:25:00',1.23),('3355','2013-08-10','09:30:00',1.01),('3355','2013-08-10','09:35:00',1.3),('3355','2013-08-10','09:40:00',1.34),('3355','2013-08-10','09:45:00',1.38),('3355','2013-08-10','09:50:00',1.42),('3355','2013-08-10','09:55:00',1.45),('3355','2013-08-10','10:00:00',1.49),('3355','2013-08-10','10:05:00',1.52),('3355','2013-08-10','10:10:00',1.55),('3355','2013-08-10','10:15:00',1.59),('3355','2013-08-10','10:20:00',1.62),('3355','2013-08-10','10:25:00',1.65),('3355','2013-08-10','10:30:00',1.69),('3355','2013-08-10','10:35:00',1.72),('3355','2013-08-10','10:40:00',1.74),('3355','2013-08-10','10:45:00',1.77),('3355','2013-08-10','10:50:00',1.8),('3355','2013-08-10','10:55:00',1.83),('3355','2013-08-10','11:00:00',1.88),('3355','2013-08-10','11:05:00',1.9),('3355','2013-08-10','11:10:00',1.94),('3355','2013-08-10','11:15:00',1.17),('3355','2013-08-10','11:20:00',1.71),('3355','2013-08-10','11:25:00',1.08),('3355','2013-08-10','11:30:00',1.59),('3355','2013-08-10','11:35:00',2.06),('3355','2013-08-10','11:40:00',2.04),('3355','2013-08-10','11:45:00',2.04),('3355','2013-08-10','11:50:00',2.05),('3355','2013-08-10','11:55:00',2.05),('3355','2013-08-10','12:00:00',2.08),('3355','2013-08-10','12:05:00',2.08),('3355','2013-08-10','12:10:00',2.09),('3355','2013-08-10','12:15:00',2.09),('3355','2013-08-10','12:20:00',2.11),('3355','2013-08-10','12:25:00',2.14),('3355','2013-08-10','12:30:00',2.14),('3355','2013-08-10','12:35:00',2.15),('3355','2013-08-10','12:40:00',2.17),('3355','2013-08-10','12:45:00',2.2),('3355','2013-08-10','12:50:00',2.23),('3355','2013-08-10','12:55:00',2.24),('3355','2013-08-10','13:00:00',2.22),('3355','2013-08-10','13:05:00',2.2),('3355','2013-08-10','13:10:00',2.22),('3355','2013-08-10','13:15:00',2.25),('3355','2013-08-10','13:20:00',2.28),('3355','2013-08-10','13:25:00',2.27),('3355','2013-08-10','13:30:00',2.13),('3355','2013-08-10','13:35:00',2.1),('3355','2013-08-10','13:50:00',2.37),('3355','2013-08-10','13:55:00',2.29),('3355','2013-08-10','14:00:00',1.73),('3355','2013-08-10','14:05:00',1.31),('3355','2013-08-10','14:10:00',2.53),('3355','2013-08-10','14:15:00',2.17),('3355','2013-08-10','14:20:00',1.03),('3355','2013-08-10','15:55:00',1.04),('3355','2013-08-10','16:00:00',1.04),('3355','2013-08-10','16:05:00',1.96),('3355','2013-08-10','16:10:00',1.07),('3355','2013-08-10','16:15:00',1.04),('3355','2013-08-10','16:20:00',1.25),('3355','2013-08-10','16:35:00',1.86),('3355','2013-08-10','16:40:00',1.71),('3355','2013-08-10','16:45:00',1.66),('3355','2013-08-10','16:50:00',1.57),('3355','2013-08-10','16:55:00',1.47),('3355','2013-08-10','17:00:00',1.39),('3355','2014-04-09','09:55:00',1.52),('3355','2014-04-09','10:00:00',1.52),('3355','2014-04-09','10:05:00',1.54),('3355','2014-04-09','10:10:00',1.6),('3355','2014-04-09','10:15:00',1.68),('3355','2014-04-09','10:20:00',1.7),('3355','2014-04-09','10:25:00',1.78),('3355','2014-04-09','10:30:00',1.88),('3355','2014-04-09','10:35:00',2.05),('3355','2014-04-09','10:40:00',1.26),('3355','2014-04-09','11:00:00',1.97),('3355','2014-04-09','11:05:00',2.19),('3355','2014-04-09','11:10:00',2.21),('3355','2014-04-09','11:15:00',2.3),('3355','2014-04-09','11:20:00',2.11),('3355','2014-04-09','11:25:00',1.02),('3355','2014-04-09','11:40:00',1.74),('3355','2014-04-09','11:45:00',2.55),('3355','2014-04-09','11:50:00',2.39),('3355','2014-04-09','11:55:00',2.52),('3355','2014-04-09','12:00:00',2.5),('3355','2014-04-09','12:05:00',2.35),('3355','2014-04-09','12:10:00',1.01),('3355','2014-04-09','14:10:00',1.5),('3355','2014-04-09','14:20:00',1.47),('3355','2014-04-09','14:30:00',1.1),('3355','2014-04-09','14:35:00',2.48),('3355','2014-04-09','14:40:00',1.55),('3355','2014-04-09','14:50:00',1.05),('3355','2014-04-09','14:55:00',1.32),('3355','2014-04-09','15:00:00',1.24),('3355','2014-04-09','15:05:00',2.25),('3355','2014-04-09','15:10:00',2.11),('3355','2014-04-09','15:15:00',2.01),('3355','2014-04-09','15:20:00',1.89),('3355','2014-04-09','15:25:00',1.26),('3355','2014-04-09','15:30:00',2.15),('3355','2014-04-09','15:35:00',1.43),('3355','2014-04-09','15:45:00',1.23),('3355','2014-04-09','15:50:00',1.25),('3355','2014-04-09','16:05:00',1.11),('3355','2014-04-09','16:10:00',1.02),('3355','2014-04-09','16:15:00',1.85),('3355','2014-04-09','16:20:00',1.86),('3355','2014-04-09','16:25:00',1.76),('3355','2014-04-09','16:30:00',1.5),('3355','2014-04-09','16:50:00',1.27),('3355','2014-04-09','17:05:00',1.45),('3355','2014-04-09','17:10:00',1.42),('3355','2014-04-09','17:15:00',1.22),('3355','2014-04-09','17:20:00',1.22),('3355','2014-04-09','17:25:00',1.24),('3355','2013-08-09','09:10:00',1.08),('3355','2013-08-09','09:30:00',1.22),('3355','2013-08-09','09:35:00',1.29),('3355','2013-08-09','09:45:00',1.16),('3355','2013-08-09','09:50:00',1.34),('3355','2013-08-09','09:55:00',1.02),('3355','2013-08-09','10:00:00',1.03),('3355','2013-08-09','10:05:00',1.13),('3355','2013-08-09','10:10:00',1.36),('3355','2013-08-09','10:15:00',1.4),('3355','2013-08-09','10:20:00',1.42),('3355','2013-08-09','10:25:00',1.28),('3355','2013-08-09','10:30:00',1.45),('3355','2013-08-09','10:35:00',1.57),('3355','2013-08-09','10:40:00',1.6),('3355','2013-08-09','10:45:00',1.57),('3355','2013-08-09','10:50:00',1.6),('3355','2013-08-09','10:55:00',1.66),('3355','2013-08-09','11:00:00',1.68),('3355','2013-08-09','11:05:00',1.7),('3355','2013-08-09','11:10:00',1.73),('3355','2013-08-09','11:15:00',1.76),('3355','2013-08-09','11:20:00',1.76),('3355','2013-08-09','11:25:00',1.78),('3355','2013-08-09','11:30:00',1.82),('3355','2013-08-09','11:35:00',1.83),('3355','2013-08-09','11:40:00',1.83),('3355','2013-08-09','11:45:00',1.84),('3355','2013-08-09','11:50:00',1.86),('3355','2013-08-09','11:55:00',1.9),('3355','2013-08-09','12:00:00',1.9),('3355','2013-08-09','12:05:00',1.9),('3355','2013-08-09','12:10:00',1.93),('3355','2013-08-09','12:15:00',1.96),('3355','2013-08-09','12:20:00',2.03),('3355','2013-08-09','12:25:00',1.97),('3355','2013-08-09','12:30:00',1.3),('3355','2013-08-09','12:35:00',1.74),('3355','2013-08-09','12:40:00',2.04),('3355','2013-08-09','12:45:00',1.52),('3355','2013-08-09','12:50:00',1.34),('3355','2013-08-09','12:55:00',1.52),('3355','2013-08-09','13:25:00',1.18),('3355','2013-08-09','15:10:00',1.55),('3355','2013-08-09','15:15:00',1.38),('3355','2013-08-09','15:35:00',1.16),('3355','2013-08-09','15:45:00',1.79),('3355','2013-08-09','15:50:00',1.19),('3355','2013-08-09','15:55:00',1.25),('3355','2013-08-09','16:55:00',1.08),('3355','2013-08-09','17:05:00',1.08),('3355','2013-08-08','09:15:00',1.01),('3355','2013-08-08','09:20:00',1.07),('3355','2013-08-08','09:25:00',1.11),('3355','2013-08-08','09:30:00',1.15),('3355','2013-08-08','09:35:00',1.19),('3355','2013-08-08','09:40:00',1.22),('3355','2013-08-08','09:45:00',1.26),('3355','2013-08-08','09:50:00',1.31),('3355','2013-08-08','09:55:00',1.34),('3355','2013-08-08','10:00:00',1.37),('3355','2013-08-08','10:05:00',1.41),('3355','2013-08-08','10:10:00',1.43),('3355','2013-08-08','10:15:00',1.47),('3355','2013-08-08','10:20:00',1.49),('3355','2013-08-08','10:25:00',1.51),('3355','2013-08-08','10:30:00',1.55),('3355','2013-08-08','10:35:00',1.58),('3355','2013-08-08','10:40:00',1.61),('3355','2013-08-08','10:45:00',1.63),('3355','2013-08-08','10:50:00',1.65),('3355','2013-08-08','10:55:00',1.68),('3355','2013-08-08','11:00:00',1.7),('3355','2013-08-08','11:05:00',1.72),('3355','2013-08-08','11:10:00',1.74),('3355','2013-08-08','11:15:00',1.76),('3355','2013-08-08','11:20:00',1.78),('3355','2013-08-08','11:25:00',1.78),('3355','2013-08-08','11:30:00',1.81),('3355','2013-08-08','11:35:00',1.82),('3355','2013-08-08','11:40:00',1.83),('3355','2013-08-08','11:45:00',1.85),('3355','2013-08-08','11:50:00',1.86),('3355','2013-08-08','11:55:00',1.87),('3355','2013-08-08','12:00:00',1.89),('3355','2013-08-08','12:05:00',1.89),('3355','2013-08-08','12:10:00',1.91),('3355','2013-08-08','12:15:00',1.91),('3355','2013-08-08','12:20:00',1.94),('3355','2013-08-08','12:25:00',1.95),('3355','2013-08-08','12:30:00',1.96),('3355','2013-08-08','12:35:00',1.94),('3355','2013-08-08','12:40:00',1.97),('3355','2013-08-08','12:45:00',1.98),('3355','2013-08-08','12:50:00',2.01),('3355','2013-08-08','12:55:00',2.02),('3355','2013-08-08','13:00:00',2.02),('3355','2013-08-08','13:05:00',1.97),('3355','2013-08-08','13:10:00',2.02),('3355','2013-08-08','13:15:00',2.03),('3355','2013-08-08','13:20:00',2.02),('3355','2013-08-08','13:25:00',2.05),('3355','2013-08-08','13:30:00',2.05),('3355','2013-08-08','13:35:00',2.03),('3355','2013-08-08','13:40:00',2.02),('3355','2013-08-08','13:45:00',2.02),('3355','2013-08-08','13:50:00',2.03),('3355','2013-08-08','13:55:00',2.01),('3355','2013-08-08','14:00:00',2.02),('3355','2013-08-08','14:05:00',2.03),('3355','2013-08-08','14:10:00',2.02),('3355','2013-08-08','14:15:00',2.01),('3355','2013-08-08','14:20:00',1.96),('3355','2013-08-08','14:25:00',1.96),('3355','2013-08-08','14:30:00',1.96),('3355','2013-08-08','14:35:00',1.95),('3355','2013-08-08','14:40:00',1.93),('3355','2013-08-08','14:45:00',1.92),('3355','2013-08-08','14:50:00',1.91),('3355','2013-08-08','14:55:00',1.87),('3355','2013-08-08','15:00:00',1.86),('3355','2013-08-08','15:05:00',1.85),('3355','2013-08-08','15:10:00',1.83),('3355','2013-08-08','15:15:00',1.8),('3355','2013-08-08','15:20:00',1.8),('3355','2013-08-08','15:25:00',1.78),('3355','2013-08-08','15:30:00',1.76),('3355','2013-08-08','15:35:00',1.74),('3355','2013-08-08','15:40:00',1.73),('3355','2013-08-08','15:45:00',1.71),('3355','2013-08-08','15:50:00',1.68),('3355','2013-08-08','15:55:00',1.66),('3355','2013-08-08','16:00:00',1.64),('3355','2013-08-08','16:05:00',1.63),('3355','2013-08-08','16:10:00',1.61),('3355','2013-08-08','16:15:00',1.58),('3355','2013-08-08','16:20:00',1.57),('3355','2013-08-08','16:25:00',1.55),('3355','2013-08-08','16:30:00',1.51),('3355','2013-08-08','16:35:00',1.48),('3355','2013-08-08','16:40:00',1.46),('3355','2013-08-08','16:45:00',1.41),('3355','2013-08-08','16:50:00',1.38),('3355','2013-08-08','16:55:00',1.34),('3355','2013-08-08','17:00:00',1.3),('3355','2013-08-08','17:05:00',1.26),('3355','2013-08-08','17:10:00',1.21),('3355','2013-08-08','17:15:00',1.18),('3355','2013-08-08','17:20:00',1.12),('3355','2013-08-08','17:25:00',1.09),('3355','2013-08-08','17:30:00',1.06),('3355','2013-08-08','17:35:00',1.02),('3355','2013-08-07','09:10:00',1.01),('3355','2013-08-07','09:15:00',1.04),('3355','2013-08-07','09:20:00',1.1),('3355','2013-08-07','09:25:00',1.14),('3355','2013-08-07','09:30:00',1.18),('3355','2013-08-07','09:35:00',1.22),('3355','2013-08-07','09:40:00',1.26),('3355','2013-08-07','09:45:00',1.29),('3355','2013-08-07','09:50:00',1.3),('3355','2013-08-07','09:55:00',1.35),('3355','2013-08-07','10:00:00',1.37),('3355','2013-08-07','10:05:00',1.42),('3355','2013-08-07','10:10:00',1.45),('3355','2013-08-07','10:15:00',1.49),('3355','2013-08-07','10:20:00',1.5),('3355','2013-08-07','10:25:00',1.53),('3355','2013-08-07','10:30:00',1.58),('3355','2013-08-07','10:35:00',1.6),('3355','2013-08-07','10:40:00',1.62),('3355','2013-08-07','10:45:00',1.64),('3355','2013-08-07','10:50:00',1.68),('3355','2013-08-07','10:55:00',1.71),('3355','2013-08-07','11:00:00',1.73),('3355','2013-08-07','11:05:00',1.74),('3355','2013-08-07','11:10:00',1.76),('3355','2013-08-07','11:15:00',1.78),('3355','2013-08-07','11:20:00',1.79),('3355','2013-08-07','11:25:00',1.81),('3355','2013-08-07','11:30:00',1.83),('3355','2013-08-07','11:35:00',1.85),('3355','2013-08-07','11:40:00',1.86),('3355','2013-08-07','11:45:00',1.88),('3355','2013-08-07','11:50:00',1.89),('3355','2013-08-07','11:55:00',1.89),('3355','2013-08-07','12:00:00',1.9),('3355','2013-08-07','12:05:00',1.92),('3355','2013-08-07','12:10:00',1.93),('3355','2013-08-07','12:15:00',1.96),('3355','2013-08-07','12:20:00',1.95),('3355','2013-08-07','12:25:00',1.96),('3355','2013-08-07','12:30:00',1.96),('3355','2013-08-07','12:35:00',1.98),('3355','2013-08-07','12:40:00',1.95),('3355','2013-08-07','12:45:00',1.95),('3355','2013-08-07','12:50:00',1.99),('3355','2013-08-07','12:55:00',2.01),('3355','2013-08-07','13:00:00',2),('3355','2013-08-07','13:05:00',1.97),('3355','2013-08-07','13:10:00',1.99),('3355','2013-08-07','13:15:00',1.96),('3355','2013-08-07','13:20:00',2.02),('3355','2013-08-07','13:25:00',1.99),('3355','2013-08-07','13:30:00',2.03),('3355','2013-08-07','13:35:00',2.03),('3355','2013-08-07','13:40:00',2.03),('3355','2013-08-07','13:45:00',2.06),('3355','2013-08-07','13:50:00',2.02),('3355','2013-08-07','13:55:00',2.04),('3355','2013-08-07','14:00:00',2.04),('3355','2013-08-07','14:05:00',2.02),('3355','2013-08-07','14:10:00',2.01),('3355','2013-08-07','14:15:00',1.99),('3355','2013-08-07','14:20:00',1.95),('3355','2013-08-07','14:25:00',1.96),('3355','2013-08-07','14:30:00',1.93),('3355','2013-08-07','14:35:00',1.91),('3355','2013-08-07','14:40:00',1.89),('3355','2013-08-07','14:45:00',1.95),('3355','2013-08-07','14:50:00',1.93),('3355','2013-08-07','14:55:00',1.92),('3355','2013-08-07','15:00:00',1.89),('3355','2013-08-07','15:05:00',1.88),('3355','2013-08-07','15:10:00',1.86),('3355','2013-08-07','15:15:00',1.85),('3355','2013-08-07','15:20:00',1.84),('3355','2013-08-07','15:25:00',1.84),('3355','2013-08-07','15:30:00',1.78),('3355','2013-08-07','15:35:00',1.78),('3355','2013-08-07','15:40:00',1.76),('3355','2013-08-07','15:45:00',1.75),('3355','2013-08-07','15:50:00',1.72),('3355','2013-08-07','15:55:00',1.7),('3355','2013-08-07','16:00:00',1.67),('3355','2013-08-07','16:05:00',1.64),('3355','2013-08-07','16:10:00',1.59),('3355','2013-08-07','16:15:00',1.56),('3355','2013-08-07','16:20:00',1.55),('3355','2013-08-07','16:25:00',1.54),('3355','2013-08-07','16:30:00',1.51),('3355','2013-08-07','16:35:00',1.48),('3355','2013-08-07','16:40:00',1.45),('3355','2013-08-07','16:45:00',1.43),('3355','2013-08-07','16:50:00',1.4),('3355','2013-08-07','16:55:00',1.37),('3355','2013-08-07','17:00:00',1.34),('3355','2013-08-07','17:05:00',1.3),('3355','2013-08-07','17:10:00',1.25),('3355','2013-08-07','17:15:00',1.2),('3355','2013-08-07','17:20:00',1.17),('3355','2013-08-07','17:25:00',1.15),('3355','2013-08-07','17:30:00',1.09),('3355','2013-08-07','17:35:00',1.03),('3355','2013-08-06','09:15:00',1.03),('3355','2013-08-06','09:20:00',1.07),('3355','2013-08-06','09:25:00',1.11),('3355','2013-08-06','09:30:00',1.15),('3355','2013-08-06','09:35:00',1.19),('3355','2013-08-06','09:40:00',1.23),('3355','2013-08-06','09:45:00',1.26),('3355','2013-08-06','09:50:00',1.3),('3355','2013-08-06','09:55:00',1.34),('3355','2013-08-06','10:00:00',1.37),('3355','2013-08-06','10:05:00',1.41),('3355','2013-08-06','10:10:00',1.43),('3355','2013-08-06','10:15:00',1.47),('3355','2013-08-06','10:20:00',1.5),('3355','2013-08-06','10:25:00',1.53),('3355','2013-08-06','10:30:00',1.57),('3355','2013-08-06','10:35:00',1.59),('3355','2013-08-06','10:40:00',1.6),('3355','2013-08-06','10:45:00',1.63),('3355','2013-08-06','10:50:00',1.65),('3355','2013-08-06','10:55:00',1.67),('3355','2013-08-06','11:00:00',1.71),('3355','2013-08-06','11:05:00',1.73),('3355','2013-08-06','11:10:00',1.74),('3355','2013-08-06','11:15:00',1.78),('3355','2013-08-06','11:20:00',1.8),('3355','2013-08-06','11:25:00',1.8),('3355','2013-08-06','11:30:00',1.82),('3355','2013-08-06','11:35:00',1.85),('3355','2013-08-06','11:40:00',1.88),('3355','2013-08-06','11:45:00',1.87),('3355','2013-08-06','11:50:00',1.86),('3355','2013-08-06','11:55:00',1.88),('3355','2013-08-06','12:00:00',1.91),('3355','2013-08-06','12:05:00',1.91),('3355','2013-08-06','12:10:00',1.94),('3355','2013-08-06','12:15:00',1.93),('3355','2013-08-06','12:20:00',1.94),('3355','2013-08-06','12:25:00',1.95),('3355','2013-08-06','12:30:00',1.94),('3355','2013-08-06','12:35:00',1.96),('3355','2013-08-06','12:40:00',1.97),('3355','2013-08-06','12:45:00',1.95),('3355','2013-08-06','12:50:00',1.97),('3355','2013-08-06','12:55:00',1.99),('3355','2013-08-06','13:00:00',1.99),('3355','2013-08-06','13:05:00',1.99),('3355','2013-08-06','13:10:00',2),('3355','2013-08-06','13:15:00',2.02),('3355','2013-08-06','13:20:00',2.02),('3355','2013-08-06','13:25:00',2.04),('3355','2013-08-06','13:30:00',2.05),('3355','2013-08-06','13:35:00',2.06),('3355','2013-08-06','13:40:00',2.07),('3355','2013-08-06','13:45:00',2.07),('3355','2013-08-06','13:50:00',2.08),('3355','2013-08-06','13:55:00',2.09),('3355','2013-08-06','14:00:00',2.09),('3355','2013-08-06','14:05:00',2.1),('3355','2013-08-06','14:10:00',2.09),('3355','2013-08-06','14:15:00',2.09),('3355','2013-08-06','14:20:00',2.08),('3355','2013-08-06','14:25:00',2.07),('3355','2013-08-06','14:30:00',2.06),('3355','2013-08-06','14:35:00',2.04),('3355','2013-08-06','14:40:00',2.03),('3355','2013-08-06','14:45:00',2.02),('3355','2013-08-06','14:50:00',2.02),('3355','2013-08-06','14:55:00',2),('3355','2013-08-06','15:00:00',1.99),('3355','2013-08-06','15:05:00',1.98),('3355','2013-08-06','15:10:00',1.97),('3355','2013-08-06','15:15:00',1.94),('3355','2013-08-06','15:20:00',1.93),('3355','2013-08-06','15:25:00',1.92),('3355','2013-08-06','15:30:00',1.89),('3355','2013-08-06','15:35:00',1.88),('3355','2013-08-06','15:40:00',1.85),('3355','2013-08-06','15:45:00',1.83),('3355','2013-08-06','15:50:00',1.8),('3355','2013-08-06','15:55:00',1.77),('3355','2013-08-06','16:00:00',1.75),('3355','2013-08-06','16:05:00',1.72),('3355','2013-08-06','16:10:00',1.69),('3355','2013-08-06','16:15:00',1.66),('3355','2013-08-06','16:20:00',1.63),('3355','2013-08-06','16:25:00',1.6),('3355','2013-08-06','16:30:00',1.56),('3355','2013-08-06','16:35:00',1.54),('3355','2013-08-06','16:40:00',1.5),('3355','2013-08-06','16:45:00',1.47),('3355','2013-08-06','16:50:00',1.43),('3355','2013-08-06','16:55:00',1.4),('3355','2013-08-06','17:00:00',1.36),('3355','2013-08-06','17:05:00',1.33),('3355','2013-08-06','17:10:00',1.29),('3355','2013-08-06','17:15:00',1.23),('3355','2013-08-06','17:20:00',1.2),('3355','2013-08-06','17:25:00',1.16),('3355','2013-08-06','17:30:00',1.12),('3355','2013-08-06','17:35:00',1.07),('3355','2013-08-06','17:40:00',1.02),('3355','2013-08-05','09:10:00',1.02),('3355','2013-08-05','09:15:00',1.05),('3355','2013-08-05','09:20:00',1.09),('3355','2013-08-05','09:25:00',1.13),('3355','2013-08-05','09:30:00',1.17),('3355','2013-08-05','09:35:00',1.21),('3355','2013-08-05','09:40:00',1.24),('3355','2013-08-05','09:45:00',1.28),('3355','2013-08-05','09:50:00',1.31),('3355','2013-08-05','09:55:00',1.34),('3355','2013-08-05','10:00:00',1.38),('3355','2013-08-05','10:05:00',1.41),('3355','2013-08-05','10:10:00',1.45),('3355','2013-08-05','10:15:00',1.49),('3355','2013-08-05','10:20:00',1.52),('3355','2013-08-05','10:25:00',1.54),('3355','2013-08-05','10:30:00',1.58),('3355','2013-08-05','10:35:00',1.6),('3355','2013-08-05','10:40:00',1.63),('3355','2013-08-05','10:45:00',1.66),('3355','2013-08-05','10:50:00',1.69),('3355','2013-08-05','10:55:00',1.7),('3355','2013-08-05','11:00:00',1.74),('3355','2013-08-05','11:05:00',1.75),('3355','2013-08-05','11:10:00',1.79),('3355','2013-08-05','11:15:00',1.8),('3355','2013-08-05','11:20:00',1.83),('3355','2013-08-05','11:25:00',1.85),('3355','2013-08-05','11:30:00',1.86),('3355','2013-08-05','11:35:00',1.87),('3355','2013-08-05','11:40:00',1.9),('3355','2013-08-05','11:45:00',1.91),('3355','2013-08-05','11:50:00',1.94),('3355','2013-08-05','11:55:00',1.93),('3355','2013-08-05','12:00:00',1.95),('3355','2013-08-05','12:05:00',1.96),('3355','2013-08-05','12:10:00',1.97),('3355','2013-08-05','12:15:00',2),('3355','2013-08-05','12:20:00',2),('3355','2013-08-05','12:25:00',2.01),('3355','2013-08-05','12:30:00',2.01),('3355','2013-08-05','12:35:00',2.02),('3355','2013-08-05','12:40:00',2.03),('3355','2013-08-05','12:45:00',2.03),('3355','2013-08-05','12:50:00',2.03),('3355','2013-08-05','12:55:00',2.02),('3355','2013-08-05','13:00:00',2.03),('3355','2013-08-05','13:05:00',2.04),('3355','2013-08-05','13:10:00',2.05),('3355','2013-08-05','13:15:00',2.05),('3355','2013-08-05','13:20:00',2.05),('3355','2013-08-05','13:25:00',2.05),('3355','2013-08-05','13:30:00',2.05),('3355','2013-08-05','13:35:00',2.06),('3355','2013-08-05','13:40:00',2.06),('3355','2013-08-05','13:45:00',2.04),('3355','2013-08-05','13:50:00',2.01),('3355','2013-08-05','13:55:00',2),('3355','2013-08-05','14:00:00',2.02),('3355','2013-08-05','14:05:00',2.03),('3355','2013-08-05','14:10:00',2.02),('3355','2013-08-05','14:15:00',2.01),('3355','2013-08-05','14:20:00',2),('3355','2013-08-05','14:25:00',1.99),('3355','2013-08-05','14:30:00',1.98),('3355','2013-08-05','14:35:00',1.98),('3355','2013-08-05','14:40:00',1.97),('3355','2013-08-05','14:45:00',1.96),('3355','2013-08-05','14:50:00',1.94),('3355','2013-08-05','14:55:00',1.93),('3355','2013-08-05','15:00:00',1.92),('3355','2013-08-05','15:05:00',1.92),('3355','2013-08-05','15:10:00',1.91),('3355','2013-08-05','15:15:00',1.9),('3355','2013-08-05','15:20:00',1.88),('3355','2013-08-05','15:25:00',1.87),('3355','2013-08-05','15:30:00',1.85),('3355','2013-08-05','15:35:00',1.84),('3355','2013-08-05','15:40:00',1.82),('3355','2013-08-05','15:45:00',1.8),('3355','2013-08-05','15:50:00',1.77),('3355','2013-08-05','15:55:00',1.75),('3355','2013-08-05','16:00:00',1.74),('3355','2013-08-05','16:05:00',1.72),('3355','2013-08-05','16:10:00',1.68),('3355','2013-08-05','16:15:00',1.65),('3355','2013-08-05','16:20:00',1.61),('3355','2013-08-05','16:25:00',1.58),('3355','2013-08-05','16:30:00',1.55),('3355','2013-08-05','16:35:00',1.53),('3355','2013-08-05','16:40:00',1.49),('3355','2013-08-05','16:45:00',1.45),('3355','2013-08-05','16:50:00',1.41),('3355','2013-08-05','16:55:00',1.38),('3355','2013-08-05','17:00:00',1.35),('3355','2013-08-05','17:05:00',1.31),('3355','2013-08-05','17:10:00',1.27),('3355','2013-08-05','17:15:00',1.22),('3355','2013-08-05','17:20:00',1.18),('3355','2013-08-05','17:25:00',1.14),('3355','2013-08-05','17:30:00',1.1),('3355','2013-08-05','17:35:00',1.06),('3355','2013-08-05','17:40:00',1.01),('3355','2013-08-04','09:05:00',1.03),('3355','2013-08-04','09:10:00',1.07),('3355','2013-08-04','09:15:00',1.11),('3355','2013-08-04','09:20:00',1.15),('3355','2013-08-04','09:25:00',1.19),('3355','2013-08-04','09:30:00',1.23),('3355','2013-08-04','09:35:00',1.28),('3355','2013-08-04','09:40:00',1.31),('3355','2013-08-04','09:45:00',1.35),('3355','2013-08-04','09:50:00',1.39),('3355','2013-08-04','09:55:00',1.42),('3355','2013-08-04','10:00:00',1.46),('3355','2013-08-04','10:05:00',1.49),('3355','2013-08-04','10:10:00',1.52),('3355','2013-08-04','10:15:00',1.55),('3355','2013-08-04','10:20:00',1.59),('3355','2013-08-04','10:25:00',1.62),('3355','2013-08-04','10:30:00',1.65),('3355','2013-08-04','10:35:00',1.68),('3355','2013-08-04','10:40:00',1.71),('3355','2013-08-04','10:45:00',1.73),('3355','2013-08-04','10:50:00',1.4),('3355','2013-08-04','10:55:00',1.77),('3355','2013-08-04','11:00:00',1.79),('3355','2013-08-04','11:05:00',1.81),('3355','2013-08-04','11:10:00',1.82),('3355','2013-08-04','11:15:00',1.84),('3355','2013-08-04','11:20:00',1.86),('3355','2013-08-04','11:25:00',1.88),('3355','2013-08-04','11:30:00',1.91),('3355','2013-08-04','11:35:00',1.93),('3355','2013-08-04','11:40:00',1.95),('3355','2013-08-04','11:45:00',1.96),('3355','2013-08-04','11:50:00',1.97),('3355','2013-08-04','11:55:00',2),('3355','2013-08-04','12:00:00',2.01),('3355','2013-08-04','12:05:00',2.02),('3355','2013-08-04','12:10:00',2.02),('3355','2013-08-04','12:15:00',2.03),('3355','2013-08-04','12:20:00',2.05),('3355','2013-08-04','12:25:00',2.04),('3355','2013-08-04','12:30:00',2.04),('3355','2013-08-04','12:35:00',2.06),('3355','2013-08-04','12:40:00',2.08),('3355','2013-08-04','12:45:00',2.09),('3355','2013-08-04','12:50:00',2.09),('3355','2013-08-04','12:55:00',2.09),('3355','2013-08-04','13:00:00',2.09),('3355','2013-08-04','13:05:00',2.09),('3355','2013-08-04','13:10:00',2.06),('3355','2013-08-04','13:15:00',2.08),('3355','2013-08-04','13:20:00',2.08),('3355','2013-08-04','13:25:00',2.08),('3355','2013-08-04','13:30:00',2.09),('3355','2013-08-04','13:35:00',2.11),('3355','2013-08-04','13:40:00',2.14),('3355','2013-08-04','13:45:00',2.14),('3355','2013-08-04','13:50:00',2.15),('3355','2013-08-04','13:55:00',2.15),('3355','2013-08-04','14:00:00',2.15),('3355','2013-08-04','14:05:00',2.15),('3355','2013-08-04','14:10:00',2.13),('3355','2013-08-04','14:15:00',2.13),('3355','2013-08-04','14:20:00',2.1),('3355','2013-08-04','14:25:00',2.1),('3355','2013-08-04','14:30:00',2.1),('3355','2013-08-04','14:35:00',2.08),('3355','2013-08-04','14:40:00',2.06),('3355','2013-08-04','14:45:00',2.06),('3355','2013-08-04','14:50:00',2.04),('3355','2013-08-04','14:55:00',2.03),('3355','2013-08-04','15:00:00',2.02),('3355','2013-08-04','15:05:00',2),('3355','2013-08-04','15:10:00',1.98),('3355','2013-08-04','15:15:00',1.96),('3355','2013-08-04','15:20:00',1.95),('3355','2013-08-04','15:25:00',1.93),('3355','2013-08-04','15:30:00',1.89),('3355','2013-08-04','15:35:00',1.9),('3355','2013-08-04','15:40:00',1.86),('3355','2013-08-04','15:45:00',1.84),('3355','2013-08-04','15:50:00',1.8),('3355','2013-08-04','15:55:00',1.79),('3355','2013-08-04','16:00:00',1.77),('3355','2013-08-04','16:05:00',1.74),('3355','2013-08-04','16:10:00',1.72),('3355','2013-08-04','16:15:00',1.71),('3355','2013-08-04','16:20:00',1.68),('3355','2013-08-04','16:25:00',1.65),('3355','2013-08-04','16:30:00',1.61),('3355','2013-08-04','16:35:00',1.57),('3355','2013-08-04','16:40:00',1.54),('3355','2013-08-04','16:45:00',1.51),('3355','2013-08-04','16:50:00',1.47),('3355','2013-08-04','16:55:00',1.44),('3355','2013-08-04','17:00:00',1.39),('3355','2013-08-04','17:05:00',1.36),('3355','2013-08-04','17:10:00',1.33),('3355','2013-08-04','17:15:00',1.28),('3355','2013-08-04','17:20:00',1.24),('3355','2013-08-04','17:25:00',1.19),('3355','2013-08-04','17:30:00',1.14),('3355','2013-08-04','17:35:00',1.1),('3355','2013-08-04','17:40:00',1.06),('3355','2013-08-04','17:45:00',1.01),('3355','2013-08-03','09:05:00',1.02),('3355','2013-08-03','09:10:00',1.06),('3355','2013-08-03','09:15:00',1.11),('3355','2013-08-03','09:20:00',1.15),('3355','2013-08-03','09:25:00',1.19),('3355','2013-08-03','09:30:00',1.24),('3355','2013-08-03','09:35:00',1.27),('3355','2013-08-03','09:40:00',1.31),('3355','2013-08-03','09:45:00',1.34),('3355','2013-08-03','09:50:00',1.38),('3355','2013-08-03','09:55:00',1.42),('3355','2013-08-03','10:00:00',1.44),('3355','2013-08-03','10:05:00',1.48),('3355','2013-08-03','10:10:00',1.51),('3355','2013-08-03','10:15:00',1.55),('3355','2013-08-03','10:20:00',1.58),('3355','2013-08-03','10:25:00',1.62),('3355','2013-08-03','10:30:00',1.65),('3355','2013-08-03','10:35:00',1.68),('3355','2013-08-03','10:40:00',1.7),('3355','2013-08-03','10:45:00',1.73),('3355','2013-08-03','10:50:00',1.75),('3355','2013-08-03','10:55:00',1.77),('3355','2013-08-03','11:00:00',1.8),('3355','2013-08-03','11:05:00',1.83),('3355','2013-08-03','11:10:00',1.82),('3355','2013-08-03','11:15:00',1.84),('3355','2013-08-03','11:20:00',1.87),('3355','2013-08-03','11:25:00',1.87),('3355','2013-08-03','11:30:00',1.87),('3355','2013-08-03','11:35:00',1.92),('3355','2013-08-03','11:40:00',1.93),('3355','2013-08-03','11:45:00',1.94),('3355','2013-08-03','11:50:00',1.97),('3355','2013-08-03','11:55:00',2.01),('3355','2013-08-03','12:00:00',2),('3355','2013-08-03','12:05:00',2),('3355','2013-08-03','12:10:00',2.01),('3355','2013-08-03','12:15:00',2.03),('3355','2013-08-03','12:20:00',2.04),('3355','2013-08-03','12:25:00',2.03),('3355','2013-08-03','12:30:00',2.07),('3355','2013-08-03','12:35:00',2.06),('3355','2013-08-03','12:40:00',2.05),('3355','2013-08-03','12:45:00',2.07),('3355','2013-08-03','12:50:00',2.06),('3355','2013-08-03','12:55:00',2.05),('3355','2013-08-03','13:00:00',2.07),('3355','2013-08-03','13:05:00',2.04),('3355','2013-08-03','13:10:00',2.05),('3355','2013-08-03','13:15:00',2.06),('3355','2013-08-03','13:20:00',2.04),('3355','2013-08-03','13:25:00',2.03),('3355','2013-08-03','13:30:00',2.02),('3355','2013-08-03','13:35:00',1.99),('3355','2013-08-03','13:40:00',2.03),('3355','2013-08-03','13:45:00',2.06),('3355','2013-08-03','13:50:00',2.06),('3355','2013-08-03','13:55:00',2.06),('3355','2013-08-03','14:00:00',2.06),('3355','2013-08-03','14:05:00',2.05),('3355','2013-08-03','14:10:00',1.99),('3355','2013-08-03','14:15:00',1.97),('3355','2013-08-03','14:20:00',2),('3355','2013-08-03','14:25:00',1.98),('3355','2013-08-03','14:30:00',1.98),('3355','2013-08-03','14:35:00',2.03),('3355','2013-08-03','14:40:00',2),('3355','2013-08-03','14:45:00',2.02),('3355','2013-08-03','14:50:00',2.01),('3355','2013-08-03','14:55:00',2),('3355','2013-08-03','15:00:00',1.99),('3355','2013-08-03','15:05:00',1.95),('3355','2013-08-03','15:10:00',1.94),('3355','2013-08-03','15:15:00',1.92),('3355','2013-08-03','15:20:00',1.92),('3355','2013-08-03','15:25:00',1.91),('3355','2013-08-03','15:30:00',1.91),('3355','2013-08-03','15:35:00',1.89),('3355','2013-08-03','15:40:00',1.86),('3355','2013-08-03','15:45:00',1.84),('3355','2013-08-03','15:50:00',1.82),('3355','2013-08-03','15:55:00',1.79),('3355','2013-08-03','16:00:00',1.75),('3355','2013-08-03','16:05:00',1.72),('3355','2013-08-03','16:10:00',1.68),('3355','2013-08-03','16:15:00',1.65),('3355','2013-08-03','16:20:00',1.62),('3355','2013-08-03','16:25:00',1.59),('3355','2013-08-03','16:30:00',1.57),('3355','2013-08-03','16:35:00',1.54),('3355','2013-08-03','16:40:00',1.51),('3355','2013-08-03','16:45:00',1.48),('3355','2013-08-03','16:50:00',1.45),('3355','2013-08-03','16:55:00',1.42),('3355','2013-08-03','17:00:00',1.34),('3355','2013-08-03','17:05:00',1.33),('3355','2013-08-03','17:10:00',1.3),('3355','2013-08-03','17:15:00',1.25),('3355','2013-08-03','17:20:00',1.22),('3355','2013-08-03','17:25:00',1.17),('3355','2013-08-03','17:30:00',1.13),('3355','2013-08-03','17:35:00',1.1),('3355','2013-08-03','17:40:00',1.05),('3355','2013-08-03','17:45:00',1),('3355','2013-08-02','09:00:00',1.01),('3355','2013-08-02','09:05:00',1.05),('3355','2013-08-02','09:10:00',1.1),('3355','2013-08-02','09:15:00',1.14),('3355','2013-08-02','09:20:00',1.18),('3355','2013-08-02','09:25:00',1.23),('3355','2013-08-02','09:30:00',1.27),('3355','2013-08-02','09:35:00',1.31),('3355','2013-08-02','09:40:00',1.34),('3355','2013-08-02','09:45:00',1.38),('3355','2013-08-02','09:50:00',1.41),('3355','2013-08-02','09:55:00',1.45),('3355','2013-08-02','10:00:00',1.48),('3355','2013-08-02','10:05:00',1.51),('3355','2013-08-02','10:10:00',1.55),('3355','2013-08-02','10:15:00',1.58),('3355','2013-08-02','10:20:00',1.61),('3355','2013-08-02','10:25:00',1.64),('3355','2013-08-02','10:30:00',1.67),('3355','2013-08-02','10:35:00',1.7),('3355','2013-08-02','10:40:00',1.72),('3355','2013-08-02','10:45:00',1.75),('3355','2013-08-02','10:50:00',1.77),('3355','2013-08-02','10:55:00',1.8),('3355','2013-08-02','11:00:00',1.82),('3355','2013-08-02','11:05:00',1.84),('3355','2013-08-02','11:10:00',1.85),('3355','2013-08-02','11:15:00',1.88),('3355','2013-08-02','11:20:00',1.91),('3355','2013-08-02','11:25:00',1.93),('3355','2013-08-02','11:30:00',1.94),('3355','2013-08-02','11:35:00',1.95),('3355','2013-08-02','11:40:00',1.97),('3355','2013-08-02','11:45:00',1.98),('3355','2013-08-02','11:50:00',2),('3355','2013-08-02','11:55:00',2.02),('3355','2013-08-02','12:00:00',2.04),('3355','2013-08-02','12:05:00',2.04),('3355','2013-08-02','12:10:00',2.06),('3355','2013-08-02','12:15:00',2.06),('3355','2013-08-02','12:20:00',2.07),('3355','2013-08-02','12:25:00',2.08),('3355','2013-08-02','12:30:00',2.08),('3355','2013-08-02','12:35:00',2.1),('3355','2013-08-02','12:40:00',2.09),('3355','2013-08-02','12:45:00',2.1),('3355','2013-08-02','12:50:00',2.08),('3355','2013-08-02','12:55:00',2.09),('3355','2013-08-02','13:00:00',2.09),('3355','2013-08-02','13:05:00',2.13),('3355','2013-08-02','13:10:00',2.15),('3355','2013-08-02','13:15:00',2.16),('3355','2013-08-02','13:20:00',2.11),('3355','2013-08-02','13:25:00',2.12),('3355','2013-08-02','13:30:00',2.11),('3355','2013-08-02','13:35:00',2.12),('3355','2013-08-02','13:40:00',2.1),('3355','2013-08-02','13:45:00',2.11),('3355','2013-08-02','13:50:00',2.11),('3355','2013-08-02','13:55:00',2.1),('3355','2013-08-02','14:00:00',2.11),('3355','2013-08-02','14:05:00',2.1),('3355','2013-08-02','14:10:00',2.08),('3355','2013-08-02','14:15:00',2.06),('3355','2013-08-02','14:20:00',2.05),('3355','2013-08-02','14:25:00',2.02),('3355','2013-08-02','14:30:00',2.03),('3355','2013-08-02','14:35:00',2.04),('3355','2013-08-02','14:40:00',2.06),('3355','2013-08-02','14:45:00',2.04),('3355','2013-08-02','14:50:00',2.04),('3355','2013-08-02','14:55:00',2.03),('3355','2013-08-02','15:00:00',2.02),('3355','2013-08-02','15:05:00',2.02),('3355','2013-08-02','15:10:00',1.99),('3355','2013-08-02','15:15:00',1.95),('3355','2013-08-02','15:20:00',1.97),('3355','2013-08-02','15:25:00',1.96),('3355','2013-08-02','15:30:00',1.94),('3355','2013-08-02','15:35:00',1.92),('3355','2013-08-02','15:40:00',1.9),('3355','2013-08-02','15:45:00',1.88),('3355','2013-08-02','15:50:00',1.84),('3355','2013-08-02','15:55:00',1.81),('3355','2013-08-02','16:00:00',1.79),('3355','2013-08-02','16:05:00',1.77),('3355','2013-08-02','16:10:00',1.75),('3355','2013-08-02','16:15:00',1.72),('3355','2013-08-02','16:20:00',1.68),('3355','2013-08-02','16:25:00',1.63),('3355','2013-08-02','16:30:00',1.62),('3355','2013-08-02','16:35:00',1.6),('3355','2013-08-02','16:40:00',1.56),('3355','2013-08-02','16:45:00',1.53),('3355','2013-08-02','16:50:00',1.5),('3355','2013-08-02','16:55:00',1.46),('3355','2013-08-02','17:00:00',1.42),('3355','2013-08-02','17:05:00',1.37),('3355','2013-08-02','17:10:00',1.33),('3355','2013-08-02','17:15:00',1.3),('3355','2013-08-02','17:20:00',1.27),('3355','2013-08-02','17:25:00',1.23),('3355','2013-08-02','17:30:00',1.18),('3355','2013-08-02','17:35:00',1.13),('3355','2013-08-02','17:40:00',1.09),('3355','2013-08-02','17:45:00',1.04),('3355','2013-08-01','09:00:00',1.03),('3355','2013-08-01','09:05:00',1.08),('3355','2013-08-01','09:10:00',1.13),('3355','2013-08-01','09:15:00',1.18),('3355','2013-08-01','09:20:00',1.22),('3355','2013-08-01','09:25:00',1.26),('3355','2013-08-01','09:30:00',1.3),('3355','2013-08-01','09:35:00',1.35),('3355','2013-08-01','09:40:00',1.39),('3355','2013-08-01','09:45:00',1.43),('3355','2013-08-01','09:50:00',1.47),('3355','2013-08-01','09:55:00',1.5),('3355','2013-08-01','10:00:00',1.53),('3355','2013-08-01','10:05:00',1.56),('3355','2013-08-01','10:10:00',1.6),('3355','2013-08-01','10:15:00',1.63),('3355','2013-08-01','10:20:00',1.67),('3355','2013-08-01','10:25:00',1.7),('3355','2013-08-01','10:30:00',1.73),('3355','2013-08-01','10:35:00',1.75),('3355','2013-08-01','10:40:00',1.77),('3355','2013-08-01','10:45:00',1.81),('3355','2013-08-01','10:50:00',1.83),('3355','2013-08-01','10:55:00',1.86),('3355','2013-08-01','11:00:00',1.88),('3355','2013-08-01','11:05:00',1.92),('3355','2013-08-01','11:10:00',1.95),('3355','2013-08-01','11:15:00',1.98),('3355','2013-08-01','11:20:00',2),('3355','2013-08-01','11:25:00',2.02),('3355','2013-08-01','11:30:00',2.03),('3355','2013-08-01','11:35:00',2.06),('3355','2013-08-01','11:40:00',2.07),('3355','2013-08-01','11:45:00',2.1),('3355','2013-08-01','11:50:00',2.12),('3355','2013-08-01','11:55:00',2.12),('3355','2013-08-01','12:00:00',2.13),('3355','2013-08-01','12:05:00',2.14),('3355','2013-08-01','12:10:00',2.15),('3355','2013-08-01','12:15:00',2.16),('3355','2013-08-01','12:20:00',2.17),('3355','2013-08-01','12:25:00',2.18),('3355','2013-08-01','12:30:00',2.19),('3355','2013-08-01','12:35:00',2.21),('3355','2013-08-01','12:40:00',2.22),('3355','2013-08-01','12:45:00',2.21),('3355','2013-08-01','12:50:00',2.23),('3355','2013-08-01','12:55:00',2.22),('3355','2013-08-01','13:00:00',2.22),('3355','2013-08-01','13:05:00',2.24),('3355','2013-08-01','13:10:00',2.24),('3355','2013-08-01','13:15:00',2.1),('3355','2013-08-01','13:20:00',2.26),('3355','2013-08-01','13:25:00',2.25),('3355','2013-08-01','13:30:00',2.24),('3355','2013-08-01','13:35:00',2.11),('3355','2013-08-01','13:40:00',2.24),('3355','2013-08-01','13:45:00',2.07),('3355','2013-08-01','13:50:00',2.28),('3355','2013-08-01','13:55:00',2.19),('3355','2013-08-01','14:00:00',2.13),('3355','2013-08-01','14:05:00',2.2),('3355','2013-08-01','14:10:00',2.12),('3355','2013-08-01','14:15:00',2.01),('3355','2013-08-01','14:20:00',2.11),('3355','2013-08-01','14:25:00',2.14),('3355','2013-08-01','14:30:00',2.15),('3355','2013-08-01','14:35:00',1.65),('3355','2013-08-01','14:40:00',2.15),('3355','2013-08-01','14:45:00',2.15),('3355','2013-08-01','14:50:00',2.1),('3355','2013-08-01','14:55:00',2.09),('3355','2013-08-01','15:00:00',2.05),('3355','2013-08-01','15:05:00',2),('3355','2013-08-01','15:10:00',2.07),('3355','2013-08-01','15:15:00',1.6),('3355','2013-08-01','15:20:00',1.28),('3355','2013-08-01','15:25:00',2.04),('3355','2013-08-01','15:30:00',1.99),('3355','2013-08-01','15:35:00',1.99),('3355','2013-08-01','15:40:00',1.16),('3355','2013-08-01','15:45:00',1.9),('3355','2013-08-01','15:50:00',1.89),('3355','2013-08-01','15:55:00',1.89),('3355','2013-08-01','16:00:00',1.87),('3355','2013-08-01','16:05:00',1.82),('3355','2013-08-01','16:10:00',1.78),('3355','2013-08-01','16:15:00',1.76),('3355','2013-08-01','16:20:00',1.73),('3355','2013-08-01','16:25:00',1.7),('3355','2013-08-01','16:30:00',1.66),('3355','2013-08-01','16:35:00',1.64),('3355','2013-08-01','16:40:00',1.6),('3355','2013-08-01','16:45:00',1.56),('3355','2013-08-01','16:50:00',1.53),('3355','2013-08-01','16:55:00',1.5),('3355','2013-08-01','17:00:00',1.45),('3355','2013-08-01','17:05:00',1.42),('3355','2013-08-01','17:10:00',1.38),('3355','2013-08-01','17:15:00',1.34),('3355','2013-08-01','17:20:00',1.29),('3355','2013-08-01','17:25:00',1.25),('3355','2013-08-01','17:30:00',1.21),('3355','2013-08-01','17:35:00',1.17),('3355','2013-08-01','17:40:00',1.13),('3355','2013-08-01','17:45:00',1.08),('3355','2013-08-01','17:50:00',1.03),('3355','2013-07-31','08:55:00',1.01),('3355','2013-07-31','09:00:00',1.05),('3355','2013-07-31','09:05:00',1.1),('3355','2013-07-31','09:10:00',1.14),('3355','2013-07-31','09:15:00',1.19),('3355','2013-07-31','09:20:00',1.23),('3355','2013-07-31','09:25:00',1.27),('3355','2013-07-31','09:30:00',1.31),('3355','2013-07-31','09:35:00',1.35),('3355','2013-07-31','09:40:00',1.39),('3355','2013-07-31','09:45:00',1.44),('3355','2013-07-31','09:50:00',1.48),('3355','2013-07-31','09:55:00',1.51),('3355','2013-07-31','10:00:00',1.55),('3355','2013-07-31','10:05:00',1.58),('3355','2013-07-31','10:10:00',1.6),('3355','2013-07-31','10:15:00',1.63),('3355','2013-07-31','10:20:00',1.67),('3355','2013-07-31','10:25:00',1.71),('3355','2013-07-31','10:30:00',1.74),('3355','2013-07-31','10:35:00',1.78),('3355','2013-07-31','10:40:00',1.82),('3355','2013-07-31','10:45:00',1.85),('3355','2013-07-31','10:50:00',1.89),('3355','2013-07-31','10:55:00',1.91),('3355','2013-07-31','11:00:00',1.93),('3355','2013-07-31','11:05:00',1.95),('3355','2013-07-31','11:10:00',1.97),('3355','2013-07-31','11:15:00',1.99),('3355','2013-07-31','11:20:00',2),('3355','2013-07-31','11:25:00',2.02),('3355','2013-07-31','11:30:00',2.04),('3355','2013-07-31','11:35:00',2.06),('3355','2013-07-31','11:40:00',2.08),('3355','2013-07-31','11:45:00',2.11),('3355','2013-07-31','11:50:00',2.12),('3355','2013-07-31','11:55:00',2.14),('3355','2013-07-31','12:00:00',2.16),('3355','2013-07-31','12:05:00',2.16),('3355','2013-07-31','12:10:00',2.17),('3355','2013-07-31','12:15:00',2.2),('3355','2013-07-31','12:20:00',2.21),('3355','2013-07-31','12:25:00',2.22),('3355','2013-07-31','12:30:00',2.22),('3355','2013-07-31','12:35:00',2.21),('3355','2013-07-31','12:40:00',2.23),('3355','2013-07-31','12:45:00',2.08),('3355','2013-07-31','12:50:00',1.83),('3355','2013-07-31','12:55:00',2.26),('3355','2013-07-31','13:05:00',2.38),('3355','2013-07-31','13:10:00',2.29),('3355','2013-07-31','13:15:00',2.27),('3355','2013-07-31','13:20:00',2.15),('3355','2013-07-31','13:25:00',1.9),('3355','2013-07-31','13:30:00',1.97),('3355','2013-07-31','13:35:00',2.12),('3355','2013-07-31','13:40:00',2.11),('3355','2013-07-31','13:45:00',2.24),('3355','2013-07-31','13:50:00',1.84),('3355','2013-07-31','13:55:00',1.39),('3355','2013-07-31','14:00:00',1.63),('3355','2013-07-31','14:05:00',2.33),('3355','2013-07-31','14:10:00',2.3),('3355','2013-07-31','14:15:00',2.26),('3355','2013-07-31','14:20:00',2.29),('3355','2013-07-31','14:25:00',2.23),('3355','2013-07-31','14:30:00',2.19),('3355','2013-07-31','14:35:00',2.17),('3355','2013-07-31','14:40:00',2.2),('3355','2013-07-31','14:45:00',2.18),('3355','2013-07-31','14:50:00',1.18),('3355','2013-07-31','15:05:00',2.22),('3355','2013-07-31','15:10:00',2.13),('3355','2013-07-31','15:15:00',1.56),('3355','2013-07-31','15:20:00',2.13),('3355','2013-07-31','15:25:00',1.86),('3355','2013-07-31','15:30:00',2.04),('3355','2013-07-31','15:35:00',1.85),('3355','2013-07-31','15:40:00',1.33),('3355','2013-07-31','15:45:00',1.95),('3355','2013-07-31','15:50:00',1.91),('3355','2013-07-31','15:55:00',1.86),('3355','2013-07-31','16:00:00',1.83),('3355','2013-07-31','16:05:00',1.84),('3355','2013-07-31','16:10:00',1.82),('3355','2013-07-31','16:15:00',1.79),('3355','2013-07-31','16:20:00',1.78),('3355','2013-07-31','16:25:00',1.53),('3355','2013-07-31','16:30:00',1.15),('3355','2013-07-31','16:40:00',1.62),('3355','2013-07-31','16:45:00',1.56),('3355','2013-07-31','16:50:00',1.54),('3355','2013-07-31','16:55:00',1.49),('3355','2013-07-31','17:00:00',1.47),('3355','2013-07-31','17:05:00',1.42),('3355','2013-07-31','17:10:00',1.34),('3355','2013-07-31','17:15:00',1),('3355','2013-07-31','17:20:00',1.28),('3355','2013-07-31','17:25:00',1.25),('3355','2013-07-31','17:30:00',1.19),('3355','2013-07-31','17:35:00',1.14),('3355','2013-07-31','17:40:00',1.11),('3355','2013-07-31','17:45:00',1.04),('3355','2013-07-31','17:50:00',1.02),('3355','2014-04-08','09:10:00',1),('3355','2014-04-08','09:15:00',1.06),('3355','2014-04-08','09:20:00',1.1),('3355','2014-04-08','09:25:00',1.16),('3355','2014-04-08','09:30:00',1.21),('3355','2014-04-08','09:35:00',1.24),('3355','2014-04-08','09:40:00',1.27),('3355','2014-04-08','09:45:00',1.31),('3355','2014-04-08','09:50:00',1.36),('3355','2014-04-08','09:55:00',1.37),('3355','2014-04-08','10:00:00',1.41),('3355','2014-04-08','10:05:00',1.43),('3355','2014-04-08','10:10:00',1.45),('3355','2014-04-08','10:15:00',1.55),('3355','2014-04-08','10:20:00',1.6),('3355','2014-04-08','10:25:00',1.63),('3355','2014-04-08','10:30:00',1.63),('3355','2014-04-08','10:35:00',1.67),('3355','2014-04-08','10:40:00',1.73),('3355','2014-04-08','10:45:00',1.77),('3355','2014-04-08','10:50:00',1.8),('3355','2014-04-08','10:55:00',1.84),('3355','2014-04-08','11:00:00',1.85),('3355','2014-04-08','11:05:00',1.89),('3355','2014-04-08','11:10:00',1.89),('3355','2014-04-08','11:15:00',1.91),('3355','2014-04-08','11:20:00',1.95),('3355','2014-04-08','11:25:00',1.76),('3355','2014-04-08','11:30:00',1.94),('3355','2014-04-08','11:35:00',1.93),('3355','2014-04-08','11:40:00',1.98),('3355','2014-04-08','11:45:00',2.03),('3355','2014-04-08','11:50:00',2.02),('3355','2014-04-08','11:55:00',2.01),('3355','2014-04-08','12:00:00',2.11),('3355','2014-04-08','12:05:00',2.04),('3355','2014-04-08','12:10:00',1.99),('3355','2014-04-08','12:15:00',1.95),('3355','2014-04-08','12:20:00',1.95),('3355','2014-04-08','12:25:00',1.95),('3355','2014-04-08','12:30:00',2.13),('3355','2014-04-08','12:35:00',2.26),('3355','2014-04-08','12:40:00',1.98),('3355','2014-04-08','12:45:00',1.81),('3355','2014-04-08','12:50:00',2.04),('3355','2014-04-08','12:55:00',2.2),('3355','2014-04-08','13:00:00',2.13),('3355','2014-04-08','13:05:00',2.24),('3355','2014-04-08','13:10:00',2.29),('3355','2014-04-08','13:15:00',2.31),('3355','2014-04-08','13:20:00',2.3),('3355','2014-04-08','13:25:00',2.27),('3355','2014-04-08','13:30:00',2.3),('3355','2014-04-08','13:35:00',2.31),('3355','2014-04-08','13:40:00',2.31),('3355','2014-04-08','13:45:00',2.28),('3355','2014-04-08','13:50:00',2.29),('3355','2014-04-08','13:55:00',2.3),('3355','2014-04-08','14:00:00',2.3),('3355','2014-04-08','14:05:00',2.29),('3355','2014-04-08','14:10:00',2.28),('3355','2014-04-08','14:15:00',2.27),('3355','2014-04-08','14:20:00',2.17),('3355','2014-04-08','14:25:00',2.21),('3355','2014-04-08','14:30:00',2.23),('3355','2014-04-08','14:35:00',2.13),('3355','2014-04-08','14:40:00',2.01),('3355','2014-04-08','14:45:00',1.85),('3355','2014-04-08','14:50:00',2.14),('3355','2014-04-08','14:55:00',2.17),('3355','2014-04-08','15:00:00',2.13),('3355','2014-04-08','15:05:00',2.08),('3355','2014-04-08','15:10:00',2.08),('3355','2014-04-08','15:15:00',2.07),('3355','2014-04-08','15:20:00',2.03),('3355','2014-04-08','15:25:00',2.02),('3355','2014-04-08','15:30:00',1.98),('3355','2014-04-08','15:35:00',1.95),('3355','2014-04-08','15:40:00',1.93),('3355','2014-04-08','15:45:00',1.81),('3355','2014-04-08','15:50:00',1.84),('3355','2014-04-08','15:55:00',1.83),('3355','2014-04-08','16:00:00',1.77),('3355','2014-04-08','16:05:00',1.73),('3355','2014-04-08','16:10:00',1.67),('3355','2014-04-08','16:15:00',1.56),('3355','2014-04-08','16:20:00',1.45),('3355','2014-04-08','16:25:00',1.56),('3355','2014-04-08','16:30:00',1.61),('3355','2014-04-08','16:35:00',1.6),('3355','2014-04-08','16:40:00',1.49),('3355','2014-04-08','16:45:00',1.4),('3355','2014-04-08','16:50:00',1.44),('3355','2014-04-08','16:55:00',1.32),('3355','2014-04-08','17:00:00',1.21),('3355','2014-04-08','17:05:00',1.29),('3355','2014-04-08','17:10:00',1.21),('3355','2014-04-08','17:15:00',1.18),('3355','2014-04-08','17:20:00',1.14),('3355','2014-04-08','17:25:00',1.06),('3355','2013-07-30','09:00:00',1.05),('3355','2013-07-30','09:05:00',1.1),('3355','2013-07-30','09:10:00',1.06),('3355','2013-07-30','09:15:00',1.15),('3355','2013-07-30','09:20:00',1.26),('3355','2013-07-30','09:25:00',1.33),('3355','2013-07-30','09:30:00',1.36),('3355','2013-07-30','09:35:00',1.43),('3355','2013-07-30','09:40:00',1.5),('3355','2013-07-30','09:45:00',1.53),('3355','2013-07-30','09:50:00',1.57),('3355','2013-07-30','09:55:00',1.59),('3355','2013-07-30','10:00:00',1.6),('3355','2013-07-30','10:05:00',1.64),('3355','2013-07-30','10:10:00',1.68),('3355','2013-07-30','10:15:00',1.68),('3355','2013-07-30','10:20:00',1.73),('3355','2013-07-30','10:25:00',1.72),('3355','2013-07-30','10:30:00',1.74),('3355','2013-07-30','10:35:00',1.43),('3355','2013-07-30','10:40:00',1.78),('3355','2013-07-30','10:45:00',1.83),('3355','2013-07-30','10:50:00',1.83),('3355','2013-07-30','10:55:00',1.84),('3355','2013-07-30','11:00:00',1.88),('3355','2013-07-30','11:05:00',1.92),('3355','2013-07-30','11:10:00',1.99),('3355','2013-07-30','11:15:00',2.01),('3355','2013-07-30','11:20:00',1.84),('3355','2013-07-30','11:40:00',2.12),('3355','2013-07-30','11:45:00',2.11),('3355','2013-07-30','11:50:00',2.09),('3355','2013-07-30','11:55:00',2.07),('3355','2013-07-30','12:00:00',2.1),('3355','2013-07-30','12:05:00',2.11),('3355','2013-07-30','12:10:00',2.11),('3355','2013-07-30','12:15:00',2.1),('3355','2013-07-30','12:20:00',2.07),('3355','2013-07-30','12:25:00',2.09),('3355','2013-07-30','12:30:00',2.15),('3355','2013-07-30','12:35:00',2.2),('3355','2013-07-30','12:40:00',2.17),('3355','2013-07-30','12:50:00',2.29),('3355','2013-07-30','12:55:00',2.34),('3355','2013-07-30','13:00:00',2.28),('3355','2013-07-30','13:05:00',1.43),('3355','2013-07-30','13:10:00',1.46),('3355','2013-07-30','13:15:00',1.5),('3355','2013-07-30','13:20:00',2.28),('3355','2013-07-30','13:25:00',2.3),('3355','2013-07-30','13:30:00',2.33),('3355','2013-07-30','13:35:00',2.22),('3355','2013-07-30','13:40:00',2.01),('3355','2013-07-30','13:45:00',2.24),('3355','2013-07-30','13:50:00',2.29),('3355','2013-07-30','13:55:00',2.35),('3355','2013-07-30','14:00:00',2.28),('3355','2013-07-30','14:05:00',2.32),('3355','2013-07-30','14:10:00',1.91),('3355','2013-07-30','14:15:00',2.3),('3355','2013-07-30','14:20:00',2.18),('3355','2013-07-30','14:25:00',2.18),('3355','2013-07-30','14:30:00',2.18),('3355','2013-07-30','14:35:00',2.16),('3355','2013-07-30','14:40:00',2.11),('3355','2013-07-30','14:45:00',2.1),('3355','2013-07-30','14:50:00',2.13),('3355','2013-07-30','14:55:00',2.11),('3355','2013-07-30','15:00:00',2.06),('3355','2013-07-30','15:05:00',2.01),('3355','2013-07-30','15:10:00',1.99),('3355','2013-07-30','15:15:00',1.99),('3355','2013-07-30','15:20:00',1.93),('3355','2013-07-30','15:25:00',1.89),('3355','2013-07-30','15:30:00',1.91),('3355','2013-07-30','15:35:00',1.91),('3355','2013-07-30','15:40:00',1.89),('3355','2013-07-30','15:45:00',1.86),('3355','2013-07-30','15:50:00',1.85),('3355','2013-07-30','15:55:00',1.82),('3355','2013-07-30','16:00:00',1.79),('3355','2013-07-30','16:05:00',1.77),('3355','2013-07-30','16:10:00',1.74),('3355','2013-07-30','16:15:00',1.71),('3355','2013-07-30','16:20:00',1.71),('3355','2013-07-30','16:25:00',1.66),('3355','2013-07-30','16:30:00',1.62),('3355','2013-07-30','16:35:00',1.6),('3355','2013-07-30','16:40:00',1.58),('3355','2013-07-30','16:45:00',1.53),('3355','2013-07-30','16:50:00',1.5),('3355','2013-07-30','16:55:00',1.46),('3355','2013-07-30','17:00:00',1.43),('3355','2013-07-30','17:05:00',1.39),('3355','2013-07-30','17:10:00',1.34),('3355','2013-07-30','17:15:00',1.3),('3355','2013-07-30','17:20:00',1.27),('3355','2013-07-30','17:25:00',1.23),('3355','2013-07-30','17:30:00',1.18),('3355','2013-07-30','17:35:00',1.15),('3355','2013-07-30','17:40:00',1.11),('3355','2013-07-30','17:45:00',1.05),('3355','2013-07-29','09:10:00',1.02),('3355','2013-07-29','09:15:00',1.06),('3355','2013-07-29','09:20:00',1.11),('3355','2013-07-29','09:25:00',1.13),('3355','2013-07-29','09:30:00',1.17),('3355','2013-07-29','09:35:00',1.22),('3355','2013-07-29','09:40:00',1.28),('3355','2013-07-29','09:45:00',1.31),('3355','2013-07-29','09:50:00',1.34),('3355','2013-07-29','09:55:00',1.38),('3355','2013-07-29','10:00:00',1.42),('3355','2013-07-29','10:05:00',1.46),('3355','2013-07-29','10:10:00',1.49),('3355','2013-07-29','10:15:00',1.52),('3355','2013-07-29','10:20:00',1.57),('3355','2013-07-29','10:25:00',1.59),('3355','2013-07-29','10:30:00',1.61),('3355','2013-07-29','10:35:00',1.65),('3355','2013-07-29','10:40:00',1.69),('3355','2013-07-29','10:45:00',1.7),('3355','2013-07-29','10:50:00',1.71),('3355','2013-07-29','10:55:00',1.75),('3355','2013-07-29','11:00:00',1.78),('3355','2013-07-29','11:05:00',1.78),('3355','2013-07-29','11:10:00',1.77),('3355','2013-07-29','11:15:00',1.81),('3355','2013-07-29','11:20:00',1.85),('3355','2013-07-29','11:25:00',1.86),('3355','2013-07-29','11:30:00',1.87),('3355','2013-07-29','11:35:00',1.9),('3355','2013-07-29','11:40:00',1.9),('3355','2013-07-29','11:45:00',1.92),('3355','2013-07-29','11:50:00',1.94),('3355','2013-07-29','11:55:00',1.95),('3355','2013-07-29','12:00:00',1.97),('3355','2013-07-29','12:05:00',1.96),('3355','2013-07-29','12:10:00',1.97),('3355','2013-07-29','12:15:00',1.98),('3355','2013-07-29','12:20:00',2.02),('3355','2013-07-29','12:25:00',2),('3355','2013-07-29','12:30:00',2.03),('3355','2013-07-29','12:35:00',2.05),('3355','2013-07-29','12:40:00',2.06),('3355','2013-07-29','12:45:00',2.06),('3355','2013-07-29','12:50:00',2.06),('3355','2013-07-29','12:55:00',2.03),('3355','2013-07-29','13:00:00',2.03),('3355','2013-07-29','13:05:00',2.07),('3355','2013-07-29','13:10:00',2.08),('3355','2013-07-29','13:15:00',2.08),('3355','2013-07-29','13:20:00',2.09),('3355','2013-07-29','13:25:00',2.12),('3355','2013-07-29','13:30:00',2.15),('3355','2013-07-29','13:35:00',2.15),('3355','2013-07-29','13:40:00',2.15),('3355','2013-07-29','13:45:00',2.16),('3355','2013-07-29','13:50:00',2.16),('3355','2013-07-29','13:55:00',2.16),('3355','2013-07-29','14:00:00',2.15),('3355','2013-07-29','14:05:00',2.15),('3355','2013-07-29','14:10:00',2.14),('3355','2013-07-29','14:15:00',2.14),('3355','2013-07-29','14:20:00',2.14),('3355','2013-07-29','14:25:00',2.11),('3355','2013-07-29','14:30:00',2.1),('3355','2013-07-29','14:35:00',2.1),('3355','2013-07-29','14:40:00',2.08),('3355','2013-07-29','14:45:00',2.07),('3355','2013-07-29','14:50:00',2.04),('3355','2013-07-29','14:55:00',2.03),('3355','2013-07-29','15:00:00',2.03),('3355','2013-07-29','15:05:00',2.02),('3355','2013-07-29','15:10:00',2),('3355','2013-07-29','15:15:00',1.98),('3355','2013-07-29','15:20:00',1.95),('3355','2013-07-29','15:25:00',1.93),('3355','2013-07-29','15:30:00',1.92),('3355','2013-07-29','15:35:00',1.91),('3355','2013-07-29','15:40:00',1.91),('3355','2013-07-29','15:45:00',1.94),('3355','2013-07-29','15:50:00',1.67),('3355','2013-07-29','15:55:00',1.12),('3355','2013-07-29','16:05:00',1.48),('3355','2013-07-29','16:10:00',1.6),('3355','2013-07-29','16:15:00',1.41),('3355','2013-07-29','16:20:00',1.44),('3355','2013-07-29','16:25:00',1.24),('3355','2013-07-29','16:30:00',1.74),('3355','2013-07-29','16:35:00',1.6),('3355','2013-07-29','16:40:00',1.18),('3355','2013-07-29','16:45:00',1.67),('3355','2013-07-29','16:50:00',1.58),('3355','2013-07-29','16:55:00',1.02),('3355','2013-07-29','17:20:00',1.15),('3355','2013-07-29','17:25:00',1.23),('3355','2013-07-29','17:45:00',1.08),('3355','2013-07-29','17:50:00',1.01),('3355','2013-07-28','09:05:00',1.01),('3355','2013-07-28','09:10:00',1.06),('3355','2013-07-28','09:15:00',1.1),('3355','2013-07-28','09:20:00',1.14),('3355','2013-07-28','09:25:00',1.17),('3355','2013-07-28','09:30:00',1.23),('3355','2013-07-28','09:35:00',1.27),('3355','2013-07-28','09:40:00',1.28),('3355','2013-07-28','09:45:00',1.32),('3355','2013-07-28','09:50:00',1.35),('3355','2013-07-28','09:55:00',1.39),('3355','2013-07-28','10:00:00',1.43),('3355','2013-07-28','10:05:00',1.45),('3355','2013-07-28','10:10:00',1.5),('3355','2013-07-28','10:15:00',1.52),('3355','2013-07-28','10:20:00',1.54),('3355','2013-07-28','10:25:00',1.56),('3355','2013-07-28','10:30:00',1.59),('3355','2013-07-28','10:35:00',1.64),('3355','2013-07-28','10:40:00',1.67),('3355','2013-07-28','10:45:00',1.69),('3355','2013-07-28','10:50:00',1.72),('3355','2013-07-28','10:55:00',1.74),('3355','2013-07-28','11:00:00',1.78),('3355','2013-07-28','11:05:00',1.8),('3355','2013-07-28','11:10:00',1.82),('3355','2013-07-28','11:15:00',1.84),('3355','2013-07-28','11:20:00',1.85),('3355','2013-07-28','11:25:00',1.86),('3355','2013-07-28','11:30:00',1.88),('3355','2013-07-28','11:35:00',1.88),('3355','2013-07-28','11:40:00',1.9),('3355','2013-07-28','11:45:00',1.91),('3355','2013-07-28','11:50:00',1.91),('3355','2013-07-28','11:55:00',1.96),('3355','2013-07-28','12:00:00',1.97),('3355','2013-07-28','12:05:00',2.02),('3355','2013-07-28','12:10:00',2),('3355','2013-07-28','12:15:00',1.98),('3355','2013-07-28','12:20:00',1.99),('3355','2013-07-28','12:25:00',1.99),('3355','2013-07-28','12:30:00',2.03),('3355','2013-07-28','12:35:00',2.08),('3355','2013-07-28','12:40:00',2.09),('3355','2013-07-28','12:45:00',2.09),('3355','2013-07-28','12:50:00',2.05),('3355','2013-07-28','12:55:00',2.03),('3355','2013-07-28','13:00:00',2.05),('3355','2013-07-28','13:05:00',2.02),('3355','2013-07-28','13:10:00',2.04),('3355','2013-07-28','13:15:00',2.13),('3355','2013-07-28','13:20:00',2.14),('3355','2013-07-28','13:25:00',2.09),('3355','2013-07-28','13:30:00',2.11),('3355','2013-07-28','13:35:00',2.16),('3355','2013-07-28','13:40:00',2.15),('3355','2013-07-28','13:45:00',2.12),('3355','2013-07-28','13:50:00',2.13),('3355','2013-07-28','13:55:00',2.11),('3355','2013-07-28','14:00:00',2.1),('3355','2013-07-28','14:05:00',2.1),('3355','2013-07-28','14:10:00',2.09),('3355','2013-07-28','14:15:00',2.09),('3355','2013-07-28','14:20:00',2.09),('3355','2013-07-28','14:25:00',2.07),('3355','2013-07-28','14:30:00',2.06),('3355','2013-07-28','14:35:00',2.05),('3355','2013-07-28','14:40:00',2.04),('3355','2013-07-28','14:45:00',2.03),('3355','2013-07-28','14:50:00',2.01),('3355','2013-07-28','14:55:00',2),('3355','2013-07-28','15:00:00',1.97),('3355','2013-07-28','15:05:00',1.96),('3355','2013-07-28','15:10:00',1.95),('3355','2013-07-28','15:15:00',1.95),('3355','2013-07-28','15:20:00',1.9),('3355','2013-07-28','15:25:00',1.89),('3355','2013-07-28','15:30:00',1.88),('3355','2013-07-28','15:35:00',1.84),('3355','2013-07-28','15:40:00',1.83),('3355','2013-07-28','15:45:00',1.84),('3355','2013-07-28','15:50:00',1.81),('3355','2013-07-28','15:55:00',1.78),('3355','2013-07-28','16:00:00',1.76),('3355','2013-07-28','16:05:00',1.75),('3355','2013-07-28','16:10:00',1.74),('3355','2013-07-28','16:15:00',1.71),('3355','2013-07-28','16:20:00',1.68),('3355','2013-07-28','16:25:00',1.67),('3355','2013-07-28','16:30:00',1.64),('3355','2013-07-28','16:35:00',1.61),('3355','2013-07-28','16:40:00',1.57),('3355','2013-07-28','16:45:00',1.54),('3355','2013-07-28','16:50:00',1.51),('3355','2013-07-28','16:55:00',1.47),('3355','2013-07-28','17:00:00',1.43),('3355','2013-07-28','17:05:00',1.39),('3355','2013-07-28','17:10:00',1.35),('3355','2013-07-28','17:15:00',1.32),('3355','2013-07-28','17:20:00',1.29),('3355','2013-07-28','17:25:00',1.24),('3355','2013-07-28','17:30:00',1.2),('3355','2013-07-28','17:35:00',1.15),('3355','2013-07-28','17:40:00',1.11),('3355','2013-07-28','17:45:00',1.08),('3355','2013-07-28','17:50:00',1.02),('3355','2013-07-27','09:05:00',1.03),('3355','2013-07-27','09:10:00',1.08),('3355','2013-07-27','09:15:00',1.13),('3355','2013-07-27','09:20:00',1.16),('3355','2013-07-27','09:25:00',1.21),('3355','2013-07-27','09:30:00',1.25),('3355','2013-07-27','09:35:00',1.28),('3355','2013-07-27','09:40:00',1.32),('3355','2013-07-27','09:45:00',1.36),('3355','2013-07-27','09:50:00',1.4),('3355','2013-07-27','09:55:00',1.44),('3355','2013-07-27','10:00:00',1.48),('3355','2013-07-27','10:05:00',1.51),('3355','2013-07-27','10:10:00',1.54),('3355','2013-07-27','10:15:00',1.57),('3355','2013-07-27','10:20:00',1.6),('3355','2013-07-27','10:25:00',1.63),('3355','2013-07-27','10:30:00',1.66),('3355','2013-07-27','10:35:00',1.68),('3355','2013-07-27','10:40:00',1.72),('3355','2013-07-27','10:45:00',1.73),('3355','2013-07-27','10:50:00',1.76),('3355','2013-07-27','10:55:00',1.78),('3355','2013-07-27','11:00:00',1.79),('3355','2013-07-27','11:05:00',1.81),('3355','2013-07-27','11:10:00',1.82),('3355','2013-07-27','11:15:00',1.83),('3355','2013-07-27','11:20:00',1.89),('3355','2013-07-27','11:25:00',1.92),('3355','2013-07-27','11:30:00',1.94),('3355','2013-07-27','11:35:00',1.95),('3355','2013-07-27','11:40:00',1.95),('3355','2013-07-27','11:45:00',1.97),('3355','2013-07-27','11:50:00',1.98),('3355','2013-07-27','11:55:00',1.99),('3355','2013-07-27','12:00:00',2.01),('3355','2013-07-27','12:05:00',2.03),('3355','2013-07-27','12:10:00',2.04),('3355','2013-07-27','12:15:00',2.06),('3355','2013-07-27','12:20:00',2.07),('3355','2013-07-27','12:25:00',2.05),('3355','2013-07-27','12:30:00',2.02),('3355','2013-07-27','12:35:00',2.01),('3355','2013-07-27','12:40:00',2.02),('3355','2013-07-27','12:45:00',2.06),('3355','2013-07-27','12:50:00',2.03),('3355','2013-07-27','12:55:00',2.08),('3355','2013-07-27','13:00:00',2.1),('3355','2013-07-27','13:05:00',2.14),('3355','2013-07-27','13:10:00',2.15),('3355','2013-07-27','13:15:00',2.13),('3355','2013-07-27','13:20:00',2.1),('3355','2013-07-27','13:25:00',2.17),('3355','2013-07-27','13:30:00',2.16),('3355','2013-07-27','13:35:00',2.11),('3355','2013-07-27','13:40:00',2.19),('3355','2013-07-27','13:45:00',2.22),('3355','2013-07-27','13:50:00',2.2),('3355','2013-07-27','13:55:00',2.18),('3355','2013-07-27','14:00:00',1.99),('3355','2013-07-27','14:05:00',2.14),('3355','2013-07-27','14:10:00',2.17),('3355','2013-07-27','14:15:00',2.07),('3355','2013-07-27','14:20:00',2.11),('3355','2013-07-27','14:25:00',2.09),('3355','2013-07-27','14:30:00',2.07),('3355','2013-07-27','14:35:00',2.07),('3355','2013-07-27','14:40:00',2.09),('3355','2013-07-27','14:45:00',2.07),('3355','2013-07-27','14:50:00',2.03),('3355','2013-07-27','14:55:00',2.01),('3355','2013-07-27','15:00:00',2),('3355','2013-07-27','15:05:00',1.98),('3355','2013-07-27','15:10:00',1.98),('3355','2013-07-27','15:15:00',1.96),('3355','2013-07-27','15:20:00',1.96),('3355','2013-07-27','15:25:00',1.93),('3355','2013-07-27','15:30:00',1.92),('3355','2013-07-27','15:35:00',1.91),('3355','2013-07-27','15:40:00',1.88),('3355','2013-07-27','15:45:00',1.86),('3355','2013-07-27','15:50:00',1.84),('3355','2013-07-27','15:55:00',1.81),('3355','2013-07-27','16:00:00',1.78),('3355','2013-07-27','16:05:00',1.76),('3355','2013-07-27','16:10:00',1.74),('3355','2013-07-27','16:15:00',1.71),('3355','2013-07-27','16:20:00',1.68),('3355','2013-07-27','16:25:00',1.66),('3355','2013-07-27','16:30:00',1.64),('3355','2013-07-27','16:35:00',1.62),('3355','2013-07-27','16:40:00',1.58),('3355','2013-07-27','16:45:00',1.55),('3355','2013-07-27','16:50:00',1.51),('3355','2013-07-27','16:55:00',1.47),('3355','2013-07-27','17:00:00',1.42),('3355','2013-07-27','17:05:00',1.38),('3355','2013-07-27','17:10:00',1.35),('3355','2013-07-27','17:15:00',1.31),('3355','2013-07-27','17:20:00',1.28),('3355','2013-07-27','17:25:00',1.24),('3355','2013-07-27','17:30:00',1.2),('3355','2013-07-27','17:35:00',1.15),('3355','2013-07-27','17:40:00',1.1),('3355','2013-07-27','17:45:00',1.05),('3355','2013-07-27','17:50:00',1.02),('3355','2013-07-26','09:05:00',1.02),('3355','2013-07-26','09:10:00',1.06),('3355','2013-07-26','09:15:00',1.1),('3355','2013-07-26','09:20:00',1.12),('3355','2013-07-26','09:25:00',1.18),('3355','2013-07-26','09:30:00',1.23),('3355','2013-07-26','09:35:00',1.27),('3355','2013-07-26','09:40:00',1.3),('3355','2013-07-26','09:45:00',1.34),('3355','2013-07-26','09:50:00',1.36),('3355','2013-07-26','09:55:00',1.37),('3355','2013-07-26','10:00:00',1.43),('3355','2013-07-26','10:05:00',1.47),('3355','2013-07-26','10:10:00',1.49),('3355','2013-07-26','10:15:00',1.49),('3355','2013-07-26','10:20:00',1.55),('3355','2013-07-26','10:25:00',1.58),('3355','2013-07-26','10:30:00',1.63),('3355','2013-07-26','10:35:00',1.66),('3355','2013-07-26','10:40:00',1.69),('3355','2013-07-26','10:45:00',1.73),('3355','2013-07-26','10:50:00',1.74),('3355','2013-07-26','10:55:00',1.77),('3355','2013-07-26','11:00:00',1.78),('3355','2013-07-26','11:05:00',1.76),('3355','2013-07-26','11:10:00',1.66),('3355','2013-07-26','11:15:00',1.82),('3355','2013-07-26','11:20:00',1.85),('3355','2013-07-26','11:25:00',1.9),('3355','2013-07-26','11:30:00',1.93),('3355','2013-07-26','11:35:00',1.89),('3355','2013-07-26','11:40:00',1.29),('3355','2013-07-26','11:45:00',1.86),('3355','2013-07-26','11:50:00',2.02),('3355','2013-07-26','11:55:00',2.05),('3355','2013-07-26','12:00:00',2.02),('3355','2013-07-26','12:05:00',1.68),('3355','2013-07-26','12:15:00',1.86),('3355','2013-07-26','12:25:00',2.09),('3355','2013-07-26','12:30:00',1.91),('3355','2013-07-26','12:35:00',1.07),('3355','2013-07-26','12:40:00',2.23),('3355','2013-07-26','12:45:00',1.33),('3355','2013-07-26','12:50:00',1.51),('3355','2013-07-26','12:55:00',2.3),('3355','2013-07-26','13:00:00',1.32),('3355','2013-07-26','13:25:00',2.22),('3355','2013-07-26','13:30:00',2.36),('3355','2013-07-26','13:35:00',2.21),('3355','2013-07-26','13:40:00',2.17),('3355','2013-07-26','13:45:00',2.26),('3355','2013-07-26','13:50:00',2.19),('3355','2013-07-26','13:55:00',2),('3355','2013-07-26','14:00:00',2.2),('3355','2013-07-26','14:05:00',2.19),('3355','2013-07-26','14:10:00',2.19),('3355','2013-07-26','14:15:00',2.24),('3355','2013-07-26','14:20:00',2.2),('3355','2013-07-26','14:25:00',2.2),('3355','2013-07-26','14:30:00',2.12),('3355','2013-07-26','14:35:00',2.11),('3355','2013-07-26','14:40:00',2.14),('3355','2013-07-26','14:45:00',2.08),('3355','2013-07-26','14:50:00',2.09),('3355','2013-07-26','14:55:00',2.04),('3355','2013-07-26','15:00:00',2.06),('3355','2013-07-26','15:05:00',2.03),('3355','2013-07-26','15:10:00',2.01),('3355','2013-07-26','15:15:00',2.01),('3355','2013-07-26','15:20:00',1.97),('3355','2013-07-26','15:25:00',1.93),('3355','2013-07-26','15:30:00',1.92),('3355','2013-07-26','15:35:00',1.93),('3355','2013-07-26','15:40:00',1.91),('3355','2013-07-26','15:45:00',1.9),('3355','2013-07-26','15:50:00',1.88),('3355','2013-07-26','15:55:00',1.83),('3355','2013-07-26','16:00:00',1.8),('3355','2013-07-26','16:05:00',1.79),('3355','2013-07-26','16:10:00',1.75),('3355','2013-07-26','16:15:00',1.72),('3355','2013-07-26','16:20:00',1.71),('3355','2013-07-26','16:25:00',1.68),('3355','2013-07-26','16:30:00',1.65),('3355','2013-07-26','16:35:00',1.61),('3355','2013-07-26','16:40:00',1.58),('3355','2013-07-26','16:45:00',1.55),('3355','2013-07-26','16:50:00',1.5),('3355','2013-07-26','16:55:00',1.46),('3355','2013-07-26','17:00:00',1.43),('3355','2013-07-26','17:05:00',1.39),('3355','2013-07-26','17:10:00',1.35),('3355','2013-07-26','17:15:00',1.3),('3355','2013-07-26','17:20:00',1.26),('3355','2013-07-26','17:25:00',1.23),('3355','2013-07-26','17:30:00',1.16),('3355','2013-07-26','17:35:00',1.13),('3355','2013-07-26','17:40:00',1.09),('3355','2013-07-26','17:45:00',1.04),('3355','2013-07-25','09:05:00',1.04),('3355','2013-07-25','09:10:00',1.09),('3355','2013-07-25','09:15:00',1.15),('3355','2013-07-25','09:20:00',1.23),('3355','2013-07-25','09:40:00',1.21),('3355','2013-07-25','09:45:00',1.57),('3355','2013-07-25','09:50:00',1.03),('3355','2013-07-25','10:20:00',1.73),('3355','2013-07-25','10:25:00',1.77),('3355','2013-07-25','10:30:00',1.79),('3355','2013-07-25','10:35:00',1.79),('3355','2013-07-25','10:40:00',1.52),('3355','2013-07-25','10:45:00',1.63),('3355','2013-07-25','10:50:00',1.27),('3355','2013-07-25','10:55:00',1.5),('3355','2013-07-25','11:00:00',1.1),('3355','2013-07-25','11:10:00',1.2),('3355','2013-07-25','11:15:00',1.99),('3355','2013-07-25','11:20:00',1.96),('3355','2013-07-25','11:25:00',1.97),('3355','2013-07-25','11:30:00',1.92),('3355','2013-07-25','11:35:00',1.98),('3355','2013-07-25','11:40:00',1.85),('3355','2013-07-25','11:45:00',1.95),('3355','2013-07-25','11:50:00',1.88),('3355','2013-07-25','12:00:00',1.84),('3355','2013-07-25','12:05:00',2.17),('3355','2013-07-25','12:15:00',1.43),('3355','2013-07-25','12:20:00',1.28),('3355','2013-07-25','12:25:00',1.05),('3355','2013-07-25','12:35:00',1.5),('3355','2013-07-25','13:05:00',1.7),('3355','2013-07-25','13:10:00',1.39),('3355','2013-07-25','13:15:00',1.67),('3355','2013-07-25','13:20:00',2.24),('3355','2013-07-25','13:25:00',2.27),('3355','2013-07-25','13:30:00',2.3),('3355','2013-07-25','13:35:00',2.23),('3355','2013-07-25','13:40:00',2.21),('3355','2013-07-25','13:45:00',2.2),('3355','2013-07-25','13:50:00',2.22),('3355','2013-07-25','13:55:00',2.19),('3355','2013-07-25','14:00:00',2.2),('3355','2013-07-25','14:05:00',2.2),('3355','2013-07-25','14:10:00',2.23),('3355','2013-07-25','14:15:00',2.24),('3355','2013-07-25','14:20:00',2.24),('3355','2013-07-25','14:25:00',2.24),('3355','2013-07-25','14:30:00',2.2),('3355','2013-07-25','14:35:00',2.2),('3355','2013-07-25','14:40:00',2.17),('3355','2013-07-25','14:45:00',2.17),('3355','2013-07-25','14:50:00',2.16),('3355','2013-07-25','14:55:00',2.15),('3355','2013-07-25','15:00:00',2.14),('3355','2013-07-25','15:05:00',2.13),('3355','2013-07-25','15:10:00',2.09),('3355','2013-07-25','15:15:00',2.06),('3355','2013-07-25','15:20:00',2.05),('3355','2013-07-25','15:25:00',2.03),('3355','2013-07-25','15:30:00',2.03),('3355','2013-07-25','15:35:00',2),('3355','2013-07-25','15:40:00',1.98),('3355','2013-07-25','15:45:00',1.97),('3355','2013-07-25','15:50:00',1.93),('3355','2013-07-25','15:55:00',1.9),('3355','2013-07-25','16:00:00',1.88),('3355','2013-07-25','16:05:00',1.86),('3355','2013-07-25','16:10:00',1.83),('3355','2013-07-25','16:15:00',1.8),('3355','2013-07-25','16:20:00',1.77),('3355','2013-07-25','16:25:00',1.74),('3355','2013-07-25','16:30:00',1.7),('3355','2013-07-25','16:35:00',1.66),('3355','2013-07-25','16:40:00',1.64),('3355','2013-07-25','16:45:00',1.61),('3355','2013-07-25','16:50:00',1.58),('3355','2013-07-25','16:55:00',1.54),('3355','2013-07-25','17:00:00',1.49),('3355','2013-07-25','17:05:00',1.48),('3355','2013-07-25','17:10:00',1.42),('3355','2013-07-25','17:15:00',1.38),('3355','2013-07-25','17:20:00',1.34),('3355','2013-07-25','17:25:00',1.29),('3355','2013-07-25','17:30:00',1.26),('3355','2013-07-25','17:35:00',1.22),('3355','2013-07-25','17:40:00',1.17),('3355','2013-07-25','17:45:00',1.14),('3355','2013-07-25','17:50:00',1.07),('3355','2013-07-25','17:55:00',1.02),('3355','2013-07-24','09:05:00',1.11),('3355','2013-07-24','09:10:00',1.23),('3355','2013-07-24','09:35:00',1.31),('3355','2013-07-24','09:40:00',1.14),('3355','2013-07-24','09:45:00',1.01),('3355','2013-07-24','10:25:00',1.01),('3355','2013-07-24','10:30:00',1.66),('3355','2013-07-24','10:35:00',1.72),('3355','2013-07-24','10:40:00',1.87),('3355','2013-07-24','10:45:00',1.99),('3355','2013-07-24','10:55:00',1.35),('3355','2013-07-24','11:00:00',1.6),('3355','2013-07-24','11:05:00',1.12),('3355','2013-07-24','11:10:00',2.01),('3355','2013-07-24','11:15:00',1.67),('3355','2013-07-24','11:20:00',1.32),('3355','2013-07-24','11:25:00',1.95),('3355','2013-07-24','11:30:00',2.06),('3355','2013-07-24','11:35:00',2.09),('3355','2013-07-24','11:40:00',2.06),('3355','2013-07-24','11:45:00',2.04),('3355','2013-07-24','11:50:00',2.02),('3355','2013-07-24','11:55:00',2.08),('3355','2013-07-24','12:00:00',2.16),('3355','2013-07-24','12:05:00',1.81),('3355','2013-07-24','12:15:00',1.12),('3355','2013-07-24','12:20:00',1.7),('3355','2013-07-24','12:25:00',1.37),('3355','2013-07-24','12:45:00',1.08),('3355','2013-07-24','12:50:00',1.23),('3355','2013-07-24','13:00:00',1.05),('3355','2013-07-24','13:05:00',2.44),('3355','2013-07-24','13:10:00',2.34),('3355','2013-07-24','13:15:00',2.22),('3355','2013-07-24','13:20:00',1.07),('3355','2013-07-24','13:35:00',1.51),('3355','2013-07-24','13:55:00',2.1),('3355','2013-07-24','14:00:00',1.27),('3355','2013-07-24','14:05:00',2.34),('3355','2013-07-24','14:10:00',1.39),('3355','2013-07-24','14:15:00',2.4),('3355','2013-07-24','14:20:00',2.07),('3355','2013-07-24','14:25:00',1.85),('3355','2013-07-24','14:30:00',2.03),('3355','2013-07-24','14:35:00',1.61),('3355','2013-07-24','14:40:00',2.26),('3355','2013-07-24','14:45:00',2.29),('3355','2013-07-24','14:50:00',2.27),('3355','2013-07-24','14:55:00',2.23),('3355','2013-07-24','15:00:00',2.18),('3355','2013-07-24','15:05:00',2.18),('3355','2013-07-24','15:10:00',2.13),('3355','2013-07-24','15:15:00',2.12),('3355','2013-07-24','15:20:00',2.11),('3355','2013-07-24','15:25:00',2.1),('3355','2013-07-24','15:30:00',1.98),('3355','2013-07-24','15:35:00',1.92),('3355','2013-07-24','15:40:00',1.99),('3355','2013-07-24','15:45:00',1.93),('3355','2013-07-24','15:50:00',1.9),('3355','2013-07-24','15:55:00',1.89),('3355','2013-07-24','16:00:00',1.89),('3355','2013-07-24','16:05:00',1.84),('3355','2013-07-24','16:10:00',1.79),('3355','2013-07-24','16:15:00',1.8),('3355','2013-07-24','16:20:00',1.84),('3355','2013-07-24','16:25:00',1.8),('3355','2013-07-24','16:30:00',1.76),('3355','2013-07-24','16:35:00',1.73),('3355','2013-07-24','16:40:00',1.69),('3355','2013-07-24','16:45:00',1.63),('3355','2013-07-24','16:50:00',1.58),('3355','2013-07-24','16:55:00',1.64),('3355','2013-07-24','17:00:00',1.62),('3355','2013-07-24','17:05:00',1.5),('3355','2013-07-24','17:10:00',1.01),('3355','2013-07-24','17:15:00',1.32),('3355','2013-07-24','17:20:00',1.39),('3355','2013-07-24','17:25:00',1.33),('3355','2013-07-24','17:30:00',1.28),('3355','2013-07-24','17:35:00',1.22),('3355','2013-07-24','17:40:00',1.16),('3355','2013-07-24','17:45:00',1.12),('3355','2013-07-24','17:50:00',1.05),('3355','2013-07-24','17:55:00',1.01),('3355','2013-07-23','08:55:00',1.02),('3355','2013-07-23','09:00:00',1.06),('3355','2013-07-23','09:05:00',1.11),('3355','2013-07-23','09:10:00',1.15),('3355','2013-07-23','09:15:00',1.18),('3355','2013-07-23','09:20:00',1.21),('3355','2013-07-23','09:25:00',1.24),('3355','2013-07-23','09:30:00',1.28),('3355','2013-07-23','09:35:00',1.32),('3355','2013-07-23','09:40:00',1.35),('3355','2013-07-23','09:45:00',1.38),('3355','2013-07-23','09:50:00',1.41),('3355','2013-07-23','09:55:00',1.43),('3355','2013-07-23','10:00:00',1.48),('3355','2013-07-23','10:05:00',1.53),('3355','2013-07-23','10:10:00',1.55),('3355','2013-07-23','10:15:00',1.58),('3355','2013-07-23','10:20:00',1.6),('3355','2013-07-23','10:25:00',1.64),('3355','2013-07-23','10:30:00',1.72),('3355','2013-07-23','10:35:00',1.74),('3355','2013-07-23','10:40:00',1.78),('3355','2013-07-23','10:45:00',1.78),('3355','2013-07-23','10:50:00',1.8),('3355','2013-07-23','10:55:00',1.83),('3355','2013-07-23','11:00:00',1.86),('3355','2013-07-23','11:05:00',1.88),('3355','2013-07-23','11:10:00',1.91),('3355','2013-07-23','11:15:00',1.94),('3355','2013-07-23','11:20:00',1.97),('3355','2013-07-23','11:25:00',1.98),('3355','2013-07-23','11:30:00',1.99),('3355','2013-07-23','11:35:00',2),('3355','2013-07-23','11:40:00',2.01),('3355','2013-07-23','11:45:00',2.01),('3355','2013-07-23','11:50:00',2.03),('3355','2013-07-23','11:55:00',2.04),('3355','2013-07-23','12:00:00',2.09),('3355','2013-07-23','12:05:00',2.08),('3355','2013-07-23','12:10:00',2.12),('3355','2013-07-23','12:15:00',2.14),('3355','2013-07-23','12:20:00',2.14),('3355','2013-07-23','12:25:00',2.15),('3355','2013-07-23','12:30:00',2.17),('3355','2013-07-23','12:35:00',2.15),('3355','2013-07-23','12:40:00',2.17),('3355','2013-07-23','12:45:00',2.15),('3355','2013-07-23','12:50:00',1.55),('3355','2013-07-23','12:55:00',1.63),('3355','2013-07-23','13:00:00',1.59),('3355','2013-07-23','13:10:00',1.07),('3355','2013-07-23','13:15:00',1.06),('3355','2013-07-23','13:30:00',1.49),('3355','2013-07-23','13:35:00',2.36),('3355','2013-07-23','13:40:00',2.3),('3355','2013-07-23','13:45:00',2.16),('3355','2013-07-23','13:50:00',2.2),('3355','2013-07-23','13:55:00',1.85),('3355','2013-07-23','14:00:00',2.36),('3355','2013-07-23','14:05:00',1.24),('3355','2013-07-23','14:40:00',1.78),('3355','2013-07-23','14:45:00',1.81),('3355','2013-07-23','14:50:00',1.9),('3355','2013-07-23','14:55:00',2.06),('3355','2013-07-23','15:00:00',2.35),('3355','2013-07-23','15:05:00',2.34),('3355','2013-07-23','15:10:00',2.08),('3355','2013-07-23','15:15:00',1.97),('3355','2013-07-23','15:20:00',2.07),('3355','2013-07-23','15:25:00',1.97),('3355','2013-07-23','15:30:00',1.97),('3355','2013-07-23','15:35:00',1.92),('3355','2013-07-23','15:40:00',1.98),('3355','2013-07-23','15:45:00',1.92),('3355','2013-07-23','15:50:00',1.92),('3355','2013-07-23','15:55:00',1.91),('3355','2013-07-23','16:00:00',1.86),('3355','2013-07-23','16:05:00',1.81),('3355','2013-07-23','16:10:00',1.79),('3355','2013-07-23','16:15:00',1.74),('3355','2013-07-23','16:20:00',1.74),('3355','2013-07-23','16:25:00',1.73),('3355','2013-07-23','16:30:00',1.69),('3355','2013-07-23','16:35:00',1.65),('3355','2013-07-23','16:40:00',1.61),('3355','2013-07-23','16:45:00',1.57),('3355','2013-07-23','16:50:00',1.53),('3355','2013-07-23','16:55:00',1.49),('3355','2013-07-23','17:00:00',1.45),('3355','2013-07-23','17:05:00',1.42),('3355','2013-07-23','17:10:00',1.4),('3355','2013-07-23','17:15:00',1.36),('3355','2013-07-23','17:20:00',1.34),('3355','2013-07-23','17:25:00',1.3),('3355','2013-07-23','17:30:00',1.26),('3355','2013-07-23','17:35:00',1.22),('3355','2013-07-23','17:40:00',1.17),('3355','2013-07-23','17:45:00',1.13),('3355','2013-07-23','17:50:00',1.09),('3355','2013-07-23','17:55:00',1.05),('3355','2013-07-23','18:00:00',1),('3355','2013-07-22','08:55:00',1),('3355','2013-07-22','09:00:00',1.05),('3355','2013-07-22','09:05:00',1.09),('3355','2013-07-22','09:10:00',1.14),('3355','2013-07-22','09:15:00',1.18),('3355','2013-07-22','09:20:00',1.22),('3355','2013-07-22','09:25:00',1.25),('3355','2013-07-22','09:30:00',1.29),('3355','2013-07-22','09:35:00',1.33),('3355','2013-07-22','09:40:00',1.37),('3355','2013-07-22','09:45:00',1.41),('3355','2013-07-22','09:50:00',1.45),('3355','2013-07-22','09:55:00',1.48),('3355','2013-07-22','10:00:00',1.51),('3355','2013-07-22','10:05:00',1.54),('3355','2013-07-22','10:10:00',1.58),('3355','2013-07-22','10:15:00',1.62),('3355','2013-07-22','10:20:00',1.65),('3355','2013-07-22','10:25:00',1.67),('3355','2013-07-22','10:30:00',1.7),('3355','2013-07-22','10:35:00',1.73),('3355','2013-07-22','10:40:00',1.76),('3355','2013-07-22','10:45:00',1.78),('3355','2013-07-22','10:50:00',1.8),('3355','2013-07-22','10:55:00',1.83),('3355','2013-07-22','11:00:00',1.86),('3355','2013-07-22','11:05:00',1.89),('3355','2013-07-22','11:10:00',1.9),('3355','2013-07-22','11:15:00',1.9),('3355','2013-07-22','11:20:00',1.91),('3355','2013-07-22','11:25:00',1.95),('3355','2013-07-22','11:30:00',1.97),('3355','2013-07-22','11:35:00',1.99),('3355','2013-07-22','11:40:00',2.01),('3355','2013-07-22','11:45:00',2.03),('3355','2013-07-22','11:50:00',2.04),('3355','2013-07-22','11:55:00',2.03),('3355','2013-07-22','12:00:00',2.06),('3355','2013-07-22','12:05:00',2.07),('3355','2013-07-22','12:10:00',2.09),('3355','2013-07-22','12:15:00',2.09),('3355','2013-07-22','12:20:00',2.1),('3355','2013-07-22','12:25:00',2.11),('3355','2013-07-22','12:30:00',2.13),('3355','2013-07-22','12:35:00',2.13),('3355','2013-07-22','12:40:00',2.13),('3355','2013-07-22','12:45:00',2.13),('3355','2013-07-22','12:50:00',2.15),('3355','2013-07-22','12:55:00',2.16),('3355','2013-07-22','13:00:00',2.17),('3355','2013-07-22','13:05:00',2.18),('3355','2013-07-22','13:10:00',2.17),('3355','2013-07-22','13:15:00',2.15),('3355','2013-07-22','13:20:00',2.16),('3355','2013-07-22','13:25:00',2.14),('3355','2013-07-22','13:30:00',2.14),('3355','2013-07-22','13:35:00',2.13),('3355','2013-07-22','13:40:00',2.19),('3355','2013-07-22','13:45:00',2.17),('3355','2013-07-22','13:50:00',2.16),('3355','2013-07-22','13:55:00',2.14),('3355','2013-07-22','14:00:00',2.13),('3355','2013-07-22','14:05:00',2.14),('3355','2013-07-22','14:10:00',2.11),('3355','2013-07-22','14:15:00',2.12),('3355','2013-07-22','14:20:00',2.12),('3355','2013-07-22','14:25:00',2.11),('3355','2013-07-22','14:30:00',2.1),('3355','2013-07-22','14:35:00',2.11),('3355','2013-07-22','14:40:00',2.1),('3355','2013-07-22','14:45:00',2.09),('3355','2013-07-22','14:50:00',2.07),('3355','2013-07-22','14:55:00',2.05),('3355','2013-07-22','15:00:00',1.79),('3355','2013-07-22','15:05:00',2.06),('3355','2013-07-22','15:10:00',2.03),('3355','2013-07-22','15:15:00',2.01),('3355','2013-07-22','15:20:00',1.95),('3355','2013-07-22','15:25:00',1.99),('3355','2013-07-22','15:30:00',1.97),('3355','2013-07-22','15:35:00',1.24),('3355','2013-07-22','15:40:00',1.61),('3355','2013-07-22','15:45:00',1.99),('3355','2013-07-22','15:50:00',1.96),('3355','2013-07-22','15:55:00',1.83),('3355','2013-07-22','16:00:00',1.56),('3355','2013-07-22','16:05:00',1.18),('3355','2013-07-22','16:20:00',1.66),('3355','2013-07-22','16:25:00',1.89),('3355','2013-07-22','16:30:00',1.77),('3355','2013-07-22','16:35:00',1.67),('3355','2013-07-22','16:40:00',1.59),('3355','2013-07-22','16:45:00',1.56),('3355','2013-07-22','16:50:00',1.52),('3355','2013-07-22','16:55:00',1.51),('3355','2013-07-22','17:00:00',1.45),('3355','2013-07-22','17:05:00',1.43),('3355','2013-07-22','17:10:00',1.4),('3355','2013-07-22','17:15:00',1.36),('3355','2013-07-22','17:20:00',1.31),('3355','2013-07-22','17:25:00',1.22),('3355','2013-07-22','17:30:00',1.19),('3355','2013-07-22','17:35:00',1.2),('3355','2013-07-22','17:40:00',1.1),('3355','2013-07-22','17:45:00',1.01),('3355','2013-07-22','17:50:00',1),('3355','2013-07-21','09:00:00',1),('3355','2013-07-21','09:05:00',1.04),('3355','2013-07-21','09:10:00',1.09),('3355','2013-07-21','09:15:00',1.13),('3355','2013-07-21','09:20:00',1.17),('3355','2013-07-21','09:25:00',1.21),('3355','2013-07-21','09:30:00',1.24),('3355','2013-07-21','09:35:00',1.28),('3355','2013-07-21','09:40:00',1.32),('3355','2013-07-21','09:45:00',1.35),('3355','2013-07-21','09:50:00',1.39),('3355','2013-07-21','09:55:00',1.42),('3355','2013-07-21','10:00:00',1.46),('3355','2013-07-21','10:05:00',1.5),('3355','2013-07-21','10:10:00',1.53),('3355','2013-07-21','10:15:00',1.56),('3355','2013-07-21','10:20:00',1.59),('3355','2013-07-21','10:25:00',1.62),('3355','2013-07-21','10:30:00',1.64),('3355','2013-07-21','10:35:00',1.68),('3355','2013-07-21','10:40:00',1.71),('3355','2013-07-21','10:45:00',1.74),('3355','2013-07-21','10:50:00',1.77),('3355','2013-07-21','10:55:00',1.8),('3355','2013-07-21','11:00:00',1.82),('3355','2013-07-21','11:05:00',1.84),('3355','2013-07-21','11:10:00',1.85),('3355','2013-07-21','11:15:00',1.88),('3355','2013-07-21','11:20:00',1.89),('3355','2013-07-21','11:25:00',1.91),('3355','2013-07-21','11:30:00',1.95),('3355','2013-07-21','11:35:00',1.97),('3355','2013-07-21','11:40:00',2.05),('3355','2013-07-21','11:45:00',2.05),('3355','2013-07-21','11:50:00',2.01),('3355','2013-07-21','11:55:00',2.02),('3355','2013-07-21','12:00:00',2.04),('3355','2013-07-21','12:05:00',2.06),('3355','2013-07-21','12:10:00',2.1),('3355','2013-07-21','12:15:00',2.17),('3355','2013-07-21','12:20:00',2.23),('3355','2013-07-21','12:25:00',2.26),('3355','2013-07-21','12:30:00',2.32),('3355','2013-07-21','12:35:00',2.4),('3355','2013-07-21','12:40:00',2.45),('3355','2013-07-21','12:45:00',2.15),('3355','2013-07-21','12:50:00',2.07),('3355','2013-07-21','12:55:00',2.04),('3355','2013-07-21','13:00:00',2.28),('3355','2013-07-21','13:05:00',2.34),('3355','2013-07-21','13:10:00',2.52),('3355','2013-07-21','13:15:00',2.45),('3355','2013-07-21','13:20:00',2.23),('3355','2013-07-21','13:25:00',2.38),('3355','2013-07-21','13:30:00',2.27),('3355','2013-07-21','13:35:00',1.8),('3355','2013-07-21','13:40:00',1.61),('3355','2013-07-21','14:45:00',1.21),('3355','2013-07-21','14:50:00',1.59),('3355','2013-07-21','15:15:00',2.23),('3355','2013-07-21','15:20:00',2.58),('3355','2013-07-21','15:40:00',1.96),('3355','2013-07-21','15:45:00',1.67),('3355','2013-07-21','15:55:00',1.05),('3355','2014-04-07','11:05:00',1.03),('3355','2014-04-07','11:10:00',1.18),('3355','2014-04-07','11:15:00',1.3),('3355','2014-04-07','11:20:00',1.17),('3355','2014-04-07','11:25:00',1.13),('3355','2014-04-07','11:30:00',1.13),('3355','2014-04-07','11:35:00',1.1),('3355','2014-04-07','11:40:00',1.06),('3355','2014-04-07','12:00:00',1.03),('3355','2014-04-07','12:05:00',1.27),('3355','2014-04-07','12:10:00',1.47),('3355','2014-04-07','12:15:00',1.9),('3355','2014-04-07','12:20:00',2.35),('3355','2014-04-07','12:25:00',2.26),('3355','2014-04-07','12:30:00',1.46),('3355','2014-04-07','12:35:00',1.33),('3355','2014-04-07','12:40:00',1.61),('3355','2014-04-07','12:45:00',2.22),('3355','2014-04-07','12:50:00',2.25),('3355','2014-04-07','12:55:00',2.22),('3355','2014-04-07','13:00:00',2.23),('3355','2014-04-07','13:05:00',2.21),('3355','2014-04-07','13:10:00',2.21),('3355','2014-04-07','13:15:00',2.21),('3355','2014-04-07','13:20:00',2.22),('3355','2014-04-07','13:25:00',2.2),('3355','2014-04-07','13:30:00',2.19),('3355','2014-04-07','13:35:00',2.18),('3355','2014-04-07','13:40:00',2.19),('3355','2014-04-07','13:45:00',2.2),('3355','2014-04-07','13:50:00',2.19),('3355','2014-04-07','13:55:00',2.18),('3355','2014-04-07','14:00:00',2.15),('3355','2014-04-07','14:05:00',2.16),('3355','2014-04-07','14:10:00',2.15),('3355','2014-04-07','14:15:00',2.15),('3355','2014-04-07','14:20:00',2.15),('3355','2014-04-07','14:25:00',2.22),('3355','2014-04-07','14:30:00',2.2),('3355','2014-04-07','14:35:00',2.14),('3355','2014-04-07','14:40:00',2.13),('3355','2014-04-07','14:45:00',2.08),('3355','2014-04-07','14:50:00',1.98),('3355','2014-04-07','14:55:00',1.7),('3355','2014-04-07','15:00:00',2.02),('3355','2014-04-07','15:05:00',2.1),('3355','2014-04-07','15:10:00',2.06),('3355','2014-04-07','15:15:00',1.33),('3355','2014-04-07','15:20:00',2.04),('3355','2014-04-07','15:25:00',2.03),('3355','2014-04-07','15:30:00',1.97),('3355','2014-04-07','15:35:00',2),('3355','2014-04-07','15:40:00',1.97),('3355','2014-04-07','15:45:00',2.01),('3355','2014-04-07','15:50:00',2.09),('3355','2014-04-07','15:55:00',1.9),('3355','2014-04-07','16:00:00',1.17),('3355','2014-04-07','16:10:00',1.83),('3355','2014-04-07','16:15:00',1.72),('3355','2014-04-07','16:20:00',1.59),('3355','2014-04-07','16:25:00',1.56),('3355','2014-04-07','16:30:00',1.52),('3355','2014-04-07','16:35:00',1.24),('3355','2014-04-07','16:45:00',1.22),('3355','2014-04-07','16:50:00',1.22),('3355','2014-04-07','16:55:00',1.48),('3355','2014-04-07','17:00:00',1.49),('3355','2014-04-07','17:05:00',1.29),('3355','2014-04-07','17:15:00',1.08),('3355','2013-07-20','08:55:00',1.02),('3355','2013-07-20','09:00:00',1.08),('3355','2013-07-20','09:05:00',1.13),('3355','2013-07-20','09:10:00',1.2),('3355','2013-07-20','09:15:00',1.25),('3355','2013-07-20','09:20:00',1.28),('3355','2013-07-20','09:25:00',1.27),('3355','2013-07-20','09:30:00',1.27),('3355','2013-07-20','09:35:00',1.3),('3355','2013-07-20','09:40:00',1.28),('3355','2013-07-20','09:45:00',1.42),('3355','2013-07-20','09:50:00',1.4),('3355','2013-07-20','09:55:00',1.42),('3355','2013-07-20','10:00:00',1.5),('3355','2013-07-20','10:05:00',1.51),('3355','2013-07-20','10:10:00',1.56),('3355','2013-07-20','10:15:00',1.6),('3355','2013-07-20','10:20:00',1.63),('3355','2013-07-20','10:25:00',1.66),('3355','2013-07-20','10:30:00',1.7),('3355','2013-07-20','10:35:00',1.73),('3355','2013-07-20','10:40:00',1.75),('3355','2013-07-20','10:45:00',1.78),('3355','2013-07-20','10:50:00',1.81),('3355','2013-07-20','10:55:00',1.83),('3355','2013-07-20','11:00:00',1.86),('3355','2013-07-20','11:05:00',1.85),('3355','2013-07-20','11:10:00',1.91),('3355','2013-07-20','11:15:00',1.92),('3355','2013-07-20','11:20:00',1.93),('3355','2013-07-20','11:25:00',1.93),('3355','2013-07-20','11:30:00',1.94),('3355','2013-07-20','11:35:00',1.98),('3355','2013-07-20','11:40:00',2.02),('3355','2013-07-20','11:45:00',2.02),('3355','2013-07-20','11:50:00',2.07),('3355','2013-07-20','11:55:00',2.09),('3355','2013-07-20','12:00:00',2.06),('3355','2013-07-20','12:05:00',2.09),('3355','2013-07-20','12:10:00',2.12),('3355','2013-07-20','12:15:00',2.15),('3355','2013-07-20','12:20:00',2.05),('3355','2013-07-20','12:30:00',1.88),('3355','2013-07-20','12:35:00',2.19),('3355','2013-07-20','12:40:00',2.19),('3355','2013-07-20','12:45:00',2.22),('3355','2013-07-20','12:50:00',2.2),('3355','2013-07-20','12:55:00',2.24),('3355','2013-07-20','13:00:00',2.28),('3355','2013-07-20','13:05:00',2.27),('3355','2013-07-20','13:10:00',2.25),('3355','2013-07-20','13:15:00',2.27),('3355','2013-07-20','13:20:00',1.05),('3355','2013-07-20','13:25:00',1.13),('3355','2013-07-20','13:30:00',2.36),('3355','2013-07-20','13:35:00',2.32),('3355','2013-07-20','13:40:00',2.33),('3355','2013-07-20','13:45:00',2.3),('3355','2013-07-20','13:50:00',2.28),('3355','2013-07-20','14:05:00',2.33),('3355','2013-07-20','14:10:00',2.33),('3355','2013-07-20','14:15:00',1.5),('3355','2013-07-20','14:20:00',1.68),('3355','2013-07-20','14:25:00',2.29),('3355','2013-07-20','14:30:00',2.24),('3355','2013-07-20','14:35:00',1.97),('3355','2013-07-20','14:40:00',2.12),('3355','2013-07-20','14:50:00',1.89),('3355','2013-07-20','14:55:00',1.25),('3355','2013-07-20','15:05:00',1.89),('3355','2013-07-20','15:10:00',2.21),('3355','2013-07-20','15:15:00',2.12),('3355','2013-07-20','15:20:00',2.07),('3355','2013-07-20','15:25:00',2.02),('3355','2013-07-20','15:30:00',2),('3355','2013-07-20','15:35:00',1.97),('3355','2013-07-20','15:40:00',1.94),('3355','2013-07-20','15:45:00',1.91),('3355','2013-07-20','15:50:00',1.88),('3355','2013-07-20','15:55:00',1.86),('3355','2013-07-20','16:00:00',1.84),('3355','2013-07-20','16:05:00',1.78),('3355','2013-07-20','16:10:00',1.78),('3355','2013-07-20','16:15:00',1.77),('3355','2013-07-20','16:20:00',1.75),('3355','2013-07-20','16:25:00',1.72),('3355','2013-07-20','16:30:00',1.69),('3355','2013-07-20','16:35:00',1.65),('3355','2013-07-20','16:40:00',1.61),('3355','2013-07-20','16:45:00',1.56),('3355','2013-07-20','16:50:00',1.51),('3355','2013-07-20','16:55:00',1.48),('3355','2013-07-20','17:00:00',1.45),('3355','2013-07-20','17:05:00',1.42),('3355','2013-07-20','17:10:00',1.37),('3355','2013-07-20','17:15:00',1.34),('3355','2013-07-20','17:20:00',1.31),('3355','2013-07-20','17:25:00',1.27),('3355','2013-07-20','17:30:00',1.23),('3355','2013-07-20','17:35:00',1.2),('3355','2013-07-20','17:40:00',1.15),('3355','2013-07-20','17:45:00',1.11),('3355','2013-07-20','17:50:00',1.05),('3355','2013-07-20','17:55:00',1),('3355','2013-07-19','09:00:00',1),('3355','2013-07-19','09:05:00',1.04),('3355','2013-07-19','09:10:00',1.09),('3355','2013-07-19','09:15:00',1.13),('3355','2013-07-19','09:20:00',1.17),('3355','2013-07-19','09:25:00',1.2),('3355','2013-07-19','09:30:00',1.24),('3355','2013-07-19','09:35:00',1.29),('3355','2013-07-19','09:40:00',1.31),('3355','2013-07-19','09:45:00',1.32),('3355','2013-07-19','09:50:00',1.37),('3355','2013-07-19','09:55:00',1.41),('3355','2013-07-19','10:00:00',1.44),('3355','2013-07-19','10:05:00',1.47),('3355','2013-07-19','10:10:00',1.49),('3355','2013-07-19','10:15:00',1.52),('3355','2013-07-19','10:20:00',1.54),('3355','2013-07-19','10:25:00',1.6),('3355','2013-07-19','10:30:00',1.6),('3355','2013-07-19','10:35:00',1.65),('3355','2013-07-19','10:40:00',1.67),('3355','2013-07-19','10:45:00',1.7),('3355','2013-07-19','10:50:00',1.72),('3355','2013-07-19','10:55:00',1.75),('3355','2013-07-19','11:00:00',1.79),('3355','2013-07-19','11:05:00',1.8),('3355','2013-07-19','11:10:00',1.81),('3355','2013-07-19','11:15:00',1.82),('3355','2013-07-19','11:20:00',1.86),('3355','2013-07-19','11:25:00',1.88),('3355','2013-07-19','11:30:00',1.87),('3355','2013-07-19','11:35:00',1.88),('3355','2013-07-19','11:40:00',1.91),('3355','2013-07-19','11:45:00',1.97),('3355','2013-07-19','11:50:00',2.03),('3355','2013-07-19','11:55:00',2.02),('3355','2013-07-19','12:00:00',1.68),('3355','2013-07-19','12:05:00',1.11),('3355','2013-07-19','12:10:00',2.05),('3355','2013-07-19','12:15:00',2.09),('3355','2013-07-19','12:20:00',2.11),('3355','2013-07-19','12:25:00',1.68),('3355','2013-07-19','12:30:00',1.96),('3355','2013-07-19','12:35:00',1.98),('3355','2013-07-19','12:40:00',1.89),('3355','2013-07-19','12:45:00',2.1),('3355','2013-07-19','12:50:00',2.14),('3355','2013-07-19','12:55:00',1.46),('3355','2013-07-19','13:00:00',1.09),('3355','2013-07-19','13:05:00',1.87),('3355','2013-07-19','13:10:00',2.24),('3355','2013-07-19','13:15:00',1.61),('3355','2013-07-19','13:25:00',1.51),('3355','2013-07-19','13:30:00',2.4),('3355','2013-07-19','13:35:00',2.3),('3355','2013-07-19','13:40:00',2.29),('3355','2013-07-19','13:45:00',2.29),('3355','2013-07-19','13:50:00',2.22),('3355','2013-07-19','13:55:00',2.1),('3355','2013-07-19','14:00:00',1.79),('3355','2013-07-19','14:05:00',2.32),('3355','2013-07-19','14:10:00',1.74),('3355','2013-07-19','14:15:00',2.17),('3355','2013-07-19','14:20:00',2.3),('3355','2013-07-19','14:25:00',2.18),('3355','2013-07-19','14:30:00',2.31),('3355','2013-07-19','14:35:00',2.31),('3355','2013-07-19','14:40:00',1.92),('3355','2013-07-19','14:45:00',1.72),('3355','2013-07-19','14:50:00',2.18),('3355','2013-07-19','14:55:00',1.78),('3355','2013-07-19','15:00:00',2.22),('3355','2013-07-19','15:05:00',2.15),('3355','2013-07-19','15:10:00',2.15),('3355','2013-07-19','15:15:00',1.16),('3355','2013-07-19','15:20:00',1.85),('3355','2013-07-19','15:25:00',1.52),('3355','2013-07-19','15:30:00',2.13),('3355','2013-07-19','15:35:00',2.02),('3355','2013-07-19','15:40:00',2.07),('3355','2013-07-19','15:45:00',2.03),('3355','2013-07-19','15:50:00',1.98),('3355','2013-07-19','15:55:00',1.93),('3355','2013-07-19','16:00:00',1.9),('3355','2013-07-19','16:05:00',1.88),('3355','2013-07-19','16:10:00',1.86),('3355','2013-07-19','16:15:00',1.85),('3355','2013-07-19','16:20:00',1.81),('3355','2013-07-19','16:25:00',1.78),('3355','2013-07-19','16:30:00',1.75),('3355','2013-07-19','16:35:00',1.74),('3355','2013-07-19','16:40:00',1.71),('3355','2013-07-19','16:45:00',1.68),('3355','2013-07-19','16:50:00',1.64),('3355','2013-07-19','16:55:00',1.66),('3355','2013-07-19','17:00:00',1.38),('3355','2013-07-19','17:05:00',1.38),('3355','2013-07-19','17:10:00',1.53),('3355','2013-07-19','17:15:00',1.4),('3355','2013-07-19','17:20:00',1.24),('3355','2013-07-19','17:25:00',1.1),('3355','2013-07-19','17:30:00',1.19),('3355','2013-07-19','17:35:00',1.12),('3355','2013-07-18','08:55:00',1.01),('3355','2013-07-18','09:00:00',1.05),('3355','2013-07-18','09:05:00',1.09),('3355','2013-07-18','09:10:00',1.13),('3355','2013-07-18','09:15:00',1.16),('3355','2013-07-18','09:20:00',1.22),('3355','2013-07-18','09:25:00',1.25),('3355','2013-07-18','09:30:00',1.29),('3355','2013-07-18','09:35:00',1.33),('3355','2013-07-18','09:40:00',1.37),('3355','2013-07-18','09:45:00',1.4),('3355','2013-07-18','09:50:00',1.44),('3355','2013-07-18','09:55:00',1.47),('3355','2013-07-18','10:00:00',1.5),('3355','2013-07-18','10:05:00',1.53),('3355','2013-07-18','10:10:00',1.57),('3355','2013-07-18','10:15:00',1.61),('3355','2013-07-18','10:20:00',1.63),('3355','2013-07-18','10:25:00',1.66),('3355','2013-07-18','10:30:00',1.71),('3355','2013-07-18','10:35:00',1.73),('3355','2013-07-18','10:40:00',1.76),('3355','2013-07-18','10:45:00',1.77),('3355','2013-07-18','10:50:00',1.8),('3355','2013-07-18','10:55:00',1.83),('3355','2013-07-18','11:00:00',1.84),('3355','2013-07-18','11:05:00',1.87),('3355','2013-07-18','11:10:00',1.89),('3355','2013-07-18','11:15:00',1.9),('3355','2013-07-18','11:20:00',1.94),('3355','2013-07-18','11:25:00',1.96),('3355','2013-07-18','11:30:00',1.97),('3355','2013-07-18','11:35:00',1.98),('3355','2013-07-18','11:40:00',1.99),('3355','2013-07-18','11:45:00',2),('3355','2013-07-18','11:50:00',2.01),('3355','2013-07-18','11:55:00',2.03),('3355','2013-07-18','12:00:00',2.05),('3355','2013-07-18','12:05:00',2.06),('3355','2013-07-18','12:10:00',2.06),('3355','2013-07-18','12:15:00',2.06),('3355','2013-07-18','12:20:00',2.09),('3355','2013-07-18','12:25:00',2.05),('3355','2013-07-18','12:30:00',1.13),('3355','2013-07-18','12:35:00',1.48),('3355','2013-07-18','12:40:00',1.89),('3355','2013-07-18','12:45:00',1.89),('3355','2013-07-18','12:50:00',1.08),('3355','2013-07-18','12:55:00',1.72),('3355','2013-07-18','13:00:00',2.29),('3355','2013-07-18','13:05:00',2.23),('3355','2013-07-18','13:10:00',2.2),('3355','2013-07-18','13:15:00',2.15),('3355','2013-07-18','13:20:00',2),('3355','2013-07-18','13:25:00',2.04),('3355','2013-07-18','13:30:00',2.29),('3355','2013-07-18','13:35:00',2.15),('3355','2013-07-18','13:40:00',2.19),('3355','2013-07-18','13:45:00',2.29),('3355','2013-07-18','13:50:00',2.27),('3355','2013-07-18','13:55:00',2.18),('3355','2013-07-18','14:00:00',2.2),('3355','2013-07-18','14:05:00',2.19),('3355','2013-07-18','14:10:00',2.15),('3355','2013-07-18','14:15:00',2.16),('3355','2013-07-18','14:20:00',2.22),('3355','2013-07-18','14:25:00',2.17),('3355','2013-07-18','14:30:00',2.14),('3355','2013-07-18','14:35:00',2.17),('3355','2013-07-18','14:40:00',2.18),('3355','2013-07-18','14:45:00',2.12),('3355','2013-07-18','14:50:00',2.11),('3355','2013-07-18','14:55:00',2.08),('3355','2013-07-18','15:00:00',2.06),('3355','2013-07-18','15:05:00',2.08),('3355','2013-07-18','15:10:00',2.07),('3355','2013-07-18','15:15:00',2.04),('3355','2013-07-18','15:20:00',2.04),('3355','2013-07-18','15:25:00',2.03),('3355','2013-07-18','15:30:00',2.01),('3355','2013-07-18','15:35:00',1.97),('3355','2013-07-18','15:40:00',1.96),('3355','2013-07-18','15:45:00',1.93),('3355','2013-07-18','15:50:00',1.92),('3355','2013-07-18','15:55:00',1.88),('3355','2013-07-18','16:00:00',1.85),('3355','2013-07-18','16:05:00',1.82),('3355','2013-07-18','16:10:00',1.79),('3355','2013-07-18','16:15:00',1.77),('3355','2013-07-18','16:20:00',1.73),('3355','2013-07-18','16:25:00',1.7),('3355','2013-07-18','16:30:00',1.66),('3355','2013-07-18','16:35:00',1.64),('3355','2013-07-18','16:40:00',1.6),('3355','2013-07-18','16:45:00',1.56),('3355','2013-07-18','16:50:00',1.53),('3355','2013-07-18','16:55:00',1.49),('3355','2013-07-18','17:00:00',1.45),('3355','2013-07-18','17:05:00',1.4),('3355','2013-07-18','17:10:00',1.36),('3355','2013-07-18','17:15:00',1.3),('3355','2013-07-18','17:20:00',1.27),('3355','2013-07-18','17:25:00',1.26),('3355','2013-07-18','17:30:00',1.19),('3355','2013-07-18','17:35:00',1.13),('3355','2013-07-18','17:40:00',1.1),('3355','2013-07-17','08:55:00',1.05),('3355','2013-07-17','09:00:00',1.1),('3355','2013-07-17','09:05:00',1.15),('3355','2013-07-17','09:10:00',1.2),('3355','2013-07-17','09:15:00',1.24),('3355','2013-07-17','09:20:00',1.28),('3355','2013-07-17','09:25:00',1.32),('3355','2013-07-17','09:30:00',1.36),('3355','2013-07-17','09:35:00',1.39),('3355','2013-07-17','09:40:00',1.44),('3355','2013-07-17','09:45:00',1.48),('3355','2013-07-17','09:50:00',1.52),('3355','2013-07-17','09:55:00',1.54),('3355','2013-07-17','10:00:00',1.57),('3355','2013-07-17','10:05:00',1.6),('3355','2013-07-17','10:10:00',1.63),('3355','2013-07-17','10:15:00',1.67),('3355','2013-07-17','10:20:00',1.7),('3355','2013-07-17','10:25:00',1.73),('3355','2013-07-17','10:30:00',1.76),('3355','2013-07-17','10:35:00',1.78),('3355','2013-07-17','10:40:00',1.8),('3355','2013-07-17','10:45:00',1.85),('3355','2013-07-17','10:50:00',1.87),('3355','2013-07-17','10:55:00',1.89),('3355','2013-07-17','11:00:00',1.91),('3355','2013-07-17','11:05:00',1.94),('3355','2013-07-17','11:10:00',1.97),('3355','2013-07-17','11:15:00',1.98),('3355','2013-07-17','11:20:00',2),('3355','2013-07-17','11:25:00',2.03),('3355','2013-07-17','11:30:00',2.04),('3355','2013-07-17','11:35:00',2.06),('3355','2013-07-17','11:40:00',2.06),('3355','2013-07-17','11:45:00',2.08),('3355','2013-07-17','11:50:00',2.09),('3355','2013-07-17','11:55:00',2.12),('3355','2013-07-17','12:00:00',2.13),('3355','2013-07-17','12:05:00',2.14),('3355','2013-07-17','12:10:00',2.16),('3355','2013-07-17','12:15:00',2.15),('3355','2013-07-17','12:20:00',2.18),('3355','2013-07-17','12:25:00',2.19),('3355','2013-07-17','12:30:00',2.19),('3355','2013-07-17','12:35:00',2.2),('3355','2013-07-17','12:40:00',2.19),('3355','2013-07-17','12:45:00',2.21),('3355','2013-07-17','12:50:00',2.21),('3355','2013-07-17','12:55:00',2.23),('3355','2013-07-17','13:00:00',2.21),('3355','2013-07-17','13:05:00',2.2),('3355','2013-07-17','13:10:00',2.22),('3355','2013-07-17','13:15:00',2.21),('3355','2013-07-17','13:20:00',2.19),('3355','2013-07-17','13:25:00',2.18),('3355','2013-07-17','13:30:00',2.19),('3355','2013-07-17','13:35:00',2.17),('3355','2013-07-17','13:40:00',2.18),('3355','2013-07-17','13:45:00',2.2),('3355','2013-07-17','13:50:00',2.2),('3355','2013-07-17','13:55:00',2.19),('3355','2013-07-17','14:00:00',2.2),('3355','2013-07-17','14:05:00',2.19),('3355','2013-07-17','14:10:00',2.17),('3355','2013-07-17','14:15:00',2.16),('3355','2013-07-17','14:20:00',2.15),('3355','2013-07-17','14:25:00',2.12),('3355','2013-07-17','14:30:00',2.11),('3355','2013-07-17','14:35:00',2.11),('3355','2013-07-17','14:40:00',2.22),('3355','2013-07-17','14:45:00',2.19),('3355','2013-07-17','14:50:00',2.12),('3355','2013-07-17','14:55:00',2.07),('3355','2013-07-17','15:00:00',2.05),('3355','2013-07-17','15:05:00',2.08),('3355','2013-07-17','15:10:00',2.1),('3355','2013-07-17','15:15:00',2.06),('3355','2013-07-17','15:20:00',2.05),('3355','2013-07-17','15:25:00',2),('3355','2013-07-17','15:30:00',1.99),('3355','2013-07-17','15:35:00',1.97),('3355','2013-07-17','15:40:00',1.65),('3355','2013-07-17','15:45:00',1.93),('3355','2013-07-17','15:50:00',1.9),('3355','2013-07-17','15:55:00',1.91),('3355','2013-07-17','16:00:00',1.88),('3355','2013-07-17','16:05:00',1.84),('3355','2013-07-17','16:10:00',1.83),('3355','2013-07-17','16:15:00',1.8),('3355','2013-07-17','16:20:00',1.76),('3355','2013-07-17','16:25:00',1.72),('3355','2013-07-17','16:30:00',1.69),('3355','2013-07-17','16:35:00',1.64),('3355','2013-07-17','16:40:00',1.63),('3355','2013-07-17','16:45:00',1.6),('3355','2013-07-17','16:50:00',1.52),('3355','2013-07-17','16:55:00',1.46),('3355','2013-07-17','17:00:00',1.49),('3355','2013-07-17','17:05:00',1.48),('3355','2013-07-17','17:10:00',1.47),('3355','2013-07-17','17:15:00',1.38),('3355','2013-07-17','17:20:00',1.34),('3355','2013-07-17','17:25:00',1.25),('3355','2013-07-17','17:30:00',1.24),('3355','2013-07-17','17:35:00',1.19),('3355','2013-07-17','17:40:00',1.13),('3355','2013-07-17','17:45:00',1.1),('3355','2013-07-17','17:50:00',1.08),('3355','2013-07-16','08:55:00',1.01),('3355','2013-07-16','09:00:00',1.05),('3355','2013-07-16','09:05:00',1.09),('3355','2013-07-16','09:10:00',1.13),('3355','2013-07-16','09:15:00',1.17),('3355','2013-07-16','09:20:00',1.21),('3355','2013-07-16','09:25:00',1.26),('3355','2013-07-16','09:30:00',1.29),('3355','2013-07-16','09:35:00',1.33),('3355','2013-07-16','09:40:00',1.37),('3355','2013-07-16','09:45:00',1.42),('3355','2013-07-16','09:50:00',1.46),('3355','2013-07-16','09:55:00',1.5),('3355','2013-07-16','10:00:00',1.53),('3355','2013-07-16','10:05:00',1.58),('3355','2013-07-16','10:10:00',1.62),('3355','2013-07-16','10:15:00',1.65),('3355','2013-07-16','10:20:00',1.66),('3355','2013-07-16','10:25:00',1.69),('3355','2013-07-16','10:30:00',1.73),('3355','2013-07-16','10:35:00',1.75),('3355','2013-07-16','10:40:00',1.79),('3355','2013-07-16','10:45:00',1.8),('3355','2013-07-16','10:50:00',1.83),('3355','2013-07-16','10:55:00',1.86),('3355','2013-07-16','11:00:00',1.88),('3355','2013-07-16','11:05:00',1.91),('3355','2013-07-16','11:10:00',1.94),('3355','2013-07-16','11:15:00',1.95),('3355','2013-07-16','11:20:00',1.97),('3355','2013-07-16','11:25:00',1.99),('3355','2013-07-16','11:30:00',2.02),('3355','2013-07-16','11:35:00',2.03),('3355','2013-07-16','11:40:00',2.05),('3355','2013-07-16','11:45:00',2.07),('3355','2013-07-16','11:50:00',2.09),('3355','2013-07-16','11:55:00',2.11),('3355','2013-07-16','12:00:00',2.12),('3355','2013-07-16','12:05:00',2.12),('3355','2013-07-16','12:10:00',2.13),('3355','2013-07-16','12:15:00',2.15),('3355','2013-07-16','12:20:00',2.15),('3355','2013-07-16','12:25:00',2.16),('3355','2013-07-16','12:30:00',2.16),('3355','2013-07-16','12:35:00',2.16),('3355','2013-07-16','12:40:00',2.16),('3355','2013-07-16','12:45:00',2.16),('3355','2013-07-16','12:50:00',2.17),('3355','2013-07-16','12:55:00',2.16),('3355','2013-07-16','13:00:00',2.15),('3355','2013-07-16','13:05:00',2.18),('3355','2013-07-16','13:10:00',2.19),('3355','2013-07-16','13:15:00',2.2),('3355','2013-07-16','13:20:00',2.18),('3355','2013-07-16','13:25:00',2.17),('3355','2013-07-16','13:30:00',2.17),('3355','2013-07-16','13:35:00',2.18),('3355','2013-07-16','13:40:00',2.18),('3355','2013-07-16','13:45:00',2.21),('3355','2013-07-16','13:50:00',2.26),('3355','2013-07-16','13:55:00',2.21),('3355','2013-07-16','14:00:00',2.16),('3355','2013-07-16','14:05:00',2.15),('3355','2013-07-16','14:10:00',2.14),('3355','2013-07-16','14:15:00',2.13),('3355','2013-07-16','14:25:00',1.9),('3355','2013-07-16','14:30:00',2.23),('3355','2013-07-16','14:35:00',2.19),('3355','2013-07-16','14:40:00',2.17),('3355','2013-07-16','14:45:00',2.14),('3355','2013-07-16','14:50:00',2.14),('3355','2013-07-16','14:55:00',2.13),('3355','2013-07-16','15:00:00',2.12),('3355','2013-07-16','15:05:00',2.07),('3355','2013-07-16','15:10:00',2.04),('3355','2013-07-16','15:15:00',2.02),('3355','2013-07-16','15:20:00',2.02),('3355','2013-07-16','15:25:00',1.99),('3355','2013-07-16','15:30:00',2),('3355','2013-07-16','15:35:00',2.01),('3355','2013-07-16','15:40:00',1.97),('3355','2013-07-16','15:45:00',1.27),('3355','2013-07-16','15:50:00',1.88),('3355','2013-07-16','15:55:00',1.3),('3355','2013-07-16','16:00:00',1.36),('3355','2013-07-16','16:10:00',1.71),('3355','2013-07-16','16:15:00',1.66),('3355','2013-07-16','16:20:00',1.27),('3355','2013-07-16','16:25:00',1.16),('3355','2013-07-16','17:00:00',1.5),('3355','2013-07-16','17:05:00',1.54),('3355','2013-07-16','17:10:00',1.54),('3355','2013-07-16','17:15:00',1.51),('3355','2013-07-16','17:20:00',1.14),('3355','2013-07-16','17:45:00',1.21),('3355','2013-07-16','17:50:00',1.12),('3355','2013-07-15','08:50:00',1),('3355','2013-07-15','08:55:00',1.06),('3355','2013-07-15','09:00:00',1.1),('3355','2013-07-15','09:05:00',1.14),('3355','2013-07-15','09:10:00',1.19),('3355','2013-07-15','09:15:00',1.23),('3355','2013-07-15','09:20:00',1.27),('3355','2013-07-15','09:25:00',1.31),('3355','2013-07-15','09:30:00',1.35),('3355','2013-07-15','09:35:00',1.39),('3355','2013-07-15','09:40:00',1.42),('3355','2013-07-15','09:45:00',1.46),('3355','2013-07-15','09:50:00',1.5),('3355','2013-07-15','09:55:00',1.53),('3355','2013-07-15','10:00:00',1.55),('3355','2013-07-15','10:05:00',1.58),('3355','2013-07-15','10:10:00',1.62),('3355','2013-07-15','10:15:00',1.65),('3355','2013-07-15','10:20:00',1.68),('3355','2013-07-15','10:25:00',1.71),('3355','2013-07-15','10:30:00',1.74),('3355','2013-07-15','10:35:00',1.75),('3355','2013-07-15','10:40:00',1.78),('3355','2013-07-15','10:45:00',1.8),('3355','2013-07-15','10:50:00',1.84),('3355','2013-07-15','10:55:00',1.86),('3355','2013-07-15','11:00:00',1.88),('3355','2013-07-15','11:05:00',1.92),('3355','2013-07-15','11:10:00',1.94),('3355','2013-07-15','11:15:00',1.96),('3355','2013-07-15','11:20:00',1.99),('3355','2013-07-15','11:25:00',2),('3355','2013-07-15','11:30:00',2.01),('3355','2013-07-15','11:35:00',2.02),('3355','2013-07-15','11:40:00',2.03),('3355','2013-07-15','11:45:00',2.03),('3355','2013-07-15','11:50:00',2.06),('3355','2013-07-15','11:55:00',2.07),('3355','2013-07-15','12:00:00',2.11),('3355','2013-07-15','12:05:00',2.11),('3355','2013-07-15','12:10:00',2.11),('3355','2013-07-15','12:15:00',2.13),('3355','2013-07-15','12:20:00',2.15),('3355','2013-07-15','12:25:00',2.15),('3355','2013-07-15','12:30:00',2.16),('3355','2013-07-15','12:35:00',2.15),('3355','2013-07-15','12:40:00',2.16),('3355','2013-07-15','12:45:00',2.16),('3355','2013-07-15','12:50:00',2.18),('3355','2013-07-15','12:55:00',2.19),('3355','2013-07-15','13:00:00',2.19),('3355','2013-07-15','13:05:00',2.07),('3355','2013-07-15','13:10:00',2.24),('3355','2013-07-15','13:15:00',2.2),('3355','2013-07-15','13:20:00',2.19),('3355','2013-07-15','13:25:00',2.26),('3355','2013-07-15','13:30:00',2.31),('3355','2013-07-15','13:35:00',1.79),('3355','2013-07-15','13:50:00',2.46),('3355','2013-07-15','13:55:00',2.4),('3355','2013-07-15','14:00:00',2.38),('3355','2013-07-15','14:05:00',1.38),('3355','2013-07-15','14:20:00',1.71),('3355','2013-07-15','14:25:00',2.33),('3355','2013-07-15','14:30:00',1.46),('3355','2013-07-15','14:35:00',1.77),('3355','2013-07-15','14:40:00',2.27),('3355','2013-07-15','14:45:00',2.23),('3355','2013-07-15','14:50:00',2.22),('3355','2013-07-15','14:55:00',2.21),('3355','2013-07-15','15:00:00',2.18),('3355','2013-07-15','15:05:00',2.15),('3355','2013-07-15','15:10:00',2.13),('3355','2013-07-15','15:15:00',1.87),('3355','2013-07-15','15:20:00',1.96),('3355','2013-07-15','15:25:00',1.9),('3355','2013-07-15','15:30:00',1.76),('3355','2013-07-15','15:35:00',1.17),('3355','2013-07-15','15:40:00',2.05),('3355','2013-07-15','15:45:00',1.94),('3355','2013-07-15','15:50:00',1.97),('3355','2013-07-15','15:55:00',1.91),('3355','2013-07-15','16:00:00',1.86),('3355','2013-07-15','16:05:00',1.85),('3355','2013-07-15','16:10:00',1.81),('3355','2013-07-15','16:15:00',1.78),('3355','2013-07-15','16:20:00',1.72),('3355','2013-07-15','16:25:00',1.68),('3355','2013-07-15','16:30:00',1.64),('3355','2013-07-15','16:35:00',1.64),('3355','2013-07-15','16:40:00',1.6),('3355','2013-07-15','16:45:00',1.57),('3355','2013-07-15','16:50:00',1.53),('3355','2013-07-15','16:55:00',1.51),('3355','2013-07-15','17:00:00',1.47),('3355','2013-07-15','17:05:00',1.44),('3355','2013-07-15','17:10:00',1.39),('3355','2013-07-15','17:15:00',1.36),('3355','2013-07-15','17:20:00',1.32),('3355','2013-07-15','17:25:00',1.28),('3355','2013-07-15','17:30:00',1.23),('3355','2013-07-15','17:35:00',1.19),('3355','2013-07-15','17:40:00',1.14),('3355','2013-07-15','17:45:00',1.09),('3355','2013-07-15','17:50:00',1.03),('3355','2013-07-14','09:25:00',1.1),('3355','2013-07-14','09:30:00',1.11),('3355','2013-07-14','10:20:00',1.23),('3355','2013-07-14','10:25:00',1.34),('3355','2013-07-14','10:30:00',1.37),('3355','2013-07-14','10:35:00',1.87),('3355','2013-07-14','10:40:00',1.96),('3355','2013-07-14','10:45:00',1.62),('3355','2013-07-14','10:50:00',2.02),('3355','2013-07-14','10:55:00',1.86),('3355','2013-07-14','11:00:00',2.07),('3355','2013-07-14','11:05:00',1.63),('3355','2013-07-14','11:10:00',1.9),('3355','2013-07-14','11:15:00',1.91),('3355','2013-07-14','11:20:00',2.28),('3355','2013-07-14','11:25:00',2.14),('3355','2013-07-14','11:30:00',2.26),('3355','2013-07-14','11:35:00',2.22),('3355','2013-07-14','11:40:00',2.17),('3355','2013-07-14','11:45:00',2.01),('3355','2013-07-14','11:50:00',1.12),('3355','2013-07-14','12:10:00',1.12),('3355','2013-07-14','12:15:00',2.05),('3355','2013-07-14','12:20:00',2.37),('3355','2013-07-14','12:25:00',1.57),('3355','2013-07-14','12:35:00',1.64),('3355','2013-07-14','12:40:00',2.29),('3355','2013-07-14','12:45:00',2.39),('3355','2013-07-14','12:50:00',2.29),('3355','2013-07-14','13:00:00',1.05),('3355','2013-07-14','13:05:00',2.5),('3355','2013-07-14','13:10:00',2.4),('3355','2013-07-14','13:15:00',2.36),('3355','2013-07-14','13:20:00',1.65),('3355','2013-07-14','13:25:00',2.43),('3355','2013-07-14','13:30:00',2.23),('3355','2013-07-14','13:35:00',2.32),('3355','2013-07-14','13:40:00',2.32),('3355','2013-07-14','13:45:00',2.3),('3355','2013-07-14','13:50:00',2.31),('3355','2013-07-14','13:55:00',2.3),('3355','2013-07-14','14:00:00',2.3),('3355','2013-07-14','14:05:00',2.32),('3355','2013-07-14','14:10:00',2.29),('3355','2013-07-14','14:15:00',2.28),('3355','2013-07-14','14:20:00',2.26),('3355','2013-07-14','14:25:00',2.26),('3355','2013-07-14','14:30:00',2.26),('3355','2013-07-14','14:35:00',2.22),('3355','2013-07-14','14:40:00',2.19),('3355','2013-07-14','14:45:00',2.17),('3355','2013-07-14','14:50:00',2.16),('3355','2013-07-14','14:55:00',2.17),('3355','2013-07-14','15:00:00',2.12),('3355','2013-07-14','15:05:00',2.12),('3355','2013-07-14','15:10:00',2.09),('3355','2013-07-14','15:15:00',2.08),('3355','2013-07-14','15:20:00',2.06),('3355','2013-07-14','15:25:00',2.03),('3355','2013-07-14','15:30:00',2.01),('3355','2013-07-14','15:35:00',1.99),('3355','2013-07-14','15:40:00',1.97),('3355','2013-07-14','15:45:00',1.94),('3355','2013-07-14','15:50:00',1.82),('3355','2013-07-14','15:55:00',1.92),('3355','2013-07-14','16:00:00',1.86),('3355','2013-07-14','16:05:00',1.87),('3355','2013-07-14','16:10:00',1.85),('3355','2013-07-14','16:15:00',1.82),('3355','2013-07-14','16:20:00',1.8),('3355','2013-07-14','16:25:00',1.58),('3355','2013-07-14','16:30:00',1.27),('3355','2013-07-14','16:35:00',1.68),('3355','2013-07-14','16:40:00',1.67),('3355','2013-07-14','16:45:00',1.6),('3355','2013-07-14','16:50:00',1.64),('3355','2013-07-14','16:55:00',1.47),('3355','2013-07-14','17:00:00',1.09),('3355','2013-07-14','17:05:00',1.25),('3355','2013-07-14','17:10:00',1),('3355','2013-07-14','17:15:00',1.38),('3355','2013-07-14','17:25:00',1.15),('3355','2013-07-14','17:30:00',1.42),('3355','2013-07-14','17:35:00',1.25),('3355','2013-07-13','09:00:00',1.04),('3355','2013-07-13','09:05:00',1.09),('3355','2013-07-13','09:10:00',1.13),('3355','2013-07-13','09:15:00',1.17),('3355','2013-07-13','09:20:00',1.21),('3355','2013-07-13','09:25:00',1.27),('3355','2013-07-13','09:30:00',1.3),('3355','2013-07-13','09:35:00',1.32),('3355','2013-07-13','09:40:00',1.38),('3355','2013-07-13','09:45:00',1.36),('3355','2013-07-13','09:50:00',1.42),('3355','2013-07-13','09:55:00',1.47),('3355','2013-07-13','10:00:00',1.53),('3355','2013-07-13','10:05:00',1.58),('3355','2013-07-13','10:10:00',1.59),('3355','2013-07-13','10:15:00',1.64),('3355','2013-07-13','10:20:00',1.68),('3355','2013-07-13','10:25:00',1.73),('3355','2013-07-13','10:30:00',1.74),('3355','2013-07-13','10:35:00',1.71),('3355','2013-07-13','10:40:00',1.66),('3355','2013-07-13','10:45:00',1.45),('3355','2013-07-13','10:55:00',1.49),('3355','2013-07-13','11:00:00',2.01),('3355','2013-07-13','11:05:00',2.02),('3355','2013-07-13','11:10:00',1.69),('3355','2013-07-13','11:15:00',2.11),('3355','2013-07-13','11:20:00',1.7),('3355','2013-07-13','11:25:00',1.04),('3355','2013-07-13','11:30:00',2.05),('3355','2013-07-13','11:35:00',2.12),('3355','2013-07-13','11:40:00',2.08),('3355','2013-07-13','11:45:00',1.32),('3355','2013-07-13','11:55:00',1.82),('3355','2013-07-13','12:00:00',2.1),('3355','2013-07-13','12:10:00',1.91),('3355','2013-07-13','12:15:00',2.02),('3355','2013-07-13','12:25:00',2.09),('3355','2013-07-13','12:30:00',1.84),('3355','2013-07-13','12:35:00',1.74),('3355','2013-07-13','12:40:00',2.29),('3355','2013-07-13','12:45:00',2.34),('3355','2013-07-13','12:50:00',2.18),('3355','2013-07-13','12:55:00',2.21),('3355','2013-07-13','13:05:00',2.17),('3355','2013-07-13','13:10:00',2.42),('3355','2013-07-13','13:15:00',1.86),('3355','2013-07-13','13:20:00',2.35),('3355','2013-07-13','13:25:00',2.31),('3355','2013-07-13','13:30:00',2.25),('3355','2013-07-13','13:35:00',2.29),('3355','2013-07-13','13:40:00',2.29),('3355','2013-07-13','13:45:00',2.26),('3355','2013-07-13','13:50:00',2.28),('3355','2013-07-13','13:55:00',2.27),('3355','2013-07-13','14:00:00',2.28),('3355','2013-07-13','14:05:00',2.27),('3355','2013-07-13','14:10:00',2.26),('3355','2013-07-13','14:15:00',2.25),('3355','2013-07-13','14:20:00',2.24),('3355','2013-07-13','14:25:00',2.23),('3355','2013-07-13','14:30:00',2.23),('3355','2013-07-13','14:35:00',2.21),('3355','2013-07-13','14:40:00',2.2),('3355','2013-07-13','14:45:00',2.19),('3355','2013-07-13','14:50:00',2.2),('3355','2013-07-13','14:55:00',2.18),('3355','2013-07-13','15:00:00',2.18),('3355','2013-07-13','15:05:00',2.19),('3355','2013-07-13','15:10:00',2.17),('3355','2013-07-13','15:15:00',2.15),('3355','2013-07-13','15:20:00',2.05),('3355','2013-07-13','15:25:00',2.11),('3355','2013-07-13','15:30:00',2.07),('3355','2013-07-13','15:35:00',2.1),('3355','2013-07-13','15:40:00',2.07),('3355','2013-07-13','15:45:00',2.04),('3355','2013-07-13','15:50:00',2),('3355','2013-07-13','15:55:00',1.98),('3355','2013-07-13','16:00:00',1.96),('3355','2013-07-13','16:05:00',1.92),('3355','2013-07-13','16:10:00',1.89),('3355','2013-07-13','16:15:00',1.85),('3355','2013-07-13','16:20:00',1.81),('3355','2013-07-13','16:25:00',1.82),('3355','2013-07-13','16:30:00',1.79),('3355','2013-07-13','16:35:00',1.74),('3355','2013-07-13','16:40:00',1.71),('3355','2013-07-13','16:45:00',1.66),('3355','2013-07-13','16:50:00',1.62),('3355','2013-07-13','16:55:00',1.59),('3355','2013-07-13','17:00:00',1.55),('3355','2013-07-13','17:05:00',1.48),('3355','2013-07-13','17:10:00',1.47),('3355','2013-07-13','17:15:00',1.42),('3355','2013-07-13','17:20:00',1.34),('3355','2013-07-13','17:25:00',1.35),('3355','2013-07-13','17:30:00',1.28),('3355','2013-07-13','17:35:00',1.23),('3355','2013-07-13','17:40:00',1.21),('3355','2013-07-13','17:45:00',1.17),('3355','2013-07-13','17:50:00',1.11),('3355','2013-07-13','17:55:00',1.11),('3355','2013-07-13','18:00:00',1.02),('3355','2013-07-12','09:25:00',1.27),('3355','2013-07-12','09:35:00',1.01),('3355','2013-07-12','09:45:00',1.35),('3355','2013-07-12','09:50:00',1.44),('3355','2013-07-12','09:55:00',1.44),('3355','2013-07-12','10:00:00',1.23),('3355','2013-07-12','10:05:00',1.5),('3355','2013-07-12','10:10:00',1.56),('3355','2013-07-12','10:15:00',1.34),('3355','2013-07-12','10:30:00',1.14),('3355','2013-07-12','10:35:00',1.29),('3355','2013-07-12','10:55:00',1.52),('3355','2013-07-12','11:00:00',2.19),('3355','2013-07-12','11:05:00',1.12),('3355','2013-07-12','11:15:00',1.76),('3355','2013-07-12','11:25:00',1.67),('3355','2013-07-12','11:30:00',2.08),('3355','2013-07-12','11:35:00',2),('3355','2013-07-12','11:45:00',1.18),('3355','2013-07-12','11:55:00',2.26),('3355','2013-07-12','12:00:00',2.29),('3355','2013-07-12','12:05:00',2.36),('3355','2013-07-12','12:10:00',1.45),('3355','2013-07-12','12:15:00',1.32),('3355','2013-07-12','12:20:00',2.41),('3355','2013-07-12','12:25:00',2.39),('3355','2013-07-12','12:30:00',1.82),('3355','2013-07-12','12:35:00',2.51),('3355','2013-07-12','12:40:00',1.04),('3355','2013-07-12','12:45:00',2.37),('3355','2013-07-12','12:50:00',1.25),('3355','2013-07-12','12:55:00',2.27),('3355','2013-07-12','13:00:00',2.25),('3355','2013-07-12','13:05:00',2.37),('3355','2013-07-12','13:10:00',2.32),('3355','2013-07-12','13:15:00',2.25),('3355','2013-07-12','13:20:00',2.31),('3355','2013-07-12','13:25:00',2.3),('3355','2013-07-12','13:30:00',2.32),('3355','2013-07-12','13:35:00',2.32),('3355','2013-07-12','13:40:00',2.31),('3355','2013-07-12','13:45:00',2.29),('3355','2013-07-12','13:50:00',1.55),('3355','2013-07-12','13:55:00',2.35),('3355','2013-07-12','14:00:00',2.37),('3355','2013-07-12','14:05:00',2.17),('3355','2013-07-12','14:10:00',1.86),('3355','2013-07-12','14:15:00',1.66),('3355','2013-07-12','14:20:00',2.47),('3355','2013-07-12','14:25:00',2.34),('3355','2013-07-12','14:30:00',2.26),('3355','2013-07-12','14:35:00',2.19),('3355','2013-07-12','14:40:00',2.16),('3355','2013-07-12','14:45:00',2.14),('3355','2013-07-12','14:50:00',2.14),('3355','2013-07-12','14:55:00',2.16),('3355','2013-07-12','15:00:00',2.12),('3355','2013-07-12','15:05:00',2.11),('3355','2013-07-12','15:10:00',2.13),('3355','2013-07-12','15:15:00',2.1),('3355','2013-07-12','15:20:00',2.07),('3355','2013-07-12','15:25:00',2.05),('3355','2013-07-12','15:30:00',2.02),('3355','2013-07-12','15:35:00',1.99),('3355','2013-07-12','15:40:00',2.01),('3355','2013-07-12','15:45:00',1.97),('3355','2013-07-12','15:50:00',1.94),('3355','2013-07-12','15:55:00',1.88),('3355','2013-07-12','16:00:00',1.88),('3355','2013-07-12','16:05:00',1.84),('3355','2013-07-12','16:10:00',1.82),('3355','2013-07-12','16:15:00',1.79),('3355','2013-07-12','16:20:00',1.76),('3355','2013-07-12','16:25:00',1.74),('3355','2013-07-12','16:30:00',1.69),('3355','2013-07-12','16:35:00',1.67),('3355','2013-07-12','16:40:00',1.65),('3355','2013-07-12','16:45:00',1.62),('3355','2013-07-12','16:50:00',1.58),('3355','2013-07-12','16:55:00',1.53),('3355','2013-07-12','17:00:00',1.49),('3355','2013-07-12','17:05:00',1.45),('3355','2013-07-12','17:10:00',1.41),('3355','2013-07-12','17:15:00',1.38),('3355','2013-07-12','17:20:00',1.33),('3355','2013-07-12','17:25:00',1.27),('3355','2013-07-12','17:30:00',1.24),('3355','2013-07-12','17:35:00',1.2),('3355','2013-07-12','17:40:00',1.16),('3355','2013-07-12','17:45:00',1.1),('3355','2013-07-12','17:50:00',1.05),('3355','2013-07-12','17:55:00',1.01),('3355','2013-07-11','09:00:00',1.07),('3355','2013-07-11','09:05:00',1.11),('3355','2013-07-11','09:10:00',1.13),('3355','2013-07-11','09:15:00',1.2),('3355','2013-07-11','09:20:00',1.29),('3355','2013-07-11','09:25:00',1.3),('3355','2013-07-11','09:30:00',1.27),('3355','2013-07-11','09:40:00',1.45),('3355','2013-07-11','09:45:00',1.5),('3355','2013-07-11','09:50:00',1.01),('3355','2013-07-11','10:05:00',1.24),('3355','2013-07-11','10:10:00',1.25),('3355','2013-07-11','10:15:00',1.7),('3355','2013-07-11','10:20:00',1.73),('3355','2013-07-11','10:25:00',1.62),('3355','2013-07-11','10:30:00',1.58),('3355','2013-07-11','10:50:00',1.72),('3355','2013-07-11','10:55:00',2.03),('3355','2013-07-11','11:00:00',1.91),('3355','2013-07-11','11:10:00',1.89),('3355','2013-07-11','11:15:00',1.8),('3355','2013-07-11','11:20:00',1.84),('3355','2013-07-11','11:25:00',1.83),('3355','2013-07-11','11:30:00',2.14),('3355','2013-07-11','11:35:00',2.07),('3355','2013-07-11','11:40:00',1.8),('3355','2013-07-11','11:45:00',1.93),('3355','2013-07-11','11:50:00',1.88),('3355','2013-07-11','11:55:00',1.75),('3355','2013-07-11','12:05:00',1.55),('3355','2013-07-11','12:20:00',2.42),('3355','2013-07-11','12:25:00',2.37),('3355','2013-07-11','12:30:00',2.37),('3355','2013-07-11','12:35:00',2.43),('3355','2013-07-11','12:40:00',2.38),('3355','2013-07-11','12:45:00',2.31),('3355','2013-07-11','12:50:00',1.79),('3355','2013-07-11','12:55:00',2.37),('3355','2013-07-11','13:00:00',1.87),('3355','2013-07-11','13:10:00',1.86),('3355','2013-07-11','13:15:00',2.45),('3355','2013-07-11','13:20:00',2.38),('3355','2013-07-11','13:25:00',2.37),('3355','2013-07-11','13:30:00',2.38),('3355','2013-07-11','13:35:00',2.45),('3355','2013-07-11','13:40:00',2.33),('3355','2013-07-11','13:45:00',2.31),('3355','2013-07-11','13:50:00',1.47),('3355','2013-07-11','14:00:00',1.42),('3355','2013-07-11','14:05:00',2.28),('3355','2013-07-11','14:10:00',2.19),('3355','2013-07-11','14:15:00',2.4),('3355','2013-07-11','14:20:00',2.09),('3355','2013-07-11','14:25:00',2.28),('3355','2013-07-11','14:30:00',1.83),('3355','2013-07-11','14:35:00',2.3),('3355','2013-07-11','14:40:00',2.26),('3355','2013-07-11','14:45:00',2.29),('3355','2013-07-11','14:50:00',2.2),('3355','2013-07-11','14:55:00',1.31),('3355','2013-07-11','15:00:00',2.05),('3355','2013-07-11','15:05:00',1.83),('3355','2013-07-11','15:10:00',1.24),('3355','2013-07-11','15:15:00',1.56),('3355','2013-07-11','15:20:00',1.57),('3355','2013-07-11','15:25:00',1.41),('3355','2013-07-11','15:30:00',1.72),('3355','2013-07-11','15:35:00',2.03),('3355','2013-07-11','15:40:00',1.6),('3355','2013-07-11','15:45:00',1.38),('3355','2013-07-11','15:50:00',1.59),('3355','2013-07-11','16:00:00',1.37),('3355','2013-07-11','16:05:00',1.62),('3355','2013-07-11','16:10:00',1.83),('3355','2013-07-11','16:15:00',1.67),('3355','2013-07-11','16:20:00',1.99),('3355','2013-07-11','16:25:00',1.75),('3355','2013-07-11','16:30:00',2),('3355','2013-07-11','16:35:00',1.33),('3355','2013-07-11','16:40:00',1.78),('3355','2013-07-11','16:45:00',1.38),('3355','2013-07-11','16:50:00',1.78),('3355','2013-07-11','16:55:00',1.48),('3355','2013-07-11','17:00:00',1.34),('3355','2013-07-11','17:05:00',1.62),('3355','2013-07-11','17:10:00',1.56),('3355','2013-07-11','17:15:00',1.28),('3355','2013-07-11','17:20:00',1.33),('3355','2013-07-11','17:30:00',1.26),('3355','2013-07-11','17:35:00',1.33),('3355','2013-07-11','17:45:00',1.22),('3355','2013-07-11','17:55:00',1.06),('3355','2014-05-03','08:45:00',1.08),('3355','2014-05-03','08:50:00',1.21),('3355','2014-05-03','08:55:00',1.28),('3355','2014-05-03','09:00:00',1.47),('3355','2014-05-03','09:05:00',1.49),('3355','2014-05-03','09:20:00',1.44),('3355','2014-05-03','09:25:00',1.63),('3355','2014-05-03','09:30:00',1.46),('3355','2014-05-03','09:35:00',1.16),('3355','2014-05-03','09:45:00',1.26),('3355','2014-05-03','09:55:00',1.88),('3355','2014-05-03','10:00:00',1.86),('3355','2014-05-03','10:05:00',1.88),('3355','2014-05-03','10:10:00',1.95),('3355','2014-05-03','10:15:00',1.95),('3355','2014-05-03','10:20:00',1.72),('3355','2014-05-03','10:25:00',1.04),('3355','2014-05-03','10:45:00',1.26),('3355','2014-05-03','10:55:00',1.39),('3355','2014-05-03','11:00:00',1.04),('3355','2014-05-03','11:05:00',1.93),('3355','2014-05-03','11:10:00',2.44),('3355','2014-05-03','11:20:00',1.46),('3355','2014-05-03','11:25:00',1.96),('3355','2014-05-03','11:30:00',2.32),('3355','2014-05-03','11:35:00',1.39),('3355','2014-05-03','11:40:00',1.55),('3355','2014-05-03','11:45:00',1.24),('3355','2014-05-03','11:50:00',1.18),('3355','2014-05-03','11:55:00',1.26),('3355','2014-05-03','12:00:00',1.05),('3355','2014-05-03','12:35:00',1.16),('3355','2014-05-03','12:40:00',1.02),('3355','2014-05-03','12:45:00',1.05),('3355','2014-05-03','12:50:00',1.06),('3355','2014-05-03','12:55:00',1.09),('3355','2014-05-03','13:00:00',1.09),('3355','2014-05-03','13:05:00',1.05),('3355','2014-05-03','13:10:00',1.63),('3355','2014-05-03','13:15:00',1.39),('3355','2014-05-03','13:20:00',1.53),('3355','2014-05-03','13:25:00',1.63),('3355','2014-05-03','13:30:00',1.63),('3355','2014-05-03','13:35:00',1.11),('3355','2014-05-03','14:10:00',1.07),('3355','2014-05-03','14:15:00',1.26),('3355','2014-05-03','14:20:00',1.52),('3355','2014-05-03','14:25:00',2.09),('3355','2014-05-03','14:30:00',1.06),('3355','2014-04-06','09:05:00',1.06),('3355','2014-04-06','09:10:00',1.1),('3355','2014-04-06','09:15:00',1.17),('3355','2014-04-06','09:20:00',1),('3355','2014-04-06','09:25:00',1.02),('3355','2014-04-06','09:35:00',1.22),('3355','2014-04-06','09:40:00',1.34),('3355','2014-04-06','09:45:00',1.78),('3355','2014-04-06','09:50:00',1.86),('3355','2014-04-06','09:55:00',1.78),('3355','2014-04-06','10:00:00',1.75),('3355','2014-04-06','10:05:00',1.49),('3355','2014-04-06','10:10:00',1.65),('3355','2014-04-06','10:15:00',1.41),('3355','2014-04-06','10:45:00',1.73),('3355','2014-04-06','10:50:00',1.67),('3355','2014-04-06','11:00:00',1.3),('3355','2014-04-06','11:05:00',1.03),('3355','2014-04-06','11:10:00',1.77),('3355','2014-04-06','11:15:00',1.82),('3355','2014-04-06','11:20:00',2.23),('3355','2014-04-06','11:25:00',2.22),('3355','2014-04-06','11:30:00',2.29),('3355','2014-04-06','11:35:00',2.42),('3355','2014-04-06','11:40:00',2.38),('3355','2014-04-06','11:45:00',2.33),('3355','2014-04-06','11:50:00',2.36),('3355','2014-04-06','11:55:00',2.43),('3355','2014-04-06','12:00:00',2.33),('3355','2014-04-06','12:05:00',2.31),('3355','2014-04-06','12:10:00',2.31),('3355','2014-04-06','12:15:00',2.39),('3355','2014-04-06','12:20:00',1.84),('3355','2014-04-06','12:25:00',2.08),('3355','2014-04-06','12:30:00',1.86),('3355','2014-04-06','12:35:00',1.94),('3355','2014-04-06','12:40:00',1.98),('3355','2014-04-06','12:45:00',1.66),('3355','2014-04-06','12:55:00',2.03),('3355','2014-04-06','13:00:00',2.5),('3355','2014-04-06','13:05:00',2.08),('3355','2014-04-06','13:10:00',2.69),('3355','2014-04-06','13:15:00',2.27),('3355','2014-04-06','13:30:00',2.36),('3355','2014-04-06','13:40:00',1.8),('3355','2014-04-06','13:45:00',2.59),('3355','2014-04-06','13:50:00',2.28),('3355','2014-04-06','13:55:00',2.43),('3355','2014-04-06','14:00:00',2.38),('3355','2014-04-06','14:05:00',2.36),('3355','2014-04-06','14:10:00',2.4),('3355','2014-04-06','14:15:00',2.42),('3355','2014-04-06','14:20:00',2.18),('3355','2014-04-06','14:25:00',1.41),('3355','2014-04-06','14:35:00',1.61),('3355','2014-04-06','14:40:00',2.14),('3355','2014-04-06','14:45:00',2.61),('3355','2014-04-06','14:50:00',2),('3355','2014-04-06','14:55:00',1.23),('3355','2014-04-06','15:00:00',1.39),('3355','2014-04-06','15:10:00',1.76),('3355','2014-04-06','15:15:00',1.61),('3355','2014-04-06','15:55:00',2.37),('3355','2014-04-06','16:00:00',1.61),('3355','2014-04-06','16:35:00',1.27),('3355','2014-04-06','16:40:00',1.18),('3355','2014-04-06','16:45:00',1.85),('3355','2014-04-06','16:50:00',1.76),('3355','2014-04-06','17:25:00',1.22),('3355','2014-04-06','17:30:00',1.12),('3355','2014-04-06','17:35:00',1.01),('3355','2013-07-10','08:25:00',1.1),('3355','2013-07-10','08:30:00',1.11),('3355','2013-07-10','08:35:00',1.24),('3355','2013-07-10','08:40:00',1.13),('3355','2013-07-10','08:45:00',1.1),('3355','2013-07-10','08:50:00',1.11),('3355','2013-07-10','08:55:00',1.09),('3355','2013-07-10','09:00:00',1.12),('3355','2013-07-10','09:05:00',1.18),('3355','2013-07-10','09:10:00',1.24),('3355','2013-07-10','09:15:00',1.3),('3355','2013-07-10','09:20:00',1.32),('3355','2013-07-10','09:25:00',1.34),('3355','2013-07-10','09:30:00',1.37),('3355','2013-07-10','09:35:00',1.38),('3355','2013-07-10','09:40:00',1.42),('3355','2013-07-10','09:45:00',1.45),('3355','2013-07-10','09:50:00',1.47),('3355','2013-07-10','09:55:00',1.48),('3355','2013-07-10','10:00:00',1.45),('3355','2013-07-10','10:05:00',1.56),('3355','2013-07-10','10:10:00',1.6),('3355','2013-07-10','10:15:00',1.63),('3355','2013-07-10','10:20:00',1.67),('3355','2013-07-10','10:25:00',1.68),('3355','2013-07-10','10:30:00',1.7),('3355','2013-07-10','10:35:00',1.74),('3355','2013-07-10','10:40:00',1.8),('3355','2013-07-10','10:45:00',1.82),('3355','2013-07-10','10:50:00',1.86),('3355','2013-07-10','10:55:00',1.87),('3355','2013-07-10','11:00:00',1.88),('3355','2013-07-10','11:05:00',1.89),('3355','2013-07-10','11:10:00',1.91),('3355','2013-07-10','11:15:00',1.94),('3355','2013-07-10','11:20:00',1.94),('3355','2013-07-10','11:25:00',1.92),('3355','2013-07-10','11:30:00',1.98),('3355','2013-07-10','11:35:00',1.99),('3355','2013-07-10','11:40:00',2.02),('3355','2013-07-10','11:45:00',2.04),('3355','2013-07-10','11:50:00',2.06),('3355','2013-07-10','11:55:00',2.08),('3355','2013-07-10','12:00:00',2.1),('3355','2013-07-10','12:05:00',2.14),('3355','2013-07-10','12:10:00',2.13),('3355','2013-07-10','12:15:00',2.11),('3355','2013-07-10','12:20:00',2.15),('3355','2013-07-10','12:25:00',2.16),('3355','2013-07-10','12:30:00',2.17),('3355','2013-07-10','12:35:00',2.22),('3355','2013-07-10','12:40:00',2.2),('3355','2013-07-10','12:45:00',2.19),('3355','2013-07-10','12:50:00',2.2),('3355','2013-07-10','12:55:00',2.2),('3355','2013-07-10','13:00:00',2.21),('3355','2013-07-10','13:05:00',2.22),('3355','2013-07-10','13:10:00',2.25),('3355','2013-07-10','13:15:00',2.26),('3355','2013-07-10','13:20:00',2.25),('3355','2013-07-10','13:25:00',2.25),('3355','2013-07-10','13:30:00',2.25),('3355','2013-07-10','13:35:00',2.25),('3355','2013-07-10','13:40:00',2.26),('3355','2013-07-10','13:45:00',2.27),('3355','2013-07-10','13:50:00',2.28),('3355','2013-07-10','13:55:00',2.27),('3355','2013-07-10','14:00:00',2.29),('3355','2013-07-10','14:05:00',2.29),('3355','2013-07-10','14:10:00',2.28),('3355','2013-07-10','14:15:00',2.27),('3355','2013-07-10','14:20:00',2.25),('3355','2013-07-10','14:25:00',2.24),('3355','2013-07-10','14:30:00',2.23),('3355','2013-07-10','14:35:00',2.22),('3355','2013-07-10','14:40:00',2.22),('3355','2013-07-10','14:45:00',2.21),('3355','2013-07-10','14:50:00',2.19),('3355','2013-07-10','14:55:00',2.18),('3355','2013-07-10','15:00:00',2.18),('3355','2013-07-10','15:05:00',2.16),('3355','2013-07-10','15:10:00',2.13),('3355','2013-07-10','15:15:00',2.12),('3355','2013-07-10','15:20:00',2.09),('3355','2013-07-10','15:25:00',2.07),('3355','2013-07-10','15:30:00',2.06),('3355','2013-07-10','15:35:00',2.05),('3355','2013-07-10','15:40:00',2.02),('3355','2013-07-10','15:45:00',1.98),('3355','2013-07-10','15:50:00',1.96),('3355','2013-07-10','15:55:00',1.94),('3355','2013-07-10','16:00:00',1.92),('3355','2013-07-10','16:05:00',1.89),('3355','2013-07-10','16:10:00',1.85),('3355','2013-07-10','16:15:00',1.83),('3355','2013-07-10','16:20:00',1.79),('3355','2013-07-10','16:25:00',1.76),('3355','2013-07-10','16:30:00',1.72),('3355','2013-07-10','16:35:00',1.69),('3355','2013-07-10','16:40:00',1.65),('3355','2013-07-10','16:45:00',1.62),('3355','2013-07-10','16:50:00',1.59),('3355','2013-07-10','16:55:00',1.58),('3355','2013-07-10','17:00:00',1.58),('3355','2013-07-10','17:05:00',1.45),('3355','2013-07-10','17:10:00',1.35),('3355','2013-07-10','17:35:00',1.35),('3355','2013-07-10','17:40:00',1.09),('3355','2013-07-10','17:45:00',1.16),('3355','2013-07-10','17:50:00',1.09),('3355','2013-07-10','17:55:00',1.02),('3355','2013-07-09','08:55:00',1.04),('3355','2013-07-09','09:00:00',1.08),('3355','2013-07-09','09:05:00',1.12),('3355','2013-07-09','09:10:00',1.16),('3355','2013-07-09','09:15:00',1.2),('3355','2013-07-09','09:20:00',1.24),('3355','2013-07-09','09:25:00',1.28),('3355','2013-07-09','09:30:00',1.32),('3355','2013-07-09','09:35:00',1.37),('3355','2013-07-09','09:40:00',1.4),('3355','2013-07-09','09:45:00',1.45),('3355','2013-07-09','09:50:00',1.48),('3355','2013-07-09','09:55:00',1.51),('3355','2013-07-09','10:00:00',1.53),('3355','2013-07-09','10:05:00',1.57),('3355','2013-07-09','10:10:00',1.6),('3355','2013-07-09','10:15:00',1.63),('3355','2013-07-09','10:20:00',1.66),('3355','2013-07-09','10:25:00',1.69),('3355','2013-07-09','10:30:00',1.72),('3355','2013-07-09','10:35:00',1.74),('3355','2013-07-09','10:40:00',1.76),('3355','2013-07-09','10:45:00',1.79),('3355','2013-07-09','10:50:00',1.83),('3355','2013-07-09','10:55:00',1.87),('3355','2013-07-09','11:00:00',1.9),('3355','2013-07-09','11:05:00',1.85),('3355','2013-07-09','11:10:00',1.69),('3355','2013-07-09','11:15:00',1.74),('3355','2013-07-09','11:20:00',1.69),('3355','2013-07-09','11:25:00',1.57),('3355','2013-07-09','11:35:00',1.18),('3355','2013-07-09','11:40:00',1.64),('3355','2013-07-09','11:45:00',2.07),('3355','2013-07-09','11:50:00',2.34),('3355','2013-07-09','11:55:00',2.32),('3355','2013-07-09','12:00:00',2.31),('3355','2013-07-09','12:05:00',2.28),('3355','2013-07-09','12:10:00',2.22),('3355','2013-07-09','12:15:00',2.15),('3355','2013-07-09','12:20:00',2.11),('3355','2013-07-09','12:25:00',2.11),('3355','2013-07-09','12:30:00',2.13),('3355','2013-07-09','12:35:00',2.13),('3355','2013-07-09','12:40:00',2.16),('3355','2013-07-09','12:45:00',2.17),('3355','2013-07-09','12:50:00',2.21),('3355','2013-07-09','12:55:00',2.21),('3355','2013-07-09','13:00:00',2.21),('3355','2013-07-09','13:05:00',2.21),('3355','2013-07-09','13:10:00',2.27),('3355','2013-07-09','13:15:00',2.31),('3355','2013-07-09','13:20:00',2.31),('3355','2013-07-09','13:25:00',2.26),('3355','2013-07-09','13:30:00',2.31),('3355','2013-07-09','13:35:00',2.16),('3355','2013-07-09','13:40:00',2.11),('3355','2013-07-09','13:45:00',1.81),('3355','2013-07-09','13:50:00',1.67),('3355','2013-07-09','13:55:00',1.61),('3355','2013-07-09','14:00:00',1.66),('3355','2013-07-09','14:05:00',1.62),('3355','2013-07-09','14:10:00',1.83),('3355','2013-07-09','14:15:00',1.9),('3355','2013-07-09','14:20:00',1.56),('3355','2013-07-09','14:25:00',1.21),('3355','2013-07-08','08:55:00',1.03),('3355','2013-07-08','09:00:00',1.07),('3355','2013-07-08','09:05:00',1.11),('3355','2013-07-08','09:10:00',1.14),('3355','2013-07-08','09:15:00',1.17),('3355','2013-07-08','09:20:00',1.19),('3355','2013-07-08','09:25:00',1.22),('3355','2013-07-08','09:30:00',1.29),('3355','2013-07-08','09:35:00',1.37),('3355','2013-07-08','09:40:00',1.41),('3355','2013-07-08','09:45:00',1.43),('3355','2013-07-08','09:50:00',1.44),('3355','2013-07-08','09:55:00',1.5),('3355','2013-07-08','10:00:00',1.54),('3355','2013-07-08','10:05:00',1.57),('3355','2013-07-08','10:10:00',1.59),('3355','2013-07-08','10:15:00',1.64),('3355','2013-07-08','10:20:00',1.67),('3355','2013-07-08','10:25:00',1.7),('3355','2013-07-08','10:30:00',1.74),('3355','2013-07-08','10:35:00',1.76),('3355','2013-07-08','10:40:00',1.78),('3355','2013-07-08','10:45:00',1.79),('3355','2013-07-08','10:50:00',1.81),('3355','2013-07-08','10:55:00',1.84),('3355','2013-07-08','11:00:00',1.86),('3355','2013-07-08','11:05:00',1.9),('3355','2013-07-08','11:10:00',1.93),('3355','2013-07-08','11:15:00',1.96),('3355','2013-07-08','11:20:00',1.99),('3355','2013-07-08','11:25:00',2.02),('3355','2013-07-08','11:30:00',2.06),('3355','2013-07-08','11:35:00',2.08),('3355','2013-07-08','11:40:00',1.96),('3355','2013-07-08','11:45:00',2.09),('3355','2013-07-08','11:50:00',2.11),('3355','2013-07-08','11:55:00',2.07),('3355','2013-07-08','12:00:00',2.11),('3355','2013-07-08','12:05:00',2.16),('3355','2013-07-08','12:10:00',2.19),('3355','2013-07-08','12:15:00',2.22),('3355','2013-07-08','12:20:00',2.29),('3355','2013-07-08','12:25:00',2.24),('3355','2013-07-08','12:30:00',2.09),('3355','2013-07-08','12:35:00',2.24),('3355','2013-07-08','12:40:00',2.21),('3355','2013-07-08','12:45:00',2.21),('3355','2013-07-08','12:50:00',2.22),('3355','2013-07-08','12:55:00',2.26),('3355','2013-07-08','13:00:00',2.31),('3355','2013-07-08','13:05:00',2.34),('3355','2013-07-08','13:10:00',2.45),('3355','2013-07-08','13:15:00',2.41),('3355','2013-07-08','13:20:00',1.68),('3355','2013-07-07','08:55:00',1.08),('3355','2013-07-07','09:00:00',1.1),('3355','2013-07-07','09:05:00',1.06),('3355','2013-07-07','09:10:00',1.09),('3355','2013-07-07','09:15:00',1.08),('3355','2013-07-07','09:25:00',1.11),('3355','2013-07-07','09:30:00',1.38),('3355','2013-07-07','09:35:00',1.42),('3355','2013-07-07','09:40:00',1.31),('3355','2013-07-07','09:45:00',1.58),('3355','2013-07-07','09:50:00',1.59),('3355','2013-07-07','09:55:00',1.6),('3355','2013-07-07','10:00:00',1.62),('3355','2013-07-07','10:05:00',1.56),('3355','2013-07-07','10:10:00',1.65),('3355','2013-07-07','10:15:00',1.58),('3355','2013-07-07','10:20:00',1.61),('3355','2013-07-07','10:25:00',1.49),('3355','2013-07-07','10:30:00',1.63),('3355','2013-07-07','10:35:00',1.88),('3355','2013-07-07','10:40:00',1.69),('3355','2013-07-07','10:45:00',1.84),('3355','2013-07-07','10:50:00',1.89),('3355','2013-07-07','10:55:00',1.89),('3355','2013-07-07','11:00:00',1.92),('3355','2013-07-07','11:05:00',1.96),('3355','2013-07-07','11:10:00',1.98),('3355','2013-07-07','11:15:00',1.97),('3355','2013-07-07','11:20:00',1.87),('3355','2013-07-07','11:25:00',1.68),('3355','2013-07-07','11:30:00',1.78),('3355','2013-07-07','11:35:00',1.74),('3355','2013-07-07','11:40:00',1.82),('3355','2013-07-07','11:45:00',1.37),('3355','2013-07-07','11:50:00',1.47),('3355','2013-07-07','12:00:00',1.49),('3355','2013-07-07','12:05:00',2.06),('3355','2013-07-07','12:10:00',2.11),('3355','2013-07-07','12:15:00',2.25),('3355','2013-07-07','12:20:00',2.18),('3355','2013-07-07','12:25:00',2.05),('3355','2013-07-07','12:30:00',2.07),('3355','2013-07-07','12:35:00',2.21),('3355','2013-07-07','12:40:00',2.26),('3355','2013-07-07','12:45:00',2.26),('3355','2013-07-07','12:50:00',2.2),('3355','2013-07-07','12:55:00',2.3),('3355','2013-07-07','13:00:00',2.23),('3355','2013-07-07','13:05:00',2.27),('3355','2013-07-07','13:10:00',2.29),('3355','2013-07-07','13:15:00',2.24),('3355','2013-07-07','13:20:00',2.25),('3355','2013-07-07','13:25:00',1.5),('3355','2013-07-07','13:30:00',2.21),('3355','2013-07-07','13:35:00',2.32),('3355','2013-07-07','13:40:00',2.33),('3355','2013-07-07','13:45:00',2.4),('3355','2013-07-07','13:50:00',2.31),('3355','2013-07-07','13:55:00',1.36),('3355','2013-07-07','14:00:00',1.84),('3355','2013-07-07','14:05:00',2.2),('3355','2013-07-07','14:10:00',1.07),('3355','2013-07-07','14:15:00',1.17),('3355','2013-07-06','08:50:00',1.01),('3355','2013-07-06','08:55:00',1.05),('3355','2013-07-06','09:00:00',1.1),('3355','2013-07-06','09:05:00',1.15),('3355','2013-07-06','09:10:00',1.19),('3355','2013-07-06','09:15:00',1.23),('3355','2013-07-06','09:20:00',1.27),('3355','2013-07-06','09:25:00',1.31),('3355','2013-07-06','09:30:00',1.34),('3355','2013-07-06','09:35:00',1.37),('3355','2013-07-06','09:40:00',1.41),('3355','2013-07-06','09:45:00',1.45),('3355','2013-07-06','09:50:00',1.49),('3355','2013-07-06','09:55:00',1.52),('3355','2013-07-06','10:00:00',1.56),('3355','2013-07-06','10:05:00',1.6),('3355','2013-07-06','10:10:00',1.64),('3355','2013-07-06','10:15:00',1.67),('3355','2013-07-06','10:20:00',1.7),('3355','2013-07-06','10:25:00',1.72),('3355','2013-07-06','10:30:00',1.75),('3355','2013-07-06','10:35:00',1.78),('3355','2013-07-06','10:40:00',1.81),('3355','2013-07-06','10:45:00',1.83),('3355','2013-07-06','10:50:00',1.88),('3355','2013-07-06','10:55:00',1.91),('3355','2013-07-06','11:00:00',1.92),('3355','2013-07-06','11:05:00',1.94),('3355','2013-07-06','11:10:00',1.95),('3355','2013-07-06','11:15:00',1.97),('3355','2013-07-06','11:20:00',2),('3355','2013-07-06','11:25:00',2.03),('3355','2013-07-06','11:30:00',2.01),('3355','2013-07-06','11:35:00',2.03),('3355','2013-07-06','11:40:00',2.04),('3355','2013-07-06','11:45:00',2.07),('3355','2013-07-06','11:50:00',2.09),('3355','2013-07-06','11:55:00',2.11),('3355','2013-07-06','12:00:00',2.12),('3355','2013-07-06','12:05:00',2.15),('3355','2013-07-06','12:10:00',2.17),('3355','2013-07-06','12:15:00',2.16),('3355','2013-07-06','12:20:00',2.18),('3355','2013-07-06','12:25:00',2.19),('3355','2013-07-06','12:30:00',2.22),('3355','2013-07-06','12:35:00',2.2),('3355','2013-07-06','12:40:00',2.21),('3355','2013-07-06','12:45:00',2.23),('3355','2013-07-06','12:50:00',2.22),('3355','2013-07-06','12:55:00',2.24),('3355','2013-07-06','13:00:00',2.25),('3355','2013-07-06','13:05:00',2.27),('3355','2013-07-06','13:10:00',2.28),('3355','2013-07-06','13:15:00',2.28),('3355','2013-07-06','13:20:00',2.27),('3355','2013-07-06','13:25:00',2.25),('3355','2013-07-06','13:30:00',2.28),('3355','2013-07-06','13:35:00',2.25),('3355','2013-07-06','13:40:00',2.27),('3355','2013-07-06','13:45:00',2.26),('3355','2013-07-06','13:50:00',2.24),('3355','2013-07-06','13:55:00',2.24),('3355','2013-07-06','14:00:00',2.25),('3355','2013-07-06','14:05:00',2.25),('3355','2013-07-06','14:10:00',2.24),('3355','2013-07-06','14:15:00',1.6),('3355','2013-07-06','14:20:00',2.04),('3355','2013-07-06','14:25:00',2.25),('3355','2013-07-06','14:30:00',2.21),('3355','2013-07-06','14:35:00',2.21),('3355','2013-07-06','14:40:00',2.19),('3355','2013-07-06','14:45:00',2.18),('3355','2013-07-06','14:50:00',2.08),('3355','2013-07-06','14:55:00',2.21),('3355','2013-07-06','15:00:00',2.04),('3355','2013-07-06','15:05:00',1.6),('3355','2013-07-06','15:10:00',2.2),('3355','2013-07-06','15:15:00',2.13),('3355','2013-07-06','15:20:00',2.1),('3355','2013-07-06','15:25:00',2.11),('3355','2013-07-06','15:30:00',2.1),('3355','2013-07-06','15:35:00',1.01),('3355','2013-07-05','08:50:00',1.02),('3355','2013-07-05','08:55:00',1.06),('3355','2013-07-05','09:00:00',1.1),('3355','2013-07-05','09:05:00',1.15),('3355','2013-07-05','09:10:00',1.18),('3355','2013-07-05','09:15:00',1.23),('3355','2013-07-05','09:20:00',1.27),('3355','2013-07-05','09:25:00',1.32),('3355','2013-07-05','09:30:00',1.35),('3355','2013-07-05','09:35:00',1.4),('3355','2013-07-05','09:40:00',1.43),('3355','2013-07-05','09:45:00',1.46),('3355','2013-07-05','09:50:00',1.5),('3355','2013-07-05','09:55:00',1.53),('3355','2013-07-05','10:00:00',1.56),('3355','2013-07-05','10:05:00',1.6),('3355','2013-07-05','10:10:00',1.63),('3355','2013-07-05','10:15:00',1.66),('3355','2013-07-05','10:20:00',1.69),('3355','2013-07-05','10:25:00',1.72),('3355','2013-07-05','10:30:00',1.76),('3355','2013-07-05','10:35:00',1.78),('3355','2013-07-05','10:40:00',1.79),('3355','2013-07-05','10:45:00',1.81),('3355','2013-07-05','10:50:00',1.84),('3355','2013-07-05','10:55:00',1.87),('3355','2013-07-05','11:00:00',1.89),('3355','2013-07-05','11:05:00',1.9),('3355','2013-07-05','11:10:00',1.93),('3355','2013-07-05','11:15:00',1.95),('3355','2013-07-05','11:20:00',1.95),('3355','2013-07-05','11:25:00',1.99),('3355','2013-07-05','11:30:00',2.01),('3355','2013-07-05','11:35:00',2.03),('3355','2013-07-05','11:40:00',2.04),('3355','2013-07-05','11:45:00',2.05),('3355','2013-07-05','11:50:00',2.07),('3355','2013-07-05','11:55:00',2.08),('3355','2013-07-05','12:00:00',2.09),('3355','2013-07-05','12:05:00',2.11),('3355','2013-07-05','12:10:00',2.11),('3355','2013-07-05','12:15:00',2.12),('3355','2013-07-05','12:20:00',2.16),('3355','2013-07-05','12:25:00',1.01),('3355','2013-07-05','12:30:00',2.22),('3355','2013-07-05','12:35:00',2.17),('3355','2013-07-05','12:40:00',2.12),('3355','2013-07-05','12:45:00',2.05),('3355','2013-07-05','12:50:00',2.2),('3355','2013-07-05','12:55:00',2.23),('3355','2013-07-05','13:00:00',2.22),('3355','2013-07-05','13:05:00',1.03),('3355','2013-07-05','13:10:00',2.27),('3355','2013-07-05','13:15:00',2.21),('3355','2013-07-05','13:20:00',2.04),('3355','2013-07-05','13:25:00',1.82),('3355','2013-07-05','13:30:00',2.2),('3355','2013-07-05','13:35:00',2.26),('3355','2013-07-05','13:40:00',2.22),('3355','2013-07-05','13:45:00',2.29),('3355','2013-07-05','13:50:00',2.24),('3355','2013-07-05','13:55:00',2.27),('3355','2013-07-05','14:00:00',2.29),('3355','2013-07-05','14:05:00',2.25),('3355','2013-07-05','14:10:00',2.22),('3355','2013-07-05','14:15:00',2.22),('3355','2013-07-05','14:20:00',2.19),('3355','2013-07-05','14:25:00',2.23),('3355','2013-07-05','14:30:00',2.06),('3355','2013-07-05','14:35:00',2.2),('3355','2013-07-05','14:40:00',2.19),('3355','2013-07-05','14:45:00',1.69),('3355','2013-07-05','14:50:00',2.18),('3355','2013-07-05','14:55:00',2.12),('3355','2013-07-05','15:00:00',1.88),('3355','2013-07-05','15:05:00',1.65),('3355','2013-07-05','15:10:00',2.17),('3355','2013-07-05','15:15:00',1.81),('3355','2013-07-05','15:20:00',1.88),('3355','2013-07-05','15:25:00',1.18),('3355','2013-07-05','15:30:00',1.64),('3355','2013-07-05','15:35:00',2.07),('3355','2013-07-05','15:40:00',2.01),('3355','2013-07-05','15:45:00',2.03),('3355','2013-07-05','15:50:00',1.99),('3355','2013-07-05','15:55:00',1.92),('3355','2013-07-05','16:00:00',1.89),('3355','2013-07-05','16:05:00',1.88),('3355','2013-07-05','16:10:00',1.82),('3355','2013-07-05','16:15:00',1.8),('3355','2013-07-05','16:20:00',1.78),('3355','2013-07-05','16:25:00',1.75),('3355','2013-07-05','16:30:00',1.72),('3355','2013-07-05','16:35:00',1.7),('3355','2013-07-05','16:40:00',1.65),('3355','2013-07-05','16:45:00',1.65),('3355','2013-07-05','16:50:00',1.58),('3355','2013-07-05','16:55:00',1.49),('3355','2013-07-05','17:00:00',1.32),('3355','2013-07-05','17:05:00',1.46),('3355','2013-07-05','17:10:00',1.46),('3355','2013-07-05','17:15:00',1.45),('3355','2013-07-05','17:20:00',1.42),('3355','2013-07-05','17:25:00',1.36),('3355','2013-07-05','17:30:00',1.3),('3355','2013-07-05','17:35:00',1.21),('3355','2013-07-05','17:40:00',1.15),('3355','2013-07-05','17:45:00',1.09),('3355','2013-07-05','17:50:00',1.06),('3355','2013-07-05','17:55:00',1.05),('3355','2013-07-05','18:00:00',1.02),('3355','2013-07-04','12:10:00',1.09),('3355','2013-07-04','12:15:00',1.37),('3355','2013-07-04','12:20:00',1.4),('3355','2013-07-04','12:25:00',2.11),('3355','2013-07-04','12:30:00',1.6),('3355','2013-07-04','12:35:00',1.49),('3355','2013-07-04','13:20:00',1.02),('3355','2013-07-04','13:25:00',1.47),('3355','2013-07-04','13:30:00',1.12),('3355','2013-07-04','13:35:00',1.14),('3355','2013-07-04','13:40:00',1.79),('3355','2013-07-04','13:45:00',1.19),('3355','2013-07-04','13:50:00',2.01),('3355','2013-07-04','13:55:00',1.64),('3355','2013-07-04','14:00:00',1.18),('3355','2013-07-04','14:05:00',1.13),('3355','2013-07-04','14:10:00',1.13),('3355','2013-07-04','14:15:00',1.13),('3355','2013-07-04','14:20:00',1.35),('3355','2013-07-04','14:35:00',1.06),('3355','2013-07-04','14:40:00',1.73),('3355','2013-07-04','14:45:00',2.38),('3355','2013-07-04','14:50:00',1.65),('3355','2013-07-04','14:55:00',1.45),('3355','2013-07-04','15:00:00',2.31),('3355','2013-07-04','15:05:00',2.02),('3355','2013-07-04','15:10:00',1.91),('3355','2013-07-04','15:15:00',2.4),('3355','2013-07-04','15:20:00',2.3),('3355','2013-07-04','15:25:00',2.24),('3355','2013-07-04','15:30:00',1.39),('3355','2013-07-04','15:35:00',1.63),('3355','2013-07-04','15:40:00',1.47),('3355','2013-07-04','15:45:00',1.68),('3355','2013-07-04','15:50:00',1.41),('3355','2013-07-04','15:55:00',1.21),('3355','2013-07-04','16:00:00',1.26),('3355','2013-07-04','16:05:00',1.26),('3355','2013-07-04','16:10:00',1.1),('3355','2013-07-04','16:25:00',1.04),('3355','2013-07-04','16:30:00',1.09),('3355','2013-07-04','16:35:00',1.13),('3355','2013-07-04','17:15:00',1.46),('3355','2013-07-04','17:20:00',1.39),('3355','2013-07-04','17:25:00',1.37),('3355','2013-07-04','17:30:00',1.23),('3355','2013-07-04','17:35:00',1.32),('3355','2013-07-04','17:40:00',1.35),('3355','2013-07-04','17:45:00',1.28),('3355','2013-07-04','17:50:00',1.24),('3355','2013-07-04','17:55:00',1.22),('3355','2013-07-04','18:00:00',1.18),('3355','2013-07-04','18:05:00',1.15),('3355','2013-07-04','18:10:00',1.11),('3355','2013-07-04','18:15:00',1.03),('3355','2013-07-03','08:45:00',1.02),('3355','2013-07-03','08:50:00',1.06),('3355','2013-07-03','08:55:00',1.09),('3355','2013-07-03','09:00:00',1.14),('3355','2013-07-03','09:05:00',1.18),('3355','2013-07-03','09:10:00',1.22),('3355','2013-07-03','09:15:00',1.26),('3355','2013-07-03','09:20:00',1.31),('3355','2013-07-03','09:25:00',1.34),('3355','2013-07-03','09:30:00',1.36),('3355','2013-07-03','09:35:00',1.41),('3355','2013-07-03','09:40:00',1.46),('3355','2013-07-03','09:45:00',1.49),('3355','2013-07-03','09:50:00',1.51),('3355','2013-07-03','09:55:00',1.55),('3355','2013-07-03','10:00:00',1.6),('3355','2013-07-03','10:05:00',1.61),('3355','2013-07-03','10:10:00',1.64),('3355','2013-07-03','10:15:00',1.66),('3355','2013-07-03','10:20:00',1.69),('3355','2013-07-03','10:25:00',1.75),('3355','2013-07-03','10:30:00',1.76),('3355','2013-07-03','10:35:00',1.76),('3355','2013-07-03','10:40:00',1.81),('3355','2013-07-03','10:45:00',1.84),('3355','2013-07-03','10:50:00',1.87),('3355','2013-07-03','10:55:00',1.88),('3355','2013-07-03','11:00:00',1.9),('3355','2013-07-03','11:05:00',1.93),('3355','2013-07-03','11:10:00',1.93),('3355','2013-07-03','11:15:00',1.99),('3355','2013-07-03','11:20:00',2.03),('3355','2013-07-03','11:25:00',2.06),('3355','2013-07-03','11:30:00',2.07),('3355','2013-07-03','11:35:00',2.05),('3355','2013-07-03','11:40:00',2.05),('3355','2013-07-03','11:45:00',2.08),('3355','2013-07-03','11:50:00',2.16),('3355','2013-07-03','11:55:00',2.13),('3355','2013-07-03','12:00:00',2.14),('3355','2013-07-03','12:05:00',2.17),('3355','2013-07-03','12:10:00',2.2),('3355','2013-07-03','12:15:00',2.22),('3355','2013-07-03','12:20:00',2.2),('3355','2013-07-03','12:25:00',2.22),('3355','2013-07-03','12:30:00',2.21),('3355','2013-07-03','12:35:00',2.25),('3355','2013-07-03','12:40:00',2.26),('3355','2013-07-03','12:45:00',2.28),('3355','2013-07-03','12:50:00',2.29),('3355','2013-07-03','12:55:00',2.29),('3355','2013-07-03','13:00:00',2.3),('3355','2013-07-03','13:05:00',2.32),('3355','2013-07-03','13:10:00',2.32),('3355','2013-07-03','13:15:00',2.33),('3355','2013-07-03','13:20:00',2.33),('3355','2013-07-03','13:25:00',2.3),('3355','2013-07-03','13:30:00',2.31),('3355','2013-07-03','13:35:00',2.32),('3355','2013-07-03','13:40:00',2.31),('3355','2013-07-03','13:45:00',2.31),('3355','2013-07-03','13:50:00',2.31),('3355','2013-07-03','13:55:00',2.29),('3355','2013-07-03','14:00:00',2.29),('3355','2013-07-03','14:05:00',2.3),('3355','2013-07-03','14:10:00',2.3),('3355','2013-07-03','14:15:00',2.29),('3355','2013-07-03','14:20:00',2.28),('3355','2013-07-03','14:25:00',2.28),('3355','2013-07-03','14:30:00',2.29),('3355','2013-07-03','14:35:00',2.26),('3355','2013-07-03','14:40:00',2.26),('3355','2013-07-03','14:45:00',2.25),('3355','2013-07-03','14:50:00',2.24),('3355','2013-07-03','14:55:00',2.23),('3355','2013-07-03','15:00:00',2.21),('3355','2013-07-03','15:05:00',2.2),('3355','2013-07-03','15:10:00',2.18),('3355','2013-07-03','15:15:00',2.17),('3355','2013-07-03','15:20:00',2.15),('3355','2013-07-03','15:25:00',2.13),('3355','2013-07-03','15:30:00',2.11),('3355','2013-07-03','15:35:00',2.08),('3355','2013-07-03','15:40:00',2.07),('3355','2013-07-03','15:45:00',2.03),('3355','2013-07-03','15:50:00',2.02),('3355','2013-07-03','15:55:00',1.99),('3355','2013-07-03','16:00:00',1.95),('3355','2013-07-03','16:05:00',1.94),('3355','2013-07-03','16:10:00',1.92),('3355','2013-07-03','16:15:00',1.88),('3355','2013-07-03','16:20:00',1.85),('3355','2013-07-03','16:25:00',1.82),('3355','2013-07-03','16:30:00',1.79),('3355','2013-07-03','16:35:00',1.77),('3355','2013-07-03','16:40:00',1.73),('3355','2013-07-03','16:45:00',1.7),('3355','2013-07-03','16:50:00',1.65),('3355','2013-07-03','16:55:00',1.62),('3355','2013-07-03','17:00:00',1.58),('3355','2013-07-03','17:05:00',1.55),('3355','2013-07-03','17:10:00',1.51),('3355','2013-07-03','17:15:00',1.47),('3355','2013-07-03','17:20:00',1.43),('3355','2013-07-03','17:25:00',1.39),('3355','2013-07-03','17:30:00',1.35),('3355','2013-07-03','17:35:00',1.31),('3355','2013-07-03','17:40:00',1.27),('3355','2013-07-03','17:45:00',1.22),('3355','2013-07-03','17:50:00',1.18),('3355','2013-07-03','17:55:00',1.13),('3355','2013-07-03','18:00:00',1.08),('3355','2013-07-03','18:05:00',1.02),('3355','2013-07-02','08:45:00',1),('3355','2013-07-02','08:50:00',1.05),('3355','2013-07-02','08:55:00',1.08),('3355','2013-07-02','09:00:00',1.12),('3355','2013-07-02','09:05:00',1.18),('3355','2013-07-02','09:10:00',1.22),('3355','2013-07-02','09:15:00',1.26),('3355','2013-07-02','09:20:00',1.3),('3355','2013-07-02','09:25:00',1.34),('3355','2013-07-02','09:30:00',1.37),('3355','2013-07-02','09:35:00',1.41),('3355','2013-07-02','09:40:00',1.45),('3355','2013-07-02','09:45:00',1.49),('3355','2013-07-02','09:50:00',1.51),('3355','2013-07-02','09:55:00',1.55),('3355','2013-07-02','10:00:00',1.59),('3355','2013-07-02','10:05:00',1.61),('3355','2013-07-02','10:10:00',1.63),('3355','2013-07-02','10:15:00',1.66),('3355','2013-07-02','10:20:00',1.69),('3355','2013-07-02','10:25:00',1.73),('3355','2013-07-02','10:30:00',1.77),('3355','2013-07-02','10:35:00',1.79),('3355','2013-07-02','10:40:00',1.81),('3355','2013-07-02','10:45:00',1.83),('3355','2013-07-02','10:50:00',1.84),('3355','2013-07-02','10:55:00',1.86),('3355','2013-07-02','11:00:00',1.87),('3355','2013-07-02','11:05:00',1.88),('3355','2013-07-02','11:10:00',1.92),('3355','2013-07-02','11:15:00',1.94),('3355','2013-07-02','11:20:00',1.95),('3355','2013-07-02','11:25:00',1.97),('3355','2013-07-02','11:30:00',2.02),('3355','2013-07-02','11:35:00',2.05),('3355','2013-07-02','11:40:00',2.04),('3355','2013-07-02','11:45:00',2.05),('3355','2013-07-02','11:50:00',2.07),('3355','2013-07-02','11:55:00',2.1),('3355','2013-07-02','12:00:00',2.08),('3355','2013-07-02','12:05:00',2.06),('3355','2013-07-02','12:10:00',2.1),('3355','2013-07-02','12:15:00',2.13),('3355','2013-07-02','12:20:00',2.13),('3355','2013-07-02','12:25:00',2.14),('3355','2013-07-02','12:30:00',2.16),('3355','2013-07-02','12:35:00',2.19),('3355','2013-07-02','12:40:00',2.22),('3355','2013-07-02','12:45:00',2.26),('3355','2013-07-02','12:50:00',2.27),('3355','2013-07-02','12:55:00',1.84),('3355','2013-07-02','13:00:00',1.24),('3355','2013-07-02','13:05:00',1.93),('3355','2013-07-02','13:10:00',1.77),('3355','2013-07-02','13:15:00',2.35),('3355','2013-07-02','13:20:00',2.36),('3355','2013-07-02','13:25:00',2.37),('3355','2013-07-02','13:30:00',2.32),('3355','2013-07-02','13:35:00',2.25),('3355','2013-07-02','13:40:00',2.34),('3355','2013-07-02','13:45:00',2.27),('3355','2013-07-02','13:50:00',2.16),('3355','2013-07-02','13:55:00',2.18),('3355','2013-07-02','14:00:00',2.23),('3355','2013-07-02','14:05:00',2.22),('3355','2013-07-02','14:10:00',2.22),('3355','2013-07-02','14:15:00',2.21),('3355','2013-07-02','14:20:00',2.21),('3355','2013-07-02','14:25:00',2.21),('3355','2013-07-02','14:30:00',2.2),('3355','2013-07-02','14:35:00',2.19),('3355','2013-07-02','14:40:00',2.18),('3355','2013-07-02','14:45:00',2.16),('3355','2013-07-02','14:50:00',2.16),('3355','2013-07-02','14:55:00',2.13),('3355','2013-07-02','15:00:00',2.12),('3355','2013-07-02','15:05:00',2.13),('3355','2013-07-02','15:10:00',2.12),('3355','2013-07-02','15:15:00',2.1),('3355','2013-07-02','15:20:00',2.09),('3355','2013-07-02','15:25:00',2.08),('3355','2013-07-02','15:30:00',2.04),('3355','2013-07-02','15:35:00',2.04),('3355','2013-07-02','15:40:00',2.03),('3355','2013-07-02','15:45:00',1.98),('3355','2013-07-02','15:50:00',1.96),('3355','2013-07-02','15:55:00',1.94),('3355','2013-07-02','16:00:00',1.92),('3355','2013-07-02','16:05:00',1.9),('3355','2013-07-02','16:10:00',1.86),('3355','2013-07-02','16:15:00',1.84),('3355','2013-07-02','16:20:00',1.81),('3355','2013-07-02','16:25:00',1.77),('3355','2013-07-02','16:30:00',1.74),('3355','2013-07-02','16:35:00',1.7),('3355','2013-07-02','16:40:00',1.67),('3355','2013-07-02','16:45:00',1.63),('3355','2013-07-02','16:50:00',1.59),('3355','2013-07-02','16:55:00',1.55),('3355','2013-07-02','17:00:00',1.54),('3355','2013-07-02','17:05:00',1.5),('3355','2013-07-02','17:10:00',1.45),('3355','2013-07-02','17:15:00',1.42),('3355','2013-07-02','17:20:00',1.37),('3355','2013-07-02','17:25:00',1.33),('3355','2013-07-02','17:30:00',1.28),('3355','2013-07-02','17:35:00',1.25),('3355','2013-07-02','17:40:00',1.2),('3355','2013-07-02','17:45:00',1.16),('3355','2013-07-02','17:50:00',1.11),('3355','2013-07-02','17:55:00',1.06),('3355','2013-07-02','18:00:00',1.01),('3355','2013-07-01','08:45:00',1.03),('3355','2013-07-01','08:50:00',1.07),('3355','2013-07-01','08:55:00',1.12),('3355','2013-07-01','09:00:00',1.16),('3355','2013-07-01','09:05:00',1.2),('3355','2013-07-01','09:10:00',1.25),('3355','2013-07-01','09:15:00',1.3),('3355','2013-07-01','09:20:00',1.34),('3355','2013-07-01','09:25:00',1.37),('3355','2013-07-01','09:30:00',1.42),('3355','2013-07-01','09:35:00',1.46),('3355','2013-07-01','09:40:00',1.49),('3355','2013-07-01','09:45:00',1.53),('3355','2013-07-01','09:50:00',1.57),('3355','2013-07-01','09:55:00',1.6),('3355','2013-07-01','10:00:00',1.62),('3355','2013-07-01','10:05:00',1.65),('3355','2013-07-01','10:10:00',1.69),('3355','2013-07-01','10:15:00',1.72),('3355','2013-07-01','10:20:00',1.76),('3355','2013-07-01','10:25:00',1.79),('3355','2013-07-01','10:30:00',1.82),('3355','2013-07-01','10:35:00',1.85),('3355','2013-07-01','10:40:00',1.89),('3355','2013-07-01','10:45:00',1.92),('3355','2013-07-01','10:50:00',1.93),('3355','2013-07-01','10:55:00',1.95),('3355','2013-07-01','11:00:00',1.97),('3355','2013-07-01','11:05:00',2.01),('3355','2013-07-01','11:10:00',2.04),('3355','2013-07-01','11:15:00',2.06),('3355','2013-07-01','11:20:00',2.06),('3355','2013-07-01','11:25:00',2.08),('3355','2013-07-01','11:30:00',2.11),('3355','2013-07-01','11:35:00',2.13),('3355','2013-07-01','11:40:00',2.14),('3355','2013-07-01','11:45:00',2.15),('3355','2013-07-01','11:50:00',2.17),('3355','2013-07-01','11:55:00',2.18),('3355','2013-07-01','12:00:00',2.19),('3355','2013-07-01','12:05:00',2.19),('3355','2013-07-01','12:10:00',2.18),('3355','2013-07-01','12:15:00',2.19),('3355','2013-07-01','12:20:00',2.21),('3355','2013-07-01','12:25:00',2.22),('3355','2013-07-01','12:30:00',2.22),('3355','2013-07-01','12:35:00',2.24),('3355','2013-07-01','12:40:00',2.25),('3355','2013-07-01','12:45:00',2.26),('3355','2013-07-01','12:50:00',2.25),('3355','2013-07-01','12:55:00',2.26),('3355','2013-07-01','13:00:00',2.27),('3355','2013-07-01','13:05:00',2.28),('3355','2013-07-01','13:10:00',2.29),('3355','2013-07-01','13:15:00',2.27),('3355','2013-07-01','13:20:00',2.27),('3355','2013-07-01','13:25:00',2.29),('3355','2013-07-01','13:30:00',2.29),('3355','2013-07-01','13:35:00',2.28),('3355','2013-07-01','13:40:00',2.27),('3355','2013-07-01','13:45:00',2.23),('3355','2013-07-01','13:50:00',2.23),('3355','2013-07-01','13:55:00',2.26),('3355','2013-07-01','14:00:00',2.25),('3355','2013-07-01','14:05:00',2.28),('3355','2013-07-01','14:10:00',2.27),('3355','2013-07-01','14:15:00',2.28),('3355','2013-07-01','14:20:00',2.25),('3355','2013-07-01','14:25:00',2.23),('3355','2013-07-01','14:30:00',2.2),('3355','2013-07-01','14:35:00',2.22),('3355','2013-07-01','14:40:00',2.21),('3355','2013-07-01','14:45:00',2.2),('3355','2013-07-01','14:50:00',2.16),('3355','2013-07-01','14:55:00',2.15),('3355','2013-07-01','15:00:00',2.14),('3355','2013-07-01','15:05:00',2.1),('3355','2013-07-01','15:10:00',2.1),('3355','2013-07-01','15:15:00',2.09),('3355','2013-07-01','15:20:00',2.08),('3355','2013-07-01','15:25:00',2.05),('3355','2013-07-01','15:30:00',2.03),('3355','2013-07-01','15:35:00',1.99),('3355','2013-07-01','15:40:00',1.97),('3355','2013-07-01','15:45:00',1.97),('3355','2013-07-01','15:50:00',1.94),('3355','2013-07-01','15:55:00',1.92),('3355','2013-07-01','16:00:00',1.88),('3355','2013-07-01','16:05:00',1.87),('3355','2013-07-01','16:10:00',1.84),('3355','2013-07-01','16:15:00',1.8),('3355','2013-07-01','16:20:00',1.76),('3355','2013-07-01','16:25:00',1.72),('3355','2013-07-01','16:30:00',1.69),('3355','2013-07-01','16:35:00',1.67),('3355','2013-07-01','16:40:00',1.64),('3355','2013-07-01','16:45:00',1.6),('3355','2013-07-01','16:50:00',1.58),('3355','2013-07-01','16:55:00',1.55),('3355','2013-07-01','17:00:00',1.52),('3355','2013-07-01','17:05:00',1.49),('3355','2013-07-01','17:10:00',1.45),('3355','2013-07-01','17:15:00',1.41),('3355','2013-07-01','17:20:00',1.36),('3355','2013-07-01','17:25:00',1.31),('3355','2013-07-01','17:30:00',1.27),('3355','2013-07-01','17:35:00',1.22),('3355','2013-07-01','17:40:00',1.18),('3355','2013-07-01','17:45:00',1.15),('3355','2013-07-01','17:50:00',1.11),('3355','2013-07-01','17:55:00',1.07),('3355','2014-04-05','09:25:00',1.37),('3355','2014-04-05','09:30:00',1.76),('3355','2014-04-05','09:35:00',1.69),('3355','2014-04-05','09:40:00',1.64),('3355','2014-04-05','09:55:00',1.24),('3355','2014-04-05','10:00:00',1.22),('3355','2014-04-05','10:05:00',1.3),('3355','2014-04-05','10:10:00',1.12),('3355','2014-04-05','10:20:00',1.17),('3355','2014-04-05','10:25:00',1.42),('3355','2014-04-05','10:30:00',1.44),('3355','2014-04-05','10:35:00',1.72),('3355','2014-04-05','10:40:00',1.78),('3355','2014-04-05','10:45:00',1.56),('3355','2014-04-05','10:50:00',1.33),('3355','2014-04-05','10:55:00',1.64),('3355','2014-04-05','11:00:00',1.93),('3355','2014-04-05','11:05:00',2.08),('3355','2014-04-05','11:10:00',2.14),('3355','2014-04-05','11:15:00',2.26),('3355','2014-04-05','11:20:00',2.18),('3355','2014-04-05','11:25:00',1.33),('3355','2014-04-05','11:30:00',1.11),('3355','2014-04-05','11:35:00',1.62),('3355','2014-04-05','11:40:00',2.07),('3355','2014-04-05','11:45:00',2.29),('3355','2014-04-05','11:50:00',2.42),('3355','2014-04-05','11:55:00',2.18),('3355','2014-04-05','12:00:00',1.6),('3355','2014-04-05','12:05:00',1.66),('3355','2014-04-05','12:10:00',1.87),('3355','2014-04-05','12:15:00',1.96),('3355','2014-04-05','12:20:00',1.82),('3355','2014-04-05','12:25:00',1.38),('3355','2014-04-05','12:30:00',1.52),('3355','2014-04-05','12:35:00',1.63),('3355','2014-04-05','12:40:00',2.47),('3355','2014-04-05','12:45:00',2.73),('3355','2014-04-05','12:50:00',2.58),('3355','2014-04-05','12:55:00',1.99),('3355','2014-04-05','13:00:00',2.23),('3355','2014-04-05','13:05:00',2.02),('3355','2014-04-05','13:10:00',2.21),('3355','2014-04-05','13:15:00',1.16),('3355','2014-04-05','13:20:00',2.2),('3355','2014-04-05','13:25:00',2.17),('3355','2014-04-05','13:30:00',2.23),('3355','2014-04-05','13:35:00',2.66),('3355','2014-04-05','13:40:00',1.89),('3355','2014-04-05','13:45:00',1.14),('3355','2014-04-05','13:50:00',2),('3355','2014-04-05','13:55:00',2.28),('3355','2014-04-05','14:00:00',1.74),('3355','2014-04-05','14:05:00',2.81),('3355','2014-04-05','14:10:00',1.16),('3355','2014-04-05','14:25:00',1.37),('3355','2014-04-05','14:55:00',2.31),('3355','2014-04-05','15:00:00',1.38),('3355','2014-04-05','15:05:00',2.15),('3355','2014-04-05','15:15:00',1.51),('3355','2014-04-05','15:20:00',2.45),('3355','2014-04-05','15:25:00',1.66),('3355','2014-04-05','15:40:00',1.86),('3355','2014-04-05','16:15:00',1.74),('3355','2014-04-05','16:20:00',1.88),('3355','2014-04-05','16:25:00',1.79),('3355','2014-04-05','16:30:00',1.21),('3355','2014-04-05','16:35:00',1.61),('3355','2014-04-05','16:45:00',1.27),('3355','2014-04-05','16:55:00',1.11),('3355','2014-04-05','17:00:00',1.31),('3355','2014-04-05','17:05:00',1.26),('3355','2014-04-05','17:10:00',1.09),('3355','2013-06-30','08:40:00',1.02),('3355','2013-06-30','08:45:00',1.07),('3355','2013-06-30','08:50:00',1.12),('3355','2013-06-30','08:55:00',1.16),('3355','2013-06-30','09:00:00',1.2),('3355','2013-06-30','09:05:00',1.25),('3355','2013-06-30','09:10:00',1.29),('3355','2013-06-30','09:15:00',1.34),('3355','2013-06-30','09:20:00',1.37),('3355','2013-06-30','09:25:00',1.41),('3355','2013-06-30','09:30:00',1.46),('3355','2013-06-30','09:35:00',1.5),('3355','2013-06-30','09:40:00',1.53),('3355','2013-06-30','09:45:00',1.58),('3355','2013-06-30','09:50:00',1.61),('3355','2013-06-30','09:55:00',1.64),('3355','2013-06-30','10:00:00',1.67),('3355','2013-06-30','10:05:00',1.71),('3355','2013-06-30','10:10:00',1.73),('3355','2013-06-30','10:15:00',1.76),('3355','2013-06-30','10:20:00',1.8),('3355','2013-06-30','10:25:00',1.83),('3355','2013-06-30','10:30:00',1.86),('3355','2013-06-30','10:35:00',1.89),('3355','2013-06-30','10:40:00',1.91),('3355','2013-06-30','10:45:00',1.94),('3355','2013-06-30','10:50:00',1.96),('3355','2013-06-30','10:55:00',1.98),('3355','2013-06-30','11:00:00',2.01),('3355','2013-06-30','11:05:00',2.03),('3355','2013-06-30','11:10:00',2.05),('3355','2013-06-30','11:15:00',2.05),('3355','2013-06-30','11:20:00',2.06),('3355','2013-06-30','11:25:00',2.09),('3355','2013-06-30','11:30:00',2.12),('3355','2013-06-30','11:35:00',2.13),('3355','2013-06-30','11:40:00',2.14),('3355','2013-06-30','11:45:00',2.16),('3355','2013-06-30','11:50:00',2.18),('3355','2013-06-30','11:55:00',2.2),('3355','2013-06-30','12:00:00',2.21),('3355','2013-06-30','12:05:00',2.22),('3355','2013-06-30','12:10:00',2.23),('3355','2013-06-30','12:15:00',2.24),('3355','2013-06-30','12:20:00',2.25),('3355','2013-06-30','12:25:00',2.26),('3355','2013-06-30','12:30:00',2.28),('3355','2013-06-30','12:35:00',2.27),('3355','2013-06-30','12:40:00',2.28),('3355','2013-06-30','12:45:00',2.31),('3355','2013-06-30','12:50:00',2.32),('3355','2013-06-30','12:55:00',2.32),('3355','2013-06-30','13:00:00',2.3),('3355','2013-06-30','13:05:00',2.33),('3355','2013-06-30','13:10:00',2.34),('3355','2013-06-30','13:15:00',2.32),('3355','2013-06-30','13:20:00',2.31),('3355','2013-06-30','13:25:00',2.33),('3355','2013-06-30','13:30:00',2.33),('3355','2013-06-30','13:35:00',2.3),('3355','2013-06-30','13:40:00',2.31),('3355','2013-06-30','13:45:00',2.33),('3355','2013-06-30','13:50:00',2.34),('3355','2013-06-30','13:55:00',2.3),('3355','2013-06-30','14:00:00',2.24),('3355','2013-06-30','14:05:00',2.31),('3355','2013-06-30','14:10:00',2.29),('3355','2013-06-30','14:15:00',2.26),('3355','2013-06-30','14:20:00',2.25),('3355','2013-06-30','14:25:00',2.24),('3355','2013-06-30','14:30:00',2.23),('3355','2013-06-30','14:35:00',2.23),('3355','2013-06-30','14:40:00',2.22),('3355','2013-06-30','14:45:00',2.22),('3355','2013-06-30','14:50:00',2.21),('3355','2013-06-30','14:55:00',2.2),('3355','2013-06-30','15:00:00',2.19),('3355','2013-06-30','15:05:00',2.15),('3355','2013-06-30','15:10:00',2.15),('3355','2013-06-30','15:15:00',2.14),('3355','2013-06-30','15:20:00',2.13),('3355','2013-06-30','15:25:00',2.1),('3355','2013-06-30','15:30:00',2.08),('3355','2013-06-30','15:35:00',2.08),('3355','2013-06-30','15:40:00',2.06),('3355','2013-06-30','15:45:00',2.04),('3355','2013-06-30','15:50:00',2.02),('3355','2013-06-30','15:55:00',1.98),('3355','2013-06-30','16:00:00',1.95),('3355','2013-06-30','16:05:00',1.93),('3355','2013-06-30','16:10:00',1.92),('3355','2013-06-30','16:15:00',1.91),('3355','2013-06-30','16:20:00',1.92),('3355','2013-06-30','16:25:00',1.94),('3355','2013-06-30','16:30:00',1.94),('3355','2013-06-30','16:35:00',1.66),('3355','2013-06-30','16:40:00',1.68),('3355','2013-06-30','16:45:00',1.68),('3355','2013-06-30','16:50:00',1.65),('3355','2013-06-30','16:55:00',1.59),('3355','2013-06-30','17:00:00',1.54),('3355','2013-06-30','17:05:00',1.51),('3355','2013-06-30','17:10:00',1.48),('3355','2013-06-30','17:15:00',1.43),('3355','2013-06-30','17:20:00',1.39),('3355','2013-06-30','17:25:00',1.33),('3355','2013-06-30','17:30:00',1.27),('3355','2013-06-30','17:35:00',1.22),('3355','2013-06-30','17:40:00',1.2),('3355','2013-06-30','17:45:00',1.15),('3355','2013-06-30','17:50:00',1.11),('3355','2013-06-30','17:55:00',1.06),('3355','2013-06-30','18:00:00',1.01),('3355','2013-06-29','08:35:00',1.02),('3355','2013-06-29','08:50:00',1.12),('3355','2013-06-29','08:55:00',1.15),('3355','2013-06-29','09:00:00',1.18),('3355','2013-06-29','09:05:00',1.22),('3355','2013-06-29','09:10:00',1.27),('3355','2013-06-29','09:15:00',1.31),('3355','2013-06-29','09:20:00',1.35),('3355','2013-06-29','09:25:00',1.39),('3355','2013-06-29','09:30:00',1.4),('3355','2013-06-29','09:35:00',1.47),('3355','2013-06-29','09:40:00',1.51),('3355','2013-06-29','09:45:00',1.54),('3355','2013-06-29','09:50:00',1.58),('3355','2013-06-29','09:55:00',1.62),('3355','2013-06-29','10:00:00',1.65),('3355','2013-06-29','10:05:00',1.68),('3355','2013-06-29','10:10:00',1.72),('3355','2013-06-29','10:15:00',1.75),('3355','2013-06-29','10:20:00',1.77),('3355','2013-06-29','10:25:00',1.81),('3355','2013-06-29','10:30:00',1.85),('3355','2013-06-29','10:35:00',1.87),('3355','2013-06-29','10:40:00',1.9),('3355','2013-06-29','10:45:00',1.95),('3355','2013-06-29','10:50:00',1.97),('3355','2013-06-29','10:55:00',1.98),('3355','2013-06-29','11:00:00',2.02),('3355','2013-06-29','11:05:00',2.06),('3355','2013-06-29','11:10:00',2.11),('3355','2013-06-29','11:15:00',2.15),('3355','2013-06-29','11:20:00',1.57),('3355','2013-06-29','11:25:00',2.1),('3355','2013-06-29','11:30:00',2.33),('3355','2013-06-29','11:35:00',2.3),('3355','2013-06-29','11:40:00',2.41),('3355','2013-06-29','11:55:00',2.54),('3355','2013-06-29','12:00:00',1.91),('3355','2013-06-29','12:05:00',2.33),('3355','2013-06-29','12:10:00',2.38),('3355','2013-06-29','12:15:00',2.41),('3355','2013-06-29','12:25:00',2.23),('3355','2013-06-29','12:30:00',2.44),('3355','2013-06-29','12:35:00',2.43),('3355','2013-06-29','12:40:00',2.43),('3355','2013-06-29','12:45:00',2.52),('3355','2013-06-29','12:50:00',1.74),('3355','2013-06-29','12:55:00',1.3),('3355','2013-06-29','13:00:00',1.86),('3355','2013-06-29','13:05:00',1.37),('3355','2013-06-29','13:10:00',2.29),('3355','2013-06-29','13:15:00',2.65),('3355','2013-06-29','13:20:00',1.68),('3355','2013-06-29','13:25:00',2.66),('3355','2013-06-29','13:30:00',1.24),('3355','2013-06-29','13:45:00',1.16),('3355','2013-06-29','13:50:00',2.24),('3355','2013-06-29','13:55:00',1.32),('3355','2013-06-29','14:00:00',2.54),('3355','2013-06-29','14:05:00',1.85),('3355','2013-06-29','14:10:00',2.17),('3355','2013-06-29','14:15:00',2.68),('3355','2013-06-29','14:20:00',2.69),('3355','2013-06-29','14:25:00',1.51),('3355','2013-06-29','14:30:00',2.71),('3355','2013-06-29','14:35:00',2.52),('3355','2013-06-29','14:40:00',2.51),('3355','2013-06-29','14:45:00',2.57),('3355','2013-06-29','14:50:00',2.37),('3355','2013-06-29','15:00:00',1.16),('3355','2013-06-29','15:05:00',1.54),('3355','2013-06-29','16:50:00',1.43),('3355','2013-06-29','17:30:00',1.5),('3355','2013-06-29','17:35:00',1.47),('3355','2013-06-29','17:45:00',1.14),('3355','2013-06-29','17:50:00',1.2),('3355','2013-06-29','17:55:00',1.13),('3355','2013-06-29','18:00:00',1.06),('3355','2013-06-29','18:05:00',1.02),('3355','2013-06-28','08:45:00',1.02),('3355','2013-06-28','08:50:00',1.08),('3355','2013-06-28','08:55:00',1.12),('3355','2013-06-28','09:00:00',1.15),('3355','2013-06-28','09:05:00',1.22),('3355','2013-06-28','09:10:00',1.34),('3355','2013-06-28','09:35:00',1.58),('3355','2013-06-28','09:40:00',1.41),('3355','2013-06-28','09:45:00',1.03),('3355','2013-06-28','09:55:00',1.82),('3355','2013-06-28','10:00:00',1.77),('3355','2013-06-28','10:05:00',1.67),('3355','2013-06-28','10:10:00',1.49),('3355','2013-06-28','10:15:00',1.64),('3355','2013-06-28','10:20:00',2.09),('3355','2013-06-28','10:35:00',1.7),('3355','2013-06-28','10:40:00',2.14),('3355','2013-06-28','10:50:00',2.28),('3355','2013-06-28','11:00:00',1),('3355','2013-06-28','11:05:00',2.1),('3355','2013-06-28','11:10:00',1.6),('3355','2013-06-28','11:25:00',1.45),('3355','2013-06-28','11:30:00',1.72),('3355','2013-06-28','11:35:00',1.92),('3355','2013-06-28','11:40:00',1.09),('3355','2013-06-28','11:45:00',1.99),('3355','2013-06-28','11:50:00',2.38),('3355','2013-06-28','11:55:00',2.34),('3355','2013-06-28','12:00:00',1.97),('3355','2013-06-28','12:05:00',2.37),('3355','2013-06-28','12:10:00',2.02),('3355','2013-06-28','12:15:00',2.48),('3355','2013-06-28','12:20:00',2.4),('3355','2013-06-28','12:25:00',2.26),('3355','2013-06-28','12:30:00',2.02),('3355','2013-06-28','12:35:00',2.18),('3355','2013-06-28','12:40:00',2.51),('3355','2013-06-28','12:45:00',2.38),('3355','2013-06-28','12:50:00',1.35),('3355','2013-06-28','12:55:00',2.41),('3355','2013-06-28','13:00:00',1.5),('3355','2013-06-28','13:05:00',2.21),('3355','2013-06-28','13:10:00',2.26),('3355','2013-06-28','13:15:00',2.46),('3355','2013-06-28','13:20:00',2.35),('3355','2013-06-28','13:25:00',2.39),('3355','2013-06-28','13:30:00',1.88),('3355','2013-06-28','13:35:00',2.04),('3355','2013-06-28','13:40:00',2.27),('3355','2013-06-28','13:45:00',2.17),('3355','2013-06-28','13:50:00',2.19),('3355','2013-06-28','13:55:00',2.44),('3355','2013-06-28','14:00:00',2.16),('3355','2013-06-28','14:05:00',2.16),('3355','2013-06-28','14:10:00',2.16),('3355','2013-06-28','14:15:00',2.21),('3355','2013-06-28','14:20:00',2.01),('3355','2013-06-28','14:25:00',2.57),('3355','2013-06-28','14:30:00',2.24),('3355','2013-06-28','14:35:00',2.04),('3355','2013-06-28','14:40:00',1.82),('3355','2013-06-28','14:45:00',1.62),('3355','2013-06-28','14:50:00',2.32),('3355','2013-06-28','14:55:00',2.04),('3355','2013-06-28','15:00:00',1.93),('3355','2013-06-28','15:05:00',2.29),('3355','2013-06-28','15:10:00',1.47),('3355','2013-06-28','15:15:00',1.13),('3355','2013-06-28','15:25:00',1.7),('3355','2013-06-28','15:30:00',1.9),('3355','2013-06-28','15:35:00',2.4),('3355','2013-06-28','15:40:00',1.57),('3355','2013-06-28','15:45:00',1.11),('3355','2013-06-28','15:50:00',1.99),('3355','2013-06-28','15:55:00',1.36),('3355','2013-06-28','16:00:00',1.67),('3355','2013-06-28','16:05:00',1.86),('3355','2013-06-28','16:10:00',1.79),('3355','2013-06-28','16:15:00',1.78),('3355','2013-06-28','16:20:00',1.01),('3355','2013-06-28','16:35:00',1.35),('3355','2013-06-28','17:00:00',1.5),('3355','2013-06-28','17:05:00',1.57),('3355','2013-06-28','17:10:00',1.52),('3355','2013-06-28','17:15:00',1.35),('3355','2013-06-28','17:20:00',1.39),('3355','2013-06-28','17:25:00',1.38),('3355','2013-06-28','17:30:00',1.15),('3355','2013-06-28','17:35:00',1.27),('3355','2013-06-28','17:40:00',1.22),('3355','2013-06-28','17:45:00',1.19),('3355','2013-06-28','17:50:00',1.16),('3355','2013-06-28','17:55:00',1.1),('3355','2013-06-28','18:00:00',1.04),('3355','2013-06-28','18:05:00',1),('3355','2013-06-27','08:45:00',1.04),('3355','2013-06-27','08:50:00',1.07),('3355','2013-06-27','08:55:00',1.13),('3355','2013-06-27','09:00:00',1.19),('3355','2013-06-27','09:05:00',1.23),('3355','2013-06-27','09:10:00',1.27),('3355','2013-06-27','09:15:00',1.32),('3355','2013-06-27','09:20:00',1.37),('3355','2013-06-27','09:25:00',1.4),('3355','2013-06-27','09:30:00',1.44),('3355','2013-06-27','09:35:00',1.49),('3355','2013-06-27','09:40:00',1.52),('3355','2013-06-27','09:45:00',1.56),('3355','2013-06-27','09:50:00',1.61),('3355','2013-06-27','09:55:00',1.65),('3355','2013-06-27','10:00:00',1.7),('3355','2013-06-27','10:05:00',1.79),('3355','2013-06-27','10:10:00',1.75),('3355','2013-06-27','10:15:00',1.85),('3355','2013-06-27','10:20:00',1.81),('3355','2013-06-27','10:25:00',1.82),('3355','2013-06-27','10:30:00',1.88),('3355','2013-06-27','10:35:00',1.94),('3355','2013-06-27','10:40:00',2.01),('3355','2013-06-27','10:45:00',2.07),('3355','2013-06-27','10:50:00',2.06),('3355','2013-06-27','10:55:00',2.08),('3355','2013-06-27','11:00:00',2.06),('3355','2013-06-27','11:05:00',1.96),('3355','2013-06-27','11:10:00',1.41),('3355','2013-06-27','11:15:00',2.19),('3355','2013-06-27','11:20:00',2.17),('3355','2013-06-27','11:25:00',2.16),('3355','2013-06-27','11:30:00',2.2),('3355','2013-06-27','11:35:00',2.06),('3355','2013-06-27','11:40:00',2.19),('3355','2013-06-27','11:45:00',1.68),('3355','2013-06-27','12:00:00',1.03),('3355','2013-06-27','12:40:00',1.26),('3355','2013-06-27','12:50:00',1),('3355','2013-06-27','14:20:00',1.92),('3355','2013-06-27','14:25:00',2.18),('3355','2013-06-27','14:30:00',1.89),('3355','2013-06-27','14:35:00',1.91),('3355','2013-06-27','14:40:00',1.8),('3355','2013-06-27','14:45:00',1),('3355','2013-06-27','14:50:00',1.26),('3355','2013-06-27','14:55:00',2.27),('3355','2013-06-27','15:00:00',2.2),('3355','2013-06-27','15:05:00',2.14),('3355','2013-06-27','15:10:00',2.12),('3355','2013-06-27','15:15:00',2.11),('3355','2013-06-27','15:20:00',2.08),('3355','2013-06-27','15:25:00',2.1),('3355','2013-06-27','15:30:00',2.08),('3355','2013-06-27','15:35:00',2.05),('3355','2013-06-27','15:40:00',2.03),('3355','2013-06-27','15:45:00',2.01),('3355','2013-06-27','15:50:00',1.98),('3355','2013-06-27','15:55:00',1.95),('3355','2013-06-27','16:00:00',1.89),('3355','2013-06-27','16:05:00',1.86),('3355','2013-06-27','16:10:00',1.83),('3355','2013-06-27','16:15:00',1.82),('3355','2013-06-27','16:20:00',1.79),('3355','2013-06-27','16:25:00',1.77),('3355','2013-06-27','16:30:00',1.74),('3355','2013-06-27','16:35:00',1.62),('3355','2013-06-27','16:40:00',1.61),('3355','2013-06-27','16:45:00',1.63),('3355','2013-06-27','16:50:00',1.59),('3355','2013-06-27','16:55:00',1.55),('3355','2013-06-27','17:00:00',1.51),('3355','2013-06-27','17:05:00',1.47),('3355','2013-06-27','17:10:00',1.4),('3355','2013-06-27','17:15:00',1.34),('3355','2013-06-27','17:20:00',1.37),('3355','2013-06-27','17:25:00',1.35),('3355','2013-06-27','17:30:00',1.3),('3355','2013-06-27','17:35:00',1.26),('3355','2013-06-27','17:50:00',1.04),('3355','2013-06-27','17:55:00',1.05),('3355','2013-06-26','08:45:00',1.03),('3355','2013-06-26','08:50:00',1.08),('3355','2013-06-26','08:55:00',1.11),('3355','2013-06-26','09:00:00',1.15),('3355','2013-06-26','09:05:00',1.2),('3355','2013-06-26','09:10:00',1.24),('3355','2013-06-26','09:15:00',1.28),('3355','2013-06-26','09:20:00',1.32),('3355','2013-06-26','09:25:00',1.37),('3355','2013-06-26','09:30:00',1.41),('3355','2013-06-26','09:35:00',1.45),('3355','2013-06-26','09:40:00',1.49),('3355','2013-06-26','09:45:00',1.51),('3355','2013-06-26','09:50:00',1.54),('3355','2013-06-26','09:55:00',1.57),('3355','2013-06-26','10:00:00',1.61),('3355','2013-06-26','10:05:00',1.65),('3355','2013-06-26','10:10:00',1.67),('3355','2013-06-26','10:15:00',1.72),('3355','2013-06-26','10:20:00',1.74),('3355','2013-06-26','10:25:00',1.77),('3355','2013-06-26','10:30:00',1.79),('3355','2013-06-26','10:35:00',1.83),('3355','2013-06-26','10:40:00',1.86),('3355','2013-06-26','10:45:00',1.89),('3355','2013-06-26','10:50:00',1.91),('3355','2013-06-26','10:55:00',1.93),('3355','2013-06-26','11:00:00',1.96),('3355','2013-06-26','11:05:00',1.99),('3355','2013-06-26','11:10:00',2.01),('3355','2013-06-26','11:15:00',2.02),('3355','2013-06-26','11:20:00',2.03),('3355','2013-06-26','11:25:00',2.04),('3355','2013-06-26','11:30:00',2.05),('3355','2013-06-26','11:35:00',2.08),('3355','2013-06-26','11:40:00',2.12),('3355','2013-06-26','11:45:00',2.14),('3355','2013-06-26','11:50:00',2.15),('3355','2013-06-26','11:55:00',2.18),('3355','2013-06-26','12:00:00',2.15),('3355','2013-06-26','12:05:00',2.15),('3355','2013-06-26','12:10:00',2.18),('3355','2013-06-26','12:15:00',2.18),('3355','2013-06-26','12:20:00',2.12),('3355','2013-06-26','12:25:00',2.17),('3355','2013-06-26','12:30:00',2.14),('3355','2013-06-26','12:35:00',2.1),('3355','2013-06-26','12:40:00',2.24),('3355','2013-06-26','12:45:00',2.25),('3355','2013-06-26','12:50:00',2.24),('3355','2013-06-26','12:55:00',1.41),('3355','2013-06-26','13:10:00',2.07),('3355','2013-06-26','13:15:00',2.52),('3355','2013-06-26','13:20:00',2.46),('3355','2013-06-26','13:25:00',1.7),('3355','2013-06-26','14:00:00',1.51),('3355','2013-06-26','14:05:00',1.27),('3355','2013-06-26','14:15:00',1.5),('3355','2013-06-26','14:20:00',2.28),('3355','2013-06-26','14:25:00',1.26),('3355','2013-06-26','14:30:00',1.26),('3355','2013-06-26','14:45:00',1.67),('3355','2013-06-26','14:55:00',1.48),('3355','2013-06-26','15:00:00',2.29),('3355','2013-06-26','15:05:00',2.22),('3355','2013-06-26','15:10:00',2.17),('3355','2013-06-26','15:15:00',2.13),('3355','2013-06-26','15:20:00',2.09),('3355','2013-06-26','15:25:00',2.07),('3355','2013-06-26','15:30:00',2.06),('3355','2013-06-26','15:35:00',2.08),('3355','2013-06-26','15:40:00',2.03),('3355','2013-06-26','15:45:00',2),('3355','2013-06-26','15:50:00',1.6),('3355','2013-06-26','15:55:00',1.53),('3355','2013-06-26','16:00:00',1.97),('3355','2013-06-26','16:05:00',1.91),('3355','2013-06-26','16:10:00',1.89),('3355','2013-06-26','16:15:00',1.88),('3355','2013-06-26','16:20:00',1.84),('3355','2013-06-26','16:25:00',1.8),('3355','2013-06-26','16:30:00',1.78),('3355','2013-06-26','16:35:00',1.73),('3355','2013-06-26','16:40:00',1.67),('3355','2013-06-26','16:45:00',1.64),('3355','2013-06-26','16:50:00',1.61),('3355','2013-06-26','16:55:00',1.58),('3355','2013-06-26','17:00:00',1.55),('3355','2013-06-26','17:05:00',1.52),('3355','2013-06-26','17:10:00',1.48),('3355','2013-06-26','17:15:00',1.41),('3355','2013-06-26','17:20:00',1.37),('3355','2013-06-26','17:25:00',1.33),('3355','2013-06-26','17:30:00',1.29),('3355','2013-06-26','17:35:00',1.26),('3355','2013-06-26','17:40:00',1.21),('3355','2013-06-26','17:45:00',1.15),('3355','2013-06-26','17:50:00',1.11),('3355','2013-06-26','17:55:00',1.06),('3355','2013-06-26','18:00:00',1.04),('3355','2013-06-26','18:05:00',1.06),('3355','2013-06-26','18:10:00',1.01),('3355','2013-06-25','08:40:00',1.01),('3355','2013-06-25','08:45:00',1.07),('3355','2013-06-25','08:50:00',1.09),('3355','2013-06-25','08:55:00',1.14),('3355','2013-06-25','09:00:00',1.2),('3355','2013-06-25','09:05:00',1.24),('3355','2013-06-25','09:10:00',1.28),('3355','2013-06-25','09:15:00',1.33),('3355','2013-06-25','09:20:00',1.35),('3355','2013-06-25','09:25:00',1.43),('3355','2013-06-25','09:30:00',1.47),('3355','2013-06-25','09:35:00',1.38),('3355','2013-06-25','09:50:00',1.83),('3355','2013-06-25','09:55:00',1.86),('3355','2013-06-25','10:00:00',1.8),('3355','2013-06-25','10:10:00',1.21),('3355','2013-06-25','10:15:00',2.02),('3355','2013-06-25','10:20:00',1.37),('3355','2013-06-25','10:30:00',1.93),('3355','2013-06-25','10:40:00',1.89),('3355','2013-06-25','10:45:00',2.13),('3355','2013-06-25','10:50:00',2.11),('3355','2013-06-25','10:55:00',2.14),('3355','2013-06-25','11:00:00',2.01),('3355','2013-06-25','11:05:00',2.23),('3355','2013-06-25','11:10:00',2.29),('3355','2013-06-25','11:15:00',2.08),('3355','2013-06-25','11:20:00',2.34),('3355','2013-06-25','11:25:00',1.23),('3355','2013-06-25','11:30:00',1.51),('3355','2013-06-25','11:35:00',2.2),('3355','2013-06-25','11:40:00',2.43),('3355','2013-06-25','11:45:00',2.41),('3355','2013-06-25','11:50:00',2.37),('3355','2013-06-25','11:55:00',2.18),('3355','2013-06-25','12:00:00',1.84),('3355','2013-06-25','12:05:00',1.66),('3355','2013-06-25','12:55:00',1.05),('3355','2013-06-25','13:00:00',2.23),('3355','2013-06-25','13:05:00',2.59),('3355','2013-06-25','13:10:00',1.79),('3355','2013-06-25','13:15:00',1.71),('3355','2013-06-25','13:20:00',2.48),('3355','2013-06-25','13:25:00',2.44),('3355','2013-06-25','13:30:00',2.09),('3355','2013-06-25','13:35:00',1.89),('3355','2013-06-25','13:40:00',2.23),('3355','2013-06-25','13:45:00',2.4),('3355','2013-06-25','13:50:00',1.84),('3355','2013-06-25','13:55:00',1.92),('3355','2013-06-25','14:00:00',1.81),('3355','2013-06-25','14:05:00',2.49),('3355','2013-06-25','14:10:00',1.79),('3355','2013-06-25','14:15:00',1.21),('3355','2013-06-25','14:20:00',2.49),('3355','2013-06-25','14:25:00',2.37),('3355','2013-06-25','14:30:00',2.27),('3355','2013-06-25','14:35:00',2.29),('3355','2013-06-25','14:40:00',1.93),('3355','2013-06-25','14:45:00',2.32),('3355','2013-06-25','14:50:00',2.28),('3355','2013-06-25','14:55:00',2.24),('3355','2013-06-25','15:00:00',2.22),('3355','2013-06-25','15:05:00',2.19),('3355','2013-06-25','15:10:00',2.18),('3355','2013-06-25','15:15:00',2.19),('3355','2013-06-25','15:20:00',2.14),('3355','2013-06-25','15:25:00',2.1),('3355','2013-06-25','15:30:00',2.07),('3355','2013-06-25','15:35:00',2.05),('3355','2013-06-25','15:40:00',2.02),('3355','2013-06-25','15:45:00',1.99),('3355','2013-06-25','15:50:00',1.97),('3355','2013-06-25','15:55:00',1.94),('3355','2013-06-25','16:00:00',1.92),('3355','2013-06-25','16:05:00',1.9),('3355','2013-06-25','16:10:00',1.87),('3355','2013-06-25','16:15:00',1.84),('3355','2013-06-25','16:20:00',1.81),('3355','2013-06-25','16:25:00',1.78),('3355','2013-06-25','16:30:00',1.75),('3355','2013-06-25','16:35:00',1.71),('3355','2013-06-25','16:40:00',1.68),('3355','2013-06-25','16:45:00',1.65),('3355','2013-06-25','16:50:00',1.62),('3355','2013-06-25','16:55:00',1.57),('3355','2013-06-25','17:00:00',1.53),('3355','2013-06-25','17:05:00',1.49),('3355','2013-06-25','17:10:00',1.45),('3355','2013-06-25','17:15:00',1.42),('3355','2013-06-25','17:20:00',1.38),('3355','2013-06-25','17:25:00',1.33),('3355','2013-06-25','17:30:00',1.29),('3355','2013-06-25','17:35:00',1.25),('3355','2013-06-25','17:40:00',1.2),('3355','2013-06-25','17:45:00',1.15),('3355','2013-06-25','17:50:00',1.11),('3355','2013-06-25','17:55:00',1.07),('3355','2013-06-25','18:00:00',1.02),('3355','2013-06-24','08:45:00',1.1),('3355','2013-06-24','08:50:00',1.17),('3355','2013-06-24','08:55:00',1.23),('3355','2013-06-24','09:00:00',1.36),('3355','2013-06-24','09:05:00',1.37),('3355','2013-06-24','09:15:00',1.35),('3355','2013-06-24','09:20:00',1.47),('3355','2013-06-24','09:25:00',1.4),('3355','2013-06-24','09:30:00',1.75),('3355','2013-06-24','09:35:00',1.28),('3355','2013-06-24','09:45:00',1.12),('3355','2013-06-24','09:50:00',1.77),('3355','2013-06-24','09:55:00',1.7),('3355','2013-06-24','10:00:00',1.74),('3355','2013-06-24','10:05:00',1.77),('3355','2013-06-24','10:10:00',1.84),('3355','2013-06-24','10:15:00',1.61),('3355','2013-06-24','10:20:00',1.61),('3355','2013-06-24','10:25:00',2.09),('3355','2013-06-24','10:30:00',1.5),('3355','2013-06-24','10:35:00',1.97),('3355','2013-06-24','10:40:00',1.14),('3355','2013-06-24','10:50:00',1.87),('3355','2013-06-24','10:55:00',1.41),('3355','2013-06-24','11:00:00',2.24),('3355','2013-06-24','11:05:00',2.36),('3355','2013-06-24','11:10:00',1.21),('3355','2013-06-24','11:20:00',2.53),('3355','2013-06-24','11:30:00',1.28),('3355','2013-06-24','11:50:00',1.92),('3355','2013-06-24','11:55:00',1.14),('3355','2013-06-24','12:00:00',2.03),('3355','2013-06-24','12:05:00',2.16),('3355','2013-06-24','12:10:00',1.75),('3355','2013-06-24','12:15:00',1.96),('3355','2013-06-24','12:20:00',2.02),('3355','2013-06-24','12:25:00',2.57),('3355','2013-06-24','12:30:00',1.65),('3355','2013-06-24','12:35:00',2.48),('3355','2013-06-24','12:40:00',2.63),('3355','2013-06-24','12:45:00',1.28),('3355','2013-06-24','12:50:00',2.12),('3355','2013-06-24','12:55:00',2.75),('3355','2013-06-24','13:00:00',1.71),('3355','2013-06-24','13:05:00',2.3),('3355','2013-06-24','13:10:00',2.42),('3355','2013-06-24','13:15:00',1.76),('3355','2013-06-24','13:20:00',1.29),('3355','2013-06-24','13:25:00',2.05),('3355','2013-06-24','13:30:00',2.78),('3355','2013-06-24','13:35:00',2.21),('3355','2013-06-24','13:40:00',2.27),('3355','2013-06-24','13:45:00',2.32),('3355','2013-06-24','13:50:00',2.48),('3355','2013-06-24','13:55:00',2.44),('3355','2013-06-24','14:00:00',2.4),('3355','2013-06-24','14:05:00',2.43),('3355','2013-06-24','14:10:00',2.43),('3355','2013-06-24','14:15:00',2.41),('3355','2013-06-24','14:20:00',2.4),('3355','2013-06-24','14:25:00',2.4),('3355','2013-06-24','14:30:00',2.33),('3355','2013-06-24','14:35:00',2.4),('3355','2013-06-24','14:40:00',2.39),('3355','2013-06-24','14:45:00',2.42),('3355','2013-06-24','14:50:00',1.68),('3355','2013-06-24','14:55:00',2.24),('3355','2013-06-24','15:00:00',1.84),('3355','2013-06-24','15:05:00',1.7),('3355','2013-06-24','15:10:00',2),('3355','2013-06-24','15:15:00',2.51),('3355','2013-06-24','15:20:00',1.91),('3355','2013-06-24','15:25:00',1.54),('3355','2013-06-24','15:30:00',1.54),('3355','2013-06-24','15:35:00',1.94),('3355','2013-06-24','15:45:00',2.27),('3355','2013-06-24','15:50:00',1.65),('3355','2013-06-24','15:55:00',1.93),('3355','2013-06-24','16:00:00',2.34),('3355','2013-06-24','16:05:00',2.09),('3355','2013-06-24','16:10:00',1.87),('3355','2013-06-24','16:15:00',2.18),('3355','2013-06-24','16:20:00',1.29),('3355','2013-06-24','16:25:00',1.46),('3355','2013-06-24','16:30:00',1.29),('3355','2013-06-24','16:35:00',1.74),('3355','2013-06-24','16:40:00',1.19),('3355','2013-06-24','16:45:00',1.11),('3355','2013-06-24','17:05:00',1.21),('3355','2013-06-24','17:15:00',1.69),('3355','2013-06-24','17:20:00',1.07),('3355','2013-06-24','17:25:00',1.26),('3355','2013-06-24','17:30:00',1.16),('3355','2013-06-24','18:00:00',1.22),('3355','2013-06-24','18:05:00',1.17),('3355','2013-06-23','09:25:00',1.23),('3355','2013-06-23','09:30:00',1.41),('3355','2013-06-23','09:35:00',1.5),('3355','2013-06-23','09:40:00',1.66),('3355','2013-06-23','09:45:00',1.24),('3355','2013-06-23','10:00:00',1.79),('3355','2013-06-23','10:05:00',1.81),('3355','2013-06-23','10:10:00',1.93),('3355','2013-06-23','10:15:00',1.79),('3355','2013-06-23','10:20:00',1.22),('3355','2013-06-23','10:25:00',1.68),('3355','2013-06-23','10:40:00',1.99),('3355','2013-06-23','10:45:00',1.94),('3355','2013-06-23','10:50:00',1.92),('3355','2013-06-23','10:55:00',1.9),('3355','2013-06-23','11:00:00',1.94),('3355','2013-06-23','11:05:00',1.97),('3355','2013-06-23','11:10:00',2),('3355','2013-06-23','11:15:00',2),('3355','2013-06-23','11:20:00',2.05),('3355','2013-06-23','11:25:00',2.08),('3355','2013-06-23','11:30:00',2.07),('3355','2013-06-23','11:35:00',2.05),('3355','2013-06-23','11:40:00',2.04),('3355','2013-06-23','11:45:00',2.07),('3355','2013-06-23','11:50:00',2.14),('3355','2013-06-23','11:55:00',2.16),('3355','2013-06-23','12:00:00',1.92),('3355','2013-06-23','12:05:00',2.24),('3355','2013-06-23','12:10:00',2.26),('3355','2013-06-23','12:15:00',2.22),('3355','2013-06-23','12:20:00',2.26),('3355','2013-06-23','12:25:00',2.29),('3355','2013-06-23','12:30:00',2.28),('3355','2013-06-23','12:35:00',2.27),('3355','2013-06-23','12:40:00',2.27),('3355','2013-06-23','12:45:00',2.29),('3355','2013-06-23','12:50:00',2.29),('3355','2013-06-23','12:55:00',2.31),('3355','2013-06-23','13:00:00',2.31),('3355','2013-06-23','13:05:00',2.31),('3355','2013-06-23','13:10:00',2.32),('3355','2013-06-23','13:15:00',2.33),('3355','2013-06-23','13:20:00',2.32),('3355','2013-06-23','13:25:00',2.33),('3355','2013-06-23','13:30:00',2.31),('3355','2013-06-23','13:35:00',2.33),('3355','2013-06-23','13:40:00',2.34),('3355','2013-06-23','13:45:00',2.33),('3355','2013-06-23','13:50:00',2.33),('3355','2013-06-23','13:55:00',2.34),('3355','2013-06-23','14:00:00',2.33),('3355','2013-06-23','14:05:00',2.31),('3355','2013-06-23','14:10:00',2.31),('3355','2013-06-23','14:15:00',2.31),('3355','2013-06-23','14:20:00',2.3),('3355','2013-06-23','14:25:00',2.3),('3355','2013-06-23','14:30:00',2.31),('3355','2013-06-23','14:35:00',2.28),('3355','2013-06-23','14:40:00',2.28),('3355','2013-06-23','14:45:00',2.26),('3355','2013-06-23','14:50:00',2.26),('3355','2013-06-23','14:55:00',2.24),('3355','2013-06-23','15:00:00',2.24),('3355','2013-06-23','15:05:00',2.22),('3355','2013-06-23','15:10:00',2.18),('3355','2013-06-23','15:15:00',2.17),('3355','2013-06-23','15:20:00',2.14),('3355','2013-06-23','15:25:00',2.14),('3355','2013-06-23','15:30:00',2.11),('3355','2013-06-23','15:35:00',2.09),('3355','2013-06-23','15:40:00',2.06),('3355','2013-06-23','15:45:00',2.03),('3355','2013-06-23','15:50:00',2.01),('3355','2013-06-23','15:55:00',1.99),('3355','2013-06-23','16:00:00',1.96),('3355','2013-06-23','16:05:00',1.92),('3355','2013-06-23','16:10:00',1.89),('3355','2013-06-23','16:15:00',1.85),('3355','2013-06-23','16:20:00',1.83),('3355','2013-06-23','16:25:00',1.8),('3355','2013-06-23','16:30:00',1.77),('3355','2013-06-23','16:35:00',1.74),('3355','2013-06-23','16:40:00',1.7),('3355','2013-06-23','16:45:00',1.68),('3355','2013-06-23','16:50:00',1.65),('3355','2013-06-23','16:55:00',1.59),('3355','2013-06-23','17:00:00',1.56),('3355','2013-06-23','17:05:00',1.53),('3355','2013-06-23','17:10:00',1.49),('3355','2013-06-23','17:15:00',1.46),('3355','2013-06-23','17:20:00',1.41),('3355','2013-06-23','17:25:00',1.39),('3355','2013-06-23','17:30:00',1.33),('3355','2013-06-23','17:35:00',1.29),('3355','2013-06-23','17:40:00',1.23),('3355','2013-06-23','17:45:00',1.21),('3355','2013-06-23','17:50:00',1.16),('3355','2013-06-23','17:55:00',1.11),('3355','2013-06-23','18:00:00',1.05),('3355','2013-06-23','18:05:00',1.01),('3355','2013-06-22','08:50:00',1.04),('3355','2013-06-22','08:55:00',1.08),('3355','2013-06-22','09:00:00',1.11),('3355','2013-06-22','09:05:00',1.14),('3355','2013-06-22','09:10:00',1.18),('3355','2013-06-22','09:15:00',1.22),('3355','2013-06-22','09:20:00',1.26),('3355','2013-06-22','09:25:00',1.3),('3355','2013-06-22','09:30:00',1.33),('3355','2013-06-22','09:35:00',1.38),('3355','2013-06-22','09:40:00',1.41),('3355','2013-06-22','09:45:00',1.45),('3355','2013-06-22','09:50:00',1.48),('3355','2013-06-22','09:55:00',1.52),('3355','2013-06-22','10:00:00',1.54),('3355','2013-06-22','10:05:00',1.59),('3355','2013-06-22','10:10:00',1.62),('3355','2013-06-22','10:15:00',1.65),('3355','2013-06-22','10:20:00',1.69),('3355','2013-06-22','10:25:00',1.74),('3355','2013-06-22','10:30:00',1.74),('3355','2013-06-22','10:35:00',1.77),('3355','2013-06-22','10:40:00',1.8),('3355','2013-06-22','10:45:00',1.84),('3355','2013-06-22','10:50:00',1.86),('3355','2013-06-22','10:55:00',1.89),('3355','2013-06-22','11:00:00',1.91),('3355','2013-06-22','11:05:00',1.93),('3355','2013-06-22','11:10:00',1.95),('3355','2013-06-22','11:15:00',1.97),('3355','2013-06-22','11:20:00',1.99),('3355','2013-06-22','11:25:00',2.01),('3355','2013-06-22','11:30:00',2.02),('3355','2013-06-22','11:35:00',2.05),('3355','2013-06-22','11:40:00',2.07),('3355','2013-06-22','11:45:00',2.08),('3355','2013-06-22','11:50:00',2.1),('3355','2013-06-22','11:55:00',2.1),('3355','2013-06-22','12:00:00',2.12),('3355','2013-06-22','12:05:00',2.11),('3355','2013-06-22','12:10:00',2.07),('3355','2013-06-22','12:15:00',2.15),('3355','2013-06-22','12:20:00',2.16),('3355','2013-06-22','12:25:00',2.14),('3355','2013-06-22','12:30:00',2.18),('3355','2013-06-22','12:35:00',2.2),('3355','2013-06-22','12:40:00',2.22),('3355','2013-06-22','12:45:00',2.19),('3355','2013-06-22','12:50:00',2.16),('3355','2013-06-22','12:55:00',2.15),('3355','2013-06-22','13:00:00',2.14),('3355','2013-06-22','13:05:00',2.15),('3355','2013-06-22','13:10:00',2.11),('3355','2013-06-22','13:15:00',2.09),('3355','2013-06-22','13:20:00',2.03),('3355','2013-06-22','13:25:00',2.06),('3355','2013-06-22','13:30:00',2.28),('3355','2013-06-22','13:35:00',2.32),('3355','2013-06-22','13:40:00',2.17),('3355','2013-06-22','13:45:00',2.15),('3355','2013-06-22','13:50:00',2.29),('3355','2013-06-22','13:55:00',1.95),('3355','2013-06-22','14:00:00',1.19),('3355','2013-06-22','14:05:00',2.49),('3355','2013-06-22','14:10:00',2.37),('3355','2013-06-22','14:15:00',2.35),('3355','2013-06-22','14:20:00',1.95),('3355','2013-06-22','14:25:00',2.32),('3355','2013-06-22','14:30:00',1.8),('3355','2013-06-22','14:35:00',1.27),('3355','2013-06-22','14:45:00',1),('3355','2013-06-22','14:50:00',1.91),('3355','2013-06-22','14:55:00',2.03),('3355','2013-06-22','15:00:00',2.09),('3355','2013-06-22','15:05:00',1.85),('3355','2013-06-22','15:10:00',1.99),('3355','2013-06-22','15:15:00',2.23),('3355','2013-06-22','15:20:00',2.07),('3355','2013-06-22','15:25:00',1.92),('3355','2013-06-22','15:30:00',1.27),('3355','2013-06-22','15:35:00',1.14),('3355','2013-06-22','15:45:00',1.36),('3355','2013-06-22','15:50:00',1.43),('3355','2013-06-22','15:55:00',1.33),('3355','2013-06-22','16:00:00',1.12),('3355','2013-06-22','16:20:00',1.05),('3355','2013-06-22','17:10:00',1.04),('3355','2013-06-22','17:15:00',1.59),('3355','2013-06-22','17:20:00',1.54),('3355','2013-06-22','17:25:00',1.55),('3355','2013-06-22','17:30:00',1.23),('3355','2013-06-22','17:35:00',1.1),('3355','2013-06-22','17:40:00',1.24),('3355','2013-06-22','17:45:00',1.22),('3355','2013-06-22','17:50:00',1.13),('3355','2013-06-22','17:55:00',1.09),('3355','2013-06-22','18:00:00',1.02),('3355','2013-06-21','08:55:00',1.03),('3355','2013-06-21','09:00:00',1.08),('3355','2013-06-21','09:05:00',1.11),('3355','2013-06-21','09:10:00',1.15),('3355','2013-06-21','09:15:00',1.18),('3355','2013-06-21','09:20:00',1.22),('3355','2013-06-21','09:25:00',1.24),('3355','2013-06-21','09:30:00',1.28),('3355','2013-06-21','09:35:00',1.32),('3355','2013-06-21','09:40:00',1.35),('3355','2013-06-21','09:45:00',1.38),('3355','2013-06-21','09:50:00',1.4),('3355','2013-06-21','09:55:00',1.43),('3355','2013-06-21','10:00:00',1.48),('3355','2013-06-21','10:05:00',1.51),('3355','2013-06-21','10:10:00',1.54),('3355','2013-06-21','10:15:00',1.54),('3355','2013-06-21','10:20:00',1.57),('3355','2013-06-21','10:25:00',1.59),('3355','2013-06-21','10:30:00',1.64),('3355','2013-06-21','10:35:00',1.66),('3355','2013-06-21','10:40:00',1.68),('3355','2013-06-21','10:45:00',1.71),('3355','2013-06-21','10:50:00',1.74),('3355','2013-06-21','10:55:00',1.76),('3355','2013-06-21','11:00:00',1.79),('3355','2013-06-21','11:05:00',1.8),('3355','2013-06-21','11:10:00',1.8),('3355','2013-06-21','11:15:00',1.83),('3355','2013-06-21','11:20:00',1.88),('3355','2013-06-21','11:25:00',1.91),('3355','2013-06-21','11:30:00',1.94),('3355','2013-06-21','11:35:00',1.93),('3355','2013-06-21','11:40:00',1.94),('3355','2013-06-21','11:45:00',1.95),('3355','2013-06-21','11:50:00',2),('3355','2013-06-21','11:55:00',2),('3355','2013-06-21','12:00:00',1.98),('3355','2013-06-21','12:05:00',2.02),('3355','2013-06-21','12:10:00',2.03),('3355','2013-06-21','12:15:00',2.03),('3355','2013-06-21','12:20:00',2.02),('3355','2013-06-21','12:25:00',2.02),('3355','2013-06-21','12:30:00',2.06),('3355','2013-06-21','12:35:00',2.05),('3355','2013-06-21','12:40:00',2.07),('3355','2013-06-21','12:45:00',2.05),('3355','2013-06-21','12:50:00',2.04),('3355','2013-06-21','12:55:00',2.02),('3355','2013-06-21','13:00:00',2.03),('3355','2013-06-21','13:05:00',2.07),('3355','2013-06-21','13:10:00',2.05),('3355','2013-06-21','13:15:00',2.07),('3355','2013-06-21','13:20:00',2.08),('3355','2013-06-21','13:25:00',2.06),('3355','2013-06-21','13:30:00',2.09),('3355','2013-06-21','13:35:00',2.13),('3355','2013-06-21','13:40:00',2.1),('3355','2013-06-21','13:45:00',2.1),('3355','2013-06-21','13:50:00',2.11),('3355','2013-06-21','13:55:00',2.1),('3355','2013-06-21','14:00:00',2.1),('3355','2013-06-21','14:05:00',2.1),('3355','2013-06-21','14:10:00',2.12),('3355','2013-06-21','14:15:00',2.11),('3355','2013-06-21','14:20:00',2.11),('3355','2013-06-21','14:25:00',2.12),('3355','2013-06-21','14:30:00',2.12),('3355','2013-06-21','14:35:00',2.13),('3355','2013-06-21','14:40:00',2.11),('3355','2013-06-21','14:45:00',2.1),('3355','2013-06-21','14:50:00',2.1),('3355','2013-06-21','14:55:00',2.08),('3355','2013-06-21','15:00:00',2.07),('3355','2013-06-21','15:05:00',2.06),('3355','2013-06-21','15:10:00',2.03),('3355','2013-06-21','15:15:00',2.02),('3355','2013-06-21','15:20:00',2.01),('3355','2013-06-21','15:25:00',1.99),('3355','2013-06-21','15:30:00',1.97),('3355','2013-06-21','15:35:00',1.96),('3355','2013-06-21','15:40:00',1.94),('3355','2013-06-21','15:45:00',1.92),('3355','2013-06-21','15:50:00',1.89),('3355','2013-06-21','15:55:00',1.86),('3355','2013-06-21','16:00:00',1.85),('3355','2013-06-21','16:05:00',1.82),('3355','2013-06-21','16:10:00',1.8),('3355','2013-06-21','16:15:00',1.77),('3355','2013-06-21','16:20:00',1.74),('3355','2013-06-21','16:25:00',1.71),('3355','2013-06-21','16:30:00',1.68),('3355','2013-06-21','16:35:00',1.65),('3355','2013-06-21','16:40:00',1.61),('3355','2013-06-21','16:45:00',1.57),('3355','2013-06-21','16:50:00',1.55),('3355','2013-06-21','16:55:00',1.52),('3355','2013-06-21','17:00:00',1.48),('3355','2013-06-21','17:05:00',1.44),('3355','2013-06-21','17:10:00',1.41),('3355','2013-06-21','17:15:00',1.37),('3355','2013-06-21','17:20:00',1.33),('3355','2013-06-21','17:25:00',1.28),('3355','2013-06-21','17:30:00',1.24),('3355','2013-06-21','17:35:00',1.2),('3355','2013-06-21','17:40:00',1.16),('3355','2013-06-21','17:45:00',1.12),('3355','2013-06-21','17:50:00',1.07),('3355','2013-06-21','17:55:00',1.01),('3355','2014-04-04','13:25:00',1.57),('3355','2014-04-04','13:30:00',1.26),('3355','2014-04-04','13:35:00',1.85),('3355','2014-04-04','13:40:00',2.15),('3355','2014-04-04','13:45:00',1.97),('3355','2014-04-04','13:50:00',1.91),('3355','2014-04-04','13:55:00',1.45),('3355','2014-04-04','14:00:00',1.11),('3355','2014-04-04','14:05:00',2.31),('3355','2014-04-04','14:10:00',1.25),('3355','2014-04-04','14:15:00',2.39),('3355','2014-04-04','14:20:00',1.72),('3355','2014-04-04','14:25:00',1.81),('3355','2014-04-04','14:35:00',1.79),('3355','2014-04-04','14:45:00',1.81),('3355','2014-04-04','14:50:00',1.86),('3355','2014-04-04','14:55:00',1.83),('3355','2014-04-04','15:00:00',2.33),('3355','2014-04-04','15:05:00',2.32),('3355','2014-04-04','15:10:00',2.34),('3355','2014-04-04','15:15:00',1.92),('3355','2014-04-04','15:20:00',1.21),('3355','2014-04-04','15:25:00',1.04),('3355','2014-04-04','15:40:00',1.46),('3355','2014-04-04','15:45:00',1.27),('3355','2014-04-04','15:50:00',1.06),('3355','2014-04-04','15:55:00',1.67),('3355','2014-04-04','16:00:00',1.57),('3355','2014-04-04','16:10:00',1.03),('3355','2014-04-04','16:30:00',1.26),('3355','2014-04-04','16:45:00',1.63),('3355','2014-04-04','16:50:00',1.86),('3355','2014-04-04','16:55:00',1.25),('3355','2014-04-04','17:00:00',1.08),('3355','2014-04-04','17:05:00',1.22),('3355','2014-04-04','17:10:00',1.27),('3355','2014-04-04','17:15:00',1.38),('3355','2014-04-04','17:20:00',1.29),('3355','2014-04-04','17:25:00',1.07),('3355','2014-04-04','17:30:00',1.21),('3355','2013-06-20','08:50:00',1),('3355','2013-06-20','08:55:00',1.05),('3355','2013-06-20','09:00:00',1.1),('3355','2013-06-20','09:05:00',1.14),('3355','2013-06-20','09:10:00',1.18),('3355','2013-06-20','09:15:00',1.21),('3355','2013-06-20','09:20:00',1.25),('3355','2013-06-20','09:25:00',1.28),('3355','2013-06-20','09:30:00',1.32),('3355','2013-06-20','09:35:00',1.35),('3355','2013-06-20','09:40:00',1.39),('3355','2013-06-20','09:45:00',1.42),('3355','2013-06-20','09:50:00',1.46),('3355','2013-06-20','09:55:00',1.49),('3355','2013-06-20','10:00:00',1.53),('3355','2013-06-20','10:05:00',1.56),('3355','2013-06-20','10:10:00',1.58),('3355','2013-06-20','10:15:00',1.61),('3355','2013-06-20','10:20:00',1.65),('3355','2013-06-20','10:25:00',1.68),('3355','2013-06-20','10:30:00',1.71),('3355','2013-06-20','10:35:00',1.73),('3355','2013-06-20','10:40:00',1.76),('3355','2013-06-20','10:45:00',1.77),('3355','2013-06-20','10:50:00',1.78),('3355','2013-06-20','10:55:00',1.8),('3355','2013-06-20','11:00:00',1.85),('3355','2013-06-20','11:05:00',1.85),('3355','2013-06-20','11:10:00',1.88),('3355','2013-06-20','11:15:00',1.9),('3355','2013-06-20','11:20:00',1.87),('3355','2013-06-20','11:25:00',1.87),('3355','2013-06-20','11:30:00',1.93),('3355','2013-06-20','11:35:00',1.96),('3355','2013-06-20','11:40:00',1.98),('3355','2013-06-20','11:45:00',2),('3355','2013-06-20','11:50:00',2.02),('3355','2013-06-20','11:55:00',1.99),('3355','2013-06-20','12:00:00',1.99),('3355','2013-06-20','12:05:00',1.99),('3355','2013-06-20','12:10:00',2),('3355','2013-06-20','12:15:00',1.95),('3355','2013-06-20','12:20:00',1.93),('3355','2013-06-20','12:25:00',1.99),('3355','2013-06-20','12:30:00',1.98),('3355','2013-06-20','12:35:00',2.13),('3355','2013-06-20','12:40:00',1.57),('3355','2013-06-20','12:45:00',1.7),('3355','2013-06-20','12:50:00',2.11),('3355','2013-06-20','12:55:00',1.33),('3355','2013-06-20','13:00:00',1.75),('3355','2013-06-20','13:05:00',2.04),('3355','2013-06-20','13:10:00',2.19),('3355','2013-06-20','13:15:00',2.16),('3355','2013-06-20','13:20:00',2.13),('3355','2013-06-20','13:25:00',1.66),('3355','2013-06-20','13:30:00',2.03),('3355','2013-06-20','13:35:00',2.12),('3355','2013-06-20','13:40:00',2.14),('3355','2013-06-20','13:45:00',2.15),('3355','2013-06-20','13:50:00',2.16),('3355','2013-06-20','13:55:00',2.12),('3355','2013-06-20','14:00:00',2.14),('3355','2013-06-20','14:05:00',2.19),('3355','2013-06-20','14:10:00',2.19),('3355','2013-06-20','14:15:00',2.19),('3355','2013-06-20','14:20:00',2.2),('3355','2013-06-20','14:25:00',2.18),('3355','2013-06-20','14:30:00',2.17),('3355','2013-06-20','14:35:00',2.19),('3355','2013-06-20','14:40:00',2.19),('3355','2013-06-20','14:45:00',2.18),('3355','2013-06-20','14:50:00',2.18),('3355','2013-06-20','14:55:00',2.17),('3355','2013-06-20','15:00:00',2.15),('3355','2013-06-20','15:05:00',2.13),('3355','2013-06-20','15:10:00',2.11),('3355','2013-06-20','15:15:00',2.09),('3355','2013-06-20','15:20:00',2.07),('3355','2013-06-20','15:25:00',2.03),('3355','2013-06-20','15:30:00',2.02),('3355','2013-06-20','15:35:00',1.99),('3355','2013-06-20','15:40:00',1.98),('3355','2013-06-20','15:45:00',1.96),('3355','2013-06-20','15:50:00',1.92),('3355','2013-06-20','15:55:00',1.9),('3355','2013-06-20','16:00:00',1.87),('3355','2013-06-20','16:05:00',1.85),('3355','2013-06-20','16:10:00',1.84),('3355','2013-06-20','16:15:00',1.81),('3355','2013-06-20','16:20:00',1.78),('3355','2013-06-20','16:25:00',1.74),('3355','2013-06-20','16:30:00',1.72),('3355','2013-06-20','16:35:00',1.68),('3355','2013-06-20','16:40:00',1.64),('3355','2013-06-20','16:45:00',1.61),('3355','2013-06-20','16:50:00',1.57),('3355','2013-06-20','16:55:00',1.53),('3355','2013-06-20','17:00:00',1.49),('3355','2013-06-20','17:05:00',1.45),('3355','2013-06-20','17:10:00',1.41),('3355','2013-06-20','17:15:00',1.38),('3355','2013-06-20','17:20:00',1.34),('3355','2013-06-20','17:25:00',1.29),('3355','2013-06-20','17:30:00',1.26),('3355','2013-06-20','17:35:00',1.21),('3355','2013-06-20','17:40:00',1.18),('3355','2013-06-20','17:45:00',1.14),('3355','2013-06-20','17:50:00',1.1),('3355','2013-06-20','17:55:00',1.05),('3355','2013-06-19','08:55:00',1.02),('3355','2013-06-19','09:00:00',1.07),('3355','2013-06-19','09:05:00',1.12),('3355','2013-06-19','09:10:00',1.16),('3355','2013-06-19','09:15:00',1.19),('3355','2013-06-19','09:20:00',1.23),('3355','2013-06-19','09:25:00',1.26),('3355','2013-06-19','09:30:00',1.3),('3355','2013-06-19','09:35:00',1.34),('3355','2013-06-19','09:40:00',1.37),('3355','2013-06-19','09:45:00',1.4),('3355','2013-06-19','09:50:00',1.43),('3355','2013-06-19','09:55:00',1.47),('3355','2013-06-19','10:00:00',1.49),('3355','2013-06-19','10:05:00',1.51),('3355','2013-06-19','10:10:00',1.55),('3355','2013-06-19','10:15:00',1.58),('3355','2013-06-19','10:20:00',1.6),('3355','2013-06-19','10:25:00',1.62),('3355','2013-06-19','10:30:00',1.65),('3355','2013-06-19','10:35:00',1.67),('3355','2013-06-19','10:40:00',1.69),('3355','2013-06-19','10:45:00',1.72),('3355','2013-06-19','10:50:00',1.75),('3355','2013-06-19','10:55:00',1.76),('3355','2013-06-19','11:00:00',1.78),('3355','2013-06-19','11:05:00',1.79),('3355','2013-06-19','11:10:00',1.82),('3355','2013-06-19','11:15:00',1.84),('3355','2013-06-19','11:20:00',1.85),('3355','2013-06-19','11:25:00',1.88),('3355','2013-06-19','11:30:00',1.9),('3355','2013-06-19','11:35:00',1.9),('3355','2013-06-19','11:40:00',1.91),('3355','2013-06-19','11:45:00',1.89),('3355','2013-06-19','11:50:00',1.94),('3355','2013-06-19','11:55:00',1.93),('3355','2013-06-19','12:00:00',1.97),('3355','2013-06-19','12:05:00',1.97),('3355','2013-06-19','12:10:00',1.99),('3355','2013-06-19','12:15:00',1.97),('3355','2013-06-19','12:20:00',1.96),('3355','2013-06-19','12:25:00',1.94),('3355','2013-06-19','12:30:00',1.92),('3355','2013-06-19','12:35:00',2.07),('3355','2013-06-19','12:40:00',2.09),('3355','2013-06-19','12:45:00',2.09),('3355','2013-06-19','12:50:00',2.07),('3355','2013-06-19','12:55:00',2.1),('3355','2013-06-19','13:00:00',2.1),('3355','2013-06-19','13:05:00',2.11),('3355','2013-06-19','13:10:00',2.1),('3355','2013-06-19','13:15:00',2.11),('3355','2013-06-19','13:20:00',2.11),('3355','2013-06-19','13:25:00',2.14),('3355','2013-06-19','13:30:00',2.16),('3355','2013-06-19','13:35:00',2.14),('3355','2013-06-19','13:40:00',2.15),('3355','2013-06-19','13:45:00',2.15),('3355','2013-06-19','13:50:00',2.14),('3355','2013-06-19','13:55:00',2.17),('3355','2013-06-19','14:00:00',2.16),('3355','2013-06-19','14:05:00',2.17),('3355','2013-06-19','14:10:00',2.15),('3355','2013-06-19','14:15:00',2.13),('3355','2013-06-19','14:20:00',2.13),('3355','2013-06-19','14:25:00',2.13),('3355','2013-06-19','14:30:00',2.11),('3355','2013-06-19','14:35:00',2.1),('3355','2013-06-19','14:40:00',2.07),('3355','2013-06-19','14:45:00',2.06),('3355','2013-06-19','14:50:00',2.03),('3355','2013-06-19','14:55:00',2.02),('3355','2013-06-19','15:00:00',2.03),('3355','2013-06-19','15:05:00',2.02),('3355','2013-06-19','15:10:00',2),('3355','2013-06-19','15:15:00',1.97),('3355','2013-06-19','15:20:00',1.95),('3355','2013-06-19','15:25:00',1.94),('3355','2013-06-19','15:30:00',1.92),('3355','2013-06-19','15:35:00',1.9),('3355','2013-06-19','15:40:00',1.88),('3355','2013-06-19','15:45:00',1.85),('3355','2013-06-19','15:50:00',1.82),('3355','2013-06-19','15:55:00',1.79),('3355','2013-06-19','16:00:00',1.77),('3355','2013-06-19','16:05:00',1.74),('3355','2013-06-19','16:10:00',1.72),('3355','2013-06-19','16:15:00',1.69),('3355','2013-06-19','16:20:00',1.66),('3355','2013-06-19','16:25:00',1.63),('3355','2013-06-19','16:30:00',1.6),('3355','2013-06-19','16:35:00',1.58),('3355','2013-06-19','16:40:00',1.54),('3355','2013-06-19','16:45:00',1.52),('3355','2013-06-19','16:50:00',1.48),('3355','2013-06-19','16:55:00',1.46),('3355','2013-06-19','17:00:00',1.42),('3355','2013-06-19','17:05:00',1.37),('3355','2013-06-19','17:10:00',1.35),('3355','2013-06-19','17:15:00',1.31),('3355','2013-06-19','17:20:00',1.3),('3355','2013-06-19','17:25:00',1.27),('3355','2013-06-19','17:30:00',1.22),('3355','2013-06-19','17:35:00',1.17),('3355','2013-06-19','17:40:00',1.13),('3355','2013-06-19','17:45:00',1.1),('3355','2013-06-19','17:50:00',1.05),('3355','2013-06-18','08:55:00',1),('3355','2013-06-18','09:00:00',1.06),('3355','2013-06-18','09:05:00',1.09),('3355','2013-06-18','09:10:00',1.14),('3355','2013-06-18','09:15:00',1.17),('3355','2013-06-18','09:20:00',1.21),('3355','2013-06-18','09:25:00',1.25),('3355','2013-06-18','09:30:00',1.28),('3355','2013-06-18','09:35:00',1.33),('3355','2013-06-18','09:40:00',1.36),('3355','2013-06-18','09:45:00',1.39),('3355','2013-06-18','09:50:00',1.42),('3355','2013-06-18','09:55:00',1.44),('3355','2013-06-18','10:00:00',1.47),('3355','2013-06-18','10:05:00',1.48),('3355','2013-06-18','10:10:00',1.54),('3355','2013-06-18','10:15:00',1.56),('3355','2013-06-18','10:20:00',1.59),('3355','2013-06-18','10:25:00',1.63),('3355','2013-06-18','10:30:00',1.65),('3355','2013-06-18','10:35:00',1.67),('3355','2013-06-18','10:40:00',1.7),('3355','2013-06-18','10:45:00',1.71),('3355','2013-06-18','10:50:00',1.72),('3355','2013-06-18','10:55:00',1.75),('3355','2013-06-18','11:00:00',1.77),('3355','2013-06-18','11:05:00',1.81),('3355','2013-06-18','11:10:00',1.86),('3355','2013-06-18','11:15:00',1.87),('3355','2013-06-18','11:20:00',1.88),('3355','2013-06-18','11:25:00',1.88),('3355','2013-06-18','11:30:00',1.88),('3355','2013-06-18','11:35:00',1.89),('3355','2013-06-18','11:40:00',1.91),('3355','2013-06-18','11:45:00',1.93),('3355','2013-06-18','11:50:00',1.93),('3355','2013-06-18','11:55:00',1.91),('3355','2013-06-18','12:00:00',1.9),('3355','2013-06-18','12:05:00',1.95),('3355','2013-06-18','12:10:00',1.95),('3355','2013-06-18','12:15:00',1.93),('3355','2013-06-18','12:20:00',1.93),('3355','2013-06-18','12:25:00',1.97),('3355','2013-06-18','12:30:00',1.97),('3355','2013-06-18','12:35:00',1.9),('3355','2013-06-18','12:40:00',1.7),('3355','2013-06-18','12:45:00',1.48),('3355','2013-06-18','12:50:00',1.79),('3355','2013-06-18','12:55:00',2.1),('3355','2013-06-18','13:00:00',2.04),('3355','2013-06-18','13:05:00',1.78),('3355','2013-06-18','13:10:00',2.16),('3355','2013-06-18','13:15:00',2.09),('3355','2013-06-18','13:20:00',2.2),('3355','2013-06-18','13:25:00',2.03),('3355','2013-06-18','13:30:00',2.17),('3355','2013-06-18','13:35:00',2.09),('3355','2013-06-18','13:40:00',2.05),('3355','2013-06-18','13:45:00',2.09),('3355','2013-06-18','13:50:00',2.11),('3355','2013-06-18','13:55:00',2.16),('3355','2013-06-18','14:00:00',2.17),('3355','2013-06-18','14:05:00',2.17),('3355','2013-06-18','14:10:00',2.16),('3355','2013-06-18','14:15:00',2.14),('3355','2013-06-18','14:20:00',2.1),('3355','2013-06-18','14:25:00',2.12),('3355','2013-06-18','14:30:00',2.09),('3355','2013-06-18','14:35:00',2.11),('3355','2013-06-18','14:40:00',2.11),('3355','2013-06-18','14:45:00',2.08),('3355','2013-06-18','14:50:00',2.07),('3355','2013-06-18','14:55:00',2.06),('3355','2013-06-18','15:00:00',2.05),('3355','2013-06-18','15:05:00',2.03),('3355','2013-06-18','15:10:00',2.02),('3355','2013-06-18','15:15:00',2),('3355','2013-06-18','15:20:00',1.97),('3355','2013-06-18','15:25:00',1.96),('3355','2013-06-18','15:30:00',1.93),('3355','2013-06-18','15:35:00',1.92),('3355','2013-06-18','15:40:00',1.91),('3355','2013-06-18','15:45:00',1.9),('3355','2013-06-18','15:50:00',1.89),('3355','2013-06-18','15:55:00',1.86),('3355','2013-06-18','16:00:00',1.85),('3355','2013-06-18','16:05:00',1.84),('3355','2013-06-18','16:10:00',1.82),('3355','2013-06-18','16:15:00',1.8),('3355','2013-06-18','16:20:00',1.79),('3355','2013-06-18','16:25:00',1.69),('3355','2013-06-18','16:30:00',1.66),('3355','2013-06-18','16:35:00',1.58),('3355','2013-06-18','16:40:00',1.59),('3355','2013-06-18','16:45:00',1.53),('3355','2013-06-18','16:50:00',1.51),('3355','2013-06-18','16:55:00',1.48),('3355','2013-06-18','17:00:00',1.44),('3355','2013-06-18','17:05:00',1.4),('3355','2013-06-18','17:10:00',1.37),('3355','2013-06-18','17:15:00',1.34),('3355','2013-06-18','17:20:00',1.31),('3355','2013-06-18','17:25:00',1.26),('3355','2013-06-18','17:30:00',1.22),('3355','2013-06-18','17:35:00',1.18),('3355','2013-06-18','17:40:00',1.13),('3355','2013-06-18','17:45:00',1.09),('3355','2013-06-18','17:50:00',1.03),('3355','2013-06-17','08:50:00',1.04),('3355','2013-06-17','08:55:00',1.08),('3355','2013-06-17','09:00:00',1.12),('3355','2013-06-17','09:05:00',1.16),('3355','2013-06-17','09:10:00',1.2),('3355','2013-06-17','09:15:00',1.23),('3355','2013-06-17','09:20:00',1.28),('3355','2013-06-17','09:25:00',1.32),('3355','2013-06-17','09:30:00',1.35),('3355','2013-06-17','09:35:00',1.39),('3355','2013-06-17','09:40:00',1.42),('3355','2013-06-17','09:45:00',1.46),('3355','2013-06-17','09:50:00',1.49),('3355','2013-06-17','09:55:00',1.52),('3355','2013-06-17','10:00:00',1.54),('3355','2013-06-17','10:05:00',1.58),('3355','2013-06-17','10:10:00',1.61),('3355','2013-06-17','10:15:00',1.63),('3355','2013-06-17','10:20:00',1.66),('3355','2013-06-17','10:25:00',1.68),('3355','2013-06-17','10:30:00',1.72),('3355','2013-06-17','10:35:00',1.75),('3355','2013-06-17','10:40:00',1.77),('3355','2013-06-17','10:45:00',1.79),('3355','2013-06-17','10:50:00',1.81),('3355','2013-06-17','10:55:00',1.83),('3355','2013-06-17','11:00:00',1.86),('3355','2013-06-17','11:05:00',1.87),('3355','2013-06-17','11:10:00',1.88),('3355','2013-06-17','11:15:00',1.89),('3355','2013-06-17','11:20:00',1.91),('3355','2013-06-17','11:25:00',1.92),('3355','2013-06-17','11:30:00',1.93),('3355','2013-06-17','11:35:00',1.94),('3355','2013-06-17','11:40:00',1.93),('3355','2013-06-17','11:45:00',1.97),('3355','2013-06-17','11:50:00',1.99),('3355','2013-06-17','11:55:00',2),('3355','2013-06-17','12:00:00',2),('3355','2013-06-17','12:05:00',2),('3355','2013-06-17','12:10:00',2.03),('3355','2013-06-17','12:15:00',2.05),('3355','2013-06-17','12:20:00',2.07),('3355','2013-06-17','12:25:00',2.06),('3355','2013-06-17','12:30:00',2.04),('3355','2013-06-17','12:35:00',2.05),('3355','2013-06-17','12:40:00',2.05),('3355','2013-06-17','12:45:00',2.05),('3355','2013-06-17','12:50:00',2.07),('3355','2013-06-17','12:55:00',2.09),('3355','2013-06-17','13:00:00',2.12),('3355','2013-06-17','13:05:00',2.13),('3355','2013-06-17','13:10:00',2.15),('3355','2013-06-17','13:15:00',2.16),('3355','2013-06-17','13:20:00',2.15),('3355','2013-06-17','13:25:00',2.15),('3355','2013-06-17','13:30:00',2.16),('3355','2013-06-17','13:35:00',2.14),('3355','2013-06-17','13:40:00',2.14),('3355','2013-06-17','13:45:00',2.15),('3355','2013-06-17','13:50:00',2.14),('3355','2013-06-17','13:55:00',2.14),('3355','2013-06-17','14:00:00',2.14),('3355','2013-06-17','14:05:00',2.14),('3355','2013-06-17','14:10:00',2.13),('3355','2013-06-17','14:15:00',2.13),('3355','2013-06-17','14:20:00',2.11),('3355','2013-06-17','14:25:00',2.11),('3355','2013-06-17','14:30:00',2.1),('3355','2013-06-17','14:35:00',2.09),('3355','2013-06-17','14:40:00',2.09),('3355','2013-06-17','14:45:00',2.08),('3355','2013-06-17','14:50:00',2.06),('3355','2013-06-17','14:55:00',2.06),('3355','2013-06-17','15:00:00',2.04),('3355','2013-06-17','15:05:00',2.03),('3355','2013-06-17','15:10:00',2),('3355','2013-06-17','15:15:00',1.98),('3355','2013-06-17','15:20:00',1.97),('3355','2013-06-17','15:25:00',1.95),('3355','2013-06-17','15:30:00',1.93),('3355','2013-06-17','15:35:00',1.91),('3355','2013-06-17','15:40:00',1.89),('3355','2013-06-17','15:45:00',1.87),('3355','2013-06-17','15:50:00',1.84),('3355','2013-06-17','15:55:00',1.82),('3355','2013-06-17','16:00:00',1.8),('3355','2013-06-17','16:05:00',1.77),('3355','2013-06-17','16:10:00',1.75),('3355','2013-06-17','16:15:00',1.73),('3355','2013-06-17','16:20:00',1.7),('3355','2013-06-17','16:25:00',1.67),('3355','2013-06-17','16:30:00',1.63),('3355','2013-06-17','16:35:00',1.6),('3355','2013-06-17','16:40:00',1.57),('3355','2013-06-17','16:45:00',1.54),('3355','2013-06-17','16:50:00',1.51),('3355','2013-06-17','16:55:00',1.49),('3355','2013-06-17','17:00:00',1.46),('3355','2013-06-17','17:05:00',1.42),('3355','2013-06-17','17:10:00',1.38),('3355','2013-06-17','17:15:00',1.34),('3355','2013-06-17','17:20:00',1.31),('3355','2013-06-17','17:25:00',1.28),('3355','2013-06-17','17:30:00',1.25),('3355','2013-06-17','17:35:00',1.21),('3355','2013-06-17','17:40:00',1.17),('3355','2013-06-17','17:45:00',1.12),('3355','2013-06-17','17:50:00',1.08),('3355','2013-06-17','17:55:00',1.03),('3355','2013-06-16','08:50:00',1.03),('3355','2013-06-16','08:55:00',1.09),('3355','2013-06-16','09:00:00',1.14),('3355','2013-06-16','09:05:00',1.18),('3355','2013-06-16','09:10:00',1.23),('3355','2013-06-16','09:15:00',1.28),('3355','2013-06-16','09:20:00',1.31),('3355','2013-06-16','09:25:00',1.34),('3355','2013-06-16','09:30:00',1.37),('3355','2013-06-16','09:35:00',1.4),('3355','2013-06-16','09:40:00',1.43),('3355','2013-06-16','09:45:00',1.47),('3355','2013-06-16','09:50:00',1.51),('3355','2013-06-16','09:55:00',1.53),('3355','2013-06-16','10:00:00',1.56),('3355','2013-06-16','10:05:00',1.6),('3355','2013-06-16','10:10:00',1.61),('3355','2013-06-16','10:15:00',1.64),('3355','2013-06-16','10:20:00',1.67),('3355','2013-06-16','10:25:00',1.72),('3355','2013-06-16','10:30:00',1.75),('3355','2013-06-16','10:35:00',1.79),('3355','2013-06-16','10:40:00',1.8),('3355','2013-06-16','10:45:00',1.82),('3355','2013-06-16','10:50:00',1.83),('3355','2013-06-16','10:55:00',1.86),('3355','2013-06-16','11:00:00',1.89),('3355','2013-06-16','11:05:00',1.89),('3355','2013-06-16','11:10:00',1.92),('3355','2013-06-16','11:15:00',1.95),('3355','2013-06-16','11:20:00',1.97),('3355','2013-06-16','11:25:00',1.99),('3355','2013-06-16','11:30:00',2),('3355','2013-06-16','11:35:00',2.02),('3355','2013-06-16','11:40:00',2.05),('3355','2013-06-16','11:45:00',2.04),('3355','2013-06-16','11:50:00',2.06),('3355','2013-06-16','11:55:00',2.08),('3355','2013-06-16','12:00:00',2.09),('3355','2013-06-16','12:05:00',2.12),('3355','2013-06-16','12:10:00',2.13),('3355','2013-06-16','12:15:00',2.14),('3355','2013-06-16','12:20:00',2.16),('3355','2013-06-16','12:25:00',2.16),('3355','2013-06-16','12:30:00',2.18),('3355','2013-06-16','12:35:00',2.19),('3355','2013-06-16','12:40:00',2.18),('3355','2013-06-16','12:45:00',2.18),('3355','2013-06-16','12:50:00',2.18),('3355','2013-06-16','12:55:00',2.16),('3355','2013-06-16','13:00:00',2.16),('3355','2013-06-16','13:05:00',2.19),('3355','2013-06-16','13:10:00',2.23),('3355','2013-06-16','13:15:00',2.24),('3355','2013-06-16','13:20:00',2.24),('3355','2013-06-16','13:25:00',2.25),('3355','2013-06-16','13:30:00',2.25),('3355','2013-06-16','13:35:00',2.26),('3355','2013-06-16','13:40:00',2.26),('3355','2013-06-16','13:45:00',2.25),('3355','2013-06-16','13:50:00',2.24),('3355','2013-06-16','13:55:00',2.24),('3355','2013-06-16','14:00:00',2.23),('3355','2013-06-16','14:05:00',2.21),('3355','2013-06-16','14:10:00',2.21),('3355','2013-06-16','14:15:00',2.22),('3355','2013-06-16','14:20:00',2.22),('3355','2013-06-16','14:25:00',2.2),('3355','2013-06-16','14:30:00',2.19),('3355','2013-06-16','14:35:00',2.18),('3355','2013-06-16','14:40:00',2.15),('3355','2013-06-16','14:45:00',2.14),('3355','2013-06-16','14:50:00',2.12),('3355','2013-06-16','14:55:00',2.11),('3355','2013-06-16','15:00:00',2.1),('3355','2013-06-16','15:05:00',2.09),('3355','2013-06-16','15:10:00',2.07),('3355','2013-06-16','15:15:00',2.06),('3355','2013-06-16','15:20:00',2.05),('3355','2013-06-16','15:25:00',2.03),('3355','2013-06-16','15:30:00',2.01),('3355','2013-06-16','15:35:00',1.98),('3355','2013-06-16','15:40:00',1.96),('3355','2013-06-16','15:45:00',1.93),('3355','2013-06-16','15:50:00',1.91),('3355','2013-06-16','15:55:00',1.89),('3355','2013-06-16','16:00:00',1.86),('3355','2013-06-16','16:05:00',1.83),('3355','2013-06-16','16:10:00',1.81),('3355','2013-06-16','16:15:00',1.79),('3355','2013-06-16','16:20:00',1.75),('3355','2013-06-16','16:25:00',1.73),('3355','2013-06-16','16:30:00',1.7),('3355','2013-06-16','16:35:00',1.67),('3355','2013-06-16','16:40:00',1.63),('3355','2013-06-16','16:45:00',1.6),('3355','2013-06-16','16:50:00',1.56),('3355','2013-06-16','16:55:00',1.52),('3355','2013-06-16','17:00:00',1.48),('3355','2013-06-16','17:05:00',1.44),('3355','2013-06-16','17:10:00',1.4),('3355','2013-06-16','17:15:00',1.36),('3355','2013-06-16','17:20:00',1.32),('3355','2013-06-16','17:25:00',1.28),('3355','2013-06-16','17:30:00',1.24),('3355','2013-06-16','17:35:00',1.19),('3355','2013-06-16','17:40:00',1.16),('3355','2013-06-16','17:45:00',1.11),('3355','2013-06-16','17:50:00',1.07),('3355','2013-06-16','17:55:00',1.01),('3355','2013-06-15','08:45:00',1.01),('3355','2013-06-15','08:55:00',1.07),('3355','2013-06-15','09:00:00',1.09),('3355','2013-06-15','09:10:00',1.22),('3355','2013-06-15','09:15:00',1.25),('3355','2013-06-15','09:20:00',1.3),('3355','2013-06-15','09:25:00',1.3),('3355','2013-06-15','09:30:00',1.38),('3355','2013-06-15','09:35:00',1.43),('3355','2013-06-15','09:40:00',1.4),('3355','2013-06-15','09:45:00',1.46),('3355','2013-06-15','09:50:00',1.45),('3355','2013-06-15','09:55:00',1.54),('3355','2013-06-15','10:00:00',1.6),('3355','2013-06-15','10:05:00',1.65),('3355','2013-06-15','10:10:00',1.66),('3355','2013-06-15','10:20:00',1.19),('3355','2013-06-15','10:25:00',1.12),('3355','2013-06-15','10:30:00',1.28),('3355','2013-06-15','10:35:00',1.87),('3355','2013-06-15','10:40:00',1.22),('3355','2013-06-15','10:45:00',1.56),('3355','2013-06-15','10:50:00',1.6),('3355','2013-06-15','10:55:00',1.72),('3355','2013-06-15','11:00:00',1.49),('3355','2013-06-15','11:05:00',1.2),('3355','2013-06-15','11:10:00',1.54),('3355','2013-06-15','11:15:00',2.14),('3355','2013-06-15','11:20:00',2.14),('3355','2013-06-15','11:25:00',1.56),('3355','2013-06-15','11:30:00',1.57),('3355','2013-06-15','11:35:00',2.22),('3355','2013-06-15','11:40:00',2.02),('3355','2013-06-15','11:45:00',2.17),('3355','2013-06-15','11:50:00',1.13),('3355','2013-06-15','11:55:00',2.25),('3355','2013-06-15','12:00:00',2.23),('3355','2013-06-15','12:05:00',2.22),('3355','2013-06-15','12:10:00',2.09),('3355','2013-06-15','12:15:00',2.28),('3355','2013-06-15','12:20:00',2.25),('3355','2013-06-15','12:25:00',2.21),('3355','2013-06-15','12:30:00',2.24),('3355','2013-06-15','12:35:00',2.26),('3355','2013-06-15','12:40:00',2.22),('3355','2013-06-15','12:45:00',2.24),('3355','2013-06-15','12:50:00',2.23),('3355','2013-06-15','12:55:00',2.24),('3355','2013-06-15','13:00:00',2.25),('3355','2013-06-15','13:05:00',2.23),('3355','2013-06-15','13:10:00',2.25),('3355','2013-06-15','13:15:00',2.24),('3355','2013-06-15','13:20:00',2.25),('3355','2013-06-15','13:25:00',2.24),('3355','2013-06-15','13:30:00',2.24),('3355','2013-06-15','13:35:00',2.2),('3355','2013-06-15','13:40:00',2.23),('3355','2013-06-15','13:45:00',2.23),('3355','2013-06-15','13:50:00',2.23),('3355','2013-06-15','13:55:00',2.21),('3355','2013-06-15','14:00:00',2.21),('3355','2013-06-15','14:05:00',2.21),('3355','2013-06-15','14:10:00',2.22),('3355','2013-06-15','14:15:00',2.2),('3355','2013-06-15','14:20:00',2.2),('3355','2013-06-15','14:25:00',2.2),('3355','2013-06-15','14:30:00',2.17),('3355','2013-06-15','14:35:00',2.17),('3355','2013-06-15','14:40:00',2.16),('3355','2013-06-15','14:45:00',2.13),('3355','2013-06-15','14:50:00',2.13),('3355','2013-06-15','14:55:00',2.13),('3355','2013-06-15','15:00:00',2.08),('3355','2013-06-15','15:05:00',2.06),('3355','2013-06-15','15:10:00',2.05),('3355','2013-06-15','15:15:00',2.04),('3355','2013-06-15','15:20:00',2.05),('3355','2013-06-15','15:25:00',2.04),('3355','2013-06-15','15:30:00',2.03),('3355','2013-06-15','15:35:00',1.99),('3355','2013-06-15','15:40:00',1.97),('3355','2013-06-15','15:45:00',1.95),('3355','2013-06-15','15:50:00',1.92),('3355','2013-06-15','15:55:00',1.9),('3355','2013-06-15','16:00:00',1.87),('3355','2013-06-15','16:05:00',1.84),('3355','2013-06-15','16:10:00',1.8),('3355','2013-06-15','16:15:00',1.78),('3355','2013-06-15','16:20:00',1.74),('3355','2013-06-15','16:25:00',1.71),('3355','2013-06-15','16:30:00',1.68),('3355','2013-06-15','16:35:00',1.64),('3355','2013-06-15','16:40:00',1.62),('3355','2013-06-15','16:45:00',1.59),('3355','2013-06-15','16:50:00',1.55),('3355','2013-06-15','16:55:00',1.51),('3355','2013-06-15','17:00:00',1.48),('3355','2013-06-15','17:05:00',1.43),('3355','2013-06-15','17:10:00',1.4),('3355','2013-06-15','17:15:00',1.37),('3355','2013-06-15','17:20:00',1.32),('3355','2013-06-15','17:25:00',1.28),('3355','2013-06-15','17:30:00',1.23),('3355','2013-06-15','17:35:00',1.19),('3355','2013-06-15','17:40:00',1.16),('3355','2013-06-15','17:45:00',1.1),('3355','2013-06-15','17:50:00',1.04),('3355','2013-06-14','08:40:00',1.01),('3355','2013-06-14','08:45:00',1.07),('3355','2013-06-14','08:50:00',1.11),('3355','2013-06-14','08:55:00',1.15),('3355','2013-06-14','09:00:00',1.2),('3355','2013-06-14','09:05:00',1.24),('3355','2013-06-14','09:10:00',1.28),('3355','2013-06-14','09:15:00',1.32),('3355','2013-06-14','09:20:00',1.36),('3355','2013-06-14','09:25:00',1.39),('3355','2013-06-14','09:30:00',1.41),('3355','2013-06-14','09:35:00',1.47),('3355','2013-06-14','09:40:00',1.51),('3355','2013-06-14','09:45:00',1.55),('3355','2013-06-14','09:50:00',1.59),('3355','2013-06-14','09:55:00',1.62),('3355','2013-06-14','10:00:00',1.65),('3355','2013-06-14','10:05:00',1.68),('3355','2013-06-14','10:10:00',1.69),('3355','2013-06-14','10:15:00',1.72),('3355','2013-06-14','10:20:00',1.76),('3355','2013-06-14','10:25:00',1.76),('3355','2013-06-14','10:30:00',1.81),('3355','2013-06-14','10:35:00',1.88),('3355','2013-06-14','10:40:00',1.9),('3355','2013-06-14','10:45:00',1.92),('3355','2013-06-14','10:50:00',1.91),('3355','2013-06-14','10:55:00',1.91),('3355','2013-06-14','11:00:00',1.91),('3355','2013-06-14','11:05:00',1.93),('3355','2013-06-14','11:10:00',1.99),('3355','2013-06-14','11:15:00',2.01),('3355','2013-06-14','11:20:00',2.01),('3355','2013-06-14','11:25:00',1.98),('3355','2013-06-14','11:30:00',2.09),('3355','2013-06-14','11:35:00',2.1),('3355','2013-06-14','11:40:00',2.1),('3355','2013-06-14','11:45:00',2.11),('3355','2013-06-14','11:50:00',2.12),('3355','2013-06-14','11:55:00',2.14),('3355','2013-06-14','12:00:00',2.15),('3355','2013-06-14','12:05:00',2.14),('3355','2013-06-14','12:10:00',2.15),('3355','2013-06-14','12:15:00',2.15),('3355','2013-06-14','12:20:00',2.17),('3355','2013-06-14','12:25:00',2.18),('3355','2013-06-14','12:30:00',2.16),('3355','2013-06-14','12:35:00',2.18),('3355','2013-06-14','12:40:00',2.18),('3355','2013-06-14','12:45:00',2.21),('3355','2013-06-14','12:50:00',2.19),('3355','2013-06-14','12:55:00',2.18),('3355','2013-06-14','13:00:00',2.19),('3355','2013-06-14','13:05:00',2.22),('3355','2013-06-14','13:10:00',2.2),('3355','2013-06-14','13:15:00',1.19),('3355','2013-06-14','13:20:00',2.3),('3355','2013-06-14','13:25:00',2.34),('3355','2013-06-14','13:30:00',2.28),('3355','2013-06-14','13:35:00',2.23),('3355','2013-06-14','13:40:00',2.23),('3355','2013-06-14','13:45:00',2.26),('3355','2013-06-14','13:50:00',2.26),('3355','2013-06-14','13:55:00',2.26),('3355','2013-06-14','14:00:00',2.25),('3355','2013-06-14','14:05:00',2.25),('3355','2013-06-14','14:10:00',2.26),('3355','2013-06-14','14:15:00',2.23),('3355','2013-06-14','14:20:00',2.21),('3355','2013-06-14','14:25:00',2.21),('3355','2013-06-14','14:30:00',2.23),('3355','2013-06-14','14:35:00',2.19),('3355','2013-06-14','14:40:00',2.17),('3355','2013-06-14','14:45:00',2.16),('3355','2013-06-14','14:50:00',2.13),('3355','2013-06-14','14:55:00',2.14),('3355','2013-06-14','15:00:00',2.14),('3355','2013-06-14','15:05:00',2.13),('3355','2013-06-14','15:10:00',2.11),('3355','2013-06-14','15:15:00',2.09),('3355','2013-06-14','15:20:00',2.08),('3355','2013-06-14','15:25:00',2.06),('3355','2013-06-14','15:30:00',2.05),('3355','2013-06-14','15:35:00',2.02),('3355','2013-06-14','15:40:00',2),('3355','2013-06-14','15:45:00',1.98),('3355','2013-06-14','15:50:00',1.96),('3355','2013-06-14','15:55:00',1.93),('3355','2013-06-14','16:00:00',1.9),('3355','2013-06-14','16:05:00',1.87),('3355','2013-06-14','16:10:00',1.85),('3355','2013-06-14','16:15:00',1.81),('3355','2013-06-14','16:20:00',1.79),('3355','2013-06-14','16:25:00',1.75),('3355','2013-06-14','16:30:00',1.71),('3355','2013-06-14','16:35:00',1.67),('3355','2013-06-14','16:40:00',1.62),('3355','2013-06-14','16:45:00',1.6),('3355','2013-06-14','16:50:00',1.57),('3355','2013-06-14','16:55:00',1.54),('3355','2013-06-14','17:00:00',1.5),('3355','2013-06-14','17:05:00',1.42),('3355','2013-06-14','17:10:00',1.4),('3355','2013-06-14','17:15:00',1.39),('3355','2013-06-14','17:20:00',1.34),('3355','2013-06-14','17:25:00',1.3),('3355','2013-06-14','17:30:00',1.23),('3355','2013-06-14','17:35:00',1.2),('3355','2013-06-14','17:40:00',1.18),('3355','2013-06-14','17:45:00',1.13),('3355','2013-06-14','17:50:00',1.09),('3355','2013-06-14','17:55:00',1.04),('3355','2013-06-13','08:40:00',1.03),('3355','2013-06-13','08:45:00',1.08),('3355','2013-06-13','08:50:00',1.12),('3355','2013-06-13','08:55:00',1.17),('3355','2013-06-13','09:00:00',1.21),('3355','2013-06-13','09:05:00',1.25),('3355','2013-06-13','09:10:00',1.3),('3355','2013-06-13','09:15:00',1.34),('3355','2013-06-13','09:20:00',1.38),('3355','2013-06-13','09:25:00',1.43),('3355','2013-06-13','09:30:00',1.47),('3355','2013-06-13','09:35:00',1.5),('3355','2013-06-13','09:40:00',1.54),('3355','2013-06-13','09:45:00',1.57),('3355','2013-06-13','09:50:00',1.6),('3355','2013-06-13','09:55:00',1.64),('3355','2013-06-13','10:00:00',1.68),('3355','2013-06-13','10:05:00',1.71),('3355','2013-06-13','10:10:00',1.73),('3355','2013-06-13','10:15:00',1.77),('3355','2013-06-13','10:20:00',1.8),('3355','2013-06-13','10:25:00',1.83),('3355','2013-06-13','10:30:00',1.87),('3355','2013-06-13','10:35:00',1.89),('3355','2013-06-13','10:40:00',1.91),('3355','2013-06-13','10:45:00',1.95),('3355','2013-06-13','10:50:00',1.97),('3355','2013-06-13','10:55:00',2),('3355','2013-06-13','11:00:00',2.01),('3355','2013-06-13','11:05:00',2.04),('3355','2013-06-13','11:10:00',2.06),('3355','2013-06-13','11:15:00',2.08),('3355','2013-06-13','11:20:00',2.1),('3355','2013-06-13','11:25:00',2.12),('3355','2013-06-13','11:30:00',2.14),('3355','2013-06-13','11:35:00',2.17),('3355','2013-06-13','11:40:00',2.19),('3355','2013-06-13','11:45:00',2.21),('3355','2013-06-13','11:50:00',2.21),('3355','2013-06-13','11:55:00',2.21),('3355','2013-06-13','12:00:00',2.23),('3355','2013-06-13','12:05:00',2.26),('3355','2013-06-13','12:10:00',2.25),('3355','2013-06-13','12:15:00',2.27),('3355','2013-06-13','12:20:00',2.28),('3355','2013-06-13','12:25:00',2.3),('3355','2013-06-13','12:30:00',2.31),('3355','2013-06-13','12:35:00',2.32),('3355','2013-06-13','12:40:00',2.32),('3355','2013-06-13','12:45:00',2.32),('3355','2013-06-13','12:50:00',2.32),('3355','2013-06-13','12:55:00',2.32),('3355','2013-06-13','13:00:00',2.31),('3355','2013-06-13','13:05:00',2.33),('3355','2013-06-13','13:10:00',2.31),('3355','2013-06-13','13:15:00',2.31),('3355','2013-06-13','13:20:00',2.18),('3355','2013-06-13','13:25:00',2.31),('3355','2013-06-13','13:30:00',2.3),('3355','2013-06-13','13:35:00',2.3),('3355','2013-06-13','13:40:00',2.3),('3355','2013-06-13','13:45:00',2.3),('3355','2013-06-13','13:50:00',2.29),('3355','2013-06-13','13:55:00',2.29),('3355','2013-06-13','14:00:00',2.28),('3355','2013-06-13','14:05:00',2.28),('3355','2013-06-13','14:10:00',2.26),('3355','2013-06-13','14:15:00',2.27),('3355','2013-06-13','14:20:00',2.24),('3355','2013-06-13','14:25:00',2.27),('3355','2013-06-13','14:30:00',1.77),('3355','2013-06-13','14:35:00',1.95),('3355','2013-06-13','14:40:00',2.26),('3355','2013-06-13','14:45:00',2.23),('3355','2013-06-13','14:50:00',2.17),('3355','2013-06-13','14:55:00',2.15),('3355','2013-06-13','15:00:00',2.15),('3355','2013-06-13','15:05:00',2.13),('3355','2013-06-13','15:10:00',2.11),('3355','2013-06-13','15:15:00',2.09),('3355','2013-06-13','15:20:00',2.07),('3355','2013-06-13','15:25:00',2.04),('3355','2013-06-13','15:30:00',2.03),('3355','2013-06-13','15:35:00',2.03),('3355','2013-06-13','15:40:00',2.01),('3355','2013-06-13','15:45:00',1.98),('3355','2013-06-13','15:50:00',1.95),('3355','2013-06-13','15:55:00',1.93),('3355','2013-06-13','16:00:00',1.89),('3355','2013-06-13','16:05:00',1.86),('3355','2013-06-13','16:10:00',1.83),('3355','2013-06-13','16:15:00',1.8),('3355','2013-06-13','16:20:00',1.77),('3355','2013-06-13','16:25:00',1.73),('3355','2013-06-13','16:30:00',1.71),('3355','2013-06-13','16:35:00',1.67),('3355','2013-06-13','16:40:00',1.63),('3355','2013-06-13','16:45:00',1.6),('3355','2013-06-13','16:50:00',1.55),('3355','2013-06-13','16:55:00',1.5),('3355','2013-06-13','17:00:00',1.47),('3355','2013-06-13','17:05:00',1.43),('3355','2013-06-13','17:10:00',1.4),('3355','2013-06-13','17:15:00',1.38),('3355','2013-06-13','17:20:00',1.34),('3355','2013-06-13','17:25:00',1.3),('3355','2013-06-13','17:30:00',1.26),('3355','2013-06-13','17:35:00',1.22),('3355','2013-06-13','17:40:00',1.17),('3355','2013-06-13','17:45:00',1.13),('3355','2013-06-13','17:50:00',1.09),('3355','2013-06-13','17:55:00',1.04),('3355','2013-06-12','08:35:00',1),('3355','2013-06-12','08:40:00',1.05),('3355','2013-06-12','08:45:00',1.1),('3355','2013-06-12','08:50:00',1.14),('3355','2013-06-12','08:55:00',1.19),('3355','2013-06-12','09:00:00',1.23),('3355','2013-06-12','09:05:00',1.28),('3355','2013-06-12','09:10:00',1.33),('3355','2013-06-12','09:15:00',1.37),('3355','2013-06-12','09:20:00',1.41),('3355','2013-06-12','09:25:00',1.45),('3355','2013-06-12','09:30:00',1.49),('3355','2013-06-12','09:35:00',1.53),('3355','2013-06-12','09:40:00',1.57),('3355','2013-06-12','09:45:00',1.6),('3355','2013-06-12','09:50:00',1.65),('3355','2013-06-12','09:55:00',1.68),('3355','2013-06-12','10:00:00',1.7),('3355','2013-06-12','10:05:00',1.73),('3355','2013-06-12','10:10:00',1.77),('3355','2013-06-12','10:15:00',1.8),('3355','2013-06-12','10:20:00',1.84),('3355','2013-06-12','10:25:00',1.86),('3355','2013-06-12','10:30:00',1.88),('3355','2013-06-12','10:35:00',1.89),('3355','2013-06-12','10:40:00',1.92),('3355','2013-06-12','10:45:00',1.95),('3355','2013-06-12','10:50:00',1.99),('3355','2013-06-12','10:55:00',2.02),('3355','2013-06-12','11:00:00',2.06),('3355','2013-06-12','11:05:00',2.07),('3355','2013-06-12','11:10:00',2.09),('3355','2013-06-12','11:15:00',2.12),('3355','2013-06-12','11:20:00',2.13),('3355','2013-06-12','11:25:00',2.14),('3355','2013-06-12','11:30:00',2.16),('3355','2013-06-12','11:35:00',2.17),('3355','2013-06-12','11:40:00',2.2),('3355','2013-06-12','11:45:00',2.2),('3355','2013-06-12','11:50:00',2.21),('3355','2013-06-12','11:55:00',2.25),('3355','2013-06-12','12:00:00',2.24),('3355','2013-06-12','12:05:00',2.27),('3355','2013-06-12','12:10:00',2.25),('3355','2013-06-12','12:15:00',2.28),('3355','2013-06-12','12:20:00',2.3),('3355','2013-06-12','12:25:00',2.26),('3355','2013-06-12','12:30:00',2.45),('3355','2013-06-12','12:35:00',2.39),('3355','2013-06-12','12:45:00',1.68),('3355','2013-06-12','12:50:00',2.48),('3355','2013-06-12','12:55:00',2.38),('3355','2013-06-12','13:00:00',2.23),('3355','2013-06-12','13:05:00',2.18),('3355','2013-06-12','13:10:00',2.36),('3355','2013-06-12','13:15:00',2.32),('3355','2013-06-12','13:20:00',2.3),('3355','2013-06-12','13:25:00',2.31),('3355','2013-06-12','13:30:00',2.32),('3355','2013-06-12','13:35:00',2.33),('3355','2013-06-12','13:40:00',2.33),('3355','2013-06-12','13:45:00',2.35),('3355','2013-06-12','13:50:00',2.34),('3355','2013-06-12','13:55:00',2.36),('3355','2013-06-12','14:00:00',2.39),('3355','2013-06-12','14:05:00',1.81),('3355','2013-06-12','14:10:00',2.19),('3355','2013-06-12','14:15:00',2.23),('3355','2013-06-12','14:20:00',1.21),('3355','2013-06-12','14:30:00',2.51),('3355','2013-06-12','14:35:00',2.35),('3355','2013-06-12','14:40:00',2.26),('3355','2013-06-12','14:45:00',2.29),('3355','2013-06-12','14:50:00',2.32),('3355','2013-06-12','14:55:00',2.4),('3355','2013-06-12','15:00:00',2.38),('3355','2013-06-12','15:05:00',2.27),('3355','2013-06-12','15:10:00',2.27),('3355','2013-06-12','15:15:00',1.9),('3355','2013-06-12','15:20:00',2.23),('3355','2013-06-12','15:25:00',2.13),('3355','2013-06-12','15:30:00',2.13),('3355','2013-06-12','15:35:00',2.12),('3355','2013-06-12','15:40:00',2.09),('3355','2013-06-12','15:45:00',2.08),('3355','2013-06-12','15:50:00',2.03),('3355','2013-06-12','15:55:00',2.03),('3355','2013-06-12','16:00:00',1.95),('3355','2013-06-12','16:05:00',1.78),('3355','2013-06-12','16:10:00',1.94),('3355','2013-06-12','16:15:00',1.9),('3355','2013-06-12','16:20:00',1.83),('3355','2013-06-12','16:25:00',1.81),('3355','2013-06-12','16:30:00',1.77),('3355','2013-06-12','16:35:00',1.74),('3355','2013-06-12','16:40:00',1.7),('3355','2013-06-12','16:45:00',1.4),('3355','2013-06-12','16:50:00',1.64),('3355','2013-06-12','16:55:00',1.59),('3355','2013-06-12','17:00:00',1.53),('3355','2013-06-12','17:05:00',1.51),('3355','2013-06-12','17:10:00',1.48),('3355','2013-06-12','17:15:00',1.44),('3355','2013-06-12','17:20:00',1.38),('3355','2013-06-12','17:25:00',1.33),('3355','2013-06-12','17:30:00',1.3),('3355','2013-06-12','17:35:00',1.27),('3355','2013-06-12','17:40:00',1.24),('3355','2013-06-12','17:45:00',1.16),('3355','2013-06-12','18:05:00',1.02),('3355','2013-06-11','08:50:00',1.25),('3355','2013-06-11','08:55:00',1.36),('3355','2013-06-11','09:00:00',1),('3355','2013-06-11','09:15:00',1.21),('3355','2013-06-11','09:20:00',1.5),('3355','2013-06-11','09:25:00',1.63),('3355','2013-06-11','09:30:00',1.41),('3355','2013-06-11','09:35:00',1.63),('3355','2013-06-11','09:55:00',1.84),('3355','2013-06-11','10:00:00',1.86),('3355','2013-06-11','10:05:00',1.59),('3355','2013-06-11','10:10:00',1.66),('3355','2013-06-11','10:15:00',1.81),('3355','2013-06-11','10:20:00',1.92),('3355','2013-06-11','10:25:00',1.96),('3355','2013-06-11','10:30:00',1.56),('3355','2013-06-11','10:35:00',2),('3355','2013-06-11','10:40:00',2.05),('3355','2013-06-11','10:45:00',1.88),('3355','2013-06-11','10:50:00',2.07),('3355','2013-06-11','10:55:00',1.54),('3355','2013-06-11','11:00:00',1.18),('3355','2013-06-11','11:05:00',2.28),('3355','2013-06-11','11:10:00',1.05),('3355','2013-06-11','11:15:00',1.58),('3355','2013-06-11','11:20:00',2.26),('3355','2013-06-11','11:25:00',2.24),('3355','2013-06-11','11:30:00',2.27),('3355','2013-06-11','11:35:00',2.22),('3355','2013-06-11','11:40:00',2.25),('3355','2013-06-11','11:45:00',2.26),('3355','2013-06-11','11:50:00',2.3),('3355','2013-06-11','11:55:00',2.32),('3355','2013-06-11','12:00:00',2.34),('3355','2013-06-11','12:05:00',2.4),('3355','2013-06-11','12:10:00',2.37),('3355','2013-06-11','12:15:00',2.35),('3355','2013-06-11','12:20:00',2.37),('3355','2013-06-11','12:25:00',2.37),('3355','2013-06-11','12:30:00',2.38),('3355','2013-06-11','12:35:00',2.37),('3355','2013-06-11','12:40:00',2.4),('3355','2013-06-11','12:45:00',2.41),('3355','2013-06-11','12:50:00',2.42),('3355','2013-06-11','12:55:00',2.44),('3355','2013-06-11','13:00:00',2.43),('3355','2013-06-11','13:05:00',2.45),('3355','2013-06-11','13:10:00',2.45),('3355','2013-06-11','13:15:00',2.23),('3355','2013-06-11','13:20:00',2.46),('3355','2013-06-11','13:25:00',2.45),('3355','2013-06-11','13:30:00',2.45),('3355','2013-06-11','13:35:00',2.46),('3355','2013-06-11','13:40:00',2.47),('3355','2013-06-11','13:45:00',2.46),('3355','2013-06-11','13:50:00',1.75),('3355','2013-06-11','13:55:00',2.4),('3355','2013-06-11','14:00:00',2.46),('3355','2013-06-11','14:05:00',2.44),('3355','2013-06-11','14:10:00',2.4),('3355','2013-06-11','14:15:00',2.38),('3355','2013-06-11','14:20:00',2.36),('3355','2013-06-11','14:25:00',2.36),('3355','2013-06-11','14:30:00',2.37),('3355','2013-06-11','14:35:00',2.36),('3355','2013-06-11','14:40:00',2.33),('3355','2013-06-11','14:45:00',2.32),('3355','2013-06-11','14:50:00',2.29),('3355','2013-06-11','14:55:00',2.28),('3355','2013-06-11','15:00:00',2.27),('3355','2013-06-11','15:05:00',2.26),('3355','2013-06-11','15:10:00',2.24),('3355','2013-06-11','15:15:00',2.21),('3355','2013-06-11','15:20:00',2.2),('3355','2013-06-11','15:25:00',2.16),('3355','2013-06-11','15:30:00',2.15),('3355','2013-06-11','15:35:00',2.16),('3355','2013-06-11','15:40:00',2.15),('3355','2013-06-11','15:45:00',2.06),('3355','2013-06-11','15:50:00',2.07),('3355','2013-06-11','15:55:00',1.99),('3355','2013-06-11','16:00:00',2.03),('3355','2013-06-11','16:05:00',1.99),('3355','2013-06-11','16:10:00',1.96),('3355','2013-06-11','16:15:00',1.93),('3355','2013-06-11','16:20:00',1.89),('3355','2013-06-11','16:25:00',1.85),('3355','2013-06-11','16:30:00',1.82),('3355','2013-06-11','16:35:00',1.79),('3355','2013-06-11','16:40:00',1.8),('3355','2013-06-11','16:45:00',1.87),('3355','2013-06-11','16:50:00',1.88),('3355','2013-06-11','16:55:00',1.82),('3355','2013-06-11','17:00:00',1.7),('3355','2013-06-11','17:05:00',1.29),('3355','2014-04-03','09:40:00',1),('3355','2014-04-03','10:00:00',1.14),('3355','2014-04-03','10:05:00',1.35),('3355','2014-04-03','10:10:00',1.45),('3355','2014-04-03','10:15:00',1.64),('3355','2014-04-03','10:20:00',1.71),('3355','2014-04-03','10:25:00',1.52),('3355','2014-04-03','10:30:00',1.41),('3355','2014-04-03','10:35:00',1.55),('3355','2014-04-03','10:40:00',1.25),('3355','2014-04-03','10:45:00',1.31),('3355','2014-04-03','10:50:00',1.1),('3355','2014-04-03','10:55:00',1.16),('3355','2014-04-03','11:00:00',1.11),('3355','2014-04-03','11:50:00',1.17),('3355','2014-04-03','11:55:00',1.32),('3355','2014-04-03','12:00:00',1.24),('3355','2014-04-03','12:05:00',1.24),('3355','2014-04-03','12:10:00',1.19),('3355','2014-04-03','12:15:00',1.17),('3355','2014-04-03','12:20:00',1.3),('3355','2014-04-03','12:25:00',1.55),('3355','2014-04-03','12:30:00',2.14),('3355','2014-04-03','12:35:00',2.04),('3355','2014-04-03','12:40:00',2.32),('3355','2014-04-03','12:45:00',1.34),('3355','2014-04-03','12:50:00',1.47),('3355','2014-04-03','12:55:00',1.48),('3355','2014-04-03','13:00:00',1.43),('3355','2014-04-03','13:05:00',1.91),('3355','2014-04-03','13:10:00',1.26),('3355','2014-04-03','13:15:00',2.55),('3355','2014-04-03','13:20:00',1.73),('3355','2014-04-03','13:25:00',1.53),('3355','2014-04-03','13:30:00',1.54),('3355','2014-04-03','13:35:00',2.47),('3355','2014-04-03','13:40:00',2.29),('3355','2014-04-03','13:45:00',1.32),('3355','2014-04-03','13:50:00',1.14),('3355','2014-04-03','13:55:00',1.42),('3355','2014-04-03','14:00:00',2.11),('3355','2014-04-03','14:05:00',2.01),('3355','2014-04-03','14:10:00',1.51),('3355','2014-04-03','14:15:00',1.99),('3355','2014-04-03','14:20:00',2.14),('3355','2014-04-03','14:25:00',2.16),('3355','2014-04-03','14:30:00',2.2),('3355','2014-04-03','14:35:00',2.25),('3355','2014-04-03','14:40:00',2.2),('3355','2014-04-03','14:45:00',2.14),('3355','2014-04-03','14:50:00',2.1),('3355','2014-04-03','14:55:00',2.07),('3355','2014-04-03','15:00:00',2.06),('3355','2014-04-03','15:05:00',2.03),('3355','2014-04-03','15:10:00',2.02),('3355','2014-04-03','15:15:00',2.01),('3355','2014-04-03','15:20:00',2),('3355','2014-04-03','15:25:00',2),('3355','2014-04-03','15:30:00',1.97),('3355','2014-04-03','15:35:00',1.94),('3355','2014-04-03','15:40:00',1.91),('3355','2014-04-03','15:45:00',1.9),('3355','2014-04-03','15:50:00',1.89),('3355','2014-04-03','15:55:00',1.88),('3355','2014-04-03','16:00:00',1.86),('3355','2014-04-03','16:05:00',1.82),('3355','2014-04-03','16:10:00',1.82),('3355','2014-04-03','16:15:00',1.75),('3355','2014-04-03','16:20:00',1.73),('3355','2014-04-03','16:25:00',1.68),('3355','2014-04-03','16:30:00',1.64),('3355','2014-04-03','16:35:00',1.6),('3355','2014-04-03','16:40:00',1.56),('3355','2014-04-03','16:45:00',1.46),('3355','2014-04-03','16:50:00',1.12),('3355','2013-06-10','08:20:00',1.01),('3355','2013-06-10','09:35:00',1.76),('3355','2013-06-10','09:40:00',1.13),('3355','2013-06-10','09:45:00',1.72),('3355','2013-06-10','09:50:00',1.19),('3355','2013-06-10','10:00:00',1.2),('3355','2013-06-10','10:05:00',1.44),('3355','2013-06-10','10:10:00',1.66),('3355','2013-06-10','10:15:00',1.8),('3355','2013-06-10','10:20:00',1.51),('3355','2013-06-10','10:25:00',1.59),('3355','2013-06-10','10:55:00',1.25),('3355','2013-06-10','11:00:00',1.5),('3355','2013-06-10','11:05:00',1.02),('3355','2013-06-10','11:10:00',1.17),('3355','2013-06-10','11:15:00',2.13),('3355','2013-06-10','11:20:00',1.57),('3355','2013-06-10','11:25:00',2.3),('3355','2013-06-10','11:30:00',2.34),('3355','2013-06-10','11:35:00',2.53),('3355','2013-06-10','11:40:00',1.7),('3355','2013-06-10','11:45:00',2.16),('3355','2013-06-10','11:50:00',1.18),('3355','2013-06-10','11:55:00',1.23),('3355','2013-06-10','12:00:00',2.56),('3355','2013-06-10','12:05:00',1.36),('3355','2013-06-10','12:10:00',2.37),('3355','2013-06-10','12:15:00',2.43),('3355','2013-06-10','12:20:00',2.42),('3355','2013-06-10','12:25:00',2.39),('3355','2013-06-10','12:30:00',2.28),('3355','2013-06-10','12:35:00',1.89),('3355','2013-06-10','12:40:00',1.77),('3355','2013-06-10','12:45:00',2.03),('3355','2013-06-10','12:50:00',1.74),('3355','2013-06-10','12:55:00',1.09),('3355','2013-06-10','13:00:00',1.21),('3355','2013-06-10','13:05:00',2.57),('3355','2013-06-10','13:10:00',1.65),('3355','2013-06-10','13:15:00',1.63),('3355','2013-06-10','13:20:00',1.82),('3355','2013-06-10','13:25:00',1.44),('3355','2013-06-10','13:30:00',1.47),('3355','2013-06-10','13:35:00',2.31),('3355','2013-06-10','13:40:00',1.94),('3355','2013-06-10','13:45:00',1.49),('3355','2013-06-10','13:50:00',1.39),('3355','2013-06-10','13:55:00',1.8),('3355','2013-06-10','14:00:00',2.64),('3355','2013-06-10','14:05:00',2.46),('3355','2013-06-10','14:10:00',2.47),('3355','2013-06-10','14:15:00',2.34),('3355','2013-06-10','14:20:00',2.37),('3355','2013-06-10','14:25:00',2.41),('3355','2013-06-10','14:30:00',2.37),('3355','2013-06-10','14:35:00',2.37),('3355','2013-06-10','14:40:00',2.08),('3355','2013-06-10','14:45:00',2.39),('3355','2013-06-10','14:50:00',2.33),('3355','2013-06-10','14:55:00',2.3),('3355','2013-06-10','15:00:00',2.29),('3355','2013-06-10','15:05:00',2.27),('3355','2013-06-10','15:10:00',2.24),('3355','2013-06-10','15:15:00',2.22),('3355','2013-06-10','15:20:00',2.21),('3355','2013-06-10','15:25:00',2.18),('3355','2013-06-10','15:30:00',2.17),('3355','2013-06-10','15:35:00',2.16),('3355','2013-06-10','15:40:00',2.14),('3355','2013-06-10','15:45:00',2.12),('3355','2013-06-10','15:50:00',2.09),('3355','2013-06-10','15:55:00',2.06),('3355','2013-06-10','16:00:00',2.03),('3355','2013-06-10','16:05:00',2),('3355','2013-06-10','16:10:00',1.97),('3355','2013-06-10','16:15:00',1.94),('3355','2013-06-10','16:20:00',1.9),('3355','2013-06-10','16:25:00',1.87),('3355','2013-06-10','16:30:00',1.84),('3355','2013-06-10','16:35:00',1.81),('3355','2013-06-10','16:40:00',1.77),('3355','2013-06-10','16:45:00',1.73),('3355','2013-06-10','16:50:00',1.7),('3355','2013-06-10','16:55:00',1.66),('3355','2013-06-10','17:00:00',1.62),('3355','2013-06-10','17:05:00',1.59),('3355','2013-06-10','17:10:00',1.55),('3355','2013-06-10','17:15:00',1.5),('3355','2013-06-10','17:20:00',1.46),('3355','2013-06-10','17:25:00',1.42),('3355','2013-06-10','17:30:00',1.37),('3355','2013-06-10','17:35:00',1.33),('3355','2013-06-10','17:40:00',1.28),('3355','2013-06-10','17:45:00',1.23),('3355','2013-06-10','17:50:00',1.18),('3355','2013-06-10','17:55:00',1.13),('3355','2013-06-10','18:00:00',1.09),('3355','2013-06-10','18:05:00',1.03),('3355','2013-06-09','08:45:00',1.02),('3355','2013-06-09','08:50:00',1.07),('3355','2013-06-09','08:55:00',1.13),('3355','2013-06-09','09:00:00',1.17),('3355','2013-06-09','09:05:00',1.2),('3355','2013-06-09','09:10:00',1.27),('3355','2013-06-09','09:15:00',1.31),('3355','2013-06-09','09:20:00',1.33),('3355','2013-06-09','09:25:00',1.37),('3355','2013-06-09','09:30:00',1.4),('3355','2013-06-09','09:35:00',1.45),('3355','2013-06-09','09:40:00',1.49),('3355','2013-06-09','09:45:00',1.53),('3355','2013-06-09','09:50:00',1.56),('3355','2013-06-09','09:55:00',1.6),('3355','2013-06-09','10:00:00',1.63),('3355','2013-06-09','10:05:00',1.66),('3355','2013-06-09','10:10:00',1.69),('3355','2013-06-09','10:15:00',1.72),('3355','2013-06-09','10:20:00',1.73),('3355','2013-06-09','10:25:00',1.76),('3355','2013-06-09','10:30:00',1.81),('3355','2013-06-09','10:35:00',1.84),('3355','2013-06-09','10:40:00',1.86),('3355','2013-06-09','10:45:00',1.88),('3355','2013-06-09','10:50:00',1.91),('3355','2013-06-09','10:55:00',1.94),('3355','2013-06-09','11:00:00',1.96),('3355','2013-06-09','11:05:00',1.97),('3355','2013-06-09','11:10:00',1.96),('3355','2013-06-09','11:15:00',1.99),('3355','2013-06-09','11:20:00',2.04),('3355','2013-06-09','11:25:00',2.03),('3355','2013-06-09','11:30:00',2.05),('3355','2013-06-09','11:35:00',2.06),('3355','2013-06-09','11:40:00',2.06),('3355','2013-06-09','11:45:00',2.11),('3355','2013-06-09','11:50:00',2.14),('3355','2013-06-09','11:55:00',2.13),('3355','2013-06-09','12:00:00',2.13),('3355','2013-06-09','12:05:00',2.16),('3355','2013-06-09','12:10:00',2.01),('3355','2013-06-09','12:15:00',2.04),('3355','2013-06-09','12:20:00',2.19),('3355','2013-06-09','12:25:00',2.18),('3355','2013-06-09','12:30:00',2.19),('3355','2013-06-09','12:35:00',2.19),('3355','2013-06-09','12:40:00',2.23),('3355','2013-06-09','12:45:00',2.22),('3355','2013-06-09','12:50:00',2.27),('3355','2013-06-09','12:55:00',2.15),('3355','2013-06-09','13:00:00',2.03),('3355','2013-06-09','13:05:00',2.35),('3355','2013-06-09','13:10:00',1.73),('3355','2013-06-09','13:15:00',1.11),('3355','2013-06-09','13:20:00',2.34),('3355','2013-06-09','13:25:00',2.25),('3355','2013-06-09','13:30:00',2.33),('3355','2013-06-09','13:35:00',2.34),('3355','2013-06-09','13:40:00',2.4),('3355','2013-06-09','13:45:00',2.43),('3355','2013-06-09','13:50:00',2.52),('3355','2013-06-09','13:55:00',2.62),('3355','2013-06-09','14:00:00',1.6),('3355','2013-06-09','14:05:00',2.45),('3355','2013-06-09','14:10:00',2.45),('3355','2013-06-09','14:15:00',1.49),('3355','2013-06-09','14:20:00',1.12),('3355','2013-06-09','14:35:00',2.01),('3355','2013-06-09','14:40:00',1.79),('3355','2013-06-09','14:45:00',2.18),('3355','2013-06-09','14:50:00',2.14),('3355','2013-06-09','14:55:00',2.21),('3355','2013-06-09','15:00:00',2.2),('3355','2013-06-09','15:05:00',2.1),('3355','2013-06-09','15:10:00',2.13),('3355','2013-06-09','15:15:00',2.04),('3355','2013-06-09','15:20:00',2.05),('3355','2013-06-09','15:25:00',2.08),('3355','2013-06-09','15:30:00',1.92),('3355','2013-06-09','15:35:00',2),('3355','2013-06-09','15:40:00',1.64),('3355','2013-06-09','15:45:00',1.69),('3355','2013-06-09','15:50:00',1.82),('3355','2013-06-09','15:55:00',2.03),('3355','2013-06-09','16:00:00',1.35),('3355','2013-06-09','16:05:00',1.77),('3355','2013-06-09','16:10:00',1.72),('3355','2013-06-09','16:15:00',1.03),('3355','2013-06-09','16:25:00',1.17),('3355','2013-06-08','08:40:00',1.01),('3355','2013-06-08','08:45:00',1.05),('3355','2013-06-08','08:50:00',1.1),('3355','2013-06-08','08:55:00',1.14),('3355','2013-06-08','09:00:00',1.19),('3355','2013-06-08','09:05:00',1.23),('3355','2013-06-08','09:10:00',1.25),('3355','2013-06-08','09:15:00',1.29),('3355','2013-06-08','09:20:00',1.35),('3355','2013-06-08','09:25:00',1.4),('3355','2013-06-08','09:30:00',1.44),('3355','2013-06-08','09:35:00',1.46),('3355','2013-06-08','09:40:00',1.48),('3355','2013-06-08','09:45:00',1.52),('3355','2013-06-08','09:50:00',1.52),('3355','2013-06-08','09:55:00',1.58),('3355','2013-06-08','10:00:00',1.65),('3355','2013-06-08','10:05:00',1.68),('3355','2013-06-08','10:10:00',1.29),('3355','2013-06-08','10:15:00',1.6),('3355','2013-06-08','10:20:00',1.74),('3355','2013-06-08','10:25:00',1.81),('3355','2013-06-08','10:30:00',1.87),('3355','2013-06-08','10:35:00',1.87),('3355','2013-06-08','10:40:00',1.91),('3355','2013-06-08','10:45:00',1.95),('3355','2013-06-08','10:50:00',1.96),('3355','2013-06-08','11:00:00',1.18),('3355','2013-06-08','11:10:00',2.21),('3355','2013-06-08','11:15:00',1.93),('3355','2013-06-08','11:20:00',2.28),('3355','2013-06-08','11:25:00',2.31),('3355','2013-06-08','11:30:00',2.29),('3355','2013-06-08','11:35:00',2.08),('3355','2013-06-08','11:40:00',2.3),('3355','2013-06-08','11:45:00',2.21),('3355','2013-06-08','11:50:00',2.28),('3355','2013-06-08','11:55:00',2.33),('3355','2013-06-08','12:00:00',1.4),('3355','2013-06-08','12:05:00',1.13),('3355','2013-06-08','12:15:00',1.43),('3355','2013-06-08','12:20:00',2.37),('3355','2013-06-08','12:35:00',1.62),('3355','2013-06-08','12:40:00',2.42),('3355','2013-06-08','12:45:00',2.41),('3355','2013-06-08','12:55:00',1.92),('3355','2013-06-08','13:00:00',2.46),('3355','2013-06-08','13:05:00',2.46),('3355','2013-06-08','13:10:00',2.28),('3355','2013-06-08','13:15:00',2.43),('3355','2013-06-08','13:20:00',1.78),('3355','2013-06-08','13:25:00',2.46),('3355','2013-06-08','13:30:00',2.47),('3355','2013-06-08','13:35:00',2.43),('3355','2013-06-08','13:40:00',2.41),('3355','2013-06-08','13:45:00',2.39),('3355','2013-06-08','13:50:00',2.38),('3355','2013-06-08','13:55:00',2.38),('3355','2013-06-08','14:00:00',2.35),('3355','2013-06-08','14:05:00',2.34),('3355','2013-06-08','14:10:00',2.34),('3355','2013-06-08','14:15:00',2.34),('3355','2013-06-08','14:20:00',2.33),('3355','2013-06-08','14:25:00',2.32),('3355','2013-06-08','14:30:00',2.31),('3355','2013-06-08','14:35:00',2.28),('3355','2013-06-08','14:40:00',2.28),('3355','2013-06-08','14:45:00',2.28),('3355','2013-06-08','14:50:00',2.29),('3355','2013-06-08','14:55:00',2.27),('3355','2013-06-08','15:00:00',2.26),('3355','2013-06-08','15:05:00',2.17),('3355','2013-06-08','15:10:00',2.05),('3355','2013-06-08','15:15:00',2.09),('3355','2013-06-08','15:20:00',2.19),('3355','2013-06-08','15:25:00',2.06),('3355','2013-06-08','15:30:00',2.08),('3355','2013-06-08','15:35:00',2.19),('3355','2013-06-08','15:40:00',2.11),('3355','2013-06-08','15:45:00',2.16),('3355','2013-06-08','15:50:00',2.11),('3355','2013-06-08','15:55:00',2),('3355','2013-06-08','16:00:00',2.01),('3355','2013-06-08','16:05:00',1.99),('3355','2013-06-08','16:10:00',1.95),('3355','2013-06-08','16:15:00',1.97),('3355','2013-06-08','16:20:00',1.93),('3355','2013-06-08','16:25:00',1.85),('3355','2013-06-08','16:30:00',1.76),('3355','2013-06-08','16:35:00',1.72),('3355','2013-06-08','16:40:00',1.7),('3355','2013-06-08','16:45:00',1.66),('3355','2013-06-08','16:50:00',1.43),('3355','2013-06-08','16:55:00',1.42),('3355','2013-06-08','17:00:00',1.55),('3355','2013-06-08','17:05:00',1.29),('3355','2013-06-08','17:10:00',1.59),('3355','2013-06-08','17:15:00',1.59),('3355','2013-06-08','17:20:00',1.49),('3355','2013-06-08','17:25:00',1.39),('3355','2013-06-08','17:40:00',1.05),('3355','2013-06-08','17:45:00',1.22),('3355','2013-06-08','17:50:00',1.08),('3355','2013-06-08','17:55:00',1.16),('3355','2013-06-07','08:35:00',1.01),('3355','2013-06-07','08:40:00',1.06),('3355','2013-06-07','08:45:00',1.11),('3355','2013-06-07','08:50:00',1.16),('3355','2013-06-07','08:55:00',1.21),('3355','2013-06-07','09:00:00',1.25),('3355','2013-06-07','09:05:00',1.29),('3355','2013-06-07','09:10:00',1.34),('3355','2013-06-07','09:15:00',1.38),('3355','2013-06-07','09:20:00',1.42),('3355','2013-06-07','09:25:00',1.47),('3355','2013-06-07','09:30:00',1.51),('3355','2013-06-07','09:35:00',1.55),('3355','2013-06-07','09:40:00',1.59),('3355','2013-06-07','09:45:00',1.64),('3355','2013-06-07','09:50:00',1.67),('3355','2013-06-07','09:55:00',1.71),('3355','2013-06-07','10:00:00',1.74),('3355','2013-06-07','10:05:00',1.77),('3355','2013-06-07','10:10:00',1.8),('3355','2013-06-07','10:15:00',1.83),('3355','2013-06-07','10:20:00',1.86),('3355','2013-06-07','10:25:00',1.9),('3355','2013-06-07','10:30:00',1.93),('3355','2013-06-07','10:35:00',1.95),('3355','2013-06-07','10:40:00',1.98),('3355','2013-06-07','10:45:00',2),('3355','2013-06-07','10:50:00',2.02),('3355','2013-06-07','10:55:00',2.04),('3355','2013-06-07','11:00:00',2.07),('3355','2013-06-07','11:05:00',2.1),('3355','2013-06-07','11:10:00',2.12),('3355','2013-06-07','11:15:00',2.13),('3355','2013-06-07','11:20:00',2.14),('3355','2013-06-07','11:25:00',2.16),('3355','2013-06-07','11:30:00',2.2),('3355','2013-06-07','11:35:00',2.21),('3355','2013-06-07','11:40:00',2.22),('3355','2013-06-07','11:45:00',2.23),('3355','2013-06-07','11:50:00',2.25),('3355','2013-06-07','11:55:00',2.26),('3355','2013-06-07','12:00:00',2.26),('3355','2013-06-07','12:05:00',2.28),('3355','2013-06-07','12:10:00',2.29),('3355','2013-06-07','12:15:00',2.31),('3355','2013-06-07','12:20:00',2.31),('3355','2013-06-07','12:25:00',2.3),('3355','2013-06-07','12:30:00',2.31),('3355','2013-06-07','12:35:00',2.3),('3355','2013-06-07','12:40:00',2.32),('3355','2013-06-07','12:45:00',2.34),('3355','2013-06-07','12:50:00',2.34),('3355','2013-06-07','12:55:00',2.34),('3355','2013-06-07','13:00:00',2.36),('3355','2013-06-07','13:05:00',2.34),('3355','2013-06-07','13:10:00',2.34),('3355','2013-06-07','13:15:00',2.34),('3355','2013-06-07','13:20:00',2.34),('3355','2013-06-07','13:25:00',2.34),('3355','2013-06-07','13:30:00',2.34),('3355','2013-06-07','13:35:00',2.33),('3355','2013-06-07','13:40:00',2.32),('3355','2013-06-07','13:45:00',2.3),('3355','2013-06-07','13:50:00',2.3),('3355','2013-06-07','13:55:00',2.3),('3355','2013-06-07','14:00:00',2.29),('3355','2013-06-07','14:05:00',2.27),('3355','2013-06-07','14:10:00',2.26),('3355','2013-06-07','14:15:00',2.26),('3355','2013-06-07','14:20:00',2.23),('3355','2013-06-07','14:25:00',2.21),('3355','2013-06-07','14:30:00',2.2),('3355','2013-06-07','14:35:00',2.19),('3355','2013-06-07','14:40:00',2.19),('3355','2013-06-07','14:45:00',2.19),('3355','2013-06-07','14:50:00',2.18),('3355','2013-06-07','14:55:00',2.17),('3355','2013-06-07','15:00:00',2.16),('3355','2013-06-07','15:05:00',2.17),('3355','2013-06-07','15:10:00',2.17),('3355','2013-06-07','15:15:00',2.13),('3355','2013-06-07','15:20:00',2.1),('3355','2013-06-07','15:25:00',2.12),('3355','2013-06-07','15:30:00',2.11),('3355','2013-06-07','15:35:00',2.08),('3355','2013-06-07','15:40:00',2.04),('3355','2013-06-07','15:45:00',2.02),('3355','2013-06-07','15:50:00',1.99),('3355','2013-06-07','15:55:00',1.96),('3355','2013-06-07','16:00:00',1.94),('3355','2013-06-07','16:05:00',1.9),('3355','2013-06-07','16:10:00',1.83),('3355','2013-06-07','16:15:00',1.75),('3355','2013-06-07','16:20:00',1.74),('3355','2013-06-07','16:25:00',1.75),('3355','2013-06-07','16:30:00',1.75),('3355','2013-06-07','16:35:00',1.72),('3355','2013-06-07','16:40:00',1.69),('3355','2013-06-07','16:45:00',1.66),('3355','2013-06-07','16:50:00',1.62),('3355','2013-06-07','16:55:00',1.59),('3355','2013-06-07','17:00:00',1.54),('3355','2013-06-07','17:05:00',1.5),('3355','2013-06-07','17:10:00',1.44),('3355','2013-06-07','17:15:00',1.39),('3355','2013-06-07','17:20:00',1.32),('3355','2013-06-07','17:25:00',1.3),('3355','2013-06-07','17:30:00',1.26),('3355','2013-06-07','17:35:00',1.23),('3355','2013-06-07','17:40:00',1.19),('3355','2013-06-07','17:45:00',1.19),('3355','2013-06-07','17:50:00',1.14),('3355','2013-06-07','17:55:00',1.07),('3355','2013-06-07','18:00:00',1.01),('3355','2013-06-06','08:35:00',1),('3355','2013-06-06','08:40:00',1.04),('3355','2013-06-06','08:45:00',1.08),('3355','2013-06-06','08:50:00',1.13),('3355','2013-06-06','08:55:00',1.19),('3355','2013-06-06','09:00:00',1.23),('3355','2013-06-06','09:05:00',1.26),('3355','2013-06-06','09:10:00',1.31),('3355','2013-06-06','09:15:00',1.36),('3355','2013-06-06','09:20:00',1.41),('3355','2013-06-06','09:25:00',1.43),('3355','2013-06-06','09:30:00',1.46),('3355','2013-06-06','09:35:00',1.51),('3355','2013-06-06','09:40:00',1.19),('3355','2013-06-06','09:45:00',1.56),('3355','2013-06-06','09:50:00',1.63),('3355','2013-06-06','09:55:00',1.69),('3355','2013-06-06','10:00:00',1.69),('3355','2013-06-06','10:05:00',1.73),('3355','2013-06-06','10:10:00',1.77),('3355','2013-06-06','10:15:00',1.8),('3355','2013-06-06','10:20:00',1.83),('3355','2013-06-06','10:25:00',1.87),('3355','2013-06-06','10:30:00',1.88),('3355','2013-06-06','10:35:00',1.87),('3355','2013-06-06','10:40:00',1.93),('3355','2013-06-06','10:45:00',1.97),('3355','2013-06-06','10:50:00',2),('3355','2013-06-06','10:55:00',2.03),('3355','2013-06-06','11:00:00',2.06),('3355','2013-06-06','11:05:00',2.08),('3355','2013-06-06','11:10:00',2.09),('3355','2013-06-06','11:15:00',2.12),('3355','2013-06-06','11:20:00',2.1),('3355','2013-06-06','11:25:00',2.13),('3355','2013-06-06','11:30:00',2.16),('3355','2013-06-06','11:35:00',2.16),('3355','2013-06-06','11:40:00',2.19),('3355','2013-06-06','11:45:00',2.17),('3355','2013-06-06','11:50:00',2.16),('3355','2013-06-06','11:55:00',2.13),('3355','2013-06-06','12:00:00',2.19),('3355','2013-06-06','12:05:00',1.9),('3355','2013-06-06','12:10:00',2.21),('3355','2013-06-06','12:15:00',2.25),('3355','2013-06-06','12:20:00',2.23),('3355','2013-06-06','12:25:00',2.27),('3355','2013-06-06','12:30:00',2.27),('3355','2013-06-06','12:35:00',2.26),('3355','2013-06-06','12:40:00',2.25),('3355','2013-06-06','12:45:00',2.23),('3355','2013-06-06','12:50:00',2.22),('3355','2013-06-06','12:55:00',2.32),('3355','2013-06-06','13:00:00',2.35),('3355','2013-06-06','13:05:00',2.31),('3355','2013-06-06','13:10:00',2.36),('3355','2013-06-06','13:15:00',2.38),('3355','2013-06-06','13:20:00',2.41),('3355','2013-06-06','13:25:00',2.39),('3355','2013-06-06','13:30:00',2.38),('3355','2013-06-06','13:35:00',2.35),('3355','2013-06-06','13:40:00',2.35),('3355','2013-06-06','13:45:00',2.21),('3355','2013-06-06','13:50:00',2.37),('3355','2013-06-06','13:55:00',2.35),('3355','2013-06-06','14:00:00',2.34),('3355','2013-06-06','14:05:00',2.32),('3355','2013-06-06','14:10:00',2.22),('3355','2013-06-06','14:15:00',2.35),('3355','2013-06-06','14:20:00',1.9),('3355','2013-06-06','14:25:00',1.02),('3355','2013-06-06','14:30:00',2.34),('3355','2013-06-06','14:35:00',1.04),('3355','2013-06-06','14:40:00',1.5),('3355','2013-06-06','14:45:00',1.74),('3355','2013-06-06','14:50:00',1.67),('3355','2013-06-06','14:55:00',2.31),('3355','2013-06-06','15:00:00',2.23),('3355','2013-06-06','15:05:00',2.26),('3355','2013-06-06','15:10:00',1.98),('3355','2013-06-06','15:15:00',2.22),('3355','2013-06-06','15:20:00',2.22),('3355','2013-06-06','15:25:00',2.14),('3355','2013-06-06','15:30:00',1.91),('3355','2013-06-06','15:35:00',2.09),('3355','2013-06-06','15:40:00',2.07),('3355','2013-06-06','15:45:00',2.07),('3355','2013-06-06','15:50:00',1.96),('3355','2013-06-06','15:55:00',1.92),('3355','2013-06-06','16:00:00',1.75),('3355','2013-06-06','16:05:00',1.52),('3355','2013-06-06','16:10:00',1.84),('3355','2013-06-06','16:15:00',1.8),('3355','2013-06-06','16:20:00',1.74),('3355','2013-06-06','16:25:00',1.75),('3355','2013-06-06','16:30:00',1.76),('3355','2013-06-06','16:35:00',1.74),('3355','2013-06-06','16:40:00',1.69),('3355','2013-06-06','16:45:00',1.59),('3355','2013-06-06','16:50:00',1.55),('3355','2013-06-06','16:55:00',1.54),('3355','2013-06-06','17:00:00',1.48),('3355','2013-06-06','17:05:00',1.44),('3355','2013-06-06','17:10:00',1.4),('3355','2013-06-06','17:15:00',1.38),('3355','2013-06-06','17:20:00',1.33),('3355','2013-06-06','17:25:00',1.27),('3355','2013-06-06','17:30:00',1.24),('3355','2013-06-06','17:35:00',1.2),('3355','2013-06-06','17:40:00',1.15),('3355','2013-06-06','17:45:00',1.1),('3355','2013-06-06','17:50:00',1.05),('3355','2013-06-05','08:40:00',1.03),('3355','2013-06-05','08:45:00',1.1),('3355','2013-06-05','08:50:00',1.13),('3355','2013-06-05','08:55:00',1.18),('3355','2013-06-05','09:00:00',1.23),('3355','2013-06-05','09:05:00',1.3),('3355','2013-06-05','09:10:00',1.38),('3355','2013-06-05','09:15:00',1.42),('3355','2013-06-05','09:20:00',1.47),('3355','2013-06-05','09:25:00',1.57),('3355','2013-06-05','09:30:00',1.59),('3355','2013-06-05','09:35:00',1.77),('3355','2013-06-05','09:40:00',1.88),('3355','2013-06-05','09:45:00',1.89),('3355','2013-06-05','09:50:00',1.02),('3355','2013-06-05','09:55:00',1),('3355','2013-06-05','10:00:00',1.08),('3355','2013-06-05','10:05:00',2.07),('3355','2013-06-05','10:10:00',2.07),('3355','2013-06-05','10:15:00',2.07),('3355','2013-06-05','10:45:00',2.03),('3355','2013-06-05','10:55:00',1.13),('3355','2013-06-05','11:00:00',2.19),('3355','2013-06-05','11:05:00',1.29),('3355','2013-06-05','11:40:00',1.28),('3355','2013-06-05','11:45:00',1.17),('3355','2013-06-05','11:50:00',1.32),('3355','2013-06-05','11:55:00',2.34),('3355','2013-06-05','12:00:00',2.52),('3355','2013-06-05','12:05:00',1.82),('3355','2013-06-05','12:10:00',2.57),('3355','2013-06-05','12:15:00',2.61),('3355','2013-06-05','12:20:00',2.69),('3355','2013-06-05','12:25:00',2.63),('3355','2013-06-05','12:30:00',2.21),('3355','2013-06-05','12:35:00',1.6),('3355','2013-06-05','12:40:00',2.04),('3355','2013-06-05','12:45:00',2.73),('3355','2013-06-05','12:50:00',1.91),('3355','2013-06-05','13:00:00',1.72),('3355','2013-06-05','13:05:00',2.81),('3355','2013-06-05','13:10:00',1.68),('3355','2013-06-05','13:15:00',1.06),('3355','2013-06-05','13:20:00',1.38),('3355','2013-06-05','13:25:00',2.15),('3355','2013-06-05','13:30:00',2.3),('3355','2013-06-05','13:35:00',2.81),('3355','2013-06-05','13:40:00',2.66),('3355','2013-06-05','13:45:00',2.6),('3355','2013-06-05','13:50:00',2.51),('3355','2013-06-05','13:55:00',2.5),('3355','2013-06-05','14:00:00',2.46),('3355','2013-06-05','14:05:00',2.38),('3355','2013-06-05','14:10:00',2.37),('3355','2013-06-05','14:15:00',2.4),('3355','2013-06-05','14:20:00',2.4),('3355','2013-06-05','14:25:00',2.34),('3355','2013-06-05','14:30:00',2.37),('3355','2013-06-05','14:35:00',2.36),('3355','2013-06-05','14:40:00',2.35),('3355','2013-06-05','14:45:00',2.36),('3355','2013-06-05','14:50:00',2.35),('3355','2013-06-05','14:55:00',2.34),('3355','2013-06-05','15:00:00',2.28),('3355','2013-06-05','15:05:00',2.23),('3355','2013-06-05','15:10:00',2.22),('3355','2013-06-05','15:15:00',2.21),('3355','2013-06-05','15:20:00',2.19),('3355','2013-06-05','15:25:00',2.18),('3355','2013-06-05','15:30:00',2.19),('3355','2013-06-05','15:35:00',2.22),('3355','2013-06-05','15:40:00',2.2),('3355','2013-06-05','15:45:00',2.07),('3355','2013-06-05','15:50:00',2.09),('3355','2013-06-05','15:55:00',2.06),('3355','2013-06-05','16:00:00',2.05),('3355','2013-06-05','16:05:00',2.02),('3355','2013-06-05','16:10:00',1.96),('3355','2013-06-05','16:15:00',1.94),('3355','2013-06-05','16:20:00',1.9),('3355','2013-06-05','16:25:00',1.85),('3355','2013-06-05','16:30:00',1.84),('3355','2013-06-05','16:35:00',1.78),('3355','2013-06-05','16:40:00',1.75),('3355','2013-06-05','16:45:00',1.71),('3355','2013-06-05','16:50:00',1.68),('3355','2013-06-05','16:55:00',1.64),('3355','2013-06-05','17:00:00',1.6),('3355','2013-06-05','17:05:00',1.22),('3355','2013-06-05','17:10:00',1.53),('3355','2013-06-05','17:30:00',1.31),('3355','2013-06-05','17:35:00',1.32),('3355','2013-06-05','17:45:00',1.16),('3355','2013-06-05','17:50:00',1.11),('3355','2013-06-05','17:55:00',1.04),('3355','2013-06-04','08:10:00',1),('3355','2013-06-04','08:15:00',1.04),('3355','2013-06-04','08:20:00',1.07),('3355','2013-06-04','08:25:00',1.07),('3355','2013-06-04','08:35:00',1.28),('3355','2013-06-04','08:40:00',1.05),('3355','2013-06-04','08:45:00',1.05),('3355','2013-06-04','09:10:00',1.14),('3355','2013-06-04','09:15:00',1.3),('3355','2013-06-04','09:20:00',1.66),('3355','2013-06-04','09:25:00',1.72),('3355','2013-06-04','09:30:00',1.54),('3355','2013-06-04','09:35:00',1.36),('3355','2013-06-04','10:00:00',1.02),('3355','2013-06-04','10:05:00',1.25),('3355','2013-06-04','10:10:00',1.47),('3355','2013-06-04','10:15:00',1.51),('3355','2013-06-04','10:20:00',1.01),('3355','2013-06-04','10:45:00',1.11),('3355','2013-06-04','10:50:00',1.51),('3355','2013-06-04','10:55:00',1.81),('3355','2013-06-04','11:00:00',1.21),('3355','2013-06-04','11:05:00',1.41),('3355','2013-06-04','11:10:00',1.67),('3355','2013-06-04','11:15:00',1.77),('3355','2013-06-04','11:20:00',1.15),('3355','2013-06-04','11:25:00',1.48),('3355','2013-06-04','11:30:00',1.88),('3355','2013-06-04','11:35:00',1.65),('3355','2013-06-04','11:40:00',1.59),('3355','2013-06-04','11:45:00',2.12),('3355','2013-06-04','11:50:00',2.5),('3355','2013-06-04','11:55:00',2.4),('3355','2013-06-04','12:00:00',2.1),('3355','2013-06-04','12:05:00',1.79),('3355','2013-06-04','12:10:00',1.39),('3355','2013-06-04','12:15:00',1.51),('3355','2013-06-04','12:20:00',1.23),('3355','2013-06-04','12:25:00',1.15),('3355','2013-06-04','12:30:00',1.23),('3355','2013-06-04','12:35:00',2.17),('3355','2013-06-04','12:40:00',1.36),('3355','2013-06-04','12:45:00',1.64),('3355','2013-06-04','12:50:00',1.73),('3355','2013-06-04','12:55:00',1.11),('3355','2013-06-04','13:00:00',1.27),('3355','2013-06-04','13:05:00',1.23),('3355','2013-06-04','13:35:00',1.79),('3355','2013-06-04','13:40:00',1.62),('3355','2013-06-04','13:45:00',1.91),('3355','2013-06-04','13:50:00',2.83),('3355','2013-06-04','13:55:00',1.97),('3355','2013-06-04','14:05:00',1.63),('3355','2013-06-04','14:10:00',2.8),('3355','2013-06-04','14:15:00',2.55),('3355','2013-06-04','14:20:00',1.94),('3355','2013-06-04','14:25:00',1.54),('3355','2013-06-04','14:40:00',1.5),('3355','2013-06-04','14:55:00',1.63),('3355','2013-06-04','15:00:00',2.89),('3355','2013-06-04','15:05:00',2.79),('3355','2013-06-04','15:10:00',1.12),('3355','2013-06-03','08:35:00',1.01),('3355','2013-06-03','08:40:00',1.06),('3355','2013-06-03','08:45:00',1.09),('3355','2013-06-03','08:50:00',1.15),('3355','2013-06-03','08:55:00',1.19),('3355','2013-06-03','09:00:00',1.23),('3355','2013-06-03','09:05:00',1.21),('3355','2013-06-03','09:10:00',1.29),('3355','2013-06-03','09:15:00',1.51),('3355','2013-06-03','09:20:00',1.25),('3355','2013-06-03','09:25:00',1.33),('3355','2013-06-03','09:30:00',1.15),('3355','2013-06-03','09:40:00',1.21),('3355','2013-06-03','09:45:00',1.42),('3355','2013-06-03','09:50:00',1.65),('3355','2013-06-03','09:55:00',1.7),('3355','2013-06-03','10:00:00',1.83),('3355','2013-06-03','10:05:00',2.12),('3355','2013-06-03','10:10:00',1.55),('3355','2013-06-03','10:15:00',1.15),('3355','2013-06-03','10:20:00',1.6),('3355','2013-06-03','10:25:00',1.17),('3355','2013-06-03','10:50:00',1.01),('3355','2013-06-03','10:55:00',1.11),('3355','2013-06-03','11:00:00',1.03),('3355','2013-06-03','11:05:00',1.22),('3355','2013-06-03','11:45:00',1.01),('3355','2013-06-03','11:55:00',1.15),('3355','2013-06-03','12:00:00',1.44),('3355','2013-06-03','12:05:00',1.96),('3355','2013-06-03','12:10:00',1.01),('3355','2013-06-03','12:30:00',1.08),('3355','2013-06-03','12:35:00',2.25),('3355','2013-06-03','12:40:00',1.83),('3355','2013-06-03','12:45:00',1.26),('3355','2013-06-03','12:50:00',1.24),('3355','2013-06-03','12:55:00',1.45),('3355','2013-06-03','13:00:00',1.07),('3355','2013-06-03','13:05:00',1),('3355','2013-06-03','13:10:00',1.09),('3355','2013-06-03','13:15:00',2.09),('3355','2013-06-03','13:20:00',2.79),('3355','2013-06-03','13:25:00',1.64),('3355','2013-06-03','13:30:00',2.29),('3355','2013-06-03','13:35:00',2.61),('3355','2013-06-03','13:40:00',1.95),('3355','2013-06-03','13:45:00',1.13),('3355','2013-06-03','13:50:00',2.15),('3355','2013-06-03','13:55:00',1.69),('3355','2013-06-03','14:00:00',2.46),('3355','2013-06-03','14:05:00',1.67),('3355','2013-06-03','14:10:00',1.17),('3355','2013-06-03','14:15:00',1.64),('3355','2013-06-03','14:20:00',1.05),('3355','2013-06-03','14:25:00',2.05),('3355','2013-06-03','14:30:00',2.63),('3355','2013-06-03','14:35:00',2.57),('3355','2013-06-03','14:40:00',1.65),('3355','2013-06-03','14:45:00',1.87),('3355','2013-06-03','14:50:00',1.56),('3355','2013-06-03','14:55:00',2.28),('3355','2013-06-03','15:00:00',2.07),('3355','2013-06-03','15:05:00',1.7),('3355','2013-06-03','15:10:00',2.31),('3355','2013-06-03','15:15:00',1.96),('3355','2013-06-03','15:20:00',1.8),('3355','2013-06-03','15:25:00',2.25),('3355','2013-06-03','15:30:00',2.19),('3355','2013-06-03','15:35:00',2.15),('3355','2013-06-03','15:40:00',2.12),('3355','2013-06-03','15:45:00',2.09),('3355','2013-06-03','15:50:00',2.08),('3355','2013-06-03','15:55:00',2.04),('3355','2013-06-03','16:00:00',2),('3355','2013-06-03','16:05:00',2),('3355','2013-06-03','16:10:00',1.98),('3355','2013-06-03','16:15:00',1.93),('3355','2013-06-03','16:20:00',1.84),('3355','2013-06-03','16:25:00',1.89),('3355','2013-06-03','16:30:00',1.91),('3355','2013-06-03','16:35:00',1.79),('3355','2013-06-03','16:40:00',1.8),('3355','2013-06-03','16:45:00',1.56),('3355','2013-06-03','16:50:00',1.2),('3355','2013-06-03','16:55:00',1.02),('3355','2013-06-03','17:00:00',1.19),('3355','2013-06-03','17:05:00',1.5),('3355','2013-06-03','17:10:00',1.44),('3355','2013-06-03','17:15:00',1.45),('3355','2013-06-03','17:20:00',1.24),('3355','2013-06-02','09:25:00',1.72),('3355','2013-06-02','09:30:00',1.64),('3355','2013-06-02','09:35:00',1.63),('3355','2013-06-02','09:40:00',1.63),('3355','2013-06-02','09:45:00',1.65),('3355','2013-06-02','09:50:00',1.69),('3355','2013-06-02','09:55:00',1.72),('3355','2013-06-02','10:00:00',1.77),('3355','2013-06-02','10:05:00',1.8),('3355','2013-06-02','10:10:00',1.84),('3355','2013-06-02','10:15:00',1.87),('3355','2013-06-02','10:20:00',1.9),('3355','2013-06-02','10:25:00',1.93),('3355','2013-06-02','10:30:00',2),('3355','2013-06-02','10:35:00',2.14),('3355','2013-06-02','10:40:00',2.17),('3355','2013-06-02','10:45:00',2.03),('3355','2013-06-02','10:50:00',1.83),('3355','2013-06-02','10:55:00',1.42),('3355','2013-06-02','11:00:00',2.31),('3355','2013-06-02','11:05:00',2.3),('3355','2013-06-02','11:10:00',2.44),('3355','2013-06-02','11:15:00',1.26),('3355','2013-06-02','11:20:00',2.42),('3355','2013-06-02','11:25:00',1.52),('3355','2013-06-02','11:30:00',1.66),('3355','2013-06-02','11:35:00',1.2),('3355','2013-06-02','11:55:00',1.67),('3355','2013-06-02','12:00:00',2.47),('3355','2013-06-02','12:05:00',1.32),('3355','2013-06-02','12:10:00',1.12),('3355','2013-06-02','12:15:00',2.46),('3355','2013-06-02','12:20:00',1.38),('3355','2013-06-02','12:30:00',1.06),('3355','2013-06-02','12:35:00',1.51),('3355','2013-06-02','12:40:00',2.46),('3355','2013-06-02','12:45:00',1.98),('3355','2013-06-02','12:50:00',1.27),('3355','2013-06-02','12:55:00',1.19),('3355','2013-06-02','13:00:00',1.56),('3355','2013-06-02','13:15:00',2.37),('3355','2013-06-02','13:20:00',2.64),('3355','2013-06-02','13:25:00',2.52),('3355','2013-06-02','13:30:00',2.48),('3355','2013-06-02','13:35:00',2.48),('3355','2013-06-02','13:40:00',2.46),('3355','2013-06-02','13:45:00',2.43),('3355','2013-06-02','13:50:00',2.43),('3355','2013-06-02','13:55:00',2.42),('3355','2013-06-02','14:00:00',2.42),('3355','2013-06-02','14:05:00',2.4),('3355','2013-06-02','14:10:00',2.44),('3355','2013-06-02','14:15:00',2.35),('3355','2013-06-02','14:20:00',2.4),('3355','2013-06-02','14:25:00',2.4),('3355','2013-06-02','14:30:00',2.38),('3355','2013-06-02','14:35:00',2.35),('3355','2013-06-02','14:40:00',2.34),('3355','2013-06-02','14:45:00',2.31),('3355','2013-06-02','14:50:00',2.31),('3355','2013-06-02','14:55:00',2.3),('3355','2013-06-02','15:00:00',2.29),('3355','2013-06-02','15:05:00',2.28),('3355','2013-06-02','15:10:00',2.23),('3355','2013-06-02','15:15:00',2.23),('3355','2013-06-02','15:20:00',2.21),('3355','2013-06-02','15:25:00',1.96),('3355','2013-06-02','15:30:00',2.21),('3355','2013-06-02','15:35:00',1.68),('3355','2013-06-02','15:40:00',1.57),('3355','2013-06-02','15:45:00',1.9),('3355','2013-06-02','15:50:00',2.11),('3355','2013-06-02','15:55:00',1.55),('3355','2013-06-02','16:00:00',2.14),('3355','2013-06-02','16:05:00',2.03),('3355','2013-06-02','16:10:00',1.82),('3355','2013-06-02','16:15:00',1.66),('3355','2013-06-02','16:20:00',1.94),('3355','2013-06-02','16:25:00',1.83),('3355','2013-06-02','16:30:00',1.85),('3355','2013-06-02','16:35:00',1.7),('3355','2013-06-02','16:40:00',1.78),('3355','2013-06-02','16:45:00',1.82),('3355','2013-06-02','16:50:00',1.66),('3355','2013-06-02','16:55:00',1.68),('3355','2013-06-02','17:00:00',1.64),('3355','2013-06-02','17:05:00',1.46),('3355','2013-06-02','17:10:00',1.51),('3355','2013-06-02','17:15:00',1.48),('3355','2013-06-02','17:20:00',1.42),('3355','2013-06-02','17:25:00',1.39),('3355','2013-06-02','17:35:00',1.09),('3355','2013-06-01','10:55:00',1.48),('3355','2013-06-01','11:55:00',1.04),('3355','2013-06-01','12:00:00',1.33),('3355','2013-06-01','12:05:00',1.99),('3355','2013-06-01','12:10:00',1.92),('3355','2013-06-01','13:00:00',1.21),('3355','2013-06-01','13:05:00',1.3),('3355','2013-06-01','13:10:00',1.35),('3355','2013-06-01','13:15:00',1.52),('3355','2013-06-01','13:20:00',1.28),('3355','2013-06-01','14:00:00',1.07),('3355','2013-06-01','14:05:00',1.35),('3355','2013-06-01','14:10:00',1.32),('3355','2013-06-01','14:15:00',1.38),('3355','2013-06-01','14:20:00',1.43),('3355','2014-04-02','10:00:00',1.04),('3355','2014-04-02','10:25:00',1.8),('3355','2014-04-02','10:30:00',1.68),('3355','2014-04-02','10:55:00',1.6),('3355','2014-04-02','11:00:00',1.99),('3355','2014-04-02','11:05:00',1.91),('3355','2014-04-02','11:10:00',1.6),('3355','2014-04-02','11:20:00',1.91),('3355','2014-04-02','11:25:00',2.23),('3355','2014-04-02','11:30:00',2.13),('3355','2014-04-02','11:35:00',1.66),('3355','2014-04-02','11:40:00',1.66),('3355','2014-04-02','11:45:00',1.18),('3355','2014-04-02','11:50:00',1.82),('3355','2014-04-02','11:55:00',1.34),('3355','2014-04-02','12:00:00',2.13),('3355','2014-04-02','12:05:00',2.57),('3355','2014-04-02','12:20:00',1.39),('3355','2014-04-02','12:25:00',2.52),('3355','2014-04-02','12:35:00',2.05),('3355','2014-04-02','12:40:00',2.52),('3355','2014-04-02','12:45:00',2.46),('3355','2014-04-02','12:50:00',2.35),('3355','2014-04-02','12:55:00',2.58),('3355','2014-04-02','13:00:00',1.74),('3355','2014-04-02','13:10:00',1.87),('3355','2014-04-02','13:15:00',2.17),('3355','2014-04-02','13:20:00',1.81),('3355','2014-04-02','13:25:00',2.38),('3355','2014-04-02','13:30:00',2.48),('3355','2014-04-02','13:35:00',2.5),('3355','2014-04-02','13:40:00',2.59),('3355','2014-04-02','13:45:00',2.47),('3355','2014-04-02','13:50:00',2.38),('3355','2014-04-02','13:55:00',2.36),('3355','2014-04-02','14:00:00',2.36),('3355','2014-04-02','14:05:00',2.31),('3355','2014-04-02','14:10:00',2.36),('3355','2014-04-02','14:15:00',2.34),('3355','2014-04-02','14:20:00',2.31),('3355','2014-04-02','14:25:00',2.3),('3355','2014-04-02','14:30:00',2.29),('3355','2014-04-02','14:35:00',2.24),('3355','2014-04-02','14:40:00',2.28),('3355','2014-04-02','14:45:00',2.29),('3355','2014-04-02','14:50:00',1.22),('3355','2014-04-02','14:55:00',2),('3355','2014-04-02','15:00:00',1.91),('3355','2014-04-02','15:05:00',2.17),('3355','2014-04-02','15:10:00',2.01),('3355','2014-04-02','15:15:00',2.02),('3355','2014-04-02','15:20:00',2.03),('3355','2014-04-02','15:25:00',1.99),('3355','2014-04-02','15:30:00',1.89),('3355','2014-04-02','15:35:00',1.83),('3355','2014-04-02','15:40:00',1.93),('3355','2014-04-02','15:45:00',1.95),('3355','2014-04-02','15:50:00',1.93),('3355','2014-04-02','15:55:00',1.7),('3355','2014-04-02','16:00:00',1.76),('3355','2014-04-02','16:05:00',1.76),('3355','2014-04-02','16:10:00',1.73),('3355','2014-04-02','16:15:00',1.7),('3355','2014-04-02','16:20:00',1.64),('3355','2014-04-02','16:25:00',1.62),('3355','2014-04-02','16:30:00',1.62),('3355','2014-04-02','16:35:00',1.56),('3355','2014-04-02','16:40:00',1.52),('3355','2014-04-02','16:45:00',1.47),('3355','2014-04-02','16:50:00',1.35),('3355','2014-04-02','16:55:00',1.33),('3355','2014-04-02','17:00:00',1.38),('3355','2014-04-02','17:05:00',1.24),('3355','2014-04-02','17:10:00',1.18),('3355','2014-04-02','17:15:00',1.05),('3355','2014-04-02','17:20:00',1.05),('3355','2014-04-02','17:25:00',1.01),('3355','2013-05-31','08:30:00',1.07),('3355','2013-05-31','08:40:00',1.27),('3355','2013-05-31','08:50:00',1.24),('3355','2013-05-31','09:35:00',1.37),('3355','2013-05-31','09:40:00',1.33),('3355','2013-05-31','09:45:00',1.64),('3355','2013-05-31','09:50:00',1.79),('3355','2013-05-31','09:55:00',1.96),('3355','2013-05-31','10:00:00',1.97),('3355','2013-05-31','10:05:00',1.02),('3355','2013-05-31','10:10:00',1.06),('3355','2013-05-31','10:15:00',1.54),('3355','2013-05-31','10:20:00',1.84),('3355','2013-05-31','10:30:00',1.12),('3355','2013-05-31','10:35:00',1.54),('3355','2013-05-31','10:40:00',1.65),('3355','2013-05-31','10:45:00',2.05),('3355','2013-05-31','10:50:00',1.58),('3355','2013-05-31','10:55:00',2.16),('3355','2013-05-31','11:10:00',2.77),('3355','2013-05-31','11:15:00',2.5),('3355','2013-05-31','11:25:00',1),('3355','2013-05-31','11:30:00',2.01),('3355','2013-05-31','11:35:00',1.38),('3355','2013-05-31','11:45:00',1.78),('3355','2013-05-31','11:50:00',2.39),('3355','2013-05-31','11:55:00',1.28),('3355','2013-05-31','12:00:00',1.57),('3355','2013-05-31','12:05:00',2.43),('3355','2013-05-31','12:10:00',2.37),('3355','2013-05-31','12:25:00',1.88),('3355','2013-05-31','12:40:00',2.04),('3355','2013-05-31','12:45:00',1.49),('3355','2013-05-31','13:00:00',2.09),('3355','2013-05-31','13:05:00',1.26),('3355','2013-05-31','13:30:00',2.02),('3355','2013-05-31','13:35:00',2.7),('3355','2013-05-31','13:40:00',1.22),('3355','2013-05-31','14:00:00',1.22),('3355','2013-05-31','15:10:00',1),('3355','2013-05-31','15:15:00',1.31),('3355','2013-05-31','15:20:00',2.85),('3355','2013-05-31','15:25:00',1.91),('3355','2013-05-31','15:30:00',1.61),('3355','2013-05-31','15:35:00',1.17),('3355','2013-05-31','15:50:00',1.27),('3355','2013-05-31','15:55:00',1.19),('3355','2013-05-30','08:40:00',1.12),('3355','2013-05-30','08:45:00',1.18),('3355','2013-05-30','08:50:00',1.22),('3355','2013-05-30','08:55:00',1.27),('3355','2013-05-30','09:00:00',1.32),('3355','2013-05-30','09:05:00',1.29),('3355','2013-05-30','09:10:00',1.18),('3355','2013-05-30','09:15:00',1.47),('3355','2013-05-30','09:20:00',1.52),('3355','2013-05-30','09:25:00',1.55),('3355','2013-05-30','09:30:00',1.49),('3355','2013-05-30','09:35:00',1.58),('3355','2013-05-30','09:40:00',1.71),('3355','2013-05-30','09:45:00',1.7),('3355','2013-05-30','09:50:00',1.61),('3355','2013-05-30','09:55:00',1.51),('3355','2013-05-30','10:10:00',1.77),('3355','2013-05-30','10:15:00',1.05),('3355','2013-05-30','10:20:00',2.23),('3355','2013-05-30','10:40:00',1.63),('3355','2013-05-30','10:45:00',1.68),('3355','2013-05-30','10:50:00',2.25),('3355','2013-05-30','10:55:00',1.77),('3355','2013-05-30','11:00:00',2.3),('3355','2013-05-30','11:05:00',2.56),('3355','2013-05-30','11:10:00',1.35),('3355','2013-05-30','11:20:00',2.35),('3355','2013-05-30','11:25:00',1.18),('3355','2013-05-30','11:30:00',1.83),('3355','2013-05-30','11:35:00',2.77),('3355','2013-05-30','11:40:00',2.71),('3355','2013-05-30','11:45:00',2.23),('3355','2013-05-30','11:50:00',2.76),('3355','2013-05-30','12:00:00',2.05),('3355','2013-05-30','12:05:00',2.8),('3355','2013-05-30','12:10:00',1.51),('3355','2013-05-30','12:15:00',2.03),('3355','2013-05-30','12:20:00',2.56),('3355','2013-05-30','12:25:00',1.76),('3355','2013-05-30','12:30:00',2.16),('3355','2013-05-30','12:35:00',1.87),('3355','2013-05-30','12:40:00',2.22),('3355','2013-05-30','12:45:00',1.03),('3355','2013-05-30','12:50:00',2.67),('3355','2013-05-30','12:55:00',2.73),('3355','2013-05-30','13:00:00',1.99),('3355','2013-05-30','13:05:00',1.85),('3355','2013-05-30','13:10:00',1.27),('3355','2013-05-30','13:15:00',1.62),('3355','2013-05-30','13:25:00',1.11),('3355','2013-05-30','13:30:00',1.49),('3355','2013-05-30','13:40:00',2.47),('3355','2013-05-30','13:45:00',2.26),('3355','2013-05-30','13:50:00',1.06),('3355','2013-05-30','14:00:00',1.78),('3355','2013-05-30','14:05:00',2.73),('3355','2013-05-30','14:10:00',1.77),('3355','2013-05-30','14:15:00',2.45),('3355','2013-05-30','14:20:00',2.13),('3355','2013-05-30','14:25:00',1.91),('3355','2013-05-30','14:30:00',2.58),('3355','2013-05-30','14:35:00',1.94),('3355','2013-05-30','14:40:00',2.61),('3355','2013-05-30','14:45:00',2.57),('3355','2013-05-30','14:50:00',2.59),('3355','2013-05-30','14:55:00',2.5),('3355','2013-05-30','15:00:00',2.41),('3355','2013-05-30','15:05:00',2.29),('3355','2013-05-30','15:10:00',1.05),('3355','2013-05-30','15:15:00',2.44),('3355','2013-05-30','15:20:00',2.52),('3355','2013-05-30','15:25:00',2.44),('3355','2013-05-30','15:30:00',2.27),('3355','2013-05-30','15:35:00',1.82),('3355','2013-05-30','15:40:00',2.57),('3355','2013-05-30','15:45:00',2.54),('3355','2013-05-30','15:50:00',1.37),('3355','2013-05-30','15:55:00',1.75),('3355','2013-05-30','16:00:00',2.42),('3355','2013-05-30','16:05:00',2.05),('3355','2013-05-30','16:10:00',2.25),('3355','2013-05-30','16:15:00',2.13),('3355','2013-05-30','16:20:00',1.96),('3355','2013-05-30','16:25:00',1.4),('3355','2013-05-30','16:30:00',1.16),('3355','2013-05-30','16:35:00',1.2),('3355','2013-05-30','16:45:00',1.3),('3355','2013-05-30','16:50:00',1.54),('3355','2013-05-30','16:55:00',1.47),('3355','2013-05-30','17:00:00',1.23),('3355','2013-05-30','17:05:00',1.09),('3355','2013-05-29','08:35:00',1.03),('3355','2013-05-29','08:40:00',1.08),('3355','2013-05-29','08:45:00',1.13),('3355','2013-05-29','08:50:00',1.18),('3355','2013-05-29','08:55:00',1.23),('3355','2013-05-29','09:00:00',1.28),('3355','2013-05-29','09:05:00',1.33),('3355','2013-05-29','09:10:00',1.37),('3355','2013-05-29','09:15:00',1.41),('3355','2013-05-29','09:20:00',1.45),('3355','2013-05-29','09:25:00',1.49),('3355','2013-05-29','09:30:00',1.53),('3355','2013-05-29','09:35:00',1.57),('3355','2013-05-29','09:40:00',1.63),('3355','2013-05-29','09:45:00',1.67),('3355','2013-05-29','09:50:00',1.72),('3355','2013-05-29','09:55:00',1.75),('3355','2013-05-29','10:00:00',1.78),('3355','2013-05-29','10:05:00',1.82),('3355','2013-05-29','10:10:00',1.85),('3355','2013-05-29','10:15:00',1.89),('3355','2013-05-29','10:20:00',1.93),('3355','2013-05-29','10:25:00',1.97),('3355','2013-05-29','10:30:00',2),('3355','2013-05-29','10:35:00',2.05),('3355','2013-05-29','10:40:00',2.08),('3355','2013-05-29','10:45:00',2.1),('3355','2013-05-29','10:50:00',2.13),('3355','2013-05-29','10:55:00',2.15),('3355','2013-05-29','11:00:00',2.18),('3355','2013-05-29','11:05:00',1.96),('3355','2013-05-29','11:10:00',2.27),('3355','2013-05-29','11:15:00',1.5),('3355','2013-05-29','11:20:00',2.41),('3355','2013-05-29','11:25:00',2.46),('3355','2013-05-29','11:30:00',2.14),('3355','2013-05-29','11:35:00',2.54),('3355','2013-05-29','11:40:00',2.35),('3355','2013-05-29','11:45:00',2.22),('3355','2013-05-29','11:50:00',1.68),('3355','2013-05-29','11:55:00',2.02),('3355','2013-05-29','12:00:00',2.09),('3355','2013-05-29','12:05:00',1.43),('3355','2013-05-29','12:10:00',1.85),('3355','2013-05-29','12:15:00',2.24),('3355','2013-05-29','12:20:00',1.91),('3355','2013-05-29','12:25:00',2.6),('3355','2013-05-29','12:30:00',2.54),('3355','2013-05-29','12:35:00',2.52),('3355','2013-05-29','12:40:00',2.6),('3355','2013-05-29','12:45:00',2.15),('3355','2013-05-29','12:50:00',2.37),('3355','2013-05-29','12:55:00',2.47),('3355','2013-05-29','13:00:00',2.56),('3355','2013-05-29','13:05:00',2.35),('3355','2013-05-29','13:10:00',2.23),('3355','2013-05-29','13:15:00',2.36),('3355','2013-05-29','13:20:00',2.17),('3355','2013-05-29','13:25:00',2.7),('3355','2013-05-29','13:30:00',2.59),('3355','2013-05-29','13:35:00',2.46),('3355','2013-05-29','13:40:00',2.72),('3355','2013-05-29','13:45:00',2.41),('3355','2013-05-29','13:50:00',2.16),('3355','2013-05-29','13:55:00',2.16),('3355','2013-05-29','14:00:00',2.53),('3355','2013-05-29','14:05:00',2.51),('3355','2013-05-29','14:10:00',2.42),('3355','2013-05-29','14:15:00',2.51),('3355','2013-05-29','14:20:00',2.51),('3355','2013-05-29','14:25:00',2.47),('3355','2013-05-29','14:30:00',2.52),('3355','2013-05-29','14:35:00',1.59),('3355','2013-05-29','14:40:00',2.22),('3355','2013-05-29','14:45:00',2.53),('3355','2013-05-29','14:50:00',2.57),('3355','2013-05-29','14:55:00',2.45),('3355','2013-05-29','15:00:00',2.08),('3355','2013-05-29','15:05:00',2.5),('3355','2013-05-29','15:10:00',2.17),('3355','2013-05-29','15:15:00',1.31),('3355','2013-05-29','15:20:00',1.68),('3355','2013-05-29','15:25:00',1.72),('3355','2013-05-29','15:30:00',1.55),('3355','2013-05-29','15:35:00',1.66),('3355','2013-05-29','15:40:00',1.44),('3355','2013-05-29','15:45:00',1.74),('3355','2013-05-29','15:50:00',1.75),('3355','2013-05-29','15:55:00',1.7),('3355','2013-05-29','16:00:00',1.45),('3355','2013-05-29','16:05:00',1.51),('3355','2013-05-29','16:10:00',1.24),('3355','2013-05-29','16:15:00',1.15),('3355','2013-05-29','16:20:00',1.14),('3355','2013-05-29','16:25:00',1.12),('3355','2013-05-29','16:30:00',1.05),('3355','2013-05-29','16:40:00',1.13),('3355','2013-05-29','16:45:00',1.03),('3355','2013-05-29','18:15:00',1.09),('3355','2013-05-28','09:25:00',1.1),('3355','2013-05-28','09:30:00',1.18),('3355','2013-05-28','09:35:00',1.23),('3355','2013-05-28','09:40:00',1.18),('3355','2013-05-28','09:45:00',1.09),('3355','2013-05-28','09:50:00',1.11),('3355','2013-05-28','09:55:00',1.23),('3355','2013-05-28','10:00:00',1.14),('3355','2013-05-28','10:05:00',1.2),('3355','2013-05-28','10:10:00',1.34),('3355','2013-05-28','10:15:00',1.38),('3355','2013-05-28','10:20:00',1.48),('3355','2013-05-28','10:25:00',1.43),('3355','2013-05-28','10:30:00',1.59),('3355','2013-05-28','10:35:00',1.62),('3355','2013-05-28','10:40:00',1.45),('3355','2013-05-28','10:45:00',1.4),('3355','2013-05-28','10:50:00',1.52),('3355','2013-05-28','10:55:00',1.3),('3355','2013-05-28','11:00:00',1.29),('3355','2013-05-28','11:05:00',1.27),('3355','2013-05-28','11:10:00',1.41),('3355','2013-05-28','11:15:00',1.03),('3355','2013-05-28','11:20:00',1.26),('3355','2013-05-28','11:25:00',1.01),('3355','2013-05-28','11:30:00',1.87),('3355','2013-05-28','11:35:00',1.55),('3355','2013-05-28','11:40:00',2.1),('3355','2013-05-28','11:45:00',1.95),('3355','2013-05-28','12:10:00',1.63),('3355','2013-05-28','12:15:00',1.53),('3355','2013-05-28','12:20:00',1.26),('3355','2013-05-28','12:25:00',1.31),('3355','2013-05-28','12:30:00',1.47),('3355','2013-05-28','12:35:00',1.41),('3355','2013-05-28','12:40:00',1.43),('3355','2013-05-28','12:45:00',1.64),('3355','2013-05-28','12:50:00',1.46),('3355','2013-05-28','12:55:00',1.45),('3355','2013-05-28','13:00:00',1.51),('3355','2013-05-28','13:05:00',1.6),('3355','2013-05-28','13:10:00',1.66),('3355','2013-05-28','13:15:00',1.58),('3355','2013-05-28','13:20:00',1.8),('3355','2013-05-28','13:25:00',1.03),('3355','2013-05-28','13:30:00',1.17),('3355','2013-05-28','13:40:00',1.04),('3355','2013-05-28','13:45:00',1.02),('3355','2013-05-28','13:50:00',1.61),('3355','2013-05-28','13:55:00',1.59),('3355','2013-05-28','14:00:00',1.42),('3355','2013-05-28','14:05:00',1.51),('3355','2013-05-28','14:10:00',2.06),('3355','2013-05-28','14:15:00',2.2),('3355','2013-05-28','14:20:00',1.41),('3355','2013-05-28','14:25:00',1.6),('3355','2013-05-28','14:30:00',1.84),('3355','2013-05-28','14:35:00',1.73),('3355','2013-05-28','14:40:00',1.89),('3355','2013-05-28','14:45:00',2.11),('3355','2013-05-28','14:50:00',1.52),('3355','2013-05-28','14:55:00',1.34),('3355','2013-05-28','15:00:00',1.24),('3355','2013-05-28','15:05:00',2.12),('3355','2013-05-28','15:15:00',1.54),('3355','2013-05-28','15:20:00',1.81),('3355','2013-05-28','15:25:00',1.15),('3355','2013-05-28','15:40:00',1.49),('3355','2013-05-28','15:45:00',2.14),('3355','2013-05-28','15:50:00',1.76),('3355','2013-05-28','15:55:00',1.35),('3355','2013-05-28','16:20:00',1.26),('3355','2013-05-28','16:25:00',1.27),('3355','2013-05-28','16:30:00',1.33),('3355','2013-05-28','16:35:00',1.76),('3355','2013-05-28','16:40:00',1.64),('3355','2013-05-28','16:45:00',1.58),('3355','2013-05-28','16:50:00',1.54),('3355','2013-05-28','16:55:00',1.5),('3355','2013-05-28','17:00:00',1.48),('3355','2013-05-28','17:05:00',1.44),('3355','2013-05-28','17:10:00',1.39),('3355','2013-05-28','17:15:00',1.36),('3355','2013-05-28','17:20:00',1.31),('3355','2013-05-28','17:25:00',1.25),('3355','2013-05-28','17:30:00',1.22),('3355','2013-05-28','17:35:00',1.17),('3355','2013-05-28','17:45:00',1.07),('3355','2013-05-27','08:30:00',1.01),('3355','2013-05-27','08:35:00',1.06),('3355','2013-05-27','08:40:00',1.11),('3355','2013-05-27','08:45:00',1.17),('3355','2013-05-27','08:50:00',1.39),('3355','2013-05-27','08:55:00',1.41),('3355','2013-05-27','09:00:00',1.44),('3355','2013-05-27','09:05:00',1.54),('3355','2013-05-27','09:10:00',1.39),('3355','2013-05-27','09:15:00',1.28),('3355','2013-05-27','09:20:00',1.42),('3355','2013-05-27','09:30:00',1.51),('3355','2013-05-27','09:35:00',1.68),('3355','2013-05-27','09:40:00',1.71),('3355','2013-05-27','09:45:00',1.76),('3355','2013-05-27','09:50:00',1.71),('3355','2013-05-27','09:55:00',1.93),('3355','2013-05-27','10:00:00',1.94),('3355','2013-05-27','10:05:00',1.95),('3355','2013-05-27','10:10:00',1.96),('3355','2013-05-27','10:15:00',2.02),('3355','2013-05-27','10:20:00',1.83),('3355','2013-05-27','10:25:00',1.06),('3355','2013-05-27','10:30:00',1.76),('3355','2013-05-27','10:45:00',1.53),('3355','2013-05-27','10:50:00',1.44),('3355','2013-05-27','10:55:00',1.22),('3355','2013-05-27','11:00:00',1.46),('3355','2013-05-27','11:05:00',2.55),('3355','2013-05-27','11:10:00',2.2),('3355','2013-05-27','11:15:00',1.46),('3355','2013-05-27','11:20:00',1.43),('3355','2013-05-27','11:25:00',2.8),('3355','2013-05-27','11:30:00',1.2),('3355','2013-05-27','11:35:00',1.48),('3355','2013-05-27','11:40:00',1.47),('3355','2013-05-27','11:45:00',2),('3355','2013-05-27','11:50:00',1.33),('3355','2013-05-27','11:55:00',1.43),('3355','2013-05-27','12:00:00',2.27),('3355','2013-05-27','12:05:00',1.79),('3355','2013-05-27','12:10:00',1.8),('3355','2013-05-27','12:15:00',2.53),('3355','2013-05-27','12:20:00',2.29),('3355','2013-05-27','12:25:00',2.74),('3355','2013-05-27','12:30:00',2.58),('3355','2013-05-27','12:35:00',2.08),('3355','2013-05-27','12:40:00',2.22),('3355','2013-05-27','12:45:00',2.81),('3355','2013-05-27','12:50:00',2.66),('3355','2013-05-27','12:55:00',2.68),('3355','2013-05-27','13:00:00',2.72),('3355','2013-05-27','13:10:00',2.03),('3355','2013-05-27','13:15:00',1.86),('3355','2013-05-27','13:20:00',1.56),('3355','2013-05-27','13:25:00',2.67),('3355','2013-05-27','13:30:00',2.61),('3355','2013-05-27','13:35:00',2.1),('3355','2013-05-27','13:40:00',2.65),('3355','2013-05-27','13:45:00',2.7),('3355','2013-05-27','13:50:00',1.85),('3355','2013-05-27','13:55:00',1.71),('3355','2013-05-27','14:00:00',2.42),('3355','2013-05-27','14:05:00',2.56),('3355','2013-05-27','14:10:00',2.21),('3355','2013-05-27','14:15:00',2.12),('3355','2013-05-27','14:20:00',1.8),('3355','2013-05-27','14:25:00',2.44),('3355','2013-05-27','14:30:00',1.64),('3355','2013-05-27','14:35:00',2.45),('3355','2013-05-27','14:45:00',2.34),('3355','2013-05-27','14:50:00',2.59);
INSERT INTO `solarlogmod` VALUES ('3355','2013-05-27','14:55:00',2.13),('3355','2013-05-27','15:00:00',1.63),('3355','2013-05-27','15:05:00',1.43),('3355','2013-05-27','15:10:00',2.39),('3355','2013-05-27','15:15:00',1.65),('3355','2013-05-27','15:20:00',1.99),('3355','2013-05-27','15:25:00',1.88),('3355','2013-05-27','15:30:00',2.01),('3355','2013-05-27','15:35:00',2.33),('3355','2013-05-27','15:40:00',1.9),('3355','2013-05-27','15:45:00',1.71),('3355','2013-05-27','15:50:00',2.19),('3355','2013-05-27','15:55:00',1.43),('3355','2013-05-27','16:00:00',1.72),('3355','2013-05-27','16:05:00',1.25),('3355','2013-05-27','16:10:00',1.52),('3355','2013-05-27','16:15:00',1.3),('3355','2013-05-27','16:20:00',2.13),('3355','2013-05-27','16:25:00',2.09),('3355','2013-05-27','16:30:00',1.89),('3355','2013-05-27','16:35:00',1.72),('3355','2013-05-27','18:25:00',1.03),('3355','2013-05-26','08:30:00',1.03),('3355','2013-05-26','08:40:00',1.06),('3355','2013-05-26','08:45:00',1.21),('3355','2013-05-26','08:50:00',1.47),('3355','2013-05-26','09:15:00',1.03),('3355','2013-05-26','09:45:00',1.25),('3355','2013-05-26','10:05:00',1.34),('3355','2013-05-26','10:10:00',2.14),('3355','2013-05-26','10:15:00',1.44),('3355','2013-05-26','10:20:00',1.54),('3355','2013-05-26','10:25:00',1.42),('3355','2013-05-26','10:30:00',1.99),('3355','2013-05-26','10:35:00',1.95),('3355','2013-05-26','10:40:00',2.18),('3355','2013-05-26','10:45:00',2.21),('3355','2013-05-26','10:50:00',2.25),('3355','2013-05-26','10:55:00',2.18),('3355','2013-05-26','11:00:00',2.21),('3355','2013-05-26','11:05:00',2.33),('3355','2013-05-26','11:10:00',2.34),('3355','2013-05-26','11:15:00',2.36),('3355','2013-05-26','11:20:00',2.4),('3355','2013-05-26','11:25:00',2.41),('3355','2013-05-26','11:30:00',2.45),('3355','2013-05-26','11:35:00',2.4),('3355','2013-05-26','11:40:00',2.49),('3355','2013-05-26','11:45:00',2.55),('3355','2013-05-26','11:50:00',2.49),('3355','2013-05-26','11:55:00',2.59),('3355','2013-05-26','12:00:00',2.52),('3355','2013-05-26','12:05:00',2.54),('3355','2013-05-26','12:10:00',2.35),('3355','2013-05-26','12:15:00',2.33),('3355','2013-05-26','12:20:00',1.79),('3355','2013-05-26','12:25:00',2.32),('3355','2013-05-26','12:30:00',2.7),('3355','2013-05-26','12:35:00',2.67),('3355','2013-05-26','12:40:00',2.4),('3355','2013-05-26','12:45:00',1.98),('3355','2013-05-26','12:50:00',2.69),('3355','2013-05-26','12:55:00',2.65),('3355','2013-05-26','13:00:00',2.52),('3355','2013-05-26','13:05:00',2.33),('3355','2013-05-26','13:10:00',2.64),('3355','2013-05-26','13:15:00',2.46),('3355','2013-05-26','13:20:00',2.72),('3355','2013-05-26','13:25:00',2.66),('3355','2013-05-26','13:30:00',2.69),('3355','2013-05-26','13:35:00',2.68),('3355','2013-05-26','13:40:00',2.63),('3355','2013-05-26','13:45:00',2.63),('3355','2013-05-26','13:50:00',2.56),('3355','2013-05-26','13:55:00',2.56),('3355','2013-05-26','14:00:00',2.59),('3355','2013-05-26','14:05:00',2.59),('3355','2013-05-26','14:10:00',2.57),('3355','2013-05-26','14:15:00',2.55),('3355','2013-05-26','14:20:00',2.54),('3355','2013-05-26','14:25:00',2.52),('3355','2013-05-26','14:30:00',2.53),('3355','2013-05-26','14:35:00',2.5),('3355','2013-05-26','14:40:00',2.48),('3355','2013-05-26','14:45:00',2.46),('3355','2013-05-26','14:50:00',2.46),('3355','2013-05-26','14:55:00',2.44),('3355','2013-05-26','15:00:00',2.41),('3355','2013-05-26','15:05:00',2.41),('3355','2013-05-26','15:10:00',2.39),('3355','2013-05-26','15:15:00',2.38),('3355','2013-05-26','15:20:00',2.35),('3355','2013-05-26','15:25:00',2.33),('3355','2013-05-26','15:30:00',2.31),('3355','2013-05-26','15:35:00',2.28),('3355','2013-05-26','15:40:00',2.25),('3355','2013-05-26','15:45:00',2.21),('3355','2013-05-26','15:50:00',2.18),('3355','2013-05-26','15:55:00',2.16),('3355','2013-05-26','16:00:00',2.13),('3355','2013-05-26','16:05:00',2.1),('3355','2013-05-26','16:10:00',2.07),('3355','2013-05-26','16:15:00',2.03),('3355','2013-05-26','16:20:00',1.99),('3355','2013-05-26','16:25:00',1.96),('3355','2013-05-26','16:30:00',1.93),('3355','2013-05-26','16:35:00',1.88),('3355','2013-05-26','16:40:00',1.83),('3355','2013-05-26','16:45:00',1.8),('3355','2013-05-26','16:50:00',1.76),('3355','2013-05-26','16:55:00',1.72),('3355','2013-05-26','17:00:00',1.68),('3355','2013-05-26','17:05:00',1.64),('3355','2013-05-26','17:10:00',1.57),('3355','2013-05-26','17:15:00',1.53),('3355','2013-05-26','17:20:00',1.49),('3355','2013-05-26','17:25:00',1.44),('3355','2013-05-26','17:30:00',1.39),('3355','2013-05-26','17:35:00',1.34),('3355','2013-05-26','17:40:00',1.29),('3355','2013-05-26','17:45:00',1.24),('3355','2013-05-26','17:50:00',1.19),('3355','2013-05-26','17:55:00',1.14),('3355','2013-05-26','18:00:00',1.08),('3355','2013-05-26','18:05:00',1.02),('3355','2013-05-25','08:05:00',1.01),('3355','2013-05-25','08:25:00',1.12),('3355','2013-05-25','08:30:00',1.39),('3355','2013-05-25','09:05:00',1.67),('3355','2013-05-25','09:10:00',1.56),('3355','2013-05-25','09:15:00',1.88),('3355','2013-05-25','09:35:00',1.21),('3355','2013-05-25','09:40:00',2.08),('3355','2013-05-25','09:45:00',1.47),('3355','2013-05-25','09:50:00',1.79),('3355','2013-05-25','09:55:00',1.29),('3355','2013-05-25','11:05:00',1.14),('3355','2013-05-25','11:10:00',2.39),('3355','2013-05-25','11:15:00',2.17),('3355','2013-05-25','11:20:00',1.52),('3355','2013-05-25','11:45:00',1.29),('3355','2013-05-25','11:55:00',1.01),('3355','2013-05-25','12:45:00',1.05),('3355','2013-05-25','12:55:00',1.36),('3355','2013-05-25','13:20:00',1.1),('3355','2013-05-25','13:25:00',1.45),('3355','2013-05-25','13:30:00',1.16),('3355','2013-05-25','13:40:00',1.1),('3355','2013-05-25','13:45:00',1.04),('3355','2013-05-25','13:50:00',1.38),('3355','2013-05-25','13:55:00',1.62),('3355','2013-05-25','14:00:00',2.2),('3355','2013-05-25','14:05:00',2.68),('3355','2013-05-25','14:10:00',2.6),('3355','2013-05-25','14:15:00',2.57),('3355','2013-05-25','14:20:00',1.97),('3355','2013-05-25','14:25:00',2.07),('3355','2013-05-25','14:30:00',2.1),('3355','2013-05-25','14:35:00',1.1),('3355','2013-05-25','14:45:00',1.01),('3355','2013-05-25','14:50:00',1.03),('3355','2013-05-25','15:00:00',1.64),('3355','2013-05-25','15:05:00',1.67),('3355','2013-05-25','15:10:00',1.02),('3355','2013-05-25','15:15:00',1.6),('3355','2013-05-25','15:25:00',1.41),('3355','2013-05-25','15:30:00',1.52),('3355','2013-05-25','15:35:00',2.46),('3355','2013-05-25','15:40:00',2.11),('3355','2013-05-25','15:45:00',2.12),('3355','2013-05-25','15:50:00',2.42),('3355','2013-05-25','15:55:00',2.5),('3355','2013-05-25','16:00:00',1.82),('3355','2013-05-25','16:10:00',1.6),('3355','2013-05-25','16:30:00',1.38),('3355','2013-05-25','16:35:00',1.41),('3355','2013-05-25','16:40:00',1.49),('3355','2013-05-25','16:45:00',1.66),('3355','2013-05-25','16:50:00',1.28),('3355','2013-05-25','17:10:00',1.77),('3355','2013-05-25','17:15:00',1.1),('3355','2013-05-25','17:20:00',1.03),('3355','2013-05-25','17:25:00',1.11),('3355','2013-05-24','08:50:00',1.11),('3355','2013-05-24','08:55:00',1.28),('3355','2013-05-24','09:00:00',1.38),('3355','2013-05-24','09:05:00',1.62),('3355','2013-05-24','09:20:00',1.15),('3355','2013-05-24','09:55:00',1.28),('3355','2013-05-24','10:00:00',1.41),('3355','2013-05-24','10:25:00',1.22),('3355','2013-05-24','10:30:00',2.25),('3355','2013-05-24','10:35:00',2.05),('3355','2013-05-24','10:40:00',1.74),('3355','2013-05-24','10:45:00',1.85),('3355','2013-05-24','10:50:00',1.48),('3355','2013-05-24','10:55:00',2.39),('3355','2013-05-24','11:00:00',1.7),('3355','2013-05-24','11:05:00',1.66),('3355','2013-05-24','11:10:00',2.18),('3355','2013-05-24','11:15:00',2.05),('3355','2013-05-24','11:20:00',2.45),('3355','2013-05-24','11:25:00',2.52),('3355','2013-05-24','11:30:00',1.71),('3355','2013-05-24','11:45:00',1.26),('3355','2013-05-24','11:50:00',2.69),('3355','2013-05-24','11:55:00',2.09),('3355','2013-05-24','12:00:00',1),('3355','2013-05-24','12:05:00',1.71),('3355','2013-05-24','12:10:00',1.84),('3355','2013-05-24','12:15:00',1.22),('3355','2013-05-24','12:20:00',1.15),('3355','2013-05-24','12:25:00',2.29),('3355','2013-05-24','12:30:00',2.34),('3355','2013-05-24','12:35:00',1.14),('3355','2013-05-24','12:40:00',1.48),('3355','2013-05-24','12:45:00',1.98),('3355','2013-05-24','12:50:00',1.62),('3355','2013-05-24','12:55:00',1.3),('3355','2013-05-24','13:00:00',1.24),('3355','2013-05-24','13:05:00',1.11),('3355','2013-05-24','13:10:00',1.42),('3355','2013-05-24','13:15:00',1.61),('3355','2013-05-24','13:20:00',1.84),('3355','2013-05-24','13:25:00',1.47),('3355','2013-05-24','13:30:00',1.05),('3355','2013-05-24','13:35:00',2.1),('3355','2013-05-24','13:40:00',1.45),('3355','2013-05-24','13:55:00',1.97),('3355','2013-05-24','14:00:00',1.69),('3355','2013-05-24','14:05:00',1.29),('3355','2013-05-24','14:15:00',1.97),('3355','2013-05-24','14:20:00',1.96),('3355','2013-05-24','14:25:00',2.03),('3355','2013-05-24','14:30:00',1.65),('3355','2013-05-24','14:35:00',1.73),('3355','2013-05-24','14:40:00',1.44),('3355','2013-05-24','14:45:00',1.56),('3355','2013-05-24','15:00:00',1.23),('3355','2013-05-24','15:05:00',2.21),('3355','2013-05-24','15:10:00',1.65),('3355','2013-05-24','15:15:00',1.76),('3355','2013-05-24','15:20:00',2.37),('3355','2013-05-24','15:25:00',1.87),('3355','2013-05-24','15:30:00',1.83),('3355','2013-05-24','15:35:00',1.5),('3355','2013-05-24','15:40:00',1.53),('3355','2013-05-24','15:45:00',2.11),('3355','2013-05-24','15:50:00',2.17),('3355','2013-05-24','15:55:00',2.67),('3355','2013-05-24','16:00:00',1.3),('3355','2013-05-24','16:05:00',1.12),('3355','2013-05-24','16:10:00',1.16),('3355','2013-05-24','16:15:00',1.48),('3355','2013-05-24','16:20:00',1.03),('3355','2013-05-24','16:25:00',1.35),('3355','2013-05-24','16:30:00',1.83),('3355','2013-05-24','16:55:00',1.18),('3355','2013-05-23','08:35:00',1.12),('3355','2013-05-23','08:40:00',1.05),('3355','2013-05-23','09:00:00',1.29),('3355','2013-05-23','09:25:00',1.68),('3355','2013-05-23','09:30:00',1.88),('3355','2013-05-23','09:35:00',1.37),('3355','2013-05-23','09:40:00',1.32),('3355','2013-05-23','09:45:00',1.11),('3355','2013-05-23','09:50:00',1.77),('3355','2013-05-23','10:05:00',1.47),('3355','2013-05-23','10:10:00',1.98),('3355','2013-05-23','10:15:00',1.77),('3355','2013-05-23','10:20:00',1.45),('3355','2013-05-23','10:25:00',1.97),('3355','2013-05-23','10:30:00',2.11),('3355','2013-05-23','10:35:00',1.77),('3355','2013-05-23','10:40:00',1.98),('3355','2013-05-23','10:45:00',2.28),('3355','2013-05-23','10:50:00',2.15),('3355','2013-05-23','10:55:00',2.34),('3355','2013-05-23','11:00:00',1.94),('3355','2013-05-23','11:05:00',1.79),('3355','2013-05-23','11:10:00',1.24),('3355','2013-05-23','11:20:00',1.06),('3355','2013-05-23','11:25:00',1.19),('3355','2013-05-23','11:30:00',1.92),('3355','2013-05-23','11:35:00',2.13),('3355','2013-05-23','11:40:00',2.43),('3355','2013-05-23','11:45:00',1.38),('3355','2013-05-23','11:50:00',2.47),('3355','2013-05-23','11:55:00',2.78),('3355','2013-05-23','12:00:00',2.44),('3355','2013-05-23','12:05:00',2.57),('3355','2013-05-23','12:10:00',2.6),('3355','2013-05-23','12:15:00',2.39),('3355','2013-05-23','12:20:00',1.72),('3355','2013-05-23','12:25:00',2.62),('3355','2013-05-23','12:30:00',2.17),('3355','2013-05-23','12:40:00',2.17),('3355','2013-05-23','12:45:00',2.18),('3355','2013-05-23','12:50:00',1.73),('3355','2013-05-23','12:55:00',2.28),('3355','2013-05-23','13:00:00',2.78),('3355','2013-05-23','13:05:00',1.73),('3355','2013-05-23','13:10:00',2.21),('3355','2013-05-23','13:15:00',2.05),('3355','2013-05-23','13:20:00',1.98),('3355','2013-05-23','13:25:00',1.23),('3355','2013-05-23','13:30:00',1.86),('3355','2013-05-23','13:35:00',1.21),('3355','2013-05-23','13:45:00',2.31),('3355','2013-05-23','13:50:00',1.49),('3355','2013-05-23','13:55:00',2.13),('3355','2013-05-23','14:00:00',2.35),('3355','2013-05-23','14:05:00',2.41),('3355','2013-05-23','14:10:00',2.84),('3355','2013-05-23','14:15:00',1.56),('3355','2013-05-23','14:20:00',2.77),('3355','2013-05-23','14:25:00',2.6),('3355','2013-05-23','14:35:00',2.61),('3355','2013-05-23','14:40:00',2.33),('3355','2013-05-23','14:45:00',1.3),('3355','2013-05-23','14:50:00',1.28),('3355','2013-05-23','14:55:00',1.68),('3355','2013-05-23','15:00:00',1.91),('3355','2013-05-23','15:05:00',1.47),('3355','2013-05-23','15:20:00',1.77),('3355','2013-05-23','15:30:00',1.44),('3355','2013-05-23','15:35:00',1.77),('3355','2013-05-23','15:40:00',1.17),('3355','2013-05-23','15:45:00',1.41),('3355','2013-05-23','16:00:00',2.06),('3355','2013-05-23','16:05:00',2.01),('3355','2013-05-23','16:10:00',1.44),('3355','2013-05-23','16:15:00',1.3),('3355','2013-05-23','16:20:00',1.87),('3355','2013-05-23','16:25:00',1.71),('3355','2013-05-23','16:30:00',1.91),('3355','2013-05-23','16:35:00',1.11),('3355','2013-05-23','16:40:00',1.03),('3355','2013-05-23','17:10:00',1.3),('3355','2013-05-23','17:15:00',1.07),('3355','2013-05-23','18:05:00',1.34),('3355','2013-05-22','08:30:00',1.06),('3355','2013-05-22','08:35:00',1.28),('3355','2013-05-22','09:30:00',1.41),('3355','2013-05-22','09:35:00',1.53),('3355','2013-05-22','09:40:00',1.52),('3355','2013-05-22','09:45:00',1.54),('3355','2013-05-22','09:50:00',1.57),('3355','2013-05-22','09:55:00',1.6),('3355','2013-05-22','10:00:00',1.64),('3355','2013-05-22','10:05:00',1.68),('3355','2013-05-22','10:10:00',1.72),('3355','2013-05-22','10:15:00',1.75),('3355','2013-05-22','10:20:00',1.74),('3355','2013-05-22','10:25:00',1.87),('3355','2013-05-22','10:30:00',1.85),('3355','2013-05-22','10:35:00',1.88),('3355','2013-05-22','10:40:00',1.95),('3355','2013-05-22','10:45:00',1.95),('3355','2013-05-22','10:50:00',1.94),('3355','2013-05-22','10:55:00',1.96),('3355','2013-05-22','11:00:00',2.02),('3355','2013-05-22','11:05:00',2.09),('3355','2013-05-22','11:10:00',1.97),('3355','2013-05-22','11:15:00',1.92),('3355','2013-05-22','11:20:00',2.14),('3355','2013-05-22','11:25:00',2.21),('3355','2013-05-22','11:30:00',1.8),('3355','2013-05-22','11:35:00',1.76),('3355','2013-05-22','11:40:00',1.9),('3355','2013-05-22','11:45:00',2.19),('3355','2013-05-22','11:50:00',1.34),('3355','2013-05-22','11:55:00',1.15),('3355','2013-05-22','12:00:00',1.65),('3355','2013-05-22','12:05:00',1.27),('3355','2013-05-22','12:10:00',1.2),('3355','2013-05-22','12:15:00',1.7),('3355','2013-05-22','12:20:00',2.45),('3355','2013-05-22','12:25:00',1.59),('3355','2013-05-22','12:30:00',1.23),('3355','2013-05-22','12:35:00',1.3),('3355','2013-05-22','13:05:00',2.68),('3355','2013-05-22','13:10:00',1.21),('3355','2013-05-22','13:15:00',1.26),('3355','2013-05-22','13:20:00',1.18),('3355','2013-05-22','13:35:00',1.8),('3355','2013-05-22','13:40:00',1.71),('3355','2013-05-22','13:45:00',1.29),('3355','2013-05-22','13:50:00',1.32),('3355','2013-05-22','13:55:00',1.25),('3355','2013-05-22','14:00:00',1.46),('3355','2013-05-22','14:05:00',1.97),('3355','2013-05-22','14:10:00',2.12),('3355','2013-05-22','14:15:00',2.38),('3355','2013-05-22','14:20:00',2.31),('3355','2013-05-22','14:25:00',2.28),('3355','2013-05-22','14:30:00',2.27),('3355','2013-05-22','14:35:00',2.26),('3355','2013-05-22','14:40:00',2.23),('3355','2013-05-22','14:45:00',2.22),('3355','2013-05-22','14:50:00',2.2),('3355','2013-05-22','14:55:00',2.16),('3355','2013-05-22','15:00:00',2.16),('3355','2013-05-22','15:05:00',2.14),('3355','2013-05-22','15:10:00',2.12),('3355','2013-05-22','15:15:00',2.11),('3355','2013-05-22','15:20:00',2.03),('3355','2013-05-22','15:25:00',1.04),('3355','2013-05-22','15:30:00',1.09),('3355','2013-05-22','15:35:00',1.14),('3355','2013-05-22','15:45:00',1.52),('3355','2013-05-22','15:50:00',1.97),('3355','2013-05-22','15:55:00',1.91),('3355','2013-05-22','16:00:00',1.88),('3355','2013-05-22','16:05:00',1.84),('3355','2013-05-22','16:10:00',1.78),('3355','2013-05-22','16:15:00',1.77),('3355','2013-05-22','16:20:00',1.74),('3355','2013-05-22','16:25:00',1.71),('3355','2013-05-22','16:30:00',1.66),('3355','2013-05-22','16:35:00',1.61),('3355','2013-05-22','16:40:00',1.57),('3355','2013-05-22','16:45:00',1.3),('3355','2013-05-22','16:50:00',1.1),('3355','2013-05-22','17:25:00',1.18),('3355','2014-04-01','09:15:00',1.03),('3355','2014-04-01','09:20:00',1.08),('3355','2014-04-01','09:25:00',1.12),('3355','2014-04-01','09:30:00',1.17),('3355','2014-04-01','09:35:00',1.22),('3355','2014-04-01','09:40:00',1.24),('3355','2014-04-01','09:45:00',1.32),('3355','2014-04-01','09:50:00',1.38),('3355','2014-04-01','09:55:00',1.42),('3355','2014-04-01','10:00:00',1.16),('3355','2014-04-01','10:05:00',1.19),('3355','2014-04-01','10:10:00',1.54),('3355','2014-04-01','10:15:00',1.54),('3355','2014-04-01','10:20:00',1.65),('3355','2014-04-01','10:25:00',1.73),('3355','2014-04-01','10:30:00',1.82),('3355','2014-04-01','10:35:00',1.74),('3355','2014-04-01','10:40:00',1.74),('3355','2014-04-01','10:45:00',1.89),('3355','2014-04-01','10:50:00',1.82),('3355','2014-04-01','10:55:00',1.93),('3355','2014-04-01','11:00:00',1.93),('3355','2014-04-01','11:05:00',1.97),('3355','2014-04-01','11:10:00',1.98),('3355','2014-04-01','11:15:00',2),('3355','2014-04-01','11:20:00',2.02),('3355','2014-04-01','11:25:00',2.03),('3355','2014-04-01','11:30:00',2.09),('3355','2014-04-01','11:35:00',2.13),('3355','2014-04-01','11:40:00',2.16),('3355','2014-04-01','11:45:00',2.17),('3355','2014-04-01','11:50:00',2.21),('3355','2014-04-01','11:55:00',2.2),('3355','2014-04-01','12:00:00',2.18),('3355','2014-04-01','12:05:00',2.26),('3355','2014-04-01','12:10:00',2.28),('3355','2014-04-01','12:15:00',2.29),('3355','2014-04-01','12:20:00',2.3),('3355','2014-04-01','12:25:00',2.33),('3355','2014-04-01','12:30:00',2.35),('3355','2014-04-01','12:35:00',2.38),('3355','2014-04-01','12:40:00',2.38),('3355','2014-04-01','12:45:00',2.39),('3355','2014-04-01','12:50:00',2.41),('3355','2014-04-01','12:55:00',2.4),('3355','2014-04-01','13:00:00',2.42),('3355','2014-04-01','13:05:00',2.43),('3355','2014-04-01','13:10:00',1.97),('3355','2014-04-01','13:15:00',2.46),('3355','2014-04-01','13:20:00',2.09),('3355','2014-04-01','13:25:00',2.42),('3355','2014-04-01','13:30:00',2.4),('3355','2014-04-01','13:35:00',2.42),('3355','2014-04-01','13:40:00',2.45),('3355','2014-04-01','13:45:00',2.44),('3355','2014-04-01','13:50:00',2.4),('3355','2014-04-01','13:55:00',2.41),('3355','2014-04-01','14:00:00',2.37),('3355','2014-04-01','14:05:00',2.39),('3355','2014-04-01','14:10:00',2.38),('3355','2014-04-01','14:15:00',1.66),('3355','2014-04-01','14:20:00',2.32),('3355','2014-04-01','14:25:00',2.32),('3355','2014-04-01','14:30:00',1.77),('3355','2014-04-01','14:35:00',2.33),('3355','2014-04-01','14:40:00',1.91),('3355','2014-04-01','14:45:00',2.32),('3355','2014-04-01','14:50:00',2.43),('3355','2014-04-01','14:55:00',1.9),('3355','2014-04-01','15:00:00',2.37),('3355','2014-04-01','15:05:00',2.21),('3355','2014-04-01','15:10:00',1.94),('3355','2014-04-01','15:15:00',2.36),('3355','2014-04-01','15:20:00',2.22),('3355','2014-04-01','15:25:00',1.81),('3355','2014-04-01','15:30:00',1.8),('3355','2014-04-01','15:35:00',1.68),('3355','2014-04-01','15:40:00',1.71),('3355','2014-04-01','15:45:00',1.59),('3355','2014-04-01','15:50:00',2.14),('3355','2014-04-01','15:55:00',1.79),('3355','2014-04-01','16:00:00',1.18),('3355','2014-04-01','16:05:00',1.53),('3355','2014-04-01','16:10:00',1.51),('3355','2014-04-01','16:15:00',1.51),('3355','2014-04-01','16:25:00',1.25),('3355','2014-04-01','16:30:00',1.42),('3355','2014-04-01','16:35:00',1.74),('3355','2014-04-01','16:40:00',1.7),('3355','2014-04-01','16:45:00',1.22),('3355','2014-04-01','16:55:00',1.26),('3355','2014-04-01','17:00:00',1.45),('3355','2014-04-01','17:05:00',1.26),('3355','2014-04-01','17:10:00',1.1),('3355','2014-04-01','17:15:00',1.27),('3355','2014-04-01','17:20:00',1.22),('3355','2014-04-01','17:25:00',1.16),('3355','2014-04-01','17:30:00',1.09),('3355','2014-04-01','17:35:00',1),('3355','2013-05-21','09:20:00',1.16),('3355','2013-05-21','09:25:00',1.31),('3355','2013-05-21','09:30:00',1.03),('3355','2013-05-21','09:35:00',1.09),('3355','2013-05-21','09:40:00',1.06),('3355','2013-05-21','10:00:00',1.05),('3355','2013-05-21','10:05:00',1.19),('3355','2013-05-21','10:10:00',1.25),('3355','2013-05-21','10:15:00',1.17),('3355','2013-05-21','10:20:00',1.15),('3355','2013-05-21','10:25:00',1.01),('3355','2013-05-21','10:35:00',1.01),('3355','2013-05-21','10:40:00',1.14),('3355','2013-05-21','10:45:00',1.62),('3355','2013-05-21','10:50:00',1.14),('3355','2013-05-21','11:00:00',1.07),('3355','2013-05-21','11:10:00',1.65),('3355','2013-05-21','11:15:00',2.1),('3355','2013-05-21','11:20:00',1.55),('3355','2013-05-21','11:25:00',1.95),('3355','2013-05-21','11:30:00',1.41),('3355','2013-05-21','11:35:00',1.68),('3355','2013-05-21','11:40:00',1.52),('3355','2013-05-21','11:45:00',1.79),('3355','2013-05-21','11:50:00',1.29),('3355','2013-05-21','11:55:00',1.92),('3355','2013-05-21','12:00:00',1.83),('3355','2013-05-21','12:05:00',1.9),('3355','2013-05-21','12:10:00',1.53),('3355','2013-05-21','12:15:00',1.88),('3355','2013-05-21','12:20:00',1.29),('3355','2013-05-21','12:25:00',1.69),('3355','2013-05-21','12:30:00',2.15),('3355','2013-05-21','12:35:00',1.34),('3355','2013-05-21','12:40:00',2.19),('3355','2013-05-21','12:45:00',2.19),('3355','2013-05-21','12:50:00',1.37),('3355','2013-05-21','12:55:00',2.21),('3355','2013-05-21','13:00:00',2.16),('3355','2013-05-21','13:05:00',2.36),('3355','2013-05-21','13:10:00',1.47),('3355','2013-05-21','13:15:00',2.23),('3355','2013-05-21','13:20:00',1.76),('3355','2013-05-21','13:25:00',1.75),('3355','2013-05-21','13:30:00',1.71),('3355','2013-05-21','14:15:00',1.05),('3355','2013-05-21','14:25:00',1.39),('3355','2013-05-21','14:30:00',1.22),('3355','2013-05-21','14:35:00',1.07),('3355','2013-05-21','14:40:00',1.03),('3355','2013-05-21','15:30:00',1.19),('3355','2013-05-21','16:35:00',1.04),('3355','2013-05-21','16:40:00',1.15),('3355','2013-05-21','16:45:00',1.02),('3355','2013-05-20','08:50:00',1.08),('3355','2013-05-20','08:55:00',1.35),('3355','2013-05-20','09:00:00',1.49),('3355','2013-05-20','09:05:00',1.53),('3355','2013-05-20','09:10:00',1.65),('3355','2013-05-20','09:15:00',1.21),('3355','2013-05-20','09:20:00',1.33),('3355','2013-05-20','09:35:00',1.1),('3355','2013-05-20','09:50:00',1.14),('3355','2013-05-20','10:35:00',1.02),('3355','2013-05-20','10:50:00',1.27),('3355','2013-05-20','10:55:00',1.54),('3355','2013-05-20','11:00:00',1.4),('3355','2013-05-20','11:05:00',2.28),('3355','2013-05-20','11:10:00',2.6),('3355','2013-05-20','11:15:00',2.56),('3355','2013-05-20','11:20:00',2.19),('3355','2013-05-20','11:25:00',2.04),('3355','2013-05-20','11:30:00',1.34),('3355','2013-05-20','11:35:00',1.79),('3355','2013-05-20','11:55:00',1.63),('3355','2013-05-20','12:00:00',1.51),('3355','2013-05-20','12:05:00',1.29),('3355','2013-05-20','12:10:00',2.54),('3355','2013-05-20','12:15:00',1.23),('3355','2013-05-20','12:20:00',1.52),('3355','2013-05-20','12:25:00',1.55),('3355','2013-05-20','12:30:00',1.54),('3355','2013-05-20','12:40:00',2.65),('3355','2013-05-20','12:45:00',2.88),('3355','2013-05-20','12:50:00',1.17),('3355','2013-05-20','13:00:00',1.4),('3355','2013-05-20','13:05:00',1.95),('3355','2013-05-20','13:20:00',1.31),('3355','2013-05-20','13:25:00',1.71),('3355','2013-05-20','13:30:00',1.86),('3355','2013-05-20','13:35:00',1.36),('3355','2013-05-20','13:40:00',1.78),('3355','2013-05-20','13:50:00',2.8),('3355','2013-05-20','13:55:00',1.58),('3355','2013-05-20','14:00:00',2.73),('3355','2013-05-20','14:05:00',1.48),('3355','2013-05-20','14:15:00',2.72),('3355','2013-05-20','14:20:00',1.59),('3355','2013-05-20','14:25:00',1.15),('3355','2013-05-20','14:30:00',1.46),('3355','2013-05-20','14:50:00',2.67),('3355','2013-05-20','14:55:00',1.31),('3355','2013-05-20','15:00:00',2),('3355','2013-05-20','15:10:00',2.22),('3355','2013-05-20','15:15:00',1.94),('3355','2013-05-20','15:20:00',1.27),('3355','2013-05-20','15:25:00',1.87),('3355','2013-05-20','15:30:00',1.01),('3355','2013-05-20','15:35:00',1.97),('3355','2013-05-20','15:40:00',1.68),('3355','2013-05-20','15:50:00',1.91),('3355','2013-05-20','16:00:00',1.52),('3355','2013-05-20','16:05:00',1.65),('3355','2013-05-20','16:10:00',1.35),('3355','2013-05-20','16:15:00',1.69),('3355','2013-05-20','16:20:00',2.07),('3355','2013-05-20','16:25:00',1.98),('3355','2013-05-20','16:30:00',1.92),('3355','2013-05-20','16:35:00',1.84),('3355','2013-05-20','16:40:00',1.82),('3355','2013-05-20','16:45:00',1.7),('3355','2013-05-20','16:50:00',1.66),('3355','2013-05-20','16:55:00',1.62),('3355','2013-05-20','17:00:00',1.57),('3355','2013-05-20','17:05:00',1.62),('3355','2013-05-20','17:10:00',1.09),('3355','2013-05-20','17:20:00',1.11),('3355','2013-05-20','17:25:00',1.47),('3355','2013-05-20','17:30:00',1.55),('3355','2013-05-20','17:35:00',1.29),('3355','2013-05-20','17:40:00',1.19),('3355','2013-05-20','17:45:00',1.14),('3355','2013-05-20','17:50:00',1.09),('3355','2013-05-20','17:55:00',1.03),('3355','2013-05-20','18:00:00',1),('3355','2013-05-20','18:05:00',1.04),('3355','2013-05-19','10:10:00',1.05),('3355','2013-05-19','10:15:00',1.77),('3355','2013-05-19','10:20:00',1.32),('3355','2013-05-19','10:25:00',1.42),('3355','2013-05-19','10:30:00',1.52),('3355','2013-05-19','10:40:00',1.05),('3355','2013-05-19','10:45:00',1.16),('3355','2013-05-19','11:00:00',1.02),('3355','2013-05-19','11:05:00',1.81),('3355','2013-05-19','11:10:00',1.51),('3355','2013-05-19','11:15:00',1.69),('3355','2013-05-19','11:20:00',2.36),('3355','2013-05-19','11:25:00',2.41),('3355','2013-05-19','11:30:00',2.37),('3355','2013-05-19','11:35:00',2.38),('3355','2013-05-19','11:40:00',2.47),('3355','2013-05-19','11:45:00',2.49),('3355','2013-05-19','11:50:00',2.48),('3355','2013-05-19','11:55:00',2.49),('3355','2013-05-19','12:00:00',2.5),('3355','2013-05-19','12:05:00',2.49),('3355','2013-05-19','12:10:00',2.5),('3355','2013-05-19','12:15:00',2.51),('3355','2013-05-19','12:20:00',2.64),('3355','2013-05-19','12:25:00',2.85),('3355','2013-05-19','12:30:00',2.42),('3355','2013-05-19','12:35:00',2.79),('3355','2013-05-19','12:40:00',2.78),('3355','2013-05-19','12:45:00',2.66),('3355','2013-05-19','12:50:00',1.95),('3355','2013-05-19','12:55:00',1.59),('3355','2013-05-19','13:00:00',2.26),('3355','2013-05-19','13:05:00',2.23),('3355','2013-05-19','13:10:00',2.02),('3355','2013-05-19','13:15:00',2),('3355','2013-05-19','13:20:00',2.26),('3355','2013-05-19','13:25:00',2.31),('3355','2013-05-19','13:30:00',2.54),('3355','2013-05-19','13:35:00',2.53),('3355','2013-05-19','13:40:00',2.5),('3355','2013-05-19','13:45:00',2.5),('3355','2013-05-19','13:50:00',2.5),('3355','2013-05-19','13:55:00',2.5),('3355','2013-05-19','14:00:00',2.49),('3355','2013-05-19','14:05:00',2.48),('3355','2013-05-19','14:10:00',2.46),('3355','2013-05-19','14:15:00',2.47),('3355','2013-05-19','14:20:00',2.46),('3355','2013-05-19','14:25:00',2.46),('3355','2013-05-19','14:30:00',2.46),('3355','2013-05-19','14:35:00',2.44),('3355','2013-05-19','14:40:00',2.43),('3355','2013-05-19','14:45:00',2.4),('3355','2013-05-19','14:50:00',2.39),('3355','2013-05-19','14:55:00',2.37),('3355','2013-05-19','15:00:00',2.37),('3355','2013-05-19','15:05:00',2.36),('3355','2013-05-19','15:10:00',2.32),('3355','2013-05-19','15:15:00',2.3),('3355','2013-05-19','15:20:00',2.27),('3355','2013-05-19','15:25:00',2.27),('3355','2013-05-19','15:30:00',2.24),('3355','2013-05-19','15:35:00',2.22),('3355','2013-05-19','15:40:00',2.16),('3355','2013-05-19','15:45:00',2.13),('3355','2013-05-19','15:50:00',2.11),('3355','2013-05-19','15:55:00',2.1),('3355','2013-05-19','16:00:00',2.05),('3355','2013-05-19','16:05:00',2.04),('3355','2013-05-19','16:10:00',2),('3355','2013-05-19','16:15:00',1.97),('3355','2013-05-19','16:20:00',1.93),('3355','2013-05-19','16:25:00',1.92),('3355','2013-05-19','16:30:00',1.86),('3355','2013-05-19','16:35:00',1.83),('3355','2013-05-19','16:40:00',1.8),('3355','2013-05-19','16:45:00',1.76),('3355','2013-05-19','16:50:00',1.72),('3355','2013-05-19','16:55:00',1.68),('3355','2013-05-19','17:00:00',1.64),('3355','2013-05-19','17:05:00',1.6),('3355','2013-05-19','17:10:00',1.55),('3355','2013-05-19','17:15:00',1.51),('3355','2013-05-19','17:20:00',1.47),('3355','2013-05-19','17:25:00',1.41),('3355','2013-05-19','17:30:00',1.36),('3355','2013-05-19','17:35:00',1.32),('3355','2013-05-19','17:40:00',1.27),('3355','2013-05-19','17:45:00',1.21),('3355','2013-05-19','17:50:00',1.17),('3355','2013-05-19','17:55:00',1.11),('3355','2013-05-19','18:00:00',1.05),('3355','2013-05-19','18:05:00',1.01),('3355','2013-05-18','08:25:00',1.22),('3355','2013-05-18','08:30:00',1.1),('3355','2013-05-18','08:40:00',1.07),('3355','2013-05-18','08:45:00',1.09),('3355','2013-05-18','08:50:00',1.14),('3355','2013-05-18','08:55:00',1.19),('3355','2013-05-18','09:00:00',1.25),('3355','2013-05-18','09:05:00',1.27),('3355','2013-05-18','09:10:00',1.34),('3355','2013-05-18','09:15:00',1.39),('3355','2013-05-18','09:20:00',1.42),('3355','2013-05-18','09:25:00',1.45),('3355','2013-05-18','09:30:00',1.5),('3355','2013-05-18','09:35:00',1.54),('3355','2013-05-18','09:40:00',1.57),('3355','2013-05-18','09:45:00',1.61),('3355','2013-05-18','09:50:00',1.64),('3355','2013-05-18','09:55:00',1.69),('3355','2013-05-18','10:00:00',1.72),('3355','2013-05-18','10:05:00',1.75),('3355','2013-05-18','10:10:00',1.8),('3355','2013-05-18','10:15:00',1.82),('3355','2013-05-18','10:20:00',1.85),('3355','2013-05-18','10:25:00',1.87),('3355','2013-05-18','10:30:00',1.9),('3355','2013-05-18','10:35:00',1.91),('3355','2013-05-18','10:40:00',1.94),('3355','2013-05-18','10:45:00',1.97),('3355','2013-05-18','10:50:00',2),('3355','2013-05-18','10:55:00',2.06),('3355','2013-05-18','11:00:00',2.15),('3355','2013-05-18','11:05:00',2.17),('3355','2013-05-18','11:10:00',1.7),('3355','2013-05-18','11:15:00',2.23),('3355','2013-05-18','11:20:00',2.25),('3355','2013-05-18','11:25:00',2.12),('3355','2013-05-18','11:30:00',2.25),('3355','2013-05-18','11:35:00',2.05),('3355','2013-05-18','11:40:00',2.17),('3355','2013-05-18','11:45:00',2.16),('3355','2013-05-18','11:50:00',2.13),('3355','2013-05-18','11:55:00',2.16),('3355','2013-05-18','12:00:00',2.31),('3355','2013-05-18','12:05:00',2.16),('3355','2013-05-18','12:10:00',2.2),('3355','2013-05-18','12:15:00',2.21),('3355','2013-05-18','12:20:00',2.24),('3355','2013-05-18','12:25:00',2.25),('3355','2013-05-18','12:30:00',1.75),('3355','2013-05-18','12:35:00',2.31),('3355','2013-05-18','12:40:00',2.29),('3355','2013-05-18','12:45:00',2.19),('3355','2013-05-18','12:50:00',2.27),('3355','2013-05-18','12:55:00',2.25),('3355','2013-05-18','13:00:00',2.24),('3355','2013-05-18','13:05:00',2.26),('3355','2013-05-18','13:10:00',2.28),('3355','2013-05-18','13:15:00',2.27),('3355','2013-05-18','13:20:00',2.27),('3355','2013-05-18','13:25:00',2.27),('3355','2013-05-18','13:30:00',2.3),('3355','2013-05-18','13:35:00',2.09),('3355','2013-05-18','13:40:00',2.33),('3355','2013-05-18','13:45:00',2.4),('3355','2013-05-18','13:50:00',2.02),('3355','2013-05-18','13:55:00',1.89),('3355','2013-05-18','14:00:00',1.93),('3355','2013-05-18','14:05:00',1.82),('3355','2013-05-18','14:10:00',2.38),('3355','2013-05-18','14:15:00',2.36),('3355','2013-05-18','14:20:00',2.29),('3355','2013-05-18','14:25:00',2.22),('3355','2013-05-18','14:30:00',2.27),('3355','2013-05-18','14:35:00',2),('3355','2013-05-18','14:40:00',2.34),('3355','2013-05-18','14:45:00',2.23),('3355','2013-05-18','14:50:00',1.81),('3355','2013-05-18','14:55:00',1.9),('3355','2013-05-18','15:00:00',1.98),('3355','2013-05-18','15:05:00',2.03),('3355','2013-05-18','15:10:00',1.99),('3355','2013-05-18','15:15:00',1.96),('3355','2013-05-18','15:20:00',1.93),('3355','2013-05-18','15:25:00',1.91),('3355','2013-05-18','15:30:00',1.89),('3355','2013-05-18','15:35:00',1.87),('3355','2013-05-18','15:40:00',1.84),('3355','2013-05-18','15:45:00',1.79),('3355','2013-05-18','15:50:00',1.77),('3355','2013-05-18','15:55:00',1.74),('3355','2013-05-18','16:00:00',1.71),('3355','2013-05-18','16:05:00',1.69),('3355','2013-05-18','16:10:00',1.66),('3355','2013-05-18','16:15:00',1.61),('3355','2013-05-18','16:20:00',1.59),('3355','2013-05-18','16:25:00',1.55),('3355','2013-05-18','16:30:00',1.52),('3355','2013-05-18','16:35:00',1.48),('3355','2013-05-18','16:40:00',1.45),('3355','2013-05-18','16:45:00',1.42),('3355','2013-05-18','16:50:00',1.37),('3355','2013-05-18','16:55:00',1.33),('3355','2013-05-18','17:00:00',1.3),('3355','2013-05-18','17:05:00',1.26),('3355','2013-05-18','17:10:00',1.23),('3355','2013-05-18','17:15:00',1.19),('3355','2013-05-18','17:20:00',1.15),('3355','2013-05-18','17:25:00',1.11),('3355','2013-05-18','17:30:00',1.04),('3355','2013-05-17','08:20:00',1.06),('3355','2013-05-17','10:50:00',1.3),('3355','2013-05-17','10:55:00',1.56),('3355','2013-05-17','11:00:00',1.19),('3355','2013-05-17','11:05:00',1.16),('3355','2013-05-17','11:15:00',1.01),('3355','2013-05-17','11:20:00',1.08),('3355','2013-05-17','11:30:00',1.24),('3355','2013-05-17','11:35:00',1.94),('3355','2013-05-17','11:55:00',1.1),('3355','2013-05-17','12:05:00',1.58),('3355','2013-05-17','12:10:00',1.71),('3355','2013-05-17','12:15:00',1.63),('3355','2013-05-17','12:20:00',1.01),('3355','2013-05-17','12:25:00',2.03),('3355','2013-05-17','12:30:00',1.54),('3355','2013-05-17','12:35:00',1.49),('3355','2013-05-17','12:40:00',2.6),('3355','2013-05-17','12:45:00',2.08),('3355','2013-05-17','12:50:00',2.49),('3355','2013-05-17','12:55:00',2.53),('3355','2013-05-17','13:00:00',2.08),('3355','2013-05-17','13:05:00',2.15),('3355','2013-05-17','13:10:00',1.9),('3355','2013-05-17','13:15:00',2.41),('3355','2013-05-17','13:20:00',2.41),('3355','2013-05-17','13:25:00',2.29),('3355','2013-05-17','13:30:00',1.56),('3355','2013-05-17','13:35:00',2.23),('3355','2013-05-17','13:40:00',2.01),('3355','2013-05-17','13:45:00',2.52),('3355','2013-05-17','13:50:00',2.52),('3355','2013-05-17','13:55:00',2.29),('3355','2013-05-17','14:00:00',2.06),('3355','2013-05-17','14:05:00',1.42),('3355','2013-05-17','14:10:00',2.12),('3355','2013-05-17','14:15:00',2.36),('3355','2013-05-17','14:20:00',2.63),('3355','2013-05-17','14:25:00',2.09),('3355','2013-05-17','14:30:00',2.14),('3355','2013-05-17','14:35:00',2.04),('3355','2013-05-17','14:40:00',1.34),('3355','2013-05-17','14:45:00',2.36),('3355','2013-05-17','14:50:00',1.52),('3355','2013-05-17','14:55:00',1.78),('3355','2013-05-17','15:00:00',2.03),('3355','2013-05-17','15:05:00',1.56),('3355','2013-05-17','15:10:00',1.04),('3355','2013-05-17','15:15:00',1.6),('3355','2013-05-17','15:20:00',1.32),('3355','2013-05-17','15:25:00',1.93),('3355','2013-05-17','15:30:00',1.73),('3355','2013-05-17','15:35:00',1.99),('3355','2013-05-17','15:40:00',1.99),('3355','2013-05-17','15:45:00',1.11),('3355','2013-05-17','15:50:00',1.39),('3355','2013-05-17','15:55:00',1.61),('3355','2013-05-17','16:15:00',1.86),('3355','2013-05-17','16:20:00',1.94),('3355','2013-05-17','16:25:00',1.89),('3355','2013-05-17','16:30:00',1.82),('3355','2013-05-17','16:35:00',1.72),('3355','2013-05-17','16:40:00',1.97),('3355','2013-05-17','16:45:00',1.76),('3355','2013-05-17','16:50:00',1.7),('3355','2013-05-17','16:55:00',1.61),('3355','2013-05-17','17:00:00',1.57),('3355','2013-05-17','17:05:00',1.53),('3355','2013-05-17','17:10:00',1.49),('3355','2013-05-17','17:15:00',1.45),('3355','2013-05-17','17:20:00',1.41),('3355','2013-05-17','17:25:00',1.35),('3355','2013-05-17','17:30:00',1.31),('3355','2013-05-17','17:35:00',1.26),('3355','2013-05-17','17:40:00',1.21),('3355','2013-05-17','17:45:00',1.16),('3355','2013-05-17','17:50:00',1.11),('3355','2013-05-17','17:55:00',1.06),('3355','2013-05-17','18:00:00',1.03),('3355','2013-05-16','09:40:00',1.08),('3355','2013-05-16','09:45:00',1.33),('3355','2013-05-16','10:20:00',1.15),('3355','2013-05-16','10:25:00',1.39),('3355','2013-05-16','10:30:00',1.05),('3355','2013-05-16','10:55:00',1.02),('3355','2013-05-16','11:00:00',2.18),('3355','2013-05-16','11:05:00',1.85),('3355','2013-05-16','11:10:00',1.44),('3355','2013-05-16','11:35:00',1.3),('3355','2013-05-16','11:40:00',2.19),('3355','2013-05-16','11:45:00',2.11),('3355','2013-05-16','11:50:00',1.94),('3355','2013-05-16','11:55:00',1.22),('3355','2013-05-16','12:15:00',1.53),('3355','2013-05-16','12:20:00',1.06),('3355','2013-05-16','12:25:00',1.26),('3355','2013-05-16','12:30:00',1.74),('3355','2013-05-16','12:35:00',1.88),('3355','2013-05-16','12:40:00',1.79),('3355','2013-05-16','12:45:00',1.73),('3355','2013-05-16','12:50:00',1.47),('3355','2013-05-16','12:55:00',2.44),('3355','2013-05-16','13:00:00',2.28),('3355','2013-05-16','13:05:00',2),('3355','2013-05-16','13:10:00',2.27),('3355','2013-05-16','13:15:00',2.17),('3355','2013-05-16','13:20:00',2.33),('3355','2013-05-16','13:25:00',2.27),('3355','2013-05-16','13:30:00',2.24),('3355','2013-05-16','13:35:00',2.23),('3355','2013-05-16','13:40:00',2.2),('3355','2013-05-16','13:45:00',2.2),('3355','2013-05-16','13:50:00',2.18),('3355','2013-05-16','13:55:00',2.2),('3355','2013-05-16','14:00:00',2.18),('3355','2013-05-16','14:05:00',2.18),('3355','2013-05-16','14:10:00',2.16),('3355','2013-05-16','14:15:00',2.13),('3355','2013-05-16','14:20:00',2.14),('3355','2013-05-16','14:25:00',2.08),('3355','2013-05-16','14:30:00',2.08),('3355','2013-05-16','14:35:00',2.05),('3355','2013-05-16','14:40:00',2.04),('3355','2013-05-16','14:45:00',2.04),('3355','2013-05-16','14:50:00',1.93),('3355','2013-05-16','14:55:00',1.71),('3355','2013-05-16','15:00:00',1.96),('3355','2013-05-16','15:05:00',1.99),('3355','2013-05-16','15:10:00',1.97),('3355','2013-05-16','15:15:00',1.75),('3355','2013-05-16','15:20:00',1.89),('3355','2013-05-16','15:25:00',1.89),('3355','2013-05-16','15:30:00',1.84),('3355','2013-05-16','15:35:00',1.78),('3355','2013-05-16','15:40:00',1.83),('3355','2013-05-16','15:45:00',1.77),('3355','2013-05-16','15:50:00',1.76),('3355','2013-05-16','15:55:00',1.75),('3355','2013-05-16','16:00:00',1.73),('3355','2013-05-16','16:05:00',1.66),('3355','2013-05-16','16:10:00',1.64),('3355','2013-05-16','16:15:00',1.55),('3355','2013-05-16','16:20:00',1.61),('3355','2013-05-16','16:25:00',1.54),('3355','2013-05-16','16:30:00',1.54),('3355','2013-05-16','16:35:00',1.48),('3355','2013-05-16','16:50:00',1.18),('3355','2013-05-16','17:35:00',1.06),('3355','2013-05-15','08:40:00',1.02),('3355','2013-05-15','08:45:00',1.07),('3355','2013-05-15','08:50:00',1.13),('3355','2013-05-15','08:55:00',1.17),('3355','2013-05-15','09:00:00',1.14),('3355','2013-05-15','09:05:00',1.25),('3355','2013-05-15','09:10:00',1.24),('3355','2013-05-15','09:15:00',1.3),('3355','2013-05-15','09:20:00',1.3),('3355','2013-05-15','09:25:00',1.08),('3355','2013-05-15','09:30:00',1.44),('3355','2013-05-15','09:35:00',1.49),('3355','2013-05-15','09:40:00',1.48),('3355','2013-05-15','09:45:00',1.53),('3355','2013-05-15','09:50:00',1.59),('3355','2013-05-15','09:55:00',1.6),('3355','2013-05-15','10:00:00',1.65),('3355','2013-05-15','10:05:00',1.69),('3355','2013-05-15','10:10:00',1.75),('3355','2013-05-15','10:15:00',1.71),('3355','2013-05-15','10:20:00',1.79),('3355','2013-05-15','10:25:00',1.84),('3355','2013-05-15','10:30:00',1.79),('3355','2013-05-15','10:35:00',1.84),('3355','2013-05-15','10:40:00',1.91),('3355','2013-05-15','10:45:00',1.94),('3355','2013-05-15','10:50:00',1.95),('3355','2013-05-15','10:55:00',1.89),('3355','2013-05-15','11:00:00',1.92),('3355','2013-05-15','11:05:00',2.03),('3355','2013-05-15','11:10:00',2.02),('3355','2013-05-15','11:15:00',2.07),('3355','2013-05-15','11:20:00',1.97),('3355','2013-05-15','11:25:00',2.05),('3355','2013-05-15','11:30:00',2.17),('3355','2013-05-15','11:35:00',2.03),('3355','2013-05-15','11:40:00',1.78),('3355','2013-05-15','11:45:00',1.56),('3355','2013-05-15','11:50:00',1.45),('3355','2013-05-15','11:55:00',1.03),('3355','2013-05-15','12:00:00',1.12),('3355','2013-05-15','12:05:00',1.85),('3355','2013-05-15','12:10:00',2.45),('3355','2013-05-15','12:15:00',2.37),('3355','2013-05-15','12:20:00',1.43),('3355','2013-05-15','12:25:00',1.84),('3355','2013-05-15','12:30:00',1.54),('3355','2013-05-15','12:35:00',1.49),('3355','2013-05-15','12:40:00',2.56),('3355','2013-05-15','12:45:00',1.35),('3355','2013-05-15','12:50:00',1.34),('3355','2013-05-15','12:55:00',1.51),('3355','2013-05-15','13:00:00',1.56),('3355','2013-05-15','13:05:00',1.7),('3355','2013-05-15','13:10:00',1.67),('3355','2013-05-15','13:15:00',1.24),('3355','2013-05-15','13:20:00',1.52),('3355','2013-05-15','13:25:00',1.44),('3355','2013-05-15','13:30:00',1.52),('3355','2013-05-15','13:35:00',1.34),('3355','2013-05-15','13:40:00',1.39),('3355','2013-05-15','13:45:00',1.39),('3355','2013-05-15','13:50:00',1.16),('3355','2013-05-15','13:55:00',1.11),('3355','2013-05-15','15:55:00',1.04),('3355','2013-05-15','16:00:00',1.04),('3355','2013-05-15','17:05:00',1.1),('3355','2013-05-15','17:10:00',1.06),('3355','2013-05-15','17:15:00',1.48),('3355','2013-05-15','17:20:00',1.27),('3355','2013-05-14','08:35:00',1.03),('3355','2013-05-14','08:40:00',1.08),('3355','2013-05-14','08:45:00',1.13),('3355','2013-05-14','08:50:00',1.17),('3355','2013-05-14','08:55:00',1.23),('3355','2013-05-14','09:00:00',1.27),('3355','2013-05-14','09:05:00',1.32),('3355','2013-05-14','09:10:00',1.36),('3355','2013-05-14','09:15:00',1.41),('3355','2013-05-14','09:20:00',1.45),('3355','2013-05-14','09:25:00',1.49),('3355','2013-05-14','09:30:00',1.53),('3355','2013-05-14','09:35:00',1.57),('3355','2013-05-14','09:40:00',1.61),('3355','2013-05-14','09:45:00',1.64),('3355','2013-05-14','09:50:00',1.69),('3355','2013-05-14','09:55:00',1.73),('3355','2013-05-14','10:00:00',1.76),('3355','2013-05-14','10:05:00',1.8),('3355','2013-05-14','10:10:00',1.82),('3355','2013-05-14','10:15:00',1.85),('3355','2013-05-14','10:20:00',1.9),('3355','2013-05-14','10:25:00',1.91),('3355','2013-05-14','10:30:00',1.94),('3355','2013-05-14','10:35:00',1.96),('3355','2013-05-14','10:40:00',1.99),('3355','2013-05-14','10:45:00',2.01),('3355','2013-05-14','10:50:00',2.05),('3355','2013-05-14','10:55:00',2.07),('3355','2013-05-14','11:00:00',2.09),('3355','2013-05-14','11:05:00',2.11),('3355','2013-05-14','11:10:00',2.13),('3355','2013-05-14','11:15:00',2.14),('3355','2013-05-14','11:20:00',2.15),('3355','2013-05-14','11:25:00',2.16),('3355','2013-05-14','11:30:00',2.2),('3355','2013-05-14','11:35:00',2.22),('3355','2013-05-14','11:40:00',2.22),('3355','2013-05-14','11:45:00',2.25),('3355','2013-05-14','11:50:00',2.26),('3355','2013-05-14','11:55:00',2.28),('3355','2013-05-14','12:00:00',2.28),('3355','2013-05-14','12:05:00',2.29),('3355','2013-05-14','12:10:00',2.29),('3355','2013-05-14','12:15:00',2.3),('3355','2013-05-14','12:20:00',2.31),('3355','2013-05-14','12:25:00',2.34),('3355','2013-05-14','12:30:00',2.36),('3355','2013-05-14','12:35:00',2.35),('3355','2013-05-14','12:40:00',2.35),('3355','2013-05-14','12:45:00',2.35),('3355','2013-05-14','12:50:00',2.35),('3355','2013-05-14','12:55:00',2.36),('3355','2013-05-14','13:00:00',2.36),('3355','2013-05-14','13:05:00',2.35),('3355','2013-05-14','13:10:00',2.37),('3355','2013-05-14','13:15:00',2.37),('3355','2013-05-14','13:20:00',2.36),('3355','2013-05-14','13:25:00',2.34),('3355','2013-05-14','13:30:00',2.34),('3355','2013-05-14','13:35:00',2.34),('3355','2013-05-14','13:40:00',2.34),('3355','2013-05-14','13:45:00',2.33),('3355','2013-05-14','13:50:00',2.32),('3355','2013-05-14','13:55:00',2.3),('3355','2013-05-14','14:00:00',2.31),('3355','2013-05-14','14:05:00',2.31),('3355','2013-05-14','14:10:00',2.3),('3355','2013-05-14','14:15:00',2.29),('3355','2013-05-14','14:20:00',2.27),('3355','2013-05-14','14:25:00',2.25),('3355','2013-05-14','14:30:00',2.24),('3355','2013-05-14','14:35:00',2.23),('3355','2013-05-14','14:40:00',2.23),('3355','2013-05-14','14:45:00',2.24),('3355','2013-05-14','14:50:00',2.25),('3355','2013-05-14','14:55:00',2.24),('3355','2013-05-14','15:00:00',2.24),('3355','2013-05-14','15:05:00',2.24),('3355','2013-05-14','15:10:00',2.23),('3355','2013-05-14','15:15:00',2.21),('3355','2013-05-14','15:20:00',2.19),('3355','2013-05-14','15:25:00',2.18),('3355','2013-05-14','15:30:00',2.15),('3355','2013-05-14','15:35:00',2.12),('3355','2013-05-14','15:40:00',2.09),('3355','2013-05-14','15:45:00',2.07),('3355','2013-05-14','15:50:00',2.04),('3355','2013-05-14','15:55:00',2.01),('3355','2013-05-14','16:00:00',1.98),('3355','2013-05-14','16:05:00',1.95),('3355','2013-05-14','16:10:00',1.92),('3355','2013-05-14','16:15:00',1.89),('3355','2013-05-14','16:20:00',1.85),('3355','2013-05-14','16:25:00',1.82),('3355','2013-05-14','16:30:00',1.77),('3355','2013-05-14','16:35:00',1.74),('3355','2013-05-14','16:40:00',1.7),('3355','2013-05-14','16:45:00',1.66),('3355','2013-05-14','16:50:00',1.63),('3355','2013-05-14','16:55:00',1.59),('3355','2013-05-14','17:00:00',1.54),('3355','2013-05-14','17:05:00',1.5),('3355','2013-05-14','17:10:00',1.45),('3355','2013-05-14','17:15:00',1.41),('3355','2013-05-14','17:20:00',1.36),('3355','2013-05-14','17:25:00',1.31),('3355','2013-05-14','17:30:00',1.26),('3355','2013-05-14','17:35:00',1.21),('3355','2013-05-14','17:40:00',1.16),('3355','2013-05-14','17:45:00',1.12),('3355','2013-05-14','17:50:00',1.07),('3355','2013-05-14','17:55:00',1),('3355','2013-05-13','08:45:00',1.04),('3355','2013-05-13','08:50:00',1.09),('3355','2013-05-13','08:55:00',1.14),('3355','2013-05-13','09:00:00',1.18),('3355','2013-05-13','09:05:00',1.22),('3355','2013-05-13','09:10:00',1.27),('3355','2013-05-13','09:15:00',1.31),('3355','2013-05-13','09:20:00',1.38),('3355','2013-05-13','09:25:00',1.41),('3355','2013-05-13','09:30:00',1.46),('3355','2013-05-13','09:35:00',1.49),('3355','2013-05-13','09:40:00',1.54),('3355','2013-05-13','09:45:00',1.57),('3355','2013-05-13','09:50:00',1.66),('3355','2013-05-13','09:55:00',1.72),('3355','2013-05-13','10:00:00',1.75),('3355','2013-05-13','10:05:00',1.78),('3355','2013-05-13','10:10:00',1.82),('3355','2013-05-13','10:15:00',1.92),('3355','2013-05-13','10:20:00',1.96),('3355','2013-05-13','10:25:00',1.46),('3355','2013-05-13','10:30:00',1.95),('3355','2013-05-13','10:45:00',1.86),('3355','2013-05-13','10:50:00',1.89),('3355','2013-05-13','10:55:00',1.08),('3355','2013-05-13','11:00:00',1.6),('3355','2013-05-13','11:05:00',1.27),('3355','2013-05-13','11:15:00',1.44),('3355','2013-05-13','11:25:00',1.09),('3355','2013-05-13','11:30:00',1.56),('3355','2013-05-13','11:35:00',1.34),('3355','2013-05-13','11:40:00',1.14),('3355','2013-05-13','11:45:00',1.44),('3355','2013-05-13','12:10:00',1.48),('3355','2013-05-13','12:15:00',1.68),('3355','2013-05-13','12:30:00',1.71),('3355','2013-05-13','12:35:00',2.02),('3355','2013-05-13','12:40:00',1.15),('3355','2013-05-13','12:45:00',1.4),('3355','2013-05-13','12:50:00',1.53),('3355','2013-05-13','12:55:00',2.7),('3355','2013-05-13','13:00:00',2.66),('3355','2013-05-13','13:05:00',1.53),('3355','2013-05-13','13:10:00',2.28),('3355','2013-05-13','13:15:00',2.64),('3355','2013-05-13','13:20:00',2.23),('3355','2013-05-13','13:25:00',2.64),('3355','2013-05-13','13:30:00',2.64),('3355','2013-05-13','13:35:00',2.08),('3355','2013-05-13','13:40:00',1.49),('3355','2013-05-13','14:05:00',1.48),('3355','2013-05-13','14:10:00',2.73),('3355','2013-05-13','14:15:00',2.59),('3355','2013-05-13','14:20:00',2.42),('3355','2013-05-13','14:25:00',1.1),('3355','2013-05-13','14:35:00',2.21),('3355','2013-05-13','14:40:00',2.52),('3355','2013-05-13','14:45:00',1.69),('3355','2013-05-13','14:55:00',2.55),('3355','2013-05-13','15:00:00',2.37),('3355','2013-05-13','15:05:00',1.31),('3355','2013-05-13','16:10:00',1.11),('3355','2013-05-13','16:40:00',1.06),('3355','2013-05-13','16:45:00',1.49),('3355','2013-05-13','16:50:00',2.01),('3355','2013-05-13','16:55:00',1.85),('3355','2013-05-13','17:00:00',1.73),('3355','2013-05-13','17:05:00',1.47),('3355','2013-05-13','17:10:00',1.17),('3355','2013-05-13','17:15:00',1.66),('3355','2013-05-13','17:20:00',1.76),('3355','2013-05-13','17:25:00',1.6),('3355','2013-05-13','17:30:00',1.23),('3355','2013-05-13','17:35:00',1.39),('3355','2013-05-13','17:40:00',1.26),('3355','2013-05-13','17:45:00',1.12),('3355','2013-05-13','17:50:00',1.02),('3355','2013-05-12','09:25:00',1.09),('3355','2013-05-12','09:30:00',1.55),('3355','2013-05-12','09:40:00',1.12),('3355','2013-05-12','09:45:00',2.01),('3355','2013-05-12','09:50:00',1.84),('3355','2013-05-12','09:55:00',1.82),('3355','2013-05-12','10:00:00',1.75),('3355','2013-05-12','10:05:00',1.12),('3355','2013-05-12','10:55:00',2.46),('3355','2013-05-12','11:00:00',1.13),('3355','2013-05-12','11:15:00',1.01),('3355','2013-05-12','11:20:00',1.43),('3355','2013-05-12','11:25:00',1.57),('3355','2013-05-12','11:30:00',2.54),('3355','2013-05-12','11:35:00',1.96),('3355','2013-05-12','11:40:00',2.47),('3355','2013-05-12','11:45:00',2.52),('3355','2013-05-12','11:50:00',2.27),('3355','2013-05-12','11:55:00',1.97),('3355','2013-05-12','12:00:00',1.19),('3355','2013-05-12','12:05:00',1.55),('3355','2013-05-12','12:10:00',2.75),('3355','2013-05-12','12:15:00',1.55),('3355','2013-05-12','12:45:00',1.49),('3355','2013-05-12','12:50:00',2.83),('3355','2013-05-12','12:55:00',1.08),('3355','2013-05-12','13:10:00',1.32),('3355','2013-05-12','13:15:00',1.45),('3355','2013-05-12','13:25:00',1.26),('3355','2013-05-12','13:30:00',2.36),('3355','2013-05-12','13:35:00',2.55),('3355','2013-05-12','13:40:00',1.96),('3355','2013-05-12','13:45:00',2.79),('3355','2013-05-12','13:50:00',1.64),('3355','2013-05-12','13:55:00',2.17),('3355','2013-05-12','14:00:00',1.29),('3355','2013-05-12','14:05:00',2.81),('3355','2013-05-12','14:10:00',1.7),('3355','2013-05-12','14:15:00',2.39),('3355','2013-05-12','14:20:00',2.56),('3355','2013-05-12','14:25:00',2.54),('3355','2013-05-12','14:30:00',2.5),('3355','2013-05-12','14:35:00',2.39),('3355','2013-05-12','14:40:00',2.14),('3355','2013-05-12','14:45:00',2.42),('3355','2013-05-12','14:50:00',2.21),('3355','2013-05-12','14:55:00',2.39),('3355','2013-05-12','15:00:00',2.38),('3355','2013-05-12','15:05:00',2.35),('3355','2013-05-12','15:10:00',2.36),('3355','2013-05-12','15:15:00',2.35),('3355','2013-05-12','15:20:00',2.04),('3355','2013-05-12','15:25:00',1.78),('3355','2013-05-12','15:30:00',1.85),('3355','2013-05-12','15:35:00',2.15),('3355','2013-05-12','15:40:00',2.11),('3355','2013-05-12','15:45:00',2.07),('3355','2013-05-12','15:50:00',2.02),('3355','2013-05-12','15:55:00',2),('3355','2013-05-12','16:00:00',1.96),('3355','2013-05-12','16:05:00',1.92),('3355','2013-05-12','16:10:00',1.89),('3355','2013-05-12','16:15:00',1.86),('3355','2013-05-12','16:20:00',1.84),('3355','2013-05-12','16:25:00',1.79),('3355','2013-05-12','16:30:00',1.76),('3355','2013-05-12','16:35:00',1.74),('3355','2013-05-12','16:40:00',1.75),('3355','2013-05-12','16:45:00',1.82),('3355','2013-05-12','16:50:00',1.76),('3355','2013-05-12','16:55:00',1.85),('3355','2013-05-12','17:00:00',1.94),('3355','2013-05-12','17:05:00',1.71),('3355','2013-05-12','17:10:00',1.7),('3355','2013-05-12','17:15:00',1.79),('3355','2013-05-12','17:20:00',1.64),('3355','2013-05-12','17:25:00',1.3),('3355','2013-05-12','17:30:00',1.31),('3355','2013-05-12','17:40:00',1.16),('3355','2014-03-31','09:15:00',1.04),('3355','2014-03-31','09:20:00',1.09),('3355','2014-03-31','09:25:00',1.14),('3355','2014-03-31','09:30:00',1.19),('3355','2014-03-31','09:35:00',1.24),('3355','2014-03-31','09:40:00',1.28),('3355','2014-03-31','09:45:00',1.32),('3355','2014-03-31','09:50:00',1.36),('3355','2014-03-31','09:55:00',1.4),('3355','2014-03-31','10:00:00',1.44),('3355','2014-03-31','10:05:00',1.49),('3355','2014-03-31','10:10:00',1.53),('3355','2014-03-31','10:15:00',1.57),('3355','2014-03-31','10:20:00',1.61),('3355','2014-03-31','10:25:00',1.64),('3355','2014-03-31','10:30:00',1.66),('3355','2014-03-31','10:35:00',1.7),('3355','2014-03-31','10:40:00',1.73),('3355','2014-03-31','10:45:00',1.77),('3355','2014-03-31','10:50:00',1.81),('3355','2014-03-31','10:55:00',1.85),('3355','2014-03-31','11:00:00',1.87),('3355','2014-03-31','11:05:00',1.9),('3355','2014-03-31','11:10:00',1.92),('3355','2014-03-31','11:15:00',1.95),('3355','2014-03-31','11:20:00',1.98),('3355','2014-03-31','11:25:00',2),('3355','2014-03-31','11:30:00',2),('3355','2014-03-31','11:35:00',2.02),('3355','2014-03-31','11:40:00',2.05),('3355','2014-03-31','11:45:00',2.06),('3355','2014-03-31','11:50:00',2.07),('3355','2014-03-31','11:55:00',2.1),('3355','2014-03-31','12:00:00',2.15),('3355','2014-03-31','12:05:00',2.15),('3355','2014-03-31','12:10:00',2.15),('3355','2014-03-31','12:15:00',2.15),('3355','2014-03-31','12:20:00',2.18),('3355','2014-03-31','12:25:00',2.19),('3355','2014-03-31','12:30:00',2.2),('3355','2014-03-31','12:35:00',2.21),('3355','2014-03-31','12:40:00',2.23),('3355','2014-03-31','12:45:00',2.24),('3355','2014-03-31','12:50:00',2.22),('3355','2014-03-31','12:55:00',2.22),('3355','2014-03-31','13:00:00',2.23),('3355','2014-03-31','13:05:00',2.25),('3355','2014-03-31','13:10:00',2.26),('3355','2014-03-31','13:15:00',2.25),('3355','2014-03-31','13:20:00',2.26),('3355','2014-03-31','13:25:00',2.26),('3355','2014-03-31','13:30:00',2.27),('3355','2014-03-31','13:35:00',2.28),('3355','2014-03-31','13:40:00',2.28),('3355','2014-03-31','13:45:00',2.28),('3355','2014-03-31','13:50:00',2.28),('3355','2014-03-31','13:55:00',2.27),('3355','2014-03-31','14:00:00',2.26),('3355','2014-03-31','14:05:00',2.26),('3355','2014-03-31','14:10:00',2.25),('3355','2014-03-31','14:15:00',2.25),('3355','2014-03-31','14:20:00',2.25),('3355','2014-03-31','14:25:00',2.24),('3355','2014-03-31','14:30:00',2.24),('3355','2014-03-31','14:35:00',2.22),('3355','2014-03-31','14:40:00',2.2),('3355','2014-03-31','14:45:00',2.2),('3355','2014-03-31','14:50:00',2.18),('3355','2014-03-31','14:55:00',2.15),('3355','2014-03-31','15:00:00',2.15),('3355','2014-03-31','15:05:00',2.13),('3355','2014-03-31','15:10:00',2.12),('3355','2014-03-31','15:15:00',2.09),('3355','2014-03-31','15:20:00',2.06),('3355','2014-03-31','15:25:00',2.02),('3355','2014-03-31','15:30:00',2),('3355','2014-03-31','15:35:00',1.97),('3355','2014-03-31','15:40:00',1.94),('3355','2014-03-31','15:45:00',1.92),('3355','2014-03-31','15:50:00',1.88),('3355','2014-03-31','15:55:00',1.84),('3355','2014-03-31','16:00:00',1.81),('3355','2014-03-31','16:05:00',1.77),('3355','2014-03-31','16:10:00',1.73),('3355','2014-03-31','16:15:00',1.69),('3355','2014-03-31','16:20:00',1.66),('3355','2014-03-31','16:25:00',1.62),('3355','2014-03-31','16:30:00',1.58),('3355','2014-03-31','16:35:00',1.53),('3355','2014-03-31','16:40:00',1.49),('3355','2014-03-31','16:45:00',1.45),('3355','2014-03-31','16:50:00',1.42),('3355','2014-03-31','16:55:00',1.36),('3355','2014-03-31','17:00:00',1.32),('3355','2014-03-31','17:05:00',1.26),('3355','2014-03-31','17:10:00',1.23),('3355','2014-03-31','17:15:00',1.17),('3355','2014-03-31','17:20:00',1.11),('3355','2014-03-31','17:25:00',1.06),('3355','2014-03-31','17:30:00',1),('3355','2013-05-11','09:35:00',1.52),('3355','2013-05-11','09:40:00',1.19),('3355','2013-05-11','09:45:00',1.54),('3355','2013-05-11','10:55:00',1.81),('3355','2013-05-11','11:00:00',1.35),('3355','2013-05-11','11:05:00',1.42),('3355','2013-05-11','11:35:00',1.43),('3355','2013-05-11','11:40:00',1.21),('3355','2013-05-11','11:45:00',2.05),('3355','2013-05-11','11:50:00',1.4),('3355','2013-05-11','12:25:00',2.27),('3355','2013-05-11','12:30:00',1.88),('3355','2013-05-11','12:40:00',1.05),('3355','2013-05-11','12:45:00',1.18),('3355','2013-05-11','12:50:00',1.26),('3355','2013-05-11','14:05:00',1.39),('3355','2013-05-11','14:10:00',1.87),('3355','2013-05-11','14:15:00',1.59),('3355','2013-05-11','14:20:00',2.58),('3355','2013-05-11','14:25:00',2.58),('3355','2013-05-11','14:30:00',1.87),('3355','2013-05-11','14:35:00',1.52),('3355','2013-05-11','14:40:00',2.68),('3355','2013-05-11','14:45:00',2.28),('3355','2013-05-11','14:50:00',2.53),('3355','2013-05-11','14:55:00',2.44),('3355','2013-05-11','15:00:00',2.36),('3355','2013-05-11','15:05:00',2.33),('3355','2013-05-11','15:10:00',2.04),('3355','2013-05-11','15:15:00',2.33),('3355','2013-05-11','15:20:00',2),('3355','2013-05-11','15:25:00',2.25),('3355','2013-05-11','15:30:00',2.21),('3355','2013-05-11','15:35:00',2.19),('3355','2013-05-11','15:40:00',2.17),('3355','2013-05-11','15:45:00',2.08),('3355','2013-05-11','15:50:00',2.23),('3355','2013-05-11','15:55:00',2.12),('3355','2013-05-11','16:00:00',1.15),('3355','2013-05-11','16:05:00',1.84),('3355','2013-05-11','16:10:00',1.79),('3355','2013-05-11','16:15:00',1.67),('3355','2013-05-11','16:20:00',1.63),('3355','2013-05-11','16:25:00',1.8),('3355','2013-05-11','16:30:00',1.89),('3355','2013-05-11','16:35:00',1.83),('3355','2013-05-11','16:40:00',1.6),('3355','2013-05-11','16:45:00',1.72),('3355','2013-05-11','16:50:00',1.62),('3355','2013-05-11','16:55:00',1.6),('3355','2013-05-11','17:00:00',1.44),('3355','2013-05-11','17:05:00',1.57),('3355','2013-05-11','17:10:00',1.48),('3355','2013-05-11','17:15:00',1.12),('3355','2013-05-11','17:20:00',1.37),('3355','2013-05-11','17:25:00',1.02),('3355','2013-05-11','17:35:00',1.3),('3355','2013-05-11','17:40:00',1.05),('3355','2013-05-11','17:45:00',1.3),('3355','2013-05-11','17:55:00',1.09),('3355','2013-05-11','18:10:00',1.11),('3355','2013-05-10','08:15:00',1.02),('3355','2013-05-10','09:05:00',1.11),('3355','2013-05-10','09:10:00',1.33),('3355','2013-05-10','09:15:00',1.38),('3355','2013-05-10','09:20:00',1.34),('3355','2013-05-10','09:25:00',1.26),('3355','2013-05-10','09:30:00',1.15),('3355','2013-05-10','09:35:00',1.46),('3355','2013-05-10','09:40:00',1.37),('3355','2013-05-10','09:45:00',1.33),('3355','2013-05-10','09:50:00',1.69),('3355','2013-05-10','09:55:00',1.71),('3355','2013-05-10','10:00:00',1.5),('3355','2013-05-10','10:05:00',1.76),('3355','2013-05-10','10:10:00',1.39),('3355','2013-05-10','10:15:00',1.29),('3355','2013-05-10','10:20:00',1.96),('3355','2013-05-10','10:30:00',1.05),('3355','2013-05-10','10:35:00',1.63),('3355','2013-05-10','10:40:00',2.06),('3355','2013-05-10','10:45:00',2.07),('3355','2013-05-10','10:50:00',2.13),('3355','2013-05-10','10:55:00',2.09),('3355','2013-05-10','11:00:00',2.15),('3355','2013-05-10','11:05:00',2.13),('3355','2013-05-10','11:10:00',2.08),('3355','2013-05-10','11:15:00',1.98),('3355','2013-05-10','11:20:00',2.31),('3355','2013-05-10','11:25:00',2.07),('3355','2013-05-10','11:30:00',1.78),('3355','2013-05-10','11:35:00',2.13),('3355','2013-05-10','11:40:00',1.7),('3355','2013-05-10','11:45:00',1.12),('3355','2013-05-10','11:50:00',1.53),('3355','2013-05-10','11:55:00',2.05),('3355','2013-05-10','12:00:00',2.29),('3355','2013-05-10','12:05:00',1.87),('3355','2013-05-10','12:10:00',1.61),('3355','2013-05-10','12:15:00',1.29),('3355','2013-05-10','12:20:00',1.49),('3355','2013-05-10','12:25:00',1.23),('3355','2013-05-10','12:30:00',1.13),('3355','2013-05-10','12:35:00',1.13),('3355','2013-05-10','12:40:00',2.01),('3355','2013-05-10','12:45:00',2.5),('3355','2013-05-10','12:50:00',1.97),('3355','2013-05-10','12:55:00',1.6),('3355','2013-05-10','13:00:00',2.31),('3355','2013-05-10','13:05:00',1.93),('3355','2013-05-10','13:10:00',2.09),('3355','2013-05-10','13:15:00',2.65),('3355','2013-05-10','13:20:00',1.82),('3355','2013-05-10','13:25:00',1.67),('3355','2013-05-10','13:30:00',1.8),('3355','2013-05-10','13:35:00',2.4),('3355','2013-05-10','13:40:00',2.34),('3355','2013-05-10','13:45:00',2.18),('3355','2013-05-10','13:50:00',1.38),('3355','2013-05-10','13:55:00',1.16),('3355','2013-05-10','14:00:00',1.06),('3355','2013-05-10','14:05:00',1.08),('3355','2013-05-10','14:10:00',1.28),('3355','2013-05-10','14:15:00',1.41),('3355','2013-05-10','14:20:00',1.42),('3355','2013-05-10','14:25:00',1.38),('3355','2013-05-10','14:30:00',1.4),('3355','2013-05-10','14:35:00',1.74),('3355','2013-05-10','14:40:00',1.56),('3355','2013-05-10','14:45:00',1.18),('3355','2013-05-10','15:15:00',1.5),('3355','2013-05-10','15:20:00',1.68),('3355','2013-05-10','15:25:00',1.14),('3355','2013-05-10','15:30:00',1.04),('3355','2013-05-10','15:35:00',1.09),('3355','2013-05-10','15:40:00',1.13),('3355','2013-05-10','15:45:00',1.09),('3355','2013-05-10','17:20:00',1.19),('3355','2013-05-10','17:25:00',1.16),('3355','2013-05-10','17:35:00',1.28),('3355','2013-05-09','08:40:00',1),('3355','2013-05-09','08:45:00',1.06),('3355','2013-05-09','08:50:00',1.1),('3355','2013-05-09','08:55:00',1.14),('3355','2013-05-09','09:00:00',1.2),('3355','2013-05-09','09:05:00',1.24),('3355','2013-05-09','09:10:00',1.29),('3355','2013-05-09','09:15:00',1.34),('3355','2013-05-09','09:20:00',1.38),('3355','2013-05-09','09:25:00',1.43),('3355','2013-05-09','09:30:00',1.47),('3355','2013-05-09','09:35:00',1.52),('3355','2013-05-09','09:40:00',1.56),('3355','2013-05-09','09:45:00',1.6),('3355','2013-05-09','09:50:00',1.64),('3355','2013-05-09','09:55:00',1.67),('3355','2013-05-09','10:00:00',1.71),('3355','2013-05-09','10:05:00',1.74),('3355','2013-05-09','10:10:00',1.77),('3355','2013-05-09','10:15:00',1.81),('3355','2013-05-09','10:20:00',1.84),('3355','2013-05-09','10:25:00',1.87),('3355','2013-05-09','10:30:00',1.9),('3355','2013-05-09','10:35:00',1.93),('3355','2013-05-09','10:40:00',1.95),('3355','2013-05-09','10:45:00',1.97),('3355','2013-05-09','10:50:00',1.99),('3355','2013-05-09','10:55:00',2.02),('3355','2013-05-09','11:00:00',2.03),('3355','2013-05-09','11:05:00',2.07),('3355','2013-05-09','11:10:00',2.1),('3355','2013-05-09','11:15:00',2.12),('3355','2013-05-09','11:20:00',2.13),('3355','2013-05-09','11:25:00',2.14),('3355','2013-05-09','11:30:00',2.15),('3355','2013-05-09','11:35:00',2.16),('3355','2013-05-09','11:40:00',2.18),('3355','2013-05-09','11:45:00',2.19),('3355','2013-05-09','11:50:00',2.2),('3355','2013-05-09','11:55:00',2.21),('3355','2013-05-09','12:00:00',2.24),('3355','2013-05-09','12:05:00',2.27),('3355','2013-05-09','12:10:00',2.28),('3355','2013-05-09','12:15:00',2.3),('3355','2013-05-09','12:20:00',2.28),('3355','2013-05-09','12:25:00',1.43),('3355','2013-05-09','12:30:00',2.16),('3355','2013-05-09','12:35:00',2.35),('3355','2013-05-09','12:40:00',1.7),('3355','2013-05-09','12:45:00',1.5),('3355','2013-05-09','12:50:00',2.37),('3355','2013-05-09','12:55:00',2.37),('3355','2013-05-09','13:00:00',2.34),('3355','2013-05-09','13:05:00',2.33),('3355','2013-05-09','13:10:00',2.35),('3355','2013-05-09','13:15:00',2.34),('3355','2013-05-09','13:20:00',2.36),('3355','2013-05-09','13:25:00',2.35),('3355','2013-05-09','13:30:00',2.36),('3355','2013-05-09','13:35:00',2.35),('3355','2013-05-09','13:40:00',2.37),('3355','2013-05-09','13:45:00',2.39),('3355','2013-05-09','13:50:00',2.35),('3355','2013-05-09','13:55:00',2.24),('3355','2013-05-09','14:00:00',2.3),('3355','2013-05-09','14:05:00',2.36),('3355','2013-05-09','14:10:00',1.89),('3355','2013-05-09','14:15:00',1.68),('3355','2013-05-09','14:20:00',2.22),('3355','2013-05-09','14:25:00',1.88),('3355','2013-05-09','14:30:00',2.11),('3355','2013-05-09','14:35:00',2.28),('3355','2013-05-09','14:40:00',2.28),('3355','2013-05-09','14:45:00',2.26),('3355','2013-05-09','14:50:00',2.25),('3355','2013-05-09','14:55:00',2.26),('3355','2013-05-09','15:00:00',2.23),('3355','2013-05-09','15:05:00',2.19),('3355','2013-05-09','15:10:00',2.16),('3355','2013-05-09','15:15:00',2.15),('3355','2013-05-09','15:20:00',2.12),('3355','2013-05-09','15:25:00',2.1),('3355','2013-05-09','15:30:00',2.1),('3355','2013-05-09','15:35:00',2.08),('3355','2013-05-09','15:40:00',2.06),('3355','2013-05-09','15:45:00',2.03),('3355','2013-05-09','15:50:00',2.01),('3355','2013-05-09','15:55:00',1.97),('3355','2013-05-09','16:00:00',1.93),('3355','2013-05-09','16:05:00',1.91),('3355','2013-05-09','16:10:00',1.87),('3355','2013-05-09','16:15:00',1.84),('3355','2013-05-09','16:20:00',1.81),('3355','2013-05-09','16:25:00',1.77),('3355','2013-05-09','16:30:00',1.72),('3355','2013-05-09','16:35:00',1.69),('3355','2013-05-09','16:40:00',1.64),('3355','2013-05-09','16:45:00',1.59),('3355','2013-05-09','16:50:00',1.54),('3355','2013-05-09','16:55:00',1.51),('3355','2013-05-09','17:00:00',1.47),('3355','2013-05-09','17:05:00',1.43),('3355','2013-05-09','17:10:00',1.39),('3355','2013-05-09','17:15:00',1.33),('3355','2013-05-09','17:20:00',1.3),('3355','2013-05-09','17:25:00',1.26),('3355','2013-05-09','17:30:00',1.21),('3355','2013-05-09','17:35:00',1.16),('3355','2013-05-09','17:40:00',1.12),('3355','2013-05-09','17:45:00',1.05),('3355','2013-05-09','17:50:00',1.01),('3355','2013-05-08','08:40:00',1),('3355','2013-05-08','08:45:00',1.09),('3355','2013-05-08','08:50:00',1.3),('3355','2013-05-08','08:55:00',1.47),('3355','2013-05-08','09:00:00',1.56),('3355','2013-05-08','09:05:00',1.66),('3355','2013-05-08','09:10:00',1.53),('3355','2013-05-08','09:15:00',1.47),('3355','2013-05-08','09:45:00',1.26),('3355','2013-05-08','10:05:00',1.62),('3355','2013-05-08','10:10:00',1.66),('3355','2013-05-08','10:20:00',1.05),('3355','2013-05-08','10:25:00',1.06),('3355','2013-05-08','10:30:00',1.06),('3355','2013-05-08','11:05:00',1.28),('3355','2013-05-08','11:10:00',2.03),('3355','2013-05-08','11:15:00',2.38),('3355','2013-05-08','11:20:00',2.25),('3355','2013-05-08','11:25:00',2.19),('3355','2013-05-08','11:30:00',2.36),('3355','2013-05-08','11:35:00',2.44),('3355','2013-05-08','11:40:00',2.46),('3355','2013-05-08','11:45:00',1.65),('3355','2013-05-08','11:50:00',1.08),('3355','2013-05-08','12:00:00',2.26),('3355','2013-05-08','12:05:00',1.8),('3355','2013-05-08','12:50:00',1.98),('3355','2013-05-08','13:00:00',2.47),('3355','2013-05-08','13:05:00',2.07),('3355','2013-05-08','13:10:00',2.13),('3355','2013-05-08','13:15:00',1.61),('3355','2013-05-08','13:45:00',2.33),('3355','2013-05-08','13:50:00',2.43),('3355','2013-05-08','13:55:00',1.91),('3355','2013-05-08','14:00:00',2.31),('3355','2013-05-08','14:20:00',1.34),('3355','2013-05-08','14:30:00',1.7),('3355','2013-05-08','14:35:00',1.65),('3355','2013-05-08','14:40:00',1.17),('3355','2013-05-08','14:50:00',1.3),('3355','2013-05-08','14:55:00',1.96),('3355','2013-05-08','15:00:00',2.16),('3355','2013-05-08','15:05:00',2.3),('3355','2013-05-08','15:10:00',1.89),('3355','2013-05-08','15:15:00',1.82),('3355','2013-05-08','15:20:00',2.24),('3355','2013-05-08','15:25:00',2.19),('3355','2013-05-08','15:30:00',2.16),('3355','2013-05-08','15:35:00',2.1),('3355','2013-05-08','15:40:00',2.07),('3355','2013-05-08','15:45:00',2.04),('3355','2013-05-08','15:50:00',2.02),('3355','2013-05-08','15:55:00',1.98),('3355','2013-05-08','16:00:00',1.97),('3355','2013-05-08','16:05:00',1.93),('3355','2013-05-08','16:10:00',1.91),('3355','2013-05-08','16:15:00',1.86),('3355','2013-05-08','16:20:00',1.82),('3355','2013-05-08','16:25:00',1.78),('3355','2013-05-08','16:30:00',1.8),('3355','2013-05-08','16:35:00',1.75),('3355','2013-05-08','16:40:00',1.68),('3355','2013-05-08','16:45:00',1.5),('3355','2013-05-08','16:50:00',1.71),('3355','2013-05-08','16:55:00',1.55),('3355','2013-05-08','17:00:00',1.41),('3355','2013-05-08','17:05:00',1.75),('3355','2013-05-08','17:10:00',1.59),('3355','2013-05-08','17:15:00',1.51),('3355','2013-05-08','17:20:00',1.44),('3355','2013-05-08','17:25:00',1.12),('3355','2013-05-08','17:30:00',1.42),('3355','2013-05-08','17:35:00',1.4),('3355','2013-05-08','17:40:00',1.35),('3355','2013-05-08','17:45:00',1.36),('3355','2013-05-08','17:50:00',1.36),('3355','2013-05-08','17:55:00',1.05),('3355','2013-05-07','08:45:00',1.07),('3355','2013-05-07','08:50:00',1.06),('3355','2013-05-07','08:55:00',1.24),('3355','2013-05-07','09:00:00',1.31),('3355','2013-05-07','09:05:00',1.47),('3355','2013-05-07','09:10:00',1.51),('3355','2013-05-07','09:15:00',1.63),('3355','2013-05-07','09:35:00',1.69),('3355','2013-05-07','09:40:00',1.36),('3355','2013-05-07','09:55:00',1.13),('3355','2013-05-07','10:00:00',1.05),('3355','2013-05-07','11:20:00',1.16),('3355','2013-05-07','11:25:00',1.72),('3355','2013-05-07','12:30:00',1.99),('3355','2013-05-07','13:30:00',1.58),('3355','2013-05-07','13:35:00',2.03),('3355','2013-05-07','13:40:00',2.05),('3355','2013-05-07','13:45:00',2.03),('3355','2013-05-07','13:50:00',2.67),('3355','2013-05-07','13:55:00',2.59),('3355','2013-05-07','14:00:00',2.38),('3355','2013-05-07','14:05:00',2.51),('3355','2013-05-07','14:10:00',2.51),('3355','2013-05-07','14:15:00',2.52),('3355','2013-05-07','14:20:00',2.5),('3355','2013-05-07','14:25:00',2.54),('3355','2013-05-07','14:30:00',2.4),('3355','2013-05-07','14:35:00',2.66),('3355','2013-05-07','14:40:00',2.34),('3355','2013-05-07','14:45:00',2.36),('3355','2013-05-07','14:50:00',2.3),('3355','2013-05-07','14:55:00',1.74),('3355','2013-05-07','15:00:00',2.66),('3355','2013-05-07','15:05:00',2.41),('3355','2013-05-07','15:10:00',2.01),('3355','2013-05-07','15:15:00',1.97),('3355','2013-05-07','15:20:00',2.06),('3355','2013-05-07','15:25:00',1.6),('3355','2013-05-07','15:30:00',1.71),('3355','2013-05-07','15:35:00',1.91),('3355','2013-05-07','16:00:00',1.84),('3355','2013-05-07','16:05:00',1.78),('3355','2013-05-07','16:15:00',1.66),('3355','2013-05-07','16:20:00',2.33),('3355','2013-05-07','16:25:00',2.33),('3355','2013-05-07','16:30:00',2.19),('3355','2013-05-07','16:35:00',2.16),('3355','2013-05-07','16:40:00',2.17),('3355','2013-05-07','16:45:00',1.55),('3355','2013-05-07','16:50:00',1.9),('3355','2013-05-07','16:55:00',1.62),('3355','2013-05-07','17:00:00',1.68),('3355','2013-05-07','17:05:00',1.72),('3355','2013-05-07','17:10:00',1.26),('3355','2013-05-06','10:30:00',1),('3355','2013-05-06','10:45:00',1.56),('3355','2013-05-06','10:50:00',1.31),('3355','2013-05-06','10:55:00',1.09),('3355','2013-05-06','11:00:00',1.14),('3355','2013-05-06','11:05:00',1.1),('3355','2013-05-06','11:10:00',1.05),('3355','2013-05-06','11:20:00',1.17),('3355','2013-05-06','11:25:00',1.17),('3355','2013-05-06','11:30:00',1.19),('3355','2013-05-06','11:40:00',2.17),('3355','2013-05-06','11:45:00',2.02),('3355','2013-05-06','11:50:00',1.52),('3355','2013-05-06','12:00:00',1.13),('3355','2013-05-06','12:05:00',1.09),('3355','2013-05-06','12:10:00',2.04),('3355','2013-05-06','12:15:00',1.24),('3355','2013-05-06','12:20:00',1.37),('3355','2013-05-06','12:25:00',1.8),('3355','2013-05-06','12:30:00',2.23),('3355','2013-05-06','12:35:00',1.89),('3355','2013-05-06','12:40:00',1.95),('3355','2013-05-06','12:45:00',1.16),('3355','2013-05-06','12:50:00',1.43),('3355','2013-05-06','12:55:00',2.11),('3355','2013-05-06','13:00:00',1.03),('3355','2013-05-06','13:05:00',1.23),('3355','2013-05-06','13:10:00',2.49),('3355','2013-05-06','13:15:00',2.13),('3355','2013-05-06','13:20:00',2.49),('3355','2013-05-06','13:25:00',1.75),('3355','2013-05-06','13:30:00',1.98),('3355','2013-05-06','13:35:00',1.35),('3355','2013-05-06','13:40:00',2.86),('3355','2013-05-06','13:45:00',1.88),('3355','2013-05-06','13:50:00',2.56),('3355','2013-05-06','13:55:00',2.58),('3355','2013-05-06','14:00:00',2.65),('3355','2013-05-06','14:05:00',2.3),('3355','2013-05-06','14:10:00',1.59),('3355','2013-05-06','14:15:00',1.76),('3355','2013-05-06','14:20:00',2.25),('3355','2013-05-06','14:25:00',1.79),('3355','2013-05-06','14:30:00',1.72),('3355','2013-05-06','14:35:00',2.69),('3355','2013-05-06','14:40:00',2.39),('3355','2013-05-06','14:45:00',1.63),('3355','2013-05-06','14:50:00',1.73),('3355','2013-05-06','14:55:00',2.42),('3355','2013-05-06','15:00:00',1.37),('3355','2013-05-06','15:05:00',1.06),('3355','2013-05-06','15:10:00',1.43),('3355','2013-05-06','15:15:00',1.42),('3355','2013-05-06','15:20:00',1.55),('3355','2013-05-06','15:30:00',1.68),('3355','2013-05-06','15:35:00',1.23),('3355','2013-05-06','15:40:00',1.64),('3355','2013-05-06','15:55:00',1.29),('3355','2013-05-06','16:25:00',1.44),('3355','2013-05-06','16:30:00',1.75),('3355','2013-05-06','16:35:00',1.1),('3355','2013-05-06','16:40:00',1.72),('3355','2013-05-06','16:45:00',1.41),('3355','2013-05-06','16:50:00',1.19),('3355','2013-05-06','16:55:00',1.45),('3355','2013-05-06','17:35:00',1.1),('3355','2013-05-05','08:25:00',1.05),('3355','2013-05-05','08:30:00',1.06),('3355','2013-05-05','08:35:00',1.02),('3355','2013-05-05','08:40:00',1.05),('3355','2013-05-05','09:25:00',1.03),('3355','2013-05-05','09:40:00',1.29),('3355','2013-05-05','09:45:00',1.31),('3355','2013-05-05','09:55:00',1.76),('3355','2013-05-05','10:00:00',1.15),('3355','2013-05-05','10:05:00',1.08),('3355','2013-05-05','10:10:00',1.11),('3355','2013-05-05','10:20:00',1.27),('3355','2013-05-05','10:25:00',1.26),('3355','2013-05-05','10:30:00',1.32),('3355','2013-05-05','10:35:00',1.27),('3355','2013-05-05','10:40:00',1.32),('3355','2013-05-05','10:45:00',1.36),('3355','2013-05-05','10:50:00',1.08),('3355','2013-05-05','11:05:00',1.04),('3355','2013-05-05','11:20:00',1.25),('3355','2013-05-05','11:25:00',1.69),('3355','2013-05-05','11:30:00',1.56),('3355','2013-05-05','11:35:00',1.96),('3355','2013-05-05','11:40:00',1.91),('3355','2013-05-05','11:45:00',1.67),('3355','2013-05-05','11:50:00',1.48),('3355','2013-05-05','11:55:00',1.59),('3355','2013-05-05','12:00:00',1.31),('3355','2013-05-05','12:05:00',1.41),('3355','2013-05-05','12:10:00',1.41),('3355','2013-05-05','12:15:00',1.39),('3355','2013-05-05','12:20:00',1.74),('3355','2013-05-05','12:25:00',1.87),('3355','2013-05-05','12:30:00',1.98),('3355','2013-05-05','12:35:00',2.36),('3355','2013-05-05','12:40:00',1.89),('3355','2013-05-05','12:45:00',1.87),('3355','2013-05-05','12:50:00',1.79),('3355','2013-05-05','12:55:00',2.24),('3355','2013-05-05','13:00:00',1.99),('3355','2013-05-05','13:05:00',2.34),('3355','2013-05-05','13:10:00',2.06),('3355','2013-05-05','13:15:00',2.52),('3355','2013-05-05','13:20:00',2.01),('3355','2013-05-05','13:25:00',1.27),('3355','2013-05-05','13:35:00',1.82),('3355','2013-05-05','13:40:00',2.44),('3355','2013-05-05','13:45:00',2.41),('3355','2013-05-05','13:50:00',2.4),('3355','2013-05-05','13:55:00',2.41),('3355','2013-05-05','14:00:00',2.45),('3355','2013-05-05','14:05:00',2.52),('3355','2013-05-05','14:10:00',1.9),('3355','2013-05-05','14:15:00',1.69),('3355','2013-05-05','14:20:00',2.2),('3355','2013-05-05','14:25:00',2.24),('3355','2013-05-05','14:30:00',2.17),('3355','2013-05-05','14:35:00',2.16),('3355','2013-05-05','14:40:00',2.14),('3355','2013-05-05','14:45:00',2.13),('3355','2013-05-05','14:50:00',2.11),('3355','2013-05-05','14:55:00',2.09),('3355','2013-05-05','15:00:00',2.08),('3355','2013-05-05','15:05:00',2.05),('3355','2013-05-05','15:10:00',2.04),('3355','2013-05-05','15:15:00',2.03),('3355','2013-05-05','15:20:00',1.99),('3355','2013-05-05','15:25:00',1.99),('3355','2013-05-05','15:30:00',1.98),('3355','2013-05-05','15:35:00',1.95),('3355','2013-05-05','15:40:00',1.92),('3355','2013-05-05','15:45:00',1.89),('3355','2013-05-05','15:50:00',1.87),('3355','2013-05-05','15:55:00',1.84),('3355','2013-05-05','16:00:00',1.81),('3355','2013-05-05','16:05:00',1.78),('3355','2013-05-05','16:10:00',1.75),('3355','2013-05-05','16:15:00',1.73),('3355','2013-05-05','16:20:00',1.7),('3355','2013-05-05','16:25:00',1.65),('3355','2013-05-05','16:30:00',1.62),('3355','2013-05-05','16:35:00',1.59),('3355','2013-05-05','16:40:00',1.55),('3355','2013-05-05','16:45:00',1.5),('3355','2013-05-05','16:50:00',1.47),('3355','2013-05-05','16:55:00',1.42),('3355','2013-05-05','17:00:00',1.38),('3355','2013-05-05','17:05:00',1.33),('3355','2013-05-05','17:10:00',1.29),('3355','2013-05-05','17:15:00',1.26),('3355','2013-05-05','17:20:00',1.21),('3355','2013-05-05','17:25:00',1.15),('3355','2013-05-05','17:30:00',1.11),('3355','2013-05-05','17:35:00',1.05),('3355','2013-05-05','17:40:00',1.01),('3355','2013-05-04','08:55:00',1.03),('3355','2013-05-04','09:00:00',1.07),('3355','2013-05-04','09:05:00',1.12),('3355','2013-05-04','09:10:00',1.17),('3355','2013-05-04','09:15:00',1.19),('3355','2013-05-04','09:20:00',1.26),('3355','2013-05-04','09:25:00',1.29),('3355','2013-05-04','09:30:00',1.32),('3355','2013-05-04','09:35:00',1.37),('3355','2013-05-04','09:40:00',1.42),('3355','2013-05-04','09:45:00',1.47),('3355','2013-05-04','09:50:00',1.51),('3355','2013-05-04','09:55:00',1.55),('3355','2013-05-04','10:00:00',1.59),('3355','2013-05-04','10:05:00',1.62),('3355','2013-05-04','10:10:00',1.67),('3355','2013-05-04','10:15:00',1.7),('3355','2013-05-04','10:20:00',1.72),('3355','2013-05-04','10:25:00',1.77),('3355','2013-05-04','10:30:00',1.8),('3355','2013-05-04','10:35:00',1.83),('3355','2013-05-04','10:40:00',1.83),('3355','2013-05-04','10:45:00',1.83),('3355','2013-05-04','10:50:00',1.83),('3355','2013-05-04','10:55:00',1.8),('3355','2013-05-04','11:00:00',1.83),('3355','2013-05-04','11:05:00',1.84),('3355','2013-05-04','11:10:00',1.77),('3355','2013-05-04','11:15:00',1.7),('3355','2013-05-04','11:20:00',1.82),('3355','2013-05-04','11:25:00',1.88),('3355','2013-05-04','11:30:00',1.8),('3355','2013-05-04','11:35:00',1.85),('3355','2013-05-04','11:40:00',1.8),('3355','2013-05-04','11:45:00',1.86),('3355','2013-05-04','11:50:00',1.86),('3355','2013-05-04','11:55:00',1.87),('3355','2013-05-04','12:00:00',1.81),('3355','2013-05-04','12:05:00',1.89),('3355','2013-05-04','12:10:00',1.94),('3355','2013-05-04','12:15:00',1.97),('3355','2013-05-04','12:20:00',2.03),('3355','2013-05-04','12:25:00',2.06),('3355','2013-05-04','12:30:00',2.07),('3355','2013-05-04','12:35:00',2.1),('3355','2013-05-04','12:40:00',2.1),('3355','2013-05-04','12:45:00',2.11),('3355','2013-05-04','12:50:00',2.05),('3355','2013-05-04','12:55:00',2),('3355','2013-05-04','13:00:00',1.97),('3355','2013-05-04','13:05:00',1.79),('3355','2013-05-04','13:10:00',1.94),('3355','2013-05-04','13:15:00',2.2),('3355','2013-05-04','13:20:00',2.24),('3355','2013-05-04','13:25:00',2.09),('3355','2013-05-04','13:30:00',2.14),('3355','2013-05-04','13:35:00',2.08),('3355','2013-05-04','13:40:00',2.09),('3355','2013-05-04','13:45:00',2.08),('3355','2013-05-04','13:50:00',1.84),('3355','2013-05-04','13:55:00',1.98),('3355','2013-05-04','14:00:00',1.94),('3355','2013-05-04','14:05:00',2.04),('3355','2013-05-04','14:10:00',1.94),('3355','2013-05-04','14:15:00',2),('3355','2013-05-04','14:20:00',2.02),('3355','2013-05-04','14:25:00',1.87),('3355','2013-05-04','14:30:00',1.94),('3355','2013-05-04','14:35:00',1.84),('3355','2013-05-04','14:40:00',1.92),('3355','2013-05-04','14:45:00',1.9),('3355','2013-05-04','14:50:00',1.8),('3355','2013-05-04','14:55:00',1.85),('3355','2013-05-04','15:00:00',1.89),('3355','2013-05-04','15:05:00',1.92),('3355','2013-05-04','15:10:00',1.8),('3355','2013-05-04','15:15:00',1.85),('3355','2013-05-04','15:20:00',1.9),('3355','2013-05-04','15:25:00',1.92),('3355','2013-05-04','15:30:00',1.9),('3355','2013-05-04','15:35:00',1.82),('3355','2013-05-04','15:40:00',1.78),('3355','2013-05-04','15:45:00',1.81),('3355','2013-05-04','15:50:00',1.8),('3355','2013-05-04','15:55:00',1.77),('3355','2013-05-04','16:00:00',1.72),('3355','2013-05-04','16:05:00',1.7),('3355','2013-05-04','16:10:00',1.68),('3355','2013-05-04','16:15:00',1.64),('3355','2013-05-04','16:20:00',1.61),('3355','2013-05-04','16:25:00',1.57),('3355','2013-05-04','16:30:00',1.54),('3355','2013-05-04','16:35:00',1.51),('3355','2013-05-04','16:40:00',1.47),('3355','2013-05-04','16:45:00',1.43),('3355','2013-05-04','16:50:00',1.38),('3355','2013-05-04','16:55:00',1.34),('3355','2013-05-04','17:00:00',1.31),('3355','2013-05-04','17:05:00',1.23),('3355','2013-05-04','17:15:00',1.11),('3355','2013-05-04','17:20:00',1.16),('3355','2013-05-04','17:25:00',1.11),('3355','2013-05-04','17:30:00',1.04),('3355','2013-05-03','08:45:00',1.02),('3355','2013-05-03','08:50:00',1.01),('3355','2013-05-03','08:55:00',1.03),('3355','2013-05-03','09:00:00',1.1),('3355','2013-05-03','09:05:00',1.18),('3355','2013-05-03','09:10:00',1.2),('3355','2013-05-03','09:15:00',1.24),('3355','2013-05-03','09:20:00',1.27),('3355','2013-05-03','09:25:00',1.34),('3355','2013-05-03','09:30:00',1.36),('3355','2013-05-03','09:35:00',1.41),('3355','2013-05-03','09:40:00',1.46),('3355','2013-05-03','09:45:00',1.51),('3355','2013-05-03','09:50:00',1.54),('3355','2013-05-03','09:55:00',1.58),('3355','2013-05-03','10:00:00',1.62),('3355','2013-05-03','10:05:00',1.65),('3355','2013-05-03','10:10:00',1.69),('3355','2013-05-03','10:15:00',1.73),('3355','2013-05-03','10:20:00',1.76),('3355','2013-05-03','10:25:00',1.79),('3355','2013-05-03','10:30:00',1.82),('3355','2013-05-03','10:35:00',1.84),('3355','2013-05-03','10:40:00',1.86),('3355','2013-05-03','10:45:00',1.88),('3355','2013-05-03','10:50:00',1.9),('3355','2013-05-03','10:55:00',1.93),('3355','2013-05-03','11:00:00',1.95),('3355','2013-05-03','11:05:00',1.98),('3355','2013-05-03','11:10:00',2),('3355','2013-05-03','11:15:00',2.02),('3355','2013-05-03','11:20:00',2.03),('3355','2013-05-03','11:25:00',2.08),('3355','2013-05-03','11:30:00',2.1),('3355','2013-05-03','11:35:00',2.11),('3355','2013-05-03','11:40:00',2.12),('3355','2013-05-03','11:45:00',2.12),('3355','2013-05-03','11:50:00',2.14),('3355','2013-05-03','11:55:00',2.15),('3355','2013-05-03','12:00:00',2.16),('3355','2013-05-03','12:05:00',2.18),('3355','2013-05-03','12:10:00',2.19),('3355','2013-05-03','12:15:00',2.21),('3355','2013-05-03','12:20:00',2.21),('3355','2013-05-03','12:25:00',2.21),('3355','2013-05-03','12:30:00',2.21),('3355','2013-05-03','12:35:00',2.2),('3355','2013-05-03','12:40:00',2.22),('3355','2013-05-03','12:45:00',2.22),('3355','2013-05-03','12:50:00',2.26),('3355','2013-05-03','12:55:00',2.25),('3355','2013-05-03','13:00:00',2.23),('3355','2013-05-03','13:05:00',2.23),('3355','2013-05-03','13:10:00',2.23),('3355','2013-05-03','13:15:00',2.24),('3355','2013-05-03','13:20:00',2.24),('3355','2013-05-03','13:25:00',2.25),('3355','2013-05-03','13:30:00',2.22),('3355','2013-05-03','13:35:00',2.18),('3355','2013-05-03','13:40:00',2.13),('3355','2013-05-03','13:45:00',2.12),('3355','2013-05-03','13:50:00',2.13),('3355','2013-05-03','13:55:00',2.16),('3355','2013-05-03','14:00:00',2.15),('3355','2013-05-03','14:05:00',2.06),('3355','2013-05-03','14:10:00',2.1),('3355','2013-05-03','14:15:00',2.03),('3355','2013-05-03','14:20:00',2.07),('3355','2013-05-03','14:25:00',2.09),('3355','2013-05-03','14:30:00',2.05),('3355','2013-05-03','14:35:00',2.09),('3355','2013-05-03','14:40:00',2.06),('3355','2013-05-03','14:45:00',2.04),('3355','2013-05-03','14:50:00',2.04),('3355','2013-05-03','14:55:00',2.05),('3355','2013-05-03','15:00:00',2.06),('3355','2013-05-03','15:05:00',2.04),('3355','2013-05-03','15:10:00',2.04),('3355','2013-05-03','15:15:00',2.01),('3355','2013-05-03','15:20:00',2),('3355','2013-05-03','15:25:00',1.98),('3355','2013-05-03','15:30:00',1.96),('3355','2013-05-03','15:35:00',1.94),('3355','2013-05-03','15:40:00',1.92),('3355','2013-05-03','15:45:00',1.9),('3355','2013-05-03','15:50:00',1.85),('3355','2013-05-03','15:55:00',1.82),('3355','2013-05-03','16:00:00',1.82),('3355','2013-05-03','16:05:00',1.8),('3355','2013-05-03','16:10:00',1.75),('3355','2013-05-03','16:15:00',1.71),('3355','2013-05-03','16:20:00',1.65),('3355','2013-05-03','16:25:00',1.6),('3355','2013-05-03','16:30:00',1.61),('3355','2013-05-03','16:35:00',1.59),('3355','2013-05-03','16:40:00',1.54),('3355','2013-05-03','16:45:00',1.49),('3355','2013-05-03','16:50:00',1.45),('3355','2013-05-03','16:55:00',1.41),('3355','2013-05-03','17:00:00',1.37),('3355','2013-05-03','17:05:00',1.31),('3355','2013-05-03','17:10:00',1.27),('3355','2013-05-03','17:15:00',1.21),('3355','2013-05-03','17:20:00',1.16),('3355','2013-05-03','17:25:00',1.09),('3355','2013-05-03','17:30:00',1.04),('3355','2013-05-02','09:35:00',1.16),('3355','2013-05-02','09:45:00',1.25),('3355','2013-05-02','10:25:00',1.09),('3355','2013-05-02','10:30:00',1.72),('3355','2013-05-02','10:35:00',1.25),('3355','2013-05-02','10:40:00',1.93),('3355','2013-05-02','10:45:00',1.41),('3355','2013-05-02','10:50:00',1.7),('3355','2013-05-02','10:55:00',2.05),('3355','2013-05-02','11:00:00',2.12),('3355','2013-05-02','11:05:00',2.09),('3355','2013-05-02','11:10:00',1.49),('3355','2013-05-02','11:15:00',1.56),('3355','2013-05-02','11:20:00',1.47),('3355','2013-05-02','11:25:00',2.09),('3355','2013-05-02','11:30:00',2.12),('3355','2013-05-02','11:35:00',2.1),('3355','2013-05-02','11:40:00',2.08),('3355','2013-05-02','11:45:00',2.09),('3355','2013-05-02','11:50:00',2.09),('3355','2013-05-02','11:55:00',2.1),('3355','2013-05-02','12:00:00',2.1),('3355','2013-05-02','12:05:00',2.1),('3355','2013-05-02','12:10:00',2.1),('3355','2013-05-02','12:15:00',2.13),('3355','2013-05-02','12:20:00',2.13),('3355','2013-05-02','12:25:00',2.14),('3355','2013-05-02','12:30:00',2.17),('3355','2013-05-02','12:35:00',2.2),('3355','2013-05-02','12:40:00',2.23),('3355','2013-05-02','12:45:00',2.23),('3355','2013-05-02','12:50:00',2.24),('3355','2013-05-02','12:55:00',2.26),('3355','2013-05-02','13:00:00',2.27),('3355','2013-05-02','13:05:00',2.28),('3355','2013-05-02','13:10:00',2.31),('3355','2013-05-02','13:15:00',2.32),('3355','2013-05-02','13:20:00',2.32),('3355','2013-05-02','13:25:00',2.31),('3355','2013-05-02','13:30:00',2.32),('3355','2013-05-02','13:35:00',2.31),('3355','2013-05-02','13:40:00',2.3),('3355','2013-05-02','13:45:00',2.32),('3355','2013-05-02','13:50:00',2.3),('3355','2013-05-02','13:55:00',2.3),('3355','2013-05-02','14:00:00',2.28),('3355','2013-05-02','14:05:00',2.26),('3355','2013-05-02','14:10:00',2.25),('3355','2013-05-02','14:15:00',2.25),('3355','2013-05-02','14:20:00',2.22),('3355','2013-05-02','14:25:00',2.2),('3355','2013-05-02','14:30:00',2.19),('3355','2013-05-02','14:35:00',2.18),('3355','2013-05-02','14:40:00',2.17),('3355','2013-05-02','14:45:00',2.15),('3355','2013-05-02','14:50:00',2.12),('3355','2013-05-02','14:55:00',2.12),('3355','2013-05-02','15:00:00',2.1),('3355','2013-05-02','15:05:00',2.08),('3355','2013-05-02','15:10:00',2.06),('3355','2013-05-02','15:15:00',2.05),('3355','2013-05-02','15:20:00',2.02),('3355','2013-05-02','15:25:00',1.99),('3355','2013-05-02','15:30:00',1.94),('3355','2013-05-02','15:35:00',1.9),('3355','2013-05-02','15:40:00',1.88),('3355','2013-05-02','15:45:00',1.86),('3355','2013-05-02','15:50:00',1.85),('3355','2013-05-02','15:55:00',1.81),('3355','2013-05-02','16:00:00',1.77),('3355','2013-05-02','16:05:00',1.77),('3355','2013-05-02','16:10:00',1.75),('3355','2013-05-02','16:15:00',1.72),('3355','2013-05-02','16:20:00',1.68),('3355','2013-05-02','16:25:00',1.65),('3355','2013-05-02','16:30:00',1.61),('3355','2013-05-02','16:35:00',1.56),('3355','2013-05-02','16:40:00',1.53),('3355','2013-05-02','16:45:00',1.49),('3355','2013-05-02','16:50:00',1.45),('3355','2013-05-02','16:55:00',1.41),('3355','2013-05-02','17:00:00',1.37),('3355','2013-05-02','17:05:00',1.33),('3355','2013-05-02','17:10:00',1.29),('3355','2013-05-02','17:15:00',1.25),('3355','2013-05-02','17:20:00',1.21),('3355','2013-05-02','17:25:00',1.16),('3355','2013-05-02','17:30:00',1.11),('3355','2013-05-02','17:35:00',1.06),('3355','2013-05-02','17:40:00',1.02),('3355','2014-03-30','09:30:00',1),('3355','2014-03-30','09:35:00',1.14),('3355','2014-03-30','09:40:00',1.18),('3355','2014-03-30','09:45:00',1.22),('3355','2014-03-30','09:50:00',1.24),('3355','2014-03-30','09:55:00',1.22),('3355','2014-03-30','10:00:00',1.23),('3355','2014-03-30','10:05:00',1.43),('3355','2014-03-30','10:10:00',1.46),('3355','2014-03-30','10:15:00',1.43),('3355','2014-03-30','10:20:00',1.49),('3355','2014-03-30','10:25:00',1.54),('3355','2014-03-30','10:30:00',1.59),('3355','2014-03-30','10:35:00',1.64),('3355','2014-03-30','10:40:00',1.69),('3355','2014-03-30','10:45:00',1.69),('3355','2014-03-30','10:50:00',1.71),('3355','2014-03-30','10:55:00',1.75),('3355','2014-03-30','11:00:00',1.76),('3355','2014-03-30','11:05:00',1.68),('3355','2014-03-30','11:10:00',1.74),('3355','2014-03-30','11:15:00',1.72),('3355','2014-03-30','11:20:00',1.72),('3355','2014-03-30','11:25:00',1.77),('3355','2014-03-30','11:30:00',1.9),('3355','2014-03-30','11:35:00',1.87),('3355','2014-03-30','11:40:00',1.95),('3355','2014-03-30','11:45:00',2.02),('3355','2014-03-30','11:50:00',2.06),('3355','2014-03-30','11:55:00',2.12),('3355','2014-03-30','12:00:00',2.13),('3355','2014-03-30','12:05:00',2.2),('3355','2014-03-30','12:10:00',2.27),('3355','2014-03-30','12:15:00',2.26),('3355','2014-03-30','12:20:00',2.24),('3355','2014-03-30','12:25:00',2.24),('3355','2014-03-30','12:30:00',2.09),('3355','2014-03-30','12:35:00',2.08),('3355','2014-03-30','12:40:00',2.24),('3355','2014-03-30','12:45:00',2.17),('3355','2014-03-30','12:50:00',2.22),('3355','2014-03-30','12:55:00',2.24),('3355','2014-03-30','13:00:00',2.3),('3355','2014-03-30','13:05:00',2.31),('3355','2014-03-30','13:10:00',2.31),('3355','2014-03-30','13:15:00',2.31),('3355','2014-03-30','13:20:00',2.31),('3355','2014-03-30','13:25:00',2.32),('3355','2014-03-30','13:30:00',2.31),('3355','2014-03-30','13:35:00',2.34),('3355','2014-03-30','13:40:00',2.32),('3355','2014-03-30','13:45:00',2.34),('3355','2014-03-30','13:50:00',2.34),('3355','2014-03-30','13:55:00',2.29),('3355','2014-03-30','14:00:00',2.28),('3355','2014-03-30','14:05:00',2.3),('3355','2014-03-30','14:10:00',2.24),('3355','2014-03-30','14:15:00',2.24),('3355','2014-03-30','14:20:00',2.27),('3355','2014-03-30','14:25:00',2.3),('3355','2014-03-30','14:30:00',2.33),('3355','2014-03-30','14:35:00',2.3),('3355','2014-03-30','14:40:00',2.17),('3355','2014-03-30','14:45:00',2.01),('3355','2014-03-30','14:50:00',1.82),('3355','2014-03-30','14:55:00',1.53),('3355','2014-03-30','15:00:00',1.22),('3355','2014-03-30','15:20:00',1.06),('3355','2014-03-30','15:25:00',1.77),('3355','2014-03-30','15:30:00',1.89),('3355','2014-03-30','15:35:00',1.87),('3355','2014-03-30','15:40:00',1.9),('3355','2014-03-30','15:45:00',1.88),('3355','2014-03-30','15:50:00',1.88),('3355','2014-03-30','15:55:00',1.83),('3355','2014-03-30','16:00:00',1.77),('3355','2014-03-30','16:05:00',1.62),('3355','2014-03-30','16:10:00',1.61),('3355','2014-03-30','16:15:00',1.56),('3355','2014-03-30','16:20:00',1.67),('3355','2014-03-30','16:25:00',1.67),('3355','2014-03-30','16:30:00',1.63),('3355','2014-03-30','16:35:00',1.64),('3355','2014-03-30','16:40:00',1.55),('3355','2014-03-30','16:45:00',1.39),('3355','2014-03-30','16:50:00',1.29),('3355','2014-03-30','16:55:00',1.05),('3355','2014-03-30','17:00:00',1.06),('3355','2014-03-30','17:05:00',1.21),('3355','2014-03-30','17:10:00',1.27),('3355','2014-03-30','17:15:00',1.29),('3355','2014-03-30','17:20:00',1.24),('3355','2014-03-30','17:25:00',1.12),('3355','2014-03-30','17:30:00',1.09),('3355','2014-03-30','17:35:00',1.04),('3355','2013-05-01','09:00:00',1.04),('3355','2013-05-01','09:05:00',1.08),('3355','2013-05-01','09:10:00',1.12),('3355','2013-05-01','09:15:00',1.16),('3355','2013-05-01','09:20:00',1.19),('3355','2013-05-01','09:25:00',1.22),('3355','2013-05-01','09:30:00',1.25),('3355','2013-05-01','09:35:00',1.28),('3355','2013-05-01','09:40:00',1.33),('3355','2013-05-01','09:45:00',1.36),('3355','2013-05-01','09:50:00',1.4),('3355','2013-05-01','09:55:00',1.43),('3355','2013-05-01','10:00:00',1.47),('3355','2013-05-01','10:05:00',1.48),('3355','2013-05-01','10:10:00',1.54),('3355','2013-05-01','10:15:00',1.59),('3355','2013-05-01','10:20:00',1.62),('3355','2013-05-01','10:25:00',1.64),('3355','2013-05-01','10:30:00',1.67),('3355','2013-05-01','10:35:00',1.7),('3355','2013-05-01','10:40:00',1.77),('3355','2013-05-01','10:45:00',1.86),('3355','2013-05-01','10:50:00',1.88),('3355','2013-05-01','10:55:00',1.9),('3355','2013-05-01','11:00:00',1.92),('3355','2013-05-01','11:05:00',1.94),('3355','2013-05-01','11:10:00',1.97),('3355','2013-05-01','11:15:00',1.86),('3355','2013-05-01','11:20:00',1.77),('3355','2013-05-01','11:25:00',1.74),('3355','2013-05-01','11:30:00',1.71),('3355','2013-05-01','11:35:00',1.81),('3355','2013-05-01','11:40:00',1.62),('3355','2013-05-01','11:45:00',1.53),('3355','2013-05-01','11:50:00',1.76),('3355','2013-05-01','11:55:00',2.12),('3355','2013-05-01','12:00:00',2.1),('3355','2013-05-01','12:05:00',2.07),('3355','2013-05-01','12:10:00',2.07),('3355','2013-05-01','12:15:00',2.07),('3355','2013-05-01','12:20:00',2.09),('3355','2013-05-01','12:25:00',2.1),('3355','2013-05-01','12:30:00',2.14),('3355','2013-05-01','12:35:00',2.17),('3355','2013-05-01','12:40:00',2.21),('3355','2013-05-01','12:45:00',2.01),('3355','2013-05-01','12:50:00',1.95),('3355','2013-05-01','13:00:00',1.01),('3355','2013-05-01','13:10:00',1.32),('3355','2013-05-01','13:15:00',2.39),('3355','2013-05-01','13:20:00',2.48),('3355','2013-05-01','13:25:00',2.11),('3355','2013-05-01','13:30:00',1.44),('3355','2013-05-01','13:35:00',1.61),('3355','2013-05-01','13:40:00',2.35),('3355','2013-05-01','13:45:00',2.37),('3355','2013-05-01','13:50:00',2.26),('3355','2013-05-01','13:55:00',2.2),('3355','2013-05-01','14:00:00',2.16),('3355','2013-05-01','14:05:00',2.1),('3355','2013-05-01','14:10:00',2.1),('3355','2013-05-01','14:15:00',1.78),('3355','2013-05-01','14:20:00',2.19),('3355','2013-05-01','14:25:00',2.21),('3355','2013-05-01','14:30:00',2.22),('3355','2013-05-01','14:35:00',2.15),('3355','2013-05-01','14:40:00',1.92),('3355','2013-05-01','14:45:00',2.05),('3355','2013-05-01','14:50:00',1.69),('3355','2013-05-01','14:55:00',1.59),('3355','2013-05-01','15:00:00',1.74),('3355','2013-05-01','15:05:00',1.88),('3355','2013-05-01','15:10:00',1.93),('3355','2013-05-01','15:15:00',1.87),('3355','2013-05-01','15:20:00',1.78),('3355','2013-05-01','15:25:00',1.89),('3355','2013-05-01','15:30:00',1.55),('3355','2013-05-01','15:35:00',1.33),('3355','2013-05-01','15:40:00',1.32),('3355','2013-05-01','15:45:00',1.3),('3355','2013-05-01','16:00:00',1.13),('3355','2013-05-01','16:05:00',1.1),('3355','2013-04-30','09:10:00',1.1),('3355','2013-04-30','09:15:00',1.3),('3355','2013-04-30','09:20:00',1.31),('3355','2013-04-30','09:25:00',1.4),('3355','2013-04-30','09:30:00',1.39),('3355','2013-04-30','09:35:00',1.16),('3355','2013-04-30','09:45:00',1),('3355','2013-04-30','09:50:00',1.33),('3355','2013-04-30','09:55:00',1.47),('3355','2013-04-30','10:00:00',1.72),('3355','2013-04-30','10:05:00',1.72),('3355','2013-04-30','10:10:00',1.46),('3355','2013-04-30','10:15:00',1.34),('3355','2013-04-30','10:20:00',1.26),('3355','2013-04-30','10:25:00',1.18),('3355','2013-04-30','10:30:00',1.06),('3355','2013-04-30','10:35:00',1.04),('3355','2013-04-30','11:20:00',1.13),('3355','2013-04-30','11:25:00',1.05),('3355','2013-04-30','11:30:00',1.02),('3355','2013-04-30','11:35:00',1.06),('3355','2013-04-30','11:40:00',1.04),('3355','2013-04-30','12:35:00',1.24),('3355','2013-04-30','12:40:00',2.26),('3355','2013-04-30','12:45:00',2.46),('3355','2013-04-30','12:50:00',2.37),('3355','2013-04-30','12:55:00',2.04),('3355','2013-04-30','13:00:00',2.21),('3355','2013-04-30','13:05:00',2.18),('3355','2013-04-30','13:10:00',2.24),('3355','2013-04-30','13:15:00',2.22),('3355','2013-04-30','13:20:00',2.2),('3355','2013-04-30','13:25:00',2.19),('3355','2013-04-30','13:30:00',2.17),('3355','2013-04-30','13:35:00',2.18),('3355','2013-04-30','13:40:00',2.16),('3355','2013-04-30','13:45:00',2.15),('3355','2013-04-30','13:50:00',2.13),('3355','2013-04-30','13:55:00',2.11),('3355','2013-04-30','14:00:00',2.1),('3355','2013-04-30','14:05:00',2.09),('3355','2013-04-30','14:10:00',2.09),('3355','2013-04-30','14:15:00',2.08),('3355','2013-04-30','14:20:00',2.08),('3355','2013-04-30','14:25:00',2.07),('3355','2013-04-30','14:30:00',2.06),('3355','2013-04-30','14:35:00',2.04),('3355','2013-04-30','14:40:00',2.01),('3355','2013-04-30','14:45:00',1.98),('3355','2013-04-30','14:50:00',1.95),('3355','2013-04-30','14:55:00',1.92),('3355','2013-04-30','15:00:00',1.91),('3355','2013-04-30','15:05:00',1.89),('3355','2013-04-30','15:10:00',1.87),('3355','2013-04-30','15:15:00',1.85),('3355','2013-04-30','15:20:00',1.82),('3355','2013-04-30','15:25:00',1.8),('3355','2013-04-30','15:30:00',1.77),('3355','2013-04-30','15:35:00',1.77),('3355','2013-04-30','15:40:00',1.74),('3355','2013-04-30','15:45:00',1.7),('3355','2013-04-30','15:50:00',1.67),('3355','2013-04-30','15:55:00',1.63),('3355','2013-04-30','16:00:00',1.6),('3355','2013-04-30','16:05:00',1.57),('3355','2013-04-30','16:10:00',1.54),('3355','2013-04-30','16:15:00',1.51),('3355','2013-04-30','16:20:00',1.49),('3355','2013-04-30','16:25:00',1.45),('3355','2013-04-30','16:30:00',1.43),('3355','2013-04-30','16:35:00',1.36),('3355','2013-04-30','16:40:00',1.09),('3355','2013-04-30','16:45:00',1.17),('3355','2013-04-30','16:50:00',1.05),('3355','2013-04-30','16:55:00',1.2),('3355','2013-04-30','17:00:00',1.11),('3355','2013-04-30','17:05:00',1.12),('3355','2013-04-29','08:50:00',1.04),('3355','2013-04-29','08:55:00',1.05),('3355','2013-04-29','09:05:00',1.12),('3355','2013-04-29','09:10:00',1.25),('3355','2013-04-29','09:15:00',1.33),('3355','2013-04-29','09:20:00',1.26),('3355','2013-04-29','09:25:00',1.24),('3355','2013-04-29','09:30:00',1.22),('3355','2013-04-29','09:35:00',1.32),('3355','2013-04-29','09:40:00',1.34),('3355','2013-04-29','09:45:00',1.4),('3355','2013-04-29','09:50:00',1.5),('3355','2013-04-29','09:55:00',1.4),('3355','2013-04-29','10:00:00',1.46),('3355','2013-04-29','10:05:00',1.44),('3355','2013-04-29','10:10:00',1.43),('3355','2013-04-29','10:15:00',1.23),('3355','2013-04-29','10:20:00',1.16),('3355','2013-04-29','10:25:00',1.44),('3355','2013-04-29','10:30:00',1.42),('3355','2013-04-29','10:35:00',1.72),('3355','2013-04-29','10:40:00',1.74),('3355','2013-04-29','10:45:00',1.77),('3355','2013-04-29','10:50:00',1.7),('3355','2013-04-29','10:55:00',1.59),('3355','2013-04-29','11:00:00',1.78),('3355','2013-04-29','11:05:00',1.73),('3355','2013-04-29','11:10:00',1.72),('3355','2013-04-29','11:15:00',1.58),('3355','2013-04-29','11:20:00',1.81),('3355','2013-04-29','11:25:00',1.88),('3355','2013-04-29','11:30:00',1.99),('3355','2013-04-29','11:35:00',1.9),('3355','2013-04-29','11:40:00',1.92),('3355','2013-04-29','11:45:00',1.9),('3355','2013-04-29','11:50:00',2.06),('3355','2013-04-29','11:55:00',2.03),('3355','2013-04-29','12:00:00',2.13),('3355','2013-04-29','12:05:00',2.13),('3355','2013-04-29','12:10:00',2.05),('3355','2013-04-29','12:15:00',2.06),('3355','2013-04-29','12:20:00',2.09),('3355','2013-04-29','12:25:00',2.06),('3355','2013-04-29','12:30:00',2.09),('3355','2013-04-29','12:35:00',2.14),('3355','2013-04-29','12:40:00',2.19),('3355','2013-04-29','12:45:00',2.21),('3355','2013-04-29','12:50:00',2.2),('3355','2013-04-29','12:55:00',2.12),('3355','2013-04-29','13:00:00',2.17),('3355','2013-04-29','13:05:00',2.16),('3355','2013-04-29','13:10:00',2.13),('3355','2013-04-29','13:15:00',1.99),('3355','2013-04-29','13:20:00',2.11),('3355','2013-04-29','13:25:00',2.24),('3355','2013-04-29','13:30:00',2.19),('3355','2013-04-29','13:35:00',2.18),('3355','2013-04-29','13:40:00',2.16),('3355','2013-04-29','13:45:00',2.13),('3355','2013-04-29','13:50:00',2.1),('3355','2013-04-29','13:55:00',2.21),('3355','2013-04-29','14:00:00',2.08),('3355','2013-04-29','14:05:00',2.13),('3355','2013-04-29','14:10:00',2.12),('3355','2013-04-29','14:15:00',2.16),('3355','2013-04-29','14:20:00',2.15),('3355','2013-04-29','14:25:00',2.11),('3355','2013-04-29','14:30:00',2.02),('3355','2013-04-29','14:35:00',1.96),('3355','2013-04-29','14:40:00',1.86),('3355','2013-04-29','14:45:00',2.02),('3355','2013-04-29','14:50:00',1.95),('3355','2013-04-29','14:55:00',2.02),('3355','2013-04-29','15:00:00',1.94),('3355','2013-04-29','15:05:00',2.05),('3355','2013-04-29','15:10:00',1.94),('3355','2013-04-29','15:15:00',1.78),('3355','2013-04-29','15:20:00',1.87),('3355','2013-04-29','15:25:00',1.97),('3355','2013-04-29','15:30:00',1.93),('3355','2013-04-29','15:35:00',1.72),('3355','2013-04-29','15:40:00',1.56),('3355','2013-04-29','15:45:00',1.49),('3355','2013-04-29','15:50:00',1.53),('3355','2013-04-29','15:55:00',1.63),('3355','2013-04-29','16:00:00',1.59),('3355','2013-04-29','16:05:00',1.71),('3355','2013-04-29','16:10:00',1.58),('3355','2013-04-29','16:15:00',1.85),('3355','2013-04-29','16:20:00',1.82),('3355','2013-04-29','16:25:00',1.4),('3355','2013-04-29','16:30:00',1.47),('3355','2013-04-29','16:35:00',1.48),('3355','2013-04-29','16:40:00',1.57),('3355','2013-04-29','16:45:00',1.54),('3355','2013-04-29','16:50:00',1.58),('3355','2013-04-29','16:55:00',1.65),('3355','2013-04-29','17:00:00',1.52),('3355','2013-04-29','17:05:00',1.31),('3355','2013-04-29','17:10:00',1.36),('3355','2013-04-29','17:15:00',1.2),('3355','2013-04-28','08:50:00',1.01),('3355','2013-04-28','08:55:00',1.06),('3355','2013-04-28','09:00:00',1.1),('3355','2013-04-28','09:05:00',1.15),('3355','2013-04-28','09:10:00',1.2),('3355','2013-04-28','09:15:00',1.24),('3355','2013-04-28','09:20:00',1.3),('3355','2013-04-28','09:25:00',1.34),('3355','2013-04-28','09:30:00',1.38),('3355','2013-04-28','09:35:00',1.43),('3355','2013-04-28','09:40:00',1.47),('3355','2013-04-28','09:45:00',1.52),('3355','2013-04-28','09:50:00',1.56),('3355','2013-04-28','09:55:00',1.6),('3355','2013-04-28','10:00:00',1.63),('3355','2013-04-28','10:05:00',1.65),('3355','2013-04-28','10:10:00',1.69),('3355','2013-04-28','10:15:00',1.68),('3355','2013-04-28','10:20:00',1.75),('3355','2013-04-28','10:25:00',1.82),('3355','2013-04-28','10:30:00',1.8),('3355','2013-04-28','10:35:00',1.85),('3355','2013-04-28','10:40:00',1.67),('3355','2013-04-28','10:45:00',1.92),('3355','2013-04-28','10:50:00',1.93),('3355','2013-04-28','10:55:00',1.95),('3355','2013-04-28','11:00:00',1.98),('3355','2013-04-28','11:05:00',2),('3355','2013-04-28','11:10:00',2.04),('3355','2013-04-28','11:15:00',2.06),('3355','2013-04-28','11:20:00',2.05),('3355','2013-04-28','11:25:00',2.08),('3355','2013-04-28','11:30:00',2.11),('3355','2013-04-28','11:35:00',2.06),('3355','2013-04-28','11:40:00',2.09),('3355','2013-04-28','11:45:00',2),('3355','2013-04-28','11:50:00',2.05),('3355','2013-04-28','11:55:00',2.12),('3355','2013-04-28','12:00:00',1.89),('3355','2013-04-28','12:05:00',1.87),('3355','2013-04-28','12:10:00',2.07),('3355','2013-04-28','12:15:00',2.14),('3355','2013-04-28','12:20:00',2.09),('3355','2013-04-28','12:25:00',1.88),('3355','2013-04-28','12:30:00',1.79),('3355','2013-04-28','12:35:00',1.56),('3355','2013-04-28','12:40:00',1.63),('3355','2013-04-28','12:45:00',2.14),('3355','2013-04-28','12:50:00',2.23),('3355','2013-04-28','12:55:00',2.05),('3355','2013-04-28','13:00:00',2.12),('3355','2013-04-28','13:05:00',2.31),('3355','2013-04-28','13:10:00',2.24),('3355','2013-04-28','13:15:00',2.04),('3355','2013-04-28','13:20:00',2.13),('3355','2013-04-28','13:25:00',2.08),('3355','2013-04-28','13:30:00',2.22),('3355','2013-04-28','13:35:00',2.22),('3355','2013-04-28','13:40:00',2.36),('3355','2013-04-28','13:45:00',1.92),('3355','2013-04-28','13:50:00',2.03),('3355','2013-04-28','13:55:00',2.31),('3355','2013-04-28','14:00:00',2.26),('3355','2013-04-28','14:05:00',2.23),('3355','2013-04-28','14:10:00',2.15),('3355','2013-04-28','14:15:00',2.12),('3355','2013-04-28','14:20:00',2.21),('3355','2013-04-28','14:25:00',2.17),('3355','2013-04-28','14:30:00',2.15),('3355','2013-04-28','14:35:00',2.16),('3355','2013-04-28','14:40:00',2.14),('3355','2013-04-28','14:45:00',2.11),('3355','2013-04-28','14:50:00',2.09),('3355','2013-04-28','14:55:00',2.07),('3355','2013-04-28','15:00:00',2.05),('3355','2013-04-28','15:05:00',2.03),('3355','2013-04-28','15:10:00',2.03),('3355','2013-04-28','15:15:00',2),('3355','2013-04-28','15:20:00',1.98),('3355','2013-04-28','15:25:00',1.95),('3355','2013-04-28','15:30:00',1.93),('3355','2013-04-28','15:35:00',1.91),('3355','2013-04-28','15:40:00',1.89),('3355','2013-04-28','15:45:00',1.87),('3355','2013-04-28','15:50:00',1.84),('3355','2013-04-28','15:55:00',1.81),('3355','2013-04-28','16:00:00',1.78),('3355','2013-04-28','16:05:00',1.75),('3355','2013-04-28','16:10:00',1.71),('3355','2013-04-28','16:15:00',1.68),('3355','2013-04-28','16:20:00',1.65),('3355','2013-04-28','16:25:00',1.61),('3355','2013-04-28','16:30:00',1.58),('3355','2013-04-28','16:35:00',1.54),('3355','2013-04-28','16:40:00',1.5),('3355','2013-04-28','16:45:00',1.47),('3355','2013-04-28','16:50:00',1.43),('3355','2013-04-28','16:55:00',1.39),('3355','2013-04-28','17:00:00',1.35),('3355','2013-04-28','17:05:00',1.26),('3355','2013-04-28','17:10:00',1.18),('3355','2013-04-28','17:15:00',1.24),('3355','2013-04-28','17:20:00',1.18),('3355','2013-04-28','17:25:00',1.15),('3355','2013-04-27','13:40:00',1.03),('3355','2013-04-27','14:30:00',1.19),('3355','2013-04-27','15:05:00',1.01),('3355','2013-04-27','16:55:00',1.3),('3355','2013-04-27','17:00:00',1.6),('3355','2013-04-26','09:40:00',1.11),('3355','2013-04-26','09:45:00',1.4),('3355','2013-04-26','09:50:00',1.31),('3355','2013-04-26','10:05:00',1.28),('3355','2013-04-26','10:10:00',1.59),('3355','2013-04-26','10:15:00',1.6),('3355','2013-04-26','10:20:00',1.62),('3355','2013-04-26','10:25:00',1.27),('3355','2013-04-26','10:30:00',1.78),('3355','2013-04-26','10:35:00',1.84),('3355','2013-04-26','10:40:00',1.71),('3355','2013-04-26','10:45:00',1.52),('3355','2013-04-26','10:50:00',1.04),('3355','2013-04-26','10:55:00',1.46),('3355','2013-04-26','11:00:00',1.58),('3355','2013-04-26','11:05:00',1.85),('3355','2013-04-26','11:10:00',1.61),('3355','2013-04-26','11:15:00',1.98),('3355','2013-04-26','11:20:00',1.52),('3355','2013-04-26','11:25:00',1.67),('3355','2013-04-26','11:30:00',1.68),('3355','2013-04-26','11:35:00',1.89),('3355','2013-04-26','11:40:00',1.79),('3355','2013-04-26','11:45:00',1.77),('3355','2013-04-26','11:50:00',1.46),('3355','2013-04-26','11:55:00',1.35),('3355','2013-04-26','12:00:00',1.59),('3355','2013-04-26','12:05:00',1.33),('3355','2013-04-26','12:10:00',1.22),('3355','2013-04-26','12:15:00',1.45),('3355','2013-04-26','12:20:00',1.3),('3355','2013-04-26','12:25:00',1.03),('3355','2013-04-26','12:35:00',1.29),('3355','2013-04-26','12:40:00',1.74),('3355','2013-04-26','12:45:00',1.91),('3355','2013-04-26','12:50:00',1.12),('3355','2013-04-26','12:55:00',1.05),('3355','2013-04-26','13:15:00',1.17),('3355','2013-04-26','13:25:00',1.07),('3355','2013-04-26','13:30:00',1.39),('3355','2013-04-26','13:35:00',1.2),('3355','2013-04-26','13:40:00',1.51),('3355','2013-04-26','13:45:00',1.24),('3355','2013-04-26','13:50:00',1.47),('3355','2013-04-26','13:55:00',1.48),('3355','2013-04-26','14:00:00',1.58),('3355','2013-04-26','14:05:00',1.86),('3355','2013-04-26','14:10:00',2.04),('3355','2013-04-26','14:15:00',1.91),('3355','2013-04-26','14:20:00',1.87),('3355','2013-04-26','14:25:00',1.77),('3355','2013-04-26','14:30:00',2.14),('3355','2013-04-26','14:35:00',1.67),('3355','2013-04-26','14:45:00',1.03),('3355','2013-04-26','14:50:00',2.11),('3355','2013-04-26','14:55:00',2.27),('3355','2013-04-26','15:00:00',2.14),('3355','2013-04-26','15:05:00',1.56),('3355','2013-04-26','15:30:00',1.13),('3355','2013-04-26','15:35:00',1.02),('3355','2013-04-26','15:40:00',1.06),('3355','2013-04-26','15:45:00',1.1),('3355','2013-04-26','15:50:00',1.01),('3355','2013-04-25','08:50:00',1.01),('3355','2013-04-25','08:55:00',1.19),('3355','2013-04-25','09:00:00',1.04),('3355','2013-04-25','09:40:00',1.08),('3355','2013-04-25','09:45:00',1.34),('3355','2013-04-25','09:50:00',1.58),('3355','2013-04-25','09:55:00',1.59),('3355','2013-04-25','10:00:00',1.62),('3355','2013-04-25','10:05:00',1.56),('3355','2013-04-25','10:10:00',1.41),('3355','2013-04-25','10:15:00',1.44),('3355','2013-04-25','10:20:00',1.68),('3355','2013-04-25','10:25:00',1.73),('3355','2013-04-25','10:30:00',1.8),('3355','2013-04-25','10:35:00',1.83),('3355','2013-04-25','10:40:00',1.84),('3355','2013-04-25','10:45:00',1.77),('3355','2013-04-25','10:50:00',1.8),('3355','2013-04-25','10:55:00',1.92),('3355','2013-04-25','11:00:00',1.95),('3355','2013-04-25','11:05:00',1.98),('3355','2013-04-25','11:10:00',2),('3355','2013-04-25','11:15:00',2.01),('3355','2013-04-25','11:20:00',2.03),('3355','2013-04-25','11:25:00',2.06),('3355','2013-04-25','11:30:00',2.08),('3355','2013-04-25','11:35:00',2.11),('3355','2013-04-25','11:40:00',2.13),('3355','2013-04-25','11:45:00',2.15),('3355','2013-04-25','11:50:00',2.18),('3355','2013-04-25','11:55:00',2.14),('3355','2013-04-25','12:00:00',2.11),('3355','2013-04-25','12:05:00',2.11),('3355','2013-04-25','12:10:00',2.16),('3355','2013-04-25','12:15:00',2.19),('3355','2013-04-25','12:20:00',2.2),('3355','2013-04-25','12:25:00',2.2),('3355','2013-04-25','12:30:00',2.2),('3355','2013-04-25','12:35:00',2.22),('3355','2013-04-25','12:40:00',2.21),('3355','2013-04-25','12:45:00',2.22),('3355','2013-04-25','12:50:00',2.21),('3355','2013-04-25','12:55:00',2.23),('3355','2013-04-25','13:00:00',2.26),('3355','2013-04-25','13:05:00',2.3),('3355','2013-04-25','13:10:00',2.29),('3355','2013-04-25','13:15:00',2.08),('3355','2013-04-25','13:20:00',1.99),('3355','2013-04-25','13:25:00',1.88),('3355','2013-04-25','13:30:00',1.56),('3355','2013-04-25','13:35:00',1.56),('3355','2013-04-25','13:40:00',1.29),('3355','2013-04-25','13:45:00',1.18),('3355','2013-04-25','13:50:00',1.1),('3355','2013-04-25','13:55:00',1.16),('3355','2013-04-25','14:00:00',1.23),('3355','2013-04-25','14:05:00',1.11),('3355','2013-04-25','14:10:00',1.24),('3355','2013-04-25','14:15:00',1.28),('3355','2013-04-25','14:20:00',1.3),('3355','2013-04-25','14:25:00',1.32),('3355','2013-04-25','14:30:00',1.56),('3355','2013-04-25','14:35:00',1.87),('3355','2013-04-25','14:40:00',1.91),('3355','2013-04-25','14:45:00',1.88),('3355','2013-04-25','14:50:00',1.74),('3355','2013-04-25','14:55:00',1.78),('3355','2013-04-25','15:00:00',1.76),('3355','2013-04-25','15:05:00',1.59),('3355','2013-04-25','15:10:00',1.59),('3355','2013-04-25','15:15:00',1.78),('3355','2013-04-25','15:20:00',1.86),('3355','2013-04-25','15:25:00',1.96),('3355','2013-04-25','15:30:00',1.93),('3355','2013-04-25','15:35:00',1.8),('3355','2013-04-25','15:40:00',1.72),('3355','2013-04-25','15:45:00',1.58),('3355','2013-04-25','15:50:00',1.49),('3355','2013-04-25','15:55:00',1.46),('3355','2013-04-25','16:00:00',1.48),('3355','2013-04-25','16:05:00',1.21),('3355','2013-04-25','16:10:00',1.27),('3355','2013-04-25','16:15:00',1.21),('3355','2013-04-25','16:20:00',1.24),('3355','2013-04-25','16:25:00',1.11),('3355','2013-04-25','16:30:00',1.04),('3355','2013-04-25','16:35:00',1.33),('3355','2013-04-25','16:40:00',1.17),('3355','2013-04-25','16:45:00',1.12),('3355','2013-04-25','16:55:00',1.08),('3355','2013-04-25','17:05:00',1.25),('3355','2013-04-25','17:10:00',1.36),('3355','2013-04-25','17:15:00',1.25),('3355','2013-04-25','17:20:00',1.21),('3355','2013-04-25','17:25:00',1.02),('3355','2013-04-24','09:00:00',1.05),('3355','2013-04-24','09:05:00',1.15),('3355','2013-04-24','09:10:00',1.1),('3355','2013-04-24','09:15:00',1.17),('3355','2013-04-24','09:20:00',1.06),('3355','2013-04-24','09:25:00',1.26),('3355','2013-04-24','09:30:00',1.55),('3355','2013-04-24','09:35:00',1.41),('3355','2013-04-24','09:40:00',1.33),('3355','2013-04-24','09:45:00',1.3),('3355','2013-04-24','09:50:00',1.38),('3355','2013-04-24','09:55:00',1.59),('3355','2013-04-24','10:00:00',1.66),('3355','2013-04-24','10:05:00',1.71),('3355','2013-04-24','10:10:00',1.73),('3355','2013-04-24','10:15:00',1.74),('3355','2013-04-24','10:20:00',1.72),('3355','2013-04-24','10:25:00',1.71),('3355','2013-04-24','10:30:00',1.7),('3355','2013-04-24','10:35:00',1.7),('3355','2013-04-24','10:40:00',1.88),('3355','2013-04-24','10:45:00',1.93),('3355','2013-04-24','10:50:00',1.95),('3355','2013-04-24','10:55:00',2),('3355','2013-04-24','11:00:00',2.03),('3355','2013-04-24','11:05:00',1.98),('3355','2013-04-24','11:10:00',2.11),('3355','2013-04-24','11:15:00',2.17),('3355','2013-04-24','11:20:00',2.21),('3355','2013-04-24','11:25:00',2.22),('3355','2013-04-24','11:30:00',2.17),('3355','2013-04-24','11:35:00',1.92),('3355','2013-04-24','11:40:00',1.36),('3355','2013-04-24','11:45:00',1.62),('3355','2013-04-24','11:50:00',1.11),('3355','2013-04-24','11:55:00',1.56),('3355','2013-04-24','12:00:00',1.97),('3355','2013-04-24','12:05:00',1.24),('3355','2013-04-24','12:10:00',1.45),('3355','2013-04-24','12:15:00',2.12),('3355','2013-04-24','12:20:00',2.47),('3355','2013-04-24','12:25:00',2.16),('3355','2013-04-24','12:30:00',2.09),('3355','2013-04-24','12:35:00',2.15),('3355','2013-04-24','12:40:00',2.02),('3355','2013-04-24','12:45:00',2.08),('3355','2013-04-24','12:50:00',2.24),('3355','2013-04-24','12:55:00',2.17),('3355','2013-04-24','13:00:00',2.13),('3355','2013-04-24','13:05:00',1.83),('3355','2013-04-24','13:10:00',2.4),('3355','2013-04-24','13:15:00',2.21),('3355','2013-04-24','13:20:00',2.13),('3355','2013-04-24','13:25:00',2.18),('3355','2013-04-24','13:30:00',2.08),('3355','2013-04-24','13:35:00',2.11),('3355','2013-04-24','13:40:00',2.36),('3355','2013-04-24','13:45:00',2.07),('3355','2013-04-24','13:50:00',1.4),('3355','2013-04-24','13:55:00',2.26),('3355','2013-04-24','14:00:00',2.29),('3355','2013-04-24','14:05:00',1.6),('3355','2013-04-24','14:10:00',1.52),('3355','2013-04-24','14:15:00',2.29),('3355','2013-04-24','14:20:00',2.06),('3355','2013-04-24','14:25:00',2.13),('3355','2013-04-24','14:30:00',2.02),('3355','2013-04-24','14:35:00',1.78),('3355','2013-04-24','14:40:00',1.72),('3355','2013-04-24','14:45:00',1.65),('3355','2013-04-24','14:50:00',1.48),('3355','2013-04-24','14:55:00',1.3),('3355','2013-04-24','15:00:00',1.43),('3355','2013-04-24','15:05:00',1.3),('3355','2013-04-24','15:10:00',1.23),('3355','2013-04-24','15:15:00',1.29),('3355','2013-04-24','15:20:00',1.36),('3355','2013-04-24','15:25:00',1.16),('3355','2013-04-24','15:55:00',1.16),('3355','2013-04-24','16:00:00',1.52),('3355','2013-04-24','16:05:00',1.57),('3355','2013-04-24','16:10:00',1.56),('3355','2013-04-24','16:15:00',1.43),('3355','2013-04-24','16:20:00',1.88),('3355','2013-04-24','16:25:00',1.45),('3355','2013-04-24','16:30:00',1.27),('3355','2013-04-24','16:35:00',1.01),('3355','2013-04-24','16:40:00',1.43),('3355','2013-04-24','16:45:00',1.48),('3355','2013-04-24','16:50:00',1.3),('3355','2013-04-24','16:55:00',1.56),('3355','2013-04-24','17:00:00',1.6),('3355','2013-04-24','17:05:00',1.49),('3355','2013-04-24','17:10:00',1.44),('3355','2013-04-24','17:15:00',1.1),('3355','2013-04-23','08:50:00',1.05),('3355','2013-04-23','08:55:00',1.1),('3355','2013-04-23','09:00:00',1.15),('3355','2013-04-23','09:05:00',1.2),('3355','2013-04-23','09:10:00',1.26),('3355','2013-04-23','09:15:00',1.31),('3355','2013-04-23','09:20:00',1.35),('3355','2013-04-23','09:25:00',1.4),('3355','2013-04-23','09:30:00',1.45),('3355','2013-04-23','09:35:00',1.5),('3355','2013-04-23','09:40:00',1.41),('3355','2013-04-23','09:45:00',1.37),('3355','2013-04-23','09:50:00',1.66),('3355','2013-04-23','09:55:00',1.69),('3355','2013-04-23','10:00:00',1.7),('3355','2013-04-23','10:05:00',1.73),('3355','2013-04-23','10:10:00',1.78),('3355','2013-04-23','10:15:00',1.81),('3355','2013-04-23','10:20:00',1.85),('3355','2013-04-23','10:25:00',1.87),('3355','2013-04-23','10:30:00',1.91),('3355','2013-04-23','10:35:00',1.94),('3355','2013-04-23','10:40:00',1.97),('3355','2013-04-23','10:45:00',1.96),('3355','2013-04-23','10:50:00',1.98),('3355','2013-04-23','10:55:00',2.04),('3355','2013-04-23','11:00:00',2.08),('3355','2013-04-23','11:05:00',2.09),('3355','2013-04-23','11:10:00',2.1),('3355','2013-04-23','11:15:00',2.12),('3355','2013-04-23','11:20:00',2.15),('3355','2013-04-23','11:25:00',2.18),('3355','2013-04-23','11:30:00',2.2),('3355','2013-04-23','11:35:00',2.2),('3355','2013-04-23','11:40:00',2.21),('3355','2013-04-23','11:45:00',2.23),('3355','2013-04-23','11:50:00',2.24),('3355','2013-04-23','11:55:00',2.25),('3355','2013-04-23','12:00:00',2.26),('3355','2013-04-23','12:05:00',2.23),('3355','2013-04-23','12:10:00',2.27),('3355','2013-04-23','12:15:00',2.26),('3355','2013-04-23','12:20:00',2.27),('3355','2013-04-23','12:25:00',2.26),('3355','2013-04-23','12:35:00',1.83),('3355','2013-04-23','12:40:00',1.28),('3355','2013-04-23','12:50:00',1.81),('3355','2013-04-23','13:00:00',1.98),('3355','2013-04-23','13:05:00',1.33),('3355','2013-04-23','13:15:00',2.44),('3355','2013-04-23','13:20:00',2.31),('3355','2013-04-23','13:25:00',2.54),('3355','2013-04-23','13:30:00',2.42),('3355','2013-04-23','13:35:00',2.46),('3355','2013-04-23','13:40:00',2.43),('3355','2013-04-23','13:45:00',1.72),('3355','2013-04-23','13:50:00',2.15),('3355','2013-04-23','13:55:00',2.27),('3355','2013-04-23','14:00:00',1.12),('3355','2013-04-23','14:05:00',2.57),('3355','2013-04-23','14:10:00',1.66),('3355','2013-04-23','14:15:00',2.21),('3355','2013-04-23','14:20:00',2.18),('3355','2013-04-23','14:25:00',2.01),('3355','2013-04-23','15:05:00',1.35),('3355','2013-04-23','15:10:00',1.62),('3355','2013-04-23','15:15:00',1.65),('3355','2013-04-23','15:20:00',1.5),('3355','2013-04-23','15:25:00',1.38),('3355','2013-04-23','15:30:00',1.35),('3355','2013-04-23','15:35:00',1.3),('3355','2013-04-23','15:40:00',1.16),('3355','2013-04-23','15:45:00',1.2),('3355','2013-04-23','15:50:00',1.01),('3355','2013-04-23','17:15:00',1.27),('3355','2013-04-23','17:20:00',1.27),('3355','2013-04-23','17:25:00',1.05),('3355','2013-04-22','10:35:00',1.17),('3355','2013-04-22','10:40:00',2.03),('3355','2013-04-22','10:45:00',2.62),('3355','2013-04-22','10:50:00',1.24),('3355','2013-04-22','10:55:00',1.18),('3355','2013-04-22','11:00:00',1.09),('3355','2013-04-22','11:05:00',1.03),('3355','2013-04-22','11:10:00',1.18),('3355','2013-04-22','11:25:00',1.01),('3355','2013-04-22','11:30:00',1.65),('3355','2013-04-22','11:35:00',1.86),('3355','2013-04-22','11:40:00',2.01),('3355','2013-04-22','11:55:00',2.31),('3355','2013-04-22','12:00:00',1.5),('3355','2013-04-22','12:05:00',1.75),('3355','2013-04-22','12:10:00',2.65),('3355','2013-04-22','12:15:00',1.89),('3355','2013-04-22','12:20:00',2.23),('3355','2013-04-22','12:25:00',1.32),('3355','2013-04-22','12:30:00',1.52),('3355','2013-04-22','12:35:00',1.63),('3355','2013-04-22','12:40:00',2.45),('3355','2013-04-22','12:45:00',2.39),('3355','2013-04-22','12:50:00',2.53),('3355','2013-04-22','12:55:00',2.55),('3355','2013-04-22','13:00:00',2.55),('3355','2013-04-22','13:05:00',2.65),('3355','2013-04-22','13:10:00',2.66),('3355','2013-04-22','13:15:00',2.52),('3355','2013-04-22','13:20:00',2.24),('3355','2013-04-22','13:25:00',1.3),('3355','2013-04-22','13:30:00',1.66),('3355','2013-04-22','13:35:00',1.42),('3355','2013-04-22','13:40:00',1.65),('3355','2013-04-22','13:45:00',2.45),('3355','2013-04-22','14:20:00',2.37),('3355','2013-04-22','14:25:00',2.29),('3355','2013-04-22','14:30:00',2.64),('3355','2013-04-22','14:35:00',1.46),('3355','2013-04-22','14:45:00',2.52),('3355','2013-04-22','14:50:00',2.57),('3355','2013-04-22','14:55:00',2.23),('3355','2013-04-22','15:00:00',1.85),('3355','2013-04-22','15:05:00',2.5),('3355','2013-04-22','15:10:00',1.15),('3355','2013-04-22','15:30:00',1.22),('3355','2013-04-22','15:40:00',1.24),('3355','2013-04-22','15:45:00',1.93),('3355','2013-04-22','15:50:00',1.44),('3355','2014-03-29','08:15:00',1),('3355','2014-03-29','08:20:00',1.06),('3355','2014-03-29','08:25:00',1.1),('3355','2014-03-29','08:30:00',1.15),('3355','2014-03-29','08:35:00',1.2),('3355','2014-03-29','08:40:00',1.24),('3355','2014-03-29','08:45:00',1.29),('3355','2014-03-29','08:50:00',1.33),('3355','2014-03-29','08:55:00',1.36),('3355','2014-03-29','09:00:00',1.41),('3355','2014-03-29','09:05:00',1.45),('3355','2014-03-29','09:10:00',1.5),('3355','2014-03-29','09:15:00',1.54),('3355','2014-03-29','09:20:00',1.58),('3355','2014-03-29','09:25:00',1.63),('3355','2014-03-29','09:30:00',1.65),('3355','2014-03-29','09:35:00',1.7),('3355','2014-03-29','09:40:00',1.74),('3355','2014-03-29','09:45:00',1.77),('3355','2014-03-29','09:50:00',1.82),('3355','2014-03-29','09:55:00',1.87),('3355','2014-03-29','10:00:00',1.9),('3355','2014-03-29','10:05:00',1.93),('3355','2014-03-29','10:10:00',1.96),('3355','2014-03-29','10:15:00',1.99),('3355','2014-03-29','10:20:00',2.02),('3355','2014-03-29','10:25:00',2.04),('3355','2014-03-29','10:30:00',2.05),('3355','2014-03-29','10:35:00',2.08),('3355','2014-03-29','10:40:00',2.08),('3355','2014-03-29','10:45:00',2.11),('3355','2014-03-29','10:50:00',2.14),('3355','2014-03-29','10:55:00',2.16),('3355','2014-03-29','11:00:00',2.17),('3355','2014-03-29','11:05:00',2.18),('3355','2014-03-29','11:10:00',2.21),('3355','2014-03-29','11:15:00',2.23),('3355','2014-03-29','11:20:00',2.22),('3355','2014-03-29','11:25:00',2.24),('3355','2014-03-29','11:30:00',2.22),('3355','2014-03-29','11:35:00',2.24),('3355','2014-03-29','11:40:00',2.2),('3355','2014-03-29','11:45:00',2.29),('3355','2014-03-29','11:50:00',2.28),('3355','2014-03-29','11:55:00',2.26),('3355','2014-03-29','12:00:00',2.26),('3355','2014-03-29','12:05:00',2.27),('3355','2014-03-29','12:10:00',2.28),('3355','2014-03-29','12:15:00',2.29),('3355','2014-03-29','12:20:00',2.31),('3355','2014-03-29','12:25:00',2.3),('3355','2014-03-29','12:30:00',2.32),('3355','2014-03-29','12:35:00',2.31),('3355','2014-03-29','12:40:00',2.28),('3355','2014-03-29','12:45:00',2.3),('3355','2014-03-29','12:50:00',2.3),('3355','2014-03-29','12:55:00',2.3),('3355','2014-03-29','13:00:00',2.29),('3355','2014-03-29','13:05:00',2.28),('3355','2014-03-29','13:10:00',2.27),('3355','2014-03-29','13:15:00',2.24),('3355','2014-03-29','13:20:00',2.24),('3355','2014-03-29','13:25:00',2.19),('3355','2014-03-29','13:30:00',2.18),('3355','2014-03-29','13:35:00',2.15),('3355','2014-03-29','13:40:00',2.12),('3355','2014-03-29','13:45:00',2.09),('3355','2014-03-29','13:50:00',2.09),('3355','2014-03-29','13:55:00',2.06),('3355','2014-03-29','14:00:00',2.05),('3355','2014-03-29','14:05:00',2.05),('3355','2014-03-29','14:10:00',2.03),('3355','2014-03-29','14:15:00',1.99),('3355','2014-03-29','14:20:00',1.85),('3355','2014-03-29','14:25:00',1.95),('3355','2014-03-29','14:30:00',1.89),('3355','2014-03-29','14:35:00',1.84),('3355','2014-03-29','14:40:00',1.83),('3355','2014-03-29','14:45:00',1.79),('3355','2014-03-29','14:50:00',1.78),('3355','2014-03-29','14:55:00',1.81),('3355','2014-03-29','15:00:00',1.76),('3355','2014-03-29','15:05:00',1.72),('3355','2014-03-29','15:10:00',1.61),('3355','2014-03-29','15:15:00',1.63),('3355','2014-03-29','15:20:00',1.62),('3355','2014-03-29','15:25:00',1.57),('3355','2014-03-29','15:30:00',1.49),('3355','2014-03-29','15:35:00',1.42),('3355','2014-03-29','15:40:00',1.41),('3355','2014-03-29','15:45:00',1.38),('3355','2014-03-29','15:50:00',1.34),('3355','2014-03-29','15:55:00',1.3),('3355','2014-03-29','16:00:00',1.26),('3355','2014-03-29','16:05:00',1.2),('3355','2014-03-29','16:10:00',1.15),('3355','2014-03-29','16:15:00',1.11),('3355','2014-03-29','16:20:00',1.01),('3355','2013-04-21','09:10:00',1.22),('3355','2013-04-21','09:15:00',1.33),('3355','2013-04-21','09:30:00',1.53),('3355','2013-04-21','09:35:00',1.58),('3355','2013-04-21','09:40:00',1.57),('3355','2013-04-21','09:45:00',1.71),('3355','2013-04-21','09:50:00',1.86),('3355','2013-04-21','09:55:00',1.59),('3355','2013-04-21','10:00:00',1.55),('3355','2013-04-21','10:05:00',1.37),('3355','2013-04-21','10:10:00',1.07),('3355','2013-04-21','10:20:00',1.44),('3355','2013-04-21','10:25:00',1.79),('3355','2013-04-21','10:30:00',1.65),('3355','2013-04-21','10:35:00',1.27),('3355','2013-04-21','10:40:00',1.76),('3355','2013-04-21','10:45:00',1.59),('3355','2013-04-21','10:50:00',2.03),('3355','2013-04-21','10:55:00',1.86),('3355','2013-04-21','11:00:00',1.95),('3355','2013-04-21','11:05:00',2),('3355','2013-04-21','11:10:00',2.43),('3355','2013-04-21','11:15:00',1.59),('3355','2013-04-21','11:20:00',1.71),('3355','2013-04-21','11:25:00',1.77),('3355','2013-04-21','11:30:00',1.61),('3355','2013-04-21','11:35:00',1.68),('3355','2013-04-21','11:40:00',2.04),('3355','2013-04-21','11:45:00',2.03),('3355','2013-04-21','11:50:00',1.8),('3355','2013-04-21','11:55:00',1.77),('3355','2013-04-21','12:00:00',1.38),('3355','2013-04-21','12:05:00',1.34),('3355','2013-04-21','12:10:00',1.3),('3355','2013-04-21','12:15:00',1.22),('3355','2013-04-21','12:20:00',1.12),('3355','2013-04-21','12:25:00',1.07),('3355','2013-04-21','12:30:00',1.18),('3355','2013-04-21','12:35:00',1.2),('3355','2013-04-21','12:40:00',1.22),('3355','2013-04-21','12:45:00',1.22),('3355','2013-04-21','12:50:00',1.13),('3355','2013-04-21','12:55:00',1.11),('3355','2013-04-21','13:00:00',1.27),('3355','2013-04-21','13:05:00',1.47),('3355','2013-04-21','13:10:00',1.49),('3355','2013-04-21','13:15:00',1.42),('3355','2013-04-21','13:20:00',1.31),('3355','2013-04-21','13:25:00',1.25),('3355','2013-04-21','13:30:00',1.9),('3355','2013-04-21','13:35:00',2.12),('3355','2013-04-21','13:40:00',1.64),('3355','2013-04-21','13:45:00',1.69),('3355','2013-04-21','13:50:00',1.34),('3355','2013-04-21','13:55:00',2.39),('3355','2013-04-21','14:00:00',2.61),('3355','2013-04-21','14:05:00',2.25),('3355','2013-04-21','14:10:00',2.46),('3355','2013-04-21','14:15:00',2.14),('3355','2013-04-21','14:20:00',2.72),('3355','2013-04-21','14:25:00',2.24),('3355','2013-04-21','14:30:00',2.19),('3355','2013-04-21','14:35:00',2.18),('3355','2013-04-21','14:40:00',2.54),('3355','2013-04-21','14:45:00',2.12),('3355','2013-04-21','14:50:00',1.27),('3355','2013-04-21','14:55:00',1.2),('3355','2013-04-21','15:00:00',1.76),('3355','2013-04-21','15:05:00',2.54),('3355','2013-04-21','15:10:00',2.44),('3355','2013-04-21','15:15:00',1.98),('3355','2013-04-21','15:20:00',1.29),('3355','2013-04-21','15:25:00',1.1),('3355','2013-04-20','09:00:00',1.12),('3355','2013-04-20','09:05:00',1.15),('3355','2013-04-20','09:10:00',1.14),('3355','2013-04-20','09:15:00',1.16),('3355','2013-04-20','09:20:00',1.34),('3355','2013-04-20','09:25:00',1.29),('3355','2013-04-20','10:50:00',1.28),('3355','2013-04-20','10:55:00',1.16),('3355','2013-04-20','11:00:00',1.35),('3355','2013-04-20','11:10:00',1.18),('3355','2013-04-20','11:15:00',2.41),('3355','2013-04-20','11:20:00',1.34),('3355','2013-04-20','11:25:00',1.46),('3355','2013-04-20','11:30:00',2.42),('3355','2013-04-20','11:35:00',1.81),('3355','2013-04-20','11:40:00',1.36),('3355','2013-04-20','11:45:00',1.41),('3355','2013-04-20','11:55:00',2.35),('3355','2013-04-20','12:00:00',2.38),('3355','2013-04-20','12:10:00',2.15),('3355','2013-04-20','12:15:00',1.48),('3355','2013-04-20','12:20:00',1.4),('3355','2013-04-20','12:25:00',1.7),('3355','2013-04-20','12:30:00',2.63),('3355','2013-04-20','12:35:00',2.03),('3355','2013-04-20','13:55:00',2.67),('3355','2013-04-20','14:00:00',1.37),('3355','2013-04-20','14:30:00',2.26),('3355','2013-04-20','14:35:00',2.24),('3355','2013-04-20','14:40:00',2.23),('3355','2013-04-20','14:45:00',2.24),('3355','2013-04-20','14:50:00',2.25),('3355','2013-04-20','14:55:00',2.26),('3355','2013-04-20','15:00:00',2.24),('3355','2013-04-20','15:05:00',2.21),('3355','2013-04-20','15:10:00',1.31),('3355','2013-04-20','15:15:00',1.67),('3355','2013-04-20','15:20:00',1.54),('3355','2013-04-20','15:25:00',1.97),('3355','2013-04-20','15:30:00',1.26),('3355','2013-04-20','16:15:00',1.21),('3355','2013-04-20','16:20:00',1.21),('3355','2013-04-20','16:25:00',1.49),('3355','2013-04-20','16:30:00',1.7),('3355','2013-04-20','16:35:00',1.58),('3355','2013-04-20','16:40:00',1.72),('3355','2013-04-20','16:45:00',1.79),('3355','2013-04-20','16:50:00',1.62),('3355','2013-04-20','16:55:00',1.56),('3355','2013-04-20','17:00:00',1.48),('3355','2013-04-20','17:05:00',1.42),('3355','2013-04-20','17:10:00',1.39),('3355','2013-04-20','17:15:00',1.28),('3355','2013-04-20','17:20:00',1.17),('3355','2013-04-20','17:25:00',1.13),('3355','2013-04-20','17:30:00',1.19),('3355','2013-04-20','17:35:00',1.28),('3355','2013-04-20','17:40:00',1.18),('3355','2013-04-20','17:55:00',1.05),('3355','2013-04-18','09:05:00',1.08),('3355','2013-04-18','09:15:00',1.14),('3355','2013-04-18','09:20:00',1.23),('3355','2013-04-18','09:25:00',1.29),('3355','2013-04-18','09:30:00',1.32),('3355','2013-04-18','09:35:00',1.36),('3355','2013-04-18','09:40:00',1.53),('3355','2013-04-18','09:45:00',1.38),('3355','2013-04-18','09:50:00',1.22),('3355','2013-04-18','09:55:00',1.27),('3355','2013-04-18','10:00:00',1.54),('3355','2013-04-18','10:05:00',1.64),('3355','2013-04-18','10:10:00',1.71),('3355','2013-04-18','10:15:00',1.76),('3355','2013-04-18','10:20:00',1.79),('3355','2013-04-18','10:25:00',1.77),('3355','2013-04-18','10:30:00',1.83),('3355','2013-04-18','10:35:00',1.86),('3355','2013-04-18','10:40:00',1.89),('3355','2013-04-18','10:45:00',1.92),('3355','2013-04-18','10:50:00',1.95),('3355','2013-04-18','10:55:00',1.97),('3355','2013-04-18','11:00:00',1.99),('3355','2013-04-18','11:05:00',2.03),('3355','2013-04-18','11:10:00',2.04),('3355','2013-04-18','11:15:00',2.07),('3355','2013-04-18','11:20:00',2.09),('3355','2013-04-18','11:25:00',2.11),('3355','2013-04-18','11:30:00',2.12),('3355','2013-04-18','11:35:00',2.15),('3355','2013-04-18','11:40:00',2.15),('3355','2013-04-18','11:45:00',2.15),('3355','2013-04-18','11:50:00',2.16),('3355','2013-04-18','11:55:00',2.2),('3355','2013-04-18','12:00:00',2.19),('3355','2013-04-18','12:05:00',2.23),('3355','2013-04-18','12:10:00',2.26),('3355','2013-04-18','12:15:00',2.28),('3355','2013-04-18','12:20:00',2.29),('3355','2013-04-18','12:25:00',2.31),('3355','2013-04-18','12:30:00',2.3),('3355','2013-04-18','12:35:00',2.33),('3355','2013-04-18','12:40:00',2.33),('3355','2013-04-18','12:45:00',2.33),('3355','2013-04-18','12:50:00',2.34),('3355','2013-04-18','12:55:00',2.33),('3355','2013-04-18','13:00:00',2.34),('3355','2013-04-18','13:05:00',2.35),('3355','2013-04-18','13:10:00',2.36),('3355','2013-04-18','13:15:00',2.36),('3355','2013-04-18','13:20:00',2.34),('3355','2013-04-18','13:25:00',2.35),('3355','2013-04-18','13:30:00',2.36),('3355','2013-04-18','13:35:00',2.35),('3355','2013-04-18','13:40:00',2.35),('3355','2013-04-18','13:45:00',2.34),('3355','2013-04-18','13:50:00',2.34),('3355','2013-04-18','13:55:00',2.35),('3355','2013-04-18','14:00:00',2.34),('3355','2013-04-18','14:05:00',2.32),('3355','2013-04-18','14:10:00',2.33),('3355','2013-04-18','14:15:00',2.32),('3355','2013-04-18','14:20:00',2.31),('3355','2013-04-18','14:25:00',2.3),('3355','2013-04-18','14:50:00',2.21),('3355','2013-04-18','14:55:00',2.2),('3355','2014-03-28','08:15:00',1.04),('3355','2014-03-28','08:20:00',1.1),('3355','2014-03-28','08:25:00',1.14),('3355','2014-03-28','08:30:00',1.19),('3355','2014-03-28','08:35:00',1.24),('3355','2014-03-28','08:40:00',1.29),('3355','2014-03-28','08:45:00',1.34),('3355','2014-03-28','08:50:00',1.39),('3355','2014-03-28','08:55:00',1.45),('3355','2014-03-28','09:00:00',1.47),('3355','2014-03-28','09:05:00',1.56),('3355','2014-03-28','09:10:00',1.67),('3355','2014-03-28','09:15:00',1.67),('3355','2014-03-28','09:20:00',1.44),('3355','2014-03-28','09:25:00',1.72),('3355','2014-03-28','09:30:00',1.85),('3355','2014-03-28','09:35:00',1.7),('3355','2014-03-28','09:40:00',1.15),('3355','2014-03-28','09:50:00',1.15),('3355','2014-03-28','09:55:00',1.78),('3355','2014-03-28','10:00:00',2.06),('3355','2014-03-28','10:05:00',1.99),('3355','2014-03-28','10:10:00',1.58),('3355','2014-03-28','10:15:00',1.55),('3355','2014-03-28','10:20:00',1.47),('3355','2014-03-28','10:25:00',1.96),('3355','2014-03-28','10:30:00',2.08),('3355','2014-03-28','10:35:00',1.9),('3355','2014-03-28','10:40:00',1.97),('3355','2014-03-28','10:45:00',1.58),('3355','2014-03-28','10:50:00',2.07),('3355','2014-03-28','10:55:00',2.24),('3355','2014-03-28','11:00:00',2.25),('3355','2014-03-28','11:05:00',2.25),('3355','2014-03-28','11:10:00',1.72),('3355','2014-03-28','11:15:00',2.29),('3355','2014-03-28','11:20:00',2.28),('3355','2014-03-28','11:25:00',1.59),('3355','2014-03-28','11:30:00',1.51),('3355','2014-03-28','11:35:00',2.62),('3355','2014-03-28','11:40:00',1.13),('3355','2014-03-28','12:10:00',2.65),('3355','2014-03-28','12:15:00',2.7),('3355','2014-03-28','12:20:00',2.49),('3355','2014-03-28','12:25:00',1),('3355','2014-03-28','12:30:00',1.25),('3355','2014-03-28','12:35:00',2.1),('3355','2014-03-28','12:40:00',1.83),('3355','2014-03-28','12:45:00',2.5),('3355','2014-03-28','12:50:00',2.45),('3355','2014-03-28','12:55:00',2.58),('3355','2014-03-28','13:00:00',2.15),('3355','2014-03-28','13:05:00',1.45),('3355','2014-03-28','13:20:00',2.57),('3355','2014-03-28','13:25:00',1.59),('3355','2014-03-28','13:35:00',2.47),('3355','2014-03-28','13:40:00',2.13),('3355','2014-03-28','13:45:00',2.34),('3355','2014-03-28','13:50:00',2.28),('3355','2014-03-28','13:55:00',2.19),('3355','2014-03-28','14:00:00',2.24),('3355','2014-03-28','14:05:00',2.2),('3355','2014-03-28','14:10:00',2.13),('3355','2014-03-28','14:15:00',2.15),('3355','2014-03-28','14:20:00',2.13),('3355','2014-03-28','14:25:00',2.1),('3355','2014-03-28','14:30:00',2.07),('3355','2014-03-28','14:35:00',2.06),('3355','2014-03-28','14:40:00',2.03),('3355','2014-03-28','14:45:00',2),('3355','2014-03-28','14:50:00',1.97),('3355','2014-03-28','14:55:00',1.93),('3355','2014-03-28','15:00:00',1.93),('3355','2014-03-28','15:05:00',1.89),('3355','2014-03-28','15:10:00',1.84),('3355','2014-03-28','15:15:00',1.8),('3355','2014-03-28','15:20:00',1.76),('3355','2014-03-28','15:25:00',1.71),('3355','2014-03-28','15:30:00',1.68),('3355','2014-03-28','15:35:00',1.64),('3355','2014-03-28','15:40:00',1.6),('3355','2014-03-28','15:45:00',1.6),('3355','2014-03-28','15:50:00',1.57),('3355','2014-03-28','15:55:00',1.51),('3355','2014-03-28','16:00:00',1.54),('3355','2014-03-28','16:05:00',1.56),('3355','2014-03-28','16:10:00',1.52),('3355','2014-03-28','16:15:00',1.48),('3355','2014-03-28','16:20:00',1.31),('3355','2014-03-28','16:25:00',1.15),('3355','2014-05-02','10:10:00',1.04),('3355','2014-05-02','13:05:00',1.01),('3355','2014-05-02','13:10:00',1.1),('3355','2014-05-02','13:15:00',1.17),('3355','2014-05-02','13:20:00',1.73),('3355','2014-05-02','13:25:00',1.61),('3355','2014-05-02','13:30:00',1.31),('3355','2014-05-02','13:35:00',1.23),('3355','2014-05-02','13:40:00',1.26),('3355','2014-05-02','13:45:00',1.25),('3355','2014-05-02','14:35:00',1.04),('3355','2014-05-02','14:40:00',1.43),('3355','2014-05-02','14:45:00',1.24),('3355','2014-05-02','14:55:00',1.02),('3355','2014-05-02','15:00:00',1.78),('3355','2014-05-02','15:05:00',1.32),('3355','2014-05-02','15:10:00',1.68),('3355','2014-05-02','15:15:00',2.34),('3355','2014-05-02','15:35:00',1.41),('3355','2014-05-02','15:40:00',2.22),('3355','2014-05-02','16:20:00',1.58),('3355','2014-03-27','10:30:00',1.22),('3355','2014-03-27','10:35:00',1.06),('3355','2014-03-27','10:40:00',1.32),('3355','2014-03-27','11:10:00',1.37),('3355','2014-03-27','11:15:00',2.6),('3355','2014-03-27','11:20:00',1.3),('3355','2014-03-27','13:15:00',1.09),('3355','2014-03-27','13:20:00',1.21),('3355','2014-03-27','13:25:00',1.32),('3355','2014-03-27','13:30:00',1.14),('3355','2014-03-27','13:35:00',1.06),('3355','2014-03-27','13:50:00',1.15),('3355','2014-03-27','13:55:00',1.47),('3355','2014-03-27','14:00:00',1.42),('3355','2014-03-27','14:15:00',1.19),('3355','2014-03-27','14:20:00',1.9),('3355','2014-03-27','14:25:00',2.07),('3355','2014-03-27','14:30:00',1.74),('3355','2014-03-27','14:35:00',1.4),('3355','2014-03-27','14:50:00',1.12),('3355','2014-03-27','14:55:00',1.52),('3355','2014-03-27','15:00:00',1.03),('3355','2014-03-27','15:25:00',1.3),('3355','2014-03-27','15:30:00',1.39),('3355','2014-03-26','08:15:00',1.1),('3355','2014-03-26','08:20:00',1.22),('3355','2014-03-26','09:30:00',1.84),('3355','2014-03-26','09:35:00',1.78),('3355','2014-03-26','09:40:00',1.8),('3355','2014-03-26','09:45:00',1.83),('3355','2014-03-26','09:50:00',1.86),('3355','2014-03-26','09:55:00',1.93),('3355','2014-03-26','10:00:00',1.7),('3355','2014-03-26','10:05:00',1.94),('3355','2014-03-26','10:10:00',1.91),('3355','2014-03-26','10:15:00',2.17),('3355','2014-03-26','10:20:00',2.23),('3355','2014-03-26','10:25:00',2.23),('3355','2014-03-26','10:30:00',2.03),('3355','2014-03-26','10:35:00',1.87),('3355','2014-03-26','10:45:00',1.7),('3355','2014-03-26','10:50:00',1.88),('3355','2014-03-26','10:55:00',1.83),('3355','2014-03-26','11:00:00',2.37),('3355','2014-03-26','11:05:00',2.07),('3355','2014-03-26','11:10:00',2.32),('3355','2014-03-26','11:15:00',2.53),('3355','2014-03-26','11:20:00',1.49),('3355','2014-03-26','11:35:00',1.03),('3355','2014-03-26','11:40:00',1.01),('3355','2014-03-26','11:45:00',1.2),('3355','2014-03-26','11:50:00',1.85),('3355','2014-03-26','11:55:00',1.96),('3355','2014-03-26','12:00:00',2.71),('3355','2014-03-26','12:05:00',2.37),('3355','2014-03-26','12:10:00',1.87),('3355','2014-03-26','12:45:00',1.19),('3355','2014-03-26','13:25:00',2.38),('3355','2014-03-26','13:30:00',2.43),('3355','2014-03-26','13:35:00',1.38),('3355','2014-03-26','13:40:00',1.31),('3355','2014-03-26','14:00:00',1.05),('3355','2014-03-26','14:05:00',2),('3355','2014-03-26','14:10:00',2.14),('3355','2014-03-26','14:50:00',1.93),('3355','2014-03-26','14:55:00',2.02),('3355','2014-03-26','15:00:00',1.71),('3355','2014-03-26','15:05:00',1.86),('3355','2014-03-26','15:10:00',1.9),('3355','2014-03-26','15:15:00',1.98),('3355','2014-03-26','15:20:00',1.82),('3355','2014-03-26','15:25:00',1.9),('3355','2014-03-26','15:30:00',1.91),('3355','2014-03-26','15:35:00',1.86),('3355','2014-03-26','15:40:00',1.39),('3355','2014-03-26','15:45:00',1.54),('3355','2014-03-26','15:50:00',1.14),('3355','2014-03-26','15:55:00',1.14),('3355','2014-03-25','08:50:00',1.01),('3355','2014-03-25','08:55:00',1.07),('3355','2014-03-25','09:15:00',1.25),('3355','2014-03-25','09:20:00',1.37),('3355','2014-03-25','09:25:00',1.2),('3355','2014-03-25','09:30:00',1.07),('3355','2014-03-25','09:40:00',1.01),('3355','2014-03-25','09:55:00',1.1),('3355','2014-03-25','10:00:00',1.29),('3355','2014-03-25','10:05:00',1.38),('3355','2014-03-25','10:10:00',1.48),('3355','2014-03-25','10:15:00',1.6),('3355','2014-03-25','10:20:00',1.63),('3355','2014-03-25','10:25:00',1.51),('3355','2014-03-25','10:30:00',1.68),('3355','2014-03-25','10:35:00',1.41),('3355','2014-03-25','10:40:00',1.16),('3355','2014-03-25','10:45:00',1.05),('3355','2014-03-25','10:50:00',1.02),('3355','2014-03-25','10:55:00',1.02),('3355','2014-03-25','11:00:00',1.1),('3355','2014-03-25','11:05:00',1.26),('3355','2014-03-25','11:10:00',1.41),('3355','2014-03-25','11:15:00',1.64),('3355','2014-03-25','11:20:00',1.72),('3355','2014-03-25','11:25:00',1.7),('3355','2014-03-25','11:30:00',1.21),('3355','2014-03-25','11:35:00',1.71),('3355','2014-03-25','11:40:00',1.24),('3355','2014-03-25','11:45:00',1.22),('3355','2014-03-25','11:50:00',1.06),('3355','2014-03-24','09:20:00',1.15),('3355','2014-03-24','10:00:00',1),('3355','2014-03-24','10:05:00',1.22),('3355','2014-03-24','10:10:00',1.74),('3355','2014-03-24','10:15:00',1.62),('3355','2014-03-24','10:50:00',2.61),('3355','2014-03-24','10:55:00',2.3),('3355','2014-03-24','11:05:00',1.45),('3355','2014-03-24','11:10:00',1.44),('3355','2014-03-24','11:15:00',1.6),('3355','2014-03-24','11:20:00',1.14),('3355','2014-03-24','11:25:00',1.45),('3355','2014-03-24','11:30:00',1.91),('3355','2014-03-24','11:35:00',1.06),('3355','2014-03-24','12:40:00',1.1),('3355','2014-03-24','14:20:00',1.16),('3355','2014-03-24','14:25:00',1.14),('3355','2014-03-24','14:35:00',1.28),('3355','2014-03-24','14:40:00',1.66),('3355','2014-03-24','14:45:00',1.94),('3355','2014-03-24','14:50:00',2.08),('3355','2014-03-24','14:55:00',1.83),('3355','2014-03-24','15:00:00',1.62),('3355','2014-03-24','15:05:00',1.44),('3355','2014-03-24','15:10:00',1.27),('3355','2014-03-24','15:30:00',1.05),('3355','2014-03-24','16:00:00',1.72),('3355','2014-03-23','09:10:00',1.37),('3355','2014-03-23','09:15:00',1.39),('3355','2014-03-23','11:40:00',1.53),('3355','2014-03-23','13:45:00',1.17),('3355','2014-03-23','13:50:00',1.11),('3355','2014-03-23','15:15:00',1.08),('3355','2014-03-23','15:25:00',1.06),('3355','2014-03-22','08:45:00',1.23),('3355','2014-03-22','09:00:00',1.12),('3355','2014-03-22','09:30:00',1.18),('3355','2014-03-22','09:45:00',1.63),('3355','2014-03-22','09:50:00',1.66),('3355','2014-03-22','09:55:00',1.71),('3355','2014-03-22','10:00:00',1.75),('3355','2014-03-22','10:05:00',1.81),('3355','2014-03-22','10:10:00',2.07),('3355','2014-03-22','10:15:00',1.09),('3355','2014-03-22','10:40:00',1.18),('3355','2014-03-22','10:45:00',1.53),('3355','2014-03-22','10:50:00',1.88),('3355','2014-03-22','11:20:00',1.41),('3355','2014-03-22','11:25:00',2.15),('3355','2014-03-22','11:30:00',1.75),('3355','2014-03-22','11:40:00',1.22),('3355','2014-03-22','11:45:00',1.16),('3355','2014-03-22','11:50:00',1.23),('3355','2014-03-22','11:55:00',1.64),('3355','2014-03-22','12:00:00',1.52),('3355','2014-03-22','12:05:00',1.11),('3355','2014-03-22','12:15:00',1.63),('3355','2014-03-22','12:20:00',2.56),('3355','2014-03-22','12:25:00',1.95),('3355','2014-03-22','12:35:00',1.4),('3355','2014-03-22','12:40:00',1.23),('3355','2014-03-22','12:45:00',1.71),('3355','2014-03-22','12:50:00',2.07),('3355','2014-03-22','12:55:00',1.32),('3355','2014-03-22','13:00:00',1.61),('3355','2014-03-22','13:05:00',1.01),('3355','2014-03-22','13:10:00',2.07),('3355','2014-03-22','13:15:00',1.96),('3355','2014-03-22','13:20:00',1.95),('3355','2014-03-22','13:25:00',1.53),('3355','2014-03-22','13:30:00',1.76),('3355','2014-03-22','13:35:00',1.84),('3355','2014-03-22','13:40:00',1.83),('3355','2014-03-22','13:45:00',1.99),('3355','2014-03-22','13:50:00',1.04),('3355','2014-03-22','14:00:00',2.18),('3355','2014-03-22','14:05:00',1.49),('3355','2014-03-22','14:10:00',2.12),('3355','2014-03-22','14:15:00',1.94),('3355','2014-03-22','14:20:00',1.96),('3355','2014-03-22','14:25:00',1.9),('3355','2014-03-22','14:30:00',1.86),('3355','2014-03-22','14:35:00',1.85),('3355','2014-03-22','14:40:00',1.81),('3355','2014-03-22','14:45:00',1.78),('3355','2014-03-22','14:50:00',1.76),('3355','2014-03-22','14:55:00',1.72),('3355','2014-03-22','15:00:00',1.67),('3355','2014-03-22','15:05:00',1.66),('3355','2014-03-22','15:10:00',1.6),('3355','2014-03-22','15:15:00',1.53),('3355','2014-03-22','15:20:00',1.55),('3355','2014-03-22','15:25:00',1.31),('3355','2014-03-22','15:40:00',1.04),('3355','2014-03-22','15:50:00',1.42),('3355','2014-03-22','15:55:00',1.58),('3355','2014-03-22','16:00:00',1.23),('3355','2014-03-22','16:05:00',1.24),('3355','2014-03-22','16:10:00',1.17),('3355','2014-03-21','08:35:00',1.03),('3355','2014-03-21','08:40:00',1.08),('3355','2014-03-21','08:45:00',1.12),('3355','2014-03-21','08:50:00',1.17),('3355','2014-03-21','08:55:00',1.23),('3355','2014-03-21','09:00:00',1.28),('3355','2014-03-21','09:05:00',1.3),('3355','2014-03-21','09:10:00',1.36),('3355','2014-03-21','09:15:00',1.41),('3355','2014-03-21','09:20:00',1.47),('3355','2014-03-21','09:25:00',1.42),('3355','2014-03-21','09:30:00',1.51),('3355','2014-03-21','09:35:00',1.54),('3355','2014-03-21','09:40:00',1.58),('3355','2014-03-21','09:45:00',1.62),('3355','2014-03-21','09:50:00',1.66),('3355','2014-03-21','09:55:00',1.69),('3355','2014-03-21','10:00:00',1.7),('3355','2014-03-21','10:05:00',1.72),('3355','2014-03-21','10:10:00',1.75),('3355','2014-03-21','10:15:00',1.79),('3355','2014-03-21','10:20:00',1.8),('3355','2014-03-21','10:25:00',1.83),('3355','2014-03-21','10:30:00',1.89),('3355','2014-03-21','10:35:00',1.88),('3355','2014-03-21','10:40:00',1.92),('3355','2014-03-21','10:45:00',1.91),('3355','2014-03-21','10:50:00',1.91),('3355','2014-03-21','10:55:00',1.95),('3355','2014-03-21','11:00:00',1.99),('3355','2014-03-21','11:05:00',1.96),('3355','2014-03-21','11:10:00',1.94),('3355','2014-03-21','11:15:00',1.93),('3355','2014-03-21','11:20:00',1.92),('3355','2014-03-21','11:25:00',1.81),('3355','2014-03-21','11:30:00',1.12),('3355','2014-03-21','11:35:00',1.4),('3355','2014-03-21','11:50:00',1.74),('3355','2014-03-21','11:55:00',2.25),('3355','2014-03-21','12:00:00',1.58),('3355','2014-03-21','12:05:00',2.07),('3355','2014-03-21','12:10:00',2.14),('3355','2014-03-21','12:15:00',2.25),('3355','2014-03-21','12:20:00',2.22),('3355','2014-03-21','12:25:00',2.14),('3355','2014-03-21','12:30:00',2.12),('3355','2014-03-21','12:35:00',2.13),('3355','2014-03-21','12:40:00',2.13),('3355','2014-03-21','12:45:00',2.14),('3355','2014-03-21','12:50:00',2.12),('3355','2014-03-21','12:55:00',2.14),('3355','2014-03-21','13:00:00',2.11),('3355','2014-03-21','13:05:00',2.13),('3355','2014-03-21','13:10:00',2.11),('3355','2014-03-21','13:15:00',2.12),('3355','2014-03-21','13:20:00',2.11),('3355','2014-03-21','13:25:00',2.09),('3355','2014-03-21','13:30:00',2.09),('3355','2014-03-21','13:35:00',2.06),('3355','2014-03-21','13:40:00',2.06),('3355','2014-03-21','13:45:00',2.05),('3355','2014-03-21','13:50:00',2.05),('3355','2014-03-21','13:55:00',2.02),('3355','2014-03-21','14:00:00',2.02),('3355','2014-03-21','14:05:00',2.01),('3355','2014-03-21','14:10:00',2),('3355','2014-03-21','14:15:00',1.98),('3355','2014-03-21','14:20:00',1.96),('3355','2014-03-21','14:25:00',1.93),('3355','2014-03-21','14:30:00',1.87),('3355','2014-03-21','14:35:00',1.78),('3355','2014-03-21','14:40:00',1.8),('3355','2014-03-21','14:45:00',1.77),('3355','2014-03-21','14:50:00',1.42),('3355','2014-03-21','15:10:00',1.82),('3355','2014-03-21','15:15:00',1.9),('3355','2014-03-21','15:20:00',1.78),('3355','2014-03-21','15:25:00',1.74),('3355','2014-03-21','15:30:00',1.78),('3355','2014-03-21','15:35:00',1.66),('3355','2014-03-21','15:40:00',1.66),('3355','2014-03-21','15:45:00',1.61),('3355','2014-03-21','15:50:00',1.58),('3355','2014-03-21','15:55:00',1.46),('3355','2014-03-21','16:00:00',1.42),('3355','2014-03-21','16:05:00',1.31),('3355','2014-03-21','16:10:00',1.24),('3355','2014-03-21','16:15:00',1.14),('3355','2014-03-21','16:20:00',1.06),('3355','2014-03-20','08:35:00',1.03),('3355','2014-03-20','08:40:00',1.1),('3355','2014-03-20','08:45:00',1.16),('3355','2014-03-20','08:50:00',1.2),('3355','2014-03-20','08:55:00',1.23),('3355','2014-03-20','09:00:00',1.26),('3355','2014-03-20','09:05:00',1.31),('3355','2014-03-20','09:10:00',1.38),('3355','2014-03-20','09:15:00',1.4),('3355','2014-03-20','09:20:00',1.45),('3355','2014-03-20','09:25:00',1.47),('3355','2014-03-20','09:30:00',1.49),('3355','2014-03-20','09:35:00',1.56),('3355','2014-03-20','09:40:00',1.56),('3355','2014-03-20','09:45:00',1.6),('3355','2014-03-20','09:50:00',1.6),('3355','2014-03-20','09:55:00',1.62),('3355','2014-03-20','10:00:00',1.7),('3355','2014-03-20','10:05:00',1.77),('3355','2014-03-20','10:10:00',1.81),('3355','2014-03-20','10:15:00',1.77),('3355','2014-03-20','10:20:00',1.82),('3355','2014-03-20','10:25:00',1.84),('3355','2014-03-20','10:30:00',1.86),('3355','2014-03-20','10:35:00',1.83),('3355','2014-03-20','10:40:00',1.79),('3355','2014-03-20','10:45:00',1.77),('3355','2014-03-20','10:50:00',1.91),('3355','2014-03-20','10:55:00',2.01),('3355','2014-03-20','11:00:00',2.03),('3355','2014-03-20','11:05:00',2.02),('3355','2014-03-20','11:10:00',2.01),('3355','2014-03-20','11:15:00',1.92),('3355','2014-03-20','11:20:00',1.99),('3355','2014-03-20','11:25:00',2.02),('3355','2014-03-20','11:30:00',2.08),('3355','2014-03-20','11:35:00',2.15),('3355','2014-03-20','11:40:00',2.1),('3355','2014-03-20','11:45:00',2.13),('3355','2014-03-20','11:50:00',2.1),('3355','2014-03-20','11:55:00',2.02),('3355','2014-03-20','12:00:00',1.86),('3355','2014-03-20','12:05:00',2.03),('3355','2014-03-20','12:10:00',2.12),('3355','2014-03-20','12:15:00',2.13),('3355','2014-03-20','12:20:00',2.06),('3355','2014-03-20','12:25:00',1.96),('3355','2014-03-20','12:30:00',2.06),('3355','2014-03-20','12:35:00',2.1),('3355','2014-03-20','12:40:00',2.09),('3355','2014-03-20','12:45:00',2.17),('3355','2014-03-20','12:50:00',2.15),('3355','2014-03-20','12:55:00',2.1),('3355','2014-03-20','13:00:00',2.12),('3355','2014-03-20','13:05:00',2.09),('3355','2014-03-20','13:10:00',2.05),('3355','2014-03-20','13:15:00',2.07),('3355','2014-03-20','13:20:00',2.07),('3355','2014-03-20','13:25:00',2.02),('3355','2014-03-20','13:30:00',2.06),('3355','2014-03-20','13:35:00',2.02),('3355','2014-03-20','13:40:00',1.87),('3355','2014-03-20','13:45:00',1.82),('3355','2014-03-20','13:50:00',1.77),('3355','2014-03-20','13:55:00',1.69),('3355','2014-03-20','14:00:00',1.68),('3355','2014-03-20','14:05:00',1.83),('3355','2014-03-20','14:10:00',1.77),('3355','2014-03-20','14:15:00',1.71),('3355','2014-03-20','14:20:00',1.71),('3355','2014-03-20','14:25:00',1.72),('3355','2014-03-20','14:30:00',1.48),('3355','2014-03-20','14:35:00',1.36),('3355','2014-03-20','14:40:00',1.52),('3355','2014-03-20','14:45:00',1.51),('3355','2014-03-20','14:50:00',1.43),('3355','2014-03-20','14:55:00',1.38),('3355','2014-03-20','15:00:00',1.26),('3355','2014-03-20','15:05:00',1.24),('3355','2014-03-20','15:10:00',1.27),('3355','2014-03-20','15:15:00',1.17),('3355','2014-03-20','15:20:00',1.25),('3355','2014-03-20','15:25:00',1.17),('3355','2014-03-20','15:30:00',1.1),('3355','2014-03-20','15:35:00',1.09),('3355','2014-03-19','09:25:00',1.24),('3355','2014-03-19','09:35:00',1.35),('3355','2014-03-19','09:40:00',1.47),('3355','2014-03-19','09:45:00',1.56),('3355','2014-03-19','09:50:00',1.88),('3355','2014-03-19','09:55:00',1.61),('3355','2014-03-19','10:40:00',1.17),('3355','2014-03-19','10:45:00',1.72),('3355','2014-03-19','10:50:00',1.55),('3355','2014-03-19','11:05:00',1.24),('3355','2014-03-19','11:10:00',2.21),('3355','2014-03-19','11:15:00',1.14),('3355','2014-03-19','11:20:00',1.03),('3355','2014-03-19','11:25:00',1.14),('3355','2014-03-19','11:30:00',1.2),('3355','2014-03-19','11:35:00',1.37),('3355','2014-03-19','11:40:00',1.06),('3355','2014-03-19','11:45:00',1.08),('3355','2014-03-19','12:05:00',1.9),('3355','2014-03-19','12:10:00',2.4),('3355','2014-03-19','12:15:00',2.42),('3355','2014-03-19','12:20:00',2.41),('3355','2014-03-19','12:25:00',2.29),('3355','2014-03-19','12:30:00',2.34),('3355','2014-03-19','12:35:00',2.27),('3355','2014-03-19','12:40:00',2.3),('3355','2014-03-19','12:45:00',2.22),('3355','2014-03-19','12:50:00',2.07),('3355','2014-03-19','12:55:00',1.65),('3355','2014-03-19','13:00:00',1.91),('3355','2014-03-19','13:05:00',1.91),('3355','2014-03-19','13:10:00',2.22),('3355','2014-03-19','13:15:00',2.18),('3355','2014-03-19','13:20:00',1.61),('3355','2014-03-19','13:25:00',1.44),('3355','2014-03-19','13:30:00',2.08),('3355','2014-03-19','13:35:00',2.12),('3355','2014-03-19','13:40:00',2.03),('3355','2014-03-19','13:45:00',2.11),('3355','2014-03-19','13:50:00',2.07),('3355','2014-03-19','13:55:00',2.03),('3355','2014-03-19','14:00:00',1.97),('3355','2014-03-19','14:05:00',1.99),('3355','2014-03-19','14:10:00',1.97),('3355','2014-03-19','14:15:00',1.91),('3355','2014-03-19','14:20:00',1.89),('3355','2014-03-19','14:25:00',1.86),('3355','2014-03-19','14:30:00',1.8),('3355','2014-03-19','14:35:00',1.84),('3355','2014-03-19','14:40:00',1.8),('3355','2014-03-19','14:45:00',1.77),('3355','2014-03-19','14:50:00',1.74),('3355','2014-03-19','14:55:00',1.7),('3355','2014-03-19','15:00:00',1.66),('3355','2014-03-19','15:05:00',1.63),('3355','2014-03-19','15:10:00',1.59),('3355','2014-03-19','15:15:00',1.59),('3355','2014-03-19','15:20:00',1.52),('3355','2014-03-19','15:25:00',1.51),('3355','2014-03-19','15:30:00',1.47),('3355','2014-03-19','15:35:00',1.39),('3355','2014-03-19','15:40:00',1.39),('3355','2014-03-19','15:45:00',1.35),('3355','2014-03-19','15:50:00',1.29),('3355','2014-03-19','15:55:00',1.26),('3355','2014-03-19','16:00:00',1.2),('3355','2014-03-19','16:05:00',1.15),('3355','2014-03-19','16:10:00',1.13),('3355','2014-03-19','16:15:00',1.06),('3355','2014-03-19','16:20:00',1.01),('3355','2014-03-18','08:55:00',1.25),('3355','2014-03-18','09:00:00',1.32),('3355','2014-03-18','09:15:00',1.25),('3355','2014-03-18','09:20:00',1.74),('3355','2014-03-18','09:25:00',1.69),('3355','2014-03-18','09:50:00',1.01),('3355','2014-03-18','09:55:00',1.05),('3355','2014-03-18','10:00:00',1.38),('3355','2014-03-18','10:05:00',1.55),('3355','2014-03-18','10:10:00',1.96),('3355','2014-03-18','10:15:00',1.89),('3355','2014-03-18','10:20:00',1.7),('3355','2014-03-18','10:25:00',2.3),('3355','2014-03-18','10:30:00',1.85),('3355','2014-03-18','10:35:00',1.79),('3355','2014-03-18','10:40:00',2.36),('3355','2014-03-18','10:45:00',1.61),('3355','2014-03-18','10:50:00',1.91),('3355','2014-03-18','10:55:00',1.17),('3355','2014-03-18','11:00:00',1.99),('3355','2014-03-18','11:05:00',1.72),('3355','2014-03-18','11:10:00',1.67),('3355','2014-03-18','11:30:00',1.13),('3355','2014-03-18','11:35:00',2.16),('3355','2014-03-18','11:40:00',1.66),('3355','2014-03-18','11:45:00',1.33),('3355','2014-03-18','11:50:00',1.16),('3355','2014-03-18','12:15:00',1.02),('3355','2014-03-18','12:20:00',1.39),('3355','2014-03-18','12:25:00',1.33),('3355','2014-03-18','12:35:00',1.84),('3355','2014-03-18','12:40:00',2.1),('3355','2014-03-18','12:45:00',1.41),('3355','2014-03-18','12:50:00',1.59),('3355','2014-03-18','12:55:00',1.74),('3355','2014-03-18','13:00:00',2.16),('3355','2014-03-18','13:05:00',2.32),('3355','2014-03-18','13:10:00',2.23),('3355','2014-03-18','13:15:00',2.2),('3355','2014-03-18','13:20:00',2.18),('3355','2014-03-18','13:25:00',2.12),('3355','2014-03-18','13:30:00',2.04),('3355','2014-03-18','13:35:00',2.07),('3355','2014-03-18','13:40:00',2.09),('3355','2014-03-18','13:45:00',2.09),('3355','2014-03-18','13:50:00',2.04),('3355','2014-03-18','13:55:00',2.04),('3355','2014-03-18','14:00:00',2.03),('3355','2014-03-18','14:05:00',1.99),('3355','2014-03-18','14:10:00',2),('3355','2014-03-18','14:15:00',1.98),('3355','2014-03-18','14:20:00',1.96),('3355','2014-03-18','14:25:00',1.94),('3355','2014-03-18','14:30:00',1.91),('3355','2014-03-18','14:35:00',1.89),('3355','2014-03-18','14:40:00',1.86),('3355','2014-03-18','14:45:00',1.81),('3355','2014-03-18','14:50:00',1.79),('3355','2014-03-18','14:55:00',1.77),('3355','2014-03-18','15:00:00',1.73),('3355','2014-03-18','15:05:00',1.67),('3355','2014-03-18','15:10:00',1.64),('3355','2014-03-18','15:15:00',1.61),('3355','2014-03-18','15:20:00',1.59),('3355','2014-03-18','15:25:00',1.54),('3355','2014-03-18','15:30:00',1.49),('3355','2014-03-18','15:35:00',1.45),('3355','2014-03-18','15:40:00',1.4),('3355','2014-03-18','15:45:00',1.35),('3355','2014-03-18','15:50:00',1.3),('3355','2014-03-18','15:55:00',1.24),('3355','2014-03-18','16:00:00',1.22),('3355','2014-03-18','16:05:00',1.19),('3355','2014-03-18','16:10:00',1.13),('3355','2014-03-18','16:15:00',1.08),('3355','2014-03-18','16:20:00',1.03),('3355','2014-05-01','08:45:00',1.03),('3355','2014-05-01','08:50:00',1.11),('3355','2014-05-01','08:55:00',1.3),('3355','2014-05-01','09:25:00',1.05),('3355','2014-05-01','09:30:00',1.5),('3355','2014-05-01','09:35:00',1.57),('3355','2014-05-01','09:40:00',1.47),('3355','2014-05-01','10:05:00',1.43),('3355','2014-05-01','10:10:00',2.29),('3355','2014-05-01','10:15:00',1.41),('3355','2014-05-01','10:20:00',1.44),('3355','2014-05-01','10:25:00',2.04),('3355','2014-05-01','10:30:00',1.71),('3355','2014-05-01','10:40:00',1.14),('3355','2014-05-01','10:45:00',1.18),('3355','2014-05-01','10:50:00',2.27),('3355','2014-05-01','10:55:00',2.35),('3355','2014-05-01','11:00:00',2.49),('3355','2014-05-01','11:05:00',1.97),('3355','2014-05-01','11:10:00',1.25),('3355','2014-05-01','11:15:00',1.21),('3355','2014-05-01','11:20:00',1.79),('3355','2014-05-01','11:25:00',2.53),('3355','2014-05-01','11:30:00',1.72),('3355','2014-05-01','11:35:00',2.31),('3355','2014-05-01','11:40:00',2.48),('3355','2014-05-01','11:45:00',2.32),('3355','2014-05-01','11:50:00',2.05),('3355','2014-05-01','11:55:00',2.19),('3355','2014-05-01','12:00:00',2.54),('3355','2014-05-01','12:05:00',2.58),('3355','2014-05-01','12:10:00',2.49),('3355','2014-05-01','12:15:00',2.34),('3355','2014-05-01','12:20:00',1.88),('3355','2014-05-01','12:30:00',1.35),('3355','2014-05-01','12:35:00',2.72),('3355','2014-05-01','12:40:00',2.67),('3355','2014-05-01','12:45:00',2.59),('3355','2014-05-01','12:50:00',2.03),('3355','2014-05-01','13:00:00',2.6),('3355','2014-05-01','13:05:00',2.61),('3355','2014-05-01','13:10:00',2.62),('3355','2014-05-01','13:15:00',2.54),('3355','2014-05-01','13:20:00',2.56),('3355','2014-05-01','13:25:00',2.03),('3355','2014-05-01','13:30:00',1.43),('3355','2014-05-01','13:35:00',2.73),('3355','2014-05-01','13:40:00',2.39),('3355','2014-05-01','13:45:00',2.7),('3355','2014-05-01','13:50:00',2.75),('3355','2014-05-01','13:55:00',2.23),('3355','2014-05-01','14:00:00',1.12),('3355','2014-05-01','14:05:00',2.7),('3355','2014-05-01','14:10:00',2.56),('3355','2014-05-01','14:15:00',2.58),('3355','2014-05-01','14:20:00',2.51),('3355','2014-05-01','14:25:00',2.58),('3355','2014-05-01','14:30:00',2.43),('3355','2014-05-01','14:35:00',2.27),('3355','2014-05-01','14:40:00',2.43),('3355','2014-05-01','14:45:00',2.54),('3355','2014-05-01','14:50:00',2.47),('3355','2014-05-01','14:55:00',2.44),('3355','2014-05-01','15:00:00',2.51),('3355','2014-05-01','15:05:00',2.42),('3355','2014-05-01','15:10:00',1.29),('3355','2014-05-01','15:15:00',2.19),('3355','2014-05-01','15:20:00',2.28),('3355','2014-05-01','15:25:00',2.25),('3355','2014-05-01','15:30:00',2.17),('3355','2014-05-01','15:35:00',2.15),('3355','2014-05-01','15:40:00',2.11),('3355','2014-05-01','15:45:00',2.09),('3355','2014-05-01','15:50:00',2.03),('3355','2014-05-01','15:55:00',2.01),('3355','2014-05-01','16:00:00',1.99),('3355','2014-05-01','16:05:00',2),('3355','2014-05-01','16:10:00',1.89),('3355','2014-05-01','16:15:00',1.88),('3355','2014-05-01','16:20:00',1.82),('3355','2014-05-01','16:25:00',1.64),('3355','2014-05-01','16:30:00',1.71),('3355','2014-05-01','16:35:00',1.73),('3355','2014-05-01','16:40:00',1.65),('3355','2014-05-01','16:45:00',1.4),('3355','2014-05-01','16:50:00',1.34),('3355','2014-05-01','16:55:00',1.34),('3355','2014-05-01','17:00:00',1.35),('3355','2014-05-01','17:05:00',1.38),('3355','2014-05-01','17:10:00',1.47),('3355','2014-05-01','17:15:00',1.39),('3355','2014-05-01','17:20:00',1.34),('3355','2014-05-01','17:25:00',1.28),('3355','2014-05-01','17:30:00',1.23),('3355','2014-05-01','17:35:00',1.19),('3355','2014-05-01','17:40:00',1.13),('3355','2014-05-01','17:45:00',1.08),('3355','2014-05-01','17:50:00',1.03),('3355','2014-03-17','09:55:00',1),('3355','2014-03-17','10:00:00',1.04),('3355','2014-03-17','10:10:00',1),('3355','2014-03-17','10:20:00',1.12),('3355','2014-03-17','11:50:00',1.02),('3355','2014-03-17','12:05:00',1.49),('3355','2014-03-17','12:15:00',1.17),('3355','2014-03-17','12:25:00',1.84),('3355','2014-03-17','12:30:00',1.08),('3355','2014-03-17','12:35:00',1.3),('3355','2014-03-17','12:40:00',1.21),('3355','2014-03-17','12:45:00',1.39),('3355','2014-03-17','12:55:00',1.98),('3355','2014-03-17','13:00:00',2.3),('3355','2014-03-17','13:05:00',1.9),('3355','2014-03-17','13:10:00',1.77),('3355','2014-03-17','13:15:00',2.19),('3355','2014-03-17','13:20:00',2.2),('3355','2014-03-17','13:25:00',2.2),('3355','2014-03-17','13:30:00',1.47),('3355','2014-03-17','13:35:00',1.82),('3355','2014-03-17','13:40:00',2.13),('3355','2014-03-17','13:45:00',2.17),('3355','2014-03-17','13:50:00',1.79),('3355','2014-03-17','13:55:00',1.72),('3355','2014-03-17','14:00:00',1.68),('3355','2014-03-17','14:05:00',1.37),('3355','2014-03-17','14:10:00',1.34),('3355','2014-03-17','14:20:00',1.22),('3355','2014-03-17','14:25:00',1.08),('3355','2014-03-17','14:30:00',1.53),('3355','2014-03-17','14:35:00',1.93),('3355','2014-03-17','14:40:00',1.58),('3355','2014-03-17','14:45:00',1.71),('3355','2014-03-17','14:50:00',1.81),('3355','2014-03-17','14:55:00',1.76),('3355','2014-03-17','15:00:00',1.72),('3355','2014-03-17','15:05:00',1.62),('3355','2014-03-17','15:10:00',1.6),('3355','2014-03-17','15:15:00',1.6),('3355','2014-03-17','15:25:00',1.32),('3355','2014-03-17','15:30:00',1.44),('3355','2014-03-17','15:35:00',1.38),('3355','2014-03-17','15:40:00',1.3),('3355','2014-03-17','15:45:00',1.11),('3355','2014-03-17','15:50:00',1.25),('3355','2014-03-17','15:55:00',1.16),('3355','2014-03-17','16:00:00',1.16),('3355','2014-03-17','16:05:00',1.09),('3355','2014-03-16','08:50:00',1.03),('3355','2014-03-16','08:55:00',1.04),('3355','2014-03-16','09:00:00',1.05),('3355','2014-03-16','09:05:00',1.1),('3355','2014-03-16','09:10:00',1.17),('3355','2014-03-16','09:15:00',1.27),('3355','2014-03-16','09:20:00',1.29),('3355','2014-03-16','09:25:00',1.29),('3355','2014-03-16','09:30:00',1.32),('3355','2014-03-16','09:35:00',1.32),('3355','2014-03-16','09:40:00',1.34),('3355','2014-03-16','09:45:00',1.43),('3355','2014-03-16','09:50:00',1.54),('3355','2014-03-16','09:55:00',1.56),('3355','2014-03-16','10:00:00',1.59),('3355','2014-03-16','10:05:00',1.59),('3355','2014-03-16','10:10:00',1.64),('3355','2014-03-16','10:15:00',1.68),('3355','2014-03-16','10:20:00',1.65),('3355','2014-03-16','10:25:00',1.66),('3355','2014-03-16','10:30:00',1.72),('3355','2014-03-16','10:35:00',1.77),('3355','2014-03-16','10:40:00',1.82),('3355','2014-03-16','10:45:00',1.84),('3355','2014-03-16','10:50:00',1.84),('3355','2014-03-16','10:55:00',1.85),('3355','2014-03-16','11:00:00',1.79),('3355','2014-03-16','11:05:00',1.75),('3355','2014-03-16','11:10:00',1.81),('3355','2014-03-16','11:15:00',1.86),('3355','2014-03-16','11:20:00',1.94),('3355','2014-03-16','11:25:00',1.98),('3355','2014-03-16','11:30:00',2),('3355','2014-03-16','11:35:00',2.03),('3355','2014-03-16','11:40:00',2.03),('3355','2014-03-16','11:45:00',2.01),('3355','2014-03-16','11:50:00',2.02),('3355','2014-03-16','11:55:00',2),('3355','2014-03-16','12:00:00',2.02),('3355','2014-03-16','12:05:00',1.99),('3355','2014-03-16','12:10:00',2.01),('3355','2014-03-16','12:15:00',1.99),('3355','2014-03-16','12:20:00',2.02),('3355','2014-03-16','12:25:00',1.99),('3355','2014-03-16','12:30:00',2),('3355','2014-03-16','12:35:00',2.01),('3355','2014-03-16','12:40:00',2.03),('3355','2014-03-16','12:45:00',2.03),('3355','2014-03-16','12:50:00',1.99),('3355','2014-03-16','12:55:00',1.96),('3355','2014-03-16','13:00:00',1.94),('3355','2014-03-16','13:05:00',1.97),('3355','2014-03-16','13:10:00',1.96),('3355','2014-03-16','13:15:00',1.97),('3355','2014-03-16','13:20:00',1.92),('3355','2014-03-16','13:25:00',1.95),('3355','2014-03-16','13:30:00',1.95),('3355','2014-03-16','13:35:00',1.9),('3355','2014-03-16','13:40:00',1.96),('3355','2014-03-16','13:45:00',1.91),('3355','2014-03-16','13:50:00',1.87),('3355','2014-03-16','13:55:00',1.91),('3355','2014-03-16','14:00:00',1.88),('3355','2014-03-16','14:05:00',1.85),('3355','2014-03-16','14:10:00',1.81),('3355','2014-03-16','14:15:00',1.78),('3355','2014-03-16','14:20:00',1.79),('3355','2014-03-16','14:25:00',1.76),('3355','2014-03-16','14:30:00',1.75),('3355','2014-03-16','14:35:00',1.7),('3355','2014-03-16','14:40:00',1.68),('3355','2014-03-16','14:45:00',1.62),('3355','2014-03-16','14:50:00',1.52),('3355','2014-03-16','14:55:00',1.52),('3355','2014-03-16','15:00:00',1.62),('3355','2014-03-16','15:05:00',1.51),('3355','2014-03-16','15:10:00',1.4),('3355','2014-03-16','15:15:00',1.29),('3355','2014-03-16','15:20:00',1.12),('3355','2014-03-16','15:25:00',1.24),('3355','2014-03-16','15:30:00',1.19),('3355','2014-03-16','15:35:00',1.06),('3355','2014-03-15','08:55:00',1.03),('3355','2014-03-15','09:00:00',1.07),('3355','2014-03-15','09:05:00',1.11),('3355','2014-03-15','09:10:00',1.16),('3355','2014-03-15','09:15:00',1.21),('3355','2014-03-15','09:20:00',1.26),('3355','2014-03-15','09:25:00',1.29),('3355','2014-03-15','09:30:00',1.33),('3355','2014-03-15','09:35:00',1.36),('3355','2014-03-15','09:40:00',1.4),('3355','2014-03-15','09:45:00',1.43),('3355','2014-03-15','09:50:00',1.44),('3355','2014-03-15','09:55:00',1.48),('3355','2014-03-15','10:00:00',1.52),('3355','2014-03-15','10:05:00',1.54),('3355','2014-03-15','10:10:00',1.57),('3355','2014-03-15','10:15:00',1.59),('3355','2014-03-15','10:20:00',1.6),('3355','2014-03-15','10:25:00',1.64),('3355','2014-03-15','10:30:00',1.68),('3355','2014-03-15','10:35:00',1.69),('3355','2014-03-15','10:40:00',1.72),('3355','2014-03-15','10:45:00',1.77),('3355','2014-03-15','10:50:00',1.82),('3355','2014-03-15','10:55:00',1.78),('3355','2014-03-15','11:00:00',1.78),('3355','2014-03-15','11:05:00',1.8),('3355','2014-03-15','11:10:00',1.84),('3355','2014-03-15','11:15:00',1.83),('3355','2014-03-15','11:20:00',1.89),('3355','2014-03-15','11:25:00',1.92),('3355','2014-03-15','11:30:00',1.97),('3355','2014-03-15','11:35:00',1.96),('3355','2014-03-15','11:40:00',1.99),('3355','2014-03-15','11:45:00',1.98),('3355','2014-03-15','11:50:00',2),('3355','2014-03-15','11:55:00',1.98),('3355','2014-03-15','12:00:00',2),('3355','2014-03-15','12:05:00',2),('3355','2014-03-15','12:10:00',1.98),('3355','2014-03-15','12:15:00',2.01),('3355','2014-03-15','12:20:00',2.04),('3355','2014-03-15','12:25:00',2.03),('3355','2014-03-15','12:30:00',2.04),('3355','2014-03-15','12:35:00',2.08),('3355','2014-03-15','12:40:00',2.08),('3355','2014-03-15','12:45:00',2.08),('3355','2014-03-15','12:50:00',2.08),('3355','2014-03-15','12:55:00',2.07),('3355','2014-03-15','13:00:00',2.04),('3355','2014-03-15','13:05:00',2.07),('3355','2014-03-15','13:10:00',2.07),('3355','2014-03-15','13:15:00',2.05),('3355','2014-03-15','13:20:00',2.04),('3355','2014-03-15','13:25:00',2.02),('3355','2014-03-15','13:30:00',2.01),('3355','2014-03-15','13:35:00',2.03),('3355','2014-03-15','13:40:00',2),('3355','2014-03-15','13:45:00',2),('3355','2014-03-15','13:50:00',1.98),('3355','2014-03-15','13:55:00',1.98),('3355','2014-03-15','14:00:00',1.97),('3355','2014-03-15','14:05:00',1.96),('3355','2014-03-15','14:10:00',1.93),('3355','2014-03-15','14:15:00',1.9),('3355','2014-03-15','14:20:00',1.87),('3355','2014-03-15','14:25:00',1.85),('3355','2014-03-15','14:30:00',1.82),('3355','2014-03-15','14:35:00',1.79),('3355','2014-03-15','14:40:00',1.75),('3355','2014-03-15','14:45:00',1.71),('3355','2014-03-15','14:50:00',1.68),('3355','2014-03-15','14:55:00',1.65),('3355','2014-03-15','15:00:00',1.62),('3355','2014-03-15','15:05:00',1.6),('3355','2014-03-15','15:10:00',1.55),('3355','2014-03-15','15:15:00',1.52),('3355','2014-03-15','15:20:00',1.47),('3355','2014-03-15','15:25:00',1.42),('3355','2014-03-15','15:30:00',1.38),('3355','2014-03-15','15:35:00',1.34),('3355','2014-03-15','15:40:00',1.28),('3355','2014-03-15','15:45:00',1.24),('3355','2014-03-15','15:50:00',1.19),('3355','2014-03-15','15:55:00',1.14),('3355','2014-03-15','16:00:00',1.09),('3355','2014-03-14','09:35:00',1.01),('3355','2014-03-14','09:40:00',1.26),('3355','2014-03-14','09:45:00',1.46),('3355','2014-03-14','09:50:00',1.71),('3355','2014-03-14','09:55:00',1.77),('3355','2014-03-14','10:00:00',1.89),('3355','2014-03-14','10:05:00',1.88),('3355','2014-03-14','10:10:00',1.84),('3355','2014-03-14','10:15:00',1.81),('3355','2014-03-14','10:20:00',1.76),('3355','2014-03-14','10:25:00',1.75),('3355','2014-03-14','10:30:00',1.69),('3355','2014-03-14','10:35:00',1.8),('3355','2014-03-14','10:40:00',1.84),('3355','2014-03-14','10:45:00',1.68),('3355','2014-03-14','10:50:00',1.01),('3355','2014-03-14','10:55:00',1.47),('3355','2014-03-14','11:00:00',1.82),('3355','2014-03-14','11:05:00',1.89),('3355','2014-03-14','11:10:00',2.05),('3355','2014-03-14','11:15:00',2.07),('3355','2014-03-14','11:20:00',2.01),('3355','2014-03-14','11:25:00',1.97),('3355','2014-03-14','11:30:00',1.99),('3355','2014-03-14','11:35:00',2.03),('3355','2014-03-14','11:40:00',2.04),('3355','2014-03-14','11:45:00',2.07),('3355','2014-03-14','11:50:00',2.09),('3355','2014-03-14','11:55:00',2.1),('3355','2014-03-14','12:00:00',2.12),('3355','2014-03-14','12:05:00',2.13),('3355','2014-03-14','12:10:00',2.02),('3355','2014-03-14','12:15:00',1.91),('3355','2014-03-14','12:20:00',1.59),('3355','2014-03-14','12:25:00',1.35),('3355','2014-03-14','12:30:00',1.25),('3355','2014-03-14','12:35:00',1.08),('3355','2014-03-14','12:40:00',1.3),('3355','2014-03-14','12:45:00',1.45),('3355','2014-03-14','12:50:00',1.74),('3355','2014-03-14','12:55:00',1.69),('3355','2014-03-14','13:00:00',1.23),('3355','2014-03-14','13:05:00',1.09),('3355','2014-03-14','13:10:00',1.32),('3355','2014-03-14','13:15:00',1.59),('3355','2014-03-14','13:20:00',1.59),('3355','2014-03-14','13:25:00',1.48),('3355','2014-03-14','13:30:00',1.36),('3355','2014-03-14','13:35:00',1.24),('3355','2014-03-14','13:40:00',1.12),('3355','2014-03-14','13:45:00',1.15),('3355','2014-03-14','13:50:00',1.07),('3355','2014-03-14','13:55:00',1.14),('3355','2014-03-14','14:00:00',1.33),('3355','2014-03-14','14:05:00',1.49),('3355','2014-03-14','14:10:00',1.49),('3355','2014-03-14','14:15:00',1.56),('3355','2014-03-14','14:20:00',1.63),('3355','2014-03-14','14:25:00',1.61),('3355','2014-03-14','14:30:00',1.5),('3355','2014-03-14','14:35:00',1.38),('3355','2014-03-14','14:40:00',1.15),('3355','2014-03-13','08:35:00',1.02),('3355','2014-03-13','08:40:00',1.07),('3355','2014-03-13','08:45:00',1.12),('3355','2014-03-13','08:50:00',1.17),('3355','2014-03-13','08:55:00',1.22),('3355','2014-03-13','09:00:00',1.27),('3355','2014-03-13','09:05:00',1.32),('3355','2014-03-13','09:10:00',1.36),('3355','2014-03-13','09:15:00',1.4),('3355','2014-03-13','09:20:00',1.44),('3355','2014-03-13','09:25:00',1.48),('3355','2014-03-13','09:30:00',1.52),('3355','2014-03-13','09:35:00',1.57),('3355','2014-03-13','09:40:00',1.61),('3355','2014-03-13','09:45:00',1.65),('3355','2014-03-13','09:50:00',1.69),('3355','2014-03-13','09:55:00',1.73),('3355','2014-03-13','10:00:00',1.76),('3355','2014-03-13','10:05:00',1.79),('3355','2014-03-13','10:10:00',1.82),('3355','2014-03-13','10:15:00',1.85),('3355','2014-03-13','10:20:00',1.87),('3355','2014-03-13','10:25:00',1.89),('3355','2014-03-13','10:30:00',1.92),('3355','2014-03-13','10:35:00',1.93),('3355','2014-03-13','10:40:00',1.95),('3355','2014-03-13','10:45:00',1.97),('3355','2014-03-13','10:50:00',1.99),('3355','2014-03-13','10:55:00',2.01),('3355','2014-03-13','11:00:00',2.02),('3355','2014-03-13','11:05:00',2.04),('3355','2014-03-13','11:10:00',2.06),('3355','2014-03-13','11:15:00',2.07),('3355','2014-03-13','11:20:00',2.09),('3355','2014-03-13','11:25:00',2.1),('3355','2014-03-13','11:30:00',2.11),('3355','2014-03-13','11:35:00',2.11),('3355','2014-03-13','11:40:00',2.12),('3355','2014-03-13','11:45:00',2.15),('3355','2014-03-13','11:50:00',2.15),('3355','2014-03-13','11:55:00',2.17),('3355','2014-03-13','12:00:00',2.15),('3355','2014-03-13','12:05:00',2.14),('3355','2014-03-13','12:10:00',2.14),('3355','2014-03-13','12:15:00',2.13),('3355','2014-03-13','12:20:00',2.14),('3355','2014-03-13','12:25:00',2.15),('3355','2014-03-13','12:30:00',2.16),('3355','2014-03-13','12:35:00',2.15),('3355','2014-03-13','12:40:00',2.13),('3355','2014-03-13','12:45:00',2.13),('3355','2014-03-13','12:50:00',2.12),('3355','2014-03-13','12:55:00',2.11),('3355','2014-03-13','13:00:00',2.1),('3355','2014-03-13','13:05:00',2.09),('3355','2014-03-13','13:10:00',2.08),('3355','2014-03-13','13:15:00',2.04),('3355','2014-03-13','13:20:00',2.07),('3355','2014-03-13','13:25:00',2.07),('3355','2014-03-13','13:30:00',2.08),('3355','2014-03-13','13:35:00',2.07),('3355','2014-03-13','13:40:00',2.04),('3355','2014-03-13','13:45:00',2.01),('3355','2014-03-13','13:50:00',1.99),('3355','2014-03-13','13:55:00',1.96),('3355','2014-03-13','14:00:00',1.94),('3355','2014-03-13','14:05:00',1.93),('3355','2014-03-13','14:10:00',1.92),('3355','2014-03-13','14:15:00',1.9),('3355','2014-03-13','14:20:00',1.87),('3355','2014-03-13','14:25:00',1.84),('3355','2014-03-13','14:30:00',1.81),('3355','2014-03-13','14:35:00',1.79),('3355','2014-03-13','14:40:00',1.77),('3355','2014-03-13','14:45:00',1.73),('3355','2014-03-13','14:50:00',1.7),('3355','2014-03-13','14:55:00',1.67),('3355','2014-03-13','15:00:00',1.63),('3355','2014-03-13','15:05:00',1.6),('3355','2014-03-13','15:10:00',1.56),('3355','2014-03-13','15:15:00',1.53),('3355','2014-03-13','15:20:00',1.48),('3355','2014-03-13','15:25:00',1.44),('3355','2014-03-13','15:30:00',1.41),('3355','2014-03-13','15:35:00',1.36),('3355','2014-03-13','15:40:00',1.31),('3355','2014-03-13','15:45:00',1.28),('3355','2014-03-13','15:50:00',1.23),('3355','2014-03-13','15:55:00',1.18),('3355','2014-03-13','16:00:00',1.13),('3355','2014-03-13','16:05:00',1.07),('3355','2014-03-13','16:10:00',1.02),('3355','2014-03-12','08:35:00',1),('3355','2014-03-12','08:40:00',1.06),('3355','2014-03-12','08:45:00',1.11),('3355','2014-03-12','08:50:00',1.16),('3355','2014-03-12','08:55:00',1.21),('3355','2014-03-12','09:00:00',1.25),('3355','2014-03-12','09:05:00',1.29),('3355','2014-03-12','09:10:00',1.34),('3355','2014-03-12','09:15:00',1.39),('3355','2014-03-12','09:20:00',1.43),('3355','2014-03-12','09:25:00',1.47),('3355','2014-03-12','09:30:00',1.51),('3355','2014-03-12','09:35:00',1.55),('3355','2014-03-12','09:40:00',1.58),('3355','2014-03-12','09:45:00',1.62),('3355','2014-03-12','09:50:00',1.66),('3355','2014-03-12','09:55:00',1.7),('3355','2014-03-12','10:00:00',1.74),('3355','2014-03-12','10:05:00',1.78),('3355','2014-03-12','10:10:00',1.81),('3355','2014-03-12','10:15:00',1.83),('3355','2014-03-12','10:20:00',1.86),('3355','2014-03-12','10:25:00',1.89),('3355','2014-03-12','10:30:00',1.91),('3355','2014-03-12','10:35:00',1.94),('3355','2014-03-12','10:40:00',1.97),('3355','2014-03-12','10:45:00',2),('3355','2014-03-12','10:50:00',2.02),('3355','2014-03-12','10:55:00',2.04),('3355','2014-03-12','11:00:00',2.06),('3355','2014-03-12','11:05:00',2.09),('3355','2014-03-12','11:10:00',2.1),('3355','2014-03-12','11:15:00',2.13),('3355','2014-03-12','11:20:00',2.15),('3355','2014-03-12','11:25:00',2.16),('3355','2014-03-12','11:30:00',2.17),('3355','2014-03-12','11:35:00',2.18),('3355','2014-03-12','11:40:00',2.2),('3355','2014-03-12','11:45:00',2.2),('3355','2014-03-12','11:50:00',2.21),('3355','2014-03-12','11:55:00',2.22),('3355','2014-03-12','12:00:00',2.21),('3355','2014-03-12','12:05:00',2.22),('3355','2014-03-12','12:10:00',2.21),('3355','2014-03-12','12:15:00',2.22),('3355','2014-03-12','12:20:00',2.21),('3355','2014-03-12','12:25:00',2.2),('3355','2014-03-12','12:30:00',2.2),('3355','2014-03-12','12:35:00',2.2),('3355','2014-03-12','12:40:00',2.19),('3355','2014-03-12','12:45:00',2.2),('3355','2014-03-12','12:50:00',2.19),('3355','2014-03-12','12:55:00',2.18),('3355','2014-03-12','13:00:00',2.18),('3355','2014-03-12','13:05:00',2.17),('3355','2014-03-12','13:10:00',2.14),('3355','2014-03-12','13:15:00',2.14),('3355','2014-03-12','13:20:00',2.13),('3355','2014-03-12','13:25:00',2.12),('3355','2014-03-12','13:30:00',2.09),('3355','2014-03-12','13:35:00',2.09),('3355','2014-03-12','13:40:00',2.07),('3355','2014-03-12','13:45:00',2.05),('3355','2014-03-12','13:50:00',2.04),('3355','2014-03-12','13:55:00',2.03),('3355','2014-03-12','14:00:00',2.02),('3355','2014-03-12','14:05:00',2.01),('3355','2014-03-12','14:10:00',1.96),('3355','2014-03-12','14:15:00',1.95),('3355','2014-03-12','14:20:00',1.91),('3355','2014-03-12','14:25:00',1.9),('3355','2014-03-12','14:30:00',1.87),('3355','2014-03-12','14:35:00',1.81),('3355','2014-03-12','14:40:00',1.76),('3355','2014-03-12','14:45:00',1.72),('3355','2014-03-12','14:50:00',1.7),('3355','2014-03-12','14:55:00',1.62),('3355','2014-03-12','15:00:00',1.6),('3355','2014-03-12','15:05:00',1.58),('3355','2014-03-12','15:10:00',1.54),('3355','2014-03-12','15:15:00',1.49),('3355','2014-03-12','15:20:00',1.47),('3355','2014-03-12','15:25:00',1.43),('3355','2014-03-12','15:30:00',1.37),('3355','2014-03-12','15:35:00',1.32),('3355','2014-03-12','15:40:00',1.29),('3355','2014-03-12','15:45:00',1.25),('3355','2014-03-12','15:50:00',1.22),('3355','2014-03-12','15:55:00',1.19),('3355','2014-03-12','16:00:00',1.15),('3355','2014-03-12','16:05:00',1.07),('3355','2014-03-12','16:10:00',1.02),('3355','2014-03-11','13:55:00',1.03),('3355','2014-03-11','14:00:00',1.05),('3355','2014-03-11','14:05:00',1.14),('3355','2014-03-11','14:10:00',1.51),('3355','2014-03-11','14:15:00',1.37),('3355','2014-03-11','14:20:00',1.13),('3355','2014-03-11','14:25:00',1.06),('3355','2014-03-11','15:10:00',1.06),('3355','2014-03-10','14:10:00',1.02),('3355','2014-03-10','14:15:00',1.5),('3355','2014-03-10','14:35:00',1.37),('3355','2014-03-10','14:40:00',1.68),('3355','2014-03-10','14:45:00',1.05),('3355','2014-03-10','14:50:00',1.25),('3355','2014-03-10','15:20:00',1.42),('3355','2014-03-10','15:25:00',1.25),('3355','2014-03-09','09:20:00',1.45),('3355','2014-03-09','09:25:00',1.53),('3355','2014-03-09','09:35:00',1.24),('3355','2014-03-09','09:40:00',1.72),('3355','2014-03-09','09:45:00',1.75),('3355','2014-03-09','09:50:00',1.77),('3355','2014-03-09','09:55:00',1.77),('3355','2014-03-09','10:00:00',1.79),('3355','2014-03-09','10:05:00',1.83),('3355','2014-03-09','10:10:00',1.89),('3355','2014-03-09','10:15:00',1.89),('3355','2014-03-09','10:20:00',1.89),('3355','2014-03-09','10:25:00',1.76),('3355','2014-03-09','10:30:00',1.98),('3355','2014-03-09','10:35:00',2),('3355','2014-03-09','10:40:00',2.02),('3355','2014-03-09','10:45:00',2.04),('3355','2014-03-09','10:50:00',2.08),('3355','2014-03-09','10:55:00',2.15),('3355','2014-03-09','11:00:00',2.08),('3355','2014-03-09','11:05:00',2.34),('3355','2014-03-09','11:10:00',2.16),('3355','2014-03-09','11:15:00',2.47),('3355','2014-03-09','11:20:00',2.39),('3355','2014-03-09','11:25:00',2.34),('3355','2014-03-09','11:30:00',1.42),('3355','2014-03-09','11:35:00',2.2),('3355','2014-03-09','11:40:00',1.31),('3355','2014-03-09','11:45:00',1.34),('3355','2014-03-09','11:50:00',1.81),('3355','2014-03-09','11:55:00',2.46),('3355','2014-03-09','12:00:00',2.28),('3355','2014-03-09','12:05:00',2.59),('3355','2014-03-09','12:10:00',2.55),('3355','2014-03-09','12:15:00',2.51),('3355','2014-03-09','12:20:00',2.48),('3355','2014-03-09','12:25:00',2.45),('3355','2014-03-09','12:30:00',2.46),('3355','2014-03-09','12:35:00',2.52),('3355','2014-03-09','12:40:00',2.45),('3355','2014-03-09','12:45:00',2.42),('3355','2014-03-09','12:50:00',2.43),('3355','2014-03-09','12:55:00',2.43),('3355','2014-03-09','13:00:00',2.46),('3355','2014-03-09','13:05:00',2.46),('3355','2014-03-09','13:10:00',2.45),('3355','2014-03-09','13:15:00',2.3),('3355','2014-03-09','13:20:00',2.25),('3355','2014-03-09','13:25:00',2.29),('3355','2014-03-09','13:30:00',2.26),('3355','2014-03-09','13:35:00',1.53),('3355','2014-03-09','13:55:00',2.11),('3355','2014-03-09','14:00:00',2.22),('3355','2014-03-09','14:05:00',2.12),('3355','2014-03-09','14:10:00',2.09),('3355','2014-03-09','14:15:00',1.89),('3355','2014-03-09','14:20:00',2.11),('3355','2014-03-09','14:40:00',1.8),('3355','2014-03-09','14:45:00',2),('3355','2014-03-09','14:50:00',1.87),('3355','2014-03-09','14:55:00',1.82),('3355','2014-03-09','15:00:00',1.76),('3355','2014-03-09','15:05:00',1.22),('3355','2014-03-09','15:10:00',1.71),('3355','2014-03-09','15:15:00',1.64),('3355','2014-03-09','15:20:00',1.6),('3355','2014-03-09','15:25:00',1.58),('3355','2014-03-09','15:30:00',1.56),('3355','2014-03-09','15:35:00',1.48),('3355','2014-03-09','15:40:00',1.41),('3355','2014-03-09','15:55:00',1.31),('3355','2014-03-09','16:00:00',1.23),('3355','2014-03-09','16:05:00',1.12),('3355','2014-03-08','08:40:00',1.01),('3355','2014-03-08','08:45:00',1.06),('3355','2014-03-08','08:50:00',1.11),('3355','2014-03-08','08:55:00',1.16),('3355','2014-03-08','09:00:00',1.21),('3355','2014-03-08','09:05:00',1.26),('3355','2014-03-08','09:10:00',1.31),('3355','2014-03-08','09:15:00',1.35),('3355','2014-03-08','09:20:00',1.4),('3355','2014-03-08','09:25:00',1.44),('3355','2014-03-08','09:30:00',1.49),('3355','2014-03-08','09:35:00',1.54),('3355','2014-03-08','09:40:00',1.58),('3355','2014-03-08','09:45:00',1.61),('3355','2014-03-08','09:50:00',1.65),('3355','2014-03-08','09:55:00',1.68),('3355','2014-03-08','10:00:00',1.72),('3355','2014-03-08','10:05:00',1.75),('3355','2014-03-08','10:10:00',1.78),('3355','2014-03-08','10:15:00',1.82),('3355','2014-03-08','10:20:00',1.85),('3355','2014-03-08','10:25:00',1.88),('3355','2014-03-08','10:30:00',1.92),('3355','2014-03-08','10:35:00',1.96),('3355','2014-03-08','10:40:00',1.98),('3355','2014-03-08','10:45:00',2),('3355','2014-03-08','10:50:00',2.01),('3355','2014-03-08','10:55:00',2.03),('3355','2014-03-08','11:00:00',2.05),('3355','2014-03-08','11:05:00',2.07),('3355','2014-03-08','11:10:00',2.09),('3355','2014-03-08','11:15:00',2.13),('3355','2014-03-08','11:20:00',2.17),('3355','2014-03-08','11:25:00',2.24),('3355','2014-03-08','11:30:00',2.32),('3355','2014-03-08','11:35:00',1.59),('3355','2014-03-08','11:40:00',1.07),('3355','2014-03-08','11:55:00',2.05),('3355','2014-03-08','12:30:00',1.39),('3355','2014-03-08','12:35:00',2.02),('3355','2014-03-08','12:40:00',1.08),('3355','2014-03-08','12:45:00',1.15),('3355','2014-03-08','12:50:00',1.62),('3355','2014-03-08','12:55:00',2.28),('3355','2014-03-08','13:30:00',1.28),('3355','2014-03-08','13:40:00',1.74),('3355','2014-03-08','13:45:00',1.55),('3355','2014-03-08','15:20:00',1.1),('3355','2014-03-08','15:25:00',1.24),('3355','2014-04-30','08:50:00',1.06),('3355','2014-04-30','08:55:00',1.12),('3355','2014-04-30','09:00:00',1.15),('3355','2014-04-30','09:05:00',1.23),('3355','2014-04-30','09:10:00',1.36),('3355','2014-04-30','09:15:00',1.53),('3355','2014-04-30','09:20:00',1.11),('3355','2014-04-30','09:35:00',1.01),('3355','2014-04-30','09:40:00',1.56),('3355','2014-04-30','09:45:00',1.5),('3355','2014-04-30','09:50:00',1.08),('3355','2014-04-30','09:55:00',1.31),('3355','2014-04-30','10:00:00',1.72),('3355','2014-04-30','10:05:00',1.82),('3355','2014-04-30','10:15:00',1.59),('3355','2014-04-30','10:20:00',1.03),('3355','2014-04-30','10:35:00',1.16),('3355','2014-04-30','10:40:00',1.18),('3355','2014-04-30','10:55:00',1.84),('3355','2014-04-30','11:00:00',2.56),('3355','2014-04-30','11:05:00',1.85),('3355','2014-04-30','11:10:00',1.65),('3355','2014-04-30','11:15:00',1.49),('3355','2014-04-30','11:25:00',1.31),('3355','2014-04-30','11:30:00',1.25),('3355','2014-04-30','11:35:00',1.1),('3355','2014-04-30','11:40:00',1.5),('3355','2014-04-30','11:50:00',1.61),('3355','2014-04-30','11:55:00',1.35),('3355','2014-04-30','12:00:00',2.13),('3355','2014-04-30','12:15:00',1.02),('3355','2014-04-30','12:20:00',1.03),('3355','2014-04-30','12:55:00',2.07),('3355','2014-04-30','13:00:00',2.64),('3355','2014-04-30','13:05:00',1.75),('3355','2014-04-30','13:10:00',1.7),('3355','2014-04-30','13:15:00',1.49),('3355','2014-04-30','13:20:00',1.19),('3355','2014-04-30','13:25:00',1.31),('3355','2014-04-30','13:30:00',1.26),('3355','2014-04-30','13:35:00',1.07),('3355','2014-04-30','13:40:00',1.67),('3355','2014-04-30','13:45:00',1.74),('3355','2014-04-30','13:50:00',1.41),('3355','2014-04-30','13:55:00',2.48),('3355','2014-04-30','14:00:00',1.46),('3355','2014-04-30','14:05:00',1.26),('3355','2014-04-30','14:20:00',1.52),('3355','2014-04-30','14:25:00',1.92),('3355','2014-04-30','14:30:00',2.49),('3355','2014-04-30','14:35:00',2.34),('3355','2014-04-30','14:40:00',1.38),('3355','2014-04-30','15:35:00',1.44),('3355','2014-04-30','15:40:00',1.81),('3355','2014-04-30','15:45:00',2.27),('3355','2014-04-30','15:50:00',2.51),('3355','2014-04-30','15:55:00',1.87),('3355','2014-04-30','16:05:00',1.34),('3355','2014-04-30','16:15:00',1.62),('3355','2014-04-30','16:20:00',1.33),('3355','2014-04-30','16:30:00',1.72),('3355','2014-04-30','16:40:00',1.21),('3355','2014-04-30','16:50:00',1.01),('3355','2014-04-30','16:55:00',1.44),('3355','2014-04-30','17:00:00',1.12),('3355','2014-04-30','17:05:00',1.64),('3355','2014-04-30','17:15:00',1.29),('3355','2014-03-07','11:45:00',1.16),('3355','2014-03-07','11:50:00',1.6),('3355','2014-03-07','11:55:00',2.09),('3355','2014-03-07','12:00:00',2.61),('3355','2014-03-07','12:05:00',2.26),('3355','2014-03-07','12:10:00',2.56),('3355','2014-03-07','12:15:00',2.44),('3355','2014-03-07','12:20:00',2.47),('3355','2014-03-07','12:25:00',2.46),('3355','2014-03-07','12:30:00',2.51),('3355','2014-03-07','12:35:00',2.42),('3355','2014-03-07','12:40:00',1.96),('3355','2014-03-07','12:45:00',2.24),('3355','2014-03-07','12:50:00',1.22),('3355','2014-03-07','13:05:00',1.47),('3355','2014-03-07','13:20:00',1.59),('3355','2014-03-07','13:25:00',1.59),('3355','2014-03-07','13:30:00',1.01),('3355','2014-03-07','13:35:00',1.79),('3355','2014-03-07','13:40:00',1.83),('3355','2014-03-07','13:45:00',1.35),('3355','2014-03-07','14:55:00',1.2),('3355','2014-03-07','15:00:00',1.57),('3355','2014-03-07','15:05:00',1.83),('3355','2014-03-07','15:10:00',1.85),('3355','2014-03-07','15:15:00',1.9),('3355','2014-03-07','15:20:00',1.99),('3355','2014-03-07','15:25:00',1.93),('3355','2014-03-07','15:30:00',1.87),('3355','2014-03-07','15:35:00',1.76),('3355','2014-03-07','15:40:00',1.67),('3355','2014-03-07','16:05:00',1.24),('3355','2014-03-07','16:10:00',1.22),('3355','2014-03-07','16:15:00',1.21),('3355','2014-03-07','16:20:00',1.13),('3355','2014-03-07','16:25:00',1.06),('3355','2014-03-06','09:50:00',1.01),('3355','2014-03-06','10:05:00',1.25),('3355','2014-03-06','10:10:00',1.71),('3355','2014-03-06','10:15:00',1.9),('3355','2014-03-06','10:20:00',1.59),('3355','2014-03-06','10:25:00',1.27),('3355','2014-03-06','10:45:00',1.3),('3355','2014-03-06','10:55:00',1.03),('3355','2014-03-06','11:00:00',1),('3355','2014-03-06','11:05:00',1.57),('3355','2014-03-06','11:15:00',1.57),('3355','2014-03-06','11:30:00',1.08),('3355','2014-03-06','11:40:00',1.05),('3355','2014-03-06','11:45:00',1.86),('3355','2014-03-06','11:50:00',1.8),('3355','2014-03-06','11:55:00',2.07),('3355','2014-03-06','12:05:00',1.94),('3355','2014-03-06','12:10:00',2.63),('3355','2014-03-06','12:15:00',2.19),('3355','2014-03-06','12:20:00',1.67),('3355','2014-03-06','12:25:00',2.59),('3355','2014-03-06','12:30:00',2.61),('3355','2014-03-06','12:35:00',1.31),('3355','2014-03-06','16:25:00',1.05),('3355','2014-03-05','08:30:00',1.05),('3355','2014-03-05','08:35:00',1.07),('3355','2014-03-05','08:40:00',1.25),('3355','2014-03-05','09:00:00',1.43),('3355','2014-03-05','09:15:00',1.09),('3355','2014-03-05','09:20:00',1.46),('3355','2014-03-05','09:25:00',1.48),('3355','2014-03-05','09:30:00',1.52),('3355','2014-03-05','09:35:00',1.57),('3355','2014-03-05','09:40:00',1.6),('3355','2014-03-05','09:45:00',1.63),('3355','2014-03-05','09:50:00',1.66),('3355','2014-03-05','09:55:00',1.7),('3355','2014-03-05','10:00:00',1.74),('3355','2014-03-05','10:05:00',1.78),('3355','2014-03-05','10:10:00',1.83),('3355','2014-03-05','10:15:00',1.84),('3355','2014-03-05','10:20:00',1.86),('3355','2014-03-05','10:25:00',1.89),('3355','2014-03-05','10:30:00',1.91),('3355','2014-03-05','10:35:00',1.94),('3355','2014-03-05','10:40:00',1.96),('3355','2014-03-05','10:45:00',1.98),('3355','2014-03-05','10:50:00',2),('3355','2014-03-05','10:55:00',2.03),('3355','2014-03-05','11:00:00',2.06),('3355','2014-03-05','11:05:00',2.11),('3355','2014-03-05','11:10:00',2.12),('3355','2014-03-05','11:15:00',2.14),('3355','2014-03-05','11:20:00',2.15),('3355','2014-03-05','11:25:00',2.17),('3355','2014-03-05','11:30:00',2.22),('3355','2014-03-05','11:35:00',2.31),('3355','2014-03-05','11:40:00',2.3),('3355','2014-03-05','11:45:00',2.26),('3355','2014-03-05','11:50:00',2.23),('3355','2014-03-05','11:55:00',1.91),('3355','2014-03-05','12:00:00',1.93),('3355','2014-03-05','12:05:00',1.82),('3355','2014-03-05','12:35:00',1.06),('3355','2014-03-05','13:00:00',1.11),('3355','2014-03-05','13:05:00',1.52),('3355','2014-03-05','13:10:00',1.85),('3355','2014-03-05','13:15:00',1.71),('3355','2014-03-05','13:20:00',1.18),('3355','2014-03-05','14:50:00',1.2),('3355','2014-03-05','15:40:00',1.33),('3355','2014-03-05','15:45:00',1.11),('3355','2014-03-05','15:55:00',1.45),('3355','2014-03-05','16:00:00',1.78),('3355','2014-03-05','16:05:00',1.62),('3355','2014-03-05','16:10:00',1.39),('3355','2014-03-04','09:20:00',1.51),('3355','2014-03-04','09:45:00',1.17),('3355','2014-03-04','09:55:00',1.08),('3355','2014-03-04','10:25:00',1.98),('3355','2014-03-04','10:30:00',1.67),('3355','2014-03-04','10:35:00',1.7),('3355','2014-03-04','10:40:00',2.28),('3355','2014-03-04','10:45:00',2.26),('3355','2014-03-04','10:55:00',1.33),('3355','2014-03-04','11:00:00',1.42),('3355','2014-03-04','11:10:00',1.61),('3355','2014-03-04','11:15:00',2.62),('3355','2014-03-04','11:20:00',2.05),('3355','2014-03-04','11:45:00',1.14),('3355','2014-03-04','11:50:00',2.78),('3355','2014-03-04','11:55:00',2.42),('3355','2014-03-04','12:00:00',2.33),('3355','2014-03-04','12:05:00',2.29),('3355','2014-03-04','12:10:00',2.28),('3355','2014-03-04','12:15:00',2.27),('3355','2014-03-04','12:20:00',2.27),('3355','2014-03-04','12:25:00',2.27),('3355','2014-03-04','12:30:00',2.24),('3355','2014-03-04','12:35:00',2.25),('3355','2014-03-04','12:40:00',2.27),('3355','2014-03-04','12:45:00',2.27),('3355','2014-03-04','12:50:00',1.72),('3355','2014-03-04','12:55:00',1.96),('3355','2014-03-04','13:00:00',1.97),('3355','2014-03-04','13:05:00',2.24),('3355','2014-03-04','13:10:00',2.45),('3355','2014-03-04','13:15:00',2.04),('3355','2014-03-04','14:10:00',1.77),('3355','2014-03-04','14:15:00',1.45),('3355','2014-03-04','14:20:00',1.22),('3355','2014-03-04','14:25:00',2.24),('3355','2014-03-04','14:30:00',2.05),('3355','2014-03-04','14:35:00',1.96),('3355','2014-03-04','14:40:00',1.93),('3355','2014-03-04','14:45:00',1.92),('3355','2014-03-04','14:50:00',1.84),('3355','2014-03-04','15:00:00',1.03),('3355','2014-03-04','15:05:00',1.77),('3355','2014-03-04','15:10:00',1.73),('3355','2014-03-04','15:15:00',1.68),('3355','2014-03-04','15:20:00',1.03),('3355','2014-03-04','15:25:00',1.46),('3355','2014-03-04','15:35:00',1.61),('3355','2014-03-04','15:40:00',1.59),('3355','2014-03-04','15:45:00',1.17),('3355','2014-03-04','15:50:00',1.13),('3355','2014-03-03','08:40:00',1.01),('3355','2014-03-03','08:45:00',1.05),('3355','2014-03-03','08:50:00',1.05),('3355','2014-03-03','08:55:00',1.19),('3355','2014-03-03','09:00:00',1.24),('3355','2014-03-03','09:05:00',1.26),('3355','2014-03-03','09:10:00',1.26),('3355','2014-03-03','09:15:00',1.25),('3355','2014-03-03','09:20:00',1.36),('3355','2014-03-03','09:25:00',1.43),('3355','2014-03-03','09:30:00',1.41),('3355','2014-03-03','09:35:00',1.29),('3355','2014-03-03','09:40:00',1.2),('3355','2014-03-03','09:45:00',1.2),('3355','2014-03-03','09:50:00',1.24),('3355','2014-03-03','09:55:00',1.45),('3355','2014-03-03','10:00:00',1.62),('3355','2014-03-03','10:05:00',1.73),('3355','2014-03-03','10:10:00',1.76),('3355','2014-03-03','10:15:00',1.78),('3355','2014-03-03','10:20:00',1.82),('3355','2014-03-03','10:25:00',1.86),('3355','2014-03-03','10:30:00',1.88),('3355','2014-03-03','10:35:00',1.9),('3355','2014-03-03','10:40:00',1.92),('3355','2014-03-03','10:45:00',1.93),('3355','2014-03-03','10:50:00',1.95),('3355','2014-03-03','10:55:00',1.97),('3355','2014-03-03','11:00:00',2.01),('3355','2014-03-03','11:05:00',2.02),('3355','2014-03-03','11:10:00',2.03),('3355','2014-03-03','11:15:00',2.05),('3355','2014-03-03','11:20:00',2.07),('3355','2014-03-03','11:25:00',2.11),('3355','2014-03-03','11:30:00',2.08),('3355','2014-03-03','11:35:00',1.89),('3355','2014-03-03','11:40:00',1.51),('3355','2014-03-03','11:45:00',2.23),('3355','2014-03-03','11:50:00',2.23),('3355','2014-03-03','11:55:00',2.25),('3355','2014-03-03','12:00:00',2.24),('3355','2014-03-03','12:05:00',2.25),('3355','2014-03-03','12:10:00',2.27),('3355','2014-03-03','12:15:00',2.26),('3355','2014-03-03','12:20:00',2.26),('3355','2014-03-03','12:25:00',2.27),('3355','2014-03-03','12:30:00',2.26),('3355','2014-03-03','12:35:00',2.27),('3355','2014-03-03','12:40:00',2.28),('3355','2014-03-03','12:45:00',2.25),('3355','2014-03-03','12:50:00',2.25),('3355','2014-03-03','12:55:00',2.24),('3355','2014-03-03','13:00:00',2.25),('3355','2014-03-03','13:05:00',2.23),('3355','2014-03-03','13:10:00',2.22),('3355','2014-03-03','13:15:00',2.2),('3355','2014-03-03','13:20:00',2.19),('3355','2014-03-03','13:25:00',2.19),('3355','2014-03-03','13:30:00',2.18),('3355','2014-03-03','13:35:00',2.17),('3355','2014-03-03','13:40:00',2.15),('3355','2014-03-03','13:45:00',2.14),('3355','2014-03-03','13:50:00',2.12),('3355','2014-03-03','13:55:00',2.11),('3355','2014-03-03','14:00:00',2.1),('3355','2014-03-03','14:05:00',2.08),('3355','2014-03-03','14:10:00',2.07),('3355','2014-03-03','14:15:00',2.08),('3355','2014-03-03','14:20:00',2.04),('3355','2014-03-03','14:25:00',1.81),('3355','2014-03-03','14:30:00',1.91),('3355','2014-03-03','14:35:00',1.96),('3355','2014-03-03','14:40:00',1.91),('3355','2014-03-03','14:45:00',1.87),('3355','2014-03-03','14:50:00',1.83),('3355','2014-03-03','14:55:00',1.79),('3355','2014-03-03','15:00:00',1.75),('3355','2014-03-03','15:05:00',1.71),('3355','2014-03-03','15:10:00',1.69),('3355','2014-03-03','15:15:00',1.65),('3355','2014-03-03','15:20:00',1.61),('3355','2014-03-03','15:25:00',1.58),('3355','2014-03-03','15:30:00',1.53),('3355','2014-03-03','15:35:00',1.48),('3355','2014-03-03','15:40:00',1.44),('3355','2014-03-03','15:45:00',1.39),('3355','2014-03-03','15:50:00',1.32),('3355','2014-03-03','15:55:00',1.27),('3355','2014-03-03','16:00:00',1.22),('3355','2014-03-03','16:05:00',1.17),('3355','2014-03-03','16:10:00',1.12),('3355','2014-03-03','16:15:00',1.08),('3355','2014-03-03','16:20:00',1.03),('3355','2014-03-02','08:45:00',1.05),('3355','2014-03-02','08:50:00',1.11),('3355','2014-03-02','08:55:00',1.17),('3355','2014-03-02','09:00:00',1.22),('3355','2014-03-02','09:05:00',1.28),('3355','2014-03-02','09:10:00',1.36),('3355','2014-03-02','09:15:00',1.4),('3355','2014-03-02','09:20:00',1.14),('3355','2014-03-02','09:25:00',1.35),('3355','2014-03-02','09:30:00',1.61),('3355','2014-03-02','09:35:00',1.63),('3355','2014-03-02','09:40:00',1.58),('3355','2014-03-02','10:00:00',1.11),('3355','2014-03-02','10:40:00',1.32),('3355','2014-03-02','11:00:00',1.18),('3355','2014-03-02','11:05:00',1.66),('3355','2014-03-02','11:25:00',1.05),('3355','2014-03-02','11:30:00',1.06),('3355','2014-03-02','11:35:00',1.54),('3355','2014-03-02','11:40:00',2.22),('3355','2014-03-02','11:45:00',1.97),('3355','2014-03-02','11:50:00',2.64),('3355','2014-03-02','11:55:00',2.54),('3355','2014-03-02','12:00:00',1.47),('3355','2014-03-02','12:05:00',1),('3355','2014-03-02','12:10:00',1.13),('3355','2014-03-02','12:15:00',1.93),('3355','2014-03-02','12:20:00',1.42),('3355','2014-03-02','12:25:00',1.02),('3355','2014-02-28','08:35:00',1.02),('3355','2014-02-28','09:45:00',1.64),('3355','2014-02-28','09:50:00',1.91),('3355','2014-02-28','09:55:00',1.79),('3355','2014-02-28','10:25:00',2.04),('3355','2014-02-28','10:30:00',2.16),('3355','2014-02-28','10:35:00',1.68),('3355','2014-02-28','10:40:00',1.2),('3355','2014-02-28','12:05:00',1.12),('3355','2014-02-28','12:10:00',1.27),('3355','2014-02-28','12:30:00',1.28),('3355','2014-02-28','12:35:00',1.48),('3355','2014-02-28','12:40:00',1.89),('3355','2014-02-28','12:50:00',1.38),('3355','2014-02-28','12:55:00',1.04),('3355','2014-02-28','13:00:00',1.37),('3355','2014-02-28','13:05:00',1.07),('3355','2014-02-28','13:50:00',1.89),('3355','2014-02-28','13:55:00',2.48),('3355','2014-02-28','14:00:00',1.04),('3355','2014-02-28','14:20:00',1.04),('3355','2014-02-28','14:25:00',1.17),('3355','2014-02-28','15:00:00',1.22),('3355','2014-02-28','15:25:00',1.1),('3355','2014-02-28','15:30:00',1.34),('3355','2014-02-28','15:35:00',1.59),('3355','2014-02-28','15:40:00',1.31),('3355','2014-02-28','16:15:00',1.34),('3355','2014-02-28','16:20:00',1.16),('3355','2014-02-28','16:45:00',1.03),('3355','2014-02-27','11:30:00',1.07),('3355','2014-02-27','11:35:00',1.02),('3355','2014-02-27','13:55:00',1.12),('3355','2014-02-27','14:00:00',1.09),('3355','2014-02-26','08:45:00',1.07),('3355','2014-02-26','08:50:00',1.06),('3355','2014-02-26','08:55:00',1.06),('3355','2014-02-26','09:00:00',1.11),('3355','2014-02-26','09:05:00',1.13),('3355','2014-02-26','09:10:00',1.15),('3355','2014-02-26','09:15:00',1.26),('3355','2014-02-26','09:20:00',1.3),('3355','2014-02-26','09:25:00',1.39),('3355','2014-02-26','09:30:00',1.31),('3355','2014-02-26','09:35:00',1.36),('3355','2014-02-26','09:45:00',1.27),('3355','2014-02-26','09:50:00',1.43),('3355','2014-02-26','12:10:00',1.82),('3355','2014-02-26','12:30:00',1.11),('3355','2014-02-26','12:45:00',1.73),('3355','2014-02-26','12:50:00',1.56),('3355','2014-02-26','12:55:00',1.05),('3355','2014-02-26','13:00:00',1.21),('3355','2014-02-26','13:05:00',1.91),('3355','2014-02-26','13:10:00',1.77),('3355','2014-02-26','13:15:00',1.74),('3355','2014-02-26','13:20:00',1.87),('3355','2014-02-26','13:25:00',1.8),('3355','2014-02-26','13:30:00',2.21),('3355','2014-02-26','13:35:00',2.12),('3355','2014-02-26','13:40:00',1.88),('3355','2014-02-26','13:45:00',1.95),('3355','2014-02-26','13:50:00',1.33),('3355','2014-02-26','14:00:00',2.01),('3355','2014-02-26','14:05:00',2.13),('3355','2014-02-26','14:15:00',1.27),('3355','2014-02-26','14:20:00',1.85),('3355','2014-02-26','14:25:00',2.06),('3355','2014-02-26','14:30:00',1.13),('3355','2014-02-26','14:40:00',1.61),('3355','2014-02-26','14:45:00',1.9),('3355','2014-02-26','14:50:00',1.11),('3355','2014-02-26','14:55:00',1.69),('3355','2014-02-26','15:00:00',1.78),('3355','2014-02-26','15:05:00',1.66),('3355','2014-02-26','15:10:00',1.52),('3355','2014-02-26','15:15:00',1.34),('3355','2014-02-26','15:20:00',1.2),('3355','2014-02-26','15:35:00',1.08),('3355','2014-02-26','16:00:00',1.15),('3355','2014-02-26','16:05:00',1.08),('3355','2014-04-29','10:10:00',1.47),('3355','2014-04-29','10:15:00',1.68),('3355','2014-04-29','10:20:00',1.75),('3355','2014-04-29','10:25:00',1.82),('3355','2014-04-29','10:30:00',2.11),('3355','2014-04-29','10:35:00',2.07),('3355','2014-04-29','10:40:00',2.09),('3355','2014-04-29','10:45:00',2.1),('3355','2014-04-29','10:50:00',2.15),('3355','2014-04-29','10:55:00',2.07),('3355','2014-04-29','11:00:00',2.1),('3355','2014-04-29','11:05:00',2.1),('3355','2014-04-29','11:10:00',2.16),('3355','2014-04-29','11:15:00',1.86),('3355','2014-04-29','11:20:00',2.1),('3355','2014-04-29','11:25:00',1.75),('3355','2014-04-29','11:30:00',2.21),('3355','2014-04-29','11:35:00',2.13),('3355','2014-04-29','11:40:00',2.01),('3355','2014-04-29','11:45:00',2.07),('3355','2014-04-29','12:05:00',1.16),('3355','2014-04-29','12:10:00',1.32),('3355','2014-04-29','12:15:00',2.4),('3355','2014-04-29','12:20:00',1.06),('3355','2014-04-29','12:25:00',1.61),('3355','2014-04-29','12:30:00',1.64),('3355','2014-04-29','12:35:00',1.53),('3355','2014-04-29','12:40:00',2.17),('3355','2014-04-29','12:45:00',1.57),('3355','2014-04-29','12:50:00',2.76),('3355','2014-04-29','12:55:00',1.82),('3355','2014-04-29','13:00:00',1.13),('3355','2014-04-29','13:15:00',1.16),('3355','2014-04-29','13:20:00',2.38),('3355','2014-04-29','13:25:00',2.25),('3355','2014-04-29','13:30:00',1.28),('3355','2014-04-29','13:35:00',1.13),('3355','2014-04-29','17:25:00',1.04),('3355','2014-04-29','17:35:00',1.11),('3355','2014-04-29','17:40:00',1.06),('3355','2014-04-29','17:45:00',1.13),('3355','2014-02-25','08:55:00',1.03),('3355','2014-02-25','09:00:00',1.08),('3355','2014-02-25','09:05:00',1.13),('3355','2014-02-25','09:10:00',1.17),('3355','2014-02-25','09:15:00',1.24),('3355','2014-02-25','09:20:00',1.26),('3355','2014-02-25','09:25:00',1.3),('3355','2014-02-25','09:30:00',1.35),('3355','2014-02-25','09:35:00',1.39),('3355','2014-02-25','09:40:00',1.43),('3355','2014-02-25','09:45:00',1.48),('3355','2014-02-25','09:50:00',1.5),('3355','2014-02-25','09:55:00',1.54),('3355','2014-02-25','10:00:00',1.56),('3355','2014-02-25','10:05:00',1.6),('3355','2014-02-25','10:10:00',1.63),('3355','2014-02-25','10:15:00',1.69),('3355','2014-02-25','10:20:00',1.71),('3355','2014-02-25','10:25:00',1.72),('3355','2014-02-25','10:30:00',1.75),('3355','2014-02-25','10:35:00',1.77),('3355','2014-02-25','10:40:00',1.8),('3355','2014-02-25','10:45:00',1.82),('3355','2014-02-25','10:50:00',1.83),('3355','2014-02-25','10:55:00',1.84),('3355','2014-02-25','11:00:00',1.87),('3355','2014-02-25','11:05:00',1.88),('3355','2014-02-25','11:10:00',1.9),('3355','2014-02-25','11:15:00',1.92),('3355','2014-02-25','11:20:00',1.94),('3355','2014-02-25','11:25:00',1.96),('3355','2014-02-25','11:30:00',1.96),('3355','2014-02-25','11:35:00',1.96),('3355','2014-02-25','11:40:00',2),('3355','2014-02-25','11:45:00',1.98),('3355','2014-02-25','11:50:00',2.01),('3355','2014-02-25','11:55:00',2.02),('3355','2014-02-25','12:00:00',2.01),('3355','2014-02-25','12:05:00',2.04),('3355','2014-02-25','12:10:00',2.05),('3355','2014-02-25','12:15:00',2.05),('3355','2014-02-25','12:20:00',2.05),('3355','2014-02-25','12:25:00',2.01),('3355','2014-02-25','12:30:00',2),('3355','2014-02-25','12:35:00',2.02),('3355','2014-02-25','12:40:00',2.04),('3355','2014-02-25','12:45:00',2.06),('3355','2014-02-25','12:50:00',2.11),('3355','2014-02-25','12:55:00',2.09),('3355','2014-02-25','13:00:00',2.02),('3355','2014-02-25','13:05:00',2.03),('3355','2014-02-25','13:10:00',2.07),('3355','2014-02-25','13:15:00',1.67),('3355','2014-02-25','13:20:00',1.12),('3355','2014-02-25','14:35:00',1.5),('3355','2014-02-25','14:40:00',1.75),('3355','2014-02-25','14:45:00',1.83),('3355','2014-02-25','14:50:00',1.75),('3355','2014-02-25','14:55:00',1.41),('3355','2014-02-25','15:00:00',1.56),('3355','2014-02-25','15:05:00',1.48),('3355','2014-02-25','15:10:00',1.5),('3355','2014-02-25','15:15:00',1.41),('3355','2014-02-25','15:20:00',1.4),('3355','2014-02-25','15:25:00',1.23),('3355','2014-02-25','15:30:00',1.09),('3355','2014-02-25','15:35:00',1),('3355','2014-02-25','15:40:00',1.15),('3355','2014-02-24','08:35:00',1.03),('3355','2014-02-24','08:40:00',1.1),('3355','2014-02-24','08:45:00',1.14),('3355','2014-02-24','08:50:00',1.08),('3355','2014-02-24','08:55:00',1.06),('3355','2014-02-24','09:00:00',1.08),('3355','2014-02-24','09:05:00',1.11),('3355','2014-02-24','09:10:00',1.16),('3355','2014-02-24','09:15:00',1.22),('3355','2014-02-24','09:20:00',1.26),('3355','2014-02-24','09:25:00',1.32),('3355','2014-02-24','09:30:00',1.36),('3355','2014-02-24','09:35:00',1.39),('3355','2014-02-24','09:40:00',1.43),('3355','2014-02-24','09:45:00',1.48),('3355','2014-02-24','09:50:00',1.51),('3355','2014-02-24','09:55:00',1.55),('3355','2014-02-24','10:00:00',1.59),('3355','2014-02-24','10:05:00',1.63),('3355','2014-02-24','10:10:00',1.66),('3355','2014-02-24','10:15:00',1.7),('3355','2014-02-24','10:20:00',1.73),('3355','2014-02-24','10:25:00',1.76),('3355','2014-02-24','10:30:00',1.79),('3355','2014-02-24','10:35:00',1.81),('3355','2014-02-24','10:40:00',1.84),('3355','2014-02-24','10:45:00',1.87),('3355','2014-02-24','10:50:00',1.9),('3355','2014-02-24','10:55:00',1.91),('3355','2014-02-24','11:00:00',1.93),('3355','2014-02-24','11:05:00',1.96),('3355','2014-02-24','11:10:00',1.98),('3355','2014-02-24','11:15:00',1.99),('3355','2014-02-24','11:20:00',2),('3355','2014-02-24','11:25:00',2.08),('3355','2014-02-24','11:30:00',2.21),('3355','2014-02-24','11:35:00',1.65),('3355','2014-02-24','11:40:00',2.2),('3355','2014-02-24','11:45:00',2.37),('3355','2014-02-24','11:50:00',1.77),('3355','2014-02-24','11:55:00',1.62),('3355','2014-02-24','12:00:00',1.84),('3355','2014-02-24','12:05:00',1.34),('3355','2014-02-24','12:10:00',1.89),('3355','2014-02-24','12:15:00',1.84),('3355','2014-02-24','12:20:00',1.93),('3355','2014-02-24','12:25:00',2.23),('3355','2014-02-24','12:30:00',2.06),('3355','2014-02-24','12:40:00',1.86),('3355','2014-02-24','12:50:00',2.24),('3355','2014-02-24','12:55:00',2.17),('3355','2014-02-24','13:10:00',2.48),('3355','2014-02-24','13:15:00',2.58),('3355','2014-02-24','15:35:00',1.55),('3355','2014-02-24','15:40:00',1.66),('3355','2014-02-24','15:45:00',1.58),('3355','2014-02-24','15:50:00',1.48),('3355','2014-02-24','15:55:00',1.12),('3355','2014-02-24','16:00:00',1.32),('3355','2014-02-24','16:05:00',1.36),('3355','2014-02-24','16:10:00',1.26),('3355','2014-02-24','16:15:00',1.18),('3355','2014-02-24','16:20:00',1.01),('3355','2014-02-23','09:55:00',1.52),('3355','2014-02-23','10:00:00',1.53),('3355','2014-02-23','10:05:00',1.58),('3355','2014-02-23','10:10:00',1.6),('3355','2014-02-23','10:15:00',1.62),('3355','2014-02-23','10:20:00',1.67),('3355','2014-02-23','10:25:00',1.71),('3355','2014-02-23','10:30:00',1.74),('3355','2014-02-23','10:35:00',1.76),('3355','2014-02-23','10:40:00',1.8),('3355','2014-02-23','10:45:00',1.84),('3355','2014-02-23','10:50:00',1.84),('3355','2014-02-23','10:55:00',1.58),('3355','2014-02-23','11:00:00',1.79),('3355','2014-02-23','11:05:00',1.95),('3355','2014-02-23','11:10:00',1.97),('3355','2014-02-23','11:15:00',1.98),('3355','2014-02-23','11:20:00',1.97),('3355','2014-02-23','11:25:00',1.97),('3355','2014-02-23','11:30:00',2.08),('3355','2014-02-23','11:35:00',2.08),('3355','2014-02-23','11:40:00',2.14),('3355','2014-02-23','11:45:00',2.13),('3355','2014-02-23','11:50:00',2.06),('3355','2014-02-23','11:55:00',1.87),('3355','2014-02-23','12:00:00',1.88),('3355','2014-02-23','12:05:00',2.23),('3355','2014-02-23','12:10:00',1.89),('3355','2014-02-23','12:15:00',2.3),('3355','2014-02-23','12:20:00',2.17),('3355','2014-02-23','12:25:00',1.36),('3355','2014-02-23','12:30:00',1.49),('3355','2014-02-23','12:35:00',2.37),('3355','2014-02-23','12:40:00',1.41),('3355','2014-02-23','12:45:00',1.29),('3355','2014-02-23','12:55:00',1.24),('3355','2014-02-23','13:00:00',1.36),('3355','2014-02-23','13:05:00',2.15),('3355','2014-02-23','13:10:00',2.16),('3355','2014-02-23','13:15:00',2.12),('3355','2014-02-23','13:20:00',2.11),('3355','2014-02-23','13:25:00',2.11),('3355','2014-02-23','13:30:00',2.06),('3355','2014-02-23','13:40:00',2.01),('3355','2014-02-23','13:45:00',1.87),('3355','2014-02-23','13:50:00',1.67),('3355','2014-02-23','14:00:00',1.8),('3355','2014-02-23','14:05:00',1.86),('3355','2014-02-23','14:10:00',2.03),('3355','2014-02-23','14:15:00',1.57),('3355','2014-02-23','14:20:00',1.03),('3355','2014-02-23','14:25:00',1.43),('3355','2014-02-23','14:30:00',1.71),('3355','2014-02-23','14:35:00',1.19),('3355','2014-02-22','10:05:00',1.36),('3355','2014-02-22','10:10:00',1.02),('3355','2014-02-22','10:15:00',1.24),('3355','2014-02-22','10:30:00',1.71),('3355','2014-02-22','10:45:00',1.53),('3355','2014-02-22','10:50:00',2.11),('3355','2014-02-22','12:15:00',1.26),('3355','2014-02-22','12:25:00',1.05),('3355','2014-02-22','12:45:00',2.04),('3355','2014-02-22','12:50:00',1.8),('3355','2014-02-22','13:10:00',2.28),('3355','2014-02-22','13:15:00',1.51),('3355','2014-02-22','13:40:00',1.31),('3355','2014-02-22','13:55:00',1.92),('3355','2014-02-22','14:00:00',2.16),('3355','2014-02-22','14:05:00',1.66),('3355','2014-02-22','14:10:00',1.85),('3355','2014-02-22','14:15:00',1.5),('3355','2014-02-22','14:20:00',1.98),('3355','2014-02-22','14:25:00',1.75),('3355','2014-02-22','14:30:00',1.72),('3355','2014-02-22','14:40:00',1.52),('3355','2014-02-22','14:45:00',1.9),('3355','2014-02-22','14:50:00',1.88),('3355','2014-02-22','15:05:00',1.18),('3355','2014-02-22','15:30:00',1.23),('3355','2014-02-22','15:35:00',1.45),('3355','2014-02-22','15:45:00',1.17),('3355','2014-02-22','15:50:00',1.24),('3355','2014-02-22','15:55:00',1.09),('3355','2014-02-22','16:00:00',1.13),('3355','2014-02-21','10:20:00',1.08),('3355','2014-02-21','10:25:00',1.36),('3355','2014-02-21','10:30:00',1.58),('3355','2014-02-21','10:35:00',1.26),('3355','2014-02-21','10:40:00',1.05),('3355','2014-02-21','10:45:00',1.01),('3355','2014-02-21','10:55:00',1.19),('3355','2014-02-21','11:00:00',1.06),('3355','2014-02-21','11:25:00',1.29),('3355','2014-02-21','11:30:00',2.19),('3355','2014-02-21','11:35:00',1.58),('3355','2014-02-21','11:40:00',2.05),('3355','2014-02-21','11:45:00',2.03),('3355','2014-02-21','11:55:00',2.28),('3355','2014-02-21','12:00:00',2.46),('3355','2014-02-21','12:05:00',2.39),('3355','2014-02-21','12:10:00',1.9),('3355','2014-02-21','15:05:00',1.05),('3355','2014-02-21','15:30:00',1.35),('3355','2014-02-21','15:35:00',1.26),('3355','2014-02-21','15:40:00',1.19),('3355','2014-02-21','15:45:00',1.16),('3355','2014-02-21','15:50:00',1.1),('3355','2014-02-21','15:55:00',1.04),('3355','2014-02-19','10:45:00',1.06),('3355','2014-02-18','09:05:00',1.02),('3355','2014-02-18','09:10:00',1.06),('3355','2014-02-18','09:15:00',1.1),('3355','2014-02-18','09:20:00',1.15),('3355','2014-02-18','09:25:00',1.19),('3355','2014-02-18','09:30:00',1.24),('3355','2014-02-18','09:35:00',1.28),('3355','2014-02-18','09:40:00',1.32),('3355','2014-02-18','09:45:00',1.35),('3355','2014-02-18','09:50:00',1.4),('3355','2014-02-18','09:55:00',1.44),('3355','2014-02-18','10:00:00',1.48),('3355','2014-02-18','10:05:00',1.51),('3355','2014-02-18','10:10:00',1.54),('3355','2014-02-18','10:15:00',1.56),('3355','2014-02-18','10:20:00',1.59),('3355','2014-02-18','10:25:00',1.62),('3355','2014-02-18','10:30:00',1.63),('3355','2014-02-18','10:35:00',1.65),('3355','2014-02-18','10:40:00',1.68),('3355','2014-02-18','10:45:00',1.71),('3355','2014-02-18','10:50:00',1.74),('3355','2014-02-18','10:55:00',1.77),('3355','2014-02-18','11:00:00',1.8),('3355','2014-02-18','11:05:00',1.54),('3355','2014-02-18','11:10:00',1.49),('3355','2014-02-18','11:15:00',1.43),('3355','2014-02-18','11:20:00',1.66),('3355','2014-02-18','11:25:00',1.87),('3355','2014-02-18','11:30:00',1.74),('3355','2014-02-18','11:35:00',1.55),('3355','2014-02-18','11:40:00',1.28),('3355','2014-02-18','11:45:00',1.29),('3355','2014-02-18','11:50:00',1.08),('3355','2014-02-18','12:15:00',1.05),('3355','2014-02-18','12:20:00',1.01),('3355','2014-02-18','12:25:00',1.19),('3355','2014-02-18','12:30:00',1.36),('3355','2014-02-18','12:35:00',1.01),('3355','2014-02-18','12:55:00',1.03),('3355','2014-02-18','13:15:00',1.05),('3355','2014-02-18','13:20:00',1.15),('3355','2014-02-18','13:25:00',1.38),('3355','2014-02-18','13:40:00',1.05),('3355','2014-02-18','13:45:00',1.27),('3355','2014-02-18','14:00:00',1.12),('3355','2014-02-18','14:05:00',1.63),('3355','2014-02-17','09:15:00',1.02),('3355','2014-02-17','09:20:00',1.06),('3355','2014-02-17','09:25:00',1.11),('3355','2014-02-17','09:30:00',1.16),('3355','2014-02-17','09:35:00',1.2),('3355','2014-02-17','09:40:00',1.23),('3355','2014-02-17','09:45:00',1.26),('3355','2014-02-17','09:50:00',1.29),('3355','2014-02-17','09:55:00',1.32),('3355','2014-02-17','10:00:00',1.35),('3355','2014-02-17','10:05:00',1.4),('3355','2014-02-17','10:10:00',1.43),('3355','2014-02-17','10:15:00',1.45),('3355','2014-02-17','10:20:00',1.46),('3355','2014-02-17','10:25:00',1.48),('3355','2014-02-17','10:30:00',1.51),('3355','2014-02-17','10:35:00',1.52),('3355','2014-02-17','10:40:00',1.53),('3355','2014-02-17','10:45:00',1.54),('3355','2014-02-17','10:50:00',1.55),('3355','2014-02-17','10:55:00',1.59),('3355','2014-02-17','11:00:00',1.59),('3355','2014-02-17','11:05:00',1.62),('3355','2014-02-17','11:10:00',1.65),('3355','2014-02-17','11:15:00',1.67),('3355','2014-02-17','11:20:00',1.71),('3355','2014-02-17','11:25:00',1.74),('3355','2014-02-17','11:30:00',1.78),('3355','2014-02-17','11:35:00',1.81),('3355','2014-02-17','11:40:00',1.83),('3355','2014-02-17','11:45:00',1.84),('3355','2014-02-17','11:50:00',1.85),('3355','2014-02-17','11:55:00',1.85),('3355','2014-02-17','12:00:00',1.86),('3355','2014-02-17','12:05:00',1.88),('3355','2014-02-17','12:10:00',1.87),('3355','2014-02-17','12:15:00',1.87),('3355','2014-02-17','12:20:00',1.87),('3355','2014-02-17','12:25:00',1.87),('3355','2014-02-17','12:30:00',1.87),('3355','2014-02-17','12:35:00',1.87),('3355','2014-02-17','12:40:00',1.86),('3355','2014-02-17','12:45:00',1.85),('3355','2014-02-17','12:50:00',1.85),('3355','2014-02-17','12:55:00',1.85),('3355','2014-02-17','13:00:00',1.85),('3355','2014-02-17','13:05:00',1.83),('3355','2014-02-17','13:10:00',1.82),('3355','2014-02-17','13:15:00',1.8),('3355','2014-02-17','13:20:00',1.79),('3355','2014-02-17','13:25:00',1.79),('3355','2014-02-17','13:30:00',1.79),('3355','2014-02-17','13:35:00',1.79),('3355','2014-02-17','13:40:00',1.77),('3355','2014-02-17','13:45:00',1.73),('3355','2014-02-17','13:50:00',1.73),('3355','2014-02-17','13:55:00',1.71),('3355','2014-02-17','14:00:00',1.67),('3355','2014-02-17','14:05:00',1.67),('3355','2014-02-17','14:10:00',1.6),('3355','2014-02-17','14:15:00',1.55),('3355','2014-02-17','14:20:00',1.61),('3355','2014-02-17','14:25:00',1.55),('3355','2014-02-17','14:30:00',1.51),('3355','2014-02-17','14:35:00',1.47),('3355','2014-02-17','14:40:00',1.34),('3355','2014-02-17','14:45:00',1.47),('3355','2014-02-17','14:50:00',1.38),('3355','2014-02-17','14:55:00',1.38),('3355','2014-02-17','15:00:00',1.3),('3355','2014-02-17','15:05:00',1.28),('3355','2014-02-17','15:10:00',1.25),('3355','2014-02-17','15:15:00',1.27),('3355','2014-02-17','15:20:00',1.24),('3355','2014-02-17','15:25:00',1.16),('3355','2014-02-17','15:30:00',1.14),('3355','2014-02-17','15:35:00',1.09),('3355','2014-02-17','15:40:00',1.01),('3355','2014-02-17','15:45:00',1.01),('3355','2014-02-16','09:05:00',1.04),('3355','2014-02-16','09:10:00',1.02),('3355','2014-02-16','09:20:00',1.08),('3355','2014-02-16','09:25:00',1.14),('3355','2014-02-16','09:30:00',1.19),('3355','2014-02-16','09:35:00',1),('3355','2014-02-16','09:40:00',1.26),('3355','2014-02-16','09:45:00',1.35),('3355','2014-02-16','09:50:00',1.39),('3355','2014-02-16','09:55:00',1.37),('3355','2014-02-16','10:00:00',1.33),('3355','2014-02-16','10:05:00',1.5),('3355','2014-02-16','10:10:00',1.55),('3355','2014-02-16','10:15:00',1.58),('3355','2014-02-16','10:20:00',1.61),('3355','2014-02-16','10:25:00',1.65),('3355','2014-02-16','10:30:00',1.67),('3355','2014-02-16','10:35:00',1.74),('3355','2014-02-16','10:40:00',1.79),('3355','2014-02-16','10:45:00',1.77),('3355','2014-02-16','10:50:00',1.61),('3355','2014-02-16','10:55:00',1.5),('3355','2014-02-16','11:00:00',1.79),('3355','2014-02-16','11:05:00',1.84),('3355','2014-02-16','11:10:00',1.77),('3355','2014-02-16','11:15:00',1.82),('3355','2014-02-16','11:20:00',1.79),('3355','2014-02-16','11:25:00',1.73),('3355','2014-02-16','11:30:00',1.79),('3355','2014-02-16','11:35:00',1.9),('3355','2014-02-16','11:40:00',1.9),('3355','2014-02-16','11:45:00',1.69),('3355','2014-02-16','11:50:00',1.91),('3355','2014-02-16','11:55:00',1.64),('3355','2014-02-16','12:00:00',1.95),('3355','2014-02-16','12:05:00',1.93),('3355','2014-02-16','12:10:00',1.94),('3355','2014-02-16','12:15:00',1.94),('3355','2014-02-16','12:20:00',1.95),('3355','2014-02-16','12:25:00',1.91),('3355','2014-02-16','12:30:00',1.95),('3355','2014-02-16','12:35:00',1.94),('3355','2014-02-16','12:40:00',1.93),('3355','2014-02-16','12:45:00',1.91),('3355','2014-02-16','12:50:00',1.92),('3355','2014-02-16','12:55:00',1.94),('3355','2014-02-16','13:00:00',1.92),('3355','2014-02-16','13:05:00',1.92),('3355','2014-02-16','13:10:00',1.87),('3355','2014-02-16','13:15:00',1.89),('3355','2014-02-16','13:20:00',1.92),('3355','2014-02-16','13:25:00',1.89),('3355','2014-02-16','13:30:00',1.84),('3355','2014-02-16','13:35:00',1.84),('3355','2014-02-16','13:40:00',1.82),('3355','2014-02-16','13:45:00',1.84),('3355','2014-02-16','13:50:00',1.82),('3355','2014-02-16','13:55:00',1.82),('3355','2014-02-16','14:00:00',1.82),('3355','2014-02-16','14:05:00',1.81),('3355','2014-02-16','14:10:00',1.8),('3355','2014-02-16','14:15:00',1.77),('3355','2014-02-16','14:20:00',1.75),('3355','2014-02-16','14:25:00',1.74),('3355','2014-02-16','14:30:00',1.7),('3355','2014-02-16','14:35:00',1.68),('3355','2014-02-16','14:40:00',1.62),('3355','2014-02-16','14:45:00',1.62),('3355','2014-02-16','14:50:00',1.58),('3355','2014-02-16','14:55:00',1.56),('3355','2014-02-16','15:00:00',1.51),('3355','2014-02-16','15:05:00',1.5),('3355','2014-02-16','15:10:00',1.45),('3355','2014-02-16','15:15:00',1.41),('3355','2014-02-16','15:20:00',1.36),('3355','2014-02-16','15:25:00',1.31),('3355','2014-02-16','15:30:00',1.27),('3355','2014-02-16','15:35:00',1.13),('3355','2014-02-16','15:45:00',1.17),('3355','2014-04-28','09:15:00',1.48),('3355','2014-04-28','09:20:00',1.48),('3355','2014-04-28','09:25:00',1.16),('3355','2014-04-28','09:30:00',1.19),('3355','2014-04-28','09:40:00',1.08),('3355','2014-04-28','09:50:00',1.29),('3355','2014-04-28','10:05:00',1.17),('3355','2014-04-28','10:10:00',1.26),('3355','2014-04-28','10:15:00',1.21),('3355','2014-04-28','10:20:00',1.03),('3355','2014-04-28','10:50:00',1.08),('3355','2014-04-28','11:05:00',1.23),('3355','2014-04-28','11:10:00',1.4),('3355','2014-04-28','11:15:00',1.34),('3355','2014-04-28','11:20:00',1.31),('3355','2014-04-28','11:30:00',1.08),('3355','2014-04-28','11:35:00',1.04),('3355','2014-04-28','11:55:00',1.08),('3355','2014-04-28','12:15:00',1.45),('3355','2014-04-28','12:20:00',1.68),('3355','2014-04-28','12:25:00',1.54),('3355','2014-04-28','12:30:00',1.45),('3355','2014-04-28','12:35:00',1.34),('3355','2014-04-28','12:40:00',1.21),('3355','2014-04-28','12:45:00',1.04),('3355','2014-04-28','12:50:00',1.29),('3355','2014-04-28','12:55:00',1.2),('3355','2014-04-28','13:00:00',1.22),('3355','2014-04-28','13:05:00',1.39),('3355','2014-04-28','13:10:00',2.2),('3355','2014-04-28','13:15:00',1.31),('3355','2014-04-28','13:20:00',1.18),('3355','2014-04-28','13:25:00',1.35),('3355','2014-04-28','13:30:00',2.38),('3355','2014-04-28','13:35:00',2.16),('3355','2014-04-28','13:40:00',2.14),('3355','2014-04-28','13:45:00',1.07),('3355','2014-04-28','13:50:00',2.34),('3355','2014-04-28','13:55:00',1.92),('3355','2014-04-28','14:05:00',1.25),('3355','2014-04-28','14:10:00',1.8),('3355','2014-04-28','14:15:00',2.08),('3355','2014-04-28','14:20:00',2.3),('3355','2014-04-28','14:25:00',1.57),('3355','2014-04-28','14:30:00',1.32),('3355','2014-04-28','14:35:00',2.32),('3355','2014-04-28','14:40:00',2.43),('3355','2014-04-28','14:45:00',1.58),('3355','2014-04-28','14:50:00',1.3),('3355','2014-04-28','14:55:00',2.17),('3355','2014-04-28','15:00:00',1.49),('3355','2014-04-28','15:05:00',1.65),('3355','2014-04-28','15:10:00',1.84),('3355','2014-04-28','15:15:00',1.4),('3355','2014-04-28','15:20:00',1.02),('3355','2014-04-28','15:25:00',1.24),('3355','2014-04-28','15:30:00',1.13),('3355','2014-04-28','15:35:00',1.6),('3355','2014-04-28','15:40:00',1.41),('3355','2014-04-28','15:50:00',2.07),('3355','2014-04-28','16:00:00',1.48),('3355','2014-04-28','16:05:00',1.96),('3355','2014-04-28','16:10:00',2.15),('3355','2014-04-28','16:15:00',1.68),('3355','2014-04-28','16:20:00',1.21),('3355','2014-04-28','16:30:00',2),('3355','2014-04-28','16:35:00',1.85),('3355','2014-02-15','09:15:00',1.03),('3355','2014-02-15','09:20:00',1.1),('3355','2014-02-15','09:25:00',1.15),('3355','2014-02-15','09:30:00',1.19),('3355','2014-02-15','09:35:00',1.24),('3355','2014-02-15','09:40:00',1.28),('3355','2014-02-15','09:45:00',1.31),('3355','2014-02-15','09:50:00',1.34),('3355','2014-02-15','09:55:00',1.39),('3355','2014-02-15','10:00:00',1.42),('3355','2014-02-15','10:05:00',1.46),('3355','2014-02-15','10:10:00',1.48),('3355','2014-02-15','10:15:00',1.52),('3355','2014-02-15','10:20:00',1.54),('3355','2014-02-15','10:25:00',1.57),('3355','2014-02-15','10:30:00',1.58),('3355','2014-02-15','10:35:00',1.6),('3355','2014-02-15','10:40:00',1.63),('3355','2014-02-15','10:45:00',1.64),('3355','2014-02-15','10:50:00',1.67),('3355','2014-02-15','10:55:00',1.72),('3355','2014-02-15','11:00:00',1.78),('3355','2014-02-15','11:05:00',1.84),('3355','2014-02-15','11:10:00',1.78),('3355','2014-02-15','11:15:00',1.75),('3355','2014-02-15','11:20:00',1.88),('3355','2014-02-15','11:35:00',1.94),('3355','2014-02-15','11:40:00',1.66),('3355','2014-02-15','11:45:00',2.03),('3355','2014-02-15','11:50:00',1.59),('3355','2014-02-15','11:55:00',2.01),('3355','2014-02-15','12:00:00',1.04),('3355','2014-02-15','12:05:00',1.68),('3355','2014-02-15','12:10:00',1.7),('3355','2014-02-15','12:15:00',2.01),('3355','2014-02-15','12:20:00',2.21),('3355','2014-02-15','12:25:00',2.12),('3355','2014-02-15','12:30:00',2.1),('3355','2014-02-15','12:35:00',2.05),('3355','2014-02-15','12:40:00',2.22),('3355','2014-02-15','12:45:00',2.28),('3355','2014-02-15','12:50:00',2.24),('3355','2014-02-15','12:55:00',2.04),('3355','2014-02-15','13:00:00',2.1),('3355','2014-02-15','13:05:00',2.08),('3355','2014-02-15','13:10:00',2.07),('3355','2014-02-15','13:15:00',2.03),('3355','2014-02-15','13:20:00',1.99),('3355','2014-02-15','13:25:00',1.91),('3355','2014-02-15','13:30:00',1.9),('3355','2014-02-15','13:35:00',1.88),('3355','2014-02-15','13:40:00',1.87),('3355','2014-02-15','13:45:00',1.84),('3355','2014-02-15','13:50:00',1.84),('3355','2014-02-15','13:55:00',1.79),('3355','2014-02-15','14:00:00',1.78),('3355','2014-02-15','14:05:00',1.77),('3355','2014-02-15','14:10:00',1.73),('3355','2014-02-15','14:15:00',1.72),('3355','2014-02-15','14:20:00',1.7),('3355','2014-02-15','14:25:00',1.66),('3355','2014-02-15','14:30:00',1.64),('3355','2014-02-15','14:35:00',1.62),('3355','2014-02-15','14:40:00',1.6),('3355','2014-02-15','14:45:00',1.56),('3355','2014-02-15','14:50:00',1.53),('3355','2014-02-15','14:55:00',1.48),('3355','2014-02-15','15:00:00',1.41),('3355','2014-02-15','15:05:00',1.39),('3355','2014-02-15','15:10:00',1.33),('3355','2014-02-15','15:15:00',1.33),('3355','2014-02-15','15:20:00',1.3),('3355','2014-02-15','15:25:00',1.26),('3355','2014-02-15','15:30:00',1.22),('3355','2014-02-15','15:35:00',1.19),('3355','2014-02-15','15:40:00',1.16),('3355','2014-02-15','15:45:00',1.12),('3355','2014-02-15','15:50:00',1.07),('3355','2014-02-15','15:55:00',1.02),('3355','2014-02-14','09:30:00',1.01),('3355','2014-02-14','09:50:00',1.11),('3355','2014-02-14','09:55:00',1.45),('3355','2014-02-14','10:00:00',1.3),('3355','2014-02-14','10:05:00',1.52),('3355','2014-02-14','10:10:00',1.62),('3355','2014-02-14','10:15:00',1.19),('3355','2014-02-14','10:20:00',1.52),('3355','2014-02-14','10:25:00',1.46),('3355','2014-02-14','10:30:00',1.71),('3355','2014-02-14','10:35:00',1.67),('3355','2014-02-14','10:40:00',1.7),('3355','2014-02-14','10:45:00',1.75),('3355','2014-02-14','10:50:00',1.8),('3355','2014-02-14','10:55:00',1.82),('3355','2014-02-14','11:00:00',1.84),('3355','2014-02-14','11:05:00',1.87),('3355','2014-02-14','11:10:00',1.89),('3355','2014-02-14','11:15:00',1.9),('3355','2014-02-14','11:20:00',1.93),('3355','2014-02-14','11:25:00',1.95),('3355','2014-02-14','11:30:00',1.97),('3355','2014-02-14','11:35:00',2),('3355','2014-02-14','11:40:00',1.93),('3355','2014-02-14','11:45:00',2.01),('3355','2014-02-14','11:50:00',1.9),('3355','2014-02-14','11:55:00',2.01),('3355','2014-02-14','12:00:00',2.03),('3355','2014-02-14','12:05:00',2.04),('3355','2014-02-14','12:10:00',2),('3355','2014-02-14','12:15:00',2.05),('3355','2014-02-14','12:20:00',2.04),('3355','2014-02-14','12:25:00',2.06),('3355','2014-02-14','12:30:00',2.06),('3355','2014-02-14','12:35:00',2.04),('3355','2014-02-14','12:40:00',2.03),('3355','2014-02-14','12:45:00',2.02),('3355','2014-02-14','12:50:00',2.02),('3355','2014-02-14','12:55:00',2.03),('3355','2014-02-14','13:00:00',2.02),('3355','2014-02-14','13:05:00',2.01),('3355','2014-02-14','13:10:00',2),('3355','2014-02-14','13:15:00',1.99),('3355','2014-02-14','13:20:00',1.99),('3355','2014-02-14','13:25:00',1.96),('3355','2014-02-14','13:30:00',1.94),('3355','2014-02-14','13:35:00',1.93),('3355','2014-02-14','13:40:00',1.94),('3355','2014-02-14','13:45:00',1.9),('3355','2014-02-14','13:50:00',1.89),('3355','2014-02-14','13:55:00',1.87),('3355','2014-02-14','14:00:00',1.85),('3355','2014-02-14','14:05:00',1.82),('3355','2014-02-14','14:10:00',1.8),('3355','2014-02-14','14:15:00',1.77),('3355','2014-02-14','14:20:00',1.75),('3355','2014-02-14','14:25:00',1.73),('3355','2014-02-14','14:30:00',1.71),('3355','2014-02-14','14:35:00',1.68),('3355','2014-02-14','14:40:00',1.64),('3355','2014-02-14','14:45:00',1.6),('3355','2014-02-14','14:50:00',1.56),('3355','2014-02-14','14:55:00',1.52),('3355','2014-02-14','15:00:00',1.48),('3355','2014-02-14','15:05:00',1.45),('3355','2014-02-14','15:10:00',1.42),('3355','2014-02-14','15:15:00',1.39),('3355','2014-02-14','15:20:00',1.34),('3355','2014-02-14','15:25:00',1.3),('3355','2014-02-14','15:30:00',1.26),('3355','2014-02-14','15:35:00',1.21),('3355','2014-02-14','15:40:00',1.16),('3355','2014-02-14','15:45:00',1.11),('3355','2014-02-14','15:50:00',1.06),('3355','2014-02-13','09:10:00',1.04),('3355','2014-02-13','09:15:00',1.08),('3355','2014-02-13','09:20:00',1.13),('3355','2014-02-13','09:25:00',1.18),('3355','2014-02-13','09:30:00',1.21),('3355','2014-02-13','09:35:00',1.26),('3355','2014-02-13','09:40:00',1.3),('3355','2014-02-13','09:45:00',1.33),('3355','2014-02-13','09:50:00',1.36),('3355','2014-02-13','09:55:00',1.4),('3355','2014-02-13','10:00:00',1.44),('3355','2014-02-13','10:05:00',1.48),('3355','2014-02-13','10:10:00',1.51),('3355','2014-02-13','10:15:00',1.54),('3355','2014-02-13','10:20:00',1.56),('3355','2014-02-13','10:25:00',1.58),('3355','2014-02-13','10:30:00',1.62),('3355','2014-02-13','10:35:00',1.65),('3355','2014-02-13','10:40:00',1.67),('3355','2014-02-13','10:45:00',1.66),('3355','2014-02-13','10:50:00',1.69),('3355','2014-02-13','10:55:00',1.72),('3355','2014-02-13','11:00:00',1.74),('3355','2014-02-13','11:05:00',1.75),('3355','2014-02-13','11:10:00',1.82),('3355','2014-02-13','11:15:00',1.86),('3355','2014-02-13','11:20:00',1.86),('3355','2014-02-13','11:25:00',1.79),('3355','2014-02-13','11:30:00',1.62),('3355','2014-02-13','11:35:00',1.84),('3355','2014-02-13','11:40:00',1.28),('3355','2014-02-13','11:45:00',1.98),('3355','2014-02-13','11:55:00',1.87),('3355','2014-02-13','12:00:00',1.03),('3355','2014-02-13','12:10:00',1.58),('3355','2014-02-13','12:15:00',1.42),('3355','2014-02-13','12:20:00',1.34),('3355','2014-02-13','12:30:00',2.16),('3355','2014-02-13','12:35:00',2.34),('3355','2014-02-13','12:40:00',2.25),('3355','2014-02-13','12:55:00',1.13),('3355','2014-02-13','13:00:00',1.1),('3355','2014-02-13','13:05:00',2.14),('3355','2014-02-13','13:10:00',2.09),('3355','2014-02-13','13:15:00',2.05),('3355','2014-02-13','13:20:00',2.03),('3355','2014-02-13','13:25:00',2.01),('3355','2014-02-13','13:30:00',2),('3355','2014-02-13','13:35:00',1.98),('3355','2014-02-13','13:40:00',1.96),('3355','2014-02-13','13:45:00',1.96),('3355','2014-02-13','13:50:00',1.94),('3355','2014-02-13','13:55:00',1.93),('3355','2014-02-13','14:00:00',1.9),('3355','2014-02-13','14:05:00',1.87),('3355','2014-02-13','14:10:00',1.85),('3355','2014-02-13','14:15:00',1.82),('3355','2014-02-13','14:20:00',1.78),('3355','2014-02-13','14:25:00',1.76),('3355','2014-02-13','14:30:00',1.73),('3355','2014-02-13','14:35:00',1.71),('3355','2014-02-13','14:40:00',1.68),('3355','2014-02-13','14:45:00',1.62),('3355','2014-02-13','14:55:00',1.65),('3355','2014-02-13','15:00:00',1.66),('3355','2014-02-13','15:05:00',1.25),('3355','2014-02-13','15:10:00',1.54),('3355','2014-02-13','15:15:00',1.28),('3355','2014-02-13','15:20:00',1.44),('3355','2014-02-13','15:25:00',1.41),('3355','2014-02-13','15:40:00',1.06),('3355','2014-02-13','15:45:00',1.22),('3355','2014-02-12','09:15:00',1.11),('3355','2014-02-12','09:20:00',1.08),('3355','2014-02-12','09:45:00',1.23),('3355','2014-02-12','09:50:00',1.08),('3355','2014-02-12','10:35:00',1.17),('3355','2014-02-12','10:45:00',1.19),('3355','2014-02-12','11:05:00',1.57),('3355','2014-02-12','11:20:00',1.08),('3355','2014-02-12','11:30:00',1.15),('3355','2014-02-12','11:35:00',1.12),('3355','2014-02-12','13:00:00',1.04),('3355','2014-02-12','13:30:00',1.3),('3355','2014-02-12','13:35:00',2.12),('3355','2014-02-12','13:40:00',1.98),('3355','2014-02-12','13:45:00',1.49),('3355','2014-02-12','13:50:00',1.72),('3355','2014-02-12','13:55:00',1.45),('3355','2014-02-12','14:00:00',1.99),('3355','2014-02-12','14:05:00',2.02),('3355','2014-02-12','14:10:00',1.93),('3355','2014-02-12','14:15:00',1.98),('3355','2014-02-12','14:20:00',1.8),('3355','2014-02-12','14:25:00',1.86),('3355','2014-02-12','14:35:00',1.5),('3355','2014-02-12','14:40:00',1.17),('3355','2014-02-12','14:45:00',1.2),('3355','2014-02-12','14:50:00',1.8),('3355','2014-02-12','14:55:00',1.71),('3355','2014-02-12','15:00:00',1.07),('3355','2014-02-12','15:20:00',1.16),('3355','2014-02-12','15:25:00',1.01),('3355','2014-02-12','15:35:00',1.24),('3355','2014-02-12','15:40:00',1.25),('3355','2014-02-12','15:50:00',1.18),('3355','2014-02-11','10:20:00',1.05),('3355','2014-02-11','10:25:00',1.1),('3355','2014-02-11','10:30:00',1.19),('3355','2014-02-11','10:35:00',1.4),('3355','2014-02-11','10:40:00',1.43),('3355','2014-02-11','10:45:00',1.24),('3355','2014-02-11','10:50:00',1.27),('3355','2014-02-11','10:55:00',1.12),('3355','2014-02-11','11:00:00',1.25),('3355','2014-02-11','11:05:00',1.29),('3355','2014-02-11','11:10:00',1.08),('3355','2014-02-11','11:25:00',1.2),('3355','2014-02-11','11:30:00',1.45),('3355','2014-02-11','11:35:00',1.46),('3355','2014-02-11','11:40:00',1.04),('3355','2014-02-11','11:50:00',1.26),('3355','2014-02-11','12:25:00',1.31),('3355','2014-02-11','12:30:00',1.27),('3355','2014-02-11','12:35:00',1.07),('3355','2014-02-11','13:00:00',1),('3355','2014-02-11','13:05:00',1.25),('3355','2014-02-11','13:10:00',1.54),('3355','2014-02-11','13:15:00',1.51),('3355','2014-02-11','13:20:00',1.86),('3355','2014-02-11','13:25:00',1.7),('3355','2014-02-11','13:30:00',1.51),('3355','2014-02-11','13:35:00',1.43),('3355','2014-02-11','13:40:00',1.72),('3355','2014-02-11','13:45:00',1.33),('3355','2014-02-11','14:00:00',1.08),('3355','2014-02-11','14:05:00',1.15),('3355','2014-02-11','14:15:00',1.09),('3355','2014-02-09','12:45:00',1.22),('3355','2014-02-09','13:00:00',1.6),('3355','2014-02-09','13:05:00',1.45),('3355','2014-02-09','13:10:00',1.42),('3355','2014-02-09','13:40:00',1.02),('3355','2014-02-09','13:45:00',1.89),('3355','2014-02-09','13:50:00',1.09),('3355','2014-02-09','13:55:00',1.62),('3355','2014-02-09','14:00:00',1.02),('3355','2014-02-09','14:05:00',1.55),('3355','2014-02-09','14:10:00',1.32),('3355','2014-02-09','14:30:00',1.55),('3355','2014-02-09','14:35:00',1.24),('3355','2014-02-09','14:50:00',1.11),('3355','2014-02-09','15:15:00',1.02),('3355','2014-02-09','15:20:00',1.13),('3355','2014-02-09','15:25:00',1.15),('3355','2014-02-08','10:20:00',1.01),('3355','2014-02-08','10:35:00',1.54),('3355','2014-02-08','10:40:00',1.01),('3355','2014-02-08','10:50:00',1.11),('3355','2014-02-08','10:55:00',1.74),('3355','2014-02-08','11:00:00',1.08),('3355','2014-02-08','11:05:00',1.9),('3355','2014-02-08','11:10:00',1.56),('3355','2014-02-08','11:20:00',1.03),('3355','2014-02-08','11:35:00',2.01),('3355','2014-02-08','11:40:00',1.62),('3355','2014-02-08','11:55:00',2.18),('3355','2014-02-08','12:00:00',1.49),('3355','2014-02-08','12:15:00',2.31),('3355','2014-02-08','12:30:00',2.28),('3355','2014-02-08','12:35:00',1.38),('3355','2014-02-08','12:40:00',1.48),('3355','2014-02-08','12:45:00',1.42),('3355','2014-02-08','12:50:00',2.06),('3355','2014-02-08','12:55:00',2.04),('3355','2014-02-08','13:00:00',1.06),('3355','2014-02-08','13:15:00',2.38),('3355','2014-02-08','13:20:00',2.38),('3355','2014-02-08','13:25:00',2.01),('3355','2014-02-08','13:30:00',2.01),('3355','2014-02-08','13:35:00',1.01),('3355','2014-02-08','13:40:00',1.73),('3355','2014-02-08','13:45:00',2.09),('3355','2014-02-08','13:50:00',1.88),('3355','2014-02-08','13:55:00',1.82),('3355','2014-02-08','14:00:00',1.89),('3355','2014-02-08','14:05:00',1.89),('3355','2014-02-08','14:10:00',1.31),('3355','2014-02-08','14:20:00',1.52),('3355','2014-02-08','14:25:00',1.03),('3355','2014-02-08','14:30:00',1.92),('3355','2014-02-08','14:35:00',1.12),('3355','2014-02-08','14:40:00',1.54),('3355','2014-02-08','14:55:00',1.58),('3355','2014-02-08','15:20:00',1.41),('3355','2014-02-08','15:45:00',1.19),('3355','2014-02-08','15:50:00',1.08),('3355','2014-02-07','09:20:00',1.04),('3355','2014-02-07','09:25:00',1.09),('3355','2014-02-07','09:30:00',1.13),('3355','2014-02-07','09:35:00',1.17),('3355','2014-02-07','09:40:00',1.22),('3355','2014-02-07','09:45:00',1.25),('3355','2014-02-07','09:50:00',1.29),('3355','2014-02-07','09:55:00',1.32),('3355','2014-02-07','10:00:00',1.35),('3355','2014-02-07','10:05:00',1.38),('3355','2014-02-07','10:10:00',1.41),('3355','2014-02-07','10:15:00',1.46),('3355','2014-02-07','10:20:00',1.5),('3355','2014-02-07','10:25:00',1.52),('3355','2014-02-07','10:30:00',1.58),('3355','2014-02-07','10:35:00',1.45),('3355','2014-02-07','10:40:00',1.65),('3355','2014-02-07','10:45:00',1.73),('3355','2014-02-07','10:50:00',1.37),('3355','2014-02-07','10:55:00',1.39),('3355','2014-02-07','11:00:00',1.59),('3355','2014-02-07','11:05:00',1.19),('3355','2014-02-07','11:10:00',1.21),('3355','2014-02-07','11:15:00',1.88),('3355','2014-02-07','11:20:00',1.97),('3355','2014-02-07','11:25:00',1.98),('3355','2014-02-07','11:30:00',1.91),('3355','2014-02-07','11:35:00',1.88),('3355','2014-02-07','11:40:00',1.93),('3355','2014-02-07','11:45:00',2.02),('3355','2014-02-07','11:50:00',2.06),('3355','2014-02-07','11:55:00',1.98),('3355','2014-02-07','12:00:00',2.2),('3355','2014-02-07','12:05:00',1.98),('3355','2014-02-07','12:10:00',2.11),('3355','2014-02-07','12:15:00',1.16),('3355','2014-02-07','12:25:00',2.29),('3355','2014-02-07','12:30:00',1.58),('3355','2014-02-07','12:50:00',1.05),('3355','2014-02-07','12:55:00',1.76),('3355','2014-02-07','13:00:00',1.41),('3355','2014-02-07','13:05:00',1.66),('3355','2014-02-07','13:10:00',2.37),('3355','2014-02-07','13:15:00',2.27),('3355','2014-02-07','13:25:00',1.12),('3355','2014-02-07','13:30:00',1.39),('3355','2014-02-07','13:35:00',1.3),('3355','2014-02-07','13:45:00',1.52),('3355','2014-02-07','13:50:00',1.71),('3355','2014-02-07','13:55:00',1.79),('3355','2014-02-07','14:00:00',1.66),('3355','2014-02-07','14:05:00',1.95),('3355','2014-02-07','14:10:00',1.63),('3355','2014-02-07','14:15:00',1.23),('3355','2014-02-07','14:40:00',1.21),('3355','2014-02-07','14:45:00',1.5),('3355','2014-02-07','14:50:00',1.5),('3355','2014-02-07','14:55:00',1.51),('3355','2014-02-07','15:00:00',1.46),('3355','2014-02-07','15:05:00',1.44),('3355','2014-02-07','15:10:00',1.41),('3355','2014-02-07','15:15:00',1.33),('3355','2014-02-07','15:25:00',1.26),('3355','2014-02-07','15:30:00',1.21),('3355','2014-02-07','15:35:00',1.16),('3355','2014-02-07','15:40:00',1.12),('3355','2014-02-07','15:45:00',1.03),('3355','2014-02-06','09:00:00',1.05),('3355','2014-02-06','09:05:00',1.16),('3355','2014-02-06','09:30:00',1.03),('3355','2014-02-06','09:35:00',1.21),('3355','2014-02-06','09:40:00',1.25),('3355','2014-02-06','09:45:00',1.28),('3355','2014-02-06','09:50:00',1.32),('3355','2014-02-06','09:55:00',1.35),('3355','2014-02-06','10:00:00',1.38),('3355','2014-02-06','10:05:00',1.42),('3355','2014-02-06','10:10:00',1.46),('3355','2014-02-06','10:15:00',1.49),('3355','2014-02-06','10:20:00',1.52),('3355','2014-02-06','10:25:00',1.55),('3355','2014-02-06','10:30:00',1.6),('3355','2014-02-06','10:35:00',1.7),('3355','2014-02-06','10:40:00',1.25),('3355','2014-02-06','10:45:00',1.52),('3355','2014-02-06','10:55:00',1.12),('3355','2014-02-06','11:00:00',1.43),('3355','2014-02-06','11:25:00',1.98),('3355','2014-02-06','11:30:00',1.88),('3355','2014-02-06','11:35:00',1.95),('3355','2014-02-06','11:40:00',1.94),('3355','2014-02-06','11:45:00',1.95),('3355','2014-02-06','11:50:00',1.97),('3355','2014-02-06','11:55:00',1.97),('3355','2014-02-06','12:00:00',2),('3355','2014-02-06','12:05:00',2.05),('3355','2014-02-06','12:10:00',2.05),('3355','2014-02-06','12:15:00',1.99),('3355','2014-02-06','12:20:00',2.01),('3355','2014-02-06','12:25:00',2.01),('3355','2014-02-06','12:30:00',2.02),('3355','2014-02-06','12:35:00',1.84),('3355','2014-02-06','12:40:00',1.98),('3355','2014-02-06','12:45:00',1.79),('3355','2014-02-06','12:50:00',1.99),('3355','2014-02-06','12:55:00',1.99),('3355','2014-02-06','13:00:00',1.99),('3355','2014-02-06','13:05:00',1.46),('3355','2014-02-06','13:10:00',2.06),('3355','2014-02-06','13:15:00',2.04),('3355','2014-02-06','13:20:00',2.07),('3355','2014-02-06','13:25:00',1.88),('3355','2014-02-06','13:30:00',1.45),('3355','2014-02-06','13:35:00',1.93),('3355','2014-02-06','13:40:00',1.93),('3355','2014-02-06','13:45:00',1.9),('3355','2014-02-06','13:50:00',1.92),('3355','2014-02-06','13:55:00',1.63),('3355','2014-02-06','14:00:00',1.85),('3355','2014-02-06','14:05:00',1.69),('3355','2014-02-06','14:10:00',1.78),('3355','2014-02-06','14:15:00',1.75),('3355','2014-02-06','14:20:00',1.72),('3355','2014-02-06','14:25:00',1.72),('3355','2014-02-06','14:30:00',1.18),('3355','2014-02-06','14:40:00',1.53),('3355','2014-02-06','14:45:00',1.18),('3355','2014-02-06','14:50:00',1.01),('3355','2014-02-06','14:55:00',1.56),('3355','2014-02-06','15:00:00',1.48),('3355','2014-02-06','15:05:00',1.42),('3355','2014-02-06','15:10:00',1.38),('3355','2014-02-06','15:15:00',1.37),('3355','2014-02-06','15:20:00',1.35),('3355','2014-02-06','15:25:00',1.24),('3355','2014-02-06','15:30:00',1.18),('3355','2014-02-06','15:35:00',1.14),('3355','2014-02-06','15:40:00',1.02),('3355','2014-02-06','15:45:00',1.01),('3355','2014-04-27','11:45:00',1.77),('3355','2014-04-27','11:50:00',1.45),('3355','2014-04-27','11:55:00',1.32),('3355','2014-04-27','12:00:00',1.38),('3355','2014-04-27','12:05:00',1.47),('3355','2014-04-27','12:10:00',1.77),('3355','2014-04-27','12:15:00',1.65),('3355','2014-04-27','12:20:00',1.41),('3355','2014-04-27','12:25:00',1.53),('3355','2014-04-27','12:30:00',1.41),('3355','2014-04-27','12:35:00',1.44),('3355','2014-04-27','12:40:00',1.29),('3355','2014-04-27','12:45:00',1.45),('3355','2014-04-27','12:50:00',1.17),('3355','2014-04-27','13:00:00',1.07),('3355','2014-04-27','13:05:00',1.12),('3355','2014-04-27','13:20:00',1.32),('3355','2014-04-27','13:25:00',1.25),('3355','2014-04-27','13:30:00',1.11),('3355','2014-04-27','14:05:00',1.34),('3355','2014-04-27','14:25:00',1.21),('3355','2014-04-27','14:30:00',1.29),('3355','2014-04-27','14:35:00',1.23),('3355','2014-04-27','14:40:00',1.24),('3355','2014-04-27','14:45:00',1.08),('3355','2014-04-27','14:50:00',1.02),('3355','2014-04-27','14:55:00',1.1),('3355','2014-04-27','15:00:00',1.17),('3355','2014-04-27','15:05:00',1.68),('3355','2014-04-27','15:10:00',2.37),('3355','2014-04-27','15:15:00',1.75),('3355','2014-04-27','15:20:00',1.05),('3355','2014-02-05','10:20:00',1.59),('3355','2014-02-05','10:25:00',1.65),('3355','2014-02-05','11:15:00',1.45),('3355','2014-02-05','11:20:00',1.74),('3355','2014-02-05','11:25:00',1.52),('3355','2014-02-05','13:25:00',1.01),('3355','2014-02-05','13:30:00',1.01),('3355','2014-02-05','13:35:00',1.19),('3355','2014-02-05','13:40:00',1.14),('3355','2014-02-05','13:45:00',1.19),('3355','2014-02-05','14:35:00',1.07),('3355','2014-02-04','09:25:00',1.37),('3355','2014-02-04','09:30:00',1.31),('3355','2014-02-04','09:35:00',1.48),('3355','2014-02-04','09:40:00',1.33),('3355','2014-02-04','09:45:00',1.27),('3355','2014-02-04','09:50:00',1.06),('3355','2014-02-04','09:55:00',1.29),('3355','2014-02-04','10:00:00',1.46),('3355','2014-02-04','10:05:00',1.2),('3355','2014-02-04','10:15:00',1.18),('3355','2014-02-04','10:50:00',1.36),('3355','2014-02-04','10:55:00',1.57),('3355','2014-02-04','11:55:00',2.01),('3355','2014-02-04','12:00:00',2.22),('3355','2014-02-01','11:20:00',1.06),('3355','2014-02-01','11:30:00',1.28),('3355','2014-02-01','11:35:00',1.16),('3355','2014-02-01','11:55:00',1.1),('3355','2014-02-01','12:10:00',1.21),('3355','2014-02-01','12:20:00',1.34),('3355','2014-02-01','12:40:00',1.1),('3355','2014-02-01','12:45:00',1.39),('3355','2014-02-01','12:50:00',1.18),('3355','2014-01-30','09:55:00',1.19),('3355','2014-01-30','10:00:00',1.13),('3355','2014-01-30','10:10:00',1.08),('3355','2014-01-30','10:15:00',1.33),('3355','2014-01-30','10:20:00',1.16),('3355','2014-01-30','10:25:00',1.33),('3355','2014-01-30','10:30:00',1.44),('3355','2014-01-30','10:35:00',1.45),('3355','2014-01-30','10:40:00',1.44),('3355','2014-01-30','10:45:00',1.31),('3355','2014-01-30','10:50:00',1.61),('3355','2014-01-30','10:55:00',1.9),('3355','2014-01-30','11:00:00',1.83),('3355','2014-01-30','11:05:00',1.74),('3355','2014-01-30','11:10:00',1.73),('3355','2014-01-30','11:15:00',1.67),('3355','2014-01-30','11:20:00',1.56),('3355','2014-01-30','11:25:00',1.68),('3355','2014-01-30','11:30:00',1.42),('3355','2014-01-30','11:35:00',1.34),('3355','2014-01-30','11:45:00',1.55),('3355','2014-01-30','11:55:00',1.94),('3355','2014-01-30','12:05:00',1.54),('3355','2014-01-30','12:20:00',1.66),('3355','2014-01-30','12:25:00',1.55),('3355','2014-01-30','12:30:00',1.18),('3355','2014-01-30','12:35:00',1.43),('3355','2014-01-30','12:40:00',1.27),('3355','2014-01-30','12:45:00',1.77),('3355','2014-01-30','12:50:00',1.43),('3355','2014-01-30','12:55:00',1.57),('3355','2014-01-30','13:05:00',1.54),('3355','2014-01-30','13:10:00',1.09),('3355','2014-01-30','13:15:00',1.57),('3355','2014-01-30','13:20:00',1.23),('3355','2014-01-30','13:25:00',1.81),('3355','2014-01-30','13:30:00',1.52),('3355','2014-01-30','13:35:00',1.34),('3355','2014-01-30','13:40:00',1.55),('3355','2014-01-30','13:45:00',1.78),('3355','2014-01-30','13:50:00',1.66),('3355','2014-01-30','13:55:00',1.54),('3355','2014-01-30','14:00:00',1.51),('3355','2014-01-30','14:05:00',1.45),('3355','2014-01-30','14:10:00',1.42),('3355','2014-01-30','14:15:00',1.22),('3355','2014-01-30','14:20:00',1.08),('3355','2014-01-30','14:25:00',1.16),('3355','2014-01-30','14:30:00',1.25),('3355','2014-01-30','14:35:00',1.21),('3355','2014-01-30','14:40:00',1.37),('3355','2014-01-30','14:45:00',1.31),('3355','2014-01-30','14:50:00',1.37),('3355','2014-01-30','14:55:00',1.32),('3355','2014-01-30','15:00:00',1.3),('3355','2014-01-30','15:05:00',1.27),('3355','2014-01-30','15:10:00',1.21),('3355','2014-01-30','15:15:00',1.1),('3355','2014-01-30','15:20:00',1.15),('3355','2014-01-30','15:25:00',1.09),('3355','2014-01-29','09:35:00',1.03),('3355','2014-01-29','09:45:00',1.09),('3355','2014-01-29','10:25:00',1.45),('3355','2014-01-29','10:30:00',1.55),('3355','2014-01-29','10:35:00',1.23),('3355','2014-01-29','10:40:00',1.13),('3355','2014-01-29','10:45:00',1.1),('3355','2014-01-29','10:50:00',1.03),('3355','2014-01-29','11:05:00',1.14),('3355','2014-01-29','11:10:00',1.03),('3355','2014-01-29','11:15:00',1.04),('3355','2014-01-29','11:20:00',1.09),('3355','2014-01-29','11:25:00',1.02),('3355','2014-01-29','11:30:00',1.49),('3355','2014-01-29','11:35:00',1.5),('3355','2014-01-29','11:40:00',1.41),('3355','2014-01-29','12:50:00',1.54),('3355','2014-01-29','12:55:00',1.98),('3355','2014-01-29','13:00:00',1.73),('3355','2014-01-29','13:40:00',1.3),('3355','2014-01-29','13:50:00',1.17),('3355','2014-01-29','13:55:00',1.39),('3355','2014-01-28','09:50:00',1.09),('3355','2014-01-28','09:55:00',1.16),('3355','2014-01-28','10:00:00',1.28),('3355','2014-01-28','10:05:00',1.27),('3355','2014-01-28','10:10:00',1.27),('3355','2014-01-28','10:15:00',1.28),('3355','2014-01-28','10:20:00',1.33),('3355','2014-01-28','10:25:00',1.44),('3355','2014-01-28','10:30:00',1.45),('3355','2014-01-28','10:35:00',1.51),('3355','2014-01-28','10:40:00',1.54),('3355','2014-01-28','10:45:00',1.33),('3355','2014-01-28','10:50:00',1.56),('3355','2014-01-28','10:55:00',1.52),('3355','2014-01-28','11:00:00',1.46),('3355','2014-01-28','11:05:00',1.73),('3355','2014-01-28','11:15:00',1.19),('3355','2014-01-28','11:30:00',1.25),('3355','2014-01-28','11:35:00',1.26),('3355','2014-01-28','11:40:00',1.87),('3355','2014-01-28','11:45:00',1.53),('3355','2014-01-28','12:05:00',1.89),('3355','2014-01-28','12:10:00',1.33),('3355','2014-01-28','12:15:00',1.69),('3355','2014-01-28','12:20:00',1.2),('3355','2014-01-28','12:40:00',1.06),('3355','2014-01-28','12:50:00',1.83),('3355','2014-01-28','12:55:00',1.71),('3355','2014-01-28','13:00:00',1.79),('3355','2014-01-28','13:05:00',2.2),('3355','2014-01-28','13:10:00',1.49),('3355','2014-01-28','13:15:00',1.54),('3355','2014-01-28','13:20:00',1.6),('3355','2014-01-28','13:25:00',1.75),('3355','2014-01-28','13:30:00',1.77),('3355','2014-01-28','13:35:00',1.96),('3355','2014-01-28','13:40:00',1.89),('3355','2014-01-28','13:45:00',1.84),('3355','2014-01-28','13:50:00',1.8),('3355','2014-01-28','13:55:00',1.77),('3355','2014-01-28','14:00:00',1.76),('3355','2014-01-28','14:05:00',1.71),('3355','2014-01-28','14:10:00',1.68),('3355','2014-01-28','14:15:00',1.66),('3355','2014-01-28','14:20:00',1.62),('3355','2014-01-28','14:25:00',1.65),('3355','2014-01-28','14:30:00',1.55),('3355','2014-01-28','14:35:00',1.45),('3355','2014-01-28','14:40:00',1.37),('3355','2014-01-28','14:45:00',1.49),('3355','2014-01-28','14:50:00',1.15),('3355','2014-01-28','14:55:00',1.39),('3355','2014-01-28','15:00:00',1.35),('3355','2014-01-28','15:05:00',1.31),('3355','2014-01-28','15:10:00',1.26),('3355','2014-01-28','15:15:00',1.17),('3355','2014-01-28','15:20:00',1.11),('3355','2014-01-28','15:25:00',1.01),('5815','2014-05-04','08:35:00',1.04),('5815','2014-05-04','08:40:00',1.1),('5815','2014-05-04','08:45:00',1.15),('5815','2014-05-04','08:50:00',1.2),('5815','2014-05-04','08:55:00',1.26),('5815','2014-05-04','09:00:00',1.3),('5815','2014-05-04','09:05:00',1.34),('5815','2014-05-04','09:10:00',1.38),('5815','2014-05-04','09:15:00',1.44),('5815','2014-05-04','09:20:00',1.47),('5815','2014-05-04','09:25:00',1.55),('5815','2014-05-04','09:30:00',1.6),('5815','2014-05-04','09:35:00',1.65),('5815','2014-05-04','09:40:00',1.69),('5815','2014-05-04','09:45:00',1.73),('5815','2014-05-04','09:50:00',1.78),('5815','2014-05-04','09:55:00',1.83),('5815','2014-05-04','10:00:00',1.87),('5815','2014-05-04','10:05:00',1.91),('5815','2014-05-04','10:10:00',1.95),('5815','2014-05-04','10:15:00',1.97),('5815','2014-05-04','10:20:00',1.98),('5815','2014-05-04','10:25:00',2.02),('5815','2014-05-04','10:30:00',2.06),('5815','2014-05-04','10:35:00',2.12),('5815','2014-05-04','10:40:00',2.13),('5815','2014-05-04','10:45:00',2.15),('5815','2014-05-04','10:50:00',2.18),('5815','2014-05-04','10:55:00',2.18),('5815','2014-05-04','11:00:00',2.15),('5815','2014-05-04','11:05:00',2.19),('5815','2014-05-04','11:10:00',2.23),('5815','2014-05-04','11:15:00',2.24),('5815','2014-05-04','11:20:00',2.25),('5815','2014-05-04','11:25:00',2.25),('5815','2014-05-04','11:30:00',2.28),('5815','2014-05-04','11:35:00',2.3),('5815','2014-05-04','11:40:00',2.35),('5815','2014-05-04','11:45:00',2.34),('5815','2014-05-04','11:50:00',2.39),('5815','2014-05-04','11:55:00',2.51),('5815','2014-05-04','12:00:00',1.81),('5815','2014-05-04','12:05:00',1.34),('5815','2014-05-04','12:10:00',1.73),('5815','2014-05-04','12:15:00',1.48),('5815','2014-05-04','12:20:00',1.36),('5815','2014-05-04','12:25:00',2.15),('5815','2014-05-04','12:30:00',2.32),('5815','2014-05-04','12:35:00',1.08),('5815','2014-05-04','12:40:00',1.07),('5815','2014-05-04','12:45:00',2.89),('5815','2014-05-04','12:50:00',1.98),('5815','2014-05-04','12:55:00',1.55),('5815','2014-05-04','13:00:00',1.53),('5815','2014-05-04','13:05:00',2.64),('5815','2014-05-04','13:10:00',2.68),('5815','2014-05-04','13:15:00',2.63),('5815','2014-05-04','13:20:00',2.55),('5815','2014-05-04','13:25:00',2.54),('5815','2014-05-04','13:30:00',2.54),('5815','2014-05-04','13:35:00',2.53),('5815','2014-05-04','13:40:00',2.52),('5815','2014-05-04','13:45:00',2.52),('5815','2014-05-04','13:50:00',2.52),('5815','2014-05-04','13:55:00',2.53),('5815','2014-05-04','14:00:00',2.53),('5815','2014-05-04','14:05:00',2.61),('5815','2014-05-04','14:10:00',2.64),('5815','2014-05-04','14:15:00',2.63),('5815','2014-05-04','14:20:00',2.82),('5815','2014-05-04','14:25:00',2.45),('5815','2014-05-04','14:30:00',1.31),('5815','2014-05-04','15:25:00',1.8),('5815','2014-05-04','15:30:00',2.48),('5815','2014-05-04','15:35:00',1.55),('5815','2014-05-04','15:40:00',1.99),('5815','2014-05-04','16:05:00',1.37),('5815','2014-05-04','16:40:00',1.15),('5815','2014-05-04','16:45:00',1.05),('5815','2014-05-04','16:55:00',1.29),('5815','2014-05-04','17:00:00',1.54),('5815','2014-05-04','17:05:00',1.41),('5815','2014-05-04','17:10:00',1.4),('5815','2014-05-04','17:15:00',1.37),('5815','2014-05-04','17:20:00',1.31),('5815','2014-05-04','17:25:00',1.23),('5815','2014-05-04','17:30:00',1.14),('5815','2014-05-04','17:35:00',1.09),('5815','2014-05-04','17:40:00',1.03),('5815','2014-04-25','10:30:00',1.2),('5815','2014-04-25','10:35:00',1.11),('5815','2014-04-25','10:40:00',1.04),('5815','2014-04-25','10:45:00',1.12),('5815','2014-04-25','10:50:00',1.35),('5815','2014-04-25','10:55:00',1.87),('5815','2014-04-25','11:00:00',2.08),('5815','2014-04-25','11:05:00',1.86),('5815','2014-04-25','11:10:00',1.96),('5815','2014-04-25','11:15:00',1.86),('5815','2014-04-25','11:20:00',1.81),('5815','2014-04-25','11:25:00',1.8),('5815','2014-04-25','11:30:00',1.81),('5815','2014-04-25','11:35:00',1.77),('5815','2014-04-25','11:40:00',1.73),('5815','2014-04-25','11:45:00',1.88),('5815','2014-04-25','11:50:00',1.88),('5815','2014-04-25','11:55:00',1.58),('5815','2014-04-25','12:00:00',1.86),('5815','2014-04-25','12:05:00',1.86),('5815','2014-04-25','12:10:00',1.88),('5815','2014-04-25','12:15:00',1.69),('5815','2014-04-25','12:20:00',1.62),('5815','2014-04-25','12:25:00',1.1),('5815','2014-04-25','12:30:00',1.44),('5815','2014-04-25','12:35:00',1.98),('5815','2014-04-25','12:40:00',1.83),('5815','2014-04-25','12:45:00',2),('5815','2014-04-25','12:50:00',2.44),('5815','2014-04-25','12:55:00',2.54),('5815','2014-04-25','13:00:00',2.37),('5815','2014-04-25','13:05:00',1.99),('5815','2014-04-25','13:10:00',1.8),('5815','2014-04-25','13:15:00',2.58),('5815','2014-04-25','13:20:00',2.1),('5815','2014-04-25','13:25:00',1.33),('5815','2014-04-25','13:35:00',1.87),('5815','2014-04-25','13:40:00',2.61),('5815','2014-04-25','13:45:00',2.48),('5815','2014-04-25','13:50:00',2.45),('5815','2014-04-25','13:55:00',2.63),('5815','2014-04-25','14:00:00',1.76),('5815','2014-04-25','14:10:00',2.29),('5815','2014-04-25','14:35:00',1.38),('5815','2014-04-25','14:40:00',1.31),('5815','2014-04-24','08:50:00',1.05),('5815','2014-04-24','08:55:00',1.11),('5815','2014-04-24','09:00:00',1.23),('5815','2014-04-24','09:05:00',1.17),('5815','2014-04-24','09:10:00',1.38),('5815','2014-04-24','09:15:00',1.35),('5815','2014-04-24','10:35:00',1.39),('5815','2014-04-24','10:40:00',2.23),('5815','2014-04-24','10:45:00',2.28),('5815','2014-04-24','10:50:00',2.06),('5815','2014-04-24','10:55:00',1.44),('5815','2014-04-24','11:00:00',2.11),('5815','2014-04-24','11:05:00',1.43),('5815','2014-04-24','11:15:00',1.03),('5815','2014-04-24','11:20:00',2.41),('5815','2014-04-24','11:25:00',2.08),('5815','2014-04-24','11:35:00',2.44),('5815','2014-04-24','11:40:00',1.51),('5815','2014-04-24','11:45:00',1.23),('5815','2014-04-24','12:00:00',1.05),('5815','2014-04-24','12:15:00',1.62),('5815','2014-04-24','12:20:00',2.59),('5815','2014-04-24','12:25:00',1.81),('5815','2014-04-24','12:30:00',1.42),('5815','2014-04-24','12:35:00',2.24),('5815','2014-04-24','12:40:00',2.41),('5815','2014-04-24','12:45:00',2.36),('5815','2014-04-24','12:50:00',1.63),('5815','2014-04-24','12:55:00',1.37),('5815','2014-04-24','13:05:00',1.7),('5815','2014-04-24','13:15:00',1.49),('5815','2014-04-24','13:20:00',1.29),('5815','2014-04-24','13:25:00',1.26),('5815','2014-04-24','13:30:00',1.27),('5815','2014-04-24','13:40:00',1.74),('5815','2014-04-24','13:45:00',1.29),('5815','2014-04-24','14:20:00',1.77),('5815','2014-04-24','14:25:00',1.76),('5815','2014-04-24','14:30:00',2.2),('5815','2014-04-24','14:35:00',2.43),('5815','2014-04-24','14:40:00',2.42),('5815','2014-04-24','14:45:00',2.41),('5815','2014-04-24','14:50:00',2.4),('5815','2014-04-24','14:55:00',2.32),('5815','2014-04-24','15:00:00',2.31),('5815','2014-04-24','15:05:00',2.27),('5815','2014-04-24','15:10:00',2.23),('5815','2014-04-24','15:15:00',2.22),('5815','2014-04-24','15:20:00',2.13),('5815','2014-04-24','15:25:00',2.12),('5815','2014-04-24','15:30:00',2.06),('5815','2014-04-24','15:35:00',2.06),('5815','2014-04-24','15:40:00',2.07),('5815','2014-04-24','15:45:00',2),('5815','2014-04-24','15:50:00',1.97),('5815','2014-04-24','15:55:00',1.96),('5815','2014-04-24','16:00:00',1.95),('5815','2014-04-24','16:05:00',1.85),('5815','2014-04-24','16:10:00',1.82),('5815','2014-04-24','16:15:00',1.74),('5815','2014-04-24','16:20:00',1.61),('5815','2014-04-24','16:25:00',1.6),('5815','2014-04-24','16:30:00',1.68),('5815','2014-04-24','16:35:00',1.66),('5815','2014-04-24','16:40:00',1.67),('5815','2014-04-24','16:45:00',1.61),('5815','2014-04-24','16:50:00',1.5),('5815','2014-04-24','16:55:00',1.3),('5815','2014-04-24','17:00:00',1.14),('5815','2014-04-24','17:05:00',1.31),('5815','2014-04-24','17:10:00',1.19),('5815','2014-04-24','17:15:00',1.12),('5815','2014-01-11','11:10:00',1.14),('5815','2014-01-11','11:15:00',1.01),('5815','2014-01-11','11:20:00',1.01),('5815','2014-01-11','11:30:00',1),('5815','2014-01-11','11:45:00',1.2),('5815','2014-01-11','11:50:00',1.22),('5815','2014-01-11','11:55:00',1.2),('5815','2014-01-10','10:00:00',1.15),('5815','2014-01-10','10:25:00',1.22),('5815','2014-01-10','10:30:00',1.17),('5815','2014-01-10','10:35:00',1.22),('5815','2014-01-10','10:40:00',1.51),('5815','2014-01-10','10:45:00',1.61),('5815','2014-01-10','10:50:00',1.64),('5815','2014-01-10','10:55:00',1.62),('5815','2014-01-10','11:00:00',1.58),('5815','2014-01-10','11:05:00',1.53),('5815','2014-01-10','11:10:00',1.63),('5815','2014-01-10','11:15:00',1.52),('5815','2014-01-10','11:20:00',1.37),('5815','2014-01-10','11:25:00',1.36),('5815','2014-01-10','11:30:00',1.38),('5815','2014-01-10','11:35:00',1.26),('5815','2014-01-10','11:40:00',1.14),('5815','2014-01-10','11:45:00',1.17),('5815','2014-01-10','11:50:00',1.26),('5815','2014-01-10','11:55:00',1.25),('5815','2014-01-10','12:00:00',1.26),('5815','2014-01-10','12:05:00',1.4),('5815','2014-01-10','12:10:00',1.32),('5815','2014-01-10','12:15:00',1.36),('5815','2014-01-10','12:20:00',1.29),('5815','2014-01-10','12:25:00',1.19),('5815','2014-01-10','12:30:00',1.06),('5815','2014-01-10','12:50:00',1.18),('5815','2014-01-10','12:55:00',1.42),('5815','2014-01-10','13:00:00',1.41),('5815','2014-01-10','13:05:00',1.28),('5815','2014-01-10','13:10:00',1.29),('5815','2014-01-10','13:15:00',1.49),('5815','2014-01-10','13:20:00',1.28),('5815','2014-01-10','13:25:00',1.01),('5815','2014-01-08','09:35:00',1.05),('5815','2014-01-08','09:40:00',1),('5815','2014-01-08','09:45:00',1.12),('5815','2014-01-08','09:50:00',1.24),('5815','2014-01-08','09:55:00',1.24),('5815','2014-01-08','10:00:00',1.26),('5815','2014-01-08','10:05:00',1.26),('5815','2014-01-08','10:10:00',1.02),('5815','2014-01-08','10:15:00',1.11),('5815','2014-01-08','10:20:00',1.14),('5815','2014-01-08','10:25:00',1.18),('5815','2014-01-08','10:30:00',1.24),('5815','2014-01-08','10:35:00',1.23),('5815','2014-01-08','10:40:00',1.25),('5815','2014-01-08','10:45:00',1.27),('5815','2014-01-08','10:50:00',1.35),('5815','2014-01-07','09:30:00',1.01),('5815','2014-01-07','09:35:00',1.04),('5815','2014-01-07','09:40:00',1.14),('5815','2014-01-07','09:45:00',1.18),('5815','2014-01-07','09:50:00',1.19),('5815','2014-01-07','09:55:00',1.24),('5815','2014-01-07','10:00:00',1.27),('5815','2014-01-07','10:05:00',1.26),('5815','2014-01-07','10:10:00',1.26),('5815','2014-01-07','10:15:00',1.31),('5815','2014-01-07','10:20:00',1.41),('5815','2014-01-07','10:25:00',1.47),('5815','2014-01-07','10:30:00',1.47),('5815','2014-01-07','10:35:00',1.39),('5815','2014-01-07','10:40:00',1.39),('5815','2014-01-07','10:45:00',1.53),('5815','2014-01-07','10:50:00',1.6),('5815','2014-01-07','10:55:00',1.63),('5815','2014-01-07','11:00:00',1.64),('5815','2014-01-07','11:05:00',1.65),('5815','2014-01-07','11:10:00',1.68),('5815','2014-01-07','11:15:00',1.7),('5815','2014-01-07','11:20:00',1.7),('5815','2014-01-07','11:25:00',1.71),('5815','2014-01-07','11:30:00',1.72),('5815','2014-01-07','11:35:00',1.77),('5815','2014-01-07','11:40:00',1.79),('5815','2014-01-07','11:45:00',1.75),('5815','2014-01-07','11:50:00',1.76),('5815','2014-01-07','11:55:00',1.74),('5815','2014-01-07','12:00:00',1.74),('5815','2014-01-07','12:05:00',1.75),('5815','2014-01-07','12:10:00',1.73),('5815','2014-01-07','12:15:00',1.76),('5815','2014-01-07','12:20:00',1.76),('5815','2014-01-07','12:25:00',1.74),('5815','2014-01-07','12:30:00',1.75),('5815','2014-01-07','12:35:00',1.73),('5815','2014-01-07','12:40:00',1.69),('5815','2014-01-07','12:45:00',1.62),('5815','2014-01-07','12:50:00',1.6),('5815','2014-01-07','12:55:00',1.61),('5815','2014-01-07','13:00:00',1.65),('5815','2014-01-07','13:05:00',1.66),('5815','2014-01-07','13:10:00',1.62),('5815','2014-01-07','13:15:00',1.61),('5815','2014-01-07','13:20:00',1.59),('5815','2014-01-07','13:25:00',1.59),('5815','2014-01-07','13:30:00',1.53),('5815','2014-01-07','13:35:00',1.52),('5815','2014-01-07','13:40:00',1.49),('5815','2014-01-07','13:45:00',1.49),('5815','2014-01-07','13:50:00',1.42),('5815','2014-01-07','13:55:00',1.41),('5815','2014-01-07','14:00:00',1.39),('5815','2014-01-07','14:05:00',1.4),('5815','2014-01-07','14:10:00',1.37),('5815','2014-01-07','14:15:00',1.36),('5815','2014-01-07','14:20:00',1.35),('5815','2014-01-07','14:25:00',1.34),('5815','2014-01-07','14:30:00',1.33),('5815','2014-01-07','14:35:00',1.32),('5815','2014-01-07','14:40:00',1.2),('5815','2014-01-07','14:45:00',1.17),('5815','2014-01-07','14:50:00',1.15),('5815','2014-04-23','08:45:00',1.02),('5815','2014-04-23','08:50:00',1.06),('5815','2014-04-23','08:55:00',1.12),('5815','2014-04-23','09:00:00',1.17),('5815','2014-04-23','09:05:00',1.22),('5815','2014-04-23','09:10:00',1.26),('5815','2014-04-23','09:15:00',1.31),('5815','2014-04-23','09:20:00',1.35),('5815','2014-04-23','09:25:00',1.4),('5815','2014-04-23','09:30:00',1.45),('5815','2014-04-23','09:35:00',1.5),('5815','2014-04-23','09:40:00',1.54),('5815','2014-04-23','09:45:00',1.59),('5815','2014-04-23','09:50:00',1.63),('5815','2014-04-23','09:55:00',1.66),('5815','2014-04-23','10:00:00',1.69),('5815','2014-04-23','10:05:00',1.74),('5815','2014-04-23','10:10:00',1.77),('5815','2014-04-23','10:15:00',1.82),('5815','2014-04-23','10:20:00',1.84),('5815','2014-04-23','10:25:00',1.86),('5815','2014-04-23','10:30:00',1.9),('5815','2014-04-23','10:35:00',1.92),('5815','2014-04-23','10:40:00',1.96),('5815','2014-04-23','10:45:00',1.99),('5815','2014-04-23','10:50:00',2.01),('5815','2014-04-23','10:55:00',2.04),('5815','2014-04-23','11:00:00',2.09),('5815','2014-04-23','11:05:00',2.14),('5815','2014-04-23','11:10:00',2.14),('5815','2014-04-23','11:15:00',2.16),('5815','2014-04-23','11:20:00',2.16),('5815','2014-04-23','11:25:00',2.17),('5815','2014-04-23','11:30:00',2.19),('5815','2014-04-23','11:35:00',2.2),('5815','2014-04-23','11:40:00',2.23),('5815','2014-04-23','11:45:00',2.22),('5815','2014-04-23','11:50:00',2.25),('5815','2014-04-23','11:55:00',2.28),('5815','2014-04-23','12:00:00',2.28),('5815','2014-04-23','12:05:00',2.32),('5815','2014-04-23','12:10:00',2.36),('5815','2014-04-23','12:15:00',2.44),('5815','2014-04-23','12:20:00',2.42),('5815','2014-04-23','12:25:00',2.36),('5815','2014-04-23','12:30:00',2.44),('5815','2014-04-23','12:35:00',2.43),('5815','2014-04-23','12:40:00',2.43),('5815','2014-04-23','12:45:00',2.45),('5815','2014-04-23','12:50:00',2.47),('5815','2014-04-23','12:55:00',2.38),('5815','2014-04-23','13:00:00',2.34),('5815','2014-04-23','13:05:00',2.4),('5815','2014-04-23','13:10:00',2.5),('5815','2014-04-23','13:15:00',2.52),('5815','2014-04-23','13:20:00',2.54),('5815','2014-04-23','13:25:00',2.49),('5815','2014-04-23','13:30:00',2.51),('5815','2014-04-23','13:35:00',2.49),('5815','2014-04-23','13:45:00',2.5),('5815','2014-04-23','13:55:00',1.3),('5815','2014-04-23','14:00:00',2.04),('5815','2014-04-23','14:05:00',1.04),('5815','2014-04-23','14:10:00',2.32),('5815','2014-04-23','14:15:00',1.5),('5815','2014-04-23','14:20:00',1.93),('5815','2014-04-23','14:25:00',1.85),('5815','2014-04-23','14:30:00',2.65),('5815','2014-04-23','14:35:00',2.59),('5815','2014-04-23','14:40:00',1.76),('5815','2014-04-23','14:45:00',2.14),('5815','2014-04-23','14:55:00',2.05),('5815','2014-04-23','15:00:00',2.77),('5815','2014-04-23','15:05:00',2.7),('5815','2014-04-23','15:10:00',2.32),('5815','2014-04-23','15:15:00',2.33),('5815','2014-04-23','15:20:00',1.42),('5815','2014-04-23','15:25:00',1.28),('5815','2014-04-23','15:30:00',1.45),('5815','2014-04-23','15:35:00',1.59),('5815','2014-04-23','15:40:00',1.26),('5815','2014-04-23','15:45:00',1.16),('5815','2014-04-23','15:50:00',1.51),('5815','2014-04-23','15:55:00',1.44),('5815','2014-04-23','16:00:00',2.22),('5815','2014-04-23','16:05:00',2.19),('5815','2014-04-23','16:10:00',1.67),('5815','2014-04-23','16:15:00',1.79),('5815','2014-04-23','16:20:00',1.77),('5815','2014-04-23','16:25:00',1.48),('5815','2014-04-23','16:30:00',1.9),('5815','2014-04-23','16:35:00',1.08),('5815','2014-04-23','16:40:00',1.14),('5815','2014-04-23','16:45:00',1.23),('5815','2014-04-23','16:55:00',1.02),('5815','2014-01-05','11:40:00',2.04),('5815','2014-01-05','11:45:00',1.87),('5815','2014-01-05','11:50:00',1.85),('5815','2014-01-05','11:55:00',1.79),('5815','2014-01-05','12:00:00',1.84),('5815','2014-01-05','12:05:00',1.89),('5815','2014-01-05','12:10:00',1.83),('5815','2014-01-05','12:15:00',1.81),('5815','2014-01-05','12:20:00',1.79),('5815','2014-01-05','12:25:00',1.81),('5815','2014-01-05','12:30:00',1.8),('5815','2014-01-05','12:35:00',1.79),('5815','2014-01-05','12:40:00',1.8),('5815','2014-01-05','12:45:00',1.79),('5815','2014-01-05','12:50:00',1.81),('5815','2014-01-05','12:55:00',1.78),('5815','2014-01-05','13:00:00',1.77),('5815','2014-01-05','13:05:00',1.74),('5815','2014-01-05','13:10:00',1.75),('5815','2014-01-05','13:15:00',1.8),('5815','2014-01-05','13:20:00',1.77),('5815','2014-01-05','13:25:00',1.76),('5815','2014-01-05','13:30:00',1.66),('5815','2014-01-05','13:35:00',1.64),('5815','2014-01-05','13:40:00',1.61),('5815','2014-01-05','13:45:00',1.59),('5815','2014-01-05','13:50:00',1.58),('5815','2014-01-05','13:55:00',1.54),('5815','2014-01-05','14:00:00',1.27),('5815','2014-01-05','14:20:00',1.59),('5815','2014-01-05','14:40:00',1.36),('5815','2014-01-05','14:45:00',1.49),('5815','2014-01-05','14:50:00',1.22),('5815','2014-01-05','15:05:00',1.08),('5815','2014-01-05','15:10:00',1.04),('5815','2014-01-02','09:30:00',1),('5815','2014-01-02','09:35:00',1.18),('5815','2014-01-02','09:40:00',1.35),('5815','2014-01-02','09:45:00',1.35),('5815','2014-01-02','10:00:00',1.02),('5815','2014-01-02','10:05:00',1.21),('5815','2014-01-02','10:20:00',1.42),('5815','2014-01-02','12:05:00',1.01),('5815','2014-01-02','12:10:00',1.07),('5815','2014-01-02','12:45:00',1.15),('5815','2014-01-02','12:55:00',1.36),('5815','2014-01-02','13:10:00',1.04),('5815','2014-01-02','13:35:00',1.04),('5815','2014-01-01','09:20:00',1.02),('5815','2014-01-01','09:25:00',1.06),('5815','2014-01-01','09:30:00',1.08),('5815','2014-01-01','09:35:00',1.13),('5815','2014-01-01','09:40:00',1.16),('5815','2014-01-01','09:45:00',1.2),('5815','2014-01-01','09:50:00',1.23),('5815','2014-01-01','09:55:00',1.26),('5815','2014-01-01','10:00:00',1.32),('5815','2014-01-01','10:05:00',1.39),('5815','2014-01-01','10:10:00',1.4),('5815','2014-01-01','10:15:00',1.39),('5815','2014-01-01','10:20:00',1.4),('5815','2014-01-01','10:25:00',1.47),('5815','2014-01-01','10:30:00',1.5),('5815','2014-01-01','10:35:00',1.53),('5815','2014-01-01','10:40:00',1.52),('5815','2014-01-01','10:45:00',1.55),('5815','2014-01-01','10:50:00',1.59),('5815','2014-01-01','10:55:00',1.66),('5815','2014-01-01','11:00:00',1.65),('5815','2014-01-01','11:05:00',1.66),('5815','2014-01-01','11:10:00',1.31),('5815','2014-01-01','11:40:00',1.01),('5815','2014-01-01','12:55:00',1.41),('5815','2014-01-01','13:00:00',1.12),('5815','2014-01-01','13:40:00',1.33),('5815','2013-12-31','09:10:00',1.14),('5815','2013-12-31','09:30:00',1.28),('5815','2013-12-31','09:40:00',1.01),('5815','2013-12-31','09:45:00',1.14),('5815','2013-12-31','09:50:00',1.45),('5815','2013-12-31','13:35:00',1.14),('5815','2013-12-31','13:40:00',2.04),('5815','2013-12-31','14:00:00',1.34),('5815','2013-12-31','15:10:00',1.14),('5815','2013-12-31','15:15:00',1.06),('5815','2013-12-30','09:20:00',1.1),('5815','2013-12-30','09:25:00',1.15),('5815','2013-12-30','09:30:00',1.25),('5815','2013-12-30','09:35:00',1.3),('5815','2013-12-30','09:40:00',1.3),('5815','2013-12-30','09:45:00',1.35),('5815','2013-12-30','09:50:00',1.22),('5815','2013-12-30','11:10:00',1.32),('5815','2013-12-30','11:15:00',1.51),('5815','2013-12-30','11:20:00',1.28),('5815','2013-12-30','11:25:00',1.46),('5815','2013-12-30','11:30:00',1.49),('5815','2013-12-30','11:40:00',1.68),('5815','2013-12-30','11:50:00',1.17),('5815','2013-12-30','11:55:00',1.93),('5815','2013-12-30','12:00:00',1.98),('5815','2013-12-30','12:05:00',1.94),('5815','2013-12-30','12:10:00',1.93),('5815','2013-12-30','12:15:00',1.92),('5815','2013-12-30','12:20:00',1.91),('5815','2013-12-30','12:25:00',1.89),('5815','2013-12-30','12:30:00',1.88),('5815','2013-12-30','12:35:00',1.82),('5815','2013-12-30','12:40:00',1.84),('5815','2013-12-30','12:45:00',1.84),('5815','2013-12-30','12:50:00',1.82),('5815','2013-12-30','12:55:00',1.81),('5815','2013-12-30','13:00:00',1.81),('5815','2013-12-30','13:05:00',1.8),('5815','2013-12-30','13:10:00',1.78),('5815','2013-12-30','13:15:00',1.76),('5815','2013-12-30','13:20:00',1.75),('5815','2013-12-30','13:25:00',1.74),('5815','2013-12-30','13:30:00',1.72),('5815','2013-12-30','13:35:00',1.69),('5815','2013-12-30','13:40:00',1.66),('5815','2013-12-30','13:45:00',1.64),('5815','2013-12-30','13:50:00',1.6),('5815','2013-12-30','13:55:00',1.57),('5815','2013-12-30','14:00:00',1.55),('5815','2013-12-30','14:05:00',1.52),('5815','2013-12-30','14:10:00',1.49),('5815','2013-12-30','14:15:00',1.46),('5815','2013-12-30','14:20:00',1.43),('5815','2013-12-30','14:25:00',1.4),('5815','2013-12-30','14:30:00',1.36),('5815','2013-12-30','14:35:00',1.31),('5815','2013-12-30','14:40:00',1.28),('5815','2013-12-30','14:45:00',1.23),('5815','2013-12-30','14:50:00',1.18),('5815','2013-12-30','14:55:00',1.14),('5815','2013-12-30','15:00:00',1.09),('5815','2013-12-30','15:05:00',1.05),('5815','2013-12-30','15:10:00',1),('5815','2013-12-28','09:20:00',1.1),('5815','2013-12-28','09:25:00',1.12),('5815','2013-12-28','09:30:00',1.17),('5815','2013-12-28','09:35:00',1.19),('5815','2013-12-28','09:40:00',1.26),('5815','2013-12-28','09:45:00',1.29),('5815','2013-12-28','09:50:00',1.24),('5815','2013-12-28','09:55:00',1.04),('5815','2013-12-28','10:00:00',1.12),('5815','2013-12-28','10:05:00',1.22),('5815','2013-12-28','10:15:00',1.49),('5815','2013-12-28','10:20:00',1.59),('5815','2013-12-28','10:25:00',1.36),('5815','2013-12-28','10:30:00',1.67),('5815','2013-12-28','10:35:00',1.79),('5815','2013-12-28','10:40:00',1.95),('5815','2013-12-27','09:15:00',1.02),('5815','2013-12-27','09:20:00',1.07),('5815','2013-12-27','09:25:00',1.13),('5815','2013-12-27','09:30:00',1.17),('5815','2013-12-27','09:35:00',1.21),('5815','2013-12-27','09:40:00',1.24),('5815','2013-12-27','09:45:00',1.29),('5815','2013-12-27','09:50:00',1.33),('5815','2013-12-27','09:55:00',1.37),('5815','2013-12-27','10:00:00',1.4),('5815','2013-12-27','10:05:00',1.42),('5815','2013-12-27','10:10:00',1.45),('5815','2013-12-27','10:15:00',1.48),('5815','2013-12-27','10:20:00',1.51),('5815','2013-12-27','10:25:00',1.55),('5815','2013-12-27','10:30:00',1.58),('5815','2013-12-27','10:35:00',1.61),('5815','2013-12-27','10:40:00',1.63),('5815','2013-12-27','10:45:00',1.64),('5815','2013-12-27','10:50:00',1.66),('5815','2013-12-27','10:55:00',1.68),('5815','2013-12-27','11:00:00',1.71),('5815','2013-12-27','11:05:00',1.73),('5815','2013-12-27','11:10:00',1.74),('5815','2013-12-27','11:15:00',1.75),('5815','2013-12-27','11:20:00',1.77),('5815','2013-12-27','11:25:00',1.79),('5815','2013-12-27','11:30:00',1.79),('5815','2013-12-27','11:35:00',1.8),('5815','2013-12-27','11:40:00',1.81),('5815','2013-12-27','11:45:00',1.8),('5815','2013-12-27','11:50:00',1.82),('5815','2013-12-27','11:55:00',1.82),('5815','2013-12-27','12:00:00',1.81),('5815','2013-12-27','12:05:00',1.79),('5815','2013-12-27','12:10:00',1.82),('5815','2013-12-27','12:15:00',1.83),('5815','2013-12-27','12:20:00',1.82),('5815','2013-12-27','12:25:00',1.8),('5815','2013-12-27','12:30:00',1.78),('5815','2013-12-27','12:35:00',1.77),('5815','2013-12-27','12:40:00',1.76),('5815','2013-12-27','12:45:00',1.76),('5815','2013-12-27','12:50:00',1.74),('5815','2013-12-27','12:55:00',1.73),('5815','2013-12-27','13:00:00',1.7),('5815','2013-12-27','13:05:00',1.7),('5815','2013-12-27','13:10:00',1.68),('5815','2013-12-27','13:15:00',1.65),('5815','2013-12-27','13:20:00',1.63),('5815','2013-12-27','13:25:00',1.6),('5815','2013-12-27','13:30:00',1.58),('5815','2013-12-27','13:35:00',1.56),('5815','2013-12-27','13:40:00',1.54),('5815','2013-12-27','13:45:00',1.49),('5815','2013-12-27','13:50:00',1.47),('5815','2013-12-27','13:55:00',1.45),('5815','2013-12-27','14:00:00',1.4),('5815','2013-12-27','14:05:00',1.38),('5815','2013-12-27','14:10:00',1.34),('5815','2013-12-27','14:15:00',1.3),('5815','2013-12-27','14:20:00',1.23),('5815','2013-12-27','14:25:00',1.22),('5815','2013-12-27','14:30:00',1.16),('5815','2013-12-27','14:35:00',1.13),('5815','2013-12-27','14:40:00',1.08),('5815','2013-12-26','12:15:00',1.59),('5815','2013-12-26','12:40:00',1.07),('5815','2013-12-26','12:45:00',1.43),('5815','2013-12-26','12:50:00',1.68),('5815','2013-12-26','12:55:00',1.72),('5815','2013-12-26','13:00:00',1.72),('5815','2013-12-26','13:05:00',1.52),('5815','2013-12-26','13:30:00',1.54),('5815','2013-12-26','13:35:00',1.58),('5815','2013-12-24','10:35:00',1.02),('5815','2013-12-24','10:40:00',1.05),('5815','2013-12-24','10:50:00',1.03),('5815','2013-12-24','11:20:00',1),('5815','2013-12-24','11:25:00',1.15),('5815','2013-12-24','11:30:00',1.09),('5815','2013-12-24','11:40:00',1.25),('5815','2013-12-24','11:45:00',1.31),('5815','2013-12-24','11:55:00',1.57),('5815','2013-12-24','12:00:00',1.76),('5815','2013-12-24','12:20:00',1.1),('5815','2013-12-24','12:35:00',1.04),('5815','2013-12-23','09:30:00',1.05),('5815','2013-12-23','09:35:00',1.12),('5815','2013-12-23','09:40:00',1.17),('5815','2013-12-23','09:45:00',1.2),('5815','2013-12-23','09:50:00',1.19),('5815','2013-12-23','09:55:00',1.23),('5815','2013-12-23','10:00:00',1.22),('5815','2013-12-23','10:05:00',1.24),('5815','2013-12-23','10:10:00',1.32),('5815','2013-12-23','10:15:00',1.38),('5815','2013-12-23','10:20:00',1.39),('5815','2013-12-23','10:25:00',1.41),('5815','2013-12-23','10:30:00',1.44),('5815','2013-12-23','10:35:00',1.47),('5815','2013-12-23','10:40:00',1.5),('5815','2013-12-23','10:45:00',1.54),('5815','2013-12-23','10:50:00',1.55),('5815','2013-12-23','10:55:00',1.55),('5815','2013-12-23','11:00:00',1.57),('5815','2013-12-23','11:05:00',1.59),('5815','2013-12-23','11:10:00',1.57),('5815','2013-12-23','11:15:00',1.6),('5815','2013-12-23','11:20:00',1.63),('5815','2013-12-23','11:25:00',1.65),('5815','2013-12-23','11:30:00',1.66),('5815','2013-12-23','11:35:00',1.67),('5815','2013-12-23','11:40:00',1.68),('5815','2013-12-23','11:45:00',1.69),('5815','2013-12-23','11:50:00',1.68),('5815','2013-12-23','11:55:00',1.66),('5815','2013-12-23','12:00:00',1.63),('5815','2013-12-23','12:05:00',1.64),('5815','2013-12-23','12:10:00',1.63),('5815','2013-12-23','12:15:00',1.63),('5815','2013-12-23','12:20:00',1.64),('5815','2013-12-23','12:25:00',1.63),('5815','2013-12-23','12:30:00',1.61),('5815','2013-12-23','12:35:00',1.59),('5815','2013-12-23','12:40:00',1.56),('5815','2013-12-23','12:45:00',1.55),('5815','2013-12-23','12:50:00',1.56),('5815','2013-12-23','12:55:00',1.56),('5815','2013-12-23','13:00:00',1.52),('5815','2013-12-23','13:05:00',1.51),('5815','2013-12-23','13:10:00',1.49),('5815','2013-12-23','13:15:00',1.46),('5815','2013-12-23','13:20:00',1.44),('5815','2013-12-23','13:25:00',1.42),('5815','2013-12-23','13:30:00',1.4),('5815','2013-12-23','13:35:00',1.38),('5815','2013-12-23','13:40:00',1.34),('5815','2013-12-23','13:45:00',1.3),('5815','2013-12-23','13:50:00',1.28),('5815','2013-12-23','13:55:00',1.24),('5815','2013-12-23','14:00:00',1.2),('5815','2013-12-23','14:05:00',1.17),('5815','2013-12-23','14:10:00',1.16),('5815','2013-12-23','14:15:00',1.12),('5815','2013-12-23','14:20:00',1.09),('5815','2013-12-23','14:25:00',1.03),('5815','2013-12-22','09:55:00',1.05),('5815','2013-12-22','10:00:00',1.24),('5815','2013-12-22','10:05:00',1.36),('5815','2013-12-22','10:10:00',1.43),('5815','2013-12-22','10:15:00',1.31),('5815','2013-12-22','10:20:00',1.42),('5815','2013-12-22','10:25:00',1.38),('5815','2013-12-22','10:30:00',1.29),('5815','2013-12-22','10:35:00',1.31),('5815','2013-12-22','10:40:00',1.35),('5815','2013-12-22','10:45:00',1.36),('5815','2013-12-22','10:50:00',1.36),('5815','2013-12-22','10:55:00',1.41),('5815','2013-12-22','11:00:00',1.62),('5815','2013-12-22','11:05:00',1.73),('5815','2013-12-22','11:10:00',1.76),('5815','2013-12-22','11:15:00',1.77),('5815','2013-12-22','11:20:00',1.69),('5815','2013-12-22','11:25:00',1.75),('5815','2013-12-22','11:30:00',1.65),('5815','2013-12-22','11:35:00',1.72),('5815','2013-12-22','11:40:00',1.77),('5815','2013-12-22','11:45:00',1.55),('5815','2013-12-22','11:50:00',1.58),('5815','2013-12-22','11:55:00',1.62),('5815','2013-12-22','12:00:00',1.67),('5815','2013-12-22','12:05:00',1.73),('5815','2013-12-22','12:10:00',1.7),('5815','2013-12-22','12:15:00',1.66),('5815','2013-12-22','12:20:00',1.66),('5815','2013-12-22','12:25:00',1.67),('5815','2013-12-22','12:30:00',1.77),('5815','2013-12-22','12:35:00',1.76),('5815','2013-12-22','12:40:00',1.75),('5815','2013-12-22','12:45:00',1.74),('5815','2013-12-22','12:50:00',1.73),('5815','2013-12-22','12:55:00',1.73),('5815','2013-12-22','13:00:00',1.72),('5815','2013-12-22','13:05:00',1.69),('5815','2013-12-22','13:10:00',1.67),('5815','2013-12-22','13:15:00',1.64),('5815','2013-12-22','13:20:00',1.54),('5815','2013-12-22','13:25:00',1.33),('5815','2013-12-22','13:30:00',1.57),('5815','2013-12-22','13:40:00',1.22),('5815','2013-12-22','13:45:00',1.12),('5815','2013-12-22','13:50:00',1.05),('5815','2013-12-22','13:55:00',1.24),('5815','2013-12-22','14:00:00',1.45),('5815','2013-12-22','14:05:00',1.42),('5815','2013-12-22','14:10:00',1.4),('5815','2013-12-22','14:15:00',1.34),('5815','2013-12-22','14:20:00',1.26),('5815','2013-12-22','14:25:00',1.23),('5815','2013-12-22','14:30:00',1.11),('5815','2013-12-22','14:35:00',1.12),('5815','2013-12-22','14:40:00',1.09),('5815','2013-12-22','14:45:00',1.07),('5815','2013-12-22','14:50:00',1.04),('5815','2013-12-21','09:35:00',1.02),('5815','2013-12-21','09:40:00',1.41),('5815','2013-12-21','09:45:00',1.44),('5815','2013-12-21','09:50:00',1.53),('5815','2013-12-21','09:55:00',1.54),('5815','2013-12-21','10:00:00',1.55),('5815','2013-12-21','10:05:00',1.57),('5815','2013-12-21','10:10:00',1.59),('5815','2013-12-21','10:15:00',1.56),('5815','2013-12-21','10:20:00',1.51),('5815','2013-12-21','10:25:00',1.53),('5815','2013-12-21','10:30:00',1.6),('5815','2013-12-21','10:35:00',1.52),('5815','2013-12-21','10:40:00',1.43),('5815','2013-12-21','10:45:00',1.48),('5815','2013-12-21','10:50:00',1.55),('5815','2013-12-21','10:55:00',1.44),('5815','2013-12-21','11:00:00',1.27),('5815','2013-12-21','11:05:00',1.24),('5815','2013-12-21','11:10:00',1.69),('5815','2013-12-21','11:15:00',1.67),('5815','2013-12-21','11:20:00',1.52),('5815','2013-12-21','11:25:00',1.55),('5815','2013-12-21','11:30:00',1.47),('5815','2013-12-21','11:35:00',1.45),('5815','2013-12-21','11:40:00',1.57),('5815','2013-12-21','11:45:00',1.47),('5815','2013-12-21','11:50:00',1.1),('5815','2013-12-21','12:35:00',1.11),('5815','2013-12-21','12:40:00',1.07),('5815','2013-12-21','12:50:00',1.22),('5815','2013-12-21','12:55:00',1.55),('5815','2013-12-21','13:00:00',1.5),('5815','2013-12-21','13:05:00',1.85),('5815','2013-12-21','13:10:00',1.88),('5815','2013-12-21','13:15:00',1.43),('5815','2013-12-21','13:20:00',1.39),('5815','2013-12-21','13:25:00',1.41),('5815','2013-12-21','13:30:00',1.33),('5815','2013-12-21','13:35:00',1.27),('5815','2013-12-21','13:40:00',1.01),('5815','2013-12-21','13:45:00',1.19),('5815','2013-12-21','13:50:00',1.14),('5815','2013-12-21','14:10:00',1.14),('5815','2013-12-20','09:20:00',1.01),('5815','2013-12-20','09:25:00',1.05),('5815','2013-12-20','09:30:00',1.09),('5815','2013-12-20','09:35:00',1.14),('5815','2013-12-20','09:40:00',1.17),('5815','2013-12-20','09:45:00',1.21),('5815','2013-12-20','09:50:00',1.25),('5815','2013-12-20','09:55:00',1.3),('5815','2013-12-20','10:00:00',1.34),('5815','2013-12-20','10:05:00',1.38),('5815','2013-12-20','10:10:00',1.41),('5815','2013-12-20','10:15:00',1.43),('5815','2013-12-20','10:20:00',1.46),('5815','2013-12-20','10:25:00',1.48),('5815','2013-12-20','10:30:00',1.53),('5815','2013-12-20','10:35:00',1.56),('5815','2013-12-20','10:40:00',1.57),('5815','2013-12-20','10:45:00',1.6),('5815','2013-12-20','10:50:00',1.62),('5815','2013-12-20','10:55:00',1.64),('5815','2013-12-20','11:00:00',1.67),('5815','2013-12-20','11:05:00',1.7),('5815','2013-12-20','11:10:00',1.71),('5815','2013-12-20','11:15:00',1.73),('5815','2013-12-20','11:20:00',1.75),('5815','2013-12-20','11:25:00',1.77),('5815','2013-12-20','11:30:00',1.79),('5815','2013-12-20','11:35:00',1.79),('5815','2013-12-20','11:40:00',1.8),('5815','2013-12-20','11:45:00',1.8),('5815','2013-12-20','11:50:00',1.81),('5815','2013-12-20','11:55:00',1.81),('5815','2013-12-20','12:00:00',1.82),('5815','2013-12-20','12:05:00',1.83),('5815','2013-12-20','12:10:00',1.82),('5815','2013-12-20','12:15:00',1.81),('5815','2013-12-20','12:20:00',1.81),('5815','2013-12-20','12:25:00',1.8),('5815','2013-12-20','12:30:00',1.81),('5815','2013-12-20','12:35:00',1.8),('5815','2013-12-20','12:40:00',1.79),('5815','2013-12-20','12:45:00',1.78),('5815','2013-12-20','12:50:00',1.78),('5815','2013-12-20','12:55:00',1.76),('5815','2013-12-20','13:00:00',1.74),('5815','2013-12-20','13:05:00',1.73),('5815','2013-12-20','13:10:00',1.71),('5815','2013-12-20','13:15:00',1.68),('5815','2013-12-20','13:20:00',1.66),('5815','2013-12-20','13:25:00',1.65),('5815','2013-12-20','13:30:00',1.62),('5815','2013-12-20','13:35:00',1.59),('5815','2013-12-20','13:40:00',1.55),('5815','2013-12-20','13:45:00',1.54),('5815','2013-12-20','13:50:00',1.52),('5815','2013-12-20','13:55:00',1.49),('5815','2013-12-20','14:00:00',1.46),('5815','2013-12-20','14:05:00',1.42),('5815','2013-12-20','14:10:00',1.39),('5815','2013-12-20','14:15:00',1.38),('5815','2013-12-20','14:20:00',1.36),('5815','2013-12-20','14:25:00',1.32),('5815','2013-12-20','14:30:00',1.28),('5815','2013-12-20','14:35:00',1.24),('5815','2013-12-20','14:40:00',1.18),('5815','2013-12-20','14:45:00',1.15),('5815','2013-12-20','14:50:00',1.08),('5815','2013-12-20','14:55:00',1.04),('5815','2013-12-19','09:25:00',1.03),('5815','2013-12-19','09:30:00',1.07),('5815','2013-12-19','09:35:00',1.11),('5815','2013-12-19','09:40:00',1.15),('5815','2013-12-19','09:45:00',1.19),('5815','2013-12-19','09:50:00',1.22),('5815','2013-12-19','09:55:00',1.25),('5815','2013-12-19','10:00:00',1.28),('5815','2013-12-19','10:05:00',1.32),('5815','2013-12-19','10:10:00',1.34),('5815','2013-12-19','10:15:00',1.36),('5815','2013-12-19','10:20:00',1.39),('5815','2013-12-19','10:25:00',1.43),('5815','2013-12-19','10:30:00',1.44),('5815','2013-12-19','10:35:00',1.47),('5815','2013-12-19','10:40:00',1.5),('5815','2013-12-19','10:45:00',1.52),('5815','2013-12-19','10:50:00',1.55),('5815','2013-12-19','10:55:00',1.57),('5815','2013-12-19','11:00:00',1.58),('5815','2013-12-19','11:05:00',1.59),('5815','2013-12-19','11:10:00',1.6),('5815','2013-12-19','11:15:00',1.62),('5815','2013-12-19','11:20:00',1.63),('5815','2013-12-19','11:25:00',1.64),('5815','2013-12-19','11:30:00',1.65),('5815','2013-12-19','11:35:00',1.65),('5815','2013-12-19','11:40:00',1.67),('5815','2013-12-19','11:45:00',1.68),('5815','2013-12-19','11:50:00',1.7),('5815','2013-12-19','11:55:00',1.71),('5815','2013-12-19','12:00:00',1.69),('5815','2013-12-19','12:05:00',1.68),('5815','2013-12-19','12:10:00',1.71),('5815','2013-12-19','12:15:00',1.7),('5815','2013-12-19','12:20:00',1.69),('5815','2013-12-19','12:25:00',1.66),('5815','2013-12-19','12:30:00',1.67),('5815','2013-12-19','12:35:00',1.66),('5815','2013-12-19','12:40:00',1.65),('5815','2013-12-19','12:45:00',1.62),('5815','2013-12-19','12:50:00',1.6),('5815','2013-12-19','12:55:00',1.6),('5815','2013-12-19','13:00:00',1.6),('5815','2013-12-19','13:05:00',1.59),('5815','2013-12-19','13:10:00',1.58),('5815','2013-12-19','13:15:00',1.54),('5815','2013-12-19','13:20:00',1.49),('5815','2013-12-19','13:25:00',1.48),('5815','2013-12-19','13:30:00',1.46),('5815','2013-12-19','13:35:00',1.43),('5815','2013-12-19','13:40:00',1.39),('5815','2013-12-19','13:45:00',1.38),('5815','2013-12-19','13:50:00',1.31),('5815','2013-12-19','13:55:00',1.26),('5815','2013-12-19','14:00:00',1.17),('5815','2013-12-18','09:25:00',1.12),('5815','2013-12-18','09:55:00',1.4),('5815','2013-12-18','10:00:00',1.3),('5815','2013-12-18','10:05:00',1.33),('5815','2013-12-18','10:10:00',1.37),('5815','2013-12-18','10:15:00',1.41),('5815','2013-12-18','10:20:00',1.15),('5815','2013-12-18','10:45:00',1.16),('5815','2013-12-18','10:50:00',1.68),('5815','2013-12-18','11:15:00',1.37),('5815','2013-12-18','14:35:00',1.26),('5815','2013-12-18','14:40:00',1.1),('5815','2013-12-18','14:45:00',1.04),('5815','2013-12-17','09:20:00',1.04),('5815','2013-12-17','09:25:00',1.09),('5815','2013-12-17','09:30:00',1.13),('5815','2013-12-17','09:35:00',1.17),('5815','2013-12-17','09:40:00',1.2),('5815','2013-12-17','09:45:00',1.26),('5815','2013-12-17','09:50:00',1.29),('5815','2013-12-17','09:55:00',1.32),('5815','2013-12-17','10:00:00',1.36),('5815','2013-12-17','10:05:00',1.4),('5815','2013-12-17','10:10:00',1.44),('5815','2013-12-17','10:15:00',1.47),('5815','2013-12-17','10:20:00',1.5),('5815','2013-12-17','10:25:00',1.53),('5815','2013-12-17','10:30:00',1.57),('5815','2013-12-17','10:35:00',1.59),('5815','2013-12-17','10:40:00',1.6),('5815','2013-12-17','10:45:00',1.62),('5815','2013-12-17','10:50:00',1.64),('5815','2013-12-17','10:55:00',1.65),('5815','2013-12-17','11:00:00',1.66),('5815','2013-12-17','11:05:00',1.68),('5815','2013-12-17','11:10:00',1.69),('5815','2013-12-17','11:15:00',1.71),('5815','2013-12-17','11:20:00',1.71),('5815','2013-12-17','11:25:00',1.71),('5815','2013-12-17','11:30:00',1.73),('5815','2013-12-17','11:35:00',1.73),('5815','2013-12-17','11:40:00',1.74),('5815','2013-12-17','11:45:00',1.74),('5815','2013-12-17','11:50:00',1.74),('5815','2013-12-17','11:55:00',1.75),('5815','2013-12-17','12:00:00',1.75),('5815','2013-12-17','12:05:00',1.76),('5815','2013-12-17','12:10:00',1.76),('5815','2013-12-17','12:15:00',1.77),('5815','2013-12-17','12:20:00',1.76),('5815','2013-12-17','12:25:00',1.75),('5815','2013-12-17','12:30:00',1.76),('5815','2013-12-17','12:35:00',1.75),('5815','2013-12-17','12:40:00',1.73),('5815','2013-12-17','12:45:00',1.72),('5815','2013-12-17','12:50:00',1.7),('5815','2013-12-17','12:55:00',1.69),('5815','2013-12-17','13:00:00',1.66),('5815','2013-12-17','13:05:00',1.65),('5815','2013-12-17','13:10:00',1.63),('5815','2013-12-17','13:15:00',1.6),('5815','2013-12-17','13:20:00',1.59),('5815','2013-12-17','13:25:00',1.56),('5815','2013-12-17','13:30:00',1.53),('5815','2013-12-17','13:35:00',1.5),('5815','2013-12-17','13:40:00',1.49),('5815','2013-12-17','13:45:00',1.44),('5815','2013-12-17','13:50:00',1.42),('5815','2013-12-17','13:55:00',1.36),('5815','2013-12-17','14:00:00',1.36),('5815','2013-12-17','14:05:00',1.33),('5815','2013-12-17','14:10:00',1.29),('5815','2013-12-17','14:15:00',1.28),('5815','2013-12-17','14:20:00',1.23),('5815','2013-12-17','14:25:00',1.21),('5815','2013-12-17','14:30:00',1.18),('5815','2013-12-17','14:35:00',1.14),('5815','2013-12-17','14:40:00',1.11),('5815','2013-12-17','14:45:00',1.05),('5815','2013-12-17','14:50:00',1.02),('5815','2014-04-21','08:45:00',1.01),('5815','2014-04-21','08:50:00',1.04),('5815','2014-04-21','08:55:00',1.08),('5815','2014-04-21','09:00:00',1.14),('5815','2014-04-21','09:05:00',1.24),('5815','2014-04-21','09:10:00',1.2),('5815','2014-04-21','09:15:00',1.2),('5815','2014-04-21','09:20:00',1.28),('5815','2014-04-21','09:25:00',1.12),('5815','2014-04-21','09:30:00',1),('5815','2014-04-21','09:35:00',1.33),('5815','2014-04-21','09:40:00',1.54),('5815','2014-04-21','09:45:00',1.65),('5815','2014-04-21','09:50:00',1.39),('5815','2014-04-21','10:10:00',1.04),('5815','2014-04-21','10:15:00',1.11),('5815','2014-04-21','10:20:00',1.67),('5815','2014-04-21','10:25:00',1.26),('5815','2014-04-21','10:30:00',1.84),('5815','2014-04-21','10:35:00',2.01),('5815','2014-04-21','10:40:00',1.85),('5815','2014-04-21','10:45:00',1.98),('5815','2014-04-21','10:50:00',2.32),('5815','2014-04-21','10:55:00',1.7),('5815','2014-04-21','11:00:00',1.11),('5815','2014-04-21','11:05:00',1.24),('5815','2014-04-21','13:20:00',1.27),('5815','2014-04-21','13:25:00',1.46),('5815','2014-04-21','13:30:00',1.63),('5815','2014-04-21','13:35:00',1.48),('5815','2014-04-21','13:40:00',1.84),('5815','2014-04-21','13:45:00',1.85),('5815','2014-04-21','13:50:00',1.63),('5815','2014-04-21','14:10:00',2.02),('5815','2014-04-21','14:15:00',1.84),('5815','2014-04-21','14:20:00',2.02),('5815','2014-04-21','14:25:00',1.66),('5815','2014-04-21','14:30:00',1.13),('5815','2014-04-21','14:35:00',1.31),('5815','2014-04-21','14:40:00',1.83),('5815','2014-04-21','14:45:00',2.24),('5815','2014-04-21','14:50:00',2.05),('5815','2014-04-21','14:55:00',1.62),('5815','2014-04-21','15:35:00',1.46),('5815','2014-04-21','15:40:00',1.29),('5815','2014-04-21','15:45:00',1.06),('5815','2014-04-21','15:50:00',1.24),('5815','2014-04-21','15:55:00',1.02),('5815','2014-04-21','16:00:00',1.2),('5815','2014-04-21','16:40:00',1.01),('5815','2013-12-16','09:05:00',1),('5815','2013-12-16','09:10:00',1.05),('5815','2013-12-16','09:15:00',1.09),('5815','2013-12-16','09:20:00',1.13),('5815','2013-12-16','09:25:00',1.17),('5815','2013-12-16','09:30:00',1.21),('5815','2013-12-16','09:35:00',1.25),('5815','2013-12-16','09:40:00',1.3),('5815','2013-12-16','09:45:00',1.34),('5815','2013-12-16','09:50:00',1.38),('5815','2013-12-16','09:55:00',1.42),('5815','2013-12-16','10:00:00',1.45),('5815','2013-12-16','10:05:00',1.49),('5815','2013-12-16','10:10:00',1.49),('5815','2013-12-16','10:15:00',1.53),('5815','2013-12-16','10:20:00',1.56),('5815','2013-12-16','10:25:00',1.59),('5815','2013-12-16','10:30:00',1.62),('5815','2013-12-16','10:35:00',1.64),('5815','2013-12-16','10:40:00',1.66),('5815','2013-12-16','10:45:00',1.68),('5815','2013-12-16','10:50:00',1.68),('5815','2013-12-16','10:55:00',1.71),('5815','2013-12-16','11:00:00',1.73),('5815','2013-12-16','11:05:00',1.74),('5815','2013-12-16','11:10:00',1.76),('5815','2013-12-16','11:15:00',1.78),('5815','2013-12-16','11:20:00',1.79),('5815','2013-12-16','11:25:00',1.79),('5815','2013-12-16','11:30:00',1.81),('5815','2013-12-16','11:35:00',1.82),('5815','2013-12-16','11:40:00',1.83),('5815','2013-12-16','11:45:00',1.84),('5815','2013-12-16','11:50:00',1.85),('5815','2013-12-16','11:55:00',1.84),('5815','2013-12-16','12:00:00',1.83),('5815','2013-12-16','12:05:00',1.83),('5815','2013-12-16','12:10:00',1.83),('5815','2013-12-16','12:15:00',1.84),('5815','2013-12-16','12:20:00',1.84),('5815','2013-12-16','12:25:00',1.83),('5815','2013-12-16','12:30:00',1.84),('5815','2013-12-16','12:35:00',1.85),('5815','2013-12-16','12:40:00',1.82),('5815','2013-12-16','12:45:00',1.8),('5815','2013-12-16','12:50:00',1.79),('5815','2013-12-16','12:55:00',1.74),('5815','2013-12-16','13:00:00',1.76),('5815','2013-12-16','13:05:00',1.75),('5815','2013-12-16','13:10:00',1.72),('5815','2013-12-16','13:15:00',1.69),('5815','2013-12-16','13:20:00',1.67),('5815','2013-12-16','13:25:00',1.64),('5815','2013-12-16','13:30:00',1.62),('5815','2013-12-16','13:35:00',1.62),('5815','2013-12-16','13:40:00',1.6),('5815','2013-12-16','13:45:00',1.57),('5815','2013-12-16','13:50:00',1.53),('5815','2013-12-16','13:55:00',1.5),('5815','2013-12-16','14:00:00',1.47),('5815','2013-12-16','14:05:00',1.43),('5815','2013-12-16','14:10:00',1.38),('5815','2013-12-16','14:15:00',1.35),('5815','2013-12-16','14:20:00',1.32),('5815','2013-12-16','14:25:00',1.29),('5815','2013-12-16','14:30:00',1.25),('5815','2013-12-16','14:35:00',1.23),('5815','2013-12-16','14:40:00',1.18),('5815','2013-12-16','14:45:00',1.13),('5815','2013-12-16','14:50:00',1.08),('5815','2013-12-16','14:55:00',1.05),('5815','2013-12-16','15:00:00',1),('5815','2013-12-15','09:10:00',1.02),('5815','2013-12-15','09:15:00',1.07),('5815','2013-12-15','09:20:00',1.1),('5815','2013-12-15','09:25:00',1.16),('5815','2013-12-15','09:30:00',1.2),('5815','2013-12-15','09:35:00',1.24),('5815','2013-12-15','09:40:00',1.28),('5815','2013-12-15','09:45:00',1.32),('5815','2013-12-15','09:50:00',1.36),('5815','2013-12-15','09:55:00',1.38),('5815','2013-12-15','10:00:00',1.41),('5815','2013-12-15','10:05:00',1.45),('5815','2013-12-15','10:10:00',1.47),('5815','2013-12-15','10:15:00',1.5),('5815','2013-12-15','10:20:00',1.52),('5815','2013-12-15','10:25:00',1.53),('5815','2013-12-15','10:30:00',1.56),('5815','2013-12-15','10:35:00',1.58),('5815','2013-12-15','10:40:00',1.6),('5815','2013-12-15','10:45:00',1.63),('5815','2013-12-15','10:50:00',1.65),('5815','2013-12-15','10:55:00',1.68),('5815','2013-12-15','11:00:00',1.7),('5815','2013-12-15','11:05:00',1.71),('5815','2013-12-15','11:10:00',1.72),('5815','2013-12-15','11:15:00',1.73),('5815','2013-12-15','11:20:00',1.74),('5815','2013-12-15','11:25:00',1.76),('5815','2013-12-15','11:30:00',1.79),('5815','2013-12-15','11:35:00',1.79),('5815','2013-12-15','11:40:00',1.79),('5815','2013-12-15','11:45:00',1.8),('5815','2013-12-15','11:50:00',1.81),('5815','2013-12-15','11:55:00',1.82),('5815','2013-12-15','12:00:00',1.84),('5815','2013-12-15','12:05:00',1.84),('5815','2013-12-15','12:10:00',1.84),('5815','2013-12-15','12:15:00',1.84),('5815','2013-12-15','12:20:00',1.85),('5815','2013-12-15','12:25:00',1.83),('5815','2013-12-15','12:30:00',1.82),('5815','2013-12-15','12:35:00',1.82),('5815','2013-12-15','12:40:00',1.82),('5815','2013-12-15','12:45:00',1.81),('5815','2013-12-15','12:50:00',1.79),('5815','2013-12-15','12:55:00',1.78),('5815','2013-12-15','13:00:00',1.78),('5815','2013-12-15','13:05:00',1.77),('5815','2013-12-15','13:10:00',1.73),('5815','2013-12-15','13:15:00',1.7),('5815','2013-12-15','13:20:00',1.67),('5815','2013-12-15','13:25:00',1.64),('5815','2013-12-15','13:30:00',1.63),('5815','2013-12-15','13:35:00',1.59),('5815','2013-12-15','13:40:00',1.58),('5815','2013-12-15','13:45:00',1.56),('5815','2013-12-15','13:50:00',1.54),('5815','2013-12-15','13:55:00',1.49),('5815','2013-12-15','14:00:00',1.43),('5815','2013-12-15','14:05:00',1.43),('5815','2013-12-15','14:10:00',1.38),('5815','2013-12-15','14:15:00',1.36),('5815','2013-12-15','14:20:00',1.32),('5815','2013-12-15','14:25:00',1.28),('5815','2013-12-15','14:30:00',1.25),('5815','2013-12-15','14:35:00',1.21),('5815','2013-12-15','14:40:00',1.17),('5815','2013-12-15','14:45:00',1.12),('5815','2013-12-15','14:50:00',1.07),('5815','2013-12-15','14:55:00',1.02),('5815','2013-12-13','09:15:00',1.02),('5815','2013-12-13','09:20:00',1.07),('5815','2013-12-13','09:25:00',1.12),('5815','2013-12-13','09:30:00',1.16),('5815','2013-12-13','09:35:00',1.2),('5815','2013-12-13','09:40:00',1.24),('5815','2013-12-13','09:45:00',1.28),('5815','2013-12-13','09:50:00',1.31),('5815','2013-12-13','09:55:00',1.33),('5815','2013-12-13','10:00:00',1.36),('5815','2013-12-13','10:05:00',1.39),('5815','2013-12-13','10:10:00',1.42),('5815','2013-12-13','10:15:00',1.46),('5815','2013-12-13','10:20:00',1.49),('5815','2013-12-13','10:25:00',1.48),('5815','2013-12-13','10:30:00',1.52),('5815','2013-12-13','10:35:00',1.56),('5815','2013-12-13','10:40:00',1.57),('5815','2013-12-13','10:45:00',1.59),('5815','2013-12-13','10:50:00',1.61),('5815','2013-12-13','10:55:00',1.61),('5815','2013-12-13','11:00:00',1.62),('5815','2013-12-13','11:05:00',1.63),('5815','2013-12-13','11:10:00',1.67),('5815','2013-12-13','11:15:00',1.67),('5815','2013-12-13','11:20:00',1.69),('5815','2013-12-13','11:25:00',1.69),('5815','2013-12-13','11:30:00',1.7),('5815','2013-12-13','11:35:00',1.7),('5815','2013-12-13','11:40:00',1.73),('5815','2013-12-13','11:45:00',1.72),('5815','2013-12-13','11:50:00',1.7),('5815','2013-12-13','11:55:00',1.68),('5815','2013-12-13','12:00:00',1.67),('5815','2013-12-13','12:05:00',1.67),('5815','2013-12-13','12:10:00',1.67),('5815','2013-12-13','12:15:00',1.69),('5815','2013-12-13','12:20:00',1.68),('5815','2013-12-13','12:25:00',1.67),('5815','2013-12-13','12:30:00',1.62),('5815','2013-12-13','12:35:00',1.61),('5815','2013-12-13','12:40:00',1.61),('5815','2013-12-13','12:45:00',1.59),('5815','2013-12-13','12:50:00',1.64),('5815','2013-12-13','12:55:00',1.61),('5815','2013-12-13','13:00:00',1.6),('5815','2013-12-13','13:05:00',1.58),('5815','2013-12-13','13:10:00',1.56),('5815','2013-12-13','13:15:00',1.56),('5815','2013-12-13','13:20:00',1.57),('5815','2013-12-13','13:25:00',1.57),('5815','2013-12-13','13:30:00',1.52),('5815','2013-12-13','13:35:00',1.49),('5815','2013-12-13','13:40:00',1.51),('5815','2013-12-13','13:45:00',1.52),('5815','2013-12-13','13:50:00',1.49),('5815','2013-12-13','13:55:00',1.46),('5815','2013-12-13','14:00:00',1.41),('5815','2013-12-13','14:05:00',1.4),('5815','2013-12-13','14:10:00',1.35),('5815','2013-12-13','14:15:00',1.32),('5815','2013-12-13','14:20:00',1.28),('5815','2013-12-13','14:25:00',1.25),('5815','2013-12-13','14:30:00',1.22),('5815','2013-12-13','14:35:00',1.18),('5815','2013-12-13','14:40:00',1.13),('5815','2013-12-13','14:45:00',1.08),('5815','2013-12-13','14:50:00',1.01),('5815','2013-12-12','09:25:00',1.01),('5815','2013-12-12','09:30:00',1.03),('5815','2013-12-12','09:35:00',1.06),('5815','2013-12-12','09:40:00',1.1),('5815','2013-12-12','09:45:00',1.15),('5815','2013-12-12','09:50:00',1.19),('5815','2013-12-12','09:55:00',1.23),('5815','2013-12-12','10:00:00',1.24),('5815','2013-12-12','10:05:00',1.28),('5815','2013-12-12','10:10:00',1.31),('5815','2013-12-12','10:15:00',1.34),('5815','2013-12-12','10:20:00',1.38),('5815','2013-12-12','10:25:00',1.39),('5815','2013-12-12','10:30:00',1.43),('5815','2013-12-12','10:35:00',1.46),('5815','2013-12-12','10:40:00',1.48),('5815','2013-12-12','10:45:00',1.5),('5815','2013-12-12','10:50:00',1.51),('5815','2013-12-12','10:55:00',1.55),('5815','2013-12-12','11:00:00',1.56),('5815','2013-12-12','11:05:00',1.58),('5815','2013-12-12','11:10:00',1.56),('5815','2013-12-12','11:15:00',1.59),('5815','2013-12-12','11:20:00',1.63),('5815','2013-12-12','11:25:00',1.63),('5815','2013-12-12','11:30:00',1.63),('5815','2013-12-12','11:35:00',1.63),('5815','2013-12-12','11:40:00',1.63),('5815','2013-12-12','11:45:00',1.66),('5815','2013-12-12','11:50:00',1.66),('5815','2013-12-12','11:55:00',1.66),('5815','2013-12-12','12:00:00',1.7),('5815','2013-12-12','12:05:00',1.68),('5815','2013-12-12','12:10:00',1.65),('5815','2013-12-12','12:15:00',1.64),('5815','2013-12-12','12:20:00',1.6),('5815','2013-12-12','12:25:00',1.66),('5815','2013-12-12','12:30:00',1.66),('5815','2013-12-12','12:35:00',1.63),('5815','2013-12-12','12:40:00',1.62),('5815','2013-12-12','12:45:00',1.64),('5815','2013-12-12','12:50:00',1.61),('5815','2013-12-12','12:55:00',1.58),('5815','2013-12-12','13:00:00',1.6),('5815','2013-12-12','13:05:00',1.6),('5815','2013-12-12','13:10:00',1.57),('5815','2013-12-12','13:15:00',1.57),('5815','2013-12-12','13:20:00',1.5),('5815','2013-12-12','13:25:00',1.54),('5815','2013-12-12','13:30:00',1.55),('5815','2013-12-12','13:35:00',1.51),('5815','2013-12-12','13:40:00',1.45),('5815','2013-12-12','13:45:00',1.45),('5815','2013-12-12','13:50:00',1.43),('5815','2013-12-12','13:55:00',1.4),('5815','2013-12-12','14:00:00',1.37),('5815','2013-12-12','14:05:00',1.34),('5815','2013-12-12','14:10:00',1.32),('5815','2013-12-12','14:15:00',1.31),('5815','2013-12-12','14:20:00',1.26),('5815','2013-12-12','14:25:00',1.25),('5815','2013-12-12','14:30:00',1.2),('5815','2013-12-12','14:35:00',1.17),('5815','2013-12-12','14:40:00',1.1),('5815','2013-12-12','14:45:00',1.06),('5815','2013-12-12','14:50:00',1.04),('5815','2013-12-12','14:55:00',1.01),('5815','2013-12-11','09:20:00',1.03),('5815','2013-12-11','09:25:00',1.08),('5815','2013-12-11','09:30:00',1.13),('5815','2013-12-11','09:35:00',1.18),('5815','2013-12-11','09:40:00',1.22),('5815','2013-12-11','09:45:00',1.25),('5815','2013-12-11','09:50:00',1.28),('5815','2013-12-11','09:55:00',1.31),('5815','2013-12-11','10:00:00',1.35),('5815','2013-12-11','10:05:00',1.35),('5815','2013-12-11','10:10:00',1.42),('5815','2013-12-11','10:15:00',1.45),('5815','2013-12-11','10:20:00',1.47),('5815','2013-12-11','10:25:00',1.5),('5815','2013-12-11','10:30:00',1.52),('5815','2013-12-11','10:35:00',1.55),('5815','2013-12-11','10:40:00',1.57),('5815','2013-12-11','10:45:00',1.59),('5815','2013-12-11','10:50:00',1.61),('5815','2013-12-11','10:55:00',1.62),('5815','2013-12-11','11:00:00',1.63),('5815','2013-12-11','11:05:00',1.65),('5815','2013-12-11','11:10:00',1.65),('5815','2013-12-11','11:15:00',1.66),('5815','2013-12-11','11:20:00',1.67),('5815','2013-12-11','11:25:00',1.68),('5815','2013-12-11','11:30:00',1.7),('5815','2013-12-11','11:35:00',1.72),('5815','2013-12-11','11:40:00',1.71),('5815','2013-12-11','11:45:00',1.7),('5815','2013-12-11','11:50:00',1.69),('5815','2013-12-11','11:55:00',1.69),('5815','2013-12-11','12:00:00',1.71),('5815','2013-12-11','12:05:00',1.72),('5815','2013-12-11','12:10:00',1.72),('5815','2013-12-11','12:15:00',1.71),('5815','2013-12-11','12:20:00',1.7),('5815','2013-12-11','12:25:00',1.71),('5815','2013-12-11','12:30:00',1.71),('5815','2013-12-11','12:35:00',1.69),('5815','2013-12-11','12:40:00',1.67),('5815','2013-12-11','12:45:00',1.67),('5815','2013-12-11','12:50:00',1.69),('5815','2013-12-11','12:55:00',1.61),('5815','2013-12-11','13:00:00',1.62),('5815','2013-12-11','13:05:00',1.59),('5815','2013-12-11','13:10:00',1.59),('5815','2013-12-11','13:15:00',1.59),('5815','2013-12-11','13:20:00',1.59),('5815','2013-12-11','13:25:00',1.54),('5815','2013-12-11','13:30:00',1.5),('5815','2013-12-11','13:35:00',1.54),('5815','2013-12-11','13:40:00',1.49),('5815','2013-12-11','13:45:00',1.46),('5815','2013-12-11','13:50:00',1.46),('5815','2013-12-11','13:55:00',1.43),('5815','2013-12-11','14:00:00',1.37),('5815','2013-12-11','14:05:00',1.35),('5815','2013-12-11','14:10:00',1.31),('5815','2013-12-11','14:15:00',1.27),('5815','2013-12-11','14:20:00',1.24),('5815','2013-12-11','14:25:00',1.2),('5815','2013-12-11','14:30:00',1.14),('5815','2013-12-11','14:35:00',1.1),('5815','2013-12-11','14:40:00',1.08),('5815','2013-12-11','14:45:00',1.03),('5815','2013-12-10','09:15:00',1.04),('5815','2013-12-10','09:20:00',1.07),('5815','2013-12-10','09:25:00',1.13),('5815','2013-12-10','09:30:00',1.18),('5815','2013-12-10','09:35:00',1.22),('5815','2013-12-10','09:40:00',1.27),('5815','2013-12-10','09:45:00',1.31),('5815','2013-12-10','09:50:00',1.34),('5815','2013-12-10','09:55:00',1.38),('5815','2013-12-10','10:00:00',1.41),('5815','2013-12-10','10:05:00',1.44),('5815','2013-12-10','10:10:00',1.48),('5815','2013-12-10','10:15:00',1.51),('5815','2013-12-10','10:20:00',1.54),('5815','2013-12-10','10:25:00',1.57),('5815','2013-12-10','10:30:00',1.62),('5815','2013-12-10','10:35:00',1.66),('5815','2013-12-10','10:40:00',1.67),('5815','2013-12-10','10:45:00',1.66),('5815','2013-12-10','10:50:00',1.62),('5815','2013-12-10','10:55:00',1.68),('5815','2013-12-10','11:00:00',1.72),('5815','2013-12-10','11:05:00',1.75),('5815','2013-12-10','11:10:00',1.76),('5815','2013-12-10','11:15:00',1.76),('5815','2013-12-10','11:20:00',1.77),('5815','2013-12-10','11:25:00',1.73),('5815','2013-12-10','11:30:00',1.75),('5815','2013-12-10','11:35:00',1.78),('5815','2013-12-10','11:40:00',1.8),('5815','2013-12-10','11:45:00',1.8),('5815','2013-12-10','11:50:00',1.82),('5815','2013-12-10','11:55:00',1.83),('5815','2013-12-10','12:00:00',1.83),('5815','2013-12-10','12:05:00',1.82),('5815','2013-12-10','12:10:00',1.82),('5815','2013-12-10','12:15:00',1.83),('5815','2013-12-10','12:20:00',1.81),('5815','2013-12-10','12:25:00',1.75),('5815','2013-12-10','12:30:00',1.74),('5815','2013-12-10','12:35:00',1.75),('5815','2013-12-10','12:40:00',1.75),('5815','2013-12-10','12:45:00',1.75),('5815','2013-12-10','12:50:00',1.73),('5815','2013-12-10','12:55:00',1.73),('5815','2013-12-10','13:00:00',1.74),('5815','2013-12-10','13:05:00',1.71),('5815','2013-12-10','13:10:00',1.67),('5815','2013-12-10','13:15:00',1.64),('5815','2013-12-10','13:20:00',1.63),('5815','2013-12-10','13:25:00',1.62),('5815','2013-12-10','13:30:00',1.61),('5815','2013-12-10','13:35:00',1.57),('5815','2013-12-10','13:40:00',1.56),('5815','2013-12-10','13:45:00',1.53),('5815','2013-12-10','13:50:00',1.5),('5815','2013-12-10','13:55:00',1.47),('5815','2013-12-10','14:00:00',1.43),('5815','2013-12-10','14:05:00',1.42),('5815','2013-12-10','14:10:00',1.4),('5815','2013-12-10','14:15:00',1.36),('5815','2013-12-10','14:20:00',1.32),('5815','2013-12-10','14:25:00',1.29),('5815','2013-12-10','14:30:00',1.26),('5815','2013-12-10','14:35:00',1.21),('5815','2013-12-10','14:40:00',1.16),('5815','2013-12-10','14:45:00',1.11),('5815','2013-12-10','14:50:00',1.05),('5815','2013-12-10','14:55:00',1.02),('5815','2013-12-09','09:10:00',1.03),('5815','2013-12-09','09:15:00',1.07),('5815','2013-12-09','09:20:00',1.13),('5815','2013-12-09','09:25:00',1.18),('5815','2013-12-09','09:30:00',1.21),('5815','2013-12-09','09:35:00',1.24),('5815','2013-12-09','09:40:00',1.28),('5815','2013-12-09','09:45:00',1.32),('5815','2013-12-09','09:50:00',1.35),('5815','2013-12-09','09:55:00',1.39),('5815','2013-12-09','10:00:00',1.43),('5815','2013-12-09','10:05:00',1.47),('5815','2013-12-09','10:10:00',1.49),('5815','2013-12-09','10:15:00',1.52),('5815','2013-12-09','10:20:00',1.52),('5815','2013-12-09','10:25:00',1.55),('5815','2013-12-09','10:30:00',1.58),('5815','2013-12-09','10:35:00',1.61),('5815','2013-12-09','10:40:00',1.63),('5815','2013-12-09','10:45:00',1.65),('5815','2013-12-09','10:50:00',1.68),('5815','2013-12-09','10:55:00',1.7),('5815','2013-12-09','11:00:00',1.72),('5815','2013-12-09','11:05:00',1.74),('5815','2013-12-09','11:10:00',1.74),('5815','2013-12-09','11:15:00',1.77),('5815','2013-12-09','11:20:00',1.78),('5815','2013-12-09','11:25:00',1.8),('5815','2013-12-09','11:30:00',1.78),('5815','2013-12-09','11:35:00',1.83),('5815','2013-12-09','11:40:00',1.83),('5815','2013-12-09','11:45:00',1.84),('5815','2013-12-09','11:50:00',1.84),('5815','2013-12-09','11:55:00',1.84),('5815','2013-12-09','12:00:00',1.83),('5815','2013-12-09','12:05:00',1.82),('5815','2013-12-09','12:10:00',1.81),('5815','2013-12-09','12:15:00',1.81),('5815','2013-12-09','12:20:00',1.8),('5815','2013-12-09','12:25:00',1.78),('5815','2013-12-09','12:30:00',1.77),('5815','2013-12-09','12:35:00',1.73),('5815','2013-12-09','12:40:00',1.73),('5815','2013-12-09','12:45:00',1.72),('5815','2013-12-09','12:50:00',1.71),('5815','2013-12-09','12:55:00',1.67),('5815','2013-12-09','13:00:00',1.64),('5815','2013-12-09','13:05:00',1.67),('5815','2013-12-09','13:10:00',1.66),('5815','2013-12-09','13:15:00',1.62),('5815','2013-12-09','13:20:00',1.6),('5815','2013-12-09','13:25:00',1.59),('5815','2013-12-09','13:30:00',1.59),('5815','2013-12-09','13:35:00',1.6),('5815','2013-12-09','13:40:00',1.59),('5815','2013-12-09','13:45:00',1.56),('5815','2013-12-09','13:50:00',1.54),('5815','2013-12-09','13:55:00',1.51),('5815','2013-12-09','14:00:00',1.48),('5815','2013-12-09','14:05:00',1.45),('5815','2013-12-09','14:10:00',1.41),('5815','2013-12-09','14:15:00',1.38),('5815','2013-12-09','14:20:00',1.32),('5815','2013-12-09','14:25:00',1.34),('5815','2013-12-09','14:30:00',1.3),('5815','2013-12-09','14:35:00',1.26),('5815','2013-12-09','14:40:00',1.22),('5815','2013-12-09','14:45:00',1.16),('5815','2013-12-09','14:50:00',1.13),('5815','2013-12-09','14:55:00',1.08),('5815','2013-12-09','15:00:00',1.03),('5815','2013-12-08','09:35:00',1.17),('5815','2013-12-08','09:40:00',1.26),('5815','2013-12-08','09:45:00',1.27),('5815','2013-12-08','09:50:00',1.31),('5815','2013-12-08','09:55:00',1.35),('5815','2013-12-08','10:00:00',1.37),('5815','2013-12-08','10:05:00',1.45),('5815','2013-12-08','10:10:00',1.7),('5815','2013-12-08','10:15:00',1.67),('5815','2013-12-08','10:20:00',1.86),('5815','2013-12-08','10:25:00',1.15),('5815','2013-12-08','12:30:00',1.31),('5815','2013-12-08','12:45:00',1.08),('5815','2013-12-08','12:55:00',1.17),('5815','2013-12-08','13:00:00',1.69),('5815','2013-12-08','13:05:00',1.49),('5815','2013-12-08','13:10:00',1.15),('5815','2013-12-08','13:20:00',1.1),('5815','2013-12-07','11:20:00',1.07),('5815','2013-12-07','13:15:00',1.15),('5815','2013-12-07','13:20:00',1.12),('5815','2014-04-20','10:05:00',1.31),('5815','2014-04-20','10:10:00',1.78),('5815','2014-04-20','10:15:00',1.91),('5815','2014-04-20','10:20:00',1.86),('5815','2014-04-20','10:25:00',1.88),('5815','2014-04-20','10:30:00',1.89),('5815','2014-04-20','10:35:00',1.91),('5815','2014-04-20','10:40:00',1.94),('5815','2014-04-20','10:45:00',1.93),('5815','2014-04-20','10:50:00',1.99),('5815','2014-04-20','10:55:00',2.02),('5815','2014-04-20','11:00:00',2.04),('5815','2014-04-20','11:05:00',2.07),('5815','2014-04-20','11:10:00',2.09),('5815','2014-04-20','11:15:00',2.11),('5815','2014-04-20','11:20:00',2.13),('5815','2014-04-20','11:25:00',2.15),('5815','2014-04-20','11:30:00',2.18),('5815','2014-04-20','11:35:00',2.2),('5815','2014-04-20','11:40:00',2.22),('5815','2014-04-20','11:45:00',2.25),('5815','2014-04-20','11:50:00',2.28),('5815','2014-04-20','11:55:00',2.29),('5815','2014-04-20','12:00:00',2.28),('5815','2014-04-20','12:05:00',2.3),('5815','2014-04-20','12:10:00',2.33),('5815','2014-04-20','12:15:00',2.34),('5815','2014-04-20','12:20:00',2.37),('5815','2014-04-20','12:25:00',2.39),('5815','2014-04-20','12:30:00',2.4),('5815','2014-04-20','12:35:00',2.41),('5815','2014-04-20','12:40:00',2.43),('5815','2014-04-20','12:45:00',2.44),('5815','2014-04-20','12:50:00',2.45),('5815','2014-04-20','12:55:00',2.45),('5815','2014-04-20','13:00:00',2.43),('5815','2014-04-20','13:05:00',2.43),('5815','2014-04-20','13:10:00',2.45),('5815','2014-04-20','13:15:00',2.44),('5815','2014-04-20','13:20:00',2.43),('5815','2014-04-20','13:25:00',2.43),('5815','2014-04-20','13:30:00',2.42),('5815','2014-04-20','13:35:00',2.42),('5815','2014-04-20','13:40:00',2.41),('5815','2014-04-20','13:45:00',2.44),('5815','2014-04-20','13:50:00',2.46),('5815','2014-04-20','13:55:00',2.46),('5815','2014-04-20','14:00:00',2.46),('5815','2014-04-20','14:05:00',2.45),('5815','2014-04-20','14:10:00',2.42),('5815','2014-04-20','14:15:00',2.42),('5815','2014-04-20','14:20:00',2.41),('5815','2014-04-20','14:25:00',2.4),('5815','2014-04-20','14:30:00',2.39),('5815','2014-04-20','14:35:00',2.36),('5815','2014-04-20','14:40:00',2.35),('5815','2014-04-20','14:45:00',2.33),('5815','2014-04-20','14:50:00',2.31),('5815','2014-04-20','14:55:00',2.29),('5815','2014-04-20','15:00:00',2.27),('5815','2014-04-20','15:05:00',2.24),('5815','2014-04-20','15:10:00',2.22),('5815','2014-04-20','15:15:00',2.19),('5815','2014-04-20','15:20:00',2.16),('5815','2014-04-20','15:25:00',2.14),('5815','2014-04-20','15:30:00',2.11),('5815','2014-04-20','15:35:00',2.08),('5815','2014-04-20','15:40:00',2.04),('5815','2014-04-20','15:45:00',2.01),('5815','2014-04-20','15:50:00',1.97),('5815','2014-04-20','15:55:00',1.95),('5815','2014-04-20','16:00:00',1.91),('5815','2014-04-20','16:05:00',1.88),('5815','2014-04-20','16:10:00',1.75),('5815','2014-04-20','16:15:00',1.41),('5815','2014-04-20','16:20:00',1.79),('5815','2014-04-20','16:25:00',1.72),('5815','2014-04-20','16:30:00',1.64),('5815','2014-04-20','16:35:00',1.63),('5815','2014-04-20','16:40:00',1.62),('5815','2014-04-20','16:45:00',1.59),('5815','2014-04-20','16:50:00',1.54),('5815','2014-04-20','16:55:00',1.48),('5815','2014-04-20','17:00:00',1.43),('5815','2014-04-20','17:05:00',1.39),('5815','2014-04-20','17:10:00',1.34),('5815','2014-04-20','17:15:00',1.29),('5815','2014-04-20','17:20:00',1.24),('5815','2014-04-20','17:25:00',1.18),('5815','2014-04-20','17:30:00',1.14),('5815','2014-04-20','17:35:00',1.07),('5815','2013-12-06','09:10:00',1.01),('5815','2013-12-06','09:15:00',1.07),('5815','2013-12-06','09:20:00',1.11),('5815','2013-12-06','09:25:00',1.15),('5815','2013-12-06','09:30:00',1.18),('5815','2013-12-06','09:35:00',1.24),('5815','2013-12-06','09:40:00',1.28),('5815','2013-12-06','09:45:00',1.3),('5815','2013-12-06','09:50:00',1.34),('5815','2013-12-06','09:55:00',1.36),('5815','2013-12-06','10:00:00',1.41),('5815','2013-12-06','10:05:00',1.44),('5815','2013-12-06','10:10:00',1.46),('5815','2013-12-06','10:15:00',1.49),('5815','2013-12-06','10:20:00',1.5),('5815','2013-12-06','10:25:00',1.54),('5815','2013-12-06','10:30:00',1.56),('5815','2013-12-06','10:35:00',1.59),('5815','2013-12-06','10:40:00',1.62),('5815','2013-12-06','10:45:00',1.62),('5815','2013-12-06','10:50:00',1.61),('5815','2013-12-06','10:55:00',1.61),('5815','2013-12-06','11:00:00',1.63),('5815','2013-12-06','11:05:00',1.66),('5815','2013-12-06','11:10:00',1.67),('5815','2013-12-06','11:15:00',1.68),('5815','2013-12-06','11:20:00',1.7),('5815','2013-12-06','11:25:00',1.71),('5815','2013-12-06','11:30:00',1.72),('5815','2013-12-06','11:35:00',1.7),('5815','2013-12-06','11:40:00',1.71),('5815','2013-12-06','11:45:00',1.71),('5815','2013-12-06','11:50:00',1.71),('5815','2013-12-06','11:55:00',1.71),('5815','2013-12-06','12:00:00',1.7),('5815','2013-12-06','12:05:00',1.7),('5815','2013-12-06','12:10:00',1.71),('5815','2013-12-06','12:15:00',1.7),('5815','2013-12-06','12:20:00',1.7),('5815','2013-12-06','12:25:00',1.7),('5815','2013-12-06','12:30:00',1.69),('5815','2013-12-06','12:35:00',1.69),('5815','2013-12-06','12:40:00',1.68),('5815','2013-12-06','12:45:00',1.67),('5815','2013-12-06','12:50:00',1.66),('5815','2013-12-06','12:55:00',1.62),('5815','2013-12-06','13:00:00',1.65),('5815','2013-12-06','13:05:00',1.64),('5815','2013-12-06','13:10:00',1.63),('5815','2013-12-06','13:15:00',1.62),('5815','2013-12-06','13:20:00',1.61),('5815','2013-12-06','13:25:00',1.58),('5815','2013-12-06','13:30:00',1.55),('5815','2013-12-06','13:35:00',1.55),('5815','2013-12-06','13:40:00',1.53),('5815','2013-12-06','13:45:00',1.51),('5815','2013-12-06','13:50:00',1.5),('5815','2013-12-06','13:55:00',1.45),('5815','2013-12-06','14:00:00',1.42),('5815','2013-12-06','14:05:00',1.39),('5815','2013-12-06','14:10:00',1.35),('5815','2013-12-06','14:15:00',1.3),('5815','2013-12-06','14:20:00',1.26),('5815','2013-12-06','14:25:00',1.22),('5815','2013-12-06','14:30:00',1.16),('5815','2013-12-06','14:35:00',1.12),('5815','2013-12-06','14:40:00',1.07),('5815','2013-12-06','14:45:00',1.04),('5815','2013-12-05','11:40:00',1.1),('5815','2013-12-05','11:45:00',1.01),('5815','2013-12-05','11:50:00',1.22),('5815','2013-12-05','11:55:00',1.08),('5815','2013-12-05','12:05:00',1.01),('5815','2013-12-05','12:10:00',1.06),('5815','2013-12-05','12:20:00',1.16),('5815','2013-12-05','12:35:00',1.38),('5815','2013-12-05','12:40:00',1.25),('5815','2013-12-04','09:05:00',1.02),('5815','2013-12-04','09:10:00',1.07),('5815','2013-12-04','09:15:00',1.11),('5815','2013-12-04','09:20:00',1.16),('5815','2013-12-04','09:25:00',1.21),('5815','2013-12-04','09:30:00',1.24),('5815','2013-12-04','09:35:00',1.28),('5815','2013-12-04','09:40:00',1.31),('5815','2013-12-04','09:45:00',1.33),('5815','2013-12-04','09:50:00',1.38),('5815','2013-12-04','09:55:00',1.42),('5815','2013-12-04','10:00:00',1.44),('5815','2013-12-04','10:05:00',1.47),('5815','2013-12-04','10:10:00',1.51),('5815','2013-12-04','10:15:00',1.54),('5815','2013-12-04','10:20:00',1.56),('5815','2013-12-04','10:25:00',1.58),('5815','2013-12-04','10:30:00',1.62),('5815','2013-12-04','10:35:00',1.64),('5815','2013-12-04','10:40:00',1.65),('5815','2013-12-04','10:45:00',1.66),('5815','2013-12-04','10:50:00',1.68),('5815','2013-12-04','10:55:00',1.69),('5815','2013-12-04','11:00:00',1.71),('5815','2013-12-04','11:05:00',1.73),('5815','2013-12-04','11:10:00',1.7),('5815','2013-12-04','11:15:00',1.73),('5815','2013-12-04','11:20:00',1.77),('5815','2013-12-04','11:25:00',1.78),('5815','2013-12-04','11:30:00',1.8),('5815','2013-12-04','11:35:00',1.77),('5815','2013-12-04','11:40:00',1.78),('5815','2013-12-04','11:45:00',1.78),('5815','2013-12-04','11:50:00',1.77),('5815','2013-12-04','11:55:00',1.78),('5815','2013-12-04','12:00:00',1.8),('5815','2013-12-04','12:05:00',1.79),('5815','2013-12-04','12:10:00',1.76),('5815','2013-12-04','12:15:00',1.74),('5815','2013-12-04','12:20:00',1.79),('5815','2013-12-04','12:25:00',1.71),('5815','2013-12-04','12:30:00',1.72),('5815','2013-12-04','12:35:00',1.76),('5815','2013-12-04','12:40:00',1.73),('5815','2013-12-04','12:45:00',1.58),('5815','2013-12-04','12:50:00',1.56),('5815','2013-12-04','12:55:00',1.58),('5815','2013-12-04','13:00:00',1.44),('5815','2013-12-04','13:05:00',1.21),('5815','2013-12-04','13:10:00',1.46),('5815','2013-12-04','13:15:00',1.69),('5815','2013-12-04','13:20:00',1.64),('5815','2013-12-04','13:25:00',1.47),('5815','2013-12-04','13:35:00',1.46),('5815','2013-12-04','13:40:00',1.44),('5815','2013-12-04','13:45:00',1.51),('5815','2013-12-04','13:50:00',1.47),('5815','2013-12-04','13:55:00',1.39),('5815','2013-12-04','14:00:00',1.38),('5815','2013-12-04','14:05:00',1.34),('5815','2013-12-04','14:10:00',1.32),('5815','2013-12-04','14:15:00',1.26),('5815','2013-12-04','14:20:00',1.23),('5815','2013-12-04','14:25:00',1.23),('5815','2013-12-04','14:30:00',1.17),('5815','2013-12-04','14:35:00',1.14),('5815','2013-12-04','14:40:00',1.1),('5815','2013-12-04','14:45:00',1.03),('5815','2013-12-04','14:50:00',1.02),('5815','2013-12-03','08:55:00',1.03),('5815','2013-12-03','09:00:00',1.08),('5815','2013-12-03','09:05:00',1.13),('5815','2013-12-03','09:10:00',1.17),('5815','2013-12-03','09:15:00',1.21),('5815','2013-12-03','09:20:00',1.26),('5815','2013-12-03','09:25:00',1.3),('5815','2013-12-03','09:30:00',1.33),('5815','2013-12-03','09:35:00',1.38),('5815','2013-12-03','09:40:00',1.42),('5815','2013-12-03','09:45:00',1.46),('5815','2013-12-03','09:50:00',1.49),('5815','2013-12-03','09:55:00',1.52),('5815','2013-12-03','10:00:00',1.55),('5815','2013-12-03','10:05:00',1.58),('5815','2013-12-03','10:10:00',1.61),('5815','2013-12-03','10:15:00',1.63),('5815','2013-12-03','10:20:00',1.66),('5815','2013-12-03','10:25:00',1.69),('5815','2013-12-03','10:30:00',1.71),('5815','2013-12-03','10:35:00',1.73),('5815','2013-12-03','10:40:00',1.75),('5815','2013-12-03','10:45:00',1.77),('5815','2013-12-03','10:50:00',1.79),('5815','2013-12-03','10:55:00',1.81),('5815','2013-12-03','11:00:00',1.81),('5815','2013-12-03','11:05:00',1.83),('5815','2013-12-03','11:10:00',1.84),('5815','2013-12-03','11:15:00',1.85),('5815','2013-12-03','11:20:00',1.85),('5815','2013-12-03','11:25:00',1.86),('5815','2013-12-03','11:30:00',1.87),('5815','2013-12-03','11:35:00',1.88),('5815','2013-12-03','11:40:00',1.88),('5815','2013-12-03','11:45:00',1.89),('5815','2013-12-03','11:50:00',1.89),('5815','2013-12-03','11:55:00',1.9),('5815','2013-12-03','12:00:00',1.9),('5815','2013-12-03','12:05:00',1.89),('5815','2013-12-03','12:10:00',1.89),('5815','2013-12-03','12:15:00',1.85),('5815','2013-12-03','12:20:00',1.88),('5815','2013-12-03','12:25:00',1.88),('5815','2013-12-03','12:30:00',1.87),('5815','2013-12-03','12:35:00',1.85),('5815','2013-12-03','12:40:00',1.85),('5815','2013-12-03','12:45:00',1.84),('5815','2013-12-03','12:50:00',1.82),('5815','2013-12-03','12:55:00',1.81),('5815','2013-12-03','13:00:00',1.8),('5815','2013-12-03','13:05:00',1.79),('5815','2013-12-03','13:10:00',1.76),('5815','2013-12-03','13:15:00',1.74),('5815','2013-12-03','13:20:00',1.72),('5815','2013-12-03','13:25:00',1.7),('5815','2013-12-03','13:30:00',1.68),('5815','2013-12-03','13:35:00',1.66),('5815','2013-12-03','13:40:00',1.62),('5815','2013-12-03','13:45:00',1.6),('5815','2013-12-03','13:50:00',1.58),('5815','2013-12-03','13:55:00',1.55),('5815','2013-12-03','14:00:00',1.52),('5815','2013-12-03','14:05:00',1.49),('5815','2013-12-03','14:10:00',1.47),('5815','2013-12-03','14:15:00',1.42),('5815','2013-12-03','14:20:00',1.39),('5815','2013-12-03','14:25:00',1.34),('5815','2013-12-03','14:30:00',1.3),('5815','2013-12-03','14:35:00',1.28),('5815','2013-12-03','14:40:00',1.25),('5815','2013-12-03','14:45:00',1.2),('5815','2013-12-03','14:50:00',1.15),('5815','2013-12-03','14:55:00',1.11),('5815','2013-12-03','15:00:00',1.05),('5815','2013-12-03','15:05:00',1),('5815','2013-12-02','09:40:00',1.04),('5815','2013-12-02','09:45:00',1.14),('5815','2013-12-02','09:50:00',1.26),('5815','2013-12-02','09:55:00',1.25),('5815','2013-12-02','10:00:00',1.56),('5815','2013-12-02','10:05:00',1.56),('5815','2013-12-02','10:10:00',1.61),('5815','2013-12-02','10:15:00',1.63),('5815','2013-12-02','10:20:00',1.65),('5815','2013-12-02','10:25:00',1.68),('5815','2013-12-02','10:30:00',1.7),('5815','2013-12-02','10:35:00',1.72),('5815','2013-12-02','10:40:00',1.74),('5815','2013-12-02','10:45:00',1.75),('5815','2013-12-02','10:50:00',1.78),('5815','2013-12-02','10:55:00',1.79),('5815','2013-12-02','11:00:00',1.84),('5815','2013-12-02','11:05:00',1.87),('5815','2013-12-02','11:10:00',1.89),('5815','2013-12-02','11:15:00',1.9),('5815','2013-12-02','11:20:00',1.91),('5815','2013-12-02','11:25:00',1.9),('5815','2013-12-02','11:30:00',1.9),('5815','2013-12-02','11:35:00',1.9),('5815','2013-12-02','11:40:00',1.91),('5815','2013-12-02','11:45:00',1.92),('5815','2013-12-02','11:50:00',1.92),('5815','2013-12-02','11:55:00',1.93),('5815','2013-12-02','12:00:00',1.93),('5815','2013-12-02','12:05:00',1.94),('5815','2013-12-02','12:10:00',1.91),('5815','2013-12-02','12:15:00',1.95),('5815','2013-12-02','12:20:00',1.95),('5815','2013-12-02','12:25:00',1.96),('5815','2013-12-02','12:30:00',1.97),('5815','2013-12-02','12:35:00',1.99),('5815','2013-12-02','12:40:00',2),('5815','2013-12-02','12:45:00',2.03),('5815','2013-12-02','12:50:00',2.08),('5815','2013-12-02','12:55:00',2.12),('5815','2013-12-02','13:00:00',2.14),('5815','2013-12-02','13:05:00',2.18),('5815','2013-12-02','13:10:00',2.17),('5815','2013-12-02','13:15:00',2.08),('5815','2013-12-02','13:20:00',2.07),('5815','2013-12-02','13:25:00',1.98),('5815','2013-12-02','13:30:00',1.94),('5815','2013-12-02','13:35:00',1.89),('5815','2013-12-02','13:40:00',1.8),('5815','2013-12-02','13:45:00',1.76),('5815','2013-12-02','13:50:00',1.72),('5815','2013-12-02','13:55:00',1.65),('5815','2013-12-02','14:00:00',1.63),('5815','2013-12-02','14:05:00',1.55),('5815','2013-12-02','14:10:00',1.47),('5815','2013-12-02','14:15:00',1.39),('5815','2013-12-02','14:20:00',1.18),('5815','2013-12-02','14:25:00',1.1),('5815','2013-12-02','14:30:00',1.21),('5815','2013-12-02','14:35:00',1.27),('5815','2013-12-02','14:40:00',1.23),('5815','2013-12-02','14:45:00',1.18),('5815','2013-12-02','14:50:00',1.13),('5815','2013-12-02','14:55:00',1.06),('5815','2013-12-02','15:00:00',1.02),('5815','2013-11-29','09:15:00',1.09),('5815','2013-11-29','09:20:00',1.22),('5815','2013-11-29','09:25:00',1.2),('5815','2013-11-29','09:30:00',1.11),('5815','2013-11-29','09:35:00',1.26),('5815','2013-11-29','09:40:00',1.43),('5815','2013-11-29','09:45:00',1.19),('5815','2013-11-28','08:55:00',1.03),('5815','2013-11-28','09:00:00',1.08),('5815','2013-11-28','09:05:00',1.13),('5815','2013-11-28','09:10:00',1.17),('5815','2013-11-28','09:15:00',1.22),('5815','2013-11-28','09:20:00',1.27),('5815','2013-11-28','09:25:00',1.3),('5815','2013-11-28','09:30:00',1.35),('5815','2013-11-28','09:35:00',1.39),('5815','2013-11-28','09:40:00',1.44),('5815','2013-11-28','09:45:00',1.47),('5815','2013-11-28','09:50:00',1.51),('5815','2013-11-28','09:55:00',1.55),('5815','2013-11-28','10:00:00',1.57),('5815','2013-11-28','10:05:00',1.61),('5815','2013-11-28','10:10:00',1.64),('5815','2013-11-28','10:15:00',1.66),('5815','2013-11-28','10:20:00',1.69),('5815','2013-11-28','10:25:00',1.71),('5815','2013-11-28','10:30:00',1.74),('5815','2013-11-28','10:35:00',1.76),('5815','2013-11-28','10:40:00',1.77),('5815','2013-11-28','10:45:00',1.81),('5815','2013-11-28','10:50:00',1.83),('5815','2013-11-28','10:55:00',1.85),('5815','2013-11-28','11:00:00',1.86),('5815','2013-11-28','11:05:00',1.88),('5815','2013-11-28','11:10:00',1.89),('5815','2013-11-28','11:15:00',1.9),('5815','2013-11-28','11:20:00',1.92),('5815','2013-11-28','11:25:00',1.93),('5815','2013-11-28','11:30:00',1.94),('5815','2013-11-28','11:35:00',1.94),('5815','2013-11-28','11:40:00',1.95),('5815','2013-11-28','11:45:00',1.95),('5815','2013-11-28','11:50:00',1.95),('5815','2013-11-28','11:55:00',1.95),('5815','2013-11-28','12:00:00',1.96),('5815','2013-11-28','12:05:00',1.95),('5815','2013-11-28','12:10:00',1.93),('5815','2013-11-28','12:15:00',1.94),('5815','2013-11-28','12:20:00',1.93),('5815','2013-11-28','12:25:00',1.92),('5815','2013-11-28','12:30:00',1.92),('5815','2013-11-28','12:35:00',1.91),('5815','2013-11-28','12:40:00',1.91),('5815','2013-11-28','12:45:00',1.9),('5815','2013-11-28','12:50:00',1.89),('5815','2013-11-28','12:55:00',1.88),('5815','2013-11-28','13:00:00',1.85),('5815','2013-11-28','13:05:00',1.83),('5815','2013-11-28','13:10:00',1.82),('5815','2013-11-28','13:15:00',1.79),('5815','2013-11-28','13:20:00',1.77),('5815','2013-11-28','13:25:00',1.73),('5815','2013-11-28','13:30:00',1.71),('5815','2013-11-28','13:35:00',1.69),('5815','2013-11-28','13:40:00',1.67),('5815','2013-11-28','13:45:00',1.64),('5815','2013-11-28','13:50:00',1.62),('5815','2013-11-28','13:55:00',1.57),('5815','2013-11-28','14:00:00',1.54),('5815','2013-11-28','14:05:00',1.5),('5815','2013-11-28','14:10:00',1.47),('5815','2013-11-28','14:15:00',1.43),('5815','2013-11-28','14:20:00',1.39),('5815','2013-11-28','14:25:00',1.35),('5815','2013-11-28','14:30:00',1.31),('5815','2013-11-28','14:35:00',1.27),('5815','2013-11-28','14:40:00',1.21),('5815','2013-11-28','14:45:00',1.17),('5815','2013-11-28','14:50:00',1.13),('5815','2013-11-28','14:55:00',1.06),('5815','2013-11-28','15:00:00',1.03),('5815','2014-04-19','08:25:00',1.15),('5815','2014-04-19','08:30:00',1.23),('5815','2014-04-19','08:35:00',1.24),('5815','2014-04-19','08:40:00',1.03),('5815','2014-04-19','08:50:00',1.11),('5815','2014-04-19','09:15:00',1.36),('5815','2014-04-19','09:20:00',1.5),('5815','2014-04-19','09:25:00',1.64),('5815','2014-04-19','09:30:00',1.87),('5815','2014-04-19','09:35:00',1.7),('5815','2014-04-19','09:55:00',1.05),('5815','2014-04-19','10:00:00',1.25),('5815','2014-04-19','10:05:00',1.78),('5815','2014-04-19','10:10:00',1.44),('5815','2014-04-19','10:15:00',1.57),('5815','2014-04-19','10:20:00',1.62),('5815','2014-04-19','10:25:00',1.48),('5815','2014-04-19','10:30:00',1.4),('5815','2014-04-19','10:35:00',1.49),('5815','2014-04-19','10:40:00',1.46),('5815','2014-04-19','10:45:00',1.46),('5815','2014-04-19','10:50:00',1.64),('5815','2014-04-19','10:55:00',1.79),('5815','2014-04-19','11:00:00',1.95),('5815','2014-04-19','11:05:00',1.92),('5815','2014-04-19','11:10:00',1.79),('5815','2014-04-19','11:15:00',1.96),('5815','2014-04-19','11:20:00',1.95),('5815','2014-04-19','11:25:00',1.85),('5815','2014-04-19','11:30:00',2.4),('5815','2014-04-19','11:35:00',2.52),('5815','2014-04-19','11:40:00',1.9),('5815','2014-04-19','11:45:00',2.23),('5815','2014-04-19','11:50:00',2.17),('5815','2014-04-19','12:00:00',1.72),('5815','2014-04-19','12:05:00',1.51),('5815','2014-04-19','12:10:00',1.93),('5815','2014-04-19','12:15:00',2.05),('5815','2014-04-19','12:25:00',2.08),('5815','2014-04-19','12:30:00',2.67),('5815','2014-04-19','12:35:00',2.52),('5815','2014-04-19','12:40:00',2.52),('5815','2014-04-19','12:45:00',2.53),('5815','2014-04-19','12:50:00',2.56),('5815','2014-04-19','12:55:00',2.58),('5815','2014-04-19','13:00:00',2.61),('5815','2014-04-19','13:05:00',2.61),('5815','2014-04-19','13:10:00',2.68),('5815','2014-04-19','13:15:00',2.6),('5815','2014-04-19','13:20:00',2.56),('5815','2014-04-19','13:25:00',2.55),('5815','2014-04-19','13:30:00',2.56),('5815','2014-04-19','13:35:00',2.57),('5815','2014-04-19','13:40:00',2.57),('5815','2014-04-19','13:45:00',2.56),('5815','2014-04-19','13:50:00',2.55),('5815','2014-04-19','13:55:00',2.53),('5815','2014-04-19','14:00:00',2.52),('5815','2014-04-19','14:05:00',2.52),('5815','2014-04-19','14:10:00',2.53),('5815','2014-04-19','14:15:00',2.61),('5815','2014-04-19','14:20:00',2.16),('5815','2014-04-19','14:25:00',1.85),('5815','2014-04-19','14:30:00',1.8),('5815','2014-04-19','14:35:00',1.43),('5815','2014-04-19','14:40:00',1.41),('5815','2014-04-19','14:45:00',1.52),('5815','2014-04-19','14:50:00',1.45),('5815','2014-04-19','14:55:00',1.65),('5815','2014-04-19','15:00:00',2.08),('5815','2014-04-19','15:05:00',2.24),('5815','2014-04-19','15:10:00',2.14),('5815','2014-04-19','15:15:00',2.31),('5815','2014-04-19','15:20:00',2.21),('5815','2014-04-19','15:25:00',2.21),('5815','2014-04-19','15:30:00',2.18),('5815','2014-04-19','15:35:00',2.15),('5815','2014-04-19','15:40:00',2.16),('5815','2014-04-19','15:45:00',1.95),('5815','2014-04-19','15:50:00',1.5),('5815','2014-04-19','15:55:00',2.09),('5815','2014-04-19','16:00:00',2),('5815','2014-04-19','16:05:00',1.97),('5815','2014-04-19','16:10:00',1.94),('5815','2014-04-19','16:15:00',1.92),('5815','2014-04-19','16:20:00',1.93),('5815','2014-04-19','16:25:00',1.59),('5815','2014-04-19','16:30:00',1.88),('5815','2014-04-19','16:35:00',1.66),('5815','2014-04-19','16:40:00',1.63),('5815','2014-04-19','16:45:00',1.43),('5815','2014-04-19','16:50:00',1.64),('5815','2014-04-19','16:55:00',1.62),('5815','2014-04-19','17:00:00',1.53),('5815','2014-04-19','17:05:00',1.46),('5815','2014-04-19','17:10:00',1.37),('5815','2014-04-19','17:15:00',1.31),('5815','2014-04-19','17:20:00',1.25),('5815','2014-04-19','17:25:00',1.2),('5815','2014-04-19','17:30:00',1.14),('5815','2014-04-19','17:35:00',1.06),('5815','2013-11-26','11:10:00',1.13),('5815','2013-11-26','11:30:00',1.28),('5815','2013-11-26','11:35:00',1.32),('5815','2013-11-26','11:50:00',1.23),('5815','2013-11-26','11:55:00',2.07),('5815','2013-11-26','12:00:00',2.17),('5815','2013-11-26','12:05:00',1.7),('5815','2013-11-26','12:15:00',1.36),('5815','2013-11-26','12:20:00',2),('5815','2013-11-26','12:30:00',1.55),('5815','2013-11-26','12:35:00',1.06),('5815','2013-11-25','09:40:00',1.3),('5815','2013-11-25','09:50:00',1.02),('5815','2013-11-25','09:55:00',1.29),('5815','2013-11-25','10:00:00',1.19),('5815','2013-11-25','10:05:00',1.47),('5815','2013-11-25','10:25:00',1.22),('5815','2013-11-25','10:30:00',1.76),('5815','2013-11-25','10:35:00',1.94),('5815','2013-11-25','10:40:00',1.94),('5815','2013-11-25','10:45:00',1.95),('5815','2013-11-25','10:50:00',1.99),('5815','2013-11-25','10:55:00',2.02),('5815','2013-11-25','11:00:00',2.14),('5815','2013-11-25','11:05:00',1.62),('5815','2013-11-25','11:10:00',2.2),('5815','2013-11-25','11:15:00',2.4),('5815','2013-11-25','11:20:00',2.27),('5815','2013-11-25','11:25:00',2.28),('5815','2013-11-25','11:30:00',2.31),('5815','2013-11-25','11:35:00',2.33),('5815','2013-11-25','11:40:00',2.22),('5815','2013-11-25','11:45:00',2.08),('5815','2013-11-25','11:50:00',1.87),('5815','2013-11-25','12:05:00',1.01),('5815','2013-11-25','12:15:00',1.05),('5815','2013-11-25','12:20:00',2.16),('5815','2013-11-25','12:25:00',2.1),('5815','2013-11-25','12:30:00',2.06),('5815','2013-11-25','12:35:00',2.06),('5815','2013-11-25','12:40:00',2.07),('5815','2013-11-25','12:45:00',2.05),('5815','2013-11-25','12:50:00',2.04),('5815','2013-11-25','12:55:00',2.04),('5815','2013-11-25','13:00:00',2.02),('5815','2013-11-25','13:05:00',2),('5815','2013-11-25','13:10:00',1.99),('5815','2013-11-25','13:15:00',1.97),('5815','2013-11-25','13:20:00',1.95),('5815','2013-11-25','13:25:00',1.92),('5815','2013-11-25','13:30:00',1.89),('5815','2013-11-25','13:35:00',1.86),('5815','2013-11-25','13:40:00',1.84),('5815','2013-11-25','13:45:00',1.82),('5815','2013-11-25','13:50:00',1.83),('5815','2013-11-25','13:55:00',1.77),('5815','2013-11-25','14:00:00',1.67),('5815','2013-11-25','14:05:00',1.26),('5815','2013-11-25','14:10:00',1.97),('5815','2013-11-25','14:15:00',2.05),('5815','2013-11-25','14:20:00',1.78),('5815','2013-11-25','14:25:00',1.08),('5815','2013-11-25','14:30:00',1.06),('5815','2013-11-25','14:35:00',1.27),('5815','2013-11-25','14:40:00',1.35),('5815','2013-11-25','14:45:00',1.39),('5815','2013-11-25','14:50:00',1.53),('5815','2013-11-25','14:55:00',1.57),('5815','2013-11-25','15:00:00',1.48),('5815','2013-11-25','15:05:00',1.34),('5815','2013-11-25','15:10:00',1.18),('5815','2013-11-25','15:15:00',1.09),('5815','2013-11-25','15:20:00',1.02),('5815','2013-11-24','08:40:00',1.02),('5815','2013-11-24','08:45:00',1.11),('5815','2013-11-24','08:50:00',1.19),('5815','2013-11-24','08:55:00',1.29),('5815','2013-11-24','09:00:00',1.41),('5815','2013-11-24','09:05:00',1.46),('5815','2013-11-24','09:10:00',1.48),('5815','2013-11-24','09:15:00',1.54),('5815','2013-11-24','09:20:00',1.62),('5815','2013-11-24','09:25:00',1.67),('5815','2013-11-24','09:30:00',1.51),('5815','2013-11-24','09:35:00',1.48),('5815','2013-11-24','09:40:00',1.27),('5815','2013-11-24','10:15:00',1.02),('5815','2013-11-24','10:20:00',1.08),('5815','2013-11-24','10:25:00',1.07),('5815','2013-11-24','10:30:00',1.51),('5815','2013-11-24','10:35:00',2.29),('5815','2013-11-24','10:40:00',2.18),('5815','2013-11-24','10:45:00',1.96),('5815','2013-11-24','10:50:00',1.71),('5815','2013-11-24','10:55:00',1.69),('5815','2013-11-24','11:00:00',1.92),('5815','2013-11-24','11:05:00',2.04),('5815','2013-11-24','11:10:00',2.29),('5815','2013-11-24','11:15:00',1.23),('5815','2013-11-24','11:20:00',1.04),('5815','2013-11-24','11:50:00',1.12),('5815','2013-11-24','11:55:00',1.37),('5815','2013-11-24','12:10:00',1.37),('5815','2013-11-24','12:15:00',1.07),('5815','2013-11-24','12:40:00',1.97),('5815','2013-11-24','12:45:00',2.02),('5815','2013-11-24','12:50:00',1.41),('5815','2013-11-24','12:55:00',1.78),('5815','2013-11-24','13:00:00',2.28),('5815','2013-11-24','13:05:00',2.25),('5815','2013-11-24','13:10:00',1.34),('5815','2013-11-24','13:15:00',1.36),('5815','2013-11-24','13:20:00',1.46),('5815','2013-11-23','10:25:00',1.05),('5815','2013-11-23','10:30:00',1.1),('5815','2013-11-22','10:30:00',1.09),('5815','2013-11-22','10:40:00',1.73),('5815','2013-11-20','09:45:00',1.41),('5815','2013-11-20','09:50:00',1.37),('5815','2013-11-20','09:55:00',1.2),('5815','2013-11-20','10:00:00',1.01),('5815','2013-11-20','10:05:00',1.7),('5815','2013-11-20','10:10:00',1.57),('5815','2013-11-20','10:15:00',1.76),('5815','2013-11-20','10:20:00',1.76),('5815','2013-11-20','10:25:00',1.24),('5815','2013-11-20','10:30:00',1.53),('5815','2013-11-20','10:35:00',1.77),('5815','2013-11-20','10:40:00',1.87),('5815','2013-11-20','10:45:00',1.46),('5815','2013-11-20','11:25:00',1.39),('5815','2013-11-20','11:30:00',1.97),('5815','2013-11-20','11:35:00',1.2),('5815','2013-11-20','11:40:00',2.04),('5815','2013-11-20','11:45:00',1.57),('5815','2013-11-20','11:50:00',2.04),('5815','2013-11-20','11:55:00',2.02),('5815','2013-11-20','12:00:00',1.41),('5815','2013-11-20','12:05:00',1.98),('5815','2013-11-20','12:10:00',2.05),('5815','2013-11-20','12:15:00',2.05),('5815','2013-11-20','12:20:00',2.04),('5815','2013-11-20','12:25:00',2.08),('5815','2013-11-20','12:30:00',2.17),('5815','2013-11-20','12:35:00',2.2),('5815','2013-11-20','12:40:00',2.27),('5815','2013-11-20','12:45:00',2.14),('5815','2013-11-20','12:50:00',2.07),('5815','2013-11-20','12:55:00',2.27),('5815','2013-11-20','13:00:00',2.23),('5815','2013-11-20','13:05:00',1.93),('5815','2013-11-20','13:10:00',1.25),('5815','2013-11-20','13:15:00',1.92),('5815','2013-11-20','13:20:00',2.02),('5815','2013-11-20','13:25:00',1.66),('5815','2013-11-20','13:40:00',1.23),('5815','2013-11-20','13:45:00',1.9),('5815','2013-11-20','13:55:00',1.66),('5815','2013-11-20','14:00:00',1.74),('5815','2013-11-20','14:40:00',1.34),('5815','2013-11-20','14:45:00',1.28),('5815','2013-11-20','14:50:00',1.2),('5815','2013-11-20','14:55:00',1),('5815','2013-11-20','15:00:00',1.11),('5815','2013-11-20','15:05:00',1.05),('5815','2013-11-20','15:10:00',1),('5815','2013-11-19','09:15:00',1.26),('5815','2013-11-19','09:20:00',1.27),('5815','2013-11-19','09:25:00',1.42),('5815','2013-11-19','09:30:00',1.46),('5815','2013-11-19','10:00:00',1.07),('5815','2013-11-19','10:15:00',1.21),('5815','2013-11-19','11:45:00',2.11),('5815','2013-11-19','11:50:00',2.19),('5815','2013-11-19','12:20:00',1.66),('5815','2013-11-19','12:55:00',1.11),('5815','2013-11-19','13:00:00',1.5),('5815','2013-11-19','13:05:00',1.31),('5815','2013-11-19','13:20:00',1.05),('5815','2013-11-19','13:40:00',1.27),('5815','2013-11-19','13:50:00',1.46),('5815','2013-11-19','14:45:00',1.02),('5815','2013-11-19','15:10:00',1.13),('5815','2013-11-18','09:40:00',1.41),('5815','2013-11-18','09:45:00',1.39),('5815','2013-11-18','10:05:00',1.01),('5815','2013-11-18','11:20:00',1.64),('5815','2013-11-18','11:25:00',1.46),('5815','2013-11-18','11:30:00',1.75),('5815','2013-11-18','11:35:00',1.83),('5815','2013-11-18','11:40:00',1.8),('5815','2013-11-18','11:45:00',1.78),('5815','2013-11-18','11:50:00',1.8),('5815','2013-11-18','11:55:00',1.82),('5815','2013-11-18','12:00:00',1.71),('5815','2013-11-18','12:05:00',1.65),('5815','2013-11-18','12:10:00',1.83),('5815','2013-11-18','12:15:00',1.85),('5815','2013-11-18','12:20:00',1.15),('5815','2013-11-18','12:45:00',1.46),('5815','2013-11-18','12:55:00',2.12),('5815','2013-11-18','13:00:00',1.73),('5815','2013-11-18','13:15:00',1.38),('5815','2013-11-18','13:20:00',1.76),('5815','2013-11-18','15:30:00',1.19),('5815','2013-11-17','09:20:00',1.04),('5815','2013-11-17','09:25:00',1.08),('5815','2013-11-17','09:30:00',1.01),('5815','2013-11-17','09:35:00',1.35),('5815','2013-11-17','09:40:00',1.07),('5815','2013-11-17','10:15:00',1.11),('5815','2013-11-17','12:25:00',1.03),('5815','2014-04-18','08:35:00',1.21),('5815','2014-04-18','08:40:00',1.13),('5815','2014-04-18','08:45:00',1.03),('5815','2014-04-18','09:30:00',1.18),('5815','2014-04-18','09:35:00',1.2),('5815','2014-04-18','11:20:00',1.78),('5815','2014-04-18','11:25:00',1.51),('5815','2014-04-18','11:30:00',1.53),('5815','2014-04-18','11:35:00',1.34),('5815','2014-04-18','11:40:00',1.58),('5815','2014-04-18','11:45:00',1.18),('5815','2014-04-18','14:45:00',1.03),('5815','2014-04-18','15:50:00',1.52),('5815','2014-04-18','15:55:00',1.92),('5815','2014-04-18','16:00:00',1.04),('5815','2014-04-18','16:20:00',1.07),('5815','2014-04-18','16:25:00',1.08),('5815','2014-04-18','16:30:00',1.67),('5815','2013-11-16','08:55:00',1.41),('5815','2013-11-16','09:00:00',1.31),('5815','2013-11-16','09:05:00',1.25),('5815','2013-11-16','09:10:00',1.27),('5815','2013-11-16','09:15:00',1.3),('5815','2013-11-16','09:20:00',1.14),('5815','2013-11-16','09:25:00',1.4),('5815','2013-11-16','09:30:00',1.43),('5815','2013-11-16','09:35:00',1.44),('5815','2013-11-16','09:40:00',1.48),('5815','2013-11-16','09:45:00',1.49),('5815','2013-11-16','09:50:00',1.53),('5815','2013-11-16','09:55:00',1.56),('5815','2013-11-16','10:00:00',1.59),('5815','2013-11-16','10:05:00',1.62),('5815','2013-11-16','10:10:00',1.65),('5815','2013-11-16','10:15:00',1.68),('5815','2013-11-16','10:20:00',1.69),('5815','2013-11-16','10:25:00',1.71),('5815','2013-11-16','10:30:00',1.73),('5815','2013-11-16','10:35:00',1.74),('5815','2013-11-16','10:40:00',1.76),('5815','2013-11-16','10:45:00',1.78),('5815','2013-11-16','10:50:00',1.79),('5815','2013-11-16','10:55:00',1.8),('5815','2013-11-16','11:00:00',1.8),('5815','2013-11-16','11:05:00',1.82),('5815','2013-11-16','11:10:00',1.83),('5815','2013-11-16','11:15:00',1.84),('5815','2013-11-16','11:20:00',1.85),('5815','2013-11-16','11:25:00',1.85),('5815','2013-11-16','11:30:00',1.85),('5815','2013-11-16','11:35:00',1.86),('5815','2013-11-16','11:40:00',1.87),('5815','2013-11-16','11:45:00',1.87),('5815','2013-11-16','11:50:00',1.87),('5815','2013-11-16','11:55:00',1.88),('5815','2013-11-16','12:00:00',1.84),('5815','2013-11-16','12:05:00',1.85),('5815','2013-11-16','12:10:00',1.85),('5815','2013-11-16','12:15:00',1.85),('5815','2013-11-16','12:20:00',1.85),('5815','2013-11-16','12:25:00',1.84),('5815','2013-11-16','12:30:00',1.82),('5815','2013-11-16','12:35:00',1.83),('5815','2013-11-16','12:40:00',1.82),('5815','2013-11-16','12:45:00',1.81),('5815','2013-11-16','12:50:00',1.79),('5815','2013-11-16','12:55:00',1.77),('5815','2013-11-16','13:00:00',1.76),('5815','2013-11-16','13:05:00',1.72),('5815','2013-11-16','13:10:00',1.73),('5815','2013-11-16','13:15:00',1.72),('5815','2013-11-16','13:20:00',1.7),('5815','2013-11-16','13:25:00',1.68),('5815','2013-11-16','13:30:00',1.43),('5815','2013-11-16','13:35:00',1.48),('5815','2013-11-16','14:00:00',1.09),('5815','2013-11-16','14:05:00',1.32),('5815','2013-11-16','14:10:00',1.42),('5815','2013-11-16','14:15:00',1.4),('5815','2013-11-16','14:20:00',1.37),('5815','2013-11-16','14:25:00',1.32),('5815','2013-11-16','14:30:00',1.23),('5815','2013-11-16','14:35:00',1.2),('5815','2013-11-16','14:40:00',1.12),('5815','2013-11-16','14:45:00',1.15),('5815','2013-11-16','14:50:00',1.14),('5815','2013-11-16','14:55:00',1.08),('5815','2013-11-14','10:55:00',1.18),('5815','2013-11-14','11:20:00',1.05),('5815','2013-11-14','11:25:00',1.71),('5815','2013-11-14','11:30:00',1),('5815','2013-11-14','11:35:00',1.03),('5815','2013-11-14','11:40:00',1.19),('5815','2013-11-14','12:25:00',1.19),('5815','2013-11-14','12:30:00',1.04),('5815','2013-11-14','12:55:00',1.04),('5815','2013-11-14','13:45:00',1.07),('5815','2013-11-14','13:50:00',1.13),('5815','2013-11-13','09:20:00',1.37),('5815','2013-11-13','09:25:00',1.37),('5815','2013-11-13','09:30:00',1.39),('5815','2013-11-13','09:35:00',1.43),('5815','2013-11-13','09:40:00',1.45),('5815','2013-11-13','09:45:00',1.44),('5815','2013-11-13','09:50:00',1.17),('5815','2013-11-13','10:05:00',1.23),('5815','2013-11-13','10:15:00',1.68),('5815','2013-11-13','10:20:00',1.71),('5815','2013-11-13','10:25:00',1.7),('5815','2013-11-13','10:30:00',1.7),('5815','2013-11-13','10:35:00',1.7),('5815','2013-11-13','10:40:00',1.73),('5815','2013-11-13','10:45:00',1.74),('5815','2013-11-13','10:50:00',1.76),('5815','2013-11-13','10:55:00',1.75),('5815','2013-11-13','11:00:00',1.75),('5815','2013-11-13','11:05:00',1.82),('5815','2013-11-13','11:10:00',1.87),('5815','2013-11-13','11:15:00',1.91),('5815','2013-11-13','11:20:00',1.92),('5815','2013-11-13','11:25:00',1.95),('5815','2013-11-13','11:30:00',1.96),('5815','2013-11-13','11:35:00',1.9),('5815','2013-11-13','11:40:00',1.64),('5815','2013-11-13','11:45:00',1.06),('5815','2013-11-13','11:50:00',1.13),('5815','2013-11-13','11:55:00',1.69),('5815','2013-11-13','12:00:00',1.37),('5815','2013-11-13','12:15:00',1.05),('5815','2013-11-12','10:30:00',1.05),('5815','2013-11-12','10:35:00',2.02),('5815','2013-11-12','10:40:00',1.82),('5815','2013-11-12','10:45:00',1.75),('5815','2013-11-12','10:50:00',2.31),('5815','2013-11-12','10:55:00',2.16),('5815','2013-11-12','11:00:00',2.12),('5815','2013-11-12','13:55:00',1.18),('5815','2013-11-12','14:00:00',1.35),('5815','2013-11-12','14:05:00',1.31),('5815','2013-11-12','14:10:00',1.13),('5815','2013-11-12','14:15:00',1.22),('5815','2013-11-12','14:20:00',1.07),('5815','2013-11-12','14:25:00',1.12),('5815','2013-11-12','14:30:00',1.06),('5815','2013-11-11','11:40:00',1.7),('5815','2013-11-11','11:45:00',1.01),('5815','2013-11-11','12:00:00',1.86),('5815','2013-11-11','12:30:00',2.49),('5815','2013-11-11','12:35:00',1.9),('5815','2013-11-11','12:40:00',1.18),('5815','2013-11-11','12:45:00',1.12),('5815','2013-11-11','12:55:00',1.17),('5815','2013-11-11','13:00:00',1.15),('5815','2013-11-11','13:05:00',1.35),('5815','2013-11-11','13:10:00',1.63),('5815','2013-11-11','13:15:00',2.48),('5815','2013-11-11','13:20:00',1.9),('5815','2013-11-11','13:25:00',1.49),('5815','2013-11-11','13:30:00',1.12),('5815','2013-11-11','13:35:00',1.45),('5815','2013-11-11','13:40:00',2.22),('5815','2013-11-11','13:45:00',1.15),('5815','2013-11-11','14:10:00',1.09),('5815','2013-11-11','14:15:00',1.86),('5815','2013-11-11','14:20:00',1.88),('5815','2013-11-11','14:25:00',1.81),('5815','2013-11-11','14:30:00',1.46),('5815','2013-11-11','14:35:00',1.16),('5815','2013-11-11','14:40:00',1.53),('5815','2013-11-11','14:45:00',1.31),('5815','2013-11-11','14:50:00',1.11),('5815','2013-11-10','10:15:00',1.26),('5815','2013-11-10','10:20:00',1.99),('5815','2013-11-10','10:25:00',1.05),('5815','2013-11-10','11:10:00',1.48),('5815','2013-11-10','11:15:00',1.23),('5815','2013-11-10','11:20:00',1.05),('5815','2013-11-10','11:25:00',2.19),('5815','2013-11-10','11:35:00',1.83),('5815','2013-11-10','11:40:00',2.4),('5815','2013-11-10','11:45:00',2.41),('5815','2013-11-10','11:50:00',2.46),('5815','2013-11-10','11:55:00',2.28),('5815','2013-11-10','12:00:00',2.17),('5815','2013-11-10','12:05:00',2.13),('5815','2013-11-10','12:10:00',2.11),('5815','2013-11-10','12:15:00',2.12),('5815','2013-11-10','12:20:00',2.01),('5815','2013-11-10','12:25:00',1.69),('5815','2013-11-10','12:30:00',2.1),('5815','2013-11-10','12:35:00',1.15),('5815','2013-11-10','12:40:00',1.5),('5815','2013-11-10','12:45:00',1.16),('5815','2013-11-10','13:10:00',2),('5815','2013-11-10','13:15:00',1.39),('5815','2013-11-10','13:35:00',1.11),('5815','2013-11-10','13:40:00',1.19),('5815','2013-11-10','14:15:00',1.3),('5815','2013-11-10','14:20:00',1.63),('5815','2013-11-10','14:25:00',1.6),('5815','2013-11-10','14:30:00',1.52),('5815','2013-11-10','14:35:00',1.47),('5815','2013-11-10','14:40:00',1.25),('5815','2013-11-09','08:50:00',1.01),('5815','2013-11-09','08:55:00',1.25),('5815','2013-11-09','09:15:00',1.01),('5815','2013-11-09','09:20:00',1.32),('5815','2013-11-09','09:25:00',1.46),('5815','2013-11-09','09:30:00',1.3),('5815','2013-11-09','09:35:00',1.31),('5815','2013-11-09','09:40:00',1.39),('5815','2013-11-09','09:45:00',1.53),('5815','2013-11-09','09:50:00',1.59),('5815','2013-11-09','09:55:00',1.66),('5815','2013-11-09','10:00:00',1.61),('5815','2013-11-09','10:05:00',1.79),('5815','2013-11-09','10:10:00',1.83),('5815','2013-11-09','10:15:00',1.83),('5815','2013-11-09','10:20:00',1.68),('5815','2013-11-09','10:25:00',1.88),('5815','2013-11-09','10:30:00',2.01),('5815','2013-11-09','10:35:00',1.81),('5815','2013-11-09','10:40:00',1.49),('5815','2013-11-09','10:45:00',1.46),('5815','2013-11-09','10:50:00',1.61),('5815','2013-11-09','10:55:00',1.65),('5815','2013-11-09','11:00:00',1.53),('5815','2013-11-09','11:05:00',1.19),('5815','2013-11-09','11:45:00',1.29),('5815','2013-11-09','11:50:00',1.01),('5815','2013-11-09','12:10:00',1.21),('5815','2013-11-09','12:15:00',2.06),('5815','2013-11-09','12:20:00',2.09),('5815','2013-11-09','12:25:00',1.92),('5815','2013-11-09','12:30:00',1.42),('5815','2013-11-09','12:35:00',1.17),('5815','2013-11-09','12:40:00',2.11),('5815','2013-11-09','12:45:00',2.2),('5815','2013-11-09','12:50:00',2.15),('5815','2013-11-09','13:50:00',1.42),('5815','2013-11-09','13:55:00',1.47),('5815','2013-11-08','09:40:00',1.73),('5815','2013-11-08','09:45:00',1.13),('5815','2013-11-08','09:50:00',1.63),('5815','2013-11-08','09:55:00',1.84),('5815','2013-11-08','10:00:00',1.76),('5815','2013-11-08','10:05:00',1.63),('5815','2013-11-08','10:10:00',1.55),('5815','2013-11-08','10:15:00',1.48),('5815','2013-11-08','10:20:00',1.66),('5815','2013-11-08','10:25:00',1.82),('5815','2013-11-08','10:55:00',1.25),('5815','2013-11-08','11:00:00',1.46),('5815','2013-11-08','11:05:00',2.21),('5815','2013-11-08','11:10:00',1.93),('5815','2013-11-08','11:15:00',2.47),('5815','2013-11-08','11:20:00',1.8),('5815','2013-11-08','11:30:00',1.89),('5815','2013-11-08','11:35:00',1.94),('5815','2013-11-08','11:40:00',1.65),('5815','2013-11-08','11:45:00',1.38),('5815','2013-11-08','11:55:00',1.4),('5815','2013-11-08','12:00:00',1.59),('5815','2013-11-08','12:05:00',1.83),('5815','2013-11-08','12:10:00',1.32),('5815','2013-11-08','12:15:00',1.38),('5815','2013-11-08','12:30:00',1.38),('5815','2013-11-08','12:35:00',1.98),('5815','2013-11-08','12:40:00',1.17),('5815','2013-11-08','12:45:00',1.03),('5815','2013-11-08','12:50:00',1.78),('5815','2013-11-08','12:55:00',1.67),('5815','2013-11-08','13:00:00',2.2),('5815','2013-11-08','13:05:00',1.96),('5815','2013-11-08','13:10:00',2.05),('5815','2013-11-08','13:15:00',2.07),('5815','2013-11-08','13:20:00',1.39),('5815','2013-11-08','13:25:00',1.52),('5815','2013-11-08','13:30:00',1.92),('5815','2013-11-08','13:35:00',1.85),('5815','2013-11-08','13:40:00',1.7),('5815','2013-11-08','13:45:00',1.72),('5815','2013-11-08','13:50:00',1.7),('5815','2013-11-08','13:55:00',1.69),('5815','2013-11-08','14:00:00',1.52),('5815','2013-11-08','14:05:00',1.46),('5815','2013-11-08','14:10:00',1.01),('5815','2013-11-08','14:20:00',1.6),('5815','2013-11-08','14:25:00',1.3),('5815','2013-11-08','14:40:00',1.14),('5815','2013-11-08','14:50:00',1.12),('5815','2013-11-07','09:20:00',1.27),('5815','2013-11-07','09:25:00',1.3),('5815','2013-11-07','09:30:00',1.41),('5815','2013-11-07','09:35:00',1.49),('5815','2013-11-07','09:40:00',1.12),('5815','2013-11-07','09:50:00',1.29),('5815','2013-11-07','10:05:00',1.17),('5815','2013-11-07','10:10:00',1.75),('5815','2013-11-07','10:50:00',1.53),('5815','2013-11-07','10:55:00',1.45),('5815','2013-11-07','11:25:00',1.84),('5815','2013-11-07','11:30:00',2.28),('5815','2013-11-07','11:35:00',2.23),('5815','2013-11-07','11:40:00',2.16),('5815','2013-11-07','11:45:00',2.14),('5815','2013-11-07','11:50:00',2.15),('5815','2013-11-07','11:55:00',2.01),('5815','2013-11-07','12:00:00',1.11),('5815','2013-11-07','12:05:00',2.03),('5815','2013-11-07','12:10:00',1.99),('5815','2013-11-07','12:15:00',1.72),('5815','2013-11-07','12:40:00',1.78),('5815','2013-11-07','12:45:00',1.26),('5815','2013-11-07','12:50:00',1.81),('5815','2013-11-07','12:55:00',2.11),('5815','2013-11-07','13:00:00',2.05),('5815','2013-11-07','13:05:00',1.96),('5815','2013-11-07','13:10:00',1.97),('5815','2013-11-07','13:15:00',2.01),('5815','2013-11-07','13:20:00',1.33),('5815','2013-11-07','13:25:00',1.98),('5815','2013-11-07','13:30:00',1.23),('5815','2013-11-07','13:35:00',1.69),('5815','2013-11-07','13:40:00',1.8),('5815','2013-11-07','13:45:00',1.73),('5815','2013-11-07','13:50:00',1.71),('5815','2013-11-07','13:55:00',1.66),('5815','2013-11-07','14:00:00',1.68),('5815','2013-11-07','14:05:00',1.62),('5815','2013-11-07','14:10:00',1.58),('5815','2013-11-07','14:15:00',1.4),('5815','2013-11-07','14:25:00',1.19),('5815','2013-11-07','14:35:00',1.36),('5815','2013-11-07','14:40:00',1.25),('5815','2013-11-07','14:45:00',1.31),('5815','2013-11-07','14:50:00',1.28),('5815','2013-11-07','14:55:00',1.01),('5815','2013-11-07','15:05:00',1.06),('5815','2013-11-07','15:10:00',1.07),('5815','2013-11-07','15:15:00',1.01),('5815','2014-04-17','09:05:00',1.4),('5815','2014-04-17','09:10:00',1.75),('5815','2014-04-17','09:15:00',1.61),('5815','2014-04-17','09:20:00',1.47),('5815','2014-04-17','09:25:00',1.07),('5815','2014-04-17','09:30:00',1.71),('5815','2014-04-17','09:50:00',1.63),('5815','2014-04-17','09:55:00',1.58),('5815','2014-04-17','10:00:00',1.42),('5815','2014-04-17','10:45:00',1.51),('5815','2014-04-17','10:50:00',1.71),('5815','2014-04-17','10:55:00',1.67),('5815','2014-04-17','11:00:00',1),('5815','2014-04-17','11:10:00',1.28),('5815','2014-04-17','11:15:00',1.53),('5815','2014-04-17','11:20:00',1.02),('5815','2014-04-17','11:50:00',1.06),('5815','2014-04-17','12:00:00',1),('5815','2014-04-17','12:05:00',1.63),('5815','2014-04-17','12:10:00',1.92),('5815','2014-04-17','12:15:00',1.78),('5815','2014-04-17','12:20:00',2.31),('5815','2014-04-17','12:25:00',1.77),('5815','2014-04-17','12:30:00',2.67),('5815','2014-04-17','12:35:00',2.48),('5815','2014-04-17','12:40:00',2.56),('5815','2014-04-17','12:45:00',2.16),('5815','2014-04-17','12:50:00',2.17),('5815','2014-04-17','12:55:00',1.57),('5815','2014-04-17','13:00:00',2.69),('5815','2014-04-17','13:05:00',1.9),('5815','2014-04-17','13:10:00',1.52),('5815','2014-04-17','13:15:00',1.43),('5815','2014-04-17','13:20:00',1.29),('5815','2014-04-17','13:55:00',1.22),('5815','2014-04-17','14:00:00',1.08),('5815','2014-04-17','14:25:00',1.12),('5815','2014-04-17','14:30:00',1.26),('5815','2014-04-17','14:35:00',1.45),('5815','2014-04-17','14:40:00',1.36),('5815','2014-04-17','14:45:00',1.7),('5815','2014-04-17','14:50:00',1.96),('5815','2014-04-17','14:55:00',1.28),('5815','2014-04-17','15:00:00',2.42),('5815','2014-04-17','15:05:00',1.42),('5815','2014-04-17','15:10:00',1.28),('5815','2014-04-17','15:15:00',1.43),('5815','2014-04-17','15:20:00',1.21),('5815','2014-04-17','15:25:00',1.28),('5815','2014-04-17','15:30:00',1.72),('5815','2014-04-17','15:35:00',2.24),('5815','2014-04-17','15:40:00',1.07),('5815','2014-04-17','15:45:00',1.39),('5815','2014-04-17','15:50:00',1.67),('5815','2014-04-17','15:55:00',1.46),('5815','2014-04-17','16:00:00',1.27),('5815','2014-04-17','16:25:00',1.1),('5815','2014-04-17','16:30:00',1.25),('5815','2014-04-17','16:35:00',1.48),('5815','2014-04-17','16:40:00',1.74),('5815','2014-04-17','16:45:00',1.72),('5815','2014-04-17','16:50:00',1.65),('5815','2014-04-17','16:55:00',1.08),('5815','2014-04-17','17:00:00',1.32),('5815','2014-04-17','17:05:00',1.66),('5815','2014-04-17','17:10:00',1.19),('5815','2014-04-17','17:15:00',1.32),('5815','2014-04-17','17:20:00',1.22),('5815','2014-04-17','17:25:00',1.25),('5815','2014-04-17','17:30:00',1.15),('5815','2014-04-17','17:35:00',1.02),('5815','2013-11-06','08:35:00',1.03),('5815','2013-11-06','08:40:00',1.07),('5815','2013-11-06','08:45:00',1.12),('5815','2013-11-06','08:50:00',1.17),('5815','2013-11-06','08:55:00',1.21),('5815','2013-11-06','09:00:00',1.25),('5815','2013-11-06','09:05:00',1.29),('5815','2013-11-06','09:10:00',1.32),('5815','2013-11-06','09:15:00',1.36),('5815','2013-11-06','09:20:00',1.4),('5815','2013-11-06','09:25:00',1.44),('5815','2013-11-06','09:30:00',1.47),('5815','2013-11-06','09:35:00',1.5),('5815','2013-11-06','09:40:00',1.52),('5815','2013-11-06','09:45:00',1.56),('5815','2013-11-06','09:50:00',1.58),('5815','2013-11-06','09:55:00',1.61),('5815','2013-11-06','10:00:00',1.62),('5815','2013-11-06','10:05:00',1.63),('5815','2013-11-06','10:10:00',1.66),('5815','2013-11-06','10:15:00',1.68),('5815','2013-11-06','10:20:00',1.69),('5815','2013-11-06','10:25:00',1.71),('5815','2013-11-06','10:30:00',1.73),('5815','2013-11-06','10:35:00',1.75),('5815','2013-11-06','10:40:00',1.75),('5815','2013-11-06','10:45:00',1.73),('5815','2013-11-06','10:50:00',1.77),('5815','2013-11-06','10:55:00',1.77),('5815','2013-11-06','11:00:00',1.8),('5815','2013-11-06','11:05:00',1.8),('5815','2013-11-06','11:10:00',1.81),('5815','2013-11-06','11:15:00',1.81),('5815','2013-11-06','11:20:00',1.81),('5815','2013-11-06','11:25:00',1.81),('5815','2013-11-06','11:30:00',1.76),('5815','2013-11-06','11:35:00',1.72),('5815','2013-11-06','11:40:00',1.81),('5815','2013-11-06','11:45:00',1.83),('5815','2013-11-06','11:50:00',1.81),('5815','2013-11-06','11:55:00',1.78),('5815','2013-11-06','12:00:00',1.79),('5815','2013-11-06','12:05:00',1.79),('5815','2013-11-06','12:10:00',1.74),('5815','2013-11-06','12:15:00',1.76),('5815','2013-11-06','12:20:00',1.78),('5815','2013-11-06','12:25:00',1.77),('5815','2013-11-06','12:30:00',1.74),('5815','2013-11-06','12:35:00',1.76),('5815','2013-11-06','12:40:00',1.73),('5815','2013-11-06','12:45:00',1.71),('5815','2013-11-06','12:50:00',1.7),('5815','2013-11-06','12:55:00',1.77),('5815','2013-11-06','13:00:00',1.8),('5815','2013-11-06','13:05:00',1.88),('5815','2013-11-06','13:10:00',1.34),('5815','2013-11-06','13:20:00',1.04),('5815','2013-11-06','13:40:00',1.64),('5815','2013-11-06','13:50:00',1.05),('5815','2013-11-06','13:55:00',1.69),('5815','2013-11-06','14:10:00',1.05),('5815','2013-11-06','14:25:00',1.34),('5815','2013-11-06','14:35:00',1.24),('5815','2013-11-06','14:40:00',1.38),('5815','2013-11-06','14:45:00',1.28),('5815','2013-11-06','14:50:00',1.24),('5815','2013-11-06','14:55:00',1.21),('5815','2013-11-06','15:00:00',1.16),('5815','2013-11-06','15:05:00',1.11),('5815','2013-11-06','15:10:00',1.06),('5815','2013-11-05','08:35:00',1.09),('5815','2013-11-05','08:40:00',1.11),('5815','2013-11-05','08:45:00',1.17),('5815','2013-11-05','08:50:00',1.25),('5815','2013-11-05','08:55:00',1.16),('5815','2013-11-05','09:15:00',1.15),('5815','2013-11-05','09:20:00',1.37),('5815','2013-11-05','09:25:00',1.42),('5815','2013-11-05','09:30:00',1.52),('5815','2013-11-05','09:35:00',1.55),('5815','2013-11-05','09:40:00',1.57),('5815','2013-11-05','09:45:00',1.59),('5815','2013-11-05','09:50:00',1.61),('5815','2013-11-05','09:55:00',1.64),('5815','2013-11-05','10:00:00',1.68),('5815','2013-11-05','10:05:00',1.7),('5815','2013-11-05','10:10:00',1.72),('5815','2013-11-05','10:15:00',1.74),('5815','2013-11-05','10:20:00',1.78),('5815','2013-11-05','10:25:00',1.81),('5815','2013-11-05','10:30:00',1.83),('5815','2013-11-05','10:35:00',1.85),('5815','2013-11-05','10:40:00',1.86),('5815','2013-11-05','10:45:00',1.88),('5815','2013-11-05','10:50:00',1.89),('5815','2013-11-05','10:55:00',1.9),('5815','2013-11-05','11:00:00',1.91),('5815','2013-11-05','11:05:00',1.92),('5815','2013-11-05','11:10:00',1.9),('5815','2013-11-05','11:15:00',1.94),('5815','2013-11-05','11:20:00',1.94),('5815','2013-11-05','11:25:00',1.96),('5815','2013-11-05','11:30:00',1.95),('5815','2013-11-05','11:35:00',1.94),('5815','2013-11-05','11:40:00',1.97),('5815','2013-11-05','11:45:00',1.97),('5815','2013-11-05','11:50:00',1.98),('5815','2013-11-05','11:55:00',1.97),('5815','2013-11-05','12:00:00',1.98),('5815','2013-11-05','12:05:00',1.99),('5815','2013-11-05','12:10:00',1.97),('5815','2013-11-05','12:15:00',1.96),('5815','2013-11-05','12:20:00',1.97),('5815','2013-11-05','12:25:00',1.96),('5815','2013-11-05','12:30:00',1.96),('5815','2013-11-05','12:35:00',1.95),('5815','2013-11-05','12:40:00',1.94),('5815','2013-11-05','12:45:00',1.92),('5815','2013-11-05','12:50:00',1.93),('5815','2013-11-05','12:55:00',1.91),('5815','2013-11-05','13:00:00',1.88),('5815','2013-11-05','13:05:00',1.87),('5815','2013-11-05','13:10:00',1.85),('5815','2013-11-05','13:15:00',1.81),('5815','2013-11-05','13:20:00',1.81),('5815','2013-11-05','13:25:00',1.8),('5815','2013-11-05','13:30:00',1.78),('5815','2013-11-05','13:35:00',1.75),('5815','2013-11-05','13:40:00',1.72),('5815','2013-11-05','13:45:00',1.68),('5815','2013-11-05','13:50:00',1.68),('5815','2013-11-05','13:55:00',1.63),('5815','2013-11-05','14:00:00',1.65),('5815','2013-11-05','14:05:00',1.62),('5815','2013-11-05','14:10:00',1.58),('5815','2013-11-05','14:15:00',1.54),('5815','2013-11-05','14:20:00',1.51),('5815','2013-11-05','14:25:00',1.47),('5815','2013-11-05','14:30:00',1.43),('5815','2013-11-05','14:35:00',1.4),('5815','2013-11-05','14:40:00',1.36),('5815','2013-11-05','14:45:00',1.32),('5815','2013-11-05','14:50:00',1.27),('5815','2013-11-05','14:55:00',1.23),('5815','2013-11-05','15:00:00',1.18),('5815','2013-11-05','15:05:00',1.13),('5815','2013-11-05','15:10:00',1.08),('5815','2013-11-05','15:15:00',1.04),('5815','2013-11-04','08:35:00',1.15),('5815','2013-11-04','08:40:00',1.18),('5815','2013-11-04','10:25:00',1.34),('5815','2013-11-04','10:30:00',1.09),('5815','2013-11-04','10:35:00',1.23),('5815','2013-11-04','10:40:00',1.21),('5815','2013-11-04','10:45:00',1.2),('5815','2013-11-04','12:20:00',1.02),('5815','2013-11-04','12:25:00',1.07),('5815','2013-11-04','13:35:00',1.35),('5815','2013-11-04','13:40:00',1.55),('5815','2013-11-04','13:45:00',1.52),('5815','2013-11-04','14:00:00',1.57),('5815','2013-11-04','14:05:00',1.69),('5815','2013-11-04','14:10:00',1.93),('5815','2013-11-04','14:15:00',1.43),('5815','2013-11-04','14:35:00',1.16),('5815','2013-11-03','09:10:00',1.3),('5815','2013-11-03','09:15:00',1.53),('5815','2013-11-03','09:20:00',1.61),('5815','2013-11-03','09:25:00',1.82),('5815','2013-11-03','09:30:00',1.07),('5815','2013-11-03','10:05:00',1.54),('5815','2013-11-03','10:10:00',1.81),('5815','2013-11-03','10:15:00',1.84),('5815','2013-11-03','10:20:00',1.86),('5815','2013-11-03','10:25:00',2.04),('5815','2013-11-03','10:30:00',1.98),('5815','2013-11-03','10:35:00',1.37),('5815','2013-11-03','10:40:00',2.03),('5815','2013-11-03','10:45:00',1.33),('5815','2013-11-03','10:50:00',1.05),('5815','2013-11-03','11:00:00',1.18),('5815','2013-11-03','11:05:00',2.35),('5815','2013-11-03','11:10:00',1.14),('5815','2013-11-03','11:15:00',1.91),('5815','2013-11-03','11:20:00',1.19),('5815','2013-11-03','11:30:00',1.43),('5815','2013-11-03','11:35:00',1.85),('5815','2013-11-03','11:40:00',1.21),('5815','2013-11-03','11:45:00',1.47),('5815','2013-11-03','11:50:00',2.49),('5815','2013-11-03','11:55:00',2.26),('5815','2013-11-03','12:00:00',1.9),('5815','2013-11-03','12:05:00',1.99),('5815','2013-11-03','12:10:00',1.99),('5815','2013-11-03','12:15:00',1.67),('5815','2013-11-03','12:20:00',2.11),('5815','2013-11-03','12:25:00',2.1),('5815','2013-11-03','12:30:00',2.09),('5815','2013-11-03','12:35:00',2.13),('5815','2013-11-03','12:40:00',1.8),('5815','2013-11-03','12:45:00',1.81),('5815','2013-11-03','12:50:00',1.79),('5815','2013-11-03','12:55:00',2.01),('5815','2013-11-03','13:00:00',1.98),('5815','2013-11-03','13:05:00',1.98),('5815','2013-11-03','13:10:00',1.88),('5815','2013-11-03','13:15:00',1.79),('5815','2013-11-03','13:20:00',1.7),('5815','2013-11-03','13:25:00',1.86),('5815','2013-11-03','13:30:00',1.9),('5815','2013-11-03','13:35:00',1.9),('5815','2013-11-03','13:40:00',1.84),('5815','2013-11-03','13:45:00',1.61),('5815','2013-11-03','13:50:00',1.86),('5815','2013-11-03','13:55:00',1.67),('5815','2013-11-03','14:00:00',1.4),('5815','2013-11-03','14:05:00',1.7),('5815','2013-11-03','14:10:00',1.39),('5815','2013-11-03','14:15:00',1.63),('5815','2013-11-03','14:20:00',1.73),('5815','2013-11-03','14:25:00',1.06),('5815','2013-11-03','14:30:00',1.53),('5815','2013-11-03','14:35:00',1.41),('5815','2013-11-03','14:40:00',1.49),('5815','2013-11-03','14:45:00',1.19),('5815','2013-11-03','14:50:00',1.27),('5815','2013-11-03','15:00:00',1.29),('5815','2013-11-03','15:20:00',1.01),('5815','2013-11-02','09:40:00',1.54),('5815','2013-11-02','09:45:00',1.23),('5815','2013-11-02','10:10:00',1.36),('5815','2013-11-02','10:20:00',1.3),('5815','2013-11-02','10:25:00',1.57),('5815','2013-11-02','10:30:00',1.81),('5815','2013-11-02','10:35:00',1.48),('5815','2013-11-02','11:25:00',1.39),('5815','2013-11-02','11:30:00',1.14),('5815','2013-11-02','11:35:00',1.81),('5815','2013-11-02','11:40:00',2.06),('5815','2013-11-02','11:45:00',2.18),('5815','2013-11-02','11:50:00',2.24),('5815','2013-11-02','11:55:00',2.18),('5815','2013-11-02','12:00:00',1.09),('5815','2013-11-02','12:05:00',1.81),('5815','2013-11-02','12:10:00',1.97),('5815','2013-11-02','12:20:00',1.01),('5815','2013-11-02','13:45:00',1.31),('5815','2013-11-02','14:05:00',1.73),('5815','2013-11-02','14:10:00',1.36),('5815','2013-11-02','14:15:00',1.32),('5815','2013-11-02','14:20:00',1.25),('5815','2013-11-02','14:25:00',1.53),('5815','2013-11-02','14:40:00',1.39),('5815','2013-11-02','14:45:00',1.22),('5815','2013-11-01','08:40:00',1.03),('5815','2013-11-01','08:45:00',1.08),('5815','2013-11-01','08:50:00',1.11),('5815','2013-11-01','08:55:00',1.16),('5815','2013-11-01','09:00:00',1.21),('5815','2013-11-01','09:05:00',1.3),('5815','2013-11-01','09:10:00',1.39),('5815','2013-11-01','09:20:00',1.15),('5815','2013-11-01','09:25:00',1.49),('5815','2013-11-01','09:30:00',1.44),('5815','2013-11-01','09:35:00',1.48),('5815','2013-11-01','09:40:00',1.43),('5815','2013-11-01','09:45:00',1.15),('5815','2013-11-01','09:50:00',1.63),('5815','2013-11-01','09:55:00',1.67),('5815','2013-11-01','10:00:00',1.8),('5815','2013-11-01','10:05:00',1.99),('5815','2013-11-01','10:10:00',1.05),('5815','2013-11-01','12:00:00',2.22),('5815','2013-11-01','12:05:00',2.38),('5815','2013-11-01','12:10:00',2.14),('5815','2013-11-01','12:15:00',2.41),('5815','2013-11-01','12:20:00',2.19),('5815','2013-11-01','12:25:00',2.28),('5815','2013-11-01','12:30:00',2.4),('5815','2013-11-01','12:35:00',2.32),('5815','2013-11-01','12:40:00',1.95),('5815','2013-11-01','12:45:00',1.65),('5815','2013-11-01','12:50:00',1.73),('5815','2013-11-01','12:55:00',2.17),('5815','2013-11-01','13:00:00',1.88),('5815','2013-11-01','13:05:00',2.12),('5815','2013-11-01','13:10:00',2.16),('5815','2013-11-01','13:15:00',1.38),('5815','2013-11-01','13:30:00',1.14),('5815','2013-11-01','13:35:00',1.16),('5815','2013-11-01','13:40:00',1.95),('5815','2013-11-01','13:45:00',1.76),('5815','2013-11-01','13:50:00',2.16),('5815','2013-11-01','13:55:00',2.06),('5815','2013-11-01','14:00:00',1.9),('5815','2013-11-01','14:05:00',1.75),('5815','2013-11-01','14:10:00',1.66),('5815','2013-11-01','14:15:00',1.58),('5815','2013-11-01','14:20:00',1.52),('5815','2013-11-01','14:25:00',1.48),('5815','2013-11-01','14:30:00',1.44),('5815','2013-11-01','14:35:00',1.41),('5815','2013-11-01','14:40:00',1.37),('5815','2013-11-01','14:45:00',1.3),('5815','2013-11-01','14:50:00',1.27),('5815','2013-11-01','14:55:00',1.23),('5815','2013-11-01','15:00:00',1.16),('5815','2013-11-01','15:05:00',1.01),('5815','2013-11-01','15:10:00',1.07),('5815','2013-10-31','08:40:00',1.03),('5815','2013-10-31','08:45:00',1.06),('5815','2013-10-31','08:50:00',1.02),('5815','2013-10-31','08:55:00',1.08),('5815','2013-10-31','09:00:00',1.12),('5815','2013-10-31','09:05:00',1.25),('5815','2013-10-31','09:10:00',1.3),('5815','2013-10-31','09:15:00',1.31),('5815','2013-10-31','09:20:00',1.36),('5815','2013-10-31','09:25:00',1.4),('5815','2013-10-31','09:30:00',1.43),('5815','2013-10-31','09:35:00',1.46),('5815','2013-10-31','09:40:00',1.5),('5815','2013-10-31','09:45:00',1.54),('5815','2013-10-31','09:50:00',1.57),('5815','2013-10-31','09:55:00',1.61),('5815','2013-10-31','10:00:00',1.64),('5815','2013-10-31','10:05:00',1.66),('5815','2013-10-31','10:10:00',1.69),('5815','2013-10-31','10:15:00',1.71),('5815','2013-10-31','10:20:00',1.74),('5815','2013-10-31','10:25:00',1.77),('5815','2013-10-31','10:30:00',1.75),('5815','2013-10-31','10:35:00',1.75),('5815','2013-10-31','10:40:00',1.79),('5815','2013-10-31','10:45:00',1.76),('5815','2013-10-31','10:50:00',1.77),('5815','2013-10-31','10:55:00',1.75),('5815','2013-10-31','11:00:00',1.81),('5815','2013-10-31','11:05:00',1.74),('5815','2013-10-31','11:10:00',1.52),('5815','2013-10-31','11:15:00',1.53),('5815','2013-10-31','11:20:00',1.81),('5815','2013-10-31','11:25:00',1.97),('5815','2013-10-31','11:30:00',1.97),('5815','2013-10-31','11:35:00',1.92),('5815','2013-10-31','11:40:00',1.81),('5815','2013-10-31','11:45:00',1.67),('5815','2013-10-31','11:50:00',1.93),('5815','2013-10-31','11:55:00',1.99),('5815','2013-10-31','12:00:00',1.99),('5815','2013-10-31','12:05:00',1.95),('5815','2013-10-31','12:10:00',1.83),('5815','2013-10-31','12:15:00',1.81),('5815','2013-10-31','12:20:00',1.47),('5815','2013-10-31','12:30:00',1.25),('5815','2013-10-31','12:35:00',1.6),('5815','2013-10-30','08:40:00',1.08),('5815','2013-10-30','08:45:00',1.09),('5815','2013-10-30','08:50:00',1.03),('5815','2013-10-30','09:00:00',1.13),('5815','2013-10-30','09:05:00',1.05),('5815','2013-10-30','09:35:00',1.24),('5815','2013-10-30','09:40:00',1.14),('5815','2013-10-30','09:45:00',1.2),('5815','2013-10-30','09:50:00',1.28),('5815','2013-10-30','09:55:00',1.25),('5815','2013-10-30','10:00:00',1.24),('5815','2013-10-30','10:05:00',1.11),('5815','2013-10-30','10:20:00',1.06),('5815','2013-10-30','10:25:00',1.15),('5815','2013-10-30','10:30:00',1.1),('5815','2013-10-30','10:35:00',1.14),('5815','2013-10-30','10:40:00',1.19),('5815','2013-10-30','10:45:00',1.15),('5815','2013-10-30','10:50:00',1.17),('5815','2013-10-30','10:55:00',1.36),('5815','2013-10-30','11:00:00',1.69),('5815','2013-10-30','11:05:00',1.84),('5815','2013-10-30','11:10:00',1.78),('5815','2013-10-30','11:15:00',1.31),('5815','2013-10-30','11:20:00',1.77),('5815','2013-10-30','11:25:00',1.6),('5815','2013-10-30','11:30:00',1.67),('5815','2013-10-30','11:35:00',1.62),('5815','2013-10-30','11:40:00',1.73),('5815','2013-10-30','11:45:00',1.85),('5815','2013-10-30','11:50:00',1.86),('5815','2013-10-30','11:55:00',1.87),('5815','2013-10-30','12:00:00',1.83),('5815','2013-10-30','12:05:00',1.79),('5815','2013-10-30','12:10:00',1.75),('5815','2013-10-30','12:15:00',1.81),('5815','2013-10-30','12:20:00',1.77),('5815','2013-10-30','12:25:00',1.79),('5815','2013-10-30','12:30:00',1.76),('5815','2013-10-30','12:35:00',1.72),('5815','2013-10-30','12:40:00',1.76),('5815','2013-10-30','12:45:00',1.81),('5815','2013-10-30','12:50:00',1.82),('5815','2013-10-30','12:55:00',1.85),('5815','2013-10-30','13:00:00',1.83),('5815','2013-10-30','13:05:00',1.79),('5815','2013-10-30','13:10:00',1.77),('5815','2013-10-30','13:15:00',1.75),('5815','2013-10-30','13:20:00',1.74),('5815','2013-10-30','13:25:00',1.71),('5815','2013-10-30','13:30:00',1.66),('5815','2013-10-30','13:35:00',1.63),('5815','2013-10-30','13:40:00',1.5),('5815','2013-10-30','13:45:00',1.5),('5815','2013-10-30','13:50:00',1.29),('5815','2013-10-30','13:55:00',1.07),('5815','2013-10-30','14:00:00',1.52),('5815','2013-10-30','14:05:00',1.48),('5815','2013-10-30','14:10:00',1.38),('5815','2013-10-30','14:15:00',1.35),('5815','2013-10-30','14:20:00',1.17),('5815','2013-10-30','14:25:00',1.3),('5815','2013-10-30','14:30:00',1.03),('5815','2013-10-29','08:45:00',1.02),('5815','2013-10-29','08:50:00',1.04),('5815','2013-10-29','08:55:00',1.04),('5815','2013-10-29','09:00:00',1.1),('5815','2013-10-29','09:05:00',1.17),('5815','2013-10-29','09:10:00',1.25),('5815','2013-10-29','09:15:00',1.28),('5815','2013-10-29','09:20:00',1.3),('5815','2013-10-29','09:25:00',1.35),('5815','2013-10-29','09:30:00',1.4),('5815','2013-10-29','09:35:00',1.44),('5815','2013-10-29','09:40:00',1.44),('5815','2013-10-29','09:45:00',1.49),('5815','2013-10-29','09:50:00',1.47),('5815','2013-10-29','09:55:00',1.5),('5815','2013-10-29','10:00:00',1.4),('5815','2013-10-29','10:05:00',1.46),('5815','2013-10-29','10:10:00',1.5),('5815','2013-10-29','10:15:00',1.62),('5815','2013-10-29','10:20:00',1.6),('5815','2013-10-29','10:25:00',1.54),('5815','2013-10-29','10:30:00',1.47),('5815','2013-10-29','10:35:00',1.54),('5815','2013-10-29','10:40:00',1.58),('5815','2013-10-29','10:45:00',1.52),('5815','2013-10-29','10:50:00',1.51),('5815','2013-10-29','11:00:00',1.2),('5815','2013-10-29','11:05:00',1.47),('5815','2013-10-29','11:10:00',1.83),('5815','2013-10-29','11:15:00',1.86),('5815','2013-10-29','11:20:00',1.64),('5815','2013-10-29','11:50:00',1.45),('5815','2013-10-29','12:30:00',1.49),('5815','2013-10-29','12:45:00',1.15),('5815','2013-10-29','12:55:00',1.51),('5815','2013-10-29','13:00:00',1.46),('5815','2013-10-29','13:30:00',1.06),('5815','2013-10-29','13:45:00',1.22),('5815','2013-10-29','13:50:00',1.17),('5815','2013-10-29','14:05:00',1.42),('5815','2013-10-29','14:10:00',1.59),('5815','2013-10-29','14:15:00',1.27),('5815','2013-10-29','14:40:00',1.26),('5815','2013-10-29','14:45:00',1.21),('5815','2013-10-29','14:50:00',1.12),('5815','2013-10-28','08:50:00',1.16),('5815','2013-10-28','08:55:00',1.17),('5815','2013-10-28','09:00:00',1.22),('5815','2013-10-28','09:05:00',1.26),('5815','2013-10-28','09:10:00',1.29),('5815','2013-10-28','09:15:00',1.32),('5815','2013-10-28','09:20:00',1.38),('5815','2013-10-28','09:25:00',1.4),('5815','2013-10-28','09:30:00',1.45),('5815','2013-10-28','09:35:00',1.47),('5815','2013-10-28','09:40:00',1.5),('5815','2013-10-28','09:45:00',1.49),('5815','2013-10-28','09:50:00',1.29),('5815','2013-10-28','09:55:00',1.53),('5815','2013-10-28','10:00:00',1.65),('5815','2013-10-28','10:05:00',1.74),('5815','2013-10-28','10:10:00',1.68),('5815','2013-10-28','10:15:00',1.49),('5815','2013-10-28','10:20:00',1.47),('5815','2013-10-28','10:25:00',1.77),('5815','2013-10-28','10:30:00',1.93),('5815','2013-10-28','10:35:00',1.88),('5815','2013-10-28','10:40:00',1.89),('5815','2013-10-28','10:45:00',1.91),('5815','2013-10-28','10:50:00',1.98),('5815','2013-10-28','10:55:00',1.81),('5815','2013-10-28','11:00:00',1.09),('5815','2013-10-28','11:05:00',1.22),('5815','2013-10-28','11:15:00',1.56),('5815','2013-10-28','11:20:00',1.94),('5815','2013-10-28','11:25:00',1.86),('5815','2013-10-28','11:30:00',1.99),('5815','2013-10-28','11:35:00',1.99),('5815','2013-10-28','11:40:00',1.97),('5815','2013-10-28','11:45:00',1.86),('5815','2013-10-28','11:50:00',1.85),('5815','2013-10-28','11:55:00',1.85),('5815','2013-10-28','12:00:00',1.79),('5815','2013-10-28','12:05:00',1.91),('5815','2013-10-28','12:10:00',1.87),('5815','2013-10-28','12:15:00',1.86),('5815','2013-10-28','12:20:00',1.87),('5815','2013-10-28','12:25:00',1.87),('5815','2013-10-28','12:30:00',1.85),('5815','2013-10-28','12:35:00',1.79),('5815','2013-10-28','12:40:00',1.83),('5815','2013-10-28','12:45:00',1.87),('5815','2013-10-28','12:50:00',1.85),('5815','2013-10-28','12:55:00',1.8),('5815','2013-10-28','13:00:00',1.75),('5815','2013-10-28','13:05:00',1.7),('5815','2013-10-28','13:10:00',1.74),('5815','2013-10-28','13:15:00',1.72),('5815','2013-10-28','13:20:00',1.7),('5815','2013-10-28','13:25:00',1.65),('5815','2013-10-28','13:30:00',1.65),('5815','2013-10-28','13:35:00',1.63),('5815','2013-10-28','13:40:00',1.62),('5815','2013-10-28','13:45:00',1.61),('5815','2013-10-28','13:50:00',1.58),('5815','2013-10-28','13:55:00',1.5),('5815','2013-10-28','14:00:00',1.47),('5815','2013-10-28','14:05:00',1.45),('5815','2013-10-28','14:10:00',1.49),('5815','2013-10-28','14:15:00',1.46),('5815','2013-10-28','14:20:00',1.43),('5815','2013-10-28','14:25:00',1.35),('5815','2013-10-28','14:30:00',1.29),('5815','2013-10-28','14:35:00',1.24),('5815','2013-10-28','14:40:00',1.2),('5815','2013-10-28','14:45:00',1.18),('5815','2013-10-28','14:50:00',1.15),('5815','2013-10-28','14:55:00',1.09),('5815','2013-10-28','15:00:00',1.03),('5815','2014-04-16','08:45:00',1.02),('5815','2014-04-16','08:50:00',1.12),('5815','2014-04-16','09:00:00',1.01),('5815','2014-04-16','09:05:00',1.17),('5815','2014-04-16','09:10:00',1.3),('5815','2014-04-16','09:15:00',1.32),('5815','2014-04-16','09:20:00',1.43),('5815','2014-04-16','09:25:00',1.5),('5815','2014-04-16','09:30:00',1.55),('5815','2014-04-16','09:35:00',1.6),('5815','2014-04-16','09:40:00',1.65),('5815','2014-04-16','09:45:00',1.7),('5815','2014-04-16','09:50:00',1.75),('5815','2014-04-16','09:55:00',1.8),('5815','2014-04-16','10:00:00',1.87),('5815','2014-04-16','10:05:00',2.02),('5815','2014-04-16','10:10:00',1.88),('5815','2014-04-16','10:15:00',1.66),('5815','2014-04-16','10:20:00',1.98),('5815','2014-04-16','10:25:00',2.25),('5815','2014-04-16','10:30:00',2.34),('5815','2014-04-16','10:35:00',2.42),('5815','2014-04-16','10:40:00',2.29),('5815','2014-04-16','10:45:00',1.83),('5815','2014-04-16','10:50:00',1.4),('5815','2014-04-16','10:55:00',1.42),('5815','2014-04-16','11:00:00',1.47),('5815','2014-04-16','11:05:00',2.18),('5815','2014-04-16','11:10:00',1.84),('5815','2014-04-16','11:15:00',1.77),('5815','2014-04-16','11:20:00',1.85),('5815','2014-04-16','11:25:00',2.02),('5815','2014-04-16','11:30:00',1.39),('5815','2014-04-16','11:35:00',1.66),('5815','2014-04-16','11:40:00',1.65),('5815','2014-04-16','11:45:00',1.85),('5815','2014-04-16','11:50:00',1.41),('5815','2014-04-16','11:55:00',1.13),('5815','2014-04-16','12:00:00',1.25),('5815','2014-04-16','12:05:00',1.63),('5815','2014-04-16','12:10:00',1.64),('5815','2014-04-16','12:15:00',1.4),('5815','2014-04-16','12:20:00',1.38),('5815','2014-04-16','12:25:00',1.55),('5815','2014-04-16','12:30:00',1.81),('5815','2014-04-16','12:35:00',2.36),('5815','2014-04-16','12:40:00',2.58),('5815','2014-04-16','12:45:00',2.47),('5815','2014-04-16','12:50:00',2.56),('5815','2014-04-16','12:55:00',2.6),('5815','2014-04-16','13:00:00',2.23),('5815','2014-04-16','13:05:00',1.49),('5815','2014-04-16','13:20:00',2.5),('5815','2014-04-16','13:25:00',2.92),('5815','2014-04-16','13:30:00',2.01),('5815','2014-04-16','14:10:00',1.52),('5815','2014-04-16','14:35:00',1.03),('5815','2014-04-16','14:40:00',1.92),('5815','2014-04-16','15:35:00',1.19),('5815','2013-10-27','08:55:00',1.13),('5815','2013-10-27','09:00:00',1.26),('5815','2013-10-27','09:05:00',1.38),('5815','2013-10-27','09:10:00',1.45),('5815','2013-10-27','09:15:00',1.15),('5815','2013-10-27','09:25:00',1.46),('5815','2013-10-27','09:30:00',1.6),('5815','2013-10-27','09:35:00',1.27),('5815','2013-10-27','09:50:00',1.4),('5815','2013-10-27','09:55:00',1.06),('5815','2013-10-27','10:50:00',1.92),('5815','2013-10-27','10:55:00',1.91),('5815','2013-10-27','11:00:00',1.92),('5815','2013-10-27','11:05:00',1.92),('5815','2013-10-27','11:10:00',1.94),('5815','2013-10-27','11:15:00',1.96),('5815','2013-10-27','11:20:00',1.96),('5815','2013-10-27','11:25:00',1.97),('5815','2013-10-27','11:30:00',1.95),('5815','2013-10-27','11:35:00',1.94),('5815','2013-10-27','11:40:00',1.9),('5815','2013-10-27','11:45:00',1.94),('5815','2013-10-27','11:50:00',1.96),('5815','2013-10-27','11:55:00',1.96),('5815','2013-10-27','12:00:00',1.78),('5815','2013-10-27','12:05:00',1.93),('5815','2013-10-27','12:10:00',1.46),('5815','2013-10-27','12:15:00',2.07),('5815','2013-10-27','12:20:00',2.11),('5815','2013-10-27','12:25:00',2.1),('5815','2013-10-27','12:30:00',1.87),('5815','2013-10-27','12:35:00',2.11),('5815','2013-10-27','12:40:00',2.13),('5815','2013-10-27','12:45:00',2.07),('5815','2013-10-27','12:50:00',2.09),('5815','2013-10-27','12:55:00',2.01),('5815','2013-10-27','13:00:00',1.93),('5815','2013-10-27','13:05:00',1.9),('5815','2013-10-27','13:10:00',1.92),('5815','2013-10-27','13:15:00',1.88),('5815','2013-10-27','13:20:00',1.84),('5815','2013-10-27','13:25:00',1.85),('5815','2013-10-27','13:30:00',1.81),('5815','2013-10-27','13:35:00',1.79),('5815','2013-10-27','13:40:00',1.73),('5815','2013-10-27','13:45:00',1.38),('5815','2013-10-27','13:50:00',1.73),('5815','2013-10-27','13:55:00',1.71),('5815','2013-10-27','14:00:00',1.71),('5815','2013-10-27','14:05:00',1.27),('5815','2013-10-27','14:10:00',1.7),('5815','2013-10-27','14:15:00',1.67),('5815','2013-10-27','14:20:00',1.61),('5815','2013-10-27','14:25:00',1.65),('5815','2013-10-27','14:30:00',1.51),('5815','2013-10-27','14:35:00',1.43),('5815','2013-10-27','14:40:00',1.15),('5815','2013-10-27','14:45:00',1.31),('5815','2013-10-27','14:50:00',1.29),('5815','2013-10-27','14:55:00',1.22),('5815','2013-10-27','15:00:00',1.19),('5815','2013-10-27','15:05:00',1.16),('5815','2013-10-27','15:10:00',1.1),('5815','2013-10-27','15:15:00',1.02),('5815','2013-10-26','11:40:00',1.61),('5815','2013-10-26','11:45:00',1.75),('5815','2013-10-26','11:50:00',1.36),('5815','2013-10-26','12:20:00',1.54),('5815','2013-10-26','12:25:00',1.94),('5815','2013-10-26','12:30:00',1.69),('5815','2013-10-26','12:35:00',1.74),('5815','2013-10-26','12:40:00',1.43),('5815','2013-10-26','12:50:00',1.06),('5815','2013-10-26','13:00:00',1.47),('5815','2013-10-26','13:10:00',1.37),('5815','2013-10-26','13:25:00',1.04),('5815','2013-10-26','13:30:00',1.58),('5815','2013-10-26','13:35:00',1.22),('5815','2013-10-26','13:40:00',1.43),('5815','2013-10-26','14:35:00',1.28),('5815','2013-10-26','14:40:00',1.33),('5815','2013-10-26','14:45:00',1.1),('5815','2013-10-26','14:50:00',1.05),('5815','2013-10-26','14:55:00',1.16),('5815','2013-10-26','15:00:00',1.12),('5815','2013-10-26','15:15:00',1),('5815','2013-10-25','09:35:00',1.01),('5815','2013-10-25','09:40:00',1.06),('5815','2013-10-25','09:45:00',1.11),('5815','2013-10-25','09:50:00',1.16),('5815','2013-10-25','09:55:00',1.2),('5815','2013-10-25','10:00:00',1.24),('5815','2013-10-25','10:05:00',1.29),('5815','2013-10-25','10:10:00',1.32),('5815','2013-10-25','10:15:00',1.36),('5815','2013-10-25','10:20:00',1.39),('5815','2013-10-25','10:25:00',1.42),('5815','2013-10-25','10:30:00',1.45),('5815','2013-10-25','10:35:00',1.48),('5815','2013-10-25','10:40:00',1.52),('5815','2013-10-25','10:45:00',1.54),('5815','2013-10-25','10:50:00',1.58),('5815','2013-10-25','10:55:00',1.61),('5815','2013-10-25','11:00:00',1.65),('5815','2013-10-25','11:05:00',1.67),('5815','2013-10-25','11:10:00',1.69),('5815','2013-10-25','11:15:00',1.71),('5815','2013-10-25','11:20:00',1.73),('5815','2013-10-25','11:25:00',1.75),('5815','2013-10-25','11:30:00',1.77),('5815','2013-10-25','11:35:00',1.79),('5815','2013-10-25','11:40:00',1.8),('5815','2013-10-25','11:45:00',1.82),('5815','2013-10-25','11:50:00',1.84),('5815','2013-10-25','11:55:00',1.83),('5815','2013-10-25','12:00:00',1.86),('5815','2013-10-25','12:05:00',1.86),('5815','2013-10-25','12:10:00',1.87),('5815','2013-10-25','12:15:00',1.84),('5815','2013-10-25','12:20:00',1.89),('5815','2013-10-25','12:25:00',1.86),('5815','2013-10-25','12:30:00',1.9),('5815','2013-10-25','12:35:00',1.93),('5815','2013-10-25','12:40:00',1.9),('5815','2013-10-25','12:45:00',1.88),('5815','2013-10-25','12:50:00',1.9),('5815','2013-10-25','12:55:00',1.89),('5815','2013-10-25','13:00:00',1.91),('5815','2013-10-25','13:05:00',1.9),('5815','2013-10-25','13:10:00',1.88),('5815','2013-10-25','13:15:00',1.75),('5815','2013-10-25','13:20:00',1.71),('5815','2013-10-25','13:25:00',1.81),('5815','2013-10-25','13:30:00',1.72),('5815','2013-10-25','13:35:00',1.82),('5815','2013-10-25','13:40:00',1.91),('5815','2013-10-25','13:45:00',1.8),('5815','2013-10-25','13:50:00',1.63),('5815','2013-10-25','13:55:00',1.76),('5815','2013-10-25','14:00:00',1.73),('5815','2013-10-25','14:05:00',1.62),('5815','2013-10-25','14:10:00',1.59),('5815','2013-10-25','14:15:00',1.67),('5815','2013-10-25','14:20:00',1.54),('5815','2013-10-25','14:25:00',1.11),('5815','2013-10-25','14:40:00',1.53),('5815','2013-10-25','14:45:00',1.54),('5815','2013-10-25','14:50:00',1.53),('5815','2013-10-25','14:55:00',1.47),('5815','2013-10-25','15:00:00',1.41),('5815','2013-10-25','15:05:00',1.31),('5815','2013-10-25','15:10:00',1.36),('5815','2013-10-25','15:15:00',1.23),('5815','2013-10-25','15:20:00',1.23),('5815','2013-10-25','15:25:00',1.22),('5815','2013-10-25','15:30:00',1.2),('5815','2013-10-25','15:35:00',1.2),('5815','2013-10-25','15:40:00',1.2),('5815','2013-10-25','15:45:00',1.05),('5815','2013-10-25','15:50:00',1.12),('5815','2013-10-25','15:55:00',1.01),('5815','2013-10-24','09:35:00',1.03),('5815','2013-10-24','09:40:00',1.08),('5815','2013-10-24','09:45:00',1.12),('5815','2013-10-24','09:50:00',1.17),('5815','2013-10-24','09:55:00',1.21),('5815','2013-10-24','10:00:00',1.25),('5815','2013-10-24','10:05:00',1.3),('5815','2013-10-24','10:10:00',1.34),('5815','2013-10-24','10:15:00',1.37),('5815','2013-10-24','10:20:00',1.41),('5815','2013-10-24','10:25:00',1.45),('5815','2013-10-24','10:30:00',1.49),('5815','2013-10-24','10:35:00',1.53),('5815','2013-10-24','10:40:00',1.55),('5815','2013-10-24','10:45:00',1.58),('5815','2013-10-24','10:50:00',1.61),('5815','2013-10-24','10:55:00',1.63),('5815','2013-10-24','11:00:00',1.66),('5815','2013-10-24','11:05:00',1.66),('5815','2013-10-24','11:10:00',1.7),('5815','2013-10-24','11:15:00',1.73),('5815','2013-10-24','11:20:00',1.74),('5815','2013-10-24','11:25:00',1.76),('5815','2013-10-24','11:30:00',1.77),('5815','2013-10-24','11:35:00',1.78),('5815','2013-10-24','11:40:00',1.79),('5815','2013-10-24','11:45:00',1.83),('5815','2013-10-24','11:50:00',1.85),('5815','2013-10-24','11:55:00',1.88),('5815','2013-10-24','12:00:00',1.89),('5815','2013-10-24','12:05:00',1.91),('5815','2013-10-24','12:10:00',1.92),('5815','2013-10-24','12:15:00',1.92),('5815','2013-10-24','12:20:00',1.94),('5815','2013-10-24','12:25:00',1.94),('5815','2013-10-24','12:30:00',1.95),('5815','2013-10-24','12:35:00',1.96),('5815','2013-10-24','12:40:00',1.96),('5815','2013-10-24','12:45:00',1.95),('5815','2013-10-24','12:50:00',1.94),('5815','2013-10-24','12:55:00',1.94),('5815','2013-10-24','13:00:00',1.97),('5815','2013-10-24','13:05:00',1.96),('5815','2013-10-24','13:10:00',1.94),('5815','2013-10-24','13:15:00',1.92),('5815','2013-10-24','13:20:00',1.92),('5815','2013-10-24','13:25:00',1.87),('5815','2013-10-24','13:30:00',1.86),('5815','2013-10-24','13:35:00',1.87),('5815','2013-10-24','13:40:00',1.89),('5815','2013-10-24','13:45:00',1.86),('5815','2013-10-24','13:50:00',1.86),('5815','2013-10-24','13:55:00',1.87),('5815','2013-10-24','14:00:00',1.84),('5815','2013-10-24','14:05:00',1.83),('5815','2013-10-24','14:10:00',1.82),('5815','2013-10-24','14:15:00',1.81),('5815','2013-10-24','14:20:00',1.79),('5815','2013-10-24','14:25:00',1.76),('5815','2013-10-24','14:30:00',1.72),('5815','2013-10-24','14:35:00',1.7),('5815','2013-10-24','14:40:00',1.7),('5815','2013-10-24','14:45:00',1.69),('5815','2013-10-24','14:50:00',1.67),('5815','2013-10-24','14:55:00',1.64),('5815','2013-10-24','15:00:00',1.58),('5815','2013-10-24','15:05:00',1.57),('5815','2013-10-24','15:10:00',1.54),('5815','2013-10-24','15:15:00',1.51),('5815','2013-10-24','15:20:00',1.47),('5815','2013-10-24','15:25:00',1.44),('5815','2013-10-24','15:30:00',1.37),('5815','2013-10-24','15:35:00',1.34),('5815','2013-10-24','15:40:00',1.27),('5815','2013-10-24','15:45:00',1.25),('5815','2013-10-24','15:50:00',1.2),('5815','2013-10-24','15:55:00',1.19),('5815','2013-10-24','16:00:00',1.15),('5815','2013-10-24','16:05:00',1.11),('5815','2013-10-24','16:10:00',1.06),('5815','2013-10-24','16:15:00',1.02),('5815','2013-10-23','10:45:00',1.57),('5815','2013-10-23','10:50:00',1.28),('5815','2013-10-23','10:55:00',1.55),('5815','2013-10-23','11:00:00',1.82),('5815','2013-10-23','11:05:00',1.92),('5815','2013-10-23','11:10:00',2.09),('5815','2013-10-23','11:25:00',1.51),('5815','2013-10-23','11:30:00',1.19),('5815','2013-10-23','11:50:00',1.06),('5815','2013-10-23','11:55:00',1.95),('5815','2013-10-23','12:00:00',1.09),('5815','2013-10-23','12:40:00',1.15),('5815','2013-10-23','12:45:00',1.26),('5815','2013-10-23','12:50:00',1.34),('5815','2013-10-23','12:55:00',1.37),('5815','2013-10-23','13:00:00',1.69),('5815','2013-10-23','13:05:00',2.27),('5815','2013-10-23','13:10:00',1.83),('5815','2013-10-23','13:15:00',1.43),('5815','2013-10-23','13:20:00',1.48),('5815','2013-10-23','13:25:00',1.53),('5815','2013-10-23','13:55:00',1.17),('5815','2013-10-23','14:00:00',1.38),('5815','2013-10-23','14:05:00',1.24),('5815','2013-10-23','14:35:00',1.13),('5815','2013-10-23','14:40:00',1.15),('5815','2013-10-23','14:45:00',1.2),('5815','2013-10-23','14:50:00',1.58),('5815','2013-10-23','15:10:00',1.53),('5815','2013-10-23','15:15:00',1.11),('5815','2013-10-23','15:35:00',1.54),('5815','2013-10-23','15:40:00',1.58),('5815','2013-10-23','15:45:00',1.19),('5815','2013-10-22','11:10:00',1.02),('5815','2013-10-22','11:15:00',1.77),('5815','2013-10-22','11:20:00',1.61),('5815','2013-10-22','11:25:00',1.77),('5815','2013-10-22','11:30:00',1.45),('5815','2013-10-22','11:35:00',1.75),('5815','2013-10-22','11:40:00',1.86),('5815','2013-10-22','11:45:00',1.81),('5815','2013-10-22','11:50:00',1.76),('5815','2013-10-22','11:55:00',1.79),('5815','2013-10-22','12:00:00',1.86),('5815','2013-10-22','12:05:00',1.84),('5815','2013-10-22','12:10:00',1.76),('5815','2013-10-22','12:15:00',1.82),('5815','2013-10-22','12:20:00',1.81),('5815','2013-10-22','12:25:00',1.85),('5815','2013-10-22','12:30:00',1.83),('5815','2013-10-22','12:35:00',1.81),('5815','2013-10-22','12:40:00',1.83),('5815','2013-10-22','12:45:00',1.67),('5815','2013-10-22','12:50:00',1.56),('5815','2013-10-22','12:55:00',1.33),('5815','2013-10-22','13:00:00',1.87),('5815','2013-10-22','13:05:00',1.83),('5815','2013-10-22','13:10:00',1.82),('5815','2013-10-22','13:15:00',1.85),('5815','2013-10-22','13:20:00',1.85),('5815','2013-10-22','13:25:00',1.86),('5815','2013-10-22','13:30:00',1.87),('5815','2013-10-22','13:35:00',1.86),('5815','2013-10-22','13:40:00',1.86),('5815','2013-10-22','13:45:00',1.85),('5815','2013-10-22','13:50:00',1.72),('5815','2013-10-22','13:55:00',1.28),('5815','2013-10-22','14:00:00',1.6),('5815','2013-10-22','14:05:00',1.64),('5815','2013-10-22','14:10:00',1.62),('5815','2013-10-22','14:15:00',1.76),('5815','2013-10-22','14:20:00',1.68),('5815','2013-10-22','14:25:00',1.61),('5815','2013-10-22','14:30:00',1.64),('5815','2013-10-22','14:35:00',1.59),('5815','2013-10-22','14:40:00',1.45),('5815','2013-10-22','14:45:00',1.45),('5815','2013-10-22','14:50:00',1.37),('5815','2013-10-22','14:55:00',1.52),('5815','2013-10-22','15:00:00',1.42),('5815','2013-10-22','15:05:00',1.49),('5815','2013-10-22','15:10:00',1.43),('5815','2013-10-22','15:15:00',1.46),('5815','2013-10-22','15:20:00',1.47),('5815','2013-10-22','15:25:00',1.47),('5815','2013-10-22','15:30:00',1.43),('5815','2013-10-22','15:35:00',1.34),('5815','2013-10-22','15:40:00',1.41),('5815','2013-10-22','15:45:00',1.35),('5815','2013-10-22','15:50:00',1.22),('5815','2013-10-21','09:35:00',1.02),('5815','2013-10-21','09:40:00',1.07),('5815','2013-10-21','09:45:00',1.11),('5815','2013-10-21','09:50:00',1.15),('5815','2013-10-21','09:55:00',1.19),('5815','2013-10-21','10:00:00',1.22),('5815','2013-10-21','10:05:00',1.26),('5815','2013-10-21','10:10:00',1.3),('5815','2013-10-21','10:15:00',1.35),('5815','2013-10-21','10:20:00',1.38),('5815','2013-10-21','10:25:00',1.39),('5815','2013-10-21','10:30:00',1.45),('5815','2013-10-21','10:35:00',1.48),('5815','2013-10-21','10:40:00',1.51),('5815','2013-10-21','10:45:00',1.55),('5815','2013-10-21','10:50:00',1.59),('5815','2013-10-21','10:55:00',1.59),('5815','2013-10-21','11:00:00',1.61),('5815','2013-10-21','11:05:00',1.65),('5815','2013-10-21','11:10:00',1.66),('5815','2013-10-21','11:15:00',1.69),('5815','2013-10-21','11:20:00',1.73),('5815','2013-10-21','11:25:00',1.73),('5815','2013-10-21','11:30:00',1.73),('5815','2013-10-21','11:35:00',1.75),('5815','2013-10-21','11:40:00',1.74),('5815','2013-10-21','11:45:00',1.74),('5815','2013-10-21','11:50:00',1.75),('5815','2013-10-21','11:55:00',1.78),('5815','2013-10-21','12:00:00',1.81),('5815','2013-10-21','12:05:00',1.83),('5815','2013-10-21','12:10:00',1.82),('5815','2013-10-21','12:15:00',1.82),('5815','2013-10-21','12:20:00',1.85),('5815','2013-10-21','12:25:00',1.87),('5815','2013-10-21','12:30:00',1.84),('5815','2013-10-21','12:35:00',1.85),('5815','2013-10-21','12:40:00',1.87),('5815','2013-10-21','12:45:00',1.87),('5815','2013-10-21','12:50:00',1.88),('5815','2013-10-21','12:55:00',1.82),('5815','2013-10-21','13:00:00',1.29),('5815','2013-10-21','13:05:00',1.72),('5815','2013-10-21','13:10:00',1.8),('5815','2013-10-21','13:15:00',1.8),('5815','2013-10-21','13:20:00',1.83),('5815','2013-10-21','13:25:00',1.84),('5815','2013-10-21','13:30:00',1.84),('5815','2013-10-21','13:35:00',1.75),('5815','2013-10-21','13:40:00',1.82),('5815','2013-10-21','13:45:00',1.81),('5815','2013-10-21','13:50:00',1.74),('5815','2013-10-21','13:55:00',1.72),('5815','2013-10-21','14:00:00',1.67),('5815','2013-10-21','14:05:00',1.76),('5815','2013-10-21','14:10:00',1.73),('5815','2013-10-21','14:15:00',1.64),('5815','2013-10-21','14:20:00',1.13),('5815','2013-10-21','14:25:00',1.52),('5815','2013-10-21','14:45:00',1.06),('5815','2013-10-21','14:50:00',1.42),('5815','2013-10-21','14:55:00',1.52),('5815','2013-10-21','15:00:00',1.44),('5815','2013-10-21','15:05:00',1.44),('5815','2013-10-21','15:10:00',1.46),('5815','2013-10-21','15:15:00',1.41),('5815','2013-10-21','15:20:00',1.36),('5815','2013-10-21','15:25:00',1.33),('5815','2013-10-21','15:30:00',1.26),('5815','2013-10-21','15:35:00',1.24),('5815','2013-10-21','15:40:00',1.22),('5815','2013-10-21','15:45:00',1.19),('5815','2013-10-21','15:50:00',1.15),('5815','2013-10-21','15:55:00',1.09),('5815','2013-10-21','16:00:00',1.01),('5815','2013-10-20','09:25:00',1),('5815','2013-10-20','09:40:00',1.08),('5815','2013-10-20','09:50:00',1.01),('5815','2013-10-20','09:55:00',1.12),('5815','2013-10-20','10:00:00',1.13),('5815','2013-10-20','10:05:00',1.25),('5815','2013-10-20','10:10:00',1.36),('5815','2013-10-20','10:15:00',1.41),('5815','2013-10-20','10:20:00',1.4),('5815','2013-10-20','10:25:00',1.47),('5815','2013-10-20','10:30:00',1.45),('5815','2013-10-20','10:35:00',1.46),('5815','2013-10-20','10:40:00',1.44),('5815','2013-10-20','10:45:00',1.49),('5815','2013-10-20','10:50:00',1.56),('5815','2013-10-20','10:55:00',1.57),('5815','2013-10-20','11:00:00',1.66),('5815','2013-10-20','11:05:00',1.57),('5815','2013-10-20','11:10:00',1.4),('5815','2013-10-20','11:15:00',1.77),('5815','2013-10-20','11:20:00',1.78),('5815','2013-10-20','11:25:00',1.76),('5815','2013-10-20','11:30:00',1.8),('5815','2013-10-20','11:35:00',1.82),('5815','2013-10-20','11:40:00',1.81),('5815','2013-10-20','11:45:00',1.89),('5815','2013-10-20','11:50:00',1.89),('5815','2013-10-20','11:55:00',1.9),('5815','2013-10-20','12:00:00',1.93),('5815','2013-10-20','12:05:00',1.95),('5815','2013-10-20','12:10:00',1.95),('5815','2013-10-20','12:15:00',1.94),('5815','2013-10-20','12:20:00',1.94),('5815','2013-10-20','12:25:00',1.96),('5815','2013-10-20','12:30:00',1.88),('5815','2013-10-20','12:35:00',1.91),('5815','2013-10-20','12:40:00',1.97),('5815','2013-10-20','12:45:00',1.98),('5815','2013-10-20','12:50:00',1.96),('5815','2013-10-20','12:55:00',1.95),('5815','2013-10-20','13:00:00',1.94),('5815','2013-10-20','13:05:00',1.91),('5815','2013-10-20','13:10:00',1.81),('5815','2013-10-20','13:15:00',1.86),('5815','2013-10-20','13:20:00',1.88),('5815','2013-10-20','13:25:00',1.87),('5815','2013-10-20','13:30:00',1.94),('5815','2013-10-20','13:35:00',1.93),('5815','2013-10-20','13:40:00',1.89),('5815','2013-10-20','13:45:00',1.86),('5815','2013-10-20','13:50:00',1.86),('5815','2013-10-20','13:55:00',1.83),('5815','2013-10-20','14:00:00',1.77),('5815','2013-10-20','14:05:00',1.84),('5815','2013-10-20','14:10:00',1.82),('5815','2013-10-20','14:15:00',1.8),('5815','2013-10-20','14:20:00',1.79),('5815','2013-10-20','14:25:00',1.76),('5815','2013-10-20','14:30:00',1.73),('5815','2013-10-20','14:35:00',1.74),('5815','2013-10-20','14:40:00',1.65),('5815','2013-10-20','14:45:00',1.59),('5815','2013-10-20','14:50:00',1.56),('5815','2013-10-20','14:55:00',1.55),('5815','2013-10-20','15:00:00',1.58),('5815','2013-10-20','15:05:00',1.55),('5815','2013-10-20','15:10:00',1.51),('5815','2013-10-20','15:15:00',1.48),('5815','2013-10-20','15:20:00',1.5),('5815','2013-10-20','15:25:00',1.44),('5815','2013-10-20','15:30:00',1.34),('5815','2013-10-20','15:35:00',1.28),('5815','2013-10-20','15:40:00',1.31),('5815','2013-10-20','15:45:00',1.28),('5815','2013-10-20','15:50:00',1.23),('5815','2013-10-20','15:55:00',1.19),('5815','2013-10-20','16:00:00',1.16),('5815','2013-10-20','16:05:00',1.11),('5815','2013-10-20','16:10:00',1.08),('5815','2013-10-20','16:15:00',1.03),('5815','2013-10-19','09:25:00',1.01),('5815','2013-10-19','09:30:00',1.04),('5815','2013-10-19','09:35:00',1.09),('5815','2013-10-19','09:40:00',1.14),('5815','2013-10-19','09:45:00',1.18),('5815','2013-10-19','09:50:00',1.22),('5815','2013-10-19','09:55:00',1.24),('5815','2013-10-19','10:00:00',1.31),('5815','2013-10-19','10:05:00',1.36),('5815','2013-10-19','10:10:00',1.41),('5815','2013-10-19','10:15:00',1.44),('5815','2013-10-19','10:20:00',1.47),('5815','2013-10-19','10:25:00',1.51),('5815','2013-10-19','10:30:00',1.54),('5815','2013-10-19','10:35:00',1.57),('5815','2013-10-19','10:40:00',1.6),('5815','2013-10-19','10:45:00',1.64),('5815','2013-10-19','10:50:00',1.66),('5815','2013-10-19','10:55:00',1.68),('5815','2013-10-19','11:00:00',1.71),('5815','2013-10-19','11:05:00',1.74),('5815','2013-10-19','11:10:00',1.77),('5815','2013-10-19','11:15:00',1.78),('5815','2013-10-19','11:20:00',1.8),('5815','2013-10-19','11:25:00',1.83),('5815','2013-10-19','11:30:00',1.86),('5815','2013-10-19','11:35:00',1.88),('5815','2013-10-19','11:40:00',1.9),('5815','2013-10-19','11:45:00',1.91),('5815','2013-10-19','11:50:00',1.93),('5815','2013-10-19','11:55:00',1.91),('5815','2013-10-19','12:00:00',1.94),('5815','2013-10-19','12:05:00',1.96),('5815','2013-10-19','12:10:00',1.99),('5815','2013-10-19','12:15:00',1.32),('5815','2013-10-19','12:30:00',1.82),('5815','2013-10-19','12:35:00',1.57),('5815','2013-10-19','12:40:00',1.76),('5815','2013-10-19','12:50:00',1.09),('5815','2013-10-19','12:55:00',1.76),('5815','2013-10-19','13:00:00',1.71),('5815','2013-10-19','13:05:00',1.59),('5815','2013-10-19','13:10:00',2.3),('5815','2013-10-19','13:15:00',1.4),('5815','2013-10-19','13:25:00',1.04),('5815','2013-10-19','13:30:00',1.48),('5815','2013-10-19','13:35:00',1.52),('5815','2013-10-19','13:45:00',1.55),('5815','2013-10-19','13:55:00',1.09),('5815','2013-10-18','09:15:00',1.13),('5815','2013-10-18','09:20:00',1.15),('5815','2013-10-18','09:25:00',1.17),('5815','2013-10-18','09:30:00',1.2),('5815','2013-10-18','09:35:00',1.23),('5815','2013-10-18','09:40:00',1.29),('5815','2013-10-18','09:45:00',1.36),('5815','2013-10-18','09:50:00',1.41),('5815','2013-10-18','09:55:00',1.47),('5815','2013-10-18','10:00:00',1.48),('5815','2013-10-18','10:05:00',1.4),('5815','2013-10-18','10:10:00',1.51),('5815','2013-10-18','10:15:00',1.5),('5815','2013-10-18','10:20:00',1.61),('5815','2013-10-18','10:25:00',1.74),('5815','2013-10-18','10:30:00',1.76),('5815','2013-10-18','10:35:00',1.78),('5815','2013-10-18','10:40:00',1.78),('5815','2013-10-18','10:45:00',1.77),('5815','2013-10-18','10:50:00',1.82),('5815','2013-10-18','10:55:00',1.87),('5815','2013-10-18','11:00:00',1.89),('5815','2013-10-18','11:05:00',1.69),('5815','2013-10-18','11:10:00',1.1),('5815','2013-10-18','11:20:00',1.35),('5815','2013-10-18','11:25:00',2.15),('5815','2013-10-18','11:30:00',2.09),('5815','2013-10-18','11:35:00',2.09),('5815','2013-10-18','11:40:00',1.98),('5815','2013-10-18','11:45:00',2.05),('5815','2013-10-18','11:50:00',2.01),('5815','2013-10-18','11:55:00',2.05),('5815','2013-10-18','12:00:00',2.13),('5815','2013-10-18','12:05:00',2.13),('5815','2013-10-18','12:10:00',2.09),('5815','2013-10-18','12:15:00',2.09),('5815','2013-10-18','12:20:00',2.13),('5815','2013-10-18','12:25:00',1.92),('5815','2013-10-18','12:30:00',2.08),('5815','2013-10-18','12:35:00',2.14),('5815','2013-10-18','12:40:00',2.18),('5815','2013-10-18','12:45:00',2.23),('5815','2013-10-18','12:50:00',2.28),('5815','2013-10-18','12:55:00',2.19),('5815','2013-10-18','13:00:00',2.37),('5815','2013-10-18','13:05:00',1.85),('5815','2013-10-18','13:10:00',1.93),('5815','2013-10-18','13:15:00',1.97),('5815','2013-10-18','13:20:00',1.94),('5815','2013-10-18','13:25:00',2.16),('5815','2013-10-18','13:30:00',2.19),('5815','2013-10-18','13:35:00',1.87),('5815','2013-10-18','13:40:00',1.69),('5815','2013-10-18','13:45:00',1.73),('5815','2013-10-18','13:50:00',1.81),('5815','2013-10-18','13:55:00',2.25),('5815','2013-10-18','14:00:00',1.86),('5815','2013-10-18','14:05:00',1.6),('5815','2013-10-18','14:10:00',1.22),('5815','2013-10-18','14:15:00',1.54),('5815','2013-10-18','14:20:00',1.39),('5815','2013-10-18','14:25:00',1.39),('5815','2013-10-18','14:30:00',1.61),('5815','2013-10-18','14:35:00',2.2),('5815','2013-10-18','14:40:00',1.67),('5815','2013-10-18','14:45:00',1.35),('5815','2013-10-18','14:50:00',1.97),('5815','2013-10-18','14:55:00',1.91),('5815','2013-10-18','15:00:00',1.85),('5815','2013-10-18','15:05:00',1.8),('5815','2013-10-18','15:10:00',1.78),('5815','2013-10-18','15:15:00',1.76),('5815','2013-10-18','15:20:00',1.65),('5815','2013-10-18','15:25:00',1.59),('5815','2013-10-18','15:30:00',1.52),('5815','2013-10-18','15:35:00',1.51),('5815','2013-10-18','15:40:00',1.4),('5815','2013-10-18','15:45:00',1.19),('5815','2013-10-18','15:50:00',1.25),('5815','2013-10-18','15:55:00',1.41),('5815','2013-10-18','16:00:00',1.19),('5815','2013-10-18','16:05:00',1.27),('5815','2013-10-18','16:10:00',1.21),('5815','2013-10-18','16:15:00',1.28),('5815','2013-10-18','16:20:00',1.21),('5815','2013-10-18','16:30:00',1.09),('5815','2013-10-18','16:35:00',1.14),('5815','2013-10-18','16:40:00',1.09),('5815','2014-05-03','08:30:00',1.09),('5815','2014-05-03','08:35:00',1.07),('5815','2014-05-03','09:05:00',1.28),('5815','2014-05-03','09:10:00',1.04),('5815','2014-05-03','09:15:00',1.34),('5815','2014-05-03','09:20:00',2),('5815','2014-05-03','09:25:00',1.52),('5815','2014-05-03','09:40:00',1.09),('5815','2014-05-03','09:45:00',1.38),('5815','2014-05-03','09:50:00',1.38),('5815','2014-05-03','09:55:00',1.53),('5815','2014-05-03','10:00:00',2.07),('5815','2014-05-03','10:05:00',1.99),('5815','2014-05-03','10:10:00',2.1),('5815','2014-05-03','10:15:00',1.51),('5815','2014-05-03','10:20:00',1.09),('5815','2014-05-03','10:25:00',1.06),('5815','2014-05-03','10:30:00',1.1),('5815','2014-05-03','10:35:00',1.16),('5815','2014-05-03','10:40:00',1.21),('5815','2014-05-03','10:45:00',1.69),('5815','2014-05-03','10:50:00',1.64),('5815','2014-05-03','10:55:00',1.53),('5815','2014-05-03','11:00:00',1.49),('5815','2014-05-03','11:05:00',2.18),('5815','2014-05-03','11:10:00',2.4),('5815','2014-05-03','11:15:00',2.39),('5815','2014-05-03','11:20:00',2.22),('5815','2014-05-03','11:25:00',1.95),('5815','2014-05-03','11:30:00',2.24),('5815','2014-05-03','11:35:00',2.22),('5815','2014-05-03','11:40:00',1.73),('5815','2014-05-03','11:45:00',2.55),('5815','2014-05-03','11:50:00',1.62),('5815','2014-05-03','11:55:00',2.03),('5815','2014-05-03','12:00:00',1.82),('5815','2014-05-03','12:05:00',1.67),('5815','2014-05-03','12:10:00',1.46),('5815','2014-05-03','12:20:00',1.02),('5815','2014-05-03','12:25:00',1.82),('5815','2014-05-03','12:30:00',2.95),('5815','2014-05-03','12:35:00',2.81),('5815','2014-05-03','12:40:00',2.85),('5815','2014-05-03','12:45:00',1.96),('5815','2014-05-03','12:50:00',1.37),('5815','2014-05-03','12:55:00',1.33),('5815','2014-05-03','13:00:00',1.39),('5815','2014-05-03','13:05:00',1.31),('5815','2014-05-03','13:10:00',1.34),('5815','2014-05-03','13:15:00',1.15),('5815','2014-05-03','13:20:00',1.03),('5815','2014-05-03','15:00:00',1.07),('5815','2014-05-03','15:05:00',1.82),('5815','2014-05-03','15:10:00',1.84),('5815','2014-05-03','15:15:00',1.58),('5815','2014-04-15','08:50:00',1.12),('5815','2014-04-15','08:55:00',1.17),('5815','2014-04-15','09:00:00',1.23),('5815','2014-04-15','09:05:00',1.29),('5815','2014-04-15','09:10:00',1.34),('5815','2014-04-15','09:15:00',1.38),('5815','2014-04-15','09:20:00',1.43),('5815','2014-04-15','09:25:00',1.51),('5815','2014-04-15','09:50:00',1.36),('5815','2014-04-15','09:55:00',1.94),('5815','2014-04-15','10:00:00',1.9),('5815','2014-04-15','10:05:00',1.92),('5815','2014-04-15','10:10:00',1.96),('5815','2014-04-15','10:15:00',2.01),('5815','2014-04-15','10:20:00',2.05),('5815','2014-04-15','10:25:00',2.08),('5815','2014-04-15','10:30:00',2.12),('5815','2014-04-15','10:35:00',2.15),('5815','2014-04-15','10:40:00',2.19),('5815','2014-04-15','10:45:00',2.22),('5815','2014-04-15','10:50:00',2.3),('5815','2014-04-15','10:55:00',2.08),('5815','2014-04-15','11:00:00',2.25),('5815','2014-04-15','11:05:00',1.82),('5815','2014-04-15','11:15:00',1.34),('5815','2014-04-15','11:20:00',2.64),('5815','2014-04-15','11:25:00',1.73),('5815','2014-04-15','11:30:00',2.24),('5815','2014-04-15','11:35:00',1.6),('5815','2014-04-15','11:40:00',2.24),('5815','2014-04-15','11:45:00',2.49),('5815','2014-04-15','11:50:00',2.86),('5815','2014-04-15','11:55:00',2.73),('5815','2014-04-15','12:00:00',2.8),('5815','2014-04-15','12:05:00',1.04),('5815','2014-04-15','12:10:00',2.48),('5815','2014-04-15','12:15:00',2.62),('5815','2014-04-15','12:20:00',2.23),('5815','2014-04-15','12:30:00',1.7),('5815','2014-04-15','12:35:00',2.76),('5815','2014-04-15','12:40:00',2.83),('5815','2014-04-15','12:45:00',2.77),('5815','2014-04-15','12:50:00',2.8),('5815','2014-04-15','12:55:00',1.93),('5815','2014-04-15','13:00:00',1.54),('5815','2014-04-15','13:40:00',1.21),('5815','2014-04-15','13:45:00',2.57),('5815','2014-04-15','13:50:00',2.46),('5815','2014-04-15','13:55:00',1.45),('5815','2014-04-15','14:00:00',1.04),('5815','2014-04-15','14:05:00',1.97),('5815','2014-04-15','14:10:00',2.81),('5815','2014-04-15','14:15:00',2.95),('5815','2014-04-15','14:20:00',2.59),('5815','2014-04-15','14:25:00',2.25),('5815','2014-04-15','14:30:00',2.31),('5815','2014-04-15','14:35:00',2.6),('5815','2014-04-15','14:40:00',2.55),('5815','2014-04-15','14:45:00',1.69),('5815','2014-04-15','14:50:00',2.03),('5815','2014-04-15','15:00:00',1.02),('5815','2014-04-15','15:05:00',1.94),('5815','2014-04-15','15:10:00',2.85),('5815','2014-04-15','15:15:00',1.6),('5815','2014-04-15','15:30:00',2.21),('5815','2014-04-15','15:35:00',2.49),('5815','2014-04-15','15:40:00',2.42),('5815','2014-04-15','15:45:00',2.33),('5815','2014-04-15','15:50:00',2.27),('5815','2014-04-15','15:55:00',2.21),('5815','2014-04-15','16:00:00',2.14),('5815','2014-04-15','16:05:00',2.08),('5815','2014-04-15','16:10:00',2.03),('5815','2014-04-15','16:15:00',2),('5815','2014-04-15','16:20:00',1.98),('5815','2014-04-15','16:25:00',1.91),('5815','2014-04-15','16:30:00',1.86),('5815','2014-04-15','16:35:00',1.83),('5815','2014-04-15','16:40:00',1.79),('5815','2014-04-15','16:45:00',1.75),('5815','2014-04-15','16:50:00',1.68),('5815','2014-04-15','16:55:00',1.62),('5815','2014-04-15','17:00:00',1.57),('5815','2014-04-15','17:05:00',1.51),('5815','2014-04-15','17:10:00',1.46),('5815','2014-04-15','17:15:00',1.41),('5815','2014-04-15','17:20:00',1.34),('5815','2014-04-15','17:25:00',1.27),('5815','2014-04-15','17:30:00',1.22),('5815','2014-04-15','17:35:00',1.03),('5815','2014-04-15','17:40:00',1.03),('5815','2014-04-15','17:45:00',1.03),('5815','2014-04-15','17:50:00',1.02),('5815','2013-10-17','09:15:00',1.01),('5815','2013-10-17','09:20:00',1.1),('5815','2013-10-17','09:25:00',1.13),('5815','2013-10-17','09:30:00',1.2),('5815','2013-10-17','09:35:00',1.25),('5815','2013-10-17','09:40:00',1.3),('5815','2013-10-17','09:45:00',1.35),('5815','2013-10-17','09:50:00',1.37),('5815','2013-10-17','09:55:00',1.43),('5815','2013-10-17','10:00:00',1.46),('5815','2013-10-17','10:05:00',1.51),('5815','2013-10-17','10:10:00',1.54),('5815','2013-10-17','10:15:00',1.58),('5815','2013-10-17','10:20:00',1.6),('5815','2013-10-17','10:25:00',1.65),('5815','2013-10-17','10:30:00',1.68),('5815','2013-10-17','10:35:00',1.72),('5815','2013-10-17','10:40:00',1.76),('5815','2013-10-17','10:45:00',1.78),('5815','2013-10-17','10:50:00',1.8),('5815','2013-10-17','10:55:00',1.84),('5815','2013-10-17','11:00:00',1.83),('5815','2013-10-17','11:05:00',1.82),('5815','2013-10-17','11:10:00',1.8),('5815','2013-10-17','11:15:00',1.67),('5815','2013-10-17','11:20:00',1.89),('5815','2013-10-17','11:25:00',1.74),('5815','2013-10-17','11:30:00',1.96),('5815','2013-10-17','11:35:00',1.98),('5815','2013-10-17','11:40:00',2.04),('5815','2013-10-17','11:45:00',1.99),('5815','2013-10-17','11:50:00',2.01),('5815','2013-10-17','11:55:00',2.06),('5815','2013-10-17','12:00:00',1.98),('5815','2013-10-17','12:05:00',2.06),('5815','2013-10-17','12:10:00',2.07),('5815','2013-10-17','12:15:00',2.04),('5815','2013-10-17','12:20:00',2.03),('5815','2013-10-17','12:25:00',2.08),('5815','2013-10-17','12:30:00',2.1),('5815','2013-10-17','12:35:00',2.03),('5815','2013-10-17','12:40:00',2.09),('5815','2013-10-17','12:45:00',2.03),('5815','2013-10-17','12:50:00',2.01),('5815','2013-10-17','12:55:00',2.07),('5815','2013-10-17','13:00:00',2.05),('5815','2013-10-17','13:05:00',2.01),('5815','2013-10-17','13:10:00',1.94),('5815','2013-10-17','13:15:00',2.03),('5815','2013-10-17','13:20:00',2.04),('5815','2013-10-17','13:25:00',2.11),('5815','2013-10-17','13:30:00',2.09),('5815','2013-10-17','13:35:00',2.06),('5815','2013-10-17','13:40:00',2.06),('5815','2013-10-17','13:45:00',2.02),('5815','2013-10-17','13:50:00',2.02),('5815','2013-10-17','13:55:00',2.01),('5815','2013-10-17','14:00:00',1.85),('5815','2013-10-17','14:05:00',1.91),('5815','2013-10-17','14:10:00',1.9),('5815','2013-10-17','14:15:00',1.94),('5815','2013-10-17','14:20:00',1.93),('5815','2013-10-17','14:25:00',1.92),('5815','2013-10-17','14:30:00',1.89),('5815','2013-10-17','14:35:00',1.83),('5815','2013-10-17','14:40:00',1.83),('5815','2013-10-17','14:45:00',1.79),('5815','2013-10-17','14:50:00',1.73),('5815','2013-10-17','14:55:00',1.74),('5815','2013-10-17','15:00:00',1.57),('5815','2013-10-17','15:05:00',1.42),('5815','2013-10-17','15:10:00',1.52),('5815','2013-10-17','15:15:00',1.54),('5815','2013-10-17','15:20:00',1.61),('5815','2013-10-17','15:25:00',1.54),('5815','2013-10-17','15:30:00',1.48),('5815','2013-10-17','15:35:00',1.47),('5815','2013-10-17','15:40:00',1.41),('5815','2013-10-17','15:45:00',1.28),('5815','2013-10-17','15:50:00',1.3),('5815','2013-10-17','15:55:00',1.21),('5815','2013-10-17','16:00:00',1.26),('5815','2013-10-17','16:05:00',1.18),('5815','2013-10-17','16:10:00',1.14),('5815','2013-10-17','16:15:00',1.03),('5815','2013-10-16','09:15:00',1.05),('5815','2013-10-16','09:20:00',1.1),('5815','2013-10-16','09:25:00',1.15),('5815','2013-10-16','09:30:00',1.19),('5815','2013-10-16','09:35:00',1.24),('5815','2013-10-16','09:40:00',1.29),('5815','2013-10-16','09:45:00',1.33),('5815','2013-10-16','09:50:00',1.38),('5815','2013-10-16','09:55:00',1.42),('5815','2013-10-16','10:00:00',1.46),('5815','2013-10-16','10:05:00',1.5),('5815','2013-10-16','10:10:00',1.54),('5815','2013-10-16','10:15:00',1.58),('5815','2013-10-16','10:20:00',1.62),('5815','2013-10-16','10:25:00',1.66),('5815','2013-10-16','10:30:00',1.7),('5815','2013-10-16','10:35:00',1.73),('5815','2013-10-16','10:40:00',1.76),('5815','2013-10-16','10:45:00',1.8),('5815','2013-10-16','10:50:00',1.81),('5815','2013-10-16','10:55:00',1.85),('5815','2013-10-16','11:00:00',1.87),('5815','2013-10-16','11:05:00',1.9),('5815','2013-10-16','11:10:00',1.92),('5815','2013-10-16','11:15:00',1.94),('5815','2013-10-16','11:20:00',1.96),('5815','2013-10-16','11:25:00',1.99),('5815','2013-10-16','11:30:00',2.02),('5815','2013-10-16','11:35:00',2.05),('5815','2013-10-16','11:40:00',2.07),('5815','2013-10-16','11:45:00',2.06),('5815','2013-10-16','11:50:00',2.07),('5815','2013-10-16','11:55:00',2.09),('5815','2013-10-16','12:00:00',2.09),('5815','2013-10-16','12:05:00',2.09),('5815','2013-10-16','12:10:00',2.12),('5815','2013-10-16','12:15:00',2.14),('5815','2013-10-16','12:20:00',2.13),('5815','2013-10-16','12:25:00',2.14),('5815','2013-10-16','12:30:00',2.16),('5815','2013-10-16','12:35:00',2.16),('5815','2013-10-16','12:40:00',2.16),('5815','2013-10-16','12:45:00',2.18),('5815','2013-10-16','12:50:00',2.18),('5815','2013-10-16','12:55:00',2.18),('5815','2013-10-16','13:00:00',2.16),('5815','2013-10-16','13:05:00',2.15),('5815','2013-10-16','13:10:00',2.14),('5815','2013-10-16','13:15:00',2.15),('5815','2013-10-16','13:20:00',2.17),('5815','2013-10-16','13:25:00',2.15),('5815','2013-10-16','13:30:00',2.13),('5815','2013-10-16','13:35:00',2.1),('5815','2013-10-16','13:40:00',2.1),('5815','2013-10-16','13:45:00',2.09),('5815','2013-10-16','13:50:00',2.07),('5815','2013-10-16','13:55:00',2.08),('5815','2013-10-16','14:00:00',2.07),('5815','2013-10-16','14:05:00',2.05),('5815','2013-10-16','14:10:00',2.04),('5815','2013-10-16','14:15:00',2.02),('5815','2013-10-16','14:20:00',1.99),('5815','2013-10-16','14:25:00',1.97),('5815','2013-10-16','14:30:00',1.95),('5815','2013-10-16','14:35:00',1.93),('5815','2013-10-16','14:40:00',1.91),('5815','2013-10-16','14:45:00',1.89),('5815','2013-10-16','14:50:00',1.85),('5815','2013-10-16','14:55:00',1.83),('5815','2013-10-16','15:00:00',1.81),('5815','2013-10-16','15:05:00',1.78),('5815','2013-10-16','15:10:00',1.76),('5815','2013-10-16','15:15:00',1.74),('5815','2013-10-16','15:20:00',1.7),('5815','2013-10-16','15:25:00',1.68),('5815','2013-10-16','15:30:00',1.64),('5815','2013-10-16','15:35:00',1.59),('5815','2013-10-16','15:40:00',1.53),('5815','2013-10-16','15:45:00',1.49),('5815','2013-10-16','15:50:00',1.46),('5815','2013-10-16','15:55:00',1.42),('5815','2013-10-16','16:00:00',1.37),('5815','2013-10-16','16:05:00',1.32),('5815','2013-10-16','16:10:00',1.28),('5815','2013-10-16','16:15:00',1.24),('5815','2013-10-16','16:20:00',1.19),('5815','2013-10-16','16:25:00',1.15),('5815','2013-10-16','16:30:00',1.11),('5815','2013-10-16','16:35:00',1.06),('5815','2013-10-16','16:40:00',1),('5815','2013-10-15','09:50:00',1.03),('5815','2013-10-15','12:20:00',1.76),('5815','2013-10-15','12:40:00',2.29),('5815','2013-10-15','12:45:00',2.35),('5815','2013-10-15','12:50:00',2.25),('5815','2013-10-15','12:55:00',1.93),('5815','2013-10-15','13:00:00',1.51),('5815','2013-10-15','13:05:00',2.04),('5815','2013-10-15','13:10:00',2.28),('5815','2013-10-15','13:15:00',1.59),('5815','2013-10-15','13:20:00',1.5),('5815','2013-10-15','13:25:00',2.13),('5815','2013-10-15','13:30:00',1.83),('5815','2013-10-15','13:35:00',2.12),('5815','2013-10-15','13:40:00',2.21),('5815','2013-10-15','13:45:00',2.16),('5815','2013-10-15','13:50:00',2.12),('5815','2013-10-15','13:55:00',2.25),('5815','2013-10-15','14:00:00',1.88),('5815','2013-10-15','14:05:00',1.44),('5815','2013-10-15','14:10:00',1.97),('5815','2013-10-15','14:15:00',1.33),('5815','2013-10-15','14:20:00',2.01),('5815','2013-10-15','14:25:00',1.01),('5815','2013-10-15','14:30:00',1.62),('5815','2013-10-15','14:35:00',1.63),('5815','2013-10-15','14:40:00',1.58),('5815','2013-10-15','14:45:00',2.04),('5815','2013-10-15','14:50:00',1.96),('5815','2013-10-15','14:55:00',1.68),('5815','2013-10-15','15:00:00',1.85),('5815','2013-10-15','15:05:00',1.86),('5815','2013-10-15','15:10:00',1.83),('5815','2013-10-15','15:15:00',1.81),('5815','2013-10-15','15:20:00',1.77),('5815','2013-10-15','15:25:00',1.42),('5815','2013-10-15','15:35:00',1.43),('5815','2013-10-15','15:40:00',1.69),('5815','2013-10-15','15:45:00',1.53),('5815','2013-10-15','15:50:00',1.48),('5815','2013-10-15','15:55:00',1.44),('5815','2013-10-15','16:00:00',1.41),('5815','2013-10-15','16:05:00',1.36),('5815','2013-10-15','16:10:00',1.28),('5815','2013-10-15','16:15:00',1.25),('5815','2013-10-15','16:20:00',1.2),('5815','2013-10-15','16:25:00',1.16),('5815','2013-10-15','16:30:00',1.08),('5815','2013-10-15','16:35:00',1.04),('5815','2013-10-15','16:40:00',1.01),('5815','2013-10-14','09:45:00',1.18),('5815','2013-10-14','09:50:00',1.34),('5815','2013-10-14','09:55:00',1.4),('5815','2013-10-14','10:00:00',1.39),('5815','2013-10-14','10:05:00',1.49),('5815','2013-10-14','10:10:00',1.18),('5815','2013-10-14','10:30:00',1.21),('5815','2013-10-14','10:40:00',1.19),('5815','2013-10-14','10:45:00',1.36),('5815','2013-10-14','10:50:00',1.34),('5815','2013-10-14','10:55:00',1.13),('5815','2013-10-14','11:00:00',1.13),('5815','2013-10-14','11:05:00',1.18),('5815','2013-10-14','11:10:00',1.6),('5815','2013-10-14','11:15:00',1.7),('5815','2013-10-14','11:20:00',1.72),('5815','2013-10-14','11:25:00',1.64),('5815','2013-10-14','11:30:00',1.68),('5815','2013-10-14','11:35:00',1.44),('5815','2013-10-14','11:40:00',1.13),('5815','2013-10-14','13:10:00',1.08),('5815','2013-10-14','13:15:00',1.11),('5815','2013-10-14','13:20:00',1.62),('5815','2013-10-14','13:25:00',1.93),('5815','2013-10-14','13:30:00',1.21),('5815','2013-10-14','13:35:00',1.01),('5815','2013-10-14','14:15:00',1.02),('5815','2013-10-14','14:20:00',1.2),('5815','2013-10-14','14:25:00',1.34),('5815','2013-10-14','14:30:00',1.36),('5815','2013-10-14','14:40:00',1.24),('5815','2013-10-14','14:45:00',1.39),('5815','2013-10-14','14:50:00',1.51),('5815','2013-10-14','14:55:00',1.31),('5815','2013-10-13','09:25:00',1.05),('5815','2013-10-13','09:30:00',1.16),('5815','2013-10-13','09:35:00',1.13),('5815','2013-10-13','09:50:00',1.06),('5815','2013-10-13','09:55:00',1.26),('5815','2013-10-13','10:00:00',1.22),('5815','2013-10-13','10:05:00',1.35),('5815','2013-10-13','10:10:00',1.42),('5815','2013-10-13','10:15:00',1.5),('5815','2013-10-13','10:20:00',1.53),('5815','2013-10-13','10:25:00',1.56),('5815','2013-10-13','10:30:00',1.58),('5815','2013-10-13','10:35:00',1.6),('5815','2013-10-13','10:40:00',1.58),('5815','2013-10-13','10:45:00',1.63),('5815','2013-10-13','10:50:00',1.7),('5815','2013-10-13','10:55:00',1.72),('5815','2013-10-13','11:00:00',1.76),('5815','2013-10-13','11:05:00',1.73),('5815','2013-10-13','11:10:00',1.82),('5815','2013-10-13','11:15:00',1.83),('5815','2013-10-13','11:20:00',1.83),('5815','2013-10-13','11:25:00',1.88),('5815','2013-10-13','11:30:00',1.92),('5815','2013-10-13','11:35:00',1.88),('5815','2013-10-13','11:40:00',1.9),('5815','2013-10-13','11:45:00',1.87),('5815','2013-10-13','11:50:00',1.9),('5815','2013-10-13','11:55:00',1.92),('5815','2013-10-13','12:00:00',1.93),('5815','2013-10-13','12:05:00',1.94),('5815','2013-10-13','12:10:00',1.98),('5815','2013-10-13','12:15:00',1.97),('5815','2013-10-13','12:20:00',1.83),('5815','2013-10-13','12:25:00',1.92),('5815','2013-10-13','12:30:00',2.05),('5815','2013-10-13','12:35:00',2.03),('5815','2013-10-13','12:40:00',2.03),('5815','2013-10-13','12:45:00',2.01),('5815','2013-10-13','12:50:00',2.02),('5815','2013-10-13','12:55:00',2.02),('5815','2013-10-13','13:00:00',2.02),('5815','2013-10-13','13:05:00',2.02),('5815','2013-10-13','13:10:00',2.03),('5815','2013-10-13','13:15:00',2.02),('5815','2013-10-13','13:20:00',2.02),('5815','2013-10-13','13:25:00',2.01),('5815','2013-10-13','13:30:00',2),('5815','2013-10-13','13:35:00',1.98),('5815','2013-10-13','13:40:00',1.98),('5815','2013-10-13','13:45:00',1.97),('5815','2013-10-13','13:50:00',1.95),('5815','2013-10-13','13:55:00',1.94),('5815','2013-10-13','14:00:00',1.92),('5815','2013-10-13','14:05:00',1.92),('5815','2013-10-13','14:10:00',1.91),('5815','2013-10-13','14:15:00',1.89),('5815','2013-10-13','14:20:00',1.87),('5815','2013-10-13','14:25:00',1.86),('5815','2013-10-13','14:30:00',1.84),('5815','2013-10-13','14:35:00',1.81),('5815','2013-10-13','14:40:00',1.79),('5815','2013-10-13','14:45:00',1.78),('5815','2013-10-13','14:50:00',1.77),('5815','2013-10-13','14:55:00',1.74),('5815','2013-10-13','15:00:00',1.71),('5815','2013-10-13','15:05:00',1.66),('5815','2013-10-13','15:10:00',1.63),('5815','2013-10-13','15:15:00',1.59),('5815','2013-10-13','15:20:00',1.56),('5815','2013-10-13','15:25:00',1.52),('5815','2013-10-13','15:30:00',1.48),('5815','2013-10-13','15:35:00',1.43),('5815','2013-10-13','15:40:00',1.25),('5815','2013-10-13','15:45:00',1.16),('5815','2013-10-13','15:50:00',1.05),('5815','2013-10-13','16:00:00',1.03),('5815','2013-10-12','09:15:00',1.01),('5815','2013-10-12','09:20:00',1.1),('5815','2013-10-12','09:25:00',1.03),('5815','2013-10-12','09:40:00',1.14),('5815','2013-10-12','09:45:00',1.61),('5815','2013-10-12','09:50:00',1.58),('5815','2013-10-12','09:55:00',1.64),('5815','2013-10-12','10:00:00',1.33),('5815','2013-10-12','10:10:00',1.18),('5815','2013-10-12','10:15:00',1.41),('5815','2013-10-12','10:20:00',1.16),('5815','2013-10-12','10:25:00',1.25),('5815','2013-10-12','10:30:00',1.59),('5815','2013-10-12','10:35:00',1.89),('5815','2013-10-12','10:40:00',1.96),('5815','2013-10-12','10:45:00',1.99),('5815','2013-10-12','10:50:00',1.83),('5815','2013-10-12','10:55:00',1.29),('5815','2013-10-12','11:00:00',1.69),('5815','2013-10-12','11:05:00',1.8),('5815','2013-10-12','11:10:00',1.92),('5815','2013-10-12','11:15:00',1.97),('5815','2013-10-12','11:20:00',1.91),('5815','2013-10-12','11:25:00',1.89),('5815','2013-10-12','11:30:00',1.93),('5815','2013-10-12','11:35:00',1.92),('5815','2013-10-12','11:40:00',1.93),('5815','2013-10-12','11:45:00',1.94),('5815','2013-10-12','11:50:00',1.96),('5815','2013-10-12','11:55:00',1.97),('5815','2013-10-12','12:00:00',1.99),('5815','2013-10-12','12:05:00',2),('5815','2013-10-12','12:10:00',2.01),('5815','2013-10-12','12:15:00',2.03),('5815','2013-10-12','12:20:00',2.02),('5815','2013-10-12','12:25:00',1.94),('5815','2013-10-12','12:30:00',2.02),('5815','2013-10-12','12:35:00',2.07),('5815','2013-10-12','12:40:00',2.06),('5815','2013-10-12','12:45:00',2.02),('5815','2013-10-12','12:50:00',2.01),('5815','2013-10-12','12:55:00',2.04),('5815','2013-10-12','13:00:00',2.04),('5815','2013-10-12','13:05:00',2.03),('5815','2013-10-12','13:10:00',2.05),('5815','2013-10-12','13:15:00',2.08),('5815','2013-10-12','13:20:00',2.08),('5815','2013-10-12','13:25:00',1.88),('5815','2013-10-12','13:30:00',1.51),('5815','2013-10-12','13:35:00',1.89),('5815','2013-10-12','13:40:00',1.18),('5815','2013-10-12','13:45:00',1.29),('5815','2013-10-12','13:50:00',1.38),('5815','2013-10-12','13:55:00',1.54),('5815','2013-10-12','14:00:00',1.96),('5815','2013-10-12','14:05:00',2.01),('5815','2013-10-12','14:10:00',1.97),('5815','2013-10-12','14:15:00',1.82),('5815','2013-10-12','14:20:00',1.98),('5815','2013-10-12','14:25:00',1.99),('5815','2013-10-12','14:30:00',1.87),('5815','2013-10-12','14:35:00',1.41),('5815','2013-10-12','14:40:00',1.73),('5815','2013-10-12','14:45:00',1.44),('5815','2013-10-12','14:50:00',1.11),('5815','2013-10-12','14:55:00',1.31),('5815','2013-10-12','15:00:00',1.57),('5815','2013-10-12','15:05:00',1.51),('5815','2013-10-12','15:10:00',1.04),('5815','2013-10-12','15:15:00',1.09),('5815','2013-10-12','15:20:00',1.32),('5815','2013-10-12','15:25:00',1.42),('5815','2013-10-12','15:30:00',1.06),('5815','2013-10-12','16:05:00',1.11),('5815','2013-10-12','16:25:00',1.15),('5815','2013-10-12','16:30:00',1.18),('5815','2013-10-12','16:35:00',1.06),('5815','2013-10-11','11:35:00',1),('5815','2013-10-11','11:40:00',1.79),('5815','2013-10-11','12:20:00',1.02),('5815','2013-10-11','12:25:00',2.22),('5815','2013-10-11','12:30:00',1.63),('5815','2013-10-11','12:35:00',1.96),('5815','2013-10-11','12:40:00',1.91),('5815','2013-10-11','12:45:00',1.75),('5815','2013-10-11','12:50:00',1.93),('5815','2013-10-11','12:55:00',1.65),('5815','2013-10-11','13:00:00',1.14),('5815','2013-10-11','13:30:00',2.01),('5815','2013-10-11','16:15:00',1.08),('5815','2013-10-10','09:45:00',1.38),('5815','2013-10-10','09:50:00',1.41),('5815','2013-10-10','09:55:00',1.44),('5815','2013-10-10','10:00:00',1.48),('5815','2013-10-10','10:05:00',1.49),('5815','2013-10-10','10:10:00',1.56),('5815','2013-10-10','10:15:00',1.38),('5815','2013-10-10','10:20:00',1.43),('5815','2013-10-10','10:25:00',1.05),('5815','2013-10-10','10:30:00',1.37),('5815','2013-10-10','10:35:00',1.93),('5815','2013-10-10','11:05:00',1.53),('5815','2013-10-10','11:10:00',1.72),('5815','2013-10-10','11:40:00',1.15),('5815','2013-10-10','11:45:00',1.01),('5815','2013-10-10','11:50:00',1.24),('5815','2013-10-10','11:55:00',1.05),('5815','2013-10-10','12:00:00',1.47),('5815','2013-10-10','12:05:00',2.46),('5815','2013-10-10','12:10:00',1.07),('5815','2013-10-10','12:30:00',1.13),('5815','2013-10-10','13:05:00',1.54),('5815','2013-10-10','13:20:00',1.13),('5815','2013-10-10','13:25:00',2.17),('5815','2013-10-10','13:40:00',1.61),('5815','2013-10-10','13:45:00',2.27),('5815','2013-10-10','16:00:00',1.35),('5815','2013-10-10','16:35:00',1.09),('5815','2013-10-09','09:15:00',1.04),('5815','2013-10-09','09:20:00',1.1),('5815','2013-10-09','09:25:00',1.09),('5815','2013-10-09','09:30:00',1.12),('5815','2013-10-09','09:35:00',1.02),('5815','2013-10-09','09:40:00',1.07),('5815','2013-10-09','09:45:00',1.01),('5815','2013-10-09','10:15:00',1.16),('5815','2013-10-09','10:20:00',1.61),('5815','2013-10-09','10:25:00',1.59),('5815','2013-10-09','10:30:00',1.64),('5815','2013-10-09','10:45:00',1.15),('5815','2013-10-09','11:25:00',1.95),('5815','2013-10-09','11:30:00',1.43),('5815','2013-10-09','11:55:00',2.01),('5815','2013-10-09','12:00:00',2.17),('5815','2013-10-09','12:05:00',1.56),('5815','2013-10-09','12:25:00',1.83),('5815','2013-10-09','12:35:00',2.23),('5815','2013-10-09','12:40:00',2.51),('5815','2013-10-09','12:45:00',1.89),('5815','2013-10-09','12:50:00',1.7),('5815','2013-10-09','13:00:00',1.73),('5815','2013-10-09','13:05:00',2.47),('5815','2013-10-09','13:10:00',1.58),('5815','2013-10-09','13:15:00',1.06),('5815','2013-10-09','13:25:00',1.61),('5815','2013-10-09','13:30:00',1.57),('5815','2013-10-09','13:35:00',1.37),('5815','2013-10-09','13:40:00',1.26),('5815','2013-10-09','13:45:00',2.17),('5815','2013-10-09','13:50:00',2.21),('5815','2013-10-09','13:55:00',2.27),('5815','2013-10-09','14:00:00',2.24),('5815','2013-10-09','14:05:00',1.56),('5815','2013-10-09','14:10:00',1.27),('5815','2013-10-09','14:15:00',1.16),('5815','2013-10-09','14:20:00',2.29),('5815','2013-10-09','14:25:00',2.19),('5815','2013-10-09','14:30:00',1.58),('5815','2013-10-09','14:35:00',1.26),('5815','2013-10-09','14:40:00',2.26),('5815','2013-10-09','14:45:00',2.07),('5815','2013-10-09','14:50:00',2.1),('5815','2013-10-09','14:55:00',2.08),('5815','2013-10-09','15:00:00',1.89),('5815','2013-10-09','15:05:00',2.08),('5815','2013-10-09','15:10:00',1.98),('5815','2013-10-09','15:15:00',2),('5815','2013-10-09','15:20:00',1.48),('5815','2013-10-09','15:25:00',1.26),('5815','2013-10-09','15:30:00',1.07),('5815','2013-10-09','16:15:00',1.18),('5815','2013-10-09','16:20:00',1.23),('5815','2013-10-09','16:25:00',1.29),('5815','2013-10-09','16:30:00',1.1),('5815','2013-10-09','16:45:00',1.11),('5815','2013-10-09','16:50:00',1.04),('5815','2013-10-08','09:10:00',1.04),('5815','2013-10-08','09:15:00',1.03),('5815','2013-10-08','09:25:00',1.19),('5815','2013-10-08','09:30:00',1.23),('5815','2013-10-08','09:35:00',1.28),('5815','2013-10-08','09:40:00',1.34),('5815','2013-10-08','09:45:00',1.4),('5815','2013-10-08','09:50:00',1.44),('5815','2013-10-08','09:55:00',1.51),('5815','2013-10-08','10:00:00',1.59),('5815','2013-10-08','10:05:00',1.64),('5815','2013-10-08','10:10:00',1.75),('5815','2013-10-08','10:35:00',1.12),('5815','2013-10-08','10:45:00',1.22),('5815','2013-10-08','10:50:00',2.25),('5815','2013-10-08','10:55:00',1.09),('5815','2013-10-08','11:00:00',1.72),('5815','2013-10-08','11:05:00',1.87),('5815','2013-10-08','11:10:00',2.39),('5815','2013-10-08','11:15:00',2.32),('5815','2013-10-08','11:20:00',2.15),('5815','2013-10-08','11:25:00',1.78),('5815','2013-10-08','11:30:00',2.3),('5815','2013-10-08','11:35:00',2.45),('5815','2013-10-08','11:40:00',1.96),('5815','2013-10-08','11:45:00',1.69),('5815','2013-10-08','11:50:00',2.01),('5815','2013-10-08','11:55:00',2.1),('5815','2013-10-08','12:00:00',1.73),('5815','2013-10-08','12:10:00',1.41),('5815','2013-10-08','12:15:00',1.32),('5815','2013-10-08','12:20:00',1.83),('5815','2013-10-08','12:25:00',2.2),('5815','2013-10-08','13:15:00',1.02),('5815','2013-10-08','13:20:00',1.13),('5815','2013-10-08','13:25:00',1.24),('5815','2013-10-08','13:30:00',1.24),('5815','2013-10-08','13:35:00',1.32),('5815','2013-10-08','13:40:00',2.09),('5815','2013-10-08','13:45:00',1.79),('5815','2013-10-08','13:50:00',1.79),('5815','2013-10-08','13:55:00',2.58),('5815','2013-10-08','14:00:00',2.36),('5815','2013-10-08','14:10:00',1.29),('5815','2013-10-08','14:55:00',1.68),('5815','2013-10-08','15:00:00',1.22),('5815','2013-10-08','15:05:00',1.84),('5815','2013-10-08','15:10:00',2.07),('5815','2013-10-08','15:15:00',1.89),('5815','2013-10-08','15:20:00',1.77),('5815','2013-10-08','15:25:00',1.74),('5815','2013-10-08','15:30:00',1.31),('5815','2013-10-08','15:35:00',1.08),('5815','2013-10-08','15:40:00',1.43),('5815','2013-10-08','15:50:00',1.22),('5815','2013-10-08','16:20:00',1.11),('5815','2013-10-08','16:30:00',1.55),('5815','2013-10-08','16:40:00',1.15),('5815','2014-04-14','09:05:00',1.07),('5815','2014-04-14','09:15:00',1.07),('5815','2014-04-14','09:25:00',1.28),('5815','2014-04-14','09:30:00',1.23),('5815','2014-04-14','09:50:00',1.75),('5815','2014-04-14','10:15:00',1.27),('5815','2014-04-14','10:30:00',1.02),('5815','2014-04-14','10:35:00',1.95),('5815','2014-04-14','10:40:00',1.14),('5815','2014-04-14','10:45:00',1.67),('5815','2014-04-14','10:50:00',1.42),('5815','2014-04-14','11:05:00',1.93),('5815','2014-04-14','11:10:00',1.84),('5815','2014-04-14','12:20:00',1.07),('5815','2014-04-14','13:20:00',1.59),('5815','2014-04-14','13:25:00',1.02),('5815','2014-04-14','13:30:00',1.67),('5815','2014-04-14','13:35:00',1.42),('5815','2014-04-14','13:40:00',1.68),('5815','2014-04-14','14:00:00',1.12),('5815','2014-04-14','14:05:00',1.63),('5815','2014-04-14','14:15:00',1.97),('5815','2014-04-14','14:20:00',1.73),('5815','2014-04-14','14:25:00',2.19),('5815','2014-04-14','14:30:00',1.59),('5815','2014-04-14','14:35:00',1.3),('5815','2014-04-14','15:25:00',1.33),('5815','2013-10-07','11:10:00',1.61),('5815','2013-10-07','11:15:00',2.4),('5815','2013-10-07','11:20:00',2.2),('5815','2013-10-07','11:25:00',1.16),('5815','2013-10-07','11:30:00',1.81),('5815','2013-10-07','11:35:00',1.56),('5815','2013-10-07','12:30:00',2.05),('5815','2013-10-07','12:35:00',1.15),('5815','2013-10-07','12:40:00',2.72),('5815','2013-10-07','12:45:00',2.41),('5815','2013-10-07','12:50:00',2.45),('5815','2013-10-07','12:55:00',2.43),('5815','2013-10-07','13:00:00',2.1),('5815','2013-10-07','13:05:00',2.21),('5815','2013-10-07','13:10:00',1.45),('5815','2013-10-07','13:15:00',2.3),('5815','2013-10-07','13:20:00',1.06),('5815','2013-10-07','13:25:00',1.93),('5815','2013-10-07','13:30:00',1.18),('5815','2013-10-07','14:10:00',1.33),('5815','2013-10-07','14:15:00',1.4),('5815','2013-10-07','14:20:00',1.71),('5815','2013-10-07','14:25:00',1.7),('5815','2013-10-07','14:30:00',1.79),('5815','2013-10-07','14:45:00',1.88),('5815','2013-10-07','14:50:00',2.14),('5815','2013-10-07','14:55:00',2.02),('5815','2013-10-07','15:00:00',1.98),('5815','2013-10-07','15:05:00',1.99),('5815','2013-10-07','15:10:00',1.97),('5815','2013-10-07','15:15:00',1.8),('5815','2013-10-07','15:20:00',1.61),('5815','2013-10-07','15:25:00',1.4),('5815','2013-10-07','15:30:00',2.06),('5815','2013-10-07','15:35:00',1.98),('5815','2013-10-07','15:40:00',1.67),('5815','2013-10-07','15:45:00',1.11),('5815','2013-10-07','15:50:00',1.41),('5815','2013-10-07','15:55:00',1.13),('5815','2013-10-06','09:05:00',1.08),('5815','2013-10-06','09:10:00',1.05),('5815','2013-10-06','09:15:00',1.09),('5815','2013-10-06','09:20:00',1.13),('5815','2013-10-06','09:25:00',1.17),('5815','2013-10-06','09:30:00',1.22),('5815','2013-10-06','09:35:00',1.27),('5815','2013-10-06','09:40:00',1.32),('5815','2013-10-06','09:45:00',1.36),('5815','2013-10-06','09:50:00',1.4),('5815','2013-10-06','09:55:00',1.44),('5815','2013-10-06','10:00:00',1.47),('5815','2013-10-06','10:05:00',1.53),('5815','2013-10-06','10:10:00',1.55),('5815','2013-10-06','10:15:00',1.58),('5815','2013-10-06','10:20:00',1.64),('5815','2013-10-06','10:25:00',1.68),('5815','2013-10-06','10:30:00',1.72),('5815','2013-10-06','10:35:00',1.8),('5815','2013-10-06','10:40:00',1.8),('5815','2013-10-06','10:45:00',1.84),('5815','2013-10-06','10:50:00',1.86),('5815','2013-10-06','10:55:00',1.65),('5815','2013-10-06','11:00:00',1.72),('5815','2013-10-06','11:05:00',1.95),('5815','2013-10-06','11:10:00',1.59),('5815','2013-10-06','11:15:00',1.66),('5815','2013-10-06','11:20:00',1.93),('5815','2013-10-06','11:25:00',2.02),('5815','2013-10-06','11:30:00',2.02),('5815','2013-10-06','11:35:00',2.05),('5815','2013-10-06','11:40:00',2.07),('5815','2013-10-06','11:45:00',2.07),('5815','2013-10-06','11:50:00',2.08),('5815','2013-10-06','11:55:00',2.12),('5815','2013-10-06','12:00:00',2.12),('5815','2013-10-06','12:05:00',1.79),('5815','2013-10-06','12:10:00',2.31),('5815','2013-10-06','12:15:00',1.73),('5815','2013-10-06','12:20:00',1.7),('5815','2013-10-06','12:25:00',2.21),('5815','2013-10-06','12:30:00',2.42),('5815','2013-10-06','12:35:00',2.24),('5815','2013-10-06','12:40:00',2.34),('5815','2013-10-06','12:45:00',2.35),('5815','2013-10-06','12:50:00',2.34),('5815','2013-10-06','12:55:00',2.39),('5815','2013-10-06','13:00:00',2.05),('5815','2013-10-06','13:05:00',2.35),('5815','2013-10-06','13:10:00',2.35),('5815','2013-10-06','13:15:00',1.42),('5815','2013-10-06','13:20:00',2.11),('5815','2013-10-06','13:25:00',2.13),('5815','2013-10-06','13:30:00',2.3),('5815','2013-10-06','13:40:00',1.09),('5815','2013-10-06','13:50:00',1.54),('5815','2013-10-06','13:55:00',2.42),('5815','2013-10-06','14:00:00',2.61),('5815','2013-10-06','14:05:00',1.44),('5815','2013-10-06','14:25:00',1.92),('5815','2013-10-06','14:35:00',1.17),('5815','2013-10-06','14:40:00',1.29),('5815','2013-10-06','14:45:00',1.94),('5815','2013-10-06','14:50:00',2.31),('5815','2013-10-06','14:55:00',2.3),('5815','2013-10-06','15:00:00',1.61),('5815','2013-10-06','15:05:00',1.18),('5815','2013-10-06','15:10:00',1.82),('5815','2013-10-06','15:25:00',1.4),('5815','2013-10-06','15:30:00',1.24),('5815','2013-10-06','15:40:00',1.19),('5815','2013-10-06','15:45:00',1.61),('5815','2013-10-06','15:50:00',1.19),('5815','2013-10-06','15:55:00',1.86),('5815','2013-10-06','16:10:00',1.25),('5815','2013-10-06','16:15:00',1.57),('5815','2013-10-06','16:20:00',1.49),('5815','2013-10-06','16:25:00',1.1),('5815','2013-10-06','16:30:00',1.37),('5815','2013-10-06','16:35:00',1.08),('5815','2013-10-06','16:40:00',1.25),('5815','2013-10-06','16:45:00',1.19),('5815','2013-10-06','16:50:00',1.12),('5815','2013-10-06','16:55:00',1),('5815','2013-10-05','09:50:00',1.23),('5815','2013-10-05','09:55:00',1.47),('5815','2013-10-05','10:00:00',1.71),('5815','2013-10-05','10:05:00',1.75),('5815','2013-10-05','10:10:00',1.7),('5815','2013-10-05','10:15:00',1.58),('5815','2013-10-05','10:20:00',1.59),('5815','2013-10-05','10:25:00',1.78),('5815','2013-10-05','10:30:00',1.74),('5815','2013-10-05','10:35:00',1.73),('5815','2013-10-05','10:40:00',1.47),('5815','2013-10-05','10:45:00',1.19),('5815','2013-10-05','10:50:00',1.31),('5815','2013-10-05','10:55:00',1.46),('5815','2013-10-05','11:00:00',1.51),('5815','2013-10-05','11:05:00',1.68),('5815','2013-10-05','11:10:00',1.76),('5815','2013-10-05','11:15:00',1.7),('5815','2013-10-05','11:20:00',1.7),('5815','2013-10-05','11:25:00',1.82),('5815','2013-10-05','11:30:00',1.76),('5815','2013-10-05','11:35:00',1.74),('5815','2013-10-05','11:40:00',1.51),('5815','2013-10-05','11:45:00',1.14),('5815','2013-10-05','11:50:00',1.22),('5815','2013-10-05','11:55:00',1.61),('5815','2013-10-05','12:00:00',1.65),('5815','2013-10-05','12:05:00',1.67),('5815','2013-10-05','12:10:00',2.06),('5815','2013-10-05','12:15:00',2.01),('5815','2013-10-05','12:20:00',1.74),('5815','2013-10-05','12:25:00',1.52),('5815','2013-10-05','12:30:00',1.63),('5815','2013-10-05','12:35:00',1.71),('5815','2013-10-05','12:40:00',1.46),('5815','2013-10-05','12:45:00',1.45),('5815','2013-10-05','12:50:00',1.71),('5815','2013-10-05','12:55:00',2.04),('5815','2013-10-05','13:00:00',2.11),('5815','2013-10-05','13:05:00',2.03),('5815','2013-10-05','13:10:00',1.58),('5815','2013-10-05','13:20:00',1.91),('5815','2013-10-05','13:50:00',2.1),('5815','2013-10-05','13:55:00',1.36),('5815','2013-10-05','14:00:00',1.13),('5815','2013-10-05','14:05:00',2.14),('5815','2013-10-05','14:10:00',2.17),('5815','2013-10-05','14:15:00',1.44),('5815','2013-10-05','14:20:00',1.16),('5815','2013-10-05','14:30:00',1.07),('5815','2013-10-05','14:50:00',1.11),('5815','2013-10-05','14:55:00',1.52),('5815','2013-10-05','15:00:00',1.3),('5815','2013-10-03','09:55:00',1.56),('5815','2013-10-03','10:00:00',1.22),('5815','2013-10-03','10:15:00',1.06),('5815','2013-10-03','10:25:00',1.32),('5815','2013-10-03','10:30:00',1.14),('5815','2013-10-03','10:40:00',1.66),('5815','2013-10-03','10:45:00',1.41),('5815','2013-10-03','10:50:00',1.01),('5815','2013-10-03','10:55:00',1.59),('5815','2013-10-03','11:00:00',1.44),('5815','2013-10-03','11:05:00',1.01),('5815','2013-10-03','11:15:00',2.08),('5815','2013-10-03','11:20:00',1.76),('5815','2013-10-03','11:25:00',1.77),('5815','2013-10-03','11:30:00',2.27),('5815','2013-10-03','11:35:00',2.27),('5815','2013-10-03','11:40:00',2.24),('5815','2013-10-03','11:45:00',2.2),('5815','2013-10-03','11:50:00',2.16),('5815','2013-10-03','11:55:00',2.16),('5815','2013-10-03','12:00:00',2.15),('5815','2013-10-03','12:05:00',2.18),('5815','2013-10-03','12:10:00',2.21),('5815','2013-10-03','12:15:00',2),('5815','2013-10-03','12:20:00',2.12),('5815','2013-10-03','12:25:00',2.25),('5815','2013-10-03','12:30:00',2.04),('5815','2013-10-03','12:35:00',1.97),('5815','2013-10-03','12:40:00',2.2),('5815','2013-10-03','12:45:00',2.21),('5815','2013-10-03','12:50:00',2.12),('5815','2013-10-03','12:55:00',2.15),('5815','2013-10-03','13:00:00',2.17),('5815','2013-10-03','13:05:00',2.19),('5815','2013-10-03','13:10:00',2.19),('5815','2013-10-03','13:15:00',2.3),('5815','2013-10-03','13:20:00',2.26),('5815','2013-10-03','13:25:00',2.13),('5815','2013-10-03','13:30:00',2.26),('5815','2013-10-03','13:35:00',1.63),('5815','2013-10-03','13:40:00',2.18),('5815','2013-10-03','13:45:00',2.14),('5815','2013-10-03','13:50:00',2.12),('5815','2013-10-03','13:55:00',2.12),('5815','2013-10-03','14:00:00',2.11),('5815','2013-10-03','14:05:00',2.09),('5815','2013-10-03','14:10:00',1.93),('5815','2013-10-03','14:15:00',1.76),('5815','2013-10-03','14:20:00',1.84),('5815','2013-10-03','14:25:00',2.02),('5815','2013-10-03','14:30:00',1.76),('5815','2013-10-03','14:35:00',1.26),('5815','2013-10-03','14:40:00',1.04),('5815','2013-10-03','14:45:00',1.12),('5815','2013-10-03','14:50:00',1.53),('5815','2013-10-03','14:55:00',1.59),('5815','2013-10-03','15:00:00',1.37),('5815','2013-10-03','15:05:00',1.55),('5815','2013-10-03','15:10:00',1.37),('5815','2013-10-03','15:15:00',1.07),('5815','2013-10-03','15:25:00',1.35),('5815','2013-10-03','15:30:00',1.67),('5815','2013-10-03','15:35:00',1.02),('5815','2013-10-02','09:05:00',1.05),('5815','2013-10-02','09:10:00',1.11),('5815','2013-10-02','09:15:00',1.17),('5815','2013-10-02','09:20:00',1.22),('5815','2013-10-02','09:25:00',1.28),('5815','2013-10-02','09:30:00',1.33),('5815','2013-10-02','09:35:00',1.38),('5815','2013-10-02','09:40:00',1.43),('5815','2013-10-02','09:45:00',1.48),('5815','2013-10-02','09:50:00',1.53),('5815','2013-10-02','09:55:00',1.57),('5815','2013-10-02','10:00:00',1.62),('5815','2013-10-02','10:05:00',1.67),('5815','2013-10-02','10:10:00',1.71),('5815','2013-10-02','10:15:00',1.76),('5815','2013-10-02','10:20:00',1.79),('5815','2013-10-02','10:25:00',1.83),('5815','2013-10-02','10:30:00',1.87),('5815','2013-10-02','10:35:00',1.88),('5815','2013-10-02','10:40:00',1.93),('5815','2013-10-02','10:45:00',1.97),('5815','2013-10-02','10:50:00',1.99),('5815','2013-10-02','10:55:00',2.03),('5815','2013-10-02','11:00:00',2.05),('5815','2013-10-02','11:05:00',2.07),('5815','2013-10-02','11:10:00',2.1),('5815','2013-10-02','11:15:00',2.13),('5815','2013-10-02','11:20:00',2.15),('5815','2013-10-02','11:25:00',2.18),('5815','2013-10-02','11:30:00',2.19),('5815','2013-10-02','11:35:00',2.22),('5815','2013-10-02','11:40:00',2.24),('5815','2013-10-02','11:45:00',2.25),('5815','2013-10-02','11:50:00',2.27),('5815','2013-10-02','11:55:00',2.31),('5815','2013-10-02','12:00:00',2.31),('5815','2013-10-02','12:05:00',2.31),('5815','2013-10-02','12:10:00',2.33),('5815','2013-10-02','12:15:00',2.32),('5815','2013-10-02','12:20:00',2.32),('5815','2013-10-02','12:25:00',2.34),('5815','2013-10-02','12:30:00',2.36),('5815','2013-10-02','12:35:00',2.37),('5815','2013-10-02','12:40:00',2.36),('5815','2013-10-02','12:45:00',2.36),('5815','2013-10-02','12:50:00',2.37),('5815','2013-10-02','12:55:00',2.37),('5815','2013-10-02','13:00:00',2.35),('5815','2013-10-02','13:05:00',2.33),('5815','2013-10-02','13:10:00',2.34),('5815','2013-10-02','13:15:00',2.33),('5815','2013-10-02','13:20:00',2.32),('5815','2013-10-02','13:25:00',2.32),('5815','2013-10-02','13:30:00',2.33),('5815','2013-10-02','13:35:00',2.32),('5815','2013-10-02','13:40:00',2.31),('5815','2013-10-02','13:45:00',2.3),('5815','2013-10-02','13:50:00',2.28),('5815','2013-10-02','13:55:00',2.29),('5815','2013-10-02','14:00:00',2.28),('5815','2013-10-02','14:05:00',2.28),('5815','2013-10-02','14:10:00',2.26),('5815','2013-10-02','14:15:00',2.24),('5815','2013-10-02','14:20:00',2.22),('5815','2013-10-02','14:25:00',2.2),('5815','2013-10-02','14:30:00',2.18),('5815','2013-10-02','14:35:00',2.15),('5815','2013-10-02','14:40:00',2.13),('5815','2013-10-02','14:45:00',2.11),('5815','2013-10-02','14:50:00',2.08),('5815','2013-10-02','14:55:00',2.06),('5815','2013-10-02','15:00:00',2.03),('5815','2013-10-02','15:05:00',2),('5815','2013-10-02','15:10:00',1.97),('5815','2013-10-02','15:15:00',1.94),('5815','2013-10-02','15:20:00',1.91),('5815','2013-10-02','15:25:00',1.88),('5815','2013-10-02','15:30:00',1.84),('5815','2013-10-02','15:35:00',1.8),('5815','2013-10-02','15:40:00',1.76),('5815','2013-10-02','15:45:00',1.72),('5815','2013-10-02','15:50:00',1.68),('5815','2013-10-02','15:55:00',1.64),('5815','2013-10-02','16:00:00',1.6),('5815','2013-10-02','16:05:00',1.53),('5815','2013-10-02','16:10:00',1.51),('5815','2013-10-02','16:15:00',1.46),('5815','2013-10-02','16:20:00',1.42),('5815','2013-10-02','16:25:00',1.37),('5815','2013-10-02','16:30:00',1.32),('5815','2013-10-02','16:35:00',1.26),('5815','2013-10-02','16:40:00',1.21),('5815','2013-10-02','16:45:00',1.16),('5815','2013-10-02','16:50:00',1.11),('5815','2013-10-02','16:55:00',1.05),('5815','2013-10-01','09:10:00',1.05),('5815','2013-10-01','09:15:00',1.11),('5815','2013-10-01','09:20:00',1.16),('5815','2013-10-01','09:25:00',1.21),('5815','2013-10-01','09:30:00',1.26),('5815','2013-10-01','09:35:00',1.31),('5815','2013-10-01','09:40:00',1.35),('5815','2013-10-01','09:45:00',1.4),('5815','2013-10-01','09:50:00',1.44),('5815','2013-10-01','09:55:00',1.48),('5815','2013-10-01','10:00:00',1.52),('5815','2013-10-01','10:05:00',1.55),('5815','2013-10-01','10:10:00',1.59),('5815','2013-10-01','10:15:00',1.63),('5815','2013-10-01','10:20:00',1.68),('5815','2013-10-01','10:25:00',1.72),('5815','2013-10-01','10:30:00',1.75),('5815','2013-10-01','10:35:00',1.79),('5815','2013-10-01','10:40:00',1.84),('5815','2013-10-01','10:45:00',1.87),('5815','2013-10-01','10:50:00',1.91),('5815','2013-10-01','10:55:00',1.94),('5815','2013-10-01','11:00:00',1.97),('5815','2013-10-01','11:05:00',1.99),('5815','2013-10-01','11:10:00',2.02),('5815','2013-10-01','11:15:00',2.04),('5815','2013-10-01','11:20:00',2.07),('5815','2013-10-01','11:25:00',2.08),('5815','2013-10-01','11:30:00',2.1),('5815','2013-10-01','11:35:00',2.12),('5815','2013-10-01','11:40:00',2.15),('5815','2013-10-01','11:45:00',2.17),('5815','2013-10-01','11:50:00',2.17),('5815','2013-10-01','11:55:00',2.19),('5815','2013-10-01','12:00:00',2.21),('5815','2013-10-01','12:05:00',2.17),('5815','2013-10-01','12:10:00',2.23),('5815','2013-10-01','12:15:00',2.24),('5815','2013-10-01','12:20:00',2.24),('5815','2013-10-01','12:25:00',2.24),('5815','2013-10-01','12:30:00',2.24),('5815','2013-10-01','12:35:00',2.26),('5815','2013-10-01','12:40:00',2.26),('5815','2013-10-01','12:45:00',2.27),('5815','2013-10-01','12:50:00',2.28),('5815','2013-10-01','12:55:00',2.28),('5815','2013-10-01','13:00:00',2.27),('5815','2013-10-01','13:05:00',2.28),('5815','2013-10-01','13:10:00',2.27),('5815','2013-10-01','13:15:00',2.27),('5815','2013-10-01','13:20:00',2.26),('5815','2013-10-01','13:25:00',2.27),('5815','2013-10-01','13:30:00',2.27),('5815','2013-10-01','13:35:00',2.25),('5815','2013-10-01','13:40:00',2.26),('5815','2013-10-01','13:45:00',2.25),('5815','2013-10-01','13:50:00',2.24),('5815','2013-10-01','13:55:00',2.21),('5815','2013-10-01','14:00:00',2.21),('5815','2013-10-01','14:05:00',2.19),('5815','2013-10-01','14:10:00',2.18),('5815','2013-10-01','14:15:00',2.17),('5815','2013-10-01','14:20:00',2.14),('5815','2013-10-01','14:25:00',2.13),('5815','2013-10-01','14:30:00',2.11),('5815','2013-10-01','14:35:00',2.1),('5815','2013-10-01','14:40:00',2.07),('5815','2013-10-01','14:45:00',2.05),('5815','2013-10-01','14:50:00',2.03),('5815','2013-10-01','14:55:00',2.01),('5815','2013-10-01','15:00:00',1.99),('5815','2013-10-01','15:05:00',1.96),('5815','2013-10-01','15:10:00',1.92),('5815','2013-10-01','15:15:00',1.89),('5815','2013-10-01','15:20:00',1.86),('5815','2013-10-01','15:25:00',1.82),('5815','2013-10-01','15:30:00',1.79),('5815','2013-10-01','15:35:00',1.76),('5815','2013-10-01','15:40:00',1.73),('5815','2013-10-01','15:45:00',1.69),('5815','2013-10-01','15:50:00',1.63),('5815','2013-10-01','15:55:00',1.59),('5815','2013-10-01','16:00:00',1.56),('5815','2013-10-01','16:05:00',1.52),('5815','2013-10-01','16:10:00',1.47),('5815','2013-10-01','16:15:00',1.43),('5815','2013-10-01','16:20:00',1.38),('5815','2013-10-01','16:25:00',1.33),('5815','2013-10-01','16:30:00',1.29),('5815','2013-10-01','16:35:00',1.24),('5815','2013-10-01','16:40:00',1.18),('5815','2013-10-01','16:45:00',1.12),('5815','2013-10-01','16:50:00',1.07),('5815','2013-10-01','16:55:00',1.02),('5815','2013-09-30','09:05:00',1),('5815','2013-09-30','09:10:00',1.05),('5815','2013-09-30','09:15:00',1.11),('5815','2013-09-30','09:20:00',1.15),('5815','2013-09-30','09:25:00',1.19),('5815','2013-09-30','09:30:00',1.24),('5815','2013-09-30','09:35:00',1.28),('5815','2013-09-30','09:40:00',1.32),('5815','2013-09-30','09:45:00',1.37),('5815','2013-09-30','09:50:00',1.41),('5815','2013-09-30','09:55:00',1.46),('5815','2013-09-30','10:00:00',1.5),('5815','2013-09-30','10:05:00',1.54),('5815','2013-09-30','10:10:00',1.58),('5815','2013-09-30','10:15:00',1.62),('5815','2013-09-30','10:20:00',1.66),('5815','2013-09-30','10:25:00',1.69),('5815','2013-09-30','10:30:00',1.74),('5815','2013-09-30','10:35:00',1.78),('5815','2013-09-30','10:40:00',1.8),('5815','2013-09-30','10:45:00',1.82),('5815','2013-09-30','10:50:00',1.85),('5815','2013-09-30','10:55:00',1.87),('5815','2013-09-30','11:00:00',1.93),('5815','2013-09-30','11:05:00',1.21),('5815','2013-09-30','11:10:00',2.16),('5815','2013-09-30','11:15:00',1.55),('5815','2013-09-30','11:20:00',2.08),('5815','2013-09-30','11:25:00',1.66),('5815','2013-09-30','11:30:00',2.15),('5815','2013-09-30','11:35:00',1.58),('5815','2013-09-30','11:40:00',2.21),('5815','2013-09-30','11:45:00',2.26),('5815','2013-09-30','11:50:00',2.27),('5815','2013-09-30','11:55:00',2.23),('5815','2013-09-30','12:00:00',1.97),('5815','2013-09-30','12:10:00',1.83),('5815','2013-09-30','12:15:00',2.23),('5815','2013-09-30','12:20:00',2.33),('5815','2013-09-30','12:25:00',2.24),('5815','2013-09-30','12:30:00',2.4),('5815','2013-09-30','12:35:00',2.41),('5815','2013-09-30','12:40:00',1.63),('5815','2013-09-30','12:45:00',2.03),('5815','2013-09-30','12:50:00',2.35),('5815','2013-09-30','12:55:00',2.3),('5815','2013-09-30','13:00:00',2.15),('5815','2013-09-30','13:05:00',2.37),('5815','2013-09-30','13:20:00',2.48),('5815','2013-09-30','13:25:00',2.47),('5815','2013-09-30','13:30:00',1.8),('5815','2013-09-30','13:35:00',2.07),('5815','2013-09-30','13:40:00',1.04),('5815','2013-09-30','13:45:00',1.68),('5815','2013-09-30','13:55:00',1.17),('5815','2013-09-30','14:00:00',2.29),('5815','2013-09-30','14:05:00',2.22),('5815','2013-09-30','14:10:00',2.18),('5815','2013-09-30','14:15:00',2.16),('5815','2013-09-30','14:20:00',2.13),('5815','2013-09-30','14:25:00',2.11),('5815','2013-09-30','14:30:00',2.1),('5815','2013-09-30','14:35:00',2.09),('5815','2013-09-30','14:40:00',2.06),('5815','2013-09-30','14:45:00',2.08),('5815','2013-09-30','14:50:00',2.08),('5815','2013-09-30','14:55:00',2.05),('5815','2013-09-30','15:00:00',2.03),('5815','2013-09-30','15:05:00',1.95),('5815','2013-09-30','15:10:00',1.91),('5815','2013-09-30','15:15:00',1.88),('5815','2013-09-30','15:20:00',1.86),('5815','2013-09-30','15:25:00',1.83),('5815','2013-09-30','15:30:00',1.8),('5815','2013-09-30','15:35:00',1.76),('5815','2013-09-30','15:40:00',1.72),('5815','2013-09-30','15:45:00',1.68),('5815','2013-09-30','15:50:00',1.65),('5815','2013-09-30','15:55:00',1.61),('5815','2013-09-30','16:00:00',1.57),('5815','2013-09-30','16:05:00',1.52),('5815','2013-09-30','16:10:00',1.47),('5815','2013-09-30','16:15:00',1.43),('5815','2013-09-30','16:20:00',1.39),('5815','2013-09-30','16:25:00',1.35),('5815','2013-09-30','16:30:00',1.29),('5815','2013-09-30','16:35:00',1.24),('5815','2013-09-30','16:40:00',1.19),('5815','2013-09-30','16:45:00',1.13),('5815','2013-09-30','16:50:00',1.08),('5815','2013-09-30','16:55:00',1.03),('5815','2013-09-29','10:40:00',1.26),('5815','2013-09-29','10:45:00',1.92),('5815','2013-09-29','10:50:00',2.02),('5815','2013-09-29','10:55:00',1.85),('5815','2013-09-29','11:00:00',1.64),('5815','2013-09-29','11:05:00',1.87),('5815','2013-09-29','11:10:00',1.95),('5815','2013-09-29','11:15:00',1.56),('5815','2013-09-29','11:20:00',1.53),('5815','2013-09-29','11:25:00',1.78),('5815','2013-09-29','11:35:00',1.09),('5815','2013-09-29','11:40:00',1.95),('5815','2013-09-29','11:45:00',1.22),('5815','2013-09-29','11:50:00',1.08),('5815','2013-09-29','12:00:00',1.05),('5815','2013-09-29','12:05:00',1.91),('5815','2013-09-29','12:10:00',1.63),('5815','2013-09-29','12:15:00',2.36),('5815','2013-09-29','12:20:00',2.43),('5815','2013-09-29','12:25:00',2.45),('5815','2013-09-29','12:30:00',2.36),('5815','2013-09-29','12:35:00',2.31),('5815','2013-09-29','12:40:00',2.38),('5815','2013-09-29','12:45:00',1.73),('5815','2013-09-29','12:50:00',2.44),('5815','2013-09-29','12:55:00',2.4),('5815','2013-09-29','13:00:00',2.4),('5815','2013-09-29','13:05:00',1.84),('5815','2013-09-29','13:10:00',2.47),('5815','2013-09-29','13:15:00',2.05),('5815','2013-09-29','13:20:00',2.58),('5815','2013-09-29','13:25:00',2.7),('5815','2013-09-29','13:30:00',2.69),('5815','2013-09-29','13:35:00',2.11),('5815','2013-09-29','13:40:00',1.56),('5815','2013-09-29','13:50:00',1.84),('5815','2013-09-29','13:55:00',1.46),('5815','2013-09-29','14:30:00',1.43),('5815','2013-09-29','14:35:00',1.8),('5815','2013-09-29','14:40:00',2.31),('5815','2013-09-29','14:45:00',1.65),('5815','2013-09-29','14:50:00',2.12),('5815','2013-09-29','14:55:00',1.31),('5815','2013-09-29','15:00:00',1.66),('5815','2013-09-29','15:05:00',1.37),('5815','2013-09-29','15:10:00',1.73),('5815','2013-09-29','15:15:00',1.16),('5815','2013-09-29','15:25:00',2.06),('5815','2013-09-29','15:30:00',1.4),('5815','2013-09-29','15:35:00',1.27),('5815','2013-09-29','15:40:00',2.04),('5815','2013-09-29','15:45:00',1.14),('5815','2013-09-29','16:15:00',1.1),('5815','2013-09-29','16:45:00',1),('5815','2013-09-28','10:10:00',1.13),('5815','2013-09-28','10:15:00',1.45),('5815','2013-09-28','10:20:00',1.25),('5815','2013-09-28','10:25:00',1.17),('5815','2013-09-28','10:30:00',1.39),('5815','2013-09-28','10:35:00',1.52),('5815','2013-09-28','10:40:00',1.67),('5815','2013-09-28','10:45:00',1.6),('5815','2013-09-28','10:50:00',1.68),('5815','2013-09-28','10:55:00',1.67),('5815','2013-09-28','11:00:00',1.71),('5815','2013-09-28','11:05:00',1.65),('5815','2013-09-28','11:10:00',1.64),('5815','2013-09-28','11:15:00',1.77),('5815','2013-09-28','11:20:00',1.79),('5815','2013-09-28','11:25:00',1.69),('5815','2013-09-28','11:30:00',1.82),('5815','2013-09-28','11:35:00',1.78),('5815','2013-09-28','11:40:00',1.88),('5815','2013-09-28','11:45:00',1.87),('5815','2013-09-28','11:50:00',2.02),('5815','2013-09-28','11:55:00',2),('5815','2013-09-28','12:00:00',1.87),('5815','2013-09-28','12:05:00',2.02),('5815','2013-09-28','12:10:00',1.96),('5815','2013-09-28','12:15:00',2.15),('5815','2013-09-28','12:20:00',1.77),('5815','2013-09-28','12:25:00',1.19),('5815','2013-09-28','12:30:00',1.2),('5815','2013-09-28','12:35:00',1.15),('5815','2013-09-28','13:30:00',1.33),('5815','2013-09-28','13:55:00',1.31),('5815','2013-09-28','14:00:00',1.19),('5815','2013-09-28','14:05:00',1.42),('5815','2013-09-28','14:15:00',1.02),('5815','2013-09-28','14:20:00',1.38),('5815','2013-09-27','09:15:00',1.03),('5815','2013-09-27','09:20:00',1.08),('5815','2013-09-27','09:25:00',1.14),('5815','2013-09-27','09:30:00',1.19),('5815','2013-09-27','09:35:00',1.24),('5815','2013-09-27','09:40:00',1.29),('5815','2013-09-27','09:45:00',1.34),('5815','2013-09-27','09:50:00',1.4),('5815','2013-09-27','09:55:00',1.48),('5815','2013-09-27','10:35:00',1.51),('5815','2013-09-27','10:40:00',1.32),('5815','2013-09-27','10:45:00',1.52),('5815','2013-09-27','10:50:00',1.84),('5815','2013-09-27','10:55:00',2.05),('5815','2013-09-27','11:20:00',1.43),('5815','2013-09-27','11:25:00',2.17),('5815','2013-09-27','11:30:00',2.25),('5815','2013-09-27','11:35:00',1.87),('5815','2013-09-27','11:40:00',1.27),('5815','2013-09-27','12:05:00',2.19),('5815','2013-09-27','12:10:00',2.33),('5815','2013-09-27','12:15:00',1.82),('5815','2013-09-27','12:20:00',1.12),('5815','2013-09-27','12:25:00',2.24),('5815','2013-09-27','12:35:00',1.34),('5815','2013-09-27','12:40:00',2.02),('5815','2013-09-27','12:50:00',1.81),('5815','2013-09-27','12:55:00',2.33),('5815','2013-09-27','13:00:00',1.03),('5815','2013-09-27','13:05:00',2.22),('5815','2013-09-27','13:30:00',1.87),('5815','2013-09-27','13:35:00',1.02),('5815','2013-09-27','13:50:00',1.31),('5815','2013-09-27','14:20:00',1.23),('5815','2013-09-27','14:25:00',2.43),('5815','2013-09-27','14:30:00',1.73),('5815','2013-09-27','14:35:00',1.48),('5815','2013-09-27','14:40:00',2.28),('5815','2013-09-27','14:45:00',2.15),('5815','2013-09-27','14:50:00',1.93),('5815','2013-09-27','15:00:00',1.79),('5815','2013-09-27','15:05:00',2.03),('5815','2013-09-27','15:10:00',1.38),('5815','2013-09-27','15:15:00',2.04),('5815','2013-09-27','15:20:00',1.89),('5815','2013-09-27','15:25:00',2),('5815','2013-09-27','15:30:00',1.97),('5815','2013-09-27','15:35:00',1.82),('5815','2013-09-27','15:40:00',1.81),('5815','2013-09-27','15:45:00',1.66),('5815','2013-09-27','15:55:00',1.17),('5815','2013-09-27','16:00:00',1.64),('5815','2013-09-27','16:05:00',1.53),('5815','2013-09-27','16:10:00',1.62),('5815','2013-09-27','16:15:00',1.52),('5815','2013-09-27','16:20:00',1.21),('5815','2013-09-27','16:25:00',1.33),('5815','2013-09-27','16:30:00',1.2),('5815','2013-09-27','16:35:00',1.19),('5815','2013-09-27','16:40:00',1.15),('5815','2013-09-27','16:45:00',1.09),('5815','2013-09-27','16:50:00',1.05),('5815','2013-09-27','16:55:00',1),('5815','2013-09-26','10:05:00',1.22),('5815','2013-09-26','10:10:00',1.21),('5815','2013-09-26','10:20:00',1.25),('5815','2013-09-26','10:25:00',1),('5815','2013-09-26','10:30:00',1.26),('5815','2013-09-26','10:50:00',1.71),('5815','2013-09-26','10:55:00',1.78),('5815','2013-09-26','11:00:00',1.86),('5815','2013-09-26','11:05:00',1.87),('5815','2013-09-26','11:10:00',1.72),('5815','2013-09-26','11:15:00',1.91),('5815','2013-09-26','11:20:00',1.9),('5815','2013-09-26','11:25:00',1.73),('5815','2013-09-26','11:30:00',1.74),('5815','2013-09-26','11:45:00',1.36),('5815','2013-09-26','12:00:00',1.83),('5815','2013-09-26','12:05:00',1.11),('5815','2013-09-26','12:10:00',1.73),('5815','2013-09-26','12:15:00',1.69),('5815','2013-09-26','12:45:00',1.01),('5815','2013-09-26','12:50:00',2.14),('5815','2013-09-26','12:55:00',2.17),('5815','2013-09-26','13:00:00',2.18),('5815','2013-09-26','13:05:00',2.19),('5815','2013-09-26','13:10:00',2.16),('5815','2013-09-26','13:20:00',2.04),('5815','2013-09-26','13:25:00',1.8),('5815','2013-09-26','13:45:00',1.6),('5815','2013-09-26','14:05:00',1.95),('5815','2013-09-26','14:10:00',1.73),('5815','2013-09-26','14:15:00',1.97),('5815','2013-09-26','14:20:00',2.26),('5815','2013-09-26','14:25:00',2.18),('5815','2013-09-26','14:30:00',2.16),('5815','2013-09-26','14:35:00',2.09),('5815','2013-09-26','14:40:00',2.11),('5815','2013-09-26','14:45:00',2.03),('5815','2013-09-26','14:50:00',1.91),('5815','2013-09-26','14:55:00',1.86),('5815','2013-09-26','15:00:00',1.49),('5815','2013-09-26','15:05:00',1.53),('5815','2013-09-26','15:10:00',1.35),('5815','2013-09-26','15:15:00',1.89),('5815','2013-09-26','15:20:00',1.18),('5815','2013-09-26','15:25:00',1.76),('5815','2013-09-26','15:30:00',1.86),('5815','2013-09-26','15:35:00',1.48),('5815','2013-09-26','15:40:00',1.74),('5815','2013-09-26','15:50:00',1.68),('5815','2013-09-26','15:55:00',1.64),('5815','2013-09-26','16:00:00',1.3),('5815','2013-09-26','16:05:00',1.3),('5815','2013-09-26','16:20:00',1.43),('5815','2013-09-26','16:25:00',1.35),('5815','2013-09-26','16:30:00',1.05),('5815','2013-09-26','16:35:00',1.24),('5815','2013-09-26','16:40:00',1.18),('5815','2013-09-26','16:45:00',1.12),('5815','2013-09-26','16:50:00',1.1),('5815','2013-09-25','09:10:00',1.05),('5815','2013-09-25','09:15:00',1.1),('5815','2013-09-25','09:20:00',1.16),('5815','2013-09-25','09:25:00',1.2),('5815','2013-09-25','09:30:00',1.25),('5815','2013-09-25','09:35:00',1.29),('5815','2013-09-25','09:40:00',1.32),('5815','2013-09-25','09:45:00',1.37),('5815','2013-09-25','09:50:00',1.4),('5815','2013-09-25','09:55:00',1.44),('5815','2013-09-25','10:00:00',1.49),('5815','2013-09-25','10:05:00',1.52),('5815','2013-09-25','10:10:00',1.54),('5815','2013-09-25','10:15:00',1.6),('5815','2013-09-25','10:20:00',1.62),('5815','2013-09-25','10:25:00',1.65),('5815','2013-09-25','10:30:00',1.65),('5815','2013-09-25','10:35:00',1.7),('5815','2013-09-25','10:40:00',1.72),('5815','2013-09-25','10:45:00',1.56),('5815','2013-09-25','10:50:00',1.81),('5815','2013-09-25','10:55:00',1.84),('5815','2013-09-25','11:00:00',1.86),('5815','2013-09-25','11:05:00',1.84),('5815','2013-09-25','11:10:00',1.9),('5815','2013-09-25','11:15:00',1.91),('5815','2013-09-25','11:20:00',1.95),('5815','2013-09-25','11:25:00',1.99),('5815','2013-09-25','11:30:00',2),('5815','2013-09-25','11:35:00',2.05),('5815','2013-09-25','11:40:00',1.85),('5815','2013-09-25','11:45:00',1.61),('5815','2013-09-25','11:50:00',2.05),('5815','2013-09-25','11:55:00',1.91),('5815','2013-09-25','12:00:00',1.49),('5815','2013-09-25','12:05:00',1.73),('5815','2013-09-25','12:20:00',1.04),('5815','2013-09-25','12:40:00',1.04),('5815','2013-09-25','12:45:00',1.14),('5815','2013-09-25','12:55:00',1.2),('5815','2013-09-25','13:00:00',1.91),('5815','2013-09-25','13:05:00',1.25),('5815','2013-09-25','13:15:00',1.86),('5815','2013-09-25','13:20:00',2.38),('5815','2013-09-25','13:25:00',1.88),('5815','2013-09-25','13:30:00',1.34),('5815','2013-09-25','13:35:00',1.21),('5815','2013-09-25','13:55:00',1.12),('5815','2013-09-25','14:00:00',1.23),('5815','2013-09-25','14:05:00',1.65),('5815','2013-09-25','14:10:00',2.35),('5815','2013-09-25','14:15:00',2.28),('5815','2013-09-25','14:20:00',2.09),('5815','2013-09-25','14:25:00',1.38),('5815','2013-09-25','14:30:00',1.15),('5815','2013-09-25','14:35:00',1.28),('5815','2013-09-25','14:40:00',1.45),('5815','2013-09-25','14:45:00',1.57),('5815','2013-09-25','14:50:00',2.36),('5815','2013-09-25','14:55:00',1.58),('5815','2013-09-25','15:25:00',1.69),('5815','2013-09-25','15:35:00',1.17),('5815','2013-09-25','15:45:00',1.64),('5815','2013-09-25','15:50:00',1.81),('5815','2013-09-25','15:55:00',1.66),('5815','2013-09-25','16:00:00',1.58),('5815','2013-09-25','16:05:00',1.52),('5815','2013-09-25','16:10:00',1.51),('5815','2013-09-25','16:15:00',1.42),('5815','2013-09-25','16:20:00',1.39),('5815','2013-09-25','16:25:00',1.38),('5815','2013-09-25','16:30:00',1.32),('5815','2013-09-25','16:35:00',1.26),('5815','2013-09-25','16:40:00',1.21),('5815','2013-09-25','16:45:00',1.15),('5815','2013-09-25','16:50:00',1.09),('5815','2013-09-25','16:55:00',1.05),('5815','2013-09-24','09:10:00',1.04),('5815','2013-09-24','09:15:00',1.03),('5815','2013-09-24','09:30:00',1.08),('5815','2013-09-24','09:35:00',1.01),('5815','2013-09-24','09:40:00',1.34),('5815','2013-09-24','09:45:00',1.31),('5815','2013-09-24','09:50:00',1.11),('5815','2013-09-24','10:00:00',1.63),('5815','2013-09-24','10:05:00',1.2),('5815','2013-09-24','10:45:00',1.64),('5815','2013-09-24','10:50:00',2.11),('5815','2013-09-24','10:55:00',2.24),('5815','2013-09-24','11:00:00',1.63),('5815','2013-09-24','11:25:00',1.09),('5815','2013-09-24','11:30:00',2.16),('5815','2013-09-24','11:35:00',2.18),('5815','2013-09-24','11:40:00',2.07),('5815','2013-09-24','11:45:00',2.16),('5815','2013-09-24','11:50:00',1.56),('5815','2013-09-24','11:55:00',1.19),('5815','2013-09-24','12:00:00',1.49),('5815','2013-09-24','12:15:00',2.11),('5815','2013-09-24','12:20:00',2.26),('5815','2013-09-24','12:25:00',2.27),('5815','2013-09-24','12:30:00',1.62),('5815','2013-09-24','12:35:00',2.32),('5815','2013-09-24','12:40:00',2.35),('5815','2013-09-24','13:35:00',1.95),('5815','2013-09-24','13:40:00',1.56),('5815','2013-09-24','13:45:00',2.5),('5815','2013-09-24','13:50:00',2.42),('5815','2013-09-24','13:55:00',2.5),('5815','2013-09-24','14:35:00',1.01),('5815','2013-09-24','14:40:00',1.7),('5815','2013-09-24','14:45:00',1.78),('5815','2013-09-24','14:50:00',1.28),('5815','2013-09-24','14:55:00',2.07),('5815','2013-09-24','15:00:00',1.59),('5815','2013-09-24','15:05:00',2.2),('5815','2013-09-24','15:10:00',2.12),('5815','2013-09-24','15:15:00',2.06),('5815','2013-09-24','15:20:00',2.01),('5815','2013-09-24','15:25:00',1.86),('5815','2013-09-24','15:30:00',1.84),('5815','2013-09-24','15:35:00',1.69),('5815','2013-09-24','15:40:00',1.99),('5815','2013-09-24','15:45:00',1.78),('5815','2013-09-24','15:50:00',1.78),('5815','2013-09-24','15:55:00',1.74),('5815','2013-09-24','16:00:00',1.7),('5815','2013-09-24','16:05:00',1.64),('5815','2013-09-24','16:10:00',1.59),('5815','2013-09-24','16:15:00',1.53),('5815','2013-09-24','16:20:00',1.49),('5815','2013-09-24','16:30:00',1.16),('5815','2013-09-24','16:35:00',1.37),('5815','2013-09-24','16:40:00',1.3),('5815','2013-09-24','16:45:00',1.22),('5815','2013-09-24','16:50:00',1.19),('5815','2013-09-24','16:55:00',1.13),('5815','2013-09-24','17:00:00',1.07),('5815','2013-09-23','09:05:00',1.04),('5815','2013-09-23','09:10:00',1.1),('5815','2013-09-23','09:15:00',1.15),('5815','2013-09-23','09:20:00',1.2),('5815','2013-09-23','09:25:00',1.25),('5815','2013-09-23','09:30:00',1.3),('5815','2013-09-23','09:35:00',1.35),('5815','2013-09-23','09:40:00',1.39),('5815','2013-09-23','09:45:00',1.43),('5815','2013-09-23','09:50:00',1.47),('5815','2013-09-23','09:55:00',1.51),('5815','2013-09-23','10:00:00',1.54),('5815','2013-09-23','10:05:00',1.59),('5815','2013-09-23','10:10:00',1.64),('5815','2013-09-23','10:15:00',1.68),('5815','2013-09-23','10:20:00',1.72),('5815','2013-09-23','10:25:00',1.75),('5815','2013-09-23','10:30:00',1.79),('5815','2013-09-23','10:35:00',1.81),('5815','2013-09-23','10:40:00',1.83),('5815','2013-09-23','10:45:00',1.87),('5815','2013-09-23','10:50:00',1.9),('5815','2013-09-23','10:55:00',1.92),('5815','2013-09-23','11:00:00',1.95),('5815','2013-09-23','11:05:00',1.98),('5815','2013-09-23','11:10:00',1.99),('5815','2013-09-23','11:15:00',2),('5815','2013-09-23','11:20:00',2.01),('5815','2013-09-23','11:25:00',2.03),('5815','2013-09-23','11:30:00',2.05),('5815','2013-09-23','11:35:00',2.08),('5815','2013-09-23','11:40:00',2.1),('5815','2013-09-23','11:45:00',2.1),('5815','2013-09-23','11:50:00',2.12),('5815','2013-09-23','11:55:00',2.14),('5815','2013-09-23','12:00:00',2.15),('5815','2013-09-23','12:05:00',2.16),('5815','2013-09-23','12:10:00',2.17),('5815','2013-09-23','12:15:00',2.18),('5815','2013-09-23','12:20:00',2.21),('5815','2013-09-23','12:25:00',2.2),('5815','2013-09-23','12:30:00',2.19),('5815','2013-09-23','12:35:00',2.2),('5815','2013-09-23','12:40:00',2.22),('5815','2013-09-23','12:45:00',2.25),('5815','2013-09-23','12:50:00',2.25),('5815','2013-09-23','12:55:00',2.23),('5815','2013-09-23','13:00:00',2.22),('5815','2013-09-23','13:05:00',2.25),('5815','2013-09-23','13:10:00',2.22),('5815','2013-09-23','13:15:00',2.24),('5815','2013-09-23','13:20:00',2.25),('5815','2013-09-23','13:25:00',2.25),('5815','2013-09-23','13:30:00',2.25),('5815','2013-09-23','13:35:00',2.23),('5815','2013-09-23','13:40:00',2.23),('5815','2013-09-23','13:45:00',2.24),('5815','2013-09-23','13:50:00',2.24),('5815','2013-09-23','13:55:00',2.21),('5815','2013-09-23','14:00:00',2.19),('5815','2013-09-23','14:05:00',2.19),('5815','2013-09-23','14:10:00',2.18),('5815','2013-09-23','14:15:00',2.17),('5815','2013-09-23','14:20:00',2.15),('5815','2013-09-23','14:25:00',2.12),('5815','2013-09-23','14:30:00',2.13),('5815','2013-09-23','14:35:00',2.1),('5815','2013-09-23','14:40:00',2.08),('5815','2013-09-23','14:45:00',2.05),('5815','2013-09-23','14:50:00',2.02),('5815','2013-09-23','14:55:00',2),('5815','2013-09-23','15:00:00',1.96),('5815','2013-09-23','15:05:00',1.95),('5815','2013-09-23','15:10:00',1.95),('5815','2013-09-23','15:15:00',1.91),('5815','2013-09-23','15:20:00',1.9),('5815','2013-09-23','15:25:00',1.9),('5815','2013-09-23','15:30:00',1.87),('5815','2013-09-23','15:35:00',1.82),('5815','2013-09-23','15:40:00',1.78),('5815','2013-09-23','15:45:00',1.75),('5815','2013-09-23','15:50:00',1.72),('5815','2013-09-23','15:55:00',1.66),('5815','2013-09-23','16:00:00',1.64),('5815','2013-09-23','16:05:00',1.6),('5815','2013-09-23','16:10:00',1.56),('5815','2013-09-23','16:15:00',1.53),('5815','2013-09-23','16:20:00',1.48),('5815','2013-09-23','16:25:00',1.43),('5815','2013-09-23','16:30:00',1.39),('5815','2013-09-23','16:35:00',1.34),('5815','2013-09-23','16:40:00',1.28),('5815','2013-09-23','16:45:00',1.24),('5815','2013-09-23','16:50:00',1.18),('5815','2013-09-23','16:55:00',1.15),('5815','2013-09-23','17:00:00',1.1),('5815','2013-09-22','09:00:00',1.02),('5815','2013-09-22','09:05:00',1.08),('5815','2013-09-22','09:10:00',1.13),('5815','2013-09-22','09:15:00',1.18),('5815','2013-09-22','09:20:00',1.24),('5815','2013-09-22','09:25:00',1.29),('5815','2013-09-22','09:30:00',1.34),('5815','2013-09-22','09:35:00',1.38),('5815','2013-09-22','09:40:00',1.4),('5815','2013-09-22','09:45:00',1.47),('5815','2013-09-22','09:50:00',1.51),('5815','2013-09-22','09:55:00',1.55),('5815','2013-09-22','10:00:00',1.59),('5815','2013-09-22','10:05:00',1.63),('5815','2013-09-22','10:10:00',1.67),('5815','2013-09-22','10:15:00',1.69),('5815','2013-09-22','10:20:00',1.73),('5815','2013-09-22','10:25:00',1.76),('5815','2013-09-22','10:30:00',1.79),('5815','2013-09-22','10:35:00',1.82),('5815','2013-09-22','10:40:00',1.85),('5815','2013-09-22','10:45:00',1.88),('5815','2013-09-22','10:50:00',1.92),('5815','2013-09-22','10:55:00',1.92),('5815','2013-09-22','11:00:00',1.96),('5815','2013-09-22','11:05:00',2),('5815','2013-09-22','11:10:00',2.02),('5815','2013-09-22','11:15:00',2.06),('5815','2013-09-22','11:20:00',2.09),('5815','2013-09-22','11:25:00',2.11),('5815','2013-09-22','11:30:00',2.13),('5815','2013-09-22','11:35:00',2.14),('5815','2013-09-22','11:40:00',2.15),('5815','2013-09-22','11:45:00',2.17),('5815','2013-09-22','11:50:00',2.18),('5815','2013-09-22','11:55:00',2.2),('5815','2013-09-22','12:00:00',2.22),('5815','2013-09-22','12:05:00',2.25),('5815','2013-09-22','12:10:00',2.28),('5815','2013-09-22','12:15:00',2.29),('5815','2013-09-22','12:20:00',2.27),('5815','2013-09-22','12:25:00',2.25),('5815','2013-09-22','12:30:00',2.25),('5815','2013-09-22','12:35:00',2.25),('5815','2013-09-22','12:40:00',2.26),('5815','2013-09-22','12:45:00',2.27),('5815','2013-09-22','12:50:00',2.27),('5815','2013-09-22','12:55:00',2.28),('5815','2013-09-22','13:00:00',2.27),('5815','2013-09-22','13:05:00',2.28),('5815','2013-09-22','13:10:00',2.28),('5815','2013-09-22','13:15:00',2.27),('5815','2013-09-22','13:20:00',2.25),('5815','2013-09-22','13:25:00',2.26),('5815','2013-09-22','13:30:00',2.26),('5815','2013-09-22','13:35:00',2.25),('5815','2013-09-22','13:40:00',2.22),('5815','2013-09-22','13:45:00',2.22),('5815','2013-09-22','13:50:00',2.21),('5815','2013-09-22','13:55:00',2.19),('5815','2013-09-22','14:00:00',2.16),('5815','2013-09-22','14:05:00',2.13),('5815','2013-09-22','14:10:00',2.13),('5815','2013-09-22','14:15:00',2.13),('5815','2013-09-22','14:20:00',2.11),('5815','2013-09-22','14:25:00',2.11),('5815','2013-09-22','14:30:00',2.15),('5815','2013-09-22','14:35:00',2.11),('5815','2013-09-22','14:40:00',2.07),('5815','2013-09-22','14:45:00',2.03),('5815','2013-09-22','14:50:00',2),('5815','2013-09-22','14:55:00',2.01),('5815','2013-09-22','15:00:00',1.97),('5815','2013-09-22','15:05:00',1.52),('5815','2013-09-22','15:10:00',1.31),('5815','2013-09-22','15:15:00',1.95),('5815','2013-09-22','15:20:00',1.89),('5815','2013-09-22','15:25:00',1.85),('5815','2013-09-22','15:30:00',1.81),('5815','2013-09-22','15:35:00',1.8),('5815','2013-09-22','15:40:00',1.76),('5815','2013-09-22','15:45:00',1.72),('5815','2013-09-22','15:50:00',1.67),('5815','2013-09-22','15:55:00',1.39),('5815','2013-09-22','16:00:00',1.57),('5815','2013-09-22','16:05:00',1.56),('5815','2013-09-22','16:10:00',1.3),('5815','2013-09-22','16:15:00',1.32),('5815','2013-09-22','16:20:00',1.28),('5815','2013-09-22','16:25:00',1.14),('5815','2013-09-22','16:30:00',1.3),('5815','2013-09-22','16:35:00',1.27),('5815','2013-09-22','16:40:00',1.24),('5815','2013-09-22','16:45:00',1.2),('5815','2013-09-22','16:50:00',1.15),('5815','2013-09-22','16:55:00',1.1),('5815','2013-09-22','17:00:00',1.05),('5815','2013-09-21','09:05:00',1.05),('5815','2013-09-21','09:10:00',1.11),('5815','2013-09-21','09:15:00',1.17),('5815','2013-09-21','09:20:00',1.22),('5815','2013-09-21','09:25:00',1.27),('5815','2013-09-21','09:30:00',1.32),('5815','2013-09-21','09:35:00',1.37),('5815','2013-09-21','09:40:00',1.4),('5815','2013-09-21','09:45:00',1.45),('5815','2013-09-21','09:50:00',1.49),('5815','2013-09-21','09:55:00',1.54),('5815','2013-09-21','10:00:00',1.59),('5815','2013-09-21','10:05:00',1.64),('5815','2013-09-21','10:10:00',1.68),('5815','2013-09-21','10:15:00',1.72),('5815','2013-09-21','10:20:00',1.76),('5815','2013-09-21','10:25:00',1.79),('5815','2013-09-21','10:30:00',1.8),('5815','2013-09-21','10:35:00',1.87),('5815','2013-09-21','10:40:00',1.9),('5815','2013-09-21','10:45:00',1.92),('5815','2013-09-21','10:50:00',1.94),('5815','2013-09-21','10:55:00',1.96),('5815','2013-09-21','11:00:00',1.99),('5815','2013-09-21','11:05:00',2),('5815','2013-09-21','11:10:00',2.02),('5815','2013-09-21','11:15:00',2.05),('5815','2013-09-21','11:20:00',2.09),('5815','2013-09-21','11:25:00',2.11),('5815','2013-09-21','11:30:00',2.14),('5815','2013-09-21','11:35:00',2.18),('5815','2013-09-21','11:40:00',2.21),('5815','2013-09-21','11:45:00',2.23),('5815','2013-09-21','11:50:00',2.24),('5815','2013-09-21','11:55:00',2.26),('5815','2013-09-21','12:00:00',2.26),('5815','2013-09-21','12:05:00',2.29),('5815','2013-09-21','12:10:00',2.3),('5815','2013-09-21','12:15:00',2.3),('5815','2013-09-21','12:20:00',2.32),('5815','2013-09-21','12:25:00',2.32),('5815','2013-09-21','12:30:00',2.32),('5815','2013-09-21','12:35:00',2.33),('5815','2013-09-21','12:40:00',2.34),('5815','2013-09-21','12:45:00',2.32),('5815','2013-09-21','12:50:00',2.35),('5815','2013-09-21','12:55:00',2.38),('5815','2013-09-21','13:00:00',2.35),('5815','2013-09-21','13:05:00',2.35),('5815','2013-09-21','13:10:00',2.39),('5815','2013-09-21','13:15:00',2.34),('5815','2013-09-21','13:20:00',2.33),('5815','2013-09-21','13:25:00',2.33),('5815','2013-09-21','13:30:00',2.31),('5815','2013-09-21','13:35:00',2.3),('5815','2013-09-21','13:40:00',2.29),('5815','2013-09-21','13:45:00',2.29),('5815','2013-09-21','13:50:00',2.3),('5815','2013-09-21','13:55:00',2.15),('5815','2013-09-21','14:00:00',2.27),('5815','2013-09-21','14:05:00',2.29),('5815','2013-09-21','14:10:00',2.23),('5815','2013-09-21','14:15:00',2.27),('5815','2013-09-21','14:20:00',1.51),('5815','2013-09-21','14:25:00',2.08),('5815','2013-09-21','14:30:00',2.31),('5815','2013-09-21','14:35:00',2.21),('5815','2013-09-21','14:40:00',1.67),('5815','2013-09-21','14:45:00',1.92),('5815','2013-09-21','14:50:00',2.14),('5815','2013-09-21','14:55:00',2.12),('5815','2013-09-21','15:00:00',2.13),('5815','2013-09-21','15:05:00',2.18),('5815','2013-09-21','15:10:00',2.1),('5815','2013-09-21','15:15:00',2.2),('5815','2013-09-21','15:20:00',2.2),('5815','2013-09-21','15:40:00',1.46),('5815','2013-09-21','15:45:00',1.92),('5815','2013-09-21','15:50:00',1.82),('5815','2013-09-21','15:55:00',1.79),('5815','2013-09-21','16:00:00',1.91),('5815','2013-09-21','16:05:00',1.9),('5815','2013-09-21','16:10:00',2),('5815','2013-09-21','16:15:00',1.56),('5815','2013-09-21','16:45:00',1.09),('5815','2013-09-21','17:05:00',1.07),('5815','2013-09-20','09:05:00',1.04),('5815','2013-09-20','09:10:00',1.09),('5815','2013-09-20','09:15:00',1.15),('5815','2013-09-20','09:20:00',1.2),('5815','2013-09-20','09:25:00',1.24),('5815','2013-09-20','09:30:00',1.29),('5815','2013-09-20','09:35:00',1.34),('5815','2013-09-20','09:40:00',1.37),('5815','2013-09-20','09:45:00',1.42),('5815','2013-09-20','09:50:00',1.46),('5815','2013-09-20','09:55:00',1.51),('5815','2013-09-20','10:00:00',1.55),('5815','2013-09-20','10:05:00',1.6),('5815','2013-09-20','10:10:00',1.63),('5815','2013-09-20','10:15:00',1.67),('5815','2013-09-20','10:20:00',1.7),('5815','2013-09-20','10:25:00',1.72),('5815','2013-09-20','10:30:00',1.77),('5815','2013-09-20','10:35:00',1.8),('5815','2013-09-20','10:40:00',1.84),('5815','2013-09-20','10:45:00',1.86),('5815','2013-09-20','10:50:00',1.89),('5815','2013-09-20','10:55:00',1.92),('5815','2013-09-20','11:00:00',1.95),('5815','2013-09-20','11:05:00',1.96),('5815','2013-09-20','11:10:00',1.99),('5815','2013-09-20','11:15:00',2.01),('5815','2013-09-20','11:20:00',2.03),('5815','2013-09-20','11:25:00',2.06),('5815','2013-09-20','11:30:00',2.07),('5815','2013-09-20','11:35:00',2.09),('5815','2013-09-20','11:40:00',2.12),('5815','2013-09-20','11:45:00',2.14),('5815','2013-09-20','11:50:00',2.17),('5815','2013-09-20','11:55:00',2.12),('5815','2013-09-20','12:00:00',2.18),('5815','2013-09-20','12:05:00',2.2),('5815','2013-09-20','12:10:00',2.22),('5815','2013-09-20','12:15:00',2.24),('5815','2013-09-20','12:20:00',2.25),('5815','2013-09-20','12:25:00',2.05),('5815','2013-09-20','12:30:00',2.31),('5815','2013-09-20','12:35:00',2.29),('5815','2013-09-20','12:40:00',2.08),('5815','2013-09-20','12:45:00',2.08),('5815','2013-09-20','12:50:00',2.26),('5815','2013-09-20','12:55:00',2.28),('5815','2013-09-20','13:00:00',2.27),('5815','2013-09-20','13:05:00',2.19),('5815','2013-09-20','13:10:00',2.28),('5815','2013-09-20','13:15:00',2.28),('5815','2013-09-20','13:20:00',1.82),('5815','2013-09-20','13:25:00',2.08),('5815','2013-09-20','13:30:00',2.17),('5815','2013-09-20','13:35:00',2.21),('5815','2013-09-20','13:40:00',1.96),('5815','2013-09-20','13:45:00',1.94),('5815','2013-09-20','13:50:00',2.02),('5815','2013-09-20','13:55:00',2.08),('5815','2013-09-20','14:00:00',2.02),('5815','2013-09-20','14:05:00',2.15),('5815','2013-09-20','14:10:00',2.09),('5815','2013-09-20','14:15:00',2.17),('5815','2013-09-20','14:20:00',2.18),('5815','2013-09-20','14:25:00',2.12),('5815','2013-09-20','14:30:00',2.11),('5815','2013-09-20','14:35:00',2.09),('5815','2013-09-20','14:40:00',2.06),('5815','2013-09-20','14:45:00',2.04),('5815','2013-09-20','14:50:00',2.03),('5815','2013-09-20','14:55:00',2.01),('5815','2013-09-20','15:00:00',1.98),('5815','2013-09-20','15:05:00',1.96),('5815','2013-09-20','15:10:00',1.87),('5815','2013-09-20','15:15:00',1.89),('5815','2013-09-20','15:20:00',1.88),('5815','2013-09-20','15:25:00',1.84),('5815','2013-09-20','15:30:00',1.8),('5815','2013-09-20','15:35:00',1.8),('5815','2013-09-20','15:40:00',1.66),('5815','2013-09-20','15:45:00',1.27),('5815','2013-09-20','15:50:00',1.46),('5815','2013-09-20','15:55:00',1.66),('5815','2013-09-20','16:00:00',1.33),('5815','2013-09-20','16:10:00',1.03),('5815','2013-09-20','16:20:00',1.11),('5815','2013-09-19','09:25:00',1.11),('5815','2013-09-19','10:05:00',1.02),('5815','2013-09-19','10:10:00',1.93),('5815','2013-09-19','10:15:00',1.12),('5815','2013-09-19','10:20:00',1.84),('5815','2013-09-19','10:25:00',1.07),('5815','2013-09-19','10:30:00',1.08),('5815','2013-09-19','10:35:00',1.47),('5815','2013-09-19','10:40:00',1.26),('5815','2013-09-19','10:45:00',1.34),('5815','2013-09-19','10:50:00',1.41),('5815','2013-09-19','10:55:00',1.49),('5815','2013-09-19','11:00:00',1.41),('5815','2013-09-19','11:05:00',1.11),('5815','2013-09-19','11:10:00',1.13),('5815','2013-09-19','11:15:00',1.43),('5815','2013-09-19','11:20:00',1.47),('5815','2013-09-19','11:25:00',1.31),('5815','2013-09-19','11:30:00',1.63),('5815','2013-09-19','11:35:00',1.55),('5815','2013-09-19','11:40:00',1.81),('5815','2013-09-19','11:45:00',2.34),('5815','2013-09-19','11:50:00',2.36),('5815','2013-09-19','11:55:00',2.3),('5815','2013-09-19','12:00:00',2.25),('5815','2013-09-19','12:05:00',2.26),('5815','2013-09-19','12:10:00',2.27),('5815','2013-09-19','12:15:00',2.31),('5815','2013-09-19','12:20:00',2.35),('5815','2013-09-19','12:25:00',2.37),('5815','2013-09-19','12:30:00',1.94),('5815','2013-09-19','12:35:00',2.12),('5815','2013-09-19','12:40:00',1.77),('5815','2013-09-19','12:45:00',2.3),('5815','2013-09-19','12:50:00',1.93),('5815','2013-09-19','12:55:00',2.38),('5815','2013-09-19','13:00:00',2.15),('5815','2013-09-19','13:05:00',2.02),('5815','2013-09-19','13:10:00',2.2),('5815','2013-09-19','13:15:00',2.15),('5815','2013-09-19','13:20:00',2.09),('5815','2013-09-19','13:25:00',2.44),('5815','2013-09-19','13:30:00',2.35),('5815','2013-09-19','13:35:00',1.45),('5815','2013-09-19','13:40:00',2.07),('5815','2013-09-19','13:45:00',2.33),('5815','2013-09-19','13:50:00',2.26),('5815','2013-09-19','13:55:00',2.08),('5815','2013-09-19','14:00:00',2.25),('5815','2013-09-19','14:05:00',2.28),('5815','2013-09-19','14:10:00',1.65),('5815','2013-09-19','14:15:00',2.21),('5815','2013-09-19','14:20:00',1.54),('5815','2013-09-19','14:25:00',1.04),('5815','2013-09-19','14:30:00',2.38),('5815','2013-09-19','14:35:00',2.3),('5815','2013-09-19','14:40:00',2.25),('5815','2013-09-19','14:45:00',2.24),('5815','2013-09-19','14:50:00',2.23),('5815','2013-09-19','14:55:00',2.19),('5815','2013-09-19','15:00:00',1.92),('5815','2013-09-19','15:05:00',1.15),('5815','2013-09-19','15:10:00',1.94),('5815','2013-09-19','15:15:00',1.58),('5815','2013-09-19','15:20:00',1.74),('5815','2013-09-19','15:25:00',1.3),('5815','2013-09-19','15:30:00',1.02),('5815','2013-09-19','15:45:00',1.95),('5815','2013-09-19','15:50:00',1.88),('5815','2013-09-19','15:55:00',1.92),('5815','2013-09-19','16:00:00',1.14),('5815','2013-09-19','16:10:00',1.65),('5815','2013-09-19','16:15:00',1.72),('5815','2013-09-19','16:55:00',1.32),('5815','2013-09-19','17:00:00',1.37),('5815','2013-09-19','17:05:00',1.42),('5815','2013-09-19','17:10:00',1.31),('5815','2013-09-18','09:15:00',1.09),('5815','2013-09-18','10:05:00',1.03),('5815','2013-09-18','10:10:00',1.52),('5815','2013-09-18','10:15:00',1.58),('5815','2013-09-18','10:35:00',1.47),('5815','2013-09-18','10:40:00',2),('5815','2013-09-18','10:45:00',1.38),('5815','2013-09-18','10:55:00',1.35),('5815','2013-09-18','11:00:00',2.15),('5815','2013-09-18','11:05:00',2.06),('5815','2013-09-18','11:15:00',1.21),('5815','2013-09-18','11:20:00',1.36),('5815','2013-09-18','11:30:00',2.51),('5815','2013-09-18','11:35:00',1.73),('5815','2013-09-18','11:40:00',2.11),('5815','2013-09-18','11:45:00',1.42),('5815','2013-09-18','11:50:00',2.29),('5815','2013-09-18','11:55:00',2.26),('5815','2013-09-18','12:00:00',1.65),('5815','2013-09-18','12:05:00',1.02),('5815','2013-09-18','12:10:00',1.95),('5815','2013-09-18','12:15:00',2.22),('5815','2013-09-18','12:20:00',1.91),('5815','2013-09-18','12:25:00',2.66),('5815','2013-09-18','12:30:00',2.58),('5815','2013-09-18','12:35:00',2.41),('5815','2013-09-18','12:40:00',2.42),('5815','2013-09-18','12:45:00',1.12),('5815','2013-09-18','12:50:00',2.49),('5815','2013-09-18','12:55:00',2.5),('5815','2013-09-18','13:00:00',2.52),('5815','2013-09-18','13:05:00',2.53),('5815','2013-09-18','13:10:00',2.64),('5815','2013-09-18','13:15:00',2.45),('5815','2013-09-18','13:20:00',2.4),('5815','2013-09-18','13:25:00',1.41),('5815','2013-09-18','13:30:00',2.48),('5815','2013-09-18','13:35:00',2.55),('5815','2013-09-18','13:40:00',2.46),('5815','2013-09-18','13:45:00',2.31),('5815','2013-09-18','14:05:00',1.66),('5815','2013-09-18','14:10:00',2.12),('5815','2013-09-18','14:15:00',2.37),('5815','2013-09-18','14:20:00',2.34),('5815','2013-09-18','14:25:00',2.17),('5815','2013-09-18','14:30:00',2.26),('5815','2013-09-18','14:35:00',2.22),('5815','2013-09-18','14:40:00',2.2),('5815','2013-09-18','14:45:00',2.18),('5815','2013-09-18','14:50:00',2.18),('5815','2013-09-18','14:55:00',1.62),('5815','2013-09-18','15:00:00',2.22),('5815','2013-09-18','15:05:00',2.17),('5815','2013-09-18','15:10:00',1.87),('5815','2013-09-18','15:15:00',1.79),('5815','2013-09-18','15:20:00',2.06),('5815','2013-09-18','15:25:00',1.91),('5815','2013-09-18','15:30:00',1.48),('5815','2013-09-18','15:35:00',1.09),('5815','2013-09-18','15:40:00',1.64),('5815','2013-09-18','15:45:00',1.83),('5815','2013-09-18','15:50:00',1.84),('5815','2013-09-18','15:55:00',1.67),('5815','2013-09-18','16:00:00',1.72),('5815','2013-09-18','16:05:00',1.68),('5815','2013-09-18','16:10:00',1.19),('5815','2013-09-18','16:15:00',1.08),('5815','2013-09-18','16:20:00',1.61),('5815','2013-09-18','16:25:00',1.52),('5815','2013-09-18','16:30:00',1.31),('5815','2013-09-18','17:00:00',1.15),('5815','2013-09-18','17:05:00',1.09),('5815','2013-09-18','17:10:00',1.03),('5815','2013-09-17','09:20:00',1.31),('5815','2013-09-17','09:25:00',1.04),('5815','2013-09-17','09:30:00',1.04),('5815','2013-09-17','09:35:00',1.11),('5815','2013-09-17','09:40:00',1.5),('5815','2013-09-17','09:45:00',1.15),('5815','2013-09-17','10:00:00',1.01),('5815','2013-09-17','10:05:00',1.93),('5815','2013-09-17','10:10:00',1.81),('5815','2013-09-17','10:15:00',1.7),('5815','2013-09-17','10:20:00',1.68),('5815','2013-09-17','10:25:00',1.73),('5815','2013-09-17','10:30:00',1.74),('5815','2013-09-17','10:35:00',1.79),('5815','2013-09-17','10:40:00',1.81),('5815','2013-09-17','10:45:00',1.69),('5815','2013-09-17','10:50:00',1.74),('5815','2013-09-17','10:55:00',1.4),('5815','2013-09-17','11:00:00',1.37),('5815','2013-09-17','11:05:00',1.86),('5815','2013-09-17','11:10:00',1.21),('5815','2013-09-17','11:15:00',1.78),('5815','2013-09-17','11:20:00',1.34),('5815','2013-09-17','11:25:00',1.78),('5815','2013-09-17','11:30:00',2.24),('5815','2013-09-17','11:35:00',2.16),('5815','2013-09-17','11:40:00',1.1),('5815','2013-09-17','11:45:00',1.13),('5815','2013-09-17','11:50:00',2.09),('5815','2013-09-17','11:55:00',2.36),('5815','2013-09-17','12:00:00',2.35),('5815','2013-09-17','12:05:00',1.66),('5815','2013-09-17','12:10:00',2.42),('5815','2013-09-17','12:15:00',2.47),('5815','2013-09-17','12:20:00',2.34),('5815','2013-09-17','12:25:00',2.3),('5815','2013-09-17','12:30:00',2.28),('5815','2013-09-17','12:35:00',1.21),('5815','2013-09-17','12:40:00',2.65),('5815','2013-09-17','12:45:00',2.42),('5815','2013-09-17','12:50:00',2.5),('5815','2013-09-17','12:55:00',2.49),('5815','2013-09-17','13:00:00',2.48),('5815','2013-09-17','13:05:00',1.4),('5815','2013-09-17','13:10:00',2.51),('5815','2013-09-17','13:15:00',1.29),('5815','2013-09-17','13:20:00',2.53),('5815','2013-09-17','13:25:00',2.34),('5815','2013-09-17','13:30:00',2.48),('5815','2013-09-17','13:35:00',2.44),('5815','2013-09-17','13:40:00',2.41),('5815','2013-09-17','13:45:00',2.41),('5815','2013-09-17','13:50:00',2.23),('5815','2013-09-17','13:55:00',1.79),('5815','2013-09-17','14:00:00',2.46),('5815','2013-09-17','14:05:00',2.31),('5815','2013-09-17','14:10:00',2.36),('5815','2013-09-17','14:15:00',2.35),('5815','2013-09-17','14:20:00',2.32),('5815','2013-09-17','14:25:00',2.3),('5815','2013-09-17','14:30:00',2.26),('5815','2013-09-17','14:35:00',2.24),('5815','2013-09-17','14:40:00',2.24),('5815','2013-09-17','14:45:00',2.21),('5815','2013-09-17','14:50:00',2.2),('5815','2013-09-17','14:55:00',2.2),('5815','2013-09-17','15:00:00',2.14),('5815','2013-09-17','15:05:00',2.15),('5815','2013-09-17','15:10:00',1.03),('5815','2013-09-17','15:15:00',1.46),('5815','2013-09-17','15:20:00',2.13),('5815','2013-09-17','15:25:00',2.09),('5815','2013-09-17','15:30:00',2.06),('5815','2013-09-17','15:35:00',2.04),('5815','2013-09-17','15:40:00',2.01),('5815','2013-09-17','15:45:00',1.82),('5815','2013-09-17','15:50:00',1.33),('5815','2013-09-17','15:55:00',1.3),('5815','2013-09-17','16:00:00',1.33),('5815','2013-09-17','16:05:00',1.49),('5815','2013-09-17','16:10:00',1.8),('5815','2013-09-17','16:15:00',1.7),('5815','2013-09-17','16:20:00',1.62),('5815','2013-09-17','16:25:00',1.41),('5815','2013-09-17','16:30:00',1.33),('5815','2013-09-17','16:35:00',1.31),('5815','2013-09-17','16:40:00',1.31),('5815','2013-09-17','16:45:00',1.26),('5815','2013-09-17','16:50:00',1.14),('5815','2013-09-17','16:55:00',1.12),('5815','2013-09-17','17:00:00',1.17),('5815','2013-09-17','17:05:00',1.02),('5815','2013-09-17','17:10:00',1),('5815','2013-09-16','09:45:00',1.37),('5815','2013-09-16','10:00:00',1.25),('5815','2013-09-16','10:05:00',1.05),('5815','2013-09-16','10:10:00',1.14),('5815','2013-09-16','10:25:00',1.23),('5815','2013-09-16','10:30:00',1.74),('5815','2013-09-16','10:40:00',1.09),('5815','2013-09-16','10:45:00',1.43),('5815','2013-09-16','10:50:00',2.27),('5815','2013-09-16','10:55:00',1.62),('5815','2013-09-16','11:00:00',1.2),('5815','2013-09-16','11:10:00',1.97),('5815','2013-09-16','11:15:00',1.68),('5815','2013-09-16','11:20:00',1.41),('5815','2013-09-16','11:25:00',1.08),('5815','2013-09-16','11:30:00',1.06),('5815','2013-09-16','11:35:00',1.96),('5815','2013-09-16','11:40:00',2.22),('5815','2013-09-16','11:45:00',2.22),('5815','2013-09-16','11:50:00',1.91),('5815','2013-09-16','11:55:00',1.8),('5815','2013-09-16','12:00:00',2.02),('5815','2013-09-16','12:05:00',1.92),('5815','2013-09-16','12:10:00',1.05),('5815','2013-09-16','12:15:00',1.37),('5815','2013-09-16','12:20:00',1.23),('5815','2013-09-16','12:25:00',2.36),('5815','2013-09-16','12:30:00',2.19),('5815','2013-09-16','12:35:00',1.3),('5815','2013-09-16','12:40:00',1.95),('5815','2013-09-16','12:45:00',1.96),('5815','2013-09-16','12:50:00',1.73),('5815','2013-09-16','12:55:00',1.38),('5815','2013-09-16','13:00:00',1.57),('5815','2013-09-16','13:10:00',1.37),('5815','2013-09-16','13:15:00',2.02),('5815','2013-09-16','13:20:00',1.37),('5815','2013-09-16','13:25:00',1.19),('5815','2013-09-16','13:30:00',1.05),('5815','2013-09-16','13:35:00',1.04),('5815','2013-09-16','13:40:00',1.53),('5815','2013-09-16','13:45:00',1.09),('5815','2013-09-16','14:25:00',1.11),('5815','2013-09-16','14:55:00',1.86),('5815','2013-09-16','15:00:00',2.18),('5815','2013-09-16','15:05:00',1.71),('5815','2013-09-16','15:10:00',1.66),('5815','2013-09-16','15:15:00',1.47),('5815','2013-09-16','15:20:00',1.73),('5815','2013-09-16','15:25:00',1.72),('5815','2013-09-16','15:30:00',1.33),('5815','2013-09-16','15:50:00',1.13),('5815','2013-09-16','15:55:00',1.41),('5815','2013-09-16','16:05:00',1.03),('5815','2013-09-16','16:10:00',1.04),('5815','2013-09-16','16:15:00',1.18),('5815','2013-09-15','09:10:00',1.23),('5815','2013-09-15','09:20:00',1.02),('5815','2013-09-15','09:25:00',1.17),('5815','2013-09-15','09:30:00',1.21),('5815','2013-09-15','09:35:00',1.32),('5815','2013-09-15','09:40:00',1.36),('5815','2013-09-15','09:45:00',1.43),('5815','2013-09-15','09:50:00',1.48),('5815','2013-09-15','09:55:00',1.55),('5815','2013-09-15','10:00:00',1.6),('5815','2013-09-15','10:05:00',1.65),('5815','2013-09-15','10:10:00',1.72),('5815','2013-09-15','10:20:00',1.23),('5815','2013-09-15','10:30:00',1.63),('5815','2013-09-15','10:35:00',2.07),('5815','2013-09-15','10:40:00',1.86),('5815','2013-09-15','10:45:00',2.3),('5815','2013-09-15','10:50:00',1.09),('5815','2013-09-15','11:05:00',1.54),('5815','2013-09-15','11:10:00',1.31),('5815','2013-09-15','11:15:00',1.08),('5815','2013-09-15','11:20:00',1.44),('5815','2013-09-15','11:25:00',1.08),('5815','2013-09-15','11:30:00',2.3),('5815','2013-09-15','11:35:00',2.3),('5815','2013-09-15','11:40:00',2.34),('5815','2013-09-15','11:45:00',1.29),('5815','2013-09-15','11:50:00',1.62),('5815','2013-09-15','11:55:00',2.41),('5815','2013-09-15','12:00:00',2.46),('5815','2013-09-15','12:05:00',2.23),('5815','2013-09-15','12:10:00',1.88),('5815','2013-09-15','12:15:00',1.89),('5815','2013-09-15','12:20:00',2.43),('5815','2013-09-15','12:25:00',2.39),('5815','2013-09-15','12:30:00',2.38),('5815','2013-09-15','12:35:00',2.4),('5815','2013-09-15','12:40:00',2.46),('5815','2013-09-15','12:45:00',2.6),('5815','2013-09-15','12:50:00',1.63),('5815','2013-09-15','12:55:00',1.84),('5815','2013-09-15','13:00:00',1.48),('5815','2013-09-15','13:05:00',2.29),('5815','2013-09-15','13:10:00',2.22),('5815','2013-09-15','13:15:00',2.38),('5815','2013-09-15','13:20:00',2.45),('5815','2013-09-15','13:25:00',2.4),('5815','2013-09-15','13:30:00',2.37),('5815','2013-09-15','13:35:00',2.4),('5815','2013-09-15','13:40:00',2.41),('5815','2013-09-15','13:45:00',2.37),('5815','2013-09-15','13:50:00',2.38),('5815','2013-09-15','13:55:00',2.45),('5815','2013-09-15','14:00:00',2.39),('5815','2013-09-15','14:05:00',2.01),('5815','2013-09-15','14:10:00',2.33),('5815','2013-09-15','14:15:00',2.3),('5815','2013-09-15','14:20:00',2.25),('5815','2013-09-15','14:25:00',2.25),('5815','2013-09-15','14:30:00',2.24),('5815','2013-09-15','14:35:00',2.23),('5815','2013-09-15','14:40:00',2.19),('5815','2013-09-15','14:45:00',2.17),('5815','2013-09-15','14:50:00',2.16),('5815','2013-09-15','14:55:00',2.15),('5815','2013-09-15','15:00:00',2.12),('5815','2013-09-15','15:05:00',2.09),('5815','2013-09-15','15:10:00',2.09),('5815','2013-09-15','15:15:00',2.07),('5815','2013-09-15','15:20:00',2.05),('5815','2013-09-15','15:25:00',2.01),('5815','2013-09-15','15:30:00',1.98),('5815','2013-09-15','15:35:00',1.95),('5815','2013-09-15','15:40:00',1.92),('5815','2013-09-15','15:45:00',1.89),('5815','2013-09-15','15:50:00',1.84),('5815','2013-09-15','15:55:00',1.8),('5815','2013-09-15','16:00:00',1.78),('5815','2013-09-15','16:10:00',1.64),('5815','2013-09-15','16:15:00',1.67),('5815','2013-09-15','16:20:00',1.62),('5815','2013-09-15','16:25:00',1.58),('5815','2013-09-15','16:30:00',1.54),('5815','2013-09-15','16:35:00',1.49),('5815','2013-09-15','16:40:00',1.44),('5815','2013-09-15','16:45:00',1.4),('5815','2013-09-15','16:50:00',1.34),('5815','2013-09-15','16:55:00',1.29),('5815','2013-09-15','17:00:00',1.24),('5815','2013-09-15','17:05:00',1.18),('5815','2013-09-15','17:10:00',1.11),('5815','2013-09-14','09:05:00',1.03),('5815','2013-09-14','09:10:00',1.12),('5815','2013-09-14','09:15:00',1.23),('5815','2013-09-14','09:20:00',1.2),('5815','2013-09-14','09:25:00',1.26),('5815','2013-09-14','09:30:00',1.3),('5815','2013-09-14','09:35:00',1.38),('5815','2013-09-14','09:40:00',1.42),('5815','2013-09-14','09:45:00',1.43),('5815','2013-09-14','09:50:00',1.5),('5815','2013-09-14','09:55:00',1.52),('5815','2013-09-14','10:00:00',1.6),('5815','2013-09-14','10:05:00',1.64),('5815','2013-09-14','10:10:00',1.65),('5815','2013-09-14','10:15:00',1.57),('5815','2013-09-14','10:20:00',1.67),('5815','2013-09-14','10:25:00',1.73),('5815','2013-09-14','10:30:00',1.63),('5815','2013-09-14','10:35:00',1.54),('5815','2013-09-14','10:55:00',1.36),('5815','2013-09-14','11:00:00',1.33),('5815','2013-09-14','11:05:00',2.21),('5815','2013-09-14','11:10:00',1.65),('5815','2013-09-14','11:35:00',1.62),('5815','2013-09-14','11:50:00',1.74),('5815','2013-09-14','11:55:00',1.16),('5815','2013-09-14','13:45:00',1.29),('5815','2013-09-14','13:50:00',1.49),('5815','2013-09-14','15:15:00',1.44),('5815','2013-09-14','15:20:00',1.22),('5815','2013-09-13','09:00:00',1.02),('5815','2013-09-13','09:05:00',1.07),('5815','2013-09-13','09:10:00',1.12),('5815','2013-09-13','09:15:00',1.17),('5815','2013-09-13','09:20:00',1.22),('5815','2013-09-13','09:25:00',1.27),('5815','2013-09-13','09:30:00',1.33),('5815','2013-09-13','09:35:00',1.36),('5815','2013-09-13','09:40:00',1.4),('5815','2013-09-13','09:45:00',1.45),('5815','2013-09-13','09:50:00',1.47),('5815','2013-09-13','09:55:00',1.54),('5815','2013-09-13','10:00:00',1.51),('5815','2013-09-13','10:05:00',1.17),('5815','2013-09-13','10:10:00',1.5),('5815','2013-09-13','10:15:00',1.5),('5815','2013-09-13','10:20:00',1.68),('5815','2013-09-13','10:25:00',1.76),('5815','2013-09-13','10:30:00',1.77),('5815','2013-09-13','10:35:00',1.84),('5815','2013-09-13','10:40:00',1.92),('5815','2013-09-13','10:45:00',2.03),('5815','2013-09-13','10:50:00',2.21),('5815','2013-09-13','10:55:00',2.09),('5815','2013-09-13','11:00:00',2.24),('5815','2013-09-13','11:05:00',1.18),('5815','2013-09-13','11:25:00',1.29),('5815','2013-09-13','11:30:00',2.29),('5815','2013-09-13','11:35:00',2.26),('5815','2013-09-13','11:40:00',2.33),('5815','2013-09-13','11:45:00',2.26),('5815','2013-09-13','11:50:00',2.14),('5815','2013-09-13','11:55:00',1.94),('5815','2013-09-13','12:00:00',1.07),('5815','2013-09-13','12:05:00',1.87),('5815','2013-09-13','12:10:00',1.1),('5815','2013-09-13','12:15:00',1.15),('5815','2013-09-13','12:40:00',1.65),('5815','2013-09-13','13:15:00',2.26),('5815','2013-09-13','13:20:00',2.57),('5815','2013-09-13','13:25:00',2.17),('5815','2013-09-13','13:30:00',2.6),('5815','2013-09-13','13:35:00',1.77),('5815','2013-09-13','13:45:00',1.46),('5815','2013-09-13','13:50:00',1.38),('5815','2013-09-13','13:55:00',2.22),('5815','2013-09-13','14:00:00',2.61),('5815','2013-09-13','14:05:00',2.41),('5815','2013-09-13','14:10:00',2.35),('5815','2013-09-13','14:15:00',2.32),('5815','2013-09-13','14:20:00',2.34),('5815','2013-09-13','14:25:00',2.23),('5815','2013-09-13','14:30:00',2.28),('5815','2013-09-13','14:35:00',2.26),('5815','2013-09-13','14:40:00',2.23),('5815','2013-09-13','14:45:00',2.21),('5815','2013-09-13','14:50:00',2.18),('5815','2013-09-13','14:55:00',2.15),('5815','2013-09-13','15:00:00',2.11),('5815','2013-09-13','15:05:00',2.11),('5815','2013-09-13','15:10:00',2.06),('5815','2013-09-13','15:15:00',2.05),('5815','2013-09-13','15:20:00',2.02),('5815','2013-09-13','15:25:00',2.01),('5815','2013-09-13','15:30:00',1.98),('5815','2013-09-13','15:35:00',1.93),('5815','2013-09-13','15:40:00',1.92),('5815','2013-09-13','15:45:00',1.86),('5815','2013-09-13','15:50:00',1.83),('5815','2013-09-13','15:55:00',1.8),('5815','2013-09-13','16:00:00',1.76),('5815','2013-09-13','16:05:00',1.73),('5815','2013-09-13','16:10:00',1.67),('5815','2013-09-13','16:15:00',1.62),('5815','2013-09-13','16:20:00',1.6),('5815','2013-09-13','16:25:00',1.54),('5815','2013-09-13','16:30:00',1.52),('5815','2013-09-13','16:35:00',1.47),('5815','2013-09-13','16:40:00',1.43),('5815','2013-09-13','16:45:00',1.38),('5815','2013-09-13','16:50:00',1.32),('5815','2013-09-13','16:55:00',1.28),('5815','2013-09-13','17:00:00',1.23),('5815','2013-09-13','17:05:00',1.15),('5815','2013-09-13','17:10:00',1.14),('5815','2013-09-13','17:15:00',1.02),('5815','2013-09-12','09:55:00',1.05),('5815','2013-09-12','10:00:00',1.55),('5815','2013-09-12','10:10:00',1.09),('5815','2013-09-12','10:15:00',2.1),('5815','2013-09-12','10:20:00',1.91),('5815','2013-09-12','10:30:00',1.2),('5815','2013-09-12','10:35:00',2.05),('5815','2013-09-12','10:40:00',1.91),('5815','2013-09-12','10:45:00',1.92),('5815','2013-09-12','10:50:00',1.94),('5815','2013-09-12','10:55:00',1.96),('5815','2013-09-12','11:00:00',2),('5815','2013-09-12','11:05:00',2.03),('5815','2013-09-12','11:10:00',2.06),('5815','2013-09-12','11:15:00',2.08),('5815','2013-09-12','11:20:00',2.06),('5815','2013-09-12','11:25:00',2.12),('5815','2013-09-12','11:30:00',2.13),('5815','2013-09-12','11:35:00',2.16),('5815','2013-09-12','11:40:00',2.18),('5815','2013-09-12','11:45:00',2.19),('5815','2013-09-12','11:50:00',2.21),('5815','2013-09-12','11:55:00',2.22),('5815','2013-09-12','12:00:00',2.24),('5815','2013-09-12','12:05:00',2.27),('5815','2013-09-12','12:10:00',2.28),('5815','2013-09-12','12:15:00',2.3),('5815','2013-09-12','12:20:00',2.31),('5815','2013-09-12','12:25:00',2.34),('5815','2013-09-12','12:30:00',1.34),('5815','2013-09-12','12:35:00',2.4),('5815','2013-09-12','12:40:00',2.4),('5815','2013-09-12','12:45:00',2.39),('5815','2013-09-12','12:50:00',2.36),('5815','2013-09-12','12:55:00',2.36),('5815','2013-09-12','13:00:00',2.36),('5815','2013-09-12','13:05:00',2.37),('5815','2013-09-12','13:10:00',2.36),('5815','2013-09-12','13:15:00',2.36),('5815','2013-09-12','13:20:00',2.37),('5815','2013-09-12','13:25:00',2.36),('5815','2013-09-12','13:30:00',2.34),('5815','2013-09-12','13:35:00',2.31),('5815','2013-09-12','13:40:00',2.3),('5815','2013-09-12','13:45:00',2.3),('5815','2013-09-12','13:50:00',2.3),('5815','2013-09-12','13:55:00',2.28),('5815','2013-09-12','14:00:00',2.28),('5815','2013-09-12','14:05:00',2.28),('5815','2013-09-12','14:10:00',2.28),('5815','2013-09-12','14:15:00',2.26),('5815','2013-09-12','14:20:00',2.25),('5815','2013-09-12','14:25:00',2.24),('5815','2013-09-12','14:30:00',2.24),('5815','2013-09-12','14:35:00',2.22),('5815','2013-09-12','14:40:00',2.17),('5815','2013-09-12','14:45:00',2.17),('5815','2013-09-12','14:50:00',2.16),('5815','2013-09-12','14:55:00',2.13),('5815','2013-09-12','15:00:00',2.07),('5815','2013-09-12','15:05:00',2.07),('5815','2013-09-12','15:10:00',2.07),('5815','2013-09-12','15:15:00',2.07),('5815','2013-09-12','15:20:00',2.02),('5815','2013-09-12','15:25:00',2),('5815','2013-09-12','15:30:00',1.96),('5815','2013-09-12','15:35:00',1.91),('5815','2013-09-12','15:40:00',1.91),('5815','2013-09-12','15:45:00',1.88),('5815','2013-09-12','15:50:00',1.85),('5815','2013-09-12','15:55:00',1.81),('5815','2013-09-12','16:00:00',1.77),('5815','2013-09-12','16:05:00',1.74),('5815','2013-09-12','16:10:00',1.69),('5815','2013-09-12','16:15:00',1.66),('5815','2013-09-12','16:20:00',1.62),('5815','2013-09-12','16:25:00',1.57),('5815','2013-09-12','16:30:00',1.52),('5815','2013-09-12','16:35:00',1.49),('5815','2013-09-12','16:40:00',1.44),('5815','2013-09-12','16:45:00',1.39),('5815','2013-09-12','16:50:00',1.34),('5815','2013-09-12','16:55:00',1.28),('5815','2013-09-12','17:00:00',1.22),('5815','2013-09-12','17:05:00',1.17),('5815','2013-09-12','17:10:00',1.12),('5815','2013-09-11','09:00:00',1.03),('5815','2013-09-11','09:15:00',1.12),('5815','2013-09-11','09:20:00',1.15),('5815','2013-09-11','09:25:00',1.3),('5815','2013-09-11','09:30:00',1.39),('5815','2013-09-11','09:35:00',1.29),('5815','2013-09-11','09:40:00',1.12),('5815','2013-09-11','09:45:00',1.34),('5815','2013-09-11','09:50:00',1.14),('5815','2013-09-11','10:55:00',1),('5815','2013-09-11','11:00:00',1.27),('5815','2013-09-11','11:05:00',2.09),('5815','2013-09-11','11:10:00',1.52),('5815','2013-09-11','11:15:00',1.77),('5815','2013-09-11','11:45:00',1.05),('5815','2013-09-11','11:55:00',1.77),('5815','2013-09-11','12:00:00',1.9),('5815','2013-09-11','12:05:00',2.31),('5815','2013-09-11','12:10:00',2.25),('5815','2013-09-11','12:15:00',2.03),('5815','2013-09-11','12:25:00',1),('5815','2013-09-11','12:35:00',1.63),('5815','2013-09-11','12:40:00',2.37),('5815','2013-09-11','12:50:00',1.88),('5815','2013-09-11','12:55:00',1.06),('5815','2013-09-11','13:00:00',2.35),('5815','2013-09-11','13:05:00',1.96),('5815','2013-09-11','13:10:00',1.81),('5815','2013-09-11','13:15:00',2.1),('5815','2013-09-11','13:20:00',2.49),('5815','2013-09-11','13:25:00',2.83),('5815','2013-09-11','13:30:00',2.4),('5815','2013-09-11','13:35:00',1.93),('5815','2013-09-11','13:40:00',1.81),('5815','2013-09-11','13:45:00',2.45),('5815','2013-09-11','13:50:00',2.56),('5815','2013-09-11','13:55:00',2.45),('5815','2013-09-11','14:00:00',2.37),('5815','2013-09-11','14:05:00',2.24),('5815','2013-09-11','14:10:00',1.89),('5815','2013-09-11','14:15:00',2.44),('5815','2013-09-11','14:20:00',2.25),('5815','2013-09-11','14:25:00',2.45),('5815','2013-09-11','14:30:00',2.42),('5815','2013-09-11','14:35:00',1.82),('5815','2013-09-11','14:40:00',1.79),('5815','2013-09-11','14:45:00',2.33),('5815','2013-09-11','14:50:00',2.27),('5815','2013-09-11','14:55:00',2.24),('5815','2013-09-11','15:00:00',2.22),('5815','2013-09-11','15:05:00',2.21),('5815','2013-09-11','15:10:00',1.73),('5815','2013-09-11','15:15:00',1.97),('5815','2013-09-11','15:20:00',2.09),('5815','2013-09-11','15:25:00',1.84),('5815','2013-09-11','15:30:00',2.05),('5815','2013-09-11','15:35:00',2),('5815','2013-09-11','15:40:00',1.91),('5815','2013-09-11','15:45:00',1.96),('5815','2013-09-11','15:50:00',1.9),('5815','2013-09-11','15:55:00',1.77),('5815','2013-09-11','16:00:00',1.85),('5815','2013-09-11','16:05:00',1.4),('5815','2013-09-11','16:10:00',1.52),('5815','2013-09-11','16:15:00',1.64),('5815','2013-09-11','16:20:00',1.14),('5815','2013-09-11','16:25:00',1.35),('5815','2013-09-11','16:45:00',1.59),('5815','2013-09-11','16:55:00',1.19),('5815','2013-09-11','17:05:00',1.34),('5815','2013-09-11','17:15:00',1.12),('5815','2013-09-10','09:05:00',1.18),('5815','2013-09-10','09:10:00',1.29),('5815','2013-09-10','09:15:00',1.09),('5815','2013-09-10','09:20:00',1.46),('5815','2013-09-10','09:25:00',1.07),('5815','2013-09-10','10:15:00',1.09),('5815','2013-09-10','10:20:00',1.78),('5815','2013-09-10','10:25:00',1.07),('5815','2013-09-10','10:30:00',1.77),('5815','2013-09-10','10:35:00',1.58),('5815','2013-09-10','10:40:00',1.67),('5815','2013-09-10','10:50:00',1.66),('5815','2013-09-10','10:55:00',1.06),('5815','2013-09-10','11:05:00',1.26),('5815','2013-09-10','11:10:00',1.66),('5815','2013-09-10','11:15:00',1.55),('5815','2013-09-10','11:20:00',2.26),('5815','2013-09-10','11:25:00',1.8),('5815','2013-09-10','11:35:00',1.51),('5815','2013-09-10','11:40:00',1.58),('5815','2013-09-10','11:45:00',2.31),('5815','2013-09-10','11:50:00',2.37),('5815','2013-09-10','11:55:00',2.43),('5815','2013-09-10','12:00:00',1.38),('5815','2013-09-10','12:05:00',2.36),('5815','2013-09-10','12:10:00',1.77),('5815','2013-09-10','12:15:00',1.37),('5815','2013-09-10','12:20:00',1.91),('5815','2013-09-10','12:25:00',1.85),('5815','2013-09-10','12:30:00',2.44),('5815','2013-09-10','12:35:00',2.19),('5815','2013-09-10','12:50:00',2.18),('5815','2013-09-10','12:55:00',2.11),('5815','2013-09-10','13:00:00',1.85),('5815','2013-09-10','13:05:00',2.46),('5815','2013-09-10','13:10:00',2.5),('5815','2013-09-10','13:15:00',2.61),('5815','2013-09-10','13:20:00',2.14),('5815','2013-09-10','13:25:00',2.47),('5815','2013-09-10','13:30:00',2.26),('5815','2013-09-10','13:35:00',1.03),('5815','2013-09-10','13:40:00',1.78),('5815','2013-09-10','13:45:00',1.05),('5815','2013-09-10','13:50:00',2.18),('5815','2013-09-10','13:55:00',1.96),('5815','2013-09-10','14:00:00',1.65),('5815','2013-09-10','14:05:00',2.52),('5815','2013-09-10','14:10:00',2.3),('5815','2013-09-10','14:15:00',2.45),('5815','2013-09-10','14:20:00',1.33),('5815','2013-09-10','14:25:00',2.43),('5815','2013-09-10','14:30:00',1.48),('5815','2013-09-10','14:35:00',2.26),('5815','2013-09-10','14:45:00',1.98),('5815','2013-09-10','14:50:00',2.43),('5815','2013-09-10','14:55:00',2.24),('5815','2013-09-10','15:00:00',1.07),('5815','2013-09-10','15:05:00',2.39),('5815','2013-09-10','15:10:00',1.05),('5815','2013-09-10','15:15:00',2.14),('5815','2013-09-10','15:20:00',1.59),('5815','2013-09-10','15:25:00',1.99),('5815','2013-09-10','15:30:00',1.82),('5815','2013-09-10','15:35:00',1.02),('5815','2013-09-10','15:45:00',1.88),('5815','2013-09-10','15:50:00',2),('5815','2013-09-10','15:55:00',1.46),('5815','2013-09-10','16:00:00',1.56),('5815','2013-09-10','16:05:00',1.88),('5815','2013-09-10','16:10:00',1.64),('5815','2013-09-10','16:15:00',1.76),('5815','2013-09-10','16:20:00',1.69),('5815','2013-09-10','16:25:00',1.61),('5815','2013-09-10','16:35:00',1.33),('5815','2013-09-10','16:45:00',1.54),('5815','2013-09-10','16:50:00',1.39),('5815','2013-09-10','16:55:00',1.28),('5815','2013-09-10','17:00:00',1.16),('5815','2013-09-10','17:05:00',1.23),('5815','2013-09-10','17:10:00',1.17),('5815','2013-09-10','17:15:00',1.08),('5815','2013-09-10','17:20:00',1.02),('5815','2013-09-09','09:10:00',1.27),('5815','2013-09-09','09:15:00',1.09),('5815','2013-09-09','09:30:00',1.4),('5815','2013-09-09','09:35:00',1.57),('5815','2013-09-09','10:45:00',1.15),('5815','2013-09-09','13:45:00',1.59),('5815','2013-09-09','13:50:00',1.06),('5815','2013-09-09','14:25:00',1.25),('5815','2013-09-09','14:30:00',1.17),('5815','2013-09-09','14:40:00',1.01),('5815','2013-09-09','14:45:00',1.05),('5815','2013-09-09','14:50:00',1.24),('5815','2013-09-09','14:55:00',1.18),('5815','2013-09-09','15:00:00',1.39),('5815','2013-09-09','15:05:00',1.36),('5815','2013-09-09','15:10:00',1.02),('5815','2013-09-09','15:20:00',1.23),('5815','2013-09-09','15:25:00',1.07),('5815','2013-09-09','15:30:00',1.21),('5815','2013-09-09','15:35:00',1.13),('5815','2013-09-08','10:10:00',1),('5815','2013-09-08','10:40:00',1.01),('5815','2013-09-08','10:45:00',1.11),('5815','2013-09-08','10:50:00',1.47),('5815','2013-09-08','10:55:00',1.43),('5815','2013-09-08','11:00:00',1.55),('5815','2013-09-08','11:05:00',1.19),('5815','2013-09-08','11:15:00',1.19),('5815','2013-09-08','11:20:00',1.41),('5815','2013-09-08','11:25:00',1.58),('5815','2013-09-08','11:30:00',1.25),('5815','2013-09-08','11:35:00',1.22),('5815','2013-09-08','11:40:00',1.87),('5815','2013-09-08','11:45:00',1.94),('5815','2013-09-08','11:50:00',1.5),('5815','2013-09-08','11:55:00',1.85),('5815','2013-09-08','12:00:00',1.66),('5815','2013-09-08','12:05:00',1.86),('5815','2013-09-08','12:10:00',1.73),('5815','2013-09-08','12:15:00',1.3),('5815','2013-09-08','13:05:00',1.31),('5815','2013-09-08','13:10:00',1.5),('5815','2013-09-08','13:15:00',1.94),('5815','2013-09-08','13:20:00',1.61),('5815','2013-09-08','13:25:00',1.41),('5815','2013-09-08','13:30:00',1.68),('5815','2013-09-08','13:35:00',2.14),('5815','2013-09-08','13:40:00',2.17),('5815','2013-09-08','13:45:00',2.21),('5815','2013-09-08','13:50:00',2.41),('5815','2013-09-08','13:55:00',2.44),('5815','2013-09-08','14:00:00',2.22),('5815','2013-09-08','14:05:00',2.11),('5815','2013-09-08','14:10:00',2.24),('5815','2013-09-08','14:15:00',1.65),('5815','2013-09-08','14:20:00',1.16),('5815','2013-09-08','14:25:00',1.07),('5815','2013-09-08','14:30:00',1.04),('5815','2013-09-08','14:35:00',2.24),('5815','2013-09-08','14:40:00',2.19),('5815','2013-09-08','14:45:00',1.16),('5815','2013-09-08','14:50:00',1.94),('5815','2013-09-08','14:55:00',1.98),('5815','2013-09-08','15:00:00',1.61),('5815','2013-09-08','15:05:00',1.49),('5815','2013-09-08','15:10:00',1.73),('5815','2013-09-08','15:20:00',1.25),('5815','2013-09-08','15:30:00',1.73),('5815','2013-09-08','15:35:00',1.39),('5815','2013-09-08','15:40:00',1.5),('5815','2013-09-08','16:15:00',1.28),('5815','2013-09-08','16:20:00',1.03),('5815','2013-09-08','16:45:00',1.33),('5815','2013-09-07','09:30:00',1.13),('5815','2013-09-07','09:35:00',1.33),('5815','2013-09-07','09:40:00',1.31),('5815','2013-09-07','09:45:00',1.3),('5815','2013-09-07','09:50:00',1.36),('5815','2013-09-07','09:55:00',1.4),('5815','2013-09-07','10:00:00',1.42),('5815','2013-09-07','10:05:00',1.48),('5815','2013-09-07','10:10:00',1.52),('5815','2013-09-07','10:15:00',1.54),('5815','2013-09-07','10:20:00',1.61),('5815','2013-09-07','10:25:00',1.64),('5815','2013-09-07','10:30:00',1.67),('5815','2013-09-07','10:35:00',1.71),('5815','2013-09-07','10:40:00',1.69),('5815','2013-09-07','10:45:00',1.75),('5815','2013-09-07','10:50:00',1.78),('5815','2013-09-07','10:55:00',1.82),('5815','2013-09-07','11:00:00',1.85),('5815','2013-09-07','11:05:00',1.85),('5815','2013-09-07','11:10:00',1.86),('5815','2013-09-07','11:15:00',1.88),('5815','2013-09-07','11:20:00',1.88),('5815','2013-09-07','11:25:00',1.88),('5815','2013-09-07','11:30:00',1.93),('5815','2013-09-07','11:35:00',1.92),('5815','2013-09-07','11:40:00',1.95),('5815','2013-09-07','11:45:00',1.96),('5815','2013-09-07','11:50:00',1.95),('5815','2013-09-07','11:55:00',1.92),('5815','2013-09-07','12:00:00',1.94),('5815','2013-09-07','12:05:00',1.95),('5815','2013-09-07','12:10:00',1.98),('5815','2013-09-07','12:15:00',2.05),('5815','2013-09-07','12:20:00',2.08),('5815','2013-09-07','12:25:00',2.03),('5815','2013-09-07','12:30:00',2.05),('5815','2013-09-07','12:35:00',2.12),('5815','2013-09-07','12:40:00',2.06),('5815','2013-09-07','12:45:00',2.01),('5815','2013-09-07','12:50:00',2.05),('5815','2013-09-07','12:55:00',2.09),('5815','2013-09-07','13:00:00',2.07),('5815','2013-09-07','13:05:00',2.1),('5815','2013-09-07','13:10:00',2.12),('5815','2013-09-07','13:15:00',2.07),('5815','2013-09-07','13:20:00',2.05),('5815','2013-09-07','13:25:00',1.96),('5815','2013-09-07','13:30:00',1.84),('5815','2013-09-07','13:35:00',1.87),('5815','2013-09-07','13:40:00',1.44),('5815','2013-09-07','13:45:00',1.23),('5815','2013-09-07','13:50:00',1.41),('5815','2013-09-07','13:55:00',1.51),('5815','2013-09-07','14:00:00',1.9),('5815','2013-09-07','14:05:00',1.97),('5815','2013-09-07','14:10:00',2.05),('5815','2013-09-07','14:15:00',1.88),('5815','2013-09-07','14:20:00',1.71),('5815','2013-09-07','14:25:00',2.28),('5815','2013-09-07','14:30:00',1.97),('5815','2013-09-07','14:35:00',2.18),('5815','2013-09-07','14:40:00',2.05),('5815','2013-09-07','14:45:00',2.1),('5815','2013-09-07','14:50:00',2.07),('5815','2013-09-07','14:55:00',2.02),('5815','2013-09-07','15:00:00',2.01),('5815','2013-09-07','15:05:00',1.73),('5815','2013-09-07','15:10:00',1.06),('5815','2013-09-07','15:15:00',1.52),('5815','2013-09-07','15:20:00',1.89),('5815','2013-09-07','15:25:00',1.94),('5815','2013-09-07','15:30:00',1.95),('5815','2013-09-07','15:35:00',1.89),('5815','2013-09-07','15:40:00',1.75),('5815','2013-09-07','15:45:00',1.77),('5815','2013-09-07','15:50:00',1.79),('5815','2013-09-07','15:55:00',1.45),('5815','2013-09-07','16:00:00',1.49),('5815','2013-09-07','16:05:00',1.45),('5815','2013-09-07','16:10:00',1.35),('5815','2013-09-07','16:15:00',1.46),('5815','2013-09-07','16:20:00',1.42),('5815','2013-09-07','16:25:00',1.43),('5815','2013-09-07','16:30:00',1.33),('5815','2013-09-07','16:35:00',1.34),('5815','2013-09-07','16:40:00',1.15),('5815','2013-09-07','17:05:00',1.21),('5815','2013-09-07','17:10:00',1.16),('5815','2013-09-07','17:15:00',1.06),('5815','2013-09-06','09:05:00',1.01),('5815','2013-09-06','09:10:00',1.06),('5815','2013-09-06','09:15:00',1.11),('5815','2013-09-06','09:20:00',1.15),('5815','2013-09-06','09:25:00',1.19),('5815','2013-09-06','09:30:00',1.25),('5815','2013-09-06','09:35:00',1.29),('5815','2013-09-06','09:40:00',1.31),('5815','2013-09-06','09:45:00',1.37),('5815','2013-09-06','09:50:00',1.4),('5815','2013-09-06','09:55:00',1.45),('5815','2013-09-06','10:00:00',1.48),('5815','2013-09-06','10:05:00',1.51),('5815','2013-09-06','10:10:00',1.55),('5815','2013-09-06','10:15:00',1.56),('5815','2013-09-06','10:20:00',1.61),('5815','2013-09-06','10:25:00',1.65),('5815','2013-09-06','10:30:00',1.68),('5815','2013-09-06','10:35:00',1.71),('5815','2013-09-06','10:40:00',1.74),('5815','2013-09-06','10:45:00',1.77),('5815','2013-09-06','10:50:00',1.8),('5815','2013-09-06','10:55:00',1.81),('5815','2013-09-06','11:00:00',1.83),('5815','2013-09-06','11:05:00',1.85),('5815','2013-09-06','11:10:00',1.89),('5815','2013-09-06','11:15:00',1.93),('5815','2013-09-06','11:20:00',1.95),('5815','2013-09-06','11:25:00',2.01),('5815','2013-09-06','11:30:00',2.03),('5815','2013-09-06','11:35:00',2.04),('5815','2013-09-06','11:40:00',2.04),('5815','2013-09-06','11:45:00',2.07),('5815','2013-09-06','11:50:00',2.06),('5815','2013-09-06','11:55:00',2.06),('5815','2013-09-06','12:00:00',2.07),('5815','2013-09-06','12:05:00',2.1),('5815','2013-09-06','12:10:00',2.12),('5815','2013-09-06','12:15:00',2.11),('5815','2013-09-06','12:20:00',2.12),('5815','2013-09-06','12:25:00',2.14),('5815','2013-09-06','12:30:00',2.13),('5815','2013-09-06','12:35:00',2.15),('5815','2013-09-06','12:40:00',2.14),('5815','2013-09-06','12:45:00',2.13),('5815','2013-09-06','12:50:00',2.19),('5815','2013-09-06','12:55:00',2.2),('5815','2013-09-06','13:00:00',2.2),('5815','2013-09-06','13:05:00',2.19),('5815','2013-09-06','13:10:00',2.19),('5815','2013-09-06','13:15:00',2.17),('5815','2013-09-06','13:20:00',2.17),('5815','2013-09-06','13:25:00',2.16),('5815','2013-09-06','13:30:00',2.16),('5815','2013-09-06','13:35:00',2.17),('5815','2013-09-06','13:40:00',2.22),('5815','2013-09-06','13:45:00',2.21),('5815','2013-09-06','13:50:00',2.21),('5815','2013-09-06','13:55:00',2.15),('5815','2013-09-06','14:00:00',1.24),('5815','2013-09-06','14:05:00',2.17),('5815','2013-09-06','14:10:00',2.2),('5815','2013-09-06','14:15:00',2.21),('5815','2013-09-06','14:20:00',2.15),('5815','2013-09-06','14:25:00',2.11),('5815','2013-09-06','14:30:00',2.12),('5815','2013-09-06','14:35:00',2.13),('5815','2013-09-06','14:40:00',2.1),('5815','2013-09-06','14:45:00',2.11),('5815','2013-09-06','14:50:00',2.08),('5815','2013-09-06','14:55:00',2.05),('5815','2013-09-06','15:00:00',2.05),('5815','2013-09-06','15:05:00',2.03),('5815','2013-09-06','15:10:00',1.95),('5815','2013-09-06','15:15:00',1.97),('5815','2013-09-06','15:20:00',1.94),('5815','2013-09-06','15:25:00',1.91),('5815','2013-09-06','15:30:00',1.89),('5815','2013-09-06','15:35:00',1.87),('5815','2013-09-06','15:40:00',1.82),('5815','2013-09-06','15:45:00',1.78),('5815','2013-09-06','15:50:00',1.75),('5815','2013-09-06','15:55:00',1.72),('5815','2013-09-06','16:00:00',1.68),('5815','2013-09-06','16:05:00',1.65),('5815','2013-09-06','16:10:00',1.61),('5815','2013-09-06','16:15:00',1.57),('5815','2013-09-06','16:20:00',1.53),('5815','2013-09-06','16:25:00',1.47),('5815','2013-09-06','16:30:00',1.44),('5815','2013-09-06','16:35:00',1.4),('5815','2013-09-06','16:40:00',1.35),('5815','2013-09-06','16:45:00',1.3),('5815','2013-09-06','16:50:00',1.26),('5815','2013-09-06','16:55:00',1.22),('5815','2013-09-06','17:00:00',1.17),('5815','2013-09-06','17:05:00',1.12),('5815','2013-09-06','17:10:00',1.07),('5815','2013-09-06','17:15:00',1.02),('5815','2013-09-05','09:05:00',1.04),('5815','2013-09-05','09:10:00',1.08),('5815','2013-09-05','09:15:00',1.13),('5815','2013-09-05','09:20:00',1.17),('5815','2013-09-05','09:25:00',1.21),('5815','2013-09-05','09:30:00',1.26),('5815','2013-09-05','09:35:00',1.3),('5815','2013-09-05','09:40:00',1.34),('5815','2013-09-05','09:45:00',1.39),('5815','2013-09-05','09:50:00',1.44),('5815','2013-09-05','09:55:00',1.47),('5815','2013-09-05','10:00:00',1.5),('5815','2013-09-05','10:05:00',1.54),('5815','2013-09-05','10:10:00',1.59),('5815','2013-09-05','10:15:00',1.61),('5815','2013-09-05','10:20:00',1.65),('5815','2013-09-05','10:25:00',1.68),('5815','2013-09-05','10:30:00',1.72),('5815','2013-09-05','10:35:00',1.74),('5815','2013-09-05','10:40:00',1.77),('5815','2013-09-05','10:45:00',1.8),('5815','2013-09-05','10:50:00',1.83),('5815','2013-09-05','10:55:00',1.86),('5815','2013-09-05','11:00:00',1.88),('5815','2013-09-05','11:05:00',1.9),('5815','2013-09-05','11:10:00',1.9),('5815','2013-09-05','11:15:00',1.96),('5815','2013-09-05','11:20:00',1.97),('5815','2013-09-05','11:25:00',1.98),('5815','2013-09-05','11:30:00',2.01),('5815','2013-09-05','11:35:00',2.03),('5815','2013-09-05','11:40:00',2.06),('5815','2013-09-05','11:45:00',2.06),('5815','2013-09-05','11:50:00',2.08),('5815','2013-09-05','11:55:00',2.1),('5815','2013-09-05','12:00:00',2.1),('5815','2013-09-05','12:05:00',2.1),('5815','2013-09-05','12:10:00',2.1),('5815','2013-09-05','12:15:00',2.13),('5815','2013-09-05','12:20:00',2.15),('5815','2013-09-05','12:25:00',2.16),('5815','2013-09-05','12:30:00',2.18),('5815','2013-09-05','12:35:00',2.19),('5815','2013-09-05','12:40:00',2.16),('5815','2013-09-05','12:45:00',2.15),('5815','2013-09-05','12:50:00',2.17),('5815','2013-09-05','12:55:00',2.2),('5815','2013-09-05','13:00:00',2.19),('5815','2013-09-05','13:05:00',2.18),('5815','2013-09-05','13:10:00',2.19),('5815','2013-09-05','13:15:00',2.18),('5815','2013-09-05','13:20:00',2.18),('5815','2013-09-05','13:25:00',2.16),('5815','2013-09-05','13:30:00',2.17),('5815','2013-09-05','13:35:00',2.17),('5815','2013-09-05','13:40:00',2.18),('5815','2013-09-05','13:45:00',1.95),('5815','2013-09-05','13:50:00',1.92),('5815','2013-09-05','13:55:00',2.11),('5815','2013-09-05','14:00:00',2.12),('5815','2013-09-05','14:05:00',2.1),('5815','2013-09-05','14:10:00',2.12),('5815','2013-09-05','14:15:00',2.13),('5815','2013-09-05','14:20:00',2.13),('5815','2013-09-05','14:25:00',2.11),('5815','2013-09-05','14:30:00',2.08),('5815','2013-09-05','14:35:00',2.05),('5815','2013-09-05','14:40:00',1.96),('5815','2013-09-05','14:45:00',2),('5815','2013-09-05','14:50:00',2.04),('5815','2013-09-05','14:55:00',2.04),('5815','2013-09-05','15:00:00',2),('5815','2013-09-05','15:05:00',1.96),('5815','2013-09-05','15:10:00',1.92),('5815','2013-09-05','15:15:00',1.92),('5815','2013-09-05','15:20:00',1.9),('5815','2013-09-05','15:25:00',1.87),('5815','2013-09-05','15:30:00',1.86),('5815','2013-09-05','15:35:00',1.82),('5815','2013-09-05','15:40:00',1.79),('5815','2013-09-05','15:45:00',1.77),('5815','2013-09-05','15:50:00',1.74),('5815','2013-09-05','15:55:00',1.72),('5815','2013-09-05','16:00:00',1.68),('5815','2013-09-05','16:05:00',1.63),('5815','2013-09-05','16:10:00',1.59),('5815','2013-09-05','16:15:00',1.55),('5815','2013-09-05','16:20:00',1.52),('5815','2013-09-05','16:25:00',1.49),('5815','2013-09-05','16:30:00',1.45),('5815','2013-09-05','16:35:00',1.41),('5815','2013-09-05','16:40:00',1.35),('5815','2013-09-05','16:45:00',1.33),('5815','2013-09-05','16:50:00',1.26),('5815','2013-09-05','16:55:00',1.23),('5815','2013-09-05','17:00:00',1.18),('5815','2013-09-05','17:05:00',1.11),('5815','2013-09-05','17:10:00',1.08),('5815','2013-09-05','17:15:00',1.02),('5815','2013-09-04','08:55:00',1.01),('5815','2013-09-04','09:00:00',1.06),('5815','2013-09-04','09:05:00',1.11),('5815','2013-09-04','09:10:00',1.16),('5815','2013-09-04','09:15:00',1.2),('5815','2013-09-04','09:20:00',1.25),('5815','2013-09-04','09:25:00',1.3),('5815','2013-09-04','09:30:00',1.34),('5815','2013-09-04','09:35:00',1.38),('5815','2013-09-04','09:40:00',1.42),('5815','2013-09-04','09:45:00',1.47),('5815','2013-09-04','09:50:00',1.51),('5815','2013-09-04','09:55:00',1.55),('5815','2013-09-04','10:00:00',1.59),('5815','2013-09-04','10:05:00',1.63),('5815','2013-09-04','10:10:00',1.65),('5815','2013-09-04','10:15:00',1.69),('5815','2013-09-04','10:20:00',1.69),('5815','2013-09-04','10:25:00',1.75),('5815','2013-09-04','10:30:00',1.78),('5815','2013-09-04','10:35:00',1.82),('5815','2013-09-04','10:40:00',1.84),('5815','2013-09-04','10:45:00',1.87),('5815','2013-09-04','10:50:00',1.9),('5815','2013-09-04','10:55:00',1.93),('5815','2013-09-04','11:00:00',1.94),('5815','2013-09-04','11:05:00',1.98),('5815','2013-09-04','11:10:00',2),('5815','2013-09-04','11:15:00',2.01),('5815','2013-09-04','11:20:00',2.04),('5815','2013-09-04','11:25:00',2.07),('5815','2013-09-04','11:30:00',2.08),('5815','2013-09-04','11:35:00',2.07),('5815','2013-09-04','11:40:00',2.06),('5815','2013-09-04','11:45:00',2.07),('5815','2013-09-04','11:50:00',2.14),('5815','2013-09-04','11:55:00',2.16),('5815','2013-09-04','12:00:00',2.16),('5815','2013-09-04','12:05:00',2.19),('5815','2013-09-04','12:10:00',2.2),('5815','2013-09-04','12:15:00',2.21),('5815','2013-09-04','12:20:00',2.2),('5815','2013-09-04','12:25:00',2.22),('5815','2013-09-04','12:30:00',2.21),('5815','2013-09-04','12:35:00',2.21),('5815','2013-09-04','12:40:00',2.23),('5815','2013-09-04','12:45:00',2.24),('5815','2013-09-04','12:50:00',2.25),('5815','2013-09-04','12:55:00',2.27),('5815','2013-09-04','13:00:00',2.27),('5815','2013-09-04','13:05:00',2.26),('5815','2013-09-04','13:10:00',2.22),('5815','2013-09-04','13:15:00',2.25),('5815','2013-09-04','13:20:00',2.25),('5815','2013-09-04','13:25:00',2.25),('5815','2013-09-04','13:30:00',2.24),('5815','2013-09-04','13:35:00',2.28),('5815','2013-09-04','13:40:00',2.29),('5815','2013-09-04','13:45:00',2.25),('5815','2013-09-04','13:50:00',2.23),('5815','2013-09-04','13:55:00',2.21),('5815','2013-09-04','14:00:00',2.19),('5815','2013-09-04','14:05:00',2.18),('5815','2013-09-04','14:10:00',2.19),('5815','2013-09-04','14:15:00',2.2),('5815','2013-09-04','14:20:00',2.18),('5815','2013-09-04','14:25:00',2.14),('5815','2013-09-04','14:30:00',2.11),('5815','2013-09-04','14:35:00',2.09),('5815','2013-09-04','14:40:00',2.05),('5815','2013-09-04','14:45:00',2.03),('5815','2013-09-04','14:50:00',2.03),('5815','2013-09-04','14:55:00',2.03),('5815','2013-09-04','15:00:00',2.03),('5815','2013-09-04','15:05:00',2.04),('5815','2013-09-04','15:10:00',2.03),('5815','2013-09-04','15:15:00',2.01),('5815','2013-09-04','15:20:00',2),('5815','2013-09-04','15:25:00',1.97),('5815','2013-09-04','15:30:00',1.94),('5815','2013-09-04','15:35:00',1.9),('5815','2013-09-04','15:40:00',1.86),('5815','2013-09-04','15:45:00',1.83),('5815','2013-09-04','15:50:00',1.8),('5815','2013-09-04','15:55:00',1.76),('5815','2013-09-04','16:00:00',1.76),('5815','2013-09-04','16:05:00',1.73),('5815','2013-09-04','16:10:00',1.69),('5815','2013-09-04','16:15:00',1.66),('5815','2013-09-04','16:20:00',1.62),('5815','2013-09-04','16:25:00',1.59),('5815','2013-09-04','16:30:00',1.55),('5815','2013-09-04','16:35:00',1.53),('5815','2013-09-04','16:40:00',1.51),('5815','2013-09-04','16:45:00',1.49),('5815','2013-09-04','16:50:00',1.34),('5815','2013-09-04','16:55:00',1.07),('5815','2013-09-03','09:00:00',1.05),('5815','2013-09-03','09:05:00',1.1),('5815','2013-09-03','09:10:00',1.16),('5815','2013-09-03','09:15:00',1.21),('5815','2013-09-03','09:20:00',1.26),('5815','2013-09-03','09:25:00',1.32),('5815','2013-09-03','09:30:00',1.36),('5815','2013-09-03','09:35:00',1.41),('5815','2013-09-03','09:40:00',1.46),('5815','2013-09-03','09:45:00',1.51),('5815','2013-09-03','09:50:00',1.54),('5815','2013-09-03','09:55:00',1.59),('5815','2013-09-03','10:00:00',1.63),('5815','2013-09-03','10:05:00',1.67),('5815','2013-09-03','10:10:00',1.71),('5815','2013-09-03','10:15:00',1.73),('5815','2013-09-03','10:20:00',1.76),('5815','2013-09-03','10:25:00',1.79),('5815','2013-09-03','10:30:00',1.83),('5815','2013-09-03','10:35:00',1.87),('5815','2013-09-03','10:40:00',1.89),('5815','2013-09-03','10:45:00',1.92),('5815','2013-09-03','10:50:00',1.95),('5815','2013-09-03','10:55:00',1.98),('5815','2013-09-03','11:00:00',2),('5815','2013-09-03','11:05:00',2.01),('5815','2013-09-03','11:10:00',2.06),('5815','2013-09-03','11:15:00',2.07),('5815','2013-09-03','11:20:00',2.09),('5815','2013-09-03','11:25:00',2.11),('5815','2013-09-03','11:30:00',2.13),('5815','2013-09-03','11:35:00',2.15),('5815','2013-09-03','11:40:00',2.18),('5815','2013-09-03','11:45:00',2.19),('5815','2013-09-03','11:50:00',2.22),('5815','2013-09-03','11:55:00',2.23),('5815','2013-09-03','12:00:00',2.24),('5815','2013-09-03','12:05:00',2.26),('5815','2013-09-03','12:10:00',2.26),('5815','2013-09-03','12:15:00',2.26),('5815','2013-09-03','12:20:00',2.27),('5815','2013-09-03','12:25:00',2.29),('5815','2013-09-03','12:30:00',2.29),('5815','2013-09-03','12:35:00',2.3),('5815','2013-09-03','12:40:00',2.32),('5815','2013-09-03','12:45:00',2.31),('5815','2013-09-03','12:50:00',2.31),('5815','2013-09-03','12:55:00',2.32),('5815','2013-09-03','13:00:00',2.3),('5815','2013-09-03','13:05:00',2.3),('5815','2013-09-03','13:10:00',2.3),('5815','2013-09-03','13:15:00',2.3),('5815','2013-09-03','13:20:00',2.31),('5815','2013-09-03','13:25:00',2.31),('5815','2013-09-03','13:30:00',2.31),('5815','2013-09-03','13:35:00',2.31),('5815','2013-09-03','13:40:00',2.31),('5815','2013-09-03','13:45:00',2.29),('5815','2013-09-03','13:50:00',2.28),('5815','2013-09-03','13:55:00',2.29),('5815','2013-09-03','14:00:00',2.26),('5815','2013-09-03','14:05:00',2.27),('5815','2013-09-03','14:10:00',2.28),('5815','2013-09-03','14:15:00',2.27),('5815','2013-09-03','14:20:00',2.24),('5815','2013-09-03','14:25:00',2.23),('5815','2013-09-03','14:30:00',2.22),('5815','2013-09-03','14:35:00',2.19),('5815','2013-09-03','14:40:00',2.17),('5815','2013-09-03','14:45:00',2.15),('5815','2013-09-03','14:50:00',2.14),('5815','2013-09-03','14:55:00',2.12),('5815','2013-09-03','15:00:00',2.09),('5815','2013-09-03','15:05:00',2.07),('5815','2013-09-03','15:10:00',2.04),('5815','2013-09-03','15:15:00',2.03),('5815','2013-09-03','15:20:00',2),('5815','2013-09-03','15:25:00',1.93),('5815','2013-09-03','15:30:00',1.94),('5815','2013-09-03','15:35:00',1.91),('5815','2013-09-03','15:40:00',1.88),('5815','2013-09-03','15:45:00',1.85),('5815','2013-09-03','15:50:00',1.82),('5815','2013-09-03','15:55:00',1.78),('5815','2013-09-03','16:00:00',1.74),('5815','2013-09-03','16:05:00',1.7),('5815','2013-09-03','16:10:00',1.67),('5815','2013-09-03','16:15:00',1.64),('5815','2013-09-03','16:20:00',1.6),('5815','2013-09-03','16:25:00',1.56),('5815','2013-09-03','16:30:00',1.53),('5815','2013-09-03','16:35:00',1.48),('5815','2013-09-03','16:40:00',1.44),('5815','2013-09-03','16:45:00',1.4),('5815','2013-09-03','16:50:00',1.35),('5815','2013-09-03','16:55:00',1.3),('5815','2013-09-03','17:00:00',1.26),('5815','2013-09-03','17:05:00',1.21),('5815','2013-09-03','17:10:00',1.16),('5815','2013-09-03','17:15:00',1.12),('5815','2013-09-03','17:20:00',1.05),('5815','2013-09-02','09:05:00',1.02),('5815','2013-09-02','09:10:00',1.07),('5815','2013-09-02','09:15:00',1.13),('5815','2013-09-02','09:20:00',1.18),('5815','2013-09-02','09:25:00',1.23),('5815','2013-09-02','09:30:00',1.27),('5815','2013-09-02','09:35:00',1.31),('5815','2013-09-02','09:40:00',1.35),('5815','2013-09-02','09:45:00',1.4),('5815','2013-09-02','09:50:00',1.44),('5815','2013-09-02','09:55:00',1.48),('5815','2013-09-02','10:00:00',1.51),('5815','2013-09-02','10:05:00',1.55),('5815','2013-09-02','10:10:00',1.59),('5815','2013-09-02','10:15:00',1.63),('5815','2013-09-02','10:20:00',1.66),('5815','2013-09-02','10:25:00',1.7),('5815','2013-09-02','10:30:00',1.74),('5815','2013-09-02','10:35:00',1.8),('5815','2013-09-02','10:40:00',1.84),('5815','2013-09-02','10:45:00',1.86),('5815','2013-09-02','10:50:00',1.88),('5815','2013-09-02','10:55:00',1.9),('5815','2013-09-02','11:00:00',1.92),('5815','2013-09-02','11:05:00',1.94),('5815','2013-09-02','11:10:00',1.97),('5815','2013-09-02','11:15:00',1.99),('5815','2013-09-02','11:20:00',2.02),('5815','2013-09-02','11:25:00',2.04),('5815','2013-09-02','11:30:00',2.06),('5815','2013-09-02','11:35:00',2.08),('5815','2013-09-02','11:40:00',2.08),('5815','2013-09-02','11:45:00',2.1),('5815','2013-09-02','11:50:00',2.13),('5815','2013-09-02','11:55:00',2.11),('5815','2013-09-02','12:00:00',2.15),('5815','2013-09-02','12:05:00',2.18),('5815','2013-09-02','12:10:00',2.19),('5815','2013-09-02','12:15:00',2.21),('5815','2013-09-02','12:20:00',2.22),('5815','2013-09-02','12:25:00',2.23),('5815','2013-09-02','12:30:00',2.24),('5815','2013-09-02','12:35:00',2.25),('5815','2013-09-02','12:40:00',2.26),('5815','2013-09-02','12:45:00',2.26),('5815','2013-09-02','12:50:00',2.25),('5815','2013-09-02','12:55:00',2.26),('5815','2013-09-02','13:00:00',2.27),('5815','2013-09-02','13:05:00',2.28),('5815','2013-09-02','13:10:00',2.26),('5815','2013-09-02','13:15:00',2.25),('5815','2013-09-02','13:20:00',2.26),('5815','2013-09-02','13:25:00',2.26),('5815','2013-09-02','13:30:00',2.27),('5815','2013-09-02','13:35:00',2.27),('5815','2013-09-02','13:40:00',2.23),('5815','2013-09-02','13:45:00',2.26),('5815','2013-09-02','13:50:00',2.24),('5815','2013-09-02','13:55:00',2.21),('5815','2013-09-02','14:00:00',2.18),('5815','2013-09-02','14:05:00',2.15),('5815','2013-09-02','14:10:00',2.17),('5815','2013-09-02','14:15:00',2.18),('5815','2013-09-02','14:20:00',2.17),('5815','2013-09-02','14:25:00',2.17),('5815','2013-09-02','14:30:00',2.16),('5815','2013-09-02','14:35:00',2.14),('5815','2013-09-02','14:40:00',2.1),('5815','2013-09-02','14:45:00',2.1),('5815','2013-09-02','14:50:00',2.1),('5815','2013-09-02','14:55:00',2.07),('5815','2013-09-02','15:00:00',2.04),('5815','2013-09-02','15:05:00',2.01),('5815','2013-09-02','15:10:00',2.01),('5815','2013-09-02','15:15:00',1.99),('5815','2013-09-02','15:20:00',1.96),('5815','2013-09-02','15:25:00',1.93),('5815','2013-09-02','15:30:00',1.89),('5815','2013-09-02','15:35:00',1.87),('5815','2013-09-02','15:40:00',1.83),('5815','2013-09-02','15:45:00',1.79),('5815','2013-09-02','15:50:00',1.77),('5815','2013-09-02','15:55:00',1.76),('5815','2013-09-02','16:00:00',1.74),('5815','2013-09-02','16:05:00',1.7),('5815','2013-09-02','16:10:00',1.64),('5815','2013-09-02','16:15:00',1.6),('5815','2013-09-02','16:20:00',1.58),('5815','2013-09-02','16:25:00',1.54),('5815','2013-09-02','16:30:00',1.5),('5815','2013-09-02','16:35:00',1.47),('5815','2013-09-02','16:40:00',1.42),('5815','2013-09-02','16:45:00',1.39),('5815','2013-09-02','16:50:00',1.35),('5815','2013-09-02','16:55:00',1.3),('5815','2013-09-02','17:00:00',1.26),('5815','2013-09-02','17:05:00',1.21),('5815','2013-09-02','17:10:00',1.16),('5815','2013-09-02','17:15:00',1.11),('5815','2013-09-02','17:20:00',1.06),('5815','2013-09-01','09:00:00',1.01),('5815','2013-09-01','09:05:00',1.05),('5815','2013-09-01','09:10:00',1.11),('5815','2013-09-01','09:15:00',1.16),('5815','2013-09-01','09:20:00',1.21),('5815','2013-09-01','09:25:00',1.26),('5815','2013-09-01','09:30:00',1.3),('5815','2013-09-01','09:35:00',1.35),('5815','2013-09-01','09:40:00',1.39),('5815','2013-09-01','09:45:00',1.43),('5815','2013-09-01','09:50:00',1.47),('5815','2013-09-01','09:55:00',1.5),('5815','2013-09-01','10:00:00',1.54),('5815','2013-09-01','10:05:00',1.59),('5815','2013-09-01','10:10:00',1.63),('5815','2013-09-01','10:15:00',1.67),('5815','2013-09-01','10:20:00',1.69),('5815','2013-09-01','10:25:00',1.74),('5815','2013-09-01','10:30:00',1.77),('5815','2013-09-01','10:35:00',1.8),('5815','2013-09-01','10:40:00',1.83),('5815','2013-09-01','10:45:00',1.85),('5815','2013-09-01','10:50:00',1.87),('5815','2013-09-01','10:55:00',1.9),('5815','2013-09-01','11:00:00',1.93),('5815','2013-09-01','11:05:00',1.95),('5815','2013-09-01','11:10:00',1.98),('5815','2013-09-01','11:15:00',2.01),('5815','2013-09-01','11:20:00',2.03),('5815','2013-09-01','11:25:00',2.04),('5815','2013-09-01','11:30:00',2.07),('5815','2013-09-01','11:35:00',2.06),('5815','2013-09-01','11:40:00',2.09),('5815','2013-09-01','11:45:00',2.11),('5815','2013-09-01','11:50:00',2.11),('5815','2013-09-01','11:55:00',2.13),('5815','2013-09-01','12:00:00',2.15),('5815','2013-09-01','12:05:00',2.18),('5815','2013-09-01','12:10:00',2.19),('5815','2013-09-01','12:15:00',2.19),('5815','2013-09-01','12:20:00',2.21),('5815','2013-09-01','12:25:00',2.21),('5815','2013-09-01','12:30:00',2.21),('5815','2013-09-01','12:35:00',2.22),('5815','2013-09-01','12:40:00',2.22),('5815','2013-09-01','12:45:00',2.21),('5815','2013-09-01','12:50:00',2.23),('5815','2013-09-01','12:55:00',2.23),('5815','2013-09-01','13:00:00',2.26),('5815','2013-09-01','13:05:00',2.26),('5815','2013-09-01','13:10:00',2.25),('5815','2013-09-01','13:15:00',2.26),('5815','2013-09-01','13:20:00',2.25),('5815','2013-09-01','13:25:00',2.24),('5815','2013-09-01','13:30:00',2.22),('5815','2013-09-01','13:35:00',2.2),('5815','2013-09-01','13:40:00',2.17),('5815','2013-09-01','13:45:00',2.15),('5815','2013-09-01','13:50:00',1.95),('5815','2013-09-01','13:55:00',2.25),('5815','2013-09-01','14:00:00',2.22),('5815','2013-09-01','14:05:00',1.89),('5815','2013-09-01','14:10:00',2.01),('5815','2013-09-01','14:15:00',2.24),('5815','2013-09-01','14:20:00',2.2),('5815','2013-09-01','14:25:00',2.21),('5815','2013-09-01','14:30:00',2.21),('5815','2013-09-01','14:35:00',2.16),('5815','2013-09-01','14:40:00',2.17),('5815','2013-09-01','14:45:00',2.18),('5815','2013-09-01','14:50:00',2.16),('5815','2013-09-01','14:55:00',1.27),('5815','2013-09-01','15:00:00',2.06),('5815','2013-09-01','15:05:00',2.03),('5815','2013-09-01','15:10:00',1.95),('5815','2013-09-01','15:15:00',2.05),('5815','2013-09-01','15:20:00',1.16),('5815','2013-09-01','15:25:00',1.92),('5815','2013-09-01','15:30:00',1.16),('5815','2013-09-01','15:35:00',1),('5815','2013-09-01','15:40:00',1.96),('5815','2013-09-01','15:45:00',1.9),('5815','2013-09-01','15:50:00',1.87),('5815','2013-09-01','15:55:00',1.84),('5815','2013-09-01','16:00:00',1.77),('5815','2013-09-01','16:05:00',1.7),('5815','2013-09-01','16:10:00',1.68),('5815','2013-09-01','16:15:00',1.68),('5815','2013-09-01','16:20:00',1.66),('5815','2013-09-01','16:25:00',1.6),('5815','2013-09-01','16:30:00',1.56),('5815','2013-09-01','16:35:00',1.49),('5815','2013-09-01','16:40:00',1.43),('5815','2013-09-01','16:45:00',1.39),('5815','2013-09-01','16:50:00',1.31),('5815','2013-09-01','16:55:00',1.27),('5815','2013-09-01','17:00:00',1.2),('5815','2013-09-01','17:05:00',1.16),('5815','2013-09-01','17:10:00',1.12),('5815','2013-09-01','17:15:00',1.08),('5815','2013-09-01','17:20:00',1.02),('5815','2013-08-31','09:00:00',1.03),('5815','2013-08-31','09:05:00',1.08),('5815','2013-08-31','09:10:00',1.13),('5815','2013-08-31','09:15:00',1.18),('5815','2013-08-31','09:20:00',1.22),('5815','2013-08-31','09:25:00',1.27),('5815','2013-08-31','09:30:00',1.32),('5815','2013-08-31','09:35:00',1.37),('5815','2013-08-31','09:40:00',1.41),('5815','2013-08-31','09:45:00',1.45),('5815','2013-08-31','09:50:00',1.5),('5815','2013-08-31','09:55:00',1.53),('5815','2013-08-31','10:00:00',1.57),('5815','2013-08-31','10:05:00',1.6),('5815','2013-08-31','10:10:00',1.63),('5815','2013-08-31','10:15:00',1.67),('5815','2013-08-31','10:20:00',1.7),('5815','2013-08-31','10:25:00',1.74),('5815','2013-08-31','10:30:00',1.77),('5815','2013-08-31','10:35:00',1.79),('5815','2013-08-31','10:40:00',1.83),('5815','2013-08-31','10:45:00',1.86),('5815','2013-08-31','10:50:00',1.88),('5815','2013-08-31','10:55:00',1.92),('5815','2013-08-31','11:00:00',1.95),('5815','2013-08-31','11:05:00',1.98),('5815','2013-08-31','11:10:00',2),('5815','2013-08-31','11:15:00',2.01),('5815','2013-08-31','11:20:00',2.02),('5815','2013-08-31','11:25:00',2.04),('5815','2013-08-31','11:30:00',2.08),('5815','2013-08-31','11:35:00',2.09),('5815','2013-08-31','11:40:00',2.12),('5815','2013-08-31','11:45:00',2.14),('5815','2013-08-31','11:50:00',2.16),('5815','2013-08-31','11:55:00',2.18),('5815','2013-08-31','12:00:00',2.19),('5815','2013-08-31','12:05:00',2.15),('5815','2013-08-31','12:10:00',2.18),('5815','2013-08-31','12:15:00',2.2),('5815','2013-08-31','12:20:00',2.24),('5815','2013-08-31','12:25:00',2.2),('5815','2013-08-31','12:30:00',2.24),('5815','2013-08-31','12:35:00',2.23),('5815','2013-08-31','12:40:00',2.24),('5815','2013-08-31','12:45:00',2.23),('5815','2013-08-31','12:50:00',2.23),('5815','2013-08-31','12:55:00',2.23),('5815','2013-08-31','13:00:00',2.25),('5815','2013-08-31','13:05:00',2.23),('5815','2013-08-31','13:10:00',2.25),('5815','2013-08-31','13:15:00',2.18),('5815','2013-08-31','13:20:00',2.28),('5815','2013-08-31','13:25:00',2.27),('5815','2013-08-31','13:30:00',2.29),('5815','2013-08-31','13:35:00',2.28),('5815','2013-08-31','13:40:00',2.27),('5815','2013-08-31','13:45:00',2.2),('5815','2013-08-31','13:50:00',1.93),('5815','2013-08-31','13:55:00',2.07),('5815','2013-08-31','14:00:00',1.77),('5815','2013-08-31','14:05:00',1.78),('5815','2013-08-31','14:10:00',2.03),('5815','2013-08-31','14:15:00',2.08),('5815','2013-08-31','14:20:00',1.85),('5815','2013-08-31','14:25:00',1.89),('5815','2013-08-31','14:30:00',1.94),('5815','2013-08-31','14:35:00',1.94),('5815','2013-08-31','14:40:00',1.94),('5815','2013-08-31','14:45:00',1.98),('5815','2013-08-31','14:50:00',1.96),('5815','2013-08-31','14:55:00',1.9),('5815','2013-08-31','15:00:00',1.9),('5815','2013-08-31','15:05:00',1.89),('5815','2013-08-31','15:10:00',1.86),('5815','2013-08-31','15:15:00',1.78),('5815','2013-08-31','15:20:00',1.71),('5815','2013-08-31','15:25:00',1.58),('5815','2013-08-31','15:30:00',1.29),('5815','2013-08-31','15:35:00',1.44),('5815','2013-08-31','15:40:00',1.63),('5815','2013-08-31','15:45:00',1.54),('5815','2013-08-31','15:50:00',1.21),('5815','2013-08-31','15:55:00',1.26),('5815','2013-08-31','16:00:00',1.51),('5815','2013-08-31','16:05:00',1.55),('5815','2013-08-31','16:10:00',1.65),('5815','2013-08-31','16:15:00',1.59),('5815','2013-08-31','16:20:00',1.54),('5815','2013-08-31','16:25:00',1.47),('5815','2013-08-31','16:30:00',1.61),('5815','2013-08-31','16:35:00',1.53),('5815','2013-08-31','16:40:00',1.49),('5815','2013-08-31','16:45:00',1.41),('5815','2013-08-31','16:50:00',1.33),('5815','2013-08-31','16:55:00',1.21),('5815','2013-08-31','17:00:00',1.01),('5815','2013-08-30','08:50:00',1.01),('5815','2013-08-30','08:55:00',1.11),('5815','2013-08-30','09:00:00',1.17),('5815','2013-08-30','09:05:00',1.07),('5815','2013-08-30','09:15:00',1.08),('5815','2013-08-30','09:20:00',1.24),('5815','2013-08-30','09:25:00',1.36),('5815','2013-08-30','09:30:00',1.39),('5815','2013-08-30','09:35:00',1.45),('5815','2013-08-30','09:40:00',1.48),('5815','2013-08-30','09:45:00',1.4),('5815','2013-08-30','09:50:00',1.43),('5815','2013-08-30','09:55:00',1.56),('5815','2013-08-30','10:00:00',1.64),('5815','2013-08-30','10:05:00',1.62),('5815','2013-08-30','10:10:00',1.71),('5815','2013-08-30','10:15:00',1.71),('5815','2013-08-30','10:20:00',1.75),('5815','2013-08-30','10:25:00',1.78),('5815','2013-08-30','10:30:00',1.81),('5815','2013-08-30','10:35:00',1.87),('5815','2013-08-30','10:40:00',1.88),('5815','2013-08-30','10:45:00',1.92),('5815','2013-08-30','10:50:00',1.97),('5815','2013-08-30','10:55:00',2),('5815','2013-08-30','11:00:00',2.04),('5815','2013-08-30','11:05:00',2.07),('5815','2013-08-30','11:10:00',2.09),('5815','2013-08-30','11:15:00',2.1),('5815','2013-08-30','11:20:00',2.13),('5815','2013-08-30','11:25:00',2.15),('5815','2013-08-30','11:30:00',2.17),('5815','2013-08-30','11:35:00',2.2),('5815','2013-08-30','11:40:00',2.21),('5815','2013-08-30','11:45:00',2.21),('5815','2013-08-30','11:50:00',2.24),('5815','2013-08-30','11:55:00',2.26),('5815','2013-08-30','12:00:00',2.27),('5815','2013-08-30','12:05:00',2.14),('5815','2013-08-30','12:10:00',2.28),('5815','2013-08-30','12:15:00',2.29),('5815','2013-08-30','12:20:00',2.26),('5815','2013-08-30','12:25:00',2.28),('5815','2013-08-30','12:30:00',2.28),('5815','2013-08-30','12:35:00',2.28),('5815','2013-08-30','12:40:00',2.29),('5815','2013-08-30','12:45:00',2.29),('5815','2013-08-30','12:50:00',2.28),('5815','2013-08-30','12:55:00',2.32),('5815','2013-08-30','13:00:00',2.3),('5815','2013-08-30','13:05:00',2.32),('5815','2013-08-30','13:10:00',2.3),('5815','2013-08-30','13:15:00',2.27),('5815','2013-08-30','13:20:00',2.29),('5815','2013-08-30','13:25:00',2.3),('5815','2013-08-30','13:30:00',2.29),('5815','2013-08-30','13:35:00',2.3),('5815','2013-08-30','13:40:00',2.3),('5815','2013-08-30','13:45:00',2.26),('5815','2013-08-30','13:50:00',2.27),('5815','2013-08-30','13:55:00',2.24),('5815','2013-08-30','14:00:00',2.25),('5815','2013-08-30','14:05:00',2.25),('5815','2013-08-30','14:10:00',2.24),('5815','2013-08-30','14:15:00',2.21),('5815','2013-08-30','14:20:00',2.17),('5815','2013-08-30','14:25:00',2.16),('5815','2013-08-30','14:30:00',2.15),('5815','2013-08-30','14:35:00',2.05),('5815','2013-08-30','14:40:00',2.09),('5815','2013-08-30','14:45:00',2.04),('5815','2013-08-30','14:50:00',2.08),('5815','2013-08-30','14:55:00',2.02),('5815','2013-08-30','15:00:00',2.02),('5815','2013-08-30','15:05:00',2.02),('5815','2013-08-30','15:10:00',2),('5815','2013-08-30','15:15:00',1.95),('5815','2013-08-30','15:20:00',1.92),('5815','2013-08-30','15:25:00',1.88),('5815','2013-08-30','15:30:00',1.87),('5815','2013-08-30','15:35:00',1.82),('5815','2013-08-30','15:40:00',1.82),('5815','2013-08-30','15:45:00',1.8),('5815','2013-08-30','15:50:00',1.77),('5815','2013-08-30','15:55:00',1.72),('5815','2013-08-30','16:00:00',1.69),('5815','2013-08-30','16:05:00',1.67),('5815','2013-08-30','16:10:00',1.64),('5815','2013-08-30','16:15:00',1.6),('5815','2013-08-30','16:20:00',1.56),('5815','2013-08-30','16:25:00',1.53),('5815','2013-08-30','16:30:00',1.46),('5815','2013-08-30','16:35:00',1.47),('5815','2013-08-30','16:40:00',1.42),('5815','2013-08-30','16:45:00',1.35),('5815','2013-08-30','16:50:00',1.31),('5815','2013-08-30','16:55:00',1.28),('5815','2013-08-30','17:00:00',1.23),('5815','2013-08-30','17:05:00',1.21),('5815','2013-08-30','17:10:00',1.18),('5815','2013-08-30','17:15:00',1.11),('5815','2013-08-30','17:20:00',1.05),('5815','2013-08-29','09:45:00',1.01),('5815','2013-08-29','09:50:00',1.01),('5815','2013-08-29','09:55:00',1.05),('5815','2013-08-29','10:00:00',1.09),('5815','2013-08-29','10:05:00',1.06),('5815','2013-08-29','10:10:00',1.07),('5815','2013-08-29','10:15:00',1.15),('5815','2013-08-29','10:20:00',1.2),('5815','2013-08-29','10:25:00',1.1),('5815','2013-08-29','10:30:00',1.24),('5815','2013-08-29','10:35:00',1.18),('5815','2013-08-29','10:40:00',1.13),('5815','2013-08-29','10:45:00',1.08),('5815','2013-08-29','10:50:00',1.15),('5815','2013-08-29','10:55:00',1.1),('5815','2013-08-29','11:00:00',1.14),('5815','2013-08-29','11:05:00',1.23),('5815','2013-08-29','11:10:00',1.27),('5815','2013-08-29','11:15:00',1.31),('5815','2013-08-29','11:20:00',1.31),('5815','2013-08-29','11:25:00',1.36),('5815','2013-08-29','11:30:00',1.14),('5815','2013-08-29','11:35:00',1.38),('5815','2013-08-29','11:40:00',1.5),('5815','2013-08-29','11:45:00',1.47),('5815','2013-08-29','11:50:00',1.73),('5815','2013-08-29','11:55:00',1.5),('5815','2013-08-29','12:00:00',1.36),('5815','2013-08-29','12:05:00',1.14),('5815','2013-08-29','12:10:00',1.25),('5815','2013-08-29','12:15:00',1.37),('5815','2013-08-29','12:20:00',1.47),('5815','2013-08-29','12:25:00',1.72),('5815','2013-08-29','12:30:00',1.86),('5815','2013-08-29','12:35:00',1.8),('5815','2013-08-29','12:40:00',1.74),('5815','2013-08-29','12:45:00',1.81),('5815','2013-08-29','12:50:00',1.75),('5815','2013-08-29','12:55:00',1.65),('5815','2013-08-29','13:00:00',1.6),('5815','2013-08-29','13:05:00',1.57),('5815','2013-08-29','13:10:00',1.59),('5815','2013-08-29','13:15:00',1.63),('5815','2013-08-29','13:20:00',1.79),('5815','2013-08-29','13:25:00',2.08),('5815','2013-08-29','13:30:00',2.27),('5815','2013-08-29','13:35:00',2.1),('5815','2013-08-29','13:40:00',2.24),('5815','2013-08-29','13:45:00',2.05),('5815','2013-08-29','13:50:00',2.05),('5815','2013-08-29','13:55:00',2.22),('5815','2013-08-29','14:00:00',2.28),('5815','2013-08-29','14:05:00',2.22),('5815','2013-08-29','14:10:00',2.24),('5815','2013-08-29','14:15:00',2.2),('5815','2013-08-29','14:20:00',2.24),('5815','2013-08-29','14:25:00',2.22),('5815','2013-08-29','14:30:00',2.19),('5815','2013-08-29','14:35:00',2.22),('5815','2013-08-29','14:40:00',2.14),('5815','2013-08-29','14:45:00',1.8),('5815','2013-08-29','14:50:00',1.47),('5815','2013-08-29','14:55:00',1.68),('5815','2013-08-29','15:00:00',1.46),('5815','2013-08-29','15:05:00',1.34),('5815','2013-08-29','15:10:00',1.29),('5815','2013-08-29','15:15:00',1.64),('5815','2013-08-29','15:20:00',1.44),('5815','2013-08-29','15:25:00',1.3),('5815','2013-08-29','15:30:00',1.16),('5815','2013-08-29','15:35:00',1.01),('5815','2013-08-29','15:40:00',1.08),('5815','2013-08-29','15:45:00',1.27),('5815','2013-08-29','15:50:00',1.37),('5815','2013-08-29','15:55:00',1.34),('5815','2013-08-29','16:00:00',1.26),('5815','2013-08-29','16:05:00',1.11),('5815','2013-08-29','16:35:00',1.26),('5815','2013-08-29','16:45:00',1.14),('5815','2013-08-29','16:50:00',1.38),('5815','2013-08-29','16:55:00',1.18),('5815','2013-08-28','11:10:00',1.19),('5815','2013-08-28','11:15:00',1.42),('5815','2013-08-28','11:20:00',1.38),('5815','2013-08-28','11:25:00',1.02),('5815','2013-08-28','11:45:00',1.01),('5815','2013-08-28','11:50:00',1.06),('5815','2013-08-28','11:55:00',1.02),('5815','2013-08-28','12:00:00',1.01),('5815','2013-08-28','12:05:00',1.15),('5815','2013-08-28','12:10:00',1.44),('5815','2013-08-28','12:15:00',1.74),('5815','2013-08-28','12:20:00',1.52),('5815','2013-08-28','12:25:00',1.57),('5815','2013-08-28','12:30:00',1.51),('5815','2013-08-28','12:35:00',1.83),('5815','2013-08-28','12:40:00',2.46),('5815','2013-08-28','12:45:00',2.58),('5815','2013-08-28','12:50:00',1.62),('5815','2013-08-28','12:55:00',1.88),('5815','2013-08-28','13:00:00',1.6),('5815','2013-08-28','13:05:00',1.4),('5815','2013-08-28','13:10:00',1.4),('5815','2013-08-28','13:15:00',1.34),('5815','2013-08-28','13:20:00',1.36),('5815','2013-08-28','13:25:00',1.16),('5815','2013-08-28','13:30:00',1.03),('5815','2013-08-28','14:00:00',1.31),('5815','2013-08-28','15:30:00',1.31),('5815','2013-08-28','15:35:00',1.4),('5815','2013-08-28','15:40:00',1.25),('5815','2013-08-28','15:45:00',1.36),('5815','2013-08-28','15:50:00',1.73),('5815','2013-08-28','15:55:00',2.05),('5815','2013-08-28','16:00:00',2),('5815','2013-08-28','16:05:00',1.95),('5815','2013-08-28','16:10:00',1.96),('5815','2013-08-28','16:15:00',1.8),('5815','2013-08-28','16:20:00',1.72),('5815','2013-08-28','16:25:00',1.66),('5815','2013-08-28','16:30:00',1.57),('5815','2013-08-28','16:35:00',1.57),('5815','2013-08-28','16:40:00',1.52),('5815','2013-08-28','16:45:00',1.47),('5815','2013-08-28','16:50:00',1.43),('5815','2013-08-28','16:55:00',1.38),('5815','2013-08-28','17:00:00',1.32),('5815','2013-08-28','17:05:00',1.29),('5815','2013-08-28','17:10:00',1.23),('5815','2013-08-28','17:15:00',1.19),('5815','2013-08-28','17:20:00',1.13),('5815','2013-08-28','17:25:00',1.08),('5815','2013-08-27','09:35:00',1.41),('5815','2013-08-27','09:40:00',1.47),('5815','2013-08-27','09:45:00',1.5),('5815','2013-08-27','09:50:00',1.54),('5815','2013-08-27','09:55:00',1.55),('5815','2013-08-27','10:00:00',1.57),('5815','2013-08-27','10:05:00',1.63),('5815','2013-08-27','10:15:00',1.74),('5815','2013-08-27','10:20:00',1.81),('5815','2013-08-27','10:25:00',1.25),('5815','2013-08-27','10:30:00',1.39),('5815','2013-08-27','10:35:00',1.18),('5815','2013-08-27','10:40:00',1.78),('5815','2013-08-27','10:45:00',1.41),('5815','2013-08-27','10:50:00',2.01),('5815','2013-08-27','10:55:00',2.07),('5815','2013-08-27','11:00:00',1.7),('5815','2013-08-27','11:05:00',1.19),('5815','2013-08-27','11:10:00',1.41),('5815','2013-08-27','11:15:00',1.93),('5815','2013-08-27','11:20:00',1.86),('5815','2013-08-27','11:25:00',2.25),('5815','2013-08-27','11:30:00',2.29),('5815','2013-08-27','11:35:00',2.27),('5815','2013-08-27','11:40:00',2.43),('5815','2013-08-27','11:45:00',2.03),('5815','2013-08-27','11:50:00',1.14),('5815','2013-08-27','11:55:00',2.01),('5815','2013-08-27','12:00:00',1.02),('5815','2013-08-27','12:05:00',1.95),('5815','2013-08-27','12:10:00',2.41),('5815','2013-08-27','12:15:00',2.47),('5815','2013-08-27','12:20:00',2.41),('5815','2013-08-27','12:25:00',2.32),('5815','2013-08-27','12:30:00',2.41),('5815','2013-08-27','12:35:00',2.4),('5815','2013-08-27','12:40:00',2.37),('5815','2013-08-27','12:45:00',2.5),('5815','2013-08-27','12:50:00',2.49),('5815','2013-08-27','12:55:00',2.45),('5815','2013-08-27','13:00:00',2.47),('5815','2013-08-27','13:05:00',2.16),('5815','2013-08-27','13:10:00',2.38),('5815','2013-08-27','13:15:00',2.5),('5815','2013-08-27','13:20:00',2.48),('5815','2013-08-27','13:25:00',2.51),('5815','2013-08-27','13:30:00',2.51),('5815','2013-08-27','13:35:00',2.46),('5815','2013-08-27','13:40:00',2.48),('5815','2013-08-27','13:45:00',2.35),('5815','2013-08-27','13:50:00',2.36),('5815','2013-08-27','13:55:00',2.41),('5815','2013-08-27','14:00:00',2.21),('5815','2013-08-27','14:05:00',2.45),('5815','2013-08-27','14:10:00',2.26),('5815','2013-08-27','14:15:00',2.45),('5815','2013-08-27','14:20:00',2.39),('5815','2013-08-27','14:25:00',2.39),('5815','2013-08-27','14:30:00',2.2),('5815','2013-08-27','14:35:00',1.87),('5815','2013-08-27','14:40:00',1.77),('5815','2013-08-27','14:45:00',2.38),('5815','2013-08-27','14:50:00',2.26),('5815','2013-08-27','14:55:00',2.28),('5815','2013-08-27','15:00:00',2.25),('5815','2013-08-27','15:05:00',2.24),('5815','2013-08-27','15:10:00',2.25),('5815','2013-08-27','15:15:00',2.21),('5815','2013-08-27','15:20:00',2.19),('5815','2013-08-27','15:25:00',2.14),('5815','2013-08-27','15:30:00',1.5),('5815','2013-08-27','15:35:00',1.42),('5815','2013-08-27','15:40:00',1.62),('5815','2013-08-27','15:45:00',1.07),('5815','2013-08-27','15:50:00',1.8),('5815','2013-08-27','15:55:00',1.46),('5815','2013-08-27','16:00:00',1.9),('5815','2013-08-27','16:05:00',1.82),('5815','2013-08-27','16:10:00',1.98),('5815','2013-08-27','16:15:00',1.85),('5815','2013-08-27','16:25:00',1.88),('5815','2013-08-27','16:30:00',1.75),('5815','2013-08-27','16:35:00',1.44),('5815','2013-08-27','16:40:00',1.66),('5815','2013-08-27','16:45:00',1.57),('5815','2013-08-27','16:50:00',1.49),('5815','2013-08-27','16:55:00',1.3),('5815','2013-08-27','17:00:00',1.42),('5815','2013-08-27','17:05:00',1.33),('5815','2013-08-26','09:25:00',1.14),('5815','2013-08-26','09:30:00',1.26),('5815','2013-08-26','10:00:00',1.07),('5815','2013-08-26','10:05:00',1.3),('5815','2013-08-26','10:10:00',1.58),('5815','2013-08-26','10:15:00',1.64),('5815','2013-08-26','10:20:00',1.72),('5815','2013-08-26','10:25:00',1.75),('5815','2013-08-26','10:30:00',1.77),('5815','2013-08-26','10:35:00',1.82),('5815','2013-08-26','10:40:00',1.8),('5815','2013-08-26','10:45:00',1.86),('5815','2013-08-26','10:50:00',1.88),('5815','2013-08-26','10:55:00',1.89),('5815','2013-08-26','11:00:00',1.92),('5815','2013-08-26','11:05:00',1.97),('5815','2013-08-26','11:10:00',1.97),('5815','2013-08-26','11:15:00',1.97),('5815','2013-08-26','11:20:00',1.91),('5815','2013-08-26','11:25:00',2.01),('5815','2013-08-26','11:30:00',2.04),('5815','2013-08-26','11:35:00',2.07),('5815','2013-08-26','11:40:00',2.03),('5815','2013-08-26','11:45:00',2.3),('5815','2013-08-26','11:50:00',2.13),('5815','2013-08-26','11:55:00',2.19),('5815','2013-08-26','12:00:00',2.31),('5815','2013-08-26','12:05:00',2.32),('5815','2013-08-26','12:10:00',1.95),('5815','2013-08-26','12:15:00',1.97),('5815','2013-08-26','12:20:00',2.18),('5815','2013-08-26','12:25:00',2.05),('5815','2013-08-26','12:30:00',2.24),('5815','2013-08-26','12:35:00',2.36),('5815','2013-08-26','12:40:00',2.19),('5815','2013-08-26','12:45:00',1.82),('5815','2013-08-26','12:50:00',1.39),('5815','2013-08-26','12:55:00',1.25),('5815','2013-08-26','13:10:00',1.37),('5815','2013-08-26','13:15:00',1.02),('5815','2013-08-26','13:20:00',1.05),('5815','2013-08-26','13:25:00',1.1),('5815','2013-08-26','13:30:00',1.42),('5815','2013-08-26','13:35:00',1.07),('5815','2013-08-26','13:40:00',1.07),('5815','2013-08-26','13:45:00',1.18),('5815','2013-08-26','13:50:00',2.31),('5815','2013-08-26','13:55:00',1.84),('5815','2013-08-26','14:00:00',2.04),('5815','2013-08-26','14:05:00',1.27),('5815','2013-08-26','14:10:00',1.16),('5815','2013-08-26','14:15:00',1.99),('5815','2013-08-26','14:20:00',1.49),('5815','2013-08-26','16:10:00',1.76),('5815','2013-08-26','16:15:00',1.88),('5815','2013-08-26','16:25:00',1.04),('5815','2013-08-26','17:10:00',1.45),('5815','2013-08-25','09:00:00',1.03),('5815','2013-08-25','09:05:00',1.07),('5815','2013-08-25','09:10:00',1.13),('5815','2013-08-25','09:15:00',1.17),('5815','2013-08-25','09:20:00',1.22),('5815','2013-08-25','09:25:00',1.26),('5815','2013-08-25','09:30:00',1.31),('5815','2013-08-25','09:35:00',1.36),('5815','2013-08-25','09:40:00',1.4),('5815','2013-08-25','09:45:00',1.44),('5815','2013-08-25','09:50:00',1.48),('5815','2013-08-25','09:55:00',1.51),('5815','2013-08-25','10:00:00',1.54),('5815','2013-08-25','10:05:00',1.59),('5815','2013-08-25','10:10:00',1.62),('5815','2013-08-25','10:15:00',1.65),('5815','2013-08-25','10:20:00',1.7),('5815','2013-08-25','10:25:00',1.75),('5815','2013-08-25','10:30:00',1.78),('5815','2013-08-25','10:35:00',1.81),('5815','2013-08-25','10:40:00',1.83),('5815','2013-08-25','10:45:00',1.87),('5815','2013-08-25','10:50:00',1.89),('5815','2013-08-25','10:55:00',1.95),('5815','2013-08-25','11:00:00',1.98),('5815','2013-08-25','11:05:00',2),('5815','2013-08-25','11:10:00',2.01),('5815','2013-08-25','11:15:00',2),('5815','2013-08-25','11:20:00',2.06),('5815','2013-08-25','11:25:00',2.08),('5815','2013-08-25','11:30:00',2.08),('5815','2013-08-25','11:35:00',2.13),('5815','2013-08-25','11:40:00',2.15),('5815','2013-08-25','11:45:00',2.15),('5815','2013-08-25','11:50:00',2.15),('5815','2013-08-25','11:55:00',2.16),('5815','2013-08-25','12:00:00',2.19),('5815','2013-08-25','12:05:00',2.2),('5815','2013-08-25','12:10:00',2.22),('5815','2013-08-25','12:15:00',2.23),('5815','2013-08-25','12:20:00',2.24),('5815','2013-08-25','12:25:00',2.23),('5815','2013-08-25','12:30:00',2.2),('5815','2013-08-25','12:35:00',2.22),('5815','2013-08-25','12:40:00',2.24),('5815','2013-08-25','12:45:00',2.27),('5815','2013-08-25','12:50:00',2.29),('5815','2013-08-25','12:55:00',1.82),('5815','2013-08-25','13:00:00',2.4),('5815','2013-08-25','13:05:00',2.64),('5815','2013-08-25','13:10:00',2.39),('5815','2013-08-25','13:15:00',1.61),('5815','2013-08-25','13:20:00',1.81),('5815','2013-08-25','13:25:00',1.61),('5815','2013-08-25','13:30:00',1.66),('5815','2013-08-25','13:35:00',2.25),('5815','2013-08-25','13:40:00',2.31),('5815','2013-08-25','13:45:00',2.32),('5815','2013-08-25','13:50:00',2.42),('5815','2013-08-25','13:55:00',1.9),('5815','2013-08-25','14:00:00',1.81),('5815','2013-08-25','14:05:00',2.28),('5815','2013-08-25','14:10:00',1.41),('5815','2013-08-25','14:15:00',2.35),('5815','2013-08-25','14:20:00',2.25),('5815','2013-08-25','14:25:00',2.21),('5815','2013-08-25','14:30:00',2.2),('5815','2013-08-25','14:35:00',2.15),('5815','2013-08-25','14:40:00',1.97),('5815','2013-08-25','14:45:00',1.6),('5815','2013-08-25','14:50:00',1.28),('5815','2013-08-25','14:55:00',1.15),('5815','2013-08-25','15:00:00',1.09),('5815','2013-08-25','16:00:00',1.17),('5815','2013-08-25','16:05:00',1.96),('5815','2013-08-25','16:10:00',1.74),('5815','2013-08-25','16:15:00',1.62),('5815','2013-08-25','16:20:00',1.63),('5815','2013-08-25','16:25:00',1.56),('5815','2013-08-25','16:30:00',1.52),('5815','2013-08-25','16:35:00',1.49),('5815','2013-08-25','16:40:00',1.46),('5815','2013-08-25','16:45:00',1.42),('5815','2013-08-25','16:50:00',1.33),('5815','2013-08-25','16:55:00',1.29),('5815','2013-08-25','17:00:00',1.27),('5815','2013-08-25','17:05:00',1.16),('5815','2013-08-25','17:10:00',1.15),('5815','2013-08-25','17:15:00',1.11),('5815','2013-08-24','09:20:00',1.08),('5815','2013-08-24','09:25:00',1.06),('5815','2013-08-24','09:30:00',1.2),('5815','2013-08-24','09:35:00',1.06),('5815','2013-08-24','09:40:00',1.6),('5815','2013-08-24','09:45:00',1.74),('5815','2013-08-24','09:50:00',1.63),('5815','2013-08-24','09:55:00',1.81),('5815','2013-08-24','10:00:00',1.34),('5815','2013-08-24','15:30:00',1.24),('5815','2013-08-24','15:35:00',1.88),('5815','2013-08-24','15:40:00',2.05),('5815','2013-08-24','15:45:00',2.11),('5815','2013-08-24','15:50:00',1.82),('5815','2013-08-24','15:55:00',1.06),('5815','2013-08-24','16:00:00',2.05),('5815','2013-08-24','16:05:00',1.92),('5815','2013-08-24','16:10:00',1.83),('5815','2013-08-24','16:15:00',1.77),('5815','2013-08-24','16:20:00',1.72),('5815','2013-08-24','16:25:00',1.68),('5815','2013-08-24','16:30:00',1.63),('5815','2013-08-24','16:35:00',1.57),('5815','2013-08-24','16:40:00',1.26),('5815','2013-08-24','16:50:00',1.13),('5815','2013-08-24','16:55:00',1.6),('5815','2013-08-24','17:00:00',1.45),('5815','2013-08-24','17:05:00',1.37),('5815','2013-08-24','17:10:00',1.31),('5815','2013-08-24','17:15:00',1.21),('5815','2013-08-24','17:20:00',1.15),('5815','2013-08-24','17:25:00',1.09),('5815','2013-08-24','17:30:00',1.02),('5815','2013-08-23','09:00:00',1.03),('5815','2013-08-23','09:05:00',1.06),('5815','2013-08-23','09:10:00',1.16),('5815','2013-08-23','09:15:00',1.03),('5815','2013-08-23','09:20:00',1.22),('5815','2013-08-23','09:25:00',1.05),('5815','2013-08-23','09:30:00',1.02),('5815','2013-08-23','09:40:00',1.45),('5815','2013-08-23','09:50:00',1.22),('5815','2013-08-23','09:55:00',1.26),('5815','2013-08-23','10:00:00',1.61),('5815','2013-08-23','10:05:00',1.62),('5815','2013-08-23','10:10:00',1.66),('5815','2013-08-23','10:15:00',1.68),('5815','2013-08-23','10:20:00',1.71),('5815','2013-08-23','10:25:00',1.73),('5815','2013-08-23','10:30:00',1.75),('5815','2013-08-23','10:35:00',1.78),('5815','2013-08-23','10:40:00',1.84),('5815','2013-08-23','10:45:00',1.87),('5815','2013-08-23','10:50:00',1.73),('5815','2013-08-23','10:55:00',1.68),('5815','2013-08-23','11:00:00',1.96),('5815','2013-08-23','11:05:00',1.98),('5815','2013-08-23','11:10:00',2.02),('5815','2013-08-23','11:15:00',2.03),('5815','2013-08-23','11:20:00',2.07),('5815','2013-08-23','11:25:00',2.08),('5815','2013-08-23','11:30:00',2.06),('5815','2013-08-23','11:35:00',2.12),('5815','2013-08-23','11:40:00',2.13),('5815','2013-08-23','11:45:00',2.14),('5815','2013-08-23','11:50:00',2.18),('5815','2013-08-23','11:55:00',2.17),('5815','2013-08-23','12:00:00',2.14),('5815','2013-08-23','12:05:00',2.17),('5815','2013-08-23','12:10:00',2.2),('5815','2013-08-23','12:15:00',2.24),('5815','2013-08-23','12:20:00',2.24),('5815','2013-08-23','12:25:00',2.25),('5815','2013-08-23','12:30:00',2.24),('5815','2013-08-23','12:35:00',2.25),('5815','2013-08-23','12:40:00',2.26),('5815','2013-08-23','12:45:00',2.27),('5815','2013-08-23','12:50:00',2.28),('5815','2013-08-23','12:55:00',2.26),('5815','2013-08-23','13:00:00',2.24),('5815','2013-08-23','13:05:00',2.27),('5815','2013-08-23','13:10:00',2.3),('5815','2013-08-23','13:15:00',2.29),('5815','2013-08-23','13:20:00',2.3),('5815','2013-08-23','13:25:00',2.32),('5815','2013-08-23','13:30:00',2.33),('5815','2013-08-23','13:35:00',2.32),('5815','2013-08-23','13:40:00',2.31),('5815','2013-08-23','13:45:00',2.3),('5815','2013-08-23','13:50:00',2.32),('5815','2013-08-23','13:55:00',2.29),('5815','2013-08-23','14:00:00',2.27),('5815','2013-08-23','14:05:00',2.27),('5815','2013-08-23','14:10:00',2.27),('5815','2013-08-23','14:15:00',2.25),('5815','2013-08-23','14:20:00',2.25),('5815','2013-08-23','14:25:00',2.22),('5815','2013-08-23','14:30:00',2.21),('5815','2013-08-23','14:35:00',2.21),('5815','2013-08-23','14:40:00',2.18),('5815','2013-08-23','14:45:00',2.12),('5815','2013-08-23','14:50:00',2.14),('5815','2013-08-23','14:55:00',2.13),('5815','2013-08-23','15:00:00',2.1),('5815','2013-08-23','15:05:00',2.09),('5815','2013-08-23','15:10:00',2.07),('5815','2013-08-23','15:15:00',2.04),('5815','2013-08-23','15:20:00',2),('5815','2013-08-23','15:25:00',1.98),('5815','2013-08-23','15:30:00',1.96),('5815','2013-08-23','15:35:00',1.93),('5815','2013-08-23','15:40:00',1.89),('5815','2013-08-23','15:45:00',1.86),('5815','2013-08-23','15:50:00',1.83),('5815','2013-08-23','15:55:00',1.8),('5815','2013-08-23','16:00:00',1.77),('5815','2013-08-23','16:05:00',1.75),('5815','2013-08-23','16:10:00',1.72),('5815','2013-08-23','16:15:00',1.67),('5815','2013-08-23','16:20:00',1.64),('5815','2013-08-23','16:25:00',1.6),('5815','2013-08-23','16:30:00',1.55),('5815','2013-08-23','16:35:00',1.52),('5815','2013-08-23','16:40:00',1.48),('5815','2013-08-23','16:45:00',1.43),('5815','2013-08-23','16:50:00',1.39),('5815','2013-08-23','16:55:00',1.36),('5815','2013-08-23','17:00:00',1.29),('5815','2013-08-23','17:05:00',1.26),('5815','2013-08-23','17:10:00',1.22),('5815','2013-08-23','17:15:00',1.18),('5815','2013-08-23','17:20:00',1.13),('5815','2013-08-23','17:25:00',1.08),('5815','2013-08-23','17:30:00',1.02),('5815','2013-08-22','09:10:00',1),('5815','2013-08-22','09:15:00',1.05),('5815','2013-08-22','09:20:00',1.1),('5815','2013-08-22','09:25:00',1.14),('5815','2013-08-22','09:30:00',1.18),('5815','2013-08-22','09:35:00',1.22),('5815','2013-08-22','09:40:00',1.24),('5815','2013-08-22','09:45:00',1.28),('5815','2013-08-22','09:50:00',1.33),('5815','2013-08-22','09:55:00',1.36),('5815','2013-08-22','10:00:00',1.41),('5815','2013-08-22','10:05:00',1.44),('5815','2013-08-22','10:10:00',1.45),('5815','2013-08-22','10:15:00',1.5),('5815','2013-08-22','10:20:00',1.55),('5815','2013-08-22','10:25:00',1.58),('5815','2013-08-22','10:30:00',1.59),('5815','2013-08-22','10:35:00',1.64),('5815','2013-08-22','10:40:00',1.64),('5815','2013-08-22','10:45:00',1.69),('5815','2013-08-22','10:50:00',1.71),('5815','2013-08-22','10:55:00',1.71),('5815','2013-08-22','11:00:00',1.75),('5815','2013-08-22','11:05:00',1.84),('5815','2013-08-22','11:10:00',1.85),('5815','2013-08-22','11:15:00',1.58),('5815','2013-08-22','11:20:00',1.3),('5815','2013-08-22','11:25:00',1.73),('5815','2013-08-22','11:30:00',2.03),('5815','2013-08-22','11:35:00',1.51),('5815','2013-08-22','11:40:00',1.41),('5815','2013-08-22','11:45:00',1.9),('5815','2013-08-22','11:50:00',2.03),('5815','2013-08-22','11:55:00',2.06),('5815','2013-08-22','12:00:00',1.74),('5815','2013-08-22','12:05:00',1.35),('5815','2013-08-22','12:15:00',1.02),('5815','2013-08-22','13:15:00',1.41),('5815','2013-08-22','13:25:00',1.48),('5815','2013-08-22','13:30:00',2.46),('5815','2013-08-22','13:35:00',2.17),('5815','2013-08-22','13:40:00',1.63),('5815','2013-08-22','13:45:00',2.24),('5815','2013-08-22','13:50:00',1.37),('5815','2013-08-22','13:55:00',1.9),('5815','2013-08-22','14:00:00',2.5),('5815','2013-08-22','14:05:00',2.35),('5815','2013-08-22','14:10:00',2.33),('5815','2013-08-22','14:15:00',2.34),('5815','2013-08-22','14:20:00',1.98),('5815','2013-08-22','14:25:00',1.88),('5815','2013-08-22','14:30:00',2.14),('5815','2013-08-22','14:35:00',2.23),('5815','2013-08-22','14:40:00',2.22),('5815','2013-08-22','14:45:00',2.17),('5815','2013-08-22','14:50:00',2.12),('5815','2013-08-22','14:55:00',2.04),('5815','2013-08-22','15:00:00',1.99),('5815','2013-08-22','15:05:00',1.93),('5815','2013-08-22','15:10:00',1.97),('5815','2013-08-22','15:15:00',1.99),('5815','2013-08-22','15:20:00',1.95),('5815','2013-08-22','15:25:00',1.96),('5815','2013-08-22','15:30:00',2.02),('5815','2013-08-22','15:35:00',1.88),('5815','2013-08-22','15:40:00',1.85),('5815','2013-08-22','15:45:00',1.85),('5815','2013-08-22','15:50:00',1.73),('5815','2013-08-22','15:55:00',1.77),('5815','2013-08-22','16:00:00',1.7),('5815','2013-08-22','16:05:00',1.61),('5815','2013-08-22','16:10:00',1.38),('5815','2013-08-22','16:15:00',1.46),('5815','2013-08-22','16:20:00',1.7),('5815','2013-08-22','16:25:00',1.53),('5815','2013-08-22','16:30:00',1.49),('5815','2013-08-22','16:35:00',1.57),('5815','2013-08-22','16:40:00',1.54),('5815','2013-08-22','16:45:00',1.48),('5815','2013-08-22','16:50:00',1.43),('5815','2013-08-22','16:55:00',1.36),('5815','2013-08-22','17:00:00',1.31),('5815','2013-08-22','17:05:00',1.24),('5815','2013-08-22','17:10:00',1.19),('5815','2013-08-22','17:15:00',1.13),('5815','2013-08-22','17:20:00',1.08),('5815','2013-08-22','17:25:00',1.03),('5815','2013-08-21','09:00:00',1),('5815','2013-08-21','09:05:00',1.09),('5815','2013-08-21','09:10:00',1.15),('5815','2013-08-21','09:15:00',1.21),('5815','2013-08-21','09:20:00',1.29),('5815','2013-08-21','09:25:00',1.23),('5815','2013-08-21','09:30:00',1.05),('5815','2013-08-21','09:45:00',1.01),('5815','2013-08-21','09:50:00',1.19),('5815','2013-08-21','09:55:00',1.37),('5815','2013-08-21','10:00:00',1.62),('5815','2013-08-21','10:05:00',1.63),('5815','2013-08-21','10:10:00',1.65),('5815','2013-08-21','10:15:00',1.64),('5815','2013-08-21','10:20:00',1.65),('5815','2013-08-21','10:25:00',1.68),('5815','2013-08-21','10:30:00',1.71),('5815','2013-08-21','10:35:00',1.73),('5815','2013-08-21','10:40:00',1.77),('5815','2013-08-21','10:45:00',1.79),('5815','2013-08-21','10:50:00',1.81),('5815','2013-08-21','10:55:00',1.84),('5815','2013-08-21','11:00:00',1.86),('5815','2013-08-21','11:05:00',1.88),('5815','2013-08-21','11:10:00',1.91),('5815','2013-08-21','11:15:00',1.93),('5815','2013-08-21','11:20:00',1.94),('5815','2013-08-21','11:25:00',1.96),('5815','2013-08-21','11:30:00',1.99),('5815','2013-08-21','11:35:00',2.01),('5815','2013-08-21','11:40:00',2.03),('5815','2013-08-21','11:45:00',2.04),('5815','2013-08-21','11:50:00',2.05),('5815','2013-08-21','11:55:00',2.07),('5815','2013-08-21','12:00:00',2.08),('5815','2013-08-21','12:05:00',2.09),('5815','2013-08-21','12:10:00',2.1),('5815','2013-08-21','12:15:00',2.11),('5815','2013-08-21','12:20:00',2.13),('5815','2013-08-21','12:25:00',2.12),('5815','2013-08-21','12:30:00',2.13),('5815','2013-08-21','12:35:00',2.14),('5815','2013-08-21','12:40:00',2.15),('5815','2013-08-21','12:45:00',2.16),('5815','2013-08-21','12:50:00',2.16),('5815','2013-08-21','12:55:00',2.16),('5815','2013-08-21','13:00:00',2.02),('5815','2013-08-21','13:05:00',2.05),('5815','2013-08-21','13:10:00',2.09),('5815','2013-08-21','13:15:00',2.1),('5815','2013-08-21','13:20:00',2.08),('5815','2013-08-21','13:25:00',2.12),('5815','2013-08-21','13:30:00',2.12),('5815','2013-08-21','13:35:00',2.13),('5815','2013-08-21','13:40:00',2.14),('5815','2013-08-21','13:45:00',2.15),('5815','2013-08-21','13:50:00',2.14),('5815','2013-08-21','13:55:00',2.12),('5815','2013-08-21','14:00:00',2.11),('5815','2013-08-21','14:05:00',2.12),('5815','2013-08-21','14:10:00',2.12),('5815','2013-08-21','14:15:00',2.11),('5815','2013-08-21','14:20:00',2.12),('5815','2013-08-21','14:25:00',2.14),('5815','2013-08-21','14:30:00',2.09),('5815','2013-08-21','14:35:00',2.09),('5815','2013-08-21','14:40:00',1.84),('5815','2013-08-21','14:45:00',2.07),('5815','2013-08-21','14:50:00',2.03),('5815','2013-08-21','14:55:00',1.79),('5815','2013-08-21','15:00:00',1.98),('5815','2013-08-21','15:05:00',1.99),('5815','2013-08-21','15:10:00',1.97),('5815','2013-08-21','15:15:00',1.97),('5815','2013-08-21','15:20:00',1.93),('5815','2013-08-21','15:25:00',1.89),('5815','2013-08-21','15:30:00',1.89),('5815','2013-08-21','15:35:00',1.85),('5815','2013-08-21','15:40:00',1.84),('5815','2013-08-21','15:45:00',1.81),('5815','2013-08-21','15:50:00',1.78),('5815','2013-08-21','15:55:00',1.75),('5815','2013-08-21','16:00:00',1.72),('5815','2013-08-21','16:05:00',1.65),('5815','2013-08-21','16:10:00',1.63),('5815','2013-08-21','16:15:00',1.6),('5815','2013-08-21','16:20:00',1.55),('5815','2013-08-21','16:25:00',1.53),('5815','2013-08-21','16:30:00',1.49),('5815','2013-08-21','16:35:00',1.46),('5815','2013-08-21','16:40:00',1.41),('5815','2013-08-21','16:45:00',1.35),('5815','2013-08-21','16:50:00',1.31),('5815','2013-08-21','16:55:00',1.27),('5815','2013-08-21','17:00:00',1.22),('5815','2013-08-21','17:05:00',1.19),('5815','2013-08-21','17:10:00',1.13),('5815','2013-08-21','17:15:00',1.07),('5815','2013-08-21','17:20:00',1.03),('5815','2013-08-20','09:15:00',1.26),('5815','2013-08-20','09:20:00',1.43),('5815','2013-08-20','09:50:00',1.66),('5815','2013-08-20','09:55:00',1.92),('5815','2013-08-20','10:00:00',1.79),('5815','2013-08-20','10:05:00',1.38),('5815','2013-08-20','10:10:00',1.22),('5815','2013-08-20','10:15:00',1.48),('5815','2013-08-20','10:20:00',1.08),('5815','2013-08-20','10:25:00',1.05),('5815','2013-08-20','10:30:00',1.01),('5815','2013-08-20','10:35:00',1.89),('5815','2013-08-20','10:40:00',1.7),('5815','2013-08-20','10:45:00',1.56),('5815','2013-08-20','10:50:00',1.37),('5815','2013-08-20','10:55:00',1.03),('5815','2013-08-20','11:00:00',1.29),('5815','2013-08-20','11:05:00',1.1),('5815','2013-08-20','11:15:00',1.27),('5815','2013-08-20','11:20:00',2.01),('5815','2013-08-20','11:25:00',1.57),('5815','2013-08-20','11:30:00',1.55),('5815','2013-08-20','11:35:00',2.17),('5815','2013-08-20','11:40:00',2.27),('5815','2013-08-20','11:45:00',2.27),('5815','2013-08-20','11:50:00',1.83),('5815','2013-08-20','11:55:00',2.12),('5815','2013-08-20','12:00:00',2.31),('5815','2013-08-20','12:05:00',2.31),('5815','2013-08-20','12:10:00',2.3),('5815','2013-08-20','12:15:00',2.27),('5815','2013-08-20','12:20:00',2.25),('5815','2013-08-20','12:25:00',1.48),('5815','2013-08-20','12:30:00',2.28),('5815','2013-08-20','12:35:00',2.09),('5815','2013-08-20','12:40:00',2.05),('5815','2013-08-20','12:45:00',2.23),('5815','2013-08-20','12:50:00',2.15),('5815','2013-08-20','12:55:00',2.07),('5815','2013-08-20','13:00:00',2.14),('5815','2013-08-20','13:05:00',2.19),('5815','2013-08-20','13:10:00',2.22),('5815','2013-08-20','13:15:00',2.24),('5815','2013-08-20','13:20:00',2.24),('5815','2013-08-20','13:25:00',2.26),('5815','2013-08-20','13:30:00',2.24),('5815','2013-08-20','13:35:00',2.23),('5815','2013-08-20','13:40:00',2.25),('5815','2013-08-20','13:45:00',2.19),('5815','2013-08-20','13:50:00',2.13),('5815','2013-08-20','13:55:00',2.12),('5815','2013-08-20','14:00:00',2.21),('5815','2013-08-20','14:05:00',2.18),('5815','2013-08-20','14:10:00',2.2),('5815','2013-08-20','14:15:00',2.23),('5815','2013-08-20','14:20:00',2.13),('5815','2013-08-20','14:25:00',1.76),('5815','2013-08-20','14:30:00',1.95),('5815','2013-08-20','14:35:00',1.9),('5815','2013-08-20','14:40:00',1.94),('5815','2013-08-20','14:45:00',1.96),('5815','2013-08-20','14:50:00',1.9),('5815','2013-08-20','14:55:00',1.87),('5815','2013-08-20','15:00:00',1.89),('5815','2013-08-20','15:05:00',1.95),('5815','2013-08-20','15:10:00',1.89),('5815','2013-08-20','15:15:00',1.84),('5815','2013-08-20','15:20:00',1.83),('5815','2013-08-20','15:25:00',1.85),('5815','2013-08-20','15:30:00',1.75),('5815','2013-08-20','15:35:00',1.68),('5815','2013-08-20','15:40:00',1.6),('5815','2013-08-20','15:45:00',1.65),('5815','2013-08-20','15:50:00',1.69),('5815','2013-08-20','15:55:00',1.54),('5815','2013-08-20','16:00:00',1.46),('5815','2013-08-20','16:05:00',1.47),('5815','2013-08-20','16:10:00',1.41),('5815','2013-08-20','16:15:00',1.47),('5815','2013-08-20','16:20:00',1.5),('5815','2013-08-20','16:25:00',1.48),('5815','2013-08-20','16:30:00',1.54),('5815','2013-08-20','16:35:00',1.48),('5815','2013-08-20','16:40:00',1.45),('5815','2013-08-20','16:45:00',1.41),('5815','2013-08-20','16:50:00',1.36),('5815','2013-08-20','16:55:00',1.33),('5815','2013-08-20','17:00:00',1.3),('5815','2013-08-20','17:05:00',1.26),('5815','2013-08-20','17:10:00',1.23),('5815','2013-08-20','17:15:00',1.21),('5815','2013-08-20','17:20:00',1.19),('5815','2013-08-20','17:25:00',1.15),('5815','2013-08-20','17:30:00',1.08),('5815','2013-08-20','17:35:00',1.05),('5815','2013-08-19','09:30:00',1.3),('5815','2013-08-19','09:35:00',1.34),('5815','2013-08-19','09:40:00',1.58),('5815','2013-08-19','09:45:00',1.69),('5815','2013-08-19','09:50:00',1.59),('5815','2013-08-19','09:55:00',1.04),('5815','2013-08-19','10:00:00',1.93),('5815','2013-08-19','10:05:00',1.01),('5815','2013-08-19','10:10:00',1.04),('5815','2013-08-19','10:15:00',1.43),('5815','2013-08-19','10:50:00',1.19),('5815','2013-08-19','10:55:00',1.58),('5815','2013-08-19','11:20:00',2.28),('5815','2013-08-19','11:25:00',2.25),('5815','2013-08-19','11:30:00',1.06),('5815','2013-08-19','11:40:00',1.87),('5815','2013-08-19','11:45:00',2.38),('5815','2013-08-19','11:50:00',1.64),('5815','2013-08-19','11:55:00',2.53),('5815','2013-08-19','12:00:00',1.36),('5815','2013-08-19','12:50:00',1.06),('5815','2013-08-19','12:55:00',1.03),('5815','2013-08-19','13:30:00',1.08),('5815','2013-08-19','13:35:00',1.38),('5815','2013-08-19','13:40:00',2.17),('5815','2013-08-19','13:45:00',2.13),('5815','2013-08-19','13:50:00',2.45),('5815','2013-08-19','13:55:00',2.42),('5815','2013-08-19','14:00:00',2.38),('5815','2013-08-19','14:05:00',2.37),('5815','2013-08-19','14:10:00',2.33),('5815','2013-08-19','14:15:00',2.31),('5815','2013-08-19','14:20:00',2.3),('5815','2013-08-19','14:25:00',2.22),('5815','2013-08-19','14:30:00',1.79),('5815','2013-08-19','14:35:00',2.1),('5815','2013-08-19','14:40:00',2.12),('5815','2013-08-19','14:45:00',2.12),('5815','2013-08-19','14:50:00',2.28),('5815','2013-08-19','14:55:00',1.91),('5815','2013-08-19','15:00:00',2.31),('5815','2013-08-19','15:05:00',2.19),('5815','2013-08-19','15:10:00',2.28),('5815','2013-08-19','15:15:00',2.17),('5815','2013-08-19','15:20:00',2.19),('5815','2013-08-19','15:25:00',2.18),('5815','2013-08-19','15:30:00',2.15),('5815','2013-08-19','15:35:00',2.14),('5815','2013-08-19','15:40:00',2.17),('5815','2013-08-19','15:45:00',2.23),('5815','2013-08-19','15:50:00',2.22),('5815','2013-08-19','15:55:00',2.34),('5815','2013-08-19','16:00:00',2.19),('5815','2013-08-19','16:05:00',2.09),('5815','2013-08-19','16:10:00',2.13),('5815','2013-08-19','16:15:00',2.08),('5815','2013-08-19','16:20:00',2.05),('5815','2013-08-19','16:25:00',1.9),('5815','2013-08-19','16:30:00',1.72),('5815','2013-08-19','16:35:00',1.81),('5815','2013-08-19','16:40:00',1.86),('5815','2013-08-19','16:45:00',1.76),('5815','2013-08-19','16:50:00',1.57),('5815','2013-08-19','16:55:00',1.54),('5815','2013-08-19','17:00:00',1.46),('5815','2013-08-19','17:05:00',1.36),('5815','2013-08-19','17:10:00',1.29),('5815','2013-08-19','17:15:00',1.23),('5815','2013-08-19','17:20:00',1.21),('5815','2013-08-19','17:25:00',1.14),('5815','2013-08-19','17:30:00',1.09),('5815','2013-08-19','17:35:00',1.05),('5815','2013-08-18','09:00:00',1.04),('5815','2013-08-18','09:05:00',1.08),('5815','2013-08-18','09:10:00',1.12),('5815','2013-08-18','09:15:00',1.17),('5815','2013-08-18','09:20:00',1.22),('5815','2013-08-18','09:25:00',1.26),('5815','2013-08-18','09:30:00',1.3),('5815','2013-08-18','09:35:00',1.35),('5815','2013-08-18','09:40:00',1.39),('5815','2013-08-18','09:45:00',1.43),('5815','2013-08-18','09:50:00',1.46),('5815','2013-08-18','09:55:00',1.5),('5815','2013-08-18','10:00:00',1.54),('5815','2013-08-18','10:05:00',1.57),('5815','2013-08-18','10:10:00',1.61),('5815','2013-08-18','10:15:00',1.65),('5815','2013-08-18','10:20:00',1.68),('5815','2013-08-18','10:25:00',1.69),('5815','2013-08-18','10:30:00',1.73),('5815','2013-08-18','10:35:00',1.75),('5815','2013-08-18','10:40:00',1.79),('5815','2013-08-18','10:45:00',1.82),('5815','2013-08-18','10:50:00',1.86),('5815','2013-08-18','10:55:00',1.89),('5815','2013-08-18','11:00:00',1.9),('5815','2013-08-18','11:05:00',1.92),('5815','2013-08-18','11:10:00',1.95),('5815','2013-08-18','11:15:00',1.97),('5815','2013-08-18','11:20:00',1.98),('5815','2013-08-18','11:25:00',2),('5815','2013-08-18','11:30:00',2.02),('5815','2013-08-18','11:35:00',2.04),('5815','2013-08-18','11:40:00',2.05),('5815','2013-08-18','11:45:00',2.06),('5815','2013-08-18','11:50:00',2.1),('5815','2013-08-18','11:55:00',2.09),('5815','2013-08-18','12:00:00',2.09),('5815','2013-08-18','12:05:00',2.1),('5815','2013-08-18','12:10:00',2.16),('5815','2013-08-18','12:15:00',2.16),('5815','2013-08-18','12:20:00',2.19),('5815','2013-08-18','12:25:00',2.19),('5815','2013-08-18','12:30:00',2.2),('5815','2013-08-18','12:35:00',2.2),('5815','2013-08-18','12:40:00',2.22),('5815','2013-08-18','12:45:00',2.22),('5815','2013-08-18','12:50:00',2.23),('5815','2013-08-18','12:55:00',2.24),('5815','2013-08-18','13:00:00',2.26),('5815','2013-08-18','13:05:00',2.26),('5815','2013-08-18','13:10:00',2.27),('5815','2013-08-18','13:15:00',2.26),('5815','2013-08-18','13:20:00',2.28),('5815','2013-08-18','13:25:00',2.27),('5815','2013-08-18','13:30:00',2.3),('5815','2013-08-18','13:35:00',2.29),('5815','2013-08-18','13:40:00',2.29),('5815','2013-08-18','13:45:00',2.28),('5815','2013-08-18','13:50:00',2.27),('5815','2013-08-18','13:55:00',2.27),('5815','2013-08-18','14:00:00',2.27),('5815','2013-08-18','14:05:00',2.25),('5815','2013-08-18','14:10:00',2.24),('5815','2013-08-18','14:15:00',2.22),('5815','2013-08-18','14:20:00',2.23),('5815','2013-08-18','14:25:00',2.23),('5815','2013-08-18','14:30:00',2.24),('5815','2013-08-18','14:35:00',2.22),('5815','2013-08-18','14:40:00',2.17),('5815','2013-08-18','14:45:00',2.19),('5815','2013-08-18','14:50:00',2.17),('5815','2013-08-18','14:55:00',2.15),('5815','2013-08-18','15:00:00',2.14),('5815','2013-08-18','15:05:00',2.13),('5815','2013-08-18','15:10:00',2.11),('5815','2013-08-18','15:15:00',2.08),('5815','2013-08-18','15:20:00',2.05),('5815','2013-08-18','15:25:00',2.03),('5815','2013-08-18','15:30:00',2.01),('5815','2013-08-18','15:35:00',1.98),('5815','2013-08-18','15:40:00',1.96),('5815','2013-08-18','15:45:00',1.93),('5815','2013-08-18','15:50:00',1.9),('5815','2013-08-18','15:55:00',1.88),('5815','2013-08-18','16:00:00',1.85),('5815','2013-08-18','16:05:00',1.79),('5815','2013-08-18','16:10:00',1.74),('5815','2013-08-18','16:15:00',1.68),('5815','2013-08-18','16:20:00',1.68),('5815','2013-08-18','16:25:00',1.66),('5815','2013-08-18','16:30:00',1.61),('5815','2013-08-18','16:35:00',1.57),('5815','2013-08-18','16:40:00',1.53),('5815','2013-08-18','16:45:00',1.49),('5815','2013-08-18','16:50:00',1.46),('5815','2013-08-18','16:55:00',1.42),('5815','2013-08-18','17:00:00',1.38),('5815','2013-08-18','17:05:00',1.32),('5815','2013-08-18','17:10:00',1.28),('5815','2013-08-18','17:15:00',1.23),('5815','2013-08-18','17:20:00',1.18),('5815','2013-08-18','17:25:00',1.12),('5815','2013-08-18','17:30:00',1.08),('5815','2013-08-18','17:35:00',1.03),('5815','2013-08-17','08:55:00',1),('5815','2013-08-17','09:00:00',1.05),('5815','2013-08-17','09:05:00',1.09),('5815','2013-08-17','09:10:00',1.14),('5815','2013-08-17','09:15:00',1.19),('5815','2013-08-17','09:20:00',1.24),('5815','2013-08-17','09:25:00',1.27),('5815','2013-08-17','09:30:00',1.33),('5815','2013-08-17','09:35:00',1.37),('5815','2013-08-17','09:40:00',1.43),('5815','2013-08-17','09:45:00',1.35),('5815','2013-08-17','09:50:00',1.51),('5815','2013-08-17','09:55:00',1.11),('5815','2013-08-17','10:00:00',1.57),('5815','2013-08-17','10:05:00',1.34),('5815','2013-08-17','10:10:00',1.4),('5815','2013-08-17','10:15:00',1.67),('5815','2013-08-17','10:20:00',1.69),('5815','2013-08-17','10:25:00',1.72),('5815','2013-08-17','10:30:00',1.74),('5815','2013-08-17','10:35:00',1.76),('5815','2013-08-17','10:40:00',1.79),('5815','2013-08-17','10:45:00',1.82),('5815','2013-08-17','10:50:00',1.83),('5815','2013-08-17','10:55:00',1.87),('5815','2013-08-17','11:00:00',1.88),('5815','2013-08-17','11:05:00',1.92),('5815','2013-08-17','11:10:00',1.93),('5815','2013-08-17','11:15:00',1.94),('5815','2013-08-17','11:20:00',1.97),('5815','2013-08-17','11:25:00',2),('5815','2013-08-17','11:30:00',2.02),('5815','2013-08-17','11:35:00',2.02),('5815','2013-08-17','11:40:00',2.05),('5815','2013-08-17','11:45:00',2.07),('5815','2013-08-17','11:50:00',2.07),('5815','2013-08-17','11:55:00',2.08),('5815','2013-08-17','12:00:00',2.08),('5815','2013-08-17','12:05:00',2.1),('5815','2013-08-17','12:10:00',2.13),('5815','2013-08-17','12:15:00',2.09),('5815','2013-08-17','12:20:00',2.17),('5815','2013-08-17','12:25:00',2.26),('5815','2013-08-17','12:30:00',2.22),('5815','2013-08-17','12:35:00',2.03),('5815','2013-08-17','12:40:00',1.46),('5815','2013-08-17','12:45:00',1.2),('5815','2013-08-17','12:55:00',1.61),('5815','2013-08-17','13:05:00',2.35),('5815','2013-08-17','13:10:00',2.39),('5815','2013-08-17','13:15:00',2.21),('5815','2013-08-17','13:20:00',2.17),('5815','2013-08-17','13:25:00',2.31),('5815','2013-08-17','13:30:00',2.23),('5815','2013-08-17','13:35:00',2.24),('5815','2013-08-17','13:40:00',2.29),('5815','2013-08-17','13:45:00',2.27),('5815','2013-08-17','13:50:00',2.27),('5815','2013-08-17','13:55:00',1.9),('5815','2013-08-17','14:00:00',2.27),('5815','2013-08-17','14:05:00',2.28),('5815','2013-08-17','14:10:00',2.24),('5815','2013-08-17','14:15:00',2.23),('5815','2013-08-17','14:20:00',2.21),('5815','2013-08-17','14:25:00',2.2),('5815','2013-08-17','14:30:00',2.2),('5815','2013-08-17','14:35:00',2.19),('5815','2013-08-17','14:40:00',2.18),('5815','2013-08-17','14:45:00',2.17),('5815','2013-08-17','14:50:00',2.15),('5815','2013-08-17','14:55:00',2.14),('5815','2013-08-17','15:00:00',2.11),('5815','2013-08-17','15:05:00',2.1),('5815','2013-08-17','15:10:00',2.08),('5815','2013-08-17','15:15:00',2.05),('5815','2013-08-17','15:20:00',2.03),('5815','2013-08-17','15:25:00',2.01),('5815','2013-08-17','15:30:00',1.97),('5815','2013-08-17','15:35:00',1.96),('5815','2013-08-17','15:40:00',1.94),('5815','2013-08-17','15:45:00',1.9),('5815','2013-08-17','15:50:00',1.87),('5815','2013-08-17','15:55:00',1.84),('5815','2013-08-17','16:00:00',1.82),('5815','2013-08-17','16:05:00',1.79),('5815','2013-08-17','16:10:00',1.74),('5815','2013-08-17','16:15:00',1.71),('5815','2013-08-17','16:20:00',1.67),('5815','2013-08-17','16:25:00',1.65),('5815','2013-08-17','16:30:00',1.61),('5815','2013-08-17','16:35:00',1.57),('5815','2013-08-17','16:40:00',1.53),('5815','2013-08-17','16:45:00',1.48),('5815','2013-08-17','16:50:00',1.45),('5815','2013-08-17','16:55:00',1.41),('5815','2013-08-17','17:00:00',1.37),('5815','2013-08-17','17:05:00',1.33),('5815','2013-08-17','17:10:00',1.28),('5815','2013-08-17','17:15:00',1.23),('5815','2013-08-17','17:20:00',1.19),('5815','2013-08-17','17:25:00',1.14),('5815','2013-08-17','17:30:00',1.09),('5815','2013-08-17','17:35:00',1.04),('5815','2013-08-16','09:00:00',1.04),('5815','2013-08-16','09:05:00',1.09),('5815','2013-08-16','09:10:00',1.13),('5815','2013-08-16','09:15:00',1.17),('5815','2013-08-16','09:20:00',1.23),('5815','2013-08-16','09:25:00',1.27),('5815','2013-08-16','09:30:00',1.32),('5815','2013-08-16','09:35:00',1.36),('5815','2013-08-16','09:40:00',1.4),('5815','2013-08-16','09:45:00',1.44),('5815','2013-08-16','09:50:00',1.48),('5815','2013-08-16','09:55:00',1.52),('5815','2013-08-16','10:00:00',1.56),('5815','2013-08-16','10:05:00',1.59),('5815','2013-08-16','10:10:00',1.63),('5815','2013-08-16','10:15:00',1.67),('5815','2013-08-16','10:20:00',1.69),('5815','2013-08-16','10:25:00',1.72),('5815','2013-08-16','10:30:00',1.75),('5815','2013-08-16','10:35:00',1.78),('5815','2013-08-16','10:40:00',1.81),('5815','2013-08-16','10:45:00',1.84),('5815','2013-08-16','10:50:00',1.88),('5815','2013-08-16','10:55:00',1.9),('5815','2013-08-16','11:00:00',1.91),('5815','2013-08-16','11:05:00',1.93),('5815','2013-08-16','11:10:00',1.96),('5815','2013-08-16','11:15:00',1.97),('5815','2013-08-16','11:20:00',1.99),('5815','2013-08-16','11:25:00',2.02),('5815','2013-08-16','11:30:00',2.04),('5815','2013-08-16','11:35:00',2.02),('5815','2013-08-16','11:40:00',2.09),('5815','2013-08-16','11:45:00',2.1),('5815','2013-08-16','11:50:00',2.11),('5815','2013-08-16','11:55:00',2.17),('5815','2013-08-16','12:00:00',2.14),('5815','2013-08-16','12:05:00',2.15),('5815','2013-08-16','12:10:00',2.14),('5815','2013-08-16','12:15:00',2.07),('5815','2013-08-16','12:20:00',2.17),('5815','2013-08-16','12:25:00',2.2),('5815','2013-08-16','12:30:00',2.24),('5815','2013-08-16','12:35:00',2.22),('5815','2013-08-16','12:40:00',2.11),('5815','2013-08-16','12:45:00',2.21),('5815','2013-08-16','12:50:00',2.27),('5815','2013-08-16','12:55:00',2.25),('5815','2013-08-16','13:00:00',2.21),('5815','2013-08-16','13:05:00',2.09),('5815','2013-08-16','13:10:00',2.3),('5815','2013-08-16','13:15:00',2.29),('5815','2013-08-16','13:20:00',2.26),('5815','2013-08-16','13:25:00',2.33),('5815','2013-08-16','13:30:00',1.45),('5815','2013-08-16','13:35:00',1.99),('5815','2013-08-16','13:40:00',1.02),('5815','2013-08-16','14:00:00',1.28),('5815','2013-08-16','14:05:00',1.87),('5815','2013-08-16','14:10:00',1.83),('5815','2013-08-16','14:15:00',2.32),('5815','2013-08-16','14:20:00',2.24),('5815','2013-08-16','14:25:00',2.28),('5815','2013-08-16','14:30:00',2.21),('5815','2013-08-16','14:35:00',2.21),('5815','2013-08-16','14:40:00',2.16),('5815','2013-08-16','14:45:00',2.16),('5815','2013-08-16','14:50:00',2.17),('5815','2013-08-16','14:55:00',2.12),('5815','2013-08-16','15:00:00',2.12),('5815','2013-08-16','15:05:00',2.11),('5815','2013-08-16','15:10:00',2.07),('5815','2013-08-16','15:15:00',2.05),('5815','2013-08-16','15:20:00',2.04),('5815','2013-08-16','15:25:00',2),('5815','2013-08-16','15:30:00',1.99),('5815','2013-08-16','15:35:00',1.99),('5815','2013-08-16','15:40:00',1.95),('5815','2013-08-16','15:45:00',1.9),('5815','2013-08-16','15:50:00',1.88),('5815','2013-08-16','15:55:00',1.85),('5815','2013-08-16','16:00:00',1.83),('5815','2013-08-16','16:05:00',1.79),('5815','2013-08-16','16:10:00',1.76),('5815','2013-08-16','16:15:00',1.74),('5815','2013-08-16','16:20:00',1.71),('5815','2013-08-16','16:25:00',1.67),('5815','2013-08-16','16:30:00',1.65),('5815','2013-08-16','16:35:00',1.62),('5815','2013-08-16','16:40:00',1.56),('5815','2013-08-16','16:45:00',1.51),('5815','2013-08-16','16:50:00',1.43),('5815','2013-08-16','16:55:00',1.45),('5815','2013-08-16','17:00:00',1.4),('5815','2013-08-16','17:05:00',1.33),('5815','2013-08-16','17:10:00',1.3),('5815','2013-08-16','17:15:00',1.11),('5815','2013-08-16','17:20:00',1.21),('5815','2013-08-16','17:25:00',1.15),('5815','2013-08-16','17:30:00',1.16),('5815','2013-08-16','17:35:00',1.1),('5815','2013-08-16','17:40:00',1.04),('5815','2013-08-15','08:55:00',1.01),('5815','2013-08-15','09:00:00',1.06),('5815','2013-08-15','09:05:00',1.11),('5815','2013-08-15','09:10:00',1.16),('5815','2013-08-15','09:15:00',1.21),('5815','2013-08-15','09:20:00',1.27),('5815','2013-08-15','09:25:00',1.31),('5815','2013-08-15','09:30:00',1.36),('5815','2013-08-15','09:35:00',1.4),('5815','2013-08-15','09:40:00',1.45),('5815','2013-08-15','09:45:00',1.49),('5815','2013-08-15','09:50:00',1.54),('5815','2013-08-15','09:55:00',1.57),('5815','2013-08-15','10:00:00',1.61),('5815','2013-08-15','10:05:00',1.65),('5815','2013-08-15','10:10:00',1.68),('5815','2013-08-15','10:15:00',1.72),('5815','2013-08-15','10:20:00',1.75),('5815','2013-08-15','10:25:00',1.78),('5815','2013-08-15','10:30:00',1.82),('5815','2013-08-15','10:35:00',1.85),('5815','2013-08-15','10:40:00',1.87),('5815','2013-08-15','10:45:00',1.89),('5815','2013-08-15','10:50:00',1.92),('5815','2013-08-15','10:55:00',1.95),('5815','2013-08-15','11:00:00',1.96),('5815','2013-08-15','11:05:00',1.98),('5815','2013-08-15','11:10:00',2),('5815','2013-08-15','11:15:00',2.01),('5815','2013-08-15','11:20:00',2.04),('5815','2013-08-15','11:25:00',2.05),('5815','2013-08-15','11:30:00',2.07),('5815','2013-08-15','11:35:00',2.1),('5815','2013-08-15','11:40:00',2.1),('5815','2013-08-15','11:45:00',2.12),('5815','2013-08-15','11:50:00',2.13),('5815','2013-08-15','11:55:00',2.14),('5815','2013-08-15','12:00:00',2.16),('5815','2013-08-15','12:05:00',2.17),('5815','2013-08-15','12:10:00',2.19),('5815','2013-08-15','12:15:00',2.21),('5815','2013-08-15','12:20:00',2.22),('5815','2013-08-15','12:25:00',2.22),('5815','2013-08-15','12:30:00',2.22),('5815','2013-08-15','12:35:00',2.21),('5815','2013-08-15','12:40:00',2.22),('5815','2013-08-15','12:45:00',2.23),('5815','2013-08-15','12:50:00',2.23),('5815','2013-08-15','12:55:00',2.24),('5815','2013-08-15','13:00:00',2.24),('5815','2013-08-15','13:05:00',2.25),('5815','2013-08-15','13:10:00',2.25),('5815','2013-08-15','13:15:00',2.25),('5815','2013-08-15','13:20:00',2.23),('5815','2013-08-15','13:25:00',2.23),('5815','2013-08-15','13:30:00',2.22),('5815','2013-08-15','13:35:00',2.22),('5815','2013-08-15','13:40:00',2.22),('5815','2013-08-15','13:45:00',2.22),('5815','2013-08-15','13:50:00',2.2),('5815','2013-08-15','13:55:00',2.21),('5815','2013-08-15','14:00:00',2.21),('5815','2013-08-15','14:05:00',2.22),('5815','2013-08-15','14:10:00',2.21),('5815','2013-08-15','14:15:00',2.21),('5815','2013-08-15','14:20:00',2.18),('5815','2013-08-15','14:25:00',2.17),('5815','2013-08-15','14:30:00',2.15),('5815','2013-08-15','14:35:00',2.12),('5815','2013-08-15','14:40:00',2.1),('5815','2013-08-15','14:45:00',2.09),('5815','2013-08-15','14:50:00',2.08),('5815','2013-08-15','14:55:00',2.08),('5815','2013-08-15','15:00:00',2.05),('5815','2013-08-15','15:05:00',2),('5815','2013-08-15','15:10:00',2.03),('5815','2013-08-15','15:15:00',2.02),('5815','2013-08-15','15:20:00',1.98),('5815','2013-08-15','15:25:00',1.97),('5815','2013-08-15','15:30:00',1.97),('5815','2013-08-15','15:35:00',1.95),('5815','2013-08-15','15:40:00',1.91),('5815','2013-08-15','15:45:00',1.9),('5815','2013-08-15','15:50:00',1.87),('5815','2013-08-15','15:55:00',1.85),('5815','2013-08-15','16:00:00',1.82),('5815','2013-08-15','16:05:00',1.79),('5815','2013-08-15','16:10:00',1.76),('5815','2013-08-15','16:15:00',1.72),('5815','2013-08-15','16:20:00',1.68),('5815','2013-08-15','16:25:00',1.65),('5815','2013-08-15','16:30:00',1.61),('5815','2013-08-15','16:35:00',1.58),('5815','2013-08-15','16:40:00',1.55),('5815','2013-08-15','16:45:00',1.52),('5815','2013-08-15','16:50:00',1.47),('5815','2013-08-15','16:55:00',1.43),('5815','2013-08-15','17:00:00',1.38),('5815','2013-08-15','17:05:00',1.33),('5815','2013-08-15','17:10:00',1.28),('5815','2013-08-15','17:15:00',1.23),('5815','2013-08-15','17:20:00',1.18),('5815','2013-08-15','17:25:00',1.13),('5815','2013-08-15','17:30:00',1.07),('5815','2013-08-15','17:35:00',1.02),('5815','2013-08-14','08:55:00',1.03),('5815','2013-08-14','09:00:00',1.09),('5815','2013-08-14','09:05:00',1.05),('5815','2013-08-14','09:20:00',1.24),('5815','2013-08-14','09:25:00',1.31),('5815','2013-08-14','09:30:00',1.35),('5815','2013-08-14','09:35:00',1.4),('5815','2013-08-14','09:40:00',1.44),('5815','2013-08-14','09:45:00',1.48),('5815','2013-08-14','09:50:00',1.53),('5815','2013-08-14','09:55:00',1.57),('5815','2013-08-14','10:00:00',1.61),('5815','2013-08-14','10:05:00',1.64),('5815','2013-08-14','10:10:00',1.68),('5815','2013-08-14','10:15:00',1.72),('5815','2013-08-14','10:20:00',1.75),('5815','2013-08-14','10:25:00',1.79),('5815','2013-08-14','10:30:00',1.82),('5815','2013-08-14','10:35:00',1.84),('5815','2013-08-14','10:40:00',1.87),('5815','2013-08-14','10:45:00',1.87),('5815','2013-08-14','10:50:00',1.85),('5815','2013-08-14','10:55:00',1.84),('5815','2013-08-14','11:00:00',1.8),('5815','2013-08-14','11:05:00',1.55),('5815','2013-08-14','11:10:00',1.38),('5815','2013-08-14','11:15:00',1.48),('5815','2013-08-14','11:20:00',1.7),('5815','2013-08-14','11:25:00',1.88),('5815','2013-08-14','11:30:00',2.11),('5815','2013-08-14','11:35:00',2.21),('5815','2013-08-14','11:40:00',2.26),('5815','2013-08-14','11:45:00',2.31),('5815','2013-08-14','11:50:00',2.32),('5815','2013-08-14','11:55:00',2.33),('5815','2013-08-14','12:00:00',2.32),('5815','2013-08-14','12:05:00',2.31),('5815','2013-08-14','12:10:00',2.29),('5815','2013-08-14','12:15:00',2.31),('5815','2013-08-14','12:20:00',2.3),('5815','2013-08-14','12:25:00',2.31),('5815','2013-08-14','12:30:00',2.31),('5815','2013-08-14','12:35:00',2.32),('5815','2013-08-14','12:40:00',2.29),('5815','2013-08-14','12:45:00',2.32),('5815','2013-08-14','12:50:00',2.28),('5815','2013-08-14','12:55:00',2.18),('5815','2013-08-14','13:00:00',2.2),('5815','2013-08-14','13:05:00',2.2),('5815','2013-08-14','13:10:00',2.18),('5815','2013-08-14','13:15:00',2.14),('5815','2013-08-14','13:20:00',2.15),('5815','2013-08-14','13:25:00',2.25),('5815','2013-08-14','13:30:00',2.29),('5815','2013-08-14','13:35:00',2.29),('5815','2013-08-14','13:40:00',2.26),('5815','2013-08-14','13:45:00',2.25),('5815','2013-08-14','13:50:00',2.23),('5815','2013-08-14','13:55:00',2.2),('5815','2013-08-14','14:00:00',2.23),('5815','2013-08-14','14:05:00',2.23),('5815','2013-08-14','14:10:00',2.22),('5815','2013-08-14','14:15:00',2.22),('5815','2013-08-14','14:20:00',2.19),('5815','2013-08-14','14:25:00',2.14),('5815','2013-08-14','14:30:00',2.11),('5815','2013-08-14','14:35:00',2.16),('5815','2013-08-14','14:40:00',2.13),('5815','2013-08-14','14:45:00',2.09),('5815','2013-08-14','14:50:00',2.08),('5815','2013-08-14','14:55:00',2.05),('5815','2013-08-14','15:00:00',2.04),('5815','2013-08-14','15:05:00',2.04),('5815','2013-08-14','15:10:00',2.02),('5815','2013-08-14','15:15:00',1.99),('5815','2013-08-14','15:20:00',1.94),('5815','2013-08-14','15:25:00',1.91),('5815','2013-08-14','15:30:00',1.92),('5815','2013-08-14','15:35:00',1.9),('5815','2013-08-14','15:40:00',1.86),('5815','2013-08-14','15:45:00',1.81),('5815','2013-08-14','15:50:00',1.79),('5815','2013-08-14','15:55:00',1.78),('5815','2013-08-14','16:00:00',1.73),('5815','2013-08-14','16:05:00',1.68),('5815','2013-08-14','16:10:00',1.56),('5815','2013-08-14','16:15:00',1.62),('5815','2013-08-14','16:20:00',1.62),('5815','2013-08-14','16:25:00',1.56),('5815','2013-08-14','16:30:00',1.5),('5815','2013-08-14','16:35:00',1.48),('5815','2013-08-14','16:40:00',1.45),('5815','2013-08-14','16:45:00',1.41),('5815','2013-08-14','16:50:00',1.39),('5815','2013-08-14','16:55:00',1.32),('5815','2013-08-14','17:00:00',1.31),('5815','2013-08-14','17:05:00',1.27),('5815','2013-08-14','17:10:00',1.23),('5815','2013-08-14','17:15:00',1.19),('5815','2013-08-14','17:20:00',1.16),('5815','2013-08-14','17:25:00',1.09),('5815','2013-08-14','17:30:00',1.05),('5815','2013-08-13','09:00:00',1.04),('5815','2013-08-13','09:05:00',1.09),('5815','2013-08-13','09:10:00',1.15),('5815','2013-08-13','09:15:00',1.21),('5815','2013-08-13','09:20:00',1.25),('5815','2013-08-13','09:25:00',1.22),('5815','2013-08-13','09:30:00',1.35),('5815','2013-08-13','09:35:00',1.44),('5815','2013-08-13','09:40:00',1.44),('5815','2013-08-13','10:05:00',1.23),('5815','2013-08-13','10:10:00',1.44),('5815','2013-08-13','10:15:00',1.55),('5815','2013-08-13','10:20:00',1.51),('5815','2013-08-13','10:25:00',1.76),('5815','2013-08-13','10:30:00',1.89),('5815','2013-08-13','10:35:00',1.93),('5815','2013-08-13','10:40:00',1.99),('5815','2013-08-13','10:45:00',1.45),('5815','2013-08-13','10:50:00',1.49),('5815','2013-08-13','11:00:00',1.44),('5815','2013-08-13','11:05:00',2.04),('5815','2013-08-13','11:20:00',1.73),('5815','2013-08-13','11:25:00',1.76),('5815','2013-08-13','11:30:00',2.13),('5815','2013-08-13','11:35:00',2.16),('5815','2013-08-13','11:40:00',2.2),('5815','2013-08-13','11:45:00',1.54),('5815','2013-08-13','12:05:00',1.13),('5815','2013-08-13','12:10:00',1.15),('5815','2013-08-13','12:15:00',1.24),('5815','2013-08-13','12:20:00',1.15),('5815','2013-08-13','12:35:00',1.23),('5815','2013-08-13','12:55:00',1.18),('5815','2013-08-13','13:30:00',1.07),('5815','2013-08-13','13:40:00',1.44),('5815','2013-08-13','13:45:00',2.04),('5815','2013-08-13','13:50:00',2.52),('5815','2013-08-13','13:55:00',1.77),('5815','2013-08-13','14:05:00',2.43),('5815','2013-08-13','14:10:00',1.28),('5815','2013-08-13','14:15:00',2.46),('5815','2013-08-13','14:20:00',2.41),('5815','2013-08-13','14:25:00',2.41),('5815','2013-08-13','14:30:00',2.35),('5815','2013-08-13','14:35:00',2.34),('5815','2013-08-13','14:40:00',2.27),('5815','2013-08-13','14:45:00',2.22),('5815','2013-08-13','14:50:00',2.23),('5815','2013-08-13','14:55:00',1.57),('5815','2013-08-13','15:00:00',2.15),('5815','2013-08-13','15:05:00',2.14),('5815','2013-08-13','15:10:00',2.08),('5815','2013-08-13','15:15:00',2.09),('5815','2013-08-13','15:20:00',2.11),('5815','2013-08-13','15:25:00',2.11),('5815','2013-08-13','15:30:00',2.02),('5815','2013-08-13','15:35:00',1.97),('5815','2013-08-13','15:40:00',1.96),('5815','2013-08-13','15:45:00',1.93),('5815','2013-08-13','15:50:00',1.91),('5815','2013-08-13','15:55:00',1.87),('5815','2013-08-13','16:00:00',1.86),('5815','2013-08-13','16:05:00',1.84),('5815','2013-08-13','16:10:00',1.81),('5815','2013-08-13','16:15:00',1.77),('5815','2013-08-13','16:20:00',1.75),('5815','2013-08-13','16:25:00',1.7),('5815','2013-08-13','16:30:00',1.65),('5815','2013-08-13','16:35:00',1.62),('5815','2013-08-13','16:40:00',1.58),('5815','2013-08-13','16:45:00',1.52),('5815','2013-08-13','16:50:00',1.51),('5815','2013-08-13','16:55:00',1.46),('5815','2013-08-13','17:00:00',1.41),('5815','2013-08-13','17:05:00',1.35),('5815','2013-08-13','17:10:00',1.3),('5815','2013-08-13','17:15:00',1.26),('5815','2013-08-13','17:20:00',1.2),('5815','2013-08-13','17:25:00',1.16),('5815','2013-08-13','17:30:00',1.1),('5815','2013-08-13','17:35:00',1.05),('5815','2013-08-12','08:55:00',1.01),('5815','2013-08-12','09:00:00',1.06),('5815','2013-08-12','09:05:00',1.11),('5815','2013-08-12','09:10:00',1.15),('5815','2013-08-12','09:15:00',1.21),('5815','2013-08-12','09:20:00',1.24),('5815','2013-08-12','09:25:00',1.25),('5815','2013-08-12','09:30:00',1.27),('5815','2013-08-12','09:35:00',1.36),('5815','2013-08-12','09:40:00',1.44),('5815','2013-08-12','09:45:00',1.18),('5815','2013-08-12','09:50:00',1.51),('5815','2013-08-12','09:55:00',1.54),('5815','2013-08-12','10:00:00',1.41),('5815','2013-08-12','10:05:00',1.06),('5815','2013-08-12','10:10:00',1.64),('5815','2013-08-12','10:15:00',1.73),('5815','2013-08-12','10:20:00',1.71),('5815','2013-08-12','10:25:00',1.76),('5815','2013-08-12','10:30:00',1.78),('5815','2013-08-12','10:35:00',1.82),('5815','2013-08-12','10:40:00',1.84),('5815','2013-08-12','10:45:00',1.87),('5815','2013-08-12','10:50:00',1.9),('5815','2013-08-12','10:55:00',1.91),('5815','2013-08-12','11:00:00',1.92),('5815','2013-08-12','11:05:00',1.98),('5815','2013-08-12','11:10:00',1.96),('5815','2013-08-12','11:15:00',1.96),('5815','2013-08-12','11:20:00',1.98),('5815','2013-08-12','11:25:00',2.02),('5815','2013-08-12','11:30:00',2.05),('5815','2013-08-12','11:35:00',2.03),('5815','2013-08-12','11:40:00',2.07),('5815','2013-08-12','11:45:00',2.08),('5815','2013-08-12','11:50:00',2.12),('5815','2013-08-12','11:55:00',2.18),('5815','2013-08-12','12:00:00',2.22),('5815','2013-08-12','12:05:00',2.24),('5815','2013-08-12','12:10:00',2.25),('5815','2013-08-12','12:15:00',2.28),('5815','2013-08-12','12:20:00',2.3),('5815','2013-08-12','12:25:00',2.32),('5815','2013-08-12','12:30:00',2.34),('5815','2013-08-12','12:35:00',1.92),('5815','2013-08-12','12:40:00',2.26),('5815','2013-08-12','12:45:00',1.13),('5815','2013-08-12','12:50:00',1.99),('5815','2013-08-12','12:55:00',2.23),('5815','2013-08-12','13:15:00',1.11),('5815','2013-08-12','13:20:00',2.69),('5815','2013-08-12','13:25:00',2.58),('5815','2013-08-12','13:30:00',2.55),('5815','2013-08-12','13:35:00',2.48),('5815','2013-08-12','13:40:00',2.48),('5815','2013-08-12','13:45:00',2.49),('5815','2013-08-12','13:50:00',2.53),('5815','2013-08-12','13:55:00',2.52),('5815','2013-08-12','14:00:00',2.39),('5815','2013-08-12','14:05:00',2.46),('5815','2013-08-12','14:10:00',1.86),('5815','2013-08-12','14:15:00',2.38),('5815','2013-08-12','14:20:00',2.42),('5815','2013-08-12','14:25:00',1.92),('5815','2013-08-12','14:35:00',2.37),('5815','2013-08-12','14:40:00',1.62),('5815','2013-08-12','14:45:00',1.09),('5815','2013-08-12','14:50:00',2.27),('5815','2013-08-12','14:55:00',2.41),('5815','2013-08-12','15:00:00',2.01),('5815','2013-08-12','15:05:00',1.75),('5815','2013-08-12','15:10:00',1.41),('5815','2013-08-12','15:15:00',1.85),('5815','2013-08-12','15:20:00',2.1),('5815','2013-08-12','15:25:00',2.1),('5815','2013-08-12','15:30:00',2.04),('5815','2013-08-12','15:35:00',2.03),('5815','2013-08-12','15:40:00',2),('5815','2013-08-12','15:45:00',1.96),('5815','2013-08-12','15:50:00',1.91),('5815','2013-08-12','15:55:00',1.88),('5815','2013-08-12','16:00:00',1.86),('5815','2013-08-12','16:05:00',1.81),('5815','2013-08-12','16:10:00',1.77),('5815','2013-08-12','16:15:00',1.75),('5815','2013-08-12','16:20:00',1.72),('5815','2013-08-12','16:25:00',1.68),('5815','2013-08-12','16:30:00',1.64),('5815','2013-08-12','16:35:00',1.58),('5815','2013-08-12','16:40:00',1.57),('5815','2013-08-12','16:45:00',1.53),('5815','2013-08-12','16:50:00',1.49),('5815','2013-08-12','16:55:00',1.44),('5815','2013-08-12','17:00:00',1.39),('5815','2013-08-12','17:05:00',1.35),('5815','2013-08-12','17:10:00',1.31),('5815','2013-08-12','17:15:00',1.26),('5815','2013-08-12','17:20:00',1.2),('5815','2013-08-12','17:25:00',1.16),('5815','2013-08-12','17:30:00',1.07),('5815','2013-08-12','17:35:00',1.04),('5815','2013-08-11','09:00:00',1.04),('5815','2013-08-11','09:05:00',1.09),('5815','2013-08-11','09:10:00',1.13),('5815','2013-08-11','09:15:00',1.18),('5815','2013-08-11','09:20:00',1.22),('5815','2013-08-11','09:25:00',1.27),('5815','2013-08-11','09:30:00',1.31),('5815','2013-08-11','09:35:00',1.35),('5815','2013-08-11','09:40:00',1.39),('5815','2013-08-11','09:45:00',1.43),('5815','2013-08-11','09:50:00',1.47),('5815','2013-08-11','09:55:00',1.51),('5815','2013-08-11','10:00:00',1.53),('5815','2013-08-11','10:05:00',1.57),('5815','2013-08-11','10:10:00',1.6),('5815','2013-08-11','10:15:00',1.63),('5815','2013-08-11','10:20:00',1.67),('5815','2013-08-11','10:25:00',1.7),('5815','2013-08-11','10:30:00',1.73),('5815','2013-08-11','10:35:00',1.75),('5815','2013-08-11','10:40:00',1.79),('5815','2013-08-11','10:45:00',1.82),('5815','2013-08-11','10:50:00',1.86),('5815','2013-08-11','10:55:00',1.88),('5815','2013-08-11','11:00:00',1.86),('5815','2013-08-11','11:05:00',1.91),('5815','2013-08-11','11:10:00',1.92),('5815','2013-08-11','11:15:00',1.93),('5815','2013-08-11','11:20:00',1.93),('5815','2013-08-11','11:25:00',1.97),('5815','2013-08-11','11:30:00',1.99),('5815','2013-08-11','11:35:00',1.95),('5815','2013-08-11','11:40:00',2.04),('5815','2013-08-11','11:45:00',2.09),('5815','2013-08-11','11:50:00',2.11),('5815','2013-08-11','11:55:00',2.15),('5815','2013-08-11','12:00:00',2.2),('5815','2013-08-11','12:05:00',2.25),('5815','2013-08-11','12:10:00',2.18),('5815','2013-08-11','12:15:00',1.76),('5815','2013-08-11','12:45:00',1.81),('5815','2013-08-11','12:50:00',1.03),('5815','2013-08-11','13:25:00',1.25),('5815','2013-08-11','13:50:00',1.43),('5815','2013-08-11','13:55:00',2.24),('5815','2013-08-11','14:50:00',1.2),('5815','2013-08-11','14:55:00',2.51),('5815','2013-08-11','15:00:00',2.26),('5815','2013-08-11','15:05:00',1.93),('5815','2013-08-11','15:10:00',2.25),('5815','2013-08-11','15:15:00',2.19),('5815','2013-08-11','15:20:00',1.72),('5815','2013-08-11','15:25:00',1.95),('5815','2013-08-11','15:30:00',2.09),('5815','2013-08-11','15:35:00',1.97),('5815','2013-08-11','15:40:00',1.98),('5815','2013-08-11','15:45:00',1.93),('5815','2013-08-11','15:50:00',1.91),('5815','2013-08-11','15:55:00',1.88),('5815','2013-08-11','16:00:00',1.84),('5815','2013-08-11','16:05:00',1.8),('5815','2013-08-11','16:10:00',1.78),('5815','2013-08-11','16:15:00',1.73),('5815','2013-08-11','16:20:00',1.7),('5815','2013-08-11','16:25:00',1.66),('5815','2013-08-11','16:30:00',1.61),('5815','2013-08-11','16:35:00',1.57),('5815','2013-08-11','16:40:00',1.55),('5815','2013-08-11','16:45:00',1.5),('5815','2013-08-11','16:50:00',1.46),('5815','2013-08-11','16:55:00',1.42),('5815','2013-08-11','17:00:00',1.39),('5815','2013-08-11','17:05:00',1.34),('5815','2013-08-11','17:10:00',1.29),('5815','2013-08-11','17:15:00',1.23),('5815','2013-08-11','17:20:00',1.17),('5815','2013-08-11','17:25:00',1.14),('5815','2013-08-11','17:30:00',1.06),('5815','2013-08-11','17:35:00',1.03),('5815','2013-08-10','08:55:00',1.01),('5815','2013-08-10','09:00:00',1.06),('5815','2013-08-10','09:05:00',1.11),('5815','2013-08-10','09:10:00',1.16),('5815','2013-08-10','09:15:00',1.2),('5815','2013-08-10','09:20:00',1.25),('5815','2013-08-10','09:25:00',1.29),('5815','2013-08-10','09:30:00',1.34),('5815','2013-08-10','09:35:00',1.38),('5815','2013-08-10','09:40:00',1.42),('5815','2013-08-10','09:45:00',1.47),('5815','2013-08-10','09:50:00',1.5),('5815','2013-08-10','09:55:00',1.55),('5815','2013-08-10','10:00:00',1.59),('5815','2013-08-10','10:05:00',1.62),('5815','2013-08-10','10:10:00',1.66),('5815','2013-08-10','10:15:00',1.7),('5815','2013-08-10','10:20:00',1.73),('5815','2013-08-10','10:25:00',1.76),('5815','2013-08-10','10:30:00',1.79),('5815','2013-08-10','10:35:00',1.81),('5815','2013-08-10','10:40:00',1.84),('5815','2013-08-10','10:45:00',1.87),('5815','2013-08-10','10:50:00',1.89),('5815','2013-08-10','10:55:00',1.92),('5815','2013-08-10','11:00:00',1.95),('5815','2013-08-10','11:05:00',1.97),('5815','2013-08-10','11:10:00',1.97),('5815','2013-08-10','11:15:00',1.97),('5815','2013-08-10','11:20:00',2),('5815','2013-08-10','11:25:00',2.03),('5815','2013-08-10','11:30:00',2.03),('5815','2013-08-10','11:35:00',2.03),('5815','2013-08-10','11:40:00',2.09),('5815','2013-08-10','11:45:00',2.1),('5815','2013-08-10','11:50:00',2.14),('5815','2013-08-10','11:55:00',2.15),('5815','2013-08-10','12:00:00',2.17),('5815','2013-08-10','12:05:00',2.18),('5815','2013-08-10','12:10:00',2.19),('5815','2013-08-10','12:15:00',2.19),('5815','2013-08-10','12:20:00',2.21),('5815','2013-08-10','12:25:00',2.22),('5815','2013-08-10','12:30:00',2.23),('5815','2013-08-10','12:35:00',2.23),('5815','2013-08-10','12:40:00',2.24),('5815','2013-08-10','12:45:00',2.25),('5815','2013-08-10','12:50:00',2.25),('5815','2013-08-10','12:55:00',2.25),('5815','2013-08-10','13:00:00',2.22),('5815','2013-08-10','13:05:00',2.24),('5815','2013-08-10','13:10:00',2.23),('5815','2013-08-10','13:15:00',2.23),('5815','2013-08-10','13:20:00',2.24),('5815','2013-08-10','13:25:00',2.24),('5815','2013-08-10','13:30:00',2.23),('5815','2013-08-10','13:35:00',2.22),('5815','2013-08-10','13:40:00',2.25),('5815','2013-08-10','13:45:00',2.23),('5815','2013-08-10','13:50:00',2.22),('5815','2013-08-10','13:55:00',2.2),('5815','2013-08-10','14:00:00',2.21),('5815','2013-08-10','14:05:00',2.21),('5815','2013-08-10','14:10:00',2.22),('5815','2013-08-10','14:15:00',2.16),('5815','2013-08-10','14:20:00',2.17),('5815','2013-08-10','14:25:00',2.14),('5815','2013-08-10','14:30:00',2.12),('5815','2013-08-10','14:35:00',2.11),('5815','2013-08-10','14:40:00',2.12),('5815','2013-08-10','14:45:00',2.1),('5815','2013-08-10','14:50:00',2.06),('5815','2013-08-10','14:55:00',2.06),('5815','2013-08-10','15:00:00',2.08),('5815','2013-08-10','15:05:00',2.05),('5815','2013-08-10','15:10:00',2.01),('5815','2013-08-10','15:15:00',1.99),('5815','2013-08-10','15:20:00',2),('5815','2013-08-10','15:25:00',2.03),('5815','2013-08-10','15:30:00',1.4),('5815','2013-08-10','15:35:00',1.93),('5815','2013-08-10','15:40:00',1.91),('5815','2013-08-10','15:45:00',1.88),('5815','2013-08-10','15:50:00',1.89),('5815','2013-08-10','15:55:00',1.87),('5815','2013-08-10','16:00:00',1.82),('5815','2013-08-10','16:05:00',1.78),('5815','2013-08-10','16:10:00',1.75),('5815','2013-08-10','16:15:00',1.71),('5815','2013-08-10','16:20:00',1.68),('5815','2013-08-10','16:25:00',1.64),('5815','2013-08-10','16:30:00',1.6),('5815','2013-08-10','16:35:00',1.57),('5815','2013-08-10','16:40:00',1.53),('5815','2013-08-10','16:45:00',1.48),('5815','2013-08-10','16:50:00',1.45),('5815','2013-08-10','16:55:00',1.41),('5815','2013-08-10','17:00:00',1.37),('5815','2013-08-10','17:05:00',1.33),('5815','2013-08-10','17:10:00',1.29),('5815','2013-08-10','17:15:00',1.2),('5815','2013-08-10','17:20:00',1.16),('5815','2013-08-10','17:25:00',1.13),('5815','2013-08-10','17:30:00',1.05),('5815','2013-08-10','17:35:00',1.03),('5815','2013-08-09','08:55:00',1.03),('5815','2013-08-09','09:00:00',1.08),('5815','2013-08-09','09:05:00',1.13),('5815','2013-08-09','09:10:00',1.17),('5815','2013-08-09','09:15:00',1.23),('5815','2013-08-09','09:20:00',1.27),('5815','2013-08-09','09:25:00',1.32),('5815','2013-08-09','09:30:00',1.36),('5815','2013-08-09','09:35:00',1.4),('5815','2013-08-09','09:40:00',1.43),('5815','2013-08-09','09:45:00',1.48),('5815','2013-08-09','09:50:00',1.5),('5815','2013-08-09','09:55:00',1.55),('5815','2013-08-09','10:00:00',1.6),('5815','2013-08-09','10:05:00',1.62),('5815','2013-08-09','10:15:00',1.7),('5815','2013-08-09','10:20:00',1.7),('5815','2013-08-09','10:25:00',1.76),('5815','2013-08-09','10:30:00',1.78),('5815','2013-08-09','10:35:00',1.81),('5815','2013-08-09','10:40:00',1.85),('5815','2013-08-09','10:45:00',1.88),('5815','2013-08-09','10:50:00',1.92),('5815','2013-08-09','10:55:00',1.95),('5815','2013-08-09','11:00:00',2),('5815','2013-08-09','11:05:00',2),('5815','2013-08-09','11:10:00',1.73),('5815','2013-08-09','11:15:00',1.79),('5815','2013-08-09','11:20:00',1.33),('5815','2013-08-09','11:25:00',1.49),('5815','2013-08-09','11:30:00',1.81),('5815','2013-08-09','11:35:00',2.12),('5815','2013-08-09','11:40:00',2.12),('5815','2013-08-09','11:45:00',2.14),('5815','2013-08-09','11:50:00',2.16),('5815','2013-08-09','11:55:00',2.16),('5815','2013-08-09','12:00:00',2.19),('5815','2013-08-09','12:05:00',2.19),('5815','2013-08-09','12:10:00',2.21),('5815','2013-08-09','12:15:00',2.21),('5815','2013-08-09','12:20:00',2.22),('5815','2013-08-09','12:25:00',2.23),('5815','2013-08-09','12:30:00',2.22),('5815','2013-08-09','12:35:00',2.24),('5815','2013-08-09','12:40:00',2.26),('5815','2013-08-09','12:45:00',2.3),('5815','2013-08-09','12:50:00',2.35),('5815','2013-08-09','12:55:00',2.36),('5815','2013-08-09','13:00:00',2.33),('5815','2013-08-09','13:05:00',2.27),('5815','2013-08-09','13:10:00',2.33),('5815','2013-08-09','13:15:00',2.37),('5815','2013-08-09','13:20:00',2.32),('5815','2013-08-09','13:25:00',2.44),('5815','2013-08-09','13:30:00',2.06),('5815','2013-08-09','13:35:00',1.52),('5815','2013-08-09','13:45:00',1.04),('5815','2013-08-09','13:50:00',2.46),('5815','2013-08-09','13:55:00',2.4),('5815','2013-08-09','14:00:00',2.51),('5815','2013-08-09','14:05:00',1.98),('5815','2013-08-09','14:10:00',2.52),('5815','2013-08-09','14:15:00',2.1),('5815','2013-08-09','14:20:00',1.06),('5815','2013-08-09','15:55:00',1.08),('5815','2013-08-09','16:00:00',1.2),('5815','2013-08-09','16:05:00',2.13),('5815','2013-08-09','16:10:00',1.09),('5815','2013-08-09','16:15:00',1.23),('5815','2013-08-09','16:20:00',1.32),('5815','2013-08-09','16:30:00',1.06),('5815','2013-08-09','16:35:00',1.87),('5815','2013-08-09','16:40:00',1.71),('5815','2013-08-09','16:45:00',1.66),('5815','2013-08-09','16:50:00',1.56),('5815','2013-08-09','16:55:00',1.45),('5815','2013-08-09','17:00:00',1.33),('5815','2013-08-08','09:05:00',1.05),('5815','2013-08-08','09:10:00',1.13),('5815','2013-08-08','09:15:00',1),('5815','2013-08-08','09:30:00',1.16),('5815','2013-08-08','09:35:00',1.42),('5815','2013-08-08','09:40:00',1.14),('5815','2013-08-08','09:45:00',1.43),('5815','2013-08-08','09:50:00',1.44),('5815','2013-08-08','10:00:00',1.07),('5815','2013-08-08','10:05:00',1.29),('5815','2013-08-08','10:10:00',1.5),('5815','2013-08-08','10:15:00',1.53),('5815','2013-08-08','10:20:00',1.53),('5815','2013-08-08','10:25:00',1.56),('5815','2013-08-08','10:30:00',1.62),('5815','2013-08-08','10:35:00',1.63),('5815','2013-08-08','10:40:00',1.71),('5815','2013-08-08','10:45:00',1.67),('5815','2013-08-08','10:50:00',1.73),('5815','2013-08-08','10:55:00',1.75),('5815','2013-08-08','11:00:00',1.77),('5815','2013-08-08','11:05:00',1.79),('5815','2013-08-08','11:10:00',1.8),('5815','2013-08-08','11:15:00',1.81),('5815','2013-08-08','11:20:00',1.85),('5815','2013-08-08','11:25:00',1.88),('5815','2013-08-08','11:30:00',1.89),('5815','2013-08-08','11:35:00',1.88),('5815','2013-08-08','11:40:00',1.9),('5815','2013-08-08','11:45:00',1.94),('5815','2013-08-08','11:50:00',1.97),('5815','2013-08-08','11:55:00',1.99),('5815','2013-08-08','12:00:00',1.99),('5815','2013-08-08','12:05:00',1.99),('5815','2013-08-08','12:10:00',2.03),('5815','2013-08-08','12:15:00',2.06),('5815','2013-08-08','12:20:00',2.15),('5815','2013-08-08','12:25:00',2.06),('5815','2013-08-08','12:30:00',1.5),('5815','2013-08-08','12:35:00',1.79),('5815','2013-08-08','12:40:00',2.25),('5815','2013-08-08','12:45:00',1.71),('5815','2013-08-08','12:50:00',1.38),('5815','2013-08-08','12:55:00',1.48),('5815','2013-08-08','13:25:00',1.2),('5815','2013-08-08','13:30:00',1.13),('5815','2013-08-08','15:10:00',1.59),('5815','2013-08-08','15:15:00',1.46),('5815','2013-08-08','15:35:00',1.17),('5815','2013-08-08','15:45:00',1.66),('5815','2013-08-08','15:50:00',1.2),('5815','2013-08-08','15:55:00',1.19),('5815','2013-08-08','16:55:00',1.19),('5815','2013-08-08','17:05:00',1.11),('5815','2013-08-07','09:05:00',1.01),('5815','2013-08-07','09:10:00',1.06),('5815','2013-08-07','09:15:00',1.11),('5815','2013-08-07','09:20:00',1.15),('5815','2013-08-07','09:25:00',1.19),('5815','2013-08-07','09:30:00',1.23),('5815','2013-08-07','09:35:00',1.28),('5815','2013-08-07','09:40:00',1.32),('5815','2013-08-07','09:45:00',1.36),('5815','2013-08-07','09:50:00',1.39),('5815','2013-08-07','09:55:00',1.41),('5815','2013-08-07','10:00:00',1.47),('5815','2013-08-07','10:05:00',1.5),('5815','2013-08-07','10:10:00',1.54),('5815','2013-08-07','10:15:00',1.57),('5815','2013-08-07','10:20:00',1.59),('5815','2013-08-07','10:25:00',1.62),('5815','2013-08-07','10:30:00',1.66),('5815','2013-08-07','10:35:00',1.68),('5815','2013-08-07','10:40:00',1.7),('5815','2013-08-07','10:45:00',1.73),('5815','2013-08-07','10:50:00',1.76),('5815','2013-08-07','10:55:00',1.79),('5815','2013-08-07','11:00:00',1.8),('5815','2013-08-07','11:05:00',1.82),('5815','2013-08-07','11:10:00',1.82),('5815','2013-08-07','11:15:00',1.82),('5815','2013-08-07','11:20:00',1.84),('5815','2013-08-07','11:25:00',1.87),('5815','2013-08-07','11:30:00',1.87),('5815','2013-08-07','11:35:00',1.9),('5815','2013-08-07','11:40:00',1.95),('5815','2013-08-07','11:45:00',1.96),('5815','2013-08-07','11:50:00',1.98),('5815','2013-08-07','11:55:00',1.98),('5815','2013-08-07','12:00:00',2),('5815','2013-08-07','12:05:00',2),('5815','2013-08-07','12:10:00',2),('5815','2013-08-07','12:15:00',2.03),('5815','2013-08-07','12:20:00',2.04),('5815','2013-08-07','12:25:00',2.07),('5815','2013-08-07','12:30:00',2.1),('5815','2013-08-07','12:35:00',2.12),('5815','2013-08-07','12:40:00',2.1),('5815','2013-08-07','12:45:00',2.08),('5815','2013-08-07','12:50:00',2.11),('5815','2013-08-07','12:55:00',2.13),('5815','2013-08-07','13:00:00',2.14),('5815','2013-08-07','13:05:00',2.16),('5815','2013-08-07','13:10:00',2.16),('5815','2013-08-07','13:15:00',2.16),('5815','2013-08-07','13:20:00',2.16),('5815','2013-08-07','13:25:00',2.17),('5815','2013-08-07','13:30:00',2.16),('5815','2013-08-07','13:35:00',2.15),('5815','2013-08-07','13:40:00',2.14),('5815','2013-08-07','13:45:00',2.12),('5815','2013-08-07','13:50:00',2.14),('5815','2013-08-07','13:55:00',2.11),('5815','2013-08-07','14:00:00',2.12),('5815','2013-08-07','14:05:00',2.12),('5815','2013-08-07','14:10:00',2.11),('5815','2013-08-07','14:15:00',2.08),('5815','2013-08-07','14:20:00',2.07),('5815','2013-08-07','14:25:00',2.06),('5815','2013-08-07','14:30:00',2.05),('5815','2013-08-07','14:35:00',2.04),('5815','2013-08-07','14:40:00',2.03),('5815','2013-08-07','14:45:00',2.01),('5815','2013-08-07','14:50:00',2),('5815','2013-08-07','14:55:00',1.97),('5815','2013-08-07','15:00:00',1.96),('5815','2013-08-07','15:05:00',1.92),('5815','2013-08-07','15:10:00',1.9),('5815','2013-08-07','15:15:00',1.9),('5815','2013-08-07','15:20:00',1.88),('5815','2013-08-07','15:25:00',1.85),('5815','2013-08-07','15:30:00',1.81),('5815','2013-08-07','15:35:00',1.79),('5815','2013-08-07','15:40:00',1.77),('5815','2013-08-07','15:45:00',1.76),('5815','2013-08-07','15:50:00',1.73),('5815','2013-08-07','15:55:00',1.7),('5815','2013-08-07','16:00:00',1.68),('5815','2013-08-07','16:05:00',1.66),('5815','2013-08-07','16:10:00',1.63),('5815','2013-08-07','16:15:00',1.6),('5815','2013-08-07','16:20:00',1.58),('5815','2013-08-07','16:25:00',1.56),('5815','2013-08-07','16:30:00',1.53),('5815','2013-08-07','16:35:00',1.49),('5815','2013-08-07','16:40:00',1.46),('5815','2013-08-07','16:45:00',1.41),('5815','2013-08-07','16:50:00',1.37),('5815','2013-08-07','16:55:00',1.33),('5815','2013-08-07','17:00:00',1.27),('5815','2013-08-07','17:05:00',1.23),('5815','2013-08-07','17:15:00',1.13),('5815','2013-08-07','17:20:00',1.09),('5815','2013-08-07','17:25:00',1.04),('5815','2013-08-06','09:05:00',1.03),('5815','2013-08-06','09:10:00',1.09),('5815','2013-08-06','09:15:00',1.13),('5815','2013-08-06','09:20:00',1.18),('5815','2013-08-06','09:25:00',1.21),('5815','2013-08-06','09:30:00',1.26),('5815','2013-08-06','09:35:00',1.3),('5815','2013-08-06','09:40:00',1.33),('5815','2013-08-06','09:45:00',1.35),('5815','2013-08-06','09:50:00',1.4),('5815','2013-08-06','09:55:00',1.44),('5815','2013-08-06','10:00:00',1.49),('5815','2013-08-06','10:05:00',1.5),('5815','2013-08-06','10:10:00',1.55),('5815','2013-08-06','10:15:00',1.58),('5815','2013-08-06','10:20:00',1.62),('5815','2013-08-06','10:25:00',1.65),('5815','2013-08-06','10:30:00',1.67),('5815','2013-08-06','10:35:00',1.68),('5815','2013-08-06','10:40:00',1.73),('5815','2013-08-06','10:45:00',1.77),('5815','2013-08-06','10:50:00',1.8),('5815','2013-08-06','10:55:00',1.81),('5815','2013-08-06','11:00:00',1.83),('5815','2013-08-06','11:05:00',1.84),('5815','2013-08-06','11:10:00',1.81),('5815','2013-08-06','11:15:00',1.83),('5815','2013-08-06','11:20:00',1.85),('5815','2013-08-06','11:25:00',1.87),('5815','2013-08-06','11:30:00',1.89),('5815','2013-08-06','11:35:00',1.93),('5815','2013-08-06','11:40:00',1.95),('5815','2013-08-06','11:45:00',1.97),('5815','2013-08-06','11:50:00',1.99),('5815','2013-08-06','11:55:00',1.99),('5815','2013-08-06','12:00:00',2.02),('5815','2013-08-06','12:05:00',2.03),('5815','2013-08-06','12:10:00',2.03),('5815','2013-08-06','12:15:00',2.05),('5815','2013-08-06','12:20:00',2.06),('5815','2013-08-06','12:25:00',2.05),('5815','2013-08-06','12:30:00',2.05),('5815','2013-08-06','12:35:00',2.09),('5815','2013-08-06','12:40:00',2.07),('5815','2013-08-06','12:45:00',2.07),('5815','2013-08-06','12:50:00',2.09),('5815','2013-08-06','12:55:00',2.09),('5815','2013-08-06','13:00:00',2.1),('5815','2013-08-06','13:05:00',2.13),('5815','2013-08-06','13:10:00',2.15),('5815','2013-08-06','13:15:00',2.13),('5815','2013-08-06','13:20:00',2.15),('5815','2013-08-06','13:25:00',2.12),('5815','2013-08-06','13:30:00',2.14),('5815','2013-08-06','13:35:00',2.07),('5815','2013-08-06','13:40:00',2.13),('5815','2013-08-06','13:45:00',2.15),('5815','2013-08-06','13:50:00',2.13),('5815','2013-08-06','13:55:00',2.15),('5815','2013-08-06','14:00:00',2.13),('5815','2013-08-06','14:05:00',2.14),('5815','2013-08-06','14:10:00',2.15),('5815','2013-08-06','14:15:00',2.07),('5815','2013-08-06','14:20:00',2.08),('5815','2013-08-06','14:25:00',2.04),('5815','2013-08-06','14:30:00',2.02),('5815','2013-08-06','14:35:00',2.02),('5815','2013-08-06','14:40:00',2.03),('5815','2013-08-06','14:45:00',2.06),('5815','2013-08-06','14:50:00',2.03),('5815','2013-08-06','14:55:00',2.01),('5815','2013-08-06','15:00:00',1.99),('5815','2013-08-06','15:05:00',1.95),('5815','2013-08-06','15:10:00',1.95),('5815','2013-08-06','15:15:00',1.93),('5815','2013-08-06','15:20:00',1.91),('5815','2013-08-06','15:25:00',1.88),('5815','2013-08-06','15:30:00',1.87),('5815','2013-08-06','15:35:00',1.84),('5815','2013-08-06','15:40:00',1.82),('5815','2013-08-06','15:45:00',1.79),('5815','2013-08-06','15:50:00',1.76),('5815','2013-08-06','15:55:00',1.74),('5815','2013-08-06','16:00:00',1.69),('5815','2013-08-06','16:05:00',1.68),('5815','2013-08-06','16:10:00',1.64),('5815','2013-08-06','16:15:00',1.61),('5815','2013-08-06','16:20:00',1.58),('5815','2013-08-06','16:25:00',1.54),('5815','2013-08-06','16:30:00',1.53),('5815','2013-08-06','16:35:00',1.51),('5815','2013-08-06','16:40:00',1.46),('5815','2013-08-06','16:45:00',1.43),('5815','2013-08-06','16:50:00',1.4),('5815','2013-08-06','16:55:00',1.35),('5815','2013-08-06','17:00:00',1.28),('5815','2013-08-06','17:05:00',1.25),('5815','2013-08-06','17:10:00',1.19),('5815','2013-08-06','17:15:00',1.14),('5815','2013-08-06','17:20:00',1.09),('5815','2013-08-06','17:25:00',1.07),('5815','2013-08-06','17:30:00',1.03),('5815','2013-08-05','09:05:00',1.02),('5815','2013-08-05','09:10:00',1.07),('5815','2013-08-05','09:15:00',1.11),('5815','2013-08-05','09:20:00',1.16),('5815','2013-08-05','09:25:00',1.19),('5815','2013-08-05','09:30:00',1.23),('5815','2013-08-05','09:35:00',1.28),('5815','2013-08-05','09:40:00',1.32),('5815','2013-08-05','09:45:00',1.36),('5815','2013-08-05','09:50:00',1.38),('5815','2013-08-05','09:55:00',1.42),('5815','2013-08-05','10:00:00',1.46),('5815','2013-08-05','10:05:00',1.5),('5815','2013-08-05','10:10:00',1.52),('5815','2013-08-05','10:15:00',1.56),('5815','2013-08-05','10:20:00',1.6),('5815','2013-08-05','10:25:00',1.62),('5815','2013-08-05','10:30:00',1.65),('5815','2013-08-05','10:35:00',1.67),('5815','2013-08-05','10:40:00',1.7),('5815','2013-08-05','10:45:00',1.72),('5815','2013-08-05','10:50:00',1.75),('5815','2013-08-05','10:55:00',1.77),('5815','2013-08-05','11:00:00',1.79),('5815','2013-08-05','11:05:00',1.82),('5815','2013-08-05','11:10:00',1.81),('5815','2013-08-05','11:15:00',1.83),('5815','2013-08-05','11:20:00',1.85),('5815','2013-08-05','11:25:00',1.86),('5815','2013-08-05','11:30:00',1.88),('5815','2013-08-05','11:35:00',1.9),('5815','2013-08-05','11:40:00',1.94),('5815','2013-08-05','11:45:00',1.96),('5815','2013-08-05','11:50:00',1.97),('5815','2013-08-05','11:55:00',1.99),('5815','2013-08-05','12:00:00',2.02),('5815','2013-08-05','12:05:00',2.02),('5815','2013-08-05','12:10:00',2.04),('5815','2013-08-05','12:15:00',2.05),('5815','2013-08-05','12:20:00',2.06),('5815','2013-08-05','12:25:00',2.04),('5815','2013-08-05','12:30:00',2.06),('5815','2013-08-05','12:35:00',2.07),('5815','2013-08-05','12:40:00',2.07),('5815','2013-08-05','12:45:00',2.05),('5815','2013-08-05','12:50:00',2.05),('5815','2013-08-05','12:55:00',2.07),('5815','2013-08-05','13:00:00',2.1),('5815','2013-08-05','13:05:00',2.12),('5815','2013-08-05','13:10:00',2.11),('5815','2013-08-05','13:15:00',2.14),('5815','2013-08-05','13:20:00',2.13),('5815','2013-08-05','13:25:00',2.16),('5815','2013-08-05','13:30:00',2.16),('5815','2013-08-05','13:35:00',2.18),('5815','2013-08-05','13:40:00',2.17),('5815','2013-08-05','13:45:00',2.18),('5815','2013-08-05','13:50:00',2.19),('5815','2013-08-05','13:55:00',2.19),('5815','2013-08-05','14:00:00',2.2),('5815','2013-08-05','14:05:00',2.19),('5815','2013-08-05','14:10:00',2.19),('5815','2013-08-05','14:15:00',2.19),('5815','2013-08-05','14:20:00',2.17),('5815','2013-08-05','14:25:00',2.16),('5815','2013-08-05','14:30:00',2.17),('5815','2013-08-05','14:35:00',2.14),('5815','2013-08-05','14:40:00',2.12),('5815','2013-08-05','14:45:00',2.11),('5815','2013-08-05','14:50:00',2.1),('5815','2013-08-05','14:55:00',2.09),('5815','2013-08-05','15:00:00',2.08),('5815','2013-08-05','15:05:00',2.07),('5815','2013-08-05','15:10:00',2.04),('5815','2013-08-05','15:15:00',2.02),('5815','2013-08-05','15:20:00',2),('5815','2013-08-05','15:25:00',1.97),('5815','2013-08-05','15:30:00',1.95),('5815','2013-08-05','15:35:00',1.93),('5815','2013-08-05','15:40:00',1.88),('5815','2013-08-05','15:45:00',1.87),('5815','2013-08-05','15:50:00',1.85),('5815','2013-08-05','15:55:00',1.82),('5815','2013-08-05','16:00:00',1.78),('5815','2013-08-05','16:05:00',1.75),('5815','2013-08-05','16:10:00',1.72),('5815','2013-08-05','16:15:00',1.68),('5815','2013-08-05','16:20:00',1.65),('5815','2013-08-05','16:25:00',1.61),('5815','2013-08-05','16:30:00',1.59),('5815','2013-08-05','16:35:00',1.55),('5815','2013-08-05','16:40:00',1.5),('5815','2013-08-05','16:45:00',1.45),('5815','2013-08-05','16:50:00',1.43),('5815','2013-08-05','16:55:00',1.37),('5815','2013-08-05','17:00:00',1.31),('5815','2013-08-05','17:05:00',1.28),('5815','2013-08-05','17:10:00',1.23),('5815','2013-08-05','17:15:00',1.18),('5815','2013-08-05','17:20:00',1.13),('5815','2013-08-05','17:25:00',1.08),('5815','2013-08-05','17:30:00',1.04),('5815','2013-08-04','09:00:00',1.01),('5815','2013-08-04','09:05:00',1.06),('5815','2013-08-04','09:10:00',1.1),('5815','2013-08-04','09:15:00',1.14),('5815','2013-08-04','09:20:00',1.18),('5815','2013-08-04','09:25:00',1.22),('5815','2013-08-04','09:30:00',1.26),('5815','2013-08-04','09:35:00',1.3),('5815','2013-08-04','09:40:00',1.33),('5815','2013-08-04','09:45:00',1.37),('5815','2013-08-04','09:50:00',1.4),('5815','2013-08-04','09:55:00',1.45),('5815','2013-08-04','10:00:00',1.48),('5815','2013-08-04','10:05:00',1.52),('5815','2013-08-04','10:10:00',1.56),('5815','2013-08-04','10:15:00',1.59),('5815','2013-08-04','10:20:00',1.62),('5815','2013-08-04','10:25:00',1.64),('5815','2013-08-04','10:30:00',1.68),('5815','2013-08-04','10:35:00',1.71),('5815','2013-08-04','10:40:00',1.74),('5815','2013-08-04','10:45:00',1.77),('5815','2013-08-04','10:50:00',1.8),('5815','2013-08-04','10:55:00',1.83),('5815','2013-08-04','11:00:00',1.84),('5815','2013-08-04','11:05:00',1.87),('5815','2013-08-04','11:10:00',1.85),('5815','2013-08-04','11:15:00',1.87),('5815','2013-08-04','11:20:00',1.9),('5815','2013-08-04','11:25:00',1.92),('5815','2013-08-04','11:30:00',1.93),('5815','2013-08-04','11:35:00',1.96),('5815','2013-08-04','11:40:00',1.95),('5815','2013-08-04','11:45:00',2.04),('5815','2013-08-04','11:50:00',2.04),('5815','2013-08-04','11:55:00',2.04),('5815','2013-08-04','12:00:00',2.05),('5815','2013-08-04','12:05:00',2.07),('5815','2013-08-04','12:10:00',2.09),('5815','2013-08-04','12:15:00',2.08),('5815','2013-08-04','12:20:00',2.1),('5815','2013-08-04','12:25:00',2.11),('5815','2013-08-04','12:30:00',2.12),('5815','2013-08-04','12:35:00',2.12),('5815','2013-08-04','12:40:00',2.15),('5815','2013-08-04','12:45:00',2.18),('5815','2013-08-04','12:50:00',2.16),('5815','2013-08-04','12:55:00',2.16),('5815','2013-08-04','13:00:00',2.18),('5815','2013-08-04','13:05:00',2.19),('5815','2013-08-04','13:10:00',1.67),('5815','2013-08-04','13:15:00',2.14),('5815','2013-08-04','13:20:00',2.16),('5815','2013-08-04','13:25:00',2.16),('5815','2013-08-04','13:30:00',2.15),('5815','2013-08-04','13:35:00',2.16),('5815','2013-08-04','13:40:00',2.15),('5815','2013-08-04','13:45:00',2.16),('5815','2013-08-04','13:50:00',2.16),('5815','2013-08-04','13:55:00',2.11),('5815','2013-08-04','14:00:00',2.11),('5815','2013-08-04','14:05:00',2.14),('5815','2013-08-04','14:10:00',2.11),('5815','2013-08-04','14:15:00',2.1),('5815','2013-08-04','14:20:00',2.11),('5815','2013-08-04','14:25:00',2.07),('5815','2013-08-04','14:30:00',2.08),('5815','2013-08-04','14:35:00',2.07),('5815','2013-08-04','14:40:00',2.06),('5815','2013-08-04','14:45:00',2.06),('5815','2013-08-04','14:50:00',2.03),('5815','2013-08-04','14:55:00',2.02),('5815','2013-08-04','15:00:00',2),('5815','2013-08-04','15:05:00',2),('5815','2013-08-04','15:10:00',1.99),('5815','2013-08-04','15:15:00',1.98),('5815','2013-08-04','15:20:00',1.96),('5815','2013-08-04','15:25:00',1.94),('5815','2013-08-04','15:30:00',1.92),('5815','2013-08-04','15:35:00',1.9),('5815','2013-08-04','15:40:00',1.86),('5815','2013-08-04','15:45:00',1.83),('5815','2013-08-04','15:50:00',1.79),('5815','2013-08-04','15:55:00',1.76),('5815','2013-08-04','16:00:00',1.76),('5815','2013-08-04','16:05:00',1.76),('5815','2013-08-04','16:10:00',1.71),('5815','2013-08-04','16:15:00',1.66),('5815','2013-08-04','16:20:00',1.62),('5815','2013-08-04','16:25:00',1.59),('5815','2013-08-04','16:30:00',1.56),('5815','2013-08-04','16:35:00',1.53),('5815','2013-08-04','16:40:00',1.48),('5815','2013-08-04','16:45:00',1.44),('5815','2013-08-04','16:50:00',1.41),('5815','2013-08-04','16:55:00',1.34),('5815','2013-08-04','17:00:00',1.29),('5815','2013-08-04','17:05:00',1.25),('5815','2013-08-04','17:10:00',1.22),('5815','2013-08-04','17:15:00',1.13),('5815','2013-08-04','17:20:00',1.07),('5815','2013-08-04','17:25:00',1.05),('5815','2013-08-03','08:55:00',1.01),('5815','2013-08-03','09:00:00',1.06),('5815','2013-08-03','09:05:00',1.1),('5815','2013-08-03','09:10:00',1.15),('5815','2013-08-03','09:15:00',1.19),('5815','2013-08-03','09:20:00',1.23),('5815','2013-08-03','09:25:00',1.28),('5815','2013-08-03','09:30:00',1.33),('5815','2013-08-03','09:35:00',1.34),('5815','2013-08-03','09:40:00',1.4),('5815','2013-08-03','09:45:00',1.45),('5815','2013-08-03','09:50:00',1.48),('5815','2013-08-03','09:55:00',1.51),('5815','2013-08-03','10:00:00',1.55),('5815','2013-08-03','10:05:00',1.59),('5815','2013-08-03','10:10:00',1.61),('5815','2013-08-03','10:15:00',1.65),('5815','2013-08-03','10:20:00',1.69),('5815','2013-08-03','10:25:00',1.73),('5815','2013-08-03','10:30:00',1.75),('5815','2013-08-03','10:35:00',1.78),('5815','2013-08-03','10:40:00',1.8),('5815','2013-08-03','10:45:00',1.83),('5815','2013-08-03','10:50:00',1.86),('5815','2013-08-03','10:55:00',1.88),('5815','2013-08-03','11:00:00',1.89),('5815','2013-08-03','11:05:00',1.89),('5815','2013-08-03','11:10:00',1.85),('5815','2013-08-03','11:15:00',1.9),('5815','2013-08-03','11:20:00',1.93),('5815','2013-08-03','11:25:00',1.97),('5815','2013-08-03','11:30:00',1.99),('5815','2013-08-03','11:35:00',2.01),('5815','2013-08-03','11:40:00',2.05),('5815','2013-08-03','11:45:00',2.07),('5815','2013-08-03','11:50:00',2.07),('5815','2013-08-03','11:55:00',2.09),('5815','2013-08-03','12:00:00',2.1),('5815','2013-08-03','12:05:00',2.11),('5815','2013-08-03','12:10:00',2.13),('5815','2013-08-03','12:15:00',2.12),('5815','2013-08-03','12:20:00',2.14),('5815','2013-08-03','12:25:00',2.14),('5815','2013-08-03','12:30:00',2.15),('5815','2013-08-03','12:35:00',2.17),('5815','2013-08-03','12:40:00',2.18),('5815','2013-08-03','12:45:00',2.18),('5815','2013-08-03','12:50:00',2.2),('5815','2013-08-03','12:55:00',2.16),('5815','2013-08-03','13:00:00',2.18),('5815','2013-08-03','13:05:00',2.21),('5815','2013-08-03','13:10:00',2.19),('5815','2013-08-03','13:15:00',2.19),('5815','2013-08-03','13:20:00',2.19),('5815','2013-08-03','13:25:00',2.17),('5815','2013-08-03','13:30:00',2.19),('5815','2013-08-03','13:35:00',2.22),('5815','2013-08-03','13:40:00',2.23),('5815','2013-08-03','13:45:00',2.24),('5815','2013-08-03','13:50:00',2.25),('5815','2013-08-03','13:55:00',2.22),('5815','2013-08-03','14:00:00',2.23),('5815','2013-08-03','14:05:00',2.24),('5815','2013-08-03','14:10:00',2.22),('5815','2013-08-03','14:15:00',2.22),('5815','2013-08-03','14:20:00',2.2),('5815','2013-08-03','14:25:00',2.19),('5815','2013-08-03','14:30:00',2.17),('5815','2013-08-03','14:35:00',2.17),('5815','2013-08-03','14:40:00',2.17),('5815','2013-08-03','14:45:00',2.15),('5815','2013-08-03','14:50:00',2.13),('5815','2013-08-03','14:55:00',2.11),('5815','2013-08-03','15:00:00',2.09),('5815','2013-08-03','15:05:00',2.08),('5815','2013-08-03','15:10:00',2.06),('5815','2013-08-03','15:15:00',2.05),('5815','2013-08-03','15:20:00',2.03),('5815','2013-08-03','15:25:00',1.97),('5815','2013-08-03','15:30:00',1.95),('5815','2013-08-03','15:35:00',1.96),('5815','2013-08-03','15:40:00',1.92),('5815','2013-08-03','15:45:00',1.89),('5815','2013-08-03','15:50:00',1.86),('5815','2013-08-03','15:55:00',1.83),('5815','2013-08-03','16:00:00',1.8),('5815','2013-08-03','16:05:00',1.77),('5815','2013-08-03','16:10:00',1.74),('5815','2013-08-03','16:15:00',1.71),('5815','2013-08-03','16:20:00',1.69),('5815','2013-08-03','16:25:00',1.66),('5815','2013-08-03','16:30:00',1.62),('5815','2013-08-03','16:35:00',1.56),('5815','2013-08-03','16:40:00',1.51),('5815','2013-08-03','16:45:00',1.47),('5815','2013-08-03','16:50:00',1.44),('5815','2013-08-03','16:55:00',1.38),('5815','2013-08-03','17:00:00',1.32),('5815','2013-08-03','17:05:00',1.29),('5815','2013-08-03','17:10:00',1.27),('5815','2013-08-03','17:15:00',1.22),('5815','2013-08-03','17:20:00',1.17),('5815','2013-08-03','17:25:00',1.11),('5815','2013-08-03','17:30:00',1),('5815','2013-08-02','08:55:00',1),('5815','2013-08-02','09:00:00',1.06),('5815','2013-08-02','09:05:00',1.1),('5815','2013-08-02','09:10:00',1.14),('5815','2013-08-02','09:15:00',1.19),('5815','2013-08-02','09:20:00',1.23),('5815','2013-08-02','09:25:00',1.28),('5815','2013-08-02','09:30:00',1.31),('5815','2013-08-02','09:35:00',1.35),('5815','2013-08-02','09:40:00',1.39),('5815','2013-08-02','09:45:00',1.43),('5815','2013-08-02','09:50:00',1.46),('5815','2013-08-02','09:55:00',1.51),('5815','2013-08-02','10:00:00',1.54),('5815','2013-08-02','10:05:00',1.57),('5815','2013-08-02','10:10:00',1.61),('5815','2013-08-02','10:15:00',1.65),('5815','2013-08-02','10:20:00',1.68),('5815','2013-08-02','10:25:00',1.71),('5815','2013-08-02','10:30:00',1.73),('5815','2013-08-02','10:35:00',1.74),('5815','2013-08-02','10:40:00',1.8),('5815','2013-08-02','10:45:00',1.85),('5815','2013-08-02','10:50:00',1.87),('5815','2013-08-02','10:55:00',1.9),('5815','2013-08-02','11:00:00',1.92),('5815','2013-08-02','11:05:00',1.91),('5815','2013-08-02','11:10:00',1.86),('5815','2013-08-02','11:15:00',1.88),('5815','2013-08-02','11:20:00',1.89),('5815','2013-08-02','11:25:00',1.95),('5815','2013-08-02','11:30:00',1.97),('5815','2013-08-02','11:35:00',2),('5815','2013-08-02','11:40:00',2.01),('5815','2013-08-02','11:45:00',2.03),('5815','2013-08-02','11:50:00',2.05),('5815','2013-08-02','11:55:00',2.06),('5815','2013-08-02','12:00:00',2.07),('5815','2013-08-02','12:05:00',2.11),('5815','2013-08-02','12:10:00',2.11),('5815','2013-08-02','12:15:00',2.13),('5815','2013-08-02','12:20:00',2.14),('5815','2013-08-02','12:25:00',2.15),('5815','2013-08-02','12:30:00',2.17),('5815','2013-08-02','12:35:00',2.15),('5815','2013-08-02','12:40:00',2.17),('5815','2013-08-02','12:45:00',2.17),('5815','2013-08-02','12:50:00',2.18),('5815','2013-08-02','12:55:00',2.2),('5815','2013-08-02','13:00:00',2.18),('5815','2013-08-02','13:05:00',2.15),('5815','2013-08-02','13:10:00',2.14),('5815','2013-08-02','13:15:00',2.13),('5815','2013-08-02','13:20:00',2.11),('5815','2013-08-02','13:25:00',1.69),('5815','2013-08-02','13:30:00',2.12),('5815','2013-08-02','13:35:00',2.09),('5815','2013-08-02','13:40:00',2.15),('5815','2013-08-02','13:45:00',2.17),('5815','2013-08-02','13:50:00',2.16),('5815','2013-08-02','13:55:00',2.17),('5815','2013-08-02','14:00:00',2.19),('5815','2013-08-02','14:05:00',2.16),('5815','2013-08-02','14:10:00',2.1),('5815','2013-08-02','14:15:00',2.06),('5815','2013-08-02','14:20:00',2.02),('5815','2013-08-02','14:25:00',2.04),('5815','2013-08-02','14:30:00',2.08),('5815','2013-08-02','14:35:00',2.12),('5815','2013-08-02','14:40:00',2.1),('5815','2013-08-02','14:45:00',2.11),('5815','2013-08-02','14:50:00',2.1),('5815','2013-08-02','14:55:00',2.09),('5815','2013-08-02','15:00:00',2.07),('5815','2013-08-02','15:05:00',2.03),('5815','2013-08-02','15:10:00',2.02),('5815','2013-08-02','15:15:00',1.99),('5815','2013-08-02','15:20:00',2),('5815','2013-08-02','15:25:00',1.99),('5815','2013-08-02','15:30:00',1.97),('5815','2013-08-02','15:35:00',1.92),('5815','2013-08-02','15:40:00',1.92),('5815','2013-08-02','15:45:00',1.89),('5815','2013-08-02','15:50:00',1.88),('5815','2013-08-02','15:55:00',1.84),('5815','2013-08-02','16:00:00',1.8),('5815','2013-08-02','16:05:00',1.76),('5815','2013-08-02','16:10:00',1.71),('5815','2013-08-02','16:15:00',1.66),('5815','2013-08-02','16:20:00',1.62),('5815','2013-08-02','16:25:00',1.61),('5815','2013-08-02','16:30:00',1.59),('5815','2013-08-02','16:35:00',1.53),('5815','2013-08-02','16:40:00',1.48),('5815','2013-08-02','16:45:00',1.45),('5815','2013-08-02','16:50:00',1.42),('5815','2013-08-02','16:55:00',1.35),('5815','2013-08-02','17:00:00',1.28),('5815','2013-08-02','17:05:00',1.23),('5815','2013-08-02','17:10:00',1.24),('5815','2013-08-02','17:15:00',1.2),('5815','2013-08-02','17:20:00',1.16),('5815','2013-08-02','17:25:00',1.1),('5815','2013-08-02','17:30:00',1.01),('5815','2013-08-01','08:55:00',1.04),('5815','2013-08-01','09:00:00',1.09),('5815','2013-08-01','09:05:00',1.13),('5815','2013-08-01','09:10:00',1.18),('5815','2013-08-01','09:15:00',1.23),('5815','2013-08-01','09:20:00',1.27),('5815','2013-08-01','09:25:00',1.31),('5815','2013-08-01','09:30:00',1.35),('5815','2013-08-01','09:35:00',1.4),('5815','2013-08-01','09:40:00',1.43),('5815','2013-08-01','09:45:00',1.47),('5815','2013-08-01','09:50:00',1.5),('5815','2013-08-01','09:55:00',1.53),('5815','2013-08-01','10:00:00',1.56),('5815','2013-08-01','10:05:00',1.61),('5815','2013-08-01','10:10:00',1.64),('5815','2013-08-01','10:15:00',1.67),('5815','2013-08-01','10:20:00',1.67),('5815','2013-08-01','10:25:00',1.73),('5815','2013-08-01','10:30:00',1.77),('5815','2013-08-01','10:35:00',1.8),('5815','2013-08-01','10:40:00',1.82),('5815','2013-08-01','10:45:00',1.85),('5815','2013-08-01','10:50:00',1.88),('5815','2013-08-01','10:55:00',1.89),('5815','2013-08-01','11:00:00',1.91),('5815','2013-08-01','11:05:00',1.9),('5815','2013-08-01','11:10:00',1.9),('5815','2013-08-01','11:15:00',1.92),('5815','2013-08-01','11:20:00',1.95),('5815','2013-08-01','11:25:00',1.97),('5815','2013-08-01','11:30:00',1.99),('5815','2013-08-01','11:35:00',2),('5815','2013-08-01','11:40:00',2.02),('5815','2013-08-01','11:45:00',2.05),('5815','2013-08-01','11:50:00',2.06),('5815','2013-08-01','11:55:00',2.09),('5815','2013-08-01','12:00:00',2.1),('5815','2013-08-01','12:05:00',2.11),('5815','2013-08-01','12:10:00',2.12),('5815','2013-08-01','12:15:00',2.13),('5815','2013-08-01','12:20:00',2.14),('5815','2013-08-01','12:25:00',2.14),('5815','2013-08-01','12:30:00',2.15),('5815','2013-08-01','12:35:00',2.18),('5815','2013-08-01','12:40:00',2.18),('5815','2013-08-01','12:45:00',2.19),('5815','2013-08-01','12:50:00',2.18),('5815','2013-08-01','12:55:00',2.18),('5815','2013-08-01','13:00:00',2.2),('5815','2013-08-01','13:05:00',2.21),('5815','2013-08-01','13:10:00',2.24),('5815','2013-08-01','13:15:00',2.24),('5815','2013-08-01','13:20:00',2.22),('5815','2013-08-01','13:25:00',2.2),('5815','2013-08-01','13:30:00',2.22),('5815','2013-08-01','13:35:00',2.22),('5815','2013-08-01','13:40:00',2.2),('5815','2013-08-01','13:45:00',2.18),('5815','2013-08-01','13:50:00',2.18),('5815','2013-08-01','13:55:00',2.19),('5815','2013-08-01','14:00:00',2.18),('5815','2013-08-01','14:05:00',2.17),('5815','2013-08-01','14:10:00',2.16),('5815','2013-08-01','14:15:00',2.16),('5815','2013-08-01','14:20:00',2.11),('5815','2013-08-01','14:25:00',2.08),('5815','2013-08-01','14:30:00',2.13),('5815','2013-08-01','14:35:00',2.13),('5815','2013-08-01','14:40:00',2.12),('5815','2013-08-01','14:45:00',2.14),('5815','2013-08-01','14:50:00',2.13),('5815','2013-08-01','14:55:00',2.13),('5815','2013-08-01','15:00:00',2.12),('5815','2013-08-01','15:05:00',2.1),('5815','2013-08-01','15:10:00',2.06),('5815','2013-08-01','15:15:00',2.01),('5815','2013-08-01','15:20:00',2.02),('5815','2013-08-01','15:25:00',2.02),('5815','2013-08-01','15:30:00',2),('5815','2013-08-01','15:35:00',1.98),('5815','2013-08-01','15:40:00',1.97),('5815','2013-08-01','15:45:00',1.95),('5815','2013-08-01','15:50:00',1.91),('5815','2013-08-01','15:55:00',1.86),('5815','2013-08-01','16:00:00',1.83),('5815','2013-08-01','16:05:00',1.81),('5815','2013-08-01','16:10:00',1.77),('5815','2013-08-01','16:15:00',1.71),('5815','2013-08-01','16:20:00',1.68),('5815','2013-08-01','16:25:00',1.65),('5815','2013-08-01','16:30:00',1.63),('5815','2013-08-01','16:35:00',1.57),('5815','2013-08-01','16:40:00',1.53),('5815','2013-08-01','16:45:00',1.5),('5815','2013-08-01','16:50:00',1.48),('5815','2013-08-01','16:55:00',1.39),('5815','2013-08-01','17:00:00',1.31),('5815','2013-08-01','17:05:00',1.25),('5815','2013-08-01','17:10:00',1.27),('5815','2013-08-01','17:15:00',1.24),('5815','2013-08-01','17:20:00',1.18),('5815','2013-08-01','17:25:00',1.15),('5815','2013-08-01','17:30:00',1.05),('5815','2013-08-01','17:40:00',1.01),('5815','2013-07-31','08:50:00',1.01),('5815','2013-07-31','08:55:00',1.06),('5815','2013-07-31','09:00:00',1.11),('5815','2013-07-31','09:05:00',1.15),('5815','2013-07-31','09:10:00',1.21),('5815','2013-07-31','09:15:00',1.25),('5815','2013-07-31','09:20:00',1.3),('5815','2013-07-31','09:25:00',1.34),('5815','2013-07-31','09:30:00',1.38),('5815','2013-07-31','09:35:00',1.43),('5815','2013-07-31','09:40:00',1.47),('5815','2013-07-31','09:45:00',1.51),('5815','2013-07-31','09:50:00',1.54),('5815','2013-07-31','09:55:00',1.59),('5815','2013-07-31','10:00:00',1.63),('5815','2013-07-31','10:05:00',1.67),('5815','2013-07-31','10:10:00',1.71),('5815','2013-07-31','10:15:00',1.74),('5815','2013-07-31','10:20:00',1.77),('5815','2013-07-31','10:25:00',1.8),('5815','2013-07-31','10:30:00',1.84),('5815','2013-07-31','10:35:00',1.86),('5815','2013-07-31','10:40:00',1.88),('5815','2013-07-31','10:45:00',1.92),('5815','2013-07-31','10:50:00',1.96),('5815','2013-07-31','10:55:00',1.97),('5815','2013-07-31','11:00:00',1.99),('5815','2013-07-31','11:05:00',1.99),('5815','2013-07-31','11:10:00',2.01),('5815','2013-07-31','11:15:00',2.03),('5815','2013-07-31','11:20:00',2.04),('5815','2013-07-31','11:25:00',2.08),('5815','2013-07-31','11:30:00',2.1),('5815','2013-07-31','11:35:00',2.11),('5815','2013-07-31','11:40:00',2.13),('5815','2013-07-31','11:45:00',2.16),('5815','2013-07-31','11:50:00',2.17),('5815','2013-07-31','11:55:00',2.17),('5815','2013-07-31','12:00:00',2.19),('5815','2013-07-31','12:05:00',2.21),('5815','2013-07-31','12:10:00',2.22),('5815','2013-07-31','12:15:00',2.25),('5815','2013-07-31','12:20:00',2.25),('5815','2013-07-31','12:25:00',2.25),('5815','2013-07-31','12:30:00',2.28),('5815','2013-07-31','12:35:00',2.3),('5815','2013-07-31','12:40:00',2.32),('5815','2013-07-31','12:45:00',2.31),('5815','2013-07-31','12:50:00',2.32),('5815','2013-07-31','12:55:00',2.31),('5815','2013-07-31','13:00:00',2.31),('5815','2013-07-31','13:05:00',2.3),('5815','2013-07-31','13:10:00',2.31),('5815','2013-07-31','13:15:00',2.26),('5815','2013-07-31','13:20:00',2.33),('5815','2013-07-31','13:25:00',2.35),('5815','2013-07-31','13:30:00',2.21),('5815','2013-07-31','13:35:00',2.32),('5815','2013-07-31','13:40:00',2.33),('5815','2013-07-31','13:45:00',2.3),('5815','2013-07-31','13:50:00',2.22),('5815','2013-07-31','13:55:00',2.28),('5815','2013-07-31','14:00:00',2.19),('5815','2013-07-31','14:05:00',2.29),('5815','2013-07-31','14:10:00',2.22),('5815','2013-07-31','14:15:00',2.25),('5815','2013-07-31','14:20:00',2.16),('5815','2013-07-31','14:25:00',2.21),('5815','2013-07-31','14:30:00',2.2),('5815','2013-07-31','14:35:00',1.77),('5815','2013-07-31','14:40:00',2.1),('5815','2013-07-31','14:45:00',1.82),('5815','2013-07-31','14:50:00',1.89),('5815','2013-07-31','14:55:00',2.16),('5815','2013-07-31','15:00:00',2.12),('5815','2013-07-31','15:05:00',2.13),('5815','2013-07-31','15:10:00',1.79),('5815','2013-07-31','15:15:00',1.93),('5815','2013-07-31','15:20:00',2.12),('5815','2013-07-31','15:25:00',2.06),('5815','2013-07-31','15:30:00',2.02),('5815','2013-07-31','15:35:00',1.72),('5815','2013-07-31','15:40:00',1.28),('5815','2013-07-31','15:45:00',1.97),('5815','2013-07-31','15:50:00',1.93),('5815','2013-07-31','15:55:00',1.92),('5815','2013-07-31','16:00:00',1.89),('5815','2013-07-31','16:05:00',1.82),('5815','2013-07-31','16:10:00',1.75),('5815','2013-07-31','16:15:00',1.72),('5815','2013-07-31','16:20:00',1.69),('5815','2013-07-31','16:25:00',1.68),('5815','2013-07-31','16:30:00',1.63),('5815','2013-07-31','16:35:00',1.58),('5815','2013-07-31','16:40:00',1.55),('5815','2013-07-31','16:45:00',1.5),('5815','2013-07-31','16:50:00',1.46),('5815','2013-07-31','16:55:00',1.39),('5815','2013-07-31','17:00:00',1.31),('5815','2013-07-31','17:05:00',1.29),('5815','2013-07-31','17:10:00',1.3),('5815','2013-07-31','17:15:00',1.26),('5815','2013-07-31','17:20:00',1.22),('5815','2013-07-31','17:25:00',1.15),('5815','2013-07-31','17:30:00',1.06),('5815','2013-07-31','17:40:00',1.03),('5815','2013-07-30','08:50:00',1.03),('5815','2013-07-30','08:55:00',1.08),('5815','2013-07-30','09:00:00',1.12),('5815','2013-07-30','09:05:00',1.17),('5815','2013-07-30','09:10:00',1.22),('5815','2013-07-30','09:15:00',1.26),('5815','2013-07-30','09:20:00',1.31),('5815','2013-07-30','09:25:00',1.35),('5815','2013-07-30','09:30:00',1.4),('5815','2013-07-30','09:35:00',1.42),('5815','2013-07-30','09:40:00',1.47),('5815','2013-07-30','09:45:00',1.52),('5815','2013-07-30','09:50:00',1.56),('5815','2013-07-30','09:55:00',1.6),('5815','2013-07-30','10:00:00',1.63),('5815','2013-07-30','10:05:00',1.67),('5815','2013-07-30','10:10:00',1.7),('5815','2013-07-30','10:15:00',1.75),('5815','2013-07-30','10:20:00',1.77),('5815','2013-07-30','10:25:00',1.79),('5815','2013-07-30','10:30:00',1.82),('5815','2013-07-30','10:35:00',1.87),('5815','2013-07-30','10:40:00',1.9),('5815','2013-07-30','10:45:00',1.94),('5815','2013-07-30','10:50:00',1.96),('5815','2013-07-30','10:55:00',1.99),('5815','2013-07-30','11:00:00',2.03),('5815','2013-07-30','11:05:00',2),('5815','2013-07-30','11:10:00',2.02),('5815','2013-07-30','11:15:00',2.04),('5815','2013-07-30','11:20:00',2.06),('5815','2013-07-30','11:25:00',2.08),('5815','2013-07-30','11:30:00',2.09),('5815','2013-07-30','11:35:00',2.11),('5815','2013-07-30','11:40:00',2.13),('5815','2013-07-30','11:45:00',2.15),('5815','2013-07-30','11:50:00',2.18),('5815','2013-07-30','11:55:00',2.2),('5815','2013-07-30','12:00:00',2.2),('5815','2013-07-30','12:05:00',2.21),('5815','2013-07-30','12:10:00',2.21),('5815','2013-07-30','12:15:00',2.23),('5815','2013-07-30','12:20:00',2.22),('5815','2013-07-30','12:25:00',2.3),('5815','2013-07-30','12:30:00',2.3),('5815','2013-07-30','12:35:00',2.32),('5815','2013-07-30','12:40:00',2.34),('5815','2013-07-30','12:45:00',1.69),('5815','2013-07-30','12:50:00',1.78),('5815','2013-07-30','12:55:00',2.42),('5815','2013-07-30','13:00:00',1.03),('5815','2013-07-30','13:05:00',2.48),('5815','2013-07-30','13:10:00',2.28),('5815','2013-07-30','13:15:00',2.38),('5815','2013-07-30','13:20:00',2.17),('5815','2013-07-30','13:25:00',2.32),('5815','2013-07-30','13:30:00',2.36),('5815','2013-07-30','13:35:00',2.3),('5815','2013-07-30','13:40:00',2.4),('5815','2013-07-30','13:45:00',2.44),('5815','2013-07-30','13:50:00',2),('5815','2013-07-30','13:55:00',1.2),('5815','2013-07-30','14:00:00',2.05),('5815','2013-07-30','14:05:00',2.4),('5815','2013-07-30','14:10:00',1.93),('5815','2013-07-30','14:15:00',2.17),('5815','2013-07-30','14:20:00',2.38),('5815','2013-07-30','14:25:00',2.34),('5815','2013-07-30','14:30:00',2.28),('5815','2013-07-30','14:35:00',2.25),('5815','2013-07-30','14:40:00',2.26),('5815','2013-07-30','14:45:00',2.24),('5815','2013-07-30','14:50:00',1.76),('5815','2013-07-30','15:00:00',1.2),('5815','2013-07-30','15:05:00',2.13),('5815','2013-07-30','15:10:00',1.59),('5815','2013-07-30','15:15:00',1.14),('5815','2013-07-30','15:20:00',2.04),('5815','2013-07-30','15:25:00',1.9),('5815','2013-07-30','15:30:00',2.11),('5815','2013-07-30','15:35:00',1.75),('5815','2013-07-30','15:40:00',2.02),('5815','2013-07-30','15:45:00',1.97),('5815','2013-07-30','15:50:00',1.93),('5815','2013-07-30','15:55:00',1.88),('5815','2013-07-30','16:00:00',1.84),('5815','2013-07-30','16:05:00',1.82),('5815','2013-07-30','16:10:00',1.79),('5815','2013-07-30','16:15:00',1.76),('5815','2013-07-30','16:20:00',1.62),('5815','2013-07-30','16:25:00',1.7),('5815','2013-07-30','16:40:00',1.52),('5815','2013-07-30','16:45:00',1.48),('5815','2013-07-30','16:50:00',1.48),('5815','2013-07-30','16:55:00',1.4),('5815','2013-07-30','17:00:00',1.19),('5815','2013-07-30','17:05:00',1.35),('5815','2013-07-30','17:10:00',1.27),('5815','2013-07-30','17:20:00',1.21),('5815','2013-07-30','17:25:00',1.17),('5815','2013-07-30','17:30:00',1.06),('5815','2013-07-30','17:35:00',1.03),('5815','2013-07-30','17:40:00',1.02),('5815','2013-07-29','08:50:00',1.01),('5815','2013-07-29','08:55:00',1.08),('5815','2013-07-29','09:00:00',1.13),('5815','2013-07-29','09:05:00',1.17),('5815','2013-07-29','09:10:00',1.19),('5815','2013-07-29','09:15:00',1.28),('5815','2013-07-29','09:20:00',1.37),('5815','2013-07-29','09:25:00',1.43),('5815','2013-07-29','09:30:00',1.48),('5815','2013-07-29','09:35:00',1.54),('5815','2013-07-29','09:40:00',1.57),('5815','2013-07-29','09:45:00',1.62),('5815','2013-07-29','09:50:00',1.63),('5815','2013-07-29','09:55:00',1.65),('5815','2013-07-29','10:00:00',1.64),('5815','2013-07-29','10:05:00',1.72),('5815','2013-07-29','10:10:00',1.76),('5815','2013-07-29','10:15:00',1.45),('5815','2013-07-29','10:20:00',1.6),('5815','2013-07-29','10:25:00',1.86),('5815','2013-07-29','10:30:00',1.88),('5815','2013-07-29','10:35:00',1.91),('5815','2013-07-29','10:40:00',1.9),('5815','2013-07-29','10:45:00',1.93),('5815','2013-07-29','10:50:00',1.93),('5815','2013-07-29','10:55:00',1.95),('5815','2013-07-29','11:00:00',1.99),('5815','2013-07-29','11:05:00',2.01),('5815','2013-07-29','11:10:00',2.02),('5815','2013-07-29','11:15:00',2.06),('5815','2013-07-29','11:20:00',2),('5815','2013-07-29','11:25:00',1.98),('5815','2013-07-29','11:30:00',1.97),('5815','2013-07-29','11:35:00',1.12),('5815','2013-07-29','11:40:00',1.89),('5815','2013-07-29','11:45:00',2.17),('5815','2013-07-29','11:50:00',2.18),('5815','2013-07-29','11:55:00',2.16),('5815','2013-07-29','12:00:00',2.18),('5815','2013-07-29','12:05:00',2.17),('5815','2013-07-29','12:10:00',2.2),('5815','2013-07-29','12:15:00',2.18),('5815','2013-07-29','12:20:00',2.17),('5815','2013-07-29','12:25:00',2.15),('5815','2013-07-29','12:30:00',2.21),('5815','2013-07-29','12:35:00',2.33),('5815','2013-07-29','12:40:00',2.25),('5815','2013-07-29','12:45:00',1.87),('5815','2013-07-29','12:50:00',2.41),('5815','2013-07-29','12:55:00',2.44),('5815','2013-07-29','13:00:00',1.34),('5815','2013-07-29','13:05:00',1.4),('5815','2013-07-29','13:10:00',2.49),('5815','2013-07-29','13:15:00',2.47),('5815','2013-07-29','13:20:00',1.66),('5815','2013-07-29','13:25:00',1.22),('5815','2013-07-29','13:30:00',2.04),('5815','2013-07-29','13:35:00',2.49),('5815','2013-07-29','13:40:00',2.39),('5815','2013-07-29','13:45:00',2.4),('5815','2013-07-29','13:50:00',2.48),('5815','2013-07-29','13:55:00',2.47),('5815','2013-07-29','14:00:00',2.24),('5815','2013-07-29','14:05:00',2.46),('5815','2013-07-29','14:10:00',2.46),('5815','2013-07-29','14:15:00',2.32),('5815','2013-07-29','14:20:00',2.28),('5815','2013-07-29','14:25:00',2.3),('5815','2013-07-29','14:30:00',1.71),('5815','2013-07-29','14:35:00',2.19),('5815','2013-07-29','14:40:00',2.21),('5815','2013-07-29','14:45:00',2.22),('5815','2013-07-29','14:50:00',2.23),('5815','2013-07-29','14:55:00',2.2),('5815','2013-07-29','15:00:00',2.16),('5815','2013-07-29','15:05:00',2.12),('5815','2013-07-29','15:10:00',1.99),('5815','2013-07-29','15:15:00',2.07),('5815','2013-07-29','15:20:00',2.07),('5815','2013-07-29','15:25:00',2.02),('5815','2013-07-29','15:30:00',1.99),('5815','2013-07-29','15:35:00',1.97),('5815','2013-07-29','15:40:00',1.96),('5815','2013-07-29','15:45:00',1.91),('5815','2013-07-29','15:50:00',1.89),('5815','2013-07-29','15:55:00',1.86),('5815','2013-07-29','16:00:00',1.83),('5815','2013-07-29','16:05:00',1.78),('5815','2013-07-29','16:10:00',1.72),('5815','2013-07-29','16:15:00',1.68),('5815','2013-07-29','16:20:00',1.67),('5815','2013-07-29','16:25:00',1.65),('5815','2013-07-29','16:30:00',1.59),('5815','2013-07-29','16:35:00',1.54),('5815','2013-07-29','16:40:00',1.51),('5815','2013-07-29','16:45:00',1.49),('5815','2013-07-29','16:50:00',1.44),('5815','2013-07-29','16:55:00',1.39),('5815','2013-07-29','17:00:00',1.37),('5815','2013-07-29','17:05:00',1.32),('5815','2013-07-29','17:10:00',1.27),('5815','2013-07-29','17:15:00',1.24),('5815','2013-07-29','17:20:00',1.2),('5815','2013-07-29','17:25:00',1.15),('5815','2013-07-29','17:30:00',1.07),('5815','2013-07-28','09:05:00',1.06),('5815','2013-07-28','09:10:00',1.1),('5815','2013-07-28','09:15:00',1.13),('5815','2013-07-28','09:20:00',1.18),('5815','2013-07-28','09:25:00',1.22),('5815','2013-07-28','09:30:00',1.26),('5815','2013-07-28','09:35:00',1.31),('5815','2013-07-28','09:40:00',1.36),('5815','2013-07-28','09:45:00',1.4),('5815','2013-07-28','09:50:00',1.43),('5815','2013-07-28','09:55:00',1.47),('5815','2013-07-28','10:00:00',1.52),('5815','2013-07-28','10:05:00',1.56),('5815','2013-07-28','10:10:00',1.59),('5815','2013-07-28','10:15:00',1.61),('5815','2013-07-28','10:20:00',1.66),('5815','2013-07-28','10:25:00',1.7),('5815','2013-07-28','10:30:00',1.71),('5815','2013-07-28','10:35:00',1.77),('5815','2013-07-28','10:40:00',1.81),('5815','2013-07-28','10:45:00',1.81),('5815','2013-07-28','10:50:00',1.84),('5815','2013-07-28','10:55:00',1.86),('5815','2013-07-28','11:00:00',1.89),('5815','2013-07-28','11:05:00',1.88),('5815','2013-07-28','11:10:00',1.82),('5815','2013-07-28','11:15:00',1.83),('5815','2013-07-28','11:20:00',1.88),('5815','2013-07-28','11:25:00',1.9),('5815','2013-07-28','11:30:00',1.93),('5815','2013-07-28','11:35:00',1.94),('5815','2013-07-28','11:40:00',1.97),('5815','2013-07-28','11:45:00',2),('5815','2013-07-28','11:50:00',2),('5815','2013-07-28','11:55:00',2),('5815','2013-07-28','12:00:00',2.03),('5815','2013-07-28','12:05:00',2.02),('5815','2013-07-28','12:10:00',2.04),('5815','2013-07-28','12:15:00',2.06),('5815','2013-07-28','12:20:00',2.06),('5815','2013-07-28','12:25:00',2.1),('5815','2013-07-28','12:30:00',2.13),('5815','2013-07-28','12:35:00',2.15),('5815','2013-07-28','12:40:00',2.16),('5815','2013-07-28','12:45:00',2.15),('5815','2013-07-28','12:50:00',2.15),('5815','2013-07-28','12:55:00',2.13),('5815','2013-07-28','13:00:00',2.11),('5815','2013-07-28','13:05:00',2.18),('5815','2013-07-28','13:10:00',2.18),('5815','2013-07-28','13:15:00',2.18),('5815','2013-07-28','13:20:00',2.23),('5815','2013-07-28','13:25:00',2.24),('5815','2013-07-28','13:30:00',2.24),('5815','2013-07-28','13:35:00',2.21),('5815','2013-07-28','13:40:00',2.27),('5815','2013-07-28','13:45:00',2.28),('5815','2013-07-28','13:50:00',2.26),('5815','2013-07-28','13:55:00',2.25),('5815','2013-07-28','14:00:00',2.25),('5815','2013-07-28','14:05:00',2.24),('5815','2013-07-28','14:10:00',2.24),('5815','2013-07-28','14:15:00',2.23),('5815','2013-07-28','14:20:00',2.23),('5815','2013-07-28','14:25:00',2.21),('5815','2013-07-28','14:30:00',2.18),('5815','2013-07-28','14:35:00',2.18),('5815','2013-07-28','14:40:00',2.16),('5815','2013-07-28','14:45:00',2.15),('5815','2013-07-28','14:50:00',2.11),('5815','2013-07-28','14:55:00',2.11),('5815','2013-07-28','15:00:00',2.09),('5815','2013-07-28','15:05:00',2.08),('5815','2013-07-28','15:10:00',2.06),('5815','2013-07-28','15:15:00',2.04),('5815','2013-07-28','15:20:00',2.02),('5815','2013-07-28','15:25:00',2),('5815','2013-07-28','15:30:00',1.97),('5815','2013-07-28','15:35:00',1.95),('5815','2013-07-28','15:40:00',1.97),('5815','2013-07-28','15:45:00',1.97),('5815','2013-07-28','15:50:00',1.74),('5815','2013-07-28','15:55:00',1.11),('5815','2013-07-28','16:05:00',1.46),('5815','2013-07-28','16:10:00',1.66),('5815','2013-07-28','16:15:00',1.62),('5815','2013-07-28','16:20:00',1.45),('5815','2013-07-28','16:25:00',1.35),('5815','2013-07-28','16:30:00',1.72),('5815','2013-07-28','16:35:00',1.61),('5815','2013-07-28','16:40:00',1.26),('5815','2013-07-28','16:45:00',1.62),('5815','2013-07-28','16:50:00',1.54),('5815','2013-07-28','17:20:00',1.15),('5815','2013-07-28','17:25:00',1.13),('5815','2013-07-28','17:45:00',1.02),('5815','2013-07-27','09:00:00',1.03),('5815','2013-07-27','09:05:00',1.08),('5815','2013-07-27','09:10:00',1.12),('5815','2013-07-27','09:15:00',1.17),('5815','2013-07-27','09:20:00',1.21),('5815','2013-07-27','09:25:00',1.24),('5815','2013-07-27','09:30:00',1.3),('5815','2013-07-27','09:35:00',1.34),('5815','2013-07-27','09:40:00',1.39),('5815','2013-07-27','09:45:00',1.42),('5815','2013-07-27','09:50:00',1.46),('5815','2013-07-27','09:55:00',1.49),('5815','2013-07-27','10:00:00',1.52),('5815','2013-07-27','10:05:00',1.55),('5815','2013-07-27','10:10:00',1.58),('5815','2013-07-27','10:15:00',1.61),('5815','2013-07-27','10:20:00',1.64),('5815','2013-07-27','10:25:00',1.67),('5815','2013-07-27','10:30:00',1.68),('5815','2013-07-27','10:35:00',1.71),('5815','2013-07-27','10:40:00',1.77),('5815','2013-07-27','10:45:00',1.79),('5815','2013-07-27','10:50:00',1.81),('5815','2013-07-27','10:55:00',1.83),('5815','2013-07-27','11:00:00',1.84),('5815','2013-07-27','11:05:00',1.83),('5815','2013-07-27','11:10:00',1.82),('5815','2013-07-27','11:15:00',1.85),('5815','2013-07-27','11:20:00',1.91),('5815','2013-07-27','11:25:00',1.93),('5815','2013-07-27','11:30:00',1.93),('5815','2013-07-27','11:35:00',1.95),('5815','2013-07-27','11:40:00',1.94),('5815','2013-07-27','11:45:00',1.95),('5815','2013-07-27','11:50:00',1.96),('5815','2013-07-27','11:55:00',1.98),('5815','2013-07-27','12:00:00',2.03),('5815','2013-07-27','12:05:00',2.07),('5815','2013-07-27','12:10:00',2.04),('5815','2013-07-27','12:15:00',2.07),('5815','2013-07-27','12:20:00',2.01),('5815','2013-07-27','12:25:00',2.06),('5815','2013-07-27','12:30:00',2.1),('5815','2013-07-27','12:35:00',2.18),('5815','2013-07-27','12:40:00',2.18),('5815','2013-07-27','12:45:00',2.15),('5815','2013-07-27','12:50:00',2.14),('5815','2013-07-27','12:55:00',2.13),('5815','2013-07-27','13:00:00',2.16),('5815','2013-07-27','13:05:00',2.14),('5815','2013-07-27','13:10:00',2.05),('5815','2013-07-27','13:15:00',2.19),('5815','2013-07-27','13:20:00',2.2),('5815','2013-07-27','13:25:00',2.19),('5815','2013-07-27','13:30:00',2.17),('5815','2013-07-27','13:35:00',2.21),('5815','2013-07-27','13:40:00',2.21),('5815','2013-07-27','13:45:00',2.19),('5815','2013-07-27','13:50:00',2.26),('5815','2013-07-27','13:55:00',2.23),('5815','2013-07-27','14:00:00',2.21),('5815','2013-07-27','14:05:00',2.21),('5815','2013-07-27','14:10:00',2.2),('5815','2013-07-27','14:15:00',2.19),('5815','2013-07-27','14:20:00',2.18),('5815','2013-07-27','14:25:00',2.16),('5815','2013-07-27','14:30:00',2.15),('5815','2013-07-27','14:35:00',2.12),('5815','2013-07-27','14:40:00',2.15),('5815','2013-07-27','14:45:00',2.12),('5815','2013-07-27','14:50:00',2.1),('5815','2013-07-27','14:55:00',2.07),('5815','2013-07-27','15:00:00',2.05),('5815','2013-07-27','15:05:00',2.03),('5815','2013-07-27','15:10:00',2),('5815','2013-07-27','15:15:00',2.01),('5815','2013-07-27','15:20:00',1.99),('5815','2013-07-27','15:25:00',1.95),('5815','2013-07-27','15:30:00',1.94),('5815','2013-07-27','15:35:00',1.92),('5815','2013-07-27','15:40:00',1.88),('5815','2013-07-27','15:45:00',1.88),('5815','2013-07-27','15:50:00',1.85),('5815','2013-07-27','15:55:00',1.83),('5815','2013-07-27','16:00:00',1.79),('5815','2013-07-27','16:05:00',1.76),('5815','2013-07-27','16:10:00',1.73),('5815','2013-07-27','16:15:00',1.69),('5815','2013-07-27','16:20:00',1.68),('5815','2013-07-27','16:25:00',1.65),('5815','2013-07-27','16:30:00',1.61),('5815','2013-07-27','16:35:00',1.57),('5815','2013-07-27','16:40:00',1.54),('5815','2013-07-27','16:45:00',1.5),('5815','2013-07-27','16:50:00',1.45),('5815','2013-07-27','16:55:00',1.38),('5815','2013-07-27','17:00:00',1.29),('5815','2013-07-27','17:05:00',1.33),('5815','2013-07-27','17:10:00',1.3),('5815','2013-07-27','17:15:00',1.26),('5815','2013-07-27','17:20:00',1.22),('5815','2013-07-27','17:25:00',1.16),('5815','2013-07-27','17:30:00',1.09),('5815','2013-07-27','17:35:00',1.05),('5815','2013-07-27','17:40:00',1.04),('5815','2013-07-26','08:55:00',1.01),('5815','2013-07-26','09:00:00',1.05),('5815','2013-07-26','09:05:00',1.1),('5815','2013-07-26','09:10:00',1.14),('5815','2013-07-26','09:15:00',1.19),('5815','2013-07-26','09:20:00',1.25),('5815','2013-07-26','09:25:00',1.3),('5815','2013-07-26','09:30:00',1.31),('5815','2013-07-26','09:35:00',1.35),('5815','2013-07-26','09:40:00',1.4),('5815','2013-07-26','09:45:00',1.44),('5815','2013-07-26','09:50:00',1.48),('5815','2013-07-26','09:55:00',1.52),('5815','2013-07-26','10:00:00',1.56),('5815','2013-07-26','10:05:00',1.59),('5815','2013-07-26','10:10:00',1.63),('5815','2013-07-26','10:15:00',1.66),('5815','2013-07-26','10:20:00',1.7),('5815','2013-07-26','10:25:00',1.73),('5815','2013-07-26','10:30:00',1.76),('5815','2013-07-26','10:35:00',1.78),('5815','2013-07-26','10:40:00',1.8),('5815','2013-07-26','10:45:00',1.83),('5815','2013-07-26','10:50:00',1.85),('5815','2013-07-26','10:55:00',1.88),('5815','2013-07-26','11:00:00',1.89),('5815','2013-07-26','11:05:00',1.89),('5815','2013-07-26','11:10:00',1.86),('5815','2013-07-26','11:15:00',1.89),('5815','2013-07-26','11:20:00',1.93),('5815','2013-07-26','11:25:00',1.97),('5815','2013-07-26','11:30:00',1.99),('5815','2013-07-26','11:35:00',2.02),('5815','2013-07-26','11:40:00',2.01),('5815','2013-07-26','11:45:00',2.05),('5815','2013-07-26','11:50:00',2.04),('5815','2013-07-26','11:55:00',2.05),('5815','2013-07-26','12:00:00',2.05),('5815','2013-07-26','12:05:00',2.07),('5815','2013-07-26','12:10:00',2.08),('5815','2013-07-26','12:15:00',2.09),('5815','2013-07-26','12:20:00',2.14),('5815','2013-07-26','12:25:00',2.15),('5815','2013-07-26','12:30:00',2.14),('5815','2013-07-26','12:35:00',2.2),('5815','2013-07-26','12:40:00',2.2),('5815','2013-07-26','12:45:00',2.16),('5815','2013-07-26','12:50:00',2.15),('5815','2013-07-26','12:55:00',2.18),('5815','2013-07-26','13:00:00',2.19),('5815','2013-07-26','13:05:00',2.27),('5815','2013-07-26','13:10:00',2.25),('5815','2013-07-26','13:15:00',2.26),('5815','2013-07-26','13:20:00',2.28),('5815','2013-07-26','13:25:00',2.3),('5815','2013-07-26','13:30:00',2.34),('5815','2013-07-26','13:35:00',2.13),('5815','2013-07-26','13:40:00',2.11),('5815','2013-07-26','13:45:00',2.32),('5815','2013-07-26','13:50:00',2.33),('5815','2013-07-26','13:55:00',2.34),('5815','2013-07-26','14:00:00',2.23),('5815','2013-07-26','14:05:00',2.27),('5815','2013-07-26','14:10:00',1.79),('5815','2013-07-26','14:15:00',2.04),('5815','2013-07-26','14:20:00',2.26),('5815','2013-07-26','14:25:00',2.22),('5815','2013-07-26','14:30:00',2.2),('5815','2013-07-26','14:35:00',2.19),('5815','2013-07-26','14:40:00',2.18),('5815','2013-07-26','14:45:00',2.17),('5815','2013-07-26','14:50:00',2.13),('5815','2013-07-26','14:55:00',2.1),('5815','2013-07-26','15:00:00',2.08),('5815','2013-07-26','15:05:00',2.05),('5815','2013-07-26','15:10:00',2.09),('5815','2013-07-26','15:15:00',2.04),('5815','2013-07-26','15:20:00',2.02),('5815','2013-07-26','15:25:00',1.99),('5815','2013-07-26','15:30:00',1.97),('5815','2013-07-26','15:35:00',1.94),('5815','2013-07-26','15:40:00',1.92),('5815','2013-07-26','15:45:00',1.9),('5815','2013-07-26','15:50:00',1.88),('5815','2013-07-26','15:55:00',1.84),('5815','2013-07-26','16:00:00',1.8),('5815','2013-07-26','16:05:00',1.75),('5815','2013-07-26','16:10:00',1.73),('5815','2013-07-26','16:15:00',1.69),('5815','2013-07-26','16:20:00',1.66),('5815','2013-07-26','16:25:00',1.63),('5815','2013-07-26','16:30:00',1.59),('5815','2013-07-26','16:35:00',1.57),('5815','2013-07-26','16:40:00',1.53),('5815','2013-07-26','16:45:00',1.49),('5815','2013-07-26','16:50:00',1.45),('5815','2013-07-26','16:55:00',1.38),('5815','2013-07-26','17:00:00',1.31),('5815','2013-07-26','17:05:00',1.33),('5815','2013-07-26','17:10:00',1.29),('5815','2013-07-26','17:15:00',1.25),('5815','2013-07-26','17:20:00',1.21),('5815','2013-07-26','17:25:00',1.16),('5815','2013-07-26','17:30:00',1.1),('5815','2013-07-26','17:35:00',1.07),('5815','2013-07-26','17:40:00',1.03),('5815','2013-07-25','09:00:00',1.03),('5815','2013-07-25','09:05:00',1.08),('5815','2013-07-25','09:10:00',1.13),('5815','2013-07-25','09:15:00',1.16),('5815','2013-07-25','09:20:00',1.21),('5815','2013-07-25','09:25:00',1.24),('5815','2013-07-25','09:30:00',1.26),('5815','2013-07-25','09:35:00',1.3),('5815','2013-07-25','09:40:00',1.35),('5815','2013-07-25','09:45:00',1.37),('5815','2013-07-25','09:50:00',1.08),('5815','2013-07-25','09:55:00',1.48),('5815','2013-07-25','10:00:00',1.51),('5815','2013-07-25','10:05:00',1.58),('5815','2013-07-25','10:10:00',1.57),('5815','2013-07-25','10:15:00',1.63),('5815','2013-07-25','10:20:00',1.66),('5815','2013-07-25','10:25:00',1.69),('5815','2013-07-25','10:30:00',1.72),('5815','2013-07-25','10:35:00',1.75),('5815','2013-07-25','10:40:00',1.79),('5815','2013-07-25','10:45:00',1.82),('5815','2013-07-25','10:50:00',1.84),('5815','2013-07-25','10:55:00',1.86),('5815','2013-07-25','11:00:00',1.89),('5815','2013-07-25','11:05:00',1.88),('5815','2013-07-25','11:10:00',1.86),('5815','2013-07-25','11:15:00',1.87),('5815','2013-07-25','11:20:00',1.48),('5815','2013-07-25','11:25:00',1.85),('5815','2013-07-25','11:30:00',1.9),('5815','2013-07-25','11:35:00',1.86),('5815','2013-07-25','11:40:00',1.97),('5815','2013-07-25','11:45:00',2.02),('5815','2013-07-25','11:50:00',2.06),('5815','2013-07-25','11:55:00',2.07),('5815','2013-07-25','12:00:00',2.05),('5815','2013-07-25','12:05:00',2.06),('5815','2013-07-25','12:15:00',1.56),('5815','2013-07-25','12:20:00',1.17),('5815','2013-07-25','12:25:00',2.2),('5815','2013-07-25','12:30:00',2.2),('5815','2013-07-25','12:35:00',2.23),('5815','2013-07-25','12:40:00',2.3),('5815','2013-07-25','12:45:00',2.35),('5815','2013-07-25','12:50:00',2.35),('5815','2013-07-25','12:55:00',2.26),('5815','2013-07-25','13:00:00',1.54),('5815','2013-07-25','13:15:00',1.06),('5815','2013-07-25','13:20:00',1.63),('5815','2013-07-25','13:25:00',2.21),('5815','2013-07-25','13:30:00',2.49),('5815','2013-07-25','13:35:00',2.37),('5815','2013-07-25','13:40:00',2.33),('5815','2013-07-25','13:45:00',2.35),('5815','2013-07-25','13:50:00',2.31),('5815','2013-07-25','13:55:00',2.15),('5815','2013-07-25','14:00:00',2.31),('5815','2013-07-25','14:05:00',2.37),('5815','2013-07-25','14:10:00',2.28),('5815','2013-07-25','14:15:00',2.26),('5815','2013-07-25','14:20:00',2.28),('5815','2013-07-25','14:25:00',2.26),('5815','2013-07-25','14:30:00',2.23),('5815','2013-07-25','14:35:00',2.2),('5815','2013-07-25','14:40:00',2.22),('5815','2013-07-25','14:45:00',2.11),('5815','2013-07-25','14:50:00',2.15),('5815','2013-07-25','14:55:00',2.12),('5815','2013-07-25','15:00:00',2.14),('5815','2013-07-25','15:05:00',2.1),('5815','2013-07-25','15:10:00',2.1),('5815','2013-07-25','15:15:00',2.07),('5815','2013-07-25','15:20:00',2.04),('5815','2013-07-25','15:25:00',1.99),('5815','2013-07-25','15:30:00',1.98),('5815','2013-07-25','15:35:00',1.97),('5815','2013-07-25','15:40:00',1.96),('5815','2013-07-25','15:45:00',1.96),('5815','2013-07-25','15:50:00',1.93),('5815','2013-07-25','15:55:00',1.88),('5815','2013-07-25','16:00:00',1.81),('5815','2013-07-25','16:05:00',1.76),('5815','2013-07-25','16:10:00',1.71),('5815','2013-07-25','16:15:00',1.68),('5815','2013-07-25','16:20:00',1.66),('5815','2013-07-25','16:25:00',1.64),('5815','2013-07-25','16:30:00',1.61),('5815','2013-07-25','16:35:00',1.57),('5815','2013-07-25','16:40:00',1.54),('5815','2013-07-25','16:45:00',1.51),('5815','2013-07-25','16:50:00',1.45),('5815','2013-07-25','16:55:00',1.39),('5815','2013-07-25','17:00:00',1.32),('5815','2013-07-25','17:05:00',1.33),('5815','2013-07-25','17:10:00',1.29),('5815','2013-07-25','17:15:00',1.23),('5815','2013-07-25','17:20:00',1.2),('5815','2013-07-25','17:25:00',1.15),('5815','2013-07-25','17:30:00',1.07),('5815','2013-07-25','17:35:00',1.03),('5815','2013-07-24','09:00:00',1.04),('5815','2013-07-24','09:05:00',1.07),('5815','2013-07-24','09:15:00',1.18),('5815','2013-07-24','09:20:00',1.27),('5815','2013-07-24','09:25:00',1.09),('5815','2013-07-24','10:10:00',1.05),('5815','2013-07-24','10:15:00',1.77),('5815','2013-07-24','10:20:00',1.81),('5815','2013-07-24','10:25:00',1.85),('5815','2013-07-24','10:30:00',1.86),('5815','2013-07-24','10:35:00',1.73),('5815','2013-07-24','10:40:00',1.66),('5815','2013-07-24','10:45:00',1.7),('5815','2013-07-24','10:50:00',1.85),('5815','2013-07-24','10:55:00',1.98),('5815','2013-07-24','11:00:00',1.98),('5815','2013-07-24','11:05:00',1.39),('5815','2013-07-24','11:10:00',1.49),('5815','2013-07-24','11:15:00',1.95),('5815','2013-07-24','11:20:00',1.84),('5815','2013-07-24','11:25:00',1.78),('5815','2013-07-24','11:30:00',1.84),('5815','2013-07-24','11:35:00',2.02),('5815','2013-07-24','11:40:00',2.08),('5815','2013-07-24','11:45:00',2.24),('5815','2013-07-24','11:50:00',2.3),('5815','2013-07-24','11:55:00',1.65),('5815','2013-07-24','12:00:00',1.7),('5815','2013-07-24','12:05:00',2.2),('5815','2013-07-24','12:10:00',2.23),('5815','2013-07-24','12:15:00',1.89),('5815','2013-07-24','12:20:00',1.53),('5815','2013-07-24','12:25:00',1.96),('5815','2013-07-24','12:35:00',1.27),('5815','2013-07-24','12:55:00',1.09),('5815','2013-07-24','13:00:00',2.09),('5815','2013-07-24','13:05:00',1.36),('5815','2013-07-24','13:20:00',1.8),('5815','2013-07-24','13:25:00',2.45),('5815','2013-07-24','13:30:00',2.4),('5815','2013-07-24','13:35:00',2.26),('5815','2013-07-24','13:40:00',2.28),('5815','2013-07-24','13:45:00',2.3),('5815','2013-07-24','13:50:00',2.3),('5815','2013-07-24','13:55:00',2.29),('5815','2013-07-24','14:00:00',2.31),('5815','2013-07-24','14:05:00',2.32),('5815','2013-07-24','14:10:00',2.33),('5815','2013-07-24','14:15:00',2.32),('5815','2013-07-24','14:20:00',2.34),('5815','2013-07-24','14:25:00',2.33),('5815','2013-07-24','14:30:00',2.3),('5815','2013-07-24','14:35:00',2.28),('5815','2013-07-24','14:40:00',2.25),('5815','2013-07-24','14:45:00',2.2),('5815','2013-07-24','14:50:00',2.18),('5815','2013-07-24','14:55:00',2.18),('5815','2013-07-24','15:00:00',2.18),('5815','2013-07-24','15:05:00',2.18),('5815','2013-07-24','15:10:00',2.16),('5815','2013-07-24','15:15:00',2.12),('5815','2013-07-24','15:20:00',2.11),('5815','2013-07-24','15:25:00',2.06),('5815','2013-07-24','15:30:00',2.05),('5815','2013-07-24','15:35:00',2.03),('5815','2013-07-24','15:40:00',2.02),('5815','2013-07-24','15:45:00',2.02),('5815','2013-07-24','15:50:00',2),('5815','2013-07-24','15:55:00',1.96),('5815','2013-07-24','16:00:00',1.87),('5815','2013-07-24','16:05:00',1.81),('5815','2013-07-24','16:10:00',1.77),('5815','2013-07-24','16:15:00',1.73),('5815','2013-07-24','16:20:00',1.73),('5815','2013-07-24','16:25:00',1.7),('5815','2013-07-24','16:30:00',1.66),('5815','2013-07-24','16:35:00',1.65),('5815','2013-07-24','16:40:00',1.62),('5815','2013-07-24','16:45:00',1.57),('5815','2013-07-24','16:50:00',1.51),('5815','2013-07-24','16:55:00',1.45),('5815','2013-07-24','17:00:00',1.37),('5815','2013-07-24','17:05:00',1.4),('5815','2013-07-24','17:10:00',1.35),('5815','2013-07-24','17:15:00',1.31),('5815','2013-07-24','17:20:00',1.26),('5815','2013-07-24','17:25:00',1.2),('5815','2013-07-24','17:30:00',1.15),('5815','2013-07-24','17:35:00',1.1),('5815','2013-07-24','17:40:00',1.02),('5815','2013-07-23','09:10:00',1.19),('5815','2013-07-23','09:15:00',1.08),('5815','2013-07-23','09:35:00',1.04),('5815','2013-07-23','09:40:00',1.01),('5815','2013-07-23','09:45:00',1.06),('5815','2013-07-23','09:50:00',1.04),('5815','2013-07-23','10:25:00',1.39),('5815','2013-07-23','10:30:00',1.83),('5815','2013-07-23','10:35:00',1.88),('5815','2013-07-23','10:40:00',2),('5815','2013-07-23','10:45:00',1.99),('5815','2013-07-23','10:50:00',1.44),('5815','2013-07-23','10:55:00',1.33),('5815','2013-07-23','11:10:00',2.06),('5815','2013-07-23','11:15:00',2.08),('5815','2013-07-23','11:20:00',2.11),('5815','2013-07-23','11:25:00',2.12),('5815','2013-07-23','11:30:00',2.12),('5815','2013-07-23','11:35:00',2.19),('5815','2013-07-23','11:40:00',2.1),('5815','2013-07-23','11:45:00',2.12),('5815','2013-07-23','11:50:00',2.14),('5815','2013-07-23','11:55:00',2.15),('5815','2013-07-23','12:00:00',2.23),('5815','2013-07-23','12:05:00',2.34),('5815','2013-07-23','12:10:00',1.9),('5815','2013-07-23','12:20:00',1.54),('5815','2013-07-23','12:25:00',2.45),('5815','2013-07-23','12:30:00',1.42),('5815','2013-07-23','12:40:00',1.25),('5815','2013-07-23','12:45:00',2.4),('5815','2013-07-23','12:50:00',1.21),('5815','2013-07-23','13:00:00',2.38),('5815','2013-07-23','13:05:00',2.21),('5815','2013-07-23','13:15:00',1.53),('5815','2013-07-23','13:25:00',2.19),('5815','2013-07-23','13:30:00',1.09),('5815','2013-07-23','13:35:00',2.53),('5815','2013-07-23','13:40:00',2.03),('5815','2013-07-23','13:45:00',2.28),('5815','2013-07-23','13:50:00',1.83),('5815','2013-07-23','13:55:00',2.48),('5815','2013-07-23','14:00:00',2.45),('5815','2013-07-23','14:05:00',2.44),('5815','2013-07-23','14:10:00',2.42),('5815','2013-07-23','14:15:00',2.42),('5815','2013-07-23','14:20:00',2.38),('5815','2013-07-23','14:25:00',2.28),('5815','2013-07-23','14:30:00',2.36),('5815','2013-07-23','14:35:00',1.78),('5815','2013-07-23','14:40:00',2.35),('5815','2013-07-23','14:45:00',2.28),('5815','2013-07-23','14:50:00',2.33),('5815','2013-07-23','14:55:00',2.31),('5815','2013-07-23','15:00:00',2.22),('5815','2013-07-23','15:05:00',2.24),('5815','2013-07-23','15:10:00',2.18),('5815','2013-07-23','15:15:00',2.18),('5815','2013-07-23','15:20:00',2.16),('5815','2013-07-23','15:25:00',2.12),('5815','2013-07-23','15:30:00',1.97),('5815','2013-07-23','15:35:00',1.98),('5815','2013-07-23','15:40:00',2.02),('5815','2013-07-23','15:45:00',1.97),('5815','2013-07-23','15:50:00',1.93),('5815','2013-07-23','15:55:00',1.96),('5815','2013-07-23','16:00:00',1.88),('5815','2013-07-23','16:05:00',1.8),('5815','2013-07-23','16:10:00',1.74),('5815','2013-07-23','16:15:00',1.6),('5815','2013-07-23','16:20:00',1.82),('5815','2013-07-23','16:25:00',1.72),('5815','2013-07-23','16:30:00',1.75),('5815','2013-07-23','16:35:00',1.62),('5815','2013-07-23','16:40:00',1.65),('5815','2013-07-23','16:45:00',1.51),('5815','2013-07-23','16:50:00',1.5),('5815','2013-07-23','16:55:00',1.56),('5815','2013-07-23','17:00:00',1.51),('5815','2013-07-23','17:05:00',1.29),('5815','2013-07-23','17:15:00',1.33),('5815','2013-07-23','17:20:00',1.3),('5815','2013-07-23','17:25:00',1.25),('5815','2013-07-23','17:30:00',1.17),('5815','2013-07-23','17:35:00',1.12),('5815','2013-07-23','17:40:00',1.05),('5815','2013-07-23','17:45:00',1.01),('5815','2013-07-22','08:50:00',1.03),('5815','2013-07-22','08:55:00',1.08),('5815','2013-07-22','09:00:00',1.13),('5815','2013-07-22','09:05:00',1.18),('5815','2013-07-22','09:10:00',1.21),('5815','2013-07-22','09:15:00',1.26),('5815','2013-07-22','09:20:00',1.3),('5815','2013-07-22','09:25:00',1.33),('5815','2013-07-22','09:30:00',1.36),('5815','2013-07-22','09:35:00',1.41),('5815','2013-07-22','09:40:00',1.44),('5815','2013-07-22','09:45:00',1.47),('5815','2013-07-22','09:50:00',1.5),('5815','2013-07-22','09:55:00',1.53),('5815','2013-07-22','10:00:00',1.55),('5815','2013-07-22','10:05:00',1.6),('5815','2013-07-22','10:10:00',1.63),('5815','2013-07-22','10:15:00',1.66),('5815','2013-07-22','10:20:00',1.7),('5815','2013-07-22','10:25:00',1.74),('5815','2013-07-22','10:30:00',1.78),('5815','2013-07-22','10:35:00',1.84),('5815','2013-07-22','10:40:00',1.86),('5815','2013-07-22','10:45:00',1.9),('5815','2013-07-22','10:50:00',1.91),('5815','2013-07-22','10:55:00',1.93),('5815','2013-07-22','11:00:00',1.96),('5815','2013-07-22','11:05:00',1.94),('5815','2013-07-22','11:10:00',1.92),('5815','2013-07-22','11:15:00',2),('5815','2013-07-22','11:20:00',2.02),('5815','2013-07-22','11:25:00',2.04),('5815','2013-07-22','11:30:00',2.07),('5815','2013-07-22','11:35:00',2.1),('5815','2013-07-22','11:40:00',2.1),('5815','2013-07-22','11:45:00',2.14),('5815','2013-07-22','11:50:00',2.09),('5815','2013-07-22','11:55:00',2.09),('5815','2013-07-22','12:00:00',2.16),('5815','2013-07-22','12:05:00',2.18),('5815','2013-07-22','12:10:00',2.2),('5815','2013-07-22','12:15:00',2.23),('5815','2013-07-22','12:20:00',2.22),('5815','2013-07-22','12:25:00',2.25),('5815','2013-07-22','12:30:00',2.27),('5815','2013-07-22','12:35:00',2.24),('5815','2013-07-22','12:40:00',2.27),('5815','2013-07-22','12:45:00',1.61),('5815','2013-07-22','12:50:00',1.63),('5815','2013-07-22','12:55:00',1.46),('5815','2013-07-22','13:10:00',1.6),('5815','2013-07-22','13:15:00',1.74),('5815','2013-07-22','13:30:00',1.57),('5815','2013-07-22','13:35:00',2.46),('5815','2013-07-22','13:40:00',2.43),('5815','2013-07-22','13:45:00',2.33),('5815','2013-07-22','13:50:00',1.52),('5815','2013-07-22','13:55:00',1.6),('5815','2013-07-22','14:00:00',2.42),('5815','2013-07-22','14:05:00',1.3),('5815','2013-07-22','14:40:00',2.24),('5815','2013-07-22','14:45:00',1.63),('5815','2013-07-22','14:50:00',2.34),('5815','2013-07-22','14:55:00',2.42),('5815','2013-07-22','15:00:00',1.55),('5815','2013-07-22','15:05:00',2.5),('5815','2013-07-22','15:10:00',2.36),('5815','2013-07-22','15:15:00',2.19),('5815','2013-07-22','15:20:00',2.2),('5815','2013-07-22','15:25:00',2.1),('5815','2013-07-22','15:30:00',2.06),('5815','2013-07-22','15:35:00',1.42),('5815','2013-07-22','15:40:00',2),('5815','2013-07-22','15:45:00',1.96),('5815','2013-07-22','15:50:00',1.95),('5815','2013-07-22','15:55:00',1.92),('5815','2013-07-22','16:00:00',1.85),('5815','2013-07-22','16:05:00',1.79),('5815','2013-07-22','16:10:00',1.73),('5815','2013-07-22','16:15:00',1.71),('5815','2013-07-22','16:20:00',1.72),('5815','2013-07-22','16:25:00',1.68),('5815','2013-07-22','16:30:00',1.63),('5815','2013-07-22','16:35:00',1.54),('5815','2013-07-22','16:40:00',1.49),('5815','2013-07-22','16:45:00',1.51),('5815','2013-07-22','16:50:00',1.46),('5815','2013-07-22','16:55:00',1.42),('5815','2013-07-22','17:00:00',1.39),('5815','2013-07-22','17:05:00',1.35),('5815','2013-07-22','17:10:00',1.33),('5815','2013-07-22','17:15:00',1.31),('5815','2013-07-22','17:20:00',1.26),('5815','2013-07-22','17:25:00',1.22),('5815','2013-07-22','17:30:00',1.16),('5815','2013-07-22','17:35:00',1.11),('5815','2013-07-22','17:40:00',1.09),('5815','2013-07-22','17:45:00',1.05),('5815','2013-07-22','17:50:00',1),('5815','2013-07-21','08:50:00',1.02),('5815','2013-07-21','08:55:00',1.07),('5815','2013-07-21','09:00:00',1.12),('5815','2013-07-21','09:05:00',1.16),('5815','2013-07-21','09:10:00',1.21),('5815','2013-07-21','09:15:00',1.25),('5815','2013-07-21','09:20:00',1.29),('5815','2013-07-21','09:25:00',1.33),('5815','2013-07-21','09:30:00',1.37),('5815','2013-07-21','09:35:00',1.41),('5815','2013-07-21','09:40:00',1.45),('5815','2013-07-21','09:45:00',1.5),('5815','2013-07-21','09:50:00',1.53),('5815','2013-07-21','09:55:00',1.57),('5815','2013-07-21','10:00:00',1.6),('5815','2013-07-21','10:05:00',1.64),('5815','2013-07-21','10:10:00',1.67),('5815','2013-07-21','10:15:00',1.71),('5815','2013-07-21','10:20:00',1.74),('5815','2013-07-21','10:25:00',1.77),('5815','2013-07-21','10:30:00',1.81),('5815','2013-07-21','10:35:00',1.83),('5815','2013-07-21','10:40:00',1.86),('5815','2013-07-21','10:45:00',1.88),('5815','2013-07-21','10:50:00',1.91),('5815','2013-07-21','10:55:00',1.93),('5815','2013-07-21','11:00:00',1.94),('5815','2013-07-21','11:05:00',1.9),('5815','2013-07-21','11:10:00',1.89),('5815','2013-07-21','11:15:00',1.95),('5815','2013-07-21','11:20:00',1.96),('5815','2013-07-21','11:25:00',1.98),('5815','2013-07-21','11:30:00',2),('5815','2013-07-21','11:35:00',2.02),('5815','2013-07-21','11:40:00',2.04),('5815','2013-07-21','11:45:00',2.07),('5815','2013-07-21','11:50:00',2.05),('5815','2013-07-21','11:55:00',2.05),('5815','2013-07-21','12:00:00',2.07),('5815','2013-07-21','12:05:00',2.09),('5815','2013-07-21','12:10:00',2.11),('5815','2013-07-21','12:15:00',2.12),('5815','2013-07-21','12:20:00',2.13),('5815','2013-07-21','12:25:00',2.17),('5815','2013-07-21','12:30:00',2.21),('5815','2013-07-21','12:35:00',2.21),('5815','2013-07-21','12:40:00',2.2),('5815','2013-07-21','12:45:00',2.19),('5815','2013-07-21','12:50:00',2.18),('5815','2013-07-21','12:55:00',2.2),('5815','2013-07-21','13:00:00',2.24),('5815','2013-07-21','13:05:00',2.24),('5815','2013-07-21','13:10:00',2.22),('5815','2013-07-21','13:15:00',1.86),('5815','2013-07-21','13:20:00',2.24),('5815','2013-07-21','13:25:00',2.24),('5815','2013-07-21','13:30:00',2.23),('5815','2013-07-21','13:35:00',2.24),('5815','2013-07-21','13:40:00',2.26),('5815','2013-07-21','13:45:00',2.21),('5815','2013-07-21','13:50:00',2.23),('5815','2013-07-21','13:55:00',2.19),('5815','2013-07-21','14:00:00',2.2),('5815','2013-07-21','14:05:00',2.16),('5815','2013-07-21','14:10:00',2.19),('5815','2013-07-21','14:15:00',1.89),('5815','2013-07-21','14:20:00',2.1),('5815','2013-07-21','14:25:00',2.19),('5815','2013-07-21','14:30:00',2.16),('5815','2013-07-21','14:35:00',2.16),('5815','2013-07-21','14:40:00',2.14),('5815','2013-07-21','14:45:00',2.13),('5815','2013-07-21','14:50:00',2.11),('5815','2013-07-21','14:55:00',2.05),('5815','2013-07-21','15:00:00',2.03),('5815','2013-07-21','15:05:00',1.91),('5815','2013-07-21','15:10:00',2.06),('5815','2013-07-21','15:15:00',2.05),('5815','2013-07-21','15:20:00',2.01),('5815','2013-07-21','15:25:00',1.97),('5815','2013-07-21','15:40:00',1.93),('5815','2013-07-21','15:45:00',2.05),('5815','2013-07-21','15:50:00',2),('5815','2013-07-21','15:55:00',2.08),('5815','2013-07-21','16:00:00',1.88),('5815','2013-07-21','16:05:00',1.06),('5815','2013-07-21','16:15:00',1.56),('5815','2013-07-21','16:20:00',1.89),('5815','2013-07-21','16:25:00',1.85),('5815','2013-07-21','16:30:00',1.72),('5815','2013-07-21','16:35:00',1.62),('5815','2013-07-21','16:40:00',1.52),('5815','2013-07-21','16:45:00',1.51),('5815','2013-07-21','16:50:00',1.47),('5815','2013-07-21','16:55:00',1.41),('5815','2013-07-21','17:00:00',1.4),('5815','2013-07-21','17:05:00',1.38),('5815','2013-07-21','17:10:00',1.34),('5815','2013-07-21','17:15:00',1.29),('5815','2013-07-21','17:20:00',1.25),('5815','2013-07-21','17:25:00',1.17),('5815','2013-07-21','17:30:00',1.15),('5815','2013-07-21','17:35:00',1.14),('5815','2013-07-21','17:40:00',1.06),('5815','2013-07-20','08:55:00',1.01),('5815','2013-07-20','09:00:00',1.07),('5815','2013-07-20','09:05:00',1.11),('5815','2013-07-20','09:10:00',1.15),('5815','2013-07-20','09:15:00',1.19),('5815','2013-07-20','09:20:00',1.24),('5815','2013-07-20','09:25:00',1.29),('5815','2013-07-20','09:30:00',1.32),('5815','2013-07-20','09:35:00',1.36),('5815','2013-07-20','09:40:00',1.4),('5815','2013-07-20','09:45:00',1.44),('5815','2013-07-20','09:50:00',1.47),('5815','2013-07-20','09:55:00',1.51),('5815','2013-07-20','10:00:00',1.55),('5815','2013-07-20','10:05:00',1.59),('5815','2013-07-20','10:10:00',1.61),('5815','2013-07-20','10:15:00',1.66),('5815','2013-07-20','10:20:00',1.69),('5815','2013-07-20','10:25:00',1.72),('5815','2013-07-20','10:30:00',1.73),('5815','2013-07-20','10:35:00',1.76),('5815','2013-07-20','10:40:00',1.8),('5815','2013-07-20','10:45:00',1.83),('5815','2013-07-20','10:50:00',1.86),('5815','2013-07-20','10:55:00',1.86),('5815','2013-07-20','11:00:00',1.9),('5815','2013-07-20','11:05:00',1.85),('5815','2013-07-20','11:10:00',1.82),('5815','2013-07-20','11:15:00',1.93),('5815','2013-07-20','11:20:00',1.94),('5815','2013-07-20','11:25:00',1.97),('5815','2013-07-20','11:30:00',1.98),('5815','2013-07-20','11:35:00',2),('5815','2013-07-20','11:40:00',2.08),('5815','2013-07-20','11:45:00',1.83),('5815','2013-07-20','11:50:00',2.11),('5815','2013-07-20','11:55:00',2.08),('5815','2013-07-20','12:00:00',2.1),('5815','2013-07-20','12:05:00',2.01),('5815','2013-07-20','12:10:00',2.15),('5815','2013-07-20','12:15:00',2.25),('5815','2013-07-20','12:20:00',2.31),('5815','2013-07-20','12:25:00',2.39),('5815','2013-07-20','12:30:00',2.41),('5815','2013-07-20','12:35:00',2.34),('5815','2013-07-20','12:40:00',2.41),('5815','2013-07-20','12:45:00',2),('5815','2013-07-20','12:50:00',2.55),('5815','2013-07-20','12:55:00',2.66),('5815','2013-07-20','13:00:00',2.56),('5815','2013-07-20','13:05:00',2.62),('5815','2013-07-20','13:10:00',2.47),('5815','2013-07-20','13:15:00',2.21),('5815','2013-07-20','13:20:00',1.9),('5815','2013-07-20','13:25:00',2.51),('5815','2013-07-20','13:30:00',2.38),('5815','2013-07-20','13:35:00',1.22),('5815','2013-07-20','14:45:00',1.25),('5815','2013-07-20','14:50:00',1.32),('5815','2013-07-20','14:55:00',1.05),('5815','2013-07-20','15:15:00',1.87),('5815','2013-07-20','15:20:00',1.8),('5815','2013-07-20','15:40:00',2.34),('5815','2013-07-20','15:45:00',1.19),('5815','2013-07-20','15:50:00',1.35),('5815','2013-07-20','15:55:00',1.27),('5815','2013-07-19','08:50:00',1.04),('5815','2013-07-19','08:55:00',1.09),('5815','2013-07-19','09:00:00',1.15),('5815','2013-07-19','09:05:00',1.2),('5815','2013-07-19','09:10:00',1.27),('5815','2013-07-19','09:15:00',1.33),('5815','2013-07-19','09:20:00',1.36),('5815','2013-07-19','09:25:00',1.35),('5815','2013-07-19','09:30:00',1.36),('5815','2013-07-19','09:35:00',1.4),('5815','2013-07-19','09:40:00',1.4),('5815','2013-07-19','09:45:00',1.48),('5815','2013-07-19','09:50:00',1.45),('5815','2013-07-19','09:55:00',1.49),('5815','2013-07-19','10:00:00',1.59),('5815','2013-07-19','10:05:00',1.61),('5815','2013-07-19','10:10:00',1.66),('5815','2013-07-19','10:15:00',1.69),('5815','2013-07-19','10:20:00',1.72),('5815','2013-07-19','10:25:00',1.76),('5815','2013-07-19','10:30:00',1.78),('5815','2013-07-19','10:35:00',1.82),('5815','2013-07-19','10:40:00',1.85),('5815','2013-07-19','10:45:00',1.87),('5815','2013-07-19','10:50:00',1.92),('5815','2013-07-19','10:55:00',1.93),('5815','2013-07-19','11:00:00',1.95),('5815','2013-07-19','11:05:00',1.9),('5815','2013-07-19','11:10:00',1.9),('5815','2013-07-19','11:15:00',1.96),('5815','2013-07-19','11:20:00',1.98),('5815','2013-07-19','11:25:00',1.98),('5815','2013-07-19','11:30:00',2.01),('5815','2013-07-19','11:35:00',2.01),('5815','2013-07-19','11:40:00',2.06),('5815','2013-07-19','11:45:00',2.09),('5815','2013-07-19','11:50:00',2.09),('5815','2013-07-19','11:55:00',2.12),('5815','2013-07-19','12:00:00',2.16),('5815','2013-07-19','12:05:00',2.18),('5815','2013-07-19','12:10:00',2.21),('5815','2013-07-19','12:15:00',2.18),('5815','2013-07-19','12:20:00',2.01),('5815','2013-07-19','12:25:00',2.2),('5815','2013-07-19','12:30:00',2.22),('5815','2013-07-19','12:35:00',2.18),('5815','2013-07-19','12:40:00',2.21),('5815','2013-07-19','12:45:00',2.3),('5815','2013-07-19','12:50:00',2.27),('5815','2013-07-19','12:55:00',2.26),('5815','2013-07-19','13:00:00',2.36),('5815','2013-07-19','13:05:00',2.34),('5815','2013-07-19','13:10:00',2.27),('5815','2013-07-19','13:15:00',2.1),('5815','2013-07-19','13:20:00',2.09),('5815','2013-07-19','13:25:00',2.33),('5815','2013-07-19','13:30:00',2.4),('5815','2013-07-19','13:35:00',2.4),('5815','2013-07-19','13:40:00',2.42),('5815','2013-07-19','13:45:00',2.41),('5815','2013-07-19','13:50:00',1.67),('5815','2013-07-19','14:00:00',2),('5815','2013-07-19','14:05:00',2.46),('5815','2013-07-19','14:10:00',2.25),('5815','2013-07-19','14:15:00',1.9),('5815','2013-07-19','14:20:00',1.32),('5815','2013-07-19','14:25:00',2.41),('5815','2013-07-19','14:30:00',2.33),('5815','2013-07-19','14:35:00',1.61),('5815','2013-07-19','14:40:00',2.08),('5815','2013-07-19','14:50:00',1.75),('5815','2013-07-19','15:05:00',2.3),('5815','2013-07-19','15:10:00',2.22),('5815','2013-07-19','15:15:00',2.15),('5815','2013-07-19','15:20:00',2.1),('5815','2013-07-19','15:25:00',2.04),('5815','2013-07-19','15:30:00',2),('5815','2013-07-19','15:35:00',1.97),('5815','2013-07-19','15:40:00',1.94),('5815','2013-07-19','15:45:00',1.96),('5815','2013-07-19','15:50:00',1.91),('5815','2013-07-19','15:55:00',1.87),('5815','2013-07-19','16:00:00',1.8),('5815','2013-07-19','16:05:00',1.77),('5815','2013-07-19','16:10:00',1.75),('5815','2013-07-19','16:15:00',1.74),('5815','2013-07-19','16:20:00',1.72),('5815','2013-07-19','16:25:00',1.69),('5815','2013-07-19','16:30:00',1.65),('5815','2013-07-19','16:35:00',1.62),('5815','2013-07-19','16:40:00',1.57),('5815','2013-07-19','16:45:00',1.52),('5815','2013-07-19','16:50:00',1.47),('5815','2013-07-19','16:55:00',1.42),('5815','2013-07-19','17:00:00',1.39),('5815','2013-07-19','17:05:00',1.35),('5815','2013-07-19','17:10:00',1.31),('5815','2013-07-19','17:15:00',1.28),('5815','2013-07-19','17:20:00',1.24),('5815','2013-07-19','17:25:00',1.19),('5815','2013-07-19','17:30:00',1.15),('5815','2013-07-19','17:35:00',1.12),('5815','2013-07-19','17:40:00',1.06),('5815','2013-07-19','17:45:00',1.02),('5815','2013-07-18','08:55:00',1.03),('5815','2013-07-18','09:00:00',1.07),('5815','2013-07-18','09:05:00',1.11),('5815','2013-07-18','09:10:00',1.14),('5815','2013-07-18','09:15:00',1.19),('5815','2013-07-18','09:20:00',1.23),('5815','2013-07-18','09:25:00',1.27),('5815','2013-07-18','09:30:00',1.31),('5815','2013-07-18','09:35:00',1.36),('5815','2013-07-18','09:40:00',1.4),('5815','2013-07-18','09:45:00',1.43),('5815','2013-07-18','09:50:00',1.46),('5815','2013-07-18','09:55:00',1.49),('5815','2013-07-18','10:00:00',1.53),('5815','2013-07-18','10:05:00',1.55),('5815','2013-07-18','10:10:00',1.58),('5815','2013-07-18','10:15:00',1.61),('5815','2013-07-18','10:20:00',1.63),('5815','2013-07-18','10:25:00',1.71),('5815','2013-07-18','10:30:00',1.68),('5815','2013-07-18','10:35:00',1.77),('5815','2013-07-18','10:40:00',1.73),('5815','2013-07-18','10:45:00',1.78),('5815','2013-07-18','10:50:00',1.82),('5815','2013-07-18','10:55:00',1.84),('5815','2013-07-18','11:00:00',1.86),('5815','2013-07-18','11:05:00',1.82),('5815','2013-07-18','11:10:00',1.83),('5815','2013-07-18','11:15:00',1.87),('5815','2013-07-18','11:20:00',1.9),('5815','2013-07-18','11:25:00',1.93),('5815','2013-07-18','11:30:00',1.94),('5815','2013-07-18','11:35:00',1.92),('5815','2013-07-18','11:40:00',1.94),('5815','2013-07-18','11:45:00',2.08),('5815','2013-07-18','11:50:00',2.04),('5815','2013-07-18','11:55:00',1.99),('5815','2013-07-18','12:00:00',1.47),('5815','2013-07-18','12:05:00',1.87),('5815','2013-07-18','12:10:00',2.14),('5815','2013-07-18','12:15:00',2.21),('5815','2013-07-18','12:20:00',2.19),('5815','2013-07-18','12:25:00',2.21),('5815','2013-07-18','12:30:00',2.22),('5815','2013-07-18','12:35:00',2.2),('5815','2013-07-18','12:40:00',2.2),('5815','2013-07-18','12:45:00',2.17),('5815','2013-07-18','12:50:00',2.23),('5815','2013-07-18','12:55:00',1.6),('5815','2013-07-18','13:00:00',1.76),('5815','2013-07-18','13:05:00',2.32),('5815','2013-07-18','13:10:00',2.32),('5815','2013-07-18','13:15:00',1.21),('5815','2013-07-18','13:25:00',1.74),('5815','2013-07-18','13:30:00',2.51),('5815','2013-07-18','13:35:00',2.41),('5815','2013-07-18','13:40:00',2.38),('5815','2013-07-18','13:45:00',2.37),('5815','2013-07-18','13:50:00',2.38),('5815','2013-07-18','13:55:00',2.39),('5815','2013-07-18','14:00:00',2.42),('5815','2013-07-18','14:05:00',2.39),('5815','2013-07-18','14:10:00',1.94),('5815','2013-07-18','14:15:00',2.23),('5815','2013-07-18','14:20:00',1.89),('5815','2013-07-18','14:25:00',1.95),('5815','2013-07-18','14:30:00',2.23),('5815','2013-07-18','14:35:00',2.39),('5815','2013-07-18','14:40:00',2.11),('5815','2013-07-18','14:45:00',2.27),('5815','2013-07-18','14:50:00',2.06),('5815','2013-07-18','14:55:00',2.2),('5815','2013-07-18','15:00:00',2.03),('5815','2013-07-18','15:05:00',2.25),('5815','2013-07-18','15:10:00',2.17),('5815','2013-07-18','15:15:00',1.85),('5815','2013-07-18','15:20:00',1.69),('5815','2013-07-18','15:25:00',1.68),('5815','2013-07-18','15:30:00',2.17),('5815','2013-07-18','15:35:00',2.09),('5815','2013-07-18','15:40:00',1.82),('5815','2013-07-18','15:45:00',2.02),('5815','2013-07-18','15:50:00',2.01),('5815','2013-07-18','15:55:00',1.89),('5815','2013-07-18','16:00:00',1.92),('5815','2013-07-18','16:05:00',1.87),('5815','2013-07-18','16:10:00',1.78),('5815','2013-07-18','16:15:00',1.8),('5815','2013-07-18','16:20:00',1.79),('5815','2013-07-18','16:25:00',1.77),('5815','2013-07-18','16:30:00',1.74),('5815','2013-07-18','16:35:00',1.67),('5815','2013-07-18','16:40:00',1.65),('5815','2013-07-18','16:45:00',1.64),('5815','2013-07-18','16:50:00',1.5),('5815','2013-07-18','16:55:00',1.6),('5815','2013-07-18','17:00:00',1.13),('5815','2013-07-18','17:05:00',1.57),('5815','2013-07-18','17:10:00',1.51),('5815','2013-07-18','17:15:00',1.25),('5815','2013-07-18','17:25:00',1.1),('5815','2013-07-18','17:30:00',1.13),('5815','2013-07-18','17:35:00',1.03),('5815','2013-07-17','08:50:00',1.02),('5815','2013-07-17','08:55:00',1.07),('5815','2013-07-17','09:00:00',1.11),('5815','2013-07-17','09:05:00',1.16),('5815','2013-07-17','09:10:00',1.19),('5815','2013-07-17','09:15:00',1.23),('5815','2013-07-17','09:20:00',1.29),('5815','2013-07-17','09:25:00',1.32),('5815','2013-07-17','09:30:00',1.37),('5815','2013-07-17','09:35:00',1.41),('5815','2013-07-17','09:40:00',1.45),('5815','2013-07-17','09:45:00',1.48),('5815','2013-07-17','09:50:00',1.53),('5815','2013-07-17','09:55:00',1.56),('5815','2013-07-17','10:00:00',1.59),('5815','2013-07-17','10:05:00',1.6),('5815','2013-07-17','10:10:00',1.67),('5815','2013-07-17','10:15:00',1.7),('5815','2013-07-17','10:20:00',1.72),('5815','2013-07-17','10:25:00',1.76),('5815','2013-07-17','10:30:00',1.8),('5815','2013-07-17','10:35:00',1.84),('5815','2013-07-17','10:40:00',1.87),('5815','2013-07-17','10:45:00',1.89),('5815','2013-07-17','10:50:00',1.92),('5815','2013-07-17','10:55:00',1.93),('5815','2013-07-17','11:00:00',1.94),('5815','2013-07-17','11:05:00',1.9),('5815','2013-07-17','11:10:00',1.94),('5815','2013-07-17','11:15:00',1.97),('5815','2013-07-17','11:20:00',1.99),('5815','2013-07-17','11:25:00',1.99),('5815','2013-07-17','11:30:00',2.01),('5815','2013-07-17','11:35:00',2.02),('5815','2013-07-17','11:40:00',2.05),('5815','2013-07-17','11:45:00',2.06),('5815','2013-07-17','11:50:00',2.03),('5815','2013-07-17','11:55:00',2.08),('5815','2013-07-17','12:00:00',2.11),('5815','2013-07-17','12:05:00',2.09),('5815','2013-07-17','12:10:00',2.11),('5815','2013-07-17','12:15:00',2.13),('5815','2013-07-17','12:20:00',2.14),('5815','2013-07-17','12:25:00',2.17),('5815','2013-07-17','12:30:00',2.18),('5815','2013-07-17','12:35:00',2.31),('5815','2013-07-17','12:40:00',2.38),('5815','2013-07-17','12:45:00',1.62),('5815','2013-07-17','12:55:00',2),('5815','2013-07-17','13:00:00',2.36),('5815','2013-07-17','13:05:00',2.26),('5815','2013-07-17','13:10:00',2.24),('5815','2013-07-17','13:15:00',2.26),('5815','2013-07-17','13:20:00',2.37),('5815','2013-07-17','13:25:00',2.37),('5815','2013-07-17','13:30:00',2.4),('5815','2013-07-17','13:35:00',2.26),('5815','2013-07-17','13:40:00',1.92),('5815','2013-07-17','13:45:00',2.36),('5815','2013-07-17','13:50:00',2.33),('5815','2013-07-17','13:55:00',2.21),('5815','2013-07-17','14:00:00',2.28),('5815','2013-07-17','14:05:00',2.24),('5815','2013-07-17','14:10:00',2.26),('5815','2013-07-17','14:15:00',2.12),('5815','2013-07-17','14:20:00',2.28),('5815','2013-07-17','14:25:00',2.26),('5815','2013-07-17','14:30:00',2.22),('5815','2013-07-17','14:35:00',2.22),('5815','2013-07-17','14:40:00',2.2),('5815','2013-07-17','14:45:00',2.18),('5815','2013-07-17','14:50:00',2.15),('5815','2013-07-17','14:55:00',2.11),('5815','2013-07-17','15:00:00',2.09),('5815','2013-07-17','15:05:00',2.11),('5815','2013-07-17','15:10:00',2.11),('5815','2013-07-17','15:15:00',2.07),('5815','2013-07-17','15:20:00',2.05),('5815','2013-07-17','15:25:00',2.06),('5815','2013-07-17','15:30:00',2.01),('5815','2013-07-17','15:35:00',1.96),('5815','2013-07-17','15:40:00',1.95),('5815','2013-07-17','15:45:00',1.95),('5815','2013-07-17','15:50:00',1.94),('5815','2013-07-17','15:55:00',1.9),('5815','2013-07-17','16:00:00',1.82),('5815','2013-07-17','16:05:00',1.76),('5815','2013-07-17','16:10:00',1.76),('5815','2013-07-17','16:15:00',1.72),('5815','2013-07-17','16:20:00',1.69),('5815','2013-07-17','16:25:00',1.66),('5815','2013-07-17','16:30:00',1.62),('5815','2013-07-17','16:35:00',1.6),('5815','2013-07-17','16:40:00',1.56),('5815','2013-07-17','16:45:00',1.51),('5815','2013-07-17','16:50:00',1.46),('5815','2013-07-17','16:55:00',1.41),('5815','2013-07-17','17:00:00',1.29),('5815','2013-07-17','17:05:00',1.23),('5815','2013-07-17','17:10:00',1.23),('5815','2013-07-17','17:15:00',1.23),('5815','2013-07-17','17:20:00',1.1),('5815','2013-07-17','17:25:00',1.16),('5815','2013-07-17','17:30:00',1.08),('5815','2013-07-17','17:35:00',1.05),('5815','2013-07-16','08:45:00',1.02),('5815','2013-07-16','08:50:00',1.05),('5815','2013-07-16','08:55:00',1.11),('5815','2013-07-16','09:00:00',1.17),('5815','2013-07-16','09:05:00',1.22),('5815','2013-07-16','09:10:00',1.27),('5815','2013-07-16','09:15:00',1.32),('5815','2013-07-16','09:20:00',1.36),('5815','2013-07-16','09:25:00',1.4),('5815','2013-07-16','09:30:00',1.44),('5815','2013-07-16','09:35:00',1.47),('5815','2013-07-16','09:40:00',1.51),('5815','2013-07-16','09:45:00',1.56),('5815','2013-07-16','09:50:00',1.6),('5815','2013-07-16','09:55:00',1.62),('5815','2013-07-16','10:00:00',1.66),('5815','2013-07-16','10:05:00',1.68),('5815','2013-07-16','10:10:00',1.72),('5815','2013-07-16','10:15:00',1.75),('5815','2013-07-16','10:20:00',1.78),('5815','2013-07-16','10:25:00',1.82),('5815','2013-07-16','10:30:00',1.85),('5815','2013-07-16','10:35:00',1.88),('5815','2013-07-16','10:40:00',1.9),('5815','2013-07-16','10:45:00',1.94),('5815','2013-07-16','10:50:00',1.97),('5815','2013-07-16','10:55:00',1.99),('5815','2013-07-16','11:00:00',2.01),('5815','2013-07-16','11:05:00',1.98),('5815','2013-07-16','11:10:00',2),('5815','2013-07-16','11:15:00',2.02),('5815','2013-07-16','11:20:00',2.03),('5815','2013-07-16','11:25:00',2.06),('5815','2013-07-16','11:30:00',2.08),('5815','2013-07-16','11:35:00',2.09),('5815','2013-07-16','11:40:00',2.11),('5815','2013-07-16','11:45:00',2.12),('5815','2013-07-16','11:50:00',2.15),('5815','2013-07-16','11:55:00',2.17),('5815','2013-07-16','12:00:00',2.17),('5815','2013-07-16','12:05:00',2.18),('5815','2013-07-16','12:10:00',2.19),('5815','2013-07-16','12:15:00',2.17),('5815','2013-07-16','12:20:00',2.19),('5815','2013-07-16','12:25:00',2.21),('5815','2013-07-16','12:30:00',2.23),('5815','2013-07-16','12:35:00',2.24),('5815','2013-07-16','12:40:00',2.21),('5815','2013-07-16','12:45:00',2.22),('5815','2013-07-16','12:50:00',2.23),('5815','2013-07-16','12:55:00',2.26),('5815','2013-07-16','13:00:00',2.28),('5815','2013-07-16','13:05:00',2.27),('5815','2013-07-16','13:10:00',2.26),('5815','2013-07-16','13:15:00',2.27),('5815','2013-07-16','13:20:00',2.26),('5815','2013-07-16','13:25:00',2.27),('5815','2013-07-16','13:30:00',2.26),('5815','2013-07-16','13:35:00',2.24),('5815','2013-07-16','13:40:00',2.25),('5815','2013-07-16','13:45:00',2.25),('5815','2013-07-16','13:50:00',2.24),('5815','2013-07-16','13:55:00',2.24),('5815','2013-07-16','14:00:00',2.24),('5815','2013-07-16','14:05:00',2.23),('5815','2013-07-16','14:10:00',2.22),('5815','2013-07-16','14:15:00',2.25),('5815','2013-07-16','14:20:00',2.21),('5815','2013-07-16','14:25:00',2.21),('5815','2013-07-16','14:30:00',2.19),('5815','2013-07-16','14:35:00',2.16),('5815','2013-07-16','14:40:00',2.27),('5815','2013-07-16','14:45:00',2.19),('5815','2013-07-16','14:50:00',2.12),('5815','2013-07-16','14:55:00',2.09),('5815','2013-07-16','15:00:00',2.14),('5815','2013-07-16','15:05:00',2.13),('5815','2013-07-16','15:10:00',2.09),('5815','2013-07-16','15:15:00',2.1),('5815','2013-07-16','15:20:00',2.07),('5815','2013-07-16','15:25:00',2.02),('5815','2013-07-16','15:30:00',1.97),('5815','2013-07-16','15:35:00',1.96),('5815','2013-07-16','15:40:00',1.61),('5815','2013-07-16','15:45:00',1.96),('5815','2013-07-16','15:50:00',1.94),('5815','2013-07-16','15:55:00',1.9),('5815','2013-07-16','16:00:00',1.85),('5815','2013-07-16','16:05:00',1.78),('5815','2013-07-16','16:10:00',1.78),('5815','2013-07-16','16:15:00',1.74),('5815','2013-07-16','16:20:00',1.69),('5815','2013-07-16','16:25:00',1.66),('5815','2013-07-16','16:30:00',1.64),('5815','2013-07-16','16:35:00',1.62),('5815','2013-07-16','16:40:00',1.56),('5815','2013-07-16','16:45:00',1.56),('5815','2013-07-16','16:50:00',1.51),('5815','2013-07-16','16:55:00',1.43),('5815','2013-07-16','17:00:00',1.21),('5815','2013-07-16','17:05:00',1.38),('5815','2013-07-16','17:10:00',1.37),('5815','2013-07-16','17:15:00',1.32),('5815','2013-07-16','17:20:00',1.26),('5815','2013-07-16','17:25:00',1.18),('5815','2013-07-16','17:30:00',1.12),('5815','2013-07-16','17:35:00',1.08),('5815','2013-07-15','08:50:00',1.03),('5815','2013-07-15','08:55:00',1.08),('5815','2013-07-15','09:00:00',1.11),('5815','2013-07-15','09:05:00',1.15),('5815','2013-07-15','09:10:00',1.2),('5815','2013-07-15','09:15:00',1.24),('5815','2013-07-15','09:20:00',1.28),('5815','2013-07-15','09:25:00',1.33),('5815','2013-07-15','09:30:00',1.37),('5815','2013-07-15','09:35:00',1.4),('5815','2013-07-15','09:40:00',1.44),('5815','2013-07-15','09:45:00',1.5),('5815','2013-07-15','09:50:00',1.54),('5815','2013-07-15','09:55:00',1.58),('5815','2013-07-15','10:00:00',1.62),('5815','2013-07-15','10:05:00',1.66),('5815','2013-07-15','10:10:00',1.7),('5815','2013-07-15','10:15:00',1.72),('5815','2013-07-15','10:20:00',1.74),('5815','2013-07-15','10:25:00',1.78),('5815','2013-07-15','10:30:00',1.81),('5815','2013-07-15','10:35:00',1.84),('5815','2013-07-15','10:40:00',1.87),('5815','2013-07-15','10:45:00',1.89),('5815','2013-07-15','10:50:00',1.92),('5815','2013-07-15','10:55:00',1.95),('5815','2013-07-15','11:00:00',1.96),('5815','2013-07-15','11:05:00',1.9),('5815','2013-07-15','11:10:00',1.96),('5815','2013-07-15','11:15:00',1.98),('5815','2013-07-15','11:20:00',2),('5815','2013-07-15','11:25:00',2.02),('5815','2013-07-15','11:30:00',2.02),('5815','2013-07-15','11:35:00',2.03),('5815','2013-07-15','11:40:00',2.09),('5815','2013-07-15','11:45:00',2.11),('5815','2013-07-15','11:50:00',2.1),('5815','2013-07-15','11:55:00',2.14),('5815','2013-07-15','12:00:00',2.16),('5815','2013-07-15','12:05:00',2.16),('5815','2013-07-15','12:10:00',2.18),('5815','2013-07-15','12:15:00',2.19),('5815','2013-07-15','12:20:00',2.19),('5815','2013-07-15','12:25:00',2.21),('5815','2013-07-15','12:30:00',2.22),('5815','2013-07-15','12:35:00',2.22),('5815','2013-07-15','12:40:00',2.19),('5815','2013-07-15','12:45:00',2.16),('5815','2013-07-15','12:50:00',2.19),('5815','2013-07-15','12:55:00',2.2),('5815','2013-07-15','13:00:00',2.21),('5815','2013-07-15','13:05:00',2.23),('5815','2013-07-15','13:10:00',2.23),('5815','2013-07-15','13:15:00',2.26),('5815','2013-07-15','13:20:00',2.26),('5815','2013-07-15','13:25:00',2.29),('5815','2013-07-15','13:30:00',2.26),('5815','2013-07-15','13:35:00',2.25),('5815','2013-07-15','13:40:00',2.24),('5815','2013-07-15','13:45:00',2.3),('5815','2013-07-15','13:50:00',2.26),('5815','2013-07-15','13:55:00',2.19),('5815','2013-07-15','14:00:00',2.21),('5815','2013-07-15','14:05:00',2.24),('5815','2013-07-15','14:10:00',2.06),('5815','2013-07-15','14:15:00',1.61),('5815','2013-07-15','14:20:00',1.15),('5815','2013-07-15','14:25:00',2.32),('5815','2013-07-15','14:30:00',2.25),('5815','2013-07-15','14:35:00',2.23),('5815','2013-07-15','14:40:00',2.19),('5815','2013-07-15','14:45:00',2.17),('5815','2013-07-15','14:50:00',2.17),('5815','2013-07-15','14:55:00',2.17),('5815','2013-07-15','15:00:00',2.15),('5815','2013-07-15','15:05:00',2.11),('5815','2013-07-15','15:10:00',2.05),('5815','2013-07-15','15:15:00',2.03),('5815','2013-07-15','15:20:00',2.02),('5815','2013-07-15','15:25:00',1.97),('5815','2013-07-15','15:30:00',2.01),('5815','2013-07-15','15:35:00',1.98),('5815','2013-07-15','15:40:00',1.92),('5815','2013-07-15','15:45:00',1.4),('5815','2013-07-15','15:50:00',1.95),('5815','2013-07-15','15:55:00',1.85),('5815','2013-07-15','16:00:00',1.1),('5815','2013-07-15','16:10:00',1.71),('5815','2013-07-15','16:15:00',1.6),('5815','2013-07-15','16:20:00',1.24),('5815','2013-07-15','17:00:00',1.45),('5815','2013-07-15','17:05:00',1.43),('5815','2013-07-15','17:10:00',1.5),('5815','2013-07-15','17:15:00',1.38),('5815','2013-07-15','17:20:00',1.3),('5815','2013-07-15','17:45:00',1.12),('5815','2013-07-15','17:50:00',1.04),('5815','2013-07-14','08:45:00',1.02),('5815','2013-07-14','08:50:00',1.06),('5815','2013-07-14','08:55:00',1.11),('5815','2013-07-14','09:00:00',1.16),('5815','2013-07-14','09:05:00',1.2),('5815','2013-07-14','09:10:00',1.26),('5815','2013-07-14','09:15:00',1.3),('5815','2013-07-14','09:20:00',1.34),('5815','2013-07-14','09:25:00',1.38),('5815','2013-07-14','09:30:00',1.42),('5815','2013-07-14','09:35:00',1.46),('5815','2013-07-14','09:40:00',1.5),('5815','2013-07-14','09:45:00',1.53),('5815','2013-07-14','09:50:00',1.57),('5815','2013-07-14','09:55:00',1.61),('5815','2013-07-14','10:00:00',1.63),('5815','2013-07-14','10:05:00',1.66),('5815','2013-07-14','10:10:00',1.7),('5815','2013-07-14','10:15:00',1.73),('5815','2013-07-14','10:20:00',1.73),('5815','2013-07-14','10:25:00',1.79),('5815','2013-07-14','10:30:00',1.81),('5815','2013-07-14','10:35:00',1.85),('5815','2013-07-14','10:40:00',1.88),('5815','2013-07-14','10:45:00',1.91),('5815','2013-07-14','10:50:00',1.93),('5815','2013-07-14','10:55:00',1.96),('5815','2013-07-14','11:00:00',1.99),('5815','2013-07-14','11:05:00',1.96),('5815','2013-07-14','11:10:00',1.99),('5815','2013-07-14','11:15:00',2),('5815','2013-07-14','11:20:00',2.02),('5815','2013-07-14','11:25:00',2.04),('5815','2013-07-14','11:30:00',2.05),('5815','2013-07-14','11:35:00',2.07),('5815','2013-07-14','11:40:00',2.12),('5815','2013-07-14','11:45:00',2.11),('5815','2013-07-14','11:50:00',2.06),('5815','2013-07-14','11:55:00',2.12),('5815','2013-07-14','12:00:00',2.13),('5815','2013-07-14','12:05:00',2.12),('5815','2013-07-14','12:10:00',2.13),('5815','2013-07-14','12:15:00',2.17),('5815','2013-07-14','12:20:00',2.18),('5815','2013-07-14','12:25:00',2.19),('5815','2013-07-14','12:30:00',2.23),('5815','2013-07-14','12:35:00',2.22),('5815','2013-07-14','12:40:00',2.18),('5815','2013-07-14','12:45:00',2.18),('5815','2013-07-14','12:50:00',2.2),('5815','2013-07-14','12:55:00',2.21),('5815','2013-07-14','13:00:00',1.89),('5815','2013-07-14','13:05:00',2.09),('5815','2013-07-14','13:10:00',2.06),('5815','2013-07-14','13:15:00',2.25),('5815','2013-07-14','13:20:00',2.27),('5815','2013-07-14','13:25:00',2.4),('5815','2013-07-14','13:30:00',2.39),('5815','2013-07-14','13:35:00',1.51),('5815','2013-07-14','13:45:00',1.26),('5815','2013-07-14','13:50:00',2.54),('5815','2013-07-14','13:55:00',2.46),('5815','2013-07-14','14:00:00',2.46),('5815','2013-07-14','14:05:00',1.45),('5815','2013-07-14','14:20:00',2.08),('5815','2013-07-14','14:25:00',2.35),('5815','2013-07-14','14:30:00',1.95),('5815','2013-07-14','14:35:00',2.28),('5815','2013-07-14','14:40:00',2.27),('5815','2013-07-14','14:45:00',2.21),('5815','2013-07-14','14:50:00',2.21),('5815','2013-07-14','14:55:00',2.21),('5815','2013-07-14','15:00:00',2.21),('5815','2013-07-14','15:05:00',2.18),('5815','2013-07-14','15:10:00',2.12),('5815','2013-07-14','15:15:00',2.11),('5815','2013-07-14','15:20:00',2.05),('5815','2013-07-14','15:25:00',2.02),('5815','2013-07-14','15:30:00',2.01),('5815','2013-07-14','15:35:00',1.95),('5815','2013-07-14','15:40:00',2.03),('5815','2013-07-14','15:45:00',1.94),('5815','2013-07-14','15:50:00',2.04),('5815','2013-07-14','15:55:00',1.81),('5815','2013-07-14','16:00:00',1.85),('5815','2013-07-14','16:05:00',1.82),('5815','2013-07-14','16:10:00',1.8),('5815','2013-07-14','16:15:00',1.78),('5815','2013-07-14','16:20:00',1.69),('5815','2013-07-14','16:25:00',1.65),('5815','2013-07-14','16:30:00',1.62),('5815','2013-07-14','16:35:00',1.61),('5815','2013-07-14','16:40:00',1.57),('5815','2013-07-14','16:45:00',1.52),('5815','2013-07-14','16:50:00',1.48),('5815','2013-07-14','16:55:00',1.44),('5815','2013-07-14','17:00:00',1.37),('5815','2013-07-14','17:05:00',1.37),('5815','2013-07-14','17:10:00',1.32),('5815','2013-07-14','17:15:00',1.29),('5815','2013-07-14','17:20:00',1.23),('5815','2013-07-14','17:25:00',1.21),('5815','2013-07-14','17:30:00',1.17),('5815','2013-07-14','17:35:00',1.1),('5815','2013-07-14','17:40:00',1.02),('5815','2013-07-13','08:20:00',1.13),('5815','2013-07-13','09:25:00',1.25),('5815','2013-07-13','09:30:00',1.2),('5815','2013-07-13','10:15:00',1),('5815','2013-07-13','10:20:00',1.28),('5815','2013-07-13','10:25:00',1.53),('5815','2013-07-13','10:30:00',1.36),('5815','2013-07-13','10:35:00',1.84),('5815','2013-07-13','10:40:00',1.95),('5815','2013-07-13','10:45:00',1.8),('5815','2013-07-13','10:50:00',2.1),('5815','2013-07-13','10:55:00',1.8),('5815','2013-07-13','11:00:00',2.18),('5815','2013-07-13','11:05:00',2.1),('5815','2013-07-13','11:10:00',1.5),('5815','2013-07-13','11:15:00',1.74),('5815','2013-07-13','11:20:00',2.37),('5815','2013-07-13','11:25:00',2.19),('5815','2013-07-13','11:30:00',2.28),('5815','2013-07-13','11:35:00',2.17),('5815','2013-07-13','11:40:00',2.13),('5815','2013-07-13','11:45:00',2.4),('5815','2013-07-13','11:50:00',1.9),('5815','2013-07-13','12:10:00',2.02),('5815','2013-07-13','12:15:00',1.9),('5815','2013-07-13','12:20:00',1.24),('5815','2013-07-13','12:25:00',1.26),('5815','2013-07-13','12:45:00',1.84),('5815','2013-07-13','12:50:00',1.56),('5815','2013-07-13','12:55:00',2.02),('5815','2013-07-13','13:00:00',2.52),('5815','2013-07-13','13:05:00',2.53),('5815','2013-07-13','13:10:00',2.45),('5815','2013-07-13','13:15:00',2.46),('5815','2013-07-13','13:20:00',2.52),('5815','2013-07-13','13:25:00',2.43),('5815','2013-07-13','13:30:00',2.41),('5815','2013-07-13','13:35:00',2.4),('5815','2013-07-13','13:40:00',2.37),('5815','2013-07-13','13:45:00',2.37),('5815','2013-07-13','13:50:00',2.38),('5815','2013-07-13','13:55:00',2.38),('5815','2013-07-13','14:00:00',2.38),('5815','2013-07-13','14:05:00',2.38),('5815','2013-07-13','14:10:00',2.37),('5815','2013-07-13','14:15:00',2.4),('5815','2013-07-13','14:20:00',2.36),('5815','2013-07-13','14:25:00',2.32),('5815','2013-07-13','14:30:00',2.3),('5815','2013-07-13','14:35:00',2.25),('5815','2013-07-13','14:40:00',2.21),('5815','2013-07-13','14:45:00',2.19),('5815','2013-07-13','14:50:00',2.23),('5815','2013-07-13','14:55:00',2.23),('5815','2013-07-13','15:00:00',2.19),('5815','2013-07-13','15:05:00',2.18),('5815','2013-07-13','15:10:00',2.14),('5815','2013-07-13','15:15:00',2.1),('5815','2013-07-13','15:20:00',2.07),('5815','2013-07-13','15:25:00',2.04),('5815','2013-07-13','15:30:00',2.02),('5815','2013-07-13','15:35:00',2),('5815','2013-07-13','15:40:00',1.98),('5815','2013-07-13','15:45:00',1.98),('5815','2013-07-13','15:50:00',1.96),('5815','2013-07-13','15:55:00',1.94),('5815','2013-07-13','16:00:00',1.84),('5815','2013-07-13','16:05:00',1.81),('5815','2013-07-13','16:10:00',1.79),('5815','2013-07-13','16:15:00',1.78),('5815','2013-07-13','16:20:00',1.63),('5815','2013-07-13','16:25:00',1.67),('5815','2013-07-13','16:30:00',1.36),('5815','2013-07-13','16:35:00',1.37),('5815','2013-07-13','16:40:00',1.56),('5815','2013-07-13','16:45:00',1.52),('5815','2013-07-13','16:50:00',1.53),('5815','2013-07-13','16:55:00',1.57),('5815','2013-07-13','17:00:00',1.39),('5815','2013-07-13','17:05:00',1.13),('5815','2013-07-13','17:10:00',1.12),('5815','2013-07-13','17:15:00',1.04),('5815','2013-07-13','17:25:00',1.04),('5815','2013-07-13','17:30:00',1.08),('5815','2013-07-13','17:35:00',1.13),('5815','2013-07-12','08:50:00',1.02),('5815','2013-07-12','08:55:00',1.05),('5815','2013-07-12','09:00:00',1.11),('5815','2013-07-12','09:05:00',1.16),('5815','2013-07-12','09:10:00',1.2),('5815','2013-07-12','09:15:00',1.25),('5815','2013-07-12','09:20:00',1.28),('5815','2013-07-12','09:25:00',1.34),('5815','2013-07-12','09:30:00',1.36),('5815','2013-07-12','09:35:00',1.41),('5815','2013-07-12','09:40:00',1.45),('5815','2013-07-12','09:45:00',1.5),('5815','2013-07-12','09:50:00',1.55),('5815','2013-07-12','09:55:00',1.57),('5815','2013-07-12','10:00:00',1.58),('5815','2013-07-12','10:05:00',1.62),('5815','2013-07-12','10:10:00',1.68),('5815','2013-07-12','10:15:00',1.66),('5815','2013-07-12','10:20:00',1.72),('5815','2013-07-12','10:25:00',1.81),('5815','2013-07-12','10:30:00',1.84),('5815','2013-07-12','10:35:00',1.83),('5815','2013-07-12','10:40:00',1.81),('5815','2013-07-12','10:45:00',1.88),('5815','2013-07-12','10:50:00',1.89),('5815','2013-07-12','10:55:00',1.99),('5815','2013-07-12','11:00:00',1.98),('5815','2013-07-12','11:05:00',2.06),('5815','2013-07-12','11:10:00',2.13),('5815','2013-07-12','11:15:00',1.41),('5815','2013-07-12','11:25:00',1.17),('5815','2013-07-12','11:30:00',2.15),('5815','2013-07-12','11:35:00',2.18),('5815','2013-07-12','11:40:00',1.91),('5815','2013-07-12','11:50:00',2.14),('5815','2013-07-12','11:55:00',1.72),('5815','2013-07-12','12:00:00',1.52),('5815','2013-07-12','12:05:00',1.94),('5815','2013-07-12','12:10:00',2.23),('5815','2013-07-12','12:15:00',1.12),('5815','2013-07-12','12:20:00',1.12),('5815','2013-07-12','12:25:00',1.53),('5815','2013-07-12','12:35:00',2.44),('5815','2013-07-12','12:40:00',2.45),('5815','2013-07-12','12:45:00',1.43),('5815','2013-07-12','12:50:00',1.66),('5815','2013-07-12','12:55:00',2.39),('5815','2013-07-12','13:00:00',2.39),('5815','2013-07-12','13:05:00',2.43),('5815','2013-07-12','13:10:00',1.87),('5815','2013-07-12','13:15:00',1.98),('5815','2013-07-12','13:20:00',2.46),('5815','2013-07-12','13:25:00',2.43),('5815','2013-07-12','13:30:00',2.36),('5815','2013-07-12','13:35:00',2.35),('5815','2013-07-12','13:40:00',2.34),('5815','2013-07-12','13:45:00',2.31),('5815','2013-07-12','13:50:00',2.32),('5815','2013-07-12','13:55:00',2.33),('5815','2013-07-12','14:00:00',2.31),('5815','2013-07-12','14:05:00',2.32),('5815','2013-07-12','14:10:00',2.32),('5815','2013-07-12','14:15:00',2.32),('5815','2013-07-12','14:20:00',2.29),('5815','2013-07-12','14:25:00',2.26),('5815','2013-07-12','14:30:00',2.26),('5815','2013-07-12','14:35:00',2.25),('5815','2013-07-12','14:40:00',2.23),('5815','2013-07-12','14:45:00',2.23),('5815','2013-07-12','14:50:00',2.21),('5815','2013-07-12','14:55:00',2.22),('5815','2013-07-12','15:00:00',2.21),('5815','2013-07-12','15:05:00',2.21),('5815','2013-07-12','15:10:00',2.16),('5815','2013-07-12','15:15:00',2.15),('5815','2013-07-12','15:20:00',2.04),('5815','2013-07-12','15:25:00',2.13),('5815','2013-07-12','15:30:00',2.07),('5815','2013-07-12','15:35:00',2.06),('5815','2013-07-12','15:40:00',2.04),('5815','2013-07-12','15:45:00',2.03),('5815','2013-07-12','15:50:00',2.03),('5815','2013-07-12','15:55:00',1.99),('5815','2013-07-12','16:00:00',1.89),('5815','2013-07-12','16:05:00',1.84),('5815','2013-07-12','16:10:00',1.87),('5815','2013-07-12','16:15:00',1.81),('5815','2013-07-12','16:20:00',1.73),('5815','2013-07-12','16:25:00',1.78),('5815','2013-07-12','16:30:00',1.74),('5815','2013-07-12','16:35:00',1.71),('5815','2013-07-12','16:40:00',1.66),('5815','2013-07-12','16:45:00',1.6),('5815','2013-07-12','16:50:00',1.53),('5815','2013-07-12','16:55:00',1.48),('5815','2013-07-12','17:00:00',1.4),('5815','2013-07-12','17:05:00',1.32),('5815','2013-07-12','17:10:00',1.39),('5815','2013-07-12','17:15:00',1.36),('5815','2013-07-12','17:20:00',1.27),('5815','2013-07-12','17:25:00',1.27),('5815','2013-07-12','17:30:00',1.17),('5815','2013-07-12','17:35:00',1.11),('5815','2013-07-12','17:40:00',1.1),('5815','2013-07-12','17:45:00',1.08),('5815','2013-07-12','17:50:00',1.01),('5815','2013-07-12','17:55:00',1.03),('5815','2013-07-11','09:20:00',1.1),('5815','2013-07-11','09:25:00',1.3),('5815','2013-07-11','09:40:00',1.01),('5815','2013-07-11','09:45:00',1.53),('5815','2013-07-11','09:50:00',1.52),('5815','2013-07-11','09:55:00',1.58),('5815','2013-07-11','10:00:00',1.59),('5815','2013-07-11','10:05:00',1.61),('5815','2013-07-11','10:15:00',1.48),('5815','2013-07-11','10:30:00',1.17),('5815','2013-07-11','10:35:00',1.11),('5815','2013-07-11','10:55:00',1.11),('5815','2013-07-11','11:00:00',2.26),('5815','2013-07-11','11:05:00',1.06),('5815','2013-07-11','11:15:00',1.54),('5815','2013-07-11','11:25:00',2.05),('5815','2013-07-11','11:30:00',2.33),('5815','2013-07-11','11:35:00',2.13),('5815','2013-07-11','11:40:00',1.53),('5815','2013-07-11','11:45:00',1.91),('5815','2013-07-11','11:50:00',2),('5815','2013-07-11','11:55:00',1.82),('5815','2013-07-11','12:00:00',2.33),('5815','2013-07-11','12:05:00',1.35),('5815','2013-07-11','12:10:00',2.29),('5815','2013-07-11','12:15:00',1.38),('5815','2013-07-11','12:20:00',2.41),('5815','2013-07-11','12:25:00',1.56),('5815','2013-07-11','12:30:00',2.31),('5815','2013-07-11','12:35:00',2.17),('5815','2013-07-11','12:40:00',1.66),('5815','2013-07-11','12:45:00',2.05),('5815','2013-07-11','12:50:00',1.59),('5815','2013-07-11','12:55:00',2.44),('5815','2013-07-11','13:00:00',2.37),('5815','2013-07-11','13:05:00',2.43),('5815','2013-07-11','13:10:00',2.4),('5815','2013-07-11','13:15:00',2.42),('5815','2013-07-11','13:20:00',2.41),('5815','2013-07-11','13:25:00',2.41),('5815','2013-07-11','13:30:00',2.42),('5815','2013-07-11','13:35:00',2.41),('5815','2013-07-11','13:40:00',2.41),('5815','2013-07-11','13:45:00',2.39),('5815','2013-07-11','13:50:00',2.44),('5815','2013-07-11','13:55:00',2.39),('5815','2013-07-11','14:00:00',1.94),('5815','2013-07-11','14:05:00',1.96),('5815','2013-07-11','14:10:00',1.83),('5815','2013-07-11','14:15:00',2.11),('5815','2013-07-11','14:20:00',2.56),('5815','2013-07-11','14:25:00',2.47),('5815','2013-07-11','14:30:00',1.55),('5815','2013-07-11','14:35:00',1.77),('5815','2013-07-11','14:40:00',2.26),('5815','2013-07-11','14:45:00',2.21),('5815','2013-07-11','14:50:00',2.19),('5815','2013-07-11','14:55:00',2.18),('5815','2013-07-11','15:00:00',2.09),('5815','2013-07-11','15:05:00',2.17),('5815','2013-07-11','15:10:00',2.07),('5815','2013-07-11','15:15:00',1.73),('5815','2013-07-11','15:20:00',2.11),('5815','2013-07-11','15:25:00',2.06),('5815','2013-07-11','15:30:00',1.93),('5815','2013-07-11','15:35:00',1.69),('5815','2013-07-11','15:40:00',2.05),('5815','2013-07-11','15:45:00',1.77),('5815','2013-07-11','15:50:00',1.88),('5815','2013-07-11','15:55:00',1.93),('5815','2013-07-11','16:00:00',1.84),('5815','2013-07-11','16:05:00',1.81),('5815','2013-07-11','16:10:00',1.79),('5815','2013-07-11','16:15:00',1.74),('5815','2013-07-11','16:20:00',1.71),('5815','2013-07-11','16:25:00',1.7),('5815','2013-07-11','16:30:00',1.66),('5815','2013-07-11','16:35:00',1.6),('5815','2013-07-11','16:40:00',1.59),('5815','2013-07-11','16:45:00',1.55),('5815','2013-07-11','16:50:00',1.5),('5815','2013-07-11','16:55:00',1.46),('5815','2013-07-11','17:00:00',1.37),('5815','2013-07-11','17:05:00',1.35),('5815','2013-07-11','17:10:00',1.35),('5815','2013-07-11','17:15:00',1.29),('5815','2013-07-11','17:20:00',1.26),('5815','2013-07-11','17:25:00',1.18),('5815','2013-07-11','17:30:00',1.11),('5815','2013-07-11','17:35:00',1.08),('5815','2013-07-11','17:40:00',1.04),('5815','2013-07-11','17:45:00',1.01),('5815','2013-07-10','08:50:00',1.01),('5815','2013-07-10','08:55:00',1.08),('5815','2013-07-10','09:00:00',1.13),('5815','2013-07-10','09:05:00',1.19),('5815','2013-07-10','09:10:00',1.2),('5815','2013-07-10','09:15:00',1.25),('5815','2013-07-10','09:20:00',1.22),('5815','2013-07-10','09:25:00',1.43),('5815','2013-07-10','09:30:00',1.47),('5815','2013-07-10','09:35:00',1.39),('5815','2013-07-10','09:40:00',1.33),('5815','2013-07-10','09:45:00',1.61),('5815','2013-07-10','09:50:00',1.23),('5815','2013-07-10','09:55:00',1.15),('5815','2013-07-10','10:00:00',1.35),('5815','2013-07-10','10:15:00',1.78),('5815','2013-07-10','10:20:00',1.8),('5815','2013-07-10','10:25:00',1.82),('5815','2013-07-10','10:30:00',1.96),('5815','2013-07-10','10:35:00',1.11),('5815','2013-07-10','10:45:00',1.55),('5815','2013-07-10','10:50:00',1.97),('5815','2013-07-10','10:55:00',2.11),('5815','2013-07-10','11:00:00',1.78),('5815','2013-07-10','11:05:00',1.59),('5815','2013-07-10','11:10:00',2.01),('5815','2013-07-10','11:15:00',1.19),('5815','2013-07-10','11:20:00',1.52),('5815','2013-07-10','11:25:00',1.3),('5815','2013-07-10','11:30:00',1.66),('5815','2013-07-10','11:35:00',1.74),('5815','2013-07-10','11:40:00',2.46),('5815','2013-07-10','11:45:00',2.31),('5815','2013-07-10','11:50:00',1.48),('5815','2013-07-10','12:00:00',1.97),('5815','2013-07-10','12:15:00',1.22),('5815','2013-07-10','12:20:00',2.43),('5815','2013-07-10','12:25:00',2.36),('5815','2013-07-10','12:30:00',2.13),('5815','2013-07-10','12:35:00',2.35),('5815','2013-07-10','12:40:00',1.64),('5815','2013-07-10','12:45:00',1.11),('5815','2013-07-10','12:50:00',1.55),('5815','2013-07-10','12:55:00',2.18),('5815','2013-07-10','13:00:00',2.5),('5815','2013-07-10','13:05:00',2.02),('5815','2013-07-10','13:10:00',2.34),('5815','2013-07-10','13:15:00',2.42),('5815','2013-07-10','13:20:00',2.45),('5815','2013-07-10','13:25:00',2.46),('5815','2013-07-10','13:30:00',2.5),('5815','2013-07-10','13:35:00',2.33),('5815','2013-07-10','13:40:00',2.47),('5815','2013-07-10','13:45:00',2.19),('5815','2013-07-10','13:50:00',1.8),('5815','2013-07-10','13:55:00',1.91),('5815','2013-07-10','14:00:00',2.2),('5815','2013-07-10','14:05:00',2.11),('5815','2013-07-10','14:10:00',2.43),('5815','2013-07-10','14:15:00',2.43),('5815','2013-07-10','14:20:00',2.38),('5815','2013-07-10','14:25:00',2.09),('5815','2013-07-10','14:30:00',2.13),('5815','2013-07-10','14:35:00',2.34),('5815','2013-07-10','14:40:00',2.3),('5815','2013-07-10','14:45:00',2.25),('5815','2013-07-10','14:50:00',2.29),('5815','2013-07-10','14:55:00',1.69),('5815','2013-07-10','15:00:00',2.41),('5815','2013-07-10','15:05:00',1.31),('5815','2013-07-10','15:10:00',1.13),('5815','2013-07-10','15:15:00',2.18),('5815','2013-07-10','15:20:00',1.39),('5815','2013-07-10','15:25:00',1.54),('5815','2013-07-10','15:30:00',1.74),('5815','2013-07-10','15:35:00',2.21),('5815','2013-07-10','15:40:00',1.62),('5815','2013-07-10','15:45:00',1.84),('5815','2013-07-10','15:50:00',1.55),('5815','2013-07-10','15:55:00',1.18),('5815','2013-07-10','16:00:00',1.42),('5815','2013-07-10','16:05:00',1.47),('5815','2013-07-10','16:10:00',1.59),('5815','2013-07-10','16:15:00',1.24),('5815','2013-07-10','16:20:00',1.11),('5815','2013-07-10','16:25:00',1.28),('5815','2013-07-10','16:30:00',1.61),('5815','2013-07-10','16:40:00',1.59),('5815','2013-07-10','16:45:00',1.24),('5815','2013-07-10','16:50:00',1.53),('5815','2013-07-10','16:55:00',1.59),('5815','2013-07-10','17:00:00',1.38),('5815','2013-07-10','17:05:00',1.18),('5815','2013-07-10','17:10:00',1.05),('5815','2013-07-10','17:20:00',1.02),('5815','2013-07-10','17:30:00',1.2),('5815','2013-07-10','17:35:00',1.14),('5815','2013-07-10','17:40:00',1.11),('5815','2013-07-10','17:45:00',1.02),('5815','2013-07-10','18:05:00',1.03),('5815','2014-05-02','08:50:00',1.22),('5815','2014-05-02','08:55:00',1.39),('5815','2014-05-02','09:00:00',1.64),('5815','2014-05-02','09:05:00',1.81),('5815','2014-05-02','09:10:00',1.17),('5815','2014-05-02','09:20:00',1.35),('5815','2014-05-02','09:25:00',1.78),('5815','2014-05-02','09:30:00',1.06),('5815','2014-05-02','09:35:00',1.72),('5815','2014-05-02','09:40:00',1.03),('5815','2014-05-02','09:45:00',1.6),('5815','2014-05-02','09:55:00',1.66),('5815','2014-05-02','10:00:00',1.99),('5815','2014-05-02','10:05:00',2.01),('5815','2014-05-02','10:10:00',2.05),('5815','2014-05-02','10:15:00',2.21),('5815','2014-05-02','10:20:00',1.71),('5815','2014-05-02','10:25:00',1.85),('5815','2014-05-02','10:30:00',1.39),('5815','2014-05-02','10:45:00',1.1),('5815','2014-05-02','10:55:00',1.16),('5815','2014-05-02','11:05:00',1.76),('5815','2014-05-02','11:10:00',2.95),('5815','2014-05-02','11:15:00',1.08),('5815','2014-05-02','11:20:00',1.46),('5815','2014-05-02','11:25:00',1.8),('5815','2014-05-02','11:30:00',2.66),('5815','2014-05-02','11:35:00',1.72),('5815','2014-05-02','11:40:00',1.62),('5815','2014-05-02','11:45:00',1.58),('5815','2014-05-02','11:50:00',1.33),('5815','2014-05-02','11:55:00',1.45),('5815','2014-05-02','12:00:00',1.24),('5815','2014-05-02','12:05:00',1.03),('5815','2014-05-02','12:35:00',1.15),('5815','2014-05-02','12:40:00',1.04),('5815','2014-05-02','12:45:00',1.07),('5815','2014-05-02','12:50:00',1.09),('5815','2014-05-02','12:55:00',1.12),('5815','2014-05-02','13:00:00',1.15),('5815','2014-05-02','13:05:00',1.09),('5815','2014-05-02','13:10:00',1.65),('5815','2014-05-02','13:15:00',1.65),('5815','2014-05-02','13:20:00',1.46),('5815','2014-05-02','13:25:00',1.8),('5815','2014-05-02','13:30:00',1.73),('5815','2014-05-02','13:35:00',1.39),('5815','2014-05-02','13:40:00',1.04),('5815','2014-05-02','13:45:00',1.02),('5815','2014-05-02','13:50:00',1.02),('5815','2014-05-02','13:55:00',1.03),('5815','2014-05-02','14:00:00',1),('5815','2014-05-02','14:05:00',1),('5815','2014-05-02','14:10:00',1.09),('5815','2014-05-02','14:15:00',1.22),('5815','2014-05-02','14:20:00',1.39),('5815','2014-05-02','14:25:00',1.62),('5815','2014-05-02','14:30:00',1.34),('5815','2013-07-09','08:25:00',1.1),('5815','2013-07-09','08:30:00',1.07),('5815','2013-07-09','08:35:00',1.17),('5815','2013-07-09','08:40:00',1.23),('5815','2013-07-09','08:45:00',1.17),('5815','2013-07-09','08:50:00',1.17),('5815','2013-07-09','08:55:00',1.15),('5815','2013-07-09','09:00:00',1.18),('5815','2013-07-09','09:05:00',1.26),('5815','2013-07-09','09:10:00',1.32),('5815','2013-07-09','09:15:00',1.36),('5815','2013-07-09','09:20:00',1.39),('5815','2013-07-09','09:25:00',1.38),('5815','2013-07-09','09:30:00',1.44),('5815','2013-07-09','09:35:00',1.46),('5815','2013-07-09','09:40:00',1.48),('5815','2013-07-09','09:45:00',1.51),('5815','2013-07-09','09:50:00',1.56),('5815','2013-07-09','09:55:00',1.63),('5815','2013-07-09','10:00:00',1.54),('5815','2013-07-09','10:05:00',1.67),('5815','2013-07-09','10:10:00',1.69),('5815','2013-07-09','10:15:00',1.73),('5815','2013-07-09','10:20:00',1.77),('5815','2013-07-09','10:25:00',1.81),('5815','2013-07-09','10:30:00',1.83),('5815','2013-07-09','10:35:00',1.86),('5815','2013-07-09','10:40:00',1.89),('5815','2013-07-09','10:45:00',1.91),('5815','2013-07-09','10:50:00',1.91),('5815','2013-07-09','10:55:00',1.93),('5815','2013-07-09','11:00:00',1.96),('5815','2013-07-09','11:05:00',1.93),('5815','2013-07-09','11:10:00',1.91),('5815','2013-07-09','11:15:00',1.93),('5815','2013-07-09','11:20:00',2),('5815','2013-07-09','11:25:00',2.02),('5815','2013-07-09','11:30:00',2.03),('5815','2013-07-09','11:35:00',2.02),('5815','2013-07-09','11:40:00',2.03),('5815','2013-07-09','11:45:00',2.04),('5815','2013-07-09','11:50:00',2.09),('5815','2013-07-09','11:55:00',2.15),('5815','2013-07-09','12:00:00',2.14),('5815','2013-07-09','12:05:00',2.16),('5815','2013-07-09','12:10:00',2.16),('5815','2013-07-09','12:15:00',2.16),('5815','2013-07-09','12:20:00',2.2),('5815','2013-07-09','12:25:00',2.23),('5815','2013-07-09','12:30:00',2.23),('5815','2013-07-09','12:35:00',2.21),('5815','2013-07-09','12:40:00',2.2),('5815','2013-07-09','12:45:00',2.23),('5815','2013-07-09','12:50:00',2.25),('5815','2013-07-09','12:55:00',2.26),('5815','2013-07-09','13:00:00',2.27),('5815','2013-07-09','13:05:00',2.28),('5815','2013-07-09','13:10:00',2.31),('5815','2013-07-09','13:15:00',2.29),('5815','2013-07-09','13:20:00',2.33),('5815','2013-07-09','13:25:00',2.35),('5815','2013-07-09','13:30:00',2.32),('5815','2013-07-09','13:35:00',2.3),('5815','2013-07-09','13:40:00',2.29),('5815','2013-07-09','13:45:00',2.3),('5815','2013-07-09','13:50:00',2.34),('5815','2013-07-09','13:55:00',2.31),('5815','2013-07-09','14:00:00',2.31),('5815','2013-07-09','14:05:00',2.32),('5815','2013-07-09','14:10:00',2.32),('5815','2013-07-09','14:15:00',2.34),('5815','2013-07-09','14:20:00',2.27),('5815','2013-07-09','14:25:00',2.25),('5815','2013-07-09','14:30:00',2.25),('5815','2013-07-09','14:35:00',2.25),('5815','2013-07-09','14:40:00',2.23),('5815','2013-07-09','14:45:00',2.22),('5815','2013-07-09','14:50:00',2.2),('5815','2013-07-09','14:55:00',2.2),('5815','2013-07-09','15:00:00',2.2),('5815','2013-07-09','15:05:00',2.22),('5815','2013-07-09','15:10:00',2.15),('5815','2013-07-09','15:15:00',2.12),('5815','2013-07-09','15:20:00',2.1),('5815','2013-07-09','15:25:00',2.08),('5815','2013-07-09','15:30:00',2.06),('5815','2013-07-09','15:35:00',2.05),('5815','2013-07-09','15:40:00',2.02),('5815','2013-07-09','15:45:00',2.02),('5815','2013-07-09','15:50:00',2),('5815','2013-07-09','15:55:00',1.95),('5815','2013-07-09','16:00:00',1.88),('5815','2013-07-09','16:05:00',1.87),('5815','2013-07-09','16:10:00',1.82),('5815','2013-07-09','16:15:00',1.77),('5815','2013-07-09','16:20:00',1.75),('5815','2013-07-09','16:25:00',1.71),('5815','2013-07-09','16:30:00',1.66),('5815','2013-07-09','16:35:00',1.63),('5815','2013-07-09','16:40:00',1.6),('5815','2013-07-09','16:45:00',1.57),('5815','2013-07-09','16:50:00',1.51),('5815','2013-07-09','16:55:00',1.5),('5815','2013-07-09','17:00:00',1.51),('5815','2013-07-09','17:05:00',1.37),('5815','2013-07-09','17:10:00',1.18),('5815','2013-07-09','17:35:00',1.21),('5815','2013-07-08','08:45:00',1),('5815','2013-07-08','08:50:00',1.05),('5815','2013-07-08','08:55:00',1.1),('5815','2013-07-08','09:00:00',1.15),('5815','2013-07-08','09:05:00',1.19),('5815','2013-07-08','09:10:00',1.22),('5815','2013-07-08','09:15:00',1.27),('5815','2013-07-08','09:20:00',1.31),('5815','2013-07-08','09:25:00',1.35),('5815','2013-07-08','09:30:00',1.39),('5815','2013-07-08','09:35:00',1.43),('5815','2013-07-08','09:40:00',1.48),('5815','2013-07-08','09:45:00',1.52),('5815','2013-07-08','09:50:00',1.56),('5815','2013-07-08','09:55:00',1.6),('5815','2013-07-08','10:00:00',1.63),('5815','2013-07-08','10:05:00',1.66),('5815','2013-07-08','10:10:00',1.71),('5815','2013-07-08','10:15:00',1.73),('5815','2013-07-08','10:20:00',1.77),('5815','2013-07-08','10:25:00',1.79),('5815','2013-07-08','10:30:00',1.81),('5815','2013-07-08','10:35:00',1.84),('5815','2013-07-08','10:40:00',1.85),('5815','2013-07-08','10:45:00',1.89),('5815','2013-07-08','10:50:00',1.9),('5815','2013-07-08','10:55:00',1.96),('5815','2013-07-08','11:00:00',1.98),('5815','2013-07-08','11:05:00',1.83),('5815','2013-07-08','11:10:00',1.74),('5815','2013-07-08','11:15:00',1.64),('5815','2013-07-08','11:20:00',1.72),('5815','2013-07-08','11:25:00',1.76),('5815','2013-07-08','11:30:00',1.2),('5815','2013-07-08','11:35:00',1.39),('5815','2013-07-08','11:40:00',1.51),('5815','2013-07-08','11:45:00',2.09),('5815','2013-07-08','11:50:00',2.4),('5815','2013-07-08','11:55:00',2.38),('5815','2013-07-08','12:00:00',2.38),('5815','2013-07-08','12:05:00',2.23),('5815','2013-07-08','12:10:00',1.6),('5815','2013-07-08','12:15:00',2.21),('5815','2013-07-08','12:20:00',2.19),('5815','2013-07-08','12:25:00',2.16),('5815','2013-07-08','12:30:00',2.19),('5815','2013-07-08','12:35:00',2.2),('5815','2013-07-08','12:40:00',2.19),('5815','2013-07-08','12:45:00',2.17),('5815','2013-07-08','12:50:00',2.21),('5815','2013-07-08','12:55:00',2.24),('5815','2013-07-08','13:00:00',2.24),('5815','2013-07-08','13:05:00',2.13),('5815','2013-07-08','13:10:00',2.35),('5815','2013-07-08','13:15:00',2.39),('5815','2013-07-08','13:20:00',2.37),('5815','2013-07-08','13:25:00',2.41),('5815','2013-07-08','13:30:00',2.43),('5815','2013-07-08','13:35:00',2.28),('5815','2013-07-08','13:40:00',2.28),('5815','2013-07-08','13:45:00',1.89),('5815','2013-07-08','13:50:00',1.78),('5815','2013-07-08','13:55:00',1.79),('5815','2013-07-08','14:00:00',1.76),('5815','2013-07-08','14:05:00',1.76),('5815','2013-07-08','14:10:00',1.95),('5815','2013-07-08','14:15:00',1.96),('5815','2013-07-08','14:20:00',1.47),('5815','2013-07-08','14:25:00',1.17),('5815','2013-07-07','08:50:00',1.04),('5815','2013-07-07','08:55:00',1.09),('5815','2013-07-07','09:00:00',1.13),('5815','2013-07-07','09:05:00',1.17),('5815','2013-07-07','09:10:00',1.22),('5815','2013-07-07','09:15:00',1.26),('5815','2013-07-07','09:20:00',1.3),('5815','2013-07-07','09:25:00',1.32),('5815','2013-07-07','09:30:00',1.39),('5815','2013-07-07','09:35:00',1.45),('5815','2013-07-07','09:40:00',1.49),('5815','2013-07-07','09:45:00',1.51),('5815','2013-07-07','09:50:00',1.52),('5815','2013-07-07','09:55:00',1.58),('5815','2013-07-07','10:00:00',1.62),('5815','2013-07-07','10:05:00',1.65),('5815','2013-07-07','10:10:00',1.66),('5815','2013-07-07','10:15:00',1.71),('5815','2013-07-07','10:20:00',1.74),('5815','2013-07-07','10:25:00',1.78),('5815','2013-07-07','10:30:00',1.75),('5815','2013-07-07','10:35:00',1.84),('5815','2013-07-07','10:40:00',1.85),('5815','2013-07-07','10:45:00',1.86),('5815','2013-07-07','10:50:00',1.88),('5815','2013-07-07','10:55:00',1.9),('5815','2013-07-07','11:00:00',1.92),('5815','2013-07-07','11:05:00',1.91),('5815','2013-07-07','11:10:00',1.95),('5815','2013-07-07','11:15:00',1.98),('5815','2013-07-07','11:20:00',2.03),('5815','2013-07-07','11:25:00',2.06),('5815','2013-07-07','11:30:00',2.09),('5815','2013-07-07','11:35:00',2.13),('5815','2013-07-07','11:40:00',2.01),('5815','2013-07-07','11:45:00',2.14),('5815','2013-07-07','11:50:00',2.12),('5815','2013-07-07','11:55:00',2.12),('5815','2013-07-07','12:00:00',2.12),('5815','2013-07-07','12:05:00',2.17),('5815','2013-07-07','12:10:00',2.21),('5815','2013-07-07','12:15:00',2.23),('5815','2013-07-07','12:20:00',2.32),('5815','2013-07-07','12:25:00',2.25),('5815','2013-07-07','12:30:00',2.19),('5815','2013-07-07','12:35:00',2.26),('5815','2013-07-07','12:40:00',2.22),('5815','2013-07-07','12:45:00',2.23),('5815','2013-07-07','12:50:00',2.24),('5815','2013-07-07','12:55:00',2.27),('5815','2013-07-07','13:00:00',2.07),('5815','2013-07-07','13:05:00',2.42),('5815','2013-07-07','13:10:00',2.56),('5815','2013-07-07','13:15:00',1.95),('5815','2013-07-07','13:20:00',1.37),('5815','2013-07-06','08:50:00',1),('5815','2013-07-06','08:55:00',1.19),('5815','2013-07-06','09:00:00',1.19),('5815','2013-07-06','09:05:00',1.11),('5815','2013-07-06','09:10:00',1.11),('5815','2013-07-06','09:15:00',1.08),('5815','2013-07-06','09:25:00',1.17),('5815','2013-07-06','09:30:00',1.42),('5815','2013-07-06','09:35:00',1.5),('5815','2013-07-06','09:40:00',1.4),('5815','2013-07-06','09:45:00',1.66),('5815','2013-07-06','09:50:00',1.67),('5815','2013-07-06','09:55:00',1.71),('5815','2013-07-06','10:00:00',1.71),('5815','2013-07-06','10:05:00',1.63),('5815','2013-07-06','10:10:00',1.72),('5815','2013-07-06','10:15:00',1.61),('5815','2013-07-06','10:20:00',1.76),('5815','2013-07-06','10:25:00',1.71),('5815','2013-07-06','10:30:00',1.7),('5815','2013-07-06','10:35:00',1.97),('5815','2013-07-06','10:40:00',1.81),('5815','2013-07-06','10:45:00',1.97),('5815','2013-07-06','10:50:00',1.99),('5815','2013-07-06','10:55:00',1.99),('5815','2013-07-06','11:00:00',2),('5815','2013-07-06','11:05:00',1.97),('5815','2013-07-06','11:10:00',1.98),('5815','2013-07-06','11:15:00',1.89),('5815','2013-07-06','11:20:00',1.91),('5815','2013-07-06','11:25:00',1.73),('5815','2013-07-06','11:30:00',1.82),('5815','2013-07-06','11:35:00',1.82),('5815','2013-07-06','11:40:00',1.84),('5815','2013-07-06','11:45:00',1.57),('5815','2013-07-06','11:50:00',1.46),('5815','2013-07-06','11:55:00',1.12),('5815','2013-07-06','12:00:00',1.67),('5815','2013-07-06','12:05:00',2.09),('5815','2013-07-06','12:10:00',2.12),('5815','2013-07-06','12:15:00',2.28),('5815','2013-07-06','12:20:00',2.21),('5815','2013-07-06','12:25:00',2.1),('5815','2013-07-06','12:30:00',2.16),('5815','2013-07-06','12:35:00',2.28),('5815','2013-07-06','12:40:00',2.31),('5815','2013-07-06','12:45:00',2.28),('5815','2013-07-06','12:50:00',2.24),('5815','2013-07-06','12:55:00',2.33),('5815','2013-07-06','13:00:00',2.3),('5815','2013-07-06','13:05:00',2.3),('5815','2013-07-06','13:10:00',2.3),('5815','2013-07-06','13:15:00',2.28),('5815','2013-07-06','13:20:00',2.3),('5815','2013-07-06','13:25:00',2.25),('5815','2013-07-06','13:30:00',2.16),('5815','2013-07-06','13:35:00',2.34),('5815','2013-07-06','13:40:00',1.6),('5815','2013-07-06','13:45:00',2.44),('5815','2013-07-06','13:50:00',2.44),('5815','2013-07-06','13:55:00',2.15),('5815','2013-07-06','14:00:00',1.94),('5815','2013-07-06','14:05:00',2.07),('5815','2013-07-06','14:10:00',1.27),('5815','2013-07-06','14:15:00',1.05),('5815','2013-07-05','08:45:00',1.02),('5815','2013-07-05','08:50:00',1.06),('5815','2013-07-05','08:55:00',1.11),('5815','2013-07-05','09:00:00',1.16),('5815','2013-07-05','09:05:00',1.2),('5815','2013-07-05','09:10:00',1.24),('5815','2013-07-05','09:15:00',1.28),('5815','2013-07-05','09:20:00',1.34),('5815','2013-07-05','09:25:00',1.38),('5815','2013-07-05','09:30:00',1.41),('5815','2013-07-05','09:35:00',1.44),('5815','2013-07-05','09:40:00',1.48),('5815','2013-07-05','09:45:00',1.52),('5815','2013-07-05','09:50:00',1.56),('5815','2013-07-05','09:55:00',1.61),('5815','2013-07-05','10:00:00',1.64),('5815','2013-07-05','10:05:00',1.69),('5815','2013-07-05','10:10:00',1.72),('5815','2013-07-05','10:15:00',1.75),('5815','2013-07-05','10:20:00',1.78),('5815','2013-07-05','10:25:00',1.81),('5815','2013-07-05','10:30:00',1.84),('5815','2013-07-05','10:35:00',1.87),('5815','2013-07-05','10:40:00',1.89),('5815','2013-07-05','10:45:00',1.91),('5815','2013-07-05','10:50:00',1.97),('5815','2013-07-05','10:55:00',1.99),('5815','2013-07-05','11:00:00',2),('5815','2013-07-05','11:05:00',1.96),('5815','2013-07-05','11:10:00',1.94),('5815','2013-07-05','11:15:00',1.97),('5815','2013-07-05','11:20:00',2.02),('5815','2013-07-05','11:25:00',2.05),('5815','2013-07-05','11:30:00',2.05),('5815','2013-07-05','11:35:00',2.06),('5815','2013-07-05','11:40:00',2.07),('5815','2013-07-05','11:45:00',2.08),('5815','2013-07-05','11:50:00',2.05),('5815','2013-07-05','11:55:00',2.04),('5815','2013-07-05','12:00:00',2.08),('5815','2013-07-05','12:05:00',2.16),('5815','2013-07-05','12:10:00',2.19),('5815','2013-07-05','12:15:00',2.19),('5815','2013-07-05','12:20:00',2.22),('5815','2013-07-05','12:25:00',2.21),('5815','2013-07-05','12:30:00',2.28),('5815','2013-07-05','12:35:00',2.23),('5815','2013-07-05','12:40:00',2.23),('5815','2013-07-05','12:45:00',2.24),('5815','2013-07-05','12:50:00',2.25),('5815','2013-07-05','12:55:00',2.26),('5815','2013-07-05','13:00:00',2.27),('5815','2013-07-05','13:05:00',2.29),('5815','2013-07-05','13:10:00',2.31),('5815','2013-07-05','13:15:00',2.32),('5815','2013-07-05','13:20:00',2.33),('5815','2013-07-05','13:25:00',2.32),('5815','2013-07-05','13:30:00',2.31),('5815','2013-07-05','13:35:00',2.27),('5815','2013-07-05','13:40:00',2.29),('5815','2013-07-05','13:45:00',2.28),('5815','2013-07-05','13:50:00',2.25),('5815','2013-07-05','13:55:00',2.27),('5815','2013-07-05','14:00:00',2.29),('5815','2013-07-05','14:05:00',2.3),('5815','2013-07-05','14:10:00',2.28),('5815','2013-07-05','14:15:00',2.18),('5815','2013-07-05','14:20:00',2.34),('5815','2013-07-05','14:25:00',2.26),('5815','2013-07-05','14:30:00',2.21),('5815','2013-07-05','14:35:00',2.22),('5815','2013-07-05','14:40:00',2.2),('5815','2013-07-05','14:45:00',2.17),('5815','2013-07-05','14:50:00',2.16),('5815','2013-07-05','14:55:00',1.95),('5815','2013-07-05','15:00:00',2.21),('5815','2013-07-05','15:05:00',2.21),('5815','2013-07-05','15:10:00',2.16),('5815','2013-07-05','15:15:00',2.11),('5815','2013-07-05','15:20:00',2.1),('5815','2013-07-05','15:25:00',2.1),('5815','2013-07-05','15:30:00',1.87),('5815','2013-07-04','08:45:00',1.03),('5815','2013-07-04','08:50:00',1.08),('5815','2013-07-04','08:55:00',1.12),('5815','2013-07-04','09:00:00',1.15),('5815','2013-07-04','09:05:00',1.2),('5815','2013-07-04','09:10:00',1.24),('5815','2013-07-04','09:15:00',1.28),('5815','2013-07-04','09:20:00',1.34),('5815','2013-07-04','09:25:00',1.38),('5815','2013-07-04','09:30:00',1.43),('5815','2013-07-04','09:35:00',1.47),('5815','2013-07-04','09:40:00',1.51),('5815','2013-07-04','09:45:00',1.54),('5815','2013-07-04','09:50:00',1.57),('5815','2013-07-04','09:55:00',1.61),('5815','2013-07-04','10:00:00',1.64),('5815','2013-07-04','10:05:00',1.67),('5815','2013-07-04','10:10:00',1.71),('5815','2013-07-04','10:15:00',1.75),('5815','2013-07-04','10:20:00',1.77),('5815','2013-07-04','10:25:00',1.8),('5815','2013-07-04','10:30:00',1.83),('5815','2013-07-04','10:35:00',1.86),('5815','2013-07-04','10:40:00',1.88),('5815','2013-07-04','10:45:00',1.9),('5815','2013-07-04','10:50:00',1.93),('5815','2013-07-04','10:55:00',1.95),('5815','2013-07-04','11:00:00',1.96),('5815','2013-07-04','11:05:00',1.92),('5815','2013-07-04','11:10:00',1.96),('5815','2013-07-04','11:15:00',1.98),('5815','2013-07-04','11:20:00',2),('5815','2013-07-04','11:25:00',2.02),('5815','2013-07-04','11:30:00',2.05),('5815','2013-07-04','11:35:00',2.05),('5815','2013-07-04','11:40:00',2.1),('5815','2013-07-04','11:45:00',2.06),('5815','2013-07-04','11:50:00',2.11),('5815','2013-07-04','11:55:00',2.1),('5815','2013-07-04','12:00:00',2.11),('5815','2013-07-04','12:05:00',2.12),('5815','2013-07-04','12:10:00',2.13),('5815','2013-07-04','12:15:00',2.16),('5815','2013-07-04','12:20:00',2.17),('5815','2013-07-04','12:25:00',1.36),('5815','2013-07-04','12:30:00',2.05),('5815','2013-07-04','12:35:00',1.7),('5815','2013-07-04','12:40:00',2.23),('5815','2013-07-04','12:45:00',2.29),('5815','2013-07-04','12:50:00',2.14),('5815','2013-07-04','12:55:00',2),('5815','2013-07-04','13:00:00',2.27),('5815','2013-07-04','13:05:00',1.55),('5815','2013-07-04','13:10:00',2.33),('5815','2013-07-04','13:15:00',2.1),('5815','2013-07-04','13:20:00',2.05),('5815','2013-07-04','13:25:00',2.18),('5815','2013-07-04','13:30:00',2.09),('5815','2013-07-04','13:35:00',2.32),('5815','2013-07-04','13:40:00',2.33),('5815','2013-07-04','13:45:00',2.28),('5815','2013-07-04','13:50:00',2.27),('5815','2013-07-04','13:55:00',2.29),('5815','2013-07-04','14:00:00',2.27),('5815','2013-07-04','14:05:00',2.02),('5815','2013-07-04','14:10:00',1.97),('5815','2013-07-04','14:15:00',2.3),('5815','2013-07-04','14:20:00',2.17),('5815','2013-07-04','14:25:00',2.24),('5815','2013-07-04','14:30:00',2.17),('5815','2013-07-04','14:35:00',2.09),('5815','2013-07-04','14:40:00',2.18),('5815','2013-07-04','14:45:00',1.86),('5815','2013-07-04','14:50:00',2.15),('5815','2013-07-04','14:55:00',2.13),('5815','2013-07-04','15:00:00',2.02),('5815','2013-07-04','15:05:00',2.16),('5815','2013-07-04','15:10:00',2.14),('5815','2013-07-04','15:15:00',1.75),('5815','2013-07-04','15:20:00',1.62),('5815','2013-07-04','15:25:00',1.59),('5815','2013-07-04','15:30:00',1.94),('5815','2013-07-04','15:35:00',2.03),('5815','2013-07-04','15:40:00',1.98),('5815','2013-07-04','15:45:00',2.03),('5815','2013-07-04','15:50:00',2.01),('5815','2013-07-04','15:55:00',1.92),('5815','2013-07-04','16:00:00',1.82),('5815','2013-07-04','16:05:00',1.78),('5815','2013-07-04','16:10:00',1.71),('5815','2013-07-04','16:15:00',1.71),('5815','2013-07-04','16:20:00',1.74),('5815','2013-07-04','16:25:00',1.7),('5815','2013-07-04','16:30:00',1.65),('5815','2013-07-04','16:35:00',1.56),('5815','2013-07-04','16:40:00',1.57),('5815','2013-07-04','16:45:00',1.58),('5815','2013-07-04','16:50:00',1.5),('5815','2013-07-04','16:55:00',1.34),('5815','2013-07-04','17:00:00',1.42),('5815','2013-07-04','17:05:00',1.38),('5815','2013-07-04','17:10:00',1.38),('5815','2013-07-04','17:15:00',1.36),('5815','2013-07-04','17:20:00',1.32),('5815','2013-07-04','17:25:00',1.26),('5815','2013-07-04','17:30:00',1.2),('5815','2013-07-04','17:35:00',1.07),('5815','2013-07-03','12:10:00',1.21),('5815','2013-07-03','12:15:00',1.66),('5815','2013-07-03','12:20:00',1.47),('5815','2013-07-03','12:25:00',1.73),('5815','2013-07-03','12:30:00',1.67),('5815','2013-07-03','12:35:00',1.28),('5815','2013-07-03','13:20:00',1.04),('5815','2013-07-03','13:25:00',1.19),('5815','2013-07-03','13:30:00',1.1),('5815','2013-07-03','13:35:00',1.14),('5815','2013-07-03','13:40:00',1.36),('5815','2013-07-03','13:45:00',1.21),('5815','2013-07-03','13:50:00',1.74),('5815','2013-07-03','13:55:00',1.51),('5815','2013-07-03','14:00:00',1.22),('5815','2013-07-03','14:05:00',1.18),('5815','2013-07-03','14:10:00',1.16),('5815','2013-07-03','14:15:00',1.2),('5815','2013-07-03','14:20:00',1.23),('5815','2013-07-03','14:25:00',1.04),('5815','2013-07-03','14:35:00',1.03),('5815','2013-07-03','14:40:00',1.73),('5815','2013-07-03','14:45:00',2.49),('5815','2013-07-03','14:50:00',1.32),('5815','2013-07-03','14:55:00',1.37),('5815','2013-07-03','15:00:00',2.47),('5815','2013-07-03','15:05:00',2.24),('5815','2013-07-03','15:10:00',1.65),('5815','2013-07-03','15:15:00',2.46),('5815','2013-07-03','15:20:00',2.35),('5815','2013-07-03','15:25:00',2.27),('5815','2013-07-03','15:30:00',1.53),('5815','2013-07-03','15:35:00',1.75),('5815','2013-07-03','15:40:00',1.8),('5815','2013-07-03','15:45:00',1.74),('5815','2013-07-03','15:50:00',1.29),('5815','2013-07-03','15:55:00',1.37),('5815','2013-07-03','16:00:00',1.45),('5815','2013-07-03','16:05:00',1.25),('5815','2013-07-03','16:10:00',1.17),('5815','2013-07-03','16:15:00',1.05),('5815','2013-07-03','16:20:00',1.05),('5815','2013-07-03','16:25:00',1.12),('5815','2013-07-03','16:30:00',1.11),('5815','2013-07-03','16:35:00',1.08),('5815','2013-07-03','17:10:00',1.15),('5815','2013-07-03','17:15:00',1.43),('5815','2013-07-03','17:20:00',1.47),('5815','2013-07-03','17:25:00',1.37),('5815','2013-07-03','17:30:00',1.15),('5815','2013-07-03','17:35:00',1.13),('5815','2013-07-03','17:40:00',1.21),('5815','2013-07-03','17:45:00',1.17),('5815','2013-07-03','17:50:00',1.13),('5815','2013-07-03','17:55:00',1.08),('5815','2013-07-03','18:00:00',1.06),('5815','2013-07-03','18:05:00',1.05),('5815','2013-07-02','08:40:00',1.02),('5815','2013-07-02','08:45:00',1.07),('5815','2013-07-02','08:50:00',1.12),('5815','2013-07-02','08:55:00',1.17),('5815','2013-07-02','09:00:00',1.2),('5815','2013-07-02','09:05:00',1.25),('5815','2013-07-02','09:10:00',1.3),('5815','2013-07-02','09:15:00',1.33),('5815','2013-07-02','09:20:00',1.38),('5815','2013-07-02','09:25:00',1.42),('5815','2013-07-02','09:30:00',1.46),('5815','2013-07-02','09:35:00',1.48),('5815','2013-07-02','09:40:00',1.51),('5815','2013-07-02','09:45:00',1.57),('5815','2013-07-02','09:50:00',1.61),('5815','2013-07-02','09:55:00',1.63),('5815','2013-07-02','10:00:00',1.68),('5815','2013-07-02','10:05:00',1.7),('5815','2013-07-02','10:10:00',1.7),('5815','2013-07-02','10:15:00',1.73),('5815','2013-07-02','10:20:00',1.74),('5815','2013-07-02','10:25:00',1.81),('5815','2013-07-02','10:30:00',1.87),('5815','2013-07-02','10:35:00',1.88),('5815','2013-07-02','10:40:00',1.89),('5815','2013-07-02','10:45:00',1.96),('5815','2013-07-02','10:50:00',1.98),('5815','2013-07-02','10:55:00',1.99),('5815','2013-07-02','11:00:00',2.01),('5815','2013-07-02','11:05:00',1.96),('5815','2013-07-02','11:10:00',1.96),('5815','2013-07-02','11:15:00',2.03),('5815','2013-07-02','11:20:00',2.06),('5815','2013-07-02','11:25:00',2.08),('5815','2013-07-02','11:30:00',2.08),('5815','2013-07-02','11:35:00',2.09),('5815','2013-07-02','11:40:00',2.1),('5815','2013-07-02','11:45:00',2.12),('5815','2013-07-02','11:50:00',2.1),('5815','2013-07-02','11:55:00',2.09),('5815','2013-07-02','12:00:00',2.21),('5815','2013-07-02','12:05:00',2.25),('5815','2013-07-02','12:10:00',2.21),('5815','2013-07-02','12:15:00',2.26),('5815','2013-07-02','12:20:00',2.28),('5815','2013-07-02','12:25:00',2.28),('5815','2013-07-02','12:30:00',2.32),('5815','2013-07-02','12:35:00',2.29),('5815','2013-07-02','12:40:00',2.27),('5815','2013-07-02','12:45:00',2.29),('5815','2013-07-02','12:50:00',2.32),('5815','2013-07-02','12:55:00',2.32),('5815','2013-07-02','13:00:00',2.34),('5815','2013-07-02','13:05:00',2.36),('5815','2013-07-02','13:10:00',2.37),('5815','2013-07-02','13:15:00',2.36),('5815','2013-07-02','13:20:00',2.37),('5815','2013-07-02','13:25:00',2.35),('5815','2013-07-02','13:30:00',2.32),('5815','2013-07-02','13:35:00',2.32),('5815','2013-07-02','13:40:00',2.32),('5815','2013-07-02','13:45:00',2.35),('5815','2013-07-02','13:50:00',2.34),('5815','2013-07-02','13:55:00',2.32),('5815','2013-07-02','14:00:00',2.31),('5815','2013-07-02','14:05:00',2.3),('5815','2013-07-02','14:10:00',2.3),('5815','2013-07-02','14:15:00',2.33),('5815','2013-07-02','14:20:00',2.31),('5815','2013-07-02','14:25:00',2.28),('5815','2013-07-02','14:30:00',2.3),('5815','2013-07-02','14:35:00',2.28),('5815','2013-07-02','14:40:00',2.26),('5815','2013-07-02','14:45:00',2.25),('5815','2013-07-02','14:50:00',2.24),('5815','2013-07-02','14:55:00',2.22),('5815','2013-07-02','15:00:00',2.2),('5815','2013-07-02','15:05:00',2.22),('5815','2013-07-02','15:10:00',2.15),('5815','2013-07-02','15:15:00',2.15),('5815','2013-07-02','15:20:00',2.13),('5815','2013-07-02','15:25:00',2.11),('5815','2013-07-02','15:30:00',2.1),('5815','2013-07-02','15:35:00',2.08),('5815','2013-07-02','15:40:00',2.04),('5815','2013-07-02','15:45:00',2.06),('5815','2013-07-02','15:50:00',2.04),('5815','2013-07-02','15:55:00',1.98),('5815','2013-07-02','16:00:00',1.92),('5815','2013-07-02','16:05:00',1.89),('5815','2013-07-02','16:10:00',1.87),('5815','2013-07-02','16:15:00',1.82),('5815','2013-07-02','16:20:00',1.8),('5815','2013-07-02','16:25:00',1.77),('5815','2013-07-02','16:30:00',1.73),('5815','2013-07-02','16:35:00',1.7),('5815','2013-07-02','16:40:00',1.66),('5815','2013-07-02','16:45:00',1.62),('5815','2013-07-02','16:50:00',1.58),('5815','2013-07-02','16:55:00',1.54),('5815','2013-07-02','17:00:00',1.49),('5815','2013-07-02','17:05:00',1.44),('5815','2013-07-02','17:10:00',1.42),('5815','2013-07-02','17:15:00',1.37),('5815','2013-07-02','17:20:00',1.32),('5815','2013-07-02','17:25:00',1.28),('5815','2013-07-02','17:30:00',1.2),('5815','2013-07-02','17:35:00',1.17),('5815','2013-07-02','17:40:00',1.12),('5815','2013-07-02','17:45:00',1.07),('5815','2013-07-02','17:50:00',1.04),('5815','2013-07-01','08:40:00',1),('5815','2013-07-01','08:45:00',1.05),('5815','2013-07-01','08:50:00',1.09),('5815','2013-07-01','08:55:00',1.14),('5815','2013-07-01','09:00:00',1.18),('5815','2013-07-01','09:05:00',1.24),('5815','2013-07-01','09:10:00',1.27),('5815','2013-07-01','09:15:00',1.33),('5815','2013-07-01','09:20:00',1.37),('5815','2013-07-01','09:25:00',1.41),('5815','2013-07-01','09:30:00',1.46),('5815','2013-07-01','09:35:00',1.48),('5815','2013-07-01','09:40:00',1.52),('5815','2013-07-01','09:45:00',1.56),('5815','2013-07-01','09:50:00',1.59),('5815','2013-07-01','09:55:00',1.62),('5815','2013-07-01','10:00:00',1.66),('5815','2013-07-01','10:05:00',1.71),('5815','2013-07-01','10:10:00',1.73),('5815','2013-07-01','10:15:00',1.75),('5815','2013-07-01','10:20:00',1.78),('5815','2013-07-01','10:25:00',1.81),('5815','2013-07-01','10:30:00',1.85),('5815','2013-07-01','10:35:00',1.89),('5815','2013-07-01','10:40:00',1.91),('5815','2013-07-01','10:45:00',1.93),('5815','2013-07-01','10:50:00',1.94),('5815','2013-07-01','10:55:00',1.96),('5815','2013-07-01','11:00:00',1.97),('5815','2013-07-01','11:05:00',1.92),('5815','2013-07-01','11:10:00',1.92),('5815','2013-07-01','11:15:00',1.96),('5815','2013-07-01','11:20:00',1.97),('5815','2013-07-01','11:25:00',1.99),('5815','2013-07-01','11:30:00',2.02),('5815','2013-07-01','11:35:00',2.05),('5815','2013-07-01','11:40:00',2.09),('5815','2013-07-01','11:45:00',2.03),('5815','2013-07-01','11:50:00',1.99),('5815','2013-07-01','11:55:00',2),('5815','2013-07-01','12:00:00',2.09),('5815','2013-07-01','12:05:00',2.06),('5815','2013-07-01','12:10:00',2.14),('5815','2013-07-01','12:15:00',2.14),('5815','2013-07-01','12:20:00',2.12),('5815','2013-07-01','12:25:00',2.08),('5815','2013-07-01','12:30:00',2.2),('5815','2013-07-01','12:35:00',2.22),('5815','2013-07-01','12:40:00',2.25),('5815','2013-07-01','12:45:00',2.27),('5815','2013-07-01','12:50:00',2.28),('5815','2013-07-01','12:55:00',1.05),('5815','2013-07-01','13:00:00',1.87),('5815','2013-07-01','13:10:00',2.4),('5815','2013-07-01','13:15:00',2.44),('5815','2013-07-01','13:20:00',2.4),('5815','2013-07-01','13:25:00',2.45),('5815','2013-07-01','13:30:00',2.38),('5815','2013-07-01','13:35:00',2.34),('5815','2013-07-01','13:40:00',2.36),('5815','2013-07-01','13:45:00',2.19),('5815','2013-07-01','13:50:00',2.19),('5815','2013-07-01','13:55:00',2.24),('5815','2013-07-01','14:00:00',2.23),('5815','2013-07-01','14:05:00',2.23),('5815','2013-07-01','14:10:00',2.23),('5815','2013-07-01','14:15:00',2.27),('5815','2013-07-01','14:20:00',2.24),('5815','2013-07-01','14:25:00',2.21),('5815','2013-07-01','14:30:00',2.22),('5815','2013-07-01','14:35:00',2.22),('5815','2013-07-01','14:40:00',2.18),('5815','2013-07-01','14:45:00',2.18),('5815','2013-07-01','14:50:00',2.17),('5815','2013-07-01','14:55:00',2.16),('5815','2013-07-01','15:00:00',2.17),('5815','2013-07-01','15:05:00',2.17),('5815','2013-07-01','15:10:00',2.12),('5815','2013-07-01','15:15:00',2.09),('5815','2013-07-01','15:20:00',2.09),('5815','2013-07-01','15:25:00',2.07),('5815','2013-07-01','15:30:00',2.05),('5815','2013-07-01','15:35:00',2.03),('5815','2013-07-01','15:40:00',2.01),('5815','2013-07-01','15:45:00',2),('5815','2013-07-01','15:50:00',1.99),('5815','2013-07-01','15:55:00',1.92),('5815','2013-07-01','16:00:00',1.88),('5815','2013-07-01','16:05:00',1.86),('5815','2013-07-01','16:10:00',1.83),('5815','2013-07-01','16:15:00',1.79),('5815','2013-07-01','16:20:00',1.76),('5815','2013-07-01','16:25:00',1.72),('5815','2013-07-01','16:30:00',1.68),('5815','2013-07-01','16:35:00',1.64),('5815','2013-07-01','16:40:00',1.6),('5815','2013-07-01','16:45:00',1.55),('5815','2013-07-01','16:50:00',1.51),('5815','2013-07-01','16:55:00',1.49),('5815','2013-07-01','17:00:00',1.46),('5815','2013-07-01','17:05:00',1.41),('5815','2013-07-01','17:10:00',1.33),('5815','2013-07-01','17:15:00',1.32),('5815','2013-07-01','17:20:00',1.28),('5815','2013-07-01','17:25:00',1.24),('5815','2013-07-01','17:30:00',1.18),('5815','2013-07-01','17:35:00',1.07),('5815','2013-07-01','17:45:00',1.01),('5815','2013-06-30','08:40:00',1.03),('5815','2013-06-30','08:45:00',1.08),('5815','2013-06-30','08:50:00',1.13),('5815','2013-06-30','08:55:00',1.17),('5815','2013-06-30','09:00:00',1.22),('5815','2013-06-30','09:05:00',1.27),('5815','2013-06-30','09:10:00',1.3),('5815','2013-06-30','09:15:00',1.36),('5815','2013-06-30','09:20:00',1.41),('5815','2013-06-30','09:25:00',1.45),('5815','2013-06-30','09:30:00',1.51),('5815','2013-06-30','09:35:00',1.54),('5815','2013-06-30','09:40:00',1.57),('5815','2013-06-30','09:45:00',1.61),('5815','2013-06-30','09:50:00',1.64),('5815','2013-06-30','09:55:00',1.68),('5815','2013-06-30','10:00:00',1.7),('5815','2013-06-30','10:05:00',1.74),('5815','2013-06-30','10:10:00',1.78),('5815','2013-06-30','10:15:00',1.83),('5815','2013-06-30','10:20:00',1.85),('5815','2013-06-30','10:25:00',1.88),('5815','2013-06-30','10:30:00',1.91),('5815','2013-06-30','10:35:00',1.94),('5815','2013-06-30','10:40:00',1.98),('5815','2013-06-30','10:45:00',2),('5815','2013-06-30','10:50:00',2.02),('5815','2013-06-30','10:55:00',2.04),('5815','2013-06-30','11:00:00',2.06),('5815','2013-06-30','11:05:00',2.02),('5815','2013-06-30','11:10:00',2.03),('5815','2013-06-30','11:15:00',2.09),('5815','2013-06-30','11:20:00',2.11),('5815','2013-06-30','11:25:00',2.13),('5815','2013-06-30','11:30:00',2.15),('5815','2013-06-30','11:35:00',2.15),('5815','2013-06-30','11:40:00',2.16),('5815','2013-06-30','11:45:00',2.14),('5815','2013-06-30','11:50:00',2.11),('5815','2013-06-30','11:55:00',2.11),('5815','2013-06-30','12:00:00',2.23),('5815','2013-06-30','12:05:00',2.22),('5815','2013-06-30','12:10:00',2.22),('5815','2013-06-30','12:15:00',2.24),('5815','2013-06-30','12:20:00',2.23),('5815','2013-06-30','12:25:00',2.24),('5815','2013-06-30','12:30:00',2.29),('5815','2013-06-30','12:35:00',2.27),('5815','2013-06-30','12:40:00',2.27),('5815','2013-06-30','12:45:00',2.28),('5815','2013-06-30','12:50:00',2.3),('5815','2013-06-30','12:55:00',2.32),('5815','2013-06-30','13:00:00',2.31),('5815','2013-06-30','13:05:00',2.3),('5815','2013-06-30','13:10:00',2.31),('5815','2013-06-30','13:15:00',2.32),('5815','2013-06-30','13:20:00',2.36),('5815','2013-06-30','13:25:00',2.36),('5815','2013-06-30','13:30:00',2.31),('5815','2013-06-30','13:35:00',2.28),('5815','2013-06-30','13:40:00',2.26),('5815','2013-06-30','13:45:00',2.26),('5815','2013-06-30','13:50:00',2.28),('5815','2013-06-30','13:55:00',2.26),('5815','2013-06-30','14:00:00',2.28),('5815','2013-06-30','14:05:00',2.32),('5815','2013-06-30','14:10:00',2.35),('5815','2013-06-30','14:15:00',2.34),('5815','2013-06-30','14:20:00',2.3),('5815','2013-06-30','14:25:00',2.27),('5815','2013-06-30','14:30:00',2.25),('5815','2013-06-30','14:35:00',2.23),('5815','2013-06-30','14:40:00',2.23),('5815','2013-06-30','14:45:00',2.21),('5815','2013-06-30','14:50:00',2.19),('5815','2013-06-30','14:55:00',2.17),('5815','2013-06-30','15:00:00',2.18),('5815','2013-06-30','15:05:00',2.14),('5815','2013-06-30','15:10:00',2.1),('5815','2013-06-30','15:15:00',2.09),('5815','2013-06-30','15:20:00',2.07),('5815','2013-06-30','15:25:00',2.05),('5815','2013-06-30','15:30:00',2.02),('5815','2013-06-30','15:35:00',2),('5815','2013-06-30','15:40:00',1.96),('5815','2013-06-30','15:45:00',1.99),('5815','2013-06-30','15:50:00',1.97),('5815','2013-06-30','15:55:00',1.91),('5815','2013-06-30','16:00:00',1.86),('5815','2013-06-30','16:05:00',1.83),('5815','2013-06-30','16:10:00',1.81),('5815','2013-06-30','16:15:00',1.74),('5815','2013-06-30','16:20:00',1.71),('5815','2013-06-30','16:25:00',1.68),('5815','2013-06-30','16:30:00',1.65),('5815','2013-06-30','16:35:00',1.61),('5815','2013-06-30','16:40:00',1.57),('5815','2013-06-30','16:45:00',1.54),('5815','2013-06-30','16:50:00',1.52),('5815','2013-06-30','16:55:00',1.49),('5815','2013-06-30','17:00:00',1.46),('5815','2013-06-30','17:05:00',1.4),('5815','2013-06-30','17:10:00',1.33),('5815','2013-06-30','17:15:00',1.31),('5815','2013-06-30','17:20:00',1.26),('5815','2013-06-30','17:25:00',1.22),('5815','2013-06-30','17:30:00',1.15),('5815','2013-06-30','17:35:00',1.05),('5815','2013-06-30','17:45:00',1.02),('5815','2013-06-29','08:35:00',1.02),('5815','2013-06-29','08:40:00',1.07),('5815','2013-06-29','08:45:00',1.12),('5815','2013-06-29','08:50:00',1.17),('5815','2013-06-29','08:55:00',1.22),('5815','2013-06-29','09:00:00',1.26),('5815','2013-06-29','09:05:00',1.31),('5815','2013-06-29','09:10:00',1.34),('5815','2013-06-29','09:15:00',1.4),('5815','2013-06-29','09:20:00',1.44),('5815','2013-06-29','09:25:00',1.48),('5815','2013-06-29','09:30:00',1.53),('5815','2013-06-29','09:35:00',1.57),('5815','2013-06-29','09:40:00',1.61),('5815','2013-06-29','09:45:00',1.65),('5815','2013-06-29','09:50:00',1.68),('5815','2013-06-29','09:55:00',1.72),('5815','2013-06-29','10:00:00',1.76),('5815','2013-06-29','10:05:00',1.79),('5815','2013-06-29','10:10:00',1.81),('5815','2013-06-29','10:15:00',1.85),('5815','2013-06-29','10:20:00',1.88),('5815','2013-06-29','10:25:00',1.91),('5815','2013-06-29','10:30:00',1.95),('5815','2013-06-29','10:35:00',1.98),('5815','2013-06-29','10:40:00',1.98),('5815','2013-06-29','10:45:00',2.03),('5815','2013-06-29','10:50:00',2.05),('5815','2013-06-29','10:55:00',2.07),('5815','2013-06-29','11:00:00',2.08),('5815','2013-06-29','11:05:00',2.04),('5815','2013-06-29','11:10:00',2.05),('5815','2013-06-29','11:15:00',2.08),('5815','2013-06-29','11:20:00',2.11),('5815','2013-06-29','11:25:00',2.13),('5815','2013-06-29','11:30:00',2.13),('5815','2013-06-29','11:35:00',2.16),('5815','2013-06-29','11:40:00',2.2),('5815','2013-06-29','11:45:00',2.15),('5815','2013-06-29','11:50:00',2.11),('5815','2013-06-29','11:55:00',2.14),('5815','2013-06-29','12:00:00',2.23),('5815','2013-06-29','12:05:00',2.27),('5815','2013-06-29','12:10:00',2.29),('5815','2013-06-29','12:15:00',2.27),('5815','2013-06-29','12:20:00',2.29),('5815','2013-06-29','12:25:00',2.33),('5815','2013-06-29','12:30:00',2.36),('5815','2013-06-29','12:35:00',2.33),('5815','2013-06-29','12:40:00',2.31),('5815','2013-06-29','12:45:00',2.35),('5815','2013-06-29','12:50:00',2.37),('5815','2013-06-29','12:55:00',2.35),('5815','2013-06-29','13:00:00',2.36),('5815','2013-06-29','13:05:00',2.35),('5815','2013-06-29','13:10:00',2.35),('5815','2013-06-29','13:15:00',2.37),('5815','2013-06-29','13:20:00',2.4),('5815','2013-06-29','13:25:00',2.41),('5815','2013-06-29','13:30:00',2.38),('5815','2013-06-29','13:35:00',2.36),('5815','2013-06-29','13:40:00',2.35),('5815','2013-06-29','13:45:00',2.36),('5815','2013-06-29','13:50:00',2.38),('5815','2013-06-29','13:55:00',2.07),('5815','2013-06-29','14:00:00',2.38),('5815','2013-06-29','14:05:00',2.36),('5815','2013-06-29','14:10:00',2.36),('5815','2013-06-29','14:15:00',2.34),('5815','2013-06-29','14:20:00',2.29),('5815','2013-06-29','14:25:00',2.26),('5815','2013-06-29','14:30:00',2.25),('5815','2013-06-29','14:35:00',2.26),('5815','2013-06-29','14:40:00',2.26),('5815','2013-06-29','14:45:00',2.26),('5815','2013-06-29','14:50:00',2.25),('5815','2013-06-29','14:55:00',2.23),('5815','2013-06-29','15:00:00',2.22),('5815','2013-06-29','15:05:00',2.2),('5815','2013-06-29','15:10:00',2.16),('5815','2013-06-29','15:15:00',2.14),('5815','2013-06-29','15:20:00',2.14),('5815','2013-06-29','15:25:00',2.1),('5815','2013-06-29','15:30:00',2.09),('5815','2013-06-29','15:35:00',2.08),('5815','2013-06-29','15:40:00',2.07),('5815','2013-06-29','15:45:00',2.08),('5815','2013-06-29','15:50:00',2.07),('5815','2013-06-29','15:55:00',2),('5815','2013-06-29','16:00:00',1.92),('5815','2013-06-29','16:05:00',1.84),('5815','2013-06-29','16:10:00',1.8),('5815','2013-06-29','16:15:00',1.87),('5815','2013-06-29','16:20:00',1.89),('5815','2013-06-29','16:25:00',1.89),('5815','2013-06-29','16:30:00',1.64),('5815','2013-06-29','16:35:00',1.7),('5815','2013-06-29','16:40:00',1.65),('5815','2013-06-29','16:45:00',1.63),('5815','2013-06-29','16:50:00',1.58),('5815','2013-06-29','16:55:00',1.53),('5815','2013-06-29','17:00:00',1.47),('5815','2013-06-29','17:05:00',1.43),('5815','2013-06-29','17:10:00',1.38),('5815','2013-06-29','17:15:00',1.35),('5815','2013-06-29','17:20:00',1.3),('5815','2013-06-29','17:25:00',1.24),('5815','2013-06-29','17:30:00',1.18),('5815','2013-06-29','17:35:00',1.08),('5815','2013-06-29','17:45:00',1.03),('5815','2013-06-29','17:50:00',1.01),('5815','2013-06-28','08:10:00',1.03),('5815','2013-06-28','08:30:00',1.03),('5815','2013-06-28','08:35:00',1.06),('5815','2013-06-28','08:45:00',1.01),('5815','2013-06-28','08:50:00',1.17),('5815','2013-06-28','08:55:00',1.21),('5815','2013-06-28','09:00:00',1.24),('5815','2013-06-28','09:05:00',1.28),('5815','2013-06-28','09:10:00',1.33),('5815','2013-06-28','09:15:00',1.38),('5815','2013-06-28','09:20:00',1.41),('5815','2013-06-28','09:25:00',1.45),('5815','2013-06-28','09:30:00',1.48),('5815','2013-06-28','09:35:00',1.55),('5815','2013-06-28','09:40:00',1.58),('5815','2013-06-28','09:45:00',1.61),('5815','2013-06-28','09:50:00',1.66),('5815','2013-06-28','09:55:00',1.69),('5815','2013-06-28','10:00:00',1.73),('5815','2013-06-28','10:05:00',1.77),('5815','2013-06-28','10:10:00',1.81),('5815','2013-06-28','10:15:00',1.82),('5815','2013-06-28','10:20:00',1.86),('5815','2013-06-28','10:25:00',1.89),('5815','2013-06-28','10:30:00',1.92),('5815','2013-06-28','10:35:00',1.95),('5815','2013-06-28','10:40:00',1.98),('5815','2013-06-28','10:45:00',2.03),('5815','2013-06-28','10:50:00',2.04),('5815','2013-06-28','10:55:00',2.11),('5815','2013-06-28','11:00:00',2.12),('5815','2013-06-28','11:05:00',2.12),('5815','2013-06-28','11:10:00',2.14),('5815','2013-06-28','11:15:00',2.18),('5815','2013-06-28','11:20:00',1.3),('5815','2013-06-28','11:25:00',2.36),('5815','2013-06-28','11:30:00',2.4),('5815','2013-06-28','11:35:00',2.15),('5815','2013-06-28','11:40:00',2),('5815','2013-06-28','11:50:00',1.63),('5815','2013-06-28','11:55:00',2.52),('5815','2013-06-28','12:00:00',1.82),('5815','2013-06-28','12:05:00',2.4),('5815','2013-06-28','12:10:00',2.44),('5815','2013-06-28','12:15:00',1.85),('5815','2013-06-28','12:25:00',2.58),('5815','2013-06-28','12:30:00',2.36),('5815','2013-06-28','12:35:00',2.48),('5815','2013-06-28','12:40:00',2.41),('5815','2013-06-28','12:45:00',2.6),('5815','2013-06-28','12:50:00',1.22),('5815','2013-06-28','12:55:00',1.88),('5815','2013-06-28','13:00:00',1.74),('5815','2013-06-28','13:05:00',1.36),('5815','2013-06-28','13:10:00',2.7),('5815','2013-06-28','13:15:00',2.55),('5815','2013-06-28','13:20:00',1.41),('5815','2013-06-28','13:25:00',2.22),('5815','2013-06-28','13:45:00',1.77),('5815','2013-06-28','13:50:00',2.55),('5815','2013-06-28','13:55:00',2.04),('5815','2013-06-28','14:00:00',2.48),('5815','2013-06-28','14:05:00',1.84),('5815','2013-06-28','14:10:00',2.24),('5815','2013-06-28','14:15:00',2.71),('5815','2013-06-28','14:20:00',2.44),('5815','2013-06-28','14:25:00',1.52),('5815','2013-06-28','14:30:00',2.73),('5815','2013-06-28','14:35:00',2.57),('5815','2013-06-28','14:40:00',2.53),('5815','2013-06-28','14:45:00',2.54),('5815','2013-06-28','14:50:00',2.04),('5815','2013-06-28','15:00:00',1.24),('5815','2013-06-28','15:05:00',1.8),('5815','2013-06-28','15:10:00',1.28),('5815','2013-06-28','16:50:00',1.41),('5815','2013-06-28','17:30:00',1.29),('5815','2013-06-28','17:35:00',1.23),('5815','2013-06-28','17:45:00',1.06),('5815','2013-06-28','17:50:00',1.08),('5815','2013-06-27','08:35:00',1),('5815','2013-06-27','08:40:00',1.05),('5815','2013-06-27','08:45:00',1.08),('5815','2013-06-27','08:50:00',1.14),('5815','2013-06-27','08:55:00',1.18),('5815','2013-06-27','09:00:00',1.22),('5815','2013-06-27','09:05:00',1.26),('5815','2013-06-27','09:10:00',1.37),('5815','2013-06-27','09:15:00',1.31),('5815','2013-06-27','09:35:00',1.67),('5815','2013-06-27','09:40:00',1.66),('5815','2013-06-27','09:45:00',1.01),('5815','2013-06-27','09:55:00',1.19),('5815','2013-06-27','10:00:00',1.87),('5815','2013-06-27','10:05:00',1.15),('5815','2013-06-27','10:10:00',1.94),('5815','2013-06-27','10:15:00',1.88),('5815','2013-06-27','10:20:00',2.08),('5815','2013-06-27','10:25:00',1.74),('5815','2013-06-27','10:35:00',1.6),('5815','2013-06-27','10:40:00',2.35),('5815','2013-06-27','10:45:00',2.23),('5815','2013-06-27','10:50:00',2.27),('5815','2013-06-27','10:55:00',1.4),('5815','2013-06-27','11:00:00',1.45),('5815','2013-06-27','11:05:00',2.48),('5815','2013-06-27','11:10:00',1.71),('5815','2013-06-27','11:25:00',1.37),('5815','2013-06-27','11:30:00',2.47),('5815','2013-06-27','11:35:00',2.2),('5815','2013-06-27','11:40:00',2.46),('5815','2013-06-27','11:45:00',2.09),('5815','2013-06-27','11:50:00',2.48),('5815','2013-06-27','11:55:00',1.83),('5815','2013-06-27','12:00:00',1.38),('5815','2013-06-27','12:05:00',1.64),('5815','2013-06-27','12:10:00',1.69),('5815','2013-06-27','12:15:00',2.6),('5815','2013-06-27','12:20:00',2.5),('5815','2013-06-27','12:25:00',2.53),('5815','2013-06-27','12:30:00',2.41),('5815','2013-06-27','12:35:00',2.52),('5815','2013-06-27','12:40:00',2.01),('5815','2013-06-27','12:45:00',2.34),('5815','2013-06-27','12:50:00',2.49),('5815','2013-06-27','12:55:00',2.47),('5815','2013-06-27','13:00:00',2.24),('5815','2013-06-27','13:05:00',2.48),('5815','2013-06-27','13:10:00',2.02),('5815','2013-06-27','13:15:00',2.58),('5815','2013-06-27','13:20:00',2.49),('5815','2013-06-27','13:25:00',2.45),('5815','2013-06-27','13:30:00',2.51),('5815','2013-06-27','13:35:00',2.5),('5815','2013-06-27','13:40:00',2.48),('5815','2013-06-27','13:45:00',2.33),('5815','2013-06-27','13:50:00',2.56),('5815','2013-06-27','13:55:00',2.52),('5815','2013-06-27','14:00:00',2.33),('5815','2013-06-27','14:05:00',2.32),('5815','2013-06-27','14:10:00',2.43),('5815','2013-06-27','14:15:00',2.08),('5815','2013-06-27','14:20:00',2.46),('5815','2013-06-27','14:25:00',2.43),('5815','2013-06-27','14:30:00',2.15),('5815','2013-06-27','14:35:00',2.27),('5815','2013-06-27','14:40:00',2.1),('5815','2013-06-27','14:45:00',1.91),('5815','2013-06-27','14:50:00',2.48),('5815','2013-06-27','14:55:00',2.12),('5815','2013-06-27','15:00:00',1.89),('5815','2013-06-27','15:05:00',2.32),('5815','2013-06-27','15:10:00',2.13),('5815','2013-06-27','15:15:00',2.19),('5815','2013-06-27','15:20:00',1.04),('5815','2013-06-27','15:25:00',2.2),('5815','2013-06-27','15:30:00',1.57),('5815','2013-06-27','15:35:00',1.13),('5815','2013-06-27','15:40:00',2.06),('5815','2013-06-27','15:45:00',1.36),('5815','2013-06-27','15:50:00',2.36),('5815','2013-06-27','15:55:00',2.22),('5815','2013-06-27','16:00:00',1.37),('5815','2013-06-27','16:05:00',2.15),('5815','2013-06-27','16:10:00',1.46),('5815','2013-06-27','16:15:00',2.04),('5815','2013-06-27','16:20:00',1.17),('5815','2013-06-27','16:25:00',1.4),('5815','2013-06-27','16:35:00',1.17),('5815','2013-06-27','16:40:00',1.61),('5815','2013-06-27','16:55:00',1.03),('5815','2013-06-27','17:05:00',1.5),('5815','2013-06-27','17:10:00',1.43),('5815','2013-06-27','17:15:00',1.36),('5815','2013-06-27','17:20:00',1.3),('5815','2013-06-27','17:25:00',1.26),('5815','2013-06-27','17:35:00',1.05),('5815','2013-06-27','17:40:00',1.1),('5815','2013-06-27','17:45:00',1.06),('5815','2013-06-27','17:50:00',1.05),('5815','2013-06-26','08:40:00',1.03),('5815','2013-06-26','08:45:00',1.08),('5815','2013-06-26','08:50:00',1.12),('5815','2013-06-26','08:55:00',1.18),('5815','2013-06-26','09:00:00',1.24),('5815','2013-06-26','09:05:00',1.28),('5815','2013-06-26','09:10:00',1.32),('5815','2013-06-26','09:15:00',1.37),('5815','2013-06-26','09:20:00',1.43),('5815','2013-06-26','09:25:00',1.47),('5815','2013-06-26','09:30:00',1.52),('5815','2013-06-26','09:35:00',1.56),('5815','2013-06-26','09:40:00',1.59),('5815','2013-06-26','09:45:00',1.63),('5815','2013-06-26','09:50:00',1.7),('5815','2013-06-26','09:55:00',1.73),('5815','2013-06-26','10:00:00',1.62),('5815','2013-06-26','10:05:00',1.88),('5815','2013-06-26','10:10:00',1.55),('5815','2013-06-26','10:15:00',1.8),('5815','2013-06-26','10:20:00',1.89),('5815','2013-06-26','10:25:00',1.91),('5815','2013-06-26','10:30:00',1.96),('5815','2013-06-26','10:35:00',2.04),('5815','2013-06-26','10:40:00',2.09),('5815','2013-06-26','10:45:00',2.19),('5815','2013-06-26','10:50:00',2.18),('5815','2013-06-26','10:55:00',2.17),('5815','2013-06-26','11:00:00',1.53),('5815','2013-06-26','11:05:00',2.21),('5815','2013-06-26','11:10:00',2.17),('5815','2013-06-26','11:15:00',2.17),('5815','2013-06-26','11:20:00',2.17),('5815','2013-06-26','11:25:00',2.18),('5815','2013-06-26','11:30:00',2.26),('5815','2013-06-26','11:35:00',2.17),('5815','2013-06-26','11:45:00',2.25),('5815','2013-06-26','11:50:00',1.52),('5815','2013-06-26','12:00:00',1.19),('5815','2013-06-26','12:10:00',1.24),('5815','2013-06-26','12:35:00',2.1),('5815','2013-06-26','12:40:00',1.39),('5815','2013-06-26','13:15:00',1.54),('5815','2013-06-26','13:20:00',1.81),('5815','2013-06-26','13:25:00',1.19),('5815','2013-06-26','13:35:00',1.88),('5815','2013-06-26','14:15:00',1.06),('5815','2013-06-26','14:20:00',1.12),('5815','2013-06-26','14:25:00',1.2),('5815','2013-06-26','14:30:00',2.55),('5815','2013-06-26','14:35:00',2.42),('5815','2013-06-26','14:40:00',2.37),('5815','2013-06-26','14:45:00',2.03),('5815','2013-06-26','14:50:00',1.9),('5815','2013-06-26','14:55:00',2.18),('5815','2013-06-26','15:00:00',2.19),('5815','2013-06-26','15:05:00',2.15),('5815','2013-06-26','15:10:00',2.12),('5815','2013-06-26','15:15:00',2.09),('5815','2013-06-26','15:20:00',2.08),('5815','2013-06-26','15:25:00',2.09),('5815','2013-06-26','15:30:00',2.08),('5815','2013-06-26','15:35:00',2.04),('5815','2013-06-26','15:40:00',2.01),('5815','2013-06-26','15:45:00',2.02),('5815','2013-06-26','15:50:00',1.99),('5815','2013-06-26','15:55:00',1.93),('5815','2013-06-26','16:00:00',1.85),('5815','2013-06-26','16:05:00',1.82),('5815','2013-06-26','16:10:00',1.79),('5815','2013-06-26','16:15:00',1.76),('5815','2013-06-26','16:20:00',1.74),('5815','2013-06-26','16:25:00',1.72),('5815','2013-06-26','16:30:00',1.68),('5815','2013-06-26','16:35:00',1.54),('5815','2013-06-26','16:40:00',1.55),('5815','2013-06-26','16:45:00',1.56),('5815','2013-06-26','16:50:00',1.5),('5815','2013-06-26','16:55:00',1.49),('5815','2013-06-26','17:00:00',1.45),('5815','2013-06-26','17:05:00',1.4),('5815','2013-06-26','17:10:00',1.31),('5815','2013-06-26','17:15:00',1.24),('5815','2013-06-26','17:20:00',1.27),('5815','2013-06-26','17:25:00',1.25),('5815','2013-06-26','17:30:00',1.18),('5815','2013-06-26','17:35:00',1.1),('5815','2013-06-25','08:40:00',1.03),('5815','2013-06-25','08:45:00',1.08),('5815','2013-06-25','08:50:00',1.12),('5815','2013-06-25','08:55:00',1.17),('5815','2013-06-25','09:00:00',1.21),('5815','2013-06-25','09:05:00',1.26),('5815','2013-06-25','09:10:00',1.3),('5815','2013-06-25','09:15:00',1.34),('5815','2013-06-25','09:20:00',1.37),('5815','2013-06-25','09:25:00',1.43),('5815','2013-06-25','09:30:00',1.48),('5815','2013-06-25','09:35:00',1.52),('5815','2013-06-25','09:40:00',1.54),('5815','2013-06-25','09:45:00',1.58),('5815','2013-06-25','09:50:00',1.61),('5815','2013-06-25','09:55:00',1.64),('5815','2013-06-25','10:00:00',1.69),('5815','2013-06-25','10:05:00',1.74),('5815','2013-06-25','10:10:00',1.77),('5815','2013-06-25','10:15:00',1.8),('5815','2013-06-25','10:20:00',1.84),('5815','2013-06-25','10:25:00',1.86),('5815','2013-06-25','10:30:00',1.87),('5815','2013-06-25','10:35:00',1.91),('5815','2013-06-25','10:40:00',1.95),('5815','2013-06-25','10:45:00',1.98),('5815','2013-06-25','10:50:00',2),('5815','2013-06-25','10:55:00',2.02),('5815','2013-06-25','11:00:00',2.04),('5815','2013-06-25','11:05:00',2.01),('5815','2013-06-25','11:10:00',2),('5815','2013-06-25','11:15:00',2.07),('5815','2013-06-25','11:20:00',2.08),('5815','2013-06-25','11:25:00',2.09),('5815','2013-06-25','11:30:00',2.12),('5815','2013-06-25','11:35:00',2.15),('5815','2013-06-25','11:40:00',2.16),('5815','2013-06-25','11:45:00',2.16),('5815','2013-06-25','11:50:00',2.17),('5815','2013-06-25','11:55:00',2.19),('5815','2013-06-25','12:00:00',2.22),('5815','2013-06-25','12:05:00',2.22),('5815','2013-06-25','12:10:00',2.22),('5815','2013-06-25','12:15:00',2.17),('5815','2013-06-25','12:20:00',2.16),('5815','2013-06-25','12:25:00',2.22),('5815','2013-06-25','12:30:00',2.29),('5815','2013-06-25','12:35:00',2.26),('5815','2013-06-25','12:40:00',2.3),('5815','2013-06-25','12:45:00',2.28),('5815','2013-06-25','12:50:00',1.17),('5815','2013-06-25','13:15:00',2.12),('5815','2013-06-25','13:20:00',2.62),('5815','2013-06-25','13:25:00',1.77),('5815','2013-06-25','13:55:00',1.47),('5815','2013-06-25','14:00:00',1.45),('5815','2013-06-25','14:10:00',1.25),('5815','2013-06-25','14:15:00',2.59),('5815','2013-06-25','14:20:00',2.41),('5815','2013-06-25','14:25:00',2.11),('5815','2013-06-25','14:30:00',1.99),('5815','2013-06-25','14:35:00',2.33),('5815','2013-06-25','14:45:00',1.99),('5815','2013-06-25','14:50:00',2.43),('5815','2013-06-25','14:55:00',2.18),('5815','2013-06-25','15:00:00',2.24),('5815','2013-06-25','15:05:00',2.2),('5815','2013-06-25','15:10:00',2.14),('5815','2013-06-25','15:15:00',2.13),('5815','2013-06-25','15:20:00',2.1),('5815','2013-06-25','15:25:00',2.08),('5815','2013-06-25','15:30:00',2.05),('5815','2013-06-25','15:35:00',2.07),('5815','2013-06-25','15:40:00',2.02),('5815','2013-06-25','15:45:00',2.04),('5815','2013-06-25','15:50:00',2.03),('5815','2013-06-25','15:55:00',1.86),('5815','2013-06-25','16:00:00',1.9),('5815','2013-06-25','16:05:00',1.86),('5815','2013-06-25','16:10:00',1.84),('5815','2013-06-25','16:15:00',1.82),('5815','2013-06-25','16:20:00',1.78),('5815','2013-06-25','16:25:00',1.75),('5815','2013-06-25','16:30:00',1.72),('5815','2013-06-25','16:35:00',1.67),('5815','2013-06-25','16:40:00',1.61),('5815','2013-06-25','16:45:00',1.55),('5815','2013-06-25','16:50:00',1.53),('5815','2013-06-25','16:55:00',1.51),('5815','2013-06-25','17:00:00',1.49),('5815','2013-06-25','17:05:00',1.43),('5815','2013-06-25','17:10:00',1.38),('5815','2013-06-25','17:15:00',1.33),('5815','2013-06-25','17:20:00',1.29),('5815','2013-06-25','17:25:00',1.24),('5815','2013-06-25','17:30:00',1.19),('5815','2013-06-25','17:35:00',1.08),('5815','2013-06-25','17:45:00',1.03),('5815','2013-06-25','17:50:00',1.01),('5815','2013-06-25','18:10:00',1.02),('5815','2013-06-24','08:35:00',1.01),('5815','2013-06-24','08:40:00',1.06),('5815','2013-06-24','08:45:00',1.11),('5815','2013-06-24','08:50:00',1.15),('5815','2013-06-24','08:55:00',1.2),('5815','2013-06-24','09:00:00',1.25),('5815','2013-06-24','09:05:00',1.3),('5815','2013-06-24','09:10:00',1.34),('5815','2013-06-24','09:15:00',1.4),('5815','2013-06-24','09:20:00',1.38),('5815','2013-06-24','09:25:00',1.51),('5815','2013-06-24','09:30:00',1.55),('5815','2013-06-24','09:35:00',1.64),('5815','2013-06-24','09:40:00',1.67),('5815','2013-06-24','09:45:00',1.72),('5815','2013-06-24','09:50:00',1.82),('5815','2013-06-24','09:55:00',1.89),('5815','2013-06-24','10:00:00',1.94),('5815','2013-06-24','10:05:00',1.14),('5815','2013-06-24','10:10:00',1.35),('5815','2013-06-24','10:15:00',2.09),('5815','2013-06-24','10:20:00',2.08),('5815','2013-06-24','10:25:00',1.37),('5815','2013-06-24','10:30:00',2.17),('5815','2013-06-24','10:35:00',2.2),('5815','2013-06-24','10:40:00',2.18),('5815','2013-06-24','10:45:00',2.1),('5815','2013-06-24','10:50:00',2.16),('5815','2013-06-24','10:55:00',1.97),('5815','2013-06-24','11:10:00',1.91),('5815','2013-06-24','11:15:00',1.36),('5815','2013-06-24','11:20:00',2.2),('5815','2013-06-24','11:30:00',1.21),('5815','2013-06-24','11:35:00',1.86),('5815','2013-06-24','11:40:00',2.28),('5815','2013-06-24','11:45:00',2.31),('5815','2013-06-24','11:50:00',1.76),('5815','2013-06-24','11:55:00',1.66),('5815','2013-06-24','12:00:00',1.97),('5815','2013-06-24','12:05:00',1.68),('5815','2013-06-24','12:10:00',1.57),('5815','2013-06-24','12:15:00',1.72),('5815','2013-06-24','12:20:00',1.11),('5815','2013-06-24','12:55:00',1.56),('5815','2013-06-24','13:00:00',2.66),('5815','2013-06-24','13:05:00',2.57),('5815','2013-06-24','13:10:00',2.58),('5815','2013-06-24','13:15:00',2.39),('5815','2013-06-24','13:20:00',2.54),('5815','2013-06-24','13:25:00',2.49),('5815','2013-06-24','13:30:00',2.52),('5815','2013-06-24','13:35:00',2.2),('5815','2013-06-24','13:40:00',1.74),('5815','2013-06-24','13:45:00',2.58),('5815','2013-06-24','13:50:00',2.17),('5815','2013-06-24','13:55:00',2.5),('5815','2013-06-24','14:00:00',1.99),('5815','2013-06-24','14:05:00',2.46),('5815','2013-06-24','14:10:00',2.55),('5815','2013-06-24','14:15:00',1.83),('5815','2013-06-24','14:20:00',2.34),('5815','2013-06-24','14:25:00',2.37),('5815','2013-06-24','14:30:00',2.34),('5815','2013-06-24','14:35:00',2.29),('5815','2013-06-24','14:40:00',2.15),('5815','2013-06-24','14:45:00',1.93),('5815','2013-06-24','14:50:00',2.3),('5815','2013-06-24','14:55:00',2.25),('5815','2013-06-24','15:00:00',2.23),('5815','2013-06-24','15:05:00',2.19),('5815','2013-06-24','15:10:00',2.14),('5815','2013-06-24','15:15:00',2.15),('5815','2013-06-24','15:20:00',2.09),('5815','2013-06-24','15:25:00',2.07),('5815','2013-06-24','15:30:00',2.06),('5815','2013-06-24','15:35:00',2.03),('5815','2013-06-24','15:40:00',2.01),('5815','2013-06-24','15:45:00',2.02),('5815','2013-06-24','15:50:00',1.97),('5815','2013-06-24','15:55:00',1.91),('5815','2013-06-24','16:00:00',1.89),('5815','2013-06-24','16:05:00',1.86),('5815','2013-06-24','16:10:00',1.83),('5815','2013-06-24','16:15:00',1.79),('5815','2013-06-24','16:20:00',1.76),('5815','2013-06-24','16:25:00',1.72),('5815','2013-06-24','16:30:00',1.69),('5815','2013-06-24','16:35:00',1.64),('5815','2013-06-24','16:40:00',1.59),('5815','2013-06-24','16:45:00',1.57),('5815','2013-06-24','16:50:00',1.54),('5815','2013-06-24','16:55:00',1.5),('5815','2013-06-24','17:00:00',1.47),('5815','2013-06-24','17:05:00',1.41),('5815','2013-06-24','17:10:00',1.35),('5815','2013-06-24','17:15:00',1.33),('5815','2013-06-24','17:20:00',1.29),('5815','2013-06-24','17:25:00',1.23),('5815','2013-06-24','17:30:00',1.18),('5815','2013-06-24','17:35:00',1.07),('5815','2013-06-24','17:40:00',1.04),('5815','2013-06-24','17:45:00',1.02),('5815','2013-06-23','08:50:00',1.23),('5815','2013-06-23','08:55:00',1.29),('5815','2013-06-23','09:00:00',1.11),('5815','2013-06-23','09:05:00',1.21),('5815','2013-06-23','09:15:00',1.33),('5815','2013-06-23','09:20:00',1.51),('5815','2013-06-23','09:25:00',1.52),('5815','2013-06-23','09:30:00',1.53),('5815','2013-06-23','09:40:00',1.12),('5815','2013-06-23','09:45:00',1.14),('5815','2013-06-23','09:50:00',1.41),('5815','2013-06-23','09:55:00',1.81),('5815','2013-06-23','10:00:00',1.84),('5815','2013-06-23','10:05:00',1.86),('5815','2013-06-23','10:10:00',1.94),('5815','2013-06-23','10:15:00',2.09),('5815','2013-06-23','10:20:00',1.36),('5815','2013-06-23','10:25:00',2.18),('5815','2013-06-23','10:30:00',1.26),('5815','2013-06-23','10:35:00',1.72),('5815','2013-06-23','10:40:00',1.28),('5815','2013-06-23','10:45:00',1.39),('5815','2013-06-23','10:50:00',1.8),('5815','2013-06-23','10:55:00',1.79),('5815','2013-06-23','11:00:00',2.43),('5815','2013-06-23','11:05:00',2.03),('5815','2013-06-23','11:10:00',2.14),('5815','2013-06-23','11:15:00',1.2),('5815','2013-06-23','11:20:00',1.87),('5815','2013-06-23','11:50:00',1.53),('5815','2013-06-23','11:55:00',2.05),('5815','2013-06-23','12:00:00',1.98),('5815','2013-06-23','12:05:00',2.18),('5815','2013-06-23','12:10:00',2.41),('5815','2013-06-23','12:15:00',2.14),('5815','2013-06-23','12:20:00',2.23),('5815','2013-06-23','12:25:00',1.48),('5815','2013-06-23','12:30:00',1.49),('5815','2013-06-23','12:35:00',2.66),('5815','2013-06-23','12:40:00',2.74),('5815','2013-06-23','12:45:00',1.32),('5815','2013-06-23','12:50:00',2.85),('5815','2013-06-23','12:55:00',2.8),('5815','2013-06-23','13:00:00',2.63),('5815','2013-06-23','13:05:00',2.71),('5815','2013-06-23','13:10:00',2.27),('5815','2013-06-23','13:15:00',1.82),('5815','2013-06-23','13:20:00',1.41),('5815','2013-06-23','13:25:00',2.36),('5815','2013-06-23','13:30:00',2.46),('5815','2013-06-23','13:35:00',2.25),('5815','2013-06-23','13:40:00',2.41),('5815','2013-06-23','13:45:00',2.58),('5815','2013-06-23','13:50:00',2.49),('5815','2013-06-23','13:55:00',2.45),('5815','2013-06-23','14:00:00',2.44),('5815','2013-06-23','14:05:00',2.45),('5815','2013-06-23','14:10:00',2.47),('5815','2013-06-23','14:15:00',2.45),('5815','2013-06-23','14:20:00',2.41),('5815','2013-06-23','14:25:00',2.41),('5815','2013-06-23','14:30:00',2.42),('5815','2013-06-23','14:35:00',2.38),('5815','2013-06-23','14:40:00',2.4),('5815','2013-06-23','14:45:00',2.43),('5815','2013-06-23','14:50:00',2.25),('5815','2013-06-23','14:55:00',2.58),('5815','2013-06-23','15:00:00',2.58),('5815','2013-06-23','15:05:00',1.83),('5815','2013-06-23','15:10:00',1.16),('5815','2013-06-23','15:15:00',2.14),('5815','2013-06-23','15:20:00',2.33),('5815','2013-06-23','15:25:00',2.12),('5815','2013-06-23','15:30:00',1.57),('5815','2013-06-23','15:35:00',1.96),('5815','2013-06-23','15:40:00',1.31),('5815','2013-06-23','15:45:00',2.12),('5815','2013-06-23','15:50:00',1.52),('5815','2013-06-23','15:55:00',1.72),('5815','2013-06-23','16:00:00',2.08),('5815','2013-06-23','16:05:00',2.05),('5815','2013-06-23','16:10:00',2.02),('5815','2013-06-23','16:15:00',2.14),('5815','2013-06-23','16:20:00',1.66),('5815','2013-06-23','16:25:00',1.4),('5815','2013-06-23','16:30:00',1.9),('5815','2013-06-23','16:35:00',1.54),('5815','2013-06-23','16:40:00',1.1),('5815','2013-06-23','16:45:00',1.25),('5815','2013-06-23','16:50:00',1.15),('5815','2013-06-23','17:05:00',1.1),('5815','2013-06-23','17:10:00',1.31),('5815','2013-06-23','17:15:00',1.64),('5815','2013-06-23','17:20:00',1.46),('5815','2013-06-23','17:30:00',1.28),('5815','2013-06-23','17:50:00',1.11),('5815','2013-06-23','18:00:00',1.06),('5815','2013-06-22','09:25:00',1.35),('5815','2013-06-22','09:30:00',1.54),('5815','2013-06-22','09:35:00',1.58),('5815','2013-06-22','09:40:00',1.79),('5815','2013-06-22','09:45:00',1.26),('5815','2013-06-22','10:00:00',1.68),('5815','2013-06-22','10:05:00',1.9),('5815','2013-06-22','10:10:00',1.52),('5815','2013-06-22','10:15:00',1.86),('5815','2013-06-22','10:20:00',1.37),('5815','2013-06-22','10:45:00',2.09),('5815','2013-06-22','10:50:00',1.13),('5815','2013-06-22','10:55:00',2.07),('5815','2013-06-22','11:00:00',1.99),('5815','2013-06-22','11:05:00',1.97),('5815','2013-06-22','11:10:00',2.04),('5815','2013-06-22','11:15:00',2.05),('5815','2013-06-22','11:20:00',2.15),('5815','2013-06-22','11:25:00',2.1),('5815','2013-06-22','11:30:00',2.1),('5815','2013-06-22','11:35:00',2.17),('5815','2013-06-22','11:40:00',2.11),('5815','2013-06-22','11:45:00',2.12),('5815','2013-06-22','11:50:00',2.19),('5815','2013-06-22','11:55:00',2.22),('5815','2013-06-22','12:00:00',1.55),('5815','2013-06-22','12:05:00',1.57),('5815','2013-06-22','12:10:00',2.35),('5815','2013-06-22','12:15:00',2.31),('5815','2013-06-22','12:20:00',2.33),('5815','2013-06-22','12:25:00',2.29),('5815','2013-06-22','12:30:00',2.31),('5815','2013-06-22','12:35:00',2.28),('5815','2013-06-22','12:40:00',2.28),('5815','2013-06-22','12:45:00',2.29),('5815','2013-06-22','12:50:00',2.33),('5815','2013-06-22','12:55:00',2.34),('5815','2013-06-22','13:00:00',2.36),('5815','2013-06-22','13:05:00',2.36),('5815','2013-06-22','13:10:00',2.36),('5815','2013-06-22','13:15:00',2.36),('5815','2013-06-22','13:20:00',2.35),('5815','2013-06-22','13:25:00',2.35),('5815','2013-06-22','13:30:00',2.36),('5815','2013-06-22','13:35:00',2.37),('5815','2013-06-22','13:40:00',2.38),('5815','2013-06-22','13:45:00',2.38),('5815','2013-06-22','13:50:00',2.37),('5815','2013-06-22','13:55:00',2.36),('5815','2013-06-22','14:00:00',2.33),('5815','2013-06-22','14:05:00',2.34),('5815','2013-06-22','14:10:00',2.34),('5815','2013-06-22','14:15:00',2.34),('5815','2013-06-22','14:20:00',2.3),('5815','2013-06-22','14:25:00',2.29),('5815','2013-06-22','14:30:00',2.3),('5815','2013-06-22','14:35:00',2.3),('5815','2013-06-22','14:40:00',2.29),('5815','2013-06-22','14:45:00',2.28),('5815','2013-06-22','14:50:00',2.27),('5815','2013-06-22','14:55:00',2.26),('5815','2013-06-22','15:00:00',2.26),('5815','2013-06-22','15:05:00',2.22),('5815','2013-06-22','15:10:00',2.15),('5815','2013-06-22','15:15:00',2.15),('5815','2013-06-22','15:20:00',2.16),('5815','2013-06-22','15:25:00',2.14),('5815','2013-06-22','15:30:00',2.09),('5815','2013-06-22','15:35:00',2.06),('5815','2013-06-22','15:40:00',2.05),('5815','2013-06-22','15:45:00',2.06),('5815','2013-06-22','15:50:00',2.04),('5815','2013-06-22','15:55:00',1.95),('5815','2013-06-22','16:00:00',1.89),('5815','2013-06-22','16:05:00',1.91),('5815','2013-06-22','16:10:00',1.86),('5815','2013-06-22','16:15:00',1.82),('5815','2013-06-22','16:20:00',1.78),('5815','2013-06-22','16:25:00',1.75),('5815','2013-06-22','16:30:00',1.72),('5815','2013-06-22','16:35:00',1.68),('5815','2013-06-22','16:40:00',1.65),('5815','2013-06-22','16:45:00',1.58),('5815','2013-06-22','16:50:00',1.57),('5815','2013-06-22','16:55:00',1.53),('5815','2013-06-22','17:00:00',1.5),('5815','2013-06-22','17:05:00',1.42),('5815','2013-06-22','17:10:00',1.36),('5815','2013-06-22','17:15:00',1.31),('5815','2013-06-22','17:20:00',1.23),('5815','2013-06-22','17:30:00',1.21),('5815','2013-06-22','17:35:00',1.13),('5815','2013-06-22','17:40:00',1.1),('5815','2013-06-22','17:50:00',1.04),('5815','2013-06-21','08:45:00',1.04),('5815','2013-06-21','08:50:00',1.08),('5815','2013-06-21','08:55:00',1.13),('5815','2013-06-21','09:00:00',1.18),('5815','2013-06-21','09:05:00',1.21),('5815','2013-06-21','09:10:00',1.25),('5815','2013-06-21','09:15:00',1.29),('5815','2013-06-21','09:20:00',1.33),('5815','2013-06-21','09:25:00',1.37),('5815','2013-06-21','09:30:00',1.4),('5815','2013-06-21','09:35:00',1.44),('5815','2013-06-21','09:40:00',1.48),('5815','2013-06-21','09:45:00',1.52),('5815','2013-06-21','09:50:00',1.54),('5815','2013-06-21','09:55:00',1.59),('5815','2013-06-21','10:00:00',1.64),('5815','2013-06-21','10:05:00',1.68),('5815','2013-06-21','10:10:00',1.72),('5815','2013-06-21','10:15:00',1.75),('5815','2013-06-21','10:20:00',1.78),('5815','2013-06-21','10:25:00',1.81),('5815','2013-06-21','10:30:00',1.83),('5815','2013-06-21','10:35:00',1.86),('5815','2013-06-21','10:40:00',1.89),('5815','2013-06-21','10:45:00',1.94),('5815','2013-06-21','10:50:00',1.96),('5815','2013-06-21','10:55:00',1.97),('5815','2013-06-21','11:00:00',1.98),('5815','2013-06-21','11:05:00',1.96),('5815','2013-06-21','11:10:00',1.99),('5815','2013-06-21','11:15:00',2.01),('5815','2013-06-21','11:20:00',2.04),('5815','2013-06-21','11:25:00',2.07),('5815','2013-06-21','11:30:00',2.07),('5815','2013-06-21','11:35:00',2.13),('5815','2013-06-21','11:40:00',2.11),('5815','2013-06-21','11:45:00',2.05),('5815','2013-06-21','11:50:00',2.05),('5815','2013-06-21','11:55:00',2.15),('5815','2013-06-21','12:00:00',2.16),('5815','2013-06-21','12:05:00',2.13),('5815','2013-06-21','12:10:00',2.09),('5815','2013-06-21','12:15:00',2.19),('5815','2013-06-21','12:20:00',2.2),('5815','2013-06-21','12:25:00',2.2),('5815','2013-06-21','12:30:00',2.22),('5815','2013-06-21','12:35:00',2.21),('5815','2013-06-21','12:40:00',2.26),('5815','2013-06-21','12:45:00',2.25),('5815','2013-06-21','12:50:00',2.21),('5815','2013-06-21','12:55:00',2.19),('5815','2013-06-21','13:00:00',2.16),('5815','2013-06-21','13:05:00',2.17),('5815','2013-06-21','13:10:00',2.16),('5815','2013-06-21','13:15:00',2.13),('5815','2013-06-21','13:20:00',2.07),('5815','2013-06-21','13:25:00',2.15),('5815','2013-06-21','13:30:00',2.35),('5815','2013-06-21','13:35:00',2.36),('5815','2013-06-21','13:40:00',2.19),('5815','2013-06-21','13:45:00',2.18),('5815','2013-06-21','13:50:00',2.34),('5815','2013-06-21','13:55:00',1.85),('5815','2013-06-21','14:00:00',1.24),('5815','2013-06-21','14:05:00',2.53),('5815','2013-06-21','14:10:00',2.43),('5815','2013-06-21','14:15:00',2.41),('5815','2013-06-21','14:20:00',1.92),('5815','2013-06-21','14:25:00',2.35),('5815','2013-06-21','14:30:00',1.72),('5815','2013-06-21','14:35:00',1.32),('5815','2013-06-21','14:45:00',1.12),('5815','2013-06-21','14:50:00',1.8),('5815','2013-06-21','14:55:00',2.27),('5815','2013-06-21','15:00:00',2.13),('5815','2013-06-21','15:05:00',1.89),('5815','2013-06-21','15:10:00',1.99),('5815','2013-06-21','15:15:00',2.22),('5815','2013-06-21','15:20:00',2.05),('5815','2013-06-21','15:25:00',1.93),('5815','2013-06-21','15:30:00',1.3),('5815','2013-06-21','15:35:00',1.2),('5815','2013-06-21','15:40:00',1.15),('5815','2013-06-21','15:45:00',1.5),('5815','2013-06-21','15:50:00',1.48),('5815','2013-06-21','15:55:00',1.38),('5815','2013-06-21','16:00:00',1.15),('5815','2013-06-21','16:20:00',1.05),('5815','2013-06-21','17:10:00',1.02),('5815','2013-06-21','17:15:00',1.54),('5815','2013-06-21','17:20:00',1.47),('5815','2013-06-21','17:25:00',1.48),('5815','2013-06-21','17:30:00',1.28),('5815','2013-06-21','17:40:00',1.11),('5815','2013-06-21','17:45:00',1.14),('5815','2013-06-21','17:50:00',1.05),('5815','2013-06-21','17:55:00',1.01),('5815','2013-06-20','08:45:00',1.01),('5815','2013-06-20','08:50:00',1.06),('5815','2013-06-20','08:55:00',1.1),('5815','2013-06-20','09:00:00',1.14),('5815','2013-06-20','09:05:00',1.17),('5815','2013-06-20','09:10:00',1.2),('5815','2013-06-20','09:15:00',1.24),('5815','2013-06-20','09:20:00',1.27),('5815','2013-06-20','09:25:00',1.31),('5815','2013-06-20','09:30:00',1.34),('5815','2013-06-20','09:35:00',1.38),('5815','2013-06-20','09:40:00',1.41),('5815','2013-06-20','09:45:00',1.45),('5815','2013-06-20','09:50:00',1.5),('5815','2013-06-20','09:55:00',1.52),('5815','2013-06-20','10:00:00',1.54),('5815','2013-06-20','10:05:00',1.57),('5815','2013-06-20','10:10:00',1.58),('5815','2013-06-20','10:15:00',1.64),('5815','2013-06-20','10:20:00',1.67),('5815','2013-06-20','10:25:00',1.68),('5815','2013-06-20','10:30:00',1.72),('5815','2013-06-20','10:35:00',1.75),('5815','2013-06-20','10:40:00',1.75),('5815','2013-06-20','10:45:00',1.77),('5815','2013-06-20','10:50:00',1.82),('5815','2013-06-20','10:55:00',1.84),('5815','2013-06-20','11:00:00',1.85),('5815','2013-06-20','11:05:00',1.82),('5815','2013-06-20','11:10:00',1.81),('5815','2013-06-20','11:15:00',1.88),('5815','2013-06-20','11:20:00',1.91),('5815','2013-06-20','11:25:00',1.94),('5815','2013-06-20','11:30:00',1.97),('5815','2013-06-20','11:35:00',1.99),('5815','2013-06-20','11:40:00',1.99),('5815','2013-06-20','11:45:00',1.94),('5815','2013-06-20','11:50:00',1.95),('5815','2013-06-20','11:55:00',2.02),('5815','2013-06-20','12:00:00',2.05),('5815','2013-06-20','12:05:00',2.06),('5815','2013-06-20','12:10:00',2.07),('5815','2013-06-20','12:15:00',2.07),('5815','2013-06-20','12:20:00',2.06),('5815','2013-06-20','12:25:00',2.09),('5815','2013-06-20','12:30:00',2.15),('5815','2013-06-20','12:35:00',2.1),('5815','2013-06-20','12:40:00',2.08),('5815','2013-06-20','12:45:00',2.11),('5815','2013-06-20','12:50:00',2.08),('5815','2013-06-20','12:55:00',2.05),('5815','2013-06-20','13:00:00',2.08),('5815','2013-06-20','13:05:00',2.05),('5815','2013-06-20','13:10:00',2.07),('5815','2013-06-20','13:15:00',2.11),('5815','2013-06-20','13:20:00',2.14),('5815','2013-06-20','13:25:00',2.15),('5815','2013-06-20','13:30:00',2.15),('5815','2013-06-20','13:35:00',2.17),('5815','2013-06-20','13:40:00',2.16),('5815','2013-06-20','13:45:00',2.14),('5815','2013-06-20','13:50:00',2.15),('5815','2013-06-20','13:55:00',2.17),('5815','2013-06-20','14:00:00',2.15),('5815','2013-06-20','14:05:00',2.18),('5815','2013-06-20','14:10:00',2.17),('5815','2013-06-20','14:15:00',2.17),('5815','2013-06-20','14:20:00',2.14),('5815','2013-06-20','14:25:00',2.14),('5815','2013-06-20','14:30:00',2.16),('5815','2013-06-20','14:35:00',2.16),('5815','2013-06-20','14:40:00',2.14),('5815','2013-06-20','14:45:00',2.14),('5815','2013-06-20','14:50:00',2.12),('5815','2013-06-20','14:55:00',2.1),('5815','2013-06-20','15:00:00',2.11),('5815','2013-06-20','15:05:00',2.07),('5815','2013-06-20','15:10:00',2.03),('5815','2013-06-20','15:15:00',2.02),('5815','2013-06-20','15:20:00',2),('5815','2013-06-20','15:25:00',1.98),('5815','2013-06-20','15:30:00',1.96),('5815','2013-06-20','15:35:00',1.94),('5815','2013-06-20','15:40:00',1.9),('5815','2013-06-20','15:45:00',1.93),('5815','2013-06-20','15:50:00',1.9),('5815','2013-06-20','15:55:00',1.83),('5815','2013-06-20','16:00:00',1.8),('5815','2013-06-20','16:05:00',1.78),('5815','2013-06-20','16:10:00',1.75),('5815','2013-06-20','16:15:00',1.72),('5815','2013-06-20','16:20:00',1.69),('5815','2013-06-20','16:25:00',1.67),('5815','2013-06-20','16:30:00',1.63),('5815','2013-06-20','16:35:00',1.59),('5815','2013-06-20','16:40:00',1.55),('5815','2013-06-20','16:45:00',1.52),('5815','2013-06-20','16:50:00',1.47),('5815','2013-06-20','16:55:00',1.45),('5815','2013-06-20','17:00:00',1.41),('5815','2013-06-20','17:05:00',1.34),('5815','2013-06-20','17:10:00',1.3),('5815','2013-06-20','17:15:00',1.28),('5815','2013-06-20','17:20:00',1.24),('5815','2013-06-20','17:25:00',1.2),('5815','2013-06-20','17:30:00',1.13),('5815','2013-06-19','08:45:00',1.02),('5815','2013-06-19','08:50:00',1.07),('5815','2013-06-19','08:55:00',1.11),('5815','2013-06-19','09:00:00',1.15),('5815','2013-06-19','09:05:00',1.19),('5815','2013-06-19','09:10:00',1.24),('5815','2013-06-19','09:15:00',1.27),('5815','2013-06-19','09:20:00',1.31),('5815','2013-06-19','09:25:00',1.35),('5815','2013-06-19','09:30:00',1.39),('5815','2013-06-19','09:35:00',1.43),('5815','2013-06-19','09:40:00',1.46),('5815','2013-06-19','09:45:00',1.48),('5815','2013-06-19','09:50:00',1.53),('5815','2013-06-19','09:55:00',1.56),('5815','2013-06-19','10:00:00',1.61),('5815','2013-06-19','10:05:00',1.64),('5815','2013-06-19','10:10:00',1.67),('5815','2013-06-19','10:15:00',1.69),('5815','2013-06-19','10:20:00',1.72),('5815','2013-06-19','10:25:00',1.75),('5815','2013-06-19','10:30:00',1.78),('5815','2013-06-19','10:35:00',1.82),('5815','2013-06-19','10:40:00',1.83),('5815','2013-06-19','10:45:00',1.86),('5815','2013-06-19','10:50:00',1.87),('5815','2013-06-19','10:55:00',1.88),('5815','2013-06-19','12:05:00',1.98),('5815','2013-06-19','12:10:00',2.01),('5815','2013-06-19','12:15:00',2.03),('5815','2013-06-19','12:20:00',2.01),('5815','2013-06-19','12:25:00',2.04),('5815','2013-06-19','12:30:00',2),('5815','2013-06-19','12:35:00',2.11),('5815','2013-06-19','12:40:00',2.1),('5815','2013-06-19','12:45:00',2.05),('5815','2013-06-19','12:50:00',2.15),('5815','2013-06-19','12:55:00',1.97),('5815','2013-06-19','13:00:00',1.12),('5815','2013-06-19','13:05:00',1.7),('5815','2013-06-19','13:10:00',2.26),('5815','2013-06-19','13:15:00',2.23),('5815','2013-06-19','13:20:00',2.18),('5815','2013-06-19','13:25:00',2.1),('5815','2013-06-19','13:30:00',1.86),('5815','2013-06-19','13:35:00',2.12),('5815','2013-06-19','13:40:00',2.15),('5815','2013-06-19','13:45:00',2.16),('5815','2013-06-19','13:50:00',2.15),('5815','2013-06-19','13:55:00',2.16),('5815','2013-06-19','14:00:00',2.18),('5815','2013-06-19','14:05:00',2.19),('5815','2013-06-19','14:10:00',2.26),('5815','2013-06-19','14:15:00',2.23),('5815','2013-06-19','14:20:00',2.2),('5815','2013-06-19','14:25:00',2.2),('5815','2013-06-19','14:30:00',2.18),('5815','2013-06-19','14:35:00',2.19),('5815','2013-06-19','14:40:00',2.21),('5815','2013-06-19','14:45:00',2.19),('5815','2013-06-19','14:50:00',2.19),('5815','2013-06-19','14:55:00',2.17),('5815','2013-06-19','15:00:00',2.15),('5815','2013-06-19','15:05:00',2.11),('5815','2013-06-19','15:10:00',2.09),('5815','2013-06-19','15:15:00',2.08),('5815','2013-06-19','15:20:00',2.02),('5815','2013-06-19','15:25:00',2.04),('5815','2013-06-19','15:30:00',2.01),('5815','2013-06-19','15:35:00',1.98),('5815','2013-06-19','15:40:00',1.96),('5815','2013-06-19','15:45:00',1.98),('5815','2013-06-19','15:50:00',1.93),('5815','2013-06-19','15:55:00',1.84),('5815','2013-06-19','16:00:00',1.74),('5815','2013-06-19','16:05:00',1.72),('5815','2013-06-19','16:10:00',1.79),('5815','2013-06-19','16:15:00',1.75),('5815','2013-06-19','16:20:00',1.71),('5815','2013-06-19','16:25:00',1.69),('5815','2013-06-19','16:30:00',1.66),('5815','2013-06-19','16:35:00',1.61),('5815','2013-06-19','16:40:00',1.56),('5815','2013-06-19','16:45:00',1.51),('5815','2013-06-19','16:50:00',1.47),('5815','2013-06-19','16:55:00',1.46),('5815','2013-06-19','17:00:00',1.43),('5815','2013-06-19','17:05:00',1.36),('5815','2013-06-19','17:10:00',1.33),('5815','2013-06-19','17:15:00',1.28),('5815','2013-06-19','17:20:00',1.24),('5815','2013-06-19','17:25:00',1.21),('5815','2013-06-19','17:30:00',1.13),('5815','2013-06-19','17:35:00',1.01),('5815','2013-06-19','17:40:00',1.04),('5815','2013-06-19','17:45:00',1.01),('5815','2013-06-18','08:45:00',1),('5815','2013-06-18','08:50:00',1.05),('5815','2013-06-18','08:55:00',1.09),('5815','2013-06-18','09:00:00',1.13),('5815','2013-06-18','09:05:00',1.17),('5815','2013-06-18','09:10:00',1.22),('5815','2013-06-18','09:15:00',1.26),('5815','2013-06-18','09:20:00',1.3),('5815','2013-06-18','09:25:00',1.33),('5815','2013-06-18','09:30:00',1.37),('5815','2013-06-18','09:35:00',1.39),('5815','2013-06-18','09:40:00',1.44),('5815','2013-06-18','09:45:00',1.48),('5815','2013-06-18','09:50:00',1.5),('5815','2013-06-18','09:55:00',1.54),('5815','2013-06-18','10:00:00',1.57),('5815','2013-06-18','10:05:00',1.6),('5815','2013-06-18','10:10:00',1.63),('5815','2013-06-18','10:15:00',1.67),('5815','2013-06-18','10:20:00',1.7),('5815','2013-06-18','10:25:00',1.72),('5815','2013-06-18','10:30:00',1.73),('5815','2013-06-18','10:35:00',1.75),('5815','2013-06-18','10:40:00',1.78),('5815','2013-06-18','10:45:00',1.83),('5815','2013-06-18','10:50:00',1.84),('5815','2013-06-18','10:55:00',1.85),('5815','2013-06-18','11:00:00',1.84),('5815','2013-06-18','11:05:00',1.85),('5815','2013-06-18','11:10:00',1.86),('5815','2013-06-18','11:15:00',1.87),('5815','2013-06-18','11:20:00',1.89),('5815','2013-06-18','11:25:00',1.91),('5815','2013-06-18','11:30:00',1.93),('5815','2013-06-18','11:35:00',1.97),('5815','2013-06-18','11:40:00',1.97),('5815','2013-06-18','11:45:00',1.97),('5815','2013-06-18','11:50:00',1.96),('5815','2013-06-18','11:55:00',1.95),('5815','2013-06-18','12:00:00',1.99),('5815','2013-06-18','12:05:00',1.98),('5815','2013-06-18','12:10:00',2.03),('5815','2013-06-18','12:15:00',2.02),('5815','2013-06-18','12:20:00',2.04),('5815','2013-06-18','12:25:00',2.06),('5815','2013-06-18','12:30:00',2.09),('5815','2013-06-18','12:35:00',2.07),('5815','2013-06-18','12:40:00',2.09),('5815','2013-06-18','12:45:00',2.12),('5815','2013-06-18','12:50:00',2.12),('5815','2013-06-18','12:55:00',2.12),('5815','2013-06-18','13:00:00',2.1),('5815','2013-06-18','13:05:00',2.1),('5815','2013-06-18','13:10:00',2.1),('5815','2013-06-18','13:15:00',2.12),('5815','2013-06-18','13:20:00',2.1),('5815','2013-06-18','13:25:00',2.16),('5815','2013-06-18','13:30:00',2.16),('5815','2013-06-18','13:35:00',2.15),('5815','2013-06-18','13:40:00',2.16),('5815','2013-06-18','13:45:00',2.16),('5815','2013-06-18','13:50:00',2.14),('5815','2013-06-18','13:55:00',2.18),('5815','2013-06-18','14:00:00',2.19),('5815','2013-06-18','14:05:00',2.18),('5815','2013-06-18','14:10:00',2.19),('5815','2013-06-18','14:15:00',2.17),('5815','2013-06-18','14:20:00',2.12),('5815','2013-06-18','14:25:00',2.12),('5815','2013-06-18','14:30:00',2.1),('5815','2013-06-18','14:35:00',2.07),('5815','2013-06-18','14:40:00',2.06),('5815','2013-06-18','14:45:00',2.05),('5815','2013-06-18','14:50:00',2.04),('5815','2013-06-18','14:55:00',2.02),('5815','2013-06-18','15:00:00',2),('5815','2013-06-18','15:05:00',1.99),('5815','2013-06-18','15:10:00',1.96),('5815','2013-06-18','15:15:00',1.95),('5815','2013-06-18','15:20:00',1.94),('5815','2013-06-18','15:25:00',1.92),('5815','2013-06-18','15:30:00',1.9),('5815','2013-06-18','15:35:00',1.87),('5815','2013-06-18','15:40:00',1.86),('5815','2013-06-18','15:45:00',1.88),('5815','2013-06-18','15:50:00',1.82),('5815','2013-06-18','15:55:00',1.74),('5815','2013-06-18','16:00:00',1.66),('5815','2013-06-18','16:05:00',1.66),('5815','2013-06-18','16:10:00',1.67),('5815','2013-06-18','16:15:00',1.64),('5815','2013-06-18','16:20:00',1.61),('5815','2013-06-18','16:25:00',1.57),('5815','2013-06-18','16:30:00',1.55),('5815','2013-06-18','16:35:00',1.51),('5815','2013-06-18','16:40:00',1.47),('5815','2013-06-18','16:45:00',1.44),('5815','2013-06-18','16:50:00',1.41),('5815','2013-06-18','16:55:00',1.39),('5815','2013-06-18','17:00:00',1.36),('5815','2013-06-18','17:05:00',1.29),('5815','2013-06-18','17:10:00',1.27),('5815','2013-06-18','17:15:00',1.23),('5815','2013-06-18','17:20:00',1.21),('5815','2013-06-18','17:25:00',1.18),('5815','2013-06-18','17:30:00',1.1),('5815','2013-06-17','08:50:00',1.04),('5815','2013-06-17','08:55:00',1.08),('5815','2013-06-17','09:00:00',1.11),('5815','2013-06-17','09:05:00',1.16),('5815','2013-06-17','09:10:00',1.2),('5815','2013-06-17','09:15:00',1.24),('5815','2013-06-17','09:20:00',1.29),('5815','2013-06-17','09:25:00',1.33),('5815','2013-06-17','09:30:00',1.36),('5815','2013-06-17','09:35:00',1.39),('5815','2013-06-17','09:40:00',1.43),('5815','2013-06-17','09:45:00',1.45),('5815','2013-06-17','09:50:00',1.48),('5815','2013-06-17','09:55:00',1.51),('5815','2013-06-17','10:00:00',1.55),('5815','2013-06-17','10:05:00',1.56),('5815','2013-06-17','10:10:00',1.61),('5815','2013-06-17','10:15:00',1.65),('5815','2013-06-17','10:20:00',1.68),('5815','2013-06-17','10:25:00',1.7),('5815','2013-06-17','10:30:00',1.71),('5815','2013-06-17','10:35:00',1.72),('5815','2013-06-17','10:40:00',1.76),('5815','2013-06-17','10:45:00',1.8),('5815','2013-06-17','10:50:00',1.82),('5815','2013-06-17','10:55:00',1.85),('5815','2013-06-17','11:00:00',1.85),('5815','2013-06-17','11:05:00',1.85),('5815','2013-06-17','11:10:00',1.88),('5815','2013-06-17','11:15:00',1.89),('5815','2013-06-17','11:20:00',1.88),('5815','2013-06-17','11:25:00',1.93),('5815','2013-06-17','11:30:00',1.97),('5815','2013-06-17','11:35:00',1.98),('5815','2013-06-17','11:40:00',1.92),('5815','2013-06-17','11:45:00',1.89),('5815','2013-06-17','11:50:00',1.91),('5815','2013-06-17','11:55:00',1.97),('5815','2013-06-17','12:00:00',1.96),('5815','2013-06-17','12:05:00',1.97),('5815','2013-06-17','12:10:00',1.97),('5815','2013-06-17','12:15:00',1.97),('5815','2013-06-17','12:20:00',1.97),('5815','2013-06-17','12:25:00',2.02),('5815','2013-06-17','12:30:00',2.03),('5815','2013-06-17','12:35:00',2.01),('5815','2013-06-17','12:40:00',2),('5815','2013-06-17','12:45:00',1.57),('5815','2013-06-17','12:55:00',2.06),('5815','2013-06-17','13:00:00',2.16),('5815','2013-06-17','13:05:00',1.23),('5815','2013-06-17','13:10:00',1.5),('5815','2013-06-17','13:15:00',2.23),('5815','2013-06-17','13:20:00',2.27),('5815','2013-06-17','13:25:00',2.28),('5815','2013-06-17','13:30:00',1.45),('5815','2013-06-17','13:35:00',2.14),('5815','2013-06-17','13:40:00',2.18),('5815','2013-06-17','13:45:00',2.15),('5815','2013-06-17','13:50:00',2.18),('5815','2013-06-17','13:55:00',2.21),('5815','2013-06-17','14:00:00',2.2),('5815','2013-06-17','14:05:00',2.22),('5815','2013-06-17','14:10:00',2.21),('5815','2013-06-17','14:15:00',2.19),('5815','2013-06-17','14:20:00',2.13),('5815','2013-06-17','14:25:00',2.12),('5815','2013-06-17','14:30:00',2.11),('5815','2013-06-17','14:35:00',2.11),('5815','2013-06-17','14:40:00',2.14),('5815','2013-06-17','14:45:00',2.09),('5815','2013-06-17','14:50:00',2.09),('5815','2013-06-17','14:55:00',2.09),('5815','2013-06-17','15:00:00',2.11),('5815','2013-06-17','15:05:00',2.04),('5815','2013-06-17','15:10:00',2.02),('5815','2013-06-17','15:15:00',2),('5815','2013-06-17','15:20:00',1.96),('5815','2013-06-17','15:25:00',1.94),('5815','2013-06-17','15:30:00',1.91),('5815','2013-06-17','15:35:00',1.91),('5815','2013-06-17','15:40:00',1.89),('5815','2013-06-17','15:45:00',1.93),('5815','2013-06-17','15:50:00',1.88),('5815','2013-06-17','15:55:00',1.83),('5815','2013-06-17','16:00:00',1.76),('5815','2013-06-17','16:05:00',1.71),('5815','2013-06-17','16:10:00',1.76),('5815','2013-06-17','16:15:00',1.77),('5815','2013-06-17','16:20:00',1.74),('5815','2013-06-17','16:25:00',1.62),('5815','2013-06-17','16:30:00',1.54),('5815','2013-06-17','16:35:00',1.55),('5815','2013-06-17','16:40:00',1.53),('5815','2013-06-17','16:45:00',1.47),('5815','2013-06-17','16:50:00',1.43),('5815','2013-06-17','16:55:00',1.42),('5815','2013-06-17','17:00:00',1.38),('5815','2013-06-17','17:05:00',1.31),('5815','2013-06-17','17:10:00',1.28),('5815','2013-06-17','17:15:00',1.25),('5815','2013-06-17','17:20:00',1.22),('5815','2013-06-17','17:25:00',1.17),('5815','2013-06-17','17:30:00',1.08),('5815','2013-06-16','08:45:00',1.04),('5815','2013-06-16','08:50:00',1.08),('5815','2013-06-16','08:55:00',1.13),('5815','2013-06-16','09:00:00',1.18),('5815','2013-06-16','09:05:00',1.22),('5815','2013-06-16','09:10:00',1.26),('5815','2013-06-16','09:15:00',1.3),('5815','2013-06-16','09:20:00',1.34),('5815','2013-06-16','09:25:00',1.38),('5815','2013-06-16','09:30:00',1.42),('5815','2013-06-16','09:35:00',1.46),('5815','2013-06-16','09:40:00',1.49),('5815','2013-06-16','09:45:00',1.53),('5815','2013-06-16','09:50:00',1.57),('5815','2013-06-16','09:55:00',1.61),('5815','2013-06-16','10:00:00',1.63),('5815','2013-06-16','10:05:00',1.65),('5815','2013-06-16','10:10:00',1.69),('5815','2013-06-16','10:15:00',1.72),('5815','2013-06-16','10:20:00',1.75),('5815','2013-06-16','10:25:00',1.77),('5815','2013-06-16','10:30:00',1.8),('5815','2013-06-16','10:35:00',1.82),('5815','2013-06-16','10:40:00',1.85),('5815','2013-06-16','10:45:00',1.88),('5815','2013-06-16','10:50:00',1.9),('5815','2013-06-16','10:55:00',1.92),('5815','2013-06-16','11:00:00',1.9),('5815','2013-06-16','11:05:00',1.89),('5815','2013-06-16','11:10:00',1.91),('5815','2013-06-16','11:15:00',1.93),('5815','2013-06-16','11:20:00',1.96),('5815','2013-06-16','11:25:00',1.97),('5815','2013-06-16','11:30:00',2.01),('5815','2013-06-16','11:35:00',2.03),('5815','2013-06-16','11:40:00',1.99),('5815','2013-06-16','11:45:00',1.96),('5815','2013-06-16','11:50:00',1.94),('5815','2013-06-16','11:55:00',2.03),('5815','2013-06-16','12:00:00',2.02),('5815','2013-06-16','12:05:00',2.03),('5815','2013-06-16','12:10:00',2.05),('5815','2013-06-16','12:15:00',2.06),('5815','2013-06-16','12:20:00',2.08),('5815','2013-06-16','12:25:00',2.11),('5815','2013-06-16','12:30:00',2.09),('5815','2013-06-16','12:35:00',2.06),('5815','2013-06-16','12:40:00',2.09),('5815','2013-06-16','12:45:00',2.09),('5815','2013-06-16','12:50:00',2.13),('5815','2013-06-16','12:55:00',2.14),('5815','2013-06-16','13:00:00',2.18),('5815','2013-06-16','13:05:00',2.19),('5815','2013-06-16','13:10:00',2.21),('5815','2013-06-16','13:15:00',2.21),('5815','2013-06-16','13:20:00',2.19),('5815','2013-06-16','13:25:00',2.19),('5815','2013-06-16','13:30:00',2.18),('5815','2013-06-16','13:35:00',2.15),('5815','2013-06-16','13:40:00',2.16),('5815','2013-06-16','13:45:00',2.16),('5815','2013-06-16','13:50:00',2.15),('5815','2013-06-16','13:55:00',2.14),('5815','2013-06-16','14:00:00',2.15),('5815','2013-06-16','14:05:00',2.16),('5815','2013-06-16','14:10:00',2.15),('5815','2013-06-16','14:15:00',2.14),('5815','2013-06-16','14:20:00',2.12),('5815','2013-06-16','14:25:00',2.11),('5815','2013-06-16','14:30:00',2.12),('5815','2013-06-16','14:35:00',2.11),('5815','2013-06-16','14:40:00',2.1),('5815','2013-06-16','14:45:00',2.08),('5815','2013-06-16','14:50:00',2.07),('5815','2013-06-16','14:55:00',2.07),('5815','2013-06-16','15:00:00',2.06),('5815','2013-06-16','15:05:00',2.01),('5815','2013-06-16','15:10:00',2),('5815','2013-06-16','15:15:00',1.97),('5815','2013-06-16','15:20:00',1.96),('5815','2013-06-16','15:25:00',1.94),('5815','2013-06-16','15:30:00',1.93),('5815','2013-06-16','15:35:00',1.91),('5815','2013-06-16','15:40:00',1.87),('5815','2013-06-16','15:45:00',1.9),('5815','2013-06-16','15:50:00',1.85),('5815','2013-06-16','15:55:00',1.8),('5815','2013-06-16','16:00:00',1.77),('5815','2013-06-16','16:05:00',1.75),('5815','2013-06-16','16:10:00',1.72),('5815','2013-06-16','16:15:00',1.7),('5815','2013-06-16','16:20:00',1.66),('5815','2013-06-16','16:25:00',1.63),('5815','2013-06-16','16:30:00',1.59),('5815','2013-06-16','16:35:00',1.56),('5815','2013-06-16','16:40:00',1.52),('5815','2013-06-16','16:45:00',1.48),('5815','2013-06-16','16:50:00',1.45),('5815','2013-06-16','16:55:00',1.42),('5815','2013-06-16','17:00:00',1.39),('5815','2013-06-16','17:05:00',1.32),('5815','2013-06-16','17:10:00',1.29),('5815','2013-06-16','17:15:00',1.26),('5815','2013-06-16','17:20:00',1.22),('5815','2013-06-16','17:25:00',1.19),('5815','2013-06-16','17:30:00',1.12),('5815','2013-06-16','17:45:00',1.01),('5815','2013-06-15','08:40:00',1.01),('5815','2013-06-15','08:45:00',1.07),('5815','2013-06-15','08:50:00',1.09),('5815','2013-06-15','08:55:00',1.15),('5815','2013-06-15','09:00:00',1.2),('5815','2013-06-15','09:05:00',1.24),('5815','2013-06-15','09:10:00',1.28),('5815','2013-06-15','09:15:00',1.33),('5815','2013-06-15','09:20:00',1.37),('5815','2013-06-15','09:25:00',1.41),('5815','2013-06-15','09:30:00',1.45),('5815','2013-06-15','09:35:00',1.5),('5815','2013-06-15','09:40:00',1.53),('5815','2013-06-15','09:45:00',1.56),('5815','2013-06-15','09:50:00',1.6),('5815','2013-06-15','09:55:00',1.63),('5815','2013-06-15','10:00:00',1.65),('5815','2013-06-15','10:05:00',1.67),('5815','2013-06-15','10:10:00',1.7),('5815','2013-06-15','10:15:00',1.75),('5815','2013-06-15','10:20:00',1.77),('5815','2013-06-15','10:25:00',1.79),('5815','2013-06-15','10:30:00',1.83),('5815','2013-06-15','10:35:00',1.86),('5815','2013-06-15','10:40:00',1.89),('5815','2013-06-15','10:45:00',1.91),('5815','2013-06-15','10:50:00',1.93),('5815','2013-06-15','10:55:00',1.94),('5815','2013-06-15','11:00:00',1.93),('5815','2013-06-15','11:05:00',1.91),('5815','2013-06-15','11:10:00',1.95),('5815','2013-06-15','11:15:00',1.97),('5815','2013-06-15','11:20:00',1.98),('5815','2013-06-15','11:25:00',2.01),('5815','2013-06-15','11:30:00',2.04),('5815','2013-06-15','11:35:00',2.08),('5815','2013-06-15','11:40:00',2.06),('5815','2013-06-15','11:45:00',2.07),('5815','2013-06-15','11:50:00',2.09),('5815','2013-06-15','11:55:00',2.12),('5815','2013-06-15','12:00:00',2.14),('5815','2013-06-15','12:05:00',2.15),('5815','2013-06-15','12:10:00',2.17),('5815','2013-06-15','12:15:00',2.17),('5815','2013-06-15','12:20:00',2.19),('5815','2013-06-15','12:25:00',2.25),('5815','2013-06-15','12:30:00',2.21),('5815','2013-06-15','12:35:00',2.17),('5815','2013-06-15','12:40:00',2.2),('5815','2013-06-15','12:45:00',2.19),('5815','2013-06-15','12:50:00',2.19),('5815','2013-06-15','12:55:00',2.22),('5815','2013-06-15','13:00:00',2.23),('5815','2013-06-15','13:05:00',2.24),('5815','2013-06-15','13:10:00',2.27),('5815','2013-06-15','13:15:00',2.27),('5815','2013-06-15','13:20:00',2.28),('5815','2013-06-15','13:25:00',2.28),('5815','2013-06-15','13:30:00',2.26),('5815','2013-06-15','13:35:00',2.26),('5815','2013-06-15','13:40:00',2.27),('5815','2013-06-15','13:45:00',2.27),('5815','2013-06-15','13:50:00',2.26),('5815','2013-06-15','13:55:00',2.26),('5815','2013-06-15','14:00:00',2.27),('5815','2013-06-15','14:05:00',2.26),('5815','2013-06-15','14:10:00',2.28),('5815','2013-06-15','14:15:00',2.25),('5815','2013-06-15','14:20:00',2.2),('5815','2013-06-15','14:25:00',2.2),('5815','2013-06-15','14:30:00',2.19),('5815','2013-06-15','14:35:00',2.17),('5815','2013-06-15','14:40:00',2.16),('5815','2013-06-15','14:45:00',2.15),('5815','2013-06-15','14:50:00',2.13),('5815','2013-06-15','14:55:00',2.11),('5815','2013-06-15','15:00:00',2.1),('5815','2013-06-15','15:05:00',2.09),('5815','2013-06-15','15:10:00',2.06),('5815','2013-06-15','15:15:00',2.05),('5815','2013-06-15','15:20:00',2.03),('5815','2013-06-15','15:25:00',2.02),('5815','2013-06-15','15:30:00',1.99),('5815','2013-06-15','15:35:00',1.96),('5815','2013-06-15','15:40:00',1.96),('5815','2013-06-15','15:45:00',1.96),('5815','2013-06-15','15:50:00',1.91),('5815','2013-06-15','15:55:00',1.85),('5815','2013-06-15','16:00:00',1.83),('5815','2013-06-15','16:05:00',1.8),('5815','2013-06-15','16:10:00',1.78),('5815','2013-06-15','16:15:00',1.75),('5815','2013-06-15','16:20:00',1.71),('5815','2013-06-15','16:25:00',1.68),('5815','2013-06-15','16:30:00',1.65),('5815','2013-06-15','16:35:00',1.61),('5815','2013-06-15','16:40:00',1.56),('5815','2013-06-15','16:45:00',1.52),('5815','2013-06-15','16:50:00',1.47),('5815','2013-06-15','16:55:00',1.46),('5815','2013-06-15','17:00:00',1.41),('5815','2013-06-15','17:05:00',1.33),('5815','2013-06-15','17:10:00',1.3),('5815','2013-06-15','17:15:00',1.27),('5815','2013-06-15','17:20:00',1.23),('5815','2013-06-15','17:25:00',1.19),('5815','2013-06-15','17:30:00',1.1),('5815','2013-06-15','17:40:00',1.01),('5815','2013-06-14','08:40:00',1.01),('5815','2013-06-14','08:45:00',1.07),('5815','2013-06-14','08:50:00',1.11),('5815','2013-06-14','08:55:00',1.09),('5815','2013-06-14','09:00:00',1.14),('5815','2013-06-14','09:05:00',1.23),('5815','2013-06-14','09:10:00',1.27),('5815','2013-06-14','09:15:00',1.32),('5815','2013-06-14','09:20:00',1.37),('5815','2013-06-14','09:25:00',1.37),('5815','2013-06-14','09:30:00',1.43),('5815','2013-06-14','09:35:00',1.39),('5815','2013-06-14','09:40:00',1.49),('5815','2013-06-14','09:45:00',1.43),('5815','2013-06-14','09:50:00',1.58),('5815','2013-06-14','09:55:00',1.62),('5815','2013-06-14','10:00:00',1.27),('5815','2013-06-14','10:10:00',1.07),('5815','2013-06-14','10:15:00',1.33),('5815','2013-06-14','10:20:00',1.68),('5815','2013-06-14','10:25:00',1.62),('5815','2013-06-14','10:30:00',1.8),('5815','2013-06-14','10:35:00',1.93),('5815','2013-06-14','10:40:00',1.93),('5815','2013-06-14','10:45:00',1.88),('5815','2013-06-14','10:50:00',1.99),('5815','2013-06-14','10:55:00',2.02),('5815','2013-06-14','11:00:00',1.26),('5815','2013-06-14','11:05:00',1.05),('5815','2013-06-14','11:10:00',1.8),('5815','2013-06-14','11:15:00',1.93),('5815','2013-06-14','11:20:00',1.97),('5815','2013-06-14','11:25:00',2),('5815','2013-06-14','11:30:00',1.56),('5815','2013-06-14','11:35:00',1.68),('5815','2013-06-14','11:40:00',1.41),('5815','2013-06-14','11:45:00',1),('5815','2013-06-14','11:50:00',1.13),('5815','2013-06-14','11:55:00',2.28),('5815','2013-06-14','12:00:00',2.22),('5815','2013-06-14','12:05:00',1.98),('5815','2013-06-14','12:10:00',2.24),('5815','2013-06-14','12:15:00',2.28),('5815','2013-06-14','12:20:00',2.29),('5815','2013-06-14','12:25:00',2.29),('5815','2013-06-14','12:30:00',2.29),('5815','2013-06-14','12:35:00',2.27),('5815','2013-06-14','12:40:00',2.29),('5815','2013-06-14','12:45:00',2.28),('5815','2013-06-14','12:50:00',2.28),('5815','2013-06-14','12:55:00',2.28),('5815','2013-06-14','13:00:00',2.3),('5815','2013-06-14','13:05:00',2.28),('5815','2013-06-14','13:10:00',2.26),('5815','2013-06-14','13:15:00',2.29),('5815','2013-06-14','13:20:00',2.27),('5815','2013-06-14','13:25:00',2.27),('5815','2013-06-14','13:30:00',2.28),('5815','2013-06-14','13:35:00',2.26),('5815','2013-06-14','13:40:00',2.27),('5815','2013-06-14','13:45:00',2.28),('5815','2013-06-14','13:50:00',2.29),('5815','2013-06-14','13:55:00',2.25),('5815','2013-06-14','14:00:00',2.24),('5815','2013-06-14','14:05:00',2.23),('5815','2013-06-14','14:10:00',2.25),('5815','2013-06-14','14:15:00',2.24),('5815','2013-06-14','14:20:00',2.2),('5815','2013-06-14','14:25:00',2.19),('5815','2013-06-14','14:30:00',2.19),('5815','2013-06-14','14:35:00',2.17),('5815','2013-06-14','14:40:00',2.15),('5815','2013-06-14','14:45:00',2.17),('5815','2013-06-14','14:50:00',2.12),('5815','2013-06-14','14:55:00',2.15),('5815','2013-06-14','15:00:00',2.14),('5815','2013-06-14','15:05:00',2.07),('5815','2013-06-14','15:10:00',2.07),('5815','2013-06-14','15:15:00',2.06),('5815','2013-06-14','15:20:00',2.04),('5815','2013-06-14','15:25:00',2.02),('5815','2013-06-14','15:30:00',2.01),('5815','2013-06-14','15:35:00',1.98),('5815','2013-06-14','15:40:00',1.97),('5815','2013-06-14','15:45:00',1.97),('5815','2013-06-14','15:50:00',1.91),('5815','2013-06-14','15:55:00',1.85),('5815','2013-06-14','16:00:00',1.84),('5815','2013-06-14','16:05:00',1.8),('5815','2013-06-14','16:10:00',1.77),('5815','2013-06-14','16:15:00',1.74),('5815','2013-06-14','16:20:00',1.7),('5815','2013-06-14','16:25:00',1.67),('5815','2013-06-14','16:30:00',1.63),('5815','2013-06-14','16:35:00',1.6),('5815','2013-06-14','16:40:00',1.55),('5815','2013-06-14','16:45:00',1.52),('5815','2013-06-14','16:50:00',1.47),('5815','2013-06-14','16:55:00',1.45),('5815','2013-06-14','17:00:00',1.41),('5815','2013-06-14','17:05:00',1.33),('5815','2013-06-14','17:10:00',1.3),('5815','2013-06-14','17:15:00',1.26),('5815','2013-06-14','17:20:00',1.22),('5815','2013-06-14','17:25:00',1.17),('5815','2013-06-14','17:30:00',1.09),('5815','2013-06-13','08:35:00',1.01),('5815','2013-06-13','08:40:00',1.06),('5815','2013-06-13','08:45:00',1.12),('5815','2013-06-13','08:50:00',1.16),('5815','2013-06-13','08:55:00',1.21),('5815','2013-06-13','09:00:00',1.25),('5815','2013-06-13','09:05:00',1.3),('5815','2013-06-13','09:10:00',1.34),('5815','2013-06-13','09:15:00',1.38),('5815','2013-06-13','09:20:00',1.42),('5815','2013-06-13','09:25:00',1.46),('5815','2013-06-13','09:30:00',1.49),('5815','2013-06-13','09:35:00',1.54),('5815','2013-06-13','09:40:00',1.59),('5815','2013-06-13','09:45:00',1.63),('5815','2013-06-13','09:50:00',1.68),('5815','2013-06-13','09:55:00',1.72),('5815','2013-06-13','10:00:00',1.75),('5815','2013-06-13','10:05:00',1.76),('5815','2013-06-13','10:10:00',1.77),('5815','2013-06-13','10:15:00',1.81),('5815','2013-06-13','10:20:00',1.85),('5815','2013-06-13','10:25:00',1.85),('5815','2013-06-13','10:30:00',1.91),('5815','2013-06-13','10:35:00',1.96),('5815','2013-06-13','10:40:00',1.97),('5815','2013-06-13','10:45:00',2.01),('5815','2013-06-13','10:50:00',2.01),('5815','2013-06-13','10:55:00',1.99),('5815','2013-06-13','11:00:00',1.94),('5815','2013-06-13','11:05:00',1.94),('5815','2013-06-13','11:10:00',2.03),('5815','2013-06-13','11:15:00',2.07),('5815','2013-06-13','11:20:00',2.04),('5815','2013-06-13','11:25:00',2.02),('5815','2013-06-13','11:30:00',2.12),('5815','2013-06-13','11:35:00',2.16),('5815','2013-06-13','11:40:00',2.1),('5815','2013-06-13','11:45:00',2.04),('5815','2013-06-13','11:50:00',2.08),('5815','2013-06-13','11:55:00',2.16),('5815','2013-06-13','12:00:00',2.17),('5815','2013-06-13','12:05:00',2.17),('5815','2013-06-13','12:10:00',2.21),('5815','2013-06-13','12:15:00',2.21),('5815','2013-06-13','12:20:00',2.2),('5815','2013-06-13','12:25:00',2.25),('5815','2013-06-13','12:30:00',2.21),('5815','2013-06-13','12:35:00',2.17),('5815','2013-06-13','12:40:00',2.22),('5815','2013-06-13','12:45:00',2.22),('5815','2013-06-13','12:50:00',2.19),('5815','2013-06-13','12:55:00',2.21),('5815','2013-06-13','13:00:00',2.24),('5815','2013-06-13','13:05:00',2.25),('5815','2013-06-13','13:10:00',1.62),('5815','2013-06-13','13:15:00',1.08),('5815','2013-06-13','13:20:00',1.38),('5815','2013-06-13','13:30:00',1.9),('5815','2013-06-13','13:35:00',1.99),('5815','2013-06-13','13:40:00',2.29),('5815','2013-06-13','13:45:00',2.24),('5815','2013-06-13','13:50:00',2.26),('5815','2013-06-13','13:55:00',2.28),('5815','2013-06-13','14:00:00',2.26),('5815','2013-06-13','14:05:00',2.29),('5815','2013-06-13','14:10:00',2.32),('5815','2013-06-13','14:15:00',2.27),('5815','2013-06-13','14:20:00',2.21),('5815','2013-06-13','14:25:00',2.21),('5815','2013-06-13','14:30:00',2.21),('5815','2013-06-13','14:35:00',2.23),('5815','2013-06-13','14:40:00',2.21),('5815','2013-06-13','14:45:00',2.17),('5815','2013-06-13','14:50:00',2.15),('5815','2013-06-13','14:55:00',2.15),('5815','2013-06-13','15:00:00',2.14),('5815','2013-06-13','15:05:00',2.12),('5815','2013-06-13','15:10:00',2.12),('5815','2013-06-13','15:15:00',2.09),('5815','2013-06-13','15:20:00',2.07),('5815','2013-06-13','15:25:00',2.04),('5815','2013-06-13','15:30:00',2.01),('5815','2013-06-13','15:35:00',1.99),('5815','2013-06-13','15:40:00',2),('5815','2013-06-13','15:45:00',2),('5815','2013-06-13','15:50:00',1.94),('5815','2013-06-13','15:55:00',1.89),('5815','2013-06-13','16:00:00',1.86),('5815','2013-06-13','16:05:00',1.83),('5815','2013-06-13','16:10:00',1.8),('5815','2013-06-13','16:15:00',1.77),('5815','2013-06-13','16:20:00',1.75),('5815','2013-06-13','16:25:00',1.7),('5815','2013-06-13','16:30:00',1.65),('5815','2013-06-13','16:35:00',1.62),('5815','2013-06-13','16:40:00',1.57),('5815','2013-06-13','16:45:00',1.54),('5815','2013-06-13','16:50:00',1.49),('5815','2013-06-13','16:55:00',1.46),('5815','2013-06-13','17:00:00',1.43),('5815','2013-06-13','17:05:00',1.32),('5815','2013-06-13','17:10:00',1.33),('5815','2013-06-13','17:15:00',1.31),('5815','2013-06-13','17:20:00',1.26),('5815','2013-06-13','17:25:00',1.2),('5815','2013-06-13','17:30:00',1.09),('5815','2013-06-13','17:40:00',1.03),('5815','2013-06-13','17:45:00',1),('5815','2013-06-12','08:35:00',1.02),('5815','2013-06-12','08:40:00',1.08),('5815','2013-06-12','08:45:00',1.12),('5815','2013-06-12','08:50:00',1.17),('5815','2013-06-12','08:55:00',1.22),('5815','2013-06-12','09:00:00',1.27),('5815','2013-06-12','09:05:00',1.32),('5815','2013-06-12','09:10:00',1.36),('5815','2013-06-12','09:15:00',1.41),('5815','2013-06-12','09:20:00',1.45),('5815','2013-06-12','09:25:00',1.5),('5815','2013-06-12','09:30:00',1.54),('5815','2013-06-12','09:35:00',1.57),('5815','2013-06-12','09:40:00',1.62),('5815','2013-06-12','09:45:00',1.65),('5815','2013-06-12','09:50:00',1.69),('5815','2013-06-12','09:55:00',1.73),('5815','2013-06-12','10:00:00',1.77),('5815','2013-06-12','10:05:00',1.8),('5815','2013-06-12','10:10:00',1.83),('5815','2013-06-12','10:15:00',1.86),('5815','2013-06-12','10:20:00',1.89),('5815','2013-06-12','10:25:00',1.92),('5815','2013-06-12','10:30:00',1.95),('5815','2013-06-12','10:35:00',1.97),('5815','2013-06-12','10:40:00',2),('5815','2013-06-12','10:45:00',2.05),('5815','2013-06-12','10:50:00',2.06),('5815','2013-06-12','10:55:00',2.07),('5815','2013-06-12','11:00:00',2.04),('5815','2013-06-12','11:05:00',2.03),('5815','2013-06-12','11:10:00',2.08),('5815','2013-06-12','11:15:00',2.1),('5815','2013-06-12','11:20:00',2.13),('5815','2013-06-12','11:25:00',2.15),('5815','2013-06-12','11:30:00',2.16),('5815','2013-06-12','11:35:00',2.18),('5815','2013-06-12','11:40:00',2.15),('5815','2013-06-12','11:45:00',2.11),('5815','2013-06-12','11:50:00',2.1),('5815','2013-06-12','11:55:00',2.23),('5815','2013-06-12','12:00:00',2.24),('5815','2013-06-12','12:05:00',2.27),('5815','2013-06-12','12:10:00',2.28),('5815','2013-06-12','12:15:00',2.28),('5815','2013-06-12','12:20:00',2.29),('5815','2013-06-12','12:25:00',2.33),('5815','2013-06-12','12:30:00',2.29),('5815','2013-06-12','12:35:00',2.25),('5815','2013-06-12','12:40:00',2.31),('5815','2013-06-12','12:45:00',2.32),('5815','2013-06-12','12:50:00',2.31),('5815','2013-06-12','12:55:00',2.31),('5815','2013-06-12','13:00:00',2.32),('5815','2013-06-12','13:05:00',2.32),('5815','2013-06-12','13:10:00',2.32),('5815','2013-06-12','13:15:00',2.33),('5815','2013-06-12','13:20:00',2.32),('5815','2013-06-12','13:25:00',2.32),('5815','2013-06-12','13:30:00',2.29),('5815','2013-06-12','13:35:00',2.29),('5815','2013-06-12','13:40:00',2.32),('5815','2013-06-12','13:45:00',2.31),('5815','2013-06-12','13:50:00',2.29),('5815','2013-06-12','13:55:00',2.27),('5815','2013-06-12','14:00:00',2.28),('5815','2013-06-12','14:05:00',2.27),('5815','2013-06-12','14:10:00',2.3),('5815','2013-06-12','14:15:00',2.27),('5815','2013-06-12','14:20:00',2.22),('5815','2013-06-12','14:25:00',2.28),('5815','2013-06-12','14:30:00',1.21),('5815','2013-06-12','14:35:00',2.27),('5815','2013-06-12','14:40:00',2.27),('5815','2013-06-12','14:45:00',2.21),('5815','2013-06-12','14:50:00',2.14),('5815','2013-06-12','14:55:00',2.15),('5815','2013-06-12','15:00:00',2.14),('5815','2013-06-12','15:05:00',2.1),('5815','2013-06-12','15:10:00',2.06),('5815','2013-06-12','15:15:00',2.04),('5815','2013-06-12','15:20:00',2.03),('5815','2013-06-12','15:25:00',2.01),('5815','2013-06-12','15:30:00',1.98),('5815','2013-06-12','15:35:00',1.97),('5815','2013-06-12','15:40:00',1.99),('5815','2013-06-12','15:45:00',1.97),('5815','2013-06-12','15:50:00',1.92),('5815','2013-06-12','15:55:00',1.87),('5815','2013-06-12','16:00:00',1.84),('5815','2013-06-12','16:05:00',1.81),('5815','2013-06-12','16:10:00',1.78),('5815','2013-06-12','16:15:00',1.75),('5815','2013-06-12','16:20:00',1.72),('5815','2013-06-12','16:25:00',1.68),('5815','2013-06-12','16:30:00',1.65),('5815','2013-06-12','16:35:00',1.6),('5815','2013-06-12','16:40:00',1.54),('5815','2013-06-12','16:45:00',1.52),('5815','2013-06-12','16:50:00',1.48),('5815','2013-06-12','16:55:00',1.46),('5815','2013-06-12','17:00:00',1.39),('5815','2013-06-12','17:05:00',1.33),('5815','2013-06-12','17:10:00',1.31),('5815','2013-06-12','17:15:00',1.29),('5815','2013-06-12','17:20:00',1.24),('5815','2013-06-12','17:25:00',1.2),('5815','2013-06-12','17:30:00',1.1),('5815','2013-06-12','17:40:00',1),('5815','2013-06-12','17:45:00',1.01),('5815','2013-06-11','08:35:00',1.05),('5815','2013-06-11','08:40:00',1.1),('5815','2013-06-11','08:45:00',1.15),('5815','2013-06-11','08:50:00',1.2),('5815','2013-06-11','08:55:00',1.24),('5815','2013-06-11','09:00:00',1.29),('5815','2013-06-11','09:05:00',1.34),('5815','2013-06-11','09:10:00',1.39),('5815','2013-06-11','09:15:00',1.43),('5815','2013-06-11','09:20:00',1.48),('5815','2013-06-11','09:25:00',1.51),('5815','2013-06-11','09:30:00',1.56),('5815','2013-06-11','09:35:00',1.6),('5815','2013-06-11','09:40:00',1.63),('5815','2013-06-11','09:45:00',1.67),('5815','2013-06-11','09:50:00',1.71),('5815','2013-06-11','09:55:00',1.75),('5815','2013-06-11','10:00:00',1.77),('5815','2013-06-11','10:05:00',1.81),('5815','2013-06-11','10:10:00',1.84),('5815','2013-06-11','10:15:00',1.88),('5815','2013-06-11','10:20:00',1.91),('5815','2013-06-11','10:25:00',1.93),('5815','2013-06-11','10:30:00',1.95),('5815','2013-06-11','10:35:00',1.97),('5815','2013-06-11','10:40:00',2),('5815','2013-06-11','10:45:00',2.05),('5815','2013-06-11','10:50:00',2.09),('5815','2013-06-11','10:55:00',2.09),('5815','2013-06-11','11:00:00',2.08),('5815','2013-06-11','11:05:00',2.06),('5815','2013-06-11','11:10:00',2.11),('5815','2013-06-11','11:15:00',2.14),('5815','2013-06-11','11:20:00',2.15),('5815','2013-06-11','11:25:00',2.17),('5815','2013-06-11','11:30:00',2.2),('5815','2013-06-11','11:35:00',2.2),('5815','2013-06-11','11:40:00',2.23),('5815','2013-06-11','11:45:00',2.21),('5815','2013-06-11','11:50:00',2.25),('5815','2013-06-11','11:55:00',2.27),('5815','2013-06-11','12:00:00',2.29),('5815','2013-06-11','12:05:00',2.3),('5815','2013-06-11','12:10:00',2.29),('5815','2013-06-11','12:15:00',2.32),('5815','2013-06-11','12:20:00',2.33),('5815','2013-06-11','12:25:00',2.34),('5815','2013-06-11','12:30:00',2.39),('5815','2013-06-11','12:35:00',2.16),('5815','2013-06-11','12:40:00',1.32),('5815','2013-06-11','12:45:00',1.67),('5815','2013-06-11','12:50:00',2.57),('5815','2013-06-11','12:55:00',2.02),('5815','2013-06-11','13:00:00',2.15),('5815','2013-06-11','13:05:00',2.39),('5815','2013-06-11','13:10:00',2.36),('5815','2013-06-11','13:15:00',2.33),('5815','2013-06-11','13:20:00',2.32),('5815','2013-06-11','13:25:00',2.34),('5815','2013-06-11','13:30:00',2.33),('5815','2013-06-11','13:35:00',2.32),('5815','2013-06-11','13:40:00',2.3),('5815','2013-06-11','13:45:00',2.35),('5815','2013-06-11','13:50:00',2.34),('5815','2013-06-11','13:55:00',2.38),('5815','2013-06-11','14:00:00',2.42),('5815','2013-06-11','14:05:00',1.49),('5815','2013-06-11','14:10:00',2.15),('5815','2013-06-11','14:15:00',2.17),('5815','2013-06-11','14:20:00',1.33),('5815','2013-06-11','14:25:00',1.03),('5815','2013-06-11','14:30:00',2.48),('5815','2013-06-11','14:35:00',2.41),('5815','2013-06-11','14:40:00',2.24),('5815','2013-06-11','14:45:00',2.06),('5815','2013-06-11','14:50:00',2.34),('5815','2013-06-11','14:55:00',2.41),('5815','2013-06-11','15:00:00',2.4),('5815','2013-06-11','15:05:00',2.17),('5815','2013-06-11','15:10:00',2.16),('5815','2013-06-11','15:15:00',1.5),('5815','2013-06-11','15:20:00',2.21),('5815','2013-06-11','15:25:00',2.1),('5815','2013-06-11','15:30:00',2.09),('5815','2013-06-11','15:35:00',2.09),('5815','2013-06-11','15:40:00',2.08),('5815','2013-06-11','15:45:00',2.07),('5815','2013-06-11','15:50:00',1.99),('5815','2013-06-11','15:55:00',1.98),('5815','2013-06-11','16:00:00',1.75),('5815','2013-06-11','16:05:00',1.87),('5815','2013-06-11','16:10:00',1.89),('5815','2013-06-11','16:15:00',1.86),('5815','2013-06-11','16:20:00',1.78),('5815','2013-06-11','16:25:00',1.68),('5815','2013-06-11','16:30:00',1.72),('5815','2013-06-11','16:35:00',1.66),('5815','2013-06-11','16:40:00',1.66),('5815','2013-06-11','16:45:00',1.41),('5815','2013-06-11','16:50:00',1.58),('5815','2013-06-11','16:55:00',1.49),('5815','2013-06-11','17:00:00',1.44),('5815','2013-06-11','17:05:00',1.42),('5815','2013-06-11','17:10:00',1.39),('5815','2013-06-11','17:15:00',1.33),('5815','2013-06-11','17:20:00',1.28),('5815','2013-06-11','17:25:00',1.23),('5815','2013-06-11','17:30:00',1.13),('5815','2013-06-11','17:40:00',1.03),('5815','2013-06-10','08:20:00',1.02),('5815','2013-06-10','08:25:00',1.03),('5815','2013-06-10','08:30:00',1.07),('5815','2013-06-10','08:35:00',1.1),('5815','2013-06-10','08:40:00',1.2),('5815','2013-06-10','08:45:00',1.21),('5815','2013-06-10','08:50:00',1.27),('5815','2013-06-10','08:55:00',1.35),('5815','2013-06-10','09:00:00',1.39),('5815','2013-06-10','09:05:00',1.43),('5815','2013-06-10','09:10:00',1.45),('5815','2013-06-10','09:15:00',1.52),('5815','2013-06-10','09:20:00',1.55),('5815','2013-06-10','09:25:00',1.68),('5815','2013-06-10','09:30:00',1.73),('5815','2013-06-10','09:35:00',1.7),('5815','2013-06-10','09:50:00',1.45),('5815','2013-06-10','09:55:00',1.7),('5815','2013-06-10','10:00:00',1.2),('5815','2013-06-10','10:05:00',1.58),('5815','2013-06-10','10:15:00',1.98),('5815','2013-06-10','10:20:00',2.02),('5815','2013-06-10','10:25:00',1.85),('5815','2013-06-10','10:30:00',2.08),('5815','2013-06-10','10:35:00',2.05),('5815','2013-06-10','10:40:00',1.57),('5815','2013-06-10','10:45:00',1.97),('5815','2013-06-10','10:50:00',2.19),('5815','2013-06-10','10:55:00',2.23),('5815','2013-06-10','11:00:00',2.21),('5815','2013-06-10','11:05:00',2.19),('5815','2013-06-10','11:10:00',1.76),('5815','2013-06-10','11:15:00',1.9),('5815','2013-06-10','11:20:00',2.3),('5815','2013-06-10','11:25:00',1.5),('5815','2013-06-10','11:30:00',1.99),('5815','2013-06-10','11:35:00',2.31),('5815','2013-06-10','11:40:00',2.29),('5815','2013-06-10','11:45:00',2.29),('5815','2013-06-10','11:50:00',2.32),('5815','2013-06-10','11:55:00',2.33),('5815','2013-06-10','12:00:00',2.06),('5815','2013-06-10','12:05:00',1.47),('5815','2013-06-10','12:10:00',2.42),('5815','2013-06-10','12:15:00',2.39),('5815','2013-06-10','12:20:00',2.37),('5815','2013-06-10','12:25:00',2.4),('5815','2013-06-10','12:30:00',2.44),('5815','2013-06-10','12:35:00',2.45),('5815','2013-06-10','12:40:00',2.45),('5815','2013-06-10','12:45:00',2.44),('5815','2013-06-10','12:50:00',2.44),('5815','2013-06-10','12:55:00',2.47),('5815','2013-06-10','13:00:00',2.48),('5815','2013-06-10','13:05:00',2.49),('5815','2013-06-10','13:10:00',2.49),('5815','2013-06-10','13:15:00',2.5),('5815','2013-06-10','13:20:00',2.48),('5815','2013-06-10','13:25:00',2.47),('5815','2013-06-10','13:30:00',2.45),('5815','2013-06-10','13:35:00',2.45),('5815','2013-06-10','13:40:00',2.49),('5815','2013-06-10','13:45:00',2.5),('5815','2013-06-10','13:50:00',2.38),('5815','2013-06-10','13:55:00',2.51),('5815','2013-06-10','14:00:00',2.48),('5815','2013-06-10','14:05:00',2.45),('5815','2013-06-10','14:10:00',2.45),('5815','2013-06-10','14:15:00',2.39),('5815','2013-06-10','14:20:00',2.35),('5815','2013-06-10','14:25:00',2.35),('5815','2013-06-10','14:30:00',2.35),('5815','2013-06-10','14:35:00',2.35),('5815','2013-06-10','14:40:00',2.32),('5815','2013-06-10','14:45:00',2.32),('5815','2013-06-10','14:50:00',2.3),('5815','2013-06-10','14:55:00',2.27),('5815','2013-06-10','15:00:00',2.26),('5815','2013-06-10','15:05:00',2.2),('5815','2013-06-10','15:10:00',2.18),('5815','2013-06-10','15:15:00',2.19),('5815','2013-06-10','15:20:00',2.16),('5815','2013-06-10','15:25:00',2.11),('5815','2013-06-10','15:30:00',2.09),('5815','2013-06-10','15:35:00',2.07),('5815','2013-06-10','15:40:00',2.02),('5815','2013-06-10','15:45:00',1.55),('5815','2013-06-10','15:50:00',1.97),('5815','2013-06-10','15:55:00',1.79),('5815','2013-06-10','16:00:00',1.97),('5815','2013-06-10','16:05:00',1.95),('5815','2013-06-10','16:10:00',1.9),('5815','2013-06-10','16:15:00',1.87),('5815','2013-06-10','16:20:00',1.82),('5815','2013-06-10','16:25:00',1.78),('5815','2013-06-10','16:30:00',1.75),('5815','2013-06-10','16:35:00',1.72),('5815','2013-06-10','16:40:00',1.73),('5815','2013-06-10','16:45:00',1.79),('5815','2013-06-10','16:50:00',1.78),('5815','2013-06-10','16:55:00',1.75),('5815','2013-06-10','17:00:00',1.64),('5815','2013-06-10','17:05:00',1.33),('5815','2013-06-09','08:20:00',1.01),('5815','2013-06-09','09:20:00',1.32),('5815','2013-06-09','09:30:00',1.12),('5815','2013-06-09','09:35:00',1.74),('5815','2013-06-09','09:40:00',1.32),('5815','2013-06-09','09:45:00',2.01),('5815','2013-06-09','09:50:00',1.16),('5815','2013-06-09','09:55:00',1.07),('5815','2013-06-09','10:00:00',1.2),('5815','2013-06-09','10:05:00',1.32),('5815','2013-06-09','10:10:00',1.73),('5815','2013-06-09','10:15:00',1.6),('5815','2013-06-09','10:20:00',1.13),('5815','2013-06-09','10:50:00',1.05),('5815','2013-06-09','10:55:00',1.33),('5815','2013-06-09','11:00:00',1.88),('5815','2013-06-09','11:05:00',1.67),('5815','2013-06-09','11:10:00',1.6),('5815','2013-06-09','11:15:00',2.32),('5815','2013-06-09','11:20:00',2.37),('5815','2013-06-09','11:25:00',2.27),('5815','2013-06-09','11:30:00',2.44),('5815','2013-06-09','11:35:00',2.51),('5815','2013-06-09','11:40:00',1.62),('5815','2013-06-09','11:45:00',1.77),('5815','2013-06-09','11:50:00',1.42),('5815','2013-06-09','11:55:00',1.75),('5815','2013-06-09','12:00:00',2.58),('5815','2013-06-09','12:05:00',1.19),('5815','2013-06-09','12:10:00',1.57),('5815','2013-06-09','12:15:00',1.6),('5815','2013-06-09','12:20:00',1.98),('5815','2013-06-09','12:25:00',2.58),('5815','2013-06-09','12:30:00',2.55),('5815','2013-06-09','12:35:00',2.63),('5815','2013-06-09','12:40:00',2.26),('5815','2013-06-09','12:45:00',2.71),('5815','2013-06-09','12:50:00',1.14),('5815','2013-06-09','12:55:00',2.47),('5815','2013-06-09','13:00:00',2.81),('5815','2013-06-09','13:05:00',2.49),('5815','2013-06-09','13:10:00',2.29),('5815','2013-06-09','13:15:00',1.62),('5815','2013-06-09','13:20:00',1.28),('5815','2013-06-09','13:25:00',1.34),('5815','2013-06-09','13:30:00',1.04),('5815','2013-06-09','13:35:00',2.08),('5815','2013-06-09','13:40:00',2.14),('5815','2013-06-09','13:45:00',2.59),('5815','2013-06-09','13:50:00',2.77),('5815','2013-06-09','13:55:00',2.22),('5815','2013-06-09','14:00:00',2.6),('5815','2013-06-09','14:05:00',2.58),('5815','2013-06-09','14:10:00',2.57),('5815','2013-06-09','14:15:00',2.45),('5815','2013-06-09','14:20:00',2.17),('5815','2013-06-09','14:25:00',2.37),('5815','2013-06-09','14:30:00',2.39),('5815','2013-06-09','14:35:00',2.37),('5815','2013-06-09','14:40:00',2.34),('5815','2013-06-09','14:45:00',2.35),('5815','2013-06-09','14:50:00',2.32),('5815','2013-06-09','14:55:00',2.3),('5815','2013-06-09','15:00:00',2.28),('5815','2013-06-09','15:05:00',2.23),('5815','2013-06-09','15:10:00',2.23),('5815','2013-06-09','15:15:00',2.22),('5815','2013-06-09','15:20:00',2.21),('5815','2013-06-09','15:25:00',2.18),('5815','2013-06-09','15:30:00',2.16),('5815','2013-06-09','15:35:00',2.14),('5815','2013-06-09','15:40:00',2.13),('5815','2013-06-09','15:45:00',2.14),('5815','2013-06-09','15:50:00',2.06),('5815','2013-06-09','15:55:00',2.02),('5815','2013-06-09','16:00:00',2),('5815','2013-06-09','16:05:00',1.96),('5815','2013-06-09','16:10:00',1.92),('5815','2013-06-09','16:15:00',1.89),('5815','2013-06-09','16:20:00',1.85),('5815','2013-06-09','16:25:00',1.81),('5815','2013-06-09','16:30:00',1.78),('5815','2013-06-09','16:35:00',1.73),('5815','2013-06-09','16:40:00',1.68),('5815','2013-06-09','16:45:00',1.63),('5815','2013-06-09','16:50:00',1.6),('5815','2013-06-09','16:55:00',1.56),('5815','2013-06-09','17:00:00',1.51),('5815','2013-06-09','17:05:00',1.47),('5815','2013-06-09','17:10:00',1.41),('5815','2013-06-09','17:15:00',1.38),('5815','2013-06-09','17:20:00',1.34),('5815','2013-06-09','17:25:00',1.29),('5815','2013-06-09','17:30:00',1.15),('5815','2013-06-09','17:35:00',1),('5815','2013-06-09','17:40:00',1.1),('5815','2013-06-09','17:45:00',1.08),('5815','2013-06-09','17:50:00',1.03),('5815','2013-06-08','08:40:00',1.04),('5815','2013-06-08','08:45:00',1.1),('5815','2013-06-08','08:50:00',1.14),('5815','2013-06-08','08:55:00',1.17),('5815','2013-06-08','09:00:00',1.23),('5815','2013-06-08','09:05:00',1.28),('5815','2013-06-08','09:10:00',1.33),('5815','2013-06-08','09:15:00',1.37),('5815','2013-06-08','09:20:00',1.33),('5815','2013-06-08','09:25:00',1.42),('5815','2013-06-08','09:30:00',1.47),('5815','2013-06-08','09:35:00',1.53),('5815','2013-06-08','09:40:00',1.57),('5815','2013-06-08','09:45:00',1.61),('5815','2013-06-08','09:50:00',1.65),('5815','2013-06-08','09:55:00',1.67),('5815','2013-06-08','10:00:00',1.71),('5815','2013-06-08','10:05:00',1.75),('5815','2013-06-08','10:10:00',1.78),('5815','2013-06-08','10:15:00',1.82),('5815','2013-06-08','10:20:00',1.86),('5815','2013-06-08','10:25:00',1.88),('5815','2013-06-08','10:30:00',1.88),('5815','2013-06-08','10:35:00',1.95),('5815','2013-06-08','10:40:00',1.98),('5815','2013-06-08','10:45:00',1.97),('5815','2013-06-08','10:50:00',2.01),('5815','2013-06-08','10:55:00',2.01),('5815','2013-06-08','11:00:00',1.97),('5815','2013-06-08','11:05:00',1.98),('5815','2013-06-08','11:10:00',2.01),('5815','2013-06-08','11:15:00',2.01),('5815','2013-06-08','11:20:00',2.05),('5815','2013-06-08','11:25:00',2.11),('5815','2013-06-08','11:30:00',2.12),('5815','2013-06-08','11:35:00',2.13),('5815','2013-06-08','11:40:00',2.11),('5815','2013-06-08','11:45:00',2.15),('5815','2013-06-08','11:50:00',2.17),('5815','2013-06-08','11:55:00',2.19),('5815','2013-06-08','12:00:00',2.2),('5815','2013-06-08','12:05:00',2.2),('5815','2013-06-08','12:10:00',2),('5815','2013-06-08','12:15:00',2.11),('5815','2013-06-08','12:20:00',2.2),('5815','2013-06-08','12:25:00',2.19),('5815','2013-06-08','12:30:00',2.19),('5815','2013-06-08','12:35:00',2.16),('5815','2013-06-08','12:40:00',2.22),('5815','2013-06-08','12:45:00',2.2),('5815','2013-06-08','12:50:00',2.17),('5815','2013-06-08','12:55:00',1.99),('5815','2013-06-08','13:00:00',2.07),('5815','2013-06-08','13:05:00',1.52),('5815','2013-06-08','13:10:00',2.2),('5815','2013-06-08','13:20:00',1.14),('5815','2013-06-08','13:25:00',2.57),('5815','2013-06-08','13:30:00',2.42),('5815','2013-06-08','13:35:00',2.39),('5815','2013-06-08','13:40:00',2.45),('5815','2013-06-08','13:45:00',2.47),('5815','2013-06-08','13:50:00',2.57),('5815','2013-06-08','13:55:00',2.46),('5815','2013-06-08','14:00:00',2.24),('5815','2013-06-08','14:05:00',2.46),('5815','2013-06-08','14:10:00',2.53),('5815','2013-06-08','14:15:00',1.64),('5815','2013-06-08','14:20:00',1.25),('5815','2013-06-08','14:35:00',1.9),('5815','2013-06-08','14:40:00',2.04),('5815','2013-06-08','14:45:00',1.96),('5815','2013-06-08','14:50:00',2.17),('5815','2013-06-08','14:55:00',2.26),('5815','2013-06-08','15:00:00',2.23),('5815','2013-06-08','15:05:00',2.12),('5815','2013-06-08','15:10:00',2.09),('5815','2013-06-08','15:15:00',2.03),('5815','2013-06-08','15:20:00',2.05),('5815','2013-06-08','15:25:00',2.07),('5815','2013-06-08','15:30:00',1.97),('5815','2013-06-08','15:35:00',2.06),('5815','2013-06-08','15:40:00',1.67),('5815','2013-06-08','15:45:00',1.67),('5815','2013-06-08','15:50:00',1.82),('5815','2013-06-08','15:55:00',2.02),('5815','2013-06-08','16:00:00',1.29),('5815','2013-06-08','16:05:00',1.75),('5815','2013-06-08','16:10:00',1.78),('5815','2013-06-08','16:15:00',1.05),('5815','2013-06-08','16:25:00',1.27),('5815','2013-06-07','08:35:00',1.01),('5815','2013-06-07','08:40:00',1.06),('5815','2013-06-07','08:45:00',1.11),('5815','2013-06-07','08:50:00',1.16),('5815','2013-06-07','08:55:00',1.2),('5815','2013-06-07','09:00:00',1.24),('5815','2013-06-07','09:05:00',1.3),('5815','2013-06-07','09:10:00',1.35),('5815','2013-06-07','09:15:00',1.38),('5815','2013-06-07','09:20:00',1.41),('5815','2013-06-07','09:25:00',1.45),('5815','2013-06-07','09:30:00',1.5),('5815','2013-06-07','09:35:00',1.52),('5815','2013-06-07','09:40:00',1.57),('5815','2013-06-07','09:45:00',1.58),('5815','2013-06-07','09:50:00',1.61),('5815','2013-06-07','09:55:00',1.62),('5815','2013-06-07','10:00:00',1.65),('5815','2013-06-07','10:05:00',1.74),('5815','2013-06-07','10:10:00',1.83),('5815','2013-06-07','10:15:00',1.86),('5815','2013-06-07','10:20:00',1.87),('5815','2013-06-07','10:25:00',1.9),('5815','2013-06-07','10:30:00',1.92),('5815','2013-06-07','10:35:00',1.96),('5815','2013-06-07','10:40:00',2.01),('5815','2013-06-07','10:45:00',1.97),('5815','2013-06-07','10:50:00',2.09),('5815','2013-06-07','10:55:00',1.75),('5815','2013-06-07','11:05:00',2.2),('5815','2013-06-07','11:10:00',2.33),('5815','2013-06-07','11:15:00',2.27),('5815','2013-06-07','11:20:00',2.28),('5815','2013-06-07','11:25:00',2.35),('5815','2013-06-07','11:30:00',2.14),('5815','2013-06-07','11:35:00',1.35),('5815','2013-06-07','11:40:00',2.35),('5815','2013-06-07','11:45:00',2.26),('5815','2013-06-07','11:50:00',2.29),('5815','2013-06-07','11:55:00',2.06),('5815','2013-06-07','12:05:00',1.53),('5815','2013-06-07','12:15:00',1.82),('5815','2013-06-07','12:20:00',2.5),('5815','2013-06-07','12:35:00',1.77),('5815','2013-06-07','12:40:00',2.42),('5815','2013-06-07','12:45:00',2.44),('5815','2013-06-07','12:50:00',2.44),('5815','2013-06-07','12:55:00',2.44),('5815','2013-06-07','13:00:00',1.29),('5815','2013-06-07','13:05:00',2.45),('5815','2013-06-07','13:10:00',2.5),('5815','2013-06-07','13:15:00',2.53),('5815','2013-06-07','13:20:00',2.52),('5815','2013-06-07','13:25:00',2.42),('5815','2013-06-07','13:30:00',2.42),('5815','2013-06-07','13:35:00',2.44),('5815','2013-06-07','13:40:00',2.46),('5815','2013-06-07','13:45:00',2.41),('5815','2013-06-07','13:50:00',2.39),('5815','2013-06-07','13:55:00',2.39),('5815','2013-06-07','14:00:00',2.38),('5815','2013-06-07','14:05:00',2.39),('5815','2013-06-07','14:10:00',2.42),('5815','2013-06-07','14:15:00',2.37),('5815','2013-06-07','14:20:00',2.33),('5815','2013-06-07','14:25:00',2.33),('5815','2013-06-07','14:30:00',2.33),('5815','2013-06-07','14:35:00',2.31),('5815','2013-06-07','14:40:00',2.29),('5815','2013-06-07','14:45:00',2.28),('5815','2013-06-07','14:50:00',2.28),('5815','2013-06-07','14:55:00',2.28),('5815','2013-06-07','15:00:00',2.29),('5815','2013-06-07','15:05:00',2.18),('5815','2013-06-07','15:10:00',2.01),('5815','2013-06-07','15:15:00',2.12),('5815','2013-06-07','15:20:00',2.18),('5815','2013-06-07','15:25:00',2.06),('5815','2013-06-07','15:30:00',2.11),('5815','2013-06-07','15:35:00',2.2),('5815','2013-06-07','15:40:00',2.19),('5815','2013-06-07','15:45:00',2.22),('5815','2013-06-07','15:50:00',2.17),('5815','2013-06-07','15:55:00',1.96),('5815','2013-06-07','16:00:00',1.87),('5815','2013-06-07','16:05:00',1.82),('5815','2013-06-07','16:10:00',1.89),('5815','2013-06-07','16:15:00',1.94),('5815','2013-06-07','16:20:00',1.89),('5815','2013-06-07','16:25:00',1.8),('5815','2013-06-07','16:30:00',1.71),('5815','2013-06-07','16:35:00',1.66),('5815','2013-06-07','16:40:00',1.61),('5815','2013-06-07','16:45:00',1.58),('5815','2013-06-07','16:50:00',1.38),('5815','2013-06-07','16:55:00',1.38),('5815','2013-06-07','17:00:00',1.47),('5815','2013-06-07','17:05:00',1.08),('5815','2013-06-07','17:10:00',1.49),('5815','2013-06-07','17:15:00',1.48),('5815','2013-06-07','17:20:00',1.4),('5815','2013-06-07','17:25:00',1.29),('5815','2013-06-07','17:45:00',1.11),('5815','2013-06-07','17:55:00',1.02),('5815','2013-06-06','08:30:00',1.01),('5815','2013-06-06','08:35:00',1.06),('5815','2013-06-06','08:40:00',1.11),('5815','2013-06-06','08:45:00',1.17),('5815','2013-06-06','08:50:00',1.22),('5815','2013-06-06','08:55:00',1.27),('5815','2013-06-06','09:00:00',1.32),('5815','2013-06-06','09:05:00',1.36),('5815','2013-06-06','09:10:00',1.41),('5815','2013-06-06','09:15:00',1.45),('5815','2013-06-06','09:20:00',1.49),('5815','2013-06-06','09:25:00',1.54),('5815','2013-06-06','09:30:00',1.59),('5815','2013-06-06','09:35:00',1.63),('5815','2013-06-06','09:40:00',1.68),('5815','2013-06-06','09:45:00',1.73),('5815','2013-06-06','09:50:00',1.76),('5815','2013-06-06','09:55:00',1.8),('5815','2013-06-06','10:00:00',1.83),('5815','2013-06-06','10:05:00',1.86),('5815','2013-06-06','10:10:00',1.9),('5815','2013-06-06','10:15:00',1.93),('5815','2013-06-06','10:20:00',1.96),('5815','2013-06-06','10:25:00',2),('5815','2013-06-06','10:30:00',2.03),('5815','2013-06-06','10:35:00',2.03),('5815','2013-06-06','10:40:00',2.07),('5815','2013-06-06','10:45:00',2.09),('5815','2013-06-06','10:50:00',2.12),('5815','2013-06-06','10:55:00',2.11),('5815','2013-06-06','11:00:00',2.06),('5815','2013-06-06','11:05:00',2.08),('5815','2013-06-06','11:10:00',2.15),('5815','2013-06-06','11:15:00',2.16),('5815','2013-06-06','11:20:00',2.18),('5815','2013-06-06','11:25:00',2.2),('5815','2013-06-06','11:30:00',2.21),('5815','2013-06-06','11:35:00',2.24),('5815','2013-06-06','11:40:00',2.19),('5815','2013-06-06','11:45:00',2.14),('5815','2013-06-06','11:50:00',2.19),('5815','2013-06-06','11:55:00',2.28),('5815','2013-06-06','12:00:00',2.3),('5815','2013-06-06','12:05:00',2.31),('5815','2013-06-06','12:10:00',2.32),('5815','2013-06-06','12:15:00',2.33),('5815','2013-06-06','12:20:00',2.33),('5815','2013-06-06','12:25:00',2.38),('5815','2013-06-06','12:30:00',2.33),('5815','2013-06-06','12:35:00',2.31),('5815','2013-06-06','12:40:00',2.38),('5815','2013-06-06','12:45:00',2.36),('5815','2013-06-06','12:50:00',2.36),('5815','2013-06-06','12:55:00',2.36),('5815','2013-06-06','13:00:00',2.36),('5815','2013-06-06','13:05:00',2.35),('5815','2013-06-06','13:10:00',2.35),('5815','2013-06-06','13:15:00',2.35),('5815','2013-06-06','13:20:00',2.33),('5815','2013-06-06','13:25:00',2.35),('5815','2013-06-06','13:30:00',2.35),('5815','2013-06-06','13:35:00',2.32),('5815','2013-06-06','13:40:00',2.31),('5815','2013-06-06','13:45:00',2.3),('5815','2013-06-06','13:50:00',2.3),('5815','2013-06-06','13:55:00',2.29),('5815','2013-06-06','14:00:00',2.29),('5815','2013-06-06','14:05:00',2.29),('5815','2013-06-06','14:10:00',2.28),('5815','2013-06-06','14:15:00',2.24),('5815','2013-06-06','14:20:00',2.2),('5815','2013-06-06','14:25:00',2.2),('5815','2013-06-06','14:30:00',2.21),('5815','2013-06-06','14:35:00',2.2),('5815','2013-06-06','14:40:00',2.2),('5815','2013-06-06','14:45:00',2.21),('5815','2013-06-06','14:50:00',2.19),('5815','2013-06-06','14:55:00',2.18),('5815','2013-06-06','15:00:00',2.18),('5815','2013-06-06','15:05:00',2.15),('5815','2013-06-06','15:10:00',2.16),('5815','2013-06-06','15:15:00',2.12),('5815','2013-06-06','15:20:00',2.08),('5815','2013-06-06','15:25:00',2.07),('5815','2013-06-06','15:30:00',2.08),('5815','2013-06-06','15:35:00',2.07),('5815','2013-06-06','15:40:00',2.06),('5815','2013-06-06','15:45:00',2.06),('5815','2013-06-06','15:50:00',1.99),('5815','2013-06-06','15:55:00',1.94),('5815','2013-06-06','16:00:00',1.92),('5815','2013-06-06','16:05:00',1.87),('5815','2013-06-06','16:10:00',1.84),('5815','2013-06-06','16:15:00',1.79),('5815','2013-06-06','16:20:00',1.74),('5815','2013-06-06','16:25:00',1.72),('5815','2013-06-06','16:30:00',1.67),('5815','2013-06-06','16:35:00',1.62),('5815','2013-06-06','16:40:00',1.61),('5815','2013-06-06','16:45:00',1.57),('5815','2013-06-06','16:50:00',1.53),('5815','2013-06-06','16:55:00',1.48),('5815','2013-06-06','17:00:00',1.41),('5815','2013-06-06','17:05:00',1.36),('5815','2013-06-06','17:10:00',1.34),('5815','2013-06-06','17:15:00',1.3),('5815','2013-06-06','17:20:00',1.25),('5815','2013-06-06','17:25:00',1.21),('5815','2013-06-06','17:30:00',1.1),('5815','2013-06-06','17:35:00',1.01),('5815','2013-06-06','17:40:00',1.09),('5815','2013-06-06','17:45:00',1.08),('5815','2013-06-06','17:50:00',1.03),('5815','2013-06-05','08:30:00',1.01),('5815','2013-06-05','08:35:00',1.06),('5815','2013-06-05','08:40:00',1.09),('5815','2013-06-05','08:45:00',1.13),('5815','2013-06-05','08:50:00',1.18),('5815','2013-06-05','08:55:00',1.24),('5815','2013-06-05','09:00:00',1.28),('5815','2013-06-05','09:05:00',1.32),('5815','2013-06-05','09:10:00',1.38),('5815','2013-06-05','09:15:00',1.42),('5815','2013-06-05','09:20:00',1.45),('5815','2013-06-05','09:25:00',1.51),('5815','2013-06-05','09:30:00',1.53),('5815','2013-06-05','09:35:00',1.59),('5815','2013-06-05','09:40:00',1.65),('5815','2013-06-05','09:45:00',1.69),('5815','2013-06-05','09:50:00',1.71),('5815','2013-06-05','09:55:00',1.71),('5815','2013-06-05','10:00:00',1.77),('5815','2013-06-05','10:05:00',1.82),('5815','2013-06-05','10:10:00',1.85),('5815','2013-06-05','10:15:00',1.89),('5815','2013-06-05','10:20:00',1.94),('5815','2013-06-05','10:25:00',1.97),('5815','2013-06-05','10:30:00',1.98),('5815','2013-06-05','10:35:00',1.99),('5815','2013-06-05','10:40:00',2),('5815','2013-06-05','10:45:00',2.07),('5815','2013-06-05','10:50:00',2.08),('5815','2013-06-05','10:55:00',2.08),('5815','2013-06-05','11:00:00',2.04),('5815','2013-06-05','11:05:00',2.08),('5815','2013-06-05','11:10:00',2.1),('5815','2013-06-05','11:15:00',2.13),('5815','2013-06-05','11:20:00',2.12),('5815','2013-06-05','11:25:00',2.15),('5815','2013-06-05','11:30:00',2.16),('5815','2013-06-05','11:35:00',2.17),('5815','2013-06-05','11:40:00',2.18),('5815','2013-06-05','11:45:00',2.11),('5815','2013-06-05','11:50:00',2.13),('5815','2013-06-05','11:55:00',2.17),('5815','2013-06-05','12:00:00',2.19),('5815','2013-06-05','12:05:00',2.26),('5815','2013-06-05','12:10:00',2.29),('5815','2013-06-05','12:15:00',2.29),('5815','2013-06-05','12:20:00',2.29),('5815','2013-06-05','12:25:00',2.33),('5815','2013-06-05','12:30:00',2.3),('5815','2013-06-05','12:35:00',2.28),('5815','2013-06-05','12:40:00',2.33),('5815','2013-06-05','12:45:00',2.34),('5815','2013-06-05','12:50:00',2.34),('5815','2013-06-05','12:55:00',2.35),('5815','2013-06-05','13:00:00',2.36),('5815','2013-06-05','13:05:00',2.38),('5815','2013-06-05','13:10:00',2.38),('5815','2013-06-05','13:15:00',2.41),('5815','2013-06-05','13:20:00',2.45),('5815','2013-06-05','13:25:00',2.41),('5815','2013-06-05','13:30:00',2.44),('5815','2013-06-05','13:35:00',2.39),('5815','2013-06-05','13:40:00',2.4),('5815','2013-06-05','13:45:00',2.39),('5815','2013-06-05','13:50:00',2.35),('5815','2013-06-05','13:55:00',2.35),('5815','2013-06-05','14:00:00',2.39),('5815','2013-06-05','14:05:00',2.4),('5815','2013-06-05','14:10:00',2.39),('5815','2013-06-05','14:15:00',2.09),('5815','2013-06-05','14:20:00',2.26),('5815','2013-06-05','14:25:00',2.02),('5815','2013-06-05','14:30:00',2.3),('5815','2013-06-05','14:35:00',2.31),('5815','2013-06-05','14:40:00',2.36),('5815','2013-06-05','14:45:00',1.66),('5815','2013-06-05','14:50:00',1.83),('5815','2013-06-05','14:55:00',2.51),('5815','2013-06-05','15:00:00',2.38),('5815','2013-06-05','15:05:00',2.26),('5815','2013-06-05','15:10:00',2.19),('5815','2013-06-05','15:15:00',2.03),('5815','2013-06-05','15:20:00',2.19),('5815','2013-06-05','15:25:00',2.14),('5815','2013-06-05','15:30:00',2.06),('5815','2013-06-05','15:35:00',2.02),('5815','2013-06-05','15:40:00',2.09),('5815','2013-06-05','15:45:00',2.08),('5815','2013-06-05','15:50:00',1.99),('5815','2013-06-05','15:55:00',1.85),('5815','2013-06-05','16:00:00',1.9),('5815','2013-06-05','16:05:00',1.9),('5815','2013-06-05','16:10:00',1.77),('5815','2013-06-05','16:15:00',1.75),('5815','2013-06-05','16:20:00',1.68),('5815','2013-06-05','16:25:00',1.67),('5815','2013-06-05','16:30:00',1.61),('5815','2013-06-05','16:35:00',1.57),('5815','2013-06-05','16:40:00',1.64),('5815','2013-06-05','16:45:00',1.54),('5815','2013-06-05','16:50:00',1.5),('5815','2013-06-05','16:55:00',1.44),('5815','2013-06-05','17:00:00',1.4),('5815','2013-06-05','17:05:00',1.31),('5815','2013-06-05','17:10:00',1.31),('5815','2013-06-05','17:15:00',1.26),('5815','2013-06-05','17:20:00',1.24),('5815','2013-06-05','17:25:00',1.18),('5815','2013-06-05','17:30:00',1.08),('5815','2013-06-05','17:40:00',1.04),('5815','2013-06-04','08:30:00',1),('5815','2013-06-04','08:35:00',1.05),('5815','2013-06-04','08:40:00',1.1),('5815','2013-06-04','08:45:00',1.16),('5815','2013-06-04','08:50:00',1.19),('5815','2013-06-04','08:55:00',1.27),('5815','2013-06-04','09:00:00',1.27),('5815','2013-06-04','09:05:00',1.35),('5815','2013-06-04','09:10:00',1.39),('5815','2013-06-04','09:15:00',1.46),('5815','2013-06-04','09:20:00',1.6),('5815','2013-06-04','09:25:00',1.52),('5815','2013-06-04','09:30:00',1.66),('5815','2013-06-04','09:35:00',1.77),('5815','2013-06-04','09:40:00',1.88),('5815','2013-06-04','09:45:00',1.73),('5815','2013-06-04','09:50:00',1.65),('5815','2013-06-04','09:55:00',1.05),('5815','2013-06-04','10:00:00',1.03),('5815','2013-06-04','10:05:00',2.02),('5815','2013-06-04','10:25:00',1.55),('5815','2013-06-04','10:35:00',1.89),('5815','2013-06-04','10:40:00',1.48),('5815','2013-06-04','10:45:00',1.88),('5815','2013-06-04','10:50:00',1.98),('5815','2013-06-04','10:55:00',2.24),('5815','2013-06-04','11:00:00',2.23),('5815','2013-06-04','11:05:00',2.31),('5815','2013-06-04','11:35:00',1.02),('5815','2013-06-04','11:40:00',1.24),('5815','2013-06-04','11:45:00',2.37),('5815','2013-06-04','11:50:00',1.8),('5815','2013-06-04','11:55:00',1.94),('5815','2013-06-04','12:05:00',1.59),('5815','2013-06-04','12:10:00',2.64),('5815','2013-06-04','12:15:00',1.34),('5815','2013-06-04','12:20:00',2.51),('5815','2013-06-04','12:25:00',2.79),('5815','2013-06-04','12:30:00',2.67),('5815','2013-06-04','12:35:00',2.15),('5815','2013-06-04','12:40:00',2.16),('5815','2013-06-04','12:45:00',1.91),('5815','2013-06-04','12:50:00',1.98),('5815','2013-06-04','13:00:00',1.15),('5815','2013-06-04','13:05:00',1.82),('5815','2013-06-04','13:10:00',1.39),('5815','2013-06-04','13:15:00',1.2),('5815','2013-06-04','13:20:00',1.55),('5815','2013-06-04','13:25:00',2.31),('5815','2013-06-04','13:30:00',1.77),('5815','2013-06-04','13:35:00',2.84),('5815','2013-06-04','13:40:00',2.72),('5815','2013-06-04','13:45:00',2.64),('5815','2013-06-04','13:50:00',2.54),('5815','2013-06-04','13:55:00',2.52),('5815','2013-06-04','14:00:00',2.49),('5815','2013-06-04','14:05:00',2.49),('5815','2013-06-04','14:10:00',2.45),('5815','2013-06-04','14:15:00',2.44),('5815','2013-06-04','14:20:00',2.42),('5815','2013-06-04','14:25:00',2.39),('5815','2013-06-04','14:30:00',2.37),('5815','2013-06-04','14:35:00',2.33),('5815','2013-06-04','14:40:00',2.34),('5815','2013-06-04','14:45:00',2.37),('5815','2013-06-04','14:50:00',2.34),('5815','2013-06-04','14:55:00',2.34),('5815','2013-06-04','15:00:00',2.28),('5815','2013-06-04','15:05:00',2.21),('5815','2013-06-04','15:10:00',2.21),('5815','2013-06-04','15:15:00',2.21),('5815','2013-06-04','15:20:00',2.11),('5815','2013-06-04','15:25:00',2.2),('5815','2013-06-04','15:30:00',2.17),('5815','2013-06-04','15:35:00',2.04),('5815','2013-06-04','15:40:00',2.16),('5815','2013-06-04','15:45:00',2.1),('5815','2013-06-04','15:50:00',2.08),('5815','2013-06-04','15:55:00',2.03),('5815','2013-06-04','16:00:00',2),('5815','2013-06-04','16:05:00',1.98),('5815','2013-06-04','16:10:00',1.91),('5815','2013-06-04','16:15:00',1.89),('5815','2013-06-04','16:20:00',1.85),('5815','2013-06-04','16:25:00',1.8),('5815','2013-06-04','16:30:00',1.75),('5815','2013-06-04','16:35:00',1.72),('5815','2013-06-04','16:40:00',1.67),('5815','2013-06-04','16:45:00',1.62),('5815','2013-06-04','16:50:00',1.6),('5815','2013-06-04','16:55:00',1.55),('5815','2013-06-04','17:00:00',1.51),('5815','2013-06-04','17:05:00',1.41),('5815','2013-06-04','17:10:00',1.18),('5815','2013-06-04','17:15:00',1.04),('5815','2013-06-04','17:25:00',1.1),('5815','2013-06-04','17:30:00',1.22),('5815','2013-06-04','17:35:00',1.02),('5815','2013-06-04','17:40:00',1.02),('5815','2013-06-04','17:45:00',1.05),('5815','2013-06-03','08:10:00',1.04),('5815','2013-06-03','08:15:00',1.08),('5815','2013-06-03','08:20:00',1.11),('5815','2013-06-03','08:25:00',1),('5815','2013-06-03','08:35:00',1.28),('5815','2013-06-03','08:40:00',1.22),('5815','2013-06-03','08:45:00',1.05),('5815','2013-06-03','09:05:00',1.01),('5815','2013-06-03','09:10:00',1.21),('5815','2013-06-03','09:15:00',1.49),('5815','2013-06-03','09:20:00',1.48),('5815','2013-06-03','09:25:00',1.96),('5815','2013-06-03','09:30:00',1.64),('5815','2013-06-03','09:35:00',1.51),('5815','2013-06-03','09:45:00',1),('5815','2013-06-03','10:00:00',1.11),('5815','2013-06-03','10:05:00',1.18),('5815','2013-06-03','10:10:00',1.81),('5815','2013-06-03','10:15:00',1.64),('5815','2013-06-03','10:20:00',1.06),('5815','2013-06-03','10:40:00',1),('5815','2013-06-03','10:45:00',1.16),('5815','2013-06-03','10:50:00',1.57),('5815','2013-06-03','10:55:00',1.9),('5815','2013-06-03','11:00:00',1.28),('5815','2013-06-03','11:05:00',1.5),('5815','2013-06-03','11:10:00',1.76),('5815','2013-06-03','11:15:00',1.74),('5815','2013-06-03','11:20:00',1.25),('5815','2013-06-03','11:25:00',1.63),('5815','2013-06-03','11:30:00',1.94),('5815','2013-06-03','11:35:00',1.61),('5815','2013-06-03','11:40:00',1.72),('5815','2013-06-03','11:45:00',2.26),('5815','2013-06-03','11:50:00',2.49),('5815','2013-06-03','11:55:00',2.21),('5815','2013-06-03','12:00:00',1.84),('5815','2013-06-03','12:05:00',1.66),('5815','2013-06-03','12:10:00',1.35),('5815','2013-06-03','12:15:00',1.44),('5815','2013-06-03','12:20:00',1.06),('5815','2013-06-03','12:25:00',1.16),('5815','2013-06-03','12:30:00',1.6),('5815','2013-06-03','12:35:00',2.2),('5815','2013-06-03','12:40:00',1.44),('5815','2013-06-03','12:45:00',1.65),('5815','2013-06-03','12:50:00',1.41),('5815','2013-06-03','12:55:00',1.03),('5815','2013-06-03','13:00:00',1.2),('5815','2013-06-03','13:30:00',1.03),('5815','2013-06-03','13:35:00',2.36),('5815','2013-06-03','13:40:00',2.12),('5815','2013-06-03','13:45:00',2.94),('5815','2013-06-03','13:50:00',2.91),('5815','2013-06-03','13:55:00',1.56),('5815','2013-06-03','14:00:00',1.06),('5815','2013-06-03','14:05:00',2.33),('5815','2013-06-03','14:10:00',2.86),('5815','2013-06-03','14:15:00',2.58),('5815','2013-06-03','14:20:00',1.97),('5815','2013-06-03','14:25:00',1.43),('5815','2013-06-03','14:35:00',1.05),('5815','2013-06-03','14:40:00',1.42),('5815','2013-06-03','14:55:00',1.94),('5815','2013-06-03','15:00:00',2.95),('5815','2013-06-03','15:05:00',2.87),('5815','2013-06-03','15:10:00',1.46),('5815','2013-06-02','08:30:00',1.01),('5815','2013-06-02','08:35:00',1.07),('5815','2013-06-02','08:40:00',1.11),('5815','2013-06-02','08:45:00',1.17),('5815','2013-06-02','08:50:00',1.2),('5815','2013-06-02','08:55:00',1.21),('5815','2013-06-02','09:00:00',1.29),('5815','2013-06-02','09:05:00',1.37),('5815','2013-06-02','09:10:00',1.45),('5815','2013-06-02','09:15:00',1.56),('5815','2013-06-02','09:20:00',1.32),('5815','2013-06-02','09:25:00',1.45),('5815','2013-06-02','09:30:00',1.41),('5815','2013-06-02','09:35:00',1.02),('5815','2013-06-02','09:40:00',1.16),('5815','2013-06-02','09:45:00',1.35),('5815','2013-06-02','09:50:00',1.96),('5815','2013-06-02','09:55:00',2.08),('5815','2013-06-02','10:00:00',2.24),('5815','2013-06-02','10:05:00',2.29),('5815','2013-06-02','10:10:00',1.94),('5815','2013-06-02','10:15:00',1.34),('5815','2013-06-02','10:50:00',1.87),('5815','2013-06-02','10:55:00',2.68),('5815','2013-06-02','11:00:00',1.3),('5815','2013-06-02','11:45:00',1.44),('5815','2013-06-02','12:05:00',2.16),('5815','2013-06-02','12:40:00',2.37),('5815','2013-06-02','12:45:00',1.41),('5815','2013-06-02','12:50:00',1.57),('5815','2013-06-02','12:55:00',1.52),('5815','2013-06-02','13:00:00',1.15),('5815','2013-06-02','13:05:00',1.01),('5815','2013-06-02','13:10:00',1.06),('5815','2013-06-02','13:15:00',1.4),('5815','2013-06-02','13:20:00',2.66),('5815','2013-06-02','13:25:00',1.9),('5815','2013-06-02','13:30:00',2.13),('5815','2013-06-02','13:35:00',2.42),('5815','2013-06-02','13:40:00',2.75),('5815','2013-06-02','13:45:00',1.35),('5815','2013-06-02','13:50:00',2.93),('5815','2013-06-02','13:55:00',1.81),('5815','2013-06-02','14:00:00',2.52),('5815','2013-06-02','14:05:00',2.57),('5815','2013-06-02','14:10:00',1.38),('5815','2013-06-02','14:15:00',1.37),('5815','2013-06-02','14:20:00',1.1),('5815','2013-06-02','14:25:00',1.76),('5815','2013-06-02','14:30:00',2.67),('5815','2013-06-02','14:35:00',2.77),('5815','2013-06-02','14:40:00',2.08),('5815','2013-06-02','14:45:00',2.15),('5815','2013-06-02','14:50:00',2),('5815','2013-06-02','14:55:00',2.11),('5815','2013-06-02','15:00:00',2.14),('5815','2013-06-02','15:05:00',1.85),('5815','2013-06-02','15:10:00',2.24),('5815','2013-06-02','15:15:00',1.4),('5815','2013-06-02','15:20:00',1.91),('5815','2013-06-02','15:25:00',2.25),('5815','2013-06-02','15:30:00',2.19),('5815','2013-06-02','15:35:00',2.17),('5815','2013-06-02','15:40:00',2.18),('5815','2013-06-02','15:45:00',2.15),('5815','2013-06-02','15:50:00',2.09),('5815','2013-06-02','15:55:00',2.03),('5815','2013-06-02','16:00:00',2.02),('5815','2013-06-02','16:05:00',1.98),('5815','2013-06-02','16:10:00',1.95),('5815','2013-06-02','16:15:00',1.85),('5815','2013-06-02','16:20:00',1.82),('5815','2013-06-02','16:25:00',1.81),('5815','2013-06-02','16:30:00',1.86),('5815','2013-06-02','16:35:00',1.74),('5815','2013-06-02','16:40:00',1.73),('5815','2013-06-02','16:45:00',1.48),('5815','2013-06-02','16:50:00',1.13),('5815','2013-06-02','16:55:00',1.03),('5815','2013-06-02','17:00:00',1.32),('5815','2013-06-02','17:05:00',1.49),('5815','2013-06-02','17:10:00',1.65),('5815','2013-06-02','17:15:00',1.39),('5815','2013-06-02','17:20:00',1.18),('5815','2013-06-01','09:25:00',1.78),('5815','2013-06-01','09:30:00',1.71),('5815','2013-06-01','09:35:00',1.7),('5815','2013-06-01','09:40:00',1.71),('5815','2013-06-01','09:45:00',1.73),('5815','2013-06-01','09:50:00',1.77),('5815','2013-06-01','09:55:00',1.81),('5815','2013-06-01','10:00:00',1.82),('5815','2013-06-01','10:05:00',1.9),('5815','2013-06-01','10:10:00',1.94),('5815','2013-06-01','10:15:00',1.96),('5815','2013-06-01','10:20:00',2),('5815','2013-06-01','10:25:00',2.05),('5815','2013-06-01','10:30:00',2.11),('5815','2013-06-01','10:35:00',2.23),('5815','2013-06-01','10:40:00',2.28),('5815','2013-06-01','10:45:00',1.91),('5815','2013-06-01','11:00:00',2.25),('5815','2013-06-01','11:05:00',2.13),('5815','2013-06-01','11:10:00',2.29),('5815','2013-06-01','11:15:00',1.81),('5815','2013-06-01','11:20:00',2.06),('5815','2013-06-01','11:25:00',1.31),('5815','2013-06-01','11:30:00',2.37),('5815','2013-06-01','11:35:00',1.37),('5815','2013-06-01','11:50:00',1.02),('5815','2013-06-01','11:55:00',2.69),('5815','2013-06-01','12:00:00',2.32),('5815','2013-06-01','12:05:00',1.51),('5815','2013-06-01','12:10:00',2.12),('5815','2013-06-01','12:15:00',2.64),('5815','2013-06-01','12:20:00',1.45),('5815','2013-06-01','12:25:00',1.32),('5815','2013-06-01','12:30:00',2.12),('5815','2013-06-01','12:35:00',2.79),('5815','2013-06-01','12:40:00',1.86),('5815','2013-06-01','12:45:00',2.39),('5815','2013-06-01','12:50:00',1.34),('5815','2013-06-01','13:00:00',1.62),('5815','2013-06-01','13:05:00',1.49),('5815','2013-06-01','13:15:00',2.87),('5815','2013-06-01','13:20:00',2.64),('5815','2013-06-01','13:25:00',2.53),('5815','2013-06-01','13:30:00',2.51),('5815','2013-06-01','13:35:00',2.5),('5815','2013-06-01','13:40:00',2.48),('5815','2013-06-01','13:45:00',2.45),('5815','2013-06-01','13:50:00',2.44),('5815','2013-06-01','13:55:00',2.44),('5815','2013-06-01','14:00:00',2.46),('5815','2013-06-01','14:05:00',2.48),('5815','2013-06-01','14:10:00',2.47),('5815','2013-06-01','14:15:00',2.45),('5815','2013-06-01','14:20:00',2.36),('5815','2013-06-01','14:25:00',2.39),('5815','2013-06-01','14:30:00',2.4),('5815','2013-06-01','14:35:00',2.36),('5815','2013-06-01','14:40:00',2.35),('5815','2013-06-01','14:45:00',2.34),('5815','2013-06-01','14:50:00',2.29),('5815','2013-06-01','14:55:00',2.3),('5815','2013-06-01','15:00:00',2.28),('5815','2013-06-01','15:05:00',2.24),('5815','2013-06-01','15:10:00',2.21),('5815','2013-06-01','15:15:00',2.23),('5815','2013-06-01','15:20:00',2.22),('5815','2013-06-01','15:25:00',2),('5815','2013-06-01','15:30:00',1.94),('5815','2013-06-01','15:35:00',1.95),('5815','2013-06-01','15:40:00',1.64),('5815','2013-06-01','15:45:00',1.8),('5815','2013-06-01','15:50:00',2.12),('5815','2013-06-01','15:55:00',1.85),('5815','2013-06-01','16:00:00',1.76),('5815','2013-06-01','16:05:00',1.97),('5815','2013-06-01','16:10:00',1.95),('5815','2013-06-01','16:15:00',2),('5815','2013-06-01','16:20:00',1.84),('5815','2013-06-01','16:25:00',1.88),('5815','2013-06-01','16:30:00',1.8),('5815','2013-06-01','16:35:00',1.74),('5815','2013-06-01','16:40:00',1.71),('5815','2013-06-01','16:45:00',1.57),('5815','2013-06-01','16:50:00',1.55),('5815','2013-06-01','16:55:00',1.59),('5815','2013-06-01','17:00:00',1.43),('5815','2013-06-01','17:05:00',1.23),('5815','2013-06-01','17:10:00',1.46),('5815','2013-06-01','17:15:00',1.21),('5815','2013-06-01','17:20:00',1.33),('5815','2013-06-01','17:25:00',1.26),('5815','2013-06-01','17:30:00',1.19),('5815','2013-06-01','17:35:00',1.03),('5815','2013-05-31','10:50:00',1.06),('5815','2013-05-31','10:55:00',1.22),('5815','2013-05-31','11:55:00',1.04),('5815','2013-05-31','12:00:00',1.16),('5815','2013-05-31','12:05:00',1.65),('5815','2013-05-31','12:10:00',1.71),('5815','2013-05-31','12:50:00',1.06),('5815','2013-05-31','12:55:00',1.01),('5815','2013-05-31','13:00:00',1.19),('5815','2013-05-31','13:05:00',1.3),('5815','2013-05-31','13:10:00',1.36),('5815','2013-05-31','13:15:00',1.47),('5815','2013-05-31','13:20:00',1.33),('5815','2013-05-31','13:25:00',1.01),('5815','2013-05-31','14:00:00',1.1),('5815','2013-05-31','14:05:00',1.37),('5815','2013-05-31','14:10:00',1.34),('5815','2013-05-31','14:15:00',1.4),('5815','2013-05-31','14:20:00',1.57),('5815','2013-05-30','08:30:00',1.12),('5815','2013-05-30','08:40:00',1.34),('5815','2013-05-30','08:45:00',1.35),('5815','2013-05-30','08:50:00',1.55),('5815','2013-05-30','09:15:00',1),('5815','2013-05-30','09:35:00',1.07),('5815','2013-05-30','09:40:00',1),('5815','2013-05-30','09:45:00',1.98),('5815','2013-05-30','09:50:00',1.98),('5815','2013-05-30','09:55:00',2.06),('5815','2013-05-30','10:00:00',1.99),('5815','2013-05-30','10:05:00',1.84),('5815','2013-05-30','10:10:00',1.38),('5815','2013-05-30','10:15:00',1.25),('5815','2013-05-30','10:20:00',1.79),('5815','2013-05-30','10:35:00',1.22),('5815','2013-05-30','10:40:00',1.83),('5815','2013-05-30','10:45:00',2.6),('5815','2013-05-30','10:50:00',1.56),('5815','2013-05-30','10:55:00',1.77),('5815','2013-05-30','11:05:00',1.14),('5815','2013-05-30','11:10:00',2.27),('5815','2013-05-30','11:15:00',2.23),('5815','2013-05-30','11:20:00',1.03),('5815','2013-05-30','11:25:00',1.7),('5815','2013-05-30','11:30:00',2.68),('5815','2013-05-30','11:35:00',1.04),('5815','2013-05-30','11:45:00',1.99),('5815','2013-05-30','11:50:00',2.15),('5815','2013-05-30','11:55:00',1.45),('5815','2013-05-30','12:00:00',1.81),('5815','2013-05-30','12:05:00',2.53),('5815','2013-05-30','12:10:00',2.1),('5815','2013-05-30','12:25:00',2.08),('5815','2013-05-30','12:30:00',1.05),('5815','2013-05-30','12:40:00',2.55),('5815','2013-05-30','12:45:00',1.53),('5815','2013-05-30','13:00:00',2.58),('5815','2013-05-30','13:05:00',1.35),('5815','2013-05-30','13:25:00',1.08),('5815','2013-05-30','13:30:00',1.85),('5815','2013-05-30','13:35:00',2.68),('5815','2013-05-30','13:40:00',1.66),('5815','2013-05-30','14:00:00',1.52),('5815','2013-05-30','15:15:00',1.42),('5815','2013-05-30','15:20:00',2.59),('5815','2013-05-30','15:25:00',2.02),('5815','2013-05-30','15:30:00',1.67),('5815','2013-05-30','15:35:00',1.23),('5815','2013-05-30','15:40:00',1.02),('5815','2013-05-30','15:50:00',1.28),('5815','2013-05-30','15:55:00',1.25),('5815','2013-05-29','08:40:00',1.15),('5815','2013-05-29','08:45:00',1.25),('5815','2013-05-29','08:50:00',1.28),('5815','2013-05-29','08:55:00',1.33),('5815','2013-05-29','09:00:00',1.39),('5815','2013-05-29','09:05:00',1.44),('5815','2013-05-29','09:10:00',1.5),('5815','2013-05-29','09:15:00',1.52),('5815','2013-05-29','09:20:00',1.61),('5815','2013-05-29','09:25:00',1.72),('5815','2013-05-29','09:30:00',1.79),('5815','2013-05-29','09:35:00',1.76),('5815','2013-05-29','09:40:00',1.84),('5815','2013-05-29','09:45:00',1.72),('5815','2013-05-29','09:50:00',2.05),('5815','2013-05-29','09:55:00',1.59),('5815','2013-05-29','10:10:00',2.18),('5815','2013-05-29','10:20:00',2.07),('5815','2013-05-29','10:45:00',2.14),('5815','2013-05-29','10:50:00',2.52),('5815','2013-05-29','10:55:00',2.43),('5815','2013-05-29','11:00:00',2.32),('5815','2013-05-29','11:05:00',2.19),('5815','2013-05-29','11:10:00',1.23),('5815','2013-05-29','11:20:00',2.61),('5815','2013-05-29','11:25:00',1.5),('5815','2013-05-29','11:30:00',1.46),('5815','2013-05-29','11:35:00',2.39),('5815','2013-05-29','11:40:00',2.76),('5815','2013-05-29','11:45:00',1.86),('5815','2013-05-29','11:50:00',2.72),('5815','2013-05-29','12:00:00',1.44),('5815','2013-05-29','12:05:00',2.79),('5815','2013-05-29','12:10:00',2.5),('5815','2013-05-29','12:15:00',1.91),('5815','2013-05-29','12:20:00',2.76),('5815','2013-05-29','12:25:00',2.02),('5815','2013-05-29','12:30:00',2.32),('5815','2013-05-29','12:35:00',2.2),('5815','2013-05-29','12:40:00',2.23),('5815','2013-05-29','12:45:00',1.17),('5815','2013-05-29','12:50:00',2.12),('5815','2013-05-29','12:55:00',2.59),('5815','2013-05-29','13:00:00',2.18),('5815','2013-05-29','13:05:00',1.15),('5815','2013-05-29','13:10:00',1.14),('5815','2013-05-29','13:15:00',1.52),('5815','2013-05-29','13:20:00',1.2),('5815','2013-05-29','13:25:00',1.21),('5815','2013-05-29','13:30:00',1.53),('5815','2013-05-29','13:40:00',1.96),('5815','2013-05-29','13:45:00',2.02),('5815','2013-05-29','13:55:00',1.12),('5815','2013-05-29','14:00:00',2.56),('5815','2013-05-29','14:05:00',2.94),('5815','2013-05-29','14:10:00',2.21),('5815','2013-05-29','14:15:00',1.21),('5815','2013-05-29','14:20:00',2.58),('5815','2013-05-29','14:25:00',1.25),('5815','2013-05-29','14:30:00',2.7),('5815','2013-05-29','14:35:00',2.17),('5815','2013-05-29','14:40:00',2.61),('5815','2013-05-29','14:45:00',2.58),('5815','2013-05-29','14:50:00',2.63),('5815','2013-05-29','14:55:00',2.57),('5815','2013-05-29','15:00:00',2.53),('5815','2013-05-29','15:05:00',2.52),('5815','2013-05-29','15:15:00',2.35),('5815','2013-05-29','15:20:00',2.48),('5815','2013-05-29','15:25:00',2.42),('5815','2013-05-29','15:30:00',2.46),('5815','2013-05-29','15:35:00',2.56),('5815','2013-05-29','15:40:00',2.52),('5815','2013-05-29','15:45:00',1.98),('5815','2013-05-29','15:50:00',2.27),('5815','2013-05-29','15:55:00',1.66),('5815','2013-05-29','16:00:00',2.44),('5815','2013-05-29','16:05:00',1.99),('5815','2013-05-29','16:10:00',2.19),('5815','2013-05-29','16:15:00',2.08),('5815','2013-05-29','16:20:00',1.85),('5815','2013-05-29','16:25:00',1.51),('5815','2013-05-29','16:45:00',1.11),('5815','2013-05-29','16:50:00',1.38),('5815','2013-05-29','16:55:00',1.36),('5815','2013-05-29','17:05:00',1.12),('5815','2013-05-28','08:30:00',1.03),('5815','2013-05-28','08:35:00',1.09),('5815','2013-05-28','08:40:00',1.13),('5815','2013-05-28','08:45:00',1.19),('5815','2013-05-28','08:50:00',1.24),('5815','2013-05-28','08:55:00',1.3),('5815','2013-05-28','09:00:00',1.36),('5815','2013-05-28','09:05:00',1.4),('5815','2013-05-28','09:10:00',1.45),('5815','2013-05-28','09:15:00',1.5),('5815','2013-05-28','09:20:00',1.54),('5815','2013-05-28','09:25:00',1.55),('5815','2013-05-28','09:30:00',1.63),('5815','2013-05-28','09:35:00',1.67),('5815','2013-05-28','09:40:00',1.72),('5815','2013-05-28','09:45:00',1.77),('5815','2013-05-28','09:50:00',1.8),('5815','2013-05-28','09:55:00',1.85),('5815','2013-05-28','10:00:00',1.87),('5815','2013-05-28','10:05:00',1.92),('5815','2013-05-28','10:10:00',1.95),('5815','2013-05-28','10:15:00',1.97),('5815','2013-05-28','10:20:00',2.03),('5815','2013-05-28','10:25:00',2.08),('5815','2013-05-28','10:30:00',2.11),('5815','2013-05-28','10:35:00',2.15),('5815','2013-05-28','10:40:00',2.16),('5815','2013-05-28','10:45:00',2.22),('5815','2013-05-28','10:50:00',2.23),('5815','2013-05-28','10:55:00',2.22),('5815','2013-05-28','11:00:00',2.25),('5815','2013-05-28','11:05:00',2.3),('5815','2013-05-28','11:10:00',2.34),('5815','2013-05-28','11:15:00',1.87),('5815','2013-05-28','11:20:00',2.09),('5815','2013-05-28','11:25:00',1.4),('5815','2013-05-28','11:30:00',2.53),('5815','2013-05-28','11:35:00',2.49),('5815','2013-05-28','11:40:00',2.11),('5815','2013-05-28','11:45:00',2.29),('5815','2013-05-28','11:50:00',2.11),('5815','2013-05-28','11:55:00',2.07),('5815','2013-05-28','12:00:00',2.54),('5815','2013-05-28','12:05:00',2.07),('5815','2013-05-28','12:10:00',1.93),('5815','2013-05-28','12:15:00',2.04),('5815','2013-05-28','12:20:00',2.67),('5815','2013-05-28','12:25:00',2.46),('5815','2013-05-28','12:30:00',2.56),('5815','2013-05-28','12:35:00',2.57),('5815','2013-05-28','12:40:00',2.6),('5815','2013-05-28','12:45:00',2.45),('5815','2013-05-28','12:50:00',2.52),('5815','2013-05-28','12:55:00',2.54),('5815','2013-05-28','13:00:00',2.62),('5815','2013-05-28','13:05:00',2.69),('5815','2013-05-28','13:10:00',2.2),('5815','2013-05-28','13:15:00',2.71),('5815','2013-05-28','13:20:00',2.86),('5815','2013-05-28','13:25:00',2.86),('5815','2013-05-28','13:30:00',2.85),('5815','2013-05-28','13:35:00',2.39),('5815','2013-05-28','13:40:00',2.62),('5815','2013-05-28','13:45:00',2.52),('5815','2013-05-28','13:50:00',2.3),('5815','2013-05-28','13:55:00',2.15),('5815','2013-05-28','14:00:00',2.55),('5815','2013-05-28','14:05:00',2.57),('5815','2013-05-28','14:10:00',2.47),('5815','2013-05-28','14:15:00',2.53),('5815','2013-05-28','14:20:00',2.55),('5815','2013-05-28','14:25:00',2.16),('5815','2013-05-28','14:30:00',2.51),('5815','2013-05-28','14:35:00',2.04),('5815','2013-05-28','14:40:00',2.6),('5815','2013-05-28','14:45:00',2.55),('5815','2013-05-28','14:50:00',2.32),('5815','2013-05-28','14:55:00',2.44),('5815','2013-05-28','15:00:00',2.53),('5815','2013-05-28','15:05:00',2.56),('5815','2013-05-28','15:10:00',2.48),('5815','2013-05-28','15:15:00',1.57),('5815','2013-05-28','15:20:00',1.78),('5815','2013-05-28','15:25:00',1.53),('5815','2013-05-28','15:30:00',1.62),('5815','2013-05-28','15:35:00',1.79),('5815','2013-05-28','15:40:00',1.8),('5815','2013-05-28','15:45:00',1.72),('5815','2013-05-28','15:50:00',1.66),('5815','2013-05-28','15:55:00',1.71),('5815','2013-05-28','16:00:00',1.55),('5815','2013-05-28','16:05:00',1.52),('5815','2013-05-28','16:10:00',1.26),('5815','2013-05-28','16:15:00',1.18),('5815','2013-05-28','16:20:00',1.16),('5815','2013-05-28','16:25:00',1.22),('5815','2013-05-28','16:30:00',1.15),('5815','2013-05-28','16:35:00',1.05),('5815','2013-05-28','16:40:00',1.23),('5815','2013-05-28','16:45:00',1.05),('5815','2013-05-27','09:25:00',1.13),('5815','2013-05-27','09:30:00',1.22),('5815','2013-05-27','09:35:00',1.31),('5815','2013-05-27','09:40:00',1.24),('5815','2013-05-27','09:45:00',1.15),('5815','2013-05-27','09:50:00',1.18),('5815','2013-05-27','09:55:00',1.25),('5815','2013-05-27','10:00:00',1.17),('5815','2013-05-27','10:05:00',1.23),('5815','2013-05-27','10:10:00',1.38),('5815','2013-05-27','10:15:00',1.43),('5815','2013-05-27','10:20:00',1.52),('5815','2013-05-27','10:25:00',1.49),('5815','2013-05-27','10:30:00',1.64),('5815','2013-05-27','10:35:00',1.7),('5815','2013-05-27','10:40:00',1.53),('5815','2013-05-27','10:45:00',1.41),('5815','2013-05-27','10:50:00',1.55),('5815','2013-05-27','10:55:00',1.37),('5815','2013-05-27','11:00:00',1.35),('5815','2013-05-27','11:05:00',1.32),('5815','2013-05-27','11:10:00',1.47),('5815','2013-05-27','11:15:00',1.11),('5815','2013-05-27','11:20:00',1.25),('5815','2013-05-27','11:25:00',1.12),('5815','2013-05-27','11:30:00',1.96),('5815','2013-05-27','11:35:00',1.75),('5815','2013-05-27','11:40:00',1.95),('5815','2013-05-27','11:45:00',2.05),('5815','2013-05-27','12:05:00',1.01),('5815','2013-05-27','12:10:00',1.6),('5815','2013-05-27','12:15:00',1.53),('5815','2013-05-27','12:20:00',1.27),('5815','2013-05-27','12:25:00',1.32),('5815','2013-05-27','12:30:00',1.49),('5815','2013-05-27','12:35:00',1.45),('5815','2013-05-27','12:40:00',1.46),('5815','2013-05-27','12:45:00',1.67),('5815','2013-05-27','12:50:00',1.5),('5815','2013-05-27','12:55:00',1.5),('5815','2013-05-27','13:00:00',1.54),('5815','2013-05-27','13:05:00',1.65),('5815','2013-05-27','13:10:00',1.73),('5815','2013-05-27','13:15:00',1.53),('5815','2013-05-27','13:20:00',2.03),('5815','2013-05-27','13:25:00',1.07),('5815','2013-05-27','13:30:00',1.22),('5815','2013-05-27','13:35:00',1),('5815','2013-05-27','13:40:00',1.12),('5815','2013-05-27','13:45:00',1.05),('5815','2013-05-27','13:50:00',1.52),('5815','2013-05-27','13:55:00',1.6),('5815','2013-05-27','14:00:00',1.48),('5815','2013-05-27','14:05:00',1.53),('5815','2013-05-27','14:10:00',2.2),('5815','2013-05-27','14:15:00',2.32),('5815','2013-05-27','14:20:00',1.39),('5815','2013-05-27','14:25:00',1.61),('5815','2013-05-27','14:30:00',1.97),('5815','2013-05-27','14:35:00',1.68),('5815','2013-05-27','14:40:00',1.91),('5815','2013-05-27','14:45:00',2.21),('5815','2013-05-27','14:50:00',1.68),('5815','2013-05-27','14:55:00',1.52),('5815','2013-05-27','15:00:00',1.27),('5815','2013-05-27','15:05:00',2.13),('5815','2013-05-27','15:10:00',1.02),('5815','2013-05-27','15:15:00',1.44),('5815','2013-05-27','15:20:00',1.82),('5815','2013-05-27','15:25:00',1.23),('5815','2013-05-27','15:40:00',1.23),('5815','2013-05-27','15:45:00',2.18),('5815','2013-05-27','15:50:00',1.8),('5815','2013-05-27','15:55:00',1.43),('5815','2013-05-27','16:20:00',1.22),('5815','2013-05-27','16:25:00',1.21),('5815','2013-05-27','16:30:00',1.22),('5815','2013-05-27','16:35:00',1.7),('5815','2013-05-27','16:40:00',1.57),('5815','2013-05-27','16:45:00',1.52),('5815','2013-05-27','16:50:00',1.47),('5815','2013-05-27','16:55:00',1.43),('5815','2013-05-27','17:00:00',1.4),('5815','2013-05-27','17:05:00',1.35),('5815','2013-05-27','17:10:00',1.3),('5815','2013-05-27','17:15:00',1.28),('5815','2013-05-27','17:20:00',1.22),('5815','2013-05-27','17:25:00',1.15),('5815','2013-05-27','17:30:00',1.06),('5815','2013-05-27','17:35:00',1.04),('5815','2013-05-26','08:25:00',1.01),('5815','2013-05-26','08:30:00',1.06),('5815','2013-05-26','08:35:00',1.11),('5815','2013-05-26','08:40:00',1.17),('5815','2013-05-26','08:45:00',1.32),('5815','2013-05-26','08:50:00',1.44),('5815','2013-05-26','09:00:00',1.3),('5815','2013-05-26','09:05:00',1.63),('5815','2013-05-26','09:10:00',1.51),('5815','2013-05-26','09:20:00',1.36),('5815','2013-05-26','09:25:00',1.55),('5815','2013-05-26','09:30:00',1.75),('5815','2013-05-26','09:35:00',1.76),('5815','2013-05-26','09:40:00',1.78),('5815','2013-05-26','09:45:00',1.85),('5815','2013-05-26','09:50:00',1.24),('5815','2013-05-26','09:55:00',1.42),('5815','2013-05-26','10:00:00',2.06),('5815','2013-05-26','10:05:00',1.81),('5815','2013-05-26','10:10:00',2.04),('5815','2013-05-26','10:15:00',2.15),('5815','2013-05-26','10:20:00',1.88),('5815','2013-05-26','10:25:00',1.39),('5815','2013-05-26','10:30:00',1.33),('5815','2013-05-26','10:45:00',1.74),('5815','2013-05-26','10:50:00',1.63),('5815','2013-05-26','10:55:00',1.43),('5815','2013-05-26','11:00:00',1.8),('5815','2013-05-26','11:05:00',1.8),('5815','2013-05-26','11:10:00',1.86),('5815','2013-05-26','11:15:00',1.13),('5815','2013-05-26','11:20:00',1.88),('5815','2013-05-26','11:25:00',2.59),('5815','2013-05-26','11:30:00',1.91),('5815','2013-05-26','11:35:00',2.27),('5815','2013-05-26','11:40:00',1.41),('5815','2013-05-26','11:45:00',2.8),('5815','2013-05-26','11:50:00',1.3),('5815','2013-05-26','11:55:00',1.1),('5815','2013-05-26','12:00:00',2.57),('5815','2013-05-26','12:05:00',2.42),('5815','2013-05-26','12:10:00',1.53),('5815','2013-05-26','12:15:00',2.39),('5815','2013-05-26','12:20:00',1.79),('5815','2013-05-26','12:25:00',2.07),('5815','2013-05-26','12:30:00',2.03),('5815','2013-05-26','12:35:00',1.43),('5815','2013-05-26','12:40:00',1.96),('5815','2013-05-26','12:45:00',2.93),('5815','2013-05-26','12:50:00',2.75),('5815','2013-05-26','12:55:00',2.63),('5815','2013-05-26','13:00:00',1.66),('5815','2013-05-26','13:05:00',2.38),('5815','2013-05-26','13:10:00',2.69),('5815','2013-05-26','13:15:00',2.42),('5815','2013-05-26','13:20:00',2.66),('5815','2013-05-26','13:25:00',2.12),('5815','2013-05-26','13:30:00',2.71),('5815','2013-05-26','13:35:00',2.38),('5815','2013-05-26','13:40:00',2.56),('5815','2013-05-26','13:45:00',2.81),('5815','2013-05-26','13:50:00',2.36),('5815','2013-05-26','13:55:00',1.74),('5815','2013-05-26','14:00:00',2.65),('5815','2013-05-26','14:05:00',2.64),('5815','2013-05-26','14:10:00',2.55),('5815','2013-05-26','14:15:00',2.35),('5815','2013-05-26','14:20:00',2.36),('5815','2013-05-26','14:25:00',2.16),('5815','2013-05-26','14:30:00',2.3),('5815','2013-05-26','14:35:00',2.56),('5815','2013-05-26','14:45:00',2.61),('5815','2013-05-26','14:50:00',2.61),('5815','2013-05-26','14:55:00',2.13),('5815','2013-05-26','15:00:00',1.64),('5815','2013-05-26','15:05:00',1.55),('5815','2013-05-26','15:10:00',2.46),('5815','2013-05-26','15:15:00',1.69),('5815','2013-05-26','15:20:00',1.96),('5815','2013-05-26','15:25:00',1.93),('5815','2013-05-26','15:30:00',2.11),('5815','2013-05-26','15:35:00',2.38),('5815','2013-05-26','15:40:00',1.9),('5815','2013-05-26','15:45:00',1.75),('5815','2013-05-26','15:50:00',2.19),('5815','2013-05-26','15:55:00',1.46),('5815','2013-05-26','16:00:00',1.78),('5815','2013-05-26','16:05:00',1.3),('5815','2013-05-26','16:10:00',1.52),('5815','2013-05-26','16:15:00',1.35),('5815','2013-05-26','16:20:00',2.08),('5815','2013-05-26','16:25:00',1.96),('5815','2013-05-26','16:30:00',1.84),('5815','2013-05-26','16:35:00',1.71),('5815','2013-05-26','17:10:00',1.01),('5815','2013-05-25','08:05:00',1.01),('5815','2013-05-25','08:10:00',1.02),('5815','2013-05-25','08:30:00',1.13),('5815','2013-05-25','08:35:00',1.22),('5815','2013-05-25','08:40:00',1.2),('5815','2013-05-25','08:45:00',1.11),('5815','2013-05-25','08:50:00',1.27),('5815','2013-05-25','09:00:00',1.39),('5815','2013-05-25','09:15:00',1.48),('5815','2013-05-25','09:45:00',1.15),('5815','2013-05-25','10:05:00',1.68),('5815','2013-05-25','10:10:00',2.25),('5815','2013-05-25','10:15:00',1.65),('5815','2013-05-25','10:20:00',2.02),('5815','2013-05-25','10:25:00',1.65),('5815','2013-05-25','10:30:00',1.96),('5815','2013-05-25','10:35:00',1.88),('5815','2013-05-25','10:40:00',2.3),('5815','2013-05-25','10:45:00',2.32),('5815','2013-05-25','10:50:00',2.34),('5815','2013-05-25','10:55:00',2.13),('5815','2013-05-25','11:00:00',2.25),('5815','2013-05-25','11:05:00',2.39),('5815','2013-05-25','11:10:00',2.4),('5815','2013-05-25','11:15:00',2.41),('5815','2013-05-25','11:20:00',2.44),('5815','2013-05-25','11:25:00',2.47),('5815','2013-05-25','11:30:00',2.44),('5815','2013-05-25','11:35:00',2.53),('5815','2013-05-25','11:40:00',2.57),('5815','2013-05-25','11:45:00',2.6),('5815','2013-05-25','11:50:00',2.56),('5815','2013-05-25','11:55:00',2.53),('5815','2013-05-25','12:00:00',2.53),('5815','2013-05-25','12:05:00',2.63),('5815','2013-05-25','12:10:00',2.68),('5815','2013-05-25','12:15:00',2.56),('5815','2013-05-25','12:20:00',2.22),('5815','2013-05-25','12:25:00',2.23),('5815','2013-05-25','12:30:00',2.74),('5815','2013-05-25','12:35:00',2.68),('5815','2013-05-25','12:40:00',2.44),('5815','2013-05-25','12:45:00',1.9),('5815','2013-05-25','12:50:00',2.72),('5815','2013-05-25','12:55:00',2.72),('5815','2013-05-25','13:00:00',2.74),('5815','2013-05-25','13:05:00',2.68),('5815','2013-05-25','13:10:00',2.64),('5815','2013-05-25','13:15:00',2.59),('5815','2013-05-25','13:20:00',2.61),('5815','2013-05-25','13:25:00',2.71),('5815','2013-05-25','13:30:00',2.7),('5815','2013-05-25','13:35:00',2.7),('5815','2013-05-25','13:40:00',2.69),('5815','2013-05-25','13:45:00',2.68),('5815','2013-05-25','13:50:00',2.24),('5815','2013-05-25','13:55:00',2.64),('5815','2013-05-25','14:00:00',2.61),('5815','2013-05-25','14:05:00',2.66),('5815','2013-05-25','14:10:00',2.62),('5815','2013-05-25','14:15:00',2.55),('5815','2013-05-25','14:20:00',2.56),('5815','2013-05-25','14:25:00',2.52),('5815','2013-05-25','14:30:00',2.5),('5815','2013-05-25','14:35:00',2.49),('5815','2013-05-25','14:40:00',2.49),('5815','2013-05-25','14:45:00',2.48),('5815','2013-05-25','14:50:00',2.48),('5815','2013-05-25','14:55:00',2.49),('5815','2013-05-25','15:00:00',2.42),('5815','2013-05-25','15:05:00',2.39),('5815','2013-05-25','15:10:00',2.39),('5815','2013-05-25','15:15:00',2.35),('5815','2013-05-25','15:20:00',2.33),('5815','2013-05-25','15:25:00',2.29),('5815','2013-05-25','15:30:00',2.26),('5815','2013-05-25','15:35:00',2.27),('5815','2013-05-25','15:40:00',2.28),('5815','2013-05-25','15:45:00',2.21),('5815','2013-05-25','15:50:00',2.13),('5815','2013-05-25','15:55:00',2.1),('5815','2013-05-25','16:00:00',2.08),('5815','2013-05-25','16:05:00',2.04),('5815','2013-05-25','16:10:00',2.01),('5815','2013-05-25','16:15:00',1.98),('5815','2013-05-25','16:20:00',1.94),('5815','2013-05-25','16:25:00',1.9),('5815','2013-05-25','16:30:00',1.86),('5815','2013-05-25','16:35:00',1.8),('5815','2013-05-25','16:40:00',1.73),('5815','2013-05-25','16:45:00',1.66),('5815','2013-05-25','16:50:00',1.6),('5815','2013-05-25','16:55:00',1.6),('5815','2013-05-25','17:00:00',1.56),('5815','2013-05-25','17:05:00',1.52),('5815','2013-05-25','17:10:00',1.47),('5815','2013-05-25','17:15:00',1.41),('5815','2013-05-25','17:20:00',1.35),('5815','2013-05-25','17:25:00',1.3),('5815','2013-05-25','17:30:00',1.17),('5815','2013-05-25','17:35:00',1.18),('5815','2013-05-25','17:40:00',1.14),('5815','2013-05-25','17:45:00',1.09),('5815','2013-05-25','17:50:00',1.03),('5815','2013-05-24','08:05:00',1.1),('5815','2013-05-24','08:25:00',1.17),('5815','2013-05-24','08:30:00',1.3),('5815','2013-05-24','08:55:00',1.39),('5815','2013-05-24','09:00:00',1.02),('5815','2013-05-24','09:05:00',1.58),('5815','2013-05-24','09:10:00',1.28),('5815','2013-05-24','09:15:00',1.6),('5815','2013-05-24','09:20:00',1.02),('5815','2013-05-24','09:35:00',1.24),('5815','2013-05-24','09:40:00',2.02),('5815','2013-05-24','09:45:00',1.44),('5815','2013-05-24','09:50:00',1.92),('5815','2013-05-24','09:55:00',1.31),('5815','2013-05-24','11:05:00',1.05),('5815','2013-05-24','11:10:00',2.41),('5815','2013-05-24','11:15:00',2.03),('5815','2013-05-24','11:20:00',1.58),('5815','2013-05-24','11:40:00',1.44),('5815','2013-05-24','11:45:00',1.27),('5815','2013-05-24','11:55:00',1.14),('5815','2013-05-24','12:25:00',1.12),('5815','2013-05-24','12:45:00',1.05),('5815','2013-05-24','12:55:00',1.07),('5815','2013-05-24','13:05:00',1.15),('5815','2013-05-24','13:20:00',1.49),('5815','2013-05-24','13:25:00',1.38),('5815','2013-05-24','13:30:00',1.19),('5815','2013-05-24','13:40:00',1.12),('5815','2013-05-24','13:45:00',1.25),('5815','2013-05-24','13:50:00',1.39),('5815','2013-05-24','13:55:00',1.9),('5815','2013-05-24','14:00:00',2.16),('5815','2013-05-24','14:05:00',2.65),('5815','2013-05-24','14:10:00',2.49),('5815','2013-05-24','14:15:00',2.75),('5815','2013-05-24','14:20:00',2.26),('5815','2013-05-24','14:25:00',1.03),('5815','2013-05-24','14:30:00',1.69),('5815','2013-05-24','14:35:00',1.04),('5815','2013-05-24','14:40:00',1.26),('5815','2013-05-24','14:45:00',1.23),('5815','2013-05-24','14:50:00',1.65),('5815','2013-05-24','14:55:00',1.23),('5815','2013-05-24','15:00:00',2.04),('5815','2013-05-24','15:05:00',1.92),('5815','2013-05-24','15:10:00',1.25),('5815','2013-05-24','15:15:00',1.56),('5815','2013-05-24','15:25:00',1.57),('5815','2013-05-24','15:30:00',2.08),('5815','2013-05-24','15:35:00',2.55),('5815','2013-05-24','15:40:00',2.49),('5815','2013-05-24','15:45:00',2.25),('5815','2013-05-24','15:50:00',2.22),('5815','2013-05-24','15:55:00',2.27),('5815','2013-05-24','16:00:00',1.96),('5815','2013-05-24','16:10:00',1.29),('5815','2013-05-24','16:25:00',1.07),('5815','2013-05-24','16:30:00',1.77),('5815','2013-05-24','16:35:00',1.67),('5815','2013-05-24','16:40:00',1.92),('5815','2013-05-24','16:45:00',1.4),('5815','2013-05-24','17:10:00',1.66),('5815','2013-05-24','17:15:00',1.43),('5815','2013-05-24','17:20:00',1.28),('5815','2013-05-23','08:15:00',1.01),('5815','2013-05-23','08:30:00',1.05),('5815','2013-05-23','08:45:00',1.26),('5815','2013-05-23','08:50:00',1.3),('5815','2013-05-23','08:55:00',1.36),('5815','2013-05-23','09:00:00',1.44),('5815','2013-05-23','09:05:00',1.6),('5815','2013-05-23','09:20:00',1.05),('5815','2013-05-23','09:30:00',1.65),('5815','2013-05-23','09:55:00',1.31),('5815','2013-05-23','10:00:00',1.72),('5815','2013-05-23','10:25:00',1.15),('5815','2013-05-23','10:30:00',2.14),('5815','2013-05-23','10:35:00',2.27),('5815','2013-05-23','10:40:00',2.24),('5815','2013-05-23','10:45:00',2.25),('5815','2013-05-23','10:50:00',2.21),('5815','2013-05-23','10:55:00',2.48),('5815','2013-05-23','11:00:00',2.17),('5815','2013-05-23','11:05:00',2.17),('5815','2013-05-23','11:10:00',2.07),('5815','2013-05-23','11:15:00',1.93),('5815','2013-05-23','11:20:00',2.43),('5815','2013-05-23','11:25:00',2.58),('5815','2013-05-23','11:30:00',2.06),('5815','2013-05-23','11:45:00',1.45),('5815','2013-05-23','11:50:00',2.89),('5815','2013-05-23','11:55:00',2.24),('5815','2013-05-23','12:00:00',1.09),('5815','2013-05-23','12:05:00',1.63),('5815','2013-05-23','12:10:00',2.26),('5815','2013-05-23','12:15:00',1.71),('5815','2013-05-23','12:20:00',1.18),('5815','2013-05-23','12:25:00',2.15),('5815','2013-05-23','12:30:00',2.54),('5815','2013-05-23','12:35:00',1.22),('5815','2013-05-23','12:40:00',1.57),('5815','2013-05-23','12:45:00',1.54),('5815','2013-05-23','12:50:00',1.8),('5815','2013-05-23','12:55:00',1.54),('5815','2013-05-23','13:00:00',1.37),('5815','2013-05-23','13:05:00',1.16),('5815','2013-05-23','13:10:00',1.41),('5815','2013-05-23','13:15:00',1.74),('5815','2013-05-23','13:20:00',1.9),('5815','2013-05-23','13:25:00',1.43),('5815','2013-05-23','13:30:00',1.04),('5815','2013-05-23','13:35:00',2.12),('5815','2013-05-23','13:40:00',1.59),('5815','2013-05-23','13:55:00',1.68),('5815','2013-05-23','14:00:00',1.38),('5815','2013-05-23','14:05:00',1.36),('5815','2013-05-23','14:15:00',2.44),('5815','2013-05-23','14:20:00',2.12),('5815','2013-05-23','14:25:00',1.54),('5815','2013-05-23','14:30:00',1.56),('5815','2013-05-23','14:35:00',1.71),('5815','2013-05-23','14:40:00',1.62),('5815','2013-05-23','14:45:00',1.54),('5815','2013-05-23','14:55:00',1.07),('5815','2013-05-23','15:00:00',1.24),('5815','2013-05-23','15:05:00',1.94),('5815','2013-05-23','15:10:00',1.74),('5815','2013-05-23','15:15:00',1.34),('5815','2013-05-23','15:20:00',2.77),('5815','2013-05-23','15:25:00',2.06),('5815','2013-05-23','15:30:00',1.84),('5815','2013-05-23','15:35:00',1.6),('5815','2013-05-23','15:40:00',1.85),('5815','2013-05-23','15:45:00',2.36),('5815','2013-05-23','15:50:00',2.66),('5815','2013-05-23','15:55:00',2.62),('5815','2013-05-23','16:00:00',1.35),('5815','2013-05-23','16:05:00',1.17),('5815','2013-05-23','16:10:00',1.26),('5815','2013-05-23','16:15:00',1.5),('5815','2013-05-23','16:20:00',1.19),('5815','2013-05-23','16:25:00',1.49),('5815','2013-05-23','16:30:00',1.86),('5815','2013-05-23','16:55:00',1),('5815','2013-05-22','08:35:00',1.03),('5815','2013-05-22','08:40:00',1.16),('5815','2013-05-22','08:45:00',1.24),('5815','2013-05-22','09:00:00',1.52),('5815','2013-05-22','09:05:00',1),('5815','2013-05-22','09:20:00',1.21),('5815','2013-05-22','09:25:00',1.65),('5815','2013-05-22','09:30:00',1.97),('5815','2013-05-22','09:35:00',1.26),('5815','2013-05-22','09:40:00',1.37),('5815','2013-05-22','09:50:00',1.98),('5815','2013-05-22','09:55:00',1.05),('5815','2013-05-22','10:05:00',2.07),('5815','2013-05-22','10:10:00',1.64),('5815','2013-05-22','10:15:00',2.03),('5815','2013-05-22','10:20:00',1.62),('5815','2013-05-22','10:25:00',2.1),('5815','2013-05-22','10:30:00',1.95),('5815','2013-05-22','10:35:00',2.1),('5815','2013-05-22','10:40:00',2.1),('5815','2013-05-22','10:45:00',2.45),('5815','2013-05-22','10:50:00',2.29),('5815','2013-05-22','10:55:00',1.7),('5815','2013-05-22','11:00:00',1.68),('5815','2013-05-22','11:05:00',1.64),('5815','2013-05-22','11:10:00',1.63),('5815','2013-05-22','11:15:00',1.45),('5815','2013-05-22','11:20:00',1.16),('5815','2013-05-22','11:25:00',1.46),('5815','2013-05-22','11:30:00',1.63),('5815','2013-05-22','11:35:00',2.02),('5815','2013-05-22','11:40:00',2.54),('5815','2013-05-22','11:45:00',1.99),('5815','2013-05-22','11:50:00',1.57),('5815','2013-05-22','11:55:00',2.08),('5815','2013-05-22','12:00:00',2.5),('5815','2013-05-22','12:05:00',2.61),('5815','2013-05-22','12:10:00',2.68),('5815','2013-05-22','12:15:00',2.46),('5815','2013-05-22','12:20:00',1.86),('5815','2013-05-22','12:25:00',2.27),('5815','2013-05-22','12:30:00',2.17),('5815','2013-05-22','12:35:00',1.42),('5815','2013-05-22','12:40:00',2.39),('5815','2013-05-22','12:45:00',1.9),('5815','2013-05-22','12:50:00',1.82),('5815','2013-05-22','12:55:00',2.26),('5815','2013-05-22','13:00:00',2.77),('5815','2013-05-22','13:05:00',1.63),('5815','2013-05-22','13:10:00',2.71),('5815','2013-05-22','13:15:00',2.37),('5815','2013-05-22','13:20:00',2),('5815','2013-05-22','13:25:00',2.3),('5815','2013-05-22','13:30:00',2.32),('5815','2013-05-22','13:35:00',1.29),('5815','2013-05-22','13:40:00',1.1),('5815','2013-05-22','13:45:00',2.03),('5815','2013-05-22','13:50:00',1.72),('5815','2013-05-22','13:55:00',2.32),('5815','2013-05-22','14:00:00',2.6),('5815','2013-05-22','14:05:00',2.81),('5815','2013-05-22','14:10:00',1.9),('5815','2013-05-22','14:15:00',2.53),('5815','2013-05-22','14:20:00',2.59),('5815','2013-05-22','14:25:00',1.69),('5815','2013-05-22','14:35:00',2.83),('5815','2013-05-22','14:40:00',1.97),('5815','2013-05-22','14:45:00',1.37),('5815','2013-05-22','14:50:00',1.17),('5815','2013-05-22','14:55:00',2.1),('5815','2013-05-22','15:00:00',2.26),('5815','2013-05-22','15:05:00',2.35),('5815','2013-05-22','15:20:00',2.22),('5815','2013-05-22','15:30:00',1.4),('5815','2013-05-22','15:35:00',1.8),('5815','2013-05-22','15:40:00',1.25),('5815','2013-05-22','15:45:00',1.63),('5815','2013-05-22','16:00:00',1.82),('5815','2013-05-22','16:05:00',2.24),('5815','2013-05-22','16:10:00',1.48),('5815','2013-05-22','16:15:00',1.38),('5815','2013-05-22','16:20:00',2),('5815','2013-05-22','16:25:00',1.3),('5815','2013-05-22','16:30:00',1.77),('5815','2013-05-22','16:45:00',1.14),('5815','2013-05-22','17:10:00',1.36),('5815','2013-05-22','17:15:00',1.16),('5815','2013-05-22','18:05:00',1.28),('5815','2013-05-21','08:15:00',1.03),('5815','2013-05-21','08:20:00',1.01),('5815','2013-05-21','08:30:00',1.11),('5815','2013-05-21','08:35:00',1.32),('5815','2013-05-21','09:30:00',1.44),('5815','2013-05-21','09:35:00',1.6),('5815','2013-05-21','09:40:00',1.6),('5815','2013-05-21','09:45:00',1.62),('5815','2013-05-21','09:50:00',1.66),('5815','2013-05-21','09:55:00',1.7),('5815','2013-05-21','10:00:00',1.73),('5815','2013-05-21','10:05:00',1.78),('5815','2013-05-21','10:10:00',1.82),('5815','2013-05-21','10:15:00',1.85),('5815','2013-05-21','10:20:00',1.85),('5815','2013-05-21','10:25:00',1.95),('5815','2013-05-21','10:30:00',1.95),('5815','2013-05-21','10:35:00',1.94),('5815','2013-05-21','10:40:00',2.06),('5815','2013-05-21','10:45:00',2.05),('5815','2013-05-21','10:50:00',2.04),('5815','2013-05-21','10:55:00',2.03),('5815','2013-05-21','11:00:00',2.07),('5815','2013-05-21','11:05:00',2.12),('5815','2013-05-21','11:10:00',1.99),('5815','2013-05-21','11:15:00',1.91),('5815','2013-05-21','11:20:00',2.2),('5815','2013-05-21','11:25:00',2.33),('5815','2013-05-21','11:30:00',1.99),('5815','2013-05-21','11:35:00',1.96),('5815','2013-05-21','11:40:00',1.85),('5815','2013-05-21','11:45:00',2.39),('5815','2013-05-21','11:50:00',1.46),('5815','2013-05-21','11:55:00',1.14),('5815','2013-05-21','12:00:00',1.72),('5815','2013-05-21','12:05:00',1.32),('5815','2013-05-21','12:10:00',1.25),('5815','2013-05-21','12:15:00',1.62),('5815','2013-05-21','12:20:00',2.2),('5815','2013-05-21','12:25:00',1.78),('5815','2013-05-21','12:30:00',1.33),('5815','2013-05-21','12:35:00',1.29),('5815','2013-05-21','13:05:00',2.43),('5815','2013-05-21','13:10:00',1.31),('5815','2013-05-21','13:15:00',1.27),('5815','2013-05-21','13:20:00',1.36),('5815','2013-05-21','13:30:00',1.02),('5815','2013-05-21','13:35:00',1.83),('5815','2013-05-21','13:40:00',1.97),('5815','2013-05-21','13:45:00',1.33),('5815','2013-05-21','13:50:00',1.31),('5815','2013-05-21','13:55:00',1.47),('5815','2013-05-21','14:00:00',1.45),('5815','2013-05-21','14:05:00',2.03),('5815','2013-05-21','14:10:00',2.21),('5815','2013-05-21','14:15:00',2.46),('5815','2013-05-21','14:20:00',2.37),('5815','2013-05-21','14:25:00',2.35),('5815','2013-05-21','14:30:00',2.3),('5815','2013-05-21','14:35:00',2.28),('5815','2013-05-21','14:40:00',2.28),('5815','2013-05-21','14:45:00',2.26),('5815','2013-05-21','14:50:00',2.25),('5815','2013-05-21','14:55:00',2.24),('5815','2013-05-21','15:00:00',2.21),('5815','2013-05-21','15:05:00',2.15),('5815','2013-05-21','15:10:00',2.15),('5815','2013-05-21','15:15:00',2.1),('5815','2013-05-21','15:20:00',1.98),('5815','2013-05-21','15:25:00',1.19),('5815','2013-05-21','15:30:00',1.05),('5815','2013-05-21','15:35:00',1.05),('5815','2013-05-21','15:45:00',1.4),('5815','2013-05-21','15:50:00',1.97),('5815','2013-05-21','15:55:00',1.86),('5815','2013-05-21','16:00:00',1.82),('5815','2013-05-21','16:05:00',1.79),('5815','2013-05-21','16:10:00',1.77),('5815','2013-05-21','16:15:00',1.72),('5815','2013-05-21','16:20:00',1.7),('5815','2013-05-21','16:25:00',1.66),('5815','2013-05-21','16:30:00',1.61),('5815','2013-05-21','16:35:00',1.56),('5815','2013-05-21','16:40:00',1.52),('5815','2013-05-21','16:45:00',1.25),('5815','2013-05-21','17:25:00',1.12),('5815','2013-05-20','08:25:00',1.01),('5815','2013-05-20','09:20:00',1.17),('5815','2013-05-20','09:25:00',1.35),('5815','2013-05-20','09:30:00',1.07),('5815','2013-05-20','09:35:00',1.07),('5815','2013-05-20','09:40:00',1.1),('5815','2013-05-20','09:55:00',1.04),('5815','2013-05-20','10:00:00',1.12),('5815','2013-05-20','10:05:00',1.23),('5815','2013-05-20','10:10:00',1.25),('5815','2013-05-20','10:15:00',1.27),('5815','2013-05-20','10:20:00',1.21),('5815','2013-05-20','10:25:00',1.08),('5815','2013-05-20','10:30:00',1),('5815','2013-05-20','10:35:00',1.02),('5815','2013-05-20','10:40:00',1.16),('5815','2013-05-20','10:45:00',1.69),('5815','2013-05-20','10:50:00',1.2),('5815','2013-05-20','11:00:00',1.06),('5815','2013-05-20','11:10:00',1.6),('5815','2013-05-20','11:15:00',2.3),('5815','2013-05-20','11:20:00',1.7),('5815','2013-05-20','11:25:00',2.26),('5815','2013-05-20','11:30:00',1.57),('5815','2013-05-20','11:35:00',1.43),('5815','2013-05-20','11:40:00',1.48),('5815','2013-05-20','11:45:00',2.04),('5815','2013-05-20','11:50:00',1.49),('5815','2013-05-20','11:55:00',2.11),('5815','2013-05-20','12:00:00',1.74),('5815','2013-05-20','12:05:00',2.06),('5815','2013-05-20','12:10:00',1.6),('5815','2013-05-20','12:15:00',1.76),('5815','2013-05-20','12:20:00',1.32),('5815','2013-05-20','12:25:00',1.81),('5815','2013-05-20','12:30:00',2.26),('5815','2013-05-20','12:35:00',1.35),('5815','2013-05-20','12:40:00',2.29),('5815','2013-05-20','12:45:00',2.28),('5815','2013-05-20','12:50:00',1.42),('5815','2013-05-20','12:55:00',2.52),('5815','2013-05-20','13:00:00',2.3),('5815','2013-05-20','13:05:00',2.48),('5815','2013-05-20','13:10:00',1.48),('5815','2013-05-20','13:15:00',2.12),('5815','2013-05-20','13:20:00',1.61),('5815','2013-05-20','13:25:00',1.88),('5815','2013-05-20','13:30:00',1.69),('5815','2013-05-20','14:15:00',1.12),('5815','2013-05-20','14:20:00',1),('5815','2013-05-20','14:25:00',1.32),('5815','2013-05-20','14:30:00',1.43),('5815','2013-05-20','14:35:00',1.11),('5815','2013-05-20','14:40:00',1.04),('5815','2013-05-20','15:30:00',1.28),('5815','2013-05-20','16:30:00',1.04),('5815','2013-05-20','16:35:00',1.12),('5815','2013-05-20','16:40:00',1.17),('5815','2013-05-20','16:45:00',1.1),('5815','2013-05-19','08:50:00',1.43),('5815','2013-05-19','08:55:00',1.43),('5815','2013-05-19','09:00:00',1.58),('5815','2013-05-19','09:05:00',1.41),('5815','2013-05-19','09:10:00',1.71),('5815','2013-05-19','09:15:00',1.3),('5815','2013-05-19','09:50:00',1.88),('5815','2013-05-19','10:30:00',1.51),('5815','2013-05-19','10:35:00',1.42),('5815','2013-05-19','10:55:00',1.01),('5815','2013-05-19','11:00:00',1.87),('5815','2013-05-19','11:05:00',2.43),('5815','2013-05-19','11:10:00',2.27),('5815','2013-05-19','11:15:00',2.43),('5815','2013-05-19','11:20:00',1.82),('5815','2013-05-19','11:25:00',1.98),('5815','2013-05-19','11:30:00',2.06),('5815','2013-05-19','11:35:00',1.98),('5815','2013-05-19','11:40:00',1.06),('5815','2013-05-19','11:50:00',1.03),('5815','2013-05-19','11:55:00',2.09),('5815','2013-05-19','12:00:00',1.59),('5815','2013-05-19','12:05:00',2.89),('5815','2013-05-19','12:10:00',1.95),('5815','2013-05-19','12:15:00',1.08),('5815','2013-05-19','12:20:00',1.49),('5815','2013-05-19','12:25:00',1.1),('5815','2013-05-19','12:30:00',1.11),('5815','2013-05-19','12:35:00',1.89),('5815','2013-05-19','12:40:00',1.72),('5815','2013-05-19','12:45:00',2.7),('5815','2013-05-19','12:50:00',1.37),('5815','2013-05-19','12:55:00',1.21),('5815','2013-05-19','13:00:00',1.11),('5815','2013-05-19','13:05:00',1.85),('5815','2013-05-19','13:10:00',1.21),('5815','2013-05-19','13:15:00',1.43),('5815','2013-05-19','13:20:00',2.72),('5815','2013-05-19','13:25:00',2.2),('5815','2013-05-19','13:30:00',2.12),('5815','2013-05-19','13:35:00',1.46),('5815','2013-05-19','13:40:00',1.78),('5815','2013-05-19','13:45:00',1.48),('5815','2013-05-19','13:50:00',2.81),('5815','2013-05-19','13:55:00',1.97),('5815','2013-05-19','14:00:00',2.81),('5815','2013-05-19','14:05:00',1.74),('5815','2013-05-19','14:15:00',2.62),('5815','2013-05-19','14:20:00',1.99),('5815','2013-05-19','14:25:00',1.41),('5815','2013-05-19','14:30:00',2.74),('5815','2013-05-19','14:35:00',2.01),('5815','2013-05-19','14:45:00',1.54),('5815','2013-05-19','14:50:00',2.8),('5815','2013-05-19','14:55:00',2.55),('5815','2013-05-19','15:00:00',2.16),('5815','2013-05-19','15:10:00',2.19),('5815','2013-05-19','15:15:00',2.31),('5815','2013-05-19','15:20:00',1.56),('5815','2013-05-19','15:25:00',2.54),('5815','2013-05-19','15:30:00',1.8),('5815','2013-05-19','15:35:00',2.41),('5815','2013-05-19','15:40:00',1.65),('5815','2013-05-19','15:45:00',1.31),('5815','2013-05-19','15:50:00',1.68),('5815','2013-05-19','16:00:00',1.25),('5815','2013-05-19','16:05:00',1.9),('5815','2013-05-19','16:10:00',2.03),('5815','2013-05-19','16:15:00',2.13),('5815','2013-05-19','16:20:00',1.99),('5815','2013-05-19','16:25:00',1.93),('5815','2013-05-19','16:30:00',1.88),('5815','2013-05-19','16:35:00',1.8),('5815','2013-05-19','16:40:00',1.75),('5815','2013-05-19','16:45:00',1.58),('5815','2013-05-19','16:50:00',1.56),('5815','2013-05-19','16:55:00',1.54),('5815','2013-05-19','17:00:00',1.47),('5815','2013-05-19','17:05:00',1.5),('5815','2013-05-19','17:10:00',1.11),('5815','2013-05-19','17:20:00',1.12),('5815','2013-05-19','17:25:00',1.36),('5815','2013-05-19','17:30:00',1.44),('5815','2013-05-19','17:35:00',1.19),('5815','2013-05-19','17:40:00',1.08),('5815','2013-05-19','17:45:00',1.03),('5815','2013-05-18','10:10:00',1.07),('5815','2013-05-18','10:15:00',1.61),('5815','2013-05-18','10:20:00',1.68),('5815','2013-05-18','10:25:00',1.24),('5815','2013-05-18','10:30:00',1.5),('5815','2013-05-18','10:35:00',1.32),('5815','2013-05-18','10:40:00',1.07),('5815','2013-05-18','10:45:00',1.6),('5815','2013-05-18','10:50:00',1.03),('5815','2013-05-18','10:55:00',1.16),('5815','2013-05-18','11:00:00',1.09),('5815','2013-05-18','11:05:00',1.74),('5815','2013-05-18','11:10:00',1.49),('5815','2013-05-18','11:15:00',2.03),('5815','2013-05-18','11:20:00',2.45),('5815','2013-05-18','11:25:00',2.39),('5815','2013-05-18','11:30:00',2.46),('5815','2013-05-18','11:35:00',2.47),('5815','2013-05-18','11:40:00',2.54),('5815','2013-05-18','11:45:00',2.55),('5815','2013-05-18','11:50:00',2.54),('5815','2013-05-18','11:55:00',2.57),('5815','2013-05-18','12:00:00',2.59),('5815','2013-05-18','12:05:00',2.57),('5815','2013-05-18','12:10:00',2.58),('5815','2013-05-18','12:15:00',2.61),('5815','2013-05-18','12:20:00',2.77),('5815','2013-05-18','12:25:00',2.94),('5815','2013-05-18','12:30:00',2.34),('5815','2013-05-18','12:35:00',2.84),('5815','2013-05-18','12:40:00',2.86),('5815','2013-05-18','12:45:00',2.76),('5815','2013-05-18','12:50:00',2.18),('5815','2013-05-18','12:55:00',1.71),('5815','2013-05-18','13:00:00',2.56),('5815','2013-05-18','13:05:00',2.74),('5815','2013-05-18','13:10:00',2.38),('5815','2013-05-18','13:15:00',2.28),('5815','2013-05-18','13:20:00',2.65),('5815','2013-05-18','13:25:00',2.35),('5815','2013-05-18','13:30:00',2.62),('5815','2013-05-18','13:35:00',2.61),('5815','2013-05-18','13:40:00',2.57),('5815','2013-05-18','13:45:00',2.55),('5815','2013-05-18','13:50:00',2.54),('5815','2013-05-18','13:55:00',2.57),('5815','2013-05-18','14:00:00',2.58),('5815','2013-05-18','14:05:00',2.58),('5815','2013-05-18','14:10:00',2.59),('5815','2013-05-18','14:15:00',2.56),('5815','2013-05-18','14:20:00',2.53),('5815','2013-05-18','14:25:00',2.51),('5815','2013-05-18','14:30:00',2.5),('5815','2013-05-18','14:35:00',2.47),('5815','2013-05-18','14:40:00',2.45),('5815','2013-05-18','14:45:00',2.45),('5815','2013-05-18','14:50:00',2.44),('5815','2013-05-18','14:55:00',2.43),('5815','2013-05-18','15:00:00',2.43),('5815','2013-05-18','15:05:00',2.4),('5815','2013-05-18','15:10:00',2.36),('5815','2013-05-18','15:15:00',2.32),('5815','2013-05-18','15:20:00',2.27),('5815','2013-05-18','15:25:00',2.25),('5815','2013-05-18','15:30:00',2.23),('5815','2013-05-18','15:35:00',2.25),('5815','2013-05-18','15:40:00',2.22),('5815','2013-05-18','15:45:00',2.17),('5815','2013-05-18','15:50:00',2.08),('5815','2013-05-18','15:55:00',2.08),('5815','2013-05-18','16:00:00',2.03),('5815','2013-05-18','16:05:00',1.99),('5815','2013-05-18','16:10:00',1.96),('5815','2013-05-18','16:15:00',1.91),('5815','2013-05-18','16:20:00',1.88),('5815','2013-05-18','16:25:00',1.85),('5815','2013-05-18','16:30:00',1.81),('5815','2013-05-18','16:35:00',1.77),('5815','2013-05-18','16:40:00',1.71),('5815','2013-05-18','16:45:00',1.62),('5815','2013-05-18','16:50:00',1.51),('5815','2013-05-18','16:55:00',1.59),('5815','2013-05-18','17:00:00',1.54),('5815','2013-05-18','17:05:00',1.5),('5815','2013-05-18','17:10:00',1.45),('5815','2013-05-18','17:15:00',1.39),('5815','2013-05-18','17:20:00',1.32),('5815','2013-05-18','17:25:00',1.27),('5815','2013-05-18','17:30:00',1.18),('5815','2013-05-18','17:35:00',1.12),('5815','2013-05-18','17:40:00',1.12),('5815','2013-05-18','17:45:00',1.06),('5815','2013-05-17','08:25:00',1.25),('5815','2013-05-17','08:30:00',1.16),('5815','2013-05-17','08:35:00',1.02),('5815','2013-05-17','08:40:00',1.14),('5815','2013-05-17','08:45:00',1.15),('5815','2013-05-17','08:50:00',1.2),('5815','2013-05-17','08:55:00',1.25),('5815','2013-05-17','09:00:00',1.3),('5815','2013-05-17','09:05:00',1.33),('5815','2013-05-17','09:10:00',1.42),('5815','2013-05-17','09:15:00',1.46),('5815','2013-05-17','09:20:00',1.49),('5815','2013-05-17','09:25:00',1.54),('5815','2013-05-17','09:30:00',1.55),('5815','2013-05-17','09:35:00',1.62),('5815','2013-05-17','09:40:00',1.66),('5815','2013-05-17','09:45:00',1.7),('5815','2013-05-17','09:50:00',1.73),('5815','2013-05-17','09:55:00',1.78),('5815','2013-05-17','10:00:00',1.82),('5815','2013-05-17','10:05:00',1.84),('5815','2013-05-17','10:10:00',1.88),('5815','2013-05-17','10:15:00',1.9),('5815','2013-05-17','10:20:00',1.94),('5815','2013-05-17','10:25:00',1.97),('5815','2013-05-17','10:30:00',1.99),('5815','2013-05-17','10:35:00',2),('5815','2013-05-17','10:40:00',2.04),('5815','2013-05-17','10:45:00',2.06),('5815','2013-05-17','10:50:00',2.09),('5815','2013-05-17','10:55:00',2.01),('5815','2013-05-17','11:00:00',2.15),('5815','2013-05-17','11:05:00',2.11),('5815','2013-05-17','11:10:00',1.77),('5815','2013-05-17','11:15:00',2.34),('5815','2013-05-17','11:20:00',2.26),('5815','2013-05-17','11:25:00',2.31),('5815','2013-05-17','11:30:00',2.3),('5815','2013-05-17','11:35:00',2.14),('5815','2013-05-17','11:40:00',2.26),('5815','2013-05-17','11:45:00',2.13),('5815','2013-05-17','11:50:00',2.14),('5815','2013-05-17','11:55:00',2.25),('5815','2013-05-17','12:00:00',2.26),('5815','2013-05-17','12:05:00',2.22),('5815','2013-05-17','12:10:00',2.26),('5815','2013-05-17','12:15:00',2.24),('5815','2013-05-17','12:20:00',2.31),('5815','2013-05-17','12:25:00',2.37),('5815','2013-05-17','12:30:00',1.91),('5815','2013-05-17','12:35:00',2.39),('5815','2013-05-17','12:40:00',2.36),('5815','2013-05-17','12:45:00',2.29),('5815','2013-05-17','12:50:00',2.31),('5815','2013-05-17','12:55:00',2.33),('5815','2013-05-17','13:00:00',2.34),('5815','2013-05-17','13:05:00',2.3),('5815','2013-05-17','13:10:00',2.36),('5815','2013-05-17','13:15:00',2.37),('5815','2013-05-17','13:20:00',2.37),('5815','2013-05-17','13:25:00',2.37),('5815','2013-05-17','13:30:00',2.4),('5815','2013-05-17','13:35:00',2.11),('5815','2013-05-17','13:40:00',2.32),('5815','2013-05-17','13:45:00',2.48),('5815','2013-05-17','13:50:00',2.19),('5815','2013-05-17','13:55:00',2.02),('5815','2013-05-17','14:00:00',1.66),('5815','2013-05-17','14:05:00',1.75),('5815','2013-05-17','14:10:00',2.56),('5815','2013-05-17','14:15:00',2.43),('5815','2013-05-17','14:20:00',2.4),('5815','2013-05-17','14:25:00',2.34),('5815','2013-05-17','14:30:00',2.34),('5815','2013-05-17','14:35:00',2.23),('5815','2013-05-17','14:40:00',2.42),('5815','2013-05-17','14:45:00',2.27),('5815','2013-05-17','14:50:00',2.08),('5815','2013-05-17','14:55:00',1.87),('5815','2013-05-17','15:00:00',2.1),('5815','2013-05-17','15:05:00',2.08),('5815','2013-05-17','15:10:00',2.04),('5815','2013-05-17','15:15:00',2),('5815','2013-05-17','15:20:00',1.97),('5815','2013-05-17','15:25:00',1.95),('5815','2013-05-17','15:30:00',1.92),('5815','2013-05-17','15:35:00',1.9),('5815','2013-05-17','15:40:00',1.87),('5815','2013-05-17','15:45:00',1.84),('5815','2013-05-17','15:50:00',1.79),('5815','2013-05-17','15:55:00',1.75),('5815','2013-05-17','16:00:00',1.72),('5815','2013-05-17','16:05:00',1.69),('5815','2013-05-17','16:10:00',1.65),('5815','2013-05-17','16:15:00',1.63),('5815','2013-05-17','16:20:00',1.58),('5815','2013-05-17','16:25:00',1.52),('5815','2013-05-17','16:30:00',1.48),('5815','2013-05-17','16:35:00',1.44),('5815','2013-05-17','16:40:00',1.41),('5815','2013-05-17','16:45:00',1.39),('5815','2013-05-17','16:50:00',1.32),('5815','2013-05-17','16:55:00',1.28),('5815','2013-05-17','17:00:00',1.25),('5815','2013-05-17','17:05:00',1.22),('5815','2013-05-17','17:10:00',1.16),('5815','2013-05-17','17:15:00',1.12),('5815','2013-05-17','17:20:00',1.11),('5815','2013-05-17','17:25:00',1.07),('5815','2013-05-17','17:30:00',1.02),('5815','2013-05-16','08:20:00',1.16),('5815','2013-05-16','10:50:00',1.62),('5815','2013-05-16','10:55:00',2.02),('5815','2013-05-16','11:00:00',1.28),('5815','2013-05-16','11:05:00',1.23),('5815','2013-05-16','11:15:00',1.38),('5815','2013-05-16','11:20:00',1.22),('5815','2013-05-16','11:30:00',1.04),('5815','2013-05-16','11:35:00',1.42),('5815','2013-05-16','11:50:00',1.48),('5815','2013-05-16','11:55:00',1.39),('5815','2013-05-16','12:00:00',1.29),('5815','2013-05-16','12:05:00',1.43),('5815','2013-05-16','12:10:00',1.82),('5815','2013-05-16','12:15:00',1.34),('5815','2013-05-16','12:20:00',1.39),('5815','2013-05-16','12:25:00',1.56),('5815','2013-05-16','12:30:00',1.37),('5815','2013-05-16','12:35:00',1.75),('5815','2013-05-16','12:40:00',2.13),('5815','2013-05-16','12:45:00',2.51),('5815','2013-05-16','12:50:00',2.62),('5815','2013-05-16','12:55:00',2.54),('5815','2013-05-16','13:00:00',2.06),('5815','2013-05-16','13:05:00',2.49),('5815','2013-05-16','13:10:00',1.83),('5815','2013-05-16','13:15:00',2.08),('5815','2013-05-16','13:20:00',2.77),('5815','2013-05-16','13:25:00',2.66),('5815','2013-05-16','13:30:00',1.92),('5815','2013-05-16','13:35:00',2.67),('5815','2013-05-16','13:40:00',2.09),('5815','2013-05-16','13:45:00',2.56),('5815','2013-05-16','13:50:00',2.44),('5815','2013-05-16','13:55:00',2.69),('5815','2013-05-16','14:00:00',1.94),('5815','2013-05-16','14:05:00',1.27),('5815','2013-05-16','14:10:00',2.54),('5815','2013-05-16','14:15:00',2.49),('5815','2013-05-16','14:20:00',2.7),('5815','2013-05-16','14:25:00',2.25),('5815','2013-05-16','14:30:00',2.39),('5815','2013-05-16','14:35:00',2.22),('5815','2013-05-16','14:40:00',1.59),('5815','2013-05-16','14:45:00',1.74),('5815','2013-05-16','14:50:00',1.82),('5815','2013-05-16','14:55:00',1.24),('5815','2013-05-16','15:00:00',2.24),('5815','2013-05-16','15:05:00',1.68),('5815','2013-05-16','15:10:00',1.07),('5815','2013-05-16','15:15:00',1.42),('5815','2013-05-16','15:20:00',1.64),('5815','2013-05-16','15:25:00',1.98),('5815','2013-05-16','15:30:00',1.1),('5815','2013-05-16','15:35:00',1.67),('5815','2013-05-16','15:40:00',2.37),('5815','2013-05-16','15:50:00',1.64),('5815','2013-05-16','15:55:00',1.82),('5815','2013-05-16','16:00:00',2.02),('5815','2013-05-16','16:05:00',1.17),('5815','2013-05-16','16:15:00',1.63),('5815','2013-05-16','16:20:00',1.93),('5815','2013-05-16','16:25:00',1.84),('5815','2013-05-16','16:30:00',1.98),('5815','2013-05-16','16:35:00',1.85),('5815','2013-05-16','16:40:00',1.79),('5815','2013-05-16','16:45:00',1.75),('5815','2013-05-16','16:50:00',1.5),('5815','2013-05-16','16:55:00',1.38),('5815','2013-05-16','17:00:00',1.45),('5815','2013-05-16','17:05:00',1.44),('5815','2013-05-16','17:10:00',1.39),('5815','2013-05-16','17:15:00',1.32),('5815','2013-05-16','17:20:00',1.27),('5815','2013-05-16','17:25:00',1.23),('5815','2013-05-16','17:30:00',1.21),('5815','2013-05-16','17:35:00',1.16),('5815','2013-05-16','17:40:00',1.09),('5815','2013-05-16','17:45:00',1.03),('5815','2013-05-15','09:40:00',1.14),('5815','2013-05-15','09:45:00',1.39),('5815','2013-05-15','10:20:00',1.13),('5815','2013-05-15','10:25:00',1.2),('5815','2013-05-15','10:30:00',1.05),('5815','2013-05-15','11:00:00',2.16),('5815','2013-05-15','11:05:00',2),('5815','2013-05-15','11:10:00',1.65),('5815','2013-05-15','11:15:00',1.13),('5815','2013-05-15','11:35:00',1.76),('5815','2013-05-15','11:40:00',2.28),('5815','2013-05-15','11:45:00',2.25),('5815','2013-05-15','11:50:00',2.16),('5815','2013-05-15','11:55:00',1.43),('5815','2013-05-15','12:15:00',1.54),('5815','2013-05-15','12:20:00',1.09),('5815','2013-05-15','12:25:00',1.25),('5815','2013-05-15','12:30:00',1.72),('5815','2013-05-15','12:35:00',1.91),('5815','2013-05-15','12:40:00',2.21),('5815','2013-05-15','12:45:00',2.08),('5815','2013-05-15','12:50:00',1.56),('5815','2013-05-15','12:55:00',2.42),('5815','2013-05-15','13:00:00',2.35),('5815','2013-05-15','13:05:00',2.18),('5815','2013-05-15','13:10:00',2.33),('5815','2013-05-15','13:15:00',1.94),('5815','2013-05-15','13:20:00',1.91),('5815','2013-05-15','13:25:00',2.4),('5815','2013-05-15','13:30:00',2.34),('5815','2013-05-15','13:35:00',2.33),('5815','2013-05-15','13:40:00',2.28),('5815','2013-05-15','13:45:00',2.28),('5815','2013-05-15','13:50:00',2.28),('5815','2013-05-15','13:55:00',2.29),('5815','2013-05-15','14:00:00',2.28),('5815','2013-05-15','14:05:00',2.28),('5815','2013-05-15','14:10:00',2.27),('5815','2013-05-15','14:15:00',2.23),('5815','2013-05-15','14:20:00',2.23),('5815','2013-05-15','14:25:00',2.15),('5815','2013-05-15','14:30:00',2.15),('5815','2013-05-15','14:35:00',2.12),('5815','2013-05-15','14:40:00',2.12),('5815','2013-05-15','14:45:00',2.11),('5815','2013-05-15','14:50:00',1.99),('5815','2013-05-15','14:55:00',1.68),('5815','2013-05-15','15:00:00',2.03),('5815','2013-05-15','15:05:00',2.05),('5815','2013-05-15','15:10:00',2.03),('5815','2013-05-15','15:15:00',1.82),('5815','2013-05-15','15:20:00',1.88),('5815','2013-05-15','15:25:00',1.93),('5815','2013-05-15','15:30:00',1.88),('5815','2013-05-15','15:35:00',1.83),('5815','2013-05-15','15:40:00',1.87),('5815','2013-05-15','15:45:00',1.82),('5815','2013-05-15','15:50:00',1.81),('5815','2013-05-15','15:55:00',1.78),('5815','2013-05-15','16:00:00',1.75),('5815','2013-05-15','16:05:00',1.67),('5815','2013-05-15','16:10:00',1.66),('5815','2013-05-15','16:15:00',1.56),('5815','2013-05-15','16:20:00',1.62),('5815','2013-05-15','16:25:00',1.55),('5815','2013-05-15','16:30:00',1.55),('5815','2013-05-15','16:35:00',1.5),('5815','2013-05-15','16:50:00',1.06),('5815','2013-05-14','08:35:00',1.03),('5815','2013-05-14','08:40:00',1.09),('5815','2013-05-14','08:45:00',1.14),('5815','2013-05-14','08:50:00',1.2),('5815','2013-05-14','08:55:00',1.26),('5815','2013-05-14','09:00:00',1.22),('5815','2013-05-14','09:05:00',1.32),('5815','2013-05-14','09:10:00',1.33),('5815','2013-05-14','09:15:00',1.37),('5815','2013-05-14','09:20:00',1.39),('5815','2013-05-14','09:25:00',1.44),('5815','2013-05-14','09:30:00',1.53),('5815','2013-05-14','09:35:00',1.58),('5815','2013-05-14','09:40:00',1.58),('5815','2013-05-14','09:45:00',1.64),('5815','2013-05-14','09:50:00',1.7),('5815','2013-05-14','09:55:00',1.71),('5815','2013-05-14','10:00:00',1.77),('5815','2013-05-14','10:05:00',1.82),('5815','2013-05-14','10:10:00',1.83),('5815','2013-05-14','10:15:00',1.82),('5815','2013-05-14','10:20:00',1.91),('5815','2013-05-14','10:25:00',1.95),('5815','2013-05-14','10:30:00',1.9),('5815','2013-05-14','10:35:00',1.95),('5815','2013-05-14','10:40:00',2),('5815','2013-05-14','10:45:00',2.05),('5815','2013-05-14','10:50:00',2.05),('5815','2013-05-14','10:55:00',1.96),('5815','2013-05-14','11:00:00',1.91),('5815','2013-05-14','11:05:00',1.98),('5815','2013-05-14','11:10:00',2.07),('5815','2013-05-14','11:15:00',2.11),('5815','2013-05-14','11:20:00',2.04),('5815','2013-05-14','11:25:00',2.12),('5815','2013-05-14','11:30:00',2.14),('5815','2013-05-14','11:35:00',2.16),('5815','2013-05-14','11:40:00',1.94),('5815','2013-05-14','11:45:00',1.78),('5815','2013-05-14','11:50:00',1.5),('5815','2013-05-14','11:55:00',1.13),('5815','2013-05-14','12:00:00',1.24),('5815','2013-05-14','12:05:00',1.82),('5815','2013-05-14','12:10:00',2.43),('5815','2013-05-14','12:15:00',2.69),('5815','2013-05-14','12:20:00',1.59),('5815','2013-05-14','12:25:00',2.06),('5815','2013-05-14','12:30:00',1.53),('5815','2013-05-14','12:35:00',1.64),('5815','2013-05-14','12:40:00',2.69),('5815','2013-05-14','12:45:00',1.42),('5815','2013-05-14','12:50:00',1.39),('5815','2013-05-14','12:55:00',1.53),('5815','2013-05-14','13:00:00',1.58),('5815','2013-05-14','13:05:00',1.85),('5815','2013-05-14','13:10:00',1.64),('5815','2013-05-14','13:15:00',1.32),('5815','2013-05-14','13:20:00',1.51),('5815','2013-05-14','13:25:00',1.49),('5815','2013-05-14','13:30:00',1.52),('5815','2013-05-14','13:35:00',1.36),('5815','2013-05-14','13:40:00',1.39),('5815','2013-05-14','13:45:00',1.45),('5815','2013-05-14','13:50:00',1.18),('5815','2013-05-14','13:55:00',1.16),('5815','2013-05-14','14:00:00',1.01),('5815','2013-05-14','15:55:00',1.05),('5815','2013-05-14','16:00:00',1.06),('5815','2013-05-14','17:05:00',1.11),('5815','2013-05-14','17:10:00',1.13),('5815','2013-05-14','17:15:00',1.57),('5815','2013-05-14','17:20:00',1.01),('5815','2013-05-13','08:30:00',1.04),('5815','2013-05-13','08:35:00',1.1),('5815','2013-05-13','08:40:00',1.15),('5815','2013-05-13','08:45:00',1.2),('5815','2013-05-13','08:50:00',1.25),('5815','2013-05-13','08:55:00',1.31),('5815','2013-05-13','09:00:00',1.36),('5815','2013-05-13','09:05:00',1.41),('5815','2013-05-13','09:10:00',1.46),('5815','2013-05-13','09:15:00',1.5),('5815','2013-05-13','09:20:00',1.54),('5815','2013-05-13','09:25:00',1.59),('5815','2013-05-13','09:30:00',1.63),('5815','2013-05-13','09:35:00',1.67),('5815','2013-05-13','09:40:00',1.7),('5815','2013-05-13','09:45:00',1.75),('5815','2013-05-13','09:50:00',1.8),('5815','2013-05-13','09:55:00',1.82),('5815','2013-05-13','10:00:00',1.86),('5815','2013-05-13','10:05:00',1.89),('5815','2013-05-13','10:10:00',1.93),('5815','2013-05-13','10:15:00',1.97),('5815','2013-05-13','10:20:00',1.99),('5815','2013-05-13','10:25:00',2.01),('5815','2013-05-13','10:30:00',2.04),('5815','2013-05-13','10:35:00',2.07),('5815','2013-05-13','10:40:00',2.1),('5815','2013-05-13','10:45:00',2.12),('5815','2013-05-13','10:50:00',2.11),('5815','2013-05-13','10:55:00',2.11),('5815','2013-05-13','11:00:00',2.04),('5815','2013-05-13','11:05:00',2.08),('5815','2013-05-13','11:10:00',2.17),('5815','2013-05-13','11:15:00',2.18),('5815','2013-05-13','11:20:00',2.2),('5815','2013-05-13','11:25:00',2.21),('5815','2013-05-13','11:30:00',2.23),('5815','2013-05-13','11:35:00',2.24),('5815','2013-05-13','11:40:00',2.24),('5815','2013-05-13','11:45:00',2.23),('5815','2013-05-13','11:50:00',2.26),('5815','2013-05-13','11:55:00',2.29),('5815','2013-05-13','12:00:00',2.3),('5815','2013-05-13','12:05:00',2.31),('5815','2013-05-13','12:10:00',2.34),('5815','2013-05-13','12:15:00',2.35),('5815','2013-05-13','12:20:00',2.37),('5815','2013-05-13','12:25:00',2.42),('5815','2013-05-13','12:30:00',2.41),('5815','2013-05-13','12:35:00',2.4),('5815','2013-05-13','12:40:00',2.38),('5815','2013-05-13','12:45:00',2.41),('5815','2013-05-13','12:50:00',2.42),('5815','2013-05-13','12:55:00',2.44),('5815','2013-05-13','13:00:00',2.43),('5815','2013-05-13','13:05:00',2.43),('5815','2013-05-13','13:10:00',2.46),('5815','2013-05-13','13:15:00',2.46),('5815','2013-05-13','13:20:00',2.45),('5815','2013-05-13','13:25:00',2.44),('5815','2013-05-13','13:30:00',2.46),('5815','2013-05-13','13:35:00',2.45),('5815','2013-05-13','13:40:00',2.46),('5815','2013-05-13','13:45:00',2.42),('5815','2013-05-13','13:50:00',2.41),('5815','2013-05-13','13:55:00',2.38),('5815','2013-05-13','14:00:00',2.37),('5815','2013-05-13','14:05:00',2.38),('5815','2013-05-13','14:10:00',2.37),('5815','2013-05-13','14:15:00',2.36),('5815','2013-05-13','14:20:00',2.35),('5815','2013-05-13','14:25:00',2.32),('5815','2013-05-13','14:30:00',2.3),('5815','2013-05-13','14:35:00',2.28),('5815','2013-05-13','14:40:00',2.26),('5815','2013-05-13','14:45:00',2.27),('5815','2013-05-13','14:50:00',2.3),('5815','2013-05-13','14:55:00',2.33),('5815','2013-05-13','15:00:00',2.32),('5815','2013-05-13','15:05:00',2.31),('5815','2013-05-13','15:10:00',2.29),('5815','2013-05-13','15:15:00',2.26),('5815','2013-05-13','15:20:00',2.22),('5815','2013-05-13','15:25:00',2.19),('5815','2013-05-13','15:30:00',2.2),('5815','2013-05-13','15:35:00',2.17),('5815','2013-05-13','15:40:00',2.14),('5815','2013-05-13','15:45:00',2.1),('5815','2013-05-13','15:50:00',2.06),('5815','2013-05-13','15:55:00',2),('5815','2013-05-13','16:00:00',1.94),('5815','2013-05-13','16:05:00',1.89),('5815','2013-05-13','16:10:00',1.89),('5815','2013-05-13','16:15:00',1.85),('5815','2013-05-13','16:20:00',1.79),('5815','2013-05-13','16:25:00',1.78),('5815','2013-05-13','16:30:00',1.74),('5815','2013-05-13','16:35:00',1.69),('5815','2013-05-13','16:40:00',1.64),('5815','2013-05-13','16:45:00',1.54),('5815','2013-05-13','16:50:00',1.55),('5815','2013-05-13','16:55:00',1.51),('5815','2013-05-13','17:00:00',1.46),('5815','2013-05-13','17:05:00',1.41),('5815','2013-05-13','17:10:00',1.37),('5815','2013-05-13','17:15:00',1.3),('5815','2013-05-13','17:20:00',1.2),('5815','2013-05-13','17:25:00',1.2),('5815','2013-05-13','17:30:00',1.15),('5815','2013-05-13','17:35:00',1.12),('5815','2013-05-13','17:40:00',1.04),('5815','2013-05-12','08:35:00',1.01),('5815','2013-05-12','08:40:00',1.06),('5815','2013-05-12','08:45:00',1.11),('5815','2013-05-12','08:50:00',1.17),('5815','2013-05-12','08:55:00',1.21),('5815','2013-05-12','09:00:00',1.25),('5815','2013-05-12','09:05:00',1.32),('5815','2013-05-12','09:10:00',1.37),('5815','2013-05-12','09:15:00',1.4),('5815','2013-05-12','09:20:00',1.43),('5815','2013-05-12','09:25:00',1.5),('5815','2013-05-12','09:30:00',1.54),('5815','2013-05-12','09:35:00',1.57),('5815','2013-05-12','09:40:00',1.62),('5815','2013-05-12','09:45:00',1.69),('5815','2013-05-12','09:50:00',1.73),('5815','2013-05-12','09:55:00',1.82),('5815','2013-05-12','10:00:00',1.79),('5815','2013-05-12','10:05:00',1.24),('5815','2013-05-12','10:10:00',1.81),('5815','2013-05-12','10:15:00',2.04),('5815','2013-05-12','10:20:00',1.4),('5815','2013-05-12','10:25:00',1.51),('5815','2013-05-12','10:30:00',2.11),('5815','2013-05-12','10:45:00',2.15),('5815','2013-05-12','10:50:00',2.38),('5815','2013-05-12','10:55:00',1.49),('5815','2013-05-12','11:00:00',1.48),('5815','2013-05-12','11:05:00',1.21),('5815','2013-05-12','11:15:00',1.26),('5815','2013-05-12','11:30:00',1.15),('5815','2013-05-12','11:35:00',1.92),('5815','2013-05-12','11:40:00',1.29),('5815','2013-05-12','11:45:00',1.51),('5815','2013-05-12','11:55:00',1),('5815','2013-05-12','12:10:00',1.84),('5815','2013-05-12','12:15:00',1.37),('5815','2013-05-12','12:25:00',1.45),('5815','2013-05-12','12:30:00',2.48),('5815','2013-05-12','12:35:00',1.71),('5815','2013-05-12','12:40:00',1.1),('5815','2013-05-12','12:45:00',1.17),('5815','2013-05-12','12:50:00',2.08),('5815','2013-05-12','12:55:00',2.75),('5815','2013-05-12','13:00:00',2.42),('5815','2013-05-12','13:05:00',2.46),('5815','2013-05-12','13:10:00',2.64),('5815','2013-05-12','13:15:00',2.77),('5815','2013-05-12','13:20:00',2.55),('5815','2013-05-12','13:25:00',2.7),('5815','2013-05-12','13:30:00',2.73),('5815','2013-05-12','13:35:00',2.42),('5815','2013-05-12','13:40:00',1.35),('5815','2013-05-12','13:45:00',1.25),('5815','2013-05-12','14:05:00',2.81),('5815','2013-05-12','14:10:00',2.76),('5815','2013-05-12','14:15:00',2.64),('5815','2013-05-12','14:20:00',2.52),('5815','2013-05-12','14:25:00',1.73),('5815','2013-05-12','14:30:00',1.36),('5815','2013-05-12','14:35:00',2.54),('5815','2013-05-12','14:40:00',2.54),('5815','2013-05-12','14:45:00',1.03),('5815','2013-05-12','14:50:00',1.49),('5815','2013-05-12','14:55:00',2.6),('5815','2013-05-12','15:00:00',2.01),('5815','2013-05-12','15:05:00',1.18),('5815','2013-05-12','16:30:00',1.16),('5815','2013-05-12','16:40:00',1.29),('5815','2013-05-12','16:45:00',1.53),('5815','2013-05-12','16:50:00',1.97),('5815','2013-05-12','16:55:00',1.78),('5815','2013-05-12','17:00:00',1.65),('5815','2013-05-12','17:05:00',1.35),('5815','2013-05-12','17:10:00',1.14),('5815','2013-05-12','17:15:00',1.67),('5815','2013-05-12','17:20:00',1.66),('5815','2013-05-12','17:25:00',1.38),('5815','2013-05-12','17:30:00',1.05),('5815','2013-05-12','17:35:00',1.31),('5815','2013-05-12','17:40:00',1.19),('5815','2013-05-12','17:45:00',1.16),('5815','2013-05-12','17:50:00',1.03),('5815','2013-05-11','08:15:00',1.04),('5815','2013-05-11','09:30:00',1.45),('5815','2013-05-11','09:45:00',1.24),('5815','2013-05-11','09:50:00',1.63),('5815','2013-05-11','09:55:00',1.81),('5815','2013-05-11','10:00:00',1.93),('5815','2013-05-11','10:05:00',1.46),('5815','2013-05-11','10:15:00',1.43),('5815','2013-05-11','10:45:00',1.93),('5815','2013-05-11','10:50:00',1.35),('5815','2013-05-11','10:55:00',2.51),('5815','2013-05-11','11:00:00',2.32),('5815','2013-05-11','11:15:00',2.19),('5815','2013-05-11','11:20:00',2.5),('5815','2013-05-11','11:25:00',2.51),('5815','2013-05-11','11:30:00',2.64),('5815','2013-05-11','11:35:00',2.52),('5815','2013-05-11','11:40:00',2.53),('5815','2013-05-11','11:45:00',2.67),('5815','2013-05-11','11:50:00',1.49),('5815','2013-05-11','11:55:00',2.69),('5815','2013-05-11','12:00:00',2.08),('5815','2013-05-11','12:05:00',2.08),('5815','2013-05-11','12:10:00',2.26),('5815','2013-05-11','12:15:00',1.36),('5815','2013-05-11','12:40:00',1.18),('5815','2013-05-11','12:45:00',1.48),('5815','2013-05-11','12:50:00',2.9),('5815','2013-05-11','12:55:00',2.03),('5815','2013-05-11','13:00:00',2.29),('5815','2013-05-11','13:10:00',1.82),('5815','2013-05-11','13:15:00',2.5),('5815','2013-05-11','13:20:00',1.08),('5815','2013-05-11','13:25:00',1.21),('5815','2013-05-11','13:30:00',1.97),('5815','2013-05-11','13:35:00',2.65),('5815','2013-05-11','13:40:00',2.74),('5815','2013-05-11','13:45:00',2.12),('5815','2013-05-11','13:50:00',2.42),('5815','2013-05-11','13:55:00',2.38),('5815','2013-05-11','14:00:00',1.61),('5815','2013-05-11','14:05:00',2.88),('5815','2013-05-11','14:10:00',2.01),('5815','2013-05-11','14:15:00',2.28),('5815','2013-05-11','14:20:00',2.73),('5815','2013-05-11','14:25:00',2.65),('5815','2013-05-11','14:30:00',2.61),('5815','2013-05-11','14:35:00',2.59),('5815','2013-05-11','14:40:00',2.55),('5815','2013-05-11','14:45:00',2.47),('5815','2013-05-11','14:50:00',2.5),('5815','2013-05-11','14:55:00',2.49),('5815','2013-05-11','15:00:00',2.11),('5815','2013-05-11','15:05:00',2.46),('5815','2013-05-11','15:10:00',2.35),('5815','2013-05-11','15:15:00',1.93),('5815','2013-05-11','15:20:00',2.08),('5815','2013-05-11','15:25:00',2.33),('5815','2013-05-11','15:30:00',2.2),('5815','2013-05-11','15:35:00',2.21),('5815','2013-05-11','15:40:00',2.18),('5815','2013-05-11','15:45:00',2.14),('5815','2013-05-11','15:50:00',2.08),('5815','2013-05-11','15:55:00',2.01),('5815','2013-05-11','16:00:00',1.96),('5815','2013-05-11','16:05:00',1.77),('5815','2013-05-11','16:10:00',1.86),('5815','2013-05-11','16:15:00',1.86),('5815','2013-05-11','16:20:00',1.8),('5815','2013-05-11','16:25:00',1.72),('5815','2013-05-11','16:30:00',1.68),('5815','2013-05-11','16:35:00',1.67),('5815','2013-05-11','16:40:00',1.7),('5815','2013-05-11','16:45:00',1.77),('5815','2013-05-11','16:50:00',1.75),('5815','2013-05-11','16:55:00',1.56),('5815','2013-05-11','17:00:00',1.87),('5815','2013-05-11','17:05:00',1.61),('5815','2013-05-11','17:10:00',1.59),('5815','2013-05-11','17:15:00',1.73),('5815','2013-05-11','17:20:00',1.5),('5815','2013-05-11','17:25:00',1.27),('5815','2013-05-11','17:30:00',1.27),('5815','2013-05-11','17:35:00',1.06),('5815','2013-05-10','09:30:00',1.3),('5815','2013-05-10','09:40:00',1),('5815','2013-05-10','09:45:00',1.22),('5815','2013-05-10','10:55:00',1.43),('5815','2013-05-10','11:00:00',2.23),('5815','2013-05-10','11:05:00',1.81),('5815','2013-05-10','11:35:00',1.45),('5815','2013-05-10','11:40:00',1.18),('5815','2013-05-10','11:45:00',1.84),('5815','2013-05-10','11:50:00',1.83),('5815','2013-05-10','12:05:00',1.04),('5815','2013-05-10','12:25:00',2.89),('5815','2013-05-10','12:30:00',2.05),('5815','2013-05-10','12:35:00',1.32),('5815','2013-05-10','12:40:00',1.08),('5815','2013-05-10','12:45:00',1.13),('5815','2013-05-10','12:50:00',1.01),('5815','2013-05-10','14:00:00',1.21),('5815','2013-05-10','14:05:00',1.6),('5815','2013-05-10','14:10:00',1.87),('5815','2013-05-10','14:15:00',1.24),('5815','2013-05-10','14:20:00',2.43),('5815','2013-05-10','14:25:00',2.17),('5815','2013-05-10','14:30:00',1.92),('5815','2013-05-10','14:35:00',1.65),('5815','2013-05-10','14:40:00',1.68),('5815','2013-05-10','14:45:00',2),('5815','2013-05-10','14:50:00',2.58),('5815','2013-05-10','14:55:00',2.56),('5815','2013-05-10','15:00:00',2.44),('5815','2013-05-10','15:05:00',2.34),('5815','2013-05-10','15:10:00',2.35),('5815','2013-05-10','15:15:00',2.4),('5815','2013-05-10','15:20:00',2.39),('5815','2013-05-10','15:25:00',2.31),('5815','2013-05-10','15:30:00',2.27),('5815','2013-05-10','15:35:00',2.22),('5815','2013-05-10','15:40:00',2.23),('5815','2013-05-10','15:45:00',2.22),('5815','2013-05-10','15:50:00',1.7),('5815','2013-05-10','15:55:00',2.14),('5815','2013-05-10','16:00:00',1.84),('5815','2013-05-10','16:05:00',2.01),('5815','2013-05-10','16:10:00',2),('5815','2013-05-10','16:15:00',1.23),('5815','2013-05-10','16:20:00',1.97),('5815','2013-05-10','16:25:00',1.89),('5815','2013-05-10','16:30:00',1.75),('5815','2013-05-10','16:35:00',1.57),('5815','2013-05-10','16:40:00',1.65),('5815','2013-05-10','16:45:00',1.64),('5815','2013-05-10','16:50:00',1.34),('5815','2013-05-10','16:55:00',1.41),('5815','2013-05-10','17:00:00',1.45),('5815','2013-05-10','17:05:00',1.46),('5815','2013-05-10','17:10:00',1.37),('5815','2013-05-10','17:15:00',1.28),('5815','2013-05-10','17:20:00',1.15),('5815','2013-05-10','17:25:00',1.32),('5815','2013-05-10','17:30:00',1.06),('5815','2013-05-10','17:35:00',1.05),('5815','2013-05-10','17:45:00',1.06),('5815','2013-05-09','08:10:00',1),('5815','2013-05-09','08:15:00',1.06),('5815','2013-05-09','08:20:00',1),('5815','2013-05-09','08:30:00',1),('5815','2013-05-09','08:35:00',1.01),('5815','2013-05-09','09:05:00',1.23),('5815','2013-05-09','09:10:00',1.41),('5815','2013-05-09','09:15:00',1.48),('5815','2013-05-09','09:20:00',1.44),('5815','2013-05-09','09:25:00',1.27),('5815','2013-05-09','09:30:00',1.29),('5815','2013-05-09','09:35:00',1.59),('5815','2013-05-09','09:40:00',1.55),('5815','2013-05-09','09:45:00',1.43),('5815','2013-05-09','09:50:00',1.48),('5815','2013-05-09','09:55:00',1.7),('5815','2013-05-09','10:00:00',1.38),('5815','2013-05-09','10:05:00',1.65),('5815','2013-05-09','10:10:00',1.68),('5815','2013-05-09','10:15:00',1.83),('5815','2013-05-09','10:20:00',1.01),('5815','2013-05-09','10:25:00',1.41),('5815','2013-05-09','10:30:00',1.61),('5815','2013-05-09','10:40:00',1.75),('5815','2013-05-09','10:45:00',2.26),('5815','2013-05-09','10:50:00',2.31),('5815','2013-05-09','10:55:00',2.18),('5815','2013-05-09','11:00:00',2.06),('5815','2013-05-09','11:05:00',2.21),('5815','2013-05-09','11:10:00',2.19),('5815','2013-05-09','11:15:00',2),('5815','2013-05-09','11:20:00',2.39),('5815','2013-05-09','11:25:00',2.18),('5815','2013-05-09','11:30:00',1.96),('5815','2013-05-09','11:35:00',2.18),('5815','2013-05-09','11:40:00',2.36),('5815','2013-05-09','11:45:00',1.81),('5815','2013-05-09','11:50:00',1.97),('5815','2013-05-09','11:55:00',2.27),('5815','2013-05-09','12:00:00',2.26),('5815','2013-05-09','12:05:00',1.92),('5815','2013-05-09','12:10:00',1.34),('5815','2013-05-09','12:15:00',1.24),('5815','2013-05-09','12:20:00',1.46),('5815','2013-05-09','12:25:00',1.32),('5815','2013-05-09','12:30:00',1.21),('5815','2013-05-09','12:35:00',1.44),('5815','2013-05-09','12:40:00',2.04),('5815','2013-05-09','12:45:00',2.65),('5815','2013-05-09','12:50:00',2.2),('5815','2013-05-09','12:55:00',1.89),('5815','2013-05-09','13:00:00',2.26),('5815','2013-05-09','13:05:00',2.15),('5815','2013-05-09','13:10:00',2.56),('5815','2013-05-09','13:15:00',2.72),('5815','2013-05-09','13:20:00',1.97),('5815','2013-05-09','13:25:00',1.72),('5815','2013-05-09','13:30:00',1.83),('5815','2013-05-09','13:35:00',2.02),('5815','2013-05-09','13:40:00',2.66),('5815','2013-05-09','13:45:00',2.4),('5815','2013-05-09','13:50:00',1.41),('5815','2013-05-09','13:55:00',1.21),('5815','2013-05-09','14:00:00',1.1),('5815','2013-05-09','14:05:00',1.12),('5815','2013-05-09','14:10:00',1.35),('5815','2013-05-09','14:15:00',1.45),('5815','2013-05-09','14:20:00',1.49),('5815','2013-05-09','14:25:00',1.46),('5815','2013-05-09','14:30:00',1.46),('5815','2013-05-09','14:35:00',1.84),('5815','2013-05-09','14:40:00',1.63),('5815','2013-05-09','14:45:00',1.19),('5815','2013-05-09','15:15:00',1.73),('5815','2013-05-09','15:20:00',1.63),('5815','2013-05-09','15:25:00',1.17),('5815','2013-05-09','15:30:00',1.09),('5815','2013-05-09','15:35:00',1.11),('5815','2013-05-09','15:40:00',1.14),('5815','2013-05-09','15:45:00',1.12),('5815','2013-05-09','15:50:00',1.02),('5815','2013-05-09','17:20:00',1.13),('5815','2013-05-09','17:25:00',1.11),('5815','2013-05-09','17:35:00',1.17),('5815','2013-05-08','08:35:00',1.02),('5815','2013-05-08','08:40:00',1.08),('5815','2013-05-08','08:45:00',1.13),('5815','2013-05-08','08:50:00',1.17),('5815','2013-05-08','08:55:00',1.21),('5815','2013-05-08','09:00:00',1.27),('5815','2013-05-08','09:05:00',1.33),('5815','2013-05-08','09:10:00',1.38),('5815','2013-05-08','09:15:00',1.43),('5815','2013-05-08','09:20:00',1.47),('5815','2013-05-08','09:25:00',1.53),('5815','2013-05-08','09:30:00',1.56),('5815','2013-05-08','09:35:00',1.61),('5815','2013-05-08','09:40:00',1.64),('5815','2013-05-08','09:45:00',1.68),('5815','2013-05-08','09:50:00',1.73),('5815','2013-05-08','09:55:00',1.77),('5815','2013-05-08','10:00:00',1.81),('5815','2013-05-08','10:05:00',1.84),('5815','2013-05-08','10:10:00',1.88),('5815','2013-05-08','10:15:00',1.91),('5815','2013-05-08','10:20:00',1.94),('5815','2013-05-08','10:25:00',1.97),('5815','2013-05-08','10:30:00',2),('5815','2013-05-08','10:35:00',2.03),('5815','2013-05-08','10:40:00',2.07),('5815','2013-05-08','10:45:00',2.09),('5815','2013-05-08','10:50:00',2.1),('5815','2013-05-08','10:55:00',2.09),('5815','2013-05-08','11:00:00',2.05),('5815','2013-05-08','11:05:00',2.07),('5815','2013-05-08','11:10:00',2.1),('5815','2013-05-08','11:15:00',2.16),('5815','2013-05-08','11:20:00',2.17),('5815','2013-05-08','11:25:00',2.17),('5815','2013-05-08','11:30:00',2.2),('5815','2013-05-08','11:35:00',2.21),('5815','2013-05-08','11:40:00',2.21),('5815','2013-05-08','11:45:00',2.24),('5815','2013-05-08','11:50:00',2.26),('5815','2013-05-08','11:55:00',2.29),('5815','2013-05-08','12:00:00',2.3),('5815','2013-05-08','12:05:00',2.32),('5815','2013-05-08','12:10:00',2.37),('5815','2013-05-08','12:15:00',2.38),('5815','2013-05-08','12:20:00',2.39),('5815','2013-05-08','12:25:00',2.43),('5815','2013-05-08','12:30:00',2.33),('5815','2013-05-08','12:35:00',2.28),('5815','2013-05-08','12:40:00',2.47),('5815','2013-05-08','12:45:00',2.46),('5815','2013-05-08','12:50:00',2.47),('5815','2013-05-08','12:55:00',2.44),('5815','2013-05-08','13:00:00',2.42),('5815','2013-05-08','13:05:00',2.41),('5815','2013-05-08','13:10:00',2.42),('5815','2013-05-08','13:15:00',2.45),('5815','2013-05-08','13:20:00',2.47),('5815','2013-05-08','13:25:00',2.45),('5815','2013-05-08','13:30:00',2.44),('5815','2013-05-08','13:35:00',2.44),('5815','2013-05-08','13:40:00',2.46),('5815','2013-05-08','13:45:00',2.48),('5815','2013-05-08','13:50:00',2.46),('5815','2013-05-08','13:55:00',2.37),('5815','2013-05-08','14:00:00',1.92),('5815','2013-05-08','14:05:00',2.3),('5815','2013-05-08','14:10:00',1.86),('5815','2013-05-08','14:15:00',1.89),('5815','2013-05-08','14:20:00',2.27),('5815','2013-05-08','14:25:00',1.91),('5815','2013-05-08','14:30:00',2.18),('5815','2013-05-08','14:35:00',2.4),('5815','2013-05-08','14:40:00',2.37),('5815','2013-05-08','14:45:00',2.35),('5815','2013-05-08','14:50:00',2.3),('5815','2013-05-08','14:55:00',2.14),('5815','2013-05-08','15:00:00',2.32),('5815','2013-05-08','15:05:00',2.28),('5815','2013-05-08','15:10:00',2.27),('5815','2013-05-08','15:15:00',2.22),('5815','2013-05-08','15:20:00',2.18),('5815','2013-05-08','15:25:00',2.15),('5815','2013-05-08','15:30:00',2.16),('5815','2013-05-08','15:35:00',2.15),('5815','2013-05-08','15:40:00',2.12),('5815','2013-05-08','15:45:00',2.09),('5815','2013-05-08','15:55:00',2.05),('5815','2013-05-08','16:00:00',1.95),('5815','2013-05-08','16:05:00',1.9),('5815','2013-05-08','16:10:00',1.88),('5815','2013-05-08','16:15:00',1.86),('5815','2013-05-08','16:20:00',1.8),('5815','2013-05-08','16:25:00',1.72),('5815','2013-05-08','16:30:00',1.68),('5815','2013-05-08','16:35:00',1.64),('5815','2013-05-08','16:40:00',1.61),('5815','2013-05-08','16:45:00',1.55),('5815','2013-05-08','16:50:00',1.49),('5815','2013-05-08','16:55:00',1.45),('5815','2013-05-08','17:00:00',1.41),('5815','2013-05-08','17:05:00',1.36),('5815','2013-05-08','17:10:00',1.32),('5815','2013-05-08','17:15:00',1.25),('5815','2013-05-08','17:20:00',1.16),('5815','2013-05-08','17:25:00',1.18),('5815','2013-05-08','17:30:00',1.12),('5815','2013-05-08','17:35:00',1.08),('5815','2013-05-08','17:40:00',1.01),('5815','2013-05-07','08:45:00',1.07),('5815','2013-05-07','08:50:00',1.24),('5815','2013-05-07','08:55:00',1.45),('5815','2013-05-07','09:00:00',1.45),('5815','2013-05-07','09:05:00',1.68),('5815','2013-05-07','09:10:00',1.61),('5815','2013-05-07','09:15:00',1.1),('5815','2013-05-07','09:20:00',1.37),('5815','2013-05-07','09:40:00',1.08),('5815','2013-05-07','09:45:00',1.16),('5815','2013-05-07','10:10:00',1.81),('5815','2013-05-07','10:15:00',1.18),('5815','2013-05-07','11:05:00',2.48),('5815','2013-05-07','11:10:00',2.38),('5815','2013-05-07','11:15:00',2.35),('5815','2013-05-07','11:20:00',2.26),('5815','2013-05-07','11:25:00',2.34),('5815','2013-05-07','11:30:00',2.45),('5815','2013-05-07','11:35:00',2.35),('5815','2013-05-07','11:40:00',1.96),('5815','2013-05-07','11:45:00',1.14),('5815','2013-05-07','12:00:00',2.26),('5815','2013-05-07','12:05:00',1.77),('5815','2013-05-07','12:20:00',1.55),('5815','2013-05-07','12:25:00',2.79),('5815','2013-05-07','12:45:00',1),('5815','2013-05-07','12:55:00',1.41),('5815','2013-05-07','13:00:00',1.98),('5815','2013-05-07','13:05:00',2.92),('5815','2013-05-07','13:10:00',2.95),('5815','2013-05-07','13:15:00',1.8),('5815','2013-05-07','13:45:00',2.93),('5815','2013-05-07','13:50:00',2.86),('5815','2013-05-07','13:55:00',2.5),('5815','2013-05-07','14:00:00',2.24),('5815','2013-05-07','14:05:00',1.84),('5815','2013-05-07','14:10:00',1.98),('5815','2013-05-07','14:30:00',1.04),('5815','2013-05-07','14:40:00',2.58),('5815','2013-05-07','14:45:00',1.77),('5815','2013-05-07','14:50:00',1.89),('5815','2013-05-07','14:55:00',2.5),('5815','2013-05-07','15:00:00',2.3),('5815','2013-05-07','15:05:00',2.35),('5815','2013-05-07','15:10:00',1.91),('5815','2013-05-07','15:15:00',2.36),('5815','2013-05-07','15:20:00',2.27),('5815','2013-05-07','15:25:00',2.25),('5815','2013-05-07','15:30:00',2.21),('5815','2013-05-07','15:35:00',2.14),('5815','2013-05-07','15:40:00',2.11),('5815','2013-05-07','15:45:00',2.08),('5815','2013-05-07','15:50:00',2.04),('5815','2013-05-07','15:55:00',2.01),('5815','2013-05-07','16:00:00',1.99),('5815','2013-05-07','16:05:00',1.94),('5815','2013-05-07','16:10:00',1.93),('5815','2013-05-07','16:15:00',1.9),('5815','2013-05-07','16:20:00',1.84),('5815','2013-05-07','16:25:00',1.72),('5815','2013-05-07','16:30:00',1.78),('5815','2013-05-07','16:35:00',1.75),('5815','2013-05-07','16:40:00',1.72),('5815','2013-05-07','16:50:00',1.44),('5815','2013-05-07','16:55:00',1.66),('5815','2013-05-07','17:00:00',1.7),('5815','2013-05-07','17:05:00',1.36),('5815','2013-05-07','17:10:00',1.54),('5815','2013-05-07','17:15:00',1.45),('5815','2013-05-07','17:20:00',1.08),('5815','2013-05-07','17:25:00',1.26),('5815','2013-05-07','17:30:00',1.33),('5815','2013-05-07','17:35:00',1.31),('5815','2013-05-07','17:40:00',1.26),('5815','2013-05-07','17:45:00',1.28),('5815','2013-05-07','17:50:00',1.25),('5815','2013-05-06','08:35:00',1.05),('5815','2013-05-06','08:40:00',1.08),('5815','2013-05-06','08:45:00',1.14),('5815','2013-05-06','08:50:00',1.13),('5815','2013-05-06','08:55:00',1.1),('5815','2013-05-06','09:00:00',1.45),('5815','2013-05-06','09:05:00',1.59),('5815','2013-05-06','09:10:00',1.31),('5815','2013-05-06','09:15:00',1.39),('5815','2013-05-06','09:35:00',1.18),('5815','2013-05-06','09:40:00',1.2),('5815','2013-05-06','09:50:00',1.27),('5815','2013-05-06','11:20:00',1.84),('5815','2013-05-06','11:25:00',1.75),('5815','2013-05-06','12:05:00',1.04),('5815','2013-05-06','12:15:00',2.26),('5815','2013-05-06','12:25:00',1.25),('5815','2013-05-06','12:30:00',2.91),('5815','2013-05-06','13:40:00',2.19),('5815','2013-05-06','13:45:00',2.65),('5815','2013-05-06','13:50:00',2.82),('5815','2013-05-06','13:55:00',2.76),('5815','2013-05-06','14:00:00',2.71),('5815','2013-05-06','14:05:00',2.67),('5815','2013-05-06','14:10:00',2.68),('5815','2013-05-06','14:15:00',2.68),('5815','2013-05-06','14:20:00',2.62),('5815','2013-05-06','14:25:00',1.66),('5815','2013-05-06','14:30:00',2.72),('5815','2013-05-06','14:35:00',1.75),('5815','2013-05-06','14:40:00',2.9),('5815','2013-05-06','14:45:00',2.31),('5815','2013-05-06','14:50:00',2.12),('5815','2013-05-06','14:55:00',2.56),('5815','2013-05-06','15:00:00',1.87),('5815','2013-05-06','15:05:00',2.59),('5815','2013-05-06','15:10:00',2.02),('5815','2013-05-06','15:15:00',2.25),('5815','2013-05-06','15:20:00',1.97),('5815','2013-05-06','15:25:00',1.36),('5815','2013-05-06','15:30:00',1.26),('5815','2013-05-06','15:35:00',1.76),('5815','2013-05-06','15:40:00',1.22),('5815','2013-05-06','15:45:00',1.49),('5815','2013-05-06','15:55:00',1.04),('5815','2013-05-06','16:00:00',1.85),('5815','2013-05-06','16:05:00',1.51),('5815','2013-05-06','16:15:00',1.03),('5815','2013-05-06','16:20:00',2.42),('5815','2013-05-06','16:25:00',2.34),('5815','2013-05-06','16:30:00',2.18),('5815','2013-05-06','16:35:00',2.12),('5815','2013-05-06','16:40:00',2.15),('5815','2013-05-06','16:45:00',1.55),('5815','2013-05-06','16:50:00',1.61),('5815','2013-05-06','16:55:00',1.46),('5815','2013-05-06','17:00:00',1.56),('5815','2013-05-06','17:05:00',1.52),('5815','2013-05-06','17:10:00',1.2),('5815','2013-05-05','09:00:00',1.03),('5815','2013-05-05','10:20:00',1.08),('5815','2013-05-05','10:45:00',1.42),('5815','2013-05-05','10:50:00',1.44),('5815','2013-05-05','10:55:00',1.15),('5815','2013-05-05','11:00:00',1.14),('5815','2013-05-05','11:05:00',1.14),('5815','2013-05-05','11:10:00',1.09),('5815','2013-05-05','11:20:00',1.25),('5815','2013-05-05','11:25:00',1.2),('5815','2013-05-05','11:30:00',1.16),('5815','2013-05-05','11:40:00',1.69),('5815','2013-05-05','11:45:00',2.19),('5815','2013-05-05','11:50:00',1.84),('5815','2013-05-05','12:05:00',1.12),('5815','2013-05-05','12:10:00',2.57),('5815','2013-05-05','12:15:00',1.78),('5815','2013-05-05','12:20:00',1.49),('5815','2013-05-05','12:25:00',1.55),('5815','2013-05-05','12:30:00',2.18),('5815','2013-05-05','12:35:00',2.05),('5815','2013-05-05','12:40:00',1.6),('5815','2013-05-05','12:45:00',1.36),('5815','2013-05-05','12:50:00',1.54),('5815','2013-05-05','12:55:00',2.4),('5815','2013-05-05','13:05:00',1.82),('5815','2013-05-05','13:10:00',2.5),('5815','2013-05-05','13:15:00',2.11),('5815','2013-05-05','13:20:00',2.05),('5815','2013-05-05','13:25:00',1.5),('5815','2013-05-05','13:30:00',2.15),('5815','2013-05-05','13:35:00',1.44),('5815','2013-05-05','13:40:00',2.19),('5815','2013-05-05','13:45:00',2.77),('5815','2013-05-05','13:50:00',2.45),('5815','2013-05-05','13:55:00',2.52),('5815','2013-05-05','14:00:00',1.81),('5815','2013-05-05','14:05:00',2.85),('5815','2013-05-05','14:10:00',1.49),('5815','2013-05-05','14:15:00',1.86),('5815','2013-05-05','14:20:00',2.19),('5815','2013-05-05','14:25:00',1.59),('5815','2013-05-05','14:30:00',2.1),('5815','2013-05-05','14:35:00',2.13),('5815','2013-05-05','14:40:00',1.12),('5815','2013-05-05','14:45:00',2.1),('5815','2013-05-05','14:50:00',1.1),('5815','2013-05-05','14:55:00',2.04),('5815','2013-05-05','15:00:00',2.58),('5815','2013-05-05','15:05:00',1.62),('5815','2013-05-05','15:10:00',2.22),('5815','2013-05-05','15:15:00',1.39),('5815','2013-05-05','15:20:00',1.04),('5815','2013-05-05','15:25:00',2),('5815','2013-05-05','15:30:00',1.29),('5815','2013-05-05','15:40:00',1.01),('5815','2013-05-05','15:55:00',1.26),('5815','2013-05-05','16:00:00',1.15),('5815','2013-05-05','16:25:00',1.24),('5815','2013-05-05','16:30:00',1.31),('5815','2013-05-05','16:35:00',1.21),('5815','2013-05-05','16:40:00',1.64),('5815','2013-05-05','16:45:00',1.69),('5815','2013-05-05','16:50:00',1.33),('5815','2013-05-05','16:55:00',1.69),('5815','2013-05-04','08:25:00',1.13),('5815','2013-05-04','08:30:00',1.16),('5815','2013-05-04','08:35:00',1.02),('5815','2013-05-04','08:40:00',1.11),('5815','2013-05-04','09:25:00',1.03),('5815','2013-05-04','09:30:00',1.13),('5815','2013-05-04','09:40:00',1.21),('5815','2013-05-04','09:45:00',1.57),('5815','2013-05-04','09:50:00',1.16),('5815','2013-05-04','09:55:00',1.92),('5815','2013-05-04','10:00:00',1.34),('5815','2013-05-04','10:05:00',1.27),('5815','2013-05-04','10:10:00',1.23),('5815','2013-05-04','10:15:00',1.05),('5815','2013-05-04','10:20:00',1.75),('5815','2013-05-04','10:25:00',1.33),('5815','2013-05-04','10:30:00',1.46),('5815','2013-05-04','10:35:00',1.38),('5815','2013-05-04','10:40:00',1.33),('5815','2013-05-04','10:45:00',1.37),('5815','2013-05-04','10:50:00',1.06),('5815','2013-05-04','11:05:00',1.03),('5815','2013-05-04','11:20:00',1.3),('5815','2013-05-04','11:25:00',1.88),('5815','2013-05-04','11:30:00',1.54),('5815','2013-05-04','11:35:00',2.06),('5815','2013-05-04','11:40:00',1.81),('5815','2013-05-04','11:45:00',1.67),('5815','2013-05-04','11:50:00',1.49),('5815','2013-05-04','11:55:00',2),('5815','2013-05-04','12:00:00',1.44),('5815','2013-05-04','12:05:00',1.49),('5815','2013-05-04','12:10:00',1.36),('5815','2013-05-04','12:15:00',1.62),('5815','2013-05-04','12:20:00',1.77),('5815','2013-05-04','12:25:00',1.96),('5815','2013-05-04','12:30:00',2.08),('5815','2013-05-04','12:35:00',2.27),('5815','2013-05-04','12:40:00',2.01),('5815','2013-05-04','12:45:00',1.99),('5815','2013-05-04','12:50:00',1.95),('5815','2013-05-04','12:55:00',2.27),('5815','2013-05-04','13:00:00',2.41),('5815','2013-05-04','13:05:00',2.57),('5815','2013-05-04','13:10:00',2.53),('5815','2013-05-04','13:15:00',2.62),('5815','2013-05-04','13:20:00',2.21),('5815','2013-05-04','13:25:00',1.29),('5815','2013-05-04','13:35:00',2.21),('5815','2013-05-04','13:40:00',2.46),('5815','2013-05-04','13:45:00',2.53),('5815','2013-05-04','13:50:00',2.53),('5815','2013-05-04','13:55:00',2.53),('5815','2013-05-04','14:00:00',2.57),('5815','2013-05-04','14:05:00',2.64),('5815','2013-05-04','14:10:00',1.97),('5815','2013-05-04','14:15:00',1.71),('5815','2013-05-04','14:20:00',2.3),('5815','2013-05-04','14:25:00',2.33),('5815','2013-05-04','14:30:00',2.27),('5815','2013-05-04','14:35:00',2.24),('5815','2013-05-04','14:40:00',2.21),('5815','2013-05-04','14:45:00',2.22),('5815','2013-05-04','14:50:00',2.2),('5815','2013-05-04','14:55:00',2.17),('5815','2013-05-04','15:00:00',2.14),('5815','2013-05-04','15:05:00',2.13),('5815','2013-05-04','15:10:00',2.1),('5815','2013-05-04','15:15:00',2.09),('5815','2013-05-04','15:20:00',2.06),('5815','2013-05-04','15:25:00',2.04),('5815','2013-05-04','15:30:00',2.01),('5815','2013-05-04','15:35:00',2),('5815','2013-05-04','15:40:00',1.96),('5815','2013-05-04','15:45:00',1.94),('5815','2013-05-04','15:50:00',1.92),('5815','2013-05-04','15:55:00',1.88),('5815','2013-05-04','16:00:00',1.85),('5815','2013-05-04','16:05:00',1.82),('5815','2013-05-04','16:10:00',1.78),('5815','2013-05-04','16:15:00',1.76),('5815','2013-05-04','16:20:00',1.72),('5815','2013-05-04','16:25:00',1.69),('5815','2013-05-04','16:30:00',1.64),('5815','2013-05-04','16:35:00',1.59),('5815','2013-05-04','16:40:00',1.56),('5815','2013-05-04','16:45:00',1.51),('5815','2013-05-04','16:50:00',1.44),('5815','2013-05-04','16:55:00',1.39),('5815','2013-05-04','17:00:00',1.35),('5815','2013-05-04','17:05:00',1.28),('5815','2013-05-04','17:10:00',1.21),('5815','2013-05-04','17:15:00',1.19),('5815','2013-05-04','17:20:00',1.12),('5815','2013-05-04','17:25:00',1.02),('5815','2013-05-04','17:30:00',1.03),('5815','2013-05-04','17:35:00',1),('5815','2013-05-03','08:45:00',1.02),('5815','2013-05-03','08:50:00',1.07),('5815','2013-05-03','08:55:00',1.12),('5815','2013-05-03','09:00:00',1.16),('5815','2013-05-03','09:05:00',1.22),('5815','2013-05-03','09:10:00',1.25),('5815','2013-05-03','09:15:00',1.29),('5815','2013-05-03','09:20:00',1.36),('5815','2013-05-03','09:25:00',1.39),('5815','2013-05-03','09:30:00',1.42),('5815','2013-05-03','09:35:00',1.47),('5815','2013-05-03','09:40:00',1.52),('5815','2013-05-03','09:45:00',1.58),('5815','2013-05-03','09:50:00',1.63),('5815','2013-05-03','09:55:00',1.66),('5815','2013-05-03','10:00:00',1.72),('5815','2013-05-03','10:05:00',1.74),('5815','2013-05-03','10:10:00',1.78),('5815','2013-05-03','10:15:00',1.82),('5815','2013-05-03','10:20:00',1.87),('5815','2013-05-03','10:25:00',1.89),('5815','2013-05-03','10:30:00',1.93),('5815','2013-05-03','10:35:00',1.95),('5815','2013-05-03','10:40:00',1.95),('5815','2013-05-03','10:45:00',1.96),('5815','2013-05-03','10:50:00',1.95),('5815','2013-05-03','10:55:00',1.94),('5815','2013-05-03','11:00:00',1.93),('5815','2013-05-03','11:05:00',1.94),('5815','2013-05-03','11:10:00',1.87),('5815','2013-05-03','11:15:00',1.78),('5815','2013-05-03','11:20:00',1.91),('5815','2013-05-03','11:25:00',2),('5815','2013-05-03','11:30:00',1.89),('5815','2013-05-03','11:35:00',1.98),('5815','2013-05-03','11:40:00',1.92),('5815','2013-05-03','11:45:00',1.96),('5815','2013-05-03','11:50:00',1.99),('5815','2013-05-03','11:55:00',1.94),('5815','2013-05-03','12:00:00',1.94),('5815','2013-05-03','12:05:00',2.02),('5815','2013-05-03','12:10:00',2.04),('5815','2013-05-03','12:15:00',2.08),('5815','2013-05-03','12:20:00',2.13),('5815','2013-05-03','12:25:00',2.18),('5815','2013-05-03','12:30:00',2.19),('5815','2013-05-03','12:35:00',2.23),('5815','2013-05-03','12:40:00',2.22),('5815','2013-05-03','12:45:00',2.24),('5815','2013-05-03','12:50:00',2.18),('5815','2013-05-03','12:55:00',2.13),('5815','2013-05-03','13:00:00',2.1),('5815','2013-05-03','13:05:00',1.95),('5815','2013-05-03','13:10:00',2),('5815','2013-05-03','13:15:00',2.29),('5815','2013-05-03','13:20:00',2.35),('5815','2013-05-03','13:25:00',2.24),('5815','2013-05-03','13:30:00',2.22),('5815','2013-05-03','13:35:00',2.15),('5815','2013-05-03','13:40:00',2.19),('5815','2013-05-03','13:45:00',2.18),('5815','2013-05-03','13:50:00',1.92),('5815','2013-05-03','13:55:00',2.04),('5815','2013-05-03','14:00:00',2.09),('5815','2013-05-03','14:05:00',2.16),('5815','2013-05-03','14:10:00',2.05),('5815','2013-05-03','14:15:00',2.07),('5815','2013-05-03','14:20:00',2.11),('5815','2013-05-03','14:25:00',1.91),('5815','2013-05-03','14:30:00',2.03),('5815','2013-05-03','14:35:00',1.9),('5815','2013-05-03','14:40:00',1.98),('5815','2013-05-03','14:45:00',1.97),('5815','2013-05-03','14:50:00',1.85),('5815','2013-05-03','14:55:00',1.91),('5815','2013-05-03','15:00:00',1.94),('5815','2013-05-03','15:05:00',2.02),('5815','2013-05-03','15:10:00',1.87),('5815','2013-05-03','15:15:00',1.92),('5815','2013-05-03','15:20:00',1.94),('5815','2013-05-03','15:25:00',1.97),('5815','2013-05-03','15:30:00',1.94),('5815','2013-05-03','15:35:00',1.86),('5815','2013-05-03','15:40:00',1.81),('5815','2013-05-03','15:45:00',1.85),('5815','2013-05-03','15:50:00',1.84),('5815','2013-05-03','15:55:00',1.81),('5815','2013-05-03','16:00:00',1.77),('5815','2013-05-03','16:05:00',1.75),('5815','2013-05-03','16:10:00',1.71),('5815','2013-05-03','16:15:00',1.67),('5815','2013-05-03','16:20:00',1.62),('5815','2013-05-03','16:25:00',1.59),('5815','2013-05-03','16:30:00',1.55),('5815','2013-05-03','16:35:00',1.51),('5815','2013-05-03','16:40:00',1.47),('5815','2013-05-03','16:45:00',1.42),('5815','2013-05-03','16:50:00',1.35),('5815','2013-05-03','16:55:00',1.3),('5815','2013-05-03','17:00:00',1.29),('5815','2013-05-03','17:05:00',1.21),('5815','2013-05-03','17:15:00',1.05),('5815','2013-05-03','17:20:00',1.07),('5815','2013-05-02','08:35:00',1.02),('5815','2013-05-02','08:40:00',1.05),('5815','2013-05-02','08:45:00',1.1),('5815','2013-05-02','08:50:00',1.09),('5815','2013-05-02','08:55:00',1.1),('5815','2013-05-02','09:00:00',1.19),('5815','2013-05-02','09:05:00',1.27),('5815','2013-05-02','09:10:00',1.29),('5815','2013-05-02','09:15:00',1.34),('5815','2013-05-02','09:20:00',1.39),('5815','2013-05-02','09:25:00',1.43),('5815','2013-05-02','09:30:00',1.47),('5815','2013-05-02','09:35:00',1.53),('5815','2013-05-02','09:40:00',1.58),('5815','2013-05-02','09:45:00',1.61),('5815','2013-05-02','09:50:00',1.66),('5815','2013-05-02','09:55:00',1.69),('5815','2013-05-02','10:00:00',1.74),('5815','2013-05-02','10:05:00',1.77),('5815','2013-05-02','10:10:00',1.82),('5815','2013-05-02','10:15:00',1.84),('5815','2013-05-02','10:20:00',1.88),('5815','2013-05-02','10:25:00',1.9),('5815','2013-05-02','10:30:00',1.94),('5815','2013-05-02','10:35:00',1.95),('5815','2013-05-02','10:40:00',1.96),('5815','2013-05-02','10:45:00',2.01),('5815','2013-05-02','10:50:00',2.03),('5815','2013-05-02','10:55:00',2.05),('5815','2013-05-02','11:00:00',2.04),('5815','2013-05-02','11:05:00',2.02),('5815','2013-05-02','11:10:00',2.07),('5815','2013-05-02','11:15:00',2.08),('5815','2013-05-02','11:20:00',2.12),('5815','2013-05-02','11:25:00',2.15),('5815','2013-05-02','11:30:00',2.16),('5815','2013-05-02','11:35:00',2.2),('5815','2013-05-02','11:40:00',2.22),('5815','2013-05-02','11:45:00',2.23),('5815','2013-05-02','11:50:00',2.25),('5815','2013-05-02','11:55:00',2.26),('5815','2013-05-02','12:00:00',2.26),('5815','2013-05-02','12:05:00',2.27),('5815','2013-05-02','12:10:00',2.3),('5815','2013-05-02','12:15:00',2.31),('5815','2013-05-02','12:20:00',2.32),('5815','2013-05-02','12:25:00',2.33),('5815','2013-05-02','12:30:00',2.33),('5815','2013-05-02','12:35:00',2.31),('5815','2013-05-02','12:40:00',2.31),('5815','2013-05-02','12:45:00',2.31),('5815','2013-05-02','12:50:00',2.34),('5815','2013-05-02','12:55:00',2.38),('5815','2013-05-02','13:00:00',2.35),('5815','2013-05-02','13:05:00',2.34),('5815','2013-05-02','13:10:00',2.35),('5815','2013-05-02','13:15:00',2.34),('5815','2013-05-02','13:20:00',2.38),('5815','2013-05-02','13:25:00',2.37),('5815','2013-05-02','13:30:00',2.35),('5815','2013-05-02','13:35:00',2.32),('5815','2013-05-02','13:40:00',2.23),('5815','2013-05-02','13:45:00',2.23),('5815','2013-05-02','13:50:00',2.2),('5815','2013-05-02','13:55:00',2.25),('5815','2013-05-02','14:00:00',2.23),('5815','2013-05-02','14:05:00',2.13),('5815','2013-05-02','14:10:00',2.15),('5815','2013-05-02','14:15:00',2.1),('5815','2013-05-02','14:20:00',2.16),('5815','2013-05-02','14:25:00',2.15),('5815','2013-05-02','14:30:00',2.17),('5815','2013-05-02','14:35:00',2.2),('5815','2013-05-02','14:40:00',2.15),('5815','2013-05-02','14:45:00',2.14),('5815','2013-05-02','14:50:00',2.14),('5815','2013-05-02','14:55:00',2.13),('5815','2013-05-02','15:00:00',2.12),('5815','2013-05-02','15:05:00',2.1),('5815','2013-05-02','15:10:00',2.12),('5815','2013-05-02','15:15:00',2.11),('5815','2013-05-02','15:20:00',2.07),('5815','2013-05-02','15:25:00',2.05),('5815','2013-05-02','15:30:00',2.03),('5815','2013-05-02','15:35:00',2.01),('5815','2013-05-02','15:40:00',1.98),('5815','2013-05-02','15:45:00',1.96),('5815','2013-05-02','15:50:00',1.91),('5815','2013-05-02','15:55:00',1.87),('5815','2013-05-02','16:00:00',1.86),('5815','2013-05-02','16:05:00',1.82),('5815','2013-05-02','16:10:00',1.79),('5815','2013-05-02','16:15:00',1.74),('5815','2013-05-02','16:20:00',1.68),('5815','2013-05-02','16:25:00',1.63),('5815','2013-05-02','16:30:00',1.63),('5815','2013-05-02','16:35:00',1.58),('5815','2013-05-02','16:40:00',1.55),('5815','2013-05-02','16:45:00',1.49),('5815','2013-05-02','16:50:00',1.43),('5815','2013-05-02','16:55:00',1.37),('5815','2013-05-02','17:00:00',1.36),('5815','2013-05-02','17:05:00',1.28),('5815','2013-05-02','17:10:00',1.23),('5815','2013-05-02','17:15:00',1.18),('5815','2013-05-02','17:20:00',1.08),('5815','2013-05-02','17:25:00',1.03),('5815','2013-05-01','09:35:00',1.15),('5815','2013-05-01','09:45:00',1.4),('5815','2013-05-01','10:25:00',1.04),('5815','2013-05-01','10:30:00',1.65),('5815','2013-05-01','10:35:00',1.43),('5815','2013-05-01','10:40:00',2.02),('5815','2013-05-01','10:45:00',1.64),('5815','2013-05-01','10:50:00',1.86),('5815','2013-05-01','10:55:00',2.17),('5815','2013-05-01','11:00:00',2.25),('5815','2013-05-01','11:05:00',2.1),('5815','2013-05-01','11:10:00',1.68),('5815','2013-05-01','11:15:00',1.61),('5815','2013-05-01','11:20:00',1.45),('5815','2013-05-01','11:25:00',2.2),('5815','2013-05-01','11:30:00',2.24),('5815','2013-05-01','11:35:00',2.23),('5815','2013-05-01','11:40:00',2.19),('5815','2013-05-01','11:45:00',2.2),('5815','2013-05-01','11:50:00',2.21),('5815','2013-05-01','11:55:00',2.22),('5815','2013-05-01','12:00:00',2.22),('5815','2013-05-01','12:05:00',2.21),('5815','2013-05-01','12:10:00',2.2),('5815','2013-05-01','12:15:00',2.23),('5815','2013-05-01','12:20:00',2.26),('5815','2013-05-01','12:25:00',2.26),('5815','2013-05-01','12:30:00',2.31),('5815','2013-05-01','12:35:00',2.35),('5815','2013-05-01','12:40:00',2.38),('5815','2013-05-01','12:45:00',2.39),('5815','2013-05-01','12:50:00',2.4),('5815','2013-05-01','12:55:00',2.42),('5815','2013-05-01','13:00:00',2.45),('5815','2013-05-01','13:05:00',2.45),('5815','2013-05-01','13:10:00',2.48),('5815','2013-05-01','13:15:00',2.48),('5815','2013-05-01','13:20:00',2.48),('5815','2013-05-01','13:25:00',2.48),('5815','2013-05-01','13:30:00',2.48),('5815','2013-05-01','13:35:00',2.48),('5815','2013-05-01','13:40:00',2.47),('5815','2013-05-01','13:45:00',2.45),('5815','2013-05-01','13:50:00',2.43),('5815','2013-05-01','13:55:00',2.43),('5815','2013-05-01','14:00:00',2.41),('5815','2013-05-01','14:05:00',2.37),('5815','2013-05-01','14:10:00',2.37),('5815','2013-05-01','14:15:00',2.36),('5815','2013-05-01','14:20:00',2.35),('5815','2013-05-01','14:25:00',2.33),('5815','2013-05-01','14:30:00',2.31),('5815','2013-05-01','14:35:00',2.29),('5815','2013-05-01','14:40:00',2.28),('5815','2013-05-01','14:45:00',2.25),('5815','2013-05-01','14:50:00',2.26),('5815','2013-05-01','14:55:00',2.23),('5815','2013-05-01','15:00:00',2.21),('5815','2013-05-01','15:05:00',2.18),('5815','2013-05-01','15:10:00',2.17),('5815','2013-05-01','15:15:00',2.13),('5815','2013-05-01','15:20:00',2.1),('5815','2013-05-01','15:25:00',2.08),('5815','2013-05-01','15:30:00',2.03),('5815','2013-05-01','15:35:00',1.97),('5815','2013-05-01','15:40:00',1.96),('5815','2013-05-01','15:45:00',1.92),('5815','2013-05-01','15:50:00',1.9),('5815','2013-05-01','15:55:00',1.87),('5815','2013-05-01','16:00:00',1.83),('5815','2013-05-01','16:05:00',1.81),('5815','2013-05-01','16:10:00',1.78),('5815','2013-05-01','16:15:00',1.74),('5815','2013-05-01','16:20:00',1.72),('5815','2013-05-01','16:25:00',1.67),('5815','2013-05-01','16:30:00',1.62),('5815','2013-05-01','16:35:00',1.57),('5815','2013-05-01','16:40:00',1.53),('5815','2013-05-01','16:45:00',1.49),('5815','2013-05-01','16:50:00',1.44),('5815','2013-05-01','16:55:00',1.39),('5815','2013-05-01','17:00:00',1.36),('5815','2013-05-01','17:05:00',1.3),('5815','2013-05-01','17:10:00',1.23),('5815','2013-05-01','17:15:00',1.21),('5815','2013-05-01','17:20:00',1.13),('5815','2013-05-01','17:25:00',1.05),('5815','2013-05-01','17:30:00',1.03),('5815','2013-05-01','17:35:00',1),('5815','2013-04-30','08:50:00',1.01),('5815','2013-04-30','08:55:00',1.06),('5815','2013-04-30','09:00:00',1.12),('5815','2013-04-30','09:05:00',1.17),('5815','2013-04-30','09:10:00',1.2),('5815','2013-04-30','09:15:00',1.25),('5815','2013-04-30','09:20:00',1.28),('5815','2013-04-30','09:25:00',1.31),('5815','2013-04-30','09:30:00',1.34),('5815','2013-04-30','09:35:00',1.37),('5815','2013-04-30','09:40:00',1.42),('5815','2013-04-30','09:45:00',1.46),('5815','2013-04-30','09:50:00',1.5),('5815','2013-04-30','09:55:00',1.53),('5815','2013-04-30','10:00:00',1.57),('5815','2013-04-30','10:05:00',1.58),('5815','2013-04-30','10:10:00',1.63),('5815','2013-04-30','10:15:00',1.68),('5815','2013-04-30','10:20:00',1.72),('5815','2013-04-30','10:25:00',1.75),('5815','2013-04-30','10:30:00',1.78),('5815','2013-04-30','10:35:00',1.81),('5815','2013-04-30','10:40:00',1.85),('5815','2013-04-30','10:45:00',1.98),('5815','2013-04-30','10:50:00',2),('5815','2013-04-30','10:55:00',2.01),('5815','2013-04-30','11:00:00',2),('5815','2013-04-30','11:05:00',2.02),('5815','2013-04-30','11:10:00',2.05),('5815','2013-04-30','11:15:00',1.94),('5815','2013-04-30','11:20:00',1.96),('5815','2013-04-30','11:25:00',1.91),('5815','2013-04-30','11:30:00',1.89),('5815','2013-04-30','11:35:00',1.96),('5815','2013-04-30','11:40:00',1.63),('5815','2013-04-30','11:45:00',1.51),('5815','2013-04-30','11:50:00',1.83),('5815','2013-04-30','11:55:00',2.23),('5815','2013-04-30','12:00:00',2.22),('5815','2013-04-30','12:05:00',2.2),('5815','2013-04-30','12:10:00',2.2),('5815','2013-04-30','12:15:00',2.19),('5815','2013-04-30','12:20:00',2.19),('5815','2013-04-30','12:25:00',2.22),('5815','2013-04-30','12:30:00',2.25),('5815','2013-04-30','12:35:00',2.28),('5815','2013-04-30','12:40:00',2.33),('5815','2013-04-30','12:45:00',2.23),('5815','2013-04-30','12:50:00',1.85),('5815','2013-04-30','13:05:00',1),('5815','2013-04-30','13:10:00',1.21),('5815','2013-04-30','13:15:00',2.1),('5815','2013-04-30','13:20:00',2.69),('5815','2013-04-30','13:25:00',2.16),('5815','2013-04-30','13:30:00',1.41),('5815','2013-04-30','13:35:00',1.86),('5815','2013-04-30','13:40:00',2.14),('5815','2013-04-30','13:45:00',2.56),('5815','2013-04-30','13:50:00',2.41),('5815','2013-04-30','13:55:00',2.34),('5815','2013-04-30','14:00:00',2.27),('5815','2013-04-30','14:05:00',2.21),('5815','2013-04-30','14:10:00',2.21),('5815','2013-04-30','14:15:00',1.94),('5815','2013-04-30','14:20:00',2.3),('5815','2013-04-30','14:25:00',2.31),('5815','2013-04-30','14:30:00',2.32),('5815','2013-04-30','14:35:00',2.27),('5815','2013-04-30','14:40:00',2),('5815','2013-04-30','14:45:00',2.14),('5815','2013-04-30','14:50:00',1.84),('5815','2013-04-30','14:55:00',1.71),('5815','2013-04-30','15:00:00',1.74),('5815','2013-04-30','15:05:00',2.02),('5815','2013-04-30','15:10:00',2.03),('5815','2013-04-30','15:15:00',1.96),('5815','2013-04-30','15:20:00',1.87),('5815','2013-04-30','15:25:00',1.93),('5815','2013-04-30','15:30:00',1.62),('5815','2013-04-30','15:35:00',1.38),('5815','2013-04-30','15:40:00',1.37),('5815','2013-04-30','15:45:00',1.33),('5815','2013-04-30','15:50:00',1.01),('5815','2013-04-30','16:00:00',1.14),('5815','2013-04-30','16:05:00',1.12),('5815','2013-04-29','09:10:00',1.13),('5815','2013-04-29','09:15:00',1.39),('5815','2013-04-29','09:20:00',1.39),('5815','2013-04-29','09:25:00',1.5),('5815','2013-04-29','09:30:00',1.48),('5815','2013-04-29','09:35:00',1.26),('5815','2013-04-29','09:45:00',1.03),('5815','2013-04-29','09:50:00',1.4),('5815','2013-04-29','09:55:00',1.56),('5815','2013-04-29','10:00:00',1.8),('5815','2013-04-29','10:05:00',1.89),('5815','2013-04-29','10:10:00',1.55),('5815','2013-04-29','10:15:00',1.35),('5815','2013-04-29','10:20:00',1.23),('5815','2013-04-29','10:25:00',1.33),('5815','2013-04-29','10:30:00',1.14),('5815','2013-04-29','10:35:00',1.07),('5815','2013-04-29','11:15:00',1.01),('5815','2013-04-29','11:20:00',1.17),('5815','2013-04-29','11:25:00',1.07),('5815','2013-04-29','11:30:00',1.05),('5815','2013-04-29','11:35:00',1.1),('5815','2013-04-29','11:40:00',1.09),('5815','2013-04-29','12:35:00',1.23),('5815','2013-04-29','12:40:00',2.36),('5815','2013-04-29','12:45:00',2.58),('5815','2013-04-29','12:50:00',2.46),('5815','2013-04-29','12:55:00',2.23),('5815','2013-04-29','13:00:00',2.32),('5815','2013-04-29','13:05:00',2.28),('5815','2013-04-29','13:10:00',2.35),('5815','2013-04-29','13:15:00',2.31),('5815','2013-04-29','13:20:00',2.28),('5815','2013-04-29','13:25:00',2.28),('5815','2013-04-29','13:30:00',2.26),('5815','2013-04-29','13:35:00',2.24),('5815','2013-04-29','13:40:00',2.24),('5815','2013-04-29','13:45:00',2.22),('5815','2013-04-29','13:50:00',2.2),('5815','2013-04-29','13:55:00',2.18),('5815','2013-04-29','14:00:00',2.17),('5815','2013-04-29','14:05:00',2.15),('5815','2013-04-29','14:10:00',2.14),('5815','2013-04-29','14:15:00',2.13),('5815','2013-04-29','14:20:00',2.13),('5815','2013-04-29','14:25:00',2.12),('5815','2013-04-29','14:30:00',2.1),('5815','2013-04-29','14:35:00',2.09),('5815','2013-04-29','14:40:00',2.07),('5815','2013-04-29','14:45:00',2.05),('5815','2013-04-29','14:50:00',2.03),('5815','2013-04-29','14:55:00',1.99),('5815','2013-04-29','15:00:00',1.97),('5815','2013-04-29','15:05:00',1.91),('5815','2013-04-29','15:10:00',1.92),('5815','2013-04-29','15:15:00',1.9),('5815','2013-04-29','15:20:00',1.88),('5815','2013-04-29','15:25:00',1.85),('5815','2013-04-29','15:30:00',1.82),('5815','2013-04-29','15:35:00',1.82),('5815','2013-04-29','15:40:00',1.79),('5815','2013-04-29','15:45:00',1.76),('5815','2013-04-29','15:50:00',1.71),('5815','2013-04-29','15:55:00',1.68),('5815','2013-04-29','16:00:00',1.65),('5815','2013-04-29','16:05:00',1.61),('5815','2013-04-29','16:10:00',1.58),('5815','2013-04-29','16:15:00',1.55),('5815','2013-04-29','16:20:00',1.5),('5815','2013-04-29','16:25:00',1.47),('5815','2013-04-29','16:30:00',1.44),('5815','2013-04-29','16:35:00',1.38),('5815','2013-04-29','16:40:00',1.19),('5815','2013-04-29','16:45:00',1.22),('5815','2013-04-29','16:50:00',1.01),('5815','2013-04-29','16:55:00',1.16),('5815','2013-04-29','17:00:00',1.11),('5815','2013-04-29','17:05:00',1.11),('5815','2013-04-28','08:35:00',1.04),('5815','2013-04-28','08:40:00',1.07),('5815','2013-04-28','08:45:00',1.04),('5815','2013-04-28','08:50:00',1.13),('5815','2013-04-28','08:55:00',1.14),('5815','2013-04-28','09:05:00',1.18),('5815','2013-04-28','09:10:00',1.34),('5815','2013-04-28','09:15:00',1.42),('5815','2013-04-28','09:20:00',1.36),('5815','2013-04-28','09:25:00',1.32),('5815','2013-04-28','09:30:00',1.32),('5815','2013-04-28','09:35:00',1.42),('5815','2013-04-28','09:40:00',1.43),('5815','2013-04-28','09:45:00',1.48),('5815','2013-04-28','09:50:00',1.59),('5815','2013-04-28','09:55:00',1.48),('5815','2013-04-28','10:00:00',1.55),('5815','2013-04-28','10:05:00',1.56),('5815','2013-04-28','10:10:00',1.54),('5815','2013-04-28','10:15:00',1.31),('5815','2013-04-28','10:20:00',1.24),('5815','2013-04-28','10:25:00',1.55),('5815','2013-04-28','10:30:00',1.52),('5815','2013-04-28','10:35:00',1.82),('5815','2013-04-28','10:40:00',1.84),('5815','2013-04-28','10:45:00',1.87),('5815','2013-04-28','10:50:00',1.8),('5815','2013-04-28','10:55:00',1.68),('5815','2013-04-28','11:00:00',1.87),('5815','2013-04-28','11:05:00',1.84),('5815','2013-04-28','11:10:00',1.77),('5815','2013-04-28','11:15:00',1.65),('5815','2013-04-28','11:20:00',1.93),('5815','2013-04-28','11:25:00',2),('5815','2013-04-28','11:30:00',2.09),('5815','2013-04-28','11:35:00',2.01),('5815','2013-04-28','11:40:00',2.03),('5815','2013-04-28','11:45:00',2),('5815','2013-04-28','11:50:00',2.18),('5815','2013-04-28','11:55:00',2.18),('5815','2013-04-28','12:00:00',2.25),('5815','2013-04-28','12:05:00',2.27),('5815','2013-04-28','12:10:00',2.19),('5815','2013-04-28','12:15:00',2.19),('5815','2013-04-28','12:20:00',2.23),('5815','2013-04-28','12:25:00',2.17),('5815','2013-04-28','12:30:00',2.2),('5815','2013-04-28','12:35:00',2.27),('5815','2013-04-28','12:40:00',2.34),('5815','2013-04-28','12:45:00',2.35),('5815','2013-04-28','12:50:00',2.36),('5815','2013-04-28','12:55:00',2.29),('5815','2013-04-28','13:00:00',2.35),('5815','2013-04-28','13:05:00',2.32),('5815','2013-04-28','13:10:00',2.24),('5815','2013-04-28','13:15:00',2.13),('5815','2013-04-28','13:20:00',2.26),('5815','2013-04-28','13:25:00',2.38),('5815','2013-04-28','13:30:00',2.35),('5815','2013-04-28','13:35:00',2.3),('5815','2013-04-28','13:40:00',2.34),('5815','2013-04-28','13:45:00',2.3),('5815','2013-04-28','13:50:00',2.21),('5815','2013-04-28','13:55:00',2.42),('5815','2013-04-28','14:00:00',2.25),('5815','2013-04-28','14:05:00',2.24),('5815','2013-04-28','14:10:00',2.28),('5815','2013-04-28','14:15:00',2.32),('5815','2013-04-28','14:20:00',2.32),('5815','2013-04-28','14:25:00',2.25),('5815','2013-04-28','14:30:00',2.15),('5815','2013-04-28','14:35:00',2.09),('5815','2013-04-28','14:40:00',1.99),('5815','2013-04-28','14:45:00',2.15),('5815','2013-04-28','14:50:00',2.07),('5815','2013-04-28','14:55:00',2.11),('5815','2013-04-28','15:00:00',2.03),('5815','2013-04-28','15:05:00',2.15),('5815','2013-04-28','15:10:00',1.97),('5815','2013-04-28','15:15:00',1.82),('5815','2013-04-28','15:20:00',1.93),('5815','2013-04-28','15:25:00',2.07),('5815','2013-04-28','15:30:00',2.02),('5815','2013-04-28','15:35:00',1.8),('5815','2013-04-28','15:40:00',1.63),('5815','2013-04-28','15:45:00',1.56),('5815','2013-04-28','15:50:00',1.58),('5815','2013-04-28','15:55:00',1.69),('5815','2013-04-28','16:00:00',1.64),('5815','2013-04-28','16:05:00',1.76),('5815','2013-04-28','16:10:00',1.65),('5815','2013-04-28','16:15:00',1.91),('5815','2013-04-28','16:20:00',1.87),('5815','2013-04-28','16:25:00',1.42),('5815','2013-04-28','16:30:00',1.5),('5815','2013-04-28','16:35:00',1.5),('5815','2013-04-28','16:40:00',1.6),('5815','2013-04-28','16:45:00',1.57),('5815','2013-04-28','16:50:00',1.61),('5815','2013-04-28','16:55:00',1.67),('5815','2013-04-28','17:00:00',1.55),('5815','2013-04-28','17:05:00',1.34),('5815','2013-04-28','17:10:00',1.37),('5815','2013-04-28','17:15:00',1.2),('5815','2013-04-27','08:45:00',1.05),('5815','2013-04-27','08:50:00',1.1),('5815','2013-04-27','08:55:00',1.14),('5815','2013-04-27','09:00:00',1.2),('5815','2013-04-27','09:05:00',1.24),('5815','2013-04-27','09:10:00',1.3),('5815','2013-04-27','09:15:00',1.35),('5815','2013-04-27','09:20:00',1.39),('5815','2013-04-27','09:25:00',1.43),('5815','2013-04-27','09:30:00',1.48),('5815','2013-04-27','09:35:00',1.53),('5815','2013-04-27','09:40:00',1.56),('5815','2013-04-27','09:45:00',1.62),('5815','2013-04-27','09:50:00',1.66),('5815','2013-04-27','09:55:00',1.7),('5815','2013-04-27','10:00:00',1.73),('5815','2013-04-27','10:05:00',1.75),('5815','2013-04-27','10:10:00',1.81),('5815','2013-04-27','10:15:00',1.79),('5815','2013-04-27','10:20:00',1.86),('5815','2013-04-27','10:25:00',1.92),('5815','2013-04-27','10:30:00',1.89),('5815','2013-04-27','10:35:00',1.95),('5815','2013-04-27','10:40:00',1.78),('5815','2013-04-27','10:45:00',2.04),('5815','2013-04-27','10:50:00',2.05),('5815','2013-04-27','10:55:00',2.06),('5815','2013-04-27','11:00:00',2.08),('5815','2013-04-27','11:05:00',2.07),('5815','2013-04-27','11:10:00',2.12),('5815','2013-04-27','11:15:00',2.14),('5815','2013-04-27','11:20:00',2.16),('5815','2013-04-27','11:25:00',2.2),('5815','2013-04-27','11:30:00',2.23),('5815','2013-04-27','11:35:00',2.18),('5815','2013-04-27','11:40:00',2.21),('5815','2013-04-27','11:45:00',2.15),('5815','2013-04-27','11:50:00',2.16),('5815','2013-04-27','11:55:00',2.25),('5815','2013-04-27','12:00:00',1.98),('5815','2013-04-27','12:05:00',1.95),('5815','2013-04-27','12:10:00',2.15),('5815','2013-04-27','12:15:00',2.27),('5815','2013-04-27','12:20:00',2.21),('5815','2013-04-27','12:25:00',1.97),('5815','2013-04-27','12:30:00',1.92),('5815','2013-04-27','12:35:00',1.72),('5815','2013-04-27','12:40:00',1.73),('5815','2013-04-27','12:45:00',2.22),('5815','2013-04-27','12:50:00',2.33),('5815','2013-04-27','12:55:00',2.15),('5815','2013-04-27','13:00:00',2.23),('5815','2013-04-27','13:05:00',2.39),('5815','2013-04-27','13:10:00',2.37),('5815','2013-04-27','13:15:00',2.21),('5815','2013-04-27','13:20:00',2.22),('5815','2013-04-27','13:25:00',2.23),('5815','2013-04-27','13:30:00',2.36),('5815','2013-04-27','13:35:00',2.33),('5815','2013-04-27','13:40:00',2.44),('5815','2013-04-27','13:45:00',2.41),('5815','2013-04-27','13:50:00',2.36),('5815','2013-04-27','13:55:00',2.2),('5815','2013-04-27','14:00:00',2.31),('5815','2013-04-27','14:05:00',2.32),('5815','2013-04-27','14:10:00',2.25),('5815','2013-04-27','14:15:00',2.29),('5815','2013-04-27','14:20:00',2.12),('5815','2013-04-27','14:25:00',2.07),('5815','2013-04-27','14:30:00',2.22),('5815','2013-04-27','14:35:00',2.23),('5815','2013-04-27','14:40:00',2.2),('5815','2013-04-27','14:45:00',2.18),('5815','2013-04-27','14:50:00',2.16),('5815','2013-04-27','14:55:00',2.12),('5815','2013-04-27','15:00:00',2.12),('5815','2013-04-27','15:05:00',2.1),('5815','2013-04-27','15:10:00',2.09),('5815','2013-04-27','15:15:00',2.1),('5815','2013-04-27','15:20:00',2.07),('5815','2013-04-27','15:25:00',2.03),('5815','2013-04-27','15:30:00',2),('5815','2013-04-27','15:35:00',1.96),('5815','2013-04-27','15:40:00',1.93),('5815','2013-04-27','15:45:00',1.92),('5815','2013-04-27','15:50:00',1.89),('5815','2013-04-27','15:55:00',1.86),('5815','2013-04-27','16:00:00',1.82),('5815','2013-04-27','16:05:00',1.79),('5815','2013-04-27','16:10:00',1.76),('5815','2013-04-27','16:15:00',1.71),('5815','2013-04-27','16:20:00',1.68),('5815','2013-04-27','16:25:00',1.62),('5815','2013-04-27','16:30:00',1.59),('5815','2013-04-27','16:35:00',1.55),('5815','2013-04-27','16:40:00',1.51),('5815','2013-04-27','16:45:00',1.47),('5815','2013-04-27','16:50:00',1.43),('5815','2013-04-27','16:55:00',1.39),('5815','2013-04-27','17:00:00',1.34),('5815','2013-04-27','17:05:00',1.25),('5815','2013-04-27','17:10:00',1.17),('5815','2013-04-27','17:15:00',1.21),('5815','2013-04-27','17:20:00',1.15),('5815','2013-04-27','17:25:00',1.09),('5815','2013-04-26','14:30:00',1.21),('5815','2013-04-26','14:35:00',1.09),('5815','2013-04-26','16:50:00',1.07),('5815','2013-04-26','16:55:00',1.05),('5815','2013-04-26','17:00:00',1.48),('5815','2013-04-26','17:05:00',1.08),('5815','2013-04-25','09:10:00',1.03),('5815','2013-04-25','09:40:00',1.2),('5815','2013-04-25','09:45:00',1.42),('5815','2013-04-25','09:50:00',1.43),('5815','2013-04-25','10:05:00',1.21),('5815','2013-04-25','10:10:00',1.63),('5815','2013-04-25','10:15:00',1.73),('5815','2013-04-25','10:20:00',1.77),('5815','2013-04-25','10:25:00',1.42),('5815','2013-04-25','10:30:00',1.79),('5815','2013-04-25','10:35:00',1.95),('5815','2013-04-25','10:40:00',1.96),('5815','2013-04-25','10:45:00',1.71),('5815','2013-04-25','10:50:00',1.12),('5815','2013-04-25','10:55:00',1.56),('5815','2013-04-25','11:00:00',1.69),('5815','2013-04-25','11:05:00',1.95),('5815','2013-04-25','11:10:00',1.74),('5815','2013-04-25','11:15:00',2.01),('5815','2013-04-25','11:20:00',1.69),('5815','2013-04-25','11:25:00',1.72),('5815','2013-04-25','11:30:00',1.72),('5815','2013-04-25','11:35:00',1.91),('5815','2013-04-25','11:40:00',1.97),('5815','2013-04-25','11:45:00',1.97),('5815','2013-04-25','11:50:00',1.57),('5815','2013-04-25','11:55:00',1.46),('5815','2013-04-25','12:00:00',1.56),('5815','2013-04-25','12:05:00',1.49),('5815','2013-04-25','12:10:00',1.29),('5815','2013-04-25','12:15:00',1.39),('5815','2013-04-25','12:20:00',1.37),('5815','2013-04-25','12:25:00',1.17),('5815','2013-04-25','12:35:00',1.23),('5815','2013-04-25','12:40:00',1.86),('5815','2013-04-25','12:45:00',2.14),('5815','2013-04-25','12:50:00',1.33),('5815','2013-04-25','12:55:00',1.12),('5815','2013-04-25','13:15:00',1.27),('5815','2013-04-25','13:25:00',1.08),('5815','2013-04-25','13:30:00',1.39),('5815','2013-04-25','13:35:00',1.26),('5815','2013-04-25','13:40:00',1.51),('5815','2013-04-25','13:45:00',1.25),('5815','2013-04-25','13:50:00',1.71),('5815','2013-04-25','13:55:00',1.45),('5815','2013-04-25','14:00:00',1.55),('5815','2013-04-25','14:05:00',2.01),('5815','2013-04-25','14:10:00',1.9),('5815','2013-04-25','14:15:00',2.1),('5815','2013-04-25','14:20:00',1.84),('5815','2013-04-25','14:25:00',2.1),('5815','2013-04-25','14:30:00',2.25),('5815','2013-04-25','14:35:00',1.76),('5815','2013-04-25','14:40:00',1.05),('5815','2013-04-25','14:50:00',2.1),('5815','2013-04-25','14:55:00',2.37),('5815','2013-04-25','15:00:00',2.2),('5815','2013-04-25','15:05:00',1.84),('5815','2013-04-25','15:30:00',1.18),('5815','2013-04-25','15:35:00',1.04),('5815','2013-04-25','15:40:00',1.04),('5815','2013-04-25','15:45:00',1.18),('5815','2013-04-25','15:50:00',1.04),('5815','2013-04-24','08:50:00',1.05),('5815','2013-04-24','08:55:00',1.27),('5815','2013-04-24','09:00:00',1.1),('5815','2013-04-24','09:40:00',1.23),('5815','2013-04-24','09:45:00',1.45),('5815','2013-04-24','09:50:00',1.7),('5815','2013-04-24','09:55:00',1.71),('5815','2013-04-24','10:00:00',1.73),('5815','2013-04-24','10:05:00',1.65),('5815','2013-04-24','10:10:00',1.52),('5815','2013-04-24','10:15:00',1.59),('5815','2013-04-24','10:20:00',1.81),('5815','2013-04-24','10:25:00',1.86),('5815','2013-04-24','10:30:00',1.91),('5815','2013-04-24','10:35:00',1.95),('5815','2013-04-24','10:40:00',1.96),('5815','2013-04-24','10:45:00',1.9),('5815','2013-04-24','10:50:00',1.99),('5815','2013-04-24','10:55:00',2.04),('5815','2013-04-24','11:00:00',2.08),('5815','2013-04-24','11:05:00',2.12),('5815','2013-04-24','11:10:00',2.13),('5815','2013-04-24','11:15:00',2.14),('5815','2013-04-24','11:20:00',2.16),('5815','2013-04-24','11:25:00',2.18),('5815','2013-04-24','11:30:00',2.16),('5815','2013-04-24','11:35:00',2.24),('5815','2013-04-24','11:40:00',2.25),('5815','2013-04-24','11:45:00',2.28),('5815','2013-04-24','11:50:00',2.3),('5815','2013-04-24','11:55:00',2.28),('5815','2013-04-24','12:00:00',2.24),('5815','2013-04-24','12:05:00',2.25),('5815','2013-04-24','12:10:00',2.29),('5815','2013-04-24','12:15:00',2.3),('5815','2013-04-24','12:20:00',2.31),('5815','2013-04-24','12:25:00',2.31),('5815','2013-04-24','12:30:00',2.32),('5815','2013-04-24','12:35:00',2.32),('5815','2013-04-24','12:40:00',2.32),('5815','2013-04-24','12:45:00',2.33),('5815','2013-04-24','12:50:00',2.33),('5815','2013-04-24','12:55:00',2.35),('5815','2013-04-24','13:00:00',2.37),('5815','2013-04-24','13:05:00',2.41),('5815','2013-04-24','13:10:00',2.35),('5815','2013-04-24','13:15:00',2.29),('5815','2013-04-24','13:20:00',2.16),('5815','2013-04-24','13:25:00',2.17),('5815','2013-04-24','13:30:00',1.71),('5815','2013-04-24','13:35:00',1.66),('5815','2013-04-24','13:40:00',1.36),('5815','2013-04-24','13:45:00',1.22),('5815','2013-04-24','13:50:00',1.13),('5815','2013-04-24','13:55:00',1.19),('5815','2013-04-24','14:00:00',1.28),('5815','2013-04-24','14:05:00',1.16),('5815','2013-04-24','14:10:00',1.26),('5815','2013-04-24','14:15:00',1.33),('5815','2013-04-24','14:20:00',1.38),('5815','2013-04-24','14:25:00',1.4),('5815','2013-04-24','14:30:00',1.66),('5815','2013-04-24','14:35:00',2),('5815','2013-04-24','14:40:00',1.93),('5815','2013-04-24','14:45:00',1.97),('5815','2013-04-24','14:50:00',1.79),('5815','2013-04-24','14:55:00',1.9),('5815','2013-04-24','15:00:00',1.81),('5815','2013-04-24','15:05:00',1.67),('5815','2013-04-24','15:10:00',1.6),('5815','2013-04-24','15:15:00',1.84),('5815','2013-04-24','15:20:00',1.96),('5815','2013-04-24','15:25:00',2),('5815','2013-04-24','15:30:00',1.97),('5815','2013-04-24','15:35:00',1.86),('5815','2013-04-24','15:40:00',1.76),('5815','2013-04-24','15:45:00',1.65),('5815','2013-04-24','15:50:00',1.56),('5815','2013-04-24','15:55:00',1.51),('5815','2013-04-24','16:00:00',1.54),('5815','2013-04-24','16:05:00',1.29),('5815','2013-04-24','16:10:00',1.29),('5815','2013-04-24','16:15:00',1.25),('5815','2013-04-24','16:20:00',1.3),('5815','2013-04-24','16:25:00',1.18),('5815','2013-04-24','16:30:00',1.08),('5815','2013-04-24','16:35:00',1.37),('5815','2013-04-24','16:40:00',1.15),('5815','2013-04-24','16:45:00',1.24),('5815','2013-04-24','16:50:00',1.04),('5815','2013-04-24','16:55:00',1.07),('5815','2013-04-24','17:00:00',1.02),('5815','2013-04-24','17:05:00',1.19),('5815','2013-04-24','17:10:00',1.33),('5815','2013-04-24','17:15:00',1.22),('5815','2013-04-24','17:20:00',1.2),('5815','2013-04-24','17:25:00',1.01),('5815','2013-04-23','08:55:00',1.04),('5815','2013-04-23','09:00:00',1.14),('5815','2013-04-23','09:05:00',1.28),('5815','2013-04-23','09:10:00',1.31),('5815','2013-04-23','09:15:00',1.26),('5815','2013-04-23','09:20:00',1.07),('5815','2013-04-23','09:25:00',1.22),('5815','2013-04-23','09:30:00',1.49),('5815','2013-04-23','09:35:00',1.54),('5815','2013-04-23','09:40:00',1.45),('5815','2013-04-23','09:45:00',1.45),('5815','2013-04-23','09:50:00',1.53),('5815','2013-04-23','09:55:00',1.77),('5815','2013-04-23','10:00:00',1.77),('5815','2013-04-23','10:05:00',1.83),('5815','2013-04-23','10:10:00',1.84),('5815','2013-04-23','10:15:00',1.84),('5815','2013-04-23','10:20:00',1.85),('5815','2013-04-23','10:25:00',1.84),('5815','2013-04-23','10:30:00',1.83),('5815','2013-04-23','10:35:00',1.8),('5815','2013-04-23','10:40:00',1.98),('5815','2013-04-23','10:45:00',2.06),('5815','2013-04-23','10:50:00',2.04),('5815','2013-04-23','10:55:00',2.13),('5815','2013-04-23','11:00:00',2.17),('5815','2013-04-23','11:05:00',2.11),('5815','2013-04-23','11:10:00',2.23),('5815','2013-04-23','11:15:00',2.31),('5815','2013-04-23','11:20:00',2.36),('5815','2013-04-23','11:25:00',2.45),('5815','2013-04-23','11:30:00',2.34),('5815','2013-04-23','11:35:00',1.95),('5815','2013-04-23','11:40:00',1.37),('5815','2013-04-23','11:45:00',1.58),('5815','2013-04-23','11:50:00',1.15),('5815','2013-04-23','11:55:00',1.5),('5815','2013-04-23','12:00:00',1.93),('5815','2013-04-23','12:05:00',1.36),('5815','2013-04-23','12:10:00',1.62),('5815','2013-04-23','12:15:00',2.16),('5815','2013-04-23','12:20:00',2.62),('5815','2013-04-23','12:25:00',2.24),('5815','2013-04-23','12:30:00',2.21),('5815','2013-04-23','12:35:00',2.24),('5815','2013-04-23','12:40:00',2.07),('5815','2013-04-23','12:45:00',2.22),('5815','2013-04-23','12:50:00',2.38),('5815','2013-04-23','12:55:00',2.25),('5815','2013-04-23','13:00:00',2.14),('5815','2013-04-23','13:05:00',1.89),('5815','2013-04-23','13:10:00',2.53),('5815','2013-04-23','13:15:00',2.2),('5815','2013-04-23','13:20:00',2.21),('5815','2013-04-23','13:25:00',2.21),('5815','2013-04-23','13:30:00',2.09),('5815','2013-04-23','13:35:00',1.97),('5815','2013-04-23','13:40:00',2.52),('5815','2013-04-23','13:45:00',2.03),('5815','2013-04-23','13:50:00',1.49),('5815','2013-04-23','13:55:00',2.29),('5815','2013-04-23','14:00:00',2.29),('5815','2013-04-23','14:05:00',1.64),('5815','2013-04-23','14:10:00',1.57),('5815','2013-04-23','14:15:00',2.36),('5815','2013-04-23','14:20:00',2.05),('5815','2013-04-23','14:25:00',2.19),('5815','2013-04-23','14:30:00',2.09),('5815','2013-04-23','14:35:00',1.8),('5815','2013-04-23','14:40:00',1.69),('5815','2013-04-23','14:45:00',1.7),('5815','2013-04-23','14:50:00',1.48),('5815','2013-04-23','14:55:00',1.34),('5815','2013-04-23','15:00:00',1.48),('5815','2013-04-23','15:05:00',1.35),('5815','2013-04-23','15:10:00',1.26),('5815','2013-04-23','15:15:00',1.34),('5815','2013-04-23','15:20:00',1.39),('5815','2013-04-23','15:25:00',1.17),('5815','2013-04-23','15:55:00',1.21),('5815','2013-04-23','16:00:00',1.48),('5815','2013-04-23','16:05:00',1.56),('5815','2013-04-23','16:10:00',1.56),('5815','2013-04-23','16:15:00',1.5),('5815','2013-04-23','16:20:00',1.99),('5815','2013-04-23','16:25:00',1.47),('5815','2013-04-23','16:30:00',1.26),('5815','2013-04-23','16:35:00',1.01),('5815','2013-04-23','16:40:00',1.41),('5815','2013-04-23','16:45:00',1.47),('5815','2013-04-23','16:50:00',1.3),('5815','2013-04-23','16:55:00',1.55),('5815','2013-04-23','17:00:00',1.57),('5815','2013-04-23','17:05:00',1.47),('5815','2013-04-23','17:10:00',1.42),('5815','2013-04-23','17:15:00',1.07),('5815','2013-04-22','08:40:00',1.03),('5815','2013-04-22','08:45:00',1.09),('5815','2013-04-22','08:50:00',1.15),('5815','2013-04-22','08:55:00',1.2),('5815','2013-04-22','09:00:00',1.25),('5815','2013-04-22','09:05:00',1.3),('5815','2013-04-22','09:10:00',1.35),('5815','2013-04-22','09:15:00',1.41),('5815','2013-04-22','09:20:00',1.47),('5815','2013-04-22','09:25:00',1.51),('5815','2013-04-22','09:30:00',1.55),('5815','2013-04-22','09:35:00',1.61),('5815','2013-04-22','09:40:00',1.55),('5815','2013-04-22','09:45:00',1.42),('5815','2013-04-22','09:50:00',1.75),('5815','2013-04-22','09:55:00',1.79),('5815','2013-04-22','10:00:00',1.82),('5815','2013-04-22','10:05:00',1.86),('5815','2013-04-22','10:10:00',1.89),('5815','2013-04-22','10:15:00',1.93),('5815','2013-04-22','10:20:00',1.97),('5815','2013-04-22','10:25:00',2),('5815','2013-04-22','10:30:00',2.02),('5815','2013-04-22','10:35:00',2.05),('5815','2013-04-22','10:40:00',2.06),('5815','2013-04-22','10:45:00',2.05),('5815','2013-04-22','10:50:00',2.09),('5815','2013-04-22','10:55:00',2.15),('5815','2013-04-22','11:00:00',2.19),('5815','2013-04-22','11:05:00',2.19),('5815','2013-04-22','11:10:00',2.23),('5815','2013-04-22','11:15:00',2.26),('5815','2013-04-22','11:20:00',2.28),('5815','2013-04-22','11:25:00',2.31),('5815','2013-04-22','11:30:00',2.32),('5815','2013-04-22','11:35:00',2.32),('5815','2013-04-22','11:40:00',2.33),('5815','2013-04-22','11:45:00',2.34),('5815','2013-04-22','11:50:00',2.36),('5815','2013-04-22','11:55:00',2.36),('5815','2013-04-22','12:00:00',2.37),('5815','2013-04-22','12:05:00',2.37),('5815','2013-04-22','12:10:00',2.37),('5815','2013-04-22','12:15:00',2.39),('5815','2013-04-22','12:20:00',2.38),('5815','2013-04-22','12:25:00',2.38),('5815','2013-04-22','12:30:00',1.23),('5815','2013-04-22','12:40:00',1.6),('5815','2013-04-22','12:50:00',2.02),('5815','2013-04-22','12:55:00',1.35),('5815','2013-04-22','13:00:00',1.49),('5815','2013-04-22','13:05:00',2.09),('5815','2013-04-22','13:15:00',2.2),('5815','2013-04-22','13:20:00',2.44),('5815','2013-04-22','13:25:00',2.63),('5815','2013-04-22','13:30:00',2.48),('5815','2013-04-22','13:35:00',2.53),('5815','2013-04-22','13:40:00',2.6),('5815','2013-04-22','13:45:00',1.85),('5815','2013-04-22','13:50:00',2.22),('5815','2013-04-22','13:55:00',2.51),('5815','2013-04-22','14:00:00',1.69),('5815','2013-04-22','14:05:00',2.26),('5815','2013-04-22','14:10:00',1.79),('5815','2013-04-22','14:15:00',2.22),('5815','2013-04-22','14:20:00',2.31),('5815','2013-04-22','14:25:00',2.11),('5815','2013-04-22','14:30:00',2.43),('5815','2013-04-22','14:35:00',2.41),('5815','2013-04-22','14:40:00',2.39),('5815','2013-04-22','14:45:00',1.99),('5815','2013-04-22','14:50:00',1.29),('5815','2013-04-22','14:55:00',1.34),('5815','2013-04-22','15:00:00',1.34),('5815','2013-04-22','15:05:00',1.37),('5815','2013-04-22','15:10:00',1.61),('5815','2013-04-22','15:15:00',1.74),('5815','2013-04-22','15:20:00',1.59),('5815','2013-04-22','15:25:00',1.45),('5815','2013-04-22','15:30:00',1.43),('5815','2013-04-22','15:35:00',1.44),('5815','2013-04-22','15:40:00',1.2),('5815','2013-04-22','15:45:00',1.4),('5815','2013-04-22','15:50:00',1.06),('5815','2013-04-22','17:15:00',1.14),('5815','2013-04-22','17:20:00',1.1),('5815','2013-04-21','10:35:00',1.13),('5815','2013-04-21','10:40:00',1.96),('5815','2013-04-21','10:45:00',2.75),('5815','2013-04-21','10:50:00',1.35),('5815','2013-04-21','10:55:00',1.2),('5815','2013-04-21','11:00:00',1.13),('5815','2013-04-21','11:05:00',1.06),('5815','2013-04-21','11:10:00',1.35),('5815','2013-04-21','11:25:00',1.04),('5815','2013-04-21','11:30:00',1.65),('5815','2013-04-21','11:35:00',2.05),('5815','2013-04-21','11:40:00',2.33),('5815','2013-04-21','11:45:00',1.17),('5815','2013-04-21','11:55:00',2.03),('5815','2013-04-21','12:00:00',1.88),('5815','2013-04-21','12:05:00',1.9),('5815','2013-04-21','12:10:00',2.36),('5815','2013-04-21','12:15:00',1.89),('5815','2013-04-21','12:20:00',1.86),('5815','2013-04-21','12:25:00',1.73),('5815','2013-04-21','12:30:00',1.34),('5815','2013-04-21','12:35:00',1.29),('5815','2013-04-21','12:40:00',2.46),('5815','2013-04-21','12:45:00',2.3),('5815','2013-04-21','12:50:00',2.68),('5815','2013-04-21','12:55:00',2.64),('5815','2013-04-21','13:00:00',2.66),('5815','2013-04-21','13:05:00',2.61),('5815','2013-04-21','13:10:00',2.15),('5815','2013-04-21','13:15:00',2.51),('5815','2013-04-21','13:20:00',2.44),('5815','2013-04-21','13:25:00',1.38),('5815','2013-04-21','13:30:00',2.16),('5815','2013-04-21','13:35:00',1.53),('5815','2013-04-21','13:40:00',1.23),('5815','2013-04-21','13:45:00',2.48),('5815','2013-04-21','13:55:00',1.44),('5815','2013-04-21','14:10:00',1.17),('5815','2013-04-21','14:20:00',1.82),('5815','2013-04-21','14:25:00',1.49),('5815','2013-04-21','14:30:00',2.41),('5815','2013-04-21','14:35:00',1.91),('5815','2013-04-21','14:40:00',2.63),('5815','2013-04-21','14:45:00',2.68),('5815','2013-04-21','14:50:00',2.67),('5815','2013-04-21','14:55:00',2.65),('5815','2013-04-21','15:00:00',1.74),('5815','2013-04-21','15:05:00',1.58),('5815','2013-04-21','15:10:00',1.46),('5815','2013-04-21','15:25:00',1.11),('5815','2013-04-21','15:30:00',1.14),('5815','2013-04-21','15:45:00',1.87),('5815','2013-04-21','15:50:00',1.84),('5815','2013-04-20','08:50:00',1.34),('5815','2013-04-20','08:55:00',1.34),('5815','2013-04-20','09:05:00',1.03),('5815','2013-04-20','09:10:00',1.22),('5815','2013-04-20','09:15:00',1.35),('5815','2013-04-20','09:20:00',1.03),('5815','2013-04-20','09:25:00',1.15),('5815','2013-04-20','09:30:00',1.64),('5815','2013-04-20','09:35:00',1.68),('5815','2013-04-20','09:40:00',1.73),('5815','2013-04-20','09:45:00',1.78),('5815','2013-04-20','09:50:00',2.1),('5815','2013-04-20','09:55:00',1.97),('5815','2013-04-20','10:00:00',1.72),('5815','2013-04-20','10:05:00',1.34),('5815','2013-04-20','10:10:00',1.12),('5815','2013-04-20','10:20:00',1.65),('5815','2013-04-20','10:25:00',1.99),('5815','2013-04-20','10:30:00',1.72),('5815','2013-04-20','10:35:00',1.18),('5815','2013-04-20','10:40:00',1.49),('5815','2013-04-20','10:45:00',1.33),('5815','2013-04-20','10:50:00',2.23),('5815','2013-04-20','10:55:00',1.9),('5815','2013-04-20','11:00:00',2.28),('5815','2013-04-20','11:05:00',1.93),('5815','2013-04-20','11:10:00',2.3),('5815','2013-04-20','11:15:00',1.9),('5815','2013-04-20','11:20:00',1.79),('5815','2013-04-20','11:25:00',1.92),('5815','2013-04-20','11:30:00',1.74),('5815','2013-04-20','11:35:00',1.55),('5815','2013-04-20','11:40:00',1.92),('5815','2013-04-20','11:45:00',2.1),('5815','2013-04-20','11:50:00',1.81),('5815','2013-04-20','11:55:00',1.77),('5815','2013-04-20','12:00:00',1.49),('5815','2013-04-20','12:05:00',1.42),('5815','2013-04-20','12:10:00',1.42),('5815','2013-04-20','12:15:00',1.26),('5815','2013-04-20','12:20:00',1.15),('5815','2013-04-20','12:25:00',1.08),('5815','2013-04-20','12:30:00',1.19),('5815','2013-04-20','12:35:00',1.23),('5815','2013-04-20','12:40:00',1.23),('5815','2013-04-20','12:45:00',1.24),('5815','2013-04-20','12:50:00',1.15),('5815','2013-04-20','12:55:00',1.11),('5815','2013-04-20','13:00:00',1.28),('5815','2013-04-20','13:05:00',1.5),('5815','2013-04-20','13:10:00',1.55),('5815','2013-04-20','13:15:00',1.44),('5815','2013-04-20','13:20:00',1.35),('5815','2013-04-20','13:25:00',1.27),('5815','2013-04-20','13:30:00',1.84),('5815','2013-04-20','13:35:00',2.33),('5815','2013-04-20','13:40:00',1.63),('5815','2013-04-20','13:45:00',1.68),('5815','2013-04-20','13:50:00',1.54),('5815','2013-04-20','13:55:00',2.17),('5815','2013-04-20','14:00:00',2.77),('5815','2013-04-20','14:05:00',2.19),('5815','2013-04-20','14:10:00',2.33),('5815','2013-04-20','14:15:00',2.08),('5815','2013-04-20','14:20:00',2.71),('5815','2013-04-20','14:25:00',2.19),('5815','2013-04-20','14:30:00',2.36),('5815','2013-04-20','14:35:00',2.42),('5815','2013-04-20','14:40:00',2.65),('5815','2013-04-20','14:45:00',2.34),('5815','2013-04-20','14:50:00',1.27),('5815','2013-04-20','14:55:00',1.16),('5815','2013-04-20','15:00:00',1.58),('5815','2013-04-20','15:05:00',2.39),('5815','2013-04-20','15:10:00',2.54),('5815','2013-04-20','15:15:00',1.96),('5815','2013-04-20','15:20:00',1.23),('5815','2013-04-20','15:25:00',1.12),('5815','2013-04-19','08:50:00',1.03),('5815','2013-04-19','08:55:00',1.04),('5815','2013-04-19','09:00:00',1.19),('5815','2013-04-19','09:05:00',1.26),('5815','2013-04-19','09:10:00',1.22),('5815','2013-04-19','09:15:00',1.18),('5815','2013-04-19','09:20:00',1.45),('5815','2013-04-19','09:25:00',1.35),('5815','2013-04-19','09:30:00',1.24),('5815','2013-04-19','09:35:00',1.01),('5815','2013-04-19','10:50:00',1.37),('5815','2013-04-19','10:55:00',1.25),('5815','2013-04-19','11:00:00',1.67),('5815','2013-04-19','11:05:00',1.58),('5815','2013-04-19','11:15:00',2.27),('5815','2013-04-19','11:20:00',2.03),('5815','2013-04-19','11:25:00',1.03),('5815','2013-04-19','11:30:00',2.57),('5815','2013-04-19','11:35:00',2.27),('5815','2013-04-19','11:40:00',1.04),('5815','2013-04-19','11:45:00',1.7),('5815','2013-04-19','11:50:00',1.52),('5815','2013-04-19','11:55:00',2.35),('5815','2013-04-19','12:00:00',2.64),('5815','2013-04-19','12:05:00',1.47),('5815','2013-04-19','12:10:00',2.46),('5815','2013-04-19','12:15:00',2.56),('5815','2013-04-19','12:20:00',1.51),('5815','2013-04-19','12:25:00',2.1),('5815','2013-04-19','12:30:00',1.29),('5815','2013-04-19','12:35:00',2.6),('5815','2013-04-19','12:40:00',1.17),('5815','2013-04-19','12:45:00',2.58),('5815','2013-04-19','12:50:00',2.71),('5815','2013-04-19','12:55:00',2.72),('5815','2013-04-19','13:00:00',1.01),('5815','2013-04-19','13:05:00',1.4),('5815','2013-04-19','13:10:00',2.68),('5815','2013-04-19','13:15:00',2.55),('5815','2013-04-19','13:20:00',1.15),('5815','2013-04-19','13:25:00',2.04),('5815','2013-04-19','13:30:00',1.89),('5815','2013-04-19','13:35:00',1.12),('5815','2013-04-19','13:40:00',2.61),('5815','2013-04-19','13:45:00',1.37),('5815','2013-04-19','13:50:00',1.34),('5815','2013-04-19','13:55:00',1.82),('5815','2013-04-19','14:00:00',1.68),('5815','2013-04-19','14:05:00',2.42),('5815','2013-04-19','14:10:00',2.67),('5815','2013-04-19','14:15:00',2.29),('5815','2013-04-19','14:20:00',2.4),('5815','2013-04-19','14:25:00',2.43),('5815','2013-04-19','14:30:00',2.4),('5815','2013-04-19','14:35:00',2.35),('5815','2013-04-19','14:40:00',2.34),('5815','2013-04-19','14:45:00',2.34),('5815','2013-04-19','14:50:00',2.38),('5815','2013-04-19','14:55:00',2.37),('5815','2013-04-19','15:00:00',2.35),('5815','2013-04-19','15:05:00',2.31),('5815','2013-04-19','15:10:00',1.67),('5815','2013-04-19','15:15:00',1.64),('5815','2013-04-19','15:20:00',1.45),('5815','2013-04-19','15:25:00',2.01),('5815','2013-04-19','15:30:00',1.37),('5815','2013-04-19','16:15:00',1.3),('5815','2013-04-19','16:20:00',1.32),('5815','2013-04-19','16:25:00',1.41),('5815','2013-04-19','16:30:00',1.74),('5815','2013-04-19','16:35:00',1.72),('5815','2013-04-19','16:40:00',1.52),('5815','2013-04-19','16:45:00',1.55),('5815','2013-04-19','16:50:00',1.6),('5815','2013-04-19','16:55:00',1.55),('5815','2013-04-19','17:00:00',1.46),('5815','2013-04-19','17:05:00',1.41),('5815','2013-04-19','17:10:00',1.36),('5815','2013-04-19','17:15:00',1.27),('5815','2013-04-19','17:20:00',1.03),('5815','2013-04-19','17:25:00',1.2),('5815','2013-04-19','17:30:00',1.2),('5815','2013-04-19','17:35:00',1.19),('5815','2013-04-18','08:50:00',1.02),('5815','2013-04-18','08:55:00',1.09),('5815','2013-04-18','09:00:00',1.13),('5815','2013-04-18','09:05:00',1.15),('5815','2013-04-18','09:10:00',1.22),('5815','2013-04-18','09:15:00',1.26),('5815','2013-04-18','09:20:00',1.31),('5815','2013-04-18','09:25:00',1.34),('5815','2013-04-18','09:30:00',1.41),('5815','2013-04-18','09:35:00',1.46),('5815','2013-04-18','09:40:00',1.5),('5815','2013-04-18','09:45:00',1.53),('5815','2013-04-18','09:50:00',1.55),('5815','2013-04-18','09:55:00',1.59),('5815','2013-04-18','10:00:00',1.64),('5815','2013-04-18','10:05:00',1.68),('5815','2013-04-18','10:10:00',1.71),('5815','2013-04-18','10:15:00',1.77),('5815','2013-04-18','10:20:00',1.37),('5815','2013-04-18','10:25:00',1.74),('5815','2013-04-18','10:30:00',1.6),('5815','2013-04-18','10:35:00',1.68),('5815','2013-04-18','10:40:00',1.92),('5815','2013-04-18','10:45:00',1.92),('5815','2013-04-18','10:50:00',1.97),('5815','2013-04-18','10:55:00',1.96),('5815','2013-04-18','11:00:00',1.99),('5815','2013-04-18','11:05:00',2.01),('5815','2013-04-18','11:10:00',2.03),('5815','2013-04-18','11:15:00',2.06),('5815','2013-04-18','11:20:00',2.07),('5815','2013-04-18','11:25:00',2.09),('5815','2013-04-18','11:30:00',2.11),('5815','2013-04-18','11:35:00',2.15),('5815','2013-04-18','11:40:00',2.17),('5815','2013-04-18','11:45:00',2.2),('5815','2013-04-18','11:50:00',2.21),('5815','2013-04-18','11:55:00',2.22),('5815','2013-04-18','12:00:00',2.23),('5815','2013-04-18','12:05:00',2.24),('5815','2013-04-18','12:10:00',2.25),('5815','2013-04-18','12:15:00',2.28),('5815','2013-04-18','12:20:00',2.28),('5815','2013-04-18','12:25:00',2.28),('5815','2013-04-18','12:30:00',2.26),('5815','2013-04-18','12:35:00',2.24),('5815','2013-04-18','12:40:00',2.29),('5815','2013-04-18','12:45:00',2.31),('5815','2013-04-18','12:50:00',2.32),('5815','2013-04-18','12:55:00',2.29),('5815','2013-04-18','13:00:00',2.33),('5815','2013-04-18','13:05:00',2.33),('5815','2013-04-18','13:10:00',2.33),('5815','2013-04-18','13:15:00',2.36),('5815','2013-04-18','13:20:00',2.34),('5815','2013-04-18','13:25:00',2.35),('5815','2013-04-18','13:30:00',2.4),('5815','2013-04-18','13:35:00',2.34),('5815','2013-04-18','13:40:00',2.33),('5815','2013-04-18','13:45:00',2.32),('5815','2013-04-18','13:50:00',2.32),('5815','2013-04-18','13:55:00',2.27),('5815','2013-04-18','14:00:00',2.29),('5815','2013-04-18','14:05:00',2.27),('5815','2013-04-18','14:10:00',2.28),('5815','2013-04-18','14:15:00',2.25),('5815','2013-04-18','14:20:00',2.22),('5815','2013-04-18','14:25:00',2.2),('5815','2013-04-18','14:30:00',2.22),('5815','2013-04-18','14:35:00',2.18),('5815','2013-04-18','14:40:00',2.16),('5815','2013-04-18','14:45:00',2.14),('5815','2013-04-18','14:50:00',2.17),('5815','2013-04-18','14:55:00',2.17),('5815','2013-04-18','15:00:00',2.14),('5815','2013-04-18','15:05:00',2.13),('5815','2013-04-18','15:10:00',2.08),('5815','2013-04-18','15:15:00',2.02),('5815','2013-04-18','15:20:00',2.01),('5815','2013-04-18','15:25:00',2.01),('5815','2013-04-18','15:30:00',1.96),('5815','2013-04-18','15:35:00',1.93),('5815','2013-04-18','15:40:00',1.92),('5815','2013-04-18','15:45:00',1.89),('5815','2013-04-18','15:50:00',1.86),('5815','2013-04-18','15:55:00',1.84),('5815','2013-04-18','16:00:00',1.8),('5815','2013-04-18','16:05:00',1.77),('5815','2013-04-18','16:10:00',1.71),('5815','2013-04-18','16:15:00',1.66),('5815','2013-04-18','16:20:00',1.63),('5815','2013-04-18','16:25:00',1.61),('5815','2013-04-18','16:30:00',1.55),('5815','2013-04-18','16:35:00',1.51),('5815','2013-04-18','16:40:00',1.47),('5815','2013-04-18','16:45:00',1.42),('5815','2013-04-18','16:50:00',1.38),('5815','2013-04-18','16:55:00',1.33),('5815','2013-04-18','17:00:00',1.27),('5815','2013-04-18','17:05:00',1.22),('5815','2013-04-18','17:10:00',1.16),('5815','2013-04-18','17:15:00',1.11),('5815','2013-04-18','17:20:00',1.06),('5815','2013-04-18','17:25:00',1.01),('5815','2013-04-17','09:05:00',1.11),('5815','2013-04-17','09:10:00',1.11),('5815','2013-04-17','09:15:00',1.14),('5815','2013-04-17','09:20:00',1.26),('5815','2013-04-17','09:25:00',1.31),('5815','2013-04-17','09:30:00',1.36),('5815','2013-04-17','09:35:00',1.46),('5815','2013-04-17','09:40:00',1.65),('5815','2013-04-17','09:45:00',1.48),('5815','2013-04-17','09:50:00',1.3),('5815','2013-04-17','09:55:00',1.34),('5815','2013-04-17','10:00:00',1.61),('5815','2013-04-17','10:05:00',1.74),('5815','2013-04-17','10:10:00',1.78),('5815','2013-04-17','10:15:00',1.86),('5815','2013-04-17','10:20:00',1.89),('5815','2013-04-17','10:25:00',1.88),('5815','2013-04-17','10:30:00',1.93),('5815','2013-04-17','10:35:00',1.95),('5815','2013-04-17','10:40:00',1.98),('5815','2013-04-17','10:45:00',2),('5815','2013-04-17','10:50:00',2.04),('5815','2013-04-17','10:55:00',2.07),('5815','2013-04-17','11:00:00',2.09),('5815','2013-04-17','11:05:00',2.11),('5815','2013-04-17','11:10:00',2.13),('5815','2013-04-17','11:15:00',2.15),('5815','2013-04-17','11:20:00',2.2),('5815','2013-04-17','11:25:00',2.22),('5815','2013-04-17','11:30:00',2.23),('5815','2013-04-17','11:35:00',2.25),('5815','2013-04-17','11:40:00',2.24),('5815','2013-04-17','11:45:00',2.23),('5815','2013-04-17','11:50:00',2.25),('5815','2013-04-17','11:55:00',2.3),('5815','2013-04-17','12:00:00',2.28),('5815','2013-04-17','12:05:00',2.37),('5815','2013-04-17','12:10:00',2.38),('5815','2013-04-17','12:15:00',2.36),('5815','2013-04-17','12:20:00',2.39),('5815','2013-04-17','12:25:00',2.41),('5815','2013-04-17','12:30:00',2.42),('5815','2013-04-17','12:35:00',2.42),('5815','2013-04-17','12:40:00',2.45),('5815','2013-04-17','12:45:00',2.43),('5815','2013-04-17','12:50:00',2.44),('5815','2013-04-17','12:55:00',2.46),('5815','2013-04-17','13:00:00',2.47),('5815','2013-04-17','13:05:00',2.46),('5815','2013-04-17','13:10:00',2.46),('5815','2013-04-17','13:15:00',2.46),('5815','2013-04-17','13:20:00',2.44),('5815','2013-04-17','13:25:00',2.45),('5815','2013-04-17','13:30:00',2.45),('5815','2013-04-17','13:35:00',2.45),('5815','2013-04-17','13:40:00',2.43),('5815','2013-04-17','13:45:00',2.44),('5815','2013-04-17','13:50:00',2.45),('5815','2013-04-17','13:55:00',2.44),('5815','2013-04-17','14:00:00',2.41),('5815','2013-04-17','14:05:00',2.43),('5815','2013-04-17','14:10:00',2.41),('5815','2013-04-17','14:15:00',2.4),('5815','2013-04-17','14:20:00',2.4),('5815','2013-04-17','14:25:00',2.4),('5815','2013-04-17','14:30:00',2.37),('5815','2013-04-17','14:35:00',2.35),('5815','2013-04-17','14:40:00',2.34),('5815','2013-04-17','14:45:00',2.32),('5815','2013-04-17','14:50:00',2.27),('5815','2013-04-17','14:55:00',2.26),('5815','2013-04-17','15:00:00',2.23),('5815','2013-04-17','15:05:00',2.22),('5815','2013-04-17','15:10:00',2.2),('5815','2013-04-17','15:15:00',2.18),('5815','2013-04-17','15:20:00',2.15),('5815','2013-04-17','15:25:00',2.12),('5815','2013-04-17','15:30:00',2.09),('5815','2013-04-17','15:35:00',2.07),('5815','2013-04-17','15:40:00',2.03),('5815','2013-04-17','15:45:00',1.99),('5815','2013-04-17','15:50:00',1.96),('5815','2013-04-17','15:55:00',1.91),('5815','2013-04-17','16:00:00',1.88),('5815','2013-04-17','16:05:00',1.83),('5815','2013-04-17','16:10:00',1.82),('5815','2013-04-17','16:15:00',1.78),('5815','2013-04-17','16:20:00',1.72),('5815','2013-04-17','16:25:00',1.68),('5815','2013-04-17','16:30:00',1.64),('5815','2013-04-17','16:35:00',1.59),('5815','2013-04-17','16:40:00',1.55),('5815','2013-04-17','16:45:00',1.52),('5815','2013-04-17','16:50:00',1.47),('5815','2013-04-17','16:55:00',1.42),('5815','2013-04-17','17:00:00',1.36),('5815','2013-04-17','17:05:00',1.3),('5815','2013-04-17','17:10:00',1.25),('5815','2013-04-17','17:15:00',1.21),('5815','2013-04-17','17:20:00',1.15),('5815','2013-04-17','17:25:00',1.09),('5815','2013-04-17','17:30:00',1.05),('5815','2013-04-16','08:50:00',1.05),('5815','2013-04-16','08:55:00',1.11),('5815','2013-04-16','09:00:00',1.16),('5815','2013-04-16','09:05:00',1.21),('5815','2013-04-16','09:10:00',1.27),('5815','2013-04-16','09:15:00',1.32),('5815','2013-04-16','09:20:00',1.37),('5815','2013-04-16','09:25:00',1.42),('5815','2013-04-16','09:30:00',1.47),('5815','2013-04-16','09:35:00',1.51),('5815','2013-04-16','09:40:00',1.54),('5815','2013-04-16','09:45:00',1.59),('5815','2013-04-16','09:50:00',1.63),('5815','2013-04-16','09:55:00',1.67),('5815','2013-04-16','10:00:00',1.72),('5815','2013-04-16','10:05:00',1.77),('5815','2013-04-16','10:10:00',1.8),('5815','2013-04-16','10:15:00',1.84),('5815','2013-04-16','10:20:00',1.88),('5815','2013-04-16','10:25:00',1.91),('5815','2013-04-16','10:30:00',1.94),('5815','2013-04-16','10:35:00',1.97),('5815','2013-04-16','10:40:00',2.01),('5815','2013-04-16','10:45:00',2.04),('5815','2013-04-16','10:50:00',2.06),('5815','2013-04-16','10:55:00',2.08),('5815','2013-04-16','11:00:00',2.14),('5815','2013-04-16','11:05:00',2.16),('5815','2013-04-16','11:10:00',2.17),('5815','2013-04-16','11:15:00',2.19),('5815','2013-04-16','11:20:00',2.21),('5815','2013-04-16','11:25:00',2.22),('5815','2013-04-16','11:30:00',2.23),('5815','2013-04-16','11:35:00',2.25),('5815','2013-04-16','11:40:00',2.28),('5815','2013-04-16','11:45:00',2.3),('5815','2013-04-16','11:50:00',2.33),('5815','2013-04-16','11:55:00',2.33),('5815','2013-04-16','12:00:00',2.33),('5815','2013-04-16','12:05:00',2.36),('5815','2013-04-16','12:10:00',2.36),('5815','2013-04-16','12:15:00',2.37),('5815','2013-04-16','12:20:00',2.37),('5815','2013-04-16','12:25:00',2.39),('5815','2013-04-16','12:30:00',2.42),('5815','2013-04-16','12:35:00',2.41),('5815','2013-04-16','12:40:00',2.41),('5815','2013-04-16','12:45:00',2.43),('5815','2013-04-16','12:50:00',2.42),('5815','2013-04-16','12:55:00',2.43),('5815','2013-04-16','13:00:00',2.41),('5815','2013-04-16','13:05:00',2.39),('5815','2013-04-16','13:10:00',2.41),('5815','2013-04-16','13:15:00',2.43),('5815','2013-04-16','13:20:00',2.44),('5815','2013-04-16','13:25:00',2.46),('5815','2013-04-16','13:30:00',2.44),('5815','2013-04-16','13:35:00',2.41),('5815','2013-04-16','13:40:00',2.45),('5815','2013-04-16','13:45:00',2.3),('5815','2013-04-16','13:50:00',2.31),('5815','2013-04-16','13:55:00',2.51),('5815','2013-04-16','14:00:00',2.42),('5815','2013-04-16','14:05:00',2.61),('5815','2013-04-16','14:10:00',2.56),('5815','2013-04-16','14:15:00',2.24),('5815','2013-04-16','14:20:00',2.24),('5815','2013-04-16','14:25:00',2.25),('5815','2013-04-16','14:30:00',2.15),('5815','2013-04-16','14:35:00',2.5),('5815','2013-04-16','14:40:00',2.42),('5815','2013-04-16','14:45:00',2.04),('5815','2013-04-16','14:50:00',2.42),('5815','2013-04-16','14:55:00',2.5),('5815','2013-04-16','15:00:00',2.47),('5815','2013-04-16','15:05:00',2.51),('5815','2013-04-16','15:10:00',2.56),('5815','2013-04-16','15:15:00',2.34),('5815','2013-04-16','15:20:00',1.23),('5815','2013-04-16','15:25:00',1.39),('5815','2013-04-16','15:30:00',2.13),('5815','2013-04-16','15:35:00',2.23),('5815','2013-04-16','15:40:00',2.2),('5815','2013-04-16','15:45:00',2.19),('5815','2013-04-16','15:50:00',2.17),('5815','2013-04-16','15:55:00',2.18),('5815','2013-04-16','16:00:00',2.1),('5815','2013-04-16','16:05:00',1.57),('5815','2013-04-16','16:10:00',2),('5815','2013-04-16','16:15:00',1.93),('5815','2013-04-16','16:20:00',1.85),('5815','2013-04-16','16:25:00',1.8),('5815','2013-04-16','16:30:00',1.76),('5815','2013-04-16','16:35:00',1.75),('5815','2013-04-16','16:40:00',1.61),('5815','2013-04-16','16:45:00',1.67),('5815','2013-04-16','16:50:00',1.55),('5815','2013-04-16','16:55:00',1.48),('5815','2013-04-16','17:00:00',1.42),('5815','2013-04-16','17:05:00',1.36),('5815','2013-04-16','17:10:00',1.3),('5815','2013-04-16','17:15:00',1.24),('5815','2013-04-16','17:20:00',1.19),('5815','2013-04-16','17:25:00',1.13),('5815','2013-04-16','17:30:00',1.07),('5815','2013-04-15','11:15:00',1.03),('5815','2013-04-15','11:20:00',1.06),('5815','2013-04-15','11:25:00',1.05),('5815','2013-04-15','11:30:00',1.03),('5815','2013-04-15','11:35:00',1.02),('5815','2013-04-15','11:40:00',1.14),('5815','2013-04-15','11:45:00',1.36),('5815','2013-04-15','11:50:00',1.47),('5815','2013-04-15','11:55:00',1.54),('5815','2013-04-15','12:00:00',1.79),('5815','2013-04-15','12:05:00',2.29),('5815','2013-04-15','12:10:00',2.35),('5815','2013-04-15','12:15:00',2.75),('5815','2013-04-15','12:20:00',2.19),('5815','2013-04-15','12:25:00',1.93),('5815','2013-04-15','12:30:00',2.28),('5815','2013-04-15','12:35:00',2.49),('5815','2013-04-15','12:40:00',2.46),('5815','2013-04-15','12:45:00',2.12),('5815','2013-04-15','12:50:00',1.84),('5815','2013-04-15','12:55:00',2.4),('5815','2013-04-15','13:00:00',2.46),('5815','2013-04-15','13:05:00',2.33),('5815','2013-04-15','13:10:00',2.36),('5815','2013-04-15','13:15:00',2.39),('5815','2013-04-15','13:20:00',2.41),('5815','2013-04-15','13:25:00',2.43),('5815','2013-04-15','13:30:00',2.43),('5815','2013-04-15','13:35:00',2.43),('5815','2013-04-15','13:40:00',2.4),('5815','2013-04-15','13:45:00',2.36),('5815','2013-04-15','13:50:00',2.35),('5815','2013-04-15','13:55:00',2.27),('5815','2013-04-15','14:00:00',2.26),('5815','2013-04-15','14:05:00',2.35),('5815','2013-04-15','14:10:00',2.36),('5815','2013-04-15','14:15:00',2.28),('5815','2013-04-15','14:20:00',2.32),('5815','2013-04-15','14:25:00',1.83),('5815','2013-04-15','14:30:00',1.95),('5815','2013-04-15','14:35:00',1.96),('5815','2013-04-15','14:40:00',2.21),('5815','2013-04-15','14:45:00',2.3),('5815','2013-04-15','14:50:00',2.2),('5815','2013-04-15','14:55:00',2.15),('5815','2013-04-15','15:00:00',2.22),('5815','2013-04-15','15:05:00',2.19),('5815','2013-04-15','15:10:00',2.17),('5815','2013-04-15','15:15:00',2.14),('5815','2013-04-15','15:20:00',2.13),('5815','2013-04-15','15:25:00',2.06),('5815','2013-04-15','15:30:00',2),('5815','2013-04-15','15:35:00',2.03),('5815','2013-04-15','15:40:00',2),('5815','2013-04-15','15:45:00',1.96),('5815','2013-04-15','15:50:00',1.95),('5815','2013-04-15','15:55:00',1.9),('5815','2013-04-15','16:00:00',1.8),('5815','2013-04-15','16:05:00',1.82),('5815','2013-04-15','16:10:00',1.78),('5815','2013-04-15','16:15:00',1.71),('5815','2013-04-15','16:20:00',1.72),('5815','2013-04-15','16:25:00',1.68),('5815','2013-04-15','16:30:00',1.64),('5815','2013-04-15','16:35:00',1.61),('5815','2013-04-15','16:40:00',1.69),('5815','2013-04-15','16:45:00',1.69),('5815','2013-04-15','16:50:00',1.55),('5815','2013-04-15','16:55:00',1.33),('5815','2013-04-15','17:00:00',1.4),('5815','2013-04-15','17:05:00',1.4),('5815','2013-04-15','17:10:00',1.39),('5815','2013-04-15','17:15:00',1.33),('5815','2013-04-15','17:20:00',1.29),('5815','2013-04-15','17:25:00',1.24),('5815','2013-04-15','17:30:00',1.2),('5815','2013-04-15','17:35:00',1.12),('5815','2013-04-14','08:45:00',1),('5815','2013-04-14','08:50:00',1.06),('5815','2013-04-14','08:55:00',1.12),('5815','2013-04-14','09:00:00',1.17),('5815','2013-04-14','09:05:00',1.23),('5815','2013-04-14','09:10:00',1.28),('5815','2013-04-14','09:15:00',1.33),('5815','2013-04-14','09:20:00',1.38),('5815','2013-04-14','09:25:00',1.42),('5815','2013-04-14','09:30:00',1.46),('5815','2013-04-14','09:35:00',1.51),('5815','2013-04-14','09:40:00',1.56),('5815','2013-04-14','09:45:00',1.59),('5815','2013-04-14','09:50:00',1.64),('5815','2013-04-14','09:55:00',1.68),('5815','2013-04-14','10:00:00',1.72),('5815','2013-04-14','10:05:00',1.75),('5815','2013-04-14','10:10:00',1.79),('5815','2013-04-14','10:15:00',1.83),('5815','2013-04-14','10:20:00',1.87),('5815','2013-04-14','10:25:00',1.89),('5815','2013-04-14','10:30:00',1.93),('5815','2013-04-14','10:35:00',1.96),('5815','2013-04-14','10:40:00',1.99),('5815','2013-04-14','10:45:00',2.03),('5815','2013-04-14','10:50:00',2.06),('5815','2013-04-14','10:55:00',2.09),('5815','2013-04-14','11:00:00',2.11),('5815','2013-04-14','11:05:00',2.15),('5815','2013-04-14','11:10:00',2.17),('5815','2013-04-14','11:15:00',2.2),('5815','2013-04-14','11:20:00',2.2),('5815','2013-04-14','11:25:00',2.22),('5815','2013-04-14','11:30:00',2.24),('5815','2013-04-14','11:35:00',2.26),('5815','2013-04-14','11:40:00',2.28),('5815','2013-04-14','11:45:00',2.31),('5815','2013-04-14','11:50:00',2.31),('5815','2013-04-14','11:55:00',2.32),('5815','2013-04-14','12:00:00',2.33),('5815','2013-04-14','12:05:00',2.33),('5815','2013-04-14','12:10:00',2.36),('5815','2013-04-14','12:15:00',2.37),('5815','2013-04-14','12:20:00',2.37),('5815','2013-04-14','12:25:00',2.38),('5815','2013-04-14','12:30:00',2.4),('5815','2013-04-14','12:35:00',2.41),('5815','2013-04-14','12:40:00',2.41),('5815','2013-04-14','12:45:00',2.41),('5815','2013-04-14','12:50:00',2.4),('5815','2013-04-14','12:55:00',2.39),('5815','2013-04-14','13:00:00',2.4),('5815','2013-04-14','13:05:00',2.4),('5815','2013-04-14','13:10:00',2.44),('5815','2013-04-14','13:15:00',2.44),('5815','2013-04-14','13:20:00',2.41),('5815','2013-04-14','13:25:00',2.39),('5815','2013-04-14','13:30:00',2.38),('5815','2013-04-14','13:35:00',2.41),('5815','2013-04-14','13:40:00',2.41),('5815','2013-04-14','13:45:00',2.32),('5815','2013-04-14','13:50:00',2.37),('5815','2013-04-14','13:55:00',2.42),('5815','2013-04-14','14:00:00',2.44),('5815','2013-04-14','14:05:00',2.42),('5815','2013-04-14','14:10:00',2.44),('5815','2013-04-14','14:15:00',2.45),('5815','2013-04-14','14:20:00',2.44),('5815','2013-04-14','14:25:00',2.42),('5815','2013-04-14','14:30:00',2.4),('5815','2013-04-14','14:35:00',2.38),('5815','2013-04-14','14:40:00',2.36),('5815','2013-04-14','14:45:00',2.35),('5815','2013-04-14','14:50:00',2.33),('5815','2013-04-14','14:55:00',2.3),('5815','2013-04-14','15:00:00',2.28),('5815','2013-04-14','15:05:00',2.27),('5815','2013-04-14','15:10:00',2.24),('5815','2013-04-14','15:15:00',2.22),('5815','2013-04-14','15:20:00',2.19),('5815','2013-04-14','15:25:00',2.16),('5815','2013-04-14','15:30:00',2.14),('5815','2013-04-14','15:35:00',2.11),('5815','2013-04-14','15:40:00',2.08),('5815','2013-04-14','15:45:00',2.05),('5815','2013-04-14','15:50:00',2.01),('5815','2013-04-14','15:55:00',1.97),('5815','2013-04-14','16:00:00',1.93),('5815','2013-04-14','16:05:00',1.89),('5815','2013-04-14','16:10:00',1.85),('5815','2013-04-14','16:15:00',1.81),('5815','2013-04-14','16:20:00',1.77),('5815','2013-04-14','16:25:00',1.73),('5815','2013-04-14','16:30:00',1.67),('5815','2013-04-14','16:35:00',1.64),('5815','2013-04-14','16:40:00',1.59),('5815','2013-04-14','16:45:00',1.54),('5815','2013-04-14','16:50:00',1.49),('5815','2013-04-14','16:55:00',1.45),('5815','2013-04-14','17:00:00',1.39),('5815','2013-04-14','17:05:00',1.34),('5815','2013-04-14','17:10:00',1.29),('5815','2013-04-14','17:15:00',1.23),('5815','2013-04-14','17:20:00',1.19),('5815','2013-04-14','17:25:00',1.14),('5815','2013-04-14','17:30:00',1.07),('5815','2013-04-13','08:50:00',1),('5815','2013-04-13','08:55:00',1.06),('5815','2013-04-13','09:00:00',1.11),('5815','2013-04-13','09:05:00',1.16),('5815','2013-04-13','09:10:00',1.2),('5815','2013-04-13','09:15:00',1.24),('5815','2013-04-13','09:20:00',1.3),('5815','2013-04-13','09:25:00',1.35),('5815','2013-04-13','09:30:00',1.39),('5815','2013-04-13','09:35:00',1.45),('5815','2013-04-13','09:40:00',1.49),('5815','2013-04-13','09:45:00',1.54),('5815','2013-04-13','09:50:00',1.59),('5815','2013-04-13','09:55:00',1.63),('5815','2013-04-13','10:00:00',1.68),('5815','2013-04-13','10:05:00',1.72),('5815','2013-04-13','10:10:00',1.76),('5815','2013-04-13','10:15:00',1.8),('5815','2013-04-13','10:20:00',1.82),('5815','2013-04-13','10:25:00',1.85),('5815','2013-04-13','10:30:00',1.86),('5815','2013-04-13','10:35:00',1.92),('5815','2013-04-13','10:40:00',1.95),('5815','2013-04-13','10:45:00',1.98),('5815','2013-04-13','10:50:00',2.01),('5815','2013-04-13','10:55:00',2.03),('5815','2013-04-13','11:00:00',2.07),('5815','2013-04-13','11:05:00',2.09),('5815','2013-04-13','11:10:00',2.13),('5815','2013-04-13','11:15:00',2.14),('5815','2013-04-13','11:20:00',2.16),('5815','2013-04-13','11:25:00',2.16),('5815','2013-04-13','11:30:00',2.18),('5815','2013-04-13','11:35:00',2.22),('5815','2013-04-13','11:40:00',2.25),('5815','2013-04-13','11:45:00',2.24),('5815','2013-04-13','11:50:00',2.25),('5815','2013-04-13','11:55:00',2.28),('5815','2013-04-13','12:00:00',2.28),('5815','2013-04-13','12:05:00',2.29),('5815','2013-04-13','12:10:00',2.32),('5815','2013-04-13','12:15:00',2.32),('5815','2013-04-13','12:20:00',2.33),('5815','2013-04-13','12:25:00',2.34),('5815','2013-04-13','12:30:00',2.36),('5815','2013-04-13','12:35:00',2.37),('5815','2013-04-13','12:40:00',2.41),('5815','2013-04-13','12:45:00',2.42),('5815','2013-04-13','12:50:00',2.45),('5815','2013-04-13','12:55:00',2.48),('5815','2013-04-13','13:00:00',1.72),('5815','2013-04-13','13:05:00',1.97),('5815','2013-04-13','13:10:00',2.52),('5815','2013-04-13','13:15:00',2.46),('5815','2013-04-13','13:20:00',2.47),('5815','2013-04-13','13:25:00',2.45),('5815','2013-04-13','13:30:00',2.4),('5815','2013-04-13','13:35:00',2.41),('5815','2013-04-13','13:40:00',2.41),('5815','2013-04-13','13:45:00',2.4),('5815','2013-04-13','13:50:00',2.36),('5815','2013-04-13','13:55:00',2.33),('5815','2013-04-13','14:00:00',2.29),('5815','2013-04-13','14:05:00',2.37),('5815','2013-04-13','14:10:00',2.37),('5815','2013-04-13','14:15:00',2.34),('5815','2013-04-13','14:20:00',2.31),('5815','2013-04-13','14:25:00',2.28),('5815','2013-04-13','14:30:00',2.28),('5815','2013-04-13','14:35:00',2.32),('5815','2013-04-13','14:40:00',2.34),('5815','2013-04-13','14:45:00',2.38),('5815','2013-04-13','14:50:00',2.37),('5815','2013-04-13','14:55:00',2.31),('5815','2013-04-13','15:00:00',2.27),('5815','2013-04-13','15:05:00',2.25),('5815','2013-04-13','15:10:00',2.13),('5815','2013-04-13','15:15:00',2.11),('5815','2013-04-13','15:20:00',1.91),('5815','2013-04-13','15:25:00',1.81),('5815','2013-04-13','15:30:00',2.04),('5815','2013-04-13','15:35:00',2.13),('5815','2013-04-13','15:40:00',2.16),('5815','2013-04-13','15:45:00',2.11),('5815','2013-04-13','15:50:00',2.04),('5815','2013-04-13','15:55:00',1.24),('5815','2013-04-13','16:00:00',1.9),('5815','2013-04-13','16:05:00',1.87),('5815','2013-04-13','16:10:00',1.83),('5815','2013-04-13','16:15:00',1.73),('5815','2013-04-13','16:20:00',1.71),('5815','2013-04-13','16:25:00',1.72),('5815','2013-04-13','16:30:00',1.66),('5815','2013-04-13','16:35:00',1.59),('5815','2013-04-13','16:40:00',1.53),('5815','2013-04-13','16:45:00',1.48),('5815','2013-04-13','16:50:00',1.46),('5815','2013-04-13','16:55:00',1.39),('5815','2013-04-13','17:00:00',1.35),('5815','2013-04-13','17:05:00',1.3),('5815','2013-04-13','17:10:00',1.26),('5815','2013-04-13','17:15:00',1.2),('5815','2013-04-13','17:20:00',1.15),('5815','2013-04-13','17:25:00',1.08),('5815','2013-04-13','17:30:00',1.02),('5815','2013-04-12','09:05:00',1.02),('5815','2013-04-12','09:10:00',1.03),('5815','2013-04-12','09:15:00',1.31),('5815','2013-04-12','09:20:00',1.44),('5815','2013-04-12','09:25:00',1.24),('5815','2013-04-12','09:30:00',1.43),('5815','2013-04-12','09:35:00',1.41),('5815','2013-04-12','09:40:00',1.31),('5815','2013-04-12','09:45:00',1.54),('5815','2013-04-12','09:50:00',1.58),('5815','2013-04-12','09:55:00',1.66),('5815','2013-04-12','10:00:00',1.69),('5815','2013-04-12','10:05:00',1.74),('5815','2013-04-12','10:10:00',1.84),('5815','2013-04-12','10:15:00',2.04),('5815','2013-04-12','10:20:00',1.96),('5815','2013-04-12','10:25:00',1.55),('5815','2013-04-12','10:30:00',1.8),('5815','2013-04-12','10:35:00',1.41),('5815','2013-04-12','10:40:00',1.21),('5815','2013-04-12','10:45:00',1.93),('5815','2013-04-12','10:55:00',1.53),('5815','2013-04-12','11:00:00',1.39),('5815','2013-04-12','11:05:00',1.48),('5815','2013-04-12','11:10:00',1.2),('5815','2013-04-12','11:15:00',1.53),('5815','2013-04-12','11:20:00',2.11),('5815','2013-04-12','11:25:00',1.02),('5815','2013-04-12','11:35:00',2.58),('5815','2013-04-12','11:40:00',2.27),('5815','2013-04-12','11:45:00',1.89),('5815','2013-04-12','11:50:00',2.57),('5815','2013-04-12','11:55:00',1.35),('5815','2013-04-12','12:00:00',2.62),('5815','2013-04-12','12:05:00',2.55),('5815','2013-04-12','12:10:00',2.6),('5815','2013-04-12','12:15:00',2.58),('5815','2013-04-12','12:20:00',2.51),('5815','2013-04-12','12:25:00',2.42),('5815','2013-04-12','12:30:00',2.31),('5815','2013-04-12','12:35:00',2.58),('5815','2013-04-12','12:40:00',2.6),('5815','2013-04-12','12:45:00',2.55),('5815','2013-04-12','12:50:00',2.44),('5815','2013-04-12','12:55:00',2.52),('5815','2013-04-12','13:00:00',2.3),('5815','2013-04-12','13:05:00',2.54),('5815','2013-04-12','13:10:00',2.59),('5815','2013-04-12','13:15:00',2.49),('5815','2013-04-12','13:20:00',2.34),('5815','2013-04-12','13:25:00',2.51),('5815','2013-04-12','13:30:00',2.48),('5815','2013-04-12','13:35:00',1.36),('5815','2013-04-12','13:40:00',1.17),('5815','2013-04-12','13:45:00',2.12),('5815','2013-04-12','13:50:00',1.68),('5815','2013-04-12','13:55:00',1.12),('5815','2013-04-12','14:00:00',1.19),('5815','2013-04-12','14:05:00',1.41),('5815','2013-04-12','14:20:00',1.97),('5815','2013-04-12','14:25:00',2.2),('5815','2013-04-12','14:30:00',2.15),('5815','2013-04-12','14:35:00',2.3),('5815','2013-04-12','14:40:00',2.23),('5815','2013-04-12','14:45:00',2.24),('5815','2013-04-12','14:50:00',2.15),('5815','2013-04-12','14:55:00',2.18),('5815','2013-04-12','15:00:00',2.01),('5815','2013-04-12','15:05:00',1.81),('5815','2013-04-12','15:10:00',1.61),('5815','2013-04-12','15:15:00',1.82),('5815','2013-04-12','15:20:00',1.73),('5815','2013-04-12','15:25:00',1.61),('5815','2013-04-12','15:30:00',1.64),('5815','2013-04-12','15:35:00',1.58),('5815','2013-04-12','15:40:00',1.67),('5815','2013-04-12','15:45:00',1.7),('5815','2013-04-12','15:50:00',1.67),('5815','2013-04-12','15:55:00',1.63),('5815','2013-04-12','16:00:00',1.63),('5815','2013-04-12','16:05:00',1.53),('5815','2013-04-12','16:10:00',1.44),('5815','2013-04-12','16:15:00',1.49),('5815','2013-04-12','16:20:00',1.41),('5815','2013-04-12','16:25:00',1.3),('5815','2013-04-12','16:30:00',1.26),('5815','2013-04-12','16:35:00',1.16),('5815','2013-04-12','16:40:00',1.1),('5815','2013-04-12','16:45:00',1.07),('5815','2013-04-12','16:50:00',1.1),('5815','2013-04-12','17:10:00',1.13),('5815','2013-04-12','17:15:00',1.23),('5815','2013-04-12','17:20:00',1.03),('5815','2013-04-12','17:25:00',1.18),('5815','2013-04-12','17:30:00',1),('5815','2013-04-11','09:15:00',1.23),('5815','2013-04-11','09:20:00',1.06),('5815','2013-04-11','09:30:00',1.02),('5815','2013-04-11','10:25:00',1.03),('5815','2013-04-11','10:45:00',2.09),('5815','2013-04-11','10:50:00',1.69),('5815','2013-04-11','10:55:00',2.54),('5815','2013-04-11','11:00:00',1.07),('5815','2013-04-11','11:15:00',1.28),('5815','2013-04-11','11:20:00',2.61),('5815','2013-04-11','11:25:00',2.55),('5815','2013-04-11','11:30:00',1.87),('5815','2013-04-11','11:35:00',2.24),('5815','2013-04-11','11:40:00',2.57),('5815','2013-04-11','11:45:00',2.03),('5815','2013-04-11','11:50:00',1.86),('5815','2013-04-11','11:55:00',2.51),('5815','2013-04-11','12:00:00',2.49),('5815','2013-04-11','12:05:00',2.38),('5815','2013-04-11','12:10:00',2.35),('5815','2013-04-11','12:15:00',2.46),('5815','2013-04-11','12:20:00',2.55),('5815','2013-04-11','12:25:00',2.53),('5815','2013-04-11','12:30:00',2.51);
INSERT INTO `solarlogmod` VALUES ('5815','2013-04-11','12:35:00',2.46),('5815','2013-04-11','12:40:00',2.38),('5815','2013-04-11','12:45:00',2.39),('5815','2013-04-11','12:50:00',2.39),('5815','2013-04-11','12:55:00',2.49),('5815','2013-04-11','13:00:00',2.53),('5815','2013-04-11','13:05:00',2.49),('5815','2013-04-11','13:10:00',2.47),('5815','2013-04-11','13:15:00',2.48),('5815','2013-04-11','13:20:00',2.49),('5815','2013-04-11','13:25:00',2.47),('5815','2013-04-11','13:30:00',2.45),('5815','2013-04-11','13:35:00',2.46),('5815','2013-04-11','13:40:00',2.43),('5815','2013-04-11','13:45:00',2.48),('5815','2013-04-11','13:50:00',2.48),('5815','2013-04-11','13:55:00',2.47),('5815','2013-04-11','14:00:00',2.47),('5815','2013-04-11','14:05:00',2.46),('5815','2013-04-11','14:10:00',2.45),('5815','2013-04-11','14:15:00',2.42),('5815','2013-04-11','14:20:00',2.4),('5815','2013-04-11','14:25:00',2.39),('5815','2013-04-11','14:30:00',2.37),('5815','2013-04-11','14:35:00',2.35),('5815','2013-04-11','14:40:00',2.33),('5815','2013-04-11','14:45:00',2.31),('5815','2013-04-11','14:50:00',2.29),('5815','2013-04-11','14:55:00',2.28),('5815','2013-04-11','15:00:00',2.27),('5815','2013-04-11','15:05:00',2.24),('5815','2013-04-11','15:10:00',2.2),('5815','2013-04-11','15:15:00',2.17),('5815','2013-04-11','15:20:00',2.15),('5815','2013-04-11','15:25:00',2.12),('5815','2013-04-11','15:30:00',2.09),('5815','2013-04-11','15:35:00',2.06),('5815','2013-04-11','15:40:00',2.03),('5815','2013-04-11','15:45:00',2.01),('5815','2013-04-11','15:50:00',1.97),('5815','2013-04-11','15:55:00',1.92),('5815','2013-04-11','16:00:00',1.89),('5815','2013-04-11','16:05:00',1.85),('5815','2013-04-11','16:10:00',1.83),('5815','2013-04-11','16:15:00',1.64),('5815','2013-04-11','16:20:00',1.66),('5815','2013-04-11','16:25:00',1.69),('5815','2013-04-11','16:30:00',1.09),('5815','2013-04-11','16:45:00',1.54),('5815','2013-04-11','16:50:00',1.43),('5815','2013-04-11','16:55:00',1.39),('5815','2013-04-11','17:00:00',1.32),('5815','2013-04-11','17:05:00',1.27),('5815','2013-04-11','17:10:00',1.21),('5815','2013-04-11','17:15:00',1.16),('5815','2013-04-11','17:20:00',1.12),('5815','2013-04-11','17:25:00',1.06),('5815','2013-04-10','08:55:00',1.04),('5815','2013-04-10','09:00:00',1.09),('5815','2013-04-10','09:05:00',1.14),('5815','2013-04-10','09:10:00',1.18),('5815','2013-04-10','09:15:00',1.24),('5815','2013-04-10','09:20:00',1.29),('5815','2013-04-10','09:25:00',1.34),('5815','2013-04-10','09:30:00',1.36),('5815','2013-04-10','09:35:00',1.41),('5815','2013-04-10','09:40:00',1.48),('5815','2013-04-10','09:45:00',1.54),('5815','2013-04-10','09:50:00',1.6),('5815','2013-04-10','09:55:00',1.42),('5815','2013-04-10','10:15:00',1.28),('5815','2013-04-10','10:20:00',1.91),('5815','2013-04-10','10:25:00',1.9),('5815','2013-04-10','10:30:00',1.94),('5815','2013-04-10','10:35:00',2.1),('5815','2013-04-10','10:40:00',2.16),('5815','2013-04-10','10:45:00',2.28),('5815','2013-04-10','10:50:00',1.12),('5815','2013-04-10','11:05:00',2.22),('5815','2013-04-10','11:10:00',2.28),('5815','2013-04-10','11:15:00',2.29),('5815','2013-04-10','11:20:00',1.8),('5815','2013-04-10','11:30:00',1.73),('5815','2013-04-10','11:35:00',2.4),('5815','2013-04-10','11:40:00',1.06),('5815','2013-04-10','12:00:00',2.45),('5815','2013-04-10','12:05:00',2.59),('5815','2013-04-10','12:10:00',2.51),('5815','2013-04-10','12:20:00',1.17),('5815','2013-04-10','12:25:00',2.73),('5815','2013-04-10','12:30:00',2.65),('5815','2013-04-10','12:35:00',2.61),('5815','2013-04-10','12:40:00',2.65),('5815','2013-04-10','12:45:00',2.66),('5815','2013-04-10','12:50:00',2.62),('5815','2013-04-10','12:55:00',2.27),('5815','2013-04-10','13:00:00',2.32),('5815','2013-04-10','13:05:00',2.38),('5815','2013-04-10','13:10:00',1.9),('5815','2013-04-10','13:15:00',2.61),('5815','2013-04-10','13:20:00',1.78),('5815','2013-04-10','13:25:00',2.25),('5815','2013-04-10','13:30:00',2.58),('5815','2013-04-10','13:35:00',2.54),('5815','2013-04-10','13:40:00',2.55),('5815','2013-04-10','13:45:00',2.52),('5815','2013-04-10','13:50:00',2.5),('5815','2013-04-10','13:55:00',2.54),('5815','2013-04-10','14:00:00',2.53),('5815','2013-04-10','14:05:00',2.46),('5815','2013-04-10','14:10:00',2.52),('5815','2013-04-10','14:15:00',2.5),('5815','2013-04-10','14:20:00',2.48),('5815','2013-04-10','14:25:00',2.45),('5815','2013-04-10','14:30:00',2.4),('5815','2013-04-10','14:35:00',2.25),('5815','2013-04-10','14:40:00',2.33),('5815','2013-04-10','14:45:00',2.45),('5815','2013-04-10','14:50:00',2.38),('5815','2013-04-10','14:55:00',2.35),('5815','2013-04-10','15:00:00',2.33),('5815','2013-04-10','15:05:00',2.29),('5815','2013-04-10','15:10:00',2.24),('5815','2013-04-10','15:15:00',2.22),('5815','2013-04-10','15:20:00',2.15),('5815','2013-04-10','15:25:00',2.16),('5815','2013-04-10','15:30:00',2.14),('5815','2013-04-10','15:35:00',2.11),('5815','2013-04-10','15:40:00',2.07),('5815','2013-04-10','15:45:00',2.04),('5815','2013-04-10','15:50:00',1.99),('5815','2013-04-10','15:55:00',1.97),('5815','2013-04-10','16:00:00',1.93),('5815','2013-04-10','16:05:00',1.9),('5815','2013-04-10','16:10:00',1.86),('5815','2013-04-10','16:15:00',1.82),('5815','2013-04-10','16:20:00',1.79),('5815','2013-04-10','16:25:00',1.74),('5815','2013-04-10','16:30:00',1.69),('5815','2013-04-10','16:35:00',1.65),('5815','2013-04-10','16:40:00',1.6),('5815','2013-04-10','16:45:00',1.55),('5815','2013-04-10','16:50:00',1.49),('5815','2013-04-10','16:55:00',1.46),('5815','2013-04-10','17:00:00',1.41),('5815','2013-04-10','17:05:00',1.35),('5815','2013-04-10','17:10:00',1.3),('5815','2013-04-10','17:15:00',1.25),('5815','2013-04-10','17:20:00',1.2),('5815','2013-04-10','17:25:00',1.13),('5815','2013-04-09','09:00:00',1.09),('5815','2013-04-09','09:05:00',1.18),('5815','2013-04-09','09:10:00',1.24),('5815','2013-04-09','09:15:00',1.21),('5815','2013-04-09','09:20:00',1.22),('5815','2013-04-09','09:25:00',1.37),('5815','2013-04-09','09:30:00',1.41),('5815','2013-04-09','09:35:00',1.49),('5815','2013-04-09','09:40:00',1.52),('5815','2013-04-09','09:45:00',1.59),('5815','2013-04-09','09:50:00',1.65),('5815','2013-04-09','09:55:00',1.72),('5815','2013-04-09','10:00:00',1.74),('5815','2013-04-09','10:05:00',1.84),('5815','2013-04-09','10:10:00',1.95),('5815','2013-04-09','10:15:00',2.01),('5815','2013-04-09','10:20:00',2.03),('5815','2013-04-09','10:25:00',2.06),('5815','2013-04-09','10:30:00',2.07),('5815','2013-04-09','10:35:00',2.09),('5815','2013-04-09','10:40:00',2.11),('5815','2013-04-09','10:45:00',2.17),('5815','2013-04-09','10:50:00',2.06),('5815','2013-04-09','10:55:00',2.05),('5815','2013-04-09','11:00:00',2.04),('5815','2013-04-09','11:05:00',2.05),('5815','2013-04-09','11:10:00',2.08),('5815','2013-04-09','11:15:00',2.03),('5815','2013-04-09','11:20:00',2.24),('5815','2013-04-09','11:25:00',2.33),('5815','2013-04-09','11:30:00',2.33),('5815','2013-04-09','11:35:00',2.35),('5815','2013-04-09','11:40:00',2.38),('5815','2013-04-09','11:45:00',2.41),('5815','2013-04-09','11:50:00',2.42),('5815','2013-04-09','11:55:00',2.17),('5815','2013-04-09','12:00:00',2.46),('5815','2013-04-09','12:05:00',2.49),('5815','2013-04-09','12:10:00',2.5),('5815','2013-04-09','12:15:00',2.53),('5815','2013-04-09','12:20:00',2.54),('5815','2013-04-09','12:25:00',2.58),('5815','2013-04-09','12:30:00',2.62),('5815','2013-04-09','12:35:00',2.6),('5815','2013-04-09','12:40:00',2.55),('5815','2013-04-09','12:45:00',2.57),('5815','2013-04-09','12:50:00',2.62),('5815','2013-04-09','12:55:00',2.49),('5815','2013-04-09','13:00:00',2.59),('5815','2013-04-09','13:05:00',2.56),('5815','2013-04-09','13:10:00',2.42),('5815','2013-04-09','13:15:00',1.89),('5815','2013-04-09','13:20:00',2.85),('5815','2013-04-09','13:25:00',1.57),('5815','2013-04-09','13:30:00',1.69),('5815','2013-04-09','13:35:00',2.44),('5815','2013-04-09','13:40:00',2.09),('5815','2013-04-09','13:45:00',2.72),('5815','2013-04-09','13:50:00',2.04),('5815','2013-04-09','13:55:00',2.25),('5815','2013-04-09','14:00:00',1.99),('5815','2013-04-09','14:05:00',2.63),('5815','2013-04-09','14:10:00',2.57),('5815','2013-04-09','14:15:00',2.58),('5815','2013-04-09','14:20:00',2.56),('5815','2013-04-09','14:25:00',2.57),('5815','2013-04-09','14:30:00',2.54),('5815','2013-04-09','14:35:00',2.53),('5815','2013-04-09','14:40:00',2.51),('5815','2013-04-09','14:45:00',2.28),('5815','2013-04-09','14:50:00',2.34),('5815','2013-04-09','14:55:00',2.28),('5815','2013-04-09','15:00:00',2.47),('5815','2013-04-09','15:05:00',2.43),('5815','2013-04-09','15:10:00',2.36),('5815','2013-04-09','15:15:00',1.93),('5815','2013-04-09','15:20:00',1.69),('5815','2013-04-09','15:25:00',2.3),('5815','2013-04-09','15:30:00',2.16),('5815','2013-04-09','15:35:00',1.86),('5815','2013-04-09','15:40:00',2.14),('5815','2013-04-09','15:45:00',2.09),('5815','2013-04-09','15:50:00',2.18),('5815','2013-04-09','15:55:00',1.74),('5815','2013-04-09','16:00:00',2),('5815','2013-04-09','16:05:00',1.58),('5815','2013-04-09','16:10:00',1.78),('5815','2013-04-09','16:15:00',1.67),('5815','2013-04-09','16:20:00',1.8),('5815','2013-04-09','16:25:00',1.47),('5815','2013-04-09','16:30:00',1.7),('5815','2013-04-09','16:40:00',1.52),('5815','2013-04-09','16:45:00',1.44),('5815','2013-04-09','16:50:00',1.39),('5815','2013-04-09','17:00:00',1.54),('5815','2013-04-09','17:05:00',1.16),('5815','2013-04-09','17:15:00',1.15),('5815','2013-04-09','17:20:00',1.29),('5815','2013-04-08','09:55:00',1.69),('5815','2013-04-08','10:00:00',1.04),('5815','2013-04-08','10:15:00',1.16),('5815','2013-04-08','10:20:00',1.07),('5815','2013-04-08','10:35:00',1.83),('5815','2013-04-08','10:40:00',1.19),('5815','2013-04-08','10:45:00',1.8),('5815','2013-04-08','10:50:00',2.39),('5815','2013-04-08','10:55:00',1.94),('5815','2013-04-08','11:00:00',1.85),('5815','2013-04-08','11:05:00',2.06),('5815','2013-04-08','11:10:00',2.45),('5815','2013-04-08','11:15:00',1.43),('5815','2013-04-08','11:25:00',2.31),('5815','2013-04-08','11:30:00',2.73),('5815','2013-04-08','11:35:00',2.14),('5815','2013-04-08','11:45:00',1.79),('5815','2013-04-08','11:50:00',2.57),('5815','2013-04-08','11:55:00',1.38),('5815','2013-04-08','12:00:00',2.77),('5815','2013-04-08','12:05:00',2.65),('5815','2013-04-08','12:10:00',2.67),('5815','2013-04-08','12:15:00',2.67),('5815','2013-04-08','12:20:00',1.91),('5815','2013-04-08','12:25:00',2.45),('5815','2013-04-08','12:30:00',2.65),('5815','2013-04-08','12:35:00',2.44),('5815','2013-04-08','12:40:00',2.65),('5815','2013-04-08','12:45:00',2.62),('5815','2013-04-08','12:50:00',2.72),('5815','2013-04-08','12:55:00',2.66),('5815','2013-04-08','13:00:00',2.71),('5815','2013-04-08','13:05:00',2.78),('5815','2013-04-08','13:10:00',2.87),('5815','2013-04-08','13:15:00',2.8),('5815','2013-04-08','13:20:00',1.77),('5815','2013-04-08','13:25:00',2.58),('5815','2013-04-08','13:30:00',2.21),('5815','2013-04-08','13:40:00',1.35),('5815','2013-04-08','13:50:00',1.94),('5815','2013-04-08','13:55:00',2.54),('5815','2013-04-08','14:00:00',2.45),('5815','2013-04-08','14:05:00',2.27),('5815','2013-04-08','14:10:00',1.89),('5815','2013-04-08','14:15:00',2.2),('5815','2013-04-08','14:20:00',1.26),('5815','2013-04-08','14:25:00',1.6),('5815','2013-04-08','14:30:00',2.19),('5815','2013-04-08','14:35:00',2.28),('5815','2013-04-08','14:40:00',2.39),('5815','2013-04-08','14:45:00',2.21),('5815','2013-04-08','14:50:00',2.15),('5815','2013-04-08','14:55:00',2.17),('5815','2013-04-08','15:00:00',1.73),('5815','2013-04-08','15:05:00',1.82),('5815','2013-04-08','15:10:00',2.4),('5815','2013-04-08','15:15:00',1.65),('5815','2013-04-08','15:20:00',2.31),('5815','2013-04-08','15:25:00',2.39),('5815','2013-04-08','15:30:00',2.11),('5815','2013-04-08','15:35:00',1.47),('5815','2013-04-08','15:40:00',2.27),('5815','2013-04-08','15:45:00',1.72),('5815','2013-04-08','15:50:00',2.04),('5815','2013-04-08','15:55:00',1.82),('5815','2013-04-08','16:00:00',1.7),('5815','2013-04-08','16:05:00',1.81),('5815','2013-04-08','16:10:00',1.8),('5815','2013-04-08','16:15:00',1.26),('5815','2013-04-08','16:50:00',1.26),('5815','2013-04-08','16:55:00',1.4),('5815','2013-04-07','09:10:00',1.05),('5815','2013-04-07','09:20:00',1.15),('5815','2013-04-07','09:30:00',1.4),('5815','2013-04-07','09:35:00',1.56),('5815','2013-04-07','09:40:00',1.64),('5815','2013-04-07','09:45:00',1.65),('5815','2013-04-07','09:50:00',1.23),('5815','2013-04-07','10:00:00',1.73),('5815','2013-04-07','10:05:00',1.85),('5815','2013-04-07','10:10:00',1.79),('5815','2013-04-07','10:15:00',1.86),('5815','2013-04-07','10:20:00',1.86),('5815','2013-04-07','10:25:00',1.86),('5815','2013-04-07','10:30:00',1.9),('5815','2013-04-07','10:35:00',1.83),('5815','2013-04-07','10:40:00',1.99),('5815','2013-04-07','10:45:00',2.07),('5815','2013-04-07','10:50:00',2.12),('5815','2013-04-07','10:55:00',2.05),('5815','2013-04-07','11:00:00',2.17),('5815','2013-04-07','11:05:00',1.93),('5815','2013-04-07','11:10:00',1.64),('5815','2013-04-07','11:15:00',1.67),('5815','2013-04-07','11:20:00',1.38),('5815','2013-04-07','11:25:00',1.16),('5815','2013-04-07','11:30:00',1.26),('5815','2013-04-07','11:35:00',1.62),('5815','2013-04-07','11:40:00',1.83),('5815','2013-04-07','11:45:00',1.65),('5815','2013-04-07','11:50:00',1.56),('5815','2013-04-07','11:55:00',1.32),('5815','2013-04-07','12:00:00',1.27),('5815','2013-04-07','12:05:00',1.19),('5815','2013-04-07','12:10:00',1.26),('5815','2013-04-07','12:15:00',1.52),('5815','2013-04-07','12:20:00',1.53),('5815','2013-04-07','12:25:00',1.58),('5815','2013-04-07','12:30:00',1.72),('5815','2013-04-07','12:35:00',1.62),('5815','2013-04-07','12:40:00',1.22),('5815','2013-04-07','12:45:00',1.31),('5815','2013-04-07','12:50:00',1.64),('5815','2013-04-07','12:55:00',1.84),('5815','2013-04-07','13:00:00',1.26),('5815','2013-04-07','13:05:00',1.35),('5815','2013-04-07','13:10:00',1.63),('5815','2013-04-07','13:15:00',1.72),('5815','2013-04-07','13:20:00',2.18),('5815','2013-04-07','13:25:00',1.93),('5815','2013-04-07','13:30:00',1.69),('5815','2013-04-07','13:35:00',1.85),('5815','2013-04-07','13:40:00',2.15),('5815','2013-04-07','13:45:00',1.74),('5815','2013-04-07','13:50:00',1.79),('5815','2013-04-07','13:55:00',2.33),('5815','2013-04-07','14:00:00',2.32),('5815','2013-04-07','14:05:00',1.9),('5815','2013-04-07','14:10:00',1.99),('5815','2013-04-07','14:15:00',2.24),('5815','2013-04-07','14:20:00',2.04),('5815','2013-04-07','14:25:00',2.37),('5815','2013-04-07','14:30:00',2.32),('5815','2013-04-07','14:35:00',2.21),('5815','2013-04-07','14:40:00',2.15),('5815','2013-04-07','14:45:00',2.21),('5815','2013-04-07','14:50:00',2.23),('5815','2013-04-07','14:55:00',2.36),('5815','2013-04-07','15:00:00',1.86),('5815','2013-04-07','15:05:00',1.86),('5815','2013-04-07','15:10:00',1.73),('5815','2013-04-07','15:15:00',1.86),('5815','2013-04-07','15:20:00',1.59),('5815','2013-04-07','15:25:00',2.16),('5815','2013-04-07','15:30:00',2.24),('5815','2013-04-07','15:35:00',2.14),('5815','2013-04-07','15:40:00',2.09),('5815','2013-04-07','15:45:00',2.04),('5815','2013-04-07','15:50:00',2.01),('5815','2013-04-07','15:55:00',1.98),('5815','2013-04-07','16:00:00',1.94),('5815','2013-04-07','16:05:00',1.85),('5815','2013-04-07','16:10:00',1.7),('5815','2013-04-07','16:15:00',1.82),('5815','2013-04-07','16:20:00',1.81),('5815','2013-04-07','16:25:00',1.73),('5815','2013-04-07','16:30:00',1.69),('5815','2013-04-07','16:35:00',1.64),('5815','2013-04-07','16:40:00',1.59),('5815','2013-04-07','16:45:00',1.56),('5815','2013-04-07','16:50:00',1.52),('5815','2013-04-07','16:55:00',1.46),('5815','2013-04-07','17:00:00',1.42),('5815','2013-04-07','17:05:00',1.38),('5815','2013-04-07','17:10:00',1.3),('5815','2013-04-07','17:15:00',1.25),('5815','2013-04-07','17:20:00',1.16),('5815','2013-04-07','17:25:00',1.18),('5815','2013-04-06','09:45:00',1.07),('5815','2013-04-06','09:50:00',1.15),('5815','2013-04-06','09:55:00',1.28),('5815','2013-04-06','10:00:00',1.5),('5815','2013-04-06','10:05:00',1.54),('5815','2013-04-06','10:10:00',1.54),('5815','2013-04-06','10:15:00',1.56),('5815','2013-04-06','10:20:00',1.63),('5815','2013-04-06','10:25:00',1.6),('5815','2013-04-06','10:30:00',1.42),('5815','2013-04-06','10:35:00',1.58),('5815','2013-04-06','10:40:00',1.54),('5815','2013-04-06','10:45:00',1.53),('5815','2013-04-06','10:50:00',1.49),('5815','2013-04-06','10:55:00',1.33),('5815','2013-04-06','11:00:00',1.19),('5815','2013-04-06','11:05:00',1.03),('5815','2013-04-06','11:10:00',1.25),('5815','2013-04-06','11:15:00',1.73),('5815','2013-04-06','11:20:00',1.98),('5815','2013-04-06','11:25:00',2.17),('5815','2013-04-06','11:30:00',2.06),('5815','2013-04-06','11:35:00',1.94),('5815','2013-04-06','11:40:00',1.73),('5815','2013-04-06','11:45:00',1.38),('5815','2013-04-06','11:50:00',1.32),('5815','2013-04-06','11:55:00',1.39),('5815','2013-04-06','12:00:00',1.45),('5815','2013-04-06','12:05:00',1.41),('5815','2013-04-06','12:10:00',1.54),('5815','2013-04-06','12:15:00',1.48),('5815','2013-04-06','12:20:00',1.62),('5815','2013-04-06','12:25:00',1.78),('5815','2013-04-06','12:30:00',1.51),('5815','2013-04-06','12:35:00',1.65),('5815','2013-04-06','12:40:00',1.62),('5815','2013-04-06','12:45:00',1.41),('5815','2013-04-06','12:50:00',1.47),('5815','2013-04-06','12:55:00',1.6),('5815','2013-04-06','13:00:00',1.86),('5815','2013-04-06','13:05:00',2.05),('5815','2013-04-06','13:10:00',2),('5815','2013-04-06','13:15:00',1.77),('5815','2013-04-06','13:20:00',1.65),('5815','2013-04-06','13:25:00',1.9),('5815','2013-04-06','13:30:00',1.96),('5815','2013-04-06','13:35:00',1.77),('5815','2013-04-06','13:40:00',1.9),('5815','2013-04-06','13:45:00',2.11),('5815','2013-04-06','13:50:00',1.94),('5815','2013-04-06','13:55:00',1.82),('5815','2013-04-06','14:00:00',2.16),('5815','2013-04-06','14:05:00',1.94),('5815','2013-04-06','14:10:00',1.49),('5815','2013-04-06','14:15:00',1.36),('5815','2013-04-06','14:20:00',1.21),('5815','2013-04-06','14:25:00',1.42),('5815','2013-04-06','14:30:00',1.48),('5815','2013-04-06','14:35:00',1.35),('5815','2013-04-06','14:40:00',1.13),('5815','2013-04-06','14:45:00',1.26),('5815','2013-04-06','14:50:00',1.42),('5815','2013-04-06','14:55:00',1.35),('5815','2013-04-06','15:00:00',1.38),('5815','2013-04-06','15:05:00',1.77),('5815','2013-04-06','15:10:00',1.75),('5815','2013-04-06','15:15:00',1.73),('5815','2013-04-06','15:20:00',1.75),('5815','2013-04-06','15:25:00',1.87),('5815','2013-04-06','15:30:00',1.78),('5815','2013-04-06','15:35:00',1.66),('5815','2013-04-06','15:40:00',1.68),('5815','2013-04-06','15:45:00',1.56),('5815','2013-04-06','15:50:00',1.45),('5815','2013-04-06','15:55:00',1.56),('5815','2013-04-06','16:00:00',1.44),('5815','2013-04-06','16:05:00',1.29),('5815','2013-04-06','16:10:00',1.08),('5815','2013-04-06','16:45:00',1.29),('5815','2013-04-06','16:50:00',1.39),('5815','2013-04-06','16:55:00',1.25),('5815','2013-04-06','17:00:00',1.18),('5815','2013-04-06','17:20:00',1.04),('5815','2013-04-06','17:30:00',1.02),('5815','2013-04-06','17:35:00',1.01),('5815','2013-04-05','08:55:00',1),('5815','2013-04-05','09:00:00',1.05),('5815','2013-04-05','09:05:00',1.12),('5815','2013-04-05','09:10:00',1.17),('5815','2013-04-05','09:15:00',1.23),('5815','2013-04-05','09:20:00',1.28),('5815','2013-04-05','09:25:00',1.33),('5815','2013-04-05','09:30:00',1.37),('5815','2013-04-05','09:35:00',1.39),('5815','2013-04-05','09:40:00',1.46),('5815','2013-04-05','09:45:00',1.49),('5815','2013-04-05','09:50:00',1.53),('5815','2013-04-05','09:55:00',1.58),('5815','2013-04-05','10:00:00',1.63),('5815','2013-04-05','10:05:00',1.66),('5815','2013-04-05','10:10:00',1.69),('5815','2013-04-05','10:15:00',1.7),('5815','2013-04-05','10:20:00',1.78),('5815','2013-04-05','10:25:00',1.82),('5815','2013-04-05','10:30:00',1.89),('5815','2013-04-05','10:35:00',1.9),('5815','2013-04-05','10:40:00',1.93),('5815','2013-04-05','10:45:00',1.95),('5815','2013-04-05','10:50:00',1.99),('5815','2013-04-05','10:55:00',2.03),('5815','2013-04-05','11:00:00',2.06),('5815','2013-04-05','11:05:00',2.1),('5815','2013-04-05','11:10:00',2.14),('5815','2013-04-05','11:15:00',2.13),('5815','2013-04-05','11:20:00',2.18),('5815','2013-04-05','11:25:00',2.23),('5815','2013-04-05','11:30:00',2.24),('5815','2013-04-05','11:35:00',2.28),('5815','2013-04-05','11:40:00',2.32),('5815','2013-04-05','11:45:00',2.32),('5815','2013-04-05','11:50:00',2.33),('5815','2013-04-05','11:55:00',2.34),('5815','2013-04-05','12:00:00',2.32),('5815','2013-04-05','12:05:00',2.35),('5815','2013-04-05','12:10:00',2.34),('5815','2013-04-05','12:15:00',2.35),('5815','2013-04-05','12:20:00',2.25),('5815','2013-04-05','12:25:00',2.04),('5815','2013-04-05','12:30:00',2.31),('5815','2013-04-05','12:35:00',2.49),('5815','2013-04-05','12:40:00',2.46),('5815','2013-04-05','12:45:00',2.46),('5815','2013-04-05','12:50:00',2.46),('5815','2013-04-05','12:55:00',2.48),('5815','2013-04-05','13:00:00',2.46),('5815','2013-04-05','13:05:00',2.47),('5815','2013-04-05','13:10:00',2.46),('5815','2013-04-05','13:15:00',1.91),('5815','2013-04-05','13:20:00',1.48),('5815','2013-04-05','13:30:00',1.61),('5815','2013-04-05','13:35:00',2.65),('5815','2013-04-05','13:40:00',2.81),('5815','2013-04-05','13:45:00',2.79),('5815','2013-04-05','13:50:00',2.62),('5815','2013-04-05','13:55:00',2.61),('5815','2013-04-05','14:00:00',2.44),('5815','2013-04-05','14:05:00',2.56),('5815','2013-04-05','14:10:00',1.09),('5815','2013-04-05','14:15:00',2.65),('5815','2013-04-05','14:20:00',1.17),('5815','2013-04-05','14:25:00',1.85),('5815','2013-04-05','14:30:00',2.1),('5815','2013-04-05','14:35:00',2.42),('5815','2013-04-05','14:40:00',2.43),('5815','2013-04-05','14:45:00',2.3),('5815','2013-04-05','14:50:00',2.32),('5815','2013-04-05','14:55:00',1.91),('5815','2013-04-05','15:00:00',2.27),('5815','2013-04-05','15:05:00',2.26),('5815','2013-04-05','15:10:00',1.98),('5815','2013-04-05','15:15:00',2.15),('5815','2013-04-05','15:20:00',2.13),('5815','2013-04-05','15:25:00',2.11),('5815','2013-04-05','15:30:00',2.03),('5815','2013-04-05','15:35:00',2),('5815','2013-04-05','15:40:00',1.99),('5815','2013-04-05','15:45:00',1.8),('5815','2013-04-05','15:50:00',1.77),('5815','2013-04-05','15:55:00',1.91),('5815','2013-04-05','16:00:00',1.73),('5815','2013-04-05','16:05:00',1.85),('5815','2013-04-05','16:10:00',1.86),('5815','2013-04-05','16:15:00',1.71),('5815','2013-04-05','16:20:00',1.41),('5815','2013-04-05','16:25:00',1.17),('5815','2013-04-05','16:30:00',1.44),('5815','2013-04-05','16:35:00',1.38),('5815','2013-04-05','16:40:00',1.07),('5815','2013-04-05','16:45:00',1.44),('5815','2013-04-05','16:50:00',1.39),('5815','2013-04-05','16:55:00',1.22),('5815','2013-04-05','17:00:00',1.22),('5815','2013-04-05','17:05:00',1.07),('5815','2013-04-04','09:05:00',1.31),('5815','2013-04-04','09:15:00',1.28),('5815','2013-04-04','09:20:00',1.13),('5815','2013-04-04','09:40:00',1.24),('5815','2013-04-04','09:45:00',1.21),('5815','2013-04-04','10:10:00',1.24),('5815','2013-04-04','10:15:00',1.83),('5815','2013-04-04','10:25:00',1.39),('5815','2013-04-04','10:30:00',1.49),('5815','2013-04-04','10:35:00',1.31),('5815','2013-04-04','10:40:00',2),('5815','2013-04-04','10:45:00',1.34),('5815','2013-04-04','10:50:00',1.28),('5815','2013-04-04','10:55:00',1.37),('5815','2013-04-04','11:00:00',1.42),('5815','2013-04-04','11:05:00',1.93),('5815','2013-04-04','11:10:00',2.39),('5815','2013-04-04','11:15:00',2.42),('5815','2013-04-04','11:20:00',1.68),('5815','2013-04-04','11:25:00',1.87),('5815','2013-04-04','11:30:00',1.83),('5815','2013-04-04','11:35:00',2.45),('5815','2013-04-04','11:40:00',2.23),('5815','2013-04-04','11:45:00',2.22),('5815','2013-04-04','11:50:00',1.64),('5815','2013-04-04','11:55:00',2.19),('5815','2013-04-04','12:00:00',2.68),('5815','2013-04-04','12:05:00',2.04),('5815','2013-04-04','12:10:00',2.02),('5815','2013-04-04','12:15:00',1.17),('5815','2013-04-04','12:25:00',1.14),('5815','2013-04-04','12:45:00',1.96),('5815','2013-04-04','12:50:00',2.53),('5815','2013-04-04','12:55:00',2.53),('5815','2013-04-04','13:00:00',1.69),('5815','2013-04-04','13:05:00',2.32),('5815','2013-04-04','13:10:00',1.61),('5815','2013-04-04','13:15:00',1.63),('5815','2013-04-04','13:20:00',1.33),('5815','2013-04-04','13:25:00',1.75),('5815','2013-04-04','13:30:00',1.49),('5815','2013-04-04','13:35:00',1.95),('5815','2013-04-04','13:40:00',2.76),('5815','2013-04-04','13:45:00',1.71),('5815','2013-04-04','13:50:00',2.87),('5815','2013-04-04','13:55:00',2.36),('5815','2013-04-04','14:00:00',1.6),('5815','2013-04-04','14:05:00',2.83),('5815','2013-04-04','14:10:00',2.19),('5815','2013-04-04','14:15:00',2.23),('5815','2013-04-04','14:20:00',2.54),('5815','2013-04-04','14:25:00',2.4),('5815','2013-04-04','14:30:00',2.47),('5815','2013-04-04','14:35:00',2.44),('5815','2013-04-04','14:40:00',2.43),('5815','2013-04-04','14:45:00',2.29),('5815','2013-04-04','14:50:00',1.39),('5815','2013-04-04','14:55:00',2.69),('5815','2013-04-04','15:00:00',2.24),('5815','2013-04-04','15:05:00',2.2),('5815','2013-04-04','15:10:00',2.05),('5815','2013-04-04','15:25:00',1.24),('5815','2013-04-04','15:30:00',1.01),('5815','2013-04-04','15:50:00',1.02),('5815','2013-04-04','16:00:00',1.02),('5815','2013-04-04','16:15:00',1.37),('5815','2013-04-04','16:20:00',1.15),('5815','2013-04-04','16:25:00',1.14),('5815','2013-04-04','16:45:00',1.17),('5815','2013-04-04','16:50:00',1.84),('5815','2013-04-04','17:10:00',1.1),('5815','2013-04-04','17:15:00',1.21),('5815','2013-04-04','17:30:00',1.26),('5815','2013-04-03','09:00:00',1.08),('5815','2013-04-03','09:35:00',1.38),('5815','2013-04-03','09:40:00',1.3),('5815','2013-04-03','09:45:00',1.11),('5815','2013-04-03','10:05:00',1.36),('5815','2013-04-03','10:10:00',1.3),('5815','2013-04-03','10:25:00',1.76),('5815','2013-04-03','10:30:00',1.83),('5815','2013-04-03','10:35:00',1.15),('5815','2013-04-03','10:40:00',2.23),('5815','2013-04-03','10:45:00',1.24),('5815','2013-04-03','10:50:00',1.33),('5815','2013-04-03','10:55:00',2.03),('5815','2013-04-03','11:00:00',1.25),('5815','2013-04-03','11:40:00',1.59),('5815','2013-04-03','11:45:00',1.91),('5815','2013-04-03','11:50:00',2.21),('5815','2013-04-03','11:55:00',2.32),('5815','2013-04-03','12:00:00',2.32),('5815','2013-04-03','12:05:00',2.27),('5815','2013-04-03','12:10:00',2.33),('5815','2013-04-03','12:15:00',2.28),('5815','2013-04-03','12:20:00',2.08),('5815','2013-04-03','12:25:00',1.81),('5815','2013-04-03','12:30:00',1.72),('5815','2013-04-03','12:35:00',1.42),('5815','2013-04-03','12:40:00',2.16),('5815','2013-04-03','12:45:00',1.54),('5815','2013-04-03','12:50:00',2.12),('5815','2013-04-03','12:55:00',2.29),('5815','2013-04-03','13:00:00',2.21),('5815','2013-04-03','13:05:00',2.26),('5815','2013-04-03','13:10:00',2.35),('5815','2013-04-03','13:15:00',2.45),('5815','2013-04-03','13:20:00',2.38),('5815','2013-04-03','13:25:00',2.44),('5815','2013-04-03','13:30:00',2.4),('5815','2013-04-03','13:35:00',2.23),('5815','2013-04-03','13:40:00',1.9),('5815','2013-04-03','13:45:00',1.91),('5815','2013-04-03','13:50:00',1.86),('5815','2013-04-03','13:55:00',1.4),('5815','2013-04-03','14:00:00',1.47),('5815','2013-04-03','14:05:00',1.98),('5815','2013-04-03','14:10:00',2.3),('5815','2013-04-03','14:15:00',2.3),('5815','2013-04-03','14:20:00',2.26),('5815','2013-04-03','14:25:00',2.21),('5815','2013-04-03','14:30:00',2.2),('5815','2013-04-03','14:35:00',2.18),('5815','2013-04-03','14:40:00',2.18),('5815','2013-04-03','14:45:00',2.15),('5815','2013-04-03','14:50:00',2.14),('5815','2013-04-03','14:55:00',2.15),('5815','2013-04-03','15:00:00',2.11),('5815','2013-04-03','15:05:00',2.05),('5815','2013-04-03','15:10:00',1.94),('5815','2013-04-03','15:15:00',1.9),('5815','2013-04-03','15:20:00',1.94),('5815','2013-04-03','15:25:00',1.96),('5815','2013-04-03','15:30:00',1.94),('5815','2013-04-03','15:35:00',1.91),('5815','2013-04-03','15:40:00',1.86),('5815','2013-04-03','15:45:00',1.82),('5815','2013-04-03','15:50:00',1.75),('5815','2013-04-03','15:55:00',1.73),('5815','2013-04-03','16:00:00',1.71),('5815','2013-04-03','16:05:00',1.68),('5815','2013-04-03','16:10:00',1.55),('5815','2013-04-03','16:15:00',1.52),('5815','2013-04-03','16:20:00',1.36),('5815','2013-04-03','16:25:00',1.37),('5815','2013-04-03','16:30:00',1.07),('5815','2013-04-03','16:35:00',1.16),('5815','2013-04-03','16:40:00',1.11),('5815','2013-04-03','16:45:00',1.09),('5815','2013-04-03','16:55:00',1.12),('5815','2013-04-03','17:00:00',1.02),('5815','2013-04-03','17:05:00',1.02),('5815','2013-04-02','09:05:00',1.2),('5815','2013-04-02','09:10:00',1.25),('5815','2013-04-02','09:15:00',1.32),('5815','2013-04-02','09:20:00',1.4),('5815','2013-04-02','09:30:00',1.07),('5815','2013-04-02','09:40:00',1.69),('5815','2013-04-02','09:45:00',1.23),('5815','2013-04-02','09:50:00',1.74),('5815','2013-04-02','09:55:00',1.97),('5815','2013-04-02','10:00:00',2.04),('5815','2013-04-02','10:20:00',1.59),('5815','2013-04-02','10:25:00',1.99),('5815','2013-04-02','10:30:00',1.37),('5815','2013-04-02','10:35:00',1.23),('5815','2013-04-02','10:55:00',1.84),('5815','2013-04-02','11:05:00',2.49),('5815','2013-04-02','11:10:00',1.31),('5815','2013-04-02','11:15:00',1.7),('5815','2013-04-02','11:20:00',1.22),('5815','2013-04-02','11:25:00',1.55),('5815','2013-04-02','11:30:00',1.05),('5815','2013-04-02','11:40:00',1.33),('5815','2013-04-02','11:50:00',1.51),('5815','2013-04-02','11:55:00',1.3),('5815','2013-04-02','12:00:00',2.13),('5815','2013-04-02','12:05:00',1.66),('5815','2013-04-02','12:10:00',2.75),('5815','2013-04-02','12:20:00',2.09),('5815','2013-04-02','12:25:00',1.78),('5815','2013-04-02','12:30:00',2.47),('5815','2013-04-02','12:35:00',2.11),('5815','2013-04-02','12:40:00',2.16),('5815','2013-04-02','12:45:00',2.43),('5815','2013-04-02','12:50:00',2.59),('5815','2013-04-02','12:55:00',2.48),('5815','2013-04-02','13:00:00',2.63),('5815','2013-04-02','13:05:00',1.79),('5815','2013-04-02','13:10:00',1.4),('5815','2013-04-02','13:15:00',2.61),('5815','2013-04-02','13:20:00',1.77),('5815','2013-04-02','13:25:00',1.54),('5815','2013-04-02','13:30:00',1.46),('5815','2013-04-02','13:35:00',2.1),('5815','2013-04-02','13:40:00',1.91),('5815','2013-04-02','13:45:00',2.14),('5815','2013-04-02','13:50:00',1.82),('5815','2013-04-02','13:55:00',2.41),('5815','2013-04-02','14:00:00',2.3),('5815','2013-04-02','14:05:00',1.67),('5815','2013-04-02','14:10:00',1.47),('5815','2013-04-02','14:15:00',2.14),('5815','2013-04-02','14:20:00',1.62),('5815','2013-04-02','14:25:00',2.25),('5815','2013-04-02','14:30:00',1.92),('5815','2013-04-02','14:35:00',2.36),('5815','2013-04-02','14:40:00',2.48),('5815','2013-04-02','14:45:00',2.02),('5815','2013-04-02','14:55:00',1.34),('5815','2013-04-02','15:00:00',2.67),('5815','2013-04-02','15:05:00',2.4),('5815','2013-04-02','15:10:00',2.63),('5815','2013-04-02','15:15:00',2.32),('5815','2013-04-02','15:20:00',2.19),('5815','2013-04-02','15:25:00',2.46),('5815','2013-04-02','15:30:00',2.32),('5815','2013-04-02','15:35:00',2.33),('5815','2013-04-02','15:40:00',2.16),('5815','2013-04-02','15:45:00',1.92),('5815','2013-04-02','15:50:00',2.14),('5815','2013-04-02','15:55:00',2.01),('5815','2013-04-02','16:00:00',2.18),('5815','2013-04-02','16:05:00',2.09),('5815','2013-04-02','16:10:00',1.98),('5815','2013-04-02','16:15:00',1.96),('5815','2013-04-02','16:20:00',1.89),('5815','2013-04-02','16:25:00',1.86),('5815','2013-04-02','16:30:00',1.76),('5815','2013-04-02','16:35:00',1.55),('5815','2013-04-02','16:40:00',1.72),('5815','2013-04-02','16:45:00',1.63),('5815','2013-04-02','16:50:00',1.59),('5815','2013-04-02','16:55:00',1.52),('5815','2013-04-02','17:00:00',1.49),('5815','2013-04-02','17:05:00',1.43),('5815','2013-04-02','17:10:00',1.37),('5815','2013-04-02','17:15:00',1.32),('5815','2013-04-02','17:20:00',1.23),('5815','2013-04-02','17:25:00',1.13),('5815','2013-04-02','17:35:00',1.04),('5815','2013-04-01','08:45:00',1.01),('5815','2013-04-01','09:00:00',1.06),('5815','2013-04-01','09:05:00',1.12),('5815','2013-04-01','09:10:00',1.2),('5815','2013-04-01','09:15:00',1.3),('5815','2013-04-01','09:20:00',1.15),('5815','2013-04-01','09:30:00',1.56),('5815','2013-04-01','09:35:00',1.47),('5815','2013-04-01','09:40:00',1.06),('5815','2013-04-01','09:45:00',1.61),('5815','2013-04-01','09:50:00',1.1),('5815','2013-04-01','09:55:00',1.08),('5815','2013-04-01','10:00:00',1.22),('5815','2013-04-01','10:20:00',1.1),('5815','2013-04-01','10:25:00',1.07),('5815','2013-04-01','10:45:00',1.72),('5815','2013-04-01','10:50:00',2.26),('5815','2013-04-01','10:55:00',1.04),('5815','2013-04-01','11:05:00',1.49),('5815','2013-04-01','11:10:00',1.46),('5815','2013-04-01','12:05:00',1.27),('5815','2013-04-01','12:10:00',1.37),('5815','2013-04-01','12:15:00',1.59),('5815','2013-04-01','12:40:00',1.39),('5815','2013-04-01','12:45:00',1.19),('5815','2013-04-01','12:50:00',1.26),('5815','2013-04-01','12:55:00',1.26),('5815','2013-04-01','13:00:00',1.25),('5815','2013-04-01','13:05:00',1.37),('5815','2013-04-01','13:10:00',1.93),('5815','2013-04-01','13:15:00',1.37),('5815','2013-04-01','13:20:00',1.07),('5815','2013-04-01','13:25:00',1.85),('5815','2013-04-01','13:30:00',1.6),('5815','2013-04-01','13:35:00',1.06),('5815','2013-04-01','13:40:00',1.38),('5815','2013-04-01','13:45:00',1.49),('5815','2013-04-01','13:50:00',1.22),('5815','2013-04-01','14:00:00',1.47),('5815','2013-04-01','14:05:00',1.27),('5815','2013-04-01','14:10:00',1.97),('5815','2013-04-01','14:15:00',1.49),('5815','2013-04-01','14:20:00',2.2),('5815','2013-04-01','14:25:00',2.73),('5815','2013-04-01','14:30:00',2.07),('5815','2013-04-01','14:35:00',1.13),('5815','2013-04-01','14:40:00',1.3),('5815','2013-04-01','14:45:00',1.38),('5815','2013-04-01','14:50:00',1.26),('5815','2014-05-01','08:20:00',1.28),('5815','2014-05-01','09:30:00',1.01),('5815','2014-05-01','09:35:00',1.03),('5815','2014-05-01','10:00:00',1.03),('5815','2014-05-01','10:10:00',1.05),('5815','2014-05-01','13:10:00',1.04),('5815','2014-05-01','13:15:00',1.21),('5815','2014-05-01','13:20:00',1.77),('5815','2014-05-01','13:25:00',1.55),('5815','2014-05-01','13:30:00',1.4),('5815','2014-05-01','13:35:00',1.27),('5815','2014-05-01','13:40:00',1.57),('5815','2014-05-01','13:45:00',1.2),('5815','2014-05-01','14:40:00',1.92),('5815','2014-05-01','14:45:00',1.34),('5815','2014-05-01','14:55:00',1.03),('5815','2014-05-01','15:00:00',1.34),('5815','2014-05-01','15:05:00',1.2),('5815','2014-05-01','15:10:00',1.87),('5815','2014-05-01','15:15:00',2.7),('5815','2014-05-01','15:20:00',1.19),('5815','2014-05-01','15:25:00',1.06),('5815','2014-05-01','15:35:00',1.33),('5815','2014-05-01','15:40:00',2.03),('5815','2014-05-01','16:05:00',1.12),('5815','2014-05-01','16:20:00',1.7),('5815','2013-03-31','09:00:00',1.06),('5815','2013-03-31','09:05:00',1.13),('5815','2013-03-31','09:10:00',1.23),('5815','2013-03-31','09:15:00',1.29),('5815','2013-03-31','09:20:00',1.08),('5815','2013-03-31','09:25:00',1.25),('5815','2013-03-31','09:30:00',1.47),('5815','2013-03-31','09:40:00',1.53),('5815','2013-03-31','09:45:00',1.11),('5815','2013-03-31','09:50:00',1.46),('5815','2013-03-31','09:55:00',1.5),('5815','2013-03-31','10:00:00',1.65),('5815','2013-03-31','10:05:00',1.76),('5815','2013-03-31','10:10:00',1.6),('5815','2013-03-31','10:15:00',1.37),('5815','2013-03-31','10:20:00',1.76),('5815','2013-03-31','10:25:00',1.6),('5815','2013-03-31','10:30:00',1.44),('5815','2013-03-31','10:40:00',1.23),('5815','2013-03-31','10:45:00',2.16),('5815','2013-03-31','10:50:00',1.43),('5815','2013-03-31','11:10:00',1.36),('5815','2013-03-31','11:15:00',1.91),('5815','2013-03-31','11:20:00',1.43),('5815','2013-03-31','11:25:00',1.58),('5815','2013-03-31','11:35:00',1.1),('5815','2013-03-31','11:40:00',1.75),('5815','2013-03-31','11:45:00',1.84),('5815','2013-03-31','11:50:00',1.54),('5815','2013-03-31','11:55:00',1.24),('5815','2013-03-31','12:00:00',1.73),('5815','2013-03-31','12:05:00',1.1),('5815','2013-03-31','12:10:00',1.29),('5815','2013-03-31','12:15:00',1.19),('5815','2013-03-31','12:25:00',1.03),('5815','2013-03-31','12:30:00',1.45),('5815','2013-03-31','12:35:00',1.35),('5815','2013-03-31','12:40:00',1.33),('5815','2013-03-31','12:45:00',1.5),('5815','2013-03-31','12:50:00',1.58),('5815','2013-03-31','12:55:00',1.79),('5815','2013-03-31','13:00:00',1.7),('5815','2013-03-31','13:05:00',1.88),('5815','2013-03-31','13:10:00',1.75),('5815','2013-03-31','13:15:00',1.68),('5815','2013-03-31','13:20:00',1.65),('5815','2013-03-31','13:25:00',1.52),('5815','2013-03-31','13:30:00',1.78),('5815','2013-03-31','13:35:00',1.52),('5815','2013-03-31','13:40:00',1.81),('5815','2013-03-31','13:45:00',2.13),('5815','2013-03-31','13:50:00',2.39),('5815','2013-03-31','13:55:00',2.47),('5815','2013-03-31','14:00:00',1.39),('5815','2013-03-31','14:05:00',1),('5815','2013-03-31','14:10:00',1.28),('5815','2013-03-31','14:15:00',1.46),('5815','2013-03-31','14:20:00',1.48),('5815','2013-03-31','14:25:00',2.47),('5815','2013-03-31','14:30:00',1.8),('5815','2013-03-31','14:35:00',1.31),('5815','2013-03-31','14:40:00',1.16),('5815','2013-03-31','14:45:00',1.11),('5815','2013-03-31','14:50:00',1.2),('5815','2013-03-31','14:55:00',1.31),('5815','2013-03-31','15:00:00',1.13),('5815','2013-03-31','15:05:00',1.11),('5815','2013-03-31','15:10:00',1.13),('5815','2013-03-31','15:15:00',1.23),('5815','2013-03-31','15:20:00',1.28),('5815','2013-03-31','15:25:00',1.31),('5815','2013-03-31','15:30:00',1.15),('5815','2013-03-31','15:35:00',1.48),('5815','2013-03-31','15:40:00',1.38),('5815','2013-03-31','15:45:00',1.39),('5815','2013-03-31','15:50:00',1.65),('5815','2013-03-31','15:55:00',1.29),('5815','2013-03-31','16:00:00',1.13),('5815','2013-03-30','09:20:00',1.22),('5815','2013-03-30','09:25:00',1.6),('5815','2013-03-30','09:30:00',1.33),('5815','2013-03-30','09:35:00',1.25),('5815','2013-03-30','09:45:00',1.6),('5815','2013-03-30','09:55:00',1.07),('5815','2013-03-30','10:00:00',1.47),('5815','2013-03-30','10:20:00',1.14),('5815','2013-03-30','10:25:00',1.62),('5815','2013-03-30','10:30:00',1.42),('5815','2013-03-30','10:35:00',1.53),('5815','2013-03-30','10:50:00',1.09),('5815','2013-03-30','12:35:00',1.57),('5815','2013-03-30','12:40:00',1.88),('5815','2013-03-30','12:45:00',1.02),('5815','2013-03-30','12:55:00',1.08),('5815','2013-03-30','13:00:00',1.35),('5815','2013-03-30','13:05:00',1.15),('5815','2013-03-30','13:10:00',1.46),('5815','2013-03-30','13:15:00',1.72),('5815','2013-03-30','13:20:00',2.2),('5815','2013-03-30','13:25:00',1.92),('5815','2013-03-30','13:45:00',1.07),('5815','2013-03-30','13:50:00',1.1),('5815','2013-03-30','14:00:00',1.14),('5815','2013-03-30','14:05:00',1.98),('5815','2013-03-30','14:10:00',1.37),('5815','2013-03-30','14:15:00',1.65),('5815','2013-03-30','14:20:00',1.04),('5815','2013-03-30','14:30:00',1.28),('5815','2013-03-30','14:35:00',2.37),('5815','2013-03-30','14:40:00',2.53),('5815','2013-03-30','14:45:00',2.36),('5815','2013-03-30','14:50:00',2.28),('5815','2013-03-30','14:55:00',1.53),('5815','2013-03-30','15:00:00',1.75),('5815','2013-03-30','15:05:00',1.2),('5815','2013-03-30','15:10:00',1.81),('5815','2013-03-30','15:15:00',1.51),('5815','2013-03-30','15:20:00',2.26),('5815','2013-03-30','15:25:00',1.93),('5815','2013-03-30','15:30:00',1.73),('5815','2013-03-30','15:35:00',1.51),('5815','2013-03-30','15:40:00',2.31),('5815','2013-03-30','15:45:00',1.72),('5815','2013-03-30','16:00:00',1.34),('5815','2013-03-30','16:15:00',1.23),('5815','2013-03-30','16:20:00',1.01),('5815','2013-03-30','17:05:00',1.49),('5815','2013-03-30','17:10:00',1.08),('5815','2013-03-29','09:05:00',1.11),('5815','2013-03-29','09:20:00',1.95),('5815','2013-03-29','09:25:00',1.53),('5815','2013-03-29','09:35:00',1.03),('5815','2013-03-29','10:10:00',1),('5815','2013-03-29','10:35:00',1.09),('5815','2013-03-29','10:40:00',1.4),('5815','2013-03-29','10:45:00',1.97),('5815','2013-03-29','10:50:00',1.95),('5815','2013-03-29','10:55:00',1.39),('5815','2013-03-29','11:00:00',1.91),('5815','2013-03-29','11:05:00',2.37),('5815','2013-03-29','11:10:00',2.71),('5815','2013-03-29','11:15:00',2.46),('5815','2013-03-29','11:20:00',2.95),('5815','2013-03-29','11:25:00',2.72),('5815','2013-03-29','11:30:00',1.96),('5815','2013-03-29','11:35:00',1.81),('5815','2013-03-29','11:40:00',1.22),('5815','2013-03-29','11:45:00',1.89),('5815','2013-03-29','11:50:00',2.45),('5815','2013-03-29','11:55:00',2.15),('5815','2013-03-29','12:00:00',2.7),('5815','2013-03-29','12:05:00',1.52),('5815','2013-03-29','12:10:00',1.14),('5815','2013-03-29','12:15:00',1.07),('5815','2013-03-29','12:20:00',1.1),('5815','2013-03-29','13:15:00',1.39),('5815','2013-03-29','13:20:00',1.87),('5815','2013-03-29','13:50:00',1.56),('5815','2013-03-29','13:55:00',1.76),('5815','2013-03-29','14:00:00',1.61),('5815','2013-03-29','14:05:00',1.43),('5815','2013-03-29','14:20:00',1.16),('5815','2013-03-29','14:35:00',1.01),('5815','2013-03-28','08:10:00',1.15),('5815','2013-03-28','08:15:00',1.15),('5815','2013-03-28','08:20:00',1.2),('5815','2013-03-28','08:25:00',1.25),('5815','2013-03-28','08:30:00',1.3),('5815','2013-03-28','08:35:00',1.37),('5815','2013-03-28','08:40:00',1.42),('5815','2013-03-28','08:45:00',1.42),('5815','2013-03-28','08:50:00',1.42),('5815','2013-03-28','08:55:00',1.41),('5815','2013-03-28','09:00:00',1.38),('5815','2013-03-28','09:05:00',1.5),('5815','2013-03-28','09:10:00',1.56),('5815','2013-03-28','09:15:00',1.76),('5815','2013-03-28','09:20:00',1.86),('5815','2013-03-28','09:25:00',1.73),('5815','2013-03-28','09:30:00',1.96),('5815','2013-03-28','09:35:00',2),('5815','2013-03-28','09:40:00',1.9),('5815','2013-03-28','09:45:00',1.81),('5815','2013-03-28','09:50:00',1.99),('5815','2013-03-28','09:55:00',1.92),('5815','2013-03-28','10:00:00',1.98),('5815','2013-03-28','10:05:00',1.71),('5815','2013-03-28','10:10:00',1.56),('5815','2013-03-28','10:15:00',1.91),('5815','2013-03-28','10:20:00',1.79),('5815','2013-03-28','10:25:00',1.83),('5815','2013-03-28','10:30:00',1.79),('5815','2013-03-28','10:35:00',1.56),('5815','2013-03-28','10:40:00',1.79),('5815','2013-03-28','10:45:00',1.15),('5815','2013-03-28','10:50:00',1.64),('5815','2013-03-28','10:55:00',1.67),('5815','2013-03-28','11:00:00',2.36),('5815','2013-03-28','11:05:00',2.36),('5815','2013-03-28','11:10:00',2.66),('5815','2013-03-28','11:15:00',1.89),('5815','2013-03-28','11:20:00',1.16),('5815','2013-03-28','11:25:00',1.3),('5815','2013-03-28','11:30:00',2.6),('5815','2013-03-28','11:35:00',1.88),('5815','2013-03-28','11:40:00',2.59),('5815','2013-03-28','11:45:00',2.56),('5815','2013-03-28','11:50:00',2.57),('5815','2013-03-28','11:55:00',2.57),('5815','2013-03-28','12:00:00',2.57),('5815','2013-03-28','12:05:00',2.63),('5815','2013-03-28','12:10:00',2.59),('5815','2013-03-28','12:15:00',2.42),('5815','2013-03-28','12:20:00',2.6),('5815','2013-03-28','12:25:00',2.44),('5815','2013-03-28','12:30:00',2.3),('5815','2013-03-28','12:35:00',2.42),('5815','2013-03-28','12:40:00',2.56),('5815','2013-03-28','12:45:00',2.2),('5815','2013-03-28','12:50:00',2.01),('5815','2013-03-28','12:55:00',1.83),('5815','2013-03-28','13:00:00',2.26),('5815','2013-03-28','13:05:00',1.55),('5815','2013-03-28','13:10:00',2.34),('5815','2013-03-28','13:15:00',2.04),('5815','2013-03-28','13:20:00',2.12),('5815','2013-03-28','13:25:00',2.65),('5815','2013-03-28','13:30:00',2.33),('5815','2013-03-28','13:35:00',2.01),('5815','2013-03-28','13:40:00',2.04),('5815','2013-03-28','13:45:00',1.93),('5815','2013-03-28','13:50:00',2.07),('5815','2013-03-28','13:55:00',2.04),('5815','2013-03-28','14:00:00',2.1),('5815','2013-03-28','14:05:00',1.81),('5815','2013-03-28','14:10:00',1.42),('5815','2013-03-28','14:15:00',1.45),('5815','2013-03-28','14:20:00',1.45),('5815','2013-03-28','14:25:00',1.45),('5815','2013-03-28','14:30:00',1.22),('5815','2013-03-28','14:35:00',1.22),('5815','2013-03-28','14:40:00',1.17),('5815','2013-03-28','14:45:00',1.09),('5815','2013-03-28','14:50:00',1.01),('5815','2013-03-27','09:15:00',1.69),('5815','2013-03-27','11:55:00',1.11),('5815','2013-03-27','12:50:00',1.72),('5815','2013-03-27','12:55:00',2.03),('5815','2013-03-27','13:00:00',1.88),('5815','2013-03-27','13:05:00',2.42),('5815','2013-03-27','13:10:00',1.88),('5815','2013-03-27','13:15:00',2.06),('5815','2013-03-27','13:20:00',2.3),('5815','2013-03-27','13:25:00',2.12),('5815','2013-03-27','13:30:00',2.18),('5815','2013-03-27','13:35:00',1.66),('5815','2013-03-27','13:40:00',1.42),('5815','2013-03-27','13:45:00',1.2),('5815','2013-03-27','13:50:00',1.91),('5815','2013-03-27','14:00:00',1.09),('5815','2013-03-27','14:05:00',1.49),('5815','2013-03-27','14:10:00',1.11),('5815','2013-03-27','14:30:00',1.02),('5815','2013-03-27','15:10:00',1.13),('5815','2013-03-27','15:15:00',1.49),('5815','2013-03-27','15:25:00',1.26),('5815','2013-03-27','15:35:00',1.36),('5815','2013-03-27','15:40:00',1.11),('5815','2013-03-27','15:45:00',1.34),('5815','2013-03-27','15:55:00',1.67),('5815','2013-03-26','08:30:00',1.05),('5815','2013-03-26','08:35:00',1.06),('5815','2013-03-26','09:20:00',1.16),('5815','2013-03-26','09:50:00',1.28),('5815','2013-03-26','09:55:00',1.1),('5815','2013-03-26','10:15:00',1.04),('5815','2013-03-26','10:25:00',1.01),('5815','2013-03-26','10:30:00',1.27),('5815','2013-03-26','10:35:00',1.04),('5815','2013-03-26','10:40:00',1.05),('5815','2013-03-26','10:45:00',1.29),('5815','2013-03-26','10:50:00',1.12),('5815','2013-03-26','10:55:00',1.08),('5815','2013-03-26','11:20:00',1.05),('5815','2013-03-26','11:30:00',1.14),('5815','2013-03-26','11:35:00',1.07),('5815','2013-03-26','11:40:00',1.03),('5815','2013-03-26','11:55:00',1.48),('5815','2013-03-26','12:00:00',1.69),('5815','2013-03-26','12:05:00',1.64),('5815','2013-03-26','12:10:00',1.47),('5815','2013-03-26','12:15:00',1.07),('5815','2013-03-26','12:20:00',1.08),('5815','2013-03-26','12:30:00',1.72),('5815','2013-03-26','12:35:00',2.57),('5815','2013-03-26','12:40:00',2.27),('5815','2013-03-26','12:45:00',2.82),('5815','2013-03-26','12:50:00',1.62),('5815','2013-03-26','12:55:00',1.51),('5815','2013-03-26','13:10:00',1.31),('5815','2013-03-26','13:15:00',1.09),('5815','2013-03-26','13:30:00',1.02),('5815','2013-03-26','13:35:00',1.27),('5815','2013-03-26','13:40:00',1.1),('5815','2013-03-26','13:45:00',1.26),('5815','2013-03-26','13:50:00',1.42),('5815','2013-03-26','13:55:00',1.45),('5815','2013-03-26','14:15:00',1.02),('5815','2013-03-26','14:20:00',1.28),('5815','2013-03-26','14:25:00',1),('5815','2013-03-26','14:40:00',1.23),('5815','2013-03-26','14:45:00',1.27),('5815','2013-03-26','15:10:00',1.01),('5815','2013-03-25','07:55:00',1.21),('5815','2013-03-25','09:55:00',1.38),('5815','2013-03-25','11:10:00',1.44),('5815','2013-03-25','11:15:00',1),('5815','2013-03-25','12:25:00',1.39),('5815','2013-03-25','12:30:00',1.29),('5815','2013-03-25','12:35:00',1.63),('5815','2013-03-25','12:45:00',1.74),('5815','2013-03-25','12:50:00',1.15),('5815','2013-03-25','13:05:00',1.4),('5815','2013-03-25','13:10:00',1.22),('5815','2013-03-25','13:15:00',1.2),('5815','2013-03-25','13:25:00',1.29),('5815','2013-03-25','13:35:00',1.1),('5815','2013-03-25','13:40:00',1.32),('5815','2013-03-25','13:45:00',1.16),('5815','2013-03-24','08:25:00',1),('5815','2013-03-24','09:20:00',1.32),('5815','2013-03-24','09:25:00',1.78),('5815','2013-03-24','09:50:00',1.65),('5815','2013-03-24','09:55:00',2.3),('5815','2013-03-24','10:00:00',1.44),('5815','2013-03-24','10:25:00',1.27),('5815','2013-03-24','10:30:00',1.5),('5815','2013-03-24','10:45:00',1.4),('5815','2013-03-24','10:50:00',1.16),('5815','2013-03-24','10:55:00',1.37),('5815','2013-03-24','11:00:00',1.28),('5815','2013-03-24','11:05:00',1.1),('5815','2013-03-24','11:10:00',1.05),('5815','2013-03-24','11:15:00',1.06),('5815','2013-03-24','11:20:00',2.21),('5815','2013-03-24','11:25:00',2.09),('5815','2013-03-24','11:30:00',1.69),('5815','2013-03-24','11:35:00',1.45),('5815','2013-03-24','11:55:00',1.56),('5815','2013-03-24','12:00:00',2.43),('5815','2013-03-24','12:05:00',2.02),('5815','2013-03-24','12:10:00',2.17),('5815','2013-03-24','12:15:00',2.34),('5815','2013-03-24','12:20:00',1.7),('5815','2013-03-24','12:25:00',2.17),('5815','2013-03-24','12:30:00',2.39),('5815','2013-03-24','12:35:00',1.8),('5815','2013-03-24','12:40:00',1.44),('5815','2013-03-24','12:45:00',1.57),('5815','2013-03-24','12:50:00',1.78),('5815','2013-03-24','12:55:00',1.74),('5815','2013-03-24','13:00:00',1.36),('5815','2013-03-24','13:05:00',2.64),('5815','2013-03-24','13:10:00',2.35),('5815','2013-03-24','13:15:00',2.29),('5815','2013-03-24','13:20:00',2.57),('5815','2013-03-24','13:25:00',1.58),('5815','2013-03-24','13:30:00',1.21),('5815','2013-03-24','13:45:00',1.11),('5815','2013-03-24','13:50:00',1.28),('5815','2013-03-24','13:55:00',1.09),('5815','2013-03-24','14:10:00',1.56),('5815','2013-03-24','14:15:00',1.21),('5815','2013-03-24','14:20:00',1.34),('5815','2013-03-24','14:25:00',1.68),('5815','2013-03-24','14:30:00',2.31),('5815','2013-03-24','14:35:00',1.62),('5815','2013-03-24','14:50:00',1.07),('5815','2013-03-24','14:55:00',1.62),('5815','2013-03-24','15:00:00',1.46),('5815','2013-03-24','15:05:00',1.42),('5815','2013-03-24','15:10:00',1.29),('5815','2013-03-24','15:15:00',1.13),('5815','2013-03-24','15:20:00',1.55),('5815','2013-03-24','15:25:00',2),('5815','2013-03-24','15:30:00',1.36),('5815','2013-03-24','15:35:00',1.73),('5815','2013-03-24','15:40:00',1.12),('5815','2013-03-24','16:00:00',1.13),('5815','2013-03-23','08:10:00',1.02),('5815','2013-03-23','08:15:00',1.09),('5815','2013-03-23','08:20:00',1.15),('5815','2013-03-23','08:25:00',1.2),('5815','2013-03-23','08:30:00',1.25),('5815','2013-03-23','08:35:00',1.3),('5815','2013-03-23','08:40:00',1.35),('5815','2013-03-23','08:45:00',1.39),('5815','2013-03-23','08:50:00',1.42),('5815','2013-03-23','08:55:00',1.46),('5815','2013-03-23','09:00:00',1.5),('5815','2013-03-23','09:05:00',1.56),('5815','2013-03-23','09:10:00',1.6),('5815','2013-03-23','09:15:00',1.65),('5815','2013-03-23','09:20:00',1.7),('5815','2013-03-23','09:25:00',1.73),('5815','2013-03-23','09:30:00',1.77),('5815','2013-03-23','09:35:00',1.79),('5815','2013-03-23','09:40:00',1.83),('5815','2013-03-23','09:45:00',1.86),('5815','2013-03-23','09:50:00',1.91),('5815','2013-03-23','09:55:00',1.93),('5815','2013-03-23','10:00:00',1.97),('5815','2013-03-23','10:05:00',2.01),('5815','2013-03-23','10:10:00',2.04),('5815','2013-03-23','10:15:00',2.07),('5815','2013-03-23','10:20:00',2.1),('5815','2013-03-23','10:25:00',2.11),('5815','2013-03-23','10:30:00',2.15),('5815','2013-03-23','10:35:00',2.15),('5815','2013-03-23','10:40:00',2.15),('5815','2013-03-23','10:45:00',2.17),('5815','2013-03-23','10:50:00',2.18),('5815','2013-03-23','10:55:00',2.2),('5815','2013-03-23','11:00:00',2.22),('5815','2013-03-23','11:05:00',2.25),('5815','2013-03-23','11:10:00',2.26),('5815','2013-03-23','11:15:00',2.26),('5815','2013-03-23','11:20:00',2.26),('5815','2013-03-23','11:25:00',2.27),('5815','2013-03-23','11:30:00',2.3),('5815','2013-03-23','11:35:00',2.3),('5815','2013-03-23','11:40:00',2.3),('5815','2013-03-23','11:45:00',2.32),('5815','2013-03-23','11:50:00',2.33),('5815','2013-03-23','11:55:00',2.3),('5815','2013-03-23','12:00:00',2.36),('5815','2013-03-23','12:05:00',2.37),('5815','2013-03-23','12:10:00',2.39),('5815','2013-03-23','12:15:00',2.42),('5815','2013-03-23','12:20:00',2.46),('5815','2013-03-23','12:25:00',2.49),('5815','2013-03-23','12:30:00',2.48),('5815','2013-03-23','12:35:00',2.49),('5815','2013-03-23','12:40:00',2.49),('5815','2013-03-23','12:45:00',2.48),('5815','2013-03-23','12:50:00',2.48),('5815','2013-03-23','12:55:00',2.46),('5815','2013-03-23','13:00:00',2.45),('5815','2013-03-23','13:05:00',2.46),('5815','2013-03-23','13:10:00',2.42),('5815','2013-03-23','13:15:00',2.44),('5815','2013-03-23','13:20:00',2.43),('5815','2013-03-23','13:25:00',2.39),('5815','2013-03-23','13:30:00',2.37),('5815','2013-03-23','13:35:00',2.36),('5815','2013-03-23','13:40:00',2.34),('5815','2013-03-23','13:45:00',2.32),('5815','2013-03-23','13:50:00',2.31),('5815','2013-03-23','13:55:00',2.29),('5815','2013-03-23','14:00:00',2.27),('5815','2013-03-23','14:05:00',2.24),('5815','2013-03-23','14:10:00',2.19),('5815','2013-03-23','14:15:00',2.17),('5815','2013-03-23','14:20:00',2.14),('5815','2013-03-23','14:25:00',2.09),('5815','2013-03-23','14:30:00',2.05),('5815','2013-03-23','14:35:00',1.97),('5815','2013-03-23','14:40:00',1.93),('5815','2013-03-23','14:45:00',1.93),('5815','2013-03-23','14:50:00',1.85),('5815','2013-03-23','14:55:00',1.82),('5815','2013-03-23','15:00:00',1.77),('5815','2013-03-23','15:05:00',1.73),('5815','2013-03-23','15:10:00',1.63),('5815','2013-03-23','15:15:00',1.77),('5815','2013-03-23','15:20:00',1.7),('5815','2013-03-23','15:25:00',1.62),('5815','2013-03-23','15:30:00',1.46),('5815','2013-03-23','15:35:00',1.43),('5815','2013-03-23','15:40:00',1.42),('5815','2013-03-23','15:45:00',1.23),('5815','2013-03-22','08:05:00',1),('5815','2013-03-22','08:10:00',1.05),('5815','2013-03-22','08:15:00',1.11),('5815','2013-03-22','08:20:00',1.16),('5815','2013-03-22','08:25:00',1.21),('5815','2013-03-22','08:30:00',1.23),('5815','2013-03-22','08:35:00',1.29),('5815','2013-03-22','08:40:00',1.36),('5815','2013-03-22','08:45:00',1.41),('5815','2013-03-22','08:50:00',1.45),('5815','2013-03-22','08:55:00',1.54),('5815','2013-03-22','09:00:00',1.57),('5815','2013-03-22','09:05:00',1.62),('5815','2013-03-22','09:10:00',1.63),('5815','2013-03-22','09:15:00',1.7),('5815','2013-03-22','09:20:00',1.7),('5815','2013-03-22','09:25:00',1.77),('5815','2013-03-22','09:30:00',1.83),('5815','2013-03-22','09:35:00',1.82),('5815','2013-03-22','09:40:00',1.77),('5815','2013-03-22','09:45:00',1.9),('5815','2013-03-22','09:50:00',1.94),('5815','2013-03-22','09:55:00',2.01),('5815','2013-03-22','10:00:00',2.03),('5815','2013-03-22','10:05:00',2.05),('5815','2013-03-22','10:10:00',2.09),('5815','2013-03-22','10:15:00',2.07),('5815','2013-03-22','10:20:00',2.06),('5815','2013-03-22','10:25:00',2.04),('5815','2013-03-22','10:30:00',2.18),('5815','2013-03-22','10:35:00',2.21),('5815','2013-03-22','10:40:00',2.2),('5815','2013-03-22','10:45:00',2.2),('5815','2013-03-22','10:50:00',2.18),('5815','2013-03-22','10:55:00',2.13),('5815','2013-03-22','11:00:00',2.09),('5815','2013-03-22','11:05:00',1.95),('5815','2013-03-22','11:10:00',1.68),('5815','2013-03-22','11:15:00',1.82),('5815','2013-03-22','11:20:00',2.22),('5815','2013-03-22','11:25:00',2.21),('5815','2013-03-22','11:30:00',2.22),('5815','2013-03-22','11:35:00',2.33),('5815','2013-03-22','11:40:00',2.33),('5815','2013-03-22','11:45:00',2.34),('5815','2013-03-22','11:50:00',2.25),('5815','2013-03-22','11:55:00',2.36),('5815','2013-03-22','12:00:00',2.37),('5815','2013-03-22','12:05:00',2.35),('5815','2013-03-22','12:10:00',2.33),('5815','2013-03-22','12:15:00',2.37),('5815','2013-03-22','12:20:00',2.37),('5815','2013-03-22','12:25:00',2.38),('5815','2013-03-22','12:30:00',2.41),('5815','2013-03-22','12:35:00',2.41),('5815','2013-03-22','12:40:00',2.29),('5815','2013-03-22','12:45:00',2.35),('5815','2013-03-22','12:50:00',2.4),('5815','2013-03-22','12:55:00',2.37),('5815','2013-03-22','13:00:00',1.78),('5815','2013-03-22','13:05:00',2.31),('5815','2013-03-22','13:10:00',2.35),('5815','2013-03-22','13:15:00',2.25),('5815','2013-03-22','13:20:00',2.31),('5815','2013-03-22','13:25:00',2.31),('5815','2013-03-22','13:30:00',2.22),('5815','2013-03-22','13:35:00',2.06),('5815','2013-03-22','13:40:00',2.24),('5815','2013-03-22','13:45:00',1.78),('5815','2013-03-22','13:50:00',2.18),('5815','2013-03-22','13:55:00',2.19),('5815','2013-03-22','14:00:00',2.16),('5815','2013-03-22','14:05:00',2.15),('5815','2013-03-22','14:10:00',2.12),('5815','2013-03-22','14:15:00',2.06),('5815','2013-03-22','14:20:00',2.11),('5815','2013-03-22','14:25:00',2.08),('5815','2013-03-22','14:30:00',2.09),('5815','2013-03-22','14:35:00',2.03),('5815','2013-03-22','14:40:00',1.97),('5815','2013-03-22','14:45:00',1.84),('5815','2013-03-22','14:50:00',1.82),('5815','2013-03-22','14:55:00',1.83),('5815','2013-03-22','15:00:00',1.77),('5815','2013-03-22','15:05:00',1.66),('5815','2013-03-22','15:10:00',1.74),('5815','2013-03-22','15:15:00',1.62),('5815','2013-03-22','15:20:00',1.64),('5815','2013-03-22','15:25:00',1.63),('5815','2013-03-22','15:30:00',1.48),('5815','2013-03-22','15:35:00',1.48),('5815','2013-03-22','15:40:00',1.38),('5815','2013-03-22','15:45:00',1.3),('5815','2013-03-22','15:50:00',1.21),('5815','2013-03-22','15:55:00',1.17),('5815','2013-03-22','16:00:00',1.1),('5815','2013-03-22','16:10:00',1.25),('5815','2013-03-22','16:15:00',1.13),('5815','2013-03-21','08:10:00',1.04),('5815','2013-03-21','08:15:00',1.1),('5815','2013-03-21','08:20:00',1.16),('5815','2013-03-21','08:25:00',1.22),('5815','2013-03-21','08:30:00',1.27),('5815','2013-03-21','08:35:00',1.32),('5815','2013-03-21','08:40:00',1.38),('5815','2013-03-21','08:45:00',1.42),('5815','2013-03-21','08:50:00',1.46),('5815','2013-03-21','08:55:00',1.52),('5815','2013-03-21','09:00:00',1.56),('5815','2013-03-21','09:05:00',1.61),('5815','2013-03-21','09:10:00',1.65),('5815','2013-03-21','09:15:00',1.7),('5815','2013-03-21','09:20:00',1.71),('5815','2013-03-21','09:25:00',1.77),('5815','2013-03-21','09:30:00',1.81),('5815','2013-03-21','09:35:00',1.86),('5815','2013-03-21','09:40:00',1.92),('5815','2013-03-21','09:45:00',1.94),('5815','2013-03-21','09:50:00',2),('5815','2013-03-21','09:55:00',2),('5815','2013-03-21','10:00:00',2.05),('5815','2013-03-21','10:05:00',2.02),('5815','2013-03-21','10:10:00',2.09),('5815','2013-03-21','10:15:00',2.12),('5815','2013-03-21','10:20:00',2.11),('5815','2013-03-21','10:25:00',2.17),('5815','2013-03-21','10:30:00',2.24),('5815','2013-03-21','10:35:00',2.28),('5815','2013-03-21','10:40:00',2.33),('5815','2013-03-21','10:45:00',2.35),('5815','2013-03-21','10:50:00',2.37),('5815','2013-03-21','10:55:00',2.38),('5815','2013-03-21','11:00:00',2.37),('5815','2013-03-21','11:05:00',2.39),('5815','2013-03-21','11:10:00',2.42),('5815','2013-03-21','11:15:00',2.43),('5815','2013-03-21','11:20:00',2.44),('5815','2013-03-21','11:25:00',2.45),('5815','2013-03-21','11:30:00',2.47),('5815','2013-03-21','11:35:00',2.51),('5815','2013-03-21','11:40:00',2.49),('5815','2013-03-21','11:45:00',2.55),('5815','2013-03-21','11:50:00',2.53),('5815','2013-03-21','11:55:00',2.55),('5815','2013-03-21','12:00:00',2.56),('5815','2013-03-21','12:05:00',2.57),('5815','2013-03-21','12:10:00',2.56),('5815','2013-03-21','12:15:00',2.56),('5815','2013-03-21','12:20:00',2.55),('5815','2013-03-21','12:25:00',2.54),('5815','2013-03-21','12:30:00',2.55),('5815','2013-03-21','12:35:00',2.57),('5815','2013-03-21','12:40:00',2.59),('5815','2013-03-21','12:45:00',2.57),('5815','2013-03-21','12:50:00',2.49),('5815','2013-03-21','12:55:00',2.33),('5815','2013-03-21','13:00:00',2.57),('5815','2013-03-21','13:05:00',2.48),('5815','2013-03-21','13:10:00',2.56),('5815','2013-03-21','13:15:00',2.54),('5815','2013-03-21','13:20:00',2.5),('5815','2013-03-21','13:25:00',2.41),('5815','2013-03-21','13:30:00',2.36),('5815','2013-03-21','13:35:00',2.42),('5815','2013-03-21','13:40:00',2.04),('5815','2013-03-21','13:45:00',2.12),('5815','2013-03-21','13:50:00',2.46),('5815','2013-03-21','13:55:00',2.41),('5815','2013-03-21','14:00:00',2.36),('5815','2013-03-21','14:05:00',2.34),('5815','2013-03-21','14:10:00',2.31),('5815','2013-03-21','14:15:00',2.3),('5815','2013-03-21','14:20:00',2.26),('5815','2013-03-21','14:25:00',2.21),('5815','2013-03-21','14:30:00',2.19),('5815','2013-03-21','14:35:00',2.15),('5815','2013-03-21','14:40:00',2.1),('5815','2013-03-21','14:45:00',2.08),('5815','2013-03-21','14:50:00',2.06),('5815','2013-03-21','14:55:00',2.02),('5815','2013-03-21','15:00:00',2),('5815','2013-03-21','15:05:00',1.96),('5815','2013-03-21','15:10:00',1.75),('5815','2013-03-21','15:15:00',1.45),('5815','2013-03-21','15:20:00',1.44),('5815','2013-03-21','15:25:00',1.54),('5815','2013-03-21','15:30:00',1.42),('5815','2013-03-21','15:35:00',1.57),('5815','2013-03-21','15:40:00',1.5),('5815','2013-03-21','15:45:00',1.34),('5815','2013-03-21','15:50:00',1.44),('5815','2013-03-21','15:55:00',1.26),('5815','2013-03-21','16:10:00',1.05),('5815','2013-03-21','16:15:00',1.24),('5815','2013-03-20','08:15:00',1.17),('5815','2013-03-20','08:20:00',1.21),('5815','2013-03-20','08:25:00',1.21),('5815','2013-03-20','08:30:00',1.34),('5815','2013-03-20','08:35:00',1.39),('5815','2013-03-20','08:40:00',1.44),('5815','2013-03-20','08:45:00',1.51),('5815','2013-03-20','08:50:00',1.54),('5815','2013-03-20','08:55:00',1.6),('5815','2013-03-20','09:00:00',1.67),('5815','2013-03-20','09:05:00',1.77),('5815','2013-03-20','09:10:00',2),('5815','2013-03-20','09:15:00',1.22),('5815','2013-03-20','09:20:00',1.6),('5815','2013-03-20','09:25:00',1.98),('5815','2013-03-20','09:30:00',1.98),('5815','2013-03-20','09:35:00',1.99),('5815','2013-03-20','09:40:00',2.02),('5815','2013-03-20','09:45:00',2.07),('5815','2013-03-20','09:50:00',1.82),('5815','2013-03-20','09:55:00',2.18),('5815','2013-03-20','10:00:00',2.21),('5815','2013-03-20','10:05:00',2.23),('5815','2013-03-20','10:10:00',2.26),('5815','2013-03-20','10:15:00',2.28),('5815','2013-03-20','10:20:00',2.31),('5815','2013-03-20','10:25:00',2.32),('5815','2013-03-20','10:30:00',2.34),('5815','2013-03-20','10:35:00',2.38),('5815','2013-03-20','10:40:00',2.41),('5815','2013-03-20','10:45:00',2.39),('5815','2013-03-20','10:50:00',2.41),('5815','2013-03-20','10:55:00',1.67),('5815','2013-03-20','11:00:00',2.51),('5815','2013-03-20','11:05:00',2.5),('5815','2013-03-20','11:10:00',2.54),('5815','2013-03-20','11:15:00',2.56),('5815','2013-03-20','11:20:00',2.58),('5815','2013-03-20','11:25:00',2.6),('5815','2013-03-20','11:30:00',2.62),('5815','2013-03-20','11:35:00',2.63),('5815','2013-03-20','11:40:00',2.63),('5815','2013-03-20','11:45:00',2.64),('5815','2013-03-20','11:50:00',2.67),('5815','2013-03-20','11:55:00',2.67),('5815','2013-03-20','12:00:00',2.68),('5815','2013-03-20','12:05:00',2.69),('5815','2013-03-20','12:10:00',2.7),('5815','2013-03-20','12:15:00',2.69),('5815','2013-03-20','12:20:00',2.69),('5815','2013-03-20','12:25:00',2.69),('5815','2013-03-20','12:30:00',2.68),('5815','2013-03-20','12:35:00',2.7),('5815','2013-03-20','12:40:00',2.69),('5815','2013-03-20','12:45:00',2.68),('5815','2013-03-20','12:50:00',2.66),('5815','2013-03-20','12:55:00',2.64),('5815','2013-03-20','13:00:00',2.64),('5815','2013-03-20','13:05:00',2.61),('5815','2013-03-20','13:10:00',2.6),('5815','2013-03-20','13:15:00',2.58),('5815','2013-03-20','13:20:00',2.57),('5815','2013-03-20','13:25:00',2.57),('5815','2013-03-20','13:30:00',2.53),('5815','2013-03-20','13:35:00',2.53),('5815','2013-03-20','13:40:00',2.52),('5815','2013-03-20','13:45:00',2.48),('5815','2013-03-20','13:50:00',2.47),('5815','2013-03-20','13:55:00',2.44),('5815','2013-03-20','14:00:00',2.41),('5815','2013-03-20','14:05:00',2.37),('5815','2013-03-20','14:10:00',2.34),('5815','2013-03-20','14:15:00',2.3),('5815','2013-03-20','14:20:00',2.28),('5815','2013-03-20','14:25:00',2.26),('5815','2013-03-20','14:30:00',2.22),('5815','2013-03-20','14:35:00',2.18),('5815','2013-03-20','14:40:00',2.14),('5815','2013-03-20','14:45:00',2.09),('5815','2013-03-20','14:50:00',2.08),('5815','2013-03-20','14:55:00',2.05),('5815','2013-03-20','15:00:00',1.99),('5815','2013-03-20','15:05:00',1.97),('5815','2013-03-20','15:10:00',1.92),('5815','2013-03-20','15:15:00',1.88),('5815','2013-03-20','15:20:00',1.83),('5815','2013-03-20','15:25:00',1.78),('5815','2013-03-20','15:30:00',1.74),('5815','2013-03-20','15:35:00',1.69),('5815','2013-03-20','15:40:00',1.64),('5815','2013-03-20','15:45:00',1.58),('5815','2013-03-20','15:50:00',1.53),('5815','2013-03-20','15:55:00',1.48),('5815','2013-03-20','16:00:00',1.42),('5815','2013-03-20','16:05:00',1.37),('5815','2013-03-20','16:10:00',1.31),('5815','2013-03-20','16:15:00',1.24),('5815','2013-03-20','16:20:00',1.19),('5815','2013-03-20','16:25:00',1.05),('5815','2013-03-19','08:10:00',1.02),('5815','2013-03-19','08:15:00',1.09),('5815','2013-03-19','08:20:00',1.14),('5815','2013-03-19','08:25:00',1.21),('5815','2013-03-19','08:30:00',1.27),('5815','2013-03-19','08:35:00',1.28),('5815','2013-03-19','08:40:00',1.22),('5815','2013-03-19','08:45:00',1.35),('5815','2013-03-19','08:50:00',1.42),('5815','2013-03-19','08:55:00',1.4),('5815','2013-03-19','09:00:00',1.37),('5815','2013-03-19','09:05:00',1.83),('5815','2013-03-19','09:10:00',1.46),('5815','2013-03-19','09:15:00',1.64),('5815','2013-03-19','09:20:00',1.65),('5815','2013-03-19','09:25:00',1.68),('5815','2013-03-19','09:30:00',1.83),('5815','2013-03-19','09:35:00',1.78),('5815','2013-03-19','09:40:00',1.88),('5815','2013-03-19','09:45:00',1.93),('5815','2013-03-19','09:50:00',1.96),('5815','2013-03-19','09:55:00',1.95),('5815','2013-03-19','10:00:00',2.02),('5815','2013-03-19','10:05:00',2.05),('5815','2013-03-19','10:10:00',1.99),('5815','2013-03-19','10:15:00',1.55),('5815','2013-03-19','10:20:00',1.68),('5815','2013-03-19','10:25:00',1.47),('5815','2013-03-19','10:30:00',1.87),('5815','2013-03-19','10:35:00',2.1),('5815','2013-03-19','10:40:00',1.93),('5815','2013-03-19','10:45:00',1.36),('5815','2013-03-19','10:50:00',1.98),('5815','2013-03-19','10:55:00',1.78),('5815','2013-03-19','11:00:00',1.69),('5815','2013-03-19','11:05:00',1.79),('5815','2013-03-19','11:10:00',1.69),('5815','2013-03-19','11:15:00',1.41),('5815','2013-03-19','11:20:00',1.62),('5815','2013-03-19','11:25:00',1.58),('5815','2013-03-19','11:30:00',1.43),('5815','2013-03-19','11:35:00',1.57),('5815','2013-03-19','11:40:00',1.3),('5815','2013-03-19','11:45:00',1.21),('5815','2013-03-19','11:50:00',1.13),('5815','2013-03-19','11:55:00',1.28),('5815','2013-03-19','12:00:00',1.22),('5815','2013-03-19','12:05:00',1.4),('5815','2013-03-19','12:10:00',1.12),('5815','2013-03-19','13:00:00',1.04),('5815','2013-03-19','13:45:00',1.15),('5815','2013-03-19','14:20:00',1.21),('5815','2013-03-19','14:25:00',1.1),('5815','2013-03-18','08:15:00',1.09),('5815','2013-03-18','08:20:00',1.14),('5815','2013-03-18','08:25:00',1.18),('5815','2013-03-18','08:30:00',1.1),('5815','2013-03-18','08:35:00',1.33),('5815','2013-03-18','08:40:00',1.37),('5815','2013-03-18','08:45:00',1.44),('5815','2013-03-18','08:50:00',1.51),('5815','2013-03-18','08:55:00',1.54),('5815','2013-03-18','09:00:00',1.6),('5815','2013-03-18','09:05:00',1.52),('5815','2013-03-18','09:10:00',1.71),('5815','2013-03-18','09:15:00',1.68),('5815','2013-03-18','09:20:00',1.45),('5815','2013-03-18','09:25:00',1.63),('5815','2013-03-18','09:30:00',1.9),('5815','2013-03-18','09:35:00',1.94),('5815','2013-03-18','09:40:00',2.01),('5815','2013-03-18','09:45:00',2.11),('5815','2013-03-18','09:50:00',2.1),('5815','2013-03-18','09:55:00',1.68),('5815','2013-03-18','10:00:00',2.28),('5815','2013-03-18','10:05:00',1.8),('5815','2013-03-18','10:10:00',2.09),('5815','2013-03-18','10:15:00',2.24),('5815','2013-03-18','10:20:00',2.28),('5815','2013-03-18','10:25:00',2.34),('5815','2013-03-18','10:30:00',2.35),('5815','2013-03-18','10:35:00',2.37),('5815','2013-03-18','10:40:00',2.38),('5815','2013-03-18','10:45:00',2.41),('5815','2013-03-18','10:50:00',2.46),('5815','2013-03-18','10:55:00',2.42),('5815','2013-03-18','11:00:00',2.52),('5815','2013-03-18','11:05:00',2.52),('5815','2013-03-18','11:10:00',2.52),('5815','2013-03-18','11:15:00',2.58),('5815','2013-03-18','11:20:00',2.58),('5815','2013-03-18','11:25:00',2.59),('5815','2013-03-18','11:30:00',2.56),('5815','2013-03-18','11:35:00',1.66),('5815','2013-03-18','11:40:00',2.24),('5815','2013-03-18','11:45:00',2.42),('5815','2013-03-18','11:50:00',2.61),('5815','2013-03-18','11:55:00',2.69),('5815','2013-03-18','12:00:00',2.66),('5815','2013-03-18','12:05:00',2.6),('5815','2013-03-18','12:10:00',2.64),('5815','2013-03-18','12:15:00',2.53),('5815','2013-03-18','12:20:00',2.65),('5815','2013-03-18','12:25:00',2.61),('5815','2013-03-18','12:30:00',2.62),('5815','2013-03-18','12:35:00',2.61),('5815','2013-03-18','12:40:00',2.61),('5815','2013-03-18','12:45:00',2.64),('5815','2013-03-18','12:50:00',2.54),('5815','2013-03-18','12:55:00',2.53),('5815','2013-03-18','13:00:00',2.6),('5815','2013-03-18','13:05:00',2.58),('5815','2013-03-18','13:10:00',2.56),('5815','2013-03-18','13:15:00',2.54),('5815','2013-03-18','13:20:00',2.52),('5815','2013-03-18','13:25:00',2.49),('5815','2013-03-18','13:30:00',2.5),('5815','2013-03-18','13:35:00',2.47),('5815','2013-03-18','13:40:00',2.44),('5815','2013-03-18','13:45:00',2.45),('5815','2013-03-18','13:50:00',2.42),('5815','2013-03-18','13:55:00',2.39),('5815','2013-03-18','14:00:00',2.38),('5815','2013-03-18','14:05:00',2.35),('5815','2013-03-18','14:10:00',2.33),('5815','2013-03-18','14:15:00',2.31),('5815','2013-03-18','14:20:00',2.28),('5815','2013-03-18','14:25:00',2.24),('5815','2013-03-18','14:30:00',2.19),('5815','2013-03-18','14:35:00',2.16),('5815','2013-03-18','14:40:00',2.14),('5815','2013-03-18','14:45:00',2.11),('5815','2013-03-18','14:50:00',2.06),('5815','2013-03-18','14:55:00',2),('5815','2013-03-18','15:00:00',1.97),('5815','2013-03-18','15:05:00',1.94),('5815','2013-03-18','15:10:00',1.89),('5815','2013-03-18','15:15:00',1.85),('5815','2013-03-18','15:20:00',1.82),('5815','2013-03-18','15:25:00',1.78),('5815','2013-03-18','15:30:00',1.72),('5815','2013-03-18','15:35:00',1.69),('5815','2013-03-18','15:40:00',1.64),('5815','2013-03-18','15:45:00',1.58),('5815','2013-03-18','15:50:00',1.53),('5815','2013-03-18','15:55:00',1.48),('5815','2013-03-18','16:00:00',1.41),('5815','2013-03-18','16:05:00',1.36),('5815','2013-03-18','16:10:00',1.29),('5815','2013-03-18','16:15:00',1.23),('5815','2013-03-18','16:20:00',1.17),('5815','2013-03-18','16:25:00',1.05),('5815','2013-03-18','16:30:00',1.04),('5815','2013-03-17','10:25:00',1.14),('5815','2013-03-17','10:30:00',1.1),('5815','2013-03-17','11:20:00',1),('5815','2013-03-17','11:25:00',1.06),('5815','2013-03-17','11:30:00',1.33),('5815','2013-03-17','11:35:00',1.12),('5815','2013-03-17','11:40:00',1.01),('5815','2013-03-17','12:05:00',1.5),('5815','2013-03-17','12:10:00',1.41),('5815','2013-03-17','12:15:00',1.66),('5815','2013-03-17','12:20:00',1.65),('5815','2013-03-17','12:25:00',1.08),('5815','2013-03-17','12:30:00',1.99),('5815','2013-03-17','12:35:00',2.08),('5815','2013-03-17','12:40:00',1.83),('5815','2013-03-17','12:45:00',1.53),('5815','2013-03-17','12:50:00',2.17),('5815','2013-03-17','12:55:00',2.26),('5815','2013-03-17','13:00:00',1.56),('5815','2013-03-17','13:40:00',1.07),('5815','2013-03-17','14:05:00',1.52),('5815','2013-03-17','14:10:00',1.48),('5815','2013-03-16','09:15:00',1.06),('5815','2013-03-16','09:55:00',1.06),('5815','2013-03-16','10:00:00',1.17),('5815','2013-03-16','10:15:00',1.04),('5815','2013-03-16','10:20:00',1.05),('5815','2013-03-16','10:25:00',1.1),('5815','2013-03-16','10:30:00',1.08),('5815','2013-03-16','10:35:00',1.02),('5815','2013-03-16','10:45:00',1.02),('5815','2013-03-16','12:15:00',1.05),('5815','2013-03-16','12:20:00',1.31),('5815','2013-03-16','12:25:00',2.02),('5815','2013-03-16','12:30:00',2.34),('5815','2013-03-16','12:35:00',1.53),('5815','2013-03-16','12:40:00',1.72),('5815','2013-03-16','12:45:00',1.48),('5815','2013-03-16','12:50:00',1.28),('5815','2013-03-16','13:00:00',1.16),('5815','2013-03-16','13:05:00',1.29),('5815','2013-03-16','13:10:00',1.43),('5815','2013-03-16','13:15:00',1.39),('5815','2013-03-16','13:20:00',1.15),('5815','2013-03-16','13:25:00',1.01),('5815','2013-03-16','13:30:00',1.56),('5815','2013-03-16','13:35:00',1.84),('5815','2013-03-16','13:40:00',1.19),('5815','2013-03-16','13:45:00',1.05),('5815','2013-03-16','13:55:00',1.2),('5815','2013-03-16','14:00:00',1.25),('5815','2013-03-16','14:05:00',1.2),('5815','2013-03-16','14:10:00',1.46),('5815','2013-03-16','14:15:00',1.68),('5815','2013-03-16','14:20:00',1.45),('5815','2013-03-16','14:25:00',1.54),('5815','2013-03-16','14:30:00',1.4),('5815','2013-03-16','14:35:00',1.14),('5815','2013-03-16','15:10:00',1.28),('5815','2013-03-16','15:15:00',1.12),('5815','2013-03-16','15:20:00',1.17),('5815','2013-03-16','15:25:00',1.17),('5815','2013-03-16','15:45:00',1.04),('5815','2013-03-15','08:20:00',1.17),('5815','2013-03-15','08:25:00',1.32),('5815','2013-03-15','08:30:00',1.31),('5815','2013-03-15','08:35:00',1.37),('5815','2013-03-15','08:40:00',1.41),('5815','2013-03-15','08:45:00',1.28),('5815','2013-03-15','08:50:00',1.53),('5815','2013-03-15','08:55:00',1.64),('5815','2013-03-15','09:00:00',1.59),('5815','2013-03-15','09:05:00',1.38),('5815','2013-03-15','09:10:00',1.34),('5815','2013-03-15','09:15:00',1.8),('5815','2013-03-15','09:20:00',1.89),('5815','2013-03-15','09:25:00',1.85),('5815','2013-03-15','09:30:00',1.93),('5815','2013-03-15','09:35:00',2.02),('5815','2013-03-15','09:40:00',2.1),('5815','2013-03-15','09:45:00',2.13),('5815','2013-03-15','09:50:00',2.12),('5815','2013-03-15','09:55:00',2.18),('5815','2013-03-15','10:00:00',1.73),('5815','2013-03-15','10:05:00',1.13),('5815','2013-03-15','10:10:00',1.65),('5815','2013-03-15','10:15:00',1.61),('5815','2013-03-15','10:20:00',1.13),('5815','2013-03-15','10:25:00',1.43),('5815','2013-03-15','10:30:00',1.24),('5815','2013-03-15','10:40:00',1.72),('5815','2013-03-15','10:45:00',2.45),('5815','2013-03-15','10:50:00',2.44),('5815','2013-03-15','10:55:00',2.33),('5815','2013-03-15','11:00:00',2.46),('5815','2013-03-15','11:05:00',2.46),('5815','2013-03-15','11:10:00',2.48),('5815','2013-03-15','11:15:00',2.5),('5815','2013-03-15','11:20:00',2.49),('5815','2013-03-15','11:25:00',2.51),('5815','2013-03-15','11:30:00',2.49),('5815','2013-03-15','11:35:00',2.5),('5815','2013-03-15','11:40:00',2.53),('5815','2013-03-15','11:45:00',2.53),('5815','2013-03-15','11:50:00',2.55),('5815','2013-03-15','11:55:00',2.54),('5815','2013-03-15','12:00:00',2.55),('5815','2013-03-15','12:05:00',2.54),('5815','2013-03-15','12:10:00',2.53),('5815','2013-03-15','12:15:00',2.54),('5815','2013-03-15','12:20:00',2.53),('5815','2013-03-15','12:25:00',2.55),('5815','2013-03-15','12:30:00',2.55),('5815','2013-03-15','12:35:00',2.54),('5815','2013-03-15','12:40:00',2.52),('5815','2013-03-15','12:45:00',2.53),('5815','2013-03-15','12:50:00',2.51),('5815','2013-03-15','12:55:00',2.5),('5815','2013-03-15','13:00:00',2.45),('5815','2013-03-15','13:05:00',2.48),('5815','2013-03-15','13:10:00',2.46),('5815','2013-03-15','13:15:00',2.47),('5815','2013-03-15','13:20:00',1.11),('5815','2013-03-15','13:30:00',1.27),('5815','2013-03-15','13:35:00',2.57),('5815','2013-03-15','13:40:00',2.48),('5815','2013-03-15','13:45:00',2.44),('5815','2013-03-15','13:50:00',2.45),('5815','2013-03-15','13:55:00',2.2),('5815','2013-03-15','14:00:00',2.42),('5815','2013-03-15','14:05:00',2.37),('5815','2013-03-15','14:10:00',1.17),('5815','2013-03-15','14:15:00',1.79),('5815','2013-03-15','14:20:00',1.52),('5815','2013-03-15','14:30:00',2.25),('5815','2013-03-15','14:35:00',2.23),('5815','2013-03-15','16:05:00',1.01),('5815','2013-03-15','16:10:00',1),('5815','2013-03-14','11:35:00',1.1),('5815','2013-03-14','11:40:00',1.3),('5815','2013-03-14','11:45:00',1.22),('5815','2013-03-14','11:50:00',1.12),('5815','2013-03-14','11:55:00',1.16),('5815','2013-03-14','12:00:00',1.03),('5815','2013-03-14','12:05:00',1.03),('5815','2013-03-14','12:10:00',1.08),('5815','2013-03-14','12:35:00',1.11),('5815','2013-03-14','12:40:00',1),('5815','2013-03-13','13:50:00',1.12),('5815','2013-03-13','13:55:00',1.36),('5815','2013-03-13','14:00:00',1.09),('5815','2013-03-13','14:05:00',1.14),('5815','2013-03-12','10:15:00',1.29),('5815','2013-03-12','10:25:00',1.04),('5815','2013-03-12','10:30:00',2.16),('5815','2013-03-12','10:35:00',1.48),('5815','2013-03-12','10:40:00',1.62),('5815','2013-03-11','08:25:00',1.02),('5815','2013-03-11','08:30:00',1.12),('5815','2013-03-11','08:35:00',1.1),('5815','2013-03-11','08:40:00',1.2),('5815','2013-03-11','08:45:00',1.4),('5815','2013-03-11','08:50:00',1.01),('5815','2013-03-11','09:05:00',1.55),('5815','2013-03-11','09:10:00',1.59),('5815','2013-03-11','09:15:00',1.62),('5815','2013-03-11','09:20:00',1.66),('5815','2013-03-11','09:25:00',1.71),('5815','2013-03-11','09:30:00',1.77),('5815','2013-03-11','09:35:00',1.82),('5815','2013-03-11','09:40:00',1.81),('5815','2013-03-11','09:45:00',1.91),('5815','2013-03-11','09:50:00',1.29),('5815','2013-03-11','09:55:00',2.11),('5815','2013-03-11','10:00:00',1.97),('5815','2013-03-11','10:05:00',2.14),('5815','2013-03-11','10:10:00',1.7),('5815','2013-03-11','10:15:00',1.64),('5815','2013-03-11','10:20:00',2.05),('5815','2013-03-11','10:25:00',2.08),('5815','2013-03-11','10:30:00',2.34),('5815','2013-03-11','10:35:00',1.44),('5815','2013-03-11','10:40:00',1.8),('5815','2013-03-11','10:45:00',1.16),('5815','2013-03-11','10:50:00',2.14),('5815','2013-03-11','10:55:00',2.19),('5815','2013-03-11','11:00:00',2.15),('5815','2013-03-11','11:05:00',2.68),('5815','2013-03-11','11:10:00',1.94),('5815','2013-03-11','11:15:00',2.11),('5815','2013-03-11','11:20:00',2.53),('5815','2013-03-11','11:25:00',1.19),('5815','2013-03-11','11:40:00',1.21),('5815','2013-03-11','11:45:00',1.29),('5815','2013-03-11','11:50:00',1.55),('5815','2013-03-11','11:55:00',2.28),('5815','2013-03-11','12:10:00',2.24),('5815','2013-03-11','12:15:00',2.59),('5815','2013-03-11','12:20:00',1.02),('5815','2013-03-11','12:25:00',1.93),('5815','2013-03-11','12:30:00',2.74),('5815','2013-03-11','12:35:00',1.93),('5815','2013-03-11','12:40:00',2.36),('5815','2013-03-11','12:55:00',1.13),('5815','2013-03-11','13:00:00',2.09),('5815','2013-03-11','13:05:00',1.41),('5815','2013-03-11','13:10:00',1.51),('5815','2013-03-11','13:15:00',1.39),('5815','2013-03-11','13:20:00',1.99),('5815','2013-03-11','13:25:00',1.27),('5815','2013-03-11','14:00:00',1.21),('5815','2013-03-11','14:05:00',1.56),('5815','2013-03-11','14:10:00',1.67),('5815','2013-03-10','08:20:00',1.01),('5815','2013-03-10','08:25:00',1.07),('5815','2013-03-10','08:30:00',1.13),('5815','2013-03-10','08:35:00',1.2),('5815','2013-03-10','08:40:00',1.25),('5815','2013-03-10','08:45:00',1.3),('5815','2013-03-10','08:50:00',1.36),('5815','2013-03-10','08:55:00',1.41),('5815','2013-03-10','09:00:00',1.44),('5815','2013-03-10','09:05:00',1.51),('5815','2013-03-10','09:10:00',1.51),('5815','2013-03-10','09:15:00',1.61),('5815','2013-03-10','09:20:00',1.38),('5815','2013-03-10','09:25:00',1.22),('5815','2013-03-10','09:35:00',1.48),('5815','2013-03-10','09:40:00',2.01),('5815','2013-03-10','09:45:00',1.78),('5815','2013-03-10','10:40:00',1.18),('5815','2013-03-10','10:45:00',1.43),('5815','2013-03-10','10:50:00',1.68),('5815','2013-03-10','10:55:00',1.01),('5815','2013-03-10','11:30:00',1.38),('5815','2013-03-10','11:35:00',1.62),('5815','2013-03-10','11:40:00',1.22),('5815','2013-03-10','11:45:00',1.49),('5815','2013-03-10','11:50:00',1.51),('5815','2013-03-10','11:55:00',1.11),('5815','2013-03-10','12:00:00',1),('5815','2013-03-10','12:10:00',1.05),('5815','2013-03-10','12:50:00',1.23),('5815','2013-03-10','12:55:00',2.43),('5815','2013-03-10','13:00:00',1.64),('5815','2013-03-10','13:05:00',1.24),('5815','2013-03-10','13:10:00',1.66),('5815','2013-03-10','13:15:00',2.2),('5815','2013-03-10','13:20:00',2.24),('5815','2013-03-10','13:25:00',2.53),('5815','2013-03-10','13:30:00',2.55),('5815','2013-03-10','13:35:00',2.41),('5815','2013-03-10','13:40:00',2.35),('5815','2013-03-10','13:45:00',1.8),('5815','2013-03-10','13:50:00',1.32),('5815','2013-03-10','13:55:00',1.38),('5815','2013-03-10','14:25:00',1.21),('5815','2013-03-10','15:30:00',1.18),('5815','2013-03-10','15:45:00',1.67),('5815','2013-03-10','15:50:00',1.34),('5815','2013-03-10','15:55:00',1.34),('5815','2013-03-10','16:00:00',1.36),('5815','2013-03-10','16:05:00',1.22),('5815','2013-03-09','08:20:00',1.02),('5815','2013-03-09','08:25:00',1.07),('5815','2013-03-09','08:30:00',1.13),('5815','2013-03-09','08:35:00',1.19),('5815','2013-03-09','08:40:00',1.24),('5815','2013-03-09','08:45:00',1.31),('5815','2013-03-09','08:50:00',1.35),('5815','2013-03-09','08:55:00',1.4),('5815','2013-03-09','09:00:00',1.47),('5815','2013-03-09','09:05:00',1.52),('5815','2013-03-09','09:10:00',1.56),('5815','2013-03-09','09:15:00',1.6),('5815','2013-03-09','09:20:00',1.65),('5815','2013-03-09','09:25:00',1.69),('5815','2013-03-09','09:30:00',1.75),('5815','2013-03-09','09:35:00',1.79),('5815','2013-03-09','09:40:00',1.84),('5815','2013-03-09','09:45:00',1.83),('5815','2013-03-09','09:50:00',1.11),('5815','2013-03-09','09:55:00',2.11),('5815','2013-03-09','10:00:00',1.05),('5815','2013-03-09','10:05:00',1.65),('5815','2013-03-09','10:10:00',1.49),('5815','2013-03-09','10:15:00',1.26),('5815','2013-03-09','10:20:00',2.05),('5815','2013-03-09','10:25:00',1.93),('5815','2013-03-09','10:30:00',2.18),('5815','2013-03-09','10:35:00',2.07),('5815','2013-03-09','10:40:00',1.81),('5815','2013-03-09','10:45:00',2.31),('5815','2013-03-09','10:50:00',2.19),('5815','2013-03-09','10:55:00',1.39),('5815','2013-03-09','11:00:00',2.14),('5815','2013-03-09','11:05:00',1.91),('5815','2013-03-09','11:10:00',1.93),('5815','2013-03-09','11:15:00',1.71),('5815','2013-03-09','11:20:00',1.2),('5815','2013-03-09','11:25:00',1.72),('5815','2013-03-09','11:30:00',1.39),('5815','2013-03-09','11:50:00',1.69),('5815','2013-03-09','11:55:00',2.31),('5815','2013-03-09','12:00:00',2.39),('5815','2013-03-09','12:05:00',2.49),('5815','2013-03-09','12:10:00',2.19),('5815','2013-03-09','12:15:00',2.43),('5815','2013-03-09','12:20:00',1.26),('5815','2013-03-09','12:25:00',2.32),('5815','2013-03-09','12:45:00',2.73),('5815','2013-03-09','12:50:00',2.48),('5815','2013-03-09','12:55:00',2.56),('5815','2013-03-09','13:00:00',2.47),('5815','2013-03-09','13:05:00',2.43),('5815','2013-03-09','13:10:00',2.32),('5815','2013-03-09','13:15:00',2.44),('5815','2013-03-09','13:20:00',2.46),('5815','2013-03-09','13:25:00',2.15),('5815','2013-03-09','13:30:00',2.11),('5815','2013-03-09','13:35:00',1.95),('5815','2013-03-09','13:40:00',1.15),('5815','2013-03-09','13:45:00',1.23),('5815','2013-03-09','13:50:00',1.05),('5815','2013-03-09','14:05:00',1.06),('5815','2013-03-09','14:10:00',1.17),('5815','2013-03-09','14:15:00',1.55),('5815','2013-03-09','14:20:00',1.42),('5815','2013-03-09','14:35:00',1.92),('5815','2013-03-09','14:40:00',1.66),('5815','2013-03-08','08:25:00',1.04),('5815','2013-03-08','08:30:00',1.11),('5815','2013-03-08','08:35:00',1.17),('5815','2013-03-08','08:40:00',1.1),('5815','2013-03-08','08:55:00',1.18),('5815','2013-03-08','09:30:00',1.21),('5815','2013-03-08','09:35:00',1.5),('5815','2013-03-08','09:40:00',2),('5815','2013-03-08','09:45:00',2.18),('5815','2013-03-08','09:50:00',1.57),('5815','2013-03-08','09:55:00',1.39),('5815','2013-03-08','10:00:00',1),('5815','2013-03-08','10:20:00',1.16),('5815','2013-03-08','10:45:00',1.21),('5815','2013-03-08','10:50:00',2),('5815','2013-03-08','10:55:00',2.52),('5815','2013-03-08','11:00:00',1.68),('5815','2013-03-08','11:05:00',2.34),('5815','2013-03-08','11:10:00',2.52),('5815','2013-03-08','11:15:00',2.52),('5815','2013-03-08','11:20:00',2.55),('5815','2013-03-08','11:25:00',2.09),('5815','2013-03-08','11:30:00',2.59),('5815','2013-03-08','11:35:00',2.52),('5815','2013-03-08','11:40:00',2.53),('5815','2013-03-08','11:45:00',2.57),('5815','2013-03-08','11:50:00',2.49),('5815','2013-03-08','11:55:00',2.5),('5815','2013-03-08','12:00:00',2.5),('5815','2013-03-08','12:05:00',1.4),('5815','2013-03-08','12:45:00',1.14),('5815','2013-03-08','12:50:00',1.52),('5815','2013-03-08','12:55:00',1.66),('5815','2013-03-08','13:00:00',2.57),('5815','2013-03-08','13:05:00',2.48),('5815','2013-03-08','13:10:00',2.46),('5815','2013-03-08','13:15:00',2.35),('5815','2013-03-08','13:20:00',2.28),('5815','2013-03-08','13:25:00',1.49),('5815','2013-03-08','13:30:00',2.24),('5815','2013-03-08','13:35:00',1.66),('5815','2013-03-08','13:40:00',2.15),('5815','2013-03-08','13:45:00',2.44),('5815','2013-03-08','13:50:00',2.41),('5815','2013-03-08','13:55:00',1.13),('5815','2013-03-08','14:00:00',1.01),('5815','2013-03-08','14:10:00',2.42),('5815','2013-03-08','14:15:00',2),('5815','2013-03-08','14:20:00',2.16),('5815','2013-03-08','14:25:00',2.11),('5815','2013-03-08','14:30:00',2.08),('5815','2013-03-08','14:35:00',2.05),('5815','2013-03-08','14:40:00',2),('5815','2013-03-08','14:45:00',1.98),('5815','2013-03-08','14:50:00',1.93),('5815','2013-03-08','14:55:00',1.88),('5815','2013-03-08','15:00:00',1.86),('5815','2013-03-08','15:05:00',1.82),('5815','2013-03-08','15:10:00',1.78),('5815','2013-03-08','15:15:00',1.75),('5815','2013-03-08','15:20:00',1.7),('5815','2013-03-08','15:25:00',1.64),('5815','2013-03-08','15:30:00',1.59),('5815','2013-03-08','15:35:00',1.55),('5815','2013-03-08','15:40:00',1.52),('5815','2013-03-08','15:45:00',1.48),('5815','2013-03-08','15:50:00',1.42),('5815','2013-03-08','15:55:00',1.33),('5815','2013-03-08','16:00:00',1.19),('5815','2013-03-08','16:05:00',1.18),('5815','2013-03-08','16:15:00',1.07),('5815','2013-03-07','09:35:00',1.22),('5815','2013-03-07','09:45:00',1.41),('5815','2013-03-07','09:50:00',1.49),('5815','2013-03-07','09:55:00',1.25),('5815','2013-03-07','10:10:00',1.2),('5815','2013-03-07','10:15:00',1.1),('5815','2013-03-07','10:20:00',1.34),('5815','2013-03-07','10:35:00',1.23),('5815','2013-03-07','10:40:00',1.06),('5815','2013-03-07','11:40:00',1.24),('5815','2013-03-07','12:00:00',1.28),('5815','2013-03-07','12:40:00',1.16),('5815','2013-03-07','12:45:00',1.33),('5815','2013-03-07','12:50:00',1.33),('5815','2013-03-07','12:55:00',1.13),('5815','2013-03-07','13:00:00',1.24),('5815','2013-03-07','13:05:00',1.24),('5815','2013-03-07','13:30:00',1.02),('5815','2013-03-06','11:40:00',1.05),('5815','2013-03-06','11:45:00',1.38),('5815','2013-03-06','11:50:00',1.18),('5815','2013-03-06','12:45:00',1.15),('5815','2013-03-06','12:50:00',1.01),('5815','2013-03-06','13:20:00',1.19),('5815','2013-03-06','13:25:00',1.07),('5815','2013-03-04','08:30:00',1.21),('5815','2013-03-04','08:35:00',1.1),('5815','2013-03-04','08:40:00',1.12),('5815','2013-03-04','09:45:00',1),('5815','2013-03-04','09:50:00',1.03),('5815','2013-03-04','10:05:00',1.06),('5815','2013-03-04','10:10:00',1.13),('5815','2013-03-04','10:15:00',1.09),('5815','2013-03-04','10:20:00',1.23),('5815','2013-03-04','10:25:00',1.18),('5815','2013-03-04','10:30:00',1.1),('5815','2013-03-04','10:35:00',1.31),('5815','2013-03-04','10:40:00',1.36),('5815','2013-03-04','10:45:00',1.45),('5815','2013-03-04','10:50:00',1.56),('5815','2013-03-04','10:55:00',1.6),('5815','2013-03-04','11:00:00',1.53),('5815','2013-03-04','11:05:00',1.59),('5815','2013-03-04','11:10:00',1.65),('5815','2013-03-04','11:15:00',1.6),('5815','2013-03-04','11:20:00',1.53),('5815','2013-03-04','11:25:00',1.49),('5815','2013-03-04','11:30:00',1.5),('5815','2013-03-04','11:35:00',1.65),('5815','2013-03-04','11:40:00',1.85),('5815','2013-03-04','11:45:00',1.78),('5815','2013-03-04','11:50:00',1.83),('5815','2013-03-04','11:55:00',1.87),('5815','2013-03-04','12:00:00',1.93),('5815','2013-03-04','12:05:00',2.02),('5815','2013-03-04','12:10:00',2.05),('5815','2013-03-04','12:15:00',1.67),('5815','2013-03-04','12:20:00',1.91),('5815','2013-03-04','12:25:00',1.94),('5815','2013-03-04','12:30:00',1.62),('5815','2013-03-04','12:35:00',1.75),('5815','2013-03-04','12:40:00',1.61),('5815','2013-03-04','12:45:00',1.59),('5815','2013-03-04','12:50:00',1.36),('5815','2013-03-04','12:55:00',1.23),('5815','2013-03-04','13:15:00',1.06),('5815','2013-03-04','13:20:00',1.02),('5815','2013-03-03','08:30:00',1.01),('5815','2013-03-03','08:35:00',1.07),('5815','2013-03-03','08:40:00',1.12),('5815','2013-03-03','08:45:00',1.18),('5815','2013-03-03','08:50:00',1.23),('5815','2013-03-03','08:55:00',1.28),('5815','2013-03-03','09:00:00',1.32),('5815','2013-03-03','09:05:00',1.37),('5815','2013-03-03','09:10:00',1.42),('5815','2013-03-03','09:15:00',1.46),('5815','2013-03-03','09:20:00',1.52),('5815','2013-03-03','09:25:00',1.56),('5815','2013-03-03','09:30:00',1.61),('5815','2013-03-03','09:35:00',1.66),('5815','2013-03-03','09:40:00',1.7),('5815','2013-03-03','09:45:00',1.75),('5815','2013-03-03','09:50:00',1.79),('5815','2013-03-03','09:55:00',1.82),('5815','2013-03-03','10:00:00',1.86),('5815','2013-03-03','10:05:00',1.89),('5815','2013-03-03','10:10:00',1.92),('5815','2013-03-03','10:15:00',1.94),('5815','2013-03-03','10:20:00',1.96),('5815','2013-03-03','10:25:00',2.01),('5815','2013-03-03','10:30:00',2.04),('5815','2013-03-03','10:35:00',2.06),('5815','2013-03-03','10:40:00',2.07),('5815','2013-03-03','10:45:00',2.1),('5815','2013-03-03','10:50:00',2.12),('5815','2013-03-03','10:55:00',2.15),('5815','2013-03-03','11:00:00',2.13),('5815','2013-03-03','11:05:00',2.14),('5815','2013-03-03','11:10:00',2.19),('5815','2013-03-03','11:15:00',2.22),('5815','2013-03-03','11:20:00',2.24),('5815','2013-03-03','11:25:00',2.23),('5815','2013-03-03','11:30:00',2.23),('5815','2013-03-03','11:35:00',2.24),('5815','2013-03-03','11:40:00',2.28),('5815','2013-03-03','11:45:00',2.29),('5815','2013-03-03','11:50:00',2.25),('5815','2013-03-03','11:55:00',2.24),('5815','2013-03-03','12:00:00',2.29),('5815','2013-03-03','12:05:00',2.24),('5815','2013-03-03','12:10:00',2.22),('5815','2013-03-03','12:15:00',2.28),('5815','2013-03-03','12:20:00',2.32),('5815','2013-03-03','12:25:00',2.34),('5815','2013-03-03','12:30:00',2.34),('5815','2013-03-03','12:35:00',2.31),('5815','2013-03-03','12:40:00',2.27),('5815','2013-03-03','12:45:00',2.28),('5815','2013-03-03','12:50:00',2.3),('5815','2013-03-03','12:55:00',2.27),('5815','2013-03-03','13:00:00',2.24),('5815','2013-03-03','13:05:00',2.2),('5815','2013-03-03','13:10:00',2.25),('5815','2013-03-03','13:15:00',2.23),('5815','2013-03-03','13:20:00',2.22),('5815','2013-03-03','13:25:00',2.25),('5815','2013-03-03','13:30:00',1.77),('5815','2013-03-03','13:35:00',1.53),('5815','2013-03-03','13:40:00',1.88),('5815','2013-03-03','13:45:00',1.96),('5815','2013-03-03','13:50:00',2.07),('5815','2013-03-03','13:55:00',2.08),('5815','2013-03-03','14:00:00',2.03),('5815','2013-03-03','14:05:00',2.01),('5815','2013-03-03','14:10:00',1.99),('5815','2013-03-03','14:15:00',1.96),('5815','2013-03-03','14:20:00',1.91),('5815','2013-03-03','14:25:00',1.87),('5815','2013-03-03','14:30:00',1.81),('5815','2013-03-03','14:35:00',1.77),('5815','2013-03-03','14:40:00',1.8),('5815','2013-03-03','14:45:00',1.75),('5815','2013-03-03','14:50:00',1.7),('5815','2013-03-03','14:55:00',1.68),('5815','2013-03-03','15:00:00',1.65),('5815','2013-03-03','15:05:00',1.61),('5815','2013-03-03','15:10:00',1.56),('5815','2013-03-03','15:15:00',1.52),('5815','2013-03-03','15:20:00',1.48),('5815','2013-03-03','15:25:00',1.42),('5815','2013-03-03','15:30:00',1.41),('5815','2013-03-03','15:35:00',1.36),('5815','2013-03-03','15:40:00',1.3),('5815','2013-03-03','15:45:00',1.26),('5815','2013-03-03','15:50:00',1.2),('5815','2013-03-03','15:55:00',1.16),('5815','2013-03-03','16:00:00',1.12),('5815','2013-03-03','16:05:00',1.07),('5815','2013-03-03','16:10:00',1.02),('5815','2013-03-02','08:30:00',1.08),('5815','2013-03-02','08:35:00',1.14),('5815','2013-03-02','08:40:00',1.2),('5815','2013-03-02','08:45:00',1.25),('5815','2013-03-02','08:50:00',1.31),('5815','2013-03-02','08:55:00',1.36),('5815','2013-03-02','09:00:00',1.41),('5815','2013-03-02','09:05:00',1.46),('5815','2013-03-02','09:10:00',1.5),('5815','2013-03-02','09:15:00',1.55),('5815','2013-03-02','09:20:00',1.59),('5815','2013-03-02','09:25:00',1.64),('5815','2013-03-02','09:30:00',1.69),('5815','2013-03-02','09:35:00',1.72),('5815','2013-03-02','09:40:00',1.75),('5815','2013-03-02','09:45:00',1.81),('5815','2013-03-02','09:50:00',1.86),('5815','2013-03-02','09:55:00',1.92),('5815','2013-03-02','10:00:00',1.96),('5815','2013-03-02','10:05:00',1.99),('5815','2013-03-02','10:10:00',2.02),('5815','2013-03-02','10:15:00',2.05),('5815','2013-03-02','10:20:00',2.09),('5815','2013-03-02','10:25:00',2.12),('5815','2013-03-02','10:30:00',2.15),('5815','2013-03-02','10:35:00',2.17),('5815','2013-03-02','10:40:00',2.19),('5815','2013-03-02','10:45:00',2.21),('5815','2013-03-02','10:50:00',2.22),('5815','2013-03-02','10:55:00',2.23),('5815','2013-03-02','11:00:00',2.25),('5815','2013-03-02','11:05:00',2.26),('5815','2013-03-02','11:10:00',2.27),('5815','2013-03-02','11:15:00',2.28),('5815','2013-03-02','11:20:00',2.29),('5815','2013-03-02','11:25:00',2.31),('5815','2013-03-02','11:30:00',2.32),('5815','2013-03-02','11:35:00',2.33),('5815','2013-03-02','11:40:00',2.35),('5815','2013-03-02','11:45:00',2.35),('5815','2013-03-02','11:50:00',2.36),('5815','2013-03-02','11:55:00',2.36),('5815','2013-03-02','12:00:00',2.37),('5815','2013-03-02','12:05:00',2.36),('5815','2013-03-02','12:10:00',2.36),('5815','2013-03-02','12:15:00',2.38),('5815','2013-03-02','12:20:00',2.38),('5815','2013-03-02','12:25:00',2.36),('5815','2013-03-02','12:30:00',2.37),('5815','2013-03-02','12:35:00',2.36),('5815','2013-03-02','12:40:00',2.37),('5815','2013-03-02','12:45:00',2.37),('5815','2013-03-02','12:50:00',2.36),('5815','2013-03-02','12:55:00',2.34),('5815','2013-03-02','13:00:00',2.33),('5815','2013-03-02','13:05:00',2.35),('5815','2013-03-02','13:10:00',2.34),('5815','2013-03-02','13:15:00',2.32),('5815','2013-03-02','13:20:00',2.3),('5815','2013-03-02','13:25:00',2.28),('5815','2013-03-02','13:30:00',2.27),('5815','2013-03-02','13:35:00',2.26),('5815','2013-03-02','13:40:00',2.23),('5815','2013-03-02','13:45:00',2.2),('5815','2013-03-02','13:50:00',2.19),('5815','2013-03-02','13:55:00',2.17),('5815','2013-03-02','14:00:00',2.16),('5815','2013-03-02','14:05:00',2.14),('5815','2013-03-02','14:10:00',2.12),('5815','2013-03-02','14:15:00',2.11),('5815','2013-03-02','14:20:00',2.08),('5815','2013-03-02','14:25:00',2.05),('5815','2013-03-02','14:30:00',2.02),('5815','2013-03-02','14:35:00',1.99),('5815','2013-03-02','14:40:00',1.96),('5815','2013-03-02','14:45:00',1.91),('5815','2013-03-02','14:50:00',1.88),('5815','2013-03-02','14:55:00',1.83),('5815','2013-03-02','15:00:00',1.8),('5815','2013-03-02','15:05:00',1.77),('5815','2013-03-02','15:10:00',1.72),('5815','2013-03-02','15:15:00',1.7),('5815','2013-03-02','15:20:00',1.66),('5815','2013-03-02','15:25:00',1.62),('5815','2013-03-02','15:30:00',1.57),('5815','2013-03-02','15:35:00',1.53),('5815','2013-03-02','15:40:00',1.47),('5815','2013-03-02','15:45:00',1.42),('5815','2013-03-02','15:50:00',1.36),('5815','2013-03-02','15:55:00',1.31),('5815','2013-03-02','16:00:00',1.26),('5815','2013-03-02','16:05:00',1.19),('5815','2013-03-02','16:10:00',1.14),('5815','2013-03-02','16:15:00',1.09),('5815','2013-02-28','08:55:00',1.02),('5815','2013-02-28','09:00:00',1.09),('5815','2013-02-28','09:05:00',1.23),('5815','2013-02-28','09:10:00',1.24),('5815','2013-02-28','09:15:00',1.25),('5815','2013-02-28','09:20:00',1.29),('5815','2013-02-28','09:25:00',1.31),('5815','2013-02-28','09:30:00',1.48),('5815','2013-02-28','09:35:00',1.41),('5815','2013-02-28','09:40:00',1.46),('5815','2013-02-28','09:45:00',1.57),('5815','2013-02-28','09:50:00',1.59),('5815','2013-02-28','09:55:00',1.56),('5815','2013-02-28','10:00:00',1.6),('5815','2013-02-28','10:05:00',1.59),('5815','2013-02-28','10:10:00',1.56),('5815','2013-02-28','10:15:00',1.42),('5815','2013-02-28','10:20:00',1.29),('5815','2013-02-28','10:25:00',1.35),('5815','2013-02-28','10:30:00',1.47),('5815','2013-02-28','10:35:00',1.66),('5815','2013-02-28','10:40:00',1.47),('5815','2013-02-28','10:45:00',1.38),('5815','2013-02-28','10:50:00',1.3),('5815','2013-02-28','10:55:00',1.22),('5815','2013-02-28','11:00:00',1.07),('5815','2013-02-28','11:35:00',1.01),('5815','2013-02-27','08:40:00',1.02),('5815','2013-02-27','08:45:00',1.08),('5815','2013-02-27','08:50:00',1.15),('5815','2013-02-27','08:55:00',1.21),('5815','2013-02-27','09:00:00',1.26),('5815','2013-02-27','09:05:00',1.3),('5815','2013-02-27','09:10:00',1.34),('5815','2013-02-27','09:15:00',1.38),('5815','2013-02-27','09:20:00',1.44),('5815','2013-02-27','09:25:00',1.48),('5815','2013-02-27','09:30:00',1.52),('5815','2013-02-27','09:35:00',1.56),('5815','2013-02-27','09:40:00',1.58),('5815','2013-02-27','09:45:00',1.65),('5815','2013-02-27','09:50:00',1.57),('5815','2013-02-27','09:55:00',1.72),('5815','2013-02-27','10:00:00',1.76),('5815','2013-02-27','10:05:00',1.79),('5815','2013-02-27','10:10:00',1.8),('5815','2013-02-27','10:15:00',1.83),('5815','2013-02-27','10:20:00',1.87),('5815','2013-02-27','10:25:00',1.88),('5815','2013-02-27','10:30:00',1.87),('5815','2013-02-27','10:35:00',1.95),('5815','2013-02-27','10:40:00',1.97),('5815','2013-02-27','10:45:00',1.99),('5815','2013-02-27','10:50:00',2.01),('5815','2013-02-27','10:55:00',2.04),('5815','2013-02-27','11:00:00',2.08),('5815','2013-02-27','11:05:00',2.12),('5815','2013-02-27','11:10:00',2.12),('5815','2013-02-27','11:15:00',2.13),('5815','2013-02-27','11:20:00',2.15),('5815','2013-02-27','11:25:00',2.19),('5815','2013-02-27','11:30:00',2.2),('5815','2013-02-27','11:35:00',2.2),('5815','2013-02-27','11:40:00',2.21),('5815','2013-02-27','11:45:00',2.22),('5815','2013-02-27','11:50:00',2.24),('5815','2013-02-27','11:55:00',2.25),('5815','2013-02-27','12:00:00',2.2),('5815','2013-02-27','12:05:00',2.19),('5815','2013-02-27','12:10:00',2.25),('5815','2013-02-27','12:15:00',2.26),('5815','2013-02-27','12:20:00',2.25),('5815','2013-02-27','12:25:00',2.22),('5815','2013-02-27','12:30:00',2.2),('5815','2013-02-27','12:35:00',2.25),('5815','2013-02-27','12:40:00',2.25),('5815','2013-02-27','12:45:00',2.18),('5815','2013-02-27','12:50:00',2.17),('5815','2013-02-27','12:55:00',2.21),('5815','2013-02-27','13:00:00',2.11),('5815','2013-02-27','13:05:00',2.23),('5815','2013-02-27','13:10:00',2.18),('5815','2013-02-27','13:15:00',2.21),('5815','2013-02-27','13:20:00',2.24),('5815','2013-02-27','13:25:00',2.23),('5815','2013-02-27','13:30:00',2.15),('5815','2013-02-27','13:35:00',2.09),('5815','2013-02-27','13:40:00',1.61),('5815','2013-02-27','13:45:00',1.94),('5815','2013-02-27','13:50:00',2.15),('5815','2013-02-27','13:55:00',2.09),('5815','2013-02-27','14:00:00',2.05),('5815','2013-02-27','14:05:00',2.01),('5815','2013-02-27','14:10:00',1.99),('5815','2013-02-27','14:15:00',1.94),('5815','2013-02-27','14:20:00',1.45),('5815','2013-02-27','14:25:00',1.32),('5815','2013-02-27','14:30:00',1.81),('5815','2013-02-27','14:35:00',1.69),('5815','2013-02-27','14:40:00',1.76),('5815','2013-02-27','14:45:00',1.75),('5815','2013-02-27','14:50:00',1.71),('5815','2013-02-27','14:55:00',1.68),('5815','2013-02-27','15:00:00',1.62),('5815','2013-02-27','15:05:00',1.57),('5815','2013-02-27','15:10:00',1.5),('5815','2013-02-27','15:15:00',1.47),('5815','2013-02-27','15:20:00',1.43),('5815','2013-02-27','15:25:00',1.31),('5815','2013-02-27','15:30:00',1.25),('5815','2013-02-27','15:35:00',1.23),('5815','2013-02-27','15:40:00',1.2),('5815','2013-02-27','15:45:00',1.17),('5815','2013-02-27','15:50:00',1.12),('5815','2013-02-27','15:55:00',1.08),('5815','2013-02-27','16:00:00',1.01),('5815','2013-02-26','08:45:00',1.04),('5815','2013-02-26','08:50:00',1.11),('5815','2013-02-26','08:55:00',1.16),('5815','2013-02-26','09:00:00',1.21),('5815','2013-02-26','09:05:00',1.26),('5815','2013-02-26','09:10:00',1.31),('5815','2013-02-26','09:15:00',1.36),('5815','2013-02-26','09:20:00',1.41),('5815','2013-02-26','09:25:00',1.45),('5815','2013-02-26','09:30:00',1.5),('5815','2013-02-26','09:35:00',1.54),('5815','2013-02-26','09:40:00',1.58),('5815','2013-02-26','09:45:00',1.62),('5815','2013-02-26','09:50:00',1.64),('5815','2013-02-26','09:55:00',1.69),('5815','2013-02-26','10:00:00',1.73),('5815','2013-02-26','10:05:00',1.76),('5815','2013-02-26','10:10:00',1.8),('5815','2013-02-26','10:15:00',1.85),('5815','2013-02-26','10:20:00',1.88),('5815','2013-02-26','10:25:00',1.89),('5815','2013-02-26','10:30:00',1.92),('5815','2013-02-26','10:35:00',1.97),('5815','2013-02-26','10:40:00',1.98),('5815','2013-02-26','10:45:00',2),('5815','2013-02-26','10:50:00',2.06),('5815','2013-02-26','10:55:00',2.08),('5815','2013-02-26','11:00:00',2.11),('5815','2013-02-26','11:05:00',2.12),('5815','2013-02-26','11:10:00',2.17),('5815','2013-02-26','11:15:00',2.15),('5815','2013-02-26','11:20:00',2.14),('5815','2013-02-26','11:25:00',2.21),('5815','2013-02-26','11:30:00',1.94),('5815','2013-02-26','11:35:00',1.85),('5815','2013-02-26','11:40:00',1.97),('5815','2013-02-26','11:45:00',2.27),('5815','2013-02-26','11:50:00',2.33),('5815','2013-02-26','11:55:00',2.35),('5815','2013-02-26','12:00:00',2.32),('5815','2013-02-26','12:05:00',2.31),('5815','2013-02-26','12:10:00',2.34),('5815','2013-02-26','12:15:00',2.4),('5815','2013-02-26','12:20:00',2.39),('5815','2013-02-26','12:25:00',2.33),('5815','2013-02-26','12:30:00',2.29),('5815','2013-02-26','12:35:00',2.29),('5815','2013-02-26','12:40:00',2.33),('5815','2013-02-26','12:45:00',2.33),('5815','2013-02-26','12:50:00',2.29),('5815','2013-02-26','12:55:00',2.25),('5815','2013-02-26','13:00:00',2.27),('5815','2013-02-26','13:05:00',2.32),('5815','2013-02-26','13:10:00',2.32),('5815','2013-02-26','13:15:00',2.21),('5815','2013-02-26','13:20:00',1.17),('5815','2013-02-26','13:25:00',1.06),('5815','2013-02-26','13:30:00',1.77),('5815','2013-02-26','13:35:00',2.26),('5815','2013-02-26','13:40:00',2.15),('5815','2013-02-26','13:45:00',2.15),('5815','2013-02-26','13:50:00',1.64),('5815','2013-02-26','13:55:00',1.41),('5815','2013-02-26','14:00:00',1.53),('5815','2013-02-26','14:05:00',1.37),('5815','2013-02-26','14:10:00',1.89),('5815','2013-02-26','14:15:00',1.08),('5815','2013-02-26','14:20:00',1.91),('5815','2013-02-26','14:25:00',1.96),('5815','2013-02-26','14:30:00',1.92),('5815','2013-02-26','14:35:00',1.9),('5815','2013-02-26','14:40:00',1.87),('5815','2013-02-26','14:45:00',1.83),('5815','2013-02-26','14:50:00',1.33),('5815','2013-02-26','14:55:00',1.67),('5815','2013-02-26','15:00:00',1.68),('5815','2013-02-26','15:05:00',1.68),('5815','2013-02-26','15:10:00',1.62),('5815','2013-02-26','15:15:00',1.27),('5815','2013-02-26','15:20:00',1.49),('5815','2013-02-26','15:25:00',1.46),('5815','2013-02-26','15:30:00',1.39),('5815','2013-02-26','15:35:00',1.36),('5815','2013-02-26','15:40:00',1.26),('5815','2013-02-26','15:45:00',1.25),('5815','2013-02-26','15:50:00',1.22),('5815','2013-02-26','15:55:00',1.17),('5815','2013-02-26','16:00:00',1.13),('5815','2013-02-26','16:05:00',1.07),('5815','2013-02-26','16:10:00',1.02),('5815','2013-02-25','09:40:00',1.09),('5815','2013-02-25','09:45:00',1.09),('5815','2013-02-25','09:50:00',1.11),('5815','2013-02-25','09:55:00',1.22),('5815','2013-02-25','10:00:00',1.18),('5815','2013-02-25','10:05:00',1.2),('5815','2013-02-25','10:10:00',1.43),('5815','2013-02-25','10:15:00',1.66),('5815','2013-02-25','10:20:00',1.94),('5815','2013-02-25','10:25:00',2.13),('5815','2013-02-25','10:30:00',2.04),('5815','2013-02-25','10:35:00',1.8),('5815','2013-02-25','10:40:00',1.27),('5815','2013-02-25','10:55:00',1.05),('5815','2013-02-25','11:00:00',1.16),('5815','2013-02-25','11:05:00',1.22),('5815','2013-02-25','11:10:00',1.26),('5815','2013-02-25','11:15:00',1.14),('5815','2013-02-25','11:50:00',1.1),('5815','2013-02-25','11:55:00',1.03),('5815','2013-02-25','12:00:00',1.03),('5815','2013-02-24','10:50:00',1.67),('5815','2013-02-24','10:55:00',2.3),('5815','2013-02-24','11:00:00',2.73),('5815','2013-02-24','11:05:00',1.56),('5815','2013-02-24','11:10:00',1.07),('5815','2013-02-24','11:30:00',1.12),('5815','2013-02-24','11:50:00',1.19),('5815','2013-02-24','11:55:00',2.77),('5815','2013-02-24','12:00:00',1.8),('5815','2013-02-24','12:05:00',1.39),('5815','2013-02-24','12:10:00',1.09),('5815','2013-02-24','12:15:00',1.51),('5815','2013-02-24','12:20:00',2.42),('5815','2013-02-24','12:25:00',2.69),('5815','2013-02-24','12:30:00',2.32),('5815','2013-02-24','12:35:00',1.63),('5815','2013-02-24','12:40:00',2.42),('5815','2013-02-24','12:45:00',2.47),('5815','2013-02-24','12:50:00',2.36),('5815','2013-02-24','12:55:00',2.34),('5815','2013-02-24','13:00:00',2.46),('5815','2013-02-24','13:05:00',1.86),('5815','2013-02-24','13:10:00',2.32),('5815','2013-02-24','13:15:00',1.57),('5815','2013-02-24','13:20:00',1.24),('5815','2013-02-23','14:05:00',1.05),('5815','2013-02-23','14:10:00',1.12),('5815','2013-02-23','15:10:00',1.3),('5815','2013-02-23','15:25:00',1.21),('5815','2013-02-23','15:40:00',1.05),('5815','2013-02-23','16:00:00',1.3),('5815','2013-02-22','08:15:00',1.02),('5815','2013-02-19','08:45:00',1.06),('5815','2013-02-19','08:50:00',1.12),('5815','2013-02-19','08:55:00',1.19),('5815','2013-02-19','09:00:00',1.25),('5815','2013-02-19','09:15:00',1.01),('5815','2013-02-19','09:30:00',1.6),('5815','2013-02-19','09:35:00',1.21),('5815','2013-02-19','09:55:00',1.37),('5815','2013-02-19','10:10:00',1.16),('5815','2013-02-19','10:50:00',1.71),('5815','2013-02-19','10:55:00',2.11),('5815','2013-02-19','11:10:00',2.18),('5815','2013-02-19','11:15:00',2.33),('5815','2013-02-19','11:25:00',2.02),('5815','2013-02-19','11:30:00',1.41),('5815','2013-02-19','11:35:00',1.99),('5815','2013-02-19','11:40:00',2.45),('5815','2013-02-19','11:45:00',2.35),('5815','2013-02-19','11:50:00',2.68),('5815','2013-02-19','11:55:00',1.73),('5815','2013-02-19','12:00:00',2.28),('5815','2013-02-19','12:05:00',1.19),('5815','2013-02-19','12:10:00',1.98),('5815','2013-02-19','12:15:00',1.56),('5815','2013-02-19','12:25:00',1.36),('5815','2013-02-19','12:30:00',2.87),('5815','2013-02-19','12:35:00',2.22),('5815','2013-02-19','12:40:00',1.76),('5815','2013-02-19','13:00:00',1.09),('5815','2013-02-19','13:05:00',2.34),('5815','2013-02-19','13:10:00',1.93),('5815','2013-02-19','13:15:00',2.67),('5815','2013-02-19','13:20:00',1.57),('5815','2013-02-19','13:30:00',1.87),('5815','2013-02-19','15:20:00',1.27),('5815','2013-02-19','15:25:00',1.63),('5815','2013-02-19','15:30:00',1.2),('5815','2013-02-19','16:05:00',1.26),('5815','2013-02-19','16:10:00',1.14),('5815','2013-02-19','16:15:00',1.13),('5815','2013-02-19','16:20:00',1.01),('5815','2013-02-18','08:45:00',1.05),('5815','2013-02-18','08:50:00',1.11),('5815','2013-02-18','08:55:00',1.14),('5815','2013-02-18','09:00:00',1.2),('5815','2013-02-18','09:05:00',1.25),('5815','2013-02-18','09:10:00',1.3),('5815','2013-02-18','09:15:00',1.36),('5815','2013-02-18','09:20:00',1.41),('5815','2013-02-18','09:25:00',1.46),('5815','2013-02-18','09:30:00',1.5),('5815','2013-02-18','09:35:00',1.54),('5815','2013-02-18','09:40:00',1.57),('5815','2013-02-18','09:45:00',1.62),('5815','2013-02-18','09:50:00',1.66),('5815','2013-02-18','09:55:00',1.69),('5815','2013-02-18','10:00:00',1.73),('5815','2013-02-18','10:05:00',1.76),('5815','2013-02-18','10:10:00',1.79),('5815','2013-02-18','10:15:00',1.84),('5815','2013-02-18','10:20:00',1.87),('5815','2013-02-18','10:25:00',1.91),('5815','2013-02-18','10:30:00',1.94),('5815','2013-02-18','10:35:00',1.96),('5815','2013-02-18','10:40:00',1.98),('5815','2013-02-18','10:45:00',2),('5815','2013-02-18','10:50:00',2.03),('5815','2013-02-18','10:55:00',2.03),('5815','2013-02-18','11:00:00',2.07),('5815','2013-02-18','11:05:00',2.11),('5815','2013-02-18','11:10:00',2.11),('5815','2013-02-18','11:15:00',2.15),('5815','2013-02-18','11:20:00',2.17),('5815','2013-02-18','11:25:00',2.19),('5815','2013-02-18','11:30:00',2.18),('5815','2013-02-18','11:35:00',2.21),('5815','2013-02-18','11:40:00',2.17),('5815','2013-02-18','11:45:00',2.22),('5815','2013-02-18','11:50:00',2.25),('5815','2013-02-18','11:55:00',2.24),('5815','2013-02-18','12:00:00',2.24),('5815','2013-02-18','12:05:00',2.26),('5815','2013-02-18','12:10:00',2.24),('5815','2013-02-18','12:15:00',2.23),('5815','2013-02-18','12:20:00',2.23),('5815','2013-02-18','12:25:00',2.24),('5815','2013-02-18','12:30:00',2.24),('5815','2013-02-18','12:35:00',2.23),('5815','2013-02-18','12:40:00',2.24),('5815','2013-02-18','12:45:00',2.23),('5815','2013-02-18','12:50:00',2.25),('5815','2013-02-18','12:55:00',2.25),('5815','2013-02-18','13:00:00',2.23),('5815','2013-02-18','13:05:00',2.22),('5815','2013-02-18','13:10:00',2.19),('5815','2013-02-18','13:15:00',2.17),('5815','2013-02-18','13:20:00',2.13),('5815','2013-02-18','13:25:00',2.19),('5815','2013-02-18','13:30:00',2.18),('5815','2013-02-18','13:35:00',2.17),('5815','2013-02-18','13:40:00',2.14),('5815','2013-02-18','13:45:00',2.13),('5815','2013-02-18','13:50:00',2.11),('5815','2013-02-18','13:55:00',2.05),('5815','2013-02-18','14:00:00',1.99),('5815','2013-02-18','14:05:00',1.97),('5815','2013-02-18','14:10:00',1.98),('5815','2013-02-18','14:15:00',1.97),('5815','2013-02-18','14:20:00',1.87),('5815','2013-02-18','14:25:00',1.82),('5815','2013-02-18','14:30:00',1.83),('5815','2013-02-18','14:35:00',1.77),('5815','2013-02-18','14:40:00',1.76),('5815','2013-02-18','14:45:00',1.73),('5815','2013-02-18','14:50:00',1.74),('5815','2013-02-18','14:55:00',1.68),('5815','2013-02-18','15:00:00',1.64),('5815','2013-02-18','15:05:00',1.59),('5815','2013-02-18','15:10:00',1.57),('5815','2013-02-18','15:15:00',1.53),('5815','2013-02-18','15:20:00',1.48),('5815','2013-02-18','15:25:00',1.43),('5815','2013-02-18','15:30:00',1.37),('5815','2013-02-18','15:35:00',1.3),('5815','2013-02-18','15:40:00',1.26),('5815','2013-02-18','15:45:00',1.21),('5815','2013-02-18','15:50:00',1.16),('5815','2013-02-18','15:55:00',1.12),('5815','2013-02-18','16:00:00',1.06),('5815','2013-02-18','16:05:00',1.01),('5815','2013-02-17','08:50:00',1.01),('5815','2013-02-17','08:55:00',1.08),('5815','2013-02-17','09:00:00',1.12),('5815','2013-02-17','09:05:00',1.19),('5815','2013-02-17','09:10:00',1.24),('5815','2013-02-17','09:15:00',1.27),('5815','2013-02-17','09:20:00',1.44),('5815','2013-02-17','09:25:00',1.53),('5815','2013-02-17','09:30:00',1.47),('5815','2013-02-17','13:15:00',1.1),('5815','2013-02-17','13:25:00',1.18),('5815','2013-02-17','13:30:00',1),('5815','2013-02-16','09:00:00',1.09),('5815','2013-02-16','09:05:00',1.11),('5815','2013-02-16','09:10:00',1.18),('5815','2013-02-16','09:15:00',1.23),('5815','2013-02-16','09:20:00',1.32),('5815','2013-02-16','09:25:00',1.35),('5815','2013-02-16','09:30:00',1.38),('5815','2013-02-16','09:35:00',1.43),('5815','2013-02-16','09:40:00',1.47),('5815','2013-02-16','09:45:00',1.52),('5815','2013-02-16','09:50:00',1.57),('5815','2013-02-16','09:55:00',1.61),('5815','2013-02-16','10:00:00',1.65),('5815','2013-02-16','10:05:00',1.68),('5815','2013-02-16','10:10:00',1.71),('5815','2013-02-16','10:15:00',1.76),('5815','2013-02-16','10:20:00',1.79),('5815','2013-02-16','10:25:00',1.81),('5815','2013-02-16','10:30:00',1.86),('5815','2013-02-16','10:35:00',1.89),('5815','2013-02-16','10:40:00',1.9),('5815','2013-02-16','10:45:00',1.88),('5815','2013-02-16','10:50:00',1.95),('5815','2013-02-16','10:55:00',1.97),('5815','2013-02-16','11:00:00',1.99),('5815','2013-02-16','11:05:00',2.02),('5815','2013-02-16','11:10:00',2.02),('5815','2013-02-16','11:15:00',2.06),('5815','2013-02-16','11:20:00',2.07),('5815','2013-02-16','11:25:00',2.07),('5815','2013-02-16','11:30:00',2.1),('5815','2013-02-16','11:35:00',2.1),('5815','2013-02-16','11:40:00',2.11),('5815','2013-02-16','11:45:00',2.12),('5815','2013-02-16','11:50:00',2.13),('5815','2013-02-16','11:55:00',2.14),('5815','2013-02-16','12:00:00',2.14),('5815','2013-02-16','12:05:00',2.15),('5815','2013-02-16','12:10:00',2.18),('5815','2013-02-16','12:15:00',2.18),('5815','2013-02-16','12:20:00',2.19),('5815','2013-02-16','12:25:00',2.19),('5815','2013-02-16','12:30:00',2.18),('5815','2013-02-16','12:35:00',2.18),('5815','2013-02-16','12:40:00',2.17),('5815','2013-02-16','12:45:00',2.14),('5815','2013-02-16','12:50:00',2.1),('5815','2013-02-16','12:55:00',2.08),('5815','2013-02-16','13:00:00',2.1),('5815','2013-02-16','13:05:00',2.09),('5815','2013-02-16','13:10:00',2.07),('5815','2013-02-16','13:15:00',2.06),('5815','2013-02-16','13:20:00',2.01),('5815','2013-02-16','13:25:00',2.01),('5815','2013-02-16','13:30:00',2.01),('5815','2013-02-16','13:35:00',2),('5815','2013-02-16','13:40:00',1.96),('5815','2013-02-16','13:45:00',1.92),('5815','2013-02-16','13:50:00',1.82),('5815','2013-02-16','13:55:00',1.83),('5815','2013-02-16','14:10:00',1.74),('5815','2013-02-16','14:15:00',1.84),('5815','2013-02-16','14:30:00',1.75),('5815','2013-02-16','14:35:00',1.49),('5815','2013-02-16','14:40:00',1.06),('5815','2013-02-16','15:10:00',1.67),('5815','2013-02-16','15:15:00',1.66),('5815','2013-02-16','15:20:00',1.63),('5815','2013-02-16','15:25:00',1.57),('5815','2013-02-16','15:30:00',1.24),('5815','2013-02-16','15:35:00',1.36),('5815','2013-02-16','15:40:00',1.39),('5815','2013-02-16','15:45:00',1.31),('5815','2013-02-16','15:50:00',1.24),('5815','2013-02-16','15:55:00',1.19),('5815','2013-02-16','16:00:00',1.12),('5815','2013-02-16','16:05:00',1.04),('5815','2013-02-15','09:15:00',1.32),('5815','2013-02-15','09:20:00',1.38),('5815','2013-02-15','09:25:00',1.41),('5815','2013-02-15','09:30:00',1.45),('5815','2013-02-15','09:35:00',1.49),('5815','2013-02-15','09:40:00',1.52),('5815','2013-02-15','09:45:00',1.56),('5815','2013-02-15','09:50:00',1.62),('5815','2013-02-15','09:55:00',1.64),('5815','2013-02-15','10:00:00',1.66),('5815','2013-02-15','10:05:00',1.71),('5815','2013-02-15','10:10:00',1.76),('5815','2013-02-15','10:15:00',1.78),('5815','2013-02-15','10:20:00',1.83),('5815','2013-02-15','10:25:00',1.84),('5815','2013-02-15','10:30:00',1.89),('5815','2013-02-15','10:35:00',1.94),('5815','2013-02-15','10:40:00',2.02),('5815','2013-02-15','10:45:00',2.05),('5815','2013-02-15','10:50:00',2.05),('5815','2013-02-15','10:55:00',2.06),('5815','2013-02-15','11:00:00',2.07),('5815','2013-02-15','11:05:00',2.01),('5815','2013-02-15','11:10:00',2.14),('5815','2013-02-15','11:15:00',2.15),('5815','2013-02-15','11:20:00',2.05),('5815','2013-02-15','11:25:00',2.12),('5815','2013-02-15','11:30:00',2.17),('5815','2013-02-15','11:35:00',2.19),('5815','2013-02-15','11:40:00',2.19),('5815','2013-02-15','11:45:00',2.22),('5815','2013-02-15','11:50:00',2.24),('5815','2013-02-15','11:55:00',2.25),('5815','2013-02-15','12:00:00',2.22),('5815','2013-02-15','12:05:00',2.23),('5815','2013-02-15','12:10:00',2.24),('5815','2013-02-15','12:15:00',2.23),('5815','2013-02-15','12:20:00',2.24),('5815','2013-02-15','12:25:00',2.23),('5815','2013-02-15','12:30:00',2.23),('5815','2013-02-15','12:35:00',2.23),('5815','2013-02-15','12:40:00',2.24),('5815','2013-02-15','12:45:00',2.25),('5815','2013-02-15','12:50:00',2.27),('5815','2013-02-15','12:55:00',2.26),('5815','2013-02-15','13:00:00',2.23),('5815','2013-02-15','13:05:00',2.22),('5815','2013-02-15','13:10:00',2.2),('5815','2013-02-15','13:15:00',2.19),('5815','2013-02-15','13:20:00',2.17),('5815','2013-02-15','13:25:00',2.15),('5815','2013-02-15','13:30:00',2.14),('5815','2013-02-15','13:35:00',2.13),('5815','2013-02-15','13:40:00',2.14),('5815','2013-02-15','13:45:00',2.12),('5815','2013-02-15','13:50:00',2.11),('5815','2013-02-15','13:55:00',2.09),('5815','2013-02-15','14:00:00',2.04),('5815','2013-02-15','14:05:00',2.03),('5815','2013-02-15','14:10:00',2.01),('5815','2013-02-15','14:15:00',1.99),('5815','2013-02-15','14:20:00',1.74),('5815','2013-02-15','14:25:00',1.14),('5815','2013-02-15','15:30:00',1.39),('5815','2013-02-15','15:35:00',1.37),('5815','2013-02-15','15:40:00',1.37),('5815','2013-02-15','15:45:00',1.51),('5815','2013-02-15','15:50:00',1.42),('5815','2013-02-14','10:05:00',1.08),('5815','2013-02-14','10:25:00',1.43),('5815','2013-02-14','10:30:00',1.1),('5815','2013-02-14','10:35:00',1.72),('5815','2013-02-14','10:44:00',1.82),('5815','2013-02-14','10:45:00',1.92),('5815','2013-02-14','10:50:00',1.99),('5815','2013-02-14','10:55:00',1.2),('5815','2013-02-14','11:00:00',1.08),('5815','2013-02-14','11:05:00',1.14),('5815','2013-02-14','11:10:00',1.33),('5815','2013-02-14','11:15:00',1.61),('5815','2013-02-14','11:20:00',2.18),('5815','2013-02-14','11:25:00',2.22),('5815','2013-02-14','11:30:00',2.21),('5815','2013-02-14','11:35:00',1.85),('5815','2013-02-14','11:40:00',1.28),('5815','2013-02-14','11:45:00',1.3),('5815','2013-02-14','11:50:00',2.27),('5815','2013-02-14','11:55:00',2.19),('5815','2013-02-14','12:00:00',1.81),('5815','2013-02-14','12:05:00',1.78),('5815','2013-02-14','12:10:00',1.91),('5815','2013-02-14','12:15:00',1.83),('5815','2013-02-14','12:20:00',2.46),('5815','2013-02-14','12:25:00',2.12),('5815','2013-02-14','12:31:00',2.13),('5815','2013-02-14','12:35:00',2.26),('5815','2013-02-14','12:40:00',2.23),('5815','2013-02-14','12:45:00',2.25),('5815','2013-02-14','12:50:00',2.25),('5815','2013-02-14','12:55:00',2.26),('5815','2013-02-14','13:00:00',2.24),('5815','2013-02-14','13:05:00',2.25),('5815','2013-02-14','13:10:00',2.26),('5815','2013-02-14','13:15:00',2.23),('5815','2013-02-14','13:20:00',2.04),('5815','2013-02-14','13:25:00',1.84),('5815','2013-02-14','13:30:00',1.55),('5815','2013-02-14','13:35:00',1.68),('5815','2013-02-14','13:40:00',2.17),('5815','2013-02-14','13:45:00',1.74),('5815','2013-02-14','13:50:00',1.82),('5815','2013-02-14','13:55:00',2.05),('5815','2013-02-14','14:00:00',1.42),('5815','2013-02-14','14:05:00',1.78),('5815','2013-02-14','14:10:00',2.39),('5815','2013-02-14','14:15:00',1.52),('5815','2013-02-14','14:20:00',1.76),('5815','2013-02-14','14:25:00',1.29),('5815','2013-02-14','14:32:00',1.38),('5815','2013-02-14','14:35:00',1.98),('5815','2013-02-14','14:40:00',1.85),('5815','2013-02-14','14:45:00',1.6),('5815','2013-02-14','15:00:00',1.13),('5815','2013-02-14','15:15:00',1.16),('5815','2013-02-14','15:25:00',1.11),('5815','2013-02-14','15:30:00',1.29),('5815','2013-02-13','08:45:00',1.03),('5815','2013-02-13','08:50:00',1.09),('5815','2013-02-13','08:55:00',1.14),('5815','2013-02-13','09:00:00',1.2),('5815','2013-02-13','09:05:00',1.25),('5815','2013-02-13','09:10:00',1.3),('5815','2013-02-13','09:15:00',1.35),('5815','2013-02-13','09:20:00',1.41),('5815','2013-02-13','09:25:00',1.46),('5815','2013-02-13','09:30:00',1.51),('5815','2013-02-13','09:35:00',1.55),('5815','2013-02-13','09:40:00',1.6),('5815','2013-02-13','09:45:00',1.64),('5815','2013-02-13','09:50:00',1.67),('5815','2013-02-13','09:55:00',1.73),('5815','2013-02-13','10:00:00',1.77),('5815','2013-02-13','10:05:00',1.81),('5815','2013-02-13','10:10:00',1.85),('5815','2013-02-13','10:15:00',1.88),('5815','2013-02-13','10:20:00',1.92),('5815','2013-02-13','10:25:00',1.95),('5815','2013-02-13','10:30:00',1.98),('5815','2013-02-13','10:35:00',2),('5815','2013-02-13','10:40:00',2.03),('5815','2013-02-13','10:45:00',2.06),('5815','2013-02-13','10:50:00',2.09),('5815','2013-02-13','10:55:00',2.12),('5815','2013-02-13','11:00:00',2.14),('5815','2013-02-13','11:05:00',2.15),('5815','2013-02-13','11:10:00',2.17),('5815','2013-02-13','11:15:00',2.19),('5815','2013-02-13','11:20:00',2.2),('5815','2013-02-13','11:25:00',2.22),('5815','2013-02-13','11:30:00',2.23),('5815','2013-02-13','11:35:00',2.24),('5815','2013-02-13','11:40:00',2.24),('5815','2013-02-13','11:45:00',2.26),('5815','2013-02-13','11:50:00',2.27),('5815','2013-02-13','11:55:00',2.29),('5815','2013-02-13','12:00:00',2.29),('5815','2013-02-13','12:05:00',2.3),('5815','2013-02-13','12:10:00',2.29),('5815','2013-02-13','12:15:00',2.29),('5815','2013-02-13','12:20:00',2.29),('5815','2013-02-13','12:25:00',2.3),('5815','2013-02-13','12:30:00',2.29),('5815','2013-02-13','12:35:00',2.27),('5815','2013-02-13','12:40:00',2.29),('5815','2013-02-13','12:45:00',2.27),('5815','2013-02-13','12:50:00',2.26),('5815','2013-02-13','12:55:00',2.26),('5815','2013-02-13','13:00:00',2.25),('5815','2013-02-13','13:05:00',2.24),('5815','2013-02-13','13:10:00',2.24),('5815','2013-02-13','13:15:00',2.23),('5815','2013-02-13','13:20:00',2.21),('5815','2013-02-13','13:25:00',2.18),('5815','2013-02-13','13:30:00',2.16),('5815','2013-02-13','13:35:00',2.16),('5815','2013-02-13','13:40:00',2.15),('5815','2013-02-13','13:45:00',2.13),('5815','2013-02-13','13:50:00',2.11),('5815','2013-02-13','13:55:00',2.08),('5815','2013-02-13','14:00:00',2.05),('5815','2013-02-13','14:05:00',2),('5815','2013-02-13','14:10:00',2),('5815','2013-02-13','14:15:00',1.97),('5815','2013-02-13','14:20:00',1.95),('5815','2013-02-13','14:25:00',1.91),('5815','2013-02-13','14:30:00',1.88),('5815','2013-02-13','14:35:00',1.85),('5815','2013-02-13','14:40:00',1.83),('5815','2013-02-13','14:45:00',1.83),('5815','2013-02-13','14:50:00',1.77),('5815','2013-02-13','14:55:00',1.7),('5815','2013-02-13','15:00:00',1.65),('5815','2013-02-13','15:05:00',1.61),('5815','2013-02-13','15:10:00',1.56),('5815','2013-02-13','15:15:00',1.52),('5815','2013-02-13','15:20:00',1.46),('5815','2013-02-13','15:25:00',1.42),('5815','2013-02-13','15:30:00',1.38),('5815','2013-02-13','15:35:00',1.31),('5815','2013-02-13','15:40:00',1.26),('5815','2013-02-13','15:45:00',1.22),('5815','2013-02-13','15:50:00',1.17),('5815','2013-02-13','15:55:00',1.12),('5815','2013-02-13','16:00:00',1.05),('5815','2013-02-12','09:35:00',1.03),('5815','2013-02-12','09:40:00',1.39),('5815','2013-02-12','09:45:00',1.56),('5815','2013-02-12','09:50:00',1.54),('5815','2013-02-12','09:55:00',1.57),('5815','2013-02-12','10:00:00',1.42),('5815','2013-02-12','10:05:00',1.59),('5815','2013-02-12','10:10:00',1.69),('5815','2013-02-12','10:15:00',1.79),('5815','2013-02-12','10:20:00',1.82),('5815','2013-02-12','10:25:00',1.91),('5815','2013-02-12','10:30:00',1.96),('5815','2013-02-12','10:35:00',1.95),('5815','2013-02-12','10:40:00',2.03),('5815','2013-02-12','10:45:00',2.14),('5815','2013-02-12','10:50:00',2.15),('5815','2013-02-12','10:55:00',2.12),('5815','2013-02-12','11:00:00',2.12),('5815','2013-02-12','11:05:00',2.03),('5815','2013-02-12','11:10:00',2.08),('5815','2013-02-12','11:15:00',2.1),('5815','2013-02-12','11:20:00',2.07),('5815','2013-02-12','11:25:00',1.78),('5815','2013-02-12','11:30:00',1.55),('5815','2013-02-12','11:35:00',1.29),('5815','2013-02-12','11:50:00',1.07),('5815','2013-02-12','12:15:00',1.66),('5815','2013-02-12','12:20:00',1.04),('5815','2013-02-12','12:25:00',1.35),('5815','2013-02-12','12:50:00',1.29),('5815','2013-02-12','12:55:00',1.42),('5815','2013-02-12','13:00:00',1.59),('5815','2013-02-12','13:05:00',1.73),('5815','2013-02-12','13:10:00',1.51),('5815','2013-02-12','13:15:00',1.19),('5815','2013-02-12','13:20:00',2.17),('5815','2013-02-12','13:25:00',2.24),('5815','2013-02-12','13:30:00',2.33),('5815','2013-02-12','13:35:00',2.24),('5815','2013-02-12','13:40:00',2.07),('5815','2013-02-12','13:45:00',1.91),('5815','2013-02-12','13:50:00',1.65),('5815','2013-02-12','13:55:00',1.72),('5815','2013-02-12','14:00:00',2.06),('5815','2013-02-12','14:05:00',2.1),('5815','2013-02-12','14:10:00',1.69),('5815','2013-02-12','14:15:00',1.85),('5815','2013-02-12','14:20:00',1.63),('5815','2013-02-12','14:25:00',1.76),('5815','2013-02-12','14:30:00',1.83),('5815','2013-02-12','14:35:00',1.91),('5815','2013-02-12','14:40:00',1.86),('5815','2013-02-12','14:45:00',1.79),('5815','2013-02-12','14:50:00',1.77),('5815','2013-02-12','14:55:00',1.72),('5815','2013-02-12','15:00:00',1.66),('5815','2013-02-12','15:05:00',1.61),('5815','2013-02-12','15:10:00',1.57),('5815','2013-02-12','15:15:00',1.52),('5815','2013-02-12','15:20:00',1.47),('5815','2013-02-12','15:25:00',1.45),('5815','2013-02-12','15:30:00',1.41),('5815','2013-02-12','15:35:00',1.36),('5815','2013-02-12','15:40:00',1.33),('5815','2013-02-12','15:45:00',1.27),('5815','2013-02-12','15:50:00',1.19),('5815','2013-02-12','15:55:00',1.14),('5815','2013-02-12','16:00:00',1.09),('5815','2013-02-12','16:05:00',1.01),('5815','2013-02-10','14:30:00',1.18),('5815','2013-02-09','10:00:00',1.56),('5815','2013-02-09','10:05:00',1.82),('5815','2013-02-09','10:10:00',1.78),('5815','2013-02-09','10:15:00',1.85),('5815','2013-02-09','10:20:00',1.88),('5815','2013-02-09','10:25:00',1.92),('5815','2013-02-09','10:30:00',1.95),('5815','2013-02-09','10:35:00',1.97),('5815','2013-02-09','10:40:00',1.99),('5815','2013-02-09','10:45:00',2.02),('5815','2013-02-09','10:50:00',2.05),('5815','2013-02-09','10:55:00',2.07),('5815','2013-02-09','11:00:00',2.1),('5815','2013-02-09','11:05:00',2.11),('5815','2013-02-09','11:10:00',2.12),('5815','2013-02-09','11:15:00',2.13),('5815','2013-02-09','11:20:00',2.14),('5815','2013-02-09','11:25:00',2.15),('5815','2013-02-09','11:30:00',2.18),('5815','2013-02-09','11:35:00',2.19),('5815','2013-02-09','11:40:00',2.21),('5815','2013-02-09','11:45:00',2.22),('5815','2013-02-09','11:50:00',2.24),('5815','2013-02-09','11:55:00',2.26),('5815','2013-02-09','12:00:00',2.28),('5815','2013-02-09','12:05:00',2.25),('5815','2013-02-09','12:10:00',2.3),('5815','2013-02-09','12:15:00',2.3),('5815','2013-02-09','12:20:00',2.29),('5815','2013-02-09','12:25:00',2.29),('5815','2013-02-09','12:30:00',2.29),('5815','2013-02-09','12:35:00',2.28),('5815','2013-02-09','12:40:00',2.27),('5815','2013-02-09','12:45:00',2.27),('5815','2013-02-09','12:50:00',2.29),('5815','2013-02-09','12:55:00',2.27),('5815','2013-02-09','13:00:00',2.23),('5815','2013-02-09','13:05:00',2.2),('5815','2013-02-09','13:10:00',2.2),('5815','2013-02-09','13:15:00',2.18),('5815','2013-02-09','13:20:00',2.18),('5815','2013-02-09','13:25:00',2.17),('5815','2013-02-09','13:30:00',2.15),('5815','2013-02-09','13:35:00',2.1),('5815','2013-02-09','13:40:00',2.07),('5815','2013-02-09','13:45:00',2.05),('5815','2013-02-09','13:50:00',2.04),('5815','2013-02-09','13:55:00',2.01),('5815','2013-02-09','14:00:00',1.97),('5815','2013-02-09','14:05:00',1.96),('5815','2013-02-09','14:10:00',1.92),('5815','2013-02-09','14:15:00',1.91),('5815','2013-02-09','14:20:00',1.87),('5815','2013-02-09','14:25:00',1.8),('5815','2013-02-09','14:30:00',1.8),('5815','2013-02-09','14:35:00',1.8),('5815','2013-02-09','14:40:00',1.37),('5815','2013-02-09','14:45:00',1.77),('5815','2013-02-09','14:50:00',1.67),('5815','2013-02-09','14:55:00',1.62),('5815','2013-02-09','15:00:00',1.12),('5815','2013-02-09','15:10:00',1.52),('5815','2013-02-09','15:25:00',1.31),('5815','2013-02-09','15:35:00',1.18),('5815','2013-02-08','13:15:00',1.1),('5815','2013-02-08','13:20:00',1.23),('5815','2013-02-08','13:25:00',1.33),('5815','2013-02-08','13:30:00',1.61),('5815','2013-02-08','13:35:00',1.6),('5815','2013-02-08','13:40:00',1.71),('5815','2013-02-08','13:45:00',1.88),('5815','2013-02-08','13:50:00',2.04),('5815','2013-02-08','13:55:00',1.97),('5815','2013-02-08','14:00:00',2.04),('5815','2013-02-08','14:05:00',1.9),('5815','2013-02-08','14:10:00',1.4),('5815','2013-02-08','14:15:00',1.87),('5815','2013-02-08','14:20:00',2.09),('5815','2013-02-08','14:25:00',2.22),('5815','2013-02-08','14:30:00',2.04),('5815','2013-02-08','14:35:00',1.91),('5815','2013-02-08','14:40:00',1.79),('5815','2013-02-08','14:45:00',1.7),('5815','2013-02-08','14:50:00',1.66),('5815','2013-02-08','14:55:00',1.67),('5815','2013-02-08','15:00:00',1.59),('5815','2013-02-08','15:05:00',1.52),('5815','2013-02-08','15:10:00',1.49),('5815','2013-02-08','15:15:00',1.42),('5815','2013-02-08','15:20:00',1.37),('5815','2013-02-08','15:25:00',1.25),('5815','2013-02-08','15:30:00',1.22),('5815','2013-02-08','15:35:00',1.18),('5815','2013-02-08','15:50:00',1.02),('5815','2013-02-07','09:35:00',1.32),('5815','2013-02-07','09:40:00',1.66),('5815','2013-02-07','09:45:00',1.57),('5815','2013-02-07','09:50:00',1.86),('5815','2013-02-07','09:55:00',1.9),('5815','2013-02-07','10:00:00',1.98),('5815','2013-02-07','10:05:00',2.1),('5815','2013-02-07','10:10:00',2.15),('5815','2013-02-07','10:15:00',2.25),('5815','2013-02-07','10:20:00',2.2),('5815','2013-02-07','10:25:00',2.17),('5815','2013-02-07','10:30:00',2.25),('5815','2013-02-07','10:35:00',1.09),('5815','2013-02-07','10:40:00',1.59),('5815','2013-02-07','10:45:00',2.25),('5815','2013-02-07','10:50:00',2.28),('5815','2013-02-07','10:55:00',2.23),('5815','2013-02-07','11:00:00',2.16),('5815','2013-02-07','11:05:00',2.17),('5815','2013-02-07','11:10:00',2.17),('5815','2013-02-07','11:15:00',2.17),('5815','2013-02-07','11:20:00',2.18),('5815','2013-02-07','11:25:00',2.19),('5815','2013-02-07','11:30:00',2.19),('5815','2013-02-07','11:35:00',2.19),('5815','2013-02-07','11:40:00',2.21),('5815','2013-02-07','11:45:00',2.23),('5815','2013-02-07','11:50:00',2.23),('5815','2013-02-07','11:55:00',2.24),('5815','2013-02-07','12:00:00',2.24),('5815','2013-02-07','12:05:00',2.25),('5815','2013-02-07','12:10:00',2.25),('5815','2013-02-07','12:15:00',2.24),('5815','2013-02-07','12:20:00',2.25),('5815','2013-02-07','12:25:00',2.26),('5815','2013-02-07','12:30:00',2.26),('5815','2013-02-07','12:35:00',2.27),('5815','2013-02-07','12:40:00',2.33),('5815','2013-02-07','12:45:00',2.26),('5815','2013-02-07','12:50:00',1.82),('5815','2013-02-07','12:55:00',1.27),('5815','2013-02-07','13:00:00',1.16),('5815','2013-02-07','13:05:00',1.07),('5815','2013-02-07','13:10:00',1.16),('5815','2013-02-07','13:15:00',1.14),('5815','2013-02-07','13:20:00',1.17),('5815','2013-02-07','13:25:00',1.11),('5815','2013-02-07','13:30:00',1.08),('5815','2013-02-07','13:35:00',1.45),('5815','2013-02-07','13:40:00',1.23),('5815','2013-02-07','14:30:00',1.14),('5815','2013-02-07','14:35:00',1.13),('5815','2013-02-07','14:40:00',2.09),('5815','2013-02-07','14:45:00',2.18),('5815','2013-02-07','14:50:00',1.28),('5815','2013-02-07','14:55:00',1.72),('5815','2013-02-07','15:00:00',1.69),('5815','2013-02-07','15:05:00',1.97),('5815','2013-02-07','15:10:00',1.96),('5815','2013-02-07','15:15:00',1.79),('5815','2013-02-07','15:20:00',1.35),('5815','2013-02-07','15:25:00',1.5),('5815','2013-02-07','15:30:00',1.39),('5815','2013-02-07','15:35:00',1.32),('5815','2013-02-07','15:40:00',1.27),('5815','2013-02-07','15:45:00',1.22),('5815','2013-02-07','15:50:00',1.15),('5815','2013-02-07','15:55:00',1.08),('5815','2013-02-07','16:00:00',1.02),('5815','2013-02-06','11:00:00',1.36),('5815','2013-02-06','12:25:00',1.67),('5815','2013-02-06','12:30:00',1.34),('5815','2013-02-06','14:05:00',1.09),('5815','2013-02-06','14:10:00',1.87),('5815','2013-02-06','14:15:00',1.78),('5815','2013-02-06','14:20:00',1.72),('5815','2013-02-06','14:35:00',1.16),('5815','2013-02-06','14:45:00',1.32),('5815','2013-02-06','15:00:00',1.07),('5815','2013-02-06','15:05:00',1.57),('5815','2013-02-06','15:10:00',1.68),('5815','2013-02-06','15:15:00',1.32),('5815','2013-02-05','09:10:00',1.01),('5815','2013-02-05','09:40:00',1.04),('5815','2013-02-05','10:05:00',1.06),('5815','2013-02-05','10:35:00',1.15),('5815','2013-02-05','10:55:00',1.42),('5815','2013-02-05','11:00:00',1.12),('5815','2013-02-05','11:20:00',1.14),('5815','2013-02-05','11:25:00',1.57),('5815','2013-02-05','11:30:00',1.01),('5815','2013-02-05','13:50:00',1.07),('5815','2013-02-05','14:35:00',1.59),('5815','2013-02-04','09:00:00',1.04),('5815','2013-02-04','09:05:00',1.08),('5815','2013-02-04','09:10:00',1.14),('5815','2013-02-04','09:15:00',1.19),('5815','2013-02-04','09:20:00',1.25),('5815','2013-02-04','09:25:00',1.3),('5815','2013-02-04','09:30:00',1.33),('5815','2013-02-04','09:35:00',1.39),('5815','2013-02-04','09:40:00',1.44),('5815','2013-02-04','09:45:00',1.47),('5815','2013-02-04','09:50:00',1.51),('5815','2013-02-04','09:55:00',1.56),('5815','2013-02-04','10:00:00',1.57),('5815','2013-02-04','10:05:00',1.61),('5815','2013-02-04','10:10:00',1.52),('5815','2013-02-04','10:15:00',1.54),('5815','2013-02-04','10:20:00',1.72),('5815','2013-02-04','10:25:00',1.76),('5815','2013-02-04','10:30:00',1.79),('5815','2013-02-04','10:35:00',1.81),('5815','2013-02-04','10:40:00',1.83),('5815','2013-02-04','10:45:00',1.85),('5815','2013-02-04','10:50:00',1.85),('5815','2013-02-04','10:55:00',1.86),('5815','2013-02-04','11:00:00',1.88),('5815','2013-02-04','11:05:00',1.89),('5815','2013-02-04','11:10:00',1.94),('5815','2013-02-04','11:15:00',1.96),('5815','2013-02-04','11:20:00',1.97),('5815','2013-02-04','11:25:00',1.98),('5815','2013-02-04','11:30:00',1.95),('5815','2013-02-04','11:35:00',1.88),('5815','2013-02-04','11:40:00',1.63),('5815','2013-02-04','11:45:00',1.36),('5815','2013-02-04','11:50:00',1.09),('5815','2013-02-04','12:10:00',1.43),('5815','2013-02-04','12:40:00',1),('5815','2013-02-04','12:45:00',1.08),('5815','2013-02-04','12:50:00',1.32),('5815','2013-02-04','14:25:00',1.01),('5815','2013-02-04','14:30:00',1.05),('5815','2013-02-04','14:40:00',1.2),('5815','2013-02-03','09:00:00',1.11),('5815','2013-02-03','09:05:00',1.19),('5815','2013-02-03','09:10:00',1.26),('5815','2013-02-03','09:15:00',1.29),('5815','2013-02-03','09:20:00',1.29),('5815','2013-02-03','09:25:00',1.3),('5815','2013-02-03','09:30:00',1.41),('5815','2013-02-03','09:35:00',1.41),('5815','2013-02-03','09:40:00',1.44),('5815','2013-02-03','09:45:00',1.3),('5815','2013-02-03','09:50:00',1.56),('5815','2013-02-03','09:55:00',1.67),('5815','2013-02-03','10:00:00',1.72),('5815','2013-02-03','10:05:00',1.75),('5815','2013-02-03','10:10:00',1.81),('5815','2013-02-03','10:15:00',1.87),('5815','2013-02-03','10:20:00',1.77),('5815','2013-02-03','10:25:00',1.85),('5815','2013-02-03','10:30:00',1.76),('5815','2013-02-03','10:35:00',1.68),('5815','2013-02-03','10:40:00',1.79),('5815','2013-02-03','10:45:00',1.95),('5815','2013-02-03','10:50:00',2),('5815','2013-02-03','10:55:00',2),('5815','2013-02-03','11:00:00',2.01),('5815','2013-02-03','11:05:00',2.06),('5815','2013-02-03','11:10:00',2.07),('5815','2013-02-03','11:15:00',2.09),('5815','2013-02-03','11:20:00',2.1),('5815','2013-02-03','11:25:00',2.11),('5815','2013-02-03','11:30:00',2.12),('5815','2013-02-03','11:35:00',2.12),('5815','2013-02-03','11:40:00',2.14),('5815','2013-02-03','11:45:00',2.14),('5815','2013-02-03','11:50:00',2.15),('5815','2013-02-03','11:55:00',2.16),('5815','2013-02-03','12:00:00',2.13),('5815','2013-02-03','12:05:00',2.18),('5815','2013-02-03','12:10:00',2.19),('5815','2013-02-03','12:15:00',2.17),('5815','2013-02-03','12:20:00',2.17),('5815','2013-02-03','12:25:00',2.17),('5815','2013-02-03','12:30:00',2.18),('5815','2013-02-03','12:35:00',2.17),('5815','2013-02-03','12:40:00',2.18),('5815','2013-02-03','12:45:00',2.16),('5815','2013-02-03','12:50:00',2.14),('5815','2013-02-03','12:55:00',2.16),('5815','2013-02-03','13:00:00',2.17),('5815','2013-02-03','13:05:00',2.16),('5815','2013-02-03','13:10:00',2.15),('5815','2013-02-03','13:15:00',2.12),('5815','2013-02-03','13:20:00',2.12),('5815','2013-02-03','13:25:00',2.1),('5815','2013-02-03','13:30:00',2.09),('5815','2013-02-03','13:35:00',2.07),('5815','2013-02-03','13:40:00',2.04),('5815','2013-02-03','13:45:00',2.01),('5815','2013-02-03','13:50:00',2.01),('5815','2013-02-03','13:55:00',1.99),('5815','2013-02-03','14:00:00',1.97),('5815','2013-02-03','14:05:00',1.95),('5815','2013-02-03','14:10:00',1.92),('5815','2013-02-03','14:15:00',1.9),('5815','2013-02-03','14:20:00',1.87),('5815','2013-02-03','14:25:00',1.84),('5815','2013-02-03','14:30:00',1.82),('5815','2013-02-03','14:35:00',1.81),('5815','2013-02-03','14:40:00',1.76),('5815','2013-02-03','14:45:00',1.7),('5815','2013-02-03','14:50:00',1.66),('5815','2013-02-03','14:55:00',1.61),('5815','2013-02-03','15:00:00',1.57),('5815','2013-02-03','15:05:00',1.53),('5815','2013-02-03','15:10:00',1.49),('5815','2013-02-03','15:15:00',1.44),('5815','2013-02-03','15:20:00',1.39),('5815','2013-02-03','15:25:00',1.36),('5815','2013-02-03','15:30:00',1.31),('5815','2013-02-03','15:35:00',1.25),('5815','2013-02-03','15:40:00',1.2),('5815','2013-02-03','15:45:00',1.14),('5815','2013-02-03','15:50:00',1.09),('5815','2013-02-03','15:55:00',1.03),('5815','2013-02-02','10:00:00',1.21),('5815','2013-02-01','10:55:00',1.07),('5815','2013-02-01','11:00:00',1.26),('5815','2013-02-01','11:05:00',1.12),('5815','2013-02-01','11:10:00',1.2),('5815','2013-02-01','11:15:00',1.17),('5815','2013-02-01','11:20:00',1.15),('5815','2013-02-01','11:25:00',1.25),('5815','2013-02-01','11:30:00',1.22),('5815','2013-02-01','11:35:00',1.04),('5815','2013-02-01','11:40:00',1.02),('5815','2013-02-01','12:55:00',1.43),('5815','2013-02-01','13:00:00',1.2),('5815','2013-02-01','13:05:00',1.26),('5815','2013-02-01','13:10:00',1.11),('5815','2013-02-01','13:15:00',1.35),('5815','2013-02-01','13:20:00',1.19),('5815','2013-02-01','13:25:00',1.01),('5815','2013-02-01','13:35:00',1.3),('5815','2013-02-01','13:40:00',1.68),('5815','2013-02-01','13:45:00',1.21),('5815','2013-02-01','13:50:00',1.23),('5815','2013-01-31','09:05:00',1.03),('5815','2013-01-31','09:10:00',1.16),('5815','2013-01-31','09:25:00',1.05),('5815','2013-01-31','09:40:00',1.05),('5815','2013-01-31','10:00:00',1.09),('5815','2013-01-31','10:20:00',1.24),('5815','2013-01-31','10:50:00',1.38),('5815','2013-01-31','10:55:00',2.09),('5815','2013-01-31','11:00:00',2),('5815','2013-01-31','11:05:00',1.85),('5815','2013-01-31','11:10:00',1.97),('5815','2013-01-31','11:15:00',1.25),('5815','2013-01-31','11:20:00',1.52),('5815','2013-01-31','11:25:00',1.07),('5815','2013-01-31','11:40:00',1.64),('5815','2013-01-31','11:45:00',1.01),('5815','2013-01-31','11:50:00',1.11),('5815','2013-01-31','12:10:00',1.04),('5815','2013-01-31','12:15:00',1.16),('5815','2013-01-31','12:20:00',2.36),('5815','2013-01-31','12:25:00',2.2),('5815','2013-01-31','12:40:00',1.74),('5815','2013-01-31','12:45:00',1.81),('5815','2013-01-31','12:50:00',2.08),('5815','2013-01-31','12:55:00',2.35),('5815','2013-01-31','13:00:00',2.27),('5815','2013-01-31','13:05:00',1.37),('5815','2013-01-31','13:10:00',2.14),('5815','2013-01-31','13:15:00',2.01),('5815','2013-01-31','13:20:00',2.01),('5815','2013-01-31','13:25:00',1.38),('5815','2013-01-31','13:30:00',1.34),('5815','2013-01-31','13:35:00',1.49),('5815','2013-01-31','13:40:00',1.52),('5815','2013-01-31','13:45:00',1.56),('5815','2013-01-31','13:50:00',1.29),('5815','2013-01-31','14:15:00',1.19),('5815','2013-01-31','14:20:00',1.68),('5815','2013-01-31','14:25:00',1.78),('5815','2013-01-31','14:30:00',1.77),('5815','2013-01-31','14:35:00',1.7),('5815','2013-01-31','14:40:00',1.54),('5815','2013-01-31','15:10:00',1.42),('5815','2013-01-31','15:20:00',1.29),('5815','2013-01-30','09:25:00',1.21),('5815','2013-01-30','09:30:00',1.37),('5815','2013-01-30','09:35:00',1.31),('5815','2013-01-30','09:40:00',1.35),('5815','2013-01-30','09:45:00',1.27),('5815','2013-01-30','09:50:00',1.37),('5815','2013-01-30','09:55:00',1.51),('5815','2013-01-30','10:00:00',1.51),('5815','2013-01-30','10:05:00',1.52),('5815','2013-01-30','10:10:00',1.54),('5815','2013-01-30','10:15:00',1.6),('5815','2013-01-30','10:20:00',1.65),('5815','2013-01-30','10:25:00',1.58),('5815','2013-01-30','10:30:00',1.55),('5815','2013-01-30','10:35:00',1.79),('5815','2013-01-30','10:40:00',1.86),('5815','2013-01-30','10:45:00',1.87),('5815','2013-01-30','10:50:00',1.62),('5815','2013-01-30','11:00:00',2),('5815','2013-01-30','11:05:00',2.11),('5815','2013-01-30','11:10:00',2.1),('5815','2013-01-30','11:15:00',2.09),('5815','2013-01-30','11:20:00',2.11),('5815','2013-01-30','11:25:00',2.01),('5815','2013-01-30','11:30:00',1.94),('5815','2013-01-30','11:35:00',1.99),('5815','2013-01-30','11:40:00',1.99),('5815','2013-01-30','11:45:00',1.97),('5815','2013-01-30','11:50:00',1.97),('5815','2013-01-30','11:55:00',1.96),('5815','2013-01-30','12:00:00',1.97),('5815','2013-01-30','12:05:00',2),('5815','2013-01-30','12:10:00',1.59),('5815','2013-01-30','12:15:00',1.96),('5815','2013-01-30','12:20:00',2.01),('5815','2013-01-30','12:25:00',2.01),('5815','2013-01-30','12:30:00',2.01),('5815','2013-01-30','12:35:00',2.01),('5815','2013-01-30','12:40:00',2),('5815','2013-01-30','12:45:00',2),('5815','2013-01-30','12:50:00',1.99),('5815','2013-01-30','12:55:00',1.95),('5815','2013-01-30','13:00:00',1.96),('5815','2013-01-30','13:05:00',1.95),('5815','2013-01-30','13:10:00',1.94),('5815','2013-01-30','13:15:00',1.91),('5815','2013-01-30','13:20:00',1.88),('5815','2013-01-30','13:25:00',1.87),('5815','2013-01-30','13:30:00',1.83),('5815','2013-01-30','13:35:00',1.82),('5815','2013-01-30','13:40:00',1.77),('5815','2013-01-30','13:45:00',1.71),('5815','2013-01-30','13:50:00',1.81),('5815','2013-01-30','13:55:00',1.81),('5815','2013-01-30','14:00:00',1.77),('5815','2013-01-30','14:05:00',1.7),('5815','2013-01-30','14:10:00',1.67),('5815','2013-01-30','14:15:00',1.63),('5815','2013-01-30','14:20:00',1.66),('5815','2013-01-30','14:25:00',1.62),('5815','2013-01-30','14:30:00',1.58),('5815','2013-01-30','14:35:00',1.57),('5815','2013-01-30','14:40:00',1.53),('5815','2013-01-30','14:45:00',1.47),('5815','2013-01-30','14:50:00',1.41),('5815','2013-01-30','14:55:00',1.38),('5815','2013-01-30','15:00:00',1.32),('5815','2013-01-30','15:05:00',1.3),('5815','2013-01-30','15:10:00',1.27),('5815','2013-01-30','15:15:00',1.26),('5815','2013-01-30','15:20:00',1.22),('5815','2013-01-30','15:25:00',1.16),('5815','2013-01-30','15:30:00',1.12),('5815','2013-01-30','15:35:00',1.09),('5815','2013-01-30','15:40:00',1.03),('5815','2013-01-29','10:45:00',1.28),('5815','2013-01-29','10:50:00',1.7),('5815','2013-01-29','10:55:00',1.75),('5815','2013-01-29','11:00:00',1.82),('5815','2013-01-29','11:05:00',1.77),('5815','2013-01-29','11:10:00',1.79),('5815','2013-01-29','11:15:00',1.83),('5815','2013-01-29','11:20:00',1.85),('5815','2013-01-29','11:25:00',1.9),('5815','2013-01-29','11:30:00',1.91),('5815','2013-01-29','11:35:00',1.92),('5815','2013-01-29','11:40:00',1.63),('5815','2013-01-29','11:45:00',1.97),('5815','2013-01-29','11:50:00',1.98),('5815','2013-01-29','11:55:00',1.91),('5815','2013-01-29','12:00:00',2),('5815','2013-01-29','12:05:00',2.01),('5815','2013-01-29','12:10:00',1.25),('5815','2013-01-29','12:15:00',1.65),('5815','2013-01-29','12:20:00',1.18),('5815','2013-01-29','12:40:00',1.12),('5815','2013-01-29','12:55:00',2.23),('5815','2013-01-29','13:00:00',2.2),('5815','2013-01-29','13:05:00',2.21),('5815','2013-01-29','13:10:00',2.1),('5815','2013-01-29','13:15:00',1.99),('5815','2013-01-29','13:20:00',2.04),('5815','2013-01-29','13:25:00',2.12),('5815','2013-01-29','13:30:00',1.86),('5815','2013-01-29','13:35:00',1.92),('5815','2013-01-29','13:40:00',1.04),('5815','2013-01-29','13:45:00',1.07),('5815','2013-01-29','13:50:00',1.61),('5815','2013-01-29','13:55:00',1.33),('5815','2013-01-29','14:00:00',1.47),('5815','2013-01-29','14:05:00',1.01),('5815','2013-01-29','14:10:00',1.62),('5815','2013-01-29','14:20:00',1.24),('5815','2013-01-29','14:25:00',1.48),('5815','2013-01-29','14:40:00',1.14),('5815','2013-01-29','14:45:00',1.2),('5815','2013-01-28','09:05:00',1.02),('5815','2013-01-28','09:10:00',1.08),('5815','2013-01-28','09:15:00',1.12),('5815','2013-01-28','09:20:00',1.17),('5815','2013-01-28','09:25:00',1.22),('5815','2013-01-28','09:30:00',1.26),('5815','2013-01-28','09:35:00',1.3),('5815','2013-01-28','09:40:00',1.35),('5815','2013-01-28','09:45:00',1.41),('5815','2013-01-28','09:50:00',1.45),('5815','2013-01-28','09:55:00',1.48),('5815','2013-01-28','10:00:00',1.52),('5815','2013-01-28','10:05:00',1.58),('5815','2013-01-28','10:10:00',1.62),('5815','2013-01-28','10:15:00',1.66),('5815','2013-01-28','10:20:00',1.69),('5815','2013-01-28','10:25:00',1.74),('5815','2013-01-28','10:30:00',1.76),('5815','2013-01-28','10:35:00',1.79),('5815','2013-01-28','10:40:00',1.83),('5815','2013-01-28','10:45:00',1.84),('5815','2013-01-28','10:50:00',1.86),('5815','2013-01-28','10:55:00',1.88),('5815','2013-01-28','11:00:00',1.87),('5815','2013-01-28','11:05:00',1.89),('5815','2013-01-28','11:10:00',1.9),('5815','2013-01-28','11:15:00',1.94),('5815','2013-01-28','11:20:00',1.96),('5815','2013-01-28','11:25:00',1.95),('5815','2013-01-28','11:30:00',1.94),('5815','2013-01-28','11:35:00',2.01),('5815','2013-01-28','11:40:00',2.05),('5815','2013-01-28','11:45:00',2.05),('5815','2013-01-28','11:50:00',2.05),('5815','2013-01-28','11:55:00',2.04),('5815','2013-01-28','12:00:00',2.02),('5815','2013-01-28','12:05:00',2.03),('5815','2013-01-28','12:10:00',2.06),('5815','2013-01-28','12:15:00',2.05),('5815','2013-01-28','12:20:00',2.04),('5815','2013-01-28','12:25:00',2.06),('5815','2013-01-28','12:30:00',2.05),('5815','2013-01-28','12:35:00',2.02),('5815','2013-01-28','12:40:00',2.02),('5815','2013-01-28','12:45:00',2),('5815','2013-01-28','12:50:00',1.99),('5815','2013-01-28','12:55:00',2.02),('5815','2013-01-28','13:00:00',2.02),('5815','2013-01-28','13:05:00',1.99),('5815','2013-01-28','13:10:00',1.98),('5815','2013-01-28','13:15:00',1.96),('5815','2013-01-28','13:20:00',1.96),('5815','2013-01-28','13:25:00',1.95),('5815','2013-01-28','13:30:00',1.93),('5815','2013-01-28','13:35:00',1.89),('5815','2013-01-28','13:40:00',1.88),('5815','2013-01-28','13:45:00',1.86),('5815','2013-01-28','13:50:00',1.83),('5815','2013-01-28','13:55:00',1.8),('5815','2013-01-28','14:00:00',1.78),('5815','2013-01-28','14:05:00',1.73),('5815','2013-01-28','14:10:00',1.7),('5815','2013-01-28','14:15:00',1.72),('5815','2013-01-28','14:20:00',1.74),('5815','2013-01-28','14:25:00',1.71),('5815','2013-01-28','14:30:00',1.68),('5815','2013-01-28','14:35:00',1.62),('5815','2013-01-28','14:40:00',1.58),('5815','2013-01-28','14:45:00',1.56),('5815','2013-01-28','14:50:00',1.51),('5815','2013-01-28','14:55:00',1.47),('5815','2013-01-28','15:00:00',1.42),('5815','2013-01-28','15:05:00',1.38),('5815','2013-01-28','15:10:00',1.31),('5815','2013-01-28','15:15:00',1.27),('5815','2013-01-28','15:20:00',1.22),('5815','2013-01-28','15:25:00',1.17),('5815','2013-01-28','15:30:00',1.1),('5815','2013-01-28','15:35:00',1.05),('5815','2013-01-28','15:40:00',1.01),('5815','2013-01-26','09:10:00',1.03),('5815','2013-01-26','09:15:00',1.08),('5815','2013-01-26','09:20:00',1.14),('5815','2013-01-26','09:25:00',1.2),('5815','2013-01-26','09:30:00',1.24),('5815','2013-01-26','09:35:00',1.29),('5815','2013-01-26','09:40:00',1.34),('5815','2013-01-26','09:45:00',1.38),('5815','2013-01-26','09:50:00',1.43),('5815','2013-01-26','09:55:00',1.47),('5815','2013-01-26','10:00:00',1.5),('5815','2013-01-26','10:05:00',1.52),('5815','2013-01-26','10:10:00',1.57),('5815','2013-01-26','10:15:00',1.61),('5815','2013-01-26','10:20:00',1.64),('5815','2013-01-26','10:25:00',1.67),('5815','2013-01-26','10:30:00',1.71),('5815','2013-01-26','10:35:00',1.73),('5815','2013-01-26','10:40:00',1.75),('5815','2013-01-26','10:45:00',1.78),('5815','2013-01-26','10:50:00',1.81),('5815','2013-01-26','10:55:00',1.84),('5815','2013-01-26','11:00:00',1.85),('5815','2013-01-26','11:05:00',1.87),('5815','2013-01-26','11:10:00',1.89),('5815','2013-01-26','11:15:00',1.91),('5815','2013-01-26','11:20:00',1.94),('5815','2013-01-26','11:25:00',1.95),('5815','2013-01-26','11:30:00',1.96),('5815','2013-01-26','11:35:00',1.97),('5815','2013-01-26','11:40:00',1.97),('5815','2013-01-26','11:45:00',1.98),('5815','2013-01-26','11:50:00',1.99),('5815','2013-01-26','11:55:00',2.01),('5815','2013-01-26','12:00:00',2.02),('5815','2013-01-26','12:05:00',2.02),('5815','2013-01-26','12:10:00',2.02),('5815','2013-01-26','12:15:00',2.02),('5815','2013-01-26','12:20:00',2.03),('5815','2013-01-26','12:25:00',2.02),('5815','2013-01-26','12:30:00',2.02),('5815','2013-01-26','12:35:00',2.02),('5815','2013-01-26','12:40:00',2),('5815','2013-01-26','12:45:00',1.97),('5815','2013-01-26','12:50:00',1.98),('5815','2013-01-26','12:55:00',2.03),('5815','2013-01-26','13:00:00',2.01),('5815','2013-01-26','13:05:00',2),('5815','2013-01-26','13:10:00',1.97),('5815','2013-01-26','13:15:00',1.94),('5815','2013-01-26','13:20:00',1.89),('5815','2013-01-26','13:25:00',1.9),('5815','2013-01-26','13:30:00',1.88),('5815','2013-01-26','13:35:00',1.86),('5815','2013-01-26','13:40:00',1.82),('5815','2013-01-26','13:45:00',1.78),('5815','2013-01-26','13:50:00',1.77),('5815','2013-01-26','13:55:00',1.76),('5815','2013-01-26','14:00:00',1.76),('5815','2013-01-26','14:05:00',1.73),('5815','2013-01-26','14:10:00',1.68),('5815','2013-01-26','14:15:00',1.65),('5815','2013-01-26','14:20:00',1.62),('5815','2013-01-26','14:25:00',1.58),('5815','2013-01-26','14:30:00',1.56),('5815','2013-01-26','14:35:00',1.51),('5815','2013-01-26','14:40:00',1.47),('5815','2013-01-26','14:45:00',1.43),('5815','2013-01-26','14:50:00',1.42),('5815','2013-01-26','14:55:00',1.4),('5815','2013-01-26','15:00:00',1.33),('5815','2013-01-26','15:05:00',1.29),('5815','2013-01-26','15:10:00',1.23),('5815','2013-01-26','15:15:00',1.17),('5815','2013-01-26','15:20:00',1.12),('5815','2013-01-26','15:25:00',1.08),('5815','2013-01-26','15:30:00',1.05),('5815','2013-01-24','09:00:00',1.04),('5815','2013-01-24','09:15:00',1.14),('5815','2013-01-24','09:20:00',1.22),('5815','2013-01-24','09:25:00',1.3),('5815','2013-01-24','09:30:00',1.36),('5815','2013-01-24','09:35:00',1.34),('5815','2013-01-24','09:40:00',1.25),('5815','2013-01-24','09:45:00',1.31),('5815','2013-01-24','09:50:00',1.57),('5815','2013-01-24','09:55:00',1.63),('5815','2013-01-24','10:00:00',1.67),('5815','2013-01-24','10:05:00',1.71),('5815','2013-01-24','10:10:00',1.69),('5815','2013-01-24','10:15:00',1.7),('5815','2013-01-24','10:20:00',1.74),('5815','2013-01-24','10:25:00',1.78),('5815','2013-01-24','10:30:00',1.76),('5815','2013-01-24','10:35:00',1.43),('5815','2013-01-24','10:40:00',1.96),('5815','2013-01-24','10:45:00',1.77),('5815','2013-01-24','10:50:00',1.43),('5815','2013-01-24','10:55:00',2.04),('5815','2013-01-24','11:00:00',1.19),('5815','2013-01-24','11:05:00',1.83),('5815','2013-01-24','11:10:00',1.97),('5815','2013-01-24','11:15:00',2.04),('5815','2013-01-24','11:20:00',2.01),('5815','2013-01-24','11:25:00',2),('5815','2013-01-24','11:30:00',2.03),('5815','2013-01-24','11:35:00',2.06),('5815','2013-01-24','11:40:00',2.07),('5815','2013-01-24','11:45:00',2.07),('5815','2013-01-24','11:50:00',2.12),('5815','2013-01-24','11:55:00',2.11),('5815','2013-01-24','12:00:00',2.09),('5815','2013-01-24','12:05:00',2.09),('5815','2013-01-24','12:10:00',2.12),('5815','2013-01-24','12:15:00',2.13),('5815','2013-01-24','12:20:00',2.14),('5815','2013-01-24','12:25:00',2.16),('5815','2013-01-24','12:30:00',2.16),('5815','2013-01-24','12:35:00',1.87),('5815','2013-01-24','12:40:00',1.88),('5815','2013-01-24','12:45:00',2.01),('5815','2013-01-24','12:50:00',2.07),('5815','2013-01-24','12:55:00',2.03),('5815','2013-01-24','13:00:00',2.05),('5815','2013-01-24','13:05:00',2.02),('5815','2013-01-24','13:10:00',2),('5815','2013-01-24','13:15:00',2),('5815','2013-01-24','13:20:00',2),('5815','2013-01-24','13:25:00',2.02),('5815','2013-01-24','13:30:00',2.06),('5815','2013-01-24','13:35:00',2.04),('5815','2013-01-24','13:40:00',2),('5815','2013-01-24','13:45:00',1.96),('5815','2013-01-24','13:50:00',1.91),('5815','2013-01-24','13:55:00',1.87),('5815','2013-01-24','14:00:00',1.81),('5815','2013-01-24','14:05:00',1.76),('5815','2013-01-24','14:10:00',1.61),('5815','2013-01-24','14:15:00',1.55),('5815','2013-01-24','14:20:00',1.45),('5815','2013-01-24','14:25:00',1.47),('5815','2013-01-24','14:30:00',1.4),('5815','2013-01-24','14:35:00',1.31),('5815','2013-01-24','14:40:00',1.28),('5815','2013-01-24','14:45:00',1.23),('5815','2013-01-24','14:50:00',1.22),('5815','2013-01-24','14:55:00',1.21),('5815','2013-01-24','15:00:00',1.11),('5815','2013-01-24','15:05:00',1.05),('5815','2013-01-24','15:10:00',1.04),('5815','2013-01-24','15:35:00',1.01),('5815','2013-01-23','09:55:00',1.47),('5815','2013-01-23','10:00:00',1.53),('5815','2013-01-23','10:05:00',1.57),('5815','2013-01-23','10:10:00',1.73),('5815','2013-01-23','10:15:00',1.71),('5815','2013-01-23','10:20:00',1.76),('5815','2013-01-23','10:25:00',1.77),('5815','2013-01-23','10:30:00',1.8),('5815','2013-01-23','10:35:00',1.82),('5815','2013-01-23','10:40:00',1.86),('5815','2013-01-23','10:45:00',1.9),('5815','2013-01-23','10:50:00',1.97),('5815','2013-01-23','10:55:00',1.87),('5815','2013-01-23','11:00:00',1.06),('5815','2013-01-23','14:20:00',1.13),('5815','2013-01-23','14:25:00',2.21),('5815','2013-01-23','14:30:00',1.98),('5815','2013-01-23','14:35:00',1.42),('5815','2013-01-23','14:45:00',1.36),('5815','2013-01-23','14:50:00',1.48),('5815','2013-01-23','14:55:00',1.55),('5815','2013-01-23','15:00:00',1.17),('5815','2013-01-23','15:20:00',1.02),('5815','2013-01-23','15:25:00',1.05),('5815','2013-01-23','15:30:00',1.09),('5815','2013-01-22','09:55:00',1.02),('5815','2013-01-22','10:30:00',1.28),('5815','2013-01-22','10:35:00',1.81),('5815','2013-01-22','10:45:00',1.1),('5815','2013-01-22','10:50:00',1.43),('5815','2013-01-22','10:55:00',1.24),('5815','2013-01-21','09:30:00',1.23),('5815','2013-01-21','09:35:00',1.4),('5815','2013-01-21','09:40:00',1.05),('5815','2013-01-21','09:45:00',1.71),('5815','2013-01-21','09:50:00',1.14),('5815','2013-01-21','09:55:00',1.3),('5815','2013-01-21','10:05:00',1.59),('5815','2013-01-21','10:10:00',1.71),('5815','2013-01-21','10:15:00',1.6),('5815','2013-01-21','10:20:00',1.49),('5815','2013-01-21','10:25:00',1.65),('5815','2013-01-21','10:30:00',1.85),('5815','2013-01-21','10:35:00',1.91),('5815','2013-01-21','10:40:00',2.17),('5815','2013-01-21','10:45:00',1.74),('5815','2013-01-21','10:50:00',1.45),('5815','2013-01-21','11:15:00',1.21),('5815','2013-01-21','11:20:00',1.2),('5815','2013-01-21','11:50:00',1.57),('5815','2013-01-21','12:10:00',1.52),('5815','2013-01-21','12:15:00',1.69),('5815','2013-01-21','12:20:00',1.03),('5815','2013-01-21','12:25:00',1.72),('5815','2013-01-21','12:40:00',2.28),('5815','2013-01-21','13:00:00',1.6),('5815','2013-01-21','13:05:00',1.89),('5815','2013-01-21','13:10:00',1.31),('5815','2013-01-21','13:20:00',1.7),('5815','2013-01-21','14:15:00',1.17),('5815','2013-01-21','14:25:00',1.49),('5815','2013-01-21','14:45:00',1.15),('5815','2013-01-20','11:55:00',2.26),('5815','2013-01-20','12:00:00',2.04),('5815','2013-01-20','12:05:00',1.99),('5815','2013-01-20','12:10:00',2.08),('5815','2013-01-20','12:15:00',1.75),('5815','2013-01-20','13:05:00',1.25),('5815','2013-01-20','13:10:00',1),('5815','2013-01-20','13:30:00',1.64),('5815','2013-01-20','13:35:00',2.21),('5815','2013-01-20','13:40:00',1.72),('5815','2013-01-20','13:55:00',1.38),('5815','2013-01-20','14:00:00',1.95),('5815','2013-01-20','14:05:00',1.97),('5815','2013-01-20','14:10:00',1.68),('5815','2013-01-20','14:15:00',1.5),('5815','2013-01-20','14:20:00',1.48),('5815','2013-01-20','14:25:00',1.91),('5815','2013-01-19','11:15:00',1.02),('5815','2013-01-19','11:25:00',1.08),('5815','2013-01-19','11:30:00',1.49),('5815','2013-01-19','11:35:00',1.11),('5815','2013-01-17','10:15:00',1.49),('5815','2013-01-17','10:20:00',1.58),('5815','2013-01-17','12:50:00',1.36),('5815','2013-01-17','12:55:00',1.24),('5815','2013-01-17','13:00:00',1.38),('5815','2013-01-17','13:05:00',1.25),('5815','2013-01-17','13:10:00',1.21),('5815','2013-01-17','13:15:00',1.39),('5815','2013-01-17','13:20:00',1.12),('5815','2013-01-17','13:35:00',1.05),('5815','2013-01-17','13:40:00',1.6),('5815','2013-01-17','13:45:00',1.73),('5815','2013-01-17','13:50:00',2.07),('5815','2013-01-17','13:55:00',1.99),('5815','2013-01-17','14:00:00',1.36),('5815','2013-01-17','14:05:00',1.54),('5815','2013-01-17','14:10:00',1.43),('5815','2013-01-17','14:20:00',1.13),('5815','2013-01-16','10:25:00',1),('5815','2013-01-16','10:30:00',1.09),('5815','2013-01-16','10:55:00',1.13),('5815','2013-01-16','11:10:00',1.22),('5815','2013-01-16','11:15:00',1.18),('5815','2013-01-16','11:20:00',1.11),('5815','2013-01-16','11:55:00',1.04),('5815','2013-01-16','12:00:00',1.18),('5815','2013-01-16','12:05:00',1.15),('5815','2013-01-16','12:10:00',1.07),('5815','2013-01-16','12:15:00',1.31),('5815','2013-01-16','12:20:00',1.12),('5815','2013-01-16','12:25:00',1.03),('5815','2013-01-16','12:35:00',1.03),('5815','2013-01-16','12:40:00',1.11),('5815','2013-01-16','13:00:00',1.04),('5815','2013-01-16','13:35:00',1.09),('5815','2013-01-16','13:40:00',1.41),('5815','2013-01-16','13:45:00',1.57),('5815','2013-01-16','13:50:00',1.43),('5815','2013-01-16','14:35:00',1.1),('5815','2013-01-15','09:25:00',1.12),('5815','2013-01-15','09:30:00',1.22),('5815','2013-01-15','09:35:00',1.29),('5815','2013-01-15','09:40:00',1.39),('5815','2013-01-15','10:35:00',1.2),('5815','2013-01-15','10:40:00',1.45),('5815','2013-01-15','10:45:00',1.62),('5815','2013-01-15','10:55:00',1.45),('5815','2013-01-15','12:15:00',2.2),('5815','2013-01-15','12:20:00',2.22),('5815','2013-01-15','13:05:00',1.13),('5815','2013-01-15','13:10:00',2.25),('5815','2013-01-15','13:15:00',2.52),('5815','2013-01-15','13:20:00',2.07),('5815','2013-01-15','13:25:00',1.2),('5815','2013-01-15','13:55:00',1.56),('5815','2013-01-15','14:00:00',1.13),('5815','2013-01-14','14:05:00',1.52),('5815','2013-01-14','14:10:00',1.88),('5815','2013-01-14','14:15:00',1.92),('5815','2013-01-14','14:20:00',1.91),('5815','2013-01-14','14:25:00',1.51),('5815','2013-01-14','14:35:00',1.24),('5815','2013-01-14','14:45:00',1.35),('5815','2013-01-14','14:50:00',1.31),('5815','2013-01-14','14:55:00',1.41),('5815','2013-01-14','15:00:00',1.39),('5815','2013-01-14','15:05:00',1.28),('5815','2013-01-14','15:10:00',1.11),('5815','2013-01-13','15:15:00',1.01),('5815','2013-01-12','09:15:00',1.07),('5815','2013-01-12','09:20:00',1.14),('5815','2013-01-12','09:25:00',1.12),('5815','2013-01-12','09:30:00',1.17),('5815','2013-01-12','09:35:00',1.22),('5815','2013-01-12','09:55:00',1.21),('5815','2013-01-12','10:00:00',1.25),('5815','2013-01-12','10:05:00',1.34),('5815','2013-01-12','10:25:00',1.02),('5815','2013-01-12','10:30:00',1.16),('5815','2013-01-11','09:20:00',1.02),('5815','2013-01-11','09:25:00',1.08),('5815','2013-01-11','09:30:00',1.12),('5815','2013-01-11','09:35:00',1.16),('5815','2013-01-11','09:40:00',1.21),('5815','2013-01-11','09:45:00',1.25),('5815','2013-01-11','09:50:00',1.3),('5815','2013-01-11','09:55:00',1.33),('5815','2013-01-11','10:00:00',1.38),('5815','2013-01-11','10:05:00',1.43),('5815','2013-01-11','10:10:00',1.44),('5815','2013-01-11','10:15:00',1.45),('5815','2013-01-11','10:20:00',1.48),('5815','2013-01-11','10:25:00',1.53),('5815','2013-01-11','10:30:00',1.57),('5815','2013-01-11','10:35:00',1.58),('5815','2013-01-11','10:40:00',1.62),('5815','2013-01-11','10:45:00',1.64),('5815','2013-01-11','10:50:00',1.65),('5815','2013-01-11','10:55:00',1.66),('5815','2013-01-11','11:00:00',1.63),('5815','2013-01-11','11:05:00',1.73),('5815','2013-01-11','11:10:00',1.72),('5815','2013-01-11','11:15:00',1.74),('5815','2013-01-11','11:20:00',1.75),('5815','2013-01-11','11:25:00',1.78),('5815','2013-01-11','11:30:00',1.78),('5815','2013-01-11','11:35:00',1.79),('5815','2013-01-11','11:40:00',1.79),('5815','2013-01-11','11:45:00',1.8),('5815','2013-01-11','11:50:00',1.82),('5815','2013-01-11','11:55:00',1.84),('5815','2013-01-11','12:00:00',1.84),('5815','2013-01-11','12:05:00',1.84),('5815','2013-01-11','12:10:00',1.82),('5815','2013-01-11','12:15:00',1.81),('5815','2013-01-11','12:20:00',1.8),('5815','2013-01-11','12:25:00',1.77),('5815','2013-01-11','12:30:00',1.8),('5815','2013-01-11','12:35:00',1.56),('5815','2013-01-11','12:40:00',1.36),('5815','2013-01-11','12:50:00',1.26),('5815','2013-01-11','12:55:00',1.25),('5815','2013-01-11','13:00:00',1.6),('5815','2013-01-11','13:05:00',1.73),('5815','2013-01-11','13:10:00',1.55),('5815','2013-01-11','13:25:00',1.41),('5815','2013-01-11','13:30:00',1.7),('5815','2013-01-11','13:35:00',1.66),('5815','2013-01-11','13:50:00',1.09),('5815','2013-01-11','13:55:00',1.71),('5815','2013-01-11','14:00:00',1.16),('5815','2013-01-11','14:10:00',1.6),('5815','2013-01-11','14:15:00',1.6),('5815','2013-01-11','14:20:00',1.47),('5815','2013-01-11','14:25:00',1.43),('5815','2013-01-11','14:30:00',1.36),('5815','2013-01-11','14:35:00',1.33),('5815','2013-01-11','14:40:00',1.32),('5815','2013-01-11','14:45:00',1.28),('5815','2013-01-11','14:50:00',1.2),('5815','2013-01-11','14:55:00',1.17),('5815','2013-01-11','15:00:00',1.12),('5815','2013-01-11','15:05:00',1.06),('5815','2013-01-10','10:15:00',1.16),('5815','2013-01-10','10:25:00',1.53),('5815','2013-01-10','10:30:00',1.54),('5815','2013-01-10','10:35:00',1.56),('5815','2013-01-10','10:40:00',1.58),('5815','2013-01-10','10:45:00',1.6),('5815','2013-01-10','10:50:00',1.64),('5815','2013-01-10','10:55:00',1.66),('5815','2013-01-10','11:00:00',1.69),('5815','2013-01-10','11:05:00',1.7),('5815','2013-01-10','11:10:00',1.7),('5815','2013-01-10','11:15:00',1.68),('5815','2013-01-10','11:20:00',1.7),('5815','2013-01-10','11:25:00',1.27),('5815','2013-01-10','13:10:00',1.02),('5815','2013-01-10','13:35:00',1.46),('5815','2013-01-10','13:40:00',1.17),('5815','2013-01-10','13:45:00',1.49),('5815','2013-01-10','14:50:00',1.18),('5815','2013-01-10','14:55:00',1.13),('5815','2013-01-10','15:00:00',1.16),('5815','2013-01-10','15:05:00',1.16),('5815','2013-01-08','11:15:00',1.34),('5815','2013-01-08','11:20:00',1.07),('5815','2013-01-08','13:10:00',1.4),('5815','2013-01-07','08:55:00',1.02),('5815','2013-01-07','09:00:00',1.06),('5815','2013-01-07','09:05:00',1.08),('5815','2013-01-07','09:20:00',1.08),('5815','2013-01-07','09:25:00',1.16),('5815','2013-01-07','09:30:00',1.03),('5815','2013-01-07','09:40:00',1.22),('5815','2013-01-07','09:45:00',1.41),('5815','2013-01-07','09:50:00',1.47),('5815','2013-01-07','09:55:00',1.43),('5815','2013-01-07','10:00:00',1.3),('5815','2013-01-07','10:05:00',1.29),('5815','2013-01-07','10:10:00',1.34),('5815','2013-01-07','10:15:00',1.38),('5815','2013-01-07','10:20:00',1.31),('5815','2013-01-07','10:25:00',1.41),('5815','2013-01-07','10:30:00',1.41),('5815','2013-01-07','10:35:00',1.53),('5815','2013-01-07','10:40:00',1.63),('5815','2013-01-07','10:45:00',1.59),('5815','2013-01-07','10:50:00',1.64),('5815','2013-01-07','10:55:00',1.66),('5815','2013-01-07','11:00:00',1.63),('5815','2013-01-07','11:05:00',1.71),('5815','2013-01-07','11:10:00',1.73),('5815','2013-01-07','11:15:00',1.73),('5815','2013-01-07','11:20:00',1.73),('5815','2013-01-07','11:25:00',1.75),('5815','2013-01-07','11:30:00',1.77),('5815','2013-01-07','11:35:00',1.79),('5815','2013-01-07','11:40:00',1.73),('5815','2013-01-07','11:45:00',2.01),('5815','2013-01-07','11:50:00',1.47),('5815','2013-01-07','11:55:00',1.08),('5815','2013-01-07','12:45:00',1.11),('5815','2013-01-07','12:50:00',1.54),('5815','2013-01-07','12:55:00',1.08),('5815','2013-01-06','09:25:00',1.04),('5815','2013-01-06','09:30:00',1.07),('5815','2013-01-06','09:35:00',1.12),('5815','2013-01-06','09:40:00',1.15),('5815','2013-01-06','09:45:00',1.21),('5815','2013-01-06','09:50:00',1.25),('5815','2013-01-06','09:55:00',1.3),('5815','2013-01-06','10:00:00',1.34),('5815','2013-01-06','10:05:00',1.4),('5815','2013-01-06','10:10:00',1.45),('5815','2013-01-06','10:15:00',1.49),('5815','2013-01-06','10:20:00',1.51),('5815','2013-01-06','10:25:00',1.55),('5815','2013-01-06','10:30:00',1.57),('5815','2013-01-06','10:35:00',1.58),('5815','2013-01-06','10:40:00',1.59),('5815','2013-01-06','10:45:00',1.6),('5815','2013-01-06','10:50:00',1.62),('5815','2013-01-06','10:55:00',1.6),('5815','2013-01-06','11:00:00',1.64),('5815','2013-01-06','11:05:00',1.64),('5815','2013-01-06','11:10:00',1.69),('5815','2013-01-06','11:15:00',1.72),('5815','2013-01-06','11:20:00',1.72),('5815','2013-01-06','11:25:00',1.74),('5815','2013-01-06','11:30:00',1.75),('5815','2013-01-06','11:35:00',1.76),('5815','2013-01-06','11:40:00',1.76),('5815','2013-01-06','11:45:00',1.77),('5815','2013-01-06','11:50:00',1.79),('5815','2013-01-06','11:55:00',1.81),('5815','2013-01-06','12:00:00',1.81),('5815','2013-01-06','12:05:00',1.81),('5815','2013-01-06','12:10:00',1.82),('5815','2013-01-06','12:15:00',1.81),('5815','2013-01-06','12:20:00',1.8),('5815','2013-01-06','12:25:00',1.81),('5815','2013-01-06','12:30:00',1.8),('5815','2013-01-06','12:35:00',1.79),('5815','2013-01-06','12:40:00',1.79),('5815','2013-01-06','12:45:00',1.78),('5815','2013-01-06','12:50:00',1.76),('5815','2013-01-06','12:55:00',1.76),('5815','2013-01-06','13:00:00',1.75),('5815','2013-01-06','13:05:00',1.73),('5815','2013-01-06','13:10:00',1.71),('5815','2013-01-06','13:15:00',1.68),('5815','2013-01-06','13:20:00',1.68),('5815','2013-01-06','13:25:00',1.67),('5815','2013-01-06','13:30:00',1.64),('5815','2013-01-06','13:35:00',1.63),('5815','2013-01-06','13:40:00',1.6),('5815','2013-01-06','13:45:00',1.59),('5815','2013-01-06','13:50:00',1.56),('5815','2013-01-06','13:55:00',1.55),('5815','2013-01-06','14:00:00',1.54),('5815','2013-01-06','14:05:00',1.51),('5815','2013-01-06','14:10:00',1.47),('5815','2013-01-06','14:15:00',1.44),('5815','2013-01-06','14:20:00',1.44),('5815','2013-01-06','14:25:00',1.39),('5815','2013-01-06','14:30:00',1.35),('5815','2013-01-06','14:35:00',1.32),('5815','2013-01-06','14:40:00',1.29),('5815','2013-01-06','14:45:00',1.25),('5815','2013-01-06','14:50:00',1.23),('5815','2013-01-06','14:55:00',1.15),('5815','2013-01-06','15:00:00',1.09),('5815','2013-01-06','15:05:00',1.06),('5815','2013-01-06','15:10:00',1.02),('5815','2013-01-05','09:15:00',1.01),('5815','2013-01-05','09:20:00',1.06),('5815','2013-01-05','09:25:00',1.11),('5815','2013-01-05','09:30:00',1.15),('5815','2013-01-05','09:35:00',1.19),('5815','2013-01-05','09:40:00',1.23),('5815','2013-01-05','09:45:00',1.27),('5815','2013-01-05','09:50:00',1.32),('5815','2013-01-05','09:55:00',1.33),('5815','2013-01-05','10:00:00',1.37),('5815','2013-01-05','10:05:00',1.39),('5815','2013-01-05','10:10:00',1.43),('5815','2013-01-05','10:15:00',1.47),('5815','2013-01-05','10:20:00',1.48),('5815','2013-01-05','10:25:00',1.54),('5815','2013-01-05','10:30:00',1.57),('5815','2013-01-05','10:35:00',1.6),('5815','2013-01-05','10:40:00',1.63),('5815','2013-01-05','10:45:00',1.65),('5815','2013-01-05','10:50:00',1.66),('5815','2013-01-05','10:55:00',1.68),('5815','2013-01-05','11:00:00',1.69),('5815','2013-01-05','11:05:00',1.71),('5815','2013-01-05','11:10:00',1.73),('5815','2013-01-05','11:15:00',1.74),('5815','2013-01-05','11:20:00',1.76),('5815','2013-01-05','11:25:00',1.78),('5815','2013-01-05','11:30:00',1.77),('5815','2013-01-05','11:35:00',1.8),('5815','2013-01-05','11:40:00',1.8),('5815','2013-01-05','11:45:00',1.81),('5815','2013-01-05','11:50:00',1.82),('5815','2013-01-05','11:55:00',1.83),('5815','2013-01-05','12:00:00',1.84),('5815','2013-01-05','12:05:00',1.85),('5815','2013-01-05','12:10:00',1.84),('5815','2013-01-05','12:15:00',1.84),('5815','2013-01-05','12:20:00',1.84),('5815','2013-01-05','12:25:00',1.81),('5815','2013-01-05','12:30:00',1.81),('5815','2013-01-05','12:35:00',1.79),('5815','2013-01-05','12:40:00',1.8),('5815','2013-01-05','12:45:00',1.79),('5815','2013-01-05','12:50:00',1.81),('5815','2013-01-05','12:55:00',1.81),('5815','2013-01-05','13:00:00',1.78),('5815','2013-01-05','13:05:00',1.81),('5815','2013-01-05','13:10:00',1.8),('5815','2013-01-05','13:15:00',1.77),('5815','2013-01-05','13:20:00',1.75),('5815','2013-01-05','13:25:00',1.74),('5815','2013-01-05','13:30:00',1.72),('5815','2013-01-05','13:35:00',1.71),('5815','2013-01-05','13:40:00',1.69),('5815','2013-01-05','13:45:00',1.66),('5815','2013-01-05','13:50:00',1.63),('5815','2013-01-05','13:55:00',1.58),('5815','2013-01-05','14:00:00',1.6),('5815','2013-01-05','14:05:00',1.49),('5815','2013-01-05','14:10:00',1.33),('5815','2013-01-05','14:15:00',1.07),('5815','2013-01-05','14:20:00',1.32),('5815','2013-01-05','14:25:00',1.34),('5815','2013-01-05','14:30:00',1.35),('5815','2013-01-05','14:35:00',1.29),('5815','2013-01-05','14:40:00',1.24),('5815','2013-01-05','14:45:00',1.23),('5815','2013-01-05','14:50:00',1.17),('5815','2013-01-05','14:55:00',1.1),('5815','2013-01-05','15:00:00',1.05),('5815','2013-01-05','15:05:00',1.01),('5815','2013-01-04','10:55:00',1.44),('5815','2013-01-04','11:00:00',1.21),('5815','2013-01-04','11:05:00',1.45),('5815','2013-01-04','11:10:00',1.4),('5815','2013-01-04','11:15:00',1.19),('5815','2013-01-04','11:20:00',1.57),('5815','2013-01-04','11:25:00',1.62),('5815','2013-01-04','11:30:00',1.6),('5815','2013-01-04','11:35:00',1.46),('5815','2013-01-04','11:40:00',1.31),('5815','2013-01-04','11:45:00',1.3),('5815','2013-01-04','11:50:00',1.13),('5815','2013-01-04','11:55:00',1.02),('5815','2013-01-04','12:35:00',1.04),('5815','2013-01-04','12:40:00',1.27),('5815','2013-01-04','12:45:00',1.41),('5815','2013-01-04','13:30:00',1.14),('5815','2013-01-04','13:35:00',1.01),('5815','2013-01-04','14:05:00',1.05),('5815','2013-01-03','09:55:00',1.22),('5815','2013-01-03','10:00:00',1.43),('5815','2013-01-03','10:05:00',1.46),('5815','2013-01-03','10:10:00',1.24),('5815','2013-01-03','10:15:00',1.46),('5815','2013-01-03','10:20:00',1.21),('5815','2013-01-03','10:25:00',1.54),('5815','2013-01-03','10:30:00',1.58),('5815','2013-01-03','10:35:00',1.6),('5815','2013-01-03','10:40:00',1.64),('5815','2013-01-03','10:45:00',1.7),('5815','2013-01-03','10:50:00',1.77),('5815','2013-01-03','10:55:00',1.78),('5815','2013-01-03','11:00:00',1.55),('5815','2013-01-03','11:45:00',1.17),('5815','2013-01-03','11:50:00',1.74),('5815','2013-01-03','11:55:00',1.99),('5815','2013-01-03','12:00:00',1.99),('5815','2013-01-03','12:05:00',1.7),('5815','2013-01-03','12:10:00',1.34),('5815','2013-01-03','12:30:00',1.34),('5815','2013-01-03','12:35:00',1.25),('5815','2013-01-03','12:40:00',1.77),('5815','2013-01-03','12:45:00',1.88),('5815','2013-01-03','12:50:00',1.87),('5815','2013-01-03','12:55:00',1.86),('5815','2013-01-03','13:00:00',1.8),('5815','2013-01-03','13:05:00',1.74),('5815','2013-01-03','13:10:00',1.73),('5815','2013-01-03','13:15:00',1.52),('5815','2013-01-03','13:20:00',1.69),('5815','2013-01-03','13:25:00',1.66),('5815','2013-01-03','13:30:00',1.64),('5815','2013-01-03','13:35:00',1.6),('5815','2013-01-03','13:40:00',1.58),('5815','2013-01-03','13:45:00',1.53),('5815','2013-01-03','13:50:00',1.47),('5815','2013-01-03','13:55:00',1.45),('5815','2013-01-03','14:00:00',1.42),('5815','2013-01-03','14:05:00',1.41),('5815','2013-01-03','14:10:00',1.41),('5815','2013-01-03','14:15:00',1.37),('5815','2013-01-03','14:20:00',1.32),('5815','2013-01-03','14:25:00',1.28),('5815','2013-01-03','14:30:00',1.23),('5815','2013-01-03','14:35:00',1.21),('5815','2013-01-03','14:40:00',1.19),('5815','2013-01-03','14:45:00',1.15),('5815','2013-01-03','14:50:00',1.08),('5815','2013-01-03','14:55:00',1.08),('5815','2013-01-03','15:00:00',1.04),('5815','2013-01-02','09:20:00',1.05),('5815','2013-01-02','09:25:00',1.09),('5815','2013-01-02','09:30:00',1.14),('5815','2013-01-02','09:35:00',1.19),('5815','2013-01-02','09:40:00',1.27),('5815','2013-01-02','09:45:00',1.37),('5815','2013-01-02','09:50:00',1.47),('5815','2013-01-02','09:55:00',1.56),('5815','2013-01-02','10:00:00',1.64),('5815','2013-01-02','10:05:00',1.58),('5815','2013-01-02','10:10:00',1.68),('5815','2013-01-02','10:15:00',1.8),('5815','2013-01-02','10:20:00',1.38),('5815','2013-01-02','10:25:00',1.31),('5815','2013-01-02','10:30:00',1.23),('5815','2013-01-02','10:35:00',1.33),('5815','2013-01-02','10:40:00',1.16),('5815','2013-01-02','10:45:00',1.06),('5815','2013-01-02','10:50:00',1.02),('5815','2013-01-02','11:00:00',1.05),('5815','2013-01-02','11:05:00',1.03),('5815','2013-01-02','11:35:00',1.68),('5815','2013-01-02','11:40:00',1.93),('5815','2013-01-02','11:45:00',1.92),('5815','2013-01-02','11:50:00',1.88),('5815','2013-01-02','11:55:00',1.86),('5815','2013-01-02','12:00:00',1.85),('5815','2013-01-02','12:05:00',1.85),('5815','2013-01-02','12:10:00',1.85),('5815','2013-01-02','12:15:00',1.84),('5815','2013-01-02','12:20:00',1.84),('5815','2013-01-02','12:25:00',1.84),('5815','2013-01-02','12:30:00',1.84),('5815','2013-01-02','12:35:00',1.84),('5815','2013-01-02','12:40:00',1.83),('5815','2013-01-02','12:45:00',1.82),('5815','2013-01-02','12:50:00',1.8),('5815','2013-01-02','12:55:00',1.8),('5815','2013-01-02','13:00:00',1.78),('5815','2013-01-02','13:05:00',1.77),('5815','2013-01-02','13:10:00',1.75),('5815','2013-01-02','13:15:00',1.73),('5815','2013-01-02','13:20:00',1.72),('5815','2013-01-02','13:25:00',1.7),('5815','2013-01-02','13:30:00',1.67),('5815','2013-01-02','13:35:00',1.66),('5815','2013-01-02','13:40:00',1.64),('5815','2013-01-02','13:45:00',1.62),('5815','2013-01-02','13:50:00',1.6),('5815','2013-01-02','13:55:00',1.57),('5815','2013-01-02','14:00:00',1.55),('5815','2013-01-02','14:05:00',1.52),('5815','2013-01-02','14:10:00',1.5),('5815','2013-01-02','14:15:00',1.47),('5815','2013-01-02','14:20:00',1.44),('5815','2013-01-02','14:25:00',1.4),('5815','2013-01-02','14:30:00',1.36),('5815','2013-01-02','14:35:00',1.3),('5815','2013-01-02','14:40:00',1.28),('5815','2013-01-02','14:45:00',1.24),('5815','2013-01-02','14:50:00',1.2),('5815','2013-01-02','14:55:00',1.16),('5815','2013-01-02','15:00:00',1.11),('5815','2013-01-02','15:05:00',1.05),('5815','2013-01-02','15:10:00',1),('5815','2012-12-31','09:25:00',1.04),('5815','2012-12-31','09:30:00',1.08),('5815','2012-12-31','09:35:00',1.12),('5815','2012-12-31','09:40:00',1.16),('5815','2012-12-31','09:45:00',1.2),('5815','2012-12-31','09:50:00',1.24),('5815','2012-12-31','09:55:00',1.28),('5815','2012-12-31','10:00:00',1.29),('5815','2012-12-31','10:05:00',1.33),('5815','2012-12-31','10:10:00',1.37),('5815','2012-12-31','10:15:00',1.4),('5815','2012-12-31','10:20:00',1.44),('5815','2012-12-31','10:25:00',1.47),('5815','2012-12-31','10:30:00',1.5),('5815','2012-12-31','10:35:00',1.53),('5815','2012-12-31','10:40:00',1.57),('5815','2012-12-31','10:45:00',1.49),('5815','2012-12-31','10:50:00',1.39),('5815','2012-12-31','11:05:00',1.72),('5815','2012-12-31','11:10:00',1.76),('5815','2012-12-31','11:15:00',1.74),('5815','2012-12-31','11:20:00',1.32),('5815','2012-12-31','11:25:00',1.48),('5815','2012-12-31','11:30:00',1.9),('5815','2012-12-31','11:45:00',1.56),('5815','2012-12-31','11:50:00',1.72),('5815','2012-12-31','11:55:00',1.68),('5815','2012-12-30','09:20:00',1.1),('5815','2012-12-30','09:25:00',1.21),('5815','2012-12-30','09:30:00',1.04),('5815','2012-12-30','10:10:00',1.19),('5815','2012-12-30','10:15:00',1.62),('5815','2012-12-30','10:20:00',1.63),('5815','2012-12-30','10:25:00',1.63),('5815','2012-12-30','10:30:00',1.64),('5815','2012-12-30','10:35:00',1.65),('5815','2012-12-30','10:40:00',1.68),('5815','2012-12-30','10:45:00',1.67),('5815','2012-12-30','10:50:00',1.66),('5815','2012-12-30','10:55:00',1.69),('5815','2012-12-30','11:00:00',1.72),('5815','2012-12-30','11:05:00',1.73),('5815','2012-12-30','11:10:00',1.69),('5815','2012-12-30','11:15:00',1.69),('5815','2012-12-30','11:20:00',1.76),('5815','2012-12-30','11:25:00',1.8),('5815','2012-12-30','11:30:00',1.82),('5815','2012-12-30','11:35:00',1.82),('5815','2012-12-30','11:40:00',1.85),('5815','2012-12-30','11:45:00',1.85),('5815','2012-12-30','11:50:00',1.85),('5815','2012-12-30','11:55:00',1.86),('5815','2012-12-30','12:00:00',1.89),('5815','2012-12-30','12:05:00',1.91),('5815','2012-12-30','12:10:00',1.91),('5815','2012-12-30','12:15:00',1.91),('5815','2012-12-30','12:20:00',1.9),('5815','2012-12-30','12:25:00',1.89),('5815','2012-12-30','12:30:00',1.88),('5815','2012-12-30','12:35:00',1.88),('5815','2012-12-30','12:40:00',1.87),('5815','2012-12-30','12:45:00',1.85),('5815','2012-12-30','12:50:00',1.83),('5815','2012-12-30','12:55:00',1.84),('5815','2012-12-30','13:00:00',1.82),('5815','2012-12-30','13:05:00',1.81),('5815','2012-12-30','13:10:00',1.8),('5815','2012-12-30','13:15:00',1.78),('5815','2012-12-30','13:20:00',1.76),('5815','2012-12-30','13:25:00',1.75),('5815','2012-12-30','13:30:00',1.72),('5815','2012-12-30','13:35:00',1.7),('5815','2012-12-30','13:40:00',1.67),('5815','2012-12-30','13:45:00',1.64),('5815','2012-12-30','13:50:00',1.61),('5815','2012-12-30','13:55:00',1.59),('5815','2012-12-30','14:00:00',1.57),('5815','2012-12-30','14:05:00',1.53),('5815','2012-12-30','14:10:00',1.5),('5815','2012-12-30','14:15:00',1.46),('5815','2012-12-30','14:20:00',1.41),('5815','2012-12-30','14:25:00',1.39),('5815','2012-12-30','14:30:00',1.37),('5815','2012-12-30','14:35:00',1.33),('5815','2012-12-30','14:40:00',1.29),('5815','2012-12-30','14:45:00',1.25),('5815','2012-12-30','14:50:00',1.21),('5815','2012-12-30','14:55:00',1.16),('5815','2012-12-30','15:00:00',1.1),('5815','2012-12-30','15:05:00',1.06),('5815','2012-12-30','15:10:00',1.01),('5815','2012-12-29','09:15:00',1.02),('5815','2012-12-29','09:20:00',1.07),('5815','2012-12-29','09:25:00',1.12),('5815','2012-12-29','09:30:00',1.16),('5815','2012-12-29','09:35:00',1.2),('5815','2012-12-29','09:40:00',1.25),('5815','2012-12-29','09:45:00',1.29),('5815','2012-12-29','09:50:00',1.31),('5815','2012-12-29','09:55:00',1.35),('5815','2012-12-29','10:00:00',1.39),('5815','2012-12-29','10:05:00',1.43),('5815','2012-12-29','10:10:00',1.47),('5815','2012-12-29','10:15:00',1.49),('5815','2012-12-29','10:20:00',1.53),('5815','2012-12-29','10:25:00',1.56),('5815','2012-12-29','10:30:00',1.59),('5815','2012-12-29','10:35:00',1.62),('5815','2012-12-29','10:40:00',1.64),('5815','2012-12-29','10:45:00',1.67),('5815','2012-12-29','10:50:00',1.68),('5815','2012-12-29','10:55:00',1.7),('5815','2012-12-29','11:00:00',1.71),('5815','2012-12-29','11:05:00',1.73),('5815','2012-12-29','11:10:00',1.75),('5815','2012-12-29','11:15:00',1.77),('5815','2012-12-29','11:20:00',1.78),('5815','2012-12-29','11:25:00',1.78),('5815','2012-12-29','11:30:00',1.79),('5815','2012-12-29','11:35:00',1.82),('5815','2012-12-29','11:40:00',1.82),('5815','2012-12-29','11:45:00',1.84),('5815','2012-12-29','11:50:00',1.84),('5815','2012-12-29','11:55:00',1.84),('5815','2012-12-29','12:00:00',1.84),('5815','2012-12-29','12:05:00',1.84),('5815','2012-12-29','12:10:00',1.84),('5815','2012-12-29','12:15:00',1.84),('5815','2012-12-29','12:20:00',1.83),('5815','2012-12-29','12:25:00',1.83),('5815','2012-12-29','12:30:00',1.83),('5815','2012-12-29','12:35:00',1.81),('5815','2012-12-29','12:40:00',1.81),('5815','2012-12-29','12:45:00',1.78),('5815','2012-12-29','12:50:00',1.78),('5815','2012-12-29','12:55:00',1.79),('5815','2012-12-29','13:00:00',1.78),('5815','2012-12-29','13:05:00',1.81),('5815','2012-12-29','13:10:00',1.8),('5815','2012-12-29','13:15:00',1.79),('5815','2012-12-29','13:20:00',1.76),('5815','2012-12-29','13:25:00',1.75),('5815','2012-12-29','13:30:00',1.73),('5815','2012-12-29','13:35:00',1.71),('5815','2012-12-29','13:40:00',1.69),('5815','2012-12-29','13:45:00',1.67),('5815','2012-12-29','13:50:00',1.65),('5815','2012-12-29','13:55:00',1.62),('5815','2012-12-29','14:00:00',1.61),('5815','2012-12-29','14:05:00',1.57),('5815','2012-12-29','14:10:00',1.53),('5815','2012-12-29','14:15:00',1.5),('5815','2012-12-29','14:20:00',1.47),('5815','2012-12-29','14:25:00',1.43),('5815','2012-12-29','14:30:00',1.39),('5815','2012-12-29','14:35:00',1.36),('5815','2012-12-29','14:40:00',1.31),('5815','2012-12-29','14:45:00',1.27),('5815','2012-12-29','14:50:00',1.22),('5815','2012-12-29','14:55:00',1.17),('5815','2012-12-29','15:00:00',1.12),('5815','2012-12-29','15:05:00',1.06),('5815','2012-12-29','15:10:00',1.01),('5815','2012-12-28','09:15:00',1.04),('5815','2012-12-28','09:20:00',1.09),('5815','2012-12-28','09:25:00',1.12),('5815','2012-12-28','09:30:00',1.16),('5815','2012-12-28','09:35:00',1.2),('5815','2012-12-28','09:40:00',1.25),('5815','2012-12-28','09:45:00',1.3),('5815','2012-12-28','09:50:00',1.35),('5815','2012-12-28','09:55:00',1.39),('5815','2012-12-28','10:00:00',1.44),('5815','2012-12-28','10:05:00',1.47),('5815','2012-12-28','10:10:00',1.5),('5815','2012-12-28','10:15:00',1.54),('5815','2012-12-28','10:20:00',1.57),('5815','2012-12-28','10:25:00',1.6),('5815','2012-12-28','10:30:00',1.63),('5815','2012-12-28','10:35:00',1.65),('5815','2012-12-28','10:40:00',1.68),('5815','2012-12-28','10:45:00',1.7),('5815','2012-12-28','10:50:00',1.73),('5815','2012-12-28','10:55:00',1.76),('5815','2012-12-28','11:00:00',1.75),('5815','2012-12-28','11:05:00',1.79),('5815','2012-12-28','11:10:00',1.79),('5815','2012-12-28','11:15:00',1.82),('5815','2012-12-28','11:20:00',1.84),('5815','2012-12-28','11:25:00',1.86),('5815','2012-12-28','11:30:00',1.85),('5815','2012-12-28','11:35:00',1.87),('5815','2012-12-28','11:40:00',1.86),('5815','2012-12-28','11:45:00',1.87),('5815','2012-12-28','11:50:00',1.88),('5815','2012-12-28','11:55:00',1.88),('5815','2012-12-28','12:00:00',1.89),('5815','2012-12-28','12:05:00',1.91),('5815','2012-12-28','12:10:00',1.92),('5815','2012-12-28','12:15:00',1.89),('5815','2012-12-28','12:20:00',1.88),('5815','2012-12-28','12:25:00',1.86),('5815','2012-12-28','12:30:00',1.85),('5815','2012-12-28','12:35:00',1.87),('5815','2012-12-28','12:40:00',1.88),('5815','2012-12-28','12:45:00',1.85),('5815','2012-12-28','12:50:00',1.82),('5815','2012-12-28','12:55:00',1.82),('5815','2012-12-28','13:00:00',1.82),('5815','2012-12-28','13:05:00',1.82),('5815','2012-12-28','13:10:00',1.81),('5815','2012-12-28','13:15:00',1.81),('5815','2012-12-28','13:20:00',1.79),('5815','2012-12-28','13:25:00',1.76),('5815','2012-12-28','13:30:00',1.74),('5815','2012-12-28','13:35:00',1.73),('5815','2012-12-28','13:40:00',1.71),('5815','2012-12-28','13:45:00',1.66),('5815','2012-12-28','13:50:00',1.66),('5815','2012-12-28','13:55:00',1.63),('5815','2012-12-28','14:00:00',1.61),('5815','2012-12-28','14:05:00',1.58),('5815','2012-12-28','14:10:00',1.54),('5815','2012-12-28','14:15:00',1.52),('5815','2012-12-28','14:20:00',1.5),('5815','2012-12-28','14:25:00',1.46),('5815','2012-12-28','14:30:00',1.41),('5815','2012-12-28','14:35:00',1.37),('5815','2012-12-28','14:40:00',1.33),('5815','2012-12-28','14:45:00',1.3),('5815','2012-12-28','14:50:00',1.26),('5815','2012-12-28','14:55:00',1.21),('5815','2012-12-28','15:00:00',1.17),('5815','2012-12-28','15:05:00',1.12),('5815','2012-12-28','15:10:00',1.07),('5815','2012-12-28','15:15:00',1.01),('5815','2012-12-27','09:25:00',1.02),('5815','2012-12-27','09:30:00',1.07),('5815','2012-12-27','09:35:00',1.11),('5815','2012-12-27','09:40:00',1.16),('5815','2012-12-27','09:45:00',1.19),('5815','2012-12-27','09:50:00',1.17),('5815','2012-12-27','09:55:00',1.26),('5815','2012-12-27','10:00:00',1.29),('5815','2012-12-27','10:05:00',1.33),('5815','2012-12-27','10:10:00',1.39),('5815','2012-12-27','10:15:00',1.44),('5815','2012-12-27','10:20:00',1.46),('5815','2012-12-27','10:25:00',1.5),('5815','2012-12-27','10:30:00',1.52),('5815','2012-12-27','10:35:00',1.57),('5815','2012-12-27','10:40:00',1.57),('5815','2012-12-27','10:45:00',1.61),('5815','2012-12-27','10:50:00',1.63),('5815','2012-12-27','10:55:00',1.65),('5815','2012-12-27','11:00:00',1.68),('5815','2012-12-27','11:05:00',1.73),('5815','2012-12-27','11:10:00',1.64),('5815','2012-12-27','11:15:00',1.49),('5815','2012-12-27','11:20:00',1.76),('5815','2012-12-27','11:25:00',1.78),('5815','2012-12-27','11:30:00',1.78),('5815','2012-12-27','11:35:00',1.81),('5815','2012-12-27','11:40:00',1.81),('5815','2012-12-27','11:45:00',1.85),('5815','2012-12-27','11:50:00',1.74),('5815','2012-12-27','11:55:00',1.85),('5815','2012-12-27','12:00:00',1.85),('5815','2012-12-27','12:05:00',1.85),('5815','2012-12-27','12:10:00',1.83),('5815','2012-12-27','12:15:00',1.83),('5815','2012-12-27','12:20:00',1.82),('5815','2012-12-27','12:25:00',1.82),('5815','2012-12-27','12:30:00',1.8),('5815','2012-12-27','12:35:00',1.78),('5815','2012-12-27','12:40:00',1.54),('5815','2012-12-27','12:45:00',1.75),('5815','2012-12-27','12:50:00',1.8),('5815','2012-12-27','12:55:00',1.76),('5815','2012-12-27','13:00:00',1.71),('5815','2012-12-27','13:05:00',1.72),('5815','2012-12-27','13:10:00',1.67),('5815','2012-12-27','13:15:00',1.67),('5815','2012-12-27','13:20:00',1.65),('5815','2012-12-27','13:25:00',1.64),('5815','2012-12-27','13:30:00',1.62),('5815','2012-12-27','13:35:00',1.59),('5815','2012-12-27','13:40:00',1.57),('5815','2012-12-27','13:45:00',1.56),('5815','2012-12-27','13:50:00',1.54),('5815','2012-12-27','13:55:00',1.51),('5815','2012-12-27','14:00:00',1.48),('5815','2012-12-27','14:05:00',1.42),('5815','2012-12-27','14:10:00',1.36),('5815','2012-12-27','14:15:00',1.18),('5815','2012-12-27','14:20:00',1.34),('5815','2012-12-27','14:25:00',1.3),('5815','2012-12-27','14:30:00',1.25),('5815','2012-12-27','14:35:00',1.16),('5815','2012-12-27','14:45:00',1.12),('5815','2012-12-27','14:50:00',1.08),('5815','2012-12-27','14:55:00',1.04),('5815','2012-12-27','15:00:00',1.02),('5815','2012-12-26','09:40:00',1.17),('5815','2012-12-26','09:45:00',1.23),('5815','2012-12-26','09:50:00',1.27),('5815','2012-12-26','10:15:00',1.05),('5815','2012-12-26','10:20:00',1.34),('5815','2012-12-26','10:25:00',1.42),('5815','2012-12-26','10:30:00',1.38),('5815','2012-12-26','10:35:00',1.45),('5815','2012-12-26','10:40:00',1.49),('5815','2012-12-26','10:45:00',1.49),('5815','2012-12-26','10:50:00',1.53),('5815','2012-12-26','10:55:00',1.45),('5815','2012-12-26','11:00:00',1.48),('5815','2012-12-26','11:05:00',1.37),('5815','2012-12-26','11:50:00',1.08),('5815','2012-12-26','11:55:00',1.7),('5815','2012-12-26','12:00:00',1.76),('5815','2012-12-26','12:05:00',1.85),('5815','2012-12-26','12:10:00',1.95),('5815','2012-12-26','12:15:00',1.78),('5815','2012-12-26','12:25:00',1.69),('5815','2012-12-26','12:30:00',1.77),('5815','2012-12-26','12:35:00',1.77),('5815','2012-12-26','12:40:00',1.77),('5815','2012-12-26','12:45:00',1.79),('5815','2012-12-26','12:55:00',1.82),('5815','2012-12-26','13:00:00',1.85),('5815','2012-12-26','13:05:00',1.4),('5815','2012-12-26','14:15:00',1.18),('5815','2012-12-26','14:20:00',1.34),('5815','2012-12-26','14:25:00',1.34),('5815','2012-12-26','14:30:00',1.29),('5815','2012-12-26','14:35:00',1.26),('5815','2012-12-26','14:40:00',1.21),('5815','2012-12-26','14:45:00',1.09),('5815','2012-12-26','15:00:00',1.07),('5815','2012-12-26','15:05:00',1.01),('5815','2012-12-25','09:20:00',1.04),('5815','2012-12-25','09:25:00',1.07),('5815','2012-12-25','09:30:00',1.1),('5815','2012-12-25','09:35:00',1.13),('5815','2012-12-25','09:40:00',1.17),('5815','2012-12-25','09:45:00',1.21),('5815','2012-12-25','09:50:00',1.25),('5815','2012-12-25','09:55:00',1.29),('5815','2012-12-25','10:00:00',1.32),('5815','2012-12-25','10:05:00',1.35),('5815','2012-12-25','10:10:00',1.38),('5815','2012-12-25','10:15:00',1.4),('5815','2012-12-25','10:20:00',1.42),('5815','2012-12-25','10:25:00',1.43),('5815','2012-12-25','10:30:00',1.46),('5815','2012-12-25','10:35:00',1.48),('5815','2012-12-25','10:40:00',1.51),('5815','2012-12-25','10:45:00',1.52),('5815','2012-12-25','10:50:00',1.53),('5815','2012-12-25','10:55:00',1.56),('5815','2012-12-25','11:00:00',1.57),('5815','2012-12-25','11:05:00',1.6),('5815','2012-12-25','11:10:00',1.6),('5815','2012-12-25','11:15:00',1.62),('5815','2012-12-25','11:20:00',1.63),('5815','2012-12-25','11:25:00',1.65),('5815','2012-12-25','11:30:00',1.64),('5815','2012-12-25','11:35:00',1.67),('5815','2012-12-25','11:40:00',1.69),('5815','2012-12-25','11:45:00',1.69),('5815','2012-12-25','11:50:00',1.71),('5815','2012-12-25','11:55:00',1.75),('5815','2012-12-25','12:00:00',1.79),('5815','2012-12-25','12:05:00',1.8),('5815','2012-12-25','12:10:00',1.79),('5815','2012-12-25','12:15:00',1.81),('5815','2012-12-25','12:20:00',1.82),('5815','2012-12-25','12:25:00',1.83),('5815','2012-12-25','12:30:00',1.83),('5815','2012-12-25','12:35:00',1.81),('5815','2012-12-25','12:40:00',1.83),('5815','2012-12-25','12:45:00',1.8),('5815','2012-12-25','12:50:00',1.77),('5815','2012-12-25','12:55:00',1.78),('5815','2012-12-25','13:00:00',1.8),('5815','2012-12-25','13:05:00',1.78),('5815','2012-12-25','13:10:00',1.8),('5815','2012-12-25','13:15:00',1.77),('5815','2012-12-25','13:20:00',1.83),('5815','2012-12-25','13:25:00',1.84),('5815','2012-12-25','13:30:00',1.96),('5815','2012-12-25','13:35:00',1.89),('5815','2012-12-25','13:40:00',1.87),('5815','2012-12-25','13:45:00',1.8),('5815','2012-12-25','13:50:00',1.54),('5815','2012-12-25','13:55:00',1.56),('5815','2012-12-25','14:00:00',1.42),('5815','2012-12-25','14:05:00',1.54),('5815','2012-12-22','09:15:00',1),('5815','2012-12-22','09:20:00',1.04),('5815','2012-12-22','09:25:00',1.11),('5815','2012-12-22','09:30:00',1.12),('5815','2012-12-22','09:35:00',1.18),('5815','2012-12-22','09:40:00',1.23),('5815','2012-12-22','09:45:00',1.26),('5815','2012-12-22','09:50:00',1.29),('5815','2012-12-22','09:55:00',1.31),('5815','2012-12-22','10:00:00',1.33),('5815','2012-12-22','10:05:00',1.38),('5815','2012-12-22','10:10:00',1.41),('5815','2012-12-22','10:15:00',1.43),('5815','2012-12-22','10:20:00',1.47),('5815','2012-12-22','10:25:00',1.49),('5815','2012-12-22','10:30:00',1.48),('5815','2012-12-22','10:35:00',1.54),('5815','2012-12-22','10:40:00',1.56),('5815','2012-12-22','10:45:00',1.59),('5815','2012-12-22','10:50:00',1.6),('5815','2012-12-22','10:55:00',1.52),('5815','2012-12-22','11:00:00',1.63),('5815','2012-12-22','11:05:00',1.65),('5815','2012-12-22','11:10:00',1.65),('5815','2012-12-22','11:15:00',1.67),('5815','2012-12-22','11:20:00',1.73),('5815','2012-12-22','11:25:00',1.58),('5815','2012-12-22','11:30:00',1.68),('5815','2012-12-22','11:35:00',1.76),('5815','2012-12-22','11:40:00',1.76),('5815','2012-12-22','11:45:00',1.73),('5815','2012-12-22','11:50:00',1.77),('5815','2012-12-22','11:55:00',1.65),('5815','2012-12-22','12:00:00',1.54),('5815','2012-12-22','12:05:00',1.56),('5815','2012-12-22','12:10:00',1.57),('5815','2012-12-22','12:15:00',1.27),('5815','2012-12-22','12:20:00',1.19),('5815','2012-12-22','12:35:00',1.03),('5815','2012-12-22','12:50:00',1.15),('5815','2012-12-22','12:55:00',1.53),('5815','2012-12-22','13:00:00',1.6),('5815','2012-12-22','13:05:00',1.36),('5815','2012-12-22','13:10:00',1.58),('5815','2012-12-22','13:40:00',1.19),('5815','2012-12-22','13:45:00',1.13),('5815','2012-12-22','13:50:00',1.01),('5815','2012-12-22','14:00:00',1.42),('5815','2012-12-22','14:05:00',1.21),('5815','2012-12-22','14:10:00',1.17),('5815','2012-12-22','14:15:00',1.21),('5815','2012-12-22','14:40:00',1.05),('5815','2012-12-22','14:45:00',1.11),('5815','2014-04-30','08:35:00',1.01),('5815','2014-04-30','08:40:00',1.06),('5815','2014-04-30','08:45:00',1.12),('5815','2014-04-30','08:50:00',1.22),('5815','2014-04-30','08:55:00',1.4),('5815','2014-04-30','09:10:00',1.06),('5815','2014-04-30','09:25:00',1.02),('5815','2014-04-30','09:30:00',1.66),('5815','2014-04-30','09:35:00',1.48),('5815','2014-04-30','09:45:00',1.05),('5815','2014-04-30','10:00:00',1.01),('5815','2014-04-30','10:05:00',1.54),('5815','2014-04-30','10:10:00',1.68),('5815','2014-04-30','10:15:00',1.81),('5815','2014-04-30','10:20:00',1.7),('5815','2014-04-30','10:25:00',2.11),('5815','2014-04-30','10:30:00',1.53),('5815','2014-04-30','10:45:00',2.38),('5815','2014-04-30','10:50:00',2.39),('5815','2014-04-30','10:55:00',1.86),('5815','2014-04-30','11:00:00',1.9),('5815','2014-04-30','11:15:00',1.64),('5815','2014-04-30','11:20:00',2.62),('5815','2014-04-30','11:25:00',1.95),('5815','2014-04-30','11:30:00',2.56),('5815','2014-04-30','11:35:00',1.91),('5815','2014-04-30','11:40:00',2.19),('5815','2014-04-30','11:45:00',2.56),('5815','2014-04-30','11:50:00',1.2),('5815','2014-04-30','11:55:00',2.41),('5815','2014-04-30','12:00:00',2.16),('5815','2014-04-30','12:05:00',2.8),('5815','2014-04-30','12:10:00',2.32),('5815','2014-04-30','12:15:00',1.79),('5815','2014-04-30','12:20:00',1.43),('5815','2014-04-30','12:25:00',2.39),('5815','2014-04-30','12:30:00',2.79),('5815','2014-04-30','12:35:00',2.77),('5815','2014-04-30','12:40:00',2.75),('5815','2014-04-30','12:45:00',2.69),('5815','2014-04-30','12:50:00',2.74),('5815','2014-04-30','12:55:00',2.7),('5815','2014-04-30','13:00:00',2.8),('5815','2014-04-30','13:05:00',2.73),('5815','2014-04-30','13:10:00',2.79),('5815','2014-04-30','13:15:00',2.75),('5815','2014-04-30','13:25:00',2.52),('5815','2014-04-30','13:30:00',2.93),('5815','2014-04-30','13:35:00',2.82),('5815','2014-04-30','13:40:00',2.57),('5815','2014-04-30','13:45:00',1.77),('5815','2014-04-30','13:50:00',1.47),('5815','2014-04-30','14:10:00',2.89),('5815','2014-04-30','14:15:00',2.79),('5815','2014-04-30','14:20:00',2.5),('5815','2014-04-30','14:25:00',2.73),('5815','2014-04-30','14:30:00',2.52),('5815','2014-04-30','14:35:00',2.52),('5815','2014-04-30','14:40:00',2.62),('5815','2014-04-30','14:45:00',1.94),('5815','2014-04-30','14:50:00',2.38),('5815','2014-04-30','14:55:00',2.54),('5815','2014-04-30','15:00:00',2.35),('5815','2014-04-30','15:05:00',2.65),('5815','2014-04-30','15:10:00',1.81),('5815','2014-04-30','15:15:00',2.42),('5815','2014-04-30','15:20:00',2.39),('5815','2014-04-30','15:25:00',2.34),('5815','2014-04-30','15:30:00',2.27),('5815','2014-04-30','15:35:00',2.21),('5815','2014-04-30','15:40:00',2.15),('5815','2014-04-30','15:45:00',2.18),('5815','2014-04-30','15:50:00',2.08),('5815','2014-04-30','15:55:00',2.07),('5815','2014-04-30','16:00:00',2.03),('5815','2014-04-30','16:05:00',2.03),('5815','2014-04-30','16:10:00',1.97),('5815','2014-04-30','16:15:00',1.91),('5815','2014-04-30','16:20:00',1.85),('5815','2014-04-30','16:25:00',1.66),('5815','2014-04-30','16:30:00',1.75),('5815','2014-04-30','16:35:00',1.74),('5815','2014-04-30','16:40:00',1.64),('5815','2014-04-30','16:45:00',1.4),('5815','2014-04-30','16:50:00',1.37),('5815','2014-04-30','16:55:00',1.43),('5815','2014-04-30','17:00:00',1.26),('5815','2014-04-30','17:05:00',1.41),('5815','2014-04-30','17:10:00',1.4),('5815','2014-04-30','17:15:00',1.31),('5815','2014-04-30','17:20:00',1.25),('5815','2014-04-30','17:25:00',1.15),('5815','2014-04-30','17:30:00',1.15),('5815','2014-04-30','17:35:00',1.11),('5815','2014-04-30','17:40:00',1.06),('5815','2012-12-21','10:25:00',1.4),('5815','2012-12-21','10:30:00',1.81),('5815','2012-12-21','10:35:00',1.9),('5815','2012-12-21','10:40:00',1.86),('5815','2012-12-21','10:45:00',1.82),('5815','2012-12-21','10:50:00',1.8),('5815','2012-12-21','10:55:00',1.83),('5815','2012-12-21','11:00:00',1.13),('5815','2012-12-21','11:50:00',1.48),('5815','2012-12-21','12:00:00',1.27),('5815','2012-12-21','12:50:00',1.18),('5815','2012-12-21','13:00:00',1.37),('5815','2012-12-21','13:05:00',1.94),('5815','2012-12-21','13:10:00',2.1),('5815','2012-12-21','13:15:00',2.08),('5815','2012-12-21','13:20:00',2.06),('5815','2012-12-21','13:25:00',2.01),('5815','2012-12-21','13:30:00',1.71),('5815','2012-12-21','13:35:00',1.79),('5815','2012-12-21','13:40:00',1.63),('5815','2012-12-21','14:15:00',1.03),('5815','2012-12-21','14:20:00',1.07),('5815','2012-12-21','15:00:00',1.01),('5815','2014-04-29','08:40:00',1.02),('5815','2014-04-29','08:45:00',1.07),('5815','2014-04-29','08:50:00',1.1),('5815','2014-04-29','08:55:00',1.2),('5815','2014-04-29','09:00:00',1.24),('5815','2014-04-29','09:05:00',1.37),('5815','2014-04-29','09:10:00',1.43),('5815','2014-04-29','09:15:00',1.61),('5815','2014-04-29','09:20:00',1.49),('5815','2014-04-29','09:25:00',1.27),('5815','2014-04-29','09:35:00',1.57),('5815','2014-04-29','09:40:00',1.63),('5815','2014-04-29','09:45:00',1.78),('5815','2014-04-29','09:50:00',1.57),('5815','2014-04-29','09:55:00',1.22),('5815','2014-04-29','10:00:00',2.01),('5815','2014-04-29','10:05:00',1.92),('5815','2014-04-29','10:10:00',1.36),('5815','2014-04-29','10:15:00',1.66),('5815','2014-04-29','10:20:00',1.29),('5815','2014-04-29','10:25:00',1),('5815','2014-04-29','10:35:00',1.26),('5815','2014-04-29','10:40:00',1.34),('5815','2014-04-29','10:55:00',2.05),('5815','2014-04-29','11:00:00',1.38),('5815','2014-04-29','11:05:00',2.18),('5815','2014-04-29','11:10:00',1.95),('5815','2014-04-29','11:15:00',1.55),('5815','2014-04-29','11:20:00',1),('5815','2014-04-29','11:25:00',1.46),('5815','2014-04-29','11:30:00',1.22),('5815','2014-04-29','11:35:00',1.14),('5815','2014-04-29','11:40:00',1.13),('5815','2014-04-29','11:45:00',1.25),('5815','2014-04-29','11:50:00',1.84),('5815','2014-04-29','11:55:00',1.26),('5815','2014-04-29','12:00:00',1.78),('5815','2014-04-29','12:20:00',1.29),('5815','2014-04-29','12:45:00',1.13),('5815','2014-04-29','12:55:00',2.08),('5815','2014-04-29','13:00:00',2.59),('5815','2014-04-29','13:05:00',2.24),('5815','2014-04-29','13:10:00',2.86),('5815','2014-04-29','13:15:00',1.34),('5815','2014-04-29','13:20:00',1.09),('5815','2014-04-29','13:25:00',1.35),('5815','2014-04-29','13:30:00',1.28),('5815','2014-04-29','13:35:00',1.05),('5815','2014-04-29','13:40:00',2.06),('5815','2014-04-29','13:45:00',1.68),('5815','2014-04-29','13:50:00',2.45),('5815','2014-04-29','13:55:00',2.89),('5815','2014-04-29','14:00:00',1.29),('5815','2014-04-29','14:05:00',1.08),('5815','2014-04-29','14:15:00',1.05),('5815','2014-04-29','14:20:00',1.83),('5815','2014-04-29','14:25:00',1.76),('5815','2014-04-29','14:30:00',2.45),('5815','2014-04-29','14:35:00',2.52),('5815','2014-04-29','14:40:00',1.3),('5815','2014-04-29','14:55:00',1.05),('5815','2014-04-29','15:30:00',1.1),('5815','2014-04-29','15:35:00',1.33),('5815','2014-04-29','15:40:00',2.2),('5815','2014-04-29','15:45:00',2.26),('5815','2014-04-29','15:50:00',1.6),('5815','2014-04-29','15:55:00',1.95),('5815','2014-04-29','16:05:00',1.4),('5815','2014-04-29','16:15:00',1.07),('5815','2014-04-29','16:30:00',1.34),('5815','2014-04-29','16:40:00',1.19),('5815','2014-04-29','16:45:00',1.43),('5815','2014-04-29','16:50:00',1.77),('5815','2014-04-29','16:55:00',1.55),('5815','2014-04-29','17:05:00',1.74),('5815','2014-04-28','10:05:00',1.06),('5815','2014-04-28','10:10:00',1.5),('5815','2014-04-28','10:15:00',2.08),('5815','2014-04-28','10:20:00',2.15),('5815','2014-04-28','10:25:00',2.18),('5815','2014-04-28','10:30:00',2.23),('5815','2014-04-28','10:35:00',2.21),('5815','2014-04-28','10:40:00',2.25),('5815','2014-04-28','10:45:00',2.27),('5815','2014-04-28','10:50:00',2.31),('5815','2014-04-27','09:15:00',1.22),('5815','2014-04-27','09:20:00',1.41),('5815','2014-04-27','09:30:00',1.7),('5815','2014-04-27','09:35:00',1.1),('5815','2014-04-27','09:40:00',1.12),('5815','2014-04-27','09:45:00',1.23),('5815','2014-04-27','09:50:00',1.92),('5815','2014-04-27','10:05:00',1.13),('5815','2014-04-27','10:10:00',1.27),('5815','2014-04-27','10:15:00',1.21),('5815','2014-04-27','10:20:00',1.13),('5815','2014-04-27','10:50:00',1.1),('5815','2014-04-27','10:55:00',1.13),('5815','2014-04-27','11:00:00',1.02),('5815','2014-04-27','11:05:00',1.32),('5815','2014-04-27','11:10:00',1.47),('5815','2014-04-27','11:15:00',1.34),('5815','2014-04-27','11:20:00',1.41),('5815','2014-04-27','11:30:00',1.04),('5815','2014-04-27','11:35:00',1.01),('5815','2014-04-27','11:55:00',1.06),('5815','2014-04-27','12:00:00',1),('5815','2014-04-27','12:10:00',1.01),('5815','2014-04-27','12:15:00',1.64),('5815','2014-04-27','12:20:00',1.69),('5815','2014-04-27','12:25:00',1.6),('5815','2014-04-27','12:30:00',1.5),('5815','2014-04-27','12:35:00',1.38),('5815','2014-04-27','12:40:00',1.23),('5815','2014-04-27','12:45:00',1.07),('5815','2014-04-27','12:50:00',1.26),('5815','2014-04-27','12:55:00',1.26),('5815','2014-04-27','13:00:00',1.31),('5815','2014-04-27','13:05:00',1.53),('5815','2014-04-27','13:10:00',2.07),('5815','2014-04-27','13:15:00',1.38),('5815','2014-04-27','13:20:00',1.26),('5815','2014-04-27','13:25:00',1.52),('5815','2014-04-27','13:30:00',2.55),('5815','2014-04-27','13:35:00',1.74),('5815','2014-04-27','13:40:00',2.46),('5815','2014-04-27','13:45:00',1.25),('5815','2014-04-27','13:50:00',2.62),('5815','2014-04-27','13:55:00',2.29),('5815','2014-04-27','14:00:00',1.68),('5815','2014-04-27','14:05:00',1.09),('5815','2014-04-27','14:10:00',2.73),('5815','2014-04-27','14:15:00',2.4),('5815','2014-04-27','14:20:00',2.06),('5815','2014-04-27','14:25:00',1.85),('5815','2014-04-27','14:30:00',2.04),('5815','2014-04-27','14:35:00',2.51),('5815','2014-04-27','14:40:00',1.76),('5815','2014-04-27','14:45:00',1.54),('5815','2014-04-27','14:50:00',1.21),('5815','2014-04-27','14:55:00',1.48),('5815','2014-04-27','15:00:00',1.24),('5815','2014-04-27','15:05:00',1.72),('5815','2014-04-27','15:10:00',1.81),('5815','2014-04-27','15:15:00',1.71),('5815','2014-04-27','15:20:00',1.99),('5815','2014-04-27','15:25:00',1.38),('5815','2014-04-27','15:35:00',1.01),('5815','2014-04-27','15:40:00',1.64),('5815','2014-04-27','15:50:00',2.16),('5815','2014-04-27','16:00:00',2.11),('5815','2014-04-27','16:05:00',2.27),('5815','2014-04-27','16:10:00',1.86),('5815','2014-04-27','16:15:00',1.03),('5815','2014-04-27','16:20:00',1.72),('5815','2014-04-27','16:25:00',1.1),('5815','2014-04-27','16:30:00',1.51),('5815','2014-04-27','16:35:00',1.05),('5815','2014-04-27','16:55:00',1.41),('5815','2014-04-26','11:45:00',1.78),('5815','2014-04-26','11:50:00',1.68),('5815','2014-04-26','11:55:00',1.37),('5815','2014-04-26','12:00:00',1.42),('5815','2014-04-26','12:05:00',1.52),('5815','2014-04-26','12:10:00',1.72),('5815','2014-04-26','12:15:00',1.67),('5815','2014-04-26','12:20:00',1.56),('5815','2014-04-26','12:25:00',1.64),('5815','2014-04-26','12:30:00',1.49),('5815','2014-04-26','12:35:00',1.49),('5815','2014-04-26','12:40:00',1.36),('5815','2014-04-26','12:45:00',1.48),('5815','2014-04-26','12:50:00',1.29),('5815','2014-04-26','13:00:00',1.11),('5815','2014-04-26','13:05:00',1.17),('5815','2014-04-26','13:20:00',1.34),('5815','2014-04-26','13:25:00',1.27),('5815','2014-04-26','13:30:00',1.12),('5815','2014-04-26','14:05:00',1.31),('5815','2014-04-26','14:25:00',1.24),('5815','2014-04-26','14:30:00',1.31),('5815','2014-04-26','14:35:00',1.25),('5815','2014-04-26','14:40:00',1.29),('5815','2014-04-26','14:45:00',1.13),('5815','2014-04-26','14:50:00',1.05),('5815','2014-04-26','14:55:00',1.13),('5815','2014-04-26','15:00:00',1.19),('5815','2014-04-26','15:05:00',1.68),('5815','2014-04-26','15:10:00',2.21),('5815','2014-04-26','15:15:00',1.73),('5815','2014-04-26','15:20:00',1.1),('5819','2014-05-05','07:25:00',1.04),('5819','2014-05-05','07:40:00',1.1),('5819','2014-05-05','07:45:00',1.38),('5819','2014-05-05','07:50:00',1.48),('5819','2014-05-05','07:55:00',1.57),('5819','2014-05-05','08:00:00',1.65),('5819','2014-05-05','08:05:00',1.74),('5819','2014-05-05','08:10:00',1.84),('5819','2014-05-05','08:15:00',1.94),('5819','2014-05-05','08:20:00',2.03),('5819','2014-05-05','08:25:00',2.11),('5819','2014-05-05','08:30:00',2.19),('5819','2014-05-05','08:35:00',2.3),('5819','2014-05-05','08:40:00',2.38),('5819','2014-05-05','08:45:00',2.45),('5819','2014-05-05','08:50:00',2.52),('5819','2014-05-05','08:55:00',2.59),('5819','2014-05-05','09:00:00',2.63),('5819','2014-05-05','09:05:00',2.69),('5819','2014-05-05','09:10:00',2.73),('5819','2014-05-05','09:15:00',2.83),('5819','2014-05-05','09:20:00',2.87),('5819','2014-05-05','09:25:00',2.98),('5819','2014-05-05','09:30:00',3.07),('5819','2014-05-05','09:35:00',3.12),('5819','2014-05-05','09:40:00',3.18),('5819','2014-05-05','09:45:00',3.23),('5819','2014-05-05','09:50:00',3.3),('5819','2014-05-05','09:55:00',3.36),('5819','2014-05-05','10:00:00',3.41),('5819','2014-05-05','10:05:00',3.47),('5819','2014-05-05','10:10:00',3.51),('5819','2014-05-05','10:15:00',3.52),('5819','2014-05-05','10:20:00',3.52),('5819','2014-05-05','10:25:00',3.58),('5819','2014-05-05','10:30:00',3.64),('5819','2014-05-05','10:35:00',3.73),('5819','2014-05-05','10:40:00',3.72),('5819','2014-05-05','10:45:00',3.75),('5819','2014-05-05','10:50:00',3.79),('5819','2014-05-05','10:55:00',3.8),('5819','2014-05-05','11:00:00',3.85),('5819','2014-05-05','11:05:00',3.88),('5819','2014-05-05','11:10:00',3.91),('5819','2014-05-05','11:15:00',3.9),('5819','2014-05-05','11:20:00',3.91),('5819','2014-05-05','11:25:00',3.94),('5819','2014-05-05','11:30:00',3.92),('5819','2014-05-05','11:35:00',3.95),('5819','2014-05-05','11:40:00',3.98),('5819','2014-05-05','11:45:00',4.01),('5819','2014-05-05','11:50:00',4.03),('5819','2014-05-05','11:55:00',4.19),('5819','2014-05-05','12:00:00',2.92),('5819','2014-05-05','12:05:00',2.16),('5819','2014-05-05','12:10:00',2.79),('5819','2014-05-05','12:15:00',2.53),('5819','2014-05-05','12:20:00',2.27),('5819','2014-05-05','12:25:00',3.55),('5819','2014-05-05','12:30:00',3.9),('5819','2014-05-05','12:35:00',1.78),('5819','2014-05-05','12:40:00',1.83),('5819','2014-05-05','12:45:00',4.83),('5819','2014-05-05','12:50:00',3.25),('5819','2014-05-05','12:55:00',2.58),('5819','2014-05-05','13:00:00',2.46),('5819','2014-05-05','13:05:00',4.14),('5819','2014-05-05','13:10:00',4.2),('5819','2014-05-05','13:15:00',4.11),('5819','2014-05-05','13:20:00',3.97),('5819','2014-05-05','13:25:00',3.97),('5819','2014-05-05','13:30:00',3.98),('5819','2014-05-05','13:35:00',3.97),('5819','2014-05-05','13:40:00',3.92),('5819','2014-05-05','13:45:00',3.91),('5819','2014-05-05','13:50:00',3.92),('5819','2014-05-05','13:55:00',3.92),('5819','2014-05-05','14:00:00',3.91),('5819','2014-05-05','14:05:00',4.03),('5819','2014-05-05','14:10:00',4.07),('5819','2014-05-05','14:15:00',4.11),('5819','2014-05-05','14:20:00',4.38),('5819','2014-05-05','14:25:00',3.8),('5819','2014-05-05','14:30:00',2.12),('5819','2014-05-05','14:35:00',1.49),('5819','2014-05-05','14:40:00',1.24),('5819','2014-05-05','14:45:00',1.09),('5819','2014-05-05','14:50:00',1.13),('5819','2014-05-05','14:55:00',1.53),('5819','2014-05-05','15:00:00',1.38),('5819','2014-05-05','15:05:00',1.41),('5819','2014-05-05','15:10:00',1.29),('5819','2014-05-05','15:15:00',1.17),('5819','2014-05-05','15:20:00',1.41),('5819','2014-05-05','15:25:00',2.65),('5819','2014-05-05','15:30:00',3.65),('5819','2014-05-05','15:35:00',2.33),('5819','2014-05-05','15:40:00',2.95),('5819','2014-05-05','15:45:00',1.55),('5819','2014-05-05','15:50:00',1.32),('5819','2014-05-05','15:55:00',1.27),('5819','2014-05-05','16:00:00',1.37),('5819','2014-05-05','16:05:00',2.03),('5819','2014-05-05','16:10:00',1.15),('5819','2014-05-05','16:15:00',1.31),('5819','2014-05-05','16:20:00',1.07),('5819','2014-05-05','16:40:00',1.59),('5819','2014-05-05','16:45:00',1.42),('5819','2014-05-05','16:55:00',1.74),('5819','2014-05-05','17:00:00',2.06),('5819','2014-05-05','17:05:00',1.9),('5819','2014-05-05','17:10:00',1.83),('5819','2014-05-05','17:15:00',1.79),('5819','2014-05-05','17:20:00',1.73),('5819','2014-05-05','17:25:00',1.56),('5819','2014-05-05','17:30:00',1.4),('5819','2014-05-05','17:35:00',1.18),('5819','2014-05-05','17:40:00',1.18),('5819','2014-05-05','17:45:00',1.1),('5819','2014-05-05','17:50:00',1.02),('5819','2014-04-26','09:50:00',1.05),('5819','2014-04-26','09:55:00',1.38),('5819','2014-04-26','10:00:00',1.36),('5819','2014-04-26','10:05:00',1.27),('5819','2014-04-26','10:10:00',1.22),('5819','2014-04-26','10:15:00',1.28),('5819','2014-04-26','10:20:00',1.37),('5819','2014-04-26','10:25:00',1.44),('5819','2014-04-26','10:30:00',1.99),('5819','2014-04-26','10:35:00',1.86),('5819','2014-04-26','10:40:00',1.75),('5819','2014-04-26','10:45:00',1.87),('5819','2014-04-26','10:50:00',2.3),('5819','2014-04-26','10:55:00',3.09),('5819','2014-04-26','11:00:00',3.49),('5819','2014-04-26','11:05:00',3.12),('5819','2014-04-26','11:10:00',3.29),('5819','2014-04-26','11:15:00',3.11),('5819','2014-04-26','11:20:00',3.02),('5819','2014-04-26','11:25:00',2.98),('5819','2014-04-26','11:30:00',2.99),('5819','2014-04-26','11:35:00',2.92),('5819','2014-04-26','11:40:00',2.83),('5819','2014-04-26','11:45:00',3.09),('5819','2014-04-26','11:50:00',3.08),('5819','2014-04-26','11:55:00',2.58),('5819','2014-04-26','12:00:00',3.03),('5819','2014-04-26','12:05:00',3.03),('5819','2014-04-26','12:10:00',3.05),('5819','2014-04-26','12:15:00',2.74),('5819','2014-04-26','12:20:00',2.61),('5819','2014-04-26','12:25:00',1.79),('5819','2014-04-26','12:30:00',2.28),('5819','2014-04-26','12:35:00',3.16),('5819','2014-04-26','12:40:00',2.91),('5819','2014-04-26','12:45:00',3.15),('5819','2014-04-26','12:50:00',3.86),('5819','2014-04-26','12:55:00',4.02),('5819','2014-04-26','13:00:00',3.74),('5819','2014-04-26','13:05:00',3.16),('5819','2014-04-26','13:10:00',2.85),('5819','2014-04-26','13:15:00',4.06),('5819','2014-04-26','13:20:00',3.31),('5819','2014-04-26','13:25:00',2.12),('5819','2014-04-26','13:30:00',1.3),('5819','2014-04-26','13:35:00',2.78),('5819','2014-04-26','13:40:00',3.95),('5819','2014-04-26','13:45:00',3.79),('5819','2014-04-26','13:50:00',3.81),('5819','2014-04-26','13:55:00',4.04),('5819','2014-04-26','14:00:00',2.85),('5819','2014-04-26','14:05:00',1.03),('5819','2014-04-26','14:10:00',3.48),('5819','2014-04-26','14:35:00',2.12),('5819','2014-04-26','14:40:00',2.06),('5819','2014-04-25','07:55:00',1.28),('5819','2014-04-25','08:00:00',1.42),('5819','2014-04-25','08:05:00',1.42),('5819','2014-04-25','08:10:00',1.47),('5819','2014-04-25','08:15:00',1.53),('5819','2014-04-25','08:20:00',1.63),('5819','2014-04-25','08:25:00',1.74),('5819','2014-04-25','08:30:00',1.8),('5819','2014-04-25','08:35:00',1.85),('5819','2014-04-25','08:40:00',1.93),('5819','2014-04-25','08:45:00',2.01),('5819','2014-04-25','08:50:00',2.1),('5819','2014-04-25','08:55:00',2.18),('5819','2014-04-25','09:00:00',2.35),('5819','2014-04-25','09:05:00',2.11),('5819','2014-04-25','09:10:00',2.54),('5819','2014-04-25','09:15:00',2.5),('5819','2014-04-25','09:20:00',1.42),('5819','2014-04-25','09:25:00',1.28),('5819','2014-04-25','09:30:00',1.4),('5819','2014-04-25','09:35:00',1.25),('5819','2014-04-25','09:40:00',1),('5819','2014-04-25','10:00:00',1.21),('5819','2014-04-25','10:05:00',1.15),('5819','2014-04-25','10:10:00',1.03),('5819','2014-04-25','10:15:00',1.02),('5819','2014-04-25','10:20:00',1.06),('5819','2014-04-25','10:25:00',1.17),('5819','2014-04-25','10:30:00',1.24),('5819','2014-04-25','10:35:00',2.3),('5819','2014-04-25','10:40:00',3.8),('5819','2014-04-25','10:45:00',3.84),('5819','2014-04-25','10:50:00',3.46),('5819','2014-04-25','10:55:00',2.43),('5819','2014-04-25','11:00:00',3.44),('5819','2014-04-25','11:05:00',2.3),('5819','2014-04-25','11:10:00',1.06),('5819','2014-04-25','11:15:00',1.64),('5819','2014-04-25','11:20:00',4.02),('5819','2014-04-25','11:25:00',3.46),('5819','2014-04-25','11:30:00',1.51),('5819','2014-04-25','11:35:00',3.94),('5819','2014-04-25','11:40:00',2.53),('5819','2014-04-25','11:45:00',1.9),('5819','2014-04-25','11:50:00',1.23),('5819','2014-04-25','11:55:00',1.29),('5819','2014-04-25','12:00:00',1.7),('5819','2014-04-25','12:05:00',1.56),('5819','2014-04-25','12:10:00',1.64),('5819','2014-04-25','12:15:00',2.64),('5819','2014-04-25','12:20:00',4.07),('5819','2014-04-25','12:25:00',2.92),('5819','2014-04-25','12:30:00',2.27),('5819','2014-04-25','12:35:00',3.62),('5819','2014-04-25','12:40:00',3.81),('5819','2014-04-25','12:45:00',3.76),('5819','2014-04-25','12:50:00',2.7),('5819','2014-04-25','12:55:00',2.29),('5819','2014-04-25','13:00:00',1.39),('5819','2014-04-25','13:05:00',2.71),('5819','2014-04-25','13:10:00',1.32),('5819','2014-04-25','13:15:00',2.39),('5819','2014-04-25','13:20:00',2.03),('5819','2014-04-25','13:25:00',2.05),('5819','2014-04-25','13:30:00',1.95),('5819','2014-04-25','13:35:00',1.24),('5819','2014-04-25','13:40:00',2.74),('5819','2014-04-25','13:45:00',2.08),('5819','2014-04-25','13:50:00',1.16),('5819','2014-04-25','13:55:00',1.31),('5819','2014-04-25','14:00:00',1.19),('5819','2014-04-25','14:05:00',1.48),('5819','2014-04-25','14:10:00',1.34),('5819','2014-04-25','14:15:00',1.06),('5819','2014-04-25','14:20:00',2.57),('5819','2014-04-25','14:25:00',2.62),('5819','2014-04-25','14:30:00',3.3),('5819','2014-04-25','14:35:00',3.66),('5819','2014-04-25','14:40:00',3.52),('5819','2014-04-25','14:45:00',3.54),('5819','2014-04-25','14:50:00',3.53),('5819','2014-04-25','14:55:00',3.38),('5819','2014-04-25','15:00:00',3.33),('5819','2014-04-25','15:05:00',3.23),('5819','2014-04-25','15:10:00',3.15),('5819','2014-04-25','15:15:00',3.13),('5819','2014-04-25','15:20:00',2.98),('5819','2014-04-25','15:25:00',2.95),('5819','2014-04-25','15:30:00',2.85),('5819','2014-04-25','15:35:00',2.87),('5819','2014-04-25','15:40:00',2.83),('5819','2014-04-25','15:45:00',2.73),('5819','2014-04-25','15:50:00',2.67),('5819','2014-04-25','15:55:00',2.64),('5819','2014-04-25','16:00:00',2.59),('5819','2014-04-25','16:05:00',2.44),('5819','2014-04-25','16:10:00',2.39),('5819','2014-04-25','16:15:00',2.27),('5819','2014-04-25','16:20:00',2.09),('5819','2014-04-25','16:25:00',2.05),('5819','2014-04-25','16:30:00',2.14),('5819','2014-04-25','16:35:00',2.1),('5819','2014-04-25','16:40:00',2.09),('5819','2014-04-25','16:45:00',1.99),('5819','2014-04-25','16:50:00',1.85),('5819','2014-04-25','16:55:00',1.58),('5819','2014-04-25','17:00:00',1.37),('5819','2014-04-25','17:05:00',1.56),('5819','2014-04-25','17:10:00',1.43),('5819','2014-04-25','17:15:00',1.33),('5819','2014-04-25','17:20:00',1.1),('5819','2014-01-12','10:25:00',1),('5819','2014-01-12','10:35:00',1.06),('5819','2014-01-12','10:40:00',1.23),('5819','2014-01-12','10:45:00',1.26),('5819','2014-01-12','10:50:00',1.31),('5819','2014-01-12','10:55:00',1.43),('5819','2014-01-12','11:00:00',1.46),('5819','2014-01-12','11:05:00',1.42),('5819','2014-01-12','11:10:00',1.8),('5819','2014-01-12','11:15:00',1.62),('5819','2014-01-12','11:20:00',1.6),('5819','2014-01-12','11:25:00',1.44),('5819','2014-01-12','11:30:00',1.58),('5819','2014-01-12','11:35:00',1.3),('5819','2014-01-12','11:40:00',1.52),('5819','2014-01-12','11:45:00',1.81),('5819','2014-01-12','11:50:00',1.84),('5819','2014-01-12','11:55:00',1.82),('5819','2014-01-12','12:00:00',1.37),('5819','2014-01-12','12:05:00',1.36),('5819','2014-01-12','12:10:00',1.23),('5819','2014-01-12','12:15:00',1.11),('5819','2014-01-12','12:20:00',1.13),('5819','2014-01-12','12:25:00',1.07),('5819','2014-01-12','12:30:00',1.13),('5819','2014-01-12','12:35:00',1.12),('5819','2014-01-12','12:40:00',1.23),('5819','2014-01-12','12:45:00',1.19),('5819','2014-01-12','12:50:00',1.2),('5819','2014-01-12','12:55:00',1.18),('5819','2014-01-12','13:00:00',1.18),('5819','2014-01-12','13:05:00',1.08),('5819','2014-01-12','13:10:00',1.04),('5819','2014-01-12','13:15:00',1.01),('5819','2014-01-12','13:20:00',1.06),('5819','2014-01-12','13:25:00',1.04),('5819','2014-01-12','13:30:00',1.28),('5819','2014-01-12','13:35:00',1.14),('5819','2014-01-12','13:40:00',1.04),('5819','2014-01-11','09:50:00',1.07),('5819','2014-01-11','09:55:00',1.54),('5819','2014-01-11','10:00:00',1.8),('5819','2014-01-11','10:05:00',1.37),('5819','2014-01-11','10:10:00',1.35),('5819','2014-01-11','10:15:00',1.53),('5819','2014-01-11','10:20:00',1.49),('5819','2014-01-11','10:25:00',1.87),('5819','2014-01-11','10:30:00',1.79),('5819','2014-01-11','10:35:00',1.84),('5819','2014-01-11','10:40:00',2.27),('5819','2014-01-11','10:45:00',2.42),('5819','2014-01-11','10:50:00',2.44),('5819','2014-01-11','10:55:00',2.4),('5819','2014-01-11','11:00:00',2.33),('5819','2014-01-11','11:05:00',2.24),('5819','2014-01-11','11:10:00',2.38),('5819','2014-01-11','11:15:00',2.22),('5819','2014-01-11','11:20:00',1.99),('5819','2014-01-11','11:25:00',1.96),('5819','2014-01-11','11:30:00',1.97),('5819','2014-01-11','11:35:00',1.84),('5819','2014-01-11','11:40:00',1.63),('5819','2014-01-11','11:45:00',1.68),('5819','2014-01-11','11:50:00',1.8),('5819','2014-01-11','11:55:00',1.8),('5819','2014-01-11','12:00:00',1.8),('5819','2014-01-11','12:05:00',1.99),('5819','2014-01-11','12:10:00',1.87),('5819','2014-01-11','12:15:00',1.92),('5819','2014-01-11','12:20:00',1.81),('5819','2014-01-11','12:25:00',1.69),('5819','2014-01-11','12:30:00',1.51),('5819','2014-01-11','12:35:00',1.41),('5819','2014-01-11','12:40:00',1.28),('5819','2014-01-11','12:45:00',1.35),('5819','2014-01-11','12:50:00',1.64),('5819','2014-01-11','12:55:00',1.93),('5819','2014-01-11','13:00:00',1.93),('5819','2014-01-11','13:05:00',1.76),('5819','2014-01-11','13:10:00',1.77),('5819','2014-01-11','13:15:00',2),('5819','2014-01-11','13:20:00',1.75),('5819','2014-01-11','13:25:00',1.4),('5819','2014-01-11','13:30:00',1.19),('5819','2014-01-11','13:35:00',1.2),('5819','2014-01-11','13:40:00',1.04),('5819','2014-01-11','13:45:00',1.11),('5819','2014-01-11','14:00:00',1.25),('5819','2014-01-11','14:05:00',1.37),('5819','2014-01-11','14:10:00',1.23),('5819','2014-01-09','09:20:00',1.04),('5819','2014-01-09','09:25:00',1.25),('5819','2014-01-09','09:30:00',1.33),('5819','2014-01-09','09:35:00',1.69),('5819','2014-01-09','09:40:00',1.61),('5819','2014-01-09','09:45:00',1.77),('5819','2014-01-09','09:50:00',1.96),('5819','2014-01-09','09:55:00',1.95),('5819','2014-01-09','10:00:00',1.97),('5819','2014-01-09','10:05:00',1.97),('5819','2014-01-09','10:10:00',1.62),('5819','2014-01-09','10:15:00',1.73),('5819','2014-01-09','10:20:00',1.79),('5819','2014-01-09','10:25:00',1.83),('5819','2014-01-09','10:30:00',1.91),('5819','2014-01-09','10:35:00',1.89),('5819','2014-01-09','10:40:00',1.92),('5819','2014-01-09','10:45:00',1.94),('5819','2014-01-09','10:50:00',2.07),('5819','2014-01-09','10:55:00',1.58),('5819','2014-01-09','11:00:00',1.09),('5819','2014-01-09','11:05:00',1.01),('5819','2014-01-09','11:10:00',1.08),('5819','2014-01-09','11:15:00',1.02),('5819','2014-01-09','11:20:00',1.08),('5819','2014-01-09','11:25:00',1.23),('5819','2014-01-09','11:30:00',1.1),('5819','2014-01-09','11:35:00',1.03),('5819','2014-01-09','11:40:00',1.24),('5819','2014-01-09','11:45:00',1.46),('5819','2014-01-09','11:50:00',1.31),('5819','2014-01-08','08:55:00',1.12),('5819','2014-01-08','09:00:00',1.25),('5819','2014-01-08','09:05:00',1.28),('5819','2014-01-08','09:10:00',1.39),('5819','2014-01-08','09:15:00',1.48),('5819','2014-01-08','09:20:00',1.54),('5819','2014-01-08','09:25:00',1.59),('5819','2014-01-08','09:30:00',1.62),('5819','2014-01-08','09:35:00',1.65),('5819','2014-01-08','09:40:00',1.79),('5819','2014-01-08','09:45:00',1.86),('5819','2014-01-08','09:50:00',1.86),('5819','2014-01-08','09:55:00',1.93),('5819','2014-01-08','10:00:00',1.98),('5819','2014-01-08','10:05:00',1.94),('5819','2014-01-08','10:10:00',1.94),('5819','2014-01-08','10:15:00',2),('5819','2014-01-08','10:20:00',2.15),('5819','2014-01-08','10:25:00',2.23),('5819','2014-01-08','10:30:00',2.25),('5819','2014-01-08','10:35:00',2.09),('5819','2014-01-08','10:40:00',2.08),('5819','2014-01-08','10:45:00',2.28),('5819','2014-01-08','10:50:00',2.36),('5819','2014-01-08','10:55:00',2.4),('5819','2014-01-08','11:00:00',2.41),('5819','2014-01-08','11:05:00',2.41),('5819','2014-01-08','11:10:00',2.44),('5819','2014-01-08','11:15:00',2.46),('5819','2014-01-08','11:20:00',2.45),('5819','2014-01-08','11:25:00',2.46),('5819','2014-01-08','11:30:00',2.45),('5819','2014-01-08','11:35:00',2.51),('5819','2014-01-08','11:40:00',2.53),('5819','2014-01-08','11:45:00',2.47),('5819','2014-01-08','11:50:00',2.47),('5819','2014-01-08','11:55:00',2.43),('5819','2014-01-08','12:00:00',2.42),('5819','2014-01-08','12:05:00',2.42),('5819','2014-01-08','12:10:00',2.38),('5819','2014-01-08','12:15:00',2.4),('5819','2014-01-08','12:20:00',2.39),('5819','2014-01-08','12:25:00',2.35),('5819','2014-01-08','12:30:00',2.35),('5819','2014-01-08','12:35:00',2.31),('5819','2014-01-08','12:40:00',2.25),('5819','2014-01-08','12:45:00',2.15),('5819','2014-01-08','12:50:00',2.11),('5819','2014-01-08','12:55:00',2.11),('5819','2014-01-08','13:00:00',2.14),('5819','2014-01-08','13:05:00',2.14),('5819','2014-01-08','13:10:00',2.08),('5819','2014-01-08','13:15:00',2.07),('5819','2014-01-08','13:20:00',2.01),('5819','2014-01-08','13:25:00',1.99),('5819','2014-01-08','13:30:00',1.91),('5819','2014-01-08','13:35:00',1.88),('5819','2014-01-08','13:40:00',1.83),('5819','2014-01-08','13:45:00',1.82),('5819','2014-01-08','13:50:00',1.72),('5819','2014-01-08','13:55:00',1.69),('5819','2014-01-08','14:00:00',1.65),('5819','2014-01-08','14:05:00',1.63),('5819','2014-01-08','14:10:00',1.59),('5819','2014-01-08','14:15:00',1.56),('5819','2014-01-08','14:20:00',1.52),('5819','2014-01-08','14:25:00',1.5),('5819','2014-01-08','14:30:00',1.47),('5819','2014-01-08','14:35:00',1.44),('5819','2014-01-08','14:40:00',1.3),('5819','2014-01-08','14:45:00',1.25),('5819','2014-01-08','14:50:00',1.21),('5819','2014-01-08','14:55:00',1.04),('5819','2014-01-07','08:35:00',1.02),('5819','2014-01-07','08:40:00',1.11),('5819','2014-01-07','08:45:00',1.2),('5819','2014-01-07','08:50:00',1.27),('5819','2014-01-07','08:55:00',1.35),('5819','2014-01-07','09:00:00',1.42),('5819','2014-01-07','09:05:00',1.49),('5819','2014-01-07','09:10:00',1.57),('5819','2014-01-07','09:15:00',1.64),('5819','2014-01-07','09:20:00',1.71),('5819','2014-01-07','09:25:00',1.76),('5819','2014-01-07','09:30:00',1.82),('5819','2014-01-07','09:35:00',1.87),('5819','2014-01-07','09:40:00',1.93),('5819','2014-01-07','09:45:00',1.97),('5819','2014-01-07','09:50:00',2.02),('5819','2014-01-07','09:55:00',2.05),('5819','2014-01-07','10:00:00',2.09),('5819','2014-01-07','10:05:00',2.13),('5819','2014-01-07','10:10:00',2.17),('5819','2014-01-07','10:15:00',2.21),('5819','2014-01-07','10:20:00',2.25),('5819','2014-01-07','10:25:00',2.29),('5819','2014-01-07','10:30:00',2.33),('5819','2014-01-07','10:35:00',2.36),('5819','2014-01-07','10:40:00',2.39),('5819','2014-01-07','10:45:00',2.42),('5819','2014-01-07','10:50:00',2.45),('5819','2014-01-07','10:55:00',2.47),('5819','2014-01-07','11:00:00',2.48),('5819','2014-01-07','11:05:00',2.49),('5819','2014-01-07','11:10:00',2.51),('5819','2014-01-07','11:15:00',2.52),('5819','2014-01-07','11:20:00',2.54),('5819','2014-01-07','11:25:00',2.54),('5819','2014-01-07','11:30:00',2.56),('5819','2014-01-07','11:35:00',2.56),('5819','2014-01-07','11:40:00',2.58),('5819','2014-01-07','11:45:00',2.56),('5819','2014-01-07','11:50:00',2.56),('5819','2014-01-07','11:55:00',2.56),('5819','2014-01-07','12:00:00',2.52),('5819','2014-01-07','12:05:00',2.52),('5819','2014-01-07','12:10:00',2.52),('5819','2014-01-07','12:15:00',2.46),('5819','2014-01-07','12:20:00',2.48),('5819','2014-01-07','12:25:00',2.46),('5819','2014-01-07','12:30:00',2.43),('5819','2014-01-07','12:35:00',2.39),('5819','2014-01-07','12:40:00',2.33),('5819','2014-01-07','12:45:00',2.32),('5819','2014-01-07','12:50:00',2.33),('5819','2014-01-07','12:55:00',2.27),('5819','2014-01-07','13:00:00',2.19),('5819','2014-01-07','13:05:00',2.14),('5819','2014-01-07','13:10:00',2.17),('5819','2014-01-07','13:15:00',2.13),('5819','2014-01-07','13:20:00',2.07),('5819','2014-01-07','13:25:00',1.98),('5819','2014-01-07','13:30:00',1.91),('5819','2014-01-07','13:35:00',1.88),('5819','2014-01-07','13:40:00',1.87),('5819','2014-01-07','13:45:00',1.88),('5819','2014-01-07','13:50:00',1.86),('5819','2014-01-07','13:55:00',1.82),('5819','2014-01-07','14:00:00',1.82),('5819','2014-01-07','14:05:00',1.7),('5819','2014-01-07','14:10:00',1.65),('5819','2014-01-07','14:15:00',1.63),('5819','2014-01-07','14:20:00',1.58),('5819','2014-01-07','14:25:00',1.5),('5819','2014-01-07','14:30:00',1.44),('5819','2014-01-07','14:35:00',1.37),('5819','2014-01-07','14:40:00',1.36),('5819','2014-01-07','14:45:00',1.27),('5819','2014-01-07','14:50:00',1.25),('5819','2014-01-07','14:55:00',1.22),('5819','2014-01-07','15:00:00',1.14),('5819','2014-01-07','15:05:00',1.1),('5819','2014-01-07','15:10:00',1.05),('5819','2014-04-24','07:40:00',1.05),('5819','2014-04-24','07:45:00',1.13),('5819','2014-04-24','07:50:00',1.22),('5819','2014-04-24','07:55:00',1.31),('5819','2014-04-24','08:00:00',1.4),('5819','2014-04-24','08:05:00',1.49),('5819','2014-04-24','08:10:00',1.56),('5819','2014-04-24','08:15:00',1.64),('5819','2014-04-24','08:20:00',1.73),('5819','2014-04-24','08:25:00',1.83),('5819','2014-04-24','08:30:00',1.91),('5819','2014-04-24','08:35:00',1.99),('5819','2014-04-24','08:40:00',2.07),('5819','2014-04-24','08:45:00',2.14),('5819','2014-04-24','08:50:00',2.2),('5819','2014-04-24','08:55:00',2.28),('5819','2014-04-24','09:00:00',2.35),('5819','2014-04-24','09:05:00',2.42),('5819','2014-04-24','09:10:00',2.46),('5819','2014-04-24','09:15:00',2.53),('5819','2014-04-24','09:20:00',2.59),('5819','2014-04-24','09:25:00',2.66),('5819','2014-04-24','09:30:00',2.74),('5819','2014-04-24','09:35:00',2.81),('5819','2014-04-24','09:40:00',2.85),('5819','2014-04-24','09:45:00',2.92),('5819','2014-04-24','09:50:00',2.98),('5819','2014-04-24','09:55:00',3.01),('5819','2014-04-24','10:00:00',3.06),('5819','2014-04-24','10:05:00',3.11),('5819','2014-04-24','10:10:00',3.15),('5819','2014-04-24','10:15:00',3.21),('5819','2014-04-24','10:20:00',3.25),('5819','2014-04-24','10:25:00',3.26),('5819','2014-04-24','10:30:00',3.31),('5819','2014-04-24','10:35:00',3.33),('5819','2014-04-24','10:40:00',3.37),('5819','2014-04-24','10:45:00',3.41),('5819','2014-04-24','10:50:00',3.43),('5819','2014-04-24','10:55:00',3.47),('5819','2014-04-24','11:00:00',3.53),('5819','2014-04-24','11:05:00',3.59),('5819','2014-04-24','11:10:00',3.59),('5819','2014-04-24','11:15:00',3.6),('5819','2014-04-24','11:20:00',3.6),('5819','2014-04-24','11:25:00',3.6),('5819','2014-04-24','11:30:00',3.63),('5819','2014-04-24','11:35:00',3.67),('5819','2014-04-24','11:40:00',3.68),('5819','2014-04-24','11:45:00',3.66),('5819','2014-04-24','11:50:00',3.69),('5819','2014-04-24','11:55:00',3.7),('5819','2014-04-24','12:00:00',3.69),('5819','2014-04-24','12:05:00',3.74),('5819','2014-04-24','12:10:00',3.76),('5819','2014-04-24','12:15:00',3.89),('5819','2014-04-24','12:20:00',3.85),('5819','2014-04-24','12:25:00',3.74),('5819','2014-04-24','12:30:00',3.86),('5819','2014-04-24','12:35:00',3.84),('5819','2014-04-24','12:40:00',3.83),('5819','2014-04-24','12:45:00',3.85),('5819','2014-04-24','12:50:00',3.87),('5819','2014-04-24','12:55:00',3.73),('5819','2014-04-24','13:00:00',3.65),('5819','2014-04-24','13:05:00',3.78),('5819','2014-04-24','13:10:00',3.87),('5819','2014-04-24','13:15:00',3.91),('5819','2014-04-24','13:20:00',3.92),('5819','2014-04-24','13:25:00',3.84),('5819','2014-04-24','13:30:00',3.85),('5819','2014-04-24','13:35:00',3.85),('5819','2014-04-24','13:40:00',1.2),('5819','2014-04-24','13:45:00',3.87),('5819','2014-04-24','13:50:00',1.29),('5819','2014-04-24','13:55:00',2.19),('5819','2014-04-24','14:00:00',3.25),('5819','2014-04-24','14:05:00',1.66),('5819','2014-04-24','14:10:00',3.64),('5819','2014-04-24','14:15:00',2.44),('5819','2014-04-24','14:20:00',3.05),('5819','2014-04-24','14:25:00',2.87),('5819','2014-04-24','14:30:00',3.97),('5819','2014-04-24','14:35:00',3.83),('5819','2014-04-24','14:40:00',2.47),('5819','2014-04-24','14:45:00',3.19),('5819','2014-04-24','14:50:00',1.41),('5819','2014-04-24','14:55:00',3.06),('5819','2014-04-24','15:00:00',4.14),('5819','2014-04-24','15:05:00',4.02),('5819','2014-04-24','15:10:00',3.52),('5819','2014-04-24','15:15:00',3.47),('5819','2014-04-24','15:20:00',2.24),('5819','2014-04-24','15:25:00',1.98),('5819','2014-04-24','15:30:00',2.14),('5819','2014-04-24','15:35:00',2.46),('5819','2014-04-24','15:40:00',1.91),('5819','2014-04-24','15:45:00',1.76),('5819','2014-04-24','15:50:00',2.26),('5819','2014-04-24','15:55:00',2.15),('5819','2014-04-24','16:00:00',3.13),('5819','2014-04-24','16:05:00',3),('5819','2014-04-24','16:10:00',2.32),('5819','2014-04-24','16:15:00',2.44),('5819','2014-04-24','16:20:00',2.44),('5819','2014-04-24','16:25:00',2.1),('5819','2014-04-24','16:30:00',2.67),('5819','2014-04-24','16:35:00',1.61),('5819','2014-04-24','16:40:00',1.66),('5819','2014-04-24','16:45:00',1.75),('5819','2014-04-24','16:50:00',1.38),('5819','2014-04-24','16:55:00',1.51),('5819','2014-04-24','17:00:00',1.24),('5819','2014-04-24','17:05:00',1.11),('5819','2014-04-24','17:10:00',1.04),('5819','2014-01-06','11:35:00',1.18),('5819','2014-01-06','11:40:00',2.85),('5819','2014-01-06','11:45:00',2.59),('5819','2014-01-06','11:50:00',2.59),('5819','2014-01-06','11:55:00',2.47),('5819','2014-01-06','12:00:00',2.53),('5819','2014-01-06','12:05:00',2.59),('5819','2014-01-06','12:10:00',2.51),('5819','2014-01-06','12:15:00',2.46),('5819','2014-01-06','12:20:00',2.43),('5819','2014-01-06','12:25:00',2.45),('5819','2014-01-06','12:30:00',2.42),('5819','2014-01-06','12:35:00',2.39),('5819','2014-01-06','12:40:00',2.39),('5819','2014-01-06','12:45:00',2.38),('5819','2014-01-06','12:50:00',2.39),('5819','2014-01-06','12:55:00',2.33),('5819','2014-01-06','13:00:00',2.29),('5819','2014-01-06','13:05:00',2.24),('5819','2014-01-06','13:10:00',2.24),('5819','2014-01-06','13:15:00',2.3),('5819','2014-01-06','13:20:00',2.25),('5819','2014-01-06','13:25:00',2.23),('5819','2014-01-06','13:30:00',2.07),('5819','2014-01-06','13:35:00',2.01),('5819','2014-01-06','13:40:00',1.97),('5819','2014-01-06','13:45:00',1.91),('5819','2014-01-06','13:50:00',1.88),('5819','2014-01-06','13:55:00',1.82),('5819','2014-01-06','14:00:00',1.48),('5819','2014-01-06','14:20:00',1.86),('5819','2014-01-06','14:35:00',1.08),('5819','2014-01-06','14:40:00',1.47),('5819','2014-01-06','14:45:00',1.64),('5819','2014-01-06','14:50:00',1.39),('5819','2014-01-06','15:05:00',1.04),('5819','2014-01-06','15:10:00',1.01),('5819','2014-01-03','08:55:00',1.01),('5819','2014-01-03','09:10:00',1.01),('5819','2014-01-03','09:20:00',1.49),('5819','2014-01-03','09:30:00',1.58),('5819','2014-01-03','09:35:00',1.86),('5819','2014-01-03','09:40:00',2.1),('5819','2014-01-03','09:45:00',2.11),('5819','2014-01-03','09:50:00',1.28),('5819','2014-01-03','09:55:00',1.25),('5819','2014-01-03','10:00:00',1.56),('5819','2014-01-03','10:05:00',1.79),('5819','2014-01-03','10:15:00',1.1),('5819','2014-01-03','10:20:00',2.13),('5819','2014-01-03','10:25:00',1.07),('5819','2014-01-03','10:30:00',1.05),('5819','2014-01-03','10:40:00',1.13),('5819','2014-01-03','10:45:00',1.29),('5819','2014-01-03','10:50:00',1.28),('5819','2014-01-03','10:55:00',1.07),('5819','2014-01-03','11:05:00',1.03),('5819','2014-01-03','11:45:00',1.01),('5819','2014-01-03','11:50:00',1.03),('5819','2014-01-03','12:00:00',1.04),('5819','2014-01-03','12:05:00',1.5),('5819','2014-01-03','12:10:00',1.63),('5819','2014-01-03','12:15:00',1.46),('5819','2014-01-03','12:20:00',1.01),('5819','2014-01-03','12:25:00',1.01),('5819','2014-01-03','12:30:00',1.07),('5819','2014-01-03','12:35:00',1.27),('5819','2014-01-03','12:40:00',1.3),('5819','2014-01-03','12:45:00',1.65),('5819','2014-01-03','12:50:00',1.32),('5819','2014-01-03','12:55:00',1.9),('5819','2014-01-03','13:00:00',1.4),('5819','2014-01-03','13:05:00',1.03),('5819','2014-01-03','13:10:00',1.43),('5819','2014-01-03','13:15:00',1.19),('5819','2014-01-03','13:30:00',1.03),('5819','2014-01-03','13:35:00',1.4),('5819','2014-01-03','13:40:00',1.31),('5819','2014-01-03','13:45:00',1.25),('5819','2014-01-02','08:40:00',1.05),('5819','2014-01-02','08:45:00',1.12),('5819','2014-01-02','08:50:00',1.22),('5819','2014-01-02','08:55:00',1.29),('5819','2014-01-02','09:00:00',1.36),('5819','2014-01-02','09:05:00',1.44),('5819','2014-01-02','09:10:00',1.51),('5819','2014-01-02','09:15:00',1.56),('5819','2014-01-02','09:20:00',1.64),('5819','2014-01-02','09:25:00',1.69),('5819','2014-01-02','09:30:00',1.72),('5819','2014-01-02','09:35:00',1.77),('5819','2014-01-02','09:40:00',1.81),('5819','2014-01-02','09:45:00',1.86),('5819','2014-01-02','09:50:00',1.91),('5819','2014-01-02','09:55:00',1.95),('5819','2014-01-02','10:00:00',2.02),('5819','2014-01-02','10:05:00',2.12),('5819','2014-01-02','10:10:00',2.12),('5819','2014-01-02','10:15:00',2.09),('5819','2014-01-02','10:20:00',2.14),('5819','2014-01-02','10:25:00',2.21),('5819','2014-01-02','10:30:00',2.24),('5819','2014-01-02','10:35:00',2.26),('5819','2014-01-02','10:40:00',2.25),('5819','2014-01-02','10:45:00',2.28),('5819','2014-01-02','10:50:00',2.32),('5819','2014-01-02','10:55:00',2.41),('5819','2014-01-02','11:00:00',2.38),('5819','2014-01-02','11:05:00',2.44),('5819','2014-01-02','11:10:00',1.84),('5819','2014-01-02','11:15:00',1.45),('5819','2014-01-02','11:20:00',1.18),('5819','2014-01-02','11:25:00',1.32),('5819','2014-01-02','11:30:00',1.48),('5819','2014-01-02','11:35:00',1.52),('5819','2014-01-02','11:40:00',1.53),('5819','2014-01-02','11:45:00',1.49),('5819','2014-01-02','11:50:00',1.32),('5819','2014-01-02','11:55:00',1.15),('5819','2014-01-02','12:00:00',1.07),('5819','2014-01-02','12:05:00',1.1),('5819','2014-01-02','12:10:00',1.2),('5819','2014-01-02','12:15:00',1),('5819','2014-01-02','12:50:00',1.36),('5819','2014-01-02','12:55:00',2.01),('5819','2014-01-02','13:00:00',1.6),('5819','2014-01-02','13:40:00',1.72),('5819','2014-01-02','13:45:00',1.1),('5819','2014-01-01','08:55:00',1.42),('5819','2014-01-01','09:00:00',1.61),('5819','2014-01-01','09:05:00',1.34),('5819','2014-01-01','09:10:00',1.86),('5819','2014-01-01','09:20:00',1),('5819','2014-01-01','09:25:00',1.03),('5819','2014-01-01','09:30:00',2.04),('5819','2014-01-01','09:35:00',1.23),('5819','2014-01-01','09:40:00',1.58),('5819','2014-01-01','09:45:00',1.76),('5819','2014-01-01','09:50:00',2.26),('5819','2014-01-01','09:55:00',1.44),('5819','2014-01-01','10:00:00',1.13),('5819','2014-01-01','10:05:00',1.02),('5819','2014-01-01','12:10:00',1.04),('5819','2014-01-01','12:15:00',1.08),('5819','2014-01-01','12:20:00',1.12),('5819','2014-01-01','12:25:00',1.12),('5819','2014-01-01','12:30:00',1.18),('5819','2014-01-01','12:35:00',1.2),('5819','2014-01-01','12:40:00',1.12),('5819','2014-01-01','12:45:00',1.12),('5819','2014-01-01','12:50:00',1.12),('5819','2014-01-01','12:55:00',1.09),('5819','2014-01-01','13:00:00',1.07),('5819','2014-01-01','13:30:00',1.13),('5819','2014-01-01','13:35:00',1.54),('5819','2014-01-01','13:40:00',2.56),('5819','2014-01-01','13:45:00',1.32),('5819','2014-01-01','13:50:00',1.16),('5819','2014-01-01','13:55:00',1.18),('5819','2014-01-01','14:00:00',1.68),('5819','2014-01-01','14:05:00',1),('5819','2014-01-01','14:15:00',1.03),('5819','2014-01-01','15:05:00',1.01),('5819','2014-01-01','15:10:00',1.21),('5819','2014-01-01','15:15:00',1.08),('5819','2013-12-31','08:45:00',1.15),('5819','2013-12-31','08:50:00',1.31),('5819','2013-12-31','08:55:00',1.13),('5819','2013-12-31','09:00:00',1.56),('5819','2013-12-31','09:05:00',1.59),('5819','2013-12-31','09:10:00',1.28),('5819','2013-12-31','09:15:00',1.39),('5819','2013-12-31','09:20:00',1.78),('5819','2013-12-31','09:25:00',1.84),('5819','2013-12-31','09:30:00',1.99),('5819','2013-12-31','09:35:00',2.06),('5819','2013-12-31','09:40:00',2.04),('5819','2013-12-31','09:45:00',2.11),('5819','2013-12-31','09:50:00',1.91),('5819','2013-12-31','09:55:00',1.28),('5819','2013-12-31','10:05:00',1),('5819','2013-12-31','10:10:00',1.15),('5819','2013-12-31','10:30:00',1.03),('5819','2013-12-31','10:50:00',1.09),('5819','2013-12-31','10:55:00',1.24),('5819','2013-12-31','11:00:00',1.28),('5819','2013-12-31','11:05:00',1.17),('5819','2013-12-31','11:10:00',1.89),('5819','2013-12-31','11:15:00',2.15),('5819','2013-12-31','11:20:00',1.81),('5819','2013-12-31','11:25:00',2.03),('5819','2013-12-31','11:30:00',2.11),('5819','2013-12-31','11:35:00',1.04),('5819','2013-12-31','11:40:00',2.3),('5819','2013-12-31','11:45:00',1.36),('5819','2013-12-31','11:50:00',1.6),('5819','2013-12-31','11:55:00',2.57),('5819','2013-12-31','12:00:00',2.69),('5819','2013-12-31','12:05:00',2.63),('5819','2013-12-31','12:10:00',2.61),('5819','2013-12-31','12:15:00',2.58),('5819','2013-12-31','12:20:00',2.55),('5819','2013-12-31','12:25:00',2.52),('5819','2013-12-31','12:30:00',2.49),('5819','2013-12-31','12:35:00',2.44),('5819','2013-12-31','12:40:00',2.41),('5819','2013-12-31','12:45:00',2.39),('5819','2013-12-31','12:50:00',2.36),('5819','2013-12-31','12:55:00',2.33),('5819','2013-12-31','13:00:00',2.31),('5819','2013-12-31','13:05:00',2.28),('5819','2013-12-31','13:10:00',2.23),('5819','2013-12-31','13:15:00',2.2),('5819','2013-12-31','13:20:00',2.16),('5819','2013-12-31','13:25:00',2.13),('5819','2013-12-31','13:30:00',2.09),('5819','2013-12-31','13:35:00',2.03),('5819','2013-12-31','13:40:00',1.97),('5819','2013-12-31','13:45:00',1.93),('5819','2013-12-31','13:50:00',1.87),('5819','2013-12-31','13:55:00',1.81),('5819','2013-12-31','14:00:00',1.76),('5819','2013-12-31','14:05:00',1.71),('5819','2013-12-31','14:10:00',1.65),('5819','2013-12-31','14:15:00',1.6),('5819','2013-12-31','14:20:00',1.54),('5819','2013-12-31','14:25:00',1.49),('5819','2013-12-31','14:30:00',1.43),('5819','2013-12-31','14:35:00',1.36),('5819','2013-12-31','14:40:00',1.3),('5819','2013-12-31','14:45:00',1.23),('5819','2013-12-31','14:50:00',1.17),('5819','2013-12-31','14:55:00',1.11),('5819','2013-12-31','15:00:00',1.05),('5819','2013-12-29','08:40:00',1.45),('5819','2013-12-29','08:45:00',1.29),('5819','2013-12-29','09:05:00',1.01),('5819','2013-12-29','09:10:00',1.42),('5819','2013-12-29','09:15:00',1.54),('5819','2013-12-29','09:20:00',1.76),('5819','2013-12-29','09:25:00',1.78),('5819','2013-12-29','09:30:00',1.84),('5819','2013-12-29','09:35:00',1.87),('5819','2013-12-29','09:40:00',1.96),('5819','2013-12-29','09:45:00',1.99),('5819','2013-12-29','09:50:00',1.92),('5819','2013-12-29','09:55:00',1.61),('5819','2013-12-29','10:00:00',1.72),('5819','2013-12-29','10:05:00',1.85),('5819','2013-12-29','10:10:00',1.43),('5819','2013-12-29','10:15:00',2.24),('5819','2013-12-29','10:20:00',2.38),('5819','2013-12-29','10:25:00',2.05),('5819','2013-12-29','10:30:00',2.52),('5819','2013-12-29','10:35:00',2.69),('5819','2013-12-29','10:40:00',2.97),('5819','2013-12-29','10:45:00',1.07),('5819','2013-12-29','10:50:00',1.24),('5819','2013-12-29','11:00:00',1.23),('5819','2013-12-28','08:35:00',1.08),('5819','2013-12-28','08:40:00',1.15),('5819','2013-12-28','08:45:00',1.23),('5819','2013-12-28','08:50:00',1.31),('5819','2013-12-28','08:55:00',1.38),('5819','2013-12-28','09:00:00',1.45),('5819','2013-12-28','09:05:00',1.5),('5819','2013-12-28','09:10:00',1.57),('5819','2013-12-28','09:15:00',1.65),('5819','2013-12-28','09:20:00',1.73),('5819','2013-12-28','09:25:00',1.8),('5819','2013-12-28','09:30:00',1.86),('5819','2013-12-28','09:35:00',1.89),('5819','2013-12-28','09:40:00',1.94),('5819','2013-12-28','09:45:00',1.99),('5819','2013-12-28','09:50:00',2.06),('5819','2013-12-28','09:55:00',2.1),('5819','2013-12-28','10:00:00',2.14),('5819','2013-12-28','10:05:00',2.16),('5819','2013-12-28','10:10:00',2.2),('5819','2013-12-28','10:15:00',2.23),('5819','2013-12-28','10:20:00',2.27),('5819','2013-12-28','10:25:00',2.31),('5819','2013-12-28','10:30:00',2.35),('5819','2013-12-28','10:35:00',2.38),('5819','2013-12-28','10:40:00',2.4),('5819','2013-12-28','10:45:00',2.41),('5819','2013-12-28','10:50:00',2.42),('5819','2013-12-28','10:55:00',2.44),('5819','2013-12-28','11:00:00',2.47),('5819','2013-12-28','11:05:00',2.49),('5819','2013-12-28','11:10:00',2.49),('5819','2013-12-28','11:15:00',2.5),('5819','2013-12-28','11:20:00',2.51),('5819','2013-12-28','11:25:00',2.53),('5819','2013-12-28','11:30:00',2.52),('5819','2013-12-28','11:35:00',2.52),('5819','2013-12-28','11:40:00',2.52),('5819','2013-12-28','11:45:00',2.52),('5819','2013-12-28','11:50:00',2.51),('5819','2013-12-28','11:55:00',2.5),('5819','2013-12-28','12:00:00',2.48),('5819','2013-12-28','12:05:00',2.43),('5819','2013-12-28','12:10:00',2.47),('5819','2013-12-28','12:15:00',2.47),('5819','2013-12-28','12:20:00',2.44),('5819','2013-12-28','12:25:00',2.41),('5819','2013-12-28','12:30:00',2.36),('5819','2013-12-28','12:35:00',2.34),('5819','2013-12-28','12:40:00',2.3),('5819','2013-12-28','12:45:00',2.29),('5819','2013-12-28','12:50:00',2.25),('5819','2013-12-28','12:55:00',2.22),('5819','2013-12-28','13:00:00',2.18),('5819','2013-12-28','13:05:00',2.14),('5819','2013-12-28','13:10:00',2.1),('5819','2013-12-28','13:15:00',2.06),('5819','2013-12-28','13:20:00',2.01),('5819','2013-12-28','13:25:00',1.96),('5819','2013-12-28','13:30:00',1.91),('5819','2013-12-28','13:35:00',1.87),('5819','2013-12-28','13:40:00',1.82),('5819','2013-12-28','13:45:00',1.75),('5819','2013-12-28','13:50:00',1.71),('5819','2013-12-28','13:55:00',1.66),('5819','2013-12-28','14:00:00',1.59),('5819','2013-12-28','14:05:00',1.55),('5819','2013-12-28','14:10:00',1.48),('5819','2013-12-28','14:15:00',1.43),('5819','2013-12-28','14:20:00',1.34),('5819','2013-12-28','14:25:00',1.31),('5819','2013-12-28','14:30:00',1.25),('5819','2013-12-28','14:35:00',1.19),('5819','2013-12-28','14:40:00',1.13),('5819','2014-04-23','13:15:00',1.07),('5819','2014-04-23','13:20:00',1.1),('5819','2014-04-23','13:25:00',1.16),('5819','2014-04-23','13:30:00',1.24),('5819','2014-04-23','13:35:00',1.3),('5819','2014-04-23','13:40:00',1.4),('5819','2014-04-23','13:45:00',1.43),('5819','2014-04-23','13:50:00',1.42),('5819','2014-04-23','13:55:00',1.38),('5819','2014-04-23','14:00:00',1.3),('5819','2014-04-23','14:05:00',1.33),('5819','2014-04-23','14:10:00',1.22),('5819','2014-04-23','14:15:00',1.05),('5819','2014-04-23','14:45:00',1.13),('5819','2014-04-23','14:50:00',1.36),('5819','2014-04-23','14:55:00',1.54),('5819','2014-04-23','15:00:00',1.63),('5819','2014-04-23','15:05:00',1.64),('5819','2014-04-23','15:10:00',1.59),('5819','2014-04-23','15:15:00',1.57),('5819','2014-04-23','15:20:00',1.33),('5819','2014-04-23','15:25:00',1.28),('5819','2014-04-23','15:30:00',1.27),('5819','2014-04-23','15:35:00',1.19),('5819','2014-04-23','15:40:00',1.2),('5819','2014-04-23','15:45:00',1.08),('5819','2013-12-27','12:10:00',1.34),('5819','2013-12-27','12:15:00',2.28),('5819','2013-12-27','12:20:00',1.43),('5819','2013-12-27','12:25:00',1.44),('5819','2013-12-27','12:30:00',1.02),('5819','2013-12-27','12:35:00',1.11),('5819','2013-12-27','12:40:00',1.47),('5819','2013-12-27','12:45:00',1.9),('5819','2013-12-27','12:50:00',2.18),('5819','2013-12-27','12:55:00',2.22),('5819','2013-12-27','13:00:00',2.21),('5819','2013-12-27','13:05:00',1.94),('5819','2013-12-27','13:10:00',1.06),('5819','2013-12-27','13:15:00',1.26),('5819','2013-12-27','13:20:00',1.16),('5819','2013-12-27','13:25:00',1.21),('5819','2013-12-27','13:30:00',1.99),('5819','2013-12-27','13:35:00',2.13),('5819','2013-12-27','13:40:00',1.3),('5819','2013-12-27','13:45:00',1.25),('5819','2013-12-27','13:50:00',1.02),('5819','2013-12-27','14:20:00',1.07),('5819','2013-12-27','14:35:00',1.05),('5819','2013-12-27','14:40:00',1.1),('5819','2013-12-25','10:30:00',1.42),('5819','2013-12-25','10:35:00',1.59),('5819','2013-12-25','10:40:00',1.61),('5819','2013-12-25','10:45:00',1.38),('5819','2013-12-25','10:50:00',1.62),('5819','2013-12-25','11:15:00',1.26),('5819','2013-12-25','11:20:00',1.5),('5819','2013-12-25','11:25:00',1.67),('5819','2013-12-25','11:30:00',1.63),('5819','2013-12-25','11:35:00',1.14),('5819','2013-12-25','11:40:00',1.77),('5819','2013-12-25','11:45:00',1.86),('5819','2013-12-25','11:50:00',1.27),('5819','2013-12-25','11:55:00',2.21),('5819','2013-12-25','12:00:00',2.45),('5819','2013-12-25','12:15:00',1.14),('5819','2013-12-25','12:20:00',1.64),('5819','2013-12-25','12:25:00',1.18),('5819','2013-12-25','12:30:00',1.41),('5819','2013-12-25','12:35:00',1.49),('5819','2013-12-25','12:40:00',1.07),('5819','2013-12-25','12:50:00',1.36),('5819','2013-12-25','13:30:00',1.13),('5819','2013-12-25','13:40:00',1),('5819','2013-12-25','13:45:00',1.07),('5819','2013-12-25','13:50:00',1.18),('5819','2013-12-25','13:55:00',1.17),('5819','2013-12-24','08:55:00',1.14),('5819','2013-12-24','09:00:00',1.28),('5819','2013-12-24','09:05:00',1.37),('5819','2013-12-24','09:10:00',1.42),('5819','2013-12-24','09:15:00',1.47),('5819','2013-12-24','09:20:00',1.52),('5819','2013-12-24','09:25:00',1.57),('5819','2013-12-24','09:30:00',1.65),('5819','2013-12-24','09:35:00',1.74),('5819','2013-12-24','09:40:00',1.82),('5819','2013-12-24','09:45:00',1.84),('5819','2013-12-24','09:50:00',1.83),('5819','2013-12-24','09:55:00',1.87),('5819','2013-12-24','10:00:00',1.85),('5819','2013-12-24','10:05:00',1.87),('5819','2013-12-24','10:10:00',1.97),('5819','2013-12-24','10:15:00',2.06),('5819','2013-12-24','10:20:00',2.06),('5819','2013-12-24','10:25:00',2.09),('5819','2013-12-24','10:30:00',2.14),('5819','2013-12-24','10:35:00',2.16),('5819','2013-12-24','10:40:00',2.19),('5819','2013-12-24','10:45:00',2.24),('5819','2013-12-24','10:50:00',2.25),('5819','2013-12-24','10:55:00',2.24),('5819','2013-12-24','11:00:00',2.25),('5819','2013-12-24','11:05:00',2.28),('5819','2013-12-24','11:10:00',2.25),('5819','2013-12-24','11:15:00',2.28),('5819','2013-12-24','11:20:00',2.31),('5819','2013-12-24','11:25:00',2.33),('5819','2013-12-24','11:30:00',2.34),('5819','2013-12-24','11:35:00',2.34),('5819','2013-12-24','11:40:00',2.35),('5819','2013-12-24','11:45:00',2.34),('5819','2013-12-24','11:50:00',2.31),('5819','2013-12-24','11:55:00',2.28),('5819','2013-12-24','12:00:00',2.26),('5819','2013-12-24','12:05:00',2.23),('5819','2013-12-24','12:10:00',2.2),('5819','2013-12-24','12:15:00',2.19),('5819','2013-12-24','12:20:00',2.19),('5819','2013-12-24','12:25:00',2.16),('5819','2013-12-24','12:30:00',2.13),('5819','2013-12-24','12:35:00',2.09),('5819','2013-12-24','12:40:00',2.04),('5819','2013-12-24','12:45:00',2.02),('5819','2013-12-24','12:50:00',2.01),('5819','2013-12-24','12:55:00',2),('5819','2013-12-24','13:00:00',1.94),('5819','2013-12-24','13:05:00',1.91),('5819','2013-12-24','13:10:00',1.87),('5819','2013-12-24','13:15:00',1.83),('5819','2013-12-24','13:20:00',1.78),('5819','2013-12-24','13:25:00',1.74),('5819','2013-12-24','13:30:00',1.7),('5819','2013-12-24','13:35:00',1.66),('5819','2013-12-24','13:40:00',1.6),('5819','2013-12-24','13:45:00',1.53),('5819','2013-12-24','13:50:00',1.51),('5819','2013-12-24','13:55:00',1.44),('5819','2013-12-24','14:00:00',1.38),('5819','2013-12-24','14:05:00',1.34),('5819','2013-12-24','14:10:00',1.31),('5819','2013-12-24','14:15:00',1.25),('5819','2013-12-24','14:20:00',1.21),('5819','2013-12-24','14:25:00',1.14),('5819','2013-12-24','14:30:00',1.04),('5819','2013-12-23','09:35:00',1.02),('5819','2013-12-23','09:40:00',1.11),('5819','2013-12-23','09:45:00',1.1),('5819','2013-12-23','09:50:00',1.2),('5819','2013-12-23','09:55:00',1.64),('5819','2013-12-23','10:00:00',1.92),('5819','2013-12-23','10:05:00',2.1),('5819','2013-12-23','10:10:00',2.18),('5819','2013-12-23','10:15:00',1.99),('5819','2013-12-23','10:20:00',2.16),('5819','2013-12-23','10:25:00',2.09),('5819','2013-12-23','10:30:00',1.94),('5819','2013-12-23','10:35:00',1.96),('5819','2013-12-23','10:40:00',2.01),('5819','2013-12-23','10:45:00',2.03),('5819','2013-12-23','10:50:00',2),('5819','2013-12-23','10:55:00',2.06),('5819','2013-12-23','11:00:00',2.41),('5819','2013-12-23','11:05:00',2.51),('5819','2013-12-23','11:10:00',2.54),('5819','2013-12-23','11:15:00',2.55),('5819','2013-12-23','11:20:00',2.41),('5819','2013-12-23','11:25:00',2.49),('5819','2013-12-23','11:30:00',2.34),('5819','2013-12-23','11:35:00',2.43),('5819','2013-12-23','11:40:00',2.49),('5819','2013-12-23','11:45:00',2.18),('5819','2013-12-23','11:50:00',2.2),('5819','2013-12-23','11:55:00',2.24),('5819','2013-12-23','12:00:00',2.3),('5819','2013-12-23','12:05:00',2.36),('5819','2013-12-23','12:10:00',2.3),('5819','2013-12-23','12:15:00',2.25),('5819','2013-12-23','12:20:00',2.23),('5819','2013-12-23','12:25:00',2.21),('5819','2013-12-23','12:30:00',2.34),('5819','2013-12-23','12:35:00',2.31),('5819','2013-12-23','12:40:00',2.28),('5819','2013-12-23','12:45:00',2.25),('5819','2013-12-23','12:50:00',2.22),('5819','2013-12-23','12:55:00',2.2),('5819','2013-12-23','13:00:00',2.17),('5819','2013-12-23','13:05:00',2.13),('5819','2013-12-23','13:10:00',2.09),('5819','2013-12-23','13:15:00',2.03),('5819','2013-12-23','13:20:00',1.89),('5819','2013-12-23','13:25:00',1.62),('5819','2013-12-23','13:30:00',1.89),('5819','2013-12-23','13:40:00',1.42),('5819','2013-12-23','13:45:00',1.34),('5819','2013-12-23','13:50:00',1.22),('5819','2013-12-23','13:55:00',1.42),('5819','2013-12-23','14:00:00',1.64),('5819','2013-12-23','14:05:00',1.59),('5819','2013-12-23','14:10:00',1.54),('5819','2013-12-23','14:15:00',1.46),('5819','2013-12-23','14:20:00',1.36),('5819','2013-12-23','14:25:00',1.31),('5819','2013-12-23','14:30:00',1.18),('5819','2013-12-23','14:35:00',1.17),('5819','2013-12-23','14:40:00',1.12),('5819','2013-12-23','14:45:00',1.09),('5819','2013-12-23','14:50:00',1.04),('5819','2013-12-22','09:05:00',1.2),('5819','2013-12-22','09:10:00',1.24),('5819','2013-12-22','09:15:00',1.21),('5819','2013-12-22','09:20:00',1.36),('5819','2013-12-22','09:25:00',1.3),('5819','2013-12-22','09:30:00',1.34),('5819','2013-12-22','09:35:00',1.61),('5819','2013-12-22','09:40:00',2.21),('5819','2013-12-22','09:45:00',2.26),('5819','2013-12-22','09:50:00',2.38),('5819','2013-12-22','09:55:00',2.41),('5819','2013-12-22','10:00:00',2.39),('5819','2013-12-22','10:05:00',2.4),('5819','2013-12-22','10:10:00',2.44),('5819','2013-12-22','10:15:00',2.38),('5819','2013-12-22','10:20:00',2.29),('5819','2013-12-22','10:25:00',2.3),('5819','2013-12-22','10:30:00',2.4),('5819','2013-12-22','10:35:00',2.26),('5819','2013-12-22','10:40:00',2.12),('5819','2013-12-22','10:45:00',2.18),('5819','2013-12-22','10:50:00',2.29),('5819','2013-12-22','10:55:00',2.13),('5819','2013-12-22','11:00:00',1.88),('5819','2013-12-22','11:05:00',1.82),('5819','2013-12-22','11:10:00',2.45),('5819','2013-12-22','11:15:00',2.42),('5819','2013-12-22','11:20:00',2.19),('5819','2013-12-22','11:25:00',2.23),('5819','2013-12-22','11:30:00',2.09),('5819','2013-12-22','11:35:00',2.05),('5819','2013-12-22','11:40:00',2.21),('5819','2013-12-22','11:45:00',2.07),('5819','2013-12-22','11:50:00',1.56),('5819','2013-12-22','11:55:00',1.16),('5819','2013-12-22','12:20:00',1.07),('5819','2013-12-22','12:25:00',1.15),('5819','2013-12-22','12:30:00',1.38),('5819','2013-12-22','12:35:00',1.62),('5819','2013-12-22','12:40:00',1.57),('5819','2013-12-22','12:45:00',1.46),('5819','2013-12-22','12:50:00',1.75),('5819','2013-12-22','12:55:00',2.18),('5819','2013-12-22','13:00:00',2.08),('5819','2013-12-22','13:05:00',2.48),('5819','2013-12-22','13:10:00',2.51),('5819','2013-12-22','13:15:00',1.94),('5819','2013-12-22','13:20:00',1.84),('5819','2013-12-22','13:25:00',1.83),('5819','2013-12-22','13:30:00',1.7),('5819','2013-12-22','13:35:00',1.62),('5819','2013-12-22','13:40:00',1.29),('5819','2013-12-22','13:45:00',1.46),('5819','2013-12-22','13:50:00',1.4),('5819','2013-12-22','13:55:00',1.2),('5819','2013-12-22','14:00:00',1.1),('5819','2013-12-22','14:05:00',1.19),('5819','2013-12-22','14:10:00',1.37),('5819','2013-12-22','14:15:00',1.02),('5819','2013-12-22','14:20:00',1.02),('5819','2013-12-22','14:40:00',1.05),('5819','2013-12-22','14:45:00',1.02),('5819','2013-12-21','08:40:00',1.07),('5819','2013-12-21','08:45:00',1.15),('5819','2013-12-21','08:50:00',1.23),('5819','2013-12-21','08:55:00',1.29),('5819','2013-12-21','09:00:00',1.37),('5819','2013-12-21','09:05:00',1.42),('5819','2013-12-21','09:10:00',1.47),('5819','2013-12-21','09:15:00',1.54),('5819','2013-12-21','09:20:00',1.6),('5819','2013-12-21','09:25:00',1.65),('5819','2013-12-21','09:30:00',1.71),('5819','2013-12-21','09:35:00',1.77),('5819','2013-12-21','09:40:00',1.81),('5819','2013-12-21','09:45:00',1.86),('5819','2013-12-21','09:50:00',1.91),('5819','2013-12-21','09:55:00',1.98),('5819','2013-12-21','10:00:00',2.03),('5819','2013-12-21','10:05:00',2.08),('5819','2013-12-21','10:10:00',2.11),('5819','2013-12-21','10:15:00',2.14),('5819','2013-12-21','10:20:00',2.17),('5819','2013-12-21','10:25:00',2.21),('5819','2013-12-21','10:30:00',2.26),('5819','2013-12-21','10:35:00',2.29),('5819','2013-12-21','10:40:00',2.3),('5819','2013-12-21','10:45:00',2.33),('5819','2013-12-21','10:50:00',2.35),('5819','2013-12-21','10:55:00',2.37),('5819','2013-12-21','11:00:00',2.4),('5819','2013-12-21','11:05:00',2.42),('5819','2013-12-21','11:10:00',2.43),('5819','2013-12-21','11:15:00',2.44),('5819','2013-12-21','11:20:00',2.46),('5819','2013-12-21','11:25:00',2.48),('5819','2013-12-21','11:30:00',2.49),('5819','2013-12-21','11:35:00',2.48),('5819','2013-12-21','11:40:00',2.48),('5819','2013-12-21','11:45:00',2.48),('5819','2013-12-21','11:50:00',2.48),('5819','2013-12-21','11:55:00',2.48),('5819','2013-12-21','12:00:00',2.47),('5819','2013-12-21','12:05:00',2.46),('5819','2013-12-21','12:10:00',2.45),('5819','2013-12-21','12:15:00',2.42),('5819','2013-12-21','12:20:00',2.4),('5819','2013-12-21','12:25:00',2.38),('5819','2013-12-21','12:30:00',2.36),('5819','2013-12-21','12:35:00',2.34),('5819','2013-12-21','12:40:00',2.31),('5819','2013-12-21','12:45:00',2.28),('5819','2013-12-21','12:50:00',2.26),('5819','2013-12-21','12:55:00',2.24),('5819','2013-12-21','13:00:00',2.18),('5819','2013-12-21','13:05:00',2.15),('5819','2013-12-21','13:10:00',2.12),('5819','2013-12-21','13:15:00',2.07),('5819','2013-12-21','13:20:00',2.01),('5819','2013-12-21','13:25:00',1.98),('5819','2013-12-21','13:30:00',1.93),('5819','2013-12-21','13:35:00',1.87),('5819','2013-12-21','13:40:00',1.83),('5819','2013-12-21','13:45:00',1.79),('5819','2013-12-21','13:50:00',1.73),('5819','2013-12-21','13:55:00',1.68),('5819','2013-12-21','14:00:00',1.63),('5819','2013-12-21','14:05:00',1.57),('5819','2013-12-21','14:10:00',1.5),('5819','2013-12-21','14:15:00',1.48),('5819','2013-12-21','14:20:00',1.44),('5819','2013-12-21','14:25:00',1.37),('5819','2013-12-21','14:30:00',1.31),('5819','2013-12-21','14:35:00',1.25),('5819','2013-12-21','14:40:00',1.19),('5819','2013-12-21','14:45:00',1.13),('5819','2013-12-21','14:50:00',1.05),('5819','2013-12-20','08:40:00',1.04),('5819','2013-12-20','08:45:00',1.08),('5819','2013-12-20','08:50:00',1.12),('5819','2013-12-20','08:55:00',1.18),('5819','2013-12-20','09:00:00',1.25),('5819','2013-12-20','09:05:00',1.33),('5819','2013-12-20','09:10:00',1.41),('5819','2013-12-20','09:15:00',1.47),('5819','2013-12-20','09:20:00',1.54),('5819','2013-12-20','09:25:00',1.62),('5819','2013-12-20','09:30:00',1.67),('5819','2013-12-20','09:35:00',1.73),('5819','2013-12-20','09:40:00',1.79),('5819','2013-12-20','09:45:00',1.84),('5819','2013-12-20','09:50:00',1.88),('5819','2013-12-20','09:55:00',1.9),('5819','2013-12-20','10:00:00',1.94),('5819','2013-12-20','10:05:00',2),('5819','2013-12-20','10:10:00',2.01),('5819','2013-12-20','10:15:00',2.04),('5819','2013-12-20','10:20:00',2.07),('5819','2013-12-20','10:25:00',2.12),('5819','2013-12-20','10:30:00',2.13),('5819','2013-12-20','10:35:00',2.16),('5819','2013-12-20','10:40:00',2.2),('5819','2013-12-20','10:45:00',2.22),('5819','2013-12-20','10:50:00',2.25),('5819','2013-12-20','10:55:00',2.27),('5819','2013-12-20','11:00:00',2.29),('5819','2013-12-20','11:05:00',2.3),('5819','2013-12-20','11:10:00',2.29),('5819','2013-12-20','11:15:00',2.3),('5819','2013-12-20','11:20:00',2.31),('5819','2013-12-20','11:25:00',2.32),('5819','2013-12-20','11:30:00',2.31),('5819','2013-12-20','11:35:00',2.3),('5819','2013-12-20','11:40:00',2.33),('5819','2013-12-20','11:45:00',2.33),('5819','2013-12-20','11:50:00',2.34),('5819','2013-12-20','11:55:00',2.36),('5819','2013-12-20','12:00:00',2.31),('5819','2013-12-20','12:05:00',2.29),('5819','2013-12-20','12:10:00',2.31),('5819','2013-12-20','12:15:00',2.28),('5819','2013-12-20','12:20:00',2.26),('5819','2013-12-20','12:25:00',2.21),('5819','2013-12-20','12:30:00',2.21),('5819','2013-12-20','12:35:00',2.18),('5819','2013-12-20','12:40:00',2.15),('5819','2013-12-20','12:45:00',2.1),('5819','2013-12-20','12:50:00',2.06),('5819','2013-12-20','12:55:00',2.05),('5819','2013-12-20','13:00:00',2.03),('5819','2013-12-20','13:05:00',2),('5819','2013-12-20','13:10:00',1.97),('5819','2013-12-20','13:15:00',1.91),('5819','2013-12-20','13:20:00',1.83),('5819','2013-12-20','13:25:00',1.8),('5819','2013-12-20','13:30:00',1.76),('5819','2013-12-20','13:35:00',1.71),('5819','2013-12-20','13:40:00',1.65),('5819','2013-12-20','13:45:00',1.62),('5819','2013-12-20','13:50:00',1.55),('5819','2013-12-20','13:55:00',1.46),('5819','2013-12-20','14:00:00',1.35),('5819','2013-12-20','14:05:00',1.08),('5819','2013-12-19','08:50:00',1.12),('5819','2013-12-19','08:55:00',1.25),('5819','2013-12-19','09:00:00',1.46),('5819','2013-12-19','09:05:00',1.59),('5819','2013-12-19','09:10:00',1.49),('5819','2013-12-19','09:15:00',1.42),('5819','2013-12-19','09:20:00',1.01),('5819','2013-12-19','09:25:00',1.81),('5819','2013-12-19','09:30:00',1.11),('5819','2013-12-19','09:35:00',1.44),('5819','2013-12-19','09:50:00',1.44),('5819','2013-12-19','09:55:00',2.17),('5819','2013-12-19','10:00:00',2.01),('5819','2013-12-19','10:05:00',2.03),('5819','2013-12-19','10:10:00',2.12),('5819','2013-12-19','10:15:00',2.15),('5819','2013-12-19','10:20:00',1.75),('5819','2013-12-19','10:30:00',1.07),('5819','2013-12-19','10:40:00',1.05),('5819','2013-12-19','10:45:00',1.77),('5819','2013-12-19','10:50:00',2.52),('5819','2013-12-19','10:55:00',1.27),('5819','2013-12-19','11:15:00',2.01),('5819','2013-12-19','11:20:00',1.29),('5819','2013-12-19','11:25:00',1.14),('5819','2013-12-19','14:30:00',1.14),('5819','2013-12-19','14:35:00',1.36),('5819','2013-12-19','14:40:00',1.18),('5819','2013-12-19','14:45:00',1.08),('5819','2013-12-18','08:35:00',1.03),('5819','2013-12-18','08:40:00',1.11),('5819','2013-12-18','08:45:00',1.19),('5819','2013-12-18','08:50:00',1.27),('5819','2013-12-18','08:55:00',1.34),('5819','2013-12-18','09:00:00',1.41),('5819','2013-12-18','09:05:00',1.46),('5819','2013-12-18','09:10:00',1.53),('5819','2013-12-18','09:15:00',1.58),('5819','2013-12-18','09:20:00',1.65),('5819','2013-12-18','09:25:00',1.72),('5819','2013-12-18','09:30:00',1.77),('5819','2013-12-18','09:35:00',1.83),('5819','2013-12-18','09:40:00',1.88),('5819','2013-12-18','09:45:00',1.93),('5819','2013-12-18','09:50:00',1.96),('5819','2013-12-18','09:55:00',2.01),('5819','2013-12-18','10:00:00',2.07),('5819','2013-12-18','10:05:00',2.11),('5819','2013-12-18','10:10:00',2.16),('5819','2013-12-18','10:15:00',2.2),('5819','2013-12-18','10:20:00',2.24),('5819','2013-12-18','10:25:00',2.28),('5819','2013-12-18','10:30:00',2.32),('5819','2013-12-18','10:35:00',2.33),('5819','2013-12-18','10:40:00',2.34),('5819','2013-12-18','10:45:00',2.35),('5819','2013-12-18','10:50:00',2.37),('5819','2013-12-18','10:55:00',2.39),('5819','2013-12-18','11:00:00',2.39),('5819','2013-12-18','11:05:00',2.41),('5819','2013-12-18','11:10:00',2.43),('5819','2013-12-18','11:15:00',2.43),('5819','2013-12-18','11:20:00',2.42),('5819','2013-12-18','11:25:00',2.41),('5819','2013-12-18','11:30:00',2.42),('5819','2013-12-18','11:35:00',2.41),('5819','2013-12-18','11:40:00',2.42),('5819','2013-12-18','11:45:00',2.4),('5819','2013-12-18','11:50:00',2.4),('5819','2013-12-18','11:55:00',2.4),('5819','2013-12-18','12:00:00',2.38),('5819','2013-12-18','12:05:00',2.38),('5819','2013-12-18','12:10:00',2.38),('5819','2013-12-18','12:15:00',2.37),('5819','2013-12-18','12:20:00',2.34),('5819','2013-12-18','12:25:00',2.32),('5819','2013-12-18','12:30:00',2.32),('5819','2013-12-18','12:35:00',2.29),('5819','2013-12-18','12:40:00',2.25),('5819','2013-12-18','12:45:00',2.22),('5819','2013-12-18','12:50:00',2.18),('5819','2013-12-18','12:55:00',2.16),('5819','2013-12-18','13:00:00',2.09),('5819','2013-12-18','13:05:00',2.07),('5819','2013-12-18','13:10:00',2.03),('5819','2013-12-18','13:15:00',1.98),('5819','2013-12-18','13:20:00',1.94),('5819','2013-12-18','13:25:00',1.89),('5819','2013-12-18','13:30:00',1.84),('5819','2013-12-18','13:35:00',1.79),('5819','2013-12-18','13:40:00',1.75),('5819','2013-12-18','13:45:00',1.67),('5819','2013-12-18','13:50:00',1.63),('5819','2013-12-18','13:55:00',1.57),('5819','2013-12-18','14:00:00',1.52),('5819','2013-12-18','14:05:00',1.47),('5819','2013-12-18','14:10:00',1.41),('5819','2013-12-18','14:15:00',1.39),('5819','2013-12-18','14:20:00',1.31),('5819','2013-12-18','14:25:00',1.27),('5819','2013-12-18','14:30:00',1.23),('5819','2013-12-18','14:35:00',1.17),('5819','2013-12-18','14:40:00',1.13),('5819','2013-12-18','14:45:00',1.05),('5819','2013-12-18','14:50:00',1.01),('5819','2014-04-22','07:45:00',1.03),('5819','2014-04-22','07:50:00',1.12),('5819','2014-04-22','07:55:00',1.21),('5819','2014-04-22','08:00:00',1.29),('5819','2014-04-22','08:05:00',1.37),('5819','2014-04-22','08:10:00',1.48),('5819','2014-04-22','08:15:00',1.58),('5819','2014-04-22','08:20:00',1.65),('5819','2014-04-22','08:25:00',1.74),('5819','2014-04-22','08:30:00',1.84),('5819','2014-04-22','08:35:00',1.9),('5819','2014-04-22','08:40:00',2.01),('5819','2014-04-22','08:45:00',2.06),('5819','2014-04-22','08:50:00',2.12),('5819','2014-04-22','08:55:00',2.15),('5819','2014-04-22','09:00:00',2.24),('5819','2014-04-22','09:05:00',2.41),('5819','2014-04-22','09:10:00',2.34),('5819','2014-04-22','09:15:00',2.3),('5819','2014-04-22','09:20:00',2.44),('5819','2014-04-22','09:25:00',2.11),('5819','2014-04-22','09:30:00',1.85),('5819','2014-04-22','09:35:00',2.5),('5819','2014-04-22','09:40:00',2.8),('5819','2014-04-22','09:45:00',2.94),('5819','2014-04-22','09:50:00',2.45),('5819','2014-04-22','09:55:00',1.43),('5819','2014-04-22','10:00:00',1.29),('5819','2014-04-22','10:05:00',1.34),('5819','2014-04-22','10:10:00',1.77),('5819','2014-04-22','10:15:00',1.91),('5819','2014-04-22','10:20:00',2.94),('5819','2014-04-22','10:25:00',2.16),('5819','2014-04-22','10:30:00',3.21),('5819','2014-04-22','10:35:00',3.49),('5819','2014-04-22','10:40:00',3.2),('5819','2014-04-22','10:45:00',3.49),('5819','2014-04-22','10:50:00',3.99),('5819','2014-04-22','10:55:00',2.97),('5819','2014-04-22','11:00:00',1.91),('5819','2014-04-22','11:05:00',2.11),('5819','2014-04-22','11:10:00',1.56),('5819','2014-04-22','11:15:00',1.27),('5819','2014-04-22','11:20:00',1.1),('5819','2014-04-22','11:25:00',1.11),('5819','2014-04-22','11:35:00',1.04),('5819','2014-04-22','12:05:00',1.04),('5819','2014-04-22','12:10:00',1.1),('5819','2014-04-22','12:15:00',1.11),('5819','2014-04-22','12:20:00',1.18),('5819','2014-04-22','12:25:00',1.25),('5819','2014-04-22','12:30:00',1.46),('5819','2014-04-22','12:35:00',1.34),('5819','2014-04-22','13:15:00',1.19),('5819','2014-04-22','13:20:00',2.03),('5819','2014-04-22','13:25:00',2.36),('5819','2014-04-22','13:30:00',2.64),('5819','2014-04-22','13:35:00',2.37),('5819','2014-04-22','13:40:00',2.91),('5819','2014-04-22','13:45:00',2.94),('5819','2014-04-22','13:50:00',2.63),('5819','2014-04-22','13:55:00',1.48),('5819','2014-04-22','14:00:00',1.24),('5819','2014-04-22','14:05:00',1.41),('5819','2014-04-22','14:10:00',3.11),('5819','2014-04-22','14:15:00',2.93),('5819','2014-04-22','14:20:00',3.2),('5819','2014-04-22','14:25:00',2.64),('5819','2014-04-22','14:30:00',1.8),('5819','2014-04-22','14:35:00',2.08),('5819','2014-04-22','14:40:00',2.83),('5819','2014-04-22','14:45:00',3.4),('5819','2014-04-22','14:50:00',3.13),('5819','2014-04-22','14:55:00',2.52),('5819','2014-04-22','15:00:00',1.25),('5819','2014-04-22','15:05:00',1.2),('5819','2014-04-22','15:10:00',1.1),('5819','2014-04-22','15:15:00',1.04),('5819','2014-04-22','15:20:00',1.16),('5819','2014-04-22','15:25:00',1.27),('5819','2014-04-22','15:30:00',1.53),('5819','2014-04-22','15:35:00',2.21),('5819','2014-04-22','15:40:00',1.98),('5819','2014-04-22','15:45:00',1.63),('5819','2014-04-22','15:50:00',1.91),('5819','2014-04-22','15:55:00',1.62),('5819','2014-04-22','16:00:00',1.88),('5819','2014-04-22','16:05:00',1.36),('5819','2014-04-22','16:10:00',1.27),('5819','2014-04-22','16:15:00',1.22),('5819','2014-04-22','16:20:00',1.42),('5819','2014-04-22','16:25:00',1.39),('5819','2014-04-22','16:30:00',1.16),('5819','2014-04-22','16:35:00',1.16),('5819','2014-04-22','16:40:00',1.5),('5819','2014-04-22','16:45:00',1.47),('5819','2014-04-22','16:50:00',1.17),('5819','2014-04-22','16:55:00',1.02),('5819','2014-04-22','17:00:00',1.05),('5819','2014-04-22','17:05:00',1.25),('5819','2014-04-22','17:10:00',1),('5819','2013-12-17','08:30:00',1.06),('5819','2013-12-17','08:35:00',1.15),('5819','2013-12-17','08:40:00',1.24),('5819','2013-12-17','08:45:00',1.33),('5819','2013-12-17','08:50:00',1.41),('5819','2013-12-17','08:55:00',1.47),('5819','2013-12-17','09:00:00',1.55),('5819','2013-12-17','09:05:00',1.62),('5819','2013-12-17','09:10:00',1.68),('5819','2013-12-17','09:15:00',1.73),('5819','2013-12-17','09:20:00',1.78),('5819','2013-12-17','09:25:00',1.84),('5819','2013-12-17','09:30:00',1.89),('5819','2013-12-17','09:35:00',1.94),('5819','2013-12-17','09:40:00',2),('5819','2013-12-17','09:45:00',2.06),('5819','2013-12-17','09:50:00',2.11),('5819','2013-12-17','09:55:00',2.15),('5819','2013-12-17','10:00:00',2.19),('5819','2013-12-17','10:05:00',2.23),('5819','2013-12-17','10:10:00',2.26),('5819','2013-12-17','10:15:00',2.27),('5819','2013-12-17','10:20:00',2.32),('5819','2013-12-17','10:25:00',2.35),('5819','2013-12-17','10:30:00',2.39),('5819','2013-12-17','10:35:00',2.41),('5819','2013-12-17','10:40:00',2.43),('5819','2013-12-17','10:45:00',2.44),('5819','2013-12-17','10:50:00',2.44),('5819','2013-12-17','10:55:00',2.47),('5819','2013-12-17','11:00:00',2.48),('5819','2013-12-17','11:05:00',2.48),('5819','2013-12-17','11:10:00',2.49),('5819','2013-12-17','11:15:00',2.51),('5819','2013-12-17','11:20:00',2.51),('5819','2013-12-17','11:25:00',2.51),('5819','2013-12-17','11:30:00',2.54),('5819','2013-12-17','11:35:00',2.54),('5819','2013-12-17','11:40:00',2.54),('5819','2013-12-17','11:45:00',2.54),('5819','2013-12-17','11:50:00',2.54),('5819','2013-12-17','11:55:00',2.52),('5819','2013-12-17','12:00:00',2.5),('5819','2013-12-17','12:05:00',2.48),('5819','2013-12-17','12:10:00',2.47),('5819','2013-12-17','12:15:00',2.46),('5819','2013-12-17','12:20:00',2.45),('5819','2013-12-17','12:25:00',2.43),('5819','2013-12-17','12:30:00',2.41),('5819','2013-12-17','12:35:00',2.41),('5819','2013-12-17','12:40:00',2.36),('5819','2013-12-17','12:45:00',2.32),('5819','2013-12-17','12:50:00',2.29),('5819','2013-12-17','12:55:00',2.26),('5819','2013-12-17','13:00:00',2.22),('5819','2013-12-17','13:05:00',2.18),('5819','2013-12-17','13:10:00',2.13),('5819','2013-12-17','13:15:00',2.07),('5819','2013-12-17','13:20:00',2.03),('5819','2013-12-17','13:25:00',1.98),('5819','2013-12-17','13:30:00',1.94),('5819','2013-12-17','13:35:00',1.91),('5819','2013-12-17','13:40:00',1.87),('5819','2013-12-17','13:45:00',1.81),('5819','2013-12-17','13:50:00',1.75),('5819','2013-12-17','13:55:00',1.69),('5819','2013-12-17','14:00:00',1.64),('5819','2013-12-17','14:05:00',1.58),('5819','2013-12-17','14:10:00',1.51),('5819','2013-12-17','14:15:00',1.44),('5819','2013-12-17','14:20:00',1.39),('5819','2013-12-17','14:25:00',1.34),('5819','2013-12-17','14:30:00',1.27),('5819','2013-12-17','14:35:00',1.23),('5819','2013-12-17','14:40:00',1.17),('5819','2013-12-17','14:45:00',1.09),('5819','2013-12-17','14:50:00',1.04),('5819','2013-12-16','08:30:00',1.07),('5819','2013-12-16','08:35:00',1.15),('5819','2013-12-16','08:40:00',1.22),('5819','2013-12-16','08:45:00',1.29),('5819','2013-12-16','08:50:00',1.36),('5819','2013-12-16','08:55:00',1.44),('5819','2013-12-16','09:00:00',1.52),('5819','2013-12-16','09:05:00',1.58),('5819','2013-12-16','09:10:00',1.64),('5819','2013-12-16','09:15:00',1.69),('5819','2013-12-16','09:20:00',1.74),('5819','2013-12-16','09:25:00',1.81),('5819','2013-12-16','09:30:00',1.87),('5819','2013-12-16','09:35:00',1.93),('5819','2013-12-16','09:40:00',1.99),('5819','2013-12-16','09:45:00',2.03),('5819','2013-12-16','09:50:00',2.08),('5819','2013-12-16','09:55:00',2.1),('5819','2013-12-16','10:00:00',2.14),('5819','2013-12-16','10:05:00',2.18),('5819','2013-12-16','10:10:00',2.22),('5819','2013-12-16','10:15:00',2.25),('5819','2013-12-16','10:20:00',2.26),('5819','2013-12-16','10:25:00',2.27),('5819','2013-12-16','10:30:00',2.28),('5819','2013-12-16','10:35:00',2.31),('5819','2013-12-16','10:40:00',2.34),('5819','2013-12-16','10:45:00',2.36),('5819','2013-12-16','10:50:00',2.39),('5819','2013-12-16','10:55:00',2.41),('5819','2013-12-16','11:00:00',2.43),('5819','2013-12-16','11:05:00',2.44),('5819','2013-12-16','11:10:00',2.44),('5819','2013-12-16','11:15:00',2.44),('5819','2013-12-16','11:20:00',2.44),('5819','2013-12-16','11:25:00',2.46),('5819','2013-12-16','11:30:00',2.48),('5819','2013-12-16','11:35:00',2.48),('5819','2013-12-16','11:40:00',2.48),('5819','2013-12-16','11:45:00',2.47),('5819','2013-12-16','11:50:00',2.46),('5819','2013-12-16','11:55:00',2.47),('5819','2013-12-16','12:00:00',2.48),('5819','2013-12-16','12:05:00',2.47),('5819','2013-12-16','12:10:00',2.47),('5819','2013-12-16','12:15:00',2.45),('5819','2013-12-16','12:20:00',2.44),('5819','2013-12-16','12:25:00',2.42),('5819','2013-12-16','12:30:00',2.39),('5819','2013-12-16','12:35:00',2.36),('5819','2013-12-16','12:40:00',2.35),('5819','2013-12-16','12:45:00',2.32),('5819','2013-12-16','12:50:00',2.29),('5819','2013-12-16','12:55:00',2.25),('5819','2013-12-16','13:00:00',2.23),('5819','2013-12-16','13:05:00',2.19),('5819','2013-12-16','13:10:00',2.14),('5819','2013-12-16','13:15:00',2.08),('5819','2013-12-16','13:20:00',2.02),('5819','2013-12-16','13:25:00',1.96),('5819','2013-12-16','13:30:00',1.93),('5819','2013-12-16','13:35:00',1.87),('5819','2013-12-16','13:40:00',1.84),('5819','2013-12-16','13:45:00',1.8),('5819','2013-12-16','13:50:00',1.74),('5819','2013-12-16','13:55:00',1.68),('5819','2013-12-16','14:00:00',1.59),('5819','2013-12-16','14:05:00',1.57),('5819','2013-12-16','14:10:00',1.49),('5819','2013-12-16','14:15:00',1.45),('5819','2013-12-16','14:20:00',1.39),('5819','2013-12-16','14:25:00',1.34),('5819','2013-12-16','14:30:00',1.28),('5819','2013-12-16','14:35:00',1.22),('5819','2013-12-16','14:40:00',1.16),('5819','2013-12-16','14:45:00',1.09),('5819','2013-12-16','14:50:00',1.03),('5819','2013-12-15','10:20:00',1.25),('5819','2013-12-15','10:25:00',1.15),('5819','2013-12-15','10:30:00',1.05),('5819','2013-12-15','10:35:00',1.21),('5819','2013-12-15','10:40:00',1.24),('5819','2013-12-15','10:45:00',1.18),('5819','2013-12-14','08:35:00',1.01),('5819','2013-12-14','08:40:00',1.08),('5819','2013-12-14','08:45:00',1.16),('5819','2013-12-14','08:50:00',1.26),('5819','2013-12-14','08:55:00',1.33),('5819','2013-12-14','09:00:00',1.42),('5819','2013-12-14','09:05:00',1.5),('5819','2013-12-14','09:10:00',1.57),('5819','2013-12-14','09:15:00',1.64),('5819','2013-12-14','09:20:00',1.7),('5819','2013-12-14','09:25:00',1.77),('5819','2013-12-14','09:30:00',1.83),('5819','2013-12-14','09:35:00',1.87),('5819','2013-12-14','09:40:00',1.92),('5819','2013-12-14','09:45:00',1.97),('5819','2013-12-14','09:50:00',2),('5819','2013-12-14','09:55:00',2.03),('5819','2013-12-14','10:00:00',2.06),('5819','2013-12-14','10:05:00',2.09),('5819','2013-12-14','10:10:00',2.14),('5819','2013-12-14','10:15:00',2.18),('5819','2013-12-14','10:20:00',2.21),('5819','2013-12-14','10:25:00',2.23),('5819','2013-12-14','10:30:00',2.24),('5819','2013-12-14','10:35:00',2.29),('5819','2013-12-14','10:40:00',2.3),('5819','2013-12-14','10:45:00',2.32),('5819','2013-12-14','10:50:00',2.34),('5819','2013-12-14','10:55:00',2.33),('5819','2013-12-14','11:00:00',2.34),('5819','2013-12-14','11:05:00',2.34),('5819','2013-12-14','11:10:00',2.38),('5819','2013-12-14','11:15:00',2.37),('5819','2013-12-14','11:20:00',2.39),('5819','2013-12-14','11:25:00',2.38),('5819','2013-12-14','11:30:00',2.38),('5819','2013-12-14','11:35:00',2.37),('5819','2013-12-14','11:40:00',2.41),('5819','2013-12-14','11:45:00',2.38),('5819','2013-12-14','11:50:00',2.34),('5819','2013-12-14','11:55:00',2.3),('5819','2013-12-14','12:00:00',2.28),('5819','2013-12-14','12:05:00',2.27),('5819','2013-12-14','12:10:00',2.26),('5819','2013-12-14','12:15:00',2.27),('5819','2013-12-14','12:20:00',2.24),('5819','2013-12-14','12:25:00',2.2),('5819','2013-12-14','12:30:00',2.13),('5819','2013-12-14','12:35:00',2.12),('5819','2013-12-14','12:40:00',2.1),('5819','2013-12-14','12:45:00',2.06),('5819','2013-12-14','12:50:00',2.11),('5819','2013-12-14','12:55:00',2.05),('5819','2013-12-14','13:00:00',2.03),('5819','2013-12-14','13:05:00',1.99),('5819','2013-12-14','13:10:00',1.97),('5819','2013-12-14','13:15:00',1.93),('5819','2013-12-14','13:20:00',1.93),('5819','2013-12-14','13:25:00',1.9),('5819','2013-12-14','13:30:00',1.83),('5819','2013-12-14','13:35:00',1.78),('5819','2013-12-14','13:40:00',1.79),('5819','2013-12-14','13:45:00',1.77),('5819','2013-12-14','13:50:00',1.71),('5819','2013-12-14','13:55:00',1.65),('5819','2013-12-14','14:00:00',1.57),('5819','2013-12-14','14:05:00',1.54),('5819','2013-12-14','14:10:00',1.47),('5819','2013-12-14','14:15:00',1.43),('5819','2013-12-14','14:20:00',1.37),('5819','2013-12-14','14:25:00',1.31),('5819','2013-12-14','14:30:00',1.26),('5819','2013-12-14','14:35:00',1.2),('5819','2013-12-14','14:40:00',1.14),('5819','2013-12-14','14:45:00',1.06),('5819','2013-12-13','08:40:00',1),('5819','2013-12-13','08:45:00',1.07),('5819','2013-12-13','08:50:00',1.15),('5819','2013-12-13','08:55:00',1.22),('5819','2013-12-13','09:00:00',1.27),('5819','2013-12-13','09:05:00',1.34),('5819','2013-12-13','09:10:00',1.4),('5819','2013-12-13','09:15:00',1.48),('5819','2013-12-13','09:20:00',1.54),('5819','2013-12-13','09:25:00',1.59),('5819','2013-12-13','09:30:00',1.62),('5819','2013-12-13','09:35:00',1.65),('5819','2013-12-13','09:40:00',1.71),('5819','2013-12-13','09:45:00',1.77),('5819','2013-12-13','09:50:00',1.82),('5819','2013-12-13','09:55:00',1.87),('5819','2013-12-13','10:00:00',1.89),('5819','2013-12-13','10:05:00',1.93),('5819','2013-12-13','10:10:00',1.97),('5819','2013-12-13','10:15:00',2.02),('5819','2013-12-13','10:20:00',2.06),('5819','2013-12-13','10:25:00',2.08),('5819','2013-12-13','10:30:00',2.12),('5819','2013-12-13','10:35:00',2.15),('5819','2013-12-13','10:40:00',2.18),('5819','2013-12-13','10:45:00',2.19),('5819','2013-12-13','10:50:00',2.21),('5819','2013-12-13','10:55:00',2.25),('5819','2013-12-13','11:00:00',2.26),('5819','2013-12-13','11:05:00',2.27),('5819','2013-12-13','11:10:00',2.24),('5819','2013-12-13','11:15:00',2.27),('5819','2013-12-13','11:20:00',2.31),('5819','2013-12-13','11:25:00',2.3),('5819','2013-12-13','11:30:00',2.29),('5819','2013-12-13','11:35:00',2.28),('5819','2013-12-13','11:40:00',2.27),('5819','2013-12-13','11:45:00',2.3),('5819','2013-12-13','11:50:00',2.29),('5819','2013-12-13','11:55:00',2.29),('5819','2013-12-13','12:00:00',2.32),('5819','2013-12-13','12:05:00',2.28),('5819','2013-12-13','12:10:00',2.22),('5819','2013-12-13','12:15:00',2.2),('5819','2013-12-13','12:20:00',2.14),('5819','2013-12-13','12:25:00',2.19),('5819','2013-12-13','12:30:00',2.19),('5819','2013-12-13','12:35:00',2.15),('5819','2013-12-13','12:40:00',2.11),('5819','2013-12-13','12:45:00',2.12),('5819','2013-12-13','12:50:00',2.08),('5819','2013-12-13','12:55:00',2.02),('5819','2013-12-13','13:00:00',2.02),('5819','2013-12-13','13:05:00',2.01),('5819','2013-12-13','13:10:00',1.96),('5819','2013-12-13','13:15:00',1.94),('5819','2013-12-13','13:20:00',1.84),('5819','2013-12-13','13:25:00',1.87),('5819','2013-12-13','13:30:00',1.87),('5819','2013-12-13','13:35:00',1.8),('5819','2013-12-13','13:40:00',1.72),('5819','2013-12-13','13:45:00',1.7),('5819','2013-12-13','13:50:00',1.65),('5819','2013-12-13','13:55:00',1.6),('5819','2013-12-13','14:00:00',1.55),('5819','2013-12-13','14:05:00',1.5),('5819','2013-12-13','14:10:00',1.45),('5819','2013-12-13','14:15:00',1.43),('5819','2013-12-13','14:20:00',1.35),('5819','2013-12-13','14:25:00',1.31),('5819','2013-12-13','14:30:00',1.26),('5819','2013-12-13','14:35:00',1.2),('5819','2013-12-13','14:40:00',1.13),('5819','2013-12-13','14:45:00',1.07),('5819','2013-12-13','14:50:00',1.04),('5819','2013-12-12','08:35:00',1.03),('5819','2013-12-12','08:40:00',1.1),('5819','2013-12-12','08:45:00',1.19),('5819','2013-12-12','08:50:00',1.29),('5819','2013-12-12','08:55:00',1.36),('5819','2013-12-12','09:00:00',1.41),('5819','2013-12-12','09:05:00',1.47),('5819','2013-12-12','09:10:00',1.53),('5819','2013-12-12','09:15:00',1.58),('5819','2013-12-12','09:20:00',1.64),('5819','2013-12-12','09:25:00',1.71),('5819','2013-12-12','09:30:00',1.77),('5819','2013-12-12','09:35:00',1.84),('5819','2013-12-12','09:40:00',1.89),('5819','2013-12-12','09:45:00',1.93),('5819','2013-12-12','09:50:00',1.97),('5819','2013-12-12','09:55:00',2),('5819','2013-12-12','10:00:00',2.05),('5819','2013-12-12','10:05:00',2.1),('5819','2013-12-12','10:10:00',2.14),('5819','2013-12-12','10:15:00',2.18),('5819','2013-12-12','10:20:00',2.2),('5819','2013-12-12','10:25:00',2.22),('5819','2013-12-12','10:30:00',2.25),('5819','2013-12-12','10:35:00',2.28),('5819','2013-12-12','10:40:00',2.3),('5819','2013-12-12','10:45:00',2.32),('5819','2013-12-12','10:50:00',2.33),('5819','2013-12-12','10:55:00',2.34),('5819','2013-12-12','11:00:00',2.34),('5819','2013-12-12','11:05:00',2.36),('5819','2013-12-12','11:10:00',2.35),('5819','2013-12-12','11:15:00',2.36),('5819','2013-12-12','11:20:00',2.36),('5819','2013-12-12','11:25:00',2.37),('5819','2013-12-12','11:30:00',2.39),('5819','2013-12-12','11:35:00',2.42),('5819','2013-12-12','11:40:00',2.38),('5819','2013-12-12','11:45:00',2.36),('5819','2013-12-12','11:50:00',2.32),('5819','2013-12-12','11:55:00',2.32),('5819','2013-12-12','12:00:00',2.33),('5819','2013-12-12','12:05:00',2.33),('5819','2013-12-12','12:10:00',2.32),('5819','2013-12-12','12:15:00',2.3),('5819','2013-12-12','12:20:00',2.27),('5819','2013-12-12','12:25:00',2.27),('5819','2013-12-12','12:30:00',2.25),('5819','2013-12-12','12:35:00',2.22),('5819','2013-12-12','12:40:00',2.18),('5819','2013-12-12','12:45:00',2.16),('5819','2013-12-12','12:50:00',2.16),('5819','2013-12-12','12:55:00',2.07),('5819','2013-12-12','13:00:00',2.05),('5819','2013-12-12','13:05:00',2),('5819','2013-12-12','13:10:00',1.97),('5819','2013-12-12','13:15:00',1.96),('5819','2013-12-12','13:20:00',1.94),('5819','2013-12-12','13:25:00',1.87),('5819','2013-12-12','13:30:00',1.8),('5819','2013-12-12','13:35:00',1.82),('5819','2013-12-12','13:40:00',1.75),('5819','2013-12-12','13:45:00',1.69),('5819','2013-12-12','13:50:00',1.67),('5819','2013-12-12','13:55:00',1.63),('5819','2013-12-12','14:00:00',1.54),('5819','2013-12-12','14:05:00',1.5),('5819','2013-12-12','14:10:00',1.44),('5819','2013-12-12','14:15:00',1.38),('5819','2013-12-12','14:20:00',1.33),('5819','2013-12-12','14:25:00',1.27),('5819','2013-12-12','14:30:00',1.19),('5819','2013-12-12','14:35:00',1.13),('5819','2013-12-12','14:40:00',1.1),('5819','2013-12-12','14:45:00',1.03),('5819','2013-12-11','08:30:00',1.02),('5819','2013-12-11','08:35:00',1.09),('5819','2013-12-11','08:40:00',1.16),('5819','2013-12-11','08:45:00',1.24),('5819','2013-12-11','08:50:00',1.33),('5819','2013-12-11','08:55:00',1.41),('5819','2013-12-11','09:00:00',1.47),('5819','2013-12-11','09:05:00',1.53),('5819','2013-12-11','09:10:00',1.61),('5819','2013-12-11','09:15:00',1.66),('5819','2013-12-11','09:20:00',1.72),('5819','2013-12-11','09:25:00',1.78),('5819','2013-12-11','09:30:00',1.85),('5819','2013-12-11','09:35:00',1.9),('5819','2013-12-11','09:40:00',1.96),('5819','2013-12-11','09:45:00',2.02),('5819','2013-12-11','09:50:00',2.06),('5819','2013-12-11','09:55:00',2.12),('5819','2013-12-11','10:00:00',2.14),('5819','2013-12-11','10:05:00',2.17),('5819','2013-12-11','10:10:00',2.22),('5819','2013-12-11','10:15:00',2.26),('5819','2013-12-11','10:20:00',2.3),('5819','2013-12-11','10:25:00',2.34),('5819','2013-12-11','10:30:00',2.4),('5819','2013-12-11','10:35:00',2.44),('5819','2013-12-11','10:40:00',2.45),('5819','2013-12-11','10:45:00',2.42),('5819','2013-12-11','10:50:00',2.41),('5819','2013-12-11','10:55:00',2.43),('5819','2013-12-11','11:00:00',2.48),('5819','2013-12-11','11:05:00',2.51),('5819','2013-12-11','11:10:00',2.52),('5819','2013-12-11','11:15:00',2.5),('5819','2013-12-11','11:20:00',2.51),('5819','2013-12-11','11:25:00',2.45),('5819','2013-12-11','11:30:00',2.44),('5819','2013-12-11','11:35:00',2.47),('5819','2013-12-11','11:40:00',2.5),('5819','2013-12-11','11:45:00',2.48),('5819','2013-12-11','11:50:00',2.5),('5819','2013-12-11','11:55:00',2.5),('5819','2013-12-11','12:00:00',2.5),('5819','2013-12-11','12:05:00',2.47),('5819','2013-12-11','12:10:00',2.46),('5819','2013-12-11','12:15:00',2.46),('5819','2013-12-11','12:20:00',2.42),('5819','2013-12-11','12:25:00',2.33),('5819','2013-12-11','12:30:00',2.3),('5819','2013-12-11','12:35:00',2.29),('5819','2013-12-11','12:40:00',2.27),('5819','2013-12-11','12:45:00',2.27),('5819','2013-12-11','12:50:00',2.22),('5819','2013-12-11','12:55:00',2.2),('5819','2013-12-11','13:00:00',2.19),('5819','2013-12-11','13:05:00',2.14),('5819','2013-12-11','13:10:00',2.08),('5819','2013-12-11','13:15:00',2.02),('5819','2013-12-11','13:20:00',1.99),('5819','2013-12-11','13:25:00',1.96),('5819','2013-12-11','13:30:00',1.93),('5819','2013-12-11','13:35:00',1.87),('5819','2013-12-11','13:40:00',1.83),('5819','2013-12-11','13:45:00',1.77),('5819','2013-12-11','13:50:00',1.71),('5819','2013-12-11','13:55:00',1.66),('5819','2013-12-11','14:00:00',1.6),('5819','2013-12-11','14:05:00',1.56),('5819','2013-12-11','14:10:00',1.52),('5819','2013-12-11','14:15:00',1.46),('5819','2013-12-11','14:20:00',1.4),('5819','2013-12-11','14:25:00',1.34),('5819','2013-12-11','14:30:00',1.28),('5819','2013-12-11','14:35:00',1.22),('5819','2013-12-11','14:40:00',1.16),('5819','2013-12-11','14:45:00',1.09),('5819','2013-12-11','14:50:00',1.02),('5819','2013-12-10','08:25:00',1),('5819','2013-12-10','08:30:00',1.08),('5819','2013-12-10','08:35:00',1.16),('5819','2013-12-10','08:40:00',1.21),('5819','2013-12-10','08:45:00',1.29),('5819','2013-12-10','08:50:00',1.38),('5819','2013-12-10','08:55:00',1.45),('5819','2013-12-10','09:00:00',1.52),('5819','2013-12-10','09:05:00',1.59),('5819','2013-12-10','09:10:00',1.65),('5819','2013-12-10','09:15:00',1.71),('5819','2013-12-10','09:20:00',1.79),('5819','2013-12-10','09:25:00',1.85),('5819','2013-12-10','09:30:00',1.89),('5819','2013-12-10','09:35:00',1.93),('5819','2013-12-10','09:40:00',1.98),('5819','2013-12-10','09:45:00',2.03),('5819','2013-12-10','09:50:00',2.06),('5819','2013-12-10','09:55:00',2.12),('5819','2013-12-10','10:00:00',2.16),('5819','2013-12-10','10:05:00',2.21),('5819','2013-12-10','10:10:00',2.25),('5819','2013-12-10','10:15:00',2.28),('5819','2013-12-10','10:20:00',2.28),('5819','2013-12-10','10:25:00',2.3),('5819','2013-12-10','10:30:00',2.34),('5819','2013-12-10','10:35:00',2.37),('5819','2013-12-10','10:40:00',2.39),('5819','2013-12-10','10:45:00',2.42),('5819','2013-12-10','10:50:00',2.45),('5819','2013-12-10','10:55:00',2.46),('5819','2013-12-10','11:00:00',2.47),('5819','2013-12-10','11:05:00',2.49),('5819','2013-12-10','11:10:00',2.49),('5819','2013-12-10','11:15:00',2.51),('5819','2013-12-10','11:20:00',2.53),('5819','2013-12-10','11:25:00',2.54),('5819','2013-12-10','11:30:00',2.55),('5819','2013-12-10','11:35:00',2.55),('5819','2013-12-10','11:40:00',2.55),('5819','2013-12-10','11:45:00',2.54),('5819','2013-12-10','11:50:00',2.53),('5819','2013-12-10','11:55:00',2.52),('5819','2013-12-10','12:00:00',2.5),('5819','2013-12-10','12:05:00',2.47),('5819','2013-12-10','12:10:00',2.45),('5819','2013-12-10','12:15:00',2.43),('5819','2013-12-10','12:20:00',2.41),('5819','2013-12-10','12:25:00',2.37),('5819','2013-12-10','12:30:00',2.34),('5819','2013-12-10','12:35:00',2.28),('5819','2013-12-10','12:40:00',2.25),('5819','2013-12-10','12:45:00',2.23),('5819','2013-12-10','12:50:00',2.19),('5819','2013-12-10','12:55:00',2.13),('5819','2013-12-10','13:00:00',2.07),('5819','2013-12-10','13:05:00',2.09),('5819','2013-12-10','13:10:00',2.05),('5819','2013-12-10','13:15:00',1.99),('5819','2013-12-10','13:20:00',1.95),('5819','2013-12-10','13:25:00',1.91),('5819','2013-12-10','13:30:00',1.9),('5819','2013-12-10','13:35:00',1.89),('5819','2013-12-10','13:40:00',1.85),('5819','2013-12-10','13:45:00',1.8),('5819','2013-12-10','13:50:00',1.75),('5819','2013-12-10','13:55:00',1.7),('5819','2013-12-10','14:00:00',1.65),('5819','2013-12-10','14:05:00',1.58),('5819','2013-12-10','14:10:00',1.52),('5819','2013-12-10','14:15:00',1.47),('5819','2013-12-10','14:20:00',1.42),('5819','2013-12-10','14:25:00',1.38),('5819','2013-12-10','14:30:00',1.32),('5819','2013-12-10','14:35:00',1.25),('5819','2013-12-10','14:40:00',1.19),('5819','2013-12-10','14:45:00',1.12),('5819','2013-12-10','14:50:00',1.07),('5819','2013-12-10','14:55:00',1.01),('5819','2013-12-09','09:35:00',1.84),('5819','2013-12-09','09:40:00',1.97),('5819','2013-12-09','09:45:00',2),('5819','2013-12-09','09:50:00',2.01),('5819','2013-12-09','09:55:00',2.07),('5819','2013-12-09','10:00:00',2.09),('5819','2013-12-09','10:05:00',2.19),('5819','2013-12-09','10:10:00',2.62),('5819','2013-12-09','10:15:00',2.57),('5819','2013-12-09','10:20:00',2.84),('5819','2013-12-09','10:25:00',1.84),('5819','2013-12-09','12:30:00',1.88),('5819','2013-12-09','12:35:00',1.23),('5819','2013-12-09','12:40:00',1.1),('5819','2013-12-09','12:45:00',1.5),('5819','2013-12-09','12:50:00',1.41),('5819','2013-12-09','12:55:00',1.65),('5819','2013-12-09','13:00:00',2.33),('5819','2013-12-09','13:05:00',2.02),('5819','2013-12-09','13:10:00',1.6),('5819','2013-12-09','13:15:00',1.33),('5819','2013-12-09','13:20:00',1.62),('5819','2013-12-09','13:25:00',1.18),('5819','2013-12-09','13:50:00',1.03),('5819','2013-12-09','13:55:00',1.1),('5819','2013-12-08','08:50:00',1.21),('5819','2013-12-08','09:55:00',1.05),('5819','2013-12-08','10:40:00',1.01),('5819','2013-12-08','10:45:00',1.01),('5819','2013-12-08','10:50:00',1.04),('5819','2013-12-08','10:55:00',1.08),('5819','2013-12-08','11:00:00',1.21),('5819','2013-12-08','11:05:00',1.19),('5819','2013-12-08','11:10:00',1.21),('5819','2013-12-08','11:15:00',1.5),('5819','2013-12-08','11:20:00',1.66),('5819','2013-12-08','11:25:00',1.02),('5819','2013-12-08','13:00:00',1.08),('5819','2013-12-08','13:15:00',1.6),('5819','2013-12-08','13:20:00',1.53),('5819','2013-12-08','13:25:00',1.29),('5819','2014-04-21','09:20:00',1.34),('5819','2014-04-21','09:25:00',1.22),('5819','2014-04-21','10:00:00',1.35),('5819','2014-04-21','10:05:00',2.26),('5819','2014-04-21','10:10:00',3.17),('5819','2014-04-21','10:15:00',3.4),('5819','2014-04-21','10:20:00',3.29),('5819','2014-04-21','10:25:00',3.3),('5819','2014-04-21','10:30:00',3.29),('5819','2014-04-21','10:35:00',3.31),('5819','2014-04-21','10:40:00',3.33),('5819','2014-04-21','10:45:00',3.38),('5819','2014-04-21','10:50:00',3.4),('5819','2014-04-21','10:55:00',3.44),('5819','2014-04-21','11:00:00',3.46),('5819','2014-04-21','11:05:00',3.49),('5819','2014-04-21','11:10:00',3.5),('5819','2014-04-21','11:15:00',3.54),('5819','2014-04-21','11:20:00',3.55),('5819','2014-04-21','11:25:00',3.57),('5819','2014-04-21','11:30:00',3.6),('5819','2014-04-21','11:35:00',3.63),('5819','2014-04-21','11:40:00',3.64),('5819','2014-04-21','11:45:00',3.68),('5819','2014-04-21','11:50:00',3.71),('5819','2014-04-21','11:55:00',3.72),('5819','2014-04-21','12:00:00',3.72),('5819','2014-04-21','12:05:00',3.72),('5819','2014-04-21','12:10:00',3.75),('5819','2014-04-21','12:15:00',3.76),('5819','2014-04-21','12:20:00',3.8),('5819','2014-04-21','12:25:00',3.81),('5819','2014-04-21','12:30:00',3.82),('5819','2014-04-21','12:35:00',3.82),('5819','2014-04-21','12:40:00',3.84),('5819','2014-04-21','12:45:00',3.84),('5819','2014-04-21','12:50:00',3.85),('5819','2014-04-21','12:55:00',3.84),('5819','2014-04-21','13:00:00',3.8),('5819','2014-04-21','13:05:00',3.78),('5819','2014-04-21','13:10:00',3.8),('5819','2014-04-21','13:15:00',3.77),('5819','2014-04-21','13:20:00',3.76),('5819','2014-04-21','13:25:00',3.75),('5819','2014-04-21','13:30:00',3.74),('5819','2014-04-21','13:35:00',3.71),('5819','2014-04-21','13:40:00',3.67),('5819','2014-04-21','13:45:00',3.71),('5819','2014-04-21','13:50:00',3.71),('5819','2014-04-21','13:55:00',3.71),('5819','2014-04-21','14:00:00',3.69),('5819','2014-04-21','14:05:00',3.66),('5819','2014-04-21','14:10:00',3.62),('5819','2014-04-21','14:15:00',3.6),('5819','2014-04-21','14:20:00',3.58),('5819','2014-04-21','14:25:00',3.54),('5819','2014-04-21','14:30:00',3.51),('5819','2014-04-21','14:35:00',3.46),('5819','2014-04-21','14:40:00',3.43),('5819','2014-04-21','14:45:00',3.38),('5819','2014-04-21','14:50:00',3.33),('5819','2014-04-21','14:55:00',3.3),('5819','2014-04-21','15:00:00',3.25),('5819','2014-04-21','15:05:00',3.2),('5819','2014-04-21','15:10:00',3.15),('5819','2014-04-21','15:15:00',3.1),('5819','2014-04-21','15:20:00',3.04),('5819','2014-04-21','15:25:00',2.98),('5819','2014-04-21','15:30:00',2.93),('5819','2014-04-21','15:35:00',2.87),('5819','2014-04-21','15:40:00',2.8),('5819','2014-04-21','15:45:00',2.74),('5819','2014-04-21','15:50:00',2.68),('5819','2014-04-21','15:55:00',2.62),('5819','2014-04-21','16:00:00',2.56),('5819','2014-04-21','16:05:00',2.5),('5819','2014-04-21','16:10:00',2.31),('5819','2014-04-21','16:15:00',1.89),('5819','2014-04-21','16:20:00',2.34),('5819','2014-04-21','16:25:00',2.22),('5819','2014-04-21','16:30:00',2.09),('5819','2014-04-21','16:35:00',2.05),('5819','2014-04-21','16:40:00',2.03),('5819','2014-04-21','16:45:00',1.96),('5819','2014-04-21','16:50:00',1.88),('5819','2014-04-21','16:55:00',1.78),('5819','2014-04-21','17:00:00',1.7),('5819','2014-04-21','17:05:00',1.63),('5819','2014-04-21','17:10:00',1.56),('5819','2014-04-21','17:15:00',1.47),('5819','2014-04-21','17:20:00',1.39),('5819','2014-04-21','17:25:00',1.31),('5819','2014-04-21','17:30:00',1.14),('5819','2014-04-21','17:35:00',1.11),('5819','2014-04-21','17:40:00',1.01),('5819','2013-12-07','08:25:00',1.05),('5819','2013-12-07','08:30:00',1.14),('5819','2013-12-07','08:35:00',1.2),('5819','2013-12-07','08:40:00',1.26),('5819','2013-12-07','08:45:00',1.32),('5819','2013-12-07','08:50:00',1.39),('5819','2013-12-07','08:55:00',1.46),('5819','2013-12-07','09:00:00',1.52),('5819','2013-12-07','09:05:00',1.58),('5819','2013-12-07','09:10:00',1.64),('5819','2013-12-07','09:15:00',1.72),('5819','2013-12-07','09:20:00',1.76),('5819','2013-12-07','09:25:00',1.81),('5819','2013-12-07','09:30:00',1.86),('5819','2013-12-07','09:35:00',1.93),('5819','2013-12-07','09:40:00',1.98),('5819','2013-12-07','09:45:00',2),('5819','2013-12-07','09:50:00',2.05),('5819','2013-12-07','09:55:00',2.08),('5819','2013-12-07','10:00:00',2.13),('5819','2013-12-07','10:05:00',2.17),('5819','2013-12-07','10:10:00',2.2),('5819','2013-12-07','10:15:00',2.22),('5819','2013-12-07','10:20:00',2.24),('5819','2013-12-07','10:25:00',2.28),('5819','2013-12-07','10:30:00',2.3),('5819','2013-12-07','10:35:00',2.35),('5819','2013-12-07','10:40:00',2.38),('5819','2013-12-07','10:45:00',2.38),('5819','2013-12-07','10:50:00',2.36),('5819','2013-12-07','10:55:00',2.35),('5819','2013-12-07','11:00:00',2.37),('5819','2013-12-07','11:05:00',2.39),('5819','2013-12-07','11:10:00',2.4),('5819','2013-12-07','11:15:00',2.4),('5819','2013-12-07','11:20:00',2.42),('5819','2013-12-07','11:25:00',2.42),('5819','2013-12-07','11:30:00',2.43),('5819','2013-12-07','11:35:00',2.39),('5819','2013-12-07','11:40:00',2.4),('5819','2013-12-07','11:45:00',2.37),('5819','2013-12-07','11:50:00',2.37),('5819','2013-12-07','11:55:00',2.35),('5819','2013-12-07','12:00:00',2.34),('5819','2013-12-07','12:05:00',2.32),('5819','2013-12-07','12:10:00',2.32),('5819','2013-12-07','12:15:00',2.31),('5819','2013-12-07','12:20:00',2.29),('5819','2013-12-07','12:25:00',2.27),('5819','2013-12-07','12:30:00',2.25),('5819','2013-12-07','12:35:00',2.23),('5819','2013-12-07','12:40:00',2.2),('5819','2013-12-07','12:45:00',2.18),('5819','2013-12-07','12:50:00',2.15),('5819','2013-12-07','12:55:00',2.07),('5819','2013-12-07','13:00:00',2.11),('5819','2013-12-07','13:05:00',2.07),('5819','2013-12-07','13:10:00',2.04),('5819','2013-12-07','13:15:00',2.02),('5819','2013-12-07','13:20:00',1.99),('5819','2013-12-07','13:25:00',1.93),('5819','2013-12-07','13:30:00',1.88),('5819','2013-12-07','13:35:00',1.85),('5819','2013-12-07','13:40:00',1.81),('5819','2013-12-07','13:45:00',1.76),('5819','2013-12-07','13:50:00',1.72),('5819','2013-12-07','13:55:00',1.65),('5819','2013-12-07','14:00:00',1.6),('5819','2013-12-07','14:05:00',1.54),('5819','2013-12-07','14:10:00',1.48),('5819','2013-12-07','14:15:00',1.41),('5819','2013-12-07','14:20:00',1.34),('5819','2013-12-07','14:25:00',1.29),('5819','2013-12-07','14:30:00',1.21),('5819','2013-12-07','14:35:00',1.15),('5819','2013-12-07','14:40:00',1.09),('5819','2013-12-07','14:45:00',1.04),('5819','2013-12-06','10:10:00',1.12),('5819','2013-12-06','11:35:00',1.18),('5819','2013-12-06','11:40:00',1.65),('5819','2013-12-06','11:45:00',1.52),('5819','2013-12-06','11:50:00',1.73),('5819','2013-12-06','11:55:00',1.57),('5819','2013-12-06','12:00:00',1.54),('5819','2013-12-06','12:05:00',1.44),('5819','2013-12-06','12:10:00',1.54),('5819','2013-12-06','12:15:00',1.22),('5819','2013-12-06','12:20:00',1.64),('5819','2013-12-06','12:25:00',1.25),('5819','2013-12-06','12:30:00',1.32),('5819','2013-12-06','12:35:00',1.85),('5819','2013-12-06','12:40:00',1.81),('5819','2013-12-06','12:45:00',1.04),('5819','2013-12-06','14:40:00',1.05),('5819','2013-12-05','08:25:00',1.06),('5819','2013-12-05','08:30:00',1.14),('5819','2013-12-05','08:35:00',1.23),('5819','2013-12-05','08:40:00',1.32),('5819','2013-12-05','08:45:00',1.4),('5819','2013-12-05','08:50:00',1.48),('5819','2013-12-05','08:55:00',1.54),('5819','2013-12-05','09:00:00',1.6),('5819','2013-12-05','09:05:00',1.67),('5819','2013-12-05','09:10:00',1.72),('5819','2013-12-05','09:15:00',1.78),('5819','2013-12-05','09:20:00',1.84),('5819','2013-12-05','09:25:00',1.9),('5819','2013-12-05','09:30:00',1.94),('5819','2013-12-05','09:35:00',1.99),('5819','2013-12-05','09:40:00',2.03),('5819','2013-12-05','09:45:00',2.07),('5819','2013-12-05','09:50:00',2.12),('5819','2013-12-05','09:55:00',2.17),('5819','2013-12-05','10:00:00',2.2),('5819','2013-12-05','10:05:00',2.23),('5819','2013-12-05','10:10:00',2.27),('5819','2013-12-05','10:15:00',2.31),('5819','2013-12-05','10:20:00',2.34),('5819','2013-12-05','10:25:00',2.35),('5819','2013-12-05','10:30:00',2.39),('5819','2013-12-05','10:35:00',2.42),('5819','2013-12-05','10:40:00',2.43),('5819','2013-12-05','10:45:00',2.43),('5819','2013-12-05','10:50:00',2.44),('5819','2013-12-05','10:55:00',2.45),('5819','2013-12-05','11:00:00',2.47),('5819','2013-12-05','11:05:00',2.49),('5819','2013-12-05','11:10:00',2.44),('5819','2013-12-05','11:15:00',2.48),('5819','2013-12-05','11:20:00',2.5),('5819','2013-12-05','11:25:00',2.51),('5819','2013-12-05','11:30:00',2.53),('5819','2013-12-05','11:35:00',2.47),('5819','2013-12-05','11:40:00',2.48),('5819','2013-12-05','11:45:00',2.46),('5819','2013-12-05','11:50:00',2.45),('5819','2013-12-05','11:55:00',2.45),('5819','2013-12-05','12:00:00',2.46),('5819','2013-12-05','12:05:00',2.43),('5819','2013-12-05','12:10:00',2.37),('5819','2013-12-05','12:15:00',2.33),('5819','2013-12-05','12:20:00',2.38),('5819','2013-12-05','12:25:00',2.27),('5819','2013-12-05','12:30:00',2.26),('5819','2013-12-05','12:35:00',2.3),('5819','2013-12-05','12:40:00',2.24),('5819','2013-12-05','12:45:00',2.01),('5819','2013-12-05','12:50:00',1.98),('5819','2013-12-05','12:55:00',2.01),('5819','2013-12-05','13:00:00',1.84),('5819','2013-12-05','13:05:00',1.56),('5819','2013-12-05','13:10:00',1.88),('5819','2013-12-05','13:15:00',2.07),('5819','2013-12-05','13:20:00',2.01),('5819','2013-12-05','13:25:00',1.79),('5819','2013-12-05','13:30:00',1.18),('5819','2013-12-05','13:35:00',1.72),('5819','2013-12-05','13:40:00',1.7),('5819','2013-12-05','13:45:00',1.76),('5819','2013-12-05','13:50:00',1.69),('5819','2013-12-05','13:55:00',1.59),('5819','2013-12-05','14:00:00',1.57),('5819','2013-12-05','14:05:00',1.51),('5819','2013-12-05','14:10:00',1.47),('5819','2013-12-05','14:15:00',1.38),('5819','2013-12-05','14:20:00',1.32),('5819','2013-12-05','14:25:00',1.31),('5819','2013-12-05','14:30:00',1.23),('5819','2013-12-05','14:35:00',1.18),('5819','2013-12-05','14:40:00',1.12),('5819','2013-12-05','14:45:00',1.04),('5819','2013-12-05','14:50:00',1.01),('5819','2013-12-04','08:15:00',1.04),('5819','2013-12-04','08:20:00',1.12),('5819','2013-12-04','08:25:00',1.2),('5819','2013-12-04','08:30:00',1.29),('5819','2013-12-04','08:35:00',1.38),('5819','2013-12-04','08:40:00',1.46),('5819','2013-12-04','08:45:00',1.54),('5819','2013-12-04','08:50:00',1.61),('5819','2013-12-04','08:55:00',1.68),('5819','2013-12-04','09:00:00',1.76),('5819','2013-12-04','09:05:00',1.83),('5819','2013-12-04','09:10:00',1.88),('5819','2013-12-04','09:15:00',1.94),('5819','2013-12-04','09:20:00',1.99),('5819','2013-12-04','09:25:00',2.04),('5819','2013-12-04','09:30:00',2.1),('5819','2013-12-04','09:35:00',2.15),('5819','2013-12-04','09:40:00',2.2),('5819','2013-12-04','09:45:00',2.25),('5819','2013-12-04','09:50:00',2.29),('5819','2013-12-04','09:55:00',2.33),('5819','2013-12-04','10:00:00',2.36),('5819','2013-12-04','10:05:00',2.4),('5819','2013-12-04','10:10:00',2.43),('5819','2013-12-04','10:15:00',2.45),('5819','2013-12-04','10:20:00',2.48),('5819','2013-12-04','10:25:00',2.51),('5819','2013-12-04','10:30:00',2.54),('5819','2013-12-04','10:35:00',2.55),('5819','2013-12-04','10:40:00',2.57),('5819','2013-12-04','10:45:00',2.59),('5819','2013-12-04','10:50:00',2.62),('5819','2013-12-04','10:55:00',2.62),('5819','2013-12-04','11:00:00',2.62),('5819','2013-12-04','11:05:00',2.62),('5819','2013-12-04','11:10:00',2.63),('5819','2013-12-04','11:15:00',2.63),('5819','2013-12-04','11:20:00',2.62),('5819','2013-12-04','11:25:00',2.62),('5819','2013-12-04','11:30:00',2.64),('5819','2013-12-04','11:35:00',2.64),('5819','2013-12-04','11:40:00',2.62),('5819','2013-12-04','11:45:00',2.63),('5819','2013-12-04','11:50:00',2.61),('5819','2013-12-04','11:55:00',2.6),('5819','2013-12-04','12:00:00',2.6),('5819','2013-12-04','12:05:00',2.57),('5819','2013-12-04','12:10:00',2.55),('5819','2013-12-04','12:15:00',2.52),('5819','2013-12-04','12:20:00',2.51),('5819','2013-12-04','12:25:00',2.49),('5819','2013-12-04','12:30:00',2.46),('5819','2013-12-04','12:35:00',2.42),('5819','2013-12-04','12:40:00',2.4),('5819','2013-12-04','12:45:00',2.38),('5819','2013-12-04','12:50:00',2.34),('5819','2013-12-04','12:55:00',2.3),('5819','2013-12-04','13:00:00',2.27),('5819','2013-12-04','13:05:00',2.24),('5819','2013-12-04','13:10:00',2.19),('5819','2013-12-04','13:15:00',2.14),('5819','2013-12-04','13:20:00',2.09),('5819','2013-12-04','13:25:00',2.05),('5819','2013-12-04','13:30:00',2.01),('5819','2013-12-04','13:35:00',1.97),('5819','2013-12-04','13:40:00',1.9),('5819','2013-12-04','13:45:00',1.85),('5819','2013-12-04','13:50:00',1.79),('5819','2013-12-04','13:55:00',1.75),('5819','2013-12-04','14:00:00',1.69),('5819','2013-12-04','14:05:00',1.64),('5819','2013-12-04','14:10:00',1.58),('5819','2013-12-04','14:15:00',1.52),('5819','2013-12-04','14:20:00',1.46),('5819','2013-12-04','14:25:00',1.38),('5819','2013-12-04','14:30:00',1.33),('5819','2013-12-04','14:35:00',1.28),('5819','2013-12-04','14:40:00',1.23),('5819','2013-12-04','14:45:00',1.16),('5819','2013-12-04','14:50:00',1.09),('5819','2013-12-04','14:55:00',1.04),('5819','2013-12-03','09:20:00',1.05),('5819','2013-12-03','09:25:00',1.01),('5819','2013-12-03','09:30:00',1.41),('5819','2013-12-03','09:35:00',1.38),('5819','2013-12-03','09:40:00',1.62),('5819','2013-12-03','09:45:00',1.76),('5819','2013-12-03','09:50:00',1.92),('5819','2013-12-03','09:55:00',1.9),('5819','2013-12-03','10:00:00',2.37),('5819','2013-12-03','10:05:00',2.37),('5819','2013-12-03','10:10:00',2.42),('5819','2013-12-03','10:15:00',2.45),('5819','2013-12-03','10:20:00',2.45),('5819','2013-12-03','10:25:00',2.5),('5819','2013-12-03','10:30:00',2.52),('5819','2013-12-03','10:35:00',2.54),('5819','2013-12-03','10:40:00',2.56),('5819','2013-12-03','10:45:00',2.57),('5819','2013-12-03','10:50:00',2.61),('5819','2013-12-03','10:55:00',2.65),('5819','2013-12-03','11:00:00',2.68),('5819','2013-12-03','11:05:00',2.7),('5819','2013-12-03','11:10:00',2.72),('5819','2013-12-03','11:15:00',2.72),('5819','2013-12-03','11:20:00',2.72),('5819','2013-12-03','11:25:00',2.7),('5819','2013-12-03','11:30:00',2.67),('5819','2013-12-03','11:35:00',2.67),('5819','2013-12-03','11:40:00',2.66),('5819','2013-12-03','11:45:00',2.67),('5819','2013-12-03','11:50:00',2.67),('5819','2013-12-03','11:55:00',2.67),('5819','2013-12-03','12:00:00',2.66),('5819','2013-12-03','12:05:00',2.66),('5819','2013-12-03','12:10:00',2.66),('5819','2013-12-03','12:15:00',2.66),('5819','2013-12-03','12:20:00',2.67),('5819','2013-12-03','12:25:00',2.67),('5819','2013-12-03','12:30:00',2.67),('5819','2013-12-03','12:35:00',2.68),('5819','2013-12-03','12:40:00',2.7),('5819','2013-12-03','12:45:00',2.74),('5819','2013-12-03','12:50:00',2.8),('5819','2013-12-03','12:55:00',2.85),('5819','2013-12-03','13:00:00',2.87),('5819','2013-12-03','13:05:00',2.89),('5819','2013-12-03','13:10:00',2.85),('5819','2013-12-03','13:15:00',2.72),('5819','2013-12-03','13:20:00',2.67),('5819','2013-12-03','13:25:00',2.54),('5819','2013-12-03','13:30:00',2.44),('5819','2013-12-03','13:35:00',2.33),('5819','2013-12-03','13:40:00',2.2),('5819','2013-12-03','13:45:00',2.1),('5819','2013-12-03','13:50:00',2.02),('5819','2013-12-03','13:55:00',1.9),('5819','2013-12-03','14:00:00',1.84),('5819','2013-12-03','14:05:00',1.72),('5819','2013-12-03','14:10:00',1.6),('5819','2013-12-03','14:15:00',1.5),('5819','2013-12-03','14:20:00',1.26),('5819','2013-12-03','14:25:00',1.16),('5819','2013-12-03','14:30:00',1.25),('5819','2013-12-03','14:35:00',1.28),('5819','2013-12-03','14:40:00',1.22),('5819','2013-12-03','14:45:00',1.15),('5819','2013-12-03','14:50:00',1.09),('5819','2013-12-03','14:55:00',1.02),('5819','2013-12-01','11:55:00',1.08),('5819','2013-12-01','12:05:00',1.14),('5819','2013-12-01','12:10:00',1.39),('5819','2013-12-01','12:15:00',1.07),('5819','2013-11-30','09:10:00',1.38),('5819','2013-11-30','09:15:00',1.76),('5819','2013-11-30','09:20:00',1.96),('5819','2013-11-30','09:25:00',1.91),('5819','2013-11-30','09:30:00',1.78),('5819','2013-11-30','09:35:00',2.04),('5819','2013-11-30','09:40:00',2.28),('5819','2013-11-30','09:45:00',1.91),('5819','2013-11-30','09:50:00',1.4),('5819','2013-11-30','09:55:00',1.22),('5819','2013-11-30','10:00:00',1.21),('5819','2013-11-30','10:05:00',1.03),('5819','2013-11-30','10:15:00',1.02),('5819','2013-11-30','10:20:00',1.13),('5819','2013-11-30','10:25:00',1.09),('5819','2013-11-30','10:30:00',1.13),('5819','2013-11-30','10:35:00',1.21),('5819','2013-11-30','10:40:00',1.35),('5819','2013-11-30','10:45:00',1.32),('5819','2013-11-30','10:50:00',1.33),('5819','2013-11-30','10:55:00',1.11),('5819','2013-11-30','11:00:00',1.01),('5819','2013-11-30','11:05:00',1.21),('5819','2013-11-30','11:10:00',1.31),('5819','2013-11-30','11:15:00',1.33),('5819','2013-11-30','11:20:00',1.15),('5819','2013-11-30','11:25:00',1.2),('5819','2013-11-30','11:30:00',1.09),('5819','2013-11-29','08:15:00',1.07),('5819','2013-11-29','08:20:00',1.16),('5819','2013-11-29','08:25:00',1.25),('5819','2013-11-29','08:30:00',1.33),('5819','2013-11-29','08:35:00',1.4),('5819','2013-11-29','08:40:00',1.48),('5819','2013-11-29','08:45:00',1.55),('5819','2013-11-29','08:50:00',1.63),('5819','2013-11-29','08:55:00',1.69),('5819','2013-11-29','09:00:00',1.77),('5819','2013-11-29','09:05:00',1.83),('5819','2013-11-29','09:10:00',1.89),('5819','2013-11-29','09:15:00',1.95),('5819','2013-11-29','09:20:00',2.02),('5819','2013-11-29','09:25:00',2.08),('5819','2013-11-29','09:30:00',2.13),('5819','2013-11-29','09:35:00',2.18),('5819','2013-11-29','09:40:00',2.24),('5819','2013-11-29','09:45:00',2.29),('5819','2013-11-29','09:50:00',2.33),('5819','2013-11-29','09:55:00',2.38),('5819','2013-11-29','10:00:00',2.41),('5819','2013-11-29','10:05:00',2.45),('5819','2013-11-29','10:10:00',2.48),('5819','2013-11-29','10:15:00',2.51),('5819','2013-11-29','10:20:00',2.54),('5819','2013-11-29','10:25:00',2.56),('5819','2013-11-29','10:30:00',2.59),('5819','2013-11-29','10:35:00',2.61),('5819','2013-11-29','10:40:00',2.64),('5819','2013-11-29','10:45:00',2.66),('5819','2013-11-29','10:50:00',2.67),('5819','2013-11-29','10:55:00',2.69),('5819','2013-11-29','11:00:00',2.7),('5819','2013-11-29','11:05:00',2.71),('5819','2013-11-29','11:10:00',2.71),('5819','2013-11-29','11:15:00',2.71),('5819','2013-11-29','11:20:00',2.73),('5819','2013-11-29','11:25:00',2.73),('5819','2013-11-29','11:30:00',2.72),('5819','2013-11-29','11:35:00',2.72),('5819','2013-11-29','11:40:00',2.72),('5819','2013-11-29','11:45:00',2.72),('5819','2013-11-29','11:50:00',2.7),('5819','2013-11-29','11:55:00',2.68),('5819','2013-11-29','12:00:00',2.68),('5819','2013-11-29','12:05:00',2.66),('5819','2013-11-29','12:10:00',2.64),('5819','2013-11-29','12:15:00',2.62),('5819','2013-11-29','12:20:00',2.59),('5819','2013-11-29','12:25:00',2.56),('5819','2013-11-29','12:30:00',2.54),('5819','2013-11-29','12:35:00',2.52),('5819','2013-11-29','12:40:00',2.49),('5819','2013-11-29','12:45:00',2.47),('5819','2013-11-29','12:50:00',2.43),('5819','2013-11-29','12:55:00',2.39),('5819','2013-11-29','13:00:00',2.34),('5819','2013-11-29','13:05:00',2.29),('5819','2013-11-29','13:10:00',2.26),('5819','2013-11-29','13:15:00',2.21),('5819','2013-11-29','13:20:00',2.16),('5819','2013-11-29','13:25:00',2.11),('5819','2013-11-29','13:30:00',2.06),('5819','2013-11-29','13:35:00',2.01),('5819','2013-11-29','13:40:00',1.96),('5819','2013-11-29','13:45:00',1.91),('5819','2013-11-29','13:50:00',1.84),('5819','2013-11-29','13:55:00',1.78),('5819','2013-11-29','14:00:00',1.72),('5819','2013-11-29','14:05:00',1.66),('5819','2013-11-29','14:10:00',1.6),('5819','2013-11-29','14:15:00',1.54),('5819','2013-11-29','14:20:00',1.47),('5819','2013-11-29','14:25:00',1.41),('5819','2013-11-29','14:30:00',1.35),('5819','2013-11-29','14:35:00',1.28),('5819','2013-11-29','14:40:00',1.21),('5819','2013-11-29','14:45:00',1.15),('5819','2013-11-29','14:50:00',1.09),('5819','2013-11-29','14:55:00',1.03),('5819','2014-04-20','07:50:00',1.02),('5819','2014-04-20','07:55:00',1.3),('5819','2014-04-20','08:00:00',1.33),('5819','2014-04-20','08:05:00',1.36),('5819','2014-04-20','08:10:00',1.45),('5819','2014-04-20','08:15:00',1.45),('5819','2014-04-20','08:20:00',1.77),('5819','2014-04-20','08:25:00',2.36),('5819','2014-04-20','08:30:00',2.48),('5819','2014-04-20','08:35:00',2.54),('5819','2014-04-20','08:40:00',2.14),('5819','2014-04-20','08:45:00',1.44),('5819','2014-04-20','08:50:00',2.13),('5819','2014-04-20','09:00:00',1.73),('5819','2014-04-20','09:10:00',1.38),('5819','2014-04-20','09:15:00',2.67),('5819','2014-04-20','09:20:00',2.85),('5819','2014-04-20','09:25:00',3.06),('5819','2014-04-20','09:30:00',3.38),('5819','2014-04-20','09:35:00',3.11),('5819','2014-04-20','09:40:00',1.73),('5819','2014-04-20','09:45:00',1.45),('5819','2014-04-20','09:50:00',1.47),('5819','2014-04-20','09:55:00',1.84),('5819','2014-04-20','10:00:00',2.24),('5819','2014-04-20','10:05:00',3.18),('5819','2014-04-20','10:10:00',2.56),('5819','2014-04-20','10:15:00',2.67),('5819','2014-04-20','10:20:00',2.76),('5819','2014-04-20','10:25:00',2.55),('5819','2014-04-20','10:30:00',2.39),('5819','2014-04-20','10:35:00',2.55),('5819','2014-04-20','10:40:00',2.51),('5819','2014-04-20','10:45:00',2.53),('5819','2014-04-20','10:50:00',2.83),('5819','2014-04-20','10:55:00',3.06),('5819','2014-04-20','11:00:00',3.29),('5819','2014-04-20','11:05:00',3.17),('5819','2014-04-20','11:10:00',2.97),('5819','2014-04-20','11:15:00',3.27),('5819','2014-04-20','11:20:00',3.34),('5819','2014-04-20','11:25:00',3.08),('5819','2014-04-20','11:30:00',3.88),('5819','2014-04-20','11:35:00',4.13),('5819','2014-04-20','11:40:00',3.23),('5819','2014-04-20','11:45:00',3.76),('5819','2014-04-20','11:50:00',3.55),('5819','2014-04-20','11:55:00',1.19),('5819','2014-04-20','12:00:00',2.87),('5819','2014-04-20','12:05:00',2.41),('5819','2014-04-20','12:10:00',3.07),('5819','2014-04-20','12:15:00',3.3),('5819','2014-04-20','12:20:00',1.53),('5819','2014-04-20','12:25:00',3.41),('5819','2014-04-20','12:30:00',4.27),('5819','2014-04-20','12:35:00',4.01),('5819','2014-04-20','12:40:00',4),('5819','2014-04-20','12:45:00',4.01),('5819','2014-04-20','12:50:00',4.05),('5819','2014-04-20','12:55:00',4.08),('5819','2014-04-20','13:00:00',4.1),('5819','2014-04-20','13:05:00',4.09),('5819','2014-04-20','13:10:00',4.16),('5819','2014-04-20','13:15:00',4.06),('5819','2014-04-20','13:20:00',3.97),('5819','2014-04-20','13:25:00',3.95),('5819','2014-04-20','13:30:00',3.97),('5819','2014-04-20','13:35:00',3.96),('5819','2014-04-20','13:40:00',3.95),('5819','2014-04-20','13:45:00',3.91),('5819','2014-04-20','13:50:00',3.88),('5819','2014-04-20','13:55:00',3.83),('5819','2014-04-20','14:00:00',3.8),('5819','2014-04-20','14:05:00',3.8),('5819','2014-04-20','14:10:00',3.79),('5819','2014-04-20','14:15:00',3.89),('5819','2014-04-20','14:20:00',3.23),('5819','2014-04-20','14:25:00',2.78),('5819','2014-04-20','14:30:00',2.77),('5819','2014-04-20','14:35:00',2.25),('5819','2014-04-20','14:40:00',2.26),('5819','2014-04-20','14:45:00',2.4),('5819','2014-04-20','14:50:00',2.3),('5819','2014-04-20','14:55:00',2.6),('5819','2014-04-20','15:00:00',3.17),('5819','2014-04-20','15:05:00',3.37),('5819','2014-04-20','15:10:00',3.13),('5819','2014-04-20','15:15:00',3.32),('5819','2014-04-20','15:20:00',3.16),('5819','2014-04-20','15:25:00',3.13),('5819','2014-04-20','15:30:00',3.06),('5819','2014-04-20','15:35:00',3),('5819','2014-04-20','15:40:00',2.99),('5819','2014-04-20','15:45:00',2.69),('5819','2014-04-20','15:50:00',2.06),('5819','2014-04-20','15:55:00',2.85),('5819','2014-04-20','16:00:00',2.69),('5819','2014-04-20','16:05:00',2.62),('5819','2014-04-20','16:10:00',2.56),('5819','2014-04-20','16:15:00',2.5),('5819','2014-04-20','16:20:00',2.49),('5819','2014-04-20','16:25:00',2.03),('5819','2014-04-20','16:30:00',2.38),('5819','2014-04-20','16:35:00',2.08),('5819','2014-04-20','16:40:00',2.03),('5819','2014-04-20','16:45:00',1.82),('5819','2014-04-20','16:50:00',2.02),('5819','2014-04-20','16:55:00',1.99),('5819','2014-04-20','17:00:00',1.85),('5819','2014-04-20','17:05:00',1.73),('5819','2014-04-20','17:10:00',1.61),('5819','2014-04-20','17:15:00',1.5),('5819','2014-04-20','17:20:00',1.41),('5819','2014-04-20','17:25:00',1.33),('5819','2014-04-20','17:30:00',1.13),('5819','2014-04-20','17:35:00',1.05),('5819','2014-04-20','17:40:00',1.05),('5819','2013-11-27','09:25:00',1.03),('5819','2013-11-27','09:40:00',1.23),('5819','2013-11-27','09:55:00',1.33),('5819','2013-11-27','10:00:00',1.15),('5819','2013-11-27','10:05:00',1.17),('5819','2013-11-27','10:10:00',1.16),('5819','2013-11-27','10:15:00',1.14),('5819','2013-11-27','10:20:00',1.09),('5819','2013-11-27','10:25:00',1.03),('5819','2013-11-27','10:30:00',1),('5819','2013-11-27','10:35:00',1.08),('5819','2013-11-27','10:40:00',1.18),('5819','2013-11-27','10:45:00',1.43),('5819','2013-11-27','10:50:00',1.4),('5819','2013-11-27','10:55:00',1.22),('5819','2013-11-27','11:00:00',1.32),('5819','2013-11-27','11:05:00',1.35),('5819','2013-11-27','11:10:00',1.71),('5819','2013-11-27','11:15:00',1.41),('5819','2013-11-27','11:20:00',1.45),('5819','2013-11-27','11:25:00',1.42),('5819','2013-11-27','11:30:00',1.91),('5819','2013-11-27','11:35:00',2.03),('5819','2013-11-27','11:40:00',1.54),('5819','2013-11-27','11:45:00',1.48),('5819','2013-11-27','11:50:00',1.83),('5819','2013-11-27','11:55:00',2.97),('5819','2013-11-27','12:00:00',3.02),('5819','2013-11-27','12:05:00',2.38),('5819','2013-11-27','12:10:00',1.16),('5819','2013-11-27','12:15:00',1.92),('5819','2013-11-27','12:20:00',2.76),('5819','2013-11-27','12:25:00',1.4),('5819','2013-11-27','12:30:00',2.16),('5819','2013-11-27','12:35:00',1.46),('5819','2013-11-27','12:40:00',1.28),('5819','2013-11-26','08:05:00',1.16),('5819','2013-11-26','08:10:00',1.25),('5819','2013-11-26','08:15:00',1.01),('5819','2013-11-26','09:05:00',1.04),('5819','2013-11-26','09:10:00',1.3),('5819','2013-11-26','09:15:00',1.41),('5819','2013-11-26','09:20:00',1.45),('5819','2013-11-26','09:25:00',1.35),('5819','2013-11-26','09:30:00',1.22),('5819','2013-11-26','09:35:00',1.39),('5819','2013-11-26','09:40:00',2.04),('5819','2013-11-26','09:45:00',1.48),('5819','2013-11-26','09:50:00',1.61),('5819','2013-11-26','09:55:00',2.02),('5819','2013-11-26','10:00:00',1.89),('5819','2013-11-26','10:05:00',2.29),('5819','2013-11-26','10:10:00',1.22),('5819','2013-11-26','10:25:00',1.81),('5819','2013-11-26','10:30:00',2.58),('5819','2013-11-26','10:35:00',2.85),('5819','2013-11-26','10:40:00',2.84),('5819','2013-11-26','10:45:00',2.86),('5819','2013-11-26','10:50:00',2.92),('5819','2013-11-26','10:55:00',2.96),('5819','2013-11-26','11:00:00',3.13),('5819','2013-11-26','11:05:00',2.44),('5819','2013-11-26','11:10:00',3.15),('5819','2013-11-26','11:15:00',3.48),('5819','2013-11-26','11:20:00',3.28),('5819','2013-11-26','11:25:00',3.26),('5819','2013-11-26','11:30:00',3.3),('5819','2013-11-26','11:35:00',3.41),('5819','2013-11-26','11:40:00',3.2),('5819','2013-11-26','11:45:00',3.02),('5819','2013-11-26','11:50:00',2.79),('5819','2013-11-26','11:55:00',1.47),('5819','2013-11-26','12:05:00',1.41),('5819','2013-11-26','12:15:00',1.39),('5819','2013-11-26','12:20:00',2.87),('5819','2013-11-26','12:25:00',2.79),('5819','2013-11-26','12:30:00',2.71),('5819','2013-11-26','12:35:00',2.7),('5819','2013-11-26','12:40:00',2.69),('5819','2013-11-26','12:45:00',2.63),('5819','2013-11-26','12:50:00',2.61),('5819','2013-11-26','12:55:00',2.58),('5819','2013-11-26','13:00:00',2.55),('5819','2013-11-26','13:05:00',2.51),('5819','2013-11-26','13:10:00',2.46),('5819','2013-11-26','13:15:00',2.42),('5819','2013-11-26','13:20:00',2.37),('5819','2013-11-26','13:25:00',2.31),('5819','2013-11-26','13:30:00',2.26),('5819','2013-11-26','13:35:00',2.21),('5819','2013-11-26','13:40:00',2.16),('5819','2013-11-26','13:45:00',2.12),('5819','2013-11-26','13:50:00',2.12),('5819','2013-11-26','13:55:00',2.02),('5819','2013-11-26','14:00:00',2.03),('5819','2013-11-26','14:05:00',1.55),('5819','2013-11-26','14:10:00',2.33),('5819','2013-11-26','14:15:00',2.37),('5819','2013-11-26','14:20:00',1.99),('5819','2013-11-26','14:25:00',1.34),('5819','2013-11-26','14:30:00',1.29),('5819','2013-11-26','14:35:00',1.49),('5819','2013-11-26','14:40:00',1.57),('5819','2013-11-26','14:45:00',1.59),('5819','2013-11-26','14:50:00',1.71),('5819','2013-11-26','14:55:00',1.7),('5819','2013-11-26','15:00:00',1.58),('5819','2013-11-26','15:05:00',1.39),('5819','2013-11-26','15:10:00',1.16),('5819','2013-11-26','15:15:00',1.04),('5819','2013-11-25','08:05:00',1.05),('5819','2013-11-25','08:10:00',1.14),('5819','2013-11-25','08:15:00',1.24),('5819','2013-11-25','08:20:00',1.37),('5819','2013-11-25','08:25:00',1.51),('5819','2013-11-25','08:30:00',1.57),('5819','2013-11-25','08:35:00',1.66),('5819','2013-11-25','08:40:00',1.75),('5819','2013-11-25','08:45:00',1.88),('5819','2013-11-25','08:50:00',2.02),('5819','2013-11-25','08:55:00',2.16),('5819','2013-11-25','09:00:00',2.33),('5819','2013-11-25','09:05:00',2.41),('5819','2013-11-25','09:10:00',2.43),('5819','2013-11-25','09:15:00',2.52),('5819','2013-11-25','09:20:00',2.62),('5819','2013-11-25','09:25:00',2.68),('5819','2013-11-25','09:30:00',2.4),('5819','2013-11-25','09:35:00',2.36),('5819','2013-11-25','09:40:00',2.02),('5819','2013-11-25','09:45:00',1.22),('5819','2013-11-25','09:50:00',1.44),('5819','2013-11-25','09:55:00',1.4),('5819','2013-11-25','10:00:00',1.31),('5819','2013-11-25','10:05:00',1.36),('5819','2013-11-25','10:10:00',1.2),('5819','2013-11-25','10:15:00',1.57),('5819','2013-11-25','10:20:00',1.7),('5819','2013-11-25','10:25:00',1.66),('5819','2013-11-25','10:30:00',2.32),('5819','2013-11-25','10:35:00',3.46),('5819','2013-11-25','10:40:00',3.31),('5819','2013-11-25','10:45:00',2.94),('5819','2013-11-25','10:50:00',2.59),('5819','2013-11-25','10:55:00',2.51),('5819','2013-11-25','11:00:00',2.84),('5819','2013-11-25','11:05:00',3.01),('5819','2013-11-25','11:10:00',3.38),('5819','2013-11-25','11:15:00',1.83),('5819','2013-11-25','11:20:00',1.58),('5819','2013-11-25','11:25:00',1.12),('5819','2013-11-25','11:30:00',1.24),('5819','2013-11-25','11:35:00',1.15),('5819','2013-11-25','11:40:00',1.03),('5819','2013-11-25','11:45:00',1.05),('5819','2013-11-25','11:50:00',1.56),('5819','2013-11-25','11:55:00',1.91),('5819','2013-11-25','12:00:00',1.32),('5819','2013-11-25','12:05:00',1.33),('5819','2013-11-25','12:10:00',1.89),('5819','2013-11-25','12:15:00',1.52),('5819','2013-11-25','12:20:00',1.39),('5819','2013-11-25','12:25:00',1.35),('5819','2013-11-25','12:30:00',1.2),('5819','2013-11-25','12:35:00',1.07),('5819','2013-11-25','12:40:00',2.59),('5819','2013-11-25','12:45:00',2.71),('5819','2013-11-25','12:50:00',1.92),('5819','2013-11-25','12:55:00',2.36),('5819','2013-11-25','13:00:00',3.04),('5819','2013-11-25','13:05:00',3.05),('5819','2013-11-25','13:10:00',1.85),('5819','2013-11-25','13:15:00',1.91),('5819','2013-11-25','13:20:00',1.95),('5819','2013-11-25','13:25:00',1.34),('5819','2013-11-25','13:30:00',1.01),('5819','2013-11-24','10:00:00',1.24),('5819','2013-11-24','10:05:00',1.4),('5819','2013-11-24','10:10:00',1.47),('5819','2013-11-24','10:15:00',1.26),('5819','2013-11-24','10:20:00',1.12),('5819','2013-11-24','10:25:00',1.67),('5819','2013-11-24','10:30:00',1.75),('5819','2013-11-24','10:35:00',1.12),('5819','2013-11-24','10:40:00',1.14),('5819','2013-11-24','10:55:00',1.07),('5819','2013-11-24','11:00:00',1.09),('5819','2013-11-24','11:05:00',1.12),('5819','2013-11-24','11:10:00',1.17),('5819','2013-11-24','11:15:00',1.21),('5819','2013-11-24','11:20:00',1.37),('5819','2013-11-24','11:25:00',1.49),('5819','2013-11-24','11:30:00',1.27),('5819','2013-11-24','11:35:00',1.11),('5819','2013-11-24','11:40:00',1.04),('5819','2013-11-24','11:50:00',1.1),('5819','2013-11-24','13:10:00',1.17),('5819','2013-11-24','13:15:00',1.15),('5819','2013-11-23','10:15:00',1.03),('5819','2013-11-23','10:20:00',1.2),('5819','2013-11-23','10:25:00',1.18),('5819','2013-11-23','10:30:00',1.69),('5819','2013-11-23','10:40:00',2.63),('5819','2013-11-23','13:25:00',1.17),('5819','2013-11-23','13:35:00',1.08),('5819','2013-11-23','13:40:00',1.08),('5819','2013-11-21','08:10:00',1.3),('5819','2013-11-21','08:15:00',1.39),('5819','2013-11-21','09:15:00',1.14),('5819','2013-11-21','09:20:00',1.42),('5819','2013-11-21','09:25:00',1.1),('5819','2013-11-21','09:30:00',1.15),('5819','2013-11-21','09:40:00',1.51),('5819','2013-11-21','09:45:00',2.18),('5819','2013-11-21','09:50:00',2.16),('5819','2013-11-21','09:55:00',1.77),('5819','2013-11-21','10:00:00',1.57),('5819','2013-11-21','10:05:00',2.51),('5819','2013-11-21','10:10:00',2.32),('5819','2013-11-21','10:15:00',2.62),('5819','2013-11-21','10:20:00',2.63),('5819','2013-11-21','10:25:00',1.85),('5819','2013-11-21','10:30:00',2.21),('5819','2013-11-21','10:35:00',2.61),('5819','2013-11-21','10:40:00',2.74),('5819','2013-11-21','10:45:00',2.15),('5819','2013-11-21','11:15:00',1.15),('5819','2013-11-21','11:20:00',1.09),('5819','2013-11-21','11:25:00',2.1),('5819','2013-11-21','11:30:00',2.69),('5819','2013-11-21','11:35:00',1.68),('5819','2013-11-21','11:40:00',2.82),('5819','2013-11-21','11:45:00',2.2),('5819','2013-11-21','11:50:00',2.76),('5819','2013-11-21','11:55:00',2.74),('5819','2013-11-21','12:00:00',1.81),('5819','2013-11-21','12:05:00',2.69),('5819','2013-11-21','12:10:00',2.74),('5819','2013-11-21','12:15:00',2.71),('5819','2013-11-21','12:20:00',2.69),('5819','2013-11-21','12:25:00',2.74),('5819','2013-11-21','12:30:00',2.86),('5819','2013-11-21','12:35:00',2.94),('5819','2013-11-21','12:40:00',3.02),('5819','2013-11-21','12:45:00',2.87),('5819','2013-11-21','12:50:00',2.78),('5819','2013-11-21','12:55:00',2.99),('5819','2013-11-21','13:00:00',2.93),('5819','2013-11-21','13:05:00',2.57),('5819','2013-11-21','13:10:00',1.51),('5819','2013-11-21','13:15:00',2.38),('5819','2013-11-21','13:20:00',2.54),('5819','2013-11-21','13:25:00',2.09),('5819','2013-11-21','13:40:00',1.48),('5819','2013-11-21','13:45:00',2.23),('5819','2013-11-21','13:50:00',1.16),('5819','2013-11-21','13:55:00',1.97),('5819','2013-11-21','14:00:00',2.05),('5819','2013-11-21','14:05:00',1.1),('5819','2013-11-21','14:25:00',1.03),('5819','2013-11-21','14:40:00',1.33),('5819','2013-11-21','14:45:00',1.25),('5819','2013-11-21','14:50:00',1.18),('5819','2013-11-21','15:00:00',1.04),('5819','2013-11-20','08:20:00',1.46),('5819','2013-11-20','09:00:00',1.5),('5819','2013-11-20','09:10:00',1.16),('5819','2013-11-20','09:15:00',1.97),('5819','2013-11-20','09:20:00',1.98),('5819','2013-11-20','09:25:00',2.2),('5819','2013-11-20','09:30:00',2.27),('5819','2013-11-20','09:35:00',1.24),('5819','2013-11-20','10:00:00',1.58),('5819','2013-11-20','10:05:00',1.19),('5819','2013-11-20','10:15:00',1.82),('5819','2013-11-20','11:25:00',1.16),('5819','2013-11-20','11:30:00',1.18),('5819','2013-11-20','11:35:00',1.04),('5819','2013-11-20','11:40:00',1.01),('5819','2013-11-20','11:45:00',3.06),('5819','2013-11-20','11:50:00',3.17),('5819','2013-11-20','11:55:00',1.39),('5819','2013-11-20','12:20:00',2.34),('5819','2013-11-20','12:25:00',1.5),('5819','2013-11-20','12:45:00',1.04),('5819','2013-11-20','12:50:00',1.28),('5819','2013-11-20','12:55:00',1.5),('5819','2013-11-20','13:00:00',2),('5819','2013-11-20','13:05:00',1.74),('5819','2013-11-20','13:10:00',1.15),('5819','2013-11-20','13:20:00',1.4),('5819','2013-11-20','13:40:00',1.65),('5819','2013-11-20','13:45:00',1.15),('5819','2013-11-20','13:50:00',1.96),('5819','2013-11-20','13:55:00',1.4),('5819','2013-11-20','14:00:00',1.12),('5819','2013-11-20','14:45:00',1.22),('5819','2013-11-20','15:10:00',1.16),('5819','2013-11-19','09:35:00',1.13),('5819','2013-11-19','09:40:00',2.2),('5819','2013-11-19','09:45:00',2.14),('5819','2013-11-19','09:50:00',1.29),('5819','2013-11-19','10:00:00',1.26),('5819','2013-11-19','10:05:00',1.63),('5819','2013-11-19','10:50:00',1.55),('5819','2013-11-19','11:20:00',2.39),('5819','2013-11-19','11:25:00',2.13),('5819','2013-11-19','11:30:00',2.53),('5819','2013-11-19','11:35:00',2.61),('5819','2013-11-19','11:40:00',2.56),('5819','2013-11-19','11:45:00',2.52),('5819','2013-11-19','11:50:00',2.55),('5819','2013-11-19','11:55:00',2.52),('5819','2013-11-19','12:00:00',2.33),('5819','2013-11-19','12:05:00',2.25),('5819','2013-11-19','12:10:00',2.5),('5819','2013-11-19','12:15:00',2.49),('5819','2013-11-19','12:20:00',1.59),('5819','2013-11-19','12:30:00',1.27),('5819','2013-11-19','12:45:00',2),('5819','2013-11-19','12:50:00',1.06),('5819','2013-11-19','12:55:00',2.82),('5819','2013-11-19','13:00:00',2.35),('5819','2013-11-19','13:10:00',1.15),('5819','2013-11-19','13:15:00',1.9),('5819','2013-11-19','13:20:00',2.33),('5819','2013-11-19','15:30:00',1.35),('5819','2013-11-19','15:35:00',1.02),('5819','2013-11-18','08:00:00',1.02),('5819','2013-11-18','08:05:00',1.07),('5819','2013-11-18','08:10:00',1.09),('5819','2013-11-18','08:15:00',1.14),('5819','2013-11-18','08:20:00',1.19),('5819','2013-11-18','08:25:00',1.23),('5819','2013-11-18','08:30:00',1.32),('5819','2013-11-18','08:35:00',1.37),('5819','2013-11-18','08:40:00',1.19),('5819','2013-11-18','08:45:00',1.18),('5819','2013-11-18','08:50:00',1.01),('5819','2013-11-18','09:15:00',1.17),('5819','2013-11-18','09:20:00',1.66),('5819','2013-11-18','09:25:00',1.71),('5819','2013-11-18','09:30:00',1.61),('5819','2013-11-18','09:35:00',2.11),('5819','2013-11-18','09:40:00',1.67),('5819','2013-11-18','09:45:00',1.47),('5819','2013-11-18','09:50:00',1.06),('5819','2013-11-18','09:55:00',1.03),('5819','2013-11-18','10:00:00',1.14),('5819','2013-11-18','10:05:00',1.34),('5819','2013-11-18','10:10:00',1.46),('5819','2013-11-18','10:15:00',1.75),('5819','2013-11-18','10:20:00',1.5),('5819','2013-11-18','10:25:00',1.29),('5819','2013-11-18','10:30:00',1.24),('5819','2013-11-18','10:35:00',1.13),('5819','2013-11-18','10:40:00',1.17),('5819','2013-11-18','10:45:00',1.22),('5819','2013-11-18','10:50:00',1.16),('5819','2013-11-18','10:55:00',1.04),('5819','2013-11-18','11:35:00',1.02),('5819','2013-11-18','11:40:00',1.06),('5819','2013-11-18','11:45:00',1.1),('5819','2013-11-18','11:50:00',1.15),('5819','2013-11-18','11:55:00',1.23),('5819','2013-11-18','12:00:00',1.3),('5819','2013-11-18','12:05:00',1.37),('5819','2013-11-18','12:10:00',1.37),('5819','2013-11-18','12:15:00',1.4),('5819','2013-11-18','12:20:00',1.48),('5819','2013-11-18','12:25:00',1.55),('5819','2013-11-18','12:30:00',1.37),('5819','2013-11-18','12:35:00',1.19),('5819','2013-11-18','12:40:00',1.04),('5819','2013-11-18','13:35:00',1.03),('5819','2013-11-18','13:40:00',1.06),('5819','2014-04-19','07:35:00',1.08),('5819','2014-04-19','07:40:00',1.27),('5819','2014-04-19','07:55:00',1.72),('5819','2014-04-19','08:00:00',1.35),('5819','2014-04-19','08:05:00',1.06),('5819','2014-04-19','08:10:00',1.61),('5819','2014-04-19','08:15:00',1.08),('5819','2014-04-19','08:20:00',1.16),('5819','2014-04-19','08:25:00',1.47),('5819','2014-04-19','08:30:00',1.85),('5819','2014-04-19','08:35:00',2.46),('5819','2014-04-19','08:40:00',2.24),('5819','2014-04-19','08:45:00',1.91),('5819','2014-04-19','08:50:00',1.53),('5819','2014-04-19','08:55:00',1.13),('5819','2014-04-19','09:25:00',1.2),('5819','2014-04-19','09:30:00',2.05),('5819','2014-04-19','09:35:00',2.18),('5819','2014-04-19','09:40:00',1.28),('5819','2014-04-19','10:40:00',1.09),('5819','2014-04-19','10:45:00',1.07),('5819','2014-04-19','10:50:00',1.08),('5819','2014-04-19','10:55:00',1.36),('5819','2014-04-19','11:00:00',1.49),('5819','2014-04-19','11:05:00',1.19),('5819','2014-04-19','11:10:00',1.07),('5819','2014-04-19','11:15:00',1.55),('5819','2014-04-19','11:20:00',3.11),('5819','2014-04-19','11:25:00',2.55),('5819','2014-04-19','11:30:00',2.49),('5819','2014-04-19','11:35:00',2.23),('5819','2014-04-19','11:40:00',2.58),('5819','2014-04-19','11:45:00',1.99),('5819','2014-04-19','11:50:00',1.74),('5819','2014-04-19','11:55:00',1.08),('5819','2014-04-19','13:15:00',1.2),('5819','2014-04-19','13:20:00',1.27),('5819','2014-04-19','14:30:00',1.15),('5819','2014-04-19','14:35:00',1.36),('5819','2014-04-19','14:40:00',1.53),('5819','2014-04-19','14:45:00',1.63),('5819','2014-04-19','14:50:00',1.15),('5819','2014-04-19','15:00:00',1.19),('5819','2014-04-19','15:05:00',1.26),('5819','2014-04-19','15:30:00',1.05),('5819','2014-04-19','15:50:00',2.26),('5819','2014-04-19','15:55:00',3.02),('5819','2014-04-19','16:00:00',1.67),('5819','2014-04-19','16:05:00',1.45),('5819','2014-04-19','16:10:00',1.46),('5819','2014-04-19','16:15:00',1.36),('5819','2014-04-19','16:20:00',1.65),('5819','2014-04-19','16:25:00',1.64),('5819','2014-04-19','16:30:00',2.45),('5819','2014-04-19','16:35:00',1.45),('5819','2014-04-19','16:40:00',1.02),('5819','2014-04-19','17:20:00',1.37),('5819','2014-04-19','17:25:00',1.11),('5819','2013-11-17','08:45:00',1.31),('5819','2013-11-17','08:50:00',1.37),('5819','2013-11-17','08:55:00',2.31),('5819','2013-11-17','09:00:00',2.17),('5819','2013-11-17','09:05:00',2.04),('5819','2013-11-17','09:10:00',2.05),('5819','2013-11-17','09:15:00',2.06),('5819','2013-11-17','09:20:00',1.81),('5819','2013-11-17','09:25:00',2.18),('5819','2013-11-17','09:30:00',2.22),('5819','2013-11-17','09:35:00',2.24),('5819','2013-11-17','09:40:00',2.29),('5819','2013-11-17','09:45:00',2.31),('5819','2013-11-17','09:50:00',2.35),('5819','2013-11-17','09:55:00',2.39),('5819','2013-11-17','10:00:00',2.42),('5819','2013-11-17','10:05:00',2.45),('5819','2013-11-17','10:10:00',2.48),('5819','2013-11-17','10:15:00',2.51),('5819','2013-11-17','10:20:00',2.53),('5819','2013-11-17','10:25:00',2.54),('5819','2013-11-17','10:30:00',2.56),('5819','2013-11-17','10:35:00',2.57),('5819','2013-11-17','10:40:00',2.58),('5819','2013-11-17','10:45:00',2.59),('5819','2013-11-17','10:50:00',2.6),('5819','2013-11-17','10:55:00',2.62),('5819','2013-11-17','11:00:00',2.62),('5819','2013-11-17','11:05:00',2.63),('5819','2013-11-17','11:10:00',2.63),('5819','2013-11-17','11:15:00',2.63),('5819','2013-11-17','11:20:00',2.63),('5819','2013-11-17','11:25:00',2.62),('5819','2013-11-17','11:30:00',2.61),('5819','2013-11-17','11:35:00',2.61),('5819','2013-11-17','11:40:00',2.63),('5819','2013-11-17','11:45:00',2.61),('5819','2013-11-17','11:50:00',2.6),('5819','2013-11-17','11:55:00',2.59),('5819','2013-11-17','12:00:00',2.54),('5819','2013-11-17','12:05:00',2.54),('5819','2013-11-17','12:10:00',2.52),('5819','2013-11-17','12:15:00',2.5),('5819','2013-11-17','12:20:00',2.49),('5819','2013-11-17','12:25:00',2.46),('5819','2013-11-17','12:30:00',2.45),('5819','2013-11-17','12:35:00',2.42),('5819','2013-11-17','12:40:00',2.4),('5819','2013-11-17','12:45:00',2.36),('5819','2013-11-17','12:50:00',2.32),('5819','2013-11-17','12:55:00',2.27),('5819','2013-11-17','13:00:00',2.24),('5819','2013-11-17','13:05:00',2.17),('5819','2013-11-17','13:10:00',2.17),('5819','2013-11-17','13:15:00',2.14),('5819','2013-11-17','13:20:00',2.1),('5819','2013-11-17','13:25:00',2.05),('5819','2013-11-17','13:30:00',1.76),('5819','2013-11-17','13:35:00',1.79),('5819','2013-11-17','13:40:00',1.15),('5819','2013-11-17','14:00:00',1.26),('5819','2013-11-17','14:05:00',1.48),('5819','2013-11-17','14:10:00',1.56),('5819','2013-11-17','14:15:00',1.52),('5819','2013-11-17','14:20:00',1.46),('5819','2013-11-17','14:25:00',1.39),('5819','2013-11-17','14:30:00',1.28),('5819','2013-11-17','14:35:00',1.23),('5819','2013-11-17','14:40:00',1.14),('5819','2013-11-17','14:45:00',1.16),('5819','2013-11-17','14:50:00',1.14),('5819','2013-11-17','14:55:00',1.08),('5819','2013-11-15','09:15:00',1.02),('5819','2013-11-15','09:35:00',1.04),('5819','2013-11-15','10:15:00',1.15),('5819','2013-11-15','10:20:00',1.19),('5819','2013-11-15','10:50:00',1.09),('5819','2013-11-15','10:55:00',1.83),('5819','2013-11-15','11:00:00',1.38),('5819','2013-11-15','11:05:00',1.2),('5819','2013-11-15','11:10:00',1.12),('5819','2013-11-15','11:15:00',1.28),('5819','2013-11-15','11:20:00',1.6),('5819','2013-11-15','11:25:00',2.54),('5819','2013-11-15','11:30:00',1.55),('5819','2013-11-15','11:35:00',1.58),('5819','2013-11-15','11:40:00',1.82),('5819','2013-11-15','11:45:00',1.53),('5819','2013-11-15','11:50:00',1.35),('5819','2013-11-15','11:55:00',1.18),('5819','2013-11-15','12:00:00',1.2),('5819','2013-11-15','12:05:00',1.2),('5819','2013-11-15','12:10:00',1.17),('5819','2013-11-15','12:15:00',1.15),('5819','2013-11-15','12:20:00',1.18),('5819','2013-11-15','12:25:00',1.73),('5819','2013-11-15','12:30:00',1.53),('5819','2013-11-15','12:35:00',1.24),('5819','2013-11-15','12:40:00',1.14),('5819','2013-11-15','12:45:00',1.08),('5819','2013-11-15','12:50:00',1.39),('5819','2013-11-15','12:55:00',1.49),('5819','2013-11-15','13:00:00',1.3),('5819','2013-11-15','13:05:00',1.15),('5819','2013-11-15','13:10:00',1.15),('5819','2013-11-15','13:35:00',1.06),('5819','2013-11-15','13:40:00',1.02),('5819','2013-11-15','13:45:00',1.42),('5819','2013-11-15','13:50:00',1.49),('5819','2013-11-15','13:55:00',1.12),('5819','2013-11-15','14:00:00',1.06),('5819','2013-11-14','08:20:00',1.34),('5819','2013-11-14','08:25:00',1.41),('5819','2013-11-14','08:30:00',1.5),('5819','2013-11-14','08:35:00',1.42),('5819','2013-11-14','08:40:00',1.14),('5819','2013-11-14','09:05:00',1.37),('5819','2013-11-14','09:10:00',1.27),('5819','2013-11-14','09:15:00',1.52),('5819','2013-11-14','09:20:00',2.17),('5819','2013-11-14','09:25:00',2.17),('5819','2013-11-14','09:30:00',2.2),('5819','2013-11-14','09:35:00',2.23),('5819','2013-11-14','09:40:00',2.25),('5819','2013-11-14','09:45:00',2.23),('5819','2013-11-14','09:50:00',1.82),('5819','2013-11-14','10:00:00',1.25),('5819','2013-11-14','10:05:00',1.86),('5819','2013-11-14','10:10:00',1.34),('5819','2013-11-14','10:15:00',2.53),('5819','2013-11-14','10:20:00',2.57),('5819','2013-11-14','10:25:00',2.54),('5819','2013-11-14','10:30:00',2.53),('5819','2013-11-14','10:35:00',2.53),('5819','2013-11-14','10:40:00',2.55),('5819','2013-11-14','10:45:00',2.58),('5819','2013-11-14','10:50:00',2.58),('5819','2013-11-14','10:55:00',2.56),('5819','2013-11-14','11:00:00',2.56),('5819','2013-11-14','11:05:00',2.64),('5819','2013-11-14','11:10:00',2.7),('5819','2013-11-14','11:15:00',2.75),('5819','2013-11-14','11:20:00',2.76),('5819','2013-11-14','11:25:00',2.79),('5819','2013-11-14','11:30:00',2.78),('5819','2013-11-14','11:35:00',2.69),('5819','2013-11-14','11:40:00',2.3),('5819','2013-11-14','11:45:00',1.5),('5819','2013-11-14','11:50:00',1.6),('5819','2013-11-14','11:55:00',2.34),('5819','2013-11-14','12:00:00',1.95),('5819','2013-11-14','12:05:00',1.24),('5819','2013-11-14','12:10:00',1.22),('5819','2013-11-14','12:15:00',1.57),('5819','2013-11-14','12:20:00',1.22),('5819','2013-11-14','12:25:00',1.07),('5819','2013-11-14','12:35:00',1.02),('5819','2013-11-14','12:45:00',1.01),('5819','2013-11-14','12:50:00',1.08),('5819','2013-11-14','12:55:00',1.06),('5819','2013-11-14','13:00:00',1.05),('5819','2013-11-13','08:35:00',1.1),('5819','2013-11-13','10:00:00',1.19),('5819','2013-11-13','10:20:00',1.38),('5819','2013-11-13','10:25:00',1.32),('5819','2013-11-13','10:30:00',1.6),('5819','2013-11-13','10:35:00',3.14),('5819','2013-11-13','10:40:00',2.86),('5819','2013-11-13','10:45:00',2.6),('5819','2013-11-13','10:50:00',3.48),('5819','2013-11-13','10:55:00',3.34),('5819','2013-11-13','11:00:00',3.23),('5819','2013-11-13','11:05:00',1.02),('5819','2013-11-13','11:15:00',1.03),('5819','2013-11-13','11:25:00',1.01),('5819','2013-11-13','11:30:00',1.13),('5819','2013-11-13','11:35:00',1.11),('5819','2013-11-13','11:45:00',1.06),('5819','2013-11-13','11:50:00',1.22),('5819','2013-11-13','11:55:00',1.06),('5819','2013-11-13','13:00:00',1.03),('5819','2013-11-13','13:05:00',1.28),('5819','2013-11-13','13:10:00',1.14),('5819','2013-11-13','13:15:00',1.15),('5819','2013-11-13','13:55:00',1.48),('5819','2013-11-13','14:00:00',1.67),('5819','2013-11-13','14:05:00',1.61),('5819','2013-11-13','14:10:00',1.43),('5819','2013-11-13','14:15:00',1.51),('5819','2013-11-13','14:20:00',1.34),('5819','2013-11-13','14:25:00',1.41),('5819','2013-11-13','14:30:00',1.29),('5819','2013-11-12','11:25:00',1.31),('5819','2013-11-12','11:35:00',1.11),('5819','2013-11-12','11:40:00',2.53),('5819','2013-11-12','11:45:00',1.47),('5819','2013-11-12','11:50:00',1.43),('5819','2013-11-12','11:55:00',1),('5819','2013-11-12','12:00:00',2.69),('5819','2013-11-12','12:05:00',1.07),('5819','2013-11-12','12:30:00',3.41),('5819','2013-11-12','12:35:00',2.69),('5819','2013-11-12','12:40:00',1.83),('5819','2013-11-12','12:45:00',1.75),('5819','2013-11-12','12:50:00',1.45),('5819','2013-11-12','12:55:00',1.8),('5819','2013-11-12','13:00:00',1.78),('5819','2013-11-12','13:05:00',1.99),('5819','2013-11-12','13:10:00',2.33),('5819','2013-11-12','13:15:00',3.35),('5819','2013-11-12','13:20:00',2.66),('5819','2013-11-12','13:25:00',2.2),('5819','2013-11-12','13:30:00',1.72),('5819','2013-11-12','13:35:00',2.1),('5819','2013-11-12','13:40:00',2.98),('5819','2013-11-12','13:45:00',1.67),('5819','2013-11-12','13:50:00',1.11),('5819','2013-11-12','13:55:00',1.28),('5819','2013-11-12','14:00:00',1.26),('5819','2013-11-12','14:05:00',1.04),('5819','2013-11-12','14:10:00',1.41),('5819','2013-11-12','14:15:00',2.18),('5819','2013-11-12','14:20:00',2.18),('5819','2013-11-12','14:25:00',2.07),('5819','2013-11-12','14:30:00',1.74),('5819','2013-11-12','14:35:00',1.43),('5819','2013-11-12','14:40:00',1.68),('5819','2013-11-12','14:45:00',1.39),('5819','2013-11-12','14:50:00',1.2),('5819','2013-11-11','09:50:00',1.26),('5819','2013-11-11','09:55:00',1.25),('5819','2013-11-11','10:10:00',1.11),('5819','2013-11-11','10:15:00',1.99),('5819','2013-11-11','10:20:00',3.07),('5819','2013-11-11','10:25:00',1.64),('5819','2013-11-11','11:05:00',1.07),('5819','2013-11-11','11:10:00',2.24),('5819','2013-11-11','11:15:00',1.92),('5819','2013-11-11','11:20:00',1.57),('5819','2013-11-11','11:25:00',3.18),('5819','2013-11-11','11:30:00',1.46),('5819','2013-11-11','11:35:00',2.66),('5819','2013-11-11','11:40:00',3.48),('5819','2013-11-11','11:45:00',3.46),('5819','2013-11-11','11:50:00',3.49),('5819','2013-11-11','11:55:00',3.21),('5819','2013-11-11','12:00:00',3.03),('5819','2013-11-11','12:05:00',2.97),('5819','2013-11-11','12:10:00',2.92),('5819','2013-11-11','12:15:00',2.91),('5819','2013-11-11','12:20:00',2.75),('5819','2013-11-11','12:25:00',2.3),('5819','2013-11-11','12:30:00',2.84),('5819','2013-11-11','12:35:00',1.61),('5819','2013-11-11','12:40:00',2.01),('5819','2013-11-11','12:45:00',1.54),('5819','2013-11-11','13:00:00',1.23),('5819','2013-11-11','13:05:00',1.16),('5819','2013-11-11','13:10:00',2.58),('5819','2013-11-11','13:15:00',1.8),('5819','2013-11-11','13:35:00',1.42),('5819','2013-11-11','13:40:00',1.56),('5819','2013-11-11','13:45:00',1.08),('5819','2013-11-11','14:15:00',1.61),('5819','2013-11-11','14:20:00',1.91),('5819','2013-11-11','14:25:00',1.79),('5819','2013-11-11','14:30:00',1.66),('5819','2013-11-11','14:35:00',1.59),('5819','2013-11-11','14:40:00',1.38),('5819','2013-11-10','07:50:00',1.32),('5819','2013-11-10','07:55:00',1.32),('5819','2013-11-10','08:00:00',1.27),('5819','2013-11-10','08:40:00',1.45),('5819','2013-11-10','08:45:00',1.25),('5819','2013-11-10','08:50:00',1.61),('5819','2013-11-10','08:55:00',2.05),('5819','2013-11-10','09:00:00',1.54),('5819','2013-11-10','09:05:00',1.27),('5819','2013-11-10','09:10:00',1.1),('5819','2013-11-10','09:15:00',1.62),('5819','2013-11-10','09:20:00',2.09),('5819','2013-11-10','09:25:00',2.31),('5819','2013-11-10','09:30:00',2.05),('5819','2013-11-10','09:35:00',2.05),('5819','2013-11-10','09:40:00',2.15),('5819','2013-11-10','09:45:00',2.36),('5819','2013-11-10','09:50:00',2.44),('5819','2013-11-10','09:55:00',2.53),('5819','2013-11-10','10:00:00',2.45),('5819','2013-11-10','10:05:00',2.72),('5819','2013-11-10','10:10:00',2.79),('5819','2013-11-10','10:15:00',2.76),('5819','2013-11-10','10:20:00',2.54),('5819','2013-11-10','10:25:00',2.85),('5819','2013-11-10','10:30:00',3.09),('5819','2013-11-10','10:35:00',2.91),('5819','2013-11-10','10:40:00',2.35),('5819','2013-11-10','10:45:00',2.25),('5819','2013-11-10','10:50:00',2.45),('5819','2013-11-10','10:55:00',2.51),('5819','2013-11-10','11:00:00',2.31),('5819','2013-11-10','11:05:00',1.81),('5819','2013-11-10','11:10:00',1.32),('5819','2013-11-10','11:25:00',1.31),('5819','2013-11-10','11:40:00',1.3),('5819','2013-11-10','11:45:00',1.88),('5819','2013-11-10','11:50:00',1.51),('5819','2013-11-10','11:55:00',1.14),('5819','2013-11-10','12:00:00',1.17),('5819','2013-11-10','12:05:00',1.34),('5819','2013-11-10','12:10:00',1.66),('5819','2013-11-10','12:15:00',2.73),('5819','2013-11-10','12:20:00',2.81),('5819','2013-11-10','12:25:00',2.61),('5819','2013-11-10','12:30:00',1.98),('5819','2013-11-10','12:35:00',1.63),('5819','2013-11-10','12:40:00',2.78),('5819','2013-11-10','12:45:00',2.97),('5819','2013-11-10','12:50:00',2.97),('5819','2013-11-10','12:55:00',1.47),('5819','2013-11-10','13:00:00',1.03),('5819','2013-11-10','13:50:00',1.8),('5819','2013-11-10','13:55:00',1.97),('5819','2013-11-09','09:40:00',2.71),('5819','2013-11-09','09:45:00',1.82),('5819','2013-11-09','09:50:00',2.6),('5819','2013-11-09','09:55:00',2.89),('5819','2013-11-09','10:00:00',2.72),('5819','2013-11-09','10:05:00',2.52),('5819','2013-11-09','10:10:00',2.42),('5819','2013-11-09','10:15:00',2.28),('5819','2013-11-09','10:20:00',2.52),('5819','2013-11-09','10:25:00',2.75),('5819','2013-11-09','10:30:00',1.2),('5819','2013-11-09','10:35:00',1.27),('5819','2013-11-09','10:40:00',1.29),('5819','2013-11-09','10:45:00',1.39),('5819','2013-11-09','10:50:00',1.29),('5819','2013-11-09','10:55:00',1.97),('5819','2013-11-09','11:00:00',2.32),('5819','2013-11-09','11:05:00',3.3),('5819','2013-11-09','11:10:00',2.87),('5819','2013-11-09','11:15:00',3.69),('5819','2013-11-09','11:20:00',2.73),('5819','2013-11-09','11:25:00',1.33),('5819','2013-11-09','11:30:00',2.71),('5819','2013-11-09','11:35:00',2.76),('5819','2013-11-09','11:40:00',2.3),('5819','2013-11-09','11:45:00',2.05),('5819','2013-11-09','11:50:00',1.49),('5819','2013-11-09','11:55:00',2.02),('5819','2013-11-09','12:00:00',2.28),('5819','2013-11-09','12:05:00',2.68),('5819','2013-11-09','12:10:00',1.95),('5819','2013-11-09','12:15:00',1.98),('5819','2013-11-09','12:20:00',1.11),('5819','2013-11-09','12:25:00',1.5),('5819','2013-11-09','12:30:00',2.14),('5819','2013-11-09','12:35:00',2.71),('5819','2013-11-09','12:40:00',1.76),('5819','2013-11-09','12:45:00',1.5),('5819','2013-11-09','12:50:00',2.45),('5819','2013-11-09','12:55:00',2.29),('5819','2013-11-09','13:00:00',2.99),('5819','2013-11-09','13:05:00',2.68),('5819','2013-11-09','13:10:00',2.77),('5819','2013-11-09','13:15:00',2.76),('5819','2013-11-09','13:20:00',1.85),('5819','2013-11-09','13:25:00',1.95),('5819','2013-11-09','13:30:00',2.46),('5819','2013-11-09','13:35:00',2.34),('5819','2013-11-09','13:40:00',2.08),('5819','2013-11-09','13:45:00',2.09),('5819','2013-11-09','13:50:00',2.04),('5819','2013-11-09','13:55:00',2.01),('5819','2013-11-09','14:00:00',1.82),('5819','2013-11-09','14:05:00',1.68),('5819','2013-11-09','14:10:00',1.24),('5819','2013-11-09','14:15:00',1.05),('5819','2013-11-09','14:20:00',1.89),('5819','2013-11-09','14:25:00',1.51),('5819','2013-11-09','14:40:00',1.35),('5819','2013-11-09','14:50:00',1.2),('5819','2013-11-08','09:10:00',1.38),('5819','2013-11-08','09:15:00',1.18),('5819','2013-11-08','09:20:00',2.03),('5819','2013-11-08','09:25:00',2.11),('5819','2013-11-08','09:30:00',2.21),('5819','2013-11-08','09:35:00',2.39),('5819','2013-11-08','09:40:00',1.8),('5819','2013-11-08','09:45:00',1.07),('5819','2013-11-08','09:50:00',2.07),('5819','2013-11-08','09:55:00',1.19),('5819','2013-11-08','10:00:00',1.35),('5819','2013-11-08','10:05:00',1.87),('5819','2013-11-08','10:10:00',2.7),('5819','2013-11-08','10:45:00',1.02),('5819','2013-11-08','10:50:00',2.32),('5819','2013-11-08','10:55:00',2.2),('5819','2013-11-08','11:00:00',1.23),('5819','2013-11-08','11:05:00',1.21),('5819','2013-11-08','11:25:00',2.71),('5819','2013-11-08','11:30:00',3.35),('5819','2013-11-08','11:35:00',3.26),('5819','2013-11-08','11:40:00',3.14),('5819','2013-11-08','11:45:00',3.1),('5819','2013-11-08','11:50:00',3.11),('5819','2013-11-08','11:55:00',2.89),('5819','2013-11-08','12:00:00',1.54),('5819','2013-11-08','12:05:00',2.8),('5819','2013-11-08','12:10:00',2.72),('5819','2013-11-08','12:15:00',2.36),('5819','2013-11-08','12:40:00',2.31),('5819','2013-11-08','12:45:00',1.73),('5819','2013-11-08','12:50:00',2.39),('5819','2013-11-08','12:55:00',2.8),('5819','2013-11-08','13:00:00',2.72),('5819','2013-11-08','13:05:00',2.56),('5819','2013-11-08','13:10:00',2.54),('5819','2013-11-08','13:15:00',2.6),('5819','2013-11-08','13:20:00',1.79),('5819','2013-11-08','13:25:00',2.57),('5819','2013-11-08','13:30:00',1.63),('5819','2013-11-08','13:35:00',2.11),('5819','2013-11-08','13:40:00',2.22),('5819','2013-11-08','13:45:00',2.1),('5819','2013-11-08','13:50:00',2.03),('5819','2013-11-08','13:55:00',1.99),('5819','2013-11-08','14:00:00',1.94),('5819','2013-11-08','14:05:00',1.83),('5819','2013-11-08','14:10:00',1.77),('5819','2013-11-08','14:15:00',1.61),('5819','2013-11-08','14:25:00',1.28),('5819','2013-11-08','14:35:00',1.43),('5819','2013-11-08','14:40:00',1.31),('5819','2013-11-08','14:45:00',1.34),('5819','2013-11-08','14:50:00',1.28),('5819','2013-11-08','14:55:00',1.03),('5819','2013-11-08','15:05:00',1.01),('5819','2013-11-08','15:10:00',1.01),('5819','2014-04-18','08:05:00',1.87),('5819','2014-04-18','08:10:00',1.58),('5819','2014-04-18','08:35:00',1.06),('5819','2014-04-18','08:40:00',1.58),('5819','2014-04-18','08:45:00',1.43),('5819','2014-04-18','08:50:00',1.07),('5819','2014-04-18','09:25:00',2.07),('5819','2014-04-18','09:30:00',3.18),('5819','2014-04-18','09:35:00',1.65),('5819','2014-04-18','09:40:00',1.22),('5819','2014-04-18','09:45:00',1.82),('5819','2014-04-18','09:50:00',2.95),('5819','2014-04-18','09:55:00',2.81),('5819','2014-04-18','10:00:00',2.5),('5819','2014-04-18','10:05:00',1.6),('5819','2014-04-18','10:10:00',1.46),('5819','2014-04-18','10:15:00',1.67),('5819','2014-04-18','10:20:00',1.37),('5819','2014-04-18','10:25:00',1.43),('5819','2014-04-18','10:30:00',1.18),('5819','2014-04-18','10:35:00',1.07),('5819','2014-04-18','10:40:00',1.34),('5819','2014-04-18','10:45:00',2.6),('5819','2014-04-18','10:50:00',2.93),('5819','2014-04-18','10:55:00',2.84),('5819','2014-04-18','11:00:00',1.7),('5819','2014-04-18','11:05:00',1.53),('5819','2014-04-18','11:10:00',2.17),('5819','2014-04-18','11:15:00',2.53),('5819','2014-04-18','11:20:00',1.65),('5819','2014-04-18','11:25:00',1.25),('5819','2014-04-18','11:30:00',1.58),('5819','2014-04-18','11:35:00',1.48),('5819','2014-04-18','11:40:00',1.56),('5819','2014-04-18','11:45:00',1.48),('5819','2014-04-18','11:50:00',1.77),('5819','2014-04-18','11:55:00',1.67),('5819','2014-04-18','12:00:00',1.67),('5819','2014-04-18','12:05:00',2.74),('5819','2014-04-18','12:10:00',3.13),('5819','2014-04-18','12:15:00',2.88),('5819','2014-04-18','12:20:00',3.7),('5819','2014-04-18','12:25:00',2.83),('5819','2014-04-18','12:30:00',4.23),('5819','2014-04-18','12:35:00',3.97),('5819','2014-04-18','12:40:00',4.08),('5819','2014-04-18','12:45:00',3.46),('5819','2014-04-18','12:50:00',3.42),('5819','2014-04-18','12:55:00',2.47),('5819','2014-04-18','13:00:00',4.28),('5819','2014-04-18','13:05:00',3.01),('5819','2014-04-18','13:10:00',2.49),('5819','2014-04-18','13:15:00',2.33),('5819','2014-04-18','13:20:00',2.08),('5819','2014-04-18','13:25:00',1.51),('5819','2014-04-18','13:30:00',1.34),('5819','2014-04-18','13:35:00',1.33),('5819','2014-04-18','13:40:00',1.13),('5819','2014-04-18','13:50:00',1.3),('5819','2014-04-18','13:55:00',2.01),('5819','2014-04-18','14:00:00',1.78),('5819','2014-04-18','14:05:00',1.44),('5819','2014-04-18','14:10:00',1.29),('5819','2014-04-18','14:15:00',1.16),('5819','2014-04-18','14:20:00',1.43),('5819','2014-04-18','14:25:00',1.83),('5819','2014-04-18','14:30:00',2.03),('5819','2014-04-18','14:35:00',2.28),('5819','2014-04-18','14:40:00',2.13),('5819','2014-04-18','14:45:00',2.56),('5819','2014-04-18','14:50:00',2.93),('5819','2014-04-18','14:55:00',1.98),('5819','2014-04-18','15:00:00',3.64),('5819','2014-04-18','15:05:00',2.14),('5819','2014-04-18','15:10:00',2.01),('5819','2014-04-18','15:15:00',2.21),('5819','2014-04-18','15:20:00',1.87),('5819','2014-04-18','15:25:00',1.95),('5819','2014-04-18','15:30:00',2.47),('5819','2014-04-18','15:35:00',3.2),('5819','2014-04-18','15:40:00',1.57),('5819','2014-04-18','15:45:00',2.04),('5819','2014-04-18','15:50:00',2.41),('5819','2014-04-18','15:55:00',2.16),('5819','2014-04-18','16:00:00',1.94),('5819','2014-04-18','16:05:00',1.54),('5819','2014-04-18','16:10:00',1.25),('5819','2014-04-18','16:15:00',1.1),('5819','2014-04-18','16:20:00',1.17),('5819','2014-04-18','16:25:00',1.65),('5819','2014-04-18','16:30:00',1.85),('5819','2014-04-18','16:35:00',2.06),('5819','2014-04-18','16:40:00',2.24),('5819','2014-04-18','16:45:00',2.13),('5819','2014-04-18','16:50:00',2.05),('5819','2014-04-18','16:55:00',1.44),('5819','2014-04-18','17:00:00',1.71),('5819','2014-04-18','17:05:00',1.98),('5819','2014-04-18','17:10:00',1.42),('5819','2014-04-18','17:15:00',1.54),('5819','2014-04-18','17:20:00',1.39),('5819','2014-04-18','17:25:00',1.38),('5819','2014-04-18','17:30:00',1.13),('5819','2014-04-18','17:35:00',1.08),('5819','2014-04-18','17:40:00',1.07),('5819','2013-11-07','07:50:00',1.08),('5819','2013-11-07','07:55:00',1.16),('5819','2013-11-07','08:00:00',1.25),('5819','2013-11-07','08:05:00',1.33),('5819','2013-11-07','08:10:00',1.41),('5819','2013-11-07','08:15:00',1.47),('5819','2013-11-07','08:20:00',1.54),('5819','2013-11-07','08:25:00',1.61),('5819','2013-11-07','08:30:00',1.67),('5819','2013-11-07','08:35:00',1.74),('5819','2013-11-07','08:40:00',1.8),('5819','2013-11-07','08:45:00',1.86),('5819','2013-11-07','08:50:00',1.92),('5819','2013-11-07','08:55:00',1.98),('5819','2013-11-07','09:00:00',2.03),('5819','2013-11-07','09:05:00',2.09),('5819','2013-11-07','09:10:00',2.13),('5819','2013-11-07','09:15:00',2.17),('5819','2013-11-07','09:20:00',2.22),('5819','2013-11-07','09:25:00',2.27),('5819','2013-11-07','09:30:00',2.32),('5819','2013-11-07','09:35:00',2.35),('5819','2013-11-07','09:40:00',2.39),('5819','2013-11-07','09:45:00',2.43),('5819','2013-11-07','09:50:00',2.45),('5819','2013-11-07','09:55:00',2.48),('5819','2013-11-07','10:00:00',2.48),('5819','2013-11-07','10:05:00',2.49),('5819','2013-11-07','10:10:00',2.53),('5819','2013-11-07','10:15:00',2.55),('5819','2013-11-07','10:20:00',2.57),('5819','2013-11-07','10:25:00',2.58),('5819','2013-11-07','10:30:00',2.6),('5819','2013-11-07','10:35:00',2.62),('5819','2013-11-07','10:40:00',2.6),('5819','2013-11-07','10:45:00',2.6),('5819','2013-11-07','10:50:00',2.61),('5819','2013-11-07','10:55:00',2.6),('5819','2013-11-07','11:00:00',2.65),('5819','2013-11-07','11:05:00',2.62),('5819','2013-11-07','11:10:00',2.63),('5819','2013-11-07','11:15:00',2.63),('5819','2013-11-07','11:20:00',2.62),('5819','2013-11-07','11:25:00',2.61),('5819','2013-11-07','11:30:00',2.5),('5819','2013-11-07','11:35:00',2.45),('5819','2013-11-07','11:40:00',2.57),('5819','2013-11-07','11:45:00',2.59),('5819','2013-11-07','11:50:00',2.54),('5819','2013-11-07','11:55:00',2.5),('5819','2013-11-07','12:00:00',2.5),('5819','2013-11-07','12:05:00',2.49),('5819','2013-11-07','12:10:00',2.4),('5819','2013-11-07','12:15:00',2.42),('5819','2013-11-07','12:20:00',2.43),('5819','2013-11-07','12:25:00',2.41),('5819','2013-11-07','12:30:00',2.34),('5819','2013-11-07','12:35:00',2.36),('5819','2013-11-07','12:40:00',2.31),('5819','2013-11-07','12:45:00',2.27),('5819','2013-11-07','12:50:00',2.23),('5819','2013-11-07','12:55:00',2.31),('5819','2013-11-07','13:00:00',2.36),('5819','2013-11-07','13:05:00',2.46),('5819','2013-11-07','13:10:00',1.83),('5819','2013-11-07','13:15:00',1.24),('5819','2013-11-07','13:20:00',1.51),('5819','2013-11-07','13:40:00',2.13),('5819','2013-11-07','13:45:00',1.31),('5819','2013-11-07','13:50:00',1.4),('5819','2013-11-07','13:55:00',2.11),('5819','2013-11-07','14:00:00',1.16),('5819','2013-11-07','14:05:00',1.23),('5819','2013-11-07','14:10:00',1.34),('5819','2013-11-07','14:15:00',1.03),('5819','2013-11-07','14:20:00',1.04),('5819','2013-11-07','14:25:00',1.55),('5819','2013-11-07','14:35:00',1.38),('5819','2013-11-07','14:40:00',1.48),('5819','2013-11-07','14:45:00',1.33),('5819','2013-11-07','14:50:00',1.25),('5819','2013-11-07','14:55:00',1.19),('5819','2013-11-07','15:00:00',1.12),('5819','2013-11-07','15:05:00',1.06),('5819','2013-11-06','08:05:00',1.03),('5819','2013-11-06','08:10:00',1.47),('5819','2013-11-06','08:15:00',1.66),('5819','2013-11-06','08:20:00',1.49),('5819','2013-11-06','08:35:00',1.85),('5819','2013-11-06','08:40:00',1.87),('5819','2013-11-06','08:45:00',1.95),('5819','2013-11-06','08:50:00',2.09),('5819','2013-11-06','08:55:00',1.94),('5819','2013-11-06','09:00:00',1.37),('5819','2013-11-06','09:05:00',1.5),('5819','2013-11-06','09:10:00',1.31),('5819','2013-11-06','09:15:00',1.82),('5819','2013-11-06','09:20:00',2.19),('5819','2013-11-06','09:25:00',2.23),('5819','2013-11-06','09:30:00',2.4),('5819','2013-11-06','09:35:00',2.43),('5819','2013-11-06','09:40:00',2.46),('5819','2013-11-06','09:45:00',2.48),('5819','2013-11-06','09:50:00',2.51),('5819','2013-11-06','09:55:00',2.54),('5819','2013-11-06','10:00:00',2.59),('5819','2013-11-06','10:05:00',2.61),('5819','2013-11-06','10:10:00',2.63),('5819','2013-11-06','10:15:00',2.65),('5819','2013-11-06','10:20:00',2.69),('5819','2013-11-06','10:25:00',2.73),('5819','2013-11-06','10:30:00',2.75),('5819','2013-11-06','10:35:00',2.77),('5819','2013-11-06','10:40:00',2.78),('5819','2013-11-06','10:45:00',2.79),('5819','2013-11-06','10:50:00',2.8),('5819','2013-11-06','10:55:00',2.79),('5819','2013-11-06','11:00:00',2.8),('5819','2013-11-06','11:05:00',2.81),('5819','2013-11-06','11:10:00',2.79),('5819','2013-11-06','11:15:00',2.8),('5819','2013-11-06','11:20:00',2.8),('5819','2013-11-06','11:25:00',2.82),('5819','2013-11-06','11:30:00',2.8),('5819','2013-11-06','11:35:00',2.78),('5819','2013-11-06','11:40:00',2.79),('5819','2013-11-06','11:45:00',2.79),('5819','2013-11-06','11:50:00',2.79),('5819','2013-11-06','11:55:00',2.77),('5819','2013-11-06','12:00:00',2.75),('5819','2013-11-06','12:05:00',2.76),('5819','2013-11-06','12:10:00',2.73),('5819','2013-11-06','12:15:00',2.7),('5819','2013-11-06','12:20:00',2.69),('5819','2013-11-06','12:25:00',2.67),('5819','2013-11-06','12:30:00',2.64),('5819','2013-11-06','12:35:00',2.61),('5819','2013-11-06','12:40:00',2.58),('5819','2013-11-06','12:45:00',2.54),('5819','2013-11-06','12:50:00',2.52),('5819','2013-11-06','12:55:00',2.49),('5819','2013-11-06','13:00:00',2.44),('5819','2013-11-06','13:05:00',2.41),('5819','2013-11-06','13:10:00',2.36),('5819','2013-11-06','13:15:00',2.31),('5819','2013-11-06','13:20:00',2.28),('5819','2013-11-06','13:25:00',2.25),('5819','2013-11-06','13:30:00',2.2),('5819','2013-11-06','13:35:00',2.14),('5819','2013-11-06','13:40:00',2.09),('5819','2013-11-06','13:45:00',2.03),('5819','2013-11-06','13:50:00',1.99),('5819','2013-11-06','13:55:00',1.94),('5819','2013-11-06','14:00:00',1.89),('5819','2013-11-06','14:05:00',1.83),('5819','2013-11-06','14:10:00',1.78),('5819','2013-11-06','14:15:00',1.72),('5819','2013-11-06','14:20:00',1.66),('5819','2013-11-06','14:25:00',1.59),('5819','2013-11-06','14:30:00',1.53),('5819','2013-11-06','14:35:00',1.47),('5819','2013-11-06','14:40:00',1.41),('5819','2013-11-06','14:45:00',1.34),('5819','2013-11-06','14:50:00',1.26),('5819','2013-11-06','14:55:00',1.2),('5819','2013-11-06','15:00:00',1.14),('5819','2013-11-06','15:05:00',1.07),('5819','2013-11-06','15:10:00',1),('5819','2013-11-05','08:25:00',1.33),('5819','2013-11-05','08:30:00',1.67),('5819','2013-11-05','08:35:00',1.91),('5819','2013-11-05','08:40:00',1.96),('5819','2013-11-05','08:45:00',1.19),('5819','2013-11-05','10:20:00',1.46),('5819','2013-11-05','10:25:00',2.05),('5819','2013-11-05','10:30:00',1.74),('5819','2013-11-05','10:35:00',1.94),('5819','2013-11-05','10:40:00',1.91),('5819','2013-11-05','10:45:00',1.89),('5819','2013-11-05','10:50:00',1.6),('5819','2013-11-05','10:55:00',1.39),('5819','2013-11-05','11:00:00',1.12),('5819','2013-11-05','11:40:00',1.31),('5819','2013-11-05','11:45:00',1.38),('5819','2013-11-05','11:50:00',1.26),('5819','2013-11-05','11:55:00',1.08),('5819','2013-11-05','12:10:00',1.12),('5819','2013-11-05','12:15:00',1.22),('5819','2013-11-05','12:20:00',1.54),('5819','2013-11-05','12:25:00',1.65),('5819','2013-11-05','12:30:00',1.14),('5819','2013-11-05','13:35:00',1.85),('5819','2013-11-05','13:40:00',2.13),('5819','2013-11-05','13:45:00',2.03),('5819','2013-11-05','13:50:00',1.31),('5819','2013-11-05','13:55:00',1.26),('5819','2013-11-05','14:00:00',2.01),('5819','2013-11-05','14:05:00',2.04),('5819','2013-11-05','14:10:00',2.31),('5819','2013-11-05','14:15:00',1.76),('5819','2013-11-05','14:20:00',1.2),('5819','2013-11-05','14:25:00',1),('5819','2013-11-05','14:30:00',1.18),('5819','2013-11-05','14:35:00',1.34),('5819','2013-11-04','07:55:00',1.09),('5819','2013-11-04','08:00:00',1.2),('5819','2013-11-04','08:05:00',1.27),('5819','2013-11-04','08:10:00',1.32),('5819','2013-11-04','08:15:00',1.41),('5819','2013-11-04','08:20:00',1.55),('5819','2013-11-04','08:25:00',1.45),('5819','2013-11-04','08:30:00',1.53),('5819','2013-11-04','08:35:00',1.23),('5819','2013-11-04','08:40:00',1.07),('5819','2013-11-04','09:10:00',2.1),('5819','2013-11-04','09:15:00',2.45),('5819','2013-11-04','09:20:00',2.59),('5819','2013-11-04','09:25:00',2.92),('5819','2013-11-04','09:30:00',1.82),('5819','2013-11-04','10:05:00',2.32),('5819','2013-11-04','10:10:00',2.76),('5819','2013-11-04','10:15:00',2.78),('5819','2013-11-04','10:20:00',2.81),('5819','2013-11-04','10:25:00',3.08),('5819','2013-11-04','10:30:00',2.99),('5819','2013-11-04','10:35:00',2.15),('5819','2013-11-04','10:40:00',3.12),('5819','2013-11-04','10:45:00',2.04),('5819','2013-11-04','10:50:00',1.65),('5819','2013-11-04','10:55:00',1.29),('5819','2013-11-04','11:00:00',1.89),('5819','2013-11-04','11:05:00',3.6),('5819','2013-11-04','11:10:00',1.81),('5819','2013-11-04','11:15:00',2.92),('5819','2013-11-04','11:20:00',1.94),('5819','2013-11-04','11:25:00',1.2),('5819','2013-11-04','11:30:00',2.15),('5819','2013-11-04','11:35:00',2.77),('5819','2013-11-04','11:40:00',1.96),('5819','2013-11-04','11:45:00',2.22),('5819','2013-11-04','11:50:00',3.57),('5819','2013-11-04','11:55:00',3.23),('5819','2013-11-04','12:00:00',2.73),('5819','2013-11-04','12:05:00',2.75),('5819','2013-11-04','12:10:00',2.75),('5819','2013-11-04','12:15:00',2.33),('5819','2013-11-04','12:20:00',2.89),('5819','2013-11-04','12:25:00',2.87),('5819','2013-11-04','12:30:00',2.81),('5819','2013-11-04','12:35:00',2.85),('5819','2013-11-04','12:40:00',2.43),('5819','2013-11-04','12:45:00',2.42),('5819','2013-11-04','12:50:00',2.34),('5819','2013-11-04','12:55:00',2.6),('5819','2013-11-04','13:00:00',2.56),('5819','2013-11-04','13:05:00',2.54),('5819','2013-11-04','13:10:00',2.43),('5819','2013-11-04','13:15:00',2.19),('5819','2013-11-04','13:20:00',2.14),('5819','2013-11-04','13:25:00',2.39),('5819','2013-11-04','13:30:00',2.35),('5819','2013-11-04','13:35:00',2.31),('5819','2013-11-04','13:40:00',2.25),('5819','2013-11-04','13:45:00',1.97),('5819','2013-11-04','13:50:00',2.23),('5819','2013-11-04','13:55:00',2.01),('5819','2013-11-04','14:00:00',1.66),('5819','2013-11-04','14:05:00',1.99),('5819','2013-11-04','14:10:00',1.69),('5819','2013-11-04','14:15:00',1.88),('5819','2013-11-04','14:20:00',2),('5819','2013-11-04','14:25:00',1.26),('5819','2013-11-04','14:30:00',1.73),('5819','2013-11-04','14:35:00',1.6),('5819','2013-11-04','14:40:00',1.65),('5819','2013-11-04','14:45:00',1.31),('5819','2013-11-04','14:50:00',1.38),('5819','2013-11-04','14:55:00',1.06),('5819','2013-11-04','15:00:00',1.33),('5819','2013-11-03','07:40:00',1.04),('5819','2013-11-03','07:45:00',1.17),('5819','2013-11-03','07:50:00',1.14),('5819','2013-11-03','07:55:00',1),('5819','2013-11-03','08:00:00',1.03),('5819','2013-11-03','08:20:00',1.13),('5819','2013-11-03','08:25:00',1.06),('5819','2013-11-03','08:35:00',1.19),('5819','2013-11-03','08:40:00',1.47),('5819','2013-11-03','08:50:00',1.05),('5819','2013-11-03','08:55:00',1.35),('5819','2013-11-03','09:40:00',2.39),('5819','2013-11-03','09:45:00',1.97),('5819','2013-11-03','10:10:00',2.03),('5819','2013-11-03','10:20:00',1.99),('5819','2013-11-03','10:25:00',2.41),('5819','2013-11-03','10:30:00',2.62),('5819','2013-11-03','10:35:00',2.25),('5819','2013-11-03','11:20:00',1.41),('5819','2013-11-03','11:25:00',2.17),('5819','2013-11-03','11:30:00',1.64),('5819','2013-11-03','11:35:00',2.61),('5819','2013-11-03','11:40:00',2.95),('5819','2013-11-03','11:45:00',3.14),('5819','2013-11-03','11:50:00',3.22),('5819','2013-11-03','11:55:00',3.14),('5819','2013-11-03','12:00:00',1.62),('5819','2013-11-03','12:05:00',2.69),('5819','2013-11-03','12:10:00',2.84),('5819','2013-11-03','12:15:00',1.1),('5819','2013-11-03','12:20:00',1.53),('5819','2013-11-03','12:25:00',1.14),('5819','2013-11-03','12:30:00',1.23),('5819','2013-11-03','12:35:00',1.19),('5819','2013-11-03','12:40:00',1.21),('5819','2013-11-03','12:45:00',1.1),('5819','2013-11-03','13:40:00',1.2),('5819','2013-11-03','13:45:00',1.77),('5819','2013-11-03','13:50:00',1.36),('5819','2013-11-03','14:00:00',1.05),('5819','2013-11-03','14:05:00',2.19),('5819','2013-11-03','14:10:00',1.79),('5819','2013-11-03','14:15:00',1.72),('5819','2013-11-03','14:20:00',1.56),('5819','2013-11-03','14:25:00',1.91),('5819','2013-11-03','14:30:00',1.18),('5819','2013-11-03','14:35:00',1.05),('5819','2013-11-03','14:40:00',1.62),('5819','2013-11-03','14:45:00',1.41),('5819','2013-11-03','14:50:00',1.03),('5819','2013-11-02','08:00:00',1.11),('5819','2013-11-02','08:05:00',1.18),('5819','2013-11-02','08:10:00',1.25),('5819','2013-11-02','08:15:00',1.37),('5819','2013-11-02','08:20:00',1.45),('5819','2013-11-02','08:25:00',1.5),('5819','2013-11-02','08:30:00',1.59),('5819','2013-11-02','08:35:00',1.67),('5819','2013-11-02','08:40:00',1.75),('5819','2013-11-02','08:45:00',1.81),('5819','2013-11-02','08:50:00',1.85),('5819','2013-11-02','08:55:00',1.92),('5819','2013-11-02','09:00:00',1.99),('5819','2013-11-02','09:05:00',2.11),('5819','2013-11-02','09:10:00',2.24),('5819','2013-11-02','09:15:00',1.1),('5819','2013-11-02','09:20:00',1.81),('5819','2013-11-02','09:25:00',2.39),('5819','2013-11-02','09:30:00',2.3),('5819','2013-11-02','09:35:00',2.34),('5819','2013-11-02','09:40:00',2.28),('5819','2013-11-02','09:45:00',1.81),('5819','2013-11-02','09:50:00',2.55),('5819','2013-11-02','09:55:00',2.61),('5819','2013-11-02','10:00:00',2.79),('5819','2013-11-02','10:05:00',3.11),('5819','2013-11-02','10:10:00',1.73),('5819','2013-11-02','10:15:00',1.11),('5819','2013-11-02','11:05:00',1.24),('5819','2013-11-02','11:10:00',1.16),('5819','2013-11-02','11:50:00',1.01),('5819','2013-11-02','11:55:00',1.46),('5819','2013-11-02','12:00:00',3.15),('5819','2013-11-02','12:05:00',3.39),('5819','2013-11-02','12:10:00',3),('5819','2013-11-02','12:15:00',3.42),('5819','2013-11-02','12:20:00',3.15),('5819','2013-11-02','12:25:00',3.19),('5819','2013-11-02','12:30:00',3.41),('5819','2013-11-02','12:35:00',3.31),('5819','2013-11-02','12:40:00',2.77),('5819','2013-11-02','12:45:00',2.32),('5819','2013-11-02','12:50:00',2.38),('5819','2013-11-02','12:55:00',3.01),('5819','2013-11-02','13:00:00',2.62),('5819','2013-11-02','13:05:00',2.86),('5819','2013-11-02','13:10:00',3.01),('5819','2013-11-02','13:15:00',1.98),('5819','2013-11-02','13:20:00',1.06),('5819','2013-11-02','13:30:00',1.73),('5819','2013-11-02','13:35:00',1.67),('5819','2013-11-02','13:40:00',2.6),('5819','2013-11-02','13:45:00',2.31),('5819','2013-11-02','13:50:00',2.8),('5819','2013-11-02','13:55:00',2.67),('5819','2013-11-02','14:00:00',2.48),('5819','2013-11-02','14:05:00',2.17),('5819','2013-11-02','14:10:00',1.96),('5819','2013-11-02','14:15:00',1.84),('5819','2013-11-02','14:20:00',1.74),('5819','2013-11-02','14:25:00',1.65),('5819','2013-11-02','14:30:00',1.59),('5819','2013-11-02','14:35:00',1.52),('5819','2013-11-02','14:40:00',1.46),('5819','2013-11-02','14:45:00',1.38),('5819','2013-11-02','14:50:00',1.32),('5819','2013-11-02','14:55:00',1.27),('5819','2013-11-02','15:00:00',1.17),('5819','2013-11-02','15:05:00',1.03),('5819','2013-11-02','15:10:00',1.11),('5819','2013-11-01','08:00:00',1.04),('5819','2013-11-01','08:15:00',1.04),('5819','2013-11-01','08:20:00',1.23),('5819','2013-11-01','08:25:00',1.29),('5819','2013-11-01','08:30:00',1.51),('5819','2013-11-01','08:35:00',1.61),('5819','2013-11-01','08:40:00',1.74),('5819','2013-11-01','08:45:00',1.79),('5819','2013-11-01','08:50:00',1.7),('5819','2013-11-01','08:55:00',1.79),('5819','2013-11-01','09:00:00',1.86),('5819','2013-11-01','09:05:00',2.05),('5819','2013-11-01','09:10:00',2.11),('5819','2013-11-01','09:15:00',2.13),('5819','2013-11-01','09:20:00',2.2),('5819','2013-11-01','09:25:00',2.25),('5819','2013-11-01','09:30:00',2.28),('5819','2013-11-01','09:35:00',2.32),('5819','2013-11-01','09:40:00',2.37),('5819','2013-11-01','09:45:00',2.43),('5819','2013-11-01','09:50:00',2.48),('5819','2013-11-01','09:55:00',2.51),('5819','2013-11-01','10:00:00',2.55),('5819','2013-11-01','10:05:00',2.58),('5819','2013-11-01','10:10:00',2.61),('5819','2013-11-01','10:15:00',2.63),('5819','2013-11-01','10:20:00',2.66),('5819','2013-11-01','10:25:00',2.69),('5819','2013-11-01','10:30:00',2.66),('5819','2013-11-01','10:35:00',2.64),('5819','2013-11-01','10:40:00',2.7),('5819','2013-11-01','10:45:00',2.64),('5819','2013-11-01','10:50:00',2.65),('5819','2013-11-01','10:55:00',2.59),('5819','2013-11-01','11:00:00',2.68),('5819','2013-11-01','11:05:00',2.57),('5819','2013-11-01','11:10:00',2.23),('5819','2013-11-01','11:15:00',2.23),('5819','2013-11-01','11:20:00',2.67),('5819','2013-11-01','11:25:00',2.86),('5819','2013-11-01','11:30:00',2.86),('5819','2013-11-01','11:35:00',2.78),('5819','2013-11-01','11:40:00',2.61),('5819','2013-11-01','11:45:00',2.39),('5819','2013-11-01','11:50:00',2.74),('5819','2013-11-01','11:55:00',2.82),('5819','2013-11-01','12:00:00',2.82),('5819','2013-11-01','12:05:00',2.75),('5819','2013-11-01','12:10:00',2.57),('5819','2013-11-01','12:15:00',2.53),('5819','2013-11-01','12:20:00',2.05),('5819','2013-11-01','12:30:00',1.71),('5819','2013-11-01','12:35:00',2.25),('5819','2013-11-01','13:20:00',1.13),('5819','2013-11-01','13:25:00',1),('5819','2013-11-01','13:30:00',1.13),('5819','2013-11-01','13:35:00',1.09),('5819','2013-11-01','13:40:00',1.01),('5819','2013-11-01','13:45:00',1.05),('5819','2013-10-31','08:20:00',1.07),('5819','2013-10-31','08:25:00',1.01),('5819','2013-10-31','08:30:00',1.43),('5819','2013-10-31','08:35:00',1.57),('5819','2013-10-31','08:40:00',1.84),('5819','2013-10-31','08:45:00',1.83),('5819','2013-10-31','08:50:00',1.69),('5819','2013-10-31','08:55:00',1.2),('5819','2013-10-31','09:00:00',1.88),('5819','2013-10-31','09:05:00',1.75),('5819','2013-10-31','09:15:00',1.13),('5819','2013-10-31','09:20:00',1.26),('5819','2013-10-31','09:35:00',1.97),('5819','2013-10-31','09:40:00',1.81),('5819','2013-10-31','09:45:00',1.87),('5819','2013-10-31','09:50:00',2.01),('5819','2013-10-31','09:55:00',1.96),('5819','2013-10-31','10:00:00',1.94),('5819','2013-10-31','10:05:00',1.69),('5819','2013-10-31','10:10:00',1.49),('5819','2013-10-31','10:15:00',1.43),('5819','2013-10-31','10:20:00',1.63),('5819','2013-10-31','10:25:00',1.78),('5819','2013-10-31','10:30:00',1.69),('5819','2013-10-31','10:35:00',1.74),('5819','2013-10-31','10:40:00',1.82),('5819','2013-10-31','10:45:00',1.75),('5819','2013-10-31','10:50:00',1.78),('5819','2013-10-31','10:55:00',2.04),('5819','2013-10-31','11:00:00',2.52),('5819','2013-10-31','11:05:00',2.74),('5819','2013-10-31','11:10:00',2.65),('5819','2013-10-31','11:15:00',1.98),('5819','2013-10-31','11:20:00',2.62),('5819','2013-10-31','11:25:00',2.36),('5819','2013-10-31','11:30:00',2.44),('5819','2013-10-31','11:35:00',2.36),('5819','2013-10-31','11:40:00',2.5),('5819','2013-10-31','11:45:00',2.68),('5819','2013-10-31','11:50:00',2.68),('5819','2013-10-31','11:55:00',2.7),('5819','2013-10-31','12:00:00',2.63),('5819','2013-10-31','12:05:00',2.56),('5819','2013-10-31','12:10:00',2.5),('5819','2013-10-31','12:15:00',2.56),('5819','2013-10-31','12:20:00',2.5),('5819','2013-10-31','12:25:00',2.52),('5819','2013-10-31','12:30:00',2.46),('5819','2013-10-31','12:35:00',2.39),('5819','2013-10-31','12:40:00',2.45),('5819','2013-10-31','12:45:00',2.49),('5819','2013-10-31','12:50:00',2.5),('5819','2013-10-31','12:55:00',2.53),('5819','2013-10-31','13:00:00',2.48),('5819','2013-10-31','13:05:00',2.41),('5819','2013-10-31','13:10:00',2.36),('5819','2013-10-31','13:15:00',2.31),('5819','2013-10-31','13:20:00',2.28),('5819','2013-10-31','13:25:00',2.21),('5819','2013-10-31','13:30:00',2.13),('5819','2013-10-31','13:35:00',2.07),('5819','2013-10-31','13:40:00',1.89),('5819','2013-10-31','13:45:00',1.87),('5819','2013-10-31','13:50:00',1.6),('5819','2013-10-31','13:55:00',1.31),('5819','2013-10-31','14:00:00',1.84),('5819','2013-10-31','14:05:00',1.78),('5819','2013-10-31','14:10:00',1.65),('5819','2013-10-31','14:15:00',1.59),('5819','2013-10-31','14:20:00',1.37),('5819','2013-10-31','14:25:00',1.51),('5819','2013-10-31','14:30:00',1.2),('5819','2013-10-31','14:35:00',1.05),('5819','2013-10-31','14:50:00',1.02),('5819','2013-10-30','08:00:00',1.02),('5819','2013-10-30','08:05:00',1.09),('5819','2013-10-30','08:10:00',1.17),('5819','2013-10-30','08:15:00',1.24),('5819','2013-10-30','08:20:00',1.3),('5819','2013-10-30','08:25:00',1.37),('5819','2013-10-30','08:30:00',1.43),('5819','2013-10-30','08:35:00',1.53),('5819','2013-10-30','08:40:00',1.62),('5819','2013-10-30','08:45:00',1.71),('5819','2013-10-30','08:50:00',1.73),('5819','2013-10-30','08:55:00',1.71),('5819','2013-10-30','09:00:00',1.81),('5819','2013-10-30','09:05:00',1.92),('5819','2013-10-30','09:10:00',2.04),('5819','2013-10-30','09:15:00',2.09),('5819','2013-10-30','09:20:00',2.11),('5819','2013-10-30','09:25:00',2.18),('5819','2013-10-30','09:30:00',2.24),('5819','2013-10-30','09:35:00',2.3),('5819','2013-10-30','09:40:00',2.29),('5819','2013-10-30','09:45:00',2.35),('5819','2013-10-30','09:50:00',2.3),('5819','2013-10-30','09:55:00',2.35),('5819','2013-10-30','10:00:00',2.19),('5819','2013-10-30','10:05:00',2.27),('5819','2013-10-30','10:10:00',2.31),('5819','2013-10-30','10:15:00',2.49),('5819','2013-10-30','10:20:00',2.49),('5819','2013-10-30','10:25:00',2.36),('5819','2013-10-30','10:30:00',2.24),('5819','2013-10-30','10:35:00',2.33),('5819','2013-10-30','10:40:00',2.4),('5819','2013-10-30','10:45:00',2.33),('5819','2013-10-30','10:50:00',2.31),('5819','2013-10-30','10:55:00',1.14),('5819','2013-10-30','11:00:00',1.81),('5819','2013-10-30','11:05:00',2.19),('5819','2013-10-30','11:10:00',2.72),('5819','2013-10-30','11:15:00',2.72),('5819','2013-10-30','11:20:00',2.39),('5819','2013-10-30','11:25:00',1.41),('5819','2013-10-30','11:30:00',1.03),('5819','2013-10-30','11:35:00',1.09),('5819','2013-10-30','11:40:00',1.05),('5819','2013-10-30','11:50:00',2.14),('5819','2013-10-30','11:55:00',1.38),('5819','2013-10-30','12:10:00',1.04),('5819','2013-10-30','12:20:00',1),('5819','2013-10-30','12:25:00',1.18),('5819','2013-10-30','12:30:00',2.19),('5819','2013-10-30','12:35:00',1.08),('5819','2013-10-30','12:40:00',1.07),('5819','2013-10-30','12:45:00',1.63),('5819','2013-10-30','12:50:00',1.32),('5819','2013-10-30','12:55:00',2.08),('5819','2013-10-30','13:00:00',2.02),('5819','2013-10-30','13:05:00',1.28),('5819','2013-10-30','13:15:00',1.01),('5819','2013-10-30','13:20:00',1),('5819','2013-10-30','13:30:00',1.43),('5819','2013-10-30','13:45:00',1.6),('5819','2013-10-30','13:50:00',1.55),('5819','2013-10-30','14:00:00',1.03),('5819','2013-10-30','14:05:00',1.79),('5819','2013-10-30','14:10:00',2),('5819','2013-10-30','14:15:00',1.65),('5819','2013-10-30','14:35:00',1.12),('5819','2013-10-30','14:40:00',1.43),('5819','2013-10-30','14:45:00',1.35),('5819','2013-10-30','14:50:00',1.23),('5819','2013-10-29','08:35:00',1.08),('5819','2013-10-29','08:40:00',1.37),('5819','2013-10-29','08:45:00',1.64),('5819','2013-10-29','08:50:00',1.94),('5819','2013-10-29','08:55:00',1.94),('5819','2013-10-29','09:00:00',2.01),('5819','2013-10-29','09:05:00',2.08),('5819','2013-10-29','09:10:00',2.12),('5819','2013-10-29','09:15:00',2.15),('5819','2013-10-29','09:20:00',2.24),('5819','2013-10-29','09:25:00',2.26),('5819','2013-10-29','09:30:00',2.32),('5819','2013-10-29','09:35:00',2.35),('5819','2013-10-29','09:40:00',2.38),('5819','2013-10-29','09:45:00',2.36),('5819','2013-10-29','09:50:00',1.99),('5819','2013-10-29','09:55:00',2.38),('5819','2013-10-29','10:00:00',2.57),('5819','2013-10-29','10:05:00',2.7),('5819','2013-10-29','10:10:00',2.66),('5819','2013-10-29','10:15:00',2.33),('5819','2013-10-29','10:20:00',2.27),('5819','2013-10-29','10:25:00',2.77),('5819','2013-10-29','10:30:00',2.98),('5819','2013-10-29','10:35:00',2.85),('5819','2013-10-29','10:40:00',2.87),('5819','2013-10-29','10:45:00',2.88),('5819','2013-10-29','10:50:00',2.98),('5819','2013-10-29','10:55:00',2.72),('5819','2013-10-29','11:00:00',1.65),('5819','2013-10-29','11:05:00',1.75),('5819','2013-10-29','11:10:00',1.21),('5819','2013-10-29','11:15:00',2.19),('5819','2013-10-29','11:20:00',2.84),('5819','2013-10-29','11:25:00',2.74),('5819','2013-10-29','11:30:00',2.91),('5819','2013-10-29','11:35:00',2.9),('5819','2013-10-29','11:40:00',2.85),('5819','2013-10-29','11:45:00',2.69),('5819','2013-10-29','11:50:00',2.67),('5819','2013-10-29','11:55:00',2.63),('5819','2013-10-29','12:00:00',2.54),('5819','2013-10-29','12:05:00',2.67),('5819','2013-10-29','12:10:00',2.61),('5819','2013-10-29','12:15:00',2.6),('5819','2013-10-29','12:20:00',2.59),('5819','2013-10-29','12:25:00',2.59),('5819','2013-10-29','12:30:00',2.54),('5819','2013-10-29','12:35:00',2.45),('5819','2013-10-29','12:40:00',2.49),('5819','2013-10-29','12:45:00',2.52),('5819','2013-10-29','12:50:00',2.49),('5819','2013-10-29','12:55:00',2.43),('5819','2013-10-29','13:00:00',2.32),('5819','2013-10-29','13:05:00',2.25),('5819','2013-10-29','13:10:00',2.28),('5819','2013-10-29','13:15:00',2.25),('5819','2013-10-29','13:20:00',2.19),('5819','2013-10-29','13:25:00',2.12),('5819','2013-10-29','13:30:00',2.1),('5819','2013-10-29','13:35:00',2.05),('5819','2013-10-29','13:40:00',2.03),('5819','2013-10-29','13:45:00',2.01),('5819','2013-10-29','13:50:00',1.95),('5819','2013-10-29','13:55:00',1.86),('5819','2013-10-29','14:00:00',1.8),('5819','2013-10-29','14:05:00',1.74),('5819','2013-10-29','14:10:00',1.76),('5819','2013-10-29','14:15:00',1.7),('5819','2013-10-29','14:20:00',1.67),('5819','2013-10-29','14:25:00',1.57),('5819','2013-10-29','14:30:00',1.48),('5819','2013-10-29','14:35:00',1.41),('5819','2013-10-29','14:40:00',1.35),('5819','2013-10-29','14:45:00',1.3),('5819','2013-10-29','14:50:00',1.25),('5819','2013-10-29','14:55:00',1.17),('5819','2013-10-29','15:00:00',1.1),('5819','2013-10-29','15:05:00',1.02),('5819','2014-04-17','07:55:00',1.06),('5819','2014-04-17','08:00:00',1.42),('5819','2014-04-17','08:05:00',1.55),('5819','2014-04-17','08:10:00',1.65),('5819','2014-04-17','08:15:00',1.73),('5819','2014-04-17','08:20:00',1.74),('5819','2014-04-17','08:25:00',1.9),('5819','2014-04-17','08:30:00',2),('5819','2014-04-17','08:35:00',2.08),('5819','2014-04-17','08:40:00',2.16),('5819','2014-04-17','08:45:00',2.24),('5819','2014-04-17','08:50:00',2.35),('5819','2014-04-17','08:55:00',2.08),('5819','2014-04-17','09:00:00',2.06),('5819','2014-04-17','09:05:00',2.35),('5819','2014-04-17','09:10:00',2.59),('5819','2014-04-17','09:15:00',2.58),('5819','2014-04-17','09:20:00',2.77),('5819','2014-04-17','09:25:00',2.87),('5819','2014-04-17','09:30:00',2.94),('5819','2014-04-17','09:35:00',3.01),('5819','2014-04-17','09:40:00',3.09),('5819','2014-04-17','09:45:00',3.17),('5819','2014-04-17','09:50:00',3.23),('5819','2014-04-17','09:55:00',3.32),('5819','2014-04-17','10:00:00',3.44),('5819','2014-04-17','10:05:00',3.67),('5819','2014-04-17','10:10:00',3.41),('5819','2014-04-17','10:15:00',2.95),('5819','2014-04-17','10:20:00',3.48),('5819','2014-04-17','10:25:00',3.93),('5819','2014-04-17','10:30:00',4.08),('5819','2014-04-17','10:35:00',4.2),('5819','2014-04-17','10:40:00',3.96),('5819','2014-04-17','10:45:00',3.19),('5819','2014-04-17','10:50:00',2.43),('5819','2014-04-17','10:55:00',2.46),('5819','2014-04-17','11:00:00',2.51),('5819','2014-04-17','11:05:00',3.68),('5819','2014-04-17','11:10:00',3.13),('5819','2014-04-17','11:15:00',2.99),('5819','2014-04-17','11:20:00',3.14),('5819','2014-04-17','11:25:00',3.44),('5819','2014-04-17','11:30:00',2.35),('5819','2014-04-17','11:35:00',2.79),('5819','2014-04-17','11:40:00',2.73),('5819','2014-04-17','11:45:00',3.08),('5819','2014-04-17','11:50:00',2.35),('5819','2014-04-17','11:55:00',1.9),('5819','2014-04-17','12:00:00',2.07),('5819','2014-04-17','12:05:00',2.7),('5819','2014-04-17','12:10:00',2.72),('5819','2014-04-17','12:15:00',2.34),('5819','2014-04-17','12:20:00',2.27),('5819','2014-04-17','12:25:00',2.52),('5819','2014-04-17','12:30:00',2.91),('5819','2014-04-17','12:35:00',3.72),('5819','2014-04-17','12:40:00',4.12),('5819','2014-04-17','12:45:00',3.96),('5819','2014-04-17','12:50:00',4.05),('5819','2014-04-17','12:55:00',4.12),('5819','2014-04-17','13:00:00',3.6),('5819','2014-04-17','13:05:00',2.32),('5819','2014-04-17','13:10:00',1.53),('5819','2014-04-17','13:15:00',1.56),('5819','2014-04-17','13:20:00',3.9),('5819','2014-04-17','13:25:00',4.57),('5819','2014-04-17','13:30:00',3.2),('5819','2014-04-17','13:55:00',1.1),('5819','2014-04-17','14:00:00',1.03),('5819','2014-04-17','14:05:00',1.04),('5819','2014-04-17','14:10:00',2.32),('5819','2014-04-17','14:15:00',1.09),('5819','2014-04-17','14:20:00',1.28),('5819','2014-04-17','14:25:00',1.36),('5819','2014-04-17','14:30:00',1.39),('5819','2014-04-17','14:35:00',1.67),('5819','2014-04-17','14:40:00',3.11),('5819','2014-04-17','14:45:00',1.13),('5819','2014-04-17','15:25:00',1.06),('5819','2014-04-17','15:30:00',1.57),('5819','2014-04-17','15:35:00',1.86),('5819','2014-04-17','15:40:00',1.4),('5819','2014-04-17','15:45:00',1.06),('5819','2014-04-17','15:50:00',1.04),('5819','2014-04-17','15:55:00',1.21),('5819','2014-04-17','16:00:00',1.06),('5819','2014-04-17','16:25:00',1.06),('5819','2014-04-17','16:30:00',1.1),('5819','2014-04-17','16:35:00',1.01),('5819','2014-04-17','16:40:00',1.12),('5819','2014-04-17','16:45:00',1.29),('5819','2014-04-17','16:50:00',1.29),('5819','2014-04-17','16:55:00',1.03),('5819','2013-10-28','08:50:00',1.27),('5819','2013-10-28','08:55:00',1.87),('5819','2013-10-28','09:00:00',2.08),('5819','2013-10-28','09:05:00',2.28),('5819','2013-10-28','09:10:00',2.38),('5819','2013-10-28','09:15:00',1.89),('5819','2013-10-28','09:20:00',1.46),('5819','2013-10-28','09:25:00',2.39),('5819','2013-10-28','09:30:00',2.58),('5819','2013-10-28','09:35:00',2.08),('5819','2013-10-28','09:40:00',1.45),('5819','2013-10-28','09:45:00',1.4),('5819','2013-10-28','09:50:00',2.17),('5819','2013-10-28','09:55:00',1.7),('5819','2013-10-28','10:50:00',2.89),('5819','2013-10-28','10:55:00',2.86),('5819','2013-10-28','11:00:00',2.86),('5819','2013-10-28','11:05:00',2.84),('5819','2013-10-28','11:10:00',2.85),('5819','2013-10-28','11:15:00',2.88),('5819','2013-10-28','11:20:00',2.87),('5819','2013-10-28','11:25:00',2.88),('5819','2013-10-28','11:30:00',2.84),('5819','2013-10-28','11:35:00',2.85),('5819','2013-10-28','11:40:00',2.76),('5819','2013-10-28','11:45:00',2.78),('5819','2013-10-28','11:50:00',2.8),('5819','2013-10-28','11:55:00',2.79),('5819','2013-10-28','12:00:00',2.51),('5819','2013-10-28','12:05:00',2.73),('5819','2013-10-28','12:10:00',2.12),('5819','2013-10-28','12:15:00',2.88),('5819','2013-10-28','12:20:00',2.95),('5819','2013-10-28','12:25:00',2.94),('5819','2013-10-28','12:30:00',2.53),('5819','2013-10-28','12:35:00',3),('5819','2013-10-28','12:40:00',2.95),('5819','2013-10-28','12:45:00',2.85),('5819','2013-10-28','12:50:00',2.87),('5819','2013-10-28','12:55:00',2.75),('5819','2013-10-28','13:00:00',2.58),('5819','2013-10-28','13:05:00',2.51),('5819','2013-10-28','13:10:00',2.52),('5819','2013-10-28','13:15:00',2.44),('5819','2013-10-28','13:20:00',2.38),('5819','2013-10-28','13:25:00',2.37),('5819','2013-10-28','13:30:00',2.3),('5819','2013-10-28','13:35:00',2.26),('5819','2013-10-28','13:40:00',2.16),('5819','2013-10-28','13:45:00',1.73),('5819','2013-10-28','13:50:00',2.12),('5819','2013-10-28','13:55:00',2.08),('5819','2013-10-28','14:00:00',2.08),('5819','2013-10-28','14:05:00',1.54),('5819','2013-10-28','14:10:00',2.01),('5819','2013-10-28','14:15:00',1.97),('5819','2013-10-28','14:20:00',1.9),('5819','2013-10-28','14:25:00',1.96),('5819','2013-10-28','14:30:00',1.76),('5819','2013-10-28','14:35:00',1.62),('5819','2013-10-28','14:40:00',1.34),('5819','2013-10-28','14:45:00',1.46),('5819','2013-10-28','14:50:00',1.43),('5819','2013-10-28','14:55:00',1.31),('5819','2013-10-28','15:00:00',1.24),('5819','2013-10-28','15:05:00',1.21),('5819','2013-10-28','15:10:00',1.13),('5819','2013-10-28','15:15:00',1.03),('5819','2013-10-27','10:05:00',1.03),('5819','2013-10-27','10:10:00',1.06),('5819','2013-10-27','10:15:00',1.1),('5819','2013-10-27','10:20:00',1.16),('5819','2013-10-27','10:25:00',1.18),('5819','2013-10-27','10:30:00',1.17),('5819','2013-10-27','10:35:00',1.17),('5819','2013-10-27','10:40:00',1.16),('5819','2013-10-27','10:45:00',1.23),('5819','2013-10-27','10:50:00',1.35),('5819','2013-10-27','10:55:00',1.22),('5819','2013-10-27','11:00:00',1.17),('5819','2013-10-27','11:05:00',1.05),('5819','2013-10-27','11:35:00',1.14),('5819','2013-10-27','11:40:00',2.4),('5819','2013-10-27','11:45:00',2.65),('5819','2013-10-27','11:50:00',2.12),('5819','2013-10-27','11:55:00',1.19),('5819','2013-10-27','12:00:00',1.12),('5819','2013-10-27','12:05:00',1.12),('5819','2013-10-27','12:10:00',1.19),('5819','2013-10-27','12:15:00',1.23),('5819','2013-10-27','12:20:00',2.19),('5819','2013-10-27','12:25:00',2.72),('5819','2013-10-27','12:30:00',2.47),('5819','2013-10-27','12:35:00',2.54),('5819','2013-10-27','12:40:00',2.13),('5819','2013-10-27','12:45:00',1.42),('5819','2013-10-27','12:50:00',1.54),('5819','2013-10-27','12:55:00',1.29),('5819','2013-10-27','13:00:00',2.06),('5819','2013-10-27','13:10:00',1.93),('5819','2013-10-27','13:15:00',1.29),('5819','2013-10-27','13:25:00',1.42),('5819','2013-10-27','13:30:00',2.11),('5819','2013-10-27','13:35:00',1.68),('5819','2013-10-27','13:40:00',1.98),('5819','2013-10-27','14:05:00',1.1),('5819','2013-10-27','14:10:00',1.01),('5819','2013-10-27','14:20:00',1.01),('5819','2013-10-27','14:30:00',1.06),('5819','2013-10-27','14:35:00',1.56),('5819','2013-10-27','14:40:00',1.6),('5819','2013-10-27','14:45:00',1.37),('5819','2013-10-27','14:50:00',1.29),('5819','2013-10-27','14:55:00',1.39),('5819','2013-10-27','15:00:00',1.31),('5819','2013-10-27','15:15:00',1.05),('5819','2013-10-26','08:45:00',1.01),('5819','2013-10-26','08:50:00',1.09),('5819','2013-10-26','08:55:00',1.15),('5819','2013-10-26','09:00:00',1.22),('5819','2013-10-26','09:05:00',1.3),('5819','2013-10-26','09:10:00',1.38),('5819','2013-10-26','09:15:00',1.47),('5819','2013-10-26','09:20:00',1.54),('5819','2013-10-26','09:25:00',1.61),('5819','2013-10-26','09:30:00',1.67),('5819','2013-10-26','09:35:00',1.74),('5819','2013-10-26','09:40:00',1.81),('5819','2013-10-26','09:45:00',1.88),('5819','2013-10-26','09:50:00',1.95),('5819','2013-10-26','09:55:00',2.01),('5819','2013-10-26','10:00:00',2.06),('5819','2013-10-26','10:05:00',2.13),('5819','2013-10-26','10:10:00',2.18),('5819','2013-10-26','10:15:00',2.23),('5819','2013-10-26','10:20:00',2.27),('5819','2013-10-26','10:25:00',2.31),('5819','2013-10-26','10:30:00',2.35),('5819','2013-10-26','10:35:00',2.38),('5819','2013-10-26','10:40:00',2.42),('5819','2013-10-26','10:45:00',2.45),('5819','2013-10-26','10:50:00',2.5),('5819','2013-10-26','10:55:00',2.54),('5819','2013-10-26','11:00:00',2.58),('5819','2013-10-26','11:05:00',2.62),('5819','2013-10-26','11:10:00',2.63),('5819','2013-10-26','11:15:00',2.65),('5819','2013-10-26','11:20:00',2.67),('5819','2013-10-26','11:25:00',2.69),('5819','2013-10-26','11:30:00',2.7),('5819','2013-10-26','11:35:00',2.73),('5819','2013-10-26','11:40:00',2.74),('5819','2013-10-26','11:45:00',2.75),('5819','2013-10-26','11:50:00',2.77),('5819','2013-10-26','11:55:00',2.74),('5819','2013-10-26','12:00:00',2.78),('5819','2013-10-26','12:05:00',2.77),('5819','2013-10-26','12:10:00',2.77),('5819','2013-10-26','12:15:00',2.74),('5819','2013-10-26','12:20:00',2.79),('5819','2013-10-26','12:25:00',2.73),('5819','2013-10-26','12:30:00',2.77),('5819','2013-10-26','12:35:00',2.8),('5819','2013-10-26','12:40:00',2.75),('5819','2013-10-26','12:45:00',2.71),('5819','2013-10-26','12:50:00',2.73),('5819','2013-10-26','12:55:00',2.69),('5819','2013-10-26','13:00:00',2.72),('5819','2013-10-26','13:05:00',2.69),('5819','2013-10-26','13:10:00',2.65),('5819','2013-10-26','13:15:00',2.46),('5819','2013-10-26','13:20:00',2.37),('5819','2013-10-26','13:25:00',2.5),('5819','2013-10-26','13:30:00',2.42),('5819','2013-10-26','13:35:00',2.49),('5819','2013-10-26','13:40:00',2.62),('5819','2013-10-26','13:45:00',2.46),('5819','2013-10-26','13:50:00',2.21),('5819','2013-10-26','13:55:00',2.39),('5819','2013-10-26','14:00:00',2.33),('5819','2013-10-26','14:05:00',2.18),('5819','2013-10-26','14:10:00',2.13),('5819','2013-10-26','14:15:00',2.26),('5819','2013-10-26','14:20:00',2.09),('5819','2013-10-26','14:25:00',1.53),('5819','2013-10-26','14:35:00',1.32),('5819','2013-10-26','14:40:00',1.99),('5819','2013-10-26','14:45:00',1.98),('5819','2013-10-26','14:50:00',1.94),('5819','2013-10-26','14:55:00',1.84),('5819','2013-10-26','15:00:00',1.78),('5819','2013-10-26','15:05:00',1.63),('5819','2013-10-26','15:10:00',1.68),('5819','2013-10-26','15:15:00',1.5),('5819','2013-10-26','15:20:00',1.51),('5819','2013-10-26','15:25:00',1.5),('5819','2013-10-26','15:30:00',1.47),('5819','2013-10-26','15:35:00',1.44),('5819','2013-10-26','15:40:00',1.44),('5819','2013-10-26','15:45:00',1.26),('5819','2013-10-26','15:50:00',1.3),('5819','2013-10-26','15:55:00',1.18),('5819','2013-10-26','16:00:00',1.05),('5819','2013-10-26','16:10:00',1.02),('5819','2013-10-25','08:45:00',1.02),('5819','2013-10-25','08:50:00',1.09),('5819','2013-10-25','08:55:00',1.17),('5819','2013-10-25','09:00:00',1.26),('5819','2013-10-25','09:05:00',1.34),('5819','2013-10-25','09:10:00',1.42),('5819','2013-10-25','09:15:00',1.5),('5819','2013-10-25','09:20:00',1.58),('5819','2013-10-25','09:25:00',1.65),('5819','2013-10-25','09:30:00',1.72),('5819','2013-10-25','09:35:00',1.78),('5819','2013-10-25','09:40:00',1.85),('5819','2013-10-25','09:45:00',1.9),('5819','2013-10-25','09:50:00',1.97),('5819','2013-10-25','09:55:00',2.03),('5819','2013-10-25','10:00:00',2.09),('5819','2013-10-25','10:05:00',2.15),('5819','2013-10-25','10:10:00',2.2),('5819','2013-10-25','10:15:00',2.24),('5819','2013-10-25','10:20:00',2.29),('5819','2013-10-25','10:25:00',2.35),('5819','2013-10-25','10:30:00',2.4),('5819','2013-10-25','10:35:00',2.45),('5819','2013-10-25','10:40:00',2.48),('5819','2013-10-25','10:45:00',2.51),('5819','2013-10-25','10:50:00',2.56),('5819','2013-10-25','10:55:00',2.57),('5819','2013-10-25','11:00:00',2.61),('5819','2013-10-25','11:05:00',2.61),('5819','2013-10-25','11:10:00',2.66),('5819','2013-10-25','11:15:00',2.68),('5819','2013-10-25','11:20:00',2.69),('5819','2013-10-25','11:25:00',2.71),('5819','2013-10-25','11:30:00',2.72),('5819','2013-10-25','11:35:00',2.72),('5819','2013-10-25','11:40:00',2.73),('5819','2013-10-25','11:45:00',2.77),('5819','2013-10-25','11:50:00',2.79),('5819','2013-10-25','11:55:00',2.83),('5819','2013-10-25','12:00:00',2.84),('5819','2013-10-25','12:05:00',2.85),('5819','2013-10-25','12:10:00',2.85),('5819','2013-10-25','12:15:00',2.87),('5819','2013-10-25','12:20:00',2.87),('5819','2013-10-25','12:25:00',2.85),('5819','2013-10-25','12:30:00',2.86),('5819','2013-10-25','12:35:00',2.86),('5819','2013-10-25','12:40:00',2.84),('5819','2013-10-25','12:45:00',2.82),('5819','2013-10-25','12:50:00',2.79),('5819','2013-10-25','12:55:00',2.78),('5819','2013-10-25','13:00:00',2.8),('5819','2013-10-25','13:05:00',2.78),('5819','2013-10-25','13:10:00',2.76),('5819','2013-10-25','13:15:00',2.71),('5819','2013-10-25','13:20:00',2.69),('5819','2013-10-25','13:25:00',2.61),('5819','2013-10-25','13:30:00',2.59),('5819','2013-10-25','13:35:00',2.6),('5819','2013-10-25','13:40:00',2.6),('5819','2013-10-25','13:45:00',2.54),('5819','2013-10-25','13:50:00',2.53),('5819','2013-10-25','13:55:00',2.52),('5819','2013-10-25','14:00:00',2.47),('5819','2013-10-25','14:05:00',2.44),('5819','2013-10-25','14:10:00',2.42),('5819','2013-10-25','14:15:00',2.37),('5819','2013-10-25','14:20:00',2.33),('5819','2013-10-25','14:25:00',2.28),('5819','2013-10-25','14:30:00',2.23),('5819','2013-10-25','14:35:00',2.18),('5819','2013-10-25','14:40:00',2.16),('5819','2013-10-25','14:45:00',2.12),('5819','2013-10-25','14:50:00',2.08),('5819','2013-10-25','14:55:00',2.02),('5819','2013-10-25','15:00:00',1.96),('5819','2013-10-25','15:05:00',1.9),('5819','2013-10-25','15:10:00',1.83),('5819','2013-10-25','15:15:00',1.77),('5819','2013-10-25','15:20:00',1.7),('5819','2013-10-25','15:25:00',1.67),('5819','2013-10-25','15:30:00',1.57),('5819','2013-10-25','15:35:00',1.51),('5819','2013-10-25','15:40:00',1.42),('5819','2013-10-25','15:45:00',1.38),('5819','2013-10-25','15:50:00',1.3),('5819','2013-10-25','15:55:00',1.27),('5819','2013-10-25','16:00:00',1.21),('5819','2013-10-25','16:05:00',1.15),('5819','2013-10-25','16:10:00',1.08),('5819','2013-10-25','16:15:00',1.03),('5819','2013-10-24','09:15:00',1.52),('5819','2013-10-24','09:20:00',1.57),('5819','2013-10-24','09:35:00',1.02),('5819','2013-10-24','09:40:00',1.08),('5819','2013-10-24','09:45:00',1.1),('5819','2013-10-24','09:50:00',1.12),('5819','2013-10-24','09:55:00',1.07),('5819','2013-10-24','10:00:00',1.05),('5819','2013-10-24','10:05:00',1.01),('5819','2013-10-24','10:10:00',1.07),('5819','2013-10-24','10:35:00',1.11),('5819','2013-10-24','10:40:00',1.42),('5819','2013-10-24','10:45:00',2.48),('5819','2013-10-24','10:50:00',2.08),('5819','2013-10-24','10:55:00',2.5),('5819','2013-10-24','11:00:00',2.91),('5819','2013-10-24','11:05:00',3.08),('5819','2013-10-24','11:10:00',3.35),('5819','2013-10-24','11:15:00',1.63),('5819','2013-10-24','11:20:00',1.4),('5819','2013-10-24','11:25:00',2.4),('5819','2013-10-24','11:30:00',1.91),('5819','2013-10-24','11:35:00',1.14),('5819','2013-10-24','11:40:00',1.14),('5819','2013-10-24','11:45:00',1.17),('5819','2013-10-24','11:50:00',1.65),('5819','2013-10-24','11:55:00',3.04),('5819','2013-10-24','12:00:00',1.77),('5819','2013-10-24','12:05:00',1.35),('5819','2013-10-24','12:10:00',1.25),('5819','2013-10-24','12:15:00',1.23),('5819','2013-10-24','12:20:00',1.26),('5819','2013-10-24','12:25:00',1.38),('5819','2013-10-24','12:30:00',1.44),('5819','2013-10-24','12:35:00',1.56),('5819','2013-10-24','12:40:00',1.79),('5819','2013-10-24','12:45:00',1.93),('5819','2013-10-24','12:50:00',2.06),('5819','2013-10-24','12:55:00',2.08),('5819','2013-10-24','13:00:00',2.52),('5819','2013-10-24','13:05:00',3.34),('5819','2013-10-24','13:10:00',2.72),('5819','2013-10-24','13:15:00',2.16),('5819','2013-10-24','13:20:00',2.21),('5819','2013-10-24','13:25:00',2.31),('5819','2013-10-24','13:30:00',1.31),('5819','2013-10-24','13:35:00',1.21),('5819','2013-10-24','13:40:00',1.2),('5819','2013-10-24','13:45:00',1.26),('5819','2013-10-24','13:50:00',1.45),('5819','2013-10-24','13:55:00',1.73),('5819','2013-10-24','14:00:00',2.02),('5819','2013-10-24','14:05:00',1.83),('5819','2013-10-24','14:10:00',1.29),('5819','2013-10-24','14:15:00',1.27),('5819','2013-10-24','14:20:00',1.29),('5819','2013-10-24','14:25:00',1.36),('5819','2013-10-24','14:30:00',1.36),('5819','2013-10-24','14:35:00',1.63),('5819','2013-10-24','14:40:00',1.65),('5819','2013-10-24','14:45:00',1.66),('5819','2013-10-24','14:50:00',2.08),('5819','2013-10-24','15:05:00',1.01),('5819','2013-10-24','15:10:00',1.89),('5819','2013-10-24','15:15:00',1.47),('5819','2013-10-24','15:25:00',1.17),('5819','2013-10-24','15:35:00',1.86),('5819','2013-10-24','15:40:00',1.93),('5819','2013-10-24','15:45:00',1.49),('5819','2013-10-24','15:50:00',1.13),('5819','2013-10-23','10:45:00',1.27),('5819','2013-10-23','10:50:00',1.61),('5819','2013-10-23','10:55:00',1.35),('5819','2013-10-23','11:00:00',1.42),('5819','2013-10-23','11:05:00',1.27),('5819','2013-10-23','11:10:00',1.68),('5819','2013-10-23','11:15:00',2.84),('5819','2013-10-23','11:20:00',2.5),('5819','2013-10-23','11:25:00',2.76),('5819','2013-10-23','11:30:00',2.23),('5819','2013-10-23','11:35:00',2.66),('5819','2013-10-23','11:40:00',2.84),('5819','2013-10-23','11:45:00',2.77),('5819','2013-10-23','11:50:00',2.68),('5819','2013-10-23','11:55:00',2.69),('5819','2013-10-23','12:00:00',2.78),('5819','2013-10-23','12:05:00',2.75),('5819','2013-10-23','12:10:00',2.61),('5819','2013-10-23','12:15:00',2.68),('5819','2013-10-23','12:20:00',2.68),('5819','2013-10-23','12:25:00',2.73),('5819','2013-10-23','12:30:00',2.7),('5819','2013-10-23','12:35:00',2.66),('5819','2013-10-23','12:40:00',2.68),('5819','2013-10-23','12:45:00',2.44),('5819','2013-10-23','12:50:00',2.27),('5819','2013-10-23','12:55:00',1.95),('5819','2013-10-23','13:00:00',2.68),('5819','2013-10-23','13:05:00',2.62),('5819','2013-10-23','13:10:00',2.59),('5819','2013-10-23','13:15:00',2.62),('5819','2013-10-23','13:20:00',2.6),('5819','2013-10-23','13:25:00',2.61),('5819','2013-10-23','13:30:00',2.6),('5819','2013-10-23','13:35:00',2.57),('5819','2013-10-23','13:40:00',2.57),('5819','2013-10-23','13:45:00',2.56),('5819','2013-10-23','13:50:00',2.37),('5819','2013-10-23','13:55:00',1.75),('5819','2013-10-23','14:00:00',2.16),('5819','2013-10-23','14:05:00',2.23),('5819','2013-10-23','14:10:00',2.21),('5819','2013-10-23','14:15:00',2.36),('5819','2013-10-23','14:20:00',2.25),('5819','2013-10-23','14:25:00',2.14),('5819','2013-10-23','14:30:00',2.17),('5819','2013-10-23','14:35:00',2.1),('5819','2013-10-23','14:40:00',1.91),('5819','2013-10-23','14:45:00',1.91),('5819','2013-10-23','14:50:00',1.81),('5819','2013-10-23','14:55:00',1.96),('5819','2013-10-23','15:00:00',1.81),('5819','2013-10-23','15:05:00',1.89),('5819','2013-10-23','15:10:00',1.79),('5819','2013-10-23','15:15:00',1.8),('5819','2013-10-23','15:20:00',1.76),('5819','2013-10-23','15:25:00',1.75),('5819','2013-10-23','15:30:00',1.67),('5819','2013-10-23','15:35:00',1.55),('5819','2013-10-23','15:40:00',1.6),('5819','2013-10-23','15:45:00',1.52),('5819','2013-10-23','15:50:00',1.34),('5819','2013-10-22','08:50:00',1.08),('5819','2013-10-22','08:55:00',1.16),('5819','2013-10-22','09:00:00',1.23),('5819','2013-10-22','09:05:00',1.31),('5819','2013-10-22','09:10:00',1.39),('5819','2013-10-22','09:15:00',1.47),('5819','2013-10-22','09:20:00',1.55),('5819','2013-10-22','09:25:00',1.63),('5819','2013-10-22','09:30:00',1.69),('5819','2013-10-22','09:35:00',1.77),('5819','2013-10-22','09:40:00',1.83),('5819','2013-10-22','09:45:00',1.89),('5819','2013-10-22','09:50:00',1.95),('5819','2013-10-22','09:55:00',2.01),('5819','2013-10-22','10:00:00',2.05),('5819','2013-10-22','10:05:00',2.1),('5819','2013-10-22','10:10:00',2.16),('5819','2013-10-22','10:15:00',2.22),('5819','2013-10-22','10:20:00',2.27),('5819','2013-10-22','10:25:00',2.33),('5819','2013-10-22','10:30:00',2.36),('5819','2013-10-22','10:35:00',2.4),('5819','2013-10-22','10:40:00',2.43),('5819','2013-10-22','10:45:00',2.49),('5819','2013-10-22','10:50:00',2.53),('5819','2013-10-22','10:55:00',2.53),('5819','2013-10-22','11:00:00',2.55),('5819','2013-10-22','11:05:00',2.61),('5819','2013-10-22','11:10:00',2.61),('5819','2013-10-22','11:15:00',2.63),('5819','2013-10-22','11:20:00',2.7),('5819','2013-10-22','11:25:00',2.68),('5819','2013-10-22','11:30:00',2.67),('5819','2013-10-22','11:35:00',2.69),('5819','2013-10-22','11:40:00',2.69),('5819','2013-10-22','11:45:00',2.66),('5819','2013-10-22','11:50:00',2.67),('5819','2013-10-22','11:55:00',2.71),('5819','2013-10-22','12:00:00',2.73),('5819','2013-10-22','12:05:00',2.76),('5819','2013-10-22','12:10:00',2.73),('5819','2013-10-22','12:15:00',2.71),('5819','2013-10-22','12:20:00',2.75),('5819','2013-10-22','12:25:00',2.76),('5819','2013-10-22','12:30:00',2.71),('5819','2013-10-22','12:35:00',2.72),('5819','2013-10-22','12:40:00',2.74),('5819','2013-10-22','12:45:00',2.73),('5819','2013-10-22','12:50:00',2.74),('5819','2013-10-22','12:55:00',2.64),('5819','2013-10-22','13:00:00',2.49),('5819','2013-10-22','13:05:00',2.63),('5819','2013-10-22','13:10:00',2.58),('5819','2013-10-22','13:15:00',2.56),('5819','2013-10-22','13:20:00',2.58),('5819','2013-10-22','13:25:00',2.59),('5819','2013-10-22','13:30:00',2.58),('5819','2013-10-22','13:35:00',2.44),('5819','2013-10-22','13:40:00',2.53),('5819','2013-10-22','13:45:00',2.5),('5819','2013-10-22','13:50:00',2.4),('5819','2013-10-22','13:55:00',2.35),('5819','2013-10-22','14:00:00',2.27),('5819','2013-10-22','14:05:00',2.38),('5819','2013-10-22','14:10:00',2.33),('5819','2013-10-22','14:15:00',2.21),('5819','2013-10-22','14:20:00',1.54),('5819','2013-10-22','14:25:00',2.05),('5819','2013-10-22','14:30:00',1.1),('5819','2013-10-22','14:45:00',1.37),('5819','2013-10-22','14:50:00',1.82),('5819','2013-10-22','14:55:00',1.93),('5819','2013-10-22','15:00:00',1.82),('5819','2013-10-22','15:05:00',1.79),('5819','2013-10-22','15:10:00',1.8),('5819','2013-10-22','15:15:00',1.72),('5819','2013-10-22','15:20:00',1.66),('5819','2013-10-22','15:25:00',1.62),('5819','2013-10-22','15:30:00',1.55),('5819','2013-10-22','15:35:00',1.51),('5819','2013-10-22','15:40:00',1.47),('5819','2013-10-22','15:45:00',1.47),('5819','2013-10-22','15:50:00',1.39),('5819','2013-10-22','15:55:00',1.29),('5819','2013-10-22','16:00:00',1.19),('5819','2013-10-22','16:05:00',1.12),('5819','2013-10-22','16:10:00',1.08),('5819','2013-10-22','16:15:00',1.04),('5819','2013-10-21','08:45:00',1.04),('5819','2013-10-21','08:55:00',1.06),('5819','2013-10-21','09:10:00',1.25),('5819','2013-10-21','09:15:00',1.47),('5819','2013-10-21','09:20:00',1.68),('5819','2013-10-21','09:25:00',1.76),('5819','2013-10-21','09:30:00',1.67),('5819','2013-10-21','09:35:00',1.53),('5819','2013-10-21','09:40:00',1.86),('5819','2013-10-21','09:45:00',1.64),('5819','2013-10-21','09:50:00',1.71),('5819','2013-10-21','09:55:00',1.89),('5819','2013-10-21','10:00:00',1.9),('5819','2013-10-21','10:05:00',2.07),('5819','2013-10-21','10:10:00',2.26),('5819','2013-10-21','10:15:00',2.32),('5819','2013-10-21','10:20:00',2.3),('5819','2013-10-21','10:25:00',2.39),('5819','2013-10-21','10:30:00',2.37),('5819','2013-10-21','10:35:00',2.35),('5819','2013-10-21','10:40:00',2.32),('5819','2013-10-21','10:45:00',2.4),('5819','2013-10-21','10:50:00',2.49),('5819','2013-10-21','10:55:00',2.5),('5819','2013-10-21','11:00:00',2.65),('5819','2013-10-21','11:05:00',2.49),('5819','2013-10-21','11:10:00',2.18),('5819','2013-10-21','11:15:00',2.76),('5819','2013-10-21','11:20:00',2.76),('5819','2013-10-21','11:25:00',2.73),('5819','2013-10-21','11:30:00',2.78),('5819','2013-10-21','11:35:00',2.8),('5819','2013-10-21','11:40:00',2.76),('5819','2013-10-21','11:45:00',2.87),('5819','2013-10-21','11:50:00',2.86),('5819','2013-10-21','11:55:00',2.87),('5819','2013-10-21','12:00:00',2.91),('5819','2013-10-21','12:05:00',2.93),('5819','2013-10-21','12:10:00',2.93),('5819','2013-10-21','12:15:00',2.91),('5819','2013-10-21','12:20:00',2.89),('5819','2013-10-21','12:25:00',2.91),('5819','2013-10-21','12:30:00',2.79),('5819','2013-10-21','12:35:00',2.8),('5819','2013-10-21','12:40:00',2.89),('5819','2013-10-21','12:45:00',2.89),('5819','2013-10-21','12:50:00',2.86),('5819','2013-10-21','12:55:00',2.84),('5819','2013-10-21','13:00:00',2.81),('5819','2013-10-21','13:05:00',2.75),('5819','2013-10-21','13:10:00',2.61),('5819','2013-10-21','13:15:00',2.66),('5819','2013-10-21','13:20:00',2.68),('5819','2013-10-21','13:25:00',2.64),('5819','2013-10-21','13:30:00',2.72),('5819','2013-10-21','13:35:00',2.7),('5819','2013-10-21','13:40:00',2.64),('5819','2013-10-21','13:45:00',2.61),('5819','2013-10-21','13:50:00',2.58),('5819','2013-10-21','13:55:00',2.52),('5819','2013-10-21','14:00:00',2.42),('5819','2013-10-21','14:05:00',2.49),('5819','2013-10-21','14:10:00',2.46),('5819','2013-10-21','14:15:00',2.41),('5819','2013-10-21','14:20:00',2.38),('5819','2013-10-21','14:25:00',2.32),('5819','2013-10-21','14:30:00',2.27),('5819','2013-10-21','14:35:00',2.26),('5819','2013-10-21','14:40:00',2.13),('5819','2013-10-21','14:45:00',2.04),('5819','2013-10-21','14:50:00',1.99),('5819','2013-10-21','14:55:00',1.95),('5819','2013-10-21','15:00:00',1.97),('5819','2013-10-21','15:05:00',1.92),('5819','2013-10-21','15:10:00',1.86),('5819','2013-10-21','15:15:00',1.82),('5819','2013-10-21','15:20:00',1.79),('5819','2013-10-21','15:25:00',1.71),('5819','2013-10-21','15:30:00',1.59),('5819','2013-10-21','15:35:00',1.5),('5819','2013-10-21','15:40:00',1.51),('5819','2013-10-21','15:45:00',1.45),('5819','2013-10-21','15:50:00',1.37),('5819','2013-10-21','15:55:00',1.31),('5819','2013-10-21','16:00:00',1.26),('5819','2013-10-21','16:05:00',1.2),('5819','2013-10-21','16:10:00',1.15),('5819','2013-10-21','16:15:00',1.08),('5819','2013-10-21','16:20:00',1.01),('5819','2013-10-20','08:35:00',1.08),('5819','2013-10-20','08:40:00',1.13),('5819','2013-10-20','08:45:00',1.18),('5819','2013-10-20','08:50:00',1.27),('5819','2013-10-20','08:55:00',1.36),('5819','2013-10-20','09:00:00',1.41),('5819','2013-10-20','09:05:00',1.44),('5819','2013-10-20','09:10:00',1.54),('5819','2013-10-20','09:15:00',1.62),('5819','2013-10-20','09:20:00',1.71),('5819','2013-10-20','09:25:00',1.78),('5819','2013-10-20','09:30:00',1.83),('5819','2013-10-20','09:35:00',1.9),('5819','2013-10-20','09:40:00',1.97),('5819','2013-10-20','09:45:00',2.03),('5819','2013-10-20','09:50:00',2.08),('5819','2013-10-20','09:55:00',2.14),('5819','2013-10-20','10:00:00',2.22),('5819','2013-10-20','10:05:00',2.28),('5819','2013-10-20','10:10:00',2.34),('5819','2013-10-20','10:15:00',2.38),('5819','2013-10-20','10:20:00',2.42),('5819','2013-10-20','10:25:00',2.47),('5819','2013-10-20','10:30:00',2.52),('5819','2013-10-20','10:35:00',2.56),('5819','2013-10-20','10:40:00',2.6),('5819','2013-10-20','10:45:00',2.64),('5819','2013-10-20','10:50:00',2.66),('5819','2013-10-20','10:55:00',2.69),('5819','2013-10-20','11:00:00',2.72),('5819','2013-10-20','11:05:00',2.76),('5819','2013-10-20','11:10:00',2.8),('5819','2013-10-20','11:15:00',2.8),('5819','2013-10-20','11:20:00',2.83),('5819','2013-10-20','11:25:00',2.86),('5819','2013-10-20','11:30:00',2.9),('5819','2013-10-20','11:35:00',2.91),('5819','2013-10-20','11:40:00',2.94),('5819','2013-10-20','11:45:00',2.94),('5819','2013-10-20','11:50:00',2.96),('5819','2013-10-20','11:55:00',2.92),('5819','2013-10-20','12:00:00',2.95),('5819','2013-10-20','12:05:00',2.98),('5819','2013-10-20','12:10:00',3.01),('5819','2013-10-20','12:15:00',2.05),('5819','2013-10-20','12:20:00',1.41),('5819','2013-10-20','12:25:00',1.32),('5819','2013-10-20','12:30:00',2.68),('5819','2013-10-20','12:35:00',2.34),('5819','2013-10-20','12:40:00',2.66),('5819','2013-10-20','12:45:00',1.25),('5819','2013-10-20','12:50:00',1.62),('5819','2013-10-20','12:55:00',2.63),('5819','2013-10-20','13:00:00',2.57),('5819','2013-10-20','13:05:00',2.34),('5819','2013-10-20','13:10:00',3.35),('5819','2013-10-20','13:15:00',2.09),('5819','2013-10-20','13:25:00',1.47),('5819','2013-10-20','13:30:00',2.23),('5819','2013-10-20','13:35:00',2.28),('5819','2013-10-20','13:40:00',1.42),('5819','2013-10-20','13:45:00',2.28),('5819','2013-10-20','13:50:00',1.5),('5819','2013-10-20','13:55:00',1.64),('5819','2013-10-20','14:00:00',1.23),('5819','2013-10-20','14:10:00',1.48),('5819','2013-10-19','08:35:00',1.15),('5819','2013-10-19','08:40:00',1.32),('5819','2013-10-19','08:45:00',1.41),('5819','2013-10-19','08:50:00',1.54),('5819','2013-10-19','08:55:00',1.34),('5819','2013-10-19','09:00:00',1.35),('5819','2013-10-19','09:05:00',1.24),('5819','2013-10-19','09:10:00',1.77),('5819','2013-10-19','09:15:00',2.06),('5819','2013-10-19','09:20:00',2.1),('5819','2013-10-19','09:25:00',2.12),('5819','2013-10-19','09:30:00',2.15),('5819','2013-10-19','09:35:00',2.19),('5819','2013-10-19','09:40:00',2.27),('5819','2013-10-19','09:45:00',2.38),('5819','2013-10-19','09:50:00',2.45),('5819','2013-10-19','09:55:00',2.54),('5819','2013-10-19','10:00:00',2.54),('5819','2013-10-19','10:05:00',2.39),('5819','2013-10-19','10:10:00',2.57),('5819','2013-10-19','10:15:00',2.52),('5819','2013-10-19','10:20:00',2.69),('5819','2013-10-19','10:25:00',2.9),('5819','2013-10-19','10:30:00',2.93),('5819','2013-10-19','10:35:00',2.93),('5819','2013-10-19','10:40:00',2.92),('5819','2013-10-19','10:45:00',2.88),('5819','2013-10-19','10:50:00',2.94),('5819','2013-10-19','10:55:00',3.01),('5819','2013-10-19','11:00:00',3.03),('5819','2013-10-19','11:05:00',2.7),('5819','2013-10-19','11:10:00',1.78),('5819','2013-10-19','11:15:00',1.22),('5819','2013-10-19','11:20:00',2.11),('5819','2013-10-19','11:25:00',3.42),('5819','2013-10-19','11:30:00',3.26),('5819','2013-10-19','11:35:00',3.26),('5819','2013-10-19','11:40:00',3.08),('5819','2013-10-19','11:45:00',3.16),('5819','2013-10-19','11:50:00',3.11),('5819','2013-10-19','11:55:00',3.16),('5819','2013-10-19','12:00:00',3.26),('5819','2013-10-19','12:05:00',3.25),('5819','2013-10-19','12:10:00',3.19),('5819','2013-10-19','12:15:00',3.18),('5819','2013-10-19','12:20:00',3.22),('5819','2013-10-19','12:25:00',2.89),('5819','2013-10-19','12:30:00',3.11),('5819','2013-10-19','12:35:00',3.19),('5819','2013-10-19','12:40:00',3.29),('5819','2013-10-19','12:45:00',3.31),('5819','2013-10-19','12:50:00',3.38),('5819','2013-10-19','12:55:00',3.25),('5819','2013-10-19','13:00:00',3.51),('5819','2013-10-19','13:05:00',2.77),('5819','2013-10-19','13:10:00',2.85),('5819','2013-10-19','13:15:00',2.89),('5819','2013-10-19','13:20:00',2.84),('5819','2013-10-19','13:25:00',3.12),('5819','2013-10-19','13:30:00',3.16),('5819','2013-10-19','13:35:00',2.72),('5819','2013-10-19','13:40:00',2.47),('5819','2013-10-19','13:45:00',2.47),('5819','2013-10-19','13:50:00',2.55),('5819','2013-10-19','13:55:00',3.12),('5819','2013-10-19','14:00:00',2.56),('5819','2013-10-19','14:05:00',2.19),('5819','2013-10-19','14:10:00',1.69),('5819','2013-10-19','14:15:00',2.09),('5819','2013-10-19','14:20:00',1.89),('5819','2013-10-19','14:25:00',1.9),('5819','2013-10-19','14:30:00',2.16),('5819','2013-10-19','14:35:00',2.94),('5819','2013-10-19','14:40:00',2.24),('5819','2013-10-19','14:45:00',1.81),('5819','2013-10-19','14:50:00',2.57),('5819','2013-10-19','14:55:00',2.47),('5819','2013-10-19','15:00:00',2.39),('5819','2013-10-19','15:05:00',2.3),('5819','2013-10-19','15:10:00',2.25),('5819','2013-10-19','15:15:00',2.19),('5819','2013-10-19','15:20:00',2.02),('5819','2013-10-19','15:25:00',1.96),('5819','2013-10-19','15:30:00',1.85),('5819','2013-10-19','15:35:00',1.8),('5819','2013-10-19','15:40:00',1.66),('5819','2013-10-19','15:45:00',1.4),('5819','2013-10-19','15:50:00',1.45),('5819','2013-10-19','15:55:00',1.6),('5819','2013-10-19','16:00:00',1.34),('5819','2013-10-19','16:05:00',1.4),('5819','2013-10-19','16:10:00',1.32),('5819','2013-10-19','16:15:00',1.36),('5819','2013-10-19','16:20:00',1.27),('5819','2013-10-19','16:30:00',1.1),('5819','2013-10-19','16:35:00',1.12),('5819','2013-10-19','16:40:00',1.07),('5819','2014-05-04','07:35:00',1.03),('5819','2014-05-04','07:40:00',1.32),('5819','2014-05-04','07:45:00',1.33),('5819','2014-05-04','07:50:00',1.57),('5819','2014-05-04','07:55:00',1.65),('5819','2014-05-04','08:00:00',1.72),('5819','2014-05-04','08:05:00',1.83),('5819','2014-05-04','08:10:00',1.9),('5819','2014-05-04','08:15:00',2.01),('5819','2014-05-04','08:20:00',2.12),('5819','2014-05-04','08:25:00',2.2),('5819','2014-05-04','08:30:00',2.41),('5819','2014-05-04','08:35:00',2.24),('5819','2014-05-04','08:40:00',1.27),('5819','2014-05-04','08:45:00',1.15),('5819','2014-05-04','08:50:00',1.6),('5819','2014-05-04','08:55:00',1.23),('5819','2014-05-04','09:00:00',1.42),('5819','2014-05-04','09:05:00',2.41),('5819','2014-05-04','09:10:00',1.9),('5819','2014-05-04','09:15:00',2.46),('5819','2014-05-04','09:20:00',3.74),('5819','2014-05-04','09:25:00',2.89),('5819','2014-05-04','09:30:00',1.31),('5819','2014-05-04','09:35:00',1.24),('5819','2014-05-04','09:40:00',1.99),('5819','2014-05-04','09:45:00',2.52),('5819','2014-05-04','09:50:00',2.42),('5819','2014-05-04','09:55:00',2.73),('5819','2014-05-04','10:00:00',3.78),('5819','2014-05-04','10:05:00',3.71),('5819','2014-05-04','10:10:00',3.75),('5819','2014-05-04','10:15:00',2.72),('5819','2014-05-04','10:20:00',1.88),('5819','2014-05-04','10:25:00',1.81),('5819','2014-05-04','10:30:00',1.85),('5819','2014-05-04','10:35:00',1.96),('5819','2014-05-04','10:40:00',2.03),('5819','2014-05-04','10:45:00',2.9),('5819','2014-05-04','10:50:00',2.77),('5819','2014-05-04','10:55:00',2.57),('5819','2014-05-04','11:00:00',2.45),('5819','2014-05-04','11:05:00',3.6),('5819','2014-05-04','11:10:00',4.12),('5819','2014-05-04','11:15:00',4.08),('5819','2014-05-04','11:20:00',3.9),('5819','2014-05-04','11:25:00',3.44),('5819','2014-05-04','11:30:00',3.79),('5819','2014-05-04','11:35:00',3.85),('5819','2014-05-04','11:40:00',2.9),('5819','2014-05-04','11:45:00',4.18),('5819','2014-05-04','11:50:00',2.74),('5819','2014-05-04','11:55:00',3.37),('5819','2014-05-04','12:00:00',3.03),('5819','2014-05-04','12:05:00',2.7),('5819','2014-05-04','12:10:00',2.42),('5819','2014-05-04','12:15:00',1.56),('5819','2014-05-04','12:20:00',1.72),('5819','2014-05-04','12:25:00',2.96),('5819','2014-05-04','12:30:00',4.9),('5819','2014-05-04','12:35:00',4.61),('5819','2014-05-04','12:40:00',4.68),('5819','2014-05-04','12:45:00',3.23),('5819','2014-05-04','12:50:00',2.3),('5819','2014-05-04','12:55:00',2.21),('5819','2014-05-04','13:00:00',2.31),('5819','2014-05-04','13:05:00',2.2),('5819','2014-05-04','13:10:00',2.24),('5819','2014-05-04','13:15:00',1.95),('5819','2014-05-04','13:20:00',1.77),('5819','2014-05-04','13:25:00',1.47),('5819','2014-05-04','13:30:00',1.64),('5819','2014-05-04','13:35:00',1.66),('5819','2014-05-04','13:40:00',1.54),('5819','2014-05-04','13:45:00',1.35),('5819','2014-05-04','13:50:00',1.33),('5819','2014-05-04','13:55:00',1.35),('5819','2014-05-04','14:00:00',1.35),('5819','2014-05-04','14:05:00',1.38),('5819','2014-05-04','14:10:00',1.35),('5819','2014-05-04','14:15:00',1.21),('5819','2014-05-04','14:50:00',1.13),('5819','2014-05-04','14:55:00',1.58),('5819','2014-05-04','15:00:00',1.75),('5819','2014-05-04','15:05:00',2.78),('5819','2014-05-04','15:10:00',2.88),('5819','2014-05-04','15:15:00',2.49),('5819','2014-05-04','15:20:00',1.45),('5819','2014-05-04','15:25:00',1.16),('5819','2014-05-04','15:50:00',1.08),('5819','2014-05-04','15:55:00',1.06),('5819','2014-05-04','16:10:00',1.19),('5819','2014-05-04','16:15:00',1.16),('5819','2014-04-16','07:50:00',1.16),('5819','2014-04-16','07:55:00',1.31),('5819','2014-04-16','08:00:00',1.39),('5819','2014-04-16','08:05:00',1.5),('5819','2014-04-16','08:10:00',1.61),('5819','2014-04-16','08:15:00',1.71),('5819','2014-04-16','08:20:00',1.83),('5819','2014-04-16','08:25:00',1.92),('5819','2014-04-16','08:30:00',1.37),('5819','2014-04-16','08:35:00',1.17),('5819','2014-04-16','08:40:00',1.35),('5819','2014-04-16','08:45:00',2.12),('5819','2014-04-16','08:50:00',2.37),('5819','2014-04-16','08:55:00',2.43),('5819','2014-04-16','09:00:00',2.5),('5819','2014-04-16','09:05:00',2.58),('5819','2014-04-16','09:10:00',2.64),('5819','2014-04-16','09:15:00',2.69),('5819','2014-04-16','09:20:00',2.77),('5819','2014-04-16','09:25:00',2.89),('5819','2014-04-16','09:30:00',1.62),('5819','2014-04-16','09:45:00',1.27),('5819','2014-04-16','09:50:00',2.55),('5819','2014-04-16','09:55:00',3.53),('5819','2014-04-16','10:00:00',3.43),('5819','2014-04-16','10:05:00',3.46),('5819','2014-04-16','10:10:00',3.52),('5819','2014-04-16','10:15:00',3.57),('5819','2014-04-16','10:20:00',3.63),('5819','2014-04-16','10:25:00',3.66),('5819','2014-04-16','10:30:00',3.72),('5819','2014-04-16','10:35:00',3.75),('5819','2014-04-16','10:40:00',3.79),('5819','2014-04-16','10:45:00',3.84),('5819','2014-04-16','10:50:00',3.95),('5819','2014-04-16','10:55:00',3.57),('5819','2014-04-16','11:00:00',3.88),('5819','2014-04-16','11:05:00',3.11),('5819','2014-04-16','11:10:00',1.63),('5819','2014-04-16','11:15:00',2.33),('5819','2014-04-16','11:20:00',4.4),('5819','2014-04-16','11:25:00',2.95),('5819','2014-04-16','11:30:00',3.79),('5819','2014-04-16','11:35:00',2.67),('5819','2014-04-16','11:40:00',3.71),('5819','2014-04-16','11:45:00',4.07),('5819','2014-04-16','11:50:00',4.64),('5819','2014-04-16','11:55:00',4.37),('5819','2014-04-16','12:00:00',4.54),('5819','2014-04-16','12:05:00',1.75),('5819','2014-04-16','12:10:00',4.11),('5819','2014-04-16','12:15:00',4.36),('5819','2014-04-16','12:20:00',3.78),('5819','2014-04-16','12:25:00',1.34),('5819','2014-04-16','12:30:00',2.97),('5819','2014-04-16','12:35:00',4.44),('5819','2014-04-16','12:40:00',4.46),('5819','2014-04-16','12:45:00',4.35),('5819','2014-04-16','12:50:00',4.39),('5819','2014-04-16','12:55:00',3.15),('5819','2014-04-16','13:00:00',2.47),('5819','2014-04-16','13:05:00',1.26),('5819','2014-04-16','13:20:00',1.45),('5819','2014-04-16','13:25:00',1.06),('5819','2014-04-16','13:35:00',1.46),('5819','2014-04-16','13:40:00',1.95),('5819','2014-04-16','13:45:00',4.28),('5819','2014-04-16','13:50:00',4.12),('5819','2014-04-16','13:55:00',2.36),('5819','2014-04-16','14:00:00',1.65),('5819','2014-04-16','14:05:00',3),('5819','2014-04-16','14:10:00',4.44),('5819','2014-04-16','14:15:00',4.52),('5819','2014-04-16','14:20:00',3.92),('5819','2014-04-16','14:25:00',3.56),('5819','2014-04-16','14:30:00',3.43),('5819','2014-04-16','14:35:00',3.87),('5819','2014-04-16','14:40:00',3.78),('5819','2014-04-16','14:45:00',2.57),('5819','2014-04-16','14:50:00',3.01),('5819','2014-04-16','14:55:00',1.18),('5819','2014-04-16','15:00:00',1.41),('5819','2014-04-16','15:05:00',2.87),('5819','2014-04-16','15:10:00',4.25),('5819','2014-04-16','15:15:00',2.45),('5819','2014-04-16','15:25:00',1.23),('5819','2014-04-16','15:30:00',3.15),('5819','2014-04-16','15:35:00',3.46),('5819','2014-04-16','15:40:00',3.31),('5819','2014-04-16','15:45:00',3.15),('5819','2014-04-16','15:50:00',3.04),('5819','2014-04-16','15:55:00',2.93),('5819','2014-04-16','16:00:00',2.83),('5819','2014-04-16','16:05:00',2.74),('5819','2014-04-16','16:10:00',2.65),('5819','2014-04-16','16:15:00',2.59),('5819','2014-04-16','16:20:00',2.54),('5819','2014-04-16','16:25:00',2.43),('5819','2014-04-16','16:30:00',2.36),('5819','2014-04-16','16:35:00',2.29),('5819','2014-04-16','16:40:00',2.21),('5819','2014-04-16','16:45:00',2.14),('5819','2014-04-16','16:50:00',2.02),('5819','2014-04-16','16:55:00',1.92),('5819','2014-04-16','17:00:00',1.84),('5819','2014-04-16','17:05:00',1.74),('5819','2014-04-16','17:10:00',1.66),('5819','2014-04-16','17:15:00',1.6),('5819','2014-04-16','17:20:00',1.48),('5819','2014-04-16','17:25:00',1.37),('5819','2014-04-16','17:30:00',1.18),('5819','2014-04-16','17:35:00',1.07),('5819','2014-04-16','17:40:00',1.12),('5819','2014-04-16','17:45:00',1.08),('5819','2014-04-16','17:50:00',1.08),('5819','2014-04-16','17:55:00',1.07),('5819','2013-10-18','08:35:00',1.04),('5819','2013-10-18','08:40:00',1.17),('5819','2013-10-18','08:45:00',1.31),('5819','2013-10-18','08:50:00',1.33),('5819','2013-10-18','08:55:00',1.38),('5819','2013-10-18','09:00:00',1.55),('5819','2013-10-18','09:05:00',1.69),('5819','2013-10-18','09:10:00',1.81),('5819','2013-10-18','09:15:00',1.84),('5819','2013-10-18','09:20:00',1.99),('5819','2013-10-18','09:25:00',2.03),('5819','2013-10-18','09:30:00',2.13),('5819','2013-10-18','09:35:00',2.2),('5819','2013-10-18','09:40:00',2.27),('5819','2013-10-18','09:45:00',2.34),('5819','2013-10-18','09:50:00',2.39),('5819','2013-10-18','09:55:00',2.44),('5819','2013-10-18','10:00:00',2.48),('5819','2013-10-18','10:05:00',2.55),('5819','2013-10-18','10:10:00',2.58),('5819','2013-10-18','10:15:00',2.63),('5819','2013-10-18','10:20:00',2.65),('5819','2013-10-18','10:25:00',2.71),('5819','2013-10-18','10:30:00',2.76),('5819','2013-10-18','10:35:00',2.8),('5819','2013-10-18','10:40:00',2.86),('5819','2013-10-18','10:45:00',2.89),('5819','2013-10-18','10:50:00',2.91),('5819','2013-10-18','10:55:00',2.95),('5819','2013-10-18','11:00:00',2.91),('5819','2013-10-18','11:05:00',2.9),('5819','2013-10-18','11:10:00',2.83),('5819','2013-10-18','11:15:00',2.61),('5819','2013-10-18','11:20:00',2.97),('5819','2013-10-18','11:25:00',2.71),('5819','2013-10-18','11:30:00',3.07),('5819','2013-10-18','11:35:00',3.07),('5819','2013-10-18','11:40:00',3.15),('5819','2013-10-18','11:45:00',3.06),('5819','2013-10-18','11:50:00',3.1),('5819','2013-10-18','11:55:00',3.16),('5819','2013-10-18','12:00:00',3.02),('5819','2013-10-18','12:05:00',3.14),('5819','2013-10-18','12:10:00',3.12),('5819','2013-10-18','12:15:00',3.08),('5819','2013-10-18','12:20:00',3.05),('5819','2013-10-18','12:25:00',3.11),('5819','2013-10-18','12:30:00',3.13),('5819','2013-10-18','12:35:00',3.05),('5819','2013-10-18','12:40:00',3.08),('5819','2013-10-18','12:45:00',2.98),('5819','2013-10-18','12:50:00',2.95),('5819','2013-10-18','12:55:00',3.02),('5819','2013-10-18','13:00:00',3),('5819','2013-10-18','13:05:00',2.91),('5819','2013-10-18','13:10:00',2.8),('5819','2013-10-18','13:15:00',2.91),('5819','2013-10-18','13:20:00',2.9),('5819','2013-10-18','13:25:00',2.99),('5819','2013-10-18','13:30:00',2.95),('5819','2013-10-18','13:35:00',2.88),('5819','2013-10-18','13:40:00',2.88),('5819','2013-10-18','13:45:00',2.81),('5819','2013-10-18','13:50:00',2.79),('5819','2013-10-18','13:55:00',2.78),('5819','2013-10-18','14:00:00',2.54),('5819','2013-10-18','14:05:00',2.6),('5819','2013-10-18','14:10:00',2.57),('5819','2013-10-18','14:15:00',2.6),('5819','2013-10-18','14:20:00',2.57),('5819','2013-10-18','14:25:00',2.55),('5819','2013-10-18','14:30:00',2.48),('5819','2013-10-18','14:35:00',2.39),('5819','2013-10-18','14:40:00',2.37),('5819','2013-10-18','14:45:00',2.3),('5819','2013-10-18','14:50:00',2.2),('5819','2013-10-18','14:55:00',2.2),('5819','2013-10-18','15:00:00',1.97),('5819','2013-10-18','15:05:00',1.75),('5819','2013-10-18','15:10:00',1.87),('5819','2013-10-18','15:15:00',1.87),('5819','2013-10-18','15:20:00',1.95),('5819','2013-10-18','15:25:00',1.83),('5819','2013-10-18','15:30:00',1.74),('5819','2013-10-18','15:35:00',1.71),('5819','2013-10-18','15:40:00',1.62),('5819','2013-10-18','15:45:00',1.45),('5819','2013-10-18','15:50:00',1.45),('5819','2013-10-18','15:55:00',1.34),('5819','2013-10-18','16:00:00',1.36),('5819','2013-10-18','16:05:00',1.27),('5819','2013-10-18','16:10:00',1.21),('5819','2013-10-18','16:15:00',1.08),('5819','2013-10-18','16:20:00',1),('5819','2013-10-17','08:25:00',1.04),('5819','2013-10-17','08:30:00',1.12),('5819','2013-10-17','08:35:00',1.22),('5819','2013-10-17','08:40:00',1.31),('5819','2013-10-17','08:45:00',1.4),('5819','2013-10-17','08:50:00',1.49),('5819','2013-10-17','08:55:00',1.59),('5819','2013-10-17','09:00:00',1.67),('5819','2013-10-17','09:05:00',1.75),('5819','2013-10-17','09:10:00',1.83),('5819','2013-10-17','09:15:00',1.91),('5819','2013-10-17','09:20:00',1.99),('5819','2013-10-17','09:25:00',2.06),('5819','2013-10-17','09:30:00',2.12),('5819','2013-10-17','09:35:00',2.19),('5819','2013-10-17','09:40:00',2.26),('5819','2013-10-17','09:45:00',2.32),('5819','2013-10-17','09:50:00',2.38),('5819','2013-10-17','09:55:00',2.44),('5819','2013-10-17','10:00:00',2.48),('5819','2013-10-17','10:05:00',2.52),('5819','2013-10-17','10:10:00',2.59),('5819','2013-10-17','10:15:00',2.64),('5819','2013-10-17','10:20:00',2.68),('5819','2013-10-17','10:25:00',2.73),('5819','2013-10-17','10:30:00',2.79),('5819','2013-10-17','10:35:00',2.83),('5819','2013-10-17','10:40:00',2.87),('5819','2013-10-17','10:45:00',2.92),('5819','2013-10-17','10:50:00',2.95),('5819','2013-10-17','10:55:00',2.98),('5819','2013-10-17','11:00:00',3),('5819','2013-10-17','11:05:00',3.03),('5819','2013-10-17','11:10:00',3.05),('5819','2013-10-17','11:15:00',3.08),('5819','2013-10-17','11:20:00',3.09),('5819','2013-10-17','11:25:00',3.11),('5819','2013-10-17','11:30:00',3.14),('5819','2013-10-17','11:35:00',3.18),('5819','2013-10-17','11:40:00',3.19),('5819','2013-10-17','11:45:00',3.18),('5819','2013-10-17','11:50:00',3.2),('5819','2013-10-17','11:55:00',3.21),('5819','2013-10-17','12:00:00',3.2),('5819','2013-10-17','12:05:00',3.2),('5819','2013-10-17','12:10:00',3.21),('5819','2013-10-17','12:15:00',3.23),('5819','2013-10-17','12:20:00',3.22),('5819','2013-10-17','12:25:00',3.21),('5819','2013-10-17','12:30:00',3.22),('5819','2013-10-17','12:35:00',3.21),('5819','2013-10-17','12:40:00',3.2),('5819','2013-10-17','12:45:00',3.22),('5819','2013-10-17','12:50:00',3.19),('5819','2013-10-17','12:55:00',3.18),('5819','2013-10-17','13:00:00',3.15),('5819','2013-10-17','13:05:00',3.13),('5819','2013-10-17','13:10:00',3.1),('5819','2013-10-17','13:15:00',3.1),('5819','2013-10-17','13:20:00',3.1),('5819','2013-10-17','13:25:00',3.06),('5819','2013-10-17','13:30:00',3.03),('5819','2013-10-17','13:35:00',2.98),('5819','2013-10-17','13:40:00',2.96),('5819','2013-10-17','13:45:00',2.93),('5819','2013-10-17','13:50:00',2.89),('5819','2013-10-17','13:55:00',2.88),('5819','2013-10-17','14:00:00',2.85),('5819','2013-10-17','14:05:00',2.8),('5819','2013-10-17','14:10:00',2.77),('5819','2013-10-17','14:15:00',2.74),('5819','2013-10-17','14:20:00',2.68),('5819','2013-10-17','14:25:00',2.64),('5819','2013-10-17','14:30:00',2.6),('5819','2013-10-17','14:35:00',2.55),('5819','2013-10-17','14:40:00',2.51),('5819','2013-10-17','14:45:00',2.46),('5819','2013-10-17','14:50:00',2.39),('5819','2013-10-17','14:55:00',2.34),('5819','2013-10-17','15:00:00',2.28),('5819','2013-10-17','15:05:00',2.22),('5819','2013-10-17','15:10:00',2.17),('5819','2013-10-17','15:15:00',2.12),('5819','2013-10-17','15:20:00',2.06),('5819','2013-10-17','15:25:00',2),('5819','2013-10-17','15:30:00',1.94),('5819','2013-10-17','15:35:00',1.86),('5819','2013-10-17','15:40:00',1.76),('5819','2013-10-17','15:45:00',1.69),('5819','2013-10-17','15:50:00',1.62),('5819','2013-10-17','15:55:00',1.55),('5819','2013-10-17','16:00:00',1.48),('5819','2013-10-17','16:05:00',1.39),('5819','2013-10-17','16:10:00',1.34),('5819','2013-10-17','16:15:00',1.27),('5819','2013-10-17','16:20:00',1.2),('5819','2013-10-17','16:25:00',1.14),('5819','2013-10-17','16:30:00',1.07),('5819','2013-10-17','16:35:00',1),('5819','2013-10-16','09:45:00',1.19),('5819','2013-10-16','09:50:00',1.77),('5819','2013-10-16','11:15:00',1.4),('5819','2013-10-16','11:55:00',1.07),('5819','2013-10-16','12:15:00',1.52),('5819','2013-10-16','12:20:00',2.83),('5819','2013-10-16','12:25:00',1.48),('5819','2013-10-16','12:35:00',1.18),('5819','2013-10-16','12:40:00',3.4),('5819','2013-10-16','12:45:00',3.43),('5819','2013-10-16','12:50:00',3.3),('5819','2013-10-16','12:55:00',2.86),('5819','2013-10-16','13:00:00',2.36),('5819','2013-10-16','13:05:00',3.02),('5819','2013-10-16','13:10:00',3.32),('5819','2013-10-16','13:15:00',2.17),('5819','2013-10-16','13:20:00',2.1),('5819','2013-10-16','13:25:00',3.04),('5819','2013-10-16','13:30:00',2.84),('5819','2013-10-16','13:35:00',2.93),('5819','2013-10-16','13:40:00',3.09),('5819','2013-10-16','13:45:00',3),('5819','2013-10-16','13:50:00',2.93),('5819','2013-10-16','13:55:00',3.09),('5819','2013-10-16','14:00:00',2.58),('5819','2013-10-16','14:05:00',2.02),('5819','2013-10-16','14:10:00',2.62),('5819','2013-10-16','14:15:00',1.79),('5819','2013-10-16','14:20:00',2.75),('5819','2013-10-16','14:25:00',1.45),('5819','2013-10-16','14:30:00',2.18),('5819','2013-10-16','14:35:00',2.16),('5819','2013-10-16','14:40:00',2.04),('5819','2013-10-16','14:45:00',2.6),('5819','2013-10-16','14:50:00',2.5),('5819','2013-10-16','14:55:00',2.02),('5819','2013-10-16','15:00:00',2.37),('5819','2013-10-16','15:05:00',2.32),('5819','2013-10-16','15:10:00',2.31),('5819','2013-10-16','15:15:00',2.23),('5819','2013-10-16','15:20:00',2.16),('5819','2013-10-16','15:25:00',1.71),('5819','2013-10-16','15:30:00',1.08),('5819','2013-10-16','15:35:00',1.66),('5819','2013-10-16','15:40:00',2.02),('5819','2013-10-16','15:45:00',1.77),('5819','2013-10-16','15:50:00',1.67),('5819','2013-10-16','15:55:00',1.61),('5819','2013-10-16','16:00:00',1.54),('5819','2013-10-16','16:05:00',1.47),('5819','2013-10-16','16:10:00',1.37),('5819','2013-10-16','16:15:00',1.31),('5819','2013-10-16','16:20:00',1.24),('5819','2013-10-16','16:25:00',1.18),('5819','2013-10-16','16:30:00',1.09),('5819','2013-10-16','16:35:00',1.04),('5819','2013-10-16','16:40:00',1.01),('5819','2013-10-15','09:20:00',1.04),('5819','2013-10-15','09:25:00',1.17),('5819','2013-10-15','09:30:00',1.77),('5819','2013-10-15','09:35:00',1.07),('5819','2013-10-15','09:40:00',1.56),('5819','2013-10-15','09:45:00',2.05),('5819','2013-10-15','09:50:00',2.3),('5819','2013-10-15','09:55:00',2.39),('5819','2013-10-15','10:00:00',2.36),('5819','2013-10-15','10:05:00',2.51),('5819','2013-10-15','10:10:00',1.99),('5819','2013-10-15','10:15:00',1.26),('5819','2013-10-15','10:20:00',1.2),('5819','2013-10-15','10:25:00',1.29),('5819','2013-10-15','10:30:00',2.02),('5819','2013-10-15','10:35:00',1.61),('5819','2013-10-15','10:40:00',1.96),('5819','2013-10-15','10:45:00',2.22),('5819','2013-10-15','10:50:00',2.19),('5819','2013-10-15','10:55:00',1.86),('5819','2013-10-15','11:00:00',1.85),('5819','2013-10-15','11:05:00',1.91),('5819','2013-10-15','11:10:00',2.59),('5819','2013-10-15','11:15:00',2.74),('5819','2013-10-15','11:20:00',2.8),('5819','2013-10-15','11:25:00',2.64),('5819','2013-10-15','11:30:00',2.69),('5819','2013-10-15','11:35:00',2.32),('5819','2013-10-15','11:40:00',1.83),('5819','2013-10-15','11:45:00',1.45),('5819','2013-10-15','11:50:00',1.39),('5819','2013-10-15','11:55:00',1.36),('5819','2013-10-15','12:00:00',1.4),('5819','2013-10-15','12:05:00',1.4),('5819','2013-10-15','12:10:00',1.43),('5819','2013-10-15','12:15:00',1.41),('5819','2013-10-15','12:20:00',1.47),('5819','2013-10-15','12:25:00',1.37),('5819','2013-10-15','12:30:00',1.23),('5819','2013-10-15','12:35:00',1.2),('5819','2013-10-15','12:40:00',1.19),('5819','2013-10-15','12:45:00',1.27),('5819','2013-10-15','12:50:00',1.21),('5819','2013-10-15','12:55:00',1.07),('5819','2013-10-15','13:00:00',1.06),('5819','2013-10-15','13:05:00',1.37),('5819','2013-10-15','13:10:00',1.68),('5819','2013-10-15','13:15:00',1.71),('5819','2013-10-15','13:20:00',2.39),('5819','2013-10-15','13:25:00',2.81),('5819','2013-10-15','13:30:00',1.8),('5819','2013-10-15','13:35:00',1.54),('5819','2013-10-15','13:40:00',1.43),('5819','2013-10-15','13:45:00',1.47),('5819','2013-10-15','13:50:00',1.34),('5819','2013-10-15','13:55:00',1.2),('5819','2013-10-15','14:00:00',1.08),('5819','2013-10-15','14:05:00',1.06),('5819','2013-10-15','14:10:00',1.14),('5819','2013-10-15','14:15:00',1.56),('5819','2013-10-15','14:20:00',1.84),('5819','2013-10-15','14:25:00',1.97),('5819','2013-10-15','14:30:00',1.98),('5819','2013-10-15','14:35:00',1.25),('5819','2013-10-15','14:40:00',1.74),('5819','2013-10-15','14:45:00',1.92),('5819','2013-10-15','14:50:00',2.06),('5819','2013-10-15','14:55:00',1.86),('5819','2013-10-15','15:00:00',1.19),('5819','2013-10-15','15:05:00',1.18),('5819','2013-10-15','15:10:00',1.25),('5819','2013-10-15','15:15:00',1.13),('5819','2013-10-15','15:20:00',1.02),('5819','2013-10-15','16:35:00',1.04),('5819','2013-10-14','08:25:00',1.1),('5819','2013-10-14','08:30:00',1.13),('5819','2013-10-14','08:35:00',1.25),('5819','2013-10-14','08:40:00',1.09),('5819','2013-10-14','08:45:00',1.36),('5819','2013-10-14','08:50:00',1.21),('5819','2013-10-14','08:55:00',1.41),('5819','2013-10-14','09:00:00',1.28),('5819','2013-10-14','09:05:00',1.31),('5819','2013-10-14','09:10:00',1.24),('5819','2013-10-14','09:20:00',1.19),('5819','2013-10-14','09:25:00',1.87),('5819','2013-10-14','09:30:00',2.05),('5819','2013-10-14','09:35:00',2.04),('5819','2013-10-14','09:40:00',1.66),('5819','2013-10-14','09:45:00',1.54),('5819','2013-10-14','09:50:00',1.83),('5819','2013-10-14','09:55:00',2.16),('5819','2013-10-14','10:00:00',2.07),('5819','2013-10-14','10:05:00',2.29),('5819','2013-10-14','10:10:00',2.39),('5819','2013-10-14','10:15:00',2.52),('5819','2013-10-14','10:20:00',2.55),('5819','2013-10-14','10:25:00',2.58),('5819','2013-10-14','10:30:00',2.62),('5819','2013-10-14','10:35:00',2.63),('5819','2013-10-14','10:40:00',2.59),('5819','2013-10-14','10:45:00',2.65),('5819','2013-10-14','10:50:00',2.76),('5819','2013-10-14','10:55:00',2.78),('5819','2013-10-14','11:00:00',2.85),('5819','2013-10-14','11:05:00',2.81),('5819','2013-10-14','11:10:00',2.91),('5819','2013-10-14','11:15:00',2.92),('5819','2013-10-14','11:20:00',2.91),('5819','2013-10-14','11:25:00',2.97),('5819','2013-10-14','11:30:00',3.03),('5819','2013-10-14','11:35:00',2.96),('5819','2013-10-14','11:40:00',2.98),('5819','2013-10-14','11:45:00',2.92),('5819','2013-10-14','11:50:00',2.96),('5819','2013-10-14','11:55:00',2.97),('5819','2013-10-14','12:00:00',2.98),('5819','2013-10-14','12:05:00',2.98),('5819','2013-10-14','12:10:00',3.03),('5819','2013-10-14','12:15:00',3),('5819','2013-10-14','12:20:00',2.8),('5819','2013-10-14','12:25:00',2.9),('5819','2013-10-14','12:30:00',3.09),('5819','2013-10-14','12:35:00',3.05),('5819','2013-10-14','12:40:00',3.03),('5819','2013-10-14','12:45:00',3),('5819','2013-10-14','12:50:00',2.99),('5819','2013-10-14','12:55:00',2.99),('5819','2013-10-14','13:00:00',2.98),('5819','2013-10-14','13:05:00',2.96),('5819','2013-10-14','13:10:00',2.96),('5819','2013-10-14','13:15:00',2.94),('5819','2013-10-14','13:20:00',2.93),('5819','2013-10-14','13:25:00',2.9),('5819','2013-10-14','13:30:00',2.87),('5819','2013-10-14','13:35:00',2.83),('5819','2013-10-14','13:40:00',2.81),('5819','2013-10-14','13:45:00',2.79),('5819','2013-10-14','13:50:00',2.76),('5819','2013-10-14','13:55:00',2.72),('5819','2013-10-14','14:00:00',2.69),('5819','2013-10-14','14:05:00',2.66),('5819','2013-10-14','14:10:00',2.63),('5819','2013-10-14','14:15:00',2.59),('5819','2013-10-14','14:20:00',2.55),('5819','2013-10-14','14:25:00',2.51),('5819','2013-10-14','14:30:00',2.47),('5819','2013-10-14','14:35:00',2.42),('5819','2013-10-14','14:40:00',2.37),('5819','2013-10-14','14:45:00',2.33),('5819','2013-10-14','14:50:00',2.3),('5819','2013-10-14','14:55:00',2.25),('5819','2013-10-14','15:00:00',2.19),('5819','2013-10-14','15:05:00',2.12),('5819','2013-10-14','15:10:00',2.05),('5819','2013-10-14','15:15:00',1.98),('5819','2013-10-14','15:20:00',1.93),('5819','2013-10-14','15:25:00',1.86),('5819','2013-10-14','15:30:00',1.79),('5819','2013-10-14','15:35:00',1.73),('5819','2013-10-14','15:40:00',1.49),('5819','2013-10-14','15:45:00',1.36),('5819','2013-10-14','15:50:00',1.24),('5819','2013-10-14','16:00:00',1.21),('5819','2013-10-13','08:55:00',1.1),('5819','2013-10-13','09:00:00',1.25),('5819','2013-10-13','09:05:00',1.32),('5819','2013-10-13','09:10:00',1.16),('5819','2013-10-13','09:15:00',1.83),('5819','2013-10-13','09:20:00',2),('5819','2013-10-13','09:25:00',1.86),('5819','2013-10-13','09:30:00',1.27),('5819','2013-10-13','09:35:00',1.47),('5819','2013-10-13','09:40:00',1.96),('5819','2013-10-13','09:45:00',2.79),('5819','2013-10-13','09:50:00',2.7),('5819','2013-10-13','09:55:00',2.79),('5819','2013-10-13','10:00:00',2.27),('5819','2013-10-13','10:05:00',1.58),('5819','2013-10-13','10:10:00',1.95),('5819','2013-10-13','10:15:00',2.37),('5819','2013-10-13','10:20:00',1.96),('5819','2013-10-13','10:25:00',2.03),('5819','2013-10-13','10:30:00',2.66),('5819','2013-10-13','10:35:00',3.12),('5819','2013-10-13','10:40:00',3.23),('5819','2013-10-13','10:45:00',3.26),('5819','2013-10-13','10:50:00',3.01),('5819','2013-10-13','10:55:00',2.14),('5819','2013-10-13','11:00:00',2.76),('5819','2013-10-13','11:05:00',2.95),('5819','2013-10-13','11:10:00',3.09),('5819','2013-10-13','11:15:00',3.18),('5819','2013-10-13','11:20:00',3.04),('5819','2013-10-13','11:25:00',2.99),('5819','2013-10-13','11:30:00',3.04),('5819','2013-10-13','11:35:00',3.02),('5819','2013-10-13','11:40:00',3.02),('5819','2013-10-13','11:45:00',3.02),('5819','2013-10-13','11:50:00',3.04),('5819','2013-10-13','11:55:00',3.04),('5819','2013-10-13','12:00:00',3.05),('5819','2013-10-13','12:05:00',3.06),('5819','2013-10-13','12:10:00',3.06),('5819','2013-10-13','12:15:00',3.07),('5819','2013-10-13','12:20:00',3.06),('5819','2013-10-13','12:25:00',2.92),('5819','2013-10-13','12:30:00',3.06),('5819','2013-10-13','12:35:00',3.1),('5819','2013-10-13','12:40:00',3.08),('5819','2013-10-13','12:45:00',3.02),('5819','2013-10-13','12:50:00',2.99),('5819','2013-10-13','12:55:00',3),('5819','2013-10-13','13:00:00',3),('5819','2013-10-13','13:05:00',2.97),('5819','2013-10-13','13:10:00',2.98),('5819','2013-10-13','13:15:00',3.02),('5819','2013-10-13','13:20:00',3.01),('5819','2013-10-13','13:25:00',2.72),('5819','2013-10-13','13:30:00',2.17),('5819','2013-10-13','13:35:00',2.7),('5819','2013-10-13','13:40:00',1.71),('5819','2013-10-13','13:45:00',1.85),('5819','2013-10-13','13:50:00',1.96),('5819','2013-10-13','13:55:00',2.18),('5819','2013-10-13','14:00:00',2.74),('5819','2013-10-13','14:05:00',2.82),('5819','2013-10-13','14:10:00',2.76),('5819','2013-10-13','14:15:00',2.53),('5819','2013-10-13','14:20:00',2.75),('5819','2013-10-13','14:25:00',2.72),('5819','2013-10-13','14:30:00',2.57),('5819','2013-10-13','14:35:00',1.9),('5819','2013-10-13','14:40:00',2.33),('5819','2013-10-13','14:45:00',1.96),('5819','2013-10-13','14:50:00',1.52),('5819','2013-10-13','14:55:00',1.78),('5819','2013-10-13','15:00:00',2.13),('5819','2013-10-13','15:05:00',2.08),('5819','2013-10-13','15:10:00',1.49),('5819','2013-10-13','15:15:00',1.53),('5819','2013-10-13','15:20:00',1.79),('5819','2013-10-13','15:25:00',1.91),('5819','2013-10-13','15:30:00',1.47),('5819','2013-10-13','15:35:00',1.31),('5819','2013-10-13','15:40:00',1.3),('5819','2013-10-13','15:45:00',1.22),('5819','2013-10-13','15:50:00',1.17),('5819','2013-10-13','15:55:00',1.12),('5819','2013-10-13','16:00:00',1.18),('5819','2013-10-13','16:05:00',1.45),('5819','2013-10-13','16:10:00',1.29),('5819','2013-10-13','16:15:00',1.05),('5819','2013-10-13','16:20:00',1.09),('5819','2013-10-13','16:25:00',1.35),('5819','2013-10-13','16:30:00',1.34),('5819','2013-10-13','16:35:00',1.19),('5819','2013-10-12','11:25:00',1.05),('5819','2013-10-12','11:30:00',1.22),('5819','2013-10-12','11:35:00',1.64),('5819','2013-10-12','11:40:00',2.87),('5819','2013-10-12','11:45:00',1.62),('5819','2013-10-12','11:50:00',1.38),('5819','2013-10-12','11:55:00',1.23),('5819','2013-10-12','12:20:00',1.59),('5819','2013-10-12','12:25:00',3.4),('5819','2013-10-12','12:30:00',2.52),('5819','2013-10-12','12:35:00',3.01),('5819','2013-10-12','12:40:00',2.97),('5819','2013-10-12','12:45:00',2.74),('5819','2013-10-12','12:50:00',2.92),('5819','2013-10-12','12:55:00',2.45),('5819','2013-10-12','13:00:00',1.82),('5819','2013-10-12','13:05:00',1.38),('5819','2013-10-12','13:20:00',1.27),('5819','2013-10-12','13:25:00',1.3),('5819','2013-10-12','13:30:00',3.11),('5819','2013-10-12','13:35:00',1.62),('5819','2013-10-12','16:15:00',1.42),('5819','2013-10-12','16:20:00',1.2),('5819','2013-10-11','09:25:00',1.21),('5819','2013-10-11','09:35:00',1.26),('5819','2013-10-11','09:45:00',2.43),('5819','2013-10-11','09:50:00',2.46),('5819','2013-10-11','09:55:00',2.48),('5819','2013-10-11','10:00:00',2.53),('5819','2013-10-11','10:05:00',2.59),('5819','2013-10-11','10:10:00',2.65),('5819','2013-10-11','10:15:00',2.32),('5819','2013-10-11','10:20:00',2.32),('5819','2013-10-11','10:25:00',1.66),('5819','2013-10-11','10:30:00',2.37),('5819','2013-10-11','10:35:00',3.21),('5819','2013-10-11','10:40:00',1.73),('5819','2013-10-11','11:05:00',2.47),('5819','2013-10-11','11:10:00',2.78),('5819','2013-10-11','11:15:00',1.13),('5819','2013-10-11','11:20:00',1),('5819','2013-10-11','11:25:00',1.06),('5819','2013-10-11','11:35:00',1.32),('5819','2013-10-11','11:40:00',1.85),('5819','2013-10-11','11:45:00',1.7),('5819','2013-10-11','11:50:00',2.02),('5819','2013-10-11','11:55:00',1.72),('5819','2013-10-11','12:00:00',2.33),('5819','2013-10-11','12:05:00',3.98),('5819','2013-10-11','12:10:00',1.79),('5819','2013-10-11','12:15:00',1.15),('5819','2013-10-11','12:30:00',1.86),('5819','2013-10-11','13:05:00',2.4),('5819','2013-10-11','13:10:00',1.58),('5819','2013-10-11','13:15:00',1.13),('5819','2013-10-11','13:20:00',1.73),('5819','2013-10-11','13:25:00',3.34),('5819','2013-10-11','13:30:00',1.42),('5819','2013-10-11','13:40:00',2.4),('5819','2013-10-11','13:45:00',3.36),('5819','2013-10-11','13:50:00',1.03),('5819','2013-10-11','15:35:00',1.05),('5819','2013-10-11','15:40:00',1.17),('5819','2013-10-11','15:45:00',1.34),('5819','2013-10-11','16:00:00',1.74),('5819','2013-10-11','16:30:00',1.02),('5819','2013-10-11','16:35:00',1.27),('5819','2013-10-10','08:50:00',1.4),('5819','2013-10-10','08:55:00',1.84),('5819','2013-10-10','09:00:00',1.28),('5819','2013-10-10','09:10:00',1.73),('5819','2013-10-10','09:15:00',1.95),('5819','2013-10-10','09:20:00',2.02),('5819','2013-10-10','09:25:00',1.98),('5819','2013-10-10','09:30:00',2.01),('5819','2013-10-10','09:35:00',1.82),('5819','2013-10-10','09:40:00',1.89),('5819','2013-10-10','09:45:00',1.77),('5819','2013-10-10','10:15:00',2.06),('5819','2013-10-10','10:20:00',2.73),('5819','2013-10-10','10:25:00',2.67),('5819','2013-10-10','10:30:00',2.71),('5819','2013-10-10','10:35:00',1.09),('5819','2013-10-10','10:45:00',1.93),('5819','2013-10-10','10:50:00',1.08),('5819','2013-10-10','10:55:00',1.25),('5819','2013-10-10','11:25:00',3.15),('5819','2013-10-10','11:30:00',2.42),('5819','2013-10-10','11:45:00',1.29),('5819','2013-10-10','11:50:00',1.49),('5819','2013-10-10','11:55:00',3.16),('5819','2013-10-10','12:00:00',3.42),('5819','2013-10-10','12:05:00',2.37),('5819','2013-10-10','12:10:00',1.37),('5819','2013-10-10','12:25:00',2.81),('5819','2013-10-10','12:30:00',1.57),('5819','2013-10-10','12:35:00',3.38),('5819','2013-10-10','12:40:00',3.83),('5819','2013-10-10','12:45:00',3),('5819','2013-10-10','12:50:00',2.56),('5819','2013-10-10','12:55:00',1.42),('5819','2013-10-10','13:00:00',2.6),('5819','2013-10-10','13:05:00',3.61),('5819','2013-10-10','13:10:00',2.47),('5819','2013-10-10','13:15:00',1.53),('5819','2013-10-10','13:20:00',1.04),('5819','2013-10-10','13:25:00',2.41),('5819','2013-10-10','13:30:00',2.31),('5819','2013-10-10','13:35:00',2.14),('5819','2013-10-10','13:40:00',2.01),('5819','2013-10-10','13:45:00',3.17),('5819','2013-10-10','13:50:00',3.31),('5819','2013-10-10','13:55:00',3.22),('5819','2013-10-10','14:00:00',3.13),('5819','2013-10-10','14:05:00',2.19),('5819','2013-10-10','14:10:00',1.83),('5819','2013-10-10','14:15:00',1.76),('5819','2013-10-10','14:20:00',3.19),('5819','2013-10-10','14:25:00',3.06),('5819','2013-10-10','14:30:00',2.27),('5819','2013-10-10','14:35:00',1.76),('5819','2013-10-10','14:40:00',3.08),('5819','2013-10-10','14:45:00',2.67),('5819','2013-10-10','14:50:00',2.76),('5819','2013-10-10','14:55:00',2.72),('5819','2013-10-10','15:00:00',2.54),('5819','2013-10-10','15:05:00',2.7),('5819','2013-10-10','15:10:00',2.52),('5819','2013-10-10','15:15:00',2.55),('5819','2013-10-10','15:20:00',1.96),('5819','2013-10-10','15:25:00',1.71),('5819','2013-10-10','15:30:00',1.46),('5819','2013-10-10','15:35:00',1.34),('5819','2013-10-10','16:15:00',1.43),('5819','2013-10-10','16:20:00',1.41),('5819','2013-10-10','16:25:00',1.35),('5819','2013-10-10','16:30:00',1.14),('5819','2013-10-10','16:45:00',1.07),('5819','2013-10-09','08:25:00',1.19),('5819','2013-10-09','08:30:00',1.29),('5819','2013-10-09','08:35:00',1.16),('5819','2013-10-09','08:40:00',1.43),('5819','2013-10-09','08:45:00',1.51),('5819','2013-10-09','08:50:00',1.59),('5819','2013-10-09','08:55:00',1.68),('5819','2013-10-09','09:00:00',1.77),('5819','2013-10-09','09:05:00',1.87),('5819','2013-10-09','09:10:00',1.96),('5819','2013-10-09','09:15:00',1.91),('5819','2013-10-09','09:20:00',1.75),('5819','2013-10-09','09:25:00',2.14),('5819','2013-10-09','09:30:00',2.19),('5819','2013-10-09','09:35:00',2.26),('5819','2013-10-09','09:40:00',2.35),('5819','2013-10-09','09:45:00',2.44),('5819','2013-10-09','09:50:00',2.49),('5819','2013-10-09','09:55:00',2.59),('5819','2013-10-09','10:00:00',2.73),('5819','2013-10-09','10:05:00',2.76),('5819','2013-10-09','10:10:00',2.96),('5819','2013-10-09','10:15:00',1.38),('5819','2013-10-09','10:25:00',1.16),('5819','2013-10-09','10:30:00',1.5),('5819','2013-10-09','10:35:00',1.84),('5819','2013-10-09','10:40:00',1.6),('5819','2013-10-09','10:45:00',1.97),('5819','2013-10-09','10:50:00',3.61),('5819','2013-10-09','10:55:00',1.74),('5819','2013-10-09','11:00:00',2.74),('5819','2013-10-09','11:05:00',3.01),('5819','2013-10-09','11:10:00',3.89),('5819','2013-10-09','11:15:00',3.8),('5819','2013-10-09','11:20:00',3.52),('5819','2013-10-09','11:25:00',2.89),('5819','2013-10-09','11:30:00',3.7),('5819','2013-10-09','11:35:00',3.91),('5819','2013-10-09','11:40:00',3.18),('5819','2013-10-09','11:45:00',2.68),('5819','2013-10-09','11:50:00',3.16),('5819','2013-10-09','11:55:00',3.44),('5819','2013-10-09','12:00:00',2.78),('5819','2013-10-09','12:05:00',1.11),('5819','2013-10-09','12:10:00',2.26),('5819','2013-10-09','12:15:00',2.1),('5819','2013-10-09','12:20:00',2.93),('5819','2013-10-09','12:25:00',3.47),('5819','2013-10-09','12:30:00',1.61),('5819','2013-10-09','12:35:00',1.35),('5819','2013-10-09','12:40:00',1.37),('5819','2013-10-09','13:15:00',1.53),('5819','2013-10-09','13:20:00',1.82),('5819','2013-10-09','13:25:00',1.91),('5819','2013-10-09','13:30:00',2.07),('5819','2013-10-09','13:35:00',2.01),('5819','2013-10-09','13:40:00',3.11),('5819','2013-10-09','13:45:00',2.65),('5819','2013-10-09','13:50:00',2.71),('5819','2013-10-09','13:55:00',3.73),('5819','2013-10-09','14:00:00',3.5),('5819','2013-10-09','14:05:00',1.42),('5819','2013-10-09','14:10:00',1.97),('5819','2013-10-09','14:55:00',2.32),('5819','2013-10-09','15:00:00',1.69),('5819','2013-10-09','15:05:00',2.41),('5819','2013-10-09','15:10:00',2.68),('5819','2013-10-09','15:15:00',2.45),('5819','2013-10-09','15:20:00',2.28),('5819','2013-10-09','15:25:00',2.18),('5819','2013-10-09','15:30:00',1.64),('5819','2013-10-09','15:35:00',1.5),('5819','2013-10-09','15:40:00',1.92),('5819','2013-10-09','15:45:00',1.02),('5819','2013-10-09','15:50:00',1.64),('5819','2013-10-09','16:15:00',1.14),('5819','2013-10-09','16:20:00',1.39),('5819','2013-10-09','16:25:00',1.21),('5819','2013-10-09','16:30:00',1.75),('5819','2013-10-09','16:35:00',1.04),('5819','2013-10-09','16:40:00',1.36),('5819','2014-04-15','09:00:00',1.64),('5819','2014-04-15','09:05:00',2.13),('5819','2014-04-15','09:10:00',1.24),('5819','2014-04-15','09:15:00',2.05),('5819','2014-04-15','09:20:00',1.73),('5819','2014-04-15','09:25:00',2.36),('5819','2014-04-15','09:30:00',2.26),('5819','2014-04-15','09:35:00',1.03),('5819','2014-04-15','09:50:00',3.11),('5819','2014-04-15','09:55:00',1.03),('5819','2014-04-15','10:00:00',1.14),('5819','2014-04-15','10:05:00',1.18),('5819','2014-04-15','10:10:00',1.21),('5819','2014-04-15','10:15:00',2.16),('5819','2014-04-15','10:20:00',1.57),('5819','2014-04-15','10:25:00',1.32),('5819','2014-04-15','10:30:00',1.77),('5819','2014-04-15','10:35:00',3.42),('5819','2014-04-15','10:40:00',2),('5819','2014-04-15','10:45:00',2.85),('5819','2014-04-15','10:50:00',2.41),('5819','2014-04-15','10:55:00',1.51),('5819','2014-04-15','11:00:00',1.31),('5819','2014-04-15','11:05:00',3.13),('5819','2014-04-15','11:10:00',3.12),('5819','2014-04-15','11:15:00',1.59),('5819','2014-04-15','11:20:00',1.07),('5819','2014-04-15','11:25:00',1.37),('5819','2014-04-15','11:30:00',1.1),('5819','2014-04-15','11:50:00',1.3),('5819','2014-04-15','11:55:00',1.06),('5819','2014-04-15','12:15:00',1.59),('5819','2014-04-15','12:20:00',1.81),('5819','2014-04-15','13:10:00',1.48),('5819','2014-04-15','13:15:00',1.49),('5819','2014-04-15','13:20:00',2.59),('5819','2014-04-15','13:25:00',1.71),('5819','2014-04-15','13:30:00',2.73),('5819','2014-04-15','13:35:00',2.33),('5819','2014-04-15','13:40:00',2.83),('5819','2014-04-15','13:45:00',1.36),('5819','2014-04-15','14:00:00',1.84),('5819','2014-04-15','14:05:00',2.71),('5819','2014-04-15','14:10:00',1.51),('5819','2014-04-15','14:15:00',3.09),('5819','2014-04-15','14:20:00',2.85),('5819','2014-04-15','14:25:00',3.32),('5819','2014-04-15','14:30:00',2.45),('5819','2014-04-15','14:35:00',2.02),('5819','2014-04-15','14:40:00',1.39),('5819','2014-04-15','14:45:00',1.38),('5819','2014-04-15','14:50:00',1.22),('5819','2014-04-15','14:55:00',1.27),('5819','2014-04-15','15:15:00',1.28),('5819','2014-04-15','15:20:00',1.52),('5819','2014-04-15','15:25:00',2.11),('5819','2014-04-15','15:30:00',1.42),('5819','2014-04-15','15:35:00',1.31),('5819','2014-04-15','15:40:00',1.32),('5819','2014-04-15','15:45:00',1.22),('5819','2014-04-15','15:50:00',1.24),('5819','2014-04-15','15:55:00',1.24),('5819','2014-04-15','16:00:00',1.22),('5819','2014-04-15','16:05:00',1.14),('5819','2013-10-08','08:10:00',1.08),('5819','2013-10-08','08:15:00',1.3),('5819','2013-10-08','08:20:00',1.35),('5819','2013-10-08','10:00:00',1.12),('5819','2013-10-08','11:00:00',1.58),('5819','2013-10-08','11:05:00',1.38),('5819','2013-10-08','11:10:00',2.57),('5819','2013-10-08','11:15:00',3.87),('5819','2013-10-08','11:20:00',3.52),('5819','2013-10-08','11:25:00',1.89),('5819','2013-10-08','11:30:00',2.98),('5819','2013-10-08','11:35:00',2.57),('5819','2013-10-08','11:40:00',1.61),('5819','2013-10-08','11:45:00',1.51),('5819','2013-10-08','11:50:00',1.11),('5819','2013-10-08','12:20:00',1.07),('5819','2013-10-08','12:25:00',1.3),('5819','2013-10-08','12:30:00',3.27),('5819','2013-10-08','12:35:00',1.87),('5819','2013-10-08','12:40:00',4.14),('5819','2013-10-08','12:45:00',3.71),('5819','2013-10-08','12:50:00',3.73),('5819','2013-10-08','12:55:00',3.68),('5819','2013-10-08','13:00:00',3.18),('5819','2013-10-08','13:05:00',3.47),('5819','2013-10-08','13:10:00',2.25),('5819','2013-10-08','13:15:00',3.47),('5819','2013-10-08','13:20:00',1.69),('5819','2013-10-08','13:25:00',2.92),('5819','2013-10-08','13:30:00',1.83),('5819','2013-10-08','13:35:00',1.13),('5819','2013-10-08','13:40:00',1.15),('5819','2013-10-08','14:05:00',1.2),('5819','2013-10-08','14:10:00',1.99),('5819','2013-10-08','14:15:00',2.06),('5819','2013-10-08','14:20:00',2.48),('5819','2013-10-08','14:25:00',2.47),('5819','2013-10-08','14:30:00',2.62),('5819','2013-10-08','14:35:00',1.09),('5819','2013-10-08','14:40:00',1.22),('5819','2013-10-08','14:45:00',2.6),('5819','2013-10-08','14:50:00',2.9),('5819','2013-10-08','14:55:00',2.68),('5819','2013-10-08','15:00:00',2.6),('5819','2013-10-08','15:05:00',2.56),('5819','2013-10-08','15:10:00',2.6),('5819','2013-10-08','15:15:00',2.35),('5819','2013-10-08','15:20:00',2.15),('5819','2013-10-08','15:25:00',1.95),('5819','2013-10-08','15:30:00',2.77),('5819','2013-10-08','15:35:00',2.58),('5819','2013-10-08','15:40:00',2.09),('5819','2013-10-08','15:45:00',1.41),('5819','2013-10-08','15:50:00',1.68),('5819','2013-10-08','15:55:00',1.4),('5819','2013-10-08','16:05:00',1.03),('5819','2013-10-07','08:20:00',1.08),('5819','2013-10-07','08:25:00',1.18),('5819','2013-10-07','08:30:00',1.24),('5819','2013-10-07','08:35:00',1.44),('5819','2013-10-07','08:40:00',1.75),('5819','2013-10-07','09:00:00',1.71),('5819','2013-10-07','09:05:00',2.08),('5819','2013-10-07','09:10:00',1.97),('5819','2013-10-07','09:15:00',2.03),('5819','2013-10-07','09:20:00',2.08),('5819','2013-10-07','09:25:00',2.14),('5819','2013-10-07','09:30:00',2.21),('5819','2013-10-07','09:35:00',2.28),('5819','2013-10-07','09:40:00',2.35),('5819','2013-10-07','09:45:00',2.41),('5819','2013-10-07','09:50:00',2.46),('5819','2013-10-07','09:55:00',2.5),('5819','2013-10-07','10:00:00',2.57),('5819','2013-10-07','10:05:00',2.63),('5819','2013-10-07','10:10:00',2.66),('5819','2013-10-07','10:15:00',2.71),('5819','2013-10-07','10:20:00',2.77),('5819','2013-10-07','10:25:00',2.81),('5819','2013-10-07','10:30:00',2.87),('5819','2013-10-07','10:35:00',2.98),('5819','2013-10-07','10:40:00',2.98),('5819','2013-10-07','10:45:00',3.03),('5819','2013-10-07','10:50:00',3.07),('5819','2013-10-07','10:55:00',2.76),('5819','2013-10-07','11:00:00',2.73),('5819','2013-10-07','11:05:00',3.2),('5819','2013-10-07','11:10:00',2.61),('5819','2013-10-07','11:15:00',2.59),('5819','2013-10-07','11:20:00',3.11),('5819','2013-10-07','11:25:00',3.25),('5819','2013-10-07','11:30:00',3.24),('5819','2013-10-07','11:35:00',3.25),('5819','2013-10-07','11:40:00',3.28),('5819','2013-10-07','11:45:00',3.27),('5819','2013-10-07','11:50:00',3.27),('5819','2013-10-07','11:55:00',3.32),('5819','2013-10-07','12:00:00',3.3),('5819','2013-10-07','12:05:00',2.78),('5819','2013-10-07','12:10:00',3.57),('5819','2013-10-07','12:15:00',2.78),('5819','2013-10-07','12:20:00',2.56),('5819','2013-10-07','12:25:00',3.41),('5819','2013-10-07','12:30:00',3.7),('5819','2013-10-07','12:35:00',3.42),('5819','2013-10-07','12:40:00',3.57),('5819','2013-10-07','12:45:00',3.56),('5819','2013-10-07','12:50:00',3.54),('5819','2013-10-07','12:55:00',3.59),('5819','2013-10-07','13:00:00',3.15),('5819','2013-10-07','13:05:00',3.49),('5819','2013-10-07','13:10:00',3.49),('5819','2013-10-07','13:15:00',2.26),('5819','2013-10-07','13:20:00',3.09),('5819','2013-10-07','13:25:00',3.21),('5819','2013-10-07','13:30:00',3.44),('5819','2013-10-07','13:35:00',1.18),('5819','2013-10-07','13:40:00',1.55),('5819','2013-10-07','13:45:00',1.53),('5819','2013-10-07','13:50:00',2.38),('5819','2013-10-07','13:55:00',3.51),('5819','2013-10-07','14:00:00',3.83),('5819','2013-10-07','14:05:00',2.17),('5819','2013-10-07','14:10:00',1.46),('5819','2013-10-07','14:20:00',1.07),('5819','2013-10-07','14:25:00',2.79),('5819','2013-10-07','14:35:00',1.7),('5819','2013-10-07','14:40:00',1.93),('5819','2013-10-07','14:45:00',2.67),('5819','2013-10-07','14:50:00',3.16),('5819','2013-10-07','14:55:00',3.16),('5819','2013-10-07','15:00:00',2.32),('5819','2013-10-07','15:05:00',1.57),('5819','2013-10-07','15:10:00',2.4),('5819','2013-10-07','15:25:00',1.82),('5819','2013-10-07','15:30:00',1.68),('5819','2013-10-07','15:35:00',1.28),('5819','2013-10-07','15:40:00',1.66),('5819','2013-10-07','15:45:00',2.12),('5819','2013-10-07','15:50:00',1.56),('5819','2013-10-07','15:55:00',2.33),('5819','2013-10-07','16:10:00',1.45),('5819','2013-10-07','16:15:00',1.78),('5819','2013-10-07','16:20:00',1.67),('5819','2013-10-07','16:25:00',1.28),('5819','2013-10-07','16:30:00',1.49),('5819','2013-10-07','16:35:00',1.2),('5819','2013-10-07','16:40:00',1.32),('5819','2013-10-07','16:45:00',1.24),('5819','2013-10-07','16:50:00',1.14),('5819','2013-10-07','16:55:00',1.02),('5819','2013-10-06','09:05:00',1.07),('5819','2013-10-06','09:10:00',1.04),('5819','2013-10-06','09:30:00',1.16),('5819','2013-10-06','09:35:00',1.63),('5819','2013-10-06','09:40:00',1.47),('5819','2013-10-06','09:45:00',1.14),('5819','2013-10-06','09:50:00',2.14),('5819','2013-10-06','09:55:00',2.53),('5819','2013-10-06','10:00:00',2.93),('5819','2013-10-06','10:05:00',2.99),('5819','2013-10-06','10:10:00',2.91),('5819','2013-10-06','10:15:00',2.69),('5819','2013-10-06','10:20:00',2.69),('5819','2013-10-06','10:25:00',3),('5819','2013-10-06','10:30:00',2.91),('5819','2013-10-06','10:35:00',2.88),('5819','2013-10-06','10:40:00',2.46),('5819','2013-10-06','10:45:00',1.99),('5819','2013-10-06','10:50:00',2.19),('5819','2013-10-06','10:55:00',2.42),('5819','2013-10-06','11:00:00',2.47),('5819','2013-10-06','11:05:00',2.73),('5819','2013-10-06','11:10:00',2.85),('5819','2013-10-06','11:15:00',2.72),('5819','2013-10-06','11:20:00',2.74),('5819','2013-10-06','11:25:00',2.9),('5819','2013-10-06','11:30:00',2.81),('5819','2013-10-06','11:35:00',2.76),('5819','2013-10-06','11:40:00',2.39),('5819','2013-10-06','11:45:00',1.8),('5819','2013-10-06','11:50:00',1.93),('5819','2013-10-06','11:55:00',2.53),('5819','2013-10-06','12:00:00',2.6),('5819','2013-10-06','12:05:00',2.6),('5819','2013-10-06','12:10:00',3.23),('5819','2013-10-06','12:15:00',3.11),('5819','2013-10-06','12:20:00',2.7),('5819','2013-10-06','12:25:00',2.33),('5819','2013-10-06','12:30:00',2.38),('5819','2013-10-06','12:35:00',2.59),('5819','2013-10-06','12:40:00',2.18),('5819','2013-10-06','12:45:00',2.17),('5819','2013-10-06','12:50:00',2.58),('5819','2013-10-06','12:55:00',3.07),('5819','2013-10-06','13:00:00',3.16),('5819','2013-10-06','13:05:00',3.01),('5819','2013-10-06','13:10:00',2.34),('5819','2013-10-06','13:15:00',1.39),('5819','2013-10-06','13:20:00',2.85),('5819','2013-10-06','13:25:00',1.12),('5819','2013-10-06','13:50:00',3.07),('5819','2013-10-06','13:55:00',2.06),('5819','2013-10-06','14:00:00',1.65),('5819','2013-10-06','14:05:00',3.1),('5819','2013-10-06','14:10:00',3.18),('5819','2013-10-06','14:15:00',2.19),('5819','2013-10-06','14:20:00',1.79),('5819','2013-10-06','14:25:00',1.51),('5819','2013-10-06','14:30:00',1.6),('5819','2013-10-06','14:35:00',1.39),('5819','2013-10-06','14:40:00',1.19),('5819','2013-10-06','14:45:00',1.39),('5819','2013-10-06','14:50:00',1.66),('5819','2013-10-06','14:55:00',2.22),('5819','2013-10-06','15:00:00',1.93),('5819','2013-10-06','15:05:00',1.43),('5819','2013-10-06','15:10:00',1.2),('5819','2013-10-06','15:15:00',1.04),('5819','2013-10-05','16:05:00',1.03),('5819','2013-10-05','16:10:00',1.05),('5819','2013-10-04','09:30:00',1.03),('5819','2013-10-04','09:35:00',1.01),('5819','2013-10-04','09:40:00',1.09),('5819','2013-10-04','09:45:00',1.04),('5819','2013-10-04','09:50:00',1.25),('5819','2013-10-04','09:55:00',2.71),('5819','2013-10-04','10:00:00',2.14),('5819','2013-10-04','10:05:00',1.58),('5819','2013-10-04','10:10:00',1.51),('5819','2013-10-04','10:15:00',1.83),('5819','2013-10-04','10:20:00',1.43),('5819','2013-10-04','10:25:00',2.3),('5819','2013-10-04','10:30:00',1.96),('5819','2013-10-04','10:35:00',1.53),('5819','2013-10-04','10:40:00',2.79),('5819','2013-10-04','10:45:00',2.39),('5819','2013-10-04','10:50:00',1.69),('5819','2013-10-04','10:55:00',2.65),('5819','2013-10-04','11:00:00',2.38),('5819','2013-10-04','11:05:00',1.72),('5819','2013-10-04','11:10:00',1.58),('5819','2013-10-04','11:15:00',3.42),('5819','2013-10-04','11:20:00',2.86),('5819','2013-10-04','11:25:00',2.97),('5819','2013-10-04','11:30:00',3.71),('5819','2013-10-04','11:35:00',3.63),('5819','2013-10-04','11:40:00',3.57),('5819','2013-10-04','11:45:00',3.49),('5819','2013-10-04','11:50:00',3.43),('5819','2013-10-04','11:55:00',3.41),('5819','2013-10-04','12:00:00',3.42),('5819','2013-10-04','12:05:00',3.42),('5819','2013-10-04','12:10:00',3.46),('5819','2013-10-04','12:15:00',3.18),('5819','2013-10-04','12:20:00',3.29),('5819','2013-10-04','12:25:00',3.5),('5819','2013-10-04','12:30:00',3.23),('5819','2013-10-04','12:35:00',3.07),('5819','2013-10-04','12:40:00',3.39),('5819','2013-10-04','12:45:00',3.38),('5819','2013-10-04','12:50:00',3.25),('5819','2013-10-04','12:55:00',3.27),('5819','2013-10-04','13:00:00',3.29),('5819','2013-10-04','13:05:00',3.32),('5819','2013-10-04','13:10:00',3.33),('5819','2013-10-04','13:15:00',3.56),('5819','2013-10-04','13:20:00',3.41),('5819','2013-10-04','13:25:00',3.18),('5819','2013-10-04','13:30:00',3.37),('5819','2013-10-04','13:35:00',2.38),('5819','2013-10-04','13:40:00',3.19),('5819','2013-10-04','13:45:00',3.12),('5819','2013-10-04','13:50:00',3.07),('5819','2013-10-04','13:55:00',3.05),('5819','2013-10-04','14:00:00',3.03),('5819','2013-10-04','14:05:00',2.98),('5819','2013-10-04','14:10:00',2.75),('5819','2013-10-04','14:15:00',2.48),('5819','2013-10-04','14:20:00',2.57),('5819','2013-10-04','14:25:00',2.83),('5819','2013-10-04','14:30:00',2.45),('5819','2013-10-04','14:35:00',1.77),('5819','2013-10-04','14:40:00',1.47),('5819','2013-10-04','14:45:00',1.6),('5819','2013-10-04','14:50:00',2.14),('5819','2013-10-04','14:55:00',2.21),('5819','2013-10-04','15:00:00',1.91),('5819','2013-10-04','15:05:00',2.11),('5819','2013-10-04','15:10:00',1.85),('5819','2013-10-04','15:15:00',1.46),('5819','2013-10-04','15:20:00',1.26),('5819','2013-10-04','15:25:00',1.83),('5819','2013-10-04','15:30:00',2.23),('5819','2013-10-04','15:35:00',1.41),('5819','2013-10-03','08:15:00',1.14),('5819','2013-10-03','08:20:00',1.25),('5819','2013-10-03','08:25:00',1.32),('5819','2013-10-03','08:30:00',1.42),('5819','2013-10-03','08:35:00',1.51),('5819','2013-10-03','08:40:00',1.6),('5819','2013-10-03','08:45:00',1.7),('5819','2013-10-03','08:50:00',1.79),('5819','2013-10-03','08:55:00',1.88),('5819','2013-10-03','09:00:00',1.96),('5819','2013-10-03','09:05:00',2.04),('5819','2013-10-03','09:10:00',2.13),('5819','2013-10-03','09:15:00',2.21),('5819','2013-10-03','09:20:00',2.29),('5819','2013-10-03','09:25:00',2.36),('5819','2013-10-03','09:30:00',2.43),('5819','2013-10-03','09:35:00',2.51),('5819','2013-10-03','09:40:00',2.58),('5819','2013-10-03','09:45:00',2.65),('5819','2013-10-03','09:50:00',2.71),('5819','2013-10-03','09:55:00',2.77),('5819','2013-10-03','10:00:00',2.84),('5819','2013-10-03','10:05:00',2.91),('5819','2013-10-03','10:10:00',2.95),('5819','2013-10-03','10:15:00',3.01),('5819','2013-10-03','10:20:00',3.06),('5819','2013-10-03','10:25:00',3.1),('5819','2013-10-03','10:30:00',3.15),('5819','2013-10-03','10:35:00',3.19),('5819','2013-10-03','10:40:00',3.23),('5819','2013-10-03','10:45:00',3.29),('5819','2013-10-03','10:50:00',3.3),('5819','2013-10-03','10:55:00',3.34),('5819','2013-10-03','11:00:00',3.37),('5819','2013-10-03','11:05:00',3.4),('5819','2013-10-03','11:10:00',3.43),('5819','2013-10-03','11:15:00',3.45),('5819','2013-10-03','11:20:00',3.48),('5819','2013-10-03','11:25:00',3.5),('5819','2013-10-03','11:30:00',3.5),('5819','2013-10-03','11:35:00',3.55),('5819','2013-10-03','11:40:00',3.57),('5819','2013-10-03','11:45:00',3.58),('5819','2013-10-03','11:50:00',3.61),('5819','2013-10-03','11:55:00',3.63),('5819','2013-10-03','12:00:00',3.62),('5819','2013-10-03','12:05:00',3.63),('5819','2013-10-03','12:10:00',3.62),('5819','2013-10-03','12:15:00',3.59),('5819','2013-10-03','12:20:00',3.58),('5819','2013-10-03','12:25:00',3.61),('5819','2013-10-03','12:30:00',3.63),('5819','2013-10-03','12:35:00',3.62),('5819','2013-10-03','12:40:00',3.6),('5819','2013-10-03','12:45:00',3.59),('5819','2013-10-03','12:50:00',3.58),('5819','2013-10-03','12:55:00',3.57),('5819','2013-10-03','13:00:00',3.54),('5819','2013-10-03','13:05:00',3.48),('5819','2013-10-03','13:10:00',3.49),('5819','2013-10-03','13:15:00',3.46),('5819','2013-10-03','13:20:00',3.46),('5819','2013-10-03','13:25:00',3.43),('5819','2013-10-03','13:30:00',3.42),('5819','2013-10-03','13:35:00',3.4),('5819','2013-10-03','13:40:00',3.37),('5819','2013-10-03','13:45:00',3.33),('5819','2013-10-03','13:50:00',3.3),('5819','2013-10-03','13:55:00',3.29),('5819','2013-10-03','14:00:00',3.26),('5819','2013-10-03','14:05:00',3.23),('5819','2013-10-03','14:10:00',3.19),('5819','2013-10-03','14:15:00',3.13),('5819','2013-10-03','14:20:00',3.1),('5819','2013-10-03','14:25:00',3.05),('5819','2013-10-03','14:30:00',3.01),('5819','2013-10-03','14:35:00',2.95),('5819','2013-10-03','14:40:00',2.9),('5819','2013-10-03','14:45:00',2.85),('5819','2013-10-03','14:50:00',2.8),('5819','2013-10-03','14:55:00',2.75),('5819','2013-10-03','15:00:00',2.69),('5819','2013-10-03','15:05:00',2.63),('5819','2013-10-03','15:10:00',2.56),('5819','2013-10-03','15:15:00',2.51),('5819','2013-10-03','15:20:00',2.44),('5819','2013-10-03','15:25:00',2.38),('5819','2013-10-03','15:30:00',2.3),('5819','2013-10-03','15:35:00',2.23),('5819','2013-10-03','15:40:00',2.16),('5819','2013-10-03','15:45:00',2.09),('5819','2013-10-03','15:50:00',2.03),('5819','2013-10-03','15:55:00',1.94),('5819','2013-10-03','16:00:00',1.87),('5819','2013-10-03','16:05:00',1.78),('5819','2013-10-03','16:10:00',1.71),('5819','2013-10-03','16:15:00',1.63),('5819','2013-10-03','16:20:00',1.55),('5819','2013-10-03','16:25:00',1.47),('5819','2013-10-03','16:30:00',1.4),('5819','2013-10-03','16:35:00',1.31),('5819','2013-10-03','16:40:00',1.23),('5819','2013-10-03','16:45:00',1.16),('5819','2013-10-03','16:50:00',1.09),('5819','2013-10-03','16:55:00',1.01),('5819','2013-10-02','08:15:00',1.03),('5819','2013-10-02','08:20:00',1.31),('5819','2013-10-02','08:30:00',1.2),('5819','2013-10-02','08:35:00',1.39),('5819','2013-10-02','08:40:00',1.47),('5819','2013-10-02','08:45:00',1.56),('5819','2013-10-02','08:50:00',1.68),('5819','2013-10-02','08:55:00',1.77),('5819','2013-10-02','09:00:00',1.86),('5819','2013-10-02','09:05:00',1.93),('5819','2013-10-02','09:10:00',2.01),('5819','2013-10-02','09:15:00',2.1),('5819','2013-10-02','09:20:00',2.17),('5819','2013-10-02','09:25:00',2.24),('5819','2013-10-02','09:30:00',2.32),('5819','2013-10-02','09:35:00',2.38),('5819','2013-10-02','09:40:00',2.44),('5819','2013-10-02','09:45:00',2.5),('5819','2013-10-02','09:50:00',2.56),('5819','2013-10-02','09:55:00',2.61),('5819','2013-10-02','10:00:00',2.66),('5819','2013-10-02','10:05:00',2.71),('5819','2013-10-02','10:10:00',2.76),('5819','2013-10-02','10:15:00',2.8),('5819','2013-10-02','10:20:00',2.86),('5819','2013-10-02','10:25:00',2.92),('5819','2013-10-02','10:30:00',2.97),('5819','2013-10-02','10:35:00',3.03),('5819','2013-10-02','10:40:00',3.08),('5819','2013-10-02','10:45:00',3.12),('5819','2013-10-02','10:50:00',3.17),('5819','2013-10-02','10:55:00',3.2),('5819','2013-10-02','11:00:00',3.25),('5819','2013-10-02','11:05:00',3.27),('5819','2013-10-02','11:10:00',3.31),('5819','2013-10-02','11:15:00',3.32),('5819','2013-10-02','11:20:00',3.36),('5819','2013-10-02','11:25:00',3.37),('5819','2013-10-02','11:30:00',3.38),('5819','2013-10-02','11:35:00',3.4),('5819','2013-10-02','11:40:00',3.42),('5819','2013-10-02','11:45:00',3.45),('5819','2013-10-02','11:50:00',3.46),('5819','2013-10-02','11:55:00',3.46),('5819','2013-10-02','12:00:00',3.48),('5819','2013-10-02','12:05:00',3.47),('5819','2013-10-02','12:10:00',3.49),('5819','2013-10-02','12:15:00',3.49),('5819','2013-10-02','12:20:00',3.49),('5819','2013-10-02','12:25:00',3.47),('5819','2013-10-02','12:30:00',3.47),('5819','2013-10-02','12:35:00',3.47),('5819','2013-10-02','12:40:00',3.45),('5819','2013-10-02','12:45:00',3.46),('5819','2013-10-02','12:50:00',3.47),('5819','2013-10-02','12:55:00',3.45),('5819','2013-10-02','13:00:00',3.44),('5819','2013-10-02','13:05:00',3.42),('5819','2013-10-02','13:10:00',3.4),('5819','2013-10-02','13:15:00',3.38),('5819','2013-10-02','13:20:00',3.37),('5819','2013-10-02','13:25:00',3.37),('5819','2013-10-02','13:30:00',3.34),('5819','2013-10-02','13:35:00',3.31),('5819','2013-10-02','13:40:00',3.3),('5819','2013-10-02','13:45:00',3.28),('5819','2013-10-02','13:50:00',3.25),('5819','2013-10-02','13:55:00',3.2),('5819','2013-10-02','14:00:00',3.17),('5819','2013-10-02','14:05:00',3.13),('5819','2013-10-02','14:10:00',3.09),('5819','2013-10-02','14:15:00',3.07),('5819','2013-10-02','14:20:00',3.01),('5819','2013-10-02','14:25:00',2.97),('5819','2013-10-02','14:30:00',2.93),('5819','2013-10-02','14:35:00',2.9),('5819','2013-10-02','14:40:00',2.84),('5819','2013-10-02','14:45:00',2.79),('5819','2013-10-02','14:50:00',2.74),('5819','2013-10-02','14:55:00',2.7),('5819','2013-10-02','15:00:00',2.64),('5819','2013-10-02','15:05:00',2.58),('5819','2013-10-02','15:10:00',2.51),('5819','2013-10-02','15:15:00',2.46),('5819','2013-10-02','15:20:00',2.4),('5819','2013-10-02','15:25:00',2.33),('5819','2013-10-02','15:30:00',2.26),('5819','2013-10-02','15:35:00',2.2),('5819','2013-10-02','15:40:00',2.14),('5819','2013-10-02','15:45:00',2.07),('5819','2013-10-02','15:50:00',1.99),('5819','2013-10-02','15:55:00',1.9),('5819','2013-10-02','16:00:00',1.84),('5819','2013-10-02','16:05:00',1.76),('5819','2013-10-02','16:10:00',1.68),('5819','2013-10-02','16:15:00',1.61),('5819','2013-10-02','16:20:00',1.53),('5819','2013-10-02','16:25:00',1.45),('5819','2013-10-02','16:30:00',1.38),('5819','2013-10-02','16:35:00',1.3),('5819','2013-10-02','16:40:00',1.22),('5819','2013-10-02','16:45:00',1.14),('5819','2013-10-02','16:50:00',1.07),('5819','2013-10-01','08:40:00',1.4),('5819','2013-10-01','08:45:00',1.62),('5819','2013-10-01','08:50:00',1.72),('5819','2013-10-01','08:55:00',1.8),('5819','2013-10-01','09:00:00',1.88),('5819','2013-10-01','09:05:00',1.95),('5819','2013-10-01','09:10:00',2.02),('5819','2013-10-01','09:15:00',2.08),('5819','2013-10-01','09:20:00',2.14),('5819','2013-10-01','09:25:00',2.19),('5819','2013-10-01','09:30:00',2.27),('5819','2013-10-01','09:35:00',2.31),('5819','2013-10-01','09:40:00',2.37),('5819','2013-10-01','09:45:00',2.44),('5819','2013-10-01','09:50:00',2.5),('5819','2013-10-01','09:55:00',2.56),('5819','2013-10-01','10:00:00',2.61),('5819','2013-10-01','10:05:00',2.66),('5819','2013-10-01','10:10:00',2.71),('5819','2013-10-01','10:15:00',2.76),('5819','2013-10-01','10:20:00',2.82),('5819','2013-10-01','10:25:00',2.87),('5819','2013-10-01','10:30:00',2.93),('5819','2013-10-01','10:35:00',2.97),('5819','2013-10-01','10:40:00',3),('5819','2013-10-01','10:45:00',3.03),('5819','2013-10-01','10:50:00',3.06),('5819','2013-10-01','10:55:00',3.08),('5819','2013-10-01','11:00:00',3.15),('5819','2013-10-01','11:05:00',1.88),('5819','2013-10-01','11:10:00',3.47),('5819','2013-10-01','11:15:00',2.48),('5819','2013-10-01','11:20:00',3.28),('5819','2013-10-01','11:25:00',2.59),('5819','2013-10-01','11:30:00',3.43),('5819','2013-10-01','11:35:00',2.61),('5819','2013-10-01','11:40:00',3.52),('5819','2013-10-01','11:45:00',3.58),('5819','2013-10-01','11:50:00',3.59),('5819','2013-10-01','11:55:00',3.58),('5819','2013-10-01','12:00:00',3.16),('5819','2013-10-01','12:10:00',2.75),('5819','2013-10-01','12:15:00',3.46),('5819','2013-10-01','12:20:00',3.61),('5819','2013-10-01','12:25:00',3.49),('5819','2013-10-01','12:30:00',3.69),('5819','2013-10-01','12:35:00',3.71),('5819','2013-10-01','12:40:00',2.55),('5819','2013-10-01','12:45:00',3.04),('5819','2013-10-01','12:50:00',3.54),('5819','2013-10-01','12:55:00',3.47),('5819','2013-10-01','13:00:00',3.19),('5819','2013-10-01','13:05:00',3.53),('5819','2013-10-01','13:10:00',1.44),('5819','2013-10-01','13:15:00',1.16),('5819','2013-10-01','13:20:00',3.68),('5819','2013-10-01','13:25:00',3.68),('5819','2013-10-01','13:30:00',2.74),('5819','2013-10-01','13:35:00',3.15),('5819','2013-10-01','13:40:00',1.6),('5819','2013-10-01','13:45:00',2.5),('5819','2013-10-01','13:55:00',1.68),('5819','2013-10-01','14:00:00',3.28),('5819','2013-10-01','14:05:00',3.14),('5819','2013-10-01','14:10:00',3.08),('5819','2013-10-01','14:15:00',3.03),('5819','2013-10-01','14:20:00',2.99),('5819','2013-10-01','14:25:00',2.95),('5819','2013-10-01','14:30:00',2.91),('5819','2013-10-01','14:35:00',2.87),('5819','2013-10-01','14:40:00',2.86),('5819','2013-10-01','14:45:00',2.85),('5819','2013-10-01','14:50:00',2.84),('5819','2013-10-01','14:55:00',2.79),('5819','2013-10-01','15:00:00',2.75),('5819','2013-10-01','15:05:00',2.6),('5819','2013-10-01','15:10:00',2.51),('5819','2013-10-01','15:15:00',2.45),('5819','2013-10-01','15:20:00',2.4),('5819','2013-10-01','15:25:00',2.33),('5819','2013-10-01','15:30:00',2.27),('5819','2013-10-01','15:35:00',2.2),('5819','2013-10-01','15:40:00',2.13),('5819','2013-10-01','15:45:00',2.06),('5819','2013-10-01','15:50:00',2),('5819','2013-10-01','15:55:00',1.93),('5819','2013-10-01','16:00:00',1.84),('5819','2013-10-01','16:05:00',1.77),('5819','2013-10-01','16:10:00',1.69),('5819','2013-10-01','16:15:00',1.62),('5819','2013-10-01','16:20:00',1.55),('5819','2013-10-01','16:25:00',1.47),('5819','2013-10-01','16:30:00',1.38),('5819','2013-10-01','16:35:00',1.3),('5819','2013-10-01','16:40:00',1.23),('5819','2013-10-01','16:45:00',1.15),('5819','2013-10-01','16:50:00',1.07),('5819','2013-10-01','16:55:00',1.01),('5819','2013-09-30','09:50:00',1.25),('5819','2013-09-30','09:55:00',1.06),('5819','2013-09-30','10:15:00',1.03),('5819','2013-09-30','10:20:00',1.04),('5819','2013-09-30','10:25:00',1.27),('5819','2013-09-30','10:30:00',1.47),('5819','2013-09-30','10:35:00',1.71),('5819','2013-09-30','10:40:00',2.13),('5819','2013-09-30','10:45:00',3.22),('5819','2013-09-30','10:50:00',3.37),('5819','2013-09-30','10:55:00',3.07),('5819','2013-09-30','11:00:00',2.74),('5819','2013-09-30','11:05:00',3.08),('5819','2013-09-30','11:10:00',3.16),('5819','2013-09-30','11:15:00',2.56),('5819','2013-09-30','11:20:00',2.4),('5819','2013-09-30','11:25:00',3.01),('5819','2013-09-30','11:30:00',1.61),('5819','2013-09-30','11:35:00',1.76),('5819','2013-09-30','11:40:00',3.12),('5819','2013-09-30','11:45:00',1.98),('5819','2013-09-30','11:50:00',1.76),('5819','2013-09-30','11:55:00',1.47),('5819','2013-09-30','12:00:00',1.7),('5819','2013-09-30','12:05:00',2.83),('5819','2013-09-30','12:10:00',2.55),('5819','2013-09-30','12:15:00',3.66),('5819','2013-09-30','12:20:00',3.78),('5819','2013-09-30','12:25:00',3.81),('5819','2013-09-30','12:30:00',3.61),('5819','2013-09-30','12:35:00',3.55),('5819','2013-09-30','12:40:00',3.61),('5819','2013-09-30','12:45:00',2.77),('5819','2013-09-30','12:50:00',3.68),('5819','2013-09-30','12:55:00',3.59),('5819','2013-09-30','13:00:00',3.57),('5819','2013-09-30','13:05:00',2.81),('5819','2013-09-30','13:10:00',3.72),('5819','2013-09-30','13:15:00',3.21),('5819','2013-09-30','13:20:00',3.85),('5819','2013-09-30','13:25:00',4.04),('5819','2013-09-30','13:30:00',4.04),('5819','2013-09-30','13:35:00',3.15),('5819','2013-09-30','13:40:00',2.37),('5819','2013-09-30','13:45:00',1.56),('5819','2013-09-30','13:50:00',2.75),('5819','2013-09-30','13:55:00',2.17),('5819','2013-09-30','14:00:00',1.25),('5819','2013-09-30','14:05:00',1.25),('5819','2013-09-30','14:10:00',1.24),('5819','2013-09-30','14:15:00',1.18),('5819','2013-09-30','14:25:00',1.06),('5819','2013-09-30','14:30:00',2.08),('5819','2013-09-30','14:35:00',2.69),('5819','2013-09-30','14:40:00',3.5),('5819','2013-09-30','14:45:00',2.41),('5819','2013-09-30','14:50:00',2.99),('5819','2013-09-30','14:55:00',1.86),('5819','2013-09-30','15:00:00',2.5),('5819','2013-09-30','15:05:00',1.99),('5819','2013-09-30','15:10:00',2.43),('5819','2013-09-30','15:15:00',1.74),('5819','2013-09-30','15:25:00',2.65),('5819','2013-09-30','15:30:00',1.91),('5819','2013-09-30','15:35:00',1.68),('5819','2013-09-30','15:40:00',2.65),('5819','2013-09-30','15:45:00',1.54),('5819','2013-09-30','16:10:00',1.22),('5819','2013-09-30','16:15:00',1.48),('5819','2013-09-30','16:20:00',1.08),('5819','2013-09-30','16:45:00',1.16),('5819','2013-09-29','08:50:00',1.19),('5819','2013-09-29','08:55:00',1.09),('5819','2013-09-29','09:15:00',1.28),('5819','2013-09-29','09:55:00',1.02),('5819','2013-09-29','10:00:00',1.23),('5819','2013-09-29','10:05:00',1.72),('5819','2013-09-29','10:10:00',1.95),('5819','2013-09-29','10:15:00',2.51),('5819','2013-09-29','10:20:00',2.19),('5819','2013-09-29','10:25:00',2.01),('5819','2013-09-29','10:30:00',2.36),('5819','2013-09-29','10:35:00',2.59),('5819','2013-09-29','10:40:00',2.82),('5819','2013-09-29','10:45:00',2.67),('5819','2013-09-29','10:50:00',2.8),('5819','2013-09-29','10:55:00',2.75),('5819','2013-09-29','11:00:00',2.81),('5819','2013-09-29','11:05:00',2.7),('5819','2013-09-29','11:10:00',2.68),('5819','2013-09-29','11:15:00',2.88),('5819','2013-09-29','11:20:00',2.89),('5819','2013-09-29','11:25:00',2.73),('5819','2013-09-29','11:30:00',2.91),('5819','2013-09-29','11:35:00',2.89),('5819','2013-09-29','11:40:00',2.98),('5819','2013-09-29','11:45:00',2.97),('5819','2013-09-29','11:50:00',3.17),('5819','2013-09-29','11:55:00',3.14),('5819','2013-09-29','12:00:00',2.92),('5819','2013-09-29','12:05:00',3.13),('5819','2013-09-29','12:10:00',3.1),('5819','2013-09-29','12:15:00',3.32),('5819','2013-09-29','12:20:00',2.84),('5819','2013-09-29','12:25:00',1.89),('5819','2013-09-29','12:30:00',1.95),('5819','2013-09-29','12:35:00',1.84),('5819','2013-09-29','12:40:00',1.59),('5819','2013-09-29','12:45:00',1.39),('5819','2013-09-29','12:50:00',1.42),('5819','2013-09-29','12:55:00',1.2),('5819','2013-09-29','13:00:00',1.21),('5819','2013-09-29','13:05:00',1.01),('5819','2013-09-29','13:10:00',1.23),('5819','2013-09-29','13:25:00',1.2),('5819','2013-09-29','13:30:00',2.19),('5819','2013-09-29','13:35:00',1.5),('5819','2013-09-29','13:40:00',1.5),('5819','2013-09-29','13:45:00',1.4),('5819','2013-09-29','13:50:00',1.44),('5819','2013-09-29','13:55:00',2.02),('5819','2013-09-29','14:00:00',1.81),('5819','2013-09-29','14:05:00',2.17),('5819','2013-09-29','14:10:00',1.52),('5819','2013-09-29','14:15:00',1.54),('5819','2013-09-29','14:20:00',2.07),('5819','2013-09-29','14:25:00',1.42),('5819','2013-09-29','14:30:00',1.08),('5819','2013-09-29','14:35:00',1.1),('5819','2013-09-29','15:00:00',1.27),('5819','2013-09-29','16:00:00',1.05),('5819','2013-09-28','08:20:00',1.08),('5819','2013-09-28','08:25:00',1.04),('5819','2013-09-28','08:30:00',1),('5819','2013-09-28','08:35:00',1.29),('5819','2013-09-28','08:40:00',1.38),('5819','2013-09-28','08:45:00',1.46),('5819','2013-09-28','08:50:00',1.52),('5819','2013-09-28','08:55:00',1.61),('5819','2013-09-28','09:00:00',1.66),('5819','2013-09-28','09:05:00',1.75),('5819','2013-09-28','09:10:00',1.85),('5819','2013-09-28','09:15:00',1.95),('5819','2013-09-28','09:20:00',2.01),('5819','2013-09-28','09:25:00',2.1),('5819','2013-09-28','09:30:00',2.18),('5819','2013-09-28','09:35:00',2.24),('5819','2013-09-28','09:40:00',2.32),('5819','2013-09-28','09:45:00',2.39),('5819','2013-09-28','09:50:00',2.47),('5819','2013-09-28','09:55:00',2.58),('5819','2013-09-28','10:00:00',1.51),('5819','2013-09-28','10:05:00',1.66),('5819','2013-09-28','10:10:00',1.64),('5819','2013-09-28','10:15:00',1.11),('5819','2013-09-28','10:25:00',1.13),('5819','2013-09-28','10:30:00',1.05),('5819','2013-09-28','10:35:00',2.63),('5819','2013-09-28','10:40:00',2.25),('5819','2013-09-28','10:45:00',2.68),('5819','2013-09-28','10:50:00',3.04),('5819','2013-09-28','10:55:00',3.38),('5819','2013-09-28','11:00:00',1.71),('5819','2013-09-28','11:15:00',1.52),('5819','2013-09-28','11:20:00',2.33),('5819','2013-09-28','11:25:00',3.49),('5819','2013-09-28','11:30:00',3.61),('5819','2013-09-28','11:35:00',3),('5819','2013-09-28','11:40:00',2.05),('5819','2013-09-28','11:45:00',1.4),('5819','2013-09-28','11:50:00',1.09),('5819','2013-09-28','11:55:00',1.35),('5819','2013-09-28','12:00:00',1.29),('5819','2013-09-28','12:05:00',3.38),('5819','2013-09-28','12:10:00',3.65),('5819','2013-09-28','12:15:00',2.89),('5819','2013-09-28','12:20:00',1.7),('5819','2013-09-28','12:25:00',3.47),('5819','2013-09-28','12:30:00',1.08),('5819','2013-09-28','12:35:00',2.02),('5819','2013-09-28','12:40:00',3.08),('5819','2013-09-28','12:45:00',1.3),('5819','2013-09-28','12:50:00',2.69),('5819','2013-09-28','12:55:00',3.6),('5819','2013-09-28','13:00:00',1.55),('5819','2013-09-28','13:05:00',3.41),('5819','2013-09-28','13:10:00',1.21),('5819','2013-09-28','13:15:00',1.17),('5819','2013-09-28','13:20:00',1.24),('5819','2013-09-28','13:25:00',1.36),('5819','2013-09-28','13:30:00',2.92),('5819','2013-09-28','13:35:00',1.62),('5819','2013-09-28','13:40:00',1.3),('5819','2013-09-28','13:45:00',1.48),('5819','2013-09-28','13:50:00',1.99),('5819','2013-09-28','13:55:00',1.31),('5819','2013-09-28','14:00:00',1.28),('5819','2013-09-28','14:05:00',1.2),('5819','2013-09-28','14:10:00',1.2),('5819','2013-09-28','14:15:00',1.39),('5819','2013-09-28','14:20:00',1.86),('5819','2013-09-28','14:25:00',3.49),('5819','2013-09-28','14:30:00',2.56),('5819','2013-09-28','14:35:00',2.12),('5819','2013-09-28','14:40:00',3.25),('5819','2013-09-28','14:45:00',3.09),('5819','2013-09-28','14:50:00',2.79),('5819','2013-09-28','14:55:00',1.14),('5819','2013-09-28','15:00:00',2.49),('5819','2013-09-28','15:05:00',2.87),('5819','2013-09-28','15:10:00',1.97),('5819','2013-09-28','15:15:00',2.82),('5819','2013-09-28','15:20:00',2.6),('5819','2013-09-28','15:25:00',2.75),('5819','2013-09-28','15:30:00',2.7),('5819','2013-09-28','15:35:00',2.47),('5819','2013-09-28','15:40:00',2.44),('5819','2013-09-28','15:45:00',2.2),('5819','2013-09-28','15:50:00',1.31),('5819','2013-09-28','15:55:00',1.54),('5819','2013-09-28','16:00:00',2.1),('5819','2013-09-28','16:05:00',1.96),('5819','2013-09-28','16:10:00',2.03),('5819','2013-09-28','16:15:00',1.94),('5819','2013-09-28','16:20:00',1.54),('5819','2013-09-28','16:25:00',1.61),('5819','2013-09-28','16:30:00',1.4),('5819','2013-09-28','16:35:00',1.35),('5819','2013-09-28','16:40:00',1.29),('5819','2013-09-28','16:45:00',1.18),('5819','2013-09-28','16:50:00',1.11),('5819','2013-09-28','16:55:00',1.04),('5819','2013-09-27','08:25:00',1.25),('5819','2013-09-27','08:30:00',1.2),('5819','2013-09-27','08:35:00',1.37),('5819','2013-09-27','08:40:00',1.42),('5819','2013-09-27','08:45:00',1.49),('5819','2013-09-27','08:50:00',1.44),('5819','2013-09-27','08:55:00',1.69),('5819','2013-09-27','09:00:00',1.49),('5819','2013-09-27','09:05:00',1.09),('5819','2013-09-27','09:10:00',1.11),('5819','2013-09-27','09:15:00',1.13),('5819','2013-09-27','09:50:00',1.03),('5819','2013-09-27','09:55:00',1.39),('5819','2013-09-27','10:00:00',1.36),('5819','2013-09-27','10:05:00',2.11),('5819','2013-09-27','10:10:00',2.11),('5819','2013-09-27','10:15:00',1.56),('5819','2013-09-27','10:20:00',2.07),('5819','2013-09-27','10:25:00',1.69),('5819','2013-09-27','10:30:00',2.12),('5819','2013-09-27','10:35:00',1.28),('5819','2013-09-27','10:40:00',1.03),('5819','2013-09-27','10:45:00',1.46),('5819','2013-09-27','10:50:00',2.79),('5819','2013-09-27','10:55:00',2.92),('5819','2013-09-27','11:00:00',3.06),('5819','2013-09-27','11:05:00',3.06),('5819','2013-09-27','11:10:00',2.78),('5819','2013-09-27','11:15:00',3.09),('5819','2013-09-27','11:20:00',3.08),('5819','2013-09-27','11:25:00',2.87),('5819','2013-09-27','11:30:00',2.89),('5819','2013-09-27','11:35:00',1.2),('5819','2013-09-27','11:40:00',1.06),('5819','2013-09-27','11:45:00',2.18),('5819','2013-09-27','11:50:00',1.14),('5819','2013-09-27','11:55:00',1.22),('5819','2013-09-27','12:00:00',2.97),('5819','2013-09-27','12:05:00',1.81),('5819','2013-09-27','12:10:00',2.84),('5819','2013-09-27','12:15:00',2.67),('5819','2013-09-27','12:45:00',1.53),('5819','2013-09-27','12:50:00',3.25),('5819','2013-09-27','12:55:00',3.3),('5819','2013-09-27','13:00:00',3.31),('5819','2013-09-27','13:05:00',3.3),('5819','2013-09-27','13:10:00',3.3),('5819','2013-09-27','13:15:00',1.56),('5819','2013-09-27','13:20:00',3.18),('5819','2013-09-27','13:25:00',2.77),('5819','2013-09-27','13:35:00',1.22),('5819','2013-09-27','13:40:00',1.23),('5819','2013-09-27','13:45:00',2.48),('5819','2013-09-27','13:50:00',1.58),('5819','2013-09-27','13:55:00',1.03),('5819','2013-09-27','14:00:00',1.44),('5819','2013-09-27','14:05:00',2.82),('5819','2013-09-27','14:10:00',2.54),('5819','2013-09-27','14:15:00',2.86),('5819','2013-09-27','14:20:00',3.22),('5819','2013-09-27','14:25:00',3.1),('5819','2013-09-27','14:30:00',3.05),('5819','2013-09-27','14:35:00',2.94),('5819','2013-09-27','14:40:00',2.93),('5819','2013-09-27','14:45:00',2.8),('5819','2013-09-27','14:50:00',2.59),('5819','2013-09-27','14:55:00',2.51),('5819','2013-09-27','15:00:00',2.04),('5819','2013-09-27','15:05:00',2.07),('5819','2013-09-27','15:10:00',1.82),('5819','2013-09-27','15:15:00',2.5),('5819','2013-09-27','15:20:00',1.6),('5819','2013-09-27','15:25:00',2.27),('5819','2013-09-27','15:30:00',2.42),('5819','2013-09-27','15:35:00',1.92),('5819','2013-09-27','15:40:00',2.2),('5819','2013-09-27','15:45:00',1.17),('5819','2013-09-27','15:50:00',2.09),('5819','2013-09-27','15:55:00',2.05),('5819','2013-09-27','16:00:00',1.67),('5819','2013-09-27','16:05:00',1.61),('5819','2013-09-27','16:15:00',1.17),('5819','2013-09-27','16:20:00',1.67),('5819','2013-09-27','16:25:00',1.56),('5819','2013-09-27','16:30:00',1.21),('5819','2013-09-27','16:35:00',1.38),('5819','2013-09-27','16:40:00',1.29),('5819','2013-09-27','16:45:00',1.22),('5819','2013-09-27','16:50:00',1.18),('5819','2013-09-26','08:10:00',1.01),('5819','2013-09-26','08:15:00',1.06),('5819','2013-09-26','08:25:00',1.07),('5819','2013-09-26','08:30:00',1.33),('5819','2013-09-26','08:35:00',1.03),('5819','2013-09-26','08:40:00',1.44),('5819','2013-09-26','08:45:00',1.58),('5819','2013-09-26','08:50:00',1.69),('5819','2013-09-26','08:55:00',1.78),('5819','2013-09-26','09:00:00',1.86),('5819','2013-09-26','09:05:00',1.94),('5819','2013-09-26','09:10:00',2.02),('5819','2013-09-26','09:15:00',2.1),('5819','2013-09-26','09:20:00',2.17),('5819','2013-09-26','09:25:00',2.23),('5819','2013-09-26','09:30:00',2.3),('5819','2013-09-26','09:35:00',2.36),('5819','2013-09-26','09:40:00',2.4),('5819','2013-09-26','09:45:00',2.46),('5819','2013-09-26','09:50:00',2.49),('5819','2013-09-26','09:55:00',2.55),('5819','2013-09-26','10:00:00',2.62),('5819','2013-09-26','10:05:00',2.64),('5819','2013-09-26','10:10:00',2.68),('5819','2013-09-26','10:15:00',2.76),('5819','2013-09-26','10:20:00',2.77),('5819','2013-09-26','10:25:00',2.81),('5819','2013-09-26','10:30:00',2.82),('5819','2013-09-26','10:35:00',2.86),('5819','2013-09-26','10:40:00',2.88),('5819','2013-09-26','10:45:00',2.65),('5819','2013-09-26','10:50:00',3),('5819','2013-09-26','10:55:00',3.05),('5819','2013-09-26','11:00:00',3.08),('5819','2013-09-26','11:05:00',3.01),('5819','2013-09-26','11:10:00',3.1),('5819','2013-09-26','11:15:00',3.11),('5819','2013-09-26','11:20:00',3.16),('5819','2013-09-26','11:25:00',3.22),('5819','2013-09-26','11:30:00',3.21),('5819','2013-09-26','11:35:00',3.29),('5819','2013-09-26','11:40:00',2.93),('5819','2013-09-26','11:45:00',2.58),('5819','2013-09-26','11:50:00',3.26),('5819','2013-09-26','11:55:00',3.11),('5819','2013-09-26','12:00:00',2.34),('5819','2013-09-26','12:05:00',2.74),('5819','2013-09-26','12:15:00',1.32),('5819','2013-09-26','12:20:00',1.65),('5819','2013-09-26','12:25:00',1.25),('5819','2013-09-26','12:30:00',1.3),('5819','2013-09-26','12:35:00',1.27),('5819','2013-09-26','12:40:00',1.67),('5819','2013-09-26','12:45:00',1.84),('5819','2013-09-26','12:50:00',1.6),('5819','2013-09-26','12:55:00',1.92),('5819','2013-09-26','13:00:00',2.92),('5819','2013-09-26','13:05:00',2.06),('5819','2013-09-26','13:10:00',1.41),('5819','2013-09-26','13:15:00',2.85),('5819','2013-09-26','13:20:00',3.65),('5819','2013-09-26','13:25:00',2.96),('5819','2013-09-26','13:30:00',2.1),('5819','2013-09-26','13:35:00',1.9),('5819','2013-09-26','13:40:00',1.43),('5819','2013-09-26','13:45:00',1.33),('5819','2013-09-26','13:50:00',1.22),('5819','2013-09-26','13:55:00',1.7),('5819','2013-09-26','14:00:00',1.89),('5819','2013-09-26','14:05:00',2.4),('5819','2013-09-26','14:10:00',3.43),('5819','2013-09-26','14:15:00',3.32),('5819','2013-09-26','14:20:00',3.02),('5819','2013-09-26','14:25:00',2.02),('5819','2013-09-26','14:30:00',1.65),('5819','2013-09-26','14:35:00',1.92),('5819','2013-09-26','14:40:00',1.95),('5819','2013-09-26','14:45:00',2.24),('5819','2013-09-26','14:50:00',3.31),('5819','2013-09-26','14:55:00',2.38),('5819','2013-09-26','15:00:00',1.13),('5819','2013-09-26','15:05:00',1.27),('5819','2013-09-26','15:10:00',1.36),('5819','2013-09-26','15:20:00',1.15),('5819','2013-09-26','15:25:00',2.34),('5819','2013-09-26','15:30:00',1.05),('5819','2013-09-26','15:35:00',1.59),('5819','2013-09-26','15:40:00',1.02),('5819','2013-09-26','15:45:00',2.09),('5819','2013-09-26','15:50:00',2.33),('5819','2013-09-26','15:55:00',2.09),('5819','2013-09-26','16:00:00',1.97),('5819','2013-09-26','16:05:00',1.84),('5819','2013-09-26','16:10:00',1.81),('5819','2013-09-26','16:15:00',1.69),('5819','2013-09-26','16:20:00',1.63),('5819','2013-09-26','16:25:00',1.6),('5819','2013-09-26','16:30:00',1.51),('5819','2013-09-26','16:35:00',1.41),('5819','2013-09-26','16:40:00',1.33),('5819','2013-09-26','16:45:00',1.24),('5819','2013-09-26','16:50:00',1.16),('5819','2013-09-26','16:55:00',1.09),('5819','2013-09-26','17:00:00',1.02),('5819','2013-09-25','08:25:00',1.17),('5819','2013-09-25','08:30:00',1.12),('5819','2013-09-25','08:45:00',1.24),('5819','2013-09-25','08:50:00',1.45),('5819','2013-09-25','09:10:00',1.86),('5819','2013-09-25','09:15:00',1.94),('5819','2013-09-25','09:25:00',1.28),('5819','2013-09-25','09:30:00',1.96),('5819','2013-09-25','09:35:00',1.81),('5819','2013-09-25','09:40:00',2.34),('5819','2013-09-25','09:45:00',2.29),('5819','2013-09-25','09:50:00',1.97),('5819','2013-09-25','09:55:00',1.53),('5819','2013-09-25','10:00:00',2.85),('5819','2013-09-25','10:05:00',2.12),('5819','2013-09-25','10:10:00',1.05),('5819','2013-09-25','10:20:00',1.19),('5819','2013-09-25','10:25:00',1.6),('5819','2013-09-25','10:30:00',1.46),('5819','2013-09-25','10:35:00',1.27),('5819','2013-09-25','10:45:00',2.72),('5819','2013-09-25','10:50:00',3.48),('5819','2013-09-25','10:55:00',3.73),('5819','2013-09-25','11:00:00',2.78),('5819','2013-09-25','11:05:00',1.06),('5819','2013-09-25','11:10:00',1.38),('5819','2013-09-25','11:15:00',1.39),('5819','2013-09-25','11:25:00',1.72),('5819','2013-09-25','11:30:00',3.49),('5819','2013-09-25','11:35:00',3.49),('5819','2013-09-25','11:40:00',3.26),('5819','2013-09-25','11:45:00',3.44),('5819','2013-09-25','11:50:00',2.47),('5819','2013-09-25','11:55:00',1.88),('5819','2013-09-25','12:00:00',2.56),('5819','2013-09-25','12:10:00',1.1),('5819','2013-09-25','12:15:00',3.4),('5819','2013-09-25','12:20:00',3.54),('5819','2013-09-25','12:25:00',3.55),('5819','2013-09-25','12:30:00',2.5),('5819','2013-09-25','12:35:00',3.6),('5819','2013-09-25','12:40:00',3.63),('5819','2013-09-25','12:45:00',1.62),('5819','2013-09-25','12:50:00',1.02),('5819','2013-09-25','13:00:00',1.27),('5819','2013-09-25','13:05:00',1.4),('5819','2013-09-25','13:10:00',1.11),('5819','2013-09-25','13:35:00',2.88),('5819','2013-09-25','13:40:00',2.34),('5819','2013-09-25','13:45:00',3.7),('5819','2013-09-25','13:50:00',3.61),('5819','2013-09-25','13:55:00',3.74),('5819','2013-09-25','14:00:00',1.57),('5819','2013-09-25','14:10:00',1.01),('5819','2013-09-25','14:30:00',1.07),('5819','2013-09-25','14:35:00',1.55),('5819','2013-09-25','14:40:00',2.47),('5819','2013-09-25','14:45:00',2.5),('5819','2013-09-25','14:50:00',1.94),('5819','2013-09-25','14:55:00',2.93),('5819','2013-09-25','15:00:00',2.35),('5819','2013-09-25','15:05:00',3.09),('5819','2013-09-25','15:10:00',2.93),('5819','2013-09-25','15:15:00',2.81),('5819','2013-09-25','15:20:00',2.71),('5819','2013-09-25','15:25:00',2.49),('5819','2013-09-25','15:30:00',2.49),('5819','2013-09-25','15:35:00',2.24),('5819','2013-09-25','15:40:00',2.61),('5819','2013-09-25','15:45:00',2.3),('5819','2013-09-25','15:50:00',2.24),('5819','2013-09-25','15:55:00',2.16),('5819','2013-09-25','16:00:00',2.09),('5819','2013-09-25','16:05:00',2),('5819','2013-09-25','16:10:00',1.91),('5819','2013-09-25','16:15:00',1.82),('5819','2013-09-25','16:20:00',1.73),('5819','2013-09-25','16:30:00',1.28),('5819','2013-09-25','16:35:00',1.52),('5819','2013-09-25','16:40:00',1.41),('5819','2013-09-25','16:45:00',1.3),('5819','2013-09-25','16:50:00',1.24),('5819','2013-09-25','16:55:00',1.15),('5819','2013-09-25','17:00:00',1.08),('5819','2013-09-25','17:05:00',1.01),('5819','2013-09-24','08:10:00',1.09),('5819','2013-09-24','08:15:00',1.19),('5819','2013-09-24','08:20:00',1.28),('5819','2013-09-24','08:25:00',1.37),('5819','2013-09-24','08:30:00',1.46),('5819','2013-09-24','08:35:00',1.57),('5819','2013-09-24','08:40:00',1.65),('5819','2013-09-24','08:45:00',1.72),('5819','2013-09-24','08:50:00',1.81),('5819','2013-09-24','08:55:00',1.88),('5819','2013-09-24','09:00:00',1.96),('5819','2013-09-24','09:05:00',2.04),('5819','2013-09-24','09:10:00',2.13),('5819','2013-09-24','09:15:00',2.19),('5819','2013-09-24','09:20:00',2.26),('5819','2013-09-24','09:25:00',2.34),('5819','2013-09-24','09:30:00',2.41),('5819','2013-09-24','09:35:00',2.47),('5819','2013-09-24','09:40:00',2.53),('5819','2013-09-24','09:45:00',2.58),('5819','2013-09-24','09:50:00',2.63),('5819','2013-09-24','09:55:00',2.67),('5819','2013-09-24','10:00:00',2.71),('5819','2013-09-24','10:05:00',2.78),('5819','2013-09-24','10:10:00',2.85),('5819','2013-09-24','10:15:00',2.91),('5819','2013-09-24','10:20:00',2.95),('5819','2013-09-24','10:25:00',3),('5819','2013-09-24','10:30:00',3.04),('5819','2013-09-24','10:35:00',3.06),('5819','2013-09-24','10:40:00',3.09),('5819','2013-09-24','10:45:00',3.13),('5819','2013-09-24','10:50:00',3.17),('5819','2013-09-24','10:55:00',3.19),('5819','2013-09-24','11:00:00',3.23),('5819','2013-09-24','11:05:00',3.25),('5819','2013-09-24','11:10:00',3.26),('5819','2013-09-24','11:15:00',3.29),('5819','2013-09-24','11:20:00',3.29),('5819','2013-09-24','11:25:00',3.3),('5819','2013-09-24','11:30:00',3.32),('5819','2013-09-24','11:35:00',3.34),('5819','2013-09-24','11:40:00',3.38),('5819','2013-09-24','11:45:00',3.37),('5819','2013-09-24','11:50:00',3.38),('5819','2013-09-24','11:55:00',3.41),('5819','2013-09-24','12:00:00',3.41),('5819','2013-09-24','12:05:00',3.42),('5819','2013-09-24','12:10:00',3.43),('5819','2013-09-24','12:15:00',3.42),('5819','2013-09-24','12:20:00',3.44),('5819','2013-09-24','12:25:00',3.41),('5819','2013-09-24','12:30:00',3.39),('5819','2013-09-24','12:35:00',3.4),('5819','2013-09-24','12:40:00',3.42),('5819','2013-09-24','12:45:00',3.45),('5819','2013-09-24','12:50:00',3.44),('5819','2013-09-24','12:55:00',3.4),('5819','2013-09-24','13:00:00',3.37),('5819','2013-09-24','13:05:00',3.4),('5819','2013-09-24','13:10:00',3.36),('5819','2013-09-24','13:15:00',3.36),('5819','2013-09-24','13:20:00',3.36),('5819','2013-09-24','13:25:00',3.35),('5819','2013-09-24','13:30:00',3.33),('5819','2013-09-24','13:35:00',3.28),('5819','2013-09-24','13:40:00',3.27),('5819','2013-09-24','13:45:00',3.27),('5819','2013-09-24','13:50:00',3.26),('5819','2013-09-24','13:55:00',3.2),('5819','2013-09-24','14:00:00',3.16),('5819','2013-09-24','14:05:00',3.14),('5819','2013-09-24','14:10:00',3.11),('5819','2013-09-24','14:15:00',3.08),('5819','2013-09-24','14:20:00',3.04),('5819','2013-09-24','14:25:00',3.01),('5819','2013-09-24','14:30:00',2.99),('5819','2013-09-24','14:35:00',2.93),('5819','2013-09-24','14:40:00',2.89),('5819','2013-09-24','14:45:00',2.83),('5819','2013-09-24','14:50:00',2.77),('5819','2013-09-24','14:55:00',2.73),('5819','2013-09-24','15:00:00',2.67),('5819','2013-09-24','15:05:00',2.63),('5819','2013-09-24','15:10:00',2.61),('5819','2013-09-24','15:15:00',2.54),('5819','2013-09-24','15:20:00',2.5),('5819','2013-09-24','15:25:00',2.47),('5819','2013-09-24','15:30:00',2.41),('5819','2013-09-24','15:35:00',2.33),('5819','2013-09-24','15:40:00',2.26),('5819','2013-09-24','15:45:00',2.2),('5819','2013-09-24','15:50:00',2.13),('5819','2013-09-24','15:55:00',2.06),('5819','2013-09-24','16:00:00',1.99),('5819','2013-09-24','16:05:00',1.92),('5819','2013-09-24','16:10:00',1.84),('5819','2013-09-24','16:15:00',1.78),('5819','2013-09-24','16:20:00',1.71),('5819','2013-09-24','16:25:00',1.63),('5819','2013-09-24','16:30:00',1.55),('5819','2013-09-24','16:35:00',1.47),('5819','2013-09-24','16:40:00',1.39),('5819','2013-09-24','16:45:00',1.31),('5819','2013-09-24','16:50:00',1.23),('5819','2013-09-24','16:55:00',1.17),('5819','2013-09-24','17:00:00',1.11),('5819','2013-09-24','17:05:00',1.03),('5819','2013-09-23','08:05:00',1.06),('5819','2013-09-23','08:10:00',1.16),('5819','2013-09-23','08:15:00',1.24),('5819','2013-09-23','08:20:00',1.33),('5819','2013-09-23','08:25:00',1.42),('5819','2013-09-23','08:30:00',1.51),('5819','2013-09-23','08:35:00',1.62),('5819','2013-09-23','08:40:00',1.7),('5819','2013-09-23','08:45:00',1.79),('5819','2013-09-23','08:50:00',1.87),('5819','2013-09-23','08:55:00',1.95),('5819','2013-09-23','09:00:00',2.04),('5819','2013-09-23','09:05:00',2.12),('5819','2013-09-23','09:10:00',2.19),('5819','2013-09-23','09:15:00',2.26),('5819','2013-09-23','09:20:00',2.33),('5819','2013-09-23','09:25:00',2.41),('5819','2013-09-23','09:30:00',2.47),('5819','2013-09-23','09:35:00',2.53),('5819','2013-09-23','09:40:00',2.58),('5819','2013-09-23','09:45:00',2.64),('5819','2013-09-23','09:50:00',2.7),('5819','2013-09-23','09:55:00',2.75),('5819','2013-09-23','10:00:00',2.8),('5819','2013-09-23','10:05:00',2.85),('5819','2013-09-23','10:10:00',2.9),('5819','2013-09-23','10:15:00',2.93),('5819','2013-09-23','10:20:00',2.97),('5819','2013-09-23','10:25:00',3.02),('5819','2013-09-23','10:30:00',3.05),('5819','2013-09-23','10:35:00',3.09),('5819','2013-09-23','10:40:00',3.13),('5819','2013-09-23','10:45:00',3.16),('5819','2013-09-23','10:50:00',3.22),('5819','2013-09-23','10:55:00',3.23),('5819','2013-09-23','11:00:00',3.25),('5819','2013-09-23','11:05:00',3.31),('5819','2013-09-23','11:10:00',3.35),('5819','2013-09-23','11:15:00',3.4),('5819','2013-09-23','11:20:00',3.44),('5819','2013-09-23','11:25:00',3.45),('5819','2013-09-23','11:30:00',3.48),('5819','2013-09-23','11:35:00',3.49),('5819','2013-09-23','11:40:00',3.49),('5819','2013-09-23','11:45:00',3.51),('5819','2013-09-23','11:50:00',3.53),('5819','2013-09-23','11:55:00',3.55),('5819','2013-09-23','12:00:00',3.56),('5819','2013-09-23','12:05:00',3.58),('5819','2013-09-23','12:10:00',3.62),('5819','2013-09-23','12:15:00',3.63),('5819','2013-09-23','12:20:00',3.59),('5819','2013-09-23','12:25:00',3.56),('5819','2013-09-23','12:30:00',3.52),('5819','2013-09-23','12:35:00',3.52),('5819','2013-09-23','12:40:00',3.52),('5819','2013-09-23','12:45:00',3.53),('5819','2013-09-23','12:50:00',3.51),('5819','2013-09-23','12:55:00',3.52),('5819','2013-09-23','13:00:00',3.5),('5819','2013-09-23','13:05:00',3.5),('5819','2013-09-23','13:10:00',3.49),('5819','2013-09-23','13:15:00',3.46),('5819','2013-09-23','13:20:00',3.42),('5819','2013-09-23','13:25:00',3.43),('5819','2013-09-23','13:30:00',3.4),('5819','2013-09-23','13:35:00',3.37),('5819','2013-09-23','13:40:00',3.34),('5819','2013-09-23','13:45:00',3.31),('5819','2013-09-23','13:50:00',3.28),('5819','2013-09-23','13:55:00',3.24),('5819','2013-09-23','14:00:00',3.17),('5819','2013-09-23','14:05:00',3.1),('5819','2013-09-23','14:10:00',3.09),('5819','2013-09-23','14:15:00',3.08),('5819','2013-09-23','14:20:00',3.04),('5819','2013-09-23','14:25:00',3.03),('5819','2013-09-23','14:30:00',3.09),('5819','2013-09-23','14:35:00',3),('5819','2013-09-23','14:40:00',2.93),('5819','2013-09-23','14:45:00',2.85),('5819','2013-09-23','14:50:00',2.78),('5819','2013-09-23','14:55:00',2.78),('5819','2013-09-23','15:00:00',2.73),('5819','2013-09-23','15:05:00',2.12),('5819','2013-09-23','15:10:00',1.84),('5819','2013-09-23','15:15:00',2.63),('5819','2013-09-23','15:20:00',2.52),('5819','2013-09-23','15:25:00',2.46),('5819','2013-09-23','15:30:00',2.39),('5819','2013-09-23','15:35:00',2.34),('5819','2013-09-23','15:40:00',2.27),('5819','2013-09-23','15:45:00',2.2),('5819','2013-09-23','15:50:00',2.11),('5819','2013-09-23','15:55:00',1.81),('5819','2013-09-23','16:00:00',1.95),('5819','2013-09-23','16:05:00',1.93),('5819','2013-09-23','16:10:00',1.57),('5819','2013-09-23','16:15:00',1.6),('5819','2013-09-23','16:20:00',1.52),('5819','2013-09-23','16:25:00',1.34),('5819','2013-09-23','16:30:00',1.49),('5819','2013-09-23','16:35:00',1.42),('5819','2013-09-23','16:40:00',1.37),('5819','2013-09-23','16:45:00',1.3),('5819','2013-09-23','16:50:00',1.21),('5819','2013-09-23','16:55:00',1.14),('5819','2013-09-23','17:00:00',1.07),('5819','2013-09-22','08:05:00',1.09),('5819','2013-09-22','08:10:00',1.16),('5819','2013-09-22','08:15:00',1.02),('5819','2013-09-22','08:20:00',1.27),('5819','2013-09-22','08:25:00',1.4),('5819','2013-09-22','08:30:00',1.48),('5819','2013-09-22','08:35:00',1.56),('5819','2013-09-22','08:40:00',1.64),('5819','2013-09-22','08:45:00',1.73),('5819','2013-09-22','08:50:00',1.82),('5819','2013-09-22','08:55:00',1.91),('5819','2013-09-22','09:00:00',2),('5819','2013-09-22','09:05:00',2.08),('5819','2013-09-22','09:10:00',2.17),('5819','2013-09-22','09:15:00',2.26),('5819','2013-09-22','09:20:00',2.32),('5819','2013-09-22','09:25:00',2.4),('5819','2013-09-22','09:30:00',2.47),('5819','2013-09-22','09:35:00',2.53),('5819','2013-09-22','09:40:00',2.57),('5819','2013-09-22','09:45:00',2.63),('5819','2013-09-22','09:50:00',2.69),('5819','2013-09-22','09:55:00',2.76),('5819','2013-09-22','10:00:00',2.83),('5819','2013-09-22','10:05:00',2.9),('5819','2013-09-22','10:10:00',2.95),('5819','2013-09-22','10:15:00',3),('5819','2013-09-22','10:20:00',3.05),('5819','2013-09-22','10:25:00',3.08),('5819','2013-09-22','10:30:00',3.15),('5819','2013-09-22','10:35:00',3.19),('5819','2013-09-22','10:40:00',3.23),('5819','2013-09-22','10:45:00',3.25),('5819','2013-09-22','10:50:00',3.27),('5819','2013-09-22','10:55:00',3.31),('5819','2013-09-22','11:00:00',3.34),('5819','2013-09-22','11:05:00',3.35),('5819','2013-09-22','11:10:00',3.37),('5819','2013-09-22','11:15:00',3.39),('5819','2013-09-22','11:20:00',3.43),('5819','2013-09-22','11:25:00',3.45),('5819','2013-09-22','11:30:00',3.48),('5819','2013-09-22','11:35:00',3.53),('5819','2013-09-22','11:40:00',3.57),('5819','2013-09-22','11:45:00',3.59),('5819','2013-09-22','11:50:00',3.6),('5819','2013-09-22','11:55:00',3.61),('5819','2013-09-22','12:00:00',3.62),('5819','2013-09-22','12:05:00',3.64),('5819','2013-09-22','12:10:00',3.64),('5819','2013-09-22','12:15:00',3.62),('5819','2013-09-22','12:20:00',3.66),('5819','2013-09-22','12:25:00',3.64),('5819','2013-09-22','12:30:00',3.62),('5819','2013-09-22','12:35:00',3.61),('5819','2013-09-22','12:40:00',3.62),('5819','2013-09-22','12:45:00',3.57),('5819','2013-09-22','12:50:00',3.62),('5819','2013-09-22','12:55:00',3.65),('5819','2013-09-22','13:00:00',3.6),('5819','2013-09-22','13:05:00',3.58),('5819','2013-09-22','13:10:00',3.62),('5819','2013-09-22','13:15:00',3.56),('5819','2013-09-22','13:20:00',3.51),('5819','2013-09-22','13:25:00',3.5),('5819','2013-09-22','13:30:00',3.46),('5819','2013-09-22','13:35:00',3.43),('5819','2013-09-22','13:40:00',3.4),('5819','2013-09-22','13:45:00',3.4),('5819','2013-09-22','13:50:00',3.4),('5819','2013-09-22','13:55:00',3.18),('5819','2013-09-22','14:00:00',3.31),('5819','2013-09-22','14:05:00',3.34),('5819','2013-09-22','14:10:00',3.27),('5819','2013-09-22','14:15:00',3.33),('5819','2013-09-22','14:20:00',2.38),('5819','2013-09-22','14:25:00',3.1),('5819','2013-09-22','14:30:00',3.26),('5819','2013-09-22','14:35:00',3.13),('5819','2013-09-22','14:40:00',2.34),('5819','2013-09-22','14:45:00',2.74),('5819','2013-09-22','14:50:00',2.98),('5819','2013-09-22','14:55:00',2.93),('5819','2013-09-22','15:00:00',2.93),('5819','2013-09-22','15:05:00',2.99),('5819','2013-09-22','15:10:00',2.88),('5819','2013-09-22','15:15:00',3.02),('5819','2013-09-22','15:20:00',3.09),('5819','2013-09-22','15:25:00',1.43),('5819','2013-09-22','15:40:00',2.04),('5819','2013-09-22','15:45:00',2.48),('5819','2013-09-22','15:50:00',2.33),('5819','2013-09-22','15:55:00',2.3),('5819','2013-09-22','16:00:00',2.51),('5819','2013-09-22','16:05:00',2.55),('5819','2013-09-22','16:10:00',2.64),('5819','2013-09-22','16:15:00',2.08),('5819','2013-09-22','16:20:00',1.25),('5819','2013-09-22','16:25:00',1.05),('5819','2013-09-22','16:45:00',1.42),('5819','2013-09-22','16:50:00',1.05),('5819','2013-09-22','16:55:00',1.11),('5819','2013-09-22','17:05:00',1.24),('5819','2013-09-21','08:05:00',1.02),('5819','2013-09-21','08:10:00',1.11),('5819','2013-09-21','08:15:00',1.2),('5819','2013-09-21','08:20:00',1.28),('5819','2013-09-21','08:25:00',1.37),('5819','2013-09-21','08:30:00',1.47),('5819','2013-09-21','08:35:00',1.57),('5819','2013-09-21','08:40:00',1.65),('5819','2013-09-21','08:45:00',1.73),('5819','2013-09-21','08:50:00',1.81),('5819','2013-09-21','08:55:00',1.89),('5819','2013-09-21','09:00:00',1.96),('5819','2013-09-21','09:05:00',2.05),('5819','2013-09-21','09:10:00',2.12),('5819','2013-09-21','09:15:00',2.19),('5819','2013-09-21','09:20:00',2.26),('5819','2013-09-21','09:25:00',2.32),('5819','2013-09-21','09:30:00',2.4),('5819','2013-09-21','09:35:00',2.46),('5819','2013-09-21','09:40:00',2.5),('5819','2013-09-21','09:45:00',2.57),('5819','2013-09-21','09:50:00',2.62),('5819','2013-09-21','09:55:00',2.69),('5819','2013-09-21','10:00:00',2.75),('5819','2013-09-21','10:05:00',2.8),('5819','2013-09-21','10:10:00',2.86),('5819','2013-09-21','10:15:00',2.9),('5819','2013-09-21','10:20:00',2.94),('5819','2013-09-21','10:25:00',2.99),('5819','2013-09-21','10:30:00',3.02),('5819','2013-09-21','10:35:00',3.06),('5819','2013-09-21','10:40:00',3.11),('5819','2013-09-21','10:45:00',3.14),('5819','2013-09-21','10:50:00',3.17),('5819','2013-09-21','10:55:00',3.21),('5819','2013-09-21','11:00:00',3.23),('5819','2013-09-21','11:05:00',3.25),('5819','2013-09-21','11:10:00',3.29),('5819','2013-09-21','11:15:00',3.31),('5819','2013-09-21','11:20:00',3.34),('5819','2013-09-21','11:25:00',3.38),('5819','2013-09-21','11:30:00',3.38),('5819','2013-09-21','11:35:00',3.39),('5819','2013-09-21','11:40:00',3.43),('5819','2013-09-21','11:45:00',3.43),('5819','2013-09-21','11:50:00',3.47),('5819','2013-09-21','11:55:00',3.4),('5819','2013-09-21','12:00:00',3.47),('5819','2013-09-21','12:05:00',3.5),('5819','2013-09-21','12:10:00',3.5),('5819','2013-09-21','12:15:00',3.52),('5819','2013-09-21','12:20:00',3.53),('5819','2013-09-21','12:25:00',3.2),('5819','2013-09-21','12:30:00',3.58),('5819','2013-09-21','12:35:00',3.54),('5819','2013-09-21','12:40:00',3.2),('5819','2013-09-21','12:45:00',3.21),('5819','2013-09-21','12:50:00',3.48),('5819','2013-09-21','12:55:00',3.5),('5819','2013-09-21','13:00:00',3.47),('5819','2013-09-21','13:05:00',3.33),('5819','2013-09-21','13:10:00',3.46),('5819','2013-09-21','13:15:00',3.45),('5819','2013-09-21','13:20:00',2.8),('5819','2013-09-21','13:25:00',3.14),('5819','2013-09-21','13:30:00',3.27),('5819','2013-09-21','13:35:00',3.32),('5819','2013-09-21','13:40:00',2.93),('5819','2013-09-21','13:45:00',2.89),('5819','2013-09-21','13:50:00',3),('5819','2013-09-21','13:55:00',3.08),('5819','2013-09-21','14:00:00',2.97),('5819','2013-09-21','14:05:00',3.14),('5819','2013-09-21','14:10:00',3.04),('5819','2013-09-21','14:15:00',3.14),('5819','2013-09-21','14:20:00',3.16),('5819','2013-09-21','14:25:00',3.09),('5819','2013-09-21','14:30:00',3.05),('5819','2013-09-21','14:35:00',2.99),('5819','2013-09-21','14:40:00',2.93),('5819','2013-09-21','14:45:00',2.88),('5819','2013-09-21','14:50:00',2.85),('5819','2013-09-21','14:55:00',2.81),('5819','2013-09-21','15:00:00',2.75),('5819','2013-09-21','15:05:00',2.69),('5819','2013-09-21','15:10:00',2.56),('5819','2013-09-21','15:15:00',2.56),('5819','2013-09-21','15:20:00',2.54),('5819','2013-09-21','15:25:00',2.47),('5819','2013-09-21','15:30:00',2.4),('5819','2013-09-21','15:35:00',2.37),('5819','2013-09-21','15:40:00',2.18),('5819','2013-09-21','15:45:00',1.66),('5819','2013-09-21','15:50:00',1.88),('5819','2013-09-21','15:55:00',2.13),('5819','2013-09-21','16:00:00',1.69),('5819','2013-09-21','16:05:00',1.04),('5819','2013-09-21','16:10:00',1.3),('5819','2013-09-21','16:15:00',1.14),('5819','2013-09-21','16:20:00',1.4),('5819','2013-09-21','16:35:00',1.17),('5819','2013-09-20','08:35:00',1.57),('5819','2013-09-20','08:40:00',1.8),('5819','2013-09-20','08:45:00',1.8),('5819','2013-09-20','08:50:00',1.07),('5819','2013-09-20','09:00:00',1.11),('5819','2013-09-20','09:05:00',1.25),('5819','2013-09-20','09:10:00',1.16),('5819','2013-09-20','09:15:00',1.08),('5819','2013-09-20','09:20:00',1.64),('5819','2013-09-20','09:25:00',2),('5819','2013-09-20','09:30:00',1.32),('5819','2013-09-20','09:35:00',1.18),('5819','2013-09-20','09:40:00',1.21),('5819','2013-09-20','09:45:00',1.23),('5819','2013-09-20','09:50:00',1.34),('5819','2013-09-20','09:55:00',1.35),('5819','2013-09-20','10:00:00',1.49),('5819','2013-09-20','10:05:00',1.78),('5819','2013-09-20','10:10:00',3.37),('5819','2013-09-20','10:15:00',1.93),('5819','2013-09-20','10:20:00',3.2),('5819','2013-09-20','10:25:00',1.86),('5819','2013-09-20','10:30:00',1.87),('5819','2013-09-20','10:35:00',2.52),('5819','2013-09-20','10:40:00',2.17),('5819','2013-09-20','10:45:00',2.31),('5819','2013-09-20','10:50:00',2.4),('5819','2013-09-20','10:55:00',2.55),('5819','2013-09-20','11:00:00',2.39),('5819','2013-09-20','11:05:00',1.89),('5819','2013-09-20','11:10:00',1.9),('5819','2013-09-20','11:15:00',2.41),('5819','2013-09-20','11:20:00',2.46),('5819','2013-09-20','11:25:00',2.19),('5819','2013-09-20','11:30:00',2.71),('5819','2013-09-20','11:35:00',2.57),('5819','2013-09-20','11:40:00',2.99),('5819','2013-09-20','11:45:00',3.83),('5819','2013-09-20','11:50:00',3.82),('5819','2013-09-20','11:55:00',3.72),('5819','2013-09-20','12:00:00',3.6),('5819','2013-09-20','12:05:00',3.59),('5819','2013-09-20','12:10:00',3.59),('5819','2013-09-20','12:15:00',3.62),('5819','2013-09-20','12:20:00',3.67),('5819','2013-09-20','12:25:00',3.7),('5819','2013-09-20','12:30:00',3.02),('5819','2013-09-20','12:35:00',3.32),('5819','2013-09-20','12:40:00',2.7),('5819','2013-09-20','12:45:00',3.63),('5819','2013-09-20','12:50:00',2.99),('5819','2013-09-20','12:55:00',3.67),('5819','2013-09-20','13:00:00',3.36),('5819','2013-09-20','13:05:00',3.09),('5819','2013-09-20','13:10:00',3.37),('5819','2013-09-20','13:15:00',3.26),('5819','2013-09-20','13:20:00',3.19),('5819','2013-09-20','13:25:00',3.69),('5819','2013-09-20','13:30:00',3.53),('5819','2013-09-20','13:35:00',2.21),('5819','2013-09-20','13:40:00',3.06),('5819','2013-09-20','13:45:00',3.49),('5819','2013-09-20','13:50:00',3.36),('5819','2013-09-20','13:55:00',3.07),('5819','2013-09-20','14:00:00',3.29),('5819','2013-09-20','14:05:00',3.33),('5819','2013-09-20','14:10:00',2.47),('5819','2013-09-20','14:15:00',3.07),('5819','2013-09-20','14:20:00',2.26),('5819','2013-09-20','14:25:00',1.51),('5819','2013-09-20','14:30:00',3.39),('5819','2013-09-20','14:35:00',3.29),('5819','2013-09-20','14:40:00',3.21),('5819','2013-09-20','14:45:00',3.18),('5819','2013-09-20','14:50:00',3.18),('5819','2013-09-20','14:55:00',3.11),('5819','2013-09-20','15:00:00',2.73),('5819','2013-09-20','15:05:00',1.61),('5819','2013-09-20','15:10:00',2.69),('5819','2013-09-20','15:15:00',2.23),('5819','2013-09-20','15:20:00',2.38),('5819','2013-09-20','15:25:00',1.79),('5819','2013-09-20','15:30:00',1.39),('5819','2013-09-20','15:40:00',1.22),('5819','2013-09-20','15:45:00',2.56),('5819','2013-09-20','15:50:00',2.44),('5819','2013-09-20','15:55:00',2.51),('5819','2013-09-20','16:00:00',1.57),('5819','2013-09-20','16:05:00',1.31),('5819','2013-09-20','16:10:00',2.15),('5819','2013-09-20','16:15:00',2.25),('5819','2013-09-20','16:45:00',1.01),('5819','2013-09-20','16:50:00',1.27),('5819','2013-09-20','16:55:00',1.62),('5819','2013-09-20','17:00:00',1.66),('5819','2013-09-20','17:05:00',1.74),('5819','2013-09-20','17:10:00',1.65),('5819','2013-09-20','17:15:00',1.49),('5819','2013-09-20','17:20:00',1.37),('5819','2013-09-20','17:25:00',1.14),('5819','2013-09-19','08:20:00',1.21),('5819','2013-09-19','08:25:00',1.17),('5819','2013-09-19','08:30:00',1.45),('5819','2013-09-19','08:35:00',1.58),('5819','2013-09-19','08:40:00',1.03),('5819','2013-09-19','08:45:00',1.66),('5819','2013-09-19','08:50:00',1.26),('5819','2013-09-19','08:55:00',1.19),('5819','2013-09-19','09:00:00',1.27),('5819','2013-09-19','09:10:00',1.42),('5819','2013-09-19','09:15:00',2.04),('5819','2013-09-19','09:20:00',1.1),('5819','2013-09-19','09:40:00',1.03),('5819','2013-09-19','10:00:00',1.02),('5819','2013-09-19','10:05:00',1.79),('5819','2013-09-19','10:10:00',2.69),('5819','2013-09-19','10:15:00',2.72),('5819','2013-09-19','10:20:00',1.35),('5819','2013-09-19','10:25:00',1.13),('5819','2013-09-19','10:35:00',2.5),('5819','2013-09-19','10:40:00',3.4),('5819','2013-09-19','10:45:00',2.38),('5819','2013-09-19','10:50:00',1.6),('5819','2013-09-19','10:55:00',2.26),('5819','2013-09-19','11:00:00',3.64),('5819','2013-09-19','11:05:00',3.43),('5819','2013-09-19','11:10:00',1.49),('5819','2013-09-19','11:15:00',2.02),('5819','2013-09-19','11:20:00',2.4),('5819','2013-09-19','11:25:00',1.51),('5819','2013-09-19','11:30:00',4.01),('5819','2013-09-19','11:35:00',2.88),('5819','2013-09-19','11:40:00',3.41),('5819','2013-09-19','11:45:00',2.28),('5819','2013-09-19','11:50:00',3.63),('5819','2013-09-19','11:55:00',3.66),('5819','2013-09-19','12:00:00',2.66),('5819','2013-09-19','12:05:00',1.71),('5819','2013-09-19','12:10:00',3.13),('5819','2013-09-19','12:15:00',3.55),('5819','2013-09-19','12:20:00',3.08),('5819','2013-09-19','12:25:00',4.24),('5819','2013-09-19','12:30:00',4.12),('5819','2013-09-19','12:35:00',3.76),('5819','2013-09-19','12:40:00',3.74),('5819','2013-09-19','12:45:00',1.71),('5819','2013-09-19','12:50:00',3.83),('5819','2013-09-19','12:55:00',3.84),('5819','2013-09-19','13:00:00',3.87),('5819','2013-09-19','13:05:00',3.85),('5819','2013-09-19','13:10:00',3.98),('5819','2013-09-19','13:15:00',3.76),('5819','2013-09-19','13:20:00',3.62),('5819','2013-09-19','13:25:00',2.14),('5819','2013-09-19','13:30:00',3.7),('5819','2013-09-19','13:35:00',3.82),('5819','2013-09-19','13:40:00',3.67),('5819','2013-09-19','13:45:00',3.52),('5819','2013-09-19','13:50:00',1.61),('5819','2013-09-19','13:55:00',1.09),('5819','2013-09-19','14:00:00',1.18),('5819','2013-09-19','14:05:00',2.37),('5819','2013-09-19','14:10:00',3.09),('5819','2013-09-19','14:15:00',3.41),('5819','2013-09-19','14:20:00',3.35),('5819','2013-09-19','14:25:00',3.12),('5819','2013-09-19','14:30:00',3.2),('5819','2013-09-19','14:35:00',3.13),('5819','2013-09-19','14:40:00',3.08),('5819','2013-09-19','14:45:00',3),('5819','2013-09-19','14:50:00',3.02),('5819','2013-09-19','14:55:00',2.26),('5819','2013-09-19','15:00:00',3.07),('5819','2013-09-19','15:05:00',2.96),('5819','2013-09-19','15:10:00',2.57),('5819','2013-09-19','15:15:00',2.37),('5819','2013-09-19','15:20:00',2.8),('5819','2013-09-19','15:25:00',2.6),('5819','2013-09-19','15:30:00',2),('5819','2013-09-19','15:35:00',1.48),('5819','2013-09-19','15:40:00',2.14),('5819','2013-09-19','15:45:00',2.36),('5819','2013-09-19','15:50:00',2.36),('5819','2013-09-19','15:55:00',2.12),('5819','2013-09-19','16:00:00',2.18),('5819','2013-09-19','16:05:00',2.1),('5819','2013-09-19','16:10:00',1.52),('5819','2013-09-19','16:15:00',1.33),('5819','2013-09-19','16:20:00',1.98),('5819','2013-09-19','16:25:00',1.88),('5819','2013-09-19','16:30:00',1.54),('5819','2013-09-19','16:35:00',1.09),('5819','2013-09-19','16:40:00',1.03),('5819','2013-09-19','17:00:00',1.31),('5819','2013-09-19','17:05:00',1.18),('5819','2013-09-19','17:10:00',1.12),('5819','2013-09-19','17:15:00',1.02),('5819','2013-09-18','08:10:00',1.08),('5819','2013-09-18','08:15:00',1.11),('5819','2013-09-18','08:20:00',1.02),('5819','2013-09-18','08:25:00',1.24),('5819','2013-09-18','08:30:00',1.03),('5819','2013-09-18','08:45:00',1.42),('5819','2013-09-18','08:50:00',1.07),('5819','2013-09-18','09:00:00',1.19),('5819','2013-09-18','09:05:00',1.77),('5819','2013-09-18','09:15:00',1.03),('5819','2013-09-18','09:20:00',2.46),('5819','2013-09-18','09:25:00',1.87),('5819','2013-09-18','09:30:00',1.87),('5819','2013-09-18','09:35:00',2.04),('5819','2013-09-18','09:40:00',2.72),('5819','2013-09-18','09:45:00',2.11),('5819','2013-09-18','09:55:00',1.22),('5819','2013-09-18','10:00:00',1.75),('5819','2013-09-18','10:05:00',3.43),('5819','2013-09-18','10:10:00',3.19),('5819','2013-09-18','10:15:00',3),('5819','2013-09-18','10:20:00',2.94),('5819','2013-09-18','10:25:00',2.99),('5819','2013-09-18','10:30:00',3),('5819','2013-09-18','10:35:00',3.05),('5819','2013-09-18','10:40:00',3.07),('5819','2013-09-18','10:45:00',2.91),('5819','2013-09-18','10:50:00',2.96),('5819','2013-09-18','10:55:00',2.38),('5819','2013-09-18','11:00:00',2.29),('5819','2013-09-18','11:05:00',3.17),('5819','2013-09-18','11:10:00',2.06),('5819','2013-09-18','11:15:00',2.92),('5819','2013-09-18','11:20:00',2.25),('5819','2013-09-18','11:25:00',2.88),('5819','2013-09-18','11:30:00',3.62),('5819','2013-09-18','11:35:00',3.63),('5819','2013-09-18','11:40:00',1.8),('5819','2013-09-18','11:45:00',1.91),('5819','2013-09-18','11:50:00',3.35),('5819','2013-09-18','11:55:00',3.78),('5819','2013-09-18','12:00:00',3.74),('5819','2013-09-18','12:05:00',2.77),('5819','2013-09-18','12:10:00',3.77),('5819','2013-09-18','12:15:00',3.89),('5819','2013-09-18','12:20:00',3.64),('5819','2013-09-18','12:25:00',3.53),('5819','2013-09-18','12:30:00',3.6),('5819','2013-09-18','12:35:00',1.89),('5819','2013-09-18','12:40:00',4.12),('5819','2013-09-18','12:45:00',3.75),('5819','2013-09-18','12:50:00',3.86),('5819','2013-09-18','12:55:00',3.82),('5819','2013-09-18','13:00:00',3.86),('5819','2013-09-18','13:05:00',2.14),('5819','2013-09-18','13:10:00',3.81),('5819','2013-09-18','13:15:00',1.95),('5819','2013-09-18','13:20:00',3.85),('5819','2013-09-18','13:25:00',3.55),('5819','2013-09-18','13:30:00',3.74),('5819','2013-09-18','13:35:00',3.65),('5819','2013-09-18','13:40:00',3.58),('5819','2013-09-18','13:45:00',3.57),('5819','2013-09-18','13:50:00',3.31),('5819','2013-09-18','13:55:00',2.63),('5819','2013-09-18','14:00:00',3.6),('5819','2013-09-18','14:05:00',3.39),('5819','2013-09-18','14:10:00',3.44),('5819','2013-09-18','14:15:00',3.4),('5819','2013-09-18','14:20:00',3.37),('5819','2013-09-18','14:25:00',3.29),('5819','2013-09-18','14:30:00',3.21),('5819','2013-09-18','14:35:00',3.17),('5819','2013-09-18','14:40:00',3.15),('5819','2013-09-18','14:45:00',3.08),('5819','2013-09-18','14:50:00',3.05),('5819','2013-09-18','14:55:00',3.04),('5819','2013-09-18','15:00:00',2.93),('5819','2013-09-18','15:05:00',2.91),('5819','2013-09-18','15:10:00',1.46),('5819','2013-09-18','15:15:00',1.96),('5819','2013-09-18','15:20:00',2.87),('5819','2013-09-18','15:25:00',2.79),('5819','2013-09-18','15:30:00',2.74),('5819','2013-09-18','15:35:00',2.7),('5819','2013-09-18','15:40:00',2.67),('5819','2013-09-18','15:45:00',2.33),('5819','2013-09-18','15:50:00',1.77),('5819','2013-09-18','15:55:00',1.7),('5819','2013-09-18','16:00:00',1.74),('5819','2013-09-18','16:05:00',1.94),('5819','2013-09-18','16:10:00',2.27),('5819','2013-09-18','16:15:00',2.12),('5819','2013-09-18','16:20:00',1.98),('5819','2013-09-18','16:25:00',1.67),('5819','2013-09-18','16:30:00',1.55),('5819','2013-09-18','16:35:00',1.51),('5819','2013-09-18','16:40:00',1.48),('5819','2013-09-18','16:45:00',1.41),('5819','2013-09-18','16:50:00',1.26),('5819','2013-09-18','16:55:00',1.21),('5819','2013-09-18','17:00:00',1.24),('5819','2013-09-18','17:05:00',1.07),('5819','2013-09-18','17:10:00',1.06),('5819','2013-09-18','17:15:00',1),('5819','2013-09-17','09:20:00',1.09),('5819','2013-09-17','09:30:00',1),('5819','2013-09-17','09:40:00',1.33),('5819','2013-09-17','09:45:00',2.49),('5819','2013-09-17','09:50:00',1.52),('5819','2013-09-17','09:55:00',1.34),('5819','2013-09-17','10:00:00',2.21),('5819','2013-09-17','10:05:00',1.77),('5819','2013-09-17','10:10:00',2.01),('5819','2013-09-17','10:15:00',1.01),('5819','2013-09-17','10:25:00',2.06),('5819','2013-09-17','10:30:00',3.05),('5819','2013-09-17','10:35:00',1.65),('5819','2013-09-17','10:40:00',1.91),('5819','2013-09-17','10:45:00',2.36),('5819','2013-09-17','10:50:00',3.84),('5819','2013-09-17','10:55:00',2.74),('5819','2013-09-17','11:00:00',1.97),('5819','2013-09-17','11:05:00',1.53),('5819','2013-09-17','11:10:00',3.17),('5819','2013-09-17','11:15:00',2.74),('5819','2013-09-17','11:20:00',2.33),('5819','2013-09-17','11:25:00',1.79),('5819','2013-09-17','11:30:00',1.73),('5819','2013-09-17','11:35:00',3.16),('5819','2013-09-17','11:40:00',3.63),('5819','2013-09-17','11:45:00',3.57),('5819','2013-09-17','11:50:00',3.14),('5819','2013-09-17','11:55:00',2.83),('5819','2013-09-17','12:00:00',3.27),('5819','2013-09-17','12:05:00',3.19),('5819','2013-09-17','12:10:00',1.7),('5819','2013-09-17','12:15:00',2.2),('5819','2013-09-17','12:20:00',1.95),('5819','2013-09-17','12:25:00',3.78),('5819','2013-09-17','12:30:00',3.37),('5819','2013-09-17','12:35:00',1.99),('5819','2013-09-17','12:40:00',3.29),('5819','2013-09-17','12:45:00',3.27),('5819','2013-09-17','12:50:00',2.9),('5819','2013-09-17','12:55:00',2.13),('5819','2013-09-17','13:00:00',2.52),('5819','2013-09-17','13:05:00',1.36),('5819','2013-09-17','13:10:00',2.07),('5819','2013-09-17','13:15:00',3.11),('5819','2013-09-17','13:20:00',2.3),('5819','2013-09-17','13:25:00',2.01),('5819','2013-09-17','13:30:00',1.71),('5819','2013-09-17','13:35:00',1.6),('5819','2013-09-17','13:40:00',2.51),('5819','2013-09-17','13:45:00',1.83),('5819','2013-09-17','13:55:00',1.15),('5819','2013-09-17','14:00:00',1.54),('5819','2013-09-17','14:05:00',1.2),('5819','2013-09-17','14:15:00',1.36),('5819','2013-09-17','14:25:00',1.78),('5819','2013-09-17','14:35:00',1.02),('5819','2013-09-17','14:55:00',2.72),('5819','2013-09-17','15:00:00',3.07),('5819','2013-09-17','15:05:00',2.45),('5819','2013-09-17','15:10:00',2.36),('5819','2013-09-17','15:15:00',2.16),('5819','2013-09-17','15:20:00',2.46),('5819','2013-09-17','15:25:00',2.44),('5819','2013-09-17','15:30:00',2),('5819','2013-09-17','15:45:00',1.14),('5819','2013-09-17','15:50:00',1.65),('5819','2013-09-17','15:55:00',2.03),('5819','2013-09-17','16:00:00',1.19),('5819','2013-09-17','16:05:00',1.56),('5819','2013-09-17','16:10:00',1.49),('5819','2013-09-17','16:15:00',1.66),('5819','2013-09-17','16:20:00',1.01),('5819','2013-09-17','16:45:00',1.09),('5819','2013-09-17','16:50:00',1.04),('5819','2013-09-17','17:00:00',1.2),('5819','2013-09-17','17:05:00',1.25),('5819','2013-09-17','17:10:00',1.17),('5819','2013-09-17','17:15:00',1.24),('5819','2013-09-17','17:20:00',1.08),('5819','2013-09-17','17:25:00',1.02),('5819','2013-09-16','08:10:00',1.03),('5819','2013-09-16','08:15:00',1.3),('5819','2013-09-16','08:20:00',1.35),('5819','2013-09-16','08:25:00',1.42),('5819','2013-09-16','08:30:00',1.5),('5819','2013-09-16','08:35:00',1.6),('5819','2013-09-16','08:40:00',1.71),('5819','2013-09-16','08:45:00',1.1),('5819','2013-09-16','08:50:00',1.5),('5819','2013-09-16','08:55:00',1.3),('5819','2013-09-16','09:05:00',1.91),('5819','2013-09-16','09:10:00',2.37),('5819','2013-09-16','09:15:00',1.9),('5819','2013-09-16','09:20:00',1.94),('5819','2013-09-16','09:25:00',2.24),('5819','2013-09-16','09:30:00',2.26),('5819','2013-09-16','09:35:00',2.48),('5819','2013-09-16','09:40:00',2.53),('5819','2013-09-16','09:45:00',2.6),('5819','2013-09-16','09:50:00',2.67),('5819','2013-09-16','09:55:00',2.76),('5819','2013-09-16','10:00:00',2.83),('5819','2013-09-16','10:05:00',2.9),('5819','2013-09-16','10:10:00',3.04),('5819','2013-09-16','10:15:00',1.62),('5819','2013-09-16','10:20:00',2.09),('5819','2013-09-16','10:25:00',1.61),('5819','2013-09-16','10:30:00',2.79),('5819','2013-09-16','10:35:00',3.55),('5819','2013-09-16','10:40:00',3.25),('5819','2013-09-16','10:45:00',3.89),('5819','2013-09-16','10:50:00',1.87),('5819','2013-09-16','11:05:00',2.51),('5819','2013-09-16','11:10:00',2.24),('5819','2013-09-16','11:15:00',1.74),('5819','2013-09-16','11:20:00',2.4),('5819','2013-09-16','11:25:00',1.72),('5819','2013-09-16','11:30:00',3.74),('5819','2013-09-16','11:35:00',3.74),('5819','2013-09-16','11:40:00',3.78),('5819','2013-09-16','11:45:00',2.07),('5819','2013-09-16','11:50:00',2.66),('5819','2013-09-16','11:55:00',3.87),('5819','2013-09-16','12:00:00',3.9),('5819','2013-09-16','12:05:00',3.64),('5819','2013-09-16','12:10:00',3.08),('5819','2013-09-16','12:15:00',3.05),('5819','2013-09-16','12:20:00',3.85),('5819','2013-09-16','12:25:00',3.75),('5819','2013-09-16','12:30:00',3.72),('5819','2013-09-16','12:35:00',3.72),('5819','2013-09-16','12:40:00',3.82),('5819','2013-09-16','12:45:00',4.05),('5819','2013-09-16','12:50:00',2.67),('5819','2013-09-16','12:55:00',2.88),('5819','2013-09-16','13:00:00',2.36),('5819','2013-09-16','13:05:00',3.55),('5819','2013-09-16','13:10:00',3.48),('5819','2013-09-16','13:15:00',3.64),('5819','2013-09-16','13:20:00',3.71),('5819','2013-09-16','13:25:00',3.61),('5819','2013-09-16','13:30:00',3.54),('5819','2013-09-16','13:35:00',3.6),('5819','2013-09-16','13:40:00',3.59),('5819','2013-09-16','13:45:00',3.51),('5819','2013-09-16','13:50:00',3.51),('5819','2013-09-16','13:55:00',3.63),('5819','2013-09-16','14:00:00',3.53),('5819','2013-09-16','14:05:00',2.86),('5819','2013-09-16','14:10:00',3.39),('5819','2013-09-16','14:15:00',3.33),('5819','2013-09-16','14:20:00',3.27),('5819','2013-09-16','14:25:00',3.23),('5819','2013-09-16','14:30:00',3.2),('5819','2013-09-16','14:35:00',3.16),('5819','2013-09-16','14:40:00',3.1),('5819','2013-09-16','14:45:00',3.05),('5819','2013-09-16','14:50:00',3.02),('5819','2013-09-16','14:55:00',3),('5819','2013-09-16','15:00:00',2.93),('5819','2013-09-16','15:05:00',2.89),('5819','2013-09-16','15:10:00',2.85),('5819','2013-09-16','15:15:00',2.81),('5819','2013-09-16','15:20:00',2.75),('5819','2013-09-16','15:25:00',2.68),('5819','2013-09-16','15:30:00',2.62),('5819','2013-09-16','15:35:00',2.55),('5819','2013-09-16','15:40:00',2.5),('5819','2013-09-16','15:45:00',2.44),('5819','2013-09-16','15:50:00',2.37),('5819','2013-09-16','15:55:00',2.26),('5819','2013-09-16','16:00:00',2.23),('5819','2013-09-16','16:05:00',1.14),('5819','2013-09-16','16:10:00',2.02),('5819','2013-09-16','16:15:00',2.04),('5819','2013-09-16','16:20:00',1.95),('5819','2013-09-16','16:25:00',1.87),('5819','2013-09-16','16:30:00',1.79),('5819','2013-09-16','16:35:00',1.7),('5819','2013-09-16','16:40:00',1.62),('5819','2013-09-16','16:45:00',1.54),('5819','2013-09-16','16:50:00',1.46),('5819','2013-09-16','16:55:00',1.37),('5819','2013-09-16','17:00:00',1.29),('5819','2013-09-16','17:05:00',1.21),('5819','2013-09-16','17:10:00',1.14),('5819','2013-09-16','17:15:00',1.06),('5819','2013-09-15','08:00:00',1.04),('5819','2013-09-15','08:05:00',1.13),('5819','2013-09-15','08:10:00',1.23),('5819','2013-09-15','08:15:00',1.33),('5819','2013-09-15','08:20:00',1.41),('5819','2013-09-15','08:25:00',1.5),('5819','2013-09-15','08:30:00',1.59),('5819','2013-09-15','08:35:00',1.69),('5819','2013-09-15','08:40:00',1.8),('5819','2013-09-15','08:45:00',1.9),('5819','2013-09-15','08:50:00',1.91),('5819','2013-09-15','08:55:00',1.83),('5819','2013-09-15','09:00:00',1.98),('5819','2013-09-15','09:05:00',2.03),('5819','2013-09-15','09:10:00',2.19),('5819','2013-09-15','09:15:00',2.38),('5819','2013-09-15','09:20:00',2.3),('5819','2013-09-15','09:25:00',2.39),('5819','2013-09-15','09:30:00',2.45),('5819','2013-09-15','09:35:00',2.58),('5819','2013-09-15','09:40:00',2.62),('5819','2013-09-15','09:45:00',2.64),('5819','2013-09-15','09:50:00',2.73),('5819','2013-09-15','09:55:00',2.74),('5819','2013-09-15','10:00:00',2.87),('5819','2013-09-15','10:05:00',2.92),('5819','2013-09-15','10:10:00',2.93),('5819','2013-09-15','10:15:00',2.79),('5819','2013-09-15','10:20:00',2.92),('5819','2013-09-15','10:25:00',3),('5819','2013-09-15','10:30:00',2.81),('5819','2013-09-15','10:35:00',2.6),('5819','2013-09-15','10:40:00',1.55),('5819','2013-09-15','10:45:00',1.41),('5819','2013-09-15','10:55:00',2.26),('5819','2013-09-15','11:00:00',2.13),('5819','2013-09-15','11:05:00',3.65),('5819','2013-09-15','11:10:00',2.73),('5819','2013-09-15','11:15:00',1.5),('5819','2013-09-15','11:20:00',1.22),('5819','2013-09-15','11:25:00',1.34),('5819','2013-09-15','11:30:00',1.11),('5819','2013-09-15','11:35:00',2.62),('5819','2013-09-15','11:40:00',1.42),('5819','2013-09-15','11:45:00',1.14),('5819','2013-09-15','11:50:00',2.8),('5819','2013-09-15','11:55:00',1.93),('5819','2013-09-15','12:00:00',1.14),('5819','2013-09-15','12:05:00',1.07),('5819','2013-09-15','12:10:00',1.04),('5819','2013-09-15','12:15:00',1.02),('5819','2013-09-15','12:20:00',1.2),('5819','2013-09-15','12:25:00',1.52),('5819','2013-09-15','12:30:00',1.62),('5819','2013-09-15','12:35:00',1.49),('5819','2013-09-15','12:40:00',1.48),('5819','2013-09-15','12:45:00',1.12),('5819','2013-09-15','12:50:00',1.17),('5819','2013-09-15','12:55:00',1.21),('5819','2013-09-15','13:00:00',1.18),('5819','2013-09-15','13:05:00',1.12),('5819','2013-09-15','13:35:00',1.13),('5819','2013-09-15','13:40:00',1.33),('5819','2013-09-15','13:45:00',2.04),('5819','2013-09-15','13:50:00',2.29),('5819','2013-09-15','13:55:00',1.22),('5819','2013-09-15','14:00:00',1.55),('5819','2013-09-15','14:05:00',1.52),('5819','2013-09-15','14:10:00',1.38),('5819','2013-09-15','14:15:00',1.29),('5819','2013-09-15','14:20:00',1.15),('5819','2013-09-15','14:25:00',1.16),('5819','2013-09-15','14:30:00',1.18),('5819','2013-09-15','14:40:00',1.04),('5819','2013-09-15','15:00:00',1.02),('5819','2013-09-15','15:05:00',1.08),('5819','2013-09-15','15:10:00',1.18),('5819','2013-09-15','15:15:00',2.16),('5819','2013-09-15','15:20:00',1.93),('5819','2013-09-15','15:25:00',1.41),('5819','2013-09-15','15:30:00',1.06),('5819','2013-09-15','15:35:00',1),('5819','2013-09-14','08:05:00',1.08),('5819','2013-09-14','08:10:00',1.18),('5819','2013-09-14','08:15:00',1.26),('5819','2013-09-14','08:20:00',1.36),('5819','2013-09-14','08:25:00',1.43),('5819','2013-09-14','08:30:00',1.52),('5819','2013-09-14','08:35:00',1.62),('5819','2013-09-14','08:40:00',1.72),('5819','2013-09-14','08:45:00',1.81),('5819','2013-09-14','08:50:00',1.88),('5819','2013-09-14','08:55:00',1.96),('5819','2013-09-14','09:00:00',2.05),('5819','2013-09-14','09:05:00',2.12),('5819','2013-09-14','09:10:00',2.2),('5819','2013-09-14','09:15:00',2.27),('5819','2013-09-14','09:20:00',2.35),('5819','2013-09-14','09:25:00',2.41),('5819','2013-09-14','09:30:00',2.49),('5819','2013-09-14','09:35:00',2.53),('5819','2013-09-14','09:40:00',2.59),('5819','2013-09-14','09:45:00',2.66),('5819','2013-09-14','09:50:00',2.67),('5819','2013-09-14','09:55:00',2.78),('5819','2013-09-14','10:00:00',2.73),('5819','2013-09-14','10:05:00',1.95),('5819','2013-09-14','10:10:00',2.64),('5819','2013-09-14','10:15:00',2.69),('5819','2013-09-14','10:20:00',2.92),('5819','2013-09-14','10:25:00',3.06),('5819','2013-09-14','10:30:00',3.06),('5819','2013-09-14','10:35:00',3.15),('5819','2013-09-14','10:40:00',3.28),('5819','2013-09-14','10:45:00',3.44),('5819','2013-09-14','10:50:00',3.7),('5819','2013-09-14','10:55:00',3.48),('5819','2013-09-14','11:00:00',3.75),('5819','2013-09-14','11:05:00',2),('5819','2013-09-14','11:25:00',2.27),('5819','2013-09-14','11:30:00',3.78),('5819','2013-09-14','11:35:00',3.71),('5819','2013-09-14','11:40:00',3.83),('5819','2013-09-14','11:45:00',3.68),('5819','2013-09-14','11:50:00',3.49),('5819','2013-09-14','11:55:00',3.12),('5819','2013-09-14','12:00:00',1.72),('5819','2013-09-14','12:05:00',3.14),('5819','2013-09-14','12:10:00',1.88),('5819','2013-09-14','12:15:00',1.85),('5819','2013-09-14','12:20:00',1.56),('5819','2013-09-14','12:35:00',1.38),('5819','2013-09-14','12:40:00',2.63),('5819','2013-09-14','12:45:00',1.25),('5819','2013-09-14','12:55:00',1.05),('5819','2013-09-14','13:15:00',3.45),('5819','2013-09-14','13:20:00',3.94),('5819','2013-09-14','13:25:00',3.38),('5819','2013-09-14','13:30:00',3.95),('5819','2013-09-14','13:35:00',2.71),('5819','2013-09-14','13:40:00',1.34),('5819','2013-09-14','13:45:00',2.25),('5819','2013-09-14','13:50:00',2.13),('5819','2013-09-14','13:55:00',3.36),('5819','2013-09-14','14:00:00',3.91),('5819','2013-09-14','14:05:00',3.59),('5819','2013-09-14','14:10:00',3.48),('5819','2013-09-14','14:15:00',3.43),('5819','2013-09-14','14:20:00',3.41),('5819','2013-09-14','14:25:00',3.26),('5819','2013-09-14','14:30:00',3.31),('5819','2013-09-14','14:35:00',3.25),('5819','2013-09-14','14:40:00',3.2),('5819','2013-09-14','14:45:00',3.16),('5819','2013-09-14','14:50:00',3.1),('5819','2013-09-14','14:55:00',3.05),('5819','2013-09-14','15:00:00',2.98),('5819','2013-09-14','15:05:00',2.93),('5819','2013-09-14','15:10:00',2.85),('5819','2013-09-14','15:15:00',2.81),('5819','2013-09-14','15:20:00',2.75),('5819','2013-09-14','15:25:00',2.72),('5819','2013-09-14','15:30:00',2.67),('5819','2013-09-14','15:35:00',2.57),('5819','2013-09-14','15:40:00',2.54),('5819','2013-09-14','15:45:00',2.47),('5819','2013-09-14','15:50:00',2.38),('5819','2013-09-14','15:55:00',2.32),('5819','2013-09-14','16:00:00',2.24),('5819','2013-09-14','16:05:00',2.18),('5819','2013-09-14','16:10:00',2.08),('5819','2013-09-14','16:15:00',2),('5819','2013-09-14','16:20:00',1.95),('5819','2013-09-14','16:25:00',1.85),('5819','2013-09-14','16:30:00',1.81),('5819','2013-09-14','16:35:00',1.73),('5819','2013-09-14','16:40:00',1.65),('5819','2013-09-14','16:45:00',1.57),('5819','2013-09-14','16:50:00',1.49),('5819','2013-09-14','16:55:00',1.42),('5819','2013-09-14','17:00:00',1.34),('5819','2013-09-14','17:05:00',1.23),('5819','2013-09-14','17:10:00',1.2),('5819','2013-09-14','17:15:00',1.14),('5819','2013-09-14','17:20:00',1.04),('5819','2013-09-13','08:55:00',1.03),('5819','2013-09-13','09:25:00',1.05),('5819','2013-09-13','09:30:00',1.14),('5819','2013-09-13','09:35:00',1.27),('5819','2013-09-13','09:40:00',1.53),('5819','2013-09-13','09:45:00',1.41),('5819','2013-09-13','09:50:00',1.41),('5819','2013-09-13','09:55:00',1.87),('5819','2013-09-13','10:00:00',2.77),('5819','2013-09-13','10:05:00',1.62),('5819','2013-09-13','10:10:00',1.92),('5819','2013-09-13','10:15:00',3.68),('5819','2013-09-13','10:20:00',3.3),('5819','2013-09-13','10:25:00',1.72),('5819','2013-09-13','10:30:00',2.05),('5819','2013-09-13','10:35:00',3.52),('5819','2013-09-13','10:40:00',3.27),('5819','2013-09-13','10:45:00',3.27),('5819','2013-09-13','10:50:00',3.29),('5819','2013-09-13','10:55:00',3.31),('5819','2013-09-13','11:00:00',3.35),('5819','2013-09-13','11:05:00',3.39),('5819','2013-09-13','11:10:00',3.42),('5819','2013-09-13','11:15:00',3.46),('5819','2013-09-13','11:20:00',3.45),('5819','2013-09-13','11:25:00',3.49),('5819','2013-09-13','11:30:00',3.49),('5819','2013-09-13','11:35:00',3.52),('5819','2013-09-13','11:40:00',3.54),('5819','2013-09-13','11:45:00',3.56),('5819','2013-09-13','11:50:00',3.58),('5819','2013-09-13','11:55:00',3.58),('5819','2013-09-13','12:00:00',3.6),('5819','2013-09-13','12:05:00',3.64),('5819','2013-09-13','12:10:00',3.64),('5819','2013-09-13','12:15:00',3.67),('5819','2013-09-13','12:20:00',3.69),('5819','2013-09-13','12:25:00',3.71),('5819','2013-09-13','12:30:00',2.09),('5819','2013-09-13','12:35:00',3.76),('5819','2013-09-13','12:40:00',3.75),('5819','2013-09-13','12:45:00',3.73),('5819','2013-09-13','12:50:00',3.72),('5819','2013-09-13','12:55:00',3.66),('5819','2013-09-13','13:00:00',3.65),('5819','2013-09-13','13:05:00',3.65),('5819','2013-09-13','13:10:00',3.63),('5819','2013-09-13','13:15:00',3.61),('5819','2013-09-13','13:20:00',3.6),('5819','2013-09-13','13:25:00',3.57),('5819','2013-09-13','13:30:00',3.54),('5819','2013-09-13','13:35:00',3.49),('5819','2013-09-13','13:40:00',3.46),('5819','2013-09-13','13:45:00',3.45),('5819','2013-09-13','13:50:00',3.45),('5819','2013-09-13','13:55:00',3.4),('5819','2013-09-13','14:00:00',3.39),('5819','2013-09-13','14:05:00',3.38),('5819','2013-09-13','14:10:00',3.34),('5819','2013-09-13','14:15:00',3.3),('5819','2013-09-13','14:20:00',3.27),('5819','2013-09-13','14:25:00',3.25),('5819','2013-09-13','14:30:00',3.23),('5819','2013-09-13','14:35:00',3.19),('5819','2013-09-13','14:40:00',3.11),('5819','2013-09-13','14:45:00',3.09),('5819','2013-09-13','14:50:00',3.06),('5819','2013-09-13','14:55:00',3),('5819','2013-09-13','15:00:00',2.9),('5819','2013-09-13','15:05:00',2.88),('5819','2013-09-13','15:10:00',2.85),('5819','2013-09-13','15:15:00',2.84),('5819','2013-09-13','15:20:00',2.76),('5819','2013-09-13','15:25:00',2.71),('5819','2013-09-13','15:30:00',2.63),('5819','2013-09-13','15:35:00',2.59),('5819','2013-09-13','15:40:00',2.53),('5819','2013-09-13','15:45:00',2.47),('5819','2013-09-13','15:50:00',2.41),('5819','2013-09-13','15:55:00',2.35),('5819','2013-09-13','16:00:00',2.27),('5819','2013-09-13','16:05:00',2.21),('5819','2013-09-13','16:10:00',2.13),('5819','2013-09-13','16:15:00',2.06),('5819','2013-09-13','16:20:00',1.99),('5819','2013-09-13','16:25:00',1.91),('5819','2013-09-13','16:30:00',1.82),('5819','2013-09-13','16:35:00',1.75),('5819','2013-09-13','16:40:00',1.67),('5819','2013-09-13','16:45:00',1.59),('5819','2013-09-13','16:50:00',1.51),('5819','2013-09-13','16:55:00',1.42),('5819','2013-09-13','17:00:00',1.33),('5819','2013-09-13','17:05:00',1.25),('5819','2013-09-13','17:10:00',1.18),('5819','2013-09-13','17:15:00',1.1),('5819','2013-09-13','17:20:00',1.03),('5819','2013-09-12','08:00:00',1.11),('5819','2013-09-12','08:15:00',1.44),('5819','2013-09-12','08:20:00',1.46),('5819','2013-09-12','08:25:00',1.66),('5819','2013-09-12','08:30:00',1.81),('5819','2013-09-12','08:35:00',1.64),('5819','2013-09-12','08:55:00',1.67),('5819','2013-09-12','09:00:00',2.05),('5819','2013-09-12','09:05:00',1.92),('5819','2013-09-12','09:10:00',1.41),('5819','2013-09-12','09:15:00',2.1),('5819','2013-09-12','09:20:00',2.15),('5819','2013-09-12','09:25:00',2.4),('5819','2013-09-12','09:30:00',2.57),('5819','2013-09-12','09:35:00',2.32),('5819','2013-09-12','09:40:00',1.92),('5819','2013-09-12','09:45:00',2.37),('5819','2013-09-12','09:50:00',1.97),('5819','2013-09-12','09:55:00',1.36),('5819','2013-09-12','10:00:00',1.03),('5819','2013-09-12','10:05:00',1.3),('5819','2013-09-12','10:10:00',1.63),('5819','2013-09-12','10:15:00',1.54),('5819','2013-09-12','10:20:00',1.36),('5819','2013-09-12','10:30:00',1.46),('5819','2013-09-12','10:35:00',1.55),('5819','2013-09-12','10:55:00',1.68),('5819','2013-09-12','11:00:00',2.17),('5819','2013-09-12','11:05:00',3.49),('5819','2013-09-12','11:10:00',2.6),('5819','2013-09-12','11:15:00',2.94),('5819','2013-09-12','11:45:00',1.86),('5819','2013-09-12','11:50:00',1.47),('5819','2013-09-12','11:55:00',2.95),('5819','2013-09-12','12:00:00',3.2),('5819','2013-09-12','12:05:00',3.74),('5819','2013-09-12','12:10:00',3.51),('5819','2013-09-12','12:15:00',3.48),('5819','2013-09-12','12:20:00',1.58),('5819','2013-09-12','12:25:00',1.69),('5819','2013-09-12','12:30:00',1.71),('5819','2013-09-12','12:35:00',2.52),('5819','2013-09-12','12:40:00',3.83),('5819','2013-09-12','12:45:00',1.45),('5819','2013-09-12','12:50:00',2.81),('5819','2013-09-12','12:55:00',1.69),('5819','2013-09-12','13:00:00',3.75),('5819','2013-09-12','13:05:00',3.06),('5819','2013-09-12','13:10:00',2.81),('5819','2013-09-12','13:15:00',3.26),('5819','2013-09-12','13:20:00',3.76),('5819','2013-09-12','13:25:00',4.36),('5819','2013-09-12','13:30:00',3.86),('5819','2013-09-12','13:35:00',3.01),('5819','2013-09-12','13:40:00',2.79),('5819','2013-09-12','13:45:00',3.74),('5819','2013-09-12','13:50:00',3.83),('5819','2013-09-12','13:55:00',3.61),('5819','2013-09-12','14:00:00',3.5),('5819','2013-09-12','14:05:00',3.26),('5819','2013-09-12','14:10:00',2.71),('5819','2013-09-12','14:15:00',3.54),('5819','2013-09-12','14:20:00',3.26),('5819','2013-09-12','14:25:00',3.54),('5819','2013-09-12','14:30:00',3.49),('5819','2013-09-12','14:35:00',2.86),('5819','2013-09-12','14:40:00',2.49),('5819','2013-09-12','14:45:00',3.28),('5819','2013-09-12','14:50:00',3.19),('5819','2013-09-12','14:55:00',3.13),('5819','2013-09-12','15:00:00',3.08),('5819','2013-09-12','15:05:00',3.07),('5819','2013-09-12','15:10:00',2.33),('5819','2013-09-12','15:15:00',2.68),('5819','2013-09-12','15:20:00',2.85),('5819','2013-09-12','15:25:00',2.49),('5819','2013-09-12','15:30:00',2.74),('5819','2013-09-12','15:35:00',2.67),('5819','2013-09-12','15:40:00',2.55),('5819','2013-09-12','15:45:00',2.57),('5819','2013-09-12','15:50:00',2.46),('5819','2013-09-12','15:55:00',2.32),('5819','2013-09-12','16:00:00',2.35),('5819','2013-09-12','16:05:00',1.83),('5819','2013-09-12','16:10:00',1.9),('5819','2013-09-12','16:15:00',2.09),('5819','2013-09-12','16:20:00',1.47),('5819','2013-09-12','16:25:00',1.63),('5819','2013-09-12','16:35:00',1.07),('5819','2013-09-12','16:40:00',1.24),('5819','2013-09-12','16:45:00',1.88),('5819','2013-09-12','16:50:00',1.07),('5819','2013-09-12','16:55:00',1.37),('5819','2013-09-12','17:05:00',1.53),('5819','2013-09-12','17:10:00',1.09),('5819','2013-09-12','17:15:00',1.28),('5819','2013-09-12','17:20:00',1.05),('5819','2013-09-11','08:05:00',1.36),('5819','2013-09-11','08:10:00',1.23),('5819','2013-09-11','08:15:00',1.1),('5819','2013-09-11','08:55:00',1.02),('5819','2013-09-11','09:00:00',1.62),('5819','2013-09-11','09:05:00',2.29),('5819','2013-09-11','09:10:00',2.52),('5819','2013-09-11','09:15:00',2.06),('5819','2013-09-11','09:20:00',2.74),('5819','2013-09-11','09:25:00',1.97),('5819','2013-09-11','09:30:00',1.53),('5819','2013-09-11','09:35:00',1.38),('5819','2013-09-11','09:40:00',1.56),('5819','2013-09-11','10:05:00',1.67),('5819','2013-09-11','10:10:00',1.74),('5819','2013-09-11','10:15:00',1.78),('5819','2013-09-11','10:20:00',3.12),('5819','2013-09-11','10:25:00',1.95),('5819','2013-09-11','10:30:00',3.06),('5819','2013-09-11','10:35:00',2.86),('5819','2013-09-11','10:40:00',2.75),('5819','2013-09-11','10:45:00',1.5),('5819','2013-09-11','10:50:00',2.73),('5819','2013-09-11','10:55:00',1.75),('5819','2013-09-11','11:00:00',1.49),('5819','2013-09-11','11:05:00',2.17),('5819','2013-09-11','11:10:00',2.87),('5819','2013-09-11','11:15:00',2.6),('5819','2013-09-11','11:20:00',3.69),('5819','2013-09-11','11:25:00',3.08),('5819','2013-09-11','11:35:00',2.55),('5819','2013-09-11','11:40:00',2.58),('5819','2013-09-11','11:45:00',3.8),('5819','2013-09-11','11:50:00',3.82),('5819','2013-09-11','11:55:00',3.91),('5819','2013-09-11','12:00:00',2.11),('5819','2013-09-11','12:05:00',3.79),('5819','2013-09-11','12:10:00',2.79),('5819','2013-09-11','12:15:00',2.28),('5819','2013-09-11','12:20:00',2.96),('5819','2013-09-11','12:25:00',2.8),('5819','2013-09-11','12:30:00',3.61),('5819','2013-09-11','12:35:00',3.42),('5819','2013-09-11','12:40:00',1.31),('5819','2013-09-11','12:45:00',1.41),('5819','2013-09-11','12:50:00',3.3),('5819','2013-09-11','12:55:00',3.58),('5819','2013-09-11','13:00:00',3.03),('5819','2013-09-11','13:05:00',3.66),('5819','2013-09-11','13:10:00',3.85),('5819','2013-09-11','13:15:00',4.03),('5819','2013-09-11','13:20:00',3.45),('5819','2013-09-11','13:25:00',3.65),('5819','2013-09-11','13:30:00',3.45),('5819','2013-09-11','13:35:00',1.88),('5819','2013-09-11','13:40:00',2.78),('5819','2013-09-11','13:45:00',1.66),('5819','2013-09-11','13:50:00',3.32),('5819','2013-09-11','13:55:00',2.76),('5819','2013-09-11','14:00:00',2.39),('5819','2013-09-11','14:05:00',3.71),('5819','2013-09-11','14:10:00',3.45),('5819','2013-09-11','14:15:00',3.56),('5819','2013-09-11','14:20:00',2.08),('5819','2013-09-11','14:25:00',3.49),('5819','2013-09-11','14:30:00',2.16),('5819','2013-09-11','14:35:00',3.21),('5819','2013-09-11','14:40:00',1.43),('5819','2013-09-11','14:45:00',2.79),('5819','2013-09-11','14:50:00',3.43),('5819','2013-09-11','14:55:00',3.14),('5819','2013-09-11','15:00:00',1.47),('5819','2013-09-11','15:05:00',3.29),('5819','2013-09-11','15:10:00',1.49),('5819','2013-09-11','15:15:00',3.04),('5819','2013-09-11','15:20:00',2.27),('5819','2013-09-11','15:25:00',2.84),('5819','2013-09-11','15:30:00',2.56),('5819','2013-09-11','15:35:00',1.43),('5819','2013-09-11','15:40:00',1.24),('5819','2013-09-11','15:45:00',2.49),('5819','2013-09-11','15:50:00',2.63),('5819','2013-09-11','15:55:00',1.89),('5819','2013-09-11','16:00:00',2.08),('5819','2013-09-11','16:05:00',2.47),('5819','2013-09-11','16:10:00',2.12),('5819','2013-09-11','16:15:00',2.22),('5819','2013-09-11','16:20:00',2.1),('5819','2013-09-11','16:25:00',1.98),('5819','2013-09-11','16:30:00',1.14),('5819','2013-09-11','16:35:00',1.6),('5819','2013-09-11','16:45:00',1.81),('5819','2013-09-11','16:50:00',1.6),('5819','2013-09-11','16:55:00',1.45),('5819','2013-09-11','17:00:00',1.32),('5819','2013-09-11','17:05:00',1.33),('5819','2013-09-11','17:10:00',1.24),('5819','2013-09-11','17:15:00',1.14),('5819','2013-09-11','17:20:00',1.06),('5819','2013-09-10','08:55:00',1.48),('5819','2013-09-10','09:00:00',1.94),('5819','2013-09-10','09:05:00',1.86),('5819','2013-09-10','09:10:00',2.43),('5819','2013-09-10','09:15:00',2.07),('5819','2013-09-10','09:20:00',1.6),('5819','2013-09-10','09:25:00',1.62),('5819','2013-09-10','09:30:00',2.54),('5819','2013-09-10','09:35:00',2.85),('5819','2013-09-10','09:40:00',1.54),('5819','2013-09-10','09:45:00',1.31),('5819','2013-09-10','09:50:00',1.18),('5819','2013-09-10','09:55:00',1.05),('5819','2013-09-10','10:35:00',1.03),('5819','2013-09-10','10:40:00',1.38),('5819','2013-09-10','10:45:00',1.98),('5819','2013-09-10','10:50:00',1.25),('5819','2013-09-10','10:55:00',1.17),('5819','2013-09-10','11:00:00',1.48),('5819','2013-09-10','11:05:00',1.27),('5819','2013-09-10','11:10:00',1.31),('5819','2013-09-10','11:15:00',1.13),('5819','2013-09-10','11:20:00',1.21),('5819','2013-09-10','11:25:00',1.55),('5819','2013-09-10','11:30:00',1.06),('5819','2013-09-10','11:45:00',1.25),('5819','2013-09-10','11:50:00',1.25),('5819','2013-09-10','11:55:00',1.62),('5819','2013-09-10','12:00:00',1.37),('5819','2013-09-10','12:05:00',1.07),('5819','2013-09-10','13:25:00',1),('5819','2013-09-10','13:40:00',1.59),('5819','2013-09-10','13:45:00',2.52),('5819','2013-09-10','13:50:00',1.71),('5819','2013-09-10','13:55:00',1.47),('5819','2013-09-10','14:00:00',1.03),('5819','2013-09-10','14:05:00',1.21),('5819','2013-09-10','14:10:00',1.22),('5819','2013-09-10','14:15:00',1.47),('5819','2013-09-10','14:20:00',1.49),('5819','2013-09-10','14:25:00',1.94),('5819','2013-09-10','14:30:00',1.87),('5819','2013-09-10','14:35:00',1.35),('5819','2013-09-10','14:40:00',1.59),('5819','2013-09-10','14:45:00',1.68),('5819','2013-09-10','14:50:00',1.9),('5819','2013-09-10','14:55:00',1.79),('5819','2013-09-10','15:00:00',2.08),('5819','2013-09-10','15:05:00',2.02),('5819','2013-09-10','15:10:00',1.55),('5819','2013-09-10','15:15:00',1.35),('5819','2013-09-10','15:20:00',1.8),('5819','2013-09-10','15:25:00',1.6),('5819','2013-09-10','15:30:00',1.8),('5819','2013-09-10','15:35:00',1.71),('5819','2013-09-10','15:40:00',1.1),('5819','2013-09-10','16:05:00',1.06),('5819','2013-09-10','16:10:00',1.13),('5819','2013-09-10','16:15:00',1.3),('5819','2013-09-09','07:50:00',1.05),('5819','2013-09-09','08:55:00',1.15),('5819','2013-09-09','09:00:00',1.26),('5819','2013-09-09','09:05:00',1.1),('5819','2013-09-09','09:40:00',1),('5819','2013-09-09','10:00:00',1.08),('5819','2013-09-09','10:05:00',1.63),('5819','2013-09-09','10:10:00',1.73),('5819','2013-09-09','10:15:00',1.7),('5819','2013-09-09','10:20:00',1.27),('5819','2013-09-09','10:25:00',1.15),('5819','2013-09-09','10:30:00',1.28),('5819','2013-09-09','10:35:00',1.62),('5819','2013-09-09','10:40:00',1.72),('5819','2013-09-09','10:45:00',1.88),('5819','2013-09-09','10:50:00',2.47),('5819','2013-09-09','10:55:00',2.41),('5819','2013-09-09','11:00:00',2.63),('5819','2013-09-09','11:05:00',2.02),('5819','2013-09-09','11:10:00',1.63),('5819','2013-09-09','11:15:00',1.99),('5819','2013-09-09','11:20:00',2.36),('5819','2013-09-09','11:25:00',2.64),('5819','2013-09-09','11:30:00',2.08),('5819','2013-09-09','11:35:00',2.01),('5819','2013-09-09','11:40:00',3.11),('5819','2013-09-09','11:45:00',3.22),('5819','2013-09-09','11:50:00',2.47),('5819','2013-09-09','11:55:00',3.02),('5819','2013-09-09','12:00:00',2.69),('5819','2013-09-09','12:05:00',3.01),('5819','2013-09-09','12:10:00',2.83),('5819','2013-09-09','12:15:00',2.13),('5819','2013-09-09','12:20:00',1.65),('5819','2013-09-09','12:25:00',1.21),('5819','2013-09-09','12:30:00',1.11),('5819','2013-09-09','12:40:00',1.15),('5819','2013-09-09','12:45:00',1.58),('5819','2013-09-09','12:50:00',1.23),('5819','2013-09-09','12:55:00',1.34),('5819','2013-09-09','13:00:00',1.27),('5819','2013-09-09','13:05:00',2.08),('5819','2013-09-09','13:10:00',2.49),('5819','2013-09-09','13:15:00',3.09),('5819','2013-09-09','13:20:00',2.48),('5819','2013-09-09','13:25:00',2.23),('5819','2013-09-09','13:30:00',2.66),('5819','2013-09-09','13:35:00',3.3),('5819','2013-09-09','13:40:00',3.3),('5819','2013-09-09','13:45:00',3.39),('5819','2013-09-09','13:50:00',3.63),('5819','2013-09-09','13:55:00',3.67),('5819','2013-09-09','14:00:00',3.32),('5819','2013-09-09','14:05:00',3.13),('5819','2013-09-09','14:10:00',3.43),('5819','2013-09-09','14:15:00',2.55),('5819','2013-09-09','14:20:00',1.86),('5819','2013-09-09','14:25:00',1.69),('5819','2013-09-09','14:30:00',1.6),('5819','2013-09-09','14:35:00',3.39),('5819','2013-09-09','14:40:00',3.25),('5819','2013-09-09','14:45:00',1.84),('5819','2013-09-09','14:50:00',2.88),('5819','2013-09-09','14:55:00',2.86),('5819','2013-09-09','15:00:00',2.4),('5819','2013-09-09','15:05:00',2.24),('5819','2013-09-09','15:10:00',2.53),('5819','2013-09-09','15:15:00',1.44),('5819','2013-09-09','15:20:00',1.77),('5819','2013-09-09','15:25:00',1.01),('5819','2013-09-09','15:30:00',2.51),('5819','2013-09-09','15:35:00',2.02),('5819','2013-09-09','15:40:00',2.16),('5819','2013-09-09','15:45:00',1.04),('5819','2013-09-09','15:50:00',1.03),('5819','2013-09-09','15:55:00',1.15),('5819','2013-09-09','16:00:00',1.26),('5819','2013-09-09','16:05:00',1.13),('5819','2013-09-09','16:10:00',1.32),('5819','2013-09-09','16:15:00',1.81),('5819','2013-09-09','16:20:00',1.48),('5819','2013-09-09','16:35:00',1.03),('5819','2013-09-09','16:40:00',1.2),('5819','2013-09-09','16:45:00',1.87),('5819','2013-09-08','09:10:00',1),('5819','2013-09-08','09:15:00',1.14),('5819','2013-09-08','09:20:00',1.41),('5819','2013-09-08','09:25:00',1.49),('5819','2013-09-08','09:30:00',2.08),('5819','2013-09-08','09:35:00',2.47),('5819','2013-09-08','09:40:00',2.41),('5819','2013-09-08','09:45:00',2.4),('5819','2013-09-08','09:50:00',2.5),('5819','2013-09-08','09:55:00',2.56),('5819','2013-09-08','10:00:00',2.58),('5819','2013-09-08','10:05:00',2.65),('5819','2013-09-08','10:10:00',2.7),('5819','2013-09-08','10:15:00',2.73),('5819','2013-09-08','10:20:00',2.83),('5819','2013-09-08','10:25:00',2.89),('5819','2013-09-08','10:30:00',2.91),('5819','2013-09-08','10:35:00',2.96),('5819','2013-09-08','10:40:00',2.93),('5819','2013-09-08','10:45:00',3.01),('5819','2013-09-08','10:50:00',3.04),('5819','2013-09-08','10:55:00',3.1),('5819','2013-09-08','11:00:00',3.14),('5819','2013-09-08','11:05:00',3.12),('5819','2013-09-08','11:10:00',3.11),('5819','2013-09-08','11:15:00',3.13),('5819','2013-09-08','11:20:00',3.12),('5819','2013-09-08','11:25:00',3.11),('5819','2013-09-08','11:30:00',3.18),('5819','2013-09-08','11:35:00',3.16),('5819','2013-09-08','11:40:00',3.19),('5819','2013-09-08','11:45:00',3.21),('5819','2013-09-08','11:50:00',3.16),('5819','2013-09-08','11:55:00',3.16),('5819','2013-09-08','12:00:00',3.13),('5819','2013-09-08','12:05:00',3.13),('5819','2013-09-08','12:10:00',3.18),('5819','2013-09-08','12:15:00',3.27),('5819','2013-09-08','12:20:00',3.33),('5819','2013-09-08','12:25:00',3.23),('5819','2013-09-08','12:30:00',3.25),('5819','2013-09-08','12:35:00',3.35),('5819','2013-09-08','12:40:00',3.24),('5819','2013-09-08','12:45:00',3.16),('5819','2013-09-08','12:50:00',3.21),('5819','2013-09-08','12:55:00',3.25),('5819','2013-09-08','13:00:00',3.21),('5819','2013-09-08','13:05:00',3.26),('5819','2013-09-08','13:10:00',3.3),('5819','2013-09-08','13:15:00',3.19),('5819','2013-09-08','13:20:00',3.14),('5819','2013-09-08','13:25:00',3.01),('5819','2013-09-08','13:30:00',2.81),('5819','2013-09-08','13:35:00',2.87),('5819','2013-09-08','13:40:00',2.23),('5819','2013-09-08','13:45:00',1.88),('5819','2013-09-08','13:50:00',2.14),('5819','2013-09-08','13:55:00',2.29),('5819','2013-09-08','14:00:00',2.87),('5819','2013-09-08','14:05:00',2.93),('5819','2013-09-08','14:10:00',3.05),('5819','2013-09-08','14:15:00',2.84),('5819','2013-09-08','14:20:00',2.57),('5819','2013-09-08','14:25:00',3.38),('5819','2013-09-08','14:30:00',2.91),('5819','2013-09-08','14:35:00',3.18),('5819','2013-09-08','14:40:00',3.02),('5819','2013-09-08','14:45:00',3.01),('5819','2013-09-08','14:50:00',2.96),('5819','2013-09-08','14:55:00',2.86),('5819','2013-09-08','15:00:00',2.84),('5819','2013-09-08','15:05:00',2.45),('5819','2013-09-08','15:10:00',1.5),('5819','2013-09-08','15:15:00',2.14),('5819','2013-09-08','15:20:00',2.65),('5819','2013-09-08','15:25:00',2.71),('5819','2013-09-08','15:30:00',2.7),('5819','2013-09-08','15:35:00',2.59),('5819','2013-09-08','15:40:00',2.38),('5819','2013-09-08','15:45:00',2.38),('5819','2013-09-08','15:50:00',2.41),('5819','2013-09-08','15:55:00',1.94),('5819','2013-09-08','16:00:00',1.95),('5819','2013-09-08','16:05:00',1.89),('5819','2013-09-08','16:10:00',1.79),('5819','2013-09-08','16:15:00',1.87),('5819','2013-09-08','16:20:00',1.81),('5819','2013-09-08','16:25:00',1.8),('5819','2013-09-08','16:30:00',1.65),('5819','2013-09-08','16:35:00',1.65),('5819','2013-09-08','16:40:00',1.43),('5819','2013-09-08','17:05:00',1.43),('5819','2013-09-08','17:10:00',1.36),('5819','2013-09-08','17:15:00',1.22),('5819','2013-09-08','17:20:00',1.06),('5819','2013-09-08','17:25:00',1),('5819','2013-09-07','08:00:00',1),('5819','2013-09-07','08:05:00',1.09),('5819','2013-09-07','08:10:00',1.17),('5819','2013-09-07','08:15:00',1.26),('5819','2013-09-07','08:20:00',1.34),('5819','2013-09-07','08:25:00',1.42),('5819','2013-09-07','08:30:00',1.49),('5819','2013-09-07','08:35:00',1.57),('5819','2013-09-07','08:40:00',1.67),('5819','2013-09-07','08:45:00',1.74),('5819','2013-09-07','08:50:00',1.81),('5819','2013-09-07','08:55:00',1.87),('5819','2013-09-07','09:00:00',1.95),('5819','2013-09-07','09:05:00',2.03),('5819','2013-09-07','09:10:00',2.11),('5819','2013-09-07','09:15:00',2.18),('5819','2013-09-07','09:20:00',2.22),('5819','2013-09-07','09:25:00',2.29),('5819','2013-09-07','09:30:00',2.38),('5819','2013-09-07','09:35:00',2.42),('5819','2013-09-07','09:40:00',2.47),('5819','2013-09-07','09:45:00',2.54),('5819','2013-09-07','09:50:00',2.57),('5819','2013-09-07','09:55:00',2.63),('5819','2013-09-07','10:00:00',2.68),('5819','2013-09-07','10:05:00',2.72),('5819','2013-09-07','10:10:00',2.77),('5819','2013-09-07','10:15:00',2.77),('5819','2013-09-07','10:20:00',2.84),('5819','2013-09-07','10:25:00',2.9),('5819','2013-09-07','10:30:00',2.93),('5819','2013-09-07','10:35:00',2.96),('5819','2013-09-07','10:40:00',3),('5819','2013-09-07','10:45:00',3.03),('5819','2013-09-07','10:50:00',3.07),('5819','2013-09-07','10:55:00',3.08),('5819','2013-09-07','11:00:00',3.1),('5819','2013-09-07','11:05:00',3.12),('5819','2013-09-07','11:10:00',3.17),('5819','2013-09-07','11:15:00',3.23),('5819','2013-09-07','11:20:00',3.24),('5819','2013-09-07','11:25:00',3.32),('5819','2013-09-07','11:30:00',3.34),('5819','2013-09-07','11:35:00',3.34),('5819','2013-09-07','11:40:00',3.34),('5819','2013-09-07','11:45:00',3.38),('5819','2013-09-07','11:50:00',3.37),('5819','2013-09-07','11:55:00',3.35),('5819','2013-09-07','12:00:00',3.35),('5819','2013-09-07','12:05:00',3.38),('5819','2013-09-07','12:10:00',3.41),('5819','2013-09-07','12:15:00',3.39),('5819','2013-09-07','12:20:00',3.39),('5819','2013-09-07','12:25:00',3.42),('5819','2013-09-07','12:30:00',3.38),('5819','2013-09-07','12:35:00',3.4),('5819','2013-09-07','12:40:00',3.38),('5819','2013-09-07','12:45:00',3.33),('5819','2013-09-07','12:50:00',3.42),('5819','2013-09-07','12:55:00',3.42),('5819','2013-09-07','13:00:00',3.42),('5819','2013-09-07','13:05:00',3.38),('5819','2013-09-07','13:10:00',3.37),('5819','2013-09-07','13:15:00',3.34),('5819','2013-09-07','13:20:00',3.33),('5819','2013-09-07','13:25:00',3.29),('5819','2013-09-07','13:30:00',3.29),('5819','2013-09-07','13:35:00',3.28),('5819','2013-09-07','13:40:00',3.36),('5819','2013-09-07','13:45:00',3.33),('5819','2013-09-07','13:50:00',3.31),('5819','2013-09-07','13:55:00',3.25),('5819','2013-09-07','14:00:00',1.84),('5819','2013-09-07','14:05:00',3.23),('5819','2013-09-07','14:10:00',3.25),('5819','2013-09-07','14:15:00',3.24),('5819','2013-09-07','14:20:00',3.15),('5819','2013-09-07','14:25:00',3.06),('5819','2013-09-07','14:30:00',3.06),('5819','2013-09-07','14:35:00',3.07),('5819','2013-09-07','14:40:00',3.03),('5819','2013-09-07','14:45:00',3.02),('5819','2013-09-07','14:50:00',2.96),('5819','2013-09-07','14:55:00',2.9),('5819','2013-09-07','15:00:00',2.89),('5819','2013-09-07','15:05:00',2.85),('5819','2013-09-07','15:10:00',2.76),('5819','2013-09-07','15:15:00',2.73),('5819','2013-09-07','15:20:00',2.68),('5819','2013-09-07','15:25:00',2.62),('5819','2013-09-07','15:30:00',2.57),('5819','2013-09-07','15:35:00',2.52),('5819','2013-09-07','15:40:00',2.44),('5819','2013-09-07','15:45:00',2.37),('5819','2013-09-07','15:50:00',2.32),('5819','2013-09-07','15:55:00',2.26),('5819','2013-09-07','16:00:00',2.2),('5819','2013-09-07','16:05:00',2.13),('5819','2013-09-07','16:10:00',2.06),('5819','2013-09-07','16:15:00',1.99),('5819','2013-09-07','16:20:00',1.91),('5819','2013-09-07','16:25:00',1.83),('5819','2013-09-07','16:30:00',1.77),('5819','2013-09-07','16:35:00',1.7),('5819','2013-09-07','16:40:00',1.63),('5819','2013-09-07','16:45:00',1.55),('5819','2013-09-07','16:50:00',1.47),('5819','2013-09-07','16:55:00',1.41),('5819','2013-09-07','17:00:00',1.33),('5819','2013-09-07','17:05:00',1.26),('5819','2013-09-07','17:10:00',1.19),('5819','2013-09-07','17:15:00',1.11),('5819','2013-09-07','17:20:00',1.04),('5819','2013-09-06','08:00:00',1.02),('5819','2013-09-06','08:05:00',1.12),('5819','2013-09-06','08:10:00',1.2),('5819','2013-09-06','08:15:00',1.28),('5819','2013-09-06','08:20:00',1.36),('5819','2013-09-06','08:25:00',1.44),('5819','2013-09-06','08:30:00',1.54),('5819','2013-09-06','08:35:00',1.62),('5819','2013-09-06','08:40:00',1.71),('5819','2013-09-06','08:45:00',1.8),('5819','2013-09-06','08:50:00',1.87),('5819','2013-09-06','08:55:00',1.93),('5819','2013-09-06','09:00:00',2.01),('5819','2013-09-06','09:05:00',2.09),('5819','2013-09-06','09:10:00',2.16),('5819','2013-09-06','09:15:00',2.22),('5819','2013-09-06','09:20:00',2.27),('5819','2013-09-06','09:25:00',2.32),('5819','2013-09-06','09:30:00',2.39),('5819','2013-09-06','09:35:00',2.45),('5819','2013-09-06','09:40:00',2.51),('5819','2013-09-06','09:45:00',2.57),('5819','2013-09-06','09:50:00',2.63),('5819','2013-09-06','09:55:00',2.67),('5819','2013-09-06','10:00:00',2.71),('5819','2013-09-06','10:05:00',2.77),('5819','2013-09-06','10:10:00',2.82),('5819','2013-09-06','10:15:00',2.85),('5819','2013-09-06','10:20:00',2.9),('5819','2013-09-06','10:25:00',2.95),('5819','2013-09-06','10:30:00',3.01),('5819','2013-09-06','10:35:00',3.03),('5819','2013-09-06','10:40:00',3.06),('5819','2013-09-06','10:45:00',3.09),('5819','2013-09-06','10:50:00',3.14),('5819','2013-09-06','10:55:00',3.18),('5819','2013-09-06','11:00:00',3.19),('5819','2013-09-06','11:05:00',3.2),('5819','2013-09-06','11:10:00',3.24),('5819','2013-09-06','11:15:00',3.28),('5819','2013-09-06','11:20:00',3.3),('5819','2013-09-06','11:25:00',3.29),('5819','2013-09-06','11:30:00',3.31),('5819','2013-09-06','11:35:00',3.33),('5819','2013-09-06','11:40:00',3.38),('5819','2013-09-06','11:45:00',3.37),('5819','2013-09-06','11:50:00',3.41),('5819','2013-09-06','11:55:00',3.42),('5819','2013-09-06','12:00:00',3.41),('5819','2013-09-06','12:05:00',3.41),('5819','2013-09-06','12:10:00',3.41),('5819','2013-09-06','12:15:00',3.44),('5819','2013-09-06','12:20:00',3.45),('5819','2013-09-06','12:25:00',3.46),('5819','2013-09-06','12:30:00',3.49),('5819','2013-09-06','12:35:00',3.5),('5819','2013-09-06','12:40:00',3.44),('5819','2013-09-06','12:45:00',3.4),('5819','2013-09-06','12:50:00',3.43),('5819','2013-09-06','12:55:00',3.46),('5819','2013-09-06','13:00:00',3.44),('5819','2013-09-06','13:05:00',3.42),('5819','2013-09-06','13:10:00',3.41),('5819','2013-09-06','13:15:00',3.39),('5819','2013-09-06','13:20:00',3.37),('5819','2013-09-06','13:25:00',3.34),('5819','2013-09-06','13:30:00',3.32),('5819','2013-09-06','13:35:00',3.32),('5819','2013-09-06','13:40:00',3.34),('5819','2013-09-06','13:45:00',3.29),('5819','2013-09-06','13:50:00',3.25),('5819','2013-09-06','13:55:00',3.22),('5819','2013-09-06','14:00:00',3.2),('5819','2013-09-06','14:05:00',3.16),('5819','2013-09-06','14:10:00',3.16),('5819','2013-09-06','14:15:00',3.16),('5819','2013-09-06','14:20:00',3.13),('5819','2013-09-06','14:25:00',3.1),('5819','2013-09-06','14:30:00',3.04),('5819','2013-09-06','14:35:00',2.98),('5819','2013-09-06','14:40:00',2.83),('5819','2013-09-06','14:45:00',2.88),('5819','2013-09-06','14:50:00',2.92),('5819','2013-09-06','14:55:00',2.9),('5819','2013-09-06','15:00:00',2.83),('5819','2013-09-06','15:05:00',2.77),('5819','2013-09-06','15:10:00',2.73),('5819','2013-09-06','15:15:00',2.69),('5819','2013-09-06','15:20:00',2.64),('5819','2013-09-06','15:25:00',2.59),('5819','2013-09-06','15:30:00',2.56),('5819','2013-09-06','15:35:00',2.49),('5819','2013-09-06','15:40:00',2.43),('5819','2013-09-06','15:45:00',2.38),('5819','2013-09-06','15:50:00',2.32),('5819','2013-09-06','15:55:00',2.28),('5819','2013-09-06','16:00:00',2.2),('5819','2013-09-06','16:05:00',2.12),('5819','2013-09-06','16:10:00',2.05),('5819','2013-09-06','16:15:00',1.99),('5819','2013-09-06','16:20:00',1.93),('5819','2013-09-06','16:25:00',1.88),('5819','2013-09-06','16:30:00',1.81),('5819','2013-09-06','16:35:00',1.73),('5819','2013-09-06','16:40:00',1.66),('5819','2013-09-06','16:45:00',1.6),('5819','2013-09-06','16:50:00',1.5),('5819','2013-09-06','16:55:00',1.44),('5819','2013-09-06','17:00:00',1.37),('5819','2013-09-06','17:05:00',1.27),('5819','2013-09-06','17:10:00',1.21),('5819','2013-09-06','17:15:00',1.13),('5819','2013-09-06','17:20:00',1.06),('5819','2013-09-05','07:50:00',1.01),('5819','2013-09-05','07:55:00',1.09),('5819','2013-09-05','08:00:00',1.17),('5819','2013-09-05','08:05:00',1.26),('5819','2013-09-05','08:10:00',1.34),('5819','2013-09-05','08:15:00',1.44),('5819','2013-09-05','08:20:00',1.54),('5819','2013-09-05','08:25:00',1.63),('5819','2013-09-05','08:30:00',1.71),('5819','2013-09-05','08:35:00',1.79),('5819','2013-09-05','08:40:00',1.87),('5819','2013-09-05','08:45:00',1.95),('5819','2013-09-05','08:50:00',2.03),('5819','2013-09-05','08:55:00',2.09),('5819','2013-09-05','09:00:00',2.16),('5819','2013-09-05','09:05:00',2.23),('5819','2013-09-05','09:10:00',2.29),('5819','2013-09-05','09:15:00',2.36),('5819','2013-09-05','09:20:00',2.43),('5819','2013-09-05','09:25:00',2.48),('5819','2013-09-05','09:30:00',2.55),('5819','2013-09-05','09:35:00',2.59),('5819','2013-09-05','09:40:00',2.65),('5819','2013-09-05','09:45:00',2.71),('5819','2013-09-05','09:50:00',2.77),('5819','2013-09-05','09:55:00',2.82),('5819','2013-09-05','10:00:00',2.88),('5819','2013-09-05','10:05:00',2.91),('5819','2013-09-05','10:10:00',2.95),('5819','2013-09-05','10:15:00',2.99),('5819','2013-09-05','10:20:00',3.03),('5819','2013-09-05','10:25:00',3.07),('5819','2013-09-05','10:30:00',3.11),('5819','2013-09-05','10:35:00',3.14),('5819','2013-09-05','10:40:00',3.18),('5819','2013-09-05','10:45:00',3.2),('5819','2013-09-05','10:50:00',3.23),('5819','2013-09-05','10:55:00',3.27),('5819','2013-09-05','11:00:00',3.28),('5819','2013-09-05','11:05:00',3.32),('5819','2013-09-05','11:10:00',3.34),('5819','2013-09-05','11:15:00',3.36),('5819','2013-09-05','11:20:00',3.39),('5819','2013-09-05','11:25:00',3.41),('5819','2013-09-05','11:30:00',3.42),('5819','2013-09-05','11:35:00',3.4),('5819','2013-09-05','11:40:00',3.38),('5819','2013-09-05','11:45:00',3.38),('5819','2013-09-05','11:50:00',3.48),('5819','2013-09-05','11:55:00',3.5),('5819','2013-09-05','12:00:00',3.49),('5819','2013-09-05','12:05:00',3.52),('5819','2013-09-05','12:10:00',3.52),('5819','2013-09-05','12:15:00',3.53),('5819','2013-09-05','12:20:00',3.52),('5819','2013-09-05','12:25:00',3.53),('5819','2013-09-05','12:30:00',3.5),('5819','2013-09-05','12:35:00',3.49),('5819','2013-09-05','12:40:00',3.52),('5819','2013-09-05','12:45:00',3.51),('5819','2013-09-05','12:50:00',3.51),('5819','2013-09-05','12:55:00',3.52),('5819','2013-09-05','13:00:00',3.52),('5819','2013-09-05','13:05:00',3.5),('5819','2013-09-05','13:10:00',3.49),('5819','2013-09-05','13:15:00',3.47),('5819','2013-09-05','13:20:00',3.46),('5819','2013-09-05','13:25:00',3.45),('5819','2013-09-05','13:30:00',3.42),('5819','2013-09-05','13:35:00',3.45),('5819','2013-09-05','13:40:00',3.45),('5819','2013-09-05','13:45:00',3.4),('5819','2013-09-05','13:50:00',3.36),('5819','2013-09-05','13:55:00',3.32),('5819','2013-09-05','14:00:00',3.28),('5819','2013-09-05','14:05:00',3.26),('5819','2013-09-05','14:10:00',3.25),('5819','2013-09-05','14:15:00',3.25),('5819','2013-09-05','14:20:00',3.21),('5819','2013-09-05','14:25:00',3.15),('5819','2013-09-05','14:30:00',3.09),('5819','2013-09-05','14:35:00',3.04),('5819','2013-09-05','14:40:00',2.97),('5819','2013-09-05','14:45:00',2.94),('5819','2013-09-05','14:50:00',2.91),('5819','2013-09-05','14:55:00',2.9),('5819','2013-09-05','15:00:00',2.89),('5819','2013-09-05','15:05:00',2.87),('5819','2013-09-05','15:10:00',2.84),('5819','2013-09-05','15:15:00',2.79),('5819','2013-09-05','15:20:00',2.75),('5819','2013-09-05','15:25:00',2.7),('5819','2013-09-05','15:30:00',2.64),('5819','2013-09-05','15:35:00',2.58),('5819','2013-09-05','15:40:00',2.5),('5819','2013-09-05','15:45:00',2.45),('5819','2013-09-05','15:50:00',2.38),('5819','2013-09-05','15:55:00',2.34),('5819','2013-09-05','16:00:00',2.29),('5819','2013-09-05','16:05:00',2.24),('5819','2013-09-05','16:10:00',2.16),('5819','2013-09-05','16:15:00',2.1),('5819','2013-09-05','16:20:00',2.04),('5819','2013-09-05','16:25:00',1.97),('5819','2013-09-05','16:30:00',1.9),('5819','2013-09-05','16:35:00',1.85),('5819','2013-09-05','16:40:00',1.8),('5819','2013-09-05','16:45:00',1.76),('5819','2013-09-05','16:50:00',1.57),('5819','2013-09-05','16:55:00',1.25),('5819','2013-09-05','17:10:00',1.04),('5819','2013-09-05','17:25:00',1.02),('5819','2013-09-05','17:35:00',1),('5819','2013-09-05','17:40:00',1.05),('5819','2013-09-04','07:50:00',1),('5819','2013-09-04','07:55:00',1.09),('5819','2013-09-04','08:00:00',1.18),('5819','2013-09-04','08:05:00',1.26),('5819','2013-09-04','08:10:00',1.34),('5819','2013-09-04','08:15:00',1.43),('5819','2013-09-04','08:20:00',1.53),('5819','2013-09-04','08:25:00',1.61),('5819','2013-09-04','08:30:00',1.69),('5819','2013-09-04','08:35:00',1.77),('5819','2013-09-04','08:40:00',1.84),('5819','2013-09-04','08:45:00',1.93),('5819','2013-09-04','08:50:00',2.01),('5819','2013-09-04','08:55:00',2.08),('5819','2013-09-04','09:00:00',2.16),('5819','2013-09-04','09:05:00',2.23),('5819','2013-09-04','09:10:00',2.31),('5819','2013-09-04','09:15:00',2.39),('5819','2013-09-04','09:20:00',2.47),('5819','2013-09-04','09:25:00',2.55),('5819','2013-09-04','09:30:00',2.62),('5819','2013-09-04','09:35:00',2.69),('5819','2013-09-04','09:40:00',2.75),('5819','2013-09-04','09:45:00',2.81),('5819','2013-09-04','09:50:00',2.87),('5819','2013-09-04','09:55:00',2.93),('5819','2013-09-04','10:00:00',2.98),('5819','2013-09-04','10:05:00',3.03),('5819','2013-09-04','10:10:00',3.07),('5819','2013-09-04','10:15:00',3.1),('5819','2013-09-04','10:20:00',3.14),('5819','2013-09-04','10:25:00',3.18),('5819','2013-09-04','10:30:00',3.23),('5819','2013-09-04','10:35:00',3.28),('5819','2013-09-04','10:40:00',3.31),('5819','2013-09-04','10:45:00',3.35),('5819','2013-09-04','10:50:00',3.38),('5819','2013-09-04','10:55:00',3.42),('5819','2013-09-04','11:00:00',3.44),('5819','2013-09-04','11:05:00',3.47),('5819','2013-09-04','11:10:00',3.49),('5819','2013-09-04','11:15:00',3.51),('5819','2013-09-04','11:20:00',3.53),('5819','2013-09-04','11:25:00',3.55),('5819','2013-09-04','11:30:00',3.56),('5819','2013-09-04','11:35:00',3.59),('5819','2013-09-04','11:40:00',3.62),('5819','2013-09-04','11:45:00',3.63),('5819','2013-09-04','11:50:00',3.66),('5819','2013-09-04','11:55:00',3.67),('5819','2013-09-04','12:00:00',3.68),('5819','2013-09-04','12:05:00',3.69),('5819','2013-09-04','12:10:00',3.68),('5819','2013-09-04','12:15:00',3.66),('5819','2013-09-04','12:20:00',3.3),('5819','2013-09-04','12:25:00',3.68),('5819','2013-09-04','12:30:00',3.68),('5819','2013-09-04','12:35:00',3.7),('5819','2013-09-04','12:40:00',3.7),('5819','2013-09-04','12:45:00',3.67),('5819','2013-09-04','12:50:00',3.67),('5819','2013-09-04','12:55:00',3.67),('5819','2013-09-04','13:00:00',3.63),('5819','2013-09-04','13:05:00',3.61),('5819','2013-09-04','13:10:00',3.62),('5819','2013-09-04','13:15:00',3.6),('5819','2013-09-04','13:20:00',3.61),('5819','2013-09-04','13:25:00',3.6),('5819','2013-09-04','13:30:00',3.59),('5819','2013-09-04','13:35:00',3.57),('5819','2013-09-04','13:40:00',3.55),('5819','2013-09-04','13:45:00',3.52),('5819','2013-09-04','13:50:00',3.5),('5819','2013-09-04','13:55:00',3.48),('5819','2013-09-04','14:00:00',3.44),('5819','2013-09-04','14:05:00',3.44),('5819','2013-09-04','14:10:00',3.43),('5819','2013-09-04','14:15:00',3.41),('5819','2013-09-04','14:20:00',3.35),('5819','2013-09-04','14:25:00',3.32),('5819','2013-09-04','14:30:00',3.28),('5819','2013-09-04','14:35:00',3.23),('5819','2013-09-04','14:40:00',3.19),('5819','2013-09-04','14:45:00',3.15),('5819','2013-09-04','14:50:00',3.11),('5819','2013-09-04','14:55:00',3.07),('5819','2013-09-04','15:00:00',3),('5819','2013-09-04','15:05:00',2.97),('5819','2013-09-04','15:10:00',2.91),('5819','2013-09-04','15:15:00',2.87),('5819','2013-09-04','15:20:00',2.82),('5819','2013-09-04','15:25:00',2.76),('5819','2013-09-04','15:30:00',2.7),('5819','2013-09-04','15:35:00',2.65),('5819','2013-09-04','15:40:00',2.58),('5819','2013-09-04','15:45:00',2.52),('5819','2013-09-04','15:50:00',2.46),('5819','2013-09-04','15:55:00',2.4),('5819','2013-09-04','16:00:00',2.32),('5819','2013-09-04','16:05:00',2.25),('5819','2013-09-04','16:10:00',2.19),('5819','2013-09-04','16:15:00',2.13),('5819','2013-09-04','16:20:00',2.05),('5819','2013-09-04','16:25:00',1.98),('5819','2013-09-04','16:30:00',1.91),('5819','2013-09-04','16:35:00',1.83),('5819','2013-09-04','16:40:00',1.75),('5819','2013-09-04','16:45:00',1.68),('5819','2013-09-04','16:50:00',1.6),('5819','2013-09-04','16:55:00',1.52),('5819','2013-09-04','17:00:00',1.44),('5819','2013-09-04','17:05:00',1.36),('5819','2013-09-04','17:10:00',1.28),('5819','2013-09-04','17:15:00',1.21),('5819','2013-09-04','17:20:00',1.13),('5819','2013-09-04','17:25:00',1.06),('5819','2013-09-02','08:00:00',1.04),('5819','2013-09-02','08:05:00',1.13),('5819','2013-09-02','08:10:00',1.21),('5819','2013-09-02','08:15:00',1.3),('5819','2013-09-02','08:20:00',1.39),('5819','2013-09-02','08:25:00',1.46),('5819','2013-09-02','08:30:00',1.54),('5819','2013-09-02','08:35:00',1.64),('5819','2013-09-02','08:40:00',1.73),('5819','2013-09-02','08:45:00',1.81),('5819','2013-09-02','08:50:00',1.88),('5819','2013-09-02','08:55:00',1.97),('5819','2013-09-02','09:00:00',2.05),('5819','2013-09-02','09:05:00',2.12),('5819','2013-09-02','09:10:00',2.2),('5819','2013-09-02','09:15:00',2.28),('5819','2013-09-02','09:20:00',2.34),('5819','2013-09-02','09:25:00',2.41),('5819','2013-09-02','09:30:00',2.48),('5819','2013-09-02','09:35:00',2.55),('5819','2013-09-02','09:40:00',2.61),('5819','2013-09-02','09:45:00',2.66),('5819','2013-09-02','09:50:00',2.72),('5819','2013-09-02','09:55:00',2.76),('5819','2013-09-02','10:00:00',2.8),('5819','2013-09-02','10:05:00',2.88),('5819','2013-09-02','10:10:00',2.93),('5819','2013-09-02','10:15:00',3),('5819','2013-09-02','10:20:00',3.03),('5819','2013-09-02','10:25:00',3.07),('5819','2013-09-02','10:30:00',3.1),('5819','2013-09-02','10:35:00',3.15),('5819','2013-09-02','10:40:00',3.17),('5819','2013-09-02','10:45:00',3.19),('5819','2013-09-02','10:50:00',3.22),('5819','2013-09-02','10:55:00',3.25),('5819','2013-09-02','11:00:00',3.29),('5819','2013-09-02','11:05:00',3.31),('5819','2013-09-02','11:10:00',3.36),('5819','2013-09-02','11:15:00',3.39),('5819','2013-09-02','11:20:00',3.4),('5819','2013-09-02','11:25:00',3.4),('5819','2013-09-02','11:30:00',3.43),('5819','2013-09-02','11:35:00',3.43),('5819','2013-09-02','11:40:00',3.45),('5819','2013-09-02','11:45:00',3.47),('5819','2013-09-02','11:50:00',3.48),('5819','2013-09-02','11:55:00',3.48),('5819','2013-09-02','12:00:00',3.51),('5819','2013-09-02','12:05:00',3.54),('5819','2013-09-02','12:10:00',3.55),('5819','2013-09-02','12:15:00',3.53),('5819','2013-09-02','12:20:00',3.54),('5819','2013-09-02','12:25:00',3.53),('5819','2013-09-02','12:30:00',3.53),('5819','2013-09-02','12:35:00',3.53),('5819','2013-09-02','12:40:00',3.51),('5819','2013-09-02','12:45:00',3.49),('5819','2013-09-02','12:50:00',3.53),('5819','2013-09-02','12:55:00',3.52),('5819','2013-09-02','13:00:00',3.54),('5819','2013-09-02','13:05:00',3.53),('5819','2013-09-02','13:10:00',3.51),('5819','2013-09-02','13:15:00',3.52),('5819','2013-09-02','13:20:00',3.5),('5819','2013-09-02','13:25:00',3.48),('5819','2013-09-02','13:30:00',3.44),('5819','2013-09-02','13:35:00',3.4),('5819','2013-09-02','13:40:00',3.33),('5819','2013-09-02','13:45:00',3.29),('5819','2013-09-02','13:50:00',3),('5819','2013-09-02','13:55:00',3.43),('5819','2013-09-02','14:00:00',3.38),('5819','2013-09-02','14:05:00',2.92),('5819','2013-09-02','14:10:00',2.98),('5819','2013-09-02','14:15:00',3.34),('5819','2013-09-02','14:20:00',3.28),('5819','2013-09-02','14:25:00',3.28),('5819','2013-09-02','14:30:00',3.26),('5819','2013-09-02','14:35:00',3.2),('5819','2013-09-02','14:40:00',3.21),('5819','2013-09-02','14:45:00',3.22),('5819','2013-09-02','14:50:00',3.18),('5819','2013-09-02','14:55:00',1.89),('5819','2013-09-02','15:00:00',2.96),('5819','2013-09-02','15:05:00',2.92),('5819','2013-09-02','15:10:00',2.86),('5819','2013-09-02','15:15:00',2.91),('5819','2013-09-02','15:20:00',1.67),('5819','2013-09-02','15:25:00',2.75),('5819','2013-09-02','15:30:00',1.56),('5819','2013-09-02','15:35:00',1.46),('5819','2013-09-02','15:40:00',2.71),('5819','2013-09-02','15:45:00',2.61),('5819','2013-09-02','15:50:00',2.57),('5819','2013-09-02','15:55:00',2.5),('5819','2013-09-02','16:00:00',2.38),('5819','2013-09-02','16:05:00',2.27),('5819','2013-09-02','16:10:00',2.23),('5819','2013-09-02','16:15:00',2.22),('5819','2013-09-02','16:20:00',2.18),('5819','2013-09-02','16:25:00',2.09),('5819','2013-09-02','16:30:00',2.01),('5819','2013-09-02','16:35:00',1.91),('5819','2013-09-02','16:40:00',1.8),('5819','2013-09-02','16:45:00',1.71),('5819','2013-09-02','16:50:00',1.6),('5819','2013-09-02','16:55:00',1.52),('5819','2013-09-02','17:00:00',1.42),('5819','2013-09-02','17:05:00',1.36),('5819','2013-09-02','17:10:00',1.3),('5819','2013-09-02','17:15:00',1.22),('5819','2013-09-02','17:20:00',1.15),('5819','2013-09-02','17:25:00',1.07),('5819','2013-09-01','07:55:00',1.05),('5819','2013-09-01','08:00:00',1.14),('5819','2013-09-01','08:05:00',1.23),('5819','2013-09-01','08:10:00',1.32),('5819','2013-09-01','08:15:00',1.4),('5819','2013-09-01','08:20:00',1.48),('5819','2013-09-01','08:25:00',1.56),('5819','2013-09-01','08:30:00',1.59),('5819','2013-09-01','08:35:00',1.72),('5819','2013-09-01','08:40:00',1.82),('5819','2013-09-01','08:45:00',1.89),('5819','2013-09-01','08:50:00',1.96),('5819','2013-09-01','08:55:00',2.04),('5819','2013-09-01','09:00:00',2.11),('5819','2013-09-01','09:05:00',2.17),('5819','2013-09-01','09:10:00',2.25),('5819','2013-09-01','09:15:00',2.32),('5819','2013-09-01','09:20:00',2.39),('5819','2013-09-01','09:25:00',2.45),('5819','2013-09-01','09:30:00',2.52),('5819','2013-09-01','09:35:00',2.59),('5819','2013-09-01','09:40:00',2.65),('5819','2013-09-01','09:45:00',2.7),('5819','2013-09-01','09:50:00',2.76),('5819','2013-09-01','09:55:00',2.8),('5819','2013-09-01','10:00:00',2.85),('5819','2013-09-01','10:05:00',2.89),('5819','2013-09-01','10:10:00',2.93),('5819','2013-09-01','10:15:00',2.97),('5819','2013-09-01','10:20:00',3.01),('5819','2013-09-01','10:25:00',3.06),('5819','2013-09-01','10:30:00',3.1),('5819','2013-09-01','10:35:00',3.13),('5819','2013-09-01','10:40:00',3.17),('5819','2013-09-01','10:45:00',3.22),('5819','2013-09-01','10:50:00',3.24),('5819','2013-09-01','10:55:00',3.28),('5819','2013-09-01','11:00:00',3.32),('5819','2013-09-01','11:05:00',3.35),('5819','2013-09-01','11:10:00',3.38),('5819','2013-09-01','11:15:00',3.39),('5819','2013-09-01','11:20:00',3.4),('5819','2013-09-01','11:25:00',3.41),('5819','2013-09-01','11:30:00',3.46),('5819','2013-09-01','11:35:00',3.47),('5819','2013-09-01','11:40:00',3.51),('5819','2013-09-01','11:45:00',3.52),('5819','2013-09-01','11:50:00',3.55),('5819','2013-09-01','11:55:00',3.57),('5819','2013-09-01','12:00:00',3.57),('5819','2013-09-01','12:05:00',3.51),('5819','2013-09-01','12:10:00',3.56),('5819','2013-09-01','12:15:00',3.57),('5819','2013-09-01','12:20:00',3.61),('5819','2013-09-01','12:25:00',3.55),('5819','2013-09-01','12:30:00',3.58),('5819','2013-09-01','12:35:00',3.55),('5819','2013-09-01','12:40:00',3.57),('5819','2013-09-01','12:45:00',3.56),('5819','2013-09-01','12:50:00',3.54),('5819','2013-09-01','12:55:00',3.52),('5819','2013-09-01','13:00:00',3.53),('5819','2013-09-01','13:05:00',3.47),('5819','2013-09-01','13:10:00',3.49),('5819','2013-09-01','13:15:00',3.39),('5819','2013-09-01','13:20:00',3.52),('5819','2013-09-01','13:25:00',3.5),('5819','2013-09-01','13:30:00',3.52),('5819','2013-09-01','13:35:00',3.49),('5819','2013-09-01','13:40:00',3.48),('5819','2013-09-01','13:45:00',3.37),('5819','2013-09-01','13:50:00',2.93),('5819','2013-09-01','13:55:00',3.15),('5819','2013-09-01','14:00:00',2.69),('5819','2013-09-01','14:05:00',2.7),('5819','2013-09-01','14:10:00',3.06),('5819','2013-09-01','14:15:00',3.12),('5819','2013-09-01','14:20:00',2.75),('5819','2013-09-01','14:25:00',2.82),('5819','2013-09-01','14:30:00',2.88),('5819','2013-09-01','14:35:00',2.86),('5819','2013-09-01','14:40:00',2.85),('5819','2013-09-01','14:45:00',2.9),('5819','2013-09-01','14:50:00',2.88),('5819','2013-09-01','14:55:00',2.77),('5819','2013-09-01','15:00:00',2.76),('5819','2013-09-01','15:05:00',2.73),('5819','2013-09-01','15:10:00',2.69),('5819','2013-09-01','15:15:00',2.56),('5819','2013-09-01','15:20:00',2.46),('5819','2013-09-01','15:25:00',2.27),('5819','2013-09-01','15:30:00',1.83),('5819','2013-09-01','15:35:00',2.04),('5819','2013-09-01','15:40:00',2.31),('5819','2013-09-01','15:45:00',2.19),('5819','2013-09-01','15:50:00',1.74),('5819','2013-09-01','15:55:00',1.77),('5819','2013-09-01','16:00:00',2.11),('5819','2013-09-01','16:05:00',2.15),('5819','2013-09-01','16:10:00',2.28),('5819','2013-09-01','16:15:00',2.18),('5819','2013-09-01','16:20:00',2.1),('5819','2013-09-01','16:25:00',1.97),('5819','2013-09-01','16:30:00',2.13),('5819','2013-09-01','16:35:00',2),('5819','2013-09-01','16:40:00',1.93),('5819','2013-09-01','16:45:00',1.82),('5819','2013-09-01','16:50:00',1.71),('5819','2013-09-01','16:55:00',1.55),('5819','2013-09-01','17:00:00',1.31),('5819','2013-09-01','17:05:00',1.22),('5819','2013-09-01','17:10:00',1.13),('5819','2013-09-01','17:15:00',1.07),('5819','2013-09-01','17:20:00',1.15),('5819','2013-09-01','17:25:00',1.11),('5819','2013-09-01','17:30:00',1),('5819','2013-08-31','08:20:00',1.24),('5819','2013-08-31','08:25:00',1.41),('5819','2013-08-31','08:30:00',1.68),('5819','2013-08-31','08:35:00',1.76),('5819','2013-08-31','08:40:00',1.87),('5819','2013-08-31','08:45:00',1.98),('5819','2013-08-31','08:50:00',2.14),('5819','2013-08-31','08:55:00',2.29),('5819','2013-08-31','09:00:00',2.41),('5819','2013-08-31','09:05:00',2.17),('5819','2013-08-31','09:10:00',1.78),('5819','2013-08-31','09:15:00',2.11),('5819','2013-08-31','09:20:00',2.41),('5819','2013-08-31','09:25:00',2.62),('5819','2013-08-31','09:30:00',2.65),('5819','2013-08-31','09:35:00',2.73),('5819','2013-08-31','09:40:00',2.76),('5819','2013-08-31','09:45:00',2.6),('5819','2013-08-31','09:50:00',2.67),('5819','2013-08-31','09:55:00',2.86),('5819','2013-08-31','10:00:00',3),('5819','2013-08-31','10:05:00',2.95),('5819','2013-08-31','10:10:00',3.08),('5819','2013-08-31','10:15:00',3.07),('5819','2013-08-31','10:20:00',3.13),('5819','2013-08-31','10:25:00',3.17),('5819','2013-08-31','10:30:00',3.23),('5819','2013-08-31','10:35:00',3.29),('5819','2013-08-31','10:40:00',3.3),('5819','2013-08-31','10:45:00',3.36),('5819','2013-08-31','10:50:00',3.42),('5819','2013-08-31','10:55:00',3.46),('5819','2013-08-31','11:00:00',3.51),('5819','2013-08-31','11:05:00',3.53),('5819','2013-08-31','11:10:00',3.55),('5819','2013-08-31','11:15:00',3.57),('5819','2013-08-31','11:20:00',3.6),('5819','2013-08-31','11:25:00',3.62),('5819','2013-08-31','11:30:00',3.64),('5819','2013-08-31','11:35:00',3.68),('5819','2013-08-31','11:40:00',3.69),('5819','2013-08-31','11:45:00',3.68),('5819','2013-08-31','11:50:00',3.69),('5819','2013-08-31','11:55:00',3.73),('5819','2013-08-31','12:00:00',3.74),('5819','2013-08-31','12:05:00',3.51),('5819','2013-08-31','12:10:00',3.73),('5819','2013-08-31','12:15:00',3.72),('5819','2013-08-31','12:20:00',3.65),('5819','2013-08-31','12:25:00',3.68),('5819','2013-08-31','12:30:00',3.69),('5819','2013-08-31','12:35:00',3.66),('5819','2013-08-31','12:40:00',3.66),('5819','2013-08-31','12:45:00',3.65),('5819','2013-08-31','12:50:00',3.63),('5819','2013-08-31','12:55:00',3.68),('5819','2013-08-31','13:00:00',3.64),('5819','2013-08-31','13:05:00',3.65),('5819','2013-08-31','13:10:00',3.61),('5819','2013-08-31','13:15:00',3.58),('5819','2013-08-31','13:20:00',3.59),('5819','2013-08-31','13:25:00',3.59),('5819','2013-08-31','13:30:00',3.56),('5819','2013-08-31','13:35:00',3.57),('5819','2013-08-31','13:40:00',3.55),('5819','2013-08-31','13:45:00',3.48),('5819','2013-08-31','13:50:00',3.48),('5819','2013-08-31','13:55:00',3.44),('5819','2013-08-31','14:00:00',3.45),('5819','2013-08-31','14:05:00',3.43),('5819','2013-08-31','14:10:00',3.39),('5819','2013-08-31','14:15:00',3.35),('5819','2013-08-31','14:20:00',3.27),('5819','2013-08-31','14:25:00',3.25),('5819','2013-08-31','14:30:00',3.22),('5819','2013-08-31','14:35:00',3.06),('5819','2013-08-31','14:40:00',3.1),('5819','2013-08-31','14:45:00',3.06),('5819','2013-08-31','14:50:00',3.04),('5819','2013-08-31','14:55:00',2.97),('5819','2013-08-31','15:00:00',2.94),('5819','2013-08-31','15:05:00',2.93),('5819','2013-08-31','15:10:00',2.88),('5819','2013-08-31','15:15:00',2.81),('5819','2013-08-31','15:20:00',2.75),('5819','2013-08-31','15:25:00',2.68),('5819','2013-08-31','15:30:00',2.65),('5819','2013-08-31','15:35:00',2.56),('5819','2013-08-31','15:40:00',2.54),('5819','2013-08-31','15:45:00',2.5),('5819','2013-08-31','15:50:00',2.43),('5819','2013-08-31','15:55:00',2.35),('5819','2013-08-31','16:00:00',2.31),('5819','2013-08-31','16:05:00',2.26),('5819','2013-08-31','16:10:00',2.19),('5819','2013-08-31','16:15:00',2.13),('5819','2013-08-31','16:20:00',2.05),('5819','2013-08-31','16:25:00',1.99),('5819','2013-08-31','16:30:00',1.89),('5819','2013-08-31','16:35:00',1.88),('5819','2013-08-31','16:40:00',1.79),('5819','2013-08-31','16:45:00',1.68),('5819','2013-08-31','16:50:00',1.61),('5819','2013-08-31','16:55:00',1.55),('5819','2013-08-31','17:00:00',1.47),('5819','2013-08-31','17:05:00',1.43),('5819','2013-08-31','17:10:00',1.37),('5819','2013-08-31','17:15:00',1.27),('5819','2013-08-31','17:20:00',1.18),('5819','2013-08-31','17:25:00',1.1),('5819','2013-08-30','08:00:00',1.1),('5819','2013-08-30','08:05:00',1.35),('5819','2013-08-30','08:10:00',1.47),('5819','2013-08-30','08:15:00',1.36),('5819','2013-08-30','08:20:00',1.45),('5819','2013-08-30','08:25:00',1.47),('5819','2013-08-30','08:30:00',1.52),('5819','2013-08-30','08:35:00',1.56),('5819','2013-08-30','08:40:00',1.6),('5819','2013-08-30','08:45:00',1.43),('5819','2013-08-30','08:50:00',1.28),('5819','2013-08-30','08:55:00',1.27),('5819','2013-08-30','09:00:00',1.47),('5819','2013-08-30','09:05:00',1.61),('5819','2013-08-30','09:10:00',1.41),('5819','2013-08-30','09:15:00',1.3),('5819','2013-08-30','09:20:00',1.18),('5819','2013-08-30','09:25:00',1.24),('5819','2013-08-30','09:30:00',1.64),('5819','2013-08-30','09:35:00',1.72),('5819','2013-08-30','09:40:00',1.77),('5819','2013-08-30','09:45:00',1.8),('5819','2013-08-30','09:50:00',1.79),('5819','2013-08-30','09:55:00',1.87),('5819','2013-08-30','10:00:00',1.91),('5819','2013-08-30','10:05:00',1.86),('5819','2013-08-30','10:10:00',1.88),('5819','2013-08-30','10:15:00',1.99),('5819','2013-08-30','10:20:00',2.1),('5819','2013-08-30','10:25:00',1.91),('5819','2013-08-30','10:30:00',2.14),('5819','2013-08-30','10:35:00',2.03),('5819','2013-08-30','10:40:00',1.93),('5819','2013-08-30','10:45:00',1.85),('5819','2013-08-30','10:50:00',1.97),('5819','2013-08-30','10:55:00',1.88),('5819','2013-08-30','11:00:00',1.94),('5819','2013-08-30','11:05:00',2.08),('5819','2013-08-30','11:10:00',2.18),('5819','2013-08-30','11:15:00',2.22),('5819','2013-08-30','11:20:00',2.21),('5819','2013-08-30','11:25:00',2.3),('5819','2013-08-30','11:30:00',2.17),('5819','2013-08-30','11:35:00',2.32),('5819','2013-08-30','11:40:00',2.51),('5819','2013-08-30','11:45:00',2.44),('5819','2013-08-30','11:50:00',2.87),('5819','2013-08-30','11:55:00',2.48),('5819','2013-08-30','12:00:00',2.25),('5819','2013-08-30','12:05:00',1.9),('5819','2013-08-30','12:10:00',2.08),('5819','2013-08-30','12:15:00',2.27),('5819','2013-08-30','12:20:00',2.42),('5819','2013-08-30','12:25:00',2.81),('5819','2013-08-30','12:30:00',3.06),('5819','2013-08-30','12:35:00',2.93),('5819','2013-08-30','12:40:00',2.81),('5819','2013-08-30','12:45:00',2.91),('5819','2013-08-30','12:50:00',2.84),('5819','2013-08-30','12:55:00',2.66),('5819','2013-08-30','13:00:00',2.58),('5819','2013-08-30','13:05:00',2.53),('5819','2013-08-30','13:10:00',2.57),('5819','2013-08-30','13:15:00',2.65),('5819','2013-08-30','13:20:00',2.95),('5819','2013-08-30','13:25:00',3.35),('5819','2013-08-30','13:30:00',3.59),('5819','2013-08-30','13:35:00',3.33),('5819','2013-08-30','13:40:00',3.52),('5819','2013-08-30','13:45:00',3.22),('5819','2013-08-30','13:50:00',3.18),('5819','2013-08-30','13:55:00',3.43),('5819','2013-08-30','14:00:00',3.52),('5819','2013-08-30','14:05:00',3.39),('5819','2013-08-30','14:10:00',3.41),('5819','2013-08-30','14:15:00',3.32),('5819','2013-08-30','14:20:00',3.36),('5819','2013-08-30','14:25:00',3.34),('5819','2013-08-30','14:30:00',3.3),('5819','2013-08-30','14:35:00',3.31),('5819','2013-08-30','14:40:00',3.18),('5819','2013-08-30','14:45:00',2.68),('5819','2013-08-30','14:50:00',2.19),('5819','2013-08-30','14:55:00',2.51),('5819','2013-08-30','15:00:00',2.2),('5819','2013-08-30','15:05:00',2.03),('5819','2013-08-30','15:10:00',1.97),('5819','2013-08-30','15:15:00',2.47),('5819','2013-08-30','15:20:00',2.18),('5819','2013-08-30','15:25:00',1.96),('5819','2013-08-30','15:30:00',1.77),('5819','2013-08-30','15:35:00',1.56),('5819','2013-08-30','15:40:00',1.64),('5819','2013-08-30','15:45:00',1.9),('5819','2013-08-30','15:50:00',2.02),('5819','2013-08-30','15:55:00',1.98),('5819','2013-08-30','16:00:00',1.87),('5819','2013-08-30','16:05:00',1.66),('5819','2013-08-30','16:10:00',1.39),('5819','2013-08-30','16:15:00',1.27),('5819','2013-08-30','16:20:00',1.4),('5819','2013-08-30','16:25:00',1.42),('5819','2013-08-30','16:30:00',1.46),('5819','2013-08-30','16:35:00',1.75),('5819','2013-08-30','16:40:00',1.36),('5819','2013-08-30','16:45:00',1.6),('5819','2013-08-30','16:50:00',1.83),('5819','2013-08-30','16:55:00',1.55),('5819','2013-08-30','17:00:00',1.2),('5819','2013-08-30','17:05:00',1.08),('5819','2013-08-30','17:10:00',1.3),('5819','2013-08-30','17:15:00',1.11),('5819','2013-08-30','17:35:00',1.07),('5819','2013-08-29','07:50:00',1.05),('5819','2013-08-29','07:55:00',1.14),('5819','2013-08-29','08:00:00',1.25),('5819','2013-08-29','08:05:00',1.32),('5819','2013-08-29','08:10:00',1.42),('5819','2013-08-29','08:15:00',1.52),('5819','2013-08-29','08:20:00',1.68),('5819','2013-08-29','08:25:00',1.85),('5819','2013-08-29','08:30:00',2.06),('5819','2013-08-29','08:35:00',1.99),('5819','2013-08-29','08:40:00',1.49),('5819','2013-08-29','08:45:00',1.06),('5819','2013-08-29','08:50:00',1.25),('5819','2013-08-29','08:55:00',1.59),('5819','2013-08-29','09:00:00',1.61),('5819','2013-08-29','09:05:00',1.56),('5819','2013-08-29','09:10:00',1.5),('5819','2013-08-29','09:15:00',1.62),('5819','2013-08-29','09:20:00',1.63),('5819','2013-08-29','09:25:00',1.5),('5819','2013-08-29','09:30:00',1.51),('5819','2013-08-29','09:35:00',1.67),('5819','2013-08-29','09:40:00',1.74),('5819','2013-08-29','09:45:00',1.48),('5819','2013-08-29','09:50:00',1.4),('5819','2013-08-29','09:55:00',1.45),('5819','2013-08-29','10:00:00',1.56),('5819','2013-08-29','10:05:00',1.47),('5819','2013-08-29','10:10:00',1.44),('5819','2013-08-29','10:15:00',1.44),('5819','2013-08-29','10:20:00',1.46),('5819','2013-08-29','10:25:00',1.44),('5819','2013-08-29','10:30:00',1.49),('5819','2013-08-29','10:35:00',1.41),('5819','2013-08-29','10:40:00',1.29),('5819','2013-08-29','10:45:00',1.19),('5819','2013-08-29','10:50:00',1.16),('5819','2013-08-29','10:55:00',1.27),('5819','2013-08-29','11:00:00',1.38),('5819','2013-08-29','11:05:00',1.38),('5819','2013-08-29','11:10:00',2.02),('5819','2013-08-29','11:15:00',2.45),('5819','2013-08-29','11:20:00',2.38),('5819','2013-08-29','11:25:00',1.77),('5819','2013-08-29','11:30:00',1.53),('5819','2013-08-29','11:35:00',1.32),('5819','2013-08-29','11:40:00',1.47),('5819','2013-08-29','11:45:00',1.72),('5819','2013-08-29','11:50:00',1.81),('5819','2013-08-29','11:55:00',1.73),('5819','2013-08-29','12:00:00',1.71),('5819','2013-08-29','12:05:00',1.92),('5819','2013-08-29','12:10:00',2.36),('5819','2013-08-29','12:15:00',2.85),('5819','2013-08-29','12:20:00',2.47),('5819','2013-08-29','12:25:00',2.52),('5819','2013-08-29','12:30:00',2.44),('5819','2013-08-29','12:35:00',3),('5819','2013-08-29','12:40:00',3.99),('5819','2013-08-29','12:45:00',4.14),('5819','2013-08-29','12:50:00',2.56),('5819','2013-08-29','12:55:00',3.04),('5819','2013-08-29','13:00:00',2.65),('5819','2013-08-29','13:05:00',2.31),('5819','2013-08-29','13:10:00',2.35),('5819','2013-08-29','13:15:00',2.23),('5819','2013-08-29','13:20:00',2.25),('5819','2013-08-29','13:25:00',1.94),('5819','2013-08-29','13:30:00',1.74),('5819','2013-08-29','13:35:00',1.64),('5819','2013-08-29','13:40:00',1.56),('5819','2013-08-29','13:45:00',1.45),('5819','2013-08-29','13:50:00',1.4),('5819','2013-08-29','13:55:00',1.58),('5819','2013-08-29','14:00:00',2.13),('5819','2013-08-29','14:05:00',1.62),('5819','2013-08-29','14:10:00',1.43),('5819','2013-08-29','14:15:00',1.23),('5819','2013-08-29','14:50:00',1.05),('5819','2013-08-29','14:55:00',1.22),('5819','2013-08-29','15:00:00',1.37),('5819','2013-08-29','15:05:00',1.54),('5819','2013-08-29','15:10:00',1.28),('5819','2013-08-29','15:15:00',1.07),('5819','2013-08-29','15:20:00',1.14),('5819','2013-08-29','15:25:00',1.32),('5819','2013-08-29','15:30:00',1.99),('5819','2013-08-29','15:35:00',2.13),('5819','2013-08-29','15:40:00',1.88),('5819','2013-08-29','15:45:00',2.02),('5819','2013-08-29','15:50:00',2.51),('5819','2013-08-29','15:55:00',2.93),('5819','2013-08-29','16:00:00',2.88),('5819','2013-08-29','16:05:00',2.73),('5819','2013-08-29','16:10:00',2.72),('5819','2013-08-29','16:15:00',2.44),('5819','2013-08-29','16:20:00',2.28),('5819','2013-08-29','16:25:00',2.17),('5819','2013-08-29','16:30:00',2.02),('5819','2013-08-29','16:35:00',2),('5819','2013-08-29','16:40:00',1.91),('5819','2013-08-29','16:45:00',1.82),('5819','2013-08-29','16:50:00',1.74),('5819','2013-08-29','16:55:00',1.66),('5819','2013-08-29','17:00:00',1.58),('5819','2013-08-29','17:05:00',1.51),('5819','2013-08-29','17:10:00',1.42),('5819','2013-08-29','17:15:00',1.34),('5819','2013-08-29','17:20:00',1.26),('5819','2013-08-29','17:25:00',1.18),('5819','2013-08-29','17:30:00',1.02),('5819','2013-08-28','07:50:00',1.04),('5819','2013-08-28','08:00:00',1.15),('5819','2013-08-28','08:05:00',1.27),('5819','2013-08-28','08:10:00',1.34),('5819','2013-08-28','08:15:00',1.43),('5819','2013-08-28','08:20:00',1.49),('5819','2013-08-28','08:25:00',1.5),('5819','2013-08-28','08:30:00',1.64),('5819','2013-08-28','08:35:00',1.81),('5819','2013-08-28','08:40:00',1.69),('5819','2013-08-28','08:45:00',1.55),('5819','2013-08-28','08:50:00',1.22),('5819','2013-08-28','08:55:00',1.14),('5819','2013-08-28','09:00:00',1.76),('5819','2013-08-28','09:05:00',1.46),('5819','2013-08-28','09:10:00',1.47),('5819','2013-08-28','09:15:00',1.48),('5819','2013-08-28','09:20:00',1.4),('5819','2013-08-28','09:30:00',1.32),('5819','2013-08-28','09:35:00',2.67),('5819','2013-08-28','09:40:00',2.75),('5819','2013-08-28','09:45:00',2.78),('5819','2013-08-28','09:50:00',2.84),('5819','2013-08-28','09:55:00',2.85),('5819','2013-08-28','10:00:00',2.87),('5819','2013-08-28','10:05:00',2.95),('5819','2013-08-28','10:10:00',1.3),('5819','2013-08-28','10:15:00',3.1),('5819','2013-08-28','10:20:00',3.18),('5819','2013-08-28','10:25:00',2.32),('5819','2013-08-28','10:30:00',2.5),('5819','2013-08-28','10:35:00',2.07),('5819','2013-08-28','10:40:00',3.01),('5819','2013-08-28','10:45:00',2.39),('5819','2013-08-28','10:50:00',3.39),('5819','2013-08-28','10:55:00',3.52),('5819','2013-08-28','11:00:00',2.79),('5819','2013-08-28','11:05:00',1.86),('5819','2013-08-28','11:10:00',2.43),('5819','2013-08-28','11:15:00',3.25),('5819','2013-08-28','11:20:00',3.15),('5819','2013-08-28','11:25:00',3.73),('5819','2013-08-28','11:30:00',3.8),('5819','2013-08-28','11:35:00',3.76),('5819','2013-08-28','11:40:00',3.99),('5819','2013-08-28','11:45:00',3.43),('5819','2013-08-28','11:50:00',2.11),('5819','2013-08-28','11:55:00',3.52),('5819','2013-08-28','12:00:00',1.5),('5819','2013-08-28','12:05:00',3.36),('5819','2013-08-28','12:10:00',3.96),('5819','2013-08-28','12:15:00',3.97),('5819','2013-08-28','12:20:00',3.89),('5819','2013-08-28','12:25:00',3.74),('5819','2013-08-28','12:30:00',3.86),('5819','2013-08-28','12:35:00',3.83),('5819','2013-08-28','12:40:00',3.66),('5819','2013-08-28','12:45:00',3.94),('5819','2013-08-28','12:50:00',3.93),('5819','2013-08-28','12:55:00',3.85),('5819','2013-08-28','13:00:00',3.85),('5819','2013-08-28','13:05:00',3.36),('5819','2013-08-28','13:10:00',3.73),('5819','2013-08-28','13:15:00',3.92),('5819','2013-08-28','13:20:00',3.83),('5819','2013-08-28','13:25:00',3.85),('5819','2013-08-28','13:30:00',3.83),('5819','2013-08-28','13:35:00',3.75),('5819','2013-08-28','13:40:00',3.76),('5819','2013-08-28','13:45:00',3.61),('5819','2013-08-28','13:50:00',3.6),('5819','2013-08-28','13:55:00',3.73),('5819','2013-08-28','14:00:00',3.25),('5819','2013-08-28','14:05:00',3.69),('5819','2013-08-28','14:10:00',3.42),('5819','2013-08-28','14:15:00',3.68),('5819','2013-08-28','14:20:00',3.56),('5819','2013-08-28','14:25:00',3.53),('5819','2013-08-28','14:30:00',3.38),('5819','2013-08-28','14:35:00',2.73),('5819','2013-08-28','14:40:00',2.45),('5819','2013-08-28','14:45:00',3.49),('5819','2013-08-28','14:50:00',3.32),('5819','2013-08-28','14:55:00',3.3),('5819','2013-08-28','15:00:00',3.24),('5819','2013-08-28','15:05:00',3.2),('5819','2013-08-28','15:10:00',3.21),('5819','2013-08-28','15:15:00',3.15),('5819','2013-08-28','15:20:00',3.09),('5819','2013-08-28','15:25:00',3),('5819','2013-08-28','15:30:00',2.14),('5819','2013-08-28','15:35:00',2.02),('5819','2013-08-28','15:40:00',2.22),('5819','2013-08-28','15:45:00',1.4),('5819','2013-08-28','15:50:00',2.65),('5819','2013-08-28','15:55:00',2.1),('5819','2013-08-28','16:00:00',2.56),('5819','2013-08-28','16:05:00',2.55),('5819','2013-08-28','16:10:00',2.67),('5819','2013-08-28','16:15:00',2.44),('5819','2013-08-28','16:20:00',1.34),('5819','2013-08-28','16:25:00',2.46),('5819','2013-08-28','16:30:00',2.27),('5819','2013-08-28','16:35:00',1.83),('5819','2013-08-28','16:40:00',2.11),('5819','2013-08-28','16:45:00',1.97),('5819','2013-08-28','16:50:00',1.82),('5819','2013-08-28','16:55:00',1.6),('5819','2013-08-28','17:00:00',1.7),('5819','2013-08-28','17:05:00',1.56),('5819','2013-08-27','08:20:00',1.18),('5819','2013-08-27','08:25:00',1.64),('5819','2013-08-27','08:30:00',1.66),('5819','2013-08-27','08:35:00',1.15),('5819','2013-08-27','08:40:00',1.08),('5819','2013-08-27','08:45:00',1.34),('5819','2013-08-27','09:00:00',1.04),('5819','2013-08-27','09:05:00',1.1),('5819','2013-08-27','09:10:00',1.42),('5819','2013-08-27','09:15:00',1.47),('5819','2013-08-27','09:20:00',1.63),('5819','2013-08-27','09:25:00',2.18),('5819','2013-08-27','09:30:00',2.4),('5819','2013-08-27','09:35:00',1.43),('5819','2013-08-27','09:40:00',1.05),('5819','2013-08-27','09:45:00',1.09),('5819','2013-08-27','09:50:00',1.14),('5819','2013-08-27','09:55:00',1.47),('5819','2013-08-27','10:00:00',1.96),('5819','2013-08-27','10:05:00',2.38),('5819','2013-08-27','10:10:00',2.86),('5819','2013-08-27','10:15:00',2.95),('5819','2013-08-27','10:20:00',3.07),('5819','2013-08-27','10:25:00',3.1),('5819','2013-08-27','10:30:00',3.11),('5819','2013-08-27','10:35:00',3.18),('5819','2013-08-27','10:40:00',3.12),('5819','2013-08-27','10:45:00',3.21),('5819','2013-08-27','10:50:00',3.27),('5819','2013-08-27','10:55:00',3.25),('5819','2013-08-27','11:00:00',3.29),('5819','2013-08-27','11:05:00',3.35),('5819','2013-08-27','11:10:00',3.33),('5819','2013-08-27','11:15:00',3.32),('5819','2013-08-27','11:20:00',3.21),('5819','2013-08-27','11:25:00',3.35),('5819','2013-08-27','11:30:00',3.4),('5819','2013-08-27','11:35:00',3.43),('5819','2013-08-27','11:40:00',3.35),('5819','2013-08-27','11:45:00',3.85),('5819','2013-08-27','11:50:00',3.48),('5819','2013-08-27','11:55:00',3.63),('5819','2013-08-27','12:00:00',3.76),('5819','2013-08-27','12:05:00',3.77),('5819','2013-08-27','12:10:00',3.18),('5819','2013-08-27','12:15:00',3.19),('5819','2013-08-27','12:20:00',3.49),('5819','2013-08-27','12:25:00',3.28),('5819','2013-08-27','12:30:00',3.61),('5819','2013-08-27','12:35:00',3.81),('5819','2013-08-27','12:40:00',3.46),('5819','2013-08-27','12:45:00',2.89),('5819','2013-08-27','12:50:00',2.24),('5819','2013-08-27','12:55:00',2.06),('5819','2013-08-27','13:00:00',1.45),('5819','2013-08-27','13:05:00',1.62),('5819','2013-08-27','13:10:00',2.29),('5819','2013-08-27','13:15:00',1.68),('5819','2013-08-27','13:20:00',1.7),('5819','2013-08-27','13:25:00',1.79),('5819','2013-08-27','13:30:00',2.3),('5819','2013-08-27','13:35:00',1.81),('5819','2013-08-27','13:40:00',1.78),('5819','2013-08-27','13:45:00',1.95),('5819','2013-08-27','13:50:00',3.65),('5819','2013-08-27','13:55:00',2.88),('5819','2013-08-27','14:00:00',3.16),('5819','2013-08-27','14:05:00',2.03),('5819','2013-08-27','14:10:00',1.84),('5819','2013-08-27','14:15:00',3.12),('5819','2013-08-27','14:20:00',2.4),('5819','2013-08-27','14:25:00',1.36),('5819','2013-08-27','14:30:00',1.05),('5819','2013-08-27','14:35:00',1.06),('5819','2013-08-27','14:40:00',1.15),('5819','2013-08-27','14:45:00',1.23),('5819','2013-08-27','14:50:00',1.02),('5819','2013-08-27','16:00:00',1.27),('5819','2013-08-27','16:05:00',1.32),('5819','2013-08-27','16:10:00',2.52),('5819','2013-08-27','16:15:00',2.67),('5819','2013-08-27','16:20:00',1.33),('5819','2013-08-27','16:25:00',1.49),('5819','2013-08-27','16:30:00',1.18),('5819','2013-08-27','16:35:00',1.15),('5819','2013-08-27','16:40:00',1.27),('5819','2013-08-27','16:50:00',1.34),('5819','2013-08-27','17:10:00',1.91),('5819','2013-08-27','17:15:00',1.25),('5819','2013-08-27','17:50:00',1.06),('5819','2013-08-27','17:55:00',1.01),('5819','2013-08-26','07:55:00',1.03),('5819','2013-08-26','08:05:00',1.49),('5819','2013-08-26','08:10:00',1.45),('5819','2013-08-26','08:20:00',1.49),('5819','2013-08-26','08:25:00',1.29),('5819','2013-08-26','08:30:00',1.83),('5819','2013-08-26','08:35:00',1.56),('5819','2013-08-26','08:40:00',1.73),('5819','2013-08-26','08:45:00',1.91),('5819','2013-08-26','08:50:00',1.97),('5819','2013-08-26','08:55:00',2.05),('5819','2013-08-26','09:00:00',2.11),('5819','2013-08-26','09:05:00',2.16),('5819','2013-08-26','09:10:00',2.25),('5819','2013-08-26','09:15:00',2.31),('5819','2013-08-26','09:20:00',2.38),('5819','2013-08-26','09:25:00',2.43),('5819','2013-08-26','09:30:00',2.51),('5819','2013-08-26','09:35:00',2.57),('5819','2013-08-26','09:40:00',2.64),('5819','2013-08-26','09:45:00',2.68),('5819','2013-08-26','09:50:00',2.73),('5819','2013-08-26','09:55:00',2.77),('5819','2013-08-26','10:00:00',2.82),('5819','2013-08-26','10:05:00',2.88),('5819','2013-08-26','10:10:00',2.91),('5819','2013-08-26','10:15:00',2.95),('5819','2013-08-26','10:20:00',3.03),('5819','2013-08-26','10:25:00',3.09),('5819','2013-08-26','10:30:00',3.12),('5819','2013-08-26','10:35:00',3.16),('5819','2013-08-26','10:40:00',3.19),('5819','2013-08-26','10:45:00',3.23),('5819','2013-08-26','10:50:00',3.25),('5819','2013-08-26','10:55:00',3.34),('5819','2013-08-26','11:00:00',3.37),('5819','2013-08-26','11:05:00',3.39),('5819','2013-08-26','11:10:00',3.39),('5819','2013-08-26','11:15:00',3.43),('5819','2013-08-26','11:20:00',3.46),('5819','2013-08-26','11:25:00',3.46),('5819','2013-08-26','11:30:00',3.46),('5819','2013-08-26','11:35:00',3.53),('5819','2013-08-26','11:40:00',3.55),('5819','2013-08-26','11:45:00',3.54),('5819','2013-08-26','11:50:00',3.53),('5819','2013-08-26','11:55:00',3.54),('5819','2013-08-26','12:00:00',3.58),('5819','2013-08-26','12:05:00',3.58),('5819','2013-08-26','12:10:00',3.6),('5819','2013-08-26','12:15:00',3.61),('5819','2013-08-26','12:20:00',3.61),('5819','2013-08-26','12:25:00',3.58),('5819','2013-08-26','12:30:00',3.56),('5819','2013-08-26','12:35:00',3.54),('5819','2013-08-26','12:40:00',3.53),('5819','2013-08-26','12:45:00',3.6),('5819','2013-08-26','12:50:00',3.63),('5819','2013-08-26','12:55:00',3.21),('5819','2013-08-26','13:00:00',3.77),('5819','2013-08-26','13:05:00',4.11),('5819','2013-08-26','13:10:00',3.81),('5819','2013-08-26','13:15:00',2.67),('5819','2013-08-26','13:20:00',2.81),('5819','2013-08-26','13:25:00',2.6),('5819','2013-08-26','13:30:00',2.59),('5819','2013-08-26','13:35:00',3.48),('5819','2013-08-26','13:40:00',3.53),('5819','2013-08-26','13:45:00',3.52),('5819','2013-08-26','13:50:00',3.65),('5819','2013-08-26','13:55:00',2.94),('5819','2013-08-26','14:00:00',2.84),('5819','2013-08-26','14:05:00',3.5),('5819','2013-08-26','14:10:00',2.25),('5819','2013-08-26','14:15:00',3.55),('5819','2013-08-26','14:20:00',3.36),('5819','2013-08-26','14:25:00',3.26),('5819','2013-08-26','14:30:00',3.26),('5819','2013-08-26','14:35:00',3.18),('5819','2013-08-26','14:40:00',2.9),('5819','2013-08-26','14:45:00',2.34),('5819','2013-08-26','14:50:00',1.89),('5819','2013-08-26','14:55:00',1.7),('5819','2013-08-26','15:00:00',1.64),('5819','2013-08-26','15:05:00',1.32),('5819','2013-08-26','15:40:00',1.37),('5819','2013-08-26','15:45:00',1.51),('5819','2013-08-26','15:50:00',1.47),('5819','2013-08-26','15:55:00',1.4),('5819','2013-08-26','16:00:00',1.74),('5819','2013-08-26','16:05:00',2.77),('5819','2013-08-26','16:10:00',2.38),('5819','2013-08-26','16:15:00',2.22),('5819','2013-08-26','16:20:00',2.16),('5819','2013-08-26','16:25:00',2.05),('5819','2013-08-26','16:30:00',1.99),('5819','2013-08-26','16:35:00',1.92),('5819','2013-08-26','16:40:00',1.87),('5819','2013-08-26','16:45:00',1.83),('5819','2013-08-26','16:50:00',1.69),('5819','2013-08-26','16:55:00',1.61),('5819','2013-08-26','17:00:00',1.57),('5819','2013-08-26','17:05:00',1.42),('5819','2013-08-26','17:10:00',1.4),('5819','2013-08-26','17:15:00',1.33),('5819','2013-08-26','17:20:00',1.08),('5819','2013-08-25','08:00:00',1.05),('5819','2013-08-25','08:05:00',1.15),('5819','2013-08-25','08:10:00',1.33),('5819','2013-08-25','08:15:00',1.37),('5819','2013-08-25','08:20:00',1.17),('5819','2013-08-25','08:25:00',1.23),('5819','2013-08-25','08:30:00',1.18),('5819','2013-08-25','08:35:00',1.02),('5819','2013-08-25','08:40:00',1.11),('5819','2013-08-25','08:45:00',1.67),('5819','2013-08-25','09:20:00',2.18),('5819','2013-08-25','09:25:00',1.94),('5819','2013-08-25','09:30:00',2.34),('5819','2013-08-25','09:35:00',2.15),('5819','2013-08-25','09:40:00',2.93),('5819','2013-08-25','09:45:00',3.2),('5819','2013-08-25','09:50:00',2.95),('5819','2013-08-25','09:55:00',3.26),('5819','2013-08-25','10:00:00',2.4),('5819','2013-08-25','10:05:00',1.69),('5819','2013-08-25','15:15:00',1.06),('5819','2013-08-25','15:20:00',1.26),('5819','2013-08-25','15:25:00',1.4),('5819','2013-08-25','15:30:00',1.92),('5819','2013-08-25','15:35:00',2.8),('5819','2013-08-25','15:40:00',3.03),('5819','2013-08-25','15:45:00',3.02),('5819','2013-08-25','15:50:00',2.63),('5819','2013-08-25','15:55:00',1.51),('5819','2013-08-25','16:00:00',2.87),('5819','2013-08-25','16:05:00',2.65),('5819','2013-08-25','16:10:00',2.5),('5819','2013-08-25','16:15:00',2.4),('5819','2013-08-25','16:20:00',2.31),('5819','2013-08-25','16:25:00',2.23),('5819','2013-08-25','16:30:00',2.15),('5819','2013-08-25','16:35:00',2.05),('5819','2013-08-25','16:40:00',1.63),('5819','2013-08-25','16:45:00',1.19),('5819','2013-08-25','16:50:00',1.46),('5819','2013-08-25','16:55:00',2.06),('5819','2013-08-25','17:00:00',1.83),('5819','2013-08-25','17:05:00',1.7),('5819','2013-08-25','17:10:00',1.62),('5819','2013-08-25','17:15:00',1.48),('5819','2013-08-25','17:20:00',1.36),('5819','2013-08-25','17:25:00',1.27),('5819','2013-08-25','17:30:00',1.12),('5819','2013-08-24','08:05:00',1.1),('5819','2013-08-24','08:15:00',1.08),('5819','2013-08-24','08:25:00',1.44),('5819','2013-08-24','08:30:00',1.52),('5819','2013-08-24','08:35:00',1.59),('5819','2013-08-24','08:40:00',1.74),('5819','2013-08-24','08:45:00',1.78),('5819','2013-08-24','08:50:00',1.66),('5819','2013-08-24','08:55:00',1.94),('5819','2013-08-24','09:00:00',2.09),('5819','2013-08-24','09:05:00',2.11),('5819','2013-08-24','09:10:00',2.25),('5819','2013-08-24','09:15:00',2.06),('5819','2013-08-24','09:20:00',2.39),('5819','2013-08-24','09:25:00',2.03),('5819','2013-08-24','09:30:00',1.91),('5819','2013-08-24','09:35:00',1.74),('5819','2013-08-24','09:40:00',2.7),('5819','2013-08-24','09:45:00',1.68),('5819','2013-08-24','09:50:00',2.25),('5819','2013-08-24','09:55:00',2.3),('5819','2013-08-24','10:00:00',2.93),('5819','2013-08-24','10:05:00',2.93),('5819','2013-08-24','10:10:00',2.98),('5819','2013-08-24','10:15:00',2.99),('5819','2013-08-24','10:20:00',3.03),('5819','2013-08-24','10:25:00',3.05),('5819','2013-08-24','10:30:00',3.08),('5819','2013-08-24','10:35:00',3.11),('5819','2013-08-24','10:40:00',3.19),('5819','2013-08-24','10:45:00',3.22),('5819','2013-08-24','10:50:00',2.97),('5819','2013-08-24','10:55:00',2.83),('5819','2013-08-24','11:00:00',3.34),('5819','2013-08-24','11:05:00',3.36),('5819','2013-08-24','11:10:00',3.41),('5819','2013-08-24','11:15:00',3.42),('5819','2013-08-24','11:20:00',3.47),('5819','2013-08-24','11:25:00',3.47),('5819','2013-08-24','11:30:00',3.42),('5819','2013-08-24','11:35:00',3.5),('5819','2013-08-24','11:40:00',3.51),('5819','2013-08-24','11:45:00',3.51),('5819','2013-08-24','11:50:00',3.57),('5819','2013-08-24','11:55:00',3.53),('5819','2013-08-24','12:00:00',3.54),('5819','2013-08-24','12:05:00',3.51),('5819','2013-08-24','12:10:00',3.55),('5819','2013-08-24','12:15:00',3.6),('5819','2013-08-24','12:20:00',3.59),('5819','2013-08-24','12:25:00',3.6),('5819','2013-08-24','12:30:00',3.57),('5819','2013-08-24','12:35:00',3.58),('5819','2013-08-24','12:40:00',3.57),('5819','2013-08-24','12:45:00',3.59),('5819','2013-08-24','12:50:00',3.58),('5819','2013-08-24','12:55:00',3.56),('5819','2013-08-24','13:00:00',3.5),('5819','2013-08-24','13:05:00',3.53),('5819','2013-08-24','13:10:00',3.57),('5819','2013-08-24','13:15:00',3.56),('5819','2013-08-24','13:20:00',3.57),('5819','2013-08-24','13:25:00',3.57),('5819','2013-08-24','13:30:00',3.58),('5819','2013-08-24','13:35:00',3.55),('5819','2013-08-24','13:40:00',3.52),('5819','2013-08-24','13:45:00',3.51),('5819','2013-08-24','13:50:00',3.52),('5819','2013-08-24','13:55:00',3.48),('5819','2013-08-24','14:00:00',3.43),('5819','2013-08-24','14:05:00',3.41),('5819','2013-08-24','14:10:00',3.4),('5819','2013-08-24','14:15:00',3.37),('5819','2013-08-24','14:20:00',3.35),('5819','2013-08-24','14:25:00',3.3),('5819','2013-08-24','14:30:00',3.28),('5819','2013-08-24','14:35:00',3.26),('5819','2013-08-24','14:40:00',3.21),('5819','2013-08-24','14:45:00',3.15),('5819','2013-08-24','14:50:00',3.12),('5819','2013-08-24','14:55:00',3.09),('5819','2013-08-24','15:00:00',3.03),('5819','2013-08-24','15:05:00',3),('5819','2013-08-24','15:10:00',2.95),('5819','2013-08-24','15:15:00',2.9),('5819','2013-08-24','15:20:00',2.84),('5819','2013-08-24','15:25:00',2.79),('5819','2013-08-24','15:30:00',2.75),('5819','2013-08-24','15:35:00',2.69),('5819','2013-08-24','15:40:00',2.63),('5819','2013-08-24','15:45:00',2.57),('5819','2013-08-24','15:50:00',2.52),('5819','2013-08-24','15:55:00',2.46),('5819','2013-08-24','16:00:00',2.41),('5819','2013-08-24','16:05:00',2.35),('5819','2013-08-24','16:10:00',2.29),('5819','2013-08-24','16:15:00',2.22),('5819','2013-08-24','16:20:00',2.15),('5819','2013-08-24','16:25:00',2.08),('5819','2013-08-24','16:30:00',2.01),('5819','2013-08-24','16:35:00',1.94),('5819','2013-08-24','16:40:00',1.88),('5819','2013-08-24','16:45:00',1.8),('5819','2013-08-24','16:50:00',1.72),('5819','2013-08-24','16:55:00',1.66),('5819','2013-08-24','17:00:00',1.57),('5819','2013-08-24','17:05:00',1.51),('5819','2013-08-24','17:10:00',1.45),('5819','2013-08-24','17:15:00',1.37),('5819','2013-08-24','17:20:00',1.31),('5819','2013-08-24','17:25:00',1.23),('5819','2013-08-24','17:30:00',1.1),('5819','2013-08-24','17:35:00',1),('5819','2013-08-23','08:05:00',1.02),('5819','2013-08-23','08:10:00',1.1),('5819','2013-08-23','08:15:00',1.18),('5819','2013-08-23','08:20:00',1.27),('5819','2013-08-23','08:25:00',1.34),('5819','2013-08-23','08:30:00',1.43),('5819','2013-08-23','08:35:00',1.49),('5819','2013-08-23','08:40:00',1.53),('5819','2013-08-23','08:45:00',1.63),('5819','2013-08-23','08:50:00',1.73),('5819','2013-08-23','08:55:00',1.78),('5819','2013-08-23','09:00:00',1.81),('5819','2013-08-23','09:05:00',1.9),('5819','2013-08-23','09:10:00',1.98),('5819','2013-08-23','09:15:00',2.07),('5819','2013-08-23','09:20:00',2.14),('5819','2013-08-23','09:25:00',2.2),('5819','2013-08-23','09:30:00',2.26),('5819','2013-08-23','09:35:00',2.31),('5819','2013-08-23','09:40:00',2.32),('5819','2013-08-23','09:45:00',2.39),('5819','2013-08-23','09:50:00',2.47),('5819','2013-08-23','09:55:00',2.5),('5819','2013-08-23','10:00:00',2.58),('5819','2013-08-23','10:05:00',2.62),('5819','2013-08-23','10:10:00',2.61),('5819','2013-08-23','10:15:00',2.68),('5819','2013-08-23','10:20:00',2.76),('5819','2013-08-23','10:25:00',2.79),('5819','2013-08-23','10:30:00',2.83),('5819','2013-08-23','10:35:00',2.87),('5819','2013-08-23','10:40:00',2.86),('5819','2013-08-23','10:45:00',2.93),('5819','2013-08-23','10:50:00',2.96),('5819','2013-08-23','10:55:00',2.94),('5819','2013-08-23','11:00:00',2.98),('5819','2013-08-23','11:05:00',3.12),('5819','2013-08-23','11:10:00',3.16),('5819','2013-08-23','11:15:00',2.71),('5819','2013-08-23','11:20:00',2.25),('5819','2013-08-23','11:25:00',2.86),('5819','2013-08-23','11:30:00',3.38),('5819','2013-08-23','11:35:00',2.51),('5819','2013-08-23','11:40:00',2.34),('5819','2013-08-23','11:45:00',3.07),('5819','2013-08-23','11:50:00',3.3),('5819','2013-08-23','11:55:00',3.38),('5819','2013-08-23','12:00:00',3),('5819','2013-08-23','12:05:00',2.24),('5819','2013-08-23','12:10:00',1.09),('5819','2013-08-23','12:15:00',1.64),('5819','2013-08-23','12:20:00',1.14),('5819','2013-08-23','12:40:00',1.07),('5819','2013-08-23','12:45:00',1.09),('5819','2013-08-23','13:00:00',1.13),('5819','2013-08-23','13:05:00',1.1),('5819','2013-08-23','13:10:00',1.47),('5819','2013-08-23','13:15:00',2.3),('5819','2013-08-23','13:20:00',1.13),('5819','2013-08-23','13:25:00',2.25),('5819','2013-08-23','13:30:00',3.83),('5819','2013-08-23','13:35:00',3.45),('5819','2013-08-23','13:40:00',2.67),('5819','2013-08-23','13:45:00',3.45),('5819','2013-08-23','13:50:00',2.22),('5819','2013-08-23','13:55:00',2.9),('5819','2013-08-23','14:00:00',3.85),('5819','2013-08-23','14:05:00',3.62),('5819','2013-08-23','14:10:00',3.57),('5819','2013-08-23','14:15:00',3.58),('5819','2013-08-23','14:20:00',3.07),('5819','2013-08-23','14:25:00',2.86),('5819','2013-08-23','14:30:00',3.23),('5819','2013-08-23','14:35:00',3.33),('5819','2013-08-23','14:40:00',3.29),('5819','2013-08-23','14:45:00',3.23),('5819','2013-08-23','14:50:00',3.12),('5819','2013-08-23','14:55:00',2.98),('5819','2013-08-23','15:00:00',2.9),('5819','2013-08-23','15:05:00',2.77),('5819','2013-08-23','15:10:00',2.82),('5819','2013-08-23','15:15:00',2.85),('5819','2013-08-23','15:20:00',2.79),('5819','2013-08-23','15:25:00',2.79),('5819','2013-08-23','15:30:00',2.86),('5819','2013-08-23','15:35:00',2.65),('5819','2013-08-23','15:40:00',2.59),('5819','2013-08-23','15:45:00',2.57),('5819','2013-08-23','15:50:00',2.4),('5819','2013-08-23','15:55:00',2.44),('5819','2013-08-23','16:00:00',2.34),('5819','2013-08-23','16:05:00',2.19),('5819','2013-08-23','16:10:00',1.88),('5819','2013-08-23','16:15:00',1.96),('5819','2013-08-23','16:20:00',2.26),('5819','2013-08-23','16:25:00',2.04),('5819','2013-08-23','16:30:00',1.97),('5819','2013-08-23','16:35:00',2.05),('5819','2013-08-23','16:40:00',1.99),('5819','2013-08-23','16:45:00',1.91),('5819','2013-08-23','16:50:00',1.82),('5819','2013-08-23','16:55:00',1.72),('5819','2013-08-23','17:00:00',1.63),('5819','2013-08-23','17:05:00',1.53),('5819','2013-08-23','17:10:00',1.45),('5819','2013-08-23','17:15:00',1.37),('5819','2013-08-23','17:20:00',1.29),('5819','2013-08-23','17:25:00',1.21),('5819','2013-08-23','17:30:00',1.11),('5819','2013-08-22','08:00:00',1.04),('5819','2013-08-22','08:05:00',1.11),('5819','2013-08-22','08:10:00',1.2),('5819','2013-08-22','08:15:00',1.27),('5819','2013-08-22','08:20:00',1.35),('5819','2013-08-22','08:25:00',1.42),('5819','2013-08-22','08:30:00',1.49),('5819','2013-08-22','08:35:00',1.58),('5819','2013-08-22','08:40:00',1.65),('5819','2013-08-22','08:45:00',1.76),('5819','2013-08-22','08:50:00',1.84),('5819','2013-08-22','08:55:00',1.93),('5819','2013-08-22','09:00:00',2.02),('5819','2013-08-22','09:05:00',2.16),('5819','2013-08-22','09:10:00',2.27),('5819','2013-08-22','09:15:00',2.36),('5819','2013-08-22','09:20:00',2.49),('5819','2013-08-22','09:25:00',2.36),('5819','2013-08-22','09:30:00',1.98),('5819','2013-08-22','09:35:00',1.29),('5819','2013-08-22','09:40:00',1.43),('5819','2013-08-22','09:45:00',1.89),('5819','2013-08-22','09:50:00',2.18),('5819','2013-08-22','09:55:00',2.54),('5819','2013-08-22','10:00:00',2.97),('5819','2013-08-22','10:05:00',3),('5819','2013-08-22','10:10:00',3.01),('5819','2013-08-22','10:15:00',2.97),('5819','2013-08-22','10:20:00',2.98),('5819','2013-08-22','10:25:00',3.02),('5819','2013-08-22','10:30:00',3.05),('5819','2013-08-22','10:35:00',3.06),('5819','2013-08-22','10:40:00',3.12),('5819','2013-08-22','10:45:00',3.15),('5819','2013-08-22','10:50:00',3.17),('5819','2013-08-22','10:55:00',3.2),('5819','2013-08-22','11:00:00',3.22),('5819','2013-08-22','11:05:00',3.24),('5819','2013-08-22','11:10:00',3.27),('5819','2013-08-22','11:15:00',3.29),('5819','2013-08-22','11:20:00',3.28),('5819','2013-08-22','11:25:00',3.3),('5819','2013-08-22','11:30:00',3.36),('5819','2013-08-22','11:35:00',3.38),('5819','2013-08-22','11:40:00',3.41),('5819','2013-08-22','11:45:00',3.41),('5819','2013-08-22','11:50:00',3.42),('5819','2013-08-22','11:55:00',3.43),('5819','2013-08-22','12:00:00',3.44),('5819','2013-08-22','12:05:00',3.45),('5819','2013-08-22','12:10:00',3.45),('5819','2013-08-22','12:15:00',3.46),('5819','2013-08-22','12:20:00',3.46),('5819','2013-08-22','12:25:00',3.46),('5819','2013-08-22','12:30:00',3.45),('5819','2013-08-22','12:35:00',3.46),('5819','2013-08-22','12:40:00',3.45),('5819','2013-08-22','12:45:00',3.46),('5819','2013-08-22','12:50:00',3.45),('5819','2013-08-22','12:55:00',3.44),('5819','2013-08-22','13:00:00',3.22),('5819','2013-08-22','13:05:00',3.24),('5819','2013-08-22','13:10:00',3.29),('5819','2013-08-22','13:15:00',3.32),('5819','2013-08-22','13:20:00',3.27),('5819','2013-08-22','13:25:00',3.32),('5819','2013-08-22','13:30:00',3.31),('5819','2013-08-22','13:35:00',3.32),('5819','2013-08-22','13:40:00',3.34),('5819','2013-08-22','13:45:00',3.32),('5819','2013-08-22','13:50:00',3.31),('5819','2013-08-22','13:55:00',3.26),('5819','2013-08-22','14:00:00',3.23),('5819','2013-08-22','14:05:00',3.23),('5819','2013-08-22','14:10:00',3.22),('5819','2013-08-22','14:15:00',3.21),('5819','2013-08-22','14:20:00',3.21),('5819','2013-08-22','14:25:00',3.23),('5819','2013-08-22','14:30:00',3.16),('5819','2013-08-22','14:35:00',3.14),('5819','2013-08-22','14:40:00',2.77),('5819','2013-08-22','14:45:00',3.1),('5819','2013-08-22','14:50:00',3.02),('5819','2013-08-22','14:55:00',2.64),('5819','2013-08-22','15:00:00',2.92),('5819','2013-08-22','15:05:00',2.92),('5819','2013-08-22','15:10:00',2.89),('5819','2013-08-22','15:15:00',2.85),('5819','2013-08-22','15:20:00',2.77),('5819','2013-08-22','15:25:00',2.7),('5819','2013-08-22','15:30:00',2.68),('5819','2013-08-22','15:35:00',2.62),('5819','2013-08-22','15:40:00',2.59),('5819','2013-08-22','15:45:00',2.53),('5819','2013-08-22','15:50:00',2.48),('5819','2013-08-22','15:55:00',2.42),('5819','2013-08-22','16:00:00',2.37),('5819','2013-08-22','16:05:00',2.26),('5819','2013-08-22','16:10:00',2.21),('5819','2013-08-22','16:15:00',2.15),('5819','2013-08-22','16:20:00',2.08),('5819','2013-08-22','16:25:00',2.03),('5819','2013-08-22','16:30:00',1.98),('5819','2013-08-22','16:35:00',1.91),('5819','2013-08-22','16:40:00',1.84),('5819','2013-08-22','16:45:00',1.75),('5819','2013-08-22','16:50:00',1.67),('5819','2013-08-22','16:55:00',1.62),('5819','2013-08-22','17:00:00',1.54),('5819','2013-08-22','17:05:00',1.48),('5819','2013-08-22','17:10:00',1.4),('5819','2013-08-22','17:15:00',1.32),('5819','2013-08-22','17:20:00',1.26),('5819','2013-08-22','17:25:00',1.19),('5819','2013-08-22','17:30:00',1.11),('5819','2013-08-21','09:05:00',1.29),('5819','2013-08-21','09:10:00',1.31),('5819','2013-08-21','09:15:00',2.4),('5819','2013-08-21','09:20:00',2.74),('5819','2013-08-21','09:25:00',1.12),('5819','2013-08-21','09:40:00',1.11),('5819','2013-08-21','09:45:00',1.21),('5819','2013-08-21','09:50:00',2.99),('5819','2013-08-21','09:55:00',3.46),('5819','2013-08-21','10:00:00',3.22),('5819','2013-08-21','10:05:00',2.44),('5819','2013-08-21','10:10:00',2.17),('5819','2013-08-21','10:15:00',2.76),('5819','2013-08-21','10:20:00',1.92),('5819','2013-08-21','10:25:00',1.85),('5819','2013-08-21','10:30:00',1.73),('5819','2013-08-21','10:35:00',3.35),('5819','2013-08-21','10:40:00',2.96),('5819','2013-08-21','10:45:00',2.76),('5819','2013-08-21','10:50:00',2.4),('5819','2013-08-21','10:55:00',1.75),('5819','2013-08-21','11:00:00',2.21),('5819','2013-08-21','11:05:00',1.89),('5819','2013-08-21','11:10:00',1.63),('5819','2013-08-21','11:15:00',2.13),('5819','2013-08-21','11:20:00',3.5),('5819','2013-08-21','11:25:00',2.73),('5819','2013-08-21','11:30:00',2.63),('5819','2013-08-21','11:35:00',3.65),('5819','2013-08-21','11:40:00',3.81),('5819','2013-08-21','11:45:00',3.78),('5819','2013-08-21','11:50:00',2.7),('5819','2013-08-21','11:55:00',3.5),('5819','2013-08-21','12:00:00',3.83),('5819','2013-08-21','12:05:00',3.8),('5819','2013-08-21','12:10:00',3.77),('5819','2013-08-21','12:15:00',3.77),('5819','2013-08-21','12:20:00',3.66),('5819','2013-08-21','12:25:00',2.46),('5819','2013-08-21','12:30:00',3.75),('5819','2013-08-21','12:35:00',3.36),('5819','2013-08-21','12:40:00',3.29),('5819','2013-08-21','12:45:00',3.58),('5819','2013-08-21','12:50:00',3.45),('5819','2013-08-21','12:55:00',3.31),('5819','2013-08-21','13:00:00',3.4),('5819','2013-08-21','13:05:00',3.49),('5819','2013-08-21','13:10:00',3.53),('5819','2013-08-21','13:15:00',3.55),('5819','2013-08-21','13:20:00',3.55),('5819','2013-08-21','13:25:00',3.57),('5819','2013-08-21','13:30:00',3.55),('5819','2013-08-21','13:35:00',3.5),('5819','2013-08-21','13:40:00',3.51),('5819','2013-08-21','13:45:00',3.42),('5819','2013-08-21','13:50:00',3.32),('5819','2013-08-21','13:55:00',3.3),('5819','2013-08-21','14:00:00',3.42),('5819','2013-08-21','14:05:00',3.37),('5819','2013-08-21','14:10:00',3.38),('5819','2013-08-21','14:15:00',3.42),('5819','2013-08-21','14:20:00',3.27),('5819','2013-08-21','14:25:00',2.75),('5819','2013-08-21','14:30:00',2.97),('5819','2013-08-21','14:35:00',2.87),('5819','2013-08-21','14:40:00',2.92),('5819','2013-08-21','14:45:00',2.93),('5819','2013-08-21','14:50:00',2.83),('5819','2013-08-21','14:55:00',2.78),('5819','2013-08-21','15:00:00',2.85),('5819','2013-08-21','15:05:00',2.87),('5819','2013-08-21','15:10:00',2.78),('5819','2013-08-21','15:15:00',2.7),('5819','2013-08-21','15:20:00',2.67),('5819','2013-08-21','15:25:00',2.68),('5819','2013-08-21','15:30:00',2.54),('5819','2013-08-21','15:35:00',2.43),('5819','2013-08-21','15:40:00',2.29),('5819','2013-08-21','15:45:00',2.35),('5819','2013-08-21','15:50:00',2.4),('5819','2013-08-21','15:55:00',2.19),('5819','2013-08-21','16:00:00',2.07),('5819','2013-08-21','16:05:00',2.06),('5819','2013-08-21','16:10:00',1.98),('5819','2013-08-21','16:15:00',2.04),('5819','2013-08-21','16:20:00',2.07),('5819','2013-08-21','16:25:00',2.03),('5819','2013-08-21','16:30:00',2.1),('5819','2013-08-21','16:35:00',2.01),('5819','2013-08-21','16:40:00',1.94),('5819','2013-08-21','16:45:00',1.88),('5819','2013-08-21','16:50:00',1.8),('5819','2013-08-21','16:55:00',1.75),('5819','2013-08-21','17:00:00',1.69),('5819','2013-08-21','17:05:00',1.64),('5819','2013-08-21','17:10:00',1.58),('5819','2013-08-21','17:15:00',1.53),('5819','2013-08-21','17:20:00',1.5),('5819','2013-08-21','17:25:00',1.44),('5819','2013-08-21','17:30:00',1.35),('5819','2013-08-21','17:35:00',1.19),('5819','2013-08-21','17:40:00',1.2),('5819','2013-08-21','17:45:00',1.16),('5819','2013-08-21','17:50:00',1.1),('5819','2013-08-21','17:55:00',1.04),('5819','2013-08-20','07:55:00',1.08),('5819','2013-08-20','08:00:00',1.13),('5819','2013-08-20','08:55:00',1.13),('5819','2013-08-20','09:00:00',1.09),('5819','2013-08-20','09:05:00',1.22),('5819','2013-08-20','09:10:00',1.07),('5819','2013-08-20','09:15:00',1.16),('5819','2013-08-20','09:20:00',1.18),('5819','2013-08-20','09:25:00',1.76),('5819','2013-08-20','09:30:00',2.41),('5819','2013-08-20','09:35:00',2.48),('5819','2013-08-20','09:40:00',2.84),('5819','2013-08-20','09:45:00',3.01),('5819','2013-08-20','09:50:00',2.86),('5819','2013-08-20','09:55:00',1.85),('5819','2013-08-20','10:00:00',3.41),('5819','2013-08-20','10:05:00',1.85),('5819','2013-08-20','10:10:00',1.83),('5819','2013-08-20','10:15:00',2.48),('5819','2013-08-20','10:20:00',1.7),('5819','2013-08-20','10:25:00',1.25),('5819','2013-08-20','10:50:00',1.96),('5819','2013-08-20','10:55:00',2.77),('5819','2013-08-20','11:00:00',1.14),('5819','2013-08-20','11:20:00',3.7),('5819','2013-08-20','11:25:00',3.83),('5819','2013-08-20','11:30:00',1.85),('5819','2013-08-20','11:40:00',3.07),('5819','2013-08-20','11:45:00',3.9),('5819','2013-08-20','11:50:00',2.68),('5819','2013-08-20','11:55:00',4.11),('5819','2013-08-20','12:00:00',2.3),('5819','2013-08-20','12:05:00',1.09),('5819','2013-08-20','12:35:00',1.2),('5819','2013-08-20','12:40:00',1.56),('5819','2013-08-20','12:45:00',1.64),('5819','2013-08-20','12:50:00',1.76),('5819','2013-08-20','12:55:00',1.75),('5819','2013-08-20','13:00:00',1.7),('5819','2013-08-20','13:05:00',1.54),('5819','2013-08-20','13:10:00',1.46),('5819','2013-08-20','13:15:00',1.49),('5819','2013-08-20','13:20:00',1.55),('5819','2013-08-20','13:25:00',1.63),('5819','2013-08-20','13:30:00',1.78),('5819','2013-08-20','13:35:00',2.23),('5819','2013-08-20','13:40:00',3.42),('5819','2013-08-20','13:45:00',3.37),('5819','2013-08-20','13:50:00',3.75),('5819','2013-08-20','13:55:00',3.68),('5819','2013-08-20','14:00:00',3.63),('5819','2013-08-20','14:05:00',3.61),('5819','2013-08-20','14:10:00',3.52),('5819','2013-08-20','14:15:00',3.49),('5819','2013-08-20','14:20:00',3.47),('5819','2013-08-20','14:25:00',3.36),('5819','2013-08-20','14:30:00',2.79),('5819','2013-08-20','14:35:00',3.21),('5819','2013-08-20','14:40:00',3.19),('5819','2013-08-20','14:45:00',3.11),('5819','2013-08-20','14:50:00',3.34),('5819','2013-08-20','14:55:00',2.81),('5819','2013-08-20','15:00:00',3.39),('5819','2013-08-20','15:05:00',3.24),('5819','2013-08-20','15:10:00',3.37),('5819','2013-08-20','15:15:00',3.21),('5819','2013-08-20','15:20:00',3.19),('5819','2013-08-20','15:25:00',3.17),('5819','2013-08-20','15:30:00',3.13),('5819','2013-08-20','15:35:00',3.1),('5819','2013-08-20','15:40:00',3.14),('5819','2013-08-20','15:45:00',3.24),('5819','2013-08-20','15:50:00',3.24),('5819','2013-08-20','15:55:00',3.42),('5819','2013-08-20','16:00:00',3.18),('5819','2013-08-20','16:05:00',3.01),('5819','2013-08-20','16:10:00',3.04),('5819','2013-08-20','16:15:00',2.96),('5819','2013-08-20','16:20:00',2.88),('5819','2013-08-20','16:25:00',2.66),('5819','2013-08-20','16:30:00',2.38),('5819','2013-08-20','16:35:00',2.48),('5819','2013-08-20','16:40:00',2.55),('5819','2013-08-20','16:45:00',2.41),('5819','2013-08-20','16:50:00',2.09),('5819','2013-08-20','16:55:00',2),('5819','2013-08-20','17:00:00',1.86),('5819','2013-08-20','17:05:00',1.71),('5819','2013-08-20','17:10:00',1.61),('5819','2013-08-20','17:15:00',1.5),('5819','2013-08-20','17:20:00',1.45),('5819','2013-08-20','17:25:00',1.36),('5819','2013-08-20','17:30:00',1.26),('5819','2013-08-20','17:35:00',1.07),('5819','2013-08-20','17:40:00',1.01),('5819','2013-08-20','17:45:00',1.03),('5819','2013-08-19','07:50:00',1),('5819','2013-08-19','07:55:00',1.1),('5819','2013-08-19','08:00:00',1.17),('5819','2013-08-19','08:05:00',1.26),('5819','2013-08-19','08:10:00',1.34),('5819','2013-08-19','08:15:00',1.41),('5819','2013-08-19','08:20:00',1.48),('5819','2013-08-19','08:25:00',1.56),('5819','2013-08-19','08:30:00',1.62),('5819','2013-08-19','08:35:00',1.7),('5819','2013-08-19','08:40:00',1.79),('5819','2013-08-19','08:45:00',1.87),('5819','2013-08-19','08:50:00',1.97),('5819','2013-08-19','08:55:00',2.06),('5819','2013-08-19','09:00:00',2.14),('5819','2013-08-19','09:05:00',2.21),('5819','2013-08-19','09:10:00',2.26),('5819','2013-08-19','09:15:00',2.33),('5819','2013-08-19','09:20:00',2.4),('5819','2013-08-19','09:25:00',2.45),('5819','2013-08-19','09:30:00',2.5),('5819','2013-08-19','09:35:00',2.57),('5819','2013-08-19','09:40:00',2.63),('5819','2013-08-19','09:45:00',2.68),('5819','2013-08-19','09:50:00',2.72),('5819','2013-08-19','09:55:00',2.77),('5819','2013-08-19','10:00:00',2.82),('5819','2013-08-19','10:05:00',2.88),('5819','2013-08-19','10:10:00',2.92),('5819','2013-08-19','10:15:00',2.97),('5819','2013-08-19','10:20:00',3.01),('5819','2013-08-19','10:25:00',3.04),('5819','2013-08-19','10:30:00',3.07),('5819','2013-08-19','10:35:00',3.09),('5819','2013-08-19','10:40:00',3.14),('5819','2013-08-19','10:45:00',3.17),('5819','2013-08-19','10:50:00',3.21),('5819','2013-08-19','10:55:00',3.24),('5819','2013-08-19','11:00:00',3.24),('5819','2013-08-19','11:05:00',3.26),('5819','2013-08-19','11:10:00',3.3),('5819','2013-08-19','11:15:00',3.34),('5819','2013-08-19','11:20:00',3.34),('5819','2013-08-19','11:25:00',3.37),('5819','2013-08-19','11:30:00',3.38),('5819','2013-08-19','11:35:00',3.41),('5819','2013-08-19','11:40:00',3.41),('5819','2013-08-19','11:45:00',3.42),('5819','2013-08-19','11:50:00',3.46),('5819','2013-08-19','11:55:00',3.46),('5819','2013-08-19','12:00:00',3.43),('5819','2013-08-19','12:05:00',3.44),('5819','2013-08-19','12:10:00',3.53),('5819','2013-08-19','12:15:00',3.52),('5819','2013-08-19','12:20:00',3.55),('5819','2013-08-19','12:25:00',3.54),('5819','2013-08-19','12:30:00',3.54),('5819','2013-08-19','12:35:00',3.53),('5819','2013-08-19','12:40:00',3.55),('5819','2013-08-19','12:45:00',3.53),('5819','2013-08-19','12:50:00',3.54),('5819','2013-08-19','12:55:00',3.55),('5819','2013-08-19','13:00:00',3.56),('5819','2013-08-19','13:05:00',3.55),('5819','2013-08-19','13:10:00',3.56),('5819','2013-08-19','13:15:00',3.53),('5819','2013-08-19','13:20:00',3.55),('5819','2013-08-19','13:25:00',3.54),('5819','2013-08-19','13:30:00',3.55),('5819','2013-08-19','13:35:00',3.53),('5819','2013-08-19','13:40:00',3.53),('5819','2013-08-19','13:45:00',3.51),('5819','2013-08-19','13:50:00',3.48),('5819','2013-08-19','13:55:00',3.48),('5819','2013-08-19','14:00:00',3.44),('5819','2013-08-19','14:05:00',3.41),('5819','2013-08-19','14:10:00',3.39),('5819','2013-08-19','14:15:00',3.35),('5819','2013-08-19','14:20:00',3.34),('5819','2013-08-19','14:25:00',3.34),('5819','2013-08-19','14:30:00',3.32),('5819','2013-08-19','14:35:00',3.29),('5819','2013-08-19','14:40:00',3.25),('5819','2013-08-19','14:45:00',3.22),('5819','2013-08-19','14:50:00',3.19),('5819','2013-08-19','14:55:00',3.15),('5819','2013-08-19','15:00:00',3.12),('5819','2013-08-19','15:05:00',3.08),('5819','2013-08-19','15:10:00',3.03),('5819','2013-08-19','15:15:00',2.99),('5819','2013-08-19','15:20:00',2.93),('5819','2013-08-19','15:25:00',2.89),('5819','2013-08-19','15:30:00',2.85),('5819','2013-08-19','15:35:00',2.8),('5819','2013-08-19','15:40:00',2.75),('5819','2013-08-19','15:45:00',2.7),('5819','2013-08-19','15:50:00',2.64),('5819','2013-08-19','15:55:00',2.59),('5819','2013-08-19','16:00:00',2.53),('5819','2013-08-19','16:05:00',2.44),('5819','2013-08-19','16:10:00',2.36),('5819','2013-08-19','16:15:00',2.28),('5819','2013-08-19','16:20:00',2.25),('5819','2013-08-19','16:25:00',2.2),('5819','2013-08-19','16:30:00',2.12),('5819','2013-08-19','16:35:00',2.06),('5819','2013-08-19','16:40:00',1.98),('5819','2013-08-19','16:45:00',1.91),('5819','2013-08-19','16:50:00',1.85),('5819','2013-08-19','16:55:00',1.78),('5819','2013-08-19','17:00:00',1.71),('5819','2013-08-19','17:05:00',1.62),('5819','2013-08-19','17:10:00',1.54),('5819','2013-08-19','17:15:00',1.47),('5819','2013-08-19','17:20:00',1.39),('5819','2013-08-19','17:25:00',1.32),('5819','2013-08-19','17:30:00',1.23),('5819','2013-08-19','17:35:00',1.06),('5819','2013-08-19','17:40:00',1.07),('5819','2013-08-18','07:50:00',1.07),('5819','2013-08-18','07:55:00',1.15),('5819','2013-08-18','08:00:00',1.24),('5819','2013-08-18','08:05:00',1.31),('5819','2013-08-18','08:10:00',1.4),('5819','2013-08-18','08:15:00',1.48),('5819','2013-08-18','08:20:00',1.58),('5819','2013-08-18','08:25:00',1.66),('5819','2013-08-18','08:30:00',1.74),('5819','2013-08-18','08:35:00',1.81),('5819','2013-08-18','08:40:00',1.89),('5819','2013-08-18','08:45:00',1.97),('5819','2013-08-18','08:50:00',2.04),('5819','2013-08-18','08:55:00',2.1),('5819','2013-08-18','09:00:00',2.16),('5819','2013-08-18','09:05:00',2.23),('5819','2013-08-18','09:10:00',2.3),('5819','2013-08-18','09:15:00',2.37),('5819','2013-08-18','09:20:00',2.44),('5819','2013-08-18','09:25:00',2.5),('5819','2013-08-18','09:30:00',2.58),('5819','2013-08-18','09:35:00',2.63),('5819','2013-08-18','09:40:00',2.72),('5819','2013-08-18','09:45:00',2.54),('5819','2013-08-18','09:50:00',2.82),('5819','2013-08-18','09:55:00',2.06),('5819','2013-08-18','10:00:00',2.89),('5819','2013-08-18','10:05:00',2.45),('5819','2013-08-18','10:10:00',2.55),('5819','2013-08-18','10:15:00',3),('5819','2013-08-18','10:20:00',3.02),('5819','2013-08-18','10:25:00',3.07),('5819','2013-08-18','10:30:00',3.08),('5819','2013-08-18','10:35:00',3.1),('5819','2013-08-18','10:40:00',3.13),('5819','2013-08-18','10:45:00',3.17),('5819','2013-08-18','10:50:00',3.2),('5819','2013-08-18','10:55:00',3.23),('5819','2013-08-18','11:00:00',3.23),('5819','2013-08-18','11:05:00',3.3),('5819','2013-08-18','11:10:00',3.29),('5819','2013-08-18','11:15:00',3.3),('5819','2013-08-18','11:20:00',3.32),('5819','2013-08-18','11:25:00',3.36),('5819','2013-08-18','11:30:00',3.39),('5819','2013-08-18','11:35:00',3.37),('5819','2013-08-18','11:40:00',3.4),('5819','2013-08-18','11:45:00',3.43),('5819','2013-08-18','11:50:00',3.45),('5819','2013-08-18','11:55:00',3.45),('5819','2013-08-18','12:00:00',3.44),('5819','2013-08-18','12:05:00',3.47),('5819','2013-08-18','12:10:00',3.5),('5819','2013-08-18','12:15:00',3.42),('5819','2013-08-18','12:20:00',3.53),('5819','2013-08-18','12:25:00',3.65),('5819','2013-08-18','12:30:00',3.58),('5819','2013-08-18','12:35:00',3.31),('5819','2013-08-18','12:40:00',2.35),('5819','2013-08-18','12:45:00',1.88),('5819','2013-08-18','12:50:00',1.22),('5819','2013-08-18','12:55:00',2.6),('5819','2013-08-18','13:00:00',1.49),('5819','2013-08-18','13:05:00',3.75),('5819','2013-08-18','13:10:00',3.8),('5819','2013-08-18','13:15:00',3.49),('5819','2013-08-18','13:20:00',3.38),('5819','2013-08-18','13:25:00',3.63),('5819','2013-08-18','13:30:00',3.49),('5819','2013-08-18','13:35:00',3.51),('5819','2013-08-18','13:40:00',3.56),('5819','2013-08-18','13:45:00',3.51),('5819','2013-08-18','13:50:00',3.51),('5819','2013-08-18','13:55:00',2.94),('5819','2013-08-18','14:00:00',3.48),('5819','2013-08-18','14:05:00',3.48),('5819','2013-08-18','14:10:00',3.41),('5819','2013-08-18','14:15:00',3.38),('5819','2013-08-18','14:20:00',3.33),('5819','2013-08-18','14:25:00',3.31),('5819','2013-08-18','14:30:00',3.29),('5819','2013-08-18','14:35:00',3.27),('5819','2013-08-18','14:40:00',3.24),('5819','2013-08-18','14:45:00',3.21),('5819','2013-08-18','14:50:00',3.17),('5819','2013-08-18','14:55:00',3.14),('5819','2013-08-18','15:00:00',3.1),('5819','2013-08-18','15:05:00',3.06),('5819','2013-08-18','15:10:00',3.01),('5819','2013-08-18','15:15:00',2.97),('5819','2013-08-18','15:20:00',2.91),('5819','2013-08-18','15:25:00',2.87),('5819','2013-08-18','15:30:00',2.81),('5819','2013-08-18','15:35:00',2.78),('5819','2013-08-18','15:40:00',2.73),('5819','2013-08-18','15:45:00',2.67),('5819','2013-08-18','15:50:00',2.62),('5819','2013-08-18','15:55:00',2.55),('5819','2013-08-18','16:00:00',2.51),('5819','2013-08-18','16:05:00',2.45),('5819','2013-08-18','16:10:00',2.38),('5819','2013-08-18','16:15:00',2.31),('5819','2013-08-18','16:20:00',2.26),('5819','2013-08-18','16:25:00',2.19),('5819','2013-08-18','16:30:00',2.12),('5819','2013-08-18','16:35:00',2.06),('5819','2013-08-18','16:40:00',1.99),('5819','2013-08-18','16:45:00',1.91),('5819','2013-08-18','16:50:00',1.86),('5819','2013-08-18','16:55:00',1.78),('5819','2013-08-18','17:00:00',1.71),('5819','2013-08-18','17:05:00',1.64),('5819','2013-08-18','17:10:00',1.56),('5819','2013-08-18','17:15:00',1.49),('5819','2013-08-18','17:20:00',1.42),('5819','2013-08-18','17:25:00',1.34),('5819','2013-08-18','17:30:00',1.26),('5819','2013-08-18','17:35:00',1.08),('5819','2013-08-18','17:40:00',1.09),('5819','2013-08-18','17:45:00',1.01),('5819','2013-08-17','07:50:00',1.05),('5819','2013-08-17','07:55:00',1.12),('5819','2013-08-17','08:00:00',1.19),('5819','2013-08-17','08:05:00',1.28),('5819','2013-08-17','08:10:00',1.36),('5819','2013-08-17','08:15:00',1.43),('5819','2013-08-17','08:20:00',1.52),('5819','2013-08-17','08:25:00',1.59),('5819','2013-08-17','08:30:00',1.66),('5819','2013-08-17','08:35:00',1.75),('5819','2013-08-17','08:40:00',1.84),('5819','2013-08-17','08:45:00',1.93),('5819','2013-08-17','08:50:00',2),('5819','2013-08-17','08:55:00',2.08),('5819','2013-08-17','09:00:00',2.15),('5819','2013-08-17','09:05:00',2.22),('5819','2013-08-17','09:10:00',2.28),('5819','2013-08-17','09:15:00',2.34),('5819','2013-08-17','09:20:00',2.41),('5819','2013-08-17','09:25:00',2.49),('5819','2013-08-17','09:30:00',2.55),('5819','2013-08-17','09:35:00',2.61),('5819','2013-08-17','09:40:00',2.66),('5819','2013-08-17','09:45:00',2.71),('5819','2013-08-17','09:50:00',2.76),('5819','2013-08-17','09:55:00',2.82),('5819','2013-08-17','10:00:00',2.87),('5819','2013-08-17','10:05:00',2.91),('5819','2013-08-17','10:10:00',2.96),('5819','2013-08-17','10:15:00',3),('5819','2013-08-17','10:20:00',3.02),('5819','2013-08-17','10:25:00',3.07),('5819','2013-08-17','10:30:00',3.11),('5819','2013-08-17','10:35:00',3.14),('5819','2013-08-17','10:40:00',3.17),('5819','2013-08-17','10:45:00',3.2),('5819','2013-08-17','10:50:00',3.25),('5819','2013-08-17','10:55:00',3.28),('5819','2013-08-17','11:00:00',3.29),('5819','2013-08-17','11:05:00',3.32),('5819','2013-08-17','11:10:00',3.36),('5819','2013-08-17','11:15:00',3.36),('5819','2013-08-17','11:20:00',3.38),('5819','2013-08-17','11:25:00',3.4),('5819','2013-08-17','11:30:00',3.44),('5819','2013-08-17','11:35:00',3.45),('5819','2013-08-17','11:40:00',3.48),('5819','2013-08-17','11:45:00',3.48),('5819','2013-08-17','11:50:00',3.49),('5819','2013-08-17','11:55:00',3.56),('5819','2013-08-17','12:00:00',3.5),('5819','2013-08-17','12:05:00',3.52),('5819','2013-08-17','12:10:00',3.5),('5819','2013-08-17','12:15:00',3.37),('5819','2013-08-17','12:20:00',3.52),('5819','2013-08-17','12:25:00',3.57),('5819','2013-08-17','12:30:00',3.61),('5819','2013-08-17','12:35:00',3.57),('5819','2013-08-17','12:40:00',3.38),('5819','2013-08-17','12:45:00',3.51),('5819','2013-08-17','12:50:00',3.62),('5819','2013-08-17','12:55:00',3.58),('5819','2013-08-17','13:00:00',3.5),('5819','2013-08-17','13:05:00',3.28),('5819','2013-08-17','13:10:00',3.63),('5819','2013-08-17','13:15:00',3.61),('5819','2013-08-17','13:20:00',3.56),('5819','2013-08-17','13:25:00',3.66),('5819','2013-08-17','13:30:00',2.37),('5819','2013-08-17','13:35:00',3.16),('5819','2013-08-17','13:40:00',1.69),('5819','2013-08-17','13:50:00',1.34),('5819','2013-08-17','14:00:00',1.96),('5819','2013-08-17','14:05:00',2.89),('5819','2013-08-17','14:10:00',2.69),('5819','2013-08-17','14:15:00',3.53),('5819','2013-08-17','14:20:00',3.45),('5819','2013-08-17','14:25:00',3.44),('5819','2013-08-17','14:30:00',3.32),('5819','2013-08-17','14:35:00',3.31),('5819','2013-08-17','14:40:00',3.22),('5819','2013-08-17','14:45:00',3.2),('5819','2013-08-17','14:50:00',3.22),('5819','2013-08-17','14:55:00',3.13),('5819','2013-08-17','15:00:00',3.12),('5819','2013-08-17','15:05:00',3.09),('5819','2013-08-17','15:10:00',3.02),('5819','2013-08-17','15:15:00',2.97),('5819','2013-08-17','15:20:00',2.95),('5819','2013-08-17','15:25:00',2.88),('5819','2013-08-17','15:30:00',2.83),('5819','2013-08-17','15:35:00',2.83),('5819','2013-08-17','15:40:00',2.76),('5819','2013-08-17','15:45:00',2.68),('5819','2013-08-17','15:50:00',2.63),('5819','2013-08-17','15:55:00',2.57),('5819','2013-08-17','16:00:00',2.53),('5819','2013-08-17','16:05:00',2.46),('5819','2013-08-17','16:10:00',2.4),('5819','2013-08-17','16:15:00',2.35),('5819','2013-08-17','16:20:00',2.3),('5819','2013-08-17','16:25:00',2.23),('5819','2013-08-17','16:30:00',2.18),('5819','2013-08-17','16:35:00',2.12),('5819','2013-08-17','16:40:00',2.03),('5819','2013-08-17','16:45:00',1.95),('5819','2013-08-17','16:50:00',1.83),('5819','2013-08-17','16:55:00',1.83),('5819','2013-08-17','17:00:00',1.75),('5819','2013-08-17','17:05:00',1.67),('5819','2013-08-17','17:10:00',1.59),('5819','2013-08-17','17:15:00',1.35),('5819','2013-08-17','17:20:00',1.44),('5819','2013-08-17','17:25:00',1.35),('5819','2013-08-17','17:30:00',1.35),('5819','2013-08-17','17:35:00',1.2),('5819','2013-08-17','17:40:00',1.15),('5819','2013-08-17','17:45:00',1.1),('5819','2013-08-17','17:50:00',1.02),('5819','2013-08-16','07:45:00',1),('5819','2013-08-16','07:50:00',1.07),('5819','2013-08-16','07:55:00',1.15),('5819','2013-08-16','08:00:00',1.23),('5819','2013-08-16','08:05:00',1.31),('5819','2013-08-16','08:10:00',1.4),('5819','2013-08-16','08:15:00',1.5),('5819','2013-08-16','08:20:00',1.58),('5819','2013-08-16','08:25:00',1.67),('5819','2013-08-16','08:30:00',1.75),('5819','2013-08-16','08:35:00',1.83),('5819','2013-08-16','08:40:00',1.91),('5819','2013-08-16','08:45:00',1.99),('5819','2013-08-16','08:50:00',2.06),('5819','2013-08-16','08:55:00',2.14),('5819','2013-08-16','09:00:00',2.22),('5819','2013-08-16','09:05:00',2.3),('5819','2013-08-16','09:10:00',2.37),('5819','2013-08-16','09:15:00',2.45),('5819','2013-08-16','09:20:00',2.52),('5819','2013-08-16','09:25:00',2.58),('5819','2013-08-16','09:30:00',2.66),('5819','2013-08-16','09:35:00',2.72),('5819','2013-08-16','09:40:00',2.78),('5819','2013-08-16','09:45:00',2.83),('5819','2013-08-16','09:50:00',2.89),('5819','2013-08-16','09:55:00',2.94),('5819','2013-08-16','10:00:00',2.99),('5819','2013-08-16','10:05:00',3.04),('5819','2013-08-16','10:10:00',3.08),('5819','2013-08-16','10:15:00',3.12),('5819','2013-08-16','10:20:00',3.16),('5819','2013-08-16','10:25:00',3.2),('5819','2013-08-16','10:30:00',3.24),('5819','2013-08-16','10:35:00',3.28),('5819','2013-08-16','10:40:00',3.31),('5819','2013-08-16','10:45:00',3.34),('5819','2013-08-16','10:50:00',3.36),('5819','2013-08-16','10:55:00',3.39),('5819','2013-08-16','11:00:00',3.41),('5819','2013-08-16','11:05:00',3.46),('5819','2013-08-16','11:10:00',3.46),('5819','2013-08-16','11:15:00',3.47),('5819','2013-08-16','11:20:00',3.51),('5819','2013-08-16','11:25:00',3.51),('5819','2013-08-16','11:30:00',3.54),('5819','2013-08-16','11:35:00',3.57),('5819','2013-08-16','11:40:00',3.56),('5819','2013-08-16','11:45:00',3.56),('5819','2013-08-16','11:50:00',3.57),('5819','2013-08-16','11:55:00',3.57),('5819','2013-08-16','12:00:00',3.6),('5819','2013-08-16','12:05:00',3.61),('5819','2013-08-16','12:10:00',3.62),('5819','2013-08-16','12:15:00',3.64),('5819','2013-08-16','12:20:00',3.65),('5819','2013-08-16','12:25:00',3.64),('5819','2013-08-16','12:30:00',3.62),('5819','2013-08-16','12:35:00',3.59),('5819','2013-08-16','12:40:00',3.6),('5819','2013-08-16','12:45:00',3.6),('5819','2013-08-16','12:50:00',3.6),('5819','2013-08-16','12:55:00',3.58),('5819','2013-08-16','13:00:00',3.57),('5819','2013-08-16','13:05:00',3.58),('5819','2013-08-16','13:10:00',3.57),('5819','2013-08-16','13:15:00',3.57),('5819','2013-08-16','13:20:00',3.53),('5819','2013-08-16','13:25:00',3.51),('5819','2013-08-16','13:30:00',3.5),('5819','2013-08-16','13:35:00',3.49),('5819','2013-08-16','13:40:00',3.48),('5819','2013-08-16','13:45:00',3.48),('5819','2013-08-16','13:50:00',3.47),('5819','2013-08-16','13:55:00',3.43),('5819','2013-08-16','14:00:00',3.41),('5819','2013-08-16','14:05:00',3.4),('5819','2013-08-16','14:10:00',3.37),('5819','2013-08-16','14:15:00',3.36),('5819','2013-08-16','14:20:00',3.31),('5819','2013-08-16','14:25:00',3.28),('5819','2013-08-16','14:30:00',3.24),('5819','2013-08-16','14:35:00',3.2),('5819','2013-08-16','14:40:00',3.16),('5819','2013-08-16','14:45:00',3.14),('5819','2013-08-16','14:50:00',3.11),('5819','2013-08-16','14:55:00',3.09),('5819','2013-08-16','15:00:00',3.04),('5819','2013-08-16','15:05:00',2.96),('5819','2013-08-16','15:10:00',2.96),('5819','2013-08-16','15:15:00',2.93),('5819','2013-08-16','15:20:00',2.86),('5819','2013-08-16','15:25:00',2.83),('5819','2013-08-16','15:30:00',2.81),('5819','2013-08-16','15:35:00',2.78),('5819','2013-08-16','15:40:00',2.71),('5819','2013-08-16','15:45:00',2.67),('5819','2013-08-16','15:50:00',2.62),('5819','2013-08-16','15:55:00',2.58),('5819','2013-08-16','16:00:00',2.52),('5819','2013-08-16','16:05:00',2.47),('5819','2013-08-16','16:10:00',2.41),('5819','2013-08-16','16:15:00',2.33),('5819','2013-08-16','16:20:00',2.27),('5819','2013-08-16','16:25:00',2.2),('5819','2013-08-16','16:30:00',2.14),('5819','2013-08-16','16:35:00',2.08),('5819','2013-08-16','16:40:00',2.03),('5819','2013-08-16','16:45:00',1.96),('5819','2013-08-16','16:50:00',1.88),('5819','2013-08-16','16:55:00',1.8),('5819','2013-08-16','17:00:00',1.73),('5819','2013-08-16','17:05:00',1.65),('5819','2013-08-16','17:10:00',1.57),('5819','2013-08-16','17:15:00',1.49),('5819','2013-08-16','17:20:00',1.41),('5819','2013-08-16','17:25:00',1.34),('5819','2013-08-16','17:30:00',1.26),('5819','2013-08-16','17:35:00',1.13),('5819','2013-08-16','17:40:00',1.07),('5819','2013-08-16','17:45:00',1.01),('5819','2013-08-15','08:05:00',1.41),('5819','2013-08-15','08:10:00',1.33),('5819','2013-08-15','08:15:00',1.43),('5819','2013-08-15','08:20:00',1.65),('5819','2013-08-15','08:25:00',1.71),('5819','2013-08-15','08:30:00',1.78),('5819','2013-08-15','08:35:00',1.87),('5819','2013-08-15','08:40:00',1.94),('5819','2013-08-15','08:45:00',2.04),('5819','2013-08-15','08:50:00',2.12),('5819','2013-08-15','08:55:00',2.19),('5819','2013-08-15','09:00:00',2.28),('5819','2013-08-15','09:05:00',2.15),('5819','2013-08-15','09:10:00',1.7),('5819','2013-08-15','09:15:00',1.4),('5819','2013-08-15','09:20:00',2.46),('5819','2013-08-15','09:25:00',2.58),('5819','2013-08-15','09:30:00',2.64),('5819','2013-08-15','09:35:00',2.71),('5819','2013-08-15','09:40:00',2.77),('5819','2013-08-15','09:45:00',2.82),('5819','2013-08-15','09:50:00',2.89),('5819','2013-08-15','09:55:00',2.95),('5819','2013-08-15','10:00:00',3),('5819','2013-08-15','10:05:00',3.03),('5819','2013-08-15','10:10:00',3.08),('5819','2013-08-15','10:15:00',3.14),('5819','2013-08-15','10:20:00',3.18),('5819','2013-08-15','10:25:00',3.25),('5819','2013-08-15','10:30:00',3.28),('5819','2013-08-15','10:35:00',3.29),('5819','2013-08-15','10:40:00',3.32),('5819','2013-08-15','10:45:00',3.3),('5819','2013-08-15','10:50:00',3.25),('5819','2013-08-15','10:55:00',3.24),('5819','2013-08-15','11:00:00',3.16),('5819','2013-08-15','11:05:00',2.72),('5819','2013-08-15','11:10:00',2.42),('5819','2013-08-15','11:15:00',2.59),('5819','2013-08-15','11:20:00',2.96),('5819','2013-08-15','11:25:00',3.25),('5819','2013-08-15','11:30:00',3.63),('5819','2013-08-15','11:35:00',3.76),('5819','2013-08-15','11:40:00',3.82),('5819','2013-08-15','11:45:00',3.89),('5819','2013-08-15','11:50:00',3.89),('5819','2013-08-15','11:55:00',3.88),('5819','2013-08-15','12:00:00',3.86),('5819','2013-08-15','12:05:00',3.84),('5819','2013-08-15','12:10:00',3.8),('5819','2013-08-15','12:15:00',3.82),('5819','2013-08-15','12:20:00',3.79),('5819','2013-08-15','12:25:00',3.8),('5819','2013-08-15','12:30:00',3.78),('5819','2013-08-15','12:35:00',3.79),('5819','2013-08-15','12:40:00',3.76),('5819','2013-08-15','12:45:00',3.79),('5819','2013-08-15','12:50:00',3.72),('5819','2013-08-15','12:55:00',3.54),('5819','2013-08-15','13:00:00',3.55),('5819','2013-08-15','13:05:00',3.54),('5819','2013-08-15','13:10:00',3.5),('5819','2013-08-15','13:15:00',3.42),('5819','2013-08-15','13:20:00',3.43),('5819','2013-08-15','13:25:00',3.57),('5819','2013-08-15','13:30:00',3.63),('5819','2013-08-15','13:35:00',3.62),('5819','2013-08-15','13:40:00',3.56),('5819','2013-08-15','13:45:00',3.54),('5819','2013-08-15','13:50:00',3.49),('5819','2013-08-15','13:55:00',3.46),('5819','2013-08-15','14:00:00',3.49),('5819','2013-08-15','14:05:00',3.47),('5819','2013-08-15','14:10:00',3.45),('5819','2013-08-15','14:15:00',3.42),('5819','2013-08-15','14:20:00',3.37),('5819','2013-08-15','14:25:00',3.28),('5819','2013-08-15','14:30:00',3.22),('5819','2013-08-15','14:35:00',3.28),('5819','2013-08-15','14:40:00',3.23),('5819','2013-08-15','14:45:00',3.16),('5819','2013-08-15','14:50:00',3.14),('5819','2013-08-15','14:55:00',3.08),('5819','2013-08-15','15:00:00',3.06),('5819','2013-08-15','15:05:00',3.04),('5819','2013-08-15','15:10:00',3),('5819','2013-08-15','15:15:00',2.94),('5819','2013-08-15','15:20:00',2.86),('5819','2013-08-15','15:25:00',2.81),('5819','2013-08-15','15:30:00',2.79),('5819','2013-08-15','15:35:00',2.76),('5819','2013-08-15','15:40:00',2.69),('5819','2013-08-15','15:45:00',2.6),('5819','2013-08-15','15:50:00',2.55),('5819','2013-08-15','15:55:00',2.54),('5819','2013-08-15','16:00:00',2.46),('5819','2013-08-15','16:05:00',2.38),('5819','2013-08-15','16:10:00',2.19),('5819','2013-08-15','16:15:00',2.25),('5819','2013-08-15','16:20:00',2.25),('5819','2013-08-15','16:25:00',2.14),('5819','2013-08-15','16:30:00',2.04),('5819','2013-08-15','16:35:00',2.01),('5819','2013-08-15','16:40:00',1.95),('5819','2013-08-15','16:45:00',1.88),('5819','2013-08-15','16:50:00',1.83),('5819','2013-08-15','16:55:00',1.72),('5819','2013-08-15','17:00:00',1.69),('5819','2013-08-15','17:05:00',1.63),('5819','2013-08-15','17:10:00',1.56),('5819','2013-08-15','17:15:00',1.5),('5819','2013-08-15','17:20:00',1.44),('5819','2013-08-15','17:25:00',1.34),('5819','2013-08-15','17:30:00',1.28),('5819','2013-08-15','17:35:00',1.17),('5819','2013-08-15','17:45:00',1.04),('5819','2013-08-14','07:50:00',1.04),('5819','2013-08-14','07:55:00',1.12),('5819','2013-08-14','08:00:00',1.2),('5819','2013-08-14','08:05:00',1.27),('5819','2013-08-14','08:10:00',1.34),('5819','2013-08-14','08:15:00',1.44),('5819','2013-08-14','08:20:00',1.52),('5819','2013-08-14','08:25:00',1.54),('5819','2013-08-14','08:30:00',1.66),('5819','2013-08-14','08:35:00',1.71),('5819','2013-08-14','08:40:00',1.86),('5819','2013-08-14','08:45:00',1.98),('5819','2013-08-14','08:50:00',1.97),('5819','2013-08-14','08:55:00',2.01),('5819','2013-08-14','09:00:00',2.11),('5819','2013-08-14','09:05:00',2.18),('5819','2013-08-14','09:10:00',2.27),('5819','2013-08-14','09:15:00',2.36),('5819','2013-08-14','09:20:00',2.41),('5819','2013-08-14','09:25:00',2.34),('5819','2013-08-14','09:30:00',2.54),('5819','2013-08-14','09:35:00',2.7),('5819','2013-08-14','09:40:00',2.72),('5819','2013-08-14','09:45:00',1.19),('5819','2013-08-14','09:55:00',1.15),('5819','2013-08-14','10:00:00',1.57),('5819','2013-08-14','10:05:00',2.16),('5819','2013-08-14','10:10:00',2.55),('5819','2013-08-14','10:15:00',2.83),('5819','2013-08-14','10:20:00',2.7),('5819','2013-08-14','10:25:00',3.1),('5819','2013-08-14','10:30:00',3.32),('5819','2013-08-14','10:35:00',3.36),('5819','2013-08-14','10:40:00',3.45),('5819','2013-08-14','10:45:00',2.46),('5819','2013-08-14','10:50:00',2.62),('5819','2013-08-14','10:55:00',1.7),('5819','2013-08-14','11:00:00',2.56),('5819','2013-08-14','11:05:00',3.44),('5819','2013-08-14','11:10:00',1.6),('5819','2013-08-14','11:15:00',1.81),('5819','2013-08-14','11:20:00',3.01),('5819','2013-08-14','11:25:00',2.98),('5819','2013-08-14','11:30:00',3.58),('5819','2013-08-14','11:35:00',3.63),('5819','2013-08-14','11:40:00',3.67),('5819','2013-08-14','11:45:00',2.6),('5819','2013-08-14','11:50:00',1.37),('5819','2013-08-14','11:55:00',1.32),('5819','2013-08-14','12:00:00',1.29),('5819','2013-08-14','12:05:00',1.83),('5819','2013-08-14','12:10:00',1.84),('5819','2013-08-14','12:15:00',2.06),('5819','2013-08-14','12:20:00',1.9),('5819','2013-08-14','12:25:00',1.11),('5819','2013-08-14','12:30:00',1.24),('5819','2013-08-14','12:35:00',1.96),('5819','2013-08-14','12:40:00',1.62),('5819','2013-08-14','12:50:00',1.07),('5819','2013-08-14','12:55:00',1.88),('5819','2013-08-14','13:00:00',1.53),('5819','2013-08-14','13:25:00',1.04),('5819','2013-08-14','13:30:00',1.73),('5819','2013-08-14','13:35:00',1.18),('5819','2013-08-14','13:40:00',2.33),('5819','2013-08-14','13:45:00',3.26),('5819','2013-08-14','13:50:00',3.93),('5819','2013-08-14','13:55:00',2.8),('5819','2013-08-14','14:00:00',1.61),('5819','2013-08-14','14:05:00',3.79),('5819','2013-08-14','14:10:00',2.1),('5819','2013-08-14','14:15:00',3.79),('5819','2013-08-14','14:20:00',3.69),('5819','2013-08-14','14:25:00',3.69),('5819','2013-08-14','14:30:00',3.59),('5819','2013-08-14','14:35:00',3.57),('5819','2013-08-14','14:40:00',3.42),('5819','2013-08-14','14:45:00',3.34),('5819','2013-08-14','14:50:00',3.33),('5819','2013-08-14','14:55:00',2.46),('5819','2013-08-14','15:00:00',3.21),('5819','2013-08-14','15:05:00',3.18),('5819','2013-08-14','15:10:00',3.06),('5819','2013-08-14','15:15:00',3.09),('5819','2013-08-14','15:20:00',3.16),('5819','2013-08-14','15:25:00',3.08),('5819','2013-08-14','15:30:00',2.92),('5819','2013-08-14','15:35:00',2.83),('5819','2013-08-14','15:40:00',2.8),('5819','2013-08-14','15:45:00',2.75),('5819','2013-08-14','15:50:00',2.7),('5819','2013-08-14','15:55:00',2.63),('5819','2013-08-14','16:00:00',2.6),('5819','2013-08-14','16:05:00',2.56),('5819','2013-08-14','16:10:00',2.51),('5819','2013-08-14','16:15:00',2.43),('5819','2013-08-14','16:20:00',2.39),('5819','2013-08-14','16:25:00',2.3),('5819','2013-08-14','16:30:00',2.22),('5819','2013-08-14','16:35:00',2.18),('5819','2013-08-14','16:40:00',2.11),('5819','2013-08-14','16:45:00',2.01),('5819','2013-08-14','16:50:00',1.97),('5819','2013-08-14','16:55:00',1.88),('5819','2013-08-14','17:00:00',1.8),('5819','2013-08-14','17:05:00',1.71),('5819','2013-08-14','17:10:00',1.63),('5819','2013-08-14','17:15:00',1.57),('5819','2013-08-14','17:20:00',1.49),('5819','2013-08-14','17:25:00',1.41),('5819','2013-08-14','17:30:00',1.34),('5819','2013-08-14','17:35:00',1.24),('5819','2013-08-14','17:40:00',1.09),('5819','2013-08-14','17:45:00',1.09),('5819','2013-08-14','17:50:00',1.02),('5819','2013-08-13','07:50:00',1.06),('5819','2013-08-13','07:55:00',1.15),('5819','2013-08-13','08:00:00',1.25),('5819','2013-08-13','08:05:00',1.32),('5819','2013-08-13','08:10:00',1.37),('5819','2013-08-13','08:15:00',1.43),('5819','2013-08-13','08:20:00',1.54),('5819','2013-08-13','08:25:00',1.65),('5819','2013-08-13','08:30:00',1.74),('5819','2013-08-13','08:35:00',1.83),('5819','2013-08-13','08:40:00',1.89),('5819','2013-08-13','08:45:00',1.96),('5819','2013-08-13','08:50:00',2.05),('5819','2013-08-13','08:55:00',2.13),('5819','2013-08-13','09:00:00',2.2),('5819','2013-08-13','09:05:00',2.27),('5819','2013-08-13','09:10:00',2.33),('5819','2013-08-13','09:15:00',2.41),('5819','2013-08-13','09:20:00',2.44),('5819','2013-08-13','09:25:00',2.45),('5819','2013-08-13','09:30:00',2.45),('5819','2013-08-13','09:35:00',2.6),('5819','2013-08-13','09:40:00',2.74),('5819','2013-08-13','09:45:00',2.67),('5819','2013-08-13','09:50:00',2.83),('5819','2013-08-13','09:55:00',2.86),('5819','2013-08-13','10:00:00',2.58),('5819','2013-08-13','10:05:00',1.86),('5819','2013-08-13','10:10:00',3),('5819','2013-08-13','10:15:00',3.14),('5819','2013-08-13','10:20:00',3.07),('5819','2013-08-13','10:25:00',3.15),('5819','2013-08-13','10:30:00',3.16),('5819','2013-08-13','10:35:00',3.22),('5819','2013-08-13','10:40:00',3.24),('5819','2013-08-13','10:45:00',3.26),('5819','2013-08-13','10:50:00',3.3),('5819','2013-08-13','10:55:00',3.32),('5819','2013-08-13','11:00:00',3.35),('5819','2013-08-13','11:05:00',3.41),('5819','2013-08-13','11:10:00',3.4),('5819','2013-08-13','11:15:00',3.4),('5819','2013-08-13','11:20:00',3.45),('5819','2013-08-13','11:25:00',3.46),('5819','2013-08-13','11:30:00',3.49),('5819','2013-08-13','11:35:00',3.47),('5819','2013-08-13','11:40:00',3.48),('5819','2013-08-13','11:45:00',3.48),('5819','2013-08-13','11:50:00',3.52),('5819','2013-08-13','11:55:00',3.61),('5819','2013-08-13','12:00:00',3.65),('5819','2013-08-13','12:05:00',3.67),('5819','2013-08-13','12:10:00',3.69),('5819','2013-08-13','12:15:00',3.75),('5819','2013-08-13','12:20:00',3.76),('5819','2013-08-13','12:25:00',3.77),('5819','2013-08-13','12:30:00',3.79),('5819','2013-08-13','12:35:00',3.09),('5819','2013-08-13','12:40:00',3.69),('5819','2013-08-13','12:45:00',1.82),('5819','2013-08-13','12:50:00',3.1),('5819','2013-08-13','12:55:00',3.71),('5819','2013-08-13','13:00:00',1.24),('5819','2013-08-13','13:05:00',1.16),('5819','2013-08-13','13:10:00',1.12),('5819','2013-08-13','13:15:00',1.79),('5819','2013-08-13','13:20:00',4.26),('5819','2013-08-13','13:25:00',4.07),('5819','2013-08-13','13:30:00',3.99),('5819','2013-08-13','13:35:00',3.87),('5819','2013-08-13','13:40:00',3.88),('5819','2013-08-13','13:45:00',3.95),('5819','2013-08-13','13:50:00',3.94),('5819','2013-08-13','13:55:00',3.9),('5819','2013-08-13','14:00:00',3.75),('5819','2013-08-13','14:05:00',3.8),('5819','2013-08-13','14:10:00',2.93),('5819','2013-08-13','14:15:00',3.66),('5819','2013-08-13','14:20:00',3.72),('5819','2013-08-13','14:25:00',2.97),('5819','2013-08-13','14:30:00',1.34),('5819','2013-08-13','14:35:00',3.58),('5819','2013-08-13','14:40:00',2.53),('5819','2013-08-13','14:45:00',1.66),('5819','2013-08-13','14:50:00',3.39),('5819','2013-08-13','14:55:00',3.6),('5819','2013-08-13','15:00:00',3.04),('5819','2013-08-13','15:05:00',2.61),('5819','2013-08-13','15:10:00',2.09),('5819','2013-08-13','15:15:00',2.72),('5819','2013-08-13','15:20:00',3.05),('5819','2013-08-13','15:25:00',3.05),('5819','2013-08-13','15:30:00',2.94),('5819','2013-08-13','15:35:00',2.92),('5819','2013-08-13','15:40:00',2.86),('5819','2013-08-13','15:45:00',2.78),('5819','2013-08-13','15:50:00',2.7),('5819','2013-08-13','15:55:00',2.64),('5819','2013-08-13','16:00:00',2.59),('5819','2013-08-13','16:05:00',2.52),('5819','2013-08-13','16:10:00',2.45),('5819','2013-08-13','16:15:00',2.4),('5819','2013-08-13','16:20:00',2.34),('5819','2013-08-13','16:25:00',2.28),('5819','2013-08-13','16:30:00',2.2),('5819','2013-08-13','16:35:00',2.14),('5819','2013-08-13','16:40:00',2.08),('5819','2013-08-13','16:45:00',2.01),('5819','2013-08-13','16:50:00',1.94),('5819','2013-08-13','16:55:00',1.86),('5819','2013-08-13','17:00:00',1.78),('5819','2013-08-13','17:05:00',1.71),('5819','2013-08-13','17:10:00',1.65),('5819','2013-08-13','17:15:00',1.57),('5819','2013-08-13','17:20:00',1.49),('5819','2013-08-13','17:25:00',1.41),('5819','2013-08-13','17:30:00',1.33),('5819','2013-08-13','17:35:00',1.24),('5819','2013-08-13','17:40:00',1.03),('5819','2013-08-13','17:45:00',1.07),('5819','2013-08-13','17:50:00',1),('5819','2013-08-12','07:50:00',1.06),('5819','2013-08-12','07:55:00',1.14),('5819','2013-08-12','08:00:00',1.22),('5819','2013-08-12','08:05:00',1.3),('5819','2013-08-12','08:10:00',1.37),('5819','2013-08-12','08:15:00',1.45),('5819','2013-08-12','08:20:00',1.54),('5819','2013-08-12','08:25:00',1.62),('5819','2013-08-12','08:30:00',1.69),('5819','2013-08-12','08:35:00',1.77),('5819','2013-08-12','08:40:00',1.84),('5819','2013-08-12','08:45:00',1.92),('5819','2013-08-12','08:50:00',2),('5819','2013-08-12','08:55:00',2.08),('5819','2013-08-12','09:00:00',2.15),('5819','2013-08-12','09:05:00',2.22),('5819','2013-08-12','09:10:00',2.29),('5819','2013-08-12','09:15:00',2.36),('5819','2013-08-12','09:20:00',2.42),('5819','2013-08-12','09:25:00',2.48),('5819','2013-08-12','09:30:00',2.53),('5819','2013-08-12','09:35:00',2.59),('5819','2013-08-12','09:40:00',2.65),('5819','2013-08-12','09:45:00',2.71),('5819','2013-08-12','09:50:00',2.75),('5819','2013-08-12','09:55:00',2.8),('5819','2013-08-12','10:00:00',2.84),('5819','2013-08-12','10:05:00',2.88),('5819','2013-08-12','10:10:00',2.91),('5819','2013-08-12','10:15:00',2.95),('5819','2013-08-12','10:20:00',3),('5819','2013-08-12','10:25:00',3.04),('5819','2013-08-12','10:30:00',3.06),('5819','2013-08-12','10:35:00',3.09),('5819','2013-08-12','10:40:00',3.16),('5819','2013-08-12','10:45:00',3.19),('5819','2013-08-12','10:50:00',3.23),('5819','2013-08-12','10:55:00',3.26),('5819','2013-08-12','11:00:00',3.27),('5819','2013-08-12','11:05:00',3.3),('5819','2013-08-12','11:10:00',3.34),('5819','2013-08-12','11:15:00',3.36),('5819','2013-08-12','11:20:00',3.34),('5819','2013-08-12','11:25:00',3.38),('5819','2013-08-12','11:30:00',3.38),('5819','2013-08-12','11:35:00',3.31),('5819','2013-08-12','11:40:00',3.44),('5819','2013-08-12','11:45:00',3.5),('5819','2013-08-12','11:50:00',3.51),('5819','2013-08-12','11:55:00',3.55),('5819','2013-08-12','12:00:00',3.61),('5819','2013-08-12','12:05:00',3.67),('5819','2013-08-12','12:10:00',3.55),('5819','2013-08-12','12:15:00',2.95),('5819','2013-08-12','12:20:00',1.08),('5819','2013-08-12','12:25:00',1.04),('5819','2013-08-12','12:40:00',1.22),('5819','2013-08-12','12:45:00',2.95),('5819','2013-08-12','12:50:00',1.66),('5819','2013-08-12','12:55:00',1.24),('5819','2013-08-12','13:00:00',1.01),('5819','2013-08-12','13:25:00',1.97),('5819','2013-08-12','13:30:00',1.12),('5819','2013-08-12','13:35:00',1.12),('5819','2013-08-12','13:40:00',1.04),('5819','2013-08-12','13:50:00',2.19),('5819','2013-08-12','13:55:00',3.53),('5819','2013-08-12','14:00:00',1.29),('5819','2013-08-12','14:10:00',1.12),('5819','2013-08-12','14:15:00',1.57),('5819','2013-08-12','14:20:00',1.13),('5819','2013-08-12','14:40:00',1.06),('5819','2013-08-12','14:45:00',1.11),('5819','2013-08-12','14:50:00',1.85),('5819','2013-08-12','14:55:00',3.82),('5819','2013-08-12','15:00:00',3.52),('5819','2013-08-12','15:05:00',2.92),('5819','2013-08-12','15:10:00',3.38),('5819','2013-08-12','15:15:00',3.28),('5819','2013-08-12','15:20:00',2.65),('5819','2013-08-12','15:25:00',2.87),('5819','2013-08-12','15:30:00',3.05),('5819','2013-08-12','15:35:00',2.85),('5819','2013-08-12','15:40:00',2.84),('5819','2013-08-12','15:45:00',2.76),('5819','2013-08-12','15:50:00',2.71),('5819','2013-08-12','15:55:00',2.65),('5819','2013-08-12','16:00:00',2.58),('5819','2013-08-12','16:05:00',2.51),('5819','2013-08-12','16:10:00',2.46),('5819','2013-08-12','16:15:00',2.39),('5819','2013-08-12','16:20:00',2.33),('5819','2013-08-12','16:25:00',2.27),('5819','2013-08-12','16:30:00',2.21),('5819','2013-08-12','16:35:00',2.12),('5819','2013-08-12','16:40:00',2.07),('5819','2013-08-12','16:45:00',1.99),('5819','2013-08-12','16:50:00',1.92),('5819','2013-08-12','16:55:00',1.85),('5819','2013-08-12','17:00:00',1.8),('5819','2013-08-12','17:05:00',1.72),('5819','2013-08-12','17:10:00',1.63),('5819','2013-08-12','17:15:00',1.55),('5819','2013-08-12','17:20:00',1.48),('5819','2013-08-12','17:25:00',1.4),('5819','2013-08-12','17:30:00',1.34),('5819','2013-08-12','17:35:00',1.26),('5819','2013-08-12','17:40:00',1.09),('5819','2013-08-12','17:45:00',1.06),('5819','2013-08-12','17:50:00',1.01),('5819','2013-08-11','07:45:00',1.02),('5819','2013-08-11','07:50:00',1.11),('5819','2013-08-11','07:55:00',1.2),('5819','2013-08-11','08:00:00',1.28),('5819','2013-08-11','08:05:00',1.32),('5819','2013-08-11','08:10:00',1.44),('5819','2013-08-11','08:15:00',1.52),('5819','2013-08-11','08:20:00',1.61),('5819','2013-08-11','08:25:00',1.68),('5819','2013-08-11','08:30:00',1.75),('5819','2013-08-11','08:35:00',1.83),('5819','2013-08-11','08:40:00',1.9),('5819','2013-08-11','08:45:00',1.99),('5819','2013-08-11','08:50:00',2.06),('5819','2013-08-11','08:55:00',2.12),('5819','2013-08-11','09:00:00',2.2),('5819','2013-08-11','09:05:00',2.27),('5819','2013-08-11','09:10:00',2.34),('5819','2013-08-11','09:15:00',2.4),('5819','2013-08-11','09:20:00',2.47),('5819','2013-08-11','09:25:00',2.54),('5819','2013-08-11','09:30:00',2.6),('5819','2013-08-11','09:35:00',2.66),('5819','2013-08-11','09:40:00',2.72),('5819','2013-08-11','09:45:00',2.8),('5819','2013-08-11','09:50:00',2.84),('5819','2013-08-11','09:55:00',2.9),('5819','2013-08-11','10:00:00',2.95),('5819','2013-08-11','10:05:00',2.99),('5819','2013-08-11','10:10:00',3.04),('5819','2013-08-11','10:15:00',3.09),('5819','2013-08-11','10:20:00',3.12),('5819','2013-08-11','10:25:00',3.15),('5819','2013-08-11','10:30:00',3.19),('5819','2013-08-11','10:35:00',3.21),('5819','2013-08-11','10:40:00',3.24),('5819','2013-08-11','10:45:00',3.29),('5819','2013-08-11','10:50:00',3.32),('5819','2013-08-11','10:55:00',3.36),('5819','2013-08-11','11:00:00',3.39),('5819','2013-08-11','11:05:00',3.43),('5819','2013-08-11','11:10:00',3.47),('5819','2013-08-11','11:15:00',3.45),('5819','2013-08-11','11:20:00',3.49),('5819','2013-08-11','11:25:00',3.54),('5819','2013-08-11','11:30:00',3.54),('5819','2013-08-11','11:35:00',3.53),('5819','2013-08-11','11:40:00',3.54),('5819','2013-08-11','11:45:00',3.54),('5819','2013-08-11','11:50:00',3.59),('5819','2013-08-11','11:55:00',3.59),('5819','2013-08-11','12:00:00',3.6),('5819','2013-08-11','12:05:00',3.61),('5819','2013-08-11','12:10:00',3.63),('5819','2013-08-11','12:15:00',3.62),('5819','2013-08-11','12:20:00',3.65),('5819','2013-08-11','12:25:00',3.67),('5819','2013-08-11','12:30:00',3.65),('5819','2013-08-11','12:35:00',3.64),('5819','2013-08-11','12:40:00',3.65),('5819','2013-08-11','12:45:00',3.65),('5819','2013-08-11','12:50:00',3.65),('5819','2013-08-11','12:55:00',3.64),('5819','2013-08-11','13:00:00',3.62),('5819','2013-08-11','13:05:00',3.61),('5819','2013-08-11','13:10:00',3.57),('5819','2013-08-11','13:15:00',3.57),('5819','2013-08-11','13:20:00',3.57),('5819','2013-08-11','13:25:00',3.58),('5819','2013-08-11','13:30:00',3.55),('5819','2013-08-11','13:35:00',3.51),('5819','2013-08-11','13:40:00',3.53),('5819','2013-08-11','13:45:00',3.5),('5819','2013-08-11','13:50:00',3.49),('5819','2013-08-11','13:55:00',3.45),('5819','2013-08-11','14:00:00',3.44),('5819','2013-08-11','14:05:00',3.42),('5819','2013-08-11','14:10:00',3.42),('5819','2013-08-11','14:15:00',3.33),('5819','2013-08-11','14:20:00',3.35),('5819','2013-08-11','14:25:00',3.29),('5819','2013-08-11','14:30:00',3.26),('5819','2013-08-11','14:35:00',3.23),('5819','2013-08-11','14:40:00',3.24),('5819','2013-08-11','14:45:00',3.2),('5819','2013-08-11','14:50:00',3.13),('5819','2013-08-11','14:55:00',3.12),('5819','2013-08-11','15:00:00',3.13),('5819','2013-08-11','15:05:00',3.07),('5819','2013-08-11','15:10:00',2.99),('5819','2013-08-11','15:15:00',2.95),('5819','2013-08-11','15:20:00',2.94),('5819','2013-08-11','15:25:00',2.97),('5819','2013-08-11','15:30:00',2.12),('5819','2013-08-11','15:35:00',2.79),('5819','2013-08-11','15:40:00',2.77),('5819','2013-08-11','15:45:00',2.73),('5819','2013-08-11','15:50:00',2.71),('5819','2013-08-11','15:55:00',2.65),('5819','2013-08-11','16:00:00',2.58),('5819','2013-08-11','16:05:00',2.51),('5819','2013-08-11','16:10:00',2.45),('5819','2013-08-11','16:15:00',2.38),('5819','2013-08-11','16:20:00',2.32),('5819','2013-08-11','16:25:00',2.25),('5819','2013-08-11','16:30:00',2.17),('5819','2013-08-11','16:35:00',2.12),('5819','2013-08-11','16:40:00',2.05),('5819','2013-08-11','16:45:00',1.98),('5819','2013-08-11','16:50:00',1.91),('5819','2013-08-11','16:55:00',1.84),('5819','2013-08-11','17:00:00',1.78),('5819','2013-08-11','17:05:00',1.71),('5819','2013-08-11','17:10:00',1.63),('5819','2013-08-11','17:15:00',1.55),('5819','2013-08-11','17:20:00',1.48),('5819','2013-08-11','17:25:00',1.4),('5819','2013-08-11','17:30:00',1.33),('5819','2013-08-11','17:35:00',1.26),('5819','2013-08-11','17:40:00',1.11),('5819','2013-08-11','17:45:00',1.01),('5819','2013-08-11','17:50:00',1.01),('5819','2013-08-10','07:45:00',1.04),('5819','2013-08-10','07:50:00',1.12),('5819','2013-08-10','07:55:00',1.2),('5819','2013-08-10','08:00:00',1.3),('5819','2013-08-10','08:05:00',1.38),('5819','2013-08-10','08:10:00',1.48),('5819','2013-08-10','08:15:00',1.57),('5819','2013-08-10','08:20:00',1.66),('5819','2013-08-10','08:25:00',1.75),('5819','2013-08-10','08:30:00',1.83),('5819','2013-08-10','08:35:00',1.91),('5819','2013-08-10','08:40:00',1.98),('5819','2013-08-10','08:45:00',2.04),('5819','2013-08-10','08:50:00',2.11),('5819','2013-08-10','08:55:00',2.18),('5819','2013-08-10','09:00:00',2.24),('5819','2013-08-10','09:05:00',2.32),('5819','2013-08-10','09:10:00',2.39),('5819','2013-08-10','09:15:00',2.46),('5819','2013-08-10','09:20:00',2.53),('5819','2013-08-10','09:25:00',2.6),('5819','2013-08-10','09:30:00',2.66),('5819','2013-08-10','09:35:00',2.7),('5819','2013-08-10','09:40:00',2.74),('5819','2013-08-10','09:45:00',2.81),('5819','2013-08-10','09:50:00',2.86),('5819','2013-08-10','09:55:00',2.9),('5819','2013-08-10','10:00:00',2.96),('5819','2013-08-10','10:05:00',2.99),('5819','2013-08-10','10:15:00',3.09),('5819','2013-08-10','10:20:00',3.12),('5819','2013-08-10','10:25:00',3.16),('5819','2013-08-10','10:30:00',3.19),('5819','2013-08-10','10:35:00',3.22),('5819','2013-08-10','10:40:00',3.29),('5819','2013-08-10','10:45:00',3.32),('5819','2013-08-10','10:50:00',3.36),('5819','2013-08-10','10:55:00',3.41),('5819','2013-08-10','11:00:00',3.51),('5819','2013-08-10','11:05:00',3.53),('5819','2013-08-10','11:10:00',3.25),('5819','2013-08-10','11:15:00',3.12),('5819','2013-08-10','11:20:00',2.31),('5819','2013-08-10','11:25:00',2.57),('5819','2013-08-10','11:30:00',3.12),('5819','2013-08-10','11:35:00',3.69),('5819','2013-08-10','11:40:00',3.64),('5819','2013-08-10','11:45:00',3.64),('5819','2013-08-10','11:50:00',3.65),('5819','2013-08-10','11:55:00',3.63),('5819','2013-08-10','12:00:00',3.66),('5819','2013-08-10','12:05:00',3.68),('5819','2013-08-10','12:10:00',3.69),('5819','2013-08-10','12:15:00',3.68),('5819','2013-08-10','12:20:00',3.68),('5819','2013-08-10','12:25:00',3.7),('5819','2013-08-10','12:30:00',3.66),('5819','2013-08-10','12:35:00',3.68),('5819','2013-08-10','12:40:00',3.71),('5819','2013-08-10','12:45:00',3.78),('5819','2013-08-10','12:50:00',3.84),('5819','2013-08-10','12:55:00',3.84),('5819','2013-08-10','13:00:00',3.78),('5819','2013-08-10','13:05:00',3.74),('5819','2013-08-10','13:10:00',3.78),('5819','2013-08-10','13:15:00',3.85),('5819','2013-08-10','13:20:00',3.64),('5819','2013-08-10','13:25:00',3.94),('5819','2013-08-10','13:30:00',3.36),('5819','2013-08-10','13:35:00',2.49),('5819','2013-08-10','13:45:00',1.65),('5819','2013-08-10','13:50:00',3.87),('5819','2013-08-10','13:55:00',3.76),('5819','2013-08-10','14:00:00',3.94),('5819','2013-08-10','14:05:00',3.14),('5819','2013-08-10','14:10:00',3.96),('5819','2013-08-10','14:15:00',3.35),('5819','2013-08-10','14:20:00',1.81),('5819','2013-08-10','14:25:00',1.18),('5819','2013-08-10','14:30:00',1.21),('5819','2013-08-10','14:35:00',1.05),('5819','2013-08-10','15:10:00',1.04),('5819','2013-08-10','15:15:00',1.23),('5819','2013-08-10','15:20:00',1.23),('5819','2013-08-10','15:25:00',1.08),('5819','2013-08-10','15:30:00',1.04),('5819','2013-08-10','15:35:00',1.29),('5819','2013-08-10','15:40:00',1.21),('5819','2013-08-10','15:45:00',1.28),('5819','2013-08-10','15:50:00',1.47),('5819','2013-08-10','15:55:00',1.72),('5819','2013-08-10','16:00:00',1.9),('5819','2013-08-10','16:05:00',3.21),('5819','2013-08-10','16:10:00',1.72),('5819','2013-08-10','16:15:00',1.84),('5819','2013-08-10','16:20:00',2.02),('5819','2013-08-10','16:25:00',1.05),('5819','2013-08-10','16:30:00',1.59),('5819','2013-08-10','16:35:00',2.64),('5819','2013-08-10','16:40:00',2.35),('5819','2013-08-10','16:45:00',2.3),('5819','2013-08-10','16:50:00',2.12),('5819','2013-08-10','16:55:00',1.94),('5819','2013-08-10','17:00:00',1.76),('5819','2013-08-10','17:05:00',1.37),('5819','2013-08-10','17:15:00',1.06),('5819','2013-08-09','08:05:00',1.24),('5819','2013-08-09','08:10:00',1.07),('5819','2013-08-09','08:35:00',1.18),('5819','2013-08-09','08:40:00',1.63),('5819','2013-08-09','08:45:00',1.56),('5819','2013-08-09','08:50:00',1.84),('5819','2013-08-09','08:55:00',1.82),('5819','2013-08-09','09:00:00',1.78),('5819','2013-08-09','09:05:00',2.11),('5819','2013-08-09','09:10:00',2.2),('5819','2013-08-09','09:15:00',1.88),('5819','2013-08-09','09:20:00',1.77),('5819','2013-08-09','09:25:00',1.56),('5819','2013-08-09','09:30:00',2.13),('5819','2013-08-09','09:35:00',2.64),('5819','2013-08-09','09:40:00',2.13),('5819','2013-08-09','09:45:00',2.66),('5819','2013-08-09','09:50:00',2.66),('5819','2013-08-09','09:55:00',1.75),('5819','2013-08-09','10:00:00',1.96),('5819','2013-08-09','10:05:00',2.37),('5819','2013-08-09','10:10:00',2.76),('5819','2013-08-09','10:15:00',2.78),('5819','2013-08-09','10:20:00',2.77),('5819','2013-08-09','10:25:00',2.8),('5819','2013-08-09','10:30:00',2.88),('5819','2013-08-09','10:35:00',2.89),('5819','2013-08-09','10:40:00',3.01),('5819','2013-08-09','10:45:00',2.93),('5819','2013-08-09','10:50:00',3.02),('5819','2013-08-09','10:55:00',3.05),('5819','2013-08-09','11:00:00',3.09),('5819','2013-08-09','11:05:00',3.11),('5819','2013-08-09','11:10:00',3.14),('5819','2013-08-09','11:15:00',3.18),('5819','2013-08-09','11:20:00',3.22),('5819','2013-08-09','11:25:00',3.25),('5819','2013-08-09','11:30:00',3.26),('5819','2013-08-09','11:35:00',3.23),('5819','2013-08-09','11:40:00',3.24),('5819','2013-08-09','11:45:00',3.27),('5819','2013-08-09','11:50:00',3.31),('5819','2013-08-09','11:55:00',3.34),('5819','2013-08-09','12:00:00',3.34),('5819','2013-08-09','12:05:00',3.32),('5819','2013-08-09','12:10:00',3.36),('5819','2013-08-09','12:15:00',3.41),('5819','2013-08-09','12:20:00',3.53),('5819','2013-08-09','12:25:00',3.36),('5819','2013-08-09','12:30:00',2.41),('5819','2013-08-09','12:35:00',2.95),('5819','2013-08-09','12:40:00',3.67),('5819','2013-08-09','12:45:00',2.81),('5819','2013-08-09','12:50:00',2.3),('5819','2013-08-09','12:55:00',2.42),('5819','2013-08-09','13:00:00',1.43),('5819','2013-08-09','13:20:00',1.18),('5819','2013-08-09','13:25:00',1.91),('5819','2013-08-09','13:30:00',1.86),('5819','2013-08-09','13:35:00',1.37),('5819','2013-08-09','13:40:00',1.43),('5819','2013-08-09','13:45:00',1.32),('5819','2013-08-09','13:50:00',1.36),('5819','2013-08-09','13:55:00',1.19),('5819','2013-08-09','14:00:00',1.1),('5819','2013-08-09','14:05:00',1.14),('5819','2013-08-09','14:10:00',1.5),('5819','2013-08-09','14:30:00',1.02),('5819','2013-08-09','15:05:00',1.18),('5819','2013-08-09','15:10:00',2.46),('5819','2013-08-09','15:15:00',2.29),('5819','2013-08-09','15:20:00',1.38),('5819','2013-08-09','15:25:00',1.14),('5819','2013-08-09','15:35:00',1.76),('5819','2013-08-09','15:40:00',1.38),('5819','2013-08-09','15:45:00',2.57),('5819','2013-08-09','15:50:00',1.89),('5819','2013-08-09','15:55:00',1.91),('5819','2013-08-09','16:00:00',1.1),('5819','2013-08-09','16:50:00',1.15),('5819','2013-08-09','16:55:00',1.8),('5819','2013-08-09','17:00:00',1.23),('5819','2013-08-09','17:05:00',1.63),('5819','2013-08-08','07:55:00',1.05),('5819','2013-08-08','08:00:00',1.13),('5819','2013-08-08','08:05:00',1.2),('5819','2013-08-08','08:10:00',1.28),('5819','2013-08-08','08:15:00',1.35),('5819','2013-08-08','08:20:00',1.41),('5819','2013-08-08','08:25:00',1.5),('5819','2013-08-08','08:30:00',1.58),('5819','2013-08-08','08:35:00',1.65),('5819','2013-08-08','08:40:00',1.72),('5819','2013-08-08','08:45:00',1.78),('5819','2013-08-08','08:50:00',1.85),('5819','2013-08-08','08:55:00',1.91),('5819','2013-08-08','09:00:00',2),('5819','2013-08-08','09:05:00',2.08),('5819','2013-08-08','09:10:00',2.14),('5819','2013-08-08','09:15:00',2.21),('5819','2013-08-08','09:20:00',2.27),('5819','2013-08-08','09:25:00',2.33),('5819','2013-08-08','09:30:00',2.39),('5819','2013-08-08','09:35:00',2.47),('5819','2013-08-08','09:40:00',2.52),('5819','2013-08-08','09:45:00',2.57),('5819','2013-08-08','09:50:00',2.61),('5819','2013-08-08','09:55:00',2.66),('5819','2013-08-08','10:00:00',2.71),('5819','2013-08-08','10:05:00',2.75),('5819','2013-08-08','10:10:00',2.8),('5819','2013-08-08','10:15:00',2.84),('5819','2013-08-08','10:20:00',2.87),('5819','2013-08-08','10:25:00',2.9),('5819','2013-08-08','10:30:00',2.94),('5819','2013-08-08','10:35:00',2.97),('5819','2013-08-08','10:40:00',3),('5819','2013-08-08','10:45:00',3.03),('5819','2013-08-08','10:50:00',3.07),('5819','2013-08-08','10:55:00',3.1),('5819','2013-08-08','11:00:00',3.12),('5819','2013-08-08','11:05:00',3.15),('5819','2013-08-08','11:10:00',3.18),('5819','2013-08-08','11:15:00',3.19),('5819','2013-08-08','11:20:00',3.21),('5819','2013-08-08','11:25:00',3.23),('5819','2013-08-08','11:30:00',3.2),('5819','2013-08-08','11:35:00',3.24),('5819','2013-08-08','11:40:00',3.29),('5819','2013-08-08','11:45:00',3.29),('5819','2013-08-08','11:50:00',3.29),('5819','2013-08-08','11:55:00',3.3),('5819','2013-08-08','12:00:00',3.33),('5819','2013-08-08','12:05:00',3.32),('5819','2013-08-08','12:10:00',3.31),('5819','2013-08-08','12:15:00',3.34),('5819','2013-08-08','12:20:00',3.34),('5819','2013-08-08','12:25:00',3.36),('5819','2013-08-08','12:30:00',3.41),('5819','2013-08-08','12:35:00',3.42),('5819','2013-08-08','12:40:00',3.39),('5819','2013-08-08','12:45:00',3.39),('5819','2013-08-08','12:50:00',3.39),('5819','2013-08-08','12:55:00',3.41),('5819','2013-08-08','13:00:00',3.41),('5819','2013-08-08','13:05:00',3.42),('5819','2013-08-08','13:10:00',3.41),('5819','2013-08-08','13:15:00',3.4),('5819','2013-08-08','13:20:00',3.4),('5819','2013-08-08','13:25:00',3.41),('5819','2013-08-08','13:30:00',3.38),('5819','2013-08-08','13:35:00',3.36),('5819','2013-08-08','13:40:00',3.34),('5819','2013-08-08','13:45:00',3.29),('5819','2013-08-08','13:50:00',3.3),('5819','2013-08-08','13:55:00',3.26),('5819','2013-08-08','14:00:00',3.27),('5819','2013-08-08','14:05:00',3.26),('5819','2013-08-08','14:10:00',3.23),('5819','2013-08-08','14:15:00',3.19),('5819','2013-08-08','14:20:00',3.16),('5819','2013-08-08','14:25:00',3.12),('5819','2013-08-08','14:30:00',3.1),('5819','2013-08-08','14:35:00',3.08),('5819','2013-08-08','14:40:00',3.05),('5819','2013-08-08','14:45:00',3.02),('5819','2013-08-08','14:50:00',2.98),('5819','2013-08-08','14:55:00',2.94),('5819','2013-08-08','15:00:00',2.91),('5819','2013-08-08','15:05:00',2.85),('5819','2013-08-08','15:10:00',2.81),('5819','2013-08-08','15:15:00',2.79),('5819','2013-08-08','15:20:00',2.74),('5819','2013-08-08','15:25:00',2.69),('5819','2013-08-08','15:30:00',2.66),('5819','2013-08-08','15:35:00',2.59),('5819','2013-08-08','15:40:00',2.54),('5819','2013-08-08','15:45:00',2.51),('5819','2013-08-08','15:50:00',2.46),('5819','2013-08-08','15:55:00',2.4),('5819','2013-08-08','16:00:00',2.36),('5819','2013-08-08','16:05:00',2.32),('5819','2013-08-08','16:10:00',2.27),('5819','2013-08-08','16:15:00',2.21),('5819','2013-08-08','16:20:00',2.17),('5819','2013-08-08','16:25:00',2.13),('5819','2013-08-08','16:30:00',2.07),('5819','2013-08-08','16:35:00',2),('5819','2013-08-08','16:40:00',1.95),('5819','2013-08-08','16:45:00',1.88),('5819','2013-08-08','16:50:00',1.8),('5819','2013-08-08','16:55:00',1.74),('5819','2013-08-08','17:00:00',1.68),('5819','2013-08-08','17:05:00',1.6),('5819','2013-08-08','17:10:00',1.52),('5819','2013-08-08','17:15:00',1.46),('5819','2013-08-08','17:20:00',1.4),('5819','2013-08-08','17:25:00',1.32),('5819','2013-08-08','17:30:00',1.25),('5819','2013-08-08','17:35:00',1.18),('5819','2013-08-08','17:40:00',1.08),('5819','2013-08-07','07:50:00',1.03),('5819','2013-08-07','07:55:00',1.11),('5819','2013-08-07','08:00:00',1.19),('5819','2013-08-07','08:05:00',1.26),('5819','2013-08-07','08:10:00',1.34),('5819','2013-08-07','08:15:00',1.41),('5819','2013-08-07','08:20:00',1.5),('5819','2013-08-07','08:25:00',1.58),('5819','2013-08-07','08:30:00',1.66),('5819','2013-08-07','08:35:00',1.73),('5819','2013-08-07','08:40:00',1.8),('5819','2013-08-07','08:45:00',1.88),('5819','2013-08-07','08:50:00',1.93),('5819','2013-08-07','08:55:00',1.98),('5819','2013-08-07','09:00:00',2.05),('5819','2013-08-07','09:05:00',2.12),('5819','2013-08-07','09:10:00',2.2),('5819','2013-08-07','09:15:00',2.27),('5819','2013-08-07','09:20:00',2.33),('5819','2013-08-07','09:25:00',2.38),('5819','2013-08-07','09:30:00',2.44),('5819','2013-08-07','09:35:00',2.5),('5819','2013-08-07','09:40:00',2.54),('5819','2013-08-07','09:45:00',2.56),('5819','2013-08-07','09:50:00',2.63),('5819','2013-08-07','09:55:00',2.7),('5819','2013-08-07','10:00:00',2.76),('5819','2013-08-07','10:05:00',2.76),('5819','2013-08-07','10:10:00',2.83),('5819','2013-08-07','10:15:00',2.86),('5819','2013-08-07','10:20:00',2.92),('5819','2013-08-07','10:25:00',2.97),('5819','2013-08-07','10:30:00',2.98),('5819','2013-08-07','10:35:00',2.99),('5819','2013-08-07','10:40:00',3.06),('5819','2013-08-07','10:45:00',3.11),('5819','2013-08-07','10:50:00',3.14),('5819','2013-08-07','10:55:00',3.15),('5819','2013-08-07','11:00:00',3.17),('5819','2013-08-07','11:05:00',3.18),('5819','2013-08-07','11:10:00',3.19),('5819','2013-08-07','11:15:00',3.22),('5819','2013-08-07','11:20:00',3.25),('5819','2013-08-07','11:25:00',3.27),('5819','2013-08-07','11:30:00',3.27),('5819','2013-08-07','11:35:00',3.29),('5819','2013-08-07','11:40:00',3.3),('5819','2013-08-07','11:45:00',3.31),('5819','2013-08-07','11:50:00',3.33),('5819','2013-08-07','11:55:00',3.33),('5819','2013-08-07','12:00:00',3.37),('5819','2013-08-07','12:05:00',3.37),('5819','2013-08-07','12:10:00',3.38),('5819','2013-08-07','12:15:00',3.38),('5819','2013-08-07','12:20:00',3.38),('5819','2013-08-07','12:25:00',3.35),('5819','2013-08-07','12:30:00',3.35),('5819','2013-08-07','12:35:00',3.39),('5819','2013-08-07','12:40:00',3.34),('5819','2013-08-07','12:45:00',3.33),('5819','2013-08-07','12:50:00',3.35),('5819','2013-08-07','12:55:00',3.36),('5819','2013-08-07','13:00:00',3.36),('5819','2013-08-07','13:05:00',3.38),('5819','2013-08-07','13:10:00',3.41),('5819','2013-08-07','13:15:00',3.38),('5819','2013-08-07','13:20:00',3.4),('5819','2013-08-07','13:25:00',3.33),('5819','2013-08-07','13:30:00',3.35),('5819','2013-08-07','13:35:00',3.25),('5819','2013-08-07','13:40:00',3.34),('5819','2013-08-07','13:45:00',3.35),('5819','2013-08-07','13:50:00',3.3),('5819','2013-08-07','13:55:00',3.32),('5819','2013-08-07','14:00:00',3.27),('5819','2013-08-07','14:05:00',3.28),('5819','2013-08-07','14:10:00',3.29),('5819','2013-08-07','14:15:00',3.16),('5819','2013-08-07','14:20:00',3.16),('5819','2013-08-07','14:25:00',3.1),('5819','2013-08-07','14:30:00',3.06),('5819','2013-08-07','14:35:00',3.03),('5819','2013-08-07','14:40:00',3.05),('5819','2013-08-07','14:45:00',3.08),('5819','2013-08-07','14:50:00',3.03),('5819','2013-08-07','14:55:00',3.01),('5819','2013-08-07','15:00:00',2.96),('5819','2013-08-07','15:05:00',2.89),('5819','2013-08-07','15:10:00',2.87),('5819','2013-08-07','15:15:00',2.82),('5819','2013-08-07','15:20:00',2.79),('5819','2013-08-07','15:25:00',2.74),('5819','2013-08-07','15:30:00',2.71),('5819','2013-08-07','15:35:00',2.66),('5819','2013-08-07','15:40:00',2.61),('5819','2013-08-07','15:45:00',2.56),('5819','2013-08-07','15:50:00',2.51),('5819','2013-08-07','15:55:00',2.46),('5819','2013-08-07','16:00:00',2.38),('5819','2013-08-07','16:05:00',2.35),('5819','2013-08-07','16:10:00',2.28),('5819','2013-08-07','16:15:00',2.23),('5819','2013-08-07','16:20:00',2.18),('5819','2013-08-07','16:25:00',2.14),('5819','2013-08-07','16:30:00',2.08),('5819','2013-08-07','16:35:00',2.03),('5819','2013-08-07','16:40:00',1.96),('5819','2013-08-07','16:45:00',1.9),('5819','2013-08-07','16:50:00',1.84),('5819','2013-08-07','16:55:00',1.77),('5819','2013-08-07','17:00:00',1.7),('5819','2013-08-07','17:05:00',1.64),('5819','2013-08-07','17:10:00',1.54),('5819','2013-08-07','17:15:00',1.48),('5819','2013-08-07','17:20:00',1.4),('5819','2013-08-07','17:25:00',1.36),('5819','2013-08-07','17:30:00',1.29),('5819','2013-08-07','17:35:00',1.21),('5819','2013-08-07','17:40:00',1.09),('5819','2013-08-06','07:55:00',1.07),('5819','2013-08-06','08:00:00',1.15),('5819','2013-08-06','08:05:00',1.23),('5819','2013-08-06','08:10:00',1.3),('5819','2013-08-06','08:15:00',1.38),('5819','2013-08-06','08:20:00',1.46),('5819','2013-08-06','08:25:00',1.55),('5819','2013-08-06','08:30:00',1.61),('5819','2013-08-06','08:35:00',1.68),('5819','2013-08-06','08:40:00',1.75),('5819','2013-08-06','08:45:00',1.82),('5819','2013-08-06','08:50:00',1.9),('5819','2013-08-06','08:55:00',1.97),('5819','2013-08-06','09:00:00',2.03),('5819','2013-08-06','09:05:00',2.1),('5819','2013-08-06','09:10:00',2.18),('5819','2013-08-06','09:15:00',2.23),('5819','2013-08-06','09:20:00',2.29),('5819','2013-08-06','09:25:00',2.33),('5819','2013-08-06','09:30:00',2.4),('5819','2013-08-06','09:35:00',2.46),('5819','2013-08-06','09:40:00',2.52),('5819','2013-08-06','09:45:00',2.57),('5819','2013-08-06','09:50:00',2.58),('5819','2013-08-06','09:55:00',2.65),('5819','2013-08-06','10:00:00',2.71),('5819','2013-08-06','10:05:00',2.76),('5819','2013-08-06','10:10:00',2.8),('5819','2013-08-06','10:15:00',2.84),('5819','2013-08-06','10:20:00',2.88),('5819','2013-08-06','10:25:00',2.91),('5819','2013-08-06','10:30:00',2.94),('5819','2013-08-06','10:35:00',2.96),('5819','2013-08-06','10:40:00',3),('5819','2013-08-06','10:45:00',3.02),('5819','2013-08-06','10:50:00',3.05),('5819','2013-08-06','10:55:00',3.08),('5819','2013-08-06','11:00:00',3.12),('5819','2013-08-06','11:05:00',3.16),('5819','2013-08-06','11:10:00',3.18),('5819','2013-08-06','11:15:00',3.21),('5819','2013-08-06','11:20:00',3.24),('5819','2013-08-06','11:25:00',3.24),('5819','2013-08-06','11:30:00',3.28),('5819','2013-08-06','11:35:00',3.3),('5819','2013-08-06','11:40:00',3.31),('5819','2013-08-06','11:45:00',3.31),('5819','2013-08-06','11:50:00',3.31),('5819','2013-08-06','11:55:00',3.35),('5819','2013-08-06','12:00:00',3.37),('5819','2013-08-06','12:05:00',3.35),('5819','2013-08-06','12:10:00',3.37),('5819','2013-08-06','12:15:00',3.39),('5819','2013-08-06','12:20:00',3.39),('5819','2013-08-06','12:25:00',3.36),('5819','2013-08-06','12:30:00',3.39),('5819','2013-08-06','12:35:00',3.38),('5819','2013-08-06','12:40:00',3.38),('5819','2013-08-06','12:45:00',3.34),('5819','2013-08-06','12:50:00',3.34),('5819','2013-08-06','12:55:00',3.38),('5819','2013-08-06','13:00:00',3.38),('5819','2013-08-06','13:05:00',3.39),('5819','2013-08-06','13:10:00',3.36),('5819','2013-08-06','13:15:00',3.39),('5819','2013-08-06','13:20:00',3.37),('5819','2013-08-06','13:25:00',3.41),('5819','2013-08-06','13:30:00',3.4),('5819','2013-08-06','13:35:00',3.4),('5819','2013-08-06','13:40:00',3.38),('5819','2013-08-06','13:45:00',3.38),('5819','2013-08-06','13:50:00',3.39),('5819','2013-08-06','13:55:00',3.39),('5819','2013-08-06','14:00:00',3.39),('5819','2013-08-06','14:05:00',3.36),('5819','2013-08-06','14:10:00',3.34),('5819','2013-08-06','14:15:00',3.33),('5819','2013-08-06','14:20:00',3.3),('5819','2013-08-06','14:25:00',3.28),('5819','2013-08-06','14:30:00',3.27),('5819','2013-08-06','14:35:00',3.22),('5819','2013-08-06','14:40:00',3.19),('5819','2013-08-06','14:45:00',3.16),('5819','2013-08-06','14:50:00',3.13),('5819','2013-08-06','14:55:00',3.1),('5819','2013-08-06','15:00:00',3.07),('5819','2013-08-06','15:05:00',3.04),('5819','2013-08-06','15:10:00',2.99),('5819','2013-08-06','15:15:00',2.95),('5819','2013-08-06','15:20:00',2.92),('5819','2013-08-06','15:25:00',2.86),('5819','2013-08-06','15:30:00',2.82),('5819','2013-08-06','15:35:00',2.78),('5819','2013-08-06','15:40:00',2.73),('5819','2013-08-06','15:45:00',2.67),('5819','2013-08-06','15:50:00',2.62),('5819','2013-08-06','15:55:00',2.57),('5819','2013-08-06','16:00:00',2.51),('5819','2013-08-06','16:05:00',2.45),('5819','2013-08-06','16:10:00',2.39),('5819','2013-08-06','16:15:00',2.33),('5819','2013-08-06','16:20:00',2.28),('5819','2013-08-06','16:25:00',2.21),('5819','2013-08-06','16:30:00',2.16),('5819','2013-08-06','16:35:00',2.09),('5819','2013-08-06','16:40:00',2.03),('5819','2013-08-06','16:45:00',1.95),('5819','2013-08-06','16:50:00',1.89),('5819','2013-08-06','16:55:00',1.83),('5819','2013-08-06','17:00:00',1.75),('5819','2013-08-06','17:05:00',1.7),('5819','2013-08-06','17:10:00',1.62),('5819','2013-08-06','17:15:00',1.53),('5819','2013-08-06','17:20:00',1.46),('5819','2013-08-06','17:25:00',1.39),('5819','2013-08-06','17:30:00',1.32),('5819','2013-08-06','17:35:00',1.25),('5819','2013-08-06','17:40:00',1.14),('5819','2013-08-06','17:45:00',1.05),('5819','2013-08-06','17:50:00',1.01),('5819','2013-08-05','07:50:00',1.07),('5819','2013-08-05','07:55:00',1.15),('5819','2013-08-05','08:00:00',1.23),('5819','2013-08-05','08:05:00',1.31),('5819','2013-08-05','08:10:00',1.39),('5819','2013-08-05','08:15:00',1.47),('5819','2013-08-05','08:20:00',1.54),('5819','2013-08-05','08:25:00',1.62),('5819','2013-08-05','08:30:00',1.68),('5819','2013-08-05','08:35:00',1.75),('5819','2013-08-05','08:40:00',1.83),('5819','2013-08-05','08:45:00',1.9),('5819','2013-08-05','08:50:00',1.97),('5819','2013-08-05','08:55:00',2.03),('5819','2013-08-05','09:00:00',2.1),('5819','2013-08-05','09:05:00',2.16),('5819','2013-08-05','09:10:00',2.22),('5819','2013-08-05','09:15:00',2.29),('5819','2013-08-05','09:20:00',2.33),('5819','2013-08-05','09:25:00',2.39),('5819','2013-08-05','09:30:00',2.44),('5819','2013-08-05','09:35:00',2.5),('5819','2013-08-05','09:40:00',2.54),('5819','2013-08-05','09:45:00',2.59),('5819','2013-08-05','09:50:00',2.63),('5819','2013-08-05','09:55:00',2.7),('5819','2013-08-05','10:00:00',2.75),('5819','2013-08-05','10:05:00',2.79),('5819','2013-08-05','10:10:00',2.84),('5819','2013-08-05','10:15:00',2.88),('5819','2013-08-05','10:20:00',2.92),('5819','2013-08-05','10:25:00',2.99),('5819','2013-08-05','10:30:00',3.01),('5819','2013-08-05','10:35:00',3.05),('5819','2013-08-05','10:40:00',3.08),('5819','2013-08-05','10:45:00',3.11),('5819','2013-08-05','10:50:00',3.14),('5819','2013-08-05','10:55:00',3.18),('5819','2013-08-05','11:00:00',3.2),('5819','2013-08-05','11:05:00',3.25),('5819','2013-08-05','11:10:00',3.27),('5819','2013-08-05','11:15:00',3.3),('5819','2013-08-05','11:20:00',3.33),('5819','2013-08-05','11:25:00',3.34),('5819','2013-08-05','11:30:00',3.34),('5819','2013-08-05','11:35:00',3.37),('5819','2013-08-05','11:40:00',3.37),('5819','2013-08-05','11:45:00',3.42),('5819','2013-08-05','11:50:00',3.43),('5819','2013-08-05','11:55:00',3.44),('5819','2013-08-05','12:00:00',3.44),('5819','2013-08-05','12:05:00',3.45),('5819','2013-08-05','12:10:00',3.46),('5819','2013-08-05','12:15:00',3.45),('5819','2013-08-05','12:20:00',3.46),('5819','2013-08-05','12:25:00',3.48),('5819','2013-08-05','12:30:00',3.46),('5819','2013-08-05','12:35:00',3.46),('5819','2013-08-05','12:40:00',3.47),('5819','2013-08-05','12:45:00',3.51),('5819','2013-08-05','12:50:00',3.48),('5819','2013-08-05','12:55:00',3.46),('5819','2013-08-05','13:00:00',3.48),('5819','2013-08-05','13:05:00',3.49),('5819','2013-08-05','13:10:00',3.43),('5819','2013-08-05','13:15:00',3.42),('5819','2013-08-05','13:20:00',3.42),('5819','2013-08-05','13:25:00',3.41),('5819','2013-08-05','13:30:00',3.39),('5819','2013-08-05','13:35:00',3.39),('5819','2013-08-05','13:40:00',3.36),('5819','2013-08-05','13:45:00',3.37),('5819','2013-08-05','13:50:00',3.35),('5819','2013-08-05','13:55:00',3.28),('5819','2013-08-05','14:00:00',3.26),('5819','2013-08-05','14:05:00',3.29),('5819','2013-08-05','14:10:00',3.24),('5819','2013-08-05','14:15:00',3.22),('5819','2013-08-05','14:20:00',3.23),('5819','2013-08-05','14:25:00',3.17),('5819','2013-08-05','14:30:00',3.15),('5819','2013-08-05','14:35:00',3.13),('5819','2013-08-05','14:40:00',3.11),('5819','2013-08-05','14:45:00',3.1),('5819','2013-08-05','14:50:00',3.04),('5819','2013-08-05','14:55:00',3.02),('5819','2013-08-05','15:00:00',2.98),('5819','2013-08-05','15:05:00',2.96),('5819','2013-08-05','15:10:00',2.93),('5819','2013-08-05','15:15:00',2.91),('5819','2013-08-05','15:20:00',2.86),('5819','2013-08-05','15:25:00',2.83),('5819','2013-08-05','15:30:00',2.79),('5819','2013-08-05','15:35:00',2.74),('5819','2013-08-05','15:40:00',2.69),('5819','2013-08-05','15:45:00',2.63),('5819','2013-08-05','15:50:00',2.56),('5819','2013-08-05','15:55:00',2.52),('5819','2013-08-05','16:00:00',2.49),('5819','2013-08-05','16:05:00',2.46),('5819','2013-08-05','16:10:00',2.39),('5819','2013-08-05','16:15:00',2.31),('5819','2013-08-05','16:20:00',2.25),('5819','2013-08-05','16:25:00',2.18),('5819','2013-08-05','16:30:00',2.13),('5819','2013-08-05','16:35:00',2.09),('5819','2013-08-05','16:40:00',2.02),('5819','2013-08-05','16:45:00',1.95),('5819','2013-08-05','16:50:00',1.88),('5819','2013-08-05','16:55:00',1.8),('5819','2013-08-05','17:00:00',1.74),('5819','2013-08-05','17:05:00',1.68),('5819','2013-08-05','17:10:00',1.6),('5819','2013-08-05','17:15:00',1.52),('5819','2013-08-05','17:20:00',1.45),('5819','2013-08-05','17:25:00',1.38),('5819','2013-08-05','17:30:00',1.32),('5819','2013-08-05','17:35:00',1.25),('5819','2013-08-05','17:40:00',1.16),('5819','2013-08-05','17:45:00',1.03),('5819','2013-08-05','17:50:00',1.02),('5819','2013-08-04','07:40:00',1.02),('5819','2013-08-04','07:45:00',1.11),('5819','2013-08-04','07:50:00',1.18),('5819','2013-08-04','07:55:00',1.26),('5819','2013-08-04','08:00:00',1.35),('5819','2013-08-04','08:05:00',1.43),('5819','2013-08-04','08:10:00',1.51),('5819','2013-08-04','08:15:00',1.59),('5819','2013-08-04','08:20:00',1.67),('5819','2013-08-04','08:25:00',1.74),('5819','2013-08-04','08:30:00',1.81),('5819','2013-08-04','08:35:00',1.88),('5819','2013-08-04','08:40:00',1.96),('5819','2013-08-04','08:45:00',2.03),('5819','2013-08-04','08:50:00',2.1),('5819','2013-08-04','08:55:00',2.15),('5819','2013-08-04','09:00:00',2.22),('5819','2013-08-04','09:05:00',2.27),('5819','2013-08-04','09:10:00',2.35),('5819','2013-08-04','09:15:00',2.4),('5819','2013-08-04','09:20:00',2.46),('5819','2013-08-04','09:25:00',2.53),('5819','2013-08-04','09:30:00',2.59),('5819','2013-08-04','09:35:00',2.58),('5819','2013-08-04','09:40:00',2.7),('5819','2013-08-04','09:45:00',2.75),('5819','2013-08-04','09:50:00',2.79),('5819','2013-08-04','09:55:00',2.83),('5819','2013-08-04','10:00:00',2.87),('5819','2013-08-04','10:05:00',2.93),('5819','2013-08-04','10:10:00',2.95),('5819','2013-08-04','10:15:00',3),('5819','2013-08-04','10:20:00',3.04),('5819','2013-08-04','10:25:00',3.1),('5819','2013-08-04','10:30:00',3.14),('5819','2013-08-04','10:35:00',3.17),('5819','2013-08-04','10:40:00',3.19),('5819','2013-08-04','10:45:00',3.22),('5819','2013-08-04','10:50:00',3.25),('5819','2013-08-04','10:55:00',3.26),('5819','2013-08-04','11:00:00',3.27),('5819','2013-08-04','11:05:00',3.3),('5819','2013-08-04','11:10:00',3.33),('5819','2013-08-04','11:15:00',3.36),('5819','2013-08-04','11:20:00',3.39),('5819','2013-08-04','11:25:00',3.43),('5819','2013-08-04','11:30:00',3.45),('5819','2013-08-04','11:35:00',3.48),('5819','2013-08-04','11:40:00',3.5),('5819','2013-08-04','11:45:00',3.5),('5819','2013-08-04','11:50:00',3.51),('5819','2013-08-04','11:55:00',3.55),('5819','2013-08-04','12:00:00',3.56),('5819','2013-08-04','12:05:00',3.55),('5819','2013-08-04','12:10:00',3.57),('5819','2013-08-04','12:15:00',3.54),('5819','2013-08-04','12:20:00',3.56),('5819','2013-08-04','12:25:00',3.54),('5819','2013-08-04','12:30:00',3.54),('5819','2013-08-04','12:35:00',3.53),('5819','2013-08-04','12:40:00',3.56),('5819','2013-08-04','12:45:00',3.53),('5819','2013-08-04','12:50:00',3.56),('5819','2013-08-04','12:55:00',3.49),('5819','2013-08-04','13:00:00',3.51),('5819','2013-08-04','13:05:00',3.54),('5819','2013-08-04','13:10:00',3.49),('5819','2013-08-04','13:15:00',3.49),('5819','2013-08-04','13:20:00',3.48),('5819','2013-08-04','13:25:00',3.45),('5819','2013-08-04','13:30:00',3.46),('5819','2013-08-04','13:35:00',3.48),('5819','2013-08-04','13:40:00',3.49),('5819','2013-08-04','13:45:00',3.51),('5819','2013-08-04','13:50:00',3.5),('5819','2013-08-04','13:55:00',3.48),('5819','2013-08-04','14:00:00',3.46),('5819','2013-08-04','14:05:00',3.45),('5819','2013-08-04','14:10:00',3.41),('5819','2013-08-04','14:15:00',3.4),('5819','2013-08-04','14:20:00',3.36),('5819','2013-08-04','14:25:00',3.34),('5819','2013-08-04','14:30:00',3.31),('5819','2013-08-04','14:35:00',3.29),('5819','2013-08-04','14:40:00',3.27),('5819','2013-08-04','14:45:00',3.23),('5819','2013-08-04','14:50:00',3.2),('5819','2013-08-04','14:55:00',3.16),('5819','2013-08-04','15:00:00',3.12),('5819','2013-08-04','15:05:00',3.08),('5819','2013-08-04','15:10:00',3.05),('5819','2013-08-04','15:15:00',3.02),('5819','2013-08-04','15:20:00',2.98),('5819','2013-08-04','15:25:00',2.9),('5819','2013-08-04','15:30:00',2.83),('5819','2013-08-04','15:35:00',2.83),('5819','2013-08-04','15:40:00',2.77),('5819','2013-08-04','15:45:00',2.72),('5819','2013-08-04','15:50:00',2.65),('5819','2013-08-04','15:55:00',2.6),('5819','2013-08-04','16:00:00',2.55),('5819','2013-08-04','16:05:00',2.48),('5819','2013-08-04','16:10:00',2.44),('5819','2013-08-04','16:15:00',2.4),('5819','2013-08-04','16:20:00',2.36),('5819','2013-08-04','16:25:00',2.29),('5819','2013-08-04','16:30:00',2.21),('5819','2013-08-04','16:35:00',2.14),('5819','2013-08-04','16:40:00',2.08),('5819','2013-08-04','16:45:00',2),('5819','2013-08-04','16:50:00',1.93),('5819','2013-08-04','16:55:00',1.87),('5819','2013-08-04','17:00:00',1.78),('5819','2013-08-04','17:05:00',1.72),('5819','2013-08-04','17:10:00',1.67),('5819','2013-08-04','17:15:00',1.59),('5819','2013-08-04','17:20:00',1.51),('5819','2013-08-04','17:25:00',1.43),('5819','2013-08-04','17:30:00',1.35),('5819','2013-08-04','17:35:00',1.28),('5819','2013-08-04','17:40:00',1.18),('5819','2013-08-04','17:45:00',1.06),('5819','2013-08-04','17:50:00',1.04),('5819','2013-08-03','07:40:00',1.02),('5819','2013-08-03','07:45:00',1.1),('5819','2013-08-03','07:50:00',1.17),('5819','2013-08-03','07:55:00',1.25),('5819','2013-08-03','08:00:00',1.34),('5819','2013-08-03','08:05:00',1.41),('5819','2013-08-03','08:10:00',1.5),('5819','2013-08-03','08:15:00',1.58),('5819','2013-08-03','08:20:00',1.65),('5819','2013-08-03','08:25:00',1.73),('5819','2013-08-03','08:30:00',1.79),('5819','2013-08-03','08:35:00',1.86),('5819','2013-08-03','08:40:00',1.93),('5819','2013-08-03','08:45:00',2),('5819','2013-08-03','08:50:00',2.06),('5819','2013-08-03','08:55:00',2.13),('5819','2013-08-03','09:00:00',2.22),('5819','2013-08-03','09:05:00',2.28),('5819','2013-08-03','09:10:00',2.34),('5819','2013-08-03','09:15:00',2.4),('5819','2013-08-03','09:20:00',2.46),('5819','2013-08-03','09:25:00',2.52),('5819','2013-08-03','09:30:00',2.57),('5819','2013-08-03','09:35:00',2.63),('5819','2013-08-03','09:40:00',2.67),('5819','2013-08-03','09:45:00',2.72),('5819','2013-08-03','09:50:00',2.77),('5819','2013-08-03','09:55:00',2.82),('5819','2013-08-03','10:00:00',2.86),('5819','2013-08-03','10:05:00',2.91),('5819','2013-08-03','10:10:00',2.95),('5819','2013-08-03','10:15:00',3.01),('5819','2013-08-03','10:20:00',3.02),('5819','2013-08-03','10:25:00',3.06),('5819','2013-08-03','10:30:00',3.08),('5819','2013-08-03','10:35:00',3.1),('5819','2013-08-03','10:40:00',3.18),('5819','2013-08-03','10:45:00',3.24),('5819','2013-08-03','10:50:00',3.27),('5819','2013-08-03','10:55:00',3.3),('5819','2013-08-03','11:00:00',3.34),('5819','2013-08-03','11:05:00',3.36),('5819','2013-08-03','11:10:00',3.36),('5819','2013-08-03','11:15:00',3.38),('5819','2013-08-03','11:20:00',3.38),('5819','2013-08-03','11:25:00',3.41),('5819','2013-08-03','11:30:00',3.44),('5819','2013-08-03','11:35:00',3.46),('5819','2013-08-03','11:40:00',3.45),('5819','2013-08-03','11:45:00',3.44),('5819','2013-08-03','11:50:00',3.49),('5819','2013-08-03','11:55:00',3.5),('5819','2013-08-03','12:00:00',3.51),('5819','2013-08-03','12:05:00',3.56),('5819','2013-08-03','12:10:00',3.56),('5819','2013-08-03','12:15:00',3.56),('5819','2013-08-03','12:20:00',3.57),('5819','2013-08-03','12:25:00',3.56),('5819','2013-08-03','12:30:00',3.56),('5819','2013-08-03','12:35:00',3.52),('5819','2013-08-03','12:40:00',3.54),('5819','2013-08-03','12:45:00',3.54),('5819','2013-08-03','12:50:00',3.54),('5819','2013-08-03','12:55:00',3.55),('5819','2013-08-03','13:00:00',3.51),('5819','2013-08-03','13:05:00',3.46),('5819','2013-08-03','13:10:00',3.44),('5819','2013-08-03','13:15:00',3.41),('5819','2013-08-03','13:20:00',3.36),('5819','2013-08-03','13:25:00',3.36),('5819','2013-08-03','13:30:00',3.35),('5819','2013-08-03','13:35:00',3.28),('5819','2013-08-03','13:40:00',3.36),('5819','2013-08-03','13:45:00',3.38),('5819','2013-08-03','13:50:00',3.37),('5819','2013-08-03','13:55:00',3.37),('5819','2013-08-03','14:00:00',3.4),('5819','2013-08-03','14:05:00',3.36),('5819','2013-08-03','14:10:00',3.25),('5819','2013-08-03','14:15:00',3.19),('5819','2013-08-03','14:20:00',3.12),('5819','2013-08-03','14:25:00',3.12),('5819','2013-08-03','14:30:00',3.17),('5819','2013-08-03','14:35:00',3.21),('5819','2013-08-03','14:40:00',3.17),('5819','2013-08-03','14:45:00',3.18),('5819','2013-08-03','14:50:00',3.14),('5819','2013-08-03','14:55:00',3.13),('5819','2013-08-03','15:00:00',3.09),('5819','2013-08-03','15:05:00',3.02),('5819','2013-08-03','15:10:00',2.99),('5819','2013-08-03','15:15:00',2.94),('5819','2013-08-03','15:20:00',2.94),('5819','2013-08-03','15:25:00',2.91),('5819','2013-08-03','15:30:00',2.86),('5819','2013-08-03','15:35:00',2.82),('5819','2013-08-03','15:40:00',2.76),('5819','2013-08-03','15:45:00',2.71),('5819','2013-08-03','15:50:00',2.67),('5819','2013-08-03','15:55:00',2.61),('5819','2013-08-03','16:00:00',2.54),('5819','2013-08-03','16:05:00',2.49),('5819','2013-08-03','16:10:00',2.42),('5819','2013-08-03','16:15:00',2.34),('5819','2013-08-03','16:20:00',2.28),('5819','2013-08-03','16:25:00',2.23),('5819','2013-08-03','16:30:00',2.18),('5819','2013-08-03','16:35:00',2.12),('5819','2013-08-03','16:40:00',2.05),('5819','2013-08-03','16:45:00',1.99),('5819','2013-08-03','16:50:00',1.93),('5819','2013-08-03','16:55:00',1.86),('5819','2013-08-03','17:00:00',1.78),('5819','2013-08-03','17:05:00',1.71),('5819','2013-08-03','17:10:00',1.64),('5819','2013-08-03','17:15:00',1.57),('5819','2013-08-03','17:20:00',1.5),('5819','2013-08-03','17:25:00',1.43),('5819','2013-08-03','17:30:00',1.36),('5819','2013-08-03','17:35:00',1.29),('5819','2013-08-03','17:40:00',1.19),('5819','2013-08-03','17:45:00',1.06),('5819','2013-08-03','17:50:00',1.04),('5819','2013-08-02','07:35:00',1.03),('5819','2013-08-02','07:40:00',1.1),('5819','2013-08-02','07:45:00',1.18),('5819','2013-08-02','07:50:00',1.26),('5819','2013-08-02','07:55:00',1.34),('5819','2013-08-02','08:00:00',1.44),('5819','2013-08-02','08:05:00',1.51),('5819','2013-08-02','08:10:00',1.59),('5819','2013-08-02','08:15:00',1.66),('5819','2013-08-02','08:20:00',1.74),('5819','2013-08-02','08:25:00',1.81),('5819','2013-08-02','08:30:00',1.89),('5819','2013-08-02','08:35:00',1.96),('5819','2013-08-02','08:40:00',2.03),('5819','2013-08-02','08:45:00',2.1),('5819','2013-08-02','08:50:00',2.15),('5819','2013-08-02','08:55:00',2.22),('5819','2013-08-02','09:00:00',2.29),('5819','2013-08-02','09:05:00',2.35),('5819','2013-08-02','09:10:00',2.42),('5819','2013-08-02','09:15:00',2.48),('5819','2013-08-02','09:20:00',2.55),('5819','2013-08-02','09:25:00',2.59),('5819','2013-08-02','09:30:00',2.64),('5819','2013-08-02','09:35:00',2.7),('5819','2013-08-02','09:40:00',2.75),('5819','2013-08-02','09:45:00',2.79),('5819','2013-08-02','09:50:00',2.84),('5819','2013-08-02','09:55:00',2.87),('5819','2013-08-02','10:00:00',2.91),('5819','2013-08-02','10:05:00',2.97),('5819','2013-08-02','10:10:00',3.01),('5819','2013-08-02','10:15:00',3.04),('5819','2013-08-02','10:20:00',3.07),('5819','2013-08-02','10:25:00',3.12),('5819','2013-08-02','10:30:00',3.17),('5819','2013-08-02','10:35:00',3.2),('5819','2013-08-02','10:40:00',3.23),('5819','2013-08-02','10:45:00',3.26),('5819','2013-08-02','10:50:00',3.3),('5819','2013-08-02','10:55:00',3.32),('5819','2013-08-02','11:00:00',3.33),('5819','2013-08-02','11:05:00',3.36),('5819','2013-08-02','11:10:00',3.38),('5819','2013-08-02','11:15:00',3.4),('5819','2013-08-02','11:20:00',3.44),('5819','2013-08-02','11:25:00',3.48),('5819','2013-08-02','11:30:00',3.5),('5819','2013-08-02','11:35:00',3.5),('5819','2013-08-02','11:40:00',3.49),('5819','2013-08-02','11:45:00',3.54),('5819','2013-08-02','11:50:00',3.55),('5819','2013-08-02','11:55:00',3.59),('5819','2013-08-02','12:00:00',3.59),('5819','2013-08-02','12:05:00',3.58),('5819','2013-08-02','12:10:00',3.58),('5819','2013-08-02','12:15:00',3.57),('5819','2013-08-02','12:20:00',3.6),('5819','2013-08-02','12:25:00',3.57),('5819','2013-08-02','12:30:00',3.55),('5819','2013-08-02','12:35:00',3.56),('5819','2013-08-02','12:40:00',3.56),('5819','2013-08-02','12:45:00',3.56),('5819','2013-08-02','12:50:00',3.54),('5819','2013-08-02','12:55:00',3.53),('5819','2013-08-02','13:00:00',3.56),('5819','2013-08-02','13:05:00',3.58),('5819','2013-08-02','13:10:00',3.6),('5819','2013-08-02','13:15:00',3.58),('5819','2013-08-02','13:20:00',3.55),('5819','2013-08-02','13:25:00',3.52),('5819','2013-08-02','13:30:00',3.54),('5819','2013-08-02','13:35:00',3.53),('5819','2013-08-02','13:40:00',3.49),('5819','2013-08-02','13:45:00',3.46),('5819','2013-08-02','13:50:00',3.44),('5819','2013-08-02','13:55:00',3.44),('5819','2013-08-02','14:00:00',3.42),('5819','2013-08-02','14:05:00',3.39),('5819','2013-08-02','14:10:00',3.37),('5819','2013-08-02','14:15:00',3.34),('5819','2013-08-02','14:20:00',3.27),('5819','2013-08-02','14:25:00',3.22),('5819','2013-08-02','14:30:00',3.27),('5819','2013-08-02','14:35:00',3.27),('5819','2013-08-02','14:40:00',3.23),('5819','2013-08-02','14:45:00',3.24),('5819','2013-08-02','14:50:00',3.21),('5819','2013-08-02','14:55:00',3.19),('5819','2013-08-02','15:00:00',3.17),('5819','2013-08-02','15:05:00',3.13),('5819','2013-08-02','15:10:00',3.05),('5819','2013-08-02','15:15:00',2.97),('5819','2013-08-02','15:20:00',2.97),('5819','2013-08-02','15:25:00',2.95),('5819','2013-08-02','15:30:00',2.92),('5819','2013-08-02','15:35:00',2.87),('5819','2013-08-02','15:40:00',2.83),('5819','2013-08-02','15:45:00',2.79),('5819','2013-08-02','15:50:00',2.74),('5819','2013-08-02','15:55:00',2.64),('5819','2013-08-02','16:00:00',2.6),('5819','2013-08-02','16:05:00',2.56),('5819','2013-08-02','16:10:00',2.51),('5819','2013-08-02','16:15:00',2.43),('5819','2013-08-02','16:20:00',2.36),('5819','2013-08-02','16:25:00',2.29),('5819','2013-08-02','16:30:00',2.24),('5819','2013-08-02','16:35:00',2.18),('5819','2013-08-02','16:40:00',2.12),('5819','2013-08-02','16:45:00',2.06),('5819','2013-08-02','16:50:00',2),('5819','2013-08-02','16:55:00',1.92),('5819','2013-08-02','17:00:00',1.84),('5819','2013-08-02','17:05:00',1.74),('5819','2013-08-02','17:10:00',1.68),('5819','2013-08-02','17:15:00',1.62),('5819','2013-08-02','17:20:00',1.56),('5819','2013-08-02','17:25:00',1.49),('5819','2013-08-02','17:30:00',1.41),('5819','2013-08-02','17:35:00',1.33),('5819','2013-08-02','17:40:00',1.24),('5819','2013-08-02','17:45:00',1.1),('5819','2013-08-02','17:50:00',1.06),('5819','2013-08-01','07:35:00',1.03),('5819','2013-08-01','07:40:00',1.11),('5819','2013-08-01','07:45:00',1.19),('5819','2013-08-01','07:50:00',1.26),('5819','2013-08-01','07:55:00',1.35),('5819','2013-08-01','08:00:00',1.42),('5819','2013-08-01','08:05:00',1.51),('5819','2013-08-01','08:10:00',1.58),('5819','2013-08-01','08:15:00',1.66),('5819','2013-08-01','08:20:00',1.75),('5819','2013-08-01','08:25:00',1.84),('5819','2013-08-01','08:30:00',1.92),('5819','2013-08-01','08:35:00',1.99),('5819','2013-08-01','08:40:00',2.07),('5819','2013-08-01','08:45:00',2.15),('5819','2013-08-01','08:50:00',2.21),('5819','2013-08-01','08:55:00',2.28),('5819','2013-08-01','09:00:00',2.34),('5819','2013-08-01','09:05:00',2.41),('5819','2013-08-01','09:10:00',2.5),('5819','2013-08-01','09:15:00',2.56),('5819','2013-08-01','09:20:00',2.62),('5819','2013-08-01','09:25:00',2.68),('5819','2013-08-01','09:30:00',2.73),('5819','2013-08-01','09:35:00',2.79),('5819','2013-08-01','09:40:00',2.86),('5819','2013-08-01','09:45:00',2.92),('5819','2013-08-01','09:50:00',2.96),('5819','2013-08-01','09:55:00',3.01),('5819','2013-08-01','10:00:00',3.07),('5819','2013-08-01','10:05:00',3.12),('5819','2013-08-01','10:10:00',3.17),('5819','2013-08-01','10:15:00',3.2),('5819','2013-08-01','10:20:00',3.24),('5819','2013-08-01','10:25:00',3.28),('5819','2013-08-01','10:30:00',3.32),('5819','2013-08-01','10:35:00',3.34),('5819','2013-08-01','10:40:00',3.37),('5819','2013-08-01','10:45:00',3.42),('5819','2013-08-01','10:50:00',3.47),('5819','2013-08-01','10:55:00',3.49),('5819','2013-08-01','11:00:00',3.51),('5819','2013-08-01','11:05:00',3.54),('5819','2013-08-01','11:10:00',3.6),('5819','2013-08-01','11:15:00',3.64),('5819','2013-08-01','11:20:00',3.66),('5819','2013-08-01','11:25:00',3.7),('5819','2013-08-01','11:30:00',3.71),('5819','2013-08-01','11:35:00',3.73),('5819','2013-08-01','11:40:00',3.75),('5819','2013-08-01','11:45:00',3.78),('5819','2013-08-01','11:50:00',3.77),('5819','2013-08-01','11:55:00',3.79),('5819','2013-08-01','12:00:00',3.8),('5819','2013-08-01','12:05:00',3.81),('5819','2013-08-01','12:10:00',3.8),('5819','2013-08-01','12:15:00',3.84),('5819','2013-08-01','12:20:00',3.82),('5819','2013-08-01','12:25:00',3.8),('5819','2013-08-01','12:30:00',3.8),('5819','2013-08-01','12:35:00',3.81),('5819','2013-08-01','12:40:00',3.83),('5819','2013-08-01','12:45:00',3.8),('5819','2013-08-01','12:50:00',3.83),('5819','2013-08-01','12:55:00',3.81),('5819','2013-08-01','13:00:00',3.8),('5819','2013-08-01','13:05:00',3.77),('5819','2013-08-01','13:10:00',3.76),('5819','2013-08-01','13:15:00',3.63),('5819','2013-08-01','13:20:00',3.77),('5819','2013-08-01','13:25:00',3.78),('5819','2013-08-01','13:30:00',3.54),('5819','2013-08-01','13:35:00',3.7),('5819','2013-08-01','13:40:00',3.7),('5819','2013-08-01','13:45:00',3.66),('5819','2013-08-01','13:50:00',3.56),('5819','2013-08-01','13:55:00',3.6),('5819','2013-08-01','14:00:00',3.43),('5819','2013-08-01','14:05:00',3.61),('5819','2013-08-01','14:10:00',3.48),('5819','2013-08-01','14:15:00',3.49),('5819','2013-08-01','14:20:00',3.37),('5819','2013-08-01','14:25:00',3.43),('5819','2013-08-01','14:30:00',3.4),('5819','2013-08-01','14:35:00',2.77),('5819','2013-08-01','14:40:00',3.24),('5819','2013-08-01','14:45:00',2.81),('5819','2013-08-01','14:50:00',2.86),('5819','2013-08-01','14:55:00',3.27),('5819','2013-08-01','15:00:00',3.21),('5819','2013-08-01','15:05:00',3.2),('5819','2013-08-01','15:10:00',2.7),('5819','2013-08-01','15:15:00',2.92),('5819','2013-08-01','15:20:00',3.16),('5819','2013-08-01','15:25:00',3.07),('5819','2013-08-01','15:30:00',3),('5819','2013-08-01','15:35:00',2.65),('5819','2013-08-01','15:40:00',2.03),('5819','2013-08-01','15:45:00',2.87),('5819','2013-08-01','15:50:00',2.8),('5819','2013-08-01','15:55:00',2.77),('5819','2013-08-01','16:00:00',2.72),('5819','2013-08-01','16:05:00',2.64),('5819','2013-08-01','16:10:00',2.56),('5819','2013-08-01','16:15:00',2.49),('5819','2013-08-01','16:20:00',2.44),('5819','2013-08-01','16:25:00',2.37),('5819','2013-08-01','16:30:00',2.3),('5819','2013-08-01','16:35:00',2.24),('5819','2013-08-01','16:40:00',2.17),('5819','2013-08-01','16:45:00',2.09),('5819','2013-08-01','16:50:00',2.02),('5819','2013-08-01','16:55:00',1.96),('5819','2013-08-01','17:00:00',1.88),('5819','2013-08-01','17:05:00',1.81),('5819','2013-08-01','17:10:00',1.74),('5819','2013-08-01','17:15:00',1.66),('5819','2013-08-01','17:20:00',1.59),('5819','2013-08-01','17:25:00',1.5),('5819','2013-08-01','17:30:00',1.43),('5819','2013-08-01','17:35:00',1.36),('5819','2013-08-01','17:40:00',1.27),('5819','2013-08-01','17:45:00',1.1),('5819','2013-08-01','17:50:00',1.09),('5819','2013-07-31','07:35:00',1.07),('5819','2013-07-31','07:40:00',1.15),('5819','2013-07-31','07:45:00',1.23),('5819','2013-07-31','07:50:00',1.31),('5819','2013-07-31','07:55:00',1.4),('5819','2013-07-31','08:00:00',1.48),('5819','2013-07-31','08:05:00',1.56),('5819','2013-07-31','08:10:00',1.65),('5819','2013-07-31','08:15:00',1.73),('5819','2013-07-31','08:20:00',1.81),('5819','2013-07-31','08:25:00',1.88),('5819','2013-07-31','08:30:00',1.96),('5819','2013-07-31','08:35:00',2.04),('5819','2013-07-31','08:40:00',2.11),('5819','2013-07-31','08:45:00',2.2),('5819','2013-07-31','08:50:00',2.26),('5819','2013-07-31','08:55:00',2.33),('5819','2013-07-31','09:00:00',2.4),('5819','2013-07-31','09:05:00',2.47),('5819','2013-07-31','09:10:00',2.55),('5819','2013-07-31','09:15:00',2.59),('5819','2013-07-31','09:20:00',2.66),('5819','2013-07-31','09:25:00',2.7),('5819','2013-07-31','09:30:00',2.78),('5819','2013-07-31','09:35:00',2.83),('5819','2013-07-31','09:40:00',2.87),('5819','2013-07-31','09:45:00',2.93),('5819','2013-07-31','09:50:00',2.98),('5819','2013-07-31','09:55:00',3.04),('5819','2013-07-31','10:00:00',3.07),('5819','2013-07-31','10:05:00',3.12),('5819','2013-07-31','10:10:00',3.17),('5819','2013-07-31','10:15:00',3.24),('5819','2013-07-31','10:20:00',3.27),('5819','2013-07-31','10:25:00',3.26),('5819','2013-07-31','10:30:00',3.3),('5819','2013-07-31','10:35:00',3.37),('5819','2013-07-31','10:40:00',3.42),('5819','2013-07-31','10:45:00',3.47),('5819','2013-07-31','10:50:00',3.51),('5819','2013-07-31','10:55:00',3.54),('5819','2013-07-31','11:00:00',3.59),('5819','2013-07-31','11:05:00',3.61),('5819','2013-07-31','11:10:00',3.65),('5819','2013-07-31','11:15:00',3.66),('5819','2013-07-31','11:20:00',3.69),('5819','2013-07-31','11:25:00',3.71),('5819','2013-07-31','11:30:00',3.71),('5819','2013-07-31','11:35:00',3.74),('5819','2013-07-31','11:40:00',3.77),('5819','2013-07-31','11:45:00',3.8),('5819','2013-07-31','11:50:00',3.83),('5819','2013-07-31','11:55:00',3.85),('5819','2013-07-31','12:00:00',3.84),('5819','2013-07-31','12:05:00',3.83),('5819','2013-07-31','12:10:00',3.8),('5819','2013-07-31','12:15:00',3.83),('5819','2013-07-31','12:20:00',3.85),('5819','2013-07-31','12:25:00',3.89),('5819','2013-07-31','12:30:00',3.87),('5819','2013-07-31','12:35:00',3.85),('5819','2013-07-31','12:40:00',3.9),('5819','2013-07-31','12:45:00',2.88),('5819','2013-07-31','12:50:00',2.92),('5819','2013-07-31','12:55:00',4.04),('5819','2013-07-31','13:00:00',1.73),('5819','2013-07-31','13:05:00',4.05),('5819','2013-07-31','13:10:00',3.77),('5819','2013-07-31','13:15:00',3.88),('5819','2013-07-31','13:20:00',3.56),('5819','2013-07-31','13:25:00',3.73),('5819','2013-07-31','13:30:00',3.78),('5819','2013-07-31','13:35:00',3.75),('5819','2013-07-31','13:40:00',3.83),('5819','2013-07-31','13:45:00',3.88),('5819','2013-07-31','13:50:00',3.31),('5819','2013-07-31','13:55:00',1.96),('5819','2013-07-31','14:00:00',3.29),('5819','2013-07-31','14:05:00',3.75),('5819','2013-07-31','14:10:00',3.04),('5819','2013-07-31','14:15:00',3.45),('5819','2013-07-31','14:20:00',3.71),('5819','2013-07-31','14:25:00',3.62),('5819','2013-07-31','14:30:00',3.51),('5819','2013-07-31','14:35:00',3.46),('5819','2013-07-31','14:40:00',3.47),('5819','2013-07-31','14:45:00',3.45),('5819','2013-07-31','14:50:00',2.75),('5819','2013-07-31','14:55:00',1.18),('5819','2013-07-31','15:00:00',1.8),('5819','2013-07-31','15:05:00',3.27),('5819','2013-07-31','15:10:00',2.4),('5819','2013-07-31','15:15:00',1.78),('5819','2013-07-31','15:20:00',3.01),('5819','2013-07-31','15:25:00',2.81),('5819','2013-07-31','15:30:00',3.13),('5819','2013-07-31','15:35:00',2.66),('5819','2013-07-31','15:40:00',2.95),('5819','2013-07-31','15:45:00',2.86),('5819','2013-07-31','15:50:00',2.8),('5819','2013-07-31','15:55:00',2.71),('5819','2013-07-31','16:00:00',2.65),('5819','2013-07-31','16:05:00',2.64),('5819','2013-07-31','16:10:00',2.62),('5819','2013-07-31','16:15:00',2.57),('5819','2013-07-31','16:20:00',2.39),('5819','2013-07-31','16:25:00',2.39),('5819','2013-07-31','16:30:00',1.44),('5819','2013-07-31','16:35:00',1.36),('5819','2013-07-31','16:40:00',2.17),('5819','2013-07-31','16:45:00',2.1),('5819','2013-07-31','16:50:00',2.05),('5819','2013-07-31','16:55:00',1.97),('5819','2013-07-31','17:00:00',1.66),('5819','2013-07-31','17:05:00',1.83),('5819','2013-07-31','17:10:00',1.7),('5819','2013-07-31','17:15:00',1.19),('5819','2013-07-31','17:20:00',1.58),('5819','2013-07-31','17:25:00',1.53),('5819','2013-07-31','17:30:00',1.42),('5819','2013-07-31','17:35:00',1.34),('5819','2013-07-31','17:40:00',1.27),('5819','2013-07-31','17:45:00',1.14),('5819','2013-07-31','17:50:00',1.09),('5819','2013-07-30','07:55:00',1.25),('5819','2013-07-30','08:00:00',1.37),('5819','2013-07-30','08:05:00',1.46),('5819','2013-07-30','08:10:00',1.54),('5819','2013-07-30','08:15:00',1.6),('5819','2013-07-30','08:20:00',1.77),('5819','2013-07-30','08:25:00',1.86),('5819','2013-07-30','08:30:00',1.85),('5819','2013-07-30','08:35:00',1.97),('5819','2013-07-30','08:40:00',2.03),('5819','2013-07-30','08:45:00',2.09),('5819','2013-07-30','08:50:00',2.17),('5819','2013-07-30','08:55:00',2.29),('5819','2013-07-30','09:00:00',2.36),('5819','2013-07-30','09:05:00',2.41),('5819','2013-07-30','09:10:00',2.42),('5819','2013-07-30','09:15:00',2.56),('5819','2013-07-30','09:20:00',2.71),('5819','2013-07-30','09:25:00',2.78),('5819','2013-07-30','09:30:00',2.86),('5819','2013-07-30','09:35:00',2.93),('5819','2013-07-30','09:40:00',3.05),('5819','2013-07-30','09:45:00',3.06),('5819','2013-07-30','09:50:00',3.05),('5819','2013-07-30','09:55:00',3.07),('5819','2013-07-30','10:00:00',3.03),('5819','2013-07-30','10:05:00',3.15),('5819','2013-07-30','10:10:00',3.21),('5819','2013-07-30','10:15:00',2.7),('5819','2013-07-30','10:20:00',2.89),('5819','2013-07-30','10:25:00',3.32),('5819','2013-07-30','10:30:00',3.34),('5819','2013-07-30','10:35:00',3.39),('5819','2013-07-30','10:40:00',3.36),('5819','2013-07-30','10:45:00',3.41),('5819','2013-07-30','10:50:00',3.39),('5819','2013-07-30','10:55:00',3.41),('5819','2013-07-30','11:00:00',3.45),('5819','2013-07-30','11:05:00',3.53),('5819','2013-07-30','11:10:00',3.59),('5819','2013-07-30','11:15:00',3.63),('5819','2013-07-30','11:20:00',3.51),('5819','2013-07-30','11:25:00',3.5),('5819','2013-07-30','11:30:00',3.41),('5819','2013-07-30','11:35:00',1.99),('5819','2013-07-30','11:40:00',3.24),('5819','2013-07-30','11:45:00',3.69),('5819','2013-07-30','11:50:00',3.73),('5819','2013-07-30','11:55:00',3.71),('5819','2013-07-30','12:00:00',3.73),('5819','2013-07-30','12:05:00',3.69),('5819','2013-07-30','12:10:00',3.71),('5819','2013-07-30','12:15:00',3.68),('5819','2013-07-30','12:20:00',3.66),('5819','2013-07-30','12:25:00',3.65),('5819','2013-07-30','12:30:00',3.65),('5819','2013-07-30','12:35:00',3.8),('5819','2013-07-30','12:40:00',3.7),('5819','2013-07-30','12:45:00',2.99),('5819','2013-07-30','12:50:00',3.9),('5819','2013-07-30','12:55:00',3.96),('5819','2013-07-30','13:00:00',2.28),('5819','2013-07-30','13:05:00',2.21),('5819','2013-07-30','13:10:00',4),('5819','2013-07-30','13:15:00',3.91),('5819','2013-07-30','13:20:00',2.77),('5819','2013-07-30','13:25:00',2.05),('5819','2013-07-30','13:30:00',3.35),('5819','2013-07-30','13:35:00',3.94),('5819','2013-07-30','13:40:00',3.79),('5819','2013-07-30','13:45:00',3.79),('5819','2013-07-30','13:50:00',3.89),('5819','2013-07-30','13:55:00',3.88),('5819','2013-07-30','14:00:00',3.54),('5819','2013-07-30','14:05:00',3.84),('5819','2013-07-30','14:10:00',3.83),('5819','2013-07-30','14:15:00',3.58),('5819','2013-07-30','14:20:00',3.51),('5819','2013-07-30','14:25:00',3.53),('5819','2013-07-30','14:30:00',2.64),('5819','2013-07-30','14:35:00',3.32),('5819','2013-07-30','14:40:00',3.36),('5819','2013-07-30','14:45:00',3.34),('5819','2013-07-30','14:50:00',3.35),('5819','2013-07-30','14:55:00',3.32),('5819','2013-07-30','15:00:00',3.23),('5819','2013-07-30','15:05:00',3.16),('5819','2013-07-30','15:10:00',2.99),('5819','2013-07-30','15:15:00',3.06),('5819','2013-07-30','15:20:00',3.05),('5819','2013-07-30','15:25:00',2.96),('5819','2013-07-30','15:30:00',2.9),('5819','2013-07-30','15:35:00',2.87),('5819','2013-07-30','15:40:00',2.83),('5819','2013-07-30','15:45:00',2.76),('5819','2013-07-30','15:50:00',2.72),('5819','2013-07-30','15:55:00',2.66),('5819','2013-07-30','16:00:00',2.62),('5819','2013-07-30','16:05:00',2.56),('5819','2013-07-30','16:10:00',2.48),('5819','2013-07-30','16:15:00',2.43),('5819','2013-07-30','16:20:00',2.39),('5819','2013-07-30','16:25:00',2.32),('5819','2013-07-30','16:30:00',2.24),('5819','2013-07-30','16:35:00',2.19),('5819','2013-07-30','16:40:00',2.14),('5819','2013-07-30','16:45:00',2.07),('5819','2013-07-30','16:50:00',1.98),('5819','2013-07-30','16:55:00',1.92),('5819','2013-07-30','17:00:00',1.86),('5819','2013-07-30','17:05:00',1.79),('5819','2013-07-30','17:10:00',1.7),('5819','2013-07-30','17:15:00',1.64),('5819','2013-07-30','17:20:00',1.58),('5819','2013-07-30','17:25:00',1.51),('5819','2013-07-30','17:30:00',1.43),('5819','2013-07-30','17:35:00',1.36),('5819','2013-07-30','17:40:00',1.28),('5819','2013-07-30','17:45:00',1.12),('5819','2013-07-30','17:50:00',1.07),('5819','2013-07-29','07:45:00',1.02),('5819','2013-07-29','07:50:00',1.1),('5819','2013-07-29','07:55:00',1.18),('5819','2013-07-29','08:00:00',1.26),('5819','2013-07-29','08:05:00',1.32),('5819','2013-07-29','08:10:00',1.37),('5819','2013-07-29','08:15:00',1.44),('5819','2013-07-29','08:20:00',1.53),('5819','2013-07-29','08:25:00',1.61),('5819','2013-07-29','08:30:00',1.68),('5819','2013-07-29','08:35:00',1.75),('5819','2013-07-29','08:40:00',1.83),('5819','2013-07-29','08:45:00',1.88),('5819','2013-07-29','08:50:00',1.97),('5819','2013-07-29','08:55:00',2.04),('5819','2013-07-29','09:00:00',2.09),('5819','2013-07-29','09:05:00',2.19),('5819','2013-07-29','09:10:00',2.25),('5819','2013-07-29','09:15:00',2.3),('5819','2013-07-29','09:20:00',2.36),('5819','2013-07-29','09:25:00',2.41),('5819','2013-07-29','09:30:00',2.46),('5819','2013-07-29','09:35:00',2.54),('5819','2013-07-29','09:40:00',2.64),('5819','2013-07-29','09:45:00',2.7),('5819','2013-07-29','09:50:00',2.73),('5819','2013-07-29','09:55:00',2.79),('5819','2013-07-29','10:00:00',2.86),('5819','2013-07-29','10:05:00',2.91),('5819','2013-07-29','10:10:00',2.96),('5819','2013-07-29','10:15:00',2.99),('5819','2013-07-29','10:20:00',3.05),('5819','2013-07-29','10:25:00',3.1),('5819','2013-07-29','10:30:00',3.12),('5819','2013-07-29','10:35:00',3.19),('5819','2013-07-29','10:40:00',3.24),('5819','2013-07-29','10:45:00',3.24),('5819','2013-07-29','10:50:00',3.25),('5819','2013-07-29','10:55:00',3.26),('5819','2013-07-29','11:00:00',3.33),('5819','2013-07-29','11:05:00',3.32),('5819','2013-07-29','11:10:00',3.27),('5819','2013-07-29','11:15:00',3.28),('5819','2013-07-29','11:20:00',3.31),('5819','2013-07-29','11:25:00',3.34),('5819','2013-07-29','11:30:00',3.38),('5819','2013-07-29','11:35:00',3.37),('5819','2013-07-29','11:40:00',3.39),('5819','2013-07-29','11:45:00',3.4),('5819','2013-07-29','11:50:00',3.41),('5819','2013-07-29','11:55:00',3.43),('5819','2013-07-29','12:00:00',3.47),('5819','2013-07-29','12:05:00',3.44),('5819','2013-07-29','12:10:00',3.44),('5819','2013-07-29','12:15:00',3.46),('5819','2013-07-29','12:20:00',3.49),('5819','2013-07-29','12:25:00',3.51),('5819','2013-07-29','12:30:00',3.51),('5819','2013-07-29','12:35:00',3.52),('5819','2013-07-29','12:40:00',3.53),('5819','2013-07-29','12:45:00',3.52),('5819','2013-07-29','12:50:00',3.52),('5819','2013-07-29','12:55:00',3.49),('5819','2013-07-29','13:00:00',3.43),('5819','2013-07-29','13:05:00',3.53),('5819','2013-07-29','13:10:00',3.51),('5819','2013-07-29','13:15:00',3.5),('5819','2013-07-29','13:20:00',3.57),('5819','2013-07-29','13:25:00',3.56),('5819','2013-07-29','13:30:00',3.54),('5819','2013-07-29','13:35:00',3.54),('5819','2013-07-29','13:40:00',3.56),('5819','2013-07-29','13:45:00',3.57),('5819','2013-07-29','13:50:00',3.53),('5819','2013-07-29','13:55:00',3.51),('5819','2013-07-29','14:00:00',3.51),('5819','2013-07-29','14:05:00',3.48),('5819','2013-07-29','14:10:00',3.46),('5819','2013-07-29','14:15:00',3.43),('5819','2013-07-29','14:20:00',3.41),('5819','2013-07-29','14:25:00',3.38),('5819','2013-07-29','14:30:00',3.33),('5819','2013-07-29','14:35:00',3.3),('5819','2013-07-29','14:40:00',3.27),('5819','2013-07-29','14:45:00',3.25),('5819','2013-07-29','14:50:00',3.22),('5819','2013-07-29','14:55:00',3.17),('5819','2013-07-29','15:00:00',3.14),('5819','2013-07-29','15:05:00',3.1),('5819','2013-07-29','15:10:00',3.06),('5819','2013-07-29','15:15:00',3.03),('5819','2013-07-29','15:20:00',2.98),('5819','2013-07-29','15:25:00',2.93),('5819','2013-07-29','15:30:00',2.88),('5819','2013-07-29','15:35:00',2.85),('5819','2013-07-29','15:40:00',2.86),('5819','2013-07-29','15:45:00',2.84),('5819','2013-07-29','15:50:00',2.5),('5819','2013-07-29','15:55:00',1.66),('5819','2013-07-29','16:00:00',1.43),('5819','2013-07-29','16:05:00',2.12),('5819','2013-07-29','16:10:00',2.44),('5819','2013-07-29','16:15:00',2.35),('5819','2013-07-29','16:20:00',2.09),('5819','2013-07-29','16:25:00',1.9),('5819','2013-07-29','16:30:00',2.43),('5819','2013-07-29','16:35:00',2.29),('5819','2013-07-29','16:40:00',1.78),('5819','2013-07-29','16:45:00',2.29),('5819','2013-07-29','16:50:00',2.14),('5819','2013-07-29','16:55:00',1.38),('5819','2013-07-29','17:00:00',1.08),('5819','2013-07-29','17:05:00',1.35),('5819','2013-07-29','17:10:00',1.23),('5819','2013-07-29','17:20:00',1.56),('5819','2013-07-29','17:25:00',1.51),('5819','2013-07-29','17:45:00',1.26),('5819','2013-07-29','17:50:00',1.16),('5819','2013-07-28','07:45:00',1.03),('5819','2013-07-28','07:50:00',1.09),('5819','2013-07-28','07:55:00',1.17),('5819','2013-07-28','08:00:00',1.25),('5819','2013-07-28','08:05:00',1.35),('5819','2013-07-28','08:10:00',1.43),('5819','2013-07-28','08:15:00',1.51),('5819','2013-07-28','08:20:00',1.58),('5819','2013-07-28','08:25:00',1.67),('5819','2013-07-28','08:30:00',1.75),('5819','2013-07-28','08:35:00',1.84),('5819','2013-07-28','08:40:00',1.91),('5819','2013-07-28','08:45:00',1.97),('5819','2013-07-28','08:50:00',2.03),('5819','2013-07-28','08:55:00',2.1),('5819','2013-07-28','09:00:00',2.15),('5819','2013-07-28','09:05:00',2.24),('5819','2013-07-28','09:10:00',2.3),('5819','2013-07-28','09:15:00',2.37),('5819','2013-07-28','09:20:00',2.42),('5819','2013-07-28','09:25:00',2.46),('5819','2013-07-28','09:30:00',2.54),('5819','2013-07-28','09:35:00',2.59),('5819','2013-07-28','09:40:00',2.66),('5819','2013-07-28','09:45:00',2.7),('5819','2013-07-28','09:50:00',2.75),('5819','2013-07-28','09:55:00',2.79),('5819','2013-07-28','10:00:00',2.84),('5819','2013-07-28','10:05:00',2.87),('5819','2013-07-28','10:10:00',2.91),('5819','2013-07-28','10:15:00',2.95),('5819','2013-07-28','10:20:00',2.99),('5819','2013-07-28','10:25:00',3.02),('5819','2013-07-28','10:30:00',3.06),('5819','2013-07-28','10:35:00',3.06),('5819','2013-07-28','10:40:00',3.14),('5819','2013-07-28','10:45:00',3.16),('5819','2013-07-28','10:50:00',3.19),('5819','2013-07-28','10:55:00',3.21),('5819','2013-07-28','11:00:00',3.21),('5819','2013-07-28','11:05:00',3.25),('5819','2013-07-28','11:10:00',3.31),('5819','2013-07-28','11:15:00',3.34),('5819','2013-07-28','11:20:00',3.38),('5819','2013-07-28','11:25:00',3.42),('5819','2013-07-28','11:30:00',3.41),('5819','2013-07-28','11:35:00',3.42),('5819','2013-07-28','11:40:00',3.4),('5819','2013-07-28','11:45:00',3.38),('5819','2013-07-28','11:50:00',3.39),('5819','2013-07-28','11:55:00',3.42),('5819','2013-07-28','12:00:00',3.49),('5819','2013-07-28','12:05:00',3.5),('5819','2013-07-28','12:10:00',3.45),('5819','2013-07-28','12:15:00',3.49),('5819','2013-07-28','12:20:00',3.41),('5819','2013-07-28','12:25:00',3.45),('5819','2013-07-28','12:30:00',3.47),('5819','2013-07-28','12:35:00',3.58),('5819','2013-07-28','12:40:00',3.57),('5819','2013-07-28','12:45:00',3.54),('5819','2013-07-28','12:50:00',3.54),('5819','2013-07-28','12:55:00',3.51),('5819','2013-07-28','13:00:00',3.53),('5819','2013-07-28','13:05:00',3.48),('5819','2013-07-28','13:10:00',3.32),('5819','2013-07-28','13:15:00',3.59),('5819','2013-07-28','13:20:00',3.54),('5819','2013-07-28','13:25:00',3.54),('5819','2013-07-28','13:30:00',3.48),('5819','2013-07-28','13:35:00',3.52),('5819','2013-07-28','13:40:00',3.51),('5819','2013-07-28','13:45:00',3.46),('5819','2013-07-28','13:50:00',3.56),('5819','2013-07-28','13:55:00',3.51),('5819','2013-07-28','14:00:00',3.46),('5819','2013-07-28','14:05:00',3.45),('5819','2013-07-28','14:10:00',3.42),('5819','2013-07-28','14:15:00',3.39),('5819','2013-07-28','14:20:00',3.36),('5819','2013-07-28','14:25:00',3.31),('5819','2013-07-28','14:30:00',3.3),('5819','2013-07-28','14:35:00',3.24),('5819','2013-07-28','14:40:00',3.27),('5819','2013-07-28','14:45:00',3.22),('5819','2013-07-28','14:50:00',3.19),('5819','2013-07-28','14:55:00',3.14),('5819','2013-07-28','15:00:00',3.1),('5819','2013-07-28','15:05:00',3.04),('5819','2013-07-28','15:10:00',2.99),('5819','2013-07-28','15:15:00',3),('5819','2013-07-28','15:20:00',2.96),('5819','2013-07-28','15:25:00',2.89),('5819','2013-07-28','15:30:00',2.87),('5819','2013-07-28','15:35:00',2.83),('5819','2013-07-28','15:40:00',2.75),('5819','2013-07-28','15:45:00',2.73),('5819','2013-07-28','15:50:00',2.67),('5819','2013-07-28','15:55:00',2.64),('5819','2013-07-28','16:00:00',2.61),('5819','2013-07-28','16:05:00',2.56),('5819','2013-07-28','16:10:00',2.52),('5819','2013-07-28','16:15:00',2.46),('5819','2013-07-28','16:20:00',2.4),('5819','2013-07-28','16:25:00',2.35),('5819','2013-07-28','16:30:00',2.28),('5819','2013-07-28','16:35:00',2.22),('5819','2013-07-28','16:40:00',2.16),('5819','2013-07-28','16:45:00',2.08),('5819','2013-07-28','16:50:00',2.01),('5819','2013-07-28','16:55:00',1.95),('5819','2013-07-28','17:00:00',1.88),('5819','2013-07-28','17:05:00',1.81),('5819','2013-07-28','17:10:00',1.74),('5819','2013-07-28','17:15:00',1.67),('5819','2013-07-28','17:20:00',1.6),('5819','2013-07-28','17:25:00',1.53),('5819','2013-07-28','17:30:00',1.45),('5819','2013-07-28','17:35:00',1.38),('5819','2013-07-28','17:40:00',1.31),('5819','2013-07-28','17:45:00',1.15),('5819','2013-07-28','17:50:00',1.1),('5819','2013-07-27','07:45:00',1.04),('5819','2013-07-27','07:50:00',1.12),('5819','2013-07-27','07:55:00',1.2),('5819','2013-07-27','08:00:00',1.28),('5819','2013-07-27','08:05:00',1.36),('5819','2013-07-27','08:10:00',1.45),('5819','2013-07-27','08:15:00',1.55),('5819','2013-07-27','08:20:00',1.63),('5819','2013-07-27','08:25:00',1.7),('5819','2013-07-27','08:30:00',1.78),('5819','2013-07-27','08:35:00',1.86),('5819','2013-07-27','08:40:00',1.93),('5819','2013-07-27','08:45:00',1.99),('5819','2013-07-27','08:50:00',2.06),('5819','2013-07-27','08:55:00',2.13),('5819','2013-07-27','09:00:00',2.19),('5819','2013-07-27','09:05:00',2.27),('5819','2013-07-27','09:10:00',2.33),('5819','2013-07-27','09:15:00',2.4),('5819','2013-07-27','09:20:00',2.49),('5819','2013-07-27','09:25:00',2.57),('5819','2013-07-27','09:30:00',2.57),('5819','2013-07-27','09:35:00',2.62),('5819','2013-07-27','09:40:00',2.69),('5819','2013-07-27','09:45:00',2.76),('5819','2013-07-27','09:50:00',2.79),('5819','2013-07-27','09:55:00',2.84),('5819','2013-07-27','10:00:00',2.9),('5819','2013-07-27','10:05:00',2.95),('5819','2013-07-27','10:10:00',3),('5819','2013-07-27','10:15:00',3.04),('5819','2013-07-27','10:20:00',3.09),('5819','2013-07-27','10:25:00',3.13),('5819','2013-07-27','10:30:00',3.16),('5819','2013-07-27','10:35:00',3.17),('5819','2013-07-27','10:40:00',3.19),('5819','2013-07-27','10:45:00',3.24),('5819','2013-07-27','10:50:00',3.25),('5819','2013-07-27','10:55:00',3.29),('5819','2013-07-27','11:00:00',3.31),('5819','2013-07-27','11:05:00',3.35),('5819','2013-07-27','11:10:00',3.39),('5819','2013-07-27','11:15:00',3.39),('5819','2013-07-27','11:20:00',3.41),('5819','2013-07-27','11:25:00',3.47),('5819','2013-07-27','11:30:00',3.49),('5819','2013-07-27','11:35:00',3.52),('5819','2013-07-27','11:40:00',3.5),('5819','2013-07-27','11:45:00',3.52),('5819','2013-07-27','11:50:00',3.51),('5819','2013-07-27','11:55:00',3.53),('5819','2013-07-27','12:00:00',3.53),('5819','2013-07-27','12:05:00',3.54),('5819','2013-07-27','12:10:00',3.55),('5819','2013-07-27','12:15:00',3.54),('5819','2013-07-27','12:20:00',3.6),('5819','2013-07-27','12:25:00',3.59),('5819','2013-07-27','12:30:00',3.55),('5819','2013-07-27','12:35:00',3.61),('5819','2013-07-27','12:40:00',3.62),('5819','2013-07-27','12:45:00',3.55),('5819','2013-07-27','12:50:00',3.52),('5819','2013-07-27','12:55:00',3.56),('5819','2013-07-27','13:00:00',3.57),('5819','2013-07-27','13:05:00',3.68),('5819','2013-07-27','13:10:00',3.64),('5819','2013-07-27','13:15:00',3.64),('5819','2013-07-27','13:20:00',3.65),('5819','2013-07-27','13:25:00',3.68),('5819','2013-07-27','13:30:00',3.73),('5819','2013-07-27','13:35:00',3.38),('5819','2013-07-27','13:40:00',3.32),('5819','2013-07-27','13:45:00',3.66),('5819','2013-07-27','13:50:00',3.67),('5819','2013-07-27','13:55:00',3.67),('5819','2013-07-27','14:00:00',3.5),('5819','2013-07-27','14:05:00',3.52),('5819','2013-07-27','14:10:00',2.79),('5819','2013-07-27','14:15:00',3.17),('5819','2013-07-27','14:20:00',3.49),('5819','2013-07-27','14:25:00',3.41),('5819','2013-07-27','14:30:00',3.36),('5819','2013-07-27','14:35:00',3.35),('5819','2013-07-27','14:40:00',3.32),('5819','2013-07-27','14:45:00',3.3),('5819','2013-07-27','14:50:00',3.24),('5819','2013-07-27','14:55:00',3.19),('5819','2013-07-27','15:00:00',3.13),('5819','2013-07-27','15:05:00',3.06),('5819','2013-07-27','15:10:00',3.09),('5819','2013-07-27','15:15:00',3.04),('5819','2013-07-27','15:20:00',2.99),('5819','2013-07-27','15:25:00',2.94),('5819','2013-07-27','15:30:00',2.9),('5819','2013-07-27','15:35:00',2.85),('5819','2013-07-27','15:40:00',2.81),('5819','2013-07-27','15:45:00',2.75),('5819','2013-07-27','15:50:00',2.72),('5819','2013-07-27','15:55:00',2.66),('5819','2013-07-27','16:00:00',2.62),('5819','2013-07-27','16:05:00',2.57),('5819','2013-07-27','16:10:00',2.52),('5819','2013-07-27','16:15:00',2.46),('5819','2013-07-27','16:20:00',2.4),('5819','2013-07-27','16:25:00',2.33),('5819','2013-07-27','16:30:00',2.27),('5819','2013-07-27','16:35:00',2.22),('5819','2013-07-27','16:40:00',2.15),('5819','2013-07-27','16:45:00',2.09),('5819','2013-07-27','16:50:00',2.02),('5819','2013-07-27','16:55:00',1.95),('5819','2013-07-27','17:00:00',1.89),('5819','2013-07-27','17:05:00',1.81),('5819','2013-07-27','17:10:00',1.74),('5819','2013-07-27','17:15:00',1.67),('5819','2013-07-27','17:20:00',1.6),('5819','2013-07-27','17:25:00',1.54),('5819','2013-07-27','17:30:00',1.46),('5819','2013-07-27','17:35:00',1.38),('5819','2013-07-27','17:40:00',1.31),('5819','2013-07-27','17:45:00',1.17),('5819','2013-07-27','17:50:00',1.09),('5819','2013-07-26','07:45:00',1.05),('5819','2013-07-26','07:50:00',1.13),('5819','2013-07-26','07:55:00',1.18),('5819','2013-07-26','08:00:00',1.22),('5819','2013-07-26','08:05:00',1.31),('5819','2013-07-26','08:10:00',1.4),('5819','2013-07-26','08:15:00',1.48),('5819','2013-07-26','08:20:00',1.55),('5819','2013-07-26','08:25:00',1.62),('5819','2013-07-26','08:30:00',1.72),('5819','2013-07-26','08:35:00',1.79),('5819','2013-07-26','08:40:00',1.83),('5819','2013-07-26','08:45:00',1.91),('5819','2013-07-26','08:50:00',2.01),('5819','2013-07-26','08:55:00',2.09),('5819','2013-07-26','09:00:00',2.15),('5819','2013-07-26','09:05:00',2.21),('5819','2013-07-26','09:10:00',2.29),('5819','2013-07-26','09:15:00',2.34),('5819','2013-07-26','09:20:00',2.41),('5819','2013-07-26','09:25:00',2.43),('5819','2013-07-26','09:30:00',2.47),('5819','2013-07-26','09:35:00',2.52),('5819','2013-07-26','09:40:00',2.59),('5819','2013-07-26','09:45:00',2.62),('5819','2013-07-26','09:50:00',2.1),('5819','2013-07-26','09:55:00',2.77),('5819','2013-07-26','10:00:00',2.81),('5819','2013-07-26','10:05:00',2.92),('5819','2013-07-26','10:10:00',2.87),('5819','2013-07-26','10:15:00',2.98),('5819','2013-07-26','10:20:00',3.02),('5819','2013-07-26','10:25:00',3.06),('5819','2013-07-26','10:30:00',3.11),('5819','2013-07-26','10:35:00',3.14),('5819','2013-07-26','10:40:00',3.18),('5819','2013-07-26','10:45:00',3.22),('5819','2013-07-26','10:50:00',3.25),('5819','2013-07-26','10:55:00',3.26),('5819','2013-07-26','11:00:00',3.31),('5819','2013-07-26','11:05:00',3.33),('5819','2013-07-26','11:10:00',3.34),('5819','2013-07-26','11:15:00',3.34),('5819','2013-07-26','11:20:00',2.61),('5819','2013-07-26','11:25:00',3.29),('5819','2013-07-26','11:30:00',3.34),('5819','2013-07-26','11:35:00',3.24),('5819','2013-07-26','11:40:00',3.38),('5819','2013-07-26','11:45:00',3.44),('5819','2013-07-26','11:50:00',3.52),('5819','2013-07-26','11:55:00',3.54),('5819','2013-07-26','12:00:00',3.52),('5819','2013-07-26','12:05:00',3.52),('5819','2013-07-26','12:10:00',1.29),('5819','2013-07-26','12:15:00',2.6),('5819','2013-07-26','12:20:00',1.92),('5819','2013-07-26','12:25:00',3.69),('5819','2013-07-26','12:30:00',3.62),('5819','2013-07-26','12:35:00',3.65),('5819','2013-07-26','12:40:00',3.76),('5819','2013-07-26','12:45:00',3.85),('5819','2013-07-26','12:50:00',3.84),('5819','2013-07-26','12:55:00',3.71),('5819','2013-07-26','13:00:00',2.53),('5819','2013-07-26','13:05:00',1.11),('5819','2013-07-26','13:10:00',1.21),('5819','2013-07-26','13:15:00',1.64),('5819','2013-07-26','13:20:00',2.57),('5819','2013-07-26','13:25:00',3.55),('5819','2013-07-26','13:30:00',3.99),('5819','2013-07-26','13:35:00',3.77),('5819','2013-07-26','13:40:00',3.69),('5819','2013-07-26','13:45:00',3.71),('5819','2013-07-26','13:50:00',3.66),('5819','2013-07-26','13:55:00',3.39),('5819','2013-07-26','14:00:00',3.66),('5819','2013-07-26','14:05:00',3.72),('5819','2013-07-26','14:10:00',3.57),('5819','2013-07-26','14:15:00',3.53),('5819','2013-07-26','14:20:00',3.56),('5819','2013-07-26','14:25:00',3.51),('5819','2013-07-26','14:30:00',3.43),('5819','2013-07-26','14:35:00',3.37),('5819','2013-07-26','14:40:00',3.39),('5819','2013-07-26','14:45:00',3.27),('5819','2013-07-26','14:50:00',3.28),('5819','2013-07-26','14:55:00',3.21),('5819','2013-07-26','15:00:00',3.23),('5819','2013-07-26','15:05:00',3.15),('5819','2013-07-26','15:10:00',3.14),('5819','2013-07-26','15:15:00',3.08),('5819','2013-07-26','15:20:00',3.03),('5819','2013-07-26','15:25:00',2.95),('5819','2013-07-26','15:30:00',2.92),('5819','2013-07-26','15:35:00',2.91),('5819','2013-07-26','15:40:00',2.86),('5819','2013-07-26','15:45:00',2.84),('5819','2013-07-26','15:50:00',2.79),('5819','2013-07-26','15:55:00',2.72),('5819','2013-07-26','16:00:00',2.65),('5819','2013-07-26','16:05:00',2.59),('5819','2013-07-26','16:10:00',2.52),('5819','2013-07-26','16:15:00',2.47),('5819','2013-07-26','16:20:00',2.4),('5819','2013-07-26','16:25:00',2.36),('5819','2013-07-26','16:30:00',2.31),('5819','2013-07-26','16:35:00',2.23),('5819','2013-07-26','16:40:00',2.18),('5819','2013-07-26','16:45:00',2.12),('5819','2013-07-26','16:50:00',2.04),('5819','2013-07-26','16:55:00',1.97),('5819','2013-07-26','17:00:00',1.9),('5819','2013-07-26','17:05:00',1.83),('5819','2013-07-26','17:10:00',1.76),('5819','2013-07-26','17:15:00',1.66),('5819','2013-07-26','17:20:00',1.61),('5819','2013-07-26','17:25:00',1.54),('5819','2013-07-26','17:30:00',1.44),('5819','2013-07-26','17:35:00',1.38),('5819','2013-07-26','17:40:00',1.31),('5819','2013-07-26','17:45:00',1.17),('5819','2013-07-26','17:50:00',1.05),('5819','2013-07-25','07:45:00',1.04),('5819','2013-07-25','07:50:00',1.12),('5819','2013-07-25','07:55:00',1.19),('5819','2013-07-25','08:00:00',1.28),('5819','2013-07-25','08:05:00',1.36),('5819','2013-07-25','08:10:00',1.42),('5819','2013-07-25','08:15:00',1.52),('5819','2013-07-25','08:20:00',1.58),('5819','2013-07-25','08:25:00',1.65),('5819','2013-07-25','08:30:00',1.71),('5819','2013-07-25','08:35:00',1.79),('5819','2013-07-25','08:40:00',1.91),('5819','2013-07-25','08:45:00',2),('5819','2013-07-25','08:50:00',2.06),('5819','2013-07-25','08:55:00',2.04),('5819','2013-07-25','09:00:00',2.16),('5819','2013-07-25','09:05:00',2.18),('5819','2013-07-25','09:10:00',1.99),('5819','2013-07-25','09:15:00',2.38),('5819','2013-07-25','09:20:00',2.49),('5819','2013-07-25','09:25:00',2.14),('5819','2013-07-25','09:30:00',1.61),('5819','2013-07-25','09:35:00',1.18),('5819','2013-07-25','09:40:00',1.5),('5819','2013-07-25','09:45:00',1.25),('5819','2013-07-25','09:50:00',1.69),('5819','2013-07-25','09:55:00',1.01),('5819','2013-07-25','10:00:00',1.03),('5819','2013-07-25','10:10:00',1.81),('5819','2013-07-25','10:15:00',3.24),('5819','2013-07-25','10:20:00',3.27),('5819','2013-07-25','10:25:00',3.33),('5819','2013-07-25','10:30:00',3.33),('5819','2013-07-25','10:35:00',3.13),('5819','2013-07-25','10:40:00',2.97),('5819','2013-07-25','10:45:00',2.99),('5819','2013-07-25','10:50:00',3.25),('5819','2013-07-25','10:55:00',3.47),('5819','2013-07-25','11:00:00',3.46),('5819','2013-07-25','11:05:00',2.55),('5819','2013-07-25','11:10:00',2.63),('5819','2013-07-25','11:15:00',3.56),('5819','2013-07-25','11:20:00',3.3),('5819','2013-07-25','11:25:00',3.1),('5819','2013-07-25','11:30:00',3.22),('5819','2013-07-25','11:35:00',3.55),('5819','2013-07-25','11:40:00',3.6),('5819','2013-07-25','11:45:00',3.81),('5819','2013-07-25','11:50:00',3.92),('5819','2013-07-25','11:55:00',2.87),('5819','2013-07-25','12:00:00',2.96),('5819','2013-07-25','12:05:00',3.77),('5819','2013-07-25','12:10:00',3.79),('5819','2013-07-25','12:15:00',3.25),('5819','2013-07-25','12:20:00',2.51),('5819','2013-07-25','12:25:00',3.37),('5819','2013-07-25','12:30:00',1.35),('5819','2013-07-25','12:35:00',2.05),('5819','2013-07-25','12:40:00',1.24),('5819','2013-07-25','12:45:00',1.06),('5819','2013-07-25','12:50:00',1.18),('5819','2013-07-25','12:55:00',1.87),('5819','2013-07-25','13:00:00',3.37),('5819','2013-07-25','13:05:00',2.31),('5819','2013-07-25','13:10:00',1.48),('5819','2013-07-25','13:15:00',1.56),('5819','2013-07-25','13:20:00',2.96),('5819','2013-07-25','13:25:00',3.96),('5819','2013-07-25','13:30:00',3.86),('5819','2013-07-25','13:35:00',3.62),('5819','2013-07-25','13:40:00',3.61),('5819','2013-07-25','13:45:00',3.65),('5819','2013-07-25','13:50:00',3.63),('5819','2013-07-25','13:55:00',3.61),('5819','2013-07-25','14:00:00',3.64),('5819','2013-07-25','14:05:00',3.63),('5819','2013-07-25','14:10:00',3.63),('5819','2013-07-25','14:15:00',3.59),('5819','2013-07-25','14:20:00',3.61),('5819','2013-07-25','14:25:00',3.59),('5819','2013-07-25','14:30:00',3.54),('5819','2013-07-25','14:35:00',3.49),('5819','2013-07-25','14:40:00',3.45),('5819','2013-07-25','14:45:00',3.4),('5819','2013-07-25','14:50:00',3.34),('5819','2013-07-25','14:55:00',3.32),('5819','2013-07-25','15:00:00',3.31),('5819','2013-07-25','15:05:00',3.29),('5819','2013-07-25','15:10:00',3.23),('5819','2013-07-25','15:15:00',3.17),('5819','2013-07-25','15:20:00',3.14),('5819','2013-07-25','15:25:00',3.1),('5819','2013-07-25','15:30:00',3.06),('5819','2013-07-25','15:35:00',3.01),('5819','2013-07-25','15:40:00',2.97),('5819','2013-07-25','15:45:00',2.93),('5819','2013-07-25','15:50:00',2.88),('5819','2013-07-25','15:55:00',2.83),('5819','2013-07-25','16:00:00',2.75),('5819','2013-07-25','16:05:00',2.68),('5819','2013-07-25','16:10:00',2.63),('5819','2013-07-25','16:15:00',2.55),('5819','2013-07-25','16:20:00',2.5),('5819','2013-07-25','16:25:00',2.44),('5819','2013-07-25','16:30:00',2.38),('5819','2013-07-25','16:35:00',2.34),('5819','2013-07-25','16:40:00',2.27),('5819','2013-07-25','16:45:00',2.19),('5819','2013-07-25','16:50:00',2.12),('5819','2013-07-25','16:55:00',2.07),('5819','2013-07-25','17:00:00',1.96),('5819','2013-07-25','17:05:00',1.92),('5819','2013-07-25','17:10:00',1.82),('5819','2013-07-25','17:15:00',1.75),('5819','2013-07-25','17:20:00',1.67),('5819','2013-07-25','17:25:00',1.59),('5819','2013-07-25','17:30:00',1.52),('5819','2013-07-25','17:35:00',1.45),('5819','2013-07-25','17:40:00',1.36),('5819','2013-07-25','17:45:00',1.23),('5819','2013-07-25','17:50:00',1.11),('5819','2013-07-25','17:55:00',1.04),('5819','2013-07-25','18:00:00',1.01),('5819','2013-07-24','08:00:00',1.21),('5819','2013-07-24','08:05:00',1.08),('5819','2013-07-24','08:20:00',1.34),('5819','2013-07-24','08:25:00',1.1),('5819','2013-07-24','08:30:00',1.08),('5819','2013-07-24','08:35:00',1.05),('5819','2013-07-24','08:40:00',1.13),('5819','2013-07-24','08:45:00',1.22),('5819','2013-07-24','08:50:00',1.98),('5819','2013-07-24','08:55:00',1.53),('5819','2013-07-24','09:00:00',1.19),('5819','2013-07-24','09:05:00',1.96),('5819','2013-07-24','09:10:00',2.39),('5819','2013-07-24','09:15:00',2.04),('5819','2013-07-24','09:20:00',1.85),('5819','2013-07-24','09:25:00',1.18),('5819','2013-07-24','09:30:00',1.5),('5819','2013-07-24','09:35:00',1.9),('5819','2013-07-24','09:40:00',1.87),('5819','2013-07-24','09:45:00',1.96),('5819','2013-07-24','09:50:00',1.89),('5819','2013-07-24','09:55:00',1.3),('5819','2013-07-24','10:00:00',1.08),('5819','2013-07-24','10:05:00',1.03),('5819','2013-07-24','10:10:00',1.03),('5819','2013-07-24','10:15:00',1.13),('5819','2013-07-24','10:20:00',1.44),('5819','2013-07-24','10:25:00',2.45),('5819','2013-07-24','10:30:00',3.29),('5819','2013-07-24','10:35:00',3.33),('5819','2013-07-24','10:40:00',3.5),('5819','2013-07-24','10:45:00',3.56),('5819','2013-07-24','10:50:00',2.52),('5819','2013-07-24','10:55:00',2.37),('5819','2013-07-24','11:00:00',1.57),('5819','2013-07-24','11:05:00',1.7),('5819','2013-07-24','11:10:00',3.73),('5819','2013-07-24','11:15:00',3.71),('5819','2013-07-24','11:20:00',3.72),('5819','2013-07-24','11:25:00',3.72),('5819','2013-07-24','11:30:00',3.72),('5819','2013-07-24','11:35:00',3.83),('5819','2013-07-24','11:40:00',3.67),('5819','2013-07-24','11:45:00',3.63),('5819','2013-07-24','11:50:00',3.66),('5819','2013-07-24','11:55:00',3.69),('5819','2013-07-24','12:00:00',3.83),('5819','2013-07-24','12:05:00',3.99),('5819','2013-07-24','12:10:00',3.29),('5819','2013-07-24','12:15:00',1.47),('5819','2013-07-24','12:20:00',2.55),('5819','2013-07-24','12:25:00',4.08),('5819','2013-07-24','12:30:00',2.39),('5819','2013-07-24','12:35:00',1.08),('5819','2013-07-24','12:40:00',2.02),('5819','2013-07-24','12:45:00',3.98),('5819','2013-07-24','12:50:00',2.02),('5819','2013-07-24','12:55:00',1.33),('5819','2013-07-24','13:00:00',3.94),('5819','2013-07-24','13:05:00',3.69),('5819','2013-07-24','13:10:00',1.18),('5819','2013-07-24','13:15:00',2.45),('5819','2013-07-24','13:20:00',1.18),('5819','2013-07-24','13:25:00',3.47),('5819','2013-07-24','13:30:00',1.71),('5819','2013-07-24','13:35:00',4.03),('5819','2013-07-24','13:40:00',3.26),('5819','2013-07-24','13:45:00',3.57),('5819','2013-07-24','13:50:00',2.87),('5819','2013-07-24','13:55:00',3.86),('5819','2013-07-24','14:00:00',3.88),('5819','2013-07-24','14:05:00',3.82),('5819','2013-07-24','14:10:00',3.75),('5819','2013-07-24','14:15:00',3.76),('5819','2013-07-24','14:20:00',3.6),('5819','2013-07-24','14:25:00',3.49),('5819','2013-07-24','14:30:00',3.68),('5819','2013-07-24','14:35:00',2.73),('5819','2013-07-24','14:40:00',3.69),('5819','2013-07-24','14:45:00',3.56),('5819','2013-07-24','14:50:00',3.61),('5819','2013-07-24','14:55:00',3.55),('5819','2013-07-24','15:00:00',3.4),('5819','2013-07-24','15:05:00',3.4),('5819','2013-07-24','15:10:00',3.31),('5819','2013-07-24','15:15:00',3.3),('5819','2013-07-24','15:20:00',3.25),('5819','2013-07-24','15:25:00',3.19),('5819','2013-07-24','15:30:00',3.03),('5819','2013-07-24','15:35:00',2.95),('5819','2013-07-24','15:40:00',2.99),('5819','2013-07-24','15:45:00',2.92),('5819','2013-07-24','15:50:00',2.84),('5819','2013-07-24','15:55:00',2.9),('5819','2013-07-24','16:00:00',2.83),('5819','2013-07-24','16:05:00',2.73),('5819','2013-07-24','16:10:00',2.63),('5819','2013-07-24','16:15:00',2.31),('5819','2013-07-24','16:20:00',2.7),('5819','2013-07-24','16:25:00',2.53),('5819','2013-07-24','16:30:00',2.57),('5819','2013-07-24','16:35:00',2.36),('5819','2013-07-24','16:40:00',2.39),('5819','2013-07-24','16:45:00',2.18),('5819','2013-07-24','16:50:00',2.16),('5819','2013-07-24','16:55:00',2.25),('5819','2013-07-24','17:00:00',2.18),('5819','2013-07-24','17:05:00',1.83),('5819','2013-07-24','17:10:00',1.22),('5819','2013-07-24','17:15:00',1.83),('5819','2013-07-24','17:20:00',1.77),('5819','2013-07-24','17:25:00',1.69),('5819','2013-07-24','17:30:00',1.58),('5819','2013-07-24','17:35:00',1.49),('5819','2013-07-24','17:40:00',1.4),('5819','2013-07-24','17:45:00',1.28),('5819','2013-07-24','17:50:00',1.11),('5819','2013-07-24','18:00:00',1.02),('5819','2013-07-23','07:35:00',1.05),('5819','2013-07-23','07:40:00',1.12),('5819','2013-07-23','07:45:00',1.15),('5819','2013-07-23','07:50:00',1.19),('5819','2013-07-23','07:55:00',1.3),('5819','2013-07-23','08:00:00',1.46),('5819','2013-07-23','08:05:00',1.57),('5819','2013-07-23','08:10:00',1.63),('5819','2013-07-23','08:15:00',1.71),('5819','2013-07-23','08:20:00',1.79),('5819','2013-07-23','08:25:00',1.86),('5819','2013-07-23','08:30:00',1.92),('5819','2013-07-23','08:35:00',1.98),('5819','2013-07-23','08:40:00',2.07),('5819','2013-07-23','08:45:00',2.15),('5819','2013-07-23','08:50:00',2.22),('5819','2013-07-23','08:55:00',2.29),('5819','2013-07-23','09:00:00',2.36),('5819','2013-07-23','09:05:00',2.45),('5819','2013-07-23','09:10:00',2.48),('5819','2013-07-23','09:15:00',2.55),('5819','2013-07-23','09:20:00',2.59),('5819','2013-07-23','09:25:00',2.63),('5819','2013-07-23','09:30:00',2.67),('5819','2013-07-23','09:35:00',2.72),('5819','2013-07-23','09:40:00',2.77),('5819','2013-07-23','09:45:00',2.79),('5819','2013-07-23','09:50:00',2.85),('5819','2013-07-23','09:55:00',2.87),('5819','2013-07-23','10:00:00',2.89),('5819','2013-07-23','10:05:00',2.97),('5819','2013-07-23','10:10:00',3.02),('5819','2013-07-23','10:15:00',3.06),('5819','2013-07-23','10:20:00',3.1),('5819','2013-07-23','10:25:00',3.15),('5819','2013-07-23','10:30:00',3.22),('5819','2013-07-23','10:35:00',3.31),('5819','2013-07-23','10:40:00',3.39),('5819','2013-07-23','10:45:00',3.4),('5819','2013-07-23','10:50:00',3.4),('5819','2013-07-23','10:55:00',3.4),('5819','2013-07-23','11:00:00',3.45),('5819','2013-07-23','11:05:00',3.49),('5819','2013-07-23','11:10:00',3.5),('5819','2013-07-23','11:15:00',3.56),('5819','2013-07-23','11:20:00',3.57),('5819','2013-07-23','11:25:00',3.59),('5819','2013-07-23','11:30:00',3.63),('5819','2013-07-23','11:35:00',3.69),('5819','2013-07-23','11:40:00',3.67),('5819','2013-07-23','11:45:00',3.65),('5819','2013-07-23','11:50:00',3.62),('5819','2013-07-23','11:55:00',3.61),('5819','2013-07-23','12:00:00',3.73),('5819','2013-07-23','12:05:00',3.72),('5819','2013-07-23','12:10:00',3.74),('5819','2013-07-23','12:15:00',3.75),('5819','2013-07-23','12:20:00',3.73),('5819','2013-07-23','12:25:00',3.77),('5819','2013-07-23','12:30:00',3.75),('5819','2013-07-23','12:35:00',3.67),('5819','2013-07-23','12:40:00',3.74),('5819','2013-07-23','12:45:00',2.72),('5819','2013-07-23','12:50:00',2.7),('5819','2013-07-23','12:55:00',2.36),('5819','2013-07-23','13:00:00',1.32),('5819','2013-07-23','13:10:00',2.67),('5819','2013-07-23','13:15:00',2.9),('5819','2013-07-23','13:20:00',1.1),('5819','2013-07-23','13:25:00',1.39),('5819','2013-07-23','13:30:00',2.56),('5819','2013-07-23','13:35:00',3.96),('5819','2013-07-23','13:40:00',3.9),('5819','2013-07-23','13:45:00',3.73),('5819','2013-07-23','13:50:00',2.51),('5819','2013-07-23','13:55:00',2.57),('5819','2013-07-23','14:00:00',3.81),('5819','2013-07-23','14:05:00',2.06),('5819','2013-07-23','14:35:00',1.42),('5819','2013-07-23','14:40:00',3.5),('5819','2013-07-23','14:45:00',2.6),('5819','2013-07-23','14:50:00',3.62),('5819','2013-07-23','14:55:00',3.73),('5819','2013-07-23','15:00:00',2.46),('5819','2013-07-23','15:05:00',3.88),('5819','2013-07-23','15:10:00',3.63),('5819','2013-07-23','15:15:00',3.35),('5819','2013-07-23','15:20:00',3.35),('5819','2013-07-23','15:25:00',3.18),('5819','2013-07-23','15:30:00',3.09),('5819','2013-07-23','15:35:00',2.1),('5819','2013-07-23','15:40:00',2.97),('5819','2013-07-23','15:45:00',2.86),('5819','2013-07-23','15:50:00',2.83),('5819','2013-07-23','15:55:00',2.8),('5819','2013-07-23','16:00:00',2.73),('5819','2013-07-23','16:05:00',2.67),('5819','2013-07-23','16:10:00',2.61),('5819','2013-07-23','16:15:00',2.52),('5819','2013-07-23','16:20:00',2.51),('5819','2013-07-23','16:25:00',2.44),('5819','2013-07-23','16:30:00',2.38),('5819','2013-07-23','16:35:00',2.3),('5819','2013-07-23','16:40:00',2.23),('5819','2013-07-23','16:45:00',2.15),('5819','2013-07-23','16:50:00',2.08),('5819','2013-07-23','16:55:00',2.03),('5819','2013-07-23','17:00:00',1.95),('5819','2013-07-23','17:05:00',1.88),('5819','2013-07-23','17:10:00',1.84),('5819','2013-07-23','17:15:00',1.79),('5819','2013-07-23','17:20:00',1.72),('5819','2013-07-23','17:25:00',1.66),('5819','2013-07-23','17:30:00',1.59),('5819','2013-07-23','17:35:00',1.52),('5819','2013-07-23','17:40:00',1.45),('5819','2013-07-23','17:45:00',1.34),('5819','2013-07-23','17:50:00',1.17),('5819','2013-07-23','17:55:00',1.15),('5819','2013-07-23','18:00:00',1.1),('5819','2013-07-23','18:05:00',1.02),('5819','2013-07-22','07:40:00',1.08),('5819','2013-07-22','07:45:00',1.16),('5819','2013-07-22','07:50:00',1.23),('5819','2013-07-22','07:55:00',1.31),('5819','2013-07-22','08:00:00',1.39),('5819','2013-07-22','08:05:00',1.48),('5819','2013-07-22','08:10:00',1.56),('5819','2013-07-22','08:15:00',1.64),('5819','2013-07-22','08:20:00',1.72),('5819','2013-07-22','08:25:00',1.8),('5819','2013-07-22','08:30:00',1.88),('5819','2013-07-22','08:35:00',1.96),('5819','2013-07-22','08:40:00',2.05),('5819','2013-07-22','08:45:00',2.12),('5819','2013-07-22','08:50:00',2.18),('5819','2013-07-22','08:55:00',2.25),('5819','2013-07-22','09:00:00',2.33),('5819','2013-07-22','09:05:00',2.4),('5819','2013-07-22','09:10:00',2.45),('5819','2013-07-22','09:15:00',2.51),('5819','2013-07-22','09:20:00',2.57),('5819','2013-07-22','09:25:00',2.62),('5819','2013-07-22','09:30:00',2.67),('5819','2013-07-22','09:35:00',2.72),('5819','2013-07-22','09:40:00',2.78),('5819','2013-07-22','09:45:00',2.85),('5819','2013-07-22','09:50:00',2.88),('5819','2013-07-22','09:55:00',2.94),('5819','2013-07-22','10:00:00',3),('5819','2013-07-22','10:05:00',3.05),('5819','2013-07-22','10:10:00',3.09),('5819','2013-07-22','10:15:00',3.14),('5819','2013-07-22','10:20:00',3.18),('5819','2013-07-22','10:25:00',3.23),('5819','2013-07-22','10:30:00',3.26),('5819','2013-07-22','10:35:00',3.28),('5819','2013-07-22','10:40:00',3.32),('5819','2013-07-22','10:45:00',3.35),('5819','2013-07-22','10:50:00',3.38),('5819','2013-07-22','10:55:00',3.41),('5819','2013-07-22','11:00:00',3.41),('5819','2013-07-22','11:05:00',3.45),('5819','2013-07-22','11:10:00',3.47),('5819','2013-07-22','11:15:00',3.48),('5819','2013-07-22','11:20:00',3.49),('5819','2013-07-22','11:25:00',3.5),('5819','2013-07-22','11:30:00',3.52),('5819','2013-07-22','11:35:00',3.53),('5819','2013-07-22','11:40:00',3.55),('5819','2013-07-22','11:45:00',3.58),('5819','2013-07-22','11:50:00',3.57),('5819','2013-07-22','11:55:00',3.57),('5819','2013-07-22','12:00:00',3.6),('5819','2013-07-22','12:05:00',3.62),('5819','2013-07-22','12:10:00',3.63),('5819','2013-07-22','12:15:00',3.64),('5819','2013-07-22','12:20:00',3.65),('5819','2013-07-22','12:25:00',3.69),('5819','2013-07-22','12:30:00',3.71),('5819','2013-07-22','12:35:00',3.68),('5819','2013-07-22','12:40:00',3.69),('5819','2013-07-22','12:45:00',3.68),('5819','2013-07-22','12:50:00',3.68),('5819','2013-07-22','12:55:00',3.67),('5819','2013-07-22','13:00:00',3.71),('5819','2013-07-22','13:05:00',3.72),('5819','2013-07-22','13:10:00',3.67),('5819','2013-07-22','13:15:00',3.67),('5819','2013-07-22','13:20:00',3.65),('5819','2013-07-22','13:25:00',3.6),('5819','2013-07-22','13:30:00',3.58),('5819','2013-07-22','13:35:00',3.62),('5819','2013-07-22','13:40:00',3.66),('5819','2013-07-22','13:45:00',3.62),('5819','2013-07-22','13:50:00',3.58),('5819','2013-07-22','13:55:00',3.53),('5819','2013-07-22','14:00:00',3.54),('5819','2013-07-22','14:05:00',3.45),('5819','2013-07-22','14:10:00',3.48),('5819','2013-07-22','14:15:00',3.51),('5819','2013-07-22','14:20:00',3.49),('5819','2013-07-22','14:25:00',3.44),('5819','2013-07-22','14:30:00',3.39),('5819','2013-07-22','14:35:00',3.37),('5819','2013-07-22','14:40:00',3.36),('5819','2013-07-22','14:45:00',3.33),('5819','2013-07-22','14:50:00',3.29),('5819','2013-07-22','14:55:00',3.19),('5819','2013-07-22','15:00:00',3.1),('5819','2013-07-22','15:05:00',2.93),('5819','2013-07-22','15:10:00',3.15),('5819','2013-07-22','15:15:00',3.13),('5819','2013-07-22','15:20:00',3.07),('5819','2013-07-22','15:25:00',3.03),('5819','2013-07-22','15:30:00',1.03),('5819','2013-07-22','15:35:00',1.41),('5819','2013-07-22','15:40:00',2.92),('5819','2013-07-22','15:45:00',3.08),('5819','2013-07-22','15:50:00',3),('5819','2013-07-22','15:55:00',3.16),('5819','2013-07-22','16:00:00',2.85),('5819','2013-07-22','16:05:00',1.66),('5819','2013-07-22','16:10:00',1.26),('5819','2013-07-22','16:15:00',2.39),('5819','2013-07-22','16:20:00',2.84),('5819','2013-07-22','16:25:00',2.74),('5819','2013-07-22','16:30:00',2.55),('5819','2013-07-22','16:35:00',2.43),('5819','2013-07-22','16:40:00',2.27),('5819','2013-07-22','16:45:00',2.18),('5819','2013-07-22','16:50:00',2.11),('5819','2013-07-22','16:55:00',2.01),('5819','2013-07-22','17:00:00',1.97),('5819','2013-07-22','17:05:00',1.93),('5819','2013-07-22','17:10:00',1.87),('5819','2013-07-22','17:15:00',1.77),('5819','2013-07-22','17:20:00',1.71),('5819','2013-07-22','17:25:00',1.61),('5819','2013-07-22','17:30:00',1.58),('5819','2013-07-22','17:35:00',1.53),('5819','2013-07-22','17:40:00',1.41),('5819','2013-07-22','17:45:00',1.26),('5819','2013-07-22','17:50:00',1.13),('5819','2013-07-22','17:55:00',1.1),('5819','2013-07-22','18:00:00',1.09),('5819','2013-07-21','07:40:00',1.02),('5819','2013-07-21','07:45:00',1.13),('5819','2013-07-21','07:50:00',1.16),('5819','2013-07-21','07:55:00',1.2),('5819','2013-07-21','08:00:00',1.28),('5819','2013-07-21','08:05:00',1.34),('5819','2013-07-21','08:10:00',1.46),('5819','2013-07-21','08:15:00',1.54),('5819','2013-07-21','08:20:00',1.6),('5819','2013-07-21','08:25:00',1.7),('5819','2013-07-21','08:30:00',1.78),('5819','2013-07-21','08:35:00',1.85),('5819','2013-07-21','08:40:00',1.91),('5819','2013-07-21','08:45:00',1.97),('5819','2013-07-21','08:50:00',2.04),('5819','2013-07-21','08:55:00',2.13),('5819','2013-07-21','09:00:00',2.22),('5819','2013-07-21','09:05:00',2.28),('5819','2013-07-21','09:10:00',2.33),('5819','2013-07-21','09:15:00',2.4),('5819','2013-07-21','09:20:00',2.47),('5819','2013-07-21','09:25:00',2.53),('5819','2013-07-21','09:30:00',2.58),('5819','2013-07-21','09:35:00',2.64),('5819','2013-07-21','09:40:00',2.7),('5819','2013-07-21','09:45:00',2.74),('5819','2013-07-21','09:50:00',2.78),('5819','2013-07-21','09:55:00',2.84),('5819','2013-07-21','10:00:00',2.9),('5819','2013-07-21','10:05:00',2.94),('5819','2013-07-21','10:10:00',2.97),('5819','2013-07-21','10:15:00',3.03),('5819','2013-07-21','10:20:00',3.07),('5819','2013-07-21','10:25:00',3.12),('5819','2013-07-21','10:30:00',3.11),('5819','2013-07-21','10:35:00',3.16),('5819','2013-07-21','10:40:00',3.22),('5819','2013-07-21','10:45:00',3.26),('5819','2013-07-21','10:50:00',3.3),('5819','2013-07-21','10:55:00',3.3),('5819','2013-07-21','11:00:00',3.33),('5819','2013-07-21','11:05:00',3.33),('5819','2013-07-21','11:10:00',3.37),('5819','2013-07-21','11:15:00',3.45),('5819','2013-07-21','11:20:00',3.46),('5819','2013-07-21','11:25:00',3.51),('5819','2013-07-21','11:30:00',3.51),('5819','2013-07-21','11:35:00',3.54),('5819','2013-07-21','11:40:00',3.66),('5819','2013-07-21','11:45:00',3.13),('5819','2013-07-21','11:50:00',3.69),('5819','2013-07-21','11:55:00',3.64),('5819','2013-07-21','12:00:00',3.63),('5819','2013-07-21','12:05:00',3.49),('5819','2013-07-21','12:10:00',3.7),('5819','2013-07-21','12:15:00',3.82),('5819','2013-07-21','12:20:00',3.9),('5819','2013-07-21','12:25:00',3.98),('5819','2013-07-21','12:30:00',3.98),('5819','2013-07-21','12:35:00',3.83),('5819','2013-07-21','12:40:00',3.9),('5819','2013-07-21','12:45:00',3.26),('5819','2013-07-21','12:50:00',4.16),('5819','2013-07-21','12:55:00',4.32),('5819','2013-07-21','13:00:00',4.17),('5819','2013-07-21','13:05:00',4.25),('5819','2013-07-21','13:10:00',4),('5819','2013-07-21','13:15:00',3.6),('5819','2013-07-21','13:20:00',3.98),('5819','2013-07-21','13:25:00',4.04),('5819','2013-07-21','13:30:00',3.8),('5819','2013-07-21','13:35:00',1.94),('5819','2013-07-21','13:40:00',1.13),('5819','2013-07-21','14:25:00',1.07),('5819','2013-07-21','14:30:00',1.06),('5819','2013-07-21','14:35:00',1.15),('5819','2013-07-21','14:40:00',1.08),('5819','2013-07-21','14:45:00',1.9),('5819','2013-07-21','14:50:00',2.1),('5819','2013-07-21','14:55:00',1.68),('5819','2013-07-21','15:00:00',1.54),('5819','2013-07-21','15:05:00',1.37),('5819','2013-07-21','15:10:00',1.33),('5819','2013-07-21','15:15:00',2.97),('5819','2013-07-21','15:20:00',2.79),('5819','2013-07-21','15:25:00',1.42),('5819','2013-07-21','15:30:00',1.26),('5819','2013-07-21','15:35:00',1.54),('5819','2013-07-21','15:40:00',3.6),('5819','2013-07-21','15:45:00',1.86),('5819','2013-07-21','15:50:00',2.06),('5819','2013-07-21','15:55:00',1.94),('5819','2013-07-21','16:00:00',1.2),('5819','2013-07-21','17:00:00',1.03),('5819','2013-07-21','17:05:00',1.1),('5819','2013-07-21','17:10:00',1.06),('5819','2013-07-20','07:35:00',1.04),('5819','2013-07-20','07:40:00',1.1),('5819','2013-07-20','07:45:00',1.17),('5819','2013-07-20','07:50:00',1.2),('5819','2013-07-20','07:55:00',1.31),('5819','2013-07-20','08:00:00',1.39),('5819','2013-07-20','08:05:00',1.49),('5819','2013-07-20','08:10:00',1.56),('5819','2013-07-20','08:15:00',1.62),('5819','2013-07-20','08:20:00',1.71),('5819','2013-07-20','08:25:00',1.79),('5819','2013-07-20','08:30:00',1.86),('5819','2013-07-20','08:35:00',1.95),('5819','2013-07-20','08:40:00',2.01),('5819','2013-07-20','08:45:00',2.1),('5819','2013-07-20','08:50:00',2.19),('5819','2013-07-20','08:55:00',2.27),('5819','2013-07-20','09:00:00',2.36),('5819','2013-07-20','09:05:00',2.42),('5819','2013-07-20','09:10:00',2.53),('5819','2013-07-20','09:15:00',2.61),('5819','2013-07-20','09:20:00',2.66),('5819','2013-07-20','09:25:00',2.61),('5819','2013-07-20','09:30:00',2.62),('5819','2013-07-20','09:35:00',2.69),('5819','2013-07-20','09:40:00',2.67),('5819','2013-07-20','09:45:00',2.79),('5819','2013-07-20','09:50:00',2.74),('5819','2013-07-20','09:55:00',2.79),('5819','2013-07-20','10:00:00',2.95),('5819','2013-07-20','10:05:00',2.99),('5819','2013-07-20','10:10:00',3.05),('5819','2013-07-20','10:15:00',3.09),('5819','2013-07-20','10:20:00',3.12),('5819','2013-07-20','10:25:00',3.18),('5819','2013-07-20','10:30:00',3.2),('5819','2013-07-20','10:35:00',3.25),('5819','2013-07-20','10:40:00',3.28),('5819','2013-07-20','10:45:00',3.31),('5819','2013-07-20','10:50:00',3.37),('5819','2013-07-20','10:55:00',3.37),('5819','2013-07-20','11:00:00',3.41),('5819','2013-07-20','11:05:00',3.42),('5819','2013-07-20','11:10:00',3.4),('5819','2013-07-20','11:15:00',3.48),('5819','2013-07-20','11:20:00',3.5),('5819','2013-07-20','11:25:00',3.52),('5819','2013-07-20','11:30:00',3.53),('5819','2013-07-20','11:35:00',3.52),('5819','2013-07-20','11:40:00',3.58),('5819','2013-07-20','11:45:00',3.58),('5819','2013-07-20','11:50:00',3.64),('5819','2013-07-20','11:55:00',3.69),('5819','2013-07-20','12:00:00',3.72),('5819','2013-07-20','12:05:00',3.73),('5819','2013-07-20','12:10:00',3.77),('5819','2013-07-20','12:15:00',3.71),('5819','2013-07-20','12:20:00',3.46),('5819','2013-07-20','12:25:00',3.65),('5819','2013-07-20','12:30:00',3.7),('5819','2013-07-20','12:35:00',3.62),('5819','2013-07-20','12:40:00',3.67),('5819','2013-07-20','12:45:00',3.82),('5819','2013-07-20','12:50:00',3.77),('5819','2013-07-20','12:55:00',3.66),('5819','2013-07-20','13:00:00',3.85),('5819','2013-07-20','13:05:00',3.81),('5819','2013-07-20','13:10:00',3.71),('5819','2013-07-20','13:15:00',3.44),('5819','2013-07-20','13:20:00',3.34),('5819','2013-07-20','13:25:00',3.66),('5819','2013-07-20','13:30:00',3.82),('5819','2013-07-20','13:35:00',3.83),('5819','2013-07-20','13:40:00',3.86),('5819','2013-07-20','13:45:00',3.81),('5819','2013-07-20','13:50:00',2.74),('5819','2013-07-20','14:00:00',3.15),('5819','2013-07-20','14:05:00',3.9),('5819','2013-07-20','14:10:00',3.55),('5819','2013-07-20','14:15:00',2.99),('5819','2013-07-20','14:20:00',2.08),('5819','2013-07-20','14:25:00',3.77),('5819','2013-07-20','14:30:00',3.64),('5819','2013-07-20','14:35:00',2.57),('5819','2013-07-20','14:40:00',3.23),('5819','2013-07-20','14:45:00',1.28),('5819','2013-07-20','14:50:00',2.79),('5819','2013-07-20','14:55:00',1.08),('5819','2013-07-20','15:00:00',1.53),('5819','2013-07-20','15:05:00',3.52),('5819','2013-07-20','15:10:00',3.41),('5819','2013-07-20','15:15:00',3.29),('5819','2013-07-20','15:20:00',3.19),('5819','2013-07-20','15:25:00',3.13),('5819','2013-07-20','15:30:00',3.07),('5819','2013-07-20','15:35:00',3),('5819','2013-07-20','15:40:00',2.97),('5819','2013-07-20','15:45:00',2.89),('5819','2013-07-20','15:50:00',2.81),('5819','2013-07-20','15:55:00',2.77),('5819','2013-07-20','16:00:00',2.73),('5819','2013-07-20','16:05:00',2.67),('5819','2013-07-20','16:10:00',2.61),('5819','2013-07-20','16:15:00',2.57),('5819','2013-07-20','16:20:00',2.53),('5819','2013-07-20','16:25:00',2.46),('5819','2013-07-20','16:30:00',2.4),('5819','2013-07-20','16:35:00',2.33),('5819','2013-07-20','16:40:00',2.26),('5819','2013-07-20','16:45:00',2.17),('5819','2013-07-20','16:50:00',2.1),('5819','2013-07-20','16:55:00',2.03),('5819','2013-07-20','17:00:00',1.95),('5819','2013-07-20','17:05:00',1.89),('5819','2013-07-20','17:10:00',1.82),('5819','2013-07-20','17:15:00',1.75),('5819','2013-07-20','17:20:00',1.68),('5819','2013-07-20','17:25:00',1.6),('5819','2013-07-20','17:30:00',1.53),('5819','2013-07-20','17:35:00',1.48),('5819','2013-07-20','17:40:00',1.4),('5819','2013-07-20','17:45:00',1.31),('5819','2013-07-20','17:50:00',1.14),('5819','2013-07-20','17:55:00',1.12),('5819','2013-07-20','18:00:00',1.06),('5819','2013-07-19','07:40:00',1.04),('5819','2013-07-19','07:45:00',1.1),('5819','2013-07-19','07:50:00',1.18),('5819','2013-07-19','07:55:00',1.25),('5819','2013-07-19','08:00:00',1.32),('5819','2013-07-19','08:05:00',1.41),('5819','2013-07-19','08:10:00',1.5),('5819','2013-07-19','08:15:00',1.57),('5819','2013-07-19','08:20:00',1.65),('5819','2013-07-19','08:25:00',1.7),('5819','2013-07-19','08:30:00',1.76),('5819','2013-07-19','08:35:00',1.86),('5819','2013-07-19','08:40:00',1.94),('5819','2013-07-19','08:45:00',2.03),('5819','2013-07-19','08:50:00',2.1),('5819','2013-07-19','08:55:00',2.17),('5819','2013-07-19','09:00:00',2.22),('5819','2013-07-19','09:05:00',2.28),('5819','2013-07-19','09:10:00',2.34),('5819','2013-07-19','09:15:00',2.4),('5819','2013-07-19','09:20:00',2.46),('5819','2013-07-19','09:25:00',2.51),('5819','2013-07-19','09:30:00',2.57),('5819','2013-07-19','09:35:00',2.64),('5819','2013-07-19','09:40:00',2.69),('5819','2013-07-19','09:45:00',2.72),('5819','2013-07-19','09:50:00',2.76),('5819','2013-07-19','09:55:00',2.8),('5819','2013-07-19','10:00:00',2.85),('5819','2013-07-19','10:05:00',2.87),('5819','2013-07-19','10:10:00',2.91),('5819','2013-07-19','10:15:00',2.94),('5819','2013-07-19','10:20:00',2.98),('5819','2013-07-19','10:25:00',3.1),('5819','2013-07-19','10:30:00',3.03),('5819','2013-07-19','10:35:00',3.17),('5819','2013-07-19','10:40:00',3.15),('5819','2013-07-19','10:45:00',3.17),('5819','2013-07-19','10:50:00',3.21),('5819','2013-07-19','10:55:00',3.23),('5819','2013-07-19','11:00:00',3.27),('5819','2013-07-19','11:05:00',3.26),('5819','2013-07-19','11:10:00',3.29),('5819','2013-07-19','11:15:00',3.33),('5819','2013-07-19','11:20:00',3.37),('5819','2013-07-19','11:25:00',3.4),('5819','2013-07-19','11:30:00',3.4),('5819','2013-07-19','11:35:00',3.37),('5819','2013-07-19','11:40:00',3.36),('5819','2013-07-19','11:45:00',3.52),('5819','2013-07-19','11:50:00',3.5),('5819','2013-07-19','11:55:00',3.43),('5819','2013-07-19','12:00:00',2.51),('5819','2013-07-19','12:05:00',3.22),('5819','2013-07-19','12:10:00',3.62),('5819','2013-07-19','12:15:00',3.7),('5819','2013-07-19','12:20:00',3.66),('5819','2013-07-19','12:25:00',3.68),('5819','2013-07-19','12:30:00',3.68),('5819','2013-07-19','12:35:00',3.62),('5819','2013-07-19','12:40:00',3.63),('5819','2013-07-19','12:45:00',3.58),('5819','2013-07-19','12:50:00',3.66),('5819','2013-07-19','12:55:00',2.69),('5819','2013-07-19','13:00:00',2.76),('5819','2013-07-19','13:05:00',3.78),('5819','2013-07-19','13:10:00',3.77),('5819','2013-07-19','13:15:00',2.02),('5819','2013-07-19','13:20:00',1.43),('5819','2013-07-19','13:25:00',2.8),('5819','2013-07-19','13:30:00',4.02),('5819','2013-07-19','13:35:00',3.86),('5819','2013-07-19','13:40:00',3.79),('5819','2013-07-19','13:45:00',3.8),('5819','2013-07-19','13:50:00',3.79),('5819','2013-07-19','13:55:00',3.8),('5819','2013-07-19','14:00:00',3.83),('5819','2013-07-19','14:05:00',3.77),('5819','2013-07-19','14:10:00',3.13),('5819','2013-07-19','14:15:00',3.45),('5819','2013-07-19','14:20:00',2.92),('5819','2013-07-19','14:25:00',3.04),('5819','2013-07-19','14:30:00',3.52),('5819','2013-07-19','14:35:00',3.71),('5819','2013-07-19','14:40:00',3.26),('5819','2013-07-19','14:45:00',3.51),('5819','2013-07-19','14:50:00',3.15),('5819','2013-07-19','14:55:00',3.33),('5819','2013-07-19','15:00:00',3.1),('5819','2013-07-19','15:05:00',3.4),('5819','2013-07-19','15:10:00',3.29),('5819','2013-07-19','15:15:00',2.8),('5819','2013-07-19','15:20:00',2.6),('5819','2013-07-19','15:25:00',2.52),('5819','2013-07-19','15:30:00',3.29),('5819','2013-07-19','15:35:00',3.17),('5819','2013-07-19','15:40:00',2.76),('5819','2013-07-19','15:45:00',3.04),('5819','2013-07-19','15:50:00',3.02),('5819','2013-07-19','15:55:00',2.8),('5819','2013-07-19','16:00:00',2.89),('5819','2013-07-19','16:05:00',2.83),('5819','2013-07-19','16:10:00',2.75),('5819','2013-07-19','16:15:00',2.72),('5819','2013-07-19','16:20:00',2.68),('5819','2013-07-19','16:25:00',2.63),('5819','2013-07-19','16:30:00',2.59),('5819','2013-07-19','16:35:00',2.54),('5819','2013-07-19','16:40:00',2.48),('5819','2013-07-19','16:45:00',2.44),('5819','2013-07-19','16:50:00',2.23),('5819','2013-07-19','16:55:00',2.35),('5819','2013-07-19','17:00:00',1.71),('5819','2013-07-19','17:05:00',2.31),('5819','2013-07-19','17:10:00',2.21),('5819','2013-07-19','17:15:00',1.85),('5819','2013-07-19','17:20:00',1.47),('5819','2013-07-19','17:25:00',1.62),('5819','2013-07-19','17:30:00',1.65),('5819','2013-07-19','17:35:00',1.47),('5819','2013-07-19','17:40:00',1.3),('5819','2013-07-19','17:45:00',1.11),('5819','2013-07-18','07:35:00',1.06),('5819','2013-07-18','07:40:00',1.14),('5819','2013-07-18','07:45:00',1.22),('5819','2013-07-18','07:50:00',1.31),('5819','2013-07-18','07:55:00',1.38),('5819','2013-07-18','08:00:00',1.47),('5819','2013-07-18','08:05:00',1.55),('5819','2013-07-18','08:10:00',1.62),('5819','2013-07-18','08:15:00',1.7),('5819','2013-07-18','08:20:00',1.78),('5819','2013-07-18','08:25:00',1.84),('5819','2013-07-18','08:30:00',1.91),('5819','2013-07-18','08:35:00',1.99),('5819','2013-07-18','08:40:00',2.05),('5819','2013-07-18','08:45:00',2.12),('5819','2013-07-18','08:50:00',2.19),('5819','2013-07-18','08:55:00',2.27),('5819','2013-07-18','09:00:00',2.33),('5819','2013-07-18','09:05:00',2.39),('5819','2013-07-18','09:10:00',2.44),('5819','2013-07-18','09:15:00',2.49),('5819','2013-07-18','09:20:00',2.56),('5819','2013-07-18','09:25:00',2.61),('5819','2013-07-18','09:30:00',2.68),('5819','2013-07-18','09:35:00',2.74),('5819','2013-07-18','09:40:00',2.79),('5819','2013-07-18','09:45:00',2.83),('5819','2013-07-18','09:50:00',2.89),('5819','2013-07-18','09:55:00',2.93),('5819','2013-07-18','10:00:00',2.97),('5819','2013-07-18','10:05:00',3),('5819','2013-07-18','10:10:00',3.07),('5819','2013-07-18','10:15:00',3.1),('5819','2013-07-18','10:20:00',3.12),('5819','2013-07-18','10:25:00',3.18),('5819','2013-07-18','10:30:00',3.25),('5819','2013-07-18','10:35:00',3.28),('5819','2013-07-18','10:40:00',3.32),('5819','2013-07-18','10:45:00',3.34),('5819','2013-07-18','10:50:00',3.37),('5819','2013-07-18','10:55:00',3.39),('5819','2013-07-18','11:00:00',3.4),('5819','2013-07-18','11:05:00',3.42),('5819','2013-07-18','11:10:00',3.47),('5819','2013-07-18','11:15:00',3.49),('5819','2013-07-18','11:20:00',3.52),('5819','2013-07-18','11:25:00',3.51),('5819','2013-07-18','11:30:00',3.53),('5819','2013-07-18','11:35:00',3.54),('5819','2013-07-18','11:40:00',3.54),('5819','2013-07-18','11:45:00',3.55),('5819','2013-07-18','11:50:00',3.56),('5819','2013-07-18','11:55:00',3.6),('5819','2013-07-18','12:00:00',3.64),('5819','2013-07-18','12:05:00',3.61),('5819','2013-07-18','12:10:00',3.61),('5819','2013-07-18','12:15:00',3.64),('5819','2013-07-18','12:20:00',3.67),('5819','2013-07-18','12:25:00',3.67),('5819','2013-07-18','12:30:00',3.61),('5819','2013-07-18','12:35:00',3.82),('5819','2013-07-18','12:40:00',3.92),('5819','2013-07-18','12:45:00',2.72),('5819','2013-07-18','12:50:00',1.48),('5819','2013-07-18','12:55:00',3.29),('5819','2013-07-18','13:00:00',3.9),('5819','2013-07-18','13:05:00',3.71),('5819','2013-07-18','13:10:00',3.66),('5819','2013-07-18','13:15:00',3.68),('5819','2013-07-18','13:20:00',3.82),('5819','2013-07-18','13:25:00',3.79),('5819','2013-07-18','13:30:00',3.85),('5819','2013-07-18','13:35:00',3.62),('5819','2013-07-18','13:40:00',3.03),('5819','2013-07-18','13:45:00',3.79),('5819','2013-07-18','13:50:00',3.74),('5819','2013-07-18','13:55:00',3.54),('5819','2013-07-18','14:00:00',3.64),('5819','2013-07-18','14:05:00',3.56),('5819','2013-07-18','14:10:00',3.55),('5819','2013-07-18','14:15:00',3.36),('5819','2013-07-18','14:20:00',3.56),('5819','2013-07-18','14:25:00',3.52),('5819','2013-07-18','14:30:00',3.47),('5819','2013-07-18','14:35:00',3.47),('5819','2013-07-18','14:40:00',3.43),('5819','2013-07-18','14:45:00',3.38),('5819','2013-07-18','14:50:00',3.34),('5819','2013-07-18','14:55:00',3.25),('5819','2013-07-18','15:00:00',3.2),('5819','2013-07-18','15:05:00',3.2),('5819','2013-07-18','15:10:00',3.2),('5819','2013-07-18','15:15:00',3.15),('5819','2013-07-18','15:20:00',3.11),('5819','2013-07-18','15:25:00',3.12),('5819','2013-07-18','15:30:00',3.04),('5819','2013-07-18','15:35:00',2.96),('5819','2013-07-18','15:40:00',2.94),('5819','2013-07-18','15:45:00',2.87),('5819','2013-07-18','15:50:00',2.83),('5819','2013-07-18','15:55:00',2.77),('5819','2013-07-18','16:00:00',2.71),('5819','2013-07-18','16:05:00',2.65),('5819','2013-07-18','16:10:00',2.6),('5819','2013-07-18','16:15:00',2.52),('5819','2013-07-18','16:20:00',2.47),('5819','2013-07-18','16:25:00',2.41),('5819','2013-07-18','16:30:00',2.34),('5819','2013-07-18','16:35:00',2.29),('5819','2013-07-18','16:40:00',2.22),('5819','2013-07-18','16:45:00',2.14),('5819','2013-07-18','16:50:00',2.07),('5819','2013-07-18','16:55:00',2),('5819','2013-07-18','17:00:00',1.9),('5819','2013-07-18','17:05:00',1.86),('5819','2013-07-18','17:10:00',1.74),('5819','2013-07-18','17:15:00',1.69),('5819','2013-07-18','17:20:00',1.5),('5819','2013-07-18','17:25:00',1.58),('5819','2013-07-18','17:30:00',1.48),('5819','2013-07-18','17:35:00',1.4),('5819','2013-07-18','17:40:00',1.33),('5819','2013-07-18','17:45:00',1.09),('5819','2013-07-18','17:50:00',1.03),('5819','2013-07-17','07:30:00',1),('5819','2013-07-17','07:35:00',1.06),('5819','2013-07-17','07:40:00',1.14),('5819','2013-07-17','07:45:00',1.24),('5819','2013-07-17','07:50:00',1.33),('5819','2013-07-17','07:55:00',1.41),('5819','2013-07-17','08:00:00',1.49),('5819','2013-07-17','08:05:00',1.59),('5819','2013-07-17','08:10:00',1.68),('5819','2013-07-17','08:15:00',1.77),('5819','2013-07-17','08:20:00',1.86),('5819','2013-07-17','08:25:00',1.93),('5819','2013-07-17','08:30:00',2),('5819','2013-07-17','08:35:00',2.09),('5819','2013-07-17','08:40:00',2.17),('5819','2013-07-17','08:45:00',2.24),('5819','2013-07-17','08:50:00',2.31),('5819','2013-07-17','08:55:00',2.37),('5819','2013-07-17','09:00:00',2.45),('5819','2013-07-17','09:05:00',2.53),('5819','2013-07-17','09:10:00',2.6),('5819','2013-07-17','09:15:00',2.68),('5819','2013-07-17','09:20:00',2.74),('5819','2013-07-17','09:25:00',2.79),('5819','2013-07-17','09:30:00',2.83),('5819','2013-07-17','09:35:00',2.87),('5819','2013-07-17','09:40:00',2.92),('5819','2013-07-17','09:45:00',2.99),('5819','2013-07-17','09:50:00',3.04),('5819','2013-07-17','09:55:00',3.07),('5819','2013-07-17','10:00:00',3.14),('5819','2013-07-17','10:05:00',3.19),('5819','2013-07-17','10:10:00',3.21),('5819','2013-07-17','10:15:00',3.24),('5819','2013-07-17','10:20:00',3.27),('5819','2013-07-17','10:25:00',3.32),('5819','2013-07-17','10:30:00',3.35),('5819','2013-07-17','10:35:00',3.39),('5819','2013-07-17','10:40:00',3.41),('5819','2013-07-17','10:45:00',3.48),('5819','2013-07-17','10:50:00',3.52),('5819','2013-07-17','10:55:00',3.54),('5819','2013-07-17','11:00:00',3.59),('5819','2013-07-17','11:05:00',3.62),('5819','2013-07-17','11:10:00',3.62),('5819','2013-07-17','11:15:00',3.62),('5819','2013-07-17','11:20:00',3.65),('5819','2013-07-17','11:25:00',3.68),('5819','2013-07-17','11:30:00',3.69),('5819','2013-07-17','11:35:00',3.71),('5819','2013-07-17','11:40:00',3.72),('5819','2013-07-17','11:45:00',3.73),('5819','2013-07-17','11:50:00',3.78),('5819','2013-07-17','11:55:00',3.8),('5819','2013-07-17','12:00:00',3.79),('5819','2013-07-17','12:05:00',3.8),('5819','2013-07-17','12:10:00',3.8),('5819','2013-07-17','12:15:00',3.75),('5819','2013-07-17','12:20:00',3.77),('5819','2013-07-17','12:25:00',3.81),('5819','2013-07-17','12:30:00',3.77),('5819','2013-07-17','12:35:00',3.79),('5819','2013-07-17','12:40:00',3.78),('5819','2013-07-17','12:45:00',3.78),('5819','2013-07-17','12:50:00',3.78),('5819','2013-07-17','12:55:00',3.81),('5819','2013-07-17','13:00:00',3.82),('5819','2013-07-17','13:05:00',3.79),('5819','2013-07-17','13:10:00',3.75),('5819','2013-07-17','13:15:00',3.76),('5819','2013-07-17','13:20:00',3.7),('5819','2013-07-17','13:25:00',3.69),('5819','2013-07-17','13:30:00',3.69),('5819','2013-07-17','13:35:00',3.65),('5819','2013-07-17','13:40:00',3.67),('5819','2013-07-17','13:45:00',3.67),('5819','2013-07-17','13:50:00',3.64),('5819','2013-07-17','13:55:00',3.63),('5819','2013-07-17','14:00:00',3.61),('5819','2013-07-17','14:05:00',3.57),('5819','2013-07-17','14:10:00',3.54),('5819','2013-07-17','14:15:00',3.55),('5819','2013-07-17','14:20:00',3.54),('5819','2013-07-17','14:25:00',3.5),('5819','2013-07-17','14:30:00',3.46),('5819','2013-07-17','14:35:00',3.41),('5819','2013-07-17','14:40:00',3.6),('5819','2013-07-17','14:45:00',3.47),('5819','2013-07-17','14:50:00',3.34),('5819','2013-07-17','14:55:00',3.26),('5819','2013-07-17','15:00:00',3.33),('5819','2013-07-17','15:05:00',3.27),('5819','2013-07-17','15:10:00',3.26),('5819','2013-07-17','15:15:00',3.26),('5819','2013-07-17','15:20:00',3.19),('5819','2013-07-17','15:25:00',3.11),('5819','2013-07-17','15:30:00',3.02),('5819','2013-07-17','15:35:00',3),('5819','2013-07-17','15:40:00',2.46),('5819','2013-07-17','15:45:00',2.91),('5819','2013-07-17','15:50:00',2.88),('5819','2013-07-17','15:55:00',2.82),('5819','2013-07-17','16:00:00',2.78),('5819','2013-07-17','16:05:00',2.71),('5819','2013-07-17','16:10:00',2.68),('5819','2013-07-17','16:15:00',2.61),('5819','2013-07-17','16:20:00',2.51),('5819','2013-07-17','16:25:00',2.44),('5819','2013-07-17','16:30:00',2.41),('5819','2013-07-17','16:35:00',2.37),('5819','2013-07-17','16:40:00',2.26),('5819','2013-07-17','16:45:00',2.26),('5819','2013-07-17','16:50:00',2.18),('5819','2013-07-17','16:55:00',2.06),('5819','2013-07-17','17:00:00',1.72),('5819','2013-07-17','17:05:00',1.96),('5819','2013-07-17','17:10:00',1.95),('5819','2013-07-17','17:15:00',1.83),('5819','2013-07-17','17:20:00',1.73),('5819','2013-07-17','17:25:00',1.61),('5819','2013-07-17','17:30:00',1.56),('5819','2013-07-17','17:35:00',1.46),('5819','2013-07-17','17:40:00',1.37),('5819','2013-07-17','17:45:00',1.32),('5819','2013-07-17','17:50:00',1.15),('5819','2013-07-17','18:00:00',1),('5819','2013-07-16','07:30:00',1.03),('5819','2013-07-16','07:35:00',1.1),('5819','2013-07-16','07:40:00',1.17),('5819','2013-07-16','07:45:00',1.24),('5819','2013-07-16','07:50:00',1.31),('5819','2013-07-16','07:55:00',1.37),('5819','2013-07-16','08:00:00',1.43),('5819','2013-07-16','08:05:00',1.53),('5819','2013-07-16','08:10:00',1.6),('5819','2013-07-16','08:15:00',1.68),('5819','2013-07-16','08:20:00',1.76),('5819','2013-07-16','08:25:00',1.84),('5819','2013-07-16','08:30:00',1.92),('5819','2013-07-16','08:35:00',1.98),('5819','2013-07-16','08:40:00',2.03),('5819','2013-07-16','08:45:00',2.1),('5819','2013-07-16','08:50:00',2.19),('5819','2013-07-16','08:55:00',2.27),('5819','2013-07-16','09:00:00',2.31),('5819','2013-07-16','09:05:00',2.37),('5819','2013-07-16','09:10:00',2.44),('5819','2013-07-16','09:15:00',2.49),('5819','2013-07-16','09:20:00',2.56),('5819','2013-07-16','09:25:00',2.62),('5819','2013-07-16','09:30:00',2.67),('5819','2013-07-16','09:35:00',2.72),('5819','2013-07-16','09:40:00',2.77),('5819','2013-07-16','09:45:00',2.86),('5819','2013-07-16','09:50:00',2.92),('5819','2013-07-16','09:55:00',2.98),('5819','2013-07-16','10:00:00',3.04),('5819','2013-07-16','10:05:00',3.09),('5819','2013-07-16','10:10:00',3.15),('5819','2013-07-16','10:15:00',3.17),('5819','2013-07-16','10:20:00',3.19),('5819','2013-07-16','10:25:00',3.24),('5819','2013-07-16','10:30:00',3.28),('5819','2013-07-16','10:35:00',3.31),('5819','2013-07-16','10:40:00',3.35),('5819','2013-07-16','10:45:00',3.37),('5819','2013-07-16','10:50:00',3.41),('5819','2013-07-16','10:55:00',3.45),('5819','2013-07-16','11:00:00',3.47),('5819','2013-07-16','11:05:00',3.51),('5819','2013-07-16','11:10:00',3.54),('5819','2013-07-16','11:15:00',3.56),('5819','2013-07-16','11:20:00',3.58),('5819','2013-07-16','11:25:00',3.59),('5819','2013-07-16','11:30:00',3.58),('5819','2013-07-16','11:35:00',3.58),('5819','2013-07-16','11:40:00',3.62),('5819','2013-07-16','11:45:00',3.67),('5819','2013-07-16','11:50:00',3.73),('5819','2013-07-16','11:55:00',3.75),('5819','2013-07-16','12:00:00',3.76),('5819','2013-07-16','12:05:00',3.76),('5819','2013-07-16','12:10:00',3.78),('5819','2013-07-16','12:15:00',3.77),('5819','2013-07-16','12:20:00',3.77),('5819','2013-07-16','12:25:00',3.77),('5819','2013-07-16','12:30:00',3.74),('5819','2013-07-16','12:35:00',3.73),('5819','2013-07-16','12:40:00',3.72),('5819','2013-07-16','12:45:00',3.66),('5819','2013-07-16','12:50:00',3.7),('5819','2013-07-16','12:55:00',3.7),('5819','2013-07-16','13:00:00',3.71),('5819','2013-07-16','13:05:00',3.74),('5819','2013-07-16','13:10:00',3.72),('5819','2013-07-16','13:15:00',3.74),('5819','2013-07-16','13:20:00',3.69),('5819','2013-07-16','13:25:00',3.72),('5819','2013-07-16','13:30:00',3.68),('5819','2013-07-16','13:35:00',3.69),('5819','2013-07-16','13:40:00',3.67),('5819','2013-07-16','13:45:00',3.75),('5819','2013-07-16','13:50:00',3.73),('5819','2013-07-16','13:55:00',3.58),('5819','2013-07-16','14:00:00',3.57),('5819','2013-07-16','14:05:00',3.62),('5819','2013-07-16','14:10:00',3.26),('5819','2013-07-16','14:15:00',2.72),('5819','2013-07-16','14:20:00',1.79),('5819','2013-07-16','14:25:00',3.66),('5819','2013-07-16','14:30:00',3.56),('5819','2013-07-16','14:35:00',3.53),('5819','2013-07-16','14:40:00',3.46),('5819','2013-07-16','14:45:00',3.41),('5819','2013-07-16','14:50:00',3.41),('5819','2013-07-16','14:55:00',3.39),('5819','2013-07-16','15:00:00',3.32),('5819','2013-07-16','15:05:00',3.24),('5819','2013-07-16','15:10:00',3.18),('5819','2013-07-16','15:15:00',3.12),('5819','2013-07-16','15:20:00',3.11),('5819','2013-07-16','15:25:00',3.07),('5819','2013-07-16','15:30:00',3.08),('5819','2013-07-16','15:35:00',3.03),('5819','2013-07-16','15:40:00',2.88),('5819','2013-07-16','15:45:00',2.08),('5819','2013-07-16','15:50:00',2.87),('5819','2013-07-16','15:55:00',2.74),('5819','2013-07-16','16:00:00',1.64),('5819','2013-07-16','16:05:00',1.12),('5819','2013-07-16','16:10:00',2.58),('5819','2013-07-16','16:15:00',2.43),('5819','2013-07-16','16:20:00',1.89),('5819','2013-07-16','16:25:00',1.21),('5819','2013-07-16','16:30:00',1.06),('5819','2013-07-16','16:55:00',1.42),('5819','2013-07-16','17:00:00',2.13),('5819','2013-07-16','17:05:00',2.15),('5819','2013-07-16','17:10:00',2.18),('5819','2013-07-16','17:15:00',2.01),('5819','2013-07-16','17:20:00',1.84),('5819','2013-07-16','17:25:00',1.11),('5819','2013-07-16','17:30:00',1.22),('5819','2013-07-16','17:35:00',1.09),('5819','2013-07-16','17:40:00',1.38),('5819','2013-07-16','17:45:00',1.53),('5819','2013-07-16','17:50:00',1.33),('5819','2013-07-16','17:55:00',1.07),('5819','2013-07-15','07:30:00',1.03),('5819','2013-07-15','07:35:00',1.11),('5819','2013-07-15','07:40:00',1.19),('5819','2013-07-15','07:45:00',1.27),('5819','2013-07-15','07:50:00',1.36),('5819','2013-07-15','07:55:00',1.44),('5819','2013-07-15','08:00:00',1.52),('5819','2013-07-15','08:05:00',1.6),('5819','2013-07-15','08:10:00',1.68),('5819','2013-07-15','08:15:00',1.76),('5819','2013-07-15','08:20:00',1.85),('5819','2013-07-15','08:25:00',1.92),('5819','2013-07-15','08:30:00',2),('5819','2013-07-15','08:35:00',2.07),('5819','2013-07-15','08:40:00',2.14),('5819','2013-07-15','08:45:00',2.21),('5819','2013-07-15','08:50:00',2.28),('5819','2013-07-15','08:55:00',2.35),('5819','2013-07-15','09:00:00',2.42),('5819','2013-07-15','09:05:00',2.5),('5819','2013-07-15','09:10:00',2.57),('5819','2013-07-15','09:15:00',2.63),('5819','2013-07-15','09:20:00',2.67),('5819','2013-07-15','09:25:00',2.73),('5819','2013-07-15','09:30:00',2.79),('5819','2013-07-15','09:35:00',2.84),('5819','2013-07-15','09:40:00',2.89),('5819','2013-07-15','09:45:00',2.93),('5819','2013-07-15','09:50:00',2.99),('5819','2013-07-15','09:55:00',3.03),('5819','2013-07-15','10:00:00',3.06),('5819','2013-07-15','10:05:00',3.1),('5819','2013-07-15','10:10:00',3.16),('5819','2013-07-15','10:15:00',3.19),('5819','2013-07-15','10:20:00',3.21),('5819','2013-07-15','10:25:00',3.24),('5819','2013-07-15','10:30:00',3.26),('5819','2013-07-15','10:35:00',3.31),('5819','2013-07-15','10:40:00',3.36),('5819','2013-07-15','10:45:00',3.39),('5819','2013-07-15','10:50:00',3.41),('5819','2013-07-15','10:55:00',3.44),('5819','2013-07-15','11:00:00',3.49),('5819','2013-07-15','11:05:00',3.52),('5819','2013-07-15','11:10:00',3.54),('5819','2013-07-15','11:15:00',3.56),('5819','2013-07-15','11:20:00',3.58),('5819','2013-07-15','11:25:00',3.6),('5819','2013-07-15','11:30:00',3.61),('5819','2013-07-15','11:35:00',3.64),('5819','2013-07-15','11:40:00',3.67),('5819','2013-07-15','11:45:00',3.65),('5819','2013-07-15','11:50:00',3.66),('5819','2013-07-15','11:55:00',3.7),('5819','2013-07-15','12:00:00',3.7),('5819','2013-07-15','12:05:00',3.66),('5819','2013-07-15','12:10:00',3.68),('5819','2013-07-15','12:15:00',3.74),('5819','2013-07-15','12:20:00',3.75),('5819','2013-07-15','12:25:00',3.73),('5819','2013-07-15','12:30:00',3.75),('5819','2013-07-15','12:35:00',3.72),('5819','2013-07-15','12:40:00',3.69),('5819','2013-07-15','12:45:00',3.67),('5819','2013-07-15','12:50:00',3.71),('5819','2013-07-15','12:55:00',3.74),('5819','2013-07-15','13:00:00',3.26),('5819','2013-07-15','13:05:00',3.59),('5819','2013-07-15','13:10:00',3.47),('5819','2013-07-15','13:15:00',3.74),('5819','2013-07-15','13:20:00',3.69),('5819','2013-07-15','13:25:00',3.89),('5819','2013-07-15','13:30:00',3.9),('5819','2013-07-15','13:35:00',2.47),('5819','2013-07-15','13:40:00',1.08),('5819','2013-07-15','13:45:00',1.95),('5819','2013-07-15','13:50:00',4.11),('5819','2013-07-15','13:55:00',3.96),('5819','2013-07-15','14:00:00',3.94),('5819','2013-07-15','14:05:00',2.37),('5819','2013-07-15','14:10:00',1.21),('5819','2013-07-15','14:15:00',1.28),('5819','2013-07-15','14:20:00',3.27),('5819','2013-07-15','14:25:00',3.71),('5819','2013-07-15','14:30:00',3),('5819','2013-07-15','14:35:00',3.62),('5819','2013-07-15','14:40:00',3.57),('5819','2013-07-15','14:45:00',3.48),('5819','2013-07-15','14:50:00',3.47),('5819','2013-07-15','14:55:00',3.45),('5819','2013-07-15','15:00:00',3.42),('5819','2013-07-15','15:05:00',3.36),('5819','2013-07-15','15:10:00',3.3),('5819','2013-07-15','15:15:00',3.26),('5819','2013-07-15','15:20:00',3.16),('5819','2013-07-15','15:25:00',3.11),('5819','2013-07-15','15:30:00',3.08),('5819','2013-07-15','15:35:00',2.99),('5819','2013-07-15','15:40:00',3.07),('5819','2013-07-15','15:45:00',2.9),('5819','2013-07-15','15:50:00',3.01),('5819','2013-07-15','15:55:00',2.64),('5819','2013-07-15','16:00:00',2.77),('5819','2013-07-15','16:05:00',2.72),('5819','2013-07-15','16:10:00',2.67),('5819','2013-07-15','16:15:00',2.64),('5819','2013-07-15','16:20:00',2.49),('5819','2013-07-15','16:25:00',2.42),('5819','2013-07-15','16:30:00',2.36),('5819','2013-07-15','16:35:00',2.33),('5819','2013-07-15','16:40:00',2.25),('5819','2013-07-15','16:45:00',2.18),('5819','2013-07-15','16:50:00',2.11),('5819','2013-07-15','16:55:00',2.06),('5819','2013-07-15','17:00:00',2),('5819','2013-07-15','17:05:00',1.92),('5819','2013-07-15','17:10:00',1.84),('5819','2013-07-15','17:15:00',1.78),('5819','2013-07-15','17:20:00',1.71),('5819','2013-07-15','17:25:00',1.65),('5819','2013-07-15','17:30:00',1.57),('5819','2013-07-15','17:35:00',1.49),('5819','2013-07-15','17:40:00',1.42),('5819','2013-07-15','17:45:00',1.33),('5819','2013-07-15','17:50:00',1.18),('5819','2013-07-15','17:55:00',1.07),('5819','2013-07-15','18:00:00',1.07),('5819','2013-07-14','07:55:00',1.14),('5819','2013-07-14','08:00:00',1),('5819','2013-07-14','08:05:00',1.35),('5819','2013-07-14','08:10:00',2.16),('5819','2013-07-14','08:15:00',1.75),('5819','2013-07-14','08:20:00',2.39),('5819','2013-07-14','08:25:00',1.69),('5819','2013-07-14','08:35:00',1.18),('5819','2013-07-14','08:40:00',1.18),('5819','2013-07-14','08:45:00',1.02),('5819','2013-07-14','08:50:00',1.17),('5819','2013-07-14','08:55:00',1.33),('5819','2013-07-14','09:00:00',1.07),('5819','2013-07-14','09:05:00',1.29),('5819','2013-07-14','09:10:00',1.39),('5819','2013-07-14','09:15:00',1.51),('5819','2013-07-14','09:20:00',1.86),('5819','2013-07-14','09:25:00',2.4),('5819','2013-07-14','09:30:00',2.26),('5819','2013-07-14','09:35:00',1.79),('5819','2013-07-14','09:40:00',1.62),('5819','2013-07-14','09:45:00',1.62),('5819','2013-07-14','09:50:00',1.55),('5819','2013-07-14','09:55:00',1.7),('5819','2013-07-14','10:00:00',1.62),('5819','2013-07-14','10:05:00',1.72),('5819','2013-07-14','10:10:00',1.7),('5819','2013-07-14','10:15:00',1.77),('5819','2013-07-14','10:20:00',2.29),('5819','2013-07-14','10:25:00',2.72),('5819','2013-07-14','10:30:00',2.43),('5819','2013-07-14','10:35:00',3.31),('5819','2013-07-14','10:40:00',3.5),('5819','2013-07-14','10:45:00',3.19),('5819','2013-07-14','10:50:00',3.74),('5819','2013-07-14','10:55:00',3.19),('5819','2013-07-14','11:00:00',3.79),('5819','2013-07-14','11:05:00',3.68),('5819','2013-07-14','11:10:00',2.64),('5819','2013-07-14','11:15:00',3),('5819','2013-07-14','11:20:00',4.12),('5819','2013-07-14','11:25:00',3.81),('5819','2013-07-14','11:30:00',3.95),('5819','2013-07-14','11:35:00',3.71),('5819','2013-07-14','11:40:00',3.61),('5819','2013-07-14','11:45:00',4.06),('5819','2013-07-14','11:50:00',3.15),('5819','2013-07-14','11:55:00',1.4),('5819','2013-07-14','12:00:00',1.33),('5819','2013-07-14','12:05:00',1.54),('5819','2013-07-14','12:10:00',3.34),('5819','2013-07-14','12:15:00',3.21),('5819','2013-07-14','12:20:00',2.17),('5819','2013-07-14','12:25:00',2.11),('5819','2013-07-14','12:30:00',1.56),('5819','2013-07-14','12:35:00',1.35),('5819','2013-07-14','12:40:00',1.53),('5819','2013-07-14','12:45:00',3.14),('5819','2013-07-14','12:50:00',2.93),('5819','2013-07-14','12:55:00',3.52),('5819','2013-07-14','13:00:00',4.14),('5819','2013-07-14','13:05:00',4.19),('5819','2013-07-14','13:10:00',4.04),('5819','2013-07-14','13:15:00',4.04),('5819','2013-07-14','13:20:00',4.1),('5819','2013-07-14','13:25:00',3.94),('5819','2013-07-14','13:30:00',3.92),('5819','2013-07-14','13:35:00',3.89),('5819','2013-07-14','13:40:00',3.85),('5819','2013-07-14','13:45:00',3.85),('5819','2013-07-14','13:50:00',3.86),('5819','2013-07-14','13:55:00',3.85),('5819','2013-07-14','14:00:00',3.85),('5819','2013-07-14','14:05:00',3.83),('5819','2013-07-14','14:10:00',3.79),('5819','2013-07-14','14:15:00',3.79),('5819','2013-07-14','14:20:00',3.75),('5819','2013-07-14','14:25:00',3.7),('5819','2013-07-14','14:30:00',3.69),('5819','2013-07-14','14:35:00',3.59),('5819','2013-07-14','14:40:00',3.5),('5819','2013-07-14','14:45:00',3.47),('5819','2013-07-14','14:50:00',3.52),('5819','2013-07-14','14:55:00',3.5),('5819','2013-07-14','15:00:00',3.38),('5819','2013-07-14','15:05:00',3.33),('5819','2013-07-14','15:10:00',3.29),('5819','2013-07-14','15:15:00',3.24),('5819','2013-07-14','15:20:00',3.2),('5819','2013-07-14','15:25:00',3.14),('5819','2013-07-14','15:30:00',3.09),('5819','2013-07-14','15:35:00',3.04),('5819','2013-07-14','15:40:00',2.98),('5819','2013-07-14','15:45:00',2.94),('5819','2013-07-14','15:50:00',2.88),('5819','2013-07-14','15:55:00',2.86),('5819','2013-07-14','16:00:00',2.78),('5819','2013-07-14','16:05:00',2.76),('5819','2013-07-14','16:10:00',2.69),('5819','2013-07-14','16:15:00',2.65),('5819','2013-07-14','16:20:00',2.49),('5819','2013-07-14','16:25:00',2.48),('5819','2013-07-14','16:30:00',2.07),('5819','2013-07-14','16:35:00',2.07),('5819','2013-07-14','16:40:00',2.25),('5819','2013-07-14','16:45:00',2.23),('5819','2013-07-14','16:50:00',2.23),('5819','2013-07-14','16:55:00',2.27),('5819','2013-07-14','17:00:00',2.03),('5819','2013-07-14','17:05:00',1.62),('5819','2013-07-14','17:10:00',1.61),('5819','2013-07-14','17:15:00',1.57),('5819','2013-07-14','17:20:00',1.05),('5819','2013-07-14','17:25:00',1.49),('5819','2013-07-14','17:30:00',1.55),('5819','2013-07-14','17:35:00',1.61),('5819','2013-07-14','17:40:00',1.21),('5819','2013-07-14','17:55:00',1.24),('5819','2013-07-13','07:30:00',1.08),('5819','2013-07-13','07:35:00',1.07),('5819','2013-07-13','07:40:00',1.1),('5819','2013-07-13','07:45:00',1.18),('5819','2013-07-13','07:50:00',1.22),('5819','2013-07-13','07:55:00',1.29),('5819','2013-07-13','08:00:00',1.33),('5819','2013-07-13','08:05:00',1.4),('5819','2013-07-13','08:10:00',1.52),('5819','2013-07-13','08:15:00',1.64),('5819','2013-07-13','08:20:00',1.71),('5819','2013-07-13','08:25:00',1.81),('5819','2013-07-13','08:30:00',1.87),('5819','2013-07-13','08:35:00',1.94),('5819','2013-07-13','08:40:00',1.99),('5819','2013-07-13','08:45:00',2.1),('5819','2013-07-13','08:50:00',2.19),('5819','2013-07-13','08:55:00',2.22),('5819','2013-07-13','09:00:00',2.32),('5819','2013-07-13','09:05:00',2.38),('5819','2013-07-13','09:10:00',2.45),('5819','2013-07-13','09:15:00',2.52),('5819','2013-07-13','09:20:00',2.55),('5819','2013-07-13','09:25:00',2.64),('5819','2013-07-13','09:30:00',2.67),('5819','2013-07-13','09:35:00',2.74),('5819','2013-07-13','09:40:00',2.78),('5819','2013-07-13','09:45:00',2.85),('5819','2013-07-13','09:50:00',2.93),('5819','2013-07-13','09:55:00',2.96),('5819','2013-07-13','10:00:00',2.96),('5819','2013-07-13','10:05:00',3.03),('5819','2013-07-13','10:10:00',3.1),('5819','2013-07-13','10:15:00',3.05),('5819','2013-07-13','10:20:00',3.14),('5819','2013-07-13','10:25:00',3.27),('5819','2013-07-13','10:30:00',3.29),('5819','2013-07-13','10:35:00',3.27),('5819','2013-07-13','10:40:00',3.2),('5819','2013-07-13','10:45:00',3.32),('5819','2013-07-13','10:50:00',3.22),('5819','2013-07-13','10:55:00',3.53),('5819','2013-07-13','11:00:00',3.42),('5819','2013-07-13','11:05:00',3.62),('5819','2013-07-13','11:10:00',3.75),('5819','2013-07-13','11:15:00',2.55),('5819','2013-07-13','11:20:00',1.35),('5819','2013-07-13','11:25:00',1.99),('5819','2013-07-13','11:30:00',3.76),('5819','2013-07-13','11:35:00',3.72),('5819','2013-07-13','11:40:00',3.26),('5819','2013-07-13','11:45:00',1.7),('5819','2013-07-13','11:50:00',3.61),('5819','2013-07-13','11:55:00',2.97),('5819','2013-07-13','12:00:00',2.69),('5819','2013-07-13','12:05:00',3.33),('5819','2013-07-13','12:10:00',3.8),('5819','2013-07-13','12:15:00',1.98),('5819','2013-07-13','12:20:00',1.93),('5819','2013-07-13','12:25:00',2.62),('5819','2013-07-13','12:30:00',1.22),('5819','2013-07-13','12:35:00',3.99),('5819','2013-07-13','12:40:00',4.09),('5819','2013-07-13','12:45:00',2.32),('5819','2013-07-13','12:50:00',2.75),('5819','2013-07-13','12:55:00',3.94),('5819','2013-07-13','13:00:00',3.96),('5819','2013-07-13','13:05:00',4.01),('5819','2013-07-13','13:10:00',3.16),('5819','2013-07-13','13:15:00',3.23),('5819','2013-07-13','13:20:00',4.01),('5819','2013-07-13','13:25:00',3.93),('5819','2013-07-13','13:30:00',3.84),('5819','2013-07-13','13:35:00',3.82),('5819','2013-07-13','13:40:00',3.8),('5819','2013-07-13','13:45:00',3.75),('5819','2013-07-13','13:50:00',3.76),('5819','2013-07-13','13:55:00',3.75),('5819','2013-07-13','14:00:00',3.71),('5819','2013-07-13','14:05:00',3.71),('5819','2013-07-13','14:10:00',3.67),('5819','2013-07-13','14:15:00',3.64),('5819','2013-07-13','14:20:00',3.62),('5819','2013-07-13','14:25:00',3.6),('5819','2013-07-13','14:30:00',3.58),('5819','2013-07-13','14:35:00',3.56),('5819','2013-07-13','14:40:00',3.52),('5819','2013-07-13','14:45:00',3.5),('5819','2013-07-13','14:50:00',3.45),('5819','2013-07-13','14:55:00',3.45),('5819','2013-07-13','15:00:00',3.4),('5819','2013-07-13','15:05:00',3.38),('5819','2013-07-13','15:10:00',3.33),('5819','2013-07-13','15:15:00',3.31),('5819','2013-07-13','15:20:00',3.12),('5819','2013-07-13','15:25:00',3.25),('5819','2013-07-13','15:30:00',3.17),('5819','2013-07-13','15:35:00',3.15),('5819','2013-07-13','15:40:00',3.08),('5819','2013-07-13','15:45:00',3.02),('5819','2013-07-13','15:50:00',2.97),('5819','2013-07-13','15:55:00',2.92),('5819','2013-07-13','16:00:00',2.86),('5819','2013-07-13','16:05:00',2.82),('5819','2013-07-13','16:10:00',2.76),('5819','2013-07-13','16:15:00',2.66),('5819','2013-07-13','16:20:00',2.52),('5819','2013-07-13','16:25:00',2.58),('5819','2013-07-13','16:30:00',2.51),('5819','2013-07-13','16:35:00',2.45),('5819','2013-07-13','16:40:00',2.37),('5819','2013-07-13','16:45:00',2.29),('5819','2013-07-13','16:50:00',2.2),('5819','2013-07-13','16:55:00',2.12),('5819','2013-07-13','17:00:00',2.06),('5819','2013-07-13','17:05:00',1.97),('5819','2013-07-13','17:10:00',1.92),('5819','2013-07-13','17:15:00',1.86),('5819','2013-07-13','17:20:00',1.71),('5819','2013-07-13','17:25:00',1.72),('5819','2013-07-13','17:30:00',1.6),('5819','2013-07-13','17:35:00',1.52),('5819','2013-07-13','17:40:00',1.47),('5819','2013-07-13','17:45:00',1.4),('5819','2013-07-13','17:50:00',1.2),('5819','2013-07-13','17:55:00',1.22),('5819','2013-07-13','18:00:00',1.13),('5819','2013-07-13','18:05:00',1.05),('5819','2013-07-12','08:15:00',1.61),('5819','2013-07-12','08:20:00',2.07),('5819','2013-07-12','08:25:00',1),('5819','2013-07-12','08:35:00',1),('5819','2013-07-12','08:40:00',1.16),('5819','2013-07-12','08:45:00',1.35),('5819','2013-07-12','08:50:00',1.09),('5819','2013-07-12','09:05:00',1.01),('5819','2013-07-12','09:10:00',1.42),('5819','2013-07-12','09:15:00',1.74),('5819','2013-07-12','09:20:00',2.05),('5819','2013-07-12','09:25:00',2.53),('5819','2013-07-12','09:30:00',1.8),('5819','2013-07-12','09:35:00',1.63),('5819','2013-07-12','09:40:00',1.89),('5819','2013-07-12','09:45:00',2.88),('5819','2013-07-12','09:50:00',2.85),('5819','2013-07-12','09:55:00',2.94),('5819','2013-07-12','10:00:00',2.94),('5819','2013-07-12','10:05:00',2.98),('5819','2013-07-12','10:10:00',1.69),('5819','2013-07-12','10:15:00',2.65),('5819','2013-07-12','10:20:00',1.49),('5819','2013-07-12','10:25:00',1.34),('5819','2013-07-12','10:30:00',2.01),('5819','2013-07-12','10:35:00',2.06),('5819','2013-07-12','10:40:00',1.04),('5819','2013-07-12','10:50:00',1.58),('5819','2013-07-12','10:55:00',1.91),('5819','2013-07-12','11:00:00',3.94),('5819','2013-07-12','11:05:00',1.94),('5819','2013-07-12','11:10:00',1.18),('5819','2013-07-12','11:15:00',2.53),('5819','2013-07-12','11:25:00',3.53),('5819','2013-07-12','11:30:00',4.01),('5819','2013-07-12','11:35:00',3.73),('5819','2013-07-12','11:40:00',2.63),('5819','2013-07-12','11:45:00',3.27),('5819','2013-07-12','11:50:00',3.45),('5819','2013-07-12','11:55:00',3.11),('5819','2013-07-12','12:00:00',4.05),('5819','2013-07-12','12:05:00',2.33),('5819','2013-07-12','12:10:00',3.85),('5819','2013-07-12','12:15:00',2.37),('5819','2013-07-12','12:20:00',4.03),('5819','2013-07-12','12:25:00',2.68),('5819','2013-07-12','12:30:00',3.76),('5819','2013-07-12','12:35:00',3.69),('5819','2013-07-12','12:40:00',2.8),('5819','2013-07-12','12:45:00',3.35),('5819','2013-07-12','12:50:00',2.62),('5819','2013-07-12','12:55:00',4.09),('5819','2013-07-12','13:00:00',3.95),('5819','2013-07-12','13:05:00',3.99),('5819','2013-07-12','13:10:00',3.94),('5819','2013-07-12','13:15:00',3.95),('5819','2013-07-12','13:20:00',3.91),('5819','2013-07-12','13:25:00',3.87),('5819','2013-07-12','13:30:00',3.93),('5819','2013-07-12','13:35:00',3.9),('5819','2013-07-12','13:40:00',3.9),('5819','2013-07-12','13:45:00',3.84),('5819','2013-07-12','13:50:00',3.91),('5819','2013-07-12','13:55:00',3.81),('5819','2013-07-12','14:00:00',3.11),('5819','2013-07-12','14:05:00',3.21),('5819','2013-07-12','14:10:00',2.93),('5819','2013-07-12','14:15:00',3.32),('5819','2013-07-12','14:20:00',4.09),('5819','2013-07-12','14:25:00',3.93),('5819','2013-07-12','14:30:00',2.47),('5819','2013-07-12','14:35:00',2.76),('5819','2013-07-12','14:40:00',3.58),('5819','2013-07-12','14:45:00',3.48),('5819','2013-07-12','14:50:00',3.45),('5819','2013-07-12','14:55:00',3.4),('5819','2013-07-12','15:00:00',3.2),('5819','2013-07-12','15:05:00',3.32),('5819','2013-07-12','15:10:00',3.23),('5819','2013-07-12','15:15:00',2.69),('5819','2013-07-12','15:20:00',3.23),('5819','2013-07-12','15:25:00',3.17),('5819','2013-07-12','15:30:00',2.99),('5819','2013-07-12','15:35:00',2.58),('5819','2013-07-12','15:40:00',3.11),('5819','2013-07-12','15:45:00',2.71),('5819','2013-07-12','15:50:00',2.74),('5819','2013-07-12','15:55:00',2.86),('5819','2013-07-12','16:00:00',2.78),('5819','2013-07-12','16:05:00',2.73),('5819','2013-07-12','16:10:00',2.66),('5819','2013-07-12','16:15:00',2.57),('5819','2013-07-12','16:20:00',2.53),('5819','2013-07-12','16:25:00',2.49),('5819','2013-07-12','16:30:00',2.41),('5819','2013-07-12','16:35:00',2.33),('5819','2013-07-12','16:40:00',2.29),('5819','2013-07-12','16:45:00',2.23),('5819','2013-07-12','16:50:00',2.15),('5819','2013-07-12','16:55:00',2.09),('5819','2013-07-12','17:00:00',2.01),('5819','2013-07-12','17:05:00',1.95),('5819','2013-07-12','17:10:00',1.88),('5819','2013-07-12','17:15:00',1.79),('5819','2013-07-12','17:20:00',1.72),('5819','2013-07-12','17:25:00',1.62),('5819','2013-07-12','17:30:00',1.56),('5819','2013-07-12','17:35:00',1.49),('5819','2013-07-12','17:40:00',1.41),('5819','2013-07-12','17:45:00',1.34),('5819','2013-07-12','17:50:00',1.18),('5819','2013-07-12','17:55:00',1.11),('5819','2013-07-12','18:00:00',1.08),('5819','2013-07-12','18:05:00',1.03),('5819','2013-07-11','07:35:00',1.01),('5819','2013-07-11','07:40:00',1.09),('5819','2013-07-11','07:45:00',1.18),('5819','2013-07-11','07:50:00',1.26),('5819','2013-07-11','07:55:00',1.33),('5819','2013-07-11','08:00:00',1.41),('5819','2013-07-11','08:05:00',1.5),('5819','2013-07-11','08:10:00',1.56),('5819','2013-07-11','08:15:00',1.64),('5819','2013-07-11','08:20:00',1.73),('5819','2013-07-11','08:25:00',1.83),('5819','2013-07-11','08:30:00',1.9),('5819','2013-07-11','08:35:00',1.93),('5819','2013-07-11','08:40:00',2.02),('5819','2013-07-11','08:45:00',2.12),('5819','2013-07-11','08:50:00',2.15),('5819','2013-07-11','08:55:00',2.27),('5819','2013-07-11','09:00:00',2.35),('5819','2013-07-11','09:05:00',2.42),('5819','2013-07-11','09:10:00',2.42),('5819','2013-07-11','09:15:00',2.49),('5819','2013-07-11','09:20:00',2.41),('5819','2013-07-11','09:25:00',2.77),('5819','2013-07-11','09:30:00',2.83),('5819','2013-07-11','09:35:00',2.64),('5819','2013-07-11','09:40:00',2.52),('5819','2013-07-11','09:45:00',3.02),('5819','2013-07-11','09:50:00',2.27),('5819','2013-07-11','09:55:00',2.15),('5819','2013-07-11','10:00:00',2.45),('5819','2013-07-11','10:05:00',1.49),('5819','2013-07-11','10:10:00',1.3),('5819','2013-07-11','10:15:00',3.19),('5819','2013-07-11','10:20:00',3.25),('5819','2013-07-11','10:25:00',3.25),('5819','2013-07-11','10:30:00',3.52),('5819','2013-07-11','10:35:00',2.08),('5819','2013-07-11','10:45:00',2.67),('5819','2013-07-11','10:50:00',3.43),('5819','2013-07-11','10:55:00',3.67),('5819','2013-07-11','11:00:00',3.1),('5819','2013-07-11','11:05:00',2.75),('5819','2013-07-11','11:10:00',3.67),('5819','2013-07-11','11:15:00',2.02),('5819','2013-07-11','11:20:00',2.64),('5819','2013-07-11','11:25:00',2.35),('5819','2013-07-11','11:30:00',2.9),('5819','2013-07-11','11:35:00',2.97),('5819','2013-07-11','11:40:00',4.16),('5819','2013-07-11','11:45:00',3.97),('5819','2013-07-11','11:50:00',2.44),('5819','2013-07-11','11:55:00',1.64),('5819','2013-07-11','12:00:00',3.39),('5819','2013-07-11','12:05:00',1.06),('5819','2013-07-11','12:10:00',1.15),('5819','2013-07-11','12:15:00',1.97),('5819','2013-07-11','12:20:00',4.2),('5819','2013-07-11','12:25:00',4.02),('5819','2013-07-11','12:30:00',3.49),('5819','2013-07-11','12:35:00',3.96),('5819','2013-07-11','12:40:00',2.77),('5819','2013-07-11','12:45:00',1.87),('5819','2013-07-11','12:50:00',2.56),('5819','2013-07-11','12:55:00',3.58),('5819','2013-07-11','13:00:00',4.14),('5819','2013-07-11','13:05:00',3.19),('5819','2013-07-11','13:10:00',3.92),('5819','2013-07-11','13:15:00',4.03),('5819','2013-07-11','13:20:00',3.96),('5819','2013-07-11','13:25:00',3.94),('5819','2013-07-11','13:30:00',4.02),('5819','2013-07-11','13:35:00',3.79),('5819','2013-07-11','13:40:00',3.97),('5819','2013-07-11','13:45:00',3.51),('5819','2013-07-11','13:50:00',2.82),('5819','2013-07-11','13:55:00',3.16),('5819','2013-07-11','14:00:00',3.53),('5819','2013-07-11','14:05:00',3.45),('5819','2013-07-11','14:10:00',3.84),('5819','2013-07-11','14:15:00',3.81),('5819','2013-07-11','14:20:00',3.76),('5819','2013-07-11','14:25:00',3.26),('5819','2013-07-11','14:30:00',3.29),('5819','2013-07-11','14:35:00',3.67),('5819','2013-07-11','14:40:00',3.59),('5819','2013-07-11','14:45:00',3.57),('5819','2013-07-11','14:50:00',3.59),('5819','2013-07-11','14:55:00',2.68),('5819','2013-07-11','15:00:00',3.71),('5819','2013-07-11','15:05:00',2.1),('5819','2013-07-11','15:10:00',1.75),('5819','2013-07-11','15:15:00',3.42),('5819','2013-07-11','15:20:00',2.22),('5819','2013-07-11','15:25:00',2.29),('5819','2013-07-11','15:30:00',2.81),('5819','2013-07-11','15:35:00',3.36),('5819','2013-07-11','15:40:00',2.47),('5819','2013-07-11','15:45:00',2.75),('5819','2013-07-11','15:50:00',2.33),('5819','2013-07-11','15:55:00',1.83),('5819','2013-07-11','16:00:00',2.14),('5819','2013-07-11','16:05:00',2.33),('5819','2013-07-11','16:10:00',2.42),('5819','2013-07-11','16:15:00',1.96),('5819','2013-07-11','16:20:00',1.76),('5819','2013-07-11','16:25:00',2.03),('5819','2013-07-11','16:30:00',2.48),('5819','2013-07-11','16:35:00',1.3),('5819','2013-07-11','16:40:00',2.42),('5819','2013-07-11','16:45:00',1.89),('5819','2013-07-11','16:50:00',2.31),('5819','2013-07-11','16:55:00',2.3),('5819','2013-07-11','17:00:00',1.98),('5819','2013-07-11','17:05:00',1.75),('5819','2013-07-11','17:10:00',1.66),('5819','2013-07-11','17:15:00',1.04),('5819','2013-07-11','17:20:00',1.52),('5819','2013-07-11','17:25:00',1.15),('5819','2013-07-11','17:30:00',1.72),('5819','2013-07-11','17:35:00',1.66),('5819','2013-07-11','17:40:00',1.64),('5819','2013-07-11','17:45:00',1.51),('5819','2013-07-11','17:50:00',1.23),('5819','2013-07-11','18:00:00',1.1),('5819','2013-07-11','18:05:00',1.41),('5819','2013-07-11','18:10:00',1.31),('5819','2013-07-11','18:15:00',1.07),('5819','2013-07-11','18:25:00',1.02),('5819','2014-05-03','07:25:00',1.04),('5819','2014-05-03','07:30:00',1.13),('5819','2014-05-03','07:35:00',1.22),('5819','2014-05-03','07:40:00',1.31),('5819','2014-05-03','07:45:00',1.41),('5819','2014-05-03','07:50:00',1.53),('5819','2014-05-03','07:55:00',1.63),('5819','2014-05-03','08:00:00',1.54),('5819','2014-05-03','08:05:00',1.9),('5819','2014-05-03','08:10:00',2.14),('5819','2014-05-03','08:15:00',1.89),('5819','2014-05-03','08:20:00',1.36),('5819','2014-05-03','08:25:00',1.08),('5819','2014-05-03','08:30:00',1.22),('5819','2014-05-03','08:35:00',1.01),('5819','2014-05-03','08:40:00',1.27),('5819','2014-05-03','08:45:00',2.04),('5819','2014-05-03','08:50:00',2.6),('5819','2014-05-03','08:55:00',2.8),('5819','2014-05-03','09:00:00',3.16),('5819','2014-05-03','09:05:00',3.47),('5819','2014-05-03','09:10:00',2.23),('5819','2014-05-03','09:15:00',1.51),('5819','2014-05-03','09:20:00',2.5),('5819','2014-05-03','09:25:00',3.33),('5819','2014-05-03','09:30:00',1.9),('5819','2014-05-03','09:35:00',3.26),('5819','2014-05-03','09:40:00',1.93),('5819','2014-05-03','09:45:00',2.88),('5819','2014-05-03','09:50:00',1.8),('5819','2014-05-03','09:55:00',3.07),('5819','2014-05-03','10:00:00',3.59),('5819','2014-05-03','10:05:00',3.59),('5819','2014-05-03','10:10:00',3.67),('5819','2014-05-03','10:15:00',3.87),('5819','2014-05-03','10:20:00',2.87),('5819','2014-05-03','10:25:00',3.15),('5819','2014-05-03','10:30:00',2.4),('5819','2014-05-03','10:40:00',1.09),('5819','2014-05-03','10:45:00',1.91),('5819','2014-05-03','10:50:00',1.24),('5819','2014-05-03','10:55:00',1.92),('5819','2014-05-03','11:00:00',1.32),('5819','2014-05-03','11:05:00',2.93),('5819','2014-05-03','11:10:00',5),('5819','2014-05-03','11:15:00',1.84),('5819','2014-05-03','11:20:00',2.43),('5819','2014-05-03','11:25:00',3.02),('5819','2014-05-03','11:30:00',4.44),('5819','2014-05-03','11:35:00',2.85),('5819','2014-05-03','11:40:00',2.67),('5819','2014-05-03','11:45:00',2.63),('5819','2014-05-03','11:50:00',2.21),('5819','2014-05-03','11:55:00',2.43),('5819','2014-05-03','12:00:00',2.1),('5819','2014-05-03','12:05:00',1.8),('5819','2014-05-03','12:10:00',1.63),('5819','2014-05-03','12:15:00',1.43),('5819','2014-05-03','12:20:00',1.25),('5819','2014-05-03','12:25:00',1.28),('5819','2014-05-03','12:30:00',1.61),('5819','2014-05-03','12:35:00',1.89),('5819','2014-05-03','12:40:00',1.7),('5819','2014-05-03','12:45:00',1.77),('5819','2014-05-03','12:50:00',1.86),('5819','2014-05-03','12:55:00',1.93),('5819','2014-05-03','13:00:00',1.93),('5819','2014-05-03','13:05:00',1.78),('5819','2014-05-03','13:10:00',2.65),('5819','2014-05-03','13:15:00',2.68),('5819','2014-05-03','13:20:00',2.37),('5819','2014-05-03','13:25:00',2.91),('5819','2014-05-03','13:30:00',2.79),('5819','2014-05-03','13:35:00',2.27),('5819','2014-05-03','13:40:00',1.72),('5819','2014-05-03','13:45:00',1.66),('5819','2014-05-03','13:50:00',1.66),('5819','2014-05-03','13:55:00',1.67),('5819','2014-05-03','14:00:00',1.63),('5819','2014-05-03','14:05:00',1.62),('5819','2014-05-03','14:10:00',1.75),('5819','2014-05-03','14:15:00',1.95),('5819','2014-05-03','14:20:00',2.2),('5819','2014-05-03','14:25:00',2.57),('5819','2014-05-03','14:30:00',2.18),('5819','2014-05-03','14:35:00',1.6),('5819','2014-05-03','14:40:00',1.41),('5819','2013-07-10','07:20:00',1.08),('5819','2013-07-10','07:25:00',1.25),('5819','2013-07-10','07:30:00',1.38),('5819','2013-07-10','07:35:00',1.51),('5819','2013-07-10','07:40:00',1.65),('5819','2013-07-10','07:45:00',1.77),('5819','2013-07-10','07:50:00',1.9),('5819','2013-07-10','07:55:00',2.04),('5819','2013-07-10','08:00:00',2.16),('5819','2013-07-10','08:05:00',1.77),('5819','2013-07-10','08:10:00',1.58),('5819','2013-07-10','08:15:00',1.65),('5819','2013-07-10','08:20:00',1.8),('5819','2013-07-10','08:25:00',2.39),('5819','2013-07-10','08:30:00',2.27),('5819','2013-07-10','08:35:00',2.45),('5819','2013-07-10','08:40:00',2.61),('5819','2013-07-10','08:45:00',2.47),('5819','2013-07-10','08:50:00',2.44),('5819','2013-07-10','08:55:00',2.41),('5819','2013-07-10','09:00:00',2.45),('5819','2013-07-10','09:05:00',2.57),('5819','2013-07-10','09:10:00',2.67),('5819','2013-07-10','09:15:00',2.73),('5819','2013-07-10','09:20:00',2.77),('5819','2013-07-10','09:25:00',2.74),('5819','2013-07-10','09:30:00',2.84),('5819','2013-07-10','09:35:00',2.84),('5819','2013-07-10','09:40:00',2.86),('5819','2013-07-10','09:45:00',2.92),('5819','2013-07-10','09:50:00',2.96),('5819','2013-07-10','09:55:00',3.08),('5819','2013-07-10','10:00:00',2.91),('5819','2013-07-10','10:05:00',3.11),('5819','2013-07-10','10:10:00',3.13),('5819','2013-07-10','10:15:00',3.16),('5819','2013-07-10','10:20:00',3.23),('5819','2013-07-10','10:25:00',3.29),('5819','2013-07-10','10:30:00',3.3),('5819','2013-07-10','10:35:00',3.34),('5819','2013-07-10','10:40:00',3.36),('5819','2013-07-10','10:45:00',3.4),('5819','2013-07-10','10:50:00',3.39),('5819','2013-07-10','10:55:00',3.41),('5819','2013-07-10','11:00:00',3.47),('5819','2013-07-10','11:05:00',3.51),('5819','2013-07-10','11:10:00',3.52),('5819','2013-07-10','11:15:00',3.54),('5819','2013-07-10','11:20:00',3.56),('5819','2013-07-10','11:25:00',3.58),('5819','2013-07-10','11:30:00',3.58),('5819','2013-07-10','11:35:00',3.54),('5819','2013-07-10','11:40:00',3.5),('5819','2013-07-10','11:45:00',3.56),('5819','2013-07-10','11:50:00',3.63),('5819','2013-07-10','11:55:00',3.71),('5819','2013-07-10','12:00:00',3.7),('5819','2013-07-10','12:05:00',3.72),('5819','2013-07-10','12:10:00',3.71),('5819','2013-07-10','12:15:00',3.71),('5819','2013-07-10','12:20:00',3.75),('5819','2013-07-10','12:25:00',3.81),('5819','2013-07-10','12:30:00',3.83),('5819','2013-07-10','12:35:00',3.76),('5819','2013-07-10','12:40:00',3.71),('5819','2013-07-10','12:45:00',3.77),('5819','2013-07-10','12:50:00',3.78),('5819','2013-07-10','12:55:00',3.78),('5819','2013-07-10','13:00:00',3.78),('5819','2013-07-10','13:05:00',3.79),('5819','2013-07-10','13:10:00',3.85),('5819','2013-07-10','13:15:00',3.79),('5819','2013-07-10','13:20:00',3.78),('5819','2013-07-10','13:25:00',3.8),('5819','2013-07-10','13:30:00',3.8),('5819','2013-07-10','13:35:00',3.78),('5819','2013-07-10','13:40:00',3.75),('5819','2013-07-10','13:45:00',3.76),('5819','2013-07-10','13:50:00',3.77),('5819','2013-07-10','13:55:00',3.73),('5819','2013-07-10','14:00:00',3.73),('5819','2013-07-10','14:05:00',3.71),('5819','2013-07-10','14:10:00',3.69),('5819','2013-07-10','14:15:00',3.67),('5819','2013-07-10','14:20:00',3.64),('5819','2013-07-10','14:25:00',3.59),('5819','2013-07-10','14:30:00',3.57),('5819','2013-07-10','14:35:00',3.56),('5819','2013-07-10','14:40:00',3.54),('5819','2013-07-10','14:45:00',3.51),('5819','2013-07-10','14:50:00',3.46),('5819','2013-07-10','14:55:00',3.44),('5819','2013-07-10','15:00:00',3.42),('5819','2013-07-10','15:05:00',3.38),('5819','2013-07-10','15:10:00',3.33),('5819','2013-07-10','15:15:00',3.3),('5819','2013-07-10','15:20:00',3.25),('5819','2013-07-10','15:25:00',3.21),('5819','2013-07-10','15:30:00',3.16),('5819','2013-07-10','15:35:00',3.14),('5819','2013-07-10','15:40:00',3.07),('5819','2013-07-10','15:45:00',3.01),('5819','2013-07-10','15:50:00',2.94),('5819','2013-07-10','15:55:00',2.9),('5819','2013-07-10','16:00:00',2.86),('5819','2013-07-10','16:05:00',2.8),('5819','2013-07-10','16:10:00',2.72),('5819','2013-07-10','16:15:00',2.62),('5819','2013-07-10','16:20:00',2.59),('5819','2013-07-10','16:25:00',2.53),('5819','2013-07-10','16:30:00',2.45),('5819','2013-07-10','16:35:00',2.39),('5819','2013-07-10','16:40:00',2.32),('5819','2013-07-10','16:45:00',2.28),('5819','2013-07-10','16:50:00',2.2),('5819','2013-07-10','16:55:00',2.18),('5819','2013-07-10','17:00:00',2.19),('5819','2013-07-10','17:05:00',1.98),('5819','2013-07-10','17:10:00',1.71),('5819','2013-07-10','17:15:00',1.15),('5819','2013-07-10','17:20:00',1.04),('5819','2013-07-10','17:35:00',1.67),('5819','2013-07-10','17:40:00',1.22),('5819','2013-07-10','17:45:00',1.34),('5819','2013-07-10','17:50:00',1.11),('5819','2013-07-10','17:55:00',1.22),('5819','2013-07-10','18:00:00',1.15),('5819','2013-07-09','07:35:00',1.11),('5819','2013-07-09','07:40:00',1.18),('5819','2013-07-09','07:45:00',1.26),('5819','2013-07-09','07:50:00',1.36),('5819','2013-07-09','07:55:00',1.43),('5819','2013-07-09','08:00:00',1.5),('5819','2013-07-09','08:05:00',1.57),('5819','2013-07-09','08:10:00',1.65),('5819','2013-07-09','08:15:00',1.74),('5819','2013-07-09','08:20:00',1.81),('5819','2013-07-09','08:25:00',1.88),('5819','2013-07-09','08:30:00',1.96),('5819','2013-07-09','08:35:00',2.03),('5819','2013-07-09','08:40:00',2.09),('5819','2013-07-09','08:45:00',2.16),('5819','2013-07-09','08:50:00',2.24),('5819','2013-07-09','08:55:00',2.31),('5819','2013-07-09','09:00:00',2.38),('5819','2013-07-09','09:05:00',2.44),('5819','2013-07-09','09:10:00',2.49),('5819','2013-07-09','09:15:00',2.55),('5819','2013-07-09','09:20:00',2.61),('5819','2013-07-09','09:25:00',2.67),('5819','2013-07-09','09:30:00',2.73),('5819','2013-07-09','09:35:00',2.78),('5819','2013-07-09','09:40:00',2.84),('5819','2013-07-09','09:45:00',2.91),('5819','2013-07-09','09:50:00',2.95),('5819','2013-07-09','09:55:00',3),('5819','2013-07-09','10:00:00',3.03),('5819','2013-07-09','10:05:00',3.07),('5819','2013-07-09','10:10:00',3.13),('5819','2013-07-09','10:15:00',3.18),('5819','2013-07-09','10:20:00',3.23),('5819','2013-07-09','10:25:00',3.27),('5819','2013-07-09','10:30:00',3.26),('5819','2013-07-09','10:35:00',3.29),('5819','2013-07-09','10:40:00',3.31),('5819','2013-07-09','10:45:00',3.36),('5819','2013-07-09','10:50:00',3.39),('5819','2013-07-09','10:55:00',3.46),('5819','2013-07-09','11:00:00',3.5),('5819','2013-07-09','11:05:00',3.3),('5819','2013-07-09','11:10:00',3.13),('5819','2013-07-09','11:15:00',2.98),('5819','2013-07-09','11:20:00',3.08),('5819','2013-07-09','11:25:00',3.15),('5819','2013-07-09','11:30:00',2.12),('5819','2013-07-09','11:35:00',2.46),('5819','2013-07-09','11:40:00',2.71),('5819','2013-07-09','11:45:00',3.64),('5819','2013-07-09','11:50:00',4.23),('5819','2013-07-09','11:55:00',4.17),('5819','2013-07-09','12:00:00',4.17),('5819','2013-07-09','12:05:00',3.89),('5819','2013-07-09','12:10:00',2.81),('5819','2013-07-09','12:15:00',3.85),('5819','2013-07-09','12:20:00',3.78),('5819','2013-07-09','12:25:00',3.71),('5819','2013-07-09','12:30:00',3.67),('5819','2013-07-09','12:35:00',3.7),('5819','2013-07-09','12:40:00',3.71),('5819','2013-07-09','12:45:00',3.67),('5819','2013-07-09','12:50:00',3.71),('5819','2013-07-09','12:55:00',3.74),('5819','2013-07-09','13:00:00',3.74),('5819','2013-07-09','13:05:00',3.53),('5819','2013-07-09','13:10:00',3.87),('5819','2013-07-09','13:15:00',3.92),('5819','2013-07-09','13:20:00',3.87),('5819','2013-07-09','13:25:00',3.92),('5819','2013-07-09','13:30:00',3.97),('5819','2013-07-09','13:35:00',3.74),('5819','2013-07-09','13:40:00',3.69),('5819','2013-07-09','13:45:00',3.1),('5819','2013-07-09','13:50:00',2.91),('5819','2013-07-09','13:55:00',2.91),('5819','2013-07-09','14:00:00',2.85),('5819','2013-07-09','14:05:00',2.84),('5819','2013-07-09','14:10:00',3.13),('5819','2013-07-09','14:15:00',3.13),('5819','2013-07-09','14:20:00',2.39),('5819','2013-07-09','14:25:00',1.88),('5819','2013-07-09','14:30:00',1.24),('5819','2013-07-08','07:35:00',1.12),('5819','2013-07-08','07:40:00',1.48),('5819','2013-07-08','07:45:00',1.32),('5819','2013-07-08','07:50:00',1.26),('5819','2013-07-08','07:55:00',1.24),('5819','2013-07-08','08:00:00',1.25),('5819','2013-07-08','08:05:00',1.27),('5819','2013-07-08','08:10:00',1.53),('5819','2013-07-08','08:15:00',1.69),('5819','2013-07-08','08:20:00',1.81),('5819','2013-07-08','08:25:00',1.9),('5819','2013-07-08','08:30:00',1.97),('5819','2013-07-08','08:35:00',2.04),('5819','2013-07-08','08:40:00',2.1),('5819','2013-07-08','08:45:00',2.16),('5819','2013-07-08','08:50:00',2.22),('5819','2013-07-08','08:55:00',2.3),('5819','2013-07-08','09:00:00',2.36),('5819','2013-07-08','09:05:00',2.42),('5819','2013-07-08','09:10:00',2.48),('5819','2013-07-08','09:15:00',2.53),('5819','2013-07-08','09:20:00',2.59),('5819','2013-07-08','09:25:00',2.61),('5819','2013-07-08','09:30:00',2.73),('5819','2013-07-08','09:35:00',2.84),('5819','2013-07-08','09:40:00',2.88),('5819','2013-07-08','09:45:00',2.89),('5819','2013-07-08','09:50:00',2.89),('5819','2013-07-08','09:55:00',2.99),('5819','2013-07-08','10:00:00',3.05),('5819','2013-07-08','10:05:00',3.08),('5819','2013-07-08','10:10:00',3.08),('5819','2013-07-08','10:15:00',3.15),('5819','2013-07-08','10:20:00',3.18),('5819','2013-07-08','10:25:00',3.24),('5819','2013-07-08','10:30:00',3.17),('5819','2013-07-08','10:35:00',3.33),('5819','2013-07-08','10:40:00',3.32),('5819','2013-07-08','10:45:00',3.33),('5819','2013-07-08','10:50:00',3.35),('5819','2013-07-08','10:55:00',3.36),('5819','2013-07-08','11:00:00',3.4),('5819','2013-07-08','11:05:00',3.44),('5819','2013-07-08','11:10:00',3.51),('5819','2013-07-08','11:15:00',3.58),('5819','2013-07-08','11:20:00',3.65),('5819','2013-07-08','11:25:00',3.69),('5819','2013-07-08','11:30:00',3.73),('5819','2013-07-08','11:35:00',3.73),('5819','2013-07-08','11:40:00',3.49),('5819','2013-07-08','11:45:00',3.76),('5819','2013-07-08','11:50:00',3.73),('5819','2013-07-08','11:55:00',3.71),('5819','2013-07-08','12:00:00',3.71),('5819','2013-07-08','12:05:00',3.76),('5819','2013-07-08','12:10:00',3.83),('5819','2013-07-08','12:15:00',3.85),('5819','2013-07-08','12:20:00',3.96),('5819','2013-07-08','12:25:00',3.82),('5819','2013-07-08','12:30:00',3.67),('5819','2013-07-08','12:35:00',3.83),('5819','2013-07-08','12:40:00',3.81),('5819','2013-07-08','12:45:00',3.83),('5819','2013-07-08','12:50:00',3.84),('5819','2013-07-08','12:55:00',3.9),('5819','2013-07-08','13:00:00',3.6),('5819','2013-07-08','13:05:00',4.05),('5819','2013-07-08','13:10:00',4.3),('5819','2013-07-08','13:15:00',3.28),('5819','2013-07-08','13:20:00',2.28),('5819','2013-07-08','13:25:00',1.07),('5819','2013-07-08','14:35:00',1),('5819','2013-07-08','14:40:00',1.01),('5819','2013-07-07','07:25:00',1.06),('5819','2013-07-07','07:30:00',1.14),('5819','2013-07-07','07:35:00',1.21),('5819','2013-07-07','07:40:00',1.29),('5819','2013-07-07','07:45:00',1.38),('5819','2013-07-07','07:50:00',1.46),('5819','2013-07-07','07:55:00',1.54),('5819','2013-07-07','08:00:00',1.63),('5819','2013-07-07','08:05:00',1.71),('5819','2013-07-07','08:10:00',1.8),('5819','2013-07-07','08:15:00',1.62),('5819','2013-07-07','08:20:00',1.52),('5819','2013-07-07','08:25:00',1.6),('5819','2013-07-07','08:30:00',2.06),('5819','2013-07-07','08:35:00',2.02),('5819','2013-07-07','08:40:00',1.02),('5819','2013-07-07','08:45:00',1.18),('5819','2013-07-07','08:50:00',2.17),('5819','2013-07-07','08:55:00',2.52),('5819','2013-07-07','09:00:00',2.5),('5819','2013-07-07','09:05:00',2.28),('5819','2013-07-07','09:10:00',2.26),('5819','2013-07-07','09:15:00',2.2),('5819','2013-07-07','09:20:00',1.76),('5819','2013-07-07','09:25:00',2.31),('5819','2013-07-07','09:30:00',2.77),('5819','2013-07-07','09:35:00',2.88),('5819','2013-07-07','09:40:00',2.66),('5819','2013-07-07','09:45:00',3.18),('5819','2013-07-07','09:50:00',3.16),('5819','2013-07-07','09:55:00',3.22),('5819','2013-07-07','10:00:00',3.21),('5819','2013-07-07','10:05:00',3.04),('5819','2013-07-07','10:10:00',3.18),('5819','2013-07-07','10:15:00',2.97),('5819','2013-07-07','10:20:00',3.22),('5819','2013-07-07','10:25:00',3.1),('5819','2013-07-07','10:30:00',3.07),('5819','2013-07-07','10:35:00',3.54),('5819','2013-07-07','10:40:00',3.25),('5819','2013-07-07','10:45:00',3.53),('5819','2013-07-07','10:50:00',3.56),('5819','2013-07-07','10:55:00',3.53),('5819','2013-07-07','11:00:00',3.55),('5819','2013-07-07','11:05:00',3.59),('5819','2013-07-07','11:10:00',3.65),('5819','2013-07-07','11:15:00',3.51),('5819','2013-07-07','11:20:00',3.45),('5819','2013-07-07','11:25:00',3.13),('5819','2013-07-07','11:30:00',3.27),('5819','2013-07-07','11:35:00',3.22),('5819','2013-07-07','11:40:00',3.21),('5819','2013-07-07','11:45:00',2.75),('5819','2013-07-07','11:50:00',2.57),('5819','2013-07-07','11:55:00',1.94),('5819','2013-07-07','12:00:00',2.9),('5819','2013-07-07','12:05:00',3.64),('5819','2013-07-07','12:10:00',3.66),('5819','2013-07-07','12:15:00',3.91),('5819','2013-07-07','12:20:00',3.78),('5819','2013-07-07','12:25:00',3.57),('5819','2013-07-07','12:30:00',3.63),('5819','2013-07-07','12:35:00',3.84),('5819','2013-07-07','12:40:00',3.93),('5819','2013-07-07','12:45:00',3.9),('5819','2013-07-07','12:50:00',3.82),('5819','2013-07-07','12:55:00',3.98),('5819','2013-07-07','13:00:00',3.91),('5819','2013-07-07','13:05:00',3.89),('5819','2013-07-07','13:10:00',3.89),('5819','2013-07-07','13:15:00',3.82),('5819','2013-07-07','13:20:00',3.82),('5819','2013-07-07','13:25:00',3.71),('5819','2013-07-07','13:30:00',3.6),('5819','2013-07-07','13:35:00',3.9),('5819','2013-07-07','13:40:00',2.66),('5819','2013-07-07','13:45:00',4.12),('5819','2013-07-07','13:50:00',4.08),('5819','2013-07-07','13:55:00',3.58),('5819','2013-07-07','14:00:00',3.21),('5819','2013-07-07','14:05:00',3.38),('5819','2013-07-07','14:10:00',2.1),('5819','2013-07-07','14:15:00',1.72),('5819','2013-07-07','14:20:00',1.09),('5819','2013-07-07','15:05:00',1),('5819','2013-07-06','07:25:00',1),('5819','2013-07-06','07:30:00',1.08),('5819','2013-07-06','07:35:00',1.14),('5819','2013-07-06','07:40:00',1.22),('5819','2013-07-06','07:45:00',1.31),('5819','2013-07-06','07:50:00',1.4),('5819','2013-07-06','07:55:00',1.48),('5819','2013-07-06','08:00:00',1.56),('5819','2013-07-06','08:05:00',1.64),('5819','2013-07-06','08:10:00',1.72),('5819','2013-07-06','08:15:00',1.79),('5819','2013-07-06','08:20:00',1.86),('5819','2013-07-06','08:25:00',1.94),('5819','2013-07-06','08:30:00',2.01),('5819','2013-07-06','08:35:00',2.08),('5819','2013-07-06','08:40:00',2.15),('5819','2013-07-06','08:45:00',2.21),('5819','2013-07-06','08:50:00',2.28),('5819','2013-07-06','08:55:00',2.35),('5819','2013-07-06','09:00:00',2.42),('5819','2013-07-06','09:05:00',2.48),('5819','2013-07-06','09:10:00',2.55),('5819','2013-07-06','09:15:00',2.62),('5819','2013-07-06','09:20:00',2.68),('5819','2013-07-06','09:25:00',2.73),('5819','2013-07-06','09:30:00',2.77),('5819','2013-07-06','09:35:00',2.81),('5819','2013-07-06','09:40:00',2.86),('5819','2013-07-06','09:45:00',2.91),('5819','2013-07-06','09:50:00',2.97),('5819','2013-07-06','09:55:00',3.04),('5819','2013-07-06','10:00:00',3.08),('5819','2013-07-06','10:05:00',3.15),('5819','2013-07-06','10:10:00',3.2),('5819','2013-07-06','10:15:00',3.23),('5819','2013-07-06','10:20:00',3.26),('5819','2013-07-06','10:25:00',3.3),('5819','2013-07-06','10:30:00',3.34),('5819','2013-07-06','10:35:00',3.36),('5819','2013-07-06','10:40:00',3.39),('5819','2013-07-06','10:45:00',3.44),('5819','2013-07-06','10:50:00',3.51),('5819','2013-07-06','10:55:00',3.53),('5819','2013-07-06','11:00:00',3.55),('5819','2013-07-06','11:05:00',3.58),('5819','2013-07-06','11:10:00',3.59),('5819','2013-07-06','11:15:00',3.57),('5819','2013-07-06','11:20:00',3.63),('5819','2013-07-06','11:25:00',3.66),('5819','2013-07-06','11:30:00',3.64),('5819','2013-07-06','11:35:00',3.66),('5819','2013-07-06','11:40:00',3.65),('5819','2013-07-06','11:45:00',3.68),('5819','2013-07-06','11:50:00',3.7),('5819','2013-07-06','11:55:00',3.69),('5819','2013-07-06','12:00:00',3.72),('5819','2013-07-06','12:05:00',3.76),('5819','2013-07-06','12:10:00',3.8),('5819','2013-07-06','12:15:00',3.8),('5819','2013-07-06','12:20:00',3.83),('5819','2013-07-06','12:25:00',3.79),('5819','2013-07-06','12:30:00',3.84),('5819','2013-07-06','12:35:00',3.8),('5819','2013-07-06','12:40:00',3.83),('5819','2013-07-06','12:45:00',3.84),('5819','2013-07-06','12:50:00',3.82),('5819','2013-07-06','12:55:00',3.84),('5819','2013-07-06','13:00:00',3.85),('5819','2013-07-06','13:05:00',3.87),('5819','2013-07-06','13:10:00',3.89),('5819','2013-07-06','13:15:00',3.88),('5819','2013-07-06','13:20:00',3.84),('5819','2013-07-06','13:25:00',3.8),('5819','2013-07-06','13:30:00',3.83),('5819','2013-07-06','13:35:00',3.75),('5819','2013-07-06','13:40:00',3.78),('5819','2013-07-06','13:45:00',3.77),('5819','2013-07-06','13:50:00',3.7),('5819','2013-07-06','13:55:00',3.72),('5819','2013-07-06','14:00:00',3.74),('5819','2013-07-06','14:05:00',3.73),('5819','2013-07-06','14:10:00',3.67),('5819','2013-07-06','14:15:00',3.48),('5819','2013-07-06','14:20:00',3.74),('5819','2013-07-06','14:25:00',3.63),('5819','2013-07-06','14:30:00',3.57),('5819','2013-07-06','14:35:00',3.58),('5819','2013-07-06','14:40:00',3.53),('5819','2013-07-06','14:45:00',3.51),('5819','2013-07-06','14:50:00',3.43),('5819','2013-07-06','14:55:00',3.1),('5819','2013-07-06','15:00:00',3.46),('5819','2013-07-06','15:05:00',3.41),('5819','2013-07-06','15:10:00',3.38),('5819','2013-07-06','15:15:00',3.33),('5819','2013-07-06','15:20:00',3.32),('5819','2013-07-06','15:25:00',3.3),('5819','2013-07-06','15:30:00',2.94),('5819','2013-07-06','15:35:00',1.17),('5819','2013-07-06','16:55:00',1.11),('5819','2013-07-05','07:25:00',1.03),('5819','2013-07-05','07:30:00',1.05),('5819','2013-07-05','07:35:00',1.17),('5819','2013-07-05','07:40:00',1.24),('5819','2013-07-05','07:45:00',1.31),('5819','2013-07-05','07:50:00',1.4),('5819','2013-07-05','07:55:00',1.47),('5819','2013-07-05','08:00:00',1.58),('5819','2013-07-05','08:05:00',1.67),('5819','2013-07-05','08:10:00',1.73),('5819','2013-07-05','08:15:00',1.81),('5819','2013-07-05','08:20:00',1.87),('5819','2013-07-05','08:25:00',1.94),('5819','2013-07-05','08:30:00',2.01),('5819','2013-07-05','08:35:00',2.08),('5819','2013-07-05','08:40:00',2.15),('5819','2013-07-05','08:45:00',2.21),('5819','2013-07-05','08:50:00',2.29),('5819','2013-07-05','08:55:00',2.34),('5819','2013-07-05','09:00:00',2.41),('5819','2013-07-05','09:05:00',2.46),('5819','2013-07-05','09:10:00',2.51),('5819','2013-07-05','09:15:00',2.57),('5819','2013-07-05','09:20:00',2.65),('5819','2013-07-05','09:25:00',2.72),('5819','2013-07-05','09:30:00',2.78),('5819','2013-07-05','09:35:00',2.84),('5819','2013-07-05','09:40:00',2.89),('5819','2013-07-05','09:45:00',2.93),('5819','2013-07-05','09:50:00',2.97),('5819','2013-07-05','09:55:00',3.02),('5819','2013-07-05','10:00:00',3.06),('5819','2013-07-05','10:05:00',3.1),('5819','2013-07-05','10:10:00',3.15),('5819','2013-07-05','10:15:00',3.2),('5819','2013-07-05','10:20:00',3.23),('5819','2013-07-05','10:25:00',3.26),('5819','2013-07-05','10:30:00',3.3),('5819','2013-07-05','10:35:00',3.34),('5819','2013-07-05','10:40:00',3.35),('5819','2013-07-05','10:45:00',3.38),('5819','2013-07-05','10:50:00',3.41),('5819','2013-07-05','10:55:00',3.44),('5819','2013-07-05','11:00:00',3.47),('5819','2013-07-05','11:05:00',3.48),('5819','2013-07-05','11:10:00',3.52),('5819','2013-07-05','11:15:00',3.54),('5819','2013-07-05','11:20:00',3.56),('5819','2013-07-05','11:25:00',3.59),('5819','2013-07-05','11:30:00',3.63),('5819','2013-07-05','11:35:00',3.64),('5819','2013-07-05','11:40:00',3.62),('5819','2013-07-05','11:45:00',3.62),('5819','2013-07-05','11:50:00',3.7),('5819','2013-07-05','11:55:00',3.68),('5819','2013-07-05','12:00:00',3.68),('5819','2013-07-05','12:05:00',3.68),('5819','2013-07-05','12:10:00',3.68),('5819','2013-07-05','12:15:00',3.73),('5819','2013-07-05','12:20:00',3.75),('5819','2013-07-05','12:25:00',2.4),('5819','2013-07-05','12:30:00',3.56),('5819','2013-07-05','12:35:00',2.81),('5819','2013-07-05','12:40:00',3.77),('5819','2013-07-05','12:45:00',3.89),('5819','2013-07-05','12:50:00',3.68),('5819','2013-07-05','12:55:00',3.42),('5819','2013-07-05','13:00:00',3.81),('5819','2013-07-05','13:05:00',2.6),('5819','2013-07-05','13:10:00',3.89),('5819','2013-07-05','13:15:00',3.49),('5819','2013-07-05','13:20:00',3.43),('5819','2013-07-05','13:25:00',3.69),('5819','2013-07-05','13:30:00',3.5),('5819','2013-07-05','13:35:00',3.83),('5819','2013-07-05','13:40:00',3.84),('5819','2013-07-05','13:45:00',3.75),('5819','2013-07-05','13:50:00',3.7),('5819','2013-07-05','13:55:00',3.75),('5819','2013-07-05','14:00:00',3.74),('5819','2013-07-05','14:05:00',3.33),('5819','2013-07-05','14:10:00',3.2),('5819','2013-07-05','14:15:00',3.67),('5819','2013-07-05','14:20:00',3.51),('5819','2013-07-05','14:25:00',3.62),('5819','2013-07-05','14:30:00',3.51),('5819','2013-07-05','14:35:00',3.38),('5819','2013-07-05','14:40:00',3.51),('5819','2013-07-05','14:45:00',3.01),('5819','2013-07-05','14:50:00',3.43),('5819','2013-07-05','14:55:00',3.37),('5819','2013-07-05','15:00:00',3.19),('5819','2013-07-05','15:05:00',3.35),('5819','2013-07-05','15:10:00',3.36),('5819','2013-07-05','15:15:00',2.77),('5819','2013-07-05','15:20:00',2.51),('5819','2013-07-05','15:25:00',2.42),('5819','2013-07-05','15:30:00',3.01),('5819','2013-07-05','15:35:00',3.15),('5819','2013-07-05','15:40:00',3.05),('5819','2013-07-05','15:45:00',3.06),('5819','2013-07-05','15:50:00',3),('5819','2013-07-05','15:55:00',2.87),('5819','2013-07-05','16:00:00',2.79),('5819','2013-07-05','16:05:00',2.78),('5819','2013-07-05','16:10:00',2.7),('5819','2013-07-05','16:15:00',2.63),('5819','2013-07-05','16:20:00',2.6),('5819','2013-07-05','16:25:00',2.52),('5819','2013-07-05','16:30:00',2.46),('5819','2013-07-05','16:35:00',2.39),('5819','2013-07-05','16:40:00',2.33),('5819','2013-07-05','16:45:00',2.3),('5819','2013-07-05','16:50:00',2.18),('5819','2013-07-05','16:55:00',1.97),('5819','2013-07-05','17:00:00',2.02),('5819','2013-07-05','17:05:00',1.99),('5819','2013-07-05','17:10:00',1.97),('5819','2013-07-05','17:15:00',1.94),('5819','2013-07-05','17:20:00',1.87),('5819','2013-07-05','17:25:00',1.76),('5819','2013-07-05','17:30:00',1.65),('5819','2013-07-05','17:35:00',1.53),('5819','2013-07-05','17:40:00',1.43),('5819','2013-07-05','17:45:00',1.32),('5819','2013-07-05','17:50:00',1.19),('5819','2013-07-05','17:55:00',1.16),('5819','2013-07-05','18:00:00',1.15),('5819','2013-07-05','18:05:00',1.06),('5819','2013-07-04','11:15:00',1.01),('5819','2013-07-04','11:35:00',1.14),('5819','2013-07-04','11:40:00',1.32),('5819','2013-07-04','11:45:00',1.52),('5819','2013-07-04','11:50:00',1.63),('5819','2013-07-04','11:55:00',1.49),('5819','2013-07-04','12:00:00',1.44),('5819','2013-07-04','12:05:00',1.41),('5819','2013-07-04','12:10:00',2.02),('5819','2013-07-04','12:15:00',2.76),('5819','2013-07-04','12:20:00',2.48),('5819','2013-07-04','12:25:00',2.9),('5819','2013-07-04','12:30:00',2.85),('5819','2013-07-04','12:35:00',2.19),('5819','2013-07-04','12:40:00',1.64),('5819','2013-07-04','12:45:00',1.32),('5819','2013-07-04','12:50:00',1.05),('5819','2013-07-04','13:10:00',1.25),('5819','2013-07-04','13:15:00',1.44),('5819','2013-07-04','13:20:00',1.66),('5819','2013-07-04','13:25:00',1.93),('5819','2013-07-04','13:30:00',1.79),('5819','2013-07-04','13:35:00',1.88),('5819','2013-07-04','13:40:00',2.23),('5819','2013-07-04','13:45:00',2.01),('5819','2013-07-04','13:50:00',2.82),('5819','2013-07-04','13:55:00',2.51),('5819','2013-07-04','14:00:00',2.03),('5819','2013-07-04','14:05:00',1.97),('5819','2013-07-04','14:10:00',1.94),('5819','2013-07-04','14:15:00',1.99),('5819','2013-07-04','14:20:00',2.04),('5819','2013-07-04','14:25:00',1.74),('5819','2013-07-04','14:30:00',1.66),('5819','2013-07-04','14:35:00',1.7),('5819','2013-07-04','14:40:00',2.84),('5819','2013-07-04','14:45:00',4.05),('5819','2013-07-04','14:50:00',2.16),('5819','2013-07-04','14:55:00',2.23),('5819','2013-07-04','15:00:00',3.97),('5819','2013-07-04','15:05:00',3.55),('5819','2013-07-04','15:10:00',2.61),('5819','2013-07-04','15:15:00',3.82),('5819','2013-07-04','15:20:00',3.65),('5819','2013-07-04','15:25:00',3.58),('5819','2013-07-04','15:30:00',2.39),('5819','2013-07-04','15:35:00',2.64),('5819','2013-07-04','15:40:00',2.73),('5819','2013-07-04','15:45:00',2.71),('5819','2013-07-04','15:50:00',2.01),('5819','2013-07-04','15:55:00',2.14),('5819','2013-07-04','16:00:00',2.22),('5819','2013-07-04','16:05:00',1.92),('5819','2013-07-04','16:10:00',1.82),('5819','2013-07-04','16:15:00',1.68),('5819','2013-07-04','16:20:00',1.69),('5819','2013-07-04','16:25:00',1.75),('5819','2013-07-04','16:30:00',1.77),('5819','2013-07-04','16:35:00',1.72),('5819','2013-07-04','16:40:00',1.41),('5819','2013-07-04','16:45:00',1.33),('5819','2013-07-04','16:50:00',1.4),('5819','2013-07-04','16:55:00',1.35),('5819','2013-07-04','17:00:00',1.19),('5819','2013-07-04','17:05:00',1.13),('5819','2013-07-04','17:10:00',1.75),('5819','2013-07-04','17:15:00',2.09),('5819','2013-07-04','17:20:00',2.13),('5819','2013-07-04','17:25:00',2.01),('5819','2013-07-04','17:30:00',1.7),('5819','2013-07-04','17:35:00',1.66),('5819','2013-07-04','17:40:00',1.79),('5819','2013-07-04','17:45:00',1.69),('5819','2013-07-04','17:50:00',1.52),('5819','2013-07-04','17:55:00',1.44),('5819','2013-07-04','18:00:00',1.47),('5819','2013-07-04','18:05:00',1.43),('5819','2013-07-04','18:10:00',1.38),('5819','2013-07-04','18:15:00',1.31),('5819','2013-07-04','18:20:00',1.06),('5819','2013-07-04','18:25:00',1),('5819','2013-07-03','07:20:00',1.01),('5819','2013-07-03','07:25:00',1.08),('5819','2013-07-03','07:30:00',1.16),('5819','2013-07-03','07:35:00',1.24),('5819','2013-07-03','07:40:00',1.32),('5819','2013-07-03','07:45:00',1.42),('5819','2013-07-03','07:50:00',1.5),('5819','2013-07-03','07:55:00',1.58),('5819','2013-07-03','08:00:00',1.66),('5819','2013-07-03','08:05:00',1.74),('5819','2013-07-03','08:10:00',1.8),('5819','2013-07-03','08:15:00',1.88),('5819','2013-07-03','08:20:00',1.96),('5819','2013-07-03','08:25:00',2.03),('5819','2013-07-03','08:30:00',2.12),('5819','2013-07-03','08:35:00',2.19),('5819','2013-07-03','08:40:00',2.26),('5819','2013-07-03','08:45:00',2.33),('5819','2013-07-03','08:50:00',2.4),('5819','2013-07-03','08:55:00',2.46),('5819','2013-07-03','09:00:00',2.5),('5819','2013-07-03','09:05:00',2.57),('5819','2013-07-03','09:10:00',2.63),('5819','2013-07-03','09:15:00',2.67),('5819','2013-07-03','09:20:00',2.73),('5819','2013-07-03','09:25:00',2.78),('5819','2013-07-03','09:30:00',2.84),('5819','2013-07-03','09:35:00',2.86),('5819','2013-07-03','09:40:00',2.9),('5819','2013-07-03','09:45:00',2.99),('5819','2013-07-03','09:50:00',3.04),('5819','2013-07-03','09:55:00',3.06),('5819','2013-07-03','10:00:00',3.12),('5819','2013-07-03','10:05:00',3.15),('5819','2013-07-03','10:10:00',3.12),('5819','2013-07-03','10:15:00',3.17),('5819','2013-07-03','10:20:00',3.17),('5819','2013-07-03','10:25:00',3.28),('5819','2013-07-03','10:30:00',3.36),('5819','2013-07-03','10:35:00',3.35),('5819','2013-07-03','10:40:00',3.38),('5819','2013-07-03','10:45:00',3.45),('5819','2013-07-03','10:50:00',3.49),('5819','2013-07-03','10:55:00',3.49),('5819','2013-07-03','11:00:00',3.53),('5819','2013-07-03','11:05:00',3.54),('5819','2013-07-03','11:10:00',3.57),('5819','2013-07-03','11:15:00',3.63),('5819','2013-07-03','11:20:00',3.66),('5819','2013-07-03','11:25:00',3.68),('5819','2013-07-03','11:30:00',3.67),('5819','2013-07-03','11:35:00',3.68),('5819','2013-07-03','11:40:00',3.67),('5819','2013-07-03','11:45:00',3.74),('5819','2013-07-03','11:50:00',3.79),('5819','2013-07-03','11:55:00',3.79),('5819','2013-07-03','12:00:00',3.83),('5819','2013-07-03','12:05:00',3.87),('5819','2013-07-03','12:10:00',3.81),('5819','2013-07-03','12:15:00',3.87),('5819','2013-07-03','12:20:00',3.88),('5819','2013-07-03','12:25:00',3.87),('5819','2013-07-03','12:30:00',3.87),('5819','2013-07-03','12:35:00',3.9),('5819','2013-07-03','12:40:00',3.9),('5819','2013-07-03','12:45:00',3.85),('5819','2013-07-03','12:50:00',3.88),('5819','2013-07-03','12:55:00',3.87),('5819','2013-07-03','13:00:00',3.91),('5819','2013-07-03','13:05:00',3.93),('5819','2013-07-03','13:10:00',3.92),('5819','2013-07-03','13:15:00',3.9),('5819','2013-07-03','13:20:00',3.9),('5819','2013-07-03','13:25:00',3.86),('5819','2013-07-03','13:30:00',3.87),('5819','2013-07-03','13:35:00',3.82),('5819','2013-07-03','13:40:00',3.82),('5819','2013-07-03','13:45:00',3.82),('5819','2013-07-03','13:50:00',3.8),('5819','2013-07-03','13:55:00',3.75),('5819','2013-07-03','14:00:00',3.74),('5819','2013-07-03','14:05:00',3.71),('5819','2013-07-03','14:10:00',3.69),('5819','2013-07-03','14:15:00',3.68),('5819','2013-07-03','14:20:00',3.7),('5819','2013-07-03','14:25:00',3.66),('5819','2013-07-03','14:30:00',3.65),('5819','2013-07-03','14:35:00',3.61),('5819','2013-07-03','14:40:00',3.57),('5819','2013-07-03','14:45:00',3.54),('5819','2013-07-03','14:50:00',3.51),('5819','2013-07-03','14:55:00',3.47),('5819','2013-07-03','15:00:00',3.45),('5819','2013-07-03','15:05:00',3.43),('5819','2013-07-03','15:10:00',3.38),('5819','2013-07-03','15:15:00',3.33),('5819','2013-07-03','15:20:00',3.28),('5819','2013-07-03','15:25:00',3.24),('5819','2013-07-03','15:30:00',3.21),('5819','2013-07-03','15:35:00',3.16),('5819','2013-07-03','15:40:00',3.1),('5819','2013-07-03','15:45:00',3.05),('5819','2013-07-03','15:50:00',3),('5819','2013-07-03','15:55:00',2.95),('5819','2013-07-03','16:00:00',2.88),('5819','2013-07-03','16:05:00',2.82),('5819','2013-07-03','16:10:00',2.77),('5819','2013-07-03','16:15:00',2.7),('5819','2013-07-03','16:20:00',2.64),('5819','2013-07-03','16:25:00',2.58),('5819','2013-07-03','16:30:00',2.52),('5819','2013-07-03','16:35:00',2.45),('5819','2013-07-03','16:40:00',2.39),('5819','2013-07-03','16:45:00',2.33),('5819','2013-07-03','16:50:00',2.26),('5819','2013-07-03','16:55:00',2.19),('5819','2013-07-03','17:00:00',2.11),('5819','2013-07-03','17:05:00',2.04),('5819','2013-07-03','17:10:00',1.97),('5819','2013-07-03','17:15:00',1.89),('5819','2013-07-03','17:20:00',1.82),('5819','2013-07-03','17:25:00',1.74),('5819','2013-07-03','17:30:00',1.66),('5819','2013-07-03','17:35:00',1.58),('5819','2013-07-03','17:40:00',1.51),('5819','2013-07-03','17:45:00',1.42),('5819','2013-07-03','17:50:00',1.17),('5819','2013-07-03','17:55:00',1.16),('5819','2013-07-03','18:00:00',1.14),('5819','2013-07-03','18:05:00',1.05),('5819','2013-07-02','07:25:00',1.04),('5819','2013-07-02','07:30:00',1.12),('5819','2013-07-02','07:35:00',1.2),('5819','2013-07-02','07:40:00',1.29),('5819','2013-07-02','07:45:00',1.38),('5819','2013-07-02','07:50:00',1.45),('5819','2013-07-02','07:55:00',1.53),('5819','2013-07-02','08:00:00',1.61),('5819','2013-07-02','08:05:00',1.7),('5819','2013-07-02','08:10:00',1.79),('5819','2013-07-02','08:15:00',1.86),('5819','2013-07-02','08:20:00',1.93),('5819','2013-07-02','08:25:00',2.02),('5819','2013-07-02','08:30:00',2.08),('5819','2013-07-02','08:35:00',2.14),('5819','2013-07-02','08:40:00',2.21),('5819','2013-07-02','08:45:00',2.29),('5819','2013-07-02','08:50:00',2.34),('5819','2013-07-02','08:55:00',2.39),('5819','2013-07-02','09:00:00',2.46),('5819','2013-07-02','09:05:00',2.54),('5819','2013-07-02','09:10:00',2.61),('5819','2013-07-02','09:15:00',2.67),('5819','2013-07-02','09:20:00',2.73),('5819','2013-07-02','09:25:00',2.78),('5819','2013-07-02','09:30:00',2.84),('5819','2013-07-02','09:35:00',2.87),('5819','2013-07-02','09:40:00',2.91),('5819','2013-07-02','09:45:00',2.96),('5819','2013-07-02','09:50:00',3),('5819','2013-07-02','09:55:00',3.05),('5819','2013-07-02','10:00:00',3.11),('5819','2013-07-02','10:05:00',3.18),('5819','2013-07-02','10:10:00',3.19),('5819','2013-07-02','10:15:00',3.21),('5819','2013-07-02','10:20:00',3.24),('5819','2013-07-02','10:25:00',3.28),('5819','2013-07-02','10:30:00',3.33),('5819','2013-07-02','10:35:00',3.38),('5819','2013-07-02','10:40:00',3.41),('5819','2013-07-02','10:45:00',3.43),('5819','2013-07-02','10:50:00',3.44),('5819','2013-07-02','10:55:00',3.44),('5819','2013-07-02','11:00:00',3.47),('5819','2013-07-02','11:05:00',3.47),('5819','2013-07-02','11:10:00',3.49),('5819','2013-07-02','11:15:00',3.5),('5819','2013-07-02','11:20:00',3.51),('5819','2013-07-02','11:25:00',3.53),('5819','2013-07-02','11:30:00',3.57),('5819','2013-07-02','11:35:00',3.62),('5819','2013-07-02','11:40:00',3.63),('5819','2013-07-02','11:45:00',3.59),('5819','2013-07-02','11:50:00',3.59),('5819','2013-07-02','11:55:00',3.63),('5819','2013-07-02','12:00:00',3.62),('5819','2013-07-02','12:05:00',3.55),('5819','2013-07-02','12:10:00',3.7),('5819','2013-07-02','12:15:00',3.66),('5819','2013-07-02','12:20:00',3.63),('5819','2013-07-02','12:25:00',3.55),('5819','2013-07-02','12:30:00',3.66),('5819','2013-07-02','12:35:00',3.75),('5819','2013-07-02','12:40:00',3.82),('5819','2013-07-02','12:45:00',3.84),('5819','2013-07-02','12:50:00',3.85),('5819','2013-07-02','12:55:00',1.76),('5819','2013-07-02','13:00:00',3.16),('5819','2013-07-02','13:05:00',1.27),('5819','2013-07-02','13:10:00',4),('5819','2013-07-02','13:15:00',3.99),('5819','2013-07-02','13:20:00',3.91),('5819','2013-07-02','13:25:00',3.99),('5819','2013-07-02','13:30:00',3.9),('5819','2013-07-02','13:35:00',3.84),('5819','2013-07-02','13:40:00',3.86),('5819','2013-07-02','13:45:00',3.6),('5819','2013-07-02','13:50:00',3.57),('5819','2013-07-02','13:55:00',3.64),('5819','2013-07-02','14:00:00',3.61),('5819','2013-07-02','14:05:00',3.59),('5819','2013-07-02','14:10:00',3.57),('5819','2013-07-02','14:15:00',3.58),('5819','2013-07-02','14:20:00',3.57),('5819','2013-07-02','14:25:00',3.54),('5819','2013-07-02','14:30:00',3.52),('5819','2013-07-02','14:35:00',3.52),('5819','2013-07-02','14:40:00',3.47),('5819','2013-07-02','14:45:00',3.44),('5819','2013-07-02','14:50:00',3.41),('5819','2013-07-02','14:55:00',3.38),('5819','2013-07-02','15:00:00',3.34),('5819','2013-07-02','15:05:00',3.33),('5819','2013-07-02','15:10:00',3.3),('5819','2013-07-02','15:15:00',3.24),('5819','2013-07-02','15:20:00',3.21),('5819','2013-07-02','15:25:00',3.18),('5819','2013-07-02','15:30:00',3.14),('5819','2013-07-02','15:35:00',3.09),('5819','2013-07-02','15:40:00',3.05),('5819','2013-07-02','15:45:00',2.98),('5819','2013-07-02','15:50:00',2.92),('5819','2013-07-02','15:55:00',2.86),('5819','2013-07-02','16:00:00',2.82),('5819','2013-07-02','16:05:00',2.77),('5819','2013-07-02','16:10:00',2.71),('5819','2013-07-02','16:15:00',2.65),('5819','2013-07-02','16:20:00',2.59),('5819','2013-07-02','16:25:00',2.52),('5819','2013-07-02','16:30:00',2.46),('5819','2013-07-02','16:35:00',2.38),('5819','2013-07-02','16:40:00',2.31),('5819','2013-07-02','16:45:00',2.24),('5819','2013-07-02','16:50:00',2.18),('5819','2013-07-02','16:55:00',2.11),('5819','2013-07-02','17:00:00',2.07),('5819','2013-07-02','17:05:00',2),('5819','2013-07-02','17:10:00',1.91),('5819','2013-07-02','17:15:00',1.84),('5819','2013-07-02','17:20:00',1.77),('5819','2013-07-02','17:25:00',1.7),('5819','2013-07-02','17:30:00',1.61),('5819','2013-07-02','17:35:00',1.54),('5819','2013-07-02','17:40:00',1.46),('5819','2013-07-02','17:45:00',1.36),('5819','2013-07-02','17:50:00',1.17),('5819','2013-07-02','17:55:00',1.11),('5819','2013-07-02','18:00:00',1.11),('5819','2013-07-02','18:05:00',1.04),('5819','2013-07-01','07:25:00',1.06),('5819','2013-07-01','07:30:00',1.14),('5819','2013-07-01','07:35:00',1.22),('5819','2013-07-01','07:40:00',1.29),('5819','2013-07-01','07:45:00',1.37),('5819','2013-07-01','07:50:00',1.47),('5819','2013-07-01','07:55:00',1.56),('5819','2013-07-01','08:00:00',1.65),('5819','2013-07-01','08:05:00',1.74),('5819','2013-07-01','08:10:00',1.81),('5819','2013-07-01','08:15:00',1.89),('5819','2013-07-01','08:20:00',1.97),('5819','2013-07-01','08:25:00',2.05),('5819','2013-07-01','08:30:00',2.13),('5819','2013-07-01','08:35:00',2.2),('5819','2013-07-01','08:40:00',2.27),('5819','2013-07-01','08:45:00',2.34),('5819','2013-07-01','08:50:00',2.41),('5819','2013-07-01','08:55:00',2.47),('5819','2013-07-01','09:00:00',2.54),('5819','2013-07-01','09:05:00',2.61),('5819','2013-07-01','09:10:00',2.68),('5819','2013-07-01','09:15:00',2.74),('5819','2013-07-01','09:20:00',2.8),('5819','2013-07-01','09:25:00',2.86),('5819','2013-07-01','09:30:00',2.93),('5819','2013-07-01','09:35:00',2.98),('5819','2013-07-01','09:40:00',3.01),('5819','2013-07-01','09:45:00',3.05),('5819','2013-07-01','09:50:00',3.1),('5819','2013-07-01','09:55:00',3.13),('5819','2013-07-01','10:00:00',3.17),('5819','2013-07-01','10:05:00',3.22),('5819','2013-07-01','10:10:00',3.27),('5819','2013-07-01','10:15:00',3.34),('5819','2013-07-01','10:20:00',3.36),('5819','2013-07-01','10:25:00',3.4),('5819','2013-07-01','10:30:00',3.43),('5819','2013-07-01','10:35:00',3.47),('5819','2013-07-01','10:40:00',3.53),('5819','2013-07-01','10:45:00',3.56),('5819','2013-07-01','10:50:00',3.58),('5819','2013-07-01','10:55:00',3.6),('5819','2013-07-01','11:00:00',3.64),('5819','2013-07-01','11:05:00',3.68),('5819','2013-07-01','11:10:00',3.73),('5819','2013-07-01','11:15:00',3.75),('5819','2013-07-01','11:20:00',3.76),('5819','2013-07-01','11:25:00',3.78),('5819','2013-07-01','11:30:00',3.8),('5819','2013-07-01','11:35:00',3.79),('5819','2013-07-01','11:40:00',3.79),('5819','2013-07-01','11:45:00',3.81),('5819','2013-07-01','11:50:00',3.83),('5819','2013-07-01','11:55:00',3.86),('5819','2013-07-01','12:00:00',3.86),('5819','2013-07-01','12:05:00',3.84),('5819','2013-07-01','12:10:00',3.82),('5819','2013-07-01','12:15:00',3.85),('5819','2013-07-01','12:20:00',3.85),('5819','2013-07-01','12:25:00',3.84),('5819','2013-07-01','12:30:00',3.87),('5819','2013-07-01','12:35:00',3.86),('5819','2013-07-01','12:40:00',3.83),('5819','2013-07-01','12:45:00',3.86),('5819','2013-07-01','12:50:00',3.89),('5819','2013-07-01','12:55:00',3.92),('5819','2013-07-01','13:00:00',3.91),('5819','2013-07-01','13:05:00',3.87),('5819','2013-07-01','13:10:00',3.88),('5819','2013-07-01','13:15:00',3.86),('5819','2013-07-01','13:20:00',3.88),('5819','2013-07-01','13:25:00',3.87),('5819','2013-07-01','13:30:00',3.83),('5819','2013-07-01','13:35:00',3.79),('5819','2013-07-01','13:40:00',3.74),('5819','2013-07-01','13:45:00',3.7),('5819','2013-07-01','13:50:00',3.73),('5819','2013-07-01','13:55:00',3.68),('5819','2013-07-01','14:00:00',3.68),('5819','2013-07-01','14:05:00',3.74),('5819','2013-07-01','14:10:00',3.75),('5819','2013-07-01','14:15:00',3.7),('5819','2013-07-01','14:20:00',3.67),('5819','2013-07-01','14:25:00',3.63),('5819','2013-07-01','14:30:00',3.6),('5819','2013-07-01','14:35:00',3.55),('5819','2013-07-01','14:40:00',3.55),('5819','2013-07-01','14:45:00',3.52),('5819','2013-07-01','14:50:00',3.45),('5819','2013-07-01','14:55:00',3.41),('5819','2013-07-01','15:00:00',3.38),('5819','2013-07-01','15:05:00',3.3),('5819','2013-07-01','15:10:00',3.27),('5819','2013-07-01','15:15:00',3.25),('5819','2013-07-01','15:20:00',3.22),('5819','2013-07-01','15:25:00',3.16),('5819','2013-07-01','15:30:00',3.11),('5819','2013-07-01','15:35:00',3.06),('5819','2013-07-01','15:40:00',2.99),('5819','2013-07-01','15:45:00',2.96),('5819','2013-07-01','15:50:00',2.9),('5819','2013-07-01','15:55:00',2.85),('5819','2013-07-01','16:00:00',2.81),('5819','2013-07-01','16:05:00',2.74),('5819','2013-07-01','16:10:00',2.7),('5819','2013-07-01','16:15:00',2.62),('5819','2013-07-01','16:20:00',2.53),('5819','2013-07-01','16:25:00',2.48),('5819','2013-07-01','16:30:00',2.41),('5819','2013-07-01','16:35:00',2.35),('5819','2013-07-01','16:40:00',2.28),('5819','2013-07-01','16:45:00',2.23),('5819','2013-07-01','16:50:00',2.18),('5819','2013-07-01','16:55:00',2.11),('5819','2013-07-01','17:00:00',2.06),('5819','2013-07-01','17:05:00',1.98),('5819','2013-07-01','17:10:00',1.91),('5819','2013-07-01','17:15:00',1.84),('5819','2013-07-01','17:20:00',1.75),('5819','2013-07-01','17:25:00',1.67),('5819','2013-07-01','17:30:00',1.59),('5819','2013-07-01','17:35:00',1.51),('5819','2013-07-01','17:40:00',1.44),('5819','2013-07-01','17:45:00',1.37),('5819','2013-07-01','17:50:00',1.22),('5819','2013-07-01','17:55:00',1.13),('5819','2013-07-01','18:00:00',1.05),('5819','2013-07-01','18:05:00',1.02),('5819','2013-06-30','07:20:00',1.08),('5819','2013-06-30','07:25:00',1.15),('5819','2013-06-30','07:30:00',1.24),('5819','2013-06-30','07:35:00',1.32),('5819','2013-06-30','07:40:00',1.41),('5819','2013-06-30','07:45:00',1.49),('5819','2013-06-30','07:50:00',1.57),('5819','2013-06-30','07:55:00',1.65),('5819','2013-06-30','08:00:00',1.73),('5819','2013-06-30','08:05:00',1.81),('5819','2013-06-30','08:10:00',1.9),('5819','2013-06-30','08:15:00',1.97),('5819','2013-06-30','08:20:00',2.05),('5819','2013-06-30','08:25:00',2.13),('5819','2013-06-30','08:30:00',2.21),('5819','2013-06-30','08:35:00',2.28),('5819','2013-06-30','08:40:00',2.36),('5819','2013-06-30','08:45:00',2.43),('5819','2013-06-30','08:50:00',2.49),('5819','2013-06-30','08:55:00',2.56),('5819','2013-06-30','09:00:00',2.62),('5819','2013-06-30','09:05:00',2.69),('5819','2013-06-30','09:10:00',2.75),('5819','2013-06-30','09:15:00',2.81),('5819','2013-06-30','09:20:00',2.87),('5819','2013-06-30','09:25:00',2.92),('5819','2013-06-30','09:30:00',2.97),('5819','2013-06-30','09:35:00',3.02),('5819','2013-06-30','09:40:00',3.08),('5819','2013-06-30','09:45:00',3.14),('5819','2013-06-30','09:50:00',3.18),('5819','2013-06-30','09:55:00',3.23),('5819','2013-06-30','10:00:00',3.29),('5819','2013-06-30','10:05:00',3.33),('5819','2013-06-30','10:10:00',3.34),('5819','2013-06-30','10:15:00',3.39),('5819','2013-06-30','10:20:00',3.43),('5819','2013-06-30','10:25:00',3.46),('5819','2013-06-30','10:30:00',3.51),('5819','2013-06-30','10:35:00',3.56),('5819','2013-06-30','10:40:00',3.59),('5819','2013-06-30','10:45:00',3.6),('5819','2013-06-30','10:50:00',3.62),('5819','2013-06-30','10:55:00',3.66),('5819','2013-06-30','11:00:00',3.7),('5819','2013-06-30','11:05:00',3.72),('5819','2013-06-30','11:10:00',3.73),('5819','2013-06-30','11:15:00',3.73),('5819','2013-06-30','11:20:00',3.76),('5819','2013-06-30','11:25:00',3.79),('5819','2013-06-30','11:30:00',3.8),('5819','2013-06-30','11:35:00',3.83),('5819','2013-06-30','11:40:00',3.86),('5819','2013-06-30','11:45:00',3.87),('5819','2013-06-30','11:50:00',3.89),('5819','2013-06-30','11:55:00',3.88),('5819','2013-06-30','12:00:00',3.89),('5819','2013-06-30','12:05:00',3.93),('5819','2013-06-30','12:10:00',3.94),('5819','2013-06-30','12:15:00',3.9),('5819','2013-06-30','12:20:00',3.92),('5819','2013-06-30','12:25:00',3.95),('5819','2013-06-30','12:30:00',3.95),('5819','2013-06-30','12:35:00',3.96),('5819','2013-06-30','12:40:00',3.96),('5819','2013-06-30','12:45:00',3.98),('5819','2013-06-30','12:50:00',4),('5819','2013-06-30','12:55:00',3.96),('5819','2013-06-30','13:00:00',3.95),('5819','2013-06-30','13:05:00',3.93),('5819','2013-06-30','13:10:00',3.92),('5819','2013-06-30','13:15:00',3.92),('5819','2013-06-30','13:20:00',3.93),('5819','2013-06-30','13:25:00',3.98),('5819','2013-06-30','13:30:00',3.92),('5819','2013-06-30','13:35:00',3.88),('5819','2013-06-30','13:40:00',3.88),('5819','2013-06-30','13:45:00',3.89),('5819','2013-06-30','13:50:00',3.91),('5819','2013-06-30','13:55:00',3.41),('5819','2013-06-30','14:00:00',3.88),('5819','2013-06-30','14:05:00',3.83),('5819','2013-06-30','14:10:00',3.81),('5819','2013-06-30','14:15:00',3.73),('5819','2013-06-30','14:20:00',3.7),('5819','2013-06-30','14:25:00',3.66),('5819','2013-06-30','14:30:00',3.61),('5819','2013-06-30','14:35:00',3.61),('5819','2013-06-30','14:40:00',3.61),('5819','2013-06-30','14:45:00',3.58),('5819','2013-06-30','14:50:00',3.56),('5819','2013-06-30','14:55:00',3.51),('5819','2013-06-30','15:00:00',3.46),('5819','2013-06-30','15:05:00',3.41),('5819','2013-06-30','15:10:00',3.39),('5819','2013-06-30','15:15:00',3.35),('5819','2013-06-30','15:20:00',3.34),('5819','2013-06-30','15:25:00',3.26),('5819','2013-06-30','15:30:00',3.24),('5819','2013-06-30','15:35:00',3.21),('5819','2013-06-30','15:40:00',3.16),('5819','2013-06-30','15:45:00',3.11),('5819','2013-06-30','15:50:00',3.07),('5819','2013-06-30','15:55:00',3.01),('5819','2013-06-30','16:00:00',2.95),('5819','2013-06-30','16:05:00',2.9),('5819','2013-06-30','16:10:00',2.88),('5819','2013-06-30','16:15:00',2.83),('5819','2013-06-30','16:20:00',2.88),('5819','2013-06-30','16:25:00',2.9),('5819','2013-06-30','16:30:00',2.48),('5819','2013-06-30','16:35:00',2.51),('5819','2013-06-30','16:40:00',2.4),('5819','2013-06-30','16:45:00',2.35),('5819','2013-06-30','16:50:00',2.28),('5819','2013-06-30','16:55:00',2.18),('5819','2013-06-30','17:00:00',2.08),('5819','2013-06-30','17:05:00',2.03),('5819','2013-06-30','17:10:00',1.99),('5819','2013-06-30','17:15:00',1.9),('5819','2013-06-30','17:20:00',1.81),('5819','2013-06-30','17:25:00',1.72),('5819','2013-06-30','17:30:00',1.62),('5819','2013-06-30','17:35:00',1.55),('5819','2013-06-30','17:40:00',1.48),('5819','2013-06-30','17:45:00',1.39),('5819','2013-06-30','17:50:00',1.25),('5819','2013-06-30','17:55:00',1.17),('5819','2013-06-30','18:00:00',1.14),('5819','2013-06-30','18:05:00',1.06),('5819','2013-06-30','18:10:00',1.01),('5819','2013-06-29','07:30:00',1.27),('5819','2013-06-29','07:35:00',1.58),('5819','2013-06-29','07:40:00',1.67),('5819','2013-06-29','07:45:00',1.7),('5819','2013-06-29','07:50:00',1.76),('5819','2013-06-29','07:55:00',1.76),('5819','2013-06-29','08:00:00',2.12),('5819','2013-06-29','08:05:00',2.26),('5819','2013-06-29','08:10:00',2.35),('5819','2013-06-29','08:15:00',2.11),('5819','2013-06-29','08:20:00',1.34),('5819','2013-06-29','08:25:00',1.78),('5819','2013-06-29','08:30:00',2.33),('5819','2013-06-29','08:35:00',2.37),('5819','2013-06-29','08:40:00',1.39),('5819','2013-06-29','08:45:00',2.16),('5819','2013-06-29','08:50:00',2.51),('5819','2013-06-29','08:55:00',2.55),('5819','2013-06-29','09:00:00',2.59),('5819','2013-06-29','09:05:00',2.65),('5819','2013-06-29','09:10:00',2.71),('5819','2013-06-29','09:15:00',2.78),('5819','2013-06-29','09:20:00',2.82),('5819','2013-06-29','09:25:00',2.87),('5819','2013-06-29','09:30:00',2.9),('5819','2013-06-29','09:35:00',3),('5819','2013-06-29','09:40:00',3.04),('5819','2013-06-29','09:45:00',3.08),('5819','2013-06-29','09:50:00',3.14),('5819','2013-06-29','09:55:00',3.18),('5819','2013-06-29','10:00:00',3.22),('5819','2013-06-29','10:05:00',3.28),('5819','2013-06-29','10:10:00',3.33),('5819','2013-06-29','10:15:00',3.33),('5819','2013-06-29','10:20:00',3.39),('5819','2013-06-29','10:25:00',3.43),('5819','2013-06-29','10:30:00',3.46),('5819','2013-06-29','10:35:00',3.49),('5819','2013-06-29','10:40:00',3.53),('5819','2013-06-29','10:45:00',3.58),('5819','2013-06-29','10:50:00',3.6),('5819','2013-06-29','10:55:00',3.7),('5819','2013-06-29','11:00:00',3.72),('5819','2013-06-29','11:05:00',3.78),('5819','2013-06-29','11:10:00',3.83),('5819','2013-06-29','11:15:00',3.91),('5819','2013-06-29','11:20:00',2.23),('5819','2013-06-29','11:25:00',4.14),('5819','2013-06-29','11:30:00',4.18),('5819','2013-06-29','11:35:00',3.68),('5819','2013-06-29','11:40:00',3.65),('5819','2013-06-29','11:45:00',1.1),('5819','2013-06-29','11:50:00',2.83),('5819','2013-06-29','11:55:00',4.47),('5819','2013-06-29','12:00:00',3.15),('5819','2013-06-29','12:05:00',4.13),('5819','2013-06-29','12:10:00',4.19),('5819','2013-06-29','12:15:00',3.26),('5819','2013-06-29','12:20:00',1.59),('5819','2013-06-29','12:25:00',4.38),('5819','2013-06-29','12:30:00',4.08),('5819','2013-06-29','12:35:00',4.21),('5819','2013-06-29','12:40:00',4.08),('5819','2013-06-29','12:45:00',4.42),('5819','2013-06-29','12:50:00',2.1),('5819','2013-06-29','12:55:00',3.18),('5819','2013-06-29','13:00:00',2.79),('5819','2013-06-29','13:05:00',2.19),('5819','2013-06-29','13:10:00',4.5),('5819','2013-06-29','13:15:00',4.28),('5819','2013-06-29','13:20:00',2.29),('5819','2013-06-29','13:25:00',3.72),('5819','2013-06-29','13:30:00',1.44),('5819','2013-06-29','13:45:00',2.88),('5819','2013-06-29','13:50:00',4.25),('5819','2013-06-29','13:55:00',3.27),('5819','2013-06-29','14:00:00',4.07),('5819','2013-06-29','14:05:00',3.11),('5819','2013-06-29','14:10:00',3.66),('5819','2013-06-29','14:15:00',4.47),('5819','2013-06-29','14:20:00',4),('5819','2013-06-29','14:25:00',2.47),('5819','2013-06-29','14:30:00',4.39),('5819','2013-06-29','14:35:00',4.14),('5819','2013-06-29','14:40:00',4.1),('5819','2013-06-29','14:45:00',4.12),('5819','2013-06-29','14:50:00',3.26),('5819','2013-06-29','14:55:00',1.05),('5819','2013-06-29','15:00:00',1.84),('5819','2013-06-29','15:05:00',2.68),('5819','2013-06-29','15:10:00',1.97),('5819','2013-06-29','15:15:00',1.14),('5819','2013-06-29','16:40:00',1.1),('5819','2013-06-29','16:45:00',1.41),('5819','2013-06-29','16:50:00',2.07),('5819','2013-06-29','17:25:00',1.28),('5819','2013-06-29','17:30:00',1.84),('5819','2013-06-29','17:35:00',1.81),('5819','2013-06-29','17:45:00',1.4),('5819','2013-06-29','17:50:00',1.33),('5819','2013-06-29','17:55:00',1.25),('5819','2013-06-29','18:00:00',1.17),('5819','2013-06-29','18:05:00',1.1),('5819','2013-06-29','18:10:00',1.02),('5819','2013-06-28','07:15:00',1.03),('5819','2013-06-28','07:20:00',1.09),('5819','2013-06-28','07:25:00',1.14),('5819','2013-06-28','07:30:00',1.24),('5819','2013-06-28','07:35:00',1.28),('5819','2013-06-28','07:40:00',1.37),('5819','2013-06-28','07:45:00',1.51),('5819','2013-06-28','07:50:00',1.53),('5819','2013-06-28','07:55:00',1.62),('5819','2013-06-28','08:00:00',1.68),('5819','2013-06-28','08:05:00',1.71),('5819','2013-06-28','08:10:00',1.74),('5819','2013-06-28','08:15:00',1.88),('5819','2013-06-28','08:20:00',1.96),('5819','2013-06-28','08:25:00',1.9),('5819','2013-06-28','08:30:00',2.1),('5819','2013-06-28','08:35:00',2.23),('5819','2013-06-28','08:40:00',2.3),('5819','2013-06-28','08:45:00',2.31),('5819','2013-06-28','08:50:00',2.4),('5819','2013-06-28','08:55:00',2.46),('5819','2013-06-28','09:00:00',2.5),('5819','2013-06-28','09:05:00',2.56),('5819','2013-06-28','09:10:00',2.73),('5819','2013-06-28','09:15:00',2.56),('5819','2013-06-28','09:20:00',1.17),('5819','2013-06-28','09:30:00',1.48),('5819','2013-06-28','09:35:00',3.24),('5819','2013-06-28','09:40:00',3.18),('5819','2013-06-28','09:45:00',1.82),('5819','2013-06-28','09:50:00',1.11),('5819','2013-06-28','09:55:00',2.1),('5819','2013-06-28','10:00:00',3.53),('5819','2013-06-28','10:05:00',2.24),('5819','2013-06-28','10:10:00',3.56),('5819','2013-06-28','10:15:00',3.37),('5819','2013-06-28','10:20:00',3.75),('5819','2013-06-28','10:25:00',3.23),('5819','2013-06-28','10:30:00',1.26),('5819','2013-06-28','10:35:00',2.75),('5819','2013-06-28','10:40:00',4.13),('5819','2013-06-28','10:45:00',3.96),('5819','2013-06-28','10:50:00',3.83),('5819','2013-06-28','10:55:00',2.44),('5819','2013-06-28','11:00:00',2.63),('5819','2013-06-28','11:05:00',4.35),('5819','2013-06-28','11:10:00',2.98),('5819','2013-06-28','11:15:00',1.4),('5819','2013-06-28','11:20:00',1.62),('5819','2013-06-28','11:25:00',2.39),('5819','2013-06-28','11:30:00',4.34),('5819','2013-06-28','11:35:00',3.95),('5819','2013-06-28','11:40:00',4.16),('5819','2013-06-28','11:45:00',3.74),('5819','2013-06-28','11:50:00',4.35),('5819','2013-06-28','11:55:00',3.28),('5819','2013-06-28','12:00:00',2.36),('5819','2013-06-28','12:05:00',2.85),('5819','2013-06-28','12:10:00',2.88),('5819','2013-06-28','12:15:00',4.5),('5819','2013-06-28','12:20:00',4.23),('5819','2013-06-28','12:25:00',4.28),('5819','2013-06-28','12:30:00',4.05),('5819','2013-06-28','12:35:00',4.26),('5819','2013-06-28','12:40:00',3.62),('5819','2013-06-28','12:45:00',3.93),('5819','2013-06-28','12:50:00',4.25),('5819','2013-06-28','12:55:00',4.2),('5819','2013-06-28','13:00:00',3.84),('5819','2013-06-28','13:05:00',4.18),('5819','2013-06-28','13:10:00',3.42),('5819','2013-06-28','13:15:00',4.31),('5819','2013-06-28','13:20:00',4.14),('5819','2013-06-28','13:25:00',4.04),('5819','2013-06-28','13:30:00',4.12),('5819','2013-06-28','13:35:00',4.12),('5819','2013-06-28','13:40:00',4.03),('5819','2013-06-28','13:45:00',3.87),('5819','2013-06-28','13:50:00',4.18),('5819','2013-06-28','13:55:00',4.05),('5819','2013-06-28','14:00:00',3.94),('5819','2013-06-28','14:05:00',3.79),('5819','2013-06-28','14:10:00',3.88),('5819','2013-06-28','14:15:00',3.44),('5819','2013-06-28','14:20:00',3.82),('5819','2013-06-28','14:25:00',3.97),('5819','2013-06-28','14:30:00',3.48),('5819','2013-06-28','14:35:00',3.68),('5819','2013-06-28','14:40:00',3.3),('5819','2013-06-28','14:45:00',3),('5819','2013-06-28','14:50:00',3.97),('5819','2013-06-28','14:55:00',3.33),('5819','2013-06-28','15:00:00',3.06),('5819','2013-06-28','15:05:00',3.58),('5819','2013-06-28','15:10:00',3.27),('5819','2013-06-28','15:15:00',3.41),('5819','2013-06-28','15:20:00',1.65),('5819','2013-06-28','15:25:00',3.47),('5819','2013-06-28','15:30:00',2.46),('5819','2013-06-28','15:35:00',1.72),('5819','2013-06-28','15:40:00',3.14),('5819','2013-06-28','15:45:00',2.15),('5819','2013-06-28','15:50:00',3.56),('5819','2013-06-28','15:55:00',3.34),('5819','2013-06-28','16:00:00',2.19),('5819','2013-06-28','16:05:00',3.37),('5819','2013-06-28','16:10:00',2.25),('5819','2013-06-28','16:15:00',3.12),('5819','2013-06-28','16:20:00',1.72),('5819','2013-06-28','16:25:00',2.07),('5819','2013-06-28','16:30:00',1.33),('5819','2013-06-28','16:35:00',1.79),('5819','2013-06-28','16:40:00',2.35),('5819','2013-06-28','16:55:00',1.53),('5819','2013-06-28','17:00:00',1.39),('5819','2013-06-28','17:05:00',2.13),('5819','2013-06-28','17:10:00',2.01),('5819','2013-06-28','17:15:00',1.9),('5819','2013-06-28','17:20:00',1.81),('5819','2013-06-28','17:25:00',1.75),('5819','2013-06-28','17:30:00',1.26),('5819','2013-06-28','17:35:00',1.45),('5819','2013-06-28','17:40:00',1.5),('5819','2013-06-28','17:45:00',1.41),('5819','2013-06-28','17:50:00',1.25),('5819','2013-06-28','17:55:00',1.21),('5819','2013-06-28','18:00:00',1.15),('5819','2013-06-28','18:05:00',1.08),('5819','2013-06-27','07:30:00',1.19),('5819','2013-06-27','07:35:00',1.29),('5819','2013-06-27','07:40:00',1.36),('5819','2013-06-27','07:45:00',1.44),('5819','2013-06-27','07:50:00',1.55),('5819','2013-06-27','07:55:00',1.64),('5819','2013-06-27','08:00:00',1.72),('5819','2013-06-27','08:05:00',1.81),('5819','2013-06-27','08:10:00',1.91),('5819','2013-06-27','08:15:00',1.96),('5819','2013-06-27','08:20:00',2.01),('5819','2013-06-27','08:25:00',2.09),('5819','2013-06-27','08:30:00',2.14),('5819','2013-06-27','08:35:00',2.2),('5819','2013-06-27','08:40:00',2.26),('5819','2013-06-27','08:45:00',2.35),('5819','2013-06-27','08:50:00',2.4),('5819','2013-06-27','08:55:00',2.49),('5819','2013-06-27','09:00:00',2.58),('5819','2013-06-27','09:05:00',2.64),('5819','2013-06-27','09:10:00',2.69),('5819','2013-06-27','09:15:00',2.8),('5819','2013-06-27','09:20:00',2.85),('5819','2013-06-27','09:25:00',2.89),('5819','2013-06-27','09:30:00',2.96),('5819','2013-06-27','09:35:00',3.02),('5819','2013-06-27','09:40:00',3.06),('5819','2013-06-27','09:45:00',3.11),('5819','2013-06-27','09:50:00',3.21),('5819','2013-06-27','09:55:00',3.24),('5819','2013-06-27','10:00:00',3.03),('5819','2013-06-27','10:05:00',3.47),('5819','2013-06-27','10:10:00',2.86),('5819','2013-06-27','10:15:00',3.27),('5819','2013-06-27','10:20:00',3.45),('5819','2013-06-27','10:25:00',3.46),('5819','2013-06-27','10:30:00',3.53),('5819','2013-06-27','10:35:00',3.63),('5819','2013-06-27','10:40:00',3.69),('5819','2013-06-27','10:45:00',3.84),('5819','2013-06-27','10:50:00',3.82),('5819','2013-06-27','10:55:00',3.81),('5819','2013-06-27','11:00:00',2.61),('5819','2013-06-27','11:05:00',3.95),('5819','2013-06-27','11:10:00',3.89),('5819','2013-06-27','11:15:00',3.87),('5819','2013-06-27','11:20:00',3.84),('5819','2013-06-27','11:25:00',3.82),('5819','2013-06-27','11:30:00',3.91),('5819','2013-06-27','11:35:00',3.73),('5819','2013-06-27','11:40:00',1.52),('5819','2013-06-27','11:45:00',3.91),('5819','2013-06-27','11:50:00',2.69),('5819','2013-06-27','11:55:00',1.35),('5819','2013-06-27','12:00:00',2.03),('5819','2013-06-27','12:05:00',1.32),('5819','2013-06-27','12:10:00',2.14),('5819','2013-06-27','12:15:00',1.23),('5819','2013-06-27','12:20:00',1.18),('5819','2013-06-27','12:25:00',1.39),('5819','2013-06-27','12:30:00',1.4),('5819','2013-06-27','12:35:00',3.44),('5819','2013-06-27','12:40:00',2.34),('5819','2013-06-27','12:45:00',1.38),('5819','2013-06-27','12:50:00',1.24),('5819','2013-06-27','12:55:00',1.13),('5819','2013-06-27','13:05:00',1.04),('5819','2013-06-27','13:10:00',1.43),('5819','2013-06-27','13:15:00',2.45),('5819','2013-06-27','13:20:00',2.85),('5819','2013-06-27','13:25:00',1.94),('5819','2013-06-27','13:30:00',1.54),('5819','2013-06-27','13:35:00',3.14),('5819','2013-06-27','13:40:00',1.61),('5819','2013-06-27','13:45:00',1.13),('5819','2013-06-27','13:50:00',1.15),('5819','2013-06-27','13:55:00',1.27),('5819','2013-06-27','14:00:00',1.4),('5819','2013-06-27','14:05:00',1.24),('5819','2013-06-27','14:10:00',1.41),('5819','2013-06-27','14:15:00',1.7),('5819','2013-06-27','14:20:00',1.78),('5819','2013-06-27','14:25:00',1.9),('5819','2013-06-27','14:30:00',3.98),('5819','2013-06-27','14:35:00',3.83),('5819','2013-06-27','14:40:00',3.74),('5819','2013-06-27','14:45:00',3.3),('5819','2013-06-27','14:50:00',3.01),('5819','2013-06-27','14:55:00',3.41),('5819','2013-06-27','15:00:00',3.43),('5819','2013-06-27','15:05:00',3.38),('5819','2013-06-27','15:10:00',3.31),('5819','2013-06-27','15:15:00',3.27),('5819','2013-06-27','15:20:00',3.22),('5819','2013-06-27','15:25:00',3.23),('5819','2013-06-27','15:30:00',3.19),('5819','2013-06-27','15:35:00',3.13),('5819','2013-06-27','15:40:00',3.08),('5819','2013-06-27','15:45:00',3.02),('5819','2013-06-27','15:50:00',2.95),('5819','2013-06-27','15:55:00',2.9),('5819','2013-06-27','16:00:00',2.8),('5819','2013-06-27','16:05:00',2.72),('5819','2013-06-27','16:10:00',2.69),('5819','2013-06-27','16:15:00',2.63),('5819','2013-06-27','16:20:00',2.59),('5819','2013-06-27','16:25:00',2.55),('5819','2013-06-27','16:30:00',2.49),('5819','2013-06-27','16:35:00',2.28),('5819','2013-06-27','16:40:00',2.27),('5819','2013-06-27','16:45:00',2.28),('5819','2013-06-27','16:50:00',2.2),('5819','2013-06-27','16:55:00',2.14),('5819','2013-06-27','17:00:00',2.08),('5819','2013-06-27','17:05:00',2),('5819','2013-06-27','17:10:00',1.89),('5819','2013-06-27','17:15:00',1.79),('5819','2013-06-27','17:20:00',1.8),('5819','2013-06-27','17:25:00',1.75),('5819','2013-06-27','17:30:00',1.68),('5819','2013-06-27','17:35:00',1.61),('5819','2013-06-27','17:40:00',1.17),('5819','2013-06-27','17:50:00',1.29),('5819','2013-06-27','17:55:00',1.22),('5819','2013-06-27','18:00:00',1.15),('5819','2013-06-27','18:05:00',1.09),('5819','2013-06-27','18:10:00',1),('5819','2013-06-26','07:15:00',1),('5819','2013-06-26','07:20:00',1.08),('5819','2013-06-26','07:25:00',1.16),('5819','2013-06-26','07:30:00',1.24),('5819','2013-06-26','07:35:00',1.32),('5819','2013-06-26','07:40:00',1.4),('5819','2013-06-26','07:45:00',1.5),('5819','2013-06-26','07:50:00',1.59),('5819','2013-06-26','07:55:00',1.66),('5819','2013-06-26','08:00:00',1.71),('5819','2013-06-26','08:05:00',1.79),('5819','2013-06-26','08:10:00',1.87),('5819','2013-06-26','08:15:00',1.93),('5819','2013-06-26','08:20:00',1.99),('5819','2013-06-26','08:25:00',2.06),('5819','2013-06-26','08:30:00',2.14),('5819','2013-06-26','08:35:00',2.2),('5819','2013-06-26','08:40:00',2.25),('5819','2013-06-26','08:45:00',2.32),('5819','2013-06-26','08:50:00',2.39),('5819','2013-06-26','08:55:00',2.44),('5819','2013-06-26','09:00:00',2.5),('5819','2013-06-26','09:05:00',2.58),('5819','2013-06-26','09:10:00',2.62),('5819','2013-06-26','09:15:00',2.67),('5819','2013-06-26','09:20:00',2.72),('5819','2013-06-26','09:25:00',2.79),('5819','2013-06-26','09:30:00',2.88),('5819','2013-06-26','09:35:00',2.93),('5819','2013-06-26','09:40:00',2.97),('5819','2013-06-26','09:45:00',3),('5819','2013-06-26','09:50:00',3.04),('5819','2013-06-26','09:55:00',3.1),('5819','2013-06-26','10:00:00',3.17),('5819','2013-06-26','10:05:00',3.23),('5819','2013-06-26','10:10:00',3.27),('5819','2013-06-26','10:15:00',3.3),('5819','2013-06-26','10:20:00',3.34),('5819','2013-06-26','10:25:00',3.36),('5819','2013-06-26','10:30:00',3.38),('5819','2013-06-26','10:35:00',3.44),('5819','2013-06-26','10:40:00',3.5),('5819','2013-06-26','10:45:00',3.53),('5819','2013-06-26','10:50:00',3.56),('5819','2013-06-26','10:55:00',3.58),('5819','2013-06-26','11:00:00',3.63),('5819','2013-06-26','11:05:00',3.63),('5819','2013-06-26','11:10:00',3.67),('5819','2013-06-26','11:15:00',3.69),('5819','2013-06-26','11:20:00',3.72),('5819','2013-06-26','11:25:00',3.71),('5819','2013-06-26','11:30:00',3.71),('5819','2013-06-26','11:35:00',3.74),('5819','2013-06-26','11:40:00',3.75),('5819','2013-06-26','11:45:00',3.77),('5819','2013-06-26','11:50:00',3.8),('5819','2013-06-26','11:55:00',3.82),('5819','2013-06-26','12:00:00',3.88),('5819','2013-06-26','12:05:00',3.86),('5819','2013-06-26','12:10:00',3.85),('5819','2013-06-26','12:15:00',3.74),('5819','2013-06-26','12:20:00',3.7),('5819','2013-06-26','12:25:00',3.76),('5819','2013-06-26','12:30:00',3.87),('5819','2013-06-26','12:35:00',3.88),('5819','2013-06-26','12:40:00',3.96),('5819','2013-06-26','12:45:00',3.89),('5819','2013-06-26','12:50:00',1.99),('5819','2013-06-26','13:10:00',1.07),('5819','2013-06-26','13:15:00',3.57),('5819','2013-06-26','13:20:00',4.25),('5819','2013-06-26','13:25:00',2.85),('5819','2013-06-26','13:30:00',1.25),('5819','2013-06-26','13:45:00',1.07),('5819','2013-06-26','13:50:00',1.25),('5819','2013-06-26','13:55:00',2.39),('5819','2013-06-26','14:00:00',2.45),('5819','2013-06-26','14:10:00',1.97),('5819','2013-06-26','14:15:00',4.12),('5819','2013-06-26','14:20:00',3.86),('5819','2013-06-26','14:25:00',3.33),('5819','2013-06-26','14:30:00',3.2),('5819','2013-06-26','14:35:00',3.71),('5819','2013-06-26','14:40:00',1.05),('5819','2013-06-26','14:45:00',3.22),('5819','2013-06-26','14:50:00',3.83),('5819','2013-06-26','14:55:00',3.4),('5819','2013-06-26','15:00:00',3.47),('5819','2013-06-26','15:05:00',3.44),('5819','2013-06-26','15:10:00',3.39),('5819','2013-06-26','15:15:00',3.33),('5819','2013-06-26','15:20:00',3.26),('5819','2013-06-26','15:25:00',3.23),('5819','2013-06-26','15:30:00',3.2),('5819','2013-06-26','15:35:00',3.2),('5819','2013-06-26','15:40:00',3.1),('5819','2013-06-26','15:45:00',3.04),('5819','2013-06-26','15:50:00',3.02),('5819','2013-06-26','15:55:00',2.81),('5819','2013-06-26','16:00:00',2.87),('5819','2013-06-26','16:05:00',2.8),('5819','2013-06-26','16:10:00',2.75),('5819','2013-06-26','16:15:00',2.71),('5819','2013-06-26','16:20:00',2.63),('5819','2013-06-26','16:25:00',2.58),('5819','2013-06-26','16:30:00',2.54),('5819','2013-06-26','16:35:00',2.45),('5819','2013-06-26','16:40:00',2.35),('5819','2013-06-26','16:45:00',2.29),('5819','2013-06-26','16:50:00',2.22),('5819','2013-06-26','16:55:00',2.15),('5819','2013-06-26','17:00:00',2.1),('5819','2013-06-26','17:05:00',2.03),('5819','2013-06-26','17:10:00',1.98),('5819','2013-06-26','17:15:00',1.88),('5819','2013-06-26','17:20:00',1.81),('5819','2013-06-26','17:25:00',1.71),('5819','2013-06-26','17:30:00',1.65),('5819','2013-06-26','17:35:00',1.59),('5819','2013-06-26','17:40:00',1.5),('5819','2013-06-26','17:45:00',1.4),('5819','2013-06-26','17:50:00',1.25),('5819','2013-06-26','17:55:00',1.17),('5819','2013-06-26','18:00:00',1.16),('5819','2013-06-26','18:05:00',1.23),('5819','2013-06-26','18:10:00',1.37),('5819','2013-06-26','18:15:00',1.01),('5819','2013-06-25','07:40:00',1.38),('5819','2013-06-25','07:45:00',1.48),('5819','2013-06-25','07:50:00',1.38),('5819','2013-06-25','07:55:00',1.29),('5819','2013-06-25','08:05:00',1.37),('5819','2013-06-25','08:10:00',1.5),('5819','2013-06-25','08:15:00',1.32),('5819','2013-06-25','08:20:00',2.27),('5819','2013-06-25','08:25:00',1.01),('5819','2013-06-25','08:30:00',1.55),('5819','2013-06-25','08:35:00',2.28),('5819','2013-06-25','08:40:00',2.32),('5819','2013-06-25','08:45:00',2.4),('5819','2013-06-25','08:50:00',2.46),('5819','2013-06-25','08:55:00',2.53),('5819','2013-06-25','09:00:00',2.6),('5819','2013-06-25','09:05:00',2.65),('5819','2013-06-25','09:10:00',2.72),('5819','2013-06-25','09:15:00',2.81),('5819','2013-06-25','09:20:00',2.74),('5819','2013-06-25','09:25:00',2.96),('5819','2013-06-25','09:30:00',3.01),('5819','2013-06-25','09:35:00',3.15),('5819','2013-06-25','09:40:00',3.18),('5819','2013-06-25','09:45:00',3.22),('5819','2013-06-25','09:50:00',3.38),('5819','2013-06-25','09:55:00',3.48),('5819','2013-06-25','10:00:00',3.54),('5819','2013-06-25','10:05:00',2.01),('5819','2013-06-25','10:10:00',2.17),('5819','2013-06-25','10:15:00',3.76),('5819','2013-06-25','10:20:00',3.74),('5819','2013-06-25','10:25:00',2.43),('5819','2013-06-25','10:30:00',3.88),('5819','2013-06-25','10:35:00',3.9),('5819','2013-06-25','10:40:00',3.84),('5819','2013-06-25','10:45:00',3.61),('5819','2013-06-25','10:50:00',3.79),('5819','2013-06-25','10:55:00',3.5),('5819','2013-06-25','11:05:00',1.67),('5819','2013-06-25','11:10:00',3.55),('5819','2013-06-25','11:15:00',2.41),('5819','2013-06-25','11:20:00',3.95),('5819','2013-06-25','11:25:00',1.1),('5819','2013-06-25','11:30:00',2.18),('5819','2013-06-25','11:35:00',3.14),('5819','2013-06-25','11:40:00',4.06),('5819','2013-06-25','11:45:00',4.07),('5819','2013-06-25','11:50:00',3.12),('5819','2013-06-25','11:55:00',2.84),('5819','2013-06-25','12:00:00',3.37),('5819','2013-06-25','12:05:00',2.96),('5819','2013-06-25','12:10:00',2.69),('5819','2013-06-25','12:15:00',3.03),('5819','2013-06-25','12:20:00',1.91),('5819','2013-06-25','12:25:00',1.05),('5819','2013-06-25','12:40:00',1.55),('5819','2013-06-25','12:45:00',1.35),('5819','2013-06-25','12:50:00',1.18),('5819','2013-06-25','12:55:00',2.66),('5819','2013-06-25','13:00:00',4.47),('5819','2013-06-25','13:05:00',4.27),('5819','2013-06-25','13:10:00',4.24),('5819','2013-06-25','13:15:00',3.9),('5819','2013-06-25','13:20:00',4.13),('5819','2013-06-25','13:25:00',4.06),('5819','2013-06-25','13:30:00',4.13),('5819','2013-06-25','13:35:00',3.76),('5819','2013-06-25','13:40:00',2.88),('5819','2013-06-25','13:45:00',4.24),('5819','2013-06-25','13:50:00',3.58),('5819','2013-06-25','13:55:00',4.13),('5819','2013-06-25','14:00:00',3.42),('5819','2013-06-25','14:05:00',3.99),('5819','2013-06-25','14:10:00',4.06),('5819','2013-06-25','14:15:00',2.88),('5819','2013-06-25','14:20:00',3.75),('5819','2013-06-25','14:25:00',3.82),('5819','2013-06-25','14:30:00',3.74),('5819','2013-06-25','14:35:00',3.66),('5819','2013-06-25','14:40:00',3.43),('5819','2013-06-25','14:45:00',3.06),('5819','2013-06-25','14:50:00',3.63),('5819','2013-06-25','14:55:00',3.55),('5819','2013-06-25','15:00:00',3.5),('5819','2013-06-25','15:05:00',3.44),('5819','2013-06-25','15:10:00',3.36),('5819','2013-06-25','15:15:00',3.38),('5819','2013-06-25','15:20:00',3.29),('5819','2013-06-25','15:25:00',3.21),('5819','2013-06-25','15:30:00',3.16),('5819','2013-06-25','15:35:00',3.1),('5819','2013-06-25','15:40:00',3.05),('5819','2013-06-25','15:45:00',2.99),('5819','2013-06-25','15:50:00',2.92),('5819','2013-06-25','15:55:00',2.86),('5819','2013-06-25','16:00:00',2.83),('5819','2013-06-25','16:05:00',2.78),('5819','2013-06-25','16:10:00',2.71),('5819','2013-06-25','16:15:00',2.65),('5819','2013-06-25','16:20:00',2.58),('5819','2013-06-25','16:25:00',2.52),('5819','2013-06-25','16:30:00',2.46),('5819','2013-06-25','16:35:00',2.38),('5819','2013-06-25','16:40:00',2.32),('5819','2013-06-25','16:45:00',2.26),('5819','2013-06-25','16:50:00',2.2),('5819','2013-06-25','16:55:00',2.13),('5819','2013-06-25','17:00:00',2.06),('5819','2013-06-25','17:05:00',1.99),('5819','2013-06-25','17:10:00',1.91),('5819','2013-06-25','17:15:00',1.85),('5819','2013-06-25','17:20:00',1.78),('5819','2013-06-25','17:25:00',1.69),('5819','2013-06-25','17:30:00',1.62),('5819','2013-06-25','17:35:00',1.54),('5819','2013-06-25','17:40:00',1.47),('5819','2013-06-25','17:45:00',1.35),('5819','2013-06-25','17:50:00',1.2),('5819','2013-06-25','17:55:00',1.15),('5819','2013-06-25','18:00:00',1.12),('5819','2013-06-25','18:05:00',1.04),('5819','2013-06-24','08:45:00',1.94),('5819','2013-06-24','08:50:00',2.66),('5819','2013-06-24','08:55:00',2.71),('5819','2013-06-24','09:00:00',2.17),('5819','2013-06-24','09:05:00',2.38),('5819','2013-06-24','09:10:00',1.02),('5819','2013-06-24','09:15:00',2.69),('5819','2013-06-24','09:20:00',3.14),('5819','2013-06-24','09:25:00',2.94),('5819','2013-06-24','09:30:00',2.88),('5819','2013-06-24','09:40:00',2.21),('5819','2013-06-24','09:45:00',2.16),('5819','2013-06-24','09:50:00',2.69),('5819','2013-06-24','09:55:00',3.42),('5819','2013-06-24','10:00:00',3.41),('5819','2013-06-24','10:05:00',3.43),('5819','2013-06-24','10:10:00',3.55),('5819','2013-06-24','10:15:00',3.75),('5819','2013-06-24','10:20:00',2.38),('5819','2013-06-24','10:25:00',3.89),('5819','2013-06-24','10:30:00',2.22),('5819','2013-06-24','10:35:00',3.1),('5819','2013-06-24','10:40:00',2.33),('5819','2013-06-24','10:45:00',2.49),('5819','2013-06-24','10:50:00',3.17),('5819','2013-06-24','10:55:00',3.02),('5819','2013-06-24','11:00:00',4.25),('5819','2013-06-24','11:05:00',3.6),('5819','2013-06-24','11:10:00',3.67),('5819','2013-06-24','11:15:00',2.17),('5819','2013-06-24','11:20:00',3.22),('5819','2013-06-24','11:25:00',1.4),('5819','2013-06-24','11:30:00',1.62),('5819','2013-06-24','11:35:00',1.26),('5819','2013-06-24','11:40:00',1.31),('5819','2013-06-24','11:45:00',1.49),('5819','2013-06-24','11:50:00',2.59),('5819','2013-06-24','11:55:00',3.45),('5819','2013-06-24','12:00:00',3.38),('5819','2013-06-24','12:05:00',3.66),('5819','2013-06-24','12:10:00',4.1),('5819','2013-06-24','12:15:00',3.62),('5819','2013-06-24','12:20:00',3.64),('5819','2013-06-24','12:25:00',2.62),('5819','2013-06-24','12:30:00',2.5),('5819','2013-06-24','12:35:00',4.5),('5819','2013-06-24','12:40:00',4.57),('5819','2013-06-24','12:45:00',2.22),('5819','2013-06-24','12:50:00',4.74),('5819','2013-06-24','12:55:00',4.69),('5819','2013-06-24','13:00:00',4.35),('5819','2013-06-24','13:05:00',4.49),('5819','2013-06-24','13:10:00',3.83),('5819','2013-06-24','13:15:00',3.1),('5819','2013-06-24','13:20:00',2.37),('5819','2013-06-24','13:25:00',3.74),('5819','2013-06-24','13:30:00',4.29),('5819','2013-06-24','13:35:00',3.71),('5819','2013-06-24','13:40:00',4.07),('5819','2013-06-24','13:45:00',4.2),('5819','2013-06-24','13:50:00',4.04),('5819','2013-06-24','13:55:00',3.98),('5819','2013-06-24','14:00:00',3.96),('5819','2013-06-24','14:05:00',3.95),('5819','2013-06-24','14:10:00',3.93),('5819','2013-06-24','14:15:00',3.88),('5819','2013-06-24','14:20:00',3.87),('5819','2013-06-24','14:25:00',3.85),('5819','2013-06-24','14:30:00',3.84),('5819','2013-06-24','14:35:00',3.76),('5819','2013-06-24','14:40:00',3.77),('5819','2013-06-24','14:45:00',3.8),('5819','2013-06-24','14:50:00',3.56),('5819','2013-06-24','14:55:00',3.98),('5819','2013-06-24','15:00:00',3.94),('5819','2013-06-24','15:05:00',2.91),('5819','2013-06-24','15:10:00',1.86),('5819','2013-06-24','15:15:00',3.38),('5819','2013-06-24','15:20:00',3.62),('5819','2013-06-24','15:25:00',3.23),('5819','2013-06-24','15:30:00',2.51),('5819','2013-06-24','15:35:00',3.06),('5819','2013-06-24','15:40:00',2.07),('5819','2013-06-24','15:45:00',3.2),('5819','2013-06-24','15:50:00',2.14),('5819','2013-06-24','15:55:00',2.7),('5819','2013-06-24','16:00:00',3.15),('5819','2013-06-24','16:05:00',3.09),('5819','2013-06-24','16:10:00',3.11),('5819','2013-06-24','16:15:00',3.18),('5819','2013-06-24','16:20:00',2.51),('5819','2013-06-24','16:25:00',2.09),('5819','2013-06-24','16:30:00',2.71),('5819','2013-06-24','16:35:00',2.36),('5819','2013-06-24','16:40:00',1.61),('5819','2013-06-24','16:45:00',1.86),('5819','2013-06-24','16:50:00',1.78),('5819','2013-06-24','17:00:00',1.24),('5819','2013-06-24','17:05:00',1.64),('5819','2013-06-24','17:10:00',1.89),('5819','2013-06-24','17:15:00',2.39),('5819','2013-06-24','17:20:00',2.14),('5819','2013-06-24','17:25:00',1.36),('5819','2013-06-24','17:30:00',1.85),('5819','2013-06-24','17:35:00',1),('5819','2013-06-24','17:50:00',1.49),('5819','2013-06-24','18:00:00',1.36),('5819','2013-06-24','18:05:00',1.28),('5819','2013-06-24','18:15:00',1.06),('5819','2013-06-24','18:20:00',1.02),('5819','2013-06-23','08:50:00',1.64),('5819','2013-06-23','09:00:00',1.63),('5819','2013-06-23','09:05:00',1.61),('5819','2013-06-23','09:20:00',1.7),('5819','2013-06-23','09:25:00',2.66),('5819','2013-06-23','09:30:00',3.03),('5819','2013-06-23','09:35:00',3.05),('5819','2013-06-23','09:40:00',3.35),('5819','2013-06-23','09:45:00',2.34),('5819','2013-06-23','09:50:00',1.31),('5819','2013-06-23','09:55:00',1.18),('5819','2013-06-23','10:00:00',3.1),('5819','2013-06-23','10:05:00',3.49),('5819','2013-06-23','10:10:00',2.79),('5819','2013-06-23','10:15:00',3.42),('5819','2013-06-23','10:20:00',2.52),('5819','2013-06-23','10:25:00',1.38),('5819','2013-06-23','10:30:00',1.07),('5819','2013-06-23','10:40:00',1.57),('5819','2013-06-23','10:45:00',3.76),('5819','2013-06-23','10:50:00',2.01),('5819','2013-06-23','10:55:00',3.67),('5819','2013-06-23','11:00:00',3.55),('5819','2013-06-23','11:05:00',3.55),('5819','2013-06-23','11:10:00',3.68),('5819','2013-06-23','11:15:00',3.69),('5819','2013-06-23','11:20:00',3.83),('5819','2013-06-23','11:25:00',3.74),('5819','2013-06-23','11:30:00',3.68),('5819','2013-06-23','11:35:00',3.73),('5819','2013-06-23','11:40:00',3.68),('5819','2013-06-23','11:45:00',3.72),('5819','2013-06-23','11:50:00',3.79),('5819','2013-06-23','11:55:00',3.85),('5819','2013-06-23','12:00:00',2.78),('5819','2013-06-23','12:05:00',2.76),('5819','2013-06-23','12:10:00',4.03),('5819','2013-06-23','12:15:00',3.94),('5819','2013-06-23','12:20:00',3.96),('5819','2013-06-23','12:25:00',3.77),('5819','2013-06-23','12:30:00',3.91),('5819','2013-06-23','12:35:00',3.91),('5819','2013-06-23','12:40:00',3.93),('5819','2013-06-23','12:45:00',3.9),('5819','2013-06-23','12:50:00',3.91),('5819','2013-06-23','12:55:00',3.91),('5819','2013-06-23','13:00:00',3.93),('5819','2013-06-23','13:05:00',3.92),('5819','2013-06-23','13:10:00',3.91),('5819','2013-06-23','13:15:00',3.89),('5819','2013-06-23','13:20:00',3.87),('5819','2013-06-23','13:25:00',3.87),('5819','2013-06-23','13:30:00',3.86),('5819','2013-06-23','13:35:00',3.86),('5819','2013-06-23','13:40:00',3.87),('5819','2013-06-23','13:45:00',3.86),('5819','2013-06-23','13:50:00',3.84),('5819','2013-06-23','13:55:00',3.82),('5819','2013-06-23','14:00:00',3.78),('5819','2013-06-23','14:05:00',3.76),('5819','2013-06-23','14:10:00',3.72),('5819','2013-06-23','14:15:00',3.71),('5819','2013-06-23','14:20:00',3.7),('5819','2013-06-23','14:25:00',3.7),('5819','2013-06-23','14:30:00',3.68),('5819','2013-06-23','14:35:00',3.65),('5819','2013-06-23','14:40:00',3.61),('5819','2013-06-23','14:45:00',3.58),('5819','2013-06-23','14:50:00',3.56),('5819','2013-06-23','14:55:00',3.53),('5819','2013-06-23','15:00:00',3.5),('5819','2013-06-23','15:05:00',3.45),('5819','2013-06-23','15:10:00',3.4),('5819','2013-06-23','15:15:00',3.37),('5819','2013-06-23','15:20:00',3.32),('5819','2013-06-23','15:25:00',3.27),('5819','2013-06-23','15:30:00',3.2),('5819','2013-06-23','15:35:00',3.14),('5819','2013-06-23','15:40:00',3.11),('5819','2013-06-23','15:45:00',3.06),('5819','2013-06-23','15:50:00',3.01),('5819','2013-06-23','15:55:00',2.96),('5819','2013-06-23','16:00:00',2.89),('5819','2013-06-23','16:05:00',2.85),('5819','2013-06-23','16:10:00',2.77),('5819','2013-06-23','16:15:00',2.69),('5819','2013-06-23','16:20:00',2.62),('5819','2013-06-23','16:25:00',2.55),('5819','2013-06-23','16:30:00',2.5),('5819','2013-06-23','16:35:00',2.43),('5819','2013-06-23','16:40:00',2.38),('5819','2013-06-23','16:45:00',2.3),('5819','2013-06-23','16:50:00',2.24),('5819','2013-06-23','16:55:00',2.16),('5819','2013-06-23','17:00:00',2.09),('5819','2013-06-23','17:05:00',2.02),('5819','2013-06-23','17:10:00',1.95),('5819','2013-06-23','17:15:00',1.87),('5819','2013-06-23','17:20:00',1.73),('5819','2013-06-23','17:25:00',1.23),('5819','2013-06-23','17:30:00',1.63),('5819','2013-06-23','17:35:00',1.57),('5819','2013-06-23','17:40:00',1.5),('5819','2013-06-23','17:45:00',1.29),('5819','2013-06-23','17:50:00',1.25),('5819','2013-06-23','17:55:00',1.21),('5819','2013-06-23','18:00:00',1.13),('5819','2013-06-23','18:05:00',1.05),('5819','2013-06-22','07:25:00',1.02),('5819','2013-06-22','07:30:00',1.11),('5819','2013-06-22','07:35:00',1.18),('5819','2013-06-22','07:40:00',1.25),('5819','2013-06-22','07:45:00',1.31),('5819','2013-06-22','07:50:00',1.38),('5819','2013-06-22','07:55:00',1.46),('5819','2013-06-22','08:00:00',1.53),('5819','2013-06-22','08:05:00',1.59),('5819','2013-06-22','08:10:00',1.68),('5819','2013-06-22','08:15:00',1.75),('5819','2013-06-22','08:20:00',1.84),('5819','2013-06-22','08:25:00',1.94),('5819','2013-06-22','08:30:00',2.01),('5819','2013-06-22','08:35:00',2.09),('5819','2013-06-22','08:40:00',2.17),('5819','2013-06-22','08:45:00',2.24),('5819','2013-06-22','08:50:00',2.28),('5819','2013-06-22','08:55:00',2.36),('5819','2013-06-22','09:00:00',2.43),('5819','2013-06-22','09:05:00',2.47),('5819','2013-06-22','09:10:00',2.51),('5819','2013-06-22','09:15:00',2.57),('5819','2013-06-22','09:20:00',2.64),('5819','2013-06-22','09:25:00',2.67),('5819','2013-06-22','09:30:00',2.71),('5819','2013-06-22','09:35:00',2.78),('5819','2013-06-22','09:40:00',2.83),('5819','2013-06-22','09:45:00',2.88),('5819','2013-06-22','09:50:00',2.93),('5819','2013-06-22','09:55:00',2.97),('5819','2013-06-22','10:00:00',3.04),('5819','2013-06-22','10:05:00',3.09),('5819','2013-06-22','10:10:00',3.15),('5819','2013-06-22','10:15:00',3.18),('5819','2013-06-22','10:20:00',3.23),('5819','2013-06-22','10:25:00',3.27),('5819','2013-06-22','10:30:00',3.28),('5819','2013-06-22','10:35:00',3.32),('5819','2013-06-22','10:40:00',3.36),('5819','2013-06-22','10:45:00',3.42),('5819','2013-06-22','10:50:00',3.45),('5819','2013-06-22','10:55:00',3.46),('5819','2013-06-22','11:00:00',3.48),('5819','2013-06-22','11:05:00',3.51),('5819','2013-06-22','11:10:00',3.54),('5819','2013-06-22','11:15:00',3.57),('5819','2013-06-22','11:20:00',3.61),('5819','2013-06-22','11:25:00',3.63),('5819','2013-06-22','11:30:00',3.63),('5819','2013-06-22','11:35:00',3.65),('5819','2013-06-22','11:40:00',3.67),('5819','2013-06-22','11:45:00',3.67),('5819','2013-06-22','11:50:00',3.68),('5819','2013-06-22','11:55:00',3.69),('5819','2013-06-22','12:00:00',3.71),('5819','2013-06-22','12:05:00',3.65),('5819','2013-06-22','12:10:00',3.57),('5819','2013-06-22','12:15:00',3.72),('5819','2013-06-22','12:20:00',3.74),('5819','2013-06-22','12:25:00',3.66),('5819','2013-06-22','12:30:00',3.74),('5819','2013-06-22','12:35:00',3.77),('5819','2013-06-22','12:40:00',3.79),('5819','2013-06-22','12:45:00',3.76),('5819','2013-06-22','12:50:00',3.69),('5819','2013-06-22','12:55:00',3.66),('5819','2013-06-22','13:00:00',3.59),('5819','2013-06-22','13:05:00',3.6),('5819','2013-06-22','13:10:00',3.56),('5819','2013-06-22','13:15:00',3.51),('5819','2013-06-22','13:20:00',3.39),('5819','2013-06-22','13:25:00',3.52),('5819','2013-06-22','13:30:00',3.85),('5819','2013-06-22','13:35:00',3.84),('5819','2013-06-22','13:40:00',3.55),('5819','2013-06-22','13:45:00',3.5),('5819','2013-06-22','13:50:00',3.76),('5819','2013-06-22','13:55:00',3.01),('5819','2013-06-22','14:00:00',1.98),('5819','2013-06-22','14:05:00',4.05),('5819','2013-06-22','14:10:00',3.84),('5819','2013-06-22','14:15:00',3.79),('5819','2013-06-22','14:20:00',3.03),('5819','2013-06-22','14:25:00',3.74),('5819','2013-06-22','14:30:00',2.73),('5819','2013-06-22','14:35:00',2.08),('5819','2013-06-22','14:40:00',1.58),('5819','2013-06-22','14:45:00',1.78),('5819','2013-06-22','14:50:00',2.87),('5819','2013-06-22','14:55:00',3.59),('5819','2013-06-22','15:00:00',3.33),('5819','2013-06-22','15:05:00',2.96),('5819','2013-06-22','15:10:00',3.09),('5819','2013-06-22','15:15:00',3.48),('5819','2013-06-22','15:20:00',3.21),('5819','2013-06-22','15:25:00',3.01),('5819','2013-06-22','15:30:00',1.98),('5819','2013-06-22','15:35:00',1.82),('5819','2013-06-22','15:40:00',1.72),('5819','2013-06-22','15:45:00',2.24),('5819','2013-06-22','15:50:00',2.25),('5819','2013-06-22','15:55:00',2.14),('5819','2013-06-22','16:00:00',1.83),('5819','2013-06-22','16:05:00',1.16),('5819','2013-06-22','16:10:00',1.08),('5819','2013-06-22','16:15:00',1.32),('5819','2013-06-22','16:20:00',1.68),('5819','2013-06-22','16:25:00',1.24),('5819','2013-06-22','17:00:00',1.31),('5819','2013-06-22','17:05:00',1.27),('5819','2013-06-22','17:10:00',1.56),('5819','2013-06-22','17:15:00',2.28),('5819','2013-06-22','17:20:00',2.18),('5819','2013-06-22','17:25:00',2.17),('5819','2013-06-22','17:30:00',1.85),('5819','2013-06-22','17:35:00',1.42),('5819','2013-06-22','17:40:00',1.61),('5819','2013-06-22','17:45:00',1.56),('5819','2013-06-22','17:50:00',1.34),('5819','2013-06-22','17:55:00',1.23),('5819','2013-06-22','18:00:00',1.22),('5819','2013-06-22','18:05:00',1.01),('5819','2013-06-21','07:25:00',1.03),('5819','2013-06-21','07:30:00',1.1),('5819','2013-06-21','07:35:00',1.18),('5819','2013-06-21','07:40:00',1.25),('5819','2013-06-21','07:45:00',1.33),('5819','2013-06-21','07:50:00',1.4),('5819','2013-06-21','07:55:00',1.48),('5819','2013-06-21','08:00:00',1.55),('5819','2013-06-21','08:05:00',1.64),('5819','2013-06-21','08:10:00',1.71),('5819','2013-06-21','08:15:00',1.77),('5819','2013-06-21','08:20:00',1.84),('5819','2013-06-21','08:25:00',1.91),('5819','2013-06-21','08:30:00',1.99),('5819','2013-06-21','08:35:00',2.06),('5819','2013-06-21','08:40:00',2.12),('5819','2013-06-21','08:45:00',2.19),('5819','2013-06-21','08:50:00',2.25),('5819','2013-06-21','08:55:00',2.29),('5819','2013-06-21','09:00:00',2.35),('5819','2013-06-21','09:05:00',2.39),('5819','2013-06-21','09:10:00',2.44),('5819','2013-06-21','09:15:00',2.48),('5819','2013-06-21','09:20:00',2.52),('5819','2013-06-21','09:25:00',2.59),('5819','2013-06-21','09:30:00',2.62),('5819','2013-06-21','09:35:00',2.66),('5819','2013-06-21','09:40:00',2.72),('5819','2013-06-21','09:45:00',2.77),('5819','2013-06-21','09:50:00',2.84),('5819','2013-06-21','09:55:00',2.86),('5819','2013-06-21','10:00:00',2.87),('5819','2013-06-21','10:05:00',2.9),('5819','2013-06-21','10:10:00',2.95),('5819','2013-06-21','10:15:00',2.99),('5819','2013-06-21','10:20:00',3.03),('5819','2013-06-21','10:25:00',3.03),('5819','2013-06-21','10:30:00',3.1),('5819','2013-06-21','10:35:00',3.14),('5819','2013-06-21','10:40:00',3.13),('5819','2013-06-21','10:45:00',3.15),('5819','2013-06-21','10:50:00',3.23),('5819','2013-06-21','10:55:00',3.26),('5819','2013-06-21','11:00:00',3.29),('5819','2013-06-21','11:05:00',3.27),('5819','2013-06-21','11:10:00',3.27),('5819','2013-06-21','11:15:00',3.36),('5819','2013-06-21','11:20:00',3.4),('5819','2013-06-21','11:25:00',3.43),('5819','2013-06-21','11:30:00',3.45),('5819','2013-06-21','11:35:00',3.44),('5819','2013-06-21','11:40:00',3.48),('5819','2013-06-21','11:45:00',3.48),('5819','2013-06-21','11:50:00',3.54),('5819','2013-06-21','11:55:00',3.58),('5819','2013-06-21','12:00:00',3.55),('5819','2013-06-21','12:05:00',3.57),('5819','2013-06-21','12:10:00',3.57),('5819','2013-06-21','12:15:00',3.55),('5819','2013-06-21','12:20:00',3.54),('5819','2013-06-21','12:25:00',3.51),('5819','2013-06-21','12:30:00',3.63),('5819','2013-06-21','12:35:00',3.59),('5819','2013-06-21','12:40:00',3.54),('5819','2013-06-21','12:45:00',3.56),('5819','2013-06-21','12:50:00',3.51),('5819','2013-06-21','12:55:00',3.5),('5819','2013-06-21','13:00:00',3.5),('5819','2013-06-21','13:05:00',3.44),('5819','2013-06-21','13:10:00',3.44),('5819','2013-06-21','13:15:00',3.49),('5819','2013-06-21','13:20:00',3.52),('5819','2013-06-21','13:25:00',3.55),('5819','2013-06-21','13:30:00',3.57),('5819','2013-06-21','13:35:00',3.6),('5819','2013-06-21','13:40:00',3.57),('5819','2013-06-21','13:45:00',3.53),('5819','2013-06-21','13:50:00',3.54),('5819','2013-06-21','13:55:00',3.55),('5819','2013-06-21','14:00:00',3.51),('5819','2013-06-21','14:05:00',3.53),('5819','2013-06-21','14:10:00',3.47),('5819','2013-06-21','14:15:00',3.44),('5819','2013-06-21','14:20:00',3.43),('5819','2013-06-21','14:25:00',3.42),('5819','2013-06-21','14:30:00',3.43),('5819','2013-06-21','14:35:00',3.41),('5819','2013-06-21','14:40:00',3.38),('5819','2013-06-21','14:45:00',3.36),('5819','2013-06-21','14:50:00',3.32),('5819','2013-06-21','14:55:00',3.28),('5819','2013-06-21','15:00:00',3.25),('5819','2013-06-21','15:05:00',3.21),('5819','2013-06-21','15:10:00',3.16),('5819','2013-06-21','15:15:00',3.12),('5819','2013-06-21','15:20:00',3.09),('5819','2013-06-21','15:25:00',3.04),('5819','2013-06-21','15:30:00',3),('5819','2013-06-21','15:35:00',2.95),('5819','2013-06-21','15:40:00',2.9),('5819','2013-06-21','15:45:00',2.85),('5819','2013-06-21','15:50:00',2.81),('5819','2013-06-21','15:55:00',2.75),('5819','2013-06-21','16:00:00',2.69),('5819','2013-06-21','16:05:00',2.64),('5819','2013-06-21','16:10:00',2.59),('5819','2013-06-21','16:15:00',2.54),('5819','2013-06-21','16:20:00',2.47),('5819','2013-06-21','16:25:00',2.43),('5819','2013-06-21','16:30:00',2.37),('5819','2013-06-21','16:35:00',2.3),('5819','2013-06-21','16:40:00',2.23),('5819','2013-06-21','16:45:00',2.17),('5819','2013-06-21','16:50:00',2.1),('5819','2013-06-21','16:55:00',2.03),('5819','2013-06-21','17:00:00',1.96),('5819','2013-06-21','17:05:00',1.9),('5819','2013-06-21','17:10:00',1.84),('5819','2013-06-21','17:15:00',1.77),('5819','2013-06-21','17:20:00',1.69),('5819','2013-06-21','17:25:00',1.62),('5819','2013-06-21','17:30:00',1.55),('5819','2013-06-21','17:35:00',1.48),('5819','2013-06-21','17:40:00',1.4),('5819','2013-06-21','17:45:00',1.27),('5819','2013-06-21','17:50:00',1.13),('5819','2013-06-21','17:55:00',1.1),('5819','2013-06-21','18:00:00',1.05),('5819','2013-06-20','07:30:00',1.04),('5819','2013-06-20','07:35:00',1.1),('5819','2013-06-20','07:40:00',1.07),('5819','2013-06-20','07:45:00',1.18),('5819','2013-06-20','07:50:00',1.27),('5819','2013-06-20','07:55:00',1.41),('5819','2013-06-20','08:00:00',1.5),('5819','2013-06-20','08:05:00',1.62),('5819','2013-06-20','08:10:00',1.7),('5819','2013-06-20','08:15:00',1.78),('5819','2013-06-20','08:20:00',1.87),('5819','2013-06-20','08:25:00',1.94),('5819','2013-06-20','08:30:00',2.01),('5819','2013-06-20','08:35:00',2.08),('5819','2013-06-20','08:40:00',2.15),('5819','2013-06-20','08:45:00',2.22),('5819','2013-06-20','08:50:00',2.29),('5819','2013-06-20','08:55:00',2.33),('5819','2013-06-20','09:00:00',2.38),('5819','2013-06-20','09:05:00',2.45),('5819','2013-06-20','09:10:00',2.51),('5819','2013-06-20','09:15:00',2.55),('5819','2013-06-20','09:20:00',2.62),('5819','2013-06-20','09:25:00',2.67),('5819','2013-06-20','09:30:00',2.73),('5819','2013-06-20','09:35:00',2.77),('5819','2013-06-20','09:40:00',2.81),('5819','2013-06-20','09:45:00',2.83),('5819','2013-06-20','09:50:00',2.9),('5819','2013-06-20','09:55:00',2.94),('5819','2013-06-20','10:00:00',3.01),('5819','2013-06-20','10:05:00',3.04),('5819','2013-06-20','10:10:00',3.08),('5819','2013-06-20','10:15:00',3.1),('5819','2013-06-20','10:20:00',3.15),('5819','2013-06-20','10:25:00',3.19),('5819','2013-06-20','10:30:00',3.22),('5819','2013-06-20','10:35:00',3.27),('5819','2013-06-20','10:40:00',3.28),('5819','2013-06-20','10:45:00',3.3),('5819','2013-06-20','10:50:00',3.3),('5819','2013-06-20','10:55:00',3.32),('5819','2013-06-20','12:05:00',3.41),('5819','2013-06-20','12:10:00',3.45),('5819','2013-06-20','12:15:00',3.47),('5819','2013-06-20','12:20:00',3.42),('5819','2013-06-20','12:25:00',3.41),('5819','2013-06-20','12:30:00',3.37),('5819','2013-06-20','12:35:00',3.61),('5819','2013-06-20','12:40:00',3.49),('5819','2013-06-20','12:45:00',3.34),('5819','2013-06-20','12:50:00',3.62),('5819','2013-06-20','12:55:00',3.29),('5819','2013-06-20','13:00:00',1.79),('5819','2013-06-20','13:05:00',2.85),('5819','2013-06-20','13:10:00',3.77),('5819','2013-06-20','13:15:00',3.71),('5819','2013-06-20','13:20:00',3.58),('5819','2013-06-20','13:25:00',3.44),('5819','2013-06-20','13:30:00',3.09),('5819','2013-06-20','13:35:00',3.5),('5819','2013-06-20','13:40:00',3.53),('5819','2013-06-20','13:45:00',3.55),('5819','2013-06-20','13:50:00',3.52),('5819','2013-06-20','13:55:00',3.5),('5819','2013-06-20','14:00:00',3.51),('5819','2013-06-20','14:05:00',3.57),('5819','2013-06-20','14:10:00',3.58),('5819','2013-06-20','14:15:00',3.54),('5819','2013-06-20','14:20:00',3.53),('5819','2013-06-20','14:25:00',3.49),('5819','2013-06-20','14:30:00',3.44),('5819','2013-06-20','14:35:00',3.46),('5819','2013-06-20','14:40:00',3.47),('5819','2013-06-20','14:45:00',3.43),('5819','2013-06-20','14:50:00',3.43),('5819','2013-06-20','14:55:00',3.38),('5819','2013-06-20','15:00:00',3.34),('5819','2013-06-20','15:05:00',3.28),('5819','2013-06-20','15:10:00',3.24),('5819','2013-06-20','15:15:00',3.2),('5819','2013-06-20','15:20:00',3.15),('5819','2013-06-20','15:25:00',3.12),('5819','2013-06-20','15:30:00',3.07),('5819','2013-06-20','15:35:00',3.01),('5819','2013-06-20','15:40:00',2.96),('5819','2013-06-20','15:45:00',2.92),('5819','2013-06-20','15:50:00',2.87),('5819','2013-06-20','15:55:00',2.81),('5819','2013-06-20','16:00:00',2.75),('5819','2013-06-20','16:05:00',2.71),('5819','2013-06-20','16:10:00',2.65),('5819','2013-06-20','16:15:00',2.58),('5819','2013-06-20','16:20:00',2.51),('5819','2013-06-20','16:25:00',2.46),('5819','2013-06-20','16:30:00',2.4),('5819','2013-06-20','16:35:00',2.33),('5819','2013-06-20','16:40:00',2.25),('5819','2013-06-20','16:45:00',2.16),('5819','2013-06-20','16:50:00',2.11),('5819','2013-06-20','16:55:00',2.05),('5819','2013-06-20','17:00:00',1.99),('5819','2013-06-20','17:05:00',1.92),('5819','2013-06-20','17:10:00',1.85),('5819','2013-06-20','17:15:00',1.77),('5819','2013-06-20','17:20:00',1.7),('5819','2013-06-20','17:25:00',1.63),('5819','2013-06-20','17:30:00',1.56),('5819','2013-06-20','17:35:00',1.48),('5819','2013-06-20','17:40:00',1.4),('5819','2013-06-20','17:45:00',1.25),('5819','2013-06-20','17:50:00',1.17),('5819','2013-06-20','17:55:00',1.13),('5819','2013-06-20','18:00:00',1.06),('5819','2013-06-19','07:25:00',1),('5819','2013-06-19','07:30:00',1.07),('5819','2013-06-19','07:35:00',1.14),('5819','2013-06-19','07:40:00',1.2),('5819','2013-06-19','07:45:00',1.28),('5819','2013-06-19','07:50:00',1.37),('5819','2013-06-19','07:55:00',1.46),('5819','2013-06-19','08:00:00',1.52),('5819','2013-06-19','08:05:00',1.6),('5819','2013-06-19','08:10:00',1.68),('5819','2013-06-19','08:15:00',1.75),('5819','2013-06-19','08:20:00',1.82),('5819','2013-06-19','08:25:00',1.88),('5819','2013-06-19','08:30:00',1.96),('5819','2013-06-19','08:35:00',2.04),('5819','2013-06-19','08:40:00',2.1),('5819','2013-06-19','08:45:00',2.16),('5819','2013-06-19','08:50:00',2.23),('5819','2013-06-19','08:55:00',2.29),('5819','2013-06-19','09:00:00',2.34),('5819','2013-06-19','09:05:00',2.4),('5819','2013-06-19','09:10:00',2.47),('5819','2013-06-19','09:15:00',2.52),('5819','2013-06-19','09:20:00',2.57),('5819','2013-06-19','09:25:00',2.62),('5819','2013-06-19','09:30:00',2.68),('5819','2013-06-19','09:35:00',2.72),('5819','2013-06-19','09:40:00',2.76),('5819','2013-06-19','09:45:00',2.81),('5819','2013-06-19','09:50:00',2.84),('5819','2013-06-19','09:55:00',2.9),('5819','2013-06-19','10:00:00',2.93),('5819','2013-06-19','10:05:00',2.97),('5819','2013-06-19','10:10:00',3),('5819','2013-06-19','10:15:00',3.06),('5819','2013-06-19','10:20:00',3.1),('5819','2013-06-19','10:25:00',3.11),('5819','2013-06-19','10:30:00',3.12),('5819','2013-06-19','10:35:00',3.14),('5819','2013-06-19','10:40:00',3.16),('5819','2013-06-19','10:45:00',3.23),('5819','2013-06-19','10:50:00',3.24),('5819','2013-06-19','10:55:00',3.27),('5819','2013-06-19','11:00:00',3.25),('5819','2013-06-19','11:05:00',3.32),('5819','2013-06-19','11:10:00',3.32),('5819','2013-06-19','11:15:00',3.33),('5819','2013-06-19','11:20:00',3.36),('5819','2013-06-19','11:25:00',3.34),('5819','2013-06-19','11:30:00',3.36),('5819','2013-06-19','11:35:00',3.39),('5819','2013-06-19','11:40:00',3.43),('5819','2013-06-19','11:45:00',3.44),('5819','2013-06-19','11:50:00',3.41),('5819','2013-06-19','11:55:00',3.39),('5819','2013-06-19','12:00:00',3.44),('5819','2013-06-19','12:05:00',3.41),('5819','2013-06-19','12:10:00',3.48),('5819','2013-06-19','12:15:00',3.46),('5819','2013-06-19','12:20:00',3.48),('5819','2013-06-19','12:25:00',3.49),('5819','2013-06-19','12:30:00',3.53),('5819','2013-06-19','12:35:00',3.54),('5819','2013-06-19','12:40:00',3.52),('5819','2013-06-19','12:45:00',3.57),('5819','2013-06-19','12:50:00',3.56),('5819','2013-06-19','12:55:00',3.55),('5819','2013-06-19','13:00:00',3.51),('5819','2013-06-19','13:05:00',3.49),('5819','2013-06-19','13:10:00',3.49),('5819','2013-06-19','13:15:00',3.51),('5819','2013-06-19','13:20:00',3.47),('5819','2013-06-19','13:25:00',3.53),('5819','2013-06-19','13:30:00',3.55),('5819','2013-06-19','13:35:00',3.52),('5819','2013-06-19','13:40:00',3.53),('5819','2013-06-19','13:45:00',3.52),('5819','2013-06-19','13:50:00',3.49),('5819','2013-06-19','13:55:00',3.53),('5819','2013-06-19','14:00:00',3.53),('5819','2013-06-19','14:05:00',3.5),('5819','2013-06-19','14:10:00',3.45),('5819','2013-06-19','14:15:00',3.43),('5819','2013-06-19','14:20:00',3.4),('5819','2013-06-19','14:25:00',3.37),('5819','2013-06-19','14:30:00',3.33),('5819','2013-06-19','14:35:00',3.29),('5819','2013-06-19','14:40:00',3.26),('5819','2013-06-19','14:45:00',3.23),('5819','2013-06-19','14:50:00',3.2),('5819','2013-06-19','14:55:00',3.16),('5819','2013-06-19','15:00:00',3.14),('5819','2013-06-19','15:05:00',3.11),('5819','2013-06-19','15:10:00',3.06),('5819','2013-06-19','15:15:00',3.03),('5819','2013-06-19','15:20:00',3),('5819','2013-06-19','15:25:00',2.95),('5819','2013-06-19','15:30:00',2.91),('5819','2013-06-19','15:35:00',2.87),('5819','2013-06-19','15:40:00',2.83),('5819','2013-06-19','15:45:00',2.79),('5819','2013-06-19','15:50:00',2.71),('5819','2013-06-19','15:55:00',2.65),('5819','2013-06-19','16:00:00',2.6),('5819','2013-06-19','16:05:00',2.54),('5819','2013-06-19','16:10:00',2.5),('5819','2013-06-19','16:15:00',2.44),('5819','2013-06-19','16:20:00',2.37),('5819','2013-06-19','16:25:00',2.32),('5819','2013-06-19','16:30:00',2.26),('5819','2013-06-19','16:35:00',2.2),('5819','2013-06-19','16:40:00',2.14),('5819','2013-06-19','16:45:00',2.08),('5819','2013-06-19','16:50:00',2.02),('5819','2013-06-19','16:55:00',1.96),('5819','2013-06-19','17:00:00',1.91),('5819','2013-06-19','17:05:00',1.84),('5819','2013-06-19','17:10:00',1.79),('5819','2013-06-19','17:15:00',1.72),('5819','2013-06-19','17:20:00',1.67),('5819','2013-06-19','17:25:00',1.61),('5819','2013-06-19','17:30:00',1.53),('5819','2013-06-19','17:35:00',1.45),('5819','2013-06-19','17:40:00',1.38),('5819','2013-06-19','17:45:00',1.23),('5819','2013-06-19','17:50:00',1.12),('5819','2013-06-19','17:55:00',1.07),('5819','2013-06-19','18:00:00',1.04),('5819','2013-06-18','07:30:00',1.06),('5819','2013-06-18','07:35:00',1.13),('5819','2013-06-18','07:40:00',1.2),('5819','2013-06-18','07:45:00',1.27),('5819','2013-06-18','07:50:00',1.34),('5819','2013-06-18','07:55:00',1.43),('5819','2013-06-18','08:00:00',1.5),('5819','2013-06-18','08:05:00',1.58),('5819','2013-06-18','08:10:00',1.65),('5819','2013-06-18','08:15:00',1.72),('5819','2013-06-18','08:20:00',1.79),('5819','2013-06-18','08:25:00',1.86),('5819','2013-06-18','08:30:00',1.94),('5819','2013-06-18','08:35:00',2),('5819','2013-06-18','08:40:00',2.07),('5819','2013-06-18','08:45:00',2.13),('5819','2013-06-18','08:50:00',2.2),('5819','2013-06-18','08:55:00',2.27),('5819','2013-06-18','09:00:00',2.3),('5819','2013-06-18','09:05:00',2.36),('5819','2013-06-18','09:10:00',2.42),('5819','2013-06-18','09:15:00',2.49),('5819','2013-06-18','09:20:00',2.54),('5819','2013-06-18','09:25:00',2.6),('5819','2013-06-18','09:30:00',2.64),('5819','2013-06-18','09:35:00',2.68),('5819','2013-06-18','09:40:00',2.73),('5819','2013-06-18','09:45:00',2.75),('5819','2013-06-18','09:50:00',2.8),('5819','2013-06-18','09:55:00',2.83),('5819','2013-06-18','10:00:00',2.88),('5819','2013-06-18','10:05:00',2.9),('5819','2013-06-18','10:10:00',2.96),('5819','2013-06-18','10:15:00',3.01),('5819','2013-06-18','10:20:00',3.06),('5819','2013-06-18','10:25:00',3.06),('5819','2013-06-18','10:30:00',3.08),('5819','2013-06-18','10:35:00',3.08),('5819','2013-06-18','10:40:00',3.13),('5819','2013-06-18','10:45:00',3.18),('5819','2013-06-18','10:50:00',3.2),('5819','2013-06-18','10:55:00',3.24),('5819','2013-06-18','11:00:00',3.28),('5819','2013-06-18','11:05:00',3.31),('5819','2013-06-18','11:10:00',3.35),('5819','2013-06-18','11:15:00',3.37),('5819','2013-06-18','11:20:00',3.36),('5819','2013-06-18','11:25:00',3.39),('5819','2013-06-18','11:30:00',3.41),('5819','2013-06-18','11:35:00',3.42),('5819','2013-06-18','11:40:00',3.35),('5819','2013-06-18','11:45:00',3.38),('5819','2013-06-18','11:50:00',3.43),('5819','2013-06-18','11:55:00',3.41),('5819','2013-06-18','12:00:00',3.39),('5819','2013-06-18','12:05:00',3.4),('5819','2013-06-18','12:10:00',3.38),('5819','2013-06-18','12:15:00',3.37),('5819','2013-06-18','12:20:00',3.36),('5819','2013-06-18','12:25:00',3.36),('5819','2013-06-18','12:30:00',3.41),('5819','2013-06-18','12:35:00',3.4),('5819','2013-06-18','12:40:00',3.43),('5819','2013-06-18','12:45:00',2.63),('5819','2013-06-18','12:50:00',3.09),('5819','2013-06-18','12:55:00',3.5),('5819','2013-06-18','13:00:00',3.65),('5819','2013-06-18','13:05:00',2.09),('5819','2013-06-18','13:10:00',2.45),('5819','2013-06-18','13:15:00',3.68),('5819','2013-06-18','13:20:00',3.7),('5819','2013-06-18','13:25:00',3.74),('5819','2013-06-18','13:30:00',2.39),('5819','2013-06-18','13:35:00',3.5),('5819','2013-06-18','13:40:00',3.59),('5819','2013-06-18','13:45:00',3.54),('5819','2013-06-18','13:50:00',3.57),('5819','2013-06-18','13:55:00',3.62),('5819','2013-06-18','14:00:00',3.59),('5819','2013-06-18','14:05:00',3.61),('5819','2013-06-18','14:10:00',3.55),('5819','2013-06-18','14:15:00',3.5),('5819','2013-06-18','14:20:00',3.43),('5819','2013-06-18','14:25:00',3.42),('5819','2013-06-18','14:30:00',3.4),('5819','2013-06-18','14:35:00',3.39),('5819','2013-06-18','14:40:00',3.41),('5819','2013-06-18','14:45:00',3.33),('5819','2013-06-18','14:50:00',3.3),('5819','2013-06-18','14:55:00',3.27),('5819','2013-06-18','15:00:00',3.26),('5819','2013-06-18','15:05:00',3.19),('5819','2013-06-18','15:10:00',3.14),('5819','2013-06-18','15:15:00',3.1),('5819','2013-06-18','15:20:00',3.05),('5819','2013-06-18','15:25:00',3.01),('5819','2013-06-18','15:30:00',2.96),('5819','2013-06-18','15:35:00',2.94),('5819','2013-06-18','15:40:00',2.92),('5819','2013-06-18','15:45:00',2.9),('5819','2013-06-18','15:50:00',2.83),('5819','2013-06-18','15:55:00',2.82),('5819','2013-06-18','16:00:00',2.79),('5819','2013-06-18','16:05:00',2.76),('5819','2013-06-18','16:10:00',2.71),('5819','2013-06-18','16:15:00',2.68),('5819','2013-06-18','16:20:00',2.62),('5819','2013-06-18','16:25:00',2.43),('5819','2013-06-18','16:30:00',2.29),('5819','2013-06-18','16:35:00',2.28),('5819','2013-06-18','16:40:00',2.24),('5819','2013-06-18','16:45:00',2.13),('5819','2013-06-18','16:50:00',2.07),('5819','2013-06-18','16:55:00',2.01),('5819','2013-06-18','17:00:00',1.95),('5819','2013-06-18','17:05:00',1.89),('5819','2013-06-18','17:10:00',1.82),('5819','2013-06-18','17:15:00',1.75),('5819','2013-06-18','17:20:00',1.69),('5819','2013-06-18','17:25:00',1.6),('5819','2013-06-18','17:30:00',1.52),('5819','2013-06-18','17:35:00',1.45),('5819','2013-06-18','17:40:00',1.38),('5819','2013-06-18','17:45:00',1.25),('5819','2013-06-18','17:50:00',1.13),('5819','2013-06-18','17:55:00',1.11),('5819','2013-06-18','18:00:00',1.06),('5819','2013-06-18','18:05:00',1),('5819','2013-06-17','07:25:00',1.05),('5819','2013-06-17','07:30:00',1.13),('5819','2013-06-17','07:35:00',1.2),('5819','2013-06-17','07:40:00',1.28),('5819','2013-06-17','07:45:00',1.35),('5819','2013-06-17','07:50:00',1.44),('5819','2013-06-17','07:55:00',1.53),('5819','2013-06-17','08:00:00',1.61),('5819','2013-06-17','08:05:00',1.68),('5819','2013-06-17','08:10:00',1.76),('5819','2013-06-17','08:15:00',1.84),('5819','2013-06-17','08:20:00',1.91),('5819','2013-06-17','08:25:00',1.98),('5819','2013-06-17','08:30:00',2.04),('5819','2013-06-17','08:35:00',2.11),('5819','2013-06-17','08:40:00',2.17),('5819','2013-06-17','08:45:00',2.24),('5819','2013-06-17','08:50:00',2.31),('5819','2013-06-17','08:55:00',2.38),('5819','2013-06-17','09:00:00',2.44),('5819','2013-06-17','09:05:00',2.49),('5819','2013-06-17','09:10:00',2.55),('5819','2013-06-17','09:15:00',2.59),('5819','2013-06-17','09:20:00',2.65),('5819','2013-06-17','09:25:00',2.71),('5819','2013-06-17','09:30:00',2.77),('5819','2013-06-17','09:35:00',2.81),('5819','2013-06-17','09:40:00',2.86),('5819','2013-06-17','09:45:00',2.92),('5819','2013-06-17','09:50:00',2.98),('5819','2013-06-17','09:55:00',3.01),('5819','2013-06-17','10:00:00',3.04),('5819','2013-06-17','10:05:00',3.07),('5819','2013-06-17','10:10:00',3.1),('5819','2013-06-17','10:15:00',3.15),('5819','2013-06-17','10:20:00',3.18),('5819','2013-06-17','10:25:00',3.22),('5819','2013-06-17','10:30:00',3.24),('5819','2013-06-17','10:35:00',3.27),('5819','2013-06-17','10:40:00',3.3),('5819','2013-06-17','10:45:00',3.33),('5819','2013-06-17','10:50:00',3.34),('5819','2013-06-17','10:55:00',3.38),('5819','2013-06-17','11:00:00',3.39),('5819','2013-06-17','11:05:00',3.41),('5819','2013-06-17','11:10:00',3.43),('5819','2013-06-17','11:15:00',3.44),('5819','2013-06-17','11:20:00',3.48),('5819','2013-06-17','11:25:00',3.49),('5819','2013-06-17','11:30:00',3.49),('5819','2013-06-17','11:35:00',3.5),('5819','2013-06-17','11:40:00',3.49),('5819','2013-06-17','11:45:00',3.53),('5819','2013-06-17','11:50:00',3.5),('5819','2013-06-17','11:55:00',3.52),('5819','2013-06-17','12:00:00',3.49),('5819','2013-06-17','12:05:00',3.51),('5819','2013-06-17','12:10:00',3.54),('5819','2013-06-17','12:15:00',3.56),('5819','2013-06-17','12:20:00',3.58),('5819','2013-06-17','12:25:00',3.56),('5819','2013-06-17','12:30:00',3.56),('5819','2013-06-17','12:35:00',3.56),('5819','2013-06-17','12:40:00',3.56),('5819','2013-06-17','12:45:00',3.54),('5819','2013-06-17','12:50:00',3.58),('5819','2013-06-17','12:55:00',3.61),('5819','2013-06-17','13:00:00',3.64),('5819','2013-06-17','13:05:00',3.65),('5819','2013-06-17','13:10:00',3.65),('5819','2013-06-17','13:15:00',3.64),('5819','2013-06-17','13:20:00',3.61),('5819','2013-06-17','13:25:00',3.58),('5819','2013-06-17','13:30:00',3.59),('5819','2013-06-17','13:35:00',3.54),('5819','2013-06-17','13:40:00',3.54),('5819','2013-06-17','13:45:00',3.52),('5819','2013-06-17','13:50:00',3.5),('5819','2013-06-17','13:55:00',3.48),('5819','2013-06-17','14:00:00',3.48),('5819','2013-06-17','14:05:00',3.47),('5819','2013-06-17','14:10:00',3.43),('5819','2013-06-17','14:15:00',3.41),('5819','2013-06-17','14:20:00',3.41),('5819','2013-06-17','14:25:00',3.39),('5819','2013-06-17','14:30:00',3.37),('5819','2013-06-17','14:35:00',3.36),('5819','2013-06-17','14:40:00',3.33),('5819','2013-06-17','14:45:00',3.29),('5819','2013-06-17','14:50:00',3.26),('5819','2013-06-17','14:55:00',3.23),('5819','2013-06-17','15:00:00',3.18),('5819','2013-06-17','15:05:00',3.14),('5819','2013-06-17','15:10:00',3.1),('5819','2013-06-17','15:15:00',3.06),('5819','2013-06-17','15:20:00',3.03),('5819','2013-06-17','15:25:00',2.98),('5819','2013-06-17','15:30:00',2.95),('5819','2013-06-17','15:35:00',2.92),('5819','2013-06-17','15:40:00',2.86),('5819','2013-06-17','15:45:00',2.81),('5819','2013-06-17','15:50:00',2.77),('5819','2013-06-17','15:55:00',2.71),('5819','2013-06-17','16:00:00',2.66),('5819','2013-06-17','16:05:00',2.62),('5819','2013-06-17','16:10:00',2.57),('5819','2013-06-17','16:15:00',2.52),('5819','2013-06-17','16:20:00',2.46),('5819','2013-06-17','16:25:00',2.4),('5819','2013-06-17','16:30:00',2.34),('5819','2013-06-17','16:35:00',2.28),('5819','2013-06-17','16:40:00',2.22),('5819','2013-06-17','16:45:00',2.16),('5819','2013-06-17','16:50:00',2.1),('5819','2013-06-17','16:55:00',2.03),('5819','2013-06-17','17:00:00',1.98),('5819','2013-06-17','17:05:00',1.91),('5819','2013-06-17','17:10:00',1.85),('5819','2013-06-17','17:15:00',1.78),('5819','2013-06-17','17:20:00',1.72),('5819','2013-06-17','17:25:00',1.65),('5819','2013-06-17','17:30:00',1.59),('5819','2013-06-17','17:35:00',1.52),('5819','2013-06-17','17:40:00',1.44),('5819','2013-06-17','17:45:00',1.31),('5819','2013-06-17','17:50:00',1.2),('5819','2013-06-17','17:55:00',1.17),('5819','2013-06-17','18:00:00',1.11),('5819','2013-06-17','18:05:00',1.04),('5819','2013-06-16','07:20:00',1.02),('5819','2013-06-16','07:25:00',1.09),('5819','2013-06-16','07:30:00',1.17),('5819','2013-06-16','07:35:00',1.25),('5819','2013-06-16','07:40:00',1.33),('5819','2013-06-16','07:45:00',1.41),('5819','2013-06-16','07:50:00',1.48),('5819','2013-06-16','07:55:00',1.56),('5819','2013-06-16','08:00:00',1.64),('5819','2013-06-16','08:05:00',1.71),('5819','2013-06-16','08:10:00',1.78),('5819','2013-06-16','08:15:00',1.86),('5819','2013-06-16','08:20:00',1.93),('5819','2013-06-16','08:25:00',2.02),('5819','2013-06-16','08:30:00',2.08),('5819','2013-06-16','08:35:00',2.16),('5819','2013-06-16','08:40:00',2.22),('5819','2013-06-16','08:45:00',2.29),('5819','2013-06-16','08:50:00',2.33),('5819','2013-06-16','08:55:00',2.41),('5819','2013-06-16','09:00:00',2.48),('5819','2013-06-16','09:05:00',2.54),('5819','2013-06-16','09:10:00',2.6),('5819','2013-06-16','09:15:00',2.67),('5819','2013-06-16','09:20:00',2.73),('5819','2013-06-16','09:25:00',2.78),('5819','2013-06-16','09:30:00',2.82),('5819','2013-06-16','09:35:00',2.88),('5819','2013-06-16','09:40:00',2.93),('5819','2013-06-16','09:45:00',2.96),('5819','2013-06-16','09:50:00',3.02),('5819','2013-06-16','09:55:00',3.04),('5819','2013-06-16','10:00:00',3.08),('5819','2013-06-16','10:05:00',3.11),('5819','2013-06-16','10:10:00',3.12),('5819','2013-06-16','10:15:00',3.2),('5819','2013-06-16','10:20:00',3.22),('5819','2013-06-16','10:25:00',3.25),('5819','2013-06-16','10:30:00',3.31),('5819','2013-06-16','10:35:00',3.34),('5819','2013-06-16','10:40:00',3.37),('5819','2013-06-16','10:45:00',3.38),('5819','2013-06-16','10:50:00',3.42),('5819','2013-06-16','10:55:00',3.42),('5819','2013-06-16','11:00:00',3.44),('5819','2013-06-16','11:05:00',3.45),('5819','2013-06-16','11:10:00',3.49),('5819','2013-06-16','11:15:00',3.5),('5819','2013-06-16','11:20:00',3.52),('5819','2013-06-16','11:25:00',3.55),('5819','2013-06-16','11:30:00',3.59),('5819','2013-06-16','11:35:00',3.64),('5819','2013-06-16','11:40:00',3.64),('5819','2013-06-16','11:45:00',3.64),('5819','2013-06-16','11:50:00',3.66),('5819','2013-06-16','11:55:00',3.68),('5819','2013-06-16','12:00:00',3.7),('5819','2013-06-16','12:05:00',3.7),('5819','2013-06-16','12:10:00',3.72),('5819','2013-06-16','12:15:00',3.72),('5819','2013-06-16','12:20:00',3.74),('5819','2013-06-16','12:25:00',3.77),('5819','2013-06-16','12:30:00',3.75),('5819','2013-06-16','12:35:00',3.73),('5819','2013-06-16','12:40:00',3.72),('5819','2013-06-16','12:45:00',3.71),('5819','2013-06-16','12:50:00',3.71),('5819','2013-06-16','12:55:00',3.72),('5819','2013-06-16','13:00:00',3.72),('5819','2013-06-16','13:05:00',3.73),('5819','2013-06-16','13:10:00',3.76),('5819','2013-06-16','13:15:00',3.75),('5819','2013-06-16','13:20:00',3.75),('5819','2013-06-16','13:25:00',3.74),('5819','2013-06-16','13:30:00',3.73),('5819','2013-06-16','13:35:00',3.73),('5819','2013-06-16','13:40:00',3.69),('5819','2013-06-16','13:45:00',3.69),('5819','2013-06-16','13:50:00',3.67),('5819','2013-06-16','13:55:00',3.66),('5819','2013-06-16','14:00:00',3.67),('5819','2013-06-16','14:05:00',3.63),('5819','2013-06-16','14:10:00',3.6),('5819','2013-06-16','14:15:00',3.58),('5819','2013-06-16','14:20:00',3.54),('5819','2013-06-16','14:25:00',3.51),('5819','2013-06-16','14:30:00',3.48),('5819','2013-06-16','14:35:00',3.44),('5819','2013-06-16','14:40:00',3.41),('5819','2013-06-16','14:45:00',3.39),('5819','2013-06-16','14:50:00',3.35),('5819','2013-06-16','14:55:00',3.3),('5819','2013-06-16','15:00:00',3.27),('5819','2013-06-16','15:05:00',3.25),('5819','2013-06-16','15:10:00',3.2),('5819','2013-06-16','15:15:00',3.17),('5819','2013-06-16','15:20:00',3.13),('5819','2013-06-16','15:25:00',3.1),('5819','2013-06-16','15:30:00',3.04),('5819','2013-06-16','15:35:00',2.99),('5819','2013-06-16','15:40:00',2.95),('5819','2013-06-16','15:45:00',2.9),('5819','2013-06-16','15:50:00',2.84),('5819','2013-06-16','15:55:00',2.79),('5819','2013-06-16','16:00:00',2.73),('5819','2013-06-16','16:05:00',2.68),('5819','2013-06-16','16:10:00',2.63),('5819','2013-06-16','16:15:00',2.57),('5819','2013-06-16','16:20:00',2.51),('5819','2013-06-16','16:25:00',2.45),('5819','2013-06-16','16:30:00',2.4),('5819','2013-06-16','16:35:00',2.33),('5819','2013-06-16','16:40:00',2.25),('5819','2013-06-16','16:45:00',2.18),('5819','2013-06-16','16:50:00',2.11),('5819','2013-06-16','16:55:00',2.04),('5819','2013-06-16','17:00:00',1.97),('5819','2013-06-16','17:05:00',1.9),('5819','2013-06-16','17:10:00',1.83),('5819','2013-06-16','17:15:00',1.75),('5819','2013-06-16','17:20:00',1.68),('5819','2013-06-16','17:25:00',1.61),('5819','2013-06-16','17:30:00',1.53),('5819','2013-06-16','17:35:00',1.46),('5819','2013-06-16','17:40:00',1.39),('5819','2013-06-16','17:45:00',1.23),('5819','2013-06-16','17:50:00',1.14),('5819','2013-06-16','17:55:00',1.11),('5819','2013-06-16','18:00:00',1.04),('5819','2013-06-15','07:25:00',1.02),('5819','2013-06-15','07:30:00',1.09),('5819','2013-06-15','07:35:00',1.17),('5819','2013-06-15','07:40:00',1.25),('5819','2013-06-15','07:45:00',1.33),('5819','2013-06-15','07:50:00',1.41),('5819','2013-06-15','07:55:00',1.5),('5819','2013-06-15','08:00:00',1.55),('5819','2013-06-15','08:05:00',1.65),('5819','2013-06-15','08:10:00',1.73),('5819','2013-06-15','08:15:00',1.8),('5819','2013-06-15','08:20:00',1.89),('5819','2013-06-15','08:25:00',1.96),('5819','2013-06-15','08:30:00',1.99),('5819','2013-06-15','08:35:00',2.06),('5819','2013-06-15','08:40:00',2.16),('5819','2013-06-15','08:45:00',2.26),('5819','2013-06-15','08:50:00',2.31),('5819','2013-06-15','08:55:00',2.25),('5819','2013-06-15','09:00:00',2.3),('5819','2013-06-15','09:05:00',2.5),('5819','2013-06-15','09:10:00',2.55),('5819','2013-06-15','09:15:00',2.64),('5819','2013-06-15','09:20:00',2.69),('5819','2013-06-15','09:25:00',2.67),('5819','2013-06-15','09:30:00',2.76),('5819','2013-06-15','09:35:00',2.66),('5819','2013-06-15','09:40:00',2.84),('5819','2013-06-15','09:45:00',2.68),('5819','2013-06-15','09:50:00',2.96),('5819','2013-06-15','09:55:00',3.02),('5819','2013-06-15','10:00:00',2.34),('5819','2013-06-15','10:05:00',1.76),('5819','2013-06-15','10:10:00',2.02),('5819','2013-06-15','10:15:00',2.36),('5819','2013-06-15','10:20:00',3.04),('5819','2013-06-15','10:25:00',2.91),('5819','2013-06-15','10:30:00',3.23),('5819','2013-06-15','10:35:00',3.43),('5819','2013-06-15','10:40:00',3.42),('5819','2013-06-15','10:45:00',3.32),('5819','2013-06-15','10:50:00',3.51),('5819','2013-06-15','10:55:00',3.53),('5819','2013-06-15','11:00:00',2.27),('5819','2013-06-15','11:05:00',1.76),('5819','2013-06-15','11:10:00',3.13),('5819','2013-06-15','11:15:00',3.43),('5819','2013-06-15','11:20:00',3.41),('5819','2013-06-15','11:25:00',3.55),('5819','2013-06-15','11:30:00',2.78),('5819','2013-06-15','11:35:00',2.85),('5819','2013-06-15','11:40:00',2.44),('5819','2013-06-15','11:45:00',1.72),('5819','2013-06-15','11:50:00',1.93),('5819','2013-06-15','11:55:00',4.05),('5819','2013-06-15','12:00:00',3.94),('5819','2013-06-15','12:05:00',3.54),('5819','2013-06-15','12:10:00',3.87),('5819','2013-06-15','12:15:00',3.94),('5819','2013-06-15','12:20:00',3.9),('5819','2013-06-15','12:25:00',3.84),('5819','2013-06-15','12:30:00',3.87),('5819','2013-06-15','12:35:00',3.89),('5819','2013-06-15','12:40:00',3.87),('5819','2013-06-15','12:45:00',3.83),('5819','2013-06-15','12:50:00',3.81),('5819','2013-06-15','12:55:00',3.81),('5819','2013-06-15','13:00:00',3.83),('5819','2013-06-15','13:05:00',3.78),('5819','2013-06-15','13:10:00',3.76),('5819','2013-06-15','13:15:00',3.78),('5819','2013-06-15','13:20:00',3.75),('5819','2013-06-15','13:25:00',3.74),('5819','2013-06-15','13:30:00',3.74),('5819','2013-06-15','13:35:00',3.71),('5819','2013-06-15','13:40:00',3.71),('5819','2013-06-15','13:45:00',3.71),('5819','2013-06-15','13:50:00',3.71),('5819','2013-06-15','13:55:00',3.66),('5819','2013-06-15','14:00:00',3.63),('5819','2013-06-15','14:05:00',3.59),('5819','2013-06-15','14:10:00',3.58),('5819','2013-06-15','14:15:00',3.56),('5819','2013-06-15','14:20:00',3.53),('5819','2013-06-15','14:25:00',3.49),('5819','2013-06-15','14:30:00',3.48),('5819','2013-06-15','14:35:00',3.44),('5819','2013-06-15','14:40:00',3.43),('5819','2013-06-15','14:45:00',3.42),('5819','2013-06-15','14:50:00',3.33),('5819','2013-06-15','14:55:00',3.34),('5819','2013-06-15','15:00:00',3.29),('5819','2013-06-15','15:05:00',3.23),('5819','2013-06-15','15:10:00',3.22),('5819','2013-06-15','15:15:00',3.19),('5819','2013-06-15','15:20:00',3.14),('5819','2013-06-15','15:25:00',3.11),('5819','2013-06-15','15:30:00',3.08),('5819','2013-06-15','15:35:00',3.01),('5819','2013-06-15','15:40:00',2.95),('5819','2013-06-15','15:45:00',2.9),('5819','2013-06-15','15:50:00',2.84),('5819','2013-06-15','15:55:00',2.8),('5819','2013-06-15','16:00:00',2.74),('5819','2013-06-15','16:05:00',2.68),('5819','2013-06-15','16:10:00',2.62),('5819','2013-06-15','16:15:00',2.56),('5819','2013-06-15','16:20:00',2.5),('5819','2013-06-15','16:25:00',2.43),('5819','2013-06-15','16:30:00',2.37),('5819','2013-06-15','16:35:00',2.31),('5819','2013-06-15','16:40:00',2.23),('5819','2013-06-15','16:45:00',2.18),('5819','2013-06-15','16:50:00',2.1),('5819','2013-06-15','16:55:00',2.03),('5819','2013-06-15','17:00:00',1.97),('5819','2013-06-15','17:05:00',1.9),('5819','2013-06-15','17:10:00',1.81),('5819','2013-06-15','17:15:00',1.74),('5819','2013-06-15','17:20:00',1.67),('5819','2013-06-15','17:25:00',1.6),('5819','2013-06-15','17:30:00',1.52),('5819','2013-06-15','17:35:00',1.45),('5819','2013-06-15','17:40:00',1.38),('5819','2013-06-15','17:45:00',1.2),('5819','2013-06-15','17:50:00',1.12),('5819','2013-06-15','17:55:00',1.08),('5819','2013-06-15','18:00:00',1.03),('5819','2013-06-14','07:15:00',1.04),('5819','2013-06-14','07:20:00',1.11),('5819','2013-06-14','07:25:00',1.2),('5819','2013-06-14','07:30:00',1.27),('5819','2013-06-14','07:35:00',1.35),('5819','2013-06-14','07:40:00',1.45),('5819','2013-06-14','07:45:00',1.53),('5819','2013-06-14','07:50:00',1.61),('5819','2013-06-14','07:55:00',1.69),('5819','2013-06-14','08:00:00',1.76),('5819','2013-06-14','08:05:00',1.84),('5819','2013-06-14','08:10:00',1.9),('5819','2013-06-14','08:15:00',1.98),('5819','2013-06-14','08:20:00',2.06),('5819','2013-06-14','08:25:00',2.13),('5819','2013-06-14','08:30:00',2.21),('5819','2013-06-14','08:35:00',2.27),('5819','2013-06-14','08:40:00',2.33),('5819','2013-06-14','08:45:00',2.41),('5819','2013-06-14','08:50:00',2.47),('5819','2013-06-14','08:55:00',2.53),('5819','2013-06-14','09:00:00',2.59),('5819','2013-06-14','09:05:00',2.65),('5819','2013-06-14','09:10:00',2.7),('5819','2013-06-14','09:15:00',2.75),('5819','2013-06-14','09:20:00',2.81),('5819','2013-06-14','09:25:00',2.85),('5819','2013-06-14','09:30:00',2.9),('5819','2013-06-14','09:35:00',2.97),('5819','2013-06-14','09:40:00',3.03),('5819','2013-06-14','09:45:00',3.09),('5819','2013-06-14','09:50:00',3.15),('5819','2013-06-14','09:55:00',3.19),('5819','2013-06-14','10:00:00',3.25),('5819','2013-06-14','10:05:00',3.25),('5819','2013-06-14','10:10:00',3.24),('5819','2013-06-14','10:15:00',3.29),('5819','2013-06-14','10:20:00',3.35),('5819','2013-06-14','10:25:00',3.33),('5819','2013-06-14','10:30:00',3.42),('5819','2013-06-14','10:35:00',3.49),('5819','2013-06-14','10:40:00',3.49),('5819','2013-06-14','10:45:00',3.55),('5819','2013-06-14','10:50:00',3.54),('5819','2013-06-14','10:55:00',3.51),('5819','2013-06-14','11:00:00',3.49),('5819','2013-06-14','11:05:00',3.52),('5819','2013-06-14','11:10:00',3.61),('5819','2013-06-14','11:15:00',3.68),('5819','2013-06-14','11:20:00',3.62),('5819','2013-06-14','11:25:00',3.55),('5819','2013-06-14','11:30:00',3.73),('5819','2013-06-14','11:35:00',3.73),('5819','2013-06-14','11:40:00',3.73),('5819','2013-06-14','11:45:00',3.74),('5819','2013-06-14','11:50:00',3.78),('5819','2013-06-14','11:55:00',3.76),('5819','2013-06-14','12:00:00',3.75),('5819','2013-06-14','12:05:00',3.74),('5819','2013-06-14','12:10:00',3.79),('5819','2013-06-14','12:15:00',3.77),('5819','2013-06-14','12:20:00',3.76),('5819','2013-06-14','12:25:00',3.76),('5819','2013-06-14','12:30:00',3.77),('5819','2013-06-14','12:35:00',3.74),('5819','2013-06-14','12:40:00',3.76),('5819','2013-06-14','12:45:00',3.75),('5819','2013-06-14','12:50:00',3.7),('5819','2013-06-14','12:55:00',3.72),('5819','2013-06-14','13:00:00',3.75),('5819','2013-06-14','13:05:00',3.77),('5819','2013-06-14','13:10:00',2.84),('5819','2013-06-14','13:15:00',1.74),('5819','2013-06-14','13:20:00',2.4),('5819','2013-06-14','13:25:00',1.45),('5819','2013-06-14','13:30:00',3.17),('5819','2013-06-14','13:35:00',3.31),('5819','2013-06-14','13:40:00',3.79),('5819','2013-06-14','13:45:00',3.7),('5819','2013-06-14','13:50:00',3.72),('5819','2013-06-14','13:55:00',3.71),('5819','2013-06-14','14:00:00',3.68),('5819','2013-06-14','14:05:00',3.74),('5819','2013-06-14','14:10:00',3.7),('5819','2013-06-14','14:15:00',3.66),('5819','2013-06-14','14:20:00',3.58),('5819','2013-06-14','14:25:00',3.55),('5819','2013-06-14','14:30:00',3.55),('5819','2013-06-14','14:35:00',3.56),('5819','2013-06-14','14:40:00',3.51),('5819','2013-06-14','14:45:00',3.42),('5819','2013-06-14','14:50:00',3.39),('5819','2013-06-14','14:55:00',3.37),('5819','2013-06-14','15:00:00',3.35),('5819','2013-06-14','15:05:00',3.3),('5819','2013-06-14','15:10:00',3.29),('5819','2013-06-14','15:15:00',3.24),('5819','2013-06-14','15:20:00',3.19),('5819','2013-06-14','15:25:00',3.13),('5819','2013-06-14','15:30:00',3.08),('5819','2013-06-14','15:35:00',3.04),('5819','2013-06-14','15:40:00',3.02),('5819','2013-06-14','15:45:00',2.96),('5819','2013-06-14','15:50:00',2.91),('5819','2013-06-14','15:55:00',2.84),('5819','2013-06-14','16:00:00',2.78),('5819','2013-06-14','16:05:00',2.72),('5819','2013-06-14','16:10:00',2.67),('5819','2013-06-14','16:15:00',2.61),('5819','2013-06-14','16:20:00',2.57),('5819','2013-06-14','16:25:00',2.48),('5819','2013-06-14','16:30:00',2.4),('5819','2013-06-14','16:35:00',2.35),('5819','2013-06-14','16:40:00',2.26),('5819','2013-06-14','16:45:00',2.2),('5819','2013-06-14','16:50:00',2.14),('5819','2013-06-14','16:55:00',2.05),('5819','2013-06-14','17:00:00',2),('5819','2013-06-14','17:05:00',1.88),('5819','2013-06-14','17:10:00',1.84),('5819','2013-06-14','17:15:00',1.8),('5819','2013-06-14','17:20:00',1.71),('5819','2013-06-14','17:25:00',1.63),('5819','2013-06-14','17:30:00',1.53),('5819','2013-06-14','17:35:00',1.46),('5819','2013-06-14','17:40:00',1.41),('5819','2013-06-14','17:45:00',1.21),('5819','2013-06-14','17:50:00',1.13),('5819','2013-06-14','17:55:00',1.13),('5819','2013-06-14','18:00:00',1.06),('5819','2013-06-13','07:15:00',1.05),('5819','2013-06-13','07:20:00',1.13),('5819','2013-06-13','07:25:00',1.2),('5819','2013-06-13','07:30:00',1.29),('5819','2013-06-13','07:35:00',1.38),('5819','2013-06-13','07:40:00',1.47),('5819','2013-06-13','07:45:00',1.55),('5819','2013-06-13','07:50:00',1.63),('5819','2013-06-13','07:55:00',1.71),('5819','2013-06-13','08:00:00',1.79),('5819','2013-06-13','08:05:00',1.87),('5819','2013-06-13','08:10:00',1.94),('5819','2013-06-13','08:15:00',2.01),('5819','2013-06-13','08:20:00',2.07),('5819','2013-06-13','08:25:00',2.13),('5819','2013-06-13','08:30:00',2.19),('5819','2013-06-13','08:35:00',2.28),('5819','2013-06-13','08:40:00',2.35),('5819','2013-06-13','08:45:00',2.42),('5819','2013-06-13','08:50:00',2.48),('5819','2013-06-13','08:55:00',2.55),('5819','2013-06-13','09:00:00',2.61),('5819','2013-06-13','09:05:00',2.68),('5819','2013-06-13','09:10:00',2.74),('5819','2013-06-13','09:15:00',2.81),('5819','2013-06-13','09:20:00',2.89),('5819','2013-06-13','09:25:00',2.96),('5819','2013-06-13','09:30:00',3.01),('5819','2013-06-13','09:35:00',3.06),('5819','2013-06-13','09:40:00',3.1),('5819','2013-06-13','09:45:00',3.15),('5819','2013-06-13','09:50:00',3.2),('5819','2013-06-13','09:55:00',3.24),('5819','2013-06-13','10:00:00',3.3),('5819','2013-06-13','10:05:00',3.34),('5819','2013-06-13','10:10:00',3.37),('5819','2013-06-13','10:15:00',3.41),('5819','2013-06-13','10:20:00',3.43),('5819','2013-06-13','10:25:00',3.47),('5819','2013-06-13','10:30:00',3.53),('5819','2013-06-13','10:35:00',3.55),('5819','2013-06-13','10:40:00',3.58),('5819','2013-06-13','10:45:00',3.66),('5819','2013-06-13','10:50:00',3.68),('5819','2013-06-13','10:55:00',3.7),('5819','2013-06-13','11:00:00',3.73),('5819','2013-06-13','11:05:00',3.75),('5819','2013-06-13','11:10:00',3.76),('5819','2013-06-13','11:15:00',3.78),('5819','2013-06-13','11:20:00',3.82),('5819','2013-06-13','11:25:00',3.84),('5819','2013-06-13','11:30:00',3.84),('5819','2013-06-13','11:35:00',3.88),('5819','2013-06-13','11:40:00',3.88),('5819','2013-06-13','11:45:00',3.92),('5819','2013-06-13','11:50:00',3.93),('5819','2013-06-13','11:55:00',3.92),('5819','2013-06-13','12:00:00',3.93),('5819','2013-06-13','12:05:00',3.98),('5819','2013-06-13','12:10:00',3.96),('5819','2013-06-13','12:15:00',3.98),('5819','2013-06-13','12:20:00',3.99),('5819','2013-06-13','12:25:00',3.99),('5819','2013-06-13','12:30:00',3.99),('5819','2013-06-13','12:35:00',3.97),('5819','2013-06-13','12:40:00',3.97),('5819','2013-06-13','12:45:00',3.96),('5819','2013-06-13','12:50:00',3.92),('5819','2013-06-13','12:55:00',3.9),('5819','2013-06-13','13:00:00',3.93),('5819','2013-06-13','13:05:00',3.93),('5819','2013-06-13','13:10:00',3.92),('5819','2013-06-13','13:15:00',3.92),('5819','2013-06-13','13:20:00',3.89),('5819','2013-06-13','13:25:00',3.87),('5819','2013-06-13','13:30:00',3.86),('5819','2013-06-13','13:35:00',3.86),('5819','2013-06-13','13:40:00',3.85),('5819','2013-06-13','13:45:00',3.8),('5819','2013-06-13','13:50:00',3.77),('5819','2013-06-13','13:55:00',3.77),('5819','2013-06-13','14:00:00',3.74),('5819','2013-06-13','14:05:00',3.71),('5819','2013-06-13','14:10:00',3.68),('5819','2013-06-13','14:15:00',3.67),('5819','2013-06-13','14:20:00',3.62),('5819','2013-06-13','14:25:00',3.68),('5819','2013-06-13','14:30:00',2.04),('5819','2013-06-13','14:35:00',3.6),('5819','2013-06-13','14:40:00',3.62),('5819','2013-06-13','14:45:00',3.53),('5819','2013-06-13','14:50:00',3.39),('5819','2013-06-13','14:55:00',3.43),('5819','2013-06-13','15:00:00',3.4),('5819','2013-06-13','15:05:00',3.32),('5819','2013-06-13','15:10:00',3.26),('5819','2013-06-13','15:15:00',3.21),('5819','2013-06-13','15:20:00',3.19),('5819','2013-06-13','15:25:00',3.14),('5819','2013-06-13','15:30:00',3.1),('5819','2013-06-13','15:35:00',3.06),('5819','2013-06-13','15:40:00',3.04),('5819','2013-06-13','15:45:00',2.97),('5819','2013-06-13','15:50:00',2.93),('5819','2013-06-13','15:55:00',2.87),('5819','2013-06-13','16:00:00',2.8),('5819','2013-06-13','16:05:00',2.74),('5819','2013-06-13','16:10:00',2.67),('5819','2013-06-13','16:15:00',2.61),('5819','2013-06-13','16:20:00',2.55),('5819','2013-06-13','16:25:00',2.49),('5819','2013-06-13','16:30:00',2.42),('5819','2013-06-13','16:35:00',2.35),('5819','2013-06-13','16:40:00',2.27),('5819','2013-06-13','16:45:00',2.21),('5819','2013-06-13','16:50:00',2.14),('5819','2013-06-13','16:55:00',2.08),('5819','2013-06-13','17:00:00',1.98),('5819','2013-06-13','17:05:00',1.91),('5819','2013-06-13','17:10:00',1.85),('5819','2013-06-13','17:15:00',1.79),('5819','2013-06-13','17:20:00',1.71),('5819','2013-06-13','17:25:00',1.63),('5819','2013-06-13','17:30:00',1.56),('5819','2013-06-13','17:35:00',1.48),('5819','2013-06-13','17:40:00',1.39),('5819','2013-06-13','17:45:00',1.21),('5819','2013-06-13','17:50:00',1.16),('5819','2013-06-13','17:55:00',1.11),('5819','2013-06-13','18:00:00',1.03),('5819','2013-06-12','07:15:00',1.07),('5819','2013-06-12','07:20:00',1.15),('5819','2013-06-12','07:25:00',1.23),('5819','2013-06-12','07:30:00',1.3),('5819','2013-06-12','07:35:00',1.39),('5819','2013-06-12','07:40:00',1.47),('5819','2013-06-12','07:45:00',1.55),('5819','2013-06-12','07:50:00',1.63),('5819','2013-06-12','07:55:00',1.72),('5819','2013-06-12','08:00:00',1.81),('5819','2013-06-12','08:05:00',1.89),('5819','2013-06-12','08:10:00',1.97),('5819','2013-06-12','08:15:00',2.05),('5819','2013-06-12','08:20:00',2.12),('5819','2013-06-12','08:25:00',2.19),('5819','2013-06-12','08:30:00',2.26),('5819','2013-06-12','08:35:00',2.34),('5819','2013-06-12','08:40:00',2.41),('5819','2013-06-12','08:45:00',2.49),('5819','2013-06-12','08:50:00',2.55),('5819','2013-06-12','08:55:00',2.61),('5819','2013-06-12','09:00:00',2.68),('5819','2013-06-12','09:05:00',2.76),('5819','2013-06-12','09:10:00',2.83),('5819','2013-06-12','09:15:00',2.89),('5819','2013-06-12','09:20:00',2.94),('5819','2013-06-12','09:25:00',3),('5819','2013-06-12','09:30:00',3.05),('5819','2013-06-12','09:35:00',3.1),('5819','2013-06-12','09:40:00',3.14),('5819','2013-06-12','09:45:00',3.2),('5819','2013-06-12','09:50:00',3.24),('5819','2013-06-12','09:55:00',3.3),('5819','2013-06-12','10:00:00',3.32),('5819','2013-06-12','10:05:00',3.37),('5819','2013-06-12','10:10:00',3.41),('5819','2013-06-12','10:15:00',3.46),('5819','2013-06-12','10:20:00',3.49),('5819','2013-06-12','10:25:00',3.5),('5819','2013-06-12','10:30:00',3.53),('5819','2013-06-12','10:35:00',3.54),('5819','2013-06-12','10:40:00',3.57),('5819','2013-06-12','10:45:00',3.64),('5819','2013-06-12','10:50:00',3.7),('5819','2013-06-12','10:55:00',3.77),('5819','2013-06-12','11:00:00',3.79),('5819','2013-06-12','11:05:00',3.81),('5819','2013-06-12','11:10:00',3.83),('5819','2013-06-12','11:15:00',3.83),('5819','2013-06-12','11:20:00',3.84),('5819','2013-06-12','11:25:00',3.86),('5819','2013-06-12','11:30:00',3.9),('5819','2013-06-12','11:35:00',3.89),('5819','2013-06-12','11:40:00',3.93),('5819','2013-06-12','11:45:00',3.89),('5819','2013-06-12','11:50:00',3.96),('5819','2013-06-12','11:55:00',3.98),('5819','2013-06-12','12:00:00',3.98),('5819','2013-06-12','12:05:00',4),('5819','2013-06-12','12:10:00',3.96),('5819','2013-06-12','12:15:00',4),('5819','2013-06-12','12:20:00',4),('5819','2013-06-12','12:25:00',4.07),('5819','2013-06-12','12:30:00',4.05),('5819','2013-06-12','12:35:00',3.81),('5819','2013-06-12','12:40:00',2.23),('5819','2013-06-12','12:45:00',2.65),('5819','2013-06-12','12:50:00',4.34),('5819','2013-06-12','12:55:00',3.41),('5819','2013-06-12','13:00:00',3.59),('5819','2013-06-12','13:05:00',4.06),('5819','2013-06-12','13:10:00',3.97),('5819','2013-06-12','13:15:00',3.91),('5819','2013-06-12','13:20:00',3.88),('5819','2013-06-12','13:25:00',3.89),('5819','2013-06-12','13:30:00',3.9),('5819','2013-06-12','13:35:00',3.88),('5819','2013-06-12','13:40:00',3.84),('5819','2013-06-12','13:45:00',3.88),('5819','2013-06-12','13:50:00',3.84),('5819','2013-06-12','13:55:00',3.9),('5819','2013-06-12','14:00:00',3.92),('5819','2013-06-12','14:05:00',2.38),('5819','2013-06-12','14:10:00',3.46),('5819','2013-06-12','14:15:00',3.47),('5819','2013-06-12','14:20:00',2.18),('5819','2013-06-12','14:25:00',1.71),('5819','2013-06-12','14:30:00',3.95),('5819','2013-06-12','14:35:00',3.85),('5819','2013-06-12','14:40:00',3.66),('5819','2013-06-12','14:45:00',3.42),('5819','2013-06-12','14:50:00',3.71),('5819','2013-06-12','14:55:00',3.8),('5819','2013-06-12','15:00:00',3.73),('5819','2013-06-12','15:05:00',3.37),('5819','2013-06-12','15:10:00',3.43),('5819','2013-06-12','15:15:00',2.62),('5819','2013-06-12','15:20:00',3.48),('5819','2013-06-12','15:25:00',3.24),('5819','2013-06-12','15:30:00',3.21),('5819','2013-06-12','15:35:00',3.21),('5819','2013-06-12','15:40:00',3.14),('5819','2013-06-12','15:45:00',3.08),('5819','2013-06-12','15:50:00',2.97),('5819','2013-06-12','15:55:00',3.01),('5819','2013-06-12','16:00:00',2.68),('5819','2013-06-12','16:05:00',2.76),('5819','2013-06-12','16:10:00',2.82),('5819','2013-06-12','16:15:00',2.75),('5819','2013-06-12','16:20:00',2.62),('5819','2013-06-12','16:25:00',2.49),('5819','2013-06-12','16:30:00',2.51),('5819','2013-06-12','16:35:00',2.41),('5819','2013-06-12','16:40:00',2.4),('5819','2013-06-12','16:45:00',1.96),('5819','2013-06-12','16:50:00',2.24),('5819','2013-06-12','16:55:00',2.12),('5819','2013-06-12','17:00:00',2.03),('5819','2013-06-12','17:05:00',1.99),('5819','2013-06-12','17:10:00',1.92),('5819','2013-06-12','17:15:00',1.83),('5819','2013-06-12','17:20:00',1.73),('5819','2013-06-12','17:25:00',1.66),('5819','2013-06-12','17:30:00',1.6),('5819','2013-06-12','17:35:00',1.53),('5819','2013-06-12','17:40:00',1.46),('5819','2013-06-12','17:45:00',1.16),('5819','2013-06-12','18:05:00',1.05),('5819','2013-06-11','07:20:00',1.08),('5819','2013-06-11','07:25:00',1.31),('5819','2013-06-11','07:30:00',1.24),('5819','2013-06-11','07:35:00',1.33),('5819','2013-06-11','07:40:00',1.42),('5819','2013-06-11','07:45:00',1.5),('5819','2013-06-11','07:50:00',1.46),('5819','2013-06-11','08:00:00',1.62),('5819','2013-06-11','08:10:00',1.46),('5819','2013-06-11','08:15:00',2.25),('5819','2013-06-11','08:20:00',2.32),('5819','2013-06-11','08:25:00',2.3),('5819','2013-06-11','08:30:00',2.37),('5819','2013-06-11','08:35:00',2.39),('5819','2013-06-11','08:40:00',2.53),('5819','2013-06-11','08:45:00',2.55),('5819','2013-06-11','08:50:00',2.63),('5819','2013-06-11','08:55:00',2.73),('5819','2013-06-11','09:00:00',2.82),('5819','2013-06-11','09:05:00',2.86),('5819','2013-06-11','09:10:00',2.92),('5819','2013-06-11','09:15:00',2.99),('5819','2013-06-11','09:20:00',3.02),('5819','2013-06-11','09:25:00',3.2),('5819','2013-06-11','09:30:00',3.28),('5819','2013-06-11','09:35:00',3.22),('5819','2013-06-11','09:40:00',1.16),('5819','2013-06-11','09:45:00',1.16),('5819','2013-06-11','09:50:00',2.64),('5819','2013-06-11','09:55:00',3.22),('5819','2013-06-11','10:00:00',2.22),('5819','2013-06-11','10:05:00',2.87),('5819','2013-06-11','10:10:00',1.57),('5819','2013-06-11','10:15:00',3.62),('5819','2013-06-11','10:20:00',3.64),('5819','2013-06-11','10:25:00',3.37),('5819','2013-06-11','10:30:00',3.68),('5819','2013-06-11','10:35:00',3.64),('5819','2013-06-11','10:40:00',2.92),('5819','2013-06-11','10:45:00',3.48),('5819','2013-06-11','10:50:00',3.81),('5819','2013-06-11','10:55:00',3.9),('5819','2013-06-11','11:00:00',3.95),('5819','2013-06-11','11:05:00',3.92),('5819','2013-06-11','11:10:00',3.15),('5819','2013-06-11','11:15:00',3.37),('5819','2013-06-11','11:20:00',4.09),('5819','2013-06-11','11:25:00',2.71),('5819','2013-06-11','11:30:00',3.47),('5819','2013-06-11','11:35:00',4.02),('5819','2013-06-11','11:40:00',4.02),('5819','2013-06-11','11:45:00',3.99),('5819','2013-06-11','11:50:00',4.01),('5819','2013-06-11','11:55:00',4.05),('5819','2013-06-11','12:00:00',3.5),('5819','2013-06-11','12:05:00',2.46),('5819','2013-06-11','12:10:00',4.15),('5819','2013-06-11','12:15:00',4.08),('5819','2013-06-11','12:20:00',4),('5819','2013-06-11','12:25:00',4.11),('5819','2013-06-11','12:30:00',4.11),('5819','2013-06-11','12:35:00',4.12),('5819','2013-06-11','12:40:00',4.1),('5819','2013-06-11','12:45:00',4.09),('5819','2013-06-11','12:50:00',4.08),('5819','2013-06-11','12:55:00',4.12),('5819','2013-06-11','13:00:00',4.12),('5819','2013-06-11','13:05:00',4.12),('5819','2013-06-11','13:10:00',4.12),('5819','2013-06-11','13:15:00',4.13),('5819','2013-06-11','13:20:00',4.09),('5819','2013-06-11','13:25:00',4.06),('5819','2013-06-11','13:30:00',4.02),('5819','2013-06-11','13:35:00',4.06),('5819','2013-06-11','13:40:00',4.1),('5819','2013-06-11','13:45:00',4.08),('5819','2013-06-11','13:50:00',3.84),('5819','2013-06-11','13:55:00',4.1),('5819','2013-06-11','14:00:00',4.02),('5819','2013-06-11','14:05:00',3.94),('5819','2013-06-11','14:10:00',3.88),('5819','2013-06-11','14:15:00',3.84),('5819','2013-06-11','14:20:00',3.8),('5819','2013-06-11','14:25:00',3.77),('5819','2013-06-11','14:30:00',3.72),('5819','2013-06-11','14:35:00',3.72),('5819','2013-06-11','14:40:00',3.67),('5819','2013-06-11','14:45:00',3.63),('5819','2013-06-11','14:50:00',3.59),('5819','2013-06-11','14:55:00',3.54),('5819','2013-06-11','15:00:00',3.5),('5819','2013-06-11','15:05:00',3.45),('5819','2013-06-11','15:10:00',3.42),('5819','2013-06-11','15:15:00',3.38),('5819','2013-06-11','15:20:00',3.33),('5819','2013-06-11','15:25:00',3.25),('5819','2013-06-11','15:30:00',3.2),('5819','2013-06-11','15:35:00',3.23),('5819','2013-06-11','15:40:00',3.08),('5819','2013-06-11','15:45:00',2.32),('5819','2013-06-11','15:50:00',2.98),('5819','2013-06-11','15:55:00',2.78),('5819','2013-06-11','16:00:00',2.97),('5819','2013-06-11','16:05:00',2.93),('5819','2013-06-11','16:10:00',2.87),('5819','2013-06-11','16:15:00',2.79),('5819','2013-06-11','16:20:00',2.71),('5819','2013-06-11','16:25:00',2.65),('5819','2013-06-11','16:30:00',2.59),('5819','2013-06-11','16:35:00',2.55),('5819','2013-06-11','16:40:00',2.58),('5819','2013-06-11','16:45:00',2.69),('5819','2013-06-11','16:50:00',2.72),('5819','2013-06-11','16:55:00',2.57),('5819','2013-06-11','17:00:00',2.4),('5819','2013-06-11','17:05:00',1.96),('5819','2013-06-10','07:30:00',1.25),('5819','2013-06-10','07:35:00',1.71),('5819','2013-06-10','07:40:00',1.11),('5819','2013-06-10','08:00:00',1.14),('5819','2013-06-10','08:05:00',1.64),('5819','2013-06-10','08:10:00',2.13),('5819','2013-06-10','08:15:00',1.8),('5819','2013-06-10','08:20:00',2.18),('5819','2013-06-10','08:25:00',1.33),('5819','2013-06-10','08:30:00',1.31),('5819','2013-06-10','08:35:00',1.17),('5819','2013-06-10','08:55:00',1.12),('5819','2013-06-10','09:00:00',1.3),('5819','2013-06-10','09:05:00',1.06),('5819','2013-06-10','09:10:00',2.03),('5819','2013-06-10','09:15:00',1),('5819','2013-06-10','09:20:00',2.43),('5819','2013-06-10','09:25:00',1.73),('5819','2013-06-10','09:30:00',2.12),('5819','2013-06-10','09:35:00',3.28),('5819','2013-06-10','09:40:00',2.41),('5819','2013-06-10','09:45:00',3.66),('5819','2013-06-10','09:50:00',2.07),('5819','2013-06-10','09:55:00',1.91),('5819','2013-06-10','10:00:00',2.16),('5819','2013-06-10','10:05:00',2.5),('5819','2013-06-10','10:10:00',2.96),('5819','2013-06-10','10:15:00',3.01),('5819','2013-06-10','10:20:00',2.12),('5819','2013-06-10','10:25:00',1.75),('5819','2013-06-10','10:30:00',1.78),('5819','2013-06-10','10:35:00',1.58),('5819','2013-06-10','10:40:00',1.72),('5819','2013-06-10','10:45:00',1.23),('5819','2013-06-10','10:50:00',1.87),('5819','2013-06-10','10:55:00',2.17),('5819','2013-06-10','11:00:00',3.31),('5819','2013-06-10','11:05:00',3.08),('5819','2013-06-10','11:10:00',2.93),('5819','2013-06-10','11:15:00',4.1),('5819','2013-06-10','11:20:00',4.18),('5819','2013-06-10','11:25:00',3.89),('5819','2013-06-10','11:30:00',4.22),('5819','2013-06-10','11:35:00',4.28),('5819','2013-06-10','11:40:00',2.75),('5819','2013-06-10','11:45:00',3.12),('5819','2013-06-10','11:50:00',2.51),('5819','2013-06-10','11:55:00',3.01),('5819','2013-06-10','12:00:00',4.45),('5819','2013-06-10','12:05:00',2.08),('5819','2013-06-10','12:10:00',2.7),('5819','2013-06-10','12:15:00',2.83),('5819','2013-06-10','12:20:00',3.38),('5819','2013-06-10','12:25:00',4.28),('5819','2013-06-10','12:30:00',4.45),('5819','2013-06-10','12:35:00',4.53),('5819','2013-06-10','12:40:00',3.74),('5819','2013-06-10','12:45:00',4.51),('5819','2013-06-10','12:50:00',1.98),('5819','2013-06-10','12:55:00',4.13),('5819','2013-06-10','13:00:00',4.63),('5819','2013-06-10','13:05:00',4.24),('5819','2013-06-10','13:10:00',3.96),('5819','2013-06-10','13:15:00',2.54),('5819','2013-06-10','13:20:00',2.22),('5819','2013-06-10','13:25:00',2.24),('5819','2013-06-10','13:30:00',1.73),('5819','2013-06-10','13:35:00',3.32),('5819','2013-06-10','13:40:00',3.45),('5819','2013-06-10','13:45:00',4.14),('5819','2013-06-10','13:50:00',4.42),('5819','2013-06-10','13:55:00',3.55),('5819','2013-06-10','14:00:00',4.16),('5819','2013-06-10','14:05:00',4.07),('5819','2013-06-10','14:10:00',4.01),('5819','2013-06-10','14:15:00',3.9),('5819','2013-06-10','14:20:00',3.43),('5819','2013-06-10','14:25:00',3.79),('5819','2013-06-10','14:30:00',3.78),('5819','2013-06-10','14:35:00',3.76),('5819','2013-06-10','14:40:00',3.67),('5819','2013-06-10','14:45:00',3.69),('5819','2013-06-10','14:50:00',3.64),('5819','2013-06-10','14:55:00',3.56),('5819','2013-06-10','15:00:00',3.52),('5819','2013-06-10','15:05:00',3.5),('5819','2013-06-10','15:10:00',3.45),('5819','2013-06-10','15:15:00',3.42),('5819','2013-06-10','15:20:00',3.39),('5819','2013-06-10','15:25:00',3.33),('5819','2013-06-10','15:30:00',3.29),('5819','2013-06-10','15:35:00',3.25),('5819','2013-06-10','15:40:00',3.21),('5819','2013-06-10','15:45:00',3.14),('5819','2013-06-10','15:50:00',3.07),('5819','2013-06-10','15:55:00',3.02),('5819','2013-06-10','16:00:00',2.97),('5819','2013-06-10','16:05:00',2.9),('5819','2013-06-10','16:10:00',2.83),('5819','2013-06-10','16:15:00',2.76),('5819','2013-06-10','16:20:00',2.7),('5819','2013-06-10','16:25:00',2.63),('5819','2013-06-10','16:30:00',2.57),('5819','2013-06-10','16:35:00',2.49),('5819','2013-06-10','16:40:00',2.41),('5819','2013-06-10','16:45:00',2.34),('5819','2013-06-10','16:50:00',2.28),('5819','2013-06-10','16:55:00',2.21),('5819','2013-06-10','17:00:00',2.13),('5819','2013-06-10','17:05:00',2.05),('5819','2013-06-10','17:10:00',1.97),('5819','2013-06-10','17:15:00',1.9),('5819','2013-06-10','17:20:00',1.82),('5819','2013-06-10','17:25:00',1.74),('5819','2013-06-10','17:30:00',1.65),('5819','2013-06-10','17:35:00',1.57),('5819','2013-06-10','17:40:00',1.47),('5819','2013-06-10','17:45:00',1.29),('5819','2013-06-10','17:50:00',1.19),('5819','2013-06-10','17:55:00',1.18),('5819','2013-06-10','18:00:00',1.1),('5819','2013-06-10','18:05:00',1.02),('5819','2013-06-09','07:35:00',1.51),('5819','2013-06-09','07:40:00',1.33),('5819','2013-06-09','07:50:00',1.09),('5819','2013-06-09','07:55:00',1.59),('5819','2013-06-09','08:00:00',1.67),('5819','2013-06-09','08:05:00',1.75),('5819','2013-06-09','08:10:00',1.68),('5819','2013-06-09','08:15:00',1.84),('5819','2013-06-09','08:20:00',1.96),('5819','2013-06-09','08:25:00',2.06),('5819','2013-06-09','08:30:00',2.1),('5819','2013-06-09','08:35:00',2.18),('5819','2013-06-09','08:40:00',2.23),('5819','2013-06-09','08:45:00',2.33),('5819','2013-06-09','08:50:00',2.4),('5819','2013-06-09','08:55:00',2.42),('5819','2013-06-09','09:00:00',2.51),('5819','2013-06-09','09:05:00',2.6),('5819','2013-06-09','09:10:00',2.67),('5819','2013-06-09','09:15:00',2.73),('5819','2013-06-09','09:20:00',2.63),('5819','2013-06-09','09:25:00',2.79),('5819','2013-06-09','09:30:00',2.85),('5819','2013-06-09','09:35:00',2.94),('5819','2013-06-09','09:40:00',3.01),('5819','2013-06-09','09:45:00',3.05),('5819','2013-06-09','09:50:00',3.09),('5819','2013-06-09','09:55:00',3.12),('5819','2013-06-09','10:00:00',3.17),('5819','2013-06-09','10:05:00',3.21),('5819','2013-06-09','10:10:00',3.25),('5819','2013-06-09','10:15:00',3.31),('5819','2013-06-09','10:20:00',3.37),('5819','2013-06-09','10:25:00',3.37),('5819','2013-06-09','10:30:00',3.36),('5819','2013-06-09','10:35:00',3.46),('5819','2013-06-09','10:40:00',3.5),('5819','2013-06-09','10:45:00',3.48),('5819','2013-06-09','10:50:00',3.53),('5819','2013-06-09','10:55:00',3.53),('5819','2013-06-09','11:00:00',3.56),('5819','2013-06-09','11:05:00',3.6),('5819','2013-06-09','11:10:00',3.59),('5819','2013-06-09','11:15:00',3.56),('5819','2013-06-09','11:20:00',3.63),('5819','2013-06-09','11:25:00',3.69),('5819','2013-06-09','11:30:00',3.67),('5819','2013-06-09','11:35:00',3.67),('5819','2013-06-09','11:40:00',3.69),('5819','2013-06-09','11:45:00',3.74),('5819','2013-06-09','11:50:00',3.77),('5819','2013-06-09','11:55:00',3.77),('5819','2013-06-09','12:00:00',3.77),('5819','2013-06-09','12:05:00',3.77),('5819','2013-06-09','12:10:00',3.45),('5819','2013-06-09','12:15:00',3.7),('5819','2013-06-09','12:20:00',3.76),('5819','2013-06-09','12:25:00',3.72),('5819','2013-06-09','12:30:00',3.71),('5819','2013-06-09','12:35:00',3.69),('5819','2013-06-09','12:40:00',3.76),('5819','2013-06-09','12:45:00',3.74),('5819','2013-06-09','12:50:00',3.68),('5819','2013-06-09','12:55:00',3.47),('5819','2013-06-09','13:00:00',3.31),('5819','2013-06-09','13:05:00',2.67),('5819','2013-06-09','13:10:00',3.54),('5819','2013-06-09','13:15:00',1.62),('5819','2013-06-09','13:20:00',1.83),('5819','2013-06-09','13:25:00',4.25),('5819','2013-06-09','13:30:00',4.01),('5819','2013-06-09','13:35:00',3.92),('5819','2013-06-09','13:40:00',3.99),('5819','2013-06-09','13:45:00',3.99),('5819','2013-06-09','13:50:00',4.1),('5819','2013-06-09','13:55:00',3.86),('5819','2013-06-09','14:00:00',3.85),('5819','2013-06-09','14:05:00',3.91),('5819','2013-06-09','14:10:00',3.93),('5819','2013-06-09','14:15:00',2.46),('5819','2013-06-09','14:20:00',2),('5819','2013-06-09','14:25:00',1.09),('5819','2013-06-09','14:30:00',1.24),('5819','2013-06-09','14:35:00',2.95),('5819','2013-06-09','14:40:00',3.27),('5819','2013-06-09','14:45:00',3.29),('5819','2013-06-09','14:50:00',3.44),('5819','2013-06-09','14:55:00',3.49),('5819','2013-06-09','15:00:00',3.43),('5819','2013-06-09','15:05:00',3.28),('5819','2013-06-09','15:10:00',3.3),('5819','2013-06-09','15:15:00',3.14),('5819','2013-06-09','15:20:00',3.16),('5819','2013-06-09','15:25:00',3.18),('5819','2013-06-09','15:30:00',3.03),('5819','2013-06-09','15:35:00',3.14),('5819','2013-06-09','15:40:00',2.43),('5819','2013-06-09','15:45:00',2.46),('5819','2013-06-09','15:50:00',2.7),('5819','2013-06-09','15:55:00',3.03),('5819','2013-06-09','16:00:00',1.89),('5819','2013-06-09','16:05:00',2.65),('5819','2013-06-09','16:10:00',2.67),('5819','2013-06-09','16:15:00',1.57),('5819','2013-06-09','16:20:00',1.27),('5819','2013-06-09','16:25:00',1.91),('5819','2013-06-09','16:30:00',1.31),('5819','2013-06-08','07:15:00',1.01),('5819','2013-06-08','07:20:00',1.07),('5819','2013-06-08','07:25:00',1.13),('5819','2013-06-08','07:30:00',1.21),('5819','2013-06-08','07:35:00',1.28),('5819','2013-06-08','07:40:00',1.38),('5819','2013-06-08','07:45:00',1.47),('5819','2013-06-08','07:50:00',1.54),('5819','2013-06-08','07:55:00',1.6),('5819','2013-06-08','08:00:00',1.67),('5819','2013-06-08','08:05:00',1.74),('5819','2013-06-08','08:10:00',1.82),('5819','2013-06-08','08:15:00',1.91),('5819','2013-06-08','08:20:00',2),('5819','2013-06-08','08:25:00',2.07),('5819','2013-06-08','08:30:00',2.14),('5819','2013-06-08','08:35:00',2.22),('5819','2013-06-08','08:40:00',2.29),('5819','2013-06-08','08:45:00',2.37),('5819','2013-06-08','08:50:00',2.45),('5819','2013-06-08','08:55:00',2.5),('5819','2013-06-08','09:00:00',2.55),('5819','2013-06-08','09:05:00',2.64),('5819','2013-06-08','09:10:00',2.71),('5819','2013-06-08','09:15:00',2.74),('5819','2013-06-08','09:20:00',2.78),('5819','2013-06-08','09:25:00',2.82),('5819','2013-06-08','09:30:00',2.88),('5819','2013-06-08','09:35:00',2.91),('5819','2013-06-08','09:40:00',2.97),('5819','2013-06-08','09:45:00',2.99),('5819','2013-06-08','09:50:00',3.01),('5819','2013-06-08','09:55:00',3.01),('5819','2013-06-08','10:00:00',3.04),('5819','2013-06-08','10:05:00',3.18),('5819','2013-06-08','10:10:00',3.33),('5819','2013-06-08','10:15:00',3.35),('5819','2013-06-08','10:20:00',3.36),('5819','2013-06-08','10:25:00',3.4),('5819','2013-06-08','10:30:00',3.43),('5819','2013-06-08','10:35:00',3.49),('5819','2013-06-08','10:40:00',3.55),('5819','2013-06-08','10:45:00',3.47),('5819','2013-06-08','10:50:00',3.67),('5819','2013-06-08','10:55:00',3.1),('5819','2013-06-08','11:00:00',1.39),('5819','2013-06-08','11:05:00',3.9),('5819','2013-06-08','11:10:00',4.1),('5819','2013-06-08','11:15:00',3.97),('5819','2013-06-08','11:20:00',3.96),('5819','2013-06-08','11:25:00',4.07),('5819','2013-06-08','11:30:00',3.79),('5819','2013-06-08','11:35:00',2.29),('5819','2013-06-08','11:40:00',4.1),('5819','2013-06-08','11:45:00',4.02),('5819','2013-06-08','11:50:00',4.05),('5819','2013-06-08','11:55:00',3.57),('5819','2013-06-08','12:00:00',1.27),('5819','2013-06-08','12:05:00',2.75),('5819','2013-06-08','12:10:00',1.05),('5819','2013-06-08','12:15:00',3.13),('5819','2013-06-08','12:20:00',4.27),('5819','2013-06-08','12:25:00',1.08),('5819','2013-06-08','12:30:00',1.51),('5819','2013-06-08','12:35:00',2.87),('5819','2013-06-08','12:40:00',4.14),('5819','2013-06-08','12:45:00',4.12),('5819','2013-06-08','12:50:00',4.12),('5819','2013-06-08','12:55:00',4.08),('5819','2013-06-08','13:00:00',2.23),('5819','2013-06-08','13:05:00',4.09),('5819','2013-06-08','13:10:00',4.12),('5819','2013-06-08','13:15:00',4.14),('5819','2013-06-08','13:20:00',4.12),('5819','2013-06-08','13:25:00',3.99),('5819','2013-06-08','13:30:00',4.04),('5819','2013-06-08','13:35:00',4.01),('5819','2013-06-08','13:40:00',4.03),('5819','2013-06-08','13:45:00',3.96),('5819','2013-06-08','13:50:00',3.9),('5819','2013-06-08','13:55:00',3.89),('5819','2013-06-08','14:00:00',3.84),('5819','2013-06-08','14:05:00',3.82),('5819','2013-06-08','14:10:00',3.82),('5819','2013-06-08','14:15:00',3.81),('5819','2013-06-08','14:20:00',3.75),('5819','2013-06-08','14:25:00',3.7),('5819','2013-06-08','14:30:00',3.69),('5819','2013-06-08','14:35:00',3.64),('5819','2013-06-08','14:40:00',3.61),('5819','2013-06-08','14:45:00',3.58),('5819','2013-06-08','14:50:00',3.57),('5819','2013-06-08','14:55:00',3.52),('5819','2013-06-08','15:00:00',3.53),('5819','2013-06-08','15:05:00',3.4),('5819','2013-06-08','15:10:00',3.15),('5819','2013-06-08','15:15:00',3.28),('5819','2013-06-08','15:20:00',3.34),('5819','2013-06-08','15:25:00',3.14),('5819','2013-06-08','15:30:00',3.2),('5819','2013-06-08','15:35:00',3.32),('5819','2013-06-08','15:40:00',3.24),('5819','2013-06-08','15:45:00',3.25),('5819','2013-06-08','15:50:00',3.2),('5819','2013-06-08','15:55:00',2.98),('5819','2013-06-08','16:00:00',2.94),('5819','2013-06-08','16:05:00',2.89),('5819','2013-06-08','16:10:00',2.83),('5819','2013-06-08','16:15:00',2.9),('5819','2013-06-08','16:20:00',2.81),('5819','2013-06-08','16:25:00',2.67),('5819','2013-06-08','16:30:00',2.5),('5819','2013-06-08','16:35:00',2.41),('5819','2013-06-08','16:40:00',2.33),('5819','2013-06-08','16:45:00',2.28),('5819','2013-06-08','16:50:00',1.95),('5819','2013-06-08','16:55:00',1.96),('5819','2013-06-08','17:00:00',2.08),('5819','2013-06-08','17:05:00',1.54),('5819','2013-06-08','17:10:00',2.11),('5819','2013-06-08','17:15:00',2.12),('5819','2013-06-08','17:20:00',1.98),('5819','2013-06-08','17:25:00',1.8),('5819','2013-06-08','17:30:00',1.08),('5819','2013-06-08','17:40:00',1.29),('5819','2013-06-08','17:45:00',1.42),('5819','2013-06-08','17:50:00',1.27),('5819','2013-06-08','17:55:00',1.35),('5819','2013-06-08','18:00:00',1.04),('5819','2013-06-07','07:15:00',1.07),('5819','2013-06-07','07:20:00',1.14),('5819','2013-06-07','07:25:00',1.22),('5819','2013-06-07','07:30:00',1.3),('5819','2013-06-07','07:35:00',1.4),('5819','2013-06-07','07:40:00',1.48),('5819','2013-06-07','07:45:00',1.57),('5819','2013-06-07','07:50:00',1.66),('5819','2013-06-07','07:55:00',1.73),('5819','2013-06-07','08:00:00',1.81),('5819','2013-06-07','08:05:00',1.9),('5819','2013-06-07','08:10:00',1.97),('5819','2013-06-07','08:15:00',2.05),('5819','2013-06-07','08:20:00',2.13),('5819','2013-06-07','08:25:00',2.22),('5819','2013-06-07','08:30:00',2.3),('5819','2013-06-07','08:35:00',2.37),('5819','2013-06-07','08:40:00',2.45),('5819','2013-06-07','08:45:00',2.53),('5819','2013-06-07','08:50:00',2.61),('5819','2013-06-07','08:55:00',2.68),('5819','2013-06-07','09:00:00',2.73),('5819','2013-06-07','09:05:00',2.8),('5819','2013-06-07','09:10:00',2.86),('5819','2013-06-07','09:15:00',2.92),('5819','2013-06-07','09:20:00',2.97),('5819','2013-06-07','09:25:00',3.03),('5819','2013-06-07','09:30:00',3.09),('5819','2013-06-07','09:35:00',3.17),('5819','2013-06-07','09:40:00',3.24),('5819','2013-06-07','09:45:00',3.3),('5819','2013-06-07','09:50:00',3.33),('5819','2013-06-07','09:55:00',3.38),('5819','2013-06-07','10:00:00',3.42),('5819','2013-06-07','10:05:00',3.46),('5819','2013-06-07','10:10:00',3.52),('5819','2013-06-07','10:15:00',3.55),('5819','2013-06-07','10:20:00',3.58),('5819','2013-06-07','10:25:00',3.64),('5819','2013-06-07','10:30:00',3.68),('5819','2013-06-07','10:35:00',3.68),('5819','2013-06-07','10:40:00',3.72),('5819','2013-06-07','10:45:00',3.74),('5819','2013-06-07','10:50:00',3.77),('5819','2013-06-07','10:55:00',3.79),('5819','2013-06-07','11:00:00',3.82),('5819','2013-06-07','11:05:00',3.85),('5819','2013-06-07','11:10:00',3.87),('5819','2013-06-07','11:15:00',3.88),('5819','2013-06-07','11:20:00',3.89),('5819','2013-06-07','11:25:00',3.91),('5819','2013-06-07','11:30:00',3.92),('5819','2013-06-07','11:35:00',3.95),('5819','2013-06-07','11:40:00',3.97),('5819','2013-06-07','11:45:00',3.97),('5819','2013-06-07','11:50:00',4),('5819','2013-06-07','11:55:00',4),('5819','2013-06-07','12:00:00',4.01),('5819','2013-06-07','12:05:00',4.02),('5819','2013-06-07','12:10:00',4.03),('5819','2013-06-07','12:15:00',4.04),('5819','2013-06-07','12:20:00',4.04),('5819','2013-06-07','12:25:00',4.06),('5819','2013-06-07','12:30:00',4.04),('5819','2013-06-07','12:35:00',4.01),('5819','2013-06-07','12:40:00',4.05),('5819','2013-06-07','12:45:00',4.04),('5819','2013-06-07','12:50:00',4.01),('5819','2013-06-07','12:55:00',3.99),('5819','2013-06-07','13:00:00',3.97),('5819','2013-06-07','13:05:00',3.94),('5819','2013-06-07','13:10:00',3.94),('5819','2013-06-07','13:15:00',3.94),('5819','2013-06-07','13:20:00',3.93),('5819','2013-06-07','13:25:00',3.93),('5819','2013-06-07','13:30:00',3.91),('5819','2013-06-07','13:35:00',3.85),('5819','2013-06-07','13:40:00',3.82),('5819','2013-06-07','13:45:00',3.8),('5819','2013-06-07','13:50:00',3.8),('5819','2013-06-07','13:55:00',3.79),('5819','2013-06-07','14:00:00',3.76),('5819','2013-06-07','14:05:00',3.73),('5819','2013-06-07','14:10:00',3.67),('5819','2013-06-07','14:15:00',3.64),('5819','2013-06-07','14:20:00',3.59),('5819','2013-06-07','14:25:00',3.56),('5819','2013-06-07','14:30:00',3.56),('5819','2013-06-07','14:35:00',3.53),('5819','2013-06-07','14:40:00',3.52),('5819','2013-06-07','14:45:00',3.51),('5819','2013-06-07','14:50:00',3.48),('5819','2013-06-07','14:55:00',3.41),('5819','2013-06-07','15:00:00',3.39),('5819','2013-06-07','15:05:00',3.38),('5819','2013-06-07','15:10:00',3.38),('5819','2013-06-07','15:15:00',3.31),('5819','2013-06-07','15:20:00',3.22),('5819','2013-06-07','15:25:00',3.2),('5819','2013-06-07','15:30:00',3.19),('5819','2013-06-07','15:35:00',3.16),('5819','2013-06-07','15:40:00',3.07),('5819','2013-06-07','15:45:00',3.03),('5819','2013-06-07','15:50:00',2.97),('5819','2013-06-07','15:55:00',2.92),('5819','2013-06-07','16:00:00',2.87),('5819','2013-06-07','16:05:00',2.8),('5819','2013-06-07','16:10:00',2.73),('5819','2013-06-07','16:15:00',2.63),('5819','2013-06-07','16:20:00',2.56),('5819','2013-06-07','16:25:00',2.51),('5819','2013-06-07','16:30:00',2.43),('5819','2013-06-07','16:35:00',2.36),('5819','2013-06-07','16:40:00',2.34),('5819','2013-06-07','16:45:00',2.28),('5819','2013-06-07','16:50:00',2.2),('5819','2013-06-07','16:55:00',2.13),('5819','2013-06-07','17:00:00',2.06),('5819','2013-06-07','17:05:00',1.98),('5819','2013-06-07','17:10:00',1.9),('5819','2013-06-07','17:15:00',1.83),('5819','2013-06-07','17:20:00',1.74),('5819','2013-06-07','17:25:00',1.68),('5819','2013-06-07','17:30:00',1.62),('5819','2013-06-07','17:35:00',1.56),('5819','2013-06-07','17:40:00',1.5),('5819','2013-06-07','17:45:00',1.36),('5819','2013-06-07','17:50:00',1.36),('5819','2013-06-07','17:55:00',1.25),('5819','2013-06-07','18:00:00',1.15),('5819','2013-06-07','18:05:00',1.07),('5819','2013-06-06','07:00:00',1.03),('5819','2013-06-06','07:05:00',1.16),('5819','2013-06-06','07:10:00',1.16),('5819','2013-06-06','07:15:00',1.2),('5819','2013-06-06','07:50:00',1.38),('5819','2013-06-06','07:55:00',1.76),('5819','2013-06-06','08:00:00',1.93),('5819','2013-06-06','08:05:00',1.45),('5819','2013-06-06','08:10:00',1.68),('5819','2013-06-06','08:15:00',1.6),('5819','2013-06-06','08:20:00',1.83),('5819','2013-06-06','08:25:00',2.18),('5819','2013-06-06','08:30:00',2.26),('5819','2013-06-06','08:35:00',2.34),('5819','2013-06-06','08:40:00',2.36),('5819','2013-06-06','08:45:00',2.42),('5819','2013-06-06','08:50:00',2.5),('5819','2013-06-06','08:55:00',2.59),('5819','2013-06-06','09:00:00',2.64),('5819','2013-06-06','09:05:00',2.68),('5819','2013-06-06','09:10:00',2.77),('5819','2013-06-06','09:15:00',2.82),('5819','2013-06-06','09:20:00',2.85),('5819','2013-06-06','09:25:00',2.96),('5819','2013-06-06','09:30:00',2.97),('5819','2013-06-06','09:35:00',3.04),('5819','2013-06-06','09:40:00',3.15),('5819','2013-06-06','09:45:00',3.2),('5819','2013-06-06','09:50:00',3.21),('5819','2013-06-06','09:55:00',3.19),('5819','2013-06-06','10:00:00',3.28),('5819','2013-06-06','10:05:00',3.39),('5819','2013-06-06','10:10:00',3.4),('5819','2013-06-06','10:15:00',3.45),('5819','2013-06-06','10:20:00',3.52),('5819','2013-06-06','10:25:00',3.55),('5819','2013-06-06','10:30:00',3.55),('5819','2013-06-06','10:35:00',3.55),('5819','2013-06-06','10:40:00',3.56),('5819','2013-06-06','10:45:00',3.66),('5819','2013-06-06','10:50:00',3.66),('5819','2013-06-06','10:55:00',3.69),('5819','2013-06-06','11:00:00',3.73),('5819','2013-06-06','11:05:00',3.72),('5819','2013-06-06','11:10:00',3.76),('5819','2013-06-06','11:15:00',3.79),('5819','2013-06-06','11:20:00',3.79),('5819','2013-06-06','11:25:00',3.8),('5819','2013-06-06','11:30:00',3.81),('5819','2013-06-06','11:35:00',3.84),('5819','2013-06-06','11:40:00',3.88),('5819','2013-06-06','11:45:00',3.82),('5819','2013-06-06','11:50:00',3.81),('5819','2013-06-06','11:55:00',3.78),('5819','2013-06-06','12:00:00',3.8),('5819','2013-06-06','12:05:00',3.91),('5819','2013-06-06','12:10:00',3.93),('5819','2013-06-06','12:15:00',3.93),('5819','2013-06-06','12:20:00',3.93),('5819','2013-06-06','12:25:00',3.96),('5819','2013-06-06','12:30:00',3.96),('5819','2013-06-06','12:35:00',3.91),('5819','2013-06-06','12:40:00',3.94),('5819','2013-06-06','12:45:00',3.94),('5819','2013-06-06','12:50:00',3.95),('5819','2013-06-06','12:55:00',3.95),('5819','2013-06-06','13:00:00',3.95),('5819','2013-06-06','13:05:00',3.96),('5819','2013-06-06','13:10:00',3.95),('5819','2013-06-06','13:15:00',3.96),('5819','2013-06-06','13:20:00',3.98),('5819','2013-06-06','13:25:00',3.95),('5819','2013-06-06','13:30:00',3.98),('5819','2013-06-06','13:35:00',3.89),('5819','2013-06-06','13:40:00',3.9),('5819','2013-06-06','13:45:00',3.88),('5819','2013-06-06','13:50:00',3.82),('5819','2013-06-06','13:55:00',3.79),('5819','2013-06-06','14:00:00',3.82),('5819','2013-06-06','14:05:00',3.83),('5819','2013-06-06','14:10:00',3.76),('5819','2013-06-06','14:15:00',3.35),('5819','2013-06-06','14:20:00',3.64),('5819','2013-06-06','14:25:00',3.18),('5819','2013-06-06','14:30:00',3.67),('5819','2013-06-06','14:35:00',3.67),('5819','2013-06-06','14:40:00',3.72),('5819','2013-06-06','14:45:00',2.58),('5819','2013-06-06','14:50:00',2.8),('5819','2013-06-06','14:55:00',3.89),('5819','2013-06-06','15:00:00',3.68),('5819','2013-06-06','15:05:00',3.51),('5819','2013-06-06','15:10:00',3.42),('5819','2013-06-06','15:15:00',3.16),('5819','2013-06-06','15:20:00',3.37),('5819','2013-06-06','15:25:00',3.29),('5819','2013-06-06','15:30:00',3.17),('5819','2013-06-06','15:35:00',3.08),('5819','2013-06-06','15:40:00',3.11),('5819','2013-06-06','15:45:00',3.07),('5819','2013-06-06','15:50:00',2.96),('5819','2013-06-06','15:55:00',2.78),('5819','2013-06-06','16:00:00',2.89),('5819','2013-06-06','16:05:00',2.88),('5819','2013-06-06','16:10:00',2.65),('5819','2013-06-06','16:15:00',2.59),('5819','2013-06-06','16:20:00',2.48),('5819','2013-06-06','16:25:00',2.48),('5819','2013-06-06','16:30:00',2.47),('5819','2013-06-06','16:35:00',2.45),('5819','2013-06-06','16:40:00',2.37),('5819','2013-06-06','16:45:00',2.22),('5819','2013-06-06','16:50:00',2.12),('5819','2013-06-06','16:55:00',2.04),('5819','2013-06-06','17:00:00',2),('5819','2013-06-06','17:05:00',1.9),('5819','2013-06-06','17:10:00',1.83),('5819','2013-06-06','17:15:00',1.75),('5819','2013-06-06','17:20:00',1.7),('5819','2013-06-06','17:25:00',1.61),('5819','2013-06-06','17:30:00',1.54),('5819','2013-06-06','17:35:00',1.48),('5819','2013-06-06','17:40:00',1.37),('5819','2013-06-06','17:45:00',1.18),('5819','2013-06-06','17:50:00',1.18),('5819','2013-06-06','17:55:00',1.1),('5819','2013-06-06','18:00:00',1.04),('5819','2013-06-05','07:00:00',1.02),('5819','2013-06-05','07:55:00',1.35),('5819','2013-06-05','08:00:00',1.49),('5819','2013-06-05','08:10:00',1.47),('5819','2013-06-05','08:15:00',1.89),('5819','2013-06-05','08:20:00',2.09),('5819','2013-06-05','08:25:00',2.2),('5819','2013-06-05','08:30:00',2.26),('5819','2013-06-05','08:35:00',2.34),('5819','2013-06-05','08:40:00',2.4),('5819','2013-06-05','08:45:00',2.49),('5819','2013-06-05','08:50:00',2.52),('5819','2013-06-05','08:55:00',2.65),('5819','2013-06-05','09:00:00',2.6),('5819','2013-06-05','09:05:00',2.75),('5819','2013-06-05','09:10:00',2.78),('5819','2013-06-05','09:15:00',2.89),('5819','2013-06-05','09:20:00',3.1),('5819','2013-06-05','09:25:00',2.88),('5819','2013-06-05','09:30:00',3.16),('5819','2013-06-05','09:35:00',3.33),('5819','2013-06-05','09:40:00',3.5),('5819','2013-06-05','09:45:00',3.17),('5819','2013-06-05','09:50:00',3.02),('5819','2013-06-05','09:55:00',1.99),('5819','2013-06-05','10:00:00',1.84),('5819','2013-06-05','10:05:00',3.69),('5819','2013-06-05','10:10:00',1.55),('5819','2013-06-05','10:15:00',1.74),('5819','2013-06-05','10:20:00',1.45),('5819','2013-06-05','10:25:00',2.68),('5819','2013-06-05','10:30:00',1.73),('5819','2013-06-05','10:35:00',3.35),('5819','2013-06-05','10:40:00',2.6),('5819','2013-06-05','10:45:00',3.37),('5819','2013-06-05','10:50:00',3.43),('5819','2013-06-05','10:55:00',3.95),('5819','2013-06-05','11:00:00',3.98),('5819','2013-06-05','11:05:00',4.06),('5819','2013-06-05','11:10:00',1.68),('5819','2013-06-05','11:15:00',1.29),('5819','2013-06-05','11:20:00',1.58),('5819','2013-06-05','11:25:00',1.04),('5819','2013-06-05','11:30:00',1.13),('5819','2013-06-05','11:35:00',1.74),('5819','2013-06-05','11:40:00',2.03),('5819','2013-06-05','11:45:00',4.14),('5819','2013-06-05','11:50:00',3.37),('5819','2013-06-05','11:55:00',3.4),('5819','2013-06-05','12:00:00',1.43),('5819','2013-06-05','12:05:00',2.67),('5819','2013-06-05','12:10:00',4.6),('5819','2013-06-05','12:15:00',2.33),('5819','2013-06-05','12:20:00',4.24),('5819','2013-06-05','12:25:00',4.62),('5819','2013-06-05','12:30:00',4.44),('5819','2013-06-05','12:35:00',3.34),('5819','2013-06-05','12:40:00',3.41),('5819','2013-06-05','12:45:00',3.24),('5819','2013-06-05','12:50:00',3.29),('5819','2013-06-05','12:55:00',1.45),('5819','2013-06-05','13:00:00',1.86),('5819','2013-06-05','13:05:00',3.09),('5819','2013-06-05','13:10:00',2.27),('5819','2013-06-05','13:15:00',1.94),('5819','2013-06-05','13:20:00',2.46),('5819','2013-06-05','13:25:00',3.85),('5819','2013-06-05','13:30:00',2.99),('5819','2013-06-05','13:35:00',4.72),('5819','2013-06-05','13:40:00',4.44),('5819','2013-06-05','13:45:00',4.3),('5819','2013-06-05','13:50:00',4.15),('5819','2013-06-05','13:55:00',4.1),('5819','2013-06-05','14:00:00',4.04),('5819','2013-06-05','14:05:00',3.98),('5819','2013-06-05','14:10:00',3.84),('5819','2013-06-05','14:15:00',3.92),('5819','2013-06-05','14:20:00',3.91),('5819','2013-06-05','14:25:00',3.83),('5819','2013-06-05','14:30:00',3.78),('5819','2013-06-05','14:35:00',3.73),('5819','2013-06-05','14:40:00',3.71),('5819','2013-06-05','14:45:00',3.74),('5819','2013-06-05','14:50:00',3.68),('5819','2013-06-05','14:55:00',3.64),('5819','2013-06-05','15:00:00',3.54),('5819','2013-06-05','15:05:00',3.46),('5819','2013-06-05','15:10:00',3.44),('5819','2013-06-05','15:15:00',3.42),('5819','2013-06-05','15:20:00',3.28),('5819','2013-06-05','15:25:00',3.37),('5819','2013-06-05','15:30:00',3.31),('5819','2013-06-05','15:35:00',3.09),('5819','2013-06-05','15:40:00',3.26),('5819','2013-06-05','15:45:00',3.13),('5819','2013-06-05','15:50:00',3.13),('5819','2013-06-05','15:55:00',3.06),('5819','2013-06-05','16:00:00',3),('5819','2013-06-05','16:05:00',2.94),('5819','2013-06-05','16:10:00',2.83),('5819','2013-06-05','16:15:00',2.79),('5819','2013-06-05','16:20:00',2.7),('5819','2013-06-05','16:25:00',2.65),('5819','2013-06-05','16:30:00',2.53),('5819','2013-06-05','16:35:00',2.48),('5819','2013-06-05','16:40:00',2.41),('5819','2013-06-05','16:45:00',2.34),('5819','2013-06-05','16:50:00',2.29),('5819','2013-06-05','16:55:00',2.21),('5819','2013-06-05','17:00:00',2.13),('5819','2013-06-05','17:05:00',2.03),('5819','2013-06-05','17:10:00',1.66),('5819','2013-06-05','17:15:00',1.48),('5819','2013-06-05','17:20:00',1.07),('5819','2013-06-05','17:25:00',1.49),('5819','2013-06-05','17:30:00',1.74),('5819','2013-06-05','17:35:00',1.52),('5819','2013-06-05','17:40:00',1.34),('5819','2013-06-05','17:45:00',1.21),('5819','2013-06-05','17:50:00',1.17),('5819','2013-06-05','17:55:00',1.15),('5819','2013-06-05','18:00:00',1.07),('5819','2013-06-04','07:15:00',1.09),('5819','2013-06-04','07:20:00',1.13),('5819','2013-06-04','07:25:00',1.21),('5819','2013-06-04','07:30:00',1.26),('5819','2013-06-04','07:35:00',1.38),('5819','2013-06-04','07:40:00',1.5),('5819','2013-06-04','07:45:00',1.66),('5819','2013-06-04','07:50:00',1.79),('5819','2013-06-04','07:55:00',1.9),('5819','2013-06-04','08:00:00',2.06),('5819','2013-06-04','08:05:00',2.19),('5819','2013-06-04','08:10:00',2.25),('5819','2013-06-04','08:15:00',2.31),('5819','2013-06-04','08:20:00',2.36),('5819','2013-06-04','08:25:00',2.16),('5819','2013-06-04','08:30:00',1.87),('5819','2013-06-04','08:35:00',2.55),('5819','2013-06-04','08:40:00',2.31),('5819','2013-06-04','08:45:00',1.98),('5819','2013-06-04','08:50:00',1.31),('5819','2013-06-04','08:55:00',1.35),('5819','2013-06-04','09:00:00',1.52),('5819','2013-06-04','09:05:00',1.88),('5819','2013-06-04','09:10:00',2.32),('5819','2013-06-04','09:15:00',2.75),('5819','2013-06-04','09:20:00',2.8),('5819','2013-06-04','09:25:00',3.7),('5819','2013-06-04','09:30:00',3.03),('5819','2013-06-04','09:35:00',2.74),('5819','2013-06-04','09:40:00',1.67),('5819','2013-06-04','09:45:00',1.83),('5819','2013-06-04','09:50:00',1.61),('5819','2013-06-04','09:55:00',1.51),('5819','2013-06-04','10:00:00',1.91),('5819','2013-06-04','10:05:00',2.08),('5819','2013-06-04','10:10:00',3.29),('5819','2013-06-04','10:15:00',2.98),('5819','2013-06-04','10:20:00',1.83),('5819','2013-06-04','10:25:00',1.71),('5819','2013-06-04','10:30:00',1.61),('5819','2013-06-04','10:35:00',1.66),('5819','2013-06-04','10:40:00',1.74),('5819','2013-06-04','10:45:00',1.99),('5819','2013-06-04','10:50:00',2.73),('5819','2013-06-04','10:55:00',3.32),('5819','2013-06-04','11:00:00',2.24),('5819','2013-06-04','11:05:00',2.61),('5819','2013-06-04','11:10:00',3.1),('5819','2013-06-04','11:15:00',2.99),('5819','2013-06-04','11:20:00',2.15),('5819','2013-06-04','11:25:00',2.77),('5819','2013-06-04','11:30:00',3.32),('5819','2013-06-04','11:35:00',2.73),('5819','2013-06-04','11:40:00',2.91),('5819','2013-06-04','11:45:00',3.91),('5819','2013-06-04','11:50:00',4.38),('5819','2013-06-04','11:55:00',3.8),('5819','2013-06-04','12:00:00',3.18),('5819','2013-06-04','12:05:00',2.83),('5819','2013-06-04','12:10:00',2.26),('5819','2013-06-04','12:15:00',2.46),('5819','2013-06-04','12:20:00',1.79),('5819','2013-06-04','12:25:00',1.96),('5819','2013-06-04','12:30:00',2.62),('5819','2013-06-04','12:35:00',3.68),('5819','2013-06-04','12:40:00',2.39),('5819','2013-06-04','12:45:00',2.74),('5819','2013-06-04','12:50:00',2.41),('5819','2013-06-04','12:55:00',1.71),('5819','2013-06-04','13:00:00',2.03),('5819','2013-06-04','13:05:00',1.49),('5819','2013-06-04','13:10:00',1.29),('5819','2013-06-04','13:15:00',1.31),('5819','2013-06-04','13:20:00',1.12),('5819','2013-06-04','13:25:00',1.4),('5819','2013-06-04','13:30:00',1.72),('5819','2013-06-04','13:35:00',3.85),('5819','2013-06-04','13:40:00',3.57),('5819','2013-06-04','13:45:00',4.86),('5819','2013-06-04','13:50:00',4.77),('5819','2013-06-04','13:55:00',2.65),('5819','2013-06-04','14:00:00',1.74),('5819','2013-06-04','14:05:00',3.83),('5819','2013-06-04','14:10:00',4.6),('5819','2013-06-04','14:15:00',4.16),('5819','2013-06-04','14:20:00',3.17),('5819','2013-06-04','14:25:00',2.32),('5819','2013-06-04','14:30:00',1.39),('5819','2013-06-04','14:35:00',1.73),('5819','2013-06-04','14:40:00',2.31),('5819','2013-06-04','14:45:00',1.04),('5819','2013-06-04','14:55:00',3.04),('5819','2013-06-04','15:00:00',4.72),('5819','2013-06-04','15:05:00',4.52),('5819','2013-06-04','15:10:00',2.38),('5819','2013-06-03','07:40:00',1.21),('5819','2013-06-03','07:45:00',1.57),('5819','2013-06-03','07:50:00',1.6),('5819','2013-06-03','07:55:00',1.74),('5819','2013-06-03','08:00:00',1.82),('5819','2013-06-03','08:05:00',1.86),('5819','2013-06-03','08:10:00',1.94),('5819','2013-06-03','08:15:00',2.01),('5819','2013-06-03','08:20:00',2.08),('5819','2013-06-03','08:25:00',2.18),('5819','2013-06-03','08:30:00',2.25),('5819','2013-06-03','08:35:00',2.32),('5819','2013-06-03','08:40:00',2.39),('5819','2013-06-03','08:45:00',2.49),('5819','2013-06-03','08:50:00',2.51),('5819','2013-06-03','08:55:00',2.51),('5819','2013-06-03','09:00:00',2.65),('5819','2013-06-03','09:05:00',2.76),('5819','2013-06-03','09:10:00',2.92),('5819','2013-06-03','09:15:00',3.05),('5819','2013-06-03','09:20:00',2.46),('5819','2013-06-03','09:25:00',2.77),('5819','2013-06-03','09:30:00',2.66),('5819','2013-06-03','09:35:00',1.87),('5819','2013-06-03','09:40:00',2.14),('5819','2013-06-03','09:45:00',2.51),('5819','2013-06-03','09:50:00',3.62),('5819','2013-06-03','09:55:00',3.81),('5819','2013-06-03','10:00:00',4.06),('5819','2013-06-03','10:05:00',4.12),('5819','2013-06-03','10:10:00',3.5),('5819','2013-06-03','10:15:00',2.42),('5819','2013-06-03','10:20:00',1.35),('5819','2013-06-03','10:25:00',1.67),('5819','2013-06-03','10:30:00',1.28),('5819','2013-06-03','10:35:00',1.27),('5819','2013-06-03','10:40:00',1.65),('5819','2013-06-03','10:45:00',1.72),('5819','2013-06-03','10:50:00',3.31),('5819','2013-06-03','10:55:00',4.6),('5819','2013-06-03','11:00:00',2.26),('5819','2013-06-03','11:05:00',1.63),('5819','2013-06-03','11:10:00',1.24),('5819','2013-06-03','11:15:00',1.31),('5819','2013-06-03','11:20:00',1.63),('5819','2013-06-03','11:25:00',1.66),('5819','2013-06-03','11:30:00',1.43),('5819','2013-06-03','11:35:00',1.32),('5819','2013-06-03','11:40:00',1.45),('5819','2013-06-03','11:45:00',2.51),('5819','2013-06-03','11:50:00',1.61),('5819','2013-06-03','11:55:00',1.59),('5819','2013-06-03','12:00:00',1.63),('5819','2013-06-03','12:05:00',3.67),('5819','2013-06-03','12:10:00',1.64),('5819','2013-06-03','12:15:00',1.34),('5819','2013-06-03','12:20:00',1.49),('5819','2013-06-03','12:25:00',1.41),('5819','2013-06-03','12:30:00',1.59),('5819','2013-06-03','12:35:00',1.64),('5819','2013-06-03','12:40:00',4.01),('5819','2013-06-03','12:45:00',2.38),('5819','2013-06-03','12:50:00',2.63),('5819','2013-06-03','12:55:00',2.53),('5819','2013-06-03','13:00:00',1.92),('5819','2013-06-03','13:05:00',1.68),('5819','2013-06-03','13:10:00',1.8),('5819','2013-06-03','13:15:00',2.34),('5819','2013-06-03','13:20:00',4.44),('5819','2013-06-03','13:25:00',3.12),('5819','2013-06-03','13:30:00',3.53),('5819','2013-06-03','13:35:00',3.85),('5819','2013-06-03','13:40:00',4.52),('5819','2013-06-03','13:45:00',2.27),('5819','2013-06-03','13:50:00',4.74),('5819','2013-06-03','13:55:00',2.93),('5819','2013-06-03','14:00:00',4.01),('5819','2013-06-03','14:05:00',4.08),('5819','2013-06-03','14:10:00',2.19),('5819','2013-06-03','14:15:00',2.17),('5819','2013-06-03','14:20:00',1.68),('5819','2013-06-03','14:25:00',2.74),('5819','2013-06-03','14:30:00',4.21),('5819','2013-06-03','14:35:00',4.34),('5819','2013-06-03','14:40:00',3.24),('5819','2013-06-03','14:45:00',3.38),('5819','2013-06-03','14:50:00',3.04),('5819','2013-06-03','14:55:00',3.25),('5819','2013-06-03','15:00:00',3.29),('5819','2013-06-03','15:05:00',2.85),('5819','2013-06-03','15:10:00',3.48),('5819','2013-06-03','15:15:00',2.18),('5819','2013-06-03','15:20:00',2.94),('5819','2013-06-03','15:25:00',3.47),('5819','2013-06-03','15:30:00',3.36),('5819','2013-06-03','15:35:00',3.31),('5819','2013-06-03','15:40:00',3.24),('5819','2013-06-03','15:45:00',3.19),('5819','2013-06-03','15:50:00',3.15),('5819','2013-06-03','15:55:00',3.1),('5819','2013-06-03','16:00:00',3.03),('5819','2013-06-03','16:05:00',2.97),('5819','2013-06-03','16:10:00',2.93),('5819','2013-06-03','16:15:00',2.77),('5819','2013-06-03','16:20:00',2.72),('5819','2013-06-03','16:25:00',2.69),('5819','2013-06-03','16:30:00',2.78),('5819','2013-06-03','16:35:00',2.62),('5819','2013-06-03','16:40:00',2.6),('5819','2013-06-03','16:45:00',2.25),('5819','2013-06-03','16:50:00',1.74),('5819','2013-06-03','16:55:00',1.6),('5819','2013-06-03','17:00:00',1.97),('5819','2013-06-03','17:05:00',2.22),('5819','2013-06-03','17:10:00',2.41),('5819','2013-06-03','17:15:00',2.06),('5819','2013-06-03','17:20:00',1.79),('5819','2013-06-03','17:25:00',1.23),('5819','2013-06-02','06:55:00',1.17),('5819','2013-06-02','07:00:00',1.23),('5819','2013-06-02','08:50:00',1.06),('5819','2013-06-02','09:10:00',1.11),('5819','2013-06-02','09:15:00',1.2),('5819','2013-06-02','09:20:00',1.69),('5819','2013-06-02','09:25:00',3.47),('5819','2013-06-02','09:30:00',3.3),('5819','2013-06-02','09:35:00',3.26),('5819','2013-06-02','09:40:00',3.26),('5819','2013-06-02','09:45:00',3.28),('5819','2013-06-02','09:50:00',3.33),('5819','2013-06-02','09:55:00',3.37),('5819','2013-06-02','10:00:00',3.39),('5819','2013-06-02','10:05:00',3.51),('5819','2013-06-02','10:10:00',3.55),('5819','2013-06-02','10:15:00',3.56),('5819','2013-06-02','10:20:00',3.59),('5819','2013-06-02','10:25:00',3.69),('5819','2013-06-02','10:30:00',3.75),('5819','2013-06-02','10:35:00',3.9),('5819','2013-06-02','10:40:00',3.96),('5819','2013-06-02','10:45:00',3.38),('5819','2013-06-02','10:50:00',1.44),('5819','2013-06-02','10:55:00',1.64),('5819','2013-06-02','11:00:00',4.05),('5819','2013-06-02','11:05:00',3.75),('5819','2013-06-02','11:10:00',4.09),('5819','2013-06-02','11:15:00',3.14),('5819','2013-06-02','11:20:00',3.75),('5819','2013-06-02','11:25:00',2.18),('5819','2013-06-02','11:30:00',4.14),('5819','2013-06-02','11:35:00',2.41),('5819','2013-06-02','11:40:00',1.63),('5819','2013-06-02','11:45:00',1.22),('5819','2013-06-02','11:50:00',1.73),('5819','2013-06-02','11:55:00',4.64),('5819','2013-06-02','12:00:00',4.09),('5819','2013-06-02','12:05:00',2.62),('5819','2013-06-02','12:10:00',3.58),('5819','2013-06-02','12:15:00',4.46),('5819','2013-06-02','12:20:00',2.64),('5819','2013-06-02','12:25:00',2.34),('5819','2013-06-02','12:30:00',3.55),('5819','2013-06-02','12:35:00',4.72),('5819','2013-06-02','12:40:00',3.2),('5819','2013-06-02','12:45:00',4.1),('5819','2013-06-02','12:50:00',2.28),('5819','2013-06-02','12:55:00',1.23),('5819','2013-06-02','13:00:00',2.72),('5819','2013-06-02','13:05:00',2.5),('5819','2013-06-02','13:10:00',1.7),('5819','2013-06-02','13:15:00',4.77),('5819','2013-06-02','13:20:00',4.35),('5819','2013-06-02','13:25:00',4.18),('5819','2013-06-02','13:30:00',4.12),('5819','2013-06-02','13:35:00',4.09),('5819','2013-06-02','13:40:00',4.05),('5819','2013-06-02','13:45:00',4),('5819','2013-06-02','13:50:00',3.97),('5819','2013-06-02','13:55:00',3.96),('5819','2013-06-02','14:00:00',3.96),('5819','2013-06-02','14:05:00',3.93),('5819','2013-06-02','14:10:00',3.91),('5819','2013-06-02','14:15:00',3.93),('5819','2013-06-02','14:20:00',3.8),('5819','2013-06-02','14:25:00',3.83),('5819','2013-06-02','14:30:00',3.81),('5819','2013-06-02','14:35:00',3.75),('5819','2013-06-02','14:40:00',3.71),('5819','2013-06-02','14:45:00',3.67),('5819','2013-06-02','14:50:00',3.6),('5819','2013-06-02','14:55:00',3.57),('5819','2013-06-02','15:00:00',3.53),('5819','2013-06-02','15:05:00',3.5),('5819','2013-06-02','15:10:00',3.47),('5819','2013-06-02','15:15:00',3.46),('5819','2013-06-02','15:20:00',3.41),('5819','2013-06-02','15:25:00',3.02),('5819','2013-06-02','15:30:00',3),('5819','2013-06-02','15:35:00',2.99),('5819','2013-06-02','15:40:00',2.42),('5819','2013-06-02','15:45:00',2.67),('5819','2013-06-02','15:50:00',3.14),('5819','2013-06-02','15:55:00',2.8),('5819','2013-06-02','16:00:00',2.64),('5819','2013-06-02','16:05:00',2.96),('5819','2013-06-02','16:10:00',2.95),('5819','2013-06-02','16:15:00',2.93),('5819','2013-06-02','16:20:00',2.73),('5819','2013-06-02','16:25:00',2.75),('5819','2013-06-02','16:30:00',2.61),('5819','2013-06-02','16:35:00',2.51),('5819','2013-06-02','16:40:00',2.57),('5819','2013-06-02','16:45:00',2.27),('5819','2013-06-02','16:50:00',2.26),('5819','2013-06-02','16:55:00',2.29),('5819','2013-06-02','17:00:00',2.06),('5819','2013-06-02','17:05:00',1.73),('5819','2013-06-02','17:10:00',2.04),('5819','2013-06-02','17:15:00',1.67),('5819','2013-06-02','17:20:00',1.83),('5819','2013-06-02','17:25:00',1.73),('5819','2013-06-02','17:30:00',1.69),('5819','2013-06-02','17:35:00',1.46),('5819','2013-06-02','17:40:00',1.02),('5819','2013-06-01','07:10:00',1.02),('5819','2013-06-01','07:15:00',1.08),('5819','2013-06-01','07:20:00',1.19),('5819','2013-06-01','07:25:00',1.26),('5819','2013-06-01','07:30:00',1.34),('5819','2013-06-01','07:35:00',1.42),('5819','2013-06-01','07:40:00',1.53),('5819','2013-06-01','07:45:00',1.74),('5819','2013-06-01','07:55:00',1.49),('5819','2013-06-01','08:15:00',1.21),('5819','2013-06-01','08:20:00',1.49),('5819','2013-06-01','08:35:00',1.91),('5819','2013-06-01','09:50:00',1.05),('5819','2013-06-01','10:40:00',1.19),('5819','2013-06-01','10:50:00',1.82),('5819','2013-06-01','10:55:00',2.24),('5819','2013-06-01','11:50:00',1.23),('5819','2013-06-01','11:55:00',1.74),('5819','2013-06-01','12:00:00',1.97),('5819','2013-06-01','12:05:00',2.98),('5819','2013-06-01','12:10:00',2.84),('5819','2013-06-01','12:15:00',1.7),('5819','2013-06-01','12:20:00',1.02),('5819','2013-06-01','12:25:00',1.12),('5819','2013-06-01','12:30:00',1.15),('5819','2013-06-01','12:45:00',1.47),('5819','2013-06-01','12:50:00',1.77),('5819','2013-06-01','12:55:00',1.68),('5819','2013-06-01','13:00:00',1.95),('5819','2013-06-01','13:05:00',2.17),('5819','2013-06-01','13:10:00',2.26),('5819','2013-06-01','13:15:00',2.48),('5819','2013-06-01','13:20:00',2.3),('5819','2013-06-01','13:25:00',1.74),('5819','2013-06-01','13:30:00',1.58),('5819','2013-06-01','13:35:00',1.24),('5819','2013-06-01','13:40:00',1.09),('5819','2013-06-01','13:45:00',1.16),('5819','2013-06-01','13:50:00',1.24),('5819','2013-06-01','13:55:00',1.38),('5819','2013-06-01','14:00:00',1.78),('5819','2013-06-01','14:05:00',2.28),('5819','2013-06-01','14:10:00',2.25),('5819','2013-06-01','14:15:00',2.34),('5819','2013-06-01','14:20:00',2.62),('5819','2013-06-01','14:25:00',1.68),('5819','2013-06-01','14:30:00',1.3),('5819','2013-06-01','14:35:00',1.34),('5819','2013-06-01','14:40:00',1.29),('5819','2013-06-01','14:45:00',1.19),('5819','2013-06-01','14:50:00',1.06),('5819','2013-06-01','18:35:00',1.01),('5819','2013-05-31','07:15:00',1.05),('5819','2013-05-31','07:20:00',1.16),('5819','2013-05-31','07:25:00',1.25),('5819','2013-05-31','07:30:00',1.35),('5819','2013-05-31','07:35:00',1.43),('5819','2013-05-31','07:40:00',1.53),('5819','2013-05-31','07:45:00',1.59),('5819','2013-05-31','07:50:00',1.68),('5819','2013-05-31','07:55:00',1.81),('5819','2013-05-31','08:00:00',1.94),('5819','2013-05-31','08:05:00',1.97),('5819','2013-05-31','08:10:00',2.06),('5819','2013-05-31','08:15:00',2.13),('5819','2013-05-31','08:20:00',2.21),('5819','2013-05-31','08:25:00',2.28),('5819','2013-05-31','08:30:00',2.41),('5819','2013-05-31','08:35:00',1.4),('5819','2013-05-31','08:40:00',2.81),('5819','2013-05-31','08:45:00',2.85),('5819','2013-05-31','08:50:00',3.14),('5819','2013-05-31','08:55:00',1.78),('5819','2013-05-31','09:10:00',1.13),('5819','2013-05-31','09:15:00',1.88),('5819','2013-05-31','09:30:00',1.27),('5819','2013-05-31','09:35:00',1.99),('5819','2013-05-31','09:40:00',1.91),('5819','2013-05-31','09:45:00',3.73),('5819','2013-05-31','09:50:00',3.68),('5819','2013-05-31','09:55:00',3.78),('5819','2013-05-31','10:00:00',3.47),('5819','2013-05-31','10:05:00',3.3),('5819','2013-05-31','10:10:00',2.38),('5819','2013-05-31','10:15:00',2.32),('5819','2013-05-31','10:20:00',3.08),('5819','2013-05-31','10:25:00',1.21),('5819','2013-05-31','10:35:00',2.02),('5819','2013-05-31','10:40:00',3.3),('5819','2013-05-31','10:45:00',4.59),('5819','2013-05-31','10:50:00',2.62),('5819','2013-05-31','10:55:00',3.11),('5819','2013-05-31','11:00:00',1.71),('5819','2013-05-31','11:05:00',1.8),('5819','2013-05-31','11:10:00',3.88),('5819','2013-05-31','11:15:00',3.93),('5819','2013-05-31','11:20:00',1.75),('5819','2013-05-31','11:25:00',2.95),('5819','2013-05-31','11:30:00',4.68),('5819','2013-05-31','11:35:00',1.91),('5819','2013-05-31','11:45:00',3.34),('5819','2013-05-31','11:50:00',3.7),('5819','2013-05-31','11:55:00',2.44),('5819','2013-05-31','12:00:00',3.16),('5819','2013-05-31','12:05:00',4.29),('5819','2013-05-31','12:10:00',3.71),('5819','2013-05-31','12:15:00',1.69),('5819','2013-05-31','12:20:00',1.56),('5819','2013-05-31','12:25:00',3.45),('5819','2013-05-31','12:30:00',1.8),('5819','2013-05-31','12:35:00',1.46),('5819','2013-05-31','12:40:00',4.27),('5819','2013-05-31','12:45:00',2.65),('5819','2013-05-31','12:55:00',1.4),('5819','2013-05-31','13:00:00',4.48),('5819','2013-05-31','13:05:00',2.35),('5819','2013-05-31','13:20:00',1.02),('5819','2013-05-31','13:25:00',1.8),('5819','2013-05-31','13:30:00',3.04),('5819','2013-05-31','13:35:00',4.44),('5819','2013-05-31','13:40:00',2.87),('5819','2013-05-31','13:45:00',1.55),('5819','2013-05-31','14:00:00',2.6),('5819','2013-05-31','15:05:00',1.41),('5819','2013-05-31','15:10:00',1.58),('5819','2013-05-31','15:15:00',2.27),('5819','2013-05-31','15:20:00',4.12),('5819','2013-05-31','15:25:00',3.19),('5819','2013-05-31','15:30:00',2.63),('5819','2013-05-31','15:35:00',2.04),('5819','2013-05-31','15:40:00',1.74),('5819','2013-05-31','15:45:00',1.52),('5819','2013-05-31','15:50:00',2.03),('5819','2013-05-31','15:55:00',2.03),('5819','2013-05-31','16:00:00',1.55),('5819','2013-05-31','16:05:00',1.22),('5819','2013-05-31','16:25:00',1.18),('5819','2013-05-31','16:30:00',1.13),('5819','2013-05-31','16:40:00',1.03),('5819','2013-05-31','16:45:00',1.14),('5819','2013-05-30','07:50:00',1.15),('5819','2013-05-30','08:25:00',1.16),('5819','2013-05-30','08:30:00',1.04),('5819','2013-05-30','08:40:00',2.51),('5819','2013-05-30','08:45:00',2.7),('5819','2013-05-30','08:50:00',2.72),('5819','2013-05-30','08:55:00',2.77),('5819','2013-05-30','09:00:00',2.84),('5819','2013-05-30','09:05:00',2.92),('5819','2013-05-30','09:10:00',3),('5819','2013-05-30','09:15:00',3.04),('5819','2013-05-30','09:20:00',3.1),('5819','2013-05-30','09:25:00',3.29),('5819','2013-05-30','09:30:00',3.44),('5819','2013-05-30','09:35:00',3.37),('5819','2013-05-30','09:40:00',3.45),('5819','2013-05-30','09:45:00',3.23),('5819','2013-05-30','09:50:00',3.73),('5819','2013-05-30','09:55:00',3),('5819','2013-05-30','10:00:00',1.07),('5819','2013-05-30','10:05:00',1.28),('5819','2013-05-30','10:10:00',4.1),('5819','2013-05-30','10:15:00',1.32),('5819','2013-05-30','10:20:00',3.89),('5819','2013-05-30','10:25:00',1.23),('5819','2013-05-30','10:40:00',1.59),('5819','2013-05-30','10:45:00',3.7),('5819','2013-05-30','10:50:00',4.4),('5819','2013-05-30','10:55:00',4.3),('5819','2013-05-30','11:00:00',4.18),('5819','2013-05-30','11:05:00',3.88),('5819','2013-05-30','11:10:00',2.02),('5819','2013-05-30','11:15:00',1.24),('5819','2013-05-30','11:20:00',4.47),('5819','2013-05-30','11:25:00',2.65),('5819','2013-05-30','11:30:00',2.46),('5819','2013-05-30','11:35:00',4.07),('5819','2013-05-30','11:40:00',4.72),('5819','2013-05-30','11:45:00',3.18),('5819','2013-05-30','11:50:00',4.77),('5819','2013-05-30','11:55:00',1.39),('5819','2013-05-30','12:00:00',2.52),('5819','2013-05-30','12:05:00',4.84),('5819','2013-05-30','12:10:00',4.34),('5819','2013-05-30','12:15:00',3.34),('5819','2013-05-30','12:20:00',4.56),('5819','2013-05-30','12:25:00',3.48),('5819','2013-05-30','12:30:00',3.83),('5819','2013-05-30','12:35:00',3.86),('5819','2013-05-30','12:40:00',3.87),('5819','2013-05-30','12:45:00',2.26),('5819','2013-05-30','12:50:00',3.58),('5819','2013-05-30','12:55:00',4.56),('5819','2013-05-30','13:00:00',3.69),('5819','2013-05-30','13:05:00',2.03),('5819','2013-05-30','13:10:00',1.9),('5819','2013-05-30','13:15:00',2.55),('5819','2013-05-30','13:20:00',2.09),('5819','2013-05-30','13:25:00',2.04),('5819','2013-05-30','13:30:00',2.49),('5819','2013-05-30','13:35:00',1.63),('5819','2013-05-30','13:40:00',3.29),('5819','2013-05-30','13:45:00',3.17),('5819','2013-05-30','13:50:00',1.6),('5819','2013-05-30','13:55:00',1.78),('5819','2013-05-30','14:00:00',4.27),('5819','2013-05-30','14:05:00',4.67),('5819','2013-05-30','14:10:00',3.55),('5819','2013-05-30','14:15:00',2),('5819','2013-05-30','14:20:00',4.08),('5819','2013-05-30','14:25:00',2.26),('5819','2013-05-30','14:30:00',4.27),('5819','2013-05-30','14:35:00',3.37),('5819','2013-05-30','14:40:00',4.13),('5819','2013-05-30','14:45:00',4.07),('5819','2013-05-30','14:50:00',4.1),('5819','2013-05-30','14:55:00',3.94),('5819','2013-05-30','15:00:00',3.89),('5819','2013-05-30','15:05:00',3.9),('5819','2013-05-30','15:10:00',1.22),('5819','2013-05-30','15:15:00',3.66),('5819','2013-05-30','15:20:00',3.82),('5819','2013-05-30','15:25:00',3.69),('5819','2013-05-30','15:30:00',3.7),('5819','2013-05-30','15:35:00',3.86),('5819','2013-05-30','15:40:00',3.7),('5819','2013-05-30','15:45:00',2.91),('5819','2013-05-30','15:50:00',3.28),('5819','2013-05-30','15:55:00',2.63),('5819','2013-05-30','16:00:00',3.77),('5819','2013-05-30','16:05:00',3),('5819','2013-05-30','16:10:00',3.26),('5819','2013-05-30','16:15:00',3.06),('5819','2013-05-30','16:20:00',2.71),('5819','2013-05-30','16:25:00',2.26),('5819','2013-05-30','16:30:00',1.3),('5819','2013-05-30','16:35:00',1.4),('5819','2013-05-30','16:45:00',1.67),('5819','2013-05-30','16:50:00',2.08),('5819','2013-05-30','16:55:00',2.07),('5819','2013-05-30','17:00:00',1.15),('5819','2013-05-30','17:05:00',1.64),('5819','2013-05-29','07:15:00',1.05),('5819','2013-05-29','07:20:00',1.14),('5819','2013-05-29','07:25:00',1.22),('5819','2013-05-29','07:30:00',1.31),('5819','2013-05-29','07:35:00',1.4),('5819','2013-05-29','07:40:00',1.5),('5819','2013-05-29','07:45:00',1.58),('5819','2013-05-29','07:50:00',1.65),('5819','2013-05-29','07:55:00',1.74),('5819','2013-05-29','08:00:00',1.83),('5819','2013-05-29','08:05:00',1.91),('5819','2013-05-29','08:10:00',2),('5819','2013-05-29','08:15:00',2.08),('5819','2013-05-29','08:20:00',2.15),('5819','2013-05-29','08:25:00',2.21),('5819','2013-05-29','08:30:00',2.31),('5819','2013-05-29','08:35:00',2.41),('5819','2013-05-29','08:40:00',2.46),('5819','2013-05-29','08:45:00',2.54),('5819','2013-05-29','08:50:00',2.61),('5819','2013-05-29','08:55:00',2.69),('5819','2013-05-29','09:00:00',2.78),('5819','2013-05-29','09:05:00',2.84),('5819','2013-05-29','09:10:00',2.89),('5819','2013-05-29','09:15:00',2.97),('5819','2013-05-29','09:20:00',3.03),('5819','2013-05-29','09:25:00',3.08),('5819','2013-05-29','09:30:00',3.14),('5819','2013-05-29','09:35:00',3.19),('5819','2013-05-29','09:40:00',3.25),('5819','2013-05-29','09:45:00',3.32),('5819','2013-05-29','09:50:00',3.36),('5819','2013-05-29','09:55:00',3.42),('5819','2013-05-29','10:00:00',3.45),('5819','2013-05-29','10:05:00',3.51),('5819','2013-05-29','10:10:00',3.54),('5819','2013-05-29','10:15:00',3.56),('5819','2013-05-29','10:20:00',3.66),('5819','2013-05-29','10:25:00',3.72),('5819','2013-05-29','10:30:00',3.76),('5819','2013-05-29','10:35:00',3.82),('5819','2013-05-29','10:40:00',3.84),('5819','2013-05-29','10:45:00',3.91),('5819','2013-05-29','10:50:00',3.93),('5819','2013-05-29','10:55:00',3.98),('5819','2013-05-29','11:00:00',4.01),('5819','2013-05-29','11:05:00',4.07),('5819','2013-05-29','11:10:00',4.11),('5819','2013-05-29','11:15:00',3.17),('5819','2013-05-29','11:20:00',3.44),('5819','2013-05-29','11:25:00',2.4),('5819','2013-05-29','11:30:00',4.38),('5819','2013-05-29','11:35:00',4.41),('5819','2013-05-29','11:40:00',3.75),('5819','2013-05-29','11:45:00',3.99),('5819','2013-05-29','11:50:00',3.64),('5819','2013-05-29','11:55:00',3.87),('5819','2013-05-29','12:00:00',4.38),('5819','2013-05-29','12:05:00',3.46),('5819','2013-05-29','12:10:00',3.45),('5819','2013-05-29','12:15:00',3.65),('5819','2013-05-29','12:20:00',4.49),('5819','2013-05-29','12:25:00',4.07),('5819','2013-05-29','12:30:00',4.34),('5819','2013-05-29','12:35:00',4.34),('5819','2013-05-29','12:40:00',4.35),('5819','2013-05-29','12:45:00',4.08),('5819','2013-05-29','12:50:00',4.2),('5819','2013-05-29','12:55:00',4.2),('5819','2013-05-29','13:00:00',4.32),('5819','2013-05-29','13:05:00',4.38),('5819','2013-05-29','13:10:00',3.63),('5819','2013-05-29','13:15:00',4.32),('5819','2013-05-29','13:20:00',4.61),('5819','2013-05-29','13:25:00',4.6),('5819','2013-05-29','13:30:00',4.59),('5819','2013-05-29','13:35:00',3.86),('5819','2013-05-29','13:40:00',4.19),('5819','2013-05-29','13:45:00',4.05),('5819','2013-05-29','13:50:00',3.69),('5819','2013-05-29','13:55:00',3.48),('5819','2013-05-29','14:00:00',4.14),('5819','2013-05-29','14:05:00',4.06),('5819','2013-05-29','14:10:00',3.91),('5819','2013-05-29','14:15:00',4.02),('5819','2013-05-29','14:20:00',3.97),('5819','2013-05-29','14:25:00',3.51),('5819','2013-05-29','14:30:00',3.98),('5819','2013-05-29','14:35:00',3.22),('5819','2013-05-29','14:40:00',4.1),('5819','2013-05-29','14:45:00',3.99),('5819','2013-05-29','14:50:00',3.67),('5819','2013-05-29','14:55:00',3.77),('5819','2013-05-29','15:00:00',3.94),('5819','2013-05-29','15:05:00',3.95),('5819','2013-05-29','15:10:00',3.81),('5819','2013-05-29','15:15:00',2.41),('5819','2013-05-29','15:20:00',2.73),('5819','2013-05-29','15:25:00',2.29),('5819','2013-05-29','15:30:00',2.51),('5819','2013-05-29','15:35:00',2.74),('5819','2013-05-29','15:40:00',2.77),('5819','2013-05-29','15:45:00',2.69),('5819','2013-05-29','15:50:00',2.53),('5819','2013-05-29','15:55:00',2.7),('5819','2013-05-29','16:00:00',2.39),('5819','2013-05-29','16:05:00',2.34),('5819','2013-05-29','16:10:00',1.98),('5819','2013-05-29','16:15:00',1.86),('5819','2013-05-29','16:20:00',1.81),('5819','2013-05-29','16:25:00',1.85),('5819','2013-05-29','16:30:00',1.81),('5819','2013-05-29','16:35:00',1.65),('5819','2013-05-29','16:40:00',1.88),('5819','2013-05-29','16:45:00',1.66),('5819','2013-05-29','16:50:00',1.38),('5819','2013-05-29','16:55:00',1.31),('5819','2013-05-29','17:00:00',1.27),('5819','2013-05-29','17:40:00',1.35),('5819','2013-05-29','17:45:00',1.04),('5819','2013-05-29','18:15:00',1.14),('5819','2013-05-29','18:20:00',1.17),('5819','2013-05-28','07:15:00',1.09),('5819','2013-05-28','07:20:00',1.27),('5819','2013-05-28','07:25:00',1.31),('5819','2013-05-28','07:30:00',1.01),('5819','2013-05-28','07:40:00',1.17),('5819','2013-05-28','07:45:00',1.23),('5819','2013-05-28','07:50:00',1.22),('5819','2013-05-28','07:55:00',1.21),('5819','2013-05-28','08:00:00',1.26),('5819','2013-05-28','08:05:00',1.38),('5819','2013-05-28','08:10:00',1.51),('5819','2013-05-28','08:15:00',1.82),('5819','2013-05-28','08:20:00',1.95),('5819','2013-05-28','08:25:00',1.74),('5819','2013-05-28','08:30:00',1.9),('5819','2013-05-28','08:35:00',1.72),('5819','2013-05-28','08:40:00',1.51),('5819','2013-05-28','08:45:00',1.39),('5819','2013-05-28','08:50:00',1.63),('5819','2013-05-28','08:55:00',1.46),('5819','2013-05-28','09:00:00',1.66),('5819','2013-05-28','09:05:00',1.8),('5819','2013-05-28','09:10:00',1.68),('5819','2013-05-28','09:15:00',1.56),('5819','2013-05-28','09:20:00',1.84),('5819','2013-05-28','09:25:00',2.13),('5819','2013-05-28','09:30:00',2.28),('5819','2013-05-28','09:35:00',2.41),('5819','2013-05-28','09:40:00',2.26),('5819','2013-05-28','09:45:00',2.07),('5819','2013-05-28','09:50:00',2.1),('5819','2013-05-28','09:55:00',2.21),('5819','2013-05-28','10:00:00',2.07),('5819','2013-05-28','10:05:00',2.17),('5819','2013-05-28','10:10:00',2.45),('5819','2013-05-28','10:15:00',2.53),('5819','2013-05-28','10:20:00',2.7),('5819','2013-05-28','10:25:00',2.63),('5819','2013-05-28','10:30:00',2.93),('5819','2013-05-28','10:35:00',3.01),('5819','2013-05-28','10:40:00',2.71),('5819','2013-05-28','10:45:00',2.49),('5819','2013-05-28','10:50:00',2.67),('5819','2013-05-28','10:55:00',2.4),('5819','2013-05-28','11:00:00',2.37),('5819','2013-05-28','11:05:00',2.29),('5819','2013-05-28','11:10:00',2.57),('5819','2013-05-28','11:15:00',1.92),('5819','2013-05-28','11:20:00',2.19),('5819','2013-05-28','11:25:00',1.92),('5819','2013-05-28','11:30:00',3.41),('5819','2013-05-28','11:35:00',3.01),('5819','2013-05-28','11:40:00',3.38),('5819','2013-05-28','11:45:00',3.53),('5819','2013-05-28','11:50:00',1.15),('5819','2013-05-28','11:55:00',1.44),('5819','2013-05-28','12:00:00',1.56),('5819','2013-05-28','12:05:00',1.67),('5819','2013-05-28','12:10:00',2.67),('5819','2013-05-28','12:15:00',2.6),('5819','2013-05-28','12:20:00',2.16),('5819','2013-05-28','12:25:00',2.18),('5819','2013-05-28','12:30:00',2.5),('5819','2013-05-28','12:35:00',2.45),('5819','2013-05-28','12:40:00',2.44),('5819','2013-05-28','12:45:00',2.8),('5819','2013-05-28','12:50:00',2.52),('5819','2013-05-28','12:55:00',2.5),('5819','2013-05-28','13:00:00',2.58),('5819','2013-05-28','13:05:00',2.75),('5819','2013-05-28','13:10:00',2.9),('5819','2013-05-28','13:15:00',2.62),('5819','2013-05-28','13:20:00',3.39),('5819','2013-05-28','13:25:00',1.83),('5819','2013-05-28','13:30:00',2.03),('5819','2013-05-28','13:35:00',1.69),('5819','2013-05-28','13:40:00',1.87),('5819','2013-05-28','13:45:00',1.75),('5819','2013-05-28','13:50:00',2.52),('5819','2013-05-28','13:55:00',2.59),('5819','2013-05-28','14:00:00',2.47),('5819','2013-05-28','14:05:00',2.51),('5819','2013-05-28','14:10:00',3.55),('5819','2013-05-28','14:15:00',3.71),('5819','2013-05-28','14:20:00',2.27),('5819','2013-05-28','14:25:00',2.64),('5819','2013-05-28','14:30:00',3.12),('5819','2013-05-28','14:35:00',2.66),('5819','2013-05-28','14:40:00',3.03),('5819','2013-05-28','14:45:00',3.49),('5819','2013-05-28','14:50:00',2.67),('5819','2013-05-28','14:55:00',2.42),('5819','2013-05-28','15:00:00',2.02),('5819','2013-05-28','15:05:00',3.34),('5819','2013-05-28','15:10:00',1.63),('5819','2013-05-28','15:15:00',2.27),('5819','2013-05-28','15:20:00',2.84),('5819','2013-05-28','15:25:00',1.91),('5819','2013-05-28','15:30:00',1.39),('5819','2013-05-28','15:35:00',1.4),('5819','2013-05-28','15:40:00',1.92),('5819','2013-05-28','15:45:00',3.26),('5819','2013-05-28','15:50:00',2.71),('5819','2013-05-28','15:55:00',2.16),('5819','2013-05-28','16:00:00',1.51),('5819','2013-05-28','16:05:00',1.17),('5819','2013-05-28','16:10:00',1.31),('5819','2013-05-28','16:15:00',1.3),('5819','2013-05-28','16:20:00',1.88),('5819','2013-05-28','16:25:00',1.91),('5819','2013-05-28','16:30:00',1.82),('5819','2013-05-28','16:35:00',2.49),('5819','2013-05-28','16:40:00',2.28),('5819','2013-05-28','16:45:00',2.19),('5819','2013-05-28','16:50:00',2.11),('5819','2013-05-28','16:55:00',2.03),('5819','2013-05-28','17:00:00',1.97),('5819','2013-05-28','17:05:00',1.89),('5819','2013-05-28','17:10:00',1.81),('5819','2013-05-28','17:15:00',1.75),('5819','2013-05-28','17:20:00',1.67),('5819','2013-05-28','17:25:00',1.56),('5819','2013-05-28','17:30:00',1.48),('5819','2013-05-28','17:35:00',1.4),('5819','2013-05-28','17:40:00',1.18),('5819','2013-05-28','17:45:00',1.17),('5819','2013-05-28','17:50:00',1.12),('5819','2013-05-28','17:55:00',1.05),('5819','2013-05-28','18:00:00',1.07),('5819','2013-05-27','07:25:00',1.11),('5819','2013-05-27','07:30:00',1.43),('5819','2013-05-27','07:35:00',1.5),('5819','2013-05-27','07:40:00',1.54),('5819','2013-05-27','07:45:00',1.59),('5819','2013-05-27','07:50:00',1.54),('5819','2013-05-27','08:00:00',1.52),('5819','2013-05-27','08:05:00',1.86),('5819','2013-05-27','08:10:00',2.23),('5819','2013-05-27','08:15:00',1.77),('5819','2013-05-27','08:20:00',2.08),('5819','2013-05-27','08:25:00',2.31),('5819','2013-05-27','08:30:00',2.38),('5819','2013-05-27','08:35:00',2.44),('5819','2013-05-27','08:40:00',2.52),('5819','2013-05-27','08:45:00',2.74),('5819','2013-05-27','08:50:00',2.99),('5819','2013-05-27','08:55:00',2.14),('5819','2013-05-27','09:00:00',2.63),('5819','2013-05-27','09:05:00',3.2),('5819','2013-05-27','09:10:00',2.9),('5819','2013-05-27','09:15:00',1.98),('5819','2013-05-27','09:20:00',2.59),('5819','2013-05-27','09:25:00',3.08),('5819','2013-05-27','09:30:00',3.37),('5819','2013-05-27','09:35:00',3.36),('5819','2013-05-27','09:40:00',3.37),('5819','2013-05-27','09:45:00',3.44),('5819','2013-05-27','09:50:00',2.32),('5819','2013-05-27','09:55:00',2.62),('5819','2013-05-27','10:00:00',3.79),('5819','2013-05-27','10:05:00',3.21),('5819','2013-05-27','10:10:00',3.7),('5819','2013-05-27','10:15:00',3.87),('5819','2013-05-27','10:20:00',3.35),('5819','2013-05-27','10:25:00',2.44),('5819','2013-05-27','10:30:00',2.37),('5819','2013-05-27','10:35:00',1.32),('5819','2013-05-27','10:40:00',1.23),('5819','2013-05-27','10:45:00',3.01),('5819','2013-05-27','10:50:00',2.85),('5819','2013-05-27','10:55:00',2.45),('5819','2013-05-27','11:00:00',3.03),('5819','2013-05-27','11:05:00',3.36),('5819','2013-05-27','11:10:00',3.25),('5819','2013-05-27','11:15:00',1.97),('5819','2013-05-27','11:20:00',3.13),('5819','2013-05-27','11:25:00',4.31),('5819','2013-05-27','11:30:00',3.14),('5819','2013-05-27','11:35:00',4.03),('5819','2013-05-27','11:40:00',2.41),('5819','2013-05-27','11:45:00',4.81),('5819','2013-05-27','11:50:00',2.2),('5819','2013-05-27','11:55:00',1.85),('5819','2013-05-27','12:00:00',4.18),('5819','2013-05-27','12:05:00',4.34),('5819','2013-05-27','12:10:00',2.47),('5819','2013-05-27','12:15:00',4.18),('5819','2013-05-27','12:20:00',2.99),('5819','2013-05-27','12:25:00',3.4),('5819','2013-05-27','12:30:00',3.39),('5819','2013-05-27','12:35:00',2.55),('5819','2013-05-27','12:40:00',3.28),('5819','2013-05-27','12:45:00',4.88),('5819','2013-05-27','12:50:00',4.58),('5819','2013-05-27','12:55:00',4.31),('5819','2013-05-27','13:00:00',2.84),('5819','2013-05-27','13:05:00',3.88),('5819','2013-05-27','13:10:00',4.38),('5819','2013-05-27','13:15:00',4.01),('5819','2013-05-27','13:20:00',4.21),('5819','2013-05-27','13:25:00',3.47),('5819','2013-05-27','13:30:00',4.38),('5819','2013-05-27','13:35:00',3.85),('5819','2013-05-27','13:40:00',4.2),('5819','2013-05-27','13:45:00',4.51),('5819','2013-05-27','13:50:00',3.89),('5819','2013-05-27','13:55:00',2.87),('5819','2013-05-27','14:00:00',4.21),('5819','2013-05-27','14:05:00',4.15),('5819','2013-05-27','14:10:00',3.99),('5819','2013-05-27','14:15:00',3.68),('5819','2013-05-27','14:20:00',3.63),('5819','2013-05-27','14:25:00',3.4),('5819','2013-05-27','14:30:00',3.64),('5819','2013-05-27','14:35:00',4.01),('5819','2013-05-27','14:40:00',1.47),('5819','2013-05-27','14:45:00',4.09),('5819','2013-05-27','14:50:00',4.02),('5819','2013-05-27','14:55:00',3.27),('5819','2013-05-27','15:00:00',2.53),('5819','2013-05-27','15:05:00',2.36),('5819','2013-05-27','15:10:00',3.81),('5819','2013-05-27','15:15:00',2.65),('5819','2013-05-27','15:20:00',3),('5819','2013-05-27','15:25:00',2.95),('5819','2013-05-27','15:30:00',3.13),('5819','2013-05-27','15:35:00',3.55),('5819','2013-05-27','15:40:00',2.83),('5819','2013-05-27','15:45:00',2.65),('5819','2013-05-27','15:50:00',3.34),('5819','2013-05-27','15:55:00',2.24),('5819','2013-05-27','16:00:00',2.67),('5819','2013-05-27','16:05:00',1.94),('5819','2013-05-27','16:10:00',2.31),('5819','2013-05-27','16:15:00',2.02),('5819','2013-05-27','16:20:00',3.08),('5819','2013-05-27','16:25:00',2.96),('5819','2013-05-27','16:30:00',2.64),('5819','2013-05-27','16:35:00',2.49),('5819','2013-05-27','16:40:00',1.25),('5819','2013-05-27','16:45:00',1.09),('5819','2013-05-27','16:50:00',1.13),('5819','2013-05-27','16:55:00',1.22),('5819','2013-05-27','17:00:00',1.27),('5819','2013-05-27','17:05:00',1.3),('5819','2013-05-27','17:10:00',1.55),('5819','2013-05-27','17:15:00',1.32),('5819','2013-05-27','17:20:00',1.15),('5819','2013-05-27','17:25:00',1.06),('5819','2013-05-27','17:30:00',1.04),('5819','2013-05-26','07:35:00',1.12),('5819','2013-05-26','07:40:00',1.48),('5819','2013-05-26','07:45:00',1.7),('5819','2013-05-26','07:50:00',2.25),('5819','2013-05-26','07:55:00',1.13),('5819','2013-05-26','08:05:00',2.33),('5819','2013-05-26','08:10:00',2.26),('5819','2013-05-26','08:20:00',1.13),('5819','2013-05-26','08:25:00',1.67),('5819','2013-05-26','08:30:00',2.39),('5819','2013-05-26','08:35:00',2.63),('5819','2013-05-26','08:40:00',2.52),('5819','2013-05-26','08:45:00',2.25),('5819','2013-05-26','08:50:00',2.46),('5819','2013-05-26','09:00:00',2.59),('5819','2013-05-26','09:10:00',1.73),('5819','2013-05-26','09:15:00',2.87),('5819','2013-05-26','09:25:00',1.5),('5819','2013-05-26','09:45:00',2.2),('5819','2013-05-26','10:00:00',1.31),('5819','2013-05-26','10:05:00',3.05),('5819','2013-05-26','10:10:00',4.1),('5819','2013-05-26','10:15:00',2.99),('5819','2013-05-26','10:20:00',3.76),('5819','2013-05-26','10:25:00',2.89),('5819','2013-05-26','10:30:00',3.4),('5819','2013-05-26','10:35:00',3.24),('5819','2013-05-26','10:40:00',3.93),('5819','2013-05-26','10:45:00',4.09),('5819','2013-05-26','10:50:00',4.13),('5819','2013-05-26','10:55:00',3.92),('5819','2013-05-26','11:00:00',4.18),('5819','2013-05-26','11:05:00',4.24),('5819','2013-05-26','11:10:00',4.25),('5819','2013-05-26','11:15:00',4.25),('5819','2013-05-26','11:20:00',4.28),('5819','2013-05-26','11:25:00',4.33),('5819','2013-05-26','11:30:00',4.35),('5819','2013-05-26','11:35:00',4.39),('5819','2013-05-26','11:40:00',4.43),('5819','2013-05-26','11:45:00',4.47),('5819','2013-05-26','11:50:00',4.49),('5819','2013-05-26','11:55:00',4.43),('5819','2013-05-26','12:00:00',4.38),('5819','2013-05-26','12:05:00',4.49),('5819','2013-05-26','12:10:00',4.47),('5819','2013-05-26','12:15:00',4.37),('5819','2013-05-26','12:20:00',3.9),('5819','2013-05-26','12:25:00',3.95),('5819','2013-05-26','12:30:00',4.62),('5819','2013-05-26','12:35:00',4.52),('5819','2013-05-26','12:40:00',4.13),('5819','2013-05-26','12:45:00',3.26),('5819','2013-05-26','12:50:00',4.56),('5819','2013-05-26','12:55:00',4.52),('5819','2013-05-26','13:00:00',4.52),('5819','2013-05-26','13:05:00',4.57),('5819','2013-05-26','13:10:00',4.38),('5819','2013-05-26','13:15:00',4.22),('5819','2013-05-26','13:20:00',4.24),('5819','2013-05-26','13:25:00',4.44),('5819','2013-05-26','13:30:00',4.4),('5819','2013-05-26','13:35:00',4.39),('5819','2013-05-26','13:40:00',4.35),('5819','2013-05-26','13:45:00',4.33),('5819','2013-05-26','13:50:00',3.75),('5819','2013-05-26','13:55:00',4.24),('5819','2013-05-26','14:00:00',4.19),('5819','2013-05-26','14:05:00',4.17),('5819','2013-05-26','14:10:00',4.12),('5819','2013-05-26','14:15:00',4.06),('5819','2013-05-26','14:20:00',4.06),('5819','2013-05-26','14:25:00',4),('5819','2013-05-26','14:30:00',3.97),('5819','2013-05-26','14:35:00',3.95),('5819','2013-05-26','14:40:00',3.9),('5819','2013-05-26','14:45:00',3.87),('5819','2013-05-26','14:50:00',3.84),('5819','2013-05-26','14:55:00',3.79),('5819','2013-05-26','15:00:00',3.73),('5819','2013-05-26','15:05:00',3.69),('5819','2013-05-26','15:10:00',3.66),('5819','2013-05-26','15:15:00',3.6),('5819','2013-05-26','15:20:00',3.55),('5819','2013-05-26','15:25:00',3.48),('5819','2013-05-26','15:30:00',3.42),('5819','2013-05-26','15:35:00',3.38),('5819','2013-05-26','15:40:00',3.33),('5819','2013-05-26','15:45:00',3.26),('5819','2013-05-26','15:50:00',3.18),('5819','2013-05-26','15:55:00',3.12),('5819','2013-05-26','16:00:00',3.06),('5819','2013-05-26','16:05:00',3),('5819','2013-05-26','16:10:00',2.94),('5819','2013-05-26','16:15:00',2.87),('5819','2013-05-26','16:20:00',2.79),('5819','2013-05-26','16:25:00',2.72),('5819','2013-05-26','16:30:00',2.65),('5819','2013-05-26','16:35:00',2.56),('5819','2013-05-26','16:40:00',2.48),('5819','2013-05-26','16:45:00',2.41),('5819','2013-05-26','16:50:00',2.33),('5819','2013-05-26','16:55:00',2.24),('5819','2013-05-26','17:00:00',2.15),('5819','2013-05-26','17:05:00',2.08),('5819','2013-05-26','17:10:00',1.99),('5819','2013-05-26','17:15:00',1.91),('5819','2013-05-26','17:20:00',1.81),('5819','2013-05-26','17:25:00',1.73),('5819','2013-05-26','17:30:00',1.63),('5819','2013-05-26','17:35:00',1.54),('5819','2013-05-26','17:40:00',1.34),('5819','2013-05-26','17:45:00',1),('5819','2013-05-26','17:50:00',1.22),('5819','2013-05-26','17:55:00',1.14),('5819','2013-05-26','18:00:00',1.06),('5819','2013-05-25','07:15:00',1.31),('5819','2013-05-25','07:20:00',1.25),('5819','2013-05-25','07:30:00',1.4),('5819','2013-05-25','07:35:00',1.76),('5819','2013-05-25','07:40:00',1.57),('5819','2013-05-25','07:55:00',1.92),('5819','2013-05-25','08:00:00',2.25),('5819','2013-05-25','08:05:00',2.48),('5819','2013-05-25','08:10:00',1.68),('5819','2013-05-25','08:20:00',1.38),('5819','2013-05-25','08:25:00',2.6),('5819','2013-05-25','08:30:00',2.65),('5819','2013-05-25','08:35:00',1.52),('5819','2013-05-25','08:40:00',1.7),('5819','2013-05-25','08:45:00',1.57),('5819','2013-05-25','08:50:00',1.94),('5819','2013-05-25','08:55:00',2.74),('5819','2013-05-25','09:00:00',1.95),('5819','2013-05-25','09:05:00',3.19),('5819','2013-05-25','09:10:00',2.44),('5819','2013-05-25','09:15:00',2.97),('5819','2013-05-25','09:20:00',1.8),('5819','2013-05-25','09:25:00',1.69),('5819','2013-05-25','09:30:00',1.15),('5819','2013-05-25','09:35:00',2.31),('5819','2013-05-25','09:40:00',3.85),('5819','2013-05-25','09:45:00',2.61),('5819','2013-05-25','09:50:00',3.52),('5819','2013-05-25','09:55:00',2.33),('5819','2013-05-25','10:15:00',1.37),('5819','2013-05-25','10:40:00',1.23),('5819','2013-05-25','10:45:00',1.39),('5819','2013-05-25','10:50:00',1.35),('5819','2013-05-25','11:05:00',1.79),('5819','2013-05-25','11:10:00',4.13),('5819','2013-05-25','11:15:00',3.44),('5819','2013-05-25','11:20:00',2.9),('5819','2013-05-25','11:25:00',1.08),('5819','2013-05-25','11:35:00',1.03),('5819','2013-05-25','11:40:00',2.53),('5819','2013-05-25','11:45:00',2.12),('5819','2013-05-25','11:50:00',1.71),('5819','2013-05-25','11:55:00',1.92),('5819','2013-05-25','12:00:00',1.32),('5819','2013-05-25','12:05:00',1.2),('5819','2013-05-25','12:10:00',1.62),('5819','2013-05-25','12:15:00',1.09),('5819','2013-05-25','12:20:00',1.19),('5819','2013-05-25','12:25:00',1.9),('5819','2013-05-25','12:30:00',1.5),('5819','2013-05-25','12:35:00',1.28),('5819','2013-05-25','12:40:00',1.61),('5819','2013-05-25','12:45:00',1.74),('5819','2013-05-25','12:50:00',1.29),('5819','2013-05-25','12:55:00',1.66),('5819','2013-05-25','13:05:00',1.8),('5819','2013-05-25','13:10:00',1.35),('5819','2013-05-25','13:15:00',1.69),('5819','2013-05-25','13:20:00',2.61),('5819','2013-05-25','13:25:00',2.31),('5819','2013-05-25','13:30:00',2.15),('5819','2013-05-25','13:35:00',1.28),('5819','2013-05-25','13:40:00',1.85),('5819','2013-05-25','13:45:00',2.04),('5819','2013-05-25','13:50:00',2.21),('5819','2013-05-25','13:55:00',3.16),('5819','2013-05-25','14:00:00',3.64),('5819','2013-05-25','14:05:00',4.22),('5819','2013-05-25','14:10:00',3.93),('5819','2013-05-25','14:15:00',4.32),('5819','2013-05-25','14:20:00',3.72),('5819','2013-05-25','14:25:00',1.62),('5819','2013-05-25','14:30:00',2.8),('5819','2013-05-25','14:35:00',1.59),('5819','2013-05-25','14:40:00',2.22),('5819','2013-05-25','14:45:00',1.79),('5819','2013-05-25','14:50:00',2.69),('5819','2013-05-25','14:55:00',1.72),('5819','2013-05-25','15:00:00',3.06),('5819','2013-05-25','15:05:00',2.96),('5819','2013-05-25','15:10:00',1.93),('5819','2013-05-25','15:15:00',2.42),('5819','2013-05-25','15:20:00',1.56),('5819','2013-05-25','15:25:00',2.39),('5819','2013-05-25','15:30:00',3.12),('5819','2013-05-25','15:35:00',3.76),('5819','2013-05-25','15:40:00',3.62),('5819','2013-05-25','15:45:00',3.39),('5819','2013-05-25','15:50:00',3.32),('5819','2013-05-25','15:55:00',3.57),('5819','2013-05-25','16:00:00',2.82),('5819','2013-05-25','16:05:00',1.22),('5819','2013-05-25','16:10:00',2),('5819','2013-05-25','16:15:00',1.37),('5819','2013-05-25','16:20:00',1.41),('5819','2013-05-25','16:25:00',1.69),('5819','2013-05-25','16:30:00',2.58),('5819','2013-05-25','16:35:00',2.53),('5819','2013-05-25','16:40:00',2.89),('5819','2013-05-25','16:45:00',2.13),('5819','2013-05-25','16:50:00',1.41),('5819','2013-05-25','17:10:00',2.29),('5819','2013-05-25','17:15:00',1.94),('5819','2013-05-25','17:20:00',1.81),('5819','2013-05-25','17:35:00',1.3),('5819','2013-05-25','17:40:00',1.3),('5819','2013-05-24','08:05:00',2.02),('5819','2013-05-24','08:10:00',2.06),('5819','2013-05-24','08:15:00',2.12),('5819','2013-05-24','08:25:00',1.28),('5819','2013-05-24','08:30:00',2.3),('5819','2013-05-24','08:35:00',1.91),('5819','2013-05-24','08:45:00',2.65),('5819','2013-05-24','08:50:00',2.71),('5819','2013-05-24','08:55:00',2.8),('5819','2013-05-24','09:00:00',2.91),('5819','2013-05-24','09:05:00',3.08),('5819','2013-05-24','09:10:00',1.15),('5819','2013-05-24','09:20:00',1.91),('5819','2013-05-24','09:25:00',1.87),('5819','2013-05-24','09:30:00',3.21),('5819','2013-05-24','09:40:00',1.49),('5819','2013-05-24','09:45:00',1.04),('5819','2013-05-24','09:50:00',1.2),('5819','2013-05-24','09:55:00',2.42),('5819','2013-05-24','10:00:00',3.11),('5819','2013-05-24','10:25:00',1.95),('5819','2013-05-24','10:30:00',3.76),('5819','2013-05-24','10:35:00',4.03),('5819','2013-05-24','10:40:00',4.16),('5819','2013-05-24','10:45:00',3.99),('5819','2013-05-24','10:50:00',3.9),('5819','2013-05-24','10:55:00',4.41),('5819','2013-05-24','11:00:00',4.11),('5819','2013-05-24','11:05:00',4.05),('5819','2013-05-24','11:10:00',3.89),('5819','2013-05-24','11:15:00',3.64),('5819','2013-05-24','11:20:00',4.47),('5819','2013-05-24','11:25:00',4.48),('5819','2013-05-24','11:30:00',3.62),('5819','2013-05-24','11:35:00',1.43),('5819','2013-05-24','11:45:00',2.32),('5819','2013-05-24','11:50:00',4.88),('5819','2013-05-24','11:55:00',3.94),('5819','2013-05-24','12:00:00',1.82),('5819','2013-05-24','12:05:00',2.72),('5819','2013-05-24','12:10:00',3.93),('5819','2013-05-24','12:15:00',2.95),('5819','2013-05-24','12:20:00',2),('5819','2013-05-24','12:25:00',3.48),('5819','2013-05-24','12:30:00',4.45),('5819','2013-05-24','12:35:00',2.01),('5819','2013-05-24','12:40:00',2.68),('5819','2013-05-24','12:45:00',2.55),('5819','2013-05-24','12:50:00',3.07),('5819','2013-05-24','12:55:00',2.51),('5819','2013-05-24','13:00:00',2.3),('5819','2013-05-24','13:05:00',1.94),('5819','2013-05-24','13:10:00',2.38),('5819','2013-05-24','13:15:00',2.93),('5819','2013-05-24','13:20:00',3.27),('5819','2013-05-24','13:25:00',2.42),('5819','2013-05-24','13:30:00',1.7),('5819','2013-05-24','13:35:00',3.5),('5819','2013-05-24','13:40:00',2.55),('5819','2013-05-24','13:45:00',1.29),('5819','2013-05-24','13:50:00',1.09),('5819','2013-05-24','13:55:00',2.69),('5819','2013-05-24','14:00:00',2.32),('5819','2013-05-24','14:05:00',2.22),('5819','2013-05-24','14:10:00',1.23),('5819','2013-05-24','14:15:00',3.77),('5819','2013-05-24','14:20:00',3.55),('5819','2013-05-24','14:25:00',2.46),('5819','2013-05-24','14:30:00',2.68),('5819','2013-05-24','14:35:00',2.78),('5819','2013-05-24','14:40:00',2.56),('5819','2013-05-24','14:45:00',2.44),('5819','2013-05-24','14:50:00',1.54),('5819','2013-05-24','14:55:00',1.75),('5819','2013-05-24','15:00:00',2.12),('5819','2013-05-24','15:05:00',3.12),('5819','2013-05-24','15:10:00',2.75),('5819','2013-05-24','15:15:00',2.09),('5819','2013-05-24','15:20:00',4.6),('5819','2013-05-24','15:25:00',3.36),('5819','2013-05-24','15:30:00',2.87),('5819','2013-05-24','15:35:00',2.56),('5819','2013-05-24','15:40:00',2.93),('5819','2013-05-24','15:45:00',3.52),('5819','2013-05-24','15:50:00',4.26),('5819','2013-05-24','15:55:00',4.06),('5819','2013-05-24','16:00:00',2.14),('5819','2013-05-24','16:05:00',1.85),('5819','2013-05-24','16:10:00',2),('5819','2013-05-24','16:15:00',2.37),('5819','2013-05-24','16:20:00',1.87),('5819','2013-05-24','16:25:00',2.36),('5819','2013-05-24','16:30:00',2.88),('5819','2013-05-24','16:35:00',1.53),('5819','2013-05-24','16:50:00',1.24),('5819','2013-05-24','16:55:00',1.58),('5819','2013-05-24','17:00:00',1.29),('5819','2013-05-23','08:05:00',1.64),('5819','2013-05-23','08:10:00',1.93),('5819','2013-05-23','08:30:00',1.55),('5819','2013-05-23','08:35:00',2.04),('5819','2013-05-23','08:40:00',2.34),('5819','2013-05-23','08:45:00',2.27),('5819','2013-05-23','08:50:00',1.94),('5819','2013-05-23','09:00:00',2.86),('5819','2013-05-23','09:05:00',1.85),('5819','2013-05-23','09:20:00',2.34),('5819','2013-05-23','09:25:00',3.31),('5819','2013-05-23','09:30:00',3.78),('5819','2013-05-23','09:35:00',2.19),('5819','2013-05-23','09:40:00',2.48),('5819','2013-05-23','09:45:00',1.67),('5819','2013-05-23','09:50:00',3.74),('5819','2013-05-23','09:55:00',1.81),('5819','2013-05-23','10:00:00',1.07),('5819','2013-05-23','10:05:00',3.8),('5819','2013-05-23','10:10:00',2.96),('5819','2013-05-23','10:15:00',3.65),('5819','2013-05-23','10:20:00',2.93),('5819','2013-05-23','10:25:00',3.62),('5819','2013-05-23','10:30:00',3.57),('5819','2013-05-23','10:35:00',4.1),('5819','2013-05-23','10:40:00',3.63),('5819','2013-05-23','10:45:00',4.18),('5819','2013-05-23','10:50:00',4.12),('5819','2013-05-23','10:55:00',2.86),('5819','2013-05-23','11:00:00',2.71),('5819','2013-05-23','11:05:00',2.91),('5819','2013-05-23','11:10:00',2.8),('5819','2013-05-23','11:15:00',2.58),('5819','2013-05-23','11:20:00',2.19),('5819','2013-05-23','11:25:00',2.54),('5819','2013-05-23','11:30:00',2.99),('5819','2013-05-23','11:35:00',3.41),('5819','2013-05-23','11:40:00',4.4),('5819','2013-05-23','11:45:00',3.29),('5819','2013-05-23','11:50:00',2.87),('5819','2013-05-23','11:55:00',3.52),('5819','2013-05-23','12:00:00',4.22),('5819','2013-05-23','12:05:00',4.46),('5819','2013-05-23','12:10:00',4.51),('5819','2013-05-23','12:15:00',4.17),('5819','2013-05-23','12:20:00',3.09),('5819','2013-05-23','12:25:00',3.82),('5819','2013-05-23','12:30:00',3.42),('5819','2013-05-23','12:35:00',2.39),('5819','2013-05-23','12:40:00',4.01),('5819','2013-05-23','12:45:00',3.18),('5819','2013-05-23','12:50:00',3.17),('5819','2013-05-23','12:55:00',4.15),('5819','2013-05-23','13:00:00',4.56),('5819','2013-05-23','13:05:00',2.71),('5819','2013-05-23','13:10:00',4.3),('5819','2013-05-23','13:15:00',3.86),('5819','2013-05-23','13:20:00',3.19),('5819','2013-05-23','13:25:00',3.9),('5819','2013-05-23','13:30:00',3.83),('5819','2013-05-23','13:35:00',2.27),('5819','2013-05-23','13:40:00',1.7),('5819','2013-05-23','13:45:00',3.26),('5819','2013-05-23','13:50:00',2.81),('5819','2013-05-23','13:55:00',4.02),('5819','2013-05-23','14:00:00',4.18),('5819','2013-05-23','14:05:00',4.28),('5819','2013-05-23','14:10:00',3.18),('5819','2013-05-23','14:15:00',3.94),('5819','2013-05-23','14:20:00',4.14),('5819','2013-05-23','14:25:00',2.75),('5819','2013-05-23','14:30:00',1.45),('5819','2013-05-23','14:35:00',4.37),('5819','2013-05-23','14:40:00',3.24),('5819','2013-05-23','14:45:00',2.41),('5819','2013-05-23','14:50:00',1.88),('5819','2013-05-23','14:55:00',3.21),('5819','2013-05-23','15:00:00',3.89),('5819','2013-05-23','15:05:00',3.63),('5819','2013-05-23','15:10:00',1.3),('5819','2013-05-23','15:15:00',1.36),('5819','2013-05-23','15:20:00',3.65),('5819','2013-05-23','15:25:00',1.48),('5819','2013-05-23','15:30:00',2.18),('5819','2013-05-23','15:35:00',2.66),('5819','2013-05-23','15:40:00',1.97),('5819','2013-05-23','15:45:00',2.48),('5819','2013-05-23','15:50:00',1.37),('5819','2013-05-23','15:55:00',1.28),('5819','2013-05-23','16:00:00',2.73),('5819','2013-05-23','16:05:00',3.36),('5819','2013-05-23','16:10:00',2.4),('5819','2013-05-23','16:15:00',2.15),('5819','2013-05-23','16:20:00',2.93),('5819','2013-05-23','16:25:00',1.87),('5819','2013-05-23','16:30:00',2.51),('5819','2013-05-23','16:35:00',1.31),('5819','2013-05-23','16:40:00',1.27),('5819','2013-05-23','16:45:00',1.7),('5819','2013-05-23','16:50:00',1.05),('5819','2013-05-23','17:10:00',2.08),('5819','2013-05-23','17:15:00',1.8),('5819','2013-05-23','17:35:00',1.18),('5819','2013-05-23','17:55:00',1.09),('5819','2013-05-23','18:00:00',1.2),('5819','2013-05-23','18:05:00',1.32),('5819','2013-05-22','07:55:00',1.04),('5819','2013-05-22','08:00:00',1.13),('5819','2013-05-22','08:05:00',1.72),('5819','2013-05-22','08:10:00',1.15),('5819','2013-05-22','08:15:00',2.2),('5819','2013-05-22','08:20:00',2.17),('5819','2013-05-22','08:25:00',1.98),('5819','2013-05-22','08:30:00',2.17),('5819','2013-05-22','08:35:00',2.65),('5819','2013-05-22','08:40:00',1.55),('5819','2013-05-22','08:45:00',1.65),('5819','2013-05-22','08:50:00',1.09),('5819','2013-05-22','09:25:00',1.11),('5819','2013-05-22','09:30:00',2.79),('5819','2013-05-22','09:35:00',3.08),('5819','2013-05-22','09:40:00',3.04),('5819','2013-05-22','09:45:00',3.06),('5819','2013-05-22','09:50:00',3.1),('5819','2013-05-22','09:55:00',3.16),('5819','2013-05-22','10:00:00',3.21),('5819','2013-05-22','10:05:00',3.26),('5819','2013-05-22','10:10:00',3.33),('5819','2013-05-22','10:15:00',3.37),('5819','2013-05-22','10:20:00',3.34),('5819','2013-05-22','10:25:00',3.49),('5819','2013-05-22','10:30:00',3.49),('5819','2013-05-22','10:35:00',3.46),('5819','2013-05-22','10:40:00',3.66),('5819','2013-05-22','10:45:00',3.65),('5819','2013-05-22','10:50:00',3.61),('5819','2013-05-22','10:55:00',3.64),('5819','2013-05-22','11:00:00',3.71),('5819','2013-05-22','11:05:00',3.8),('5819','2013-05-22','11:10:00',3.61),('5819','2013-05-22','11:15:00',3.43),('5819','2013-05-22','11:20:00',3.9),('5819','2013-05-22','11:25:00',4.08),('5819','2013-05-22','11:30:00',3.22),('5819','2013-05-22','11:35:00',3.46),('5819','2013-05-22','11:40:00',3.43),('5819','2013-05-22','11:45:00',4.07),('5819','2013-05-22','11:50:00',2.51),('5819','2013-05-22','11:55:00',1.9),('5819','2013-05-22','12:00:00',2.86),('5819','2013-05-22','12:05:00',2.25),('5819','2013-05-22','12:10:00',2.13),('5819','2013-05-22','12:15:00',2.71),('5819','2013-05-22','12:20:00',3.85),('5819','2013-05-22','12:25:00',2.99),('5819','2013-05-22','12:30:00',2.23),('5819','2013-05-22','12:35:00',2.17),('5819','2013-05-22','12:40:00',1.63),('5819','2013-05-22','13:05:00',4.07),('5819','2013-05-22','13:10:00',2.27),('5819','2013-05-22','13:15:00',2.2),('5819','2013-05-22','13:20:00',2.23),('5819','2013-05-22','13:25:00',1.09),('5819','2013-05-22','13:30:00',1.61),('5819','2013-05-22','13:35:00',2.97),('5819','2013-05-22','13:40:00',3.29),('5819','2013-05-22','13:45:00',2.21),('5819','2013-05-22','13:50:00',2.16),('5819','2013-05-22','13:55:00',2.33),('5819','2013-05-22','14:00:00',2.35),('5819','2013-05-22','14:05:00',3.38),('5819','2013-05-22','14:10:00',3.53),('5819','2013-05-22','14:15:00',3.89),('5819','2013-05-22','14:20:00',3.76),('5819','2013-05-22','14:25:00',3.7),('5819','2013-05-22','14:30:00',3.6),('5819','2013-05-22','14:35:00',3.52),('5819','2013-05-22','14:40:00',3.57),('5819','2013-05-22','14:45:00',3.52),('5819','2013-05-22','14:50:00',3.46),('5819','2013-05-22','14:55:00',3.42),('5819','2013-05-22','15:00:00',3.37),('5819','2013-05-22','15:05:00',3.31),('5819','2013-05-22','15:10:00',3.27),('5819','2013-05-22','15:15:00',3.23),('5819','2013-05-22','15:20:00',3.02),('5819','2013-05-22','15:25:00',1.85),('5819','2013-05-22','15:30:00',1.69),('5819','2013-05-22','15:35:00',1.68),('5819','2013-05-22','15:40:00',1.42),('5819','2013-05-22','15:45:00',2.13),('5819','2013-05-22','15:50:00',2.93),('5819','2013-05-22','15:55:00',2.74),('5819','2013-05-22','16:00:00',2.73),('5819','2013-05-22','16:05:00',2.65),('5819','2013-05-22','16:10:00',2.61),('5819','2013-05-22','16:15:00',2.54),('5819','2013-05-22','16:20:00',2.47),('5819','2013-05-22','16:25:00',2.41),('5819','2013-05-22','16:30:00',2.34);
INSERT INTO `solarlogmod` VALUES ('5819','2013-05-22','16:35:00',2.25),('5819','2013-05-22','16:40:00',2.19),('5819','2013-05-22','16:45:00',1.79),('5819','2013-05-22','16:50:00',1.44),('5819','2013-05-22','17:20:00',1.26),('5819','2013-05-22','17:25:00',1.61),('5819','2013-05-22','17:30:00',1.27),('5819','2013-05-22','17:35:00',1.15),('5819','2013-05-22','18:00:00',1.07),('5819','2013-05-21','07:20:00',1.02),('5819','2013-05-21','07:25:00',1.12),('5819','2013-05-21','07:30:00',1.26),('5819','2013-05-21','07:35:00',1.49),('5819','2013-05-21','07:40:00',1.69),('5819','2013-05-21','07:45:00',1.46),('5819','2013-05-21','07:50:00',1.23),('5819','2013-05-21','07:55:00',1.02),('5819','2013-05-21','08:00:00',1.43),('5819','2013-05-21','08:10:00',1.48),('5819','2013-05-21','08:15:00',2.06),('5819','2013-05-21','08:20:00',1.45),('5819','2013-05-21','08:25:00',1.97),('5819','2013-05-21','08:30:00',1.4),('5819','2013-05-21','08:35:00',1.25),('5819','2013-05-21','08:40:00',1.45),('5819','2013-05-21','08:45:00',1.24),('5819','2013-05-21','08:50:00',1.3),('5819','2013-05-21','08:55:00',1.75),('5819','2013-05-21','09:00:00',1.56),('5819','2013-05-21','09:05:00',1.33),('5819','2013-05-21','09:10:00',1.46),('5819','2013-05-21','09:15:00',1.64),('5819','2013-05-21','09:20:00',2.17),('5819','2013-05-21','09:25:00',2.5),('5819','2013-05-21','09:30:00',1.95),('5819','2013-05-21','09:35:00',1.93),('5819','2013-05-21','09:40:00',1.99),('5819','2013-05-21','09:45:00',1.67),('5819','2013-05-21','09:50:00',1.57),('5819','2013-05-21','09:55:00',1.83),('5819','2013-05-21','10:00:00',1.96),('5819','2013-05-21','10:05:00',2.21),('5819','2013-05-21','10:10:00',2.23),('5819','2013-05-21','10:15:00',2.17),('5819','2013-05-21','10:20:00',2.15),('5819','2013-05-21','10:25:00',1.9),('5819','2013-05-21','10:30:00',1.73),('5819','2013-05-21','10:35:00',1.75),('5819','2013-05-21','10:40:00',1.98),('5819','2013-05-21','10:45:00',2.91),('5819','2013-05-21','10:50:00',2.12),('5819','2013-05-21','10:55:00',1.58),('5819','2013-05-21','11:00:00',1.79),('5819','2013-05-21','11:05:00',1.63),('5819','2013-05-21','11:10:00',2.64),('5819','2013-05-21','11:15:00',4.16),('5819','2013-05-21','11:20:00',3.06),('5819','2013-05-21','11:25:00',3.95),('5819','2013-05-21','11:30:00',2.64),('5819','2013-05-21','11:35:00',2.4),('5819','2013-05-21','11:40:00',2.5),('5819','2013-05-21','11:45:00',3.45),('5819','2013-05-21','11:50:00',2.54),('5819','2013-05-21','11:55:00',3.57),('5819','2013-05-21','12:00:00',2.89),('5819','2013-05-21','12:05:00',3.59),('5819','2013-05-21','12:10:00',2.69),('5819','2013-05-21','12:15:00',2.93),('5819','2013-05-21','12:20:00',2.22),('5819','2013-05-21','12:25:00',3),('5819','2013-05-21','12:30:00',3.88),('5819','2013-05-21','12:35:00',2.25),('5819','2013-05-21','12:40:00',3.78),('5819','2013-05-21','12:45:00',3.82),('5819','2013-05-21','12:50:00',2.39),('5819','2013-05-21','12:55:00',4.24),('5819','2013-05-21','13:00:00',3.69),('5819','2013-05-21','13:05:00',4.05),('5819','2013-05-21','13:10:00',2.41),('5819','2013-05-21','13:15:00',3.38),('5819','2013-05-21','13:20:00',2.68),('5819','2013-05-21','13:25:00',3.05),('5819','2013-05-21','13:30:00',2.8),('5819','2013-05-21','13:35:00',1.49),('5819','2013-05-21','14:10:00',1.55),('5819','2013-05-21','14:15:00',1.88),('5819','2013-05-21','14:20:00',1.69),('5819','2013-05-21','14:25:00',2.13),('5819','2013-05-21','14:30:00',2.34),('5819','2013-05-21','14:35:00',1.81),('5819','2013-05-21','14:40:00',1.72),('5819','2013-05-21','14:45:00',1.53),('5819','2013-05-21','15:20:00',1.37),('5819','2013-05-21','15:25:00',1.42),('5819','2013-05-21','15:30:00',2.03),('5819','2013-05-21','15:35:00',1.5),('5819','2013-05-21','15:40:00',1.2),('5819','2013-05-21','15:45:00',1.27),('5819','2013-05-21','15:50:00',1.18),('5819','2013-05-21','15:55:00',1.18),('5819','2013-05-21','16:00:00',1.16),('5819','2013-05-21','16:05:00',1.11),('5819','2013-05-21','16:10:00',1.24),('5819','2013-05-21','16:15:00',1.09),('5819','2013-05-21','16:25:00',1.12),('5819','2013-05-21','16:30:00',1.61),('5819','2013-05-21','16:35:00',1.73),('5819','2013-05-21','16:40:00',1.82),('5819','2013-05-21','16:45:00',1.73),('5819','2013-05-21','16:50:00',1.07),('5819','2013-05-20','07:15:00',1.02),('5819','2013-05-20','07:20:00',1.09),('5819','2013-05-20','07:25:00',1.07),('5819','2013-05-20','07:30:00',1.26),('5819','2013-05-20','07:35:00',1.36),('5819','2013-05-20','07:40:00',1.44),('5819','2013-05-20','07:45:00',1.53),('5819','2013-05-20','07:50:00',1.6),('5819','2013-05-20','07:55:00',1.67),('5819','2013-05-20','08:00:00',1.84),('5819','2013-05-20','08:05:00',1.67),('5819','2013-05-20','08:10:00',1.99),('5819','2013-05-20','08:15:00',1.64),('5819','2013-05-20','08:20:00',1.42),('5819','2013-05-20','08:50:00',2.96),('5819','2013-05-20','08:55:00',2.9),('5819','2013-05-20','09:00:00',3.14),('5819','2013-05-20','09:05:00',2.83),('5819','2013-05-20','09:10:00',3.31),('5819','2013-05-20','09:15:00',2.45),('5819','2013-05-20','09:20:00',1.84),('5819','2013-05-20','09:25:00',1.81),('5819','2013-05-20','09:35:00',1.77),('5819','2013-05-20','09:40:00',1.34),('5819','2013-05-20','09:50:00',3.44),('5819','2013-05-20','09:55:00',1.69),('5819','2013-05-20','10:05:00',1.24),('5819','2013-05-20','10:15:00',1.53),('5819','2013-05-20','10:30:00',2.5),('5819','2013-05-20','10:35:00',2.42),('5819','2013-05-20','10:45:00',1.38),('5819','2013-05-20','10:50:00',1.28),('5819','2013-05-20','10:55:00',1.8),('5819','2013-05-20','11:00:00',3.4),('5819','2013-05-20','11:05:00',4.37),('5819','2013-05-20','11:10:00',4),('5819','2013-05-20','11:15:00',4.35),('5819','2013-05-20','11:20:00',3.08),('5819','2013-05-20','11:25:00',3.46),('5819','2013-05-20','11:30:00',3.51),('5819','2013-05-20','11:35:00',3.34),('5819','2013-05-20','11:40:00',1.77),('5819','2013-05-20','11:45:00',1.59),('5819','2013-05-20','11:50:00',1.76),('5819','2013-05-20','11:55:00',3.39),('5819','2013-05-20','12:00:00',2.69),('5819','2013-05-20','12:05:00',4.7),('5819','2013-05-20','12:10:00',3.36),('5819','2013-05-20','12:15:00',1.83),('5819','2013-05-20','12:20:00',2.47),('5819','2013-05-20','12:25:00',1.78),('5819','2013-05-20','12:30:00',1.74),('5819','2013-05-20','12:35:00',3.17),('5819','2013-05-20','12:40:00',2.99),('5819','2013-05-20','12:45:00',4.65),('5819','2013-05-20','12:50:00',2.4),('5819','2013-05-20','12:55:00',2.07),('5819','2013-05-20','13:00:00',1.99),('5819','2013-05-20','13:05:00',3.13),('5819','2013-05-20','13:10:00',2.05),('5819','2013-05-20','13:15:00',2.31),('5819','2013-05-20','13:20:00',4.59),('5819','2013-05-20','13:25:00',3.57),('5819','2013-05-20','13:30:00',3.4),('5819','2013-05-20','13:35:00',2.37),('5819','2013-05-20','13:40:00',2.99),('5819','2013-05-20','13:45:00',2.44),('5819','2013-05-20','13:50:00',4.48),('5819','2013-05-20','13:55:00',3.15),('5819','2013-05-20','14:00:00',4.43),('5819','2013-05-20','14:05:00',2.72),('5819','2013-05-20','14:15:00',4.08),('5819','2013-05-20','14:20:00',3.14),('5819','2013-05-20','14:25:00',2.37),('5819','2013-05-20','14:30:00',4.21),('5819','2013-05-20','14:35:00',3.06),('5819','2013-05-20','14:40:00',1.28),('5819','2013-05-20','14:45:00',2.47),('5819','2013-05-20','14:50:00',4.28),('5819','2013-05-20','14:55:00',3.93),('5819','2013-05-20','15:00:00',3.32),('5819','2013-05-20','15:10:00',3.23),('5819','2013-05-20','15:15:00',3.56),('5819','2013-05-20','15:20:00',2.34),('5819','2013-05-20','15:25:00',3.82),('5819','2013-05-20','15:30:00',2.68),('5819','2013-05-20','15:35:00',3.58),('5819','2013-05-20','15:40:00',2.46),('5819','2013-05-20','15:45:00',1.93),('5819','2013-05-20','15:50:00',2.49),('5819','2013-05-20','15:55:00',1.23),('5819','2013-05-20','16:00:00',1.92),('5819','2013-05-20','16:05:00',2.88),('5819','2013-05-20','16:10:00',2.91),('5819','2013-05-20','16:15:00',3.11),('5819','2013-05-20','16:20:00',2.9),('5819','2013-05-20','16:25:00',2.78),('5819','2013-05-20','16:30:00',2.69),('5819','2013-05-20','16:35:00',2.54),('5819','2013-05-20','16:40:00',2.49),('5819','2013-05-20','16:45:00',2.25),('5819','2013-05-20','16:50:00',2.17),('5819','2013-05-20','16:55:00',2.13),('5819','2013-05-20','17:00:00',2),('5819','2013-05-20','17:05:00',2.06),('5819','2013-05-20','17:10:00',1.54),('5819','2013-05-20','17:15:00',1.02),('5819','2013-05-20','17:20:00',1.51),('5819','2013-05-20','17:25:00',1.97),('5819','2013-05-20','17:30:00',1.97),('5819','2013-05-20','17:35:00',1.52),('5819','2013-05-20','17:40:00',1.22),('5819','2013-05-20','17:45:00',1.2),('5819','2013-05-20','17:50:00',1.15),('5819','2013-05-20','17:55:00',1.06),('5819','2013-05-20','18:00:00',1.01),('5819','2013-05-20','18:05:00',1.06),('5819','2013-05-19','08:35:00',1.17),('5819','2013-05-19','08:50:00',1.13),('5819','2013-05-19','08:55:00',1.66),('5819','2013-05-19','09:00:00',1.74),('5819','2013-05-19','09:05:00',1.1),('5819','2013-05-19','09:10:00',1.18),('5819','2013-05-19','09:15:00',1.29),('5819','2013-05-19','09:20:00',1.1),('5819','2013-05-19','09:45:00',1.08),('5819','2013-05-19','10:00:00',1.37),('5819','2013-05-19','10:05:00',1.53),('5819','2013-05-19','10:10:00',1.82),('5819','2013-05-19','10:15:00',2.87),('5819','2013-05-19','10:20:00',3.04),('5819','2013-05-19','10:25:00',2.21),('5819','2013-05-19','10:30:00',2.57),('5819','2013-05-19','10:35:00',2.3),('5819','2013-05-19','10:40:00',1.89),('5819','2013-05-19','10:45:00',2.82),('5819','2013-05-19','10:50:00',1.78),('5819','2013-05-19','10:55:00',2),('5819','2013-05-19','11:00:00',1.9),('5819','2013-05-19','11:05:00',3.04),('5819','2013-05-19','11:10:00',2.62),('5819','2013-05-19','11:15:00',3.51),('5819','2013-05-19','11:20:00',4.35),('5819','2013-05-19','11:25:00',4.22),('5819','2013-05-19','11:30:00',4.3),('5819','2013-05-19','11:35:00',4.27),('5819','2013-05-19','11:40:00',4.39),('5819','2013-05-19','11:45:00',4.39),('5819','2013-05-19','11:50:00',4.35),('5819','2013-05-19','11:55:00',4.38),('5819','2013-05-19','12:00:00',4.41),('5819','2013-05-19','12:05:00',4.35),('5819','2013-05-19','12:10:00',4.36),('5819','2013-05-19','12:15:00',4.38),('5819','2013-05-19','12:20:00',4.53),('5819','2013-05-19','12:25:00',4.88),('5819','2013-05-19','12:30:00',3.91),('5819','2013-05-19','12:35:00',4.79),('5819','2013-05-19','12:40:00',4.69),('5819','2013-05-19','12:45:00',4.66),('5819','2013-05-19','12:50:00',3.55),('5819','2013-05-19','12:55:00',2.71),('5819','2013-05-19','13:00:00',4.18),('5819','2013-05-19','13:05:00',4.47),('5819','2013-05-19','13:10:00',3.78),('5819','2013-05-19','13:15:00',3.63),('5819','2013-05-19','13:20:00',4.2),('5819','2013-05-19','13:25:00',3.7),('5819','2013-05-19','13:30:00',4.16),('5819','2013-05-19','13:35:00',4.15),('5819','2013-05-19','13:40:00',4.08),('5819','2013-05-19','13:45:00',4.05),('5819','2013-05-19','13:50:00',4.05),('5819','2013-05-19','13:55:00',4.04),('5819','2013-05-19','14:00:00',4.03),('5819','2013-05-19','14:05:00',4.02),('5819','2013-05-19','14:10:00',3.99),('5819','2013-05-19','14:15:00',3.94),('5819','2013-05-19','14:20:00',3.92),('5819','2013-05-19','14:25:00',3.88),('5819','2013-05-19','14:30:00',3.86),('5819','2013-05-19','14:35:00',3.81),('5819','2013-05-19','14:40:00',3.79),('5819','2013-05-19','14:45:00',3.75),('5819','2013-05-19','14:50:00',3.7),('5819','2013-05-19','14:55:00',3.65),('5819','2013-05-19','15:00:00',3.63),('5819','2013-05-19','15:05:00',3.59),('5819','2013-05-19','15:10:00',3.54),('5819','2013-05-19','15:15:00',3.5),('5819','2013-05-19','15:20:00',3.43),('5819','2013-05-19','15:25:00',3.38),('5819','2013-05-19','15:30:00',3.31),('5819','2013-05-19','15:35:00',3.27),('5819','2013-05-19','15:40:00',3.2),('5819','2013-05-19','15:45:00',3.14),('5819','2013-05-19','15:50:00',3.06),('5819','2013-05-19','15:55:00',3.04),('5819','2013-05-19','16:00:00',2.96),('5819','2013-05-19','16:05:00',2.87),('5819','2013-05-19','16:10:00',2.82),('5819','2013-05-19','16:15:00',2.74),('5819','2013-05-19','16:20:00',2.68),('5819','2013-05-19','16:25:00',2.62),('5819','2013-05-19','16:30:00',2.54),('5819','2013-05-19','16:35:00',2.47),('5819','2013-05-19','16:40:00',2.41),('5819','2013-05-19','16:45:00',2.33),('5819','2013-05-19','16:50:00',2.25),('5819','2013-05-19','16:55:00',2.17),('5819','2013-05-19','17:00:00',2.08),('5819','2013-05-19','17:05:00',2.01),('5819','2013-05-19','17:10:00',1.93),('5819','2013-05-19','17:15:00',1.84),('5819','2013-05-19','17:20:00',1.75),('5819','2013-05-19','17:25:00',1.66),('5819','2013-05-19','17:30:00',1.56),('5819','2013-05-19','17:35:00',1.41),('5819','2013-05-19','17:40:00',1.27),('5819','2013-05-19','17:45:00',1.25),('5819','2013-05-19','17:50:00',1.17),('5819','2013-05-19','17:55:00',1.09),('5819','2013-05-19','18:00:00',1.01),('5819','2013-05-18','07:20:00',1.05),('5819','2013-05-18','07:25:00',1.14),('5819','2013-05-18','07:30:00',1.23),('5819','2013-05-18','07:35:00',1.32),('5819','2013-05-18','07:40:00',1.44),('5819','2013-05-18','07:45:00',1.46),('5819','2013-05-18','07:50:00',1.14),('5819','2013-05-18','07:55:00',1.95),('5819','2013-05-18','08:00:00',2.07),('5819','2013-05-18','08:05:00',2.11),('5819','2013-05-18','08:10:00',1.01),('5819','2013-05-18','08:20:00',1.19),('5819','2013-05-18','08:25:00',2.69),('5819','2013-05-18','08:30:00',2.47),('5819','2013-05-18','08:35:00',2.22),('5819','2013-05-18','08:40:00',2.46),('5819','2013-05-18','08:45:00',2.46),('5819','2013-05-18','08:50:00',2.5),('5819','2013-05-18','08:55:00',2.59),('5819','2013-05-18','09:00:00',2.66),('5819','2013-05-18','09:05:00',2.69),('5819','2013-05-18','09:10:00',2.83),('5819','2013-05-18','09:15:00',2.89),('5819','2013-05-18','09:20:00',2.93),('5819','2013-05-18','09:25:00',2.99),('5819','2013-05-18','09:30:00',3.05),('5819','2013-05-18','09:35:00',3.1),('5819','2013-05-18','09:40:00',3.14),('5819','2013-05-18','09:45:00',3.19),('5819','2013-05-18','09:50:00',3.24),('5819','2013-05-18','09:55:00',3.3),('5819','2013-05-18','10:00:00',3.35),('5819','2013-05-18','10:05:00',3.37),('5819','2013-05-18','10:10:00',3.43),('5819','2013-05-18','10:15:00',3.44),('5819','2013-05-18','10:20:00',3.5),('5819','2013-05-18','10:25:00',3.52),('5819','2013-05-18','10:30:00',3.55),('5819','2013-05-18','10:35:00',3.52),('5819','2013-05-18','10:40:00',3.6),('5819','2013-05-18','10:45:00',3.63),('5819','2013-05-18','10:50:00',3.66),('5819','2013-05-18','10:55:00',3.55),('5819','2013-05-18','11:00:00',3.88),('5819','2013-05-18','11:05:00',3.59),('5819','2013-05-18','11:10:00',3.09),('5819','2013-05-18','11:15:00',4.13),('5819','2013-05-18','11:20:00',3.99),('5819','2013-05-18','11:25:00',4.06),('5819','2013-05-18','11:30:00',4.03),('5819','2013-05-18','11:35:00',3.83),('5819','2013-05-18','11:40:00',3.94),('5819','2013-05-18','11:45:00',3.74),('5819','2013-05-18','11:50:00',3.72),('5819','2013-05-18','11:55:00',3.89),('5819','2013-05-18','12:00:00',3.91),('5819','2013-05-18','12:05:00',3.8),('5819','2013-05-18','12:10:00',3.89),('5819','2013-05-18','12:15:00',3.86),('5819','2013-05-18','12:20:00',3.87),('5819','2013-05-18','12:25:00',3.92),('5819','2013-05-18','12:30:00',3.08),('5819','2013-05-18','12:35:00',4),('5819','2013-05-18','12:40:00',3.93),('5819','2013-05-18','12:45:00',3.82),('5819','2013-05-18','12:50:00',3.89),('5819','2013-05-18','12:55:00',3.86),('5819','2013-05-18','13:00:00',3.84),('5819','2013-05-18','13:05:00',3.83),('5819','2013-05-18','13:10:00',3.82),('5819','2013-05-18','13:15:00',3.83),('5819','2013-05-18','13:20:00',3.8),('5819','2013-05-18','13:25:00',3.79),('5819','2013-05-18','13:30:00',3.81),('5819','2013-05-18','13:35:00',3.38),('5819','2013-05-18','13:40:00',3.71),('5819','2013-05-18','13:45:00',3.93),('5819','2013-05-18','13:50:00',3.49),('5819','2013-05-18','13:55:00',3.13),('5819','2013-05-18','14:00:00',2.66),('5819','2013-05-18','14:05:00',2.8),('5819','2013-05-18','14:10:00',4.05),('5819','2013-05-18','14:15:00',3.82),('5819','2013-05-18','14:20:00',3.76),('5819','2013-05-18','14:25:00',3.66),('5819','2013-05-18','14:30:00',3.65),('5819','2013-05-18','14:35:00',3.49),('5819','2013-05-18','14:40:00',3.77),('5819','2013-05-18','14:45:00',3.54),('5819','2013-05-18','14:50:00',3.32),('5819','2013-05-18','14:55:00',2.85),('5819','2013-05-18','15:00:00',3.24),('5819','2013-05-18','15:05:00',3.17),('5819','2013-05-18','15:10:00',3.1),('5819','2013-05-18','15:15:00',3.04),('5819','2013-05-18','15:20:00',2.99),('5819','2013-05-18','15:25:00',2.94),('5819','2013-05-18','15:30:00',2.88),('5819','2013-05-18','15:35:00',2.82),('5819','2013-05-18','15:40:00',2.77),('5819','2013-05-18','15:45:00',2.71),('5819','2013-05-18','15:50:00',2.65),('5819','2013-05-18','15:55:00',2.6),('5819','2013-05-18','16:00:00',2.54),('5819','2013-05-18','16:05:00',2.48),('5819','2013-05-18','16:10:00',2.41),('5819','2013-05-18','16:15:00',2.35),('5819','2013-05-18','16:20:00',2.29),('5819','2013-05-18','16:25:00',2.22),('5819','2013-05-18','16:30:00',2.16),('5819','2013-05-18','16:35:00',2.08),('5819','2013-05-18','16:40:00',2.02),('5819','2013-05-18','16:45:00',1.97),('5819','2013-05-18','16:50:00',1.89),('5819','2013-05-18','16:55:00',1.82),('5819','2013-05-18','17:00:00',1.76),('5819','2013-05-18','17:05:00',1.69),('5819','2013-05-18','17:10:00',1.63),('5819','2013-05-18','17:15:00',1.57),('5819','2013-05-18','17:20:00',1.5),('5819','2013-05-18','17:25:00',1.43),('5819','2013-05-18','17:30:00',1.35),('5819','2013-05-18','17:35:00',1.25),('5819','2013-05-18','17:40:00',1.12),('5819','2013-05-18','17:45:00',1.06),('5819','2013-05-18','17:50:00',1.04),('5819','2013-05-17','07:40:00',1.17),('5819','2013-05-17','07:45:00',1.41),('5819','2013-05-17','07:50:00',1.15),('5819','2013-05-17','08:00:00',1.62),('5819','2013-05-17','08:15:00',1.51),('5819','2013-05-17','08:20:00',2.31),('5819','2013-05-17','08:25:00',1.49),('5819','2013-05-17','08:30:00',1.17),('5819','2013-05-17','09:25:00',1.22),('5819','2013-05-17','10:25:00',1.13),('5819','2013-05-17','10:30:00',1.5),('5819','2013-05-17','10:35:00',1.24),('5819','2013-05-17','10:40:00',1.37),('5819','2013-05-17','10:45:00',1.49),('5819','2013-05-17','10:50:00',2.72),('5819','2013-05-17','10:55:00',3.5),('5819','2013-05-17','11:00:00',2.28),('5819','2013-05-17','11:05:00',2.14),('5819','2013-05-17','11:10:00',1.41),('5819','2013-05-17','11:15:00',2.42),('5819','2013-05-17','11:20:00',2.02),('5819','2013-05-17','11:25:00',1.7),('5819','2013-05-17','11:30:00',1.77),('5819','2013-05-17','11:35:00',2.53),('5819','2013-05-17','11:40:00',1.61),('5819','2013-05-17','11:45:00',1.48),('5819','2013-05-17','11:50:00',2.49),('5819','2013-05-17','11:55:00',2.26),('5819','2013-05-17','12:00:00',2.21),('5819','2013-05-17','12:05:00',2.49),('5819','2013-05-17','12:10:00',3.22),('5819','2013-05-17','12:15:00',2.27),('5819','2013-05-17','12:20:00',2.47),('5819','2013-05-17','12:25:00',2.64),('5819','2013-05-17','12:30:00',2.56),('5819','2013-05-17','12:35:00',3.03),('5819','2013-05-17','12:40:00',3.9),('5819','2013-05-17','12:45:00',4.19),('5819','2013-05-17','12:50:00',4.44),('5819','2013-05-17','12:55:00',4.34),('5819','2013-05-17','13:00:00',3.53),('5819','2013-05-17','13:05:00',4.43),('5819','2013-05-17','13:10:00',3.02),('5819','2013-05-17','13:15:00',3.66),('5819','2013-05-17','13:20:00',4.55),('5819','2013-05-17','13:25:00',4.15),('5819','2013-05-17','13:30:00',3.26),('5819','2013-05-17','13:35:00',4.34),('5819','2013-05-17','13:40:00',3.29),('5819','2013-05-17','13:45:00',3.96),('5819','2013-05-17','13:50:00',3.75),('5819','2013-05-17','13:55:00',4.2),('5819','2013-05-17','14:00:00',3.33),('5819','2013-05-17','14:05:00',2.07),('5819','2013-05-17','14:10:00',3.96),('5819','2013-05-17','14:15:00',3.84),('5819','2013-05-17','14:20:00',4.11),('5819','2013-05-17','14:25:00',3.43),('5819','2013-05-17','14:30:00',3.73),('5819','2013-05-17','14:35:00',3.39),('5819','2013-05-17','14:40:00',2.61),('5819','2013-05-17','14:45:00',2.68),('5819','2013-05-17','14:50:00',2.75),('5819','2013-05-17','14:55:00',2.08),('5819','2013-05-17','15:00:00',3.47),('5819','2013-05-17','15:05:00',2.61),('5819','2013-05-17','15:10:00',1.68),('5819','2013-05-17','15:15:00',2.2),('5819','2013-05-17','15:20:00',2.63),('5819','2013-05-17','15:25:00',2.97),('5819','2013-05-17','15:30:00',1.6),('5819','2013-05-17','15:35:00',2.47),('5819','2013-05-17','15:40:00',3.51),('5819','2013-05-17','15:45:00',1.46),('5819','2013-05-17','15:50:00',2.5),('5819','2013-05-17','15:55:00',2.76),('5819','2013-05-17','16:00:00',3.12),('5819','2013-05-17','16:05:00',1.8),('5819','2013-05-17','16:10:00',1.33),('5819','2013-05-17','16:15:00',2.5),('5819','2013-05-17','16:20:00',2.79),('5819','2013-05-17','16:25:00',2.62),('5819','2013-05-17','16:30:00',2.82),('5819','2013-05-17','16:35:00',2.82),('5819','2013-05-17','16:40:00',2.66),('5819','2013-05-17','16:45:00',2.58),('5819','2013-05-17','16:50:00',2.28),('5819','2013-05-17','16:55:00',2.11),('5819','2013-05-17','17:00:00',2.03),('5819','2013-05-17','17:05:00',1.94),('5819','2013-05-17','17:10:00',1.84),('5819','2013-05-17','17:15:00',1.77),('5819','2013-05-17','17:20:00',1.7),('5819','2013-05-17','17:25:00',1.61),('5819','2013-05-17','17:30:00',1.53),('5819','2013-05-17','17:35:00',1.34),('5819','2013-05-17','17:40:00',1.24),('5819','2013-05-17','17:45:00',1.15),('5819','2013-05-17','17:50:00',1.14),('5819','2013-05-17','17:55:00',1.06),('5819','2013-05-16','09:20:00',1.05),('5819','2013-05-16','09:25:00',1.58),('5819','2013-05-16','09:30:00',1.58),('5819','2013-05-16','09:35:00',1.8),('5819','2013-05-16','09:40:00',2.19),('5819','2013-05-16','09:45:00',2.63),('5819','2013-05-16','09:50:00',1.24),('5819','2013-05-16','09:55:00',1.13),('5819','2013-05-16','10:00:00',1.56),('5819','2013-05-16','10:05:00',1.25),('5819','2013-05-16','10:10:00',1.1),('5819','2013-05-16','10:15:00',1.45),('5819','2013-05-16','10:20:00',1.94),('5819','2013-05-16','10:25:00',2.18),('5819','2013-05-16','10:30:00',1.77),('5819','2013-05-16','10:35:00',1.29),('5819','2013-05-16','10:40:00',1.34),('5819','2013-05-16','10:45:00',1.25),('5819','2013-05-16','10:50:00',1.51),('5819','2013-05-16','10:55:00',1.66),('5819','2013-05-16','11:00:00',3.91),('5819','2013-05-16','11:05:00',3.61),('5819','2013-05-16','11:10:00',2.83),('5819','2013-05-16','11:15:00',1.98),('5819','2013-05-16','11:20:00',1.12),('5819','2013-05-16','11:25:00',1.27),('5819','2013-05-16','11:30:00',1.48),('5819','2013-05-16','11:35:00',3.03),('5819','2013-05-16','11:40:00',3.94),('5819','2013-05-16','11:45:00',3.84),('5819','2013-05-16','11:50:00',3.65),('5819','2013-05-16','11:55:00',2.51),('5819','2013-05-16','12:00:00',1.67),('5819','2013-05-16','12:05:00',1.51),('5819','2013-05-16','12:10:00',1.59),('5819','2013-05-16','12:15:00',2.61),('5819','2013-05-16','12:20:00',1.89),('5819','2013-05-16','12:25:00',2.11),('5819','2013-05-16','12:30:00',2.82),('5819','2013-05-16','12:35:00',3.24),('5819','2013-05-16','12:40:00',3.64),('5819','2013-05-16','12:45:00',3.35),('5819','2013-05-16','12:50:00',2.62),('5819','2013-05-16','12:55:00',4.04),('5819','2013-05-16','13:00:00',3.86),('5819','2013-05-16','13:05:00',3.51),('5819','2013-05-16','13:10:00',3.77),('5819','2013-05-16','13:15:00',3.21),('5819','2013-05-16','13:20:00',3.02),('5819','2013-05-16','13:25:00',3.82),('5819','2013-05-16','13:30:00',3.72),('5819','2013-05-16','13:35:00',3.69),('5819','2013-05-16','13:40:00',3.62),('5819','2013-05-16','13:45:00',3.6),('5819','2013-05-16','13:50:00',3.59),('5819','2013-05-16','13:55:00',3.6),('5819','2013-05-16','14:00:00',3.56),('5819','2013-05-16','14:05:00',3.54),('5819','2013-05-16','14:10:00',3.51),('5819','2013-05-16','14:15:00',3.45),('5819','2013-05-16','14:20:00',3.45),('5819','2013-05-16','14:25:00',3.32),('5819','2013-05-16','14:30:00',3.33),('5819','2013-05-16','14:35:00',3.26),('5819','2013-05-16','14:40:00',3.25),('5819','2013-05-16','14:45:00',3.22),('5819','2013-05-16','14:50:00',3.09),('5819','2013-05-16','14:55:00',2.56),('5819','2013-05-16','15:00:00',3.08),('5819','2013-05-16','15:05:00',3.09),('5819','2013-05-16','15:10:00',3.06),('5819','2013-05-16','15:15:00',2.84),('5819','2013-05-16','15:20:00',2.81),('5819','2013-05-16','15:25:00',2.9),('5819','2013-05-16','15:30:00',2.81),('5819','2013-05-16','15:35:00',2.72),('5819','2013-05-16','15:40:00',2.77),('5819','2013-05-16','15:45:00',2.68),('5819','2013-05-16','15:50:00',2.67),('5819','2013-05-16','15:55:00',2.63),('5819','2013-05-16','16:00:00',2.58),('5819','2013-05-16','16:05:00',2.46),('5819','2013-05-16','16:10:00',2.42),('5819','2013-05-16','16:15:00',2.29),('5819','2013-05-16','16:20:00',2.37),('5819','2013-05-16','16:25:00',2.29),('5819','2013-05-16','16:30:00',2.29),('5819','2013-05-16','16:35:00',2.22),('5819','2013-05-16','16:40:00',1.37),('5819','2013-05-16','16:45:00',1.24),('5819','2013-05-16','16:50:00',1.62),('5819','2013-05-16','16:55:00',1.35),('5819','2013-05-16','17:00:00',1.33),('5819','2013-05-16','17:15:00',1.01),('5819','2013-05-16','17:20:00',1.18),('5819','2013-05-16','17:25:00',1.09),('5819','2013-05-16','17:30:00',1.28),('5819','2013-05-16','17:35:00',1.41),('5819','2013-05-16','17:40:00',1.17),('5819','2013-05-15','07:20:00',1.06),('5819','2013-05-15','07:25:00',1.15),('5819','2013-05-15','07:30:00',1.26),('5819','2013-05-15','07:35:00',1.34),('5819','2013-05-15','07:40:00',1.46),('5819','2013-05-15','07:45:00',1.62),('5819','2013-05-15','07:50:00',1.63),('5819','2013-05-15','07:55:00',1.55),('5819','2013-05-15','08:00:00',1.62),('5819','2013-05-15','08:05:00',1.58),('5819','2013-05-15','08:10:00',1.86),('5819','2013-05-15','08:15:00',1.97),('5819','2013-05-15','08:20:00',2.02),('5819','2013-05-15','08:25:00',2.09),('5819','2013-05-15','08:30:00',2.08),('5819','2013-05-15','08:35:00',2.25),('5819','2013-05-15','08:40:00',2.35),('5819','2013-05-15','08:45:00',2.42),('5819','2013-05-15','08:50:00',2.5),('5819','2013-05-15','08:55:00',2.58),('5819','2013-05-15','09:00:00',2.48),('5819','2013-05-15','09:05:00',2.65),('5819','2013-05-15','09:10:00',2.64),('5819','2013-05-15','09:15:00',2.7),('5819','2013-05-15','09:20:00',2.71),('5819','2013-05-15','09:25:00',2.79),('5819','2013-05-15','09:30:00',2.94),('5819','2013-05-15','09:35:00',3),('5819','2013-05-15','09:40:00',2.97),('5819','2013-05-15','09:45:00',3.07),('5819','2013-05-15','09:50:00',3.16),('5819','2013-05-15','09:55:00',3.17),('5819','2013-05-15','10:00:00',3.27),('5819','2013-05-15','10:05:00',3.35),('5819','2013-05-15','10:10:00',3.33),('5819','2013-05-15','10:15:00',3.32),('5819','2013-05-15','10:20:00',3.39),('5819','2013-05-15','10:25:00',3.49),('5819','2013-05-15','10:30:00',3.42),('5819','2013-05-15','10:35:00',3.46),('5819','2013-05-15','10:40:00',3.53),('5819','2013-05-15','10:45:00',3.61),('5819','2013-05-15','10:50:00',3.61),('5819','2013-05-15','10:55:00',3.52),('5819','2013-05-15','11:00:00',3.5),('5819','2013-05-15','11:05:00',3.52),('5819','2013-05-15','11:10:00',3.66),('5819','2013-05-15','11:15:00',3.71),('5819','2013-05-15','11:20:00',3.56),('5819','2013-05-15','11:25:00',3.69),('5819','2013-05-15','11:30:00',3.68),('5819','2013-05-15','11:35:00',3.63),('5819','2013-05-15','11:40:00',3.22),('5819','2013-05-15','11:45:00',2.88),('5819','2013-05-15','11:50:00',2.52),('5819','2013-05-15','11:55:00',1.87),('5819','2013-05-15','12:00:00',2.05),('5819','2013-05-15','12:05:00',3.1),('5819','2013-05-15','12:10:00',4.11),('5819','2013-05-15','12:15:00',4.47),('5819','2013-05-15','12:20:00',2.62),('5819','2013-05-15','12:25:00',3.42),('5819','2013-05-15','12:30:00',2.53),('5819','2013-05-15','12:35:00',2.71),('5819','2013-05-15','12:40:00',4.42),('5819','2013-05-15','12:45:00',2.36),('5819','2013-05-15','12:50:00',2.3),('5819','2013-05-15','12:55:00',2.52),('5819','2013-05-15','13:00:00',2.63),('5819','2013-05-15','13:05:00',3.02),('5819','2013-05-15','13:10:00',2.75),('5819','2013-05-15','13:15:00',2.16),('5819','2013-05-15','13:20:00',2.55),('5819','2013-05-15','13:25:00',2.44),('5819','2013-05-15','13:30:00',2.51),('5819','2013-05-15','13:35:00',2.25),('5819','2013-05-15','13:40:00',2.27),('5819','2013-05-15','13:45:00',2.43),('5819','2013-05-15','13:50:00',1.98),('5819','2013-05-15','13:55:00',1.94),('5819','2013-05-15','14:00:00',1.73),('5819','2013-05-15','14:05:00',1.51),('5819','2013-05-15','14:10:00',1.52),('5819','2013-05-15','14:15:00',1.53),('5819','2013-05-15','14:20:00',1.55),('5819','2013-05-15','14:25:00',1.54),('5819','2013-05-15','14:30:00',1.37),('5819','2013-05-15','14:35:00',1.32),('5819','2013-05-15','14:40:00',1.45),('5819','2013-05-15','14:45:00',1.36),('5819','2013-05-15','14:50:00',1.37),('5819','2013-05-15','14:55:00',1.36),('5819','2013-05-15','15:00:00',1.36),('5819','2013-05-15','15:05:00',1.09),('5819','2013-05-15','15:50:00',1.26),('5819','2013-05-15','15:55:00',1.68),('5819','2013-05-15','16:00:00',1.73),('5819','2013-05-15','16:05:00',1.61),('5819','2013-05-15','16:10:00',1.5),('5819','2013-05-15','16:15:00',1.34),('5819','2013-05-15','16:20:00',1.44),('5819','2013-05-15','16:25:00',1.5),('5819','2013-05-15','16:30:00',1.36),('5819','2013-05-15','16:35:00',1.24),('5819','2013-05-15','16:40:00',1.14),('5819','2013-05-15','16:45:00',1.09),('5819','2013-05-15','16:50:00',1.08),('5819','2013-05-15','16:55:00',1.21),('5819','2013-05-15','17:00:00',1.43),('5819','2013-05-15','17:05:00',1.73),('5819','2013-05-15','17:10:00',1.66),('5819','2013-05-15','17:15:00',2.3),('5819','2013-05-15','17:20:00',1.44),('5819','2013-05-14','07:15:00',1.02),('5819','2013-05-14','07:20:00',1.13),('5819','2013-05-14','07:25:00',1.21),('5819','2013-05-14','07:30:00',1.3),('5819','2013-05-14','07:35:00',1.39),('5819','2013-05-14','07:40:00',1.48),('5819','2013-05-14','07:45:00',1.58),('5819','2013-05-14','07:50:00',1.67),('5819','2013-05-14','07:55:00',1.76),('5819','2013-05-14','08:00:00',1.85),('5819','2013-05-14','08:05:00',1.93),('5819','2013-05-14','08:10:00',2.02),('5819','2013-05-14','08:15:00',2.1),('5819','2013-05-14','08:20:00',2.19),('5819','2013-05-14','08:25:00',2.27),('5819','2013-05-14','08:30:00',2.35),('5819','2013-05-14','08:35:00',2.42),('5819','2013-05-14','08:40:00',2.49),('5819','2013-05-14','08:45:00',2.56),('5819','2013-05-14','08:50:00',2.63),('5819','2013-05-14','08:55:00',2.7),('5819','2013-05-14','09:00:00',2.77),('5819','2013-05-14','09:05:00',2.83),('5819','2013-05-14','09:10:00',2.9),('5819','2013-05-14','09:15:00',2.96),('5819','2013-05-14','09:20:00',3.01),('5819','2013-05-14','09:25:00',3.06),('5819','2013-05-14','09:30:00',3.11),('5819','2013-05-14','09:35:00',3.17),('5819','2013-05-14','09:40:00',3.2),('5819','2013-05-14','09:45:00',3.27),('5819','2013-05-14','09:50:00',3.33),('5819','2013-05-14','09:55:00',3.36),('5819','2013-05-14','10:00:00',3.43),('5819','2013-05-14','10:05:00',3.46),('5819','2013-05-14','10:10:00',3.5),('5819','2013-05-14','10:15:00',3.55),('5819','2013-05-14','10:20:00',3.56),('5819','2013-05-14','10:25:00',3.58),('5819','2013-05-14','10:30:00',3.62),('5819','2013-05-14','10:35:00',3.66),('5819','2013-05-14','10:40:00',3.7),('5819','2013-05-14','10:45:00',3.71),('5819','2013-05-14','10:50:00',3.76),('5819','2013-05-14','10:55:00',3.77),('5819','2013-05-14','11:00:00',3.78),('5819','2013-05-14','11:05:00',3.82),('5819','2013-05-14','11:10:00',3.84),('5819','2013-05-14','11:15:00',3.84),('5819','2013-05-14','11:20:00',3.85),('5819','2013-05-14','11:25:00',3.87),('5819','2013-05-14','11:30:00',3.89),('5819','2013-05-14','11:35:00',3.89),('5819','2013-05-14','11:40:00',3.92),('5819','2013-05-14','11:45:00',3.92),('5819','2013-05-14','11:50:00',3.94),('5819','2013-05-14','11:55:00',3.93),('5819','2013-05-14','12:00:00',3.93),('5819','2013-05-14','12:05:00',3.95),('5819','2013-05-14','12:10:00',3.96),('5819','2013-05-14','12:15:00',3.97),('5819','2013-05-14','12:20:00',3.99),('5819','2013-05-14','12:25:00',4.01),('5819','2013-05-14','12:30:00',4),('5819','2013-05-14','12:35:00',3.98),('5819','2013-05-14','12:40:00',3.99),('5819','2013-05-14','12:45:00',3.98),('5819','2013-05-14','12:50:00',3.98),('5819','2013-05-14','12:55:00',4),('5819','2013-05-14','13:00:00',3.97),('5819','2013-05-14','13:05:00',3.96),('5819','2013-05-14','13:10:00',3.98),('5819','2013-05-14','13:15:00',3.96),('5819','2013-05-14','13:20:00',3.92),('5819','2013-05-14','13:25:00',3.88),('5819','2013-05-14','13:30:00',3.89),('5819','2013-05-14','13:35:00',3.9),('5819','2013-05-14','13:40:00',3.87),('5819','2013-05-14','13:45:00',3.82),('5819','2013-05-14','13:50:00',3.8),('5819','2013-05-14','13:55:00',3.75),('5819','2013-05-14','14:00:00',3.72),('5819','2013-05-14','14:05:00',3.72),('5819','2013-05-14','14:10:00',3.7),('5819','2013-05-14','14:15:00',3.68),('5819','2013-05-14','14:20:00',3.63),('5819','2013-05-14','14:25:00',3.58),('5819','2013-05-14','14:30:00',3.55),('5819','2013-05-14','14:35:00',3.5),('5819','2013-05-14','14:40:00',3.46),('5819','2013-05-14','14:45:00',3.45),('5819','2013-05-14','14:50:00',3.49),('5819','2013-05-14','14:55:00',3.49),('5819','2013-05-14','15:00:00',3.45),('5819','2013-05-14','15:05:00',3.42),('5819','2013-05-14','15:10:00',3.38),('5819','2013-05-14','15:15:00',3.34),('5819','2013-05-14','15:20:00',3.28),('5819','2013-05-14','15:25:00',3.25),('5819','2013-05-14','15:30:00',3.19),('5819','2013-05-14','15:35:00',3.13),('5819','2013-05-14','15:40:00',3.07),('5819','2013-05-14','15:45:00',3),('5819','2013-05-14','15:50:00',2.96),('5819','2013-05-14','15:55:00',2.9),('5819','2013-05-14','16:00:00',2.84),('5819','2013-05-14','16:05:00',2.76),('5819','2013-05-14','16:10:00',2.7),('5819','2013-05-14','16:15:00',2.63),('5819','2013-05-14','16:20:00',2.56),('5819','2013-05-14','16:25:00',2.5),('5819','2013-05-14','16:30:00',2.42),('5819','2013-05-14','16:35:00',2.34),('5819','2013-05-14','16:40:00',2.27),('5819','2013-05-14','16:45:00',2.19),('5819','2013-05-14','16:50:00',2.11),('5819','2013-05-14','16:55:00',2.03),('5819','2013-05-14','17:00:00',1.95),('5819','2013-05-14','17:05:00',1.87),('5819','2013-05-14','17:10:00',1.79),('5819','2013-05-14','17:15:00',1.71),('5819','2013-05-14','17:20:00',1.62),('5819','2013-05-14','17:25:00',1.53),('5819','2013-05-14','17:30:00',1.45),('5819','2013-05-14','17:35:00',1.28),('5819','2013-05-14','17:40:00',1.21),('5819','2013-05-14','17:45:00',1.05),('5819','2013-05-14','17:50:00',1.07),('5819','2013-05-13','07:30:00',1.07),('5819','2013-05-13','07:35:00',1.15),('5819','2013-05-13','07:40:00',1.01),('5819','2013-05-13','07:45:00',1.25),('5819','2013-05-13','07:50:00',1.03),('5819','2013-05-13','08:00:00',1.47),('5819','2013-05-13','08:05:00',1.69),('5819','2013-05-13','08:10:00',1.82),('5819','2013-05-13','08:15:00',1.9),('5819','2013-05-13','08:20:00',1.99),('5819','2013-05-13','08:25:00',2.04),('5819','2013-05-13','08:30:00',2.11),('5819','2013-05-13','08:35:00',2.21),('5819','2013-05-13','08:40:00',2.28),('5819','2013-05-13','08:45:00',2.35),('5819','2013-05-13','08:50:00',2.45),('5819','2013-05-13','08:55:00',2.5),('5819','2013-05-13','09:00:00',2.56),('5819','2013-05-13','09:05:00',2.66),('5819','2013-05-13','09:10:00',2.73),('5819','2013-05-13','09:15:00',2.76),('5819','2013-05-13','09:20:00',2.8),('5819','2013-05-13','09:25:00',2.9),('5819','2013-05-13','09:30:00',2.95),('5819','2013-05-13','09:35:00',2.99),('5819','2013-05-13','09:40:00',3.07),('5819','2013-05-13','09:45:00',3.17),('5819','2013-05-13','09:50:00',3.22),('5819','2013-05-13','09:55:00',3.35),('5819','2013-05-13','10:00:00',3.29),('5819','2013-05-13','10:05:00',2.32),('5819','2013-05-13','10:10:00',3.33),('5819','2013-05-13','10:15:00',3.71),('5819','2013-05-13','10:20:00',2.56),('5819','2013-05-13','10:25:00',2.81),('5819','2013-05-13','10:30:00',3.76),('5819','2013-05-13','10:40:00',1.73),('5819','2013-05-13','10:45:00',3.8),('5819','2013-05-13','10:50:00',4.18),('5819','2013-05-13','10:55:00',2.62),('5819','2013-05-13','11:00:00',2.82),('5819','2013-05-13','11:05:00',2.06),('5819','2013-05-13','11:10:00',1.62),('5819','2013-05-13','11:15:00',2.23),('5819','2013-05-13','11:20:00',1.45),('5819','2013-05-13','11:25:00',1.7),('5819','2013-05-13','11:30:00',2),('5819','2013-05-13','11:35:00',3.24),('5819','2013-05-13','11:40:00',2.29),('5819','2013-05-13','11:45:00',2.55),('5819','2013-05-13','11:50:00',1.67),('5819','2013-05-13','11:55:00',1.64),('5819','2013-05-13','12:00:00',1.49),('5819','2013-05-13','12:05:00',1.57),('5819','2013-05-13','12:10:00',3.07),('5819','2013-05-13','12:15:00',2.32),('5819','2013-05-13','12:20:00',1.35),('5819','2013-05-13','12:25:00',2.43),('5819','2013-05-13','12:30:00',4.27),('5819','2013-05-13','12:35:00',2.75),('5819','2013-05-13','12:40:00',1.9),('5819','2013-05-13','12:45:00',1.96),('5819','2013-05-13','12:50:00',3.47),('5819','2013-05-13','12:55:00',4.5),('5819','2013-05-13','13:00:00',3.88),('5819','2013-05-13','13:05:00',3.96),('5819','2013-05-13','13:10:00',4.28),('5819','2013-05-13','13:15:00',4.43),('5819','2013-05-13','13:20:00',4.11),('5819','2013-05-13','13:25:00',4.3),('5819','2013-05-13','13:30:00',4.33),('5819','2013-05-13','13:35:00',3.9),('5819','2013-05-13','13:40:00',2.21),('5819','2013-05-13','13:45:00',2.09),('5819','2013-05-13','13:50:00',1.5),('5819','2013-05-13','13:55:00',1.07),('5819','2013-05-13','14:00:00',1.56),('5819','2013-05-13','14:05:00',4.41),('5819','2013-05-13','14:10:00',4.32),('5819','2013-05-13','14:15:00',4.11),('5819','2013-05-13','14:20:00',3.88),('5819','2013-05-13','14:25:00',2.75),('5819','2013-05-13','14:30:00',2.07),('5819','2013-05-13','14:35:00',3.88),('5819','2013-05-13','14:40:00',3.9),('5819','2013-05-13','14:45:00',1.6),('5819','2013-05-13','14:50:00',2.33),('5819','2013-05-13','14:55:00',3.96),('5819','2013-05-13','15:00:00',3.35),('5819','2013-05-13','15:05:00',1.9),('5819','2013-05-13','15:10:00',1.01),('5819','2013-05-13','15:15:00',1.01),('5819','2013-05-13','15:20:00',1.37),('5819','2013-05-13','16:00:00',1.01),('5819','2013-05-13','16:05:00',1.01),('5819','2013-05-13','16:10:00',1.48),('5819','2013-05-13','16:20:00',1.54),('5819','2013-05-13','16:25:00',1.21),('5819','2013-05-13','16:30:00',1.85),('5819','2013-05-13','16:35:00',1.2),('5819','2013-05-13','16:40:00',1.96),('5819','2013-05-13','16:45:00',2.32),('5819','2013-05-13','16:50:00',2.89),('5819','2013-05-13','16:55:00',2.56),('5819','2013-05-13','17:00:00',2.35),('5819','2013-05-13','17:05:00',1.94),('5819','2013-05-13','17:10:00',1.66),('5819','2013-05-13','17:15:00',2.37),('5819','2013-05-13','17:20:00',2.33),('5819','2013-05-13','17:25:00',1.96),('5819','2013-05-13','17:30:00',1.46),('5819','2013-05-13','17:35:00',1.62),('5819','2013-05-13','17:40:00',1.47),('5819','2013-05-13','17:45:00',1.4),('5819','2013-05-13','17:50:00',1.18),('5819','2013-05-12','08:00:00',1.4),('5819','2013-05-12','08:05:00',1.05),('5819','2013-05-12','08:10:00',1.56),('5819','2013-05-12','08:15:00',2.3),('5819','2013-05-12','08:20:00',2.04),('5819','2013-05-12','08:25:00',1.39),('5819','2013-05-12','08:40:00',1.05),('5819','2013-05-12','08:45:00',1.9),('5819','2013-05-12','08:50:00',1.58),('5819','2013-05-12','08:55:00',1.03),('5819','2013-05-12','09:00:00',1.31),('5819','2013-05-12','09:05:00',1.1),('5819','2013-05-12','09:15:00',1.14),('5819','2013-05-12','09:20:00',1.09),('5819','2013-05-12','09:25:00',1.11),('5819','2013-05-12','09:30:00',2.69),('5819','2013-05-12','09:35:00',1.28),('5819','2013-05-12','09:40:00',1.52),('5819','2013-05-12','09:45:00',2.15),('5819','2013-05-12','09:50:00',3.03),('5819','2013-05-12','09:55:00',3.33),('5819','2013-05-12','10:00:00',3.53),('5819','2013-05-12','10:05:00',2.72),('5819','2013-05-12','10:10:00',1.25),('5819','2013-05-12','10:15:00',2.7),('5819','2013-05-12','10:30:00',1.19),('5819','2013-05-12','10:35:00',1.2),('5819','2013-05-12','10:40:00',1.03),('5819','2013-05-12','10:45:00',3.37),('5819','2013-05-12','10:50:00',2.38),('5819','2013-05-12','10:55:00',4.38),('5819','2013-05-12','11:00:00',4.13),('5819','2013-05-12','11:05:00',1.47),('5819','2013-05-12','11:10:00',1.1),('5819','2013-05-12','11:15:00',3.9),('5819','2013-05-12','11:20:00',4.37),('5819','2013-05-12','11:25:00',4.36),('5819','2013-05-12','11:30:00',4.45),('5819','2013-05-12','11:35:00',4.23),('5819','2013-05-12','11:40:00',4.34),('5819','2013-05-12','11:45:00',4.47),('5819','2013-05-12','11:50:00',2.66),('5819','2013-05-12','11:55:00',4.54),('5819','2013-05-12','12:00:00',3.6),('5819','2013-05-12','12:05:00',3.43),('5819','2013-05-12','12:10:00',3.82),('5819','2013-05-12','12:15:00',2.43),('5819','2013-05-12','12:20:00',1.13),('5819','2013-05-12','12:25:00',1.05),('5819','2013-05-12','12:30:00',1.19),('5819','2013-05-12','12:35:00',1.47),('5819','2013-05-12','12:40:00',2.01),('5819','2013-05-12','12:45:00',2.43),('5819','2013-05-12','12:50:00',4.84),('5819','2013-05-12','12:55:00',3.29),('5819','2013-05-12','13:00:00',3.75),('5819','2013-05-12','13:05:00',1.34),('5819','2013-05-12','13:10:00',2.95),('5819','2013-05-12','13:15:00',4.02),('5819','2013-05-12','13:20:00',1.76),('5819','2013-05-12','13:25:00',2.02),('5819','2013-05-12','13:30:00',3.24),('5819','2013-05-12','13:35:00',4.36),('5819','2013-05-12','13:40:00',4.35),('5819','2013-05-12','13:45:00',3.46),('5819','2013-05-12','13:50:00',3.82),('5819','2013-05-12','13:55:00',3.86),('5819','2013-05-12','14:00:00',2.56),('5819','2013-05-12','14:05:00',4.58),('5819','2013-05-12','14:10:00',3.12),('5819','2013-05-12','14:15:00',3.69),('5819','2013-05-12','14:20:00',4.17),('5819','2013-05-12','14:25:00',4.05),('5819','2013-05-12','14:30:00',3.95),('5819','2013-05-12','14:35:00',3.92),('5819','2013-05-12','14:40:00',3.86),('5819','2013-05-12','14:45:00',3.72),('5819','2013-05-12','14:50:00',3.74),('5819','2013-05-12','14:55:00',3.7),('5819','2013-05-12','15:00:00',3.12),('5819','2013-05-12','15:05:00',3.66),('5819','2013-05-12','15:10:00',3.53),('5819','2013-05-12','15:15:00',2.88),('5819','2013-05-12','15:20:00',3.11),('5819','2013-05-12','15:25:00',3.4),('5819','2013-05-12','15:30:00',3.18),('5819','2013-05-12','15:35:00',3.18),('5819','2013-05-12','15:40:00',3.12),('5819','2013-05-12','15:45:00',3.06),('5819','2013-05-12','15:50:00',2.98),('5819','2013-05-12','15:55:00',2.88),('5819','2013-05-12','16:00:00',2.82),('5819','2013-05-12','16:05:00',2.56),('5819','2013-05-12','16:10:00',2.66),('5819','2013-05-12','16:15:00',2.61),('5819','2013-05-12','16:20:00',2.55),('5819','2013-05-12','16:25:00',2.46),('5819','2013-05-12','16:30:00',2.4),('5819','2013-05-12','16:35:00',2.38),('5819','2013-05-12','16:40:00',2.4),('5819','2013-05-12','16:45:00',2.56),('5819','2013-05-12','16:50:00',2.55),('5819','2013-05-12','16:55:00',2.31),('5819','2013-05-12','17:00:00',2.72),('5819','2013-05-12','17:05:00',2.36),('5819','2013-05-12','17:10:00',2.37),('5819','2013-05-12','17:15:00',2.5),('5819','2013-05-12','17:20:00',2.24),('5819','2013-05-12','17:25:00',1.86),('5819','2013-05-12','17:30:00',1.84),('5819','2013-05-12','17:35:00',1.48),('5819','2013-05-12','17:40:00',1.19),('5819','2013-05-12','18:00:00',1.04),('5819','2013-05-12','18:05:00',1.36),('5819','2013-05-12','18:10:00',1.33),('5819','2013-05-12','18:15:00',1.17),('5819','2013-05-12','18:25:00',1.01),('5819','2013-05-12','18:30:00',1.03),('5819','2013-05-12','18:35:00',1.01),('5819','2013-05-11','07:30:00',1.04),('5819','2013-05-11','07:35:00',1.05),('5819','2013-05-11','07:45:00',1.35),('5819','2013-05-11','07:50:00',1.51),('5819','2013-05-11','07:55:00',1.68),('5819','2013-05-11','08:00:00',1.55),('5819','2013-05-11','08:05:00',1.62),('5819','2013-05-11','08:15:00',1.18),('5819','2013-05-11','08:20:00',1.25),('5819','2013-05-11','08:25:00',1.06),('5819','2013-05-11','09:15:00',1.16),('5819','2013-05-11','09:20:00',1.83),('5819','2013-05-11','09:25:00',1.23),('5819','2013-05-11','09:30:00',2.34),('5819','2013-05-11','09:35:00',1.57),('5819','2013-05-11','09:40:00',1.85),('5819','2013-05-11','09:45:00',2.24),('5819','2013-05-11','09:50:00',1.49),('5819','2013-05-11','09:55:00',1.77),('5819','2013-05-11','10:00:00',1.47),('5819','2013-05-11','10:05:00',1.62),('5819','2013-05-11','10:10:00',1.26),('5819','2013-05-11','10:25:00',1.02),('5819','2013-05-11','10:30:00',1.01),('5819','2013-05-11','10:35:00',1.13),('5819','2013-05-11','10:55:00',2.55),('5819','2013-05-11','11:00:00',3.94),('5819','2013-05-11','11:05:00',3.22),('5819','2013-05-11','11:10:00',1.27),('5819','2013-05-11','11:15:00',1.02),('5819','2013-05-11','11:30:00',1.22),('5819','2013-05-11','11:35:00',2.41),('5819','2013-05-11','11:40:00',2.02),('5819','2013-05-11','11:45:00',3.08),('5819','2013-05-11','11:50:00',3.18),('5819','2013-05-11','11:55:00',1.02),('5819','2013-05-11','12:00:00',1.08),('5819','2013-05-11','12:05:00',1.69),('5819','2013-05-11','12:10:00',1.47),('5819','2013-05-11','12:15:00',1.42),('5819','2013-05-11','12:20:00',1.59),('5819','2013-05-11','12:25:00',4.74),('5819','2013-05-11','12:30:00',3.29),('5819','2013-05-11','12:35:00',2.15),('5819','2013-05-11','12:40:00',1.77),('5819','2013-05-11','12:45:00',1.92),('5819','2013-05-11','12:50:00',1.71),('5819','2013-05-11','12:55:00',1.5),('5819','2013-05-11','13:00:00',1.39),('5819','2013-05-11','13:05:00',1.36),('5819','2013-05-11','13:10:00',1.23),('5819','2013-05-11','13:35:00',1.07),('5819','2013-05-11','14:00:00',1.85),('5819','2013-05-11','14:05:00',2.75),('5819','2013-05-11','14:10:00',3.18),('5819','2013-05-11','14:15:00',1.97),('5819','2013-05-11','14:20:00',3.83),('5819','2013-05-11','14:25:00',3.35),('5819','2013-05-11','14:30:00',3.06),('5819','2013-05-11','14:35:00',2.66),('5819','2013-05-11','14:40:00',2.73),('5819','2013-05-11','14:45:00',3.05),('5819','2013-05-11','14:50:00',3.73),('5819','2013-05-11','14:55:00',3.84),('5819','2013-05-11','15:00:00',3.63),('5819','2013-05-11','15:05:00',3.41),('5819','2013-05-11','15:10:00',3.49),('5819','2013-05-11','15:15:00',3.5),('5819','2013-05-11','15:20:00',3.45),('5819','2013-05-11','15:25:00',3.35),('5819','2013-05-11','15:30:00',3.29),('5819','2013-05-11','15:35:00',3.19),('5819','2013-05-11','15:40:00',3.19),('5819','2013-05-11','15:45:00',3.17),('5819','2013-05-11','15:50:00',2.49),('5819','2013-05-11','15:55:00',3.05),('5819','2013-05-11','16:00:00',2.63),('5819','2013-05-11','16:05:00',2.91),('5819','2013-05-11','16:10:00',2.86),('5819','2013-05-11','16:15:00',1.77),('5819','2013-05-11','16:20:00',2.79),('5819','2013-05-11','16:25:00',2.66),('5819','2013-05-11','16:30:00',2.45),('5819','2013-05-11','16:35:00',2.25),('5819','2013-05-11','16:40:00',2.26),('5819','2013-05-11','16:45:00',2.26),('5819','2013-05-11','16:50:00',1.83),('5819','2013-05-11','16:55:00',1.9),('5819','2013-05-11','17:00:00',1.95),('5819','2013-05-11','17:05:00',1.93),('5819','2013-05-11','17:10:00',1.76),('5819','2013-05-11','17:15:00',1.62),('5819','2013-05-11','17:20:00',1.53),('5819','2013-05-11','17:25:00',1.7),('5819','2013-05-11','17:30:00',1.37),('5819','2013-05-11','17:35:00',1.33),('5819','2013-05-11','17:40:00',1.16),('5819','2013-05-11','17:45:00',1.34),('5819','2013-05-11','17:50:00',1.05),('5819','2013-05-11','17:55:00',1.22),('5819','2013-05-11','18:10:00',1.09),('5819','2013-05-10','07:35:00',1.04),('5819','2013-05-10','07:55:00',1.08),('5819','2013-05-10','08:00:00',1.44),('5819','2013-05-10','08:05:00',2.19),('5819','2013-05-10','08:10:00',2.16),('5819','2013-05-10','08:15:00',2.27),('5819','2013-05-10','08:20:00',2.1),('5819','2013-05-10','08:25:00',1.97),('5819','2013-05-10','08:30:00',2.09),('5819','2013-05-10','08:35:00',2.12),('5819','2013-05-10','08:40:00',1.4),('5819','2013-05-10','09:00:00',1.62),('5819','2013-05-10','09:05:00',2.48),('5819','2013-05-10','09:10:00',2.8),('5819','2013-05-10','09:15:00',2.89),('5819','2013-05-10','09:20:00',2.79),('5819','2013-05-10','09:25:00',2.45),('5819','2013-05-10','09:30:00',2.46),('5819','2013-05-10','09:35:00',3.03),('5819','2013-05-10','09:40:00',2.93),('5819','2013-05-10','09:45:00',2.68),('5819','2013-05-10','09:50:00',2.79),('5819','2013-05-10','09:55:00',3.15),('5819','2013-05-10','10:00:00',2.5),('5819','2013-05-10','10:05:00',2.97),('5819','2013-05-10','10:10:00',3.12),('5819','2013-05-10','10:15:00',3.3),('5819','2013-05-10','10:20:00',1.95),('5819','2013-05-10','10:25:00',2.54),('5819','2013-05-10','10:30:00',3),('5819','2013-05-10','10:35:00',1.15),('5819','2013-05-10','10:40:00',3.1),('5819','2013-05-10','10:45:00',3.92),('5819','2013-05-10','10:50:00',3.98),('5819','2013-05-10','10:55:00',3.79),('5819','2013-05-10','11:00:00',3.63),('5819','2013-05-10','11:05:00',3.94),('5819','2013-05-10','11:10:00',3.88),('5819','2013-05-10','11:15:00',3.52),('5819','2013-05-10','11:20:00',4.12),('5819','2013-05-10','11:25:00',3.77),('5819','2013-05-10','11:30:00',3.38),('5819','2013-05-10','11:35:00',3.68),('5819','2013-05-10','11:40:00',3.96),('5819','2013-05-10','11:45:00',3.07),('5819','2013-05-10','11:50:00',3.33),('5819','2013-05-10','11:55:00',3.75),('5819','2013-05-10','12:00:00',3.78),('5819','2013-05-10','12:05:00',3.21),('5819','2013-05-10','12:10:00',2.27),('5819','2013-05-10','12:15:00',2.08),('5819','2013-05-10','12:20:00',2.45),('5819','2013-05-10','12:25:00',2.24),('5819','2013-05-10','12:30:00',2.06),('5819','2013-05-10','12:35:00',2.39),('5819','2013-05-10','12:40:00',3.33),('5819','2013-05-10','12:45:00',4.43),('5819','2013-05-10','12:50:00',3.56),('5819','2013-05-10','12:55:00',3.19),('5819','2013-05-10','13:00:00',3.66),('5819','2013-05-10','13:05:00',3.56),('5819','2013-05-10','13:10:00',4.22),('5819','2013-05-10','13:15:00',4.46),('5819','2013-05-10','13:20:00',3.2),('5819','2013-05-10','13:25:00',2.77),('5819','2013-05-10','13:30:00',2.92),('5819','2013-05-10','13:35:00',3.19),('5819','2013-05-10','13:40:00',4.23),('5819','2013-05-10','13:45:00',3.92),('5819','2013-05-10','13:50:00',2.32),('5819','2013-05-10','13:55:00',2.02),('5819','2013-05-10','14:00:00',1.82),('5819','2013-05-10','14:05:00',1.83),('5819','2013-05-10','14:10:00',2.18),('5819','2013-05-10','14:15:00',2.34),('5819','2013-05-10','14:20:00',2.43),('5819','2013-05-10','14:25:00',2.37),('5819','2013-05-10','14:30:00',2.36),('5819','2013-05-10','14:35:00',2.99),('5819','2013-05-10','14:40:00',2.64),('5819','2013-05-10','14:45:00',1.99),('5819','2013-05-10','14:50:00',1.47),('5819','2013-05-10','14:55:00',1.25),('5819','2013-05-10','15:00:00',1.14),('5819','2013-05-10','15:05:00',1.18),('5819','2013-05-10','15:10:00',1.54),('5819','2013-05-10','15:15:00',2.64),('5819','2013-05-10','15:20:00',2.59),('5819','2013-05-10','15:25:00',1.88),('5819','2013-05-10','15:30:00',1.74),('5819','2013-05-10','15:35:00',1.77),('5819','2013-05-10','15:40:00',1.83),('5819','2013-05-10','15:45:00',1.8),('5819','2013-05-10','15:50:00',1.66),('5819','2013-05-10','15:55:00',1.56),('5819','2013-05-10','16:00:00',1.49),('5819','2013-05-10','16:05:00',1.47),('5819','2013-05-10','16:10:00',1.45),('5819','2013-05-10','16:15:00',1.36),('5819','2013-05-10','16:20:00',1.21),('5819','2013-05-10','16:25:00',1.18),('5819','2013-05-10','16:30:00',1.22),('5819','2013-05-10','16:35:00',1.29),('5819','2013-05-10','16:40:00',1.25),('5819','2013-05-10','16:45:00',1.28),('5819','2013-05-10','16:50:00',1.25),('5819','2013-05-10','16:55:00',1.08),('5819','2013-05-10','17:15:00',1.22),('5819','2013-05-10','17:20:00',1.65),('5819','2013-05-10','17:25:00',1.64),('5819','2013-05-10','17:30:00',1.48),('5819','2013-05-10','17:35:00',1.65),('5819','2013-05-10','17:40:00',1.25),('5819','2013-05-10','17:45:00',1.1),('5819','2013-05-09','07:25:00',1.07),('5819','2013-05-09','07:30:00',1.15),('5819','2013-05-09','07:35:00',1.24),('5819','2013-05-09','07:40:00',1.33),('5819','2013-05-09','07:45:00',1.42),('5819','2013-05-09','07:50:00',1.5),('5819','2013-05-09','07:55:00',1.6),('5819','2013-05-09','08:00:00',1.68),('5819','2013-05-09','08:05:00',1.76),('5819','2013-05-09','08:10:00',1.84),('5819','2013-05-09','08:15:00',1.93),('5819','2013-05-09','08:20:00',2.01),('5819','2013-05-09','08:25:00',2.09),('5819','2013-05-09','08:30:00',2.16),('5819','2013-05-09','08:35:00',2.25),('5819','2013-05-09','08:40:00',2.32),('5819','2013-05-09','08:45:00',2.4),('5819','2013-05-09','08:50:00',2.46),('5819','2013-05-09','08:55:00',2.53),('5819','2013-05-09','09:00:00',2.6),('5819','2013-05-09','09:05:00',2.68),('5819','2013-05-09','09:10:00',2.76),('5819','2013-05-09','09:15:00',2.82),('5819','2013-05-09','09:20:00',2.87),('5819','2013-05-09','09:25:00',2.96),('5819','2013-05-09','09:30:00',3.01),('5819','2013-05-09','09:35:00',3.07),('5819','2013-05-09','09:40:00',3.12),('5819','2013-05-09','09:45:00',3.16),('5819','2013-05-09','09:50:00',3.23),('5819','2013-05-09','09:55:00',3.28),('5819','2013-05-09','10:00:00',3.33),('5819','2013-05-09','10:05:00',3.37),('5819','2013-05-09','10:10:00',3.42),('5819','2013-05-09','10:15:00',3.44),('5819','2013-05-09','10:20:00',3.49),('5819','2013-05-09','10:25:00',3.54),('5819','2013-05-09','10:30:00',3.57),('5819','2013-05-09','10:35:00',3.61),('5819','2013-05-09','10:40:00',3.65),('5819','2013-05-09','10:45:00',3.67),('5819','2013-05-09','10:50:00',3.68),('5819','2013-05-09','10:55:00',3.71),('5819','2013-05-09','11:00:00',3.74),('5819','2013-05-09','11:05:00',3.77),('5819','2013-05-09','11:10:00',3.8),('5819','2013-05-09','11:15:00',3.81),('5819','2013-05-09','11:20:00',3.82),('5819','2013-05-09','11:25:00',3.81),('5819','2013-05-09','11:30:00',3.84),('5819','2013-05-09','11:35:00',3.84),('5819','2013-05-09','11:40:00',3.83),('5819','2013-05-09','11:45:00',3.85),('5819','2013-05-09','11:50:00',3.86),('5819','2013-05-09','11:55:00',3.91),('5819','2013-05-09','12:00:00',3.92),('5819','2013-05-09','12:05:00',3.92),('5819','2013-05-09','12:10:00',4),('5819','2013-05-09','12:15:00',3.98),('5819','2013-05-09','12:20:00',3.97),('5819','2013-05-09','12:25:00',3.99),('5819','2013-05-09','12:30:00',3.86),('5819','2013-05-09','12:35:00',3.71),('5819','2013-05-09','12:40:00',4.01),('5819','2013-05-09','12:45:00',3.97),('5819','2013-05-09','12:50:00',4),('5819','2013-05-09','12:55:00',3.93),('5819','2013-05-09','13:00:00',3.89),('5819','2013-05-09','13:05:00',3.87),('5819','2013-05-09','13:10:00',3.9),('5819','2013-05-09','13:15:00',3.92),('5819','2013-05-09','13:20:00',3.93),('5819','2013-05-09','13:25:00',3.9),('5819','2013-05-09','13:30:00',3.87),('5819','2013-05-09','13:35:00',3.85),('5819','2013-05-09','13:40:00',3.87),('5819','2013-05-09','13:45:00',3.91),('5819','2013-05-09','13:50:00',3.87),('5819','2013-05-09','13:55:00',3.74),('5819','2013-05-09','14:00:00',3),('5819','2013-05-09','14:05:00',3.61),('5819','2013-05-09','14:10:00',2.76),('5819','2013-05-09','14:15:00',2.88),('5819','2013-05-09','14:20:00',3.47),('5819','2013-05-09','14:25:00',3.11),('5819','2013-05-09','14:30:00',3.34),('5819','2013-05-09','14:35:00',3.61),('5819','2013-05-09','14:40:00',3.58),('5819','2013-05-09','14:45:00',3.55),('5819','2013-05-09','14:50:00',3.45),('5819','2013-05-09','14:55:00',3.18),('5819','2013-05-09','15:00:00',3.48),('5819','2013-05-09','15:05:00',3.39),('5819','2013-05-09','15:10:00',3.35),('5819','2013-05-09','15:15:00',3.28),('5819','2013-05-09','15:20:00',3.19),('5819','2013-05-09','15:25:00',3.13),('5819','2013-05-09','15:30:00',3.12),('5819','2013-05-09','15:35:00',3.08),('5819','2013-05-09','15:40:00',3.02),('5819','2013-05-09','15:45:00',2.96),('5819','2013-05-09','15:50:00',2.9),('5819','2013-05-09','15:55:00',2.85),('5819','2013-05-09','16:00:00',2.77),('5819','2013-05-09','16:05:00',2.69),('5819','2013-05-09','16:10:00',2.63),('5819','2013-05-09','16:15:00',2.57),('5819','2013-05-09','16:20:00',2.49),('5819','2013-05-09','16:25:00',2.39),('5819','2013-05-09','16:30:00',2.33),('5819','2013-05-09','16:35:00',2.25),('5819','2013-05-09','16:40:00',2.18),('5819','2013-05-09','16:45:00',2.11),('5819','2013-05-09','16:50:00',2.02),('5819','2013-05-09','16:55:00',1.94),('5819','2013-05-09','17:00:00',1.87),('5819','2013-05-09','17:05:00',1.79),('5819','2013-05-09','17:10:00',1.71),('5819','2013-05-09','17:15:00',1.63),('5819','2013-05-09','17:20:00',1.56),('5819','2013-05-09','17:25:00',1.48),('5819','2013-05-09','17:30:00',1.38),('5819','2013-05-09','17:35:00',1.24),('5819','2013-05-09','17:40:00',1.2),('5819','2013-05-09','17:45:00',1.08),('5819','2013-05-08','07:55:00',1),('5819','2013-05-08','08:05:00',1.51),('5819','2013-05-08','08:10:00',1.99),('5819','2013-05-08','08:15:00',2.04),('5819','2013-05-08','08:20:00',2.06),('5819','2013-05-08','08:25:00',2.06),('5819','2013-05-08','08:30:00',2.1),('5819','2013-05-08','08:35:00',2.17),('5819','2013-05-08','08:40:00',1.67),('5819','2013-05-08','08:45:00',2.27),('5819','2013-05-08','08:50:00',2.49),('5819','2013-05-08','08:55:00',2.85),('5819','2013-05-08','09:00:00',2.87),('5819','2013-05-08','09:05:00',3.23),('5819','2013-05-08','09:10:00',3.11),('5819','2013-05-08','09:15:00',2.11),('5819','2013-05-08','09:20:00',2.68),('5819','2013-05-08','09:25:00',1.5),('5819','2013-05-08','09:40:00',1.84),('5819','2013-05-08','09:45:00',2.06),('5819','2013-05-08','09:50:00',1.39),('5819','2013-05-08','10:05:00',1.41),('5819','2013-05-08','10:10:00',3.15),('5819','2013-05-08','10:15:00',2.16),('5819','2013-05-08','10:20:00',1.12),('5819','2013-05-08','10:55:00',1.24),('5819','2013-05-08','11:00:00',1.2),('5819','2013-05-08','11:05:00',4.35),('5819','2013-05-08','11:10:00',4.17),('5819','2013-05-08','11:15:00',4.11),('5819','2013-05-08','11:20:00',3.95),('5819','2013-05-08','11:25:00',4),('5819','2013-05-08','11:30:00',4.17),('5819','2013-05-08','11:35:00',4.05),('5819','2013-05-08','11:40:00',3.32),('5819','2013-05-08','11:45:00',1.92),('5819','2013-05-08','11:50:00',1.5),('5819','2013-05-08','11:55:00',1.56),('5819','2013-05-08','12:00:00',3.8),('5819','2013-05-08','12:05:00',3),('5819','2013-05-08','12:20:00',2.57),('5819','2013-05-08','12:25:00',4.57),('5819','2013-05-08','12:30:00',1.63),('5819','2013-05-08','12:35:00',1.11),('5819','2013-05-08','12:40:00',1.24),('5819','2013-05-08','12:45:00',1.68),('5819','2013-05-08','12:50:00',1.36),('5819','2013-05-08','12:55:00',2.31),('5819','2013-05-08','13:00:00',3.26),('5819','2013-05-08','13:05:00',4.82),('5819','2013-05-08','13:10:00',4.8),('5819','2013-05-08','13:15:00',2.95),('5819','2013-05-08','13:20:00',1.01),('5819','2013-05-08','13:40:00',1.18),('5819','2013-05-08','13:45:00',4.64),('5819','2013-05-08','13:50:00',4.47),('5819','2013-05-08','13:55:00',3.85),('5819','2013-05-08','14:00:00',3.62),('5819','2013-05-08','14:05:00',2.86),('5819','2013-05-08','14:10:00',3.13),('5819','2013-05-08','14:15:00',1.28),('5819','2013-05-08','14:20:00',1.5),('5819','2013-05-08','14:25:00',1.34),('5819','2013-05-08','14:30:00',1.66),('5819','2013-05-08','14:35:00',1.52),('5819','2013-05-08','14:40:00',3.92),('5819','2013-05-08','14:45:00',2.74),('5819','2013-05-08','14:50:00',2.9),('5819','2013-05-08','14:55:00',3.82),('5819','2013-05-08','15:00:00',3.51),('5819','2013-05-08','15:05:00',3.51),('5819','2013-05-08','15:10:00',2.85),('5819','2013-05-08','15:15:00',3.52),('5819','2013-05-08','15:20:00',3.38),('5819','2013-05-08','15:25:00',3.32),('5819','2013-05-08','15:30:00',3.26),('5819','2013-05-08','15:35:00',3.14),('5819','2013-05-08','15:40:00',3.08),('5819','2013-05-08','15:45:00',3.02),('5819','2013-05-08','15:50:00',2.95),('5819','2013-05-08','15:55:00',2.89),('5819','2013-05-08','16:00:00',2.85),('5819','2013-05-08','16:05:00',2.81),('5819','2013-05-08','16:10:00',2.76),('5819','2013-05-08','16:15:00',2.7),('5819','2013-05-08','16:20:00',2.59),('5819','2013-05-08','16:25:00',2.45),('5819','2013-05-08','16:30:00',2.55),('5819','2013-05-08','16:35:00',2.5),('5819','2013-05-08','16:40:00',2.46),('5819','2013-05-08','16:45:00',1.02),('5819','2013-05-08','16:50:00',2.02),('5819','2013-05-08','16:55:00',2.32),('5819','2013-05-08','17:00:00',2.4),('5819','2013-05-08','17:05:00',1.99),('5819','2013-05-08','17:10:00',2.18),('5819','2013-05-08','17:15:00',2.02),('5819','2013-05-08','17:20:00',1.57),('5819','2013-05-08','17:25:00',1.75),('5819','2013-05-08','17:30:00',1.81),('5819','2013-05-08','17:35:00',1.64),('5819','2013-05-08','17:40:00',1.69),('5819','2013-05-08','17:45:00',1.67),('5819','2013-05-08','17:50:00',1.61),('5819','2013-05-08','17:55:00',1.19),('5819','2013-05-07','07:25:00',1.06),('5819','2013-05-07','07:30:00',1.14),('5819','2013-05-07','07:35:00',1.24),('5819','2013-05-07','07:40:00',1.32),('5819','2013-05-07','07:45:00',1.41),('5819','2013-05-07','07:50:00',1.5),('5819','2013-05-07','07:55:00',1.57),('5819','2013-05-07','08:00:00',1.65),('5819','2013-05-07','08:05:00',1.77),('5819','2013-05-07','08:10:00',1.86),('5819','2013-05-07','08:15:00',1.95),('5819','2013-05-07','08:20:00',2.02),('5819','2013-05-07','08:25:00',2.09),('5819','2013-05-07','08:30:00',2.17),('5819','2013-05-07','08:35:00',2.28),('5819','2013-05-07','08:40:00',2.31),('5819','2013-05-07','08:45:00',2.44),('5819','2013-05-07','08:50:00',2.36),('5819','2013-05-07','08:55:00',2.24),('5819','2013-05-07','09:00:00',2.89),('5819','2013-05-07','09:05:00',3.11),('5819','2013-05-07','09:10:00',2.45),('5819','2013-05-07','09:15:00',2.71),('5819','2013-05-07','09:20:00',1.83),('5819','2013-05-07','09:25:00',1.17),('5819','2013-05-07','09:35:00',2.19),('5819','2013-05-07','09:40:00',2.19),('5819','2013-05-07','09:45:00',1.7),('5819','2013-05-07','09:50:00',2.28),('5819','2013-05-07','09:55:00',1.25),('5819','2013-05-07','10:00:00',1.31),('5819','2013-05-07','11:05:00',1.1),('5819','2013-05-07','11:10:00',1.17),('5819','2013-05-07','11:15:00',1.26),('5819','2013-05-07','11:20:00',3.15),('5819','2013-05-07','11:25:00',3.03),('5819','2013-05-07','11:30:00',1.48),('5819','2013-05-07','12:05:00',1.57),('5819','2013-05-07','12:10:00',1.12),('5819','2013-05-07','12:15:00',3.7),('5819','2013-05-07','12:20:00',1.44),('5819','2013-05-07','12:25:00',2.02),('5819','2013-05-07','12:30:00',4.9),('5819','2013-05-07','12:35:00',1.41),('5819','2013-05-07','13:25:00',1.01),('5819','2013-05-07','13:30:00',1.35),('5819','2013-05-07','13:35:00',1.26),('5819','2013-05-07','13:40:00',3.57),('5819','2013-05-07','13:45:00',4.34),('5819','2013-05-07','13:50:00',4.48),('5819','2013-05-07','13:55:00',4.32),('5819','2013-05-07','14:00:00',4.22),('5819','2013-05-07','14:05:00',4.12),('5819','2013-05-07','14:10:00',4.13),('5819','2013-05-07','14:15:00',4.14),('5819','2013-05-07','14:20:00',4.06),('5819','2013-05-07','14:25:00',2.5),('5819','2013-05-07','14:30:00',4.18),('5819','2013-05-07','14:35:00',2.67),('5819','2013-05-07','14:40:00',4.41),('5819','2013-05-07','14:45:00',3.56),('5819','2013-05-07','14:50:00',3.24),('5819','2013-05-07','14:55:00',4),('5819','2013-05-07','15:00:00',2.8),('5819','2013-05-07','15:05:00',3.91),('5819','2013-05-07','15:10:00',3.03),('5819','2013-05-07','15:15:00',3.37),('5819','2013-05-07','15:20:00',2.95),('5819','2013-05-07','15:25:00',2.1),('5819','2013-05-07','15:30:00',1.95),('5819','2013-05-07','15:35:00',2.72),('5819','2013-05-07','15:40:00',1.88),('5819','2013-05-07','15:45:00',2.31),('5819','2013-05-07','15:50:00',1.52),('5819','2013-05-07','15:55:00',1.63),('5819','2013-05-07','16:00:00',2.8),('5819','2013-05-07','16:05:00',2.38),('5819','2013-05-07','16:10:00',1.18),('5819','2013-05-07','16:15:00',1.65),('5819','2013-05-07','16:20:00',3.52),('5819','2013-05-07','16:25:00',3.39),('5819','2013-05-07','16:30:00',3.16),('5819','2013-05-07','16:35:00',3.04),('5819','2013-05-07','16:40:00',3.05),('5819','2013-05-07','16:45:00',2.25),('5819','2013-05-07','16:50:00',2.3),('5819','2013-05-07','16:55:00',2.19),('5819','2013-05-07','17:00:00',2.26),('5819','2013-05-07','17:05:00',2.19),('5819','2013-05-07','17:10:00',1.78),('5819','2013-05-07','17:15:00',1.13),('5819','2013-05-07','17:20:00',1.06),('5819','2013-05-07','17:25:00',1.12),('5819','2013-05-06','08:25:00',1.08),('5819','2013-05-06','08:30:00',1.27),('5819','2013-05-06','08:35:00',1.11),('5819','2013-05-06','08:55:00',1.53),('5819','2013-05-06','09:00:00',1.89),('5819','2013-05-06','09:05:00',1.27),('5819','2013-05-06','09:10:00',1.55),('5819','2013-05-06','09:15:00',1.35),('5819','2013-05-06','09:20:00',1.12),('5819','2013-05-06','09:25:00',1.04),('5819','2013-05-06','10:00:00',1.54),('5819','2013-05-06','10:05:00',1.25),('5819','2013-05-06','10:10:00',1.18),('5819','2013-05-06','10:15:00',1.38),('5819','2013-05-06','10:20:00',1.82),('5819','2013-05-06','10:25:00',1.47),('5819','2013-05-06','10:30:00',1.57),('5819','2013-05-06','10:35:00',1.55),('5819','2013-05-06','10:40:00',1.56),('5819','2013-05-06','10:45:00',2.38),('5819','2013-05-06','10:50:00',2.41),('5819','2013-05-06','10:55:00',1.96),('5819','2013-05-06','11:00:00',1.96),('5819','2013-05-06','11:05:00',1.94),('5819','2013-05-06','11:10:00',1.89),('5819','2013-05-06','11:15:00',1.57),('5819','2013-05-06','11:20:00',2.16),('5819','2013-05-06','11:25:00',2.03),('5819','2013-05-06','11:30:00',2.06),('5819','2013-05-06','11:35:00',1.39),('5819','2013-05-06','11:40:00',2.89),('5819','2013-05-06','11:45:00',3.88),('5819','2013-05-06','11:50:00',3.11),('5819','2013-05-06','11:55:00',1.63),('5819','2013-05-06','12:00:00',1.55),('5819','2013-05-06','12:05:00',1.9),('5819','2013-05-06','12:10:00',4.23),('5819','2013-05-06','12:15:00',2.94),('5819','2013-05-06','12:20:00',2.51),('5819','2013-05-06','12:25:00',2.69),('5819','2013-05-06','12:30:00',3.69),('5819','2013-05-06','12:35:00',3.29),('5819','2013-05-06','12:40:00',2.68),('5819','2013-05-06','12:45:00',2.38),('5819','2013-05-06','12:50:00',2.57),('5819','2013-05-06','12:55:00',4.13),('5819','2013-05-06','13:00:00',1.68),('5819','2013-05-06','13:05:00',3.18),('5819','2013-05-06','13:10:00',3.93),('5819','2013-05-06','13:15:00',3.2),('5819','2013-05-06','13:20:00',3.17),('5819','2013-05-06','13:25:00',2.52),('5819','2013-05-06','13:30:00',3.65),('5819','2013-05-06','13:35:00',2.53),('5819','2013-05-06','13:40:00',3.48),('5819','2013-05-06','13:45:00',4.31),('5819','2013-05-06','13:50:00',3.99),('5819','2013-05-06','13:55:00',4),('5819','2013-05-06','14:00:00',2.84),('5819','2013-05-06','14:05:00',4.43),('5819','2013-05-06','14:10:00',2.5),('5819','2013-05-06','14:15:00',3.14),('5819','2013-05-06','14:20:00',3.71),('5819','2013-05-06','14:25:00',2.58),('5819','2013-05-06','14:30:00',3.18),('5819','2013-05-06','14:35:00',3.3),('5819','2013-05-06','14:40:00',1.7),('5819','2013-05-06','14:45:00',3.34),('5819','2013-05-06','14:50:00',1.69),('5819','2013-05-06','14:55:00',3.38),('5819','2013-05-06','15:00:00',3.7),('5819','2013-05-06','15:05:00',2.42),('5819','2013-05-06','15:10:00',3.41),('5819','2013-05-06','15:15:00',2.17),('5819','2013-05-06','15:20:00',1.76),('5819','2013-05-06','15:25:00',2.81),('5819','2013-05-06','15:30:00',1.98),('5819','2013-05-06','15:35:00',1.49),('5819','2013-05-06','15:40:00',1.62),('5819','2013-05-06','15:45:00',1.21),('5819','2013-05-06','15:50:00',1.41),('5819','2013-05-06','15:55:00',1.9),('5819','2013-05-06','16:00:00',1.84),('5819','2013-05-06','16:05:00',1.49),('5819','2013-05-06','16:10:00',1.36),('5819','2013-05-06','16:15:00',1.41),('5819','2013-05-06','16:20:00',1.45),('5819','2013-05-06','16:25:00',1.91),('5819','2013-05-06','16:30:00',1.95),('5819','2013-05-06','16:35:00',1.74),('5819','2013-05-06','16:40:00',2.39),('5819','2013-05-06','16:45:00',2.4),('5819','2013-05-06','16:50:00',1.86),('5819','2013-05-06','16:55:00',2.39),('5819','2013-05-06','17:00:00',1.21),('5819','2013-05-06','17:40:00',1.15),('5819','2013-05-06','17:45:00',1.06),('5819','2013-05-05','07:45:00',1.21),('5819','2013-05-05','07:50:00',1.29),('5819','2013-05-05','07:55:00',1.31),('5819','2013-05-05','08:00:00',1.39),('5819','2013-05-05','08:05:00',1.53),('5819','2013-05-05','08:10:00',1.63),('5819','2013-05-05','08:15:00',1.74),('5819','2013-05-05','08:20:00',1.93),('5819','2013-05-05','08:25:00',2.3),('5819','2013-05-05','08:30:00',2.33),('5819','2013-05-05','08:35:00',2.02),('5819','2013-05-05','08:40:00',2.22),('5819','2013-05-05','08:45:00',1.88),('5819','2013-05-05','08:50:00',1.43),('5819','2013-05-05','08:55:00',1.26),('5819','2013-05-05','09:00:00',1.35),('5819','2013-05-05','09:05:00',1.46),('5819','2013-05-05','09:10:00',1.82),('5819','2013-05-05','09:15:00',1.86),('5819','2013-05-05','09:20:00',1.76),('5819','2013-05-05','09:25:00',1.98),('5819','2013-05-05','09:30:00',2.16),('5819','2013-05-05','09:35:00',1.49),('5819','2013-05-05','09:40:00',2.3),('5819','2013-05-05','09:45:00',2.9),('5819','2013-05-05','09:50:00',2.12),('5819','2013-05-05','09:55:00',3.43),('5819','2013-05-05','10:00:00',2.53),('5819','2013-05-05','10:05:00',2.25),('5819','2013-05-05','10:10:00',2.15),('5819','2013-05-05','10:15:00',1.85),('5819','2013-05-05','10:20:00',3.15),('5819','2013-05-05','10:25:00',2.33),('5819','2013-05-05','10:30:00',2.56),('5819','2013-05-05','10:35:00',2.39),('5819','2013-05-05','10:40:00',2.29),('5819','2013-05-05','10:45:00',2.4),('5819','2013-05-05','10:50:00',1.87),('5819','2013-05-05','10:55:00',1.63),('5819','2013-05-05','11:00:00',1.48),('5819','2013-05-05','11:05:00',1.76),('5819','2013-05-05','11:10:00',1.7),('5819','2013-05-05','11:15:00',1.67),('5819','2013-05-05','11:20:00',2.2),('5819','2013-05-05','11:25:00',3.2),('5819','2013-05-05','11:30:00',2.62),('5819','2013-05-05','11:35:00',3.49),('5819','2013-05-05','11:40:00',3.11),('5819','2013-05-05','11:45:00',2.81),('5819','2013-05-05','11:50:00',2.53),('5819','2013-05-05','11:55:00',3.35),('5819','2013-05-05','12:00:00',2.47),('5819','2013-05-05','12:05:00',2.47),('5819','2013-05-05','12:10:00',2.35),('5819','2013-05-05','12:15:00',2.71),('5819','2013-05-05','12:20:00',2.95),('5819','2013-05-05','12:25:00',3.15),('5819','2013-05-05','12:30:00',3.41),('5819','2013-05-05','12:35:00',3.69),('5819','2013-05-05','12:40:00',3.24),('5819','2013-05-05','12:45:00',3.23),('5819','2013-05-05','12:50:00',3.14),('5819','2013-05-05','12:55:00',3.81),('5819','2013-05-05','13:00:00',3.87),('5819','2013-05-05','13:05:00',4.05),('5819','2013-05-05','13:10:00',4.1),('5819','2013-05-05','13:15:00',4.12),('5819','2013-05-05','13:20:00',3.55),('5819','2013-05-05','13:25:00',2.06),('5819','2013-05-05','13:30:00',1.44),('5819','2013-05-05','13:35:00',3.51),('5819','2013-05-05','13:40:00',3.87),('5819','2013-05-05','13:45:00',3.95),('5819','2013-05-05','13:50:00',3.91),('5819','2013-05-05','13:55:00',3.9),('5819','2013-05-05','14:00:00',3.96),('5819','2013-05-05','14:05:00',4.08),('5819','2013-05-05','14:10:00',3.06),('5819','2013-05-05','14:15:00',2.67),('5819','2013-05-05','14:20:00',3.48),('5819','2013-05-05','14:25:00',3.55),('5819','2013-05-05','14:30:00',3.43),('5819','2013-05-05','14:35:00',3.38),('5819','2013-05-05','14:40:00',3.32),('5819','2013-05-05','14:45:00',3.33),('5819','2013-05-05','14:50:00',3.29),('5819','2013-05-05','14:55:00',3.24),('5819','2013-05-05','15:00:00',3.18),('5819','2013-05-05','15:05:00',3.14),('5819','2013-05-05','15:10:00',3.1),('5819','2013-05-05','15:15:00',3.07),('5819','2013-05-05','15:20:00',3.01),('5819','2013-05-05','15:25:00',2.97),('5819','2013-05-05','15:30:00',2.94),('5819','2013-05-05','15:35:00',2.89),('5819','2013-05-05','15:40:00',2.83),('5819','2013-05-05','15:45:00',2.79),('5819','2013-05-05','15:50:00',2.75),('5819','2013-05-05','15:55:00',2.67),('5819','2013-05-05','16:00:00',2.61),('5819','2013-05-05','16:05:00',2.55),('5819','2013-05-05','16:10:00',2.49),('5819','2013-05-05','16:15:00',2.44),('5819','2013-05-05','16:20:00',2.37),('5819','2013-05-05','16:25:00',2.3),('5819','2013-05-05','16:30:00',2.23),('5819','2013-05-05','16:35:00',2.16),('5819','2013-05-05','16:40:00',2.09),('5819','2013-05-05','16:45:00',2.01),('5819','2013-05-05','16:50:00',1.94),('5819','2013-05-05','16:55:00',1.86),('5819','2013-05-05','17:00:00',1.78),('5819','2013-05-05','17:05:00',1.7),('5819','2013-05-05','17:10:00',1.62),('5819','2013-05-05','17:15:00',1.56),('5819','2013-05-05','17:20:00',1.48),('5819','2013-05-05','17:25:00',1.39),('5819','2013-05-05','17:30:00',1.3),('5819','2013-05-05','17:35:00',1.16),('5819','2013-05-05','17:40:00',1.14),('5819','2013-05-05','17:45:00',1.07),('5819','2013-05-04','07:40:00',1.15),('5819','2013-05-04','07:45:00',1.14),('5819','2013-05-04','07:50:00',1.11),('5819','2013-05-04','07:55:00',1.33),('5819','2013-05-04','08:00:00',1.45),('5819','2013-05-04','08:05:00',1.54),('5819','2013-05-04','08:10:00',1.61),('5819','2013-05-04','08:15:00',1.68),('5819','2013-05-04','08:20:00',1.75),('5819','2013-05-04','08:25:00',1.81),('5819','2013-05-04','08:30:00',1.9),('5819','2013-05-04','08:35:00',1.97),('5819','2013-05-04','08:40:00',2.05),('5819','2013-05-04','08:45:00',2.14),('5819','2013-05-04','08:50:00',2.21),('5819','2013-05-04','08:55:00',2.28),('5819','2013-05-04','09:00:00',2.35),('5819','2013-05-04','09:05:00',2.43),('5819','2013-05-04','09:10:00',2.5),('5819','2013-05-04','09:15:00',2.52),('5819','2013-05-04','09:20:00',2.63),('5819','2013-05-04','09:25:00',2.68),('5819','2013-05-04','09:30:00',2.71),('5819','2013-05-04','09:35:00',2.79),('5819','2013-05-04','09:40:00',2.86),('5819','2013-05-04','09:45:00',2.95),('5819','2013-05-04','09:50:00',3),('5819','2013-05-04','09:55:00',3.04),('5819','2013-05-04','10:00:00',3.12),('5819','2013-05-04','10:05:00',3.15),('5819','2013-05-04','10:10:00',3.2),('5819','2013-05-04','10:15:00',3.25),('5819','2013-05-04','10:20:00',3.32),('5819','2013-05-04','10:25:00',3.35),('5819','2013-05-04','10:30:00',3.38),('5819','2013-05-04','10:35:00',3.41),('5819','2013-05-04','10:40:00',3.39),('5819','2013-05-04','10:45:00',3.39),('5819','2013-05-04','10:50:00',3.36),('5819','2013-05-04','10:55:00',3.33),('5819','2013-05-04','11:00:00',3.35),('5819','2013-05-04','11:05:00',3.36),('5819','2013-05-04','11:10:00',3.22),('5819','2013-05-04','11:15:00',3.05),('5819','2013-05-04','11:20:00',3.24),('5819','2013-05-04','11:25:00',3.39),('5819','2013-05-04','11:30:00',3.19),('5819','2013-05-04','11:35:00',3.33),('5819','2013-05-04','11:40:00',3.21),('5819','2013-05-04','11:45:00',3.26),('5819','2013-05-04','11:50:00',3.31),('5819','2013-05-04','11:55:00',3.26),('5819','2013-05-04','12:00:00',3.22),('5819','2013-05-04','12:05:00',3.34),('5819','2013-05-04','12:10:00',3.37),('5819','2013-05-04','12:15:00',3.41),('5819','2013-05-04','12:20:00',3.5),('5819','2013-05-04','12:25:00',3.56),('5819','2013-05-04','12:30:00',3.55),('5819','2013-05-04','12:35:00',3.61),('5819','2013-05-04','12:40:00',3.59),('5819','2013-05-04','12:45:00',3.6),('5819','2013-05-04','12:50:00',3.5),('5819','2013-05-04','12:55:00',3.42),('5819','2013-05-04','13:00:00',3.37),('5819','2013-05-04','13:05:00',3.11),('5819','2013-05-04','13:10:00',3.17),('5819','2013-05-04','13:15:00',3.64),('5819','2013-05-04','13:20:00',3.7),('5819','2013-05-04','13:25:00',3.52),('5819','2013-05-04','13:30:00',3.48),('5819','2013-05-04','13:35:00',3.36),('5819','2013-05-04','13:40:00',3.42),('5819','2013-05-04','13:45:00',3.38),('5819','2013-05-04','13:50:00',2.98),('5819','2013-05-04','13:55:00',3.17),('5819','2013-05-04','14:00:00',3.23),('5819','2013-05-04','14:05:00',3.32),('5819','2013-05-04','14:10:00',3.14),('5819','2013-05-04','14:15:00',3.17),('5819','2013-05-04','14:20:00',3.24),('5819','2013-05-04','14:25:00',2.92),('5819','2013-05-04','14:30:00',3.1),('5819','2013-05-04','14:35:00',2.9),('5819','2013-05-04','14:40:00',3),('5819','2013-05-04','14:45:00',2.97),('5819','2013-05-04','14:50:00',2.79),('5819','2013-05-04','14:55:00',2.88),('5819','2013-05-04','15:00:00',2.9),('5819','2013-05-04','15:05:00',3.01),('5819','2013-05-04','15:10:00',2.78),('5819','2013-05-04','15:15:00',2.83),('5819','2013-05-04','15:20:00',2.84),('5819','2013-05-04','15:25:00',2.88),('5819','2013-05-04','15:30:00',2.82),('5819','2013-05-04','15:35:00',2.7),('5819','2013-05-04','15:40:00',2.61),('5819','2013-05-04','15:45:00',2.65),('5819','2013-05-04','15:50:00',2.6),('5819','2013-05-04','15:55:00',2.55),('5819','2013-05-04','16:00:00',2.49),('5819','2013-05-04','16:05:00',2.43),('5819','2013-05-04','16:10:00',2.37),('5819','2013-05-04','16:15:00',2.3),('5819','2013-05-04','16:20:00',2.22),('5819','2013-05-04','16:25:00',2.16),('5819','2013-05-04','16:30:00',2.09),('5819','2013-05-04','16:35:00',2.03),('5819','2013-05-04','16:40:00',1.96),('5819','2013-05-04','16:45:00',1.88),('5819','2013-05-04','16:50:00',1.79),('5819','2013-05-04','16:55:00',1.73),('5819','2013-05-04','17:00:00',1.67),('5819','2013-05-04','17:05:00',1.58),('5819','2013-05-04','17:10:00',1.25),('5819','2013-05-04','17:15:00',1.36),('5819','2013-05-04','17:20:00',1.41),('5819','2013-05-04','17:25:00',1.33),('5819','2013-05-04','17:30:00',1.23),('5819','2013-05-04','17:35:00',1.02),('5819','2013-05-04','17:40:00',1.03),('5819','2013-05-03','08:05:00',1.43),('5819','2013-05-03','08:10:00',1.7),('5819','2013-05-03','08:15:00',1.94),('5819','2013-05-03','08:20:00',1.89),('5819','2013-05-03','08:25:00',2.03),('5819','2013-05-03','08:30:00',2.1),('5819','2013-05-03','08:35:00',2.15),('5819','2013-05-03','08:40:00',2.2),('5819','2013-05-03','08:45:00',2.27),('5819','2013-05-03','08:50:00',2.25),('5819','2013-05-03','08:55:00',2.25),('5819','2013-05-03','09:00:00',2.41),('5819','2013-05-03','09:05:00',2.55),('5819','2013-05-03','09:10:00',2.55),('5819','2013-05-03','09:15:00',2.63),('5819','2013-05-03','09:20:00',2.7),('5819','2013-05-03','09:25:00',2.75),('5819','2013-05-03','09:30:00',2.8),('5819','2013-05-03','09:35:00',2.89),('5819','2013-05-03','09:40:00',2.96),('5819','2013-05-03','09:45:00',3.01),('5819','2013-05-03','09:50:00',3.08),('5819','2013-05-03','09:55:00',3.11),('5819','2013-05-03','10:00:00',3.17),('5819','2013-05-03','10:05:00',3.22),('5819','2013-05-03','10:10:00',3.28),('5819','2013-05-03','10:15:00',3.31),('5819','2013-05-03','10:20:00',3.34),('5819','2013-05-03','10:25:00',3.36),('5819','2013-05-03','10:30:00',3.41),('5819','2013-05-03','10:35:00',3.42),('5819','2013-05-03','10:40:00',3.43),('5819','2013-05-03','10:45:00',3.49),('5819','2013-05-03','10:50:00',3.53),('5819','2013-05-03','10:55:00',3.55),('5819','2013-05-03','11:00:00',3.57),('5819','2013-05-03','11:05:00',3.61),('5819','2013-05-03','11:10:00',3.64),('5819','2013-05-03','11:15:00',3.64),('5819','2013-05-03','11:20:00',3.68),('5819','2013-05-03','11:25:00',3.7),('5819','2013-05-03','11:30:00',3.69),('5819','2013-05-03','11:35:00',3.72),('5819','2013-05-03','11:40:00',3.73),('5819','2013-05-03','11:45:00',3.73),('5819','2013-05-03','11:50:00',3.76),('5819','2013-05-03','11:55:00',3.77),('5819','2013-05-03','12:00:00',3.76),('5819','2013-05-03','12:05:00',3.75),('5819','2013-05-03','12:10:00',3.79),('5819','2013-05-03','12:15:00',3.8),('5819','2013-05-03','12:20:00',3.79),('5819','2013-05-03','12:25:00',3.82),('5819','2013-05-03','12:30:00',3.8),('5819','2013-05-03','12:35:00',3.76),('5819','2013-05-03','12:40:00',3.74),('5819','2013-05-03','12:45:00',3.75),('5819','2013-05-03','12:50:00',3.77),('5819','2013-05-03','12:55:00',3.83),('5819','2013-05-03','13:00:00',3.78),('5819','2013-05-03','13:05:00',3.74),('5819','2013-05-03','13:10:00',3.76),('5819','2013-05-03','13:15:00',3.73),('5819','2013-05-03','13:20:00',3.77),('5819','2013-05-03','13:25:00',3.74),('5819','2013-05-03','13:30:00',3.71),('5819','2013-05-03','13:35:00',3.66),('5819','2013-05-03','13:40:00',3.51),('5819','2013-05-03','13:45:00',3.5),('5819','2013-05-03','13:50:00',3.48),('5819','2013-05-03','13:55:00',3.49),('5819','2013-05-03','14:00:00',3.46),('5819','2013-05-03','14:05:00',3.3),('5819','2013-05-03','14:10:00',3.32),('5819','2013-05-03','14:15:00',3.22),('5819','2013-05-03','14:20:00',3.32),('5819','2013-05-03','14:25:00',3.29),('5819','2013-05-03','14:30:00',3.3),('5819','2013-05-03','14:35:00',3.31),('5819','2013-05-03','14:40:00',3.22),('5819','2013-05-03','14:45:00',3.19),('5819','2013-05-03','14:50:00',3.17),('5819','2013-05-03','14:55:00',3.14),('5819','2013-05-03','15:00:00',3.11),('5819','2013-05-03','15:05:00',3.08),('5819','2013-05-03','15:10:00',3.08),('5819','2013-05-03','15:15:00',3.06),('5819','2013-05-03','15:20:00',2.99),('5819','2013-05-03','15:25:00',2.95),('5819','2013-05-03','15:30:00',2.9),('5819','2013-05-03','15:35:00',2.87),('5819','2013-05-03','15:40:00',2.8),('5819','2013-05-03','15:45:00',2.76),('5819','2013-05-03','15:50:00',2.69),('5819','2013-05-03','15:55:00',2.61),('5819','2013-05-03','16:00:00',2.58),('5819','2013-05-03','16:05:00',2.52),('5819','2013-05-03','16:10:00',2.45),('5819','2013-05-03','16:15:00',2.37),('5819','2013-05-03','16:20:00',2.28),('5819','2013-05-03','16:25:00',2.19),('5819','2013-05-03','16:30:00',2.19),('5819','2013-05-03','16:35:00',2.12),('5819','2013-05-03','16:40:00',2.05),('5819','2013-05-03','16:45:00',1.96),('5819','2013-05-03','16:50:00',1.88),('5819','2013-05-03','16:55:00',1.8),('5819','2013-05-03','17:00:00',1.74),('5819','2013-05-03','17:05:00',1.65),('5819','2013-05-03','17:10:00',1.58),('5819','2013-05-03','17:15:00',1.5),('5819','2013-05-03','17:20:00',1.39),('5819','2013-05-03','17:25:00',1.29),('5819','2013-05-03','17:30:00',1.21),('5819','2013-05-03','17:35:00',1.08),('5819','2013-05-03','17:40:00',1.05),('5819','2013-05-02','08:55:00',1.08),('5819','2013-05-02','09:00:00',1.89),('5819','2013-05-02','09:05:00',1.86),('5819','2013-05-02','09:25:00',1.5),('5819','2013-05-02','09:30:00',1.83),('5819','2013-05-02','09:35:00',2.14),('5819','2013-05-02','09:40:00',1.4),('5819','2013-05-02','09:45:00',2.52),('5819','2013-05-02','09:50:00',1.26),('5819','2013-05-02','10:05:00',1.39),('5819','2013-05-02','10:10:00',1.45),('5819','2013-05-02','10:15:00',1.46),('5819','2013-05-02','10:20:00',1.5),('5819','2013-05-02','10:25:00',1.82),('5819','2013-05-02','10:30:00',3.01),('5819','2013-05-02','10:35:00',2.58),('5819','2013-05-02','10:40:00',3.5),('5819','2013-05-02','10:45:00',2.83),('5819','2013-05-02','10:50:00',3.24),('5819','2013-05-02','10:55:00',3.76),('5819','2013-05-02','11:00:00',3.87),('5819','2013-05-02','11:05:00',3.66),('5819','2013-05-02','11:10:00',2.93),('5819','2013-05-02','11:15:00',2.76),('5819','2013-05-02','11:20:00',2.51),('5819','2013-05-02','11:25:00',3.81),('5819','2013-05-02','11:30:00',3.82),('5819','2013-05-02','11:35:00',3.79),('5819','2013-05-02','11:40:00',3.71),('5819','2013-05-02','11:45:00',3.7),('5819','2013-05-02','11:50:00',3.71),('5819','2013-05-02','11:55:00',3.7),('5819','2013-05-02','12:00:00',3.69),('5819','2013-05-02','12:05:00',3.65),('5819','2013-05-02','12:10:00',3.63),('5819','2013-05-02','12:15:00',3.67),('5819','2013-05-02','12:20:00',3.7),('5819','2013-05-02','12:25:00',3.68),('5819','2013-05-02','12:30:00',3.74),('5819','2013-05-02','12:35:00',3.79),('5819','2013-05-02','12:40:00',3.82),('5819','2013-05-02','12:45:00',3.84),('5819','2013-05-02','12:50:00',3.85),('5819','2013-05-02','12:55:00',3.86),('5819','2013-05-02','13:00:00',3.91),('5819','2013-05-02','13:05:00',3.89),('5819','2013-05-02','13:10:00',3.91),('5819','2013-05-02','13:15:00',3.91),('5819','2013-05-02','13:20:00',3.9),('5819','2013-05-02','13:25:00',3.88),('5819','2013-05-02','13:30:00',3.88),('5819','2013-05-02','13:35:00',3.86),('5819','2013-05-02','13:40:00',3.82),('5819','2013-05-02','13:45:00',3.79),('5819','2013-05-02','13:50:00',3.76),('5819','2013-05-02','13:55:00',3.75),('5819','2013-05-02','14:00:00',3.71),('5819','2013-05-02','14:05:00',3.63),('5819','2013-05-02','14:10:00',3.61),('5819','2013-05-02','14:15:00',3.6),('5819','2013-05-02','14:20:00',3.57),('5819','2013-05-02','14:25:00',3.53),('5819','2013-05-02','14:30:00',3.5),('5819','2013-05-02','14:35:00',3.46),('5819','2013-05-02','14:40:00',3.42),('5819','2013-05-02','14:45:00',3.4),('5819','2013-05-02','14:50:00',3.36),('5819','2013-05-02','14:55:00',3.31),('5819','2013-05-02','15:00:00',3.27),('5819','2013-05-02','15:05:00',3.22),('5819','2013-05-02','15:10:00',3.18),('5819','2013-05-02','15:15:00',3.12),('5819','2013-05-02','15:20:00',3.06),('5819','2013-05-02','15:25:00',3),('5819','2013-05-02','15:30:00',2.92),('5819','2013-05-02','15:35:00',2.83),('5819','2013-05-02','15:40:00',2.79),('5819','2013-05-02','15:45:00',2.71),('5819','2013-05-02','15:50:00',2.67),('5819','2013-05-02','15:55:00',2.62),('5819','2013-05-02','16:00:00',2.55),('5819','2013-05-02','16:05:00',2.5),('5819','2013-05-02','16:10:00',2.45),('5819','2013-05-02','16:15:00',2.38),('5819','2013-05-02','16:20:00',2.32),('5819','2013-05-02','16:25:00',2.24),('5819','2013-05-02','16:30:00',2.17),('5819','2013-05-02','16:35:00',2.08),('5819','2013-05-02','16:40:00',2.02),('5819','2013-05-02','16:45:00',1.94),('5819','2013-05-02','16:50:00',1.88),('5819','2013-05-02','16:55:00',1.8),('5819','2013-05-02','17:00:00',1.73),('5819','2013-05-02','17:05:00',1.67),('5819','2013-05-02','17:10:00',1.59),('5819','2013-05-02','17:15:00',1.52),('5819','2013-05-02','17:20:00',1.45),('5819','2013-05-02','17:25:00',1.37),('5819','2013-05-02','17:30:00',1.27),('5819','2013-05-02','17:35:00',1.06),('5819','2013-05-02','17:40:00',1.04),('5819','2013-05-02','17:45:00',1.05),('5819','2013-05-01','07:50:00',1.06),('5819','2013-05-01','07:55:00',1.14),('5819','2013-05-01','08:00:00',1.23),('5819','2013-05-01','08:05:00',1.3),('5819','2013-05-01','08:10:00',1.35),('5819','2013-05-01','08:15:00',1.44),('5819','2013-05-01','08:20:00',1.55),('5819','2013-05-01','08:25:00',1.65),('5819','2013-05-01','08:30:00',1.74),('5819','2013-05-01','08:35:00',1.85),('5819','2013-05-01','08:40:00',1.92),('5819','2013-05-01','08:45:00',1.98),('5819','2013-05-01','08:50:00',2.07),('5819','2013-05-01','08:55:00',2.16),('5819','2013-05-01','09:00:00',2.26),('5819','2013-05-01','09:05:00',2.32),('5819','2013-05-01','09:10:00',2.37),('5819','2013-05-01','09:15:00',2.43),('5819','2013-05-01','09:20:00',2.46),('5819','2013-05-01','09:25:00',2.51),('5819','2013-05-01','09:30:00',2.54),('5819','2013-05-01','09:35:00',2.58),('5819','2013-05-01','09:40:00',2.65),('5819','2013-05-01','09:45:00',2.71),('5819','2013-05-01','09:50:00',2.77),('5819','2013-05-01','09:55:00',2.82),('5819','2013-05-01','10:00:00',2.85),('5819','2013-05-01','10:05:00',2.86),('5819','2013-05-01','10:10:00',2.93),('5819','2013-05-01','10:15:00',3.01),('5819','2013-05-01','10:20:00',3.06),('5819','2013-05-01','10:25:00',3.1),('5819','2013-05-01','10:30:00',3.14),('5819','2013-05-01','10:35:00',3.17),('5819','2013-05-01','10:40:00',3.27),('5819','2013-05-01','10:45:00',3.42),('5819','2013-05-01','10:50:00',3.45),('5819','2013-05-01','10:55:00',3.46),('5819','2013-05-01','11:00:00',3.45),('5819','2013-05-01','11:05:00',3.48),('5819','2013-05-01','11:10:00',3.5),('5819','2013-05-01','11:15:00',3.29),('5819','2013-05-01','11:20:00',3.28),('5819','2013-05-01','11:25:00',3.23),('5819','2013-05-01','11:30:00',3.15),('5819','2013-05-01','11:35:00',3.27),('5819','2013-05-01','11:40:00',2.73),('5819','2013-05-01','11:45:00',2.52),('5819','2013-05-01','11:50:00',3.02),('5819','2013-05-01','11:55:00',3.71),('5819','2013-05-01','12:00:00',3.65),('5819','2013-05-01','12:05:00',3.61),('5819','2013-05-01','12:10:00',3.6),('5819','2013-05-01','12:15:00',3.57),('5819','2013-05-01','12:20:00',3.57),('5819','2013-05-01','12:25:00',3.61),('5819','2013-05-01','12:30:00',3.63),('5819','2013-05-01','12:35:00',3.67),('5819','2013-05-01','12:40:00',3.74),('5819','2013-05-01','12:45:00',3.59),('5819','2013-05-01','12:50:00',2.99),('5819','2013-05-01','12:55:00',1.44),('5819','2013-05-01','13:00:00',1.41),('5819','2013-05-01','13:05:00',1.61),('5819','2013-05-01','13:10:00',1.96),('5819','2013-05-01','13:15:00',3.34),('5819','2013-05-01','13:20:00',4.31),('5819','2013-05-01','13:25:00',3.53),('5819','2013-05-01','13:30:00',2.32),('5819','2013-05-01','13:35:00',3.02),('5819','2013-05-01','13:40:00',3.4),('5819','2013-05-01','13:45:00',4.06),('5819','2013-05-01','13:50:00',3.8),('5819','2013-05-01','13:55:00',3.66),('5819','2013-05-01','14:00:00',3.52),('5819','2013-05-01','14:05:00',3.4),('5819','2013-05-01','14:10:00',3.37),('5819','2013-05-01','14:15:00',2.94),('5819','2013-05-01','14:20:00',3.48),('5819','2013-05-01','14:25:00',3.49),('5819','2013-05-01','14:30:00',3.49),('5819','2013-05-01','14:35:00',3.41),('5819','2013-05-01','14:40:00',3),('5819','2013-05-01','14:45:00',3.19),('5819','2013-05-01','14:50:00',2.73),('5819','2013-05-01','14:55:00',2.56),('5819','2013-05-01','15:00:00',2.58),('5819','2013-05-01','15:05:00',3.01),('5819','2013-05-01','15:10:00',3.04),('5819','2013-05-01','15:15:00',2.94),('5819','2013-05-01','15:20:00',2.78),('5819','2013-05-01','15:25:00',2.88),('5819','2013-05-01','15:30:00',2.46),('5819','2013-05-01','15:35:00',2.08),('5819','2013-05-01','15:40:00',2.07),('5819','2013-05-01','15:45:00',2.03),('5819','2013-05-01','15:50:00',1.58),('5819','2013-05-01','15:55:00',1.47),('5819','2013-05-01','16:00:00',1.77),('5819','2013-05-01','16:05:00',1.76),('5819','2013-05-01','16:10:00',1.56),('5819','2013-05-01','16:15:00',1.41),('5819','2013-05-01','16:20:00',1.26),('5819','2013-05-01','16:40:00',1.03),('5819','2013-04-30','08:55:00',1.47),('5819','2013-04-30','09:00:00',1.86),('5819','2013-04-30','09:05:00',1.63),('5819','2013-04-30','09:10:00',2.15),('5819','2013-04-30','09:15:00',2.69),('5819','2013-04-30','09:20:00',2.63),('5819','2013-04-30','09:25:00',2.84),('5819','2013-04-30','09:30:00',2.79),('5819','2013-04-30','09:35:00',2.37),('5819','2013-04-30','09:40:00',1.71),('5819','2013-04-30','09:45:00',1.89),('5819','2013-04-30','09:50:00',2.57),('5819','2013-04-30','09:55:00',2.83),('5819','2013-04-30','10:00:00',3.21),('5819','2013-04-30','10:05:00',3.34),('5819','2013-04-30','10:10:00',2.71),('5819','2013-04-30','10:15:00',2.38),('5819','2013-04-30','10:20:00',2.21),('5819','2013-04-30','10:25:00',2.36),('5819','2013-04-30','10:30:00',1.97),('5819','2013-04-30','10:35:00',1.9),('5819','2013-04-30','10:40:00',1.57),('5819','2013-04-30','10:45:00',1.23),('5819','2013-04-30','10:50:00',1.32),('5819','2013-04-30','10:55:00',1.42),('5819','2013-04-30','11:00:00',1.42),('5819','2013-04-30','11:05:00',1.58),('5819','2013-04-30','11:10:00',1.65),('5819','2013-04-30','11:15:00',1.7),('5819','2013-04-30','11:20:00',1.99),('5819','2013-04-30','11:25:00',1.84),('5819','2013-04-30','11:30:00',1.78),('5819','2013-04-30','11:35:00',1.86),('5819','2013-04-30','11:40:00',1.89),('5819','2013-04-30','11:45:00',1.59),('5819','2013-04-30','11:50:00',1.63),('5819','2013-04-30','11:55:00',1.66),('5819','2013-04-30','12:00:00',1.66),('5819','2013-04-30','12:05:00',1.67),('5819','2013-04-30','12:10:00',1.64),('5819','2013-04-30','12:15:00',1.52),('5819','2013-04-30','12:20:00',1.35),('5819','2013-04-30','12:25:00',1.23),('5819','2013-04-30','12:30:00',1.22),('5819','2013-04-30','12:35:00',1.99),('5819','2013-04-30','12:40:00',3.85),('5819','2013-04-30','12:45:00',4.22),('5819','2013-04-30','12:50:00',4.01),('5819','2013-04-30','12:55:00',3.66),('5819','2013-04-30','13:00:00',3.76),('5819','2013-04-30','13:05:00',3.7),('5819','2013-04-30','13:10:00',3.79),('5819','2013-04-30','13:15:00',3.72),('5819','2013-04-30','13:20:00',3.66),('5819','2013-04-30','13:25:00',3.64),('5819','2013-04-30','13:30:00',3.59),('5819','2013-04-30','13:35:00',3.59),('5819','2013-04-30','13:40:00',3.53),('5819','2013-04-30','13:45:00',3.5),('5819','2013-04-30','13:50:00',3.45),('5819','2013-04-30','13:55:00',3.41),('5819','2013-04-30','14:00:00',3.38),('5819','2013-04-30','14:05:00',3.35),('5819','2013-04-30','14:10:00',3.32),('5819','2013-04-30','14:15:00',3.29),('5819','2013-04-30','14:20:00',3.28),('5819','2013-04-30','14:25:00',3.27),('5819','2013-04-30','14:30:00',3.22),('5819','2013-04-30','14:35:00',3.19),('5819','2013-04-30','14:40:00',3.15),('5819','2013-04-30','14:45:00',3.1),('5819','2013-04-30','14:50:00',3.05),('5819','2013-04-30','14:55:00',2.99),('5819','2013-04-30','15:00:00',2.94),('5819','2013-04-30','15:05:00',2.89),('5819','2013-04-30','15:10:00',2.85),('5819','2013-04-30','15:15:00',2.8),('5819','2013-04-30','15:20:00',2.76),('5819','2013-04-30','15:25:00',2.7),('5819','2013-04-30','15:30:00',2.64),('5819','2013-04-30','15:35:00',2.62),('5819','2013-04-30','15:40:00',2.57),('5819','2013-04-30','15:45:00',2.51),('5819','2013-04-30','15:50:00',2.43),('5819','2013-04-30','15:55:00',2.37),('5819','2013-04-30','16:00:00',2.32),('5819','2013-04-30','16:05:00',2.26),('5819','2013-04-30','16:10:00',2.2),('5819','2013-04-30','16:15:00',2.14),('5819','2013-04-30','16:20:00',2.08),('5819','2013-04-30','16:25:00',2.01),('5819','2013-04-30','16:30:00',1.96),('5819','2013-04-30','16:35:00',1.88),('5819','2013-04-30','16:40:00',1.62),('5819','2013-04-30','16:45:00',1.66),('5819','2013-04-30','16:50:00',1.37),('5819','2013-04-30','16:55:00',1.57),('5819','2013-04-30','17:00:00',1.47),('5819','2013-04-30','17:05:00',1.47),('5819','2013-04-30','17:10:00',1.31),('5819','2013-04-30','17:20:00',1),('5819','2013-04-30','17:25:00',1.19),('5819','2013-04-30','17:30:00',1.11),('5819','2013-04-30','17:35:00',1.02),('5819','2013-04-29','07:55:00',1.1),('5819','2013-04-29','08:00:00',1.32),('5819','2013-04-29','08:05:00',1.42),('5819','2013-04-29','08:10:00',1.37),('5819','2013-04-29','08:15:00',1.39),('5819','2013-04-29','08:20:00',1.5),('5819','2013-04-29','08:25:00',1.7),('5819','2013-04-29','08:30:00',1.92),('5819','2013-04-29','08:35:00',2.16),('5819','2013-04-29','08:40:00',2.2),('5819','2013-04-29','08:45:00',2.11),('5819','2013-04-29','08:50:00',2.27),('5819','2013-04-29','08:55:00',2.28),('5819','2013-04-29','09:00:00',1.7),('5819','2013-04-29','09:05:00',2.27),('5819','2013-04-29','09:10:00',2.59),('5819','2013-04-29','09:15:00',2.75),('5819','2013-04-29','09:20:00',2.62),('5819','2013-04-29','09:25:00',2.5),('5819','2013-04-29','09:30:00',2.49),('5819','2013-04-29','09:35:00',2.64),('5819','2013-04-29','09:40:00',2.64),('5819','2013-04-29','09:45:00',2.72),('5819','2013-04-29','09:50:00',2.93),('5819','2013-04-29','09:55:00',2.68),('5819','2013-04-29','10:00:00',2.81),('5819','2013-04-29','10:05:00',2.81),('5819','2013-04-29','10:10:00',2.77),('5819','2013-04-29','10:15:00',2.35),('5819','2013-04-29','10:20:00',2.23),('5819','2013-04-29','10:25:00',2.76),('5819','2013-04-29','10:30:00',2.68),('5819','2013-04-29','10:35:00',3.18),('5819','2013-04-29','10:40:00',3.22),('5819','2013-04-29','10:45:00',3.27),('5819','2013-04-29','10:50:00',3.12),('5819','2013-04-29','10:55:00',2.9),('5819','2013-04-29','11:00:00',3.22),('5819','2013-04-29','11:05:00',3.19),('5819','2013-04-29','11:10:00',3.05),('5819','2013-04-29','11:15:00',2.84),('5819','2013-04-29','11:20:00',3.29),('5819','2013-04-29','11:25:00',3.4),('5819','2013-04-29','11:30:00',3.54),('5819','2013-04-29','11:35:00',3.4),('5819','2013-04-29','11:40:00',3.42),('5819','2013-04-29','11:45:00',3.37),('5819','2013-04-29','11:50:00',3.64),('5819','2013-04-29','11:55:00',3.62),('5819','2013-04-29','12:00:00',3.72),('5819','2013-04-29','12:05:00',3.75),('5819','2013-04-29','12:10:00',3.62),('5819','2013-04-29','12:15:00',3.61),('5819','2013-04-29','12:20:00',3.66),('5819','2013-04-29','12:25:00',3.54),('5819','2013-04-29','12:30:00',3.63),('5819','2013-04-29','12:35:00',3.68),('5819','2013-04-29','12:40:00',3.76),('5819','2013-04-29','12:45:00',3.76),('5819','2013-04-29','12:50:00',3.78),('5819','2013-04-29','12:55:00',3.66),('5819','2013-04-29','13:00:00',3.73),('5819','2013-04-29','13:05:00',3.69),('5819','2013-04-29','13:10:00',3.55),('5819','2013-04-29','13:15:00',3.36),('5819','2013-04-29','13:20:00',3.54),('5819','2013-04-29','13:25:00',3.74),('5819','2013-04-29','13:30:00',3.68),('5819','2013-04-29','13:35:00',3.59),('5819','2013-04-29','13:40:00',3.63),('5819','2013-04-29','13:45:00',3.58),('5819','2013-04-29','13:50:00',3.41),('5819','2013-04-29','13:55:00',3.73),('5819','2013-04-29','14:00:00',3.48),('5819','2013-04-29','14:05:00',3.44),('5819','2013-04-29','14:10:00',3.49),('5819','2013-04-29','14:15:00',3.54),('5819','2013-04-29','14:20:00',3.54),('5819','2013-04-29','14:25:00',3.43),('5819','2013-04-29','14:30:00',3.27),('5819','2013-04-29','14:35:00',3.17),('5819','2013-04-29','14:40:00',3.02),('5819','2013-04-29','14:45:00',3.23),('5819','2013-04-29','14:50:00',3.12),('5819','2013-04-29','14:55:00',3.16),('5819','2013-04-29','15:00:00',3.03),('5819','2013-04-29','15:05:00',3.21),('5819','2013-04-29','15:10:00',2.95),('5819','2013-04-29','15:15:00',2.72),('5819','2013-04-29','15:20:00',2.84),('5819','2013-04-29','15:25:00',3.03),('5819','2013-04-29','15:30:00',2.94),('5819','2013-04-29','15:35:00',2.61),('5819','2013-04-29','15:40:00',2.37),('5819','2013-04-29','15:45:00',2.26),('5819','2013-04-29','15:50:00',2.29),('5819','2013-04-29','15:55:00',2.44),('5819','2013-04-29','16:00:00',2.37),('5819','2013-04-29','16:05:00',2.54),('5819','2013-04-29','16:10:00',2.39),('5819','2013-04-29','16:15:00',2.72),('5819','2013-04-29','16:20:00',2.68),('5819','2013-04-29','16:25:00',2.06),('5819','2013-04-29','16:30:00',2.14),('5819','2013-04-29','16:35:00',2.11),('5819','2013-04-29','16:40:00',2.22),('5819','2013-04-29','16:45:00',2.15),('5819','2013-04-29','16:50:00',2.18),('5819','2013-04-29','16:55:00',2.24),('5819','2013-04-29','17:00:00',2.06),('5819','2013-04-29','17:05:00',1.76),('5819','2013-04-29','17:10:00',1.79),('5819','2013-04-29','17:15:00',1.57),('5819','2013-04-29','17:20:00',1.27),('5819','2013-04-29','17:25:00',1.25),('5819','2013-04-29','17:30:00',1.14),('5819','2013-04-29','17:35:00',1.02),('5819','2013-04-29','17:55:00',1.05),('5819','2013-04-29','18:00:00',1.02),('5819','2013-04-29','18:05:00',1.05),('5819','2013-04-28','07:35:00',1.02),('5819','2013-04-28','07:40:00',1.12),('5819','2013-04-28','07:45:00',1.21),('5819','2013-04-28','07:50:00',1.3),('5819','2013-04-28','07:55:00',1.37),('5819','2013-04-28','08:00:00',1.44),('5819','2013-04-28','08:05:00',1.55),('5819','2013-04-28','08:10:00',1.65),('5819','2013-04-28','08:15:00',1.74),('5819','2013-04-28','08:20:00',1.83),('5819','2013-04-28','08:25:00',1.92),('5819','2013-04-28','08:30:00',1.99),('5819','2013-04-28','08:35:00',2.06),('5819','2013-04-28','08:40:00',2.13),('5819','2013-04-28','08:45:00',2.21),('5819','2013-04-28','08:50:00',2.29),('5819','2013-04-28','08:55:00',2.34),('5819','2013-04-28','09:00:00',2.44),('5819','2013-04-28','09:05:00',2.51),('5819','2013-04-28','09:10:00',2.59),('5819','2013-04-28','09:15:00',2.65),('5819','2013-04-28','09:20:00',2.71),('5819','2013-04-28','09:25:00',2.78),('5819','2013-04-28','09:30:00',2.82),('5819','2013-04-28','09:35:00',2.91),('5819','2013-04-28','09:40:00',2.95),('5819','2013-04-28','09:45:00',3.03),('5819','2013-04-28','09:50:00',3.09),('5819','2013-04-28','09:55:00',3.15),('5819','2013-04-28','10:00:00',3.17),('5819','2013-04-28','10:05:00',3.19),('5819','2013-04-28','10:10:00',3.29),('5819','2013-04-28','10:15:00',3.23),('5819','2013-04-28','10:20:00',3.33),('5819','2013-04-28','10:25:00',3.43),('5819','2013-04-28','10:30:00',3.35),('5819','2013-04-28','10:35:00',3.43),('5819','2013-04-28','10:40:00',3.14),('5819','2013-04-28','10:45:00',3.57),('5819','2013-04-28','10:50:00',3.56),('5819','2013-04-28','10:55:00',3.58),('5819','2013-04-28','11:00:00',3.6),('5819','2013-04-28','11:05:00',3.6),('5819','2013-04-28','11:10:00',3.66),('5819','2013-04-28','11:15:00',3.66),('5819','2013-04-28','11:20:00',3.69),('5819','2013-04-28','11:25:00',3.75),('5819','2013-04-28','11:30:00',3.76),('5819','2013-04-28','11:35:00',3.65),('5819','2013-04-28','11:40:00',3.65),('5819','2013-04-28','11:45:00',3.54),('5819','2013-04-28','11:50:00',3.57),('5819','2013-04-28','11:55:00',3.7),('5819','2013-04-28','12:00:00',3.27),('5819','2013-04-28','12:05:00',3.22),('5819','2013-04-28','12:10:00',3.53),('5819','2013-04-28','12:15:00',3.71),('5819','2013-04-28','12:20:00',3.6),('5819','2013-04-28','12:25:00',3.2),('5819','2013-04-28','12:30:00',3.12),('5819','2013-04-28','12:35:00',2.8),('5819','2013-04-28','12:40:00',2.83),('5819','2013-04-28','12:45:00',3.6),('5819','2013-04-28','12:50:00',3.8),('5819','2013-04-28','12:55:00',3.46),('5819','2013-04-28','13:00:00',3.58),('5819','2013-04-28','13:05:00',3.82),('5819','2013-04-28','13:10:00',3.76),('5819','2013-04-28','13:15:00',3.51),('5819','2013-04-28','13:20:00',3.54),('5819','2013-04-28','13:25:00',3.52),('5819','2013-04-28','13:30:00',3.68),('5819','2013-04-28','13:35:00',3.67),('5819','2013-04-28','13:40:00',3.89),('5819','2013-04-28','13:45:00',3.8),('5819','2013-04-28','13:50:00',3.6),('5819','2013-04-28','13:55:00',3.42),('5819','2013-04-28','14:00:00',3.58),('5819','2013-04-28','14:05:00',3.58),('5819','2013-04-28','14:10:00',3.46),('5819','2013-04-28','14:15:00',3.53),('5819','2013-04-28','14:20:00',3.34),('5819','2013-04-28','14:25:00',3.17),('5819','2013-04-28','14:30:00',3.39),('5819','2013-04-28','14:35:00',3.38),('5819','2013-04-28','14:40:00',3.32),('5819','2013-04-28','14:45:00',3.27),('5819','2013-04-28','14:50:00',3.23),('5819','2013-04-28','14:55:00',3.19),('5819','2013-04-28','15:00:00',3.15),('5819','2013-04-28','15:05:00',3.1),('5819','2013-04-28','15:10:00',3.08),('5819','2013-04-28','15:15:00',3.07),('5819','2013-04-28','15:20:00',3.02),('5819','2013-04-28','15:25:00',2.95),('5819','2013-04-28','15:30:00',2.89),('5819','2013-04-28','15:35:00',2.83),('5819','2013-04-28','15:40:00',2.77),('5819','2013-04-28','15:45:00',2.73),('5819','2013-04-28','15:50:00',2.68),('5819','2013-04-28','15:55:00',2.62),('5819','2013-04-28','16:00:00',2.55),('5819','2013-04-28','16:05:00',2.49),('5819','2013-04-28','16:10:00',2.43),('5819','2013-04-28','16:15:00',2.35),('5819','2013-04-28','16:20:00',2.28),('5819','2013-04-28','16:25:00',2.21),('5819','2013-04-28','16:30:00',2.14),('5819','2013-04-28','16:35:00',2.07),('5819','2013-04-28','16:40:00',2),('5819','2013-04-28','16:45:00',1.93),('5819','2013-04-28','16:50:00',1.87),('5819','2013-04-28','16:55:00',1.79),('5819','2013-04-28','17:00:00',1.71),('5819','2013-04-28','17:05:00',1.59),('5819','2013-04-28','17:10:00',1.48),('5819','2013-04-28','17:15:00',1.51),('5819','2013-04-28','17:20:00',1.43),('5819','2013-04-28','17:25:00',1.36),('5819','2013-04-28','17:30:00',1.11),('5819','2013-04-28','17:40:00',1),('5819','2013-04-28','17:45:00',1.03),('5819','2013-04-27','12:55:00',1.16),('5819','2013-04-27','13:00:00',1.35),('5819','2013-04-27','13:05:00',1.08),('5819','2013-04-27','13:10:00',1.06),('5819','2013-04-27','13:15:00',1.3),('5819','2013-04-27','13:20:00',1.34),('5819','2013-04-27','13:25:00',1.09),('5819','2013-04-27','13:30:00',1.06),('5819','2013-04-27','13:35:00',1.29),('5819','2013-04-27','13:40:00',1.67),('5819','2013-04-27','13:45:00',1.07),('5819','2013-04-27','14:25:00',1.1),('5819','2013-04-27','14:30:00',1.98),('5819','2013-04-27','14:35:00',1.86),('5819','2013-04-27','14:40:00',1.19),('5819','2013-04-27','14:45:00',1.24),('5819','2013-04-27','15:05:00',1.33),('5819','2013-04-27','15:10:00',1.15),('5819','2013-04-27','15:15:00',1.07),('5819','2013-04-27','16:45:00',1.02),('5819','2013-04-27','16:50:00',1.57),('5819','2013-04-27','16:55:00',1.62),('5819','2013-04-27','17:00:00',2.11),('5819','2013-04-27','17:05:00',1.61),('5819','2013-04-26','08:05:00',1.01),('5819','2013-04-26','08:10:00',1.33),('5819','2013-04-26','08:15:00',1.46),('5819','2013-04-26','08:20:00',1.51),('5819','2013-04-26','08:25:00',1.59),('5819','2013-04-26','08:30:00',1.63),('5819','2013-04-26','08:35:00',1.77),('5819','2013-04-26','08:40:00',1.83),('5819','2013-04-26','08:45:00',1.92),('5819','2013-04-26','08:50:00',1.97),('5819','2013-04-26','08:55:00',1.71),('5819','2013-04-26','09:00:00',1.22),('5819','2013-04-26','09:05:00',1.68),('5819','2013-04-26','09:10:00',1.97),('5819','2013-04-26','09:15:00',1.22),('5819','2013-04-26','09:20:00',1.13),('5819','2013-04-26','09:25:00',1.27),('5819','2013-04-26','09:30:00',1.71),('5819','2013-04-26','09:35:00',1.86),('5819','2013-04-26','09:40:00',2.24),('5819','2013-04-26','09:45:00',2.64),('5819','2013-04-26','09:50:00',2.66),('5819','2013-04-26','09:55:00',1.68),('5819','2013-04-26','10:00:00',1.71),('5819','2013-04-26','10:05:00',2.19),('5819','2013-04-26','10:10:00',2.98),('5819','2013-04-26','10:15:00',3.09),('5819','2013-04-26','10:20:00',3.16),('5819','2013-04-26','10:25:00',2.53),('5819','2013-04-26','10:30:00',3.13),('5819','2013-04-26','10:35:00',3.4),('5819','2013-04-26','10:40:00',3.39),('5819','2013-04-26','10:45:00',2.96),('5819','2013-04-26','10:50:00',1.94),('5819','2013-04-26','10:55:00',2.73),('5819','2013-04-26','11:00:00',2.88),('5819','2013-04-26','11:05:00',3.35),('5819','2013-04-26','11:10:00',2.99),('5819','2013-04-26','11:15:00',3.39),('5819','2013-04-26','11:20:00',2.88),('5819','2013-04-26','11:25:00',2.88),('5819','2013-04-26','11:30:00',2.89),('5819','2013-04-26','11:35:00',3.17),('5819','2013-04-26','11:40:00',3.23),('5819','2013-04-26','11:45:00',3.26),('5819','2013-04-26','11:50:00',2.66),('5819','2013-04-26','11:55:00',2.42),('5819','2013-04-26','12:00:00',2.55),('5819','2013-04-26','12:05:00',2.56),('5819','2013-04-26','12:10:00',2.19),('5819','2013-04-26','12:15:00',2.28),('5819','2013-04-26','12:20:00',2.27),('5819','2013-04-26','12:25:00',2.02),('5819','2013-04-26','12:30:00',1.68),('5819','2013-04-26','12:35:00',2.05),('5819','2013-04-26','12:40:00',3.09),('5819','2013-04-26','12:45:00',3.52),('5819','2013-04-26','12:50:00',2.21),('5819','2013-04-26','12:55:00',1.87),('5819','2013-04-26','13:00:00',1.37),('5819','2013-04-26','13:05:00',1.25),('5819','2013-04-26','13:10:00',1.47),('5819','2013-04-26','13:15:00',2.08),('5819','2013-04-26','13:20:00',1.52),('5819','2013-04-26','13:25:00',1.75),('5819','2013-04-26','13:30:00',2.26),('5819','2013-04-26','13:35:00',2.06),('5819','2013-04-26','13:40:00',2.45),('5819','2013-04-26','13:45:00',2.04),('5819','2013-04-26','13:50:00',2.77),('5819','2013-04-26','13:55:00',2.37),('5819','2013-04-26','14:00:00',2.45),('5819','2013-04-26','14:05:00',3.1),('5819','2013-04-26','14:10:00',3.09),('5819','2013-04-26','14:15:00',3.17),('5819','2013-04-26','14:20:00',2.79),('5819','2013-04-26','14:25:00',3.28),('5819','2013-04-26','14:30:00',3.44),('5819','2013-04-26','14:35:00',2.7),('5819','2013-04-26','14:40:00',1.66),('5819','2013-04-26','14:45:00',1.55),('5819','2013-04-26','14:50:00',3.16),('5819','2013-04-26','14:55:00',3.57),('5819','2013-04-26','15:00:00',3.32),('5819','2013-04-26','15:05:00',2.82),('5819','2013-04-26','15:10:00',1.19),('5819','2013-04-26','15:15:00',1.49),('5819','2013-04-26','15:20:00',1.33),('5819','2013-04-26','15:25:00',1.39),('5819','2013-04-26','15:30:00',1.83),('5819','2013-04-26','15:35:00',1.66),('5819','2013-04-26','15:40:00',1.61),('5819','2013-04-26','15:45:00',1.79),('5819','2013-04-26','15:50:00',1.6),('5819','2013-04-26','15:55:00',1.02),('5819','2013-04-25','08:10:00',1.15),('5819','2013-04-25','08:15:00',1.44),('5819','2013-04-25','08:20:00',1.2),('5819','2013-04-25','08:25:00',1.04),('5819','2013-04-25','08:35:00',1.06),('5819','2013-04-25','08:40:00',1.12),('5819','2013-04-25','08:45:00',1.26),('5819','2013-04-25','08:50:00',2.03),('5819','2013-04-25','08:55:00',2.49),('5819','2013-04-25','09:00:00',2.14),('5819','2013-04-25','09:05:00',1.5),('5819','2013-04-25','09:10:00',1.32),('5819','2013-04-25','09:15:00',1.25),('5819','2013-04-25','09:20:00',1.27),('5819','2013-04-25','09:25:00',1.56),('5819','2013-04-25','09:30:00',1.47),('5819','2013-04-25','09:35:00',1.61),('5819','2013-04-25','09:40:00',2.3),('5819','2013-04-25','09:45:00',2.72),('5819','2013-04-25','09:50:00',3.15),('5819','2013-04-25','09:55:00',3.16),('5819','2013-04-25','10:00:00',3.17),('5819','2013-04-25','10:05:00',3.02),('5819','2013-04-25','10:10:00',2.77),('5819','2013-04-25','10:15:00',2.88),('5819','2013-04-25','10:20:00',3.27),('5819','2013-04-25','10:25:00',3.34),('5819','2013-04-25','10:30:00',3.4),('5819','2013-04-25','10:35:00',3.46),('5819','2013-04-25','10:40:00',3.45),('5819','2013-04-25','10:45:00',3.35),('5819','2013-04-25','10:50:00',3.46),('5819','2013-04-25','10:55:00',3.55),('5819','2013-04-25','11:00:00',3.61),('5819','2013-04-25','11:05:00',3.67),('5819','2013-04-25','11:10:00',3.67),('5819','2013-04-25','11:15:00',3.66),('5819','2013-04-25','11:20:00',3.68),('5819','2013-04-25','11:25:00',3.7),('5819','2013-04-25','11:30:00',3.7),('5819','2013-04-25','11:35:00',3.77),('5819','2013-04-25','11:40:00',3.77),('5819','2013-04-25','11:45:00',3.82),('5819','2013-04-25','11:50:00',3.84),('5819','2013-04-25','11:55:00',3.78),('5819','2013-04-25','12:00:00',3.72),('5819','2013-04-25','12:05:00',3.71),('5819','2013-04-25','12:10:00',3.77),('5819','2013-04-25','12:15:00',3.77),('5819','2013-04-25','12:20:00',3.79),('5819','2013-04-25','12:25:00',3.78),('5819','2013-04-25','12:30:00',3.79),('5819','2013-04-25','12:35:00',3.78),('5819','2013-04-25','12:40:00',3.76),('5819','2013-04-25','12:45:00',3.76),('5819','2013-04-25','12:50:00',3.75),('5819','2013-04-25','12:55:00',3.79),('5819','2013-04-25','13:00:00',3.82),('5819','2013-04-25','13:05:00',3.88),('5819','2013-04-25','13:10:00',3.76),('5819','2013-04-25','13:15:00',3.63),('5819','2013-04-25','13:20:00',3.42),('5819','2013-04-25','13:25:00',3.43),('5819','2013-04-25','13:30:00',2.75),('5819','2013-04-25','13:35:00',2.7),('5819','2013-04-25','13:40:00',2.23),('5819','2013-04-25','13:45:00',2.02),('5819','2013-04-25','13:50:00',1.86),('5819','2013-04-25','13:55:00',1.95),('5819','2013-04-25','14:00:00',2.1),('5819','2013-04-25','14:05:00',1.9),('5819','2013-04-25','14:10:00',2.06),('5819','2013-04-25','14:15:00',2.18),('5819','2013-04-25','14:20:00',2.24),('5819','2013-04-25','14:25:00',2.26),('5819','2013-04-25','14:30:00',2.64),('5819','2013-04-25','14:35:00',3.16),('5819','2013-04-25','14:40:00',3.04),('5819','2013-04-25','14:45:00',3.08),('5819','2013-04-25','14:50:00',2.77),('5819','2013-04-25','14:55:00',2.9),('5819','2013-04-25','15:00:00',2.75),('5819','2013-04-25','15:05:00',2.54),('5819','2013-04-25','15:10:00',2.41),('5819','2013-04-25','15:15:00',2.75),('5819','2013-04-25','15:20:00',2.92),('5819','2013-04-25','15:25:00',2.96),('5819','2013-04-25','15:30:00',2.92),('5819','2013-04-25','15:35:00',2.74),('5819','2013-04-25','15:40:00',2.59),('5819','2013-04-25','15:45:00',2.4),('5819','2013-04-25','15:50:00',2.28),('5819','2013-04-25','15:55:00',2.19),('5819','2013-04-25','16:00:00',2.23),('5819','2013-04-25','16:05:00',1.89),('5819','2013-04-25','16:10:00',1.89),('5819','2013-04-25','16:15:00',1.84),('5819','2013-04-25','16:20:00',1.89),('5819','2013-04-25','16:25:00',1.75),('5819','2013-04-25','16:30:00',1.59),('5819','2013-04-25','16:35:00',1.97),('5819','2013-04-25','16:40:00',1.67),('5819','2013-04-25','16:45:00',1.79),('5819','2013-04-25','16:50:00',1.52),('5819','2013-04-25','16:55:00',1.55),('5819','2013-04-25','17:00:00',1.49),('5819','2013-04-25','17:05:00',1.69),('5819','2013-04-25','17:10:00',1.85),('5819','2013-04-25','17:15:00',1.68),('5819','2013-04-25','17:20:00',1.63),('5819','2013-04-25','17:25:00',1.39),('5819','2013-04-25','17:30:00',1.16),('5819','2013-04-25','17:35:00',1.03),('5819','2013-04-25','17:40:00',1.01),('5819','2013-04-24','07:50:00',1.12),('5819','2013-04-24','07:55:00',1.23),('5819','2013-04-24','08:00:00',1.34),('5819','2013-04-24','08:05:00',1.37),('5819','2013-04-24','08:10:00',1.49),('5819','2013-04-24','08:15:00',1.7),('5819','2013-04-24','08:20:00',1.78),('5819','2013-04-24','08:25:00',1.92),('5819','2013-04-24','08:30:00',1.94),('5819','2013-04-24','08:35:00',1.83),('5819','2013-04-24','08:40:00',1.89),('5819','2013-04-24','08:45:00',1.94),('5819','2013-04-24','08:50:00',2.01),('5819','2013-04-24','08:55:00',2.15),('5819','2013-04-24','09:00:00',2.32),('5819','2013-04-24','09:05:00',2.56),('5819','2013-04-24','09:10:00',2.55),('5819','2013-04-24','09:15:00',2.41),('5819','2013-04-24','09:20:00',2.02),('5819','2013-04-24','09:25:00',2.28),('5819','2013-04-24','09:30:00',2.85),('5819','2013-04-24','09:35:00',2.88),('5819','2013-04-24','09:40:00',2.71),('5819','2013-04-24','09:45:00',2.71),('5819','2013-04-24','09:50:00',2.84),('5819','2013-04-24','09:55:00',3.28),('5819','2013-04-24','10:00:00',3.26),('5819','2013-04-24','10:05:00',3.33),('5819','2013-04-24','10:10:00',3.33),('5819','2013-04-24','10:15:00',3.33),('5819','2013-04-24','10:20:00',3.31),('5819','2013-04-24','10:25:00',3.29),('5819','2013-04-24','10:30:00',3.25),('5819','2013-04-24','10:35:00',3.19),('5819','2013-04-24','10:40:00',3.49),('5819','2013-04-24','10:45:00',3.63),('5819','2013-04-24','10:50:00',3.62),('5819','2013-04-24','10:55:00',3.7),('5819','2013-04-24','11:00:00',3.75),('5819','2013-04-24','11:05:00',3.63),('5819','2013-04-24','11:10:00',3.84),('5819','2013-04-24','11:15:00',3.95),('5819','2013-04-24','11:20:00',4.01),('5819','2013-04-24','11:25:00',4.13),('5819','2013-04-24','11:30:00',3.94),('5819','2013-04-24','11:35:00',3.3),('5819','2013-04-24','11:40:00',2.29),('5819','2013-04-24','11:45:00',2.64),('5819','2013-04-24','11:50:00',1.92),('5819','2013-04-24','11:55:00',2.48),('5819','2013-04-24','12:00:00',3.21),('5819','2013-04-24','12:05:00',2.26),('5819','2013-04-24','12:10:00',2.69),('5819','2013-04-24','12:15:00',3.57),('5819','2013-04-24','12:20:00',4.32),('5819','2013-04-24','12:25:00',3.69),('5819','2013-04-24','12:30:00',3.61),('5819','2013-04-24','12:35:00',3.64),('5819','2013-04-24','12:40:00',3.39),('5819','2013-04-24','12:45:00',3.63),('5819','2013-04-24','12:50:00',3.87),('5819','2013-04-24','12:55:00',3.67),('5819','2013-04-24','13:00:00',3.47),('5819','2013-04-24','13:05:00',3.06),('5819','2013-04-24','13:10:00',4.08),('5819','2013-04-24','13:15:00',3.52),('5819','2013-04-24','13:20:00',3.53),('5819','2013-04-24','13:25:00',3.48),('5819','2013-04-24','13:30:00',3.31),('5819','2013-04-24','13:35:00',3.15),('5819','2013-04-24','13:40:00',3.94),('5819','2013-04-24','13:45:00',3.21),('5819','2013-04-24','13:50:00',2.35),('5819','2013-04-24','13:55:00',3.61),('5819','2013-04-24','14:00:00',3.61),('5819','2013-04-24','14:05:00',2.59),('5819','2013-04-24','14:10:00',2.47),('5819','2013-04-24','14:15:00',3.67),('5819','2013-04-24','14:20:00',3.18),('5819','2013-04-24','14:25:00',3.41),('5819','2013-04-24','14:30:00',3.25),('5819','2013-04-24','14:35:00',2.79),('5819','2013-04-24','14:40:00',2.61),('5819','2013-04-24','14:45:00',2.6),('5819','2013-04-24','14:50:00',2.27),('5819','2013-04-24','14:55:00',2.06),('5819','2013-04-24','15:00:00',2.28),('5819','2013-04-24','15:05:00',2.11),('5819','2013-04-24','15:10:00',1.97),('5819','2013-04-24','15:15:00',2.09),('5819','2013-04-24','15:20:00',2.17),('5819','2013-04-24','15:25:00',1.86),('5819','2013-04-24','15:30:00',1.61),('5819','2013-04-24','15:35:00',1.54),('5819','2013-04-24','15:40:00',1.52),('5819','2013-04-24','15:45:00',1.53),('5819','2013-04-24','15:50:00',1.56),('5819','2013-04-24','15:55:00',1.84),('5819','2013-04-24','16:00:00',2.21),('5819','2013-04-24','16:05:00',2.31),('5819','2013-04-24','16:10:00',2.3),('5819','2013-04-24','16:15:00',2.21),('5819','2013-04-24','16:20:00',2.89),('5819','2013-04-24','16:25:00',2.15),('5819','2013-04-24','16:30:00',1.84),('5819','2013-04-24','16:35:00',1.47),('5819','2013-04-24','16:40:00',1.99),('5819','2013-04-24','16:45:00',2.07),('5819','2013-04-24','16:50:00',1.85),('5819','2013-04-24','16:55:00',2.12),('5819','2013-04-24','17:00:00',2.11),('5819','2013-04-24','17:05:00',1.95),('5819','2013-04-24','17:10:00',1.86),('5819','2013-04-24','17:15:00',1.43),('5819','2013-04-24','17:20:00',1.27),('5819','2013-04-24','17:25:00',1.24),('5819','2013-04-23','07:35:00',1.09),('5819','2013-04-23','07:40:00',1.19),('5819','2013-04-23','07:45:00',1.28),('5819','2013-04-23','07:50:00',1.36),('5819','2013-04-23','07:55:00',1.45),('5819','2013-04-23','08:00:00',1.54),('5819','2013-04-23','08:05:00',1.65),('5819','2013-04-23','08:10:00',1.73),('5819','2013-04-23','08:15:00',1.82),('5819','2013-04-23','08:20:00',1.91),('5819','2013-04-23','08:25:00',1.99),('5819','2013-04-23','08:30:00',2.07),('5819','2013-04-23','08:35:00',2.16),('5819','2013-04-23','08:40:00',2.24),('5819','2013-04-23','08:45:00',2.33),('5819','2013-04-23','08:50:00',2.42),('5819','2013-04-23','08:55:00',2.48),('5819','2013-04-23','09:00:00',2.55),('5819','2013-04-23','09:05:00',2.62),('5819','2013-04-23','09:10:00',2.7),('5819','2013-04-23','09:15:00',2.79),('5819','2013-04-23','09:20:00',2.87),('5819','2013-04-23','09:25:00',2.93),('5819','2013-04-23','09:30:00',2.98),('5819','2013-04-23','09:35:00',3.05),('5819','2013-04-23','09:40:00',2.91),('5819','2013-04-23','09:45:00',2.69),('5819','2013-04-23','09:50:00',3.25),('5819','2013-04-23','09:55:00',3.3),('5819','2013-04-23','10:00:00',3.32),('5819','2013-04-23','10:05:00',3.38),('5819','2013-04-23','10:10:00',3.41),('5819','2013-04-23','10:15:00',3.46),('5819','2013-04-23','10:20:00',3.52),('5819','2013-04-23','10:25:00',3.55),('5819','2013-04-23','10:30:00',3.58),('5819','2013-04-23','10:35:00',3.62),('5819','2013-04-23','10:40:00',3.6),('5819','2013-04-23','10:45:00',3.56),('5819','2013-04-23','10:50:00',3.62),('5819','2013-04-23','10:55:00',3.72),('5819','2013-04-23','11:00:00',3.77),('5819','2013-04-23','11:05:00',3.8),('5819','2013-04-23','11:10:00',3.82),('5819','2013-04-23','11:15:00',3.84),('5819','2013-04-23','11:20:00',3.87),('5819','2013-04-23','11:25:00',3.91),('5819','2013-04-23','11:30:00',3.91),('5819','2013-04-23','11:35:00',3.9),('5819','2013-04-23','11:40:00',3.89),('5819','2013-04-23','11:45:00',3.92),('5819','2013-04-23','11:50:00',3.93),('5819','2013-04-23','11:55:00',3.93),('5819','2013-04-23','12:00:00',3.93),('5819','2013-04-23','12:05:00',3.91),('5819','2013-04-23','12:10:00',3.91),('5819','2013-04-23','12:15:00',3.92),('5819','2013-04-23','12:20:00',3.89),('5819','2013-04-23','12:25:00',3.89),('5819','2013-04-23','12:30:00',2.19),('5819','2013-04-23','12:35:00',1.54),('5819','2013-04-23','12:40:00',2.63),('5819','2013-04-23','12:45:00',1.58),('5819','2013-04-23','12:50:00',3.5),('5819','2013-04-23','12:55:00',2.14),('5819','2013-04-23','13:00:00',2.39),('5819','2013-04-23','13:05:00',3.35),('5819','2013-04-23','13:10:00',1.52),('5819','2013-04-23','13:15:00',3.53),('5819','2013-04-23','13:20:00',3.84),('5819','2013-04-23','13:25:00',4.12),('5819','2013-04-23','13:30:00',3.9),('5819','2013-04-23','13:35:00',3.95),('5819','2013-04-23','13:40:00',4.07),('5819','2013-04-23','13:45:00',2.9),('5819','2013-04-23','13:50:00',3.46),('5819','2013-04-23','13:55:00',3.92),('5819','2013-04-23','14:00:00',2.69),('5819','2013-04-23','14:05:00',3.46),('5819','2013-04-23','14:10:00',2.8),('5819','2013-04-23','14:15:00',3.42),('5819','2013-04-23','14:20:00',3.53),('5819','2013-04-23','14:25:00',3.22),('5819','2013-04-23','14:30:00',3.69),('5819','2013-04-23','14:35:00',3.68),('5819','2013-04-23','14:40:00',3.61),('5819','2013-04-23','14:45:00',3.11),('5819','2013-04-23','14:50:00',2.04),('5819','2013-04-23','14:55:00',2.14),('5819','2013-04-23','15:00:00',2.16),('5819','2013-04-23','15:05:00',2.19),('5819','2013-04-23','15:10:00',2.53),('5819','2013-04-23','15:15:00',2.69),('5819','2013-04-23','15:20:00',2.47),('5819','2013-04-23','15:25:00',2.26),('5819','2013-04-23','15:30:00',2.22),('5819','2013-04-23','15:35:00',2.23),('5819','2013-04-23','15:40:00',1.88),('5819','2013-04-23','15:45:00',2.17),('5819','2013-04-23','15:50:00',1.69),('5819','2013-04-23','15:55:00',1.44),('5819','2013-04-23','16:00:00',1.46),('5819','2013-04-23','16:05:00',1.52),('5819','2013-04-23','16:10:00',1.45),('5819','2013-04-23','16:15:00',1.54),('5819','2013-04-23','16:20:00',1.17),('5819','2013-04-23','16:25:00',1.17),('5819','2013-04-23','16:30:00',1.07),('5819','2013-04-23','16:35:00',1.06),('5819','2013-04-23','16:40:00',1.01),('5819','2013-04-23','16:45:00',1.12),('5819','2013-04-23','17:10:00',1.26),('5819','2013-04-23','17:15:00',1.5),('5819','2013-04-23','17:20:00',1.43),('5819','2013-04-23','17:25:00',1.22),('5819','2013-04-23','17:30:00',1.14),('5819','2013-04-23','17:40:00',1.02),('5819','2013-04-23','17:45:00',1.17),('5819','2013-04-22','09:30:00',1.04),('5819','2013-04-22','10:35:00',1.9),('5819','2013-04-22','10:40:00',3.47),('5819','2013-04-22','10:45:00',4.75),('5819','2013-04-22','10:50:00',2.32),('5819','2013-04-22','10:55:00',2.03),('5819','2013-04-22','11:00:00',1.91),('5819','2013-04-22','11:05:00',1.87),('5819','2013-04-22','11:10:00',2.27),('5819','2013-04-22','11:15:00',1.43),('5819','2013-04-22','11:20:00',1.36),('5819','2013-04-22','11:25:00',1.78),('5819','2013-04-22','11:30:00',2.84),('5819','2013-04-22','11:35:00',3.51),('5819','2013-04-22','11:40:00',3.83),('5819','2013-04-22','11:45:00',2.07),('5819','2013-04-22','11:50:00',1.67),('5819','2013-04-22','11:55:00',3.59),('5819','2013-04-22','12:00:00',3.12),('5819','2013-04-22','12:05:00',3.24),('5819','2013-04-22','12:10:00',3.77),('5819','2013-04-22','12:15:00',3.13),('5819','2013-04-22','12:20:00',3.37),('5819','2013-04-22','12:25:00',3.05),('5819','2013-04-22','12:30:00',2.21),('5819','2013-04-22','12:35:00',2.2),('5819','2013-04-22','12:40:00',4.05),('5819','2013-04-22','12:45:00',3.73),('5819','2013-04-22','12:50:00',4.31),('5819','2013-04-22','12:55:00',4.27),('5819','2013-04-22','13:00:00',4.25),('5819','2013-04-22','13:05:00',3.97),('5819','2013-04-22','13:10:00',3.58),('5819','2013-04-22','13:15:00',4.03),('5819','2013-04-22','13:20:00',4.01),('5819','2013-04-22','13:25:00',2.12),('5819','2013-04-22','13:30:00',3.62),('5819','2013-04-22','13:35:00',2.58),('5819','2013-04-22','13:40:00',2),('5819','2013-04-22','13:45:00',4.12),('5819','2013-04-22','13:50:00',1.07),('5819','2013-04-22','13:55:00',2.43),('5819','2013-04-22','14:00:00',1.35),('5819','2013-04-22','14:05:00',1.27),('5819','2013-04-22','14:10:00',2.01),('5819','2013-04-22','14:15:00',1.21),('5819','2013-04-22','14:20:00',3.06),('5819','2013-04-22','14:25:00',2.67),('5819','2013-04-22','14:30:00',3.86),('5819','2013-04-22','14:35:00',2.97),('5819','2013-04-22','14:40:00',3.95),('5819','2013-04-22','14:45:00',4.01),('5819','2013-04-22','14:50:00',3.96),('5819','2013-04-22','14:55:00',3.99),('5819','2013-04-22','15:00:00',2.56),('5819','2013-04-22','15:05:00',2.43),('5819','2013-04-22','15:10:00',2.15),('5819','2013-04-22','15:25:00',1.62),('5819','2013-04-22','15:30:00',1.69),('5819','2013-04-22','15:40:00',1.24),('5819','2013-04-22','15:45:00',2.68),('5819','2013-04-22','15:50:00',2.62),('5819','2013-04-22','15:55:00',1.44),('5819','2013-04-22','16:45:00',1.54),('5819','2013-04-21','08:15:00',1.05),('5819','2013-04-21','08:25:00',1.01),('5819','2013-04-21','08:35:00',1.22),('5819','2013-04-21','08:40:00',1.38),('5819','2013-04-21','08:45:00',1.59),('5819','2013-04-21','08:50:00',2.7),('5819','2013-04-21','08:55:00',2.68),('5819','2013-04-21','09:00:00',1.76),('5819','2013-04-21','09:05:00',1.89),('5819','2013-04-21','09:10:00',2.28),('5819','2013-04-21','09:15:00',2.7),('5819','2013-04-21','09:20:00',1.88),('5819','2013-04-21','09:25:00',2.09),('5819','2013-04-21','09:30:00',3.07),('5819','2013-04-21','09:35:00',3.09),('5819','2013-04-21','09:40:00',3.16),('5819','2013-04-21','09:45:00',3.2),('5819','2013-04-21','09:50:00',3.73),('5819','2013-04-21','09:55:00',3.43),('5819','2013-04-21','10:00:00',3.01),('5819','2013-04-21','10:05:00',2.36),('5819','2013-04-21','10:10:00',2.07),('5819','2013-04-21','10:15:00',1.83),('5819','2013-04-21','10:20:00',2.98),('5819','2013-04-21','10:25:00',3.59),('5819','2013-04-21','10:30:00',2.99),('5819','2013-04-21','10:35:00',2.07),('5819','2013-04-21','10:40:00',2.6),('5819','2013-04-21','10:45:00',2.47),('5819','2013-04-21','10:50:00',3.9),('5819','2013-04-21','10:55:00',3.27),('5819','2013-04-21','11:00:00',3.84),('5819','2013-04-21','11:05:00',3.35),('5819','2013-04-21','11:10:00',3.75),('5819','2013-04-21','11:15:00',3.01),('5819','2013-04-21','11:20:00',2.85),('5819','2013-04-21','11:25:00',3.08),('5819','2013-04-21','11:30:00',2.88),('5819','2013-04-21','11:35:00',2.55),('5819','2013-04-21','11:40:00',3.22),('5819','2013-04-21','11:45:00',3.4),('5819','2013-04-21','11:50:00',2.99),('5819','2013-04-21','11:55:00',2.79),('5819','2013-04-21','12:00:00',2.42),('5819','2013-04-21','12:05:00',2.33),('5819','2013-04-21','12:10:00',2.34),('5819','2013-04-21','12:15:00',2.1),('5819','2013-04-21','12:20:00',1.93),('5819','2013-04-21','12:25:00',1.8),('5819','2013-04-21','12:30:00',1.97),('5819','2013-04-21','12:35:00',2.05),('5819','2013-04-21','12:40:00',2.05),('5819','2013-04-21','12:45:00',2.08),('5819','2013-04-21','12:50:00',1.92),('5819','2013-04-21','12:55:00',1.87),('5819','2013-04-21','13:00:00',2.09),('5819','2013-04-21','13:05:00',2.49),('5819','2013-04-21','13:10:00',2.61),('5819','2013-04-21','13:15:00',2.36),('5819','2013-04-21','13:20:00',2.23),('5819','2013-04-21','13:25:00',2.08),('5819','2013-04-21','13:30:00',3.04),('5819','2013-04-21','13:35:00',3.87),('5819','2013-04-21','13:40:00',2.58),('5819','2013-04-21','13:45:00',2.72),('5819','2013-04-21','13:50:00',2.45),('5819','2013-04-21','13:55:00',3.46),('5819','2013-04-21','14:00:00',4.23),('5819','2013-04-21','14:05:00',3.39),('5819','2013-04-21','14:10:00',3.61),('5819','2013-04-21','14:15:00',3.13),('5819','2013-04-21','14:20:00',4.15),('5819','2013-04-21','14:25:00',3.3),('5819','2013-04-21','14:30:00',3.55),('5819','2013-04-21','14:35:00',3.51),('5819','2013-04-21','14:40:00',3.95),('5819','2013-04-21','14:45:00',3.44),('5819','2013-04-21','14:50:00',1.95),('5819','2013-04-21','14:55:00',1.8),('5819','2013-04-21','15:00:00',2.43),('5819','2013-04-21','15:05:00',3.48),('5819','2013-04-21','15:10:00',3.63),('5819','2013-04-21','15:15:00',2.81),('5819','2013-04-21','15:20:00',1.87),('5819','2013-04-21','15:25:00',1.79),('5819','2013-04-21','15:30:00',1.6),('5819','2013-04-21','15:35:00',1.34),('5819','2013-04-21','15:40:00',1.4),('5819','2013-04-21','15:45:00',1.2),('5819','2013-04-21','15:50:00',1),('5819','2013-04-20','07:40:00',1.03),('5819','2013-04-20','07:55:00',1.02),('5819','2013-04-20','08:00:00',1.17),('5819','2013-04-20','08:05:00',1.31),('5819','2013-04-20','08:10:00',1.49),('5819','2013-04-20','08:15:00',1.38),('5819','2013-04-20','08:20:00',1.28),('5819','2013-04-20','08:25:00',1.46),('5819','2013-04-20','08:30:00',1.65),('5819','2013-04-20','08:35:00',1.82),('5819','2013-04-20','08:40:00',1.96),('5819','2013-04-20','08:45:00',2.03),('5819','2013-04-20','08:50:00',2.07),('5819','2013-04-20','08:55:00',2.05),('5819','2013-04-20','09:00:00',2.32),('5819','2013-04-20','09:05:00',2.42),('5819','2013-04-20','09:10:00',2.33),('5819','2013-04-20','09:15:00',2.21),('5819','2013-04-20','09:20:00',2.71),('5819','2013-04-20','09:25:00',2.51),('5819','2013-04-20','09:30:00',2.26),('5819','2013-04-20','09:35:00',1.8),('5819','2013-04-20','09:40:00',1.09),('5819','2013-04-20','09:45:00',1.32),('5819','2013-04-20','09:50:00',1.33),('5819','2013-04-20','10:40:00',1.01),('5819','2013-04-20','10:45:00',1.58),('5819','2013-04-20','10:50:00',2.41),('5819','2013-04-20','10:55:00',2.2),('5819','2013-04-20','11:00:00',2.88),('5819','2013-04-20','11:05:00',2.75),('5819','2013-04-20','11:10:00',1.48),('5819','2013-04-20','11:15:00',3.86),('5819','2013-04-20','11:20:00',3.44),('5819','2013-04-20','11:25:00',1.69),('5819','2013-04-20','11:30:00',4.38),('5819','2013-04-20','11:35:00',3.82),('5819','2013-04-20','11:40:00',1.81),('5819','2013-04-20','11:45:00',2.75),('5819','2013-04-20','11:50:00',2.57),('5819','2013-04-20','11:55:00',3.88),('5819','2013-04-20','12:00:00',4.32),('5819','2013-04-20','12:05:00',2.46),('5819','2013-04-20','12:10:00',3.94),('5819','2013-04-20','12:15:00',4.22),('5819','2013-04-20','12:20:00',2.41),('5819','2013-04-20','12:25:00',3.43),('5819','2013-04-20','12:30:00',2.05),('5819','2013-04-20','12:35:00',4.18),('5819','2013-04-20','12:40:00',1.96),('5819','2013-04-20','12:45:00',4.15),('5819','2013-04-20','12:50:00',4.31),('5819','2013-04-20','12:55:00',4.29),('5819','2013-04-20','13:00:00',1.58),('5819','2013-04-20','13:05:00',2.26),('5819','2013-04-20','13:10:00',4.18),('5819','2013-04-20','13:15:00',4.02),('5819','2013-04-20','13:20:00',1.75),('5819','2013-04-20','13:25:00',3.18),('5819','2013-04-20','13:30:00',2.96),('5819','2013-04-20','13:35:00',1.74),('5819','2013-04-20','13:40:00',4.12),('5819','2013-04-20','13:45:00',2.09),('5819','2013-04-20','13:50:00',2.05),('5819','2013-04-20','13:55:00',2.83),('5819','2013-04-20','14:00:00',2.57),('5819','2013-04-20','14:05:00',3.63),('5819','2013-04-20','14:10:00',4.08),('5819','2013-04-20','14:15:00',3.5),('5819','2013-04-20','14:20:00',3.61),('5819','2013-04-20','14:25:00',3.64),('5819','2013-04-20','14:30:00',3.57),('5819','2013-04-20','14:35:00',3.47),('5819','2013-04-20','14:40:00',3.45),('5819','2013-04-20','14:45:00',3.43),('5819','2013-04-20','14:50:00',3.47),('5819','2013-04-20','14:55:00',3.44),('5819','2013-04-20','15:00:00',3.41),('5819','2013-04-20','15:05:00',3.34),('5819','2013-04-20','15:10:00',2.41),('5819','2013-04-20','15:15:00',2.34),('5819','2013-04-20','15:20:00',2.09),('5819','2013-04-20','15:25:00',2.86),('5819','2013-04-20','15:30:00',1.97),('5819','2013-04-20','16:10:00',1.14),('5819','2013-04-20','16:15:00',1.86),('5819','2013-04-20','16:20:00',1.92),('5819','2013-04-20','16:25:00',2.04),('5819','2013-04-20','16:30:00',2.47),('5819','2013-04-20','16:35:00',2.44),('5819','2013-04-20','16:40:00',2.14),('5819','2013-04-20','16:45:00',2.12),('5819','2013-04-20','16:50:00',2.14),('5819','2013-04-20','16:55:00',2.01),('5819','2013-04-20','17:00:00',1.88),('5819','2013-04-20','17:05:00',1.78),('5819','2013-04-20','17:10:00',1.69),('5819','2013-04-20','17:15:00',1.57),('5819','2013-04-20','17:20:00',1.28),('5819','2013-04-20','17:25:00',1.48),('5819','2013-04-20','17:30:00',1.4),('5819','2013-04-20','17:35:00',1.3),('5819','2013-04-20','17:40:00',1.33),('5819','2013-04-20','17:55:00',1.1),('5819','2013-04-19','08:05:00',1.37),('5819','2013-04-19','08:15:00',1.24),('5819','2013-04-19','08:20:00',1.57),('5819','2013-04-19','08:25:00',1.73),('5819','2013-04-19','08:30:00',1.62),('5819','2013-04-19','08:35:00',1.68),('5819','2013-04-19','08:40:00',1.96),('5819','2013-04-19','08:45:00',2.03),('5819','2013-04-19','08:50:00',2.11),('5819','2013-04-19','08:55:00',2.21),('5819','2013-04-19','09:00:00',2.26),('5819','2013-04-19','09:05:00',2.28),('5819','2013-04-19','09:10:00',2.39),('5819','2013-04-19','09:15:00',2.45),('5819','2013-04-19','09:20:00',2.54),('5819','2013-04-19','09:25:00',2.57),('5819','2013-04-19','09:30:00',2.67),('5819','2013-04-19','09:35:00',2.74),('5819','2013-04-19','09:40:00',2.8),('5819','2013-04-19','09:45:00',2.84),('5819','2013-04-19','09:50:00',2.86),('5819','2013-04-19','09:55:00',2.9),('5819','2013-04-19','10:00:00',2.98),('5819','2013-04-19','10:05:00',3.02),('5819','2013-04-19','10:10:00',3.06),('5819','2013-04-19','10:15:00',3.17),('5819','2013-04-19','10:20:00',2.47),('5819','2013-04-19','10:25:00',3.06),('5819','2013-04-19','10:30:00',2.87),('5819','2013-04-19','10:35:00',2.99),('5819','2013-04-19','10:40:00',3.34),('5819','2013-04-19','10:45:00',3.32),('5819','2013-04-19','10:50:00',3.38),('5819','2013-04-19','10:55:00',3.37),('5819','2013-04-19','11:00:00',3.4),('5819','2013-04-19','11:05:00',3.42),('5819','2013-04-19','11:10:00',3.44),('5819','2013-04-19','11:15:00',3.47),('5819','2013-04-19','11:20:00',3.46),('5819','2013-04-19','11:25:00',3.49),('5819','2013-04-19','11:30:00',3.53),('5819','2013-04-19','11:35:00',3.58),('5819','2013-04-19','11:40:00',3.59),('5819','2013-04-19','11:45:00',3.63),('5819','2013-04-19','11:50:00',3.64),('5819','2013-04-19','11:55:00',3.64),('5819','2013-04-19','12:00:00',3.65),('5819','2013-04-19','12:05:00',3.66),('5819','2013-04-19','12:10:00',3.67),('5819','2013-04-19','12:15:00',3.69),('5819','2013-04-19','12:20:00',3.68),('5819','2013-04-19','12:25:00',3.7),('5819','2013-04-19','12:30:00',3.63),('5819','2013-04-19','12:35:00',3.59),('5819','2013-04-19','12:40:00',3.67),('5819','2013-04-19','12:45:00',3.68),('5819','2013-04-19','12:50:00',3.7),('5819','2013-04-19','12:55:00',3.63),('5819','2013-04-19','13:00:00',3.68),('5819','2013-04-19','13:05:00',3.66),('5819','2013-04-19','13:10:00',3.65),('5819','2013-04-19','13:15:00',3.68),('5819','2013-04-19','13:20:00',3.63),('5819','2013-04-19','13:25:00',3.64),('5819','2013-04-19','13:30:00',3.7),('5819','2013-04-19','13:35:00',3.6),('5819','2013-04-19','13:40:00',3.59),('5819','2013-04-19','13:45:00',3.56),('5819','2013-04-19','13:50:00',3.53),('5819','2013-04-19','13:55:00',3.46),('5819','2013-04-19','14:00:00',3.47),('5819','2013-04-19','14:05:00',3.43),('5819','2013-04-19','14:10:00',3.43),('5819','2013-04-19','14:15:00',3.38),('5819','2013-04-19','14:20:00',3.32),('5819','2013-04-19','14:25:00',3.27),('5819','2013-04-19','14:30:00',3.3),('5819','2013-04-19','14:35:00',3.22),('5819','2013-04-19','14:40:00',3.2),('5819','2013-04-19','14:45:00',3.16),('5819','2013-04-19','14:50:00',3.18),('5819','2013-04-19','14:55:00',3.17),('5819','2013-04-19','15:00:00',3.1),('5819','2013-04-19','15:05:00',3.07),('5819','2013-04-19','15:10:00',2.99),('5819','2013-04-19','15:15:00',2.94),('5819','2013-04-19','15:20:00',2.86),('5819','2013-04-19','15:25:00',2.83),('5819','2013-04-19','15:30:00',2.76),('5819','2013-04-19','15:35:00',2.7),('5819','2013-04-19','15:40:00',2.67),('5819','2013-04-19','15:45:00',2.62),('5819','2013-04-19','15:50:00',2.56),('5819','2013-04-19','15:55:00',2.51),('5819','2013-04-19','16:00:00',2.44),('5819','2013-04-19','16:05:00',2.38),('5819','2013-04-19','16:10:00',2.3),('5819','2013-04-19','16:15:00',2.2),('5819','2013-04-19','16:20:00',2.15),('5819','2013-04-19','16:25:00',2.11),('5819','2013-04-19','16:30:00',2.03),('5819','2013-04-19','16:35:00',1.95),('5819','2013-04-19','16:40:00',1.88),('5819','2013-04-19','16:45:00',1.8),('5819','2013-04-19','16:50:00',1.73),('5819','2013-04-19','16:55:00',1.65),('5819','2013-04-19','17:00:00',1.57),('5819','2013-04-19','17:05:00',1.49),('5819','2013-04-19','17:10:00',1.4),('5819','2013-04-19','17:15:00',1.33),('5819','2013-04-19','17:20:00',1.26),('5819','2013-04-19','17:25:00',1.19),('5819','2013-04-19','17:30:00',1.06),('5819','2013-04-18','08:10:00',1.17),('5819','2013-04-18','08:15:00',1.32),('5819','2013-04-18','08:20:00',1.33),('5819','2013-04-18','08:25:00',1.33),('5819','2013-04-18','08:30:00',1.53),('5819','2013-04-18','08:35:00',1.59),('5819','2013-04-18','08:40:00',1.53),('5819','2013-04-18','08:45:00',1.59),('5819','2013-04-18','08:50:00',1.76),('5819','2013-04-18','08:55:00',2.01),('5819','2013-04-18','09:00:00',1.87),('5819','2013-04-18','09:05:00',2.2),('5819','2013-04-18','09:10:00',2.19),('5819','2013-04-18','09:15:00',2.23),('5819','2013-04-18','09:20:00',2.42),('5819','2013-04-18','09:25:00',2.49),('5819','2013-04-18','09:30:00',2.58),('5819','2013-04-18','09:35:00',2.71),('5819','2013-04-18','09:40:00',3.07),('5819','2013-04-18','09:45:00',2.71),('5819','2013-04-18','09:50:00',2.37),('5819','2013-04-18','09:55:00',2.47),('5819','2013-04-18','10:00:00',2.93),('5819','2013-04-18','10:05:00',3.16),('5819','2013-04-18','10:10:00',3.21),('5819','2013-04-18','10:15:00',3.32),('5819','2013-04-18','10:20:00',3.36),('5819','2013-04-18','10:25:00',3.33),('5819','2013-04-18','10:30:00',3.4),('5819','2013-04-18','10:35:00',3.43),('5819','2013-04-18','10:40:00',3.45),('5819','2013-04-18','10:45:00',3.47),('5819','2013-04-18','10:50:00',3.51),('5819','2013-04-18','10:55:00',3.54),('5819','2013-04-18','11:00:00',3.57),('5819','2013-04-18','11:05:00',3.59),('5819','2013-04-18','11:10:00',3.6),('5819','2013-04-18','11:15:00',3.63),('5819','2013-04-18','11:20:00',3.69),('5819','2013-04-18','11:25:00',3.7),('5819','2013-04-18','11:30:00',3.71),('5819','2013-04-18','11:35:00',3.73),('5819','2013-04-18','11:40:00',3.72),('5819','2013-04-18','11:45:00',3.69),('5819','2013-04-18','11:50:00',3.69),('5819','2013-04-18','11:55:00',3.76),('5819','2013-04-18','12:00:00',3.74),('5819','2013-04-18','12:05:00',3.84),('5819','2013-04-18','12:10:00',3.85),('5819','2013-04-18','12:15:00',3.81),('5819','2013-04-18','12:20:00',3.85),('5819','2013-04-18','12:25:00',3.87),('5819','2013-04-18','12:30:00',3.87),('5819','2013-04-18','12:35:00',3.86),('5819','2013-04-18','12:40:00',3.89),('5819','2013-04-18','12:45:00',3.86),('5819','2013-04-18','12:50:00',3.86),('5819','2013-04-18','12:55:00',3.88),('5819','2013-04-18','13:00:00',3.87),('5819','2013-04-18','13:05:00',3.84),('5819','2013-04-18','13:10:00',3.83),('5819','2013-04-18','13:15:00',3.83),('5819','2013-04-18','13:20:00',3.79),('5819','2013-04-18','13:25:00',3.79),('5819','2013-04-18','13:30:00',3.78),('5819','2013-04-18','13:35:00',3.76),('5819','2013-04-18','13:40:00',3.72),('5819','2013-04-18','13:45:00',3.73),('5819','2013-04-18','13:50:00',3.73),('5819','2013-04-18','13:55:00',3.71),('5819','2013-04-18','14:00:00',3.65),('5819','2013-04-18','14:05:00',3.65),('5819','2013-04-18','14:10:00',3.62),('5819','2013-04-18','14:15:00',3.59),('5819','2013-04-18','14:20:00',3.57),('5819','2013-04-18','14:25:00',3.55),('5819','2013-04-18','14:30:00',3.5),('5819','2013-04-18','14:35:00',3.45),('5819','2013-04-18','14:40:00',3.42),('5819','2013-04-18','14:45:00',3.38),('5819','2013-04-18','14:50:00',3.33),('5819','2013-04-18','14:55:00',3.27),('5819','2013-04-18','15:00:00',3.21),('5819','2013-04-18','15:05:00',3.19),('5819','2013-04-18','15:10:00',3.14),('5819','2013-04-18','15:15:00',3.1),('5819','2013-04-18','15:20:00',3.04),('5819','2013-04-18','15:25:00',2.98),('5819','2013-04-18','15:30:00',2.91),('5819','2013-04-18','15:35:00',2.88),('5819','2013-04-18','15:40:00',2.81),('5819','2013-04-18','15:45:00',2.74),('5819','2013-04-18','15:50:00',2.68),('5819','2013-04-18','15:55:00',2.6),('5819','2013-04-18','16:00:00',2.54),('5819','2013-04-18','16:05:00',2.46),('5819','2013-04-18','16:10:00',2.42),('5819','2013-04-18','16:15:00',2.35),('5819','2013-04-18','16:20:00',2.25),('5819','2013-04-18','16:25:00',2.18),('5819','2013-04-18','16:30:00',2.11),('5819','2013-04-18','16:35:00',2.02),('5819','2013-04-18','16:40:00',1.95),('5819','2013-04-18','16:45:00',1.89),('5819','2013-04-18','16:50:00',1.81),('5819','2013-04-18','16:55:00',1.73),('5819','2013-04-18','17:00:00',1.64),('5819','2013-04-18','17:05:00',1.55),('5819','2013-04-18','17:10:00',1.48),('5819','2013-04-18','17:15:00',1.41),('5819','2013-04-18','17:20:00',1.32),('5819','2013-04-18','17:25:00',1.24),('5819','2013-04-18','17:30:00',1.07),('5819','2013-04-18','17:35:00',1.07),('5819','2013-04-17','07:45:00',1.08),('5819','2013-04-17','07:50:00',1.17),('5819','2013-04-17','07:55:00',1.26),('5819','2013-04-17','08:00:00',1.36),('5819','2013-04-17','08:05:00',1.45),('5819','2013-04-17','08:10:00',1.55),('5819','2013-04-17','08:15:00',1.65),('5819','2013-04-17','08:20:00',1.73),('5819','2013-04-17','08:25:00',1.81),('5819','2013-04-17','08:30:00',1.89),('5819','2013-04-17','08:35:00',1.97),('5819','2013-04-17','08:40:00',2.05),('5819','2013-04-17','08:45:00',2.13),('5819','2013-04-17','08:50:00',2.21),('5819','2013-04-17','08:55:00',2.28),('5819','2013-04-17','09:00:00',2.36),('5819','2013-04-17','09:05:00',2.43),('5819','2013-04-17','09:10:00',2.51),('5819','2013-04-17','09:15:00',2.59),('5819','2013-04-17','09:20:00',2.66),('5819','2013-04-17','09:25:00',2.72),('5819','2013-04-17','09:30:00',2.79),('5819','2013-04-17','09:35:00',2.86),('5819','2013-04-17','09:40:00',2.92),('5819','2013-04-17','09:45:00',2.97),('5819','2013-04-17','09:50:00',3.02),('5819','2013-04-17','09:55:00',3.07),('5819','2013-04-17','10:00:00',3.13),('5819','2013-04-17','10:05:00',3.19),('5819','2013-04-17','10:10:00',3.24),('5819','2013-04-17','10:15:00',3.28),('5819','2013-04-17','10:20:00',3.33),('5819','2013-04-17','10:25:00',3.37),('5819','2013-04-17','10:30:00',3.41),('5819','2013-04-17','10:35:00',3.44),('5819','2013-04-17','10:40:00',3.49),('5819','2013-04-17','10:45:00',3.52),('5819','2013-04-17','10:50:00',3.54),('5819','2013-04-17','10:55:00',3.57),('5819','2013-04-17','11:00:00',3.63),('5819','2013-04-17','11:05:00',3.66),('5819','2013-04-17','11:10:00',3.68),('5819','2013-04-17','11:15:00',3.68),('5819','2013-04-17','11:20:00',3.72),('5819','2013-04-17','11:25:00',3.73),('5819','2013-04-17','11:30:00',3.72),('5819','2013-04-17','11:35:00',3.74),('5819','2013-04-17','11:40:00',3.76),('5819','2013-04-17','11:45:00',3.78),('5819','2013-04-17','11:50:00',3.82),('5819','2013-04-17','11:55:00',3.81),('5819','2013-04-17','12:00:00',3.8),('5819','2013-04-17','12:05:00',3.84),('5819','2013-04-17','12:10:00',3.84),('5819','2013-04-17','12:15:00',3.84),('5819','2013-04-17','12:20:00',3.83),('5819','2013-04-17','12:25:00',3.87),('5819','2013-04-17','12:30:00',3.89),('5819','2013-04-17','12:35:00',3.86),('5819','2013-04-17','12:40:00',3.84),('5819','2013-04-17','12:45:00',3.85),('5819','2013-04-17','12:50:00',3.85),('5819','2013-04-17','12:55:00',3.86),('5819','2013-04-17','13:00:00',3.82),('5819','2013-04-17','13:05:00',3.78),('5819','2013-04-17','13:10:00',3.78),('5819','2013-04-17','13:15:00',3.81),('5819','2013-04-17','13:20:00',3.82),('5819','2013-04-17','13:25:00',3.82),('5819','2013-04-17','13:30:00',3.79),('5819','2013-04-17','13:35:00',3.7),('5819','2013-04-17','13:40:00',3.77),('5819','2013-04-17','13:45:00',3.5),('5819','2013-04-17','13:50:00',3.51),('5819','2013-04-17','13:55:00',3.8),('5819','2013-04-17','14:00:00',3.66),('5819','2013-04-17','14:05:00',3.92),('5819','2013-04-17','14:10:00',3.84),('5819','2013-04-17','14:15:00',3.39),('5819','2013-04-17','14:20:00',3.34),('5819','2013-04-17','14:25:00',3.38),('5819','2013-04-17','14:30:00',3.21),('5819','2013-04-17','14:35:00',3.71),('5819','2013-04-17','14:40:00',3.58),('5819','2013-04-17','14:45:00',2.99),('5819','2013-04-17','14:50:00',3.5),('5819','2013-04-17','14:55:00',3.59),('5819','2013-04-17','15:00:00',3.54),('5819','2013-04-17','15:05:00',3.61),('5819','2013-04-17','15:10:00',3.71),('5819','2013-04-17','15:15:00',3.33),('5819','2013-04-17','15:20:00',1.75),('5819','2013-04-17','15:25:00',1.91),('5819','2013-04-17','15:30:00',2.95),('5819','2013-04-17','15:35:00',3.09),('5819','2013-04-17','15:40:00',3.06),('5819','2013-04-17','15:45:00',3.07),('5819','2013-04-17','15:50:00',3.04),('5819','2013-04-17','15:55:00',3.06),('5819','2013-04-17','16:00:00',2.93),('5819','2013-04-17','16:05:00',2.17),('5819','2013-04-17','16:10:00',2.71),('5819','2013-04-17','16:15:00',2.58),('5819','2013-04-17','16:20:00',2.45),('5819','2013-04-17','16:25:00',2.36),('5819','2013-04-17','16:30:00',2.28),('5819','2013-04-17','16:35:00',2.26),('5819','2013-04-17','16:40:00',2.07),('5819','2013-04-17','16:45:00',2.12),('5819','2013-04-17','16:50:00',1.92),('5819','2013-04-17','16:55:00',1.8),('5819','2013-04-17','17:00:00',1.7),('5819','2013-04-17','17:05:00',1.61),('5819','2013-04-17','17:10:00',1.52),('5819','2013-04-17','17:15:00',1.43),('5819','2013-04-17','17:20:00',1.35),('5819','2013-04-17','17:25:00',1.26),('5819','2013-04-17','17:30:00',1.08),('5819','2013-04-17','17:35:00',1.07),('5819','2013-04-16','07:50:00',1.01),('5819','2013-04-16','07:55:00',1.08),('5819','2013-04-16','08:05:00',1.28),('5819','2013-04-16','08:10:00',1.28),('5819','2013-04-16','08:30:00',1.03),('5819','2013-04-16','08:50:00',1.01),('5819','2013-04-16','08:55:00',1.13),('5819','2013-04-16','09:00:00',1.13),('5819','2013-04-16','09:10:00',1.45),('5819','2013-04-16','09:15:00',1.88),('5819','2013-04-16','09:20:00',1.4),('5819','2013-04-16','09:25:00',1.81),('5819','2013-04-16','09:30:00',1.64),('5819','2013-04-16','09:35:00',1.46),('5819','2013-04-16','09:40:00',1.36),('5819','2013-04-16','09:45:00',1.37),('5819','2013-04-16','09:50:00',1.33),('5819','2013-04-16','09:55:00',1.29),('5819','2013-04-16','10:00:00',1.24),('5819','2013-04-16','10:05:00',1.23),('5819','2013-04-16','10:10:00',1.3),('5819','2013-04-16','10:15:00',1.4),('5819','2013-04-16','10:20:00',1.44),('5819','2013-04-16','10:25:00',1.47),('5819','2013-04-16','10:30:00',1.5),('5819','2013-04-16','10:35:00',1.51),('5819','2013-04-16','10:40:00',1.46),('5819','2013-04-16','10:45:00',1.39),('5819','2013-04-16','10:50:00',1.41),('5819','2013-04-16','10:55:00',1.51),('5819','2013-04-16','11:00:00',1.65),('5819','2013-04-16','11:05:00',1.7),('5819','2013-04-16','11:10:00',1.7),('5819','2013-04-16','11:15:00',1.76),('5819','2013-04-16','11:20:00',1.81),('5819','2013-04-16','11:25:00',1.79),('5819','2013-04-16','11:30:00',1.76),('5819','2013-04-16','11:35:00',1.75),('5819','2013-04-16','11:40:00',1.95),('5819','2013-04-16','11:45:00',2.3),('5819','2013-04-16','11:50:00',2.45),('5819','2013-04-16','11:55:00',2.55),('5819','2013-04-16','12:00:00',2.88),('5819','2013-04-16','12:05:00',3.86),('5819','2013-04-16','12:10:00',3.8),('5819','2013-04-16','12:15:00',4.55),('5819','2013-04-16','12:20:00',3.57),('5819','2013-04-16','12:25:00',3.12),('5819','2013-04-16','12:30:00',3.53),('5819','2013-04-16','12:35:00',3.92),('5819','2013-04-16','12:40:00',3.91),('5819','2013-04-16','12:45:00',3.3),('5819','2013-04-16','12:50:00',2.91),('5819','2013-04-16','12:55:00',3.76),('5819','2013-04-16','13:00:00',3.87),('5819','2013-04-16','13:05:00',3.65),('5819','2013-04-16','13:10:00',3.69),('5819','2013-04-16','13:15:00',3.72),('5819','2013-04-16','13:20:00',3.75),('5819','2013-04-16','13:25:00',3.76),('5819','2013-04-16','13:30:00',3.74),('5819','2013-04-16','13:35:00',3.74),('5819','2013-04-16','13:40:00',3.69),('5819','2013-04-16','13:45:00',3.62),('5819','2013-04-16','13:50:00',3.58),('5819','2013-04-16','13:55:00',3.46),('5819','2013-04-16','14:00:00',3.49),('5819','2013-04-16','14:05:00',3.54),('5819','2013-04-16','14:10:00',3.55),('5819','2013-04-16','14:15:00',3.4),('5819','2013-04-16','14:20:00',3.46),('5819','2013-04-16','14:25:00',2.73),('5819','2013-04-16','14:30:00',2.92),('5819','2013-04-16','14:35:00',2.88),('5819','2013-04-16','14:40:00',3.24),('5819','2013-04-16','14:45:00',3.35),('5819','2013-04-16','14:50:00',3.19),('5819','2013-04-16','14:55:00',3.11),('5819','2013-04-16','15:00:00',3.19),('5819','2013-04-16','15:05:00',3.14),('5819','2013-04-16','15:10:00',3.1),('5819','2013-04-16','15:15:00',3.07),('5819','2013-04-16','15:20:00',3.02),('5819','2013-04-16','15:25:00',2.9),('5819','2013-04-16','15:30:00',2.79),('5819','2013-04-16','15:35:00',2.81),('5819','2013-04-16','15:40:00',2.77),('5819','2013-04-16','15:45:00',2.7),('5819','2013-04-16','15:50:00',2.68),('5819','2013-04-16','15:55:00',2.59),('5819','2013-04-16','16:00:00',2.43),('5819','2013-04-16','16:05:00',2.45),('5819','2013-04-16','16:10:00',2.38),('5819','2013-04-16','16:15:00',2.27),('5819','2013-04-16','16:20:00',2.27),('5819','2013-04-16','16:25:00',2.21),('5819','2013-04-16','16:30:00',2.16),('5819','2013-04-16','16:35:00',2.13),('5819','2013-04-16','16:40:00',2.26),('5819','2013-04-16','16:45:00',2.28),('5819','2013-04-16','16:50:00',2),('5819','2013-04-16','16:55:00',1.7),('5819','2013-04-16','17:00:00',1.78),('5819','2013-04-16','17:05:00',1.8),('5819','2013-04-16','17:10:00',1.79),('5819','2013-04-16','17:15:00',1.69),('5819','2013-04-16','17:20:00',1.61),('5819','2013-04-16','17:25:00',1.57),('5819','2013-04-16','17:30:00',1.45),('5819','2013-04-16','17:35:00',1.32),('5819','2013-04-16','17:40:00',1.36),('5819','2013-04-16','17:45:00',1.24),('5819','2013-04-16','17:50:00',1.11),('5819','2013-04-15','07:40:00',1),('5819','2013-04-15','07:45:00',1.11),('5819','2013-04-15','07:50:00',1.2),('5819','2013-04-15','07:55:00',1.28),('5819','2013-04-15','08:00:00',1.38),('5819','2013-04-15','08:05:00',1.47),('5819','2013-04-15','08:10:00',1.56),('5819','2013-04-15','08:15:00',1.64),('5819','2013-04-15','08:20:00',1.72),('5819','2013-04-15','08:25:00',1.82),('5819','2013-04-15','08:30:00',1.91),('5819','2013-04-15','08:35:00',1.99),('5819','2013-04-15','08:40:00',2.07),('5819','2013-04-15','08:45:00',2.15),('5819','2013-04-15','08:50:00',2.24),('5819','2013-04-15','08:55:00',2.32),('5819','2013-04-15','09:00:00',2.4),('5819','2013-04-15','09:05:00',2.48),('5819','2013-04-15','09:10:00',2.54),('5819','2013-04-15','09:15:00',2.61),('5819','2013-04-15','09:20:00',2.68),('5819','2013-04-15','09:25:00',2.73),('5819','2013-04-15','09:30:00',2.8),('5819','2013-04-15','09:35:00',2.85),('5819','2013-04-15','09:40:00',2.91),('5819','2013-04-15','09:45:00',2.97),('5819','2013-04-15','09:50:00',3.02),('5819','2013-04-15','09:55:00',3.08),('5819','2013-04-15','10:00:00',3.13),('5819','2013-04-15','10:05:00',3.17),('5819','2013-04-15','10:10:00',3.23),('5819','2013-04-15','10:15:00',3.28),('5819','2013-04-15','10:20:00',3.31),('5819','2013-04-15','10:25:00',3.34),('5819','2013-04-15','10:30:00',3.39),('5819','2013-04-15','10:35:00',3.43),('5819','2013-04-15','10:40:00',3.46),('5819','2013-04-15','10:45:00',3.49),('5819','2013-04-15','10:50:00',3.53),('5819','2013-04-15','10:55:00',3.58),('5819','2013-04-15','11:00:00',3.62),('5819','2013-04-15','11:05:00',3.65),('5819','2013-04-15','11:10:00',3.66),('5819','2013-04-15','11:15:00',3.69),('5819','2013-04-15','11:20:00',3.69),('5819','2013-04-15','11:25:00',3.7),('5819','2013-04-15','11:30:00',3.73),('5819','2013-04-15','11:35:00',3.74),('5819','2013-04-15','11:40:00',3.75),('5819','2013-04-15','11:45:00',3.79),('5819','2013-04-15','11:50:00',3.79),('5819','2013-04-15','11:55:00',3.81),('5819','2013-04-15','12:00:00',3.81),('5819','2013-04-15','12:05:00',3.79),('5819','2013-04-15','12:10:00',3.82),('5819','2013-04-15','12:15:00',3.83),('5819','2013-04-15','12:20:00',3.81),('5819','2013-04-15','12:25:00',3.81),('5819','2013-04-15','12:30:00',3.84),('5819','2013-04-15','12:35:00',3.83),('5819','2013-04-15','12:40:00',3.83),('5819','2013-04-15','12:45:00',3.81),('5819','2013-04-15','12:50:00',3.81),('5819','2013-04-15','12:55:00',3.79),('5819','2013-04-15','13:00:00',3.79),('5819','2013-04-15','13:05:00',3.77),('5819','2013-04-15','13:10:00',3.82),('5819','2013-04-15','13:15:00',3.81),('5819','2013-04-15','13:20:00',3.77),('5819','2013-04-15','13:25:00',3.73),('5819','2013-04-15','13:30:00',3.7),('5819','2013-04-15','13:35:00',3.71),('5819','2013-04-15','13:40:00',3.71),('5819','2013-04-15','13:45:00',3.64),('5819','2013-04-15','13:50:00',3.63),('5819','2013-04-15','13:55:00',3.69),('5819','2013-04-15','14:00:00',3.69),('5819','2013-04-15','14:05:00',3.65),('5819','2013-04-15','14:10:00',3.65),('5819','2013-04-15','14:15:00',3.64),('5819','2013-04-15','14:20:00',3.61),('5819','2013-04-15','14:25:00',3.57),('5819','2013-04-15','14:30:00',3.53),('5819','2013-04-15','14:35:00',3.48),('5819','2013-04-15','14:40:00',3.44),('5819','2013-04-15','14:45:00',3.41),('5819','2013-04-15','14:50:00',3.36),('5819','2013-04-15','14:55:00',3.32),('5819','2013-04-15','15:00:00',3.28),('5819','2013-04-15','15:05:00',3.24),('5819','2013-04-15','15:10:00',3.18),('5819','2013-04-15','15:15:00',3.14),('5819','2013-04-15','15:20:00',3.08),('5819','2013-04-15','15:25:00',3.02),('5819','2013-04-15','15:30:00',2.98),('5819','2013-04-15','15:35:00',2.92),('5819','2013-04-15','15:40:00',2.85),('5819','2013-04-15','15:45:00',2.79),('5819','2013-04-15','15:50:00',2.73),('5819','2013-04-15','15:55:00',2.66),('5819','2013-04-15','16:00:00',2.58),('5819','2013-04-15','16:05:00',2.52),('5819','2013-04-15','16:10:00',2.45),('5819','2013-04-15','16:15:00',2.37),('5819','2013-04-15','16:20:00',2.3),('5819','2013-04-15','16:25:00',2.22),('5819','2013-04-15','16:30:00',2.14),('5819','2013-04-15','16:35:00',2.06),('5819','2013-04-15','16:40:00',1.98),('5819','2013-04-15','16:45:00',1.9),('5819','2013-04-15','16:50:00',1.82),('5819','2013-04-15','16:55:00',1.74),('5819','2013-04-15','17:00:00',1.65),('5819','2013-04-15','17:05:00',1.57),('5819','2013-04-15','17:10:00',1.49),('5819','2013-04-15','17:15:00',1.4),('5819','2013-04-15','17:20:00',1.33),('5819','2013-04-15','17:25:00',1.25),('5819','2013-04-15','17:30:00',1.07),('5819','2013-04-15','17:35:00',1.06),('5819','2013-04-14','07:50:00',1.08),('5819','2013-04-14','07:55:00',1.18),('5819','2013-04-14','08:00:00',1.26),('5819','2013-04-14','08:05:00',1.21),('5819','2013-04-14','08:10:00',1.36),('5819','2013-04-14','08:15:00',1.51),('5819','2013-04-14','08:20:00',1.61),('5819','2013-04-14','08:25:00',1.68),('5819','2013-04-14','08:30:00',1.73),('5819','2013-04-14','08:35:00',1.79),('5819','2013-04-14','08:40:00',1.92),('5819','2013-04-14','08:45:00',2.01),('5819','2013-04-14','08:50:00',2.08),('5819','2013-04-14','08:55:00',2.17),('5819','2013-04-14','09:00:00',2.25),('5819','2013-04-14','09:05:00',2.31),('5819','2013-04-14','09:10:00',2.37),('5819','2013-04-14','09:15:00',2.44),('5819','2013-04-14','09:20:00',2.51),('5819','2013-04-14','09:25:00',2.58),('5819','2013-04-14','09:30:00',2.64),('5819','2013-04-14','09:35:00',2.72),('5819','2013-04-14','09:40:00',2.79),('5819','2013-04-14','09:45:00',2.86),('5819','2013-04-14','09:50:00',2.92),('5819','2013-04-14','09:55:00',2.98),('5819','2013-04-14','10:00:00',3.04),('5819','2013-04-14','10:05:00',3.1),('5819','2013-04-14','10:10:00',3.14),('5819','2013-04-14','10:15:00',3.19),('5819','2013-04-14','10:20:00',3.23),('5819','2013-04-14','10:25:00',3.27),('5819','2013-04-14','10:30:00',3.31),('5819','2013-04-14','10:35:00',3.36),('5819','2013-04-14','10:40:00',3.38),('5819','2013-04-14','10:45:00',3.44),('5819','2013-04-14','10:50:00',3.48),('5819','2013-04-14','10:55:00',3.5),('5819','2013-04-14','11:00:00',3.56),('5819','2013-04-14','11:05:00',3.56),('5819','2013-04-14','11:10:00',3.62),('5819','2013-04-14','11:15:00',3.63),('5819','2013-04-14','11:20:00',3.63),('5819','2013-04-14','11:25:00',3.62),('5819','2013-04-14','11:30:00',3.65),('5819','2013-04-14','11:35:00',3.71),('5819','2013-04-14','11:40:00',3.74),('5819','2013-04-14','11:45:00',3.76),('5819','2013-04-14','11:50:00',3.72),('5819','2013-04-14','11:55:00',3.76),('5819','2013-04-14','12:00:00',3.74),('5819','2013-04-14','12:05:00',3.74),('5819','2013-04-14','12:10:00',3.78),('5819','2013-04-14','12:15:00',3.77),('5819','2013-04-14','12:20:00',3.79),('5819','2013-04-14','12:25:00',3.77),('5819','2013-04-14','12:30:00',3.78),('5819','2013-04-14','12:35:00',3.8),('5819','2013-04-14','12:40:00',3.84),('5819','2013-04-14','12:45:00',3.86),('5819','2013-04-14','12:50:00',3.9),('5819','2013-04-14','12:55:00',3.92),('5819','2013-04-14','13:00:00',2.8),('5819','2013-04-14','13:05:00',3.08),('5819','2013-04-14','13:10:00',3.99),('5819','2013-04-14','13:15:00',3.94),('5819','2013-04-14','13:20:00',3.89),('5819','2013-04-14','13:25:00',3.85),('5819','2013-04-14','13:30:00',3.75),('5819','2013-04-14','13:35:00',3.75),('5819','2013-04-14','13:40:00',3.72),('5819','2013-04-14','13:45:00',3.69),('5819','2013-04-14','13:50:00',3.63),('5819','2013-04-14','13:55:00',3.58),('5819','2013-04-14','14:00:00',3.49),('5819','2013-04-14','14:05:00',3.59),('5819','2013-04-14','14:10:00',3.58),('5819','2013-04-14','14:15:00',3.54),('5819','2013-04-14','14:20:00',3.49),('5819','2013-04-14','14:25:00',3.44),('5819','2013-04-14','14:30:00',3.43),('5819','2013-04-14','14:35:00',3.47),('5819','2013-04-14','14:40:00',3.5),('5819','2013-04-14','14:45:00',3.56),('5819','2013-04-14','14:50:00',3.54),('5819','2013-04-14','14:55:00',3.4),('5819','2013-04-14','15:00:00',3.34),('5819','2013-04-14','15:05:00',3.3),('5819','2013-04-14','15:10:00',3.12),('5819','2013-04-14','15:15:00',3.05),('5819','2013-04-14','15:20:00',2.74),('5819','2013-04-14','15:25:00',2.6),('5819','2013-04-14','15:30:00',2.92),('5819','2013-04-14','15:35:00',3.03),('5819','2013-04-14','15:40:00',3.07),('5819','2013-04-14','15:45:00',2.95),('5819','2013-04-14','15:50:00',2.82),('5819','2013-04-14','15:55:00',1.71),('5819','2013-04-14','16:00:00',2.59),('5819','2013-04-14','16:05:00',2.5),('5819','2013-04-14','16:10:00',2.44),('5819','2013-04-14','16:15:00',2.28),('5819','2013-04-14','16:20:00',2.23),('5819','2013-04-14','16:25:00',2.22),('5819','2013-04-14','16:30:00',2.13),('5819','2013-04-14','16:35:00',2.02),('5819','2013-04-14','16:40:00',1.92),('5819','2013-04-14','16:45:00',1.83),('5819','2013-04-14','16:50:00',1.79),('5819','2013-04-14','16:55:00',1.68),('5819','2013-04-14','17:00:00',1.61),('5819','2013-04-14','17:05:00',1.53),('5819','2013-04-14','17:10:00',1.47),('5819','2013-04-14','17:15:00',1.37),('5819','2013-04-14','17:20:00',1.3),('5819','2013-04-14','17:25:00',1.21),('5819','2013-04-14','17:30:00',1.07),('5819','2013-04-13','07:50:00',1.02),('5819','2013-04-13','07:55:00',1.11),('5819','2013-04-13','08:00:00',1.22),('5819','2013-04-13','08:05:00',1.31),('5819','2013-04-13','08:10:00',1.26),('5819','2013-04-13','08:55:00',1.07),('5819','2013-04-13','09:00:00',1.2),('5819','2013-04-13','09:05:00',1.93),('5819','2013-04-13','09:10:00',1.9),('5819','2013-04-13','09:15:00',2.49),('5819','2013-04-13','09:20:00',2.71),('5819','2013-04-13','09:25:00',2.33),('5819','2013-04-13','09:30:00',2.72),('5819','2013-04-13','09:35:00',2.66),('5819','2013-04-13','09:40:00',2.45),('5819','2013-04-13','09:45:00',2.86),('5819','2013-04-13','09:50:00',2.91),('5819','2013-04-13','09:55:00',3.03),('5819','2013-04-13','10:00:00',3.1),('5819','2013-04-13','10:05:00',3.14),('5819','2013-04-13','10:10:00',3.27),('5819','2013-04-13','10:15:00',3.61),('5819','2013-04-13','10:20:00',3.41),('5819','2013-04-13','10:25:00',2.62),('5819','2013-04-13','10:30:00',3.09),('5819','2013-04-13','10:35:00',2.49),('5819','2013-04-13','10:40:00',2.08),('5819','2013-04-13','10:45:00',3.32),('5819','2013-04-13','10:50:00',1.69),('5819','2013-04-13','10:55:00',2.61),('5819','2013-04-13','11:00:00',2.52),('5819','2013-04-13','11:05:00',2.46),('5819','2013-04-13','11:10:00',2.03),('5819','2013-04-13','11:15:00',2.65),('5819','2013-04-13','11:20:00',3.48),('5819','2013-04-13','11:25:00',1.68),('5819','2013-04-13','11:30:00',1.31),('5819','2013-04-13','11:35:00',4.28),('5819','2013-04-13','11:40:00',3.78),('5819','2013-04-13','11:45:00',3.08),('5819','2013-04-13','11:50:00',4.25),('5819','2013-04-13','11:55:00',2.19),('5819','2013-04-13','12:00:00',4.25),('5819','2013-04-13','12:05:00',4.11),('5819','2013-04-13','12:10:00',4.19),('5819','2013-04-13','12:15:00',4.17),('5819','2013-04-13','12:20:00',4.02),('5819','2013-04-13','12:25:00',3.94),('5819','2013-04-13','12:30:00',3.52),('5819','2013-04-13','12:35:00',4.06),('5819','2013-04-13','12:40:00',4.1),('5819','2013-04-13','12:45:00',4.01),('5819','2013-04-13','12:50:00',3.9),('5819','2013-04-13','12:55:00',3.97),('5819','2013-04-13','13:00:00',3.7),('5819','2013-04-13','13:05:00',3.98),('5819','2013-04-13','13:10:00',4.06),('5819','2013-04-13','13:15:00',3.91),('5819','2013-04-13','13:20:00',3.63),('5819','2013-04-13','13:25:00',3.91),('5819','2013-04-13','13:30:00',3.87),('5819','2013-04-13','13:35:00',2.15),('5819','2013-04-13','13:40:00',1.87),('5819','2013-04-13','13:45:00',3.28),('5819','2013-04-13','13:50:00',2.67),('5819','2013-04-13','13:55:00',1.83),('5819','2013-04-13','14:00:00',1.85),('5819','2013-04-13','14:05:00',2.27),('5819','2013-04-13','14:10:00',1.5),('5819','2013-04-13','14:15:00',1.57),('5819','2013-04-13','14:20:00',2.97),('5819','2013-04-13','14:25:00',3.35),('5819','2013-04-13','14:30:00',3.28),('5819','2013-04-13','14:35:00',3.46),('5819','2013-04-13','14:40:00',3.32),('5819','2013-04-13','14:45:00',3.31),('5819','2013-04-13','14:50:00',3.16),('5819','2013-04-13','14:55:00',3.19),('5819','2013-04-13','15:00:00',2.96),('5819','2013-04-13','15:05:00',2.63),('5819','2013-04-13','15:10:00',2.35),('5819','2013-04-13','15:15:00',2.68),('5819','2013-04-13','15:20:00',2.54),('5819','2013-04-13','15:25:00',2.37),('5819','2013-04-13','15:30:00',2.41),('5819','2013-04-13','15:35:00',2.32),('5819','2013-04-13','15:40:00',2.4),('5819','2013-04-13','15:45:00',2.43),('5819','2013-04-13','15:50:00',2.38),('5819','2013-04-13','15:55:00',2.29),('5819','2013-04-13','16:00:00',2.3),('5819','2013-04-13','16:05:00',2.16),('5819','2013-04-13','16:10:00',2.01),('5819','2013-04-13','16:15:00',2.08),('5819','2013-04-13','16:20:00',1.96),('5819','2013-04-13','16:25:00',1.83),('5819','2013-04-13','16:30:00',1.76),('5819','2013-04-13','16:35:00',1.63),('5819','2013-04-13','16:40:00',1.55),('5819','2013-04-13','16:45:00',1.49),('5819','2013-04-13','16:50:00',1.51),('5819','2013-04-13','16:55:00',1.26),('5819','2013-04-13','17:00:00',1.09),('5819','2013-04-13','17:05:00',1.06),('5819','2013-04-13','17:10:00',1.45),('5819','2013-04-13','17:15:00',1.53),('5819','2013-04-13','17:20:00',1.27),('5819','2013-04-13','17:25:00',1.4),('5819','2013-04-13','17:30:00',1.15),('5819','2013-04-13','17:35:00',1.07),('5819','2013-04-13','17:40:00',1.06),('5819','2013-04-12','07:50:00',1.12),('5819','2013-04-12','08:00:00',1.07),('5819','2013-04-12','08:05:00',1.34),('5819','2013-04-12','08:10:00',1.28),('5819','2013-04-12','08:30:00',1.07),('5819','2013-04-12','08:35:00',1.19),('5819','2013-04-12','08:40:00',1.07),('5819','2013-04-12','08:45:00',1.16),('5819','2013-04-12','08:51:00',1.13),('5819','2013-04-12','08:55:00',1.22),('5819','2013-04-12','09:00:00',1.82),('5819','2013-04-12','09:05:00',1.85),('5819','2013-04-12','09:10:00',1.15),('5819','2013-04-12','09:15:00',2.29),('5819','2013-04-12','09:20:00',2.12),('5819','2013-04-12','09:25:00',1.76),('5819','2013-04-12','09:30:00',1.89),('5819','2013-04-12','09:35:00',1.27),('5819','2013-04-12','09:40:00',1.77),('5819','2013-04-12','09:45:00',1.43),('5819','2013-04-12','09:50:00',1.15),('5819','2013-04-12','10:20:00',1.36),('5819','2013-04-12','10:25:00',1.87),('5819','2013-04-12','10:30:00',1.1),('5819','2013-04-12','10:35:00',1.15),('5819','2013-04-12','10:40:00',1.34),('5819','2013-04-12','10:45:00',3.62),('5819','2013-04-12','10:50:00',2.87),('5819','2013-04-12','10:55:00',4.28),('5819','2013-04-12','11:00:00',2.01),('5819','2013-04-12','11:05:00',1.37),('5819','2013-04-12','11:10:00',1.68),('5819','2013-04-12','11:15:00',2.12),('5819','2013-04-12','11:20:00',4.34),('5819','2013-04-12','11:25:00',4.24),('5819','2013-04-12','11:30:00',3.17),('5819','2013-04-12','11:35:00',3.75),('5819','2013-04-12','11:40:00',4.18),('5819','2013-04-12','11:45:00',3.33),('5819','2013-04-12','11:50:00',3.04),('5819','2013-04-12','11:55:00',4.1),('5819','2013-04-12','12:00:00',4.07),('5819','2013-04-12','12:05:00',3.82),('5819','2013-04-12','12:10:00',3.83),('5819','2013-04-12','12:15:00',3.98),('5819','2013-04-12','12:20:00',4.1),('5819','2013-04-12','12:25:00',4.08),('5819','2013-04-12','12:30:00',4.02),('5819','2013-04-12','12:35:00',3.95),('5819','2013-04-12','12:40:00',3.86),('5819','2013-04-12','12:45:00',3.85),('5819','2013-04-12','12:50:00',3.86),('5819','2013-04-12','12:55:00',3.99),('5819','2013-04-12','13:00:00',4.02),('5819','2013-04-12','13:05:00',3.97),('5819','2013-04-12','13:10:00',3.97),('5819','2013-04-12','13:15:00',3.95),('5819','2013-04-12','13:20:00',3.95),('5819','2013-04-12','13:25:00',3.92),('5819','2013-04-12','13:30:00',3.87),('5819','2013-04-12','13:35:00',3.89),('5819','2013-04-12','13:40:00',3.82),('5819','2013-04-12','13:45:00',3.85),('5819','2013-04-12','13:50:00',3.8),('5819','2013-04-12','13:55:00',3.78),('5819','2013-04-12','14:00:00',3.77),('5819','2013-04-12','14:05:00',3.75),('5819','2013-04-12','14:10:00',3.71),('5819','2013-04-12','14:15:00',3.64),('5819','2013-04-12','14:20:00',3.6),('5819','2013-04-12','14:25:00',3.57),('5819','2013-04-12','14:30:00',3.53),('5819','2013-04-12','14:35:00',3.49),('5819','2013-04-12','14:40:00',3.43),('5819','2013-04-12','14:45:00',3.39),('5819','2013-04-12','14:50:00',3.33),('5819','2013-04-12','14:55:00',3.31),('5819','2013-04-12','15:00:00',3.26),('5819','2013-04-12','15:05:00',3.21),('5819','2013-04-12','15:10:00',3.14),('5819','2013-04-12','15:15:00',3.07),('5819','2013-04-12','15:20:00',3.03),('5819','2013-04-12','15:25:00',2.97),('5819','2013-04-12','15:30:00',2.91),('5819','2013-04-12','15:35:00',2.84),('5819','2013-04-12','15:40:00',2.78),('5819','2013-04-12','15:45:00',2.73),('5819','2013-04-12','15:50:00',2.66),('5819','2013-04-12','15:55:00',2.59),('5819','2013-04-12','16:00:00',2.52),('5819','2013-04-12','16:05:00',2.46),('5819','2013-04-12','16:10:00',2.41),('5819','2013-04-12','16:15:00',2.14),('5819','2013-04-12','16:20:00',2.19),('5819','2013-04-12','16:25:00',2.18),('5819','2013-04-12','16:30:00',1.41),('5819','2013-04-12','16:35:00',1.1),('5819','2013-04-12','16:40:00',1.2),('5819','2013-04-12','16:45:00',1.94),('5819','2013-04-12','16:50:00',1.78),('5819','2013-04-12','16:55:00',1.71),('5819','2013-04-12','17:00:00',1.62),('5819','2013-04-12','17:05:00',1.55),('5819','2013-04-12','17:10:00',1.46),('5819','2013-04-12','17:15:00',1.37),('5819','2013-04-12','17:20:00',1.3),('5819','2013-04-12','17:25:00',1.22),('5819','2013-04-12','17:30:00',1.1),('5819','2013-04-11','07:50:00',1.04),('5819','2013-04-11','07:55:00',1.13),('5819','2013-04-11','08:00:00',1.21),('5819','2013-04-11','08:05:00',1.3),('5819','2013-04-11','08:10:00',1.38),('5819','2013-04-11','08:15:00',1.46),('5819','2013-04-11','08:20:00',1.54),('5819','2013-04-11','08:25:00',1.63),('5819','2013-04-11','08:30:00',1.72),('5819','2013-04-11','08:35:00',1.8),('5819','2013-04-11','08:40:00',1.87),('5819','2013-04-11','08:45:00',1.95),('5819','2013-04-11','08:50:00',2.04),('5819','2013-04-11','08:55:00',2.13),('5819','2013-04-11','09:00:00',2.21),('5819','2013-04-11','09:05:00',2.28),('5819','2013-04-11','09:10:00',2.34),('5819','2013-04-11','09:15:00',2.43),('5819','2013-04-11','09:20:00',2.49),('5819','2013-04-11','09:25:00',2.56),('5819','2013-04-11','09:30:00',2.57),('5819','2013-04-11','09:35:00',2.64),('5819','2013-04-11','09:40:00',2.74),('5819','2013-04-11','09:45:00',2.83),('5819','2013-04-11','09:50:00',2.92),('5819','2013-04-11','09:55:00',2.59),('5819','2013-04-11','10:00:00',1.81),('5819','2013-04-11','10:10:00',1.55),('5819','2013-04-11','10:15:00',2.24),('5819','2013-04-11','10:20:00',3.36),('5819','2013-04-11','10:25:00',3.32),('5819','2013-04-11','10:30:00',3.37),('5819','2013-04-11','10:35:00',3.61),('5819','2013-04-11','10:40:00',3.69),('5819','2013-04-11','10:45:00',3.89),('5819','2013-04-11','10:50:00',1.98),('5819','2013-04-11','10:55:00',1.14),('5819','2013-04-11','11:05:00',3.67),('5819','2013-04-11','11:10:00',3.81),('5819','2013-04-11','11:15:00',3.82),('5819','2013-04-11','11:20:00',3.12),('5819','2013-04-11','11:25:00',1.46),('5819','2013-04-11','11:30:00',2.86),('5819','2013-04-11','11:35:00',4.12),('5819','2013-04-11','11:40:00',1.81),('5819','2013-04-11','11:45:00',1.24),('5819','2013-04-11','11:50:00',1.08),('5819','2013-04-11','11:55:00',1.6),('5819','2013-04-11','12:00:00',4),('5819','2013-04-11','12:05:00',4.31),('5819','2013-04-11','12:10:00',4.11),('5819','2013-04-11','12:15:00',1.39),('5819','2013-04-11','12:20:00',1.99),('5819','2013-04-11','12:25:00',4.34),('5819','2013-04-11','12:30:00',4.25),('5819','2013-04-11','12:35:00',4.22),('5819','2013-04-11','12:40:00',4.22),('5819','2013-04-11','12:45:00',4.21),('5819','2013-04-11','12:50:00',4.13),('5819','2013-04-11','12:55:00',3.54),('5819','2013-04-11','13:00:00',3.58),('5819','2013-04-11','13:05:00',3.75),('5819','2013-04-11','13:10:00',3.06),('5819','2013-04-11','13:15:00',4.07),('5819','2013-04-11','13:20:00',2.83),('5819','2013-04-11','13:25:00',3.45),('5819','2013-04-11','13:30:00',3.97),('5819','2013-04-11','13:35:00',3.88),('5819','2013-04-11','13:40:00',3.89),('5819','2013-04-11','13:45:00',3.84),('5819','2013-04-11','13:50:00',3.8),('5819','2013-04-11','13:55:00',3.86),('5819','2013-04-11','14:00:00',3.82),('5819','2013-04-11','14:05:00',3.77),('5819','2013-04-11','14:10:00',3.77),('5819','2013-04-11','14:15:00',3.73),('5819','2013-04-11','14:20:00',3.7),('5819','2013-04-11','14:25:00',3.64),('5819','2013-04-11','14:30:00',3.56),('5819','2013-04-11','14:35:00',3.36),('5819','2013-04-11','14:40:00',3.47),('5819','2013-04-11','14:45:00',3.58),('5819','2013-04-11','14:50:00',3.46),('5819','2013-04-11','14:55:00',3.41),('5819','2013-04-11','15:00:00',3.35),('5819','2013-04-11','15:05:00',3.27),('5819','2013-04-11','15:10:00',3.19),('5819','2013-04-11','15:15:00',3.14),('5819','2013-04-11','15:20:00',3.07),('5819','2013-04-11','15:25:00',3.02),('5819','2013-04-11','15:30:00',2.96),('5819','2013-04-11','15:35:00',2.9),('5819','2013-04-11','15:40:00',2.83),('5819','2013-04-11','15:45:00',2.76),('5819','2013-04-11','15:50:00',2.68),('5819','2013-04-11','15:55:00',2.63),('5819','2013-04-11','16:00:00',2.56),('5819','2013-04-11','16:05:00',2.5),('5819','2013-04-11','16:10:00',2.43),('5819','2013-04-11','16:15:00',2.35),('5819','2013-04-11','16:20:00',2.28),('5819','2013-04-11','16:25:00',2.2),('5819','2013-04-11','16:30:00',2.13),('5819','2013-04-11','16:35:00',2.05),('5819','2013-04-11','16:40:00',1.97),('5819','2013-04-11','16:45:00',1.89),('5819','2013-04-11','16:50:00',1.8),('5819','2013-04-11','16:55:00',1.73),('5819','2013-04-11','17:00:00',1.65),('5819','2013-04-11','17:05:00',1.56),('5819','2013-04-11','17:10:00',1.48),('5819','2013-04-11','17:15:00',1.4),('5819','2013-04-11','17:20:00',1.31),('5819','2013-04-11','17:25:00',1.22),('5819','2013-04-11','17:30:00',1.09),('5819','2013-04-11','17:35:00',1.01),('5819','2013-04-10','08:55:00',1.74),('5819','2013-04-10','09:00:00',2.16),('5819','2013-04-10','09:05:00',2.33),('5819','2013-04-10','09:10:00',2.42),('5819','2013-04-10','09:15:00',2.36),('5819','2013-04-10','09:20:00',2.39),('5819','2013-04-10','09:25:00',2.62),('5819','2013-04-10','09:30:00',2.66),('5819','2013-04-10','09:35:00',2.8),('5819','2013-04-10','09:40:00',2.85),('5819','2013-04-10','09:45:00',2.95),('5819','2013-04-10','09:50:00',3.04),('5819','2013-04-10','09:55:00',3.13),('5819','2013-04-10','10:00:00',3.16),('5819','2013-04-10','10:05:00',3.3),('5819','2013-04-10','10:10:00',3.47),('5819','2013-04-10','10:15:00',3.57),('5819','2013-04-10','10:20:00',3.58),('5819','2013-04-10','10:25:00',3.61),('5819','2013-04-10','10:30:00',3.62),('5819','2013-04-10','10:35:00',3.63),('5819','2013-04-10','10:40:00',3.66),('5819','2013-04-10','10:45:00',3.77),('5819','2013-04-10','10:50:00',3.56),('5819','2013-04-10','10:55:00',3.51),('5819','2013-04-10','11:00:00',3.52),('5819','2013-04-10','11:05:00',3.47),('5819','2013-04-10','11:10:00',3.56),('5819','2013-04-10','11:15:00',3.42),('5819','2013-04-10','11:20:00',3.74),('5819','2013-04-10','11:25:00',3.86),('5819','2013-04-10','11:30:00',3.86),('5819','2013-04-10','11:35:00',3.9),('5819','2013-04-10','11:40:00',3.87),('5819','2013-04-10','11:45:00',3.93),('5819','2013-04-10','11:50:00',3.96),('5819','2013-04-10','11:55:00',3.59),('5819','2013-04-10','12:00:00',4),('5819','2013-04-10','12:05:00',4.01),('5819','2013-04-10','12:10:00',4.03),('5819','2013-04-10','12:15:00',4.06),('5819','2013-04-10','12:20:00',4.06),('5819','2013-04-10','12:25:00',4.12),('5819','2013-04-10','12:30:00',4.16),('5819','2013-04-10','12:35:00',4.12),('5819','2013-04-10','12:40:00',4.05),('5819','2013-04-10','12:45:00',4.05),('5819','2013-04-10','12:50:00',4.11),('5819','2013-04-10','12:55:00',3.94),('5819','2013-04-10','13:00:00',4.08),('5819','2013-04-10','13:05:00',4),('5819','2013-04-10','13:10:00',3.76),('5819','2013-04-10','13:15:00',3.05),('5819','2013-04-10','13:20:00',4.57),('5819','2013-04-10','13:25:00',2.55),('5819','2013-04-10','13:30:00',2.66),('5819','2013-04-10','13:35:00',3.8),('5819','2013-04-10','13:40:00',3.19),('5819','2013-04-10','13:45:00',4.14),('5819','2013-04-10','13:50:00',3.08),('5819','2013-04-10','13:55:00',3.3),('5819','2013-04-10','14:00:00',3.1),('5819','2013-04-10','14:05:00',3.93),('5819','2013-04-10','14:10:00',3.82),('5819','2013-04-10','14:15:00',3.83),('5819','2013-04-10','14:20:00',3.8),('5819','2013-04-10','14:25:00',3.78),('5819','2013-04-10','14:30:00',3.73),('5819','2013-04-10','14:35:00',3.69),('5819','2013-04-10','14:40:00',3.67),('5819','2013-04-10','14:45:00',3.35),('5819','2013-04-10','14:50:00',3.39),('5819','2013-04-10','14:55:00',3.24),('5819','2013-04-10','15:00:00',3.56),('5819','2013-04-10','15:05:00',3.51),('5819','2013-04-10','15:10:00',3.41),('5819','2013-04-10','15:15:00',2.74),('5819','2013-04-10','15:20:00',2.4),('5819','2013-04-10','15:25:00',3.26),('5819','2013-04-10','15:30:00',3.01),('5819','2013-04-10','15:35:00',2.53),('5819','2013-04-10','15:40:00',2.95),('5819','2013-04-10','15:45:00',2.86),('5819','2013-04-10','15:50:00',2.99),('5819','2013-04-10','15:55:00',2.32),('5819','2013-04-10','16:00:00',2.7),('5819','2013-04-10','16:05:00',2.17),('5819','2013-04-10','16:10:00',2.49),('5819','2013-04-10','16:15:00',2.27),('5819','2013-04-10','16:20:00',2.44),('5819','2013-04-10','16:25:00',1.95),('5819','2013-04-10','16:30:00',2.2),('5819','2013-04-10','16:35:00',1.21),('5819','2013-04-10','16:40:00',1.98),('5819','2013-04-10','16:45:00',1.9),('5819','2013-04-10','16:50:00',1.81),('5819','2013-04-10','16:55:00',1),('5819','2013-04-10','17:00:00',1.92),('5819','2013-04-10','17:05:00',1.49),('5819','2013-04-10','17:10:00',1.19),('5819','2013-04-10','17:15:00',1.39),('5819','2013-04-10','17:20:00',1.51),('5819','2013-04-10','17:25:00',1.13),('5819','2013-04-10','17:30:00',1.05),('5819','2013-04-10','17:35:00',1),('5819','2013-04-09','07:55:00',1.07),('5819','2013-04-09','08:00:00',1.26),('5819','2013-04-09','08:10:00',1.04),('5819','2013-04-09','08:20:00',1.54),('5819','2013-04-09','08:35:00',1.09),('5819','2013-04-09','09:15:00',1.13),('5819','2013-04-09','09:20:00',1.11),('5819','2013-04-09','09:25:00',1.05),('5819','2013-04-09','09:30:00',1.18),('5819','2013-04-09','09:35:00',1.02),('5819','2013-04-09','09:50:00',1.63),('5819','2013-04-09','09:55:00',3.13),('5819','2013-04-09','10:00:00',1.82),('5819','2013-04-09','10:10:00',1.29),('5819','2013-04-09','10:15:00',2.03),('5819','2013-04-09','10:20:00',1.87),('5819','2013-04-09','10:35:00',3.04),('5819','2013-04-09','10:40:00',2.03),('5819','2013-04-09','10:45:00',3.26),('5819','2013-04-09','10:50:00',4.06),('5819','2013-04-09','10:55:00',3.12),('5819','2013-04-09','11:00:00',3.16),('5819','2013-04-09','11:05:00',3.52),('5819','2013-04-09','11:10:00',4.05),('5819','2013-04-09','11:15:00',2.4),('5819','2013-04-09','11:25:00',3.79),('5819','2013-04-09','11:30:00',4.58),('5819','2013-04-09','11:35:00',3.56),('5819','2013-04-09','11:45:00',2.82),('5819','2013-04-09','11:50:00',4.17),('5819','2013-04-09','11:55:00',2.3),('5819','2013-04-09','12:00:00',4.52),('5819','2013-04-09','12:05:00',4.28),('5819','2013-04-09','12:10:00',4.27),('5819','2013-04-09','12:15:00',4.27),('5819','2013-04-09','12:20:00',3.07),('5819','2013-04-09','12:25:00',3.9),('5819','2013-04-09','12:30:00',4.17),('5819','2013-04-09','12:35:00',3.83),('5819','2013-04-09','12:40:00',4.17),('5819','2013-04-09','12:45:00',4.12),('5819','2013-04-09','12:50:00',4.24),('5819','2013-04-09','12:55:00',4.19),('5819','2013-04-09','13:00:00',4.21),('5819','2013-04-09','13:05:00',4.28),('5819','2013-04-09','13:10:00',4.41),('5819','2013-04-09','13:15:00',4.32),('5819','2013-04-09','13:20:00',2.75),('5819','2013-04-09','13:25:00',3.94),('5819','2013-04-09','13:30:00',3.4),('5819','2013-04-09','13:35:00',1.26),('5819','2013-04-09','13:40:00',2.13),('5819','2013-04-09','13:45:00',1.45),('5819','2013-04-09','13:50:00',2.94),('5819','2013-04-09','13:55:00',3.92),('5819','2013-04-09','14:00:00',3.7),('5819','2013-04-09','14:05:00',3.47),('5819','2013-04-09','14:10:00',2.91),('5819','2013-04-09','14:15:00',3.35),('5819','2013-04-09','14:20:00',1.97),('5819','2013-04-09','14:25:00',2.38),('5819','2013-04-09','14:30:00',3.32),('5819','2013-04-09','14:35:00',3.36),('5819','2013-04-09','14:40:00',3.51),('5819','2013-04-09','14:45:00',3.24),('5819','2013-04-09','14:50:00',3.15),('5819','2013-04-09','14:55:00',3.16),('5819','2013-04-09','15:00:00',2.59),('5819','2013-04-09','15:05:00',2.7),('5819','2013-04-09','15:10:00',3.47),('5819','2013-04-09','15:15:00',2.37),('5819','2013-04-09','15:20:00',3.3),('5819','2013-04-09','15:25:00',3.37),('5819','2013-04-09','15:30:00',2.92),('5819','2013-04-09','15:35:00',2.07),('5819','2013-04-09','15:40:00',3.14),('5819','2013-04-09','15:45:00',2.36),('5819','2013-04-09','15:50:00',2.82),('5819','2013-04-09','15:55:00',2.52),('5819','2013-04-09','16:00:00',2.3),('5819','2013-04-09','16:05:00',2.44),('5819','2013-04-09','16:10:00',2.54),('5819','2013-04-09','16:15:00',1.82),('5819','2013-04-09','16:20:00',1.37),('5819','2013-04-09','16:25:00',1.12),('5819','2013-04-09','16:35:00',1.33),('5819','2013-04-09','16:40:00',1.08),('5819','2013-04-09','16:50:00',1.72),('5819','2013-04-09','16:55:00',1.85),('5819','2013-04-09','17:30:00',1.09),('5819','2013-04-08','08:40:00',1.15),('5819','2013-04-08','08:45:00',1.21),('5819','2013-04-08','08:50:00',1.53),('5819','2013-04-08','08:55:00',1.18),('5819','2013-04-08','09:00:00',1.45),('5819','2013-04-08','09:05:00',1.6),('5819','2013-04-08','09:10:00',2.03),('5819','2013-04-08','09:15:00',1.67),('5819','2013-04-08','09:20:00',2.27),('5819','2013-04-08','09:25:00',1.88),('5819','2013-04-08','09:30:00',2.67),('5819','2013-04-08','09:35:00',2.92),('5819','2013-04-08','09:40:00',3.02),('5819','2013-04-08','09:45:00',3.02),('5819','2013-04-08','09:50:00',2.27),('5819','2013-04-08','09:55:00',1.51),('5819','2013-04-08','10:00:00',3.14),('5819','2013-04-08','10:05:00',3.32),('5819','2013-04-08','10:10:00',3.19),('5819','2013-04-08','10:15:00',3.3),('5819','2013-04-08','10:20:00',3.27),('5819','2013-04-08','10:25:00',3.26),('5819','2013-04-08','10:30:00',3.3),('5819','2013-04-08','10:35:00',3.17),('5819','2013-04-08','10:40:00',3.42),('5819','2013-04-08','10:45:00',3.55),('5819','2013-04-08','10:50:00',3.61),('5819','2013-04-08','10:55:00',3.45),('5819','2013-04-08','11:00:00',3.61),('5819','2013-04-08','11:05:00',3.23),('5819','2013-04-08','11:10:00',2.71),('5819','2013-04-08','11:15:00',2.77),('5819','2013-04-08','11:20:00',2.3),('5819','2013-04-08','11:25:00',1.95),('5819','2013-04-08','11:30:00',2.09),('5819','2013-04-08','11:35:00',2.7),('5819','2013-04-08','11:40:00',3.04),('5819','2013-04-08','11:45:00',2.75),('5819','2013-04-08','11:50:00',2.61),('5819','2013-04-08','11:55:00',2.22),('5819','2013-04-08','12:00:00',2.13),('5819','2013-04-08','12:05:00',2),('5819','2013-04-08','12:10:00',2.11),('5819','2013-04-08','12:15:00',2.52),('5819','2013-04-08','12:20:00',2.55),('5819','2013-04-08','12:25:00',2.6),('5819','2013-04-08','12:30:00',2.8),('5819','2013-04-08','12:35:00',2.64),('5819','2013-04-08','12:40:00',2.02),('5819','2013-04-08','12:45:00',2.13),('5819','2013-04-08','12:50:00',2.64),('5819','2013-04-08','12:55:00',2.93),('5819','2013-04-08','13:00:00',2.06),('5819','2013-04-08','13:05:00',2.14),('5819','2013-04-08','13:10:00',2.61),('5819','2013-04-08','13:15:00',2.74),('5819','2013-04-08','13:20:00',3.41),('5819','2013-04-08','13:25:00',3.04),('5819','2013-04-08','13:30:00',2.64),('5819','2013-04-08','13:35:00',2.87),('5819','2013-04-08','13:40:00',3.32),('5819','2013-04-08','13:45:00',2.69),('5819','2013-04-08','13:50:00',2.75),('5819','2013-04-08','13:55:00',3.55),('5819','2013-04-08','14:00:00',3.57),('5819','2013-04-08','14:05:00',2.89),('5819','2013-04-08','14:10:00',3.02),('5819','2013-04-08','14:15:00',3.36),('5819','2013-04-08','14:20:00',3.08),('5819','2013-04-08','14:25:00',3.53),('5819','2013-04-08','14:30:00',3.44),('5819','2013-04-08','14:35:00',3.27),('5819','2013-04-08','14:40:00',3.17),('5819','2013-04-08','14:45:00',3.25),('5819','2013-04-08','14:50:00',3.24),('5819','2013-04-08','14:55:00',3.4),('5819','2013-04-08','15:00:00',2.71),('5819','2013-04-08','15:05:00',2.68),('5819','2013-04-08','15:10:00',2.52),('5819','2013-04-08','15:15:00',2.7),('5819','2013-04-08','15:20:00',2.28),('5819','2013-04-08','15:25:00',3.05),('5819','2013-04-08','15:30:00',3.12),('5819','2013-04-08','15:35:00',2.97),('5819','2013-04-08','15:40:00',2.86),('5819','2013-04-08','15:45:00',2.77),('5819','2013-04-08','15:50:00',2.69),('5819','2013-04-08','15:55:00',2.63),('5819','2013-04-08','16:00:00',2.56),('5819','2013-04-08','16:05:00',2.42),('5819','2013-04-08','16:10:00',2.22),('5819','2013-04-08','16:15:00',2.35),('5819','2013-04-08','16:20:00',2.34),('5819','2013-04-08','16:25:00',2.2),('5819','2013-04-08','16:30:00',2.12),('5819','2013-04-08','16:35:00',2.04),('5819','2013-04-08','16:40:00',1.96),('5819','2013-04-08','16:45:00',1.89),('5819','2013-04-08','16:50:00',1.82),('5819','2013-04-08','16:55:00',1.73),('5819','2013-04-08','17:00:00',1.66),('5819','2013-04-08','17:05:00',1.59),('5819','2013-04-08','17:10:00',1.47),('5819','2013-04-08','17:15:00',1.41),('5819','2013-04-08','17:20:00',1.28),('5819','2013-04-08','17:25:00',1.3),('5819','2013-04-08','17:30:00',1.19),('5819','2013-04-08','17:35:00',1.01),('5819','2013-04-07','08:25:00',1.12),('5819','2013-04-07','08:30:00',1.25),('5819','2013-04-07','08:35:00',1.35),('5819','2013-04-07','08:40:00',1.42),('5819','2013-04-07','08:45:00',1.45),('5819','2013-04-07','08:50:00',1.49),('5819','2013-04-07','08:55:00',1.53),('5819','2013-04-07','09:00:00',1.47),('5819','2013-04-07','09:05:00',1.5),('5819','2013-04-07','09:10:00',1.6),('5819','2013-04-07','09:15:00',1.57),('5819','2013-04-07','09:20:00',1.68),('5819','2013-04-07','09:25:00',1.65),('5819','2013-04-07','09:30:00',1.59),('5819','2013-04-07','09:35:00',1.48),('5819','2013-04-07','09:40:00',1.56),('5819','2013-04-07','09:45:00',1.99),('5819','2013-04-07','09:50:00',2.12),('5819','2013-04-07','09:55:00',2.34),('5819','2013-04-07','10:00:00',2.71),('5819','2013-04-07','10:05:00',2.77),('5819','2013-04-07','10:10:00',2.77),('5819','2013-04-07','10:15:00',2.84),('5819','2013-04-07','10:20:00',2.91),('5819','2013-04-07','10:25:00',2.84),('5819','2013-04-07','10:30:00',2.5),('5819','2013-04-07','10:35:00',2.78),('5819','2013-04-07','10:40:00',2.71),('5819','2013-04-07','10:45:00',2.67),('5819','2013-04-07','10:50:00',2.6),('5819','2013-04-07','10:55:00',2.32),('5819','2013-04-07','11:00:00',2.07),('5819','2013-04-07','11:05:00',1.79),('5819','2013-04-07','11:10:00',2.15),('5819','2013-04-07','11:15:00',2.94),('5819','2013-04-07','11:20:00',3.35),('5819','2013-04-07','11:25:00',3.65),('5819','2013-04-07','11:30:00',3.48),('5819','2013-04-07','11:35:00',3.27),('5819','2013-04-07','11:40:00',2.92),('5819','2013-04-07','11:45:00',2.33),('5819','2013-04-07','11:50:00',2.22),('5819','2013-04-07','11:55:00',2.35),('5819','2013-04-07','12:00:00',2.44),('5819','2013-04-07','12:05:00',2.36),('5819','2013-04-07','12:10:00',2.55),('5819','2013-04-07','12:15:00',2.47),('5819','2013-04-07','12:20:00',2.67),('5819','2013-04-07','12:25:00',2.94),('5819','2013-04-07','12:30:00',2.49),('5819','2013-04-07','12:35:00',2.69),('5819','2013-04-07','12:40:00',2.65),('5819','2013-04-07','12:45:00',2.29),('5819','2013-04-07','12:50:00',2.39),('5819','2013-04-07','12:55:00',2.58),('5819','2013-04-07','13:00:00',2.99),('5819','2013-04-07','13:05:00',3.26),('5819','2013-04-07','13:10:00',3.18),('5819','2013-04-07','13:15:00',2.8),('5819','2013-04-07','13:20:00',2.61),('5819','2013-04-07','13:25:00',2.99),('5819','2013-04-07','13:30:00',3.08),('5819','2013-04-07','13:35:00',2.78),('5819','2013-04-07','13:40:00',2.95),('5819','2013-04-07','13:45:00',3.27),('5819','2013-04-07','13:50:00',3),('5819','2013-04-07','13:55:00',2.81),('5819','2013-04-07','14:00:00',3.31),('5819','2013-04-07','14:05:00',2.99),('5819','2013-04-07','14:10:00',2.31),('5819','2013-04-07','14:15:00',2.11),('5819','2013-04-07','14:20:00',1.87),('5819','2013-04-07','14:25:00',2.21),('5819','2013-04-07','14:30:00',2.31),('5819','2013-04-07','14:35:00',2.11),('5819','2013-04-07','14:40:00',1.76),('5819','2013-04-07','14:45:00',1.94),('5819','2013-04-07','14:50:00',2.15),('5819','2013-04-07','14:55:00',2.02),('5819','2013-04-07','15:00:00',2.05),('5819','2013-04-07','15:05:00',2.6),('5819','2013-04-07','15:10:00',2.57),('5819','2013-04-07','15:15:00',2.54),('5819','2013-04-07','15:20:00',2.56),('5819','2013-04-07','15:25:00',2.71),('5819','2013-04-07','15:30:00',2.56),('5819','2013-04-07','15:35:00',2.4),('5819','2013-04-07','15:40:00',2.43),('5819','2013-04-07','15:45:00',2.28),('5819','2013-04-07','15:50:00',2.1),('5819','2013-04-07','15:55:00',2.22),('5819','2013-04-07','16:00:00',2.06),('5819','2013-04-07','16:05:00',1.84),('5819','2013-04-07','16:10:00',1.56),('5819','2013-04-07','16:15:00',1.39),('5819','2013-04-07','16:20:00',1.31),('5819','2013-04-07','16:25:00',1.21),('5819','2013-04-07','16:30:00',1.21),('5819','2013-04-07','16:35:00',1.3),('5819','2013-04-07','16:40:00',1.38),('5819','2013-04-07','16:45:00',1.74),('5819','2013-04-07','16:50:00',1.86),('5819','2013-04-07','16:55:00',1.71),('5819','2013-04-07','17:00:00',1.58),('5819','2013-04-07','17:05:00',1.2),('5819','2013-04-07','17:20:00',1.34),('5819','2013-04-07','17:25:00',1.27),('5819','2013-04-07','17:30:00',1.38),('5819','2013-04-07','17:35:00',1.23),('5819','2013-04-07','17:40:00',1.17),('5819','2013-04-07','17:45:00',1.12),('5819','2013-04-07','17:50:00',1),('5819','2013-04-06','07:55:00',1.07),('5819','2013-04-06','08:00:00',1.15),('5819','2013-04-06','08:05:00',1.24),('5819','2013-04-06','08:10:00',1.33),('5819','2013-04-06','08:15:00',1.42),('5819','2013-04-06','08:20:00',1.5),('5819','2013-04-06','08:25:00',1.58),('5819','2013-04-06','08:30:00',1.67),('5819','2013-04-06','08:35:00',1.75),('5819','2013-04-06','08:40:00',1.82),('5819','2013-04-06','08:45:00',1.89),('5819','2013-04-06','08:50:00',1.98),('5819','2013-04-06','08:55:00',2.06),('5819','2013-04-06','09:00:00',2.13),('5819','2013-04-06','09:05:00',2.23),('5819','2013-04-06','09:10:00',2.3),('5819','2013-04-06','09:15:00',2.4),('5819','2013-04-06','09:20:00',2.47),('5819','2013-04-06','09:25:00',2.54),('5819','2013-04-06','09:30:00',2.6),('5819','2013-04-06','09:35:00',2.61),('5819','2013-04-06','09:40:00',2.72),('5819','2013-04-06','09:45:00',2.76),('5819','2013-04-06','09:50:00',2.81),('5819','2013-04-06','09:55:00',2.88),('5819','2013-04-06','10:00:00',2.96),('5819','2013-04-06','10:05:00',2.98),('5819','2013-04-06','10:10:00',3.03),('5819','2013-04-06','10:15:00',3.03),('5819','2013-04-06','10:20:00',3.13),('5819','2013-04-06','10:25:00',3.18),('5819','2013-04-06','10:30:00',3.28),('5819','2013-04-06','10:35:00',3.28),('5819','2013-04-06','10:40:00',3.33),('5819','2013-04-06','10:45:00',3.36),('5819','2013-04-06','10:50:00',3.41),('5819','2013-04-06','10:55:00',3.45),('5819','2013-04-06','11:00:00',3.5),('5819','2013-04-06','11:05:00',3.54),('5819','2013-04-06','11:10:00',3.59),('5819','2013-04-06','11:15:00',3.58),('5819','2013-04-06','11:20:00',3.65),('5819','2013-04-06','11:25:00',3.71),('5819','2013-04-06','11:30:00',3.72),('5819','2013-04-06','11:35:00',3.76),('5819','2013-04-06','11:40:00',3.79),('5819','2013-04-06','11:45:00',3.78),('5819','2013-04-06','11:50:00',3.78),('5819','2013-04-06','11:55:00',3.8),('5819','2013-04-06','12:00:00',3.75),('5819','2013-04-06','12:05:00',3.79),('5819','2013-04-06','12:10:00',3.77),('5819','2013-04-06','12:15:00',3.77),('5819','2013-04-06','12:20:00',3.64),('5819','2013-04-06','12:25:00',3.23),('5819','2013-04-06','12:30:00',3.66),('5819','2013-04-06','12:35:00',3.93),('5819','2013-04-06','12:40:00',3.88),('5819','2013-04-06','12:45:00',3.89),('5819','2013-04-06','12:50:00',3.89),('5819','2013-04-06','12:55:00',3.9),('5819','2013-04-06','13:00:00',3.86),('5819','2013-04-06','13:05:00',3.86),('5819','2013-04-06','13:10:00',3.82),('5819','2013-04-06','13:15:00',2.99),('5819','2013-04-06','13:20:00',2.3),('5819','2013-04-06','13:30:00',2.38),('5819','2013-04-06','13:35:00',3.99),('5819','2013-04-06','13:40:00',4.31),('5819','2013-04-06','13:45:00',4.27),('5819','2013-04-06','13:50:00',3.99),('5819','2013-04-06','13:55:00',3.98),('5819','2013-04-06','14:00:00',3.72),('5819','2013-04-06','14:05:00',3.83),('5819','2013-04-06','14:10:00',1.61),('5819','2013-04-06','14:15:00',3.91),('5819','2013-04-06','14:20:00',1.75),('5819','2013-04-06','14:25:00',2.7),('5819','2013-04-06','14:30:00',2.99),('5819','2013-04-06','14:35:00',3.5),('5819','2013-04-06','14:40:00',3.53),('5819','2013-04-06','14:45:00',3.33),('5819','2013-04-06','14:50:00',3.33),('5819','2013-04-06','14:55:00',2.77),('5819','2013-04-06','15:00:00',3.25),('5819','2013-04-06','15:05:00',3.23),('5819','2013-04-06','15:10:00',2.8),('5819','2013-04-06','15:15:00',3.02),('5819','2013-04-06','15:20:00',2.96),('5819','2013-04-06','15:25:00',2.92),('5819','2013-04-06','15:30:00',2.79),('5819','2013-04-06','15:35:00',2.72),('5819','2013-04-06','15:40:00',2.7),('5819','2013-04-06','15:45:00',2.44),('5819','2013-04-06','15:50:00',2.35),('5819','2013-04-06','15:55:00',2.56),('5819','2013-04-06','16:00:00',2.3),('5819','2013-04-06','16:05:00',2.43),('5819','2013-04-06','16:10:00',2.44),('5819','2013-04-06','16:15:00',2.24),('5819','2013-04-06','16:20:00',1.85),('5819','2013-04-06','16:25:00',1.54),('5819','2013-04-06','16:30:00',1.86),('5819','2013-04-06','16:35:00',1.79),('5819','2013-04-06','16:40:00',1.4),('5819','2013-04-06','16:45:00',1.85),('5819','2013-04-06','16:50:00',1.69),('5819','2013-04-06','16:55:00',1.46),('5819','2013-04-06','17:00:00',1.51),('5819','2013-04-06','17:05:00',1.23),('5819','2013-04-06','17:10:00',1.16),('5819','2013-04-05','08:20:00',1.28),('5819','2013-04-05','08:25:00',1.04),('5819','2013-04-05','08:55:00',1.53),('5819','2013-04-05','09:00:00',1),('5819','2013-04-05','09:05:00',2.53),('5819','2013-04-05','09:10:00',1.52),('5819','2013-04-05','09:15:00',2.46),('5819','2013-04-05','09:20:00',2.18),('5819','2013-04-05','09:25:00',1.11),('5819','2013-04-05','09:35:00',1.36),('5819','2013-04-05','09:40:00',2.28),('5819','2013-04-05','09:45:00',2.32),('5819','2013-04-05','09:50:00',1.2),('5819','2013-04-05','10:00:00',1.22),('5819','2013-04-05','10:10:00',2.18),('5819','2013-04-05','10:15:00',3.32),('5819','2013-04-05','10:20:00',1.36),('5819','2013-04-05','10:25:00',2.47),('5819','2013-04-05','10:30:00',2.53),('5819','2013-04-05','10:35:00',2.4),('5819','2013-04-05','10:40:00',3.43),('5819','2013-04-05','10:45:00',2.31),('5819','2013-04-05','10:50:00',2.16),('5819','2013-04-05','10:55:00',2.33),('5819','2013-04-05','11:00:00',2.38),('5819','2013-04-05','11:05:00',3.16),('5819','2013-04-05','11:10:00',3.96),('5819','2013-04-05','11:15:00',4),('5819','2013-04-05','11:20:00',2.76),('5819','2013-04-05','11:25:00',3.28),('5819','2013-04-05','11:30:00',3.22),('5819','2013-04-05','11:35:00',3.99),('5819','2013-04-05','11:40:00',3.62),('5819','2013-04-05','11:45:00',3.7),('5819','2013-04-05','11:50:00',2.82),('5819','2013-04-05','11:55:00',3.7),('5819','2013-04-05','12:00:00',4.08),('5819','2013-04-05','12:05:00',3.37),('5819','2013-04-05','12:10:00',3.28),('5819','2013-04-05','12:15:00',2.02),('5819','2013-04-05','12:20:00',1.47),('5819','2013-04-05','12:25:00',1.89),('5819','2013-04-05','12:30:00',1.22),('5819','2013-04-05','12:35:00',1.25),('5819','2013-04-05','12:40:00',1.56),('5819','2013-04-05','12:45:00',3.46),('5819','2013-04-05','12:50:00',4.27),('5819','2013-04-05','12:55:00',4.09),('5819','2013-04-05','13:00:00',2.76),('5819','2013-04-05','13:05:00',3.75),('5819','2013-04-05','13:10:00',2.53),('5819','2013-04-05','13:15:00',2.32),('5819','2013-04-05','13:20:00',2.21),('5819','2013-04-05','13:25:00',2.91),('5819','2013-04-05','13:30:00',2.44),('5819','2013-04-05','13:35:00',3.25),('5819','2013-04-05','13:40:00',4.21),('5819','2013-04-05','13:45:00',2.52),('5819','2013-04-05','13:50:00',4.38),('5819','2013-04-05','13:55:00',3.82),('5819','2013-04-05','14:00:00',2.49),('5819','2013-04-05','14:05:00',4.44),('5819','2013-04-05','14:10:00',3.25),('5819','2013-04-05','14:15:00',3.37),('5819','2013-04-05','14:20:00',3.71),('5819','2013-04-05','14:25:00',3.79),('5819','2013-04-05','14:30:00',3.66),('5819','2013-04-05','14:35:00',3.74),('5819','2013-04-05','14:40:00',3.66),('5819','2013-04-05','14:45:00',3.35),('5819','2013-04-05','14:50:00',2.26),('5819','2013-04-05','14:55:00',3.92),('5819','2013-04-05','15:00:00',3.41),('5819','2013-04-05','15:05:00',3.2),('5819','2013-04-05','15:10:00',3.13),('5819','2013-04-05','15:15:00',1.57),('5819','2013-04-05','15:20:00',1.6),('5819','2013-04-05','15:25:00',2),('5819','2013-04-05','15:30:00',1.63),('5819','2013-04-05','15:35:00',1.36),('5819','2013-04-05','15:40:00',1.08),('5819','2013-04-05','15:45:00',1.33),('5819','2013-04-05','15:50:00',1.6),('5819','2013-04-05','15:55:00',1.51),('5819','2013-04-05','16:00:00',1.62),('5819','2013-04-05','16:05:00',1.45),('5819','2013-04-05','16:10:00',1.34),('5819','2013-04-05','16:15:00',2.06),('5819','2013-04-05','16:20:00',1.76),('5819','2013-04-05','16:25:00',1.78),('5819','2013-04-05','16:30:00',1.32),('5819','2013-04-05','16:35:00',1.44),('5819','2013-04-05','16:40:00',1.29),('5819','2013-04-05','16:45:00',1.72),('5819','2013-04-05','16:50:00',2.5),('5819','2013-04-05','16:55:00',1.4),('5819','2013-04-05','17:00:00',1.38),('5819','2013-04-05','17:05:00',1.05),('5819','2013-04-05','17:10:00',1.51),('5819','2013-04-05','17:15:00',1.58),('5819','2013-04-05','17:20:00',1.09),('5819','2013-04-05','17:30:00',1.51),('5819','2013-04-05','17:35:00',1.15),('5819','2013-04-05','17:55:00',1.06),('5819','2013-04-04','08:55:00',1.31),('5819','2013-04-04','09:00:00',2.08),('5819','2013-04-04','09:05:00',1.42),('5819','2013-04-04','09:10:00',1.21),('5819','2013-04-04','09:15:00',1.22),('5819','2013-04-04','09:20:00',1.39),('5819','2013-04-04','09:30:00',1.41),('5819','2013-04-04','09:35:00',2.52),('5819','2013-04-04','09:40:00',2.37),('5819','2013-04-04','09:45:00',2),('5819','2013-04-04','09:50:00',1.16),('5819','2013-04-04','09:55:00',1.14),('5819','2013-04-04','10:00:00',1.73),('5819','2013-04-04','10:05:00',2.42),('5819','2013-04-04','10:10:00',2.34),('5819','2013-04-04','10:15:00',1.59),('5819','2013-04-04','10:20:00',1.61),('5819','2013-04-04','10:25:00',3.28),('5819','2013-04-04','10:30:00',3.25),('5819','2013-04-04','10:35:00',1.99),('5819','2013-04-04','10:40:00',3.84),('5819','2013-04-04','10:45:00',2.16),('5819','2013-04-04','10:50:00',2.3),('5819','2013-04-04','10:55:00',3.49),('5819','2013-04-04','11:00:00',2.18),('5819','2013-04-04','11:05:00',1.2),('5819','2013-04-04','11:10:00',1),('5819','2013-04-04','11:15:00',1.31),('5819','2013-04-04','11:20:00',1.33),('5819','2013-04-04','11:30:00',1.06),('5819','2013-04-04','11:35:00',1.47),('5819','2013-04-04','11:40:00',2.61),('5819','2013-04-04','11:45:00',3.18),('5819','2013-04-04','11:50:00',3.67),('5819','2013-04-04','11:55:00',3.83),('5819','2013-04-04','12:00:00',3.82),('5819','2013-04-04','12:05:00',3.73),('5819','2013-04-04','12:10:00',3.84),('5819','2013-04-04','12:15:00',3.73),('5819','2013-04-04','12:20:00',3.42),('5819','2013-04-04','12:25:00',3.01),('5819','2013-04-04','12:30:00',2.79),('5819','2013-04-04','12:35:00',2.38),('5819','2013-04-04','12:40:00',3.56),('5819','2013-04-04','12:45:00',2.48),('5819','2013-04-04','12:50:00',3.36),('5819','2013-04-04','12:55:00',3.67),('5819','2013-04-04','13:00:00',3.52),('5819','2013-04-04','13:05:00',3.64),('5819','2013-04-04','13:10:00',3.76),('5819','2013-04-04','13:15:00',3.91),('5819','2013-04-04','13:20:00',3.77),('5819','2013-04-04','13:25:00',3.83),('5819','2013-04-04','13:30:00',3.77),('5819','2013-04-04','13:35:00',3.48),('5819','2013-04-04','13:40:00',2.94),('5819','2013-04-04','13:45:00',2.93),('5819','2013-04-04','13:50:00',2.88),('5819','2013-04-04','13:55:00',2.27),('5819','2013-04-04','14:00:00',2.34),('5819','2013-04-04','14:05:00',3.11),('5819','2013-04-04','14:10:00',3.57),('5819','2013-04-04','14:15:00',3.52),('5819','2013-04-04','14:20:00',3.42),('5819','2013-04-04','14:25:00',3.32),('5819','2013-04-04','14:30:00',3.3),('5819','2013-04-04','14:35:00',3.25),('5819','2013-04-04','14:40:00',3.24),('5819','2013-04-04','14:45:00',3.18),('5819','2013-04-04','14:50:00',3.15),('5819','2013-04-04','14:55:00',3.14),('5819','2013-04-04','15:00:00',3.08),('5819','2013-04-04','15:05:00',2.97),('5819','2013-04-04','15:10:00',2.81),('5819','2013-04-04','15:15:00',2.74),('5819','2013-04-04','15:20:00',2.78),('5819','2013-04-04','15:25:00',2.8),('5819','2013-04-04','15:30:00',2.77),('5819','2013-04-04','15:35:00',2.71),('5819','2013-04-04','15:40:00',2.63),('5819','2013-04-04','15:45:00',2.56),('5819','2013-04-04','15:50:00',2.44),('5819','2013-04-04','15:55:00',2.39),('5819','2013-04-04','16:00:00',2.34),('5819','2013-04-04','16:05:00',2.27),('5819','2013-04-04','16:10:00',2.1),('5819','2013-04-04','16:15:00',2.07),('5819','2013-04-04','16:20:00',1.9),('5819','2013-04-04','16:25:00',1.9),('5819','2013-04-04','16:30:00',1.46),('5819','2013-04-04','16:35:00',1.57),('5819','2013-04-04','16:40:00',1.48),('5819','2013-04-04','16:45:00',1.45),('5819','2013-04-04','16:50:00',1.24),('5819','2013-04-04','16:55:00',1.49),('5819','2013-04-04','17:00:00',1.33),('5819','2013-04-04','17:05:00',1.31),('5819','2013-04-04','17:10:00',1.22),('5819','2013-04-04','17:15:00',1.11),('5819','2013-04-03','08:00:00',1.09),('5819','2013-04-03','08:05:00',1.18),('5819','2013-04-03','08:10:00',1.26),('5819','2013-04-03','08:15:00',1.28),('5819','2013-04-03','08:20:00',1.47),('5819','2013-04-03','08:25:00',1.43),('5819','2013-04-03','08:30:00',1.75),('5819','2013-04-03','08:35:00',2.02),('5819','2013-04-03','08:40:00',1.98),('5819','2013-04-03','08:45:00',2.05),('5819','2013-04-03','09:00:00',1.57),('5819','2013-04-03','09:05:00',2.46),('5819','2013-04-03','09:10:00',2.5),('5819','2013-04-03','09:15:00',2.61),('5819','2013-04-03','09:20:00',2.74),('5819','2013-04-03','09:25:00',1.59),('5819','2013-04-03','09:30:00',2.02),('5819','2013-04-03','09:35:00',1.5),('5819','2013-04-03','09:40:00',3.19),('5819','2013-04-03','09:45:00',2.31),('5819','2013-04-03','09:50:00',3.23),('5819','2013-04-03','09:55:00',3.54),('5819','2013-04-03','10:00:00',3.6),('5819','2013-04-03','10:05:00',1.26),('5819','2013-04-03','10:10:00',1.1),('5819','2013-04-03','10:15:00',1.43),('5819','2013-04-03','10:20:00',2.81),('5819','2013-04-03','10:25:00',3.54),('5819','2013-04-03','10:30:00',2.43),('5819','2013-04-03','10:35:00',2.13),('5819','2013-04-03','10:40:00',1.71),('5819','2013-04-03','10:45:00',1.65),('5819','2013-04-03','10:50:00',1.73),('5819','2013-04-03','10:55:00',3.2),('5819','2013-04-03','11:00:00',1.71),('5819','2013-04-03','11:05:00',4.21),('5819','2013-04-03','11:10:00',2.18),('5819','2013-04-03','11:15:00',2.74),('5819','2013-04-03','11:20:00',2.02),('5819','2013-04-03','11:25:00',2.6),('5819','2013-04-03','11:30:00',1.78),('5819','2013-04-03','11:35:00',1.4),('5819','2013-04-03','11:40:00',2.26),('5819','2013-04-03','11:45:00',1.26),('5819','2013-04-03','11:50:00',2.52),('5819','2013-04-03','11:55:00',2.12),('5819','2013-04-03','12:00:00',3.58),('5819','2013-04-03','12:05:00',2.78),('5819','2013-04-03','12:10:00',4.48),('5819','2013-04-03','12:15:00',1.58),('5819','2013-04-03','12:20:00',3.37),('5819','2013-04-03','12:25:00',2.83),('5819','2013-04-03','12:30:00',3.99),('5819','2013-04-03','12:35:00',3.46),('5819','2013-04-03','12:40:00',3.57),('5819','2013-04-03','12:45:00',4.03),('5819','2013-04-03','12:50:00',4.08),('5819','2013-04-03','12:55:00',4.17),('5819','2013-04-03','13:00:00',4.1),('5819','2013-04-03','13:05:00',3.02),('5819','2013-04-03','13:10:00',2.35),('5819','2013-04-03','13:15:00',4.26),('5819','2013-04-03','13:20:00',2.87),('5819','2013-04-03','13:25:00',2.48),('5819','2013-04-03','13:30:00',2.36),('5819','2013-04-03','13:35:00',3.36),('5819','2013-04-03','13:40:00',3.01),('5819','2013-04-03','13:45:00',3.45),('5819','2013-04-03','13:50:00',2.94),('5819','2013-04-03','13:55:00',3.78),('5819','2013-04-03','14:00:00',3.74),('5819','2013-04-03','14:05:00',2.68),('5819','2013-04-03','14:10:00',2.33),('5819','2013-04-03','14:15:00',3.37),('5819','2013-04-03','14:20:00',2.63),('5819','2013-04-03','14:25:00',3.36),('5819','2013-04-03','14:30:00',2.84),('5819','2013-04-03','14:35:00',3.57),('5819','2013-04-03','14:40:00',3.72),('5819','2013-04-03','14:45:00',3.04),('5819','2013-04-03','14:50:00',1.54),('5819','2013-04-03','14:55:00',1.97),('5819','2013-04-03','15:00:00',3.91),('5819','2013-04-03','15:05:00',3.41),('5819','2013-04-03','15:10:00',3.89),('5819','2013-04-03','15:15:00',3.49),('5819','2013-04-03','15:20:00',3.32),('5819','2013-04-03','15:25:00',3.44),('5819','2013-04-03','15:30:00',3.27),('5819','2013-04-03','15:35:00',3.21),('5819','2013-04-03','15:40:00',3.13),('5819','2013-04-03','15:45:00',2.61),('5819','2013-04-03','15:50:00',2.96),('5819','2013-04-03','15:55:00',2.71),('5819','2013-04-03','16:00:00',2.89),('5819','2013-04-03','16:05:00',2.73),('5819','2013-04-03','16:10:00',2.57),('5819','2013-04-03','16:15:00',2.5),('5819','2013-04-03','16:20:00',2.39),('5819','2013-04-03','16:25:00',2.32),('5819','2013-04-03','16:30:00',2.2),('5819','2013-04-03','16:35:00',1.94),('5819','2013-04-03','16:40:00',2.08),('5819','2013-04-03','16:45:00',1.94),('5819','2013-04-03','16:50:00',1.86),('5819','2013-04-03','16:55:00',1.77),('5819','2013-04-03','17:00:00',1.68),('5819','2013-04-03','17:05:00',1.59),('5819','2013-04-03','17:10:00',1.5),('5819','2013-04-03','17:15:00',1.42),('5819','2013-04-03','17:20:00',1.31),('5819','2013-04-03','17:25:00',1.24),('5819','2013-04-03','17:30:00',1.15),('5819','2013-04-03','17:35:00',1.07),('5819','2013-04-02','08:40:00',1.56),('5819','2013-04-02','08:45:00',2.04),('5819','2013-04-02','08:50:00',1.6),('5819','2013-04-02','08:55:00',1.04),('5819','2013-04-02','09:00:00',2.22),('5819','2013-04-02','09:05:00',2.29),('5819','2013-04-02','09:10:00',2.4),('5819','2013-04-02','09:15:00',2.58),('5819','2013-04-02','09:20:00',2.24),('5819','2013-04-02','09:30:00',2.99),('5819','2013-04-02','09:35:00',2.82),('5819','2013-04-02','09:40:00',2.07),('5819','2013-04-02','09:45:00',2.93),('5819','2013-04-02','09:50:00',2.01),('5819','2013-04-02','09:55:00',1.99),('5819','2013-04-02','10:00:00',2.14),('5819','2013-04-02','10:05:00',1.62),('5819','2013-04-02','10:10:00',1.68),('5819','2013-04-02','10:15:00',1.11),('5819','2013-04-02','10:20:00',1.99),('5819','2013-04-02','10:25:00',1.97),('5819','2013-04-02','10:35:00',1.24),('5819','2013-04-02','10:40:00',1.36),('5819','2013-04-02','10:45:00',3.02),('5819','2013-04-02','10:50:00',4.07),('5819','2013-04-02','10:55:00',1.85),('5819','2013-04-02','11:05:00',2.64),('5819','2013-04-02','11:10:00',2.52),('5819','2013-04-02','11:15:00',1.06),('5819','2013-04-02','11:35:00',1.59),('5819','2013-04-02','11:45:00',1.47),('5819','2013-04-02','11:50:00',1.68),('5819','2013-04-02','11:55:00',1.46),('5819','2013-04-02','12:05:00',1.99),('5819','2013-04-02','12:10:00',2.29),('5819','2013-04-02','12:15:00',2.74),('5819','2013-04-02','12:35:00',1.52),('5819','2013-04-02','12:40:00',2.3),('5819','2013-04-02','12:45:00',1.97),('5819','2013-04-02','12:50:00',2.13),('5819','2013-04-02','12:55:00',2.06),('5819','2013-04-02','13:00:00',2.08),('5819','2013-04-02','13:05:00',2.26),('5819','2013-04-02','13:10:00',3.11),('5819','2013-04-02','13:15:00',2.34),('5819','2013-04-02','13:20:00',1.82),('5819','2013-04-02','13:25:00',2.97),('5819','2013-04-02','13:30:00',2.68),('5819','2013-04-02','13:35:00',1.83),('5819','2013-04-02','13:40:00',2.21),('5819','2013-04-02','13:45:00',2.44),('5819','2013-04-02','13:50:00',2.03),('5819','2013-04-02','13:55:00',1.5),('5819','2013-04-02','14:00:00',2.33),('5819','2013-04-02','14:05:00',2.04),('5819','2013-04-02','14:10:00',3.15),('5819','2013-04-02','14:15:00',2.41),('5819','2013-04-02','14:20:00',3.47),('5819','2013-04-02','14:25:00',4.34),('5819','2013-04-02','14:30:00',3.4),('5819','2013-04-02','14:35:00',1.79),('5819','2013-04-02','14:40:00',2.1),('5819','2013-04-02','14:45:00',2.2),('5819','2013-04-02','14:50:00',2),('5819','2013-04-02','14:55:00',1.56),('5819','2013-04-02','15:00:00',1.57),('5819','2013-04-02','15:45:00',1.13),('5819','2013-04-02','16:05:00',1.07),('5819','2013-04-02','16:20:00',1.03),('5819','2013-04-02','17:45:00',1.16),('5819','2014-05-02','07:35:00',1.22),('5819','2014-05-02','07:40:00',1.25),('5819','2014-05-02','07:45:00',1.28),('5819','2014-05-02','07:50:00',1.39),('5819','2014-05-02','08:00:00',1.68),('5819','2014-05-02','08:05:00',1.75),('5819','2014-05-02','08:15:00',1.61),('5819','2014-05-02','08:20:00',2.64),('5819','2014-05-02','08:25:00',1.34),('5819','2014-05-02','08:30:00',1.18),('5819','2014-05-02','08:50:00',1.1),('5819','2014-05-02','09:20:00',1.2),('5819','2014-05-02','09:25:00',1.35),('5819','2014-05-02','09:30:00',1.72),('5819','2014-05-02','09:35:00',1.8),('5819','2014-05-02','09:40:00',1.36),('5819','2014-05-02','09:45:00',1.34),('5819','2014-05-02','09:50:00',1.43),('5819','2014-05-02','09:55:00',1.33),('5819','2014-05-02','10:00:00',1.73),('5819','2014-05-02','10:05:00',1.61),('5819','2014-05-02','10:10:00',1.77),('5819','2014-05-02','10:15:00',1.55),('5819','2014-05-02','10:20:00',1.48),('5819','2014-05-02','10:25:00',1.05),('5819','2014-05-02','10:45:00',1.03),('5819','2014-05-02','10:50:00',1.12),('5819','2014-05-02','12:35:00',1.17),('5819','2014-05-02','12:40:00',1.03),('5819','2014-05-02','12:45:00',1.08),('5819','2014-05-02','12:50:00',1.46),('5819','2014-05-02','12:55:00',1.52),('5819','2014-05-02','13:00:00',1.25),('5819','2014-05-02','13:05:00',1.53),('5819','2014-05-02','13:10:00',1.71),('5819','2014-05-02','13:15:00',1.99),('5819','2014-05-02','13:20:00',2.87),('5819','2014-05-02','13:25:00',2.55),('5819','2014-05-02','13:30:00',2.29),('5819','2014-05-02','13:35:00',2.08),('5819','2014-05-02','13:40:00',2.43),('5819','2014-05-02','13:45:00',1.9),('5819','2014-05-02','13:50:00',1.49),('5819','2014-05-02','13:55:00',1.15),('5819','2014-05-02','14:00:00',1.23),('5819','2014-05-02','14:05:00',1.34),('5819','2014-05-02','14:10:00',1.42),('5819','2014-05-02','14:35:00',1.22),('5819','2014-05-02','14:40:00',3),('5819','2014-05-02','14:45:00',2.19),('5819','2014-05-02','14:50:00',1.34),('5819','2014-05-02','14:55:00',1.67),('5819','2014-05-02','15:00:00',2.11),('5819','2014-05-02','15:05:00',1.89),('5819','2014-05-02','15:10:00',2.87),('5819','2014-05-02','15:15:00',4.18),('5819','2014-05-02','15:20:00',1.9),('5819','2014-05-02','15:25:00',1.68),('5819','2014-05-02','15:30:00',1.07),('5819','2014-05-02','15:35:00',1.97),('5819','2014-05-02','15:40:00',3.05),('5819','2014-05-02','15:45:00',1.41),('5819','2014-05-02','16:00:00',1.01),('5819','2014-05-02','16:05:00',1.77),('5819','2014-05-02','16:10:00',1.18),('5819','2014-05-02','16:20:00',2.5),('5819','2014-05-02','17:25:00',1.07),('5819','2013-04-01','08:25:00',1.51),('5819','2013-04-01','08:30:00',1.67),('5819','2013-04-01','08:35:00',1.86),('5819','2013-04-01','08:40:00',2.1),('5819','2013-04-01','08:45:00',1.04),('5819','2013-04-01','08:50:00',1.39),('5819','2013-04-01','08:55:00',1.83),('5819','2013-04-01','09:00:00',2.21),('5819','2013-04-01','09:05:00',2.29),('5819','2013-04-01','09:10:00',2.46),('5819','2013-04-01','09:15:00',2.52),('5819','2013-04-01','09:20:00',2.11),('5819','2013-04-01','09:25:00',2.33),('5819','2013-04-01','09:30:00',2.74),('5819','2013-04-01','09:35:00',1.41),('5819','2013-04-01','09:40:00',2.85),('5819','2013-04-01','09:45:00',2.14),('5819','2013-04-01','09:50:00',2.66),('5819','2013-04-01','09:55:00',2.75),('5819','2013-04-01','10:00:00',2.97),('5819','2013-04-01','10:05:00',3.15),('5819','2013-04-01','10:10:00',2.86),('5819','2013-04-01','10:15:00',2.37),('5819','2013-04-01','10:20:00',3.09),('5819','2013-04-01','10:25:00',2.88),('5819','2013-04-01','10:30:00',2.57),('5819','2013-04-01','10:35:00',1.37),('5819','2013-04-01','10:40:00',2.12),('5819','2013-04-01','10:45:00',3.79),('5819','2013-04-01','10:50:00',2.58),('5819','2013-04-01','11:00:00',1.48),('5819','2013-04-01','11:05:00',1.19),('5819','2013-04-01','11:10:00',2.26),('5819','2013-04-01','11:15:00',3.23),('5819','2013-04-01','11:20:00',2.44),('5819','2013-04-01','11:25:00',2.64),('5819','2013-04-01','11:30:00',1.58),('5819','2013-04-01','11:35:00',1.8),('5819','2013-04-01','11:40:00',2.89),('5819','2013-04-01','11:45:00',3.07),('5819','2013-04-01','11:50:00',2.57),('5819','2013-04-01','11:55:00',2.09),('5819','2013-04-01','12:00:00',2.84),('5819','2013-04-01','12:05:00',1.87),('5819','2013-04-01','12:10:00',2.15),('5819','2013-04-01','12:15:00',2.03),('5819','2013-04-01','12:20:00',1.68),('5819','2013-04-01','12:25:00',1.75),('5819','2013-04-01','12:30:00',2.38),('5819','2013-04-01','12:35:00',2.23),('5819','2013-04-01','12:40:00',2.19),('5819','2013-04-01','12:45:00',2.48),('5819','2013-04-01','12:50:00',2.6),('5819','2013-04-01','12:55:00',2.94),('5819','2013-04-01','13:00:00',2.78),('5819','2013-04-01','13:05:00',3.06),('5819','2013-04-01','13:10:00',2.87),('5819','2013-04-01','13:15:00',2.72),('5819','2013-04-01','13:20:00',2.66),('5819','2013-04-01','13:25:00',2.44),('5819','2013-04-01','13:30:00',2.84),('5819','2013-04-01','13:35:00',2.45),('5819','2013-04-01','13:40:00',2.87),('5819','2013-04-01','13:45:00',3.34),('5819','2013-04-01','13:50:00',3.71),('5819','2013-04-01','13:55:00',3.9),('5819','2013-04-01','14:00:00',2.27),('5819','2013-04-01','14:05:00',1.67),('5819','2013-04-01','14:10:00',2.06),('5819','2013-04-01','14:15:00',2.36),('5819','2013-04-01','14:20:00',2.37),('5819','2013-04-01','14:25:00',3.79),('5819','2013-04-01','14:30:00',2.79),('5819','2013-04-01','14:35:00',2.07),('5819','2013-04-01','14:40:00',1.87),('5819','2013-04-01','14:45:00',1.76),('5819','2013-04-01','14:50:00',1.91),('5819','2013-04-01','14:55:00',2.08),('5819','2013-04-01','15:00:00',1.84),('5819','2013-04-01','15:05:00',1.82),('5819','2013-04-01','15:10:00',1.84),('5819','2013-04-01','15:15:00',1.98),('5819','2013-04-01','15:20:00',2.03),('5819','2013-04-01','15:25:00',2.04),('5819','2013-04-01','15:30:00',1.75),('5819','2013-04-01','15:35:00',2.2),('5819','2013-04-01','15:40:00',2.09),('5819','2013-04-01','15:45:00',2.11),('5819','2013-04-01','15:50:00',2.45),('5819','2013-04-01','15:55:00',1.97),('5819','2013-04-01','16:00:00',1.75),('5819','2013-04-01','16:05:00',1.45),('5819','2013-04-01','16:10:00',1.23),('5819','2013-03-31','08:35:00',1.17),('5819','2013-03-31','08:45:00',1.34),('5819','2013-03-31','08:50:00',1),('5819','2013-03-31','08:55:00',1.21),('5819','2013-03-31','09:00:00',1.09),('5819','2013-03-31','09:10:00',1.01),('5819','2013-03-31','09:15:00',1.05),('5819','2013-03-31','09:20:00',2.35),('5819','2013-03-31','09:25:00',3.05),('5819','2013-03-31','09:30:00',2.51),('5819','2013-03-31','09:35:00',2.41),('5819','2013-03-31','09:40:00',1.56),('5819','2013-03-31','09:45:00',2.93),('5819','2013-03-31','09:50:00',1.5),('5819','2013-03-31','09:55:00',1.88),('5819','2013-03-31','10:00:00',2.6),('5819','2013-03-31','10:20:00',1.93),('5819','2013-03-31','10:25:00',2.82),('5819','2013-03-31','10:30:00',2.4),('5819','2013-03-31','10:35:00',2.71),('5819','2013-03-31','10:50:00',1.82),('5819','2013-03-31','10:55:00',1.29),('5819','2013-03-31','11:10:00',1.28),('5819','2013-03-31','11:15:00',1.28),('5819','2013-03-31','11:20:00',1.04),('5819','2013-03-31','11:25:00',1.45),('5819','2013-03-31','11:30:00',1.12),('5819','2013-03-31','11:35:00',1.36),('5819','2013-03-31','11:40:00',1.61),('5819','2013-03-31','11:45:00',1.37),('5819','2013-03-31','11:50:00',1.41),('5819','2013-03-31','11:55:00',1.52),('5819','2013-03-31','12:00:00',1.39),('5819','2013-03-31','12:05:00',1.29),('5819','2013-03-31','12:10:00',1.15),('5819','2013-03-31','12:15:00',1.16),('5819','2013-03-31','12:20:00',1.16),('5819','2013-03-31','12:25:00',1.25),('5819','2013-03-31','12:30:00',1.57),('5819','2013-03-31','12:35:00',2.64),('5819','2013-03-31','12:40:00',3.22),('5819','2013-03-31','12:45:00',1.74),('5819','2013-03-31','12:50:00',1.48),('5819','2013-03-31','12:55:00',1.78),('5819','2013-03-31','13:00:00',2.22),('5819','2013-03-31','13:05:00',1.89),('5819','2013-03-31','13:10:00',2.41),('5819','2013-03-31','13:15:00',2.86),('5819','2013-03-31','13:20:00',3.86),('5819','2013-03-31','13:25:00',3.12),('5819','2013-03-31','13:40:00',1.11),('5819','2013-03-31','13:45:00',1.88),('5819','2013-03-31','13:50:00',1.77),('5819','2013-03-31','13:55:00',1.41),('5819','2013-03-31','14:00:00',1.87),('5819','2013-03-31','14:05:00',3.27),('5819','2013-03-31','14:10:00',2.37),('5819','2013-03-31','14:15:00',2.66),('5819','2013-03-31','14:20:00',1.69),('5819','2013-03-31','14:25:00',1.56),('5819','2013-03-31','14:30:00',1.95),('5819','2013-03-31','14:35:00',3.64),('5819','2013-03-31','14:40:00',3.79),('5819','2013-03-31','14:45:00',3.4),('5819','2013-03-31','14:50:00',3.49),('5819','2013-03-31','14:55:00',2.37),('5819','2013-03-31','15:00:00',2.68),('5819','2013-03-31','15:05:00',1.85),('5819','2013-03-31','15:10:00',2.82),('5819','2013-03-31','15:15:00',2.26),('5819','2013-03-31','15:20:00',3.41),('5819','2013-03-31','15:25:00',2.85),('5819','2013-03-31','15:30:00',2.47),('5819','2013-03-31','15:35:00',2.23),('5819','2013-03-31','15:40:00',3.28),('5819','2013-03-31','15:45:00',2.43),('5819','2013-03-31','15:50:00',1.04),('5819','2013-03-31','16:00:00',1.86),('5819','2013-03-31','16:05:00',1.26),('5819','2013-03-31','16:15:00',1.7),('5819','2013-03-31','16:20:00',1.67),('5819','2013-03-31','16:25:00',1.32),('5819','2013-03-31','16:30:00',1.02),('5819','2013-03-31','16:35:00',1.02),('5819','2013-03-31','17:00:00',1.11),('5819','2013-03-31','17:05:00',1.97),('5819','2013-03-31','17:10:00',1.49),('5819','2013-03-31','17:30:00',1.11),('5819','2013-03-31','17:35:00',1.13),('5819','2013-03-31','17:55:00',1.18),('5819','2013-03-30','08:40:00',1.02),('5819','2013-03-30','09:05:00',1.88),('5819','2013-03-30','09:10:00',1.49),('5819','2013-03-30','09:15:00',1.43),('5819','2013-03-30','09:20:00',3.51),('5819','2013-03-30','09:25:00',2.7),('5819','2013-03-30','09:30:00',1.36),('5819','2013-03-30','09:35:00',1.77),('5819','2013-03-30','09:40:00',1.4),('5819','2013-03-30','10:20:00',1.4),('5819','2013-03-30','10:25:00',1.34),('5819','2013-03-30','10:30:00',1.53),('5819','2013-03-30','10:35:00',1.83),('5819','2013-03-30','10:40:00',2.33),('5819','2013-03-30','10:45:00',3.28),('5819','2013-03-30','10:50:00',3.46),('5819','2013-03-30','10:55:00',2.25),('5819','2013-03-30','11:00:00',3.18),('5819','2013-03-30','11:05:00',3.93),('5819','2013-03-30','11:10:00',4.51),('5819','2013-03-30','11:15:00',4.05),('5819','2013-03-30','11:50:00',4.8),('5819','2013-03-30','11:55:00',3.57),('5819','2013-03-30','12:00:00',4.43),('5819','2013-03-30','12:05:00',2.48),('5819','2013-03-30','12:10:00',1.91),('5819','2013-03-30','12:15:00',1.79),('5819','2013-03-30','12:20:00',1.84),('5819','2013-03-30','13:55:00',1.98),('5819','2013-03-30','14:00:00',2.74),('5819','2013-03-30','14:05:00',2.37),('5819','2013-03-30','14:10:00',1.16),('5819','2013-03-30','14:15:00',1.42),('5819','2013-03-30','14:20:00',1.92),('5819','2013-03-30','14:25:00',1.33),('5819','2013-03-30','14:30:00',1.49),('5819','2013-03-30','14:35:00',1.67),('5819','2013-03-30','14:40:00',1.05),('5819','2013-03-30','14:45:00',1.1),('5819','2013-03-30','14:50:00',1.44),('5819','2013-03-29','07:10:00',1.1),('5819','2013-03-29','07:15:00',1.18),('5819','2013-03-29','07:20:00',1.29),('5819','2013-03-29','07:25:00',1.41),('5819','2013-03-29','07:30:00',1.56),('5819','2013-03-29','07:35:00',1.36),('5819','2013-03-29','07:40:00',1.69),('5819','2013-03-29','07:45:00',1.82),('5819','2013-03-29','07:50:00',1.78),('5819','2013-03-29','07:55:00',1.05),('5819','2013-03-29','08:00:00',1.49),('5819','2013-03-29','08:05:00',1.98),('5819','2013-03-29','08:10:00',2.3),('5819','2013-03-29','08:16:00',2.27),('5819','2013-03-29','08:20:00',2.35),('5819','2013-03-29','08:25:00',2.41),('5819','2013-03-29','08:30:00',2.49),('5819','2013-03-29','08:35:00',2.59),('5819','2013-03-29','08:40:00',2.66),('5819','2013-03-29','08:45:00',2.65),('5819','2013-03-29','08:50:00',2.69),('5819','2013-03-29','08:55:00',2.6),('5819','2013-03-29','09:00:00',2.52),('5819','2013-03-29','09:05:00',2.73),('5819','2013-03-29','09:10:00',2.8),('5819','2013-03-29','09:15:00',3.14),('5819','2013-03-29','09:20:00',3.3),('5819','2013-03-29','09:25:00',3.05),('5819','2013-03-29','09:30:00',3.43),('5819','2013-03-29','09:35:00',3.49),('5819','2013-03-29','09:40:00',3.27),('5819','2013-03-29','09:45:00',3.15),('5819','2013-03-29','09:50:00',3.42),('5819','2013-03-29','09:55:00',3.3),('5819','2013-03-29','10:00:00',3.39),('5819','2013-03-29','10:05:00',2.91),('5819','2013-03-29','10:10:00',2.68),('5819','2013-03-29','10:15:00',3.3),('5819','2013-03-29','10:20:00',3.06),('5819','2013-03-29','10:25:00',3.12),('5819','2013-03-29','10:30:00',3.02),('5819','2013-03-29','10:35:00',2.66),('5819','2013-03-29','10:40:00',3.01),('5819','2013-03-29','10:45:00',2.01),('5819','2013-03-29','10:50:00',2.74),('5819','2013-03-29','10:55:00',2.61),('5819','2013-03-29','11:00:00',3.89),('5819','2013-03-29','11:05:00',3.82),('5819','2013-03-29','11:10:00',4.29),('5819','2013-03-29','11:15:00',3.13),('5819','2013-03-29','11:20:00',2.04),('5819','2013-03-29','11:25:00',2.3),('5819','2013-03-29','11:30:00',4.18),('5819','2013-03-29','11:35:00',3.03),('5819','2013-03-29','11:40:00',4.1),('5819','2013-03-29','11:45:00',4.03),('5819','2013-03-29','11:50:00',4.02),('5819','2013-03-29','11:55:00',4.01),('5819','2013-03-29','12:00:00',4),('5819','2013-03-29','12:05:00',4.09),('5819','2013-03-29','12:10:00',4.03),('5819','2013-03-29','12:15:00',3.76),('5819','2013-03-29','12:20:00',4.01),('5819','2013-03-29','12:25:00',3.76),('5819','2013-03-29','12:30:00',3.51),('5819','2013-03-29','12:35:00',3.7),('5819','2013-03-29','12:40:00',3.92),('5819','2013-03-29','12:45:00',3.38),('5819','2013-03-29','12:50:00',3.13),('5819','2013-03-29','12:55:00',2.86),('5819','2013-03-29','13:00:00',3.53),('5819','2013-03-29','13:05:00',2.39),('5819','2013-03-29','13:10:00',3.57),('5819','2013-03-29','13:15:00',3.1),('5819','2013-03-29','13:20:00',3.23),('5819','2013-03-29','13:25:00',3.96),('5819','2013-03-29','13:30:00',3.5),('5819','2013-03-29','13:35:00',3),('5819','2013-03-29','13:40:00',3.05),('5819','2013-03-29','13:45:00',2.92),('5819','2013-03-29','13:50:00',3.1),('5819','2013-03-29','13:55:00',3.04),('5819','2013-03-29','14:00:00',3.09),('5819','2013-03-29','14:05:00',2.69),('5819','2013-03-29','14:10:00',2.12),('5819','2013-03-29','14:15:00',2.16),('5819','2013-03-29','14:20:00',2.16),('5819','2013-03-29','14:25:00',2.17),('5819','2013-03-29','14:30:00',1.87),('5819','2013-03-29','14:35:00',1.88),('5819','2013-03-29','14:40:00',1.82),('5819','2013-03-29','14:45:00',1.72),('5819','2013-03-29','14:50:00',1.62),('5819','2013-03-29','14:55:00',1.56),('5819','2013-03-29','15:00:00',1.42),('5819','2013-03-29','15:05:00',1.44),('5819','2013-03-29','15:10:00',1.36),('5819','2013-03-29','15:15:00',1.3),('5819','2013-03-29','15:20:00',1.26),('5819','2013-03-29','15:25:00',1.14),('5819','2013-03-29','15:30:00',1.06),('5819','2013-03-29','15:35:00',1.01),('5819','2013-03-29','15:55:00',1.08),('5819','2013-03-29','16:00:00',1.24),('5819','2013-03-29','16:05:00',1.19),('5819','2013-03-29','16:40:00',1.37),('5819','2013-03-29','16:45:00',1.19),('5819','2013-03-28','09:15:00',2.76),('5819','2013-03-28','09:20:00',1.58),('5819','2013-03-28','09:25:00',1.46),('5819','2013-03-28','09:30:00',1.19),('5819','2013-03-28','09:55:00',1.02),('5819','2013-03-28','10:00:00',1.15),('5819','2013-03-28','11:35:00',1.03),('5819','2013-03-28','11:40:00',1.64),('5819','2013-03-28','11:45:00',1.3),('5819','2013-03-28','11:50:00',1.03),('5819','2013-03-28','11:55:00',1.83),('5819','2013-03-28','12:00:00',1.61),('5819','2013-03-28','12:05:00',1.11),('5819','2013-03-28','12:10:00',1.02),('5819','2013-03-28','12:20:00',1.14),('5819','2013-03-28','12:40:00',1.17),('5819','2013-03-28','12:45:00',1.5),('5819','2013-03-28','12:50:00',2.73),('5819','2013-03-28','12:55:00',3.21),('5819','2013-03-28','13:00:00',2.98),('5819','2013-03-28','13:05:00',3.85),('5819','2013-03-28','13:10:00',2.94),('5819','2013-03-28','13:15:00',3.07),('5819','2013-03-28','13:20:00',3.46),('5819','2013-03-28','13:25:00',3.08),('5819','2013-03-28','13:30:00',3.22),('5819','2013-03-28','13:35:00',2.46),('5819','2013-03-28','13:40:00',2.15),('5819','2013-03-28','13:45:00',1.91),('5819','2013-03-28','13:50:00',3.02),('5819','2013-03-28','13:55:00',1.57),('5819','2013-03-28','14:00:00',1.74),('5819','2013-03-28','14:05:00',2.35),('5819','2013-03-28','14:10:00',1.83),('5819','2013-03-28','14:15:00',1.39),('5819','2013-03-28','14:20:00',1.36),('5819','2013-03-28','14:25:00',1.39),('5819','2013-03-28','14:30:00',1.66),('5819','2013-03-28','14:35:00',1.56),('5819','2013-03-28','14:40:00',1.14),('5819','2013-03-28','14:45:00',1.08),('5819','2013-03-28','14:50:00',1.04),('5819','2013-03-28','15:00:00',1.04),('5819','2013-03-28','15:05:00',1.13),('5819','2013-03-28','15:10:00',1.77),('5819','2013-03-28','15:15:00',2.24),('5819','2013-03-28','15:20:00',1.52),('5819','2013-03-28','15:25:00',1.81),('5819','2013-03-28','15:30:00',1.19),('5819','2013-03-28','15:35:00',1.86),('5819','2013-03-28','15:40:00',1.52),('5819','2013-03-28','15:45:00',1.82),('5819','2013-03-28','15:50:00',1.18),('5819','2013-03-28','15:55:00',2.18),('5819','2013-03-28','16:00:00',1.37),('5819','2013-03-28','16:10:00',1.14),('5819','2013-03-28','16:35:00',1.15),('5819','2013-03-27','07:10:00',1),('5819','2013-03-27','07:15:00',1.08),('5819','2013-03-27','07:20:00',1.2),('5819','2013-03-27','07:25:00',1.31),('5819','2013-03-27','07:30:00',1.39),('5819','2013-03-27','07:35:00',1.33),('5819','2013-03-27','07:40:00',1.48),('5819','2013-03-27','07:55:00',1.42),('5819','2013-03-27','08:00:00',1.35),('5819','2013-03-27','08:05:00',1.62),('5819','2013-03-27','08:10:00',1.31),('5819','2013-03-27','08:15:00',1.48),('5819','2013-03-27','08:20:00',1.31),('5819','2013-03-27','08:25:00',1.49),('5819','2013-03-27','08:30:00',1.98),('5819','2013-03-27','08:35:00',2),('5819','2013-03-27','08:40:00',1.49),('5819','2013-03-27','08:45:00',1.28),('5819','2013-03-27','08:50:00',1.75),('5819','2013-03-27','08:55:00',1.33),('5819','2013-03-27','09:00:00',1.4),('5819','2013-03-27','09:05:00',1.1),('5819','2013-03-27','09:15:00',1.49),('5819','2013-03-27','09:20:00',2.01),('5819','2013-03-27','09:25:00',1.26),('5819','2013-03-27','09:30:00',1),('5819','2013-03-27','09:45:00',1.42),('5819','2013-03-27','09:50:00',2.15),('5819','2013-03-27','09:55:00',1.91),('5819','2013-03-27','10:00:00',1.37),('5819','2013-03-27','10:05:00',1.04),('5819','2013-03-27','10:10:00',1.22),('5819','2013-03-27','10:15:00',1.72),('5819','2013-03-27','10:20:00',1.46),('5819','2013-03-27','10:25:00',1.7),('5819','2013-03-27','10:30:00',2.12),('5819','2013-03-27','10:35:00',1.76),('5819','2013-03-27','10:40:00',1.72),('5819','2013-03-27','10:45:00',2.15),('5819','2013-03-27','10:50:00',1.86),('5819','2013-03-27','10:55:00',1.8),('5819','2013-03-27','11:00:00',1.5),('5819','2013-03-27','11:05:00',1.46),('5819','2013-03-27','11:10:00',1.61),('5819','2013-03-27','11:15:00',1.69),('5819','2013-03-27','11:20:00',1.77),('5819','2013-03-27','11:25:00',1.65),('5819','2013-03-27','11:30:00',1.88),('5819','2013-03-27','11:35:00',1.79),('5819','2013-03-27','11:40:00',1.76),('5819','2013-03-27','11:45:00',1.64),('5819','2013-03-27','11:50:00',1.6),('5819','2013-03-27','11:55:00',2.34),('5819','2013-03-27','12:00:00',2.73),('5819','2013-03-27','12:05:00',2.63),('5819','2013-03-27','12:10:00',2.41),('5819','2013-03-27','12:15:00',1.79),('5819','2013-03-27','12:20:00',1.77),('5819','2013-03-27','12:25:00',1.61),('5819','2013-03-27','12:30:00',2.74),('5819','2013-03-27','12:35:00',4.15),('5819','2013-03-27','12:40:00',3.61),('5819','2013-03-27','12:45:00',4.62),('5819','2013-03-27','12:50:00',2.63),('5819','2013-03-27','12:55:00',2.46),('5819','2013-03-27','13:00:00',1.64),('5819','2013-03-27','13:05:00',1.6),('5819','2013-03-27','13:10:00',2.07),('5819','2013-03-27','13:15:00',1.76),('5819','2013-03-27','13:20:00',1.43),('5819','2013-03-27','13:25:00',1.24),('5819','2013-03-27','13:30:00',1.62),('5819','2013-03-27','13:35:00',2),('5819','2013-03-27','13:40:00',1.8),('5819','2013-03-27','13:45:00',2.03),('5819','2013-03-27','13:50:00',2.26),('5819','2013-03-27','13:55:00',2.28),('5819','2013-03-27','14:00:00',1.66),('5819','2013-03-27','14:05:00',1.39),('5819','2013-03-27','14:10:00',1.47),('5819','2013-03-27','14:15:00',1.66),('5819','2013-03-27','14:20:00',2.03),('5819','2013-03-27','14:25:00',1.63),('5819','2013-03-27','14:30:00',1.4),('5819','2013-03-27','14:35:00',1.47),('5819','2013-03-27','14:40:00',1.89),('5819','2013-03-27','14:45:00',1.94),('5819','2013-03-27','14:50:00',1.43),('5819','2013-03-27','14:55:00',1.24),('5819','2013-03-27','15:00:00',1.14),('5819','2013-03-27','15:05:00',1.35),('5819','2013-03-27','15:10:00',1.6),('5819','2013-03-27','15:20:00',1),('5819','2013-03-27','15:25:00',1.09),('5819','2013-03-27','17:05:00',1.02),('5819','2013-03-26','07:45:00',1.02),('5819','2013-03-26','07:50:00',1.62),('5819','2013-03-26','07:55:00',2.48),('5819','2013-03-26','08:35:00',1.25),('5819','2013-03-26','08:40:00',1.38),('5819','2013-03-26','09:15:00',1.32),('5819','2013-03-26','09:20:00',1.03),('5819','2013-03-26','09:55:00',2.36),('5819','2013-03-26','10:00:00',1.59),('5819','2013-03-26','11:00:00',1.01),('5819','2013-03-26','11:05:00',1),('5819','2013-03-26','11:10:00',2.32),('5819','2013-03-26','11:15:00',1.7),('5819','2013-03-26','11:20:00',1.47),('5819','2013-03-26','11:50:00',1.1),('5819','2013-03-26','12:05:00',1.15),('5819','2013-03-26','12:10:00',1.2),('5819','2013-03-26','12:15:00',1.29),('5819','2013-03-26','12:20:00',1.4),('5819','2013-03-26','12:25:00',2.29),('5819','2013-03-26','12:30:00',2.13),('5819','2013-03-26','12:35:00',2.63),('5819','2013-03-26','12:40:00',1.65),('5819','2013-03-26','12:45:00',2.76),('5819','2013-03-26','12:50:00',1.95),('5819','2013-03-26','12:55:00',1.07),('5819','2013-03-26','13:00:00',1.2),('5819','2013-03-26','13:05:00',2.24),('5819','2013-03-26','13:10:00',1.99),('5819','2013-03-26','13:15:00',2),('5819','2013-03-26','13:20:00',1.44),('5819','2013-03-26','13:25:00',2.07),('5819','2013-03-26','13:30:00',1.48),('5819','2013-03-26','13:35:00',1.79),('5819','2013-03-26','13:40:00',2.09),('5819','2013-03-26','13:45:00',1.87),('5819','2013-03-26','13:50:00',1.65),('5819','2013-03-26','13:55:00',1.5),('5819','2013-03-26','14:00:00',1.45),('5819','2013-03-26','14:05:00',1.38),('5819','2013-03-26','14:10:00',1.42),('5819','2013-03-26','14:15:00',1.34),('5819','2013-03-26','14:20:00',1.17),('5819','2013-03-26','14:25:00',1.01),('5819','2013-03-25','08:20:00',1.04),('5819','2013-03-25','08:25:00',1.82),('5819','2013-03-25','08:30:00',1.31),('5819','2013-03-25','08:55:00',1.01),('5819','2013-03-25','09:00:00',1.09),('5819','2013-03-25','09:05:00',1.07),('5819','2013-03-25','09:10:00',1.05),('5819','2013-03-25','09:20:00',2.36),('5819','2013-03-25','09:25:00',3.14),('5819','2013-03-25','09:30:00',1.57),('5819','2013-03-25','09:35:00',1.03),('5819','2013-03-25','09:50:00',2.73),('5819','2013-03-25','09:55:00',3.81),('5819','2013-03-25','10:00:00',2.58),('5819','2013-03-25','10:05:00',1.21),('5819','2013-03-25','10:20:00',1.34),('5819','2013-03-25','10:25:00',2.09),('5819','2013-03-25','10:30:00',2.57),('5819','2013-03-25','10:35:00',1.32),('5819','2013-03-25','10:40:00',1.6),('5819','2013-03-25','10:45:00',2.32),('5819','2013-03-25','10:50:00',1.93),('5819','2013-03-25','10:55:00',2.27),('5819','2013-03-25','11:00:00',2.14),('5819','2013-03-25','11:05:00',1.84),('5819','2013-03-25','11:10:00',1.77),('5819','2013-03-25','11:15:00',1.75),('5819','2013-03-25','11:20:00',3.65),('5819','2013-03-25','11:25:00',3.45),('5819','2013-03-25','11:30:00',2.76),('5819','2013-03-25','11:35:00',2.39),('5819','2013-03-25','11:40:00',1.46),('5819','2013-03-25','11:45:00',1.61),('5819','2013-03-25','11:50:00',1.64),('5819','2013-03-25','11:55:00',2.55),('5819','2013-03-25','12:00:00',3.94),('5819','2013-03-25','12:05:00',3.29),('5819','2013-03-25','12:10:00',3.62),('5819','2013-03-25','12:15:00',3.95),('5819','2013-03-25','12:20:00',2.8),('5819','2013-03-25','12:25:00',3.52),('5819','2013-03-25','12:30:00',3.81),('5819','2013-03-25','12:35:00',2.88),('5819','2013-03-25','12:40:00',2.31),('5819','2013-03-25','12:45:00',2.48),('5819','2013-03-25','12:50:00',2.79),('5819','2013-03-25','12:55:00',2.73),('5819','2013-03-25','13:00:00',2.26),('5819','2013-03-25','13:05:00',4.02),('5819','2013-03-25','13:10:00',3.52),('5819','2013-03-25','13:15:00',3.41),('5819','2013-03-25','13:20:00',3.86),('5819','2013-03-25','13:25:00',2.43),('5819','2013-03-25','13:30:00',1.85),('5819','2013-03-25','13:35:00',1.17),('5819','2013-03-25','13:40:00',1.11),('5819','2013-03-25','13:45:00',1.72),('5819','2013-03-25','13:50:00',2.03),('5819','2013-03-25','13:55:00',1.84),('5819','2013-03-25','14:00:00',1.06),('5819','2013-03-25','14:10:00',2.36),('5819','2013-03-25','14:15:00',1.94),('5819','2013-03-25','14:20:00',2.06),('5819','2013-03-25','14:25:00',2.51),('5819','2013-03-25','14:30:00',3.33),('5819','2013-03-25','14:35:00',2.29),('5819','2013-03-25','14:40:00',1.36),('5819','2013-03-25','14:45:00',1.41),('5819','2013-03-25','14:50:00',1.56),('5819','2013-03-25','14:55:00',2.26),('5819','2013-03-25','15:00:00',2.07),('5819','2013-03-25','15:05:00',1.98),('5819','2013-03-25','15:10:00',1.83),('5819','2013-03-25','15:15:00',1.63),('5819','2013-03-25','15:20:00',2.15),('5819','2013-03-25','15:25:00',2.66),('5819','2013-03-25','15:30:00',1.9),('5819','2013-03-25','15:35:00',2.35),('5819','2013-03-25','15:40:00',1.55),('5819','2013-03-25','15:45:00',1.21),('5819','2013-03-25','16:00:00',1.58),('5819','2013-03-25','16:05:00',1.09),('5819','2013-03-25','16:10:00',1.01),('5819','2013-03-25','16:15:00',1.2),('5819','2013-03-25','16:35:00',1.19),('5819','2013-03-25','16:40:00',1.45),('5819','2013-03-24','07:25:00',1.02),('5819','2013-03-24','07:35:00',1.02),('5819','2013-03-24','07:40:00',1.08),('5819','2013-03-24','07:45:00',1.17),('5819','2013-03-24','07:50:00',1.38),('5819','2013-03-24','07:55:00',1.55),('5819','2013-03-24','08:00:00',1.87),('5819','2013-03-24','08:05:00',1.98),('5819','2013-03-24','08:10:00',2.02),('5819','2013-03-24','08:15:00',2.14),('5819','2013-03-24','08:20:00',2.24),('5819','2013-03-24','08:25:00',2.32),('5819','2013-03-24','08:30:00',2.38),('5819','2013-03-24','08:35:00',2.45),('5819','2013-03-24','08:40:00',2.53),('5819','2013-03-24','08:45:00',2.57),('5819','2013-03-24','08:50:00',2.6),('5819','2013-03-24','08:55:00',2.65),('5819','2013-03-24','09:00:00',2.71),('5819','2013-03-24','09:05:00',2.8),('5819','2013-03-24','09:10:00',2.88),('5819','2013-03-24','09:15:00',2.93),('5819','2013-03-24','09:20:00',2.98),('5819','2013-03-24','09:25:00',3.02),('5819','2013-03-24','09:30:00',3.07),('5819','2013-03-24','09:35:00',3.1),('5819','2013-03-24','09:40:00',3.14),('5819','2013-03-24','09:45:00',3.18),('5819','2013-03-24','09:50:00',3.24),('5819','2013-03-24','09:55:00',3.27),('5819','2013-03-24','10:00:00',3.31),('5819','2013-03-24','10:05:00',3.37),('5819','2013-03-24','10:10:00',3.4),('5819','2013-03-24','10:15:00',3.44),('5819','2013-03-24','10:20:00',3.47),('5819','2013-03-24','10:25:00',3.48),('5819','2013-03-24','10:30:00',3.53),('5819','2013-03-24','10:35:00',3.53),('5819','2013-03-24','10:40:00',3.54),('5819','2013-03-24','10:45:00',3.55),('5819','2013-03-24','10:50:00',3.54),('5819','2013-03-24','10:55:00',3.57),('5819','2013-03-24','11:00:00',3.58),('5819','2013-03-24','11:05:00',3.62),('5819','2013-03-24','11:10:00',3.63),('5819','2013-03-24','11:15:00',3.61),('5819','2013-03-24','11:20:00',3.61),('5819','2013-03-24','11:25:00',3.63),('5819','2013-03-24','11:30:00',3.66),('5819','2013-03-24','11:35:00',3.64),('5819','2013-03-24','11:40:00',3.64),('5819','2013-03-24','11:45:00',3.65),('5819','2013-03-24','11:50:00',3.66),('5819','2013-03-24','11:55:00',3.66),('5819','2013-03-24','12:00:00',3.68),('5819','2013-03-24','12:05:00',3.67),('5819','2013-03-24','12:10:00',3.69),('5819','2013-03-24','12:15:00',3.72),('5819','2013-03-24','12:20:00',3.76),('5819','2013-03-24','12:25:00',3.79),('5819','2013-03-24','12:30:00',3.75),('5819','2013-03-24','12:35:00',3.76),('5819','2013-03-24','12:40:00',3.74),('5819','2013-03-24','12:45:00',3.72),('5819','2013-03-24','12:50:00',3.7),('5819','2013-03-24','12:55:00',3.65),('5819','2013-03-24','13:00:00',3.61),('5819','2013-03-24','13:05:00',3.62),('5819','2013-03-24','13:10:00',3.57),('5819','2013-03-24','13:15:00',3.56),('5819','2013-03-24','13:20:00',3.53),('5819','2013-03-24','13:25:00',3.46),('5819','2013-03-24','13:30:00',3.41),('5819','2013-03-24','13:35:00',3.38),('5819','2013-03-24','13:40:00',3.34),('5819','2013-03-24','13:45:00',3.29),('5819','2013-03-24','13:50:00',3.26),('5819','2013-03-24','13:55:00',3.22),('5819','2013-03-24','14:00:00',3.16),('5819','2013-03-24','14:05:00',3.11),('5819','2013-03-24','14:10:00',3.03),('5819','2013-03-24','14:15:00',2.98),('5819','2013-03-24','14:20:00',2.92),('5819','2013-03-24','14:25:00',2.85),('5819','2013-03-24','14:30:00',2.77),('5819','2013-03-24','14:35:00',2.65),('5819','2013-03-24','14:40:00',2.61),('5819','2013-03-24','14:45:00',2.55),('5819','2013-03-24','14:50:00',2.44),('5819','2013-03-24','14:55:00',2.4),('5819','2013-03-24','15:00:00',2.32),('5819','2013-03-24','15:05:00',2.25),('5819','2013-03-24','15:10:00',2.11),('5819','2013-03-24','15:15:00',2.27),('5819','2013-03-24','15:20:00',2.17),('5819','2013-03-24','15:25:00',2.04),('5819','2013-03-24','15:30:00',1.83),('5819','2013-03-24','15:35:00',1.79),('5819','2013-03-24','15:40:00',1.78),('5819','2013-03-24','15:45:00',1.57),('5819','2013-03-24','15:50:00',1.09),('5819','2013-03-24','15:55:00',1.08),('5819','2013-03-24','16:00:00',1.04),('5819','2013-03-24','16:05:00',1.23),('5819','2013-03-24','16:15:00',1.15),('5819','2013-03-24','16:20:00',1.01),('5819','2013-03-23','07:15:00',1.09),('5819','2013-03-23','07:20:00',1.15),('5819','2013-03-23','07:25:00',1.18),('5819','2013-03-23','07:30:00',1.22),('5819','2013-03-23','07:35:00',1.25),('5819','2013-03-23','07:40:00',1.42),('5819','2013-03-23','07:45:00',1.43),('5819','2013-03-23','07:50:00',1.56),('5819','2013-03-23','07:55:00',1.73),('5819','2013-03-23','08:00:00',1.89),('5819','2013-03-23','08:05:00',2.06),('5819','2013-03-23','08:10:00',2.13),('5819','2013-03-23','08:15:00',2.21),('5819','2013-03-23','08:20:00',2.27),('5819','2013-03-23','08:25:00',2.34),('5819','2013-03-23','08:30:00',2.35),('5819','2013-03-23','08:35:00',2.44),('5819','2013-03-23','08:40:00',2.54),('5819','2013-03-23','08:45:00',2.61),('5819','2013-03-23','08:50:00',2.66),('5819','2013-03-23','08:55:00',2.81),('5819','2013-03-23','09:00:00',2.85),('5819','2013-03-23','09:05:00',2.92),('5819','2013-03-23','09:10:00',2.91),('5819','2013-03-23','09:15:00',3.03),('5819','2013-03-23','09:20:00',3),('5819','2013-03-23','09:25:00',3.11),('5819','2013-03-23','09:30:00',3.2),('5819','2013-03-23','09:35:00',3.19),('5819','2013-03-23','09:40:00',3.05),('5819','2013-03-23','09:45:00',3.24),('5819','2013-03-23','09:50:00',3.32),('5819','2013-03-23','09:55:00',3.41),('5819','2013-03-23','10:00:00',3.43),('5819','2013-03-23','10:05:00',3.45),('5819','2013-03-23','10:10:00',3.51),('5819','2013-03-23','10:15:00',3.46),('5819','2013-03-23','10:20:00',3.43),('5819','2013-03-23','10:25:00',3.38),('5819','2013-03-23','10:30:00',3.62),('5819','2013-03-23','10:35:00',3.64),('5819','2013-03-23','10:40:00',3.61),('5819','2013-03-23','10:45:00',3.59),('5819','2013-03-23','10:50:00',3.57),('5819','2013-03-23','10:55:00',3.43),('5819','2013-03-23','11:00:00',3.36),('5819','2013-03-23','11:05:00',3.18),('5819','2013-03-23','11:10:00',2.73),('5819','2013-03-23','11:15:00',2.89),('5819','2013-03-23','11:20:00',3.54),('5819','2013-03-23','11:25:00',3.53),('5819','2013-03-23','11:30:00',3.51),('5819','2013-03-23','11:35:00',3.67),('5819','2013-03-23','11:40:00',3.67),('5819','2013-03-23','11:45:00',3.68),('5819','2013-03-23','11:50:00',3.51),('5819','2013-03-23','11:55:00',3.68),('5819','2013-03-23','12:00:00',3.68),('5819','2013-03-23','12:05:00',3.64),('5819','2013-03-23','12:10:00',3.61),('5819','2013-03-23','12:15:00',3.67),('5819','2013-03-23','12:20:00',3.67),('5819','2013-03-23','12:25:00',3.65),('5819','2013-03-23','12:30:00',3.68),('5819','2013-03-23','12:35:00',3.67),('5819','2013-03-23','12:40:00',3.47),('5819','2013-03-23','12:45:00',3.54),('5819','2013-03-23','12:50:00',3.61),('5819','2013-03-23','12:55:00',3.54),('5819','2013-03-23','13:00:00',2.67),('5819','2013-03-23','13:05:00',3.45),('5819','2013-03-23','13:10:00',3.49),('5819','2013-03-23','13:15:00',3.31),('5819','2013-03-23','13:20:00',3.38),('5819','2013-03-23','13:25:00',3.37),('5819','2013-03-23','13:30:00',3.22),('5819','2013-03-23','13:35:00',3.01),('5819','2013-03-23','13:40:00',3.22),('5819','2013-03-23','13:45:00',2.59),('5819','2013-03-23','13:50:00',3.1),('5819','2013-03-23','13:55:00',3.1),('5819','2013-03-23','14:00:00',3.04),('5819','2013-03-23','14:05:00',3.02),('5819','2013-03-23','14:10:00',2.95),('5819','2013-03-23','14:15:00',2.85),('5819','2013-03-23','14:20:00',2.91),('5819','2013-03-23','14:25:00',2.86),('5819','2013-03-23','14:30:00',2.84),('5819','2013-03-23','14:35:00',2.73),('5819','2013-03-23','14:40:00',2.64),('5819','2013-03-23','14:45:00',2.45),('5819','2013-03-23','14:50:00',2.41),('5819','2013-03-23','14:55:00',2.42),('5819','2013-03-23','15:00:00',2.31),('5819','2013-03-23','15:05:00',2.18),('5819','2013-03-23','15:10:00',2.24),('5819','2013-03-23','15:15:00',2.07),('5819','2013-03-23','15:20:00',2.07),('5819','2013-03-23','15:25:00',2.04),('5819','2013-03-23','15:30:00',1.82),('5819','2013-03-23','15:35:00',1.81),('5819','2013-03-23','15:40:00',1.67),('5819','2013-03-23','15:45:00',1.58),('5819','2013-03-23','15:50:00',1.46),('5819','2013-03-23','15:55:00',1.41),('5819','2013-03-23','16:00:00',1.32),('5819','2013-03-23','16:05:00',1.17),('5819','2013-03-23','16:10:00',1.45),('5819','2013-03-23','16:15:00',1.33),('5819','2013-03-23','16:20:00',1.11),('5819','2013-03-23','16:25:00',1.09),('5819','2013-03-22','07:15:00',1.06),('5819','2013-03-22','07:20:00',1.17),('5819','2013-03-22','07:25:00',1.27),('5819','2013-03-22','07:30:00',1.36),('5819','2013-03-22','07:35:00',1.47),('5819','2013-03-22','07:40:00',1.57),('5819','2013-03-22','07:45:00',1.66),('5819','2013-03-22','07:50:00',1.73),('5819','2013-03-22','07:55:00',1.82),('5819','2013-03-22','08:00:00',1.9),('5819','2013-03-22','08:05:00',2),('5819','2013-03-22','08:10:00',2.09),('5819','2013-03-22','08:15:00',2.18),('5819','2013-03-22','08:20:00',2.27),('5819','2013-03-22','08:25:00',2.36),('5819','2013-03-22','08:30:00',2.44),('5819','2013-03-22','08:35:00',2.51),('5819','2013-03-22','08:40:00',2.58),('5819','2013-03-22','08:45:00',2.64),('5819','2013-03-22','08:50:00',2.7),('5819','2013-03-22','08:55:00',2.77),('5819','2013-03-22','09:00:00',2.83),('5819','2013-03-22','09:05:00',2.89),('5819','2013-03-22','09:10:00',2.94),('5819','2013-03-22','09:15:00',3.01),('5819','2013-03-22','09:20:00',3.02),('5819','2013-03-22','09:25:00',3.11),('5819','2013-03-22','09:30:00',3.16),('5819','2013-03-22','09:35:00',3.22),('5819','2013-03-22','09:40:00',3.3),('5819','2013-03-22','09:45:00',3.3),('5819','2013-03-22','09:50:00',3.39),('5819','2013-03-22','09:55:00',3.38),('5819','2013-03-22','10:00:00',3.44),('5819','2013-03-22','10:05:00',3.42),('5819','2013-03-22','10:10:00',3.47),('5819','2013-03-22','10:15:00',3.5),('5819','2013-03-22','10:20:00',3.47),('5819','2013-03-22','10:25:00',3.56),('5819','2013-03-22','10:30:00',3.66),('5819','2013-03-22','10:35:00',3.7),('5819','2013-03-22','10:40:00',3.77),('5819','2013-03-22','10:45:00',3.79),('5819','2013-03-22','10:50:00',3.8),('5819','2013-03-22','10:55:00',3.82),('5819','2013-03-22','11:00:00',3.79),('5819','2013-03-22','11:05:00',3.81),('5819','2013-03-22','11:10:00',3.83),('5819','2013-03-22','11:15:00',3.84),('5819','2013-03-22','11:20:00',3.86),('5819','2013-03-22','11:25:00',3.86),('5819','2013-03-22','11:30:00',3.88),('5819','2013-03-22','11:35:00',3.91),('5819','2013-03-22','11:40:00',3.87),('5819','2013-03-22','11:45:00',3.94),('5819','2013-03-22','11:50:00',3.9),('5819','2013-03-22','11:55:00',3.93),('5819','2013-03-22','12:00:00',3.93),('5819','2013-03-22','12:05:00',3.92),('5819','2013-03-22','12:10:00',3.9),('5819','2013-03-22','12:15:00',3.88),('5819','2013-03-22','12:20:00',3.86),('5819','2013-03-22','12:25:00',3.84),('5819','2013-03-22','12:30:00',3.84),('5819','2013-03-22','12:35:00',3.85),('5819','2013-03-22','12:40:00',3.86),('5819','2013-03-22','12:45:00',3.82),('5819','2013-03-22','12:50:00',3.7),('5819','2013-03-22','12:55:00',3.44),('5819','2013-03-22','13:00:00',3.77),('5819','2013-03-22','13:05:00',3.62),('5819','2013-03-22','13:10:00',3.73),('5819','2013-03-22','13:15:00',3.68),('5819','2013-03-22','13:20:00',3.61),('5819','2013-03-22','13:25:00',3.44),('5819','2013-03-22','13:30:00',3.36),('5819','2013-03-22','13:35:00',3.44),('5819','2013-03-22','13:40:00',2.87),('5819','2013-03-22','13:45:00',2.98),('5819','2013-03-22','13:50:00',3.45),('5819','2013-03-22','13:55:00',3.36),('5819','2013-03-22','14:00:00',3.27),('5819','2013-03-22','14:05:00',3.21),('5819','2013-03-22','14:10:00',3.17),('5819','2013-03-22','14:15:00',3.12),('5819','2013-03-22','14:20:00',3.05),('5819','2013-03-22','14:25:00',2.97),('5819','2013-03-22','14:30:00',2.92),('5819','2013-03-22','14:35:00',2.85),('5819','2013-03-22','14:40:00',2.76),('5819','2013-03-22','14:45:00',2.71),('5819','2013-03-22','14:50:00',2.65),('5819','2013-03-22','14:55:00',2.58),('5819','2013-03-22','15:00:00',2.53),('5819','2013-03-22','15:05:00',2.45),('5819','2013-03-22','15:10:00',2.17),('5819','2013-03-22','15:15:00',1.79),('5819','2013-03-22','15:20:00',1.74),('5819','2013-03-22','15:25:00',1.87),('5819','2013-03-22','15:30:00',1.68),('5819','2013-03-22','15:35:00',1.84),('5819','2013-03-22','15:40:00',1.76),('5819','2013-03-22','15:45:00',1.53),('5819','2013-03-22','15:50:00',1.62),('5819','2013-03-22','15:55:00',1.4),('5819','2013-03-22','16:10:00',1.13),('5819','2013-03-22','16:15:00',1.32),('5819','2013-03-22','16:20:00',1.08),('5819','2013-03-22','16:30:00',1.11),('5819','2013-03-22','16:35:00',1.09),('5819','2013-03-22','16:40:00',1.05),('5819','2013-03-21','07:45:00',1.37),('5819','2013-03-21','07:50:00',1.89),('5819','2013-03-21','07:55:00',1.02),('5819','2013-03-21','08:10:00',1.59),('5819','2013-03-21','08:15:00',2.33),('5819','2013-03-21','08:20:00',2.36),('5819','2013-03-21','08:25:00',2.36),('5819','2013-03-21','08:30:00',2.54),('5819','2013-03-21','08:35:00',2.61),('5819','2013-03-21','08:40:00',2.66),('5819','2013-03-21','08:45:00',2.71),('5819','2013-03-21','08:50:00',2.82),('5819','2013-03-21','08:55:00',2.89),('5819','2013-03-21','09:00:00',3),('5819','2013-03-21','09:05:00',3.14),('5819','2013-03-21','09:10:00',3.48),('5819','2013-03-21','09:15:00',2.3),('5819','2013-03-21','09:20:00',2.8),('5819','2013-03-21','09:25:00',3.42),('5819','2013-03-21','09:30:00',3.42),('5819','2013-03-21','09:35:00',3.42),('5819','2013-03-21','09:40:00',3.47),('5819','2013-03-21','09:45:00',3.51),('5819','2013-03-21','09:50:00',3.03),('5819','2013-03-21','09:55:00',3.67),('5819','2013-03-21','10:00:00',3.69),('5819','2013-03-21','10:05:00',3.72),('5819','2013-03-21','10:10:00',3.76),('5819','2013-03-21','10:15:00',3.77),('5819','2013-03-21','10:20:00',3.81),('5819','2013-03-21','10:25:00',3.81),('5819','2013-03-21','10:30:00',3.82),('5819','2013-03-21','10:35:00',3.87),('5819','2013-03-21','10:40:00',3.9),('5819','2013-03-21','10:45:00',3.89),('5819','2013-03-21','10:50:00',3.87),('5819','2013-03-21','10:55:00',2.7),('5819','2013-03-21','11:00:00',4.01),('5819','2013-03-21','11:05:00',3.98),('5819','2013-03-21','11:10:00',4.01),('5819','2013-03-21','11:15:00',4.03),('5819','2013-03-21','11:20:00',4.05),('5819','2013-03-21','11:25:00',4.07),('5819','2013-03-21','11:30:00',4.07),('5819','2013-03-21','11:35:00',4.08),('5819','2013-03-21','11:40:00',4.07),('5819','2013-03-21','11:45:00',4.08),('5819','2013-03-21','11:50:00',4.1),('5819','2013-03-21','11:55:00',4.09),('5819','2013-03-21','12:00:00',4.09),('5819','2013-03-21','12:05:00',4.09),('5819','2013-03-21','12:10:00',4.08),('5819','2013-03-21','12:15:00',4.07),('5819','2013-03-21','12:20:00',4.03),('5819','2013-03-21','12:25:00',4.02),('5819','2013-03-21','12:30:00',4),('5819','2013-03-21','12:35:00',4.01),('5819','2013-03-21','12:40:00',3.98),('5819','2013-03-21','12:45:00',3.95),('5819','2013-03-21','12:50:00',3.92),('5819','2013-03-21','12:55:00',3.87),('5819','2013-03-21','13:00:00',3.85),('5819','2013-03-21','13:05:00',3.8),('5819','2013-03-21','13:10:00',3.76),('5819','2013-03-21','13:15:00',3.71),('5819','2013-03-21','13:20:00',3.68),('5819','2013-03-21','13:25:00',3.66),('5819','2013-03-21','13:30:00',3.63),('5819','2013-03-21','13:35:00',3.58),('5819','2013-03-21','13:40:00',3.54),('5819','2013-03-21','13:45:00',3.49),('5819','2013-03-21','13:50:00',3.44),('5819','2013-03-21','13:55:00',3.38),('5819','2013-03-21','14:00:00',3.33),('5819','2013-03-21','14:05:00',3.26),('5819','2013-03-21','14:10:00',3.19),('5819','2013-03-21','14:15:00',3.12),('5819','2013-03-21','14:20:00',3.07),('5819','2013-03-21','14:25:00',3.02),('5819','2013-03-21','14:30:00',2.94),('5819','2013-03-21','14:35:00',2.87),('5819','2013-03-21','14:40:00',2.8),('5819','2013-03-21','14:45:00',2.73),('5819','2013-03-21','14:50:00',2.67),('5819','2013-03-21','14:55:00',2.62),('5819','2013-03-21','15:00:00',2.53),('5819','2013-03-21','15:05:00',2.46),('5819','2013-03-21','15:10:00',2.38),('5819','2013-03-21','15:15:00',2.31),('5819','2013-03-21','15:20:00',2.22),('5819','2013-03-21','15:25:00',2.13),('5819','2013-03-21','15:30:00',2.05),('5819','2013-03-21','15:35:00',1.97),('5819','2013-03-21','15:40:00',1.88),('5819','2013-03-21','15:45:00',1.79),('5819','2013-03-21','15:50:00',1.7),('5819','2013-03-21','15:55:00',1.61),('5819','2013-03-21','16:00:00',1.52),('5819','2013-03-21','16:05:00',1.44),('5819','2013-03-21','16:10:00',1.35),('5819','2013-03-21','16:15:00',1.27),('5819','2013-03-21','16:20:00',1.19),('5819','2013-03-21','16:25:00',1.1),('5819','2013-03-21','16:30:00',1.01),('5819','2013-03-20','07:15:00',1.02),('5819','2013-03-20','07:20:00',1.11),('5819','2013-03-20','07:25:00',1.22),('5819','2013-03-20','07:30:00',1.33),('5819','2013-03-20','07:35:00',1.45),('5819','2013-03-20','07:40:00',1.49),('5819','2013-03-20','07:45:00',1.53),('5819','2013-03-20','07:50:00',1.56),('5819','2013-03-20','07:55:00',1.74),('5819','2013-03-20','08:00:00',1.74),('5819','2013-03-20','08:05:00',1.7),('5819','2013-03-20','08:10:00',2.04),('5819','2013-03-20','08:15:00',2.14),('5819','2013-03-20','08:20:00',2.21),('5819','2013-03-20','08:25:00',2.31),('5819','2013-03-20','08:30:00',2.4),('5819','2013-03-20','08:35:00',2.39),('5819','2013-03-20','08:40:00',2.27),('5819','2013-03-20','08:45:00',2.47),('5819','2013-03-20','08:50:00',2.59),('5819','2013-03-20','08:55:00',2.53),('5819','2013-03-20','09:00:00',2.47),('5819','2013-03-20','09:05:00',3.22),('5819','2013-03-20','09:10:00',2.61),('5819','2013-03-20','09:15:00',2.92),('5819','2013-03-20','09:20:00',2.89),('5819','2013-03-20','09:25:00',2.98),('5819','2013-03-20','09:30:00',3.18),('5819','2013-03-20','09:35:00',3.09),('5819','2013-03-20','09:40:00',3.23),('5819','2013-03-20','09:45:00',3.31),('5819','2013-03-20','09:50:00',3.32),('5819','2013-03-20','09:55:00',3.29),('5819','2013-03-20','10:00:00',3.4),('5819','2013-03-20','10:05:00',3.39),('5819','2013-03-20','10:10:00',3.3),('5819','2013-03-20','10:15:00',2.54),('5819','2013-03-20','10:20:00',2.81),('5819','2013-03-20','10:25:00',2.45),('5819','2013-03-20','10:30:00',3.08),('5819','2013-03-20','10:35:00',3.49),('5819','2013-03-20','10:40:00',3.16),('5819','2013-03-20','10:45:00',2.25),('5819','2013-03-20','10:50:00',3.21),('5819','2013-03-20','10:55:00',2.9),('5819','2013-03-20','11:00:00',2.78),('5819','2013-03-20','11:05:00',2.94),('5819','2013-03-20','11:10:00',2.73),('5819','2013-03-20','11:15:00',2.27),('5819','2013-03-20','11:20:00',2.6),('5819','2013-03-20','11:25:00',2.54),('5819','2013-03-20','11:30:00',2.33),('5819','2013-03-20','11:35:00',2.57),('5819','2013-03-20','11:40:00',2.11),('5819','2013-03-20','11:45:00',1.96),('5819','2013-03-20','11:50:00',1.86),('5819','2013-03-20','11:55:00',2.11),('5819','2013-03-20','12:00:00',2.01),('5819','2013-03-20','12:05:00',2.27),('5819','2013-03-20','12:10:00',1.86),('5819','2013-03-20','12:15:00',1.61),('5819','2013-03-20','12:20:00',1.52),('5819','2013-03-20','12:25:00',1.28),('5819','2013-03-20','12:35:00',1.19),('5819','2013-03-20','12:50:00',1.3),('5819','2013-03-20','12:55:00',1.5),('5819','2013-03-20','13:00:00',1.72),('5819','2013-03-20','13:05:00',1.25),('5819','2013-03-20','13:10:00',1.32),('5819','2013-03-20','13:15:00',1.04),('5819','2013-03-20','13:20:00',1.13),('5819','2013-03-20','13:25:00',1.23),('5819','2013-03-20','13:30:00',1.37),('5819','2013-03-20','13:35:00',1.29),('5819','2013-03-20','13:40:00',1.57),('5819','2013-03-20','13:45:00',1.89),('5819','2013-03-20','13:50:00',1.6),('5819','2013-03-20','13:55:00',1.47),('5819','2013-03-20','14:00:00',1.48),('5819','2013-03-20','14:05:00',1.28),('5819','2013-03-20','14:10:00',1.17),('5819','2013-03-20','14:15:00',1.51),('5819','2013-03-20','14:20:00',1.92),('5819','2013-03-20','14:25:00',1.79),('5819','2013-03-20','14:30:00',1.55),('5819','2013-03-20','14:35:00',1.29),('5819','2013-03-20','14:40:00',1.02),('5819','2013-03-19','07:10:00',1.1),('5819','2013-03-19','07:15:00',1.19),('5819','2013-03-19','07:20:00',1.09),('5819','2013-03-19','07:25:00',1.18),('5819','2013-03-19','07:30:00',1.27),('5819','2013-03-19','07:35:00',1.36),('5819','2013-03-19','07:40:00',1.46),('5819','2013-03-19','07:45:00',1.56),('5819','2013-03-19','07:50:00',1.68),('5819','2013-03-19','07:55:00',1.71),('5819','2013-03-19','08:00:00',1.25),('5819','2013-03-19','08:05:00',1.64),('5819','2013-03-19','08:10:00',1.96),('5819','2013-03-19','08:15:00',2.15),('5819','2013-03-19','08:20:00',2.21),('5819','2013-03-19','08:25:00',2.27),('5819','2013-03-19','08:30:00',2.12),('5819','2013-03-19','08:35:00',2.49),('5819','2013-03-19','08:40:00',2.55),('5819','2013-03-19','08:45:00',2.64),('5819','2013-03-19','08:50:00',2.75),('5819','2013-03-19','08:55:00',2.79),('5819','2013-03-19','09:00:00',2.86),('5819','2013-03-19','09:05:00',2.78),('5819','2013-03-19','09:10:00',3.02),('5819','2013-03-19','09:15:00',3.04),('5819','2013-03-19','09:20:00',2.57),('5819','2013-03-19','09:25:00',2.91),('5819','2013-03-19','09:30:00',3.28),('5819','2013-03-19','09:35:00',3.32),('5819','2013-03-19','09:40:00',3.42),('5819','2013-03-19','09:45:00',3.57),('5819','2013-03-19','09:50:00',3.55),('5819','2013-03-19','09:55:00',2.89),('5819','2013-03-19','10:00:00',3.75),('5819','2013-03-19','10:05:00',3.2),('5819','2013-03-19','10:10:00',3.36),('5819','2013-03-19','10:15:00',3.69),('5819','2013-03-19','10:20:00',3.73),('5819','2013-03-19','10:25:00',3.82),('5819','2013-03-19','10:30:00',3.82),('5819','2013-03-19','10:35:00',3.84),('5819','2013-03-19','10:40:00',3.86),('5819','2013-03-19','10:45:00',3.9),('5819','2013-03-19','10:50:00',3.93),('5819','2013-03-19','10:55:00',3.89),('5819','2013-03-19','11:00:00',4),('5819','2013-03-19','11:05:00',3.99),('5819','2013-03-19','11:10:00',3.95),('5819','2013-03-19','11:15:00',4.02),('5819','2013-03-19','11:20:00',4.02),('5819','2013-03-19','11:25:00',4.01),('5819','2013-03-19','11:30:00',3.98),('5819','2013-03-19','11:35:00',2.6),('5819','2013-03-19','11:40:00',3.47),('5819','2013-03-19','11:45:00',3.77),('5819','2013-03-19','11:50:00',3.96),('5819','2013-03-19','11:55:00',4.11),('5819','2013-03-19','12:00:00',4.04),('5819','2013-03-19','12:05:00',3.94),('5819','2013-03-19','12:10:00',4),('5819','2013-03-19','12:15:00',3.81),('5819','2013-03-19','12:20:00',3.97),('5819','2013-03-19','12:25:00',3.88),('5819','2013-03-19','12:30:00',3.89),('5819','2013-03-19','12:35:00',3.86),('5819','2013-03-19','12:40:00',3.86),('5819','2013-03-19','12:45:00',3.88),('5819','2013-03-19','12:50:00',3.72),('5819','2013-03-19','12:55:00',3.66),('5819','2013-03-19','13:00:00',3.77),('5819','2013-03-19','13:05:00',3.73),('5819','2013-03-19','13:10:00',3.67),('5819','2013-03-19','13:15:00',3.65),('5819','2013-03-19','13:20:00',3.6),('5819','2013-03-19','13:25:00',3.56),('5819','2013-03-19','13:30:00',3.54),('5819','2013-03-19','13:35:00',3.48),('5819','2013-03-19','13:40:00',3.42),('5819','2013-03-19','13:45:00',3.41),('5819','2013-03-19','13:50:00',3.36),('5819','2013-03-19','13:55:00',3.3),('5819','2013-03-19','14:00:00',3.26),('5819','2013-03-19','14:05:00',3.2),('5819','2013-03-19','14:10:00',3.15),('5819','2013-03-19','14:15:00',3.11),('5819','2013-03-19','14:20:00',3.04),('5819','2013-03-19','14:25:00',2.98),('5819','2013-03-19','14:30:00',2.89),('5819','2013-03-19','14:35:00',2.83),('5819','2013-03-19','14:40:00',2.78),('5819','2013-03-19','14:45:00',2.72),('5819','2013-03-19','14:50:00',2.64),('5819','2013-03-19','14:55:00',2.55),('5819','2013-03-19','15:00:00',2.48),('5819','2013-03-19','15:05:00',2.42),('5819','2013-03-19','15:10:00',2.33),('5819','2013-03-19','15:15:00',2.25),('5819','2013-03-19','15:20:00',2.19),('5819','2013-03-19','15:25:00',2.11),('5819','2013-03-19','15:30:00',2.02),('5819','2013-03-19','15:35:00',1.95),('5819','2013-03-19','15:40:00',1.87),('5819','2013-03-19','15:45:00',1.78),('5819','2013-03-19','15:50:00',1.69),('5819','2013-03-19','15:55:00',1.61),('5819','2013-03-19','16:00:00',1.51),('5819','2013-03-19','16:05:00',1.43),('5819','2013-03-19','16:10:00',1.34),('5819','2013-03-19','16:15:00',1.25),('5819','2013-03-19','16:20:00',1.18),('5819','2013-03-19','16:25:00',1.11),('5819','2013-03-19','16:30:00',1.03),('5819','2013-03-18','10:00:00',1.08),('5819','2013-03-18','10:05:00',1.37),('5819','2013-03-18','10:10:00',1.38),('5819','2013-03-18','10:15:00',1.2),('5819','2013-03-18','10:20:00',1.47),('5819','2013-03-18','10:25:00',1.87),('5819','2013-03-18','10:30:00',1.8),('5819','2013-03-18','10:35:00',1.41),('5819','2013-03-18','10:40:00',1.28),('5819','2013-03-18','10:45:00',1.32),('5819','2013-03-18','10:50:00',1.3),('5819','2013-03-18','10:55:00',1.08),('5819','2013-03-18','11:00:00',1.15),('5819','2013-03-18','11:05:00',1.28),('5819','2013-03-18','11:10:00',1.45),('5819','2013-03-18','11:15:00',1.58),('5819','2013-03-18','11:20:00',1.64),('5819','2013-03-18','11:25:00',1.72),('5819','2013-03-18','11:30:00',2.16),('5819','2013-03-18','11:35:00',1.83),('5819','2013-03-18','11:40:00',1.64),('5819','2013-03-18','11:45:00',1.4),('5819','2013-03-18','11:50:00',1.13),('5819','2013-03-18','11:55:00',1.3),('5819','2013-03-18','12:00:00',1.39),('5819','2013-03-18','12:05:00',2.33),('5819','2013-03-18','12:10:00',2.26),('5819','2013-03-18','12:15:00',2.61),('5819','2013-03-18','12:20:00',2.62),('5819','2013-03-18','12:25:00',1.74),('5819','2013-03-18','12:30:00',3.05),('5819','2013-03-18','12:35:00',3.23),('5819','2013-03-18','12:40:00',2.88),('5819','2013-03-18','12:45:00',2.38),('5819','2013-03-18','12:50:00',3.35),('5819','2013-03-18','12:55:00',3.55),('5819','2013-03-18','13:00:00',2.39),('5819','2013-03-18','13:05:00',1.39),('5819','2013-03-18','13:25:00',1.54),('5819','2013-03-18','13:30:00',1.29),('5819','2013-03-18','13:35:00',1.02),('5819','2013-03-18','13:40:00',1.62),('5819','2013-03-18','13:45:00',1.56),('5819','2013-03-18','13:50:00',1.53),('5819','2013-03-18','13:55:00',1.44),('5819','2013-03-18','14:00:00',1.51),('5819','2013-03-18','14:05:00',2.33),('5819','2013-03-18','14:10:00',2.29),('5819','2013-03-18','14:15:00',1.22),('5819','2013-03-18','14:20:00',1.05),('5819','2013-03-18','14:25:00',1.5),('5819','2013-03-18','14:40:00',1.12),('5819','2013-03-18','14:45:00',1.04),('5819','2013-03-18','15:00:00',1.02),('5819','2013-03-17','08:15:00',1.18),('5819','2013-03-17','08:20:00',1.37),('5819','2013-03-17','08:25:00',1.6),('5819','2013-03-17','08:30:00',1.54),('5819','2013-03-17','08:35:00',1.2),('5819','2013-03-17','08:40:00',1.21),('5819','2013-03-17','08:45:00',1.41),('5819','2013-03-17','08:50:00',1.42),('5819','2013-03-17','08:55:00',1.32),('5819','2013-03-17','09:00:00',1.27),('5819','2013-03-17','09:05:00',1.48),('5819','2013-03-17','09:10:00',1.7),('5819','2013-03-17','09:15:00',1.86),('5819','2013-03-17','09:20:00',1.58),('5819','2013-03-17','09:25:00',1.31),('5819','2013-03-17','09:30:00',1.37),('5819','2013-03-17','09:35:00',1.64),('5819','2013-03-17','09:40:00',1.47),('5819','2013-03-17','09:45:00',1.49),('5819','2013-03-17','09:50:00',1.67),('5819','2013-03-17','09:55:00',1.82),('5819','2013-03-17','10:00:00',1.99),('5819','2013-03-17','10:05:00',1.68),('5819','2013-03-17','10:10:00',1.61),('5819','2013-03-17','10:15:00',1.77),('5819','2013-03-17','10:20:00',1.78),('5819','2013-03-17','10:25:00',1.87),('5819','2013-03-17','10:30:00',1.83),('5819','2013-03-17','10:35:00',1.73),('5819','2013-03-17','10:40:00',1.64),('5819','2013-03-17','10:45:00',1.72),('5819','2013-03-17','10:50:00',1.7),('5819','2013-03-17','10:55:00',1.5),('5819','2013-03-17','11:00:00',1.55),('5819','2013-03-17','11:05:00',1.36),('5819','2013-03-17','11:10:00',1.27),('5819','2013-03-17','11:15:00',1.31),('5819','2013-03-17','11:20:00',1.52),('5819','2013-03-17','11:25:00',1.61),('5819','2013-03-17','11:30:00',1.42),('5819','2013-03-17','11:35:00',1.4),('5819','2013-03-17','11:40:00',1.33),('5819','2013-03-17','11:45:00',1.25),('5819','2013-03-17','11:50:00',1.16),('5819','2013-03-17','11:55:00',1.03),('5819','2013-03-17','12:05:00',1.01),('5819','2013-03-17','12:10:00',1.27),('5819','2013-03-17','12:15:00',1.72),('5819','2013-03-17','12:20:00',2.12),('5819','2013-03-17','12:25:00',3.18),('5819','2013-03-17','12:30:00',3.64),('5819','2013-03-17','12:35:00',2.52),('5819','2013-03-17','12:40:00',2.72),('5819','2013-03-17','12:45:00',2.41),('5819','2013-03-17','12:50:00',2.11),('5819','2013-03-17','12:55:00',1.62),('5819','2013-03-17','13:00:00',1.83),('5819','2013-03-17','13:05:00',2.06),('5819','2013-03-17','13:10:00',2.25),('5819','2013-03-17','13:15:00',2.21),('5819','2013-03-17','13:20:00',1.87),('5819','2013-03-17','13:25:00',1.66),('5819','2013-03-17','13:30:00',2.41),('5819','2013-03-17','13:35:00',2.84),('5819','2013-03-17','13:40:00',1.9),('5819','2013-03-17','13:45:00',1.74),('5819','2013-03-17','13:50:00',1.34),('5819','2013-03-17','13:55:00',1.87),('5819','2013-03-17','14:00:00',2),('5819','2013-03-17','14:05:00',1.89),('5819','2013-03-17','14:10:00',2.24),('5819','2013-03-17','14:15:00',2.51),('5819','2013-03-17','14:20:00',2.16),('5819','2013-03-17','14:25:00',2.29),('5819','2013-03-17','14:30:00',2.1),('5819','2013-03-17','14:35:00',1.75),('5819','2013-03-17','14:40:00',1.41),('5819','2013-03-17','14:45:00',1.21),('5819','2013-03-17','14:50:00',1.06),('5819','2013-03-17','14:55:00',1.1),('5819','2013-03-17','15:00:00',1.37),('5819','2013-03-17','15:05:00',1.45),('5819','2013-03-17','15:10:00',1.83),('5819','2013-03-17','15:15:00',1.54),('5819','2013-03-17','15:20:00',1.54),('5819','2013-03-17','15:25:00',1.58),('5819','2013-03-17','15:30:00',1.13),('5819','2013-03-17','15:35:00',1.23),('5819','2013-03-17','15:40:00',1.19),('5819','2013-03-17','15:45:00',1.4),('5819','2013-03-16','08:05:00',1.09),('5819','2013-03-16','08:15:00',1.57),('5819','2013-03-16','08:20:00',2.27),('5819','2013-03-16','08:25:00',2.55),('5819','2013-03-16','08:30:00',2.51),('5819','2013-03-16','08:35:00',2.58),('5819','2013-03-16','08:40:00',2.65),('5819','2013-03-16','08:45:00',2.36),('5819','2013-03-16','08:50:00',2.83),('5819','2013-03-16','08:55:00',2.99),('5819','2013-03-16','09:00:00',2.89),('5819','2013-03-16','09:05:00',2.49),('5819','2013-03-16','09:10:00',2.4),('5819','2013-03-16','09:15:00',3.15),('5819','2013-03-16','09:20:00',3.31),('5819','2013-03-16','09:25:00',3.23),('5819','2013-03-16','09:30:00',3.32),('5819','2013-03-16','09:35:00',3.48),('5819','2013-03-16','09:40:00',3.62),('5819','2013-03-16','09:45:00',3.62),('5819','2013-03-16','09:50:00',3.62),('5819','2013-03-16','09:55:00',3.68),('5819','2013-03-16','10:00:00',2.93),('5819','2013-03-16','10:05:00',1.87),('5819','2013-03-16','10:10:00',2.79),('5819','2013-03-16','10:15:00',2.71),('5819','2013-03-16','10:20:00',1.88),('5819','2013-03-16','10:25:00',2.36),('5819','2013-03-16','10:30:00',2.03),('5819','2013-03-16','10:35:00',1.58),('5819','2013-03-16','10:40:00',2.83),('5819','2013-03-16','10:45:00',3.97),('5819','2013-03-16','10:50:00',3.94),('5819','2013-03-16','10:55:00',3.76),('5819','2013-03-16','11:00:00',3.96),('5819','2013-03-16','11:05:00',3.97),('5819','2013-03-16','11:10:00',3.97),('5819','2013-03-16','11:15:00',3.98),('5819','2013-03-16','11:20:00',3.96),('5819','2013-03-16','11:25:00',3.97),('5819','2013-03-16','11:30:00',3.96),('5819','2013-03-16','11:35:00',3.94),('5819','2013-03-16','11:40:00',3.97),('5819','2013-03-16','11:45:00',3.96),('5819','2013-03-16','11:50:00',3.98),('5819','2013-03-16','11:55:00',3.96),('5819','2013-03-16','12:00:00',3.95),('5819','2013-03-16','12:05:00',3.92),('5819','2013-03-16','12:10:00',3.9),('5819','2013-03-16','12:15:00',3.89),('5819','2013-03-16','12:20:00',3.87),('5819','2013-03-16','12:25:00',3.88),('5819','2013-03-16','12:30:00',3.86),('5819','2013-03-16','12:35:00',3.83),('5819','2013-03-16','12:40:00',3.79),('5819','2013-03-16','12:45:00',3.8),('5819','2013-03-16','12:50:00',3.75),('5819','2013-03-16','12:55:00',3.73),('5819','2013-03-16','13:00:00',3.7),('5819','2013-03-16','13:05:00',3.66),('5819','2013-03-16','13:10:00',3.62),('5819','2013-03-16','13:15:00',3.61),('5819','2013-03-16','13:20:00',1.66),('5819','2013-03-16','13:30:00',1.82),('5819','2013-03-16','13:35:00',3.64),('5819','2013-03-16','13:40:00',3.53),('5819','2013-03-16','13:45:00',3.46),('5819','2013-03-16','13:50:00',3.45),('5819','2013-03-16','13:55:00',3.11),('5819','2013-03-16','14:00:00',3.39),('5819','2013-03-16','14:05:00',3.31),('5819','2013-03-16','14:10:00',1.71),('5819','2013-03-16','14:15:00',2.41),('5819','2013-03-16','14:20:00',2.09),('5819','2013-03-16','14:25:00',1.31),('5819','2013-03-16','14:30:00',2.98),('5819','2013-03-16','14:35:00',2.95),('5819','2013-03-16','14:40:00',1.27),('5819','2013-03-16','15:40:00',1),('5819','2013-03-16','16:05:00',1.11),('5819','2013-03-16','16:10:00',1.12),('5819','2013-03-16','16:15:00',1.03),('5819','2013-03-15','10:40:00',1.09),('5819','2013-03-15','10:45:00',1.31),('5819','2013-03-15','10:50:00',1.3),('5819','2013-03-15','10:55:00',1.38),('5819','2013-03-15','11:00:00',1.34),('5819','2013-03-15','11:05:00',1.25),('5819','2013-03-15','11:10:00',1.13),('5819','2013-03-15','11:20:00',1.16),('5819','2013-03-15','11:25:00',1.36),('5819','2013-03-15','11:30:00',1.52),('5819','2013-03-15','11:35:00',1.8),('5819','2013-03-15','11:40:00',2.14),('5819','2013-03-15','11:45:00',2.02),('5819','2013-03-15','11:50:00',1.89),('5819','2013-03-15','11:55:00',1.94),('5819','2013-03-15','12:00:00',1.72),('5819','2013-03-15','12:05:00',1.74),('5819','2013-03-15','12:10:00',1.81),('5819','2013-03-15','12:15:00',1.6),('5819','2013-03-15','12:20:00',1.6),('5819','2013-03-15','12:25:00',1.6),('5819','2013-03-15','12:30:00',1.65),('5819','2013-03-15','12:35:00',1.84),('5819','2013-03-15','12:40:00',1.7),('5819','2013-03-15','12:45:00',1.49),('5819','2013-03-15','12:50:00',1.4),('5819','2013-03-15','12:55:00',1.32),('5819','2013-03-15','13:00:00',1.24),('5819','2013-03-15','13:05:00',1.13),('5819','2013-03-15','13:10:00',1.18),('5819','2013-03-15','13:15:00',1.27),('5819','2013-03-15','13:20:00',1.35),('5819','2013-03-15','13:25:00',1.49),('5819','2013-03-15','13:30:00',1.46),('5819','2013-03-15','13:35:00',1.34),('5819','2013-03-15','13:40:00',1.39),('5819','2013-03-15','13:45:00',1.47),('5819','2013-03-15','13:50:00',1.24),('5819','2013-03-15','13:55:00',1.09),('5819','2013-03-15','14:00:00',1),('5819','2013-03-15','14:55:00',1.01),('5819','2013-03-15','15:00:00',1.06),('5819','2013-03-15','15:05:00',1.05),('5819','2013-03-15','15:10:00',1.04),('5819','2013-03-15','15:15:00',1.13),('5819','2013-03-15','15:20:00',1.12),('5819','2013-03-15','15:25:00',1.19),('5819','2013-03-15','15:30:00',1.11),('5819','2013-03-14','13:00:00',1.06),('5819','2013-03-14','13:05:00',1.12),('5819','2013-03-14','13:15:00',1.01),('5819','2013-03-14','13:20:00',1.1),('5819','2013-03-14','13:25:00',1.1),('5819','2013-03-14','13:30:00',1.03),('5819','2013-03-14','13:40:00',1.11),('5819','2013-03-14','13:45:00',1.55),('5819','2013-03-14','13:50:00',1.84),('5819','2013-03-14','13:55:00',2.19),('5819','2013-03-14','14:00:00',1.82),('5819','2013-03-14','14:05:00',1.83),('5819','2013-03-14','14:10:00',1.41),('5819','2013-03-14','14:15:00',1.18),('5819','2013-03-14','14:20:00',1.02),('5819','2013-03-14','14:25:00',1.01),('5819','2013-03-14','14:30:00',1.02),('5819','2013-03-14','15:10:00',1.2),('5819','2013-03-14','15:15:00',1.23),('5819','2013-03-14','15:20:00',1.13),('5819','2013-03-14','15:25:00',1.11),('5819','2013-03-14','15:30:00',1.07),('5819','2013-03-13','08:50:00',1.05),('5819','2013-03-13','08:55:00',1.08),('5819','2013-03-13','09:10:00',1.18),('5819','2013-03-13','09:15:00',1.06),('5819','2013-03-13','09:20:00',1.08),('5819','2013-03-13','10:10:00',1.06),('5819','2013-03-13','10:15:00',2.18),('5819','2013-03-13','10:20:00',1.68),('5819','2013-03-13','10:25:00',1.68),('5819','2013-03-13','10:30:00',3.68),('5819','2013-03-13','10:35:00',2.44),('5819','2013-03-13','10:40:00',2.69),('5819','2013-03-13','10:45:00',1.46),('5819','2013-03-13','10:50:00',1.21),('5819','2013-03-13','10:55:00',1.13),('5819','2013-03-13','11:00:00',1.11),('5819','2013-03-13','11:30:00',1.03),('5819','2013-03-13','11:35:00',1.07),('5819','2013-03-13','11:40:00',1.06),('5819','2013-03-13','11:45:00',1.14),('5819','2013-03-13','11:50:00',1.07),('5819','2013-03-13','12:50:00',1.19),('5819','2013-03-13','12:55:00',1.07),('5819','2013-03-13','13:00:00',1.01),('5819','2013-03-13','13:05:00',1.01),('5819','2013-03-12','08:20:00',1.62),('5819','2013-03-12','08:25:00',1.95),('5819','2013-03-12','08:30:00',2.13),('5819','2013-03-12','08:35:00',2.08),('5819','2013-03-12','08:40:00',2.24),('5819','2013-03-12','08:45:00',2.55),('5819','2013-03-12','08:50:00',1.88),('5819','2013-03-12','09:00:00',1.45),('5819','2013-03-12','09:05:00',2.79),('5819','2013-03-12','09:10:00',2.84),('5819','2013-03-12','09:15:00',2.86),('5819','2013-03-12','09:20:00',2.9),('5819','2013-03-12','09:25:00',2.97),('5819','2013-03-12','09:30:00',3.04),('5819','2013-03-12','09:35:00',3.12),('5819','2013-03-12','09:40:00',3.16),('5819','2013-03-12','09:45:00',3.21),('5819','2013-03-12','09:50:00',2.07),('5819','2013-03-12','09:55:00',3.54),('5819','2013-03-12','10:00:00',3.37),('5819','2013-03-12','10:05:00',3.4),('5819','2013-03-12','10:10:00',2.72),('5819','2013-03-12','10:15:00',2.72),('5819','2013-03-12','10:20:00',3.5),('5819','2013-03-12','10:25:00',3.38),('5819','2013-03-12','10:30:00',3.89),('5819','2013-03-12','10:35:00',2.39),('5819','2013-03-12','10:40:00',2.92),('5819','2013-03-12','10:45:00',1.94),('5819','2013-03-12','10:50:00',3.31),('5819','2013-03-12','10:55:00',3.48),('5819','2013-03-12','11:00:00',3.41),('5819','2013-03-12','11:05:00',4.22),('5819','2013-03-12','11:10:00',3.08),('5819','2013-03-12','11:15:00',3.38),('5819','2013-03-12','11:20:00',4.05),('5819','2013-03-12','11:25:00',1.92),('5819','2013-03-12','11:30:00',1.48),('5819','2013-03-12','11:35:00',1.63),('5819','2013-03-12','11:40:00',2),('5819','2013-03-12','11:45:00',2.12),('5819','2013-03-12','11:50:00',2.51),('5819','2013-03-12','11:55:00',3.89),('5819','2013-03-12','12:05:00',1.04),('5819','2013-03-12','12:10:00',3.35),('5819','2013-03-12','12:15:00',3.8),('5819','2013-03-12','12:20:00',1.75),('5819','2013-03-12','12:25:00',3.44),('5819','2013-03-12','12:30:00',4.53),('5819','2013-03-12','12:35:00',3.24),('5819','2013-03-12','12:40:00',3.6),('5819','2013-03-12','12:45:00',1.12),('5819','2013-03-12','12:50:00',1.55),('5819','2013-03-12','12:55:00',1.82),('5819','2013-03-12','13:00:00',3.19),('5819','2013-03-12','13:05:00',2.17),('5819','2013-03-12','13:10:00',2.31),('5819','2013-03-12','13:15:00',2.12),('5819','2013-03-12','13:20:00',2.87),('5819','2013-03-12','13:25:00',1.99),('5819','2013-03-12','13:30:00',1.39),('5819','2013-03-12','13:35:00',1.53),('5819','2013-03-12','13:40:00',1.38),('5819','2013-03-12','13:50:00',1.03),('5819','2013-03-12','13:55:00',1.47),('5819','2013-03-12','14:00:00',1.77),('5819','2013-03-12','14:05:00',2.23),('5819','2013-03-12','14:10:00',2.29),('5819','2013-03-12','14:20:00',1.07),('5819','2013-03-11','07:30:00',1.01),('5819','2013-03-11','08:10:00',1.13),('5819','2013-03-11','08:15:00',1.91),('5819','2013-03-11','08:20:00',2),('5819','2013-03-11','08:25:00',2.09),('5819','2013-03-11','08:30:00',2.18),('5819','2013-03-11','08:35:00',2.28),('5819','2013-03-11','08:40:00',2.34),('5819','2013-03-11','08:45:00',2.41),('5819','2013-03-11','08:50:00',2.49),('5819','2013-03-11','08:55:00',2.57),('5819','2013-03-11','09:00:00',2.61),('5819','2013-03-11','09:05:00',2.7),('5819','2013-03-11','09:10:00',2.67),('5819','2013-03-11','09:15:00',2.83),('5819','2013-03-11','09:20:00',2.38),('5819','2013-03-11','09:25:00',2.09),('5819','2013-03-11','09:30:00',1.15),('5819','2013-03-11','09:35:00',2.55),('5819','2013-03-11','09:40:00',3.44),('5819','2013-03-11','09:45:00',3.08),('5819','2013-03-11','09:50:00',1.37),('5819','2013-03-11','10:10:00',1.04),('5819','2013-03-11','10:15:00',1.12),('5819','2013-03-11','10:20:00',1.21),('5819','2013-03-11','10:25:00',1.34),('5819','2013-03-11','10:30:00',1.22),('5819','2013-03-11','10:35:00',1.38),('5819','2013-03-11','10:40:00',2),('5819','2013-03-11','10:45:00',2.34),('5819','2013-03-11','10:50:00',2.79),('5819','2013-03-11','10:55:00',1.67),('5819','2013-03-11','11:00:00',1.43),('5819','2013-03-11','11:05:00',1.23),('5819','2013-03-11','11:10:00',1.47),('5819','2013-03-11','11:15:00',1.58),('5819','2013-03-11','11:20:00',1.36),('5819','2013-03-11','11:25:00',1.25),('5819','2013-03-11','11:30:00',2.18),('5819','2013-03-11','11:35:00',2.69),('5819','2013-03-11','11:40:00',2),('5819','2013-03-11','11:45:00',2.45),('5819','2013-03-11','11:50:00',2.49),('5819','2013-03-11','11:55:00',1.79),('5819','2013-03-11','12:00:00',1.61),('5819','2013-03-11','12:05:00',1.6),('5819','2013-03-11','12:10:00',1.67),('5819','2013-03-11','12:35:00',1.16),('5819','2013-03-11','12:40:00',1.23),('5819','2013-03-11','12:45:00',1.17),('5819','2013-03-11','12:50:00',1.95),('5819','2013-03-11','12:55:00',3.77),('5819','2013-03-11','13:00:00',2.6),('5819','2013-03-11','13:05:00',1.95),('5819','2013-03-11','13:10:00',2.6),('5819','2013-03-11','13:15:00',3.31),('5819','2013-03-11','13:20:00',3.34),('5819','2013-03-11','13:25:00',3.61),('5819','2013-03-11','13:30:00',3.58),('5819','2013-03-11','13:35:00',3.46),('5819','2013-03-11','13:40:00',3.41),('5819','2013-03-11','13:45:00',2.58),('5819','2013-03-11','13:50:00',1.92),('5819','2013-03-11','13:55:00',2.15),('5819','2013-03-11','14:25:00',1.72),('5819','2013-03-11','14:30:00',1.09),('5819','2013-03-11','14:40:00',1.45),('5819','2013-03-11','15:30:00',1.49),('5819','2013-03-11','15:35:00',1.2),('5819','2013-03-11','15:45:00',2.09),('5819','2013-03-11','15:50:00',1.63),('5819','2013-03-11','15:55:00',1.6),('5819','2013-03-11','16:00:00',1.54),('5819','2013-03-11','16:05:00',1.4),('5819','2013-03-11','16:10:00',1.15),('5819','2013-03-11','16:20:00',1.12),('5819','2013-03-11','16:25:00',1.01),('5819','2013-03-11','16:45:00',1.02),('5819','2013-03-10','07:35:00',1.12),('5819','2013-03-10','07:40:00',1.19),('5819','2013-03-10','07:45:00',1.1),('5819','2013-03-10','07:50:00',1.45),('5819','2013-03-10','07:55:00',1.57),('5819','2013-03-10','08:00:00',1.65),('5819','2013-03-10','08:05:00',1.75),('5819','2013-03-10','08:10:00',1.85),('5819','2013-03-10','08:15:00',1.78),('5819','2013-03-10','08:20:00',2.01),('5819','2013-03-10','08:25:00',2.08),('5819','2013-03-10','08:30:00',2.17),('5819','2013-03-10','08:35:00',2.26),('5819','2013-03-10','08:40:00',2.32),('5819','2013-03-10','08:45:00',2.41),('5819','2013-03-10','08:50:00',2.48),('5819','2013-03-10','08:55:00',2.57),('5819','2013-03-10','09:00:00',2.63),('5819','2013-03-10','09:05:00',2.7),('5819','2013-03-10','09:10:00',2.76),('5819','2013-03-10','09:15:00',2.81),('5819','2013-03-10','09:20:00',2.88),('5819','2013-03-10','09:25:00',2.93),('5819','2013-03-10','09:30:00',3),('5819','2013-03-10','09:35:00',3.05),('5819','2013-03-10','09:40:00',3.1),('5819','2013-03-10','09:45:00',3.1),('5819','2013-03-10','09:50:00',1.89),('5819','2013-03-10','09:55:00',3.5),('5819','2013-03-10','10:00:00',1.8),('5819','2013-03-10','10:05:00',2.71),('5819','2013-03-10','10:10:00',2.56),('5819','2013-03-10','10:15:00',2.07),('5819','2013-03-10','10:20:00',3.28),('5819','2013-03-10','10:25:00',3.15),('5819','2013-03-10','10:30:00',3.57),('5819','2013-03-10','10:35:00',3.41),('5819','2013-03-10','10:40:00',2.9),('5819','2013-03-10','10:45:00',3.71),('5819','2013-03-10','10:50:00',3.53),('5819','2013-03-10','10:55:00',2.26),('5819','2013-03-10','11:00:00',3.39),('5819','2013-03-10','11:05:00',3.13),('5819','2013-03-10','11:10:00',3.13),('5819','2013-03-10','11:15:00',2.65),('5819','2013-03-10','11:20:00',1.91),('5819','2013-03-10','11:25:00',2.72),('5819','2013-03-10','11:30:00',2.41),('5819','2013-03-10','11:35:00',1.5),('5819','2013-03-10','11:40:00',1.56),('5819','2013-03-10','11:45:00',1.61),('5819','2013-03-10','11:50:00',2.86),('5819','2013-03-10','11:55:00',3.57),('5819','2013-03-10','12:00:00',3.65),('5819','2013-03-10','12:05:00',3.78),('5819','2013-03-10','12:10:00',3.36),('5819','2013-03-10','12:15:00',3.68),('5819','2013-03-10','12:20:00',1.92),('5819','2013-03-10','12:25:00',3.56),('5819','2013-03-10','12:35:00',1.51),('5819','2013-03-10','12:40:00',1.49),('5819','2013-03-10','12:45:00',4.03),('5819','2013-03-10','12:50:00',3.8),('5819','2013-03-10','12:55:00',3.8),('5819','2013-03-10','13:00:00',3.61),('5819','2013-03-10','13:05:00',3.51),('5819','2013-03-10','13:10:00',3.36),('5819','2013-03-10','13:15:00',3.53),('5819','2013-03-10','13:20:00',3.55),('5819','2013-03-10','13:25:00',3.17),('5819','2013-03-10','13:30:00',3.05),('5819','2013-03-10','13:35:00',2.82),('5819','2013-03-10','13:40:00',1.66),('5819','2013-03-10','13:45:00',1.84),('5819','2013-03-10','13:50:00',1.62),('5819','2013-03-10','13:55:00',1.57),('5819','2013-03-10','14:00:00',1.42),('5819','2013-03-10','14:05:00',1.64),('5819','2013-03-10','14:10:00',1.83),('5819','2013-03-10','14:15:00',2.35),('5819','2013-03-10','14:20:00',2.12),('5819','2013-03-10','14:25:00',1.53),('5819','2013-03-10','14:30:00',1.44),('5819','2013-03-10','14:35:00',2.65),('5819','2013-03-10','14:40:00',2.42),('5819','2013-03-10','14:45:00',1.47),('5819','2013-03-10','14:50:00',1.48),('5819','2013-03-10','14:55:00',1.4),('5819','2013-03-10','15:00:00',1.07),('5819','2013-03-10','15:05:00',1.19),('5819','2013-03-10','15:10:00',1.24),('5819','2013-03-09','08:05:00',1.86),('5819','2013-03-09','08:10:00',1.81),('5819','2013-03-09','08:15:00',1.89),('5819','2013-03-09','08:20:00',1.91),('5819','2013-03-09','08:25:00',2.04),('5819','2013-03-09','08:30:00',2.14),('5819','2013-03-09','08:35:00',2.22),('5819','2013-03-09','08:40:00',2.02),('5819','2013-03-09','08:45:00',1.25),('5819','2013-03-09','08:50:00',1.15),('5819','2013-03-09','08:55:00',2.08),('5819','2013-03-09','09:00:00',1.02),('5819','2013-03-09','09:30:00',2.03),('5819','2013-03-09','09:35:00',2.54),('5819','2013-03-09','09:40:00',3.41),('5819','2013-03-09','09:45:00',3.67),('5819','2013-03-09','09:50:00',2.69),('5819','2013-03-09','09:55:00',2.32),('5819','2013-03-09','10:00:00',1.72),('5819','2013-03-09','10:05:00',1.24),('5819','2013-03-09','10:10:00',1.18),('5819','2013-03-09','10:15:00',1.15),('5819','2013-03-09','10:20:00',1.28),('5819','2013-03-09','10:35:00',1.12),('5819','2013-03-09','10:40:00',1.55),('5819','2013-03-09','10:45:00',2.02),('5819','2013-03-09','10:50:00',3.04),('5819','2013-03-09','10:55:00',4.01),('5819','2013-03-09','11:00:00',2.67),('5819','2013-03-09','11:05:00',3.68),('5819','2013-03-09','11:10:00',3.99),('5819','2013-03-09','11:15:00',3.97),('5819','2013-03-09','11:20:00',3.98),('5819','2013-03-09','11:25:00',3.22),('5819','2013-03-09','11:30:00',4),('5819','2013-03-09','11:35:00',3.89),('5819','2013-03-09','11:40:00',3.89),('5819','2013-03-09','11:45:00',3.93),('5819','2013-03-09','11:50:00',3.79),('5819','2013-03-09','11:55:00',3.8),('5819','2013-03-09','12:00:00',3.76),('5819','2013-03-09','12:05:00',2.16),('5819','2013-03-09','12:10:00',1.54),('5819','2013-03-09','12:15:00',1.16),('5819','2013-03-09','12:20:00',1.14),('5819','2013-03-09','12:25:00',1.56),('5819','2013-03-09','12:30:00',1.38),('5819','2013-03-09','12:35:00',1.42),('5819','2013-03-09','12:40:00',1.39),('5819','2013-03-09','12:45:00',1.77),('5819','2013-03-09','12:50:00',2.33),('5819','2013-03-09','12:55:00',2.5),('5819','2013-03-09','13:00:00',3.74),('5819','2013-03-09','13:05:00',3.58),('5819','2013-03-09','13:10:00',3.53),('5819','2013-03-09','13:15:00',3.48),('5819','2013-03-09','13:20:00',3.35),('5819','2013-03-09','13:25:00',2.33),('5819','2013-03-09','13:30:00',3.2),('5819','2013-03-09','13:35:00',2.31),('5819','2013-03-09','13:40:00',2.99),('5819','2013-03-09','13:45:00',3.4),('5819','2013-03-09','13:50:00',3.33),('5819','2013-03-09','13:55:00',1.57),('5819','2013-03-09','14:00:00',1.38),('5819','2013-03-09','14:05:00',1.27),('5819','2013-03-09','14:10:00',3.25),('5819','2013-03-09','14:15:00',2.77),('5819','2013-03-09','14:20:00',2.87),('5819','2013-03-09','14:25:00',2.78),('5819','2013-03-09','14:30:00',2.71),('5819','2013-03-09','14:35:00',2.64),('5819','2013-03-09','14:40:00',2.57),('5819','2013-03-09','14:45:00',2.51),('5819','2013-03-09','14:50:00',2.42),('5819','2013-03-09','14:55:00',2.36),('5819','2013-03-09','15:00:00',2.29),('5819','2013-03-09','15:05:00',2.21),('5819','2013-03-09','15:10:00',2.15),('5819','2013-03-09','15:15:00',2.07),('5819','2013-03-09','15:20:00',1.98),('5819','2013-03-09','15:25:00',1.89),('5819','2013-03-09','15:30:00',1.8),('5819','2013-03-09','15:35:00',1.73),('5819','2013-03-09','15:40:00',1.67),('5819','2013-03-09','15:45:00',1.59),('5819','2013-03-09','15:50:00',1.5),('5819','2013-03-09','15:55:00',1.38),('5819','2013-03-09','16:00:00',1.23),('5819','2013-03-09','16:05:00',1.19),('5819','2013-03-09','16:15:00',1.05),('5819','2013-03-08','08:10:00',1.2),('5819','2013-03-08','08:15:00',1.23),('5819','2013-03-08','08:30:00',1.26),('5819','2013-03-08','08:35:00',1.56),('5819','2013-03-08','09:25:00',1),('5819','2013-03-08','09:30:00',1.35),('5819','2013-03-08','09:35:00',2.09),('5819','2013-03-08','09:40:00',1.47),('5819','2013-03-08','09:45:00',2.43),('5819','2013-03-08','09:50:00',2.48),('5819','2013-03-08','09:55:00',2.12),('5819','2013-03-08','10:00:00',1.14),('5819','2013-03-08','10:05:00',1.13),('5819','2013-03-08','10:10:00',2.08),('5819','2013-03-08','10:15:00',1.87),('5819','2013-03-08','10:20:00',2.27),('5819','2013-03-08','10:25:00',1.66),('5819','2013-03-08','10:30:00',1.42),('5819','2013-03-08','10:35:00',2.01),('5819','2013-03-08','10:40:00',1.81),('5819','2013-03-08','10:45:00',1.08),('5819','2013-03-08','10:50:00',1.15),('5819','2013-03-08','10:55:00',1.17),('5819','2013-03-08','11:00:00',1.13),('5819','2013-03-08','11:35:00',1.31),('5819','2013-03-08','11:40:00',1.95),('5819','2013-03-08','11:45:00',1.55),('5819','2013-03-08','11:50:00',1.28),('5819','2013-03-08','11:55:00',1.37),('5819','2013-03-08','12:00:00',2.07),('5819','2013-03-08','12:05:00',1.32),('5819','2013-03-08','12:20:00',1.28),('5819','2013-03-08','12:25:00',1.06),('5819','2013-03-08','12:35:00',1.43),('5819','2013-03-08','12:40:00',1.89),('5819','2013-03-08','12:45:00',2.16),('5819','2013-03-08','12:50:00',2.14),('5819','2013-03-08','12:55:00',1.81),('5819','2013-03-08','13:00:00',1.97),('5819','2013-03-08','13:05:00',1.96),('5819','2013-03-08','13:10:00',1.39),('5819','2013-03-08','13:15:00',1.1),('5819','2013-03-08','13:20:00',1.01),('5819','2013-03-08','13:25:00',1.27),('5819','2013-03-08','13:30:00',1.6),('5819','2013-03-08','13:35:00',1.25),('5819','2013-03-08','13:40:00',1.09),('5819','2013-03-07','10:55:00',1.18),('5819','2013-03-07','11:05:00',1.47),('5819','2013-03-07','11:10:00',1.11),('5819','2013-03-07','11:30:00',1.28),('5819','2013-03-07','11:35:00',1.59),('5819','2013-03-07','11:40:00',1.75),('5819','2013-03-07','11:45:00',2.29),('5819','2013-03-07','11:50:00',1.92),('5819','2013-03-07','11:55:00',1.54),('5819','2013-03-07','12:00:00',1.17),('5819','2013-03-07','12:05:00',1),('5819','2013-03-07','12:40:00',1.29),('5819','2013-03-07','12:45:00',1.94),('5819','2013-03-07','12:50:00',1.69),('5819','2013-03-07','12:55:00',1.52),('5819','2013-03-07','13:00:00',1.52),('5819','2013-03-07','13:05:00',1.58),('5819','2013-03-07','13:10:00',1.31),('5819','2013-03-07','13:15:00',1.52),('5819','2013-03-07','13:20:00',1.86),('5819','2013-03-07','13:25:00',1.73),('5819','2013-03-07','13:30:00',1.42),('5819','2013-03-07','13:35:00',1.28),('5819','2013-03-05','08:15:00',1.51),('5819','2013-03-05','08:20:00',1.45),('5819','2013-03-05','08:25:00',1.54),('5819','2013-03-05','08:30:00',2.27),('5819','2013-03-05','08:35:00',2.01),('5819','2013-03-05','08:40:00',2.03),('5819','2013-03-05','08:45:00',1.59),('5819','2013-03-05','08:50:00',1.58),('5819','2013-03-05','08:55:00',1.49),('5819','2013-03-05','09:00:00',1.61),('5819','2013-03-05','09:05:00',1.62),('5819','2013-03-05','09:10:00',1.55),('5819','2013-03-05','09:15:00',1.44),('5819','2013-03-05','09:20:00',1.43),('5819','2013-03-05','09:25:00',1.38),('5819','2013-03-05','09:30:00',1.45),('5819','2013-03-05','09:35:00',1.61),('5819','2013-03-05','09:40:00',1.67),('5819','2013-03-05','09:45:00',1.7),('5819','2013-03-05','09:50:00',1.76),('5819','2013-03-05','09:55:00',1.64),('5819','2013-03-05','10:00:00',1.58),('5819','2013-03-05','10:05:00',1.76),('5819','2013-03-05','10:10:00',1.86),('5819','2013-03-05','10:15:00',1.8),('5819','2013-03-05','10:20:00',2.01),('5819','2013-03-05','10:25:00',1.95),('5819','2013-03-05','10:30:00',1.81),('5819','2013-03-05','10:35:00',2.13),('5819','2013-03-05','10:40:00',2.21),('5819','2013-03-05','10:45:00',2.34),('5819','2013-03-05','10:50:00',2.5),('5819','2013-03-05','10:55:00',2.59),('5819','2013-03-05','11:00:00',2.46),('5819','2013-03-05','11:05:00',2.55),('5819','2013-03-05','11:10:00',2.62),('5819','2013-03-05','11:15:00',2.56),('5819','2013-03-05','11:20:00',2.46),('5819','2013-03-05','11:25:00',2.39),('5819','2013-03-05','11:30:00',2.41),('5819','2013-03-05','11:35:00',2.64),('5819','2013-03-05','11:40:00',2.93),('5819','2013-03-05','11:45:00',2.82),('5819','2013-03-05','11:50:00',2.89),('5819','2013-03-05','11:55:00',2.92),('5819','2013-03-05','12:00:00',2.98),('5819','2013-03-05','12:05:00',3.09),('5819','2013-03-05','12:10:00',3.13),('5819','2013-03-05','12:15:00',2.55),('5819','2013-03-05','12:20:00',2.89),('5819','2013-03-05','12:25:00',2.94),('5819','2013-03-05','12:30:00',2.46),('5819','2013-03-05','12:35:00',2.63),('5819','2013-03-05','12:40:00',2.44),('5819','2013-03-05','12:45:00',2.43),('5819','2013-03-05','12:50:00',2.11),('5819','2013-03-05','12:55:00',1.95),('5819','2013-03-05','13:00:00',1.59),('5819','2013-03-05','13:05:00',1.51),('5819','2013-03-05','13:10:00',1.59),('5819','2013-03-05','13:15:00',1.71),('5819','2013-03-05','13:20:00',1.67),('5819','2013-03-05','13:25:00',1.49),('5819','2013-03-05','13:30:00',1.37),('5819','2013-03-05','13:35:00',1.28),('5819','2013-03-05','13:40:00',1.22),('5819','2013-03-05','13:45:00',1.11),('5819','2013-03-05','13:50:00',1.02),('5819','2013-03-04','07:40:00',1.01),('5819','2013-03-04','07:45:00',1.11),('5819','2013-03-04','07:50:00',1.2),('5819','2013-03-04','07:55:00',1.29),('5819','2013-03-04','08:00:00',1.38),('5819','2013-03-04','08:05:00',1.47),('5819','2013-03-04','08:45:00',2.17),('5819','2013-03-04','08:50:00',2.24),('5819','2013-03-04','08:55:00',2.31),('5819','2013-03-04','09:00:00',2.37),('5819','2013-03-04','09:05:00',2.44),('5819','2013-03-04','09:10:00',2.51),('5819','2013-03-04','09:15:00',2.57),('5819','2013-03-04','09:20:00',2.64),('5819','2013-03-04','09:25:00',2.7),('5819','2013-03-04','09:30:00',2.77),('5819','2013-03-04','09:35:00',2.83),('5819','2013-03-04','09:40:00',2.89),('5819','2013-03-04','09:45:00',2.96),('5819','2013-03-04','09:50:00',3.02),('5819','2013-03-04','09:55:00',3.05),('5819','2013-03-04','10:00:00',3.1),('5819','2013-03-04','10:05:00',3.15),('5819','2013-03-04','10:10:00',3.17),('5819','2013-03-04','10:16:00',3.19),('5819','2013-03-04','10:20:00',3.25),('5819','2013-03-04','10:25:00',3.27),('5819','2013-03-04','10:30:00',3.31),('5819','2013-03-04','10:35:00',3.32),('5819','2013-03-04','10:40:00',3.33),('5819','2013-03-04','10:45:00',3.37),('5819','2013-03-04','11:20:00',3.5),('5819','2013-03-04','11:25:00',3.46),('5819','2013-03-04','11:30:00',3.44),('5819','2013-03-04','11:35:00',3.46),('5819','2013-03-04','11:40:00',3.5),('5819','2013-03-04','11:45:00',3.51),('5819','2013-03-04','11:50:00',3.42),('5819','2013-03-04','11:55:00',3.41),('5819','2013-03-04','12:00:00',3.46),('5819','2013-03-04','12:05:00',3.37),('5819','2013-03-04','12:10:00',3.34),('5819','2013-03-04','12:15:00',3.41),('5819','2013-03-04','12:55:00',3.28),('5819','2013-03-04','13:00:00',3.23),('5819','2013-03-04','13:05:00',3.18),('5819','2013-03-04','13:10:00',3.22),('5819','2013-03-04','13:15:00',3.17),('5819','2013-03-04','13:20:00',3.14),('5819','2013-03-04','13:55:00',2.83),('5819','2013-03-04','14:00:00',2.76),('5819','2013-03-04','14:05:00',2.71),('5819','2013-03-04','14:10:00',2.67),('5819','2013-03-04','14:15:00',2.61),('5819','2013-03-04','14:20:00',2.53),('5819','2013-03-04','14:25:00',2.44),('5819','2013-03-04','14:30:00',2.35),('5819','2013-03-04','14:35:00',2.29),('5819','2013-03-04','14:40:00',2.3),('5819','2013-03-04','14:45:00',2.22),('5819','2013-03-04','14:50:00',2.13),('5819','2013-03-04','14:55:00',2.1),('5819','2013-03-04','15:00:00',2.04),('5819','2013-03-04','15:05:00',1.98),('5819','2013-03-04','15:10:00',1.9),('5819','2013-03-04','15:15:00',1.82),('5819','2013-03-04','15:20:00',1.76),('5819','2013-03-04','15:25:00',1.66),('5819','2013-03-04','15:30:00',1.62),('5819','2013-03-04','15:35:00',1.54),('5819','2013-03-04','15:40:00',1.45),('5819','2013-03-04','15:45:00',1.39),('5819','2013-03-04','15:50:00',1.31),('5819','2013-03-04','15:55:00',1.25),('5819','2013-03-04','16:00:00',1.18),('5819','2013-03-04','16:05:00',1.11),('5819','2013-03-04','16:10:00',1.04),('5819','2013-03-03','07:40:00',1.09),('5819','2013-03-03','07:45:00',1.2),('5819','2013-03-03','07:50:00',1.28),('5819','2013-03-03','07:55:00',1.39),('5819','2013-03-03','08:00:00',1.5),('5819','2013-03-03','08:05:00',1.59),('5819','2013-03-03','08:10:00',1.69),('5819','2013-03-03','08:15:00',1.78),('5819','2013-03-03','08:20:00',1.88),('5819','2013-03-03','08:25:00',1.97),('5819','2013-03-03','08:30:00',2.06),('5819','2013-03-03','08:35:00',2.15),('5819','2013-03-03','08:40:00',2.24),('5819','2013-03-03','08:45:00',2.31),('5819','2013-03-03','08:50:00',2.39),('5819','2013-03-03','08:55:00',2.46),('5819','2013-03-03','09:00:00',2.53),('5819','2013-03-03','09:05:00',2.6),('5819','2013-03-03','09:10:00',2.65),('5819','2013-03-03','09:15:00',2.7),('5819','2013-03-03','09:20:00',2.77),('5819','2013-03-03','09:25:00',2.83),('5819','2013-03-03','09:30:00',2.89),('5819','2013-03-03','09:35:00',2.94),('5819','2013-03-03','09:40:00',2.99),('5819','2013-03-03','10:15:00',3.39),('5819','2013-03-03','10:50:00',3.54),('5819','2013-03-03','10:55:00',3.56),('5819','2013-03-03','11:00:00',3.57),('5819','2013-03-03','11:05:00',3.58),('5819','2013-03-03','11:10:00',3.58),('5819','2013-03-03','11:15:00',3.58),('5819','2013-03-03','11:20:00',3.6),('5819','2013-03-03','11:25:00',3.61),('5819','2013-03-03','11:30:00',3.62),('5819','2013-03-03','11:35:00',3.62),('5819','2013-03-03','11:40:00',3.63),('5819','2013-03-03','11:45:00',3.62),('5819','2013-03-03','11:50:00',3.63),('5819','2013-03-03','11:55:00',3.6),('5819','2013-03-03','12:00:00',3.61),('5819','2013-03-03','12:05:00',3.57),('5819','2013-03-03','12:10:00',3.55),('5819','2013-03-03','12:15:00',3.56),('5819','2013-03-03','12:20:00',3.55),('5819','2013-03-03','12:25:00',3.54),('5819','2013-03-03','12:30:00',3.52),('5819','2013-03-03','12:35:00',3.49),('5819','2013-03-03','12:40:00',3.49),('5819','2013-03-03','12:45:00',3.47),('5819','2013-03-03','12:50:00',3.44),('5819','2013-03-03','12:55:00',3.41),('5819','2013-03-03','13:00:00',3.38),('5819','2013-03-03','13:05:00',3.37),('5819','2013-03-03','13:10:00',3.35),('5819','2013-03-03','13:15:00',3.32),('5819','2013-03-03','13:20:00',3.27),('5819','2013-03-03','13:25:00',3.22),('5819','2013-03-03','13:30:00',3.18),('5819','2013-03-03','13:35:00',3.15),('5819','2013-03-03','13:40:00',3.1),('5819','2013-03-03','13:45:00',3.04),('5819','2013-03-03','13:50:00',3.01),('5819','2013-03-03','13:55:00',2.97),('5819','2013-03-03','14:00:00',2.92),('5819','2013-03-03','14:05:00',2.86),('5819','2013-03-03','14:10:00',2.82),('5819','2013-03-03','14:15:00',2.77),('5819','2013-03-03','14:20:00',2.71),('5819','2013-03-03','14:25:00',2.65),('5819','2013-03-03','14:30:00',2.58),('5819','2013-03-03','14:35:00',2.52),('5819','2013-03-03','14:40:00',2.46),('5819','2013-03-03','14:45:00',2.38),('5819','2013-03-03','14:50:00',2.32),('5819','2013-03-03','14:55:00',2.23),('5819','2013-03-03','15:00:00',2.18),('5819','2013-03-03','15:05:00',2.13),('5819','2013-03-03','15:10:00',2.04),('5819','2013-03-03','15:15:00',1.97),('5819','2013-03-03','15:20:00',1.89),('5819','2013-03-03','15:25:00',1.81),('5819','2013-03-03','15:30:00',1.74),('5819','2013-03-03','15:35:00',1.66),('5819','2013-03-03','15:40:00',1.57),('5819','2013-03-03','15:45:00',1.49),('5819','2013-03-03','15:50:00',1.41),('5819','2013-03-03','15:55:00',1.33),('5819','2013-03-03','16:00:00',1.25),('5819','2013-03-03','16:05:00',1.17),('5819','2013-03-03','16:10:00',1.1),('5819','2013-03-03','16:15:00',1.03),('5819','2013-03-02','10:55:00',1.02),('5819','2013-03-02','11:00:00',1.09),('5819','2013-03-02','11:05:00',1.12),('5819','2013-03-02','11:10:00',1.21),('5819','2013-03-02','11:15:00',1.32),('5819','2013-03-02','11:20:00',1.18),('5819','2013-03-02','11:25:00',1.04),('5819','2013-03-02','11:35:00',1.04),('5819','2013-03-02','11:40:00',1.18),('5819','2013-03-02','11:45:00',1.06),('5819','2013-03-02','11:50:00',1.06),('5819','2013-03-02','11:55:00',1),('5819','2013-03-02','12:05:00',1.09),('5819','2013-03-02','12:10:00',1.1),('5819','2013-03-02','12:15:00',1.08),('5819','2013-03-02','12:20:00',1.03),('5819','2013-03-02','12:25:00',1.12),('5819','2013-03-02','12:30:00',1.1),('5819','2013-03-02','12:35:00',1.25),('5819','2013-03-02','12:40:00',1.29),('5819','2013-03-02','12:45:00',1.19),('5819','2013-03-02','12:50:00',1.15),('5819','2013-03-02','12:55:00',1.26),('5819','2013-03-02','13:00:00',1.32),('5819','2013-03-02','13:05:00',1.14),('5819','2013-03-02','13:45:00',1.04),('5819','2013-03-02','13:50:00',1),('5819','2013-03-02','13:55:00',1.09),('5819','2013-03-02','14:00:00',1.24),('5819','2013-03-02','14:05:00',1.22),('5819','2013-03-01','08:00:00',1.11),('5819','2013-03-01','08:05:00',1.13),('5819','2013-03-01','08:10:00',1.13),('5819','2013-03-01','08:15:00',1.19),('5819','2013-03-01','08:20:00',1.26),('5819','2013-03-01','08:25:00',1.27),('5819','2013-03-01','08:30:00',1.35),('5819','2013-03-01','08:35:00',1.43),('5819','2013-03-01','08:40:00',1.54),('5819','2013-03-01','08:45:00',1.65),('5819','2013-03-01','08:50:00',1.73),('5819','2013-03-01','08:55:00',1.83),('5819','2013-03-01','09:00:00',1.94),('5819','2013-03-01','09:05:00',2.18),('5819','2013-03-01','09:10:00',2.19),('5819','2013-03-01','09:15:00',2.18),('5819','2013-03-01','09:20:00',2.23),('5819','2013-03-01','09:25:00',2.24),('5819','2013-03-01','09:30:00',2.53),('5819','2013-03-01','09:35:00',2.4),('5819','2013-03-01','09:40:00',2.47),('5819','2013-03-01','09:45:00',2.63),('5819','2013-03-01','09:50:00',2.66),('5819','2013-03-01','09:55:00',2.59),('5819','2013-03-01','10:00:00',2.63),('5819','2013-03-01','10:05:00',2.61),('5819','2013-03-01','10:10:00',2.57),('5819','2013-03-01','10:15:00',2.32),('5819','2013-03-01','10:20:00',2.1),('5819','2013-03-01','10:25:00',2.19),('5819','2013-03-01','10:30:00',2.38),('5819','2013-03-01','10:35:00',2.7),('5819','2013-03-01','10:40:00',2.4),('5819','2013-03-01','10:45:00',2.26),('5819','2013-03-01','10:50:00',2.12),('5819','2013-03-01','10:55:00',2),('5819','2013-03-01','11:00:00',1.76),('5819','2013-03-01','11:05:00',1.5),('5819','2013-03-01','11:10:00',1.4),('5819','2013-03-01','11:15:00',1.52),('5819','2013-03-01','11:20:00',1.64),('5819','2013-03-01','11:25:00',1.64),('5819','2013-03-01','11:30:00',1.65),('5819','2013-03-01','11:35:00',1.68),('5819','2013-03-01','11:40:00',1.61),('5819','2013-03-01','11:45:00',1.53),('5819','2013-03-01','11:50:00',1.51),('5819','2013-03-01','11:55:00',1.44),('5819','2013-03-01','12:00:00',1.38),('5819','2013-03-01','12:05:00',1.31),('5819','2013-03-01','12:10:00',1.22),('5819','2013-03-01','12:15:00',1.12),('5819','2013-03-01','12:20:00',1.05),('5819','2013-03-01','12:25:00',1.03),('5819','2013-03-01','12:30:00',1.06),('5819','2013-03-01','12:35:00',1.06),('5819','2013-03-01','12:40:00',1.02),('5819','2013-03-01','12:45:00',1.01),('5819','2013-03-01','12:50:00',1.03),('5819','2013-03-01','12:55:00',1.08),('5819','2013-03-01','13:00:00',1.14),('5819','2013-03-01','13:05:00',1.16),('5819','2013-03-01','13:10:00',1.19),('5819','2013-03-01','13:15:00',1.28),('5819','2013-03-01','13:20:00',1.37),('5819','2013-03-01','13:25:00',1.51),('5819','2013-03-01','13:30:00',1.51),('5819','2013-03-01','13:35:00',1.4),('5819','2013-03-01','13:40:00',1.33),('5819','2013-03-01','13:45:00',1.3),('5819','2013-03-01','13:50:00',1.29),('5819','2013-03-01','13:55:00',1.24),('5819','2013-03-01','14:00:00',1.21),('5819','2013-03-01','14:05:00',1.16),('5819','2013-03-01','14:10:00',1.1),('5819','2013-03-01','14:15:00',1.04),('5819','2013-03-01','14:30:00',1.01),('5819','2013-03-01','14:35:00',1.02),('5819','2013-02-28','07:55:00',1.08),('5819','2013-02-28','08:00:00',1.18),('5819','2013-02-28','08:05:00',1.26),('5819','2013-02-28','08:10:00',1.33),('5819','2013-02-28','08:15:00',1.42),('5819','2013-02-28','08:20:00',1.51),('5819','2013-02-28','08:25:00',1.62),('5819','2013-02-28','08:30:00',1.71),('5819','2013-02-28','08:35:00',1.8),('5819','2013-02-28','08:40:00',1.89),('5819','2013-02-28','08:45:00',1.98),('5819','2013-02-28','08:50:00',2.08),('5819','2013-02-28','08:55:00',2.16),('5819','2013-02-28','09:00:00',2.24),('5819','2013-02-28','09:05:00',2.29),('5819','2013-02-28','09:10:00',2.35),('5819','2013-02-28','09:15:00',2.39),('5819','2013-02-28','09:20:00',2.47),('5819','2013-02-28','09:25:00',2.53),('5819','2013-02-28','09:30:00',2.59),('5819','2013-02-28','09:35:00',2.65),('5819','2013-02-28','09:40:00',2.7),('5819','2013-02-28','09:45:00',2.77),('5819','2013-02-28','09:50:00',2.62),('5819','2013-02-28','09:55:00',2.85),('5819','2013-02-28','10:00:00',2.91),('5819','2013-02-28','10:05:00',2.96),('5819','2013-02-28','10:10:00',2.96),('5819','2013-02-28','10:15:00',3),('5819','2013-02-28','10:20:00',3.03),('5819','2013-02-28','10:25:00',3.04),('5819','2013-02-28','10:30:00',3.02),('5819','2013-02-28','10:35:00',3.14),('5819','2013-02-28','10:40:00',3.15),('5819','2013-02-28','10:45:00',3.18),('5819','2013-02-28','10:50:00',3.2),('5819','2013-02-28','10:55:00',3.23),('5819','2013-02-28','11:00:00',3.29),('5819','2013-02-28','11:05:00',3.33),('5819','2013-02-28','11:10:00',3.32),('5819','2013-02-28','11:15:00',3.32),('5819','2013-02-28','11:20:00',3.35),('5819','2013-02-28','11:25:00',3.41),('5819','2013-02-28','11:30:00',3.4),('5819','2013-02-28','11:35:00',3.39),('5819','2013-02-28','11:40:00',3.4),('5819','2013-02-28','11:45:00',3.4),('5819','2013-02-28','11:50:00',3.42),('5819','2013-02-28','11:55:00',3.42),('5819','2013-02-28','12:00:00',3.33),('5819','2013-02-28','12:05:00',3.3),('5819','2013-02-28','12:10:00',3.38),('5819','2013-02-28','12:15:00',3.37),('5819','2013-02-28','12:20:00',3.34),('5819','2013-02-28','12:25:00',3.3),('5819','2013-02-28','12:30:00',3.31),('5819','2013-02-28','12:35:00',3.31),('5819','2013-02-28','12:40:00',3.31),('5819','2013-02-28','12:45:00',3.19),('5819','2013-02-28','12:50:00',3.17),('5819','2013-02-28','12:55:00',3.22),('5819','2013-02-28','13:00:00',3.07),('5819','2013-02-28','13:05:00',3.21),('5819','2013-02-28','13:10:00',3.13),('5819','2013-02-28','13:15:00',3.16),('5819','2013-02-28','13:20:00',3.19),('5819','2013-02-28','13:25:00',3.17),('5819','2013-02-28','13:30:00',3.03),('5819','2013-02-28','13:35:00',2.93),('5819','2013-02-28','13:40:00',2.26),('5819','2013-02-28','13:45:00',2.71),('5819','2013-02-28','13:50:00',2.99),('5819','2013-02-28','13:55:00',2.88),('5819','2013-02-28','14:00:00',2.83),('5819','2013-02-28','14:05:00',2.75),('5819','2013-02-28','14:10:00',2.7),('5819','2013-02-28','14:15:00',2.6),('5819','2013-02-28','14:20:00',1.9),('5819','2013-02-28','14:25:00',1.75),('5819','2013-02-28','14:30:00',2.35),('5819','2013-02-28','14:35:00',2.19),('5819','2013-02-28','14:40:00',2.25),('5819','2013-02-28','14:45:00',2.21),('5819','2013-02-28','14:50:00',2.14),('5819','2013-02-28','14:55:00',2.09),('5819','2013-02-28','15:00:00',2.01),('5819','2013-02-28','15:05:00',1.93),('5819','2013-02-28','15:10:00',1.8),('5819','2013-02-28','15:15:00',1.75),('5819','2013-02-28','15:20:00',1.68),('5819','2013-02-28','15:25:00',1.52),('5819','2013-02-28','15:30:00',1.44),('5819','2013-02-28','15:35:00',1.4),('5819','2013-02-28','15:40:00',1.35),('5819','2013-02-28','15:45:00',1.29),('5819','2013-02-28','15:50:00',1.22),('5819','2013-02-28','15:55:00',1.16),('5819','2013-02-28','16:00:00',1.07),('5819','2013-02-28','16:05:00',1.01),('5819','2013-02-27','07:55:00',1.02),('5819','2013-02-27','08:00:00',1.14),('5819','2013-02-27','08:05:00',1.23),('5819','2013-02-27','08:10:00',1.3),('5819','2013-02-27','08:15:00',1.38),('5819','2013-02-27','08:20:00',1.48),('5819','2013-02-27','08:25:00',1.58),('5819','2013-02-27','08:30:00',1.67),('5819','2013-02-27','08:35:00',1.75),('5819','2013-02-27','08:40:00',1.82),('5819','2013-02-27','08:45:00',1.9),('5819','2013-02-27','08:50:00',2.01),('5819','2013-02-27','08:55:00',2.08),('5819','2013-02-27','09:00:00',2.15),('5819','2013-02-27','09:05:00',2.23),('5819','2013-02-27','09:10:00',2.3),('5819','2013-02-27','09:15:00',2.38),('5819','2013-02-27','09:20:00',2.45),('5819','2013-02-27','09:25:00',2.5),('5819','2013-02-27','09:30:00',2.57),('5819','2013-02-27','09:35:00',2.62),('5819','2013-02-27','09:40:00',2.68),('5819','2013-02-27','09:45:00',2.74),('5819','2013-02-27','09:50:00',2.78),('5819','2013-02-27','09:55:00',2.83),('5819','2013-02-27','10:00:00',2.88),('5819','2013-02-27','10:05:00',2.92),('5819','2013-02-27','10:10:00',2.97),('5819','2013-02-27','10:15:00',3.03),('5819','2013-02-27','10:20:00',3.07),('5819','2013-02-27','10:25:00',3.06),('5819','2013-02-27','10:30:00',3.1),('5819','2013-02-27','10:35:00',3.17),('5819','2013-02-27','10:40:00',3.17),('5819','2013-02-27','10:45:00',3.19),('5819','2013-02-27','10:50:00',3.27),('5819','2013-02-27','10:55:00',3.29),('5819','2013-02-27','11:00:00',3.32),('5819','2013-02-27','11:05:00',3.36),('5819','2013-02-27','11:10:00',3.39),('5819','2013-02-27','11:15:00',3.35),('5819','2013-02-27','11:20:00',3.32),('5819','2013-02-27','11:25:00',3.41),('5819','2013-02-27','11:30:00',3.04),('5819','2013-02-27','11:35:00',2.78),('5819','2013-02-27','11:40:00',3.09),('5819','2013-02-27','11:45:00',3.38),('5819','2013-02-27','11:50:00',3.52),('5819','2013-02-27','11:55:00',3.54),('5819','2013-02-27','12:00:00',3.49),('5819','2013-02-27','12:05:00',3.47),('5819','2013-02-27','12:10:00',3.49),('5819','2013-02-27','12:15:00',3.59),('5819','2013-02-27','12:20:00',3.57),('5819','2013-02-27','12:25:00',3.44),('5819','2013-02-27','12:30:00',3.35),('5819','2013-02-27','12:35:00',3.36),('5819','2013-02-27','12:40:00',3.38),('5819','2013-02-27','12:45:00',3.37),('5819','2013-02-27','12:50:00',3.32),('5819','2013-02-27','12:55:00',3.25),('5819','2013-02-27','13:00:00',3.26),('5819','2013-02-27','13:05:00',3.31),('5819','2013-02-27','13:10:00',3.28),('5819','2013-02-27','13:15:00',3.12),('5819','2013-02-27','13:20:00',1.7),('5819','2013-02-27','13:25:00',1.47),('5819','2013-02-27','13:30:00',2.4),('5819','2013-02-27','13:35:00',3.13),('5819','2013-02-27','13:40:00',3.01),('5819','2013-02-27','13:45:00',2.95),('5819','2013-02-27','13:50:00',2.24),('5819','2013-02-27','13:55:00',1.9),('5819','2013-02-27','14:00:00',2.1),('5819','2013-02-27','14:05:00',1.81),('5819','2013-02-27','14:10:00',2.55),('5819','2013-02-27','14:15:00',1.41),('5819','2013-02-27','14:20:00',2.47),('5819','2013-02-27','14:25:00',2.51),('5819','2013-02-27','14:30:00',2.45),('5819','2013-02-27','14:35:00',2.41),('5819','2013-02-27','14:40:00',2.35),('5819','2013-02-27','14:45:00',2.28),('5819','2013-02-27','14:50:00',1.66),('5819','2013-02-27','14:55:00',2.05),('5819','2013-02-27','15:00:00',2.06),('5819','2013-02-27','15:05:00',2.03),('5819','2013-02-27','15:10:00',1.93),('5819','2013-02-27','15:15:00',1.51),('5819','2013-02-27','15:20:00',1.74),('5819','2013-02-27','15:25:00',1.67),('5819','2013-02-27','15:30:00',1.58),('5819','2013-02-27','15:35:00',1.52),('5819','2013-02-27','15:40:00',1.39),('5819','2013-02-27','15:45:00',1.35),('5819','2013-02-27','15:50:00',1.29),('5819','2013-02-27','15:55:00',1.22),('5819','2013-02-27','16:00:00',1.16),('5819','2013-02-27','16:05:00',1.08),('5819','2013-02-27','16:10:00',1.02),('5819','2013-02-26','09:25:00',1.07),('5819','2013-02-26','09:30:00',1.31),('5819','2013-02-26','09:35:00',1.64),('5819','2013-02-26','09:40:00',1.84),('5819','2013-02-26','09:45:00',1.84),('5819','2013-02-26','09:50:00',1.87),('5819','2013-02-26','09:55:00',2.09),('5819','2013-02-26','10:00:00',1.98),('5819','2013-02-26','10:05:00',1.99),('5819','2013-02-26','10:10:00',2.37),('5819','2013-02-26','10:15:00',2.73),('5819','2013-02-26','10:20:00',3.18),('5819','2013-02-26','10:25:00',3.45),('5819','2013-02-26','10:30:00',3.29),('5819','2013-02-26','10:35:00',2.9),('5819','2013-02-26','10:40:00',2.03),('5819','2013-02-26','10:45:00',1.36),('5819','2013-02-26','10:50:00',1.59),('5819','2013-02-26','10:55:00',1.71),('5819','2013-02-26','11:00:00',1.9),('5819','2013-02-26','11:05:00',1.99),('5819','2013-02-26','11:10:00',2.05),('5819','2013-02-26','11:15:00',1.84),('5819','2013-02-26','11:20:00',1.54),('5819','2013-02-26','11:25:00',1.47),('5819','2013-02-26','11:30:00',1.44),('5819','2013-02-26','11:35:00',1.42),('5819','2013-02-26','11:40:00',1.55),('5819','2013-02-26','11:45:00',1.48),('5819','2013-02-26','11:50:00',1.74),('5819','2013-02-26','11:55:00',1.67),('5819','2013-02-26','12:00:00',1.69),('5819','2013-02-26','12:05:00',1.62),('5819','2013-02-26','12:10:00',1.62),('5819','2013-02-26','12:15:00',1.41),('5819','2013-02-26','12:20:00',1.4),('5819','2013-02-26','12:25:00',1.27),('5819','2013-02-26','12:30:00',1.28),('5819','2013-02-26','12:35:00',1.17),('5819','2013-02-26','12:40:00',1.07),('5819','2013-02-25','08:45:00',1.05),('5819','2013-02-25','08:50:00',1.3),('5819','2013-02-25','09:00:00',1.31),('5819','2013-02-25','09:25:00',1.25),('5819','2013-02-25','09:30:00',1.42),('5819','2013-02-25','09:35:00',1.41),('5819','2013-02-25','09:40:00',1.16),('5819','2013-02-25','10:45:00',1.48),('5819','2013-02-25','10:50:00',2.72),('5819','2013-02-25','10:55:00',3.76),('5819','2013-02-25','11:00:00',4.38),('5819','2013-02-25','11:05:00',2.54),('5819','2013-02-25','11:10:00',1.78),('5819','2013-02-25','11:15:00',1.55),('5819','2013-02-25','11:20:00',1.08),('5819','2013-02-25','11:30:00',1.72),('5819','2013-02-25','11:35:00',1.16),('5819','2013-02-25','11:40:00',1.2),('5819','2013-02-25','11:45:00',1.5),('5819','2013-02-25','11:50:00',1.85),('5819','2013-02-25','11:55:00',4.33),('5819','2013-02-25','12:00:00',2.76),('5819','2013-02-25','12:05:00',2.14),('5819','2013-02-25','12:10:00',1.7),('5819','2013-02-25','12:15:00',2.38),('5819','2013-02-25','12:20:00',3.68),('5819','2013-02-25','12:25:00',4.01),('5819','2013-02-25','12:30:00',3.43),('5819','2013-02-25','12:35:00',2.46),('5819','2013-02-25','12:40:00',3.59),('5819','2013-02-25','12:45:00',3.58),('5819','2013-02-25','12:50:00',3.41),('5819','2013-02-25','12:55:00',3.37),('5819','2013-02-25','13:00:00',3.53),('5819','2013-02-25','13:05:00',2.7),('5819','2013-02-25','13:10:00',3.32),('5819','2013-02-25','13:15:00',2.25),('5819','2013-02-25','13:20:00',1.85),('5819','2013-02-25','13:25:00',1.29),('5819','2013-02-25','13:30:00',1.54),('5819','2013-02-25','13:35:00',1.32),('5819','2013-02-24','10:50:00',1.11),('5819','2013-02-24','10:55:00',1.08),('5819','2013-02-24','12:40:00',1.01),('5819','2013-02-24','12:45:00',1.24),('5819','2013-02-24','12:50:00',1.12),('5819','2013-02-24','13:00:00',1.04),('5819','2013-02-24','13:05:00',1.57),('5819','2013-02-24','13:10:00',1.46),('5819','2013-02-24','13:15:00',1.16),('5819','2013-02-24','13:20:00',1.36),('5819','2013-02-24','13:25:00',1.05),('5819','2013-02-24','13:35:00',1.16),('5819','2013-02-24','13:40:00',1.26),('5819','2013-02-24','13:45:00',1.31),('5819','2013-02-24','13:50:00',1.12),('5819','2013-02-24','14:00:00',1.06),('5819','2013-02-24','14:05:00',1.58),('5819','2013-02-24','14:10:00',1.64),('5819','2013-02-24','14:15:00',1.07),('5819','2013-02-24','14:30:00',1.09),('5819','2013-02-24','14:35:00',1.16),('5819','2013-02-24','15:10:00',1.7),('5819','2013-02-24','15:15:00',1.22),('5819','2013-02-24','15:25:00',1.54),('5819','2013-02-24','15:35:00',1.06),('5819','2013-02-24','15:40:00',1.31),('5819','2013-02-24','15:45:00',1.02),('5819','2013-02-24','15:50:00',1.08),('5819','2013-02-24','15:55:00',1.09),('5819','2013-02-24','16:00:00',1.42),('5819','2013-02-24','16:05:00',1.01),('5819','2013-02-23','07:50:00',1.09),('5819','2013-02-23','07:55:00',1.21),('5819','2013-02-23','08:00:00',1.31),('5819','2013-02-23','08:05:00',1.43),('5819','2013-02-23','08:10:00',1.68),('5819','2013-02-23','08:15:00',1.95),('5819','2013-02-23','08:20:00',1.14),('5819','2013-02-23','09:00:00',1.29),('5819','2013-02-23','09:05:00',1.33),('5819','2013-02-23','09:45:00',1.23),('5819','2013-02-23','09:50:00',1.28),('5819','2013-02-23','09:55:00',1.25),('5819','2013-02-23','10:00:00',1.01),('5819','2013-02-23','14:05:00',1.39),('5819','2013-02-23','14:10:00',1.27),('5819','2013-02-22','14:35:00',1.14),('5819','2013-02-22','14:40:00',1.27),('5819','2013-02-22','14:45:00',1.09),('5819','2013-02-22','14:55:00',1.23),('5819','2013-02-21','11:50:00',1.04),('5819','2013-02-21','11:55:00',1.08),('5819','2013-02-21','12:00:00',1.06),('5819','2013-02-21','12:05:00',1.06),('5819','2013-02-21','12:10:00',1.11),('5819','2013-02-21','12:15:00',1.17),('5819','2013-02-21','12:20:00',1.27),('5819','2013-02-21','12:25:00',1.26),('5819','2013-02-21','12:30:00',1.17),('5819','2013-02-21','12:35:00',1.11),('5819','2013-02-21','12:40:00',1.07),('5819','2013-02-21','12:45:00',1.09),('5819','2013-02-21','12:50:00',1.09),('5819','2013-02-21','12:55:00',1.16),('5819','2013-02-21','13:00:00',1.2),('5819','2013-02-21','13:05:00',1.12),('5819','2013-02-21','13:10:00',1.06),('5819','2013-02-21','13:15:00',1.07),('5819','2013-02-21','13:20:00',1.11),('5819','2013-02-21','13:25:00',1.14),('5819','2013-02-21','13:30:00',1.16),('5819','2013-02-21','13:35:00',1.16),('5819','2013-02-21','13:40:00',1.13),('5819','2013-02-21','13:45:00',1.08),('5819','2013-02-21','13:50:00',1.07),('5819','2013-02-21','13:55:00',1.07),('5819','2013-02-21','14:00:00',1.09),('5819','2013-02-21','14:05:00',1.06),('5819','2013-02-21','16:20:00',1.13),('5819','2013-02-21','16:25:00',1.2),('5819','2013-02-21','16:30:00',1.1),('5819','2013-02-20','08:20:00',1.43),('5819','2013-02-20','08:25:00',1.59),('5819','2013-02-20','08:30:00',1.67),('5819','2013-02-20','08:35:00',1.77),('5819','2013-02-20','08:40:00',1.85),('5819','2013-02-20','09:15:00',1.32),('5819','2013-02-20','09:55:00',2.34),('5819','2013-02-20','10:00:00',1.51),('5819','2013-02-20','10:10:00',1.92),('5819','2013-02-20','10:15:00',1.19),('5819','2013-02-20','10:45:00',1),('5819','2013-02-20','10:50:00',2.72),('5819','2013-02-20','10:55:00',3.41),('5819','2013-02-20','11:10:00',3.43),('5819','2013-02-20','11:15:00',3.6),('5819','2013-02-20','11:20:00',1.5),('5819','2013-02-20','11:25:00',3.13),('5819','2013-02-20','11:30:00',2.27),('5819','2013-02-20','11:35:00',3.09),('5819','2013-02-20','11:40:00',3.75),('5819','2013-02-20','11:45:00',3.65),('5819','2013-02-20','11:50:00',4.09),('5819','2013-02-20','11:55:00',2.7),('5819','2013-02-20','12:00:00',3.47),('5819','2013-02-20','12:05:00',1.88),('5819','2013-02-20','12:10:00',2.96),('5819','2013-02-20','12:15:00',2.4),('5819','2013-02-20','12:20:00',1.42),('5819','2013-02-20','12:25:00',2.13),('5819','2013-02-20','12:30:00',4.28),('5819','2013-02-20','12:35:00',3.27),('5819','2013-02-20','12:40:00',2.59),('5819','2013-02-20','12:45:00',1.29),('5819','2013-02-20','12:50:00',1.05),('5819','2013-02-20','12:55:00',1.1),('5819','2013-02-20','13:00:00',1.68),('5819','2013-02-20','13:05:00',3.43),('5819','2013-02-20','13:10:00',2.84),('5819','2013-02-20','13:15:00',3.8),('5819','2013-02-20','13:20:00',2.29),('5819','2013-02-20','13:25:00',1.24),('5819','2013-02-20','13:30:00',2.68),('5819','2013-02-20','13:35:00',1.33),('5819','2013-02-20','13:40:00',1.24),('5819','2013-02-20','13:45:00',1.1),('5819','2013-02-20','13:50:00',1.11),('5819','2013-02-20','13:55:00',1.01),('5819','2013-02-20','14:00:00',1),('5819','2013-02-20','14:05:00',1.12),('5819','2013-02-20','15:15:00',1.22),('5819','2013-02-20','15:20:00',1.61),('5819','2013-02-20','15:25:00',1.96),('5819','2013-02-20','15:30:00',1.47),('5819','2013-02-20','16:00:00',1.04),('5819','2013-02-20','16:05:00',1.33),('5819','2013-02-20','16:10:00',1.21),('5819','2013-02-20','16:15:00',1.21),('5819','2013-02-20','16:20:00',1.11),('5819','2013-02-19','08:00:00',1.09),('5819','2013-02-19','08:05:00',1.2),('5819','2013-02-19','08:10:00',1.29),('5819','2013-02-19','08:15:00',1.39),('5819','2013-02-19','08:20:00',1.48),('5819','2013-02-19','08:25:00',1.58),('5819','2013-02-19','08:30:00',1.67),('5819','2013-02-19','08:35:00',1.76),('5819','2013-02-19','08:40:00',1.83),('5819','2013-02-19','08:45:00',1.92),('5819','2013-02-19','08:50:00',2),('5819','2013-02-19','08:55:00',2.06),('5819','2013-02-19','09:00:00',2.14),('5819','2013-02-19','09:05:00',2.21),('5819','2013-02-19','09:10:00',2.27),('5819','2013-02-19','09:15:00',2.35),('5819','2013-02-19','09:20:00',2.42),('5819','2013-02-19','09:25:00',2.48),('5819','2013-02-19','09:30:00',2.54),('5819','2013-02-19','09:35:00',2.59),('5819','2013-02-19','09:40:00',2.63),('5819','2013-02-19','09:45:00',2.7),('5819','2013-02-19','09:50:00',2.75),('5819','2013-02-19','09:55:00',2.79),('5819','2013-02-19','10:00:00',2.84),('5819','2013-02-19','10:05:00',2.88),('5819','2013-02-19','10:10:00',2.93),('5819','2013-02-19','10:15:00',2.98),('5819','2013-02-19','10:20:00',3.02),('5819','2013-02-19','10:25:00',3.06),('5819','2013-02-19','10:30:00',3.09),('5819','2013-02-19','10:35:00',3.12),('5819','2013-02-19','10:40:00',3.14),('5819','2013-02-19','10:45:00',3.16),('5819','2013-02-19','10:50:00',3.19),('5819','2013-02-19','10:55:00',3.19),('5819','2013-02-19','11:00:00',3.23),('5819','2013-02-19','11:05:00',3.28),('5819','2013-02-19','11:10:00',3.27),('5819','2013-02-19','11:15:00',3.31),('5819','2013-02-19','11:20:00',3.34),('5819','2013-02-19','11:25:00',3.35),('5819','2013-02-19','11:30:00',3.33),('5819','2013-02-19','11:35:00',3.36),('5819','2013-02-19','11:40:00',3.34),('5819','2013-02-19','11:45:00',3.35),('5819','2013-02-19','11:50:00',3.37),('5819','2013-02-19','11:55:00',3.35),('5819','2013-02-19','12:00:00',3.34),('5819','2013-02-19','12:05:00',3.35),('5819','2013-02-19','12:10:00',3.31),('5819','2013-02-19','12:15:00',3.28),('5819','2013-02-19','12:20:00',3.27),('5819','2013-02-19','12:25:00',3.27),('5819','2013-02-19','12:30:00',3.25),('5819','2013-02-19','12:35:00',3.22),('5819','2013-02-19','12:40:00',3.23),('5819','2013-02-19','12:45:00',3.21),('5819','2013-02-19','12:50:00',3.21),('5819','2013-02-19','12:55:00',3.2),('5819','2013-02-19','13:00:00',3.16),('5819','2013-02-19','13:05:00',3.14),('5819','2013-02-19','13:10:00',3.08),('5819','2013-02-19','13:15:00',3.03),('5819','2013-02-19','13:20:00',2.95),('5819','2013-02-19','13:25:00',3.01),('5819','2013-02-19','13:30:00',2.98),('5819','2013-02-19','13:35:00',2.95),('5819','2013-02-19','13:40:00',2.89),('5819','2013-02-19','13:45:00',2.86),('5819','2013-02-19','13:50:00',2.82),('5819','2013-02-19','13:55:00',2.74),('5819','2013-02-19','14:00:00',2.64),('5819','2013-02-19','14:05:00',2.6),('5819','2013-02-19','14:10:00',2.58),('5819','2013-02-19','14:15:00',2.55),('5819','2013-02-19','14:20:00',2.37),('5819','2013-02-19','14:25:00',2.31),('5819','2013-02-19','14:30:00',2.28),('5819','2013-02-19','14:35:00',2.19),('5819','2013-02-19','14:40:00',2.17),('5819','2013-02-19','14:45:00',2.1),('5819','2013-02-19','14:50:00',2.06),('5819','2013-02-19','14:55:00',2.01),('5819','2013-02-19','15:00:00',1.93),('5819','2013-02-19','15:05:00',1.85),('5819','2013-02-19','15:10:00',1.79),('5819','2013-02-19','15:15:00',1.73),('5819','2013-02-19','15:20:00',1.64),('5819','2013-02-19','15:25:00',1.58),('5819','2013-02-19','15:30:00',1.44),('5819','2013-02-19','15:35:00',1.39),('5819','2013-02-19','15:40:00',1.33),('5819','2013-02-19','15:45:00',1.25),('5819','2013-02-19','15:50:00',1.18),('5819','2013-02-19','15:55:00',1.12),('5819','2013-02-19','16:00:00',1.05),('5819','2013-02-18','08:05:00',1.07),('5819','2013-02-18','08:10:00',1.21),('5819','2013-02-18','08:15:00',1.28),('5819','2013-02-18','08:20:00',1.37),('5819','2013-02-18','08:25:00',1.45),('5819','2013-02-18','08:30:00',1.54),('5819','2013-02-18','08:35:00',1.65),('5819','2013-02-18','08:40:00',1.73),('5819','2013-02-18','08:45:00',1.79),('5819','2013-02-18','08:50:00',1.83),('5819','2013-02-18','08:55:00',1.92),('5819','2013-02-18','09:00:00',1.98),('5819','2013-02-18','09:05:00',2.07),('5819','2013-02-18','09:10:00',2.15),('5819','2013-02-18','09:15:00',2.18),('5819','2013-02-18','09:20:00',2.48),('5819','2013-02-18','09:25:00',2.6),('5819','2013-02-18','09:30:00',2.48),('5819','2013-02-18','09:35:00',1.48),('5819','2013-02-18','09:40:00',1.04),('5819','2013-02-18','09:45:00',1.01),('5819','2013-02-18','09:50:00',1.64),('5819','2013-02-18','10:10:00',1.22),('5819','2013-02-18','11:00:00',1.18),('5819','2013-02-18','11:05:00',1.19),('5819','2013-02-18','11:10:00',1.27),('5819','2013-02-18','11:15:00',1.16),('5819','2013-02-18','11:20:00',1.3),('5819','2013-02-18','11:25:00',1.44),('5819','2013-02-18','11:30:00',1.29),('5819','2013-02-18','11:35:00',1.31),('5819','2013-02-18','11:40:00',1.3),('5819','2013-02-18','11:45:00',1.21),('5819','2013-02-18','11:50:00',1.28),('5819','2013-02-18','11:55:00',1.47),('5819','2013-02-18','12:00:00',1.55),('5819','2013-02-18','12:05:00',1.45),('5819','2013-02-18','12:10:00',1.34),('5819','2013-02-18','12:15:00',1.33),('5819','2013-02-18','12:20:00',1.27),('5819','2013-02-18','12:25:00',1.27),('5819','2013-02-18','12:30:00',1.23),('5819','2013-02-18','12:35:00',1.15),('5819','2013-02-18','12:40:00',1.19),('5819','2013-02-18','12:45:00',1.43),('5819','2013-02-18','12:50:00',1.48),('5819','2013-02-18','12:55:00',1.35),('5819','2013-02-18','13:00:00',1.35),('5819','2013-02-18','13:05:00',1.4),('5819','2013-02-18','13:10:00',1.39),('5819','2013-02-18','13:15:00',1.69),('5819','2013-02-18','13:20:00',1.42),('5819','2013-02-18','13:25:00',1.77),('5819','2013-02-18','13:30:00',1.56),('5819','2013-02-18','13:35:00',1.27),('5819','2013-02-18','13:40:00',1.19),('5819','2013-02-18','13:45:00',1.13),('5819','2013-02-18','13:50:00',1.15),('5819','2013-02-18','13:55:00',1.38),('5819','2013-02-18','14:00:00',1.46),('5819','2013-02-18','14:05:00',1.37),('5819','2013-02-18','14:10:00',1.22),('5819','2013-02-18','14:15:00',1.01),('5819','2013-02-18','14:20:00',1.14),('5819','2013-02-17','08:10:00',1.08),('5819','2013-02-17','08:15:00',1.19),('5819','2013-02-17','08:20:00',1.3),('5819','2013-02-17','08:25:00',1.39),('5819','2013-02-17','08:30:00',1.53),('5819','2013-02-17','08:35:00',1.68),('5819','2013-02-17','08:40:00',1.81),('5819','2013-02-17','08:45:00',1.74),('5819','2013-02-17','08:50:00',1.56),('5819','2013-02-17','08:55:00',1.73),('5819','2013-02-17','09:00:00',1.93),('5819','2013-02-17','09:05:00',1.94),('5819','2013-02-17','09:10:00',2.06),('5819','2013-02-17','09:15:00',2.13),('5819','2013-02-17','09:20:00',2.26),('5819','2013-02-17','09:25:00',2.31),('5819','2013-02-17','09:30:00',2.35),('5819','2013-02-17','09:35:00',2.41),('5819','2013-02-17','09:40:00',2.47),('5819','2013-02-17','09:45:00',2.54),('5819','2013-02-17','09:50:00',2.6),('5819','2013-02-17','09:55:00',2.66),('5819','2013-02-17','10:00:00',2.71),('5819','2013-02-17','10:05:00',2.76),('5819','2013-02-17','10:10:00',2.78),('5819','2013-02-17','10:15:00',2.84),('5819','2013-02-17','10:20:00',2.89),('5819','2013-02-17','10:25:00',2.91),('5819','2013-02-17','10:30:00',2.97),('5819','2013-02-17','10:35:00',3),('5819','2013-02-17','10:40:00',3.03),('5819','2013-02-17','10:45:00',3.04),('5819','2013-02-17','10:50:00',3.07),('5819','2013-02-17','10:55:00',3.09),('5819','2013-02-17','11:00:00',3.1),('5819','2013-02-17','11:05:00',3.14),('5819','2013-02-17','11:10:00',3.13),('5819','2013-02-17','11:15:00',3.18),('5819','2013-02-17','11:20:00',3.18),('5819','2013-02-17','11:25:00',3.18),('5819','2013-02-17','11:30:00',3.2),('5819','2013-02-17','11:35:00',3.19),('5819','2013-02-17','11:40:00',3.19),('5819','2013-02-17','11:45:00',3.18),('5819','2013-02-17','11:50:00',3.19),('5819','2013-02-17','11:55:00',3.2),('5819','2013-02-17','12:00:00',3.19),('5819','2013-02-17','12:05:00',3.19),('5819','2013-02-17','12:10:00',3.22),('5819','2013-02-17','12:15:00',3.22),('5819','2013-02-17','12:20:00',3.2),('5819','2013-02-17','12:25:00',3.2),('5819','2013-02-17','12:30:00',3.18),('5819','2013-02-17','12:35:00',3.16),('5819','2013-02-17','12:40:00',3.13),('5819','2013-02-17','12:45:00',3.07),('5819','2013-02-17','12:50:00',3),('5819','2013-02-17','12:55:00',2.98),('5819','2013-02-17','13:00:00',2.99),('5819','2013-02-17','13:05:00',2.96),('5819','2013-02-17','13:10:00',2.91),('5819','2013-02-17','13:15:00',2.89),('5819','2013-02-17','13:20:00',2.8),('5819','2013-02-17','13:25:00',2.78),('5819','2013-02-17','13:30:00',2.8),('5819','2013-02-17','13:35:00',2.73),('5819','2013-02-17','13:40:00',2.66),('5819','2013-02-17','13:45:00',2.59),('5819','2013-02-17','13:50:00',2.45),('5819','2013-02-17','13:55:00',2.44),('5819','2013-02-17','14:00:00',1.26),('5819','2013-02-17','14:10:00',2.22),('5819','2013-02-17','14:15:00',2.39),('5819','2013-02-17','14:20:00',1.27),('5819','2013-02-17','14:25:00',1.3),('5819','2013-02-17','14:30:00',2.22),('5819','2013-02-17','14:35:00',1.91),('5819','2013-02-17','14:40:00',1.36),('5819','2013-02-17','15:05:00',1.17),('5819','2013-02-17','15:10:00',2),('5819','2013-02-17','15:15:00',1.99),('5819','2013-02-17','15:20:00',1.94),('5819','2013-02-17','15:25:00',1.84),('5819','2013-02-17','15:30:00',1.48),('5819','2013-02-17','15:35:00',1.57),('5819','2013-02-17','15:40:00',1.59),('5819','2013-02-17','15:45:00',1.47),('5819','2013-02-17','15:50:00',1.36),('5819','2013-02-17','15:55:00',1.28),('5819','2013-02-17','16:00:00',1.18),('5819','2013-02-17','16:05:00',1.08),('5819','2013-02-16','08:10:00',1.08),('5819','2013-02-16','08:15:00',1.19),('5819','2013-02-16','08:20:00',1.27),('5819','2013-02-16','08:25:00',1.39),('5819','2013-02-16','08:30:00',1.48),('5819','2013-02-16','08:35:00',1.57),('5819','2013-02-16','08:40:00',1.68),('5819','2013-02-16','08:45:00',1.69),('5819','2013-02-16','09:10:00',1.16),('5819','2013-02-16','09:15:00',2.32),('5819','2013-02-16','09:20:00',2.38),('5819','2013-02-16','09:25:00',2.42),('5819','2013-02-16','09:30:00',2.47),('5819','2013-02-16','09:35:00',2.53),('5819','2013-02-16','09:40:00',2.55),('5819','2013-02-16','09:45:00',2.61),('5819','2013-02-16','09:50:00',2.7),('5819','2013-02-16','09:55:00',2.72),('5819','2013-02-16','10:00:00',2.73),('5819','2013-02-16','10:05:00',2.8),('5819','2013-02-16','10:10:00',2.88),('5819','2013-02-16','10:15:00',2.89),('5819','2013-02-16','10:20:00',2.95),('5819','2013-02-16','10:25:00',2.95),('5819','2013-02-16','10:30:00',3.05),('5819','2013-02-16','10:35:00',3.11),('5819','2013-02-16','10:40:00',3.22),('5819','2013-02-16','10:45:00',3.25),('5819','2013-02-16','10:50:00',3.24),('5819','2013-02-16','10:55:00',3.22),('5819','2013-02-16','11:00:00',3.23),('5819','2013-02-16','11:05:00',3.14),('5819','2013-02-16','11:10:00',3.31),('5819','2013-02-16','11:15:00',3.31),('5819','2013-02-16','11:20:00',3.16),('5819','2013-02-16','11:25:00',3.25),('5819','2013-02-16','11:30:00',3.3),('5819','2013-02-16','11:35:00',3.33),('5819','2013-02-16','11:40:00',3.31),('5819','2013-02-16','11:45:00',3.35),('5819','2013-02-16','11:50:00',3.37),('5819','2013-02-16','11:55:00',3.37),('5819','2013-02-16','12:00:00',3.35),('5819','2013-02-16','12:05:00',3.31),('5819','2013-02-16','12:10:00',3.31),('5819','2013-02-16','12:15:00',3.29),('5819','2013-02-16','12:20:00',3.29),('5819','2013-02-16','12:25:00',3.26),('5819','2013-02-16','12:30:00',3.25),('5819','2013-02-16','12:35:00',3.23),('5819','2013-02-16','12:40:00',3.23),('5819','2013-02-16','12:45:00',3.22),('5819','2013-02-16','12:50:00',3.23),('5819','2013-02-16','12:55:00',3.2),('5819','2013-02-16','13:00:00',3.16),('5819','2013-02-16','13:05:00',3.12),('5819','2013-02-16','13:10:00',3.07),('5819','2013-02-16','13:15:00',3.05),('5819','2013-02-16','13:20:00',3),('5819','2013-02-16','13:25:00',2.96),('5819','2013-02-16','13:30:00',2.93),('5819','2013-02-16','13:35:00',2.9),('5819','2013-02-16','13:40:00',2.89),('5819','2013-02-16','13:45:00',2.85),('5819','2013-02-16','13:50:00',2.8),('5819','2013-02-16','13:55:00',2.76),('5819','2013-02-16','14:00:00',2.69),('5819','2013-02-16','14:05:00',2.65),('5819','2013-02-16','14:10:00',2.6),('5819','2013-02-16','14:15:00',2.56),('5819','2013-02-16','14:20:00',2.24),('5819','2013-02-16','14:25:00',1.44),('5819','2013-02-16','15:20:00',1.1),('5819','2013-02-16','15:30:00',1.62),('5819','2013-02-16','15:35:00',1.57),('5819','2013-02-16','15:40:00',1.56),('5819','2013-02-16','15:45:00',1.7),('5819','2013-02-16','15:50:00',1.6),('5819','2013-02-16','15:55:00',1.06),('5819','2013-02-16','16:00:00',1.09),('5819','2013-02-16','16:05:00',1.08),('5819','2013-02-15','08:00:00',1.03),('5819','2013-02-15','09:25:00',1.61),('5819','2013-02-15','09:30:00',1.45),('5819','2013-02-15','09:35:00',1.04),('5819','2013-02-15','09:45:00',1.02),('5819','2013-02-15','09:50:00',1.21),('5819','2013-02-15','09:55:00',1.2),('5819','2013-02-15','10:00:00',1.61),('5819','2013-02-15','10:05:00',1.74),('5819','2013-02-15','10:10:00',1.51),('5819','2013-02-15','10:15:00',1.36),('5819','2013-02-15','10:20:00',1.29),('5819','2013-02-15','10:25:00',2.31),('5819','2013-02-15','10:30:00',1.79),('5819','2013-02-15','10:35:00',2.73),('5819','2013-02-15','10:41:00',3.15),('5819','2013-02-15','10:45:00',2.79),('5819','2013-02-15','10:50:00',2.47),('5819','2013-02-15','10:55:00',1.95),('5819','2013-02-15','11:00:00',1.75),('5819','2013-02-15','11:05:00',1.84),('5819','2013-02-15','11:10:00',2.13),('5819','2013-02-15','11:15:00',2.53),('5819','2013-02-15','11:20:00',3.36),('5819','2013-02-15','11:25:00',3.39),('5819','2013-02-15','11:30:00',3.4),('5819','2013-02-15','11:35:00',2.82),('5819','2013-02-15','11:40:00',1.94),('5819','2013-02-15','11:45:00',1.94),('5819','2013-02-15','11:50:00',3.39),('5819','2013-02-15','11:55:00',3.3),('5819','2013-02-15','12:00:00',2.7),('5819','2013-02-15','12:05:00',2.69),('5819','2013-02-15','12:10:00',2.81),('5819','2013-02-15','12:15:00',2.69),('5819','2013-02-15','12:20:00',3.62),('5819','2013-02-15','12:25:00',3.12),('5819','2013-02-15','12:32:00',3.15),('5819','2013-02-15','12:35:00',3.26),('5819','2013-02-15','12:40:00',3.21),('5819','2013-02-15','12:45:00',3.22),('5819','2013-02-15','12:50:00',3.18),('5819','2013-02-15','12:55:00',3.19),('5819','2013-02-15','13:00:00',3.13),('5819','2013-02-15','13:05:00',3.12),('5819','2013-02-15','13:10:00',3.11),('5819','2013-02-15','13:15:00',3.02),('5819','2013-02-15','13:20:00',2.8),('5819','2013-02-15','13:25:00',2.5),('5819','2013-02-15','13:30:00',2.16),('5819','2013-02-15','13:35:00',2.34),('5819','2013-02-15','13:40:00',3.01),('5819','2013-02-15','13:45:00',2.41),('5819','2013-02-15','13:50:00',2.47),('5819','2013-02-15','13:55:00',2.77),('5819','2013-02-15','14:00:00',1.94),('5819','2013-02-15','14:05:00',2.4),('5819','2013-02-15','14:10:00',3.13),('5819','2013-02-15','14:15:00',2.13),('5819','2013-02-15','14:20:00',2.31),('5819','2013-02-15','14:25:00',1.69),('5819','2013-02-15','14:30:00',1.62),('5819','2013-02-15','14:35:00',2.12),('5819','2013-02-15','14:40:00',2.22),('5819','2013-02-15','14:45:00',1.93),('5819','2013-02-15','14:50:00',1.09),('5819','2013-02-15','14:55:00',1.09),('5819','2013-02-15','15:00:00',1.41),('5819','2013-02-15','15:05:00',1.03),('5819','2013-02-15','15:10:00',1.23),('5819','2013-02-15','15:15:00',1.4),('5819','2013-02-15','15:20:00',1.13),('5819','2013-02-15','15:25:00',1.29),('5819','2013-02-15','15:30:00',1.47),('5819','2013-02-15','15:35:00',1.16),('5819','2013-02-14','08:00:00',1.03),('5819','2013-02-14','08:05:00',1.12),('5819','2013-02-14','08:10:00',1.23),('5819','2013-02-14','08:15:00',1.33),('5819','2013-02-14','08:20:00',1.33),('5819','2013-02-14','08:25:00',1.43),('5819','2013-02-14','08:30:00',1.42),('5819','2013-02-14','08:35:00',1.66),('5819','2013-02-14','08:40:00',1.82),('5819','2013-02-14','08:45:00',1.89),('5819','2013-02-14','08:50:00',1.97),('5819','2013-02-14','08:55:00',2.05),('5819','2013-02-14','09:00:00',2.13),('5819','2013-02-14','09:05:00',2.2),('5819','2013-02-14','09:10:00',2.28),('5819','2013-02-14','09:15:00',2.35),('5819','2013-02-14','09:20:00',2.42),('5819','2013-02-14','09:25:00',2.49),('5819','2013-02-14','09:30:00',2.56),('5819','2013-02-14','09:35:00',2.62),('5819','2013-02-14','09:40:00',2.68),('5819','2013-02-14','09:45:00',2.74),('5819','2013-02-14','09:50:00',2.79),('5819','2013-02-14','09:55:00',2.85),('5819','2013-02-14','10:00:00',2.9),('5819','2013-02-14','10:05:00',2.95),('5819','2013-02-14','10:10:00',3.01),('5819','2013-02-14','10:15:00',3.04),('5819','2013-02-14','10:20:00',3.08),('5819','2013-02-14','10:25:00',3.12),('5819','2013-02-14','10:30:00',3.15),('5819','2013-02-14','10:35:00',3.17),('5819','2013-02-14','10:40:00',3.21),('5819','2013-02-14','10:45:00',3.24),('5819','2013-02-14','10:50:00',3.27),('5819','2013-02-14','10:55:00',3.3),('5819','2013-02-14','11:00:00',3.32),('5819','2013-02-14','11:05:00',3.33),('5819','2013-02-14','11:10:00',3.35),('5819','2013-02-14','11:15:00',3.36),('5819','2013-02-14','11:20:00',3.36),('5819','2013-02-14','11:25:00',3.37),('5819','2013-02-14','11:30:00',3.38),('5819','2013-02-14','11:35:00',3.38),('5819','2013-02-14','11:40:00',3.37),('5819','2013-02-14','11:45:00',3.39),('5819','2013-02-14','11:50:00',3.39),('5819','2013-02-14','11:55:00',3.41),('5819','2013-02-14','12:00:00',3.39),('5819','2013-02-14','12:05:00',3.38),('5819','2013-02-14','12:10:00',3.36),('5819','2013-02-14','12:15:00',3.36),('5819','2013-02-14','12:20:00',3.34),('5819','2013-02-14','12:25:00',3.33),('5819','2013-02-14','12:30:00',3.31),('5819','2013-02-14','12:35:00',3.3),('5819','2013-02-14','12:40:00',3.28),('5819','2013-02-14','12:45:00',3.24),('5819','2013-02-14','12:50:00',3.2),('5819','2013-02-14','12:55:00',3.18),('5819','2013-02-14','13:00:00',3.15),('5819','2013-02-14','13:05:00',3.12),('5819','2013-02-14','13:10:00',3.11),('5819','2013-02-14','13:15:00',3.08),('5819','2013-02-14','13:20:00',3.03),('5819','2013-02-14','13:25:00',2.98),('5819','2013-02-14','13:30:00',2.94),('5819','2013-02-14','13:35:00',2.91),('5819','2013-02-14','13:40:00',2.87),('5819','2013-02-14','13:45:00',2.82),('5819','2013-02-14','13:50:00',2.78),('5819','2013-02-14','13:55:00',2.72),('5819','2013-02-14','14:00:00',2.66),('5819','2013-02-14','14:05:00',2.62),('5819','2013-02-14','14:10:00',2.55),('5819','2013-02-14','14:15:00',2.49),('5819','2013-02-14','14:20:00',2.44),('5819','2013-02-14','14:25:00',2.37),('5819','2013-02-14','14:30:00',2.31),('5819','2013-02-14','14:35:00',2.24),('5819','2013-02-14','14:40:00',2.17),('5819','2013-02-14','14:45:00',2.11),('5819','2013-02-14','14:50:00',2.06),('5819','2013-02-14','14:55:00',1.97),('5819','2013-02-14','15:00:00',1.89),('5819','2013-02-14','15:05:00',1.81),('5819','2013-02-14','15:10:00',1.73),('5819','2013-02-14','15:15:00',1.66),('5819','2013-02-14','15:20:00',1.57),('5819','2013-02-14','15:25:00',1.49),('5819','2013-02-14','15:30:00',1.42),('5819','2013-02-14','15:35:00',1.34),('5819','2013-02-14','15:40:00',1.26),('5819','2013-02-14','15:45:00',1.19),('5819','2013-02-14','15:50:00',1.13),('5819','2013-02-14','15:55:00',1.06),('5819','2013-02-13','09:00:00',1.13),('5819','2013-02-13','09:05:00',1.33),('5819','2013-02-13','09:10:00',1.43),('5819','2013-02-13','09:15:00',1.36),('5819','2013-02-13','09:20:00',1.33),('5819','2013-02-13','09:25:00',1.31),('5819','2013-02-13','09:30:00',1.47),('5819','2013-02-13','09:35:00',1.75),('5819','2013-02-13','09:40:00',2.34),('5819','2013-02-13','09:45:00',2.62),('5819','2013-02-13','09:50:00',2.58),('5819','2013-02-13','09:55:00',2.63),('5819','2013-02-13','10:00:00',2.38),('5819','2013-02-13','10:05:00',2.63),('5819','2013-02-13','10:10:00',2.78),('5819','2013-02-13','10:15:00',2.93),('5819','2013-02-13','10:20:00',2.97),('5819','2013-02-13','10:25:00',3.09),('5819','2013-02-13','10:30:00',3.16),('5819','2013-02-13','10:35:00',3.14),('5819','2013-02-13','10:40:00',3.25),('5819','2013-02-13','10:45:00',3.41),('5819','2013-02-13','10:50:00',3.41),('5819','2013-02-13','10:55:00',3.36),('5819','2013-02-13','11:00:00',3.34),('5819','2013-02-13','11:05:00',3.2),('5819','2013-02-13','11:10:00',3.25),('5819','2013-02-13','11:15:00',3.28),('5819','2013-02-13','11:20:00',3.21),('5819','2013-02-13','11:25:00',2.81),('5819','2013-02-13','11:30:00',2.39),('5819','2013-02-13','11:35:00',2.12),('5819','2013-02-13','11:40:00',1.34),('5819','2013-02-13','11:45:00',1.35),('5819','2013-02-13','11:50:00',1.72),('5819','2013-02-13','12:10:00',1.18),('5819','2013-02-13','12:15:00',2.52),('5819','2013-02-13','12:20:00',1.63),('5819','2013-02-13','12:25:00',2.05),('5819','2013-02-13','12:40:00',1.13),('5819','2013-02-13','12:45:00',1.1),('5819','2013-02-13','12:50:00',1.9),('5819','2013-02-13','12:55:00',2.09),('5819','2013-02-13','13:00:00',2.34),('5819','2013-02-13','13:05:00',2.5),('5819','2013-02-13','13:10:00',2.15),('5819','2013-02-13','13:15:00',1.76),('5819','2013-02-13','13:20:00',3),('5819','2013-02-13','13:25:00',3.09),('5819','2013-02-13','13:30:00',3.19),('5819','2013-02-13','13:35:00',3.07),('5819','2013-02-13','13:40:00',2.8),('5819','2013-02-13','13:45:00',2.57),('5819','2013-02-13','13:50:00',2.22),('5819','2013-02-13','13:55:00',2.3),('5819','2013-02-13','14:00:00',2.72),('5819','2013-02-13','14:05:00',2.76),('5819','2013-02-13','14:10:00',2.22),('5819','2013-02-13','14:15:00',2.36),('5819','2013-02-13','14:20:00',2.05),('5819','2013-02-13','14:25:00',2.19),('5819','2013-02-13','14:30:00',2.25),('5819','2013-02-13','14:35:00',2.31),('5819','2013-02-13','14:40:00',2.21),('5819','2013-02-13','14:45:00',2.07),('5819','2013-02-13','14:50:00',2.07),('5819','2013-02-13','14:55:00',2),('5819','2013-02-13','15:00:00',1.9),('5819','2013-02-13','15:05:00',1.82),('5819','2013-02-13','15:10:00',1.73),('5819','2013-02-13','15:15:00',1.65),('5819','2013-02-13','15:20:00',1.57),('5819','2013-02-13','15:25:00',1.52),('5819','2013-02-13','15:30:00',1.45),('5819','2013-02-13','15:35:00',1.37),('5819','2013-02-13','15:40:00',1.32),('5819','2013-02-13','15:45:00',1.24),('5819','2013-02-13','15:50:00',1.14),('5819','2013-02-13','15:55:00',1.08),('5819','2013-02-13','16:00:00',1.01),('5819','2013-02-11','10:35:00',1.17),('5819','2013-02-11','10:40:00',1.06),('5819','2013-02-11','11:05:00',1.16),('5819','2013-02-11','11:10:00',1.21),('5819','2013-02-11','11:15:00',1.28),('5819','2013-02-11','11:20:00',1.05),('5819','2013-02-11','12:45:00',1.09),('5819','2013-02-11','14:10:00',1.07),('5819','2013-02-11','14:25:00',1.31),('5819','2013-02-11','14:30:00',1.79),('5819','2013-02-11','14:40:00',1.33),('5819','2013-02-11','14:45:00',1.04),('5819','2013-02-10','09:45:00',1.34),('5819','2013-02-10','09:50:00',1.51),('5819','2013-02-10','09:55:00',1.07),('5819','2013-02-10','10:00:00',2.52),('5819','2013-02-10','10:05:00',2.94),('5819','2013-02-10','10:10:00',2.88),('5819','2013-02-10','10:15:00',2.97),('5819','2013-02-10','10:20:00',3),('5819','2013-02-10','10:25:00',3.05),('5819','2013-02-10','10:30:00',3.09),('5819','2013-02-10','10:35:00',3.11),('5819','2013-02-10','10:40:00',3.13),('5819','2013-02-10','10:45:00',3.17),('5819','2013-02-10','10:50:00',3.2),('5819','2013-02-10','10:55:00',3.22),('5819','2013-02-10','11:00:00',3.24),('5819','2013-02-10','11:05:00',3.25),('5819','2013-02-10','11:10:00',3.25),('5819','2013-02-10','11:15:00',3.26),('5819','2013-02-10','11:20:00',3.26),('5819','2013-02-10','11:25:00',3.26),('5819','2013-02-10','11:30:00',3.29),('5819','2013-02-10','11:35:00',3.29),('5819','2013-02-10','11:40:00',3.3),('5819','2013-02-10','11:45:00',3.31),('5819','2013-02-10','11:50:00',3.31),('5819','2013-02-10','11:55:00',3.33),('5819','2013-02-10','12:00:00',3.35),('5819','2013-02-10','12:05:00',3.34),('5819','2013-02-10','12:10:00',3.35),('5819','2013-02-10','12:15:00',3.35),('5819','2013-02-10','12:20:00',3.32),('5819','2013-02-10','12:25:00',3.3),('5819','2013-02-10','12:30:00',3.29),('5819','2013-02-10','12:35:00',3.26),('5819','2013-02-10','12:40:00',3.23),('5819','2013-02-10','12:45:00',3.22),('5819','2013-02-10','12:50:00',3.23),('5819','2013-02-10','12:55:00',3.18),('5819','2013-02-10','13:00:00',3.12),('5819','2013-02-10','13:05:00',3.06),('5819','2013-02-10','13:10:00',3.04),('5819','2013-02-10','13:15:00',3),('5819','2013-02-10','13:20:00',2.98),('5819','2013-02-10','13:25:00',2.95),('5819','2013-02-10','13:30:00',2.9),('5819','2013-02-10','13:35:00',2.82),('5819','2013-02-10','13:40:00',2.75),('5819','2013-02-10','13:45:00',2.71),('5819','2013-02-10','13:50:00',2.67),('5819','2013-02-10','13:55:00',2.61),('5819','2013-02-10','14:00:00',2.55),('5819','2013-02-10','14:05:00',2.51),('5819','2013-02-10','14:10:00',2.44),('5819','2013-02-10','14:15:00',2.4),('5819','2013-02-10','14:20:00',2.34),('5819','2013-02-10','14:25:00',2.23),('5819','2013-02-10','14:30:00',2.2),('5819','2013-02-10','14:35:00',2.17),('5819','2013-02-10','14:40:00',1.68),('5819','2013-02-10','14:45:00',2.06),('5819','2013-02-10','14:50:00',1.96),('5819','2013-02-10','14:55:00',1.88),('5819','2013-02-10','15:00:00',1.33),('5819','2013-02-10','15:05:00',1.02),('5819','2013-02-10','15:10:00',1.68),('5819','2013-02-10','15:25:00',1.48),('5819','2013-02-10','15:35:00',1.33),('5819','2013-02-09','11:10:00',1),('5819','2013-02-09','11:15:00',1.05),('5819','2013-02-09','11:20:00',1.08),('5819','2013-02-09','11:25:00',1.09),('5819','2013-02-09','11:30:00',1.11),('5819','2013-02-09','11:35:00',1.08),('5819','2013-02-09','11:40:00',1.05),('5819','2013-02-09','11:45:00',1.07),('5819','2013-02-09','11:50:00',1.07),('5819','2013-02-09','11:55:00',1.03),('5819','2013-02-09','12:00:00',1.04),('5819','2013-02-09','12:05:00',1.04),('5819','2013-02-09','12:10:00',1.03),('5819','2013-02-09','12:15:00',1.03),('5819','2013-02-09','12:20:00',1.04),('5819','2013-02-09','12:25:00',1.05),('5819','2013-02-09','12:30:00',1.06),('5819','2013-02-09','12:35:00',1.12),('5819','2013-02-09','12:40:00',1.15),('5819','2013-02-09','12:45:00',1.16),('5819','2013-02-09','12:50:00',1.18),('5819','2013-02-09','12:55:00',1.16),('5819','2013-02-09','13:00:00',1.02),('5819','2013-02-09','13:05:00',1.12),('5819','2013-02-09','13:10:00',1.54),('5819','2013-02-09','13:15:00',1.71),('5819','2013-02-09','13:20:00',1.87),('5819','2013-02-09','13:25:00',1.99),('5819','2013-02-09','13:30:00',2.34),('5819','2013-02-09','13:35:00',2.33),('5819','2013-02-09','13:40:00',2.44),('5819','2013-02-09','13:45:00',2.62),('5819','2013-02-09','13:50:00',2.81),('5819','2013-02-09','13:55:00',2.7),('5819','2013-02-09','14:00:00',2.76),('5819','2013-02-09','14:05:00',2.54),('5819','2013-02-09','14:10:00',1.91),('5819','2013-02-09','14:15:00',2.51),('5819','2013-02-09','14:20:00',2.79),('5819','2013-02-09','14:25:00',2.95),('5819','2013-02-09','14:30:00',2.67),('5819','2013-02-09','14:35:00',2.4),('5819','2013-02-09','14:40:00',2.15),('5819','2013-02-09','14:45:00',2.01),('5819','2013-02-09','14:50:00',1.94),('5819','2013-02-09','14:55:00',1.91),('5819','2013-02-09','15:00:00',1.79),('5819','2013-02-09','15:05:00',1.7),('5819','2013-02-09','15:10:00',1.63),('5819','2013-02-09','15:15:00',1.53),('5819','2013-02-09','15:20:00',1.45),('5819','2013-02-09','15:25:00',1.32),('5819','2013-02-09','15:30:00',1.27),('5819','2013-02-09','15:35:00',1.22),('5819','2013-02-09','15:50:00',1),('5819','2013-02-08','09:35:00',2.14),('5819','2013-02-08','09:40:00',2.77),('5819','2013-02-08','09:45:00',2.61),('5819','2013-02-08','09:50:00',3.09),('5819','2013-02-08','09:55:00',3.15),('5819','2013-02-08','10:00:00',3.27),('5819','2013-02-08','10:05:00',3.46),('5819','2013-02-08','10:10:00',3.54),('5819','2013-02-08','10:15:00',3.66),('5819','2013-02-08','10:20:00',3.56),('5819','2013-02-08','10:25:00',3.52),('5819','2013-02-08','10:30:00',3.61),('5819','2013-02-08','10:35:00',1.8),('5819','2013-02-08','10:40:00',2.45),('5819','2013-02-08','10:45:00',3.56),('5819','2013-02-08','10:50:00',3.59),('5819','2013-02-08','10:55:00',3.51),('5819','2013-02-08','11:00:00',3.41),('5819','2013-02-08','11:05:00',3.37),('5819','2013-02-08','11:10:00',3.36),('5819','2013-02-08','11:15:00',3.34),('5819','2013-02-08','11:20:00',3.34),('5819','2013-02-08','11:25:00',3.34),('5819','2013-02-08','11:30:00',3.32),('5819','2013-02-08','11:35:00',3.31),('5819','2013-02-08','11:40:00',3.33),('5819','2013-02-08','11:45:00',3.33),('5819','2013-02-08','11:50:00',3.32),('5819','2013-02-08','11:55:00',3.32),('5819','2013-02-08','12:00:00',3.3),('5819','2013-02-08','12:05:00',3.3),('5819','2013-02-08','12:10:00',3.3),('5819','2013-02-08','12:15:00',3.28),('5819','2013-02-08','12:20:00',3.27),('5819','2013-02-08','12:25:00',3.26),('5819','2013-02-08','12:30:00',3.26),('5819','2013-02-08','12:35:00',3.24),('5819','2013-02-08','12:40:00',3.31),('5819','2013-02-08','12:45:00',3.22),('5819','2013-02-08','12:50:00',2.61),('5819','2013-02-08','12:55:00',1.84),('5819','2013-02-08','13:00:00',1.74),('5819','2013-02-08','13:05:00',1.63),('5819','2013-02-08','13:10:00',1.78),('5819','2013-02-08','13:15:00',1.74),('5819','2013-02-08','13:20:00',1.79),('5819','2013-02-08','13:25:00',1.7),('5819','2013-02-08','13:30:00',1.62),('5819','2013-02-08','13:35:00',2.1),('5819','2013-02-08','13:40:00',1.85),('5819','2013-02-08','13:45:00',1.47),('5819','2013-02-08','13:50:00',1.48),('5819','2013-02-08','13:55:00',1.49),('5819','2013-02-08','14:00:00',1.41),('5819','2013-02-08','14:05:00',1.35),('5819','2013-02-08','14:10:00',1.24),('5819','2013-02-08','14:15:00',1.1),('5819','2013-02-08','14:20:00',1.08),('5819','2013-02-08','14:25:00',1.17),('5819','2013-02-08','14:30:00',1.57),('5819','2013-02-08','14:35:00',1.57),('5819','2013-02-08','14:40:00',2.66),('5819','2013-02-08','14:45:00',2.8),('5819','2013-02-08','14:50:00',1.76),('5819','2013-02-08','14:55:00',2.22),('5819','2013-02-08','15:00:00',2.16),('5819','2013-02-08','15:05:00',2.41),('5819','2013-02-08','15:10:00',2.37),('5819','2013-02-08','15:15:00',2.12),('5819','2013-02-08','15:20:00',1.58),('5819','2013-02-08','15:25:00',1.64),('5819','2013-02-08','15:30:00',1.47),('5819','2013-02-08','15:35:00',1.36),('5819','2013-02-08','15:40:00',1.27),('5819','2013-02-08','15:45:00',1.2),('5819','2013-02-08','15:50:00',1.12),('5819','2013-02-08','15:55:00',1.03),('5819','2013-02-07','10:40:00',1.15),('5819','2013-02-07','10:45:00',1.53),('5819','2013-02-07','10:55:00',1.16),('5819','2013-02-07','11:00:00',2.11),('5819','2013-02-07','11:05:00',1.33),('5819','2013-02-07','12:25:00',2.44),('5819','2013-02-07','12:30:00',2.1),('5819','2013-02-07','12:35:00',1.07),('5819','2013-02-07','13:15:00',1.04),('5819','2013-02-07','13:20:00',1.28),('5819','2013-02-07','13:25:00',1.13),('5819','2013-02-07','14:00:00',1.14),('5819','2013-02-07','14:05:00',1.6),('5819','2013-02-07','14:10:00',2.56),('5819','2013-02-07','14:15:00',2.46),('5819','2013-02-07','14:20:00',2.34),('5819','2013-02-07','14:25:00',1.27),('5819','2013-02-07','14:35:00',1.53),('5819','2013-02-07','14:40:00',1.37),('5819','2013-02-07','14:45:00',1.79),('5819','2013-02-07','14:50:00',1.22),('5819','2013-02-07','14:55:00',1.03),('5819','2013-02-07','15:00:00',1.4),('5819','2013-02-07','15:05:00',1.98),('5819','2013-02-07','15:10:00',2.11),('5819','2013-02-07','15:15:00',1.72),('5819','2013-02-07','15:25:00',1.03),('5819','2013-02-06','08:45:00',1.11),('5819','2013-02-06','08:50:00',1.55),('5819','2013-02-06','08:55:00',1.08),('5819','2013-02-06','09:00:00',1.17),('5819','2013-02-06','09:05:00',1.38),('5819','2013-02-06','09:10:00',1.73),('5819','2013-02-06','09:25:00',1.11),('5819','2013-02-06','09:30:00',1.59),('5819','2013-02-06','09:35:00',1.15),('5819','2013-02-06','09:40:00',1.74),('5819','2013-02-06','09:45:00',1.18),('5819','2013-02-06','09:50:00',1.26),('5819','2013-02-06','09:55:00',1.58),('5819','2013-02-06','10:00:00',1.29),('5819','2013-02-06','10:05:00',1.74),('5819','2013-02-06','10:10:00',1.5),('5819','2013-02-06','10:15:00',1.31),('5819','2013-02-06','10:20:00',1.17),('5819','2013-02-06','10:25:00',1.61),('5819','2013-02-06','10:30:00',1.4),('5819','2013-02-06','10:35:00',1.84),('5819','2013-02-06','10:40:00',1.34),('5819','2013-02-06','10:45:00',1.01),('5819','2013-02-06','10:50:00',1.57),('5819','2013-02-06','10:55:00',2.26),('5819','2013-02-06','11:00:00',1.82),('5819','2013-02-06','11:05:00',1.3),('5819','2013-02-06','11:10:00',1.52),('5819','2013-02-06','11:15:00',1.36),('5819','2013-02-06','11:20:00',1.83),('5819','2013-02-06','11:25:00',2.47),('5819','2013-02-06','11:30:00',1.62),('5819','2013-02-06','11:35:00',1.4),('5819','2013-02-06','11:40:00',1.52),('5819','2013-02-06','11:45:00',1.55),('5819','2013-02-06','11:50:00',1.59),('5819','2013-02-06','11:55:00',1.5),('5819','2013-02-06','12:00:00',1.3),('5819','2013-02-06','12:05:00',1.08),('5819','2013-02-06','12:20:00',1),('5819','2013-02-06','13:30:00',1.06),('5819','2013-02-06','13:35:00',1.19),('5819','2013-02-06','13:50:00',1.54),('5819','2013-02-06','13:55:00',1.18),('5819','2013-02-06','14:00:00',1.33),('5819','2013-02-06','14:05:00',1.24),('5819','2013-02-06','14:30:00',1.19),('5819','2013-02-06','14:35:00',2.12),('5819','2013-02-06','14:40:00',1.18),('5819','2013-02-05','08:15:00',1.09),('5819','2013-02-05','08:20:00',1.18),('5819','2013-02-05','08:25:00',1.27),('5819','2013-02-05','08:30:00',1.36),('5819','2013-02-05','08:35:00',1.46),('5819','2013-02-05','08:40:00',1.53),('5819','2013-02-05','08:45:00',1.58),('5819','2013-02-05','08:50:00',1.68),('5819','2013-02-05','08:55:00',1.74),('5819','2013-02-05','09:00:00',1.82),('5819','2013-02-05','09:05:00',1.88),('5819','2013-02-05','09:10:00',1.96),('5819','2013-02-05','09:15:00',2.03),('5819','2013-02-05','09:20:00',2.11),('5819','2013-02-05','09:25:00',2.18),('5819','2013-02-05','09:30:00',2.22),('5819','2013-02-05','09:35:00',2.29),('5819','2013-02-05','09:40:00',2.36),('5819','2013-02-05','09:45:00',2.41),('5819','2013-02-05','09:50:00',2.47),('5819','2013-02-05','09:55:00',2.52),('5819','2013-02-05','10:00:00',2.53),('5819','2013-02-05','10:05:00',2.58),('5819','2013-02-05','10:10:00',2.43),('5819','2013-02-05','10:15:00',2.44),('5819','2013-02-05','10:20:00',2.72),('5819','2013-02-05','10:25:00',2.78),('5819','2013-02-05','10:30:00',2.81),('5819','2013-02-05','10:35:00',2.84),('5819','2013-02-05','10:40:00',2.86),('5819','2013-02-05','10:45:00',2.87),('5819','2013-02-05','10:50:00',2.85),('5819','2013-02-05','10:55:00',2.86),('5819','2013-02-05','11:00:00',2.88),('5819','2013-02-05','11:05:00',2.88),('5819','2013-02-05','11:10:00',2.93),('5819','2013-02-05','11:15:00',2.96),('5819','2013-02-05','11:20:00',2.94),('5819','2013-02-05','11:25:00',2.96),('5819','2013-02-05','11:30:00',2.89),('5819','2013-02-05','11:35:00',2.78),('5819','2013-02-05','11:40:00',2.44),('5819','2013-02-05','11:45:00',2.12),('5819','2013-02-05','11:50:00',1.7),('5819','2013-02-05','11:55:00',1.44),('5819','2013-02-05','12:00:00',1.18),('5819','2013-02-05','12:10:00',2.16),('5819','2013-02-05','12:15:00',1.58),('5819','2013-02-05','12:20:00',1.14),('5819','2013-02-05','12:25:00',1.09),('5819','2013-02-05','12:35:00',1.08),('5819','2013-02-05','12:40:00',1.56),('5819','2013-02-05','12:45:00',1.69),('5819','2013-02-05','12:50:00',2.05),('5819','2013-02-05','13:15:00',1.15),('5819','2013-02-05','13:20:00',1.22),('5819','2013-02-05','13:25:00',1.15),('5819','2013-02-05','13:30:00',1.15),('5819','2013-02-05','13:45:00',1.15),('5819','2013-02-05','13:50:00',1.25),('5819','2013-02-05','13:55:00',1.09),('5819','2013-02-05','14:00:00',1.05),('5819','2013-02-05','14:05:00',1.14),('5819','2013-02-05','14:20:00',1.02),('5819','2013-02-05','14:25:00',1.53),('5819','2013-02-05','14:30:00',1.57),('5819','2013-02-05','14:35:00',1.43),('5819','2013-02-05','14:40:00',1.62),('5819','2013-02-04','08:10:00',1.02),('5819','2013-02-04','08:15:00',1.13),('5819','2013-02-04','08:20:00',1.23),('5819','2013-02-04','08:25:00',1.33),('5819','2013-02-04','08:30:00',1.43),('5819','2013-02-04','08:35:00',1.52),('5819','2013-02-04','08:40:00',1.61),('5819','2013-02-04','08:45:00',1.69),('5819','2013-02-04','08:50:00',1.77),('5819','2013-02-04','08:55:00',1.6),('5819','2013-02-04','09:00:00',1.96),('5819','2013-02-04','09:05:00',2.07),('5819','2013-02-04','09:10:00',2.18),('5819','2013-02-04','09:15:00',2.23),('5819','2013-02-04','09:20:00',2.19),('5819','2013-02-04','09:25:00',2.17),('5819','2013-02-04','09:30:00',2.33),('5819','2013-02-04','09:35:00',2.33),('5819','2013-02-04','09:40:00',2.38),('5819','2013-02-04','09:45:00',2.13),('5819','2013-02-04','09:50:00',2.52),('5819','2013-02-04','09:55:00',2.71),('5819','2013-02-04','10:00:00',2.76),('5819','2013-02-04','10:05:00',2.8),('5819','2013-02-04','10:10:00',2.89),('5819','2013-02-04','10:15:00',2.96),('5819','2013-02-04','10:20:00',2.8),('5819','2013-02-04','10:25:00',2.92),('5819','2013-02-04','10:30:00',2.79),('5819','2013-02-04','10:35:00',2.62),('5819','2013-02-04','10:40:00',2.78),('5819','2013-02-04','10:45:00',3.02),('5819','2013-02-04','10:50:00',3.08),('5819','2013-02-04','10:55:00',3.05),('5819','2013-02-04','11:00:00',3.06),('5819','2013-02-04','11:05:00',3.12),('5819','2013-02-04','11:10:00',3.13),('5819','2013-02-04','11:15:00',3.14),('5819','2013-02-04','11:20:00',3.15),('5819','2013-02-04','11:25:00',3.15),('5819','2013-02-04','11:30:00',3.15),('5819','2013-02-04','11:35:00',3.14),('5819','2013-02-04','11:40:00',3.16),('5819','2013-02-04','11:45:00',3.15),('5819','2013-02-04','11:50:00',3.16),('5819','2013-02-04','11:55:00',3.15),('5819','2013-02-04','12:00:00',3.15),('5819','2013-02-04','12:05:00',3.16),('5819','2013-02-04','12:10:00',3.15),('5819','2013-02-04','12:15:00',3.13),('5819','2013-02-04','12:20:00',3.11),('5819','2013-02-04','12:25:00',3.09),('5819','2013-02-04','12:30:00',3.08),('5819','2013-02-04','12:35:00',3.06),('5819','2013-02-04','12:40:00',3.05),('5819','2013-02-04','12:45:00',3.02),('5819','2013-02-04','12:50:00',2.97),('5819','2013-02-04','12:55:00',2.98),('5819','2013-02-04','13:00:00',2.97),('5819','2013-02-04','13:05:00',2.94),('5819','2013-02-04','13:10:00',2.91),('5819','2013-02-04','13:15:00',2.87),('5819','2013-02-04','13:20:00',2.83),('5819','2013-02-04','13:25:00',2.79),('5819','2013-02-04','13:30:00',2.76),('5819','2013-02-04','13:35:00',2.71),('5819','2013-02-04','13:40:00',2.65),('5819','2013-02-04','13:45:00',2.6),('5819','2013-02-04','13:50:00',2.58),('5819','2013-02-04','13:55:00',2.54),('5819','2013-02-04','14:00:00',2.48),('5819','2013-02-04','14:05:00',2.43),('5819','2013-02-04','14:10:00',2.37),('5819','2013-02-04','14:15:00',2.31),('5819','2013-02-04','14:20:00',2.25),('5819','2013-02-04','14:25:00',2.19),('5819','2013-02-04','14:30:00',2.12),('5819','2013-02-04','14:35:00',2.06),('5819','2013-02-04','14:40:00',2),('5819','2013-02-04','14:45:00',1.94),('5819','2013-02-04','14:50:00',1.85),('5819','2013-02-04','14:55:00',1.77),('5819','2013-02-04','15:00:00',1.71),('5819','2013-02-04','15:05:00',1.63),('5819','2013-02-04','15:10:00',1.56),('5819','2013-02-04','15:15:00',1.48),('5819','2013-02-04','15:20:00',1.41),('5819','2013-02-04','15:25:00',1.34),('5819','2013-02-04','15:30:00',1.27),('5819','2013-02-04','15:35:00',1.19),('5819','2013-02-04','15:40:00',1.12),('5819','2013-02-04','15:45:00',1.05),('5819','2013-02-03','09:25:00',1.2),('5819','2013-02-03','09:40:00',1.17),('5819','2013-02-03','09:45:00',1.54),('5819','2013-02-03','09:50:00',1.59),('5819','2013-02-03','09:55:00',1.24),('5819','2013-02-03','10:00:00',2.02),('5819','2013-02-03','10:05:00',1.14),('5819','2013-02-03','11:20:00',1.19),('5819','2013-02-03','12:00:00',1.15),('5819','2013-02-03','12:05:00',1.08),('5819','2013-02-03','12:10:00',1.02),('5819','2013-02-02','10:30:00',1.08),('5819','2013-02-02','10:35:00',1.23),('5819','2013-02-02','10:40:00',1.38),('5819','2013-02-02','10:45:00',1.56),('5819','2013-02-02','10:50:00',1.25),('5819','2013-02-02','10:55:00',1.7),('5819','2013-02-02','11:00:00',1.99),('5819','2013-02-02','11:05:00',1.78),('5819','2013-02-02','11:10:00',1.9),('5819','2013-02-02','11:15:00',1.85),('5819','2013-02-02','11:20:00',1.81),('5819','2013-02-02','11:25:00',1.93),('5819','2013-02-02','11:30:00',1.92),('5819','2013-02-02','11:35:00',1.65),('5819','2013-02-02','11:40:00',1.65),('5819','2013-02-02','11:45:00',1.1),('5819','2013-02-02','11:55:00',1.04),('5819','2013-02-02','12:55:00',2.03),('5819','2013-02-02','13:00:00',1.77),('5819','2013-02-02','13:05:00',1.81),('5819','2013-02-02','13:10:00',1.63),('5819','2013-02-02','13:15:00',1.93),('5819','2013-02-02','13:20:00',1.71),('5819','2013-02-02','13:25:00',1.54),('5819','2013-02-02','13:30:00',1.13),('5819','2013-02-02','13:35:00',1.86),('5819','2013-02-02','13:40:00',2.36),('5819','2013-02-02','13:45:00',1.79),('5819','2013-02-02','13:50:00',1.79),('5819','2013-02-02','13:55:00',1.16),('5819','2013-02-01','08:25:00',1.16),('5819','2013-02-01','08:30:00',1.11),('5819','2013-02-01','08:35:00',1.2),('5819','2013-02-01','08:40:00',1.26),('5819','2013-02-01','08:45:00',1.35),('5819','2013-02-01','09:00:00',1.59),('5819','2013-02-01','09:05:00',1.77),('5819','2013-02-01','09:10:00',1.98),('5819','2013-02-01','09:15:00',1.15),('5819','2013-02-01','09:25:00',1.74),('5819','2013-02-01','09:30:00',1.33),('5819','2013-02-01','09:35:00',1.18),('5819','2013-02-01','09:40:00',1.75),('5819','2013-02-01','09:45:00',1.34),('5819','2013-02-01','09:50:00',1.27),('5819','2013-02-01','09:55:00',1.05),('5819','2013-02-01','10:00:00',1.71),('5819','2013-02-01','10:10:00',1.29),('5819','2013-02-01','10:20:00',1.95),('5819','2013-02-01','10:25:00',1.59),('5819','2013-02-01','10:30:00',1.18),('5819','2013-02-01','10:35:00',1.37),('5819','2013-02-01','10:50:00',2.18),('5819','2013-02-01','10:55:00',3.26),('5819','2013-02-01','11:00:00',3.05),('5819','2013-02-01','11:05:00',2.82),('5819','2013-02-01','11:10:00',2.96),('5819','2013-02-01','11:15:00',1.92),('5819','2013-02-01','11:20:00',2.33),('5819','2013-02-01','11:25:00',1.67),('5819','2013-02-01','11:30:00',1.01),('5819','2013-02-01','11:35:00',1.48),('5819','2013-02-01','11:40:00',2.59),('5819','2013-02-01','11:45:00',1.54),('5819','2013-02-01','11:50:00',1.76),('5819','2013-02-01','11:55:00',1.06),('5819','2013-02-01','12:00:00',1.16),('5819','2013-02-01','12:05:00',1.27),('5819','2013-02-01','12:10:00',1.55),('5819','2013-02-01','12:15:00',1.77),('5819','2013-02-01','12:20:00',3.48),('5819','2013-02-01','12:25:00',3.14),('5819','2013-02-01','12:30:00',1.32),('5819','2013-02-01','12:35:00',1.09),('5819','2013-02-01','12:40:00',2.5),('5819','2013-02-01','12:45:00',2.48),('5819','2013-02-01','12:50:00',2.9),('5819','2013-02-01','12:55:00',3.3),('5819','2013-02-01','13:00:00',3.17),('5819','2013-02-01','13:05:00',1.92),('5819','2013-02-01','13:10:00',2.9),('5819','2013-02-01','13:15:00',2.71),('5819','2013-02-01','13:20:00',2.71),('5819','2013-02-01','13:25:00',1.89),('5819','2013-02-01','13:30:00',1.89),('5819','2013-02-01','13:35:00',2.06),('5819','2013-02-01','13:40:00',2.06),('5819','2013-02-01','13:45:00',2.1),('5819','2013-02-01','13:50:00',1.73),('5819','2013-02-01','13:55:00',1.22),('5819','2013-02-01','14:15:00',1.57),('5819','2013-02-01','14:20:00',2.16),('5819','2013-02-01','14:25:00',2.18),('5819','2013-02-01','14:30:00',2.09),('5819','2013-02-01','14:35:00',1.98),('5819','2013-02-01','14:40:00',1.78),('5819','2013-02-01','15:05:00',1.05),('5819','2013-02-01','15:10:00',1.66),('5819','2013-02-01','15:15:00',1.09),('5819','2013-02-01','15:20:00',1.39),('5819','2013-01-31','09:10:00',1.02),('5819','2013-01-31','09:20:00',1.38),('5819','2013-01-31','09:25:00',2),('5819','2013-01-31','09:30:00',2.25),('5819','2013-01-31','09:35:00',2.16),('5819','2013-01-31','09:40:00',2.21),('5819','2013-01-31','09:45:00',2.07),('5819','2013-01-31','09:50:00',2.2),('5819','2013-01-31','09:55:00',2.43),('5819','2013-01-31','10:00:00',2.42),('5819','2013-01-31','10:05:00',2.4),('5819','2013-01-31','10:10:00',2.44),('5819','2013-01-31','10:15:00',2.53),('5819','2013-01-31','10:20:00',2.6),('5819','2013-01-31','10:25:00',2.52),('5819','2013-01-31','10:30:00',2.39),('5819','2013-01-31','10:35:00',2.81),('5819','2013-01-31','10:40:00',2.88),('5819','2013-01-31','10:45:00',2.88),('5819','2013-01-31','10:50:00',2.49),('5819','2013-01-31','11:00:00',2.96),('5819','2013-01-31','11:05:00',3.22),('5819','2013-01-31','11:10:00',3.2),('5819','2013-01-31','11:15:00',3.14),('5819','2013-01-31','11:20:00',3.16),('5819','2013-01-31','11:25:00',2.98),('5819','2013-01-31','11:30:00',2.87),('5819','2013-01-31','11:35:00',2.95),('5819','2013-01-31','11:40:00',2.92),('5819','2013-01-31','11:45:00',2.89),('5819','2013-01-31','11:50:00',2.88),('5819','2013-01-31','11:55:00',2.85),('5819','2013-01-31','12:00:00',2.85),('5819','2013-01-31','12:05:00',2.88),('5819','2013-01-31','12:10:00',2.31),('5819','2013-01-31','12:15:00',2.81),('5819','2013-01-31','12:20:00',2.86),('5819','2013-01-31','12:25:00',2.84),('5819','2013-01-31','12:30:00',2.83),('5819','2013-01-31','12:35:00',2.81),('5819','2013-01-31','12:40:00',2.79),('5819','2013-01-31','12:45:00',2.77),('5819','2013-01-31','12:50:00',2.74),('5819','2013-01-31','12:55:00',2.69),('5819','2013-01-31','13:00:00',2.67),('5819','2013-01-31','13:05:00',2.67),('5819','2013-01-31','13:10:00',2.64),('5819','2013-01-31','13:15:00',2.57),('5819','2013-01-31','13:20:00',2.51),('5819','2013-01-31','13:25:00',2.48),('5819','2013-01-31','13:30:00',2.42),('5819','2013-01-31','13:35:00',2.38),('5819','2013-01-31','13:40:00',2.29),('5819','2013-01-31','13:45:00',2.21),('5819','2013-01-31','13:50:00',2.32),('5819','2013-01-31','13:55:00',2.3),('5819','2013-01-31','14:00:00',2.24),('5819','2013-01-31','14:05:00',2.12),('5819','2013-01-31','14:10:00',2.06),('5819','2013-01-31','14:15:00',1.98),('5819','2013-01-31','14:20:00',1.99),('5819','2013-01-31','14:25:00',1.92),('5819','2013-01-31','14:30:00',1.83),('5819','2013-01-31','14:35:00',1.8),('5819','2013-01-31','14:40:00',1.75),('5819','2013-01-31','14:45:00',1.67),('5819','2013-01-31','14:50:00',1.58),('5819','2013-01-31','14:55:00',1.54),('5819','2013-01-31','15:00:00',1.45),('5819','2013-01-31','15:05:00',1.4),('5819','2013-01-31','15:10:00',1.35),('5819','2013-01-31','15:15:00',1.33),('5819','2013-01-31','15:20:00',1.29),('5819','2013-01-31','15:25:00',1.19),('5819','2013-01-31','15:30:00',1.14),('5819','2013-01-31','15:35:00',1.12),('5819','2013-01-31','15:40:00',1.04),('5819','2013-01-30','10:10:00',1.52),('5819','2013-01-30','10:15:00',1.08),('5819','2013-01-30','10:20:00',1.56),('5819','2013-01-30','10:25:00',1.54),('5819','2013-01-30','10:30:00',1.47),('5819','2013-01-30','10:35:00',1.28),('5819','2013-01-30','10:40:00',1.4),('5819','2013-01-30','10:45:00',1.96),('5819','2013-01-30','10:50:00',2.61),('5819','2013-01-30','10:55:00',2.63),('5819','2013-01-30','11:00:00',2.77),('5819','2013-01-30','11:05:00',2.68),('5819','2013-01-30','11:10:00',2.71),('5819','2013-01-30','11:15:00',2.75),('5819','2013-01-30','11:20:00',2.76),('5819','2013-01-30','11:25:00',2.83),('5819','2013-01-30','11:30:00',2.84),('5819','2013-01-30','11:35:00',2.82),('5819','2013-01-30','11:40:00',2.38),('5819','2013-01-30','11:45:00',2.89),('5819','2013-01-30','11:50:00',2.9),('5819','2013-01-30','11:55:00',2.81),('5819','2013-01-30','12:00:00',2.9),('5819','2013-01-30','12:05:00',2.93),('5819','2013-01-30','12:10:00',1.87),('5819','2013-01-30','12:15:00',2.42),('5819','2013-01-30','12:20:00',1.82),('5819','2013-01-30','12:40:00',1.67),('5819','2013-01-30','12:50:00',1.31),('5819','2013-01-30','12:55:00',3.1),('5819','2013-01-30','13:00:00',3.07),('5819','2013-01-30','13:05:00',3.11),('5819','2013-01-30','13:10:00',2.88),('5819','2013-01-30','13:15:00',2.73),('5819','2013-01-30','13:20:00',2.74),('5819','2013-01-30','13:25:00',2.85),('5819','2013-01-30','13:30:00',2.51),('5819','2013-01-30','13:35:00',2.63),('5819','2013-01-30','13:40:00',1.45),('5819','2013-01-30','13:45:00',1.55),('5819','2013-01-30','13:50:00',2.14),('5819','2013-01-30','13:55:00',1.82),('5819','2013-01-30','14:00:00',1.98),('5819','2013-01-30','14:05:00',1.41),('5819','2013-01-30','14:10:00',2.15),('5819','2013-01-30','14:20:00',1.59),('5819','2013-01-30','14:25:00',1.89),('5819','2013-01-30','14:30:00',1.25),('5819','2013-01-30','14:35:00',1.24),('5819','2013-01-30','14:40:00',1.49),('5819','2013-01-30','14:45:00',1.54),('5819','2013-01-29','08:25:00',1.07),('5819','2013-01-29','08:30:00',1.18),('5819','2013-01-29','08:35:00',1.28),('5819','2013-01-29','08:40:00',1.34),('5819','2013-01-29','08:45:00',1.43),('5819','2013-01-29','08:50:00',1.52),('5819','2013-01-29','08:55:00',1.6),('5819','2013-01-29','09:00:00',1.69),('5819','2013-01-29','09:05:00',1.76),('5819','2013-01-29','09:10:00',1.83),('5819','2013-01-29','09:15:00',1.9),('5819','2013-01-29','09:20:00',1.97),('5819','2013-01-29','09:25:00',2.03),('5819','2013-01-29','09:30:00',2.09),('5819','2013-01-29','09:35:00',2.15),('5819','2013-01-29','09:40:00',2.22),('5819','2013-01-29','09:45:00',2.29),('5819','2013-01-29','09:50:00',2.34),('5819','2013-01-29','09:55:00',2.39),('5819','2013-01-29','10:00:00',2.44),('5819','2013-01-29','10:05:00',2.51),('5819','2013-01-29','10:10:00',2.57),('5819','2013-01-29','10:15:00',2.62),('5819','2013-01-29','10:20:00',2.66),('5819','2013-01-29','10:25:00',2.72),('5819','2013-01-29','10:30:00',2.76),('5819','2013-01-29','10:35:00',2.78),('5819','2013-01-29','10:40:00',2.82),('5819','2013-01-29','10:45:00',2.83),('5819','2013-01-29','10:50:00',2.86),('5819','2013-01-29','10:55:00',2.86),('5819','2013-01-29','11:00:00',2.85),('5819','2013-01-29','11:05:00',2.86),('5819','2013-01-29','11:10:00',2.87),('5819','2013-01-29','11:15:00',2.91),('5819','2013-01-29','11:20:00',2.93),('5819','2013-01-29','11:25:00',2.9),('5819','2013-01-29','11:30:00',2.87),('5819','2013-01-29','11:35:00',2.96),('5819','2013-01-29','11:40:00',3),('5819','2013-01-29','11:45:00',3),('5819','2013-01-29','11:50:00',2.99),('5819','2013-01-29','11:55:00',2.96),('5819','2013-01-29','12:00:00',2.91),('5819','2013-01-29','12:05:00',2.91),('5819','2013-01-29','12:10:00',2.95),('5819','2013-01-29','12:15:00',2.91),('5819','2013-01-29','12:20:00',2.9),('5819','2013-01-29','12:25:00',2.91),('5819','2013-01-29','12:30:00',2.87),('5819','2013-01-29','12:35:00',2.82),('5819','2013-01-29','12:40:00',2.81),('5819','2013-01-29','12:45:00',2.77),('5819','2013-01-29','12:50:00',2.74),('5819','2013-01-29','12:55:00',2.77),('5819','2013-01-29','13:00:00',2.74),('5819','2013-01-29','13:05:00',2.69),('5819','2013-01-29','13:10:00',2.67),('5819','2013-01-29','13:15:00',2.61),('5819','2013-01-29','13:20:00',2.59),('5819','2013-01-29','13:25:00',2.57),('5819','2013-01-29','13:30:00',2.53),('5819','2013-01-29','13:35:00',2.48),('5819','2013-01-29','13:40:00',2.43),('5819','2013-01-29','13:45:00',2.39),('5819','2013-01-29','13:50:00',2.32),('5819','2013-01-29','13:55:00',2.26),('5819','2013-01-29','14:00:00',2.22),('5819','2013-01-29','14:05:00',2.13),('5819','2013-01-29','14:10:00',2.07),('5819','2013-01-29','14:15:00',2.07),('5819','2013-01-29','14:20:00',2.06),('5819','2013-01-29','14:25:00',1.98),('5819','2013-01-29','14:30:00',1.92),('5819','2013-01-29','14:35:00',1.84),('5819','2013-01-29','14:40:00',1.79),('5819','2013-01-29','14:45:00',1.74),('5819','2013-01-29','14:50:00',1.67),('5819','2013-01-29','14:55:00',1.59),('5819','2013-01-29','15:00:00',1.51),('5819','2013-01-29','15:05:00',1.45),('5819','2013-01-29','15:10:00',1.36),('5819','2013-01-29','15:15:00',1.3),('5819','2013-01-29','15:20:00',1.23),('5819','2013-01-29','15:25:00',1.16),('5819','2013-01-29','15:30:00',1.08),('5819','2013-01-29','15:35:00',1.02),('5819','2013-01-28','12:50:00',1.13),('5819','2013-01-28','12:55:00',1.1),('5819','2013-01-28','13:00:00',1.03),('5819','2013-01-28','13:05:00',1),('5819','2013-01-27','08:25:00',1.01),('5819','2013-01-27','08:30:00',1.19),('5819','2013-01-27','08:35:00',1.33),('5819','2013-01-27','08:40:00',1.44),('5819','2013-01-27','08:45:00',1.41),('5819','2013-01-27','08:50:00',1.45),('5819','2013-01-27','08:55:00',1.51),('5819','2013-01-27','09:00:00',1.61),('5819','2013-01-27','09:05:00',1.69),('5819','2013-01-27','09:10:00',1.75),('5819','2013-01-27','09:15:00',1.82),('5819','2013-01-27','09:20:00',1.9),('5819','2013-01-27','09:25:00',1.98),('5819','2013-01-27','09:30:00',2.03),('5819','2013-01-27','09:35:00',2.1),('5819','2013-01-27','09:40:00',2.17),('5819','2013-01-27','09:45:00',2.23),('5819','2013-01-27','09:50:00',2.29),('5819','2013-01-27','09:55:00',2.35),('5819','2013-01-27','10:00:00',2.38),('5819','2013-01-27','10:05:00',2.44),('5819','2013-01-27','10:10:00',2.47),('5819','2013-01-27','10:15:00',2.53),('5819','2013-01-27','10:20:00',2.56),('5819','2013-01-27','10:25:00',2.6),('5819','2013-01-27','10:30:00',2.64),('5819','2013-01-27','10:35:00',2.67),('5819','2013-01-27','10:40:00',2.69),('5819','2013-01-27','10:45:00',2.72),('5819','2013-01-27','10:50:00',2.75),('5819','2013-01-27','10:55:00',2.78),('5819','2013-01-27','11:00:00',2.79),('5819','2013-01-27','11:05:00',2.81),('5819','2013-01-27','11:10:00',2.83),('5819','2013-01-27','11:15:00',2.85),('5819','2013-01-27','11:20:00',2.87),('5819','2013-01-27','11:25:00',2.88),('5819','2013-01-27','11:30:00',2.87),('5819','2013-01-27','11:35:00',2.88),('5819','2013-01-27','11:40:00',2.88),('5819','2013-01-27','11:45:00',2.89),('5819','2013-01-27','11:50:00',2.88),('5819','2013-01-27','11:55:00',2.9),('5819','2013-01-27','12:00:00',2.9),('5819','2013-01-27','12:05:00',2.89),('5819','2013-01-27','12:10:00',2.88),('5819','2013-01-27','12:15:00',2.87),('5819','2013-01-27','12:20:00',2.87),('5819','2013-01-27','12:25:00',2.85),('5819','2013-01-27','12:30:00',2.83),('5819','2013-01-27','12:35:00',2.81),('5819','2013-01-27','12:40:00',2.77),('5819','2013-01-27','12:45:00',2.72),('5819','2013-01-27','12:50:00',2.74),('5819','2013-01-27','12:55:00',2.76),('5819','2013-01-27','13:00:00',2.73),('5819','2013-01-27','13:05:00',2.69),('5819','2013-01-27','13:10:00',2.64),('5819','2013-01-27','13:15:00',2.58),('5819','2013-01-27','13:20:00',2.51),('5819','2013-01-27','13:25:00',2.49),('5819','2013-01-27','13:30:00',2.46),('5819','2013-01-27','13:35:00',2.41),('5819','2013-01-27','13:40:00',2.33),('5819','2013-01-27','13:45:00',2.27),('5819','2013-01-27','13:50:00',2.24),('5819','2013-01-27','13:55:00',2.2),('5819','2013-01-27','14:00:00',2.17),('5819','2013-01-27','14:05:00',2.12),('5819','2013-01-27','14:10:00',2.05),('5819','2013-01-27','14:15:00',1.99),('5819','2013-01-27','14:20:00',1.92),('5819','2013-01-27','14:25:00',1.84),('5819','2013-01-27','14:30:00',1.79),('5819','2013-01-27','14:35:00',1.74),('5819','2013-01-27','14:40:00',1.66),('5819','2013-01-27','14:45:00',1.6),('5819','2013-01-27','14:50:00',1.57),('5819','2013-01-27','14:55:00',1.52),('5819','2013-01-27','15:00:00',1.42),('5819','2013-01-27','15:05:00',1.36),('5819','2013-01-27','15:10:00',1.27),('5819','2013-01-27','15:15:00',1.2),('5819','2013-01-27','15:20:00',1.14),('5819','2013-01-27','15:25:00',1.08),('5819','2013-01-27','15:30:00',1.03),('5819','2013-01-26','09:00:00',1.29),('5819','2013-01-26','09:05:00',1.37),('5819','2013-01-26','09:10:00',1.15),('5819','2013-01-26','09:15:00',1.14),('5819','2013-01-26','09:20:00',1.38),('5819','2013-01-26','09:50:00',1.07),('5819','2013-01-26','09:55:00',1.16),('5819','2013-01-26','10:20:00',1.17),('5819','2013-01-26','10:25:00',1.38),('5819','2013-01-26','10:50:00',1.04),('5819','2013-01-25','08:25:00',1.09),('5819','2013-01-25','08:30:00',1.14),('5819','2013-01-25','08:35:00',1.35),('5819','2013-01-25','08:40:00',1.45),('5819','2013-01-25','08:45:00',1.54),('5819','2013-01-25','08:50:00',1.53),('5819','2013-01-25','08:55:00',1.56),('5819','2013-01-25','09:00:00',1.82),('5819','2013-01-25','09:05:00',1.54),('5819','2013-01-25','09:10:00',1.55),('5819','2013-01-25','09:15:00',1.92),('5819','2013-01-25','09:20:00',2.04),('5819','2013-01-25','09:25:00',2.16),('5819','2013-01-25','09:30:00',2.26),('5819','2013-01-25','09:35:00',2.2),('5819','2013-01-25','09:40:00',2.05),('5819','2013-01-25','09:45:00',2.13),('5819','2013-01-25','09:50:00',2.53),('5819','2013-01-25','09:55:00',2.65),('5819','2013-01-25','10:00:00',2.68),('5819','2013-01-25','10:05:00',2.72),('5819','2013-01-25','10:10:00',2.68),('5819','2013-01-25','10:15:00',2.68),('5819','2013-01-25','10:20:00',2.73),('5819','2013-01-25','10:25:00',2.78),('5819','2013-01-25','10:30:00',2.73),('5819','2013-01-25','10:35:00',2.22),('5819','2013-01-25','10:40:00',2.99),('5819','2013-01-25','10:45:00',2.71),('5819','2013-01-25','10:50:00',2.17),('5819','2013-01-25','10:55:00',3.07),('5819','2013-01-25','11:00:00',1.81),('5819','2013-01-25','11:05:00',2.7),('5819','2013-01-25','11:10:00',2.93),('5819','2013-01-25','11:15:00',3.02),('5819','2013-01-25','11:20:00',2.96),('5819','2013-01-25','11:25:00',2.95),('5819','2013-01-25','11:30:00',2.97),('5819','2013-01-25','11:35:00',3.01),('5819','2013-01-25','11:40:00',3),('5819','2013-01-25','11:45:00',3),('5819','2013-01-25','11:50:00',3.05),('5819','2013-01-25','11:55:00',3.02),('5819','2013-01-25','12:00:00',2.98),('5819','2013-01-25','12:05:00',2.97),('5819','2013-01-25','12:10:00',3),('5819','2013-01-25','12:15:00',3),('5819','2013-01-25','12:20:00',3.01),('5819','2013-01-25','12:25:00',3.01),('5819','2013-01-25','12:30:00',3.01),('5819','2013-01-25','12:35:00',2.58),('5819','2013-01-25','12:40:00',2.6),('5819','2013-01-25','12:45:00',2.75),('5819','2013-01-25','12:50:00',2.83),('5819','2013-01-25','12:55:00',2.76),('5819','2013-01-25','13:00:00',2.77),('5819','2013-01-25','13:05:00',2.71),('5819','2013-01-25','13:10:00',2.67),('5819','2013-01-25','13:15:00',2.66),('5819','2013-01-25','13:20:00',2.64),('5819','2013-01-25','13:25:00',2.65),('5819','2013-01-25','13:30:00',2.69),('5819','2013-01-25','13:35:00',2.65),('5819','2013-01-25','13:40:00',2.58),('5819','2013-01-25','13:45:00',2.5),('5819','2013-01-25','13:50:00',2.42),('5819','2013-01-25','13:55:00',2.35),('5819','2013-01-25','14:00:00',2.26),('5819','2013-01-25','14:05:00',2.17),('5819','2013-01-25','14:10:00',2),('5819','2013-01-25','14:15:00',1.9),('5819','2013-01-25','14:20:00',1.74),('5819','2013-01-25','14:25:00',1.76),('5819','2013-01-25','14:30:00',1.66),('5819','2013-01-25','14:35:00',1.56),('5819','2013-01-25','14:40:00',1.5),('5819','2013-01-25','14:45:00',1.44),('5819','2013-01-25','14:50:00',1.42),('5819','2013-01-25','14:55:00',1.39),('5819','2013-01-25','15:00:00',1.27),('5819','2013-01-25','15:05:00',1.19),('5819','2013-01-25','15:10:00',1.17),('5819','2013-01-25','15:15:00',1.11),('5819','2013-01-25','15:20:00',1.08),('5819','2013-01-25','15:25:00',1.08),('5819','2013-01-25','15:30:00',1.06),('5819','2013-01-25','15:35:00',1.07),('5819','2013-01-25','15:40:00',1.03),('5819','2013-01-24','09:30:00',1.01),('5819','2013-01-24','09:45:00',1.4),('5819','2013-01-24','09:50:00',1.38),('5819','2013-01-24','09:55:00',2.37),('5819','2013-01-24','10:00:00',2.44),('5819','2013-01-24','10:05:00',2.51),('5819','2013-01-24','10:10:00',2.74),('5819','2013-01-24','10:15:00',2.69),('5819','2013-01-24','10:20:00',2.77),('5819','2013-01-24','10:25:00',2.77),('5819','2013-01-24','10:30:00',2.79),('5819','2013-01-24','10:35:00',2.81),('5819','2013-01-24','10:40:00',2.84),('5819','2013-01-24','10:45:00',2.9),('5819','2013-01-24','10:50:00',2.98),('5819','2013-01-24','10:55:00',2.84),('5819','2013-01-24','11:00:00',1.61),('5819','2013-01-24','14:00:00',1.05),('5819','2013-01-24','14:05:00',1.09),('5819','2013-01-24','14:10:00',1.03),('5819','2013-01-24','14:15:00',1.18),('5819','2013-01-24','14:20:00',1.55),('5819','2013-01-24','14:25:00',2.73),('5819','2013-01-24','14:30:00',2.48),('5819','2013-01-24','14:35:00',1.89),('5819','2013-01-24','14:40:00',1.17),('5819','2013-01-24','14:45:00',1.63),('5819','2013-01-24','14:50:00',1.69),('5819','2013-01-24','14:55:00',1.72),('5819','2013-01-24','15:00:00',1.3),('5819','2013-01-24','15:20:00',1.05),('5819','2013-01-24','15:25:00',1.06),('5819','2013-01-24','15:30:00',1.07),('5819','2013-01-23','09:55:00',1.65),('5819','2013-01-23','10:00:00',1.1),('5819','2013-01-23','10:25:00',1.02),('5819','2013-01-23','10:30:00',2.03),('5819','2013-01-23','10:35:00',2.87),('5819','2013-01-23','10:40:00',1.28),('5819','2013-01-23','10:45:00',1.77),('5819','2013-01-23','10:50:00',2.26),('5819','2013-01-23','10:55:00',2.02),('5819','2013-01-22','08:45:00',1.26),('5819','2013-01-22','08:50:00',1.39),('5819','2013-01-22','09:00:00',1.27),('5819','2013-01-22','09:05:00',1.45),('5819','2013-01-22','09:30:00',2.02),('5819','2013-01-22','09:35:00',2.27),('5819','2013-01-22','09:40:00',1.74),('5819','2013-01-22','09:45:00',2.76),('5819','2013-01-22','09:50:00',1.84),('5819','2013-01-22','09:55:00',2.05),('5819','2013-01-22','10:00:00',1.45),('5819','2013-01-22','10:05:00',2.48),('5819','2013-01-22','10:10:00',2.66),('5819','2013-01-22','10:15:00',2.42),('5819','2013-01-22','10:20:00',2.27),('5819','2013-01-22','10:25:00',2.54),('5819','2013-01-22','10:30:00',2.83),('5819','2013-01-22','10:35:00',2.92),('5819','2013-01-22','10:40:00',3.31),('5819','2013-01-22','10:45:00',2.74),('5819','2013-01-22','10:50:00',2.3),('5819','2013-01-22','10:55:00',1.29),('5819','2013-01-22','11:10:00',1.07),('5819','2013-01-22','11:15:00',1.87),('5819','2013-01-22','11:20:00',1.78),('5819','2013-01-22','11:25:00',1.26),('5819','2013-01-22','11:45:00',1.26),('5819','2013-01-22','11:50:00',2.49),('5819','2013-01-22','12:00:00',1.02),('5819','2013-01-22','12:10:00',2.18),('5819','2013-01-22','12:15:00',2.46),('5819','2013-01-22','12:20:00',1.55),('5819','2013-01-22','12:25:00',2.49),('5819','2013-01-22','12:30:00',1.08),('5819','2013-01-22','12:40:00',3.12),('5819','2013-01-22','12:45:00',1.18),('5819','2013-01-22','12:55:00',1.19),('5819','2013-01-22','13:00:00',2.28),('5819','2013-01-22','13:05:00',2.71),('5819','2013-01-22','13:10:00',1.96),('5819','2013-01-22','13:15:00',1.17),('5819','2013-01-22','13:20:00',2.39),('5819','2013-01-22','13:50:00',1.38),('5819','2013-01-22','14:10:00',1.07),('5819','2013-01-22','14:15:00',1.51),('5819','2013-01-22','14:25:00',1.82),('5819','2013-01-22','14:35:00',1.13),('5819','2013-01-22','14:40:00',1.02),('5819','2013-01-22','14:45:00',1.45),('5819','2013-01-22','14:50:00',1.04),('5819','2013-01-21','11:15:00',1.04),('5819','2013-01-21','11:55:00',3.31),('5819','2013-01-21','12:00:00',2.88),('5819','2013-01-21','12:05:00',2.79),('5819','2013-01-21','12:10:00',2.92),('5819','2013-01-21','12:15:00',2.61),('5819','2013-01-21','12:25:00',1.19),('5819','2013-01-21','12:40:00',1.3),('5819','2013-01-21','13:05:00',1.81),('5819','2013-01-21','13:10:00',1.54),('5819','2013-01-21','13:30:00',2.21),('5819','2013-01-21','13:35:00',2.88),('5819','2013-01-21','13:40:00',2.19),('5819','2013-01-21','13:45:00',1.02),('5819','2013-01-21','13:50:00',1.26),('5819','2013-01-21','13:55:00',1.85),('5819','2013-01-21','14:00:00',2.46),('5819','2013-01-21','14:05:00',2.52),('5819','2013-01-21','14:10:00',2.07),('5819','2013-01-21','14:15:00',1.85),('5819','2013-01-21','14:20:00',1.91),('5819','2013-01-21','14:25:00',2.31),('5819','2013-01-21','14:30:00',1.08),('5819','2013-01-20','10:55:00',1.01),('5819','2013-01-20','11:00:00',1.12),('5819','2013-01-20','11:05:00',1.09),('5819','2013-01-20','11:10:00',1.09),('5819','2013-01-20','11:15:00',1.61),('5819','2013-01-20','11:20:00',1.24),('5819','2013-01-20','11:25:00',1.65),('5819','2013-01-20','11:30:00',2.33),('5819','2013-01-20','11:35:00',1.77),('5819','2013-01-19','09:15:00',1.43),('5819','2013-01-19','09:20:00',1.49),('5819','2013-01-19','09:25:00',1.08),('5819','2013-01-19','09:50:00',1.03),('5819','2013-01-19','09:55:00',1.5),('5819','2013-01-19','10:00:00',1.33),('5819','2013-01-19','10:05:00',1.01),('5819','2013-01-19','10:45:00',1.15),('5819','2013-01-19','10:50:00',1.35),('5819','2013-01-19','11:20:00',1.02),('5819','2013-01-19','11:25:00',1.07),('5819','2013-01-18','10:15:00',2.36),('5819','2013-01-18','10:20:00',2.49),('5819','2013-01-18','10:25:00',1.51),('5819','2013-01-18','10:30:00',1.27),('5819','2013-01-18','11:35:00',1.08),('5819','2013-01-18','11:40:00',1.08),('5819','2013-01-18','12:35:00',1.12),('5819','2013-01-18','12:40:00',1.31),('5819','2013-01-18','12:45:00',1.4),('5819','2013-01-18','12:50:00',2.05),('5819','2013-01-18','12:55:00',1.93),('5819','2013-01-18','13:00:00',2.08),('5819','2013-01-18','13:05:00',1.89),('5819','2013-01-18','13:10:00',1.81),('5819','2013-01-18','13:15:00',2.09),('5819','2013-01-18','13:20:00',1.72),('5819','2013-01-18','13:25:00',1.44),('5819','2013-01-18','13:30:00',1.42),('5819','2013-01-18','13:35:00',1.56),('5819','2013-01-18','13:40:00',2.19),('5819','2013-01-18','13:45:00',2.34),('5819','2013-01-18','13:50:00',2.75),('5819','2013-01-18','13:55:00',2.63),('5819','2013-01-18','14:00:00',1.94),('5819','2013-01-18','14:05:00',2.14),('5819','2013-01-18','14:10:00',1.99),('5819','2013-01-18','14:15:00',1.43),('5819','2013-01-18','14:20:00',1.59),('5819','2013-01-18','14:25:00',1.34),('5819','2013-01-17','09:45:00',1.04),('5819','2013-01-17','09:50:00',1.38),('5819','2013-01-17','09:55:00',1.23),('5819','2013-01-17','10:10:00',1.06),('5819','2013-01-17','10:15:00',1.28),('5819','2013-01-17','10:20:00',1.24),('5819','2013-01-17','10:25:00',1.59),('5819','2013-01-17','10:30:00',1.74),('5819','2013-01-17','10:35:00',1.57),('5819','2013-01-17','10:40:00',1.47),('5819','2013-01-17','10:45:00',1.59),('5819','2013-01-17','10:50:00',1.48),('5819','2013-01-17','10:55:00',1.77),('5819','2013-01-17','11:00:00',1.56),('5819','2013-01-17','11:05:00',1.56),('5819','2013-01-17','11:10:00',1.87),('5819','2013-01-17','11:15:00',1.82),('5819','2013-01-17','11:20:00',1.71),('5819','2013-01-17','11:25:00',1.49),('5819','2013-01-17','11:30:00',1.28),('5819','2013-01-17','11:35:00',1.42),('5819','2013-01-17','11:40:00',1.51),('5819','2013-01-17','11:45:00',1.39),('5819','2013-01-17','11:50:00',1.45),('5819','2013-01-17','11:55:00',1.56),('5819','2013-01-17','12:00:00',1.76),('5819','2013-01-17','12:05:00',1.72),('5819','2013-01-17','12:10:00',1.6),('5819','2013-01-17','12:15:00',1.92),('5819','2013-01-17','12:20:00',1.67),('5819','2013-01-17','12:25:00',1.57),('5819','2013-01-17','12:30:00',1.26),('5819','2013-01-17','12:35:00',1.57),('5819','2013-01-17','12:40:00',1.68),('5819','2013-01-17','12:45:00',1.34),('5819','2013-01-17','13:00:00',1.53),('5819','2013-01-17','13:05:00',1.45),('5819','2013-01-17','13:15:00',1.34),('5819','2013-01-17','13:20:00',1.42),('5819','2013-01-17','13:25:00',1.26),('5819','2013-01-17','13:30:00',1.16),('5819','2013-01-17','13:35:00',1.51),('5819','2013-01-17','13:40:00',1.89),('5819','2013-01-17','13:45:00',2.09),('5819','2013-01-17','13:50:00',1.86),('5819','2013-01-17','14:00:00',1.2),('5819','2013-01-17','14:30:00',1.09),('5819','2013-01-17','14:35:00',1.46),('5819','2013-01-16','09:15:00',1.36),('5819','2013-01-16','09:20:00',1.08),('5819','2013-01-16','09:25:00',1.82),('5819','2013-01-16','09:30:00',1.97),('5819','2013-01-16','09:35:00',2.07),('5819','2013-01-16','09:40:00',2.2),('5819','2013-01-16','09:45:00',1.3),('5819','2013-01-16','10:35:00',1.86),('5819','2013-01-16','10:40:00',2.19),('5819','2013-01-16','10:45:00',2.48),('5819','2013-01-16','10:55:00',2.16),('5819','2013-01-16','11:25:00',1.48),('5819','2013-01-16','12:00:00',1.12),('5819','2013-01-16','12:05:00',1.2),('5819','2013-01-16','12:10:00',1.42),('5819','2013-01-16','12:15:00',3.21),('5819','2013-01-16','12:20:00',3.1),('5819','2013-01-16','12:25:00',1.4),('5819','2013-01-16','13:05:00',1.55),('5819','2013-01-16','13:10:00',3.21),('5819','2013-01-16','13:15:00',3.51),('5819','2013-01-16','13:20:00',2.8),('5819','2013-01-16','13:25:00',1.76),('5819','2013-01-16','13:55:00',1.95),('5819','2013-01-16','14:00:00',1.72),('5819','2013-01-16','14:05:00',1.14),('5819','2013-01-15','10:00:00',1.14),('5819','2013-01-15','10:45:00',1.05),('5819','2013-01-15','10:50:00',1.32),('5819','2013-01-15','10:55:00',1.43),('5819','2013-01-15','11:00:00',1.38),('5819','2013-01-15','11:05:00',1.43),('5819','2013-01-15','11:10:00',1.48),('5819','2013-01-15','11:15:00',1.4),('5819','2013-01-15','11:20:00',1.48),('5819','2013-01-15','11:25:00',1.46),('5819','2013-01-15','11:30:00',1.39),('5819','2013-01-15','11:35:00',1.31),('5819','2013-01-15','11:40:00',1.17),('5819','2013-01-15','11:45:00',1.01),('5819','2013-01-15','11:55:00',1.01),('5819','2013-01-15','12:20:00',1.17),('5819','2013-01-15','12:25:00',1.15),('5819','2013-01-15','12:30:00',1.07),('5819','2013-01-15','12:35:00',1.08),('5819','2013-01-15','12:40:00',1.22),('5819','2013-01-15','12:45:00',1.3),('5819','2013-01-15','12:50:00',1.24),('5819','2013-01-15','12:55:00',1.04),('5819','2013-01-15','13:35:00',1),('5819','2013-01-15','13:40:00',1.15),('5819','2013-01-15','13:45:00',1.1),('5819','2013-01-15','13:50:00',1.04),('5819','2013-01-15','13:55:00',1.17),('5819','2013-01-15','14:00:00',1.29),('5819','2013-01-15','14:05:00',1.96),('5819','2013-01-15','14:10:00',2.3),('5819','2013-01-15','14:15:00',2.37),('5819','2013-01-15','14:20:00',2.41),('5819','2013-01-15','14:25:00',1.98),('5819','2013-01-15','14:35:00',1.53),('5819','2013-01-15','14:40:00',1.14),('5819','2013-01-15','14:45:00',1.49),('5819','2013-01-15','14:50:00',1.44),('5819','2013-01-15','14:55:00',1.51),('5819','2013-01-15','15:00:00',1.52),('5819','2013-01-15','15:05:00',1.4),('5819','2013-01-15','15:10:00',1.22),('5819','2013-01-15','15:15:00',1.08),('5819','2013-01-15','15:20:00',1),('5819','2013-01-14','12:50:00',1.06),('5819','2013-01-14','13:00:00',1.05),('5819','2013-01-14','13:05:00',1.06),('5819','2013-01-14','15:15:00',1.12),('5819','2013-01-13','09:15:00',1.74),('5819','2013-01-13','09:20:00',1.87),('5819','2013-01-13','09:25:00',1.83),('5819','2013-01-13','09:30:00',1.91),('5819','2013-01-13','09:35:00',1.99),('5819','2013-01-13','09:40:00',1.4),('5819','2013-01-13','09:50:00',1.54),('5819','2013-01-13','09:55:00',1.92),('5819','2013-01-13','10:00:00',1.98),('5819','2013-01-13','10:05:00',2.09),('5819','2013-01-13','10:10:00',1.48),('5819','2013-01-13','10:20:00',1.48),('5819','2013-01-13','10:25:00',1.58),('5819','2013-01-13','10:30:00',1.84),('5819','2013-01-12','08:35:00',1.07),('5819','2013-01-12','08:40:00',1.17),('5819','2013-01-12','08:45:00',1.23),('5819','2013-01-12','08:50:00',1.31),('5819','2013-01-12','08:55:00',1.38),('5819','2013-01-12','09:00:00',1.45),('5819','2013-01-12','09:05:00',1.52),('5819','2013-01-12','09:10:00',1.57),('5819','2013-01-12','09:15:00',1.61),('5819','2013-01-12','09:20:00',1.68),('5819','2013-01-12','09:25:00',1.75),('5819','2013-01-12','09:30:00',1.8),('5819','2013-01-12','09:35:00',1.85),('5819','2013-01-12','09:40:00',1.92),('5819','2013-01-12','09:45:00',1.97),('5819','2013-01-12','09:50:00',2.05),('5819','2013-01-12','09:55:00',2.08),('5819','2013-01-12','10:00:00',2.14),('5819','2013-01-12','10:05:00',2.21),('5819','2013-01-12','10:10:00',2.21),('5819','2013-01-12','10:15:00',2.22),('5819','2013-01-12','10:20:00',2.26),('5819','2013-01-12','10:25:00',2.32),('5819','2013-01-12','10:30:00',2.36),('5819','2013-01-12','10:35:00',2.38),('5819','2013-01-12','10:40:00',2.43),('5819','2013-01-12','10:45:00',2.44),('5819','2013-01-12','10:50:00',2.46),('5819','2013-01-12','10:55:00',2.45),('5819','2013-01-12','11:00:00',2.45),('5819','2013-01-12','11:05:00',2.53),('5819','2013-01-12','11:10:00',2.52),('5819','2013-01-12','11:15:00',2.52),('5819','2013-01-12','11:20:00',2.53),('5819','2013-01-12','11:25:00',2.56),('5819','2013-01-12','11:30:00',2.55),('5819','2013-01-12','11:35:00',2.56),('5819','2013-01-12','11:40:00',2.56),('5819','2013-01-12','11:45:00',2.55),('5819','2013-01-12','11:50:00',2.57),('5819','2013-01-12','11:55:00',2.58),('5819','2013-01-12','12:00:00',2.56),('5819','2013-01-12','12:05:00',2.54),('5819','2013-01-12','12:10:00',2.51),('5819','2013-01-12','12:15:00',2.51),('5819','2013-01-12','12:20:00',2.47),('5819','2013-01-12','12:25:00',2.43),('5819','2013-01-12','12:30:00',2.44),('5819','2013-01-12','12:35:00',2.17),('5819','2013-01-12','12:40:00',1.85),('5819','2013-01-12','12:50:00',1.67),('5819','2013-01-12','12:55:00',1.68),('5819','2013-01-12','13:00:00',2.1),('5819','2013-01-12','13:05:00',2.25),('5819','2013-01-12','13:10:00',2.05),('5819','2013-01-12','13:15:00',1.31),('5819','2013-01-12','13:25:00',1.82),('5819','2013-01-12','13:30:00',2.15),('5819','2013-01-12','13:35:00',2.08),('5819','2013-01-12','13:40:00',1.03),('5819','2013-01-12','13:50:00',1.41),('5819','2013-01-12','13:55:00',2.1),('5819','2013-01-12','14:00:00',1.45),('5819','2013-01-12','14:05:00',1.3),('5819','2013-01-12','14:10:00',2),('5819','2013-01-12','14:15:00',1.92),('5819','2013-01-12','14:20:00',1.71),('5819','2013-01-12','14:25:00',1.66),('5819','2013-01-12','14:30:00',1.54),('5819','2013-01-12','14:35:00',1.47),('5819','2013-01-12','14:40:00',1.42),('5819','2013-01-12','14:45:00',1.36),('5819','2013-01-12','14:50:00',1.25),('5819','2013-01-12','14:55:00',1.2),('5819','2013-01-12','15:00:00',1.15),('5819','2013-01-12','15:05:00',1.07),('5819','2013-01-11','09:45:00',1.01),('5819','2013-01-11','09:50:00',1.23),('5819','2013-01-11','10:00:00',1.16),('5819','2013-01-11','10:05:00',1.43),('5819','2013-01-11','10:10:00',1.46),('5819','2013-01-11','10:15:00',1.85),('5819','2013-01-11','10:20:00',1.17),('5819','2013-01-11','10:25:00',2.32),('5819','2013-01-11','10:30:00',2.32),('5819','2013-01-11','10:35:00',2.35),('5819','2013-01-11','10:40:00',2.36),('5819','2013-01-11','10:45:00',2.39),('5819','2013-01-11','10:50:00',2.44),('5819','2013-01-11','10:55:00',2.45),('5819','2013-01-11','11:00:00',2.49),('5819','2013-01-11','11:05:00',2.49),('5819','2013-01-11','11:10:00',2.48),('5819','2013-01-11','11:15:00',2.45),('5819','2013-01-11','11:20:00',2.45),('5819','2013-01-11','11:25:00',1.89),('5819','2013-01-11','11:30:00',1.03),('5819','2013-01-11','11:35:00',1.54),('5819','2013-01-11','11:40:00',1.41),('5819','2013-01-11','11:45:00',1.48),('5819','2013-01-11','11:50:00',1.37),('5819','2013-01-11','11:55:00',1.13),('5819','2013-01-11','12:55:00',1.32),('5819','2013-01-11','13:00:00',1.19),('5819','2013-01-11','13:10:00',1.43),('5819','2013-01-11','13:15:00',1.09),('5819','2013-01-11','13:35:00',1.91),('5819','2013-01-11','13:40:00',1.6),('5819','2013-01-11','13:45:00',1.93),('5819','2013-01-11','14:20:00',1.05),('5819','2013-01-11','14:25:00',1.19),('5819','2013-01-11','14:45:00',1.13),('5819','2013-01-11','14:50:00',1.48),('5819','2013-01-11','14:55:00',1.27),('5819','2013-01-11','15:00:00',1.22),('5819','2013-01-11','15:05:00',1.24),('5819','2013-01-10','11:55:00',1.06),('5819','2013-01-10','12:00:00',1.14),('5819','2013-01-10','12:05:00',1.13),('5819','2013-01-10','12:10:00',1.01),('5819','2013-01-09','10:40:00',1.02),('5819','2013-01-09','10:45:00',1.07),('5819','2013-01-09','10:50:00',1.41),('5819','2013-01-09','10:55:00',1.29),('5819','2013-01-09','11:00:00',1.2),('5819','2013-01-09','11:10:00',1.1),('5819','2013-01-09','11:15:00',2.03),('5819','2013-01-09','11:20:00',1.66),('5819','2013-01-09','11:25:00',1.24),('5819','2013-01-09','11:30:00',1.09),('5819','2013-01-09','11:35:00',1.12),('5819','2013-01-09','11:40:00',1.2),('5819','2013-01-09','11:45:00',1.06),('5819','2013-01-09','11:50:00',1.23),('5819','2013-01-09','11:55:00',1.19),('5819','2013-01-09','12:00:00',1.26),('5819','2013-01-09','12:05:00',1.16),('5819','2013-01-09','12:10:00',1.03),('5819','2013-01-09','12:15:00',1.01),('5819','2013-01-09','12:20:00',1.03),('5819','2013-01-09','13:00:00',1.09),('5819','2013-01-09','13:05:00',1.42),('5819','2013-01-09','13:10:00',2.01),('5819','2013-01-09','13:15:00',1.22),('5819','2013-01-09','13:20:00',1.1),('5819','2013-01-08','08:35:00',1.34),('5819','2013-01-08','08:40:00',1.4),('5819','2013-01-08','08:45:00',1.5),('5819','2013-01-08','08:50:00',1.55),('5819','2013-01-08','08:55:00',1.71),('5819','2013-01-08','09:00:00',1.77),('5819','2013-01-08','09:05:00',1.76),('5819','2013-01-08','09:10:00',1.06),('5819','2013-01-08','09:15:00',1.44),('5819','2013-01-08','09:20:00',1.73),('5819','2013-01-08','09:25:00',1.84),('5819','2013-01-08','09:30:00',1.64),('5819','2013-01-08','09:35:00',1.28),('5819','2013-01-08','09:40:00',1.9),('5819','2013-01-08','09:45:00',2.19),('5819','2013-01-08','09:50:00',2.27),('5819','2013-01-08','09:55:00',2.2),('5819','2013-01-08','10:00:00',2),('5819','2013-01-08','10:05:00',1.97),('5819','2013-01-08','10:10:00',2.03),('5819','2013-01-08','10:15:00',2.09),('5819','2013-01-08','10:20:00',1.97),('5819','2013-01-08','10:25:00',2.13),('5819','2013-01-08','10:30:00',2.13),('5819','2013-01-08','10:35:00',2.32),('5819','2013-01-08','10:40:00',2.47),('5819','2013-01-08','10:45:00',2.4),('5819','2013-01-08','10:50:00',2.45),('5819','2013-01-08','10:55:00',2.48),('5819','2013-01-08','11:00:00',2.42),('5819','2013-01-08','11:05:00',2.5),('5819','2013-01-08','11:10:00',2.51),('5819','2013-01-08','11:15:00',2.5),('5819','2013-01-08','11:20:00',2.5),('5819','2013-01-08','11:25:00',2.52),('5819','2013-01-08','11:30:00',2.54),('5819','2013-01-08','11:35:00',2.56),('5819','2013-01-08','11:40:00',2.49),('5819','2013-01-08','11:45:00',2.97),('5819','2013-01-08','11:50:00',2.22),('5819','2013-01-08','11:55:00',1.67),('5819','2013-01-08','12:00:00',1.48),('5819','2013-01-08','12:05:00',1.41),('5819','2013-01-08','12:10:00',1.47),('5819','2013-01-08','12:15:00',1.33),('5819','2013-01-08','12:20:00',1.2),('5819','2013-01-08','12:25:00',1.18),('5819','2013-01-08','12:30:00',1.12),('5819','2013-01-08','12:35:00',1.1),('5819','2013-01-08','12:40:00',1.39),('5819','2013-01-08','12:45:00',1.56),('5819','2013-01-08','12:50:00',2.05),('5819','2013-01-08','12:55:00',1.44),('5819','2013-01-08','13:15:00',1.03),('5819','2013-01-08','13:20:00',1.05),('5819','2013-01-08','13:25:00',1.04),('5819','2013-01-08','13:45:00',1.2),('5819','2013-01-08','13:50:00',1.19),('5819','2013-01-08','13:55:00',1.21),('5819','2013-01-08','14:40:00',1.01),('5819','2013-01-07','08:40:00',1.02),('5819','2013-01-07','08:45:00',1.1),('5819','2013-01-07','08:50:00',1.21),('5819','2013-01-07','08:55:00',1.33),('5819','2013-01-07','09:00:00',1.35),('5819','2013-01-07','09:05:00',1.2),('5819','2013-01-07','09:10:00',1.35),('5819','2013-01-07','09:15:00',1.03),('5819','2013-01-07','09:20:00',1.55),('5819','2013-01-07','09:25:00',1.68),('5819','2013-01-07','09:30:00',1.73),('5819','2013-01-07','09:35:00',1.79),('5819','2013-01-07','09:40:00',1.81),('5819','2013-01-07','09:45:00',1.91),('5819','2013-01-07','09:50:00',1.94),('5819','2013-01-07','09:55:00',2.03),('5819','2013-01-07','10:00:00',2.08),('5819','2013-01-07','10:05:00',2.16),('5819','2013-01-07','10:10:00',2.24),('5819','2013-01-07','10:15:00',2.29),('5819','2013-01-07','10:20:00',2.29),('5819','2013-01-07','10:25:00',2.35),('5819','2013-01-07','10:30:00',2.36),('5819','2013-01-07','10:35:00',2.37),('5819','2013-01-07','10:40:00',2.39),('5819','2013-01-07','10:45:00',2.41),('5819','2013-01-07','10:50:00',2.41),('5819','2013-01-07','10:55:00',2.37),('5819','2013-01-07','11:00:00',2.41),('5819','2013-01-07','11:05:00',2.39),('5819','2013-01-07','11:10:00',2.44),('5819','2013-01-07','11:15:00',2.49),('5819','2013-01-07','11:20:00',2.47),('5819','2013-01-07','11:25:00',2.5),('5819','2013-01-07','11:30:00',2.5),('5819','2013-01-07','11:35:00',2.5),('5819','2013-01-07','11:40:00',2.48),('5819','2013-01-07','11:45:00',2.49),('5819','2013-01-07','11:50:00',2.5),('5819','2013-01-07','11:55:00',2.52),('5819','2013-01-07','12:00:00',2.51),('5819','2013-01-07','12:05:00',2.5),('5819','2013-01-07','12:10:00',2.49),('5819','2013-01-07','12:15:00',2.48),('5819','2013-01-07','12:20:00',2.45),('5819','2013-01-07','12:25:00',2.45),('5819','2013-01-07','12:30:00',2.42),('5819','2013-01-07','12:35:00',2.39),('5819','2013-01-07','12:40:00',2.39),('5819','2013-01-07','12:45:00',2.36),('5819','2013-01-07','12:50:00',2.32),('5819','2013-01-07','12:55:00',2.3),('5819','2013-01-07','13:00:00',2.27),('5819','2013-01-07','13:05:00',2.23),('5819','2013-01-07','13:10:00',2.18),('5819','2013-01-07','13:15:00',2.13),('5819','2013-01-07','13:20:00',2.1),('5819','2013-01-07','13:25:00',2.07),('5819','2013-01-07','13:30:00',2.03),('5819','2013-01-07','13:35:00',1.99),('5819','2013-01-07','13:40:00',1.94),('5819','2013-01-07','13:45:00',1.91),('5819','2013-01-07','13:50:00',1.86),('5819','2013-01-07','13:55:00',1.82),('5819','2013-01-07','14:00:00',1.79),('5819','2013-01-07','14:05:00',1.73),('5819','2013-01-07','14:10:00',1.66),('5819','2013-01-07','14:15:00',1.61),('5819','2013-01-07','14:20:00',1.59),('5819','2013-01-07','14:25:00',1.51),('5819','2013-01-07','14:30:00',1.45),('5819','2013-01-07','14:35:00',1.39),('5819','2013-01-07','14:40:00',1.35),('5819','2013-01-07','14:45:00',1.28),('5819','2013-01-07','14:50:00',1.24),('5819','2013-01-07','14:55:00',1.15),('5819','2013-01-07','15:00:00',1.08),('5819','2013-01-07','15:05:00',1.02),('5819','2013-01-06','08:35:00',1.07),('5819','2013-01-06','08:40:00',1.14),('5819','2013-01-06','08:45:00',1.23),('5819','2013-01-06','08:50:00',1.3),('5819','2013-01-06','08:55:00',1.38),('5819','2013-01-06','09:00:00',1.45),('5819','2013-01-06','09:05:00',1.52),('5819','2013-01-06','09:10:00',1.59),('5819','2013-01-06','09:15:00',1.66),('5819','2013-01-06','09:20:00',1.71),('5819','2013-01-06','09:25:00',1.78),('5819','2013-01-06','09:30:00',1.84),('5819','2013-01-06','09:35:00',1.9),('5819','2013-01-06','09:40:00',1.95),('5819','2013-01-06','09:45:00',1.99),('5819','2013-01-06','09:50:00',2.05),('5819','2013-01-06','09:55:00',2.07),('5819','2013-01-06','10:00:00',2.11),('5819','2013-01-06','10:05:00',2.14),('5819','2013-01-06','10:10:00',2.19),('5819','2013-01-06','10:15:00',2.24),('5819','2013-01-06','10:20:00',2.24),('5819','2013-01-06','10:25:00',2.31),('5819','2013-01-06','10:30:00',2.35),('5819','2013-01-06','10:35:00',2.38),('5819','2013-01-06','10:40:00',2.41),('5819','2013-01-06','10:45:00',2.44),('5819','2013-01-06','10:50:00',2.46),('5819','2013-01-06','10:55:00',2.47),('5819','2013-01-06','11:00:00',2.48),('5819','2013-01-06','11:05:00',2.5),('5819','2013-01-06','11:10:00',2.51),('5819','2013-01-06','11:15:00',2.51),('5819','2013-01-06','11:20:00',2.52),('5819','2013-01-06','11:25:00',2.54),('5819','2013-01-06','11:30:00',2.54),('5819','2013-01-06','11:35:00',2.54),('5819','2013-01-06','11:40:00',2.53),('5819','2013-01-06','11:45:00',2.53),('5819','2013-01-06','11:50:00',2.54),('5819','2013-01-06','11:55:00',2.54),('5819','2013-01-06','12:00:00',2.54),('5819','2013-01-06','12:05:00',2.54),('5819','2013-01-06','12:10:00',2.52),('5819','2013-01-06','12:15:00',2.5),('5819','2013-01-06','12:20:00',2.49),('5819','2013-01-06','12:25:00',2.43),('5819','2013-01-06','12:30:00',2.42),('5819','2013-01-06','12:35:00',2.38),('5819','2013-01-06','12:40:00',2.37),('5819','2013-01-06','12:45:00',2.35),('5819','2013-01-06','12:50:00',2.35),('5819','2013-01-06','12:55:00',2.34),('5819','2013-01-06','13:00:00',2.32),('5819','2013-01-06','13:05:00',2.29),('5819','2013-01-06','13:10:00',2.27),('5819','2013-01-06','13:15:00',2.22),('5819','2013-01-06','13:20:00',2.17),('5819','2013-01-06','13:25:00',2.13),('5819','2013-01-06','13:30:00',2.1),('5819','2013-01-06','13:35:00',2.07),('5819','2013-01-06','13:40:00',2.03),('5819','2013-01-06','13:45:00',1.98),('5819','2013-01-06','13:50:00',1.92),('5819','2013-01-06','13:55:00',1.84),('5819','2013-01-06','14:00:00',1.84),('5819','2013-01-06','14:05:00',1.7),('5819','2013-01-06','14:10:00',1.51),('5819','2013-01-06','14:15:00',1.23),('5819','2013-01-06','14:20:00',1.46),('5819','2013-01-06','14:25:00',1.46),('5819','2013-01-06','14:30:00',1.45),('5819','2013-01-06','14:35:00',1.38),('5819','2013-01-06','14:40:00',1.3),('5819','2013-01-06','14:45:00',1.27),('5819','2013-01-06','14:50:00',1.19),('5819','2013-01-06','14:55:00',1.11),('5819','2013-01-06','15:00:00',1.05),('5819','2013-01-05','10:10:00',1.11),('5819','2013-01-05','10:15:00',1.16),('5819','2013-01-05','10:20:00',1.07),('5819','2013-01-05','10:35:00',1.06),('5819','2013-01-05','10:40:00',1.13),('5819','2013-01-05','10:45:00',1.1),('5819','2013-01-05','10:50:00',1.32),('5819','2013-01-05','10:55:00',2.16),('5819','2013-01-05','11:00:00',1.81),('5819','2013-01-05','11:05:00',2.17),('5819','2013-01-05','11:10:00',2.1),('5819','2013-01-05','11:15:00',1.77),('5819','2013-01-05','11:20:00',2.32),('5819','2013-01-05','11:25:00',2.41),('5819','2013-01-05','11:30:00',2.39),('5819','2013-01-05','11:35:00',2.19),('5819','2013-01-05','11:40:00',1.97),('5819','2013-01-05','11:45:00',1.96),('5819','2013-01-05','11:50:00',1.71),('5819','2013-01-05','11:55:00',1.55),('5819','2013-01-05','12:00:00',1.45),('5819','2013-01-05','12:05:00',1.42),('5819','2013-01-05','12:10:00',1.4),('5819','2013-01-05','12:15:00',1.41),('5819','2013-01-05','12:20:00',1.26),('5819','2013-01-05','12:25:00',1.09),('5819','2013-01-05','12:30:00',1.15),('5819','2013-01-05','12:35:00',1.57),('5819','2013-01-05','12:40:00',1.87),('5819','2013-01-05','12:45:00',2.06),('5819','2013-01-05','12:50:00',1.3),('5819','2013-01-05','12:55:00',1.13),('5819','2013-01-05','13:00:00',1.18),('5819','2013-01-05','13:05:00',1.07),('5819','2013-01-05','13:10:00',1.03),('5819','2013-01-05','13:30:00',1.57),('5819','2013-01-05','13:35:00',1.44),('5819','2013-01-05','13:40:00',1.02),('5819','2013-01-05','13:55:00',1.04),('5819','2013-01-05','14:05:00',1.45),('5819','2013-01-05','14:10:00',1.29),('5819','2013-01-05','14:30:00',1.05),('5819','2013-01-05','14:35:00',1.02),('5819','2013-01-05','14:40:00',1.1),('5819','2013-01-05','14:45:00',1.13),('5819','2013-01-04','08:45:00',1.21),('5819','2013-01-04','08:50:00',1.29),('5819','2013-01-04','08:55:00',1.28),('5819','2013-01-04','09:00:00',1.3),('5819','2013-01-04','09:05:00',1.4),('5819','2013-01-04','09:10:00',1.48),('5819','2013-01-04','09:15:00',1.14),('5819','2013-01-04','09:20:00',1.45),('5819','2013-01-04','09:25:00',1.36),('5819','2013-01-04','09:30:00',1.31),('5819','2013-01-04','09:35:00',1.25),('5819','2013-01-04','09:40:00',1.36),('5819','2013-01-04','09:45:00',1.35),('5819','2013-01-04','09:50:00',1.41),('5819','2013-01-04','09:55:00',1.89),('5819','2013-01-04','10:00:00',2.2),('5819','2013-01-04','10:05:00',2.25),('5819','2013-01-04','10:10:00',1.91),('5819','2013-01-04','10:15:00',2.25),('5819','2013-01-04','10:20:00',1.83),('5819','2013-01-04','10:25:00',2.3),('5819','2013-01-04','10:30:00',2.37),('5819','2013-01-04','10:35:00',2.4),('5819','2013-01-04','10:40:00',2.47),('5819','2013-01-04','10:45:00',2.56),('5819','2013-01-04','10:50:00',2.67),('5819','2013-01-04','10:55:00',2.69),('5819','2013-01-04','11:00:00',2.34),('5819','2013-01-04','11:05:00',1.3),('5819','2013-01-04','11:20:00',1.18),('5819','2013-01-04','11:35:00',1.36),('5819','2013-01-04','11:40:00',1.12),('5819','2013-01-04','11:45:00',1.68),('5819','2013-01-04','11:50:00',2.47),('5819','2013-01-04','11:55:00',2.82),('5819','2013-01-04','12:00:00',2.82),('5819','2013-01-04','12:05:00',2.42),('5819','2013-01-04','12:10:00',1.93),('5819','2013-01-04','12:15:00',1.29),('5819','2013-01-04','12:20:00',1.04),('5819','2013-01-04','12:25:00',1.37),('5819','2013-01-04','12:30:00',1.79),('5819','2013-01-04','12:35:00',1.66),('5819','2013-01-04','12:40:00',2.34),('5819','2013-01-04','12:45:00',2.49),('5819','2013-01-04','12:50:00',2.48),('5819','2013-01-04','12:55:00',2.44),('5819','2013-01-04','13:00:00',2.36),('5819','2013-01-04','13:05:00',2.23),('5819','2013-01-04','13:10:00',2.2),('5819','2013-01-04','13:15:00',1.92),('5819','2013-01-04','13:20:00',2.11),('5819','2013-01-04','13:25:00',2.06),('5819','2013-01-04','13:30:00',2.01),('5819','2013-01-04','13:35:00',1.95),('5819','2013-01-04','13:40:00',1.9),('5819','2013-01-04','13:45:00',1.83),('5819','2013-01-04','13:50:00',1.75),('5819','2013-01-04','13:55:00',1.71),('5819','2013-01-04','14:00:00',1.64),('5819','2013-01-04','14:05:00',1.62),('5819','2013-01-04','14:10:00',1.61),('5819','2013-01-04','14:15:00',1.54),('5819','2013-01-04','14:20:00',1.47),('5819','2013-01-04','14:25:00',1.39),('5819','2013-01-04','14:30:00',1.33),('5819','2013-01-04','14:35:00',1.29),('5819','2013-01-04','14:40:00',1.25),('5819','2013-01-04','14:45:00',1.2),('5819','2013-01-04','14:50:00',1.11),('5819','2013-01-04','14:55:00',1.08),('5819','2013-01-04','15:00:00',1.03),('5819','2013-01-03','08:40:00',1.08),('5819','2013-01-03','08:45:00',1.16),('5819','2013-01-03','08:50:00',1.23),('5819','2013-01-03','08:55:00',1.29),('5819','2013-01-03','09:00:00',1.39),('5819','2013-01-03','09:05:00',1.47),('5819','2013-01-03','09:10:00',1.55),('5819','2013-01-03','09:15:00',1.63),('5819','2013-01-03','09:20:00',1.7),('5819','2013-01-03','09:25:00',1.76),('5819','2013-01-03','09:30:00',1.83),('5819','2013-01-03','09:35:00',1.9),('5819','2013-01-03','09:40:00',2.02),('5819','2013-01-03','09:45:00',2.17),('5819','2013-01-03','09:50:00',2.32),('5819','2013-01-03','09:55:00',2.45),('5819','2013-01-03','10:00:00',2.56),('5819','2013-01-03','10:05:00',2.45),('5819','2013-01-03','10:10:00',2.6),('5819','2013-01-03','10:15:00',2.79),('5819','2013-01-03','10:20:00',2.17),('5819','2013-01-03','10:25:00',2.06),('5819','2013-01-03','10:30:00',1.92),('5819','2013-01-03','10:35:00',2.07),('5819','2013-01-03','10:40:00',1.81),('5819','2013-01-03','10:45:00',1.66),('5819','2013-01-03','10:50:00',1.59),('5819','2013-01-03','10:55:00',1.48),('5819','2013-01-03','11:00:00',1.6),('5819','2013-01-03','11:05:00',1.55),('5819','2013-01-03','11:10:00',1.4),('5819','2013-01-03','11:15:00',1.38),('5819','2013-01-03','11:20:00',1.24),('5819','2013-01-03','11:25:00',1.15),('5819','2013-01-03','11:30:00',1.1),('5819','2013-01-03','11:35:00',2.33),('5819','2013-01-03','11:40:00',2.7),('5819','2013-01-03','11:45:00',2.67),('5819','2013-01-03','11:50:00',2.61),('5819','2013-01-03','11:55:00',2.57),('5819','2013-01-03','12:00:00',2.55),('5819','2013-01-03','12:05:00',2.54),('5819','2013-01-03','12:10:00',2.51),('5819','2013-01-03','12:15:00',2.49),('5819','2013-01-03','12:20:00',2.48),('5819','2013-01-03','12:25:00',2.46),('5819','2013-01-03','12:30:00',2.45),('5819','2013-01-03','12:35:00',2.44),('5819','2013-01-03','12:40:00',2.41),('5819','2013-01-03','12:45:00',2.38),('5819','2013-01-03','12:50:00',2.35),('5819','2013-01-03','12:55:00',2.33),('5819','2013-01-03','13:00:00',2.29),('5819','2013-01-03','13:05:00',2.25),('5819','2013-01-03','13:10:00',2.22),('5819','2013-01-03','13:15:00',2.17),('5819','2013-01-03','13:20:00',2.14),('5819','2013-01-03','13:25:00',2.11),('5819','2013-01-03','13:30:00',2.05),('5819','2013-01-03','13:35:00',2.02),('5819','2013-01-03','13:40:00',1.98),('5819','2013-01-03','13:45:00',1.92),('5819','2013-01-03','13:50:00',1.88),('5819','2013-01-03','13:55:00',1.83),('5819','2013-01-03','14:00:00',1.78),('5819','2013-01-03','14:05:00',1.72),('5819','2013-01-03','14:10:00',1.69),('5819','2013-01-03','14:15:00',1.64),('5819','2013-01-03','14:20:00',1.58),('5819','2013-01-03','14:25:00',1.51),('5819','2013-01-03','14:30:00',1.45),('5819','2013-01-03','14:35:00',1.39),('5819','2013-01-03','14:40:00',1.33),('5819','2013-01-03','14:45:00',1.27),('5819','2013-01-03','14:50:00',1.21),('5819','2013-01-03','14:55:00',1.16),('5819','2013-01-03','15:00:00',1.09),('5819','2013-01-03','15:05:00',1.02),('5819','2013-01-01','08:40:00',1.05),('5819','2013-01-01','08:45:00',1.13),('5819','2013-01-01','08:50:00',1.19),('5819','2013-01-01','08:55:00',1.26),('5819','2013-01-01','09:00:00',1.34),('5819','2013-01-01','09:05:00',1.41),('5819','2013-01-01','09:10:00',1.48),('5819','2013-01-01','09:15:00',1.54),('5819','2013-01-01','09:20:00',1.6),('5819','2013-01-01','09:25:00',1.66),('5819','2013-01-01','09:30:00',1.71),('5819','2013-01-01','09:35:00',1.77),('5819','2013-01-01','09:40:00',1.82),('5819','2013-01-01','09:45:00',1.88),('5819','2013-01-01','09:50:00',1.93),('5819','2013-01-01','09:55:00',1.97),('5819','2013-01-01','10:00:00',1.99),('5819','2013-01-01','10:05:00',2.04),('5819','2013-01-01','10:10:00',2.09),('5819','2013-01-01','10:15:00',2.12),('5819','2013-01-01','10:20:00',2.17),('5819','2013-01-01','10:25:00',2.2),('5819','2013-01-01','10:30:00',2.24),('5819','2013-01-01','10:35:00',2.26),('5819','2013-01-01','10:40:00',2.31),('5819','2013-01-01','10:45:00',2.21),('5819','2013-01-01','10:50:00',2.08),('5819','2013-01-01','10:55:00',1.4),('5819','2013-01-01','11:05:00',2.52),('5819','2013-01-01','11:10:00',2.55),('5819','2013-01-01','11:15:00',2.57),('5819','2013-01-01','11:20:00',2.01),('5819','2013-01-01','11:25:00',2.14),('5819','2013-01-01','11:30:00',2.82),('5819','2013-01-01','11:35:00',1.3),('5819','2013-01-01','11:40:00',1.28),('5819','2013-01-01','11:45:00',2.18),('5819','2013-01-01','11:50:00',2.43),('5819','2013-01-01','11:55:00',2.4),('5819','2013-01-01','12:00:00',1.29),('5819','2013-01-01','12:05:00',1.11),('5819','2013-01-01','12:10:00',1.31),('5819','2013-01-01','12:15:00',1.18),('5819','2013-01-01','12:20:00',1.26),('5819','2013-01-01','12:25:00',1.24),('5819','2013-01-01','12:30:00',1.01),('5819','2013-01-01','12:40:00',1.09),('5819','2013-01-01','12:45:00',1.23),('5819','2013-01-01','12:50:00',1.02),('5819','2013-01-01','12:55:00',1.01),('5819','2012-12-31','08:25:00',1.01),('5819','2012-12-31','08:30:00',1.11),('5819','2012-12-31','08:35:00',1.17),('5819','2012-12-31','09:05:00',1.18),('5819','2012-12-31','09:10:00',1.16),('5819','2012-12-31','09:15:00',1.42),('5819','2012-12-31','09:20:00',1.77),('5819','2012-12-31','09:25:00',1.94),('5819','2012-12-31','09:30:00',1.67),('5819','2012-12-31','10:10:00',1.78),('5819','2012-12-31','10:15:00',2.44),('5819','2012-12-31','10:20:00',2.44),('5819','2012-12-31','10:25:00',2.43),('5819','2012-12-31','10:30:00',2.44),('5819','2012-12-31','10:35:00',2.45),('5819','2012-12-31','10:40:00',2.48),('5819','2012-12-31','10:45:00',2.45),('5819','2012-12-31','10:50:00',2.42),('5819','2012-12-31','10:55:00',2.47),('5819','2012-12-31','11:00:00',2.49),('5819','2012-12-31','11:05:00',2.5),('5819','2012-12-31','11:10:00',2.43),('5819','2012-12-31','11:15:00',2.42),('5819','2012-12-31','11:20:00',2.52),('5819','2012-12-31','11:25:00',2.55),('5819','2012-12-31','11:30:00',2.57),('5819','2012-12-31','11:35:00',2.58),('5819','2012-12-31','11:40:00',2.59),('5819','2012-12-31','11:45:00',2.58),('5819','2012-12-31','11:50:00',2.58),('5819','2012-12-31','11:55:00',2.58),('5819','2012-12-31','12:00:00',2.61),('5819','2012-12-31','12:05:00',2.61),('5819','2012-12-31','12:10:00',2.6),('5819','2012-12-31','12:15:00',2.59),('5819','2012-12-31','12:20:00',2.56),('5819','2012-12-31','12:25:00',2.54),('5819','2012-12-31','12:30:00',2.5),('5819','2012-12-31','12:35:00',2.48),('5819','2012-12-31','12:40:00',2.46),('5819','2012-12-31','12:45:00',2.43),('5819','2012-12-31','12:50:00',2.4),('5819','2012-12-31','12:55:00',2.38),('5819','2012-12-31','13:00:00',2.34),('5819','2012-12-31','13:05:00',2.3),('5819','2012-12-31','13:10:00',2.27),('5819','2012-12-31','13:15:00',2.23),('5819','2012-12-31','13:20:00',2.19),('5819','2012-12-31','13:25:00',2.16),('5819','2012-12-31','13:30:00',2.11),('5819','2012-12-31','13:35:00',2.06),('5819','2012-12-31','13:40:00',2),('5819','2012-12-31','13:45:00',1.94),('5819','2012-12-31','13:50:00',1.89),('5819','2012-12-31','13:55:00',1.85),('5819','2012-12-31','14:00:00',1.79),('5819','2012-12-31','14:05:00',1.73),('5819','2012-12-31','14:10:00',1.67),('5819','2012-12-31','14:15:00',1.61),('5819','2012-12-31','14:20:00',1.55),('5819','2012-12-31','14:25:00',1.49),('5819','2012-12-31','14:30:00',1.45),('5819','2012-12-31','14:35:00',1.38),('5819','2012-12-31','14:40:00',1.32),('5819','2012-12-31','14:45:00',1.25),('5819','2012-12-31','14:50:00',1.2),('5819','2012-12-31','14:55:00',1.13),('5819','2012-12-31','15:00:00',1.06),('5819','2012-12-31','15:05:00',1.01),('5819','2012-12-30','08:35:00',1.04),('5819','2012-12-30','08:40:00',1.12),('5819','2012-12-30','08:45:00',1.21),('5819','2012-12-30','08:50:00',1.28),('5819','2012-12-30','08:55:00',1.35),('5819','2012-12-30','09:00:00',1.42),('5819','2012-12-30','09:05:00',1.5),('5819','2012-12-30','09:10:00',1.57),('5819','2012-12-30','09:15:00',1.64),('5819','2012-12-30','09:20:00',1.71),('5819','2012-12-30','09:25:00',1.77),('5819','2012-12-30','09:30:00',1.83),('5819','2012-12-30','09:35:00',1.89),('5819','2012-12-30','09:40:00',1.95),('5819','2012-12-30','09:45:00',1.99),('5819','2012-12-30','09:50:00',2.03),('5819','2012-12-30','09:55:00',2.07),('5819','2012-12-30','10:00:00',2.13),('5819','2012-12-30','10:05:00',2.18),('5819','2012-12-30','10:10:00',2.23),('5819','2012-12-30','10:15:00',2.26),('5819','2012-12-30','10:20:00',2.3),('5819','2012-12-30','10:25:00',2.34),('5819','2012-12-30','10:30:00',2.37),('5819','2012-12-30','10:35:00',2.41),('5819','2012-12-30','10:40:00',2.43),('5819','2012-12-30','10:45:00',2.45),('5819','2012-12-30','10:50:00',2.46),('5819','2012-12-30','10:55:00',2.48),('5819','2012-12-30','11:00:00',2.49),('5819','2012-12-30','11:05:00',2.51),('5819','2012-12-30','11:10:00',2.53),('5819','2012-12-30','11:15:00',2.54),('5819','2012-12-30','11:20:00',2.54),('5819','2012-12-30','11:25:00',2.54),('5819','2012-12-30','11:30:00',2.54),('5819','2012-12-30','11:35:00',2.56),('5819','2012-12-30','11:40:00',2.54),('5819','2012-12-30','11:45:00',2.55),('5819','2012-12-30','11:50:00',2.54),('5819','2012-12-30','11:55:00',2.54),('5819','2012-12-30','12:00:00',2.52),('5819','2012-12-30','12:05:00',2.52),('5819','2012-12-30','12:10:00',2.5),('5819','2012-12-30','12:15:00',2.49),('5819','2012-12-30','12:20:00',2.46),('5819','2012-12-30','12:25:00',2.44),('5819','2012-12-30','12:30:00',2.43),('5819','2012-12-30','12:35:00',2.39),('5819','2012-12-30','12:40:00',2.37),('5819','2012-12-30','12:45:00',2.32),('5819','2012-12-30','12:50:00',2.29),('5819','2012-12-30','12:55:00',2.28),('5819','2012-12-30','13:00:00',2.29),('5819','2012-12-30','13:05:00',2.28),('5819','2012-12-30','13:10:00',2.25),('5819','2012-12-30','13:15:00',2.22),('5819','2012-12-30','13:20:00',2.16),('5819','2012-12-30','13:25:00',2.14),('5819','2012-12-30','13:30:00',2.09),('5819','2012-12-30','13:35:00',2.05),('5819','2012-12-30','13:40:00',2),('5819','2012-12-30','13:45:00',1.95),('5819','2012-12-30','13:50:00',1.91),('5819','2012-12-30','13:55:00',1.85),('5819','2012-12-30','14:00:00',1.81),('5819','2012-12-30','14:05:00',1.75),('5819','2012-12-30','14:10:00',1.69),('5819','2012-12-30','14:15:00',1.64),('5819','2012-12-30','14:20:00',1.58),('5819','2012-12-30','14:25:00',1.52),('5819','2012-12-30','14:30:00',1.44),('5819','2012-12-30','14:35:00',1.39),('5819','2012-12-30','14:40:00',1.32),('5819','2012-12-30','14:45:00',1.26),('5819','2012-12-30','14:50:00',1.2),('5819','2012-12-30','14:55:00',1.13),('5819','2012-12-30','15:00:00',1.07),('5819','2012-12-29','08:35:00',1.06),('5819','2012-12-29','08:40:00',1.18),('5819','2012-12-29','08:45:00',1.27),('5819','2012-12-29','08:50:00',1.36),('5819','2012-12-29','08:55:00',1.43),('5819','2012-12-29','09:00:00',1.47),('5819','2012-12-29','09:05:00',1.54),('5819','2012-12-29','09:10:00',1.62),('5819','2012-12-29','09:15:00',1.68),('5819','2012-12-29','09:20:00',1.74),('5819','2012-12-29','09:25:00',1.79),('5819','2012-12-29','09:30:00',1.84),('5819','2012-12-29','09:35:00',1.89),('5819','2012-12-29','09:40:00',1.96),('5819','2012-12-29','09:45:00',2.03),('5819','2012-12-29','09:50:00',2.09),('5819','2012-12-29','09:55:00',2.15),('5819','2012-12-29','10:00:00',2.2),('5819','2012-12-29','10:05:00',2.24),('5819','2012-12-29','10:10:00',2.28),('5819','2012-12-29','10:15:00',2.33),('5819','2012-12-29','10:20:00',2.36),('5819','2012-12-29','10:25:00',2.4),('5819','2012-12-29','10:30:00',2.43),('5819','2012-12-29','10:35:00',2.45),('5819','2012-12-29','10:40:00',2.47),('5819','2012-12-29','10:45:00',2.5),('5819','2012-12-29','10:50:00',2.53),('5819','2012-12-29','10:55:00',2.56),('5819','2012-12-29','11:00:00',2.57),('5819','2012-12-29','11:05:00',2.58),('5819','2012-12-29','11:10:00',2.59),('5819','2012-12-29','11:15:00',2.61),('5819','2012-12-29','11:20:00',2.62),('5819','2012-12-29','11:25:00',2.63),('5819','2012-12-29','11:30:00',2.61),('5819','2012-12-29','11:35:00',2.62),('5819','2012-12-29','11:40:00',2.59),('5819','2012-12-29','11:45:00',2.6),('5819','2012-12-29','11:50:00',2.61),('5819','2012-12-29','11:55:00',2.59),('5819','2012-12-29','12:00:00',2.59),('5819','2012-12-29','12:05:00',2.6),('5819','2012-12-29','12:10:00',2.61),('5819','2012-12-29','12:15:00',2.56),('5819','2012-12-29','12:20:00',2.52),('5819','2012-12-29','12:25:00',2.48),('5819','2012-12-29','12:30:00',2.47),('5819','2012-12-29','12:35:00',2.47),('5819','2012-12-29','12:40:00',2.46),('5819','2012-12-29','12:45:00',2.41),('5819','2012-12-29','12:50:00',2.36),('5819','2012-12-29','12:55:00',2.34),('5819','2012-12-29','13:00:00',2.33),('5819','2012-12-29','13:05:00',2.31),('5819','2012-12-29','13:10:00',2.28),('5819','2012-12-29','13:15:00',2.26),('5819','2012-12-29','13:20:00',2.22),('5819','2012-12-29','13:25:00',2.16),('5819','2012-12-29','13:30:00',2.12),('5819','2012-12-29','13:35:00',2.07),('5819','2012-12-29','13:40:00',2.03),('5819','2012-12-29','13:45:00',1.98),('5819','2012-12-29','13:50:00',1.93),('5819','2012-12-29','13:55:00',1.88),('5819','2012-12-29','14:00:00',1.82),('5819','2012-12-29','14:05:00',1.76),('5819','2012-12-29','14:10:00',1.71),('5819','2012-12-29','14:15:00',1.66),('5819','2012-12-29','14:20:00',1.6),('5819','2012-12-29','14:25:00',1.54),('5819','2012-12-29','14:30:00',1.47),('5819','2012-12-29','14:35:00',1.41),('5819','2012-12-29','14:40:00',1.34),('5819','2012-12-29','14:45:00',1.29),('5819','2012-12-29','14:50:00',1.23),('5819','2012-12-29','14:55:00',1.16),('5819','2012-12-29','15:00:00',1.1),('5819','2012-12-29','15:05:00',1.04),('5819','2012-12-28','08:45:00',1.07),('5819','2012-12-28','08:50:00',1.16),('5819','2012-12-28','08:55:00',1.26),('5819','2012-12-28','09:00:00',1.33),('5819','2012-12-28','09:05:00',1.41),('5819','2012-12-28','09:10:00',1.47),('5819','2012-12-28','09:15:00',1.55),('5819','2012-12-28','09:20:00',1.59),('5819','2012-12-28','09:25:00',1.63),('5819','2012-12-28','09:30:00',1.69),('5819','2012-12-28','09:35:00',1.74),('5819','2012-12-28','09:40:00',1.81),('5819','2012-12-28','09:45:00',1.85),('5819','2012-12-28','09:50:00',1.82),('5819','2012-12-28','09:55:00',1.94),('5819','2012-12-28','10:00:00',1.98),('5819','2012-12-28','10:05:00',2.03),('5819','2012-12-28','10:10:00',2.11),('5819','2012-12-28','10:15:00',2.18),('5819','2012-12-28','10:20:00',2.2),('5819','2012-12-28','10:25:00',2.23),('5819','2012-12-28','10:30:00',2.27),('5819','2012-12-28','10:35:00',2.32),('5819','2012-12-28','10:40:00',2.31),('5819','2012-12-28','10:45:00',2.36),('5819','2012-12-28','10:50:00',2.38),('5819','2012-12-28','10:55:00',2.4),('5819','2012-12-28','11:00:00',2.43),('5819','2012-12-28','11:05:00',2.48),('5819','2012-12-28','11:10:00',2.4),('5819','2012-12-28','11:15:00',2.11),('5819','2012-12-28','11:20:00',2.49),('5819','2012-12-28','11:25:00',2.51),('5819','2012-12-28','11:30:00',2.5),('5819','2012-12-28','11:35:00',2.52),('5819','2012-12-28','11:40:00',2.53),('5819','2012-12-28','11:45:00',2.56),('5819','2012-12-28','11:50:00',2.41),('5819','2012-12-28','11:55:00',2.53),('5819','2012-12-28','12:00:00',2.52),('5819','2012-12-28','12:05:00',2.51),('5819','2012-12-28','12:10:00',2.47),('5819','2012-12-28','12:15:00',2.46),('5819','2012-12-28','12:20:00',2.43),('5819','2012-12-28','12:25:00',2.41),('5819','2012-12-28','12:30:00',2.38),('5819','2012-12-28','12:35:00',2.35),('5819','2012-12-28','12:40:00',2.02),('5819','2012-12-28','12:45:00',2.28),('5819','2012-12-28','12:50:00',2.33),('5819','2012-12-28','12:55:00',2.26),('5819','2012-12-28','13:00:00',2.18),('5819','2012-12-28','13:05:00',2.17),('5819','2012-12-28','13:10:00',2.1),('5819','2012-12-28','13:15:00',2.08),('5819','2012-12-28','13:20:00',2.05),('5819','2012-12-28','13:25:00',2.01),('5819','2012-12-28','13:30:00',1.97),('5819','2012-12-28','13:35:00',1.91),('5819','2012-12-28','13:40:00',1.86),('5819','2012-12-28','13:45:00',1.83),('5819','2012-12-28','13:50:00',1.79),('5819','2012-12-28','13:55:00',1.73),('5819','2012-12-28','14:00:00',1.68),('5819','2012-12-28','14:05:00',1.6),('5819','2012-12-28','14:10:00',1.52),('5819','2012-12-28','14:15:00',1.3),('5819','2012-12-28','14:20:00',1.44),('5819','2012-12-28','14:25:00',1.39),('5819','2012-12-28','14:30:00',1.32),('5819','2012-12-28','14:35:00',1.22),('5819','2012-12-28','14:45:00',1.14),('5819','2012-12-28','14:50:00',1.09),('5819','2012-12-28','14:55:00',1.03),('5819','2012-12-27','09:25:00',1.02),('5819','2012-12-27','09:30:00',1.01),('5819','2012-12-27','09:35:00',1.48),('5819','2012-12-27','09:40:00',1.87),('5819','2012-12-27','09:45:00',1.93),('5819','2012-12-27','09:50:00',1.99),('5819','2012-12-27','09:55:00',1.41),('5819','2012-12-27','10:05:00',1.1),('5819','2012-12-27','10:10:00',1.28),('5819','2012-12-27','10:15:00',1.61),('5819','2012-12-27','10:20:00',2.03),('5819','2012-12-27','10:25:00',2.12),('5819','2012-12-27','10:30:00',2.05),('5819','2012-12-27','10:35:00',2.14),('5819','2012-12-27','10:40:00',2.19),('5819','2012-12-27','10:45:00',2.19),('5819','2012-12-27','10:50:00',2.23),('5819','2012-12-27','10:55:00',2.12),('5819','2012-12-27','11:00:00',2.14),('5819','2012-12-27','11:05:00',1.95),('5819','2012-12-27','11:10:00',1.36),('5819','2012-12-27','11:15:00',1.14),('5819','2012-12-27','11:25:00',1.36),('5819','2012-12-27','11:50:00',1.47),('5819','2012-12-27','11:55:00',2.33),('5819','2012-12-27','12:00:00',2.43),('5819','2012-12-27','12:05:00',2.55),('5819','2012-12-27','12:10:00',2.71),('5819','2012-12-27','12:15:00',2.52),('5819','2012-12-27','12:20:00',1.26),('5819','2012-12-27','12:25:00',2.25),('5819','2012-12-27','12:30:00',2.36),('5819','2012-12-27','12:35:00',2.37),('5819','2012-12-27','12:40:00',2.33),('5819','2012-12-27','12:45:00',2.38),('5819','2012-12-27','12:50:00',1.21),('5819','2012-12-27','12:55:00',2.34),('5819','2012-12-27','13:00:00',2.39),('5819','2012-12-27','13:05:00',1.84),('5819','2012-12-27','13:10:00',1.23),('5819','2012-12-27','13:15:00',1.12),('5819','2012-12-27','13:20:00',1.2),('5819','2012-12-27','14:05:00',1.16),('5819','2012-12-27','14:10:00',1.02),('5819','2012-12-27','14:15:00',1.3),('5819','2012-12-27','14:20:00',1.46),('5819','2012-12-27','14:25:00',1.43),('5819','2012-12-27','14:30:00',1.35),('5819','2012-12-27','14:35:00',1.29),('5819','2012-12-27','14:40:00',1.23),('5819','2012-12-27','14:45:00',1.1),('5819','2012-12-27','15:00:00',1.05),('5819','2012-12-26','09:15:00',1.3),('5819','2012-12-26','09:20:00',1.67),('5819','2012-12-26','09:25:00',1.71),('5819','2012-12-26','09:30:00',1.74),('5819','2012-12-26','09:35:00',1.78),('5819','2012-12-26','09:40:00',1.85),('5819','2012-12-26','09:45:00',1.88),('5819','2012-12-26','09:50:00',1.94),('5819','2012-12-26','09:55:00',1.98),('5819','2012-12-26','10:00:00',2.03),('5819','2012-12-26','10:05:00',2.06),('5819','2012-12-26','10:10:00',2.09),('5819','2012-12-26','10:15:00',2.12),('5819','2012-12-26','10:20:00',2.14),('5819','2012-12-26','10:25:00',2.15),('5819','2012-12-26','10:30:00',2.17),('5819','2012-12-26','10:35:00',2.2),('5819','2012-12-26','10:40:00',2.23),('5819','2012-12-26','10:45:00',2.23),('5819','2012-12-26','10:50:00',2.24),('5819','2012-12-26','10:55:00',2.27),('5819','2012-12-26','11:00:00',2.29),('5819','2012-12-26','11:05:00',2.31),('5819','2012-12-26','11:10:00',2.32),('5819','2012-12-26','11:15:00',2.32),('5819','2012-12-26','11:20:00',2.33),('5819','2012-12-26','11:25:00',2.34),('5819','2012-12-26','11:30:00',2.33),('5819','2012-12-26','11:35:00',2.35),('5819','2012-12-26','11:40:00',2.37),('5819','2012-12-26','11:45:00',2.36),('5819','2012-12-26','11:50:00',2.38),('5819','2012-12-26','11:55:00',2.42),('5819','2012-12-26','12:00:00',2.46),('5819','2012-12-26','12:05:00',2.48),('5819','2012-12-26','12:10:00',2.44),('5819','2012-12-26','12:15:00',2.47),('5819','2012-12-26','12:20:00',2.46),('5819','2012-12-26','12:25:00',2.47),('5819','2012-12-26','12:30:00',2.45),('5819','2012-12-26','12:35:00',2.41),('5819','2012-12-26','12:40:00',2.44),('5819','2012-12-26','12:45:00',2.38),('5819','2012-12-26','12:50:00',2.31),('5819','2012-12-26','12:55:00',2.3),('5819','2012-12-26','13:00:00',2.33),('5819','2012-12-26','13:05:00',2.28),('5819','2012-12-26','13:10:00',2.3),('5819','2012-12-26','13:15:00',2.29),('5819','2012-12-26','13:20:00',2.33),('5819','2012-12-26','13:25:00',2.37),('5819','2012-12-26','13:30:00',2.53),('5819','2012-12-26','13:35:00',2.4),('5819','2012-12-26','13:40:00',2.34),('5819','2012-12-26','13:45:00',2.24),('5819','2012-12-26','13:50:00',1.91),('5819','2012-12-26','13:55:00',1.91),('5819','2012-12-26','14:00:00',1.72),('5819','2012-12-26','14:05:00',1.85),('5819','2012-12-23','08:35:00',1.08),('5819','2012-12-23','08:40:00',1.17),('5819','2012-12-23','08:45:00',1.24),('5819','2012-12-23','08:50:00',1.31),('5819','2012-12-23','08:55:00',1.4),('5819','2012-12-23','09:00:00',1.49),('5819','2012-12-23','09:05:00',1.57),('5819','2012-12-23','09:10:00',1.61),('5819','2012-12-23','09:15:00',1.62),('5819','2012-12-23','09:20:00',1.67),('5819','2012-12-23','09:25:00',1.76),('5819','2012-12-23','09:30:00',1.77),('5819','2012-12-23','09:35:00',1.85),('5819','2012-12-23','09:40:00',1.9),('5819','2012-12-23','09:45:00',1.95),('5819','2012-12-23','09:50:00',1.98),('5819','2012-12-23','09:55:00',2),('5819','2012-12-23','10:00:00',2.03),('5819','2012-12-23','10:05:00',2.1),('5819','2012-12-23','10:10:00',2.13),('5819','2012-12-23','10:15:00',2.15),('5819','2012-12-23','10:20:00',2.2),('5819','2012-12-23','10:25:00',2.22),('5819','2012-12-23','10:30:00',2.2),('5819','2012-12-23','10:35:00',2.28),('5819','2012-12-23','10:40:00',2.3),('5819','2012-12-23','10:45:00',2.33),('5819','2012-12-23','10:50:00',2.33),('5819','2012-12-23','10:55:00',2.22),('5819','2012-12-23','11:00:00',2.36),('5819','2012-12-23','11:05:00',2.37),('5819','2012-12-23','11:10:00',2.37),('5819','2012-12-23','11:15:00',2.39),('5819','2012-12-23','11:20:00',2.46),('5819','2012-12-23','11:25:00',2.24),('5819','2012-12-23','11:30:00',2.37),('5819','2012-12-23','11:35:00',2.48),('5819','2012-12-23','11:40:00',2.46),('5819','2012-12-23','11:45:00',2.42),('5819','2012-12-23','11:50:00',2.48),('5819','2012-12-23','11:55:00',2.3),('5819','2012-12-23','12:00:00',2.15),('5819','2012-12-23','12:05:00',2.17),('5819','2012-12-23','12:10:00',2.17),('5819','2012-12-23','12:15:00',1.76),('5819','2012-12-23','12:20:00',1.67),('5819','2012-12-23','12:30:00',1.37),('5819','2012-12-23','12:35:00',1.42),('5819','2012-12-23','12:40:00',1.35),('5819','2012-12-23','12:45:00',1.09),('5819','2012-12-23','12:50:00',1.55),('5819','2012-12-23','12:55:00',2.03),('5819','2012-12-23','13:00:00',2.11),('5819','2012-12-23','13:05:00',1.82),('5819','2012-12-23','13:10:00',2.07),('5819','2012-12-23','13:15:00',1.35),('5819','2012-12-23','13:40:00',1.47),('5819','2012-12-23','13:45:00',1.42),('5819','2012-12-23','13:50:00',1.26),('5819','2012-12-23','13:55:00',1.2),('5819','2012-12-23','14:00:00',1.74),('5819','2012-12-23','14:05:00',1.47),('5819','2012-12-23','14:10:00',1.39),('5819','2012-12-23','14:15:00',1.4),('5819','2012-12-23','14:20:00',1.1),('5819','2012-12-23','14:40:00',1.15),('5819','2012-12-23','14:45:00',1.19),('5819','2014-05-01','07:45:00',1.07),('5819','2014-05-01','07:50:00',1.43),('5819','2014-05-01','07:55:00',1.56),('5819','2014-05-01','08:00:00',1.69),('5819','2014-05-01','08:05:00',1.68),('5819','2014-05-01','08:10:00',1.79),('5819','2014-05-01','08:15:00',1.88),('5819','2014-05-01','08:20:00',1.97),('5819','2014-05-01','08:25:00',2.05),('5819','2014-05-01','08:30:00',2.13),('5819','2014-05-01','08:35:00',2.22),('5819','2014-05-01','08:40:00',2.29),('5819','2014-05-01','08:45:00',2.37),('5819','2014-05-01','08:50:00',2.54),('5819','2014-05-01','08:55:00',2.79),('5819','2014-05-01','09:00:00',1.4),('5819','2014-05-01','09:05:00',1.33),('5819','2014-05-01','09:10:00',2.19),('5819','2014-05-01','09:15:00',1.82),('5819','2014-05-01','09:20:00',1.15),('5819','2014-05-01','09:25:00',1.98),('5819','2014-05-01','09:30:00',3.15),('5819','2014-05-01','09:35:00',2.79),('5819','2014-05-01','09:40:00',1.17),('5819','2014-05-01','09:45:00',1.8),('5819','2014-05-01','09:50:00',1.55),('5819','2014-05-01','09:55:00',1.65),('5819','2014-05-01','10:00:00',1.85),('5819','2014-05-01','10:05:00',2.81),('5819','2014-05-01','10:10:00',2.92),('5819','2014-05-01','10:15:00',3.29),('5819','2014-05-01','10:20:00',3.01),('5819','2014-05-01','10:25:00',3.73),('5819','2014-05-01','10:30:00',2.66),('5819','2014-05-01','10:35:00',1.23),('5819','2014-05-01','10:40:00',1.64),('5819','2014-05-01','10:45:00',4.11),('5819','2014-05-01','10:50:00',4.08),('5819','2014-05-01','10:55:00',3.2),('5819','2014-05-01','11:00:00',3.24),('5819','2014-05-01','11:05:00',1.47),('5819','2014-05-01','11:10:00',1.72),('5819','2014-05-01','11:15:00',2.67),('5819','2014-05-01','11:20:00',4.53),('5819','2014-05-01','11:25:00',3.4),('5819','2014-05-01','11:30:00',4.3),('5819','2014-05-01','11:35:00',3.18),('5819','2014-05-01','11:40:00',3.63),('5819','2014-05-01','11:45:00',4.24),('5819','2014-05-01','11:50:00',2.05),('5819','2014-05-01','11:55:00',3.78),('5819','2014-05-01','12:00:00',3.63),('5819','2014-05-01','12:05:00',4.53),('5819','2014-05-01','12:10:00',3.76),('5819','2014-05-01','12:15:00',2.92),('5819','2014-05-01','12:20:00',2.34),('5819','2014-05-01','12:25:00',3.63),('5819','2014-05-01','12:30:00',4.49),('5819','2014-05-01','12:35:00',4.44),('5819','2014-05-01','12:40:00',4.41),('5819','2014-05-01','12:45:00',4.29),('5819','2014-05-01','12:50:00',4.32),('5819','2014-05-01','12:55:00',4.32),('5819','2014-05-01','13:00:00',4.41),('5819','2014-05-01','13:05:00',4.31),('5819','2014-05-01','13:10:00',4.4),('5819','2014-05-01','13:15:00',4.34),('5819','2014-05-01','13:20:00',1.11),('5819','2014-05-01','13:25:00',3.89),('5819','2014-05-01','13:30:00',4.55),('5819','2014-05-01','13:35:00',4.4),('5819','2014-05-01','13:40:00',3.93),('5819','2014-05-01','13:45:00',2.69),('5819','2014-05-01','13:50:00',2.26),('5819','2014-05-01','14:00:00',1.48),('5819','2014-05-01','14:05:00',1.45),('5819','2014-05-01','14:10:00',4.48),('5819','2014-05-01','14:15:00',4.27),('5819','2014-05-01','14:20:00',3.85),('5819','2014-05-01','14:25:00',4.14),('5819','2014-05-01','14:30:00',3.79),('5819','2014-05-01','14:35:00',3.77),('5819','2014-05-01','14:40:00',3.91),('5819','2014-05-01','14:45:00',2.99),('5819','2014-05-01','14:50:00',3.55),('5819','2014-05-01','14:55:00',3.78),('5819','2014-05-01','15:00:00',3.49),('5819','2014-05-01','15:05:00',3.89),('5819','2014-05-01','15:10:00',2.72),('5819','2014-05-01','15:15:00',3.52),('5819','2014-05-01','15:20:00',3.46),('5819','2014-05-01','15:25:00',3.37),('5819','2014-05-01','15:30:00',3.25),('5819','2014-05-01','15:35:00',3.16),('5819','2014-05-01','15:40:00',3.11),('5819','2014-05-01','15:45:00',3.08),('5819','2014-05-01','15:50:00',2.91),('5819','2014-05-01','15:55:00',2.88),('5819','2014-05-01','16:00:00',2.79),('5819','2014-05-01','16:05:00',2.77),('5819','2014-05-01','16:10:00',2.67),('5819','2014-05-01','16:15:00',2.59),('5819','2014-05-01','16:20:00',2.49),('5819','2014-05-01','16:25:00',2.22),('5819','2014-05-01','16:30:00',2.32),('5819','2014-05-01','16:35:00',2.27),('5819','2014-05-01','16:40:00',2.13),('5819','2014-05-01','16:45:00',1.81),('5819','2014-05-01','16:50:00',1.77),('5819','2014-05-01','16:55:00',1.83),('5819','2014-05-01','17:00:00',1.59),('5819','2014-05-01','17:05:00',1.75),('5819','2014-05-01','17:10:00',1.76),('5819','2014-05-01','17:15:00',1.62),('5819','2014-05-01','17:20:00',1.55),('5819','2014-05-01','17:25:00',1.45),('5819','2014-05-01','17:30:00',1.34),('5819','2014-05-01','17:35:00',1.15),('5819','2014-05-01','17:45:00',1.1),('5819','2014-05-01','17:50:00',1.03),('5819','2014-05-01','18:00:00',1.02),('5819','2012-12-22','10:20:00',1.09),('5819','2012-12-22','10:25:00',2.12),('5819','2012-12-22','10:30:00',2.66),('5819','2012-12-22','10:35:00',2.82),('5819','2012-12-22','10:40:00',2.73),('5819','2012-12-22','10:45:00',2.67),('5819','2012-12-22','10:50:00',2.64),('5819','2012-12-22','10:55:00',2.66),('5819','2012-12-22','11:00:00',1.74),('5819','2012-12-22','11:45:00',1.39),('5819','2012-12-22','11:50:00',2.12),('5819','2012-12-22','11:55:00',1.31),('5819','2012-12-22','12:00:00',2.01),('5819','2012-12-22','12:50:00',1.59),('5819','2012-12-22','12:55:00',1.41),('5819','2012-12-22','13:00:00',1.81),('5819','2012-12-22','13:05:00',2.58),('5819','2012-12-22','13:10:00',2.74),('5819','2012-12-22','13:15:00',2.68),('5819','2012-12-22','13:20:00',2.66),('5819','2012-12-22','13:25:00',2.57),('5819','2012-12-22','13:30:00',2.16),('5819','2012-12-22','13:35:00',2.22),('5819','2012-12-22','13:40:00',2.06),('5819','2012-12-22','14:00:00',1.01),('5819','2012-12-22','14:05:00',1.2),('5819','2012-12-22','14:10:00',1.22),('5819','2012-12-22','14:15:00',1.31),('5819','2012-12-22','14:20:00',1.29),('5819','2012-12-22','15:00:00',1.11),('5819','2014-04-30','07:30:00',1.02),('5819','2014-04-30','07:35:00',1.13),('5819','2014-04-30','07:40:00',1.2),('5819','2014-04-30','07:45:00',1.31),('5819','2014-04-30','07:50:00',1.38),('5819','2014-04-30','07:55:00',1.49),('5819','2014-04-30','08:00:00',1.56),('5819','2014-04-30','08:05:00',1.6),('5819','2014-04-30','08:11:00',1.74),('5819','2014-04-30','08:15:00',1.83),('5819','2014-04-30','08:20:00',1.89),('5819','2014-04-30','08:25:00',1.98),('5819','2014-04-30','08:30:00',2.03),('5819','2014-04-30','08:35:00',2.14),('5819','2014-04-30','08:40:00',2.19),('5819','2014-04-30','08:45:00',2.23),('5819','2014-04-30','08:50:00',2.17),('5819','2014-04-30','08:55:00',2.45),('5819','2014-04-30','09:00:00',2.52),('5819','2014-04-30','09:05:00',2.69),('5819','2014-04-30','09:10:00',2.85),('5819','2014-04-30','09:15:00',2.88),('5819','2014-04-30','09:20:00',2.27),('5819','2014-04-30','09:25:00',1.74),('5819','2014-04-30','09:30:00',1.54),('5819','2014-04-30','09:35:00',3.16),('5819','2014-04-30','09:40:00',2.48),('5819','2014-04-30','09:45:00',3.38),('5819','2014-04-30','09:50:00',2.04),('5819','2014-04-30','09:55:00',2.45),('5819','2014-04-30','10:00:00',3.67),('5819','2014-04-30','10:05:00',3.98),('5819','2014-04-30','10:10:00',2.41),('5819','2014-04-30','10:15:00',2.35),('5819','2014-04-30','10:20:00',1.92),('5819','2014-04-30','10:25:00',1.54),('5819','2014-04-30','10:30:00',1.55),('5819','2014-04-30','10:35:00',2.22),('5819','2014-04-30','10:40:00',2.12),('5819','2014-04-30','10:45:00',1.47),('5819','2014-04-30','10:50:00',1.3),('5819','2014-04-30','10:55:00',3.79),('5819','2014-04-30','11:00:00',2.26),('5819','2014-04-30','11:05:00',3.45),('5819','2014-04-30','11:10:00',2.76),('5819','2014-04-30','11:15:00',2.1),('5819','2014-04-30','11:20:00',1.57),('5819','2014-04-30','11:25:00',2),('5819','2014-04-30','11:30:00',1.97),('5819','2014-04-30','11:35:00',1.91),('5819','2014-04-30','11:40:00',1.87),('5819','2014-04-30','11:45:00',2.03),('5819','2014-04-30','11:50:00',2.97),('5819','2014-04-30','11:55:00',2.11),('5819','2014-04-30','12:00:00',2.94),('5819','2014-04-30','12:05:00',1.48),('5819','2014-04-30','12:10:00',1.28),('5819','2014-04-30','12:15:00',1.59),('5819','2014-04-30','12:20:00',2.11),('5819','2014-04-30','12:25:00',1.39),('5819','2014-04-30','12:30:00',1.32),('5819','2014-04-30','12:35:00',1.27),('5819','2014-04-30','12:40:00',1.21),('5819','2014-04-30','12:45:00',1.9),('5819','2014-04-30','12:50:00',1.58),('5819','2014-04-30','12:55:00',3.5),('5819','2014-04-30','13:00:00',4.32),('5819','2014-04-30','13:05:00',3.58),('5819','2014-04-30','13:10:00',4.65),('5819','2014-04-30','13:15:00',2.23),('5819','2014-04-30','13:20:00',1.71),('5819','2014-04-30','13:25:00',2.14),('5819','2014-04-30','13:30:00',2.05),('5819','2014-04-30','13:35:00',1.67),('5819','2014-04-30','13:40:00',3.22),('5819','2014-04-30','13:45:00',2.67),('5819','2014-04-30','13:50:00',3.89),('5819','2014-04-30','13:55:00',4.81),('5819','2014-04-30','14:00:00',2.09),('5819','2014-04-30','14:05:00',1.75),('5819','2014-04-30','14:10:00',1.52),('5819','2014-04-30','14:15:00',1.71),('5819','2014-04-30','14:20:00',2.89),('5819','2014-04-30','14:25:00',2.76),('5819','2014-04-30','14:30:00',3.79),('5819','2014-04-30','14:35:00',4.07),('5819','2014-04-30','14:40:00',2.11),('5819','2014-04-30','14:45:00',1.38),('5819','2014-04-30','14:50:00',1.52),('5819','2014-04-30','14:55:00',1.72),('5819','2014-04-30','15:00:00',1.37),('5819','2014-04-30','15:05:00',1.35),('5819','2014-04-30','15:10:00',1.28),('5819','2014-04-30','15:15:00',1.2),('5819','2014-04-30','15:20:00',1.17),('5819','2014-04-30','15:25:00',1.3),('5819','2014-04-30','15:30:00',1.75),('5819','2014-04-30','15:35:00',2.11),('5819','2014-04-30','15:40:00',3.38),('5819','2014-04-30','15:45:00',3.4),('5819','2014-04-30','15:50:00',2.38),('5819','2014-04-30','15:55:00',2.88),('5819','2014-04-30','16:00:00',1.3),('5819','2014-04-30','16:05:00',1.96),('5819','2014-04-30','16:10:00',1.44),('5819','2014-04-30','16:15:00',1.67),('5819','2014-04-30','16:20:00',1.38),('5819','2014-04-30','16:25:00',1.37),('5819','2014-04-30','16:30:00',2.03),('5819','2014-04-30','16:35:00',1.36),('5819','2014-04-30','16:40:00',1.75),('5819','2014-04-30','16:45:00',2.02),('5819','2014-04-30','16:50:00',2.47),('5819','2014-04-30','16:55:00',2.08),('5819','2014-04-30','17:00:00',1.2),('5819','2014-04-30','17:05:00',2.28),('5819','2014-04-30','17:10:00',1.24),('5819','2014-04-29','09:55:00',1.03),('5819','2014-04-29','10:00:00',1.06),('5819','2014-04-29','10:05:00',1.82),('5819','2014-04-29','10:10:00',2.61),('5819','2014-04-29','10:15:00',3.67),('5819','2014-04-29','10:20:00',3.86),('5819','2014-04-29','10:25:00',3.86),('5819','2014-04-29','10:30:00',3.93),('5819','2014-04-29','10:35:00',3.86),('5819','2014-04-29','10:40:00',3.9),('5819','2014-04-29','10:45:00',3.92),('5819','2014-04-29','10:50:00',3.98),('5819','2014-04-29','10:55:00',3.73),('5819','2014-04-28','08:15:00',1.86),('5819','2014-04-28','08:20:00',1.98),('5819','2014-04-28','08:25:00',1.64),('5819','2014-04-28','08:30:00',1.27),('5819','2014-04-28','08:35:00',1.23),('5819','2014-04-28','08:40:00',1.11),('5819','2014-04-28','08:45:00',1.24),('5819','2014-04-28','08:50:00',1.42),('5819','2014-04-28','08:55:00',1.34),('5819','2014-04-28','09:00:00',1.2),('5819','2014-04-28','09:10:00',1.73),('5819','2014-04-28','09:15:00',2.32),('5819','2014-04-28','09:20:00',2.63),('5819','2014-04-28','09:25:00',1.77),('5819','2014-04-28','09:30:00',3.09),('5819','2014-04-28','09:35:00',1.91),('5819','2014-04-28','09:40:00',1.98),('5819','2014-04-28','09:45:00',2.25),('5819','2014-04-28','09:50:00',3.39),('5819','2014-04-28','09:55:00',1.78),('5819','2014-04-28','10:00:00',1.38),('5819','2014-04-28','10:05:00',1.89),('5819','2014-04-28','10:10:00',2.17),('5819','2014-04-28','10:15:00',2.12),('5819','2014-04-28','10:20:00',1.99),('5819','2014-04-28','10:25:00',1.51),('5819','2014-04-28','10:45:00',1.27),('5819','2014-04-28','10:50:00',1.8),('5819','2014-04-28','10:55:00',1.89),('5819','2014-04-28','11:00:00',1.67),('5819','2014-04-28','11:05:00',2.18),('5819','2014-04-28','11:10:00',2.44),('5819','2014-04-28','11:15:00',2.23),('5819','2014-04-28','11:20:00',2.37),('5819','2014-04-28','11:25:00',1.66),('5819','2014-04-28','11:30:00',1.7),('5819','2014-04-28','11:35:00',1.7),('5819','2014-04-28','11:40:00',1.43),('5819','2014-04-28','11:45:00',1.54),('5819','2014-04-28','11:50:00',1.65),('5819','2014-04-28','11:55:00',1.75),('5819','2014-04-28','12:00:00',1.67),('5819','2014-04-28','12:05:00',1.25),('5819','2014-04-28','12:10:00',1.63),('5819','2014-04-28','12:15:00',2.68),('5819','2014-04-28','12:20:00',2.79),('5819','2014-04-28','12:25:00',2.64),('5819','2014-04-28','12:30:00',2.46),('5819','2014-04-28','12:35:00',2.27),('5819','2014-04-28','12:40:00',2.04),('5819','2014-04-28','12:45:00',1.77),('5819','2014-04-28','12:50:00',2.06),('5819','2014-04-28','12:55:00',2.09),('5819','2014-04-28','13:00:00',2.16),('5819','2014-04-28','13:05:00',2.47),('5819','2014-04-28','13:10:00',3.33),('5819','2014-04-28','13:15:00',2.29),('5819','2014-04-28','13:20:00',2.05),('5819','2014-04-28','13:25:00',2.46),('5819','2014-04-28','13:30:00',4.11),('5819','2014-04-28','13:35:00',2.82),('5819','2014-04-28','13:40:00',4.02),('5819','2014-04-28','13:45:00',2.01),('5819','2014-04-28','13:50:00',4.25),('5819','2014-04-28','13:55:00',3.69),('5819','2014-04-28','14:00:00',2.9),('5819','2014-04-28','14:05:00',1.81),('5819','2014-04-28','14:10:00',4.47),('5819','2014-04-28','14:15:00',3.79),('5819','2014-04-28','14:20:00',3.24),('5819','2014-04-28','14:25:00',2.83),('5819','2014-04-28','14:30:00',3.24),('5819','2014-04-28','14:35:00',3.88),('5819','2014-04-28','14:40:00',2.73),('5819','2014-04-28','14:45:00',2.46),('5819','2014-04-28','14:50:00',1.98),('5819','2014-04-28','14:55:00',2.39),('5819','2014-04-28','15:00:00',2.04),('5819','2014-04-28','15:05:00',2.78),('5819','2014-04-28','15:10:00',2.73),('5819','2014-04-28','15:15:00',2.62),('5819','2014-04-28','15:20:00',2.96),('5819','2014-04-28','15:25:00',2.07),('5819','2014-04-28','15:30:00',1.48),('5819','2014-04-28','15:35:00',1.56),('5819','2014-04-28','15:40:00',2.54),('5819','2014-04-28','15:45:00',1.44),('5819','2014-04-28','15:50:00',3.14),('5819','2014-04-28','15:55:00',1.18),('5819','2014-04-28','16:00:00',3),('5819','2014-04-28','16:05:00',3.19),('5819','2014-04-28','16:10:00',2.65),('5819','2014-04-28','16:15:00',1.52),('5819','2014-04-28','16:20:00',2.42),('5819','2014-04-28','16:25:00',1.59),('5819','2014-04-28','16:30:00',2.16),('5819','2014-04-28','16:35:00',1.55),('5819','2014-04-28','16:55:00',1.85),('5819','2014-04-28','17:00:00',1.05),('5819','2014-04-28','17:40:00',1),('5819','2014-04-27','10:10:00',1.08),('5819','2014-04-27','11:05:00',1.24),('5819','2014-04-27','11:10:00',1.42),('5819','2014-04-27','11:15:00',1.33),('5819','2014-04-27','11:20:00',1.09),('5819','2014-04-27','11:35:00',1.27),('5819','2014-04-27','11:40:00',1.46),('5819','2014-04-27','11:45:00',2.86),('5819','2014-04-27','11:50:00',2.82),('5819','2014-04-27','11:55:00',2.27),('5819','2014-04-27','12:00:00',2.36),('5819','2014-04-27','12:05:00',2.51),('5819','2014-04-27','12:10:00',2.85),('5819','2014-04-27','12:15:00',2.79),('5819','2014-04-27','12:20:00',2.6),('5819','2014-04-27','12:25:00',2.68),('5819','2014-04-27','12:30:00',2.46),('5819','2014-04-27','12:35:00',2.47),('5819','2014-04-27','12:40:00',2.24),('5819','2014-04-27','12:45:00',2.41),('5819','2014-04-27','12:50:00',2.17),('5819','2014-04-27','12:55:00',1.55),('5819','2014-04-27','13:00:00',1.8),('5819','2014-04-27','13:05:00',1.94),('5819','2014-04-27','13:10:00',1.65),('5819','2014-04-27','13:15:00',1.63),('5819','2014-04-27','13:20:00',2.17),('5819','2014-04-27','13:25:00',2.11),('5819','2014-04-27','13:30:00',1.87),('5819','2014-04-27','13:35:00',1.62),('5819','2014-04-27','13:40:00',1.51),('5819','2014-04-27','13:45:00',1.45),('5819','2014-04-27','13:50:00',1.35),('5819','2014-04-27','13:55:00',1.31),('5819','2014-04-27','14:00:00',1.56),('5819','2014-04-27','14:05:00',2.14),('5819','2014-04-27','14:10:00',1.62),('5819','2014-04-27','14:15:00',1.36),('5819','2014-04-27','14:20:00',1.58),('5819','2014-04-27','14:25:00',1.98),('5819','2014-04-27','14:30:00',2.13),('5819','2014-04-27','14:35:00',2.05),('5819','2014-04-27','14:40:00',2.11),('5819','2014-04-27','14:45:00',1.89),('5819','2014-04-27','14:50:00',1.76),('5819','2014-04-27','14:55:00',1.86),('5819','2014-04-27','15:00:00',1.94),('5819','2014-04-27','15:05:00',2.62),('5819','2014-04-27','15:10:00',3.41),('5819','2014-04-27','15:15:00',2.7),('5819','2014-04-27','15:20:00',1.79),('5819','2014-04-27','15:25:00',1.17),('5819','2014-04-27','15:40:00',1.01),('6449','2013-06-20','06:45:00',1.04),('6449','2013-06-20','06:50:00',1.21),('6449','2013-06-20','06:55:00',1.4),('6449','2013-06-20','07:00:00',1.59),('6449','2013-06-20','07:05:00',1.83),('6449','2013-06-20','07:10:00',2.06),('6449','2013-06-20','07:15:00',2.31),('6449','2013-06-20','07:20:00',2.56),('6449','2013-06-20','07:25:00',2.85),('6449','2013-06-20','07:30:00',3.11),('6449','2013-06-20','07:35:00',3.42),('6449','2013-06-20','07:40:00',3.71),('6449','2013-06-20','07:45:00',4.03),('6449','2013-06-20','07:50:00',4.35),('6449','2013-06-20','07:55:00',4.67),('6449','2013-06-20','08:00:00',4.87),('6449','2013-06-20','08:05:00',5.27),('6449','2013-06-20','08:10:00',5.58),('6449','2013-06-20','08:15:00',5.93),('6449','2013-06-20','08:20:00',6.24),('6449','2013-06-20','08:25:00',6.57),('6449','2013-06-20','08:30:00',6.76),('6449','2013-06-20','08:35:00',7.21),('6449','2013-06-20','08:40:00',7.44),('6449','2013-06-20','08:45:00',7.74),('6449','2013-06-20','08:50:00',7.98),('6449','2013-06-20','08:55:00',8.37),('6449','2013-06-20','09:00:00',8.56),('6449','2013-06-20','09:05:00',8.91),('6449','2013-06-20','09:10:00',9.24),('6449','2013-06-20','09:15:00',9.34),('6449','2013-06-20','09:20:00',9.65),('6449','2013-06-20','09:25:00',9.97),('6449','2013-06-20','09:30:00',10.16),('6449','2013-06-20','09:35:00',10.36),('6449','2013-06-20','09:40:00',7.84),('6449','2013-06-20','09:45:00',10.7),('6449','2013-06-20','09:50:00',11.03),('6449','2013-06-20','09:55:00',11.02),('6449','2013-06-20','10:00:00',11.37),('6449','2013-06-20','10:05:00',11.42),('6449','2013-06-20','10:10:00',11.62),('6449','2013-06-20','10:15:00',11.84),('6449','2013-06-20','10:20:00',12.06),('6449','2013-06-20','10:25:00',11.98),('6449','2013-06-20','10:30:00',12.35),('6449','2013-06-20','10:35:00',12.79),('6449','2013-06-20','10:40:00',13.19),('6449','2013-06-20','10:45:00',13.41),('6449','2013-06-20','10:50:00',13.42),('6449','2013-06-20','10:55:00',13.46),('6449','2013-06-20','11:00:00',13.79),('6449','2013-06-20','11:05:00',13.88),('6449','2013-06-20','11:10:00',13.97),('6449','2013-06-20','11:15:00',13.91),('6449','2013-06-20','11:20:00',13.91),('6449','2013-06-20','11:25:00',14.06),('6449','2013-06-20','11:30:00',14.27),('6449','2013-06-20','11:35:00',14.34),('6449','2013-06-20','11:40:00',14.45),('6449','2013-06-20','11:45:00',14.5),('6449','2013-06-20','11:50:00',14.74),('6449','2013-06-20','11:55:00',14.81),('6449','2013-06-20','12:00:00',14.92),('6449','2013-06-20','12:05:00',15.02),('6449','2013-06-20','12:10:00',15.01),('6449','2013-06-20','12:15:00',14.73),('6449','2013-06-20','12:20:00',15.05),('6449','2013-06-20','12:25:00',15.2),('6449','2013-06-20','12:30:00',15.35),('6449','2013-06-20','12:35:00',15.37),('6449','2013-06-20','12:40:00',15.3),('6449','2013-06-20','12:45:00',15.17),('6449','2013-06-20','12:50:00',15.24),('6449','2013-06-20','12:55:00',15.14),('6449','2013-06-20','13:00:00',15.09),('6449','2013-06-20','13:05:00',15.14),('6449','2013-06-20','13:10:00',15.18),('6449','2013-06-20','13:15:00',15.21),('6449','2013-06-20','13:20:00',15.2),('6449','2013-06-20','13:25:00',15.15),('6449','2013-06-20','13:30:00',14.95),('6449','2013-06-20','13:35:00',14.94),('6449','2013-06-20','13:40:00',14.87),('6449','2013-06-20','13:45:00',14.85),('6449','2013-06-20','13:50:00',14.9),('6449','2013-06-20','13:55:00',14.89),('6449','2013-06-20','14:00:00',14.78),('6449','2013-06-20','14:05:00',14.9),('6449','2013-06-20','14:10:00',14.98),('6449','2013-06-20','14:15:00',14.89),('6449','2013-06-20','14:20:00',14.8),('6449','2013-06-20','14:25:00',14.79),('6449','2013-06-20','14:30:00',14.55),('6449','2013-06-20','14:35:00',14.66),('6449','2013-06-20','14:40:00',14.53),('6449','2013-06-20','14:45:00',14.32),('6449','2013-06-20','14:50:00',14.2),('6449','2013-06-20','14:55:00',14.05),('6449','2013-06-20','15:00:00',13.93),('6449','2013-06-20','15:05:00',13.74),('6449','2013-06-20','15:10:00',13.47),('6449','2013-06-20','15:15:00',13.19),('6449','2013-06-20','15:20:00',13.29),('6449','2013-06-20','15:25:00',12.93),('6449','2013-06-20','15:30:00',12.83),('6449','2013-06-20','15:35:00',12.78),('6449','2013-06-20','15:40:00',12.62),('6449','2013-06-20','15:45:00',12.23),('6449','2013-06-20','15:50:00',12.08),('6449','2013-06-20','15:55:00',11.89),('6449','2013-06-20','16:00:00',11.72),('6449','2013-06-20','16:05:00',11.61),('6449','2013-06-20','16:10:00',11.43),('6449','2013-06-20','16:15:00',10.99),('6449','2013-06-20','16:20:00',10.74),('6449','2013-06-20','16:25:00',10.66),('6449','2013-06-20','16:30:00',10.52),('6449','2013-06-20','16:35:00',10.22),('6449','2013-06-20','16:40:00',9.78),('6449','2013-06-20','16:45:00',9.53),('6449','2013-06-20','16:50:00',9.19),('6449','2013-06-20','16:55:00',8.94),('6449','2013-06-19','06:45:00',1.03),('6449','2013-06-19','06:50:00',1.2),('6449','2013-06-19','06:55:00',1.38),('6449','2013-06-19','07:00:00',1.59),('6449','2013-06-19','07:05:00',1.79),('6449','2013-06-19','07:10:00',1.76),('6449','2013-06-19','07:15:00',2.26),('6449','2013-06-19','07:20:00',2.5),('6449','2013-06-19','07:25:00',2.79),('6449','2013-06-19','07:30:00',3.08),('6449','2013-06-19','07:35:00',3.38),('6449','2013-06-19','07:40:00',3.66),('6449','2013-06-19','07:45:00',3.97),('6449','2013-06-19','07:50:00',4.26),('6449','2013-06-19','07:55:00',4.53),('6449','2013-06-19','08:00:00',4.81),('6449','2013-06-19','08:05:00',5.12),('6449','2013-06-19','08:10:00',5.41),('6449','2013-06-19','08:15:00',5.66),('6449','2013-06-19','08:20:00',6.02),('6449','2013-06-19','08:25:00',6.29),('6449','2013-06-19','08:30:00',6.46),('6449','2013-06-19','08:35:00',6.83),('6449','2013-06-19','08:40:00',7.14),('6449','2013-06-19','08:45:00',7.39),('6449','2013-06-19','08:50:00',7.72),('6449','2013-06-19','08:55:00',7.9),('6449','2013-06-19','09:00:00',8.04),('6449','2013-06-19','09:05:00',8.38),('6449','2013-06-19','09:10:00',8.6),('6449','2013-06-19','09:15:00',8.9),('6449','2013-06-19','09:20:00',9.22),('6449','2013-06-19','09:25:00',9.39),('6449','2013-06-19','09:30:00',9.63),('6449','2013-06-19','09:35:00',9.85),('6449','2013-06-19','09:40:00',10.05),('6449','2013-06-19','09:45:00',10.22),('6449','2013-06-19','09:50:00',10.54),('6449','2013-06-19','09:55:00',10.67),('6449','2013-06-19','10:00:00',11.04),('6449','2013-06-19','10:05:00',10.98),('6449','2013-06-19','10:10:00',11.36),('6449','2013-06-19','10:15:00',11.61),('6449','2013-06-19','10:20:00',12.04),('6449','2013-06-19','10:25:00',12.22),('6449','2013-06-19','10:30:00',12.33),('6449','2013-06-19','10:35:00',12.67),('6449','2013-06-19','10:40:00',12.83),('6449','2013-06-19','10:45:00',12.96),('6449','2013-06-19','10:50:00',13.24),('6449','2013-06-19','10:55:00',13.42),('6449','2013-06-19','11:00:00',13.53),('6449','2013-06-19','11:05:00',13.74),('6449','2013-06-19','11:10:00',13.86),('6449','2013-06-19','11:15:00',13.92),('6449','2013-06-19','11:20:00',14.08),('6449','2013-06-19','11:25:00',14.16),('6449','2013-06-19','11:30:00',14.39),('6449','2013-06-19','11:35:00',14.58),('6449','2013-06-19','11:40:00',14.58),('6449','2013-06-19','11:45:00',14.67),('6449','2013-06-19','11:50:00',14.5),('6449','2013-06-19','11:55:00',14.82),('6449','2013-06-19','12:00:00',14.83),('6449','2013-06-19','12:05:00',14.96),('6449','2013-06-19','12:10:00',15.01),('6449','2013-06-19','12:15:00',15.1),('6449','2013-06-19','12:20:00',15.1),('6449','2013-06-19','12:25:00',15.18),('6449','2013-06-19','12:30:00',15.31),('6449','2013-06-19','12:35:00',15.37),('6449','2013-06-19','12:40:00',15.46),('6449','2013-06-19','12:45:00',15.43),('6449','2013-06-19','12:50:00',15.41),('6449','2013-06-19','12:55:00',15.43),('6449','2013-06-19','13:00:00',15.51),('6449','2013-06-19','13:05:00',15.48),('6449','2013-06-19','13:10:00',15.58),('6449','2013-06-19','13:15:00',15.54),('6449','2013-06-19','13:20:00',15.54),('6449','2013-06-19','13:25:00',15.42),('6449','2013-06-19','13:30:00',15.37),('6449','2013-06-19','13:35:00',15.1),('6449','2013-06-19','13:40:00',15.37),('6449','2013-06-19','13:45:00',15.15),('6449','2013-06-19','13:50:00',15.36),('6449','2013-06-19','13:55:00',15.21),('6449','2013-06-19','14:00:00',15.09),('6449','2013-06-19','14:05:00',14.99),('6449','2013-06-19','14:10:00',14.93),('6449','2013-06-19','14:15:00',14.73),('6449','2013-06-19','14:20:00',14.85),('6449','2013-06-19','14:25:00',14.65),('6449','2013-06-19','14:30:00',14.45),('6449','2013-06-19','14:35:00',14.23),('6449','2013-06-19','14:40:00',14.03),('6449','2013-06-19','14:45:00',13.96),('6449','2013-06-19','14:50:00',13.74),('6449','2013-06-19','14:55:00',13.56),('6449','2013-06-19','15:00:00',13.51),('6449','2013-06-19','15:05:00',13.4),('6449','2013-06-19','15:10:00',13.2),('6449','2013-06-19','15:15:00',13.06),('6449','2013-06-19','15:20:00',12.77),('6449','2013-06-19','15:25:00',12.83),('6449','2013-06-19','15:30:00',10.92),('6449','2013-06-19','15:35:00',12.44),('6449','2013-06-19','15:40:00',12.28),('6449','2013-06-19','15:45:00',12.09),('6449','2013-06-19','15:50:00',11.97),('6449','2013-06-19','15:55:00',11.71),('6449','2013-06-19','16:00:00',11.39),('6449','2013-06-19','16:05:00',11.39),('6449','2013-06-19','16:10:00',11.02),('6449','2013-06-19','16:15:00',10.68),('6449','2013-06-19','16:20:00',10.62),('6449','2013-06-19','16:25:00',10.45),('6449','2013-06-19','16:30:00',10.19),('6449','2013-06-19','16:35:00',9.94),('6449','2013-06-19','16:40:00',9.57),('6449','2013-06-19','16:45:00',9.5),('6449','2013-06-19','16:50:00',9.21),('6449','2013-06-19','16:55:00',8.83),('6449','2013-06-19','17:00:00',8.55),('6449','2013-06-19','17:05:00',8.29),('6449','2013-06-19','17:10:00',8.06),('6449','2013-06-19','17:15:00',7.69),('6449','2013-06-19','17:20:00',7.47),('6449','2013-06-19','17:25:00',7.13),('6449','2013-06-19','17:30:00',6.79),('6449','2013-06-19','17:35:00',6.41),('6449','2013-06-19','17:40:00',6.17),('6449','2013-06-19','17:45:00',5.73),('6449','2013-06-19','17:50:00',5.51),('6449','2013-06-19','17:55:00',5.06),('6449','2013-06-19','18:00:00',4.82),('6449','2013-06-19','18:05:00',4.44),('6449','2013-06-19','18:10:00',4.19),('6449','2013-06-19','18:15:00',3.86),('6449','2013-06-19','18:20:00',3.58),('6449','2013-06-19','18:25:00',3.32),('6449','2013-06-19','18:30:00',3.02),('6449','2013-06-19','18:35:00',2.71),('6449','2013-06-19','18:40:00',2.44),('6449','2013-06-19','18:45:00',2.21),('6449','2013-06-19','18:50:00',1.94),('6449','2013-06-19','18:55:00',1.73),('6449','2013-06-19','19:00:00',1.51),('6449','2013-06-19','19:05:00',1.33),('6449','2013-06-19','19:10:00',1.15),('6449','2013-06-18','06:45:00',1.07),('6449','2013-06-18','06:50:00',1.24),('6449','2013-06-18','06:55:00',1.41),('6449','2013-06-18','07:00:00',1.59),('6449','2013-06-18','07:05:00',1.78),('6449','2013-06-18','07:10:00',2.04),('6449','2013-06-18','07:15:00',2.27),('6449','2013-06-18','07:20:00',2.5),('6449','2013-06-18','07:25:00',2.81),('6449','2013-06-18','07:30:00',3.1),('6449','2013-06-18','07:35:00',3.38),('6449','2013-06-18','07:40:00',3.71),('6449','2013-06-18','07:45:00',4),('6449','2013-06-18','07:50:00',4.28),('6449','2013-06-18','07:55:00',4.63),('6449','2013-06-18','08:00:00',4.92),('6449','2013-06-18','08:05:00',5.22),('6449','2013-06-18','08:10:00',5.55),('6449','2013-06-18','08:15:00',5.82),('6449','2013-06-18','08:20:00',6.06),('6449','2013-06-18','08:25:00',5.68),('6449','2013-06-18','08:30:00',6.69),('6449','2013-06-18','08:35:00',7.07),('6449','2013-06-18','08:40:00',7.37),('6449','2013-06-18','08:45:00',7.59),('6449','2013-06-18','08:50:00',7.82),('6449','2013-06-18','08:55:00',8.11),('6449','2013-06-18','09:00:00',8.37),('6449','2013-06-18','09:05:00',8.68),('6449','2013-06-18','09:10:00',8.83),('6449','2013-06-18','09:15:00',9.29),('6449','2013-06-18','09:20:00',9.45),('6449','2013-06-18','09:25:00',9.75),('6449','2013-06-18','09:30:00',10.01),('6449','2013-06-18','09:35:00',10.14),('6449','2013-06-18','09:40:00',10.35),('6449','2013-06-18','09:45:00',10.69),('6449','2013-06-18','09:50:00',10.9),('6449','2013-06-18','09:55:00',11.01),('6449','2013-06-18','10:00:00',11.45),('6449','2013-06-18','10:05:00',11.32),('6449','2013-06-18','10:10:00',11.68),('6449','2013-06-18','10:15:00',11.89),('6449','2013-06-18','10:20:00',12.06),('6449','2013-06-18','10:25:00',12.21),('6449','2013-06-18','10:30:00',12.33),('6449','2013-06-18','10:35:00',12.49),('6449','2013-06-18','10:40:00',12.38),('6449','2013-06-18','10:45:00',12.59),('6449','2013-06-18','10:50:00',10.99),('6449','2013-06-18','10:55:00',12.67),('6449','2013-06-18','11:00:00',11.24),('6449','2013-06-18','11:05:00',12.84),('6449','2013-06-18','11:10:00',13.14),('6449','2013-06-18','11:15:00',13.15),('6449','2013-06-18','11:20:00',13.27),('6449','2013-06-18','11:25:00',13.38),('6449','2013-06-18','11:30:00',13.38),('6449','2013-06-18','11:35:00',14.04),('6449','2013-06-18','11:40:00',14.25),('6449','2013-06-18','11:45:00',14.27),('6449','2013-06-18','11:50:00',14.17),('6449','2013-06-18','11:55:00',14.29),('6449','2013-06-18','12:00:00',14.42),('6449','2013-06-18','12:05:00',14.48),('6449','2013-06-18','12:10:00',14.51),('6449','2013-06-18','12:15:00',14.63),('6449','2013-06-18','12:20:00',14.65),('6449','2013-06-18','12:25:00',14.6),('6449','2013-06-18','12:30:00',14.63),('6449','2013-06-18','12:35:00',14.6),('6449','2013-06-18','12:40:00',14.66),('6449','2013-06-18','12:45:00',14.67),('6449','2013-06-18','12:50:00',14.58),('6449','2013-06-18','12:55:00',14.83),('6449','2013-06-18','13:00:00',14.88),('6449','2013-06-18','13:05:00',14.87),('6449','2013-06-18','13:10:00',14.9),('6449','2013-06-18','13:15:00',14.66),('6449','2013-06-18','13:20:00',14.88),('6449','2013-06-18','13:25:00',14.98),('6449','2013-06-18','13:30:00',15.03),('6449','2013-06-18','13:35:00',15.01),('6449','2013-06-18','13:40:00',15.08),('6449','2013-06-18','13:45:00',15.01),('6449','2013-06-18','13:50:00',14.99),('6449','2013-06-18','13:55:00',14.93),('6449','2013-06-18','14:00:00',14.83),('6449','2013-06-18','14:05:00',14.67),('6449','2013-06-18','14:10:00',14.64),('6449','2013-06-18','14:15:00',14.6),('6449','2013-06-18','14:20:00',14.62),('6449','2013-06-18','14:25:00',14.6),('6449','2013-06-18','14:30:00',14.53),('6449','2013-06-18','14:35:00',14.4),('6449','2013-06-18','14:40:00',14.53),('6449','2013-06-18','14:45:00',12.29),('6449','2013-06-18','14:50:00',12.88),('6449','2013-06-18','14:55:00',14.39),('6449','2013-06-18','15:00:00',14.44),('6449','2013-06-18','15:05:00',14.42),('6449','2013-06-18','15:10:00',14.36),('6449','2013-06-18','15:15:00',14.25),('6449','2013-06-18','15:20:00',13.88),('6449','2013-06-18','15:25:00',13.82),('6449','2013-06-18','15:30:00',13.53),('6449','2013-06-18','15:35:00',13.16),('6449','2013-06-18','15:40:00',12.99),('6449','2013-06-18','15:45:00',12.65),('6449','2013-06-18','15:50:00',12.39),('6449','2013-06-18','15:55:00',12.07),('6449','2013-06-18','16:00:00',11.7),('6449','2013-06-18','16:05:00',11.53),('6449','2013-06-18','16:10:00',11.3),('6449','2013-06-18','16:15:00',11.09),('6449','2013-06-18','16:20:00',10.74),('6449','2013-06-18','16:25:00',10.55),('6449','2013-06-18','16:30:00',10.31),('6449','2013-06-18','16:35:00',10.08),('6449','2013-06-18','16:40:00',9.77),('6449','2013-06-18','16:45:00',9.64),('6449','2013-06-18','16:50:00',9.35),('6449','2013-06-18','16:55:00',9.14),('6449','2013-06-18','17:00:00',8.82),('6449','2013-06-18','17:05:00',8.46),('6449','2013-06-18','17:10:00',8.28),('6449','2013-06-18','17:15:00',7.84),('6449','2013-06-18','17:20:00',7.44),('6449','2013-06-18','17:25:00',7.1),('6449','2013-06-18','17:30:00',6.77),('6449','2013-06-18','17:35:00',5.58),('6449','2013-06-18','17:40:00',6.22),('6449','2013-06-18','17:45:00',3.72),('6449','2013-06-18','17:50:00',4.37),('6449','2013-06-18','17:55:00',3.9),('6449','2013-06-18','18:00:00',4.77),('6449','2013-06-18','18:05:00',4.5),('6449','2013-06-18','18:10:00',4.18),('6449','2013-06-18','18:15:00',3.91),('6449','2013-06-18','18:20:00',3.61),('6449','2013-06-18','18:25:00',3.3),('6449','2013-06-18','18:30:00',3.02),('6449','2013-06-18','18:35:00',2.76),('6449','2013-06-18','18:40:00',2.47),('6449','2013-06-18','18:45:00',2.23),('6449','2013-06-18','18:50:00',1.98),('6449','2013-06-18','18:55:00',1.7),('6449','2013-06-18','19:00:00',1.53),('6449','2013-06-18','19:05:00',1.33),('6449','2013-06-18','19:10:00',1.15),('6449','2013-06-17','06:45:00',1.12),('6449','2013-06-17','06:50:00',1.32),('6449','2013-06-17','06:55:00',1.49),('6449','2013-06-17','07:00:00',1.71),('6449','2013-06-17','07:05:00',1.93),('6449','2013-06-17','07:10:00',2.16),('6449','2013-06-17','07:15:00',2.43),('6449','2013-06-17','07:20:00',2.7),('6449','2013-06-17','07:25:00',2.96),('6449','2013-06-17','07:30:00',3.26),('6449','2013-06-17','07:35:00',2.22),('6449','2013-06-17','07:40:00',3.86),('6449','2013-06-17','07:45:00',4.24),('6449','2013-06-17','07:50:00',4.48),('6449','2013-06-17','07:55:00',4.82),('6449','2013-06-17','08:00:00',5.17),('6449','2013-06-17','08:05:00',5.43),('6449','2013-06-17','08:10:00',5.77),('6449','2013-06-17','08:15:00',6.08),('6449','2013-06-17','08:20:00',6.35),('6449','2013-06-17','08:25:00',6.67),('6449','2013-06-17','08:30:00',6.88),('6449','2013-06-17','08:35:00',7.25),('6449','2013-06-17','08:40:00',7.6),('6449','2013-06-17','08:45:00',7.86),('6449','2013-06-17','08:50:00',8.21),('6449','2013-06-17','08:55:00',8.43),('6449','2013-06-17','09:00:00',8.69),('6449','2013-06-17','09:05:00',8.97),('6449','2013-06-17','09:10:00',9.32),('6449','2013-06-17','09:15:00',9.47),('6449','2013-06-17','09:20:00',9.78),('6449','2013-06-17','09:25:00',9.93),('6449','2013-06-17','09:30:00',10.27),('6449','2013-06-17','09:35:00',10.5),('6449','2013-06-17','09:40:00',10.61),('6449','2013-06-17','09:45:00',10.84),('6449','2013-06-17','09:50:00',10.96),('6449','2013-06-17','09:55:00',11.17),('6449','2013-06-17','10:00:00',11.42),('6449','2013-06-17','10:05:00',11.63),('6449','2013-06-17','10:10:00',12.02),('6449','2013-06-17','10:15:00',12.31),('6449','2013-06-17','10:20:00',12.31),('6449','2013-06-17','10:25:00',12.59),('6449','2013-06-17','10:30:00',12.9),('6449','2013-06-17','10:35:00',13.02),('6449','2013-06-17','10:40:00',13.13),('6449','2013-06-17','10:45:00',13.31),('6449','2013-06-17','10:50:00',13.42),('6449','2013-06-17','10:55:00',13.64),('6449','2013-06-17','11:00:00',13.74),('6449','2013-06-17','11:05:00',13.79),('6449','2013-06-17','11:10:00',14.01),('6449','2013-06-17','11:15:00',14.15),('6449','2013-06-17','11:20:00',14.25),('6449','2013-06-17','11:25:00',14.38),('6449','2013-06-17','11:30:00',14.45),('6449','2013-06-17','11:35:00',14.48),('6449','2013-06-17','11:40:00',14.7),('6449','2013-06-17','11:45:00',14.82),('6449','2013-06-17','11:50:00',14.93),('6449','2013-06-17','11:55:00',15),('6449','2013-06-17','12:00:00',15.06),('6449','2013-06-17','12:05:00',14.99),('6449','2013-06-17','12:10:00',14.9),('6449','2013-06-17','12:15:00',15.1),('6449','2013-06-17','12:20:00',15.18),('6449','2013-06-17','12:25:00',15.17),('6449','2013-06-17','12:30:00',15.15),('6449','2013-06-17','12:35:00',15.23),('6449','2013-06-17','12:40:00',15.29),('6449','2013-06-17','12:45:00',15.24),('6449','2013-06-17','12:50:00',15.14),('6449','2013-06-17','12:55:00',15.3),('6449','2013-06-17','13:00:00',15.29),('6449','2013-06-17','13:05:00',15.32),('6449','2013-06-17','13:10:00',15.26),('6449','2013-06-17','13:15:00',15.25),('6449','2013-06-17','13:20:00',15.25),('6449','2013-06-17','13:25:00',15.24),('6449','2013-06-17','13:30:00',15.23),('6449','2013-06-17','13:35:00',15.21),('6449','2013-06-17','13:40:00',15.16),('6449','2013-06-17','13:45:00',15.07),('6449','2013-06-17','13:50:00',14.95),('6449','2013-06-17','13:55:00',14.74),('6449','2013-06-17','14:00:00',14.89),('6449','2013-06-17','14:05:00',14.82),('6449','2013-06-17','14:10:00',14.77),('6449','2013-06-17','14:15:00',14.77),('6449','2013-06-17','14:20:00',14.63),('6449','2013-06-17','14:25:00',14.5),('6449','2013-06-17','14:30:00',14.4),('6449','2013-06-17','14:35:00',14.21),('6449','2013-06-17','14:40:00',14.1),('6449','2013-06-17','14:45:00',13.95),('6449','2013-06-17','14:50:00',13.77),('6449','2013-06-17','14:55:00',13.62),('6449','2013-06-17','15:00:00',13.53),('6449','2013-06-17','15:05:00',13.36),('6449','2013-06-17','15:10:00',13.3),('6449','2013-06-17','15:15:00',13.12),('6449','2013-06-17','15:20:00',12.97),('6449','2013-06-17','15:25:00',12.77),('6449','2013-06-17','15:30:00',12.69),('6449','2013-06-17','15:35:00',12.45),('6449','2013-06-17','15:40:00',12.25),('6449','2013-06-17','15:45:00',12.01),('6449','2013-06-17','15:50:00',11.93),('6449','2013-06-17','15:55:00',11.75),('6449','2013-06-17','16:00:00',11.53),('6449','2013-06-17','16:05:00',11.34),('6449','2013-06-17','16:10:00',11.07),('6449','2013-06-17','16:15:00',10.94),('6449','2013-06-17','16:20:00',10.65),('6449','2013-06-17','16:25:00',10.26),('6449','2013-06-17','16:30:00',10.16),('6449','2013-06-17','16:35:00',9.9),('6449','2013-06-17','16:40:00',9.58),('6449','2013-06-17','16:45:00',9.39),('6449','2013-06-17','16:50:00',9.13),('6449','2013-06-17','16:55:00',8.92),('6449','2013-06-17','17:00:00',8.57),('6449','2013-06-17','17:05:00',8.39),('6449','2013-06-17','17:10:00',8.01),('6449','2013-06-17','17:15:00',7.73),('6449','2013-06-17','17:20:00',7.49),('6449','2013-06-17','17:25:00',7.05),('6449','2013-06-17','17:30:00',6.78),('6449','2013-06-17','17:35:00',6.6),('6449','2013-06-17','17:40:00',6.31),('6449','2013-06-17','17:45:00',5.96),('6449','2013-06-17','17:50:00',5.68),('6449','2013-06-17','17:55:00',5.33),('6449','2013-06-17','18:00:00',4.96),('6449','2013-06-17','18:05:00',4.63),('6449','2013-06-17','18:10:00',4.31),('6449','2013-06-17','18:15:00',4.05),('6449','2013-06-17','18:20:00',3.73),('6449','2013-06-17','18:25:00',3.45),('6449','2013-06-17','18:30:00',3.12),('6449','2013-06-17','18:35:00',2.83),('6449','2013-06-17','18:40:00',2.53),('6449','2013-06-17','18:45:00',2.26),('6449','2013-06-17','18:50:00',2.02),('6449','2013-06-17','18:55:00',1.78),('6449','2013-06-17','19:00:00',1.59),('6449','2013-06-17','19:05:00',1.38),('6449','2013-06-17','19:10:00',1.19),('6449','2013-06-17','19:15:00',1.05),('6449','2013-06-16','06:45:00',1.09),('6449','2013-06-16','06:50:00',1.32),('6449','2013-06-16','06:55:00',1.51),('6449','2013-06-16','07:00:00',1.71),('6449','2013-06-16','07:05:00',1.94),('6449','2013-06-16','07:10:00',2.23),('6449','2013-06-16','07:15:00',2.49),('6449','2013-06-16','07:20:00',2.76),('6449','2013-06-16','07:25:00',3.06),('6449','2013-06-16','07:30:00',3.33),('6449','2013-06-16','07:35:00',3.66),('6449','2013-06-16','07:40:00',3.98),('6449','2013-06-16','07:45:00',4.29),('6449','2013-06-16','07:50:00',4.66),('6449','2013-06-16','07:55:00',4.97),('6449','2013-06-16','08:00:00',5.25),('6449','2013-06-16','08:05:00',5.59),('6449','2013-06-16','08:10:00',5.94),('6449','2013-06-16','08:15:00',6.16),('6449','2013-06-16','08:20:00',6.48),('6449','2013-06-16','08:25:00',6.71),('6449','2013-06-16','08:30:00',6.99),('6449','2013-06-16','08:35:00',7.15),('6449','2013-06-16','08:40:00',7.73),('6449','2013-06-16','08:45:00',7.93),('6449','2013-06-16','08:50:00',8.38),('6449','2013-06-16','08:55:00',7.47),('6449','2013-06-16','09:00:00',8.66),('6449','2013-06-16','09:05:00',9.15),('6449','2013-06-16','09:10:00',9.11),('6449','2013-06-16','09:15:00',9.44),('6449','2013-06-16','09:20:00',9.89),('6449','2013-06-16','09:25:00',9.97),('6449','2013-06-16','09:30:00',10.08),('6449','2013-06-16','09:35:00',10.36),('6449','2013-06-16','09:40:00',10.62),('6449','2013-06-16','09:45:00',10.87),('6449','2013-06-16','09:50:00',11.02),('6449','2013-06-16','09:55:00',11.31),('6449','2013-06-16','10:00:00',11.5),('6449','2013-06-16','10:05:00',11.72),('6449','2013-06-16','10:10:00',12.04),('6449','2013-06-16','10:15:00',12.04),('6449','2013-06-16','10:20:00',12.62),('6449','2013-06-16','10:25:00',12.84),('6449','2013-06-16','10:30:00',13.06),('6449','2013-06-16','10:35:00',13.16),('6449','2013-06-16','10:40:00',13.48),('6449','2013-06-16','10:45:00',13.48),('6449','2013-06-16','10:50:00',13.77),('6449','2013-06-16','10:55:00',13.94),('6449','2013-06-16','11:00:00',14.15),('6449','2013-06-16','11:05:00',14.22),('6449','2013-06-16','11:10:00',14.28),('6449','2013-06-16','11:15:00',14.41),('6449','2013-06-16','11:20:00',14.56),('6449','2013-06-16','11:25:00',14.67),('6449','2013-06-16','11:30:00',14.87),('6449','2013-06-16','11:35:00',15.02),('6449','2013-06-16','11:40:00',15.07),('6449','2013-06-16','11:45:00',15.19),('6449','2013-06-16','11:50:00',15.29),('6449','2013-06-16','11:55:00',15.45),('6449','2013-06-16','12:00:00',15.42),('6449','2013-06-16','12:05:00',15.41),('6449','2013-06-16','12:10:00',15.7),('6449','2013-06-16','12:15:00',15.66),('6449','2013-06-16','12:20:00',15.63),('6449','2013-06-16','12:25:00',15.67),('6449','2013-06-16','12:30:00',15.76),('6449','2013-06-16','12:35:00',15.73),('6449','2013-06-16','12:40:00',15.76),('6449','2013-06-16','12:45:00',15.8),('6449','2013-06-16','12:50:00',15.7),('6449','2013-06-16','12:55:00',15.68),('6449','2013-06-16','13:00:00',15.78),('6449','2013-06-16','13:05:00',15.74),('6449','2013-06-16','13:10:00',15.85),('6449','2013-06-16','13:15:00',15.76),('6449','2013-06-16','13:20:00',15.75),('6449','2013-06-16','13:25:00',15.71),('6449','2013-06-16','13:30:00',15.65),('6449','2013-06-16','13:35:00',15.52),('6449','2013-06-16','13:40:00',15.48),('6449','2013-06-16','13:45:00',15.36),('6449','2013-06-16','13:50:00',15.31),('6449','2013-06-16','13:55:00',15.44),('6449','2013-06-16','14:00:00',15.37),('6449','2013-06-16','14:05:00',15.26),('6449','2013-06-16','14:10:00',15.15),('6449','2013-06-16','14:15:00',15.06),('6449','2013-06-16','14:20:00',14.84),('6449','2013-06-16','14:25:00',14.96),('6449','2013-06-16','14:30:00',14.77),('6449','2013-06-16','14:35:00',12.81),('6449','2013-06-16','14:40:00',12.68),('6449','2013-06-16','14:45:00',14.28),('6449','2013-06-16','14:50:00',14.25),('6449','2013-06-16','14:55:00',14.02),('6449','2013-06-16','15:00:00',13.94),('6449','2013-06-16','15:05:00',13.84),('6449','2013-06-16','15:10:00',13.55),('6449','2013-06-16','15:15:00',13.61),('6449','2013-06-16','15:20:00',13.42),('6449','2013-06-16','15:25:00',13.2),('6449','2013-06-16','15:30:00',13.06),('6449','2013-06-16','15:35:00',12.91),('6449','2013-06-16','15:40:00',12.61),('6449','2013-06-16','15:45:00',12.53),('6449','2013-06-16','15:50:00',12.1),('6449','2013-06-16','15:55:00',11.98),('6449','2013-06-16','16:00:00',11.77),('6449','2013-06-16','16:05:00',11.54),('6449','2013-06-16','16:10:00',11.19),('6449','2013-06-16','16:15:00',10.99),('6449','2013-06-16','16:20:00',10.71),('6449','2013-06-16','16:25:00',10.37),('6449','2013-06-16','16:30:00',10.16),('6449','2013-06-16','16:35:00',9.92),('6449','2013-06-16','16:40:00',9.74),('6449','2013-06-16','16:45:00',9.31),('6449','2013-06-16','16:50:00',9.01),('6449','2013-06-16','16:55:00',8.62),('6449','2013-06-16','17:00:00',8.46),('6449','2013-06-16','17:05:00',7.25),('6449','2013-06-16','17:10:00',6.98),('6449','2013-06-16','17:15:00',6.92),('6449','2013-06-16','17:20:00',6.98),('6449','2013-06-16','17:25:00',7.09),('6449','2013-06-16','17:30:00',6.72),('6449','2013-06-16','17:35:00',4.82),('6449','2013-06-16','17:40:00',4.61),('6449','2013-06-16','17:45:00',5.78),('6449','2013-06-16','17:50:00',5.39),('6449','2013-06-16','17:55:00',5.09),('6449','2013-06-16','18:00:00',4.79),('6449','2013-06-16','18:05:00',4.45),('6449','2013-06-16','18:10:00',4.17),('6449','2013-06-16','18:15:00',3.89),('6449','2013-06-16','18:20:00',3.57),('6449','2013-06-16','18:25:00',3.27),('6449','2013-06-16','18:30:00',2.97),('6449','2013-06-16','18:35:00',2.7),('6449','2013-06-16','18:40:00',2.41),('6449','2013-06-16','18:45:00',2.15),('6449','2013-06-16','18:50:00',1.92),('6449','2013-06-16','18:55:00',1.7),('6449','2013-06-16','19:00:00',1.49),('6449','2013-06-16','19:05:00',1.3),('6449','2013-06-16','19:10:00',1.12),('6449','2013-06-15','06:50:00',1.08),('6449','2013-06-15','06:55:00',1.29),('6449','2013-06-15','07:00:00',1.16),('6449','2013-06-15','07:05:00',1.13),('6449','2013-06-15','07:10:00',1.75),('6449','2013-06-15','07:15:00',1.72),('6449','2013-06-15','07:20:00',1.64),('6449','2013-06-15','07:25:00',1.7),('6449','2013-06-15','07:30:00',1.33),('6449','2013-06-15','07:35:00',1.52),('6449','2013-06-15','07:40:00',2.26),('6449','2013-06-15','07:45:00',2.85),('6449','2013-06-15','07:50:00',3.7),('6449','2013-06-15','07:55:00',5),('6449','2013-06-15','08:00:00',4.15),('6449','2013-06-15','08:05:00',4.08),('6449','2013-06-15','08:10:00',3.76),('6449','2013-06-15','08:15:00',3.36),('6449','2013-06-15','08:20:00',3.91),('6449','2013-06-15','08:25:00',3.64),('6449','2013-06-15','08:30:00',3.81),('6449','2013-06-15','08:35:00',4.22),('6449','2013-06-15','08:40:00',5.52),('6449','2013-06-15','08:45:00',8.75),('6449','2013-06-15','08:50:00',7.59),('6449','2013-06-15','08:55:00',6.59),('6449','2013-06-15','09:00:00',4.7),('6449','2013-06-15','09:05:00',6.77),('6449','2013-06-15','09:10:00',9.7),('6449','2013-06-15','09:15:00',7.75),('6449','2013-06-15','09:20:00',4.41),('6449','2013-06-15','09:25:00',3.41),('6449','2013-06-15','09:30:00',3.58),('6449','2013-06-15','09:35:00',4.25),('6449','2013-06-15','09:40:00',4.3),('6449','2013-06-15','09:45:00',4.19),('6449','2013-06-15','09:50:00',4.21),('6449','2013-06-15','09:55:00',4.74),('6449','2013-06-15','10:00:00',5.47),('6449','2013-06-15','10:05:00',13.13),('6449','2013-06-15','10:10:00',12.74),('6449','2013-06-15','10:15:00',11.69),('6449','2013-06-15','10:20:00',11.19),('6449','2013-06-15','10:25:00',12.74),('6449','2013-06-15','10:30:00',12.19),('6449','2013-06-15','10:35:00',13.6),('6449','2013-06-15','10:40:00',13.62),('6449','2013-06-15','10:45:00',13.79),('6449','2013-06-15','10:50:00',13.86),('6449','2013-06-15','10:55:00',14.2),('6449','2013-06-15','11:00:00',14.11),('6449','2013-06-15','11:05:00',14.51),('6449','2013-06-15','11:10:00',14.53),('6449','2013-06-15','11:15:00',13.86),('6449','2013-06-15','11:20:00',14.72),('6449','2013-06-15','11:25:00',15.08),('6449','2013-06-15','11:30:00',14.86),('6449','2013-06-15','11:35:00',13.34),('6449','2013-06-15','11:40:00',13.44),('6449','2013-06-15','11:45:00',14.55),('6449','2013-06-15','11:50:00',15.35),('6449','2013-06-15','11:55:00',15.36),('6449','2013-06-15','12:00:00',15.32),('6449','2013-06-15','12:05:00',15.59),('6449','2013-06-15','12:10:00',14.56),('6449','2013-06-15','12:15:00',13.88),('6449','2013-06-15','12:20:00',16.11),('6449','2013-06-15','12:25:00',14.57),('6449','2013-06-15','12:30:00',15.02),('6449','2013-06-15','12:35:00',15.78),('6449','2013-06-15','12:40:00',15.74),('6449','2013-06-15','12:45:00',15.75),('6449','2013-06-15','12:50:00',15.87),('6449','2013-06-15','12:55:00',15.75),('6449','2013-06-15','13:00:00',15.92),('6449','2013-06-15','13:05:00',15.77),('6449','2013-06-15','13:10:00',13.88),('6449','2013-06-15','13:15:00',14.88),('6449','2013-06-15','13:20:00',13.15),('6449','2013-06-15','13:25:00',15.49),('6449','2013-06-15','13:30:00',15.63),('6449','2013-06-15','13:35:00',15.69),('6449','2013-06-15','13:40:00',14.65),('6449','2013-06-15','13:45:00',13.88),('6449','2013-06-15','13:50:00',8.99),('6449','2013-06-15','13:55:00',9.43),('6449','2013-06-15','14:00:00',10.01),('6449','2013-06-15','14:05:00',15.5),('6449','2013-06-15','14:10:00',12.22),('6449','2013-06-15','14:15:00',13.52),('6449','2013-06-15','14:20:00',9.99),('6449','2013-06-15','14:25:00',11.75),('6449','2013-06-15','14:30:00',14.02),('6449','2013-06-15','14:35:00',14.95),('6449','2013-06-15','14:40:00',13.19),('6449','2013-06-15','14:45:00',11.6),('6449','2013-06-15','14:50:00',13.57),('6449','2013-06-15','14:55:00',14.13),('6449','2013-06-15','15:00:00',14),('6449','2013-06-15','15:05:00',13.68),('6449','2013-06-15','15:10:00',13.48),('6449','2013-06-15','15:15:00',13.38),('6449','2013-06-15','15:20:00',13.08),('6449','2013-06-15','15:25:00',12.94),('6449','2013-06-15','15:30:00',12.83),('6449','2013-06-15','15:35:00',12.68),('6449','2013-06-15','15:40:00',12.57),('6449','2013-06-15','15:45:00',12.21),('6449','2013-06-15','15:50:00',12.11),('6449','2013-06-15','15:55:00',11.6),('6449','2013-06-15','16:00:00',11.58),('6449','2013-06-15','16:05:00',11.34),('6449','2013-06-15','16:10:00',11.17),('6449','2013-06-15','16:15:00',10.94),('6449','2013-06-15','16:20:00',10.7),('6449','2013-06-15','16:25:00',10.34),('6449','2013-06-15','16:30:00',10.01),('6449','2013-06-15','16:35:00',9.11),('6449','2013-06-15','16:40:00',8.86),('6449','2013-06-15','16:45:00',9.25),('6449','2013-06-15','16:50:00',8.98),('6449','2013-06-15','16:55:00',8.72),('6449','2013-06-15','17:00:00',8.33),('6449','2013-06-15','17:05:00',8.14),('6449','2013-06-15','17:10:00',7.83),('6449','2013-06-15','17:15:00',7.6),('6449','2013-06-15','17:20:00',7.24),('6449','2013-06-15','17:25:00',6.99),('6449','2013-06-15','17:30:00',6.65),('6449','2013-06-15','17:35:00',6.44),('6449','2013-06-15','17:40:00',6.03),('6449','2013-06-15','17:45:00',5.71),('6449','2013-06-15','17:50:00',5.4),('6449','2013-06-15','17:55:00',5.04),('6449','2013-06-15','18:00:00',4.77),('6449','2013-06-15','18:05:00',4.46),('6449','2013-06-15','18:10:00',4.12),('6449','2013-06-15','18:15:00',3.83),('6449','2013-06-15','18:20:00',3.54),('6449','2013-06-15','18:25:00',3.24),('6449','2013-06-15','18:30:00',2.96),('6449','2013-06-15','18:35:00',2.7),('6449','2013-06-15','18:40:00',2.44),('6449','2013-06-15','18:45:00',2.19),('6449','2013-06-15','18:50:00',1.97),('6449','2013-06-15','18:55:00',1.73),('6449','2013-06-15','19:00:00',1.52),('6449','2013-06-15','19:05:00',1.33),('6449','2013-06-15','19:10:00',1.15),('6449','2013-06-14','06:50:00',1.2),('6449','2013-06-14','06:59:00',1.44),('6449','2013-06-14','07:00:00',1.84),('6449','2013-06-14','07:10:00',1.93),('6449','2013-06-14','07:15:00',2.56),('6449','2013-06-14','07:20:00',2.53),('6449','2013-06-14','07:29:00',2.89),('6449','2013-06-14','07:30:00',3.73),('6449','2013-06-14','07:39:00',3.81),('6449','2013-06-14','07:40:00',4.49),('6449','2013-06-14','07:49:00',4.45),('6449','2013-06-14','07:50:00',5.14),('6449','2013-06-14','07:59:00',5.36),('6449','2013-06-14','08:00:00',5.83),('6449','2013-06-14','08:09:00',6),('6449','2013-06-14','08:10:00',6.48),('6449','2013-06-14','08:19:00',6.59),('6449','2013-06-14','08:20:00',7.16),('6449','2013-06-14','08:29:00',7.36),('6449','2013-06-14','08:30:00',7.99),('6449','2013-06-14','08:39:00',8.08),('6449','2013-06-14','08:40:00',8.69),('6449','2013-06-14','08:49:00',8.72),('6449','2013-06-14','08:50:00',9.03),('6449','2013-06-14','08:55:00',9.15),('6449','2013-06-14','09:00:00',9.36),('6449','2013-06-14','09:05:00',9.69),('6449','2013-06-14','09:10:00',10.14),('6449','2013-06-14','09:15:00',10.21),('6449','2013-06-14','09:20:00',10.35),('6449','2013-06-14','09:25:00',10.52),('6449','2013-06-14','09:30:00',10.6),('6449','2013-06-14','09:35:00',10.89),('6449','2013-06-14','09:40:00',10.96),('6449','2013-06-14','09:45:00',11.31),('6449','2013-06-14','09:50:00',11.89),('6449','2013-06-14','09:55:00',12.07),('6449','2013-06-14','10:00:00',12.02),('6449','2013-06-14','10:05:00',12.22),('6449','2013-06-14','10:10:00',12.28),('6449','2013-06-14','10:15:00',12.57),('6449','2013-06-14','10:20:00',12.86),('6449','2013-06-14','10:25:00',12.84),('6449','2013-06-14','10:30:00',13.48),('6449','2013-06-14','10:35:00',12.67),('6449','2013-06-14','10:40:00',13.97),('6449','2013-06-14','10:45:00',13.65),('6449','2013-06-14','10:50:00',13.55),('6449','2013-06-14','10:55:00',13.99),('6449','2013-06-14','11:00:00',14.75),('6449','2013-06-14','11:05:00',15.09),('6449','2013-06-14','11:10:00',15.16),('6449','2013-06-14','11:15:00',14.88),('6449','2013-06-14','11:20:00',14.55),('6449','2013-06-14','11:25:00',14.89),('6449','2013-06-14','11:30:00',15.55),('6449','2013-06-14','11:35:00',15.53),('6449','2013-06-14','11:40:00',15.56),('6449','2013-06-14','11:45:00',15.51),('6449','2013-06-14','11:50:00',15.53),('6449','2013-06-14','11:55:00',15.62),('6449','2013-06-14','12:00:00',15.87),('6449','2013-06-14','12:05:00',16),('6449','2013-06-14','12:10:00',16.09),('6449','2013-06-14','12:15:00',16.04),('6449','2013-06-14','12:20:00',16.08),('6449','2013-06-14','12:25:00',16.24),('6449','2013-06-14','12:30:00',16.04),('6449','2013-06-14','12:35:00',16.21),('6449','2013-06-14','12:40:00',16.23),('6449','2013-06-14','12:45:00',16.26),('6449','2013-06-14','12:50:00',16.29),('6449','2013-06-14','12:55:00',16.39),('6449','2013-06-14','13:00:00',16.34),('6449','2013-06-14','13:05:00',16.38),('6449','2013-06-14','13:10:00',16.5),('6449','2013-06-14','13:15:00',16.37),('6449','2013-06-14','13:20:00',15.87),('6449','2013-06-14','13:25:00',15.91),('6449','2013-06-14','13:30:00',15.74),('6449','2013-06-14','13:35:00',15.96),('6449','2013-06-14','13:40:00',16.03),('6449','2013-06-14','13:45:00',15.98),('6449','2013-06-14','13:50:00',15.94),('6449','2013-06-14','13:55:00',15.83),('6449','2013-06-14','14:00:00',15.68),('6449','2013-06-14','14:05:00',15.6),('6449','2013-06-14','14:10:00',15.57),('6449','2013-06-14','14:15:00',15.37),('6449','2013-06-14','14:20:00',15.45),('6449','2013-06-14','14:25:00',15.35),('6449','2013-06-14','14:30:00',15.33),('6449','2013-06-14','14:35:00',15.14),('6449','2013-06-14','14:40:00',15.01),('6449','2013-06-14','14:45:00',14.59),('6449','2013-06-14','14:50:00',14.71),('6449','2013-06-14','14:55:00',14.51),('6449','2013-06-14','15:00:00',14.34),('6449','2013-06-14','15:05:00',14.28),('6449','2013-06-14','15:10:00',14.2),('6449','2013-06-14','15:15:00',14.16),('6449','2013-06-14','15:20:00',13.93),('6449','2013-06-14','15:25:00',13.63),('6449','2013-06-14','15:30:00',13.37),('6449','2013-06-14','15:35:00',13.39),('6449','2013-06-14','15:40:00',13.12),('6449','2013-06-14','15:45:00',12.96),('6449','2013-06-14','15:50:00',12.63),('6449','2013-06-14','15:55:00',12.45),('6449','2013-06-14','16:00:00',12.11),('6449','2013-06-14','16:05:00',12.03),('6449','2013-06-14','16:10:00',11.82),('6449','2013-06-14','16:15:00',11.46),('6449','2013-06-14','16:20:00',11.18),('6449','2013-06-14','16:25:00',10.8),('6449','2013-06-14','16:30:00',10.38),('6449','2013-06-14','16:35:00',10.1),('6449','2013-06-14','16:40:00',9.93),('6449','2013-06-14','16:45:00',9.5),('6449','2013-06-14','16:50:00',9.27),('6449','2013-06-14','16:55:00',9.13),('6449','2013-06-14','17:00:00',8.89),('6449','2013-06-14','17:05:00',8.55),('6449','2013-06-14','17:10:00',8.21),('6449','2013-06-14','17:15:00',7.88),('6449','2013-06-14','17:20:00',7.64),('6449','2013-06-14','17:25:00',7.26),('6449','2013-06-14','17:30:00',6.94),('6449','2013-06-14','17:35:00',6.6),('6449','2013-06-14','17:40:00',6.37),('6449','2013-06-14','17:45:00',5.9),('6449','2013-06-14','17:50:00',5.67),('6449','2013-06-14','17:55:00',5.36),('6449','2013-06-14','18:00:00',4.97),('6449','2013-06-14','18:05:00',4.61),('6449','2013-06-14','18:10:00',4.31),('6449','2013-06-14','18:15:00',3.97),('6449','2013-06-14','18:20:00',3.66),('6449','2013-06-14','18:25:00',3.34),('6449','2013-06-14','18:30:00',3.05),('6449','2013-06-14','18:35:00',2.75),('6449','2013-06-14','18:40:00',2.43),('6449','2013-06-14','18:45:00',2.17),('6449','2013-06-14','18:50:00',1.91),('6449','2013-06-14','18:55:00',1.67),('6449','2013-06-14','19:00:00',1.43),('6449','2013-06-14','19:05:00',1.24),('6449','2013-06-14','19:10:00',1.05),('6449','2013-06-07','06:50:00',1.04),('6449','2013-06-07','06:55:00',1.41),('6449','2013-06-07','07:00:00',1.67),('6449','2013-06-07','07:05:00',1.94),('6449','2013-06-07','07:10:00',2.27),('6449','2013-06-07','07:15:00',2.56),('6449','2013-06-07','07:20:00',2.88),('6449','2013-06-07','07:25:00',3.23),('6449','2013-06-07','07:30:00',3.57),('6449','2013-06-07','07:35:00',3.95),('6449','2013-06-07','07:40:00',4.31),('6449','2013-06-07','07:45:00',4.66),('6449','2013-06-07','07:50:00',5.05),('6449','2013-06-07','07:55:00',5.39),('6449','2013-06-07','08:00:00',5.75),('6449','2013-06-07','08:05:00',6.08),('6449','2013-06-07','08:10:00',6.46),('6449','2013-06-07','08:15:00',6.8),('6449','2013-06-07','08:20:00',7.12),('6449','2013-06-07','08:25:00',7.48),('6449','2013-06-07','08:30:00',7.8),('6449','2013-06-07','08:35:00',8.14),('6449','2013-06-07','08:40:00',8.5),('6449','2013-06-07','08:45:00',8.82),('6449','2013-06-07','08:50:00',8.92),('6449','2013-06-07','08:55:00',9.31),('6449','2013-06-07','09:00:00',9.65),('6449','2013-06-07','09:05:00',9.85),('6449','2013-06-07','09:10:00',10.18),('6449','2013-06-07','09:15:00',10.42),('6449','2013-06-07','09:20:00',10.9),('6449','2013-06-07','09:25:00',11.05),('6449','2013-06-07','09:30:00',11.36),('6449','2013-06-07','09:35:00',11.65),('6449','2013-06-07','09:40:00',11.86),('6449','2013-06-07','09:45:00',12.2),('6449','2013-06-07','09:50:00',12.32),('6449','2013-06-07','09:55:00',12.52),('6449','2013-06-07','10:00:00',12.77),('6449','2013-06-07','10:05:00',12.76),('6449','2013-06-07','10:10:00',13.32),('6449','2013-06-07','10:15:00',13.41),('6449','2013-06-07','10:20:00',13.68),('6449','2013-06-07','10:25:00',13.84),('6449','2013-06-07','10:30:00',14.02),('6449','2013-06-07','10:35:00',13.99),('6449','2013-06-07','10:40:00',14.2),('6449','2013-06-07','10:45:00',14.38),('6449','2013-06-07','10:50:00',14.49),('6449','2013-06-07','10:55:00',14.55),('6449','2013-06-07','11:00:00',14.64),('6449','2013-06-07','11:05:00',14.87),('6449','2013-06-07','11:10:00',15.02),('6449','2013-06-07','11:15:00',14.85),('6449','2013-06-07','11:20:00',14.92),('6449','2013-06-07','11:25:00',15.11),('6449','2013-06-07','11:30:00',15.15),('6449','2013-06-07','11:35:00',15.05),('6449','2013-06-07','11:40:00',15.02),('6449','2013-06-07','11:45:00',15.03),('6449','2013-06-07','11:50:00',15.26),('6449','2013-06-07','11:55:00',15.6),('6449','2013-06-07','12:00:00',15.8),('6449','2013-06-07','12:05:00',15.86),('6449','2013-06-07','12:10:00',16.01),('6449','2013-06-07','12:15:00',16.11),('6449','2013-06-07','12:20:00',15.92),('6449','2013-06-07','12:25:00',16.07),('6449','2013-06-07','12:30:00',15.92),('6449','2013-06-07','12:35:00',15.7),('6449','2013-06-07','12:40:00',16.21),('6449','2013-06-07','12:45:00',16.28),('6449','2013-06-07','12:50:00',16.33),('6449','2013-06-07','12:55:00',16.5),('6449','2013-06-07','13:00:00',16.48),('6449','2013-06-07','13:05:00',16.7),('6449','2013-06-07','13:10:00',16.63),('6449','2013-06-07','13:15:00',16.71),('6449','2013-06-07','13:20:00',16.72),('6449','2013-06-07','13:25:00',16.65),('6449','2013-06-07','13:30:00',16.66),('6449','2013-06-07','13:35:00',16.38),('6449','2013-06-07','13:40:00',16.47),('6449','2013-06-07','13:45:00',16.48),('6449','2013-06-07','13:50:00',16.44),('6449','2013-06-07','13:55:00',16.36),('6449','2013-06-07','14:00:00',16.27),('6449','2013-06-07','14:05:00',16.09),('6449','2013-06-07','14:10:00',16.25),('6449','2013-06-07','14:15:00',16.14),('6449','2013-06-07','14:20:00',16.03),('6449','2013-06-07','14:25:00',15.92),('6449','2013-06-07','14:30:00',15.8),('6449','2013-06-07','14:35:00',15.64),('6449','2013-06-07','14:40:00',15.48),('6449','2013-06-07','14:45:00',15.33),('6449','2013-06-07','14:50:00',15.24),('6449','2013-06-07','14:55:00',15.12),('6449','2013-06-07','15:00:00',14.94),('6449','2013-06-07','15:05:00',14.71),('6449','2013-06-07','15:10:00',14.48),('6449','2013-06-07','15:15:00',14.27),('6449','2013-06-07','15:20:00',14),('6449','2013-06-07','15:25:00',13.79),('6449','2013-06-07','15:30:00',13.74),('6449','2013-06-07','15:35:00',13.51),('6449','2013-06-07','15:40:00',13.31),('6449','2013-06-07','15:45:00',13.15),('6449','2013-06-07','15:50:00',12.93),('6449','2013-06-07','15:55:00',12.53),('6449','2013-06-07','16:00:00',12.48),('6449','2013-06-07','16:05:00',12.29),('6449','2013-06-07','16:10:00',11.99),('6449','2013-06-07','16:15:00',11.66),('6449','2013-06-07','16:20:00',11.34),('6449','2013-06-07','16:25:00',9.74),('6449','2013-06-07','16:30:00',10.67),('6449','2013-06-07','16:35:00',9.28),('6449','2013-06-07','16:40:00',10.07),('6449','2013-06-07','16:45:00',8.53),('6449','2013-06-07','16:50:00',9.54),('6449','2013-06-07','16:55:00',9.27),('6449','2013-06-07','17:00:00',9.01),('6449','2013-06-07','17:05:00',8.77),('6449','2013-06-07','17:10:00',8.53),('6449','2013-06-07','17:15:00',8.88),('6449','2013-06-07','17:20:00',8.15),('6449','2013-06-07','17:25:00',8.52),('6449','2013-06-07','17:30:00',7.7),('6449','2013-06-07','17:35:00',7.22),('6449','2013-06-07','17:40:00',5.29),('6449','2013-06-07','17:45:00',3.72),('6449','2013-06-07','17:50:00',6.41),('6449','2013-06-06','06:45:00',1.19),('6449','2013-06-06','06:50:00',1.52),('6449','2013-06-06','06:55:00',2.01),('6449','2013-06-06','07:00:00',2.3),('6449','2013-06-06','07:05:00',2.17),('6449','2013-06-06','07:10:00',2.15),('6449','2013-06-06','07:15:00',2.02),('6449','2013-06-06','07:20:00',2.3),('6449','2013-06-06','07:25:00',2.91),('6449','2013-06-06','07:30:00',3.07),('6449','2013-06-06','07:35:00',3.89),('6449','2013-06-06','07:40:00',4.6),('6449','2013-06-06','07:45:00',4.91),('6449','2013-06-06','07:50:00',5.16),('6449','2013-06-06','07:55:00',5.59),('6449','2013-06-06','08:00:00',6),('6449','2013-06-06','08:05:00',6.26),('6449','2013-06-06','08:10:00',6.48),('6449','2013-06-06','08:15:00',6.79),('6449','2013-06-06','08:20:00',7.23),('6449','2013-06-06','08:25:00',7.53),('6449','2013-06-06','08:30:00',7.89),('6449','2013-06-06','08:35:00',8.12),('6449','2013-06-06','08:40:00',8.48),('6449','2013-06-06','08:45:00',8.7),('6449','2013-06-06','08:50:00',9.12),('6449','2013-06-06','08:55:00',9.36),('6449','2013-06-06','09:00:00',9.68),('6449','2013-06-06','09:05:00',9.82),('6449','2013-06-06','09:10:00',10.22),('6449','2013-06-06','09:15:00',10.36),('6449','2013-06-06','09:20:00',10.58),('6449','2013-06-06','09:25:00',10.85),('6449','2013-06-06','09:30:00',11.13),('6449','2013-06-06','09:35:00',11.32),('6449','2013-06-06','09:40:00',11.51),('6449','2013-06-06','09:45:00',11.81),('6449','2013-06-06','09:50:00',11.88),('6449','2013-06-06','09:55:00',12.23),('6449','2013-06-06','10:00:00',12.39),('6449','2013-06-06','10:05:00',12.67),('6449','2013-06-06','10:10:00',12.82),('6449','2013-06-06','10:15:00',13.19),('6449','2013-06-06','10:20:00',13.51),('6449','2013-06-06','10:25:00',11.14),('6449','2013-06-06','10:30:00',8.91),('6449','2013-06-06','10:35:00',14.68),('6449','2013-06-06','10:40:00',14.8),('6449','2013-06-06','10:45:00',12.39),('6449','2013-06-06','10:50:00',12.64),('6449','2013-06-06','10:55:00',12.64),('6449','2013-06-06','11:00:00',14.47),('6449','2013-06-06','11:05:00',15.05),('6449','2013-06-06','11:10:00',15.05),('6449','2013-06-06','11:15:00',15.25),('6449','2013-06-06','11:20:00',14.22),('6449','2013-06-06','11:25:00',15.09),('6449','2013-06-06','11:30:00',15.6),('6449','2013-06-06','11:35:00',15.55),('6449','2013-06-06','11:40:00',15.32),('6449','2013-06-06','11:45:00',15.06),('6449','2013-06-06','11:50:00',15.68),('6449','2013-06-06','11:55:00',15.65),('6449','2013-06-06','12:00:00',15.76),('6449','2013-06-06','12:05:00',15.69),('6449','2013-06-06','12:10:00',15.96),('6449','2013-06-06','12:15:00',16.07),('6449','2013-06-06','12:20:00',16.16),('6449','2013-06-06','12:25:00',16.23),('6449','2013-06-06','12:30:00',16.3),('6449','2013-06-06','12:35:00',16),('6449','2013-06-06','12:40:00',16.3),('6449','2013-06-06','12:45:00',16.35),('6449','2013-06-06','12:50:00',16.35),('6449','2013-06-06','12:55:00',16.33),('6449','2013-06-06','13:00:00',16.38),('6449','2013-06-06','13:05:00',15.96),('6449','2013-06-06','13:10:00',16.45),('6449','2013-06-06','13:15:00',16.32),('6449','2013-06-06','13:20:00',16.4),('6449','2013-06-06','13:25:00',16.23),('6449','2013-06-06','13:30:00',16.42),('6449','2013-06-06','13:35:00',16.43),('6449','2013-06-06','13:40:00',16.41),('6449','2013-06-06','13:45:00',16.15),('6449','2013-06-06','13:50:00',16.03),('6449','2013-06-06','13:55:00',16.12),('6449','2013-06-06','14:00:00',15.98),('6449','2013-06-06','14:05:00',15.84),('6449','2013-06-06','14:10:00',15.83),('6449','2013-06-06','14:15:00',15.84),('6449','2013-06-06','14:20:00',15.49),('6449','2013-06-06','14:25:00',15.61),('6449','2013-06-06','14:30:00',15.55),('6449','2013-06-06','14:35:00',15.28),('6449','2013-06-06','14:40:00',15.04),('6449','2013-06-06','14:45:00',15),('6449','2013-06-06','14:50:00',14.87),('6449','2013-06-06','14:55:00',14.32),('6449','2013-06-06','15:00:00',14.51),('6449','2013-06-06','15:05:00',14.45),('6449','2013-06-06','15:10:00',14.32),('6449','2013-06-06','15:15:00',14.07),('6449','2013-06-06','15:20:00',13.86),('6449','2013-06-06','15:25:00',13.79),('6449','2013-06-06','15:30:00',13.57),('6449','2013-06-06','15:35:00',13.58),('6449','2013-06-06','15:40:00',13.21),('6449','2013-06-06','15:45:00',12.97),('6449','2013-06-06','15:50:00',12.78),('6449','2013-06-06','15:55:00',12.63),('6449','2013-06-06','16:00:00',12.43),('6449','2013-06-06','16:05:00',11.97),('6449','2013-06-06','16:10:00',11.86),('6449','2013-06-06','16:15:00',11.56),('6449','2013-06-06','16:20:00',11.2),('6449','2013-06-06','16:25:00',10.93),('6449','2013-06-06','16:30:00',10.65),('6449','2013-06-06','16:35:00',10.48),('6449','2013-06-06','16:40:00',10.2),('6449','2013-06-06','16:45:00',9.97),('6449','2013-06-06','16:50:00',9.64),('6449','2013-06-06','16:55:00',9.11),('6449','2013-06-06','17:00:00',8.93),('6449','2013-06-06','17:05:00',8.69),('6449','2013-06-06','17:10:00',8.27),('6449','2013-06-06','17:15:00',7.92),('6449','2013-06-06','17:20:00',7.73),('6449','2013-06-06','17:25:00',7.28),('6449','2013-06-06','17:30:00',7.04),('6449','2013-06-06','17:35:00',6.63),('6449','2013-06-06','17:40:00',6.32),('6449','2013-06-06','17:45:00',6),('6449','2013-06-06','17:50:00',5.52),('6449','2013-06-06','17:55:00',5.24),('6449','2013-06-06','18:00:00',4.87),('6449','2013-06-06','18:05:00',4.54),('6449','2013-06-06','18:10:00',4.21),('6449','2013-06-06','18:15:00',3.88),('6449','2013-06-06','18:20:00',3.54),('6449','2013-06-06','18:25:00',3.23),('6449','2013-06-06','18:30:00',2.87),('6449','2013-06-06','18:35:00',2.57),('6449','2013-06-06','18:40:00',2.3),('6449','2013-06-06','18:45:00',1.99),('6449','2013-06-06','18:50:00',1.78),('6449','2013-06-06','18:55:00',1.53),('6449','2013-06-06','19:00:00',1.3),('6449','2013-06-06','19:05:00',1.1),('6449','2013-06-05','06:50:00',1.23),('6449','2013-06-05','06:55:00',1.7),('6449','2013-06-05','07:00:00',1.92),('6449','2013-06-05','07:05:00',3.08),('6449','2013-06-05','07:10:00',2.85),('6449','2013-06-05','07:15:00',2.79),('6449','2013-06-05','07:20:00',3.26),('6449','2013-06-05','07:25:00',3.05),('6449','2013-06-05','07:30:00',2.48),('6449','2013-06-05','07:35:00',3.89),('6449','2013-06-05','07:40:00',4.18),('6449','2013-06-05','07:45:00',4.67),('6449','2013-06-05','07:50:00',5.03),('6449','2013-06-05','07:55:00',5.29),('6449','2013-06-05','08:00:00',5.65),('6449','2013-06-05','08:05:00',6.02),('6449','2013-06-05','08:10:00',6.42),('6449','2013-06-05','08:15:00',6.61),('6449','2013-06-05','08:20:00',6.97),('6449','2013-06-05','08:25:00',7.08),('6449','2013-06-05','08:30:00',7.4),('6449','2013-06-05','08:35:00',7.82),('6449','2013-06-05','08:40:00',8.13),('6449','2013-06-05','08:45:00',8.43),('6449','2013-06-05','08:50:00',8.88),('6449','2013-06-05','08:55:00',9.25),('6449','2013-06-05','09:00:00',9.48),('6449','2013-06-05','09:05:00',9.8),('6449','2013-06-05','09:10:00',10.3),('6449','2013-06-05','09:15:00',10.46),('6449','2013-06-05','09:20:00',10.69),('6449','2013-06-05','09:25:00',10.69),('6449','2013-06-05','09:30:00',9.9),('6449','2013-06-05','09:35:00',11.51),('6449','2013-06-05','09:40:00',11.81),('6449','2013-06-05','09:45:00',12.21),('6449','2013-06-05','09:50:00',13.36),('6449','2013-06-05','09:55:00',11.28),('6449','2013-06-05','10:00:00',5.02),('6449','2013-06-05','10:05:00',4.67),('6449','2013-06-05','10:10:00',8.5),('6449','2013-06-05','10:15:00',9.55),('6449','2013-06-05','10:20:00',4.04),('6449','2013-06-05','10:25:00',4.04),('6449','2013-06-05','10:30:00',4.83),('6449','2013-06-05','10:35:00',4.46),('6449','2013-06-05','10:40:00',4.78),('6449','2013-06-05','10:45:00',4.77),('6449','2013-06-05','10:50:00',10.01),('6449','2013-06-05','10:55:00',13.23),('6449','2013-06-05','11:00:00',15.6),('6449','2013-06-05','11:05:00',15.07),('6449','2013-06-05','11:10:00',14.91),('6449','2013-06-05','11:15:00',14.77),('6449','2013-06-05','11:20:00',14.77),('6449','2013-06-05','11:25:00',15.38),('6449','2013-06-05','11:30:00',15.35),('6449','2013-06-05','11:35:00',15.46),('6449','2013-06-05','11:40:00',15.56),('6449','2013-06-05','11:45:00',15.77),('6449','2013-06-05','11:50:00',15.75),('6449','2013-06-05','11:55:00',15.81),('6449','2013-06-05','12:00:00',16),('6449','2013-06-05','12:05:00',16.12),('6449','2013-06-05','12:10:00',16.02),('6449','2013-06-05','12:15:00',16.16),('6449','2013-06-05','12:20:00',16.21),('6449','2013-06-05','12:25:00',16.17),('6449','2013-06-05','12:30:00',16.26),('6449','2013-06-05','12:35:00',16.14),('6449','2013-06-05','12:40:00',16.34),('6449','2013-06-05','12:45:00',16.39),('6449','2013-06-05','12:50:00',16.55),('6449','2013-06-05','12:55:00',16.6),('6449','2013-06-05','13:00:00',16.46),('6449','2013-06-05','13:05:00',16.48),('6449','2013-06-05','13:10:00',16.87),('6449','2013-06-05','13:15:00',17.02),('6449','2013-06-05','13:20:00',16.73),('6449','2013-06-05','13:25:00',16.64),('6449','2013-06-05','13:30:00',16.06),('6449','2013-06-05','13:35:00',16.14),('6449','2013-06-05','13:40:00',16.21),('6449','2013-06-05','13:45:00',16.29),('6449','2013-06-05','13:50:00',16.3),('6449','2013-06-05','13:55:00',16.14),('6449','2013-06-05','14:00:00',15.91),('6449','2013-06-05','14:05:00',15.85),('6449','2013-06-05','14:10:00',15.89),('6449','2013-06-05','14:15:00',15.86),('6449','2013-06-05','14:20:00',15.49),('6449','2013-06-05','14:25:00',15.77),('6449','2013-06-05','14:30:00',14.41),('6449','2013-06-05','14:35:00',15.43),('6449','2013-06-05','14:40:00',15.1),('6449','2013-06-05','14:45:00',14.56),('6449','2013-06-05','14:50:00',12.25),('6449','2013-06-05','14:55:00',14.84),('6449','2013-06-05','15:00:00',14.04),('6449','2013-06-05','15:05:00',14.78),('6449','2013-06-05','15:10:00',14.39),('6449','2013-06-05','15:15:00',13.99),('6449','2013-06-05','15:20:00',13.07),('6449','2013-06-05','15:25:00',12.74),('6449','2013-06-05','15:30:00',14.13),('6449','2013-06-05','15:35:00',10.88),('6449','2013-06-05','15:40:00',12.44),('6449','2013-06-05','15:45:00',8.59),('6449','2013-06-05','15:50:00',7.97),('6449','2013-06-05','15:55:00',12.6),('6449','2013-06-05','16:00:00',12.65),('6449','2013-06-05','16:05:00',10.72),('6449','2013-06-05','16:10:00',10.01),('6449','2013-06-05','16:15:00',11.84),('6449','2013-06-05','16:20:00',11.48),('6449','2013-06-05','16:25:00',10.64),('6449','2013-06-05','16:30:00',7.36),('6449','2013-06-05','16:35:00',9.69),('6449','2013-06-05','16:40:00',10.14),('6449','2013-06-05','16:45:00',9.84),('6449','2013-06-05','16:50:00',7.14),('6449','2013-06-05','16:55:00',7.99),('6449','2013-06-05','17:00:00',5.14),('6449','2013-06-05','17:05:00',7.99),('6449','2013-06-05','17:10:00',6.96),('6449','2013-06-05','17:15:00',8.51),('6449','2013-06-05','17:20:00',7.48),('6449','2013-06-05','17:25:00',6.25),('6449','2013-06-05','17:30:00',7.59),('6449','2013-06-05','17:35:00',7.09),('6449','2013-06-05','17:40:00',6.41),('6449','2013-06-05','17:45:00',6.39),('6449','2013-06-05','17:50:00',5.02),('6449','2013-06-05','17:55:00',5.16),('6449','2013-06-05','18:00:00',5.08),('6449','2013-06-05','18:05:00',4.62),('6449','2013-06-05','18:10:00',4.36),('6449','2013-06-05','18:15:00',4.27),('6449','2013-06-05','18:20:00',3.97),('6449','2013-06-05','18:25:00',3.76),('6449','2013-06-05','18:30:00',3.47),('6449','2013-06-05','18:35:00',2.97),('6449','2013-06-05','18:40:00',2.5),('6449','2013-06-05','18:45:00',2.1),('6449','2013-06-05','18:50:00',1.88),('6449','2013-06-05','18:55:00',1.64),('6449','2013-06-05','19:00:00',1.43),('6449','2013-06-05','19:05:00',1.24),('6449','2013-06-05','19:10:00',1.08),('6449','2013-06-04','06:40:00',1.05),('6449','2013-06-04','06:45:00',1.17),('6449','2013-06-04','06:50:00',1.68),('6449','2013-06-04','06:55:00',2.49),('6449','2013-06-04','07:00:00',2.84),('6449','2013-06-04','07:05:00',2.97),('6449','2013-06-04','07:10:00',3.66),('6449','2013-06-04','07:15:00',4.65),('6449','2013-06-04','07:20:00',4.77),('6449','2013-06-04','07:25:00',5.03),('6449','2013-06-04','07:30:00',4.54),('6449','2013-06-04','07:35:00',3.49),('6449','2013-06-04','07:40:00',3.1),('6449','2013-06-04','07:45:00',2.63),('6449','2013-06-04','07:50:00',3.28),('6449','2013-06-04','07:55:00',4.9),('6449','2013-06-04','08:00:00',6.4),('6449','2013-06-04','08:05:00',5.66),('6449','2013-06-04','08:10:00',3.37),('6449','2013-06-04','08:15:00',3.68),('6449','2013-06-04','08:20:00',3.96),('6449','2013-06-04','08:25:00',4.1),('6449','2013-06-04','08:30:00',2.44),('6449','2013-06-04','08:35:00',1.95),('6449','2013-06-04','08:40:00',2.04),('6449','2013-06-04','08:45:00',2.52),('6449','2013-06-04','08:50:00',2.96),('6449','2013-06-04','08:55:00',3.09),('6449','2013-06-04','09:00:00',3.7),('6449','2013-06-04','09:05:00',5.49),('6449','2013-06-04','09:10:00',6.38),('6449','2013-06-04','09:15:00',6.93),('6449','2013-06-04','09:20:00',8.4),('6449','2013-06-04','09:25:00',6.38),('6449','2013-06-04','09:30:00',5.74),('6449','2013-06-04','09:35:00',6.54),('6449','2013-06-04','09:40:00',8.69),('6449','2013-06-04','09:45:00',10.32),('6449','2013-06-04','09:50:00',5.37),('6449','2013-06-04','09:55:00',4.65),('6449','2013-06-04','10:00:00',4.91),('6449','2013-06-04','10:05:00',5.95),('6449','2013-06-04','10:10:00',7),('6449','2013-06-04','10:15:00',9.42),('6449','2013-06-04','10:20:00',9.64),('6449','2013-06-04','10:25:00',6.31),('6449','2013-06-04','10:30:00',6.41),('6449','2013-06-04','10:35:00',8.7),('6449','2013-06-04','10:40:00',8.45),('6449','2013-06-04','10:45:00',6.15),('6449','2013-06-04','10:50:00',6.35),('6449','2013-06-04','10:55:00',6.41),('6449','2013-06-04','11:00:00',6.88),('6449','2013-06-04','11:05:00',9.15),('6449','2013-06-04','11:10:00',7.12),('6449','2013-06-04','11:15:00',14.04),('6449','2013-06-04','11:20:00',12.62),('6449','2013-06-04','11:25:00',16.71),('6449','2013-06-04','11:30:00',16.63),('6449','2013-06-04','11:35:00',14.11),('6449','2013-06-04','11:40:00',11.38),('6449','2013-06-04','11:45:00',7.76),('6449','2013-06-04','11:50:00',11.16),('6449','2013-06-04','11:55:00',8.59),('6449','2013-06-04','12:00:00',7.55),('6449','2013-06-04','12:05:00',14.16),('6449','2013-06-04','12:10:00',11.97),('6449','2013-06-04','12:15:00',8.19),('6449','2013-06-04','12:20:00',8.37),('6449','2013-06-04','12:25:00',7.25),('6449','2013-06-04','12:30:00',5.31),('6449','2013-06-04','12:35:00',4.89),('6449','2013-06-04','12:40:00',5.96),('6449','2013-06-04','12:45:00',9.48),('6449','2013-06-04','12:50:00',11),('6449','2013-06-04','12:55:00',13.22),('6449','2013-06-04','13:00:00',13.04),('6449','2013-06-04','13:05:00',9.06),('6449','2013-06-04','13:10:00',12.52),('6449','2013-06-04','13:15:00',12.4),('6449','2013-06-04','13:20:00',11.46),('6449','2013-06-04','13:25:00',12.66),('6449','2013-06-04','13:30:00',10.87),('6449','2013-06-04','13:35:00',10.44),('6449','2013-06-04','13:40:00',13.07),('6449','2013-06-04','13:45:00',17.91),('6449','2013-06-04','13:50:00',16.62),('6449','2013-06-04','13:55:00',17.17),('6449','2013-06-04','14:00:00',14.3),('6449','2013-06-04','14:05:00',14.14),('6449','2013-06-04','14:10:00',12.71),('6449','2013-06-04','14:15:00',15.97),('6449','2013-06-04','14:20:00',15.78),('6449','2013-06-04','14:25:00',16.83),('6449','2013-06-04','14:30:00',12.72),('6449','2013-06-04','14:35:00',10.84),('6449','2013-06-04','14:40:00',11.01),('6449','2013-06-04','14:45:00',12.81),('6449','2013-06-04','14:50:00',6.92),('6449','2013-06-04','14:55:00',17.37),('6449','2013-06-04','15:00:00',16.27),('6449','2013-06-04','15:05:00',14.84),('6449','2013-06-04','15:10:00',13.3),('6449','2013-06-04','15:15:00',12.47),('6449','2013-06-04','15:20:00',12.6),('6449','2013-06-04','15:25:00',7.49),('6449','2013-06-04','15:30:00',8.55),('6449','2013-06-04','15:35:00',12.21),('6449','2013-06-04','15:40:00',14.07),('6449','2013-06-04','15:45:00',12.18),('6449','2013-06-04','15:50:00',10.53),('6449','2013-06-04','15:55:00',12.3),('6449','2013-06-04','16:00:00',12.5),('6449','2013-06-04','16:05:00',13.18),('6449','2013-06-04','16:10:00',10.43),('6449','2013-06-04','16:15:00',6.9),('6449','2013-06-04','16:20:00',5.16),('6449','2013-06-04','16:25:00',4.78),('6449','2013-06-04','16:30:00',4.72),('6449','2013-06-04','16:35:00',4.36),('6449','2013-06-04','16:40:00',4.33),('6449','2013-06-04','16:45:00',4.09),('6449','2013-06-04','16:50:00',3.74),('6449','2013-06-04','16:55:00',3.32),('6449','2013-06-04','17:00:00',3.1),('6449','2013-06-04','17:05:00',3.01),('6449','2013-06-04','17:10:00',2.98),('6449','2013-06-04','17:15:00',3.02),('6449','2013-06-04','17:20:00',3.22),('6449','2013-06-04','17:25:00',3.51),('6449','2013-06-04','17:30:00',3.74),('6449','2013-06-04','17:35:00',4.16),('6449','2013-06-04','17:40:00',4.96),('6449','2013-06-04','17:45:00',5.43),('6449','2013-06-04','17:50:00',6.23),('6449','2013-06-04','17:55:00',5.26),('6449','2013-06-04','18:00:00',3.29),('6449','2013-06-04','18:05:00',2.68),('6449','2013-06-04','18:10:00',2.73),('6449','2013-06-04','18:15:00',2.82),('6449','2013-06-04','18:20:00',2.73),('6449','2013-06-04','18:25:00',2.52),('6449','2013-06-04','18:30:00',2.73),('6449','2013-06-04','18:35:00',1.91),('6449','2013-06-04','18:40:00',1.71),('6449','2013-06-04','18:45:00',1.59),('6449','2013-06-04','18:50:00',1.5),('6449','2013-06-04','18:55:00',1.33),('6449','2013-06-04','19:00:00',1.17),('6449','2013-06-04','19:05:00',1.19),('6449','2013-06-04','19:10:00',1.25),('6449','2013-06-04','19:15:00',1.06),('6449','2013-06-04','19:30:00',1.01),('6449','2013-06-03','06:30:00',1.2),('6449','2013-06-03','06:35:00',1.55),('6449','2013-06-03','06:40:00',1.86),('6449','2013-06-03','06:45:00',2.17),('6449','2013-06-03','06:50:00',2.39),('6449','2013-06-03','06:55:00',2.55),('6449','2013-06-03','07:00:00',3.02),('6449','2013-06-03','07:05:00',3.34),('6449','2013-06-03','07:10:00',3.64),('6449','2013-06-03','07:15:00',2.98),('6449','2013-06-03','07:20:00',2.52),('6449','2013-06-03','07:25:00',3.69),('6449','2013-06-03','07:30:00',2.93),('6449','2013-06-03','07:35:00',2.49),('6449','2013-06-03','07:40:00',2.58),('6449','2013-06-03','07:45:00',2.82),('6449','2013-06-03','07:50:00',3.22),('6449','2013-06-03','07:55:00',3.18),('6449','2013-06-03','08:00:00',3.08),('6449','2013-06-03','08:05:00',2.7),('6449','2013-06-03','08:10:00',2.77),('6449','2013-06-03','08:15:00',2.92),('6449','2013-06-03','08:20:00',3.33),('6449','2013-06-03','08:25:00',4.88),('6449','2013-06-03','08:30:00',4.55),('6449','2013-06-03','08:35:00',7.19),('6449','2013-06-03','08:40:00',6.25),('6449','2013-06-03','08:45:00',5.04),('6449','2013-06-03','08:50:00',8.14),('6449','2013-06-03','08:55:00',8.5),('6449','2013-06-03','09:00:00',5.19),('6449','2013-06-03','09:05:00',4.52),('6449','2013-06-03','09:10:00',4.15),('6449','2013-06-03','09:15:00',3.8),('6449','2013-06-03','09:20:00',4.29),('6449','2013-06-03','09:25:00',5.09),('6449','2013-06-03','09:30:00',4.91),('6449','2013-06-03','09:35:00',4.36),('6449','2013-06-03','09:40:00',4.65),('6449','2013-06-03','09:45:00',5.74),('6449','2013-06-03','09:50:00',6.17),('6449','2013-06-03','09:55:00',8.07),('6449','2013-06-03','10:00:00',7.42),('6449','2013-06-03','10:05:00',5.61),('6449','2013-06-03','10:10:00',7.81),('6449','2013-06-03','10:15:00',10.81),('6449','2013-06-03','10:20:00',9.42),('6449','2013-06-03','10:25:00',13.59),('6449','2013-06-03','10:30:00',5.62),('6449','2013-06-03','10:35:00',6.76),('6449','2013-06-03','10:40:00',6.45),('6449','2013-06-03','10:45:00',6.15),('6449','2013-06-03','10:50:00',6.94),('6449','2013-06-03','10:55:00',8.3),('6449','2013-06-03','11:00:00',8.34),('6449','2013-06-03','11:05:00',11.54),('6449','2013-06-03','11:10:00',15.67),('6449','2013-06-03','11:15:00',10.93),('6449','2013-06-03','11:20:00',11.11),('6449','2013-06-03','11:25:00',4.32),('6449','2013-06-03','11:30:00',3.19),('6449','2013-06-03','11:35:00',3.28),('6449','2013-06-03','11:40:00',3.29),('6449','2013-06-03','11:45:00',3.65),('6449','2013-06-03','11:50:00',5),('6449','2013-06-03','11:55:00',7.61),('6449','2013-06-03','12:00:00',11.45),('6449','2013-06-03','12:05:00',18.94),('6449','2013-06-03','12:10:00',14.56),('6449','2013-06-03','12:15:00',5.4),('6449','2013-06-03','12:20:00',5.3),('6449','2013-06-03','12:25:00',5.53),('6449','2013-06-03','12:30:00',6.1),('6449','2013-06-03','12:35:00',7.03),('6449','2013-06-03','12:40:00',7.03),('6449','2013-06-03','12:45:00',11.39),('6449','2013-06-03','12:50:00',7.88),('6449','2013-06-03','12:55:00',5.51),('6449','2013-06-03','13:00:00',5.83),('6449','2013-06-03','13:05:00',6.62),('6449','2013-06-03','13:10:00',6.87),('6449','2013-06-03','13:15:00',8.44),('6449','2013-06-03','13:20:00',8.09),('6449','2013-06-03','13:25:00',7.43),('6449','2013-06-03','13:30:00',17.75),('6449','2013-06-03','13:35:00',16.91),('6449','2013-06-03','13:40:00',16.62),('6449','2013-06-03','13:45:00',16.86),('6449','2013-06-03','13:50:00',17.22),('6449','2013-06-03','13:55:00',15.45),('6449','2013-06-03','14:00:00',9.51),('6449','2013-06-03','14:05:00',7.08),('6449','2013-06-03','14:10:00',6.46),('6449','2013-06-03','14:15:00',15.3),('6449','2013-06-03','14:20:00',17.54),('6449','2013-06-03','14:25:00',18.14),('6449','2013-06-03','14:30:00',14.75),('6449','2013-06-03','14:35:00',16.24),('6449','2013-06-03','14:40:00',12.88),('6449','2013-06-03','14:45:00',9.99),('6449','2013-06-03','14:50:00',14.25),('6449','2013-06-03','14:55:00',10.63),('6449','2013-06-03','15:00:00',8.98),('6449','2013-06-03','15:05:00',15.32),('6449','2013-06-03','15:10:00',14.33),('6449','2013-06-03','15:15:00',14.01),('6449','2013-06-03','15:20:00',15.1),('6449','2013-06-03','15:25:00',14.08),('6449','2013-06-03','15:30:00',10.27),('6449','2013-06-03','15:35:00',10.13),('6449','2013-06-03','15:40:00',13.4),('6449','2013-06-03','15:45:00',12.82),('6449','2013-06-03','15:50:00',12.96),('6449','2013-06-03','15:55:00',12.66),('6449','2013-06-03','16:00:00',12.18),('6449','2013-06-03','16:05:00',12.25),('6449','2013-06-03','16:10:00',12.02),('6449','2013-06-03','16:15:00',11.84),('6449','2013-06-03','16:20:00',11.73),('6449','2013-06-03','16:25:00',10.59),('6449','2013-06-03','16:30:00',6.96),('6449','2013-06-03','16:35:00',6.64),('6449','2013-06-03','16:40:00',6.77),('6449','2013-06-03','16:45:00',7.95),('6449','2013-06-03','16:50:00',9.36),('6449','2013-06-03','16:55:00',8.06),('6449','2013-06-03','17:00:00',7.8),('6449','2013-06-03','17:05:00',6.94),('6449','2013-06-03','17:10:00',6.17),('6449','2013-06-03','17:15:00',6.38),('6449','2013-06-03','17:20:00',5.55),('6449','2013-06-03','17:25:00',4.44),('6449','2013-06-03','17:30:00',4.05),('6449','2013-06-03','17:35:00',3.78),('6449','2013-06-03','17:40:00',3.68),('6449','2013-06-03','17:45:00',3.56),('6449','2013-06-03','17:50:00',3.47),('6449','2013-06-03','17:55:00',2.96),('6449','2013-06-03','18:00:00',2.67),('6449','2013-06-03','18:05:00',2.64),('6449','2013-06-03','18:10:00',2.44),('6449','2013-06-03','18:15:00',2.09),('6449','2013-06-03','18:20:00',2.03),('6449','2013-06-03','18:25:00',2.18),('6449','2013-06-03','18:30:00',2.05),('6449','2013-06-03','18:35:00',1.92),('6449','2013-06-03','18:40:00',1.81),('6449','2013-06-03','18:45:00',1.46),('6449','2013-06-03','18:50:00',1.3),('6449','2013-06-03','18:55:00',1.26),('6449','2013-06-03','19:00:00',1.26),('6449','2013-06-03','19:05:00',1.24),('6449','2013-06-03','19:10:00',1.24),('6449','2013-06-03','19:15:00',1.08),('6449','2013-06-03','19:20:00',1.07),('6449','2013-06-02','07:35:00',1.13),('6449','2013-06-02','07:40:00',1.4),('6449','2013-06-02','07:45:00',1.83),('6449','2013-06-02','07:50:00',2.48),('6449','2013-06-02','07:55:00',3.02),('6449','2013-06-02','08:00:00',2.39),('6449','2013-06-02','08:05:00',4.64),('6449','2013-06-02','08:10:00',4.93),('6449','2013-06-02','08:15:00',4.48),('6449','2013-06-02','08:20:00',8.45),('6449','2013-06-02','08:25:00',8.32),('6449','2013-06-02','08:30:00',8.7),('6449','2013-06-02','08:35:00',8.87),('6449','2013-06-02','08:40:00',9.17),('6449','2013-06-02','08:45:00',8.28),('6449','2013-06-02','08:50:00',9.76),('6449','2013-06-02','08:55:00',9.5),('6449','2013-06-02','09:00:00',9.75),('6449','2013-06-02','09:05:00',10.06),('6449','2013-06-02','09:10:00',10.33),('6449','2013-06-02','09:15:00',10.66),('6449','2013-06-02','09:20:00',10.96),('6449','2013-06-02','09:25:00',11.17),('6449','2013-06-02','09:30:00',11.21),('6449','2013-06-02','09:35:00',11.46),('6449','2013-06-02','09:40:00',11.9),('6449','2013-06-02','09:45:00',10.76),('6449','2013-06-02','09:50:00',12.26),('6449','2013-06-02','09:55:00',12.92),('6449','2013-06-02','10:00:00',13.26),('6449','2013-06-02','10:05:00',13.49),('6449','2013-06-02','10:10:00',12.65),('6449','2013-06-02','10:15:00',10.87),('6449','2013-06-02','10:20:00',9.4),('6449','2013-06-02','10:25:00',13.47),('6449','2013-06-02','10:30:00',6.69),('6449','2013-06-02','10:35:00',9.59),('6449','2013-06-02','10:40:00',6.57),('6449','2013-06-02','10:45:00',12.5),('6449','2013-06-02','10:50:00',15.6),('6449','2013-06-02','10:55:00',15.46),('6449','2013-06-02','11:00:00',15.43),('6449','2013-06-02','11:05:00',15.42),('6449','2013-06-02','11:10:00',15.4),('6449','2013-06-02','11:15:00',15.31),('6449','2013-06-02','11:20:00',15.51),('6449','2013-06-02','11:25:00',15.65),('6449','2013-06-02','11:30:00',15.75),('6449','2013-06-02','11:35:00',15.78),('6449','2013-06-02','11:40:00',15.95),('6449','2013-06-02','11:45:00',16.09),('6449','2013-06-02','11:50:00',16.12),('6449','2013-06-02','11:55:00',16.08),('6449','2013-06-02','12:00:00',16.1),('6449','2013-06-02','12:05:00',16.14),('6449','2013-06-02','12:10:00',16.32),('6449','2013-06-02','12:15:00',16.33),('6449','2013-06-02','12:20:00',16.5),('6449','2013-06-02','12:25:00',16.56),('6449','2013-06-02','12:30:00',16.55),('6449','2013-06-02','12:35:00',16.54),('6449','2013-06-02','12:40:00',16.49),('6449','2013-06-02','12:45:00',16.49),('6449','2013-06-02','12:50:00',16.51),('6449','2013-06-02','12:55:00',16.62),('6449','2013-06-02','13:00:00',16.55),('6449','2013-06-02','13:05:00',16.65),('6449','2013-06-02','13:10:00',16.79),('6449','2013-06-02','13:15:00',16.55),('6449','2013-06-02','13:20:00',16.57),('6449','2013-06-02','13:25:00',16.34),('6449','2013-06-02','13:30:00',16.14),('6449','2013-06-02','13:35:00',16.2),('6449','2013-06-02','13:40:00',16.48),('6449','2013-06-02','13:45:00',16.42),('6449','2013-06-02','13:50:00',7.9),('6449','2013-06-02','13:55:00',16.87),('6449','2013-06-02','14:00:00',10.38),('6449','2013-06-02','14:05:00',11.27),('6449','2013-06-02','14:10:00',12.47),('6449','2013-06-02','14:15:00',13.57),('6449','2013-06-02','14:20:00',12.96),('6449','2013-06-02','14:25:00',15.01),('6449','2013-06-02','14:30:00',9.53),('6449','2013-06-02','14:35:00',11.98),('6449','2013-06-02','14:40:00',16.62),('6449','2013-06-02','14:45:00',16.6),('6449','2013-06-02','14:50:00',12.31),('6449','2013-06-02','14:55:00',14.45),('6449','2013-06-02','15:00:00',13.13),('6449','2013-06-02','15:05:00',12.55),('6449','2013-06-02','15:10:00',14.27),('6449','2013-06-02','15:15:00',14.77),('6449','2013-06-02','15:20:00',11.48),('6449','2013-06-02','15:25:00',12.65),('6449','2013-06-02','15:30:00',13.94),('6449','2013-06-02','15:35:00',13.46),('6449','2013-06-02','15:40:00',13.1),('6449','2013-06-02','15:45:00',12.8),('6449','2013-06-02','15:50:00',10.13),('6449','2013-06-02','15:55:00',7.4),('6449','2013-06-02','16:00:00',6.9),('6449','2013-06-02','16:05:00',7.76),('6449','2013-06-02','16:10:00',7.94),('6449','2013-06-02','16:15:00',6.04),('6449','2013-06-02','16:20:00',4.88),('6449','2013-06-02','16:25:00',4.93),('6449','2013-06-02','16:30:00',4.97),('6449','2013-06-02','16:35:00',5.04),('6449','2013-06-02','16:40:00',4.76),('6449','2013-06-02','16:45:00',3.86),('6449','2013-06-02','16:50:00',3.6),('6449','2013-06-02','16:55:00',3.82),('6449','2013-06-02','17:00:00',3.36),('6449','2013-06-02','17:05:00',3.23),('6449','2013-06-02','17:10:00',3.72),('6449','2013-06-02','17:15:00',3.69),('6449','2013-06-02','17:20:00',3.64),('6449','2013-06-02','17:25:00',3.12),('6449','2013-06-02','17:30:00',3.15),('6449','2013-06-02','17:35:00',3.15),('6449','2013-06-02','17:40:00',3.01),('6449','2013-06-02','17:45:00',2.92),('6449','2013-06-02','17:50:00',2.68),('6449','2013-06-02','17:55:00',2.7),('6449','2013-06-02','18:00:00',2.67),('6449','2013-06-02','18:05:00',2.55),('6449','2013-06-02','18:10:00',2.64),('6449','2013-06-02','18:15:00',2.5),('6449','2013-06-02','18:20:00',2.44),('6449','2013-06-02','18:25:00',2.49),('6449','2013-06-02','18:30:00',2.32),('6449','2013-06-02','18:35:00',2.38),('6449','2013-06-02','18:40:00',2.16),('6449','2013-06-02','18:45:00',2.27),('6449','2013-06-02','18:50:00',2.05),('6449','2013-06-02','18:55:00',2.03),('6449','2013-06-02','19:00:00',1.33),('6449','2013-06-02','19:05:00',1.29),('6449','2013-06-02','19:10:00',1.47),('6449','2013-06-02','19:15:00',1.24),('6449','2013-06-02','19:20:00',1.13),('6449','2013-06-02','19:25:00',1.11),('6449','2013-06-02','19:30:00',1.08),('6449','2013-06-02','19:35:00',1.04),('6449','2013-06-01','06:30:00',1.15),('6449','2013-06-01','06:35:00',1.22),('6449','2013-06-01','06:40:00',1.17),('6449','2013-06-01','06:45:00',1.02),('6449','2013-06-01','06:55:00',1.19),('6449','2013-06-01','07:10:00',1.92),('6449','2013-06-01','07:15:00',2.86),('6449','2013-06-01','07:20:00',3.17),('6449','2013-06-01','07:25:00',3.7),('6449','2013-06-01','07:30:00',4.42),('6449','2013-06-01','07:35:00',3.41),('6449','2013-06-01','07:40:00',3.84),('6449','2013-06-01','07:45:00',5.51),('6449','2013-06-01','07:50:00',4.88),('6449','2013-06-01','07:55:00',5.23),('6449','2013-06-01','08:00:00',4.43),('6449','2013-06-01','08:05:00',4.07),('6449','2013-06-01','08:10:00',3.47),('6449','2013-06-01','08:15:00',2.92),('6449','2013-06-01','08:20:00',6.49),('6449','2013-06-01','08:25:00',4.9),('6449','2013-06-01','08:30:00',3.34),('6449','2013-06-01','08:35:00',4.19),('6449','2013-06-01','08:40:00',4.66),('6449','2013-06-01','08:45:00',6.25),('6449','2013-06-01','08:50:00',3.87),('6449','2013-06-01','08:55:00',5.76),('6449','2013-06-01','09:00:00',5.5),('6449','2013-06-01','09:05:00',4.66),('6449','2013-06-01','09:10:00',7.09),('6449','2013-06-01','09:15:00',9.73),('6449','2013-06-01','09:20:00',10.22),('6449','2013-06-01','09:25:00',9.04),('6449','2013-06-01','09:30:00',14.11),('6449','2013-06-01','09:35:00',6.83),('6449','2013-06-01','09:40:00',3.84),('6449','2013-06-01','09:45:00',4.78),('6449','2013-06-01','09:50:00',6.13),('6449','2013-06-01','09:55:00',6.14),('6449','2013-06-01','10:00:00',5.68),('6449','2013-06-01','10:05:00',4.48),('6449','2013-06-01','10:10:00',3.25),('6449','2013-06-01','10:15:00',2.09),('6449','2013-06-01','10:25:00',1.17),('6449','2013-06-01','10:30:00',2.87),('6449','2013-06-01','10:35:00',3.84),('6449','2013-06-01','10:40:00',4.63),('6449','2013-06-01','10:45:00',2.84),('6449','2013-06-01','10:50:00',2.74),('6449','2013-06-01','10:55:00',4.36),('6449','2013-06-01','11:00:00',5.09),('6449','2013-06-01','11:05:00',6.54),('6449','2013-06-01','11:10:00',5.87),('6449','2013-06-01','11:15:00',5.18),('6449','2013-06-01','11:20:00',3.95),('6449','2013-06-01','11:25:00',3.29),('6449','2013-06-01','11:30:00',3.03),('6449','2013-06-01','11:35:00',2.57),('6449','2013-06-01','11:40:00',4.03),('6449','2013-06-01','11:45:00',7.18),('6449','2013-06-01','11:50:00',6.45),('6449','2013-06-01','11:55:00',6.59),('6449','2013-06-01','12:00:00',7.88),('6449','2013-06-01','12:05:00',13.25),('6449','2013-06-01','12:10:00',11.97),('6449','2013-06-01','12:15:00',9.96),('6449','2013-06-01','12:20:00',9.69),('6449','2013-06-01','12:25:00',8.31),('6449','2013-06-01','12:30:00',7.13),('6449','2013-06-01','12:35:00',8.31),('6449','2013-06-01','12:40:00',8.63),('6449','2013-06-01','12:45:00',8.82),('6449','2013-06-01','12:50:00',8.87),('6449','2013-06-01','12:55:00',7.78),('6449','2013-06-01','13:00:00',7.52),('6449','2013-06-01','13:05:00',7.8),('6449','2013-06-01','13:10:00',7.96),('6449','2013-06-01','13:15:00',8.48),('6449','2013-06-01','13:20:00',8.36),('6449','2013-06-01','13:25:00',8.26),('6449','2013-06-01','13:30:00',9.03),('6449','2013-06-01','13:35:00',8.89),('6449','2013-06-01','13:40:00',8.23),('6449','2013-06-01','13:45:00',7.48),('6449','2013-06-01','13:50:00',7.38),('6449','2013-06-01','13:55:00',6.26),('6449','2013-06-01','14:00:00',4.86),('6449','2013-06-01','14:05:00',5.03),('6449','2013-06-01','14:10:00',5.4),('6449','2013-06-01','14:15:00',5.82),('6449','2013-06-01','14:20:00',5.77),('6449','2013-06-01','14:25:00',4.62),('6449','2013-06-01','14:30:00',5.41),('6449','2013-06-01','14:35:00',4.28),('6449','2013-06-01','14:40:00',5.92),('6449','2013-06-01','14:45:00',6.86),('6449','2013-06-01','14:50:00',5.25),('6449','2013-06-01','14:55:00',4.75),('6449','2013-06-01','15:00:00',4.69),('6449','2013-06-01','15:05:00',4.31),('6449','2013-06-01','15:10:00',4.16),('6449','2013-06-01','15:15:00',4.12),('6449','2013-06-01','15:20:00',4.02),('6449','2013-06-01','15:25:00',4.9),('6449','2013-06-01','15:30:00',5.44),('6449','2013-06-01','15:35:00',5.43),('6449','2013-06-01','15:40:00',4.35),('6449','2013-06-01','15:45:00',5.09),('6449','2013-06-01','15:50:00',4.96),('6449','2013-06-01','15:55:00',3.79),('6449','2013-06-01','16:00:00',3.31),('6449','2013-06-01','16:05:00',3.47),('6449','2013-06-01','16:10:00',3.42),('6449','2013-06-01','16:15:00',2.98),('6449','2013-06-01','16:20:00',2.66),('6449','2013-06-01','16:25:00',2.36),('6449','2013-06-01','16:30:00',1.96),('6449','2013-06-01','16:35:00',1.63),('6449','2013-06-01','16:40:00',1.44),('6449','2013-06-01','16:45:00',1.69),('6449','2013-06-01','16:50:00',2.52),('6449','2013-06-01','16:55:00',3.73),('6449','2013-06-01','17:00:00',4.21),('6449','2013-06-01','17:05:00',3.62),('6449','2013-06-01','17:10:00',2.02),('6449','2013-06-01','17:15:00',2.24),('6449','2013-06-01','17:20:00',3.51),('6449','2013-06-01','17:25:00',4.49),('6449','2013-06-01','17:30:00',7.82),('6449','2013-06-01','17:35:00',5.06),('6449','2013-06-01','17:40:00',3.34),('6449','2013-06-01','17:45:00',5.5),('6449','2013-06-01','17:50:00',4.6),('6449','2013-06-01','17:55:00',5.5),('6449','2013-06-01','18:00:00',2.36),('6449','2013-06-01','18:05:00',4.78),('6449','2013-06-01','18:10:00',4.48),('6449','2013-06-01','18:15:00',4.05),('6449','2013-06-01','18:20:00',3.7),('6449','2013-06-01','18:25:00',2.37),('6449','2013-06-01','18:30:00',2.82),('6449','2013-06-01','18:35:00',2.49),('6449','2013-06-01','18:40:00',1.31),('6449','2013-06-01','18:45:00',1.26),('6449','2013-06-01','18:50:00',1.27),('6449','2013-06-01','18:55:00',1.49),('6449','2013-06-01','19:00:00',1.86),('6449','2013-06-01','19:05:00',2.14),('6449','2013-06-01','19:10:00',2.02),('6449','2013-06-01','19:15:00',1.89),('6449','2013-06-01','19:20:00',1.62),('6449','2013-06-01','19:25:00',1.67),('6449','2013-06-01','19:30:00',1.53),('6449','2013-06-01','19:35:00',1.24),('6449','2013-05-31','06:45:00',1.19),('6449','2013-05-31','06:50:00',1.4),('6449','2013-05-31','06:55:00',1.63),('6449','2013-05-31','07:00:00',1.94),('6449','2013-05-31','07:05:00',2.17),('6449','2013-05-31','07:10:00',2.5),('6449','2013-05-31','07:15:00',2.92),('6449','2013-05-31','07:20:00',3.42),('6449','2013-05-31','07:25:00',3.91),('6449','2013-05-31','07:30:00',3.61),('6449','2013-05-31','07:35:00',4.64),('6449','2013-05-31','07:40:00',5.77),('6449','2013-05-31','07:45:00',6.71),('6449','2013-05-31','07:50:00',4.45),('6449','2013-05-31','07:55:00',2.06),('6449','2013-05-31','08:00:00',2.56),('6449','2013-05-31','08:05:00',5.48),('6449','2013-05-31','08:10:00',6.98),('6449','2013-05-31','08:15:00',7.43),('6449','2013-05-31','08:20:00',7.99),('6449','2013-05-31','08:25:00',8.52),('6449','2013-05-31','08:30:00',5.94),('6449','2013-05-31','08:35:00',5.67),('6449','2013-05-31','08:40:00',9.41),('6449','2013-05-31','08:45:00',9.44),('6449','2013-05-31','08:50:00',9.78),('6449','2013-05-31','08:55:00',9.11),('6449','2013-05-31','09:00:00',9.65),('6449','2013-05-31','09:05:00',9.04),('6449','2013-05-31','09:10:00',6.89),('6449','2013-05-31','09:15:00',10.85),('6449','2013-05-31','09:20:00',11.4),('6449','2013-05-31','09:25:00',11.88),('6449','2013-05-31','09:30:00',11.36),('6449','2013-05-31','09:35:00',11.72),('6449','2013-05-31','09:40:00',10.76),('6449','2013-05-31','09:45:00',9.72),('6449','2013-05-31','09:50:00',14.65),('6449','2013-05-31','09:55:00',8.72),('6449','2013-05-31','10:00:00',14.08),('6449','2013-05-31','10:05:00',9.55),('6449','2013-05-31','10:10:00',8.86),('6449','2013-05-31','10:15:00',5.18),('6449','2013-05-31','10:20:00',4.82),('6449','2013-05-31','10:25:00',10.21),('6449','2013-05-31','10:30:00',10.39),('6449','2013-05-31','10:35:00',12.78),('6449','2013-05-31','10:40:00',7.91),('6449','2013-05-31','10:45:00',11.36),('6449','2013-05-31','10:50:00',16.43),('6449','2013-05-31','10:55:00',13.31),('6449','2013-05-31','11:00:00',16.24),('6449','2013-05-31','11:05:00',15.84),('6449','2013-05-31','11:10:00',16.16),('6449','2013-05-31','11:15:00',16.29),('6449','2013-05-31','11:20:00',15.78),('6449','2013-05-31','11:25:00',16.25),('6449','2013-05-31','11:30:00',16.51),('6449','2013-05-31','11:35:00',17.77),('6449','2013-05-31','11:40:00',14),('6449','2013-05-31','11:45:00',4.18),('6449','2013-05-31','11:50:00',9.62),('6449','2013-05-31','11:55:00',7.75),('6449','2013-05-31','12:00:00',4.14),('6449','2013-05-31','12:05:00',7.39),('6449','2013-05-31','12:10:00',13.15),('6449','2013-05-31','12:15:00',13.99),('6449','2013-05-31','12:20:00',13.24),('6449','2013-05-31','12:25:00',11.3),('6449','2013-05-31','12:30:00',7.81),('6449','2013-05-31','12:35:00',5.83),('6449','2013-05-31','12:40:00',4.27),('6449','2013-05-31','12:45:00',3.94),('6449','2013-05-31','12:50:00',4.35),('6449','2013-05-31','12:55:00',4.29),('6449','2013-05-31','13:00:00',4.76),('6449','2013-05-31','13:05:00',6.39),('6449','2013-05-31','13:10:00',7.22),('6449','2013-05-31','13:15:00',12.45),('6449','2013-05-31','13:20:00',14.7),('6449','2013-05-31','13:25:00',8.54),('6449','2013-05-31','13:30:00',5.55),('6449','2013-05-31','13:35:00',6.36),('6449','2013-05-31','13:40:00',6.97),('6449','2013-05-31','13:45:00',7.45),('6449','2013-05-31','13:50:00',8.45),('6449','2013-05-31','13:55:00',7.92),('6449','2013-05-31','14:00:00',7.35),('6449','2013-05-31','14:05:00',7.5),('6449','2013-05-31','14:10:00',7.86),('6449','2013-05-31','14:15:00',7.82),('6449','2013-05-31','14:20:00',9.29),('6449','2013-05-31','14:25:00',8.75),('6449','2013-05-31','14:30:00',2.84),('6449','2013-05-31','14:35:00',1.96),('6449','2013-05-31','14:40:00',2.84),('6449','2013-05-31','14:45:00',3.4),('6449','2013-05-31','14:50:00',7.44),('6449','2013-05-31','14:55:00',7.73),('6449','2013-05-31','15:00:00',5.06),('6449','2013-05-31','15:05:00',5.68),('6449','2013-05-31','15:10:00',4.15),('6449','2013-05-31','15:15:00',3.29),('6449','2013-05-31','15:20:00',4.19),('6449','2013-05-31','15:25:00',4.16),('6449','2013-05-31','15:30:00',4.37),('6449','2013-05-31','15:35:00',5.21),('6449','2013-05-31','15:40:00',8.19),('6449','2013-05-31','15:45:00',5.77),('6449','2013-05-31','15:50:00',3.34),('6449','2013-05-31','15:55:00',4.33),('6449','2013-05-31','16:00:00',5.87),('6449','2013-05-31','16:05:00',6.5),('6449','2013-05-31','16:10:00',5.77),('6449','2013-05-31','16:15:00',5.39),('6449','2013-05-31','16:20:00',5.06),('6449','2013-05-31','16:25:00',5.53),('6449','2013-05-31','16:30:00',5.5),('6449','2013-05-31','16:35:00',5.33),('6449','2013-05-31','16:40:00',5.35),('6449','2013-05-31','16:45:00',4.19),('6449','2013-05-31','16:50:00',3.04),('6449','2013-05-31','16:55:00',3.53),('6449','2013-05-31','17:00:00',3.63),('6449','2013-05-31','17:05:00',3.1),('6449','2013-05-31','17:10:00',2.6),('6449','2013-05-31','17:15:00',2.58),('6449','2013-05-31','17:20:00',2.63),('6449','2013-05-31','17:25:00',2.54),('6449','2013-05-31','17:30:00',2.24),('6449','2013-05-31','17:35:00',2.02),('6449','2013-05-31','17:40:00',1.46),('6449','2013-05-31','17:50:00',1.16),('6449','2013-05-31','17:55:00',2.08),('6449','2013-05-31','18:00:00',2.7),('6449','2013-05-31','18:05:00',2.25),('6449','2013-05-31','18:10:00',1.92),('6449','2013-05-31','18:15:00',1.8),('6449','2013-05-31','18:20:00',1.53),('6449','2013-05-31','18:25:00',1.44),('6449','2013-05-31','18:30:00',1.37),('6449','2013-05-31','18:35:00',1.48),('6449','2013-05-31','18:40:00',2.04),('6449','2013-05-31','18:45:00',1.77),('6449','2013-05-31','18:50:00',1.46),('6449','2013-05-31','18:55:00',1.46),('6449','2013-05-31','19:00:00',1.46),('6449','2013-05-31','19:05:00',1.28),('6449','2013-05-31','19:35:00',1.16),('6449','2013-05-30','06:55:00',1),('6449','2013-05-30','07:00:00',1.72),('6449','2013-05-30','07:05:00',2.49),('6449','2013-05-30','07:10:00',2.69),('6449','2013-05-30','07:15:00',3.48),('6449','2013-05-30','07:20:00',4.86),('6449','2013-05-30','07:25:00',4.49),('6449','2013-05-30','07:30:00',2.45),('6449','2013-05-30','07:35:00',3.75),('6449','2013-05-30','07:40:00',5.15),('6449','2013-05-30','07:45:00',4.47),('6449','2013-05-30','07:50:00',5.24),('6449','2013-05-30','07:55:00',5.55),('6449','2013-05-30','08:00:00',6.03),('6449','2013-05-30','08:05:00',4.92),('6449','2013-05-30','08:10:00',2.06),('6449','2013-05-30','08:15:00',6.77),('6449','2013-05-30','08:20:00',8.84),('6449','2013-05-30','08:25:00',5.89),('6449','2013-05-30','08:30:00',7.52),('6449','2013-05-30','08:35:00',8.67),('6449','2013-05-30','08:40:00',8.83),('6449','2013-05-30','08:45:00',8.97),('6449','2013-05-30','08:50:00',9.24),('6449','2013-05-30','08:55:00',9.84),('6449','2013-05-30','09:00:00',10.11),('6449','2013-05-30','09:05:00',10.49),('6449','2013-05-30','09:10:00',10.5),('6449','2013-05-30','09:15:00',11.29),('6449','2013-05-30','09:20:00',10.74),('6449','2013-05-30','09:25:00',10.72),('6449','2013-05-30','09:30:00',13.27),('6449','2013-05-30','09:35:00',7.6),('6449','2013-05-30','09:40:00',5.86),('6449','2013-05-30','09:45:00',9.74),('6449','2013-05-30','09:50:00',13.63),('6449','2013-05-30','09:55:00',12.89),('6449','2013-05-30','10:00:00',14.34),('6449','2013-05-30','10:05:00',12.66),('6449','2013-05-30','10:10:00',12.56),('6449','2013-05-30','10:15:00',15.14),('6449','2013-05-30','10:20:00',16.15),('6449','2013-05-30','10:25:00',13.75),('6449','2013-05-30','10:30:00',11.5),('6449','2013-05-30','10:35:00',9.76),('6449','2013-05-30','10:40:00',15.05),('6449','2013-05-30','10:45:00',16.55),('6449','2013-05-30','10:50:00',16.95),('6449','2013-05-30','10:55:00',14.94),('6449','2013-05-30','11:00:00',15.46),('6449','2013-05-30','11:05:00',16.17),('6449','2013-05-30','11:10:00',16.21),('6449','2013-05-30','11:15:00',14.99),('6449','2013-05-30','11:20:00',16.46),('6449','2013-05-30','11:25:00',15.43),('6449','2013-05-30','11:30:00',16.7),('6449','2013-05-30','11:35:00',16.76),('6449','2013-05-30','11:40:00',16.13),('6449','2013-05-30','11:45:00',15.21),('6449','2013-05-30','11:50:00',13.2),('6449','2013-05-30','11:55:00',19.09),('6449','2013-05-30','12:00:00',14.26),('6449','2013-05-30','12:05:00',17.54),('6449','2013-05-30','12:10:00',17.37),('6449','2013-05-30','12:15:00',17.44),('6449','2013-05-30','12:20:00',17.33),('6449','2013-05-30','12:25:00',17.2),('6449','2013-05-30','12:30:00',17.27),('6449','2013-05-30','12:35:00',17.5),('6449','2013-05-30','12:40:00',17.32),('6449','2013-05-30','12:45:00',17.34),('6449','2013-05-30','12:50:00',17.31),('6449','2013-05-30','12:55:00',17.3),('6449','2013-05-30','13:00:00',15.12),('6449','2013-05-30','13:05:00',17.26),('6449','2013-05-30','13:10:00',17.58),('6449','2013-05-30','13:15:00',12.21),('6449','2013-05-30','13:20:00',8.81),('6449','2013-05-30','13:25:00',12.49),('6449','2013-05-30','13:30:00',17.69),('6449','2013-05-30','13:35:00',19.27),('6449','2013-05-30','13:40:00',11.7),('6449','2013-05-30','13:45:00',7.95),('6449','2013-05-30','13:50:00',10.06),('6449','2013-05-30','13:55:00',16.7),('6449','2013-05-30','14:00:00',18.56),('6449','2013-05-30','14:05:00',16.98),('6449','2013-05-30','14:10:00',8.39),('6449','2013-05-30','14:15:00',10.37),('6449','2013-05-30','14:20:00',10.84),('6449','2013-05-30','14:25:00',11.61),('6449','2013-05-30','14:30:00',11.75),('6449','2013-05-30','14:35:00',12.95),('6449','2013-05-30','14:40:00',15.5),('6449','2013-05-30','14:45:00',10.81),('6449','2013-05-30','14:50:00',8.41),('6449','2013-05-30','14:55:00',9.97),('6449','2013-05-30','15:00:00',8.38),('6449','2013-05-30','15:05:00',7.37),('6449','2013-05-30','15:10:00',12.92),('6449','2013-05-30','15:15:00',8.98),('6449','2013-05-30','15:20:00',7.4),('6449','2013-05-30','15:25:00',8.04),('6449','2013-05-30','15:30:00',8.48),('6449','2013-05-30','15:35:00',6.23),('6449','2013-05-30','15:40:00',5.62),('6449','2013-05-30','15:45:00',9),('6449','2013-05-30','15:50:00',8.82),('6449','2013-05-30','15:55:00',6.87),('6449','2013-05-30','16:00:00',7.81),('6449','2013-05-30','16:05:00',12.03),('6449','2013-05-30','16:10:00',15.29),('6449','2013-05-30','16:15:00',14.26),('6449','2013-05-30','16:20:00',12.66),('6449','2013-05-30','16:25:00',12.59),('6449','2013-05-30','16:30:00',8.88),('6449','2013-05-30','16:35:00',5.82),('6449','2013-05-30','16:40:00',3.55),('6449','2013-05-30','16:45:00',2.37),('6449','2013-05-30','16:50:00',1.95),('6449','2013-05-30','16:55:00',3.25),('6449','2013-05-30','17:00:00',7.06),('6449','2013-05-30','17:05:00',8.59),('6449','2013-05-30','17:10:00',6.98),('6449','2013-05-30','17:15:00',8.11),('6449','2013-05-30','17:20:00',4.82),('6449','2013-05-30','17:25:00',6.32),('6449','2013-05-30','17:30:00',8.2),('6449','2013-05-30','17:35:00',7.24),('6449','2013-05-30','17:40:00',4.02),('6449','2013-05-30','17:45:00',2.61),('6449','2013-05-30','17:50:00',4.23),('6449','2013-05-30','17:55:00',7.8),('6449','2013-05-30','18:00:00',5.64),('6449','2013-05-30','18:05:00',2.05),('6449','2013-05-30','18:10:00',3.72),('6449','2013-05-30','18:15:00',2.33),('6449','2013-05-30','18:20:00',1.44),('6449','2013-05-30','18:25:00',1.22),('6449','2013-05-30','18:30:00',1.06),('6449','2013-05-30','18:35:00',1.03),('6449','2013-05-30','19:00:00',1.37),('6449','2013-05-30','19:05:00',1.8),('6449','2013-05-30','19:10:00',1.96),('6449','2013-05-30','19:15:00',1.07),('6449','2013-05-29','06:45:00',1.06),('6449','2013-05-29','06:50:00',1.12),('6449','2013-05-29','06:55:00',1.51),('6449','2013-05-29','07:00:00',1.77),('6449','2013-05-29','07:05:00',2.03),('6449','2013-05-29','07:10:00',2.35),('6449','2013-05-29','07:15:00',2.67),('6449','2013-05-29','07:20:00',2.98),('6449','2013-05-29','07:25:00',3.31),('6449','2013-05-29','07:30:00',3.64),('6449','2013-05-29','07:35:00',3.99),('6449','2013-05-29','07:40:00',4.36),('6449','2013-05-29','07:45:00',4.72),('6449','2013-05-29','07:50:00',5.09),('6449','2013-05-29','07:55:00',5.43),('6449','2013-05-29','08:00:00',5.82),('6449','2013-05-29','08:05:00',6.13),('6449','2013-05-29','08:10:00',6.58),('6449','2013-05-29','08:15:00',6.97),('6449','2013-05-29','08:20:00',7.37),('6449','2013-05-29','08:25:00',7.73),('6449','2013-05-29','08:30:00',8.02),('6449','2013-05-29','08:35:00',8.35),('6449','2013-05-29','08:40:00',8.73),('6449','2013-05-29','08:45:00',8.97),('6449','2013-05-29','08:50:00',8.99),('6449','2013-05-29','08:55:00',9.39),('6449','2013-05-29','09:00:00',9.88),('6449','2013-05-29','09:05:00',10.12),('6449','2013-05-29','09:10:00',10.53),('6449','2013-05-29','09:15:00',10.73),('6449','2013-05-29','09:20:00',10.84),('6449','2013-05-29','09:25:00',10.92),('6449','2013-05-29','09:30:00',11.28),('6449','2013-05-29','09:35:00',11.29),('6449','2013-05-29','09:40:00',11.92),('6449','2013-05-29','09:45:00',12.41),('6449','2013-05-29','09:50:00',12.58),('6449','2013-05-29','09:55:00',12.88),('6449','2013-05-29','10:00:00',13.03),('6449','2013-05-29','10:05:00',13.18),('6449','2013-05-29','10:10:00',13.38),('6449','2013-05-29','10:15:00',13.57),('6449','2013-05-29','10:20:00',13.8),('6449','2013-05-29','10:25:00',13.98),('6449','2013-05-29','10:30:00',14.26),('6449','2013-05-29','10:35:00',14.34),('6449','2013-05-29','10:40:00',14.68),('6449','2013-05-29','10:45:00',14.8),('6449','2013-05-29','10:50:00',15.01),('6449','2013-05-29','10:55:00',15.18),('6449','2013-05-29','11:00:00',15.36),('6449','2013-05-29','11:05:00',15.17),('6449','2013-05-29','11:10:00',15.62),('6449','2013-05-29','11:15:00',15.93),('6449','2013-05-29','11:20:00',16.15),('6449','2013-05-29','11:25:00',16.31),('6449','2013-05-29','11:30:00',16.37),('6449','2013-05-29','11:35:00',16.49),('6449','2013-05-29','11:40:00',16.91),('6449','2013-05-29','11:45:00',16.95),('6449','2013-05-29','11:50:00',16.5),('6449','2013-05-29','11:55:00',16.21),('6449','2013-05-29','12:00:00',16.45),('6449','2013-05-29','12:05:00',16.83),('6449','2013-05-29','12:10:00',17.1),('6449','2013-05-29','12:15:00',17.1),('6449','2013-05-29','12:20:00',17.1),('6449','2013-05-29','12:25:00',16.89),('6449','2013-05-29','12:30:00',17.17),('6449','2013-05-29','12:35:00',17.17),('6449','2013-05-29','12:40:00',17.18),('6449','2013-05-29','12:45:00',17.21),('6449','2013-05-29','12:50:00',17.1),('6449','2013-05-29','12:55:00',16.9),('6449','2013-05-29','13:00:00',17.14),('6449','2013-05-29','13:05:00',17.2),('6449','2013-05-29','13:10:00',17.3),('6449','2013-05-29','13:15:00',17.4),('6449','2013-05-29','13:20:00',17.34),('6449','2013-05-29','13:25:00',17.5),('6449','2013-05-29','13:30:00',17.32),('6449','2013-05-29','13:35:00',17.26),('6449','2013-05-29','13:40:00',17.18),('6449','2013-05-29','13:45:00',16.92),('6449','2013-05-29','13:50:00',15.96),('6449','2013-05-29','13:55:00',16.52),('6449','2013-05-29','14:00:00',16.55),('6449','2013-05-29','14:05:00',16.47),('6449','2013-05-29','14:10:00',16.28),('6449','2013-05-29','14:15:00',16.4),('6449','2013-05-29','14:20:00',16.02),('6449','2013-05-29','14:25:00',15.43),('6449','2013-05-29','14:30:00',15.93),('6449','2013-05-29','14:35:00',11.7),('6449','2013-05-29','14:40:00',15.26),('6449','2013-05-29','14:45:00',16.69),('6449','2013-05-29','14:50:00',8.95),('6449','2013-05-29','14:55:00',10.86),('6449','2013-05-29','15:00:00',8.02),('6449','2013-05-29','15:05:00',16.88),('6449','2013-05-29','15:10:00',15.32),('6449','2013-05-29','15:15:00',14.79),('6449','2013-05-29','15:20:00',14.8),('6449','2013-05-29','15:25:00',14.86),('6449','2013-05-29','15:30:00',14.22),('6449','2013-05-29','15:35:00',14.17),('6449','2013-05-29','15:40:00',11.12),('6449','2013-05-29','15:45:00',6.61),('6449','2013-05-29','15:50:00',9.41),('6449','2013-05-29','15:55:00',7.44),('6449','2013-05-29','16:00:00',5.91),('6449','2013-05-29','16:05:00',6.3),('6449','2013-05-29','16:10:00',8.9),('6449','2013-05-29','16:15:00',6.4),('6449','2013-05-29','16:20:00',5.85),('6449','2013-05-29','16:25:00',5.25),('6449','2013-05-29','16:30:00',4.83),('6449','2013-05-29','16:35:00',3.96),('6449','2013-05-29','16:40:00',4.72),('6449','2013-05-29','16:45:00',6.13),('6449','2013-05-29','16:50:00',5.93),('6449','2013-05-29','16:55:00',5.36),('6449','2013-05-29','17:00:00',5.54),('6449','2013-05-29','17:05:00',5.11),('6449','2013-05-29','17:10:00',6.86),('6449','2013-05-29','17:15:00',4.64),('6449','2013-05-29','17:20:00',2.48),('6449','2013-05-29','17:25:00',1.96),('6449','2013-05-29','17:30:00',2.08),('6449','2013-05-29','17:35:00',1.92),('6449','2013-05-29','17:45:00',1.89),('6449','2013-05-29','17:50:00',1.59),('6449','2013-05-29','17:55:00',1.12),('6449','2013-05-29','18:00:00',1.48),('6449','2013-05-29','18:05:00',1.51),('6449','2013-05-29','18:10:00',1.17),('6449','2013-05-29','18:15:00',1.55),('6449','2013-05-29','18:20:00',2.24),('6449','2013-05-29','18:25:00',3.1),('6449','2013-05-29','18:30:00',4.42),('6449','2013-05-29','18:35:00',3.04),('6449','2013-05-29','18:40:00',2.53),('6449','2013-05-29','18:45:00',1.91),('6449','2013-05-29','18:50:00',1.5),('6449','2013-05-29','18:55:00',2.34),('6449','2013-05-29','19:00:00',1.54),('6449','2013-05-29','19:05:00',1.26),('6449','2013-05-29','19:10:00',1.54),('6449','2013-05-29','19:15:00',1.68),('6449','2013-05-29','19:20:00',1.47),('6449','2013-05-29','19:25:00',1.24),('6449','2013-05-28','06:40:00',1.14),('6449','2013-05-28','06:45:00',1.52),('6449','2013-05-28','06:50:00',1.91),('6449','2013-05-28','06:55:00',2.36),('6449','2013-05-28','07:00:00',2.8),('6449','2013-05-28','07:05:00',3.06),('6449','2013-05-28','07:10:00',2.67),('6449','2013-05-28','07:15:00',2.68),('6449','2013-05-28','07:20:00',2.71),('6449','2013-05-28','07:25:00',2.57),('6449','2013-05-28','07:30:00',3.74),('6449','2013-05-28','07:35:00',3.56),('6449','2013-05-28','07:40:00',3.2),('6449','2013-05-28','07:45:00',3.82),('6449','2013-05-28','07:50:00',4.34),('6449','2013-05-28','07:55:00',5.65),('6449','2013-05-28','08:00:00',5.93),('6449','2013-05-28','08:05:00',3.81),('6449','2013-05-28','08:10:00',4.41),('6449','2013-05-28','08:15:00',5.41),('6449','2013-05-28','08:20:00',7.45),('6449','2013-05-28','08:25:00',7.56),('6449','2013-05-28','08:30:00',7.1),('6449','2013-05-28','08:35:00',6.74),('6449','2013-05-28','08:40:00',8.35),('6449','2013-05-28','08:45:00',9.11),('6449','2013-05-28','08:50:00',8.6),('6449','2013-05-28','08:55:00',8.54),('6449','2013-05-28','09:00:00',8.02),('6449','2013-05-28','09:05:00',7.89),('6449','2013-05-28','09:10:00',5.83),('6449','2013-05-28','09:15:00',8.76),('6449','2013-05-28','09:20:00',11.01),('6449','2013-05-28','09:25:00',10.82),('6449','2013-05-28','09:30:00',10.38),('6449','2013-05-28','09:35:00',8.32),('6449','2013-05-28','09:40:00',9.12),('6449','2013-05-28','09:45:00',9.28),('6449','2013-05-28','09:50:00',10),('6449','2013-05-28','09:55:00',8.26),('6449','2013-05-28','10:00:00',7),('6449','2013-05-28','10:05:00',8.19),('6449','2013-05-28','10:10:00',10.76),('6449','2013-05-28','10:15:00',9.66),('6449','2013-05-28','10:20:00',10.4),('6449','2013-05-28','10:25:00',7.24),('6449','2013-05-28','10:30:00',10.6),('6449','2013-05-28','10:35:00',11.44),('6449','2013-05-28','10:40:00',10.17),('6449','2013-05-28','10:45:00',10.25),('6449','2013-05-28','10:50:00',10.69),('6449','2013-05-28','10:55:00',5.41),('6449','2013-05-28','11:00:00',4.73),('6449','2013-05-28','11:05:00',6.06),('6449','2013-05-28','11:10:00',13.45),('6449','2013-05-28','11:15:00',15.41),('6449','2013-05-28','11:20:00',14.95),('6449','2013-05-28','11:25:00',14.53),('6449','2013-05-28','11:30:00',16.09),('6449','2013-05-28','11:35:00',6.41),('6449','2013-05-28','11:40:00',7.12),('6449','2013-05-28','11:45:00',8.5),('6449','2013-05-28','11:50:00',7.2),('6449','2013-05-28','11:55:00',7.36),('6449','2013-05-28','12:00:00',7.6),('6449','2013-05-28','12:05:00',8.31),('6449','2013-05-28','12:10:00',7.84),('6449','2013-05-28','12:15:00',6.21),('6449','2013-05-28','12:20:00',6.95),('6449','2013-05-28','12:25:00',6.45),('6449','2013-05-28','12:30:00',7.38),('6449','2013-05-28','12:35:00',6.81),('6449','2013-05-28','12:40:00',14.17),('6449','2013-05-28','12:45:00',16.67),('6449','2013-05-28','12:50:00',7.86),('6449','2013-05-28','12:55:00',8.04),('6449','2013-05-28','13:00:00',9.48),('6449','2013-05-28','13:05:00',11.65),('6449','2013-05-28','13:10:00',13.31),('6449','2013-05-28','13:15:00',14.07),('6449','2013-05-28','13:20:00',12.3),('6449','2013-05-28','13:25:00',12.07),('6449','2013-05-28','13:30:00',11.68),('6449','2013-05-28','13:35:00',10.93),('6449','2013-05-28','13:40:00',7.79),('6449','2013-05-28','13:45:00',11),('6449','2013-05-28','13:50:00',10.67),('6449','2013-05-28','13:55:00',7.95),('6449','2013-05-28','14:00:00',8.3),('6449','2013-05-28','14:05:00',13.18),('6449','2013-05-28','14:10:00',14.33),('6449','2013-05-28','14:15:00',14.12),('6449','2013-05-28','14:20:00',13.62),('6449','2013-05-28','14:25:00',12.67),('6449','2013-05-28','14:30:00',9.5),('6449','2013-05-28','14:35:00',15.7),('6449','2013-05-28','14:40:00',11.2),('6449','2013-05-28','14:45:00',16.24),('6449','2013-05-28','14:50:00',12.34),('6449','2013-05-28','14:55:00',6.95),('6449','2013-05-28','15:00:00',6.23),('6449','2013-05-28','15:05:00',6.45),('6449','2013-05-28','15:10:00',7.37),('6449','2013-05-28','15:15:00',8.8),('6449','2013-05-28','15:20:00',12.54),('6449','2013-05-28','15:25:00',10.86),('6449','2013-05-28','15:30:00',11.86),('6449','2013-05-28','15:35:00',10.53),('6449','2013-05-28','15:40:00',6.5),('6449','2013-05-28','15:45:00',4.45),('6449','2013-05-28','15:50:00',3.95),('6449','2013-05-28','15:55:00',4.18),('6449','2013-05-28','16:00:00',3.63),('6449','2013-05-28','16:05:00',3.81),('6449','2013-05-28','16:10:00',4.07),('6449','2013-05-28','16:15:00',3.87),('6449','2013-05-28','16:20:00',3.68),('6449','2013-05-28','16:25:00',3.91),('6449','2013-05-28','16:30:00',4.3),('6449','2013-05-28','16:35:00',4.97),('6449','2013-05-28','16:40:00',4.79),('6449','2013-05-28','16:45:00',4.52),('6449','2013-05-28','16:50:00',4.48),('6449','2013-05-28','16:55:00',5.29),('6449','2013-05-28','17:00:00',6.17),('6449','2013-05-28','17:05:00',8.25),('6449','2013-05-28','17:10:00',5.31),('6449','2013-05-28','17:15:00',6.03),('6449','2013-05-28','17:20:00',6.45),('6449','2013-05-28','17:25:00',5.02),('6449','2013-05-28','17:30:00',5.94),('6449','2013-05-28','17:35:00',4.02),('6449','2013-05-28','17:40:00',3.59),('6449','2013-05-28','17:45:00',3.49),('6449','2013-05-28','17:50:00',3.54),('6449','2013-05-28','17:55:00',3.48),('6449','2013-05-28','18:00:00',3.38),('6449','2013-05-28','18:05:00',2.78),('6449','2013-05-28','18:10:00',2.69),('6449','2013-05-28','18:15:00',4.45),('6449','2013-05-28','18:20:00',3.64),('6449','2013-05-28','18:25:00',2.03),('6449','2013-05-28','18:30:00',1.8),('6449','2013-05-28','18:35:00',2.21),('6449','2013-05-28','18:40:00',1.18),('6449','2013-05-28','18:45:00',1.17),('6449','2013-05-28','18:50:00',1.05),('6449','2013-05-28','19:05:00',1.02),('6449','2013-05-28','19:10:00',1.17),('6449','2013-05-28','19:15:00',1.04),('6449','2013-05-27','06:55:00',1.04),('6449','2013-05-27','07:00:00',1.38),('6449','2013-05-27','07:05:00',1.39),('6449','2013-05-27','07:10:00',1.03),('6449','2013-05-27','07:15:00',1.1),('6449','2013-05-27','07:20:00',1.03),('6449','2013-05-27','07:25:00',1.11),('6449','2013-05-27','07:30:00',1.29),('6449','2013-05-27','07:35:00',1.11),('6449','2013-05-27','07:40:00',1.23),('6449','2013-05-27','07:45:00',3.9),('6449','2013-05-27','07:50:00',5.43),('6449','2013-05-27','07:55:00',5.73),('6449','2013-05-27','08:00:00',6.15),('6449','2013-05-27','08:05:00',6.49),('6449','2013-05-27','08:10:00',6.88),('6449','2013-05-27','08:15:00',7.22),('6449','2013-05-27','08:20:00',7.53),('6449','2013-05-27','08:25:00',7.87),('6449','2013-05-27','08:30:00',8.18),('6449','2013-05-27','08:35:00',8.51),('6449','2013-05-27','08:40:00',8.85),('6449','2013-05-27','08:45:00',9.19),('6449','2013-05-27','08:50:00',9.54),('6449','2013-05-27','08:55:00',9.75),('6449','2013-05-27','09:00:00',9.92),('6449','2013-05-27','09:05:00',10.37),('6449','2013-05-27','09:10:00',10.63),('6449','2013-05-27','09:15:00',10.79),('6449','2013-05-27','09:20:00',11.07),('6449','2013-05-27','09:25:00',11.3),('6449','2013-05-27','09:30:00',11.46),('6449','2013-05-27','09:35:00',11.68),('6449','2013-05-27','09:40:00',12.06),('6449','2013-05-27','09:45:00',12.15),('6449','2013-05-27','09:50:00',12.41),('6449','2013-05-27','09:55:00',12.84),('6449','2013-05-27','10:00:00',13.32),('6449','2013-05-27','10:05:00',13.31),('6449','2013-05-27','10:10:00',13.62),('6449','2013-05-27','10:15:00',13.7),('6449','2013-05-27','10:20:00',13.94),('6449','2013-05-27','10:25:00',14.19),('6449','2013-05-27','10:30:00',14.28),('6449','2013-05-27','10:35:00',14.48),('6449','2013-05-27','10:40:00',15.2),('6449','2013-05-27','10:45:00',15.14),('6449','2013-05-27','10:50:00',15.77),('6449','2013-05-27','10:55:00',15.09),('6449','2013-05-27','11:00:00',14.06),('6449','2013-05-27','11:05:00',8.47),('6449','2013-05-27','11:10:00',10.83),('6449','2013-05-27','11:15:00',11.37),('6449','2013-05-27','11:20:00',9.16),('6449','2013-05-27','11:25:00',17.38),('6449','2013-05-27','11:30:00',17.1),('6449','2013-05-27','11:35:00',17.04),('6449','2013-05-27','11:40:00',16.39),('6449','2013-05-27','11:45:00',16.32),('6449','2013-05-27','11:50:00',16.4),('6449','2013-05-27','11:55:00',16.43),('6449','2013-05-27','12:00:00',16.68),('6449','2013-05-27','12:05:00',16.52),('6449','2013-05-27','12:10:00',16.95),('6449','2013-05-27','12:15:00',16.95),('6449','2013-05-27','12:20:00',16.97),('6449','2013-05-27','12:25:00',16.66),('6449','2013-05-27','12:30:00',16.39),('6449','2013-05-27','12:35:00',16.62),('6449','2013-05-27','12:40:00',16.8),('6449','2013-05-27','12:45:00',16.96),('6449','2013-05-27','12:50:00',16.8),('6449','2013-05-27','12:55:00',16.55),('6449','2013-05-27','13:00:00',16.23),('6449','2013-05-27','13:05:00',16.34),('6449','2013-05-27','13:10:00',17.3),('6449','2013-05-27','13:15:00',16.66),('6449','2013-05-27','13:20:00',15.18),('6449','2013-05-27','13:25:00',16.67),('6449','2013-05-27','13:30:00',17.1),('6449','2013-05-27','13:35:00',16.94),('6449','2013-05-27','13:40:00',16.62),('6449','2013-05-27','13:45:00',16.52),('6449','2013-05-27','13:50:00',16.72),('6449','2013-05-27','13:55:00',16.54),('6449','2013-05-27','14:00:00',16.52),('6449','2013-05-27','14:05:00',16),('6449','2013-05-27','14:10:00',16.16),('6449','2013-05-27','14:15:00',16.14),('6449','2013-05-27','14:20:00',16.04),('6449','2013-05-27','14:25:00',16.19),('6449','2013-05-27','14:30:00',16.04),('6449','2013-05-27','14:35:00',15.56),('6449','2013-05-27','14:40:00',15.02),('6449','2013-05-27','14:45:00',11.1),('6449','2013-05-27','14:50:00',12.94),('6449','2013-05-27','14:55:00',16.78),('6449','2013-05-27','15:00:00',13.26),('6449','2013-05-27','15:05:00',10),('6449','2013-05-27','15:10:00',16.36),('6449','2013-05-27','15:15:00',14.82),('6449','2013-05-27','15:20:00',14.94),('6449','2013-05-27','15:25:00',12.66),('6449','2013-05-27','15:30:00',10.03),('6449','2013-05-27','15:35:00',11.23),('6449','2013-05-27','15:40:00',9.93),('6449','2013-05-27','15:45:00',12.88),('6449','2013-05-27','15:50:00',11.89),('6449','2013-05-27','15:55:00',10.64),('6449','2013-05-27','16:00:00',9.67),('6449','2013-05-27','16:05:00',13.17),('6449','2013-05-27','16:10:00',13.5),('6449','2013-05-27','16:15:00',11.04),('6449','2013-05-27','16:20:00',8.3),('6449','2013-05-27','16:25:00',8.63),('6449','2013-05-27','16:30:00',10.05),('6449','2013-05-27','16:35:00',6.14),('6449','2013-05-27','16:40:00',9.37),('6449','2013-05-27','16:45:00',8.59),('6449','2013-05-27','16:50:00',5.35),('6449','2013-05-27','16:55:00',4.76),('6449','2013-05-27','17:00:00',4.55),('6449','2013-05-27','17:05:00',4.34),('6449','2013-05-27','17:10:00',4.24),('6449','2013-05-27','17:15:00',4.52),('6449','2013-05-27','17:20:00',4.49),('6449','2013-05-27','17:25:00',3.92),('6449','2013-05-27','17:30:00',4.89),('6449','2013-05-27','17:35:00',4.24),('6449','2013-05-27','17:40:00',3.42),('6449','2013-05-27','17:45:00',3.28),('6449','2013-05-27','17:50:00',3.29),('6449','2013-05-27','17:55:00',3.3),('6449','2013-05-27','18:00:00',3.26),('6449','2013-05-27','18:05:00',3.27),('6449','2013-05-27','18:10:00',5.02),('6449','2013-05-27','18:15:00',6.07),('6449','2013-05-27','18:20:00',4.86),('6449','2013-05-27','18:25:00',4.4),('6449','2013-05-27','18:30:00',3.63),('6449','2013-05-27','18:35:00',2.81),('6449','2013-05-27','18:40:00',2.51),('6449','2013-05-27','18:45:00',3),('6449','2013-05-27','18:50:00',2.97),('6449','2013-05-27','18:55:00',2.39),('6449','2013-05-27','19:00:00',1.76),('6449','2013-05-27','19:05:00',1.34),('6449','2013-05-27','19:10:00',1.22),('6449','2013-05-27','19:15:00',1.14),('6449','2013-05-27','19:20:00',1.01),('6449','2013-05-26','06:50:00',1.33),('6449','2013-05-26','06:55:00',1.07),('6449','2013-05-26','07:05:00',1.77),('6449','2013-05-26','07:10:00',1.83),('6449','2013-05-26','07:15:00',2.77),('6449','2013-05-26','07:20:00',4.6),('6449','2013-05-26','07:50:00',1.01),('6449','2013-05-26','07:55:00',1.54),('6449','2013-05-26','08:00:00',1.15),('6449','2013-05-26','08:05:00',2.17),('6449','2013-05-26','08:10:00',2.59),('6449','2013-05-26','08:15:00',2.87),('6449','2013-05-26','08:20:00',4.36),('6449','2013-05-26','08:25:00',2.66),('6449','2013-05-26','08:30:00',2.43),('6449','2013-05-26','08:35:00',3.99),('6449','2013-05-26','08:40:00',2.32),('6449','2013-05-26','08:55:00',2.16),('6449','2013-05-26','09:00:00',11.1),('6449','2013-05-26','09:05:00',11.07),('6449','2013-05-26','09:10:00',11.28),('6449','2013-05-26','09:15:00',11.41),('6449','2013-05-26','09:20:00',11.76),('6449','2013-05-26','09:25:00',12.1),('6449','2013-05-26','09:30:00',12.37),('6449','2013-05-26','09:35:00',12.55),('6449','2013-05-26','09:40:00',12.87),('6449','2013-05-26','09:45:00',13.16),('6449','2013-05-26','09:50:00',13.57),('6449','2013-05-26','09:55:00',13.74),('6449','2013-05-26','10:00:00',13.98),('6449','2013-05-26','10:05:00',14.32),('6449','2013-05-26','10:10:00',14.49),('6449','2013-05-26','10:15:00',14.65),('6449','2013-05-26','10:20:00',14.93),('6449','2013-05-26','10:25:00',15.06),('6449','2013-05-26','10:30:00',15.03),('6449','2013-05-26','10:35:00',15.63),('6449','2013-05-26','10:40:00',15.85),('6449','2013-05-26','10:45:00',16.01),('6449','2013-05-26','10:50:00',16.16),('6449','2013-05-26','10:55:00',16.26),('6449','2013-05-26','11:00:00',15.94),('6449','2013-05-26','11:05:00',16.63),('6449','2013-05-26','11:10:00',16.76),('6449','2013-05-26','11:15:00',16.85),('6449','2013-05-26','11:20:00',16.93),('6449','2013-05-26','11:25:00',17.05),('6449','2013-05-26','11:30:00',17.19),('6449','2013-05-26','11:35:00',17.36),('6449','2013-05-26','11:40:00',17.49),('6449','2013-05-26','11:45:00',17.61),('6449','2013-05-26','11:50:00',17.65),('6449','2013-05-26','11:55:00',17.76),('6449','2013-05-26','12:00:00',17.77),('6449','2013-05-26','12:05:00',17.91),('6449','2013-05-26','12:10:00',17.89),('6449','2013-05-26','12:15:00',17.46),('6449','2013-05-26','12:20:00',17.9),('6449','2013-05-26','12:25:00',17.94),('6449','2013-05-26','12:30:00',17.96),('6449','2013-05-26','12:35:00',17.99),('6449','2013-05-26','12:40:00',18.16),('6449','2013-05-26','12:45:00',17.69),('6449','2013-05-26','12:50:00',18),('6449','2013-05-26','12:55:00',18.22),('6449','2013-05-26','13:00:00',18.57),('6449','2013-05-26','13:05:00',18.46),('6449','2013-05-26','13:10:00',19.02),('6449','2013-05-26','13:15:00',19.73),('6449','2013-05-26','13:20:00',18.16),('6449','2013-05-26','13:25:00',17.7),('6449','2013-05-26','13:30:00',17.62),('6449','2013-05-26','13:35:00',17.62),('6449','2013-05-26','13:40:00',17.52),('6449','2013-05-26','13:45:00',17.48),('6449','2013-05-26','13:50:00',17.39),('6449','2013-05-26','13:55:00',17.35),('6449','2013-05-26','14:00:00',16.85),('6449','2013-05-26','14:05:00',17.21),('6449','2013-05-26','14:10:00',17.08),('6449','2013-05-26','14:15:00',16.96),('6449','2013-05-26','14:20:00',16.85),('6449','2013-05-26','14:25:00',16.74),('6449','2013-05-26','14:30:00',16.13),('6449','2013-05-26','14:35:00',16.53),('6449','2013-05-26','14:40:00',16.46),('6449','2013-05-26','14:45:00',16.22),('6449','2013-05-26','14:50:00',16.1),('6449','2013-05-26','14:55:00',15.96),('6449','2013-05-26','15:00:00',15.72),('6449','2013-05-26','15:05:00',15.57),('6449','2013-05-26','15:10:00',15.28),('6449','2013-05-26','15:15:00',15.11),('6449','2013-05-26','15:20:00',14.89),('6449','2013-05-26','15:25:00',14.62),('6449','2013-05-26','15:30:00',14.43),('6449','2013-05-26','15:35:00',14.19),('6449','2013-05-26','15:40:00',13.94),('6449','2013-05-26','15:45:00',13.41),('6449','2013-05-26','15:50:00',13.47),('6449','2013-05-26','15:55:00',13.19),('6449','2013-05-26','16:00:00',12.85),('6449','2013-05-26','16:05:00',12.61),('6449','2013-05-26','16:10:00',12.47),('6449','2013-05-26','16:15:00',11.83),('6449','2013-05-26','16:20:00',11.81),('6449','2013-05-26','16:25:00',11.57),('6449','2013-05-26','16:30:00',11.37),('6449','2013-05-26','16:35:00',10.27),('6449','2013-05-26','16:40:00',7.9),('6449','2013-05-26','16:45:00',10.57),('6449','2013-05-26','16:50:00',9.99),('6449','2013-05-26','16:55:00',9.69),('6449','2013-05-26','17:00:00',9.37),('6449','2013-05-26','17:05:00',9.04),('6449','2013-05-26','17:10:00',8.71),('6449','2013-05-26','17:15:00',8.37),('6449','2013-05-26','17:20:00',8.06),('6449','2013-05-26','17:25:00',7.68),('6449','2013-05-26','17:30:00',7.13),('6449','2013-05-26','17:35:00',6.89),('6449','2013-05-26','17:40:00',6.56),('6449','2013-05-26','17:45:00',6.18),('6449','2013-05-26','17:50:00',5.85),('6449','2013-05-26','17:55:00',5.41),('6449','2013-05-26','18:00:00',4.95),('6449','2013-05-26','18:05:00',4.65),('6449','2013-05-26','18:10:00',4.3),('6449','2013-05-26','18:15:00',3.94),('6449','2013-05-26','18:20:00',3.57),('6449','2013-05-26','18:25:00',3.2),('6449','2013-05-26','18:30:00',2.85),('6449','2013-05-26','18:35:00',2.51),('6449','2013-05-26','18:40:00',2.18),('6449','2013-05-26','18:45:00',1.89),('6449','2013-05-26','18:50:00',1.61),('6449','2013-05-26','18:55:00',1.35),('6449','2013-05-26','19:00:00',1.12),('6449','2013-05-25','06:35:00',1.45),('6449','2013-05-25','06:40:00',1.32),('6449','2013-05-25','06:45:00',1.47),('6449','2013-05-25','06:50:00',1.68),('6449','2013-05-25','06:55:00',1.27),('6449','2013-05-25','07:00:00',1.14),('6449','2013-05-25','07:30:00',2.27),('6449','2013-05-25','07:35:00',4.58),('6449','2013-05-25','07:40:00',4.36),('6449','2013-05-25','07:45:00',4.25),('6449','2013-05-25','07:50:00',5.35),('6449','2013-05-25','07:55:00',5.92),('6449','2013-05-25','08:00:00',6.5),('6449','2013-05-25','08:05:00',7.14),('6449','2013-05-25','08:10:00',6.36),('6449','2013-05-25','08:15:00',5.99),('6449','2013-05-25','08:20:00',6.79),('6449','2013-05-25','08:25:00',5.63),('6449','2013-05-25','08:30:00',6.91),('6449','2013-05-25','08:35:00',8.97),('6449','2013-05-25','08:40:00',4.24),('6449','2013-05-25','08:45:00',3.59),('6449','2013-05-25','08:50:00',3.55),('6449','2013-05-25','08:55:00',8.01),('6449','2013-05-25','09:00:00',10.52),('6449','2013-05-25','09:05:00',4.73),('6449','2013-05-25','09:10:00',4.63),('6449','2013-05-25','09:15:00',4.36),('6449','2013-05-25','09:20:00',2.85),('6449','2013-05-25','09:25:00',2.11),('6449','2013-05-25','09:30:00',1.5),('6449','2013-05-25','09:35:00',2),('6449','2013-05-25','09:40:00',2.33),('6449','2013-05-25','09:45:00',2.06),('6449','2013-05-25','09:50:00',2.17),('6449','2013-05-25','09:55:00',3.67),('6449','2013-05-25','10:00:00',6.66),('6449','2013-05-25','10:05:00',5.39),('6449','2013-05-25','10:10:00',3.46),('6449','2013-05-25','10:15:00',2.27),('6449','2013-05-25','10:20:00',2.63),('6449','2013-05-25','10:25:00',4.32),('6449','2013-05-25','10:30:00',6.47),('6449','2013-05-25','10:35:00',6.11),('6449','2013-05-25','10:40:00',3.41),('6449','2013-05-25','10:45:00',3.6),('6449','2013-05-25','10:50:00',4.09),('6449','2013-05-25','10:55:00',4.13),('6449','2013-05-25','11:00:00',5.45),('6449','2013-05-25','11:05:00',6.54),('6449','2013-05-25','11:10:00',5.12),('6449','2013-05-25','11:15:00',8.8),('6449','2013-05-25','11:20:00',8.23),('6449','2013-05-25','11:25:00',2.57),('6449','2013-05-25','11:30:00',5.38),('6449','2013-05-25','11:35:00',6.8),('6449','2013-05-25','11:40:00',5.32),('6449','2013-05-25','11:45:00',4.81),('6449','2013-05-25','11:50:00',4.41),('6449','2013-05-25','11:55:00',4.46),('6449','2013-05-25','12:00:00',4.64),('6449','2013-05-25','12:05:00',4.16),('6449','2013-05-25','12:10:00',3.14),('6449','2013-05-25','12:15:00',3.33),('6449','2013-05-25','12:20:00',2.71),('6449','2013-05-25','12:25:00',3.36),('6449','2013-05-25','12:30:00',4.12),('6449','2013-05-25','12:35:00',5.79),('6449','2013-05-25','12:40:00',10.38),('6449','2013-05-25','12:45:00',11.24),('6449','2013-05-25','12:50:00',12.69),('6449','2013-05-25','12:55:00',19.52),('6449','2013-05-25','13:00:00',12.67),('6449','2013-05-25','13:05:00',4.99),('6449','2013-05-25','13:10:00',10.9),('6449','2013-05-25','13:15:00',12.48),('6449','2013-05-25','13:20:00',18.57),('6449','2013-05-25','13:25:00',16.47),('6449','2013-05-25','13:30:00',16.16),('6449','2013-05-25','13:35:00',13.82),('6449','2013-05-25','13:40:00',12.73),('6449','2013-05-25','13:45:00',13.67),('6449','2013-05-25','13:50:00',10.88),('6449','2013-05-25','13:55:00',18.75),('6449','2013-05-25','14:00:00',17.6),('6449','2013-05-25','14:05:00',17.37),('6449','2013-05-25','14:10:00',16.63),('6449','2013-05-25','14:15:00',16.79),('6449','2013-05-25','14:20:00',16.87),('6449','2013-05-25','14:25:00',14.21),('6449','2013-05-25','14:30:00',10.19),('6449','2013-05-25','14:35:00',9.6),('6449','2013-05-25','14:40:00',14.83),('6449','2013-05-25','14:45:00',4.14),('6449','2013-05-25','14:50:00',11.89),('6449','2013-05-25','14:55:00',15.92),('6449','2013-05-25','15:00:00',15.27),('6449','2013-05-25','15:05:00',14.1),('6449','2013-05-25','15:10:00',15.86),('6449','2013-05-25','15:15:00',15.54),('6449','2013-05-25','15:20:00',14.22),('6449','2013-05-25','15:25:00',13.61),('6449','2013-05-25','15:30:00',5.89),('6449','2013-05-25','15:35:00',4.92),('6449','2013-05-25','15:40:00',15.04),('6449','2013-05-25','15:45:00',9.89),('6449','2013-05-25','15:50:00',6.48),('6449','2013-05-25','15:55:00',13.3),('6449','2013-05-25','16:00:00',10.14),('6449','2013-05-25','16:05:00',12.85),('6449','2013-05-25','16:10:00',12.46),('6449','2013-05-25','16:15:00',10.47),('6449','2013-05-25','16:20:00',12.26),('6449','2013-05-25','16:25:00',12.4),('6449','2013-05-25','16:30:00',11.84),('6449','2013-05-25','16:35:00',12.06),('6449','2013-05-25','16:40:00',7.72),('6449','2013-05-25','16:45:00',9.6),('6449','2013-05-25','16:50:00',10.21),('6449','2013-05-25','16:55:00',10),('6449','2013-05-25','17:00:00',9.75),('6449','2013-05-25','17:05:00',9.32),('6449','2013-05-25','17:10:00',8.98),('6449','2013-05-25','17:15:00',8.49),('6449','2013-05-25','17:20:00',6.02),('6449','2013-05-25','17:25:00',1.91),('6449','2013-05-25','17:30:00',1.95),('6449','2013-05-25','17:35:00',3.03),('6449','2013-05-25','17:40:00',3.6),('6449','2013-05-25','17:45:00',2.88),('6449','2013-05-25','17:50:00',1.69),('6449','2013-05-25','17:55:00',1.29),('6449','2013-05-25','18:00:00',1.06),('6449','2013-05-25','18:05:00',1.08),('6449','2013-05-25','18:10:00',1.37),('6449','2013-05-25','18:15:00',1.18),('6449','2013-05-25','18:20:00',1.26),('6449','2013-05-25','18:40:00',3.05),('6449','2013-05-25','18:45:00',1.95),('6449','2013-05-25','18:50:00',1.33),('6449','2013-05-25','19:10:00',1.43),('6449','2013-05-25','19:15:00',1.01),('6449','2013-05-24','07:15:00',1.26),('6449','2013-05-24','07:20:00',1.76),('6449','2013-05-24','07:25:00',2.09),('6449','2013-05-24','07:30:00',2.02),('6449','2013-05-24','07:35:00',1.66),('6449','2013-05-24','07:40:00',1.69),('6449','2013-05-24','07:45:00',4.85),('6449','2013-05-24','07:50:00',4.93),('6449','2013-05-24','07:55:00',5.25),('6449','2013-05-24','08:00:00',5.61),('6449','2013-05-24','08:05:00',5.58),('6449','2013-05-24','08:10:00',5.07),('6449','2013-05-24','08:15:00',4.25),('6449','2013-05-24','08:20:00',5.36),('6449','2013-05-24','08:25:00',8.59),('6449','2013-05-24','08:30:00',2.9),('6449','2013-05-24','08:35:00',4.98),('6449','2013-05-24','08:40:00',6.07),('6449','2013-05-24','08:45:00',4.44),('6449','2013-05-24','08:50:00',8.69),('6449','2013-05-24','08:55:00',10.98),('6449','2013-05-24','09:00:00',9.76),('6449','2013-05-24','09:05:00',11.06),('6449','2013-05-24','09:10:00',7),('6449','2013-05-24','09:15:00',4.52),('6449','2013-05-24','09:20:00',11.27),('6449','2013-05-24','09:25:00',10.57),('6449','2013-05-24','09:30:00',4.85),('6449','2013-05-24','09:35:00',12.75),('6449','2013-05-24','09:40:00',5.99),('6449','2013-05-24','09:45:00',3.79),('6449','2013-05-24','09:50:00',2.7),('6449','2013-05-24','09:55:00',4.37),('6449','2013-05-24','10:00:00',13.61),('6449','2013-05-24','10:05:00',14.57),('6449','2013-05-24','10:10:00',8.14),('6449','2013-05-24','10:15:00',3.79),('6449','2013-05-24','10:20:00',9.47),('6449','2013-05-24','10:25:00',15.69),('6449','2013-05-24','10:30:00',13.65),('6449','2013-05-24','10:35:00',14.94),('6449','2013-05-24','10:40:00',16.59),('6449','2013-05-24','10:45:00',9.25),('6449','2013-05-24','10:50:00',5.84),('6449','2013-05-24','10:55:00',13.08),('6449','2013-05-24','11:00:00',16.91),('6449','2013-05-24','11:05:00',17.68),('6449','2013-05-24','11:10:00',12.08),('6449','2013-05-24','11:15:00',8.46),('6449','2013-05-24','11:20:00',15.56),('6449','2013-05-24','11:25:00',17.67),('6449','2013-05-24','11:30:00',17.61),('6449','2013-05-24','11:35:00',17.06),('6449','2013-05-24','11:40:00',17.72),('6449','2013-05-24','11:45:00',14.34),('6449','2013-05-24','11:50:00',15.82),('6449','2013-05-24','11:55:00',14.98),('6449','2013-05-24','12:00:00',17.74),('6449','2013-05-24','12:05:00',19.25),('6449','2013-05-24','12:10:00',19.59),('6449','2013-05-24','12:15:00',8.65),('6449','2013-05-24','12:20:00',15.91),('6449','2013-05-24','12:25:00',17.93),('6449','2013-05-24','12:30:00',12.24),('6449','2013-05-24','12:35:00',12.54),('6449','2013-05-24','12:40:00',19.4),('6449','2013-05-24','12:45:00',16.23),('6449','2013-05-24','12:50:00',11.42),('6449','2013-05-24','12:55:00',6.11),('6449','2013-05-24','13:00:00',9.97),('6449','2013-05-24','13:05:00',18.71),('6449','2013-05-24','13:10:00',18.2),('6449','2013-05-24','13:15:00',17.94),('6449','2013-05-24','13:20:00',18.22),('6449','2013-05-24','13:25:00',15.62),('6449','2013-05-24','13:30:00',3.76),('6449','2013-05-24','13:35:00',5.96),('6449','2013-05-24','13:40:00',12.01),('6449','2013-05-24','13:45:00',19.44),('6449','2013-05-24','13:50:00',9.84),('6449','2013-05-24','13:55:00',4.93),('6449','2013-05-24','14:00:00',11.61),('6449','2013-05-24','14:05:00',19.11),('6449','2013-05-24','14:10:00',18.33),('6449','2013-05-24','14:15:00',13.35),('6449','2013-05-24','14:20:00',17.09),('6449','2013-05-24','14:25:00',14.72),('6449','2013-05-24','14:30:00',10.54),('6449','2013-05-24','14:35:00',10.32),('6449','2013-05-24','14:40:00',15.5),('6449','2013-05-24','14:45:00',14.84),('6449','2013-05-24','14:50:00',16.84),('6449','2013-05-24','14:55:00',16.01),('6449','2013-05-24','15:00:00',15.75),('6449','2013-05-24','15:05:00',17.06),('6449','2013-05-24','15:10:00',16.87),('6449','2013-05-24','15:15:00',16.61),('6449','2013-05-24','15:20:00',15.52),('6449','2013-05-24','15:25:00',15.28),('6449','2013-05-24','15:30:00',13.42),('6449','2013-05-24','15:35:00',5.55),('6449','2013-05-24','15:40:00',6.1),('6449','2013-05-24','15:45:00',5.04),('6449','2013-05-24','15:50:00',5.41),('6449','2013-05-24','15:55:00',9.77),('6449','2013-05-24','16:00:00',7.87),('6449','2013-05-24','16:05:00',5.32),('6449','2013-05-24','16:10:00',4.67),('6449','2013-05-24','16:15:00',4.1),('6449','2013-05-24','16:20:00',4.58),('6449','2013-05-24','16:25:00',2.97),('6449','2013-05-24','16:30:00',3.23),('6449','2013-05-24','16:35:00',4.22),('6449','2013-05-24','16:40:00',4.46),('6449','2013-05-24','16:45:00',4.64),('6449','2013-05-24','16:50:00',6.99),('6449','2013-05-24','16:55:00',13.76),('6449','2013-05-24','17:00:00',12.66),('6449','2013-05-24','17:05:00',10.57),('6449','2013-05-24','17:10:00',4.24),('6449','2013-05-24','17:15:00',4.65),('6449','2013-05-24','17:20:00',4.52),('6449','2013-05-24','17:25:00',5.05),('6449','2013-05-24','17:30:00',9.34),('6449','2013-05-24','17:35:00',4.94),('6449','2013-05-24','17:40:00',2.88),('6449','2013-05-24','17:45:00',3.37),('6449','2013-05-24','17:50:00',3.52),('6449','2013-05-24','17:55:00',3.12),('6449','2013-05-24','18:00:00',1.96),('6449','2013-05-24','18:05:00',1.45),('6449','2013-05-24','18:10:00',1.4),('6449','2013-05-24','18:15:00',1.51),('6449','2013-05-24','18:20:00',1.69),('6449','2013-05-24','18:25:00',1.63),('6449','2013-05-24','18:30:00',1.72),('6449','2013-05-24','18:35:00',1.4),('6449','2013-05-24','18:40:00',1.22),('6449','2013-05-24','18:45:00',1.23),('6449','2013-05-24','18:50:00',1.25),('6449','2013-05-24','18:55:00',1.35),('6449','2013-05-24','19:00:00',1.18),('6449','2013-05-23','07:00:00',1.02),('6449','2013-05-23','07:05:00',1.17),('6449','2013-05-23','07:10:00',1.41),('6449','2013-05-23','07:15:00',1.59),('6449','2013-05-23','07:20:00',2.96),('6449','2013-05-23','07:25:00',4.64),('6449','2013-05-23','07:30:00',4.46),('6449','2013-05-23','07:35:00',3.87),('6449','2013-05-23','07:40:00',1.13),('6449','2013-05-23','07:45:00',1.64),('6449','2013-05-23','07:50:00',2.13),('6449','2013-05-23','07:55:00',1.86),('6449','2013-05-23','08:00:00',3.21),('6449','2013-05-23','08:05:00',3.08),('6449','2013-05-23','08:10:00',2.9),('6449','2013-05-23','08:15:00',2.4),('6449','2013-05-23','08:20:00',2.34),('6449','2013-05-23','08:25:00',7.75),('6449','2013-05-23','08:30:00',7.02),('6449','2013-05-23','08:35:00',4.39),('6449','2013-05-23','08:40:00',7.44),('6449','2013-05-23','08:45:00',6.68),('6449','2013-05-23','08:50:00',9.61),('6449','2013-05-23','08:55:00',9.78),('6449','2013-05-23','09:00:00',10.08),('6449','2013-05-23','09:05:00',10.52),('6449','2013-05-23','09:10:00',10.78),('6449','2013-05-23','09:15:00',11.01),('6449','2013-05-23','09:20:00',11.58),('6449','2013-05-23','09:25:00',11.09),('6449','2013-05-23','09:30:00',8.4),('6449','2013-05-23','09:35:00',7.49),('6449','2013-05-23','09:40:00',6.27),('6449','2013-05-23','09:45:00',9.86),('6449','2013-05-23','09:50:00',11.86),('6449','2013-05-23','09:55:00',14.41),('6449','2013-05-23','10:00:00',12.56),('6449','2013-05-23','10:05:00',13.09),('6449','2013-05-23','10:10:00',10.37),('6449','2013-05-23','10:15:00',15.11),('6449','2013-05-23','10:20:00',14.58),('6449','2013-05-23','10:25:00',14.8),('6449','2013-05-23','10:30:00',13.22),('6449','2013-05-23','10:35:00',15.43),('6449','2013-05-23','10:40:00',13.25),('6449','2013-05-23','10:45:00',16.05),('6449','2013-05-23','10:50:00',16.89),('6449','2013-05-23','10:55:00',11.44),('6449','2013-05-23','11:00:00',13.57),('6449','2013-05-23','11:05:00',6.81),('6449','2013-05-23','11:10:00',11.88),('6449','2013-05-23','11:15:00',13.93),('6449','2013-05-23','11:20:00',13.22),('6449','2013-05-23','11:25:00',13.03),('6449','2013-05-23','11:30:00',17.26),('6449','2013-05-23','11:35:00',15.23),('6449','2013-05-23','11:40:00',13.44),('6449','2013-05-23','11:45:00',16.43),('6449','2013-05-23','11:50:00',11.35),('6449','2013-05-23','11:55:00',10.01),('6449','2013-05-23','12:00:00',15.2),('6449','2013-05-23','12:05:00',18.68),('6449','2013-05-23','12:10:00',16.01),('6449','2013-05-23','12:15:00',17.7),('6449','2013-05-23','12:20:00',17.45),('6449','2013-05-23','12:25:00',17.27),('6449','2013-05-23','12:30:00',17.35),('6449','2013-05-23','12:35:00',17.58),('6449','2013-05-23','12:40:00',17.49),('6449','2013-05-23','12:45:00',17.58),('6449','2013-05-23','12:50:00',18.02),('6449','2013-05-23','12:55:00',16.83),('6449','2013-05-23','13:00:00',17.54),('6449','2013-05-23','13:05:00',16.4),('6449','2013-05-23','13:10:00',17.35),('6449','2013-05-23','13:15:00',17.41),('6449','2013-05-23','13:20:00',14.22),('6449','2013-05-23','13:25:00',17.03),('6449','2013-05-23','13:30:00',18.25),('6449','2013-05-23','13:35:00',16.91),('6449','2013-05-23','13:40:00',12.44),('6449','2013-05-23','13:45:00',10.12),('6449','2013-05-23','13:50:00',7.84),('6449','2013-05-23','13:55:00',9.22),('6449','2013-05-23','14:00:00',10.59),('6449','2013-05-23','14:05:00',12.02),('6449','2013-05-23','14:10:00',16.55),('6449','2013-05-23','14:15:00',17.63),('6449','2013-05-23','14:20:00',15.1),('6449','2013-05-23','14:25:00',14.88),('6449','2013-05-23','14:30:00',13.25),('6449','2013-05-23','14:35:00',13.94),('6449','2013-05-23','14:40:00',8.64),('6449','2013-05-23','14:45:00',12.56),('6449','2013-05-23','14:50:00',17.41),('6449','2013-05-23','14:55:00',17.54),('6449','2013-05-23','15:00:00',11.08),('6449','2013-05-23','15:05:00',8.35),('6449','2013-05-23','15:10:00',9.25),('6449','2013-05-23','15:15:00',10.3),('6449','2013-05-23','15:20:00',9.31),('6449','2013-05-23','15:25:00',11.38),('6449','2013-05-23','15:30:00',8.89),('6449','2013-05-23','15:35:00',14.12),('6449','2013-05-23','15:40:00',10.04),('6449','2013-05-23','15:45:00',8.11),('6449','2013-05-23','15:50:00',11.78),('6449','2013-05-23','15:55:00',7.72),('6449','2013-05-23','16:00:00',7.54),('6449','2013-05-23','16:05:00',14.92),('6449','2013-05-23','16:10:00',5.96),('6449','2013-05-23','16:15:00',3.71),('6449','2013-05-23','16:20:00',4.38),('6449','2013-05-23','16:25:00',4.28),('6449','2013-05-23','16:30:00',5.08),('6449','2013-05-23','16:35:00',5.78),('6449','2013-05-23','16:40:00',5.84),('6449','2013-05-23','16:45:00',5.58),('6449','2013-05-23','16:50:00',5.42),('6449','2013-05-23','16:55:00',5.27),('6449','2013-05-23','17:00:00',5.69),('6449','2013-05-23','17:05:00',5.77),('6449','2013-05-23','17:10:00',6.93),('6449','2013-05-23','17:15:00',9.98),('6449','2013-05-23','17:20:00',9.61),('6449','2013-05-23','17:25:00',8.45),('6449','2013-05-23','17:30:00',4.6),('6449','2013-05-23','17:35:00',1.22),('6449','2013-05-23','17:45:00',1.24),('6449','2013-05-23','17:50:00',2.07),('6449','2013-05-23','17:55:00',2.28),('6449','2013-05-23','18:00:00',2.32),('6449','2013-05-23','18:05:00',1.76),('6449','2013-05-23','18:10:00',1.79),('6449','2013-05-23','18:15:00',2.04),('6449','2013-05-23','18:20:00',2.14),('6449','2013-05-23','18:25:00',1.74),('6449','2013-05-23','18:30:00',1.35),('6449','2013-05-23','18:50:00',1.06),('6449','2013-05-23','18:55:00',1.18),('6449','2013-05-23','19:00:00',1.22),('6449','2013-05-23','19:05:00',1.15),('6449','2013-05-23','19:10:00',1.03),('6449','2013-05-22','06:55:00',1.09),('6449','2013-05-22','07:00:00',1.13),('6449','2013-05-22','07:05:00',1.16),('6449','2013-05-22','07:10:00',1.38),('6449','2013-05-22','07:15:00',1.22),('6449','2013-05-22','07:20:00',1.34),('6449','2013-05-22','07:25:00',1.44),('6449','2013-05-22','07:30:00',1.6),('6449','2013-05-22','07:35:00',1.84),('6449','2013-05-22','07:40:00',2.07),('6449','2013-05-22','07:45:00',2.36),('6449','2013-05-22','07:50:00',2.52),('6449','2013-05-22','07:55:00',2.99),('6449','2013-05-22','08:00:00',3.91),('6449','2013-05-22','08:05:00',6.03),('6449','2013-05-22','08:10:00',5.9),('6449','2013-05-22','08:15:00',8.06),('6449','2013-05-22','08:20:00',5.05),('6449','2013-05-22','08:45:00',1.54),('6449','2013-05-22','08:50:00',7.98),('6449','2013-05-22','08:55:00',11.24),('6449','2013-05-22','09:00:00',7.24),('6449','2013-05-22','09:05:00',4.13),('6449','2013-05-22','09:10:00',5.89),('6449','2013-05-22','09:15:00',4.74),('6449','2013-05-22','09:20:00',2.15),('6449','2013-05-22','09:25:00',5.83),('6449','2013-05-22','09:30:00',11.82),('6449','2013-05-22','09:35:00',5.86),('6449','2013-05-22','09:40:00',11.97),('6449','2013-05-22','09:45:00',11.85),('6449','2013-05-22','09:50:00',11.94),('6449','2013-05-22','09:55:00',12.27),('6449','2013-05-22','10:00:00',12.75),('6449','2013-05-22','10:05:00',12.96),('6449','2013-05-22','10:10:00',11.14),('6449','2013-05-22','10:15:00',14.55),('6449','2013-05-22','10:20:00',13.4),('6449','2013-05-22','10:25:00',11.51),('6449','2013-05-22','10:30:00',12.04),('6449','2013-05-22','10:35:00',8.22),('6449','2013-05-22','10:40:00',10.4),('6449','2013-05-22','10:45:00',14.67),('6449','2013-05-22','10:50:00',16.73),('6449','2013-05-22','10:55:00',16.29),('6449','2013-05-22','11:00:00',14.02),('6449','2013-05-22','11:05:00',10.82),('6449','2013-05-22','11:10:00',11.07),('6449','2013-05-22','11:15:00',14.72),('6449','2013-05-22','11:20:00',12.53),('6449','2013-05-22','11:25:00',15.63),('6449','2013-05-22','11:30:00',14.08),('6449','2013-05-22','11:35:00',17.01),('6449','2013-05-22','11:40:00',16.05),('6449','2013-05-22','11:45:00',12.97),('6449','2013-05-22','11:50:00',16.87),('6449','2013-05-22','11:55:00',14.04),('6449','2013-05-22','12:00:00',11.22),('6449','2013-05-22','12:05:00',7.93),('6449','2013-05-22','12:10:00',6.85),('6449','2013-05-22','12:15:00',8.25),('6449','2013-05-22','12:20:00',8.21),('6449','2013-05-22','12:25:00',8.52),('6449','2013-05-22','12:30:00',8.06),('6449','2013-05-22','12:35:00',6.03),('6449','2013-05-22','12:40:00',4.73),('6449','2013-05-22','12:45:00',5.63),('6449','2013-05-22','12:50:00',6.89),('6449','2013-05-22','12:55:00',3.77),('6449','2013-05-22','13:00:00',2.33),('6449','2013-05-22','13:05:00',1.68),('6449','2013-05-22','13:10:00',1.07),('6449','2013-05-22','13:20:00',1.36),('6449','2013-05-22','13:25:00',3.09),('6449','2013-05-22','13:30:00',5.41),('6449','2013-05-22','13:35:00',9.72),('6449','2013-05-22','13:40:00',7.65),('6449','2013-05-22','13:45:00',7.55),('6449','2013-05-22','13:50:00',9.39),('6449','2013-05-22','13:55:00',13.43),('6449','2013-05-22','14:00:00',10.78),('6449','2013-05-22','14:05:00',15.1),('6449','2013-05-22','14:10:00',15.88),('6449','2013-05-22','14:15:00',16.08),('6449','2013-05-22','14:20:00',15.36),('6449','2013-05-22','14:25:00',15.55),('6449','2013-05-22','14:30:00',15.38),('6449','2013-05-22','14:35:00',15.13),('6449','2013-05-22','14:40:00',15.01),('6449','2013-05-22','14:45:00',15),('6449','2013-05-22','14:50:00',14.79),('6449','2013-05-22','14:55:00',14.57),('6449','2013-05-22','15:00:00',14.35),('6449','2013-05-22','15:05:00',14.06),('6449','2013-05-22','15:10:00',14),('6449','2013-05-22','15:15:00',13.77),('6449','2013-05-22','15:20:00',13.56),('6449','2013-05-22','15:25:00',13.43),('6449','2013-05-22','15:30:00',12.77),('6449','2013-05-22','15:35:00',13.75),('6449','2013-05-22','15:40:00',12.33),('6449','2013-05-22','15:45:00',12.23),('6449','2013-05-22','15:50:00',12.16),('6449','2013-05-22','15:55:00',11.89),('6449','2013-05-22','16:00:00',11.44),('6449','2013-05-22','16:05:00',11.37),('6449','2013-05-22','16:10:00',11.12),('6449','2013-05-22','16:15:00',10.86),('6449','2013-05-22','16:20:00',10.37),('6449','2013-05-22','16:25:00',10.08),('6449','2013-05-22','16:30:00',9.95),('6449','2013-05-22','16:35:00',9.64),('6449','2013-05-22','16:40:00',10.29),('6449','2013-05-22','16:45:00',7.33),('6449','2013-05-22','16:50:00',5.18),('6449','2013-05-22','16:55:00',4.95),('6449','2013-05-22','17:00:00',4.66),('6449','2013-05-22','17:05:00',5.44),('6449','2013-05-22','17:10:00',4.12),('6449','2013-05-22','17:15:00',2.63),('6449','2013-05-22','17:20:00',3.19),('6449','2013-05-22','17:25:00',3.95),('6449','2013-05-22','17:30:00',6.12),('6449','2013-05-22','17:35:00',5.64),('6449','2013-05-22','17:40:00',5.95),('6449','2013-05-22','17:45:00',5.88),('6449','2013-05-22','17:50:00',5.57),('6449','2013-05-22','17:55:00',5.92),('6449','2013-05-22','18:00:00',5.07),('6449','2013-05-22','18:05:00',4.28),('6449','2013-05-22','18:10:00',3.84),('6449','2013-05-22','18:15:00',3.68),('6449','2013-05-22','18:20:00',3.28),('6449','2013-05-22','18:25:00',3.17),('6449','2013-05-22','18:30:00',2.96),('6449','2013-05-22','18:35:00',2.79),('6449','2013-05-22','18:40:00',2.49),('6449','2013-05-22','18:45:00',2.13),('6449','2013-05-22','18:50:00',1.91),('6449','2013-05-22','18:55:00',1.76),('6449','2013-05-22','19:00:00',1.63),('6449','2013-05-22','19:05:00',1.58),('6449','2013-05-22','19:10:00',1.31),('6449','2013-05-21','06:40:00',1),('6449','2013-05-21','06:45:00',1.2),('6449','2013-05-21','06:50:00',1.37),('6449','2013-05-21','06:55:00',1.59),('6449','2013-05-21','07:00:00',1.82),('6449','2013-05-21','07:05:00',2.07),('6449','2013-05-21','07:10:00',2.34),('6449','2013-05-21','07:15:00',2.71),('6449','2013-05-21','07:20:00',3.09),('6449','2013-05-21','07:25:00',3.37),('6449','2013-05-21','07:30:00',3.64),('6449','2013-05-21','07:35:00',3.98),('6449','2013-05-21','07:40:00',4.41),('6449','2013-05-21','07:45:00',5.17),('6449','2013-05-21','07:50:00',5.76),('6449','2013-05-21','07:55:00',5.33),('6449','2013-05-21','08:00:00',5.42),('6449','2013-05-21','08:05:00',4.95),('6449','2013-05-21','08:10:00',3.49),('6449','2013-05-21','08:15:00',3.85),('6449','2013-05-21','08:20:00',4.65),('6449','2013-05-21','08:25:00',4.05),('6449','2013-05-21','08:30:00',3.32),('6449','2013-05-21','08:35:00',4.04),('6449','2013-05-21','08:40:00',4.87),('6449','2013-05-21','08:45:00',3.66),('6449','2013-05-21','08:50:00',3.3),('6449','2013-05-21','08:55:00',3.67),('6449','2013-05-21','09:00:00',4.58),('6449','2013-05-21','09:05:00',4.92),('6449','2013-05-21','09:10:00',4.73),('6449','2013-05-21','09:15:00',5.67),('6449','2013-05-21','09:20:00',5.88),('6449','2013-05-21','09:25:00',6.59),('6449','2013-05-21','09:30:00',6.18),('6449','2013-05-21','09:35:00',5.32),('6449','2013-05-21','09:40:00',4.43),('6449','2013-05-21','09:45:00',5.05),('6449','2013-05-21','09:50:00',10.1),('6449','2013-05-21','09:55:00',11.96),('6449','2013-05-21','10:00:00',7.05),('6449','2013-05-21','10:05:00',6.2),('6449','2013-05-21','10:10:00',5.83),('6449','2013-05-21','10:15:00',6.95),('6449','2013-05-21','10:20:00',11.07),('6449','2013-05-21','10:25:00',8.52),('6449','2013-05-21','10:30:00',11.58),('6449','2013-05-21','10:35:00',8.4),('6449','2013-05-21','10:40:00',6.62),('6449','2013-05-21','10:45:00',4.85),('6449','2013-05-21','10:50:00',5.21),('6449','2013-05-21','10:55:00',9.4),('6449','2013-05-21','11:00:00',10.36),('6449','2013-05-21','11:05:00',10.73),('6449','2013-05-21','11:10:00',13.17),('6449','2013-05-21','11:15:00',13.97),('6449','2013-05-21','11:20:00',15.51),('6449','2013-05-21','11:25:00',15.78),('6449','2013-05-21','11:30:00',16.19),('6449','2013-05-21','11:35:00',13.21),('6449','2013-05-21','11:40:00',6.41),('6449','2013-05-21','11:45:00',11.04),('6449','2013-05-21','11:50:00',15.27),('6449','2013-05-21','11:55:00',14.86),('6449','2013-05-21','12:00:00',9.89),('6449','2013-05-21','12:05:00',7.55),('6449','2013-05-21','12:10:00',5.78),('6449','2013-05-21','12:15:00',6.27),('6449','2013-05-21','12:20:00',8.16),('6449','2013-05-21','12:25:00',8.67),('6449','2013-05-21','12:30:00',14.26),('6449','2013-05-21','12:35:00',11.15),('6449','2013-05-21','12:40:00',13.81),('6449','2013-05-21','12:45:00',12.3),('6449','2013-05-21','12:50:00',14.47),('6449','2013-05-21','12:55:00',7.2),('6449','2013-05-21','13:00:00',7.04),('6449','2013-05-21','13:05:00',6.81),('6449','2013-05-21','13:10:00',9.66),('6449','2013-05-21','13:15:00',12.94),('6449','2013-05-21','13:20:00',13.62),('6449','2013-05-21','13:25:00',7.6),('6449','2013-05-21','13:30:00',6.82),('6449','2013-05-21','13:35:00',5.72),('6449','2013-05-21','13:40:00',3.99),('6449','2013-05-21','13:45:00',2.96),('6449','2013-05-21','13:50:00',2.55),('6449','2013-05-21','13:55:00',1.44),('6449','2013-05-21','14:15:00',1.28),('6449','2013-05-21','14:20:00',2.25),('6449','2013-05-21','14:25:00',3.88),('6449','2013-05-21','14:30:00',5.39),('6449','2013-05-21','14:35:00',5.77),('6449','2013-05-21','14:40:00',3.22),('6449','2013-05-21','14:45:00',1.68),('6449','2013-05-21','15:05:00',1.47),('6449','2013-05-21','15:10:00',2.61),('6449','2013-05-21','15:15:00',2.72),('6449','2013-05-21','15:20:00',2.52),('6449','2013-05-21','15:25:00',3.1),('6449','2013-05-21','15:30:00',3.34),('6449','2013-05-21','15:35:00',2.32),('6449','2013-05-21','15:40:00',2.69),('6449','2013-05-21','15:45:00',5.24),('6449','2013-05-21','15:50:00',6.55),('6449','2013-05-21','15:55:00',3.92),('6449','2013-05-21','16:00:00',2.79),('6449','2013-05-21','16:05:00',2.91),('6449','2013-05-21','16:10:00',2.75),('6449','2013-05-21','16:15:00',2.87),('6449','2013-05-21','16:20:00',2.34),('6449','2013-05-21','16:25:00',2.25),('6449','2013-05-21','16:30:00',1.55),('6449','2013-05-21','16:35:00',1.34),('6449','2013-05-21','16:40:00',1.32),('6449','2013-05-21','16:45:00',1.44),('6449','2013-05-21','16:50:00',1.99),('6449','2013-05-21','16:55:00',2.19),('6449','2013-05-21','17:00:00',1.41),('6449','2013-05-21','18:20:00',1.04),('6449','2013-05-20','06:50:00',1.18),('6449','2013-05-20','06:55:00',1.15),('6449','2013-05-20','07:00:00',1.53),('6449','2013-05-20','07:05:00',1.48),('6449','2013-05-20','07:35:00',2.96),('6449','2013-05-20','07:40:00',4.12),('6449','2013-05-20','07:45:00',4.61),('6449','2013-05-20','07:50:00',4.98),('6449','2013-05-20','07:55:00',5.38),('6449','2013-05-20','08:00:00',5.75),('6449','2013-05-20','08:05:00',6.12),('6449','2013-05-20','08:10:00',6.5),('6449','2013-05-20','08:15:00',6.86),('6449','2013-05-20','08:20:00',7.36),('6449','2013-05-20','08:25:00',7.03),('6449','2013-05-20','08:30:00',7.66),('6449','2013-05-20','08:35:00',8.07),('6449','2013-05-20','08:40:00',8.58),('6449','2013-05-20','08:45:00',8.79),('6449','2013-05-20','08:50:00',9.14),('6449','2013-05-20','08:55:00',9.48),('6449','2013-05-20','09:00:00',9.67),('6449','2013-05-20','09:05:00',10.1),('6449','2013-05-20','09:10:00',10.3),('6449','2013-05-20','09:15:00',10.37),('6449','2013-05-20','09:20:00',10.77),('6449','2013-05-20','09:25:00',11.12),('6449','2013-05-20','09:30:00',11.54),('6449','2013-05-20','09:35:00',12.24),('6449','2013-05-20','09:40:00',12.99),('6449','2013-05-20','09:45:00',12.63),('6449','2013-05-20','09:50:00',8.04),('6449','2013-05-20','09:55:00',11.63),('6449','2013-05-20','10:00:00',9.97),('6449','2013-05-20','10:05:00',13.39),('6449','2013-05-20','10:10:00',13.59),('6449','2013-05-20','10:15:00',13.61),('6449','2013-05-20','10:20:00',13.85),('6449','2013-05-20','10:25:00',14.14),('6449','2013-05-20','10:30:00',13.58),('6449','2013-05-20','10:35:00',13.98),('6449','2013-05-20','10:40:00',14.71),('6449','2013-05-20','10:45:00',14.79),('6449','2013-05-20','10:50:00',14.87),('6449','2013-05-20','10:55:00',15.02),('6449','2013-05-20','11:00:00',15.18),('6449','2013-05-20','11:05:00',15.36),('6449','2013-05-20','11:10:00',15.42),('6449','2013-05-20','11:15:00',15.55),('6449','2013-05-20','11:20:00',15.75),('6449','2013-05-20','11:25:00',15.88),('6449','2013-05-20','11:30:00',15.86),('6449','2013-05-20','11:35:00',16.01),('6449','2013-05-20','11:40:00',16.07),('6449','2013-05-20','11:45:00',15.95),('6449','2013-05-20','11:50:00',16.21),('6449','2013-05-20','11:55:00',16.35),('6449','2013-05-20','12:00:00',16.28),('6449','2013-05-20','12:05:00',16.46),('6449','2013-05-20','12:10:00',16.5),('6449','2013-05-20','12:15:00',16.33),('6449','2013-05-20','12:20:00',16.65),('6449','2013-05-20','12:25:00',16.78),('6449','2013-05-20','12:30:00',16.74),('6449','2013-05-20','12:35:00',16.79),('6449','2013-05-20','12:40:00',16.81),('6449','2013-05-20','12:45:00',16.85),('6449','2013-05-20','12:50:00',16.86),('6449','2013-05-20','12:55:00',16.95),('6449','2013-05-20','13:00:00',16.85),('6449','2013-05-20','13:05:00',16.87),('6449','2013-05-20','13:10:00',16.94),('6449','2013-05-20','13:15:00',16.98),('6449','2013-05-20','13:20:00',16.88),('6449','2013-05-20','13:25:00',16.84),('6449','2013-05-20','13:30:00',16.6),('6449','2013-05-20','13:35:00',16.75),('6449','2013-05-20','13:40:00',16.72),('6449','2013-05-20','13:45:00',16.55),('6449','2013-05-20','13:50:00',16.66),('6449','2013-05-20','13:55:00',16.59),('6449','2013-05-20','14:00:00',16.53),('6449','2013-05-20','14:05:00',16.39),('6449','2013-05-20','14:10:00',16.18),('6449','2013-05-20','14:15:00',15.96),('6449','2013-05-20','14:20:00',15.85),('6449','2013-05-20','14:25:00',15.76),('6449','2013-05-20','14:30:00',15.54),('6449','2013-05-20','14:35:00',15.53),('6449','2013-05-20','14:40:00',15.37),('6449','2013-05-20','14:45:00',15.2),('6449','2013-05-20','14:50:00',15.14),('6449','2013-05-20','14:55:00',14.9),('6449','2013-05-20','15:00:00',14.77),('6449','2013-05-20','15:05:00',14.57),('6449','2013-05-20','15:10:00',14.49),('6449','2013-05-20','15:15:00',14.08),('6449','2013-05-20','15:20:00',14.11),('6449','2013-05-20','15:25:00',13.92),('6449','2013-05-20','15:30:00',13.75),('6449','2013-05-20','15:35:00',13.39),('6449','2013-05-20','15:40:00',13.47),('6449','2013-05-20','15:45:00',13.18),('6449','2013-05-20','15:50:00',12.76),('6449','2013-05-20','15:55:00',12.57),('6449','2013-05-20','16:00:00',12.5),('6449','2013-05-20','16:05:00',10.25),('6449','2013-05-20','16:10:00',8.37),('6449','2013-05-20','16:15:00',6.36),('6449','2013-05-20','16:20:00',5.11),('6449','2013-05-20','16:25:00',4.7),('6449','2013-05-20','16:30:00',6.88),('6449','2013-05-20','16:35:00',11.15),('6449','2013-05-20','16:40:00',11.05),('6449','2013-05-20','16:45:00',6.92),('6449','2013-05-20','16:50:00',4.97),('6449','2013-05-20','16:55:00',3.15),('6449','2013-05-20','17:00:00',3.15),('6449','2013-05-20','17:05:00',5.25),('6449','2013-05-20','17:10:00',10.49),('6449','2013-05-20','17:15:00',8.23),('6449','2013-05-20','17:20:00',7.41),('6449','2013-05-20','17:25:00',7.24),('6449','2013-05-20','17:30:00',6.79),('6449','2013-05-20','17:35:00',6.43),('6449','2013-05-20','17:40:00',6.17),('6449','2013-05-20','17:45:00',6.03),('6449','2013-05-20','17:50:00',5.98),('6449','2013-05-20','17:55:00',6.18),('6449','2013-05-20','18:00:00',6.05),('6449','2013-05-20','18:05:00',3.79),('6449','2013-05-20','18:10:00',3.85),('6449','2013-05-20','18:15:00',3.67),('6449','2013-05-20','18:20:00',3.27),('6449','2013-05-20','18:25:00',2.96),('6449','2013-05-20','18:30:00',2.64),('6449','2013-05-20','18:35:00',2.39),('6449','2013-05-20','18:40:00',2.08),('6449','2013-05-20','18:45:00',1.78),('6449','2013-05-20','18:50:00',1.57),('6449','2013-05-20','18:55:00',1.35),('6449','2013-05-19','07:15:00',1.03),('6449','2013-05-19','07:20:00',1.22),('6449','2013-05-19','07:25:00',1.15),('6449','2013-05-19','07:30:00',1.3),('6449','2013-05-19','07:35:00',1.57),('6449','2013-05-19','07:40:00',1.68),('6449','2013-05-19','07:45:00',1.75),('6449','2013-05-19','07:50:00',1.91),('6449','2013-05-19','07:55:00',2.39),('6449','2013-05-19','08:00:00',2.56),('6449','2013-05-19','08:05:00',3.39),('6449','2013-05-19','08:10:00',3.46),('6449','2013-05-19','08:15:00',3.78),('6449','2013-05-19','08:20:00',3.98),('6449','2013-05-19','08:25:00',5.18),('6449','2013-05-19','08:30:00',5.52),('6449','2013-05-19','08:35:00',6.1),('6449','2013-05-19','08:40:00',7.53),('6449','2013-05-19','08:45:00',7.96),('6449','2013-05-19','08:50:00',6.77),('6449','2013-05-19','08:55:00',7.76),('6449','2013-05-19','09:00:00',8.02),('6449','2013-05-19','09:05:00',7.3),('6449','2013-05-19','09:10:00',9.22),('6449','2013-05-19','09:15:00',9.43),('6449','2013-05-19','09:20:00',10.41),('6449','2013-05-19','09:25:00',9.1),('6449','2013-05-19','09:30:00',8.71),('6449','2013-05-19','09:35:00',11.64),('6449','2013-05-19','09:40:00',11.76),('6449','2013-05-19','09:45:00',12.05),('6449','2013-05-19','09:50:00',12.31),('6449','2013-05-19','09:55:00',12.65),('6449','2013-05-19','10:00:00',12.85),('6449','2013-05-19','10:05:00',13.18),('6449','2013-05-19','10:10:00',13.44),('6449','2013-05-19','10:15:00',13.69),('6449','2013-05-19','10:20:00',13.82),('6449','2013-05-19','10:25:00',14.1),('6449','2013-05-19','10:30:00',14.45),('6449','2013-05-19','10:35:00',14.64),('6449','2013-05-19','10:40:00',14.95),('6449','2013-05-19','10:45:00',15.15),('6449','2013-05-19','10:50:00',15.39),('6449','2013-05-19','10:55:00',15.52),('6449','2013-05-19','11:00:00',15.71),('6449','2013-05-19','11:05:00',15.87),('6449','2013-05-19','11:10:00',16.05),('6449','2013-05-19','11:15:00',16.09),('6449','2013-05-19','11:20:00',16.47),('6449','2013-05-19','11:25:00',16.87),('6449','2013-05-19','11:30:00',16.77),('6449','2013-05-19','11:35:00',15.55),('6449','2013-05-19','11:40:00',9),('6449','2013-05-19','11:45:00',11.38),('6449','2013-05-19','11:50:00',10.97),('6449','2013-05-19','11:55:00',13.68),('6449','2013-05-19','12:00:00',12.89),('6449','2013-05-19','12:05:00',12.22),('6449','2013-05-19','12:10:00',17.59),('6449','2013-05-19','12:15:00',17.85),('6449','2013-05-19','12:20:00',15.36),('6449','2013-05-19','12:25:00',16.9),('6449','2013-05-19','12:30:00',17.71),('6449','2013-05-19','12:35:00',17.62),('6449','2013-05-19','12:40:00',17.54),('6449','2013-05-19','12:45:00',17.54),('6449','2013-05-19','12:50:00',17.6),('6449','2013-05-19','12:55:00',17.64),('6449','2013-05-19','13:00:00',17.51),('6449','2013-05-19','13:05:00',17.68),('6449','2013-05-19','13:10:00',17.58),('6449','2013-05-19','13:15:00',17.54),('6449','2013-05-19','13:20:00',17.58),('6449','2013-05-19','13:25:00',17.53),('6449','2013-05-19','13:30:00',17.28),('6449','2013-05-19','13:35:00',17.44),('6449','2013-05-19','13:40:00',17.39),('6449','2013-05-19','13:45:00',17.35),('6449','2013-05-19','13:50:00',17.28),('6449','2013-05-19','13:55:00',17.13),('6449','2013-05-19','14:00:00',17.01),('6449','2013-05-19','14:05:00',16.99),('6449','2013-05-19','14:10:00',16.85),('6449','2013-05-19','14:15:00',16.74),('6449','2013-05-19','14:20:00',16.66),('6449','2013-05-19','14:25:00',16.65),('6449','2013-05-19','14:30:00',16.51),('6449','2013-05-19','14:35:00',16.38),('6449','2013-05-19','14:40:00',16.26),('6449','2013-05-19','14:45:00',16.09),('6449','2013-05-19','14:50:00',15.85),('6449','2013-05-19','14:55:00',15.76),('6449','2013-05-19','15:00:00',15.61),('6449','2013-05-19','15:05:00',15.37),('6449','2013-05-19','15:10:00',15.16),('6449','2013-05-19','15:15:00',15),('6449','2013-05-19','15:20:00',14.6),('6449','2013-05-19','15:25:00',14.66),('6449','2013-05-19','15:30:00',14.39),('6449','2013-05-19','15:35:00',14.19),('6449','2013-05-19','15:40:00',14.01),('6449','2013-05-19','15:45:00',13.68),('6449','2013-05-19','15:50:00',13.39),('6449','2013-05-19','15:55:00',13.21),('6449','2013-05-19','16:00:00',12.93),('6449','2013-05-19','16:05:00',12.61),('6449','2013-05-19','16:10:00',12.43),('6449','2013-05-19','16:15:00',12.06),('6449','2013-05-19','16:20:00',11.72),('6449','2013-05-19','16:25:00',11.45),('6449','2013-05-19','16:30:00',11.21),('6449','2013-05-19','16:35:00',10.8),('6449','2013-05-19','16:40:00',10.63),('6449','2013-05-19','16:45:00',10.25),('6449','2013-05-19','16:50:00',10),('6449','2013-05-19','16:55:00',9.58),('6449','2013-05-19','17:00:00',9.43),('6449','2013-05-19','17:05:00',8.89),('6449','2013-05-19','17:10:00',8.64),('6449','2013-05-19','17:15:00',8.22),('6449','2013-05-19','17:20:00',7.89),('6449','2013-05-19','17:25:00',7.52),('6449','2013-05-19','17:30:00',7.1),('6449','2013-05-19','17:35:00',6.76),('6449','2013-05-19','17:40:00',6.37),('6449','2013-05-19','17:45:00',5.93),('6449','2013-05-19','17:50:00',5.6),('6449','2013-05-19','17:55:00',5.24),('6449','2013-05-19','18:00:00',4.89),('6449','2013-05-19','18:05:00',4.5),('6449','2013-05-19','18:10:00',4.07),('6449','2013-05-19','18:15:00',3.72),('6449','2013-05-19','18:20:00',3.35),('6449','2013-05-19','18:25:00',3.02),('6449','2013-05-19','18:30:00',2.65),('6449','2013-05-19','18:35:00',2.34),('6449','2013-05-19','18:40:00',2.03),('6449','2013-05-19','18:45:00',1.74),('6449','2013-05-19','18:50:00',1.46),('6449','2013-05-19','18:55:00',1.22),('6449','2013-05-19','19:00:00',1.01),('6449','2013-05-18','06:50:00',1.16),('6449','2013-05-18','06:55:00',1.38),('6449','2013-05-18','07:00:00',1.66),('6449','2013-05-18','07:05:00',1.93),('6449','2013-05-18','07:10:00',2.25),('6449','2013-05-18','07:15:00',2.55),('6449','2013-05-18','07:20:00',2.86),('6449','2013-05-18','07:25:00',3.19),('6449','2013-05-18','07:30:00',3.44),('6449','2013-05-18','07:35:00',3.82),('6449','2013-05-18','07:40:00',4.26),('6449','2013-05-18','07:45:00',4.6),('6449','2013-05-18','07:50:00',4.87),('6449','2013-05-18','07:55:00',5.17),('6449','2013-05-18','08:00:00',5.65),('6449','2013-05-18','08:05:00',6.15),('6449','2013-05-18','08:10:00',6.31),('6449','2013-05-18','08:15:00',6.92),('6449','2013-05-18','08:20:00',7.6),('6449','2013-05-18','08:25:00',7.18),('6449','2013-05-18','08:30:00',6.3),('6449','2013-05-18','08:35:00',8.11),('6449','2013-05-18','08:40:00',9.3),('6449','2013-05-18','08:45:00',8.7),('6449','2013-05-18','08:50:00',8.83),('6449','2013-05-18','08:55:00',7.56),('6449','2013-05-18','09:00:00',10.28),('6449','2013-05-18','09:05:00',10.26),('6449','2013-05-18','09:10:00',11.12),('6449','2013-05-18','09:15:00',10.85),('6449','2013-05-18','09:20:00',11.1),('6449','2013-05-18','09:25:00',11.32),('6449','2013-05-18','09:30:00',11.59),('6449','2013-05-18','09:35:00',11.79),('6449','2013-05-18','09:40:00',12.09),('6449','2013-05-18','09:45:00',12.16),('6449','2013-05-18','09:50:00',12.56),('6449','2013-05-18','09:55:00',12.81),('6449','2013-05-18','10:00:00',12.96),('6449','2013-05-18','10:05:00',13.31),('6449','2013-05-18','10:10:00',13.48),('6449','2013-05-18','10:15:00',14.36),('6449','2013-05-18','10:20:00',11.45),('6449','2013-05-18','10:25:00',9.9),('6449','2013-05-18','10:30:00',14.4),('6449','2013-05-18','10:35:00',14.52),('6449','2013-05-18','10:40:00',14.55),('6449','2013-05-18','10:45:00',13.62),('6449','2013-05-18','10:50:00',15.93),('6449','2013-05-18','10:55:00',11.11),('6449','2013-05-18','11:00:00',13.84),('6449','2013-05-18','11:05:00',11.93),('6449','2013-05-18','11:10:00',13.36),('6449','2013-05-18','11:15:00',15.43),('6449','2013-05-18','11:20:00',14),('6449','2013-05-18','11:25:00',9.64),('6449','2013-05-18','11:30:00',16.21),('6449','2013-05-18','11:35:00',15.78),('6449','2013-05-18','11:40:00',14.94),('6449','2013-05-18','11:45:00',15.66),('6449','2013-05-18','11:50:00',15.64),('6449','2013-05-18','11:55:00',15.67),('6449','2013-05-18','12:00:00',15.57),('6449','2013-05-18','12:05:00',15.67),('6449','2013-05-18','12:10:00',15.7),('6449','2013-05-18','12:15:00',16.41),('6449','2013-05-18','12:20:00',13.44),('6449','2013-05-18','12:25:00',15.34),('6449','2013-05-18','12:30:00',16.72),('6449','2013-05-18','12:35:00',7.26),('6449','2013-05-18','12:40:00',10.21),('6449','2013-05-18','12:45:00',17.5),('6449','2013-05-18','12:50:00',16.84),('6449','2013-05-18','12:55:00',16.08),('6449','2013-05-18','13:00:00',15.89),('6449','2013-05-18','13:05:00',15.84),('6449','2013-05-18','13:10:00',15.9),('6449','2013-05-18','13:15:00',15.76),('6449','2013-05-18','13:20:00',15.96),('6449','2013-05-18','13:25:00',15.88),('6449','2013-05-18','13:30:00',15.79),('6449','2013-05-18','13:35:00',15.73),('6449','2013-05-18','13:40:00',15.64),('6449','2013-05-18','13:45:00',15.53),('6449','2013-05-18','13:50:00',15.39),('6449','2013-05-18','13:55:00',14.9),('6449','2013-05-18','14:00:00',13.93),('6449','2013-05-18','14:05:00',14.43),('6449','2013-05-18','14:10:00',15.51),('6449','2013-05-18','14:15:00',15.57),('6449','2013-05-18','14:20:00',14.82),('6449','2013-05-18','14:25:00',15.92),('6449','2013-05-18','14:30:00',15.47),('6449','2013-05-18','14:35:00',13.1),('6449','2013-05-18','14:40:00',13.23),('6449','2013-05-18','14:45:00',14.89),('6449','2013-05-18','14:50:00',13.46),('6449','2013-05-18','14:55:00',13.52),('6449','2013-05-18','15:00:00',13.08),('6449','2013-05-18','15:05:00',13.61),('6449','2013-05-18','15:10:00',13.3),('6449','2013-05-18','15:15:00',12.45),('6449','2013-05-18','15:20:00',12.7),('6449','2013-05-18','15:25:00',12.6),('6449','2013-05-18','15:30:00',12.17),('6449','2013-05-18','15:35:00',11.89),('6449','2013-05-18','15:40:00',11.71),('6449','2013-05-18','15:45:00',11.48),('6449','2013-05-18','15:50:00',11.29),('6449','2013-05-18','15:55:00',10.99),('6449','2013-05-18','16:00:00',10.73),('6449','2013-05-18','16:05:00',10.35),('6449','2013-05-18','16:10:00',10.24),('6449','2013-05-18','16:15:00',10.06),('6449','2013-05-18','16:20:00',9.7),('6449','2013-05-18','16:25:00',9.06),('6449','2013-05-18','16:30:00',5.35),('6449','2013-05-18','16:35:00',8.42),('6449','2013-05-18','16:40:00',8.68),('6449','2013-05-18','16:45:00',8.41),('6449','2013-05-18','16:50:00',8.02),('6449','2013-05-18','16:55:00',7.73),('6449','2013-05-18','17:00:00',7.35),('6449','2013-05-18','17:05:00',6.97),('6449','2013-05-18','17:10:00',6.62),('6449','2013-05-18','17:15:00',6.29),('6449','2013-05-18','17:20:00',6.12),('6449','2013-05-18','17:25:00',5.99),('6449','2013-05-18','17:30:00',5.71),('6449','2013-05-18','17:35:00',5.42),('6449','2013-05-18','17:40:00',5.08),('6449','2013-05-18','17:45:00',4.73),('6449','2013-05-18','17:50:00',4.4),('6449','2013-05-18','17:55:00',4.24),('6449','2013-05-18','18:00:00',4.02),('6449','2013-05-18','18:05:00',3.76),('6449','2013-05-18','18:10:00',3.5),('6449','2013-05-18','18:15:00',3.26),('6449','2013-05-18','18:20:00',3),('6449','2013-05-18','18:25:00',2.74),('6449','2013-05-18','18:30:00',2.51),('6449','2013-05-18','18:35:00',2.32),('6449','2013-05-18','18:40:00',2.12),('6449','2013-05-18','18:45:00',1.95),('6449','2013-05-18','18:50:00',1.76),('6449','2013-05-18','18:55:00',1.6),('6449','2013-05-18','19:00:00',1.44),('6449','2013-05-18','19:05:00',1.31),('6449','2013-05-18','19:10:00',1.17),('6449','2013-05-18','19:15:00',1.05),('6449','2013-05-17','07:00:00',1.05),('6449','2013-05-17','07:05:00',1.8),('6449','2013-05-17','07:10:00',1.76),('6449','2013-05-17','07:15:00',1.83),('6449','2013-05-17','07:20:00',2.9),('6449','2013-05-17','07:25:00',3),('6449','2013-05-17','07:30:00',2.6),('6449','2013-05-17','07:35:00',1.95),('6449','2013-05-17','07:40:00',3.38),('6449','2013-05-17','07:45:00',4.5),('6449','2013-05-17','07:50:00',6.05),('6449','2013-05-17','07:55:00',4.29),('6449','2013-05-17','08:00:00',2.43),('6449','2013-05-17','08:05:00',1.21),('6449','2013-05-17','08:10:00',2.04),('6449','2013-05-17','08:15:00',2.4),('6449','2013-05-17','08:20:00',1.55),('6449','2013-05-17','08:50:00',1.18),('6449','2013-05-17','08:55:00',2.41),('6449','2013-05-17','09:00:00',1.92),('6449','2013-05-17','09:05:00',1.5),('6449','2013-05-17','09:10:00',1.49),('6449','2013-05-17','09:15:00',1.68),('6449','2013-05-17','09:20:00',2.02),('6449','2013-05-17','09:25:00',2),('6449','2013-05-17','09:30:00',2.16),('6449','2013-05-17','09:35:00',1.38),('6449','2013-05-17','09:40:00',1.41),('6449','2013-05-17','09:45:00',1.46),('6449','2013-05-17','09:50:00',1.94),('6449','2013-05-17','09:55:00',2.95),('6449','2013-05-17','10:00:00',4.23),('6449','2013-05-17','10:05:00',4.25),('6449','2013-05-17','10:10:00',5.46),('6449','2013-05-17','10:15:00',5.55),('6449','2013-05-17','10:20:00',7.27),('6449','2013-05-17','10:25:00',6.79),('6449','2013-05-17','10:30:00',8.93),('6449','2013-05-17','10:35:00',10.6),('6449','2013-05-17','10:40:00',8.25),('6449','2013-05-17','10:45:00',10.01),('6449','2013-05-17','10:50:00',8.43),('6449','2013-05-17','10:55:00',10.03),('6449','2013-05-17','11:00:00',10.08),('6449','2013-05-17','11:05:00',11),('6449','2013-05-17','11:10:00',7.15),('6449','2013-05-17','11:15:00',8.54),('6449','2013-05-17','11:20:00',10.62),('6449','2013-05-17','11:25:00',11.05),('6449','2013-05-17','11:30:00',12.32),('6449','2013-05-17','11:35:00',11.04),('6449','2013-05-17','11:40:00',8.89),('6449','2013-05-17','11:45:00',9.89),('6449','2013-05-17','11:50:00',5.91),('6449','2013-05-17','11:55:00',6.56),('6449','2013-05-17','12:00:00',11.6),('6449','2013-05-17','12:05:00',17.8),('6449','2013-05-17','12:10:00',13.04),('6449','2013-05-17','12:15:00',14.2),('6449','2013-05-17','12:20:00',18.19),('6449','2013-05-17','12:25:00',17.52),('6449','2013-05-17','12:30:00',14.92),('6449','2013-05-17','12:35:00',17.84),('6449','2013-05-17','12:40:00',12.83),('6449','2013-05-17','12:45:00',17.78),('6449','2013-05-17','12:50:00',17.43),('6449','2013-05-17','12:55:00',17.27),('6449','2013-05-17','13:00:00',17.23),('6449','2013-05-17','13:05:00',17.15),('6449','2013-05-17','13:10:00',17.11),('6449','2013-05-17','13:15:00',17.21),('6449','2013-05-17','13:20:00',17.5),('6449','2013-05-17','13:25:00',16.93),('6449','2013-05-17','13:30:00',14.67),('6449','2013-05-17','13:35:00',15.66),('6449','2013-05-17','13:40:00',15.35),('6449','2013-05-17','13:45:00',16.38),('6449','2013-05-17','13:50:00',14.38),('6449','2013-05-17','13:55:00',12.28),('6449','2013-05-17','14:00:00',12.11),('6449','2013-05-17','14:05:00',15.98),('6449','2013-05-17','14:10:00',15.46),('6449','2013-05-17','14:15:00',12.51),('6449','2013-05-17','14:20:00',16.36),('6449','2013-05-17','14:25:00',15.93),('6449','2013-05-17','14:30:00',12.39),('6449','2013-05-17','14:35:00',11.99),('6449','2013-05-17','14:40:00',13.08),('6449','2013-05-17','14:45:00',13.59),('6449','2013-05-17','14:50:00',14.2),('6449','2013-05-17','14:55:00',15.28),('6449','2013-05-17','15:00:00',15.16),('6449','2013-05-17','15:05:00',14.96),('6449','2013-05-17','15:10:00',14.79),('6449','2013-05-17','15:15:00',14.52),('6449','2013-05-17','15:20:00',14.42),('6449','2013-05-17','15:25:00',14.29),('6449','2013-05-17','15:30:00',13.98),('6449','2013-05-17','15:35:00',13.77),('6449','2013-05-17','15:40:00',13.52),('6449','2013-05-17','15:45:00',13.17),('6449','2013-05-17','15:50:00',12.97),('6449','2013-05-17','15:55:00',12.65),('6449','2013-05-17','16:00:00',11.44),('6449','2013-05-17','16:05:00',9.71),('6449','2013-05-17','16:10:00',11.83),('6449','2013-05-17','16:15:00',11.47),('6449','2013-05-17','16:20:00',11.25),('6449','2013-05-17','16:25:00',10.97),('6449','2013-05-17','16:30:00',10.69),('6449','2013-05-17','16:35:00',10.38),('6449','2013-05-17','16:40:00',10.09),('6449','2013-05-17','16:45:00',9.89),('6449','2013-05-17','16:50:00',9.54),('6449','2013-05-17','16:55:00',9.24),('6449','2013-05-17','17:00:00',8.8),('6449','2013-05-17','17:05:00',8.32),('6449','2013-05-17','17:10:00',8.15),('6449','2013-05-17','17:15:00',7.76),('6449','2013-05-17','17:20:00',7.51),('6449','2013-05-17','17:25:00',7.21),('6449','2013-05-17','17:30:00',6.81),('6449','2013-05-17','17:35:00',6.42),('6449','2013-05-17','17:40:00',6.09),('6449','2013-05-17','17:45:00',5.74),('6449','2013-05-17','17:50:00',5.32),('6449','2013-05-17','17:55:00',4.96),('6449','2013-05-17','18:00:00',4.66),('6449','2013-05-17','18:05:00',4.32),('6449','2013-05-17','18:10:00',3.94),('6449','2013-05-17','18:15:00',3.58),('6449','2013-05-17','18:20:00',3.23),('6449','2013-05-17','18:25:00',2.93),('6449','2013-05-17','18:30:00',2.58),('6449','2013-05-17','18:35:00',2.35),('6449','2013-05-17','18:40:00',1.97),('6449','2013-05-17','18:45:00',1.71),('6449','2013-05-17','18:50:00',1.37),('6449','2013-05-17','18:55:00',1.11),('6449','2013-05-17','19:00:00',1.02),('6449','2013-05-16','08:45:00',1.11),('6449','2013-05-16','08:50:00',1.83),('6449','2013-05-16','08:55:00',1.65),('6449','2013-05-16','09:00:00',1.3),('6449','2013-05-16','09:05:00',1.73),('6449','2013-05-16','09:10:00',2.72),('6449','2013-05-16','09:15:00',3.08),('6449','2013-05-16','09:20:00',4.33),('6449','2013-05-16','09:25:00',3.57),('6449','2013-05-16','09:30:00',4.9),('6449','2013-05-16','09:35:00',6.92),('6449','2013-05-16','09:40:00',11.9),('6449','2013-05-16','09:45:00',11.69),('6449','2013-05-16','09:50:00',12.73),('6449','2013-05-16','09:55:00',9.96),('6449','2013-05-16','10:00:00',5.32),('6449','2013-05-16','10:05:00',10.05),('6449','2013-05-16','10:10:00',7.54),('6449','2013-05-16','10:15:00',6.66),('6449','2013-05-16','10:20:00',7.31),('6449','2013-05-16','10:25:00',5.89),('6449','2013-05-16','10:30:00',2.83),('6449','2013-05-16','10:35:00',1.85),('6449','2013-05-16','10:40:00',2.93),('6449','2013-05-16','10:45:00',8.09),('6449','2013-05-16','10:50:00',6.97),('6449','2013-05-16','10:55:00',5.11),('6449','2013-05-16','11:00:00',3.83),('6449','2013-05-16','11:05:00',2.82),('6449','2013-05-16','11:10:00',2.2),('6449','2013-05-16','11:15:00',2.19),('6449','2013-05-16','11:20:00',2.85),('6449','2013-05-16','11:25:00',3.53),('6449','2013-05-16','11:30:00',2.85),('6449','2013-05-16','11:35:00',3.22),('6449','2013-05-16','11:40:00',4.76),('6449','2013-05-16','11:45:00',4.5),('6449','2013-05-16','11:50:00',4.73),('6449','2013-05-16','11:55:00',4.23),('6449','2013-05-16','12:00:00',3.5),('6449','2013-05-16','12:05:00',3.81),('6449','2013-05-16','12:10:00',5.86),('6449','2013-05-16','12:15:00',5.51),('6449','2013-05-16','12:20:00',7),('6449','2013-05-16','12:25:00',6.22),('6449','2013-05-16','12:30:00',8.42),('6449','2013-05-16','12:35:00',8.25),('6449','2013-05-16','12:40:00',7.2),('6449','2013-05-16','12:45:00',7.88),('6449','2013-05-16','12:50:00',11.19),('6449','2013-05-16','12:55:00',15.49),('6449','2013-05-16','13:00:00',16.01),('6449','2013-05-16','13:05:00',15.54),('6449','2013-05-16','13:10:00',14.4),('6449','2013-05-16','13:15:00',11.72),('6449','2013-05-16','13:20:00',15.92),('6449','2013-05-16','13:25:00',15.29),('6449','2013-05-16','13:30:00',15.09),('6449','2013-05-16','13:35:00',15.07),('6449','2013-05-16','13:40:00',15.16),('6449','2013-05-16','13:45:00',15.03),('6449','2013-05-16','13:50:00',14.82),('6449','2013-05-16','13:55:00',14.71),('6449','2013-05-16','14:00:00',14.47),('6449','2013-05-16','14:05:00',14.26),('6449','2013-05-16','14:10:00',14.18),('6449','2013-05-16','14:15:00',13.98),('6449','2013-05-16','14:20:00',13.89),('6449','2013-05-16','14:25:00',13.71),('6449','2013-05-16','14:30:00',13.78),('6449','2013-05-16','14:35:00',14.02),('6449','2013-05-16','14:40:00',13.76),('6449','2013-05-16','14:45:00',13.7),('6449','2013-05-16','14:50:00',13.51),('6449','2013-05-16','14:55:00',13.61),('6449','2013-05-16','15:00:00',13.5),('6449','2013-05-16','15:05:00',13.38),('6449','2013-05-16','15:10:00',13.21),('6449','2013-05-16','15:15:00',12.97),('6449','2013-05-16','15:20:00',12.8),('6449','2013-05-16','15:25:00',12.51),('6449','2013-05-16','15:30:00',12.18),('6449','2013-05-16','15:35:00',12.01),('6449','2013-05-16','15:40:00',11.63),('6449','2013-05-16','15:45:00',11.22),('6449','2013-05-16','15:50:00',10.58),('6449','2013-05-16','15:55:00',10.81),('6449','2013-05-16','16:00:00',10.66),('6449','2013-05-16','16:05:00',9.77),('6449','2013-05-16','16:10:00',10.26),('6449','2013-05-16','16:15:00',9.52),('6449','2013-05-16','16:20:00',9.58),('6449','2013-05-16','16:25:00',9.07),('6449','2013-05-16','16:30:00',8.88),('6449','2013-05-16','16:35:00',8.64),('6449','2013-05-16','16:40:00',8.25),('6449','2013-05-16','16:45:00',7.57),('6449','2013-05-16','16:50:00',5.96),('6449','2013-05-16','16:55:00',6.99),('6449','2013-05-16','17:00:00',5.52),('6449','2013-05-16','17:05:00',6.04),('6449','2013-05-16','17:10:00',6.58),('6449','2013-05-16','17:15:00',5.96),('6449','2013-05-16','17:20:00',6.01),('6449','2013-05-16','17:25:00',4.93),('6449','2013-05-16','17:30:00',4.76),('6449','2013-05-16','17:35:00',4.36),('6449','2013-05-16','17:40:00',4.91),('6449','2013-05-16','17:45:00',5.12),('6449','2013-05-16','17:50:00',3.65),('6449','2013-05-16','17:55:00',4.21),('6449','2013-05-16','18:00:00',4.21),('6449','2013-05-16','18:05:00',3.37),('6449','2013-05-16','18:10:00',2.79),('6449','2013-05-16','18:15:00',2.22),('6449','2013-05-16','18:20:00',1.75),('6449','2013-05-16','18:25:00',1.37),('6449','2013-05-16','18:30:00',1.88),('6449','2013-05-16','18:35:00',2),('6449','2013-05-16','18:40:00',1.94),('6449','2013-05-16','18:45:00',1.64),('6449','2013-05-16','18:50:00',1.18),('6449','2013-05-16','18:55:00',1.1),('6449','2013-05-16','19:00:00',1.26),('6449','2013-05-16','19:05:00',1.35),('6449','2013-05-16','19:10:00',1.33),('6449','2013-05-16','19:15:00',1.25),('6449','2013-05-16','19:20:00',1.14),('6449','2013-05-15','06:55:00',1.12),('6449','2013-05-15','07:00:00',1.14),('6449','2013-05-15','07:05:00',1.68),('6449','2013-05-15','07:10:00',2.14),('6449','2013-05-15','07:15:00',2.69),('6449','2013-05-15','07:20:00',3.3),('6449','2013-05-15','07:25:00',2.94),('6449','2013-05-15','07:30:00',3.95),('6449','2013-05-15','07:35:00',4.08),('6449','2013-05-15','07:40:00',4.52),('6449','2013-05-15','07:45:00',4.81),('6449','2013-05-15','07:50:00',4.48),('6449','2013-05-15','07:55:00',5.01),('6449','2013-05-15','08:00:00',5.78),('6449','2013-05-15','08:05:00',5.98),('6449','2013-05-15','08:10:00',6.48),('6449','2013-05-15','08:15:00',6.54),('6449','2013-05-15','08:20:00',7.17),('6449','2013-05-15','08:25:00',7.44),('6449','2013-05-15','08:30:00',7.71),('6449','2013-05-15','08:35:00',7.98),('6449','2013-05-15','08:40:00',8.34),('6449','2013-05-15','08:45:00',8.8),('6449','2013-05-15','08:50:00',8.95),('6449','2013-05-15','08:55:00',9.45),('6449','2013-05-15','09:00:00',9.51),('6449','2013-05-15','09:05:00',9.5),('6449','2013-05-15','09:10:00',9.69),('6449','2013-05-15','09:15:00',10.24),('6449','2013-05-15','09:20:00',10.8),('6449','2013-05-15','09:25:00',10.96),('6449','2013-05-15','09:30:00',10.67),('6449','2013-05-15','09:35:00',11.09),('6449','2013-05-15','09:40:00',11.89),('6449','2013-05-15','09:45:00',12.21),('6449','2013-05-15','09:50:00',12.2),('6449','2013-05-15','09:55:00',12.13),('6449','2013-05-15','10:00:00',12.49),('6449','2013-05-15','10:05:00',12.88),('6449','2013-05-15','10:10:00',13.14),('6449','2013-05-15','10:15:00',13.32),('6449','2013-05-15','10:20:00',13.51),('6449','2013-05-15','10:25:00',13.73),('6449','2013-05-15','10:30:00',13.2),('6449','2013-05-15','10:35:00',13.69),('6449','2013-05-15','10:40:00',14.07),('6449','2013-05-15','10:45:00',13.83),('6449','2013-05-15','10:50:00',14.83),('6449','2013-05-15','10:55:00',12.54),('6449','2013-05-15','11:00:00',14.54),('6449','2013-05-15','11:05:00',14.46),('6449','2013-05-15','11:10:00',14.84),('6449','2013-05-15','11:15:00',15.27),('6449','2013-05-15','11:20:00',15.68),('6449','2013-05-15','11:25:00',16.21),('6449','2013-05-15','11:30:00',14.06),('6449','2013-05-15','11:35:00',8.86),('6449','2013-05-15','11:40:00',13.22),('6449','2013-05-15','11:45:00',16.41),('6449','2013-05-15','11:50:00',16.63),('6449','2013-05-15','11:55:00',15.42),('6449','2013-05-15','12:00:00',11.12),('6449','2013-05-15','12:05:00',10.87),('6449','2013-05-15','12:10:00',14.35),('6449','2013-05-15','12:15:00',16.67),('6449','2013-05-15','12:20:00',15.49),('6449','2013-05-15','12:25:00',10.99),('6449','2013-05-15','12:30:00',8.96),('6449','2013-05-15','12:35:00',7.03),('6449','2013-05-15','12:40:00',6.66),('6449','2013-05-15','12:45:00',6.62),('6449','2013-05-15','12:50:00',6.59),('6449','2013-05-15','12:55:00',6.35),('6449','2013-05-15','13:00:00',6.52),('6449','2013-05-15','13:05:00',7.26),('6449','2013-05-15','13:10:00',8.09),('6449','2013-05-15','13:15:00',9.32),('6449','2013-05-15','13:20:00',9.31),('6449','2013-05-15','13:25:00',10.56),('6449','2013-05-15','13:30:00',7.51),('6449','2013-05-15','13:35:00',7.39),('6449','2013-05-15','13:40:00',7.29),('6449','2013-05-15','13:45:00',7.56),('6449','2013-05-15','13:50:00',5.87),('6449','2013-05-15','13:55:00',5.12),('6449','2013-05-15','14:00:00',5.5),('6449','2013-05-15','14:05:00',6.22),('6449','2013-05-15','14:10:00',7),('6449','2013-05-15','14:15:00',6.17),('6449','2013-05-15','14:20:00',5.67),('6449','2013-05-15','14:25:00',5.58),('6449','2013-05-15','14:30:00',5.5),('6449','2013-05-15','14:35:00',5.45),('6449','2013-05-15','14:40:00',4.98),('6449','2013-05-15','14:45:00',4.67),('6449','2013-05-15','14:50:00',4.48),('6449','2013-05-15','14:55:00',3.83),('6449','2013-05-15','15:00:00',3.38),('6449','2013-05-15','15:05:00',3.19),('6449','2013-05-15','15:10:00',3.34),('6449','2013-05-15','15:15:00',3.26),('6449','2013-05-15','15:20:00',3.52),('6449','2013-05-15','15:25:00',3.97),('6449','2013-05-15','15:30:00',4.35),('6449','2013-05-15','15:35:00',4.57),('6449','2013-05-15','15:40:00',7.04),('6449','2013-05-15','15:45:00',8.45),('6449','2013-05-15','15:50:00',9.42),('6449','2013-05-15','15:55:00',11.41),('6449','2013-05-15','16:00:00',10.44),('6449','2013-05-15','16:05:00',7.89),('6449','2013-05-15','16:10:00',6.04),('6449','2013-05-15','16:15:00',5.46),('6449','2013-05-15','16:20:00',7.87),('6449','2013-05-15','16:25:00',8.52),('6449','2013-05-15','16:30:00',8.78),('6449','2013-05-15','16:35:00',5.3),('6449','2013-05-15','16:40:00',5.06),('6449','2013-05-15','16:45:00',7.45),('6449','2013-05-15','16:50:00',7.83),('6449','2013-05-15','16:55:00',5.72),('6449','2013-05-15','17:00:00',6.77),('6449','2013-05-15','17:05:00',10),('6449','2013-05-15','17:10:00',7.75),('6449','2013-05-15','17:15:00',5.09),('6449','2013-05-15','17:20:00',3.64),('6449','2013-05-15','17:25:00',2.98),('6449','2013-05-15','17:30:00',2.21),('6449','2013-05-15','17:35:00',2.09),('6449','2013-05-15','17:40:00',1.68),('6449','2013-05-15','17:45:00',1.59),('6449','2013-05-15','17:50:00',1.59),('6449','2013-05-15','17:55:00',1.38),('6449','2013-05-15','18:00:00',1.38),('6449','2013-05-15','18:05:00',1.39),('6449','2013-05-15','18:10:00',1.03),('6449','2013-05-15','18:15:00',1.04),('6449','2013-05-15','18:20:00',1.16),('6449','2013-05-15','18:30:00',1.05),('6449','2013-05-15','18:35:00',1.46),('6449','2013-05-15','18:40:00',1.74),('6449','2013-05-15','18:45:00',1.77),('6449','2013-05-15','18:50:00',1.32),('6449','2013-05-15','18:55:00',1.44),('6449','2013-05-15','19:00:00',1.37),('6449','2013-05-14','06:55:00',1.2),('6449','2013-05-14','07:00:00',1.45),('6449','2013-05-14','07:05:00',1.79),('6449','2013-05-14','07:10:00',2.11),('6449','2013-05-14','07:15:00',2.45),('6449','2013-05-14','07:20:00',2.8),('6449','2013-05-14','07:25:00',3.16),('6449','2013-05-14','07:30:00',3.53),('6449','2013-05-14','07:35:00',3.91),('6449','2013-05-14','07:40:00',4.31),('6449','2013-05-14','07:45:00',4.67),('6449','2013-05-14','07:50:00',5.04),('6449','2013-05-14','07:55:00',5.44),('6449','2013-05-14','08:00:00',5.85),('6449','2013-05-14','08:05:00',6.24),('6449','2013-05-14','08:10:00',6.61),('6449','2013-05-14','08:15:00',6.94),('6449','2013-05-14','08:20:00',7.39),('6449','2013-05-14','08:25:00',7.73),('6449','2013-05-14','08:30:00',7.96),('6449','2013-05-14','08:35:00',8.38),('6449','2013-05-14','08:40:00',8.61),('6449','2013-05-14','08:45:00',8.89),('6449','2013-05-14','08:50:00',9.32),('6449','2013-05-14','08:55:00',9.58),('6449','2013-05-14','09:00:00',10.02),('6449','2013-05-14','09:05:00',10.35),('6449','2013-05-14','09:10:00',10.65),('6449','2013-05-14','09:15:00',10.95),('6449','2013-05-14','09:20:00',11.27),('6449','2013-05-14','09:25:00',11.51),('6449','2013-05-14','09:30:00',11.72),('6449','2013-05-14','09:35:00',11.96),('6449','2013-05-14','09:40:00',12.18),('6449','2013-05-14','09:45:00',12.42),('6449','2013-05-14','09:50:00',12.51),('6449','2013-05-14','09:55:00',12.78),('6449','2013-05-14','10:00:00',12.92),('6449','2013-05-14','10:05:00',13.02),('6449','2013-05-14','10:10:00',13.36),('6449','2013-05-14','10:15:00',13.59),('6449','2013-05-14','10:20:00',13.61),('6449','2013-05-14','10:25:00',13.93),('6449','2013-05-14','10:30:00',13.96),('6449','2013-05-14','10:35:00',13.85),('6449','2013-05-14','10:40:00',14.13),('6449','2013-05-14','10:45:00',14.21),('6449','2013-05-14','10:50:00',14.28),('6449','2013-05-14','10:55:00',14.38),('6449','2013-05-14','11:00:00',14.56),('6449','2013-05-14','11:05:00',14.68),('6449','2013-05-14','11:10:00',14.96),('6449','2013-05-14','11:15:00',15.27),('6449','2013-05-14','11:20:00',15.54),('6449','2013-05-14','11:25:00',15.71),('6449','2013-05-14','11:30:00',15.89),('6449','2013-05-14','11:35:00',16.02),('6449','2013-05-14','11:40:00',16.07),('6449','2013-05-14','11:45:00',16.08),('6449','2013-05-14','11:50:00',16.04),('6449','2013-05-14','11:55:00',16.25),('6449','2013-05-14','12:00:00',16.26),('6449','2013-05-14','12:05:00',16.11),('6449','2013-05-14','12:10:00',16.42),('6449','2013-05-14','12:15:00',16.49),('6449','2013-05-14','12:20:00',16.49),('6449','2013-05-14','12:25:00',16.46),('6449','2013-05-14','12:30:00',16.57),('6449','2013-05-14','12:35:00',16.54),('6449','2013-05-14','12:40:00',16.55),('6449','2013-05-14','12:45:00',16.61),('6449','2013-05-14','12:50:00',16.62),('6449','2013-05-14','12:55:00',16.62),('6449','2013-05-14','13:00:00',16.56),('6449','2013-05-14','13:05:00',16.62),('6449','2013-05-14','13:10:00',16.75),('6449','2013-05-14','13:15:00',16.67),('6449','2013-05-14','13:20:00',16.79),('6449','2013-05-14','13:25:00',16.85),('6449','2013-05-14','13:30:00',16.75),('6449','2013-05-14','13:35:00',16.45),('6449','2013-05-14','13:40:00',16.64),('6449','2013-05-14','13:45:00',16.54),('6449','2013-05-14','13:50:00',16.15),('6449','2013-05-14','13:55:00',16.34),('6449','2013-05-14','14:00:00',16.3),('6449','2013-05-14','14:05:00',16.16),('6449','2013-05-14','14:10:00',16.28),('6449','2013-05-14','14:15:00',16.17),('6449','2013-05-14','14:20:00',16.03),('6449','2013-05-14','14:25:00',15.99),('6449','2013-05-14','14:30:00',15.78),('6449','2013-05-14','14:35:00',15.63),('6449','2013-05-14','14:40:00',15.49),('6449','2013-05-14','14:45:00',15.32),('6449','2013-05-14','14:50:00',15.25),('6449','2013-05-14','14:55:00',15.22),('6449','2013-05-14','15:00:00',15.03),('6449','2013-05-14','15:05:00',14.97),('6449','2013-05-14','15:10:00',14.81),('6449','2013-05-14','15:15:00',14.56),('6449','2013-05-14','15:20:00',14.17),('6449','2013-05-14','15:25:00',14.2),('6449','2013-05-14','15:30:00',13.95),('6449','2013-05-14','15:35:00',13.6),('6449','2013-05-14','15:40:00',13.51),('6449','2013-05-14','15:45:00',13.29),('6449','2013-05-14','15:50:00',12.86),('6449','2013-05-14','15:55:00',12.72),('6449','2013-05-14','16:00:00',12.44),('6449','2013-05-14','16:05:00',12.22),('6449','2013-05-14','16:10:00',11.96),('6449','2013-05-14','16:15:00',11.74),('6449','2013-05-14','16:20:00',11.39),('6449','2013-05-14','16:25:00',11.13),('6449','2013-05-14','16:30:00',10.83),('6449','2013-05-14','16:35:00',10.47),('6449','2013-05-14','16:40:00',10.26),('6449','2013-05-14','16:45:00',9.9),('6449','2013-05-14','16:50:00',9.55),('6449','2013-05-14','16:55:00',9.25),('6449','2013-05-14','17:00:00',8.89),('6449','2013-05-14','17:05:00',8.43),('6449','2013-05-14','17:10:00',8.11),('6449','2013-05-14','17:15:00',7.88),('6449','2013-05-14','17:20:00',7.36),('6449','2013-05-14','17:25:00',7.09),('6449','2013-05-14','17:30:00',6.66),('6449','2013-05-14','17:35:00',6.28),('6449','2013-05-14','17:40:00',6),('6449','2013-05-14','17:45:00',5.63),('6449','2013-05-14','17:50:00',5.27),('6449','2013-05-14','17:55:00',4.85),('6449','2013-05-14','18:00:00',4.49),('6449','2013-05-14','18:05:00',4.16),('6449','2013-05-14','18:10:00',3.8),('6449','2013-05-14','18:15:00',3.47),('6449','2013-05-14','18:20:00',3.13),('6449','2013-05-14','18:25:00',2.82),('6449','2013-05-14','18:30:00',2.48),('6449','2013-05-14','18:35:00',2.2),('6449','2013-05-14','18:40:00',1.88),('6449','2013-05-14','18:45:00',1.63),('6449','2013-05-14','18:50:00',1.35),('6449','2013-05-14','18:55:00',1.14),('6449','2013-05-13','06:55:00',1.36),('6449','2013-05-13','07:00:00',1.83),('6449','2013-05-13','07:05:00',2.05),('6449','2013-05-13','07:10:00',2.27),('6449','2013-05-13','07:15:00',2.67),('6449','2013-05-13','07:20:00',3.15),('6449','2013-05-13','07:25:00',2.16),('6449','2013-05-13','07:30:00',1.27),('6449','2013-05-13','07:35:00',1.27),('6449','2013-05-13','07:40:00',2.76),('6449','2013-05-13','07:45:00',3.71),('6449','2013-05-13','07:50:00',2.16),('6449','2013-05-13','07:55:00',5.31),('6449','2013-05-13','08:00:00',5.51),('6449','2013-05-13','08:05:00',5.82),('6449','2013-05-13','08:10:00',6.24),('6449','2013-05-13','08:15:00',6.7),('6449','2013-05-13','08:20:00',7),('6449','2013-05-13','08:25:00',7.2),('6449','2013-05-13','08:30:00',7.56),('6449','2013-05-13','08:35:00',7.88),('6449','2013-05-13','08:40:00',8.15),('6449','2013-05-13','08:45:00',8.51),('6449','2013-05-13','08:50:00',8.95),('6449','2013-05-13','08:55:00',9.12),('6449','2013-05-13','09:00:00',9.51),('6449','2013-05-13','09:05:00',9.67),('6449','2013-05-13','09:10:00',10.18),('6449','2013-05-13','09:15:00',10.47),('6449','2013-05-13','09:20:00',10.94),('6449','2013-05-13','09:25:00',11.27),('6449','2013-05-13','09:30:00',11.38),('6449','2013-05-13','09:35:00',11.58),('6449','2013-05-13','09:40:00',12.09),('6449','2013-05-13','09:45:00',12.22),('6449','2013-05-13','09:50:00',12.3),('6449','2013-05-13','09:55:00',12.7),('6449','2013-05-13','10:00:00',13.12),('6449','2013-05-13','10:05:00',12.16),('6449','2013-05-13','10:10:00',3.09),('6449','2013-05-13','10:15:00',9.48),('6449','2013-05-13','10:20:00',13.95),('6449','2013-05-13','10:25:00',14.29),('6449','2013-05-13','10:30:00',13.84),('6449','2013-05-13','10:35:00',11.02),('6449','2013-05-13','10:40:00',15.35),('6449','2013-05-13','10:45:00',12.21),('6449','2013-05-13','10:50:00',13.49),('6449','2013-05-13','10:55:00',13.48),('6449','2013-05-13','11:00:00',15.58),('6449','2013-05-13','11:05:00',14.38),('6449','2013-05-13','11:10:00',13.89),('6449','2013-05-13','11:15:00',4.74),('6449','2013-05-13','11:20:00',3.76),('6449','2013-05-13','11:25:00',9.25),('6449','2013-05-13','11:30:00',6.73),('6449','2013-05-13','11:35:00',8.34),('6449','2013-05-13','11:40:00',4.11),('6449','2013-05-13','11:45:00',3.79),('6449','2013-05-13','11:50:00',5.69),('6449','2013-05-13','11:55:00',9.91),('6449','2013-05-13','12:00:00',3.98),('6449','2013-05-13','12:05:00',5.62),('6449','2013-05-13','12:10:00',17.75),('6449','2013-05-13','12:15:00',17.46),('6449','2013-05-13','12:20:00',17.06),('6449','2013-05-13','12:25:00',17.04),('6449','2013-05-13','12:30:00',16.98),('6449','2013-05-13','12:35:00',17.03),('6449','2013-05-13','12:40:00',17.5),('6449','2013-05-13','12:45:00',17.66),('6449','2013-05-13','12:50:00',17.72),('6449','2013-05-13','12:55:00',17.53),('6449','2013-05-13','13:00:00',17.03),('6449','2013-05-13','13:05:00',16.65),('6449','2013-05-13','13:10:00',17.03),('6449','2013-05-13','13:15:00',17.55),('6449','2013-05-13','13:20:00',14.25),('6449','2013-05-13','13:25:00',17.66),('6449','2013-05-13','13:30:00',17.14),('6449','2013-05-13','13:35:00',16.91),('6449','2013-05-13','13:40:00',16.67),('6449','2013-05-13','13:45:00',16.75),('6449','2013-05-13','13:50:00',16.98),('6449','2013-05-13','13:55:00',17.29),('6449','2013-05-13','14:00:00',16.43),('6449','2013-05-13','14:05:00',16.16),('6449','2013-05-13','14:10:00',15.94),('6449','2013-05-13','14:15:00',16.2),('6449','2013-05-13','14:20:00',15.4),('6449','2013-05-13','14:25:00',15.82),('6449','2013-05-13','14:30:00',15.84),('6449','2013-05-13','14:35:00',15.76),('6449','2013-05-13','14:40:00',15.74),('6449','2013-05-13','14:45:00',15.76),('6449','2013-05-13','14:50:00',15.61),('6449','2013-05-13','14:55:00',15.5),('6449','2013-05-13','15:00:00',15.13),('6449','2013-05-13','15:05:00',14.77),('6449','2013-05-13','15:10:00',14.64),('6449','2013-05-13','15:15:00',14.7),('6449','2013-05-13','15:20:00',14.35),('6449','2013-05-13','15:25:00',14.2),('6449','2013-05-13','15:30:00',14.03),('6449','2013-05-13','15:35:00',13.82),('6449','2013-05-13','15:40:00',13.53),('6449','2013-05-13','15:45:00',13.33),('6449','2013-05-13','15:50:00',13.09),('6449','2013-05-13','15:55:00',12.89),('6449','2013-05-13','16:00:00',12.63),('6449','2013-05-13','16:05:00',12.2),('6449','2013-05-13','16:10:00',12.11),('6449','2013-05-13','16:15:00',11.83),('6449','2013-05-13','16:20:00',11.56),('6449','2013-05-13','16:25:00',11.23),('6449','2013-05-13','16:30:00',10.82),('6449','2013-05-13','16:35:00',10.64),('6449','2013-05-13','16:40:00',10.11),('6449','2013-05-13','16:45:00',9.89),('6449','2013-05-13','16:50:00',9.46),('6449','2013-05-13','16:55:00',9.11),('6449','2013-05-13','17:00:00',8.72),('6449','2013-05-13','17:05:00',8.37),('6449','2013-05-13','17:10:00',7.99),('6449','2013-05-13','17:15:00',7.63),('6449','2013-05-13','17:20:00',7.31),('6449','2013-05-13','17:25:00',7.07),('6449','2013-05-13','17:30:00',6.74),('6449','2013-05-13','17:35:00',6.36),('6449','2013-05-13','17:40:00',5.89),('6449','2013-05-13','17:45:00',5.6),('6449','2013-05-13','17:50:00',5.2),('6449','2013-05-13','17:55:00',4.7),('6449','2013-05-13','18:00:00',1.16),('6449','2013-05-13','18:05:00',1.19),('6449','2013-05-13','18:10:00',2.34),('6449','2013-05-13','18:15:00',3.16),('6449','2013-05-13','18:20:00',3.26),('6449','2013-05-13','18:25:00',3),('6449','2013-05-13','18:30:00',1.97),('6449','2013-05-13','18:35:00',2.5),('6449','2013-05-13','18:40:00',2.29),('6449','2013-05-13','18:45:00',2.1),('6449','2013-05-13','18:50:00',2.09),('6449','2013-05-13','18:55:00',2.11),('6449','2013-05-13','19:00:00',2.03),('6449','2013-05-13','19:05:00',1.76),('6449','2013-05-13','19:10:00',1.46),('6449','2013-05-13','19:15:00',1.19),('6449','2013-05-12','06:45:00',1),('6449','2013-05-12','06:50:00',1.15),('6449','2013-05-12','06:55:00',1.26),('6449','2013-05-12','07:00:00',1.08),('6449','2013-05-12','07:05:00',1.79),('6449','2013-05-12','07:10:00',1.83),('6449','2013-05-12','07:15:00',1.8),('6449','2013-05-12','07:20:00',1.45),('6449','2013-05-12','07:25:00',1.27),('6449','2013-05-12','07:30:00',1.61),('6449','2013-05-12','07:35:00',1.81),('6449','2013-05-12','07:40:00',2.24),('6449','2013-05-12','07:45:00',3.71),('6449','2013-05-12','07:50:00',4.93),('6449','2013-05-12','07:55:00',4.3),('6449','2013-05-12','08:00:00',4.95),('6449','2013-05-12','08:05:00',5.61),('6449','2013-05-12','08:10:00',4.03),('6449','2013-05-12','08:15:00',3.26),('6449','2013-05-12','08:20:00',3.83),('6449','2013-05-12','08:25:00',7.8),('6449','2013-05-12','08:30:00',6.49),('6449','2013-05-12','08:35:00',5),('6449','2013-05-12','08:40:00',7.04),('6449','2013-05-12','08:45:00',9.44),('6449','2013-05-12','08:50:00',10.24),('6449','2013-05-12','08:55:00',10.43),('6449','2013-05-12','09:00:00',10.58),('6449','2013-05-12','09:05:00',9.76),('6449','2013-05-12','09:10:00',10.99),('6449','2013-05-12','09:15:00',6.65),('6449','2013-05-12','09:20:00',3.99),('6449','2013-05-12','09:25:00',3.84),('6449','2013-05-12','09:30:00',2.8),('6449','2013-05-12','09:35:00',5.8),('6449','2013-05-12','09:40:00',7.31),('6449','2013-05-12','09:45:00',7.54),('6449','2013-05-12','09:50:00',11.17),('6449','2013-05-12','09:55:00',6.37),('6449','2013-05-12','10:00:00',13.45),('6449','2013-05-12','10:05:00',13.47),('6449','2013-05-12','10:10:00',13.26),('6449','2013-05-12','10:15:00',13.63),('6449','2013-05-12','10:20:00',13.69),('6449','2013-05-12','10:25:00',13.93),('6449','2013-05-12','10:30:00',14.08),('6449','2013-05-12','10:35:00',14.22),('6449','2013-05-12','10:40:00',14.26),('6449','2013-05-12','10:45:00',14.57),('6449','2013-05-12','10:50:00',14.67),('6449','2013-05-12','10:55:00',14.9),('6449','2013-05-12','11:00:00',14.96),('6449','2013-05-12','11:05:00',15.11),('6449','2013-05-12','11:10:00',15.13),('6449','2013-05-12','11:15:00',15.4),('6449','2013-05-12','11:20:00',15.38),('6449','2013-05-12','11:25:00',15.75),('6449','2013-05-12','11:30:00',15.91),('6449','2013-05-12','11:35:00',16.03),('6449','2013-05-12','11:40:00',16.09),('6449','2013-05-12','11:45:00',16.12),('6449','2013-05-12','11:50:00',16.09),('6449','2013-05-12','11:55:00',15.86),('6449','2013-05-12','12:00:00',16.12),('6449','2013-05-12','12:05:00',16.22),('6449','2013-05-12','12:10:00',16.34),('6449','2013-05-12','12:15:00',16.38),('6449','2013-05-12','12:20:00',16.44),('6449','2013-05-12','12:25:00',16.38),('6449','2013-05-12','12:30:00',16.56),('6449','2013-05-12','12:35:00',16.55),('6449','2013-05-12','12:40:00',16.54),('6449','2013-05-12','12:45:00',16.65),('6449','2013-05-12','12:50:00',16.69),('6449','2013-05-12','12:55:00',16.74),('6449','2013-05-12','13:00:00',16.75),('6449','2013-05-12','13:05:00',16.44),('6449','2013-05-12','13:10:00',16.57),('6449','2013-05-12','13:15:00',16.56),('6449','2013-05-12','13:20:00',16.58),('6449','2013-05-12','13:25:00',16.58),('6449','2013-05-12','13:30:00',16.5),('6449','2013-05-12','13:35:00',16.39),('6449','2013-05-12','13:40:00',16.44),('6449','2013-05-12','13:45:00',16.32),('6449','2013-05-12','13:50:00',16.04),('6449','2013-05-12','13:55:00',15.92),('6449','2013-05-12','14:00:00',16.18),('6449','2013-05-12','14:05:00',15.14),('6449','2013-05-12','14:10:00',15.75),('6449','2013-05-12','14:15:00',15.95),('6449','2013-05-12','14:20:00',15.85),('6449','2013-05-12','14:25:00',15.67),('6449','2013-05-12','14:30:00',15.55),('6449','2013-05-12','14:35:00',15.52),('6449','2013-05-12','14:40:00',15.39),('6449','2013-05-12','14:45:00',15.12),('6449','2013-05-12','14:50:00',14.93),('6449','2013-05-12','14:55:00',14.81),('6449','2013-05-12','15:00:00',14.63),('6449','2013-05-12','15:05:00',14.48),('6449','2013-05-12','15:10:00',14.38),('6449','2013-05-12','15:15:00',14.05),('6449','2013-05-12','15:20:00',13.78),('6449','2013-05-12','15:25:00',13.66),('6449','2013-05-12','15:30:00',12.74),('6449','2013-05-12','15:35:00',13.42),('6449','2013-05-12','15:40:00',12.42),('6449','2013-05-12','15:45:00',11.58),('6449','2013-05-12','15:50:00',10.74),('6449','2013-05-12','15:55:00',12.13),('6449','2013-05-12','16:00:00',12.11),('6449','2013-05-12','16:05:00',12.15),('6449','2013-05-12','16:10:00',11.84),('6449','2013-05-12','16:15:00',11.73),('6449','2013-05-12','16:20:00',11.14),('6449','2013-05-12','16:25:00',11.13),('6449','2013-05-12','16:30:00',11.01),('6449','2013-05-12','16:35:00',9.05),('6449','2013-05-12','16:40:00',5.51),('6449','2013-05-12','16:45:00',8.58),('6449','2013-05-12','16:50:00',10.55),('6449','2013-05-12','16:55:00',9.34),('6449','2013-05-12','17:00:00',8.67),('6449','2013-05-12','17:05:00',8.24),('6449','2013-05-12','17:10:00',8.28),('6449','2013-05-12','17:15:00',8.12),('6449','2013-05-12','17:20:00',7.46),('6449','2013-05-12','17:25:00',6.45),('6449','2013-05-12','17:30:00',8.16),('6449','2013-05-12','17:35:00',7.59),('6449','2013-05-12','17:40:00',7.59),('6449','2013-05-12','17:45:00',6.69),('6449','2013-05-12','17:50:00',6.16),('6449','2013-05-12','17:55:00',5.55),('6449','2013-05-12','18:00:00',5.03),('6449','2013-05-12','18:05:00',4.64),('6449','2013-05-12','18:10:00',4.36),('6449','2013-05-12','18:15:00',4.07),('6449','2013-05-12','18:20:00',3.69),('6449','2013-05-12','18:25:00',3.42),('6449','2013-05-12','18:30:00',3.42),('6449','2013-05-12','18:35:00',3.52),('6449','2013-05-12','18:40:00',3.49),('6449','2013-05-12','18:45:00',3.65),('6449','2013-05-12','18:50:00',3.32),('6449','2013-05-12','18:55:00',2.44),('6449','2013-05-12','19:00:00',1.74),('6449','2013-05-12','19:05:00',1.41),('6449','2013-05-12','19:10:00',1.18),('6449','2013-05-12','19:15:00',1.04),('6449','2013-05-12','19:20:00',1.05),('6449','2013-05-12','19:25:00',1.06),('6449','2013-05-11','07:10:00',1.27),('6449','2013-05-11','07:15:00',1.62),('6449','2013-05-11','07:20:00',1.53),('6449','2013-05-11','07:25:00',2.28),('6449','2013-05-11','07:30:00',3.22),('6449','2013-05-11','07:35:00',3.66),('6449','2013-05-11','07:40:00',4),('6449','2013-05-11','07:45:00',4.48),('6449','2013-05-11','07:50:00',5.27),('6449','2013-05-11','07:55:00',6.34),('6449','2013-05-11','08:00:00',6.5),('6449','2013-05-11','08:05:00',4.23),('6449','2013-05-11','08:10:00',5.11),('6449','2013-05-11','08:15:00',5.45),('6449','2013-05-11','08:20:00',3.9),('6449','2013-05-11','08:25:00',7.82),('6449','2013-05-11','08:30:00',6.87),('6449','2013-05-11','08:35:00',4.03),('6449','2013-05-11','08:40:00',5.61),('6449','2013-05-11','08:45:00',6.02),('6449','2013-05-11','08:50:00',9.4),('6449','2013-05-11','08:55:00',9.81),('6449','2013-05-11','09:00:00',8.79),('6449','2013-05-11','09:05:00',5.68),('6449','2013-05-11','09:10:00',10.6),('6449','2013-05-11','09:15:00',10.77),('6449','2013-05-11','09:20:00',9.65),('6449','2013-05-11','09:25:00',4.34),('6449','2013-05-11','09:30:00',4.38),('6449','2013-05-11','09:35:00',2.76),('6449','2013-05-11','09:40:00',4.18),('6449','2013-05-11','09:45:00',13.73),('6449','2013-05-11','09:50:00',14.27),('6449','2013-05-11','09:55:00',7.74),('6449','2013-05-11','10:00:00',11.72),('6449','2013-05-11','10:05:00',13.55),('6449','2013-05-11','10:10:00',13.22),('6449','2013-05-11','10:15:00',13.66),('6449','2013-05-11','10:20:00',14.31),('6449','2013-05-11','10:25:00',15.42),('6449','2013-05-11','10:30:00',12.98),('6449','2013-05-11','10:35:00',13.65),('6449','2013-05-11','10:40:00',10.15),('6449','2013-05-11','10:45:00',8.34),('6449','2013-05-11','10:50:00',9.93),('6449','2013-05-11','10:55:00',6.44),('6449','2013-05-11','11:00:00',7.09),('6449','2013-05-11','11:05:00',15.76),('6449','2013-05-11','11:10:00',13.19),('6449','2013-05-11','11:15:00',16.44),('6449','2013-05-11','11:20:00',15.1),('6449','2013-05-11','11:25:00',11.21),('6449','2013-05-11','11:30:00',9.24),('6449','2013-05-11','11:35:00',6.9),('6449','2013-05-11','11:40:00',7.52),('6449','2013-05-11','11:45:00',8.74),('6449','2013-05-11','11:50:00',8.88),('6449','2013-05-11','11:55:00',10),('6449','2013-05-11','12:00:00',9.05),('6449','2013-05-11','12:05:00',11.37),('6449','2013-05-11','12:10:00',11.71),('6449','2013-05-11','12:15:00',9.8),('6449','2013-05-11','12:20:00',11.31),('6449','2013-05-11','12:25:00',11.52),('6449','2013-05-11','12:30:00',13.35),('6449','2013-05-11','12:35:00',11.13),('6449','2013-05-11','12:40:00',11.29),('6449','2013-05-11','12:45:00',4.38),('6449','2013-05-11','12:50:00',4.38),('6449','2013-05-11','12:55:00',6.07),('6449','2013-05-11','13:00:00',6.26),('6449','2013-05-11','13:05:00',9.21),('6449','2013-05-11','13:10:00',10.02),('6449','2013-05-11','13:15:00',12.38),('6449','2013-05-11','13:20:00',10.24),('6449','2013-05-11','13:25:00',7.96),('6449','2013-05-11','13:30:00',12.29),('6449','2013-05-11','13:35:00',13.74),('6449','2013-05-11','13:40:00',15.8),('6449','2013-05-11','13:45:00',16.95),('6449','2013-05-11','13:50:00',16.58),('6449','2013-05-11','13:55:00',16.55),('6449','2013-05-11','14:00:00',16.21),('6449','2013-05-11','14:05:00',16.41),('6449','2013-05-11','14:10:00',16.36),('6449','2013-05-11','14:15:00',16.21),('6449','2013-05-11','14:20:00',16.16),('6449','2013-05-11','14:25:00',16.04),('6449','2013-05-11','14:30:00',15.78),('6449','2013-05-11','14:35:00',15.76),('6449','2013-05-11','14:40:00',15.65),('6449','2013-05-11','14:45:00',15.37),('6449','2013-05-11','14:50:00',15.5),('6449','2013-05-11','14:55:00',15.83),('6449','2013-05-11','15:00:00',15.01),('6449','2013-05-11','15:05:00',14.54),('6449','2013-05-11','15:10:00',12.67),('6449','2013-05-11','15:15:00',14.72),('6449','2013-05-11','15:20:00',12.25),('6449','2013-05-11','15:25:00',15.3),('6449','2013-05-11','15:30:00',14.7),('6449','2013-05-11','15:35:00',9.77),('6449','2013-05-11','15:40:00',14.32),('6449','2013-05-11','15:45:00',11.96),('6449','2013-05-11','15:50:00',12.51),('6449','2013-05-11','15:55:00',7.93),('6449','2013-05-11','16:00:00',10.05),('6449','2013-05-11','16:05:00',5.49),('6449','2013-05-11','16:10:00',9.18),('6449','2013-05-11','16:15:00',10.66),('6449','2013-05-11','16:20:00',11.06),('6449','2013-05-11','16:25:00',11.39),('6449','2013-05-11','16:30:00',10.98),('6449','2013-05-11','16:35:00',10.69),('6449','2013-05-11','16:40:00',10.56),('6449','2013-05-11','16:45:00',10.24),('6449','2013-05-11','16:50:00',9.77),('6449','2013-05-11','16:55:00',9.26),('6449','2013-05-11','17:00:00',9.3),('6449','2013-05-11','17:05:00',9.12),('6449','2013-05-11','17:10:00',8.32),('6449','2013-05-11','17:15:00',8.18),('6449','2013-05-11','17:20:00',7.01),('6449','2013-05-11','17:25:00',7.32),('6449','2013-05-11','17:30:00',6.52),('6449','2013-05-11','17:35:00',7.41),('6449','2013-05-11','17:40:00',7.36),('6449','2013-05-11','17:45:00',5.6),('6449','2013-05-11','17:50:00',5.51),('6449','2013-05-11','17:55:00',5.13),('6449','2013-05-11','18:00:00',4.6),('6449','2013-05-11','18:05:00',3.99),('6449','2013-05-11','18:10:00',3.99),('6449','2013-05-11','18:15:00',3.15),('6449','2013-05-11','18:20:00',3.4),('6449','2013-05-11','18:25:00',3.01),('6449','2013-05-11','18:30:00',2.65),('6449','2013-05-11','18:35:00',2.47),('6449','2013-05-11','18:40:00',2.1),('6449','2013-05-11','18:45:00',2.06),('6449','2013-05-11','18:50:00',1.79),('6449','2013-05-11','18:55:00',1.54),('6449','2013-05-11','19:00:00',1.43),('6449','2013-05-11','19:05:00',1.35),('6449','2013-05-11','19:10:00',1.01),('6449','2013-05-11','19:15:00',1),('6449','2013-05-10','06:30:00',1.08),('6449','2013-05-10','06:35:00',1.16),('6449','2013-05-10','06:40:00',1.28),('6449','2013-05-10','06:45:00',1.42),('6449','2013-05-10','06:50:00',1.56),('6449','2013-05-10','06:55:00',2.05),('6449','2013-05-10','07:00:00',2.12),('6449','2013-05-10','07:05:00',2.52),('6449','2013-05-10','07:10:00',3.25),('6449','2013-05-10','07:15:00',3.44),('6449','2013-05-10','07:20:00',3.5),('6449','2013-05-10','07:25:00',3.55),('6449','2013-05-10','07:30:00',3.46),('6449','2013-05-10','07:35:00',2.9),('6449','2013-05-10','07:40:00',2.55),('6449','2013-05-10','07:45:00',2.64),('6449','2013-05-10','07:50:00',4.33),('6449','2013-05-10','07:55:00',3.05),('6449','2013-05-10','08:00:00',2.26),('6449','2013-05-10','08:05:00',3.41),('6449','2013-05-10','08:10:00',3.81),('6449','2013-05-10','08:15:00',4.05),('6449','2013-05-10','08:20:00',4.34),('6449','2013-05-10','08:25:00',5.5),('6449','2013-05-10','08:30:00',7.59),('6449','2013-05-10','08:35:00',7.27),('6449','2013-05-10','08:40:00',7.64),('6449','2013-05-10','08:45:00',8.56),('6449','2013-05-10','08:50:00',6.91),('6449','2013-05-10','08:55:00',8.04),('6449','2013-05-10','09:00:00',7.08),('6449','2013-05-10','09:05:00',4.18),('6449','2013-05-10','09:10:00',4.56),('6449','2013-05-10','09:15:00',7.14),('6449','2013-05-10','09:20:00',8.43),('6449','2013-05-10','09:25:00',6.63),('6449','2013-05-10','09:30:00',5.34),('6449','2013-05-10','09:35:00',13.29),('6449','2013-05-10','09:40:00',12.54),('6449','2013-05-10','09:45:00',6.39),('6449','2013-05-10','09:50:00',9.21),('6449','2013-05-10','09:55:00',12.9),('6449','2013-05-10','10:00:00',12.09),('6449','2013-05-10','10:05:00',12.7),('6449','2013-05-10','10:10:00',13.08),('6449','2013-05-10','10:15:00',13.66),('6449','2013-05-10','10:20:00',11.39),('6449','2013-05-10','10:25:00',12.41),('6449','2013-05-10','10:30:00',13.49),('6449','2013-05-10','10:35:00',12.55),('6449','2013-05-10','10:40:00',11.65),('6449','2013-05-10','10:45:00',12.42),('6449','2013-05-10','10:50:00',13.76),('6449','2013-05-10','10:55:00',9.41),('6449','2013-05-10','11:00:00',13.55),('6449','2013-05-10','11:05:00',9.85),('6449','2013-05-10','11:10:00',7.7),('6449','2013-05-10','11:15:00',7.44),('6449','2013-05-10','11:20:00',10.2),('6449','2013-05-10','11:25:00',13.11),('6449','2013-05-10','11:30:00',15.64),('6449','2013-05-10','11:35:00',12.94),('6449','2013-05-10','11:40:00',15.3),('6449','2013-05-10','11:45:00',17.82),('6449','2013-05-10','11:50:00',16.74),('6449','2013-05-10','11:55:00',10.94),('6449','2013-05-10','12:00:00',13.43),('6449','2013-05-10','12:05:00',17.49),('6449','2013-05-10','12:10:00',19.01),('6449','2013-05-10','12:15:00',11.55),('6449','2013-05-10','12:20:00',16.49),('6449','2013-05-10','12:25:00',12.01),('6449','2013-05-10','12:30:00',13.58),('6449','2013-05-10','12:35:00',8.75),('6449','2013-05-10','12:40:00',11.27),('6449','2013-05-10','12:45:00',14.01),('6449','2013-05-10','12:50:00',13.63),('6449','2013-05-10','12:55:00',11.63),('6449','2013-05-10','13:00:00',16.18),('6449','2013-05-10','13:05:00',18.48),('6449','2013-05-10','13:10:00',18.16),('6449','2013-05-10','13:15:00',14.66),('6449','2013-05-10','13:20:00',12.79),('6449','2013-05-10','13:25:00',10.39),('6449','2013-05-10','13:30:00',10.07),('6449','2013-05-10','13:35:00',10.71),('6449','2013-05-10','13:40:00',9.09),('6449','2013-05-10','13:45:00',7.75),('6449','2013-05-10','13:50:00',8.71),('6449','2013-05-10','13:55:00',9.35),('6449','2013-05-10','14:00:00',9.04),('6449','2013-05-10','14:05:00',9.51),('6449','2013-05-10','14:10:00',8.81),('6449','2013-05-10','14:15:00',8.24),('6449','2013-05-10','14:20:00',8.07),('6449','2013-05-10','14:25:00',8.45),('6449','2013-05-10','14:30:00',8.06),('6449','2013-05-10','14:35:00',8.34),('6449','2013-05-10','14:40:00',8.8),('6449','2013-05-10','14:45:00',7.66),('6449','2013-05-10','14:50:00',7.61),('6449','2013-05-10','14:55:00',9.01),('6449','2013-05-10','15:00:00',12.7),('6449','2013-05-10','15:05:00',9.17),('6449','2013-05-10','15:10:00',7.39),('6449','2013-05-10','15:15:00',7.25),('6449','2013-05-10','15:20:00',7.02),('6449','2013-05-10','15:25:00',6.95),('6449','2013-05-10','15:30:00',6.97),('6449','2013-05-10','15:35:00',8.61),('6449','2013-05-10','15:40:00',7.65),('6449','2013-05-10','15:45:00',6.35),('6449','2013-05-10','15:50:00',5.18),('6449','2013-05-10','15:55:00',5.27),('6449','2013-05-10','16:00:00',7.08),('6449','2013-05-10','16:05:00',8.04),('6449','2013-05-10','16:10:00',8.05),('6449','2013-05-10','16:15:00',7.34),('6449','2013-05-10','16:20:00',6.97),('6449','2013-05-10','16:25:00',6.75),('6449','2013-05-10','16:30:00',6.75),('6449','2013-05-10','16:35:00',6.72),('6449','2013-05-10','16:40:00',6.32),('6449','2013-05-10','16:45:00',5.63),('6449','2013-05-10','16:50:00',4.86),('6449','2013-05-10','16:55:00',4.88),('6449','2013-05-10','17:00:00',4.9),('6449','2013-05-10','17:05:00',4.49),('6449','2013-05-10','17:10:00',4.17),('6449','2013-05-10','17:15:00',4.06),('6449','2013-05-10','17:20:00',4.07),('6449','2013-05-10','17:25:00',3.87),('6449','2013-05-10','17:30:00',3.19),('6449','2013-05-10','17:35:00',2.71),('6449','2013-05-10','17:40:00',2.45),('6449','2013-05-10','17:45:00',2.07),('6449','2013-05-10','17:50:00',1.88),('6449','2013-05-10','17:55:00',2.08),('6449','2013-05-10','18:00:00',2.42),('6449','2013-05-10','18:05:00',2.55),('6449','2013-05-10','18:10:00',2.35),('6449','2013-05-10','18:15:00',2.2),('6449','2013-05-10','18:20:00',1.82),('6449','2013-05-10','18:25:00',1.52),('6449','2013-05-10','18:30:00',1.28),('6449','2013-05-10','18:35:00',1.11),('6449','2013-05-10','18:40:00',1.07),('6449','2013-05-10','18:45:00',1.22),('6449','2013-05-10','18:50:00',1.22),('6449','2013-05-10','18:55:00',1.04),('6449','2013-05-09','06:55:00',1.15),('6449','2013-05-09','07:00:00',1.36),('6449','2013-05-09','07:05:00',1.63),('6449','2013-05-09','07:10:00',1.89),('6449','2013-05-09','07:15:00',2.21),('6449','2013-05-09','07:20:00',2.55),('6449','2013-05-09','07:25:00',2.87),('6449','2013-05-09','07:30:00',3.21),('6449','2013-05-09','07:35:00',3.58),('6449','2013-05-09','07:40:00',3.93),('6449','2013-05-09','07:45:00',4.29),('6449','2013-05-09','07:50:00',4.56),('6449','2013-05-09','07:55:00',4.94),('6449','2013-05-09','08:00:00',5.47),('6449','2013-05-09','08:05:00',5.79),('6449','2013-05-09','08:10:00',6.08),('6449','2013-05-09','08:15:00',6.52),('6449','2013-05-09','08:20:00',6.86),('6449','2013-05-09','08:25:00',7.14),('6449','2013-05-09','08:30:00',7.64),('6449','2013-05-09','08:35:00',7.92),('6449','2013-05-09','08:40:00',8.3),('6449','2013-05-09','08:45:00',8.62),('6449','2013-05-09','08:50:00',8.96),('6449','2013-05-09','08:55:00',9.35),('6449','2013-05-09','09:00:00',9.66),('6449','2013-05-09','09:05:00',9.95),('6449','2013-05-09','09:10:00',10.32),('6449','2013-05-09','09:15:00',10.56),('6449','2013-05-09','09:20:00',10.84),('6449','2013-05-09','09:25:00',11.12),('6449','2013-05-09','09:30:00',11.38),('6449','2013-05-09','09:35:00',11.69),('6449','2013-05-09','09:40:00',11.9),('6449','2013-05-09','09:45:00',12.09),('6449','2013-05-09','09:50:00',12.34),('6449','2013-05-09','09:55:00',12.33),('6449','2013-05-09','10:00:00',12.59),('6449','2013-05-09','10:05:00',12.79),('6449','2013-05-09','10:10:00',12.95),('6449','2013-05-09','10:15:00',13.04),('6449','2013-05-09','10:20:00',13.18),('6449','2013-05-09','10:25:00',13.39),('6449','2013-05-09','10:30:00',13.63),('6449','2013-05-09','10:35:00',14),('6449','2013-05-09','10:40:00',14.21),('6449','2013-05-09','10:45:00',14.31),('6449','2013-05-09','10:50:00',14.45),('6449','2013-05-09','10:55:00',14.63),('6449','2013-05-09','11:00:00',14.85),('6449','2013-05-09','11:05:00',14.89),('6449','2013-05-09','11:10:00',15),('6449','2013-05-09','11:15:00',15.18),('6449','2013-05-09','11:20:00',15.27),('6449','2013-05-09','11:25:00',15.32),('6449','2013-05-09','11:30:00',15.57),('6449','2013-05-09','11:35:00',15.74),('6449','2013-05-09','11:40:00',15.77),('6449','2013-05-09','11:45:00',16.05),('6449','2013-05-09','11:50:00',16.29),('6449','2013-05-09','11:55:00',16.35),('6449','2013-05-09','12:00:00',16.42),('6449','2013-05-09','12:05:00',16.35),('6449','2013-05-09','12:10:00',16.32),('6449','2013-05-09','12:15:00',16.35),('6449','2013-05-09','12:20:00',16.46),('6449','2013-05-09','12:25:00',16.61),('6449','2013-05-09','12:30:00',16.66),('6449','2013-05-09','12:35:00',16.7),('6449','2013-05-09','12:40:00',16.56),('6449','2013-05-09','12:45:00',16.78),('6449','2013-05-09','12:50:00',16.76),('6449','2013-05-09','12:55:00',16.89),('6449','2013-05-09','13:00:00',16.93),('6449','2013-05-09','13:05:00',17.01),('6449','2013-05-09','13:10:00',16.89),('6449','2013-05-09','13:15:00',16.9),('6449','2013-05-09','13:20:00',17),('6449','2013-05-09','13:25:00',16.66),('6449','2013-05-09','13:30:00',16.68),('6449','2013-05-09','13:35:00',16.7),('6449','2013-05-09','13:40:00',16.61),('6449','2013-05-09','13:45:00',16.53),('6449','2013-05-09','13:50:00',16.53),('6449','2013-05-09','13:55:00',16.36),('6449','2013-05-09','14:00:00',16.15),('6449','2013-05-09','14:05:00',16.07),('6449','2013-05-09','14:10:00',16.06),('6449','2013-05-09','14:15:00',15.76),('6449','2013-05-09','14:20:00',15.95),('6449','2013-05-09','14:25:00',15.74),('6449','2013-05-09','14:30:00',15.72),('6449','2013-05-09','14:35:00',15.59),('6449','2013-05-09','14:40:00',15.46),('6449','2013-05-09','14:45:00',15.4),('6449','2013-05-09','14:50:00',15.23),('6449','2013-05-09','14:55:00',14.53),('6449','2013-05-09','15:00:00',14.86),('6449','2013-05-09','15:05:00',14.78),('6449','2013-05-09','15:10:00',14.43),('6449','2013-05-09','15:15:00',14.4),('6449','2013-05-09','15:20:00',14.22),('6449','2013-05-09','15:25:00',14.11),('6449','2013-05-09','15:30:00',13.82),('6449','2013-05-09','15:35:00',13.52),('6449','2013-05-09','15:40:00',13.27),('6449','2013-05-09','15:45:00',13.06),('6449','2013-05-09','15:50:00',12.94),('6449','2013-05-09','15:55:00',12.57),('6449','2013-05-09','16:00:00',12.09),('6449','2013-05-09','16:05:00',12.01),('6449','2013-05-09','16:10:00',11.7),('6449','2013-05-09','16:15:00',11.52),('6449','2013-05-09','16:20:00',11.18),('6449','2013-05-09','16:25:00',10.9),('6449','2013-05-09','16:30:00',10.61),('6449','2013-05-09','16:35:00',10.28),('6449','2013-05-09','16:40:00',10.03),('6449','2013-05-09','16:45:00',9.7),('6449','2013-05-09','16:50:00',9.39),('6449','2013-05-09','16:55:00',8.95),('6449','2013-05-09','17:00:00',8.72),('6449','2013-05-09','17:05:00',8.31),('6449','2013-05-09','17:10:00',8.05),('6449','2013-05-09','17:15:00',7.66),('6449','2013-05-09','17:20:00',7.29),('6449','2013-05-09','17:25:00',6.94),('6449','2013-05-09','17:30:00',6.55),('6449','2013-05-09','17:35:00',6.24),('6449','2013-05-09','17:40:00',5.87),('6449','2013-05-09','17:45:00',5.47),('6449','2013-05-09','17:50:00',5.14),('6449','2013-05-09','17:55:00',4.7),('6449','2013-05-09','18:00:00',4.31),('6449','2013-05-09','18:05:00',4.02),('6449','2013-05-09','18:10:00',3.66),('6449','2013-05-09','18:15:00',3.27),('6449','2013-05-09','18:20:00',2.97),('6449','2013-05-09','18:25:00',2.66),('6449','2013-05-09','18:30:00',2.31),('6449','2013-05-09','18:35:00',2.08),('6449','2013-05-09','18:40:00',1.8),('6449','2013-05-09','18:45:00',1.57),('6449','2013-05-09','18:50:00',1.32),('6449','2013-05-09','18:55:00',1.12),('6449','2013-05-08','07:05:00',1.12),('6449','2013-05-08','07:10:00',1.77),('6449','2013-05-08','07:15:00',2.1),('6449','2013-05-08','07:20:00',2.48),('6449','2013-05-08','07:25:00',2.77),('6449','2013-05-08','07:30:00',3.11),('6449','2013-05-08','07:35:00',3.38),('6449','2013-05-08','07:40:00',3.69),('6449','2013-05-08','07:45:00',4.1),('6449','2013-05-08','07:50:00',4.52),('6449','2013-05-08','07:55:00',4.9),('6449','2013-05-08','08:00:00',5.27),('6449','2013-05-08','08:05:00',5.31),('6449','2013-05-08','08:10:00',5.8),('6449','2013-05-08','08:15:00',6.13),('6449','2013-05-08','08:20:00',6.31),('6449','2013-05-08','08:25:00',7.06),('6449','2013-05-08','08:30:00',7.29),('6449','2013-05-08','08:35:00',7.63),('6449','2013-05-08','08:40:00',8.06),('6449','2013-05-08','08:45:00',8.45),('6449','2013-05-08','08:50:00',8.9),('6449','2013-05-08','08:55:00',9.39),('6449','2013-05-08','09:00:00',9.27),('6449','2013-05-08','09:05:00',8),('6449','2013-05-08','09:10:00',8.65),('6449','2013-05-08','09:15:00',11.18),('6449','2013-05-08','09:20:00',5.45),('6449','2013-05-08','09:25:00',11.07),('6449','2013-05-08','09:30:00',13.12),('6449','2013-05-08','09:35:00',7.55),('6449','2013-05-08','09:40:00',3.07),('6449','2013-05-08','09:45:00',3.64),('6449','2013-05-08','09:50:00',4.24),('6449','2013-05-08','09:55:00',9.7),('6449','2013-05-08','10:00:00',13.99),('6449','2013-05-08','10:05:00',14.02),('6449','2013-05-08','10:10:00',14.59),('6449','2013-05-08','10:15:00',8.94),('6449','2013-05-08','10:20:00',14.95),('6449','2013-05-08','10:25:00',13.6),('6449','2013-05-08','10:30:00',10.57),('6449','2013-05-08','10:35:00',14.27),('6449','2013-05-08','10:40:00',14.27),('6449','2013-05-08','10:45:00',14.27),('6449','2013-05-08','10:50:00',14.56),('6449','2013-05-08','10:55:00',14.59),('6449','2013-05-08','11:00:00',14.75),('6449','2013-05-08','11:05:00',14.84),('6449','2013-05-08','11:10:00',14.95),('6449','2013-05-08','11:15:00',15.18),('6449','2013-05-08','11:20:00',15.38),('6449','2013-05-08','11:25:00',15.53),('6449','2013-05-08','11:30:00',15.67),('6449','2013-05-08','11:35:00',15.7),('6449','2013-05-08','11:40:00',15.69),('6449','2013-05-08','11:45:00',15.93),('6449','2013-05-08','11:50:00',15.98),('6449','2013-05-08','11:55:00',16.1),('6449','2013-05-08','12:00:00',16.02),('6449','2013-05-08','12:05:00',16.27),('6449','2013-05-08','12:10:00',16.31),('6449','2013-05-08','12:15:00',16.47),('6449','2013-05-08','12:20:00',16.58),('6449','2013-05-08','12:25:00',16.52),('6449','2013-05-08','12:30:00',16.43),('6449','2013-05-08','12:35:00',16.59),('6449','2013-05-08','12:40:00',16.57),('6449','2013-05-08','12:45:00',16.61),('6449','2013-05-08','12:50:00',16.59),('6449','2013-05-08','12:55:00',16.52),('6449','2013-05-08','13:00:00',16.58),('6449','2013-05-08','13:05:00',16.55),('6449','2013-05-08','13:10:00',16.55),('6449','2013-05-08','13:15:00',16.56),('6449','2013-05-08','13:20:00',16.53),('6449','2013-05-08','13:25:00',16.41),('6449','2013-05-08','13:30:00',16.53),('6449','2013-05-08','13:35:00',16.4),('6449','2013-05-08','13:40:00',16.36),('6449','2013-05-08','13:45:00',16.19),('6449','2013-05-08','13:50:00',16.28),('6449','2013-05-08','13:55:00',16.11),('6449','2013-05-08','14:00:00',16.01),('6449','2013-05-08','14:05:00',15.94),('6449','2013-05-08','14:10:00',15.79),('6449','2013-05-08','14:15:00',15.75),('6449','2013-05-08','14:20:00',15.65),('6449','2013-05-08','14:25:00',15.49),('6449','2013-05-08','14:30:00',15.42),('6449','2013-05-08','14:35:00',15.31),('6449','2013-05-08','14:40:00',15.07),('6449','2013-05-08','14:45:00',15.09),('6449','2013-05-08','14:50:00',14.79),('6449','2013-05-08','14:55:00',14.9),('6449','2013-05-08','15:00:00',14.58),('6449','2013-05-08','15:05:00',14.29),('6449','2013-05-08','15:10:00',13.91),('6449','2013-05-08','15:15:00',13.92),('6449','2013-05-08','15:20:00',13.71),('6449','2013-05-08','15:25:00',13.58),('6449','2013-05-08','15:30:00',13.3),('6449','2013-05-08','15:35:00',13.28),('6449','2013-05-08','15:40:00',13.59),('6449','2013-05-08','15:45:00',11.83),('6449','2013-05-08','15:50:00',5.67),('6449','2013-05-08','15:55:00',5.13),('6449','2013-05-08','16:00:00',5.87),('6449','2013-05-08','16:05:00',9.01),('6449','2013-05-08','16:10:00',7.34),('6449','2013-05-08','16:15:00',6.88),('6449','2013-05-08','16:20:00',6.82),('6449','2013-05-08','16:25:00',3.81),('6449','2013-05-08','16:30:00',6.37),('6449','2013-05-08','16:35:00',5.46),('6449','2013-05-08','16:40:00',5.08),('6449','2013-05-08','16:45:00',4.25),('6449','2013-05-08','16:50:00',4.49),('6449','2013-05-08','16:55:00',8.62),('6449','2013-05-08','17:00:00',9.62),('6449','2013-05-08','17:05:00',9.26),('6449','2013-05-08','17:10:00',8.84),('6449','2013-05-08','17:15:00',8.26),('6449','2013-05-08','17:20:00',7.18),('6449','2013-05-08','17:25:00',3.58),('6449','2013-05-08','17:30:00',3.48),('6449','2013-05-08','17:35:00',2.06),('6449','2013-05-08','17:40:00',2.56),('6449','2013-05-08','17:45:00',2.55),('6449','2013-05-08','17:50:00',2.67),('6449','2013-05-08','17:55:00',3.09),('6449','2013-05-08','18:00:00',2.91),('6449','2013-05-08','18:05:00',2.43),('6449','2013-05-08','18:10:00',2.18),('6449','2013-05-08','18:15:00',3.65),('6449','2013-05-08','18:20:00',3.59),('6449','2013-05-08','18:25:00',2.51),('6449','2013-05-08','18:30:00',3.01),('6449','2013-05-08','18:35:00',2.82),('6449','2013-05-08','18:40:00',2.49),('6449','2013-05-08','18:45:00',1.59),('6449','2013-05-08','18:50:00',1.32),('6449','2013-05-08','18:55:00',1.07),('6449','2013-05-07','07:25:00',2.14),('6449','2013-05-07','07:30:00',3.29),('6449','2013-05-07','07:35:00',3.62),('6449','2013-05-07','07:40:00',3.98),('6449','2013-05-07','07:45:00',4.34),('6449','2013-05-07','07:50:00',4.63),('6449','2013-05-07','07:55:00',3.66),('6449','2013-05-07','08:00:00',5.42),('6449','2013-05-07','08:05:00',5.82),('6449','2013-05-07','08:10:00',6.23),('6449','2013-05-07','08:15:00',6.61),('6449','2013-05-07','08:20:00',6.95),('6449','2013-05-07','08:25:00',7.33),('6449','2013-05-07','08:30:00',7.63),('6449','2013-05-07','08:35:00',7.22),('6449','2013-05-07','08:40:00',8.34),('6449','2013-05-07','08:45:00',8.66),('6449','2013-05-07','08:50:00',9.27),('6449','2013-05-07','08:55:00',9.26),('6449','2013-05-07','09:00:00',9.78),('6449','2013-05-07','09:05:00',10.16),('6449','2013-05-07','09:10:00',8.95),('6449','2013-05-07','09:15:00',10.88),('6449','2013-05-07','09:20:00',11.05),('6449','2013-05-07','09:25:00',11.9),('6449','2013-05-07','09:30:00',9.22),('6449','2013-05-07','09:35:00',12.43),('6449','2013-05-07','09:40:00',13.78),('6449','2013-05-07','09:45:00',13.05),('6449','2013-05-07','09:50:00',13.36),('6449','2013-05-07','09:55:00',12.54),('6449','2013-05-07','10:00:00',9.48),('6449','2013-05-07','10:05:00',11.03),('6449','2013-05-07','10:10:00',13.38),('6449','2013-05-07','10:15:00',15.78),('6449','2013-05-07','10:20:00',15.75),('6449','2013-05-07','10:25:00',15.91),('6449','2013-05-07','10:30:00',16.31),('6449','2013-05-07','10:35:00',11.38),('6449','2013-05-07','10:40:00',4.96),('6449','2013-05-07','10:45:00',4.41),('6449','2013-05-07','10:50:00',3.99),('6449','2013-05-07','10:55:00',10.66),('6449','2013-05-07','11:00:00',15.2),('6449','2013-05-07','11:05:00',15.8),('6449','2013-05-07','11:10:00',15.5),('6449','2013-05-07','11:15:00',15.35),('6449','2013-05-07','11:20:00',15.58),('6449','2013-05-07','11:25:00',15.69),('6449','2013-05-07','11:30:00',15.72),('6449','2013-05-07','11:35:00',15.77),('6449','2013-05-07','11:40:00',15.79),('6449','2013-05-07','11:45:00',16.1),('6449','2013-05-07','11:50:00',16.32),('6449','2013-05-07','11:55:00',16.29),('6449','2013-05-07','12:00:00',14.73),('6449','2013-05-07','12:05:00',16.21),('6449','2013-05-07','12:10:00',16.12),('6449','2013-05-07','12:15:00',15.6),('6449','2013-05-07','12:20:00',14.24),('6449','2013-05-07','12:25:00',13.86),('6449','2013-05-07','12:30:00',13.22),('6449','2013-05-07','12:35:00',9.6),('6449','2013-05-07','12:40:00',14.61),('6449','2013-05-07','12:45:00',15.59),('6449','2013-05-07','12:50:00',16.05),('6449','2013-05-07','12:55:00',16.4),('6449','2013-05-07','13:00:00',15.8),('6449','2013-05-07','13:05:00',16.96),('6449','2013-05-07','13:10:00',14.63),('6449','2013-05-07','13:15:00',16.22),('6449','2013-05-07','13:20:00',16.81),('6449','2013-05-07','13:25:00',16.68),('6449','2013-05-07','13:30:00',16.22),('6449','2013-05-07','13:35:00',17.01),('6449','2013-05-07','13:40:00',15.53),('6449','2013-05-07','13:45:00',16.22),('6449','2013-05-07','13:50:00',15.93),('6449','2013-05-07','13:55:00',15.46),('6449','2013-05-07','14:00:00',16.89),('6449','2013-05-07','14:05:00',13.22),('6449','2013-05-07','14:10:00',14.88),('6449','2013-05-07','14:15:00',16.25),('6449','2013-05-07','14:20:00',14.68),('6449','2013-05-07','14:25:00',15.36),('6449','2013-05-07','14:30:00',14.69),('6449','2013-05-07','14:35:00',15.38),('6449','2013-05-07','14:40:00',15.53),('6449','2013-05-07','14:45:00',15.63),('6449','2013-05-07','14:50:00',15.91),('6449','2013-05-07','14:55:00',13.54),('6449','2013-05-07','15:00:00',13.51),('6449','2013-05-07','15:05:00',14.07),('6449','2013-05-07','15:10:00',15.84),('6449','2013-05-07','15:15:00',14.01),('6449','2013-05-07','15:20:00',13.21),('6449','2013-05-07','15:25:00',12.46),('6449','2013-05-07','15:30:00',11.94),('6449','2013-05-07','15:35:00',12.02),('6449','2013-05-07','15:40:00',11.03),('6449','2013-05-07','15:45:00',9.62),('6449','2013-05-07','15:50:00',8.31),('6449','2013-05-07','15:55:00',8.7),('6449','2013-05-07','16:00:00',9.71),('6449','2013-05-07','16:05:00',12.13),('6449','2013-05-07','16:10:00',12.37),('6449','2013-05-07','16:15:00',12.84),('6449','2013-05-07','16:20:00',12.86),('6449','2013-05-07','16:25:00',7.6),('6449','2013-05-07','16:30:00',7.22),('6449','2013-05-07','16:35:00',9.83),('6449','2013-05-07','16:40:00',9.67),('6449','2013-05-07','16:45:00',10.23),('6449','2013-05-07','16:50:00',6.23),('6449','2013-05-07','16:55:00',8.99),('6449','2013-05-07','17:00:00',7.88),('6449','2013-05-07','17:05:00',4.68),('6449','2013-05-07','17:10:00',4.2),('6449','2013-05-07','17:15:00',3.53),('6449','2013-05-07','17:20:00',3.25),('6449','2013-05-07','17:25:00',3.12),('6449','2013-05-07','17:30:00',3.33),('6449','2013-05-07','17:35:00',4.65),('6449','2013-05-07','17:40:00',9.86),('6449','2013-05-07','17:45:00',8.96),('6449','2013-05-07','17:50:00',3.89),('6449','2013-05-07','17:55:00',5.97),('6449','2013-05-07','18:00:00',5.34),('6449','2013-05-07','18:05:00',3.32),('6449','2013-05-07','18:10:00',2.01),('6449','2013-05-07','18:15:00',1.92),('6449','2013-05-07','18:20:00',1.92),('6449','2013-05-07','18:25:00',1.64),('6449','2013-05-07','18:30:00',1.44),('6449','2013-05-07','18:35:00',1.52),('6449','2013-05-07','18:40:00',1.5),('6449','2013-05-07','18:45:00',1.28),('6449','2013-05-06','08:25:00',1.42),('6449','2013-05-06','08:30:00',1.52),('6449','2013-05-06','08:35:00',1.03),('6449','2013-05-06','08:55:00',1.6),('6449','2013-05-06','09:00:00',1.25),('6449','2013-05-06','09:20:00',1.74),('6449','2013-05-06','09:25:00',1.21),('6449','2013-05-06','09:55:00',1.64),('6449','2013-05-06','10:00:00',4.08),('6449','2013-05-06','10:05:00',7.52),('6449','2013-05-06','10:10:00',6.09),('6449','2013-05-06','10:15:00',5.09),('6449','2013-05-06','10:20:00',8.7),('6449','2013-05-06','10:25:00',7.01),('6449','2013-05-06','10:30:00',4.33),('6449','2013-05-06','10:35:00',2.65),('6449','2013-05-06','10:40:00',4.6),('6449','2013-05-06','10:45:00',4.4),('6449','2013-05-06','10:50:00',4.99),('6449','2013-05-06','10:55:00',7),('6449','2013-05-06','11:00:00',7.96),('6449','2013-05-06','11:05:00',6.94),('6449','2013-05-06','11:10:00',8.08),('6449','2013-05-06','11:15:00',9.25),('6449','2013-05-06','11:20:00',14.79),('6449','2013-05-06','11:25:00',13.27),('6449','2013-05-06','11:30:00',11.88),('6449','2013-05-06','11:35:00',16.93),('6449','2013-05-06','11:40:00',16.91),('6449','2013-05-06','11:45:00',16.34),('6449','2013-05-06','11:50:00',16.57),('6449','2013-05-06','11:55:00',16.19),('6449','2013-05-06','12:00:00',15.93),('6449','2013-05-06','12:05:00',16.13),('6449','2013-05-06','12:10:00',16.31),('6449','2013-05-06','12:15:00',16.29),('6449','2013-05-06','12:20:00',15.94),('6449','2013-05-06','12:25:00',14.22),('6449','2013-05-06','12:30:00',16.95),('6449','2013-05-06','12:35:00',16.78),('6449','2013-05-06','12:40:00',16.56),('6449','2013-05-06','12:45:00',16.49),('6449','2013-05-06','12:50:00',14.05),('6449','2013-05-06','12:55:00',14.62),('6449','2013-05-06','13:00:00',12.31),('6449','2013-05-06','13:05:00',12.82),('6449','2013-05-06','13:10:00',18.02),('6449','2013-05-06','13:15:00',16.7),('6449','2013-05-06','13:20:00',16.78),('6449','2013-05-06','13:25:00',16.98),('6449','2013-05-06','13:30:00',15.77),('6449','2013-05-06','13:35:00',16),('6449','2013-05-06','13:40:00',15.09),('6449','2013-05-06','13:45:00',10.06),('6449','2013-05-06','13:50:00',16.5),('6449','2013-05-06','13:55:00',14.66),('6449','2013-05-06','14:00:00',15.88),('6449','2013-05-06','14:05:00',10.03),('6449','2013-05-06','14:10:00',14.87),('6449','2013-05-06','14:15:00',13.51),('6449','2013-05-06','14:20:00',12.06),('6449','2013-05-06','14:25:00',12.27),('6449','2013-05-06','14:30:00',14.69),('6449','2013-05-06','14:35:00',13.09),('6449','2013-05-06','14:40:00',13.4),('6449','2013-05-06','14:45:00',14.99),('6449','2013-05-06','14:50:00',15.18),('6449','2013-05-06','14:55:00',13.69),('6449','2013-05-06','15:00:00',15.23),('6449','2013-05-06','15:05:00',15.04),('6449','2013-05-06','15:10:00',13),('6449','2013-05-06','15:15:00',12.82),('6449','2013-05-06','15:20:00',10.57),('6449','2013-05-06','15:25:00',13.11),('6449','2013-05-06','15:30:00',14.61),('6449','2013-05-06','15:35:00',12.35),('6449','2013-05-06','15:40:00',13.74),('6449','2013-05-06','15:45:00',13.13),('6449','2013-05-06','15:50:00',13.05),('6449','2013-05-06','15:55:00',11),('6449','2013-05-06','16:00:00',6.56),('6449','2013-05-06','16:05:00',11.38),('6449','2013-05-06','16:10:00',10.29),('6449','2013-05-06','16:15:00',7.93),('6449','2013-05-06','16:20:00',8.03),('6449','2013-05-06','16:25:00',7.42),('6449','2013-05-06','16:30:00',7.41),('6449','2013-05-06','16:35:00',9.01),('6449','2013-05-06','16:40:00',5.93),('6449','2013-05-06','16:45:00',9.34),('6449','2013-05-06','16:50:00',5.5),('6449','2013-05-06','16:55:00',5.37),('6449','2013-05-06','17:00:00',4.98),('6449','2013-05-06','17:05:00',4.11),('6449','2013-05-06','17:10:00',2.44),('6449','2013-05-06','17:15:00',2.46),('6449','2013-05-06','17:20:00',2.15),('6449','2013-05-06','17:25:00',2.11),('6449','2013-05-06','17:30:00',2.54),('6449','2013-05-06','17:35:00',2.68),('6449','2013-05-06','17:40:00',2.38),('6449','2013-05-06','17:45:00',1.9),('6449','2013-05-06','17:50:00',2.99),('6449','2013-05-06','17:55:00',2.84),('6449','2013-05-06','18:00:00',2.91),('6449','2013-05-06','18:05:00',1.65),('6449','2013-05-06','18:10:00',1.72),('6449','2013-05-06','18:15:00',1.43),('6449','2013-05-06','18:20:00',1.15),('6449','2013-05-06','18:25:00',1.18),('6449','2013-05-06','18:30:00',1.51),('6449','2013-05-06','18:35:00',1.94),('6449','2013-05-06','18:40:00',1.86),('6449','2013-05-06','18:45:00',1.43),('6449','2013-05-06','18:50:00',1.15),('6449','2013-05-06','18:55:00',1.19),('6449','2013-05-06','19:00:00',1.49),('6449','2013-05-06','19:05:00',1.84),('6449','2013-05-06','19:10:00',1.94),('6449','2013-05-06','19:15:00',1.46),('6449','2013-05-06','19:20:00',1.18),('6449','2013-05-05','07:00:00',1.23),('6449','2013-05-05','07:05:00',1.69),('6449','2013-05-05','07:10:00',1.94),('6449','2013-05-05','07:15:00',2.23),('6449','2013-05-05','07:20:00',2.72),('6449','2013-05-05','07:25:00',3.31),('6449','2013-05-05','07:30:00',3.46),('6449','2013-05-05','07:35:00',3.61),('6449','2013-05-05','07:40:00',3.42),('6449','2013-05-05','07:45:00',4.07),('6449','2013-05-05','07:50:00',2.77),('6449','2013-05-05','07:55:00',2.41),('6449','2013-05-05','08:00:00',2.41),('6449','2013-05-05','08:05:00',2.36),('6449','2013-05-05','08:10:00',2.46),('6449','2013-05-05','08:15:00',2.44),('6449','2013-05-05','08:20:00',2.36),('6449','2013-05-05','08:25:00',2.55),('6449','2013-05-05','08:30:00',3.74),('6449','2013-05-05','08:35:00',4.21),('6449','2013-05-05','08:40:00',5.14),('6449','2013-05-05','08:45:00',4.48),('6449','2013-05-05','08:50:00',3.44),('6449','2013-05-05','08:55:00',3.27),('6449','2013-05-05','09:00:00',3.39),('6449','2013-05-05','09:05:00',6.38),('6449','2013-05-05','09:10:00',5.16),('6449','2013-05-05','09:15:00',10.19),('6449','2013-05-05','09:20:00',10.19),('6449','2013-05-05','09:25:00',11.68),('6449','2013-05-05','09:30:00',11.97),('6449','2013-05-05','09:35:00',12.11),('6449','2013-05-05','09:40:00',9.73),('6449','2013-05-05','09:45:00',7.02),('6449','2013-05-05','09:50:00',6.54),('6449','2013-05-05','09:55:00',2.86),('6449','2013-05-05','10:00:00',2.12),('6449','2013-05-05','10:05:00',2.78),('6449','2013-05-05','10:10:00',5.41),('6449','2013-05-05','10:15:00',13.99),('6449','2013-05-05','10:20:00',8.35),('6449','2013-05-05','10:25:00',8.68),('6449','2013-05-05','10:30:00',5.22),('6449','2013-05-05','10:35:00',5.78),('6449','2013-05-05','10:40:00',4.18),('6449','2013-05-05','10:45:00',6.14),('6449','2013-05-05','10:50:00',10.35),('6449','2013-05-05','10:55:00',12.08),('6449','2013-05-05','11:00:00',15.33),('6449','2013-05-05','11:05:00',13.22),('6449','2013-05-05','11:10:00',10.16),('6449','2013-05-05','11:15:00',10.05),('6449','2013-05-05','11:20:00',11.59),('6449','2013-05-05','11:25:00',12.53),('6449','2013-05-05','11:30:00',11.49),('6449','2013-05-05','11:35:00',11.62),('6449','2013-05-05','11:40:00',11.71),('6449','2013-05-05','11:45:00',10.28),('6449','2013-05-05','11:50:00',17.25),('6449','2013-05-05','11:55:00',17.65),('6449','2013-05-05','12:00:00',18.63),('6449','2013-05-05','12:05:00',17.43),('6449','2013-05-05','12:10:00',18.21),('6449','2013-05-05','12:15:00',17.72),('6449','2013-05-05','12:20:00',16.59),('6449','2013-05-05','12:25:00',16.55),('6449','2013-05-05','12:30:00',16.65),('6449','2013-05-05','12:35:00',16.79),('6449','2013-05-05','12:40:00',16.75),('6449','2013-05-05','12:45:00',17.76),('6449','2013-05-05','12:50:00',17.65),('6449','2013-05-05','12:55:00',17.22),('6449','2013-05-05','13:00:00',17.38),('6449','2013-05-05','13:05:00',17.34),('6449','2013-05-05','13:10:00',17.24),('6449','2013-05-05','13:15:00',17.48),('6449','2013-05-05','13:20:00',17.35),('6449','2013-05-05','13:25:00',15.37),('6449','2013-05-05','13:30:00',9.36),('6449','2013-05-05','13:35:00',9.62),('6449','2013-05-05','13:40:00',8.17),('6449','2013-05-05','13:45:00',7.77),('6449','2013-05-05','13:50:00',8.18),('6449','2013-05-05','13:55:00',6.95),('6449','2013-05-05','14:00:00',13.06),('6449','2013-05-05','14:05:00',16.58),('6449','2013-05-05','14:10:00',15.74),('6449','2013-05-05','14:15:00',15.57),('6449','2013-05-05','14:20:00',15.44),('6449','2013-05-05','14:25:00',15.19),('6449','2013-05-05','14:30:00',15.1),('6449','2013-05-05','14:35:00',14.87),('6449','2013-05-05','14:40:00',14.45),('6449','2013-05-05','14:45:00',14.47),('6449','2013-05-05','14:50:00',14.35),('6449','2013-05-05','14:55:00',14.41),('6449','2013-05-05','15:00:00',14.16),('6449','2013-05-05','15:05:00',11.99),('6449','2013-05-05','15:10:00',14.25),('6449','2013-05-05','15:15:00',13.93),('6449','2013-05-05','15:20:00',13.67),('6449','2013-05-05','15:25:00',13.4),('6449','2013-05-05','15:30:00',13.19),('6449','2013-05-05','15:35:00',12.99),('6449','2013-05-05','15:40:00',12.78),('6449','2013-05-05','15:45:00',12.57),('6449','2013-05-05','15:50:00',12.31),('6449','2013-05-05','15:55:00',12.02),('6449','2013-05-05','16:00:00',11.77),('6449','2013-05-05','16:05:00',11.37),('6449','2013-05-05','16:10:00',10.89),('6449','2013-05-05','16:15:00',10.78),('6449','2013-05-05','16:20:00',10.48),('6449','2013-05-05','16:25:00',10.19),('6449','2013-05-05','16:30:00',10.08),('6449','2013-05-05','16:35:00',9.81),('6449','2013-05-05','16:40:00',9.51),('6449','2013-05-05','16:45:00',9.24),('6449','2013-05-05','16:50:00',8.93),('6449','2013-05-05','16:55:00',8.56),('6449','2013-05-05','17:00:00',8.22),('6449','2013-05-05','17:05:00',7.86),('6449','2013-05-05','17:10:00',7.58),('6449','2013-05-05','17:15:00',7.26),('6449','2013-05-05','17:20:00',6.88),('6449','2013-05-05','17:25:00',6.45),('6449','2013-05-05','17:30:00',6.12),('6449','2013-05-05','17:35:00',5.73),('6449','2013-05-05','17:40:00',5.41),('6449','2013-05-05','17:45:00',5.05),('6449','2013-05-05','17:50:00',4.71),('6449','2013-05-05','17:55:00',4.38),('6449','2013-05-05','18:00:00',4.07),('6449','2013-05-05','18:05:00',3.75),('6449','2013-05-05','18:10:00',3.42),('6449','2013-05-05','18:15:00',3.18),('6449','2013-05-05','18:20:00',2.88),('6449','2013-05-05','18:25:00',2.56),('6449','2013-05-05','18:30:00',2.27),('6449','2013-05-05','18:35:00',2.02),('6449','2013-05-05','18:40:00',1.76),('6449','2013-05-05','18:45:00',1.56),('6449','2013-05-05','18:50:00',1.37),('6449','2013-05-05','18:55:00',1.18),('6449','2013-05-05','19:00:00',1.03),('6449','2013-05-04','06:55:00',1.05),('6449','2013-05-04','07:00:00',1.41),('6449','2013-05-04','07:05:00',1.69),('6449','2013-05-04','07:10:00',1.89),('6449','2013-05-04','07:15:00',2.12),('6449','2013-05-04','07:20:00',2.36),('6449','2013-05-04','07:25:00',2.63),('6449','2013-05-04','07:30:00',2.92),('6449','2013-05-04','07:35:00',3.46),('6449','2013-05-04','07:40:00',4.16),('6449','2013-05-04','07:45:00',4.18),('6449','2013-05-04','07:50:00',3.82),('6449','2013-05-04','07:55:00',4.37),('6449','2013-05-04','08:00:00',2.72),('6449','2013-05-04','08:05:00',5.17),('6449','2013-05-04','08:10:00',5.84),('6449','2013-05-04','08:15:00',6.66),('6449','2013-05-04','08:20:00',5.28),('6449','2013-05-04','08:25:00',3.57),('6449','2013-05-04','08:30:00',7.07),('6449','2013-05-04','08:35:00',7.35),('6449','2013-05-04','08:40:00',5.8),('6449','2013-05-04','08:45:00',6.51),('6449','2013-05-04','08:50:00',9.74),('6449','2013-05-04','08:55:00',10.7),('6449','2013-05-04','09:00:00',8.04),('6449','2013-05-04','09:05:00',9.06),('6449','2013-05-04','09:10:00',10.22),('6449','2013-05-04','09:15:00',9.39),('6449','2013-05-04','09:20:00',10.02),('6449','2013-05-04','09:25:00',9.82),('6449','2013-05-04','09:30:00',10.36),('6449','2013-05-04','09:35:00',11.14),('6449','2013-05-04','09:40:00',11.02),('6449','2013-05-04','09:45:00',11.51),('6449','2013-05-04','09:50:00',11.72),('6449','2013-05-04','09:55:00',11.93),('6449','2013-05-04','10:00:00',12.14),('6449','2013-05-04','10:05:00',12.37),('6449','2013-05-04','10:10:00',12.26),('6449','2013-05-04','10:15:00',12.63),('6449','2013-05-04','10:20:00',12.9),('6449','2013-05-04','10:25:00',12.94),('6449','2013-05-04','10:30:00',13.11),('6449','2013-05-04','10:35:00',13.13),('6449','2013-05-04','10:40:00',13.23),('6449','2013-05-04','10:45:00',13.49),('6449','2013-05-04','10:50:00',13.59),('6449','2013-05-04','10:55:00',13.78),('6449','2013-05-04','11:00:00',14),('6449','2013-05-04','11:05:00',14.06),('6449','2013-05-04','11:10:00',13.58),('6449','2013-05-04','11:15:00',13.25),('6449','2013-05-04','11:20:00',12.85),('6449','2013-05-04','11:25:00',14.12),('6449','2013-05-04','11:30:00',14.39),('6449','2013-05-04','11:35:00',14.19),('6449','2013-05-04','11:40:00',14.06),('6449','2013-05-04','11:45:00',14.19),('6449','2013-05-04','11:50:00',14.17),('6449','2013-05-04','11:55:00',13.91),('6449','2013-05-04','12:00:00',13.44),('6449','2013-05-04','12:05:00',14.11),('6449','2013-05-04','12:10:00',14.27),('6449','2013-05-04','12:15:00',14.48),('6449','2013-05-04','12:20:00',14.42),('6449','2013-05-04','12:25:00',14.19),('6449','2013-05-04','12:30:00',13.89),('6449','2013-05-04','12:35:00',13.87),('6449','2013-05-04','12:40:00',13.55),('6449','2013-05-04','12:45:00',13.44),('6449','2013-05-04','12:50:00',13.21),('6449','2013-05-04','12:55:00',14.36),('6449','2013-05-04','13:00:00',15.21),('6449','2013-05-04','13:05:00',15.13),('6449','2013-05-04','13:10:00',15.19),('6449','2013-05-04','13:15:00',14.58),('6449','2013-05-04','13:20:00',15.06),('6449','2013-05-04','13:25:00',15.17),('6449','2013-05-04','13:30:00',14.56),('6449','2013-05-04','13:35:00',14.98),('6449','2013-05-04','13:40:00',14.62),('6449','2013-05-04','13:45:00',14.45),('6449','2013-05-04','13:50:00',14.38),('6449','2013-05-04','13:55:00',13.96),('6449','2013-05-04','14:00:00',13.56),('6449','2013-05-04','14:05:00',13.81),('6449','2013-05-04','14:10:00',14.76),('6449','2013-05-04','14:15:00',14.14),('6449','2013-05-04','14:20:00',13.69),('6449','2013-05-04','14:25:00',13.56),('6449','2013-05-04','14:30:00',13.78),('6449','2013-05-04','14:35:00',13.99),('6449','2013-05-04','14:40:00',13.78),('6449','2013-05-04','14:45:00',12.21),('6449','2013-05-04','14:50:00',12.53),('6449','2013-05-04','14:55:00',12.89),('6449','2013-05-04','15:00:00',12.7),('6449','2013-05-04','15:05:00',13.36),('6449','2013-05-04','15:10:00',13.21),('6449','2013-05-04','15:15:00',11.8),('6449','2013-05-04','15:20:00',11.52),('6449','2013-05-04','15:25:00',12.83),('6449','2013-05-04','15:30:00',12.05),('6449','2013-05-04','15:35:00',12.77),('6449','2013-05-04','15:40:00',12.46),('6449','2013-05-04','15:45:00',12.11),('6449','2013-05-04','15:50:00',11.93),('6449','2013-05-04','15:55:00',11.71),('6449','2013-05-04','16:00:00',11.48),('6449','2013-05-04','16:05:00',11.27),('6449','2013-05-04','16:10:00',11),('6449','2013-05-04','16:15:00',10.72),('6449','2013-05-04','16:20:00',10.41),('6449','2013-05-04','16:25:00',10.15),('6449','2013-05-04','16:30:00',9.9),('6449','2013-05-04','16:35:00',9.52),('6449','2013-05-04','16:40:00',9.23),('6449','2013-05-04','16:45:00',8.82),('6449','2013-05-04','16:50:00',8.59),('6449','2013-05-04','16:55:00',8.28),('6449','2013-05-04','17:00:00',7.94),('6449','2013-05-04','17:05:00',7.62),('6449','2013-05-04','17:10:00',7.4),('6449','2013-05-04','17:15:00',7),('6449','2013-05-04','17:20:00',6.91),('6449','2013-05-04','17:25:00',6.45),('6449','2013-05-04','17:30:00',5.94),('6449','2013-05-04','17:35:00',5.65),('6449','2013-05-04','17:40:00',5.22),('6449','2013-05-04','17:45:00',4.79),('6449','2013-05-04','17:50:00',4.37),('6449','2013-05-04','17:55:00',4.2),('6449','2013-05-04','18:00:00',3.36),('6449','2013-05-04','18:05:00',1.7),('6449','2013-05-04','18:10:00',2.08),('6449','2013-05-04','18:15:00',2.6),('6449','2013-05-04','18:20:00',2.56),('6449','2013-05-04','18:25:00',2.19),('6449','2013-05-04','18:30:00',2.15),('6449','2013-05-04','18:35:00',2.01),('6449','2013-05-04','18:40:00',1.68),('6449','2013-05-04','18:45:00',1.43),('6449','2013-05-04','18:50:00',1.31),('6449','2013-05-04','18:55:00',1.23),('6449','2013-05-04','19:00:00',1.11),('6449','2013-05-04','19:05:00',1.05),('6449','2013-05-03','06:45:00',1.02),('6449','2013-05-03','06:50:00',1.16),('6449','2013-05-03','06:55:00',1.11),('6449','2013-05-03','07:00:00',1.11),('6449','2013-05-03','07:05:00',1.56),('6449','2013-05-03','07:10:00',1.96),('6449','2013-05-03','07:15:00',2.3),('6449','2013-05-03','07:20:00',2.53),('6449','2013-05-03','07:25:00',2.73),('6449','2013-05-03','07:30:00',2.7),('6449','2013-05-03','07:35:00',2.06),('6449','2013-05-03','07:40:00',1.92),('6449','2013-05-03','07:45:00',1.96),('6449','2013-05-03','07:50:00',2.91),('6449','2013-05-03','07:55:00',4.12),('6449','2013-05-03','08:00:00',4.45),('6449','2013-05-03','08:05:00',4.81),('6449','2013-05-03','08:10:00',5.19),('6449','2013-05-03','08:15:00',5.58),('6449','2013-05-03','08:20:00',6.01),('6449','2013-05-03','08:25:00',6.65),('6449','2013-05-03','08:30:00',7.13),('6449','2013-05-03','08:35:00',7.66),('6449','2013-05-03','08:40:00',7.96),('6449','2013-05-03','08:45:00',8.14),('6449','2013-05-03','08:50:00',8.58),('6449','2013-05-03','08:55:00',8.74),('6449','2013-05-03','09:00:00',9.12),('6449','2013-05-03','09:05:00',9.36),('6449','2013-05-03','09:10:00',9.95),('6449','2013-05-03','09:15:00',10.23),('6449','2013-05-03','09:20:00',10.35),('6449','2013-05-03','09:25:00',10.73),('6449','2013-05-03','09:30:00',11.06),('6449','2013-05-03','09:35:00',11.25),('6449','2013-05-03','09:40:00',11.52),('6449','2013-05-03','09:45:00',11.78),('6449','2013-05-03','09:50:00',11.97),('6449','2013-05-03','09:55:00',12.29),('6449','2013-05-03','10:00:00',12.42),('6449','2013-05-03','10:05:00',12.57),('6449','2013-05-03','10:10:00',12.72),('6449','2013-05-03','10:15:00',12.81),('6449','2013-05-03','10:20:00',12.95),('6449','2013-05-03','10:25:00',13.27),('6449','2013-05-03','10:30:00',13.33),('6449','2013-05-03','10:35:00',13.26),('6449','2013-05-03','10:40:00',13.65),('6449','2013-05-03','10:45:00',13.87),('6449','2013-05-03','10:50:00',13.85),('6449','2013-05-03','10:55:00',14.21),('6449','2013-05-03','11:00:00',14.33),('6449','2013-05-03','11:05:00',14.4),('6449','2013-05-03','11:10:00',14.71),('6449','2013-05-03','11:15:00',14.81),('6449','2013-05-03','11:20:00',14.93),('6449','2013-05-03','11:25:00',14.9),('6449','2013-05-03','11:30:00',14.97),('6449','2013-05-03','11:35:00',15.19),('6449','2013-05-03','11:40:00',15.22),('6449','2013-05-03','11:45:00',15.32),('6449','2013-05-03','11:50:00',15.51),('6449','2013-05-03','11:55:00',15.71),('6449','2013-05-03','12:00:00',15.72),('6449','2013-05-03','12:05:00',15.72),('6449','2013-05-03','12:10:00',15.77),('6449','2013-05-03','12:15:00',15.61),('6449','2013-05-03','12:20:00',15.6),('6449','2013-05-03','12:25:00',15.73),('6449','2013-05-03','12:30:00',15.54),('6449','2013-05-03','12:35:00',15.24),('6449','2013-05-03','12:40:00',15.18),('6449','2013-05-03','12:45:00',15.48),('6449','2013-05-03','12:50:00',15.45),('6449','2013-05-03','12:55:00',15.78),('6449','2013-05-03','13:00:00',15.7),('6449','2013-05-03','13:05:00',15.39),('6449','2013-05-03','13:10:00',14.88),('6449','2013-05-03','13:15:00',15.52),('6449','2013-05-03','13:20:00',16.01),('6449','2013-05-03','13:25:00',15.84),('6449','2013-05-03','13:30:00',15.99),('6449','2013-05-03','13:35:00',16.09),('6449','2013-05-03','13:40:00',16.15),('6449','2013-05-03','13:45:00',16.02),('6449','2013-05-03','13:50:00',15.66),('6449','2013-05-03','13:55:00',15.74),('6449','2013-05-03','14:00:00',15.69),('6449','2013-05-03','14:05:00',15.71),('6449','2013-05-03','14:10:00',15.82),('6449','2013-05-03','14:15:00',15.69),('6449','2013-05-03','14:20:00',15.5),('6449','2013-05-03','14:25:00',15.44),('6449','2013-05-03','14:30:00',15.3),('6449','2013-05-03','14:35:00',14.71),('6449','2013-05-03','14:40:00',15.05),('6449','2013-05-03','14:45:00',15.02),('6449','2013-05-03','14:50:00',14.73),('6449','2013-05-03','14:55:00',14.41),('6449','2013-05-03','15:00:00',14.25),('6449','2013-05-03','15:05:00',14.15),('6449','2013-05-03','15:10:00',13.95),('6449','2013-05-03','15:15:00',13.65),('6449','2013-05-03','15:20:00',13.42),('6449','2013-05-03','15:25:00',12.93),('6449','2013-05-03','15:30:00',13.09),('6449','2013-05-03','15:35:00',12.88),('6449','2013-05-03','15:40:00',12.42),('6449','2013-05-03','15:45:00',12.46),('6449','2013-05-03','15:50:00',11.94),('6449','2013-05-03','15:55:00',11.88),('6449','2013-05-03','16:00:00',11.54),('6449','2013-05-03','16:05:00',11.2),('6449','2013-05-03','16:10:00',10.87),('6449','2013-05-03','16:15:00',10.75),('6449','2013-05-03','16:20:00',10.36),('6449','2013-05-03','16:25:00',10.23),('6449','2013-05-03','16:30:00',9.94),('6449','2013-05-03','16:35:00',9.58),('6449','2013-05-03','16:40:00',9.25),('6449','2013-05-03','16:45:00',8.95),('6449','2013-05-03','16:50:00',8.73),('6449','2013-05-03','16:55:00',7.64),('6449','2013-05-03','17:00:00',7.61),('6449','2013-05-03','17:05:00',7.66),('6449','2013-05-03','17:10:00',7.29),('6449','2013-05-03','17:15:00',7.01),('6449','2013-05-03','17:20:00',6.59),('6449','2013-05-03','17:25:00',6.28),('6449','2013-05-03','17:30:00',5.89),('6449','2013-05-03','17:35:00',5.57),('6449','2013-05-03','17:40:00',5.21),('6449','2013-05-03','17:45:00',4.86),('6449','2013-05-03','17:50:00',4.6),('6449','2013-05-03','17:55:00',4.23),('6449','2013-05-03','18:00:00',3.88),('6449','2013-05-03','18:05:00',3.55),('6449','2013-05-03','18:10:00',3.25),('6449','2013-05-03','18:15:00',2.96),('6449','2013-05-03','18:20:00',2.68),('6449','2013-05-03','18:25:00',2.39),('6449','2013-05-03','18:30:00',2.15),('6449','2013-05-03','18:35:00',1.9),('6449','2013-05-03','18:40:00',1.67),('6449','2013-05-03','18:45:00',1.47),('6449','2013-05-03','18:50:00',1.29),('6449','2013-05-03','18:55:00',1.11),('6449','2013-05-02','07:35:00',1.23),('6449','2013-05-02','07:40:00',1.18),('6449','2013-05-02','07:45:00',1.02),('6449','2013-05-02','08:25:00',1.27),('6449','2013-05-02','08:30:00',1.74),('6449','2013-05-02','08:35:00',1.12),('6449','2013-05-02','08:45:00',1.24),('6449','2013-05-02','08:50:00',1.6),('6449','2013-05-02','08:55:00',1.37),('6449','2013-05-02','09:00:00',1.43),('6449','2013-05-02','09:05:00',2.43),('6449','2013-05-02','09:10:00',3.93),('6449','2013-05-02','09:15:00',5.53),('6449','2013-05-02','09:20:00',2.61),('6449','2013-05-02','09:25:00',1.58),('6449','2013-05-02','09:30:00',1.16),('6449','2013-05-02','09:35:00',1.19),('6449','2013-05-02','09:40:00',1.62),('6449','2013-05-02','09:45:00',2.61),('6449','2013-05-02','09:50:00',6.48),('6449','2013-05-02','09:55:00',8.85),('6449','2013-05-02','10:00:00',12.04),('6449','2013-05-02','10:05:00',5.82),('6449','2013-05-02','10:10:00',13.64),('6449','2013-05-02','10:15:00',6.78),('6449','2013-05-02','10:20:00',7.04),('6449','2013-05-02','10:25:00',8.73),('6449','2013-05-02','10:30:00',12.83),('6449','2013-05-02','10:35:00',10.03),('6449','2013-05-02','10:40:00',8.38),('6449','2013-05-02','10:45:00',9.5),('6449','2013-05-02','10:50:00',11.34),('6449','2013-05-02','10:55:00',9.57),('6449','2013-05-02','11:00:00',6.84),('6449','2013-05-02','11:05:00',7.17),('6449','2013-05-02','11:10:00',7.76),('6449','2013-05-02','11:15:00',14.78),('6449','2013-05-02','11:20:00',10.49),('6449','2013-05-02','11:25:00',8.57),('6449','2013-05-02','11:30:00',8.71),('6449','2013-05-02','11:35:00',9.46),('6449','2013-05-02','11:40:00',8.61),('6449','2013-05-02','11:45:00',9.55),('6449','2013-05-02','11:50:00',9.65),('6449','2013-05-02','11:55:00',9.03),('6449','2013-05-02','12:00:00',8.56),('6449','2013-05-02','12:05:00',8.75),('6449','2013-05-02','12:10:00',11.65),('6449','2013-05-02','12:15:00',16.97),('6449','2013-05-02','12:20:00',15.35),('6449','2013-05-02','12:25:00',12),('6449','2013-05-02','12:30:00',12.56),('6449','2013-05-02','12:35:00',10.79),('6449','2013-05-02','12:40:00',11.22),('6449','2013-05-02','12:45:00',11.87),('6449','2013-05-02','12:50:00',14.3),('6449','2013-05-02','12:55:00',16.45),('6449','2013-05-02','13:00:00',15.34),('6449','2013-05-02','13:05:00',15.54),('6449','2013-05-02','13:10:00',15.93),('6449','2013-05-02','13:15:00',15.83),('6449','2013-05-02','13:20:00',15.79),('6449','2013-05-02','13:25:00',15.97),('6449','2013-05-02','13:30:00',15.95),('6449','2013-05-02','13:35:00',16.01),('6449','2013-05-02','13:40:00',16.04),('6449','2013-05-02','13:45:00',15.94),('6449','2013-05-02','13:50:00',15.92),('6449','2013-05-02','13:55:00',15.86),('6449','2013-05-02','14:00:00',15.72),('6449','2013-05-02','14:05:00',15.71),('6449','2013-05-02','14:10:00',15.54),('6449','2013-05-02','14:15:00',15.38),('6449','2013-05-02','14:20:00',15.1),('6449','2013-05-02','14:25:00',15.19),('6449','2013-05-02','14:30:00',14.9),('6449','2013-05-02','14:35:00',15.06),('6449','2013-05-02','14:40:00',14.95),('6449','2013-05-02','14:45:00',14.77),('6449','2013-05-02','14:50:00',14.66),('6449','2013-05-02','14:55:00',14.46),('6449','2013-05-02','15:00:00',14.25),('6449','2013-05-02','15:05:00',14.05),('6449','2013-05-02','15:10:00',14.01),('6449','2013-05-02','15:15:00',13.8),('6449','2013-05-02','15:20:00',13.67),('6449','2013-05-02','15:25:00',13.49),('6449','2013-05-02','15:30:00',13.25),('6449','2013-05-02','15:35:00',12.92),('6449','2013-05-02','15:40:00',12.65),('6449','2013-05-02','15:45:00',12.47),('6449','2013-05-02','15:50:00',12.23),('6449','2013-05-02','15:55:00',11.99),('6449','2013-05-02','16:00:00',11.61),('6449','2013-05-02','16:05:00',11.22),('6449','2013-05-02','16:10:00',11.09),('6449','2013-05-02','16:15:00',10.7),('6449','2013-05-02','16:20:00',10.59),('6449','2013-05-02','16:25:00',10.28),('6449','2013-05-02','16:30:00',9.97),('6449','2013-05-02','16:35:00',9.69),('6449','2013-05-02','16:40:00',9.46),('6449','2013-05-02','16:45:00',9.07),('6449','2013-05-02','16:50:00',8.7),('6449','2013-05-02','16:55:00',8.44),('6449','2013-05-02','17:00:00',8.13),('6449','2013-05-02','17:05:00',7.82),('6449','2013-05-02','17:10:00',7.43),('6449','2013-05-02','17:15:00',7.08),('6449','2013-05-02','17:20:00',6.7),('6449','2013-05-02','17:25:00',6.39),('6449','2013-05-02','17:30:00',5.99),('6449','2013-05-02','17:35:00',5.68),('6449','2013-05-02','17:40:00',5.36),('6449','2013-05-02','17:45:00',4.98),('6449','2013-05-02','17:50:00',4.62),('6449','2013-05-02','17:55:00',4.33),('6449','2013-05-02','18:00:00',3.95),('6449','2013-05-02','18:05:00',3.64),('6449','2013-05-02','18:10:00',3.35),('6449','2013-05-02','18:15:00',3.02),('6449','2013-05-02','18:20:00',2.73),('6449','2013-05-02','18:25:00',2.45),('6449','2013-05-02','18:30:00',2.18),('6449','2013-05-02','18:35:00',1.93),('6449','2013-05-02','18:40:00',1.69),('6449','2013-05-02','18:45:00',1.48),('6449','2013-05-02','18:50:00',1.28),('6449','2013-05-02','18:55:00',1.09),('6449','2013-05-01','07:00:00',1.09),('6449','2013-05-01','07:05:00',1.22),('6449','2013-05-01','07:10:00',1.44),('6449','2013-05-01','07:15:00',1.65),('6449','2013-05-01','07:20:00',1.91),('6449','2013-05-01','07:25:00',2.18),('6449','2013-05-01','07:30:00',2.44),('6449','2013-05-01','07:35:00',2.68),('6449','2013-05-01','07:40:00',3.01),('6449','2013-05-01','07:45:00',3.27),('6449','2013-05-01','07:50:00',3.47),('6449','2013-05-01','07:55:00',3.81),('6449','2013-05-01','08:00:00',4.18),('6449','2013-05-01','08:05:00',4.54),('6449','2013-05-01','08:10:00',4.91),('6449','2013-05-01','08:15:00',5.33),('6449','2013-05-01','08:20:00',5.61),('6449','2013-05-01','08:25:00',6.02),('6449','2013-05-01','08:30:00',6.34),('6449','2013-05-01','08:35:00',6.7),('6449','2013-05-01','08:40:00',7.04),('6449','2013-05-01','08:45:00',7.44),('6449','2013-05-01','08:50:00',7.73),('6449','2013-05-01','08:55:00',7.98),('6449','2013-05-01','09:00:00',8.07),('6449','2013-05-01','09:05:00',8.33),('6449','2013-05-01','09:10:00',8.74),('6449','2013-05-01','09:15:00',8.99),('6449','2013-05-01','09:20:00',9.12),('6449','2013-05-01','09:25:00',9.43),('6449','2013-05-01','09:30:00',9.73),('6449','2013-05-01','09:35:00',9.87),('6449','2013-05-01','09:40:00',10.15),('6449','2013-05-01','09:45:00',10.49),('6449','2013-05-01','09:50:00',10.76),('6449','2013-05-01','09:55:00',11.25),('6449','2013-05-01','10:00:00',11.49),('6449','2013-05-01','10:05:00',11.58),('6449','2013-05-01','10:10:00',11.98),('6449','2013-05-01','10:15:00',12.27),('6449','2013-05-01','10:20:00',12.53),('6449','2013-05-01','10:25:00',12.75),('6449','2013-05-01','10:30:00',12.79),('6449','2013-05-01','10:35:00',12.87),('6449','2013-05-01','10:40:00',13.12),('6449','2013-05-01','10:45:00',13.14),('6449','2013-05-01','10:50:00',13.27),('6449','2013-05-01','10:55:00',13.32),('6449','2013-05-01','11:00:00',13.43),('6449','2013-05-01','11:05:00',13.43),('6449','2013-05-01','11:10:00',13.58),('6449','2013-05-01','11:15:00',13.71),('6449','2013-05-01','11:20:00',13.88),('6449','2013-05-01','11:25:00',14.22),('6449','2013-05-01','11:30:00',14.35),('6449','2013-05-01','11:35:00',14.44),('6449','2013-05-01','11:40:00',14.52),('6449','2013-05-01','11:45:00',14.47),('6449','2013-05-01','11:50:00',14.23),('6449','2013-05-01','11:55:00',14.31),('6449','2013-05-01','12:00:00',14.32),('6449','2013-05-01','12:05:00',14.4),('6449','2013-05-01','12:10:00',15.21),('6449','2013-05-01','12:15:00',11.19),('6449','2013-05-01','12:20:00',10.48),('6449','2013-05-01','12:25:00',10.25),('6449','2013-05-01','12:30:00',8.27),('6449','2013-05-01','12:35:00',10.16),('6449','2013-05-01','12:40:00',8.44),('6449','2013-05-01','12:45:00',10.08),('6449','2013-05-01','12:50:00',11.57),('6449','2013-05-01','12:55:00',15.78),('6449','2013-05-01','13:00:00',14.34),('6449','2013-05-01','13:05:00',11.45),('6449','2013-05-01','13:10:00',13.19),('6449','2013-05-01','13:15:00',15.7),('6449','2013-05-01','13:20:00',15.19),('6449','2013-05-01','13:25:00',15.24),('6449','2013-05-01','13:30:00',15.19),('6449','2013-05-01','13:35:00',14.77),('6449','2013-05-01','13:40:00',15.13),('6449','2013-05-01','13:45:00',14.98),('6449','2013-05-01','13:50:00',14.66),('6449','2013-05-01','13:55:00',13.78),('6449','2013-05-01','14:00:00',15.62),('6449','2013-05-01','14:05:00',14.27),('6449','2013-05-01','14:10:00',10.01),('6449','2013-05-01','14:15:00',10.63),('6449','2013-05-01','14:20:00',11.68),('6449','2013-05-01','14:25:00',12.84),('6449','2013-05-01','14:30:00',14.98),('6449','2013-05-01','14:35:00',13.76),('6449','2013-05-01','14:40:00',11.49),('6449','2013-05-01','14:45:00',12.52),('6449','2013-05-01','14:50:00',8.55),('6449','2013-05-01','14:55:00',7.27),('6449','2013-05-01','15:00:00',9.83),('6449','2013-05-01','15:05:00',7.33),('6449','2013-05-01','15:10:00',8.69),('6449','2013-05-01','15:15:00',7.78),('6449','2013-05-01','15:20:00',7.08),('6449','2013-05-01','15:25:00',6.89),('6449','2013-05-01','15:30:00',6.87),('6449','2013-05-01','15:35:00',7.8),('6449','2013-05-01','15:40:00',8.5),('6449','2013-05-01','15:45:00',7.56),('6449','2013-05-01','15:50:00',6.84),('6449','2013-05-01','15:55:00',5.65),('6449','2013-05-01','16:00:00',6.17),('6449','2013-05-01','16:05:00',7.5),('6449','2013-05-01','16:10:00',8.19),('6449','2013-05-01','16:15:00',8.08),('6449','2013-05-01','16:20:00',5.92),('6449','2013-05-01','16:25:00',4.64),('6449','2013-05-01','16:30:00',4.25),('6449','2013-05-01','16:35:00',4.06),('6449','2013-05-01','16:40:00',3.52),('6449','2013-05-01','16:45:00',3.16),('6449','2013-05-01','16:50:00',3.17),('6449','2013-05-01','16:55:00',3.22),('6449','2013-05-01','17:00:00',2.95),('6449','2013-05-01','17:05:00',2.48),('6449','2013-05-01','17:10:00',1.98),('6449','2013-05-01','17:15:00',1.74),('6449','2013-05-01','17:20:00',1.61),('6449','2013-05-01','17:25:00',1.63),('6449','2013-05-01','17:30:00',1.53),('6449','2013-05-01','17:35:00',1.5),('6449','2013-05-01','17:40:00',1.45),('6449','2013-05-01','17:45:00',1.32),('6449','2013-05-01','17:50:00',1.29),('6449','2013-05-01','17:55:00',1.37),('6449','2013-05-01','18:00:00',1.3),('6449','2013-04-30','07:50:00',1.18),('6449','2013-04-30','07:55:00',1.78),('6449','2013-04-30','08:00:00',2.71),('6449','2013-04-30','08:05:00',3.57),('6449','2013-04-30','08:10:00',3.47),('6449','2013-04-30','08:15:00',4.33),('6449','2013-04-30','08:20:00',3.67),('6449','2013-04-30','08:25:00',2.88),('6449','2013-04-30','08:30:00',3.08),('6449','2013-04-30','08:35:00',2.98),('6449','2013-04-30','08:40:00',2.99),('6449','2013-04-30','08:45:00',3.27),('6449','2013-04-30','08:50:00',3.62),('6449','2013-04-30','08:55:00',4.87),('6449','2013-04-30','09:00:00',6.57),('6449','2013-04-30','09:05:00',7.93),('6449','2013-04-30','09:10:00',8.38),('6449','2013-04-30','09:15:00',7.22),('6449','2013-04-30','09:20:00',6.78),('6449','2013-04-30','09:25:00',5.09),('6449','2013-04-30','09:30:00',8.84),('6449','2013-04-30','09:35:00',8.18),('6449','2013-04-30','09:40:00',7.5),('6449','2013-04-30','09:45:00',6.56),('6449','2013-04-30','09:50:00',5.82),('6449','2013-04-30','09:55:00',4.96),('6449','2013-04-30','10:00:00',2.97),('6449','2013-04-30','10:05:00',2.29),('6449','2013-04-30','10:10:00',2.19),('6449','2013-04-30','10:15:00',2.21),('6449','2013-04-30','10:20:00',2.46),('6449','2013-04-30','10:25:00',2.7),('6449','2013-04-30','10:30:00',3.21),('6449','2013-04-30','10:35:00',5.14),('6449','2013-04-30','10:40:00',6.11),('6449','2013-04-30','10:45:00',5.47),('6449','2013-04-30','10:50:00',6.28),('6449','2013-04-30','10:55:00',7.23),('6449','2013-04-30','11:00:00',8.81),('6449','2013-04-30','11:05:00',9.71),('6449','2013-04-30','11:10:00',8),('6449','2013-04-30','11:15:00',7.52),('6449','2013-04-30','11:20:00',9.2),('6449','2013-04-30','11:25:00',11.87),('6449','2013-04-30','11:30:00',8.9),('6449','2013-04-30','11:35:00',8.22),('6449','2013-04-30','11:40:00',10.39),('6449','2013-04-30','11:45:00',14.34),('6449','2013-04-30','11:50:00',14.2),('6449','2013-04-30','11:55:00',8.85),('6449','2013-04-30','12:00:00',8.23),('6449','2013-04-30','12:05:00',8),('6449','2013-04-30','12:10:00',6.75),('6449','2013-04-30','12:15:00',6.61),('6449','2013-04-30','12:20:00',7.32),('6449','2013-04-30','12:25:00',9.89),('6449','2013-04-30','12:30:00',10.11),('6449','2013-04-30','12:35:00',10.78),('6449','2013-04-30','12:40:00',15.07),('6449','2013-04-30','12:45:00',13.32),('6449','2013-04-30','12:50:00',17.33),('6449','2013-04-30','12:55:00',16.48),('6449','2013-04-30','13:00:00',16.41),('6449','2013-04-30','13:05:00',15.95),('6449','2013-04-30','13:10:00',15.66),('6449','2013-04-30','13:15:00',15.47),('6449','2013-04-30','13:20:00',15.5),('6449','2013-04-30','13:25:00',15.48),('6449','2013-04-30','13:30:00',15.32),('6449','2013-04-30','13:35:00',15.23),('6449','2013-04-30','13:40:00',15.22),('6449','2013-04-30','13:45:00',15.15),('6449','2013-04-30','13:50:00',14.73),('6449','2013-04-30','13:55:00',15.02),('6449','2013-04-30','14:00:00',15.03),('6449','2013-04-30','14:05:00',14.77),('6449','2013-04-30','14:10:00',14.62),('6449','2013-04-30','14:15:00',14.43),('6449','2013-04-30','14:20:00',14.26),('6449','2013-04-30','14:25:00',14.2),('6449','2013-04-30','14:30:00',13.99),('6449','2013-04-30','14:35:00',13.83),('6449','2013-04-30','14:40:00',13.66),('6449','2013-04-30','14:45:00',13.44),('6449','2013-04-30','14:50:00',13.11),('6449','2013-04-30','14:55:00',12.98),('6449','2013-04-30','15:00:00',12.77),('6449','2013-04-30','15:05:00',12.59),('6449','2013-04-30','15:10:00',12.27),('6449','2013-04-30','15:15:00',11.96),('6449','2013-04-30','15:20:00',12.11),('6449','2013-04-30','15:25:00',11.99),('6449','2013-04-30','15:30:00',12.07),('6449','2013-04-30','15:35:00',11.97),('6449','2013-04-30','15:40:00',9.71),('6449','2013-04-30','15:45:00',7.64),('6449','2013-04-30','15:50:00',8.62),('6449','2013-04-30','15:55:00',10.02),('6449','2013-04-30','16:00:00',11.27),('6449','2013-04-30','16:05:00',10.88),('6449','2013-04-30','16:10:00',9.59),('6449','2013-04-30','16:15:00',7.55),('6449','2013-04-30','16:20:00',5.47),('6449','2013-04-30','16:25:00',6.35),('6449','2013-04-30','16:30:00',7.25),('6449','2013-04-30','16:35:00',6.11),('6449','2013-04-30','16:40:00',5.39),('6449','2013-04-30','16:45:00',5.3),('6449','2013-04-30','16:50:00',6.32),('6449','2013-04-30','16:55:00',6.63),('6449','2013-04-30','17:00:00',5.47),('6449','2013-04-30','17:05:00',4.69),('6449','2013-04-30','17:10:00',6.68),('6449','2013-04-30','17:15:00',5.83),('6449','2013-04-30','17:20:00',4.64),('6449','2013-04-30','17:25:00',5.49),('6449','2013-04-30','17:30:00',4.91),('6449','2013-04-30','17:35:00',4.76),('6449','2013-04-30','17:40:00',4.33),('6449','2013-04-30','17:45:00',4.1),('6449','2013-04-30','17:50:00',3.84),('6449','2013-04-30','17:55:00',3.44),('6449','2013-04-30','18:00:00',3.2),('6449','2013-04-30','18:05:00',2.74),('6449','2013-04-30','18:10:00',2.17),('6449','2013-04-30','18:15:00',2.05),('6449','2013-04-30','18:20:00',2.26),('6449','2013-04-30','18:25:00',2.12),('6449','2013-04-30','18:30:00',2),('6449','2013-04-30','18:35:00',1.8),('6449','2013-04-30','18:40:00',1.54),('6449','2013-04-30','18:45:00',1.32),('6449','2013-04-30','18:50:00',1.1),('6449','2013-04-29','07:05:00',1.28),('6449','2013-04-29','07:10:00',1.66),('6449','2013-04-29','07:15:00',1.96),('6449','2013-04-29','07:20:00',2.07),('6449','2013-04-29','07:25:00',2.05),('6449','2013-04-29','07:30:00',2),('6449','2013-04-29','07:35:00',2.34),('6449','2013-04-29','07:40:00',2.87),('6449','2013-04-29','07:45:00',3.34),('6449','2013-04-29','07:50:00',3.76),('6449','2013-04-29','07:55:00',3.82),('6449','2013-04-29','08:00:00',4.26),('6449','2013-04-29','08:05:00',4.46),('6449','2013-04-29','08:10:00',4.04),('6449','2013-04-29','08:15:00',4.05),('6449','2013-04-29','08:20:00',4.69),('6449','2013-04-29','08:25:00',4.79),('6449','2013-04-29','08:30:00',5.47),('6449','2013-04-29','08:35:00',5.76),('6449','2013-04-29','08:40:00',5.63),('6449','2013-04-29','08:45:00',7.09),('6449','2013-04-29','08:50:00',7.55),('6449','2013-04-29','08:55:00',7.79),('6449','2013-04-29','09:00:00',8.21),('6449','2013-04-29','09:05:00',8.78),('6449','2013-04-29','09:10:00',8.89),('6449','2013-04-29','09:15:00',8.49),('6449','2013-04-29','09:20:00',8.8),('6449','2013-04-29','09:25:00',8.69),('6449','2013-04-29','09:30:00',8.91),('6449','2013-04-29','09:35:00',10.18),('6449','2013-04-29','09:40:00',9.85),('6449','2013-04-29','09:45:00',10.44),('6449','2013-04-29','09:50:00',10.6),('6449','2013-04-29','09:55:00',11.32),('6449','2013-04-29','10:00:00',10.81),('6449','2013-04-29','10:05:00',10.64),('6449','2013-04-29','10:10:00',10.63),('6449','2013-04-29','10:15:00',11.3),('6449','2013-04-29','10:20:00',10.72),('6449','2013-04-29','10:25:00',11.83),('6449','2013-04-29','10:30:00',11.34),('6449','2013-04-29','10:35:00',11.21),('6449','2013-04-29','10:40:00',12.51),('6449','2013-04-29','10:45:00',13.24),('6449','2013-04-29','10:50:00',13.02),('6449','2013-04-29','10:55:00',13.11),('6449','2013-04-29','11:00:00',13.3),('6449','2013-04-29','11:05:00',13.94),('6449','2013-04-29','11:10:00',13.56),('6449','2013-04-29','11:15:00',14.25),('6449','2013-04-29','11:20:00',14.55),('6449','2013-04-29','11:25:00',14.72),('6449','2013-04-29','11:30:00',14.54),('6449','2013-04-29','11:35:00',14.22),('6449','2013-04-29','11:40:00',13.87),('6449','2013-04-29','11:45:00',14.32),('6449','2013-04-29','11:50:00',14.62),('6449','2013-04-29','11:55:00',14.47),('6449','2013-04-29','12:00:00',15.02),('6449','2013-04-29','12:05:00',14.91),('6449','2013-04-29','12:10:00',14.92),('6449','2013-04-29','12:15:00',15.01),('6449','2013-04-29','12:20:00',15.2),('6449','2013-04-29','12:25:00',15.74),('6449','2013-04-29','12:30:00',15.41),('6449','2013-04-29','12:35:00',14.9),('6449','2013-04-29','12:40:00',14.91),('6449','2013-04-29','12:45:00',15.13),('6449','2013-04-29','12:50:00',14.93),('6449','2013-04-29','12:55:00',15.31),('6449','2013-04-29','13:00:00',15.39),('6449','2013-04-29','13:05:00',14.79),('6449','2013-04-29','13:10:00',14.22),('6449','2013-04-29','13:15:00',14.19),('6449','2013-04-29','13:20:00',14.41),('6449','2013-04-29','13:25:00',13.84),('6449','2013-04-29','13:30:00',14),('6449','2013-04-29','13:35:00',13.96),('6449','2013-04-29','13:40:00',13.33),('6449','2013-04-29','13:45:00',13.09),('6449','2013-04-29','13:50:00',12.46),('6449','2013-04-29','13:55:00',12.69),('6449','2013-04-29','14:00:00',12.28),('6449','2013-04-29','14:05:00',12.28),('6449','2013-04-29','14:10:00',12.18),('6449','2013-04-29','14:15:00',12.09),('6449','2013-04-29','14:20:00',12.18),('6449','2013-04-29','14:25:00',12.12),('6449','2013-04-29','14:30:00',11.9),('6449','2013-04-29','14:35:00',12.25),('6449','2013-04-29','14:40:00',12.49),('6449','2013-04-29','14:45:00',12.36),('6449','2013-04-29','14:50:00',11.33),('6449','2013-04-29','14:55:00',11.45),('6449','2013-04-29','15:00:00',12.28),('6449','2013-04-29','15:05:00',12),('6449','2013-04-29','15:10:00',10.18),('6449','2013-04-29','15:15:00',10.76),('6449','2013-04-29','15:20:00',10.2),('6449','2013-04-29','15:25:00',10.14),('6449','2013-04-29','15:30:00',10.07),('6449','2013-04-29','15:35:00',10.83),('6449','2013-04-29','15:40:00',11.39),('6449','2013-04-29','15:45:00',11.2),('6449','2013-04-29','15:50:00',10.34),('6449','2013-04-29','15:55:00',10.3),('6449','2013-04-29','16:00:00',10.01),('6449','2013-04-29','16:05:00',10.37),('6449','2013-04-29','16:10:00',10.31),('6449','2013-04-29','16:15:00',10.6),('6449','2013-04-29','16:20:00',11.05),('6449','2013-04-29','16:25:00',9.96),('6449','2013-04-29','16:30:00',10.76),('6449','2013-04-29','16:35:00',10),('6449','2013-04-29','16:40:00',8.96),('6449','2013-04-29','16:45:00',9.16),('6449','2013-04-29','16:50:00',9.37),('6449','2013-04-29','16:55:00',6.88),('6449','2013-04-29','17:00:00',6.13),('6449','2013-04-29','17:05:00',5.43),('6449','2013-04-29','17:10:00',7.68),('6449','2013-04-29','17:15:00',7.44),('6449','2013-04-29','17:20:00',7.19),('6449','2013-04-29','17:25:00',7.12),('6449','2013-04-29','17:30:00',6.45),('6449','2013-04-29','17:35:00',6.12),('6449','2013-04-29','17:40:00',5.87),('6449','2013-04-29','17:45:00',5.47),('6449','2013-04-29','17:50:00',5.47),('6449','2013-04-29','17:55:00',4.77),('6449','2013-04-29','18:00:00',4.64),('6449','2013-04-29','18:05:00',4.16),('6449','2013-04-29','18:10:00',3.45),('6449','2013-04-29','18:15:00',3.16),('6449','2013-04-29','18:20:00',2.76),('6449','2013-04-29','18:25:00',2.4),('6449','2013-04-29','18:30:00',2.14),('6449','2013-04-29','18:35:00',1.69),('6449','2013-04-29','18:40:00',1.26),('6449','2013-04-29','18:45:00',1),('6449','2013-04-28','07:00:00',1.07),('6449','2013-04-28','07:05:00',1.26),('6449','2013-04-28','07:10:00',1.54),('6449','2013-04-28','07:15:00',1.83),('6449','2013-04-28','07:20:00',2.15),('6449','2013-04-28','07:25:00',2.47),('6449','2013-04-28','07:30:00',2.78),('6449','2013-04-28','07:35:00',3.03),('6449','2013-04-28','07:40:00',3.44),('6449','2013-04-28','07:45:00',3.79),('6449','2013-04-28','07:50:00',4.11),('6449','2013-04-28','07:55:00',4.51),('6449','2013-04-28','08:00:00',4.93),('6449','2013-04-28','08:05:00',5.45),('6449','2013-04-28','08:10:00',5.99),('6449','2013-04-28','08:15:00',6.27),('6449','2013-04-28','08:20:00',4.91),('6449','2013-04-28','08:25:00',6.41),('6449','2013-04-28','08:30:00',7.22),('6449','2013-04-28','08:35:00',7.25),('6449','2013-04-28','08:40:00',7.84),('6449','2013-04-28','08:45:00',8.21),('6449','2013-04-28','08:50:00',8.46),('6449','2013-04-28','08:55:00',8.92),('6449','2013-04-28','09:00:00',9.29),('6449','2013-04-28','09:05:00',9.58),('6449','2013-04-28','09:10:00',9.87),('6449','2013-04-28','09:15:00',10.27),('6449','2013-04-28','09:20:00',10.42),('6449','2013-04-28','09:25:00',10.83),('6449','2013-04-28','09:30:00',11.18),('6449','2013-04-28','09:35:00',11.43),('6449','2013-04-28','09:40:00',11.67),('6449','2013-04-28','09:45:00',11.89),('6449','2013-04-28','09:50:00',12.26),('6449','2013-04-28','09:55:00',12.55),('6449','2013-04-28','10:00:00',12.77),('6449','2013-04-28','10:05:00',13.05),('6449','2013-04-28','10:10:00',13.27),('6449','2013-04-28','10:15:00',13.48),('6449','2013-04-28','10:20:00',13.48),('6449','2013-04-28','10:25:00',13.71),('6449','2013-04-28','10:30:00',13.48),('6449','2013-04-28','10:35:00',13.77),('6449','2013-04-28','10:40:00',14.14),('6449','2013-04-28','10:45:00',13.92),('6449','2013-04-28','10:50:00',14.6),('6449','2013-04-28','10:55:00',14.41),('6449','2013-04-28','11:00:00',14.89),('6449','2013-04-28','11:05:00',14.67),('6449','2013-04-28','11:10:00',14.65),('6449','2013-04-28','11:15:00',14.09),('6449','2013-04-28','11:20:00',13.72),('6449','2013-04-28','11:25:00',15.15),('6449','2013-04-28','11:30:00',14.91),('6449','2013-04-28','11:35:00',15.24),('6449','2013-04-28','11:40:00',15.51),('6449','2013-04-28','11:45:00',14.31),('6449','2013-04-28','11:50:00',13.6),('6449','2013-04-28','11:55:00',14.12),('6449','2013-04-28','12:00:00',14.85),('6449','2013-04-28','12:05:00',14.42),('6449','2013-04-28','12:10:00',14.54),('6449','2013-04-28','12:15:00',14.37),('6449','2013-04-28','12:20:00',14.36),('6449','2013-04-28','12:25:00',16.06),('6449','2013-04-28','12:30:00',14.69),('6449','2013-04-28','12:35:00',12.96),('6449','2013-04-28','12:40:00',15.2),('6449','2013-04-28','12:45:00',15.11),('6449','2013-04-28','12:50:00',16.14),('6449','2013-04-28','12:55:00',14.84),('6449','2013-04-28','13:00:00',14.44),('6449','2013-04-28','13:05:00',14.79),('6449','2013-04-28','13:10:00',15.2),('6449','2013-04-28','13:15:00',15.96),('6449','2013-04-28','13:20:00',15.97),('6449','2013-04-28','13:25:00',13.92),('6449','2013-04-28','13:30:00',13.51),('6449','2013-04-28','13:35:00',14.69),('6449','2013-04-28','13:40:00',15.56),('6449','2013-04-28','13:45:00',15.73),('6449','2013-04-28','13:50:00',15.53),('6449','2013-04-28','13:55:00',15.18),('6449','2013-04-28','14:00:00',15.09),('6449','2013-04-28','14:05:00',15.01),('6449','2013-04-28','14:10:00',13.91),('6449','2013-04-28','14:15:00',14.83),('6449','2013-04-28','14:20:00',14.6),('6449','2013-04-28','14:25:00',14.54),('6449','2013-04-28','14:30:00',14.44),('6449','2013-04-28','14:35:00',14.26),('6449','2013-04-28','14:40:00',13.9),('6449','2013-04-28','14:45:00',13.88),('6449','2013-04-28','14:50:00',13.73),('6449','2013-04-28','14:55:00',13.65),('6449','2013-04-28','15:00:00',13.55),('6449','2013-04-28','15:05:00',13.39),('6449','2013-04-28','15:10:00',13.21),('6449','2013-04-28','15:15:00',13.08),('6449','2013-04-28','15:20:00',12.89),('6449','2013-04-28','15:25:00',12.74),('6449','2013-04-28','15:30:00',12.54),('6449','2013-04-28','15:35:00',12.3),('6449','2013-04-28','15:40:00',12.07),('6449','2013-04-28','15:45:00',11.82),('6449','2013-04-28','15:50:00',11.55),('6449','2013-04-28','15:55:00',11.03),('6449','2013-04-28','16:00:00',10.94),('6449','2013-04-28','16:05:00',10.72),('6449','2013-04-28','16:10:00',10.51),('6449','2013-04-28','16:15:00',10.23),('6449','2013-04-28','16:20:00',9.93),('6449','2013-04-28','16:25:00',9.5),('6449','2013-04-28','16:30:00',9.35),('6449','2013-04-28','16:35:00',9.1),('6449','2013-04-28','16:40:00',8.93),('6449','2013-04-28','16:45:00',8.66),('6449','2013-04-28','16:50:00',8.42),('6449','2013-04-28','16:55:00',7.98),('6449','2013-04-28','17:00:00',7.17),('6449','2013-04-28','17:05:00',7.13),('6449','2013-04-28','17:10:00',6.99),('6449','2013-04-28','17:15:00',6.98),('6449','2013-04-28','17:20:00',6.33),('6449','2013-04-28','17:25:00',5.99),('6449','2013-04-28','17:30:00',5.58),('6449','2013-04-28','17:35:00',4.68),('6449','2013-04-28','17:40:00',5.07),('6449','2013-04-28','17:45:00',4.65),('6449','2013-04-28','17:50:00',4.49),('6449','2013-04-28','17:55:00',3.85),('6449','2013-04-28','18:00:00',3.05),('6449','2013-04-28','18:05:00',2.88),('6449','2013-04-28','18:10:00',3.26),('6449','2013-04-28','18:15:00',2.79),('6449','2013-04-28','18:20:00',2.33),('6449','2013-04-28','18:25:00',1.84),('6449','2013-04-28','18:30:00',1.73),('6449','2013-04-28','18:35:00',1.56),('6449','2013-04-28','18:40:00',1.53),('6449','2013-04-28','18:45:00',1.72),('6449','2013-04-28','18:50:00',1.65),('6449','2013-04-28','18:55:00',1.46),('6449','2013-04-28','19:00:00',1.22),('6449','2013-04-28','19:05:00',1.05),('6449','2013-04-27','07:20:00',1.05),('6449','2013-04-27','07:25:00',1.5),('6449','2013-04-27','07:30:00',1.84),('6449','2013-04-27','07:35:00',1.95),('6449','2013-04-27','07:40:00',1.97),('6449','2013-04-27','07:45:00',1.83),('6449','2013-04-27','07:50:00',1.47),('6449','2013-04-27','09:15:00',1.37),('6449','2013-04-27','09:20:00',1.44),('6449','2013-04-27','09:25:00',1.26),('6449','2013-04-27','09:30:00',1.26),('6449','2013-04-27','09:35:00',1.17),('6449','2013-04-27','09:40:00',1.13),('6449','2013-04-27','10:30:00',1.15),('6449','2013-04-27','10:35:00',1.15),('6449','2013-04-27','10:40:00',1.07),('6449','2013-04-27','10:45:00',1.11),('6449','2013-04-27','11:25:00',1.04),('6449','2013-04-27','11:35:00',1.29),('6449','2013-04-27','11:40:00',1.48),('6449','2013-04-27','11:45:00',1.72),('6449','2013-04-27','11:50:00',1.43),('6449','2013-04-27','11:55:00',1.55),('6449','2013-04-27','12:00:00',1.94),('6449','2013-04-27','12:05:00',2.35),('6449','2013-04-27','12:10:00',2.88),('6449','2013-04-27','12:15:00',2.37),('6449','2013-04-27','12:20:00',2.51),('6449','2013-04-27','12:25:00',2.62),('6449','2013-04-27','12:30:00',4.09),('6449','2013-04-27','12:35:00',4.49),('6449','2013-04-27','12:40:00',6.14),('6449','2013-04-27','12:45:00',5.71),('6449','2013-04-27','12:50:00',3.73),('6449','2013-04-27','12:55:00',2.66),('6449','2013-04-27','13:00:00',3.19),('6449','2013-04-27','13:05:00',2.63),('6449','2013-04-27','13:10:00',2.65),('6449','2013-04-27','13:15:00',4.3),('6449','2013-04-27','13:20:00',6.08),('6449','2013-04-27','13:25:00',5.71),('6449','2013-04-27','13:30:00',3.55),('6449','2013-04-27','13:35:00',5.37),('6449','2013-04-27','13:40:00',4.7),('6449','2013-04-27','13:45:00',3.5),('6449','2013-04-27','13:50:00',2.72),('6449','2013-04-27','13:55:00',2.93),('6449','2013-04-27','14:00:00',5.45),('6449','2013-04-27','14:05:00',11.9),('6449','2013-04-27','14:10:00',6.51),('6449','2013-04-27','14:15:00',6.28),('6449','2013-04-27','14:20:00',6.59),('6449','2013-04-27','14:25:00',5.61),('6449','2013-04-27','14:30:00',3.84),('6449','2013-04-27','14:35:00',3.8),('6449','2013-04-27','14:40:00',3.94),('6449','2013-04-27','14:45:00',3.39),('6449','2013-04-27','14:50:00',2.58),('6449','2013-04-27','14:55:00',1.55),('6449','2013-04-27','15:25:00',2.03),('6449','2013-04-27','15:30:00',3.1),('6449','2013-04-27','15:35:00',3.49),('6449','2013-04-27','15:40:00',2.58),('6449','2013-04-27','16:00:00',1.07),('6449','2013-04-27','16:05:00',1.92),('6449','2013-04-27','16:10:00',1.53),('6449','2013-04-27','16:15:00',2.78),('6449','2013-04-27','16:20:00',7.14),('6449','2013-04-27','16:25:00',5.48),('6449','2013-04-27','16:30:00',4.67),('6449','2013-04-27','16:35:00',8.62),('6449','2013-04-27','16:40:00',5.42),('6449','2013-04-27','16:45:00',4.21),('6449','2013-04-27','16:50:00',3.76),('6449','2013-04-27','16:55:00',2.57),('6449','2013-04-27','17:00:00',2.26),('6449','2013-04-27','17:05:00',3.13),('6449','2013-04-27','17:10:00',2.17),('6449','2013-04-27','17:15:00',1.63),('6449','2013-04-27','17:20:00',1.4),('6449','2013-04-27','17:25:00',2.71),('6449','2013-04-27','17:30:00',2.87),('6449','2013-04-27','17:35:00',1.44),('6449','2013-04-27','17:40:00',1.27),('6449','2013-04-27','17:45:00',1.46),('6449','2013-04-27','17:50:00',1.29),('6449','2013-04-27','17:55:00',1.72),('6449','2013-04-27','18:00:00',2.61),('6449','2013-04-27','18:05:00',1.83),('6449','2013-04-27','18:10:00',1.26),('6449','2013-04-27','18:15:00',1.19),('6449','2013-04-27','18:20:00',1.5),('6449','2013-04-27','18:25:00',1.22),('6449','2013-04-27','18:30:00',1.26),('6449','2013-04-26','06:55:00',1.04),('6449','2013-04-26','07:00:00',1.17),('6449','2013-04-26','07:05:00',1.22),('6449','2013-04-26','07:10:00',1.21),('6449','2013-04-26','07:15:00',1.19),('6449','2013-04-26','07:20:00',1.14),('6449','2013-04-26','07:25:00',1.23),('6449','2013-04-26','07:30:00',1.45),('6449','2013-04-26','07:35:00',1.61),('6449','2013-04-26','07:40:00',1.84),('6449','2013-04-26','07:45:00',2.38),('6449','2013-04-26','07:50:00',2.67),('6449','2013-04-26','07:55:00',3.45),('6449','2013-04-26','08:00:00',3.93),('6449','2013-04-26','08:05:00',4.3),('6449','2013-04-26','08:10:00',4.71),('6449','2013-04-26','08:15:00',4.95),('6449','2013-04-26','08:20:00',5.19),('6449','2013-04-26','08:25:00',5.69),('6449','2013-04-26','08:30:00',4.97),('6449','2013-04-26','08:35:00',5.32),('6449','2013-04-26','08:40:00',5.67),('6449','2013-04-26','08:45:00',4.07),('6449','2013-04-26','08:50:00',3.42),('6449','2013-04-26','08:55:00',3.5),('6449','2013-04-26','09:00:00',4.69),('6449','2013-04-26','09:05:00',6.8),('6449','2013-04-26','09:10:00',7.89),('6449','2013-04-26','09:15:00',9.15),('6449','2013-04-26','09:20:00',9.54),('6449','2013-04-26','09:25:00',9.77),('6449','2013-04-26','09:30:00',10.2),('6449','2013-04-26','09:35:00',10.71),('6449','2013-04-26','09:40:00',11.35),('6449','2013-04-26','09:45:00',12.44),('6449','2013-04-26','09:50:00',12.5),('6449','2013-04-26','09:55:00',9.6),('6449','2013-04-26','10:00:00',8.16),('6449','2013-04-26','10:05:00',8.06),('6449','2013-04-26','10:10:00',9.53),('6449','2013-04-26','10:15:00',10.07),('6449','2013-04-26','10:20:00',9.24),('6449','2013-04-26','10:25:00',10.76),('6449','2013-04-26','10:30:00',9.76),('6449','2013-04-26','10:35:00',8.58),('6449','2013-04-26','10:40:00',8.71),('6449','2013-04-26','10:45:00',10.14),('6449','2013-04-26','10:50:00',9.97),('6449','2013-04-26','10:55:00',10.48),('6449','2013-04-26','11:00:00',9.19),('6449','2013-04-26','11:05:00',9.2),('6449','2013-04-26','11:10:00',8.8),('6449','2013-04-26','11:15:00',8.16),('6449','2013-04-26','11:20:00',7.53),('6449','2013-04-26','11:25:00',7.08),('6449','2013-04-26','11:30:00',7.27),('6449','2013-04-26','11:35:00',8.3),('6449','2013-04-26','11:40:00',10.38),('6449','2013-04-26','11:45:00',11.28),('6449','2013-04-26','11:50:00',6.76),('6449','2013-04-26','11:55:00',5.66),('6449','2013-04-26','12:00:00',7.39),('6449','2013-04-26','12:05:00',13.54),('6449','2013-04-26','12:10:00',11.07),('6449','2013-04-26','12:15:00',14.4),('6449','2013-04-26','12:20:00',15.43),('6449','2013-04-26','12:25:00',13.52),('6449','2013-04-26','12:30:00',15.79),('6449','2013-04-26','12:35:00',13.47),('6449','2013-04-26','12:40:00',9.46),('6449','2013-04-26','12:45:00',8.39),('6449','2013-04-26','12:50:00',7.34),('6449','2013-04-26','12:55:00',8.08),('6449','2013-04-26','13:00:00',7.56),('6449','2013-04-26','13:05:00',8.8),('6449','2013-04-26','13:10:00',6.52),('6449','2013-04-26','13:15:00',7.04),('6449','2013-04-26','13:20:00',8.29),('6449','2013-04-26','13:25:00',7.89),('6449','2013-04-26','13:30:00',10.27),('6449','2013-04-26','13:35:00',16.61),('6449','2013-04-26','13:40:00',8.93),('6449','2013-04-26','13:45:00',13.13),('6449','2013-04-26','13:50:00',11.75),('6449','2013-04-26','13:55:00',10.21),('6449','2013-04-26','14:00:00',9.54),('6449','2013-04-26','14:05:00',11.36),('6449','2013-04-26','14:10:00',14.76),('6449','2013-04-26','14:15:00',8.08),('6449','2013-04-26','14:20:00',6.33),('6449','2013-04-26','14:25:00',6.33),('6449','2013-04-26','14:30:00',4.67),('6449','2013-04-26','14:35:00',5.09),('6449','2013-04-26','14:40:00',5.97),('6449','2013-04-26','14:45:00',6.62),('6449','2013-04-26','14:50:00',8.89),('6449','2013-04-26','14:55:00',5.09),('6449','2013-04-26','15:00:00',3.84),('6449','2013-04-26','15:05:00',4.1),('6449','2013-04-26','15:10:00',2.59),('6449','2013-04-26','15:15:00',1.55),('6449','2013-04-26','15:20:00',1.45),('6449','2013-04-26','15:25:00',1.59),('6449','2013-04-26','15:30:00',1.69),('6449','2013-04-26','15:35:00',1.55),('6449','2013-04-26','15:40:00',1.22),('6449','2013-04-26','15:45:00',1.48),('6449','2013-04-26','15:50:00',1.73),('6449','2013-04-26','15:55:00',1.5),('6449','2013-04-26','16:00:00',1.08),('6449','2013-04-25','07:15:00',1.12),('6449','2013-04-25','07:20:00',1.29),('6449','2013-04-25','07:25:00',1.48),('6449','2013-04-25','07:30:00',1.75),('6449','2013-04-25','07:35:00',1.96),('6449','2013-04-25','07:40:00',2.41),('6449','2013-04-25','07:45:00',2.84),('6449','2013-04-25','07:50:00',2.66),('6449','2013-04-25','07:55:00',2.98),('6449','2013-04-25','08:00:00',2.99),('6449','2013-04-25','08:05:00',2.87),('6449','2013-04-25','08:10:00',3.14),('6449','2013-04-25','08:15:00',3.11),('6449','2013-04-25','08:20:00',3.9),('6449','2013-04-25','08:25:00',5.16),('6449','2013-04-25','08:30:00',3.71),('6449','2013-04-25','08:35:00',3.64),('6449','2013-04-25','08:40:00',4.09),('6449','2013-04-25','08:45:00',5.9),('6449','2013-04-25','08:50:00',8.57),('6449','2013-04-25','08:55:00',5.72),('6449','2013-04-25','09:00:00',6.12),('6449','2013-04-25','09:05:00',5.32),('6449','2013-04-25','09:10:00',4.78),('6449','2013-04-25','09:15:00',6.91),('6449','2013-04-25','09:20:00',9.42),('6449','2013-04-25','09:25:00',9.46),('6449','2013-04-25','09:30:00',9.76),('6449','2013-04-25','09:35:00',10.71),('6449','2013-04-25','09:40:00',11.1),('6449','2013-04-25','09:45:00',11.71),('6449','2013-04-25','09:50:00',9.49),('6449','2013-04-25','09:55:00',10.03),('6449','2013-04-25','10:00:00',13.3),('6449','2013-04-25','10:05:00',10.89),('6449','2013-04-25','10:10:00',9.7),('6449','2013-04-25','10:15:00',8.99),('6449','2013-04-25','10:20:00',11.88),('6449','2013-04-25','10:25:00',12.48),('6449','2013-04-25','10:30:00',12.97),('6449','2013-04-25','10:35:00',13.7),('6449','2013-04-25','10:40:00',13.92),('6449','2013-04-25','10:45:00',14.04),('6449','2013-04-25','10:50:00',14.86),('6449','2013-04-25','10:55:00',11.48),('6449','2013-04-25','11:00:00',10.07),('6449','2013-04-25','11:05:00',14.05),('6449','2013-04-25','11:10:00',12.29),('6449','2013-04-25','11:15:00',14.2),('6449','2013-04-25','11:20:00',12.43),('6449','2013-04-25','11:25:00',11.62),('6449','2013-04-25','11:30:00',13.05),('6449','2013-04-25','11:35:00',13.57),('6449','2013-04-25','11:40:00',13.4),('6449','2013-04-25','11:45:00',16.21),('6449','2013-04-25','11:50:00',16.64),('6449','2013-04-25','11:55:00',16.65),('6449','2013-04-25','12:00:00',16.45),('6449','2013-04-25','12:05:00',16.58),('6449','2013-04-25','12:10:00',17.11),('6449','2013-04-25','12:15:00',17.07),('6449','2013-04-25','12:20:00',16.93),('6449','2013-04-25','12:25:00',16.55),('6449','2013-04-25','12:30:00',13.95),('6449','2013-04-25','12:35:00',11.5),('6449','2013-04-25','12:40:00',11.75),('6449','2013-04-25','12:45:00',11.95),('6449','2013-04-25','12:50:00',11.13),('6449','2013-04-25','12:55:00',11.06),('6449','2013-04-25','13:00:00',13.01),('6449','2013-04-25','13:05:00',11.02),('6449','2013-04-25','13:10:00',11.34),('6449','2013-04-25','13:15:00',11.83),('6449','2013-04-25','13:20:00',7.54),('6449','2013-04-25','13:25:00',6.42),('6449','2013-04-25','13:30:00',6.14),('6449','2013-04-25','13:35:00',5.93),('6449','2013-04-25','13:40:00',5.97),('6449','2013-04-25','13:45:00',6.06),('6449','2013-04-25','13:50:00',6.69),('6449','2013-04-25','13:55:00',6.94),('6449','2013-04-25','14:00:00',7.23),('6449','2013-04-25','14:05:00',9.75),('6449','2013-04-25','14:10:00',14.26),('6449','2013-04-25','14:15:00',14.54),('6449','2013-04-25','14:20:00',11.29),('6449','2013-04-25','14:25:00',14.14),('6449','2013-04-25','14:30:00',14.69),('6449','2013-04-25','14:35:00',14.91),('6449','2013-04-25','14:40:00',11.32),('6449','2013-04-25','14:45:00',12.42),('6449','2013-04-25','14:50:00',10.72),('6449','2013-04-25','14:55:00',11.25),('6449','2013-04-25','15:00:00',14.71),('6449','2013-04-25','15:05:00',13.35),('6449','2013-04-25','15:10:00',11.89),('6449','2013-04-25','15:15:00',11.03),('6449','2013-04-25','15:20:00',11.66),('6449','2013-04-25','15:25:00',10.04),('6449','2013-04-25','15:30:00',11.55),('6449','2013-04-25','15:35:00',10.29),('6449','2013-04-25','15:40:00',8.74),('6449','2013-04-25','15:45:00',8.34),('6449','2013-04-25','15:50:00',9.1),('6449','2013-04-25','15:55:00',9.51),('6449','2013-04-25','16:00:00',7.51),('6449','2013-04-25','16:05:00',7.22),('6449','2013-04-25','16:10:00',7.37),('6449','2013-04-25','16:15:00',7.87),('6449','2013-04-25','16:20:00',7.19),('6449','2013-04-25','16:25:00',6.45),('6449','2013-04-25','16:30:00',5.91),('6449','2013-04-25','16:35:00',6.37),('6449','2013-04-25','16:40:00',5.01),('6449','2013-04-25','16:45:00',4.63),('6449','2013-04-25','16:50:00',4.56),('6449','2013-04-25','16:55:00',4.35),('6449','2013-04-25','17:00:00',4.11),('6449','2013-04-25','17:05:00',3.86),('6449','2013-04-25','17:10:00',3.63),('6449','2013-04-25','17:15:00',3.57),('6449','2013-04-25','17:20:00',3.47),('6449','2013-04-25','17:25:00',3.6),('6449','2013-04-25','17:30:00',3.58),('6449','2013-04-25','17:35:00',3.56),('6449','2013-04-25','17:40:00',3.66),('6449','2013-04-25','17:45:00',3.72),('6449','2013-04-25','17:50:00',3.22),('6449','2013-04-25','17:55:00',2.81),('6449','2013-04-25','18:00:00',2.45),('6449','2013-04-25','18:05:00',2.21),('6449','2013-04-25','18:10:00',1.97),('6449','2013-04-25','18:15:00',1.81),('6449','2013-04-25','18:20:00',1.72),('6449','2013-04-25','18:25:00',1.69),('6449','2013-04-25','18:30:00',1.56),('6449','2013-04-25','18:35:00',1.44),('6449','2013-04-25','18:40:00',1.38),('6449','2013-04-25','18:45:00',1.29),('6449','2013-04-25','18:50:00',1.17),('6449','2013-04-25','18:55:00',1.05),('6449','2013-04-24','07:15:00',1.22),('6449','2013-04-24','07:20:00',1.36),('6449','2013-04-24','07:25:00',1.43),('6449','2013-04-24','07:30:00',1.64),('6449','2013-04-24','07:35:00',1.87),('6449','2013-04-24','07:40:00',2.18),('6449','2013-04-24','07:45:00',2.27),('6449','2013-04-24','07:50:00',2.96),('6449','2013-04-24','07:55:00',2.9),('6449','2013-04-24','08:00:00',3.36),('6449','2013-04-24','08:05:00',4.26),('6449','2013-04-24','08:10:00',5.19),('6449','2013-04-24','08:15:00',5.54),('6449','2013-04-24','08:20:00',5.66),('6449','2013-04-24','08:25:00',5.91),('6449','2013-04-24','08:30:00',6.35),('6449','2013-04-24','08:35:00',6.99),('6449','2013-04-24','08:40:00',7.37),('6449','2013-04-24','08:45:00',8.05),('6449','2013-04-24','08:50:00',8.56),('6449','2013-04-24','08:55:00',8.86),('6449','2013-04-24','09:00:00',5.91),('6449','2013-04-24','09:05:00',6.16),('6449','2013-04-24','09:10:00',7.5),('6449','2013-04-24','09:15:00',6.74),('6449','2013-04-24','09:20:00',7.52),('6449','2013-04-24','09:25:00',7.81),('6449','2013-04-24','09:30:00',6.78),('6449','2013-04-24','09:35:00',7.68),('6449','2013-04-24','09:40:00',7.69),('6449','2013-04-24','09:45:00',7.74),('6449','2013-04-24','09:50:00',9.88),('6449','2013-04-24','09:55:00',10.65),('6449','2013-04-24','10:00:00',10.67),('6449','2013-04-24','10:05:00',11.76),('6449','2013-04-24','10:10:00',13.98),('6449','2013-04-24','10:15:00',13.27),('6449','2013-04-24','10:20:00',12.82),('6449','2013-04-24','10:25:00',13.76),('6449','2013-04-24','10:30:00',12.71),('6449','2013-04-24','10:35:00',13.27),('6449','2013-04-24','10:40:00',13.93),('6449','2013-04-24','10:45:00',14.25),('6449','2013-04-24','10:50:00',13.9),('6449','2013-04-24','10:55:00',14.01),('6449','2013-04-24','11:00:00',14.87),('6449','2013-04-24','11:05:00',11.44),('6449','2013-04-24','11:10:00',10.35),('6449','2013-04-24','11:15:00',15.27),('6449','2013-04-24','11:20:00',16.07),('6449','2013-04-24','11:25:00',17.34),('6449','2013-04-24','11:30:00',17.97),('6449','2013-04-24','11:35:00',17.69),('6449','2013-04-24','11:40:00',13.31),('6449','2013-04-24','11:45:00',11.06),('6449','2013-04-24','11:50:00',11.45),('6449','2013-04-24','11:55:00',14.48),('6449','2013-04-24','12:00:00',14.02),('6449','2013-04-24','12:05:00',14.77),('6449','2013-04-24','12:10:00',17.51),('6449','2013-04-24','12:15:00',14.2),('6449','2013-04-24','12:20:00',14.55),('6449','2013-04-24','12:25:00',15.76),('6449','2013-04-24','12:30:00',15.85),('6449','2013-04-24','12:35:00',14.6),('6449','2013-04-24','12:40:00',15.07),('6449','2013-04-24','12:45:00',16.99),('6449','2013-04-24','12:50:00',17.01),('6449','2013-04-24','12:55:00',16.98),('6449','2013-04-24','13:00:00',14.62),('6449','2013-04-24','13:05:00',17.36),('6449','2013-04-24','13:10:00',15.86),('6449','2013-04-24','13:15:00',17.56),('6449','2013-04-24','13:20:00',16.84),('6449','2013-04-24','13:25:00',18.18),('6449','2013-04-24','13:30:00',17.74),('6449','2013-04-24','13:35:00',15.88),('6449','2013-04-24','13:40:00',13.2),('6449','2013-04-24','13:45:00',10.27),('6449','2013-04-24','13:50:00',8.97),('6449','2013-04-24','13:55:00',11.74),('6449','2013-04-24','14:00:00',12.46),('6449','2013-04-24','14:05:00',12.86),('6449','2013-04-24','14:10:00',14.91),('6449','2013-04-24','14:15:00',15.94),('6449','2013-04-24','14:20:00',15.52),('6449','2013-04-24','14:25:00',15.01),('6449','2013-04-24','14:30:00',14.42),('6449','2013-04-24','14:35:00',14.56),('6449','2013-04-24','14:40:00',13.62),('6449','2013-04-24','14:45:00',12.3),('6449','2013-04-24','14:50:00',10.68),('6449','2013-04-24','14:55:00',10.74),('6449','2013-04-24','15:00:00',8.34),('6449','2013-04-24','15:05:00',8.67),('6449','2013-04-24','15:10:00',8.52),('6449','2013-04-24','15:15:00',9.1),('6449','2013-04-24','15:20:00',10.33),('6449','2013-04-24','15:25:00',9.86),('6449','2013-04-24','15:30:00',9.96),('6449','2013-04-24','15:35:00',10.68),('6449','2013-04-24','15:40:00',9.51),('6449','2013-04-24','15:45:00',5.47),('6449','2013-04-24','15:50:00',7.18),('6449','2013-04-24','15:55:00',8.56),('6449','2013-04-24','16:00:00',9.55),('6449','2013-04-24','16:05:00',8.44),('6449','2013-04-24','16:10:00',8.48),('6449','2013-04-24','16:15:00',8.07),('6449','2013-04-24','16:20:00',7.2),('6449','2013-04-24','16:25:00',7.37),('6449','2013-04-24','16:30:00',8.07),('6449','2013-04-24','16:35:00',8.65),('6449','2013-04-24','16:40:00',7.65),('6449','2013-04-24','16:45:00',8.88),('6449','2013-04-24','16:50:00',8.01),('6449','2013-04-24','16:55:00',8.61),('6449','2013-04-24','17:00:00',8.29),('6449','2013-04-24','17:05:00',8.04),('6449','2013-04-24','17:10:00',7.05),('6449','2013-04-24','17:15:00',5.47),('6449','2013-04-24','17:20:00',6.23),('6449','2013-04-24','17:25:00',6.09),('6449','2013-04-24','17:30:00',6.08),('6449','2013-04-24','17:35:00',5.81),('6449','2013-04-24','17:40:00',5.59),('6449','2013-04-24','17:45:00',4.4),('6449','2013-04-24','17:50:00',3.13),('6449','2013-04-24','17:55:00',3.64),('6449','2013-04-24','18:00:00',3.21),('6449','2013-04-24','18:05:00',3.51),('6449','2013-04-24','18:10:00',3.57),('6449','2013-04-24','18:15:00',3.56),('6449','2013-04-24','18:20:00',3.11),('6449','2013-04-24','18:25:00',2.81),('6449','2013-04-24','18:30:00',2.4),('6449','2013-04-24','18:35:00',2.07),('6449','2013-04-24','18:40:00',1.88),('6449','2013-04-24','18:45:00',1.59),('6449','2013-04-24','18:50:00',1.33),('6449','2013-04-24','18:55:00',1.02),('6449','2013-04-23','07:05:00',1.07),('6449','2013-04-23','07:10:00',1.3),('6449','2013-04-23','07:15:00',1.56),('6449','2013-04-23','07:20:00',1.87),('6449','2013-04-23','07:25:00',2.22),('6449','2013-04-23','07:30:00',2.58),('6449','2013-04-23','07:35:00',2.94),('6449','2013-04-23','07:40:00',3.33),('6449','2013-04-23','07:45:00',3.71),('6449','2013-04-23','07:50:00',4.13),('6449','2013-04-23','07:55:00',4.57),('6449','2013-04-23','08:00:00',4.95),('6449','2013-04-23','08:05:00',5.34),('6449','2013-04-23','08:10:00',5.78),('6449','2013-04-23','08:15:00',6.16),('6449','2013-04-23','08:20:00',6.58),('6449','2013-04-23','08:25:00',6.99),('6449','2013-04-23','08:30:00',7.33),('6449','2013-04-23','08:35:00',7.78),('6449','2013-04-23','08:40:00',8.18),('6449','2013-04-23','08:45:00',8.46),('6449','2013-04-23','08:50:00',8.93),('6449','2013-04-23','08:55:00',9.28),('6449','2013-04-23','09:00:00',9.58),('6449','2013-04-23','09:05:00',10.01),('6449','2013-04-23','09:10:00',10.36),('6449','2013-04-23','09:15:00',10.69),('6449','2013-04-23','09:20:00',10.94),('6449','2013-04-23','09:25:00',11.28),('6449','2013-04-23','09:30:00',11.67),('6449','2013-04-23','09:35:00',11.94),('6449','2013-04-23','09:40:00',12.19),('6449','2013-04-23','09:45:00',12.51),('6449','2013-04-23','09:50:00',12.79),('6449','2013-04-23','09:55:00',13.1),('6449','2013-04-23','10:00:00',13.37),('6449','2013-04-23','10:05:00',13.56),('6449','2013-04-23','10:10:00',13.79),('6449','2013-04-23','10:15:00',13.88),('6449','2013-04-23','10:20:00',14.19),('6449','2013-04-23','10:25:00',14.41),('6449','2013-04-23','10:30:00',14.52),('6449','2013-04-23','10:35:00',14.97),('6449','2013-04-23','10:40:00',14.9),('6449','2013-04-23','10:45:00',15.35),('6449','2013-04-23','10:50:00',15.03),('6449','2013-04-23','10:55:00',15.52),('6449','2013-04-23','11:00:00',15.45),('6449','2013-04-23','11:05:00',15.78),('6449','2013-04-23','11:10:00',15.96),('6449','2013-04-23','11:15:00',15.27),('6449','2013-04-23','11:20:00',14.84),('6449','2013-04-23','11:25:00',15.37),('6449','2013-04-23','11:30:00',16.27),('6449','2013-04-23','11:35:00',16.38),('6449','2013-04-23','11:40:00',16.47),('6449','2013-04-23','11:45:00',16.58),('6449','2013-04-23','11:50:00',16.63),('6449','2013-04-23','11:55:00',16.57),('6449','2013-04-23','12:00:00',16.53),('6449','2013-04-23','12:05:00',16.53),('6449','2013-04-23','12:10:00',16.61),('6449','2013-04-23','12:15:00',16.42),('6449','2013-04-23','12:20:00',16.42),('6449','2013-04-23','12:25:00',16.43),('6449','2013-04-23','12:30:00',16.5),('6449','2013-04-23','12:35:00',16.43),('6449','2013-04-23','12:40:00',16.75),('6449','2013-04-23','12:45:00',16.75),('6449','2013-04-23','12:50:00',16.7),('6449','2013-04-23','12:55:00',16.44),('6449','2013-04-23','13:00:00',16.1),('6449','2013-04-23','13:05:00',16.32),('6449','2013-04-23','13:10:00',16.23),('6449','2013-04-23','13:15:00',15.15),('6449','2013-04-23','13:20:00',15.44),('6449','2013-04-23','13:25:00',14.83),('6449','2013-04-23','13:30:00',15.4),('6449','2013-04-23','13:35:00',14.16),('6449','2013-04-23','13:40:00',16.88),('6449','2013-04-23','13:45:00',16.09),('6449','2013-04-23','13:50:00',15.51),('6449','2013-04-23','13:55:00',14.93),('6449','2013-04-23','14:00:00',14.92),('6449','2013-04-23','14:05:00',15.6),('6449','2013-04-23','14:10:00',14.13),('6449','2013-04-23','14:15:00',15.6),('6449','2013-04-23','14:20:00',15.14),('6449','2013-04-23','14:25:00',16.47),('6449','2013-04-23','14:30:00',13.83),('6449','2013-04-23','14:35:00',13.62),('6449','2013-04-23','14:40:00',13.34),('6449','2013-04-23','14:45:00',14.3),('6449','2013-04-23','14:50:00',14.69),('6449','2013-04-23','14:55:00',15.7),('6449','2013-04-23','15:00:00',15.92),('6449','2013-04-23','15:05:00',12.27),('6449','2013-04-23','15:10:00',7.37),('6449','2013-04-23','15:15:00',8.7),('6449','2013-04-23','15:20:00',10.67),('6449','2013-04-23','15:25:00',9.85),('6449','2013-04-23','15:30:00',10.56),('6449','2013-04-23','15:35:00',10.88),('6449','2013-04-23','15:40:00',11.56),('6449','2013-04-23','15:45:00',12.22),('6449','2013-04-23','15:50:00',11),('6449','2013-04-23','15:55:00',10.32),('6449','2013-04-23','16:00:00',9.52),('6449','2013-04-23','16:05:00',10.04),('6449','2013-04-23','16:10:00',9.08),('6449','2013-04-23','16:15:00',8.54),('6449','2013-04-23','16:20:00',8.23),('6449','2013-04-23','16:25:00',8.26),('6449','2013-04-23','16:30:00',8.42),('6449','2013-04-23','16:35:00',8.96),('6449','2013-04-23','16:40:00',8.77),('6449','2013-04-23','16:45:00',8.05),('6449','2013-04-23','16:50:00',8.68),('6449','2013-04-23','16:55:00',7.64),('6449','2013-04-23','17:00:00',6.99),('6449','2013-04-23','17:05:00',8.12),('6449','2013-04-23','17:10:00',7.9),('6449','2013-04-23','17:15:00',7),('6449','2013-04-23','17:20:00',7),('6449','2013-04-23','17:25:00',6.82),('6449','2013-04-23','17:30:00',6.72),('6449','2013-04-23','17:35:00',6.7),('6449','2013-04-23','17:40:00',5.14),('6449','2013-04-23','17:45:00',4.08),('6449','2013-04-23','17:50:00',3.07),('6449','2013-04-23','17:55:00',3.01),('6449','2013-04-23','18:00:00',3.25),('6449','2013-04-23','18:05:00',3.16),('6449','2013-04-23','18:10:00',2.3),('6449','2013-04-23','18:15:00',2.42),('6449','2013-04-23','18:20:00',1.48),('6449','2013-04-23','18:25:00',1.5),('6449','2013-04-23','18:30:00',1.99),('6449','2013-04-23','18:35:00',2.04),('6449','2013-04-23','18:40:00',1.41),('6449','2013-04-23','18:45:00',1.09),('6449','2013-04-22','07:35:00',1.1),('6449','2013-04-22','07:40:00',1.44),('6449','2013-04-22','07:45:00',1.86),('6449','2013-04-22','07:50:00',1.55),('6449','2013-04-22','07:55:00',1.5),('6449','2013-04-22','08:00:00',1.23),('6449','2013-04-22','08:10:00',1.15),('6449','2013-04-22','08:15:00',1.38),('6449','2013-04-22','08:20:00',1.49),('6449','2013-04-22','08:25:00',1.68),('6449','2013-04-22','08:30:00',1.84),('6449','2013-04-22','08:35:00',1.74),('6449','2013-04-22','08:40:00',1.12),('6449','2013-04-22','09:20:00',1.03),('6449','2013-04-22','09:25:00',1.62),('6449','2013-04-22','09:30:00',1.71),('6449','2013-04-22','09:35:00',2.03),('6449','2013-04-22','09:40:00',1.59),('6449','2013-04-22','09:45:00',1.22),('6449','2013-04-22','09:50:00',1.22),('6449','2013-04-22','09:55:00',1.56),('6449','2013-04-22','10:00:00',1.7),('6449','2013-04-22','10:05:00',1.26),('6449','2013-04-22','10:10:00',1.05),('6449','2013-04-22','10:20:00',1.35),('6449','2013-04-22','10:25:00',1.48),('6449','2013-04-22','10:30:00',2.83),('6449','2013-04-22','10:35:00',4.01),('6449','2013-04-22','10:40:00',3.85),('6449','2013-04-22','10:45:00',4.37),('6449','2013-04-22','10:50:00',6.43),('6449','2013-04-22','10:55:00',6.4),('6449','2013-04-22','11:00:00',6.56),('6449','2013-04-22','11:05:00',18.54),('6449','2013-04-22','11:10:00',15.84),('6449','2013-04-22','11:15:00',17.07),('6449','2013-04-22','11:20:00',18.09),('6449','2013-04-22','11:25:00',17.55),('6449','2013-04-22','11:30:00',13.01),('6449','2013-04-22','11:35:00',14.04),('6449','2013-04-22','11:40:00',18.2),('6449','2013-04-22','11:45:00',13.01),('6449','2013-04-22','11:50:00',14.35),('6449','2013-04-22','11:55:00',15.36),('6449','2013-04-22','12:00:00',16.99),('6449','2013-04-22','12:05:00',16.21),('6449','2013-04-22','12:10:00',17.35),('6449','2013-04-22','12:15:00',14.77),('6449','2013-04-22','12:20:00',17.82),('6449','2013-04-22','12:25:00',17.76),('6449','2013-04-22','12:30:00',17.87),('6449','2013-04-22','12:35:00',17.09),('6449','2013-04-22','12:40:00',16.89),('6449','2013-04-22','12:45:00',17.72),('6449','2013-04-22','12:50:00',19.22),('6449','2013-04-22','12:55:00',19.66),('6449','2013-04-22','13:00:00',18.09),('6449','2013-04-22','13:05:00',13.63),('6449','2013-04-22','13:10:00',14.64),('6449','2013-04-22','13:15:00',10.82),('6449','2013-04-22','13:20:00',16.26),('6449','2013-04-22','13:25:00',6.31),('6449','2013-04-22','13:30:00',3.74),('6449','2013-04-22','13:35:00',4.01),('6449','2013-04-22','13:40:00',15.04),('6449','2013-04-22','13:45:00',10.05),('6449','2013-04-22','13:50:00',9.16),('6449','2013-04-22','13:55:00',12.69),('6449','2013-04-22','14:00:00',14.94),('6449','2013-04-22','14:05:00',3.2),('6449','2013-04-22','14:10:00',1.8),('6449','2013-04-22','14:15:00',2),('6449','2013-04-22','14:20:00',2.13),('6449','2013-04-22','14:25:00',1.52),('6449','2013-04-22','14:40:00',1.33),('6449','2013-04-22','14:45:00',1.5),('6449','2013-04-22','14:50:00',1.2),('6449','2013-04-22','14:55:00',1.51),('6449','2013-04-22','15:00:00',10.01),('6449','2013-04-22','15:05:00',9.71),('6449','2013-04-22','15:10:00',14.75),('6449','2013-04-22','15:15:00',18.34),('6449','2013-04-22','15:20:00',14.13),('6449','2013-04-22','15:25:00',15.87),('6449','2013-04-22','15:30:00',15.5),('6449','2013-04-22','15:35:00',14.93),('6449','2013-04-22','15:40:00',14.56),('6449','2013-04-22','15:45:00',14.15),('6449','2013-04-22','15:50:00',13.74),('6449','2013-04-22','15:55:00',12.97),('6449','2013-04-22','16:00:00',10.01),('6449','2013-04-22','16:05:00',4.74),('6449','2013-04-22','16:10:00',6.03),('6449','2013-04-22','16:15:00',11.94),('6449','2013-04-22','16:20:00',11.21),('6449','2013-04-22','16:25:00',11.3),('6449','2013-04-22','16:30:00',11.63),('6449','2013-04-22','16:35:00',9.5),('6449','2013-04-22','16:40:00',8.92),('6449','2013-04-22','16:45:00',10.72),('6449','2013-04-22','16:50:00',4.95),('6449','2013-04-22','16:55:00',7.22),('6449','2013-04-22','17:00:00',8.31),('6449','2013-04-22','17:05:00',7.98),('6449','2013-04-22','17:10:00',10.8),('6449','2013-04-22','17:15:00',6.15),('6449','2013-04-22','17:20:00',4.34),('6449','2013-04-22','17:25:00',3.18),('6449','2013-04-22','17:30:00',2.73),('6449','2013-04-22','17:35:00',2.71),('6449','2013-04-22','17:40:00',2.46),('6449','2013-04-22','17:45:00',2.35),('6449','2013-04-22','17:50:00',2.37),('6449','2013-04-22','17:55:00',2.44),('6449','2013-04-22','18:00:00',2.3),('6449','2013-04-22','18:05:00',2.41),('6449','2013-04-22','18:10:00',3.63),('6449','2013-04-22','18:15:00',3.6),('6449','2013-04-22','18:20:00',1.09),('6449','2013-04-21','07:15:00',1.06),('6449','2013-04-21','07:20:00',1.4),('6449','2013-04-21','07:25:00',1.21),('6449','2013-04-21','07:30:00',1.43),('6449','2013-04-21','07:35:00',1.38),('6449','2013-04-21','07:40:00',1.39),('6449','2013-04-21','07:45:00',2.15),('6449','2013-04-21','07:50:00',2.56),('6449','2013-04-21','07:55:00',2.44),('6449','2013-04-21','08:00:00',2.65),('6449','2013-04-21','08:05:00',2.9),('6449','2013-04-21','08:10:00',3.49),('6449','2013-04-21','08:15:00',4.98),('6449','2013-04-21','08:20:00',7.19),('6449','2013-04-21','08:25:00',8.54),('6449','2013-04-21','08:30:00',7.64),('6449','2013-04-21','08:35:00',5.58),('6449','2013-04-21','08:40:00',7.92),('6449','2013-04-21','08:45:00',9.14),('6449','2013-04-21','08:50:00',8.77),('6449','2013-04-21','08:55:00',4.95),('6449','2013-04-21','09:00:00',3.75),('6449','2013-04-21','09:05:00',3.42),('6449','2013-04-21','09:10:00',3.41),('6449','2013-04-21','09:15:00',3.61),('6449','2013-04-21','09:20:00',4.77),('6449','2013-04-21','09:25:00',5.15),('6449','2013-04-21','09:30:00',5.21),('6449','2013-04-21','09:35:00',10.78),('6449','2013-04-21','09:40:00',12.13),('6449','2013-04-21','09:45:00',12.46),('6449','2013-04-21','09:50:00',12.58),('6449','2013-04-21','09:55:00',12.8),('6449','2013-04-21','10:00:00',12.96),('6449','2013-04-21','10:05:00',13.2),('6449','2013-04-21','10:10:00',13.28),('6449','2013-04-21','10:15:00',13.69),('6449','2013-04-21','10:20:00',13.9),('6449','2013-04-21','10:25:00',14.09),('6449','2013-04-21','10:30:00',14.21),('6449','2013-04-21','10:35:00',14.42),('6449','2013-04-21','10:40:00',14.59),('6449','2013-04-21','10:45:00',14.82),('6449','2013-04-21','10:50:00',15.05),('6449','2013-04-21','10:55:00',15.23),('6449','2013-04-21','11:00:00',15.45),('6449','2013-04-21','11:05:00',15.59),('6449','2013-04-21','11:10:00',15.71),('6449','2013-04-21','11:15:00',15.89),('6449','2013-04-21','11:20:00',16),('6449','2013-04-21','11:25:00',16.43),('6449','2013-04-21','11:30:00',16.98),('6449','2013-04-21','11:35:00',17.5),('6449','2013-04-21','11:40:00',13.33),('6449','2013-04-21','11:45:00',11.35),('6449','2013-04-21','11:50:00',11.35),('6449','2013-04-21','11:55:00',13.79),('6449','2013-04-21','12:00:00',18.66),('6449','2013-04-21','12:05:00',19.34),('6449','2013-04-21','12:10:00',8.01),('6449','2013-04-21','12:15:00',9.23),('6449','2013-04-21','12:20:00',12.58),('6449','2013-04-21','12:25:00',16.08),('6449','2013-04-21','12:30:00',16.46),('6449','2013-04-21','12:35:00',15.64),('6449','2013-04-21','12:40:00',18.63),('6449','2013-04-21','12:45:00',18.04),('6449','2013-04-21','12:50:00',17.77),('6449','2013-04-21','12:55:00',17.51),('6449','2013-04-21','13:00:00',17.34),('6449','2013-04-21','13:05:00',17),('6449','2013-04-21','13:10:00',17.06),('6449','2013-04-21','13:15:00',17.01),('6449','2013-04-21','13:20:00',17.12),('6449','2013-04-21','13:25:00',17.31),('6449','2013-04-21','13:30:00',16.87),('6449','2013-04-21','13:35:00',16.74),('6449','2013-04-21','13:40:00',16.62),('6449','2013-04-21','13:45:00',16.65),('6449','2013-04-21','13:50:00',16.55),('6449','2013-04-21','13:55:00',16.56),('6449','2013-04-21','14:00:00',16.55),('6449','2013-04-21','14:05:00',16.16),('6449','2013-04-21','14:10:00',16.2),('6449','2013-04-21','14:15:00',15.99),('6449','2013-04-21','14:20:00',15.78),('6449','2013-04-21','14:25:00',15.4),('6449','2013-04-21','14:30:00',15.94),('6449','2013-04-21','14:35:00',13.7),('6449','2013-04-21','14:40:00',13.74),('6449','2013-04-21','14:45:00',16.67),('6449','2013-04-21','14:50:00',17.08),('6449','2013-04-21','14:55:00',16.15),('6449','2013-04-21','15:00:00',14.94),('6449','2013-04-21','15:05:00',14.7),('6449','2013-04-21','15:10:00',14.6),('6449','2013-04-21','15:15:00',14.55),('6449','2013-04-21','15:20:00',14.42),('6449','2013-04-21','15:25:00',14.16),('6449','2013-04-21','15:30:00',14.1),('6449','2013-04-21','15:35:00',9.6),('6449','2013-04-21','15:40:00',11.78),('6449','2013-04-21','15:45:00',12.1),('6449','2013-04-21','15:50:00',8.84),('6449','2013-04-21','15:55:00',8.34),('6449','2013-04-21','16:00:00',9.39),('6449','2013-04-21','16:05:00',8.91),('6449','2013-04-21','16:10:00',6.59),('6449','2013-04-21','16:15:00',10),('6449','2013-04-21','16:20:00',8.09),('6449','2013-04-21','16:25:00',6.08),('6449','2013-04-21','16:30:00',4.83),('6449','2013-04-21','16:35:00',4.19),('6449','2013-04-21','16:40:00',4.33),('6449','2013-04-21','16:45:00',3.89),('6449','2013-04-21','16:50:00',3.62),('6449','2013-04-21','16:55:00',3.29),('6449','2013-04-21','17:00:00',2.7),('6449','2013-04-21','17:05:00',2.26),('6449','2013-04-21','17:10:00',2.06),('6449','2013-04-21','17:15:00',1.9),('6449','2013-04-21','17:20:00',1.71),('6449','2013-04-21','17:25:00',1.61),('6449','2013-04-21','17:30:00',1.57),('6449','2013-04-21','17:35:00',1.45),('6449','2013-04-21','17:40:00',1.54),('6449','2013-04-21','17:45:00',1.63),('6449','2013-04-21','17:50:00',1.51),('6449','2013-04-21','17:55:00',1.43),('6449','2013-04-21','18:00:00',1.57),('6449','2013-04-21','18:05:00',1.16),('6449','2013-04-21','18:15:00',1.03),('6449','2013-04-21','18:20:00',1.2),('6449','2013-04-21','18:25:00',1.42),('6449','2013-04-21','18:30:00',1.49),('6449','2013-04-21','18:35:00',1.11),('6449','2013-04-21','18:40:00',1.04),('6449','2013-04-20','07:35:00',1.02),('6449','2013-04-20','07:55:00',1.4),('6449','2013-04-20','08:00:00',1.63),('6449','2013-04-20','08:05:00',1.62),('6449','2013-04-20','08:10:00',1.97),('6449','2013-04-20','08:15:00',2.37),('6449','2013-04-20','08:20:00',2.52),('6449','2013-04-20','08:25:00',2.82),('6449','2013-04-20','08:30:00',2.76),('6449','2013-04-20','08:35:00',2.84),('6449','2013-04-20','08:40:00',3.43),('6449','2013-04-20','08:45:00',3.26),('6449','2013-04-20','08:50:00',3.27),('6449','2013-04-20','08:55:00',3.2),('6449','2013-04-20','09:00:00',3.09),('6449','2013-04-20','09:05:00',3.13),('6449','2013-04-20','09:10:00',3.3),('6449','2013-04-20','09:15:00',2.73),('6449','2013-04-20','09:20:00',2.48),('6449','2013-04-20','09:25:00',2.38),('6449','2013-04-20','09:30:00',2.65),('6449','2013-04-20','09:35:00',2.7),('6449','2013-04-20','09:40:00',2.64),('6449','2013-04-20','09:45:00',2.47),('6449','2013-04-20','09:50:00',2.86),('6449','2013-04-20','09:55:00',3.5),('6449','2013-04-20','10:00:00',3.8),('6449','2013-04-20','10:05:00',4.38),('6449','2013-04-20','10:10:00',4.08),('6449','2013-04-20','10:15:00',4.16),('6449','2013-04-20','10:20:00',4.28),('6449','2013-04-20','10:25:00',3.66),('6449','2013-04-20','10:30:00',3.76),('6449','2013-04-20','10:35:00',4.15),('6449','2013-04-20','10:40:00',4.79),('6449','2013-04-20','10:45:00',5.35),('6449','2013-04-20','10:50:00',5.95),('6449','2013-04-20','10:55:00',6.6),('6449','2013-04-20','11:00:00',7.57),('6449','2013-04-20','11:05:00',10.05),('6449','2013-04-20','11:10:00',9.64),('6449','2013-04-20','11:15:00',9.67),('6449','2013-04-20','11:20:00',13.73),('6449','2013-04-20','11:25:00',10.1),('6449','2013-04-20','11:30:00',12.51),('6449','2013-04-20','11:35:00',16),('6449','2013-04-20','11:40:00',17.21),('6449','2013-04-20','11:45:00',16.81),('6449','2013-04-20','11:50:00',16.41),('6449','2013-04-20','11:55:00',13.3),('6449','2013-04-20','12:00:00',14.38),('6449','2013-04-20','12:05:00',18.38),('6449','2013-04-20','12:10:00',18.24),('6449','2013-04-20','12:15:00',11.31),('6449','2013-04-20','12:20:00',12.05),('6449','2013-04-20','12:25:00',10.94),('6449','2013-04-20','12:30:00',10.96),('6449','2013-04-20','12:35:00',9.27),('6449','2013-04-20','12:40:00',7.73),('6449','2013-04-20','12:45:00',7.21),('6449','2013-04-20','12:50:00',5.8),('6449','2013-04-20','12:55:00',4.82),('6449','2013-04-20','13:00:00',4.38),('6449','2013-04-20','13:05:00',4.34),('6449','2013-04-20','13:10:00',4.98),('6449','2013-04-20','13:15:00',5.81),('6449','2013-04-20','13:20:00',7.33),('6449','2013-04-20','13:25:00',11.64),('6449','2013-04-20','13:30:00',14.35),('6449','2013-04-20','13:35:00',17.11),('6449','2013-04-20','13:40:00',18.54),('6449','2013-04-20','13:45:00',17.29),('6449','2013-04-20','13:50:00',18.69),('6449','2013-04-20','13:55:00',13.72),('6449','2013-04-20','14:00:00',12.51),('6449','2013-04-20','14:05:00',14.8),('6449','2013-04-20','14:10:00',13.34),('6449','2013-04-20','14:15:00',8.79),('6449','2013-04-20','14:20:00',5.59),('6449','2013-04-20','14:25:00',6.04),('6449','2013-04-20','14:30:00',9.03),('6449','2013-04-20','14:35:00',12.88),('6449','2013-04-20','14:40:00',10.18),('6449','2013-04-20','14:45:00',8.45),('6449','2013-04-20','14:50:00',4.88),('6449','2013-04-20','14:55:00',3.63),('6449','2013-04-20','15:00:00',3.31),('6449','2013-04-20','15:05:00',3.31),('6449','2013-04-20','15:10:00',3.36),('6449','2013-04-20','15:15:00',3.8),('6449','2013-04-20','15:20:00',4.74),('6449','2013-04-20','15:25:00',6.34),('6449','2013-04-20','15:30:00',13.16),('6449','2013-04-20','15:35:00',15.74),('6449','2013-04-20','15:40:00',14.42),('6449','2013-04-20','15:45:00',13.68),('6449','2013-04-20','15:50:00',13.06),('6449','2013-04-20','15:55:00',12.42),('6449','2013-04-20','16:00:00',11.89),('6449','2013-04-20','16:05:00',10.98),('6449','2013-04-20','16:10:00',9.05),('6449','2013-04-20','16:15:00',5.21),('6449','2013-04-20','16:20:00',2.94),('6449','2013-04-20','16:25:00',7.85),('6449','2013-04-20','16:30:00',10.9),('6449','2013-04-20','16:35:00',10.63),('6449','2013-04-20','16:40:00',9.53),('6449','2013-04-20','16:45:00',8.93),('6449','2013-04-20','16:50:00',8.74),('6449','2013-04-20','16:55:00',8.39),('6449','2013-04-20','17:00:00',7.81),('6449','2013-04-20','17:05:00',7.6),('6449','2013-04-20','17:10:00',7.32),('6449','2013-04-20','17:15:00',6.57),('6449','2013-04-20','17:20:00',4.41),('6449','2013-04-20','17:25:00',3.25),('6449','2013-04-20','17:30:00',2.89),('6449','2013-04-20','17:35:00',3.33),('6449','2013-04-20','17:40:00',3.5),('6449','2013-04-20','17:45:00',3.87),('6449','2013-04-20','17:50:00',2.44),('6449','2013-04-20','17:55:00',1.94),('6449','2013-04-20','18:00:00',2.25),('6449','2013-04-20','18:05:00',2.47),('6449','2013-04-20','18:10:00',2.31),('6449','2013-04-20','18:15:00',2.11),('6449','2013-04-20','18:20:00',1.77),('6449','2013-04-20','18:25:00',1.43),('6449','2013-04-20','18:30:00',1.31),('6449','2013-04-20','18:35:00',1.36),('6449','2013-04-20','18:40:00',1.33),('6449','2013-04-20','18:45:00',1.4),('6449','2013-04-20','18:50:00',1.55),('6449','2013-04-20','18:55:00',1.68),('6449','2013-04-20','19:00:00',1.31),('6449','2013-04-20','19:05:00',1.01),('6449','2013-04-19','07:15:00',1.17),('6449','2013-04-19','07:20:00',1.03),('6449','2013-04-19','07:25:00',1.12),('6449','2013-04-19','07:30:00',1.33),('6449','2013-04-19','07:35:00',1.72),('6449','2013-04-19','07:40:00',2),('6449','2013-04-19','07:45:00',3.02),('6449','2013-04-19','07:50:00',3.32),('6449','2013-04-19','07:55:00',3.68),('6449','2013-04-19','08:00:00',4.06),('6449','2013-04-19','08:05:00',4.48),('6449','2013-04-19','08:10:00',4.74),('6449','2013-04-19','08:15:00',5.08),('6449','2013-04-19','08:20:00',5.41),('6449','2013-04-19','08:25:00',5.86),('6449','2013-04-19','08:30:00',6.26),('6449','2013-04-19','08:35:00',6.58),('6449','2013-04-19','08:40:00',7.04),('6449','2013-04-19','08:45:00',7.5),('6449','2013-04-19','08:50:00',7.78),('6449','2013-04-19','08:55:00',8.12),('6449','2013-04-19','09:00:00',8.41),('6449','2013-04-19','09:05:00',8.54),('6449','2013-04-19','09:10:00',9.06),('6449','2013-04-19','09:15:00',9.35),('6449','2013-04-19','09:20:00',9.62),('6449','2013-04-19','09:25:00',10.04),('6449','2013-04-19','09:30:00',10.28),('6449','2013-04-19','09:35:00',10.54),('6449','2013-04-19','09:40:00',11.02),('6449','2013-04-19','09:45:00',11.43),('6449','2013-04-19','09:50:00',11.17),('6449','2013-04-19','09:55:00',11.8),('6449','2013-04-19','10:00:00',11.93),('6449','2013-04-19','10:05:00',12.53),('6449','2013-04-19','10:10:00',10.22),('6449','2013-04-19','10:15:00',9.92),('6449','2013-04-19','10:20:00',13.66),('6449','2013-04-19','10:25:00',11.05),('6449','2013-04-19','10:30:00',13.52),('6449','2013-04-19','10:35:00',13.12),('6449','2013-04-19','10:40:00',14.16),('6449','2013-04-19','10:45:00',11.52),('6449','2013-04-19','10:50:00',12.72),('6449','2013-04-19','10:55:00',13.75),('6449','2013-04-19','11:00:00',11.6),('6449','2013-04-19','11:05:00',11.58),('6449','2013-04-19','11:10:00',14.18),('6449','2013-04-19','11:15:00',13.64),('6449','2013-04-19','11:20:00',14.78),('6449','2013-04-19','11:25:00',14.78),('6449','2013-04-19','11:30:00',15.04),('6449','2013-04-19','11:35:00',15.13),('6449','2013-04-19','11:40:00',15.22),('6449','2013-04-19','11:45:00',15.3),('6449','2013-04-19','11:50:00',15.29),('6449','2013-04-19','11:55:00',15.49),('6449','2013-04-19','12:00:00',15.52),('6449','2013-04-19','12:05:00',15.51),('6449','2013-04-19','12:10:00',15.7),('6449','2013-04-19','12:15:00',15.8),('6449','2013-04-19','12:20:00',15.83),('6449','2013-04-19','12:25:00',15.88),('6449','2013-04-19','12:30:00',15.88),('6449','2013-04-19','12:35:00',15.82),('6449','2013-04-19','12:40:00',15.92),('6449','2013-04-19','12:45:00',15.87),('6449','2013-04-19','12:50:00',15.93),('6449','2013-04-19','12:55:00',15.99),('6449','2013-04-19','13:00:00',15.91),('6449','2013-04-19','13:05:00',15.95),('6449','2013-04-19','13:10:00',15.92),('6449','2013-04-19','13:15:00',15.91),('6449','2013-04-19','13:20:00',15.79),('6449','2013-04-19','13:25:00',15.83),('6449','2013-04-19','13:30:00',15.87),('6449','2013-04-19','13:35:00',15.71),('6449','2013-04-19','13:40:00',15.76),('6449','2013-04-19','13:45:00',15.6),('6449','2013-04-19','13:50:00',15.55),('6449','2013-04-19','13:55:00',15.51),('6449','2013-04-19','14:00:00',15.47),('6449','2013-04-19','14:05:00',15.34),('6449','2013-04-19','14:10:00',15.3),('6449','2013-04-19','14:15:00',15.14),('6449','2013-04-19','14:20:00',14.93),('6449','2013-04-19','14:25:00',14.9),('6449','2013-04-19','14:30:00',14.8),('6449','2013-04-19','14:35:00',14.65),('6449','2013-04-19','14:40:00',14.58),('6449','2013-04-19','14:45:00',14.34),('6449','2013-04-19','14:50:00',14.24),('6449','2013-04-19','14:55:00',14.11),('6449','2013-04-19','15:00:00',14.02),('6449','2013-04-19','15:05:00',13.83),('6449','2013-04-19','15:10:00',13.64),('6449','2013-04-19','15:15:00',13.42),('6449','2013-04-19','15:20:00',13.19),('6449','2013-04-19','15:25:00',13.16),('6449','2013-04-19','15:30:00',12.91),('6449','2013-04-19','15:35:00',12.57),('6449','2013-04-19','15:40:00',12.4),('6449','2013-04-19','15:45:00',12.13),('6449','2013-04-19','15:50:00',11.49),('6449','2013-04-19','15:55:00',11.72),('6449','2013-04-19','16:00:00',11.53),('6449','2013-04-19','16:05:00',10.96),('6449','2013-04-19','16:10:00',10.9),('6449','2013-04-19','16:15:00',9.79),('6449','2013-04-19','16:20:00',10.28),('6449','2013-04-19','16:25:00',10.01),('6449','2013-04-19','16:30:00',9.66),('6449','2013-04-19','16:35:00',9.27),('6449','2013-04-19','16:40:00',9.19),('6449','2013-04-19','16:45:00',8.55),('6449','2013-04-19','16:50:00',8.04),('6449','2013-04-19','16:55:00',7.48),('6449','2013-04-19','17:00:00',7.6),('6449','2013-04-19','17:05:00',7.3),('6449','2013-04-19','17:10:00',7.03),('6449','2013-04-19','17:15:00',5.75),('6449','2013-04-19','17:20:00',5.26),('6449','2013-04-19','17:25:00',5.19),('6449','2013-04-19','17:30:00',5.74),('6449','2013-04-19','17:35:00',5.57),('6449','2013-04-19','17:40:00',5.44),('6449','2013-04-19','17:45:00',5.33),('6449','2013-04-19','17:50:00',4.54),('6449','2013-04-19','17:55:00',3.38),('6449','2013-04-19','18:00:00',3.47),('6449','2013-04-19','18:05:00',3.21),('6449','2013-04-19','18:10:00',2.81),('6449','2013-04-19','18:15:00',2.52),('6449','2013-04-19','18:20:00',2.28),('6449','2013-04-19','18:25:00',2.01),('6449','2013-04-19','18:30:00',1.73),('6449','2013-04-19','18:35:00',1.49),('6449','2013-04-19','18:40:00',1.32),('6449','2013-04-19','18:45:00',1.14),('6449','2013-04-18','07:35:00',1.1),('6449','2013-04-18','07:40:00',1.39),('6449','2013-04-18','07:45:00',1.77),('6449','2013-04-18','07:50:00',2.04),('6449','2013-04-18','07:55:00',2.99),('6449','2013-04-18','08:00:00',3.89),('6449','2013-04-18','08:05:00',4.54),('6449','2013-04-18','08:10:00',5.21),('6449','2013-04-18','08:15:00',5.08),('6449','2013-04-18','08:20:00',5.63),('6449','2013-04-18','08:25:00',5.93),('6449','2013-04-18','08:30:00',6.87),('6449','2013-04-18','08:35:00',6.92),('6449','2013-04-18','08:40:00',6.64),('6449','2013-04-18','08:45:00',6.21),('6449','2013-04-18','08:50:00',5.69),('6449','2013-04-18','08:55:00',7.04),('6449','2013-04-18','09:00:00',8.31),('6449','2013-04-18','09:05:00',9.45),('6449','2013-04-18','09:10:00',9.91),('6449','2013-04-18','09:15:00',10.08),('6449','2013-04-18','09:20:00',10.42),('6449','2013-04-18','09:25:00',10.65),('6449','2013-04-18','09:30:00',10.94),('6449','2013-04-18','09:35:00',11.22),('6449','2013-04-18','09:40:00',11.28),('6449','2013-04-18','09:45:00',11.3),('6449','2013-04-18','09:50:00',11.69),('6449','2013-04-18','09:55:00',11.87),('6449','2013-04-18','10:00:00',12.02),('6449','2013-04-18','10:05:00',12.17),('6449','2013-04-18','10:10:00',12.28),('6449','2013-04-18','10:15:00',12.6),('6449','2013-04-18','10:20:00',12.76),('6449','2013-04-18','10:25:00',12.97),('6449','2013-04-18','10:30:00',13.13),('6449','2013-04-18','10:35:00',11.24),('6449','2013-04-18','10:40:00',12.02),('6449','2013-04-18','10:45:00',13.65),('6449','2013-04-18','10:50:00',13.73),('6449','2013-04-18','10:55:00',13.88),('6449','2013-04-18','11:00:00',13.98),('6449','2013-04-18','11:05:00',14.2),('6449','2013-04-18','11:10:00',14.3),('6449','2013-04-18','11:15:00',14.58),('6449','2013-04-18','11:20:00',14.76),('6449','2013-04-18','11:25:00',14.69),('6449','2013-04-18','11:30:00',15.06),('6449','2013-04-18','11:35:00',15.28),('6449','2013-04-18','11:40:00',15.35),('6449','2013-04-18','11:45:00',15.46),('6449','2013-04-18','11:50:00',15.57),('6449','2013-04-18','11:55:00',15.52),('6449','2013-04-18','12:00:00',15.85),('6449','2013-04-18','12:05:00',16.02),('6449','2013-04-18','12:10:00',16.11),('6449','2013-04-18','12:15:00',16.24),('6449','2013-04-18','12:20:00',16.34),('6449','2013-04-18','12:25:00',16.36),('6449','2013-04-18','12:30:00',16.45),('6449','2013-04-18','12:35:00',16.51),('6449','2013-04-18','12:40:00',16.54),('6449','2013-04-18','12:45:00',16.39),('6449','2013-04-18','12:50:00',16.39),('6449','2013-04-18','12:55:00',16.32),('6449','2013-04-18','13:00:00',16.26),('6449','2013-04-18','13:05:00',16.29),('6449','2013-04-18','13:10:00',15.91),('6449','2013-04-18','13:15:00',16.21),('6449','2013-04-18','13:20:00',16),('6449','2013-04-18','13:25:00',16.14),('6449','2013-04-18','13:30:00',16.15),('6449','2013-04-18','13:35:00',15.99),('6449','2013-04-18','13:40:00',15.73),('6449','2013-04-18','13:45:00',15.81),('6449','2013-04-18','13:50:00',15.54),('6449','2013-04-18','13:55:00',15.46),('6449','2013-04-18','14:00:00',15.21),('6449','2013-04-18','14:05:00',15.33),('6449','2013-04-18','14:10:00',15.13),('6449','2013-04-18','14:15:00',15.27),('6449','2013-04-18','14:20:00',15.19),('6449','2013-04-18','14:25:00',15.07),('6449','2013-04-18','14:30:00',15.11),('6449','2013-04-18','14:35:00',14.9),('6449','2013-04-18','14:40:00',14.75),('6449','2013-04-18','14:45:00',14.73),('6449','2013-04-18','14:50:00',14.6),('6449','2013-04-18','14:55:00',13.76),('6449','2013-04-18','15:00:00',13.73),('6449','2013-04-18','15:05:00',13.14),('6449','2013-04-18','15:10:00',13.68),('6449','2013-04-18','15:15:00',13.4),('6449','2013-04-18','15:20:00',13.29),('6449','2013-04-18','15:25:00',12.95),('6449','2013-04-18','15:30:00',12.72),('6449','2013-04-18','15:35:00',12.73),('6449','2013-04-18','15:40:00',12.61),('6449','2013-04-18','15:45:00',12.28),('6449','2013-04-18','15:50:00',12.06),('6449','2013-04-18','15:55:00',11.68),('6449','2013-04-18','16:00:00',11.54),('6449','2013-04-18','16:05:00',11.35),('6449','2013-04-18','16:10:00',11.14),('6449','2013-04-18','16:15:00',10.91),('6449','2013-04-18','16:20:00',10.57),('6449','2013-04-18','16:25:00',10.25),('6449','2013-04-18','16:30:00',9.83),('6449','2013-04-18','16:35:00',9.46),('6449','2013-04-18','16:40:00',9.02),('6449','2013-04-18','16:45:00',8.82),('6449','2013-04-18','16:50:00',8.45),('6449','2013-04-18','16:55:00',8.23),('6449','2013-04-18','17:00:00',7.81),('6449','2013-04-18','17:05:00',7.44),('6449','2013-04-18','17:10:00',7),('6449','2013-04-18','17:15:00',6.77),('6449','2013-04-18','17:20:00',6.48),('6449','2013-04-18','17:25:00',6.07),('6449','2013-04-18','17:30:00',5.7),('6449','2013-04-18','17:35:00',5.26),('6449','2013-04-18','17:40:00',4.9),('6449','2013-04-18','17:45:00',4.52),('6449','2013-04-18','17:50:00',4.12),('6449','2013-04-18','17:55:00',3.76),('6449','2013-04-18','18:00:00',3.41),('6449','2013-04-18','18:05:00',3.08),('6449','2013-04-18','18:10:00',2.76),('6449','2013-04-18','18:15:00',2.5),('6449','2013-04-18','18:20:00',2.21),('6449','2013-04-18','18:25:00',1.92),('6449','2013-04-18','18:30:00',1.73),('6449','2013-04-18','18:35:00',1.49),('6449','2013-04-18','18:40:00',1.28),('6449','2013-04-18','18:45:00',1.1),('6449','2013-04-17','07:10:00',1.03),('6449','2013-04-17','07:15:00',1.25),('6449','2013-04-17','07:20:00',1.51),('6449','2013-04-17','07:25:00',1.8),('6449','2013-04-17','07:30:00',2.12),('6449','2013-04-17','07:35:00',2.46),('6449','2013-04-17','07:40:00',2.79),('6449','2013-04-17','07:45:00',3.12),('6449','2013-04-17','07:50:00',3.53),('6449','2013-04-17','07:55:00',3.9),('6449','2013-04-17','08:00:00',4.27),('6449','2013-04-17','08:05:00',4.52),('6449','2013-04-17','08:10:00',5.01),('6449','2013-04-17','08:15:00',5.38),('6449','2013-04-17','08:20:00',5.74),('6449','2013-04-17','08:25:00',6.18),('6449','2013-04-17','08:30:00',6.54),('6449','2013-04-17','08:35:00',6.87),('6449','2013-04-17','08:40:00',7.14),('6449','2013-04-17','08:45:00',7.52),('6449','2013-04-17','08:50:00',7.92),('6449','2013-04-17','08:55:00',8.33),('6449','2013-04-17','09:00:00',8.57),('6449','2013-04-17','09:05:00',8.92),('6449','2013-04-17','09:10:00',9.33),('6449','2013-04-17','09:15:00',9.56),('6449','2013-04-17','09:20:00',9.93),('6449','2013-04-17','09:25:00',10.18),('6449','2013-04-17','09:30:00',10.56),('6449','2013-04-17','09:35:00',10.9),('6449','2013-04-17','09:40:00',11.1),('6449','2013-04-17','09:45:00',11.43),('6449','2013-04-17','09:50:00',11.59),('6449','2013-04-17','09:55:00',12.01),('6449','2013-04-17','10:00:00',12.28),('6449','2013-04-17','10:05:00',12.42),('6449','2013-04-17','10:10:00',12.65),('6449','2013-04-17','10:15:00',12.81),('6449','2013-04-17','10:20:00',13.03),('6449','2013-04-17','10:25:00',13.2),('6449','2013-04-17','10:30:00',13.4),('6449','2013-04-17','10:35:00',13.58),('6449','2013-04-17','10:40:00',13.61),('6449','2013-04-17','10:45:00',13.78),('6449','2013-04-17','10:50:00',13.87),('6449','2013-04-17','10:55:00',14.02),('6449','2013-04-17','11:00:00',14.13),('6449','2013-04-17','11:05:00',14.21),('6449','2013-04-17','11:10:00',14.17),('6449','2013-04-17','11:15:00',14.32),('6449','2013-04-17','11:20:00',14.43),('6449','2013-04-17','11:25:00',14.9),('6449','2013-04-17','11:30:00',15.15),('6449','2013-04-17','11:35:00',15.32),('6449','2013-04-17','11:40:00',15.23),('6449','2013-04-17','11:45:00',15.72),('6449','2013-04-17','11:50:00',15.93),('6449','2013-04-17','11:55:00',15.99),('6449','2013-04-17','12:00:00',16.07),('6449','2013-04-17','12:05:00',16.14),('6449','2013-04-17','12:10:00',16.19),('6449','2013-04-17','12:15:00',16.33),('6449','2013-04-17','12:20:00',16.4),('6449','2013-04-17','12:25:00',16.33),('6449','2013-04-17','12:30:00',16.28),('6449','2013-04-17','12:35:00',16.16),('6449','2013-04-17','12:40:00',16.31),('6449','2013-04-17','12:45:00',16.13),('6449','2013-04-17','12:50:00',16.43),('6449','2013-04-17','12:55:00',16.13),('6449','2013-04-17','13:00:00',15.55),('6449','2013-04-17','13:05:00',15.2),('6449','2013-04-17','13:10:00',15.76),('6449','2013-04-17','13:15:00',14.8),('6449','2013-04-17','13:20:00',14.4),('6449','2013-04-17','13:25:00',14.09),('6449','2013-04-17','13:30:00',13.89),('6449','2013-04-17','13:35:00',16.23),('6449','2013-04-17','13:40:00',16.75),('6449','2013-04-17','13:45:00',15.07),('6449','2013-04-17','13:50:00',14.87),('6449','2013-04-17','13:55:00',14.1),('6449','2013-04-17','14:00:00',13.12),('6449','2013-04-17','14:05:00',12.91),('6449','2013-04-17','14:10:00',15.69),('6449','2013-04-17','14:15:00',14.41),('6449','2013-04-17','14:20:00',15.94),('6449','2013-04-17','14:25:00',16.24),('6449','2013-04-17','14:30:00',16.01),('6449','2013-04-17','14:35:00',15.91),('6449','2013-04-17','14:40:00',15.58),('6449','2013-04-17','14:45:00',16.27),('6449','2013-04-17','14:50:00',15.83),('6449','2013-04-17','14:55:00',13.77),('6449','2013-04-17','15:00:00',13.47),('6449','2013-04-17','15:05:00',12.77),('6449','2013-04-17','15:10:00',13.24),('6449','2013-04-17','15:15:00',15.83),('6449','2013-04-17','15:20:00',14.28),('6449','2013-04-17','15:25:00',15.23),('6449','2013-04-17','15:30:00',14.8),('6449','2013-04-17','15:35:00',14.04),('6449','2013-04-17','15:40:00',13.83),('6449','2013-04-17','15:45:00',13.5),('6449','2013-04-17','15:50:00',12.08),('6449','2013-04-17','15:55:00',12.41),('6449','2013-04-17','16:00:00',12.14),('6449','2013-04-17','16:05:00',11.55),('6449','2013-04-17','16:10:00',11.48),('6449','2013-04-17','16:15:00',11.04),('6449','2013-04-17','16:20:00',10.75),('6449','2013-04-17','16:25:00',10.12),('6449','2013-04-17','16:30:00',10.08),('6449','2013-04-17','16:35:00',9.75),('6449','2013-04-17','16:40:00',9.32),('6449','2013-04-17','16:45:00',8.98),('6449','2013-04-17','16:50:00',8.59),('6449','2013-04-17','16:55:00',8.2),('6449','2013-04-17','17:00:00',7.91),('6449','2013-04-17','17:05:00',7.52),('6449','2013-04-17','17:10:00',7.13),('6449','2013-04-17','17:15:00',6.84),('6449','2013-04-17','17:20:00',6.49),('6449','2013-04-17','17:25:00',6.13),('6449','2013-04-17','17:30:00',5.75),('6449','2013-04-17','17:35:00',5.37),('6449','2013-04-17','17:40:00',5.08),('6449','2013-04-17','17:45:00',4.72),('6449','2013-04-17','17:50:00',4.35),('6449','2013-04-17','17:55:00',4.03),('6449','2013-04-17','18:00:00',3.64),('6449','2013-04-17','18:05:00',3.29),('6449','2013-04-17','18:10:00',2.83),('6449','2013-04-17','18:15:00',2.62),('6449','2013-04-17','18:20:00',2.32),('6449','2013-04-17','18:25:00',2.01),('6449','2013-04-17','18:30:00',1.73),('6449','2013-04-17','18:35:00',1.47),('6449','2013-04-17','18:40:00',1.22),('6449','2013-04-17','18:45:00',1.04),('6449','2013-04-16','07:05:00',1.04),('6449','2013-04-16','07:10:00',1.3),('6449','2013-04-16','07:15:00',1.59),('6449','2013-04-16','07:20:00',1.5),('6449','2013-04-16','07:25:00',1.49),('6449','2013-04-16','07:30:00',1.84),('6449','2013-04-16','07:35:00',1.35),('6449','2013-04-16','07:40:00',2.33),('6449','2013-04-16','07:45:00',2.61),('6449','2013-04-16','07:50:00',2.82),('6449','2013-04-16','07:55:00',3.58),('6449','2013-04-16','08:00:00',3.94),('6449','2013-04-16','08:05:00',4.29),('6449','2013-04-16','08:10:00',4.61),('6449','2013-04-16','08:15:00',4.98),('6449','2013-04-16','08:20:00',5.28),('6449','2013-04-16','08:25:00',5.75),('6449','2013-04-16','08:30:00',6.05),('6449','2013-04-16','08:35:00',6.03),('6449','2013-04-16','08:40:00',6.36),('6449','2013-04-16','08:45:00',3.62),('6449','2013-04-16','08:50:00',3.18),('6449','2013-04-16','08:55:00',6.9),('6449','2013-04-16','09:00:00',8.74),('6449','2013-04-16','09:05:00',7.5),('6449','2013-04-16','09:10:00',4.31),('6449','2013-04-16','09:15:00',6.02),('6449','2013-04-16','09:20:00',6.08),('6449','2013-04-16','09:25:00',10.05),('6449','2013-04-16','09:30:00',5.05),('6449','2013-04-16','09:35:00',5.39),('6449','2013-04-16','09:40:00',5.54),('6449','2013-04-16','09:45:00',7.36),('6449','2013-04-16','09:50:00',5.49),('6449','2013-04-16','09:55:00',4.9),('6449','2013-04-16','10:00:00',5.33),('6449','2013-04-16','10:05:00',5.64),('6449','2013-04-16','10:10:00',5.33),('6449','2013-04-16','10:15:00',4.75),('6449','2013-04-16','10:20:00',4.64),('6449','2013-04-16','10:25:00',4.99),('6449','2013-04-16','10:30:00',4.85),('6449','2013-04-16','10:35:00',4.27),('6449','2013-04-16','10:40:00',4.1),('6449','2013-04-16','10:45:00',4.25),('6449','2013-04-16','10:50:00',4.54),('6449','2013-04-16','10:55:00',4.68),('6449','2013-04-16','11:00:00',4.51),('6449','2013-04-16','11:05:00',4.53),('6449','2013-04-16','11:10:00',4.94),('6449','2013-04-16','11:15:00',5.88),('6449','2013-04-16','11:20:00',6.42),('6449','2013-04-16','11:25:00',7.19),('6449','2013-04-16','11:30:00',7.88),('6449','2013-04-16','11:35:00',9.6),('6449','2013-04-16','11:40:00',12.57),('6449','2013-04-16','11:45:00',12.69),('6449','2013-04-16','11:50:00',14.35),('6449','2013-04-16','11:55:00',10.96),('6449','2013-04-16','12:00:00',15.55),('6449','2013-04-16','12:05:00',14.12),('6449','2013-04-16','12:10:00',11.92),('6449','2013-04-16','12:15:00',9.2),('6449','2013-04-16','12:20:00',13.05),('6449','2013-04-16','12:25:00',13.69),('6449','2013-04-16','12:30:00',13),('6449','2013-04-16','12:35:00',12.83),('6449','2013-04-16','12:40:00',15.75),('6449','2013-04-16','12:45:00',16.17),('6449','2013-04-16','12:50:00',16.01),('6449','2013-04-16','12:55:00',16.04),('6449','2013-04-16','13:00:00',16.13),('6449','2013-04-16','13:05:00',16.17),('6449','2013-04-16','13:10:00',16.11),('6449','2013-04-16','13:15:00',16.08),('6449','2013-04-16','13:20:00',16.05),('6449','2013-04-16','13:25:00',16.04),('6449','2013-04-16','13:30:00',15.88),('6449','2013-04-16','13:35:00',15.26),('6449','2013-04-16','13:40:00',14.87),('6449','2013-04-16','13:45:00',14.35),('6449','2013-04-16','13:50:00',15.25),('6449','2013-04-16','13:55:00',16.19),('6449','2013-04-16','14:00:00',16.43),('6449','2013-04-16','14:05:00',16.13),('6449','2013-04-16','14:10:00',16.11),('6449','2013-04-16','14:15:00',14.66),('6449','2013-04-16','14:20:00',13.8),('6449','2013-04-16','14:25:00',15.62),('6449','2013-04-16','14:30:00',14.84),('6449','2013-04-16','14:35:00',15.12),('6449','2013-04-16','14:40:00',15.25),('6449','2013-04-16','14:45:00',9.82),('6449','2013-04-16','14:50:00',11.72),('6449','2013-04-16','14:55:00',15.28),('6449','2013-04-16','15:00:00',15.09),('6449','2013-04-16','15:05:00',14.01),('6449','2013-04-16','15:10:00',13.4),('6449','2013-04-16','15:15:00',11.28),('6449','2013-04-16','15:20:00',12.39),('6449','2013-04-16','15:25:00',11.3),('6449','2013-04-16','15:30:00',10.86),('6449','2013-04-16','15:35:00',11.88),('6449','2013-04-16','15:40:00',11.33),('6449','2013-04-16','15:45:00',12.31),('6449','2013-04-16','15:50:00',11.99),('6449','2013-04-16','15:55:00',11.7),('6449','2013-04-16','16:00:00',11.62),('6449','2013-04-16','16:05:00',11.43),('6449','2013-04-16','16:10:00',10.9),('6449','2013-04-16','16:15:00',7.5),('6449','2013-04-16','16:20:00',7.59),('6449','2013-04-16','16:25:00',8.32),('6449','2013-04-16','16:30:00',10.25),('6449','2013-04-16','16:35:00',9.45),('6449','2013-04-16','16:40:00',9.62),('6449','2013-04-16','16:45:00',9.04),('6449','2013-04-16','16:50:00',8.47),('6449','2013-04-16','16:55:00',8.09),('6449','2013-04-16','17:00:00',7.29),('6449','2013-04-16','17:05:00',7.25),('6449','2013-04-16','17:10:00',6.79),('6449','2013-04-16','17:15:00',6.63),('6449','2013-04-16','17:20:00',6.3),('6449','2013-04-16','17:25:00',6),('6449','2013-04-16','17:30:00',5.66),('6449','2013-04-16','17:35:00',5.27),('6449','2013-04-16','17:40:00',4.97),('6449','2013-04-16','17:45:00',4.62),('6449','2013-04-16','17:50:00',4.29),('6449','2013-04-16','17:55:00',3.94),('6449','2013-04-16','18:00:00',3.54),('6449','2013-04-16','18:05:00',3.24),('6449','2013-04-16','18:10:00',2.89),('6449','2013-04-16','18:15:00',2.51),('6449','2013-04-16','18:20:00',2.18),('6449','2013-04-16','18:25:00',1.94),('6449','2013-04-16','18:30:00',1.62),('6449','2013-04-16','18:35:00',1.25),('6449','2013-04-15','07:15:00',1.16),('6449','2013-04-15','07:20:00',1.42),('6449','2013-04-15','07:25:00',1.71),('6449','2013-04-15','07:30:00',2.06),('6449','2013-04-15','07:35:00',2.42),('6449','2013-04-15','07:40:00',2.75),('6449','2013-04-15','07:45:00',3.17),('6449','2013-04-15','07:50:00',3.52),('6449','2013-04-15','07:55:00',3.89),('6449','2013-04-15','08:00:00',4.26),('6449','2013-04-15','08:05:00',4.67),('6449','2013-04-15','08:10:00',5),('6449','2013-04-15','08:15:00',5.42),('6449','2013-04-15','08:20:00',5.86),('6449','2013-04-15','08:25:00',6.25),('6449','2013-04-15','08:30:00',6.59),('6449','2013-04-15','08:35:00',7.01),('6449','2013-04-15','08:40:00',7.45),('6449','2013-04-15','08:45:00',7.82),('6449','2013-04-15','08:50:00',8.14),('6449','2013-04-15','08:55:00',8.44),('6449','2013-04-15','09:00:00',8.73),('6449','2013-04-15','09:05:00',9.05),('6449','2013-04-15','09:10:00',9.42),('6449','2013-04-15','09:15:00',9.82),('6449','2013-04-15','09:20:00',10.09),('6449','2013-04-15','09:25:00',10.28),('6449','2013-04-15','09:30:00',10.75),('6449','2013-04-15','09:35:00',10.98),('6449','2013-04-15','09:40:00',11.23),('6449','2013-04-15','09:45:00',11.49),('6449','2013-04-15','09:50:00',11.87),('6449','2013-04-15','09:55:00',11.97),('6449','2013-04-15','10:00:00',12.4),('6449','2013-04-15','10:05:00',12.64),('6449','2013-04-15','10:10:00',12.85),('6449','2013-04-15','10:15:00',12.98),('6449','2013-04-15','10:20:00',13.05),('6449','2013-04-15','10:25:00',13.16),('6449','2013-04-15','10:30:00',13.26),('6449','2013-04-15','10:35:00',13.39),('6449','2013-04-15','10:40:00',13.57),('6449','2013-04-15','10:45:00',13.68),('6449','2013-04-15','10:50:00',13.76),('6449','2013-04-15','10:55:00',13.87),('6449','2013-04-15','11:00:00',13.94),('6449','2013-04-15','11:05:00',14.1),('6449','2013-04-15','11:10:00',14.14),('6449','2013-04-15','11:15:00',14.46),('6449','2013-04-15','11:20:00',14.62),('6449','2013-04-15','11:25:00',14.76),('6449','2013-04-15','11:30:00',14.86),('6449','2013-04-15','11:35:00',14.9),('6449','2013-04-15','11:40:00',14.85),('6449','2013-04-15','11:45:00',15.13),('6449','2013-04-15','11:50:00',15.23),('6449','2013-04-15','11:55:00',15.3),('6449','2013-04-15','12:00:00',15.34),('6449','2013-04-15','12:05:00',15.49),('6449','2013-04-15','12:10:00',15.7),('6449','2013-04-15','12:15:00',15.91),('6449','2013-04-15','12:20:00',16.09),('6449','2013-04-15','12:25:00',16.31),('6449','2013-04-15','12:30:00',16.37),('6449','2013-04-15','12:35:00',16.39),('6449','2013-04-15','12:40:00',16.37),('6449','2013-04-15','12:45:00',16.4),('6449','2013-04-15','12:50:00',16.46),('6449','2013-04-15','12:55:00',16.22),('6449','2013-04-15','13:00:00',16.51),('6449','2013-04-15','13:05:00',16.39),('6449','2013-04-15','13:10:00',16.37),('6449','2013-04-15','13:15:00',16.32),('6449','2013-04-15','13:20:00',16.21),('6449','2013-04-15','13:25:00',15.96),('6449','2013-04-15','13:30:00',16.39),('6449','2013-04-15','13:35:00',16.31),('6449','2013-04-15','13:40:00',16.31),('6449','2013-04-15','13:45:00',16.2),('6449','2013-04-15','13:50:00',16.24),('6449','2013-04-15','13:55:00',16.11),('6449','2013-04-15','14:00:00',16.05),('6449','2013-04-15','14:05:00',15.85),('6449','2013-04-15','14:10:00',15.66),('6449','2013-04-15','14:15:00',15.63),('6449','2013-04-15','14:20:00',15.55),('6449','2013-04-15','14:25:00',15.45),('6449','2013-04-15','14:30:00',15.29),('6449','2013-04-15','14:35:00',15.12),('6449','2013-04-15','14:40:00',14.84),('6449','2013-04-15','14:45:00',14.83),('6449','2013-04-15','14:50:00',14.72),('6449','2013-04-15','14:55:00',14.58),('6449','2013-04-15','15:00:00',14.41),('6449','2013-04-15','15:05:00',14.27),('6449','2013-04-15','15:10:00',14.07),('6449','2013-04-15','15:15:00',13.79),('6449','2013-04-15','15:20:00',13.84),('6449','2013-04-15','15:25:00',13.66),('6449','2013-04-15','15:30:00',13.39),('6449','2013-04-15','15:35:00',13.11),('6449','2013-04-15','15:40:00',12.94),('6449','2013-04-15','15:45:00',12.68),('6449','2013-04-15','15:50:00',12.47),('6449','2013-04-15','15:55:00',12.22),('6449','2013-04-15','16:00:00',11.94),('6449','2013-04-15','16:05:00',11.7),('6449','2013-04-15','16:10:00',11.34),('6449','2013-04-15','16:15:00',10.99),('6449','2013-04-15','16:20:00',10.82),('6449','2013-04-15','16:25:00',10.5),('6449','2013-04-15','16:30:00',10.15),('6449','2013-04-15','16:35:00',9.9),('6449','2013-04-15','16:40:00',9.48),('6449','2013-04-15','16:45:00',9.13),('6449','2013-04-15','16:50:00',8.71),('6449','2013-04-15','16:55:00',8.43),('6449','2013-04-15','17:00:00',7.95),('6449','2013-04-15','17:05:00',7.66),('6449','2013-04-15','17:10:00',7.31),('6449','2013-04-15','17:15:00',6.92),('6449','2013-04-15','17:20:00',6.61),('6449','2013-04-15','17:25:00',6.23),('6449','2013-04-15','17:30:00',5.87),('6449','2013-04-15','17:35:00',5.47),('6449','2013-04-15','17:40:00',5.12),('6449','2013-04-15','17:45:00',4.74),('6449','2013-04-15','17:50:00',4.37),('6449','2013-04-15','17:55:00',3.98),('6449','2013-04-15','18:00:00',3.62),('6449','2013-04-15','18:05:00',3.25),('6449','2013-04-15','18:10:00',2.88),('6449','2013-04-15','18:15:00',2.55),('6449','2013-04-15','18:20:00',2.28),('6449','2013-04-15','18:25:00',1.96),('6449','2013-04-15','18:30:00',1.67),('6449','2013-04-15','18:35:00',1.4),('6449','2013-04-15','18:40:00',1.17),('6449','2013-04-14','07:15:00',1.12),('6449','2013-04-14','07:20:00',1.38),('6449','2013-04-14','07:25:00',1.71),('6449','2013-04-14','07:30:00',2.07),('6449','2013-04-14','07:35:00',2.42),('6449','2013-04-14','07:40:00',2.73),('6449','2013-04-14','07:45:00',2.95),('6449','2013-04-14','07:50:00',3.52),('6449','2013-04-14','07:55:00',3.59),('6449','2013-04-14','08:00:00',3.74),('6449','2013-04-14','08:05:00',4.16),('6449','2013-04-14','08:10:00',4.73),('6449','2013-04-14','08:15:00',5.2),('6449','2013-04-14','08:20:00',5.54),('6449','2013-04-14','08:25:00',5.94),('6449','2013-04-14','08:30:00',6.38),('6449','2013-04-14','08:35:00',6.75),('6449','2013-04-14','08:40:00',7.12),('6449','2013-04-14','08:45:00',7.48),('6449','2013-04-14','08:50:00',7.82),('6449','2013-04-14','08:55:00',8.16),('6449','2013-04-14','09:00:00',8.53),('6449','2013-04-14','09:05:00',8.83),('6449','2013-04-14','09:10:00',9.24),('6449','2013-04-14','09:15:00',9.48),('6449','2013-04-14','09:20:00',9.76),('6449','2013-04-14','09:25:00',10.06),('6449','2013-04-14','09:30:00',10.39),('6449','2013-04-14','09:35:00',10.65),('6449','2013-04-14','09:40:00',10.94),('6449','2013-04-14','09:45:00',11.26),('6449','2013-04-14','09:50:00',11.52),('6449','2013-04-14','09:55:00',11.49),('6449','2013-04-14','10:00:00',11.99),('6449','2013-04-14','10:05:00',12.23),('6449','2013-04-14','10:10:00',12.43),('6449','2013-04-14','10:15:00',12.66),('6449','2013-04-14','10:20:00',12.85),('6449','2013-04-14','10:25:00',13.06),('6449','2013-04-14','10:30:00',13.22),('6449','2013-04-14','10:35:00',13.4),('6449','2013-04-14','10:40:00',13.41),('6449','2013-04-14','10:45:00',13.7),('6449','2013-04-14','10:50:00',13.84),('6449','2013-04-14','10:55:00',13.86),('6449','2013-04-14','11:00:00',13.96),('6449','2013-04-14','11:05:00',14.12),('6449','2013-04-14','11:10:00',14.18),('6449','2013-04-14','11:15:00',14.5),('6449','2013-04-14','11:20:00',14.8),('6449','2013-04-14','11:25:00',14.88),('6449','2013-04-14','11:30:00',15.09),('6449','2013-04-14','11:35:00',15.25),('6449','2013-04-14','11:40:00',15.37),('6449','2013-04-14','11:45:00',15.33),('6449','2013-04-14','11:50:00',15.4),('6449','2013-04-14','11:55:00',15.58),('6449','2013-04-14','12:00:00',15.82),('6449','2013-04-14','12:05:00',16),('6449','2013-04-14','12:10:00',16.02),('6449','2013-04-14','12:15:00',16.05),('6449','2013-04-14','12:20:00',16.09),('6449','2013-04-14','12:25:00',16.18),('6449','2013-04-14','12:30:00',16.13),('6449','2013-04-14','12:35:00',16.3),('6449','2013-04-14','12:40:00',16.34),('6449','2013-04-14','12:45:00',16.25),('6449','2013-04-14','12:50:00',16.3),('6449','2013-04-14','12:55:00',16.3),('6449','2013-04-14','13:00:00',16.1),('6449','2013-04-14','13:05:00',16.24),('6449','2013-04-14','13:10:00',16.21),('6449','2013-04-14','13:15:00',16.18),('6449','2013-04-14','13:20:00',16.2),('6449','2013-04-14','13:25:00',16.24),('6449','2013-04-14','13:30:00',16.03),('6449','2013-04-14','13:35:00',16.14),('6449','2013-04-14','13:40:00',16.1),('6449','2013-04-14','13:45:00',16.03),('6449','2013-04-14','13:50:00',15.94),('6449','2013-04-14','13:55:00',15.83),('6449','2013-04-14','14:00:00',15.72),('6449','2013-04-14','14:05:00',15.71),('6449','2013-04-14','14:10:00',15.72),('6449','2013-04-14','14:15:00',15.57),('6449','2013-04-14','14:20:00',15.6),('6449','2013-04-14','14:25:00',15.43),('6449','2013-04-14','14:30:00',15.24),('6449','2013-04-14','14:35:00',15.17),('6449','2013-04-14','14:40:00',15.12),('6449','2013-04-14','14:45:00',14.72),('6449','2013-04-14','14:50:00',14.72),('6449','2013-04-14','14:55:00',14.48),('6449','2013-04-14','15:00:00',14.31),('6449','2013-04-14','15:05:00',14.13),('6449','2013-04-14','15:10:00',13.93),('6449','2013-04-14','15:15:00',13.63),('6449','2013-04-14','15:20:00',13.55),('6449','2013-04-14','15:25:00',13.37),('6449','2013-04-14','15:30:00',13.26),('6449','2013-04-14','15:35:00',13.09),('6449','2013-04-14','15:40:00',12.84),('6449','2013-04-14','15:45:00',12.48),('6449','2013-04-14','15:50:00',12.25),('6449','2013-04-14','15:55:00',12.02),('6449','2013-04-14','16:00:00',11.71),('6449','2013-04-14','16:05:00',11.51),('6449','2013-04-14','16:10:00',11.19),('6449','2013-04-14','16:15:00',10.96),('6449','2013-04-14','16:20:00',10.64),('6449','2013-04-14','16:25:00',10.24),('6449','2013-04-14','16:30:00',9.85),('6449','2013-04-14','16:35:00',9.62),('6449','2013-04-14','16:40:00',9.28),('6449','2013-04-14','16:45:00',8.9),('6449','2013-04-14','16:50:00',8.58),('6449','2013-04-14','16:55:00',8.19),('6449','2013-04-14','17:00:00',7.83),('6449','2013-04-14','17:05:00',7.47),('6449','2013-04-14','17:10:00',7.11),('6449','2013-04-14','17:15:00',6.7),('6449','2013-04-14','17:20:00',6.37),('6449','2013-04-14','17:25:00',6.04),('6449','2013-04-14','17:30:00',5.65),('6449','2013-04-14','17:35:00',5.4),('6449','2013-04-14','17:40:00',4.99),('6449','2013-04-14','17:45:00',4.61),('6449','2013-04-14','17:50:00',4.3),('6449','2013-04-14','17:55:00',3.93),('6449','2013-04-14','18:00:00',3.53),('6449','2013-04-14','18:05:00',3.22),('6449','2013-04-14','18:10:00',2.88),('6449','2013-04-14','18:15:00',2.51),('6449','2013-04-14','18:20:00',2.25),('6449','2013-04-14','18:25:00',1.97),('6449','2013-04-14','18:30:00',1.7),('6449','2013-04-14','18:35:00',1.46),('6449','2013-04-14','18:40:00',1.23),('6449','2013-04-14','18:45:00',1),('6449','2013-04-13','07:30:00',1.13),('6449','2013-04-13','07:35:00',1.37),('6449','2013-04-13','07:40:00',1.28),('6449','2013-04-13','07:45:00',1.1),('6449','2013-04-13','07:50:00',1.53),('6449','2013-04-13','07:55:00',1.21),('6449','2013-04-13','08:00:00',1.01),('6449','2013-04-13','08:05:00',2.56),('6449','2013-04-13','08:10:00',3.86),('6449','2013-04-13','08:15:00',5.11),('6449','2013-04-13','08:20:00',5.53),('6449','2013-04-13','08:25:00',5.86),('6449','2013-04-13','08:30:00',6.15),('6449','2013-04-13','08:35:00',6.22),('6449','2013-04-13','08:40:00',6.52),('6449','2013-04-13','08:45:00',6.89),('6449','2013-04-13','08:50:00',7.49),('6449','2013-04-13','08:55:00',8.09),('6449','2013-04-13','09:00:00',9.42),('6449','2013-04-13','09:05:00',10.15),('6449','2013-04-13','09:10:00',10.61),('6449','2013-04-13','09:15:00',10.58),('6449','2013-04-13','09:20:00',3.78),('6449','2013-04-13','09:25:00',2.27),('6449','2013-04-13','09:30:00',1.92),('6449','2013-04-13','09:35:00',2.11),('6449','2013-04-13','09:40:00',10.29),('6449','2013-04-13','09:45:00',11.07),('6449','2013-04-13','09:50:00',10.47),('6449','2013-04-13','09:55:00',8.86),('6449','2013-04-13','10:00:00',12.18),('6449','2013-04-13','10:05:00',12.35),('6449','2013-04-13','10:10:00',12.55),('6449','2013-04-13','10:15:00',12.68),('6449','2013-04-13','10:20:00',12.43),('6449','2013-04-13','10:25:00',13.05),('6449','2013-04-13','10:30:00',13.49),('6449','2013-04-13','10:35:00',13.79),('6449','2013-04-13','10:40:00',13.63),('6449','2013-04-13','10:45:00',12.99),('6449','2013-04-13','10:50:00',14.12),('6449','2013-04-13','10:55:00',14.46),('6449','2013-04-13','11:00:00',14.46),('6449','2013-04-13','11:05:00',14.19),('6449','2013-04-13','11:10:00',14.84),('6449','2013-04-13','11:15:00',14.98),('6449','2013-04-13','11:20:00',14.87),('6449','2013-04-13','11:25:00',14.93),('6449','2013-04-13','11:30:00',14.53),('6449','2013-04-13','11:35:00',14.87),('6449','2013-04-13','11:40:00',15.47),('6449','2013-04-13','11:45:00',15.6),('6449','2013-04-13','11:50:00',15.65),('6449','2013-04-13','11:55:00',15.76),('6449','2013-04-13','12:00:00',15.93),('6449','2013-04-13','12:05:00',15.78),('6449','2013-04-13','12:10:00',16.29),('6449','2013-04-13','12:15:00',16.11),('6449','2013-04-13','12:20:00',16.23),('6449','2013-04-13','12:25:00',16.27),('6449','2013-04-13','12:30:00',16.42),('6449','2013-04-13','12:35:00',16.1),('6449','2013-04-13','12:40:00',16),('6449','2013-04-13','12:45:00',16.16),('6449','2013-04-13','12:50:00',15.65),('6449','2013-04-13','12:55:00',14.28),('6449','2013-04-13','13:00:00',13.96),('6449','2013-04-13','13:05:00',14.2),('6449','2013-04-13','13:10:00',14.59),('6449','2013-04-13','13:15:00',15.16),('6449','2013-04-13','13:20:00',14.43),('6449','2013-04-13','13:25:00',14.82),('6449','2013-04-13','13:30:00',14.36),('6449','2013-04-13','13:35:00',13.75),('6449','2013-04-13','13:40:00',13.23),('6449','2013-04-13','13:45:00',14.25),('6449','2013-04-13','13:50:00',14.02),('6449','2013-04-13','13:55:00',14.52),('6449','2013-04-13','14:00:00',14.43),('6449','2013-04-13','14:05:00',14.08),('6449','2013-04-13','14:10:00',13.61),('6449','2013-04-13','14:15:00',13.42),('6449','2013-04-13','14:20:00',13.14),('6449','2013-04-13','14:25:00',13.49),('6449','2013-04-13','14:30:00',13.78),('6449','2013-04-13','14:35:00',13.28),('6449','2013-04-13','14:40:00',13.45),('6449','2013-04-13','14:45:00',12.24),('6449','2013-04-13','14:50:00',11.7),('6449','2013-04-13','14:55:00',11.19),('6449','2013-04-13','15:00:00',11.11),('6449','2013-04-13','15:05:00',11.31),('6449','2013-04-13','15:10:00',11.59),('6449','2013-04-13','15:15:00',12.01),('6449','2013-04-13','15:20:00',11.52),('6449','2013-04-13','15:25:00',11.91),('6449','2013-04-13','15:30:00',11.36),('6449','2013-04-13','15:35:00',10.35),('6449','2013-04-13','15:40:00',11.09),('6449','2013-04-13','15:45:00',10.16),('6449','2013-04-13','15:50:00',9.91),('6449','2013-04-13','15:55:00',9.32),('6449','2013-04-13','16:00:00',9.78),('6449','2013-04-13','16:05:00',7.99),('6449','2013-04-13','16:10:00',6.88),('6449','2013-04-13','16:15:00',7.81),('6449','2013-04-13','16:20:00',7.23),('6449','2013-04-13','16:25:00',8.13),('6449','2013-04-13','16:30:00',8.41),('6449','2013-04-13','16:35:00',9),('6449','2013-04-13','16:40:00',8.51),('6449','2013-04-13','16:45:00',8.71),('6449','2013-04-13','16:50:00',8.68),('6449','2013-04-13','16:55:00',7.63),('6449','2013-04-13','17:00:00',4.31),('6449','2013-04-13','17:05:00',8.56),('6449','2013-04-13','17:10:00',3.99),('6449','2013-04-13','17:15:00',6.31),('6449','2013-04-13','17:20:00',6.02),('6449','2013-04-13','17:25:00',6.48),('6449','2013-04-13','17:30:00',6.23),('6449','2013-04-13','17:35:00',3.97),('6449','2013-04-13','17:40:00',5.27),('6449','2013-04-13','17:45:00',5.54),('6449','2013-04-13','17:50:00',3.14),('6449','2013-04-13','17:55:00',2.63),('6449','2013-04-13','18:00:00',2.42),('6449','2013-04-13','18:05:00',2.14),('6449','2013-04-13','18:10:00',1.64),('6449','2013-04-13','18:15:00',1.28),('6449','2013-04-13','18:20:00',2.59),('6449','2013-04-13','18:25:00',1.79),('6449','2013-04-13','18:30:00',1.62),('6449','2013-04-12','07:40:00',1.33),('6449','2013-04-12','07:45:00',1.34),('6449','2013-04-12','07:50:00',1.61),('6449','2013-04-12','07:55:00',1.06),('6449','2013-04-12','08:00:00',1.06),('6449','2013-04-12','08:05:00',1.22),('6449','2013-04-12','08:10:00',1.3),('6449','2013-04-12','08:15:00',1.42),('6449','2013-04-12','08:20:00',2.07),('6449','2013-04-12','08:25:00',1.93),('6449','2013-04-12','08:30:00',2.52),('6449','2013-04-12','08:35:00',1.63),('6449','2013-04-12','08:40:00',2.01),('6449','2013-04-12','08:45:00',2.65),('6449','2013-04-12','08:50:00',5.77),('6449','2013-04-12','08:55:00',3.96),('6449','2013-04-12','09:00:00',2.43),('6449','2013-04-12','09:05:00',3.34),('6449','2013-04-12','09:10:00',6.87),('6449','2013-04-12','09:15:00',2.91),('6449','2013-04-12','09:20:00',2.49),('6449','2013-04-12','09:25:00',6.73),('6449','2013-04-12','09:30:00',5.28),('6449','2013-04-12','09:35:00',4.32),('6449','2013-04-12','09:40:00',4.35),('6449','2013-04-12','09:45:00',9.36),('6449','2013-04-12','09:50:00',7.2),('6449','2013-04-12','09:55:00',3.42),('6449','2013-04-12','10:00:00',3.45),('6449','2013-04-12','10:05:00',2.65),('6449','2013-04-12','10:10:00',3.14),('6449','2013-04-12','10:15:00',2.73),('6449','2013-04-12','10:20:00',5.32),('6449','2013-04-12','10:25:00',6.21),('6449','2013-04-12','10:30:00',4.37),('6449','2013-04-12','10:35:00',5.54),('6449','2013-04-12','10:40:00',4.42),('6449','2013-04-12','10:45:00',6.2),('6449','2013-04-12','10:50:00',9.75),('6449','2013-04-12','10:55:00',6.95),('6449','2013-04-12','11:00:00',5.83),('6449','2013-04-12','11:05:00',8.08),('6449','2013-04-12','11:10:00',9.69),('6449','2013-04-12','11:15:00',14.4),('6449','2013-04-12','11:20:00',8.54),('6449','2013-04-12','11:25:00',10.65),('6449','2013-04-12','11:30:00',12.45),('6449','2013-04-12','11:35:00',10.91),('6449','2013-04-12','11:40:00',16.3),('6449','2013-04-12','11:45:00',11.8),('6449','2013-04-12','11:50:00',13.62),('6449','2013-04-12','11:55:00',9.72),('6449','2013-04-12','12:00:00',9.31),('6449','2013-04-12','12:05:00',10.07),('6449','2013-04-12','12:10:00',14.68),('6449','2013-04-12','12:15:00',7.59),('6449','2013-04-12','12:20:00',15.46),('6449','2013-04-12','12:25:00',18.05),('6449','2013-04-12','12:30:00',17.86),('6449','2013-04-12','12:35:00',18.32),('6449','2013-04-12','12:40:00',17.07),('6449','2013-04-12','12:45:00',16.94),('6449','2013-04-12','12:50:00',17.1),('6449','2013-04-12','12:55:00',17.15),('6449','2013-04-12','13:00:00',17),('6449','2013-04-12','13:05:00',17.1),('6449','2013-04-12','13:10:00',16.53),('6449','2013-04-12','13:15:00',16.84),('6449','2013-04-12','13:20:00',17.35),('6449','2013-04-12','13:25:00',17.41),('6449','2013-04-12','13:30:00',16.35),('6449','2013-04-12','13:35:00',15.26),('6449','2013-04-12','13:40:00',15.04),('6449','2013-04-12','13:45:00',14.02),('6449','2013-04-12','13:50:00',14.6),('6449','2013-04-12','13:55:00',15.75),('6449','2013-04-12','14:00:00',16.85),('6449','2013-04-12','14:05:00',16.37),('6449','2013-04-12','14:10:00',15.93),('6449','2013-04-12','14:15:00',15.64),('6449','2013-04-12','14:20:00',15.67),('6449','2013-04-12','14:25:00',15.07),('6449','2013-04-12','14:30:00',15.36),('6449','2013-04-12','14:35:00',15.19),('6449','2013-04-12','14:40:00',14.98),('6449','2013-04-12','14:45:00',14.81),('6449','2013-04-12','14:50:00',14.64),('6449','2013-04-12','14:55:00',14.01),('6449','2013-04-12','15:00:00',14.33),('6449','2013-04-12','15:05:00',14.16),('6449','2013-04-12','15:10:00',13.99),('6449','2013-04-12','15:15:00',13.85),('6449','2013-04-12','15:20:00',13.65),('6449','2013-04-12','15:25:00',13.36),('6449','2013-04-12','15:30:00',13.19),('6449','2013-04-12','15:35:00',12.91),('6449','2013-04-12','15:40:00',12.68),('6449','2013-04-12','15:45:00',12.41),('6449','2013-04-12','15:50:00',12.13),('6449','2013-04-12','15:55:00',11.92),('6449','2013-04-12','16:00:00',11.58),('6449','2013-04-12','16:05:00',11.21),('6449','2013-04-12','16:10:00',10.57),('6449','2013-04-12','16:15:00',9.8),('6449','2013-04-12','16:20:00',8.73),('6449','2013-04-12','16:25:00',8.95),('6449','2013-04-12','16:30:00',7.87),('6449','2013-04-12','16:35:00',7.91),('6449','2013-04-12','16:40:00',6.38),('6449','2013-04-12','16:45:00',7.25),('6449','2013-04-12','16:50:00',6.03),('6449','2013-04-12','16:55:00',4.82),('6449','2013-04-12','17:00:00',4.35),('6449','2013-04-12','17:05:00',3.93),('6449','2013-04-12','17:10:00',4),('6449','2013-04-12','17:15:00',4.38),('6449','2013-04-12','17:20:00',5.5),('6449','2013-04-12','17:25:00',6.78),('6449','2013-04-12','17:30:00',5.44),('6449','2013-04-12','17:35:00',3.38),('6449','2013-04-12','17:40:00',2.63),('6449','2013-04-12','17:45:00',2.56),('6449','2013-04-12','17:50:00',2.09),('6449','2013-04-12','17:55:00',1.62),('6449','2013-04-12','18:00:00',1.26),('6449','2013-04-12','18:05:00',1.02),('6449','2013-04-11','07:15:00',1.16),('6449','2013-04-11','07:20:00',1.62),('6449','2013-04-11','07:25:00',1.77),('6449','2013-04-11','07:30:00',1.86),('6449','2013-04-11','07:35:00',2.13),('6449','2013-04-11','07:40:00',2.43),('6449','2013-04-11','07:45:00',2.75),('6449','2013-04-11','07:50:00',3.08),('6449','2013-04-11','07:55:00',3.48),('6449','2013-04-11','08:00:00',3.77),('6449','2013-04-11','08:05:00',4.19),('6449','2013-04-11','08:10:00',4.5),('6449','2013-04-11','08:15:00',4.98),('6449','2013-04-11','08:20:00',5.34),('6449','2013-04-11','08:25:00',5.85),('6449','2013-04-11','08:30:00',6.17),('6449','2013-04-11','08:35:00',6.66),('6449','2013-04-11','08:40:00',7.01),('6449','2013-04-11','08:45:00',7.28),('6449','2013-04-11','08:50:00',7.71),('6449','2013-04-11','08:55:00',8.1),('6449','2013-04-11','09:00:00',8.44),('6449','2013-04-11','09:05:00',8.75),('6449','2013-04-11','09:10:00',9.08),('6449','2013-04-11','09:15:00',9.48),('6449','2013-04-11','09:20:00',9.79),('6449','2013-04-11','09:25:00',10.12),('6449','2013-04-11','09:30:00',10.43),('6449','2013-04-11','09:35:00',10.79),('6449','2013-04-11','09:40:00',11.14),('6449','2013-04-11','09:45:00',11.35),('6449','2013-04-11','09:50:00',11.81),('6449','2013-04-11','09:55:00',11.82),('6449','2013-04-11','10:00:00',10.85),('6449','2013-04-11','10:05:00',5.88),('6449','2013-04-11','10:10:00',10.37),('6449','2013-04-11','10:15:00',12.98),('6449','2013-04-11','10:20:00',9.04),('6449','2013-04-11','10:25:00',13.78),('6449','2013-04-11','10:30:00',9.89),('6449','2013-04-11','10:35:00',6.48),('6449','2013-04-11','10:40:00',4.65),('6449','2013-04-11','10:45:00',3.43),('6449','2013-04-11','10:50:00',8.34),('6449','2013-04-11','10:55:00',15.18),('6449','2013-04-11','11:00:00',15.1),('6449','2013-04-11','11:05:00',15.09),('6449','2013-04-11','11:10:00',15.19),('6449','2013-04-11','11:15:00',15.38),('6449','2013-04-11','11:20:00',15.46),('6449','2013-04-11','11:25:00',15.69),('6449','2013-04-11','11:30:00',15.76),('6449','2013-04-11','11:35:00',15.76),('6449','2013-04-11','11:40:00',16.01),('6449','2013-04-11','11:45:00',15.98),('6449','2013-04-11','11:50:00',16.22),('6449','2013-04-11','11:55:00',14.56),('6449','2013-04-11','12:00:00',14.89),('6449','2013-04-11','12:05:00',16.38),('6449','2013-04-11','12:10:00',16.41),('6449','2013-04-11','12:15:00',16.51),('6449','2013-04-11','12:20:00',16.5),('6449','2013-04-11','12:25:00',16.65),('6449','2013-04-11','12:30:00',16.66),('6449','2013-04-11','12:35:00',16.66),('6449','2013-04-11','12:40:00',16.61),('6449','2013-04-11','12:45:00',16.57),('6449','2013-04-11','12:50:00',16.6),('6449','2013-04-11','12:55:00',16.61),('6449','2013-04-11','13:00:00',16.6),('6449','2013-04-11','13:05:00',16.6),('6449','2013-04-11','13:10:00',16.59),('6449','2013-04-11','13:15:00',16.34),('6449','2013-04-11','13:20:00',16.31),('6449','2013-04-11','13:25:00',16.45),('6449','2013-04-11','13:30:00',16.27),('6449','2013-04-11','13:35:00',16.32),('6449','2013-04-11','13:40:00',16.28),('6449','2013-04-11','13:45:00',16.21),('6449','2013-04-11','13:50:00',15.84),('6449','2013-04-11','13:55:00',16.16),('6449','2013-04-11','14:00:00',16.06),('6449','2013-04-11','14:05:00',16.03),('6449','2013-04-11','14:10:00',15.91),('6449','2013-04-11','14:15:00',15.81),('6449','2013-04-11','14:20:00',15.72),('6449','2013-04-11','14:25:00',15.62),('6449','2013-04-11','14:30:00',15.51),('6449','2013-04-11','14:35:00',15.41),('6449','2013-04-11','14:40:00',15.27),('6449','2013-04-11','14:45:00',15.07),('6449','2013-04-11','14:50:00',14.94),('6449','2013-04-11','14:55:00',14.75),('6449','2013-04-11','15:00:00',14.55),('6449','2013-04-11','15:05:00',14.28),('6449','2013-04-11','15:10:00',14.24),('6449','2013-04-11','15:15:00',13.9),('6449','2013-04-11','15:20:00',13.84),('6449','2013-04-11','15:25:00',13.63),('6449','2013-04-11','15:30:00',13.47),('6449','2013-04-11','15:35:00',13.04),('6449','2013-04-11','15:40:00',13.08),('6449','2013-04-11','15:45:00',12.7),('6449','2013-04-11','15:50:00',12.57),('6449','2013-04-11','15:55:00',12.38),('6449','2013-04-11','16:00:00',12.02),('6449','2013-04-11','16:05:00',11.56),('6449','2013-04-11','16:10:00',11.46),('6449','2013-04-11','16:15:00',11.12),('6449','2013-04-11','16:20:00',10.9),('6449','2013-04-11','16:25:00',10.54),('6449','2013-04-11','16:30:00',10.24),('6449','2013-04-11','16:35:00',9.97),('6449','2013-04-11','16:40:00',9.52),('6449','2013-04-11','16:45:00',9.27),('6449','2013-04-11','16:50:00',8.87),('6449','2013-04-11','16:55:00',8.56),('6449','2013-04-11','17:00:00',8.16),('6449','2013-04-11','17:05:00',7.94),('6449','2013-04-11','17:10:00',7.47),('6449','2013-04-11','17:15:00',7.09),('6449','2013-04-11','17:20:00',6.65),('6449','2013-04-11','17:25:00',6.33),('6449','2013-04-11','17:30:00',5.97),('6449','2013-04-11','17:35:00',5.62),('6449','2013-04-11','17:40:00',5.06),('6449','2013-04-11','17:45:00',4.66),('6449','2013-04-11','17:50:00',4.31),('6449','2013-04-11','17:55:00',3.64),('6449','2013-04-11','18:00:00',3.11),('6449','2013-04-11','18:05:00',3.25),('6449','2013-04-11','18:10:00',2.99),('6449','2013-04-11','18:15:00',2.7),('6449','2013-04-11','18:20:00',2.31),('6449','2013-04-11','18:25:00',2),('6449','2013-04-11','18:30:00',1.67),('6449','2013-04-11','18:35:00',1.32),('6449','2013-04-10','08:25:00',1.95),('6449','2013-04-10','08:30:00',3.17),('6449','2013-04-10','08:35:00',6.33),('6449','2013-04-10','08:40:00',6.66),('6449','2013-04-10','08:45:00',7.26),('6449','2013-04-10','08:50:00',6.41),('6449','2013-04-10','08:55:00',3.08),('6449','2013-04-10','09:00:00',3.14),('6449','2013-04-10','09:05:00',1.78),('6449','2013-04-10','09:10:00',2.39),('6449','2013-04-10','09:15:00',1.53),('6449','2013-04-10','09:20:00',1.8),('6449','2013-04-10','09:25:00',2.31),('6449','2013-04-10','09:30:00',2.56),('6449','2013-04-10','09:35:00',3.65),('6449','2013-04-10','09:40:00',3.63),('6449','2013-04-10','09:45:00',2.17),('6449','2013-04-10','09:50:00',2.6),('6449','2013-04-10','09:55:00',2.05),('6449','2013-04-10','10:00:00',2.55),('6449','2013-04-10','10:05:00',4.9),('6449','2013-04-10','10:10:00',2.9),('6449','2013-04-10','10:15:00',4.47),('6449','2013-04-10','10:20:00',6.57),('6449','2013-04-10','10:25:00',5.92),('6449','2013-04-10','10:30:00',2.89),('6449','2013-04-10','10:35:00',11.09),('6449','2013-04-10','10:40:00',12.39),('6449','2013-04-10','10:45:00',11.37),('6449','2013-04-10','10:50:00',13.67),('6449','2013-04-10','10:55:00',11.7),('6449','2013-04-10','11:00:00',10.68),('6449','2013-04-10','11:05:00',12.84),('6449','2013-04-10','11:10:00',15.39),('6449','2013-04-10','11:15:00',14.68),('6449','2013-04-10','11:20:00',14.15),('6449','2013-04-10','11:25:00',15.47),('6449','2013-04-10','11:30:00',13.94),('6449','2013-04-10','11:35:00',12.47),('6449','2013-04-10','11:40:00',14.82),('6449','2013-04-10','11:45:00',15.07),('6449','2013-04-10','11:50:00',17.52),('6449','2013-04-10','11:55:00',14.33),('6449','2013-04-10','12:00:00',15.28),('6449','2013-04-10','12:05:00',14.15),('6449','2013-04-10','12:10:00',11.65),('6449','2013-04-10','12:15:00',15.51),('6449','2013-04-10','12:20:00',17.4),('6449','2013-04-10','12:25:00',10.91),('6449','2013-04-10','12:30:00',16.59),('6449','2013-04-10','12:35:00',17.14),('6449','2013-04-10','12:40:00',16.34),('6449','2013-04-10','12:45:00',17.05),('6449','2013-04-10','12:50:00',16.76),('6449','2013-04-10','12:55:00',17.38),('6449','2013-04-10','13:00:00',13.6),('6449','2013-04-10','13:05:00',16.72),('6449','2013-04-10','13:10:00',17.58),('6449','2013-04-10','13:15:00',15.88),('6449','2013-04-10','13:20:00',13.86),('6449','2013-04-10','13:25:00',16.82),('6449','2013-04-10','13:30:00',16.44),('6449','2013-04-10','13:35:00',16.65),('6449','2013-04-10','13:40:00',16.47),('6449','2013-04-10','13:45:00',16.62),('6449','2013-04-10','13:50:00',16.21),('6449','2013-04-10','13:55:00',16.11),('6449','2013-04-10','14:00:00',16),('6449','2013-04-10','14:05:00',15.51),('6449','2013-04-10','14:10:00',15.86),('6449','2013-04-10','14:15:00',15.74),('6449','2013-04-10','14:20:00',15.72),('6449','2013-04-10','14:25:00',15.64),('6449','2013-04-10','14:30:00',15.46),('6449','2013-04-10','14:35:00',15.29),('6449','2013-04-10','14:40:00',15.2),('6449','2013-04-10','14:45:00',15.09),('6449','2013-04-10','14:50:00',14.97),('6449','2013-04-10','14:55:00',14.79),('6449','2013-04-10','15:00:00',14.7),('6449','2013-04-10','15:05:00',14.51),('6449','2013-04-10','15:10:00',14.17),('6449','2013-04-10','15:15:00',13.75),('6449','2013-04-10','15:20:00',13.89),('6449','2013-04-10','15:25:00',13.68),('6449','2013-04-10','15:30:00',13.49),('6449','2013-04-10','15:35:00',13.21),('6449','2013-04-10','15:40:00',12.99),('6449','2013-04-10','15:45:00',12.8),('6449','2013-04-10','15:50:00',12.5),('6449','2013-04-10','15:55:00',12.16),('6449','2013-04-10','16:00:00',11.98),('6449','2013-04-10','16:05:00',11.76),('6449','2013-04-10','16:10:00',11.37),('6449','2013-04-10','16:15:00',11.22),('6449','2013-04-10','16:20:00',10.54),('6449','2013-04-10','16:25:00',10.47),('6449','2013-04-10','16:30:00',9.76),('6449','2013-04-10','16:35:00',9.76),('6449','2013-04-10','16:40:00',9.21),('6449','2013-04-10','16:45:00',8.83),('6449','2013-04-10','16:50:00',8.54),('6449','2013-04-10','16:55:00',8.58),('6449','2013-04-10','17:00:00',7.88),('6449','2013-04-10','17:05:00',7.53),('6449','2013-04-10','17:10:00',7.26),('6449','2013-04-10','17:15:00',6.45),('6449','2013-04-10','17:20:00',6.7),('6449','2013-04-10','17:25:00',6.45),('6449','2013-04-10','17:30:00',5.98),('6449','2013-04-10','17:35:00',5.52),('6449','2013-04-10','17:40:00',5.09),('6449','2013-04-10','17:45:00',4.84),('6449','2013-04-10','17:50:00',4.37),('6449','2013-04-10','17:55:00',3.92),('6449','2013-04-10','18:00:00',3.65),('6449','2013-04-10','18:05:00',3.17),('6449','2013-04-10','18:10:00',2.13),('6449','2013-04-10','18:15:00',1.44),('6449','2013-04-10','18:20:00',1.75),('6449','2013-04-10','18:25:00',1.55),('6449','2013-04-10','18:30:00',1.03),('6449','2013-04-10','18:35:00',1.22),('6449','2013-04-10','18:40:00',1.05),('6449','2013-04-09','07:25:00',1.03),('6449','2013-04-09','07:30:00',1.5),('6449','2013-04-09','07:35:00',1.69),('6449','2013-04-09','07:40:00',1.57),('6449','2013-04-09','07:45:00',1.36),('6449','2013-04-09','07:50:00',2.61),('6449','2013-04-09','07:55:00',2.34),('6449','2013-04-09','08:00:00',2.49),('6449','2013-04-09','08:05:00',1.27),('6449','2013-04-09','08:10:00',1.89),('6449','2013-04-09','08:15:00',1.27),('6449','2013-04-09','08:20:00',2.31),('6449','2013-04-09','08:25:00',5.14),('6449','2013-04-09','08:30:00',6.1),('6449','2013-04-09','08:35:00',5.06),('6449','2013-04-09','08:40:00',5.32),('6449','2013-04-09','08:45:00',7.51),('6449','2013-04-09','08:50:00',7.47),('6449','2013-04-09','08:55:00',6.56),('6449','2013-04-09','09:00:00',6.13),('6449','2013-04-09','09:05:00',7.26),('6449','2013-04-09','09:10:00',3.91),('6449','2013-04-09','09:15:00',4.73),('6449','2013-04-09','09:20:00',7.4),('6449','2013-04-09','09:25:00',10.68),('6449','2013-04-09','09:30:00',10.88),('6449','2013-04-09','09:35:00',11.15),('6449','2013-04-09','09:40:00',11.15),('6449','2013-04-09','09:45:00',11.72),('6449','2013-04-09','09:50:00',11.91),('6449','2013-04-09','09:55:00',12.17),('6449','2013-04-09','10:00:00',12.46),('6449','2013-04-09','10:05:00',12.76),('6449','2013-04-09','10:10:00',13.01),('6449','2013-04-09','10:15:00',12.36),('6449','2013-04-09','10:20:00',14.08),('6449','2013-04-09','10:25:00',12.83),('6449','2013-04-09','10:30:00',6.42),('6449','2013-04-09','10:35:00',9.67),('6449','2013-04-09','10:40:00',10.05),('6449','2013-04-09','10:45:00',15.36),('6449','2013-04-09','10:50:00',13.55),('6449','2013-04-09','10:55:00',12.35),('6449','2013-04-09','11:00:00',5.22),('6449','2013-04-09','11:05:00',13.11),('6449','2013-04-09','11:10:00',9.27),('6449','2013-04-09','11:15:00',15.7),('6449','2013-04-09','11:20:00',15.1),('6449','2013-04-09','11:25:00',9.45),('6449','2013-04-09','11:30:00',9),('6449','2013-04-09','11:35:00',9.17),('6449','2013-04-09','11:40:00',12.87),('6449','2013-04-09','11:45:00',14.49),('6449','2013-04-09','11:50:00',16.08),('6449','2013-04-09','11:55:00',10),('6449','2013-04-09','12:00:00',15.58),('6449','2013-04-09','12:05:00',17.4),('6449','2013-04-09','12:10:00',15.08),('6449','2013-04-09','12:15:00',17.33),('6449','2013-04-09','12:20:00',15.55),('6449','2013-04-09','12:25:00',14.87),('6449','2013-04-09','12:30:00',9.72),('6449','2013-04-09','12:35:00',15.23),('6449','2013-04-09','12:40:00',16.8),('6449','2013-04-09','12:45:00',14.34),('6449','2013-04-09','12:50:00',17.47),('6449','2013-04-09','12:55:00',16.4),('6449','2013-04-09','13:00:00',15.58),('6449','2013-04-09','13:05:00',16.38),('6449','2013-04-09','13:10:00',12.85),('6449','2013-04-09','13:15:00',13.97),('6449','2013-04-09','13:20:00',15.8),('6449','2013-04-09','13:25:00',14.64),('6449','2013-04-09','13:30:00',16.15),('6449','2013-04-09','13:35:00',16.66),('6449','2013-04-09','13:40:00',14.74),('6449','2013-04-09','13:45:00',13.27),('6449','2013-04-09','13:50:00',15.9),('6449','2013-04-09','13:55:00',15.99),('6449','2013-04-09','14:00:00',14.72),('6449','2013-04-09','14:05:00',14.3),('6449','2013-04-09','14:10:00',12.43),('6449','2013-04-09','14:15:00',13.72),('6449','2013-04-09','14:20:00',15.12),('6449','2013-04-09','14:25:00',15.2),('6449','2013-04-09','14:30:00',15.21),('6449','2013-04-09','14:35:00',13.76),('6449','2013-04-09','14:40:00',15.44),('6449','2013-04-09','14:45:00',13.12),('6449','2013-04-09','14:50:00',13.89),('6449','2013-04-09','14:55:00',14.58),('6449','2013-04-09','15:00:00',15.19),('6449','2013-04-09','15:05:00',13.83),('6449','2013-04-09','15:10:00',14.49),('6449','2013-04-09','15:15:00',14.59),('6449','2013-04-09','15:20:00',14.62),('6449','2013-04-09','15:25:00',11.98),('6449','2013-04-09','15:30:00',13.87),('6449','2013-04-09','15:35:00',12.58),('6449','2013-04-09','15:40:00',12.94),('6449','2013-04-09','15:45:00',11.2),('6449','2013-04-09','15:50:00',12.6),('6449','2013-04-09','15:55:00',12.82),('6449','2013-04-09','16:00:00',12.05),('6449','2013-04-09','16:05:00',11.39),('6449','2013-04-09','16:10:00',11.7),('6449','2013-04-09','16:15:00',9.69),('6449','2013-04-09','16:20:00',8.76),('6449','2013-04-09','16:25:00',9.31),('6449','2013-04-09','16:30:00',9.52),('6449','2013-04-09','16:35:00',10.37),('6449','2013-04-09','16:40:00',9.42),('6449','2013-04-09','16:45:00',8.26),('6449','2013-04-09','16:50:00',9.54),('6449','2013-04-09','16:55:00',8.99),('6449','2013-04-09','17:00:00',8.5),('6449','2013-04-09','17:05:00',7.51),('6449','2013-04-09','17:10:00',7.57),('6449','2013-04-09','17:15:00',6.36),('6449','2013-04-09','17:20:00',5.85),('6449','2013-04-09','17:25:00',4.9),('6449','2013-04-09','17:30:00',4.84),('6449','2013-04-09','17:35:00',4.26),('6449','2013-04-09','17:40:00',3.37),('6449','2013-04-09','17:45:00',3.67),('6449','2013-04-09','17:50:00',4.78),('6449','2013-04-09','17:55:00',4.22),('6449','2013-04-09','18:00:00',3.99),('6449','2013-04-09','18:05:00',2.84),('6449','2013-04-09','18:10:00',1.93),('6449','2013-04-09','18:15:00',1.73),('6449','2013-04-09','18:20:00',1.8),('6449','2013-04-09','18:25:00',1.57),('6449','2013-04-09','18:30:00',1.31),('6449','2013-04-09','18:35:00',1.19),('6449','2013-04-09','18:40:00',1.1),('6449','2013-04-09','18:45:00',1.25),('6449','2013-04-09','18:50:00',1.03),('6449','2013-04-08','07:25:00',1.32),('6449','2013-04-08','07:30:00',1.16),('6449','2013-04-08','07:35:00',1),('6449','2013-04-08','07:40:00',1.16),('6449','2013-04-08','07:45:00',1.78),('6449','2013-04-08','07:50:00',2.69),('6449','2013-04-08','07:55:00',2.15),('6449','2013-04-08','08:00:00',1.48),('6449','2013-04-08','08:05:00',1.79),('6449','2013-04-08','08:10:00',2.26),('6449','2013-04-08','08:15:00',3.33),('6449','2013-04-08','08:20:00',5.17),('6449','2013-04-08','08:25:00',5.77),('6449','2013-04-08','08:30:00',5.81),('6449','2013-04-08','08:35:00',6.48),('6449','2013-04-08','08:40:00',7.02),('6449','2013-04-08','08:45:00',7.5),('6449','2013-04-08','08:50:00',7.93),('6449','2013-04-08','08:55:00',7.73),('6449','2013-04-08','09:00:00',8.26),('6449','2013-04-08','09:05:00',9.18),('6449','2013-04-08','09:10:00',9.35),('6449','2013-04-08','09:15:00',10.12),('6449','2013-04-08','09:20:00',10.83),('6449','2013-04-08','09:25:00',10.69),('6449','2013-04-08','09:30:00',11.65),('6449','2013-04-08','09:35:00',9.92),('6449','2013-04-08','09:40:00',5.55),('6449','2013-04-08','09:45:00',10.62),('6449','2013-04-08','09:50:00',12.52),('6449','2013-04-08','09:55:00',11.16),('6449','2013-04-08','10:00:00',12.88),('6449','2013-04-08','10:05:00',13.42),('6449','2013-04-08','10:10:00',12.49),('6449','2013-04-08','10:15:00',11.72),('6449','2013-04-08','10:20:00',13.02),('6449','2013-04-08','10:25:00',13.33),('6449','2013-04-08','10:30:00',12.57),('6449','2013-04-08','10:35:00',13.62),('6449','2013-04-08','10:40:00',12.87),('6449','2013-04-08','10:45:00',11.75),('6449','2013-04-08','10:50:00',12.69),('6449','2013-04-08','10:55:00',10.8),('6449','2013-04-08','11:00:00',8.91),('6449','2013-04-08','11:05:00',8.78),('6449','2013-04-08','11:10:00',7.55),('6449','2013-04-08','11:15:00',9.06),('6449','2013-04-08','11:20:00',11.19),('6449','2013-04-08','11:25:00',13.12),('6449','2013-04-08','11:30:00',10.81),('6449','2013-04-08','11:35:00',11.75),('6449','2013-04-08','11:40:00',13.17),('6449','2013-04-08','11:45:00',14.14),('6449','2013-04-08','11:50:00',12.43),('6449','2013-04-08','11:55:00',11.51),('6449','2013-04-08','12:00:00',13.5),('6449','2013-04-08','12:05:00',13.55),('6449','2013-04-08','12:10:00',11.92),('6449','2013-04-08','12:15:00',12.75),('6449','2013-04-08','12:20:00',11.53),('6449','2013-04-08','12:25:00',11.19),('6449','2013-04-08','12:30:00',12.77),('6449','2013-04-08','12:35:00',12.73),('6449','2013-04-08','12:40:00',11.89),('6449','2013-04-08','12:45:00',13.6),('6449','2013-04-08','12:50:00',14.13),('6449','2013-04-08','12:55:00',12.39),('6449','2013-04-08','13:00:00',12.71),('6449','2013-04-08','13:05:00',12.53),('6449','2013-04-08','13:10:00',13.62),('6449','2013-04-08','13:15:00',13.38),('6449','2013-04-08','13:20:00',15.06),('6449','2013-04-08','13:25:00',12.35),('6449','2013-04-08','13:30:00',11.79),('6449','2013-04-08','13:35:00',12.45),('6449','2013-04-08','13:40:00',14.18),('6449','2013-04-08','13:45:00',16.24),('6449','2013-04-08','13:50:00',12.67),('6449','2013-04-08','13:55:00',11.99),('6449','2013-04-08','14:00:00',13.94),('6449','2013-04-08','14:05:00',13.52),('6449','2013-04-08','14:10:00',13.45),('6449','2013-04-08','14:15:00',13.56),('6449','2013-04-08','14:20:00',12.79),('6449','2013-04-08','14:25:00',14.3),('6449','2013-04-08','14:30:00',14.37),('6449','2013-04-08','14:35:00',14.67),('6449','2013-04-08','14:40:00',12.91),('6449','2013-04-08','14:45:00',12.94),('6449','2013-04-08','14:50:00',10.34),('6449','2013-04-08','14:55:00',10.59),('6449','2013-04-08','15:00:00',12.55),('6449','2013-04-08','15:05:00',12.21),('6449','2013-04-08','15:10:00',8.83),('6449','2013-04-08','15:15:00',14.1),('6449','2013-04-08','15:20:00',14.34),('6449','2013-04-08','15:25:00',13.86),('6449','2013-04-08','15:30:00',13.4),('6449','2013-04-08','15:35:00',13.29),('6449','2013-04-08','15:40:00',13.18),('6449','2013-04-08','15:45:00',10.24),('6449','2013-04-08','15:50:00',9.07),('6449','2013-04-08','15:55:00',11.92),('6449','2013-04-08','16:00:00',12.06),('6449','2013-04-08','16:05:00',11.71),('6449','2013-04-08','16:10:00',11.4),('6449','2013-04-08','16:15:00',10.83),('6449','2013-04-08','16:20:00',10.77),('6449','2013-04-08','16:25:00',10.48),('6449','2013-04-08','16:30:00',10.13),('6449','2013-04-08','16:35:00',9.83),('6449','2013-04-08','16:40:00',9.7),('6449','2013-04-08','16:45:00',9.38),('6449','2013-04-08','16:50:00',8.88),('6449','2013-04-08','16:55:00',8.46),('6449','2013-04-08','17:00:00',7.86),('6449','2013-04-08','17:05:00',7.83),('6449','2013-04-08','17:10:00',7.04),('6449','2013-04-08','17:15:00',6.98),('6449','2013-04-08','17:20:00',5.35),('6449','2013-04-08','17:25:00',5.57),('6449','2013-04-08','17:30:00',5.43),('6449','2013-04-08','17:35:00',4.99),('6449','2013-04-08','17:40:00',4.36),('6449','2013-04-08','17:45:00',3.49),('6449','2013-04-08','17:50:00',2.64),('6449','2013-04-08','17:55:00',2.17),('6449','2013-04-08','18:00:00',4.46),('6449','2013-04-08','18:05:00',4.98),('6449','2013-04-08','18:10:00',3.88),('6449','2013-04-08','18:15:00',2.49),('6449','2013-04-08','18:20:00',2.24),('6449','2013-04-08','18:25:00',2.07),('6449','2013-04-08','18:30:00',1.3),('6449','2013-04-08','18:35:00',1.03),('6449','2013-04-07','07:25:00',1.09),('6449','2013-04-07','07:30:00',1.46),('6449','2013-04-07','07:35:00',1.84),('6449','2013-04-07','07:40:00',2.21),('6449','2013-04-07','07:45:00',2.68),('6449','2013-04-07','07:50:00',3.07),('6449','2013-04-07','07:55:00',3.46),('6449','2013-04-07','08:00:00',3.89),('6449','2013-04-07','08:05:00',4.27),('6449','2013-04-07','08:10:00',4.6),('6449','2013-04-07','08:15:00',5.04),('6449','2013-04-07','08:20:00',5.41),('6449','2013-04-07','08:25:00',5.67),('6449','2013-04-07','08:30:00',5.97),('6449','2013-04-07','08:35:00',6.26),('6449','2013-04-07','08:40:00',6.44),('6449','2013-04-07','08:45:00',6.78),('6449','2013-04-07','08:50:00',7.13),('6449','2013-04-07','08:55:00',7.29),('6449','2013-04-07','09:00:00',7.24),('6449','2013-04-07','09:05:00',7.27),('6449','2013-04-07','09:10:00',7.49),('6449','2013-04-07','09:15:00',8.06),('6449','2013-04-07','09:20:00',8.86),('6449','2013-04-07','09:25:00',9.18),('6449','2013-04-07','09:30:00',9.12),('6449','2013-04-07','09:35:00',9.46),('6449','2013-04-07','09:40:00',9.6),('6449','2013-04-07','09:45:00',9.81),('6449','2013-04-07','09:50:00',10.36),('6449','2013-04-07','09:55:00',10.48),('6449','2013-04-07','10:00:00',10.35),('6449','2013-04-07','10:05:00',10.5),('6449','2013-04-07','10:10:00',10.92),('6449','2013-04-07','10:15:00',11.84),('6449','2013-04-07','10:20:00',12.05),('6449','2013-04-07','10:25:00',12.16),('6449','2013-04-07','10:30:00',11.96),('6449','2013-04-07','10:35:00',12.09),('6449','2013-04-07','10:40:00',12.34),('6449','2013-04-07','10:45:00',13.12),('6449','2013-04-07','10:50:00',13.89),('6449','2013-04-07','10:55:00',13.82),('6449','2013-04-07','11:00:00',13.45),('6449','2013-04-07','11:05:00',13.88),('6449','2013-04-07','11:10:00',14.45),('6449','2013-04-07','11:15:00',14.06),('6449','2013-04-07','11:20:00',14.44),('6449','2013-04-07','11:25:00',14.52),('6449','2013-04-07','11:30:00',11.16),('6449','2013-04-07','11:35:00',13.09),('6449','2013-04-07','11:40:00',13),('6449','2013-04-07','11:45:00',13.44),('6449','2013-04-07','11:50:00',11.62),('6449','2013-04-07','11:55:00',11.8),('6449','2013-04-07','12:00:00',13.64),('6449','2013-04-07','12:05:00',14.56),('6449','2013-04-07','12:10:00',14.02),('6449','2013-04-07','12:15:00',13.03),('6449','2013-04-07','12:20:00',12.03),('6449','2013-04-07','12:25:00',12.18),('6449','2013-04-07','12:30:00',12.09),('6449','2013-04-07','12:35:00',11.66),('6449','2013-04-07','12:40:00',11.75),('6449','2013-04-07','12:45:00',10.45),('6449','2013-04-07','12:50:00',10.8),('6449','2013-04-07','12:55:00',11.13),('6449','2013-04-07','13:00:00',10.77),('6449','2013-04-07','13:05:00',10.15),('6449','2013-04-07','13:10:00',10.03),('6449','2013-04-07','13:15:00',10.12),('6449','2013-04-07','13:20:00',10.49),('6449','2013-04-07','13:25:00',10.49),('6449','2013-04-07','13:30:00',10.62),('6449','2013-04-07','13:35:00',10.95),('6449','2013-04-07','13:40:00',11.31),('6449','2013-04-07','13:45:00',11.26),('6449','2013-04-07','13:50:00',11.43),('6449','2013-04-07','13:55:00',11.72),('6449','2013-04-07','14:00:00',12.01),('6449','2013-04-07','14:05:00',12.2),('6449','2013-04-07','14:10:00',12.97),('6449','2013-04-07','14:15:00',12.62),('6449','2013-04-07','14:20:00',12.2),('6449','2013-04-07','14:25:00',11.14),('6449','2013-04-07','14:30:00',10.54),('6449','2013-04-07','14:35:00',9.85),('6449','2013-04-07','14:40:00',9.47),('6449','2013-04-07','14:45:00',9.54),('6449','2013-04-07','14:50:00',10.57),('6449','2013-04-07','14:55:00',11.51),('6449','2013-04-07','15:00:00',11.51),('6449','2013-04-07','15:05:00',11.99),('6449','2013-04-07','15:10:00',12.34),('6449','2013-04-07','15:15:00',12.79),('6449','2013-04-07','15:20:00',13.31),('6449','2013-04-07','15:25:00',13.69),('6449','2013-04-07','15:30:00',13.79),('6449','2013-04-07','15:35:00',13.98),('6449','2013-04-07','15:40:00',13.76),('6449','2013-04-07','15:45:00',13.5),('6449','2013-04-07','15:50:00',13.3),('6449','2013-04-07','15:55:00',12.89),('6449','2013-04-07','16:00:00',12.63),('6449','2013-04-07','16:05:00',12.49),('6449','2013-04-07','16:10:00',12.06),('6449','2013-04-07','16:15:00',11.58),('6449','2013-04-07','16:20:00',11.43),('6449','2013-04-07','16:25:00',11.1),('6449','2013-04-07','16:30:00',10.64),('6449','2013-04-07','16:35:00',10.38),('6449','2013-04-07','16:40:00',9.96),('6449','2013-04-07','16:45:00',9.48),('6449','2013-04-07','16:50:00',9.14),('6449','2013-04-07','16:55:00',8.73),('6449','2013-04-07','17:00:00',8.11),('6449','2013-04-07','17:05:00',4.54),('6449','2013-04-07','17:10:00',3.46),('6449','2013-04-07','17:15:00',1.76),('6449','2013-04-07','17:20:00',1.53),('6449','2013-04-07','17:25:00',1.4),('6449','2013-04-07','17:30:00',1.24),('6449','2013-04-07','17:35:00',1.11),('6449','2013-04-07','17:40:00',1.02),('6449','2013-04-06','07:25:00',1.21),('6449','2013-04-06','07:30:00',1.42),('6449','2013-04-06','07:35:00',1.79),('6449','2013-04-06','07:40:00',2.11),('6449','2013-04-06','07:45:00',2.21),('6449','2013-04-06','07:50:00',2.72),('6449','2013-04-06','07:55:00',3.22),('6449','2013-04-06','08:00:00',3.65),('6449','2013-04-06','08:05:00',4.08),('6449','2013-04-06','08:10:00',4.42),('6449','2013-04-06','08:15:00',4.84),('6449','2013-04-06','08:20:00',5.22),('6449','2013-04-06','08:25:00',5.63),('6449','2013-04-06','08:30:00',6.01),('6449','2013-04-06','08:35:00',6.45),('6449','2013-04-06','08:40:00',6.83),('6449','2013-04-06','08:45:00',7.2),('6449','2013-04-06','08:50:00',7.54),('6449','2013-04-06','08:55:00',8.06),('6449','2013-04-06','09:00:00',8.38),('6449','2013-04-06','09:05:00',8.71),('6449','2013-04-06','09:10:00',9.07),('6449','2013-04-06','09:15:00',9.47),('6449','2013-04-06','09:20:00',10.02),('6449','2013-04-06','09:25:00',10.26),('6449','2013-04-06','09:30:00',11.33),('6449','2013-04-06','09:35:00',11.42),('6449','2013-04-06','09:40:00',11.24),('6449','2013-04-06','09:45:00',11.63),('6449','2013-04-06','09:50:00',11.15),('6449','2013-04-06','09:55:00',10.66),('6449','2013-04-06','10:00:00',12.86),('6449','2013-04-06','10:05:00',12.67),('6449','2013-04-06','10:10:00',12.1),('6449','2013-04-06','10:15:00',11.59),('6449','2013-04-06','10:20:00',13.1),('6449','2013-04-06','10:25:00',13.41),('6449','2013-04-06','10:30:00',13.67),('6449','2013-04-06','10:35:00',13.79),('6449','2013-04-06','10:40:00',13.05),('6449','2013-04-06','10:45:00',14.24),('6449','2013-04-06','10:50:00',15.06),('6449','2013-04-06','10:55:00',14.7),('6449','2013-04-06','11:00:00',15.04),('6449','2013-04-06','11:05:00',14.74),('6449','2013-04-06','11:10:00',10.28),('6449','2013-04-06','11:15:00',5.32),('6449','2013-04-06','11:20:00',8.45),('6449','2013-04-06','11:25:00',12.23),('6449','2013-04-06','11:30:00',10.27),('6449','2013-04-06','11:35:00',16.45),('6449','2013-04-06','11:40:00',16.04),('6449','2013-04-06','11:45:00',16.03),('6449','2013-04-06','11:50:00',16.13),('6449','2013-04-06','11:55:00',16.03),('6449','2013-04-06','12:00:00',16.18),('6449','2013-04-06','12:05:00',16.2),('6449','2013-04-06','12:10:00',16.21),('6449','2013-04-06','12:15:00',16.34),('6449','2013-04-06','12:20:00',16.51),('6449','2013-04-06','12:25:00',16.45),('6449','2013-04-06','12:30:00',16.58),('6449','2013-04-06','12:35:00',16.58),('6449','2013-04-06','12:40:00',16.25),('6449','2013-04-06','12:45:00',16.71),('6449','2013-04-06','12:50:00',16.73),('6449','2013-04-06','12:55:00',16.57),('6449','2013-04-06','13:00:00',16.77),('6449','2013-04-06','13:05:00',16.81),('6449','2013-04-06','13:10:00',16.81),('6449','2013-04-06','13:15:00',16.78),('6449','2013-04-06','13:20:00',16.82),('6449','2013-04-06','13:25:00',16.77),('6449','2013-04-06','13:30:00',16.72),('6449','2013-04-06','13:35:00',16.65),('6449','2013-04-06','13:40:00',16.52),('6449','2013-04-06','13:45:00',16.41),('6449','2013-04-06','13:50:00',16.25),('6449','2013-04-06','13:55:00',15.93),('6449','2013-04-06','14:00:00',16.05),('6449','2013-04-06','14:05:00',15.93),('6449','2013-04-06','14:10:00',15.82),('6449','2013-04-06','14:15:00',15.82),('6449','2013-04-06','14:20:00',15.72),('6449','2013-04-06','14:25:00',15.43),('6449','2013-04-06','14:30:00',15.54),('6449','2013-04-06','14:35:00',15.43),('6449','2013-04-06','14:40:00',15.14),('6449','2013-04-06','14:45:00',15.29),('6449','2013-04-06','14:50:00',15.14),('6449','2013-04-06','14:55:00',14.89),('6449','2013-04-06','15:00:00',14.71),('6449','2013-04-06','15:05:00',14.43),('6449','2013-04-06','15:10:00',14.13),('6449','2013-04-06','15:15:00',13.75),('6449','2013-04-06','15:20:00',13.65),('6449','2013-04-06','15:25:00',13.99),('6449','2013-04-06','15:30:00',13.67),('6449','2013-04-06','15:35:00',13.23),('6449','2013-04-06','15:40:00',11.69),('6449','2013-04-06','15:45:00',11.14),('6449','2013-04-06','15:50:00',10.86),('6449','2013-04-06','15:55:00',11.52),('6449','2013-04-06','16:00:00',12.45),('6449','2013-04-06','16:05:00',12.21),('6449','2013-04-06','16:10:00',11.72),('6449','2013-04-06','16:15:00',10.69),('6449','2013-04-06','16:20:00',11.14),('6449','2013-04-06','16:25:00',10.48),('6449','2013-04-06','16:30:00',9.79),('6449','2013-04-06','16:35:00',8.85),('6449','2013-04-06','16:40:00',7.45),('6449','2013-04-06','16:45:00',5.38),('6449','2013-04-06','16:50:00',7.69),('6449','2013-04-06','16:55:00',9.28),('6449','2013-04-06','17:00:00',9.07),('6449','2013-04-06','17:05:00',7.65),('6449','2013-04-06','17:10:00',6.14),('6449','2013-04-06','17:15:00',6.85),('6449','2013-04-06','17:20:00',8.03),('6449','2013-04-06','17:25:00',6.93),('6449','2013-04-06','17:30:00',5.04),('6449','2013-04-06','17:35:00',4.23),('6449','2013-04-06','17:40:00',3.8),('6449','2013-04-06','17:45:00',3.22),('6449','2013-04-06','17:50:00',2.96),('6449','2013-04-06','17:55:00',2.82),('6449','2013-04-06','18:00:00',2.46),('6449','2013-04-06','18:05:00',2.4),('6449','2013-04-06','18:10:00',2.18),('6449','2013-04-06','18:15:00',2.08),('6449','2013-04-06','18:20:00',1.87),('6449','2013-04-06','18:25:00',1.54),('6449','2013-04-06','18:30:00',1.32),('6449','2013-04-06','18:35:00',1.16),('6449','2013-04-06','18:40:00',1.02),('6449','2013-04-05','07:50:00',1.34),('6449','2013-04-05','07:55:00',1.39),('6449','2013-04-05','08:00:00',1.47),('6449','2013-04-05','08:05:00',2.53),('6449','2013-04-05','08:10:00',3.11),('6449','2013-04-05','08:15:00',2.68),('6449','2013-04-05','08:20:00',3.39),('6449','2013-04-05','08:25:00',4.99),('6449','2013-04-05','08:30:00',3.78),('6449','2013-04-05','08:35:00',3.32),('6449','2013-04-05','08:40:00',6.57),('6449','2013-04-05','08:45:00',8.8),('6449','2013-04-05','08:50:00',7.32),('6449','2013-04-05','08:55:00',8.78),('6449','2013-04-05','09:00:00',5.64),('6449','2013-04-05','09:05:00',8.47),('6449','2013-04-05','09:10:00',7.75),('6449','2013-04-05','09:15:00',7.26),('6449','2013-04-05','09:20:00',7.14),('6449','2013-04-05','09:25:00',10.16),('6449','2013-04-05','09:30:00',7.96),('6449','2013-04-05','09:35:00',2.87),('6449','2013-04-05','09:40:00',3.84),('6449','2013-04-05','09:45:00',6.13),('6449','2013-04-05','09:50:00',8.16),('6449','2013-04-05','09:55:00',12.61),('6449','2013-04-05','10:00:00',11.4),('6449','2013-04-05','10:05:00',12.54),('6449','2013-04-05','10:10:00',13.05),('6449','2013-04-05','10:15:00',13.07),('6449','2013-04-05','10:20:00',13.31),('6449','2013-04-05','10:25:00',13.5),('6449','2013-04-05','10:30:00',13.73),('6449','2013-04-05','10:35:00',13.81),('6449','2013-04-05','10:40:00',14.16),('6449','2013-04-05','10:45:00',14.39),('6449','2013-04-05','10:50:00',14.64),('6449','2013-04-05','10:55:00',14.81),('6449','2013-04-05','11:00:00',15.04),('6449','2013-04-05','11:05:00',14.87),('6449','2013-04-05','11:10:00',10.71),('6449','2013-04-05','11:15:00',11.85),('6449','2013-04-05','11:20:00',11.4),('6449','2013-04-05','11:25:00',15.52),('6449','2013-04-05','11:30:00',16.51),('6449','2013-04-05','11:35:00',16.54),('6449','2013-04-05','11:40:00',16.25),('6449','2013-04-05','11:45:00',16.4),('6449','2013-04-05','11:50:00',16.23),('6449','2013-04-05','11:55:00',16.45),('6449','2013-04-05','12:00:00',16.53),('6449','2013-04-05','12:05:00',17.01),('6449','2013-04-05','12:10:00',16.47),('6449','2013-04-05','12:15:00',11.92),('6449','2013-04-05','12:20:00',13.45),('6449','2013-04-05','12:25:00',18.19),('6449','2013-04-05','12:30:00',13.5),('6449','2013-04-05','12:35:00',8.03),('6449','2013-04-05','12:40:00',16.02),('6449','2013-04-05','12:45:00',16.9),('6449','2013-04-05','12:50:00',11.64),('6449','2013-04-05','12:55:00',13.37),('6449','2013-04-05','13:00:00',16.29),('6449','2013-04-05','13:05:00',16.75),('6449','2013-04-05','13:10:00',17.01),('6449','2013-04-05','13:15:00',16.98),('6449','2013-04-05','13:20:00',17.01),('6449','2013-04-05','13:25:00',17.09),('6449','2013-04-05','13:30:00',8.52),('6449','2013-04-05','13:35:00',8.77),('6449','2013-04-05','13:40:00',14.57),('6449','2013-04-05','13:45:00',17.74),('6449','2013-04-05','13:50:00',8.29),('6449','2013-04-05','13:55:00',6.2),('6449','2013-04-05','14:00:00',6.8),('6449','2013-04-05','14:05:00',5.58),('6449','2013-04-05','14:10:00',4.76),('6449','2013-04-05','14:15:00',4.31),('6449','2013-04-05','14:20:00',3.77),('6449','2013-04-05','14:25:00',3.88),('6449','2013-04-05','14:30:00',4.15),('6449','2013-04-05','14:35:00',3.95),('6449','2013-04-05','14:40:00',5.52),('6449','2013-04-05','14:45:00',5.07),('6449','2013-04-05','14:50:00',3.96),('6449','2013-04-05','14:55:00',5.46),('6449','2013-04-05','15:00:00',5.04),('6449','2013-04-05','15:05:00',4.96),('6449','2013-04-05','15:10:00',6.36),('6449','2013-04-05','15:15:00',4.68),('6449','2013-04-05','15:20:00',6.58),('6449','2013-04-05','15:25:00',5.6),('6449','2013-04-05','15:30:00',5.83),('6449','2013-04-05','15:35:00',4.41),('6449','2013-04-05','15:40:00',3.91),('6449','2013-04-05','15:45:00',4.5),('6449','2013-04-05','15:50:00',4.31),('6449','2013-04-05','15:55:00',10.91),('6449','2013-04-05','16:00:00',12.02),('6449','2013-04-05','16:05:00',13.45),('6449','2013-04-05','16:10:00',12.58),('6449','2013-04-05','16:15:00',12),('6449','2013-04-05','16:20:00',11.19),('6449','2013-04-05','16:25:00',9.81),('6449','2013-04-05','16:30:00',10.17),('6449','2013-04-05','16:35:00',10.02),('6449','2013-04-05','16:40:00',9.55),('6449','2013-04-05','16:45:00',9.33),('6449','2013-04-05','16:50:00',8.97),('6449','2013-04-05','16:55:00',8.62),('6449','2013-04-05','17:00:00',7.92),('6449','2013-04-05','17:05:00',8.47),('6449','2013-04-05','17:10:00',7.76),('6449','2013-04-05','17:15:00',6.82),('6449','2013-04-05','17:20:00',6.77),('6449','2013-04-05','17:25:00',6.24),('6449','2013-04-05','17:30:00',5.89),('6449','2013-04-05','17:35:00',5.47),('6449','2013-04-05','17:40:00',5.1),('6449','2013-04-05','17:45:00',4.75),('6449','2013-04-05','17:50:00',4.41),('6449','2013-04-05','17:55:00',3.94),('6449','2013-04-05','18:00:00',3.57),('6449','2013-04-05','18:05:00',3.15),('6449','2013-04-05','18:10:00',2.84),('6449','2013-04-05','18:15:00',2.48),('6449','2013-04-05','18:20:00',2.14),('6449','2013-04-05','18:25:00',1.82),('6449','2013-04-05','18:30:00',1.54),('6449','2013-04-05','18:35:00',1.25),('6449','2013-04-05','18:40:00',1),('6449','2013-04-04','08:00:00',1.32),('6449','2013-04-04','08:05:00',1.49),('6449','2013-04-04','08:10:00',1.79),('6449','2013-04-04','08:15:00',2.07),('6449','2013-04-04','08:20:00',2.28),('6449','2013-04-04','08:25:00',2.61),('6449','2013-04-04','08:30:00',2.29),('6449','2013-04-04','08:35:00',2.94),('6449','2013-04-04','08:40:00',3.27),('6449','2013-04-04','08:45:00',3),('6449','2013-04-04','08:50:00',2.53),('6449','2013-04-04','08:55:00',2.63),('6449','2013-04-04','09:00:00',2.85),('6449','2013-04-04','09:05:00',2.63),('6449','2013-04-04','09:10:00',1.74),('6449','2013-04-04','09:15:00',1.4),('6449','2013-04-04','09:20:00',1.67),('6449','2013-04-04','09:25:00',2.18),('6449','2013-04-04','09:30:00',2.71),('6449','2013-04-04','09:35:00',3.41),('6449','2013-04-04','09:40:00',4.1),('6449','2013-04-04','09:45:00',3.95),('6449','2013-04-04','09:50:00',3.89),('6449','2013-04-04','09:55:00',3.9),('6449','2013-04-04','10:00:00',3.68),('6449','2013-04-04','10:05:00',4.74),('6449','2013-04-04','10:10:00',7.22),('6449','2013-04-04','10:15:00',6.68),('6449','2013-04-04','10:20:00',6.38),('6449','2013-04-04','10:25:00',5.78),('6449','2013-04-04','10:30:00',4.87),('6449','2013-04-04','10:35:00',5.72),('6449','2013-04-04','10:40:00',8.02),('6449','2013-04-04','10:45:00',8.02),('6449','2013-04-04','10:50:00',5.21),('6449','2013-04-04','10:55:00',4.43),('6449','2013-04-04','11:00:00',3.36),('6449','2013-04-04','11:05:00',3.19),('6449','2013-04-04','11:10:00',3.02),('6449','2013-04-04','11:15:00',2.65),('6449','2013-04-04','11:20:00',3.41),('6449','2013-04-04','11:25:00',4.27),('6449','2013-04-04','11:30:00',6.24),('6449','2013-04-04','11:35:00',7.86),('6449','2013-04-04','11:40:00',6.83),('6449','2013-04-04','11:45:00',6.53),('6449','2013-04-04','11:50:00',8.03),('6449','2013-04-04','11:55:00',11.44),('6449','2013-04-04','12:00:00',14.28),('6449','2013-04-04','12:05:00',12.99),('6449','2013-04-04','12:10:00',13.45),('6449','2013-04-04','12:15:00',11.73),('6449','2013-04-04','12:20:00',9.42),('6449','2013-04-04','12:25:00',15.14),('6449','2013-04-04','12:30:00',9.82),('6449','2013-04-04','12:35:00',6.66),('6449','2013-04-04','12:40:00',7.01),('6449','2013-04-04','12:45:00',12.34),('6449','2013-04-04','12:50:00',7.91),('6449','2013-04-04','12:55:00',6.65),('6449','2013-04-04','13:00:00',11.27),('6449','2013-04-04','13:05:00',7.75),('6449','2013-04-04','13:10:00',4.83),('6449','2013-04-04','13:15:00',7.02),('6449','2013-04-04','13:20:00',15.46),('6449','2013-04-04','13:25:00',9.39),('6449','2013-04-04','13:30:00',4.59),('6449','2013-04-04','13:35:00',7.65),('6449','2013-04-04','13:40:00',6.12),('6449','2013-04-04','13:45:00',7.04),('6449','2013-04-04','13:50:00',5.16),('6449','2013-04-04','13:55:00',6.92),('6449','2013-04-04','14:00:00',7.6),('6449','2013-04-04','14:05:00',8.69),('6449','2013-04-04','14:10:00',9.99),('6449','2013-04-04','14:15:00',8.03),('6449','2013-04-04','14:20:00',14.89),('6449','2013-04-04','14:25:00',14.99),('6449','2013-04-04','14:30:00',14.92),('6449','2013-04-04','14:35:00',14.94),('6449','2013-04-04','14:40:00',8.05),('6449','2013-04-04','14:45:00',10.88),('6449','2013-04-04','14:50:00',13.26),('6449','2013-04-04','14:55:00',14.2),('6449','2013-04-04','15:00:00',13.4),('6449','2013-04-04','15:05:00',13.33),('6449','2013-04-04','15:10:00',9.51),('6449','2013-04-04','15:15:00',12.4),('6449','2013-04-04','15:20:00',10.55),('6449','2013-04-04','15:25:00',9.16),('6449','2013-04-04','15:30:00',10.86),('6449','2013-04-04','15:35:00',11.57),('6449','2013-04-04','15:40:00',11.48),('6449','2013-04-04','15:45:00',11.34),('6449','2013-04-04','15:50:00',10.94),('6449','2013-04-04','15:55:00',9.53),('6449','2013-04-04','16:00:00',8.98),('6449','2013-04-04','16:05:00',8.9),('6449','2013-04-04','16:10:00',6.72),('6449','2013-04-04','16:15:00',7.4),('6449','2013-04-04','16:20:00',5.87),('6449','2013-04-04','16:25:00',7.27),('6449','2013-04-04','16:30:00',7.36),('6449','2013-04-04','16:35:00',5.14),('6449','2013-04-04','16:40:00',5.52),('6449','2013-04-04','16:45:00',6.68),('6449','2013-04-04','16:50:00',5.71),('6449','2013-04-04','16:55:00',5.56),('6449','2013-04-04','17:00:00',5.51),('6449','2013-04-04','17:05:00',4.81),('6449','2013-04-04','17:10:00',4.32),('6449','2013-04-04','17:15:00',4.45),('6449','2013-04-04','17:20:00',4.06),('6449','2013-04-04','17:25:00',3.6),('6449','2013-04-04','17:30:00',4.24),('6449','2013-04-04','17:35:00',3.69),('6449','2013-04-04','17:40:00',3.31),('6449','2013-04-04','17:45:00',2.99),('6449','2013-04-04','17:50:00',3.3),('6449','2013-04-04','17:55:00',2.45),('6449','2013-04-04','18:00:00',2.35),('6449','2013-04-04','18:05:00',1.96),('6449','2013-04-04','18:10:00',1.48),('6449','2013-04-04','18:15:00',1.43),('6449','2013-04-04','18:20:00',1.27),('6449','2013-04-04','18:25:00',1.14),('6449','2013-04-03','07:20:00',1.02),('6449','2013-04-03','07:25:00',1.11),('6449','2013-04-03','07:30:00',1.61),('6449','2013-04-03','07:35:00',2.14),('6449','2013-04-03','07:40:00',2.86),('6449','2013-04-03','07:45:00',2.98),('6449','2013-04-03','07:50:00',3.57),('6449','2013-04-03','07:55:00',2.65),('6449','2013-04-03','08:00:00',1.79),('6449','2013-04-03','08:05:00',2.09),('6449','2013-04-03','08:10:00',3.44),('6449','2013-04-03','08:15:00',4.06),('6449','2013-04-03','08:20:00',5.1),('6449','2013-04-03','08:25:00',5.65),('6449','2013-04-03','08:30:00',5.97),('6449','2013-04-03','08:35:00',6.52),('6449','2013-04-03','08:40:00',7.41),('6449','2013-04-03','08:45:00',8.48),('6449','2013-04-03','08:50:00',9.09),('6449','2013-04-03','08:55:00',9.2),('6449','2013-04-03','09:00:00',8.3),('6449','2013-04-03','09:05:00',7.39),('6449','2013-04-03','09:10:00',9.11),('6449','2013-04-03','09:15:00',9.42),('6449','2013-04-03','09:20:00',9.71),('6449','2013-04-03','09:25:00',10.04),('6449','2013-04-03','09:30:00',11.48),('6449','2013-04-03','09:35:00',10.66),('6449','2013-04-03','09:40:00',8.74),('6449','2013-04-03','09:45:00',4.62),('6449','2013-04-03','09:50:00',4.7),('6449','2013-04-03','09:55:00',3.4),('6449','2013-04-03','10:00:00',4.35),('6449','2013-04-03','10:05:00',6.65),('6449','2013-04-03','10:10:00',15.4),('6449','2013-04-03','10:15:00',10.26),('6449','2013-04-03','10:20:00',9.19),('6449','2013-04-03','10:25:00',8.52),('6449','2013-04-03','10:30:00',14.69),('6449','2013-04-03','10:35:00',11.24),('6449','2013-04-03','10:40:00',7.35),('6449','2013-04-03','10:45:00',7.65),('6449','2013-04-03','10:50:00',11.9),('6449','2013-04-03','10:55:00',16.61),('6449','2013-04-03','11:00:00',16.04),('6449','2013-04-03','11:05:00',14.72),('6449','2013-04-03','11:10:00',14.5),('6449','2013-04-03','11:15:00',16.61),('6449','2013-04-03','11:20:00',16.01),('6449','2013-04-03','11:25:00',15.99),('6449','2013-04-03','11:30:00',16.05),('6449','2013-04-03','11:35:00',16.22),('6449','2013-04-03','11:40:00',12.47),('6449','2013-04-03','11:45:00',14.99),('6449','2013-04-03','11:50:00',17.5),('6449','2013-04-03','11:55:00',16.78),('6449','2013-04-03','12:00:00',17.01),('6449','2013-04-03','12:05:00',11.8),('6449','2013-04-03','12:10:00',15.65),('6449','2013-04-03','12:15:00',17.63),('6449','2013-04-03','12:20:00',17.15),('6449','2013-04-03','12:25:00',16.97),('6449','2013-04-03','12:30:00',16.14),('6449','2013-04-03','12:35:00',14.98),('6449','2013-04-03','12:40:00',10.33),('6449','2013-04-03','12:45:00',10.38),('6449','2013-04-03','12:50:00',17.24),('6449','2013-04-03','12:55:00',15.27),('6449','2013-04-03','13:00:00',16.71),('6449','2013-04-03','13:05:00',19.42),('6449','2013-04-03','13:10:00',18.59),('6449','2013-04-03','13:15:00',18.78),('6449','2013-04-03','13:20:00',17.62),('6449','2013-04-03','13:25:00',18.11),('6449','2013-04-03','13:30:00',17.81),('6449','2013-04-03','13:35:00',17.48),('6449','2013-04-03','13:40:00',17.75),('6449','2013-04-03','13:45:00',16.08),('6449','2013-04-03','13:50:00',16.35),('6449','2013-04-03','13:55:00',15.86),('6449','2013-04-03','14:00:00',18),('6449','2013-04-03','14:05:00',18.4),('6449','2013-04-03','14:10:00',17.57),('6449','2013-04-03','14:15:00',16.62),('6449','2013-04-03','14:20:00',16.59),('6449','2013-04-03','14:25:00',8.18),('6449','2013-04-03','14:30:00',15.32),('6449','2013-04-03','14:35:00',17.46),('6449','2013-04-03','14:40:00',16.65),('6449','2013-04-03','14:45:00',16.69),('6449','2013-04-03','14:50:00',12.87),('6449','2013-04-03','14:55:00',15.86),('6449','2013-04-03','15:00:00',15.53),('6449','2013-04-03','15:05:00',15.26),('6449','2013-04-03','15:10:00',14.91),('6449','2013-04-03','15:15:00',14.78),('6449','2013-04-03','15:20:00',14.64),('6449','2013-04-03','15:25:00',14.79),('6449','2013-04-03','15:30:00',13.99),('6449','2013-04-03','15:35:00',14.43),('6449','2013-04-03','15:40:00',13.91),('6449','2013-04-03','15:45:00',14.57),('6449','2013-04-03','15:50:00',14.28),('6449','2013-04-03','15:55:00',11.82),('6449','2013-04-03','16:00:00',12.48),('6449','2013-04-03','16:05:00',12.21),('6449','2013-04-03','16:10:00',11.97),('6449','2013-04-03','16:15:00',11.66),('6449','2013-04-03','16:20:00',11.25),('6449','2013-04-03','16:25:00',10.95),('6449','2013-04-03','16:30:00',10.56),('6449','2013-04-03','16:35:00',10.2),('6449','2013-04-03','16:40:00',9.84),('6449','2013-04-03','16:45:00',9.55),('6449','2013-04-03','16:50:00',9.16),('6449','2013-04-03','16:55:00',8.82),('6449','2013-04-03','17:00:00',8.44),('6449','2013-04-03','17:05:00',8),('6449','2013-04-03','17:10:00',7.72),('6449','2013-04-03','17:15:00',7.6),('6449','2013-04-03','17:20:00',7.05),('6449','2013-04-03','17:25:00',6.48),('6449','2013-04-03','17:30:00',6.13),('6449','2013-04-03','17:35:00',5.6),('6449','2013-04-03','17:40:00',5.24),('6449','2013-04-03','17:45:00',4.81),('6449','2013-04-03','17:50:00',4.37),('6449','2013-04-03','17:55:00',3.95),('6449','2013-04-03','18:00:00',3.57),('6449','2013-04-03','18:05:00',3.17),('6449','2013-04-03','18:10:00',2.85),('6449','2013-04-03','18:15:00',2.47),('6449','2013-04-03','18:20:00',2.1),('6449','2013-04-03','18:25:00',1.79),('6449','2013-04-03','18:30:00',1.48),('6449','2013-04-03','18:35:00',1.21),('6449','2013-04-02','07:55:00',1.04),('6449','2013-04-02','08:00:00',1.31),('6449','2013-04-02','08:10:00',1.13),('6449','2013-04-02','08:15:00',1.76),('6449','2013-04-02','08:20:00',3.62),('6449','2013-04-02','08:25:00',3.44),('6449','2013-04-02','08:30:00',1.87),('6449','2013-04-02','08:35:00',1.19),('6449','2013-04-02','08:40:00',1.12),('6449','2013-04-02','08:45:00',2.97),('6449','2013-04-02','08:50:00',7.78),('6449','2013-04-02','08:55:00',5.38),('6449','2013-04-02','09:00:00',7.09),('6449','2013-04-02','09:05:00',9.44),('6449','2013-04-02','09:10:00',9.25),('6449','2013-04-02','09:15:00',9.32),('6449','2013-04-02','09:20:00',9.66),('6449','2013-04-02','09:25:00',9.73),('6449','2013-04-02','09:30:00',10.31),('6449','2013-04-02','09:35:00',10.75),('6449','2013-04-02','09:40:00',11.15),('6449','2013-04-02','09:45:00',11.21),('6449','2013-04-02','09:50:00',10.18),('6449','2013-04-02','09:55:00',9.36),('6449','2013-04-02','10:00:00',13),('6449','2013-04-02','10:05:00',12.66),('6449','2013-04-02','10:10:00',12.86),('6449','2013-04-02','10:15:00',11.61),('6449','2013-04-02','10:20:00',13.81),('6449','2013-04-02','10:25:00',13.25),('6449','2013-04-02','10:30:00',14.34),('6449','2013-04-02','10:35:00',14.22),('6449','2013-04-02','10:40:00',14.46),('6449','2013-04-02','10:45:00',14.33),('6449','2013-04-02','10:50:00',15.6),('6449','2013-04-02','10:55:00',11.16),('6449','2013-04-02','11:00:00',10.9),('6449','2013-04-02','11:05:00',4.96),('6449','2013-04-02','11:10:00',11.81),('6449','2013-04-02','11:15:00',18.81),('6449','2013-04-02','11:20:00',17.22),('6449','2013-04-02','11:25:00',4.14),('6449','2013-04-02','11:30:00',2.17),('6449','2013-04-02','11:35:00',1.78),('6449','2013-04-02','11:40:00',5.82),('6449','2013-04-02','11:45:00',12.78),('6449','2013-04-02','11:50:00',17.6),('6449','2013-04-02','11:55:00',11.32),('6449','2013-04-02','12:00:00',4.71),('6449','2013-04-02','12:05:00',3.52),('6449','2013-04-02','12:10:00',4.17),('6449','2013-04-02','12:15:00',1.82),('6449','2013-04-02','12:20:00',3.38),('6449','2013-04-02','12:25:00',11.08),('6449','2013-04-02','12:30:00',5.56),('6449','2013-04-02','12:35:00',7.74),('6449','2013-04-02','12:40:00',11.52),('6449','2013-04-02','12:45:00',7.38),('6449','2013-04-02','12:50:00',6.27),('6449','2013-04-02','12:55:00',7.85),('6449','2013-04-02','13:00:00',9.02),('6449','2013-04-02','13:05:00',6.08),('6449','2013-04-02','13:10:00',3.95),('6449','2013-04-02','13:15:00',4.58),('6449','2013-04-02','13:20:00',4.07),('6449','2013-04-02','13:25:00',4.12),('6449','2013-04-02','13:30:00',9.45),('6449','2013-04-02','13:35:00',7.77),('6449','2013-04-02','13:40:00',12.4),('6449','2013-04-02','13:45:00',20),('6449','2013-04-02','13:50:00',18.33),('6449','2013-04-02','13:55:00',17.18),('6449','2013-04-02','14:00:00',13.59),('6449','2013-04-02','14:05:00',14.75),('6449','2013-04-02','14:10:00',4.09),('6449','2013-04-02','14:15:00',3.39),('6449','2013-04-02','14:20:00',11.91),('6449','2013-04-02','14:25:00',15.7),('6449','2013-04-02','14:30:00',8.25),('6449','2013-04-02','14:35:00',5.89),('6449','2013-04-02','14:40:00',3.11),('6449','2013-04-02','14:45:00',2.02),('6449','2013-04-02','14:50:00',1.62),('6449','2013-04-02','14:55:00',3.68),('6449','2013-04-02','15:00:00',6.22),('6449','2013-04-02','15:05:00',4.38),('6449','2013-04-02','15:10:00',4.03),('6449','2013-04-02','15:15:00',3.6),('6449','2013-04-02','15:20:00',2.95),('6449','2013-04-02','15:25:00',1.84),('6449','2013-04-02','15:30:00',1.63),('6449','2013-04-02','15:35:00',1.31),('6449','2013-04-02','15:40:00',1.14),('6449','2013-04-02','15:45:00',1.15),('6449','2013-04-02','15:50:00',1.36),('6449','2013-04-02','15:55:00',1.61),('6449','2013-04-02','16:00:00',2.2),('6449','2013-04-02','16:05:00',2.61),('6449','2013-04-02','16:10:00',2.39),('6449','2013-04-02','16:15:00',2.55),('6449','2013-04-02','16:20:00',3.48),('6449','2013-04-02','16:25:00',4.57),('6449','2013-04-02','16:30:00',3.98),('6449','2013-04-02','16:35:00',3.18),('6449','2013-04-02','16:40:00',2.27),('6449','2013-04-02','16:45:00',1.56),('6449','2013-04-02','17:15:00',1.04),('6449','2013-04-01','07:30:00',1.14),('6449','2013-04-01','07:35:00',1.48),('6449','2013-04-01','07:40:00',1.78),('6449','2013-04-01','07:45:00',1.87),('6449','2013-04-01','07:50:00',1.33),('6449','2013-04-01','07:55:00',2.68),('6449','2013-04-01','08:00:00',3.55),('6449','2013-04-01','08:05:00',4.15),('6449','2013-04-01','08:10:00',5.02),('6449','2013-04-01','08:15:00',5.48),('6449','2013-04-01','08:20:00',2.9),('6449','2013-04-01','08:25:00',4.23),('6449','2013-04-01','08:30:00',7.41),('6449','2013-04-01','08:35:00',6.05),('6449','2013-04-01','08:40:00',2.06),('6449','2013-04-01','08:45:00',2.13),('6449','2013-04-01','08:50:00',4.35),('6449','2013-04-01','08:55:00',3.69),('6449','2013-04-01','09:00:00',4.3),('6449','2013-04-01','09:05:00',3.63),('6449','2013-04-01','09:10:00',2.31),('6449','2013-04-01','09:15:00',2.66),('6449','2013-04-01','09:20:00',3.68),('6449','2013-04-01','09:25:00',5.1),('6449','2013-04-01','09:30:00',7.18),('6449','2013-04-01','09:35:00',9.47),('6449','2013-04-01','09:40:00',4.22),('6449','2013-04-01','09:45:00',4.22),('6449','2013-04-01','09:50:00',8.97),('6449','2013-04-01','09:55:00',11.37),('6449','2013-04-01','10:00:00',13.41),('6449','2013-04-01','10:05:00',8.26),('6449','2013-04-01','10:10:00',7.95),('6449','2013-04-01','10:15:00',12.47),('6449','2013-04-01','10:20:00',9.93),('6449','2013-04-01','10:25:00',9.6),('6449','2013-04-01','10:30:00',10.95),('6449','2013-04-01','10:35:00',10.32),('6449','2013-04-01','10:40:00',9.07),('6449','2013-04-01','10:45:00',8.18),('6449','2013-04-01','10:50:00',9.87),('6449','2013-04-01','10:55:00',6.46),('6449','2013-04-01','11:00:00',9.19),('6449','2013-04-01','11:05:00',11.92),('6449','2013-04-01','11:10:00',7.71),('6449','2013-04-01','11:15:00',7.96),('6449','2013-04-01','11:20:00',8.49),('6449','2013-04-01','11:25:00',9.16),('6449','2013-04-01','11:30:00',9.34),('6449','2013-04-01','11:35:00',10.87),('6449','2013-04-01','11:40:00',10.98),('6449','2013-04-01','11:45:00',12.51),('6449','2013-04-01','11:50:00',11.56),('6449','2013-04-01','11:55:00',10.3),('6449','2013-04-01','12:00:00',7.96),('6449','2013-04-01','12:05:00',6.9),('6449','2013-04-01','12:10:00',9.46),('6449','2013-04-01','12:15:00',11.9),('6449','2013-04-01','12:20:00',12.21),('6449','2013-04-01','12:25:00',8.51),('6449','2013-04-01','12:30:00',6.88),('6449','2013-04-01','12:35:00',6.78),('6449','2013-04-01','12:40:00',7.6),('6449','2013-04-01','12:45:00',8.59),('6449','2013-04-01','12:50:00',8.76),('6449','2013-04-01','12:55:00',10.33),('6449','2013-04-01','13:00:00',10.1),('6449','2013-04-01','13:05:00',8.77),('6449','2013-04-01','13:10:00',11.58),('6449','2013-04-01','13:15:00',10.7),('6449','2013-04-01','13:20:00',9.23),('6449','2013-04-01','13:25:00',6.66),('6449','2013-04-01','13:30:00',6.24),('6449','2013-04-01','13:35:00',7.04),('6449','2013-04-01','13:40:00',8.07),('6449','2013-04-01','13:45:00',6.66),('6449','2013-04-01','13:50:00',6.2),('6449','2013-04-01','13:55:00',8.45),('6449','2013-04-01','14:00:00',11.65),('6449','2013-04-01','14:05:00',11.19),('6449','2013-04-01','14:10:00',10.42),('6449','2013-04-01','14:15:00',6.91),('6449','2013-04-01','14:20:00',8.71),('6449','2013-04-01','14:25:00',9.97),('6449','2013-04-01','14:30:00',7.73),('6449','2013-04-01','14:35:00',6.32),('6449','2013-04-01','14:40:00',5.21),('6449','2013-04-01','14:45:00',6.13),('6449','2013-04-01','14:50:00',6.71),('6449','2013-04-01','14:55:00',6.02),('6449','2013-04-01','15:00:00',6.11),('6449','2013-04-01','15:05:00',5.43),('6449','2013-04-01','15:10:00',4.15),('6449','2013-04-01','15:15:00',3.85),('6449','2013-04-01','15:20:00',5.14),('6449','2013-04-01','15:25:00',5.96),('6449','2013-04-01','15:30:00',4.76),('6449','2013-04-01','15:35:00',4.21),('6449','2013-04-01','15:40:00',4.62),('6449','2013-04-01','15:45:00',6),('6449','2013-04-01','15:50:00',7.55),('6449','2013-04-01','15:55:00',6.87),('6449','2013-04-01','16:00:00',6.19),('6449','2013-04-01','16:05:00',5.76),('6449','2013-04-01','16:10:00',3.95),('6449','2013-04-01','16:15:00',3.15),('6449','2013-04-01','16:20:00',2.72),('6449','2013-04-01','16:25:00',2.74),('6449','2013-04-01','16:30:00',2.84),('6449','2013-04-01','16:35:00',2.25),('6449','2013-04-01','16:40:00',1.87),('6449','2013-04-01','16:45:00',1.33),('6449','2013-04-01','17:15:00',1.02),('6449','2013-04-01','17:20:00',1.11),('6449','2013-04-01','17:25:00',1.06),('6449','2013-03-31','08:20:00',1.27),('6449','2013-03-31','08:25:00',1.44),('6449','2013-03-31','08:30:00',1.37),('6449','2013-03-31','08:35:00',1.6),('6449','2013-03-31','08:40:00',2.08),('6449','2013-03-31','08:45:00',3.08),('6449','2013-03-31','08:50:00',1.52),('6449','2013-03-31','08:55:00',1.64),('6449','2013-03-31','09:00:00',2.01),('6449','2013-03-31','09:05:00',3.08),('6449','2013-03-31','09:10:00',4.06),('6449','2013-03-31','09:15:00',3.72),('6449','2013-03-31','09:20:00',6.05),('6449','2013-03-31','09:25:00',4.06),('6449','2013-03-31','09:30:00',3.01),('6449','2013-03-31','09:35:00',3.83),('6449','2013-03-31','09:40:00',5.59),('6449','2013-03-31','09:45:00',4.17),('6449','2013-03-31','09:50:00',4.86),('6449','2013-03-31','09:55:00',4.26),('6449','2013-03-31','10:00:00',4.34),('6449','2013-03-31','10:05:00',13.03),('6449','2013-03-31','10:10:00',5.77),('6449','2013-03-31','10:15:00',4.65),('6449','2013-03-31','10:20:00',3.52),('6449','2013-03-31','10:25:00',2.99),('6449','2013-03-31','10:30:00',3.48),('6449','2013-03-31','10:35:00',4.81),('6449','2013-03-31','10:40:00',4.69),('6449','2013-03-31','10:45:00',3.16),('6449','2013-03-31','10:50:00',2.56),('6449','2013-03-31','10:55:00',3.37),('6449','2013-03-31','11:00:00',3.21),('6449','2013-03-31','11:05:00',3.33),('6449','2013-03-31','11:10:00',4.76),('6449','2013-03-31','11:15:00',4.42),('6449','2013-03-31','11:20:00',4.25),('6449','2013-03-31','11:25:00',3.64),('6449','2013-03-31','11:30:00',3.13),('6449','2013-03-31','11:35:00',3.64),('6449','2013-03-31','11:40:00',5.7),('6449','2013-03-31','11:45:00',4.34),('6449','2013-03-31','11:50:00',4.83),('6449','2013-03-31','11:55:00',4.06),('6449','2013-03-31','12:00:00',4.1),('6449','2013-03-31','12:05:00',4.34),('6449','2013-03-31','12:10:00',3.63),('6449','2013-03-31','12:15:00',3.49),('6449','2013-03-31','12:20:00',3.57),('6449','2013-03-31','12:25:00',4.2),('6449','2013-03-31','12:30:00',3.77),('6449','2013-03-31','12:35:00',3.97),('6449','2013-03-31','12:40:00',5.19),('6449','2013-03-31','12:45:00',6.85),('6449','2013-03-31','12:50:00',7.6),('6449','2013-03-31','12:55:00',8.11),('6449','2013-03-31','13:00:00',7.34),('6449','2013-03-31','13:05:00',9.22),('6449','2013-03-31','13:10:00',18.4),('6449','2013-03-31','13:15:00',16.94),('6449','2013-03-31','13:20:00',18.49),('6449','2013-03-31','13:25:00',12.2),('6449','2013-03-31','13:30:00',16.45),('6449','2013-03-31','13:35:00',12.11),('6449','2013-03-31','13:40:00',9.75),('6449','2013-03-31','13:45:00',14.89),('6449','2013-03-31','13:50:00',12.95),('6449','2013-03-31','13:55:00',6.16),('6449','2013-03-31','14:00:00',10.68),('6449','2013-03-31','14:05:00',10.71),('6449','2013-03-31','14:10:00',9.9),('6449','2013-03-31','14:15:00',16.91),('6449','2013-03-31','14:20:00',11.78),('6449','2013-03-31','14:25:00',14.78),('6449','2013-03-31','14:30:00',8.18),('6449','2013-03-31','14:35:00',5.92),('6449','2013-03-31','14:40:00',5.74),('6449','2013-03-31','14:45:00',5.8),('6449','2013-03-31','14:50:00',11.32),('6449','2013-03-31','14:55:00',17.8),('6449','2013-03-31','15:00:00',10.52),('6449','2013-03-31','15:05:00',9.51),('6449','2013-03-31','15:10:00',14.1),('6449','2013-03-31','15:15:00',15.53),('6449','2013-03-31','15:20:00',15.32),('6449','2013-03-31','15:25:00',14.21),('6449','2013-03-31','15:30:00',11.04),('6449','2013-03-31','15:35:00',10.88),('6449','2013-03-31','15:40:00',6.73),('6449','2013-03-31','15:45:00',8.45),('6449','2013-03-31','15:50:00',8.25),('6449','2013-03-31','15:55:00',6.78),('6449','2013-03-31','16:00:00',3.96),('6449','2013-03-31','16:05:00',2.42),('6449','2013-03-31','16:10:00',2.92),('6449','2013-03-31','16:15:00',5.8),('6449','2013-03-31','16:20:00',5.41),('6449','2013-03-31','16:25:00',2.42),('6449','2013-03-31','16:30:00',1.32),('6449','2013-03-31','16:35:00',2.79),('6449','2013-03-31','16:40:00',2.71),('6449','2013-03-31','16:45:00',1.77),('6449','2013-03-31','16:50:00',1.21),('6449','2013-03-31','17:15:00',1.59),('6449','2013-03-31','17:20:00',3.37),('6449','2013-03-31','17:25:00',9.5),('6449','2013-03-31','17:30:00',5.53),('6449','2013-03-31','17:35:00',5.12),('6449','2013-03-31','17:40:00',6.1),('6449','2013-03-31','17:45:00',4.92),('6449','2013-03-31','17:50:00',4.62),('6449','2013-03-31','17:55:00',1.11),('6449','2013-03-31','18:00:00',2.02),('6449','2013-03-31','18:05:00',3.37),('6449','2013-03-31','18:10:00',3.6),('6449','2013-03-31','18:15:00',2.2),('6449','2013-03-31','18:25:00',1.76),('6449','2013-03-31','18:30:00',1.51),('6449','2013-03-31','18:35:00',1.1),('6449','2013-03-31','18:40:00',1.01),('6449','2013-03-30','07:20:00',1.04),('6449','2013-03-30','07:30:00',1.22),('6449','2013-03-30','07:35:00',1.75),('6449','2013-03-30','07:40:00',1.71),('6449','2013-03-30','07:45:00',1.23),('6449','2013-03-30','07:50:00',1.22),('6449','2013-03-30','07:55:00',1.07),('6449','2013-03-30','08:00:00',1.02),('6449','2013-03-30','08:10:00',1.4),('6449','2013-03-30','08:15:00',1.41),('6449','2013-03-30','08:40:00',1.15),('6449','2013-03-30','08:50:00',1.35),('6449','2013-03-30','08:55:00',1.12),('6449','2013-03-30','09:00:00',1.61),('6449','2013-03-30','09:05:00',2.71),('6449','2013-03-30','09:10:00',3.18),('6449','2013-03-30','09:15:00',3.09),('6449','2013-03-30','09:20:00',3.21),('6449','2013-03-30','09:25:00',2.7),('6449','2013-03-30','09:30:00',2.01),('6449','2013-03-30','09:35:00',5.61),('6449','2013-03-30','09:40:00',4.15),('6449','2013-03-30','09:45:00',3.23),('6449','2013-03-30','09:50:00',3.5),('6449','2013-03-30','09:55:00',3.54),('6449','2013-03-30','10:00:00',5.24),('6449','2013-03-30','10:05:00',4.72),('6449','2013-03-30','10:10:00',7.46),('6449','2013-03-30','10:15:00',7.65),('6449','2013-03-30','10:20:00',7.01),('6449','2013-03-30','10:25:00',9.41),('6449','2013-03-30','10:30:00',9.94),('6449','2013-03-30','10:35:00',9.4),('6449','2013-03-30','10:40:00',6.14),('6449','2013-03-30','10:45:00',4.91),('6449','2013-03-30','10:50:00',4.79),('6449','2013-03-30','10:55:00',3.41),('6449','2013-03-30','11:00:00',3.43),('6449','2013-03-30','11:05:00',3.35),('6449','2013-03-30','11:10:00',3.22),('6449','2013-03-30','11:15:00',3.57),('6449','2013-03-30','11:20:00',3.54),('6449','2013-03-30','11:25:00',3.25),('6449','2013-03-30','11:30:00',2.79),('6449','2013-03-30','11:35:00',4),('6449','2013-03-30','11:40:00',4.82),('6449','2013-03-30','11:45:00',3.9),('6449','2013-03-30','11:50:00',3.84),('6449','2013-03-30','11:55:00',3.87),('6449','2013-03-30','12:00:00',2.56),('6449','2013-03-30','12:05:00',2.74),('6449','2013-03-30','12:10:00',3.41),('6449','2013-03-30','12:15:00',2.51),('6449','2013-03-30','12:20:00',1.88),('6449','2013-03-30','12:25:00',1.82),('6449','2013-03-30','12:30:00',1.51),('6449','2013-03-30','12:50:00',2.53),('6449','2013-03-30','12:55:00',2.19),('6449','2013-03-30','13:00:00',3.47),('6449','2013-03-30','13:05:00',3.7),('6449','2013-03-30','13:10:00',3.83),('6449','2013-03-30','13:15:00',3.52),('6449','2013-03-30','13:20:00',2.65),('6449','2013-03-30','13:25:00',1.88),('6449','2013-03-30','13:30:00',1.74),('6449','2013-03-30','13:35:00',2.65),('6449','2013-03-30','13:40:00',3.39),('6449','2013-03-30','13:45:00',3.65),('6449','2013-03-30','13:50:00',5.72),('6449','2013-03-30','13:55:00',9.11),('6449','2013-03-30','14:00:00',10.29),('6449','2013-03-30','14:05:00',13.32),('6449','2013-03-30','14:10:00',9.72),('6449','2013-03-30','14:15:00',10.11),('6449','2013-03-30','14:20:00',10.84),('6449','2013-03-30','14:25:00',8.01),('6449','2013-03-30','14:30:00',8.73),('6449','2013-03-30','14:35:00',6.94),('6449','2013-03-30','14:40:00',4.55),('6449','2013-03-30','14:45:00',3.63),('6449','2013-03-30','14:50:00',3.21),('6449','2013-03-30','14:55:00',2.16),('6449','2013-03-30','15:00:00',2.13),('6449','2013-03-30','15:05:00',1.43),('6449','2013-03-30','15:10:00',1.74),('6449','2013-03-29','06:50:00',1.07),('6449','2013-03-29','06:55:00',2.08),('6449','2013-03-29','07:00:00',3.55),('6449','2013-03-29','07:05:00',3.89),('6449','2013-03-29','07:10:00',3.54),('6449','2013-03-29','07:15:00',1.83),('6449','2013-03-29','07:20:00',2.49),('6449','2013-03-29','07:25:00',2.39),('6449','2013-03-29','07:30:00',2.84),('6449','2013-03-29','07:35:00',2.25),('6449','2013-03-29','07:40:00',1.26),('6449','2013-03-29','07:45:00',1.11),('6449','2013-03-29','07:50:00',1.54),('6449','2013-03-29','07:55:00',2.32),('6449','2013-03-29','08:00:00',3.12),('6449','2013-03-29','08:05:00',3.54),('6449','2013-03-29','08:10:00',4.77),('6449','2013-03-29','08:15:00',9.15),('6449','2013-03-29','08:20:00',8.36),('6449','2013-03-29','08:25:00',7.33),('6449','2013-03-29','08:30:00',4.63),('6449','2013-03-29','08:35:00',7.82),('6449','2013-03-29','08:40:00',10.61),('6449','2013-03-29','08:45:00',11.34),('6449','2013-03-29','08:50:00',11.52),('6449','2013-03-29','08:55:00',9.24),('6449','2013-03-29','09:00:00',11.15),('6449','2013-03-29','09:05:00',11.92),('6449','2013-03-29','09:10:00',10.99),('6449','2013-03-29','09:15:00',11.72),('6449','2013-03-29','09:20:00',12.15),('6449','2013-03-29','09:25:00',12.81),('6449','2013-03-29','09:30:00',12.52),('6449','2013-03-29','09:35:00',11.44),('6449','2013-03-29','09:40:00',10.06),('6449','2013-03-29','09:45:00',9.45),('6449','2013-03-29','09:50:00',12.81),('6449','2013-03-29','09:55:00',8.26),('6449','2013-03-29','10:00:00',9.19),('6449','2013-03-29','10:05:00',10.64),('6449','2013-03-29','10:10:00',13.53),('6449','2013-03-29','10:15:00',13.01),('6449','2013-03-29','10:20:00',14.02),('6449','2013-03-29','10:25:00',14.3),('6449','2013-03-29','10:30:00',14.15),('6449','2013-03-29','10:35:00',14.13),('6449','2013-03-29','10:40:00',15.24),('6449','2013-03-29','10:45:00',15.73),('6449','2013-03-29','10:50:00',15.65),('6449','2013-03-29','10:55:00',15.82),('6449','2013-03-29','11:00:00',15.88),('6449','2013-03-29','11:05:00',15.96),('6449','2013-03-29','11:10:00',16.04),('6449','2013-03-29','11:15:00',16.26),('6449','2013-03-29','11:20:00',16.41),('6449','2013-03-29','11:25:00',16.5),('6449','2013-03-29','11:30:00',16.57),('6449','2013-03-29','11:35:00',16.63),('6449','2013-03-29','11:40:00',16.7),('6449','2013-03-29','11:45:00',16.73),('6449','2013-03-29','11:50:00',16.77),('6449','2013-03-29','11:55:00',16.79),('6449','2013-03-29','12:00:00',16.76),('6449','2013-03-29','12:05:00',16.76),('6449','2013-03-29','12:10:00',16.86),('6449','2013-03-29','12:15:00',16.91),('6449','2013-03-29','12:20:00',16.87),('6449','2013-03-29','12:25:00',16.29),('6449','2013-03-29','12:30:00',16.55),('6449','2013-03-29','12:35:00',16.65),('6449','2013-03-29','12:40:00',16.56),('6449','2013-03-29','12:45:00',16.41),('6449','2013-03-29','12:50:00',16.27),('6449','2013-03-29','12:55:00',15.91),('6449','2013-03-29','13:00:00',16.37),('6449','2013-03-29','13:05:00',16.24),('6449','2013-03-29','13:10:00',16.34),('6449','2013-03-29','13:15:00',12.92),('6449','2013-03-29','13:20:00',10.95),('6449','2013-03-29','13:25:00',13.51),('6449','2013-03-29','13:30:00',13.29),('6449','2013-03-29','13:35:00',13.09),('6449','2013-03-29','13:40:00',13.29),('6449','2013-03-29','13:45:00',12.92),('6449','2013-03-29','13:50:00',10.58),('6449','2013-03-29','13:55:00',8.17),('6449','2013-03-29','14:00:00',7.86),('6449','2013-03-29','14:05:00',7.63),('6449','2013-03-29','14:10:00',6.86),('6449','2013-03-29','14:15:00',6.39),('6449','2013-03-29','14:20:00',6.21),('6449','2013-03-29','14:25:00',6.18),('6449','2013-03-29','14:30:00',7.02),('6449','2013-03-29','14:35:00',6.52),('6449','2013-03-29','14:40:00',6.11),('6449','2013-03-29','14:45:00',5.86),('6449','2013-03-29','14:50:00',5.37),('6449','2013-03-29','14:55:00',5),('6449','2013-03-29','15:00:00',4.65),('6449','2013-03-29','15:05:00',4.27),('6449','2013-03-29','15:10:00',3.95),('6449','2013-03-29','15:15:00',3.82),('6449','2013-03-29','15:20:00',3.86),('6449','2013-03-29','15:25:00',4.5),('6449','2013-03-29','15:30:00',4.97),('6449','2013-03-29','15:35:00',7.18),('6449','2013-03-29','15:40:00',9.7),('6449','2013-03-29','15:45:00',9.09),('6449','2013-03-29','15:50:00',5.39),('6449','2013-03-29','15:55:00',3.9),('6449','2013-03-29','16:00:00',3.72),('6449','2013-03-29','16:05:00',5.57),('6449','2013-03-29','16:10:00',5.08),('6449','2013-03-29','16:15:00',4.63),('6449','2013-03-29','16:20:00',4.84),('6449','2013-03-29','16:25:00',4.58),('6449','2013-03-29','16:30:00',5.34),('6449','2013-03-29','16:35:00',4.57),('6449','2013-03-29','16:40:00',4.55),('6449','2013-03-29','16:45:00',4.38),('6449','2013-03-29','16:50:00',2.71),('6449','2013-03-29','16:55:00',2.95),('6449','2013-03-29','17:00:00',4.07),('6449','2013-03-29','17:05:00',3.57),('6449','2013-03-29','17:10:00',3.94),('6449','2013-03-29','17:15:00',2.67),('6449','2013-03-29','17:20:00',3.11),('6449','2013-03-29','17:25:00',2.01),('6449','2013-03-29','17:30:00',1.24),('6449','2013-03-29','17:35:00',1.13),('6449','2013-03-29','17:40:00',1.02),('6449','2013-03-28','07:20:00',1.07),('6449','2013-03-28','07:25:00',1.11),('6449','2013-03-28','07:30:00',1.27),('6449','2013-03-28','07:35:00',1.47),('6449','2013-03-28','08:30:00',1.09),('6449','2013-03-28','08:35:00',2.34),('6449','2013-03-28','08:40:00',2.89),('6449','2013-03-28','08:45:00',2.95),('6449','2013-03-28','08:50:00',3.42),('6449','2013-03-28','08:55:00',3.42),('6449','2013-03-28','09:00:00',3),('6449','2013-03-28','09:05:00',2.21),('6449','2013-03-28','09:10:00',3.16),('6449','2013-03-28','09:15:00',5.09),('6449','2013-03-28','09:20:00',4.43),('6449','2013-03-28','09:25:00',3.95),('6449','2013-03-28','09:30:00',3.97),('6449','2013-03-28','09:35:00',5.49),('6449','2013-03-28','09:40:00',7.77),('6449','2013-03-28','09:45:00',7.45),('6449','2013-03-28','09:50:00',4.68),('6449','2013-03-28','09:55:00',5.06),('6449','2013-03-28','10:00:00',4.56),('6449','2013-03-28','10:05:00',3.11),('6449','2013-03-28','10:10:00',3.18),('6449','2013-03-28','10:15:00',2.94),('6449','2013-03-28','10:20:00',2.77),('6449','2013-03-28','10:25:00',2.54),('6449','2013-03-28','10:30:00',1.61),('6449','2013-03-28','10:35:00',1.73),('6449','2013-03-28','10:40:00',1.87),('6449','2013-03-28','10:45:00',1.68),('6449','2013-03-28','10:50:00',1.78),('6449','2013-03-28','10:55:00',2.38),('6449','2013-03-28','11:00:00',3.99),('6449','2013-03-28','11:05:00',3.39),('6449','2013-03-28','11:10:00',2.57),('6449','2013-03-28','11:15:00',2.75),('6449','2013-03-28','11:20:00',2.91),('6449','2013-03-28','11:25:00',2.45),('6449','2013-03-28','11:30:00',3.24),('6449','2013-03-28','11:35:00',3.02),('6449','2013-03-28','11:40:00',3.28),('6449','2013-03-28','11:45:00',3.71),('6449','2013-03-28','11:50:00',4.15),('6449','2013-03-28','11:55:00',3.33),('6449','2013-03-28','12:00:00',2.9),('6449','2013-03-28','12:05:00',3.57),('6449','2013-03-28','12:10:00',3.36),('6449','2013-03-28','12:15:00',2.94),('6449','2013-03-28','12:20:00',3.01),('6449','2013-03-28','12:25:00',4.18),('6449','2013-03-28','12:30:00',6.27),('6449','2013-03-28','12:35:00',5.34),('6449','2013-03-28','12:40:00',4.5),('6449','2013-03-28','12:45:00',4.8),('6449','2013-03-28','12:50:00',3.21),('6449','2013-03-28','12:55:00',3.65),('6449','2013-03-28','13:00:00',4.1),('6449','2013-03-28','13:05:00',6.41),('6449','2013-03-28','13:10:00',4.94),('6449','2013-03-28','13:15:00',6.02),('6449','2013-03-28','13:20:00',4.92),('6449','2013-03-28','13:25:00',2.27),('6449','2013-03-28','13:30:00',1.68),('6449','2013-03-28','13:35:00',2.23),('6449','2013-03-28','13:40:00',4.45),('6449','2013-03-28','13:45:00',3.42),('6449','2013-03-28','13:50:00',1.47),('6449','2013-03-28','13:55:00',1.43),('6449','2013-03-28','14:10:00',1.03),('6449','2013-03-28','14:15:00',1.96),('6449','2013-03-28','14:20:00',3.11),('6449','2013-03-28','14:25:00',2.92),('6449','2013-03-28','14:30:00',1.14),('6449','2013-03-28','14:35:00',1.01),('6449','2013-03-28','14:40:00',1.92),('6449','2013-03-28','15:00:00',1.41),('6449','2013-03-28','15:05:00',1.72),('6449','2013-03-28','15:10:00',2.77),('6449','2013-03-28','15:15:00',2.25),('6449','2013-03-28','15:20:00',1.28),('6449','2013-03-28','15:25:00',1.17),('6449','2013-03-28','15:30:00',1.5),('6449','2013-03-28','15:35:00',2.72),('6449','2013-03-28','15:40:00',3.03),('6449','2013-03-28','15:45:00',1.4),('6449','2013-03-28','15:55:00',1.1),('6449','2013-03-28','16:00:00',1.49),('6449','2013-03-28','16:05:00',1.48),('6449','2013-03-28','16:10:00',1.64),('6449','2013-03-28','16:15:00',1.42),('6449','2013-03-28','16:20:00',1.03),('6449','2013-03-28','16:25:00',1.55),('6449','2013-03-28','16:30:00',1.66),('6449','2013-03-28','16:35:00',1.26),('6449','2013-03-28','16:40:00',1.18),('6449','2013-03-28','16:45:00',1.58),('6449','2013-03-28','16:50:00',2.49),('6449','2013-03-28','16:55:00',2.85),('6449','2013-03-28','17:00:00',2.87),('6449','2013-03-28','17:05:00',1.94),('6449','2013-03-28','17:10:00',1.66),('6449','2013-03-28','17:15:00',1.16),('6449','2013-03-27','06:45:00',1.11),('6449','2013-03-27','06:50:00',1.3),('6449','2013-03-27','06:55:00',1.92),('6449','2013-03-27','07:00:00',2.4),('6449','2013-03-27','07:05:00',2.85),('6449','2013-03-27','07:10:00',3.11),('6449','2013-03-27','07:15:00',3.76),('6449','2013-03-27','07:20:00',3.99),('6449','2013-03-27','07:25:00',3.21),('6449','2013-03-27','07:30:00',4.35),('6449','2013-03-27','07:35:00',5.53),('6449','2013-03-27','07:40:00',6.51),('6449','2013-03-27','07:45:00',4.18),('6449','2013-03-27','07:50:00',3.56),('6449','2013-03-27','07:55:00',6.33),('6449','2013-03-27','08:00:00',7.67),('6449','2013-03-27','08:05:00',4.9),('6449','2013-03-27','08:10:00',4.1),('6449','2013-03-27','08:15:00',3.79),('6449','2013-03-27','08:20:00',3.71),('6449','2013-03-27','08:25:00',4.49),('6449','2013-03-27','08:30:00',8.57),('6449','2013-03-27','08:35:00',5.95),('6449','2013-03-27','08:40:00',4.93),('6449','2013-03-27','08:45:00',5.23),('6449','2013-03-27','08:50:00',9.72),('6449','2013-03-27','08:55:00',8.15),('6449','2013-03-27','09:00:00',8.22),('6449','2013-03-27','09:05:00',11.83),('6449','2013-03-27','09:10:00',10.47),('6449','2013-03-27','09:15:00',11.58),('6449','2013-03-27','09:20:00',8.92),('6449','2013-03-27','09:25:00',7.78),('6449','2013-03-27','09:30:00',7.24),('6449','2013-03-27','09:35:00',9.77),('6449','2013-03-27','09:40:00',15.19),('6449','2013-03-27','09:45:00',11.07),('6449','2013-03-27','09:50:00',13.88),('6449','2013-03-27','09:55:00',11.88),('6449','2013-03-27','10:00:00',14.9),('6449','2013-03-27','10:05:00',15.22),('6449','2013-03-27','10:10:00',11.22),('6449','2013-03-27','10:15:00',9),('6449','2013-03-27','10:20:00',7.65),('6449','2013-03-27','10:25:00',6.56),('6449','2013-03-27','10:30:00',7.95),('6449','2013-03-27','10:35:00',7.68),('6449','2013-03-27','10:40:00',8.83),('6449','2013-03-27','10:45:00',6.12),('6449','2013-03-27','10:50:00',7.81),('6449','2013-03-27','10:55:00',6.6),('6449','2013-03-27','11:00:00',7.57),('6449','2013-03-27','11:05:00',7.97),('6449','2013-03-27','11:10:00',7.19),('6449','2013-03-27','11:15:00',6.87),('6449','2013-03-27','11:20:00',6.64),('6449','2013-03-27','11:25:00',6.93),('6449','2013-03-27','11:30:00',9.33),('6449','2013-03-27','11:35:00',15.55),('6449','2013-03-27','11:40:00',12.2),('6449','2013-03-27','11:45:00',16.37),('6449','2013-03-27','11:50:00',14.7),('6449','2013-03-27','11:55:00',16.1),('6449','2013-03-27','12:00:00',15.35),('6449','2013-03-27','12:05:00',14.86),('6449','2013-03-27','12:10:00',16.91),('6449','2013-03-27','12:15:00',16.94),('6449','2013-03-27','12:20:00',12.24),('6449','2013-03-27','12:25:00',9.68),('6449','2013-03-27','12:30:00',13.69),('6449','2013-03-27','12:35:00',15.04),('6449','2013-03-27','12:40:00',13.93),('6449','2013-03-27','12:45:00',10.86),('6449','2013-03-27','12:50:00',9.51),('6449','2013-03-27','12:55:00',10.14),('6449','2013-03-27','13:00:00',13.59),('6449','2013-03-27','13:05:00',10.44),('6449','2013-03-27','13:10:00',11.96),('6449','2013-03-27','13:15:00',10.68),('6449','2013-03-27','13:20:00',8.87),('6449','2013-03-27','13:25:00',7.6),('6449','2013-03-27','13:30:00',6.99),('6449','2013-03-27','13:35:00',6.35),('6449','2013-03-27','13:40:00',4.85),('6449','2013-03-27','13:45:00',6.2),('6449','2013-03-27','13:50:00',9.55),('6449','2013-03-27','13:55:00',6.66),('6449','2013-03-27','14:00:00',7.82),('6449','2013-03-27','14:05:00',9.81),('6449','2013-03-27','14:10:00',10.11),('6449','2013-03-27','14:15:00',8.7),('6449','2013-03-27','14:20:00',9.84),('6449','2013-03-27','14:25:00',8.85),('6449','2013-03-27','14:30:00',9.36),('6449','2013-03-27','14:35:00',8.51),('6449','2013-03-27','14:40:00',11.21),('6449','2013-03-27','14:45:00',10.6),('6449','2013-03-27','14:50:00',10.41),('6449','2013-03-27','14:55:00',10.45),('6449','2013-03-27','15:00:00',6.72),('6449','2013-03-27','15:05:00',4.55),('6449','2013-03-27','15:10:00',4.02),('6449','2013-03-27','15:15:00',5.31),('6449','2013-03-27','15:20:00',7.22),('6449','2013-03-27','15:25:00',10.6),('6449','2013-03-27','15:30:00',6.69),('6449','2013-03-27','15:35:00',5.54),('6449','2013-03-27','15:40:00',6.47),('6449','2013-03-27','15:45:00',4.93),('6449','2013-03-27','15:50:00',4.8),('6449','2013-03-27','15:55:00',4.42),('6449','2013-03-27','16:00:00',3.96),('6449','2013-03-27','16:05:00',4.57),('6449','2013-03-27','16:10:00',4.25),('6449','2013-03-27','16:15:00',5.39),('6449','2013-03-27','16:20:00',3.3),('6449','2013-03-27','16:25:00',3.09),('6449','2013-03-27','16:30:00',3.56),('6449','2013-03-27','16:35:00',3.18),('6449','2013-03-27','16:40:00',2.13),('6449','2013-03-27','16:45:00',1.77),('6449','2013-03-27','16:50:00',1.31),('6449','2013-03-27','17:10:00',1.11),('6449','2013-03-27','17:15:00',1.16),('6449','2013-03-26','06:50:00',1.21),('6449','2013-03-26','06:55:00',1.38),('6449','2013-03-26','07:00:00',1.65),('6449','2013-03-26','07:05:00',1.42),('6449','2013-03-26','07:25:00',1.22),('6449','2013-03-26','07:30:00',1.54),('6449','2013-03-26','07:35:00',1.18),('6449','2013-03-26','07:40:00',1.1),('6449','2013-03-26','07:45:00',1.27),('6449','2013-03-26','07:50:00',1.57),('6449','2013-03-26','07:55:00',1.73),('6449','2013-03-26','08:00:00',2.14),('6449','2013-03-26','08:05:00',2.09),('6449','2013-03-26','08:10:00',2.4),('6449','2013-03-26','08:15:00',3.37),('6449','2013-03-26','08:20:00',7),('6449','2013-03-26','08:25:00',4.61),('6449','2013-03-26','08:30:00',3.03),('6449','2013-03-26','08:35:00',3.27),('6449','2013-03-26','08:40:00',2.67),('6449','2013-03-26','08:45:00',2.08),('6449','2013-03-26','08:50:00',2.3),('6449','2013-03-26','08:55:00',3.63),('6449','2013-03-26','09:00:00',3.32),('6449','2013-03-26','09:05:00',4.82),('6449','2013-03-26','09:10:00',6.77),('6449','2013-03-26','09:15:00',4.46),('6449','2013-03-26','09:20:00',6),('6449','2013-03-26','09:25:00',9.93),('6449','2013-03-26','09:30:00',2.8),('6449','2013-03-26','09:35:00',2.22),('6449','2013-03-26','09:40:00',1.77),('6449','2013-03-26','09:45:00',2.48),('6449','2013-03-26','09:50:00',3.61),('6449','2013-03-26','09:55:00',4.09),('6449','2013-03-26','10:00:00',3.52),('6449','2013-03-26','10:05:00',4.36),('6449','2013-03-26','10:10:00',8.11),('6449','2013-03-26','10:15:00',11.19),('6449','2013-03-26','10:20:00',8.65),('6449','2013-03-26','10:25:00',7.65),('6449','2013-03-26','10:30:00',6.19),('6449','2013-03-26','10:35:00',5.18),('6449','2013-03-26','10:40:00',6.06),('6449','2013-03-26','10:45:00',7.53),('6449','2013-03-26','10:50:00',5.61),('6449','2013-03-26','10:55:00',5.31),('6449','2013-03-26','11:00:00',4.57),('6449','2013-03-26','11:05:00',4.24),('6449','2013-03-26','11:10:00',3.99),('6449','2013-03-26','11:15:00',3.41),('6449','2013-03-26','11:20:00',3.4),('6449','2013-03-26','11:25:00',3.1),('6449','2013-03-26','11:30:00',3.19),('6449','2013-03-26','11:35:00',6.22),('6449','2013-03-26','11:40:00',8.36),('6449','2013-03-26','11:45:00',6.48),('6449','2013-03-26','11:50:00',5.08),('6449','2013-03-26','11:55:00',4.33),('6449','2013-03-26','12:00:00',7.1),('6449','2013-03-26','12:05:00',9.57),('6449','2013-03-26','12:10:00',8.62),('6449','2013-03-26','12:15:00',8.51),('6449','2013-03-26','12:20:00',12.52),('6449','2013-03-26','12:25:00',16.06),('6449','2013-03-26','12:30:00',11.86),('6449','2013-03-26','12:35:00',5.5),('6449','2013-03-26','12:40:00',5.73),('6449','2013-03-26','12:45:00',6.47),('6449','2013-03-26','12:50:00',5.14),('6449','2013-03-26','12:55:00',4.35),('6449','2013-03-26','13:00:00',6.72),('6449','2013-03-26','13:05:00',5.47),('6449','2013-03-26','13:10:00',3.95),('6449','2013-03-26','13:15:00',2.65),('6449','2013-03-26','13:20:00',5.29),('6449','2013-03-26','13:25:00',5.2),('6449','2013-03-26','13:30:00',6.17),('6449','2013-03-26','13:35:00',4.39),('6449','2013-03-26','13:40:00',5.26),('6449','2013-03-26','13:45:00',4.02),('6449','2013-03-26','13:50:00',2.68),('6449','2013-03-26','13:55:00',2.24),('6449','2013-03-26','14:00:00',2.54),('6449','2013-03-26','14:05:00',5.57),('6449','2013-03-26','14:10:00',5.72),('6449','2013-03-26','14:15:00',6.26),('6449','2013-03-26','14:20:00',5.17),('6449','2013-03-26','14:25:00',4.4),('6449','2013-03-26','14:30:00',4.44),('6449','2013-03-26','14:35:00',3.87),('6449','2013-03-26','14:40:00',3.37),('6449','2013-03-26','14:45:00',3.98),('6449','2013-03-26','14:50:00',3.65),('6449','2013-03-26','14:55:00',3.71),('6449','2013-03-26','15:00:00',3.96),('6449','2013-03-26','15:05:00',3.42),('6449','2013-03-26','15:10:00',3.71),('6449','2013-03-26','15:15:00',4.06),('6449','2013-03-26','15:20:00',4.17),('6449','2013-03-26','15:25:00',3.85),('6449','2013-03-26','15:30:00',2.72),('6449','2013-03-26','15:35:00',2.26),('6449','2013-03-26','15:40:00',2.55),('6449','2013-03-26','15:45:00',1.98),('6449','2013-03-26','15:50:00',1.34),('6449','2013-03-26','15:55:00',1.25),('6449','2013-03-26','16:00:00',1.25),('6449','2013-03-26','16:50:00',1.12),('6449','2013-03-26','16:55:00',1.06),('6449','2013-03-25','07:25:00',1.1),('6449','2013-03-25','07:30:00',1.24),('6449','2013-03-25','07:35:00',1.26),('6449','2013-03-25','07:40:00',2.1),('6449','2013-03-25','07:45:00',3.36),('6449','2013-03-25','07:50:00',4.7),('6449','2013-03-25','07:55:00',3.98),('6449','2013-03-25','08:00:00',2.99),('6449','2013-03-25','08:05:00',6.32),('6449','2013-03-25','08:10:00',6.18),('6449','2013-03-25','08:15:00',6.71),('6449','2013-03-25','08:20:00',10.11),('6449','2013-03-25','08:25:00',10.76),('6449','2013-03-25','08:30:00',11.54),('6449','2013-03-25','08:35:00',12.27),('6449','2013-03-25','08:40:00',12.42),('6449','2013-03-25','08:45:00',12.65),('6449','2013-03-25','08:50:00',10.18),('6449','2013-03-25','08:55:00',6.9),('6449','2013-03-25','09:00:00',6.4),('6449','2013-03-25','09:05:00',5.72),('6449','2013-03-25','09:10:00',6.57),('6449','2013-03-25','09:15:00',5.83),('6449','2013-03-25','09:20:00',6.76),('6449','2013-03-25','09:25:00',15.15),('6449','2013-03-25','09:30:00',10.01),('6449','2013-03-25','09:35:00',5.45),('6449','2013-03-25','09:40:00',6.19),('6449','2013-03-25','09:45:00',7.02),('6449','2013-03-25','09:50:00',4.59),('6449','2013-03-25','09:55:00',6.33),('6449','2013-03-25','10:00:00',4.73),('6449','2013-03-25','10:05:00',4.94),('6449','2013-03-25','10:10:00',5.58),('6449','2013-03-25','10:15:00',8.78),('6449','2013-03-25','10:20:00',14.91),('6449','2013-03-25','10:25:00',11.3),('6449','2013-03-25','10:30:00',15.69),('6449','2013-03-25','10:35:00',15.65),('6449','2013-03-25','10:40:00',17.03),('6449','2013-03-25','10:45:00',16.28),('6449','2013-03-25','10:50:00',14.41),('6449','2013-03-25','10:55:00',14.83),('6449','2013-03-25','11:00:00',12.45),('6449','2013-03-25','11:05:00',13.15),('6449','2013-03-25','11:10:00',11.16),('6449','2013-03-25','11:15:00',11.9),('6449','2013-03-25','11:20:00',19.25),('6449','2013-03-25','11:25:00',16.18),('6449','2013-03-25','11:30:00',18.81),('6449','2013-03-25','11:35:00',12.35),('6449','2013-03-25','11:40:00',5.28),('6449','2013-03-25','11:45:00',7.18),('6449','2013-03-25','11:50:00',15.94),('6449','2013-03-25','11:55:00',19.16),('6449','2013-03-25','12:00:00',13.02),('6449','2013-03-25','12:05:00',16.41),('6449','2013-03-25','12:10:00',15.57),('6449','2013-03-25','12:15:00',11.97),('6449','2013-03-25','12:20:00',16.3),('6449','2013-03-25','12:25:00',18.31),('6449','2013-03-25','12:30:00',16.88),('6449','2013-03-25','12:35:00',17.55),('6449','2013-03-25','12:40:00',16.31),('6449','2013-03-25','12:45:00',15.82),('6449','2013-03-25','12:50:00',16.6),('6449','2013-03-25','12:55:00',9.77),('6449','2013-03-25','13:00:00',5.47),('6449','2013-03-25','13:05:00',6.54),('6449','2013-03-25','13:10:00',12.68),('6449','2013-03-25','13:15:00',13.3),('6449','2013-03-25','13:20:00',14.1),('6449','2013-03-25','13:25:00',14.83),('6449','2013-03-25','13:30:00',9.33),('6449','2013-03-25','13:35:00',11.06),('6449','2013-03-25','13:40:00',13.45),('6449','2013-03-25','13:45:00',16.43),('6449','2013-03-25','13:50:00',12.16),('6449','2013-03-25','13:55:00',15.23),('6449','2013-03-25','14:00:00',15),('6449','2013-03-25','14:05:00',14.82),('6449','2013-03-25','14:10:00',12.95),('6449','2013-03-25','14:15:00',9.85),('6449','2013-03-25','14:20:00',9.62),('6449','2013-03-25','14:25:00',13.06),('6449','2013-03-25','14:30:00',12.63),('6449','2013-03-25','14:35:00',10.68),('6449','2013-03-25','14:40:00',8.92),('6449','2013-03-25','14:45:00',7.89),('6449','2013-03-25','14:50:00',9.71),('6449','2013-03-25','14:55:00',11.87),('6449','2013-03-25','15:00:00',9.56),('6449','2013-03-25','15:05:00',11.97),('6449','2013-03-25','15:10:00',11.5),('6449','2013-03-25','15:15:00',11.44),('6449','2013-03-25','15:20:00',9.74),('6449','2013-03-25','15:25:00',9.3),('6449','2013-03-25','15:30:00',10.42),('6449','2013-03-25','15:35:00',8.7),('6449','2013-03-25','15:40:00',7.8),('6449','2013-03-25','15:45:00',7.14),('6449','2013-03-25','15:50:00',8.15),('6449','2013-03-25','15:55:00',6.79),('6449','2013-03-25','16:00:00',3.57),('6449','2013-03-25','16:05:00',8.05),('6449','2013-03-25','16:10:00',5.91),('6449','2013-03-25','16:15:00',6.71),('6449','2013-03-25','16:20:00',5.21),('6449','2013-03-25','16:25:00',3.74),('6449','2013-03-25','16:30:00',2.84),('6449','2013-03-25','16:35:00',2.82),('6449','2013-03-25','16:40:00',2.6),('6449','2013-03-25','16:45:00',4.47),('6449','2013-03-25','16:50:00',4.11),('6449','2013-03-25','16:55:00',3.18),('6449','2013-03-25','17:00:00',3.5),('6449','2013-03-25','17:05:00',2.38),('6449','2013-03-25','17:10:00',2.08),('6449','2013-03-25','17:15:00',1.71),('6449','2013-03-25','17:20:00',1.4),('6449','2013-03-25','17:25:00',1.09),('6449','2013-03-24','06:45:00',1.13),('6449','2013-03-24','06:50:00',1.41),('6449','2013-03-24','06:55:00',1.88),('6449','2013-03-24','07:00:00',2.37),('6449','2013-03-24','07:05:00',2.82),('6449','2013-03-24','07:10:00',3.57),('6449','2013-03-24','07:15:00',3.72),('6449','2013-03-24','07:20:00',3.71),('6449','2013-03-24','07:25:00',4.26),('6449','2013-03-24','07:30:00',4.59),('6449','2013-03-24','07:35:00',4.55),('6449','2013-03-24','07:40:00',4.42),('6449','2013-03-24','07:45:00',5.15),('6449','2013-03-24','07:50:00',5.79),('6449','2013-03-24','07:55:00',6.65),('6449','2013-03-24','08:00:00',7.04),('6449','2013-03-24','08:05:00',7.3),('6449','2013-03-24','08:10:00',7.79),('6449','2013-03-24','08:15:00',8.29),('6449','2013-03-24','08:20:00',8.72),('6449','2013-03-24','08:25:00',9.03),('6449','2013-03-24','08:30:00',9.5),('6449','2013-03-24','08:35:00',9.79),('6449','2013-03-24','08:40:00',10.26),('6449','2013-03-24','08:45:00',10.59),('6449','2013-03-24','08:50:00',10.84),('6449','2013-03-24','08:55:00',11.23),('6449','2013-03-24','09:00:00',11.53),('6449','2013-03-24','09:05:00',11.68),('6449','2013-03-24','09:10:00',12.03),('6449','2013-03-24','09:15:00',12.36),('6449','2013-03-24','09:20:00',12.57),('6449','2013-03-24','09:25:00',12.79),('6449','2013-03-24','09:30:00',13.02),('6449','2013-03-24','09:35:00',13.23),('6449','2013-03-24','09:40:00',13.4),('6449','2013-03-24','09:45:00',13.55),('6449','2013-03-24','09:50:00',13.7),('6449','2013-03-24','09:55:00',13.9),('6449','2013-03-24','10:00:00',14.14),('6449','2013-03-24','10:05:00',14.33),('6449','2013-03-24','10:10:00',14.49),('6449','2013-03-24','10:15:00',14.67),('6449','2013-03-24','10:20:00',14.68),('6449','2013-03-24','10:25:00',15.02),('6449','2013-03-24','10:30:00',15.13),('6449','2013-03-24','10:35:00',15.1),('6449','2013-03-24','10:40:00',15.45),('6449','2013-03-24','10:45:00',15.6),('6449','2013-03-24','10:50:00',15.55),('6449','2013-03-24','10:55:00',15.8),('6449','2013-03-24','11:00:00',15.77),('6449','2013-03-24','11:05:00',15.78),('6449','2013-03-24','11:10:00',15.96),('6449','2013-03-24','11:15:00',15.98),('6449','2013-03-24','11:20:00',15.95),('6449','2013-03-24','11:25:00',16.08),('6449','2013-03-24','11:30:00',16.1),('6449','2013-03-24','11:35:00',16.11),('6449','2013-03-24','11:40:00',16.09),('6449','2013-03-24','11:45:00',16.04),('6449','2013-03-24','11:50:00',16.06),('6449','2013-03-24','11:55:00',15.91),('6449','2013-03-24','12:00:00',15.78),('6449','2013-03-24','12:05:00',15.57),('6449','2013-03-24','12:10:00',15.59),('6449','2013-03-24','12:15:00',15.57),('6449','2013-03-24','12:20:00',15.34),('6449','2013-03-24','12:25:00',15.36),('6449','2013-03-24','12:30:00',15.35),('6449','2013-03-24','12:35:00',15.24),('6449','2013-03-24','12:40:00',15.38),('6449','2013-03-24','12:45:00',15.71),('6449','2013-03-24','12:50:00',15.74),('6449','2013-03-24','12:55:00',15.73),('6449','2013-03-24','13:00:00',15.81),('6449','2013-03-24','13:05:00',15.63),('6449','2013-03-24','13:10:00',15.38),('6449','2013-03-24','13:15:00',15.16),('6449','2013-03-24','13:20:00',14.98),('6449','2013-03-24','13:25:00',14.88),('6449','2013-03-24','13:30:00',14.74),('6449','2013-03-24','13:35:00',14.7),('6449','2013-03-24','13:40:00',14.46),('6449','2013-03-24','13:45:00',14.31),('6449','2013-03-24','13:50:00',13.87),('6449','2013-03-24','13:55:00',14.05),('6449','2013-03-24','14:00:00',13.91),('6449','2013-03-24','14:05:00',13.32),('6449','2013-03-24','14:10:00',11.09),('6449','2013-03-24','14:15:00',13.39),('6449','2013-03-24','14:20:00',13),('6449','2013-03-24','14:25:00',12.91),('6449','2013-03-24','14:30:00',12.02),('6449','2013-03-24','14:35:00',12.17),('6449','2013-03-24','14:40:00',12.21),('6449','2013-03-24','14:45:00',11.73),('6449','2013-03-24','14:50:00',11.19),('6449','2013-03-24','14:55:00',10.62),('6449','2013-03-24','15:00:00',8.79),('6449','2013-03-24','15:05:00',5.87),('6449','2013-03-24','15:10:00',7.75),('6449','2013-03-24','15:15:00',5.94),('6449','2013-03-24','15:20:00',8.94),('6449','2013-03-24','15:25:00',4.51),('6449','2013-03-24','15:30:00',6.79),('6449','2013-03-24','15:35:00',6.7),('6449','2013-03-24','15:40:00',3.26),('6449','2013-03-24','15:45:00',5.09),('6449','2013-03-24','15:50:00',7.15),('6449','2013-03-24','15:55:00',3.33),('6449','2013-03-24','16:00:00',2.51),('6449','2013-03-24','16:05:00',4.72),('6449','2013-03-24','16:10:00',4.25),('6449','2013-03-24','16:15:00',3.36),('6449','2013-03-24','16:20:00',3.86),('6449','2013-03-24','16:25:00',2.69),('6449','2013-03-24','16:30:00',2.37),('6449','2013-03-24','16:35:00',2.5),('6449','2013-03-24','16:40:00',2.37),('6449','2013-03-24','16:45:00',2.63),('6449','2013-03-24','16:50:00',2.77),('6449','2013-03-24','16:55:00',2.22),('6449','2013-03-24','17:00:00',2.13),('6449','2013-03-24','17:05:00',1.64),('6449','2013-03-24','17:10:00',1.56),('6449','2013-03-24','17:15:00',1.37),('6449','2013-03-23','06:40:00',1.08),('6449','2013-03-23','06:45:00',1.28),('6449','2013-03-23','06:50:00',1.69),('6449','2013-03-23','06:55:00',1.96),('6449','2013-03-23','07:00:00',2.34),('6449','2013-03-23','07:05:00',2.62),('6449','2013-03-23','07:10:00',2.82),('6449','2013-03-23','07:15:00',2.77),('6449','2013-03-23','07:20:00',3.68),('6449','2013-03-23','07:25:00',3.79),('6449','2013-03-23','07:30:00',4.28),('6449','2013-03-23','07:35:00',4.83),('6449','2013-03-23','07:40:00',5.44),('6449','2013-03-23','07:45:00',5.71),('6449','2013-03-23','07:50:00',6.6),('6449','2013-03-23','07:55:00',6.87),('6449','2013-03-23','08:00:00',7.32),('6449','2013-03-23','08:05:00',7.66),('6449','2013-03-23','08:10:00',8.25),('6449','2013-03-23','08:15:00',8.52),('6449','2013-03-23','08:20:00',9.07),('6449','2013-03-23','08:25:00',9.22),('6449','2013-03-23','08:30:00',9.42),('6449','2013-03-23','08:35:00',9.87),('6449','2013-03-23','08:40:00',10.64),('6449','2013-03-23','08:45:00',10.38),('6449','2013-03-23','08:50:00',10.68),('6449','2013-03-23','08:55:00',11.14),('6449','2013-03-23','09:00:00',11.18),('6449','2013-03-23','09:05:00',11.71),('6449','2013-03-23','09:10:00',12.29),('6449','2013-03-23','09:15:00',12.39),('6449','2013-03-23','09:20:00',12.53),('6449','2013-03-23','09:25:00',12.81),('6449','2013-03-23','09:30:00',12.66),('6449','2013-03-23','09:35:00',13.38),('6449','2013-03-23','09:40:00',13.51),('6449','2013-03-23','09:45:00',13.56),('6449','2013-03-23','09:50:00',13.63),('6449','2013-03-23','09:55:00',13.17),('6449','2013-03-23','10:00:00',13.5),('6449','2013-03-23','10:05:00',13.34),('6449','2013-03-23','10:10:00',13.75),('6449','2013-03-23','10:15:00',13.27),('6449','2013-03-23','10:20:00',13.5),('6449','2013-03-23','10:25:00',13.18),('6449','2013-03-23','10:30:00',13.67),('6449','2013-03-23','10:35:00',14.21),('6449','2013-03-23','10:40:00',15.02),('6449','2013-03-23','10:45:00',14.86),('6449','2013-03-23','10:50:00',13.14),('6449','2013-03-23','10:55:00',15.59),('6449','2013-03-23','11:00:00',14.63),('6449','2013-03-23','11:05:00',15.31),('6449','2013-03-23','11:10:00',15.84),('6449','2013-03-23','11:15:00',14.61),('6449','2013-03-23','11:20:00',15.57),('6449','2013-03-23','11:25:00',15.92),('6449','2013-03-23','11:30:00',15.88),('6449','2013-03-23','11:35:00',15.44),('6449','2013-03-23','11:40:00',15.2),('6449','2013-03-23','11:45:00',14.87),('6449','2013-03-23','11:50:00',15.82),('6449','2013-03-23','11:55:00',16.09),('6449','2013-03-23','12:00:00',15.92),('6449','2013-03-23','12:05:00',16.2),('6449','2013-03-23','12:10:00',15.79),('6449','2013-03-23','12:15:00',16.01),('6449','2013-03-23','12:20:00',15.98),('6449','2013-03-23','12:25:00',15.86),('6449','2013-03-23','12:30:00',15.91),('6449','2013-03-23','12:35:00',15.62),('6449','2013-03-23','12:40:00',15.58),('6449','2013-03-23','12:45:00',15.52),('6449','2013-03-23','12:50:00',15.5),('6449','2013-03-23','12:55:00',15.48),('6449','2013-03-23','13:00:00',15.68),('6449','2013-03-23','13:05:00',15.3),('6449','2013-03-23','13:10:00',15.46),('6449','2013-03-23','13:15:00',15.23),('6449','2013-03-23','13:20:00',15.11),('6449','2013-03-23','13:25:00',15.15),('6449','2013-03-23','13:30:00',14.92),('6449','2013-03-23','13:35:00',14.69),('6449','2013-03-23','13:40:00',14.74),('6449','2013-03-23','13:45:00',14.64),('6449','2013-03-23','13:50:00',14.31),('6449','2013-03-23','13:55:00',13.74),('6449','2013-03-23','14:00:00',14.03),('6449','2013-03-23','14:05:00',13.59),('6449','2013-03-23','14:10:00',13.57),('6449','2013-03-23','14:15:00',13.07),('6449','2013-03-23','14:20:00',12.99),('6449','2013-03-23','14:25:00',12.41),('6449','2013-03-23','14:30:00',12.03),('6449','2013-03-23','14:35:00',11.16),('6449','2013-03-23','14:40:00',11.44),('6449','2013-03-23','14:45:00',12.16),('6449','2013-03-23','14:50:00',11.94),('6449','2013-03-23','14:55:00',10.62),('6449','2013-03-23','15:00:00',11.21),('6449','2013-03-23','15:05:00',11.35),('6449','2013-03-23','15:10:00',10.8),('6449','2013-03-23','15:15:00',10.04),('6449','2013-03-23','15:20:00',8.78),('6449','2013-03-23','15:25:00',8.53),('6449','2013-03-23','15:30:00',8.91),('6449','2013-03-23','15:35:00',8.68),('6449','2013-03-23','15:40:00',8.57),('6449','2013-03-23','15:45:00',7.96),('6449','2013-03-23','15:50:00',7.06),('6449','2013-03-23','15:55:00',6.99),('6449','2013-03-23','16:00:00',7.27),('6449','2013-03-23','16:05:00',7.07),('6449','2013-03-23','16:10:00',6.83),('6449','2013-03-23','16:15:00',5.48),('6449','2013-03-23','16:20:00',6.26),('6449','2013-03-23','16:25:00',6),('6449','2013-03-23','16:30:00',4.45),('6449','2013-03-23','16:35:00',3.82),('6449','2013-03-23','16:40:00',4.24),('6449','2013-03-23','16:45:00',3.73),('6449','2013-03-23','16:50:00',4.12),('6449','2013-03-23','16:55:00',4.1),('6449','2013-03-23','17:00:00',3.63),('6449','2013-03-23','17:05:00',2.87),('6449','2013-03-23','17:10:00',2.62),('6449','2013-03-23','17:15:00',2.32),('6449','2013-03-23','17:20:00',1.9),('6449','2013-03-23','17:25:00',1.6),('6449','2013-03-23','17:30:00',1.3),('6449','2013-03-23','17:35:00',1.03),('6449','2013-03-22','06:45:00',1.28),('6449','2013-03-22','06:50:00',1.63),('6449','2013-03-22','06:55:00',2.01),('6449','2013-03-22','07:00:00',2.4),('6449','2013-03-22','07:05:00',2.81),('6449','2013-03-22','07:10:00',3.23),('6449','2013-03-22','07:15:00',3.68),('6449','2013-03-22','07:20:00',4.12),('6449','2013-03-22','07:25:00',4.56),('6449','2013-03-22','07:30:00',5.01),('6449','2013-03-22','07:35:00',5.33),('6449','2013-03-22','07:40:00',5.89),('6449','2013-03-22','07:45:00',6.33),('6449','2013-03-22','07:50:00',6.76),('6449','2013-03-22','07:55:00',7.19),('6449','2013-03-22','08:00:00',7.59),('6449','2013-03-22','08:05:00',7.95),('6449','2013-03-22','08:10:00',8.39),('6449','2013-03-22','08:15:00',8.79),('6449','2013-03-22','08:20:00',9.18),('6449','2013-03-22','08:25:00',9.55),('6449','2013-03-22','08:30:00',9.88),('6449','2013-03-22','08:35:00',10.21),('6449','2013-03-22','08:40:00',10.61),('6449','2013-03-22','08:45:00',10.95),('6449','2013-03-22','08:50:00',11.26),('6449','2013-03-22','08:55:00',11.5),('6449','2013-03-22','09:00:00',11.78),('6449','2013-03-22','09:05:00',12.1),('6449','2013-03-22','09:10:00',12.35),('6449','2013-03-22','09:15:00',12.61),('6449','2013-03-22','09:20:00',12.52),('6449','2013-03-22','09:25:00',13.12),('6449','2013-03-22','09:30:00',13.37),('6449','2013-03-22','09:35:00',13.55),('6449','2013-03-22','09:40:00',13.72),('6449','2013-03-22','09:45:00',13.92),('6449','2013-03-22','09:50:00',14.04),('6449','2013-03-22','09:55:00',14.21),('6449','2013-03-22','10:00:00',14.34),('6449','2013-03-22','10:05:00',14.46),('6449','2013-03-22','10:10:00',14.61),('6449','2013-03-22','10:15:00',14.72),('6449','2013-03-22','10:20:00',14.75),('6449','2013-03-22','10:25:00',14.9),('6449','2013-03-22','10:30:00',15.07),('6449','2013-03-22','10:35:00',15.14),('6449','2013-03-22','10:40:00',15.08),('6449','2013-03-22','10:45:00',15.2),('6449','2013-03-22','10:50:00',15.34),('6449','2013-03-22','10:55:00',15.59),('6449','2013-03-22','11:00:00',15.81),('6449','2013-03-22','11:05:00',15.59),('6449','2013-03-22','11:10:00',16.07),('6449','2013-03-22','11:15:00',16.13),('6449','2013-03-22','11:20:00',16.28),('6449','2013-03-22','11:25:00',16.49),('6449','2013-03-22','11:30:00',16.57),('6449','2013-03-22','11:35:00',16.41),('6449','2013-03-22','11:40:00',16.74),('6449','2013-03-22','11:45:00',16.78),('6449','2013-03-22','11:50:00',16.8),('6449','2013-03-22','11:55:00',16.79),('6449','2013-03-22','12:00:00',16.84),('6449','2013-03-22','12:05:00',16.85),('6449','2013-03-22','12:10:00',16.83),('6449','2013-03-22','12:15:00',16.83),('6449','2013-03-22','12:20:00',16.74),('6449','2013-03-22','12:25:00',16.33),('6449','2013-03-22','12:30:00',16.54),('6449','2013-03-22','12:35:00',16.65),('6449','2013-03-22','12:40:00',16.63),('6449','2013-03-22','12:45:00',16.84),('6449','2013-03-22','12:50:00',16.43),('6449','2013-03-22','12:55:00',16.59),('6449','2013-03-22','13:00:00',16.47),('6449','2013-03-22','13:05:00',16.25),('6449','2013-03-22','13:10:00',15.03),('6449','2013-03-22','13:15:00',15.13),('6449','2013-03-22','13:20:00',15.71),('6449','2013-03-22','13:25:00',14.3),('6449','2013-03-22','13:30:00',14.69),('6449','2013-03-22','13:35:00',15.78),('6449','2013-03-22','13:40:00',15.56),('6449','2013-03-22','13:45:00',15.19),('6449','2013-03-22','13:50:00',14.98),('6449','2013-03-22','13:55:00',14.87),('6449','2013-03-22','14:00:00',14.66),('6449','2013-03-22','14:05:00',14.47),('6449','2013-03-22','14:10:00',14.3),('6449','2013-03-22','14:15:00',14.15),('6449','2013-03-22','14:20:00',13.92),('6449','2013-03-22','14:25:00',13.66),('6449','2013-03-22','14:30:00',13.42),('6449','2013-03-22','14:35:00',12.93),('6449','2013-03-22','14:40:00',13.03),('6449','2013-03-22','14:45:00',12.85),('6449','2013-03-22','14:50:00',12.61),('6449','2013-03-22','14:55:00',12.41),('6449','2013-03-22','15:00:00',11.69),('6449','2013-03-22','15:05:00',8.94),('6449','2013-03-22','15:10:00',10.61),('6449','2013-03-22','15:15:00',9.35),('6449','2013-03-22','15:20:00',10.76),('6449','2013-03-22','15:25:00',9.96),('6449','2013-03-22','15:30:00',9.55),('6449','2013-03-22','15:35:00',9.9),('6449','2013-03-22','15:40:00',8.32),('6449','2013-03-22','15:45:00',5.39),('6449','2013-03-22','15:50:00',5.3),('6449','2013-03-22','15:55:00',6.03),('6449','2013-03-22','16:00:00',7.96),('6449','2013-03-22','16:05:00',4.86),('6449','2013-03-22','16:10:00',3.93),('6449','2013-03-22','16:15:00',5.53),('6449','2013-03-22','16:20:00',4.94),('6449','2013-03-22','16:25:00',5.31),('6449','2013-03-22','16:30:00',5.88),('6449','2013-03-22','16:35:00',5.71),('6449','2013-03-22','16:40:00',4.74),('6449','2013-03-22','16:45:00',5.26),('6449','2013-03-22','16:50:00',4.4),('6449','2013-03-22','16:55:00',3.92),('6449','2013-03-22','17:00:00',3.99),('6449','2013-03-22','17:05:00',3.75),('6449','2013-03-22','17:10:00',3.39),('6449','2013-03-22','17:15:00',2.66),('6449','2013-03-22','17:20:00',1.99),('6449','2013-03-22','17:25:00',1.85),('6449','2013-03-22','17:30:00',1.67),('6449','2013-03-22','17:35:00',1.49),('6449','2013-03-22','17:40:00',1.07),('6449','2013-03-21','07:35:00',1.81),('6449','2013-03-21','07:40:00',2.4),('6449','2013-03-21','07:45:00',3.89),('6449','2013-03-21','07:50:00',2.01),('6449','2013-03-21','07:55:00',2.53),('6449','2013-03-21','08:00:00',2.99),('6449','2013-03-21','08:05:00',5.12),('6449','2013-03-21','08:10:00',3.15),('6449','2013-03-21','08:15:00',8.03),('6449','2013-03-21','08:20:00',9.25),('6449','2013-03-21','08:25:00',9.27),('6449','2013-03-21','08:30:00',9.81),('6449','2013-03-21','08:35:00',9.8),('6449','2013-03-21','08:40:00',8.74),('6449','2013-03-21','08:45:00',10.84),('6449','2013-03-21','08:50:00',11.29),('6449','2013-03-21','08:55:00',11.5),('6449','2013-03-21','09:00:00',12.06),('6449','2013-03-21','09:05:00',12.28),('6449','2013-03-21','09:10:00',12.51),('6449','2013-03-21','09:15:00',12.73),('6449','2013-03-21','09:20:00',13.05),('6449','2013-03-21','09:25:00',13.34),('6449','2013-03-21','09:30:00',13.7),('6449','2013-03-21','09:35:00',13.94),('6449','2013-03-21','09:40:00',14.16),('6449','2013-03-21','09:45:00',14.43),('6449','2013-03-21','09:50:00',14.51),('6449','2013-03-21','09:55:00',14.58),('6449','2013-03-21','10:00:00',14.6),('6449','2013-03-21','10:05:00',14.83),('6449','2013-03-21','10:10:00',14.64),('6449','2013-03-21','10:15:00',15.12),('6449','2013-03-21','10:20:00',15.48),('6449','2013-03-21','10:25:00',15.84),('6449','2013-03-21','10:30:00',16.23),('6449','2013-03-21','10:35:00',16.51),('6449','2013-03-21','10:40:00',16.56),('6449','2013-03-21','10:45:00',16.87),('6449','2013-03-21','10:50:00',16.98),('6449','2013-03-21','10:55:00',17.1),('6449','2013-03-21','11:00:00',17.18),('6449','2013-03-21','11:05:00',17.35),('6449','2013-03-21','11:10:00',17.35),('6449','2013-03-21','11:15:00',17.4),('6449','2013-03-21','11:20:00',17.45),('6449','2013-03-21','11:25:00',17.4),('6449','2013-03-21','11:30:00',17.62),('6449','2013-03-21','11:35:00',17.65),('6449','2013-03-21','11:40:00',17.67),('6449','2013-03-21','11:45:00',17.73),('6449','2013-03-21','11:50:00',17.79),('6449','2013-03-21','11:55:00',17.4),('6449','2013-03-21','12:00:00',17.81),('6449','2013-03-21','12:05:00',17.77),('6449','2013-03-21','12:10:00',17.7),('6449','2013-03-21','12:15:00',17.78),('6449','2013-03-21','12:20:00',17.81),('6449','2013-03-21','12:25:00',17.53),('6449','2013-03-21','12:30:00',17.72),('6449','2013-03-21','12:35:00',17.75),('6449','2013-03-21','12:40:00',17.69),('6449','2013-03-21','12:45:00',17.6),('6449','2013-03-21','12:50:00',17.44),('6449','2013-03-21','12:55:00',17.21),('6449','2013-03-21','13:00:00',17.18),('6449','2013-03-21','13:05:00',17.01),('6449','2013-03-21','13:10:00',16.73),('6449','2013-03-21','13:15:00',16.83),('6449','2013-03-21','13:20:00',16.6),('6449','2013-03-21','13:25:00',16.54),('6449','2013-03-21','13:30:00',16.44),('6449','2013-03-21','13:35:00',16.25),('6449','2013-03-21','13:40:00',15.79),('6449','2013-03-21','13:45:00',15.78),('6449','2013-03-21','13:50:00',15.59),('6449','2013-03-21','13:55:00',15.39),('6449','2013-03-21','14:00:00',15.2),('6449','2013-03-21','14:05:00',14.95),('6449','2013-03-21','14:10:00',14.43),('6449','2013-03-21','14:15:00',14.37),('6449','2013-03-21','14:20:00',14.28),('6449','2013-03-21','14:25:00',14.08),('6449','2013-03-21','14:30:00',14),('6449','2013-03-21','14:35:00',13.68),('6449','2013-03-21','14:40:00',13.4),('6449','2013-03-21','14:45:00',13.2),('6449','2013-03-21','14:50:00',12.86),('6449','2013-03-21','14:55:00',12.55),('6449','2013-03-21','15:00:00',12.38),('6449','2013-03-21','15:05:00',12.04),('6449','2013-03-21','15:10:00',11.77),('6449','2013-03-21','15:15:00',11.44),('6449','2013-03-21','15:20:00',11.05),('6449','2013-03-21','15:25:00',10.49),('6449','2013-03-21','15:30:00',10.42),('6449','2013-03-21','15:35:00',10.07),('6449','2013-03-21','15:40:00',9.71),('6449','2013-03-21','15:45:00',9.35),('6449','2013-03-21','15:50:00',8.96),('6449','2013-03-21','15:55:00',8.41),('6449','2013-03-21','16:00:00',8.2),('6449','2013-03-21','16:05:00',7.78),('6449','2013-03-21','16:10:00',7.36),('6449','2013-03-21','16:15:00',6.95),('6449','2013-03-21','16:20:00',5.78),('6449','2013-03-21','16:25:00',6.18),('6449','2013-03-21','16:30:00',5.63),('6449','2013-03-21','16:35:00',5.27),('6449','2013-03-21','16:40:00',4.8),('6449','2013-03-21','16:45:00',4.45),('6449','2013-03-21','16:50:00',4.06),('6449','2013-03-21','16:55:00',3.64),('6449','2013-03-21','17:00:00',3.23),('6449','2013-03-21','17:05:00',2.85),('6449','2013-03-21','17:10:00',2.4),('6449','2013-03-21','17:15:00',2.07),('6449','2013-03-21','17:20:00',1.74),('6449','2013-03-21','17:25:00',1.42),('6449','2013-03-21','17:30:00',1.15),('6449','2013-03-20','06:50:00',1.1),('6449','2013-03-20','06:55:00',1.66),('6449','2013-03-20','07:00:00',2.05),('6449','2013-03-20','07:05:00',2.41),('6449','2013-03-20','07:10:00',2.91),('6449','2013-03-20','07:15:00',3.44),('6449','2013-03-20','07:20:00',3.97),('6449','2013-03-20','07:25:00',4.57),('6449','2013-03-20','07:30:00',3.53),('6449','2013-03-20','07:35:00',3.27),('6449','2013-03-20','07:40:00',4.92),('6449','2013-03-20','07:45:00',5.43),('6449','2013-03-20','07:50:00',5.97),('6449','2013-03-20','07:55:00',6.77),('6449','2013-03-20','08:00:00',7.29),('6449','2013-03-20','08:05:00',7.65),('6449','2013-03-20','08:10:00',8.02),('6449','2013-03-20','08:15:00',8.73),('6449','2013-03-20','08:20:00',6.88),('6449','2013-03-20','08:25:00',5.12),('6449','2013-03-20','08:30:00',4.51),('6449','2013-03-20','08:35:00',9.18),('6449','2013-03-20','08:40:00',9.89),('6449','2013-03-20','08:45:00',9.82),('6449','2013-03-20','08:50:00',10.16),('6449','2013-03-20','08:55:00',10.85),('6449','2013-03-20','09:00:00',11.23),('6449','2013-03-20','09:05:00',11.26),('6449','2013-03-20','09:10:00',11.79),('6449','2013-03-20','09:15:00',10.26),('6449','2013-03-20','09:20:00',11.23),('6449','2013-03-20','09:25:00',10.89),('6449','2013-03-20','09:30:00',13.48),('6449','2013-03-20','09:35:00',13.3),('6449','2013-03-20','09:40:00',13.47),('6449','2013-03-20','09:45:00',13.4),('6449','2013-03-20','09:50:00',14.44),('6449','2013-03-20','09:55:00',13.9),('6449','2013-03-20','10:00:00',14.45),('6449','2013-03-20','10:05:00',14.68),('6449','2013-03-20','10:10:00',14.67),('6449','2013-03-20','10:15:00',14.62),('6449','2013-03-20','10:20:00',13.53),('6449','2013-03-20','10:25:00',12.83),('6449','2013-03-20','10:30:00',14.61),('6449','2013-03-20','10:35:00',13.51),('6449','2013-03-20','10:40:00',12.77),('6449','2013-03-20','10:45:00',6.45),('6449','2013-03-20','10:50:00',5.95),('6449','2013-03-20','10:55:00',8.35),('6449','2013-03-20','11:00:00',11),('6449','2013-03-20','11:05:00',13.08),('6449','2013-03-20','11:10:00',13.84),('6449','2013-03-20','11:15:00',8.8),('6449','2013-03-20','11:20:00',8.77),('6449','2013-03-20','11:25:00',8.74),('6449','2013-03-20','11:30:00',10.38),('6449','2013-03-20','11:35:00',9.27),('6449','2013-03-20','11:40:00',6.91),('6449','2013-03-20','11:45:00',7.98),('6449','2013-03-20','11:50:00',5.95),('6449','2013-03-20','11:55:00',5.78),('6449','2013-03-20','12:00:00',8.31),('6449','2013-03-20','12:05:00',10.35),('6449','2013-03-20','12:10:00',6.56),('6449','2013-03-20','12:15:00',3.87),('6449','2013-03-20','12:20:00',4.52),('6449','2013-03-20','12:25:00',4.56),('6449','2013-03-20','12:30:00',4.2),('6449','2013-03-20','12:35:00',4.04),('6449','2013-03-20','12:40:00',3.89),('6449','2013-03-20','12:45:00',4.66),('6449','2013-03-20','12:50:00',5.38),('6449','2013-03-20','12:55:00',3.34),('6449','2013-03-20','13:00:00',2.52),('6449','2013-03-20','13:05:00',3.39),('6449','2013-03-20','13:10:00',3.93),('6449','2013-03-20','13:15:00',3.76),('6449','2013-03-20','13:20:00',3.71),('6449','2013-03-20','13:25:00',4.12),('6449','2013-03-20','13:30:00',4.22),('6449','2013-03-20','13:35:00',4.28),('6449','2013-03-20','13:40:00',5.24),('6449','2013-03-20','13:45:00',5.31),('6449','2013-03-20','13:50:00',5.2),('6449','2013-03-20','13:55:00',4.68),('6449','2013-03-20','14:00:00',4.52),('6449','2013-03-20','14:05:00',3.75),('6449','2013-03-20','14:10:00',3.28),('6449','2013-03-20','14:15:00',2.59),('6449','2013-03-20','14:20:00',2.47),('6449','2013-03-20','14:25:00',2.67),('6449','2013-03-20','14:30:00',3.03),('6449','2013-03-20','14:35:00',2.63),('6449','2013-03-20','14:40:00',1.69),('6449','2013-03-20','14:45:00',1.65),('6449','2013-03-20','14:50:00',1.67),('6449','2013-03-20','14:55:00',1.38),('6449','2013-03-20','15:00:00',1.32),('6449','2013-03-20','15:05:00',1.12),('6449','2013-03-20','15:10:00',1.06),('6449','2013-03-20','15:15:00',1.25),('6449','2013-03-20','15:20:00',1.18),('6449','2013-03-20','15:25:00',1.19),('6449','2013-03-20','15:30:00',1.36),('6449','2013-03-20','15:35:00',1.01),('6449','2013-03-19','06:45:00',1.05),('6449','2013-03-19','06:50:00',1.33),('6449','2013-03-19','06:55:00',1.68),('6449','2013-03-19','07:00:00',2.02),('6449','2013-03-19','07:05:00',2.4),('6449','2013-03-19','07:10:00',2.82),('6449','2013-03-19','07:15:00',3.27),('6449','2013-03-19','07:20:00',3.67),('6449','2013-03-19','07:25:00',4.09),('6449','2013-03-19','07:30:00',4.49),('6449','2013-03-19','07:35:00',4.81),('6449','2013-03-19','07:40:00',5.34),('6449','2013-03-19','07:45:00',5.8),('6449','2013-03-19','07:50:00',6.19),('6449','2013-03-19','07:55:00',6.67),('6449','2013-03-19','08:00:00',7.18),('6449','2013-03-19','08:05:00',7.49),('6449','2013-03-19','08:10:00',8),('6449','2013-03-19','08:15:00',8.42),('6449','2013-03-19','08:20:00',8.79),('6449','2013-03-19','08:25:00',9.18),('6449','2013-03-19','08:30:00',9.54),('6449','2013-03-19','08:35:00',9.86),('6449','2013-03-19','08:40:00',10.31),('6449','2013-03-19','08:45:00',10.66),('6449','2013-03-19','08:50:00',10.98),('6449','2013-03-19','08:55:00',11.36),('6449','2013-03-19','09:00:00',11.68),('6449','2013-03-19','09:05:00',11.99),('6449','2013-03-19','09:10:00',12.33),('6449','2013-03-19','09:15:00',12.58),('6449','2013-03-19','09:20:00',12.88),('6449','2013-03-19','09:25:00',12.95),('6449','2013-03-19','09:30:00',13.29),('6449','2013-03-19','09:35:00',13.57),('6449','2013-03-19','09:40:00',13.81),('6449','2013-03-19','09:45:00',14.1),('6449','2013-03-19','09:50:00',14.33),('6449','2013-03-19','09:55:00',14.27),('6449','2013-03-19','10:00:00',14.79),('6449','2013-03-19','10:05:00',15.18),('6449','2013-03-19','10:10:00',15.36),('6449','2013-03-19','10:15:00',15.42),('6449','2013-03-19','10:20:00',15.73),('6449','2013-03-19','10:25:00',15.93),('6449','2013-03-19','10:30:00',16.13),('6449','2013-03-19','10:35:00',16.25),('6449','2013-03-19','10:40:00',16.33),('6449','2013-03-19','10:45:00',16.39),('6449','2013-03-19','10:50:00',16.65),('6449','2013-03-19','10:55:00',16.83),('6449','2013-03-19','11:00:00',17.07),('6449','2013-03-19','11:05:00',17.24),('6449','2013-03-19','11:10:00',17.08),('6449','2013-03-19','11:15:00',17.36),('6449','2013-03-19','11:20:00',17.23),('6449','2013-03-19','11:25:00',17.45),('6449','2013-03-19','11:30:00',17.77),('6449','2013-03-19','11:35:00',17.71),('6449','2013-03-19','11:40:00',17.32),('6449','2013-03-19','11:45:00',17.61),('6449','2013-03-19','11:50:00',17.53),('6449','2013-03-19','11:55:00',17.48),('6449','2013-03-19','12:00:00',17.44),('6449','2013-03-19','12:05:00',17.39),('6449','2013-03-19','12:10:00',17.35),('6449','2013-03-19','12:15:00',17.54),('6449','2013-03-19','12:20:00',17.44),('6449','2013-03-19','12:25:00',17.47),('6449','2013-03-19','12:30:00',17.43),('6449','2013-03-19','12:35:00',17.36),('6449','2013-03-19','12:40:00',17.28),('6449','2013-03-19','12:45:00',16.7),('6449','2013-03-19','12:50:00',16.72),('6449','2013-03-19','12:55:00',16.01),('6449','2013-03-19','13:00:00',16.68),('6449','2013-03-19','13:05:00',16.79),('6449','2013-03-19','13:10:00',16.64),('6449','2013-03-19','13:15:00',16.39),('6449','2013-03-19','13:20:00',15.93),('6449','2013-03-19','13:25:00',15.69),('6449','2013-03-19','13:30:00',16.17),('6449','2013-03-19','13:35:00',15.49),('6449','2013-03-19','13:40:00',15.06),('6449','2013-03-19','13:45:00',15.51),('6449','2013-03-19','13:50:00',15.28),('6449','2013-03-19','13:55:00',14.97),('6449','2013-03-19','14:00:00',14.86),('6449','2013-03-19','14:05:00',14.68),('6449','2013-03-19','14:10:00',14.44),('6449','2013-03-19','14:15:00',14.38),('6449','2013-03-19','14:20:00',14.15),('6449','2013-03-19','14:25:00',13.78),('6449','2013-03-19','14:30:00',13.67),('6449','2013-03-19','14:35:00',13.5),('6449','2013-03-19','14:40:00',13.09),('6449','2013-03-19','14:45:00',13.03),('6449','2013-03-19','14:50:00',12.7),('6449','2013-03-19','14:55:00',12.27),('6449','2013-03-19','15:00:00',12.01),('6449','2013-03-19','15:05:00',11.72),('6449','2013-03-19','15:10:00',11.23),('6449','2013-03-19','15:15:00',11.24),('6449','2013-03-19','15:20:00',10.99),('6449','2013-03-19','15:25:00',10.61),('6449','2013-03-19','15:30:00',10.26),('6449','2013-03-19','15:35:00',9.92),('6449','2013-03-19','15:40:00',9.59),('6449','2013-03-19','15:45:00',9.26),('6449','2013-03-19','15:50:00',8.93),('6449','2013-03-19','15:55:00',8.54),('6449','2013-03-19','16:00:00',8.15),('6449','2013-03-19','16:05:00',7.78),('6449','2013-03-19','16:10:00',7.34),('6449','2013-03-19','16:15:00',6.94),('6449','2013-03-19','16:20:00',6.38),('6449','2013-03-19','16:25:00',6.12),('6449','2013-03-19','16:30:00',5.77),('6449','2013-03-19','16:35:00',5.26),('6449','2013-03-19','16:40:00',4.46),('6449','2013-03-19','16:45:00',4.04),('6449','2013-03-19','16:50:00',3.63),('6449','2013-03-19','16:55:00',3.06),('6449','2013-03-19','17:00:00',3.27),('6449','2013-03-19','17:05:00',1.9),('6449','2013-03-19','17:10:00',1.87),('6449','2013-03-19','17:15:00',2.45),('6449','2013-03-19','17:20:00',2.14),('6449','2013-03-19','17:25:00',1.68),('6449','2013-03-19','17:30:00',1.23),('6449','2013-03-18','06:50:00',1.02),('6449','2013-03-18','06:55:00',1.56),('6449','2013-03-18','07:00:00',1.7),('6449','2013-03-18','07:05:00',1.1),('6449','2013-03-18','07:10:00',1.33),('6449','2013-03-18','07:15:00',1.23),('6449','2013-03-18','07:20:00',1.34),('6449','2013-03-18','07:25:00',1.49),('6449','2013-03-18','07:30:00',1.26),('6449','2013-03-18','07:35:00',1.78),('6449','2013-03-18','07:40:00',1.82),('6449','2013-03-18','07:45:00',2.19),('6449','2013-03-18','07:50:00',2.87),('6449','2013-03-18','07:55:00',2.17),('6449','2013-03-18','08:00:00',2.06),('6449','2013-03-18','08:05:00',2.25),('6449','2013-03-18','08:10:00',1.95),('6449','2013-03-18','08:15:00',1.64),('6449','2013-03-18','08:20:00',1.47),('6449','2013-03-18','08:25:00',1.19),('6449','2013-03-18','08:30:00',1.3),('6449','2013-03-18','08:35:00',1.62),('6449','2013-03-18','08:40:00',1.83),('6449','2013-03-18','08:45:00',1.75),('6449','2013-03-18','08:50:00',1.65),('6449','2013-03-18','08:55:00',1.7),('6449','2013-03-18','09:00:00',1.59),('6449','2013-03-18','09:05:00',1.26),('6449','2013-03-18','09:10:00',1.51),('6449','2013-03-18','09:15:00',1.65),('6449','2013-03-18','09:20:00',1.71),('6449','2013-03-18','09:25:00',1.58),('6449','2013-03-18','09:30:00',1.55),('6449','2013-03-18','09:35:00',1.97),('6449','2013-03-18','09:40:00',2.37),('6449','2013-03-18','09:45:00',3),('6449','2013-03-18','09:50:00',3.55),('6449','2013-03-18','09:55:00',3.4),('6449','2013-03-18','10:00:00',3.76),('6449','2013-03-18','10:05:00',5.04),('6449','2013-03-18','10:10:00',4.29),('6449','2013-03-18','10:15:00',3.56),('6449','2013-03-18','10:20:00',3.42),('6449','2013-03-18','10:25:00',3.61),('6449','2013-03-18','10:30:00',3.72),('6449','2013-03-18','10:35:00',3.32),('6449','2013-03-18','10:40:00',2.78),('6449','2013-03-18','10:45:00',3.06),('6449','2013-03-18','10:50:00',4.39),('6449','2013-03-18','10:55:00',5.52),('6449','2013-03-18','11:00:00',6.54),('6449','2013-03-18','11:05:00',6.91),('6449','2013-03-18','11:10:00',7.28),('6449','2013-03-18','11:15:00',6.97),('6449','2013-03-18','11:20:00',6.55),('6449','2013-03-18','11:25:00',4.79),('6449','2013-03-18','11:30:00',4.1),('6449','2013-03-18','11:35:00',3.65),('6449','2013-03-18','11:40:00',4.3),('6449','2013-03-18','11:45:00',4.37),('6449','2013-03-18','11:50:00',4.62),('6449','2013-03-18','11:55:00',4.29),('6449','2013-03-18','12:00:00',4.23),('6449','2013-03-18','12:05:00',4.82),('6449','2013-03-18','12:10:00',3.83),('6449','2013-03-18','12:15:00',3.67),('6449','2013-03-18','12:20:00',4.01),('6449','2013-03-18','12:25:00',3.44),('6449','2013-03-18','12:30:00',3.24),('6449','2013-03-18','12:35:00',2.88),('6449','2013-03-18','12:40:00',2.66),('6449','2013-03-18','12:45:00',2.71),('6449','2013-03-18','12:50:00',2.52),('6449','2013-03-18','12:55:00',3.14),('6449','2013-03-18','13:00:00',5.34),('6449','2013-03-18','13:05:00',4.74),('6449','2013-03-18','13:10:00',4),('6449','2013-03-18','13:15:00',3.47),('6449','2013-03-18','13:20:00',2.81),('6449','2013-03-18','13:25:00',2.96),('6449','2013-03-18','13:30:00',2.36),('6449','2013-03-18','13:35:00',2.02),('6449','2013-03-18','13:40:00',2.62),('6449','2013-03-18','13:45:00',3.9),('6449','2013-03-18','13:50:00',9.37),('6449','2013-03-18','13:55:00',11.38),('6449','2013-03-18','14:00:00',3.5),('6449','2013-03-18','14:05:00',3.08),('6449','2013-03-18','14:10:00',2.14),('6449','2013-03-18','14:15:00',1.7),('6449','2013-03-18','14:20:00',1.58),('6449','2013-03-18','14:25:00',1.14),('6449','2013-03-18','14:45:00',1.01),('6449','2013-03-18','15:10:00',1.03),('6449','2013-03-17','07:25:00',1.08),('6449','2013-03-17','07:30:00',1.07),('6449','2013-03-17','07:35:00',1.04),('6449','2013-03-17','07:40:00',1.25),('6449','2013-03-17','07:45:00',1.35),('6449','2013-03-17','07:50:00',1.42),('6449','2013-03-17','07:55:00',1.56),('6449','2013-03-17','08:00:00',2.16),('6449','2013-03-17','08:05:00',2.63),('6449','2013-03-17','08:10:00',2.74),('6449','2013-03-17','08:15:00',2.71),('6449','2013-03-17','08:20:00',3),('6449','2013-03-17','08:25:00',3.48),('6449','2013-03-17','08:30:00',4.58),('6449','2013-03-17','08:35:00',5.11),('6449','2013-03-17','08:40:00',5.05),('6449','2013-03-17','08:45:00',5.22),('6449','2013-03-17','08:50:00',5.56),('6449','2013-03-17','08:55:00',5),('6449','2013-03-17','09:00:00',4.9),('6449','2013-03-17','09:05:00',5.77),('6449','2013-03-17','09:10:00',4.83),('6449','2013-03-17','09:15:00',4.33),('6449','2013-03-17','09:20:00',4.99),('6449','2013-03-17','09:25:00',5.8),('6449','2013-03-17','09:30:00',5.63),('6449','2013-03-17','09:35:00',5.21),('6449','2013-03-17','09:40:00',4.81),('6449','2013-03-17','09:45:00',4.13),('6449','2013-03-17','09:50:00',3.63),('6449','2013-03-17','09:55:00',4.01),('6449','2013-03-17','10:00:00',4.62),('6449','2013-03-17','10:05:00',4.79),('6449','2013-03-17','10:10:00',5),('6449','2013-03-17','10:15:00',5.63),('6449','2013-03-17','10:20:00',6.02),('6449','2013-03-17','10:25:00',5.81),('6449','2013-03-17','10:30:00',4.62),('6449','2013-03-17','10:35:00',4.59),('6449','2013-03-17','10:40:00',4.31),('6449','2013-03-17','10:45:00',4.14),('6449','2013-03-17','10:50:00',4.14),('6449','2013-03-17','10:55:00',4.16),('6449','2013-03-17','11:00:00',5.3),('6449','2013-03-17','11:05:00',5.72),('6449','2013-03-17','11:10:00',6.14),('6449','2013-03-17','11:15:00',7.61),('6449','2013-03-17','11:20:00',7.5),('6449','2013-03-17','11:25:00',6.61),('6449','2013-03-17','11:30:00',6.47),('6449','2013-03-17','11:35:00',6.1),('6449','2013-03-17','11:40:00',5.75),('6449','2013-03-17','11:45:00',4.78),('6449','2013-03-17','11:50:00',5.67),('6449','2013-03-17','11:55:00',5.98),('6449','2013-03-17','12:00:00',6.39),('6449','2013-03-17','12:05:00',8.31),('6449','2013-03-17','12:10:00',10.23),('6449','2013-03-17','12:15:00',8.05),('6449','2013-03-17','12:20:00',7.62),('6449','2013-03-17','12:25:00',8.67),('6449','2013-03-17','12:30:00',9.11),('6449','2013-03-17','12:35:00',7.9),('6449','2013-03-17','12:40:00',6.57),('6449','2013-03-17','12:45:00',6.04),('6449','2013-03-17','12:50:00',5.27),('6449','2013-03-17','12:55:00',4.98),('6449','2013-03-17','13:00:00',4.53),('6449','2013-03-17','13:05:00',4.92),('6449','2013-03-17','13:10:00',4.23),('6449','2013-03-17','13:15:00',3.54),('6449','2013-03-17','13:20:00',3.18),('6449','2013-03-17','13:25:00',3.43),('6449','2013-03-17','13:30:00',2.76),('6449','2013-03-17','13:35:00',4.04),('6449','2013-03-17','13:40:00',4.2),('6449','2013-03-17','13:45:00',4.09),('6449','2013-03-17','13:50:00',5.11),('6449','2013-03-17','13:55:00',5.93),('6449','2013-03-17','14:00:00',5.07),('6449','2013-03-17','14:05:00',4.79),('6449','2013-03-17','14:10:00',5.84),('6449','2013-03-17','14:15:00',7.15),('6449','2013-03-17','14:20:00',8.29),('6449','2013-03-17','14:25:00',7.32),('6449','2013-03-17','14:30:00',5.97),('6449','2013-03-17','14:35:00',4.75),('6449','2013-03-17','14:40:00',5.29),('6449','2013-03-17','14:45:00',6.42),('6449','2013-03-17','14:50:00',6.28),('6449','2013-03-17','14:55:00',5.93),('6449','2013-03-17','15:00:00',5.75),('6449','2013-03-17','15:05:00',5.57),('6449','2013-03-17','15:10:00',6.25),('6449','2013-03-17','15:15:00',5.3),('6449','2013-03-17','15:20:00',4.26),('6449','2013-03-17','15:25:00',3.65),('6449','2013-03-17','15:30:00',3.21),('6449','2013-03-17','15:35:00',2.12),('6449','2013-03-17','15:40:00',1.25),('6449','2013-03-17','15:50:00',1.06),('6449','2013-03-17','15:55:00',1.47),('6449','2013-03-17','16:00:00',1.62),('6449','2013-03-17','16:05:00',1.71),('6449','2013-03-17','16:10:00',1.7),('6449','2013-03-17','16:15:00',1.68),('6449','2013-03-17','16:20:00',1.41),('6449','2013-03-17','16:25:00',1.81),('6449','2013-03-17','16:30:00',2.89),('6449','2013-03-17','16:35:00',2.9),('6449','2013-03-17','16:40:00',1.28),('6449','2013-03-16','07:10:00',1.4),('6449','2013-03-16','07:15:00',1.47),('6449','2013-03-16','07:20:00',1.22),('6449','2013-03-16','07:25:00',1.16),('6449','2013-03-16','07:30:00',2.77),('6449','2013-03-16','07:35:00',4.32),('6449','2013-03-16','07:40:00',3.11),('6449','2013-03-16','07:45:00',4.09),('6449','2013-03-16','07:50:00',5.18),('6449','2013-03-16','07:55:00',3.52),('6449','2013-03-16','08:00:00',6.03),('6449','2013-03-16','08:05:00',5.42),('6449','2013-03-16','08:10:00',6.35),('6449','2013-03-16','08:15:00',8.72),('6449','2013-03-16','08:20:00',9.59),('6449','2013-03-16','08:25:00',6.62),('6449','2013-03-16','08:30:00',6.84),('6449','2013-03-16','08:35:00',10.16),('6449','2013-03-16','08:40:00',10.35),('6449','2013-03-16','08:45:00',10.76),('6449','2013-03-16','08:50:00',10.81),('6449','2013-03-16','08:55:00',11.04),('6449','2013-03-16','09:00:00',11.44),('6449','2013-03-16','09:05:00',11.75),('6449','2013-03-16','09:10:00',12.03),('6449','2013-03-16','09:15:00',12.86),('6449','2013-03-16','09:20:00',13.57),('6449','2013-03-16','09:25:00',14.04),('6449','2013-03-16','09:30:00',14.14),('6449','2013-03-16','09:35:00',14.03),('6449','2013-03-16','09:40:00',13.96),('6449','2013-03-16','09:45:00',14.18),('6449','2013-03-16','09:50:00',14.37),('6449','2013-03-16','09:55:00',14.45),('6449','2013-03-16','10:00:00',14.54),('6449','2013-03-16','10:05:00',14.72),('6449','2013-03-16','10:10:00',14.92),('6449','2013-03-16','10:18:00',15.12),('6449','2013-03-16','10:20:00',15.39),('6449','2013-03-16','10:25:00',15.31),('6449','2013-03-16','10:30:00',15.62),('6449','2013-03-16','10:35:00',15.74),('6449','2013-03-16','10:40:00',15.88),('6449','2013-03-16','10:45:00',15.76),('6449','2013-03-16','10:50:00',16.1),('6449','2013-03-16','10:55:00',16.11),('6449','2013-03-16','11:00:00',16.23),('6449','2013-03-16','11:05:00',16.33),('6449','2013-03-16','11:10:00',16.37),('6449','2013-03-16','11:19:00',16.48),('6449','2013-03-16','11:20:00',16.77),('6449','2013-03-16','11:25:00',16.8),('6449','2013-03-16','11:30:00',16.82),('6449','2013-03-16','11:35:00',16.84),('6449','2013-03-16','11:40:00',16.78),('6449','2013-03-16','11:45:00',16.78),('6449','2013-03-16','11:50:00',16.85),('6449','2013-03-16','11:55:00',16.76),('6449','2013-03-16','12:00:00',16.78),('6449','2013-03-16','12:05:00',16.96),('6449','2013-03-16','12:10:00',16.82),('6449','2013-03-16','12:15:00',16.8),('6449','2013-03-16','12:20:00',16.76),('6449','2013-03-16','12:25:00',16.78),('6449','2013-03-16','12:30:00',16.7),('6449','2013-03-16','12:35:00',16.97),('6449','2013-03-16','12:40:00',15.96),('6449','2013-03-16','12:45:00',12.8),('6449','2013-03-16','12:50:00',16.96),('6449','2013-03-16','12:55:00',16.49),('6449','2013-03-16','13:00:00',14.31),('6449','2013-03-16','13:05:00',7.43),('6449','2013-03-16','13:10:00',11.63),('6449','2013-03-16','13:15:00',15.22),('6449','2013-03-16','13:20:00',16.73),('6449','2013-03-16','13:25:00',16.89),('6449','2013-03-16','13:30:00',10.78),('6449','2013-03-16','13:35:00',15.77),('6449','2013-03-16','13:40:00',16.9),('6449','2013-03-16','13:45:00',14.81),('6449','2013-03-16','13:50:00',17.33),('6449','2013-03-16','13:55:00',16.52),('6449','2013-03-16','14:00:00',16.37),('6449','2013-03-16','14:05:00',15.95),('6449','2013-03-16','14:10:00',15.41),('6449','2013-03-16','14:15:00',14.3),('6449','2013-03-16','14:20:00',13.98),('6449','2013-03-16','14:25:00',13.6),('6449','2013-03-16','14:30:00',13.36),('6449','2013-03-16','14:35:00',13.34),('6449','2013-03-16','14:40:00',13.14),('6449','2013-03-16','14:45:00',13.05),('6449','2013-03-16','14:50:00',12.95),('6449','2013-03-16','14:55:00',12.6),('6449','2013-03-16','15:00:00',12.15),('6449','2013-03-16','15:05:00',11.62),('6449','2013-03-16','15:10:00',11.38),('6449','2013-03-16','15:15:00',11.06),('6449','2013-03-16','15:20:00',10.74),('6449','2013-03-16','15:25:00',10.38),('6449','2013-03-16','15:30:00',10.05),('6449','2013-03-16','15:35:00',9.66),('6449','2013-03-16','15:40:00',9.28),('6449','2013-03-16','15:45:00',8.98),('6449','2013-03-16','15:50:00',8.68),('6449','2013-03-16','15:55:00',8.3),('6449','2013-03-16','16:00:00',7.88),('6449','2013-03-16','16:05:00',7.57),('6449','2013-03-16','16:10:00',7.2),('6449','2013-03-16','16:15:00',6.94),('6449','2013-03-16','16:20:00',6.51),('6449','2013-03-16','16:25:00',5.98),('6449','2013-03-16','16:30:00',5.56),('6449','2013-03-16','16:35:00',5.12),('6449','2013-03-16','16:40:00',4.64),('6449','2013-03-16','16:45:00',4.21),('6449','2013-03-16','16:50:00',3.75),('6449','2013-03-16','16:55:00',3.4),('6449','2013-03-16','17:00:00',2.98),('6449','2013-03-16','17:05:00',2.65),('6449','2013-03-16','17:10:00',2.28),('6449','2013-03-16','17:15:00',1.9),('6449','2013-03-16','17:20:00',1.6),('6449','2013-03-16','17:25:00',1.31),('6449','2013-03-16','17:30:00',1.03),('6449','2013-03-15','07:20:00',1.18),('6449','2013-03-15','07:25:00',1.47),('6449','2013-03-15','07:30:00',1.64),('6449','2013-03-15','07:35:00',1.7),('6449','2013-03-15','07:40:00',1.74),('6449','2013-03-15','07:45:00',1.76),('6449','2013-03-15','07:50:00',1.81),('6449','2013-03-15','07:55:00',1.86),('6449','2013-03-15','08:00:00',2.07),('6449','2013-03-15','08:05:00',2.2),('6449','2013-03-15','08:10:00',2),('6449','2013-03-15','08:15:00',1.94),('6449','2013-03-15','08:20:00',1.7),('6449','2013-03-15','08:25:00',1.55),('6449','2013-03-15','08:30:00',1.94),('6449','2013-03-15','08:35:00',2.23),('6449','2013-03-15','08:40:00',2.11),('6449','2013-03-15','08:45:00',2.14),('6449','2013-03-15','08:50:00',2.27),('6449','2013-03-15','08:55:00',2.36),('6449','2013-03-15','09:00:00',2.39),('6449','2013-03-15','09:05:00',2.29),('6449','2013-03-15','09:10:00',1.85),('6449','2013-03-15','09:15:00',1.7),('6449','2013-03-15','09:20:00',1.73),('6449','2013-03-15','09:25:00',1.82),('6449','2013-03-15','09:30:00',2.17),('6449','2013-03-15','09:35:00',2.59),('6449','2013-03-15','09:40:00',2.72),('6449','2013-03-15','09:45:00',2.68),('6449','2013-03-15','09:50:00',2.8),('6449','2013-03-15','09:55:00',2.83),('6449','2013-03-15','10:00:00',2.72),('6449','2013-03-15','10:05:00',2.8),('6449','2013-03-15','10:10:00',2.81),('6449','2013-03-15','10:15:00',2.85),('6449','2013-03-15','10:20:00',2.75),('6449','2013-03-15','10:25:00',2.91),('6449','2013-03-15','10:30:00',3.23),('6449','2013-03-15','10:35:00',3.83),('6449','2013-03-15','10:40:00',5.34),('6449','2013-03-15','10:45:00',7.31),('6449','2013-03-15','10:50:00',4.9),('6449','2013-03-15','10:55:00',4.46),('6449','2013-03-15','11:00:00',4.25),('6449','2013-03-15','11:05:00',4.39),('6449','2013-03-15','11:10:00',4.98),('6449','2013-03-15','11:15:00',5.48),('6449','2013-03-15','11:20:00',5.62),('6449','2013-03-15','11:25:00',5.68),('6449','2013-03-15','11:30:00',6.76),('6449','2013-03-15','11:35:00',7.48),('6449','2013-03-15','11:40:00',6.73),('6449','2013-03-15','11:45:00',6.79),('6449','2013-03-15','11:50:00',6.71),('6449','2013-03-15','11:55:00',7.26),('6449','2013-03-15','12:00:00',6.86),('6449','2013-03-15','12:05:00',6.75),('6449','2013-03-15','12:10:00',7.04),('6449','2013-03-15','12:15:00',8.1),('6449','2013-03-15','12:20:00',8.18),('6449','2013-03-15','12:25:00',7.19),('6449','2013-03-15','12:30:00',7.75),('6449','2013-03-15','12:35:00',7.76),('6449','2013-03-15','12:40:00',6.69),('6449','2013-03-15','12:45:00',7.26),('6449','2013-03-15','12:50:00',6.74),('6449','2013-03-15','12:55:00',6.57),('6449','2013-03-15','13:00:00',7.4),('6449','2013-03-15','13:05:00',8.24),('6449','2013-03-15','13:10:00',10.01),('6449','2013-03-15','13:15:00',6.41),('6449','2013-03-15','13:20:00',5.13),('6449','2013-03-15','13:25:00',3.88),('6449','2013-03-15','13:30:00',3.51),('6449','2013-03-15','13:35:00',3.3),('6449','2013-03-15','13:40:00',3.9),('6449','2013-03-15','13:45:00',5.34),('6449','2013-03-15','13:50:00',6.64),('6449','2013-03-15','13:55:00',6.56),('6449','2013-03-15','14:00:00',6.11),('6449','2013-03-15','14:05:00',6.33),('6449','2013-03-15','14:10:00',5.91),('6449','2013-03-15','14:15:00',5.35),('6449','2013-03-15','14:20:00',5.41),('6449','2013-03-15','14:25:00',5.96),('6449','2013-03-15','14:30:00',6.61),('6449','2013-03-15','14:35:00',9.82),('6449','2013-03-15','14:40:00',7.5),('6449','2013-03-15','14:45:00',6.32),('6449','2013-03-15','14:50:00',5.27),('6449','2013-03-15','14:55:00',5.54),('6449','2013-03-15','15:00:00',4.61),('6449','2013-03-15','15:05:00',4.08),('6449','2013-03-15','15:10:00',4.1),('6449','2013-03-15','15:15:00',5.02),('6449','2013-03-15','15:20:00',5.62),('6449','2013-03-15','15:25:00',4.12),('6449','2013-03-15','15:30:00',3.85),('6449','2013-03-15','15:35:00',2.98),('6449','2013-03-15','15:40:00',2.09),('6449','2013-03-15','15:45:00',2.21),('6449','2013-03-15','15:50:00',2.39),('6449','2013-03-15','15:55:00',1.9),('6449','2013-03-15','16:00:00',1.6),('6449','2013-03-15','16:05:00',1.25),('6449','2013-03-15','16:10:00',1.27),('6449','2013-03-15','16:15:00',1.67),('6449','2013-03-15','16:20:00',1.74),('6449','2013-03-15','16:25:00',1.53),('6449','2013-03-15','16:30:00',1.55),('6449','2013-03-15','16:35:00',2.43),('6449','2013-03-15','16:40:00',4.39),('6449','2013-03-15','16:45:00',4.11),('6449','2013-03-15','16:50:00',5.19),('6449','2013-03-15','16:55:00',3.35),('6449','2013-03-15','17:00:00',3.61),('6449','2013-03-15','17:05:00',3.18),('6449','2013-03-15','17:10:00',2.85),('6449','2013-03-15','17:15:00',2.59),('6449','2013-03-15','17:20:00',1.99),('6449','2013-03-15','17:25:00',1.3),('6449','2013-03-15','17:30:00',1.03),('6449','2013-03-14','07:05:00',1.34),('6449','2013-03-14','07:10:00',1.66),('6449','2013-03-14','07:15:00',1.52),('6449','2013-03-14','07:20:00',1.44),('6449','2013-03-14','07:25:00',1.48),('6449','2013-03-14','07:30:00',1.49),('6449','2013-03-14','07:35:00',1.43),('6449','2013-03-14','07:40:00',1.26),('6449','2013-03-14','08:50:00',1.16),('6449','2013-03-14','08:55:00',1.3),('6449','2013-03-14','09:00:00',1.36),('6449','2013-03-14','09:05:00',1.33),('6449','2013-03-14','09:10:00',1.32),('6449','2013-03-14','09:15:00',1.3),('6449','2013-03-14','09:20:00',1.21),('6449','2013-03-14','09:25:00',1.17),('6449','2013-03-14','09:30:00',1.09),('6449','2013-03-14','10:05:00',1.04),('6449','2013-03-14','10:10:00',1.17),('6449','2013-03-14','10:15:00',1.25),('6449','2013-03-14','10:20:00',1.33),('6449','2013-03-14','10:25:00',1.34),('6449','2013-03-14','10:30:00',1.51),('6449','2013-03-14','10:35:00',1.71),('6449','2013-03-14','10:40:00',1.85),('6449','2013-03-14','10:45:00',2.09),('6449','2013-03-14','10:50:00',2.27),('6449','2013-03-14','10:55:00',2.38),('6449','2013-03-14','11:00:00',2.41),('6449','2013-03-14','11:05:00',2.53),('6449','2013-03-14','11:10:00',2.62),('6449','2013-03-14','11:15:00',2.57),('6449','2013-03-14','11:20:00',2.71),('6449','2013-03-14','11:25:00',2.81),('6449','2013-03-14','11:30:00',3.36),('6449','2013-03-14','11:35:00',3.37),('6449','2013-03-14','11:40:00',2.76),('6449','2013-03-14','11:45:00',3.21),('6449','2013-03-14','11:50:00',3.36),('6449','2013-03-14','11:55:00',4.54),('6449','2013-03-14','12:00:00',4.42),('6449','2013-03-14','12:05:00',3.82),('6449','2013-03-14','12:10:00',3.66),('6449','2013-03-14','12:15:00',3.11),('6449','2013-03-14','12:20:00',2.57),('6449','2013-03-14','12:25:00',2.25),('6449','2013-03-14','12:30:00',1.88),('6449','2013-03-14','12:35:00',1.82),('6449','2013-03-14','12:40:00',2.14),('6449','2013-03-14','12:45:00',2.79),('6449','2013-03-14','12:50:00',3.31),('6449','2013-03-14','12:55:00',3.83),('6449','2013-03-14','13:00:00',5.51),('6449','2013-03-14','13:05:00',5.99),('6449','2013-03-14','13:10:00',7.1),('6449','2013-03-14','13:15:00',8.84),('6449','2013-03-14','13:20:00',7),('6449','2013-03-14','13:25:00',3.61),('6449','2013-03-14','13:30:00',2.45),('6449','2013-03-14','13:35:00',2),('6449','2013-03-14','13:40:00',1.76),('6449','2013-03-14','13:45:00',1.98),('6449','2013-03-14','13:50:00',2.56),('6449','2013-03-14','13:55:00',2.65),('6449','2013-03-14','14:00:00',2.64),('6449','2013-03-14','14:05:00',2.89),('6449','2013-03-14','14:10:00',3.06),('6449','2013-03-14','14:15:00',3.63),('6449','2013-03-14','14:20:00',4.1),('6449','2013-03-14','14:25:00',4.3),('6449','2013-03-14','14:30:00',4.39),('6449','2013-03-14','14:35:00',3.5),('6449','2013-03-14','14:40:00',2.88),('6449','2013-03-14','14:45:00',2.14),('6449','2013-03-14','14:50:00',1.5),('6449','2013-03-14','14:55:00',1.04),('6449','2013-03-14','15:20:00',1.07),('6449','2013-03-14','15:25:00',1.24),('6449','2013-03-14','15:30:00',1.78),('6449','2013-03-14','15:35:00',1.62),('6449','2013-03-14','15:40:00',1.69),('6449','2013-03-14','15:45:00',1.54),('6449','2013-03-14','15:50:00',2.14),('6449','2013-03-14','15:55:00',3.21),('6449','2013-03-14','16:00:00',3.11),('6449','2013-03-14','16:05:00',2.67),('6449','2013-03-14','16:10:00',1.99),('6449','2013-03-14','16:15:00',1.46),('6449','2013-03-14','16:20:00',1.16),('6449','2013-03-14','16:40:00',1.04),('6449','2013-03-14','16:45:00',1.48),('6449','2013-03-14','16:50:00',1.59),('6449','2013-03-14','16:55:00',2),('6449','2013-03-14','17:00:00',2.1),('6449','2013-03-14','17:05:00',1.63),('6449','2013-03-14','17:10:00',1.57),('6449','2013-03-14','17:15:00',1.27),('6449','2013-03-14','17:20:00',1.04),('6449','2013-03-13','07:00:00',1.05),('6449','2013-03-13','07:05:00',1.42),('6449','2013-03-13','07:10:00',1.43),('6449','2013-03-13','07:15:00',1.59),('6449','2013-03-13','07:20:00',1.61),('6449','2013-03-13','07:25:00',1.42),('6449','2013-03-13','07:45:00',1.23),('6449','2013-03-13','07:50:00',1.62),('6449','2013-03-13','07:55:00',1.73),('6449','2013-03-13','08:00:00',1.81),('6449','2013-03-13','08:05:00',2.37),('6449','2013-03-13','08:10:00',2.18),('6449','2013-03-13','08:15:00',2.1),('6449','2013-03-13','08:20:00',2.64),('6449','2013-03-13','08:25:00',2.37),('6449','2013-03-13','08:30:00',1.92),('6449','2013-03-13','08:35:00',2),('6449','2013-03-13','08:40:00',1.8),('6449','2013-03-13','08:45:00',1.66),('6449','2013-03-13','08:50:00',1.25),('6449','2013-03-13','08:55:00',1.05),('6449','2013-03-13','09:05:00',1.07),('6449','2013-03-13','09:10:00',1.95),('6449','2013-03-13','09:15:00',4.13),('6449','2013-03-13','09:20:00',4.27),('6449','2013-03-13','09:25:00',4.82),('6449','2013-03-13','09:30:00',5.41),('6449','2013-03-13','09:35:00',6.85),('6449','2013-03-13','09:40:00',9.67),('6449','2013-03-13','09:45:00',8.76),('6449','2013-03-13','09:50:00',10.35),('6449','2013-03-13','09:55:00',11.71),('6449','2013-03-13','10:00:00',10.21),('6449','2013-03-13','10:05:00',8.29),('6449','2013-03-13','10:10:00',14.01),('6449','2013-03-13','10:15:00',13.92),('6449','2013-03-13','10:20:00',13.74),('6449','2013-03-13','10:25:00',13.91),('6449','2013-03-13','10:30:00',12.38),('6449','2013-03-13','10:35:00',9.9),('6449','2013-03-13','10:40:00',11.03),('6449','2013-03-13','10:45:00',8.33),('6449','2013-03-13','10:50:00',7.89),('6449','2013-03-13','10:55:00',5.83),('6449','2013-03-13','11:00:00',5.96),('6449','2013-03-13','11:05:00',7.72),('6449','2013-03-13','11:10:00',6.64),('6449','2013-03-13','11:15:00',4.98),('6449','2013-03-13','11:20:00',4.69),('6449','2013-03-13','11:25:00',2.93),('6449','2013-03-13','11:30:00',2.98),('6449','2013-03-13','11:35:00',2.27),('6449','2013-03-13','11:40:00',2.31),('6449','2013-03-13','11:45:00',3.56),('6449','2013-03-13','11:50:00',4.94),('6449','2013-03-13','11:55:00',4.29),('6449','2013-03-13','12:00:00',2.27),('6449','2013-03-13','12:05:00',1.1),('6449','2013-03-13','12:10:00',1.24),('6449','2013-03-13','12:15:00',2.83),('6449','2013-03-13','12:20:00',2.95),('6449','2013-03-13','12:25:00',3.78),('6449','2013-03-13','12:30:00',4.14),('6449','2013-03-13','12:35:00',3.79),('6449','2013-03-13','12:40:00',3.28),('6449','2013-03-13','12:45:00',3.55),('6449','2013-03-13','12:50:00',3.45),('6449','2013-03-13','12:55:00',3.36),('6449','2013-03-13','13:00:00',3.13),('6449','2013-03-13','13:05:00',3.09),('6449','2013-03-13','13:10:00',3.13),('6449','2013-03-13','13:15:00',3.21),('6449','2013-03-13','13:20:00',3.19),('6449','2013-03-13','13:25:00',3.27),('6449','2013-03-13','13:30:00',3.49),('6449','2013-03-13','13:35:00',3.82),('6449','2013-03-13','13:40:00',3.2),('6449','2013-03-13','13:45:00',2.25),('6449','2013-03-13','13:50:00',1.69),('6449','2013-03-13','13:55:00',1.4),('6449','2013-03-13','14:00:00',1.15),('6449','2013-03-13','14:25:00',1.33),('6449','2013-03-13','14:30:00',1.53),('6449','2013-03-13','14:35:00',1.61),('6449','2013-03-13','14:40:00',1.27),('6449','2013-03-13','14:45:00',1.15),('6449','2013-03-13','14:50:00',1.12),('6449','2013-03-13','14:55:00',1.07),('6449','2013-03-13','15:00:00',1.08),('6449','2013-03-12','07:30:00',1.54),('6449','2013-03-12','07:35:00',4.12),('6449','2013-03-12','07:40:00',3.78),('6449','2013-03-12','07:45:00',3.24),('6449','2013-03-12','07:50:00',5.09),('6449','2013-03-12','07:55:00',5.88),('6449','2013-03-12','08:00:00',6.37),('6449','2013-03-12','08:05:00',6.54),('6449','2013-03-12','08:10:00',6.82),('6449','2013-03-12','08:15:00',6.73),('6449','2013-03-12','08:20:00',7.17),('6449','2013-03-12','08:25:00',7.32),('6449','2013-03-12','08:30:00',7.96),('6449','2013-03-12','08:35:00',8.78),('6449','2013-03-12','08:40:00',9.23),('6449','2013-03-12','08:45:00',9.55),('6449','2013-03-12','08:50:00',9.92),('6449','2013-03-12','08:55:00',10.32),('6449','2013-03-12','09:00:00',10.59),('6449','2013-03-12','09:05:00',10.86),('6449','2013-03-12','09:10:00',11.25),('6449','2013-03-12','09:15:00',11.49),('6449','2013-03-12','09:20:00',11.72),('6449','2013-03-12','09:25:00',11.98),('6449','2013-03-12','09:30:00',12.11),('6449','2013-03-12','09:35:00',12.43),('6449','2013-03-12','09:40:00',12.66),('6449','2013-03-12','09:45:00',12.87),('6449','2013-03-12','09:50:00',13.11),('6449','2013-03-12','09:55:00',13.3),('6449','2013-03-12','10:00:00',13.43),('6449','2013-03-12','10:05:00',13.75),('6449','2013-03-12','10:10:00',14.04),('6449','2013-03-12','10:15:00',14.17),('6449','2013-03-12','10:20:00',14.34),('6449','2013-03-12','10:25:00',14.56),('6449','2013-03-12','10:30:00',14.5),('6449','2013-03-12','10:35:00',14.92),('6449','2013-03-12','10:40:00',15.12),('6449','2013-03-12','10:45:00',15.39),('6449','2013-03-12','10:50:00',15.9),('6449','2013-03-12','10:55:00',13.27),('6449','2013-03-12','11:00:00',13.31),('6449','2013-03-12','11:05:00',17.22),('6449','2013-03-12','11:10:00',8.84),('6449','2013-03-12','11:15:00',7.92),('6449','2013-03-12','11:20:00',13.12),('6449','2013-03-12','11:25:00',9.71),('6449','2013-03-12','11:30:00',3.47),('6449','2013-03-12','11:35:00',1.83),('6449','2013-03-12','11:40:00',2.11),('6449','2013-03-12','11:45:00',2.79),('6449','2013-03-12','11:50:00',1.48),('6449','2013-03-12','11:55:00',1.52),('6449','2013-03-12','12:00:00',1.05),('6449','2013-03-12','12:05:00',1.66),('6449','2013-03-12','12:10:00',3.36),('6449','2013-03-12','12:15:00',11.11),('6449','2013-03-12','12:20:00',17.6),('6449','2013-03-12','12:25:00',16.58),('6449','2013-03-12','12:30:00',16.01),('6449','2013-03-12','12:35:00',17.23),('6449','2013-03-12','12:40:00',14.99),('6449','2013-03-12','12:45:00',16.76),('6449','2013-03-12','12:50:00',13.34),('6449','2013-03-12','12:55:00',16.26),('6449','2013-03-12','13:00:00',10.98),('6449','2013-03-12','13:05:00',6.01),('6449','2013-03-12','13:10:00',6.89),('6449','2013-03-12','13:15:00',14.61),('6449','2013-03-12','13:20:00',11.41),('6449','2013-03-12','13:25:00',15.17),('6449','2013-03-12','13:30:00',17.55),('6449','2013-03-12','13:35:00',10.28),('6449','2013-03-12','13:40:00',7.75),('6449','2013-03-12','13:45:00',5.86),('6449','2013-03-12','13:50:00',8.41),('6449','2013-03-12','13:55:00',18.32),('6449','2013-03-12','14:00:00',15.9),('6449','2013-03-12','14:05:00',10.38),('6449','2013-03-12','14:10:00',8.05),('6449','2013-03-12','14:15:00',5.18),('6449','2013-03-12','14:20:00',5.03),('6449','2013-03-12','14:25:00',2.98),('6449','2013-03-12','14:30:00',1.66),('6449','2013-03-12','14:35:00',1.24),('6449','2013-03-12','14:40:00',1.77),('6449','2013-03-12','14:45:00',6.15),('6449','2013-03-12','14:50:00',7.3),('6449','2013-03-12','14:55:00',6.08),('6449','2013-03-12','15:00:00',4.85),('6449','2013-03-12','15:05:00',4.56),('6449','2013-03-12','15:10:00',4.96),('6449','2013-03-12','15:15:00',5.84),('6449','2013-03-12','15:20:00',4.21),('6449','2013-03-12','15:25:00',3.69),('6449','2013-03-12','15:30:00',3.14),('6449','2013-03-12','15:35:00',3.97),('6449','2013-03-12','15:40:00',4.45),('6449','2013-03-12','15:45:00',3.05),('6449','2013-03-12','15:50:00',2.87),('6449','2013-03-12','15:55:00',7.42),('6449','2013-03-12','16:00:00',5.46),('6449','2013-03-12','16:05:00',3.25),('6449','2013-03-12','16:10:00',3.01),('6449','2013-03-12','16:15:00',5.82),('6449','2013-03-12','16:20:00',3.6),('6449','2013-03-12','16:25:00',3.43),('6449','2013-03-12','16:30:00',1.99),('6449','2013-03-12','16:35:00',1.5),('6449','2013-03-12','16:40:00',1.39),('6449','2013-03-12','16:45:00',1.38),('6449','2013-03-12','16:50:00',1.44),('6449','2013-03-12','16:55:00',1.59),('6449','2013-03-12','17:00:00',1.63),('6449','2013-03-12','17:05:00',1.54),('6449','2013-03-12','17:10:00',1.53),('6449','2013-03-12','17:15:00',1.22),('6449','2013-03-11','07:00:00',1.02),('6449','2013-03-11','07:05:00',1.37),('6449','2013-03-11','07:10:00',1.72),('6449','2013-03-11','07:15:00',1.99),('6449','2013-03-11','07:20:00',2.29),('6449','2013-03-11','07:25:00',2.22),('6449','2013-03-11','07:30:00',1.43),('6449','2013-03-11','07:35:00',1.65),('6449','2013-03-11','07:40:00',2.91),('6449','2013-03-11','07:45:00',3.75),('6449','2013-03-11','07:50:00',1.39),('6449','2013-03-11','08:00:00',1.08),('6449','2013-03-11','08:05:00',2.84),('6449','2013-03-11','08:10:00',7.82),('6449','2013-03-11','08:15:00',7.21),('6449','2013-03-11','08:20:00',7.75),('6449','2013-03-11','08:25:00',10.32),('6449','2013-03-11','08:30:00',6.49),('6449','2013-03-11','08:35:00',7.05),('6449','2013-03-11','08:40:00',10.44),('6449','2013-03-11','08:45:00',10.89),('6449','2013-03-11','08:50:00',10.28),('6449','2013-03-11','08:55:00',10.2),('6449','2013-03-11','09:00:00',10.53),('6449','2013-03-11','09:05:00',10.81),('6449','2013-03-11','09:10:00',11.15),('6449','2013-03-11','09:15:00',11.65),('6449','2013-03-11','09:20:00',12.2),('6449','2013-03-11','09:25:00',12.94),('6449','2013-03-11','09:30:00',12.19),('6449','2013-03-11','09:35:00',11.19),('6449','2013-03-11','09:40:00',9.72),('6449','2013-03-11','09:45:00',11.5),('6449','2013-03-11','09:50:00',13.8),('6449','2013-03-11','09:55:00',14.06),('6449','2013-03-11','10:00:00',14.59),('6449','2013-03-11','10:05:00',12.42),('6449','2013-03-11','10:10:00',10.89),('6449','2013-03-11','10:15:00',14.27),('6449','2013-03-11','10:20:00',15.01),('6449','2013-03-11','10:25:00',14.85),('6449','2013-03-11','10:30:00',15.22),('6449','2013-03-11','10:35:00',15.81),('6449','2013-03-11','10:40:00',16.75),('6449','2013-03-11','10:45:00',16.44),('6449','2013-03-11','10:50:00',9.63),('6449','2013-03-11','10:55:00',10.26),('6449','2013-03-11','11:00:00',7.74),('6449','2013-03-11','11:05:00',8.08),('6449','2013-03-11','11:10:00',11.41),('6449','2013-03-11','11:15:00',8.09),('6449','2013-03-11','11:20:00',6.73),('6449','2013-03-11','11:25:00',7.54),('6449','2013-03-11','11:30:00',8.44),('6449','2013-03-11','11:35:00',11.39),('6449','2013-03-11','11:40:00',7.44),('6449','2013-03-11','11:45:00',7.42),('6449','2013-03-11','11:50:00',7.3),('6449','2013-03-11','11:55:00',6.62),('6449','2013-03-11','12:00:00',6.86),('6449','2013-03-11','12:05:00',8.6),('6449','2013-03-11','12:10:00',11.91),('6449','2013-03-11','12:15:00',11.07),('6449','2013-03-11','12:20:00',11.75),('6449','2013-03-11','12:25:00',14.77),('6449','2013-03-11','12:30:00',18.02),('6449','2013-03-11','12:35:00',12.05),('6449','2013-03-11','12:40:00',17.36),('6449','2013-03-11','12:45:00',16.71),('6449','2013-03-11','12:50:00',14.16),('6449','2013-03-11','12:55:00',16.44),('6449','2013-03-11','13:00:00',16.04),('6449','2013-03-11','13:05:00',15.89),('6449','2013-03-11','13:10:00',15.8),('6449','2013-03-11','13:15:00',15.47),('6449','2013-03-11','13:20:00',15.4),('6449','2013-03-11','13:25:00',15.3),('6449','2013-03-11','13:30:00',15.31),('6449','2013-03-11','13:35:00',15.33),('6449','2013-03-11','13:40:00',15.96),('6449','2013-03-11','13:45:00',12.09),('6449','2013-03-11','13:50:00',10.79),('6449','2013-03-11','13:55:00',11.18),('6449','2013-03-11','14:00:00',14.57),('6449','2013-03-11','14:05:00',14.22),('6449','2013-03-11','14:10:00',14.29),('6449','2013-03-11','14:15:00',12.26),('6449','2013-03-11','14:20:00',8.63),('6449','2013-03-11','14:25:00',8.16),('6449','2013-03-11','14:30:00',8.18),('6449','2013-03-11','14:35:00',5.37),('6449','2013-03-11','14:40:00',5.39),('6449','2013-03-11','14:45:00',6.04),('6449','2013-03-11','14:50:00',4.91),('6449','2013-03-11','14:55:00',4.28),('6449','2013-03-11','15:00:00',4.69),('6449','2013-03-11','15:05:00',4.07),('6449','2013-03-11','15:10:00',3.98),('6449','2013-03-11','15:15:00',4.1),('6449','2013-03-11','15:20:00',4.66),('6449','2013-03-11','15:25:00',7.34),('6449','2013-03-11','15:30:00',7.49),('6449','2013-03-11','15:35:00',8.59),('6449','2013-03-11','15:40:00',8.72),('6449','2013-03-11','15:45:00',7.92),('6449','2013-03-11','15:50:00',7.27),('6449','2013-03-11','15:55:00',4.46),('6449','2013-03-11','16:00:00',2.95),('6449','2013-03-11','16:05:00',1.74),('6449','2013-03-11','16:10:00',3.75),('6449','2013-03-11','16:15:00',3.77),('6449','2013-03-11','16:20:00',2.76),('6449','2013-03-11','16:25:00',2.33),('6449','2013-03-11','16:30:00',2.32),('6449','2013-03-11','16:35:00',1.9),('6449','2013-03-11','16:40:00',2.59),('6449','2013-03-11','16:45:00',3.48),('6449','2013-03-11','16:50:00',3.46),('6449','2013-03-11','16:55:00',3.86),('6449','2013-03-11','17:00:00',2.8),('6449','2013-03-11','17:05:00',1.73),('6449','2013-03-11','17:10:00',1.22),('6449','2013-03-10','07:00:00',1.14),('6449','2013-03-10','07:05:00',1.46),('6449','2013-03-10','07:10:00',1.89),('6449','2013-03-10','07:20:00',1.16),('6449','2013-03-10','07:25:00',3.33),('6449','2013-03-10','07:30:00',3.44),('6449','2013-03-10','07:35:00',2.49),('6449','2013-03-10','07:40:00',4.06),('6449','2013-03-10','07:45:00',4.58),('6449','2013-03-10','07:50:00',4.87),('6449','2013-03-10','07:55:00',5.42),('6449','2013-03-10','08:00:00',5.81),('6449','2013-03-10','08:05:00',6.25),('6449','2013-03-10','08:10:00',6.54),('6449','2013-03-10','08:15:00',6.65),('6449','2013-03-10','08:20:00',7.22),('6449','2013-03-10','08:25:00',7.72),('6449','2013-03-10','08:30:00',8.22),('6449','2013-03-10','08:35:00',8.61),('6449','2013-03-10','08:40:00',9.16),('6449','2013-03-10','08:45:00',9.41),('6449','2013-03-10','08:50:00',11.34),('6449','2013-03-10','08:55:00',9.97),('6449','2013-03-10','09:00:00',10.92),('6449','2013-03-10','09:05:00',8.83),('6449','2013-03-10','09:10:00',10.94),('6449','2013-03-10','09:15:00',11.31),('6449','2013-03-10','09:20:00',11.6),('6449','2013-03-10','09:25:00',11.81),('6449','2013-03-10','09:30:00',12.14),('6449','2013-03-10','09:35:00',12.43),('6449','2013-03-10','09:40:00',12.69),('6449','2013-03-10','09:45:00',12.96),('6449','2013-03-10','09:50:00',13.14),('6449','2013-03-10','09:55:00',13.33),('6449','2013-03-10','10:00:00',13.56),('6449','2013-03-10','10:05:00',13.72),('6449','2013-03-10','10:10:00',13.89),('6449','2013-03-10','10:15:00',14.12),('6449','2013-03-10','10:20:00',14.31),('6449','2013-03-10','10:25:00',14.48),('6449','2013-03-10','10:30:00',14.66),('6449','2013-03-10','10:35:00',14.76),('6449','2013-03-10','10:40:00',14.83),('6449','2013-03-10','10:45:00',14.95),('6449','2013-03-10','10:50:00',15.08),('6449','2013-03-10','10:55:00',14.95),('6449','2013-03-10','11:00:00',15.49),('6449','2013-03-10','11:05:00',15.48),('6449','2013-03-10','11:10:00',15.66),('6449','2013-03-10','11:15:00',15.68),('6449','2013-03-10','11:20:00',15.85),('6449','2013-03-10','11:25:00',15.71),('6449','2013-03-10','11:30:00',16.13),('6449','2013-03-10','11:35:00',16.28),('6449','2013-03-10','11:40:00',16.27),('6449','2013-03-10','11:45:00',16.23),('6449','2013-03-10','11:50:00',16.27),('6449','2013-03-10','11:55:00',16.2),('6449','2013-03-10','12:00:00',16.18),('6449','2013-03-10','12:05:00',16.22),('6449','2013-03-10','12:10:00',16.2),('6449','2013-03-10','12:15:00',16.09),('6449','2013-03-10','12:20:00',15.86),('6449','2013-03-10','12:25:00',16),('6449','2013-03-10','12:30:00',16.01),('6449','2013-03-10','12:35:00',16.05),('6449','2013-03-10','12:40:00',15.88),('6449','2013-03-10','12:45:00',12.51),('6449','2013-03-10','12:50:00',11.74),('6449','2013-03-10','12:55:00',10.85),('6449','2013-03-10','13:00:00',14.2),('6449','2013-03-10','13:05:00',10.58),('6449','2013-03-10','13:10:00',12.12),('6449','2013-03-10','13:15:00',9.16),('6449','2013-03-10','13:20:00',6.97),('6449','2013-03-10','13:25:00',7.3),('6449','2013-03-10','13:30:00',9.39),('6449','2013-03-10','13:35:00',7.49),('6449','2013-03-10','13:40:00',6.99),('6449','2013-03-10','13:45:00',4.24),('6449','2013-03-10','13:50:00',3.71),('6449','2013-03-10','13:55:00',3.34),('6449','2013-03-10','14:00:00',3.52),('6449','2013-03-10','14:05:00',4.21),('6449','2013-03-10','14:10:00',5.16),('6449','2013-03-10','14:15:00',4.43),('6449','2013-03-10','14:20:00',3.7),('6449','2013-03-10','14:25:00',6.15),('6449','2013-03-10','14:30:00',8.23),('6449','2013-03-10','14:35:00',5.88),('6449','2013-03-10','14:40:00',4.18),('6449','2013-03-10','14:45:00',3.54),('6449','2013-03-10','14:50:00',2.67),('6449','2013-03-10','14:55:00',2.36),('6449','2013-03-10','15:00:00',2.4),('6449','2013-03-10','15:05:00',2.11),('6449','2013-03-10','15:10:00',1.13),('6449','2013-03-10','15:25:00',1.05),('6449','2013-03-10','15:30:00',1.08),('6449','2013-03-10','15:35:00',1.26),('6449','2013-03-10','15:40:00',1.27),('6449','2013-03-09','07:25:00',1.31),('6449','2013-03-09','07:30:00',1.99),('6449','2013-03-09','07:35:00',3.56),('6449','2013-03-09','07:40:00',3.85),('6449','2013-03-09','07:45:00',4.37),('6449','2013-03-09','07:50:00',4.78),('6449','2013-03-09','07:55:00',5.14),('6449','2013-03-09','08:00:00',5.58),('6449','2013-03-09','08:05:00',6.36),('6449','2013-03-09','08:10:00',7.39),('6449','2013-03-09','08:15:00',6.91),('6449','2013-03-09','08:20:00',7.41),('6449','2013-03-09','08:25:00',7.99),('6449','2013-03-09','08:30:00',8.26),('6449','2013-03-09','08:35:00',8.61),('6449','2013-03-09','08:40:00',8.97),('6449','2013-03-09','08:45:00',9.35),('6449','2013-03-09','08:50:00',9.7),('6449','2013-03-09','08:55:00',9.95),('6449','2013-03-09','09:00:00',10.37),('6449','2013-03-09','09:05:00',10.74),('6449','2013-03-09','09:10:00',10.95),('6449','2013-03-09','09:15:00',11.2),('6449','2013-03-09','09:20:00',11.36),('6449','2013-03-09','09:25:00',11.39),('6449','2013-03-09','09:30:00',11.98),('6449','2013-03-09','09:35:00',12.14),('6449','2013-03-09','09:40:00',12.46),('6449','2013-03-09','09:45:00',12.75),('6449','2013-03-09','09:50:00',12.95),('6449','2013-03-09','09:55:00',12.94),('6449','2013-03-09','10:00:00',13.41),('6449','2013-03-09','10:05:00',13.62),('6449','2013-03-09','10:10:00',13.87),('6449','2013-03-09','10:15:00',14.09),('6449','2013-03-09','10:20:00',14.22),('6449','2013-03-09','10:25:00',14.39),('6449','2013-03-09','10:30:00',14.6),('6449','2013-03-09','10:35:00',14.74),('6449','2013-03-09','10:40:00',14.75),('6449','2013-03-09','10:45:00',15.17),('6449','2013-03-09','10:50:00',15.37),('6449','2013-03-09','10:55:00',15.5),('6449','2013-03-09','11:00:00',15.6),('6449','2013-03-09','11:05:00',15.69),('6449','2013-03-09','11:10:00',15.73),('6449','2013-03-09','11:15:00',15.46),('6449','2013-03-09','11:20:00',15.92),('6449','2013-03-09','11:25:00',15.95),('6449','2013-03-09','11:30:00',16.01),('6449','2013-03-09','11:35:00',16.05),('6449','2013-03-09','11:40:00',16.09),('6449','2013-03-09','11:45:00',15.79),('6449','2013-03-09','11:50:00',16.08),('6449','2013-03-09','11:55:00',16.15),('6449','2013-03-09','12:00:00',16.24),('6449','2013-03-09','12:05:00',16.36),('6449','2013-03-09','12:10:00',15.55),('6449','2013-03-09','12:15:00',13.96),('6449','2013-03-09','12:20:00',16.31),('6449','2013-03-09','12:25:00',16.42),('6449','2013-03-09','12:30:00',17.01),('6449','2013-03-09','12:35:00',16.38),('6449','2013-03-09','12:40:00',16.17),('6449','2013-03-09','12:45:00',15.99),('6449','2013-03-09','12:50:00',15.9),('6449','2013-03-09','12:55:00',15.73),('6449','2013-03-09','13:00:00',15.25),('6449','2013-03-09','13:05:00',15.86),('6449','2013-03-09','13:10:00',12.81),('6449','2013-03-09','13:15:00',17.13),('6449','2013-03-09','13:20:00',15.58),('6449','2013-03-09','13:25:00',14.89),('6449','2013-03-09','13:30:00',14.45),('6449','2013-03-09','13:35:00',13.56),('6449','2013-03-09','13:40:00',14.38),('6449','2013-03-09','13:45:00',14.24),('6449','2013-03-09','13:50:00',14.22),('6449','2013-03-09','13:55:00',13.79),('6449','2013-03-09','14:00:00',12.39),('6449','2013-03-09','14:05:00',13.32),('6449','2013-03-09','14:10:00',11.69),('6449','2013-03-09','14:15:00',12.8),('6449','2013-03-09','14:20:00',12.7),('6449','2013-03-09','14:25:00',12.59),('6449','2013-03-09','14:30:00',12.45),('6449','2013-03-09','14:35:00',12.22),('6449','2013-03-09','14:40:00',11.97),('6449','2013-03-09','14:45:00',11.5),('6449','2013-03-09','14:50:00',11.27),('6449','2013-03-09','14:55:00',11.06),('6449','2013-03-09','15:00:00',10.72),('6449','2013-03-09','15:05:00',10.46),('6449','2013-03-09','15:10:00',10.15),('6449','2013-03-09','15:15:00',9.87),('6449','2013-03-09','15:20:00',9.57),('6449','2013-03-09','15:25:00',9.54),('6449','2013-03-09','15:30:00',8.51),('6449','2013-03-09','15:35:00',8.73),('6449','2013-03-09','15:40:00',8.34),('6449','2013-03-09','15:45:00',7.75),('6449','2013-03-09','15:50:00',7.21),('6449','2013-03-09','15:55:00',5.98),('6449','2013-03-09','16:00:00',5.47),('6449','2013-03-09','16:05:00',3.93),('6449','2013-03-09','16:10:00',3.94),('6449','2013-03-09','16:15:00',2.81),('6449','2013-03-09','16:20:00',2.83),('6449','2013-03-09','16:25:00',4.1),('6449','2013-03-09','16:30:00',3.07),('6449','2013-03-09','16:35:00',2.8),('6449','2013-03-09','16:40:00',2.2),('6449','2013-03-09','16:45:00',2.03),('6449','2013-03-09','16:50:00',1.92),('6449','2013-03-09','16:55:00',1.55),('6449','2013-03-09','17:00:00',1.15),('6449','2013-03-08','07:45:00',1.09),('6449','2013-03-08','07:50:00',1.17),('6449','2013-03-08','07:55:00',1.39),('6449','2013-03-08','08:00:00',1.39),('6449','2013-03-08','08:05:00',1.38),('6449','2013-03-08','08:10:00',2.28),('6449','2013-03-08','08:15:00',2.66),('6449','2013-03-08','08:20:00',1.22),('6449','2013-03-08','08:25:00',1.43),('6449','2013-03-08','08:30:00',1.62),('6449','2013-03-08','08:35:00',1.1),('6449','2013-03-08','08:40:00',1.25),('6449','2013-03-08','08:45:00',2.39),('6449','2013-03-08','08:50:00',3.54),('6449','2013-03-08','08:55:00',3.44),('6449','2013-03-08','09:00:00',3.22),('6449','2013-03-08','09:05:00',3.5),('6449','2013-03-08','09:10:00',4.16),('6449','2013-03-08','09:15:00',2.89),('6449','2013-03-08','09:20:00',2.11),('6449','2013-03-08','09:25:00',2.68),('6449','2013-03-08','09:30:00',3.06),('6449','2013-03-08','09:35:00',3.26),('6449','2013-03-08','09:40:00',4.42),('6449','2013-03-08','09:45:00',3.73),('6449','2013-03-08','09:50:00',3.49),('6449','2013-03-08','09:55:00',3.23),('6449','2013-03-08','10:00:00',2.93),('6449','2013-03-08','10:05:00',4.44),('6449','2013-03-08','10:10:00',7.08),('6449','2013-03-08','10:15:00',7.88),('6449','2013-03-08','10:20:00',4.51),('6449','2013-03-08','10:25:00',2.46),('6449','2013-03-08','10:30:00',1.9),('6449','2013-03-08','10:35:00',2.55),('6449','2013-03-08','10:40:00',2.94),('6449','2013-03-08','10:45:00',2.42),('6449','2013-03-08','10:50:00',1.28),('6449','2013-03-08','10:55:00',1.26),('6449','2013-03-08','11:00:00',1.86),('6449','2013-03-08','11:05:00',2.63),('6449','2013-03-08','11:10:00',1.36),('6449','2013-03-08','11:15:00',1.26),('6449','2013-03-08','11:20:00',2.21),('6449','2013-03-08','11:25:00',2.66),('6449','2013-03-08','11:30:00',3.38),('6449','2013-03-08','11:35:00',3.62),('6449','2013-03-08','11:40:00',3.04),('6449','2013-03-08','11:45:00',1.91),('6449','2013-03-08','11:50:00',2.52),('6449','2013-03-08','11:55:00',2.13),('6449','2013-03-08','12:00:00',1.43),('6449','2013-03-08','12:05:00',1.34),('6449','2013-03-08','12:10:00',1.73),('6449','2013-03-08','12:15:00',2.58),('6449','2013-03-08','12:20:00',2.97),('6449','2013-03-08','12:25:00',2.72),('6449','2013-03-08','12:30:00',3.32),('6449','2013-03-08','12:35:00',2.93),('6449','2013-03-08','12:40:00',2.02),('6449','2013-03-08','12:45:00',1.92),('6449','2013-03-08','12:50:00',1.37),('6449','2013-03-08','12:55:00',1.18),('6449','2013-03-08','13:00:00',1.89),('6449','2013-03-08','13:05:00',1.66),('6449','2013-03-08','13:10:00',2.56),('6449','2013-03-08','13:15:00',2.9),('6449','2013-03-08','13:20:00',2.83),('6449','2013-03-08','13:25:00',4.5),('6449','2013-03-08','13:30:00',5.18),('6449','2013-03-08','13:35:00',3.04),('6449','2013-03-08','13:40:00',1.65),('6449','2013-03-08','13:45:00',1.01),('6449','2013-03-08','13:50:00',1.06),('6449','2013-03-08','15:30:00',1.32),('6449','2013-03-08','15:35:00',1.28),('6449','2013-03-07','08:20:00',1.04),('6449','2013-03-07','08:25:00',1.17),('6449','2013-03-07','08:30:00',2.42),('6449','2013-03-07','08:35:00',3.14),('6449','2013-03-07','08:40:00',3.27),('6449','2013-03-07','08:45:00',3.98),('6449','2013-03-07','08:50:00',3.82),('6449','2013-03-07','08:55:00',2.79),('6449','2013-03-07','09:00:00',2.87),('6449','2013-03-07','09:05:00',2.19),('6449','2013-03-07','09:10:00',1.79),('6449','2013-03-07','09:15:00',1.78),('6449','2013-03-07','09:20:00',1.48),('6449','2013-03-07','09:25:00',1.89),('6449','2013-03-07','09:30:00',2.67),('6449','2013-03-07','09:35:00',2.91),('6449','2013-03-07','09:40:00',2.99),('6449','2013-03-07','09:45:00',3.75),('6449','2013-03-07','09:50:00',4.13),('6449','2013-03-07','09:55:00',4.22),('6449','2013-03-07','10:00:00',4.29),('6449','2013-03-07','10:05:00',3.91),('6449','2013-03-07','10:10:00',3.56),('6449','2013-03-07','10:15:00',3.94),('6449','2013-03-07','10:20:00',4.23),('6449','2013-03-07','10:25:00',5.15),('6449','2013-03-07','10:30:00',7.8),('6449','2013-03-07','10:35:00',4.29),('6449','2013-03-07','10:40:00',2.93),('6449','2013-03-07','10:45:00',3.49),('6449','2013-03-07','10:50:00',2.93),('6449','2013-03-07','10:55:00',3.59),('6449','2013-03-07','11:00:00',4.19),('6449','2013-03-07','11:05:00',4.65),('6449','2013-03-07','11:10:00',5.69),('6449','2013-03-07','11:15:00',6.32),('6449','2013-03-07','11:20:00',7.51),('6449','2013-03-07','11:25:00',9.94),('6449','2013-03-07','11:30:00',13.41),('6449','2013-03-07','11:35:00',13.77),('6449','2013-03-07','11:40:00',12.31),('6449','2013-03-07','11:45:00',11.64),('6449','2013-03-07','11:50:00',11.74),('6449','2013-03-07','11:55:00',7.22),('6449','2013-03-07','12:00:00',5.34),('6449','2013-03-07','12:05:00',4.68),('6449','2013-03-07','12:10:00',3.41),('6449','2013-03-07','12:15:00',3.71),('6449','2013-03-07','12:20:00',5.1),('6449','2013-03-07','12:25:00',5.97),('6449','2013-03-07','12:30:00',6.99),('6449','2013-03-07','12:35:00',8.67),('6449','2013-03-07','12:40:00',10.65),('6449','2013-03-07','12:45:00',10.61),('6449','2013-03-07','12:50:00',8.92),('6449','2013-03-07','12:55:00',7.47),('6449','2013-03-07','13:00:00',7.83),('6449','2013-03-07','13:05:00',7.91),('6449','2013-03-07','13:10:00',6.54),('6449','2013-03-07','13:15:00',7.34),('6449','2013-03-07','13:20:00',6.73),('6449','2013-03-07','13:25:00',7.8),('6449','2013-03-07','13:30:00',9.09),('6449','2013-03-07','13:35:00',9.61),('6449','2013-03-07','13:40:00',4.79),('6449','2013-03-07','13:45:00',3.09),('6449','2013-03-07','13:50:00',1.41),('6449','2013-03-07','13:55:00',1.16),('6449','2013-03-07','14:00:00',1.26),('6449','2013-03-07','14:15:00',1.22),('6449','2013-03-07','14:20:00',1.6),('6449','2013-03-07','14:25:00',3.21),('6449','2013-03-07','14:30:00',3.52),('6449','2013-03-07','14:35:00',3.03),('6449','2013-03-07','14:40:00',3.13),('6449','2013-03-07','14:45:00',2.05),('6449','2013-03-07','14:50:00',2.85),('6449','2013-03-07','14:55:00',5.58),('6449','2013-03-07','15:00:00',7.02),('6449','2013-03-07','15:05:00',5.13),('6449','2013-03-07','15:10:00',4.46),('6449','2013-03-07','15:15:00',3.94),('6449','2013-03-07','15:20:00',3.2),('6449','2013-03-07','15:25:00',2.54),('6449','2013-03-07','15:30:00',2.37),('6449','2013-03-07','15:35:00',2.18),('6449','2013-03-07','15:40:00',2.5),('6449','2013-03-07','15:45:00',2.4),('6449','2013-03-07','15:50:00',1.48),('6449','2013-03-07','15:55:00',2.08),('6449','2013-03-07','16:00:00',2.21),('6449','2013-03-07','16:05:00',2.43),('6449','2013-03-07','16:10:00',2.31),('6449','2013-03-07','16:15:00',2.13),('6449','2013-03-07','16:20:00',3.21),('6449','2013-03-07','16:25:00',2.84),('6449','2013-03-07','16:30:00',2.31),('6449','2013-03-07','16:35:00',1.51),('6449','2013-03-07','16:40:00',1.09),('6449','2013-03-06','09:20:00',1.01),('6449','2013-03-06','09:25:00',1.19),('6449','2013-03-06','09:30:00',1.37),('6449','2013-03-06','09:35:00',1.69),('6449','2013-03-06','09:40:00',2.17),('6449','2013-03-06','09:45:00',1.98),('6449','2013-03-06','09:50:00',2.01),('6449','2013-03-06','09:55:00',1.58),('6449','2013-03-06','10:00:00',1.21),('6449','2013-03-06','10:05:00',1.04),('6449','2013-03-06','10:15:00',1.14),('6449','2013-03-06','10:20:00',1.18),('6449','2013-03-06','10:55:00',1.14),('6449','2013-03-06','11:00:00',1.08),('6449','2013-03-06','12:20:00',1.08),('6449','2013-03-06','12:25:00',1),('6449','2013-03-06','12:35:00',1.27),('6449','2013-03-06','12:40:00',1.45),('6449','2013-03-06','12:45:00',1.57),('6449','2013-03-05','07:30:00',1.08),('6449','2013-03-05','07:35:00',1.74),('6449','2013-03-05','07:40:00',1.52),('6449','2013-03-05','07:45:00',1.55),('6449','2013-03-05','07:50:00',2.5),('6449','2013-03-05','07:55:00',4.14),('6449','2013-03-05','08:00:00',3.9),('6449','2013-03-05','08:05:00',4.35),('6449','2013-03-05','08:10:00',4.51),('6449','2013-03-05','08:15:00',4.81),('6449','2013-03-05','08:20:00',5.91),('6449','2013-03-05','08:25:00',6.31),('6449','2013-03-05','08:30:00',6.23),('6449','2013-03-05','08:35:00',5.69),('6449','2013-03-05','08:40:00',5.75),('6449','2013-03-05','08:45:00',4.85),('6449','2013-03-05','08:50:00',3.94),('6449','2013-03-05','08:55:00',3.68),('6449','2013-03-05','09:00:00',3.75),('6449','2013-03-05','09:05:00',4.12),('6449','2013-03-05','09:10:00',4.41),('6449','2013-03-05','09:15:00',4.38),('6449','2013-03-05','09:20:00',4.38),('6449','2013-03-05','09:25:00',4.52),('6449','2013-03-05','09:30:00',4.63),('6449','2013-03-05','09:35:00',4.56),('6449','2013-03-05','09:40:00',4.92),('6449','2013-03-05','09:45:00',6.44),('6449','2013-03-05','09:50:00',5.6),('6449','2013-03-05','09:55:00',5.45),('6449','2013-03-05','10:00:00',5.64),('6449','2013-03-05','10:05:00',7.08),('6449','2013-03-05','10:10:00',7.81),('6449','2013-03-05','10:15:00',8.16),('6449','2013-03-05','10:20:00',8.25),('6449','2013-03-05','10:25:00',9.36),('6449','2013-03-05','10:30:00',9.9),('6449','2013-03-05','10:35:00',9.94),('6449','2013-03-05','10:40:00',9.59),('6449','2013-03-05','10:45:00',9.9),('6449','2013-03-05','10:50:00',10.7),('6449','2013-03-05','10:55:00',11.83),('6449','2013-03-05','11:00:00',10.87),('6449','2013-03-05','11:05:00',10.79),('6449','2013-03-05','11:10:00',9.98),('6449','2013-03-05','11:15:00',8.74),('6449','2013-03-05','11:20:00',8.55),('6449','2013-03-05','11:25:00',9.84),('6449','2013-03-05','11:30:00',10.59),('6449','2013-03-05','11:35:00',11.75),('6449','2013-03-05','11:40:00',11.91),('6449','2013-03-05','11:45:00',12.76),('6449','2013-03-05','11:50:00',11.87),('6449','2013-03-05','11:55:00',11.48),('6449','2013-03-05','12:00:00',9.34),('6449','2013-03-05','12:05:00',10.29),('6449','2013-03-05','12:10:00',9.51),('6449','2013-03-05','12:15:00',9.42),('6449','2013-03-05','12:20:00',10.04),('6449','2013-03-05','12:25:00',9.02),('6449','2013-03-05','12:30:00',7.64),('6449','2013-03-05','12:35:00',8.65),('6449','2013-03-05','12:40:00',8.54),('6449','2013-03-05','12:45:00',6.92),('6449','2013-03-05','12:50:00',5.79),('6449','2013-03-05','12:55:00',5.63),('6449','2013-03-05','13:00:00',5.65),('6449','2013-03-05','13:05:00',5.26),('6449','2013-03-05','13:10:00',4.76),('6449','2013-03-05','13:15:00',4.27),('6449','2013-03-05','13:20:00',3.71),('6449','2013-03-05','13:25:00',3.22),('6449','2013-03-05','13:30:00',3.33),('6449','2013-03-05','13:35:00',3.38),('6449','2013-03-05','13:40:00',3.58),('6449','2013-03-05','13:45:00',4.07),('6449','2013-03-05','13:50:00',4.11),('6449','2013-03-05','13:55:00',4.16),('6449','2013-03-05','14:00:00',4.84),('6449','2013-03-05','14:05:00',4.87),('6449','2013-03-05','14:10:00',4.84),('6449','2013-03-05','14:15:00',4.9),('6449','2013-03-05','14:20:00',4.55),('6449','2013-03-05','14:25:00',4.09),('6449','2013-03-05','14:30:00',3.67),('6449','2013-03-05','14:35:00',3.57),('6449','2013-03-05','14:40:00',3.46),('6449','2013-03-05','14:45:00',3.31),('6449','2013-03-05','14:50:00',3.35),('6449','2013-03-05','14:55:00',3.15),('6449','2013-03-05','15:00:00',2.84),('6449','2013-03-05','15:05:00',2.36),('6449','2013-03-05','15:10:00',2.38),('6449','2013-03-05','15:15:00',2.66),('6449','2013-03-05','15:20:00',2.5),('6449','2013-03-05','15:25:00',2.71),('6449','2013-03-05','15:30:00',2.91),('6449','2013-03-05','15:35:00',3.18),('6449','2013-03-05','15:40:00',3.95),('6449','2013-03-05','15:45:00',4.66),('6449','2013-03-05','15:50:00',4.13),('6449','2013-03-05','15:55:00',3.1),('6449','2013-03-05','16:00:00',2.32),('6449','2013-03-05','16:05:00',2.01),('6449','2013-03-05','16:10:00',1.81),('6449','2013-03-05','16:15:00',1.59),('6449','2013-03-05','16:20:00',1.38),('6449','2013-03-05','16:25:00',1.25),('6449','2013-03-05','16:30:00',1.2),('6449','2013-03-05','16:35:00',1.08),('6449','2013-03-04','07:10:00',1.01),('6449','2013-03-04','07:15:00',1.21),('6449','2013-03-04','07:20:00',1.58),('6449','2013-03-04','07:25:00',1.87),('6449','2013-03-04','07:30:00',2.26),('6449','2013-03-04','07:35:00',2.72),('6449','2013-03-04','07:40:00',3.12),('6449','2013-03-04','07:45:00',3.49),('6449','2013-03-04','07:50:00',3.96),('6449','2013-03-04','07:55:00',4.44),('6449','2013-03-04','08:00:00',4.82),('6449','2013-03-04','08:05:00',5.28),('6449','2013-03-04','08:10:00',5.74),('6449','2013-03-04','08:15:00',6.15),('6449','2013-03-04','08:20:00',6.56),('6449','2013-03-04','08:25:00',6.98),('6449','2013-03-04','08:30:00',7.38),('6449','2013-03-04','08:35:00',7.79),('6449','2013-03-04','08:40:00',8.21),('6449','2013-03-04','08:45:00',8.57),('6449','2013-03-04','08:50:00',8.9),('6449','2013-03-04','08:55:00',9.33),('6449','2013-03-04','09:00:00',9.63),('6449','2013-03-04','09:05:00',10.1),('6449','2013-03-04','09:10:00',10.47),('6449','2013-03-04','09:15:00',10.77),('6449','2013-03-04','09:20:00',11.15),('6449','2013-03-04','09:25:00',11.44),('6449','2013-03-04','09:30:00',11.76),('6449','2013-03-04','09:35:00',12.03),('6449','2013-03-04','09:40:00',12.35),('6449','2013-03-04','09:45:00',12.46),('6449','2013-03-04','09:50:00',12.85),('6449','2013-03-04','09:55:00',13.07),('6449','2013-03-04','10:00:00',13.22),('6449','2013-03-04','10:05:00',13.36),('6449','2013-03-04','10:10:00',13.55),('6449','2013-03-04','10:15:00',13.72),('6449','2013-03-04','10:20:00',13.86),('6449','2013-03-04','10:25:00',14.05),('6449','2013-03-04','10:30:00',14.16),('6449','2013-03-04','10:35:00',14.31),('6449','2013-03-04','10:40:00',14.33),('6449','2013-03-04','10:45:00',14.51),('6449','2013-03-04','10:50:00',14.28),('6449','2013-03-04','10:55:00',14.75),('6449','2013-03-04','11:00:00',14.77),('6449','2013-03-04','11:05:00',15.03),('6449','2013-03-04','11:10:00',14.95),('6449','2013-03-04','11:15:00',14.84),('6449','2013-03-04','11:20:00',14.8),('6449','2013-03-04','11:25:00',15.21),('6449','2013-03-04','11:30:00',15.43),('6449','2013-03-04','11:35:00',13.89),('6449','2013-03-04','11:40:00',15.09),('6449','2013-03-04','11:45:00',15.26),('6449','2013-03-04','11:50:00',15.38),('6449','2013-03-04','11:55:00',15.54),('6449','2013-03-04','12:00:00',15.67),('6449','2013-03-04','12:05:00',15.77),('6449','2013-03-04','12:10:00',15.96),('6449','2013-03-04','12:15:00',15.96),('6449','2013-03-04','12:20:00',15.94),('6449','2013-03-04','12:25:00',15.89),('6449','2013-03-04','12:30:00',15.81),('6449','2013-03-04','12:35:00',15.6),('6449','2013-03-04','12:40:00',15.76),('6449','2013-03-04','12:45:00',15.74),('6449','2013-03-04','12:50:00',15.71),('6449','2013-03-04','12:55:00',15.74),('6449','2013-03-04','13:00:00',16.11),('6449','2013-03-04','13:05:00',16.4),('6449','2013-03-04','13:10:00',16.02),('6449','2013-03-04','13:15:00',15.26),('6449','2013-03-04','13:20:00',14.79),('6449','2013-03-04','13:25:00',14.84),('6449','2013-03-04','13:30:00',14.66),('6449','2013-03-04','13:35:00',14.47),('6449','2013-03-04','13:40:00',14.36),('6449','2013-03-04','13:45:00',14.26),('6449','2013-03-04','13:50:00',14.1),('6449','2013-03-04','13:55:00',13.92),('6449','2013-03-04','14:00:00',13.63),('6449','2013-03-04','14:05:00',13.46),('6449','2013-03-04','14:10:00',13.26),('6449','2013-03-04','14:15:00',13.12),('6449','2013-03-04','14:20:00',12.8),('6449','2013-03-04','14:25:00',12.69),('6449','2013-03-04','14:30:00',12.5),('6449','2013-03-04','14:35:00',12.31),('6449','2013-03-04','14:40:00',11.98),('6449','2013-03-04','14:45:00',11.6),('6449','2013-03-04','14:50:00',11.27),('6449','2013-03-04','14:55:00',11.13),('6449','2013-03-04','15:00:00',10.82),('6449','2013-03-04','15:05:00',10.49),('6449','2013-03-04','15:10:00',10.19),('6449','2013-03-04','15:15:00',9.92),('6449','2013-03-04','15:20:00',9.6),('6449','2013-03-04','15:25:00',9.26),('6449','2013-03-04','15:30:00',8.99),('6449','2013-03-04','15:35:00',8.72),('6449','2013-03-04','15:40:00',8.22),('6449','2013-03-04','15:45:00',7.92),('6449','2013-03-04','15:50:00',7.56),('6449','2013-03-04','15:55:00',7.19),('6449','2013-03-04','16:00:00',6.95),('6449','2013-03-04','16:05:00',6.34),('6449','2013-03-04','16:10:00',6.03),('6449','2013-03-04','16:15:00',5.64),('6449','2013-03-04','16:20:00',5.26),('6449','2013-03-04','16:25:00',4.89),('6449','2013-03-04','16:30:00',4.51),('6449','2013-03-04','16:35:00',4.14),('6449','2013-03-04','16:40:00',3.79),('6449','2013-03-04','16:45:00',3.42),('6449','2013-03-04','16:50:00',3.01),('6449','2013-03-04','16:55:00',2.73),('6449','2013-03-04','17:00:00',2.41),('6449','2013-03-04','17:05:00',2.06),('6449','2013-03-04','17:10:00',1.78),('6449','2013-03-04','17:15:00',1.47),('6449','2013-03-04','17:20:00',1.22),('6449','2013-03-03','07:10:00',1.21),('6449','2013-03-03','07:15:00',1.52),('6449','2013-03-03','07:20:00',1.85),('6449','2013-03-03','07:25:00',2.23),('6449','2013-03-03','07:30:00',2.66),('6449','2013-03-03','07:35:00',3.07),('6449','2013-03-03','07:40:00',3.52),('6449','2013-03-03','07:45:00',3.96),('6449','2013-03-03','07:50:00',4.33),('6449','2013-03-03','07:55:00',4.83),('6449','2013-03-03','08:00:00',5.29),('6449','2013-03-03','08:05:00',5.67),('6449','2013-03-03','08:10:00',6.19),('6449','2013-03-03','08:15:00',6.63),('6449','2013-03-03','08:20:00',7.06),('6449','2013-03-03','08:25:00',7.49),('6449','2013-03-03','08:30:00',7.94),('6449','2013-03-03','08:35:00',8.35),('6449','2013-03-03','08:40:00',8.78),('6449','2013-03-03','08:45:00',9.17),('6449','2013-03-03','08:50:00',9.59),('6449','2013-03-03','08:55:00',9.99),('6449','2013-03-03','09:00:00',10.36),('6449','2013-03-03','09:05:00',10.71),('6449','2013-03-03','09:10:00',11.05),('6449','2013-03-03','09:15:00',11.39),('6449','2013-03-03','09:20:00',11.68),('6449','2013-03-03','09:25:00',11.98),('6449','2013-03-03','09:30:00',12.29),('6449','2013-03-03','09:35:00',12.54),('6449','2013-03-03','09:40:00',12.93),('6449','2013-03-03','09:45:00',13.21),('6449','2013-03-03','09:50:00',13.4),('6449','2013-03-03','09:55:00',13.72),('6449','2013-03-03','10:00:00',13.9),('6449','2013-03-03','10:05:00',14.1),('6449','2013-03-03','10:10:00',14.32),('6449','2013-03-03','10:15:00',14.54),('6449','2013-03-03','10:20:00',14.64),('6449','2013-03-03','10:25:00',14.83),('6449','2013-03-03','10:30:00',15.02),('6449','2013-03-03','10:35:00',15.2),('6449','2013-03-03','10:40:00',15.35),('6449','2013-03-03','10:45:00',15.41),('6449','2013-03-03','10:50:00',15.51),('6449','2013-03-03','10:55:00',15.61),('6449','2013-03-03','11:00:00',15.75),('6449','2013-03-03','11:05:00',15.79),('6449','2013-03-03','11:10:00',15.87),('6449','2013-03-03','11:15:00',15.96),('6449','2013-03-03','11:20:00',15.66),('6449','2013-03-03','11:25:00',15.92),('6449','2013-03-03','11:30:00',15.88),('6449','2013-03-03','11:35:00',15.74),('6449','2013-03-03','11:40:00',15.94),('6449','2013-03-03','11:45:00',15.98),('6449','2013-03-03','11:50:00',15.91),('6449','2013-03-03','11:55:00',15.87),('6449','2013-03-03','12:00:00',15.92),('6449','2013-03-03','12:05:00',15.86),('6449','2013-03-03','12:10:00',15.87),('6449','2013-03-03','12:15:00',15.76),('6449','2013-03-03','12:20:00',15.62),('6449','2013-03-03','12:25:00',15.54),('6449','2013-03-03','12:30:00',15.46),('6449','2013-03-03','12:35:00',15.39),('6449','2013-03-03','12:40:00',15.4),('6449','2013-03-03','12:45:00',15.65),('6449','2013-03-03','12:50:00',15.67),('6449','2013-03-03','12:55:00',15.64),('6449','2013-03-03','13:00:00',15.52),('6449','2013-03-03','13:05:00',15.44),('6449','2013-03-03','13:10:00',15.07),('6449','2013-03-03','13:15:00',15.16),('6449','2013-03-03','13:20:00',15.04),('6449','2013-03-03','13:25:00',14.87),('6449','2013-03-03','13:30:00',14.87),('6449','2013-03-03','13:35:00',14.61),('6449','2013-03-03','13:40:00',14.5),('6449','2013-03-03','13:45:00',14.44),('6449','2013-03-03','13:50:00',14.26),('6449','2013-03-03','13:55:00',13.93),('6449','2013-03-03','14:00:00',13.77),('6449','2013-03-03','14:05:00',13.56),('6449','2013-03-03','14:10:00',13.3),('6449','2013-03-03','14:15:00',13.08),('6449','2013-03-03','14:20:00',12.96),('6449','2013-03-03','14:25:00',12.73),('6449','2013-03-03','14:30:00',12.63),('6449','2013-03-03','14:35:00',12.51),('6449','2013-03-03','14:40:00',12.17),('6449','2013-03-03','14:45:00',11.98),('6449','2013-03-03','14:50:00',11.69),('6449','2013-03-03','14:55:00',11.31),('6449','2013-03-03','15:00:00',11.26),('6449','2013-03-03','15:05:00',10.82),('6449','2013-03-03','15:10:00',10.36),('6449','2013-03-03','15:15:00',10.11),('6449','2013-03-03','15:20:00',9.85),('6449','2013-03-03','15:25:00',9.44),('6449','2013-03-03','15:30:00',9.11),('6449','2013-03-03','15:35:00',8.77),('6449','2013-03-03','15:40:00',8.39),('6449','2013-03-03','15:45:00',8.03),('6449','2013-03-03','15:50:00',7.66),('6449','2013-03-03','15:55:00',7.29),('6449','2013-03-03','16:00:00',6.91),('6449','2013-03-03','16:05:00',6.46),('6449','2013-03-03','16:10:00',6.1),('6449','2013-03-03','16:15:00',5.72),('6449','2013-03-03','16:20:00',5.31),('6449','2013-03-03','16:25:00',4.87),('6449','2013-03-03','16:30:00',4.55),('6449','2013-03-03','16:35:00',4.14),('6449','2013-03-03','16:40:00',3.71),('6449','2013-03-03','16:45:00',3.38),('6449','2013-03-03','16:50:00',2.99),('6449','2013-03-03','16:55:00',2.6),('6449','2013-03-03','17:00:00',2.3),('6449','2013-03-03','17:05:00',1.95),('6449','2013-03-03','17:10:00',1.65),('6449','2013-03-03','17:15:00',1.35),('6449','2013-03-03','17:20:00',1.09),('6449','2013-03-02','08:00:00',1.06),('6449','2013-03-02','08:05:00',1.04),('6449','2013-03-02','08:10:00',1.32),('6449','2013-03-02','08:15:00',1.34),('6449','2013-03-02','08:20:00',1.16),('6449','2013-03-02','08:25:00',1.32),('6449','2013-03-02','08:30:00',1.41),('6449','2013-03-02','08:35:00',1.17),('6449','2013-03-02','08:40:00',1.05),('6449','2013-03-02','09:25:00',1.52),('6449','2013-03-02','09:30:00',1.73),('6449','2013-03-02','09:35:00',1.67),('6449','2013-03-02','09:40:00',1.32),('6449','2013-03-02','09:45:00',1.24),('6449','2013-03-02','09:50:00',1.46),('6449','2013-03-02','09:55:00',1.61),('6449','2013-03-02','10:00:00',1.65),('6449','2013-03-02','10:05:00',1.78),('6449','2013-03-02','10:10:00',1.83),('6449','2013-03-02','10:15:00',1.98),('6449','2013-03-02','10:20:00',1.9),('6449','2013-03-02','10:25:00',1.93),('6449','2013-03-02','10:30:00',2.24),('6449','2013-03-02','10:35:00',2.84),('6449','2013-03-02','10:40:00',3.11),('6449','2013-03-02','10:45:00',3.61),('6449','2013-03-02','10:50:00',4.23),('6449','2013-03-02','10:55:00',4.83),('6449','2013-03-02','11:00:00',5.26),('6449','2013-03-02','11:05:00',5.72),('6449','2013-03-02','11:10:00',5.72),('6449','2013-03-02','11:15:00',6.15),('6449','2013-03-02','11:20:00',6.08),('6449','2013-03-02','11:25:00',5.91),('6449','2013-03-02','11:30:00',5.61),('6449','2013-03-02','11:35:00',7.76),('6449','2013-03-02','11:40:00',9.59),('6449','2013-03-02','11:45:00',9.76),('6449','2013-03-02','11:50:00',8.68),('6449','2013-03-02','11:55:00',5.39),('6449','2013-03-02','12:00:00',6.05),('6449','2013-03-02','12:05:00',9.56),('6449','2013-03-02','12:10:00',6.1),('6449','2013-03-02','12:15:00',5.59),('6449','2013-03-02','12:20:00',6.3),('6449','2013-03-02','12:25:00',6.54),('6449','2013-03-02','12:30:00',6.94),('6449','2013-03-02','12:35:00',6.42),('6449','2013-03-02','12:40:00',7.83),('6449','2013-03-02','12:45:00',8.24),('6449','2013-03-02','12:50:00',11.01),('6449','2013-03-02','12:55:00',14.96),('6449','2013-03-02','13:00:00',12.72),('6449','2013-03-02','13:05:00',13.17),('6449','2013-03-02','13:10:00',14.03),('6449','2013-03-02','13:15:00',14.88),('6449','2013-03-02','13:20:00',12.18),('6449','2013-03-02','13:25:00',7.68),('6449','2013-03-02','13:30:00',5.98),('6449','2013-03-02','13:35:00',4.97),('6449','2013-03-02','13:40:00',4.72),('6449','2013-03-02','13:45:00',4.69),('6449','2013-03-02','13:50:00',5.42),('6449','2013-03-02','13:55:00',5.05),('6449','2013-03-02','14:00:00',5.09),('6449','2013-03-02','14:05:00',4.53),('6449','2013-03-02','14:10:00',4.08),('6449','2013-03-02','14:15:00',3.79),('6449','2013-03-02','14:20:00',3.83),('6449','2013-03-02','14:25:00',3.32),('6449','2013-03-02','14:30:00',3.1),('6449','2013-03-02','14:35:00',3.25),('6449','2013-03-02','14:40:00',3.6),('6449','2013-03-02','14:45:00',3.96),('6449','2013-03-02','14:50:00',4.58),('6449','2013-03-02','14:55:00',4.75),('6449','2013-03-02','15:00:00',4.55),('6449','2013-03-02','15:05:00',4.7),('6449','2013-03-02','15:10:00',4.64),('6449','2013-03-02','15:15:00',4.18),('6449','2013-03-02','15:20:00',3.54),('6449','2013-03-02','15:25:00',3.06),('6449','2013-03-02','15:30:00',2.79),('6449','2013-03-02','15:35:00',3.08),('6449','2013-03-02','15:40:00',3.12),('6449','2013-03-02','15:45:00',2.99),('6449','2013-03-02','15:50:00',3.03),('6449','2013-03-02','15:55:00',3.3),('6449','2013-03-02','16:00:00',2.54),('6449','2013-03-02','16:05:00',1.65),('6449','2013-03-02','16:10:00',1.28),('6449','2013-03-02','16:15:00',1.21),('6449','2013-03-02','16:20:00',1.26),('6449','2013-03-02','16:25:00',1.34),('6449','2013-03-02','16:30:00',1.47),('6449','2013-03-02','16:35:00',1.41),('6449','2013-03-02','16:40:00',1.19),('6449','2013-03-02','16:45:00',1.01),('6449','2013-03-01','07:35:00',1.1),('6449','2013-03-01','07:40:00',1.39),('6449','2013-03-01','07:45:00',1.77),('6449','2013-03-01','07:50:00',2.18),('6449','2013-03-01','07:55:00',2.37),('6449','2013-03-01','08:00:00',2.63),('6449','2013-03-01','08:05:00',2.63),('6449','2013-03-01','08:10:00',2.57),('6449','2013-03-01','08:15:00',2.46),('6449','2013-03-01','08:20:00',2.83),('6449','2013-03-01','08:25:00',2.94),('6449','2013-03-01','08:30:00',3.13),('6449','2013-03-01','08:35:00',3.19),('6449','2013-03-01','08:40:00',3.38),('6449','2013-03-01','08:45:00',3.61),('6449','2013-03-01','08:50:00',3.79),('6449','2013-03-01','08:55:00',4.03),('6449','2013-03-01','09:00:00',4.58),('6449','2013-03-01','09:05:00',5.14),('6449','2013-03-01','09:10:00',5.34),('6449','2013-03-01','09:15:00',6.03),('6449','2013-03-01','09:20:00',7.5),('6449','2013-03-01','09:25:00',8.04),('6449','2013-03-01','09:30:00',8.45),('6449','2013-03-01','09:35:00',8.49),('6449','2013-03-01','09:40:00',7.81),('6449','2013-03-01','09:45:00',7.99),('6449','2013-03-01','09:50:00',7.96),('6449','2013-03-01','09:55:00',7.78),('6449','2013-03-01','10:00:00',7.87),('6449','2013-03-01','10:05:00',7.9),('6449','2013-03-01','10:10:00',7.25),('6449','2013-03-01','10:15:00',6.48),('6449','2013-03-01','10:20:00',6),('6449','2013-03-01','10:25:00',5.86),('6449','2013-03-01','10:30:00',5.6),('6449','2013-03-01','10:35:00',5.47),('6449','2013-03-01','10:40:00',5.49),('6449','2013-03-01','10:45:00',5.47),('6449','2013-03-01','10:50:00',5.38),('6449','2013-03-01','10:55:00',5.34),('6449','2013-03-01','11:00:00',5.26),('6449','2013-03-01','11:05:00',5.23),('6449','2013-03-01','11:10:00',5.33),('6449','2013-03-01','11:15:00',5.68),('6449','2013-03-01','11:20:00',5.85),('6449','2013-03-01','11:25:00',5.76),('6449','2013-03-01','11:30:00',6.02),('6449','2013-03-01','11:35:00',6.16),('6449','2013-03-01','11:40:00',6.28),('6449','2013-03-01','11:45:00',6.04),('6449','2013-03-01','11:50:00',5.8),('6449','2013-03-01','11:55:00',5.43),('6449','2013-03-01','12:00:00',5.28),('6449','2013-03-01','12:05:00',5.18),('6449','2013-03-01','12:10:00',5.18),('6449','2013-03-01','12:15:00',5.26),('6449','2013-03-01','12:20:00',5.45),('6449','2013-03-01','12:25:00',5.48),('6449','2013-03-01','12:30:00',5.3),('6449','2013-03-01','12:35:00',5.26),('6449','2013-03-01','12:40:00',5.68),('6449','2013-03-01','12:45:00',6.49),('6449','2013-03-01','12:50:00',6.44),('6449','2013-03-01','12:55:00',6.25),('6449','2013-03-01','13:00:00',6.06),('6449','2013-03-01','13:05:00',5.69),('6449','2013-03-01','13:10:00',5.47),('6449','2013-03-01','13:15:00',5.39),('6449','2013-03-01','13:20:00',5.06),('6449','2013-03-01','13:25:00',4.9),('6449','2013-03-01','13:30:00',4.71),('6449','2013-03-01','13:35:00',4.44),('6449','2013-03-01','13:40:00',3.96),('6449','2013-03-01','13:45:00',3.71),('6449','2013-03-01','13:50:00',3.5),('6449','2013-03-01','13:55:00',3.39),('6449','2013-03-01','14:00:00',3.42),('6449','2013-03-01','14:05:00',3.4),('6449','2013-03-01','14:10:00',3.39),('6449','2013-03-01','14:15:00',3.49),('6449','2013-03-01','14:20:00',3.65),('6449','2013-03-01','14:25:00',3.69),('6449','2013-03-01','14:30:00',3.68),('6449','2013-03-01','14:35:00',3.54),('6449','2013-03-01','14:40:00',3.48),('6449','2013-03-01','14:45:00',3.47),('6449','2013-03-01','14:50:00',3.38),('6449','2013-03-01','14:55:00',3.36),('6449','2013-03-01','15:00:00',3.33),('6449','2013-03-01','15:05:00',3.33),('6449','2013-03-01','15:10:00',2.95),('6449','2013-03-01','15:15:00',2.45),('6449','2013-03-01','15:20:00',2.08),('6449','2013-03-01','15:25:00',1.95),('6449','2013-03-01','15:30:00',1.96),('6449','2013-03-01','15:35:00',1.88),('6449','2013-03-01','15:40:00',1.66),('6449','2013-03-01','15:45:00',1.58),('6449','2013-03-01','15:50:00',1.8),('6449','2013-03-01','15:55:00',1.88),('6449','2013-03-01','16:00:00',1.78),('6449','2013-03-01','16:05:00',1.65),('6449','2013-03-01','16:10:00',1.38),('6449','2013-03-01','16:15:00',1.18),('6449','2013-03-01','16:20:00',1.11),('6449','2013-03-01','16:25:00',1.12),('6449','2013-03-01','16:30:00',1.06),('6449','2013-02-28','07:20:00',1.17),('6449','2013-02-28','07:25:00',1.42),('6449','2013-02-28','07:30:00',1.71),('6449','2013-02-28','07:35:00',2.04),('6449','2013-02-28','07:40:00',2.39),('6449','2013-02-28','07:45:00',2.76),('6449','2013-02-28','07:50:00',3.14),('6449','2013-02-28','07:55:00',3.55),('6449','2013-02-28','08:00:00',3.94),('6449','2013-02-28','08:05:00',4.32),('6449','2013-02-28','08:10:00',4.74),('6449','2013-02-28','08:15:00',5.12),('6449','2013-02-28','08:20:00',5.49),('6449','2013-02-28','08:25:00',5.76),('6449','2013-02-28','08:30:00',6.36),('6449','2013-02-28','08:35:00',6.8),('6449','2013-02-28','08:40:00',7.23),('6449','2013-02-28','08:45:00',7.33),('6449','2013-02-28','08:50:00',7.36),('6449','2013-02-28','08:55:00',8.33),('6449','2013-02-28','09:00:00',8.75),('6449','2013-02-28','09:05:00',9.12),('6449','2013-02-28','09:10:00',9.44),('6449','2013-02-28','09:15:00',9.77),('6449','2013-02-28','09:20:00',10.13),('6449','2013-02-28','09:25:00',10.49),('6449','2013-02-28','09:30:00',10.7),('6449','2013-02-28','09:35:00',10.76),('6449','2013-02-28','09:40:00',11.48),('6449','2013-02-28','09:45:00',11.76),('6449','2013-02-28','09:50:00',12.1),('6449','2013-02-28','09:55:00',12.38),('6449','2013-02-28','10:00:00',12.57),('6449','2013-02-28','10:05:00',12.76),('6449','2013-02-28','10:10:00',12.65),('6449','2013-02-28','10:15:00',13.13),('6449','2013-02-28','10:20:00',13.34),('6449','2013-02-28','10:25:00',13.4),('6449','2013-02-28','10:30:00',13.67),('6449','2013-02-28','10:35:00',13.81),('6449','2013-02-28','10:40:00',13.67),('6449','2013-02-28','10:45:00',14.09),('6449','2013-02-28','10:50:00',14.15),('6449','2013-02-28','10:55:00',14.34),('6449','2013-02-28','11:00:00',14.51),('6449','2013-02-28','11:05:00',13.1),('6449','2013-02-28','11:10:00',10.51),('6449','2013-02-28','11:15:00',14.71),('6449','2013-02-28','11:20:00',14.79),('6449','2013-02-28','11:25:00',15.01),('6449','2013-02-28','11:30:00',14.98),('6449','2013-02-28','11:35:00',15.19),('6449','2013-02-28','11:40:00',15.17),('6449','2013-02-28','11:45:00',15.28),('6449','2013-02-28','11:50:00',15.29),('6449','2013-02-28','11:55:00',14.78),('6449','2013-02-28','12:00:00',15.16),('6449','2013-02-28','12:05:00',15.14),('6449','2013-02-28','12:10:00',14.78),('6449','2013-02-28','12:15:00',14.91),('6449','2013-02-28','12:20:00',14.38),('6449','2013-02-28','12:25:00',14.01),('6449','2013-02-28','12:30:00',14.85),('6449','2013-02-28','12:35:00',14.57),('6449','2013-02-28','12:40:00',14.03),('6449','2013-02-28','12:45:00',14.81),('6449','2013-02-28','12:50:00',14.67),('6449','2013-02-28','12:55:00',14.54),('6449','2013-02-28','13:00:00',14.38),('6449','2013-02-28','13:05:00',14.15),('6449','2013-02-28','13:10:00',13.99),('6449','2013-02-28','13:15:00',13.92),('6449','2013-02-28','13:20:00',13.87),('6449','2013-02-28','13:25:00',14.12),('6449','2013-02-28','13:30:00',14.13),('6449','2013-02-28','13:35:00',14.12),('6449','2013-02-28','13:40:00',13.67),('6449','2013-02-28','13:45:00',13.59),('6449','2013-02-28','13:50:00',13.46),('6449','2013-02-28','13:55:00',13.14),('6449','2013-02-28','14:00:00',12.9),('6449','2013-02-28','14:05:00',12.78),('6449','2013-02-28','14:10:00',12.87),('6449','2013-02-28','14:15:00',12.44),('6449','2013-02-28','14:20:00',12.06),('6449','2013-02-28','14:25:00',12.04),('6449','2013-02-28','14:30:00',11.84),('6449','2013-02-28','14:35:00',11.36),('6449','2013-02-28','14:40:00',11.14),('6449','2013-02-28','14:45:00',10.86),('6449','2013-02-28','14:50:00',10.67),('6449','2013-02-28','14:55:00',10.57),('6449','2013-02-28','15:00:00',10.34),('6449','2013-02-28','15:05:00',10.02),('6449','2013-02-28','15:10:00',9.68),('6449','2013-02-28','15:15:00',9.05),('6449','2013-02-28','15:20:00',8.79),('6449','2013-02-28','15:25:00',8.53),('6449','2013-02-28','15:30:00',7.99),('6449','2013-02-28','15:35:00',7.77),('6449','2013-02-28','15:40:00',7.48),('6449','2013-02-28','15:45:00',7.05),('6449','2013-02-28','15:50:00',6.74),('6449','2013-02-28','15:55:00',6.45),('6449','2013-02-28','16:00:00',6.02),('6449','2013-02-28','16:05:00',5.83),('6449','2013-02-28','16:10:00',5.5),('6449','2013-02-28','16:15:00',5.14),('6449','2013-02-28','16:20:00',4.72),('6449','2013-02-28','16:25:00',4.32),('6449','2013-02-28','16:30:00',3.92),('6449','2013-02-28','16:35:00',3.59),('6449','2013-02-28','16:40:00',3.25),('6449','2013-02-28','16:45:00',2.89),('6449','2013-02-28','16:50:00',2.59),('6449','2013-02-28','16:55:00',2.27),('6449','2013-02-28','17:00:00',1.95),('6449','2013-02-28','17:05:00',1.66),('6449','2013-02-28','17:10:00',1.42),('6449','2013-02-28','17:15:00',1.13),('6449','2013-02-27','07:20:00',1.1),('6449','2013-02-27','07:25:00',1.37),('6449','2013-02-27','07:30:00',1.63),('6449','2013-02-27','07:35:00',1.99),('6449','2013-02-27','07:40:00',2.39),('6449','2013-02-27','07:45:00',2.73),('6449','2013-02-27','07:50:00',3.16),('6449','2013-02-27','07:55:00',3.56),('6449','2013-02-27','08:00:00',3.9),('6449','2013-02-27','08:05:00',4.36),('6449','2013-02-27','08:10:00',4.77),('6449','2013-02-27','08:15:00',5.14),('6449','2013-02-27','08:20:00',5.53),('6449','2013-02-27','08:25:00',5.97),('6449','2013-02-27','08:30:00',6.39),('6449','2013-02-27','08:35:00',6.78),('6449','2013-02-27','08:40:00',7.16),('6449','2013-02-27','08:45:00',7.57),('6449','2013-02-27','08:50:00',7.95),('6449','2013-02-27','08:55:00',8.35),('6449','2013-02-27','09:00:00',7.68),('6449','2013-02-27','09:05:00',9.06),('6449','2013-02-27','09:10:00',9.43),('6449','2013-02-27','09:15:00',9.64),('6449','2013-02-27','09:20:00',10.14),('6449','2013-02-27','09:25:00',10.53),('6449','2013-02-27','09:30:00',10.69),('6449','2013-02-27','09:35:00',11.16),('6449','2013-02-27','09:40:00',11.44),('6449','2013-02-27','09:45:00',11.69),('6449','2013-02-27','09:50:00',11.79),('6449','2013-02-27','09:55:00',12.19),('6449','2013-02-27','10:00:00',12.35),('6449','2013-02-27','10:05:00',12.61),('6449','2013-02-27','10:10:00',12.84),('6449','2013-02-27','10:15:00',13.06),('6449','2013-02-27','10:20:00',13.19),('6449','2013-02-27','10:25:00',13.34),('6449','2013-02-27','10:30:00',13.54),('6449','2013-02-27','10:35:00',13.62),('6449','2013-02-27','10:40:00',13.84),('6449','2013-02-27','10:45:00',14.06),('6449','2013-02-27','10:50:00',14.21),('6449','2013-02-27','10:55:00',14.33),('6449','2013-02-27','11:00:00',14.41),('6449','2013-02-27','11:05:00',14.33),('6449','2013-02-27','11:10:00',14.5),('6449','2013-02-27','11:15:00',14.45),('6449','2013-02-27','11:20:00',14.66),('6449','2013-02-27','11:25:00',14.78),('6449','2013-02-27','11:30:00',14.83),('6449','2013-02-27','11:35:00',14.83),('6449','2013-02-27','11:40:00',14.62),('6449','2013-02-27','11:45:00',14.56),('6449','2013-02-27','11:50:00',14.69),('6449','2013-02-27','11:55:00',14.67),('6449','2013-02-27','12:00:00',9.6),('6449','2013-02-27','12:05:00',15.09),('6449','2013-02-27','12:10:00',15.77),('6449','2013-02-27','12:15:00',15.45),('6449','2013-02-27','12:20:00',15.48),('6449','2013-02-27','12:25:00',15.6),('6449','2013-02-27','12:30:00',15.56),('6449','2013-02-27','12:35:00',15.44),('6449','2013-02-27','12:40:00',15.36),('6449','2013-02-27','12:45:00',15.31),('6449','2013-02-27','12:50:00',15.07),('6449','2013-02-27','12:55:00',15.08),('6449','2013-02-27','13:00:00',14.77),('6449','2013-02-27','13:05:00',14.92),('6449','2013-02-27','13:10:00',14.89),('6449','2013-02-27','13:15:00',14.76),('6449','2013-02-27','13:20:00',14.42),('6449','2013-02-27','13:25:00',14.5),('6449','2013-02-27','13:30:00',14.35),('6449','2013-02-27','13:35:00',14.17),('6449','2013-02-27','13:40:00',13.94),('6449','2013-02-27','13:45:00',13.8),('6449','2013-02-27','13:50:00',13.7),('6449','2013-02-27','13:55:00',13.49),('6449','2013-02-27','14:00:00',13.19),('6449','2013-02-27','14:05:00',12.95),('6449','2013-02-27','14:10:00',12.81),('6449','2013-02-27','14:15:00',12.47),('6449','2013-02-27','14:20:00',12.2),('6449','2013-02-27','14:25:00',10.67),('6449','2013-02-27','14:30:00',11.89),('6449','2013-02-27','14:35:00',11.53),('6449','2013-02-27','14:40:00',11.13),('6449','2013-02-27','14:45:00',11.1),('6449','2013-02-27','14:50:00',10.77),('6449','2013-02-27','14:55:00',10.7),('6449','2013-02-27','15:00:00',10.33),('6449','2013-02-27','15:05:00',9.93),('6449','2013-02-27','15:10:00',9.73),('6449','2013-02-27','15:15:00',9.46),('6449','2013-02-27','15:20:00',9.24),('6449','2013-02-27','15:25:00',8.87),('6449','2013-02-27','15:30:00',8.55),('6449','2013-02-27','15:35:00',8.25),('6449','2013-02-27','15:40:00',7.97),('6449','2013-02-27','15:45:00',7.55),('6449','2013-02-27','15:50:00',7.16),('6449','2013-02-27','15:55:00',6.86),('6449','2013-02-27','16:00:00',6.42),('6449','2013-02-27','16:05:00',6.06),('6449','2013-02-27','16:10:00',5.69),('6449','2013-02-27','16:15:00',5.3),('6449','2013-02-27','16:20:00',4.88),('6449','2013-02-27','16:25:00',4.5),('6449','2013-02-27','16:30:00',4.09),('6449','2013-02-27','16:35:00',3.67),('6449','2013-02-27','16:40:00',3.34),('6449','2013-02-27','16:45:00',2.98),('6449','2013-02-27','16:50:00',2.6),('6449','2013-02-27','16:55:00',2.29),('6449','2013-02-27','17:00:00',1.92),('6449','2013-02-27','17:05:00',1.65),('6449','2013-02-27','17:10:00',1.39),('6449','2013-02-27','17:15:00',1.14),('6449','2013-02-26','08:20:00',1.11),('6449','2013-02-26','08:25:00',1.27),('6449','2013-02-26','08:30:00',1.41),('6449','2013-02-26','08:35:00',1.56),('6449','2013-02-26','08:41:00',1.72),('6449','2013-02-26','08:45:00',2.03),('6449','2013-02-26','08:50:00',2.26),('6449','2013-02-26','08:55:00',2.57),('6449','2013-02-26','09:00:00',2.76),('6449','2013-02-26','09:05:00',2.94),('6449','2013-02-26','09:10:00',3.05),('6449','2013-02-26','09:15:00',3.22),('6449','2013-02-26','09:20:00',3.61),('6449','2013-02-26','09:25:00',4.09),('6449','2013-02-26','09:30:00',4.52),('6449','2013-02-26','09:35:00',5.05),('6449','2013-02-26','09:40:00',5.48),('6449','2013-02-26','09:45:00',6.01),('6449','2013-02-26','09:50:00',6.97),('6449','2013-02-26','09:55:00',8.18),('6449','2013-02-26','10:00:00',9.84),('6449','2013-02-26','10:05:00',11.4),('6449','2013-02-26','10:10:00',12.14),('6449','2013-02-26','10:15:00',12.92),('6449','2013-02-26','10:20:00',13.31),('6449','2013-02-26','10:25:00',13.35),('6449','2013-02-26','10:30:00',11.75),('6449','2013-02-26','10:35:00',11.5),('6449','2013-02-26','10:40:00',12.03),('6449','2013-02-26','10:45:00',14.33),('6449','2013-02-26','10:50:00',14.04),('6449','2013-02-26','10:55:00',13.9),('6449','2013-02-26','11:00:00',14.58),('6449','2013-02-26','11:05:00',8.41),('6449','2013-02-26','11:10:00',15.37),('6449','2013-02-26','11:15:00',10.24),('6449','2013-02-26','11:20:00',7.03),('6449','2013-02-26','11:25:00',7.1),('6449','2013-02-26','11:30:00',7.61),('6449','2013-02-26','11:35:00',8.66),('6449','2013-02-26','11:40:00',10.37),('6449','2013-02-26','11:45:00',13.02),('6449','2013-02-26','11:50:00',16.72),('6449','2013-02-26','11:55:00',18.22),('6449','2013-02-26','12:00:00',15.34),('6449','2013-02-26','12:05:00',12.98),('6449','2013-02-26','12:10:00',13.46),('6449','2013-02-26','12:15:00',12.94),('6449','2013-02-26','12:20:00',11.6),('6449','2013-02-26','12:25:00',14.95),('6449','2013-02-26','12:30:00',14.15),('6449','2013-02-26','12:35:00',12.12),('6449','2013-02-26','12:40:00',6.43),('6449','2013-02-26','12:45:00',6.48),('6449','2013-02-26','12:50:00',6.14),('6449','2013-02-26','12:55:00',5.93),('6449','2013-02-26','13:00:00',12.06),('6449','2013-02-26','13:05:00',10.67),('6449','2013-02-26','13:10:00',6.57),('6449','2013-02-26','13:15:00',6.21),('6449','2013-02-26','13:20:00',4.28),('6449','2013-02-26','13:25:00',3.04),('6449','2013-02-26','13:30:00',2.86),('6449','2013-02-26','13:35:00',2.71),('6449','2013-02-26','13:40:00',2.49),('6449','2013-02-26','13:45:00',2.28),('6449','2013-02-26','13:50:00',2.17),('6449','2013-02-26','13:55:00',2.27),('6449','2013-02-26','14:00:00',2.39),('6449','2013-02-26','14:05:00',2.68),('6449','2013-02-26','14:10:00',2.96),('6449','2013-02-26','14:15:00',3.22),('6449','2013-02-26','14:20:00',3.58),('6449','2013-02-26','14:25:00',3.72),('6449','2013-02-26','14:30:00',3.66),('6449','2013-02-26','14:35:00',3.72),('6449','2013-02-26','14:40:00',3.82),('6449','2013-02-26','14:45:00',3.67),('6449','2013-02-26','14:50:00',3.68),('6449','2013-02-26','14:55:00',3.58),('6449','2013-02-26','15:00:00',3.13),('6449','2013-02-26','15:05:00',2.5),('6449','2013-02-26','15:10:00',2.21),('6449','2013-02-26','15:15:00',1.84),('6449','2013-02-26','15:20:00',1.61),('6449','2013-02-26','15:25:00',1.4),('6449','2013-02-26','15:30:00',1.26),('6449','2013-02-26','15:35:00',1.21),('6449','2013-02-26','15:40:00',1.1),('6449','2013-02-26','15:45:00',1.29),('6449','2013-02-26','15:50:00',1.33),('6449','2013-02-26','15:55:00',1.37),('6449','2013-02-26','16:00:00',1.34),('6449','2013-02-26','16:05:00',1.26),('6449','2013-02-26','16:10:00',1.32),('6449','2013-02-26','16:15:00',1.43),('6449','2013-02-26','16:20:00',1.5),('6449','2013-02-26','16:25:00',1.48),('6449','2013-02-26','16:30:00',1.46),('6449','2013-02-26','16:35:00',1.34),('6449','2013-02-26','16:40:00',1.46),('6449','2013-02-26','16:45:00',1.61),('6449','2013-02-26','16:50:00',1.38),('6449','2013-02-26','16:55:00',1.19),('6449','2013-02-26','17:00:00',1.17),('6449','2013-02-26','17:05:00',1.12),('6449','2013-02-25','08:15:00',1.85),('6449','2013-02-25','08:20:00',1.95),('6449','2013-02-25','08:25:00',1.88),('6449','2013-02-25','08:30:00',2.05),('6449','2013-02-25','08:35:00',2.49),('6449','2013-02-25','08:40:00',2.21),('6449','2013-02-25','08:45:00',1.59),('6449','2013-02-25','08:50:00',1.14),('6449','2013-02-25','09:00:00',1.21),('6449','2013-02-25','09:05:00',2.38),('6449','2013-02-25','09:10:00',5.88),('6449','2013-02-25','09:15:00',8.59),('6449','2013-02-25','09:20:00',5.82),('6449','2013-02-25','09:25:00',6.15),('6449','2013-02-25','09:30:00',4.31),('6449','2013-02-25','09:35:00',5.09),('6449','2013-02-25','09:40:00',5.9),('6449','2013-02-25','09:45:00',5.87),('6449','2013-02-25','09:50:00',8.22),('6449','2013-02-25','09:55:00',10.28),('6449','2013-02-25','10:00:00',8.54),('6449','2013-02-25','10:05:00',7.27),('6449','2013-02-25','10:10:00',7.09),('6449','2013-02-25','10:15:00',9.95),('6449','2013-02-25','10:20:00',10.4),('6449','2013-02-25','10:25:00',7.81),('6449','2013-02-25','10:30:00',10.31),('6449','2013-02-25','10:35:00',14.53),('6449','2013-02-25','10:40:00',13.51),('6449','2013-02-25','10:45:00',15.28),('6449','2013-02-25','10:50:00',15.31),('6449','2013-02-25','10:55:00',15.06),('6449','2013-02-25','11:00:00',15.71),('6449','2013-02-25','11:05:00',15.66),('6449','2013-02-25','11:10:00',15.83),('6449','2013-02-25','11:15:00',15.91),('6449','2013-02-25','11:20:00',15.56),('6449','2013-02-25','11:25:00',12.03),('6449','2013-02-25','11:30:00',14.74),('6449','2013-02-25','11:35:00',6.45),('6449','2013-02-25','11:40:00',14.67),('6449','2013-02-25','11:45:00',8.29),('6449','2013-02-25','11:50:00',5.77),('6449','2013-02-25','11:55:00',15.3),('6449','2013-02-25','12:00:00',8.98),('6449','2013-02-25','12:05:00',6.47),('6449','2013-02-25','12:10:00',7.48),('6449','2013-02-25','12:15:00',8.38),('6449','2013-02-25','12:20:00',10.11),('6449','2013-02-25','12:25:00',6.54),('6449','2013-02-25','12:30:00',8.95),('6449','2013-02-25','12:35:00',10.25),('6449','2013-02-25','12:40:00',6.17),('6449','2013-02-25','12:45:00',5.47),('6449','2013-02-25','12:50:00',6.1),('6449','2013-02-25','12:55:00',6.59),('6449','2013-02-25','13:00:00',7.28),('6449','2013-02-25','13:05:00',7.45),('6449','2013-02-25','13:10:00',5.95),('6449','2013-02-25','13:15:00',4.73),('6449','2013-02-25','13:20:00',4.27),('6449','2013-02-25','13:25:00',4.01),('6449','2013-02-25','13:30:00',3.96),('6449','2013-02-25','13:35:00',4.22),('6449','2013-02-25','13:40:00',6.18),('6449','2013-02-25','13:45:00',6.36),('6449','2013-02-25','13:50:00',7.98),('6449','2013-02-25','13:55:00',8),('6449','2013-02-25','14:01:00',8.53),('6449','2013-02-25','14:05:00',7.79),('6449','2013-02-25','14:10:00',11.87),('6449','2013-02-25','14:15:00',8.51),('6449','2013-02-25','14:20:00',9.61),('6449','2013-02-25','14:25:00',11.84),('6449','2013-02-25','14:30:00',4.46),('6449','2013-02-25','14:35:00',6.95),('6449','2013-02-25','14:41:00',9.87),('6449','2013-02-25','14:45:00',3.61),('6449','2013-02-25','14:50:00',6.01),('6449','2013-02-25','14:55:00',8.72),('6449','2013-02-25','15:00:00',5.44),('6449','2013-02-25','15:05:00',5.09),('6449','2013-02-25','15:10:00',4.07),('6449','2013-02-25','15:15:00',3.85),('6449','2013-02-25','15:20:00',3.73),('6449','2013-02-25','15:25:00',3.53),('6449','2013-02-25','15:30:00',2.76),('6449','2013-02-25','15:35:00',2.03),('6449','2013-02-25','15:40:00',1.8),('6449','2013-02-25','15:45:00',1.96),('6449','2013-02-25','15:50:00',1.76),('6449','2013-02-25','15:55:00',1.55),('6449','2013-02-25','16:00:00',2.01),('6449','2013-02-25','16:05:00',5.26),('6449','2013-02-25','16:10:00',3.93),('6449','2013-02-25','16:15:00',3.92),('6449','2013-02-25','16:20:00',6.15),('6449','2013-02-25','16:25:00',4.5),('6449','2013-02-25','16:30:00',2.26),('6449','2013-02-25','16:35:00',1.51),('6449','2013-02-25','16:40:00',1.27),('6449','2013-02-25','16:45:00',1.09),('6449','2013-02-24','08:15:00',1.03),('6449','2013-02-24','08:20:00',1.23),('6449','2013-02-24','08:25:00',1.1),('6449','2013-02-24','08:30:00',1.46),('6449','2013-02-24','08:35:00',2.14),('6449','2013-02-24','08:40:00',2.23),('6449','2013-02-24','08:45:00',1.95),('6449','2013-02-24','08:50:00',2.3),('6449','2013-02-24','08:55:00',1.72),('6449','2013-02-24','09:00:00',2.08),('6449','2013-02-24','09:05:00',2.53),('6449','2013-02-24','09:10:00',3),('6449','2013-02-24','09:15:00',2.7),('6449','2013-02-24','09:20:00',2.22),('6449','2013-02-24','09:25:00',3.21),('6449','2013-02-24','09:30:00',2.91),('6449','2013-02-24','09:35:00',2.46),('6449','2013-02-24','09:40:00',2.71),('6449','2013-02-24','09:45:00',2.85),('6449','2013-02-24','09:50:00',3.03),('6449','2013-02-24','09:55:00',3.76),('6449','2013-02-24','10:00:00',2.59),('6449','2013-02-24','10:05:00',3),('6449','2013-02-24','10:10:00',2.7),('6449','2013-02-24','10:15:00',3.56),('6449','2013-02-24','10:20:00',4.24),('6449','2013-02-24','10:25:00',4.8),('6449','2013-02-24','10:30:00',5.57),('6449','2013-02-24','10:35:00',4.86),('6449','2013-02-24','10:40:00',3.34),('6449','2013-02-24','10:45:00',2.93),('6449','2013-02-24','10:50:00',3.03),('6449','2013-02-24','10:55:00',3.23),('6449','2013-02-24','11:00:00',2.96),('6449','2013-02-24','11:05:00',2.92),('6449','2013-02-24','11:10:00',3.42),('6449','2013-02-24','11:15:00',4),('6449','2013-02-24','11:20:00',4.85),('6449','2013-02-24','11:25:00',4.6),('6449','2013-02-24','11:30:00',3.44),('6449','2013-02-24','11:35:00',3.98),('6449','2013-02-24','11:41:00',5.08),('6449','2013-02-24','11:45:00',7.71),('6449','2013-02-24','11:50:00',7.46),('6449','2013-02-24','11:55:00',9.93),('6449','2013-02-24','12:00:00',5.96),('6449','2013-02-24','12:05:00',7.71),('6449','2013-02-24','12:10:00',7.35),('6449','2013-02-24','12:15:00',6.25),('6449','2013-02-24','12:20:00',8.09),('6449','2013-02-24','12:25:00',8.32),('6449','2013-02-24','12:30:00',6.04),('6449','2013-02-24','12:35:00',8.33),('6449','2013-02-24','12:40:00',17.17),('6449','2013-02-24','12:45:00',8.73),('6449','2013-02-24','12:50:00',8.31),('6449','2013-02-24','12:55:00',15.2),('6449','2013-02-24','13:00:00',11.35),('6449','2013-02-24','13:05:00',16.92),('6449','2013-02-24','13:10:00',16.6),('6449','2013-02-24','13:15:00',13.71),('6449','2013-02-24','13:20:00',17.19),('6449','2013-02-24','13:25:00',14.48),('6449','2013-02-24','13:30:00',13.61),('6449','2013-02-24','13:35:00',7.35),('6449','2013-02-24','13:40:00',11.6),('6449','2013-02-24','13:45:00',6.12),('6449','2013-02-24','13:50:00',3.77),('6449','2013-02-24','13:55:00',4.19),('6449','2013-02-24','14:00:00',5.19),('6449','2013-02-24','14:05:00',3.52),('6449','2013-02-24','14:10:00',3.37),('6449','2013-02-24','14:15:00',3.98),('6449','2013-02-24','14:20:00',11.26),('6449','2013-02-24','14:25:00',12.98),('6449','2013-02-24','14:30:00',9.84),('6449','2013-02-24','14:35:00',12.69),('6449','2013-02-24','14:40:00',4.54),('6449','2013-02-24','14:45:00',6.82),('6449','2013-02-24','14:50:00',12.94),('6449','2013-02-24','14:55:00',9.9),('6449','2013-02-24','15:00:00',7.55),('6449','2013-02-24','15:05:00',11.39),('6449','2013-02-24','15:10:00',9.59),('6449','2013-02-24','15:15:00',5.97),('6449','2013-02-24','15:20:00',6.92),('6449','2013-02-24','15:25:00',8.3),('6449','2013-02-24','15:30:00',8.58),('6449','2013-02-24','15:35:00',7.99),('6449','2013-02-24','15:40:00',6.35),('6449','2013-02-24','15:45:00',8.02),('6449','2013-02-24','15:50:00',7.43),('6449','2013-02-24','15:55:00',5.55),('6449','2013-02-24','16:00:00',3.95),('6449','2013-02-24','16:05:00',1.23),('6449','2013-02-24','16:10:00',1.08),('6449','2013-02-24','16:15:00',1.39),('6449','2013-02-24','16:20:00',1.24),('6449','2013-02-23','07:20:00',1.29),('6449','2013-02-23','07:25:00',1.83),('6449','2013-02-23','07:30:00',2.33),('6449','2013-02-23','07:35:00',2.83),('6449','2013-02-23','07:40:00',3.45),('6449','2013-02-23','07:45:00',4.24),('6449','2013-02-23','07:50:00',4.5),('6449','2013-02-23','07:55:00',5.14),('6449','2013-02-23','08:00:00',6.29),('6449','2013-02-23','08:05:00',3.98),('6449','2013-02-23','08:11:00',2.51),('6449','2013-02-23','08:15:00',1.73),('6449','2013-02-23','08:20:00',1.54),('6449','2013-02-23','08:25:00',1.56),('6449','2013-02-23','08:30:00',1.52),('6449','2013-02-23','08:35:00',1.7),('6449','2013-02-23','08:40:00',1.88),('6449','2013-02-23','08:45:00',2.38),('6449','2013-02-23','08:50:00',2.59),('6449','2013-02-23','08:55:00',2.3),('6449','2013-02-23','09:00:00',2.09),('6449','2013-02-23','09:05:00',1.76),('6449','2013-02-23','09:10:00',1.82),('6449','2013-02-23','09:15:00',1.64),('6449','2013-02-23','09:20:00',1.61),('6449','2013-02-23','09:25:00',2.02),('6449','2013-02-23','09:30:00',2.03),('6449','2013-02-23','09:35:00',1.91),('6449','2013-02-23','09:40:00',2.42),('6449','2013-02-23','09:45:00',2.84),('6449','2013-02-23','09:50:00',2.01),('6449','2013-02-23','09:55:00',1.24),('6449','2013-02-23','10:00:00',1.16),('6449','2013-02-23','10:05:00',1.46),('6449','2013-02-23','10:10:00',1.59),('6449','2013-02-23','10:15:00',1.3),('6449','2013-02-23','10:20:00',2.22),('6449','2013-02-23','10:25:00',3.88),('6449','2013-02-23','10:30:00',2.56),('6449','2013-02-23','10:35:00',1.99),('6449','2013-02-23','10:40:00',2.03),('6449','2013-02-23','10:45:00',2.11),('6449','2013-02-23','10:50:00',2.02),('6449','2013-02-23','10:55:00',1.54),('6449','2013-02-23','11:00:00',1.63),('6449','2013-02-23','11:05:00',2.46),('6449','2013-02-23','11:10:00',3.26),('6449','2013-02-23','11:15:00',2.41),('6449','2013-02-23','11:20:00',1.6),('6449','2013-02-23','11:25:00',2.83),('6449','2013-02-23','11:30:00',3.26),('6449','2013-02-23','11:35:00',2.33),('6449','2013-02-23','11:40:00',1.69),('6449','2013-02-23','11:45:00',2.01),('6449','2013-02-23','11:50:00',1.5),('6449','2013-02-23','11:55:00',1.38),('6449','2013-02-23','12:05:00',1.83),('6449','2013-02-23','12:10:00',1.82),('6449','2013-02-23','12:15:00',1.39),('6449','2013-02-23','12:20:00',1.41),('6449','2013-02-23','12:25:00',1.05),('6449','2013-02-23','13:05:00',1.29),('6449','2013-02-23','14:20:00',1.27),('6449','2013-02-23','14:40:00',1.05),('6449','2013-02-23','15:15:00',1.19),('6449','2013-02-23','15:20:00',1.64),('6449','2013-02-22','09:30:00',1.06),('6449','2013-02-22','09:40:00',1.53),('6449','2013-02-22','09:45:00',1.21),('6449','2013-02-22','09:50:00',1.2),('6449','2013-02-22','09:55:00',1.48),('6449','2013-02-22','10:00:00',1.39),('6449','2013-02-22','10:05:00',1.81),('6449','2013-02-22','10:10:00',1.92),('6449','2013-02-22','10:15:00',1.94),('6449','2013-02-22','10:20:00',1.07),('6449','2013-02-22','10:30:00',1.13),('6449','2013-02-22','10:35:00',1.31),('6449','2013-02-22','10:55:00',1.34),('6449','2013-02-22','11:00:00',1.49),('6449','2013-02-22','11:05:00',1.69),('6449','2013-02-22','11:10:00',2.02),('6449','2013-02-22','11:15:00',3.19),('6449','2013-02-22','11:20:00',2.83),('6449','2013-02-22','11:25:00',2.01),('6449','2013-02-22','11:30:00',1.16),('6449','2013-02-22','11:35:00',1.34),('6449','2013-02-22','11:40:00',1.44),('6449','2013-02-22','11:45:00',1.03),('6449','2013-02-22','11:50:00',1.32),('6449','2013-02-22','11:55:00',2.46),('6449','2013-02-22','12:00:00',4.22),('6449','2013-02-22','12:05:00',3.99),('6449','2013-02-22','12:10:00',3.73),('6449','2013-02-22','12:15:00',4.02),('6449','2013-02-22','12:20:00',3.08),('6449','2013-02-22','12:25:00',2.93),('6449','2013-02-22','12:30:00',1.61),('6449','2013-02-22','12:35:00',1.21),('6449','2013-02-22','12:50:00',1.22),('6449','2013-02-22','12:55:00',1.88),('6449','2013-02-22','13:00:00',2.63),('6449','2013-02-22','13:05:00',2.66),('6449','2013-02-22','13:10:00',1.45),('6449','2013-02-22','13:15:00',1.12),('6449','2013-02-22','13:20:00',1.02),('6449','2013-02-22','13:35:00',2.03),('6449','2013-02-22','13:40:00',4.27),('6449','2013-02-22','13:45:00',5.33),('6449','2013-02-22','13:50:00',5.04),('6449','2013-02-22','13:55:00',4.67),('6449','2013-02-22','14:00:00',2.58),('6449','2013-02-22','14:05:00',1.74),('6449','2013-02-22','14:10:00',2.51),('6449','2013-02-22','14:15:00',2.02),('6449','2013-02-22','14:20:00',1.23),('6449','2013-02-22','14:25:00',3.15),('6449','2013-02-22','14:30:00',5.35),('6449','2013-02-22','14:35:00',3.3),('6449','2013-02-22','14:41:00',5.24),('6449','2013-02-22','14:45:00',6.65),('6449','2013-02-22','14:50:00',5.37),('6449','2013-02-22','14:55:00',5.98),('6449','2013-02-22','15:00:00',4.93),('6449','2013-02-22','15:05:00',3.99),('6449','2013-02-22','15:10:00',2.15),('6449','2013-02-22','15:15:00',1.07),('6449','2013-02-22','15:20:00',1.41),('6449','2013-02-22','15:35:00',1.11),('6449','2013-02-22','15:40:00',2.86),('6449','2013-02-22','15:45:00',3.63),('6449','2013-02-22','15:50:00',1.93),('6449','2013-02-22','15:55:00',1.75),('6449','2013-02-22','16:00:00',1.54),('6449','2013-02-22','16:05:00',2.14),('6449','2013-02-22','16:10:00',4.04),('6449','2013-02-22','16:15:00',6.61),('6449','2013-02-22','16:20:00',1.32),('6449','2013-02-21','08:20:00',1.06),('6449','2013-02-21','08:25:00',1.11),('6449','2013-02-21','08:30:00',1.06),('6449','2013-02-21','08:35:00',1),('6449','2013-02-21','08:45:00',1.07),('6449','2013-02-21','08:50:00',1.21),('6449','2013-02-21','08:55:00',1.29),('6449','2013-02-21','09:00:00',1.18),('6449','2013-02-21','09:05:00',1.14),('6449','2013-02-21','09:10:00',1.31),('6449','2013-02-21','09:15:00',1.58),('6449','2013-02-21','09:20:00',1.9),('6449','2013-02-21','09:25:00',2.24),('6449','2013-02-21','09:30:00',2.38),('6449','2013-02-21','09:35:00',2.46),('6449','2013-02-21','09:40:00',2.4),('6449','2013-02-21','09:45:00',2.39),('6449','2013-02-21','09:50:00',2.67),('6449','2013-02-21','09:55:00',2.81),('6449','2013-02-21','10:00:00',2.99),('6449','2013-02-21','10:05:00',3.18),('6449','2013-02-21','10:10:00',3.3),('6449','2013-02-21','10:15:00',3.07),('6449','2013-02-21','10:20:00',3.02),('6449','2013-02-21','10:25:00',3.19),('6449','2013-02-21','10:30:00',3.52),('6449','2013-02-21','10:35:00',3.45),('6449','2013-02-21','10:40:00',3.34),('6449','2013-02-21','10:45:00',3.03),('6449','2013-02-21','10:50:00',2.78),('6449','2013-02-21','10:55:00',2.73),('6449','2013-02-21','11:00:00',2.52),('6449','2013-02-21','11:05:00',2.63),('6449','2013-02-21','11:10:00',3.02),('6449','2013-02-21','11:15:00',3.31),('6449','2013-02-21','11:20:00',3.5),('6449','2013-02-21','11:25:00',3.65),('6449','2013-02-21','11:30:00',3.81),('6449','2013-02-21','11:35:00',3.8),('6449','2013-02-21','11:40:00',3.74),('6449','2013-02-21','11:45:00',3.93),('6449','2013-02-21','11:50:00',4.36),('6449','2013-02-21','11:55:00',4.47),('6449','2013-02-21','12:00:00',4.28),('6449','2013-02-21','12:05:00',4.38),('6449','2013-02-21','12:10:00',4.45),('6449','2013-02-21','12:15:00',4.2),('6449','2013-02-21','12:20:00',3.8),('6449','2013-02-21','12:25:00',3.38),('6449','2013-02-21','12:30:00',2.96),('6449','2013-02-21','12:35:00',2.52),('6449','2013-02-21','12:40:00',2.33),('6449','2013-02-21','12:45:00',2.27),('6449','2013-02-21','12:50:00',2.46),('6449','2013-02-21','12:55:00',2.99),('6449','2013-02-21','13:00:00',3.97),('6449','2013-02-21','13:05:00',4.67),('6449','2013-02-21','13:10:00',4.56),('6449','2013-02-21','13:15:00',6.15),('6449','2013-02-21','13:20:00',6.81),('6449','2013-02-21','13:25:00',6.36),('6449','2013-02-21','13:30:00',6.08),('6449','2013-02-21','13:35:00',5.19),('6449','2013-02-21','13:40:00',5.1),('6449','2013-02-21','13:45:00',5.28),('6449','2013-02-21','13:50:00',5.36),('6449','2013-02-21','13:55:00',5.67),('6449','2013-02-21','14:00:00',8.34),('6449','2013-02-21','14:05:00',8.2),('6449','2013-02-21','14:10:00',6.12),('6449','2013-02-21','14:15:00',5.21),('6449','2013-02-21','14:20:00',4.5),('6449','2013-02-21','14:25:00',4.13),('6449','2013-02-21','14:30:00',3.89),('6449','2013-02-21','14:35:00',3.78),('6449','2013-02-21','14:40:00',4.5),('6449','2013-02-21','14:45:00',5.09),('6449','2013-02-21','14:50:00',6.06),('6449','2013-02-21','14:55:00',7.99),('6449','2013-02-21','15:00:00',11.47),('6449','2013-02-21','15:05:00',11.36),('6449','2013-02-21','15:10:00',10.72),('6449','2013-02-21','15:15:00',10.18),('6449','2013-02-21','15:20:00',9.65),('6449','2013-02-21','15:25:00',9.21),('6449','2013-02-21','15:30:00',8.72),('6449','2013-02-21','15:35:00',8.19),('6449','2013-02-21','15:40:00',7.75),('6449','2013-02-21','15:45:00',7.31),('6449','2013-02-21','15:50:00',6.8),('6449','2013-02-21','15:55:00',6.44),('6449','2013-02-21','16:00:00',6.03),('6449','2013-02-21','16:05:00',5.67),('6449','2013-02-21','16:10:00',5.28),('6449','2013-02-21','16:15:00',4.9),('6449','2013-02-21','16:20:00',4.42),('6449','2013-02-21','16:25:00',4.17),('6449','2013-02-21','16:30:00',3.88),('6449','2013-02-21','16:35:00',3.54),('6449','2013-02-21','16:40:00',3.12),('6449','2013-02-21','16:45:00',2.75),('6449','2013-02-21','16:50:00',2.39),('6449','2013-02-21','16:55:00',2.07),('6449','2013-02-21','17:00:00',1.72),('6449','2013-02-21','17:05:00',1.35),('6449','2013-02-21','17:10:00',1.06),('6449','2013-02-20','07:35:00',1.03),('6449','2013-02-20','07:45:00',1.02),('6449','2013-02-20','07:55:00',1.03),('6449','2013-02-20','08:00:00',1.01),('6449','2013-02-20','08:05:00',1.21),('6449','2013-02-20','08:10:00',1.63),('6449','2013-02-20','08:15:00',2.87),('6449','2013-02-20','08:20:00',4.61),('6449','2013-02-20','08:25:00',5.59),('6449','2013-02-20','08:30:00',5.83),('6449','2013-02-20','08:35:00',6.3),('6449','2013-02-20','08:40:00',6.64),('6449','2013-02-20','08:45:00',7.07),('6449','2013-02-20','08:50:00',7.36),('6449','2013-02-20','08:55:00',7.68),('6449','2013-02-20','09:00:00',8.03),('6449','2013-02-20','09:05:00',8.6),('6449','2013-02-20','09:10:00',9.95),('6449','2013-02-20','09:15:00',10.44),('6449','2013-02-20','09:20:00',10.3),('6449','2013-02-20','09:25:00',10.13),('6449','2013-02-20','09:30:00',10.44),('6449','2013-02-20','09:35:00',10.73),('6449','2013-02-20','09:40:00',11.04),('6449','2013-02-20','09:45:00',8.93),('6449','2013-02-20','09:50:00',5.64),('6449','2013-02-20','09:55:00',7.03),('6449','2013-02-20','10:00:00',5.84),('6449','2013-02-20','10:05:00',4.73),('6449','2013-02-20','10:10:00',4.82),('6449','2013-02-20','10:15:00',6.21),('6449','2013-02-20','10:20:00',6.63),('6449','2013-02-20','10:25:00',11.59),('6449','2013-02-20','10:30:00',6.58),('6449','2013-02-20','10:35:00',10.43),('6449','2013-02-20','10:40:00',9.26),('6449','2013-02-20','10:45:00',9.77),('6449','2013-02-20','10:50:00',7.96),('6449','2013-02-20','10:55:00',5.75),('6449','2013-02-20','11:00:00',11.41),('6449','2013-02-20','11:05:00',4.29),('6449','2013-02-20','11:10:00',13.65),('6449','2013-02-20','11:15:00',16.01),('6449','2013-02-20','11:20:00',14.19),('6449','2013-02-20','11:25:00',7.09),('6449','2013-02-20','11:30:00',13.87),('6449','2013-02-20','11:35:00',15.69),('6449','2013-02-20','11:40:00',15.95),('6449','2013-02-20','11:45:00',11.58),('6449','2013-02-20','11:50:00',8.68),('6449','2013-02-20','11:55:00',10.27),('6449','2013-02-20','12:00:00',11.92),('6449','2013-02-20','12:05:00',8.98),('6449','2013-02-20','12:10:00',9.73),('6449','2013-02-20','12:15:00',14.47),('6449','2013-02-20','12:20:00',9.12),('6449','2013-02-20','12:25:00',11.94),('6449','2013-02-20','12:30:00',16.83),('6449','2013-02-20','12:35:00',16.24),('6449','2013-02-20','12:40:00',15.68),('6449','2013-02-20','12:45:00',13.86),('6449','2013-02-20','12:50:00',9.73),('6449','2013-02-20','12:55:00',15.35),('6449','2013-02-20','13:00:00',15.34),('6449','2013-02-20','13:05:00',15.35),('6449','2013-02-20','13:10:00',15.1),('6449','2013-02-20','13:15:00',14.56),('6449','2013-02-20','13:20:00',13.6),('6449','2013-02-20','13:25:00',13.83),('6449','2013-02-20','13:30:00',14.45),('6449','2013-02-20','13:35:00',14.39),('6449','2013-02-20','13:40:00',13.88),('6449','2013-02-20','13:45:00',13.16),('6449','2013-02-20','13:50:00',13.79),('6449','2013-02-20','13:55:00',13.62),('6449','2013-02-20','14:00:00',13),('6449','2013-02-20','14:05:00',13.68),('6449','2013-02-20','14:10:00',13.3),('6449','2013-02-20','14:15:00',13.08),('6449','2013-02-20','14:20:00',12.87),('6449','2013-02-20','14:25:00',12.37),('6449','2013-02-20','14:30:00',12.27),('6449','2013-02-20','14:35:00',11.83),('6449','2013-02-20','14:40:00',11.37),('6449','2013-02-20','14:45:00',10.92),('6449','2013-02-20','14:50:00',9.78),('6449','2013-02-20','14:55:00',9.22),('6449','2013-02-20','15:00:00',5.68),('6449','2013-02-20','15:05:00',4.58),('6449','2013-02-20','15:10:00',9.35),('6449','2013-02-20','15:15:00',8.08),('6449','2013-02-20','15:20:00',7.64),('6449','2013-02-20','15:25:00',5.69),('6449','2013-02-20','15:30:00',5.17),('6449','2013-02-20','15:35:00',7.23),('6449','2013-02-20','15:40:00',6.02),('6449','2013-02-20','15:45:00',6.06),('6449','2013-02-20','15:50:00',7.47),('6449','2013-02-20','15:55:00',5.92),('6449','2013-02-20','16:00:00',4.69),('6449','2013-02-20','16:05:00',6.49),('6449','2013-02-20','16:10:00',4.9),('6449','2013-02-20','16:15:00',4.44),('6449','2013-02-20','16:20:00',4.42),('6449','2013-02-20','16:25:00',3.36),('6449','2013-02-20','16:30:00',4.18),('6449','2013-02-20','16:35:00',3.88),('6449','2013-02-20','16:40:00',3.91),('6449','2013-02-20','16:45:00',3.41),('6449','2013-02-20','16:50:00',2.77),('6449','2013-02-20','16:55:00',2.17),('6449','2013-02-20','17:00:00',1.7),('6449','2013-02-20','17:05:00',1.34),('6449','2013-02-20','17:10:00',1.3),('6449','2013-02-20','17:15:00',1.15),('6449','2013-02-19','07:25:00',1.06),('6449','2013-02-19','07:30:00',1.35),('6449','2013-02-19','07:35:00',1.65),('6449','2013-02-19','07:40:00',2),('6449','2013-02-19','07:45:00',2.37),('6449','2013-02-19','07:50:00',2.71),('6449','2013-02-19','07:55:00',3.08),('6449','2013-02-19','08:00:00',3.5),('6449','2013-02-19','08:05:00',3.92),('6449','2013-02-19','08:10:00',4.31),('6449','2013-02-19','08:15:00',4.64),('6449','2013-02-19','08:20:00',4.99),('6449','2013-02-19','08:25:00',5.43),('6449','2013-02-19','08:30:00',5.87),('6449','2013-02-19','08:35:00',6.2),('6449','2013-02-19','08:40:00',6.74),('6449','2013-02-19','08:45:00',7.09),('6449','2013-02-19','08:50:00',7.48),('6449','2013-02-19','08:55:00',7.8),('6449','2013-02-19','09:00:00',8.26),('6449','2013-02-19','09:05:00',8.6),('6449','2013-02-19','09:10:00',8.95),('6449','2013-02-19','09:15:00',9.29),('6449','2013-02-19','09:20:00',9.59),('6449','2013-02-19','09:25:00',9.93),('6449','2013-02-19','09:30:00',10.23),('6449','2013-02-19','09:35:00',10.53),('6449','2013-02-19','09:40:00',10.82),('6449','2013-02-19','09:45:00',11.1),('6449','2013-02-19','09:50:00',11.38),('6449','2013-02-19','09:55:00',11.66),('6449','2013-02-19','10:00:00',11.94),('6449','2013-02-19','10:05:00',12.21),('6449','2013-02-19','10:10:00',12.3),('6449','2013-02-19','10:15:00',12.68),('6449','2013-02-19','10:20:00',12.84),('6449','2013-02-19','10:25:00',12.89),('6449','2013-02-19','10:30:00',13.19),('6449','2013-02-19','10:35:00',13.31),('6449','2013-02-19','10:40:00',13.33),('6449','2013-02-19','10:45:00',13.63),('6449','2013-02-19','10:50:00',13.8),('6449','2013-02-19','10:55:00',13.86),('6449','2013-02-19','11:00:00',13.97),('6449','2013-02-19','11:05:00',14.09),('6449','2013-02-19','11:10:00',14.1),('6449','2013-02-19','11:15:00',14.28),('6449','2013-02-19','11:20:00',14.37),('6449','2013-02-19','11:25:00',14.37),('6449','2013-02-19','11:30:00',14.38),('6449','2013-02-19','11:35:00',14.4),('6449','2013-02-19','11:40:00',14.51),('6449','2013-02-19','11:45:00',14.6),('6449','2013-02-19','11:50:00',14.6),('6449','2013-02-19','11:55:00',14.32),('6449','2013-02-19','12:00:00',14.43),('6449','2013-02-19','12:05:00',14.57),('6449','2013-02-19','12:10:00',14.71),('6449','2013-02-19','12:15:00',15),('6449','2013-02-19','12:20:00',14.99),('6449','2013-02-19','12:25:00',14.77),('6449','2013-02-19','12:30:00',14.84),('6449','2013-02-19','12:35:00',14.78),('6449','2013-02-19','12:40:00',14.62),('6449','2013-02-19','12:45:00',14.72),('6449','2013-02-19','12:50:00',14.67),('6449','2013-02-19','12:55:00',14.64),('6449','2013-02-19','13:00:00',14.54),('6449','2013-02-19','13:05:00',14.52),('6449','2013-02-19','13:10:00',14.42),('6449','2013-02-19','13:15:00',14.24),('6449','2013-02-19','13:20:00',14.2),('6449','2013-02-19','13:25:00',14.16),('6449','2013-02-19','13:30:00',14.02),('6449','2013-02-19','13:35:00',13.94),('6449','2013-02-19','13:40:00',13.68),('6449','2013-02-19','13:45:00',13.53),('6449','2013-02-19','13:50:00',13.5),('6449','2013-02-19','13:55:00',13.25),('6449','2013-02-19','14:00:00',13.28),('6449','2013-02-19','14:05:00',13.05),('6449','2013-02-19','14:10:00',12.88),('6449','2013-02-19','14:15:00',12.37),('6449','2013-02-19','14:20:00',12.2),('6449','2013-02-19','14:25:00',11.89),('6449','2013-02-19','14:30:00',11.73),('6449','2013-02-19','14:35:00',11.45),('6449','2013-02-19','14:40:00',11.31),('6449','2013-02-19','14:45:00',11.13),('6449','2013-02-19','14:50:00',10.81),('6449','2013-02-19','14:55:00',10.63),('6449','2013-02-19','15:00:00',10.33),('6449','2013-02-19','15:05:00',10.03),('6449','2013-02-19','15:10:00',9.67),('6449','2013-02-19','15:15:00',9.4),('6449','2013-02-19','15:20:00',9.1),('6449','2013-02-19','15:25:00',8.64),('6449','2013-02-19','15:30:00',8.33),('6449','2013-02-19','15:35:00',8.03),('6449','2013-02-19','15:40:00',7.62),('6449','2013-02-19','15:45:00',7.33),('6449','2013-02-19','15:50:00',6.89),('6449','2013-02-19','15:55:00',6.46),('6449','2013-02-19','16:00:00',6.06),('6449','2013-02-19','16:05:00',5.66),('6449','2013-02-19','16:10:00',5.28),('6449','2013-02-19','16:15:00',4.86),('6449','2013-02-19','16:20:00',4.47),('6449','2013-02-19','16:25:00',4.05),('6449','2013-02-19','16:30:00',3.73),('6449','2013-02-19','16:35:00',3.37),('6449','2013-02-19','16:40:00',2.99),('6449','2013-02-19','16:45:00',2.61),('6449','2013-02-19','16:50:00',2.26),('6449','2013-02-19','16:55:00',1.89),('6449','2013-02-19','17:00:00',1.56),('6449','2013-02-19','17:05:00',1.25),('6449','2013-02-18','08:00:00',1.87),('6449','2013-02-18','08:05:00',3.29),('6449','2013-02-18','08:10:00',3.82),('6449','2013-02-18','08:15:00',4.15),('6449','2013-02-18','08:20:00',4.42),('6449','2013-02-18','08:25:00',5.04),('6449','2013-02-18','08:30:00',5.57),('6449','2013-02-18','08:35:00',5.89),('6449','2013-02-18','08:40:00',6.21),('6449','2013-02-18','08:45:00',6.8),('6449','2013-02-18','08:50:00',7.08),('6449','2013-02-18','08:55:00',7.58),('6449','2013-02-18','09:00:00',8.65),('6449','2013-02-18','09:05:00',8.27),('6449','2013-02-18','09:10:00',3.5),('6449','2013-02-18','09:15:00',3.22),('6449','2013-02-18','09:20:00',5.26),('6449','2013-02-18','09:25:00',5.43),('6449','2013-02-18','09:30:00',7.12),('6449','2013-02-18','09:35:00',8.05),('6449','2013-02-18','09:40:00',10.12),('6449','2013-02-18','09:45:00',9.22),('6449','2013-02-18','09:50:00',10.9),('6449','2013-02-18','09:55:00',4.52),('6449','2013-02-18','10:00:00',6.88),('6449','2013-02-18','10:05:00',12.54),('6449','2013-02-18','10:10:00',10.39),('6449','2013-02-18','10:15:00',13.2),('6449','2013-02-18','10:20:00',11.26),('6449','2013-02-18','10:25:00',12.72),('6449','2013-02-18','10:30:00',13.23),('6449','2013-02-18','10:35:00',13.76),('6449','2013-02-18','10:40:00',13.63),('6449','2013-02-18','10:45:00',14.1),('6449','2013-02-18','10:50:00',14.31),('6449','2013-02-18','10:55:00',10.72),('6449','2013-02-18','11:00:00',6.64),('6449','2013-02-18','11:05:00',8.11),('6449','2013-02-18','11:10:00',8.67),('6449','2013-02-18','11:15:00',9.66),('6449','2013-02-18','11:20:00',9.13),('6449','2013-02-18','11:25:00',12.16),('6449','2013-02-18','11:30:00',12.95),('6449','2013-02-18','11:35:00',5.61),('6449','2013-02-18','11:40:00',5.84),('6449','2013-02-18','11:45:00',5.49),('6449','2013-02-18','11:50:00',5.97),('6449','2013-02-18','11:55:00',5.73),('6449','2013-02-18','12:00:00',5.09),('6449','2013-02-18','12:05:00',6.12),('6449','2013-02-18','12:10:00',6.88),('6449','2013-02-18','12:15:00',6.48),('6449','2013-02-18','12:20:00',7.9),('6449','2013-02-18','12:25:00',9.21),('6449','2013-02-18','12:30:00',9.55),('6449','2013-02-18','12:35:00',7.43),('6449','2013-02-18','12:40:00',7.48),('6449','2013-02-18','12:45:00',8.04),('6449','2013-02-18','12:50:00',7.54),('6449','2013-02-18','12:55:00',7.14),('6449','2013-02-18','13:00:00',5.95),('6449','2013-02-18','13:05:00',5.85),('6449','2013-02-18','13:10:00',5.63),('6449','2013-02-18','13:15:00',5.27),('6449','2013-02-18','13:20:00',5.21),('6449','2013-02-18','13:25:00',6.12),('6449','2013-02-18','13:30:00',5.59),('6449','2013-02-18','13:35:00',5.84),('6449','2013-02-18','13:40:00',6.12),('6449','2013-02-18','13:45:00',5.12),('6449','2013-02-18','13:50:00',4.5),('6449','2013-02-18','13:55:00',4.27),('6449','2013-02-18','14:00:00',5.15),('6449','2013-02-18','14:05:00',5.66),('6449','2013-02-18','14:10:00',6.18),('6449','2013-02-18','14:15:00',4.91),('6449','2013-02-18','14:20:00',5.33),('6449','2013-02-18','14:25:00',5.57),('6449','2013-02-18','14:30:00',4.15),('6449','2013-02-18','14:35:00',3.98),('6449','2013-02-18','14:40:00',4.64),('6449','2013-02-18','14:45:00',5.05),('6449','2013-02-18','14:50:00',5.07),('6449','2013-02-18','14:55:00',7.88),('6449','2013-02-18','15:00:00',5.06),('6449','2013-02-18','15:05:00',3.4),('6449','2013-02-18','15:10:00',2.96),('6449','2013-02-18','15:15:00',2.24),('6449','2013-02-18','15:20:00',2.73),('6449','2013-02-18','15:25:00',2.42),('6449','2013-02-18','15:30:00',1.61),('6449','2013-02-18','15:35:00',1.44),('6449','2013-02-18','15:40:00',1.56),('6449','2013-02-18','15:45:00',1.67),('6449','2013-02-18','15:50:00',1.64),('6449','2013-02-18','15:55:00',1.29),('6449','2013-02-18','16:00:00',1.02),('6449','2013-02-18','16:05:00',1.31),('6449','2013-02-18','16:10:00',1.23),('6449','2013-02-18','16:15:00',1.27),('6449','2013-02-18','16:20:00',1.21),('6449','2013-02-18','16:25:00',1.11),('6449','2013-02-17','07:35:00',1.28),('6449','2013-02-17','07:40:00',1.58),('6449','2013-02-17','07:45:00',1.87),('6449','2013-02-17','07:50:00',2.21),('6449','2013-02-17','07:55:00',2.47),('6449','2013-02-17','08:00:00',2.86),('6449','2013-02-17','08:05:00',3.24),('6449','2013-02-17','08:10:00',3.62),('6449','2013-02-17','08:15:00',4.05),('6449','2013-02-17','08:20:00',4.25),('6449','2013-02-17','08:25:00',3.27),('6449','2013-02-17','08:30:00',4.31),('6449','2013-02-17','08:35:00',5.05),('6449','2013-02-17','08:40:00',6.03),('6449','2013-02-17','08:45:00',6.19),('6449','2013-02-17','08:50:00',6.51),('6449','2013-02-17','08:55:00',7.03),('6449','2013-02-17','09:00:00',6.97),('6449','2013-02-17','09:05:00',6.03),('6449','2013-02-17','09:10:00',7.77),('6449','2013-02-17','09:15:00',8.48),('6449','2013-02-17','09:20:00',8.87),('6449','2013-02-17','09:25:00',9.2),('6449','2013-02-17','09:30:00',9.54),('6449','2013-02-17','09:35:00',9.86),('6449','2013-02-17','09:40:00',10.04),('6449','2013-02-17','09:45:00',10.44),('6449','2013-02-17','09:50:00',10.71),('6449','2013-02-17','09:55:00',10.99),('6449','2013-02-17','10:00:00',11.25),('6449','2013-02-17','10:05:00',11.51),('6449','2013-02-17','10:10:00',11.7),('6449','2013-02-17','10:15:00',12.08),('6449','2013-02-17','10:20:00',12.29),('6449','2013-02-17','10:25:00',12.53),('6449','2013-02-17','10:30:00',12.69),('6449','2013-02-17','10:35:00',12.92),('6449','2013-02-17','10:40:00',13.14),('6449','2013-02-17','10:45:00',13.19),('6449','2013-02-17','10:50:00',13.4),('6449','2013-02-17','10:55:00',13.51),('6449','2013-02-17','11:00:00',13.66),('6449','2013-02-17','11:05:00',13.79),('6449','2013-02-17','11:10:00',13.77),('6449','2013-02-17','11:15:00',13.88),('6449','2013-02-17','11:20:00',13.97),('6449','2013-02-17','11:25:00',13.78),('6449','2013-02-17','11:30:00',14.14),('6449','2013-02-17','11:35:00',14.28),('6449','2013-02-17','11:40:00',14.35),('6449','2013-02-17','11:45:00',14.5),('6449','2013-02-17','11:50:00',14.49),('6449','2013-02-17','11:55:00',14.45),('6449','2013-02-17','12:00:00',15.13),('6449','2013-02-17','12:05:00',15.08),('6449','2013-02-17','12:10:00',14.52),('6449','2013-02-17','12:15:00',14.62),('6449','2013-02-17','12:20:00',14.77),('6449','2013-02-17','12:25:00',14.74),('6449','2013-02-17','12:30:00',14.85),('6449','2013-02-17','12:35:00',15.04),('6449','2013-02-17','12:40:00',13.93),('6449','2013-02-17','12:45:00',14.05),('6449','2013-02-17','12:50:00',13.12),('6449','2013-02-17','12:55:00',14.55),('6449','2013-02-17','13:00:00',14.13),('6449','2013-02-17','13:05:00',13.63),('6449','2013-02-17','13:10:00',13.16),('6449','2013-02-17','13:15:00',10.51),('6449','2013-02-17','13:20:00',12.01),('6449','2013-02-17','13:25:00',14.37),('6449','2013-02-17','13:30:00',15.3),('6449','2013-02-17','13:35:00',15.32),('6449','2013-02-17','13:40:00',11.86),('6449','2013-02-17','13:45:00',14.59),('6449','2013-02-17','13:50:00',11.88),('6449','2013-02-17','13:55:00',6.42),('6449','2013-02-17','14:00:00',5.66),('6449','2013-02-17','14:05:00',5.91),('6449','2013-02-17','14:10:00',6.27),('6449','2013-02-17','14:15:00',6.79),('6449','2013-02-17','14:20:00',12.38),('6449','2013-02-17','14:25:00',12.15),('6449','2013-02-17','14:30:00',9.12),('6449','2013-02-17','14:35:00',6.9),('6449','2013-02-17','14:40:00',11.15),('6449','2013-02-17','14:45:00',9.16),('6449','2013-02-17','14:50:00',9.15),('6449','2013-02-17','14:55:00',9.95),('6449','2013-02-17','15:00:00',8.27),('6449','2013-02-17','15:05:00',8.42),('6449','2013-02-17','15:10:00',8.04),('6449','2013-02-17','15:15:00',2.84),('6449','2013-02-17','15:20:00',3),('6449','2013-02-17','15:25:00',3.08),('6449','2013-02-17','15:30:00',3.13),('6449','2013-02-17','15:35:00',3.3),('6449','2013-02-17','15:40:00',2.99),('6449','2013-02-17','15:45:00',2.6),('6449','2013-02-17','15:50:00',2.03),('6449','2013-02-17','15:55:00',1.62),('6449','2013-02-17','16:00:00',1.53),('6449','2013-02-17','16:05:00',1.47),('6449','2013-02-17','16:10:00',1.45),('6449','2013-02-17','16:15:00',1.67),('6449','2013-02-17','16:20:00',1.7),('6449','2013-02-17','16:25:00',1.33),('6449','2013-02-17','16:30:00',1.19),('6449','2013-02-17','16:35:00',1.04),('6449','2013-02-16','07:30:00',1.07),('6449','2013-02-16','07:35:00',1.41),('6449','2013-02-16','07:40:00',1.44),('6449','2013-02-16','07:50:00',1.04),('6449','2013-02-16','07:55:00',1.22),('6449','2013-02-16','08:00:00',1.47),('6449','2013-02-16','08:05:00',1.81),('6449','2013-02-16','08:11:00',2.4),('6449','2013-02-16','08:15:00',4.17),('6449','2013-02-16','08:20:00',5.08),('6449','2013-02-16','08:25:00',3.97),('6449','2013-02-16','08:30:00',3.39),('6449','2013-02-16','08:35:00',3.19),('6449','2013-02-16','08:40:00',2.89),('6449','2013-02-16','08:45:00',2.35),('6449','2013-02-16','08:50:00',3),('6449','2013-02-16','08:55:00',4.98),('6449','2013-02-16','09:00:00',5.22),('6449','2013-02-16','09:05:00',7.67),('6449','2013-02-16','09:10:00',5.88),('6449','2013-02-16','09:15:00',7.08),('6449','2013-02-16','09:20:00',5.73),('6449','2013-02-16','09:25:00',9.19),('6449','2013-02-16','09:30:00',9.62),('6449','2013-02-16','09:35:00',9.8),('6449','2013-02-16','09:40:00',10.15),('6449','2013-02-16','09:45:00',10.39),('6449','2013-02-16','09:50:00',10.7),('6449','2013-02-16','09:55:00',10.98),('6449','2013-02-16','10:00:00',11.31),('6449','2013-02-16','10:05:00',11.86),('6449','2013-02-16','10:10:00',9.22),('6449','2013-02-16','10:15:00',10.67),('6449','2013-02-16','10:20:00',3.9),('6449','2013-02-16','10:25:00',9.41),('6449','2013-02-16','10:30:00',8.92),('6449','2013-02-16','10:35:00',11.67),('6449','2013-02-16','10:40:00',10.35),('6449','2013-02-16','10:45:00',11.52),('6449','2013-02-16','10:50:00',13.13),('6449','2013-02-16','10:55:00',13.73),('6449','2013-02-16','11:00:00',13.78),('6449','2013-02-16','11:05:00',13.7),('6449','2013-02-16','11:10:00',14.4),('6449','2013-02-16','11:15:00',14.78),('6449','2013-02-16','11:20:00',14.82),('6449','2013-02-16','11:25:00',11.99),('6449','2013-02-16','11:30:00',14.57),('6449','2013-02-16','11:35:00',14.07),('6449','2013-02-16','11:40:00',13.98),('6449','2013-02-16','11:45:00',14.72),('6449','2013-02-16','11:50:00',14.8),('6449','2013-02-16','11:55:00',14.75),('6449','2013-02-16','12:00:00',14.61),('6449','2013-02-16','12:05:00',14.73),('6449','2013-02-16','12:10:00',14.61),('6449','2013-02-16','12:15:00',14.94),('6449','2013-02-16','12:20:00',14.79),('6449','2013-02-16','12:25:00',15.84),('6449','2013-02-16','12:30:00',14.17),('6449','2013-02-16','12:35:00',16.06),('6449','2013-02-16','12:40:00',8.19),('6449','2013-02-16','12:45:00',6.43),('6449','2013-02-16','12:50:00',5.06),('6449','2013-02-16','12:55:00',5.73),('6449','2013-02-16','13:00:00',4.89),('6449','2013-02-16','13:05:00',5.17),('6449','2013-02-16','13:10:00',5.44),('6449','2013-02-16','13:15:00',5.27),('6449','2013-02-16','13:20:00',6.99),('6449','2013-02-16','13:25:00',9.44),('6449','2013-02-16','13:30:00',14.64),('6449','2013-02-16','13:35:00',16.01),('6449','2013-02-16','13:40:00',14.7),('6449','2013-02-16','13:45:00',15.65),('6449','2013-02-16','13:50:00',14.31),('6449','2013-02-16','13:55:00',13.08),('6449','2013-02-16','14:00:00',10.45),('6449','2013-02-16','14:05:00',5.57),('6449','2013-02-16','14:10:00',4.47),('6449','2013-02-16','14:15:00',3.95),('6449','2013-02-16','14:20:00',3.75),('6449','2013-02-16','14:25:00',3.65),('6449','2013-02-16','14:30:00',3.45),('6449','2013-02-16','14:35:00',3.41),('6449','2013-02-16','14:40:00',3.46),('6449','2013-02-16','14:45:00',3.49),('6449','2013-02-16','14:50:00',3.42),('6449','2013-02-16','14:55:00',3.27),('6449','2013-02-16','15:00:00',3.2),('6449','2013-02-16','15:05:00',3.06),('6449','2013-02-16','15:10:00',2.96),('6449','2013-02-16','15:15:00',3.06),('6449','2013-02-16','15:20:00',3.06),('6449','2013-02-16','15:25:00',3.31),('6449','2013-02-16','15:30:00',3.46),('6449','2013-02-16','15:35:00',3.73),('6449','2013-02-16','15:40:00',3.21),('6449','2013-02-16','15:45:00',3.91),('6449','2013-02-16','15:50:00',4.23),('6449','2013-02-16','15:55:00',3.31),('6449','2013-02-16','16:00:00',2.99),('6449','2013-02-16','16:05:00',2.59),('6449','2013-02-16','16:10:00',1.89),('6449','2013-02-16','16:15:00',1.51),('6449','2013-02-16','16:20:00',1.39),('6449','2013-02-16','16:25:00',1.24),('6449','2013-02-16','16:30:00',1.13),('6449','2013-02-16','16:35:00',1.03),('6449','2013-02-15','07:30:00',1.15),('6449','2013-02-15','07:35:00',1.55),('6449','2013-02-15','07:40:00',1.59),('6449','2013-02-15','07:50:00',1.02),('6449','2013-02-15','08:00:00',1.13),('6449','2013-02-15','08:05:00',1.01),('6449','2013-02-15','08:10:00',1.33),('6449','2013-02-15','08:15:00',1.16),('6449','2013-02-15','08:20:00',1.16),('6449','2013-02-15','08:25:00',1.4),('6449','2013-02-15','08:30:00',1.47),('6449','2013-02-15','08:35:00',1.65),('6449','2013-02-15','08:40:00',1.84),('6449','2013-02-15','08:45:00',1.88),('6449','2013-02-15','08:50:00',2.65),('6449','2013-02-15','08:55:00',3.68),('6449','2013-02-15','09:00:00',8.84),('6449','2013-02-15','09:05:00',9.97),('6449','2013-02-15','09:10:00',8.91),('6449','2013-02-15','09:15:00',6.65),('6449','2013-02-15','09:20:00',8.55),('6449','2013-02-15','09:25:00',10.83),('6449','2013-02-15','09:30:00',11.73),('6449','2013-02-15','09:35:00',7.24),('6449','2013-02-15','09:40:00',6.9),('6449','2013-02-15','09:45:00',6.85),('6449','2013-02-15','09:50:00',6.96),('6449','2013-02-15','09:55:00',7.97),('6449','2013-02-15','10:00:00',8.89),('6449','2013-02-15','10:05:00',10.51),('6449','2013-02-15','10:10:00',10.35),('6449','2013-02-15','10:15:00',8.75),('6449','2013-02-15','10:20:00',8.81),('6449','2013-02-15','10:25:00',6.78),('6449','2013-02-15','10:30:00',6.29),('6449','2013-02-15','10:35:00',10.3),('6449','2013-02-15','10:41:00',13.56),('6449','2013-02-15','10:45:00',14.01),('6449','2013-02-15','10:52:00',14.04),('6449','2013-02-15','10:55:00',14.19),('6449','2013-02-15','11:00:00',14.22),('6449','2013-02-15','11:05:00',13.22),('6449','2013-02-15','11:10:00',10.52),('6449','2013-02-15','11:15:00',10.74),('6449','2013-02-15','11:20:00',11.41),('6449','2013-02-15','11:25:00',12.55),('6449','2013-02-15','11:30:00',13.14),('6449','2013-02-15','11:35:00',13.15),('6449','2013-02-15','11:40:00',8.86),('6449','2013-02-15','11:45:00',11.85),('6449','2013-02-15','11:50:00',15.51),('6449','2013-02-15','11:55:00',15.59),('6449','2013-02-15','12:00:00',14.51),('6449','2013-02-15','12:05:00',14.91),('6449','2013-02-15','12:10:00',12.22),('6449','2013-02-15','12:15:00',11.31),('6449','2013-02-15','12:20:00',14.99),('6449','2013-02-15','12:25:00',13.64),('6449','2013-02-15','12:31:00',14.21),('6449','2013-02-15','12:35:00',14.75),('6449','2013-02-15','12:40:00',14.83),('6449','2013-02-15','12:45:00',11.15),('6449','2013-02-15','12:50:00',11.33),('6449','2013-02-15','12:55:00',12.04),('6449','2013-02-15','13:00:00',15.12),('6449','2013-02-15','13:05:00',14.88),('6449','2013-02-15','13:10:00',10.69),('6449','2013-02-15','13:15:00',9.09),('6449','2013-02-15','13:20:00',8.43),('6449','2013-02-15','13:25:00',8.77),('6449','2013-02-15','13:30:00',14.62),('6449','2013-02-15','13:35:00',14.57),('6449','2013-02-15','13:40:00',10.82),('6449','2013-02-15','13:45:00',11.31),('6449','2013-02-15','13:50:00',13.73),('6449','2013-02-15','13:55:00',13.86),('6449','2013-02-15','14:00:00',11.52),('6449','2013-02-15','14:05:00',11.69),('6449','2013-02-15','14:10:00',12.17),('6449','2013-02-15','14:15:00',12.59),('6449','2013-02-15','14:20:00',13.59),('6449','2013-02-15','14:25:00',9.31),('6449','2013-02-15','14:34:00',10.65),('6449','2013-02-15','14:35:00',10.55),('6449','2013-02-15','14:40:00',8.1),('6449','2013-02-15','14:45:00',6.74),('6449','2013-02-15','14:50:00',8.1),('6449','2013-02-15','14:55:00',9.76),('6449','2013-02-15','15:00:00',8.11),('6449','2013-02-15','15:05:00',5.62),('6449','2013-02-15','15:10:00',4.4),('6449','2013-02-15','15:15:00',4.09);
INSERT INTO `solarlogmod` VALUES ('6449','2013-02-15','15:20:00',4.57),('6449','2013-02-15','15:25:00',4.28),('6449','2013-02-15','15:30:00',3.83),('6449','2013-02-15','15:35:00',3.51),('6449','2013-02-15','15:40:00',3.29),('6449','2013-02-15','15:45:00',3.3),('6449','2013-02-15','15:50:00',3.53),('6449','2013-02-15','15:55:00',3.9),('6449','2013-02-15','16:00:00',3.99),('6449','2013-02-15','16:05:00',3.47),('6449','2013-02-15','16:10:00',2.99),('6449','2013-02-15','16:15:00',3.67),('6449','2013-02-15','16:20:00',4.75),('6449','2013-02-15','16:25:00',3.4),('6449','2013-02-15','16:30:00',3.19),('6449','2013-02-15','16:35:00',2.24),('6449','2013-02-15','16:40:00',1.55),('6449','2013-02-15','16:45:00',1.2),('6449','2013-02-14','07:30:00',1.06),('6449','2013-02-14','07:35:00',1.42),('6449','2013-02-14','07:40:00',1.78),('6449','2013-02-14','07:45:00',2.05),('6449','2013-02-14','07:50:00',2.49),('6449','2013-02-14','07:55:00',2.86),('6449','2013-02-14','08:00:00',3.23),('6449','2013-02-14','08:05:00',3.59),('6449','2013-02-14','08:10:00',3.85),('6449','2013-02-14','08:15:00',4.11),('6449','2013-02-14','08:20:00',4.41),('6449','2013-02-14','08:25:00',5),('6449','2013-02-14','08:30:00',5.4),('6449','2013-02-14','08:35:00',5.48),('6449','2013-02-14','08:40:00',5.78),('6449','2013-02-14','08:45:00',6.09),('6449','2013-02-14','08:50:00',5.85),('6449','2013-02-14','08:55:00',5.62),('6449','2013-02-14','09:00:00',6.68),('6449','2013-02-14','09:05:00',7.54),('6449','2013-02-14','09:10:00',8.36),('6449','2013-02-14','09:15:00',8.68),('6449','2013-02-14','09:20:00',9.15),('6449','2013-02-14','09:25:00',9.42),('6449','2013-02-14','09:30:00',9.47),('6449','2013-02-14','09:35:00',9.76),('6449','2013-02-14','09:40:00',10.33),('6449','2013-02-14','09:45:00',10.8),('6449','2013-02-14','09:50:00',11.14),('6449','2013-02-14','09:55:00',11.42),('6449','2013-02-14','10:00:00',11.67),('6449','2013-02-14','10:05:00',11.77),('6449','2013-02-14','10:10:00',12.09),('6449','2013-02-14','10:15:00',12.35),('6449','2013-02-14','10:20:00',12.59),('6449','2013-02-14','10:25:00',12.8),('6449','2013-02-14','10:30:00',13.01),('6449','2013-02-14','10:35:00',13.02),('6449','2013-02-14','10:40:00',13.44),('6449','2013-02-14','10:45:00',13.54),('6449','2013-02-14','10:50:00',13.75),('6449','2013-02-14','10:55:00',13.94),('6449','2013-02-14','11:00:00',14.1),('6449','2013-02-14','11:05:00',14.08),('6449','2013-02-14','11:10:00',14.38),('6449','2013-02-14','11:15:00',14.52),('6449','2013-02-14','11:20:00',14.58),('6449','2013-02-14','11:25:00',14.72),('6449','2013-02-14','11:30:00',14.81),('6449','2013-02-14','11:35:00',14.81),('6449','2013-02-14','11:40:00',14.86),('6449','2013-02-14','11:45:00',15.01),('6449','2013-02-14','11:50:00',14.98),('6449','2013-02-14','11:55:00',15.04),('6449','2013-02-14','12:00:00',15.1),('6449','2013-02-14','12:05:00',15.06),('6449','2013-02-14','12:10:00',15.09),('6449','2013-02-14','12:15:00',15.08),('6449','2013-02-14','12:20:00',14.84),('6449','2013-02-14','12:25:00',15.03),('6449','2013-02-14','12:30:00',14.97),('6449','2013-02-14','12:35:00',14.91),('6449','2013-02-14','12:40:00',14.91),('6449','2013-02-14','12:45:00',14.92),('6449','2013-02-14','12:50:00',14.61),('6449','2013-02-14','12:55:00',14.77),('6449','2013-02-14','13:00:00',14.72),('6449','2013-02-14','13:05:00',14.54),('6449','2013-02-14','13:10:00',14.47),('6449','2013-02-14','13:15:00',14.37),('6449','2013-02-14','13:20:00',14.23),('6449','2013-02-14','13:25:00',14.15),('6449','2013-02-14','13:30:00',14.01),('6449','2013-02-14','13:35:00',13.74),('6449','2013-02-14','13:40:00',13.67),('6449','2013-02-14','13:45:00',13.51),('6449','2013-02-14','13:50:00',13.36),('6449','2013-02-14','13:55:00',13.07),('6449','2013-02-14','14:00:00',12.82),('6449','2013-02-14','14:05:00',12.72),('6449','2013-02-14','14:10:00',12.51),('6449','2013-02-14','14:15:00',12.22),('6449','2013-02-14','14:20:00',11.99),('6449','2013-02-14','14:25:00',11.76),('6449','2013-02-14','14:30:00',11.5),('6449','2013-02-14','14:35:00',11.13),('6449','2013-02-14','14:40:00',10.99),('6449','2013-02-14','14:45:00',10.69),('6449','2013-02-14','14:50:00',10.39),('6449','2013-02-14','14:55:00',10.11),('6449','2013-02-14','15:00:00',9.8),('6449','2013-02-14','15:05:00',9.43),('6449','2013-02-14','15:10:00',9.15),('6449','2013-02-14','15:15:00',8.89),('6449','2013-02-14','15:20:00',8.46),('6449','2013-02-14','15:25:00',8.16),('6449','2013-02-14','15:30:00',7.71),('6449','2013-02-14','15:35:00',7.35),('6449','2013-02-14','15:40:00',6.95),('6449','2013-02-14','15:45:00',6.56),('6449','2013-02-14','15:50:00',6.1),('6449','2013-02-14','15:55:00',5.59),('6449','2013-02-14','16:00:00',5.38),('6449','2013-02-14','16:05:00',5.1),('6449','2013-02-14','16:10:00',4.72),('6449','2013-02-14','16:15:00',4.29),('6449','2013-02-14','16:20:00',3.81),('6449','2013-02-14','16:25:00',3.46),('6449','2013-02-14','16:30:00',3.17),('6449','2013-02-14','16:35:00',2.84),('6449','2013-02-14','16:40:00',2.51),('6449','2013-02-14','16:45:00',2.19),('6449','2013-02-14','16:50:00',1.83),('6449','2013-02-14','16:55:00',1.52),('6449','2013-02-14','17:00:00',1.19),('6449','2013-02-13','08:00:00',1.2),('6449','2013-02-13','08:05:00',1.42),('6449','2013-02-13','08:10:00',1.64),('6449','2013-02-13','08:15:00',1.87),('6449','2013-02-13','08:20:00',2.11),('6449','2013-02-13','08:25:00',2.43),('6449','2013-02-13','08:30:00',2.63),('6449','2013-02-13','08:35:00',3.08),('6449','2013-02-13','08:40:00',3.78),('6449','2013-02-13','08:45:00',4.13),('6449','2013-02-13','08:50:00',3.4),('6449','2013-02-13','08:55:00',3.6),('6449','2013-02-13','09:00:00',4.41),('6449','2013-02-13','09:05:00',4.46),('6449','2013-02-13','09:10:00',5.15),('6449','2013-02-13','09:15:00',4.91),('6449','2013-02-13','09:20:00',5.4),('6449','2013-02-13','09:25:00',6.39),('6449','2013-02-13','09:30:00',7.55),('6449','2013-02-13','09:35:00',8.87),('6449','2013-02-13','09:40:00',9.48),('6449','2013-02-13','09:45:00',9.87),('6449','2013-02-13','09:50:00',9.56),('6449','2013-02-13','09:55:00',10.83),('6449','2013-02-13','10:00:00',11.46),('6449','2013-02-13','10:05:00',11.93),('6449','2013-02-13','10:10:00',12.15),('6449','2013-02-13','10:15:00',12.55),('6449','2013-02-13','10:20:00',12.89),('6449','2013-02-13','10:25:00',13.25),('6449','2013-02-13','10:30:00',13.27),('6449','2013-02-13','10:35:00',13.15),('6449','2013-02-13','10:40:00',13.08),('6449','2013-02-13','10:45:00',13.28),('6449','2013-02-13','10:50:00',13.47),('6449','2013-02-13','10:55:00',14.04),('6449','2013-02-13','11:00:00',14.08),('6449','2013-02-13','11:05:00',13.71),('6449','2013-02-13','11:10:00',13.96),('6449','2013-02-13','11:15:00',13.54),('6449','2013-02-13','11:20:00',12.66),('6449','2013-02-13','11:25:00',12.8),('6449','2013-02-13','11:30:00',14.55),('6449','2013-02-13','11:35:00',14.23),('6449','2013-02-13','11:40:00',14.73),('6449','2013-02-13','11:45:00',15.49),('6449','2013-02-13','11:50:00',9.45),('6449','2013-02-13','11:55:00',8.87),('6449','2013-02-13','12:00:00',12.09),('6449','2013-02-13','12:05:00',12.13),('6449','2013-02-13','12:10:00',13.67),('6449','2013-02-13','12:15:00',13.08),('6449','2013-02-13','12:20:00',13.64),('6449','2013-02-13','12:25:00',14.4),('6449','2013-02-13','12:31:00',12.9),('6449','2013-02-13','12:35:00',12.5),('6449','2013-02-13','12:40:00',12.24),('6449','2013-02-13','12:45:00',15.09),('6449','2013-02-13','12:50:00',15.47),('6449','2013-02-13','12:55:00',14.68),('6449','2013-02-13','13:00:00',10.12),('6449','2013-02-13','13:05:00',11.13),('6449','2013-02-13','13:10:00',13.31),('6449','2013-02-13','13:15:00',12.54),('6449','2013-02-13','13:20:00',10.75),('6449','2013-02-13','13:25:00',8.84),('6449','2013-02-13','13:30:00',9.8),('6449','2013-02-13','13:35:00',12.99),('6449','2013-02-13','13:40:00',13.61),('6449','2013-02-13','13:45:00',13.73),('6449','2013-02-13','13:50:00',13.13),('6449','2013-02-13','13:55:00',12.4),('6449','2013-02-13','14:00:00',12.45),('6449','2013-02-13','14:05:00',12.46),('6449','2013-02-13','14:10:00',11.36),('6449','2013-02-13','14:15:00',10.53),('6449','2013-02-13','14:20:00',10.98),('6449','2013-02-13','14:25:00',9.78),('6449','2013-02-13','14:30:00',9.99),('6449','2013-02-13','14:35:00',9.4),('6449','2013-02-13','14:40:00',10.69),('6449','2013-02-13','14:45:00',10.97),('6449','2013-02-13','14:50:00',10.88),('6449','2013-02-13','14:55:00',10.26),('6449','2013-02-13','15:00:00',9.59),('6449','2013-02-13','15:05:00',8.23),('6449','2013-02-13','15:10:00',9.37),('6449','2013-02-13','15:15:00',8.86),('6449','2013-02-13','15:20:00',8.36),('6449','2013-02-13','15:25:00',7.84),('6449','2013-02-13','15:30:00',6.75),('6449','2013-02-13','15:35:00',6.82),('6449','2013-02-13','15:40:00',6.86),('6449','2013-02-13','15:45:00',6.71),('6449','2013-02-13','15:50:00',6.35),('6449','2013-02-13','15:55:00',5.85),('6449','2013-02-13','16:00:00',5.48),('6449','2013-02-13','16:05:00',5.31),('6449','2013-02-13','16:10:00',4.92),('6449','2013-02-13','16:15:00',4.52),('6449','2013-02-13','16:20:00',4.09),('6449','2013-02-13','16:25:00',3.74),('6449','2013-02-13','16:30:00',3.28),('6449','2013-02-13','16:35:00',2.94),('6449','2013-02-13','16:40:00',2.56),('6449','2013-02-13','16:45:00',2.23),('6449','2013-02-13','16:50:00',1.88),('6449','2013-02-13','16:55:00',1.56),('6449','2013-02-13','17:00:00',1.27),('6449','2013-02-13','17:05:00',1.01),('6449','2013-02-12','10:25:00',1.16),('6449','2013-02-12','10:30:00',1.33),('6449','2013-02-12','10:35:00',1.5),('6449','2013-02-12','10:40:00',1.72),('6449','2013-02-12','10:45:00',1.69),('6449','2013-02-12','10:50:00',1.62),('6449','2013-02-12','10:55:00',1.65),('6449','2013-02-12','11:00:00',1.56),('6449','2013-02-12','11:05:00',1.56),('6449','2013-02-12','11:10:00',1.62),('6449','2013-02-12','11:15:00',1.71),('6449','2013-02-12','11:20:00',1.87),('6449','2013-02-12','11:25:00',1.96),('6449','2013-02-12','11:30:00',2.07),('6449','2013-02-12','11:35:00',2.11),('6449','2013-02-12','11:40:00',1.97),('6449','2013-02-12','11:45:00',1.77),('6449','2013-02-12','11:50:00',1.78),('6449','2013-02-12','11:55:00',1.75),('6449','2013-02-12','12:00:00',1.72),('6449','2013-02-12','12:05:00',1.67),('6449','2013-02-12','12:10:00',1.68),('6449','2013-02-12','12:15:00',1.57),('6449','2013-02-12','12:20:00',1.73),('6449','2013-02-12','12:25:00',1.79),('6449','2013-02-12','12:30:00',1.85),('6449','2013-02-12','12:35:00',1.98),('6449','2013-02-12','12:40:00',1.91),('6449','2013-02-12','12:45:00',1.79),('6449','2013-02-12','12:50:00',1.71),('6449','2013-02-12','12:55:00',1.61),('6449','2013-02-12','13:00:00',1.51),('6449','2013-02-12','13:05:00',1.43),('6449','2013-02-12','13:10:00',1.41),('6449','2013-02-12','13:15:00',1.5),('6449','2013-02-12','13:20:00',1.44),('6449','2013-02-12','13:25:00',1.4),('6449','2013-02-12','13:30:00',1.38),('6449','2013-02-12','13:35:00',1.62),('6449','2013-02-12','13:40:00',1.83),('6449','2013-02-12','13:45:00',2.02),('6449','2013-02-12','13:50:00',2.2),('6449','2013-02-12','13:55:00',2.24),('6449','2013-02-12','14:00:00',2.19),('6449','2013-02-12','14:05:00',2.09),('6449','2013-02-12','14:10:00',2.02),('6449','2013-02-12','14:15:00',1.85),('6449','2013-02-12','14:20:00',1.92),('6449','2013-02-12','14:25:00',1.8),('6449','2013-02-12','14:30:00',1.77),('6449','2013-02-12','14:35:00',1.61),('6449','2013-02-12','14:40:00',1.42),('6449','2013-02-12','14:45:00',1.2),('6449','2013-02-12','14:50:00',1.35),('6449','2013-02-12','14:55:00',1.39),('6449','2013-02-12','15:00:00',1.51),('6449','2013-02-12','15:05:00',1.54),('6449','2013-02-12','15:10:00',1.84),('6449','2013-02-12','15:15:00',1.72),('6449','2013-02-12','15:20:00',1.53),('6449','2013-02-12','15:25:00',1.49),('6449','2013-02-12','15:30:00',1.49),('6449','2013-02-12','15:35:00',1.4),('6449','2013-02-12','15:40:00',1.1),('6449','2013-02-12','15:45:00',1.2),('6449','2013-02-12','15:50:00',1.1),('6449','2013-02-11','08:10:00',1.26),('6449','2013-02-11','08:15:00',1.03),('6449','2013-02-11','08:20:00',1.37),('6449','2013-02-11','08:25:00',1.32),('6449','2013-02-11','08:35:00',1.16),('6449','2013-02-11','08:40:00',1.19),('6449','2013-02-11','08:45:00',1.38),('6449','2013-02-11','08:50:00',1.49),('6449','2013-02-11','08:55:00',1.58),('6449','2013-02-11','09:00:00',1.89),('6449','2013-02-11','09:05:00',1.97),('6449','2013-02-11','09:10:00',1.84),('6449','2013-02-11','09:15:00',2.05),('6449','2013-02-11','09:20:00',2.21),('6449','2013-02-11','09:25:00',2.07),('6449','2013-02-11','09:30:00',2.77),('6449','2013-02-11','09:35:00',3.51),('6449','2013-02-11','09:40:00',3.44),('6449','2013-02-11','09:45:00',4.26),('6449','2013-02-11','09:50:00',3.09),('6449','2013-02-11','09:55:00',3.51),('6449','2013-02-11','10:00:00',4.16),('6449','2013-02-11','10:05:00',3.63),('6449','2013-02-11','10:10:00',2.96),('6449','2013-02-11','10:15:00',3.22),('6449','2013-02-11','10:20:00',2.47),('6449','2013-02-11','10:25:00',1.36),('6449','2013-02-11','10:30:00',1.26),('6449','2013-02-11','10:35:00',1.05),('6449','2013-02-11','10:40:00',1.13),('6449','2013-02-11','10:45:00',1.27),('6449','2013-02-11','10:50:00',1.15),('6449','2013-02-11','11:15:00',1.05),('6449','2013-02-11','11:20:00',1.27),('6449','2013-02-11','11:50:00',2.38),('6449','2013-02-11','11:55:00',1.45),('6449','2013-02-11','12:00:00',1.24),('6449','2013-02-11','12:05:00',1.25),('6449','2013-02-11','12:10:00',1.32),('6449','2013-02-11','12:15:00',1.16),('6449','2013-02-11','12:30:00',1.04),('6449','2013-02-11','12:35:00',1.25),('6449','2013-02-11','12:40:00',1.54),('6449','2013-02-11','12:45:00',2.01),('6449','2013-02-11','13:00:00',1.04),('6449','2013-02-11','13:05:00',1.05),('6449','2013-02-11','13:20:00',1.01),('6449','2013-02-11','13:25:00',1.42),('6449','2013-02-11','13:30:00',1.14),('6449','2013-02-11','13:40:00',1.92),('6449','2013-02-11','13:45:00',1.81),('6449','2013-02-11','13:55:00',1.62),('6449','2013-02-11','14:00:00',2.3),('6449','2013-02-11','14:05:00',2.4),('6449','2013-02-11','14:10:00',2.36),('6449','2013-02-11','14:15:00',1.81),('6449','2013-02-11','14:20:00',1.72),('6449','2013-02-11','14:25:00',2.05),('6449','2013-02-11','14:30:00',1.64),('6449','2013-02-11','14:35:00',1.5),('6449','2013-02-11','14:40:00',1.07),('6449','2013-02-11','14:55:00',1.16),('6449','2013-02-11','15:40:00',1.27),('6449','2013-02-11','15:50:00',1.62),('6449','2013-02-11','15:55:00',1.95),('6449','2013-02-11','16:15:00',1.11),('6449','2013-02-10','08:10:00',1.01),('6449','2013-02-10','08:15:00',1.31),('6449','2013-02-10','08:20:00',1.42),('6449','2013-02-10','08:25:00',1.43),('6449','2013-02-10','08:30:00',1.35),('6449','2013-02-10','08:35:00',1.22),('6449','2013-02-10','08:40:00',1.59),('6449','2013-02-10','08:45:00',2.01),('6449','2013-02-10','08:50:00',2.97),('6449','2013-02-10','08:55:00',3.98),('6449','2013-02-10','09:00:00',6.63),('6449','2013-02-10','09:05:00',8.1),('6449','2013-02-10','09:10:00',7.33),('6449','2013-02-10','09:15:00',8.42),('6449','2013-02-10','09:20:00',7.7),('6449','2013-02-10','09:25:00',8.26),('6449','2013-02-10','09:30:00',9.56),('6449','2013-02-10','09:35:00',9.8),('6449','2013-02-10','09:40:00',10.1),('6449','2013-02-10','09:45:00',10.39),('6449','2013-02-10','09:50:00',10.77),('6449','2013-02-10','09:55:00',11.14),('6449','2013-02-10','10:00:00',11.81),('6449','2013-02-10','10:05:00',12.56),('6449','2013-02-10','10:10:00',10.89),('6449','2013-02-10','10:15:00',12.49),('6449','2013-02-10','10:20:00',12.46),('6449','2013-02-10','10:25:00',12.35),('6449','2013-02-10','10:30:00',12.8),('6449','2013-02-10','10:35:00',12.9),('6449','2013-02-10','10:40:00',13.17),('6449','2013-02-10','10:45:00',13.38),('6449','2013-02-10','10:50:00',13.48),('6449','2013-02-10','10:55:00',13.75),('6449','2013-02-10','11:00:00',13.42),('6449','2013-02-10','11:05:00',12.08),('6449','2013-02-10','11:10:00',13.45),('6449','2013-02-10','11:15:00',14.2),('6449','2013-02-10','11:20:00',14.37),('6449','2013-02-10','11:25:00',14.48),('6449','2013-02-10','11:30:00',14.54),('6449','2013-02-10','11:35:00',14.6),('6449','2013-02-10','11:40:00',14.29),('6449','2013-02-10','11:45:00',14.76),('6449','2013-02-10','11:50:00',14.85),('6449','2013-02-10','11:55:00',14.84),('6449','2013-02-10','12:00:00',14.8),('6449','2013-02-10','12:05:00',14.86),('6449','2013-02-10','12:10:00',14.57),('6449','2013-02-10','12:15:00',14.74),('6449','2013-02-10','12:20:00',14.67),('6449','2013-02-10','12:25:00',14.58),('6449','2013-02-10','12:30:00',14.57),('6449','2013-02-10','12:35:00',14.59),('6449','2013-02-10','12:40:00',14.5),('6449','2013-02-10','12:45:00',14.46),('6449','2013-02-10','12:50:00',14.33),('6449','2013-02-10','12:55:00',14.17),('6449','2013-02-10','13:00:00',14.14),('6449','2013-02-10','13:05:00',13.96),('6449','2013-02-10','13:10:00',13.73),('6449','2013-02-10','13:15:00',13.66),('6449','2013-02-10','13:20:00',13.4),('6449','2013-02-10','13:25:00',13.18),('6449','2013-02-10','13:30:00',13.3),('6449','2013-02-10','13:35:00',13.19),('6449','2013-02-10','13:40:00',13.28),('6449','2013-02-10','13:45:00',13.75),('6449','2013-02-10','13:50:00',14.21),('6449','2013-02-10','13:55:00',13.59),('6449','2013-02-10','14:00:00',13.79),('6449','2013-02-10','14:05:00',13.71),('6449','2013-02-10','14:11:00',13.5),('6449','2013-02-10','14:15:00',13.22),('6449','2013-02-10','14:20:00',13.29),('6449','2013-02-10','14:25:00',12.89),('6449','2013-02-10','14:30:00',12.32),('6449','2013-02-10','14:35:00',11.7),('6449','2013-02-10','14:40:00',11.16),('6449','2013-02-10','14:45:00',10.75),('6449','2013-02-10','14:50:00',10.53),('6449','2013-02-10','14:55:00',10.53),('6449','2013-02-10','15:00:00',10.8),('6449','2013-02-10','15:05:00',11.06),('6449','2013-02-10','15:10:00',11.1),('6449','2013-02-10','15:15:00',11.54),('6449','2013-02-10','15:20:00',11.39),('6449','2013-02-10','15:25:00',11.09),('6449','2013-02-10','15:30:00',10.02),('6449','2013-02-10','15:35:00',9.74),('6449','2013-02-10','15:40:00',9.63),('6449','2013-02-10','15:45:00',8.91),('6449','2013-02-10','15:50:00',7.57),('6449','2013-02-10','15:55:00',3.2),('6449','2013-02-10','16:00:00',4.01),('6449','2013-02-10','16:05:00',6.13),('6449','2013-02-10','16:10:00',6.45),('6449','2013-02-10','16:15:00',5.5),('6449','2013-02-10','16:20:00',4.33),('6449','2013-02-10','16:25:00',3.87),('6449','2013-02-10','16:30:00',3.79),('6449','2013-02-10','16:35:00',3.41),('6449','2013-02-10','16:40:00',3.03),('6449','2013-02-10','16:45:00',2.59),('6449','2013-02-10','16:50:00',2.16),('6449','2013-02-10','16:55:00',1.54),('6449','2013-02-10','17:00:00',1.08),('6449','2013-02-09','08:45:00',1.01),('6449','2013-02-09','08:50:00',1.16),('6449','2013-02-09','08:55:00',1.31),('6449','2013-02-09','09:00:00',1.49),('6449','2013-02-09','09:05:00',1.7),('6449','2013-02-09','09:10:00',1.92),('6449','2013-02-09','09:15:00',2.07),('6449','2013-02-09','09:20:00',2.14),('6449','2013-02-09','09:25:00',2.21),('6449','2013-02-09','09:30:00',2.31),('6449','2013-02-09','09:35:00',2.4),('6449','2013-02-09','09:40:00',2.7),('6449','2013-02-09','09:45:00',3.02),('6449','2013-02-09','09:50:00',3.36),('6449','2013-02-09','09:55:00',3.57),('6449','2013-02-09','10:00:00',3.6),('6449','2013-02-09','10:05:00',3.58),('6449','2013-02-09','10:10:00',3.58),('6449','2013-02-09','10:15:00',3.63),('6449','2013-02-09','10:20:00',3.58),('6449','2013-02-09','10:25:00',3.64),('6449','2013-02-09','10:30:00',3.86),('6449','2013-02-09','10:35:00',3.93),('6449','2013-02-09','10:40:00',3.87),('6449','2013-02-09','10:45:00',3.79),('6449','2013-02-09','10:50:00',3.83),('6449','2013-02-09','10:55:00',4.08),('6449','2013-02-09','11:00:00',4.3),('6449','2013-02-09','11:05:00',4.5),('6449','2013-02-09','11:10:00',4.58),('6449','2013-02-09','11:15:00',4.6),('6449','2013-02-09','11:20:00',4.47),('6449','2013-02-09','11:25:00',4.59),('6449','2013-02-09','11:30:00',4.5),('6449','2013-02-09','11:35:00',4.61),('6449','2013-02-09','11:40:00',4.76),('6449','2013-02-09','11:45:00',4.85),('6449','2013-02-09','11:50:00',5.09),('6449','2013-02-09','11:55:00',5.3),('6449','2013-02-09','12:00:00',5.98),('6449','2013-02-09','12:05:00',6.36),('6449','2013-02-09','12:10:00',5.89),('6449','2013-02-09','12:15:00',5.63),('6449','2013-02-09','12:20:00',5.67),('6449','2013-02-09','12:25:00',5.97),('6449','2013-02-09','12:30:00',6.46),('6449','2013-02-09','12:35:00',7.25),('6449','2013-02-09','12:40:00',8.37),('6449','2013-02-09','12:45:00',9.52),('6449','2013-02-09','12:50:00',10.99),('6449','2013-02-09','12:55:00',11.57),('6449','2013-02-09','13:00:00',14.51),('6449','2013-02-09','13:05:00',14.1),('6449','2013-02-09','13:10:00',12.06),('6449','2013-02-09','13:15:00',8.85),('6449','2013-02-09','13:20:00',8.83),('6449','2013-02-09','13:25:00',10.57),('6449','2013-02-09','13:30:00',15.11),('6449','2013-02-09','13:35:00',14.31),('6449','2013-02-09','13:40:00',12.78),('6449','2013-02-09','13:45:00',11.54),('6449','2013-02-09','13:50:00',7.97),('6449','2013-02-09','13:55:00',4.37),('6449','2013-02-09','14:00:00',8.45),('6449','2013-02-09','14:05:00',6.98),('6449','2013-02-09','14:10:00',11.48),('6449','2013-02-09','14:15:00',13.5),('6449','2013-02-09','14:20:00',12.36),('6449','2013-02-09','14:25:00',11.18),('6449','2013-02-09','14:30:00',11.66),('6449','2013-02-09','14:35:00',11.48),('6449','2013-02-09','14:40:00',11.07),('6449','2013-02-09','14:45:00',10.64),('6449','2013-02-09','14:50:00',10.42),('6449','2013-02-09','14:55:00',9.89),('6449','2013-02-09','15:00:00',9.76),('6449','2013-02-09','15:05:00',9.4),('6449','2013-02-09','15:10:00',9.03),('6449','2013-02-09','15:15:00',8.67),('6449','2013-02-09','15:20:00',8.3),('6449','2013-02-09','15:25:00',7.87),('6449','2013-02-09','15:30:00',7.53),('6449','2013-02-09','15:35:00',7.14),('6449','2013-02-09','15:40:00',6.79),('6449','2013-02-09','15:45:00',6.44),('6449','2013-02-09','15:50:00',6.09),('6449','2013-02-09','15:55:00',5.83),('6449','2013-02-09','16:00:00',5.73),('6449','2013-02-09','16:05:00',5.63),('6449','2013-02-09','16:10:00',5.39),('6449','2013-02-09','16:15:00',5.4),('6449','2013-02-09','16:20:00',5.42),('6449','2013-02-09','16:25:00',5.39),('6449','2013-02-09','16:30:00',4.94),('6449','2013-02-09','16:35:00',4.52),('6449','2013-02-09','16:40:00',3.64),('6449','2013-02-09','16:45:00',2.99),('6449','2013-02-09','16:50:00',2.22),('6449','2013-02-09','16:55:00',1.46),('6449','2013-02-09','17:01:00',1.53),('6449','2013-02-09','17:05:00',1.2),('6449','2013-02-08','08:05:00',1.04),('6449','2013-02-08','08:10:00',1.23),('6449','2013-02-08','08:15:00',1.45),('6449','2013-02-08','08:20:00',1.95),('6449','2013-02-08','08:25:00',2.87),('6449','2013-02-08','08:30:00',6.15),('6449','2013-02-08','08:35:00',3.51),('6449','2013-02-08','08:40:00',6.57),('6449','2013-02-08','08:45:00',7.2),('6449','2013-02-08','08:50:00',8.61),('6449','2013-02-08','08:55:00',9.63),('6449','2013-02-08','09:00:00',9.58),('6449','2013-02-08','09:05:00',9.66),('6449','2013-02-08','09:10:00',10.48),('6449','2013-02-08','09:15:00',10.78),('6449','2013-02-08','09:20:00',9.79),('6449','2013-02-08','09:25:00',9.57),('6449','2013-02-08','09:30:00',9.42),('6449','2013-02-08','09:35:00',9.91),('6449','2013-02-08','09:40:00',10.44),('6449','2013-02-08','09:45:00',10.86),('6449','2013-02-08','09:50:00',10.95),('6449','2013-02-08','09:55:00',11.2),('6449','2013-02-08','10:00:00',11.1),('6449','2013-02-08','10:05:00',11.51),('6449','2013-02-08','10:10:00',11.71),('6449','2013-02-08','10:15:00',11.89),('6449','2013-02-08','10:20:00',12.2),('6449','2013-02-08','10:25:00',12.36),('6449','2013-02-08','10:30:00',12.62),('6449','2013-02-08','10:35:00',12.87),('6449','2013-02-08','10:40:00',13.04),('6449','2013-02-08','10:45:00',13.28),('6449','2013-02-08','10:50:00',13.57),('6449','2013-02-08','10:55:00',13.8),('6449','2013-02-08','11:00:00',14.1),('6449','2013-02-08','11:05:00',14.98),('6449','2013-02-08','11:10:00',16.22),('6449','2013-02-08','11:15:00',14.89),('6449','2013-02-08','11:20:00',14.88),('6449','2013-02-08','11:25:00',18.09),('6449','2013-02-08','11:30:00',14.68),('6449','2013-02-08','11:35:00',12.63),('6449','2013-02-08','11:40:00',16.56),('6449','2013-02-08','11:45:00',12.12),('6449','2013-02-08','11:50:00',10.29),('6449','2013-02-08','11:55:00',11.73),('6449','2013-02-08','12:00:00',15.4),('6449','2013-02-08','12:05:00',14.85),('6449','2013-02-08','12:10:00',13.93),('6449','2013-02-08','12:15:00',13.04),('6449','2013-02-08','12:20:00',15.88),('6449','2013-02-08','12:25:00',16.24),('6449','2013-02-08','12:30:00',16.24),('6449','2013-02-08','12:35:00',13.98),('6449','2013-02-08','12:40:00',16.52),('6449','2013-02-08','12:45:00',16.9),('6449','2013-02-08','12:50:00',11.48),('6449','2013-02-08','12:55:00',6.89),('6449','2013-02-08','13:00:00',12.07),('6449','2013-02-08','13:05:00',9.87),('6449','2013-02-08','13:10:00',6.72),('6449','2013-02-08','13:15:00',5.89),('6449','2013-02-08','13:20:00',3.73),('6449','2013-02-08','13:25:00',3.33),('6449','2013-02-08','13:30:00',3.48),('6449','2013-02-08','13:35:00',4.26),('6449','2013-02-08','13:40:00',4.8),('6449','2013-02-08','13:45:00',7.68),('6449','2013-02-08','13:50:00',5.71),('6449','2013-02-08','13:55:00',4.18),('6449','2013-02-08','14:00:00',4.17),('6449','2013-02-08','14:05:00',4.28),('6449','2013-02-08','14:10:00',4.76),('6449','2013-02-08','14:15:00',5.07),('6449','2013-02-08','14:20:00',6.81),('6449','2013-02-08','14:25:00',3.86),('6449','2013-02-08','14:30:00',3.13),('6449','2013-02-08','14:35:00',2.79),('6449','2013-02-08','14:40:00',3.73),('6449','2013-02-08','14:45:00',11.73),('6449','2013-02-08','14:50:00',8.84),('6449','2013-02-08','14:55:00',6),('6449','2013-02-08','15:00:00',8.83),('6449','2013-02-08','15:05:00',3.51),('6449','2013-02-08','15:10:00',2.5),('6449','2013-02-08','15:15:00',2.47),('6449','2013-02-08','15:20:00',2.39),('6449','2013-02-08','15:25:00',2.36),('6449','2013-02-08','15:30:00',2.53),('6449','2013-02-08','15:35:00',2.63),('6449','2013-02-08','15:40:00',2.6),('6449','2013-02-08','15:45:00',2.19),('6449','2013-02-08','15:50:00',1.8),('6449','2013-02-08','15:55:00',1.45),('6449','2013-02-08','16:00:00',1.4),('6449','2013-02-08','16:05:00',1.24),('6449','2013-02-08','16:10:00',1.1),('6449','2013-02-08','16:16:00',1.24),('6449','2013-02-08','16:20:00',1.41),('6449','2013-02-07','08:25:00',1.06),('6449','2013-02-07','08:30:00',1.17),('6449','2013-02-07','08:35:00',1.09),('6449','2013-02-07','08:40:00',1.41),('6449','2013-02-07','08:45:00',2.11),('6449','2013-02-07','08:50:00',2.33),('6449','2013-02-07','08:55:00',1.8),('6449','2013-02-07','09:01:00',4.45),('6449','2013-02-07','09:05:00',6.89),('6449','2013-02-07','09:10:00',4.97),('6449','2013-02-07','09:15:00',3),('6449','2013-02-07','09:20:00',2.32),('6449','2013-02-07','09:25:00',1.13),('6449','2013-02-07','09:40:00',1.19),('6449','2013-02-07','09:45:00',1.82),('6449','2013-02-07','09:50:00',2.24),('6449','2013-02-07','09:55:00',6.39),('6449','2013-02-07','10:00:00',7.03),('6449','2013-02-07','10:05:00',5.64),('6449','2013-02-07','10:10:00',12.46),('6449','2013-02-07','10:15:00',11.99),('6449','2013-02-07','10:20:00',12.75),('6449','2013-02-07','10:25:00',11.27),('6449','2013-02-07','10:30:00',3.54),('6449','2013-02-07','10:35:00',1.76),('6449','2013-02-07','10:40:00',1.26),('6449','2013-02-07','10:45:00',1.17),('6449','2013-02-07','10:50:00',1.19),('6449','2013-02-07','10:55:00',1.36),('6449','2013-02-07','11:00:00',2.16),('6449','2013-02-07','11:05:00',5.02),('6449','2013-02-07','11:10:00',7.98),('6449','2013-02-07','11:15:00',13.01),('6449','2013-02-07','11:20:00',14.41),('6449','2013-02-07','11:25:00',14.37),('6449','2013-02-07','11:30:00',14.7),('6449','2013-02-07','11:35:00',14.81),('6449','2013-02-07','11:40:00',14.38),('6449','2013-02-07','11:45:00',7.54),('6449','2013-02-07','11:50:00',1.86),('6449','2013-02-07','11:55:00',6.92),('6449','2013-02-07','12:00:00',10.36),('6449','2013-02-07','12:05:00',14.8),('6449','2013-02-07','12:10:00',15.47),('6449','2013-02-07','12:15:00',13),('6449','2013-02-07','12:20:00',10.92),('6449','2013-02-07','12:25:00',8.37),('6449','2013-02-07','12:30:00',9.61),('6449','2013-02-07','12:35:00',14.6),('6449','2013-02-07','12:40:00',12.47),('6449','2013-02-07','12:45:00',15.09),('6449','2013-02-07','12:50:00',16.11),('6449','2013-02-07','12:55:00',12.16),('6449','2013-02-07','13:00:00',12.24),('6449','2013-02-07','13:05:00',15.28),('6449','2013-02-07','13:10:00',14.62),('6449','2013-02-07','13:15:00',14.8),('6449','2013-02-07','13:20:00',3.84),('6449','2013-02-07','13:25:00',4.39),('6449','2013-02-07','13:30:00',9.06),('6449','2013-02-07','13:35:00',17.9),('6449','2013-02-07','13:40:00',16.41),('6449','2013-02-07','13:45:00',11.06),('6449','2013-02-07','13:50:00',6.91),('6449','2013-02-07','13:55:00',8.21),('6449','2013-02-07','14:00:00',11.71),('6449','2013-02-07','14:05:00',15.22),('6449','2013-02-07','14:10:00',13.68),('6449','2013-02-07','14:15:00',12.23),('6449','2013-02-07','14:20:00',10.85),('6449','2013-02-07','14:25:00',13.53),('6449','2013-02-07','14:30:00',12.87),('6449','2013-02-07','14:35:00',11.86),('6449','2013-02-07','14:40:00',11.29),('6449','2013-02-07','14:45:00',9.75),('6449','2013-02-07','14:50:00',11.53),('6449','2013-02-07','14:55:00',11.04),('6449','2013-02-07','15:00:00',9.26),('6449','2013-02-07','15:05:00',7.94),('6449','2013-02-07','15:10:00',7.05),('6449','2013-02-07','15:15:00',4.26),('6449','2013-02-07','15:20:00',6.52),('6449','2013-02-07','15:25:00',2.58),('6449','2013-02-07','15:30:00',1.09),('6449','2013-02-07','16:40:00',2.23),('6449','2013-02-07','16:45:00',3.66),('6449','2013-02-07','16:50:00',2.74),('6449','2013-02-07','16:55:00',1.78),('6449','2013-02-07','17:00:00',1.29),('6449','2013-02-06','07:45:00',1.25),('6449','2013-02-06','08:00:00',1.07),('6449','2013-02-06','08:05:00',1.3),('6449','2013-02-06','08:10:00',1.47),('6449','2013-02-06','08:15:00',2.34),('6449','2013-02-06','08:20:00',1.74),('6449','2013-02-06','08:25:00',1.75),('6449','2013-02-06','08:30:00',2.57),('6449','2013-02-06','08:35:00',2.48),('6449','2013-02-06','08:40:00',2.57),('6449','2013-02-06','08:45:00',3.42),('6449','2013-02-06','08:50:00',2.9),('6449','2013-02-06','08:55:00',3.07),('6449','2013-02-06','09:00:00',3.11),('6449','2013-02-06','09:05:00',2.64),('6449','2013-02-06','09:10:00',3.31),('6449','2013-02-06','09:15:00',2.69),('6449','2013-02-06','09:20:00',2.87),('6449','2013-02-06','09:25:00',2.8),('6449','2013-02-06','09:30:00',2.84),('6449','2013-02-06','09:35:00',2.85),('6449','2013-02-06','09:40:00',3.28),('6449','2013-02-06','09:45:00',3.9),('6449','2013-02-06','09:50:00',3.35),('6449','2013-02-06','09:55:00',3.03),('6449','2013-02-06','10:00:00',2.98),('6449','2013-02-06','10:05:00',3.06),('6449','2013-02-06','10:10:00',3.26),('6449','2013-02-06','10:15:00',3.53),('6449','2013-02-06','10:20:00',4.97),('6449','2013-02-06','10:25:00',5.85),('6449','2013-02-06','10:30:00',7.87),('6449','2013-02-06','10:35:00',6.14),('6449','2013-02-06','10:40:00',5.07),('6449','2013-02-06','10:45:00',4.78),('6449','2013-02-06','10:50:00',4.1),('6449','2013-02-06','10:55:00',4.24),('6449','2013-02-06','11:00:00',4.79),('6449','2013-02-06','11:05:00',4.16),('6449','2013-02-06','11:10:00',2.97),('6449','2013-02-06','11:15:00',4.16),('6449','2013-02-06','11:20:00',4.91),('6449','2013-02-06','11:25:00',4.51),('6449','2013-02-06','11:30:00',4.24),('6449','2013-02-06','11:35:00',3.91),('6449','2013-02-06','11:40:00',2.87),('6449','2013-02-06','11:45:00',2.02),('6449','2013-02-06','11:50:00',1.96),('6449','2013-02-06','11:55:00',2.11),('6449','2013-02-06','12:00:00',3.2),('6449','2013-02-06','12:05:00',4.84),('6449','2013-02-06','12:10:00',4.72),('6449','2013-02-06','12:15:00',4.29),('6449','2013-02-06','12:20:00',4.27),('6449','2013-02-06','12:25:00',4.07),('6449','2013-02-06','12:30:00',6.62),('6449','2013-02-06','12:35:00',9.52),('6449','2013-02-06','12:40:00',7.96),('6449','2013-02-06','12:45:00',5.86),('6449','2013-02-06','12:50:00',6.37),('6449','2013-02-06','12:55:00',4.2),('6449','2013-02-06','13:00:00',3.52),('6449','2013-02-06','13:05:00',5.02),('6449','2013-02-06','13:10:00',3.52),('6449','2013-02-06','13:15:00',1.6),('6449','2013-02-06','13:20:00',1.07),('6449','2013-02-06','13:30:00',1.45),('6449','2013-02-06','13:35:00',1.41),('6449','2013-02-06','13:40:00',1.16),('6449','2013-02-06','13:45:00',2.3),('6449','2013-02-06','13:50:00',2.1),('6449','2013-02-06','13:55:00',1.46),('6449','2013-02-06','14:15:00',1.66),('6449','2013-02-06','14:20:00',3.98),('6449','2013-02-06','14:25:00',1.23),('6449','2013-02-06','14:30:00',2.53),('6449','2013-02-06','14:35:00',13.64),('6449','2013-02-06','14:40:00',11.12),('6449','2013-02-06','14:45:00',4.65),('6449','2013-02-06','14:50:00',3.72),('6449','2013-02-06','14:55:00',10.65),('6449','2013-02-06','15:00:00',11.77),('6449','2013-02-06','15:05:00',8.82),('6449','2013-02-06','15:10:00',5.96),('6449','2013-02-06','15:15:00',6.63),('6449','2013-02-06','15:20:00',5.92),('6449','2013-02-06','15:25:00',3.76),('6449','2013-02-06','15:30:00',2.47),('6449','2013-02-06','15:35:00',2.28),('6449','2013-02-06','15:40:00',2.03),('6449','2013-02-06','15:45:00',1.82),('6449','2013-02-06','15:50:00',1.77),('6449','2013-02-06','15:55:00',1.73),('6449','2013-02-06','16:00:00',1.82),('6449','2013-02-06','16:05:00',1.7),('6449','2013-02-06','16:10:00',1.26),('6449','2013-02-06','16:15:00',1.14),('6449','2013-02-06','16:20:00',1.14),('6449','2013-02-06','16:25:00',1.14),('6449','2013-02-06','16:30:00',1.45),('6449','2013-02-06','16:35:00',2.27),('6449','2013-02-06','16:40:00',2.89),('6449','2013-02-06','16:45:00',2.45),('6449','2013-02-06','16:50:00',2.02),('6449','2013-02-06','16:55:00',1.04),('6449','2013-02-05','07:40:00',1.07),('6449','2013-02-05','07:45:00',1.44),('6449','2013-02-05','07:50:00',1.78),('6449','2013-02-05','07:55:00',2.06),('6449','2013-02-05','08:00:00',2.44),('6449','2013-02-05','08:05:00',2.81),('6449','2013-02-05','08:10:00',3.13),('6449','2013-02-05','08:15:00',3.42),('6449','2013-02-05','08:20:00',3.81),('6449','2013-02-05','08:25:00',4.09),('6449','2013-02-05','08:30:00',4.54),('6449','2013-02-05','08:35:00',4.9),('6449','2013-02-05','08:40:00',5.28),('6449','2013-02-05','08:45:00',5.68),('6449','2013-02-05','08:50:00',6.04),('6449','2013-02-05','08:55:00',6.37),('6449','2013-02-05','09:00:00',6.83),('6449','2013-02-05','09:05:00',7.11),('6449','2013-02-05','09:10:00',7.5),('6449','2013-02-05','09:15:00',7.52),('6449','2013-02-05','09:20:00',8.08),('6449','2013-02-05','09:25:00',8.42),('6449','2013-02-05','09:30:00',8.72),('6449','2013-02-05','09:35:00',9.01),('6449','2013-02-05','09:40:00',9.25),('6449','2013-02-05','09:45:00',9.52),('6449','2013-02-05','09:50:00',9.84),('6449','2013-02-05','09:55:00',10.11),('6449','2013-02-05','10:00:00',10.39),('6449','2013-02-05','10:05:00',10.62),('6449','2013-02-05','10:10:00',10.57),('6449','2013-02-05','10:15:00',11.04),('6449','2013-02-05','10:20:00',11.2),('6449','2013-02-05','10:25:00',11.3),('6449','2013-02-05','10:30:00',11.55),('6449','2013-02-05','10:35:00',11.87),('6449','2013-02-05','10:40:00',11.92),('6449','2013-02-05','10:45:00',12.57),('6449','2013-02-05','10:50:00',12.72),('6449','2013-02-05','10:55:00',12.37),('6449','2013-02-05','11:00:00',12.89),('6449','2013-02-05','11:05:00',13.41),('6449','2013-02-05','11:10:00',12.47),('6449','2013-02-05','11:15:00',12.94),('6449','2013-02-05','11:20:00',12.67),('6449','2013-02-05','11:25:00',12.86),('6449','2013-02-05','11:30:00',9.66),('6449','2013-02-05','11:35:00',8.73),('6449','2013-02-05','11:40:00',6.85),('6449','2013-02-05','11:45:00',6.36),('6449','2013-02-05','11:50:00',5.72),('6449','2013-02-05','11:55:00',5.73),('6449','2013-02-05','12:00:00',6.49),('6449','2013-02-05','12:05:00',8.49),('6449','2013-02-05','12:10:00',7.16),('6449','2013-02-05','12:15:00',6.93),('6449','2013-02-05','12:20:00',6.19),('6449','2013-02-05','12:25:00',5.43),('6449','2013-02-05','12:30:00',6.1),('6449','2013-02-05','12:35:00',5.31),('6449','2013-02-05','12:40:00',5.88),('6449','2013-02-05','12:45:00',6.18),('6449','2013-02-05','12:50:00',5.23),('6449','2013-02-05','12:55:00',4.34),('6449','2013-02-05','13:00:00',4.33),('6449','2013-02-05','13:05:00',5.22),('6449','2013-02-05','13:10:00',5.39),('6449','2013-02-05','13:15:00',5.71),('6449','2013-02-05','13:20:00',5.75),('6449','2013-02-05','13:25:00',5.99),('6449','2013-02-05','13:30:00',7.13),('6449','2013-02-05','13:35:00',7.75),('6449','2013-02-05','13:40:00',8.39),('6449','2013-02-05','13:45:00',5.63),('6449','2013-02-05','13:50:00',6.44),('6449','2013-02-05','13:55:00',6.83),('6449','2013-02-05','14:00:00',7.39),('6449','2013-02-05','14:05:00',8.84),('6449','2013-02-05','14:10:00',10.51),('6449','2013-02-05','14:15:00',10.2),('6449','2013-02-05','14:20:00',9.42),('6449','2013-02-05','14:25:00',8.57),('6449','2013-02-05','14:30:00',6.09),('6449','2013-02-05','14:35:00',4.58),('6449','2013-02-05','14:40:00',4.45),('6449','2013-02-05','14:45:00',4.23),('6449','2013-02-05','14:50:00',3.11),('6449','2013-02-05','14:55:00',2.38),('6449','2013-02-05','15:00:00',1.23),('6449','2013-02-04','07:35:00',1.04),('6449','2013-02-04','07:40:00',1.43),('6449','2013-02-04','07:45:00',1.78),('6449','2013-02-04','07:50:00',2.12),('6449','2013-02-04','07:55:00',2.55),('6449','2013-02-04','08:00:00',3.1),('6449','2013-02-04','08:05:00',3.54),('6449','2013-02-04','08:10:00',3.7),('6449','2013-02-04','08:15:00',3.92),('6449','2013-02-04','08:20:00',3.95),('6449','2013-02-04','08:25:00',4.39),('6449','2013-02-04','08:30:00',4.67),('6449','2013-02-04','08:35:00',5.18),('6449','2013-02-04','08:40:00',5.52),('6449','2013-02-04','08:45:00',5.94),('6449','2013-02-04','08:50:00',6.38),('6449','2013-02-04','08:55:00',6.79),('6449','2013-02-04','09:00:00',7.15),('6449','2013-02-04','09:05:00',7.11),('6449','2013-02-04','09:10:00',7.23),('6449','2013-02-04','09:15:00',8),('6449','2013-02-04','09:20:00',7.1),('6449','2013-02-04','09:25:00',6.71),('6449','2013-02-04','09:30:00',8.66),('6449','2013-02-04','09:35:00',8.94),('6449','2013-02-04','09:40:00',10.05),('6449','2013-02-04','09:45:00',10.31),('6449','2013-02-04','09:51:00',10.14),('6449','2013-02-04','09:55:00',9.04),('6449','2013-02-04','10:00:00',9.48),('6449','2013-02-04','10:05:00',10.92),('6449','2013-02-04','10:10:00',11.16),('6449','2013-02-04','10:15:00',11.59),('6449','2013-02-04','10:20:00',11.23),('6449','2013-02-04','10:25:00',11.99),('6449','2013-02-04','10:30:00',11.79),('6449','2013-02-04','10:35:00',11.52),('6449','2013-02-04','10:40:00',12.51),('6449','2013-02-04','10:45:00',12.66),('6449','2013-02-04','10:50:00',12.84),('6449','2013-02-04','10:55:00',12.95),('6449','2013-02-04','11:00:00',13),('6449','2013-02-04','11:05:00',13.22),('6449','2013-02-04','11:10:00',13.3),('6449','2013-02-04','11:15:00',13.42),('6449','2013-02-04','11:20:00',13.59),('6449','2013-02-04','11:25:00',13.69),('6449','2013-02-04','11:31:00',13.76),('6449','2013-02-04','11:35:00',13.9),('6449','2013-02-04','11:40:00',13.79),('6449','2013-02-04','11:45:00',14.09),('6449','2013-02-04','11:50:00',14.15),('6449','2013-02-04','11:55:00',14.12),('6449','2013-02-04','12:00:00',14.2),('6449','2013-02-04','12:05:00',14.2),('6449','2013-02-04','12:10:00',14.06),('6449','2013-02-04','12:15:00',14.06),('6449','2013-02-04','12:20:00',14.04),('6449','2013-02-04','12:25:00',14.04),('6449','2013-02-04','12:30:00',13.89),('6449','2013-02-04','12:35:00',13.9),('6449','2013-02-04','12:40:00',13.84),('6449','2013-02-04','12:45:00',13.77),('6449','2013-02-04','12:50:00',13.66),('6449','2013-02-04','12:55:00',13.55),('6449','2013-02-04','13:00:00',13.44),('6449','2013-02-04','13:05:00',13.31),('6449','2013-02-04','13:10:00',13.25),('6449','2013-02-04','13:15:00',13.13),('6449','2013-02-04','13:20:00',12.91),('6449','2013-02-04','13:25:00',12.73),('6449','2013-02-04','13:30:00',12.64),('6449','2013-02-04','13:35:00',12.5),('6449','2013-02-04','13:40:00',12.52),('6449','2013-02-04','13:45:00',12.27),('6449','2013-02-04','13:50:00',12.21),('6449','2013-02-04','13:55:00',12.08),('6449','2013-02-04','14:00:00',11.9),('6449','2013-02-04','14:05:00',11.8),('6449','2013-02-04','14:10:00',11.61),('6449','2013-02-04','14:15:00',11.27),('6449','2013-02-04','14:20:00',11.07),('6449','2013-02-04','14:25:00',10.82),('6449','2013-02-04','14:30:00',10.55),('6449','2013-02-04','14:35:00',10.32),('6449','2013-02-04','14:40:00',9.99),('6449','2013-02-04','14:45:00',9.79),('6449','2013-02-04','14:50:00',9.5),('6449','2013-02-04','14:55:00',9.24),('6449','2013-02-04','15:00:00',8.83),('6449','2013-02-04','15:05:00',8.71),('6449','2013-02-04','15:10:00',8.37),('6449','2013-02-04','15:15:00',7.95),('6449','2013-02-04','15:20:00',7.75),('6449','2013-02-04','15:25:00',7.41),('6449','2013-02-04','15:30:00',7.02),('6449','2013-02-04','15:35:00',6.68),('6449','2013-02-04','15:40:00',6.34),('6449','2013-02-04','15:45:00',5.9),('6449','2013-02-04','15:50:00',5.61),('6449','2013-02-04','15:55:00',5.24),('6449','2013-02-04','16:00:00',4.81),('6449','2013-02-04','16:05:00',4.46),('6449','2013-02-04','16:10:00',4.04),('6449','2013-02-04','16:15:00',3.68),('6449','2013-02-04','16:20:00',3.33),('6449','2013-02-04','16:25:00',2.94),('6449','2013-02-04','16:30:00',2.56),('6449','2013-02-04','16:35:00',2.21),('6449','2013-02-04','16:40:00',1.89),('6449','2013-02-04','16:45:00',1.57),('6449','2013-02-04','16:50:00',1.27),('6449','2013-02-04','16:55:00',1),('6449','2013-02-03','08:35:00',1.04),('6449','2013-02-03','08:40:00',1.2),('6449','2013-02-03','08:45:00',1.29),('6449','2013-02-03','08:50:00',1.03),('6449','2013-02-03','09:40:00',2.67),('6449','2013-02-03','09:45:00',3.52),('6449','2013-02-03','09:50:00',1.83),('6449','2013-02-03','09:55:00',1.55),('6449','2013-02-03','10:15:00',1),('6449','2013-02-03','10:20:00',1.44),('6449','2013-02-03','10:25:00',1.23),('6449','2013-02-03','11:25:00',1.18),('6449','2013-02-03','11:30:00',2.29),('6449','2013-02-03','11:35:00',4.01),('6449','2013-02-03','11:40:00',4.55),('6449','2013-02-03','11:45:00',4.12),('6449','2013-02-03','11:50:00',3.39),('6449','2013-02-03','11:55:00',2.24),('6449','2013-02-03','12:00:00',1.22),('6449','2013-02-03','13:55:00',1.18),('6449','2013-02-03','14:00:00',1.45),('6449','2013-02-03','14:05:00',1.34),('6449','2013-02-03','14:10:00',1.06),('6449','2013-02-03','14:30:00',1.07),('6449','2013-02-03','14:35:00',1.16),('6449','2013-02-03','14:40:00',1.24),('6449','2013-02-03','14:45:00',1.4),('6449','2013-02-03','14:50:00',1.35),('6449','2013-02-03','14:55:00',1.4),('6449','2013-02-03','15:00:00',1.38),('6449','2013-02-03','15:05:00',1.25),('6449','2013-02-03','15:10:00',1.17),('6449','2013-02-03','15:15:00',1.06),('6449','2013-02-02','08:25:00',1.17),('6449','2013-02-02','08:30:00',1.51),('6449','2013-02-02','08:35:00',1.65),('6449','2013-02-02','08:40:00',1.66),('6449','2013-02-02','08:45:00',1.85),('6449','2013-02-02','08:50:00',2.08),('6449','2013-02-02','08:55:00',2.12),('6449','2013-02-02','09:00:00',1.92),('6449','2013-02-02','09:05:00',1.48),('6449','2013-02-02','09:10:00',1.88),('6449','2013-02-02','09:15:00',1.8),('6449','2013-02-02','09:20:00',1.48),('6449','2013-02-02','09:25:00',2.13),('6449','2013-02-02','09:30:00',2.78),('6449','2013-02-02','09:35:00',3.72),('6449','2013-02-02','09:40:00',4.7),('6449','2013-02-02','09:45:00',5.5),('6449','2013-02-02','09:50:00',4.68),('6449','2013-02-02','09:55:00',5.01),('6449','2013-02-02','10:00:00',3.92),('6449','2013-02-02','10:05:00',2.17),('6449','2013-02-02','10:10:00',1.79),('6449','2013-02-02','10:20:00',2.63),('6449','2013-02-02','10:25:00',5.56),('6449','2013-02-02','10:30:00',3.81),('6449','2013-02-02','10:35:00',5.25),('6449','2013-02-02','10:40:00',5.87),('6449','2013-02-02','10:45:00',6.23),('6449','2013-02-02','10:50:00',7.41),('6449','2013-02-02','10:55:00',9.45),('6449','2013-02-02','11:00:00',7.93),('6449','2013-02-02','11:05:00',5.87),('6449','2013-02-02','11:10:00',4.51),('6449','2013-02-02','11:15:00',3.28),('6449','2013-02-02','11:20:00',2.74),('6449','2013-02-02','11:25:00',2),('6449','2013-02-02','11:30:00',1.63),('6449','2013-02-02','11:35:00',1.87),('6449','2013-02-02','11:40:00',1.79),('6449','2013-02-02','11:45:00',2.38),('6449','2013-02-02','11:50:00',2.14),('6449','2013-02-02','11:55:00',1.55),('6449','2013-02-02','12:00:00',2.2),('6449','2013-02-02','12:05:00',1.5),('6449','2013-02-02','12:10:00',1.28),('6449','2013-02-02','12:15:00',1.96),('6449','2013-02-02','12:20:00',1.61),('6449','2013-02-02','12:25:00',6.6),('6449','2013-02-02','12:30:00',8.5),('6449','2013-02-02','12:35:00',2.32),('6449','2013-02-02','12:40:00',1.82),('6449','2013-02-02','12:45:00',4.76),('6449','2013-02-02','12:50:00',4.18),('6449','2013-02-02','12:55:00',4.07),('6449','2013-02-02','13:00:00',3.48),('6449','2013-02-02','13:05:00',1.45),('6449','2013-02-02','13:10:00',1.26),('6449','2013-02-02','13:15:00',1.11),('6449','2013-02-02','13:20:00',1.39),('6449','2013-02-02','13:25:00',1.29),('6449','2013-02-02','13:30:00',1.27),('6449','2013-02-02','13:35:00',1.5),('6449','2013-02-02','13:40:00',1.24),('6449','2013-02-02','13:45:00',1.46),('6449','2013-02-02','13:55:00',1.01),('6449','2013-02-02','14:05:00',1.34),('6449','2013-02-02','14:10:00',2.16),('6449','2013-02-02','14:20:00',1.64),('6449','2013-02-02','14:25:00',1.69),('6449','2013-02-02','15:10:00',2.18),('6449','2013-02-02','15:15:00',1.18),('6449','2013-02-02','15:25:00',1.21),('6449','2013-02-01','08:05:00',1.41),('6449','2013-02-01','08:15:00',1.98),('6449','2013-02-01','08:20:00',2.93),('6449','2013-02-01','08:25:00',2.04),('6449','2013-02-01','08:30:00',1.69),('6449','2013-02-01','08:35:00',1.41),('6449','2013-02-01','08:40:00',2.59),('6449','2013-02-01','08:45:00',4.66),('6449','2013-02-01','08:50:00',3.46),('6449','2013-02-01','08:55:00',2.26),('6449','2013-02-01','09:00:00',3.95),('6449','2013-02-01','09:05:00',3.04),('6449','2013-02-01','09:10:00',3.08),('6449','2013-02-01','09:15:00',2.8),('6449','2013-02-01','09:20:00',3.93),('6449','2013-02-01','09:25:00',4),('6449','2013-02-01','09:30:00',3.09),('6449','2013-02-01','09:35:00',2.45),('6449','2013-02-01','09:40:00',1.59),('6449','2013-02-01','09:45:00',1.67),('6449','2013-02-01','09:50:00',3.63),('6449','2013-02-01','09:55:00',5.26),('6449','2013-02-01','10:00:00',8.39),('6449','2013-02-01','10:05:00',6.27),('6449','2013-02-01','10:10:00',4.26),('6449','2013-02-01','10:15:00',3.12),('6449','2013-02-01','10:20:00',3.61),('6449','2013-02-01','10:25:00',4.01),('6449','2013-02-01','10:30:00',4.98),('6449','2013-02-01','10:35:00',10.96),('6449','2013-02-01','10:40:00',11.44),('6449','2013-02-01','10:45:00',11.62),('6449','2013-02-01','10:50:00',10.44),('6449','2013-02-01','10:55:00',4.72),('6449','2013-02-01','11:00:00',11.29),('6449','2013-02-01','11:05:00',4.07),('6449','2013-02-01','11:10:00',3.63),('6449','2013-02-01','11:15:00',3.52),('6449','2013-02-01','11:20:00',5.32),('6449','2013-02-01','11:25:00',8.89),('6449','2013-02-01','11:30:00',12.99),('6449','2013-02-01','11:35:00',12.55),('6449','2013-02-01','11:40:00',12.62),('6449','2013-02-01','11:45:00',12.97),('6449','2013-02-01','11:50:00',10.45),('6449','2013-02-01','11:55:00',3.3),('6449','2013-02-01','12:00:00',2.81),('6449','2013-02-01','12:05:00',2.7),('6449','2013-02-01','12:10:00',4.61),('6449','2013-02-01','12:15:00',5.33),('6449','2013-02-01','12:20:00',12.61),('6449','2013-02-01','12:25:00',13.73),('6449','2013-02-01','12:30:00',13.02),('6449','2013-02-01','12:35:00',12.69),('6449','2013-02-01','12:40:00',12.4),('6449','2013-02-01','12:45:00',12.23),('6449','2013-02-01','12:50:00',12.17),('6449','2013-02-01','12:55:00',12.39),('6449','2013-02-01','13:00:00',12.24),('6449','2013-02-01','13:05:00',10.91),('6449','2013-02-01','13:10:00',11.21),('6449','2013-02-01','13:15:00',11.28),('6449','2013-02-01','13:20:00',10.41),('6449','2013-02-01','13:25:00',10.09),('6449','2013-02-01','13:30:00',11.94),('6449','2013-02-01','13:35:00',10.2),('6449','2013-02-01','13:40:00',11.29),('6449','2013-02-01','13:45:00',11.13),('6449','2013-02-01','13:50:00',11.21),('6449','2013-02-01','13:55:00',10.64),('6449','2013-02-01','14:00:00',10.99),('6449','2013-02-01','14:05:00',10.75),('6449','2013-02-01','14:10:00',10.39),('6449','2013-02-01','14:15:00',10.32),('6449','2013-02-01','14:20:00',10.19),('6449','2013-02-01','14:25:00',9.62),('6449','2013-02-01','14:30:00',9.65),('6449','2013-02-01','14:35:00',9.32),('6449','2013-02-01','14:40:00',9.08),('6449','2013-02-01','14:45:00',8.61),('6449','2013-02-01','14:50:00',8.51),('6449','2013-02-01','14:55:00',8.16),('6449','2013-02-01','15:00:00',7.91),('6449','2013-02-01','15:05:00',7.71),('6449','2013-02-01','15:10:00',7.34),('6449','2013-02-01','15:15:00',7.02),('6449','2013-02-01','15:20:00',6.5),('6449','2013-02-01','15:25:00',6.35),('6449','2013-02-01','15:30:00',5.62),('6449','2013-02-01','15:35:00',5.26),('6449','2013-02-01','15:40:00',5),('6449','2013-02-01','15:45:00',4.58),('6449','2013-02-01','15:50:00',4.04),('6449','2013-02-01','15:55:00',2.86),('6449','2013-02-01','16:00:00',2.2),('6449','2013-02-01','16:05:00',1.78),('6449','2013-02-01','16:10:00',2),('6449','2013-02-01','16:15:00',1.76),('6449','2013-02-01','16:20:00',1.48),('6449','2013-02-01','16:25:00',1.52),('6449','2013-02-01','16:30:00',1.16),('6449','2013-01-31','08:10:00',1.22),('6449','2013-01-31','08:15:00',1.91),('6449','2013-01-31','08:20:00',2.74),('6449','2013-01-31','08:25:00',2.24),('6449','2013-01-31','08:30:00',3.06),('6449','2013-01-31','08:35:00',3.77),('6449','2013-01-31','08:40:00',3.97),('6449','2013-01-31','08:45:00',4.52),('6449','2013-01-31','08:50:00',4.39),('6449','2013-01-31','08:55:00',5.39),('6449','2013-01-31','09:00:00',5.8),('6449','2013-01-31','09:05:00',6.1),('6449','2013-01-31','09:10:00',6.66),('6449','2013-01-31','09:15:00',7),('6449','2013-01-31','09:20:00',7.3),('6449','2013-01-31','09:25:00',7.66),('6449','2013-01-31','09:30:00',7.83),('6449','2013-01-31','09:35:00',8.25),('6449','2013-01-31','09:40:00',8.53),('6449','2013-01-31','09:45:00',8.77),('6449','2013-01-31','09:50:00',8.94),('6449','2013-01-31','09:55:00',9.38),('6449','2013-01-31','10:00:00',9.66),('6449','2013-01-31','10:05:00',9.76),('6449','2013-01-31','10:10:00',9.9),('6449','2013-01-31','10:15:00',10.19),('6449','2013-01-31','10:20:00',10.33),('6449','2013-01-31','10:25:00',10.72),('6449','2013-01-31','10:30:00',10.74),('6449','2013-01-31','10:35:00',10.93),('6449','2013-01-31','10:40:00',11.03),('6449','2013-01-31','10:45:00',11.29),('6449','2013-01-31','10:50:00',11.55),('6449','2013-01-31','10:55:00',11.62),('6449','2013-01-31','11:00:00',11.85),('6449','2013-01-31','11:05:00',11.78),('6449','2013-01-31','11:10:00',12.06),('6449','2013-01-31','11:15:00',11.93),('6449','2013-01-31','11:20:00',12.2),('6449','2013-01-31','11:25:00',12.16),('6449','2013-01-31','11:30:00',12.34),('6449','2013-01-31','11:35:00',12.46),('6449','2013-01-31','11:40:00',12.5),('6449','2013-01-31','11:45:00',12.62),('6449','2013-01-31','11:50:00',12.66),('6449','2013-01-31','11:55:00',12.66),('6449','2013-01-31','12:00:00',12.6),('6449','2013-01-31','12:05:00',12.67),('6449','2013-01-31','12:10:00',12.63),('6449','2013-01-31','12:15:00',12.72),('6449','2013-01-31','12:20:00',12.62),('6449','2013-01-31','12:25:00',12.7),('6449','2013-01-31','12:30:00',12.76),('6449','2013-01-31','12:35:00',12.76),('6449','2013-01-31','12:40:00',12.64),('6449','2013-01-31','12:45:00',12.56),('6449','2013-01-31','12:50:00',12.59),('6449','2013-01-31','12:55:00',12.33),('6449','2013-01-31','13:00:00',12.29),('6449','2013-01-31','13:05:00',12.29),('6449','2013-01-31','13:10:00',12.21),('6449','2013-01-31','13:15:00',12.08),('6449','2013-01-31','13:20:00',11.74),('6449','2013-01-31','13:25:00',11.83),('6449','2013-01-31','13:30:00',11.85),('6449','2013-01-31','13:35:00',11.8),('6449','2013-01-31','13:40:00',11.61),('6449','2013-01-31','13:45:00',11.49),('6449','2013-01-31','13:50:00',11.37),('6449','2013-01-31','13:55:00',11.09),('6449','2013-01-31','14:00:00',10.78),('6449','2013-01-31','14:05:00',10.64),('6449','2013-01-31','14:10:00',10.48),('6449','2013-01-31','14:15:00',10.32),('6449','2013-01-31','14:20:00',10.14),('6449','2013-01-31','14:25:00',9.81),('6449','2013-01-31','14:30:00',9.58),('6449','2013-01-31','14:35:00',9.32),('6449','2013-01-31','14:40:00',9.08),('6449','2013-01-31','14:45:00',8.66),('6449','2013-01-31','14:50:00',8.15),('6449','2013-01-31','14:55:00',8.12),('6449','2013-01-31','15:00:00',7.95),('6449','2013-01-31','15:05:00',7.57),('6449','2013-01-31','15:10:00',7.4),('6449','2013-01-31','15:15:00',7.13),('6449','2013-01-31','15:20:00',7.05),('6449','2013-01-31','15:25:00',6.74),('6449','2013-01-31','15:30:00',6.06),('6449','2013-01-31','15:35:00',5.04),('6449','2013-01-31','15:40:00',3.58),('6449','2013-01-31','15:45:00',3.65),('6449','2013-01-31','15:50:00',4.52),('6449','2013-01-31','15:55:00',3.77),('6449','2013-01-31','16:00:00',3.7),('6449','2013-01-31','16:05:00',3.31),('6449','2013-01-31','16:10:00',3.38),('6449','2013-01-31','16:15:00',3.22),('6449','2013-01-31','16:20:00',2.82),('6449','2013-01-31','16:25:00',2.48),('6449','2013-01-31','16:30:00',2.15),('6449','2013-01-31','16:35:00',1.83),('6449','2013-01-31','16:40:00',1.66),('6449','2013-01-31','16:45:00',1.37),('6449','2013-01-31','16:50:00',1.06),('6449','2013-01-30','08:10:00',1.02),('6449','2013-01-30','08:15:00',2.3),('6449','2013-01-30','08:20:00',1.74),('6449','2013-01-30','08:25:00',1.48),('6449','2013-01-30','08:30:00',1.17),('6449','2013-01-30','08:35:00',1.74),('6449','2013-01-30','08:40:00',2.29),('6449','2013-01-30','08:45:00',1.8),('6449','2013-01-30','08:50:00',5.08),('6449','2013-01-30','08:55:00',5.55),('6449','2013-01-30','09:00:00',6.1),('6449','2013-01-30','09:05:00',7.35),('6449','2013-01-30','09:10:00',8.78),('6449','2013-01-30','09:15:00',8.81),('6449','2013-01-30','09:20:00',4.91),('6449','2013-01-30','09:25:00',4.56),('6449','2013-01-30','09:30:00',7.88),('6449','2013-01-30','09:35:00',8.72),('6449','2013-01-30','09:40:00',4.87),('6449','2013-01-30','09:45:00',3.52),('6449','2013-01-30','09:50:00',3.5),('6449','2013-01-30','09:55:00',3.67),('6449','2013-01-30','10:00:00',8.27),('6449','2013-01-30','10:05:00',9.48),('6449','2013-01-30','10:10:00',3.59),('6449','2013-01-30','10:15:00',5.59),('6449','2013-01-30','10:20:00',4.29),('6449','2013-01-30','10:25:00',2.96),('6449','2013-01-30','10:30:00',6.38),('6449','2013-01-30','10:35:00',5.15),('6449','2013-01-30','10:40:00',10.01),('6449','2013-01-30','10:45:00',11.44),('6449','2013-01-30','10:50:00',11.66),('6449','2013-01-30','10:55:00',11.76),('6449','2013-01-30','11:00:00',11.97),('6449','2013-01-30','11:05:00',12.12),('6449','2013-01-30','11:10:00',12.12),('6449','2013-01-30','11:15:00',12.04),('6449','2013-01-30','11:20:00',12.32),('6449','2013-01-30','11:25:00',12.37),('6449','2013-01-30','11:30:00',12.52),('6449','2013-01-30','11:35:00',12.74),('6449','2013-01-30','11:40:00',12.67),('6449','2013-01-30','11:45:00',12.07),('6449','2013-01-30','11:50:00',13.09),('6449','2013-01-30','11:55:00',8.25),('6449','2013-01-30','12:00:00',6.29),('6449','2013-01-30','12:05:00',6.8),('6449','2013-01-30','12:10:00',9.94),('6449','2013-01-30','12:15:00',13.62),('6449','2013-01-30','12:20:00',13.25),('6449','2013-01-30','12:25:00',6.54),('6449','2013-01-30','12:30:00',6.72),('6449','2013-01-30','12:35:00',6.99),('6449','2013-01-30','12:40:00',7.58),('6449','2013-01-30','12:45:00',6.64),('6449','2013-01-30','12:50:00',7.17),('6449','2013-01-30','12:55:00',12.72),('6449','2013-01-30','13:00:00',13.52),('6449','2013-01-30','13:05:00',12.17),('6449','2013-01-30','13:10:00',12.37),('6449','2013-01-30','13:15:00',12.31),('6449','2013-01-30','13:20:00',8.9),('6449','2013-01-30','13:25:00',12.13),('6449','2013-01-30','13:30:00',10.71),('6449','2013-01-30','13:35:00',10.89),('6449','2013-01-30','13:40:00',10.56),('6449','2013-01-30','13:45:00',9.32),('6449','2013-01-30','13:50:00',8.16),('6449','2013-01-30','13:55:00',7.27),('6449','2013-01-30','14:00:00',8.45),('6449','2013-01-30','14:05:00',8.94),('6449','2013-01-30','14:10:00',8.35),('6449','2013-01-30','14:15:00',6.68),('6449','2013-01-30','14:20:00',4.33),('6449','2013-01-30','14:25:00',5.38),('6449','2013-01-30','14:30:00',5.18),('6449','2013-01-30','14:35:00',5.08),('6449','2013-01-30','14:40:00',4.63),('6449','2013-01-30','14:45:00',4.72),('6449','2013-01-30','14:50:00',4.76),('6449','2013-01-30','14:55:00',4.57),('6449','2013-01-30','15:00:00',4.14),('6449','2013-01-30','15:05:00',3.56),('6449','2013-01-30','15:10:00',3.22),('6449','2013-01-30','15:15:00',2.94),('6449','2013-01-30','15:20:00',2.76),('6449','2013-01-30','15:25:00',2.8),('6449','2013-01-30','15:30:00',3.05),('6449','2013-01-30','15:35:00',3.24),('6449','2013-01-30','15:40:00',2.89),('6449','2013-01-30','15:45:00',2.6),('6449','2013-01-30','15:50:00',2.53),('6449','2013-01-30','15:55:00',2.78),('6449','2013-01-30','16:00:00',4.02),('6449','2013-01-30','16:05:00',3.77),('6449','2013-01-30','16:10:00',2.11),('6449','2013-01-30','16:15:00',2.1),('6449','2013-01-30','16:20:00',1.55),('6449','2013-01-30','16:25:00',1.36),('6449','2013-01-30','16:30:00',1.51),('6449','2013-01-30','16:35:00',1.67),('6449','2013-01-30','16:40:00',1.4),('6449','2013-01-30','16:45:00',1.37),('6449','2013-01-30','16:50:00',1.17),('6449','2013-01-29','07:45:00',1.1),('6449','2013-01-29','07:50:00',1.46),('6449','2013-01-29','07:55:00',1.98),('6449','2013-01-29','08:00:00',2.5),('6449','2013-01-29','08:05:00',2.79),('6449','2013-01-29','08:10:00',3.17),('6449','2013-01-29','08:15:00',3.51),('6449','2013-01-29','08:20:00',3.62),('6449','2013-01-29','08:25:00',3.12),('6449','2013-01-29','08:30:00',1.67),('6449','2013-01-29','08:35:00',4.69),('6449','2013-01-29','08:40:00',5.05),('6449','2013-01-29','08:45:00',4.73),('6449','2013-01-29','08:50:00',5.32),('6449','2013-01-29','08:55:00',5.67),('6449','2013-01-29','09:00:00',5.97),('6449','2013-01-29','09:05:00',6.32),('6449','2013-01-29','09:10:00',6.67),('6449','2013-01-29','09:15:00',6.91),('6449','2013-01-29','09:20:00',7.3),('6449','2013-01-29','09:25:00',7.64),('6449','2013-01-29','09:30:00',7.95),('6449','2013-01-29','09:35:00',8.23),('6449','2013-01-29','09:40:00',8.51),('6449','2013-01-29','09:45:00',8.57),('6449','2013-01-29','09:50:00',8.98),('6449','2013-01-29','09:55:00',9.2),('6449','2013-01-29','10:00:00',9.48),('6449','2013-01-29','10:05:00',9.65),('6449','2013-01-29','10:10:00',10.35),('6449','2013-01-29','10:15:00',11.79),('6449','2013-01-29','10:20:00',9.6),('6449','2013-01-29','10:25:00',4.77),('6449','2013-01-29','10:30:00',4.61),('6449','2013-01-29','10:35:00',7.15),('6449','2013-01-29','10:40:00',6.3),('6449','2013-01-29','10:45:00',5.89),('6449','2013-01-29','10:50:00',10.36),('6449','2013-01-29','10:55:00',11.41),('6449','2013-01-29','11:00:00',12.62),('6449','2013-01-29','11:05:00',11.54),('6449','2013-01-29','11:10:00',12.49),('6449','2013-01-29','11:15:00',12.42),('6449','2013-01-29','11:20:00',12.46),('6449','2013-01-29','11:25:00',11.63),('6449','2013-01-29','11:30:00',11.94),('6449','2013-01-29','11:35:00',11.53),('6449','2013-01-29','11:41:00',11.43),('6449','2013-01-29','11:45:00',12.44),('6449','2013-01-29','11:50:00',12.53),('6449','2013-01-29','11:55:00',12.96),('6449','2013-01-29','12:00:00',12.64),('6449','2013-01-29','12:05:00',12.52),('6449','2013-01-29','12:10:00',12.59),('6449','2013-01-29','12:15:00',12.66),('6449','2013-01-29','12:20:00',12.6),('6449','2013-01-29','12:25:00',12.85),('6449','2013-01-29','12:30:00',12.89),('6449','2013-01-29','12:35:00',12.55),('6449','2013-01-29','12:40:00',12.4),('6449','2013-01-29','12:45:00',12.52),('6449','2013-01-29','12:50:00',12.52),('6449','2013-01-29','12:55:00',12.4),('6449','2013-01-29','13:01:00',12.37),('6449','2013-01-29','13:05:00',12.12),('6449','2013-01-29','13:10:00',12.18),('6449','2013-01-29','13:15:00',12.17),('6449','2013-01-29','13:20:00',12.16),('6449','2013-01-29','13:25:00',12.3),('6449','2013-01-29','13:30:00',12.39),('6449','2013-01-29','13:35:00',10.64),('6449','2013-01-29','13:40:00',8.56),('6449','2013-01-29','13:45:00',12.23),('6449','2013-01-29','13:50:00',11.89),('6449','2013-01-29','13:55:00',11.87),('6449','2013-01-29','14:00:00',8.96),('6449','2013-01-29','14:05:00',10.96),('6449','2013-01-29','14:10:00',11.08),('6449','2013-01-29','14:15:00',10.86),('6449','2013-01-29','14:20:00',10.49),('6449','2013-01-29','14:25:00',10.29),('6449','2013-01-29','14:30:00',10.32),('6449','2013-01-29','14:35:00',10.03),('6449','2013-01-29','14:40:00',5.07),('6449','2013-01-29','14:45:00',7.04),('6449','2013-01-29','14:50:00',8.95),('6449','2013-01-29','14:55:00',8.54),('6449','2013-01-29','15:00:00',8.11),('6449','2013-01-29','15:05:00',7.83),('6449','2013-01-29','15:10:00',7.48),('6449','2013-01-29','15:15:00',7.1),('6449','2013-01-29','15:20:00',6.8),('6449','2013-01-29','15:25:00',6.58),('6449','2013-01-29','15:30:00',6.29),('6449','2013-01-29','15:35:00',5.82),('6449','2013-01-29','15:40:00',5.51),('6449','2013-01-29','15:45:00',5.14),('6449','2013-01-29','15:50:00',4.79),('6449','2013-01-29','15:55:00',4.47),('6449','2013-01-29','16:00:00',4.08),('6449','2013-01-29','16:05:00',3.72),('6449','2013-01-29','16:10:00',3.39),('6449','2013-01-29','16:15:00',3.04),('6449','2013-01-29','16:20:00',2.69),('6449','2013-01-29','16:25:00',2.38),('6449','2013-01-29','16:30:00',2.06),('6449','2013-01-29','16:35:00',1.73),('6449','2013-01-29','16:40:00',1.39),('6449','2013-01-29','16:45:00',1.09),('6449','2013-01-28','09:55:00',1.01),('6449','2013-01-28','10:00:00',1.05),('6449','2013-01-28','10:05:00',1.26),('6449','2013-01-28','10:10:00',1.61),('6449','2013-01-28','10:15:00',2.03),('6449','2013-01-28','10:20:00',2.55),('6449','2013-01-28','10:25:00',3.16),('6449','2013-01-28','10:30:00',3.57),('6449','2013-01-28','10:35:00',3.45),('6449','2013-01-28','10:40:00',2.66),('6449','2013-01-28','10:45:00',2.34),('6449','2013-01-28','10:50:00',2.31),('6449','2013-01-28','10:55:00',2.3),('6449','2013-01-28','11:00:00',2.01),('6449','2013-01-28','11:05:00',1.53),('6449','2013-01-28','11:10:00',1.33),('6449','2013-01-28','11:15:00',1.23),('6449','2013-01-28','11:20:00',1.19),('6449','2013-01-28','11:25:00',1.01),('6449','2013-01-28','11:35:00',1.1),('6449','2013-01-28','11:40:00',1.37),('6449','2013-01-28','11:45:00',1.78),('6449','2013-01-28','11:50:00',2.07),('6449','2013-01-28','11:55:00',2.53),('6449','2013-01-28','12:00:00',3.08),('6449','2013-01-28','12:05:00',3.44),('6449','2013-01-28','12:10:00',3.45),('6449','2013-01-28','12:15:00',3.33),('6449','2013-01-28','12:20:00',3.35),('6449','2013-01-28','12:25:00',3.39),('6449','2013-01-28','12:30:00',2.99),('6449','2013-01-28','12:35:00',2.68),('6449','2013-01-28','12:40:00',2.54),('6449','2013-01-28','12:45:00',3.05),('6449','2013-01-28','12:50:00',3.09),('6449','2013-01-28','12:55:00',2.97),('6449','2013-01-28','13:00:00',3.14),('6449','2013-01-28','13:05:00',3.22),('6449','2013-01-28','13:10:00',2.8),('6449','2013-01-28','13:15:00',2.39),('6449','2013-01-28','13:20:00',2.34),('6449','2013-01-28','13:25:00',2.26),('6449','2013-01-28','13:30:00',2.09),('6449','2013-01-28','13:35:00',1.98),('6449','2013-01-28','13:40:00',2.26),('6449','2013-01-28','13:45:00',2.18),('6449','2013-01-28','13:50:00',2.21),('6449','2013-01-28','13:55:00',2.32),('6449','2013-01-28','14:00:00',2.44),('6449','2013-01-28','14:05:00',2.47),('6449','2013-01-28','14:10:00',2.19),('6449','2013-01-28','14:15:00',1.69),('6449','2013-01-28','14:20:00',1.59),('6449','2013-01-28','14:25:00',1.52),('6449','2013-01-28','14:30:00',1.49),('6449','2013-01-28','14:35:00',1.58),('6449','2013-01-28','14:40:00',1.54),('6449','2013-01-28','14:45:00',1.35),('6449','2013-01-28','14:50:00',1.25),('6449','2013-01-28','14:55:00',1.08),('6449','2013-01-28','15:10:00',1.02),('6449','2013-01-28','15:15:00',1.13),('6449','2013-01-28','15:20:00',1.1),('6449','2013-01-28','15:25:00',1.18),('6449','2013-01-28','15:30:00',1.17),('6449','2013-01-28','15:35:00',1.11),('6449','2013-01-28','15:40:00',1.01),('6449','2013-01-27','07:50:00',1.02),('6449','2013-01-27','07:55:00',1.15),('6449','2013-01-27','08:00:00',1.38),('6449','2013-01-27','08:05:00',1.22),('6449','2013-01-27','08:10:00',1.79),('6449','2013-01-27','08:15:00',1.51),('6449','2013-01-27','08:25:00',1.29),('6449','2013-01-27','08:30:00',1.59),('6449','2013-01-27','08:40:00',1.21),('6449','2013-01-27','08:45:00',1.68),('6449','2013-01-27','08:50:00',1.72),('6449','2013-01-27','08:55:00',1.6),('6449','2013-01-27','09:00:00',1.62),('6449','2013-01-27','09:05:00',2.42),('6449','2013-01-27','09:10:00',2.06),('6449','2013-01-27','09:15:00',1.56),('6449','2013-01-27','09:20:00',5.15),('6449','2013-01-27','09:25:00',6.62),('6449','2013-01-27','09:30:00',7.67),('6449','2013-01-27','09:35:00',7.91),('6449','2013-01-27','09:40:00',8.28),('6449','2013-01-27','09:45:00',8.53),('6449','2013-01-27','09:50:00',8.72),('6449','2013-01-27','09:55:00',8.98),('6449','2013-01-27','10:00:00',9.26),('6449','2013-01-27','10:05:00',9.49),('6449','2013-01-27','10:10:00',9.75),('6449','2013-01-27','10:15:00',10.05),('6449','2013-01-27','10:20:00',10.06),('6449','2013-01-27','10:25:00',10.43),('6449','2013-01-27','10:30:00',10.65),('6449','2013-01-27','10:35:00',10.8),('6449','2013-01-27','10:40:00',11.04),('6449','2013-01-27','10:45:00',11.28),('6449','2013-01-27','10:50:00',11.52),('6449','2013-01-27','10:55:00',11.74),('6449','2013-01-27','11:00:00',11.91),('6449','2013-01-27','11:05:00',12.09),('6449','2013-01-27','11:10:00',12.22),('6449','2013-01-27','11:15:00',12.32),('6449','2013-01-27','11:20:00',12.11),('6449','2013-01-27','11:25:00',12.51),('6449','2013-01-27','11:30:00',12.5),('6449','2013-01-27','11:35:00',12.49),('6449','2013-01-27','11:40:00',12.58),('6449','2013-01-27','11:45:00',12.65),('6449','2013-01-27','11:50:00',12.65),('6449','2013-01-27','11:55:00',12.86),('6449','2013-01-27','12:00:00',12.84),('6449','2013-01-27','12:05:00',12.48),('6449','2013-01-27','12:10:00',12.92),('6449','2013-01-27','12:15:00',13.03),('6449','2013-01-27','12:20:00',12.94),('6449','2013-01-27','12:25:00',12.85),('6449','2013-01-27','12:30:00',12.81),('6449','2013-01-27','12:35:00',12.68),('6449','2013-01-27','12:40:00',12.67),('6449','2013-01-27','12:45:00',12.6),('6449','2013-01-27','12:50:00',12.65),('6449','2013-01-27','12:55:00',12.43),('6449','2013-01-27','13:00:00',12.25),('6449','2013-01-27','13:05:00',12.12),('6449','2013-01-27','13:10:00',12.08),('6449','2013-01-27','13:15:00',11.93),('6449','2013-01-27','13:20:00',11.56),('6449','2013-01-27','13:25:00',11.4),('6449','2013-01-27','13:30:00',11.35),('6449','2013-01-27','13:35:00',11.3),('6449','2013-01-27','13:40:00',11.17),('6449','2013-01-27','13:45:00',11.18),('6449','2013-01-27','13:50:00',10.81),('6449','2013-01-27','13:55:00',10.61),('6449','2013-01-27','14:00:00',10.36),('6449','2013-01-27','14:05:00',10.27),('6449','2013-01-27','14:10:00',10.18),('6449','2013-01-27','14:15:00',9.83),('6449','2013-01-27','14:20:00',9.67),('6449','2013-01-27','14:25:00',9.35),('6449','2013-01-27','14:30:00',9.35),('6449','2013-01-27','14:35:00',9.06),('6449','2013-01-27','14:40:00',8.62),('6449','2013-01-27','14:45:00',8.57),('6449','2013-01-27','14:50:00',8.28),('6449','2013-01-27','14:55:00',7.64),('6449','2013-01-27','15:00:00',7.57),('6449','2013-01-27','15:05:00',7.2),('6449','2013-01-27','15:10:00',6.88),('6449','2013-01-27','15:15:00',6.59),('6449','2013-01-27','15:20:00',6.2),('6449','2013-01-27','15:25:00',5.25),('6449','2013-01-27','15:30:00',5.17),('6449','2013-01-27','15:35:00',5.3),('6449','2013-01-27','15:40:00',4.89),('6449','2013-01-27','15:45:00',4.57),('6449','2013-01-27','15:50:00',4.25),('6449','2013-01-27','15:55:00',3.87),('6449','2013-01-27','16:00:00',3.45),('6449','2013-01-27','16:05:00',3.09),('6449','2013-01-27','16:10:00',2.8),('6449','2013-01-27','16:15:00',2.54),('6449','2013-01-27','16:20:00',2.2),('6449','2013-01-27','16:25:00',1.9),('6449','2013-01-27','16:30:00',1.63),('6449','2013-01-27','16:35:00',1.35),('6449','2013-01-27','16:40:00',1.08),('6449','2013-01-26','09:00:00',1.19),('6449','2013-01-26','09:05:00',1.35),('6449','2013-01-26','09:20:00',1.1),('6449','2013-01-26','09:25:00',1.09),('6449','2013-01-26','09:30:00',1.41),('6449','2013-01-26','09:35:00',1.7),('6449','2013-01-26','09:40:00',1.84),('6449','2013-01-26','09:45:00',2.27),('6449','2013-01-26','09:50:00',2.86),('6449','2013-01-26','09:55:00',2.91),('6449','2013-01-26','10:00:00',3.35),('6449','2013-01-26','10:05:00',3.29),('6449','2013-01-26','10:10:00',3.01),('6449','2013-01-26','10:15:00',3.51),('6449','2013-01-26','10:20:00',3.82),('6449','2013-01-26','10:25:00',3.39),('6449','2013-01-26','10:30:00',3.59),('6449','2013-01-26','10:35:00',3.87),('6449','2013-01-26','10:40:00',4.33),('6449','2013-01-26','10:45:00',4.14),('6449','2013-01-26','10:50:00',4.04),('6449','2013-01-26','10:55:00',3.92),('6449','2013-01-26','11:00:00',3.67),('6449','2013-01-26','11:05:00',3.69),('6449','2013-01-26','11:10:00',3.56),('6449','2013-01-26','11:15:00',3.76),('6449','2013-01-26','11:20:00',9.26),('6449','2013-01-26','11:25:00',12.01),('6449','2013-01-26','11:30:00',12.72),('6449','2013-01-26','11:35:00',15.59),('6449','2013-01-26','11:40:00',9.07),('6449','2013-01-26','11:45:00',6.99),('6449','2013-01-26','11:50:00',7.65),('6449','2013-01-26','11:55:00',4.79),('6449','2013-01-26','12:00:00',4.55),('6449','2013-01-26','12:05:00',3.59),('6449','2013-01-26','12:10:00',2.99),('6449','2013-01-26','12:15:00',3.24),('6449','2013-01-26','12:20:00',3.38),('6449','2013-01-26','12:25:00',3.29),('6449','2013-01-26','12:30:00',3.32),('6449','2013-01-26','12:35:00',3.69),('6449','2013-01-26','12:40:00',4.14),('6449','2013-01-26','12:45:00',4.84),('6449','2013-01-26','12:50:00',4.59),('6449','2013-01-26','12:55:00',4.61),('6449','2013-01-26','13:00:00',4.8),('6449','2013-01-26','13:05:00',4.51),('6449','2013-01-26','13:10:00',4.53),('6449','2013-01-26','13:15:00',4.82),('6449','2013-01-26','13:20:00',4.27),('6449','2013-01-26','13:25:00',3.74),('6449','2013-01-26','13:30:00',3.58),('6449','2013-01-26','13:35:00',3.65),('6449','2013-01-26','13:40:00',3.61),('6449','2013-01-26','13:45:00',3.27),('6449','2013-01-26','13:50:00',3.35),('6449','2013-01-26','13:55:00',3.48),('6449','2013-01-26','14:00:00',3.11),('6449','2013-01-26','14:05:00',2.74),('6449','2013-01-26','14:10:00',2.47),('6449','2013-01-26','14:15:00',2.17),('6449','2013-01-26','14:20:00',1.82),('6449','2013-01-26','14:25:00',1.49),('6449','2013-01-26','14:30:00',1.35),('6449','2013-01-26','14:35:00',1.26),('6449','2013-01-26','14:40:00',1.08),('6449','2013-01-26','14:45:00',1.23),('6449','2013-01-26','14:50:00',1.52),('6449','2013-01-26','14:55:00',1.52),('6449','2013-01-26','15:00:00',1.33),('6449','2013-01-26','15:05:00',1.42),('6449','2013-01-26','15:10:00',1.41),('6449','2013-01-26','15:15:00',1.49),('6449','2013-01-26','15:20:00',1.56),('6449','2013-01-26','15:25:00',1.63),('6449','2013-01-26','15:30:00',1.71),('6449','2013-01-26','15:35:00',1.49),('6449','2013-01-26','15:40:00',1.12),('6449','2013-01-26','15:45:00',1.02),('6449','2013-01-26','15:50:00',1.05),('6449','2013-01-26','15:55:00',1.05),('6449','2013-01-25','08:00:00',1.76),('6449','2013-01-25','08:05:00',2.29),('6449','2013-01-25','08:10:00',2.73),('6449','2013-01-25','08:15:00',2.6),('6449','2013-01-25','08:20:00',3.11),('6449','2013-01-25','08:25:00',3.65),('6449','2013-01-25','08:30:00',4.24),('6449','2013-01-25','08:35:00',5.2),('6449','2013-01-25','08:40:00',4.38),('6449','2013-01-25','08:45:00',4.91),('6449','2013-01-25','08:50:00',6.09),('6449','2013-01-25','08:55:00',6.65),('6449','2013-01-25','09:00:00',7.32),('6449','2013-01-25','09:05:00',7.75),('6449','2013-01-25','09:10:00',8.01),('6449','2013-01-25','09:15:00',7.71),('6449','2013-01-25','09:20:00',8.52),('6449','2013-01-25','09:25:00',8.56),('6449','2013-01-25','09:30:00',8.99),('6449','2013-01-25','09:35:00',9.42),('6449','2013-01-25','09:40:00',9.77),('6449','2013-01-25','09:45:00',9.4),('6449','2013-01-25','09:50:00',8.3),('6449','2013-01-25','09:55:00',9.17),('6449','2013-01-25','10:00:00',9.88),('6449','2013-01-25','10:05:00',9.92),('6449','2013-01-25','10:10:00',10.95),('6449','2013-01-25','10:15:00',10.91),('6449','2013-01-25','10:20:00',9.43),('6449','2013-01-25','10:25:00',9.81),('6449','2013-01-25','10:30:00',10.19),('6449','2013-01-25','10:35:00',9.64),('6449','2013-01-25','10:40:00',9.33),('6449','2013-01-25','10:45:00',6.58),('6449','2013-01-25','10:50:00',4.33),('6449','2013-01-25','10:55:00',2.87),('6449','2013-01-25','11:00:00',3.19),('6449','2013-01-25','11:05:00',3.93),('6449','2013-01-25','11:10:00',3.73),('6449','2013-01-25','11:15:00',3.26),('6449','2013-01-25','11:20:00',3.98),('6449','2013-01-25','11:25:00',5.26),('6449','2013-01-25','11:30:00',7.54),('6449','2013-01-25','11:35:00',10.02),('6449','2013-01-25','11:40:00',12.65),('6449','2013-01-25','11:45:00',12.95),('6449','2013-01-25','11:50:00',12.91),('6449','2013-01-25','11:55:00',12.84),('6449','2013-01-25','12:00:00',12.61),('6449','2013-01-25','12:05:00',12.81),('6449','2013-01-25','12:10:00',12.88),('6449','2013-01-25','12:15:00',13.12),('6449','2013-01-25','12:20:00',11.77),('6449','2013-01-25','12:25:00',13.32),('6449','2013-01-25','12:30:00',13.01),('6449','2013-01-25','12:35:00',13.23),('6449','2013-01-25','12:40:00',13.25),('6449','2013-01-25','12:45:00',13.18),('6449','2013-01-25','12:50:00',13.19),('6449','2013-01-25','12:55:00',13.19),('6449','2013-01-25','13:00:00',13.09),('6449','2013-01-25','13:05:00',13.12),('6449','2013-01-25','13:10:00',12.26),('6449','2013-01-25','13:15:00',12.14),('6449','2013-01-25','13:20:00',12.81),('6449','2013-01-25','13:25:00',12.8),('6449','2013-01-25','13:30:00',11.76),('6449','2013-01-25','13:35:00',12.3),('6449','2013-01-25','13:40:00',11.9),('6449','2013-01-25','13:45:00',11.57),('6449','2013-01-25','13:50:00',11.66),('6449','2013-01-25','13:55:00',11.43),('6449','2013-01-25','14:00:00',11.25),('6449','2013-01-25','14:05:00',8.83),('6449','2013-01-25','14:10:00',9.84),('6449','2013-01-25','14:15:00',7.13),('6449','2013-01-25','14:20:00',9.7),('6449','2013-01-25','14:25:00',8.93),('6449','2013-01-25','14:30:00',8.86),('6449','2013-01-25','14:35:00',8.85),('6449','2013-01-25','14:40:00',8.6),('6449','2013-01-25','14:45:00',8.43),('6449','2013-01-25','14:50:00',8.09),('6449','2013-01-25','14:55:00',8.04),('6449','2013-01-25','15:00:00',7.68),('6449','2013-01-25','15:05:00',7.21),('6449','2013-01-25','15:10:00',7.12),('6449','2013-01-25','15:15:00',7.08),('6449','2013-01-25','15:20:00',6.37),('6449','2013-01-25','15:25:00',6.31),('6449','2013-01-25','15:30:00',5.95),('6449','2013-01-25','15:35:00',5.36),('6449','2013-01-25','15:40:00',4.56),('6449','2013-01-25','15:45:00',3.74),('6449','2013-01-25','15:50:00',4.89),('6449','2013-01-25','15:55:00',4.84),('6449','2013-01-25','16:00:00',1.81),('6449','2013-01-25','16:05:00',4.11),('6449','2013-01-25','16:10:00',4.16),('6449','2013-01-25','16:15:00',3.01),('6449','2013-01-25','16:20:00',1.8),('6449','2013-01-24','08:30:00',1.05),('6449','2013-01-24','08:35:00',1.35),('6449','2013-01-24','08:40:00',1.83),('6449','2013-01-24','08:45:00',2.5),('6449','2013-01-24','08:50:00',1.98),('6449','2013-01-24','08:55:00',2.24),('6449','2013-01-24','09:00:00',2.15),('6449','2013-01-24','09:05:00',2.21),('6449','2013-01-24','09:10:00',2.36),('6449','2013-01-24','09:15:00',3.36),('6449','2013-01-24','09:20:00',5.95),('6449','2013-01-24','09:25:00',7.52),('6449','2013-01-24','09:30:00',8.41),('6449','2013-01-24','09:35:00',7.07),('6449','2013-01-24','09:40:00',9.47),('6449','2013-01-24','09:45:00',9.35),('6449','2013-01-24','09:50:00',9.38),('6449','2013-01-24','09:56:00',7.24),('6449','2013-01-24','10:00:00',7.45),('6449','2013-01-24','10:05:00',6.15),('6449','2013-01-24','10:10:00',8.75),('6449','2013-01-24','10:15:00',10.99),('6449','2013-01-24','10:20:00',11.32),('6449','2013-01-24','10:25:00',11.38),('6449','2013-01-24','10:30:00',11.43),('6449','2013-01-24','10:35:00',11.49),('6449','2013-01-24','10:40:00',11.61),('6449','2013-01-24','10:45:00',11.61),('6449','2013-01-24','10:50:00',9.79),('6449','2013-01-24','10:55:00',10.28),('6449','2013-01-24','11:00:00',11.01),('6449','2013-01-24','11:05:00',12.23),('6449','2013-01-24','11:10:00',11.93),('6449','2013-01-24','11:15:00',11.3),('6449','2013-01-24','11:20:00',12.58),('6449','2013-01-24','11:25:00',12.81),('6449','2013-01-24','11:30:00',12.54),('6449','2013-01-24','11:35:00',13.61),('6449','2013-01-24','11:40:00',13.91),('6449','2013-01-24','11:45:00',8.31),('6449','2013-01-24','11:50:00',3.11),('6449','2013-01-24','11:55:00',2.62),('6449','2013-01-24','12:00:00',2.69),('6449','2013-01-24','12:05:00',2.68),('6449','2013-01-24','12:10:00',2.7),('6449','2013-01-24','12:15:00',2.74),('6449','2013-01-24','12:20:00',2.75),('6449','2013-01-24','12:25:00',2.76),('6449','2013-01-24','12:30:00',2.83),('6449','2013-01-24','12:35:00',2.9),('6449','2013-01-24','12:40:00',3.03),('6449','2013-01-24','12:45:00',3.2),('6449','2013-01-24','12:50:00',3.38),('6449','2013-01-24','12:55:00',3.6),('6449','2013-01-24','13:00:00',3.89),('6449','2013-01-24','13:05:00',4.25),('6449','2013-01-24','13:10:00',4.45),('6449','2013-01-24','13:15:00',7.11),('6449','2013-01-24','13:20:00',13.07),('6449','2013-01-24','13:25:00',11.59),('6449','2013-01-24','13:30:00',12.38),('6449','2013-01-24','13:35:00',13.23),('6449','2013-01-24','13:40:00',12.3),('6449','2013-01-24','13:45:00',9.61),('6449','2013-01-24','13:50:00',9.2),('6449','2013-01-24','13:55:00',6.2),('6449','2013-01-24','14:00:00',3.55),('6449','2013-01-24','14:05:00',5.14),('6449','2013-01-24','14:10:00',7.67),('6449','2013-01-24','14:15:00',11.09),('6449','2013-01-24','14:20:00',10.92),('6449','2013-01-24','14:25:00',10.08),('6449','2013-01-24','14:30:00',8.35),('6449','2013-01-24','14:35:00',6.86),('6449','2013-01-24','14:40:00',5.23),('6449','2013-01-24','14:45:00',4.85),('6449','2013-01-24','14:50:00',3.46),('6449','2013-01-24','14:55:00',3.87),('6449','2013-01-24','15:00:00',5.02),('6449','2013-01-24','15:05:00',7.85),('6449','2013-01-24','15:10:00',8.71),('6449','2013-01-24','15:15:00',8.24),('6449','2013-01-24','15:20:00',7.66),('6449','2013-01-24','15:25:00',6.97),('6449','2013-01-24','15:30:00',6.34),('6449','2013-01-24','15:35:00',5.52),('6449','2013-01-24','15:40:00',4.82),('6449','2013-01-24','15:45:00',4.51),('6449','2013-01-24','15:50:00',1.29),('6449','2013-01-24','15:55:00',2.33),('6449','2013-01-24','16:00:00',2.25),('6449','2013-01-24','16:05:00',3.14),('6449','2013-01-24','16:10:00',3.82),('6449','2013-01-24','16:15:00',1.98),('6449','2013-01-23','08:20:00',1.04),('6449','2013-01-23','08:40:00',1.26),('6449','2013-01-23','08:45:00',3.98),('6449','2013-01-23','08:50:00',3.45),('6449','2013-01-23','08:55:00',5.09),('6449','2013-01-23','09:00:00',5.51),('6449','2013-01-23','09:05:00',7.27),('6449','2013-01-23','09:10:00',7.2),('6449','2013-01-23','09:15:00',6.9),('6449','2013-01-23','09:20:00',4.09),('6449','2013-01-23','09:25:00',4.42),('6449','2013-01-23','09:30:00',3.09),('6449','2013-01-23','09:35:00',2.1),('6449','2013-01-23','09:40:00',1.72),('6449','2013-01-23','09:45:00',1.86),('6449','2013-01-23','09:50:00',2.05),('6449','2013-01-23','09:55:00',1.76),('6449','2013-01-23','10:00:00',1.37),('6449','2013-01-23','10:30:00',1.26),('6449','2013-01-23','10:35:00',3.1),('6449','2013-01-23','10:40:00',3.68),('6449','2013-01-23','10:45:00',3.55),('6449','2013-01-23','10:50:00',2.76),('6449','2013-01-23','10:55:00',1.7),('6449','2013-01-23','11:00:00',1.4),('6449','2013-01-23','11:05:00',1.49),('6449','2013-01-23','11:10:00',1.33),('6449','2013-01-23','11:30:00',1.14),('6449','2013-01-23','11:35:00',1.86),('6449','2013-01-23','11:40:00',2.88),('6449','2013-01-23','11:45:00',2.4),('6449','2013-01-23','11:50:00',1.99),('6449','2013-01-23','11:55:00',1.93),('6449','2013-01-23','12:00:00',1.33),('6449','2013-01-23','12:05:00',1.1),('6449','2013-01-23','12:10:00',1.76),('6449','2013-01-23','12:15:00',3.7),('6449','2013-01-23','12:20:00',4.57),('6449','2013-01-23','12:25:00',4.21),('6449','2013-01-23','12:30:00',2.3),('6449','2013-01-23','12:35:00',1.18),('6449','2013-01-23','12:40:00',1.17),('6449','2013-01-23','12:50:00',1.23),('6449','2013-01-23','13:05:00',1.2),('6449','2013-01-23','13:10:00',2.19),('6449','2013-01-23','13:15:00',1.31),('6449','2013-01-23','15:20:00',1.17),('6449','2013-01-23','15:25:00',1.3),('6449','2013-01-23','15:30:00',1.3),('6449','2013-01-23','15:35:00',1.48),('6449','2013-01-23','15:40:00',1.32),('6449','2013-01-23','15:45:00',1.02),('6449','2013-01-22','08:00:00',1.05),('6449','2013-01-22','08:20:00',1.8),('6449','2013-01-22','08:25:00',2.95),('6449','2013-01-22','08:30:00',3.16),('6449','2013-01-22','08:35:00',1.38),('6449','2013-01-22','08:40:00',1.83),('6449','2013-01-22','08:45:00',1.18),('6449','2013-01-22','09:00:00',1.62),('6449','2013-01-22','09:05:00',1.98),('6449','2013-01-22','09:10:00',3.24),('6449','2013-01-22','09:15:00',2.13),('6449','2013-01-22','09:20:00',1.23),('6449','2013-01-22','09:25:00',1.8),('6449','2013-01-22','09:30:00',5.67),('6449','2013-01-22','09:35:00',7.76),('6449','2013-01-22','09:40:00',8.7),('6449','2013-01-22','09:45:00',7.14),('6449','2013-01-22','09:50:00',8.77),('6449','2013-01-22','09:55:00',8.78),('6449','2013-01-22','10:00:00',6.75),('6449','2013-01-22','10:05:00',10.02),('6449','2013-01-22','10:10:00',11.47),('6449','2013-01-22','10:15:00',7.62),('6449','2013-01-22','10:20:00',4.11),('6449','2013-01-22','10:25:00',10.62),('6449','2013-01-22','10:30:00',4.48),('6449','2013-01-22','10:35:00',8.41),('6449','2013-01-22','10:40:00',4.54),('6449','2013-01-22','10:45:00',10.43),('6449','2013-01-22','10:50:00',5.09),('6449','2013-01-22','10:55:00',2.01),('6449','2013-01-22','11:00:00',6.13),('6449','2013-01-22','11:05:00',8.09),('6449','2013-01-22','11:10:00',12.35),('6449','2013-01-22','11:15:00',6.75),('6449','2013-01-22','11:20:00',6.01),('6449','2013-01-22','11:25:00',7.58),('6449','2013-01-22','11:30:00',7.71),('6449','2013-01-22','11:35:00',7.98),('6449','2013-01-22','11:40:00',5.67),('6449','2013-01-22','11:45:00',6.71),('6449','2013-01-22','11:50:00',7.2),('6449','2013-01-22','11:55:00',5.68),('6449','2013-01-22','12:00:00',7.89),('6449','2013-01-22','12:05:00',12.58),('6449','2013-01-22','12:10:00',10.93),('6449','2013-01-22','12:15:00',12.72),('6449','2013-01-22','12:20:00',13.6),('6449','2013-01-22','12:25:00',11.4),('6449','2013-01-22','12:30:00',11.46),('6449','2013-01-22','12:35:00',10.19),('6449','2013-01-22','12:40:00',13.23),('6449','2013-01-22','12:45:00',11.26),('6449','2013-01-22','12:50:00',8.03),('6449','2013-01-22','12:55:00',13.61),('6449','2013-01-22','13:00:00',12.98),('6449','2013-01-22','13:05:00',12.9),('6449','2013-01-22','13:10:00',12.59),('6449','2013-01-22','13:15:00',12.38),('6449','2013-01-22','13:20:00',12.51),('6449','2013-01-22','13:25:00',5.66),('6449','2013-01-22','13:30:00',6.29),('6449','2013-01-22','13:35:00',14.33),('6449','2013-01-22','13:40:00',9.98),('6449','2013-01-22','13:45:00',10.71),('6449','2013-01-22','13:50:00',9.24),('6449','2013-01-22','13:55:00',9.01),('6449','2013-01-22','14:00:00',3.32),('6449','2013-01-22','14:05:00',10.22),('6449','2013-01-22','14:10:00',9.32),('6449','2013-01-22','14:15:00',4.25),('6449','2013-01-22','14:20:00',4.58),('6449','2013-01-22','14:25:00',12.24),('6449','2013-01-22','14:30:00',8.41),('6449','2013-01-22','14:35:00',2.52),('6449','2013-01-22','14:40:00',1.49),('6449','2013-01-22','14:45:00',2.66),('6449','2013-01-22','14:55:00',1.42),('6449','2013-01-22','15:00:00',2.17),('6449','2013-01-22','15:05:00',1.1),('6449','2013-01-21','09:25:00',1.05),('6449','2013-01-21','09:30:00',1.54),('6449','2013-01-21','09:35:00',2.36),('6449','2013-01-21','09:40:00',2.31),('6449','2013-01-21','09:45:00',1.49),('6449','2013-01-21','09:50:00',1.44),('6449','2013-01-21','09:55:00',1.64),('6449','2013-01-21','10:00:00',2.38),('6449','2013-01-21','10:05:00',2.85),('6449','2013-01-21','10:10:00',2.67),('6449','2013-01-21','10:15:00',2.93),('6449','2013-01-21','10:20:00',3.58),('6449','2013-01-21','10:25:00',4.14),('6449','2013-01-21','10:30:00',3.75),('6449','2013-01-21','10:35:00',2.36),('6449','2013-01-21','10:40:00',2.04),('6449','2013-01-21','10:45:00',1.97),('6449','2013-01-21','10:50:00',2.54),('6449','2013-01-21','10:55:00',2.35),('6449','2013-01-21','11:00:00',2.69),('6449','2013-01-21','11:05:00',3.2),('6449','2013-01-21','11:10:00',3.66),('6449','2013-01-21','11:15:00',2.73),('6449','2013-01-21','11:20:00',7.78),('6449','2013-01-21','11:25:00',12.16),('6449','2013-01-21','11:30:00',11.81),('6449','2013-01-21','11:35:00',11.79),('6449','2013-01-21','11:40:00',11.45),('6449','2013-01-21','11:45:00',10.33),('6449','2013-01-21','11:50:00',12.11),('6449','2013-01-21','11:55:00',7.88),('6449','2013-01-21','12:00:00',9.91),('6449','2013-01-21','12:05:00',4.55),('6449','2013-01-21','12:10:00',3.76),('6449','2013-01-21','12:15:00',5.96),('6449','2013-01-21','12:20:00',5.2),('6449','2013-01-21','12:25:00',5.21),('6449','2013-01-21','12:30:00',3.71),('6449','2013-01-21','12:35:00',2.93),('6449','2013-01-21','12:40:00',2.35),('6449','2013-01-21','12:45:00',2.33),('6449','2013-01-21','12:50:00',3.28),('6449','2013-01-21','12:55:00',4.02),('6449','2013-01-21','13:00:00',6.04),('6449','2013-01-21','13:05:00',5.95),('6449','2013-01-21','13:10:00',14.3),('6449','2013-01-21','13:15:00',12.44),('6449','2013-01-21','13:20:00',12.05),('6449','2013-01-21','13:25:00',11.91),('6449','2013-01-21','13:30:00',9.74),('6449','2013-01-21','13:35:00',11.74),('6449','2013-01-21','13:40:00',11.62),('6449','2013-01-21','13:45:00',9.62),('6449','2013-01-21','13:50:00',11.34),('6449','2013-01-21','13:55:00',10.42),('6449','2013-01-21','14:00:00',8.05),('6449','2013-01-21','14:05:00',10.5),('6449','2013-01-21','14:10:00',7.92),('6449','2013-01-21','14:15:00',1.66),('6449','2013-01-21','14:20:00',2.82),('6449','2013-01-21','14:25:00',2.81),('6449','2013-01-21','14:30:00',1.93),('6449','2013-01-21','14:35:00',1.37),('6449','2013-01-21','14:40:00',1.91),('6449','2013-01-21','14:45:00',2.61),('6449','2013-01-21','14:50:00',2.08),('6449','2013-01-21','14:55:00',2.07),('6449','2013-01-21','15:00:00',2.87),('6449','2013-01-21','15:05:00',9.07),('6449','2013-01-21','15:10:00',7.96),('6449','2013-01-21','15:15:00',4.75),('6449','2013-01-21','15:20:00',2.63),('6449','2013-01-21','15:26:00',1.74),('6449','2013-01-21','15:30:00',1.38),('6449','2013-01-21','15:35:00',1.26),('6449','2013-01-21','15:40:00',1.04),('6449','2013-01-20','09:45:00',1.04),('6449','2013-01-20','10:05:00',1.18),('6449','2013-01-20','10:10:00',1.28),('6449','2013-01-20','10:15:00',1.36),('6449','2013-01-20','10:20:00',1.65),('6449','2013-01-20','10:25:00',1.73),('6449','2013-01-20','10:30:00',1.96),('6449','2013-01-20','10:35:00',2.26),('6449','2013-01-20','10:40:00',2.62),('6449','2013-01-20','10:45:00',2.29),('6449','2013-01-20','10:50:00',2.41),('6449','2013-01-20','10:55:00',2.04),('6449','2013-01-20','11:00:00',2.12),('6449','2013-01-20','11:05:00',2.46),('6449','2013-01-20','11:10:00',2.31),('6449','2013-01-20','11:15:00',2.24),('6449','2013-01-20','11:20:00',2.47),('6449','2013-01-20','11:25:00',2.77),('6449','2013-01-20','11:30:00',2.28),('6449','2013-01-20','11:35:00',2.13),('6449','2013-01-20','11:40:00',2.16),('6449','2013-01-20','11:45:00',2.13),('6449','2013-01-20','11:50:00',2.03),('6449','2013-01-20','11:55:00',2.04),('6449','2013-01-20','12:00:00',1.92),('6449','2013-01-20','12:05:00',1.62),('6449','2013-01-20','12:10:00',1.76),('6449','2013-01-20','12:15:00',2.1),('6449','2013-01-20','12:20:00',2.02),('6449','2013-01-20','12:25:00',2.11),('6449','2013-01-20','12:30:00',2.06),('6449','2013-01-20','12:35:00',2.02),('6449','2013-01-20','12:40:00',2.2),('6449','2013-01-20','12:45:00',2.29),('6449','2013-01-20','12:50:00',2.15),('6449','2013-01-20','12:55:00',1.96),('6449','2013-01-20','13:00:00',1.63),('6449','2013-01-20','13:05:00',1.46),('6449','2013-01-20','13:10:00',1.75),('6449','2013-01-20','13:15:00',1.79),('6449','2013-01-20','13:20:00',2),('6449','2013-01-20','13:25:00',2.48),('6449','2013-01-20','13:30:00',2.44),('6449','2013-01-20','13:35:00',2.18),('6449','2013-01-20','13:40:00',2.13),('6449','2013-01-20','13:45:00',2.08),('6449','2013-01-20','13:50:00',1.87),('6449','2013-01-20','13:55:00',1.73),('6449','2013-01-20','14:00:00',1.35),('6449','2013-01-20','14:05:00',1.15),('6449','2013-01-20','14:10:00',1.17),('6449','2013-01-20','14:15:00',1.38),('6449','2013-01-20','14:20:00',1.22),('6449','2013-01-19','08:30:00',1.15),('6449','2013-01-19','08:35:00',1.27),('6449','2013-01-19','08:40:00',1.36),('6449','2013-01-19','08:45:00',1.64),('6449','2013-01-19','08:50:00',2.12),('6449','2013-01-19','08:55:00',2.66),('6449','2013-01-19','09:00:00',2.85),('6449','2013-01-19','09:05:00',1.91),('6449','2013-01-19','09:10:00',1.55),('6449','2013-01-19','09:15:00',1.38),('6449','2013-01-19','09:20:00',1.42),('6449','2013-01-19','09:25:00',1.86),('6449','2013-01-19','09:30:00',2.82),('6449','2013-01-19','09:35:00',3.79),('6449','2013-01-19','09:40:00',4.26),('6449','2013-01-19','09:45:00',3.61),('6449','2013-01-19','09:50:00',2.35),('6449','2013-01-19','09:55:00',1.61),('6449','2013-01-19','10:00:00',1.18),('6449','2013-01-19','10:05:00',1.24),('6449','2013-01-19','10:10:00',1.4),('6449','2013-01-19','10:15:00',2.25),('6449','2013-01-19','10:20:00',2.41),('6449','2013-01-19','10:25:00',1.99),('6449','2013-01-19','10:30:00',1.51),('6449','2013-01-19','10:35:00',1.27),('6449','2013-01-19','10:40:00',1.53),('6449','2013-01-19','10:45:00',1.64),('6449','2013-01-19','10:50:00',1.87),('6449','2013-01-19','10:55:00',2.56),('6449','2013-01-19','11:00:00',2.96),('6449','2013-01-19','11:05:00',2.93),('6449','2013-01-19','11:10:00',2.54),('6449','2013-01-19','11:15:00',1.88),('6449','2013-01-19','11:20:00',1.7),('6449','2013-01-19','11:25:00',1.67),('6449','2013-01-19','11:30:00',1.63),('6449','2013-01-19','11:35:00',2.57),('6449','2013-01-19','11:40:00',2.91),('6449','2013-01-19','11:45:00',2.87),('6449','2013-01-19','11:50:00',2.3),('6449','2013-01-19','11:55:00',2.12),('6449','2013-01-19','12:00:00',2.04),('6449','2013-01-19','12:05:00',1.49),('6449','2013-01-19','12:10:00',1.76),('6449','2013-01-19','12:15:00',1.45),('6449','2013-01-19','12:20:00',1.4),('6449','2013-01-19','12:25:00',1.58),('6449','2013-01-19','12:30:00',1.58),('6449','2013-01-19','12:35:00',1.3),('6449','2013-01-19','12:40:00',1.46),('6449','2013-01-19','12:45:00',1.33),('6449','2013-01-19','12:50:00',1.21),('6449','2013-01-19','12:55:00',1.41),('6449','2013-01-19','13:00:00',1.34),('6449','2013-01-19','13:05:00',1.06),('6449','2013-01-19','13:55:00',1.02),('6449','2013-01-19','14:00:00',1.47),('6449','2013-01-19','14:05:00',1.97),('6449','2013-01-19','14:10:00',1.96),('6449','2013-01-19','14:15:00',1.42),('6449','2013-01-19','14:20:00',1.37),('6449','2013-01-19','14:25:00',1.37),('6449','2013-01-19','14:30:00',1.26),('6449','2013-01-19','14:35:00',1.42),('6449','2013-01-19','14:40:00',1.6),('6449','2013-01-19','14:45:00',1.74),('6449','2013-01-19','14:50:00',2.22),('6449','2013-01-19','14:55:00',1.78),('6449','2013-01-19','15:00:00',1.07),('6449','2013-01-18','09:30:00',1.21),('6449','2013-01-18','09:35:00',1.51),('6449','2013-01-18','09:40:00',1.92),('6449','2013-01-18','09:45:00',2.15),('6449','2013-01-18','09:50:00',2.15),('6449','2013-01-18','09:55:00',2.53),('6449','2013-01-18','10:00:00',3.69),('6449','2013-01-18','10:05:00',5.76),('6449','2013-01-18','10:10:00',3.62),('6449','2013-01-18','10:15:00',2.35),('6449','2013-01-18','10:20:00',1.8),('6449','2013-01-18','10:25:00',1.62),('6449','2013-01-18','10:30:00',1.75),('6449','2013-01-18','10:35:00',2.17),('6449','2013-01-18','10:40:00',2.54),('6449','2013-01-18','10:45:00',2.78),('6449','2013-01-18','10:50:00',3.22),('6449','2013-01-18','10:55:00',3.54),('6449','2013-01-18','11:00:00',4.5),('6449','2013-01-18','11:05:00',5.37),('6449','2013-01-18','11:10:00',4.91),('6449','2013-01-18','11:15:00',5.04),('6449','2013-01-18','11:20:00',4.23),('6449','2013-01-18','11:25:00',4.23),('6449','2013-01-18','11:30:00',4.59),('6449','2013-01-18','11:35:00',5.13),('6449','2013-01-18','11:40:00',4.7),('6449','2013-01-18','11:45:00',4.9),('6449','2013-01-18','11:50:00',5.79),('6449','2013-01-18','11:55:00',6.72),('6449','2013-01-18','12:00:00',7.04),('6449','2013-01-18','12:05:00',7.55),('6449','2013-01-18','12:10:00',8.57),('6449','2013-01-18','12:15:00',7.68),('6449','2013-01-18','12:20:00',5.18),('6449','2013-01-18','12:25:00',5),('6449','2013-01-18','12:30:00',5.33),('6449','2013-01-18','12:35:00',5.91),('6449','2013-01-18','12:40:00',5.65),('6449','2013-01-18','12:45:00',5.45),('6449','2013-01-18','12:50:00',10.97),('6449','2013-01-18','12:55:00',8.93),('6449','2013-01-18','13:00:00',6.22),('6449','2013-01-18','13:05:00',7.09),('6449','2013-01-18','13:10:00',7.16),('6449','2013-01-18','13:15:00',6.63),('6449','2013-01-18','13:20:00',5.93),('6449','2013-01-18','13:25:00',4.17),('6449','2013-01-18','13:30:00',8.73),('6449','2013-01-18','13:35:00',11.35),('6449','2013-01-18','13:40:00',11.17),('6449','2013-01-18','13:45:00',10.84),('6449','2013-01-18','13:50:00',10.22),('6449','2013-01-18','13:55:00',9.92),('6449','2013-01-18','14:00:00',9.92),('6449','2013-01-18','14:05:00',9.95),('6449','2013-01-18','14:10:00',10.33),('6449','2013-01-18','14:15:00',10.79),('6449','2013-01-18','14:20:00',10.67),('6449','2013-01-18','14:25:00',10.7),('6449','2013-01-18','14:30:00',9.79),('6449','2013-01-18','14:35:00',7.01),('6449','2013-01-18','14:40:00',4.96),('6449','2013-01-18','14:45:00',5.96),('6449','2013-01-18','14:50:00',5.15),('6449','2013-01-18','14:55:00',3.24),('6449','2013-01-18','15:00:00',3.7),('6449','2013-01-18','15:05:00',7.39),('6449','2013-01-18','15:10:00',7.99),('6449','2013-01-18','15:15:00',6.6),('6449','2013-01-18','15:20:00',6.11),('6449','2013-01-18','15:25:00',5.4),('6449','2013-01-18','15:30:00',5.48),('6449','2013-01-18','15:35:00',4.92),('6449','2013-01-18','15:40:00',4.58),('6449','2013-01-18','15:45:00',3.95),('6449','2013-01-18','15:50:00',3.49),('6449','2013-01-18','15:55:00',3.13),('6449','2013-01-18','16:00:00',2.83),('6449','2013-01-18','16:05:00',2.47),('6449','2013-01-18','16:10:00',2.23),('6449','2013-01-18','16:15:00',1.96),('6449','2013-01-18','16:20:00',1.75),('6449','2013-01-18','16:25:00',1.56),('6449','2013-01-18','16:30:00',1.41),('6449','2013-01-18','16:35:00',1.11),('6449','2013-01-17','08:40:00',1.02),('6449','2013-01-17','08:45:00',1.14),('6449','2013-01-17','08:50:00',1.17),('6449','2013-01-17','08:55:00',1.24),('6449','2013-01-17','09:00:00',1.32),('6449','2013-01-17','09:05:00',1.44),('6449','2013-01-17','09:10:00',1.67),('6449','2013-01-17','09:15:00',2.06),('6449','2013-01-17','09:20:00',2.86),('6449','2013-01-17','09:25:00',3.39),('6449','2013-01-17','09:30:00',3.49),('6449','2013-01-17','09:35:00',3.6),('6449','2013-01-17','09:40:00',3.96),('6449','2013-01-17','09:45:00',4.55),('6449','2013-01-17','09:50:00',4.18),('6449','2013-01-17','09:55:00',3.73),('6449','2013-01-17','10:00:00',3.6),('6449','2013-01-17','10:05:00',4.1),('6449','2013-01-17','10:10:00',4.57),('6449','2013-01-17','10:15:00',5.04),('6449','2013-01-17','10:20:00',5.29),('6449','2013-01-17','10:25:00',4.9),('6449','2013-01-17','10:30:00',5.77),('6449','2013-01-17','10:35:00',5.99),('6449','2013-01-17','10:40:00',6.13),('6449','2013-01-17','10:45:00',6.1),('6449','2013-01-17','10:50:00',6.1),('6449','2013-01-17','10:55:00',8.57),('6449','2013-01-17','11:00:00',10.01),('6449','2013-01-17','11:05:00',9.08),('6449','2013-01-17','11:10:00',8.29),('6449','2013-01-17','11:15:00',9.89),('6449','2013-01-17','11:20:00',10.19),('6449','2013-01-17','11:25:00',9.61),('6449','2013-01-17','11:30:00',10.8),('6449','2013-01-17','11:35:00',10.16),('6449','2013-01-17','11:40:00',9.62),('6449','2013-01-17','11:45:00',10.44),('6449','2013-01-17','11:50:00',8.7),('6449','2013-01-17','11:55:00',8.09),('6449','2013-01-17','12:00:00',9.42),('6449','2013-01-17','12:05:00',8.86),('6449','2013-01-17','12:10:00',7.03),('6449','2013-01-17','12:15:00',8.31),('6449','2013-01-17','12:20:00',9.33),('6449','2013-01-17','12:25:00',8.76),('6449','2013-01-17','12:30:00',10.14),('6449','2013-01-17','12:35:00',9.17),('6449','2013-01-17','12:40:00',3.93),('6449','2013-01-17','12:45:00',5.83),('6449','2013-01-17','12:50:00',7.16),('6449','2013-01-17','12:55:00',8.97),('6449','2013-01-17','13:00:00',8.22),('6449','2013-01-17','13:05:00',8.22),('6449','2013-01-17','13:10:00',3.84),('6449','2013-01-17','13:15:00',4.7),('6449','2013-01-17','13:20:00',9.64),('6449','2013-01-17','13:25:00',3.39),('6449','2013-01-17','13:30:00',3.71),('6449','2013-01-17','13:35:00',5.51),('6449','2013-01-17','13:40:00',9.66),('6449','2013-01-17','13:45:00',6.17),('6449','2013-01-17','13:50:00',9.18),('6449','2013-01-17','13:55:00',10.94),('6449','2013-01-17','14:00:00',7.97),('6449','2013-01-17','14:05:00',5.77),('6449','2013-01-17','14:10:00',7.47),('6449','2013-01-17','14:15:00',8.19),('6449','2013-01-17','14:20:00',6.03),('6449','2013-01-17','14:25:00',3.3),('6449','2013-01-17','14:30:00',2.96),('6449','2013-01-17','14:35:00',2.95),('6449','2013-01-17','14:40:00',2.64),('6449','2013-01-17','14:45:00',2.91),('6449','2013-01-17','14:50:00',3.17),('6449','2013-01-17','14:55:00',2.92),('6449','2013-01-17','15:00:00',2.4),('6449','2013-01-17','15:05:00',2.43),('6449','2013-01-17','15:10:00',2.2),('6449','2013-01-17','15:15:00',2.05),('6449','2013-01-17','15:20:00',1.71),('6449','2013-01-17','15:25:00',1.41),('6449','2013-01-17','15:30:00',1.25),('6449','2013-01-17','15:35:00',1.17),('6449','2013-01-17','15:40:00',1.03),('6449','2013-01-17','15:50:00',1),('6449','2013-01-16','08:30:00',1.16),('6449','2013-01-16','08:35:00',1.22),('6449','2013-01-16','08:40:00',1.35),('6449','2013-01-16','08:45:00',2.02),('6449','2013-01-16','08:50:00',1.83),('6449','2013-01-16','08:55:00',1.19),('6449','2013-01-16','09:00:00',1.78),('6449','2013-01-16','09:05:00',1.57),('6449','2013-01-16','09:15:00',1.51),('6449','2013-01-16','09:20:00',1.98),('6449','2013-01-16','09:25:00',1.31),('6449','2013-01-16','09:30:00',1.03),('6449','2013-01-16','09:45:00',1.68),('6449','2013-01-16','09:50:00',7.13),('6449','2013-01-16','09:55:00',5.04),('6449','2013-01-16','10:00:00',1.41),('6449','2013-01-16','10:05:00',1.91),('6449','2013-01-16','10:10:00',10.67),('6449','2013-01-16','10:15:00',11.33),('6449','2013-01-16','10:20:00',8.26),('6449','2013-01-16','10:25:00',5.92),('6449','2013-01-16','10:30:00',10.8),('6449','2013-01-16','10:35:00',9.25),('6449','2013-01-16','10:40:00',1.47),('6449','2013-01-16','10:45:00',1.16),('6449','2013-01-16','10:50:00',1.8),('6449','2013-01-16','10:55:00',2.61),('6449','2013-01-16','11:00:00',3.22),('6449','2013-01-16','11:05:00',6.63),('6449','2013-01-16','11:10:00',3.03),('6449','2013-01-16','11:15:00',3.12),('6449','2013-01-16','11:20:00',3.02),('6449','2013-01-16','11:25:00',2.84),('6449','2013-01-16','11:30:00',2.43),('6449','2013-01-16','11:35:00',2.52),('6449','2013-01-16','11:40:00',3.71),('6449','2013-01-16','11:45:00',3.23),('6449','2013-01-16','11:50:00',3.35),('6449','2013-01-16','11:55:00',7.42),('6449','2013-01-16','12:00:00',1.1),('6449','2013-01-16','12:10:00',1.48),('6449','2013-01-16','12:15:00',2.12),('6449','2013-01-16','12:20:00',1.63),('6449','2013-01-16','12:25:00',1.48),('6449','2013-01-16','12:55:00',1.41),('6449','2013-01-16','13:00:00',2.44),('6449','2013-01-16','13:05:00',1.45),('6449','2013-01-16','13:10:00',1.07),('6449','2013-01-16','13:30:00',1.37),('6449','2013-01-16','13:35:00',2),('6449','2013-01-16','13:40:00',1.72),('6449','2013-01-16','13:45:00',2.23),('6449','2013-01-16','13:50:00',2.2),('6449','2013-01-16','14:05:00',1.49),('6449','2013-01-16','14:10:00',6.43),('6449','2013-01-16','14:15:00',4.91),('6449','2013-01-16','14:20:00',2.6),('6449','2013-01-16','14:25:00',3.04),('6449','2013-01-16','14:30:00',3.81),('6449','2013-01-16','14:35:00',10),('6449','2013-01-16','14:40:00',5.11),('6449','2013-01-16','14:45:00',1.88),('6449','2013-01-16','14:50:00',1.26),('6449','2013-01-16','15:15:00',1.14),('6449','2013-01-16','15:20:00',4.12),('6449','2013-01-16','15:25:00',6.62),('6449','2013-01-16','15:30:00',5.6),('6449','2013-01-16','15:35:00',4.09),('6449','2013-01-16','15:40:00',4.38),('6449','2013-01-16','15:45:00',4.15),('6449','2013-01-16','15:50:00',3.64),('6449','2013-01-16','15:55:00',3.26),('6449','2013-01-16','16:00:00',1.23),('6449','2013-01-15','08:25:00',1.84),('6449','2013-01-15','08:30:00',1.03),('6449','2013-01-15','08:35:00',3.84),('6449','2013-01-15','08:40:00',4.2),('6449','2013-01-15','08:45:00',4.73),('6449','2013-01-15','08:50:00',5.07),('6449','2013-01-15','08:55:00',5.1),('6449','2013-01-15','09:00:00',5.33),('6449','2013-01-15','09:05:00',5.71),('6449','2013-01-15','09:10:00',5.96),('6449','2013-01-15','09:15:00',6.29),('6449','2013-01-15','09:20:00',6.59),('6449','2013-01-15','09:25:00',6.86),('6449','2013-01-15','09:30:00',7.22),('6449','2013-01-15','09:35:00',7.55),('6449','2013-01-15','09:40:00',7.86),('6449','2013-01-15','09:45:00',4.76),('6449','2013-01-15','09:50:00',2.49),('6449','2013-01-15','09:55:00',2.01),('6449','2013-01-15','10:00:00',6.21),('6449','2013-01-15','10:05:00',3.17),('6449','2013-01-15','10:10:00',1.14),('6449','2013-01-15','10:15:00',1.87),('6449','2013-01-15','10:20:00',4.05),('6449','2013-01-15','10:25:00',3.34),('6449','2013-01-15','10:30:00',3.12),('6449','2013-01-15','10:35:00',7.95),('6449','2013-01-15','10:40:00',8.87),('6449','2013-01-15','10:45:00',3.5),('6449','2013-01-15','10:50:00',3.98),('6449','2013-01-15','10:55:00',5.35),('6449','2013-01-15','11:00:00',4.62),('6449','2013-01-15','11:05:00',4.95),('6449','2013-01-15','11:10:00',6.02),('6449','2013-01-15','11:15:00',6.67),('6449','2013-01-15','11:20:00',6.62),('6449','2013-01-15','11:25:00',7.26),('6449','2013-01-15','11:30:00',7.1),('6449','2013-01-15','11:35:00',7.65),('6449','2013-01-15','11:40:00',8.41),('6449','2013-01-15','11:45:00',10.04),('6449','2013-01-15','11:50:00',8.7),('6449','2013-01-15','11:55:00',7.34),('6449','2013-01-15','12:00:00',5.51),('6449','2013-01-15','12:05:00',5.39),('6449','2013-01-15','12:10:00',5.83),('6449','2013-01-15','12:15:00',5.6),('6449','2013-01-15','12:20:00',5.51),('6449','2013-01-15','12:25:00',5.43),('6449','2013-01-15','12:30:00',5.64),('6449','2013-01-15','12:35:00',5.71),('6449','2013-01-15','12:40:00',6.06),('6449','2013-01-15','12:45:00',6.14),('6449','2013-01-15','12:50:00',6.31),('6449','2013-01-15','12:55:00',5.92),('6449','2013-01-15','13:00:00',6.8),('6449','2013-01-15','13:05:00',6.47),('6449','2013-01-15','13:10:00',7.04),('6449','2013-01-15','13:15:00',6.99),('6449','2013-01-15','13:20:00',6.32),('6449','2013-01-15','13:25:00',6.78),('6449','2013-01-15','13:30:00',7.44),('6449','2013-01-15','13:35:00',10.13),('6449','2013-01-15','13:40:00',8.69),('6449','2013-01-15','13:45:00',9.16),('6449','2013-01-15','13:50:00',7.97),('6449','2013-01-15','13:55:00',6.92),('6449','2013-01-15','14:00:00',6.87),('6449','2013-01-15','14:05:00',4.98),('6449','2013-01-15','14:10:00',4.92),('6449','2013-01-15','14:15:00',6.72),('6449','2013-01-15','14:20:00',9.4),('6449','2013-01-15','14:25:00',5.7),('6449','2013-01-15','14:30:00',5.19),('6449','2013-01-15','14:35:00',8.3),('6449','2013-01-15','14:40:00',7.63),('6449','2013-01-15','14:45:00',6.86),('6449','2013-01-15','14:50:00',7.19),('6449','2013-01-15','14:55:00',6.94),('6449','2013-01-15','15:00:00',6.49),('6449','2013-01-15','15:05:00',6.17),('6449','2013-01-15','15:10:00',6.01),('6449','2013-01-15','15:15:00',5.77),('6449','2013-01-15','15:20:00',5.38),('6449','2013-01-15','15:25:00',5.09),('6449','2013-01-15','15:30:00',4.89),('6449','2013-01-15','15:35:00',4.68),('6449','2013-01-15','15:40:00',4.31),('6449','2013-01-15','15:45:00',4.07),('6449','2013-01-15','15:50:00',3.86),('6449','2013-01-15','15:55:00',3.63),('6449','2013-01-15','16:00:00',3.44),('6449','2013-01-15','16:05:00',3.19),('6449','2013-01-15','16:10:00',2.89),('6449','2013-01-15','16:15:00',2.56),('6449','2013-01-15','16:20:00',2.23),('6449','2013-01-15','16:25:00',1.89),('6449','2013-01-15','16:30:00',1.45),('6449','2013-01-14','10:00:00',1.11),('6449','2013-01-14','10:05:00',1.79),('6449','2013-01-14','10:10:00',1.25),('6449','2013-01-14','10:15:00',1.1),('6449','2013-01-14','10:20:00',1.23),('6449','2013-01-14','10:25:00',1.62),('6449','2013-01-14','10:30:00',1.62),('6449','2013-01-14','10:35:00',1.34),('6449','2013-01-14','10:40:00',1.41),('6449','2013-01-14','10:45:00',1.19),('6449','2013-01-14','10:50:00',1.62),('6449','2013-01-14','10:55:00',1.76),('6449','2013-01-14','11:00:00',2.04),('6449','2013-01-14','11:05:00',1.84),('6449','2013-01-14','11:10:00',1.48),('6449','2013-01-14','11:15:00',1.55),('6449','2013-01-14','11:20:00',1.73),('6449','2013-01-14','11:25:00',1.14),('6449','2013-01-14','12:00:00',1.32),('6449','2013-01-14','12:05:00',1.31),('6449','2013-01-14','12:10:00',1.31),('6449','2013-01-14','12:15:00',1.25),('6449','2013-01-14','12:20:00',1.11),('6449','2013-01-14','12:25:00',1.14),('6449','2013-01-14','12:50:00',1.04),('6449','2013-01-14','12:55:00',1.56),('6449','2013-01-14','13:00:00',1.53),('6449','2013-01-14','13:05:00',1.41),('6449','2013-01-14','13:10:00',1.52),('6449','2013-01-14','13:15:00',1.48),('6449','2013-01-14','13:20:00',1.21),('6449','2013-01-14','13:25:00',1.56),('6449','2013-01-14','13:30:00',1.6),('6449','2013-01-14','13:35:00',1.6),('6449','2013-01-14','13:40:00',1.49),('6449','2013-01-14','13:45:00',1.41),('6449','2013-01-14','13:50:00',1.09),('6449','2013-01-14','13:55:00',1.07),('6449','2013-01-14','14:00:00',1.65),('6449','2013-01-14','14:05:00',1.86),('6449','2013-01-14','14:10:00',1.09),('6449','2013-01-14','15:10:00',1.09),('6449','2013-01-13','08:35:00',1.21),('6449','2013-01-13','08:40:00',1.28),('6449','2013-01-13','08:45:00',1.27),('6449','2013-01-13','08:50:00',1.8),('6449','2013-01-13','08:55:00',2.12),('6449','2013-01-13','09:00:00',1.15),('6449','2013-01-13','09:20:00',1.09),('6449','2013-01-13','09:25:00',1.47),('6449','2013-01-13','09:30:00',1.52),('6449','2013-01-13','09:35:00',2.09),('6449','2013-01-13','09:40:00',2.95),('6449','2013-01-13','09:45:00',1.94),('6449','2013-01-13','09:50:00',3.09),('6449','2013-01-13','09:55:00',9.13),('6449','2013-01-13','10:00:00',5.45),('6449','2013-01-13','10:05:00',6.58),('6449','2013-01-13','10:10:00',7.68),('6449','2013-01-13','10:15:00',3.22),('6449','2013-01-13','10:20:00',1.15),('6449','2013-01-13','10:25:00',1.46),('6449','2013-01-13','10:30:00',1.4),('6449','2013-01-13','10:35:00',1.75),('6449','2013-01-13','10:40:00',1.88),('6449','2013-01-13','10:45:00',1.66),('6449','2013-01-13','10:50:00',1.46),('6449','2013-01-13','10:55:00',1.58),('6449','2013-01-13','11:00:00',1.56),('6449','2013-01-13','11:05:00',2.27),('6449','2013-01-13','11:10:00',3.17),('6449','2013-01-13','11:15:00',2.38),('6449','2013-01-13','11:20:00',1.24),('6449','2013-01-13','11:25:00',1.17),('6449','2013-01-13','11:30:00',1.32),('6449','2013-01-13','11:35:00',1.38),('6449','2013-01-13','11:50:00',1.42),('6449','2013-01-13','11:55:00',1.23),('6449','2013-01-13','12:00:00',1.28),('6449','2013-01-13','12:05:00',1.39),('6449','2013-01-13','12:25:00',1.07),('6449','2013-01-13','12:30:00',1.38),('6449','2013-01-13','12:35:00',1.45),('6449','2013-01-13','12:40:00',1.21),('6449','2013-01-13','14:55:00',1.03),('6449','2013-01-13','15:00:00',1.07),('6449','2013-01-13','15:05:00',1.35),('6449','2013-01-13','15:25:00',1.03),('6449','2013-01-13','15:30:00',1.06),('6449','2013-01-12','07:55:00',1.2),('6449','2013-01-12','08:00:00',1.56),('6449','2013-01-12','08:05:00',1.91),('6449','2013-01-12','08:10:00',2.25),('6449','2013-01-12','08:15:00',2.57),('6449','2013-01-12','08:20:00',2.89),('6449','2013-01-12','08:25:00',3.2),('6449','2013-01-12','08:30:00',3.53),('6449','2013-01-12','08:35:00',3.85),('6449','2013-01-12','08:40:00',4.16),('6449','2013-01-12','08:45:00',4.45),('6449','2013-01-12','08:50:00',4.72),('6449','2013-01-12','08:55:00',5.01),('6449','2013-01-12','09:00:00',5.29),('6449','2013-01-12','09:05:00',5.56),('6449','2013-01-12','09:10:00',5.73),('6449','2013-01-12','09:15:00',6.08),('6449','2013-01-12','09:20:00',6.39),('6449','2013-01-12','09:25:00',6.65),('6449','2013-01-12','09:30:00',7),('6449','2013-01-12','09:35:00',7.29),('6449','2013-01-12','09:40:00',7.5),('6449','2013-01-12','09:45:00',7.81),('6449','2013-01-12','09:50:00',8.08),('6449','2013-01-12','09:55:00',8.29),('6449','2013-01-12','10:00:00',8.48),('6449','2013-01-12','10:05:00',8.69),('6449','2013-01-12','10:10:00',8.89),('6449','2013-01-12','10:15:00',9.08),('6449','2013-01-12','10:20:00',9.32),('6449','2013-01-12','10:25:00',9.5),('6449','2013-01-12','10:30:00',9.73),('6449','2013-01-12','10:35:00',9.95),('6449','2013-01-12','10:40:00',10.11),('6449','2013-01-12','10:45:00',10.3),('6449','2013-01-12','10:50:00',10.48),('6449','2013-01-12','10:55:00',10.46),('6449','2013-01-12','11:00:00',10.75),('6449','2013-01-12','11:05:00',10.82),('6449','2013-01-12','11:10:00',10.85),('6449','2013-01-12','11:15:00',11.05),('6449','2013-01-12','11:20:00',11.15),('6449','2013-01-12','11:25:00',11.05),('6449','2013-01-12','11:30:00',11.26),('6449','2013-01-12','11:35:00',11.33),('6449','2013-01-12','11:40:00',11.32),('6449','2013-01-12','11:45:00',11.45),('6449','2013-01-12','11:50:00',11.49),('6449','2013-01-12','11:55:00',11.5),('6449','2013-01-12','12:00:00',11.57),('6449','2013-01-12','12:05:00',11.53),('6449','2013-01-12','12:10:00',11.52),('6449','2013-01-12','12:15:00',11.3),('6449','2013-01-12','12:20:00',11.39),('6449','2013-01-12','12:25:00',11.4),('6449','2013-01-12','12:30:00',11.17),('6449','2013-01-12','12:35:00',11),('6449','2013-01-12','12:40:00',10.82),('6449','2013-01-12','12:45:00',10.69),('6449','2013-01-12','12:50:00',10.52),('6449','2013-01-12','12:55:00',10.44),('6449','2013-01-12','13:00:00',10.74),('6449','2013-01-12','13:05:00',10.67),('6449','2013-01-12','13:10:00',10.55),('6449','2013-01-12','13:15:00',10.52),('6449','2013-01-12','13:20:00',10.45),('6449','2013-01-12','13:25:00',10.18),('6449','2013-01-12','13:30:00',10.08),('6449','2013-01-12','13:35:00',9.96),('6449','2013-01-12','13:40:00',9.8),('6449','2013-01-12','13:45:00',9.61),('6449','2013-01-12','13:50:00',9.37),('6449','2013-01-12','13:55:00',9.3),('6449','2013-01-12','14:00:00',9.12),('6449','2013-01-12','14:05:00',8.94),('6449','2013-01-12','14:10:00',8.75),('6449','2013-01-12','14:15:00',8.63),('6449','2013-01-12','14:20:00',8.37),('6449','2013-01-12','14:25:00',7.96),('6449','2013-01-12','14:30:00',7.77),('6449','2013-01-12','14:35:00',7.54),('6449','2013-01-12','14:40:00',7.27),('6449','2013-01-12','14:45:00',7.02),('6449','2013-01-12','14:50:00',6.67),('6449','2013-01-12','14:55:00',6.48),('6449','2013-01-12','15:00:00',6.04),('6449','2013-01-12','15:05:00',5.78),('6449','2013-01-12','15:10:00',5.56),('6449','2013-01-12','15:15:00',5.31),('6449','2013-01-12','15:20:00',4.9),('6449','2013-01-12','15:25:00',4.63),('6449','2013-01-12','15:30:00',4.24),('6449','2013-01-12','15:36:00',3.99),('6449','2013-01-12','15:40:00',3.51),('6449','2013-01-12','15:45:00',3.3),('6449','2013-01-12','15:50:00',2.84),('6449','2013-01-12','15:55:00',2.05),('6449','2013-01-12','16:00:00',1.45),('6449','2013-01-12','16:05:00',1.32),('6449','2013-01-11','08:40:00',1.06),('6449','2013-01-11','08:45:00',1.1),('6449','2013-01-11','08:50:00',1.13),('6449','2013-01-11','08:55:00',1.25),('6449','2013-01-11','09:00:00',1.31),('6449','2013-01-11','09:05:00',1.5),('6449','2013-01-11','09:10:00',1.66),('6449','2013-01-11','09:15:00',1.79),('6449','2013-01-11','09:20:00',4.61),('6449','2013-01-11','09:25:00',6.15),('6449','2013-01-11','09:30:00',6.1),('6449','2013-01-11','09:35:00',4.6),('6449','2013-01-11','09:40:00',1.65),('6449','2013-01-11','09:45:00',4.12),('6449','2013-01-11','09:50:00',6.92),('6449','2013-01-11','09:55:00',7.36),('6449','2013-01-11','10:00:00',7.12),('6449','2013-01-11','10:05:00',6.56),('6449','2013-01-11','10:10:00',5.19),('6449','2013-01-11','10:15:00',3.77),('6449','2013-01-11','10:20:00',4.44),('6449','2013-01-11','10:25:00',5.09),('6449','2013-01-11','10:30:00',5.59),('6449','2013-01-11','10:35:00',7.86),('6449','2013-01-11','10:40:00',8.62),('6449','2013-01-11','10:45:00',8.78),('6449','2013-01-11','10:50:00',9.17),('6449','2013-01-11','10:55:00',9.57),('6449','2013-01-11','11:00:00',9.89),('6449','2013-01-11','11:05:00',10.17),('6449','2013-01-11','11:10:00',9.97),('6449','2013-01-11','11:15:00',10.46),('6449','2013-01-11','11:20:00',7.89),('6449','2013-01-11','11:25:00',5.18),('6449','2013-01-11','11:30:00',3.91),('6449','2013-01-11','11:35:00',3.14),('6449','2013-01-11','11:40:00',2.96),('6449','2013-01-11','11:45:00',3.67),('6449','2013-01-11','11:50:00',3.55),('6449','2013-01-11','11:55:00',3.21),('6449','2013-01-11','12:00:00',1.99),('6449','2013-01-11','12:05:00',1.92),('6449','2013-01-11','12:10:00',1.69),('6449','2013-01-11','12:15:00',1.9),('6449','2013-01-11','12:20:00',2.81),('6449','2013-01-11','12:25:00',6.39),('6449','2013-01-11','12:30:00',3.39),('6449','2013-01-11','12:35:00',3.47),('6449','2013-01-11','12:40:00',3.15),('6449','2013-01-11','12:45:00',2.11),('6449','2013-01-11','12:50:00',1.36),('6449','2013-01-11','12:55:00',1.38),('6449','2013-01-11','13:05:00',1.52),('6449','2013-01-11','13:10:00',2.29),('6449','2013-01-11','13:15:00',8.89),('6449','2013-01-11','13:20:00',9.1),('6449','2013-01-11','13:25:00',9.11),('6449','2013-01-11','13:30:00',5.75),('6449','2013-01-11','13:35:00',3.34),('6449','2013-01-11','13:40:00',2.03),('6449','2013-01-11','14:00:00',1.45),('6449','2013-01-11','14:05:00',1.6),('6449','2013-01-11','14:10:00',2.81),('6449','2013-01-11','14:15:00',5.11),('6449','2013-01-11','14:20:00',9.41),('6449','2013-01-11','14:25:00',5.67),('6449','2013-01-11','14:30:00',5.94),('6449','2013-01-11','14:35:00',3.17),('6449','2013-01-11','14:40:00',3.03),('6449','2013-01-11','14:45:00',1.37),('6449','2013-01-11','14:50:00',3.18),('6449','2013-01-11','14:55:00',2.76),('6449','2013-01-11','15:00:00',4.49),('6449','2013-01-11','15:05:00',3.97),('6449','2013-01-11','15:20:00',1.12),('6449','2013-01-11','15:25:00',2.01),('6449','2013-01-11','15:30:00',4.11),('6449','2013-01-11','15:35:00',4.34),('6449','2013-01-11','15:40:00',1.35),('6449','2013-01-11','16:00:00',1.16),('6449','2013-01-10','10:00:00',1.04),('6449','2013-01-10','10:05:00',1.38),('6449','2013-01-10','10:10:00',1.41),('6449','2013-01-10','10:15:00',1.43),('6449','2013-01-10','10:20:00',1.91),('6449','2013-01-10','10:25:00',1.84),('6449','2013-01-10','10:30:00',1.96),('6449','2013-01-10','10:35:00',1.89),('6449','2013-01-10','10:40:00',2),('6449','2013-01-10','10:45:00',2.05),('6449','2013-01-10','10:50:00',2.15),('6449','2013-01-10','10:55:00',2.06),('6449','2013-01-10','11:00:00',2.25),('6449','2013-01-10','11:05:00',2.42),('6449','2013-01-10','11:10:00',2.3),('6449','2013-01-10','11:15:00',1.7),('6449','2013-01-10','11:20:00',1.47),('6449','2013-01-10','11:25:00',1.42),('6449','2013-01-10','11:30:00',1.28),('6449','2013-01-10','11:35:00',1.59),('6449','2013-01-10','11:40:00',1.71),('6449','2013-01-10','11:45:00',2.02),('6449','2013-01-10','11:50:00',2.22),('6449','2013-01-10','11:55:00',2.5),('6449','2013-01-10','12:00:00',2.61),('6449','2013-01-10','12:05:00',2.94),('6449','2013-01-10','12:10:00',2.99),('6449','2013-01-10','12:15:00',2.37),('6449','2013-01-10','12:20:00',2.21),('6449','2013-01-10','12:25:00',2.15),('6449','2013-01-10','12:30:00',1.91),('6449','2013-01-10','12:35:00',1.66),('6449','2013-01-10','12:40:00',1.3),('6449','2013-01-10','12:45:00',1.62),('6449','2013-01-10','12:50:00',2.13),('6449','2013-01-10','12:55:00',2.46),('6449','2013-01-10','13:00:00',1.82),('6449','2013-01-10','13:05:00',1.64),('6449','2013-01-10','13:10:00',1.7),('6449','2013-01-10','13:15:00',2.59),('6449','2013-01-10','13:20:00',3.01),('6449','2013-01-10','13:25:00',2.46),('6449','2013-01-10','13:30:00',2.12),('6449','2013-01-10','13:35:00',2.52),('6449','2013-01-10','13:40:00',2.26),('6449','2013-01-10','13:45:00',1.86),('6449','2013-01-10','13:50:00',1.45),('6449','2013-01-10','13:55:00',1.57),('6449','2013-01-10','14:00:00',1.69),('6449','2013-01-10','14:05:00',1.56),('6449','2013-01-10','14:10:00',1.36),('6449','2013-01-10','14:15:00',1.32),('6449','2013-01-10','14:20:00',1.97),('6449','2013-01-10','14:25:00',1.99),('6449','2013-01-10','14:30:00',1.66),('6449','2013-01-10','14:35:00',1.8),('6449','2013-01-10','14:40:00',1.64),('6449','2013-01-10','14:45:00',1.6),('6449','2013-01-10','14:50:00',1.06),('6449','2013-01-10','15:00:00',1.05),('6449','2013-01-10','15:05:00',1.22),('6449','2013-01-09','08:45:00',1.03),('6449','2013-01-09','08:50:00',1.18),('6449','2013-01-09','08:55:00',1.29),('6449','2013-01-09','09:00:00',1.51),('6449','2013-01-09','09:05:00',1.59),('6449','2013-01-09','09:10:00',1.75),('6449','2013-01-09','09:15:00',1.9),('6449','2013-01-09','09:20:00',2.1),('6449','2013-01-09','09:25:00',2.62),('6449','2013-01-09','09:30:00',2.79),('6449','2013-01-09','09:35:00',2.78),('6449','2013-01-09','09:40:00',2.8),('6449','2013-01-09','09:45:00',3.14),('6449','2013-01-09','09:50:00',6.41),('6449','2013-01-09','09:55:00',4.49),('6449','2013-01-09','10:00:00',3.64),('6449','2013-01-09','10:05:00',4.22),('6449','2013-01-09','10:10:00',3.1),('6449','2013-01-09','10:15:00',3.04),('6449','2013-01-09','10:20:00',3.64),('6449','2013-01-09','10:25:00',3.51),('6449','2013-01-09','10:30:00',3.77),('6449','2013-01-09','10:35:00',5.5),('6449','2013-01-09','10:40:00',8.02),('6449','2013-01-09','10:45:00',4.21),('6449','2013-01-09','10:50:00',3.26),('6449','2013-01-09','10:55:00',2.87),('6449','2013-01-09','11:00:00',3),('6449','2013-01-09','11:05:00',3.19),('6449','2013-01-09','11:10:00',3.48),('6449','2013-01-09','11:15:00',3.67),('6449','2013-01-09','11:20:00',3.38),('6449','2013-01-09','11:25:00',3.33),('6449','2013-01-09','11:30:00',4.12),('6449','2013-01-09','11:35:00',4.98),('6449','2013-01-09','11:40:00',5.68),('6449','2013-01-09','11:45:00',9.34),('6449','2013-01-09','11:50:00',9.9),('6449','2013-01-09','11:55:00',9.91),('6449','2013-01-09','12:00:00',6.7),('6449','2013-01-09','12:05:00',8.13),('6449','2013-01-09','12:10:00',8.24),('6449','2013-01-09','12:15:00',11.43),('6449','2013-01-09','12:20:00',8.76),('6449','2013-01-09','12:25:00',7.47),('6449','2013-01-09','12:30:00',6.61),('6449','2013-01-09','12:35:00',6.96),('6449','2013-01-09','12:40:00',6.98),('6449','2013-01-09','12:45:00',6.78),('6449','2013-01-09','12:50:00',6.1),('6449','2013-01-09','12:55:00',5.88),('6449','2013-01-09','13:00:00',8.11),('6449','2013-01-09','13:05:00',8.3),('6449','2013-01-09','13:10:00',6.29),('6449','2013-01-09','13:15:00',7.18),('6449','2013-01-09','13:20:00',7.79),('6449','2013-01-09','13:25:00',10.01),('6449','2013-01-09','13:30:00',6.95),('6449','2013-01-09','13:35:00',4.05),('6449','2013-01-09','13:40:00',3.34),('6449','2013-01-09','13:45:00',3.12),('6449','2013-01-09','13:50:00',3.09),('6449','2013-01-09','13:55:00',3.55),('6449','2013-01-09','14:00:00',8.25),('6449','2013-01-09','14:05:00',7.01),('6449','2013-01-09','14:10:00',5.35),('6449','2013-01-09','14:15:00',3.85),('6449','2013-01-09','14:20:00',3.28),('6449','2013-01-09','14:25:00',2.86),('6449','2013-01-09','14:30:00',3),('6449','2013-01-09','14:35:00',2.96),('6449','2013-01-09','14:40:00',3.16),('6449','2013-01-09','14:45:00',4.29),('6449','2013-01-09','14:50:00',3.68),('6449','2013-01-09','14:55:00',3.45),('6449','2013-01-09','15:00:00',2.98),('6449','2013-01-09','15:05:00',2.4),('6449','2013-01-09','15:10:00',2.3),('6449','2013-01-09','15:15:00',3.07),('6449','2013-01-09','15:20:00',2.98),('6449','2013-01-09','15:25:00',2.4),('6449','2013-01-09','15:30:00',1.92),('6449','2013-01-09','15:35:00',3.24),('6449','2013-01-09','15:40:00',3.35),('6449','2013-01-09','15:45:00',3.34),('6449','2013-01-09','15:50:00',3.03),('6449','2013-01-09','15:55:00',2.61),('6449','2013-01-09','16:00:00',2.23),('6449','2013-01-09','16:05:00',1.94),('6449','2013-01-09','16:10:00',1.62),('6449','2013-01-09','16:15:00',1.29),('6449','2013-01-08','08:00:00',1.12),('6449','2013-01-08','08:05:00',1.79),('6449','2013-01-08','08:10:00',2.01),('6449','2013-01-08','08:15:00',2.57),('6449','2013-01-08','08:20:00',2.92),('6449','2013-01-08','08:25:00',3.2),('6449','2013-01-08','08:30:00',2.13),('6449','2013-01-08','08:40:00',1.08),('6449','2013-01-08','08:45:00',1.39),('6449','2013-01-08','08:50:00',1.73),('6449','2013-01-08','08:55:00',1.93),('6449','2013-01-08','09:00:00',2.17),('6449','2013-01-08','09:05:00',2.52),('6449','2013-01-08','09:10:00',2.66),('6449','2013-01-08','09:15:00',2.47),('6449','2013-01-08','09:20:00',2.77),('6449','2013-01-08','09:25:00',2.77),('6449','2013-01-08','09:30:00',2.96),('6449','2013-01-08','09:35:00',2.84),('6449','2013-01-08','09:40:00',2.8),('6449','2013-01-08','09:45:00',2.63),('6449','2013-01-08','09:50:00',2.62),('6449','2013-01-08','09:55:00',3.11),('6449','2013-01-08','10:00:00',3.17),('6449','2013-01-08','10:05:00',2.99),('6449','2013-01-08','10:10:00',5.71),('6449','2013-01-08','10:15:00',7.75),('6449','2013-01-08','10:20:00',8.25),('6449','2013-01-08','10:25:00',8.04),('6449','2013-01-08','10:30:00',8.51),('6449','2013-01-08','10:35:00',8.75),('6449','2013-01-08','10:40:00',9.73),('6449','2013-01-08','10:45:00',9.97),('6449','2013-01-08','10:50:00',10.15),('6449','2013-01-08','10:55:00',10.36),('6449','2013-01-08','11:00:00',10.53),('6449','2013-01-08','11:05:00',10.67),('6449','2013-01-08','11:10:00',10.78),('6449','2013-01-08','11:15:00',10.91),('6449','2013-01-08','11:20:00',11.03),('6449','2013-01-08','11:25:00',10.95),('6449','2013-01-08','11:30:00',10.9),('6449','2013-01-08','11:35:00',10.84),('6449','2013-01-08','11:40:00',10.82),('6449','2013-01-08','11:45:00',10.98),('6449','2013-01-08','11:50:00',11.5),('6449','2013-01-08','11:55:00',13.2),('6449','2013-01-08','12:00:00',10.05),('6449','2013-01-08','12:05:00',8.5),('6449','2013-01-08','12:10:00',10.07),('6449','2013-01-08','12:15:00',6.58),('6449','2013-01-08','12:20:00',5.55),('6449','2013-01-08','12:25:00',5.25),('6449','2013-01-08','12:30:00',4.71),('6449','2013-01-08','12:35:00',5.67),('6449','2013-01-08','12:40:00',3.26),('6449','2013-01-08','12:45:00',3.23),('6449','2013-01-08','12:50:00',2.21),('6449','2013-01-08','12:55:00',1.93),('6449','2013-01-08','13:00:00',2.48),('6449','2013-01-08','13:05:00',2.7),('6449','2013-01-08','13:10:00',2.44),('6449','2013-01-08','13:15:00',3.06),('6449','2013-01-08','13:20:00',3.53),('6449','2013-01-08','13:25:00',3.13),('6449','2013-01-08','13:30:00',2.22),('6449','2013-01-08','13:35:00',2.02),('6449','2013-01-08','13:40:00',1.73),('6449','2013-01-08','13:45:00',1.67),('6449','2013-01-08','13:50:00',1.41),('6449','2013-01-08','13:55:00',1.38),('6449','2013-01-08','14:00:00',1.58),('6449','2013-01-08','14:05:00',2),('6449','2013-01-08','14:10:00',2.52),('6449','2013-01-08','14:15:00',3.51),('6449','2013-01-08','14:20:00',5.22),('6449','2013-01-08','14:25:00',6.07),('6449','2013-01-08','14:30:00',6.77),('6449','2013-01-08','14:35:00',5.29),('6449','2013-01-08','14:40:00',3.49),('6449','2013-01-08','14:45:00',3),('6449','2013-01-08','14:50:00',3.21),('6449','2013-01-08','14:55:00',3.62),('6449','2013-01-08','15:00:00',2.02),('6449','2013-01-08','15:05:00',1.78),('6449','2013-01-08','15:10:00',2.01),('6449','2013-01-08','15:15:00',4.23),('6449','2013-01-08','15:20:00',2.63),('6449','2013-01-08','15:25:00',2.46),('6449','2013-01-08','15:30:00',2.01),('6449','2013-01-07','08:00:00',1.07),('6449','2013-01-07','08:05:00',1.37),('6449','2013-01-07','08:10:00',1.68),('6449','2013-01-07','08:15:00',2.05),('6449','2013-01-07','08:20:00',2.37),('6449','2013-01-07','08:25:00',2.68),('6449','2013-01-07','08:30:00',3.01),('6449','2013-01-07','08:35:00',3.34),('6449','2013-01-07','08:40:00',3.61),('6449','2013-01-07','08:45:00',3.9),('6449','2013-01-07','08:50:00',4.21),('6449','2013-01-07','08:55:00',4.47),('6449','2013-01-07','09:00:00',4.81),('6449','2013-01-07','09:05:00',5.08),('6449','2013-01-07','09:10:00',5.35),('6449','2013-01-07','09:15:00',5.59),('6449','2013-01-07','09:20:00',5.88),('6449','2013-01-07','09:25:00',6.02),('6449','2013-01-07','09:30:00',6.38),('6449','2013-01-07','09:35:00',6.64),('6449','2013-01-07','09:40:00',6.95),('6449','2013-01-07','09:45:00',7.28),('6449','2013-01-07','09:50:00',7.5),('6449','2013-01-07','09:55:00',7.75),('6449','2013-01-07','10:00:00',8.07),('6449','2013-01-07','10:05:00',8.33),('6449','2013-01-07','10:10:00',8.59),('6449','2013-01-07','10:15:00',8.83),('6449','2013-01-07','10:20:00',9.11),('6449','2013-01-07','10:25:00',9.31),('6449','2013-01-07','10:30:00',9.49),('6449','2013-01-07','10:35:00',9.69),('6449','2013-01-07','10:40:00',9.66),('6449','2013-01-07','10:45:00',9.98),('6449','2013-01-07','10:50:00',10.1),('6449','2013-01-07','10:55:00',10.24),('6449','2013-01-07','11:00:00',10.33),('6449','2013-01-07','11:05:00',10.46),('6449','2013-01-07','11:10:00',10.45),('6449','2013-01-07','11:15:00',10.71),('6449','2013-01-07','11:20:00',10.77),('6449','2013-01-07','11:25:00',10.86),('6449','2013-01-07','11:30:00',10.87),('6449','2013-01-07','11:35:00',10.86),('6449','2013-01-07','11:40:00',10.68),('6449','2013-01-07','11:45:00',10.8),('6449','2013-01-07','11:50:00',10.73),('6449','2013-01-07','11:55:00',10.77),('6449','2013-01-07','12:00:00',10.7),('6449','2013-01-07','12:05:00',10.75),('6449','2013-01-07','12:10:00',10.76),('6449','2013-01-07','12:15:00',10.78),('6449','2013-01-07','12:20:00',10.79),('6449','2013-01-07','12:25:00',10.76),('6449','2013-01-07','12:30:00',10.59),('6449','2013-01-07','12:35:00',10.66),('6449','2013-01-07','12:40:00',10.73),('6449','2013-01-07','12:45:00',10.56),('6449','2013-01-07','12:50:00',10.5),('6449','2013-01-07','12:55:00',10.44),('6449','2013-01-07','13:00:00',10.27),('6449','2013-01-07','13:05:00',10.28),('6449','2013-01-07','13:10:00',10.03),('6449','2013-01-07','13:15:00',9.72),('6449','2013-01-07','13:20:00',9.72),('6449','2013-01-07','13:25:00',9.71),('6449','2013-01-07','13:30:00',9.38),('6449','2013-01-07','13:35:00',9.48),('6449','2013-01-07','13:40:00',9.49),('6449','2013-01-07','13:45:00',9.17),('6449','2013-01-07','13:50:00',8.92),('6449','2013-01-07','13:55:00',8.78),('6449','2013-01-07','14:00:00',8.59),('6449','2013-01-07','14:05:00',8.24),('6449','2013-01-07','14:10:00',8.06),('6449','2013-01-07','14:15:00',7.94),('6449','2013-01-07','14:20:00',7.82),('6449','2013-01-07','14:25:00',7.57),('6449','2013-01-07','14:30:00',7.44),('6449','2013-01-07','14:35:00',7.12),('6449','2013-01-07','14:40:00',6.89),('6449','2013-01-07','14:45:00',6.47),('6449','2013-01-07','14:50:00',6.33),('6449','2013-01-07','14:55:00',6.05),('6449','2013-01-07','15:00:00',5.74),('6449','2013-01-07','15:05:00',5.44),('6449','2013-01-07','15:10:00',5.19),('6449','2013-01-07','15:15:00',4.87),('6449','2013-01-07','15:20:00',4.53),('6449','2013-01-07','15:25:00',4.21),('6449','2013-01-07','15:30:00',3.89),('6449','2013-01-07','15:35:00',3.63),('6449','2013-01-07','15:40:00',3.37),('6449','2013-01-07','15:45:00',3.03),('6449','2013-01-07','15:50:00',2.71),('6449','2013-01-07','15:55:00',2.39),('6449','2013-01-07','16:00:00',2.05),('6449','2013-01-07','16:05:00',1.77),('6449','2013-01-07','16:10:00',1.54),('6449','2013-01-07','16:15:00',1.29),('6449','2013-01-07','16:20:00',1.04),('6449','2013-01-06','07:55:00',1.02),('6449','2013-01-06','08:00:00',1.4),('6449','2013-01-06','08:05:00',1.84),('6449','2013-01-06','08:10:00',2.18),('6449','2013-01-06','08:15:00',2.52),('6449','2013-01-06','08:20:00',2.84),('6449','2013-01-06','08:25:00',3.13),('6449','2013-01-06','08:30:00',3.42),('6449','2013-01-06','08:35:00',3.74),('6449','2013-01-06','08:40:00',4.03),('6449','2013-01-06','08:45:00',4.32),('6449','2013-01-06','08:50:00',4.56),('6449','2013-01-06','08:55:00',4.79),('6449','2013-01-06','09:00:00',5.1),('6449','2013-01-06','09:05:00',5.34),('6449','2013-01-06','09:10:00',5.58),('6449','2013-01-06','09:15:00',5.85),('6449','2013-01-06','09:20:00',6.09),('6449','2013-01-06','09:25:00',6.31),('6449','2013-01-06','09:30:00',6.61),('6449','2013-01-06','09:35:00',6.77),('6449','2013-01-06','09:40:00',6.96),('6449','2013-01-06','09:45:00',7.29),('6449','2013-01-06','09:50:00',7.49),('6449','2013-01-06','09:55:00',7.75),('6449','2013-01-06','10:00:00',8.01),('6449','2013-01-06','10:05:00',8.2),('6449','2013-01-06','10:10:00',8.39),('6449','2013-01-06','10:15:00',8.6),('6449','2013-01-06','10:20:00',8.83),('6449','2013-01-06','10:25:00',9.04),('6449','2013-01-06','10:30:00',9.22),('6449','2013-01-06','10:35:00',9.35),('6449','2013-01-06','10:40:00',9.52),('6449','2013-01-06','10:45:00',9.57),('6449','2013-01-06','10:50:00',9.77),('6449','2013-01-06','10:55:00',9.82),('6449','2013-01-06','11:00:00',10.13),('6449','2013-01-06','11:05:00',10.22),('6449','2013-01-06','11:10:00',10.33),('6449','2013-01-06','11:15:00',10.46),('6449','2013-01-06','11:20:00',10.64),('6449','2013-01-06','11:25:00',10.75),('6449','2013-01-06','11:30:00',10.7),('6449','2013-01-06','11:35:00',11),('6449','2013-01-06','11:40:00',11.07),('6449','2013-01-06','11:45:00',11.16),('6449','2013-01-06','11:50:00',11.15),('6449','2013-01-06','11:55:00',11.21),('6449','2013-01-06','12:00:00',11.19),('6449','2013-01-06','12:05:00',11.2),('6449','2013-01-06','12:10:00',11.19),('6449','2013-01-06','12:15:00',11.15),('6449','2013-01-06','12:20:00',11.13),('6449','2013-01-06','12:25:00',11.09),('6449','2013-01-06','12:30:00',10.94),('6449','2013-01-06','12:35:00',10.99),('6449','2013-01-06','12:40:00',10.98),('6449','2013-01-06','12:45:00',10.76),('6449','2013-01-06','12:50:00',10.86),('6449','2013-01-06','12:55:00',10.75),('6449','2013-01-06','13:00:00',10.53),('6449','2013-01-06','13:05:00',10.51),('6449','2013-01-06','13:10:00',10.41),('6449','2013-01-06','13:15:00',10.17),('6449','2013-01-06','13:20:00',10.15),('6449','2013-01-06','13:25:00',9.89),('6449','2013-01-06','13:30:00',9.78),('6449','2013-01-06','13:35:00',9.67),('6449','2013-01-06','13:40:00',9.37),('6449','2013-01-06','13:45:00',9.13),('6449','2013-01-06','13:51:00',8.89),('6449','2013-01-06','13:55:00',8.74),('6449','2013-01-06','14:00:00',8.52),('6449','2013-01-06','14:05:00',8.15),('6449','2013-01-06','14:10:00',7.9),('6449','2013-01-06','14:15:00',7.63),('6449','2013-01-06','14:20:00',7.41),('6449','2013-01-06','14:25:00',7.15),('6449','2013-01-06','14:31:00',7.02),('6449','2013-01-06','14:35:00',6.62),('6449','2013-01-06','14:40:00',6.46),('6449','2013-01-06','14:45:00',6.2),('6449','2013-01-06','14:50:00',5.97),('6449','2013-01-06','14:55:00',5.61),('6449','2013-01-06','15:00:00',5.31),('6449','2013-01-06','15:05:00',5.09),('6449','2013-01-06','15:10:00',4.73),('6449','2013-01-06','15:15:00',4.33),('6449','2013-01-06','15:20:00',4.06),('6449','2013-01-06','15:25:00',3.76),('6449','2013-01-06','15:30:00',3.44),('6449','2013-01-06','15:35:00',3.19),('6449','2013-01-06','15:40:00',2.95),('6449','2013-01-06','15:45:00',2.77),('6449','2013-01-06','15:51:00',2.57),('6449','2013-01-06','15:55:00',2.22),('6449','2013-01-06','16:00:00',1.89),('6449','2013-01-06','16:05:00',1.39),('6449','2013-01-06','16:10:00',1.11),('6449','2013-01-05','08:20:00',1.29),('6449','2013-01-05','08:25:00',1.73),('6449','2013-01-05','08:30:00',2.18),('6449','2013-01-05','08:35:00',2.37),('6449','2013-01-05','08:40:00',2.67),('6449','2013-01-05','08:45:00',1.83),('6449','2013-01-05','08:50:00',3.1),('6449','2013-01-05','08:55:00',3.81),('6449','2013-01-05','09:00:00',3.81),('6449','2013-01-05','09:05:00',1.56),('6449','2013-01-05','09:10:00',1.55),('6449','2013-01-05','09:15:00',1.57),('6449','2013-01-05','09:20:00',1.66),('6449','2013-01-05','09:25:00',1.85),('6449','2013-01-05','09:30:00',2.34),('6449','2013-01-05','09:35:00',3.05),('6449','2013-01-05','09:40:00',3.45),('6449','2013-01-05','09:45:00',3.52),('6449','2013-01-05','09:50:00',3.76),('6449','2013-01-05','09:55:00',3.33),('6449','2013-01-05','10:00:00',3.13),('6449','2013-01-05','10:05:00',3.2),('6449','2013-01-05','10:10:00',3.94),('6449','2013-01-05','10:15:00',5.75),('6449','2013-01-05','10:20:00',7.17),('6449','2013-01-05','10:25:00',7),('6449','2013-01-05','10:30:00',6.27),('6449','2013-01-05','10:35:00',6.36),('6449','2013-01-05','10:40:00',7.1),('6449','2013-01-05','10:45:00',6.95),('6449','2013-01-05','10:50:00',6.38),('6449','2013-01-05','10:55:00',6.27),('6449','2013-01-05','11:00:00',7.62),('6449','2013-01-05','11:05:00',9.28),('6449','2013-01-05','11:10:00',10.3),('6449','2013-01-05','11:15:00',9.47),('6449','2013-01-05','11:20:00',9.91),('6449','2013-01-05','11:25:00',9.99),('6449','2013-01-05','11:30:00',10.01),('6449','2013-01-05','11:35:00',10.45),('6449','2013-01-05','11:40:00',10.34),('6449','2013-01-05','11:45:00',10.62),('6449','2013-01-05','11:50:00',9.84),('6449','2013-01-05','11:55:00',10.01),('6449','2013-01-05','12:00:00',8.58),('6449','2013-01-05','12:05:00',7.92),('6449','2013-01-05','12:10:00',8.15),('6449','2013-01-05','12:15:00',7.92),('6449','2013-01-05','12:20:00',7.74),('6449','2013-01-05','12:25:00',6.85),('6449','2013-01-05','12:30:00',5.93),('6449','2013-01-05','12:35:00',7.26),('6449','2013-01-05','12:40:00',6.65),('6449','2013-01-05','12:45:00',6.64),('6449','2013-01-05','12:50:00',7.69),('6449','2013-01-05','12:55:00',11.03),('6449','2013-01-05','13:00:00',10.11),('6449','2013-01-05','13:05:00',10.27),('6449','2013-01-05','13:10:00',7.87),('6449','2013-01-05','13:15:00',8.17),('6449','2013-01-05','13:20:00',9.7),('6449','2013-01-05','13:25:00',9.48),('6449','2013-01-05','13:30:00',8.42),('6449','2013-01-05','13:35:00',9.16),('6449','2013-01-05','13:40:00',8.36),('6449','2013-01-05','13:45:00',8.58),('6449','2013-01-05','13:50:00',8.26),('6449','2013-01-05','13:55:00',7.88),('6449','2013-01-05','14:00:00',7.21),('6449','2013-01-05','14:05:00',7.47),('6449','2013-01-05','14:10:00',7.05),('6449','2013-01-05','14:15:00',6.3),('6449','2013-01-05','14:20:00',6.99),('6449','2013-01-05','14:25:00',5.96),('6449','2013-01-05','14:30:00',5.8),('6449','2013-01-05','14:35:00',5.65),('6449','2013-01-05','14:40:00',4.6),('6449','2013-01-05','14:45:00',4.54),('6449','2013-01-05','14:50:00',5.5),('6449','2013-01-05','14:55:00',5.57),('6449','2013-01-05','15:00:00',5.56),('6449','2013-01-05','15:05:00',4.01),('6449','2013-01-05','15:10:00',4.69),('6449','2013-01-05','15:15:00',4.23),('6449','2013-01-05','15:20:00',3.63),('6449','2013-01-05','15:25:00',2.31),('6449','2013-01-05','15:30:00',3.13),('6449','2013-01-05','15:35:00',2.75),('6449','2013-01-05','15:40:00',2.44),('6449','2013-01-05','15:45:00',2.25),('6449','2013-01-05','15:50:00',2.06),('6449','2013-01-05','15:55:00',1.86),('6449','2013-01-05','16:00:00',1.63),('6449','2013-01-05','16:05:00',1.42),('6449','2013-01-05','16:10:00',1.2),('6449','2013-01-04','08:00:00',1.04),('6449','2013-01-04','08:05:00',1.63),('6449','2013-01-04','08:10:00',1.86),('6449','2013-01-04','08:15:00',2.23),('6449','2013-01-04','08:20:00',2.32),('6449','2013-01-04','08:25:00',2.34),('6449','2013-01-04','08:30:00',2.22),('6449','2013-01-04','08:35:00',2.64),('6449','2013-01-04','08:40:00',2.93),('6449','2013-01-04','08:45:00',3.7),('6449','2013-01-04','08:50:00',2.41),('6449','2013-01-04','08:55:00',2.39),('6449','2013-01-04','09:00:00',4.43),('6449','2013-01-04','09:05:00',4.97),('6449','2013-01-04','09:10:00',4.18),('6449','2013-01-04','09:15:00',4.78),('6449','2013-01-04','09:20:00',5.14),('6449','2013-01-04','09:25:00',5.43),('6449','2013-01-04','09:30:00',6.26),('6449','2013-01-04','09:35:00',6.82),('6449','2013-01-04','09:40:00',7.24),('6449','2013-01-04','09:45:00',8.01),('6449','2013-01-04','09:50:00',8.39),('6449','2013-01-04','09:55:00',8.94),('6449','2013-01-04','10:00:00',7.88),('6449','2013-01-04','10:05:00',5.46),('6449','2013-01-04','10:10:00',2.87),('6449','2013-01-04','10:15:00',2.44),('6449','2013-01-04','10:20:00',3.18),('6449','2013-01-04','10:25:00',5.22),('6449','2013-01-04','10:30:00',8.61),('6449','2013-01-04','10:35:00',9.48),('6449','2013-01-04','10:40:00',9.87),('6449','2013-01-04','10:45:00',10.32),('6449','2013-01-04','10:50:00',11),('6449','2013-01-04','10:55:00',10.7),('6449','2013-01-04','11:00:00',8.55),('6449','2013-01-04','11:05:00',10.1),('6449','2013-01-04','11:10:00',8.52),('6449','2013-01-04','11:15:00',4.53),('6449','2013-01-04','11:20:00',3.16),('6449','2013-01-04','11:25:00',3.46),('6449','2013-01-04','11:30:00',4.17),('6449','2013-01-04','11:35:00',3.49),('6449','2013-01-04','11:40:00',2.42),('6449','2013-01-04','11:45:00',3.85),('6449','2013-01-04','11:50:00',8.75),('6449','2013-01-04','11:55:00',12.36),('6449','2013-01-04','12:00:00',10.79),('6449','2013-01-04','12:05:00',8.16),('6449','2013-01-04','12:10:00',3.41),('6449','2013-01-04','12:15:00',3.75),('6449','2013-01-04','12:20:00',3.63),('6449','2013-01-04','12:25:00',8.96),('6449','2013-01-04','12:30:00',10.95),('6449','2013-01-04','12:35:00',10.93),('6449','2013-01-04','12:40:00',10.97),('6449','2013-01-04','12:45:00',10.84),('6449','2013-01-04','12:50:00',10.62),('6449','2013-01-04','12:55:00',10.5),('6449','2013-01-04','13:00:00',9.56),('6449','2013-01-04','13:05:00',7.99),('6449','2013-01-04','13:10:00',9.42),('6449','2013-01-04','13:15:00',9.64),('6449','2013-01-04','13:20:00',9.55),('6449','2013-01-04','13:25:00',9.35),('6449','2013-01-04','13:30:00',9.13),('6449','2013-01-04','13:35:00',8.91),('6449','2013-01-04','13:40:00',8.66),('6449','2013-01-04','13:45:00',8.56),('6449','2013-01-04','13:50:00',8.55),('6449','2013-01-04','13:55:00',8.3),('6449','2013-01-04','14:00:00',7.61),('6449','2013-01-04','14:05:00',7.95),('6449','2013-01-04','14:10:00',7.76),('6449','2013-01-04','14:15:00',7),('6449','2013-01-04','14:20:00',6.98),('6449','2013-01-04','14:25:00',6.85),('6449','2013-01-04','14:30:00',6.75),('6449','2013-01-04','14:35:00',6.5),('6449','2013-01-04','14:40:00',6.16),('6449','2013-01-04','14:45:00',5.86),('6449','2013-01-04','14:50:00',5.74),('6449','2013-01-04','14:55:00',5.4),('6449','2013-01-04','15:00:00',5.22),('6449','2013-01-04','15:05:00',5.03),('6449','2013-01-04','15:10:00',4.79),('6449','2013-01-04','15:15:00',4.47),('6449','2013-01-04','15:20:00',4.01),('6449','2013-01-04','15:25:00',3.8),('6449','2013-01-04','15:30:00',3.65),('6449','2013-01-04','15:35:00',2.27),('6449','2013-01-04','15:40:00',2.51),('6449','2013-01-04','15:45:00',2.87),('6449','2013-01-04','15:50:00',2.57),('6449','2013-01-04','15:55:00',2.31),('6449','2013-01-04','16:00:00',1.93),('6449','2013-01-04','16:05:00',1.75),('6449','2013-01-04','16:10:00',1.49),('6449','2013-01-04','16:15:00',1.2),('6449','2013-01-04','16:20:00',1.05),('6449','2013-01-03','08:05:00',1.67),('6449','2013-01-03','08:10:00',2.08),('6449','2013-01-03','08:15:00',2.34),('6449','2013-01-03','08:20:00',2.84),('6449','2013-01-03','08:25:00',3.24),('6449','2013-01-03','08:30:00',2.53),('6449','2013-01-03','08:35:00',1.99),('6449','2013-01-03','08:40:00',2.35),('6449','2013-01-03','08:45:00',2.26),('6449','2013-01-03','08:50:00',4.2),('6449','2013-01-03','08:55:00',1.94),('6449','2013-01-03','09:00:00',2.54),('6449','2013-01-03','09:05:00',2.44),('6449','2013-01-03','09:10:00',2.42),('6449','2013-01-03','09:15:00',5.68),('6449','2013-01-03','09:20:00',7.14),('6449','2013-01-03','09:25:00',5.57),('6449','2013-01-03','09:30:00',3.86),('6449','2013-01-03','09:35:00',4.24),('6449','2013-01-03','09:40:00',5.65),('6449','2013-01-03','09:45:00',4.97),('6449','2013-01-03','09:50:00',4.54),('6449','2013-01-03','09:55:00',4.87),('6449','2013-01-03','10:00:00',5.5),('6449','2013-01-03','10:05:00',5.3),('6449','2013-01-03','10:10:00',5.03),('6449','2013-01-03','10:15:00',4.95),('6449','2013-01-03','10:20:00',5.26),('6449','2013-01-03','10:25:00',4.93),('6449','2013-01-03','10:30:00',4.79),('6449','2013-01-03','10:35:00',5.06),('6449','2013-01-03','10:40:00',5.15),('6449','2013-01-03','10:45:00',4.88),('6449','2013-01-03','10:50:00',4.89),('6449','2013-01-03','10:55:00',4.92),('6449','2013-01-03','11:00:00',5.31),('6449','2013-01-03','11:05:00',5.92),('6449','2013-01-03','11:10:00',6.44),('6449','2013-01-03','11:15:00',7.67),('6449','2013-01-03','11:20:00',7.94),('6449','2013-01-03','11:25:00',7.86),('6449','2013-01-03','11:30:00',8.3),('6449','2013-01-03','11:35:00',7.83),('6449','2013-01-03','11:40:00',9.13),('6449','2013-01-03','11:45:00',9.29),('6449','2013-01-03','11:50:00',10.45),('6449','2013-01-03','11:55:00',11.18),('6449','2013-01-03','12:00:00',11.03),('6449','2013-01-03','12:05:00',11),('6449','2013-01-03','12:10:00',10.96),('6449','2013-01-03','12:15:00',10.93),('6449','2013-01-03','12:20:00',10.94),('6449','2013-01-03','12:25:00',10.92),('6449','2013-01-03','12:30:00',10.73),('6449','2013-01-03','12:35:00',10.81),('6449','2013-01-03','12:40:00',10.76),('6449','2013-01-03','12:45:00',10.64),('6449','2013-01-03','12:50:00',10.53),('6449','2013-01-03','12:55:00',10.39),('6449','2013-01-03','13:00:00',10.06),('6449','2013-01-03','13:05:00',10.12),('6449','2013-01-03','13:10:00',10.02),('6449','2013-01-03','13:15:00',9.9),('6449','2013-01-03','13:20:00',9.77),('6449','2013-01-03','13:25:00',9.61),('6449','2013-01-03','13:30:00',9.48),('6449','2013-01-03','13:35:00',9.23),('6449','2013-01-03','13:40:00',9),('6449','2013-01-03','13:45:00',8.81),('6449','2013-01-03','13:50:00',8.65),('6449','2013-01-03','13:55:00',8.44),('6449','2013-01-03','14:00:00',8.29),('6449','2013-01-03','14:05:00',8),('6449','2013-01-03','14:10:00',7.92),('6449','2013-01-03','14:15:00',7.63),('6449','2013-01-03','14:20:00',7.42),('6449','2013-01-03','14:25:00',7.21),('6449','2013-01-03','14:30:00',6.99),('6449','2013-01-03','14:35:00',6.71),('6449','2013-01-03','14:40:00',6.44),('6449','2013-01-03','14:45:00',6.16),('6449','2013-01-03','14:50:00',5.99),('6449','2013-01-03','14:55:00',5.64),('6449','2013-01-03','15:00:00',5.43),('6449','2013-01-03','15:05:00',5.14),('6449','2013-01-03','15:10:00',4.66),('6449','2013-01-03','15:15:00',4.22),('6449','2013-01-03','15:20:00',3.66),('6449','2013-01-03','15:25:00',3.22),('6449','2013-01-03','15:30:00',3.47),('6449','2013-01-03','15:35:00',3.3),('6449','2013-01-03','15:40:00',2.79),('6449','2013-01-03','15:45:00',2.46),('6449','2013-01-03','15:50:00',2.1),('6449','2013-01-03','15:55:00',1.75),('6449','2013-01-03','16:00:00',1.5),('6449','2013-01-03','16:05:00',1.29),('6449','2013-01-03','16:10:00',1.09),('6449','2013-01-02','09:00:00',1.24),('6449','2013-01-02','09:05:00',1.06),('6449','2013-01-02','09:45:00',1.05),('6449','2013-01-02','09:50:00',1.21),('6449','2013-01-02','09:55:00',1.62),('6449','2013-01-02','10:00:00',1.62),('6449','2013-01-02','10:05:00',3.34),('6449','2013-01-02','10:10:00',4.65),('6449','2013-01-02','10:15:00',4.05),('6449','2013-01-02','10:20:00',3.81),('6449','2013-01-02','10:25:00',3.05),('6449','2013-01-02','10:30:00',3.75),('6449','2013-01-02','10:35:00',5.06),('6449','2013-01-02','10:40:00',5.09),('6449','2013-01-02','10:45:00',4.26),('6449','2013-01-02','10:50:00',3.79),('6449','2013-01-02','10:55:00',3.38),('6449','2013-01-02','11:00:00',3.19),('6449','2013-01-02','11:05:00',4.11),('6449','2013-01-02','11:10:00',5.7),('6449','2013-01-02','11:15:00',6.52),('6449','2013-01-02','11:20:00',5.6),('6449','2013-01-02','11:25:00',6.12),('6449','2013-01-02','11:30:00',7.75),('6449','2013-01-02','11:35:00',10.64),('6449','2013-01-02','11:40:00',9.5),('6449','2013-01-02','11:45:00',8.25),('6449','2013-01-02','11:50:00',4.44),('6449','2013-01-02','11:55:00',3.32),('6449','2013-01-02','12:00:00',2.93),('6449','2013-01-02','12:05:00',3.41),('6449','2013-01-02','12:10:00',4.09),('6449','2013-01-02','12:15:00',4.53),('6449','2013-01-02','12:20:00',4.16),('6449','2013-01-02','12:25:00',4.21),('6449','2013-01-02','12:30:00',4.56),('6449','2013-01-02','12:35:00',4.78),('6449','2013-01-02','12:40:00',4.47),('6449','2013-01-02','12:45:00',4.03),('6449','2013-01-02','12:50:00',3.77),('6449','2013-01-02','12:55:00',4.32),('6449','2013-01-02','13:00:00',4.41),('6449','2013-01-02','13:05:00',4.96),('6449','2013-01-02','13:10:00',4.88),('6449','2013-01-02','13:15:00',5.24),('6449','2013-01-02','13:20:00',5.2),('6449','2013-01-02','13:25:00',4.91),('6449','2013-01-02','13:30:00',5.32),('6449','2013-01-02','13:35:00',6.29),('6449','2013-01-02','13:40:00',5.33),('6449','2013-01-02','13:45:00',6.15),('6449','2013-01-02','13:50:00',6.79),('6449','2013-01-02','13:55:00',6.48),('6449','2013-01-02','14:00:00',3.98),('6449','2013-01-02','14:05:00',4.04),('6449','2013-01-02','14:10:00',3.66),('6449','2013-01-02','14:15:00',3.81),('6449','2013-01-02','14:20:00',3.06),('6449','2013-01-02','14:25:00',2.37),('6449','2013-01-02','14:30:00',1.65),('6449','2013-01-02','14:35:00',1.07),('6449','2013-01-01','08:00:00',1.16),('6449','2013-01-01','08:05:00',1.53),('6449','2013-01-01','08:10:00',2.11),('6449','2013-01-01','08:15:00',2.74),('6449','2013-01-01','08:20:00',3.15),('6449','2013-01-01','08:25:00',3.43),('6449','2013-01-01','08:30:00',3.91),('6449','2013-01-01','08:35:00',4.27),('6449','2013-01-01','08:40:00',4.33),('6449','2013-01-01','08:45:00',2.52),('6449','2013-01-01','08:50:00',2.11),('6449','2013-01-01','08:55:00',4.06),('6449','2013-01-01','09:00:00',2.2),('6449','2013-01-01','09:05:00',2.77),('6449','2013-01-01','09:10:00',3.39),('6449','2013-01-01','09:15:00',5.49),('6449','2013-01-01','09:20:00',5.86),('6449','2013-01-01','09:25:00',7.28),('6449','2013-01-01','09:30:00',5.15),('6449','2013-01-01','09:35:00',3.49),('6449','2013-01-01','09:40:00',2.41),('6449','2013-01-01','09:45:00',2.19),('6449','2013-01-01','09:50:00',2.88),('6449','2013-01-01','09:55:00',6.81),('6449','2013-01-01','10:00:00',3.81),('6449','2013-01-01','10:05:00',3.99),('6449','2013-01-01','10:10:00',3.39),('6449','2013-01-01','10:15:00',3.79),('6449','2013-01-01','10:20:00',3.45),('6449','2013-01-01','10:25:00',3.42),('6449','2013-01-01','10:30:00',4.5),('6449','2013-01-01','10:35:00',3.59),('6449','2013-01-01','10:40:00',4.09),('6449','2013-01-01','10:45:00',5.8),('6449','2013-01-01','10:50:00',7.06),('6449','2013-01-01','10:55:00',5.36),('6449','2013-01-01','11:00:00',3.99),('6449','2013-01-01','11:05:00',3.66),('6449','2013-01-01','11:10:00',5.28),('6449','2013-01-01','11:15:00',3.6),('6449','2013-01-01','11:20:00',2.26),('6449','2013-01-01','11:25:00',1.73),('6449','2013-01-01','11:30:00',2.1),('6449','2013-01-01','11:35:00',3.21),('6449','2013-01-01','11:40:00',3.23),('6449','2013-01-01','11:45:00',2.69),('6449','2013-01-01','11:50:00',2.17),('6449','2013-01-01','11:55:00',1.85),('6449','2013-01-01','12:00:00',1.72),('6449','2013-01-01','12:05:00',1.83),('6449','2013-01-01','12:10:00',1.59),('6449','2013-01-01','12:15:00',1.52),('6449','2013-01-01','12:20:00',1.59),('6449','2013-01-01','12:25:00',1.27),('6449','2013-01-01','12:40:00',1.18),('6449','2013-01-01','12:45:00',1.19),('6449','2013-01-01','12:50:00',1.34),('6449','2013-01-01','12:55:00',1.9),('6449','2013-01-01','13:00:00',2.48),('6449','2013-01-01','13:05:00',3.18),('6449','2013-01-01','13:10:00',2.58),('6449','2013-01-01','13:15:00',2.04),('6449','2013-01-01','13:20:00',2.9),('6449','2013-01-01','13:25:00',4.5),('6449','2013-01-01','13:30:00',3.86),('6449','2013-01-01','13:35:00',5.93),('6449','2013-01-01','13:40:00',4.51),('6449','2013-01-01','13:45:00',5.66),('6449','2013-01-01','13:50:00',8.35),('6449','2013-01-01','13:55:00',8.91),('6449','2013-01-01','14:00:00',8.64),('6449','2013-01-01','14:05:00',8.19),('6449','2013-01-01','14:10:00',7.78),('6449','2013-01-01','14:15:00',7.36),('6449','2013-01-01','14:20:00',7.03),('6449','2013-01-01','14:25:00',6.92),('6449','2013-01-01','14:30:00',6.67),('6449','2013-01-01','14:35:00',6.44),('6449','2013-01-01','14:40:00',6.19),('6449','2013-01-01','14:45:00',5.85),('6449','2013-01-01','14:50:00',5.4),('6449','2013-01-01','14:55:00',5.29),('6449','2013-01-01','15:00:00',4.82),('6449','2013-01-01','15:05:00',4.74),('6449','2013-01-01','15:10:00',4.46),('6449','2013-01-01','15:15:00',4.2),('6449','2013-01-01','15:20:00',3.98),('6449','2013-01-01','15:25:00',3.62),('6449','2013-01-01','15:30:00',3.24),('6449','2013-01-01','15:35:00',1.21),('6449','2012-12-31','07:55:00',1.4),('6449','2012-12-31','08:00:00',1.47),('6449','2012-12-31','08:05:00',1.49),('6449','2012-12-31','08:10:00',1.99),('6449','2012-12-31','08:15:00',1.2),('6449','2012-12-31','08:20:00',1.37),('6449','2012-12-31','08:30:00',2.05),('6449','2012-12-31','08:35:00',3.95),('6449','2012-12-31','08:40:00',4.45),('6449','2012-12-31','08:45:00',4.44),('6449','2012-12-31','08:50:00',5.18),('6449','2012-12-31','08:55:00',5.41),('6449','2012-12-31','09:00:00',5.67),('6449','2012-12-31','09:05:00',5.89),('6449','2012-12-31','09:10:00',6.08),('6449','2012-12-31','09:15:00',6.1),('6449','2012-12-31','09:20:00',6.48),('6449','2012-12-31','09:25:00',6.97),('6449','2012-12-31','09:30:00',7.08),('6449','2012-12-31','09:35:00',6.85),('6449','2012-12-31','09:40:00',6.64),('6449','2012-12-31','09:45:00',7.22),('6449','2012-12-31','09:50:00',7.46),('6449','2012-12-31','09:55:00',7.38),('6449','2012-12-31','10:00:00',7.14),('6449','2012-12-31','10:05:00',7.88),('6449','2012-12-31','10:10:00',8.23),('6449','2012-12-31','10:15:00',8.88),('6449','2012-12-31','10:20:00',9.36),('6449','2012-12-31','10:25:00',9.69),('6449','2012-12-31','10:30:00',9.89),('6449','2012-12-31','10:35:00',10.05),('6449','2012-12-31','10:40:00',10.17),('6449','2012-12-31','10:45:00',10.24),('6449','2012-12-31','10:50:00',10.39),('6449','2012-12-31','10:55:00',10.41),('6449','2012-12-31','11:00:00',10.66),('6449','2012-12-31','11:05:00',10.84),('6449','2012-12-31','11:10:00',10.95),('6449','2012-12-31','11:15:00',10.99),('6449','2012-12-31','11:20:00',11.1),('6449','2012-12-31','11:25:00',11.17),('6449','2012-12-31','11:30:00',11.27),('6449','2012-12-31','11:35:00',11.3),('6449','2012-12-31','11:40:00',11.24),('6449','2012-12-31','11:45:00',11.46),('6449','2012-12-31','11:50:00',11.48),('6449','2012-12-31','11:55:00',11.51),('6449','2012-12-31','12:00:00',11.5),('6449','2012-12-31','12:05:00',11.51),('6449','2012-12-31','12:10:00',11.35),('6449','2012-12-31','12:15:00',11.5),('6449','2012-12-31','12:20:00',11.5),('6449','2012-12-31','12:25:00',11.45),('6449','2012-12-31','12:30:00',11.28),('6449','2012-12-31','12:35:00',11.27),('6449','2012-12-31','12:40:00',11.09),('6449','2012-12-31','12:45:00',11.11),('6449','2012-12-31','12:50:00',11.04),('6449','2012-12-31','12:55:00',10.9),('6449','2012-12-31','13:00:00',10.84),('6449','2012-12-31','13:05:00',10.64),('6449','2012-12-31','13:10:00',10.54),('6449','2012-12-31','13:15:00',10.38),('6449','2012-12-31','13:20:00',10.14),('6449','2012-12-31','13:25:00',9.97),('6449','2012-12-31','13:30:00',9.88),('6449','2012-12-31','13:35:00',9.75),('6449','2012-12-31','13:40:00',9.54),('6449','2012-12-31','13:45:00',9.39),('6449','2012-12-31','13:50:00',9.07),('6449','2012-12-31','13:55:00',8.96),('6449','2012-12-31','14:00:00',8.74),('6449','2012-12-31','14:05:00',8.52),('6449','2012-12-31','14:10:00',8.32),('6449','2012-12-31','14:15:00',8.08),('6449','2012-12-31','14:20:00',7.83),('6449','2012-12-31','14:25:00',7.59),('6449','2012-12-31','14:30:00',7.36),('6449','2012-12-31','14:35:00',7.12),('6449','2012-12-31','14:40:00',6.83),('6449','2012-12-31','14:45:00',6.58),('6449','2012-12-31','14:50:00',6.29),('6449','2012-12-31','14:55:00',6.03),('6449','2012-12-31','15:00:00',5.71),('6449','2012-12-31','15:05:00',5.42),('6449','2012-12-31','15:10:00',5.07),('6449','2012-12-31','15:15:00',4.81),('6449','2012-12-31','15:20:00',4.51),('6449','2012-12-31','15:25:00',4.15),('6449','2012-12-31','15:30:00',3.83),('6449','2012-12-31','15:35:00',3.52),('6449','2012-12-31','15:40:00',3.17),('6449','2012-12-31','15:45:00',2.88),('6449','2012-12-31','15:50:00',2.55),('6449','2012-12-31','15:55:00',2.2),('6449','2012-12-31','16:00:00',1.91),('6449','2012-12-31','16:05:00',1.61),('6449','2012-12-31','16:10:00',1.36),('6449','2012-12-31','16:15:00',1.15),('6449','2012-12-30','07:55:00',1.16),('6449','2012-12-30','08:00:00',1.5),('6449','2012-12-30','08:05:00',1.85),('6449','2012-12-30','08:10:00',2.18),('6449','2012-12-30','08:15:00',2.53),('6449','2012-12-30','08:20:00',2.87),('6449','2012-12-30','08:25:00',3.17),('6449','2012-12-30','08:30:00',3.52),('6449','2012-12-30','08:35:00',3.86),('6449','2012-12-30','08:40:00',4.15),('6449','2012-12-30','08:45:00',4.46),('6449','2012-12-30','08:50:00',4.74),('6449','2012-12-30','08:55:00',4.92),('6449','2012-12-30','09:00:00',5.31),('6449','2012-12-30','09:05:00',5.57),('6449','2012-12-30','09:10:00',5.85),('6449','2012-12-30','09:15:00',6.07),('6449','2012-12-30','09:20:00',6.35),('6449','2012-12-30','09:25:00',6.59),('6449','2012-12-30','09:30:00',6.89),('6449','2012-12-30','09:35:00',7.22),('6449','2012-12-30','09:40:00',7.53),('6449','2012-12-30','09:45:00',7.85),('6449','2012-12-30','09:50:00',8.14),('6449','2012-12-30','09:55:00',8.31),('6449','2012-12-30','10:00:00',8.59),('6449','2012-12-30','10:05:00',8.84),('6449','2012-12-30','10:10:00',9),('6449','2012-12-30','10:15:00',9.27),('6449','2012-12-30','10:20:00',9.48),('6449','2012-12-30','10:25:00',9.68),('6449','2012-12-30','10:30:00',9.87),('6449','2012-12-30','10:35:00',10.02),('6449','2012-12-30','10:40:00',10.1),('6449','2012-12-30','10:45:00',10.34),('6449','2012-12-30','10:50:00',10.5),('6449','2012-12-30','10:55:00',10.64),('6449','2012-12-30','11:00:00',10.75),('6449','2012-12-30','11:05:00',10.82),('6449','2012-12-30','11:10:00',10.89),('6449','2012-12-30','11:15:00',10.95),('6449','2012-12-30','11:20:00',11.04),('6449','2012-12-30','11:25:00',11.08),('6449','2012-12-30','11:30:00',11.07),('6449','2012-12-30','11:35:00',11.12),('6449','2012-12-30','11:40:00',11.07),('6449','2012-12-30','11:45:00',10.95),('6449','2012-12-30','11:50:00',10.89),('6449','2012-12-30','11:55:00',10.93),('6449','2012-12-30','12:00:00',10.94),('6449','2012-12-30','12:05:00',11.1),('6449','2012-12-30','12:10:00',11.05),('6449','2012-12-30','12:15:00',11.06),('6449','2012-12-30','12:20:00',11.04),('6449','2012-12-30','12:25:00',11.36),('6449','2012-12-30','12:30:00',11.06),('6449','2012-12-30','12:35:00',11.24),('6449','2012-12-30','12:40:00',11.16),('6449','2012-12-30','12:45:00',11.02),('6449','2012-12-30','12:50:00',11.02),('6449','2012-12-30','12:55:00',10.89),('6449','2012-12-30','13:00:00',10.63),('6449','2012-12-30','13:05:00',10.58),('6449','2012-12-30','13:10:00',10.44),('6449','2012-12-30','13:15:00',10.23),('6449','2012-12-30','13:20:00',10.01),('6449','2012-12-30','13:25:00',9.87),('6449','2012-12-30','13:30:00',9.67),('6449','2012-12-30','13:35:00',9.5),('6449','2012-12-30','13:40:00',9.4),('6449','2012-12-30','13:45:00',9.05),('6449','2012-12-30','13:50:00',8.98),('6449','2012-12-30','13:55:00',8.84),('6449','2012-12-30','14:00:00',8.56),('6449','2012-12-30','14:05:00',8.33),('6449','2012-12-30','14:10:00',8.19),('6449','2012-12-30','14:15:00',7.86),('6449','2012-12-30','14:20:00',7.68),('6449','2012-12-30','14:25:00',7.46),('6449','2012-12-30','14:30:00',7.27),('6449','2012-12-30','14:35:00',7.02),('6449','2012-12-30','14:40:00',6.74),('6449','2012-12-30','14:45:00',6.46),('6449','2012-12-30','14:50:00',6.17),('6449','2012-12-30','14:55:00',5.93),('6449','2012-12-30','15:00:00',5.62),('6449','2012-12-30','15:05:00',5.33),('6449','2012-12-30','15:10:00',5.04),('6449','2012-12-30','15:15:00',4.7),('6449','2012-12-30','15:20:00',4.39),('6449','2012-12-30','15:25:00',4.05),('6449','2012-12-30','15:30:00',3.68),('6449','2012-12-30','15:35:00',3.39),('6449','2012-12-30','15:40:00',3.07),('6449','2012-12-30','15:45:00',2.79),('6449','2012-12-30','15:50:00',2.49),('6449','2012-12-30','15:55:00',2.15),('6449','2012-12-30','16:00:00',1.83),('6449','2012-12-30','16:05:00',1.57),('6449','2012-12-30','16:10:00',1.33),('6449','2012-12-30','16:15:00',1.08),('6449','2012-12-29','07:55:00',1.08),('6449','2012-12-29','08:00:00',1.41),('6449','2012-12-29','08:05:00',1.74),('6449','2012-12-29','08:10:00',2.06),('6449','2012-12-29','08:15:00',2.48),('6449','2012-12-29','08:20:00',2.84),('6449','2012-12-29','08:25:00',3.17),('6449','2012-12-29','08:30:00',3.48),('6449','2012-12-29','08:35:00',3.82),('6449','2012-12-29','08:40:00',4.03),('6449','2012-12-29','08:45:00',4.4),('6449','2012-12-29','08:50:00',4.7),('6449','2012-12-29','08:55:00',5.04),('6449','2012-12-29','09:00:00',5.3),('6449','2012-12-29','09:05:00',5.58),('6449','2012-12-29','09:10:00',5.81),('6449','2012-12-29','09:15:00',6.11),('6449','2012-12-29','09:20:00',6.37),('6449','2012-12-29','09:25:00',6.66),('6449','2012-12-29','09:30:00',6.99),('6449','2012-12-29','09:35:00',7.26),('6449','2012-12-29','09:40:00',7.56),('6449','2012-12-29','09:45:00',7.79),('6449','2012-12-29','09:50:00',8.04),('6449','2012-12-29','09:55:00',8.07),('6449','2012-12-29','10:00:00',8.45),('6449','2012-12-29','10:05:00',8.66),('6449','2012-12-29','10:10:00',8.88),('6449','2012-12-29','10:15:00',9.11),('6449','2012-12-29','10:20:00',9.27),('6449','2012-12-29','10:25:00',9.35),('6449','2012-12-29','10:30:00',9.6),('6449','2012-12-29','10:35:00',9.74),('6449','2012-12-29','10:40:00',9.88),('6449','2012-12-29','10:45:00',10.04),('6449','2012-12-29','10:50:00',10.17),('6449','2012-12-29','10:55:00',10.31),('6449','2012-12-29','11:00:00',10.5),('6449','2012-12-29','11:05:00',10.65),('6449','2012-12-29','11:10:00',10.74),('6449','2012-12-29','11:15:00',10.84),('6449','2012-12-29','11:20:00',10.97),('6449','2012-12-29','11:25:00',11.05),('6449','2012-12-29','11:30:00',11.08),('6449','2012-12-29','11:35:00',11.1),('6449','2012-12-29','11:40:00',11.05),('6449','2012-12-29','11:45:00',11.02),('6449','2012-12-29','11:50:00',11.1),('6449','2012-12-29','11:55:00',11.01),('6449','2012-12-29','12:00:00',11.03),('6449','2012-12-29','12:05:00',11.05),('6449','2012-12-29','12:10:00',11.03),('6449','2012-12-29','12:15:00',11.14),('6449','2012-12-29','12:20:00',11.11),('6449','2012-12-29','12:25:00',10.93),('6449','2012-12-29','12:30:00',10.82),('6449','2012-12-29','12:35:00',10.76),('6449','2012-12-29','12:40:00',10.75),('6449','2012-12-29','12:45:00',10.71),('6449','2012-12-29','12:50:00',10.62),('6449','2012-12-29','12:55:00',10.55),('6449','2012-12-29','13:00:00',10.48),('6449','2012-12-29','13:05:00',10.36),('6449','2012-12-29','13:10:00',10.26),('6449','2012-12-29','13:15:00',10.01),('6449','2012-12-29','13:20:00',9.92),('6449','2012-12-29','13:25:00',9.85),('6449','2012-12-29','13:30:00',9.52),('6449','2012-12-29','13:35:00',9.65),('6449','2012-12-29','13:40:00',9.52),('6449','2012-12-29','13:45:00',9.44),('6449','2012-12-29','13:50:00',9.21),('6449','2012-12-29','13:55:00',9.15),('6449','2012-12-29','14:00:00',8.77),('6449','2012-12-29','14:06:00',8.69),('6449','2012-12-29','14:10:00',8.56),('6449','2012-12-29','14:15:00',8.2),('6449','2012-12-29','14:20:00',7.97),('6449','2012-12-29','14:25:00',7.72),('6449','2012-12-29','14:30:00',7.45),('6449','2012-12-29','14:35:00',7.16),('6449','2012-12-29','14:40:00',6.88),('6449','2012-12-29','14:45:00',6.61),('6449','2012-12-29','14:50:00',6.28),('6449','2012-12-29','14:55:00',6.03),('6449','2012-12-29','15:00:00',5.71),('6449','2012-12-29','15:05:00',5.41),('6449','2012-12-29','15:10:00',5.13),('6449','2012-12-29','15:15:00',4.7),('6449','2012-12-29','15:20:00',4.48),('6449','2012-12-29','15:25:00',4.13),('6449','2012-12-29','15:30:00',3.77),('6449','2012-12-29','15:35:00',3.44),('6449','2012-12-29','15:40:00',3.13),('6449','2012-12-29','15:45:00',2.82),('6449','2012-12-29','15:50:00',2.52),('6449','2012-12-29','15:55:00',2.2),('6449','2012-12-29','16:00:00',1.92),('6449','2012-12-29','16:05:00',1.63),('6449','2012-12-29','16:10:00',1.41),('6449','2012-12-29','16:15:00',1.13),('6449','2012-12-28','08:25:00',1.33),('6449','2012-12-28','08:30:00',2.62),('6449','2012-12-28','08:35:00',3.07),('6449','2012-12-28','08:40:00',3.55),('6449','2012-12-28','08:45:00',4.03),('6449','2012-12-28','08:50:00',4.3),('6449','2012-12-28','08:55:00',4.59),('6449','2012-12-28','09:00:00',4.81),('6449','2012-12-28','09:05:00',4.95),('6449','2012-12-28','09:10:00',5.05),('6449','2012-12-28','09:15:00',5.42),('6449','2012-12-28','09:20:00',5.78),('6449','2012-12-28','09:25:00',6.05),('6449','2012-12-28','09:30:00',6.37),('6449','2012-12-28','09:35:00',6.62),('6449','2012-12-28','09:40:00',6.81),('6449','2012-12-28','09:45:00',7.09),('6449','2012-12-28','09:50:00',7.4),('6449','2012-12-28','09:55:00',7.54),('6449','2012-12-28','10:00:00',7.81),('6449','2012-12-28','10:05:00',8.02),('6449','2012-12-28','10:10:00',8.26),('6449','2012-12-28','10:15:00',8.56),('6449','2012-12-28','10:20:00',8.84),('6449','2012-12-28','10:25:00',8.93),('6449','2012-12-28','10:30:00',9.36),('6449','2012-12-28','10:35:00',9.61),('6449','2012-12-28','10:40:00',9.69),('6449','2012-12-28','10:45:00',9.96),('6449','2012-12-28','10:50:00',10.08),('6449','2012-12-28','10:55:00',10.2),('6449','2012-12-28','11:00:00',10.29),('6449','2012-12-28','11:05:00',10.39),('6449','2012-12-28','11:10:00',10.48),('6449','2012-12-28','11:15:00',10.56),('6449','2012-12-28','11:20:00',10.59),('6449','2012-12-28','11:25:00',10.6),('6449','2012-12-28','11:30:00',10.73),('6449','2012-12-28','11:35:00',10.8),('6449','2012-12-28','11:40:00',10.76),('6449','2012-12-28','11:45:00',10.89),('6449','2012-12-28','11:50:00',10.89),('6449','2012-12-28','11:55:00',11.02),('6449','2012-12-28','12:00:00',11.04),('6449','2012-12-28','12:05:00',11.01),('6449','2012-12-28','12:10:00',11.01),('6449','2012-12-28','12:15:00',11.03),('6449','2012-12-28','12:20:00',11.09),('6449','2012-12-28','12:25:00',10.88),('6449','2012-12-28','12:30:00',10.79),('6449','2012-12-28','12:35:00',10.62),('6449','2012-12-28','12:40:00',10.3),('6449','2012-12-28','12:45:00',10.36),('6449','2012-12-28','12:50:00',10.17),('6449','2012-12-28','12:55:00',10.02),('6449','2012-12-28','13:00:00',9.9),('6449','2012-12-28','13:05:00',9.95),('6449','2012-12-28','13:10:00',9.67),('6449','2012-12-28','13:15:00',9.53),('6449','2012-12-28','13:20:00',9.42),('6449','2012-12-28','13:25:00',9.15),('6449','2012-12-28','13:30:00',9.1),('6449','2012-12-28','13:35:00',9.05),('6449','2012-12-28','13:40:00',8.98),('6449','2012-12-28','13:45:00',8.82),('6449','2012-12-28','13:50:00',8.74),('6449','2012-12-28','13:55:00',8.58),('6449','2012-12-28','14:00:00',8.2),('6449','2012-12-28','14:05:00',8.01),('6449','2012-12-28','14:10:00',7.86),('6449','2012-12-28','14:15:00',7.6),('6449','2012-12-28','14:20:00',7.38),('6449','2012-12-28','14:25:00',7.12),('6449','2012-12-28','14:30:00',6.85),('6449','2012-12-28','14:35:00',6.59),('6449','2012-12-28','14:40:00',6.35),('6449','2012-12-28','14:45:00',6.06),('6449','2012-12-28','14:50:00',5.8),('6449','2012-12-28','14:55:00',5.52),('6449','2012-12-28','15:00:00',5.22),('6449','2012-12-28','15:05:00',4.94),('6449','2012-12-28','15:10:00',4.58),('6449','2012-12-28','15:15:00',4.34),('6449','2012-12-28','15:20:00',4.05),('6449','2012-12-28','15:25:00',3.71),('6449','2012-12-28','15:30:00',3.4),('6449','2012-12-28','15:35:00',3.07),('6449','2012-12-28','15:40:00',2.74),('6449','2012-12-28','15:45:00',2.43),('6449','2012-12-28','15:50:00',2.12),('6449','2012-12-28','15:55:00',1.8),('6449','2012-12-28','16:00:00',1.54),('6449','2012-12-28','16:05:00',1.31),('6449','2012-12-28','16:10:00',1.11),('6449','2012-12-27','08:05:00',1.35),('6449','2012-12-27','08:10:00',1.65),('6449','2012-12-27','08:15:00',1.94),('6449','2012-12-27','08:20:00',2.16),('6449','2012-12-27','08:25:00',2.41),('6449','2012-12-27','08:30:00',2.63),('6449','2012-12-27','08:35:00',2.75),('6449','2012-12-27','08:40:00',1.63),('6449','2012-12-27','08:45:00',1.39),('6449','2012-12-27','08:50:00',1.46),('6449','2012-12-27','08:55:00',1.28),('6449','2012-12-27','09:00:00',1.94),('6449','2012-12-27','09:05:00',1.74),('6449','2012-12-27','09:10:00',2.69),('6449','2012-12-27','09:15:00',5.83),('6449','2012-12-27','09:20:00',4.13),('6449','2012-12-27','09:25:00',2.19),('6449','2012-12-27','09:30:00',3.58),('6449','2012-12-27','09:35:00',5.37),('6449','2012-12-27','09:40:00',5.71),('6449','2012-12-27','09:45:00',6.87),('6449','2012-12-27','09:50:00',7.04),('6449','2012-12-27','09:55:00',7.37),('6449','2012-12-27','10:00:00',7.72),('6449','2012-12-27','10:05:00',7.81),('6449','2012-12-27','10:10:00',8.01),('6449','2012-12-27','10:15:00',8.19),('6449','2012-12-27','10:20:00',8.34),('6449','2012-12-27','10:25:00',8.44),('6449','2012-12-27','10:30:00',8.77),('6449','2012-12-27','10:35:00',8.83),('6449','2012-12-27','10:40:00',9.04),('6449','2012-12-27','10:45:00',9.33),('6449','2012-12-27','10:50:00',9.42),('6449','2012-12-27','10:55:00',9.63),('6449','2012-12-27','11:00:00',9.83),('6449','2012-12-27','11:05:00',9.94),('6449','2012-12-27','11:10:00',10),('6449','2012-12-27','11:15:00',10.08),('6449','2012-12-27','11:20:00',10.05),('6449','2012-12-27','11:25:00',10.06),('6449','2012-12-27','11:30:00',10.31),('6449','2012-12-27','11:36:00',10.64),('6449','2012-12-27','11:40:00',9.71),('6449','2012-12-27','11:45:00',6.24),('6449','2012-12-27','11:50:00',7.17),('6449','2012-12-27','11:55:00',3.25),('6449','2012-12-27','12:00:00',2.62),('6449','2012-12-27','12:05:00',10.66),('6449','2012-12-27','12:10:00',10.73),('6449','2012-12-27','12:15:00',10.47),('6449','2012-12-27','12:20:00',10.59),('6449','2012-12-27','12:25:00',10.48),('6449','2012-12-27','12:30:00',10.28),('6449','2012-12-27','12:35:00',10.47),('6449','2012-12-27','12:40:00',10.36),('6449','2012-12-27','12:45:00',10.34),('6449','2012-12-27','12:50:00',8.47),('6449','2012-12-27','12:55:00',9.95),('6449','2012-12-27','13:00:00',10.04),('6449','2012-12-27','13:05:00',9.86),('6449','2012-12-27','13:10:00',9.52),('6449','2012-12-27','13:15:00',9.52),('6449','2012-12-27','13:20:00',9.51),('6449','2012-12-27','13:25:00',9.11),('6449','2012-12-27','13:30:00',3.17),('6449','2012-12-27','13:35:00',2.19),('6449','2012-12-27','13:40:00',3.6),('6449','2012-12-27','13:45:00',6.89),('6449','2012-12-27','13:50:00',3.84),('6449','2012-12-27','13:55:00',3.16),('6449','2012-12-27','14:00:00',2.8),('6449','2012-12-27','14:05:00',5.09),('6449','2012-12-27','14:10:00',8.88),('6449','2012-12-27','14:15:00',6.44),('6449','2012-12-27','14:20:00',6.97),('6449','2012-12-27','14:25:00',7.14),('6449','2012-12-27','14:30:00',6.91),('6449','2012-12-27','14:35:00',6.64),('6449','2012-12-27','14:40:00',6.37),('6449','2012-12-27','14:45:00',6.28),('6449','2012-12-27','14:50:00',5.91),('6449','2012-12-27','14:55:00',5.59),('6449','2012-12-27','15:00:00',5.39),('6449','2012-12-27','15:05:00',5.15),('6449','2012-12-27','15:10:00',4.86),('6449','2012-12-27','15:15:00',4.41),('6449','2012-12-27','15:20:00',3.82),('6449','2012-12-27','15:25:00',3.79),('6449','2012-12-27','15:30:00',3.73),('6449','2012-12-27','15:35:00',3.34),('6449','2012-12-27','15:40:00',2.33),('6449','2012-12-27','15:45:00',1.51),('6449','2012-12-27','15:50:00',2.16),('6449','2012-12-27','15:55:00',2.07),('6449','2012-12-27','16:00:00',1.62),('6449','2012-12-26','08:25:00',1.09),('6449','2012-12-26','08:30:00',1.51),('6449','2012-12-26','08:35:00',1.72),('6449','2012-12-26','08:40:00',1.09),('6449','2012-12-26','08:45:00',2.48),('6449','2012-12-26','08:55:00',1.17),('6449','2012-12-26','09:00:00',4.71),('6449','2012-12-26','09:05:00',4.97),('6449','2012-12-26','09:10:00',5.2),('6449','2012-12-26','09:15:00',5.42),('6449','2012-12-26','09:20:00',5.59),('6449','2012-12-26','09:25:00',5.97),('6449','2012-12-26','09:30:00',6.35),('6449','2012-12-26','09:35:00',6.65),('6449','2012-12-26','09:40:00',6.74),('6449','2012-12-26','09:45:00',7.03),('6449','2012-12-26','09:50:00',7.45),('6449','2012-12-26','09:55:00',7.68),('6449','2012-12-26','10:00:00',6.95),('6449','2012-12-26','10:05:00',4.11),('6449','2012-12-26','10:10:00',2.52),('6449','2012-12-26','10:15:00',2.36),('6449','2012-12-26','10:20:00',2.23),('6449','2012-12-26','10:25:00',2.13),('6449','2012-12-26','10:30:00',2.02),('6449','2012-12-26','10:35:00',2),('6449','2012-12-26','10:40:00',2.08),('6449','2012-12-26','10:45:00',1.84),('6449','2012-12-26','10:50:00',1.72),('6449','2012-12-26','10:55:00',1.54),('6449','2012-12-26','11:00:00',1.73),('6449','2012-12-26','11:05:00',1.59),('6449','2012-12-26','11:10:00',1.72),('6449','2012-12-26','11:15:00',2.01),('6449','2012-12-26','11:20:00',2.07),('6449','2012-12-26','11:25:00',2.07),('6449','2012-12-26','11:30:00',1.89),('6449','2012-12-26','11:35:00',2),('6449','2012-12-26','11:40:00',2.01),('6449','2012-12-26','11:45:00',2.01),('6449','2012-12-26','11:50:00',2.05),('6449','2012-12-26','11:55:00',2.53),('6449','2012-12-26','12:00:00',2.45),('6449','2012-12-26','12:05:00',2.21),('6449','2012-12-26','12:10:00',2.27),('6449','2012-12-26','12:15:00',2.17),('6449','2012-12-26','12:20:00',2.2),('6449','2012-12-26','12:25:00',2.19),('6449','2012-12-26','12:30:00',2.45),('6449','2012-12-26','12:35:00',2.87),('6449','2012-12-26','12:40:00',2.5),('6449','2012-12-26','12:45:00',1.91),('6449','2012-12-26','12:50:00',1.58),('6449','2012-12-26','12:55:00',1.77),('6449','2012-12-26','13:00:00',2.18),('6449','2012-12-26','13:05:00',2.07),('6449','2012-12-26','13:10:00',1.63),('6449','2012-12-26','13:15:00',2.15),('6449','2012-12-26','13:20:00',2.35),('6449','2012-12-26','13:25:00',2.79),('6449','2012-12-26','13:30:00',2.89),('6449','2012-12-26','13:35:00',2.58),('6449','2012-12-26','13:40:00',1.77),('6449','2012-12-26','13:45:00',1.42),('6449','2012-12-26','13:50:00',1.62),('6449','2012-12-26','13:55:00',1.42),('6449','2012-12-26','14:00:00',1.25),('6449','2012-12-26','14:05:00',1.32),('6449','2012-12-26','14:10:00',1.26),('6449','2012-12-26','14:15:00',1.26),('6449','2012-12-26','14:20:00',1.1),('6449','2012-12-26','14:25:00',1.39),('6449','2012-12-26','14:30:00',1.61),('6449','2012-12-26','14:35:00',1.62),('6449','2012-12-26','14:40:00',1.72),('6449','2012-12-26','14:45:00',1.8),('6449','2012-12-26','14:50:00',2.49),('6449','2012-12-26','14:55:00',2.24),('6449','2012-12-26','15:00:00',1.76),('6449','2012-12-26','15:05:00',1.44),('6449','2012-12-26','15:10:00',1.32),('6449','2012-12-26','15:15:00',1.26),('6449','2012-12-26','15:20:00',1.1),('6449','2012-12-26','15:25:00',1.1),('6449','2012-12-26','15:45:00',1.01),('6449','2012-12-25','09:00:00',1.07),('6449','2012-12-25','09:05:00',1.25),('6449','2012-12-25','09:10:00',1.25),('6449','2012-12-25','09:15:00',1.4),('6449','2012-12-25','09:20:00',1.39),('6449','2012-12-25','09:25:00',1.38),('6449','2012-12-25','09:30:00',1.51),('6449','2012-12-25','09:35:00',1.68),('6449','2012-12-25','09:40:00',1.72),('6449','2012-12-25','09:45:00',1.78),('6449','2012-12-25','09:50:00',2.02),('6449','2012-12-25','09:55:00',1.85),('6449','2012-12-25','10:00:00',1.76),('6449','2012-12-25','10:05:00',1.85),('6449','2012-12-25','10:10:00',2.01),('6449','2012-12-25','10:15:00',2.11),('6449','2012-12-25','10:20:00',2.13),('6449','2012-12-25','10:25:00',2.13),('6449','2012-12-25','10:30:00',2.18),('6449','2012-12-25','10:35:00',2.38),('6449','2012-12-25','10:40:00',2.35),('6449','2012-12-25','10:45:00',2.23),('6449','2012-12-25','10:50:00',2.17),('6449','2012-12-25','10:55:00',2.05),('6449','2012-12-25','11:00:00',2.07),('6449','2012-12-25','11:05:00',2.26),('6449','2012-12-25','11:10:00',2.2),('6449','2012-12-25','11:15:00',2.23),('6449','2012-12-25','11:20:00',2.08),('6449','2012-12-25','11:25:00',2.41),('6449','2012-12-25','11:30:00',2.94),('6449','2012-12-25','11:35:00',2.89),('6449','2012-12-25','11:40:00',2.84),('6449','2012-12-25','11:45:00',2.82),('6449','2012-12-25','11:50:00',2.77),('6449','2012-12-25','11:55:00',2.8),('6449','2012-12-25','12:00:00',2.95),('6449','2012-12-25','12:05:00',3.06),('6449','2012-12-25','12:10:00',2.92),('6449','2012-12-25','12:15:00',2.51),('6449','2012-12-25','12:20:00',2.27),('6449','2012-12-25','12:25:00',2.39),('6449','2012-12-25','12:30:00',2.67),('6449','2012-12-25','12:35:00',3.02),('6449','2012-12-25','12:40:00',3.42),('6449','2012-12-25','12:45:00',4.96),('6449','2012-12-25','12:50:00',6.69),('6449','2012-12-25','12:55:00',6.47),('6449','2012-12-25','13:00:00',4.57),('6449','2012-12-25','13:05:00',3.99),('6449','2012-12-25','13:10:00',3.09),('6449','2012-12-25','13:15:00',3.05),('6449','2012-12-25','13:20:00',3.55),('6449','2012-12-25','13:25:00',3.51),('6449','2012-12-25','13:30:00',3.3),('6449','2012-12-25','13:35:00',3.32),('6449','2012-12-25','13:40:00',2.49),('6449','2012-12-25','13:45:00',3.08),('6449','2012-12-25','13:50:00',2.57),('6449','2012-12-25','13:55:00',2.36),('6449','2012-12-25','14:00:00',2.04),('6449','2012-12-25','14:05:00',2.11),('6449','2012-12-25','14:10:00',2.69),('6449','2012-12-25','14:15:00',3.37),('6449','2012-12-25','14:20:00',3.24),('6449','2012-12-25','14:25:00',2.4),('6449','2012-12-25','14:30:00',2.22),('6449','2012-12-25','14:35:00',2.33),('6449','2012-12-25','14:40:00',2.04),('6449','2012-12-25','14:45:00',1.48),('6449','2012-12-25','14:50:00',1.68),('6449','2012-12-25','14:55:00',1.85),('6449','2012-12-25','15:00:00',1.96),('6449','2012-12-25','15:05:00',1.96),('6449','2012-12-25','15:10:00',2.2),('6449','2012-12-25','15:15:00',2.71),('6449','2012-12-25','15:20:00',2.82),('6449','2012-12-25','15:25:00',2.37),('6449','2012-12-25','15:30:00',1.98),('6449','2012-12-25','15:35:00',1.95),('6449','2012-12-25','15:40:00',1.72),('6449','2012-12-25','15:45:00',1.68),('6449','2012-12-25','15:50:00',1.43),('6449','2012-12-25','15:55:00',1.16),('6449','2012-12-24','09:35:00',1),('6449','2012-12-24','10:00:00',1.13),('6449','2012-12-24','10:05:00',1.22),('6449','2012-12-24','10:10:00',1.18),('6449','2012-12-24','10:15:00',1.14),('6449','2012-12-24','10:20:00',1.12),('6449','2012-12-24','10:25:00',1.06),('6449','2012-12-24','10:30:00',1.23),('6449','2012-12-24','10:35:00',1.73),('6449','2012-12-24','10:42:00',1.83),('6449','2012-12-24','10:45:00',1.96),('6449','2012-12-24','10:50:00',2),('6449','2012-12-24','10:55:00',2.15),('6449','2012-12-24','11:00:00',2.2),('6449','2012-12-24','11:05:00',2.27),('6449','2012-12-24','11:10:00',2.34),('6449','2012-12-24','11:15:00',2.24),('6449','2012-12-24','11:20:00',2.28),('6449','2012-12-24','11:25:00',2.56),('6449','2012-12-24','11:30:00',2.65),('6449','2012-12-24','11:35:00',2.73),('6449','2012-12-24','11:40:00',2.73),('6449','2012-12-24','11:45:00',2.31),('6449','2012-12-24','11:50:00',2.48),('6449','2012-12-24','11:55:00',2.6),('6449','2012-12-24','12:00:00',2.4),('6449','2012-12-24','12:05:00',2.42),('6449','2012-12-24','12:10:00',2.4),('6449','2012-12-24','12:15:00',2.51),('6449','2012-12-24','12:20:00',2.13),('6449','2012-12-24','12:25:00',2.38),('6449','2012-12-24','12:30:00',2.29),('6449','2012-12-24','12:35:00',2.21),('6449','2012-12-24','12:40:00',2.25),('6449','2012-12-24','12:45:00',2.21),('6449','2012-12-24','12:50:00',2.15),('6449','2012-12-24','12:55:00',2.04),('6449','2012-12-24','13:00:00',1.96),('6449','2012-12-24','13:05:00',1.89),('6449','2012-12-24','13:10:00',1.98),('6449','2012-12-24','13:15:00',2.14),('6449','2012-12-24','13:20:00',2.34),('6449','2012-12-24','13:25:00',2.36),('6449','2012-12-24','13:30:00',2.19),('6449','2012-12-24','13:35:00',1.99),('6449','2012-12-24','13:40:00',1.76),('6449','2012-12-24','13:45:00',1.55),('6449','2012-12-24','13:50:00',1.42),('6449','2012-12-24','13:55:00',1.5),('6449','2012-12-24','14:00:00',1.47),('6449','2012-12-24','14:05:00',1.52),('6449','2012-12-24','14:10:00',1.64),('6449','2012-12-24','14:15:00',1.59),('6449','2012-12-24','14:20:00',1.37),('6449','2012-12-24','14:25:00',1.27),('6449','2012-12-24','14:30:00',1.16),('6449','2012-12-24','14:35:00',1),('6449','2012-12-24','15:00:00',1),('6449','2012-12-23','07:55:00',1.15),('6449','2012-12-23','08:00:00',1.53),('6449','2012-12-23','08:05:00',1.87),('6449','2012-12-23','08:10:00',2.23),('6449','2012-12-23','08:15:00',2.46),('6449','2012-12-23','08:20:00',2.73),('6449','2012-12-23','08:25:00',3.09),('6449','2012-12-23','08:30:00',3.47),('6449','2012-12-23','08:35:00',3.78),('6449','2012-12-23','08:40:00',4.06),('6449','2012-12-23','08:45:00',4.32),('6449','2012-12-23','08:50:00',4.68),('6449','2012-12-23','08:55:00',4.9),('6449','2012-12-23','09:00:00',5.11),('6449','2012-12-23','09:05:00',5.23),('6449','2012-12-23','09:10:00',5.5),('6449','2012-12-23','09:15:00',5.58),('6449','2012-12-23','09:20:00',5.85),('6449','2012-12-23','09:25:00',6.08),('6449','2012-12-23','09:30:00',6.41),('6449','2012-12-23','09:35:00',6.83),('6449','2012-12-23','09:40:00',7.22),('6449','2012-12-23','09:45:00',7.31),('6449','2012-12-23','09:50:00',7.46),('6449','2012-12-23','09:55:00',7.85),('6449','2012-12-23','10:00:00',8.16),('6449','2012-12-23','10:05:00',8.48),('6449','2012-12-23','10:10:00',8.6),('6449','2012-12-23','10:15:00',8.86),('6449','2012-12-23','10:20:00',9.06),('6449','2012-12-23','10:25:00',9.13),('6449','2012-12-23','10:30:00',9.37),('6449','2012-12-23','10:35:00',9.49),('6449','2012-12-23','10:40:00',9.35),('6449','2012-12-23','10:45:00',9.78),('6449','2012-12-23','10:50:00',9.91),('6449','2012-12-23','10:55:00',9.85),('6449','2012-12-23','11:00:00',9.9),('6449','2012-12-23','11:05:00',10.26),('6449','2012-12-23','11:10:00',10.09),('6449','2012-12-23','11:15:00',9.91),('6449','2012-12-23','11:20:00',9.48),('6449','2012-12-23','11:25:00',9.83),('6449','2012-12-23','11:30:00',10.5),('6449','2012-12-23','11:35:00',10.61),('6449','2012-12-23','11:40:00',9.71),('6449','2012-12-23','11:45:00',10.7),('6449','2012-12-23','11:50:00',10.66),('6449','2012-12-23','11:55:00',9.83),('6449','2012-12-23','12:00:00',9.19),('6449','2012-12-23','12:05:00',10.57),('6449','2012-12-23','12:10:00',10.53),('6449','2012-12-23','12:15:00',10.38),('6449','2012-12-23','12:20:00',10.01),('6449','2012-12-23','12:25:00',9.76),('6449','2012-12-23','12:30:00',8.83),('6449','2012-12-23','12:35:00',10.31),('6449','2012-12-23','12:40:00',10.24),('6449','2012-12-23','12:45:00',10.4),('6449','2012-12-23','12:50:00',10.15),('6449','2012-12-23','12:55:00',8.25),('6449','2012-12-23','13:00:00',7.47),('6449','2012-12-23','13:05:00',8.14),('6449','2012-12-23','13:10:00',7.81),('6449','2012-12-23','13:15:00',8.72),('6449','2012-12-23','13:20:00',7.14),('6449','2012-12-23','13:25:00',7.54),('6449','2012-12-23','13:30:00',5.66),('6449','2012-12-23','13:35:00',4.07),('6449','2012-12-23','13:40:00',5.3),('6449','2012-12-23','13:45:00',8.44),('6449','2012-12-23','13:50:00',8.51),('6449','2012-12-23','13:55:00',8.04),('6449','2012-12-23','14:00:00',7.08),('6449','2012-12-23','14:05:00',5.44),('6449','2012-12-23','14:10:00',4.38),('6449','2012-12-23','14:15:00',4.04),('6449','2012-12-23','14:20:00',3.65),('6449','2012-12-23','14:25:00',3.57),('6449','2012-12-23','14:30:00',4.78),('6449','2012-12-23','14:36:00',5.81),('6449','2012-12-23','14:40:00',6.47),('6449','2012-12-23','14:45:00',6.57),('6449','2012-12-23','14:50:00',5.99),('6449','2012-12-23','14:56:00',5.82),('6449','2012-12-23','15:00:00',5.22),('6449','2012-12-23','15:05:00',4.63),('6449','2012-12-23','15:10:00',4.58),('6449','2012-12-23','15:15:00',3.36),('6449','2012-12-23','15:20:00',1.68),('6449','2012-12-23','15:25:00',1.4),('6449','2012-12-23','15:30:00',3.14),('6449','2012-12-23','15:35:00',3.25),('6449','2012-12-23','15:40:00',2.99),('6449','2012-12-23','15:45:00',2.66),('6449','2012-12-23','15:50:00',2.2),('6449','2012-12-23','15:55:00',1.81),('6449','2012-12-23','16:00:00',1.29),('6449','2012-12-22','09:45:00',1.11),('6449','2012-12-22','09:50:00',1.3),('6449','2012-12-22','09:55:00',1.49),('6449','2012-12-22','10:00:00',1.72),('6449','2012-12-22','10:05:00',1.83),('6449','2012-12-22','10:10:00',1.85),('6449','2012-12-22','10:15:00',2.02),('6449','2012-12-22','10:20:00',2.19),('6449','2012-12-22','10:25:00',2.72),('6449','2012-12-22','10:30:00',3.36),('6449','2012-12-22','10:35:00',3.02),('6449','2012-12-22','10:40:00',2.75),('6449','2012-12-22','10:45:00',2.53),('6449','2012-12-22','10:50:00',2.96),('6449','2012-12-22','10:55:00',3.26),('6449','2012-12-22','11:00:00',3.45),('6449','2012-12-22','11:05:00',3.77),('6449','2012-12-22','11:10:00',3.69),('6449','2012-12-22','11:15:00',3.7),('6449','2012-12-22','11:20:00',4.02),('6449','2012-12-22','11:25:00',5.91),('6449','2012-12-22','11:30:00',5.92),('6449','2012-12-22','11:35:00',9.38),('6449','2012-12-22','11:40:00',11.68),('6449','2012-12-22','11:45:00',12.33),('6449','2012-12-22','11:50:00',7.42),('6449','2012-12-22','11:55:00',7.59),('6449','2012-12-22','12:00:00',4.91),('6449','2012-12-22','12:05:00',4.97),('6449','2012-12-22','12:10:00',3.38),('6449','2012-12-22','12:15:00',2.54),('6449','2012-12-22','12:20:00',2.61),('6449','2012-12-22','12:25:00',2.46),('6449','2012-12-22','12:30:00',2.18),('6449','2012-12-22','12:35:00',1.85),('6449','2012-12-22','12:40:00',1.88),('6449','2012-12-22','12:45:00',2.13),('6449','2012-12-22','12:50:00',2.3),('6449','2012-12-22','12:55:00',2.5),('6449','2012-12-22','13:00:00',2.85),('6449','2012-12-22','13:05:00',2.97),('6449','2012-12-22','13:10:00',2.76),('6449','2012-12-22','13:15:00',2.34),('6449','2012-12-22','13:20:00',1.82),('6449','2012-12-22','13:25:00',1.38),('6449','2012-12-22','13:30:00',2.31),('6449','2012-12-22','13:35:00',2.97),('6449','2012-12-22','13:40:00',3.66),('6449','2012-12-22','13:45:00',3.67),('6449','2012-12-22','13:50:00',2.39),('6449','2012-12-22','13:55:00',4.16),('6449','2012-12-22','14:00:00',7.99),('6449','2012-12-22','14:05:00',9.22),('6449','2012-12-22','14:10:00',8.49),('6449','2012-12-22','14:15:00',3.93),('6449','2012-12-22','14:20:00',4.38),('6449','2012-12-22','14:25:00',7.47),('6449','2012-12-22','14:30:00',7.3),('6449','2012-12-22','14:35:00',7.37),('6449','2012-12-22','14:40:00',4.65),('6449','2012-12-22','14:45:00',2.46),('6449','2012-12-22','14:50:00',5.19),('6449','2012-12-22','14:55:00',5.23),('6449','2012-12-22','15:00:00',5.08),('6449','2012-12-22','15:05:00',4.48),('6449','2012-12-22','15:10:00',4.43),('6449','2012-12-22','15:15:00',4.18),('6449','2012-12-22','15:20:00',4.01),('6449','2012-12-22','15:25:00',3.61),('6449','2012-12-22','15:30:00',3.27),('6449','2012-12-22','15:35:00',2.97),('6449','2012-12-22','15:40:00',2.65),('6449','2012-12-22','15:45:00',2.28),('6449','2012-12-22','15:50:00',1.98),('6449','2012-12-22','15:55:00',1.73),('6449','2012-12-22','16:00:00',1.51),('6449','2012-12-22','16:05:00',1.29),('6449','2012-12-22','16:10:00',1.05),('7643','2014-05-04','07:10:00',1.64),('7643','2014-05-04','07:15:00',2.36),('7643','2014-05-04','07:20:00',2.6),('7643','2014-05-04','07:25:00',2.84),('7643','2014-05-04','07:30:00',2.16),('7643','2014-05-04','07:35:00',1.49),('7643','2014-05-04','07:40:00',2.08),('7643','2014-05-04','07:45:00',4.14),('7643','2014-05-04','07:50:00',4.78),('7643','2014-05-04','07:55:00',5.19),('7643','2014-05-04','08:00:00',5.6),('7643','2014-05-04','08:05:00',5.96),('7643','2014-05-04','08:10:00',6.36),('7643','2014-05-04','08:15:00',6.85),('7643','2014-05-04','08:20:00',7.2),('7643','2014-05-04','08:25:00',7.61),('7643','2014-05-04','08:30:00',7.99),('7643','2014-05-04','08:35:00',8.4),('7643','2014-05-04','08:40:00',8.82),('7643','2014-05-04','08:45:00',9.17),('7643','2014-05-04','08:50:00',9.46),('7643','2014-05-04','08:55:00',9.71),('7643','2014-05-04','09:00:00',9.92),('7643','2014-05-04','09:05:00',10.18),('7643','2014-05-04','09:10:00',10.54),('7643','2014-05-04','09:15:00',10.86),('7643','2014-05-04','09:20:00',11.11),('7643','2014-05-04','09:25:00',11.46),('7643','2014-05-04','09:30:00',11.85),('7643','2014-05-04','09:35:00',12.11),('7643','2014-05-04','09:40:00',12.53),('7643','2014-05-04','09:45:00',12.8),('7643','2014-05-04','09:50:00',13.15),('7643','2014-05-04','09:55:00',13.41),('7643','2014-05-04','10:00:00',13.67),('7643','2014-05-04','10:05:00',13.83),('7643','2014-05-04','10:10:00',14.04),('7643','2014-05-04','10:15:00',14.12),('7643','2014-05-04','10:20:00',14.23),('7643','2014-05-04','10:25:00',14.45),('7643','2014-05-04','10:30:00',14.59),('7643','2014-05-04','10:35:00',14.83),('7643','2014-05-04','10:40:00',14.9),('7643','2014-05-04','10:45:00',14.97),('7643','2014-05-04','10:50:00',15.24),('7643','2014-05-04','10:55:00',15.46),('7643','2014-05-04','11:00:00',15.65),('7643','2014-05-04','11:05:00',15.67),('7643','2014-05-04','11:10:00',15.78),('7643','2014-05-04','11:15:00',15.95),('7643','2014-05-04','11:20:00',15.95),('7643','2014-05-04','11:25:00',16.05),('7643','2014-05-04','11:30:00',16.07),('7643','2014-05-04','11:35:00',16.16),('7643','2014-05-04','11:40:00',16.43),('7643','2014-05-04','11:45:00',16.59),('7643','2014-05-04','11:50:00',16.72),('7643','2014-05-04','11:55:00',16.91),('7643','2014-05-04','12:00:00',14.77),('7643','2014-05-04','12:05:00',8.64),('7643','2014-05-04','12:10:00',9.43),('7643','2014-05-04','12:15:00',16.9),('7643','2014-05-04','12:20:00',7.99),('7643','2014-05-04','12:25:00',13.72),('7643','2014-05-04','12:30:00',9.3),('7643','2014-05-04','12:35:00',9.69),('7643','2014-05-04','12:40:00',9.43),('7643','2014-05-04','12:45:00',15.48),('7643','2014-05-04','12:50:00',14.16),('7643','2014-05-04','12:55:00',6.84),('7643','2014-05-04','13:00:00',15.31),('7643','2014-05-04','13:05:00',14.83),('7643','2014-05-04','13:10:00',12.59),('7643','2014-05-04','13:15:00',18.13),('7643','2014-05-04','13:20:00',16.26),('7643','2014-05-04','13:25:00',17.29),('7643','2014-05-04','13:30:00',15.09),('7643','2014-05-04','13:35:00',16.12),('7643','2014-05-04','13:40:00',17.57),('7643','2014-05-04','13:45:00',17.36),('7643','2014-05-04','13:50:00',17.41),('7643','2014-05-04','13:55:00',17.25),('7643','2014-05-04','14:00:00',17.32),('7643','2014-05-04','14:05:00',17.88),('7643','2014-05-04','14:10:00',17.44),('7643','2014-05-04','14:15:00',14.32),('7643','2014-05-04','14:20:00',15.95),('7643','2014-05-04','14:25:00',9.45),('7643','2014-05-04','14:30:00',10.3),('7643','2014-05-04','14:35:00',6.21),('7643','2014-05-04','14:40:00',7.7),('7643','2014-05-04','14:45:00',4.82),('7643','2014-05-04','14:50:00',4.78),('7643','2014-05-04','14:55:00',5.9),('7643','2014-05-04','15:00:00',5.84),('7643','2014-05-04','15:05:00',14.25),('7643','2014-05-04','15:10:00',10.52),('7643','2014-05-04','15:15:00',5.46),('7643','2014-05-04','15:20:00',5.75),('7643','2014-05-04','15:25:00',6.71),('7643','2014-05-04','15:30:00',15.63),('7643','2014-05-04','15:35:00',16.4),('7643','2014-05-04','15:40:00',15.57),('7643','2014-05-04','15:45:00',6.18),('7643','2014-05-04','15:50:00',5.57),('7643','2014-05-04','15:55:00',5.24),('7643','2014-05-04','16:00:00',4.27),('7643','2014-05-04','16:05:00',4.89),('7643','2014-05-04','16:10:00',4.99),('7643','2014-05-04','16:15:00',4.85),('7643','2014-05-04','16:20:00',4.93),('7643','2014-05-04','16:25:00',4.36),('7643','2014-05-04','16:30:00',3.83),('7643','2014-05-04','16:35:00',3.27),('7643','2014-05-04','16:40:00',4.76),('7643','2014-05-04','16:45:00',5.86),('7643','2014-05-04','16:50:00',10.87),('7643','2014-05-04','16:55:00',10.59),('7643','2014-05-04','17:00:00',9.93),('7643','2014-05-04','17:05:00',9.54),('7643','2014-05-04','17:10:00',9.66),('7643','2014-05-04','17:15:00',9.35),('7643','2014-05-04','17:20:00',8.85),('7643','2014-05-04','17:25:00',8.3),('7643','2014-05-04','17:30:00',7.63),('7643','2014-05-04','17:35:00',7.28),('7643','2014-05-04','17:40:00',6.81),('7643','2014-05-04','17:45:00',6.39),('7643','2014-05-04','17:50:00',6.04),('7643','2014-05-04','17:55:00',5.76),('7643','2014-05-04','18:00:00',5.34),('7643','2014-05-04','18:05:00',4.95),('7643','2014-05-04','18:10:00',4.6),('7643','2014-05-04','18:15:00',4.2),('7643','2014-05-04','18:20:00',3.89),('7643','2014-05-04','18:25:00',3.55),('7643','2014-05-04','18:30:00',3.22),('7643','2014-05-04','18:35:00',2.91),('7643','2014-05-04','18:40:00',2.57),('7643','2014-05-04','18:45:00',2.21),('7643','2014-05-04','18:50:00',1.83),('7643','2014-05-04','18:55:00',1.53),('7643','2014-05-04','19:00:00',1.33),('7643','2014-05-04','19:05:00',1.11),('7643','2014-04-25','07:30:00',1.04),('7643','2014-04-25','07:35:00',1.06),('7643','2014-04-25','07:40:00',1.17),('7643','2014-04-25','07:45:00',1.46),('7643','2014-04-25','07:50:00',1.75),('7643','2014-04-25','07:55:00',1.92),('7643','2014-04-25','08:00:00',2.08),('7643','2014-04-25','08:05:00',2.28),('7643','2014-04-25','08:10:00',2.48),('7643','2014-04-25','08:15:00',2.48),('7643','2014-04-25','08:20:00',2.6),('7643','2014-04-25','08:25:00',2.71),('7643','2014-04-25','08:30:00',2.53),('7643','2014-04-25','08:35:00',2.78),('7643','2014-04-25','08:40:00',3.09),('7643','2014-04-25','08:45:00',3.36),('7643','2014-04-25','08:50:00',3.45),('7643','2014-04-25','08:55:00',3.18),('7643','2014-04-25','09:00:00',3.3),('7643','2014-04-25','09:05:00',3.61),('7643','2014-04-25','09:10:00',3.11),('7643','2014-04-25','09:15:00',2.85),('7643','2014-04-25','09:20:00',2.98),('7643','2014-04-25','09:25:00',2.96),('7643','2014-04-25','09:30:00',3.05),('7643','2014-04-25','09:35:00',3.37),('7643','2014-04-25','09:40:00',3.59),('7643','2014-04-25','09:45:00',3.13),('7643','2014-04-25','09:50:00',4.04),('7643','2014-04-25','09:55:00',5.38),('7643','2014-04-25','10:00:00',5.18),('7643','2014-04-25','10:05:00',4.77),('7643','2014-04-25','10:10:00',4.72),('7643','2014-04-25','10:15:00',5.09),('7643','2014-04-25','10:20:00',5.62),('7643','2014-04-25','10:25:00',6.16),('7643','2014-04-25','10:30:00',6.95),('7643','2014-04-25','10:35:00',7.63),('7643','2014-04-25','10:40:00',7.58),('7643','2014-04-25','10:45:00',7.93),('7643','2014-04-25','10:50:00',11.27),('7643','2014-04-25','10:55:00',14.12),('7643','2014-04-25','11:00:00',14.08),('7643','2014-04-25','11:05:00',13.61),('7643','2014-04-25','11:10:00',12.44),('7643','2014-04-25','11:15:00',12.78),('7643','2014-04-25','11:20:00',11.62),('7643','2014-04-25','11:25:00',11.25),('7643','2014-04-25','11:30:00',11.89),('7643','2014-04-25','11:35:00',12.02),('7643','2014-04-25','11:40:00',11.57),('7643','2014-04-25','11:45:00',11.86),('7643','2014-04-25','11:50:00',11.82),('7643','2014-04-25','11:55:00',11.09),('7643','2014-04-25','12:00:00',11.53),('7643','2014-04-25','12:05:00',13.47),('7643','2014-04-25','12:10:00',12.07),('7643','2014-04-25','12:15:00',11.48),('7643','2014-04-25','12:20:00',12.09),('7643','2014-04-25','12:25:00',8.48),('7643','2014-04-25','12:30:00',11.67),('7643','2014-04-25','12:35:00',12.9),('7643','2014-04-25','12:40:00',14.02),('7643','2014-04-25','12:45:00',16.16),('7643','2014-04-25','12:50:00',14.79),('7643','2014-04-25','12:55:00',16.86),('7643','2014-04-25','13:00:00',15.65),('7643','2014-04-25','13:05:00',12.05),('7643','2014-04-25','13:10:00',14.82),('7643','2014-04-25','13:15:00',16.32),('7643','2014-04-25','13:20:00',16.96),('7643','2014-04-25','13:25:00',11.7),('7643','2014-04-25','13:30:00',4.98),('7643','2014-04-25','13:35:00',6.29),('7643','2014-04-25','13:40:00',13.04),('7643','2014-04-25','13:45:00',16.96),('7643','2014-04-25','13:50:00',15.67),('7643','2014-04-25','13:55:00',17.26),('7643','2014-04-25','14:00:00',16.08),('7643','2014-04-25','14:05:00',4.36),('7643','2014-04-25','14:10:00',9.8),('7643','2014-04-25','14:15:00',8.2),('7643','2014-04-25','14:20:00',1.91),('7643','2014-04-25','14:25:00',2.91),('7643','2014-04-25','14:30:00',3.14),('7643','2014-04-25','14:35:00',7.78),('7643','2014-04-25','14:40:00',11.59),('7643','2014-04-25','14:45:00',4.89),('7643','2014-04-25','14:50:00',1.94),('7643','2014-04-25','14:55:00',1.22),('7643','2014-04-25','15:00:00',1.89),('7643','2014-04-25','15:05:00',1.02),('7643','2014-04-25','15:10:00',1.74),('7643','2014-04-25','15:15:00',3.62),('7643','2014-04-25','15:20:00',2.96),('7643','2014-04-25','15:25:00',1.57),('7643','2014-04-25','15:30:00',1.33),('7643','2014-04-25','15:35:00',1.53),('7643','2014-04-25','15:40:00',1.37),('7643','2014-04-25','15:45:00',1.1),('7643','2014-04-25','15:50:00',1.38),('7643','2014-04-25','15:55:00',1.33),('7643','2014-04-25','16:00:00',1.6),('7643','2014-04-25','16:05:00',1.49),('7643','2014-04-25','16:10:00',1.36),('7643','2014-04-25','16:35:00',1.09),('7643','2014-04-25','17:30:00',1.28),('7643','2014-04-25','17:35:00',1.92),('7643','2014-04-25','17:40:00',2.7),('7643','2014-04-25','17:45:00',3.38),('7643','2014-04-25','17:50:00',3.41),('7643','2014-04-25','17:55:00',3.21),('7643','2014-04-25','18:00:00',1.99),('7643','2014-04-25','18:05:00',1.45),('7643','2014-04-25','18:10:00',1.27),('7643','2014-04-25','18:15:00',1.14),('7643','2014-04-25','18:20:00',1.2),('7643','2014-04-25','18:25:00',1.57),('7643','2014-04-25','18:30:00',2.12),('7643','2014-04-25','18:35:00',2.6),('7643','2014-04-25','18:40:00',3.04),('7643','2014-04-25','18:45:00',3.02),('7643','2014-04-25','18:50:00',2.3),('7643','2014-04-25','18:55:00',1.55),('7643','2014-01-25','08:00:00',1.43),('7643','2014-01-25','08:05:00',1.78),('7643','2014-01-25','08:10:00',2.68),('7643','2014-01-25','08:15:00',1.55),('7643','2014-01-25','08:20:00',1.08),('7643','2014-01-25','08:25:00',1.1),('7643','2014-01-25','08:30:00',1.3),('7643','2014-01-25','08:35:00',1.22),('7643','2014-01-25','08:40:00',1.69),('7643','2014-01-25','08:45:00',2.07),('7643','2014-01-25','08:50:00',2.13),('7643','2014-01-25','08:55:00',2.3),('7643','2014-01-25','09:00:00',3.26),('7643','2014-01-25','09:05:00',5.3),('7643','2014-01-25','09:10:00',2.94),('7643','2014-01-25','09:15:00',2.2),('7643','2014-01-25','09:20:00',2.06),('7643','2014-01-25','09:25:00',3.2),('7643','2014-01-25','09:30:00',6.2),('7643','2014-01-25','09:35:00',6.89),('7643','2014-01-25','09:40:00',3.13),('7643','2014-01-25','09:45:00',5.02),('7643','2014-01-25','09:50:00',5.89),('7643','2014-01-25','09:55:00',4.15),('7643','2014-01-25','10:00:00',3.11),('7643','2014-01-25','10:05:00',3.28),('7643','2014-01-25','10:10:00',8.03),('7643','2014-01-25','10:15:00',10.15),('7643','2014-01-25','10:20:00',4.65),('7643','2014-01-25','10:25:00',3.85),('7643','2014-01-25','10:30:00',3.45),('7643','2014-01-25','10:35:00',3.01),('7643','2014-01-25','10:40:00',2.51),('7643','2014-01-25','10:45:00',2.75),('7643','2014-01-25','10:50:00',2.9),('7643','2014-01-25','10:55:00',3.34),('7643','2014-01-25','11:00:00',3.03),('7643','2014-01-25','11:05:00',3.06),('7643','2014-01-25','11:10:00',2.64),('7643','2014-01-25','11:15:00',2.64),('7643','2014-01-25','11:20:00',2.61),('7643','2014-01-25','11:25:00',3.64),('7643','2014-01-25','11:30:00',3.14),('7643','2014-01-25','11:35:00',2.73),('7643','2014-01-25','11:40:00',2.75),('7643','2014-01-25','11:45:00',2.46),('7643','2014-01-25','11:50:00',2.08),('7643','2014-01-25','11:55:00',2.12),('7643','2014-01-25','12:00:00',2.11),('7643','2014-01-25','12:05:00',2.28),('7643','2014-01-25','12:10:00',2.92),('7643','2014-01-25','12:15:00',3.98),('7643','2014-01-25','12:20:00',4.36),('7643','2014-01-25','12:25:00',4.75),('7643','2014-01-25','12:30:00',9.22),('7643','2014-01-25','12:35:00',8.66),('7643','2014-01-25','12:40:00',4.86),('7643','2014-01-25','12:45:00',4.11),('7643','2014-01-25','12:50:00',3.59),('7643','2014-01-25','12:55:00',3.35),('7643','2014-01-25','13:00:00',3.6),('7643','2014-01-25','13:05:00',4.11),('7643','2014-01-25','13:10:00',4.58),('7643','2014-01-25','13:15:00',6.11),('7643','2014-01-25','13:20:00',5.81),('7643','2014-01-25','13:25:00',4.54),('7643','2014-01-25','13:30:00',3.37),('7643','2014-01-25','13:35:00',2.77),('7643','2014-01-25','13:40:00',2.41),('7643','2014-01-25','13:45:00',2.36),('7643','2014-01-25','13:50:00',3.16),('7643','2014-01-25','13:55:00',2.34),('7643','2014-01-25','14:00:00',1.8),('7643','2014-01-25','14:05:00',1.96),('7643','2014-01-25','14:10:00',2.38),('7643','2014-01-25','14:15:00',2.39),('7643','2014-01-25','14:20:00',1.72),('7643','2014-01-25','14:25:00',1.14),('7643','2014-01-25','14:35:00',1.29),('7643','2014-01-25','14:40:00',1.75),('7643','2014-01-25','14:45:00',1.81),('7643','2014-01-25','14:50:00',1.83),('7643','2014-01-25','14:55:00',1.87),('7643','2014-01-25','15:00:00',1.83),('7643','2014-01-25','15:05:00',1.57),('7643','2014-01-25','15:10:00',1.29),('7643','2014-01-25','15:15:00',1.21),('7643','2014-01-25','15:20:00',1.79),('7643','2014-01-25','15:25:00',2.89),('7643','2014-01-25','15:30:00',1.61),('7643','2014-01-25','15:40:00',1.75),('7643','2014-01-25','15:45:00',4.64),('7643','2014-01-25','15:50:00',2.69),('7643','2014-01-25','15:55:00',1.34),('7643','2014-01-24','08:15:00',1.12),('7643','2014-01-24','08:20:00',1.6),('7643','2014-01-24','08:25:00',1.5),('7643','2014-01-24','08:30:00',1.25),('7643','2014-01-24','08:35:00',1.42),('7643','2014-01-24','08:40:00',1.69),('7643','2014-01-24','08:45:00',1.45),('7643','2014-01-24','08:50:00',1.46),('7643','2014-01-24','08:55:00',1.97),('7643','2014-01-24','09:00:00',4.32),('7643','2014-01-24','09:05:00',6.97),('7643','2014-01-24','09:10:00',4.61),('7643','2014-01-24','09:15:00',4.5),('7643','2014-01-24','09:20:00',6.43),('7643','2014-01-24','09:25:00',2.92),('7643','2014-01-24','09:30:00',1.68),('7643','2014-01-24','09:35:00',1.84),('7643','2014-01-24','09:40:00',2.48),('7643','2014-01-24','09:45:00',4.49),('7643','2014-01-24','09:50:00',5.52),('7643','2014-01-24','09:55:00',7.96),('7643','2014-01-24','10:00:00',6.44),('7643','2014-01-24','10:05:00',9.08),('7643','2014-01-24','10:10:00',10.94),('7643','2014-01-24','10:15:00',10.96),('7643','2014-01-24','10:20:00',10.99),('7643','2014-01-24','10:25:00',6.86),('7643','2014-01-24','10:30:00',7.05),('7643','2014-01-24','10:35:00',7.43),('7643','2014-01-24','10:40:00',7.37),('7643','2014-01-24','10:45:00',5.63),('7643','2014-01-24','10:50:00',5.26),('7643','2014-01-24','10:55:00',6.07),('7643','2014-01-24','11:00:00',4.5),('7643','2014-01-24','11:05:00',4.24),('7643','2014-01-24','11:10:00',3.61),('7643','2014-01-24','11:15:00',3.29),('7643','2014-01-24','11:20:00',3.74),('7643','2014-01-24','11:25:00',4.44),('7643','2014-01-24','11:30:00',11.5),('7643','2014-01-24','11:35:00',15.53),('7643','2014-01-24','11:40:00',7.65),('7643','2014-01-24','11:45:00',5.33),('7643','2014-01-24','11:50:00',5.81),('7643','2014-01-24','11:55:00',5.84),('7643','2014-01-24','12:00:00',5.88),('7643','2014-01-24','12:05:00',6),('7643','2014-01-24','12:10:00',6.88),('7643','2014-01-24','12:15:00',6.81),('7643','2014-01-24','12:20:00',7.13),('7643','2014-01-24','12:25:00',7.44),('7643','2014-01-24','12:30:00',7.59),('7643','2014-01-24','12:35:00',6.68),('7643','2014-01-24','12:40:00',6.96),('7643','2014-01-24','12:45:00',8.13),('7643','2014-01-24','12:50:00',8.85),('7643','2014-01-24','12:55:00',10.33),('7643','2014-01-24','13:00:00',10.29),('7643','2014-01-24','13:05:00',11.48),('7643','2014-01-24','13:10:00',11.63),('7643','2014-01-24','13:15:00',7.66),('7643','2014-01-24','13:20:00',4.18),('7643','2014-01-24','13:25:00',4.24),('7643','2014-01-24','13:30:00',7.61),('7643','2014-01-24','13:35:00',4.38),('7643','2014-01-24','13:40:00',4.15),('7643','2014-01-24','13:45:00',7.46),('7643','2014-01-24','13:50:00',5.36),('7643','2014-01-24','13:55:00',2.58),('7643','2014-01-24','14:00:00',5.61),('7643','2014-01-24','14:05:00',7.44),('7643','2014-01-24','14:10:00',8.82),('7643','2014-01-24','14:15:00',7.51),('7643','2014-01-24','14:20:00',9.43),('7643','2014-01-24','14:25:00',9.3),('7643','2014-01-24','14:30:00',10.61),('7643','2014-01-24','14:35:00',9.04),('7643','2014-01-24','14:40:00',9.97),('7643','2014-01-24','14:45:00',10.09),('7643','2014-01-24','14:50:00',9.58),('7643','2014-01-24','14:55:00',8.83),('7643','2014-01-24','15:00:00',7.91),('7643','2014-01-24','15:05:00',7.31),('7643','2014-01-24','15:10:00',6.84),('7643','2014-01-24','15:15:00',6.45),('7643','2014-01-24','15:20:00',6.1),('7643','2014-01-24','15:25:00',5.76),('7643','2014-01-24','15:30:00',5.41),('7643','2014-01-24','15:35:00',5.03),('7643','2014-01-24','15:40:00',4.66),('7643','2014-01-24','15:45:00',4.34),('7643','2014-01-24','15:50:00',4),('7643','2014-01-24','15:55:00',3.7),('7643','2014-01-24','16:00:00',3.37),('7643','2014-01-24','16:05:00',3.07),('7643','2014-01-24','16:10:00',2.73),('7643','2014-01-24','16:15:00',2.4),('7643','2014-01-24','16:20:00',2.1),('7643','2014-01-24','16:25:00',1.79),('7643','2014-01-24','16:30:00',1.51),('7643','2014-01-24','16:35:00',1.23),('7643','2014-01-23','09:50:00',1.08),('7643','2014-01-23','09:55:00',1.34),('7643','2014-01-23','10:00:00',1.6),('7643','2014-01-23','10:05:00',3.36),('7643','2014-01-23','10:10:00',4.34),('7643','2014-01-23','10:15:00',5.41),('7643','2014-01-23','10:20:00',3.37),('7643','2014-01-23','10:25:00',2.48),('7643','2014-01-23','10:30:00',5.18),('7643','2014-01-23','10:35:00',4.69),('7643','2014-01-23','10:40:00',6.76),('7643','2014-01-23','10:45:00',6.47),('7643','2014-01-23','10:50:00',3.77),('7643','2014-01-23','10:55:00',3.7),('7643','2014-01-23','11:00:00',3.66),('7643','2014-01-23','11:05:00',2.9),('7643','2014-01-23','11:10:00',1.75),('7643','2014-01-23','11:20:00',2.08),('7643','2014-01-23','11:25:00',3.64),('7643','2014-01-23','11:30:00',4.47),('7643','2014-01-23','11:35:00',4.48),('7643','2014-01-23','11:40:00',2.21),('7643','2014-01-23','11:45:00',5.35),('7643','2014-01-23','11:50:00',11.56),('7643','2014-01-23','11:55:00',13.03),('7643','2014-01-23','12:00:00',9.49),('7643','2014-01-23','12:05:00',7.84),('7643','2014-01-23','12:10:00',3.02),('7643','2014-01-23','12:15:00',1.87),('7643','2014-01-23','12:20:00',3.58),('7643','2014-01-23','12:25:00',5.29),('7643','2014-01-23','12:30:00',4.19),('7643','2014-01-23','12:35:00',10.38),('7643','2014-01-23','12:40:00',9.16),('7643','2014-01-23','12:45:00',7.57),('7643','2014-01-23','12:50:00',4.9),('7643','2014-01-23','12:55:00',4.51),('7643','2014-01-23','13:00:00',6.78),('7643','2014-01-23','13:05:00',7.6),('7643','2014-01-23','13:10:00',6.12),('7643','2014-01-23','13:15:00',5.87),('7643','2014-01-23','13:20:00',4.29),('7643','2014-01-23','13:25:00',3.03),('7643','2014-01-23','13:30:00',5.48),('7643','2014-01-23','13:35:00',5.8),('7643','2014-01-23','13:40:00',5.8),('7643','2014-01-23','13:45:00',8.05),('7643','2014-01-23','13:50:00',11.92),('7643','2014-01-23','13:55:00',10.66),('7643','2014-01-23','14:00:00',9.39),('7643','2014-01-23','14:05:00',1.77),('7643','2014-01-23','14:10:00',11.53),('7643','2014-01-23','14:15:00',10.27),('7643','2014-01-23','14:20:00',9.48),('7643','2014-01-23','14:25:00',8.88),('7643','2014-01-23','14:30:00',2.39),('7643','2014-01-23','14:35:00',1.83),('7643','2014-01-23','14:40:00',2.17),('7643','2014-01-23','14:45:00',3.11),('7643','2014-01-23','14:50:00',1.57),('7643','2014-01-23','15:15:00',1.14),('7643','2014-01-22','09:50:00',1.12),('7643','2014-01-22','09:55:00',1.06),('7643','2014-01-22','10:10:00',1.61),('7643','2014-01-22','10:15:00',2.55),('7643','2014-01-22','10:20:00',2.53),('7643','2014-01-22','10:25:00',2.6),('7643','2014-01-22','10:30:00',2.08),('7643','2014-01-22','10:35:00',1.72),('7643','2014-01-22','10:40:00',1.99),('7643','2014-01-22','10:45:00',2.12),('7643','2014-01-22','10:50:00',2.69),('7643','2014-01-22','10:55:00',3.19),('7643','2014-01-22','11:00:00',3.7),('7643','2014-01-22','11:05:00',3.69),('7643','2014-01-22','11:10:00',3.9),('7643','2014-01-22','11:15:00',3.95),('7643','2014-01-22','11:20:00',3.46),('7643','2014-01-22','11:25:00',3.09),('7643','2014-01-22','11:30:00',2.2),('7643','2014-01-22','11:35:00',1.69),('7643','2014-01-22','11:40:00',1.13),('7643','2014-01-22','11:55:00',1.03),('7643','2014-01-22','12:00:00',1.29),('7643','2014-01-22','12:05:00',1.96),('7643','2014-01-22','12:10:00',2.92),('7643','2014-01-22','12:15:00',2.07),('7643','2014-01-22','12:20:00',1.85),('7643','2014-01-22','12:25:00',2.55),('7643','2014-01-22','12:30:00',3.63),('7643','2014-01-22','12:35:00',3.01),('7643','2014-01-22','12:40:00',1.85),('7643','2014-01-22','12:45:00',1.13),('7643','2014-01-22','13:15:00',1.08),('7643','2014-01-22','13:20:00',1.25),('7643','2014-01-22','13:25:00',1.14),('7643','2014-01-22','13:40:00',1.01),('7643','2014-01-22','13:45:00',1.21),('7643','2014-01-22','13:50:00',1.46),('7643','2014-01-22','13:55:00',1.5),('7643','2014-01-22','14:00:00',1.65),('7643','2014-01-22','14:05:00',2.23),('7643','2014-01-22','14:10:00',2.6),('7643','2014-01-22','14:15:00',2.75),('7643','2014-01-22','14:20:00',2.39),('7643','2014-01-22','14:25:00',1.97),('7643','2014-01-22','14:30:00',1.54),('7643','2014-01-22','14:35:00',1.04),('7643','2014-01-21','09:45:00',1.2),('7643','2014-01-21','09:50:00',1.09),('7643','2014-01-21','10:05:00',1.43),('7643','2014-01-21','10:10:00',1.74),('7643','2014-01-21','10:15:00',3.04),('7643','2014-01-21','10:20:00',2.76),('7643','2014-01-21','10:25:00',1.46),('7643','2014-01-21','10:30:00',1.56),('7643','2014-01-21','10:35:00',1.71),('7643','2014-01-21','10:40:00',1.99),('7643','2014-01-21','10:45:00',2.62),('7643','2014-01-21','10:50:00',2.7),('7643','2014-01-21','10:55:00',2.69),('7643','2014-01-21','11:00:00',3.14),('7643','2014-01-21','11:05:00',3.54),('7643','2014-01-21','11:10:00',3.58),('7643','2014-01-21','11:15:00',3.22),('7643','2014-01-21','11:20:00',3.34),('7643','2014-01-21','11:25:00',3.22),('7643','2014-01-21','11:30:00',2.42),('7643','2014-01-21','11:35:00',2.03),('7643','2014-01-21','11:40:00',2.98),('7643','2014-01-21','11:45:00',3.02),('7643','2014-01-21','11:50:00',2.38),('7643','2014-01-21','11:55:00',2.68),('7643','2014-01-21','12:00:00',2.82),('7643','2014-01-21','12:05:00',2.86),('7643','2014-01-21','12:10:00',2.45),('7643','2014-01-21','12:15:00',1.55),('7643','2014-01-21','12:20:00',1.36),('7643','2014-01-21','12:25:00',1.22),('7643','2014-01-21','12:30:00',1.36),('7643','2014-01-21','12:35:00',1.96),('7643','2014-01-21','12:40:00',2.18),('7643','2014-01-21','12:45:00',2.39),('7643','2014-01-21','12:50:00',2.9),('7643','2014-01-21','12:55:00',3.49),('7643','2014-01-21','13:00:00',3.31),('7643','2014-01-21','13:05:00',3.1),('7643','2014-01-21','13:10:00',3.59),('7643','2014-01-21','13:15:00',4.82),('7643','2014-01-21','13:20:00',5.04),('7643','2014-01-21','13:25:00',2.8),('7643','2014-01-21','13:30:00',2.16),('7643','2014-01-21','13:35:00',1.79),('7643','2014-01-21','13:40:00',2.15),('7643','2014-01-21','13:45:00',2.13),('7643','2014-01-21','13:50:00',2.08),('7643','2014-01-21','13:55:00',2.61),('7643','2014-01-21','14:00:00',2.47),('7643','2014-01-21','14:05:00',2.1),('7643','2014-01-21','14:10:00',2.46),('7643','2014-01-21','14:15:00',2.38),('7643','2014-01-21','14:20:00',2.17),('7643','2014-01-21','14:25:00',2.08),('7643','2014-01-21','14:30:00',2.03),('7643','2014-01-21','14:35:00',1.94),('7643','2014-01-21','14:40:00',1.46),('7643','2014-01-21','14:45:00',1.5),('7643','2014-01-21','14:50:00',1.64),('7643','2014-01-21','14:55:00',1.71),('7643','2014-01-21','15:00:00',1.98),('7643','2014-01-21','15:05:00',2.25),('7643','2014-01-21','15:10:00',1.95),('7643','2014-01-21','15:15:00',1.42),('7643','2014-01-21','15:20:00',1.27),('7643','2014-01-21','15:25:00',1.39),('7643','2014-01-21','15:30:00',1.43),('7643','2014-01-21','15:35:00',1.04),('7643','2014-01-21','15:40:00',1.18),('7643','2014-01-21','15:45:00',1.61),('7643','2014-01-21','15:50:00',1.78),('7643','2014-01-21','15:55:00',1.21),('7643','2014-01-21','16:00:00',1.25),('7643','2014-01-21','16:05:00',2.78),('7643','2014-01-21','16:10:00',3.16),('7643','2014-01-21','16:15:00',3.17),('7643','2014-01-21','16:20:00',1.59),('7643','2014-01-21','16:25:00',1.09),('7643','2014-01-21','16:35:00',1.07),('7643','2014-01-20','09:00:00',1.07),('7643','2014-01-20','09:05:00',1.33),('7643','2014-01-20','09:10:00',1.49),('7643','2014-01-20','09:15:00',1.89),('7643','2014-01-20','09:20:00',1.26),('7643','2014-01-20','09:25:00',1.07),('7643','2014-01-20','09:30:00',1.25),('7643','2014-01-20','09:35:00',2.31),('7643','2014-01-20','09:40:00',2.74),('7643','2014-01-20','09:45:00',1.65),('7643','2014-01-20','09:50:00',2.06),('7643','2014-01-20','09:55:00',3.03),('7643','2014-01-20','10:00:00',3.83),('7643','2014-01-20','10:05:00',4.77),('7643','2014-01-20','10:10:00',1.74),('7643','2014-01-20','10:15:00',1.52),('7643','2014-01-20','10:20:00',1.26),('7643','2014-01-20','10:25:00',1.11),('7643','2014-01-20','10:30:00',1.43),('7643','2014-01-20','10:35:00',2.36),('7643','2014-01-20','10:40:00',2.81),('7643','2014-01-20','10:45:00',2.06),('7643','2014-01-20','10:50:00',1.86),('7643','2014-01-20','10:55:00',5.75),('7643','2014-01-20','11:00:00',7.72),('7643','2014-01-20','11:05:00',3.46),('7643','2014-01-20','11:10:00',1.03),('7643','2014-01-20','11:15:00',1.74),('7643','2014-01-20','11:20:00',2.96),('7643','2014-01-20','11:25:00',1.77),('7643','2014-01-20','11:30:00',2.9),('7643','2014-01-20','11:35:00',2.2),('7643','2014-01-20','11:40:00',1.88),('7643','2014-01-20','11:45:00',1.84),('7643','2014-01-20','11:50:00',3.01),('7643','2014-01-20','11:55:00',4.14),('7643','2014-01-20','12:00:00',3.58),('7643','2014-01-20','12:05:00',5.61),('7643','2014-01-20','12:10:00',7.29),('7643','2014-01-20','12:15:00',4.99),('7643','2014-01-20','12:20:00',3.67),('7643','2014-01-20','12:25:00',4.91),('7643','2014-01-20','12:30:00',7.04),('7643','2014-01-20','12:35:00',5.89),('7643','2014-01-20','12:40:00',5.53),('7643','2014-01-20','12:45:00',4.97),('7643','2014-01-20','12:50:00',6.85),('7643','2014-01-20','12:55:00',3.73),('7643','2014-01-20','13:00:00',1.74),('7643','2014-01-20','13:05:00',1.52),('7643','2014-01-20','13:10:00',1.91),('7643','2014-01-20','13:15:00',2.94),('7643','2014-01-20','13:20:00',4.12),('7643','2014-01-20','13:25:00',2.21),('7643','2014-01-20','13:30:00',1.2),('7643','2014-01-20','13:35:00',1.29),('7643','2014-01-20','13:40:00',1.38),('7643','2014-01-20','13:45:00',1.07),('7643','2014-01-20','13:50:00',1.41),('7643','2014-01-20','13:55:00',2.02),('7643','2014-01-20','14:00:00',3.52),('7643','2014-01-20','14:05:00',5.11),('7643','2014-01-20','14:10:00',4.78),('7643','2014-01-20','14:15:00',3.9),('7643','2014-01-20','14:20:00',2.86),('7643','2014-01-20','14:25:00',1.92),('7643','2014-01-20','14:30:00',1.56),('7643','2014-01-20','14:35:00',1.32),('7643','2014-01-20','14:40:00',1.03),('7643','2014-01-20','15:00:00',1.12),('7643','2014-01-20','15:05:00',1.55),('7643','2014-01-20','15:10:00',2.13),('7643','2014-01-20','15:15:00',2.24),('7643','2014-01-20','15:20:00',1.63),('7643','2014-01-20','15:25:00',2.03),('7643','2014-01-20','15:30:00',2.25),('7643','2014-01-20','15:35:00',3.11),('7643','2014-01-20','15:40:00',3.8),('7643','2014-01-20','15:45:00',1.92),('7643','2014-01-20','15:50:00',1.28),('7643','2014-01-20','16:30:00',1.18),('7643','2014-01-19','08:25:00',1.16),('7643','2014-01-19','10:45:00',1.27),('7643','2014-01-19','10:50:00',2),('7643','2014-01-19','11:10:00',1.61),('7643','2014-01-19','11:15:00',3.33),('7643','2014-01-19','11:20:00',5.62),('7643','2014-01-19','11:25:00',7.18),('7643','2014-01-19','11:30:00',7.42),('7643','2014-01-19','11:35:00',7.63),('7643','2014-01-19','11:40:00',11.87),('7643','2014-01-19','11:45:00',11.35),('7643','2014-01-19','11:50:00',7.22),('7643','2014-01-19','11:55:00',3.62),('7643','2014-01-19','12:00:00',2.91),('7643','2014-01-19','12:05:00',2.15),('7643','2014-01-19','12:10:00',1.87),('7643','2014-01-19','12:15:00',2.1),('7643','2014-01-19','12:20:00',2.27),('7643','2014-01-19','12:25:00',5.14),('7643','2014-01-19','12:30:00',4.37),('7643','2014-01-19','12:35:00',2.94),('7643','2014-01-19','12:40:00',1.53),('7643','2014-01-19','12:45:00',1.66),('7643','2014-01-19','13:00:00',1.3),('7643','2014-01-19','13:05:00',2.03),('7643','2014-01-19','13:10:00',2.22),('7643','2014-01-19','13:15:00',3.81),('7643','2014-01-19','13:20:00',14.17),('7643','2014-01-19','13:25:00',13.03),('7643','2014-01-19','13:30:00',11.66),('7643','2014-01-19','13:35:00',10.98),('7643','2014-01-19','13:40:00',10.38),('7643','2014-01-19','13:45:00',9.12),('7643','2014-01-19','13:50:00',4.37),('7643','2014-01-19','13:55:00',5.51),('7643','2014-01-19','14:00:00',9.3),('7643','2014-01-19','14:05:00',8.1),('7643','2014-01-19','14:10:00',5.69),('7643','2014-01-19','14:15:00',3.93),('7643','2014-01-19','14:20:00',4.51),('7643','2014-01-19','14:25:00',2.75),('7643','2014-01-19','14:30:00',1.55),('7643','2014-01-19','15:00:00',1.37),('7643','2014-01-19','15:05:00',1.29),('7643','2014-01-18','09:50:00',1.15),('7643','2014-01-18','09:55:00',1.02),('7643','2014-01-18','10:00:00',1.07),('7643','2014-01-18','10:05:00',1.19),('7643','2014-01-18','10:10:00',1.08),('7643','2014-01-18','10:15:00',1.68),('7643','2014-01-18','10:20:00',2.05),('7643','2014-01-18','10:25:00',1.9),('7643','2014-01-18','10:30:00',1.79),('7643','2014-01-18','10:35:00',1.76),('7643','2014-01-18','10:40:00',1.8),('7643','2014-01-18','10:45:00',1.66),('7643','2014-01-18','10:50:00',1.46),('7643','2014-01-18','10:55:00',1.46),('7643','2014-01-18','11:00:00',1.87),('7643','2014-01-18','11:05:00',1.99),('7643','2014-01-18','11:10:00',1.32),('7643','2014-01-18','11:15:00',1.08),('7643','2014-01-18','11:20:00',1.47),('7643','2014-01-18','11:25:00',1.51),('7643','2014-01-18','11:30:00',1.01),('7643','2014-01-18','11:35:00',1.61),('7643','2014-01-18','11:40:00',1.84),('7643','2014-01-18','11:45:00',2.5),('7643','2014-01-18','11:50:00',3.25),('7643','2014-01-18','11:55:00',3.36),('7643','2014-01-18','12:00:00',3.71),('7643','2014-01-18','12:05:00',3.87),('7643','2014-01-18','12:10:00',3.71),('7643','2014-01-18','12:15:00',3.11),('7643','2014-01-18','12:20:00',3.37),('7643','2014-01-18','12:25:00',3.38),('7643','2014-01-18','12:30:00',2.03),('7643','2014-01-18','12:35:00',1.49),('7643','2014-01-18','12:40:00',1.81),('7643','2014-01-18','12:45:00',1.66),('7643','2014-01-18','12:50:00',1.81),('7643','2014-01-18','12:55:00',2.12),('7643','2014-01-18','13:00:00',2.71),('7643','2014-01-18','13:05:00',3.64),('7643','2014-01-18','13:10:00',4.04),('7643','2014-01-18','13:15:00',3.55),('7643','2014-01-18','13:20:00',2.84),('7643','2014-01-18','13:25:00',2.5),('7643','2014-01-18','13:30:00',2.42),('7643','2014-01-18','13:35:00',2.26),('7643','2014-01-18','13:40:00',2.03),('7643','2014-01-18','13:45:00',2),('7643','2014-01-18','13:50:00',2.1),('7643','2014-01-18','13:55:00',2.72),('7643','2014-01-18','14:00:00',2.38),('7643','2014-01-18','14:05:00',1.94),('7643','2014-01-18','14:10:00',1.78),('7643','2014-01-18','14:15:00',2.49),('7643','2014-01-18','14:20:00',4.74),('7643','2014-01-18','14:25:00',6.23),('7643','2014-01-18','14:30:00',6.84),('7643','2014-01-18','14:35:00',4.16),('7643','2014-01-18','14:40:00',3.55),('7643','2014-01-18','14:45:00',2.95),('7643','2014-01-18','14:50:00',1.84),('7643','2014-01-18','14:55:00',1.18),('7643','2014-01-18','15:35:00',1.56),('7643','2014-01-18','15:40:00',2.37),('7643','2014-01-18','15:45:00',1.41),('7643','2014-01-18','16:00:00',1.16),('7643','2014-01-18','16:05:00',1.1),('7643','2014-01-18','16:30:00',1.69),('7643','2014-01-18','16:35:00',1.41),('7643','2014-01-17','08:45:00',1.1),('7643','2014-01-17','08:50:00',1.23),('7643','2014-01-17','08:55:00',1.32),('7643','2014-01-17','09:00:00',1.49),('7643','2014-01-17','09:05:00',1.78),('7643','2014-01-17','09:10:00',1.98),('7643','2014-01-17','09:15:00',1.93),('7643','2014-01-17','09:20:00',1.86),('7643','2014-01-17','09:25:00',2.01),('7643','2014-01-17','09:30:00',2.43),('7643','2014-01-17','09:35:00',3.07),('7643','2014-01-17','09:40:00',3.32),('7643','2014-01-17','09:45:00',3.46),('7643','2014-01-17','09:50:00',3.2),('7643','2014-01-17','09:55:00',3.6),('7643','2014-01-17','10:00:00',4.72),('7643','2014-01-17','10:05:00',6.44),('7643','2014-01-17','10:10:00',9.69),('7643','2014-01-17','10:15:00',9.98),('7643','2014-01-17','10:20:00',9.1),('7643','2014-01-17','10:25:00',6.19),('7643','2014-01-17','10:30:00',6.56),('7643','2014-01-17','10:35:00',4.26),('7643','2014-01-17','10:40:00',4.18),('7643','2014-01-17','10:45:00',4.74),('7643','2014-01-17','10:50:00',4.9),('7643','2014-01-17','10:55:00',4.58),('7643','2014-01-17','11:00:00',3.31),('7643','2014-01-17','11:05:00',5.04),('7643','2014-01-17','11:10:00',8.48),('7643','2014-01-17','11:15:00',10.89),('7643','2014-01-17','11:20:00',10.54),('7643','2014-01-17','11:25:00',9.96),('7643','2014-01-17','11:30:00',10.16),('7643','2014-01-17','11:35:00',10.29),('7643','2014-01-17','11:40:00',10.69),('7643','2014-01-17','11:45:00',11.84),('7643','2014-01-17','11:50:00',11.9),('7643','2014-01-17','11:55:00',12.48),('7643','2014-01-17','12:00:00',12.01),('7643','2014-01-17','12:05:00',9.04),('7643','2014-01-17','12:10:00',11.22),('7643','2014-01-17','12:15:00',10.58),('7643','2014-01-17','12:20:00',10.43),('7643','2014-01-17','12:25:00',10.7),('7643','2014-01-17','12:30:00',10.71),('7643','2014-01-17','12:35:00',10.61),('7643','2014-01-17','12:40:00',10.83),('7643','2014-01-17','12:45:00',10.75),('7643','2014-01-17','12:50:00',10.27),('7643','2014-01-17','12:55:00',11.26),('7643','2014-01-17','13:00:00',7.2),('7643','2014-01-17','13:05:00',7.12),('7643','2014-01-17','13:10:00',8.9),('7643','2014-01-17','13:15:00',10.82),('7643','2014-01-17','13:20:00',7.05),('7643','2014-01-17','13:25:00',5.56),('7643','2014-01-17','13:30:00',9.63),('7643','2014-01-17','13:35:00',5.27),('7643','2014-01-17','13:40:00',8.28),('7643','2014-01-17','13:45:00',9.95),('7643','2014-01-17','13:50:00',6.4),('7643','2014-01-17','13:55:00',9.62),('7643','2014-01-17','14:00:00',9.36),('7643','2014-01-17','14:05:00',8.7),('7643','2014-01-17','14:10:00',8.38),('7643','2014-01-17','14:15:00',7.94),('7643','2014-01-17','14:20:00',8.24),('7643','2014-01-17','14:25:00',7.82),('7643','2014-01-17','14:30:00',7.48),('7643','2014-01-17','14:35:00',7.28),('7643','2014-01-17','14:40:00',7),('7643','2014-01-17','14:45:00',6.79),('7643','2014-01-17','14:50:00',6.53),('7643','2014-01-17','14:55:00',4.56),('7643','2014-01-17','15:00:00',1.49),('7643','2014-01-17','15:10:00',1.32),('7643','2014-01-17','15:15:00',2.03),('7643','2014-01-17','15:20:00',2.23),('7643','2014-01-17','15:25:00',2.25),('7643','2014-01-17','15:30:00',2.1),('7643','2014-01-17','15:35:00',2.18),('7643','2014-01-17','15:40:00',1.86),('7643','2014-01-17','15:45:00',1.48),('7643','2014-01-17','15:50:00',1.59),('7643','2014-01-17','15:55:00',2.99),('7643','2014-01-17','16:00:00',2.01),('7643','2014-01-17','16:05:00',2.89),('7643','2014-01-17','16:10:00',2.03),('7643','2014-01-17','16:15:00',1.57),('7643','2014-01-17','16:20:00',1.01),('7643','2014-01-16','08:20:00',1.15),('7643','2014-01-16','08:25:00',1.27),('7643','2014-01-16','08:30:00',2.2),('7643','2014-01-16','08:35:00',2.38),('7643','2014-01-16','08:40:00',2.19),('7643','2014-01-16','08:45:00',1.2),('7643','2014-01-16','08:50:00',3.02),('7643','2014-01-16','08:55:00',3.52),('7643','2014-01-16','09:00:00',4.75),('7643','2014-01-16','09:05:00',4.8),('7643','2014-01-16','09:10:00',4.14),('7643','2014-01-16','09:15:00',3.15),('7643','2014-01-16','09:20:00',5.62),('7643','2014-01-16','09:25:00',6.17),('7643','2014-01-16','09:30:00',6.04),('7643','2014-01-16','09:35:00',6.37),('7643','2014-01-16','09:40:00',7.19),('7643','2014-01-16','09:45:00',6.96),('7643','2014-01-16','09:50:00',3.25),('7643','2014-01-16','09:55:00',1.49),('7643','2014-01-16','10:05:00',1.79),('7643','2014-01-16','10:10:00',2.09),('7643','2014-01-16','10:15:00',1.82),('7643','2014-01-16','10:20:00',1.52),('7643','2014-01-16','10:25:00',1.42),('7643','2014-01-16','10:30:00',1.4),('7643','2014-01-16','10:35:00',1.3),('7643','2014-01-16','10:40:00',1.07),('7643','2014-01-16','10:45:00',1.12),('7643','2014-01-16','10:50:00',1.5),('7643','2014-01-16','10:55:00',1.88),('7643','2014-01-16','11:00:00',1.95),('7643','2014-01-16','11:05:00',1.76),('7643','2014-01-16','11:10:00',1.41),('7643','2014-01-16','11:15:00',1.74),('7643','2014-01-16','11:20:00',2.66),('7643','2014-01-16','11:25:00',5.07),('7643','2014-01-16','11:30:00',8.78),('7643','2014-01-16','11:35:00',7.43),('7643','2014-01-16','11:40:00',5.09),('7643','2014-01-16','11:45:00',2.52),('7643','2014-01-16','11:50:00',3.66),('7643','2014-01-16','11:55:00',5.02),('7643','2014-01-16','12:00:00',4.28),('7643','2014-01-16','12:05:00',7.09),('7643','2014-01-16','12:10:00',6.2),('7643','2014-01-16','12:15:00',3.13),('7643','2014-01-16','12:20:00',3.27),('7643','2014-01-16','12:25:00',3.08),('7643','2014-01-16','12:30:00',2.35),('7643','2014-01-16','12:35:00',2.79),('7643','2014-01-16','12:40:00',3.85),('7643','2014-01-16','12:45:00',3.9),('7643','2014-01-16','12:50:00',2.8),('7643','2014-01-16','12:55:00',2.27),('7643','2014-01-16','13:00:00',1.52),('7643','2014-01-16','13:05:00',1.76),('7643','2014-01-16','13:10:00',2.47),('7643','2014-01-16','13:15:00',2.35),('7643','2014-01-16','13:20:00',2.11),('7643','2014-01-16','13:25:00',1.76),('7643','2014-01-16','13:30:00',1.2),('7643','2014-01-16','13:40:00',1.01),('7643','2014-01-16','13:45:00',1.25),('7643','2014-01-16','13:50:00',1.44),('7643','2014-01-16','13:55:00',1.31),('7643','2014-01-16','14:00:00',1.13),('7643','2014-04-24','07:05:00',1.1),('7643','2014-04-24','07:10:00',1.35),('7643','2014-04-24','07:15:00',1.6),('7643','2014-04-24','07:20:00',1.82),('7643','2014-04-24','07:25:00',2.01),('7643','2014-04-24','07:30:00',2.31),('7643','2014-04-24','07:35:00',2.62),('7643','2014-04-24','07:40:00',2.87),('7643','2014-04-24','07:45:00',3.21),('7643','2014-04-24','07:50:00',3.12),('7643','2014-04-24','07:55:00',4.61),('7643','2014-04-24','08:00:00',4.77),('7643','2014-04-24','08:05:00',4.75),('7643','2014-04-24','08:10:00',5.16),('7643','2014-04-24','08:15:00',5.44),('7643','2014-04-24','08:20:00',5.83),('7643','2014-04-24','08:25:00',6.14),('7643','2014-04-24','08:30:00',6.36),('7643','2014-04-24','08:35:00',6.69),('7643','2014-04-24','08:40:00',6.99),('7643','2014-04-24','08:45:00',7.25),('7643','2014-04-24','08:50:00',7.78),('7643','2014-04-24','08:55:00',8.06),('7643','2014-04-24','09:00:00',9.26),('7643','2014-04-24','09:05:00',9.1),('7643','2014-04-24','09:10:00',10.99),('7643','2014-04-24','09:15:00',11.39),('7643','2014-04-24','09:20:00',9.98),('7643','2014-04-24','09:25:00',12.34),('7643','2014-04-24','09:30:00',11.65),('7643','2014-04-24','09:35:00',5.83),('7643','2014-04-24','09:40:00',4.49),('7643','2014-04-24','09:45:00',5.08),('7643','2014-04-24','09:50:00',4.24),('7643','2014-04-24','09:55:00',4.9),('7643','2014-04-24','10:00:00',6.69),('7643','2014-04-24','10:05:00',4.83),('7643','2014-04-24','10:10:00',4.15),('7643','2014-04-24','10:15:00',4.36),('7643','2014-04-24','10:20:00',4.6),('7643','2014-04-24','10:25:00',4.76),('7643','2014-04-24','10:30:00',4.75),('7643','2014-04-24','10:35:00',6.78),('7643','2014-04-24','10:40:00',6.61),('7643','2014-04-24','10:45:00',12.41),('7643','2014-04-24','10:50:00',13.84),('7643','2014-04-24','10:55:00',11.38),('7643','2014-04-24','11:00:00',13.56),('7643','2014-04-24','11:05:00',11.12),('7643','2014-04-24','11:10:00',13.88),('7643','2014-04-24','11:15:00',12.16),('7643','2014-04-24','11:20:00',15.67),('7643','2014-04-24','11:25:00',8.81),('7643','2014-04-24','11:30:00',12.71),('7643','2014-04-24','11:35:00',11.84),('7643','2014-04-24','11:40:00',5.14),('7643','2014-04-24','11:45:00',6.18),('7643','2014-04-24','11:50:00',5.16),('7643','2014-04-24','11:55:00',5.43),('7643','2014-04-24','12:00:00',6.82),('7643','2014-04-24','12:05:00',11.16),('7643','2014-04-24','12:10:00',9.85),('7643','2014-04-24','12:15:00',5.29),('7643','2014-04-24','12:20:00',12.05),('7643','2014-04-24','12:25:00',13.38),('7643','2014-04-24','12:30:00',17.06),('7643','2014-04-24','12:35:00',14.71),('7643','2014-04-24','12:40:00',17.04),('7643','2014-04-24','12:45:00',17.46),('7643','2014-04-24','12:50:00',13.79),('7643','2014-04-24','12:55:00',5.88),('7643','2014-04-24','13:00:00',7.53),('7643','2014-04-24','13:05:00',14.27),('7643','2014-04-24','13:10:00',4.79),('7643','2014-04-24','13:15:00',14.45),('7643','2014-04-24','13:20:00',6.69),('7643','2014-04-24','13:25:00',9.12),('7643','2014-04-24','13:30:00',4.74),('7643','2014-04-24','13:35:00',4.08),('7643','2014-04-24','13:40:00',4.28),('7643','2014-04-24','13:45:00',9.12),('7643','2014-04-24','13:50:00',4.09),('7643','2014-04-24','13:55:00',5.65),('7643','2014-04-24','14:00:00',5.95),('7643','2014-04-24','14:05:00',5.3),('7643','2014-04-24','14:10:00',4.8),('7643','2014-04-24','14:15:00',4.17),('7643','2014-04-24','14:20:00',12.85),('7643','2014-04-24','14:25:00',18.8),('7643','2014-04-24','14:30:00',13.1),('7643','2014-04-24','14:35:00',15.27),('7643','2014-04-24','14:40:00',13.82),('7643','2014-04-24','14:45:00',15.24),('7643','2014-04-24','14:50:00',15.26),('7643','2014-04-24','14:55:00',15.12),('7643','2014-04-24','15:00:00',14.63),('7643','2014-04-24','15:05:00',14.18),('7643','2014-04-24','15:10:00',14.1),('7643','2014-04-24','15:15:00',13.82),('7643','2014-04-24','15:20:00',13.37),('7643','2014-04-24','15:25:00',13.24),('7643','2014-04-24','15:30:00',12.63),('7643','2014-04-24','15:35:00',13.19),('7643','2014-04-24','15:40:00',12.97),('7643','2014-04-24','15:45:00',12.6),('7643','2014-04-24','15:50:00',12.39),('7643','2014-04-24','15:55:00',12.19),('7643','2014-04-24','16:00:00',12.16),('7643','2014-04-24','16:05:00',11.79),('7643','2014-04-24','16:10:00',11.08),('7643','2014-04-24','16:15:00',10.76),('7643','2014-04-24','16:20:00',10.01),('7643','2014-04-24','16:25:00',10.05),('7643','2014-04-24','16:30:00',10.35),('7643','2014-04-24','16:35:00',10.24),('7643','2014-04-24','16:40:00',10.24),('7643','2014-04-24','16:45:00',9.91),('7643','2014-04-24','16:50:00',9.17),('7643','2014-04-24','16:55:00',7.76),('7643','2014-04-24','17:00:00',7.27),('7643','2014-04-24','17:05:00',8.03),('7643','2014-04-24','17:10:00',7.05),('7643','2014-04-24','17:15:00',7.43),('7643','2014-04-24','17:20:00',5.22),('7643','2014-04-24','17:25:00',3.66),('7643','2014-04-24','17:30:00',3.75),('7643','2014-04-24','17:35:00',3.81),('7643','2014-04-24','17:40:00',3.76),('7643','2014-04-24','17:45:00',3.27),('7643','2014-04-24','17:50:00',2.94),('7643','2014-04-24','17:55:00',2.69),('7643','2014-04-24','18:00:00',2.59),('7643','2014-04-24','18:05:00',2.6),('7643','2014-04-24','18:10:00',2.57),('7643','2014-04-24','18:15:00',2.19),('7643','2014-04-24','18:20:00',2.1),('7643','2014-04-24','18:25:00',2.11),('7643','2014-04-24','18:30:00',1.97),('7643','2014-04-24','18:35:00',1.91),('7643','2014-04-24','18:40:00',1.76),('7643','2014-04-24','18:45:00',1.6),('7643','2014-04-24','18:50:00',1.48),('7643','2014-04-24','18:55:00',1.42),('7643','2014-04-24','19:00:00',1.3),('7643','2014-04-24','19:05:00',1.33),('7643','2014-04-24','19:10:00',1.37),('7643','2014-04-24','19:15:00',1.21),('7643','2014-01-15','08:00:00',1.15),('7643','2014-01-15','08:05:00',1.39),('7643','2014-01-15','08:10:00',1.79),('7643','2014-01-15','08:15:00',2.15),('7643','2014-01-15','08:20:00',2.75),('7643','2014-01-15','08:25:00',3.02),('7643','2014-01-15','08:30:00',2.8),('7643','2014-01-15','08:35:00',3.02),('7643','2014-01-15','08:40:00',3.12),('7643','2014-01-15','08:45:00',2.91),('7643','2014-01-15','08:50:00',2.97),('7643','2014-01-15','08:55:00',2.95),('7643','2014-01-15','09:00:00',3.45),('7643','2014-01-15','09:05:00',3.53),('7643','2014-01-15','09:10:00',4.12),('7643','2014-01-15','09:15:00',4.14),('7643','2014-01-15','09:20:00',5.75),('7643','2014-01-15','09:25:00',6.75),('7643','2014-01-15','09:30:00',7.12),('7643','2014-01-15','09:35:00',7.17),('7643','2014-01-15','09:40:00',7.69),('7643','2014-01-15','09:45:00',7),('7643','2014-01-15','09:50:00',5.28),('7643','2014-01-15','09:55:00',4.16),('7643','2014-01-15','10:00:00',3.58),('7643','2014-01-15','10:05:00',3.74),('7643','2014-01-15','10:10:00',4.19),('7643','2014-01-15','10:15:00',4.84),('7643','2014-01-15','10:20:00',5.12),('7643','2014-01-15','10:25:00',5.49),('7643','2014-01-15','10:30:00',7.65),('7643','2014-01-15','10:35:00',10.11),('7643','2014-01-15','10:40:00',9.73),('7643','2014-01-15','10:45:00',6.9),('7643','2014-01-15','10:50:00',7.3),('7643','2014-01-15','10:55:00',8.21),('7643','2014-01-15','11:00:00',8.13),('7643','2014-01-15','11:05:00',8.15),('7643','2014-01-15','11:10:00',8.43),('7643','2014-01-15','11:15:00',8.44),('7643','2014-01-15','11:20:00',7.57),('7643','2014-01-15','11:25:00',7.78),('7643','2014-01-15','11:30:00',7.01),('7643','2014-01-15','11:35:00',6.9),('7643','2014-01-15','11:40:00',6.69),('7643','2014-01-15','11:45:00',6.32),('7643','2014-01-15','11:50:00',6.69),('7643','2014-01-15','11:55:00',6.38),('7643','2014-01-15','12:00:00',6.46),('7643','2014-01-15','12:05:00',5.21),('7643','2014-01-15','12:10:00',6.44),('7643','2014-01-15','12:15:00',4.82),('7643','2014-01-15','12:20:00',5.36),('7643','2014-01-15','12:25:00',5.47),('7643','2014-01-15','12:30:00',5.49),('7643','2014-01-15','12:35:00',6.89),('7643','2014-01-15','12:40:00',7.24),('7643','2014-01-15','12:45:00',7.45),('7643','2014-01-15','12:50:00',8.17),('7643','2014-01-15','12:55:00',8.39),('7643','2014-01-15','13:00:00',8.49),('7643','2014-01-15','13:05:00',9.01),('7643','2014-01-15','13:10:00',8.63),('7643','2014-01-15','13:15:00',8.33),('7643','2014-01-15','13:20:00',5.86),('7643','2014-01-15','13:25:00',8.59),('7643','2014-01-15','13:30:00',8.54),('7643','2014-01-15','13:35:00',8.57),('7643','2014-01-15','13:40:00',5.52),('7643','2014-01-15','13:45:00',5.03),('7643','2014-01-15','13:50:00',6.7),('7643','2014-01-15','13:55:00',7.22),('7643','2014-01-15','14:00:00',4.17),('7643','2014-01-15','14:05:00',3.97),('7643','2014-01-15','14:10:00',3.85),('7643','2014-01-15','14:15:00',3.25),('7643','2014-01-15','14:20:00',2.79),('7643','2014-01-15','14:25:00',3.31),('7643','2014-01-15','14:30:00',3.58),('7643','2014-01-15','14:35:00',3.37),('7643','2014-01-15','14:40:00',2.91),('7643','2014-01-15','14:45:00',2.71),('7643','2014-01-15','14:50:00',2.93),('7643','2014-01-15','14:55:00',3.27),('7643','2014-01-15','15:00:00',3.14),('7643','2014-01-15','15:05:00',3.58),('7643','2014-01-15','15:10:00',3.62),('7643','2014-01-15','15:15:00',2.45),('7643','2014-01-15','15:20:00',1.76),('7643','2014-01-15','15:25:00',1.38),('7643','2014-01-15','15:30:00',1.19),('7643','2014-01-15','15:35:00',1.12),('7643','2014-01-15','15:40:00',1.02),('7643','2014-01-14','08:30:00',1.1),('7643','2014-01-14','08:35:00',1.26),('7643','2014-01-14','08:40:00',1.5),('7643','2014-01-14','08:45:00',1.68),('7643','2014-01-14','08:50:00',1.83),('7643','2014-01-14','08:55:00',1.97),('7643','2014-01-14','09:00:00',2.02),('7643','2014-01-14','09:05:00',1.9),('7643','2014-01-14','09:10:00',1.64),('7643','2014-01-14','09:15:00',1.53),('7643','2014-01-14','09:20:00',1.66),('7643','2014-01-14','09:25:00',1.84),('7643','2014-01-14','09:30:00',1.82),('7643','2014-01-14','09:35:00',1.9),('7643','2014-01-14','09:40:00',2.22),('7643','2014-01-14','09:45:00',2.27),('7643','2014-01-14','09:50:00',2.06),('7643','2014-01-14','09:55:00',2.28),('7643','2014-01-14','10:00:00',3.18),('7643','2014-01-14','10:05:00',3),('7643','2014-01-14','10:10:00',3.7),('7643','2014-01-14','10:15:00',5.65),('7643','2014-01-14','10:20:00',7.65),('7643','2014-01-14','10:25:00',8.48),('7643','2014-01-14','10:30:00',8.67),('7643','2014-01-14','10:35:00',5.56),('7643','2014-01-14','10:40:00',6.38),('7643','2014-01-14','10:45:00',8.1),('7643','2014-01-14','10:50:00',5.26),('7643','2014-01-14','10:55:00',5.3),('7643','2014-01-14','11:00:00',4.39),('7643','2014-01-14','11:05:00',6.63),('7643','2014-01-14','11:10:00',10.62),('7643','2014-01-14','11:15:00',10.27),('7643','2014-01-14','11:20:00',9.75),('7643','2014-01-14','11:25:00',9.32),('7643','2014-01-14','11:30:00',9.34),('7643','2014-01-14','11:35:00',10.01),('7643','2014-01-14','11:40:00',7.8),('7643','2014-01-14','11:45:00',9.42),('7643','2014-01-14','11:50:00',9.5),('7643','2014-01-14','11:55:00',8.05),('7643','2014-01-14','12:00:00',6.4),('7643','2014-01-14','12:05:00',6.41),('7643','2014-01-14','12:10:00',6.63),('7643','2014-01-14','12:15:00',8.23),('7643','2014-01-14','12:20:00',10.42),('7643','2014-01-14','12:25:00',9.17),('7643','2014-01-14','12:30:00',5.62),('7643','2014-01-14','12:35:00',5.98),('7643','2014-01-14','12:40:00',5.71),('7643','2014-01-14','12:45:00',5.12),('7643','2014-01-14','12:50:00',6.7),('7643','2014-01-14','12:55:00',5.93),('7643','2014-01-14','13:00:00',5.48),('7643','2014-01-14','13:05:00',5.83),('7643','2014-01-14','13:10:00',6.7),('7643','2014-01-14','13:15:00',10.91),('7643','2014-01-14','13:20:00',11.26),('7643','2014-01-14','13:25:00',11.09),('7643','2014-01-14','13:30:00',10.64),('7643','2014-01-14','13:35:00',10.17),('7643','2014-01-14','13:40:00',9.62),('7643','2014-01-14','13:45:00',9.35),('7643','2014-01-14','13:50:00',5.08),('7643','2014-01-14','13:55:00',4.84),('7643','2014-01-14','14:00:00',6.16),('7643','2014-01-14','14:05:00',6.16),('7643','2014-01-14','14:10:00',8.2),('7643','2014-01-14','14:15:00',7.45),('7643','2014-01-14','14:20:00',7.54),('7643','2014-01-14','14:25:00',7.53),('7643','2014-01-14','14:30:00',7.37),('7643','2014-01-14','14:35:00',7.2),('7643','2014-01-14','14:40:00',7.2),('7643','2014-01-14','14:45:00',7.3),('7643','2014-01-14','14:50:00',7.02),('7643','2014-01-14','14:55:00',6.88),('7643','2014-01-14','15:00:00',6.76),('7643','2014-01-14','15:05:00',6.34),('7643','2014-01-14','15:10:00',6.12),('7643','2014-01-14','15:15:00',5.74),('7643','2014-01-14','15:20:00',5.2),('7643','2014-01-14','15:25:00',2.54),('7643','2014-01-14','15:30:00',3.83),('7643','2014-01-14','15:35:00',4.08),('7643','2014-01-14','15:40:00',3.93),('7643','2014-01-14','15:45:00',3.66),('7643','2014-01-14','15:50:00',2.9),('7643','2014-01-14','16:10:00',1.44),('7643','2014-01-14','16:15:00',1.44),('7643','2014-01-14','16:20:00',1.23),('7643','2014-01-13','10:10:00',1.26),('7643','2014-01-13','10:15:00',2.03),('7643','2014-01-13','10:20:00',2.98),('7643','2014-01-13','10:25:00',5.05),('7643','2014-01-13','10:30:00',11.24),('7643','2014-01-13','10:35:00',11.73),('7643','2014-01-13','10:40:00',10.18),('7643','2014-01-13','10:45:00',9.34),('7643','2014-01-13','10:50:00',5.8),('7643','2014-01-13','10:55:00',4.43),('7643','2014-01-13','11:00:00',4.99),('7643','2014-01-13','11:05:00',3.94),('7643','2014-01-13','11:10:00',2.91),('7643','2014-01-13','11:15:00',3.23),('7643','2014-01-13','11:20:00',3.16),('7643','2014-01-13','11:25:00',2.77),('7643','2014-01-13','11:30:00',4.25),('7643','2014-01-13','11:35:00',5.1),('7643','2014-01-13','11:40:00',6.25),('7643','2014-01-13','11:45:00',3.39),('7643','2014-01-13','11:50:00',3.19),('7643','2014-01-13','11:55:00',3),('7643','2014-01-13','12:00:00',2.56),('7643','2014-01-13','12:05:00',1.83),('7643','2014-01-13','12:10:00',1.69),('7643','2014-01-13','13:15:00',1.48),('7643','2014-01-12','08:30:00',1.08),('7643','2014-01-12','08:35:00',1.31),('7643','2014-01-12','08:40:00',1.54),('7643','2014-01-12','08:45:00',1.73),('7643','2014-01-12','08:50:00',1.91),('7643','2014-01-12','08:55:00',2.2),('7643','2014-01-12','09:00:00',2.39),('7643','2014-01-12','09:05:00',2.28),('7643','2014-01-12','09:10:00',3.35),('7643','2014-01-12','09:15:00',4.93),('7643','2014-01-12','09:20:00',5.7),('7643','2014-01-12','09:25:00',5.78),('7643','2014-01-12','09:30:00',5.99),('7643','2014-01-12','09:35:00',6.25),('7643','2014-01-12','09:40:00',6.52),('7643','2014-01-12','09:45:00',6.7),('7643','2014-01-12','09:50:00',6.87),('7643','2014-01-12','09:55:00',7.04),('7643','2014-01-12','10:00:00',7.26),('7643','2014-01-12','10:05:00',7.39),('7643','2014-01-12','10:10:00',7.57),('7643','2014-01-12','10:15:00',7.68),('7643','2014-01-12','10:20:00',7.97),('7643','2014-01-12','10:25:00',8.1),('7643','2014-01-12','10:30:00',8.22),('7643','2014-01-12','10:35:00',8.31),('7643','2014-01-12','10:40:00',8.47),('7643','2014-01-12','10:45:00',8.65),('7643','2014-01-12','10:50:00',8.86),('7643','2014-01-12','10:55:00',9),('7643','2014-01-12','11:00:00',9.06),('7643','2014-01-12','11:05:00',9.1),('7643','2014-01-12','11:10:00',9.16),('7643','2014-01-12','11:15:00',9.36),('7643','2014-01-12','11:20:00',9.44),('7643','2014-01-12','11:25:00',9.44),('7643','2014-01-12','11:30:00',9.4),('7643','2014-01-12','11:35:00',9.43),('7643','2014-01-12','11:40:00',9.53),('7643','2014-01-12','11:45:00',9.55),('7643','2014-01-12','11:50:00',9.49),('7643','2014-01-12','11:55:00',9.53),('7643','2014-01-12','12:00:00',9.33),('7643','2014-01-12','12:05:00',9.35),('7643','2014-01-12','12:10:00',9.38),('7643','2014-01-12','12:15:00',9.34),('7643','2014-01-12','12:20:00',9.41),('7643','2014-01-12','12:25:00',9.38),('7643','2014-01-12','12:30:00',9.36),('7643','2014-01-12','12:35:00',9.39),('7643','2014-01-12','12:40:00',9.23),('7643','2014-01-12','12:45:00',9.13),('7643','2014-01-12','12:50:00',8.9),('7643','2014-01-12','12:55:00',8.65),('7643','2014-01-12','13:00:00',8.75),('7643','2014-01-12','13:05:00',8.79),('7643','2014-01-12','13:10:00',8.69),('7643','2014-01-12','13:15:00',8.53),('7643','2014-01-12','13:20:00',8.47),('7643','2014-01-12','13:25:00',7.8),('7643','2014-01-12','13:30:00',8.44),('7643','2014-01-12','13:35:00',8.19),('7643','2014-01-12','13:40:00',7.69),('7643','2014-01-12','13:45:00',7.76),('7643','2014-01-12','13:50:00',7.61),('7643','2014-01-12','13:55:00',7.66),('7643','2014-01-12','14:00:00',7.62),('7643','2014-01-12','14:05:00',7.43),('7643','2014-01-12','14:10:00',7.01),('7643','2014-01-12','14:15:00',6.96),('7643','2014-01-12','14:20:00',6.91),('7643','2014-01-12','14:25:00',6.77),('7643','2014-01-12','14:30:00',6.43),('7643','2014-01-12','14:35:00',6.31),('7643','2014-01-12','14:40:00',6.17),('7643','2014-01-12','14:45:00',5.9),('7643','2014-01-12','14:50:00',5.56),('7643','2014-01-12','14:55:00',5.32),('7643','2014-01-12','15:00:00',5.1),('7643','2014-01-12','15:05:00',4.94),('7643','2014-01-12','15:10:00',4.67),('7643','2014-01-12','15:15:00',4.39),('7643','2014-01-12','15:20:00',4.12),('7643','2014-01-12','15:25:00',3.85),('7643','2014-01-12','15:30:00',3.54),('7643','2014-01-12','15:35:00',3.23),('7643','2014-01-12','15:40:00',2.95),('7643','2014-01-12','15:45:00',2.66),('7643','2014-01-12','15:50:00',2.39),('7643','2014-01-12','15:55:00',2.12),('7643','2014-01-12','16:00:00',1.87),('7643','2014-01-12','16:05:00',1.64),('7643','2014-01-12','16:10:00',1.38),('7643','2014-01-12','16:15:00',1.15),('7643','2014-01-11','08:40:00',1.11),('7643','2014-01-11','08:45:00',1.05),('7643','2014-01-11','08:50:00',1.32),('7643','2014-01-11','08:55:00',1.61),('7643','2014-01-11','09:00:00',1.64),('7643','2014-01-11','09:05:00',1.46),('7643','2014-01-11','09:10:00',1.46),('7643','2014-01-11','09:15:00',1.67),('7643','2014-01-11','09:20:00',2.04),('7643','2014-01-11','09:25:00',2.32),('7643','2014-01-11','09:30:00',2.46),('7643','2014-01-11','09:35:00',2.43),('7643','2014-01-11','09:40:00',2.87),('7643','2014-01-11','09:45:00',3.22),('7643','2014-01-11','09:50:00',3.61),('7643','2014-01-11','09:55:00',3.56),('7643','2014-01-11','10:00:00',3.41),('7643','2014-01-11','10:05:00',3.19),('7643','2014-01-11','10:10:00',3.21),('7643','2014-01-11','10:15:00',3.45),('7643','2014-01-11','10:20:00',4.04),('7643','2014-01-11','10:25:00',3.98),('7643','2014-01-11','10:30:00',3.93),('7643','2014-01-11','10:35:00',4.43),('7643','2014-01-11','10:40:00',5.23),('7643','2014-01-11','10:45:00',5.07),('7643','2014-01-11','10:50:00',5.42),('7643','2014-01-11','10:55:00',5.8),('7643','2014-01-11','11:00:00',5.8),('7643','2014-01-11','11:05:00',5.72),('7643','2014-01-11','11:10:00',7.17),('7643','2014-01-11','11:15:00',6.31),('7643','2014-01-11','11:20:00',5.66),('7643','2014-01-11','11:25:00',5.63),('7643','2014-01-11','11:30:00',6),('7643','2014-01-11','11:35:00',5.11),('7643','2014-01-11','11:40:00',6.39),('7643','2014-01-11','11:45:00',6.21),('7643','2014-01-11','11:50:00',7.21),('7643','2014-01-11','11:55:00',7.35),('7643','2014-01-11','12:00:00',5.39),('7643','2014-01-11','12:05:00',5.33),('7643','2014-01-11','12:10:00',4.74),('7643','2014-01-11','12:15:00',4.35),('7643','2014-01-11','12:20:00',4.39),('7643','2014-01-11','12:25:00',4.24),('7643','2014-01-11','12:30:00',4.5),('7643','2014-01-11','12:35:00',4.67),('7643','2014-01-11','12:40:00',5.03),('7643','2014-01-11','12:45:00',4.8),('7643','2014-01-11','12:50:00',4.96),('7643','2014-01-11','12:55:00',4.78),('7643','2014-01-11','13:00:00',4.81),('7643','2014-01-11','13:05:00',4.36),('7643','2014-01-11','13:10:00',4.17),('7643','2014-01-11','13:15:00',4.3),('7643','2014-01-11','13:20:00',4.4),('7643','2014-01-11','13:25:00',4.42),('7643','2014-01-11','13:30:00',5.39),('7643','2014-01-11','13:35:00',4.72),('7643','2014-01-11','13:40:00',4.33),('7643','2014-01-11','13:45:00',3.72),('7643','2014-01-11','13:50:00',3.4),('7643','2014-01-11','13:55:00',3.08),('7643','2014-01-11','14:00:00',2.98),('7643','2014-01-11','14:05:00',2.85),('7643','2014-01-11','14:10:00',2.64),('7643','2014-01-11','14:15:00',2.38),('7643','2014-01-11','14:20:00',2.17),('7643','2014-01-11','14:25:00',2.05),('7643','2014-01-11','14:30:00',1.94),('7643','2014-01-11','14:35:00',1.75),('7643','2014-01-11','14:40:00',1.54),('7643','2014-01-11','14:45:00',1.41),('7643','2014-01-11','14:50:00',1.32),('7643','2014-01-11','14:55:00',1.21),('7643','2014-01-11','15:00:00',1.1),('7643','2014-01-11','15:05:00',1),('7643','2014-01-10','08:25:00',1.09),('7643','2014-01-10','08:30:00',1.23),('7643','2014-01-10','08:35:00',1.35),('7643','2014-01-10','08:40:00',1.47),('7643','2014-01-10','08:45:00',1.48),('7643','2014-01-10','08:50:00',1.58),('7643','2014-01-10','08:55:00',1.98),('7643','2014-01-10','09:00:00',1.9),('7643','2014-01-10','09:05:00',1.88),('7643','2014-01-10','09:10:00',2.08),('7643','2014-01-10','09:15:00',2.26),('7643','2014-01-10','09:20:00',2.65),('7643','2014-01-10','09:25:00',3.32),('7643','2014-01-10','09:30:00',2.49),('7643','2014-01-10','09:35:00',2.14),('7643','2014-01-10','09:40:00',2.1),('7643','2014-01-10','09:45:00',2.39),('7643','2014-01-10','09:50:00',3.72),('7643','2014-01-10','09:55:00',5.48),('7643','2014-01-10','10:00:00',6.39),('7643','2014-01-10','10:05:00',5.02),('7643','2014-01-10','10:10:00',4.89),('7643','2014-01-10','10:15:00',5.48),('7643','2014-01-10','10:20:00',5.5),('7643','2014-01-10','10:25:00',6.8),('7643','2014-01-10','10:30:00',6.66),('7643','2014-01-10','10:35:00',6.93),('7643','2014-01-10','10:40:00',8.69),('7643','2014-01-10','10:45:00',9.13),('7643','2014-01-10','10:50:00',9.23),('7643','2014-01-10','10:55:00',9.23),('7643','2014-01-10','11:00:00',9.05),('7643','2014-01-10','11:05:00',8.63),('7643','2014-01-10','11:10:00',9.28),('7643','2014-01-10','11:15:00',8.45),('7643','2014-01-10','11:20:00',7.88),('7643','2014-01-10','11:25:00',8.01),('7643','2014-01-10','11:30:00',7.93),('7643','2014-01-10','11:35:00',6.91),('7643','2014-01-10','11:40:00',6.35),('7643','2014-01-10','11:45:00',6.47),('7643','2014-01-10','11:50:00',7.03),('7643','2014-01-10','11:55:00',7.21),('7643','2014-01-10','12:00:00',7.31),('7643','2014-01-10','12:05:00',8.53),('7643','2014-01-10','12:10:00',7.71),('7643','2014-01-10','12:15:00',7.58),('7643','2014-01-10','12:20:00',7.19),('7643','2014-01-10','12:25:00',6.88),('7643','2014-01-10','12:30:00',6.35),('7643','2014-01-10','12:35:00',5.35),('7643','2014-01-10','12:40:00',5.04),('7643','2014-01-10','12:45:00',5.69),('7643','2014-01-10','12:50:00',7.14),('7643','2014-01-10','12:55:00',7.99),('7643','2014-01-10','13:00:00',7.96),('7643','2014-01-10','13:05:00',7.69),('7643','2014-01-10','13:10:00',7.64),('7643','2014-01-10','13:15:00',8.3),('7643','2014-01-10','13:20:00',6.91),('7643','2014-01-10','13:25:00',5.79),('7643','2014-01-10','13:30:00',5.05),('7643','2014-01-10','13:35:00',5.02),('7643','2014-01-10','13:40:00',4.36),('7643','2014-01-10','13:45:00',4.78),('7643','2014-01-10','13:50:00',3.62),('7643','2014-01-10','13:55:00',3.86),('7643','2014-01-10','14:00:00',5.56),('7643','2014-01-10','14:05:00',5.79),('7643','2014-01-10','14:10:00',5.19),('7643','2014-01-10','14:15:00',3.15),('7643','2014-01-10','14:20:00',2.34),('7643','2014-01-10','14:25:00',2.04),('7643','2014-01-10','14:30:00',2.19),('7643','2014-01-10','14:35:00',2.53),('7643','2014-01-10','14:40:00',2.96),('7643','2014-01-10','14:45:00',3.07),('7643','2014-01-10','14:50:00',2.8),('7643','2014-01-10','14:55:00',2.36),('7643','2014-01-10','15:00:00',2.29),('7643','2014-01-10','15:05:00',2.16),('7643','2014-01-10','15:10:00',2.07),('7643','2014-01-10','15:15:00',2.06),('7643','2014-01-10','15:20:00',1.95),('7643','2014-01-10','15:25:00',1.8),('7643','2014-01-10','15:30:00',1.74),('7643','2014-01-10','15:35:00',1.54),('7643','2014-01-10','15:40:00',1.35),('7643','2014-01-10','15:45:00',1.21),('7643','2014-01-10','15:50:00',1.14),('7643','2014-01-09','08:50:00',1.12),('7643','2014-01-09','08:55:00',1.26),('7643','2014-01-09','09:00:00',1.27),('7643','2014-01-09','09:05:00',1.24),('7643','2014-01-09','09:10:00',1.58),('7643','2014-01-09','09:15:00',1.54),('7643','2014-01-09','09:20:00',1.4),('7643','2014-01-09','09:25:00',1.55),('7643','2014-01-09','09:30:00',1.81),('7643','2014-01-09','09:35:00',1.97),('7643','2014-01-09','09:40:00',1.96),('7643','2014-01-09','09:45:00',1.88),('7643','2014-01-09','09:50:00',1.98),('7643','2014-01-09','09:55:00',2.06),('7643','2014-01-09','10:00:00',2.05),('7643','2014-01-09','10:05:00',1.96),('7643','2014-01-09','10:10:00',1.97),('7643','2014-01-09','10:15:00',2.08),('7643','2014-01-09','10:20:00',2.15),('7643','2014-01-09','10:25:00',2.29),('7643','2014-01-09','10:30:00',2.23),('7643','2014-01-09','10:35:00',2.13),('7643','2014-01-09','10:40:00',2),('7643','2014-01-09','10:45:00',2.08),('7643','2014-01-09','10:50:00',2.26),('7643','2014-01-09','10:55:00',2.27),('7643','2014-01-09','11:00:00',2.36),('7643','2014-01-09','11:05:00',2.56),('7643','2014-01-09','11:10:00',2.56),('7643','2014-01-09','11:15:00',2.19),('7643','2014-01-09','11:20:00',2),('7643','2014-01-09','11:25:00',2.14),('7643','2014-01-09','11:30:00',2.47),('7643','2014-01-09','11:35:00',2.82),('7643','2014-01-09','11:40:00',2.87),('7643','2014-01-09','11:45:00',2.62),('7643','2014-01-09','11:50:00',2.76),('7643','2014-01-09','11:55:00',2.94),('7643','2014-01-09','12:00:00',2.28),('7643','2014-01-09','12:05:00',1.89),('7643','2014-01-09','12:10:00',1.97),('7643','2014-01-09','12:15:00',2.24),('7643','2014-01-09','12:20:00',2.65),('7643','2014-01-09','12:25:00',2.68),('7643','2014-01-09','12:30:00',2.93),('7643','2014-01-09','12:35:00',2.83),('7643','2014-01-09','12:40:00',2.66),('7643','2014-01-09','12:45:00',2.77),('7643','2014-01-09','12:50:00',3.25),('7643','2014-01-09','12:55:00',3.21),('7643','2014-01-09','13:00:00',3.3),('7643','2014-01-09','13:05:00',3.45),('7643','2014-01-09','13:10:00',3.21),('7643','2014-01-09','13:15:00',2.73),('7643','2014-01-09','13:20:00',2.48),('7643','2014-01-09','13:25:00',2.42),('7643','2014-01-09','13:30:00',2.59),('7643','2014-01-09','13:35:00',2.64),('7643','2014-01-09','13:40:00',2.75),('7643','2014-01-09','13:45:00',2.49),('7643','2014-01-09','13:50:00',2.54),('7643','2014-01-09','13:55:00',2.39),('7643','2014-01-09','14:00:00',2),('7643','2014-01-09','14:05:00',1.96),('7643','2014-01-09','14:10:00',1.84),('7643','2014-01-09','14:15:00',1.58),('7643','2014-01-09','14:20:00',1.29),('7643','2014-01-09','14:25:00',1.06),('7643','2014-01-09','14:30:00',1.1),('7643','2014-01-09','14:35:00',1.01),('7643','2014-01-09','14:40:00',1.02),('7643','2014-01-09','14:45:00',1.02),('7643','2014-01-09','14:50:00',1.2),('7643','2014-01-09','14:55:00',1.18),('7643','2014-01-09','15:00:00',1.24),('7643','2014-01-09','15:05:00',1.16),('7643','2014-01-09','15:10:00',1.38),('7643','2014-01-09','15:15:00',1.18),('7643','2014-01-09','15:45:00',1.05),('7643','2014-01-08','08:35:00',1.38),('7643','2014-01-08','08:40:00',1.53),('7643','2014-01-08','08:45:00',1.6),('7643','2014-01-08','08:50:00',1.7),('7643','2014-01-08','08:55:00',2.11),('7643','2014-01-08','09:00:00',2.23),('7643','2014-01-08','09:05:00',2.48),('7643','2014-01-08','09:10:00',3.6),('7643','2014-01-08','09:15:00',4.15),('7643','2014-01-08','09:20:00',4.64),('7643','2014-01-08','09:25:00',3.84),('7643','2014-01-08','09:30:00',6.01),('7643','2014-01-08','09:35:00',6.69),('7643','2014-01-08','09:40:00',6.19),('7643','2014-01-08','09:45:00',6.83),('7643','2014-01-08','09:50:00',6.92),('7643','2014-01-08','09:55:00',7.17),('7643','2014-01-08','10:00:00',7.38),('7643','2014-01-08','10:05:00',7.15),('7643','2014-01-08','10:10:00',5.75),('7643','2014-01-08','10:15:00',6.61),('7643','2014-01-08','10:20:00',6.69),('7643','2014-01-08','10:25:00',7.04),('7643','2014-01-08','10:30:00',7.08),('7643','2014-01-08','10:35:00',7.28),('7643','2014-01-08','10:40:00',7.27),('7643','2014-01-08','10:45:00',7.82),('7643','2014-01-08','10:50:00',7.92),('7643','2014-01-08','10:55:00',5.64),('7643','2014-01-08','11:00:00',4.07),('7643','2014-01-08','11:05:00',3.81),('7643','2014-01-08','11:10:00',4.24),('7643','2014-01-08','11:15:00',4.04),('7643','2014-01-08','11:20:00',4.41),('7643','2014-01-08','11:25:00',4.63),('7643','2014-01-08','11:30:00',4.33),('7643','2014-01-08','11:35:00',4.1),('7643','2014-01-08','11:40:00',4.97),('7643','2014-01-08','11:45:00',5.48),('7643','2014-01-08','11:50:00',4.42),('7643','2014-01-08','11:55:00',3.87),('7643','2014-01-08','12:00:00',3.61),('7643','2014-01-08','12:05:00',3.15),('7643','2014-01-08','12:10:00',2.97),('7643','2014-01-08','12:15:00',3.47),('7643','2014-01-08','12:20:00',3.04),('7643','2014-01-08','12:25:00',3.06),('7643','2014-01-08','12:30:00',3.13),('7643','2014-01-08','12:35:00',3.14),('7643','2014-01-08','12:40:00',3.32),('7643','2014-01-08','12:45:00',3.6),('7643','2014-01-08','12:50:00',3.61),('7643','2014-01-08','12:55:00',2.91),('7643','2014-01-08','13:00:00',2.76),('7643','2014-01-08','13:05:00',2.86),('7643','2014-01-08','13:10:00',3.15),('7643','2014-01-08','13:15:00',3.96),('7643','2014-01-08','13:20:00',3.59),('7643','2014-01-08','13:25:00',3.42),('7643','2014-01-08','13:30:00',3.53),('7643','2014-01-08','13:35:00',3.18),('7643','2014-01-08','13:40:00',2.79),('7643','2014-01-08','13:45:00',2.62),('7643','2014-01-08','13:50:00',2.8),('7643','2014-01-08','13:55:00',2.68),('7643','2014-01-08','14:00:00',2.41),('7643','2014-01-08','14:05:00',2.29),('7643','2014-01-08','14:10:00',2.39),('7643','2014-01-08','14:15:00',2.43),('7643','2014-01-08','14:20:00',2.32),('7643','2014-01-08','14:25:00',2.11),('7643','2014-01-08','14:30:00',2.08),('7643','2014-01-08','14:35:00',2.21),('7643','2014-01-08','14:40:00',2.12),('7643','2014-01-08','14:45:00',2.1),('7643','2014-01-08','14:50:00',1.93),('7643','2014-01-08','14:55:00',1.82),('7643','2014-01-08','15:00:00',1.72),('7643','2014-01-08','15:05:00',1.69),('7643','2014-01-08','15:10:00',1.64),('7643','2014-01-08','15:15:00',1.53),('7643','2014-01-08','15:20:00',1.43),('7643','2014-01-08','15:25:00',1.23),('7643','2014-01-08','15:30:00',1.16),('7643','2014-01-08','15:35:00',1.07),('7643','2014-01-08','15:40:00',1.02),('7643','2014-01-07','08:10:00',1.11),('7643','2014-01-07','08:15:00',1.4),('7643','2014-01-07','08:20:00',1.64),('7643','2014-01-07','08:25:00',2.04),('7643','2014-01-07','08:30:00',2.37),('7643','2014-01-07','08:35:00',2.67),('7643','2014-01-07','08:40:00',2.92),('7643','2014-01-07','08:45:00',3),('7643','2014-01-07','08:50:00',2.79),('7643','2014-01-07','08:55:00',3.64),('7643','2014-01-07','09:00:00',4.03),('7643','2014-01-07','09:05:00',4.29),('7643','2014-01-07','09:10:00',4.66),('7643','2014-01-07','09:15:00',4.97),('7643','2014-01-07','09:20:00',5.16),('7643','2014-01-07','09:25:00',5.44),('7643','2014-01-07','09:30:00',5.54),('7643','2014-01-07','09:35:00',5.66),('7643','2014-01-07','09:40:00',6.22),('7643','2014-01-07','09:45:00',6.53),('7643','2014-01-07','09:50:00',6.6),('7643','2014-01-07','09:55:00',6.84),('7643','2014-01-07','10:00:00',7.03),('7643','2014-01-07','10:05:00',6.88),('7643','2014-01-07','10:10:00',7.19),('7643','2014-01-07','10:15:00',7.48),('7643','2014-01-07','10:20:00',7.83),('7643','2014-01-07','10:25:00',7.96),('7643','2014-01-07','10:30:00',8.41),('7643','2014-01-07','10:35:00',8.07),('7643','2014-01-07','10:40:00',7.87),('7643','2014-01-07','10:45:00',8.52),('7643','2014-01-07','10:50:00',8.76),('7643','2014-01-07','10:55:00',8.95),('7643','2014-01-07','11:00:00',9.07),('7643','2014-01-07','11:05:00',9.2),('7643','2014-01-07','11:10:00',9.39),('7643','2014-01-07','11:15:00',9.48),('7643','2014-01-07','11:20:00',9.52),('7643','2014-01-07','11:25:00',9.38),('7643','2014-01-07','11:30:00',9.43),('7643','2014-01-07','11:35:00',9.87),('7643','2014-01-07','11:40:00',10.05),('7643','2014-01-07','11:45:00',9.92),('7643','2014-01-07','11:50:00',9.88),('7643','2014-01-07','11:55:00',9.69),('7643','2014-01-07','12:00:00',9.69),('7643','2014-01-07','12:05:00',9.54),('7643','2014-01-07','12:10:00',9.67),('7643','2014-01-07','12:15:00',9.58),('7643','2014-01-07','12:20:00',9.61),('7643','2014-01-07','12:25:00',9.6),('7643','2014-01-07','12:30:00',9.58),('7643','2014-01-07','12:35:00',9.29),('7643','2014-01-07','12:40:00',9.43),('7643','2014-01-07','12:45:00',9.01),('7643','2014-01-07','12:50:00',8.73),('7643','2014-01-07','12:55:00',9.15),('7643','2014-01-07','13:00:00',8.96),('7643','2014-01-07','13:05:00',8.86),('7643','2014-01-07','13:10:00',8.88),('7643','2014-01-07','13:15:00',8.71),('7643','2014-01-07','13:20:00',8.63),('7643','2014-01-07','13:25:00',8.37),('7643','2014-01-07','13:30:00',8.22),('7643','2014-01-07','13:35:00',8.1),('7643','2014-01-07','13:40:00',8.1),('7643','2014-01-07','13:45:00',7.64),('7643','2014-01-07','13:50:00',7.67),('7643','2014-01-07','13:55:00',7.57),('7643','2014-01-07','14:00:00',7.4),('7643','2014-01-07','14:05:00',7.24),('7643','2014-01-07','14:10:00',7.06),('7643','2014-01-07','14:15:00',7.02),('7643','2014-01-07','14:20:00',6.96),('7643','2014-01-07','14:25:00',6.83),('7643','2014-01-07','14:30:00',6.84),('7643','2014-01-07','14:35:00',6.66),('7643','2014-01-07','14:40:00',6.07),('7643','2014-01-07','14:45:00',5.73),('7643','2014-01-07','14:50:00',5.53),('7643','2014-01-07','14:55:00',4.75),('7643','2014-01-07','15:00:00',4.12),('7643','2014-01-07','15:05:00',4.26),('7643','2014-01-07','15:10:00',3.41),('7643','2014-01-07','15:15:00',3.68),('7643','2014-01-07','15:20:00',3.95),('7643','2014-01-07','15:25:00',3.82),('7643','2014-01-07','15:30:00',3.38),('7643','2014-01-07','15:35:00',3.14),('7643','2014-01-07','15:40:00',2.84),('7643','2014-01-07','15:45:00',2.65),('7643','2014-01-07','15:50:00',2.26),('7643','2014-01-07','15:55:00',1.78),('7643','2014-01-07','16:00:00',1.59),('7643','2014-01-07','16:05:00',1.27),('7643','2014-01-07','16:10:00',1.17),('7643','2014-01-06','08:05:00',1.14),('7643','2014-01-06','08:10:00',1.41),('7643','2014-01-06','08:15:00',1.67),('7643','2014-01-06','08:20:00',1.95),('7643','2014-01-06','08:25:00',2.22),('7643','2014-01-06','08:30:00',2.54),('7643','2014-01-06','08:35:00',2.85),('7643','2014-01-06','08:40:00',3.17),('7643','2014-01-06','08:45:00',3.5),('7643','2014-01-06','08:50:00',3.79),('7643','2014-01-06','08:55:00',4.1),('7643','2014-01-06','09:00:00',4.42),('7643','2014-01-06','09:05:00',4.74),('7643','2014-01-06','09:10:00',5.03),('7643','2014-01-06','09:15:00',5.32),('7643','2014-01-06','09:20:00',5.65),('7643','2014-01-06','09:25:00',5.91),('7643','2014-01-06','09:30:00',6.23),('7643','2014-01-06','09:35:00',6.47),('7643','2014-01-06','09:40:00',6.74),('7643','2014-01-06','09:45:00',6.95),('7643','2014-01-06','09:50:00',7.16),('7643','2014-01-06','09:55:00',7.35),('7643','2014-01-06','10:00:00',7.57),('7643','2014-01-06','10:05:00',7.77),('7643','2014-01-06','10:10:00',7.99),('7643','2014-01-06','10:15:00',8.14),('7643','2014-01-06','10:20:00',8.28),('7643','2014-01-06','10:25:00',8.44),('7643','2014-01-06','10:30:00',8.54),('7643','2014-01-06','10:35:00',8.75),('7643','2014-01-06','10:40:00',8.82),('7643','2014-01-06','10:45:00',8.97),('7643','2014-01-06','10:50:00',9.06),('7643','2014-01-06','10:55:00',9.22),('7643','2014-01-06','11:00:00',9.44),('7643','2014-01-06','11:05:00',9.54),('7643','2014-01-06','11:10:00',9.61),('7643','2014-01-06','11:15:00',9.65),('7643','2014-01-06','11:20:00',9.75),('7643','2014-01-06','11:25:00',9.79),('7643','2014-01-06','11:30:00',9.8),('7643','2014-01-06','11:35:00',9.92),('7643','2014-01-06','11:40:00',9.98),('7643','2014-01-06','11:45:00',9.99),('7643','2014-01-06','11:50:00',10.03),('7643','2014-01-06','11:55:00',10.12),('7643','2014-01-06','12:00:00',10.06),('7643','2014-01-06','12:05:00',10.13),('7643','2014-01-06','12:10:00',10.16),('7643','2014-01-06','12:15:00',10.11),('7643','2014-01-06','12:20:00',10.05),('7643','2014-01-06','12:25:00',10.04),('7643','2014-01-06','12:30:00',9.98),('7643','2014-01-06','12:35:00',9.93),('7643','2014-01-06','12:40:00',9.49),('7643','2014-01-06','12:45:00',9.38),('7643','2014-01-06','12:50:00',9.5),('7643','2014-01-06','12:55:00',9.72),('7643','2014-01-06','13:00:00',9.28),('7643','2014-01-06','13:05:00',8.93),('7643','2014-01-06','13:10:00',9.04),('7643','2014-01-06','13:15:00',8.95),('7643','2014-01-06','13:20:00',8.5),('7643','2014-01-06','13:25:00',8.39),('7643','2014-01-06','13:30:00',8.11),('7643','2014-01-06','13:35:00',8.11),('7643','2014-01-06','13:40:00',8.21),('7643','2014-01-06','13:45:00',8.4),('7643','2014-01-06','13:50:00',8.36),('7643','2014-01-06','13:55:00',8.04),('7643','2014-01-06','14:00:00',8.04),('7643','2014-01-06','14:05:00',7.7),('7643','2014-01-06','14:10:00',7.39),('7643','2014-01-06','14:15:00',7.26),('7643','2014-01-06','14:20:00',7.2),('7643','2014-01-06','14:25:00',6.84),('7643','2014-01-06','14:30:00',6.59),('7643','2014-01-06','14:35:00',6.42),('7643','2014-01-06','14:40:00',6.43),('7643','2014-01-06','14:45:00',5.96),('7643','2014-01-06','14:50:00',5.9),('7643','2014-01-06','14:55:00',5.72),('7643','2014-01-06','15:00:00',5.41),('7643','2014-01-06','15:05:00',5.31),('7643','2014-01-06','15:10:00',5.09),('7643','2014-01-06','15:15:00',4.76),('7643','2014-01-06','15:20:00',4.46),('7643','2014-01-06','15:25:00',4.04),('7643','2014-01-06','15:30:00',3.58),('7643','2014-01-06','15:35:00',3.12),('7643','2014-01-06','15:40:00',2.47),('7643','2014-01-06','15:45:00',2.35),('7643','2014-01-06','15:50:00',2.18),('7643','2014-01-06','15:55:00',2.01),('7643','2014-01-06','16:00:00',1.62),('7643','2014-01-06','16:05:00',1.45),('7643','2014-01-06','16:10:00',1.57),('7643','2014-04-23','07:05:00',1.04),('7643','2014-04-23','07:10:00',1.28),('7643','2014-04-23','07:15:00',1.55),('7643','2014-04-23','07:20:00',1.84),('7643','2014-04-23','07:25:00',2.13),('7643','2014-04-23','07:30:00',2.43),('7643','2014-04-23','07:35:00',2.76),('7643','2014-04-23','07:40:00',3.14),('7643','2014-04-23','07:45:00',3.47),('7643','2014-04-23','07:50:00',3.85),('7643','2014-04-23','07:55:00',4.21),('7643','2014-04-23','08:00:00',4.59),('7643','2014-04-23','08:05:00',4.93),('7643','2014-04-23','08:10:00',5.29),('7643','2014-04-23','08:15:00',5.64),('7643','2014-04-23','08:20:00',5.99),('7643','2014-04-23','08:25:00',6.33),('7643','2014-04-23','08:30:00',6.65),('7643','2014-04-23','08:35:00',7.01),('7643','2014-04-23','08:40:00',7.33),('7643','2014-04-23','08:45:00',7.67),('7643','2014-04-23','08:50:00',7.99),('7643','2014-04-23','08:55:00',8.29),('7643','2014-04-23','09:00:00',8.67),('7643','2014-04-23','09:05:00',8.93),('7643','2014-04-23','09:10:00',9.15),('7643','2014-04-23','09:15:00',9.44),('7643','2014-04-23','09:20:00',9.76),('7643','2014-04-23','09:25:00',10.07),('7643','2014-04-23','09:30:00',10.29),('7643','2014-04-23','09:35:00',10.58),('7643','2014-04-23','09:40:00',10.79),('7643','2014-04-23','09:45:00',11.03),('7643','2014-04-23','09:50:00',11.3),('7643','2014-04-23','09:55:00',11.54),('7643','2014-04-23','10:00:00',11.71),('7643','2014-04-23','10:05:00',11.91),('7643','2014-04-23','10:10:00',12.03),('7643','2014-04-23','10:15:00',12.25),('7643','2014-04-23','10:20:00',12.43),('7643','2014-04-23','10:25:00',12.64),('7643','2014-04-23','10:30:00',12.87),('7643','2014-04-23','10:35:00',13.12),('7643','2014-04-23','10:40:00',13.31),('7643','2014-04-23','10:45:00',13.48),('7643','2014-04-23','10:50:00',13.75),('7643','2014-04-23','10:55:00',13.78),('7643','2014-04-23','11:00:00',13.94),('7643','2014-04-23','11:05:00',13.83),('7643','2014-04-23','11:10:00',14.09),('7643','2014-04-23','11:15:00',14.19),('7643','2014-04-23','11:20:00',14.32),('7643','2014-04-23','11:25:00',14.41),('7643','2014-04-23','11:30:00',14.44),('7643','2014-04-23','11:35:00',13.72),('7643','2014-04-23','11:40:00',14.74),('7643','2014-04-23','11:45:00',14.93),('7643','2014-04-23','11:50:00',15.02),('7643','2014-04-23','11:55:00',15.22),('7643','2014-04-23','12:00:00',15.28),('7643','2014-04-23','12:05:00',15.45),('7643','2014-04-23','12:10:00',16.1),('7643','2014-04-23','12:15:00',14.03),('7643','2014-04-23','12:20:00',15.68),('7643','2014-04-23','12:25:00',15.24),('7643','2014-04-23','12:30:00',15.55),('7643','2014-04-23','12:35:00',15.8),('7643','2014-04-23','12:40:00',16.12),('7643','2014-04-23','12:45:00',15.82),('7643','2014-04-23','12:50:00',16.31),('7643','2014-04-23','12:55:00',16.27),('7643','2014-04-23','13:00:00',16.04),('7643','2014-04-23','13:05:00',15.86),('7643','2014-04-23','13:10:00',13.32),('7643','2014-04-23','13:15:00',4.82),('7643','2014-04-23','13:20:00',17.18),('7643','2014-04-23','13:25:00',16.7),('7643','2014-04-23','13:30:00',16.82),('7643','2014-04-23','13:35:00',13.26),('7643','2014-04-23','13:40:00',12.66),('7643','2014-04-23','13:45:00',5.69),('7643','2014-04-23','13:50:00',12.99),('7643','2014-04-23','13:55:00',18.67),('7643','2014-04-23','14:00:00',15.54),('7643','2014-04-23','14:05:00',17.33),('7643','2014-04-23','14:10:00',14.97),('7643','2014-04-23','14:15:00',16.68),('7643','2014-04-23','14:20:00',13.1),('7643','2014-04-23','14:25:00',15.23),('7643','2014-04-23','14:30:00',17.31),('7643','2014-04-23','14:35:00',16.32),('7643','2014-04-23','14:40:00',11.55),('7643','2014-04-23','14:45:00',9.43),('7643','2014-04-23','14:50:00',6.02),('7643','2014-04-23','14:55:00',13.61),('7643','2014-04-23','15:00:00',18),('7643','2014-04-23','15:05:00',17.41),('7643','2014-04-23','15:10:00',17.18),('7643','2014-04-23','15:15:00',14.76),('7643','2014-04-23','15:20:00',9.73),('7643','2014-04-23','15:25:00',8.76),('7643','2014-04-23','15:30:00',11.22),('7643','2014-04-23','15:35:00',11.17),('7643','2014-04-23','15:40:00',8.68),('7643','2014-04-23','15:45:00',7.61),('7643','2014-04-23','15:50:00',8.61),('7643','2014-04-23','15:55:00',10.39),('7643','2014-04-23','16:00:00',14.43),('7643','2014-04-23','16:05:00',14.05),('7643','2014-04-23','16:10:00',11.88),('7643','2014-04-23','16:15:00',13.84),('7643','2014-04-23','16:20:00',12.01),('7643','2014-04-23','16:25:00',10.13),('7643','2014-04-23','16:30:00',13.3),('7643','2014-04-23','16:35:00',7.11),('7643','2014-04-23','16:40:00',8.23),('7643','2014-04-23','16:45:00',7.89),('7643','2014-04-23','16:50:00',5.51),('7643','2014-04-23','16:55:00',5.87),('7643','2014-04-23','17:00:00',5.05),('7643','2014-04-23','17:05:00',4.58),('7643','2014-04-23','17:10:00',4.26),('7643','2014-04-23','17:15:00',3.9),('7643','2014-04-23','17:20:00',3.93),('7643','2014-04-23','17:25:00',3.87),('7643','2014-04-23','17:30:00',3.76),('7643','2014-04-23','17:35:00',3.61),('7643','2014-04-23','17:40:00',3.19),('7643','2014-04-23','17:45:00',2.19),('7643','2014-04-23','17:50:00',1.72),('7643','2014-04-23','17:55:00',1.48),('7643','2014-04-23','18:00:00',1.26),('7643','2014-04-23','18:05:00',1.2),('7643','2014-04-23','18:10:00',1.4),('7643','2014-04-23','18:15:00',1.43),('7643','2014-04-23','18:20:00',1.16),('7643','2014-01-05','10:20:00',1.01),('7643','2014-01-05','10:25:00',1.04),('7643','2014-01-05','10:30:00',1.03),('7643','2014-01-05','10:50:00',1.04),('7643','2014-01-05','10:55:00',1.43),('7643','2014-01-05','11:00:00',1.82),('7643','2014-01-05','11:05:00',2.38),('7643','2014-01-05','11:10:00',2.85),('7643','2014-01-05','11:15:00',3.32),('7643','2014-01-05','11:20:00',3.47),('7643','2014-01-05','11:25:00',3.41),('7643','2014-01-05','11:30:00',3),('7643','2014-01-05','11:35:00',5.3),('7643','2014-01-05','11:40:00',10.29),('7643','2014-01-05','11:45:00',10.64),('7643','2014-01-05','11:50:00',7.79),('7643','2014-01-05','11:55:00',7.95),('7643','2014-01-05','12:00:00',4.41),('7643','2014-01-05','12:05:00',9.66),('7643','2014-01-05','12:10:00',10.42),('7643','2014-01-05','12:15:00',10.18),('7643','2014-01-05','12:20:00',10.09),('7643','2014-01-05','12:25:00',10.05),('7643','2014-01-05','12:30:00',9.95),('7643','2014-01-05','12:35:00',9.78),('7643','2014-01-05','12:40:00',9.84),('7643','2014-01-05','12:45:00',9.88),('7643','2014-01-05','12:50:00',9.84),('7643','2014-01-05','12:55:00',9.72),('7643','2014-01-05','13:00:00',9.59),('7643','2014-01-05','13:05:00',9.36),('7643','2014-01-05','13:10:00',9.5),('7643','2014-01-05','13:15:00',9.7),('7643','2014-01-05','13:20:00',9.67),('7643','2014-01-05','13:25:00',9.37),('7643','2014-01-05','13:30:00',8.72),('7643','2014-01-05','13:35:00',8.75),('7643','2014-01-05','13:40:00',8.6),('7643','2014-01-05','13:45:00',8.44),('7643','2014-01-05','13:50:00',8.2),('7643','2014-01-05','13:55:00',8.15),('7643','2014-01-05','14:00:00',5.4),('7643','2014-01-05','14:05:00',1.5),('7643','2014-01-05','14:10:00',1.93),('7643','2014-01-05','14:15:00',2.32),('7643','2014-01-05','14:20:00',7.01),('7643','2014-01-05','14:25:00',3.24),('7643','2014-01-05','14:30:00',2.68),('7643','2014-01-05','14:35:00',3.17),('7643','2014-01-05','14:40:00',7.31),('7643','2014-01-05','14:45:00',7.81),('7643','2014-01-05','14:50:00',5.69),('7643','2014-01-05','14:55:00',2.06),('7643','2014-01-05','15:00:00',3.78),('7643','2014-01-05','15:05:00',4.82),('7643','2014-01-05','15:10:00',4.83),('7643','2014-01-05','15:15:00',4.56),('7643','2014-01-05','15:20:00',4.19),('7643','2014-01-05','15:25:00',3.73),('7643','2014-01-05','15:30:00',3.38),('7643','2014-01-05','15:35:00',3.27),('7643','2014-01-05','15:40:00',3.07),('7643','2014-01-05','15:45:00',2.51),('7643','2014-01-05','15:50:00',2.28),('7643','2014-01-05','15:55:00',1.87),('7643','2014-01-05','16:00:00',1.66),('7643','2014-01-05','16:05:00',1.49),('7643','2014-01-05','16:10:00',1.37),('7643','2014-01-05','16:15:00',1.16),('7643','2014-01-04','08:45:00',1.24),('7643','2014-01-04','08:50:00',1.41),('7643','2014-01-04','08:55:00',1.29),('7643','2014-01-04','09:00:00',1.12),('7643','2014-01-04','09:30:00',1.12),('7643','2014-01-04','11:35:00',1.16),('7643','2014-01-04','11:40:00',1.23),('7643','2014-01-04','11:45:00',1.01),('7643','2014-01-04','11:50:00',1.13),('7643','2014-01-04','12:05:00',1.6),('7643','2014-01-04','12:10:00',1.46),('7643','2014-01-04','12:25:00',1.07),('7643','2014-01-04','12:30:00',1.06),('7643','2014-01-04','12:35:00',1.06),('7643','2014-01-04','12:40:00',1.88),('7643','2014-01-04','12:45:00',1.56),('7643','2014-01-04','12:55:00',1.19),('7643','2014-01-04','13:00:00',1.11),('7643','2014-01-04','13:10:00',1.12),('7643','2014-01-04','13:15:00',1.54),('7643','2014-01-04','13:20:00',2.08),('7643','2014-01-04','13:25:00',1.97),('7643','2014-01-04','13:30:00',2.05),('7643','2014-01-04','13:35:00',1.24),('7643','2014-01-04','13:40:00',1.02),('7643','2014-01-04','13:45:00',1.2),('7643','2014-01-04','13:50:00',1.35),('7643','2014-01-04','13:55:00',1.22),('7643','2014-01-04','14:45:00',1.12),('7643','2014-01-04','14:50:00',1.71),('7643','2014-01-04','14:55:00',1.6),('7643','2014-01-04','15:00:00',1.65),('7643','2014-01-04','15:05:00',1.61),('7643','2014-01-04','15:10:00',2.25),('7643','2014-01-04','15:15:00',2.24),('7643','2014-01-04','15:20:00',1.75),('7643','2014-01-04','15:25:00',1.39),('7643','2014-01-04','15:30:00',1.07),('7643','2014-01-03','09:30:00',1.23),('7643','2014-01-03','09:35:00',1.6),('7643','2014-01-03','09:40:00',1.29),('7643','2014-01-03','09:45:00',1.65),('7643','2014-01-03','09:50:00',1.23),('7643','2014-01-03','10:00:00',1.39),('7643','2014-01-03','10:05:00',1.81),('7643','2014-01-03','10:10:00',1.24),('7643','2014-01-03','12:05:00',1.16),('7643','2014-01-03','12:10:00',1.39),('7643','2014-01-03','14:40:00',1.56),('7643','2014-01-03','14:45:00',1.66),('7643','2014-01-03','14:50:00',1.8),('7643','2014-01-03','14:55:00',2.01),('7643','2014-01-03','15:00:00',2.92),('7643','2014-01-03','15:05:00',1.93),('7643','2014-01-03','15:10:00',1.19),('7643','2014-01-03','15:15:00',1.02),('7643','2014-01-03','15:25:00',1.23),('7643','2014-01-03','15:30:00',1.23),('7643','2014-01-03','15:35:00',1.01),('7643','2014-01-02','08:20:00',1.56),('7643','2014-01-02','08:50:00',1.61),('7643','2014-01-02','08:55:00',2.62),('7643','2014-01-02','09:05:00',1.34),('7643','2014-01-02','09:10:00',2.2),('7643','2014-01-02','09:15:00',3.97),('7643','2014-01-02','09:20:00',3.88),('7643','2014-01-02','09:25:00',2.52),('7643','2014-01-02','09:30:00',4.74),('7643','2014-01-02','09:35:00',6.39),('7643','2014-01-02','09:40:00',7.46),('7643','2014-01-02','09:45:00',5.52),('7643','2014-01-02','09:50:00',3.39),('7643','2014-01-02','09:55:00',3.01),('7643','2014-01-02','10:00:00',3.18),('7643','2014-01-02','10:05:00',7.52),('7643','2014-01-02','10:10:00',5.38),('7643','2014-01-02','10:15:00',2.84),('7643','2014-01-02','10:20:00',9.14),('7643','2014-01-02','10:25:00',4.54),('7643','2014-01-02','10:30:00',4.24),('7643','2014-01-02','10:35:00',4.06),('7643','2014-01-02','10:40:00',4.72),('7643','2014-01-02','10:45:00',5.03),('7643','2014-01-02','10:50:00',5.06),('7643','2014-01-02','10:55:00',4.27),('7643','2014-01-02','11:00:00',3.74),('7643','2014-01-02','11:05:00',4.03),('7643','2014-01-02','11:10:00',3.26),('7643','2014-01-02','11:15:00',2.74),('7643','2014-01-02','11:20:00',3.26),('7643','2014-01-02','11:25:00',2.92),('7643','2014-01-02','11:30:00',3.07),('7643','2014-01-02','11:35:00',3.42),('7643','2014-01-02','11:40:00',3.61),('7643','2014-01-02','11:45:00',4.36),('7643','2014-01-02','11:50:00',4.11),('7643','2014-01-02','11:55:00',4.02),('7643','2014-01-02','12:00:00',4.38),('7643','2014-01-02','12:05:00',6.89),('7643','2014-01-02','12:10:00',6.29),('7643','2014-01-02','12:15:00',5.31),('7643','2014-01-02','12:20:00',3.68),('7643','2014-01-02','12:25:00',4.6),('7643','2014-01-02','12:30:00',4.77),('7643','2014-01-02','12:35:00',5.6),('7643','2014-01-02','12:40:00',5.83),('7643','2014-01-02','12:45:00',6.46),('7643','2014-01-02','12:50:00',5.66),('7643','2014-01-02','12:55:00',7.64),('7643','2014-01-02','13:00:00',4.94),('7643','2014-01-02','13:05:00',3.85),('7643','2014-01-02','13:10:00',4.66),('7643','2014-01-02','13:15:00',4.16),('7643','2014-01-02','13:20:00',3.25),('7643','2014-01-02','13:25:00',3.46),('7643','2014-01-02','13:30:00',4.86),('7643','2014-01-02','13:35:00',6.6),('7643','2014-01-02','13:40:00',4.41),('7643','2014-01-02','13:45:00',5.5),('7643','2014-01-02','13:50:00',3.46),('7643','2014-01-02','13:55:00',2.86),('7643','2014-01-02','14:00:00',2.35),('7643','2014-01-02','14:05:00',1.39),('7643','2014-01-02','15:25:00',1.01),('7643','2014-01-01','08:35:00',2.42),('7643','2014-01-01','08:40:00',2.99),('7643','2014-01-01','08:45:00',3.29),('7643','2014-01-01','08:50:00',3.65),('7643','2014-01-01','08:55:00',3.9),('7643','2014-01-01','09:00:00',4.23),('7643','2014-01-01','09:05:00',4.57),('7643','2014-01-01','09:10:00',4.84),('7643','2014-01-01','09:15:00',5.09),('7643','2014-01-01','09:20:00',5.41),('7643','2014-01-01','09:25:00',5.62),('7643','2014-01-01','09:30:00',5.82),('7643','2014-01-01','09:35:00',6.07),('7643','2014-01-01','09:40:00',6.38),('7643','2014-01-01','09:45:00',6.63),('7643','2014-01-01','09:50:00',6.85),('7643','2014-01-01','09:55:00',7.09),('7643','2014-01-01','10:00:00',7.41),('7643','2014-01-01','10:05:00',7.65),('7643','2014-01-01','10:10:00',7.86),('7643','2014-01-01','10:15:00',8.01),('7643','2014-01-01','10:20:00',8.19),('7643','2014-01-01','10:25:00',8.19),('7643','2014-01-01','10:30:00',8.39),('7643','2014-01-01','10:35:00',8.52),('7643','2014-01-01','10:40:00',8.52),('7643','2014-01-01','10:45:00',8.59),('7643','2014-01-01','10:50:00',8.69),('7643','2014-01-01','10:55:00',9.04),('7643','2014-01-01','11:00:00',8.94),('7643','2014-01-01','11:05:00',8.98),('7643','2014-01-01','11:10:00',6.73),('7643','2014-01-01','11:15:00',4.76),('7643','2014-01-01','11:20:00',4.47),('7643','2014-01-01','11:25:00',5.25),('7643','2014-01-01','11:30:00',6.12),('7643','2014-01-01','11:35:00',6.37),('7643','2014-01-01','11:40:00',6.83),('7643','2014-01-01','11:45:00',5.81),('7643','2014-01-01','11:50:00',5.1),('7643','2014-01-01','11:55:00',4.6),('7643','2014-01-01','12:00:00',4.29),('7643','2014-01-01','12:05:00',4.38),('7643','2014-01-01','12:10:00',4.69),('7643','2014-01-01','12:15:00',3.98),('7643','2014-01-01','12:20:00',3.68),('7643','2014-01-01','12:25:00',3.52),('7643','2014-01-01','12:30:00',3.31),('7643','2014-01-01','12:35:00',2.64),('7643','2014-01-01','12:40:00',2.77),('7643','2014-01-01','12:45:00',3.34),('7643','2014-01-01','12:50:00',6.12),('7643','2014-01-01','12:55:00',11.9),('7643','2014-01-01','13:00:00',5.53),('7643','2014-01-01','13:05:00',2.64),('7643','2014-01-01','13:10:00',2.19),('7643','2014-01-01','13:15:00',2.21),('7643','2014-01-01','13:20:00',1.93),('7643','2014-01-01','13:25:00',2.01),('7643','2014-01-01','13:30:00',2.84),('7643','2014-01-01','13:35:00',4.06),('7643','2014-01-01','13:40:00',6.08),('7643','2014-01-01','13:45:00',5.1),('7643','2014-01-01','13:50:00',2.98),('7643','2014-01-01','13:55:00',1.96),('7643','2014-01-01','14:00:00',1.47),('7643','2014-01-01','14:05:00',1.18),('7643','2014-01-01','14:15:00',1.76),('7643','2014-01-01','14:20:00',2.33),('7643','2014-01-01','14:25:00',2.3),('7643','2014-01-01','14:30:00',2.09),('7643','2014-01-01','14:35:00',1.9),('7643','2014-01-01','14:40:00',1.63),('7643','2014-01-01','14:45:00',1.19),('7643','2014-01-01','15:00:00',1.06),('7643','2014-01-01','15:05:00',1.4),('7643','2014-01-01','15:10:00',1.34),('7643','2014-01-01','15:15:00',1.01),('7643','2014-01-01','15:45:00',1.09),('7643','2013-12-31','08:05:00',1.27),('7643','2013-12-31','08:10:00',1.55),('7643','2013-12-31','08:15:00',1.85),('7643','2013-12-31','08:20:00',2.13),('7643','2013-12-31','08:25:00',2.54),('7643','2013-12-31','08:30:00',2.81),('7643','2013-12-31','08:35:00',2.05),('7643','2013-12-31','08:40:00',2.24),('7643','2013-12-31','08:45:00',1.37),('7643','2013-12-31','08:50:00',2.64),('7643','2013-12-31','08:55:00',4.49),('7643','2013-12-31','09:00:00',4.68),('7643','2013-12-31','09:05:00',4.7),('7643','2013-12-31','09:10:00',6.35),('7643','2013-12-31','09:15:00',4.04),('7643','2013-12-31','09:20:00',3.42),('7643','2013-12-31','09:25:00',4.49),('7643','2013-12-31','09:30:00',6.82),('7643','2013-12-31','09:35:00',5.7),('7643','2013-12-31','09:40:00',6.38),('7643','2013-12-31','09:45:00',5.88),('7643','2013-12-31','09:50:00',8.21),('7643','2013-12-31','09:55:00',6.45),('7643','2013-12-31','10:00:00',4.59),('7643','2013-12-31','10:05:00',4.14),('7643','2013-12-31','10:10:00',3.47),('7643','2013-12-31','10:15:00',3.03),('7643','2013-12-31','10:20:00',2.8),('7643','2013-12-31','10:25:00',2.74),('7643','2013-12-31','10:30:00',2.72),('7643','2013-12-31','10:35:00',2.62),('7643','2013-12-31','10:40:00',2.65),('7643','2013-12-31','10:45:00',2.77),('7643','2013-12-31','10:50:00',2.97),('7643','2013-12-31','10:55:00',3.27),('7643','2013-12-31','11:00:00',3.33),('7643','2013-12-31','11:05:00',3.17),('7643','2013-12-31','11:10:00',3.1),('7643','2013-12-31','11:15:00',3.22),('7643','2013-12-31','11:20:00',3.41),('7643','2013-12-31','11:25:00',3.5),('7643','2013-12-31','11:30:00',3.57),('7643','2013-12-31','11:35:00',3.43),('7643','2013-12-31','11:40:00',3.42),('7643','2013-12-31','11:45:00',3.42),('7643','2013-12-31','11:50:00',3.34),('7643','2013-12-31','11:55:00',3.48),('7643','2013-12-31','12:00:00',3.82),('7643','2013-12-31','12:05:00',4.02),('7643','2013-12-31','12:10:00',4.32),('7643','2013-12-31','12:15:00',4.51),('7643','2013-12-31','12:20:00',4.62),('7643','2013-12-31','12:25:00',4.67),('7643','2013-12-31','12:30:00',5),('7643','2013-12-31','12:35:00',5.32),('7643','2013-12-31','12:40:00',4.77),('7643','2013-12-31','12:45:00',4.89),('7643','2013-12-31','12:50:00',4.7),('7643','2013-12-31','12:55:00',4.63),('7643','2013-12-31','13:00:00',4.46),('7643','2013-12-31','13:05:00',3.96),('7643','2013-12-31','13:10:00',3.74),('7643','2013-12-31','13:15:00',3.71),('7643','2013-12-31','13:20:00',3.93),('7643','2013-12-31','13:25:00',5.41),('7643','2013-12-31','13:30:00',5.8),('7643','2013-12-31','13:35:00',5.36),('7643','2013-12-31','13:40:00',5.31),('7643','2013-12-31','13:45:00',4.77),('7643','2013-12-31','13:50:00',5.4),('7643','2013-12-31','13:55:00',8.82),('7643','2013-12-31','14:00:00',7.94),('7643','2013-12-31','14:05:00',4.28),('7643','2013-12-31','14:10:00',3.89),('7643','2013-12-31','14:15:00',4.15),('7643','2013-12-31','14:20:00',3.84),('7643','2013-12-31','14:25:00',3.3),('7643','2013-12-31','14:30:00',3.22),('7643','2013-12-31','14:35:00',2.97),('7643','2013-12-31','14:40:00',3.07),('7643','2013-12-31','14:45:00',3.27),('7643','2013-12-31','14:50:00',3.02),('7643','2013-12-31','14:55:00',3.45),('7643','2013-12-31','15:00:00',2.9),('7643','2013-12-31','15:05:00',5.28),('7643','2013-12-31','15:10:00',5.84),('7643','2013-12-31','15:15:00',4.9),('7643','2013-12-31','15:20:00',4.22),('7643','2013-12-31','15:25:00',3.79),('7643','2013-12-31','15:30:00',3.35),('7643','2013-12-31','15:35:00',3.06),('7643','2013-12-31','15:40:00',2.75),('7643','2013-12-31','15:45:00',2.41),('7643','2013-12-31','15:50:00',2.14),('7643','2013-12-31','15:55:00',1.89),('7643','2013-12-31','16:00:00',1.59),('7643','2013-12-31','16:05:00',1.3),('7643','2013-12-31','16:10:00',1.02),('7643','2013-12-30','08:05:00',1.35),('7643','2013-12-30','08:10:00',1.73),('7643','2013-12-30','08:15:00',1.98),('7643','2013-12-30','08:40:00',1.46),('7643','2013-12-30','08:45:00',2.61),('7643','2013-12-30','08:50:00',3.25),('7643','2013-12-30','08:55:00',1.43),('7643','2013-12-30','09:00:00',3.89),('7643','2013-12-30','09:05:00',1.48),('7643','2013-12-30','09:10:00',3.08),('7643','2013-12-30','09:15:00',5.18),('7643','2013-12-30','09:20:00',5.91),('7643','2013-12-30','09:25:00',6.21),('7643','2013-12-30','09:30:00',6.78),('7643','2013-12-30','09:35:00',7.14),('7643','2013-12-30','09:40:00',7.61),('7643','2013-12-30','09:45:00',4.28),('7643','2013-12-30','09:50:00',6.68),('7643','2013-12-30','09:55:00',5.47),('7643','2013-12-30','10:00:00',5.6),('7643','2013-12-30','10:05:00',6.47),('7643','2013-12-30','10:10:00',3.5),('7643','2013-12-30','10:15:00',3.43),('7643','2013-12-30','10:20:00',3),('7643','2013-12-30','10:25:00',3.21),('7643','2013-12-30','10:30:00',3.79),('7643','2013-12-30','10:35:00',3.71),('7643','2013-12-30','10:40:00',3.59),('7643','2013-12-30','10:45:00',3.7),('7643','2013-12-30','10:50:00',4.83),('7643','2013-12-30','10:55:00',5.05),('7643','2013-12-30','11:00:00',4.9),('7643','2013-12-30','11:05:00',5),('7643','2013-12-30','11:10:00',6.76),('7643','2013-12-30','11:15:00',10.16),('7643','2013-12-30','11:20:00',7.5),('7643','2013-12-30','11:25:00',7.97),('7643','2013-12-30','11:30:00',9.18),('7643','2013-12-30','11:35:00',5.54),('7643','2013-12-30','11:40:00',7.49),('7643','2013-12-30','11:45:00',5.19),('7643','2013-12-30','11:50:00',5.97),('7643','2013-12-30','11:55:00',6.19),('7643','2013-12-30','12:00:00',11.18),('7643','2013-12-30','12:05:00',10.71),('7643','2013-12-30','12:10:00',10.61),('7643','2013-12-30','12:15:00',10.5),('7643','2013-12-30','12:20:00',10.41),('7643','2013-12-30','12:25:00',10.31),('7643','2013-12-30','12:30:00',10.16),('7643','2013-12-30','12:35:00',10.05),('7643','2013-12-30','12:40:00',10.01),('7643','2013-12-30','12:45:00',9.97),('7643','2013-12-30','12:50:00',9.91),('7643','2013-12-30','12:55:00',9.77),('7643','2013-12-30','13:00:00',9.72),('7643','2013-12-30','13:05:00',9.62),('7643','2013-12-30','13:10:00',9.51),('7643','2013-12-30','13:15:00',9.42),('7643','2013-12-30','13:20:00',9.27),('7643','2013-12-30','13:25:00',9.17),('7643','2013-12-30','13:30:00',9.05),('7643','2013-12-30','13:35:00',8.86),('7643','2013-12-30','13:40:00',8.64),('7643','2013-12-30','13:45:00',8.46),('7643','2013-12-30','13:50:00',8.24),('7643','2013-12-30','13:55:00',8.09),('7643','2013-12-30','14:00:00',7.94),('7643','2013-12-30','14:05:00',7.75),('7643','2013-12-30','14:10:00',7.49),('7643','2013-12-30','14:15:00',7.3),('7643','2013-12-30','14:20:00',7.09),('7643','2013-12-30','14:25:00',6.89),('7643','2013-12-30','14:30:00',6.65),('7643','2013-12-30','14:35:00',6.39),('7643','2013-12-30','14:40:00',6.14),('7643','2013-12-30','14:45:00',5.86),('7643','2013-12-30','14:50:00',5.58),('7643','2013-12-30','14:55:00',5.31),('7643','2013-12-30','15:00:00',5.03),('7643','2013-12-30','15:05:00',4.75),('7643','2013-12-30','15:10:00',4.47),('7643','2013-12-30','15:15:00',4.17),('7643','2013-12-30','15:20:00',3.87),('7643','2013-12-30','15:25:00',3.57),('7643','2013-12-30','15:30:00',3.28),('7643','2013-12-30','15:35:00',2.99),('7643','2013-12-30','15:40:00',2.66),('7643','2013-12-30','15:45:00',2.37),('7643','2013-12-30','15:50:00',2.09),('7643','2013-12-30','15:55:00',1.83),('7643','2013-12-30','16:00:00',1.57),('7643','2013-12-30','16:05:00',1.31),('7643','2013-12-30','16:10:00',1.06),('7643','2013-12-29','08:55:00',1.06),('7643','2013-12-29','09:00:00',1.44),('7643','2013-12-29','09:05:00',1.88),('7643','2013-12-29','09:10:00',2.1),('7643','2013-12-29','09:15:00',2.09),('7643','2013-12-29','09:20:00',2.25),('7643','2013-12-29','09:25:00',2.61),('7643','2013-12-29','09:30:00',2.54),('7643','2013-12-29','09:35:00',2.05),('7643','2013-12-29','09:40:00',1.98),('7643','2013-12-29','09:45:00',1.83),('7643','2013-12-29','09:50:00',1.55),('7643','2013-12-29','09:55:00',1.37),('7643','2013-12-29','10:00:00',1.24),('7643','2013-12-29','10:05:00',1.32),('7643','2013-12-29','10:10:00',1.27),('7643','2013-12-29','10:15:00',1.19),('7643','2013-12-29','10:20:00',1.14),('7643','2013-12-29','10:25:00',1.16),('7643','2013-12-29','10:30:00',1.2),('7643','2013-12-29','10:35:00',1.21),('7643','2013-12-29','10:40:00',1.27),('7643','2013-12-29','10:45:00',1.29),('7643','2013-12-29','10:50:00',1.5),('7643','2013-12-29','10:55:00',1.78),('7643','2013-12-29','11:00:00',1.92),('7643','2013-12-29','11:05:00',2.06),('7643','2013-12-29','11:10:00',2.41),('7643','2013-12-29','11:15:00',2.85),('7643','2013-12-29','11:20:00',3.41),('7643','2013-12-29','11:25:00',3.84),('7643','2013-12-29','11:30:00',3.85),('7643','2013-12-29','11:35:00',3.6),('7643','2013-12-29','11:40:00',3.37),('7643','2013-12-29','11:45:00',3.25),('7643','2013-12-29','11:50:00',3.18),('7643','2013-12-29','11:55:00',2.81),('7643','2013-12-29','12:00:00',2.48),('7643','2013-12-29','12:05:00',2.49),('7643','2013-12-29','12:10:00',2.6),('7643','2013-12-29','12:15:00',2.63),('7643','2013-12-29','12:20:00',2.54),('7643','2013-12-29','12:25:00',2.66),('7643','2013-12-29','12:30:00',2.64),('7643','2013-12-29','12:35:00',2.59),('7643','2013-12-29','12:40:00',2.7),('7643','2013-12-29','12:45:00',2.89),('7643','2013-12-29','12:50:00',2.88),('7643','2013-12-29','12:55:00',2.6),('7643','2013-12-29','13:00:00',2.33),('7643','2013-12-29','13:05:00',2.41),('7643','2013-12-29','13:10:00',2.62),('7643','2013-12-29','13:15:00',2.46),('7643','2013-12-29','13:20:00',2.35),('7643','2013-12-29','13:25:00',2.46),('7643','2013-12-29','13:30:00',2.5),('7643','2013-12-29','13:35:00',2.46),('7643','2013-12-29','13:40:00',2.31),('7643','2013-12-29','13:45:00',2.22),('7643','2013-12-29','13:50:00',2),('7643','2013-12-29','13:55:00',1.85),('7643','2013-12-29','14:00:00',1.75),('7643','2013-12-29','14:05:00',1.53),('7643','2013-12-29','14:10:00',1.45),('7643','2013-12-29','14:15:00',1.4),('7643','2013-12-29','14:20:00',1.26),('7643','2013-12-29','14:25:00',1.31),('7643','2013-12-29','14:30:00',1.51),('7643','2013-12-29','14:35:00',1.57),('7643','2013-12-29','14:40:00',1.39),('7643','2013-12-29','14:45:00',1.48),('7643','2013-12-29','14:50:00',1.46),('7643','2013-12-29','14:55:00',1.17),('7643','2013-12-29','15:00:00',1.21),('7643','2013-12-29','15:05:00',1.33),('7643','2013-12-29','15:10:00',1.27),('7643','2013-12-29','15:15:00',1.04),('7643','2013-12-28','08:05:00',1.36),('7643','2013-12-28','08:10:00',1.2),('7643','2013-12-28','08:15:00',1.24),('7643','2013-12-28','08:20:00',1.93),('7643','2013-12-28','08:25:00',2.13),('7643','2013-12-28','08:30:00',2.47),('7643','2013-12-28','08:35:00',3.75),('7643','2013-12-28','08:40:00',2.74),('7643','2013-12-28','08:45:00',3.3),('7643','2013-12-28','08:50:00',3.12),('7643','2013-12-28','09:00:00',1.22),('7643','2013-12-28','09:05:00',3.83),('7643','2013-12-28','09:10:00',4.77),('7643','2013-12-28','09:15:00',5.12),('7643','2013-12-28','09:20:00',5.82),('7643','2013-12-28','09:25:00',5.91),('7643','2013-12-28','09:30:00',6.24),('7643','2013-12-28','09:35:00',6.46),('7643','2013-12-28','09:40:00',6.81),('7643','2013-12-28','09:45:00',7.03),('7643','2013-12-28','09:50:00',6.73),('7643','2013-12-28','09:55:00',5.98),('7643','2013-12-28','10:00:00',6.03),('7643','2013-12-28','10:05:00',6.63),('7643','2013-12-28','10:10:00',7.1),('7643','2013-12-28','10:15:00',8.27),('7643','2013-12-28','10:20:00',8.92),('7643','2013-12-28','10:25:00',6.05),('7643','2013-12-28','10:30:00',6.59),('7643','2013-12-28','10:35:00',7.54),('7643','2013-12-28','10:40:00',8.69),('7643','2013-12-28','10:45:00',3.99),('7643','2013-12-28','10:50:00',3.7),('7643','2013-12-28','10:55:00',4.02),('7643','2013-12-28','11:00:00',4.65),('7643','2013-12-28','11:05:00',3.82),('7643','2013-12-28','11:10:00',4.4),('7643','2013-12-28','11:15:00',2.7),('7643','2013-12-28','11:20:00',2.24),('7643','2013-12-28','11:25:00',1.77),('7643','2013-12-28','11:30:00',2),('7643','2013-12-28','11:35:00',2.31),('7643','2013-12-28','11:40:00',2.13),('7643','2013-12-28','11:45:00',1.32),('7643','2013-12-28','11:50:00',1.46),('7643','2013-12-28','11:55:00',2.57),('7643','2013-12-28','12:00:00',2.59),('7643','2013-12-28','12:05:00',2.52),('7643','2013-12-28','12:10:00',2.43),('7643','2013-12-28','12:15:00',2.18),('7643','2013-12-28','12:20:00',1.77),('7643','2013-12-28','12:25:00',1.78),('7643','2013-12-28','12:30:00',1.6),('7643','2013-12-28','12:35:00',1.47),('7643','2013-12-28','12:40:00',1.32),('7643','2013-12-28','13:30:00',1.04),('7643','2013-12-28','13:35:00',1.95),('7643','2013-12-28','13:40:00',2.48),('7643','2013-12-28','13:45:00',1.91),('7643','2013-12-28','13:50:00',1.48),('7643','2013-12-28','13:55:00',1.29),('7643','2013-12-28','14:00:00',1.3),('7643','2013-12-28','14:05:00',1),('7643','2013-12-27','08:05:00',1.16),('7643','2013-12-27','08:10:00',1.42),('7643','2013-12-27','08:15:00',1.7),('7643','2013-12-27','08:20:00',2),('7643','2013-12-27','08:25:00',2.3),('7643','2013-12-27','08:30:00',2.64),('7643','2013-12-27','08:35:00',2.98),('7643','2013-12-27','08:40:00',3.29),('7643','2013-12-27','08:45:00',3.58),('7643','2013-12-27','08:50:00',3.9),('7643','2013-12-27','08:55:00',4.18),('7643','2013-12-27','09:00:00',4.48),('7643','2013-12-27','09:05:00',4.78),('7643','2013-12-27','09:10:00',5.06),('7643','2013-12-27','09:15:00',5.36),('7643','2013-12-27','09:20:00',5.66),('7643','2013-12-27','09:25:00',5.95),('7643','2013-12-27','09:30:00',6.25),('7643','2013-12-27','09:35:00',6.51),('7643','2013-12-27','09:40:00',6.73),('7643','2013-12-27','09:45:00',6.92),('7643','2013-12-27','09:50:00',7.18),('7643','2013-12-27','09:55:00',7.47),('7643','2013-12-27','10:00:00',7.69),('7643','2013-12-27','10:05:00',7.85),('7643','2013-12-27','10:10:00',8.03),('7643','2013-12-27','10:15:00',8.14),('7643','2013-12-27','10:20:00',8.3),('7643','2013-12-27','10:25:00',8.47),('7643','2013-12-27','10:30:00',8.68),('7643','2013-12-27','10:35:00',8.88),('7643','2013-12-27','10:40:00',9),('7643','2013-12-27','10:45:00',9.13),('7643','2013-12-27','10:50:00',9.23),('7643','2013-12-27','10:55:00',9.3),('7643','2013-12-27','11:00:00',9.4),('7643','2013-12-27','11:05:00',9.51),('7643','2013-12-27','11:10:00',9.6),('7643','2013-12-27','11:15:00',9.67),('7643','2013-12-27','11:20:00',9.76),('7643','2013-12-27','11:25:00',9.8),('7643','2013-12-27','11:30:00',9.88),('7643','2013-12-27','11:35:00',9.94),('7643','2013-12-27','11:40:00',9.92),('7643','2013-12-27','11:45:00',9.96),('7643','2013-12-27','11:50:00',9.97),('7643','2013-12-27','11:55:00',10),('7643','2013-12-27','12:00:00',9.93),('7643','2013-12-27','12:05:00',9.82),('7643','2013-12-27','12:10:00',9.95),('7643','2013-12-27','12:15:00',9.95),('7643','2013-12-27','12:20:00',9.85),('7643','2013-12-27','12:25:00',9.74),('7643','2013-12-27','12:30:00',9.65),('7643','2013-12-27','12:35:00',9.57),('7643','2013-12-27','12:40:00',9.62),('7643','2013-12-27','12:45:00',9.56),('7643','2013-12-27','12:50:00',9.45),('7643','2013-12-27','12:55:00',9.34),('7643','2013-12-27','13:00:00',9.25),('7643','2013-12-27','13:05:00',9.09),('7643','2013-12-27','13:10:00',8.86),('7643','2013-12-27','13:15:00',8.8),('7643','2013-12-27','13:20:00',8.69),('7643','2013-12-27','13:25:00',8.42),('7643','2013-12-27','13:30:00',8.04),('7643','2013-12-27','13:35:00',7.93),('7643','2013-12-27','13:40:00',7.84),('7643','2013-12-27','13:45:00',7.58),('7643','2013-12-27','13:50:00',7.54),('7643','2013-12-27','13:55:00',7.42),('7643','2013-12-27','14:00:00',7.12),('7643','2013-12-27','14:05:00',6.88),('7643','2013-12-27','14:10:00',6.7),('7643','2013-12-27','14:15:00',6.41),('7643','2013-12-27','14:20:00',6.14),('7643','2013-12-27','14:25:00',5.99),('7643','2013-12-27','14:30:00',5.9),('7643','2013-12-27','14:35:00',5.58),('7643','2013-12-27','14:40:00',5.33),('7643','2013-12-27','14:45:00',4.75),('7643','2013-12-27','14:50:00',4.15),('7643','2013-12-27','14:55:00',2.26),('7643','2013-12-27','15:00:00',3.34),('7643','2013-12-27','15:05:00',4.5),('7643','2013-12-27','15:10:00',4.15),('7643','2013-12-27','15:15:00',3.81),('7643','2013-12-27','15:20:00',3.5),('7643','2013-12-27','15:25:00',3.22),('7643','2013-12-27','15:30:00',2.77),('7643','2013-12-27','15:35:00',2.69),('7643','2013-12-27','15:40:00',2.44),('7643','2013-12-27','15:45:00',2.23),('7643','2013-12-27','15:50:00',2.04),('7643','2013-12-27','15:55:00',1.69),('7643','2013-12-27','16:00:00',1.26),('7643','2013-12-27','16:05:00',1.13),('7643','2014-04-22','08:15:00',1.08),('7643','2014-04-22','08:20:00',1.2),('7643','2014-04-22','09:10:00',1.02),('7643','2014-04-22','09:15:00',1.05),('7643','2014-04-22','09:20:00',1.16),('7643','2014-04-22','09:25:00',1.1),('7643','2014-04-22','09:45:00',1.33),('7643','2014-04-22','09:50:00',1.16),('7643','2014-04-22','10:05:00',1.17),('7643','2014-04-22','10:10:00',1.35),('7643','2014-04-22','10:15:00',1.31),('7643','2014-04-22','10:20:00',1.53),('7643','2014-04-22','10:25:00',1.73),('7643','2014-04-22','10:30:00',1.61),('7643','2014-04-22','10:35:00',1.58),('7643','2014-04-22','10:40:00',1.84),('7643','2014-04-22','10:45:00',1.86),('7643','2014-04-22','10:50:00',1.68),('7643','2014-04-22','10:55:00',1.5),('7643','2014-04-22','11:00:00',1.53),('7643','2014-04-22','11:05:00',1.49),('7643','2014-04-22','11:10:00',1.69),('7643','2014-04-22','11:15:00',1.99),('7643','2014-04-22','11:20:00',1.93),('7643','2014-04-22','11:25:00',1.81),('7643','2014-04-22','11:30:00',1.93),('7643','2014-04-22','11:35:00',2.19),('7643','2014-04-22','11:40:00',2.41),('7643','2014-04-22','11:45:00',2.53),('7643','2014-04-22','11:50:00',1.99),('7643','2014-04-22','11:55:00',1.55),('7643','2014-04-22','12:00:00',1.44),('7643','2014-04-22','12:05:00',1.48),('7643','2014-04-22','12:10:00',1.61),('7643','2014-04-22','12:15:00',1.83),('7643','2014-04-22','12:20:00',1.9),('7643','2014-04-22','12:25:00',1.98),('7643','2014-04-22','12:30:00',1.99),('7643','2014-04-22','12:35:00',2.04),('7643','2014-04-22','12:40:00',1.94),('7643','2014-04-22','12:45:00',2.02),('7643','2014-04-22','12:50:00',2.18),('7643','2014-04-22','12:55:00',2.39),('7643','2014-04-22','13:00:00',2.75),('7643','2014-04-22','13:05:00',3.37),('7643','2014-04-22','13:10:00',4.17),('7643','2014-04-22','13:15:00',4.57),('7643','2014-04-22','13:20:00',4.9),('7643','2014-04-22','13:25:00',5.08),('7643','2014-04-22','13:30:00',5.43),('7643','2014-04-22','13:35:00',5.65),('7643','2014-04-22','13:40:00',5.94),('7643','2014-04-22','13:45:00',5.97),('7643','2014-04-22','13:50:00',5.84),('7643','2014-04-22','13:55:00',5.71),('7643','2014-04-22','14:00:00',5.39),('7643','2014-04-22','14:05:00',5.5),('7643','2014-04-22','14:10:00',5.1),('7643','2014-04-22','14:15:00',4.16),('7643','2014-04-22','14:20:00',3.71),('7643','2014-04-22','14:25:00',3.41),('7643','2014-04-22','14:30:00',3.28),('7643','2014-04-22','14:35:00',3.31),('7643','2014-04-22','14:40:00',3.71),('7643','2014-04-22','14:45:00',4.54),('7643','2014-04-22','14:50:00',5.48),('7643','2014-04-22','14:55:00',6.25),('7643','2014-04-22','15:00:00',6.66),('7643','2014-04-22','15:05:00',6.71),('7643','2014-04-22','15:10:00',7),('7643','2014-04-22','15:15:00',6.64),('7643','2014-04-22','15:20:00',5.49),('7643','2014-04-22','15:25:00',5.22),('7643','2014-04-22','15:30:00',5.04),('7643','2014-04-22','15:35:00',4.79),('7643','2014-04-22','15:40:00',4.68),('7643','2014-04-22','15:45:00',4.45),('7643','2014-04-22','15:50:00',3.9),('7643','2014-04-22','15:55:00',3.74),('7643','2014-04-22','16:00:00',3.26),('7643','2014-04-22','16:05:00',3.12),('7643','2014-04-22','16:10:00',2.72),('7643','2014-04-22','16:15:00',2.4),('7643','2014-04-22','16:20:00',2.04),('7643','2014-04-22','16:25:00',1.61),('7643','2014-04-22','16:30:00',1.32),('7643','2014-04-22','16:35:00',1.29),('7643','2014-04-22','16:40:00',1.26),('7643','2014-04-22','16:45:00',1.23),('7643','2014-04-22','16:50:00',1.02),('7643','2013-12-26','08:05:00',1.16),('7643','2013-12-26','08:20:00',1.61),('7643','2013-12-26','08:25:00',1.08),('7643','2013-12-26','09:00:00',1.03),('7643','2013-12-26','09:05:00',1.1),('7643','2013-12-26','09:10:00',1.19),('7643','2013-12-26','09:15:00',1.26),('7643','2013-12-26','09:20:00',1.37),('7643','2013-12-26','09:25:00',1.45),('7643','2013-12-26','09:30:00',1.91),('7643','2013-12-26','09:35:00',1.76),('7643','2013-12-26','09:40:00',1.65),('7643','2013-12-26','09:45:00',1.7),('7643','2013-12-26','09:50:00',1.73),('7643','2013-12-26','09:55:00',1.7),('7643','2013-12-26','10:00:00',1.62),('7643','2013-12-26','10:05:00',1.55),('7643','2013-12-26','10:10:00',1.56),('7643','2013-12-26','10:15:00',1.74),('7643','2013-12-26','10:20:00',2.08),('7643','2013-12-26','10:25:00',2.47),('7643','2013-12-26','10:30:00',2.72),('7643','2013-12-26','10:35:00',2.76),('7643','2013-12-26','10:40:00',2.77),('7643','2013-12-26','10:45:00',2.7),('7643','2013-12-26','10:50:00',2.5),('7643','2013-12-26','10:55:00',2.21),('7643','2013-12-26','11:00:00',1.85),('7643','2013-12-26','11:05:00',1.8),('7643','2013-12-26','11:10:00',1.74),('7643','2013-12-26','11:15:00',1.47),('7643','2013-12-26','11:20:00',1.77),('7643','2013-12-26','11:25:00',2.27),('7643','2013-12-26','11:30:00',2.9),('7643','2013-12-26','11:35:00',3.51),('7643','2013-12-26','11:40:00',3.34),('7643','2013-12-26','11:45:00',3.08),('7643','2013-12-26','11:50:00',2.86),('7643','2013-12-26','11:55:00',2.5),('7643','2013-12-26','12:00:00',2.42),('7643','2013-12-26','12:05:00',3.41),('7643','2013-12-26','12:10:00',5.12),('7643','2013-12-26','12:15:00',8.74),('7643','2013-12-26','12:20:00',6.79),('7643','2013-12-26','12:25:00',6.26),('7643','2013-12-26','12:30:00',4.21),('7643','2013-12-26','12:35:00',4.5),('7643','2013-12-26','12:40:00',5.95),('7643','2013-12-26','12:45:00',7.61),('7643','2013-12-26','12:50:00',8.79),('7643','2013-12-26','12:55:00',9.2),('7643','2013-12-26','13:00:00',9.28),('7643','2013-12-26','13:05:00',8.14),('7643','2013-12-26','13:10:00',3.96),('7643','2013-12-26','13:15:00',4.9),('7643','2013-12-26','13:20:00',4.87),('7643','2013-12-26','13:25:00',4.82),('7643','2013-12-26','13:30:00',8.71),('7643','2013-12-26','13:35:00',9.56),('7643','2013-12-26','13:40:00',5.46),('7643','2013-12-26','13:45:00',4.92),('7643','2013-12-26','13:50:00',3.89),('7643','2013-12-26','13:55:00',3.27),('7643','2013-12-26','14:00:00',2.93),('7643','2013-12-26','14:05:00',3.02),('7643','2013-12-26','14:10:00',3.49),('7643','2013-12-26','14:15:00',3.82),('7643','2013-12-26','14:20:00',3.8),('7643','2013-12-26','14:25:00',3.76),('7643','2013-12-26','14:30:00',4.25),('7643','2013-12-26','14:35:00',4.56),('7643','2013-12-26','14:40:00',4.67),('7643','2013-12-26','14:45:00',3.79),('7643','2013-12-26','14:50:00',2.83),('7643','2013-12-26','14:55:00',1.85),('7643','2013-12-26','15:00:00',1.62),('7643','2013-12-26','15:05:00',1.34),('7643','2013-12-26','15:10:00',1.48),('7643','2013-12-26','15:15:00',1.32),('7643','2013-12-26','15:20:00',1.1),('7643','2013-12-26','15:25:00',1.42),('7643','2013-12-26','15:30:00',1.85),('7643','2013-12-26','15:35:00',1.92),('7643','2013-12-26','15:40:00',1.85),('7643','2013-12-26','15:45:00',1.55),('7643','2013-12-26','15:50:00',1.15),('7643','2013-12-25','09:50:00',1.4),('7643','2013-12-25','09:55:00',2.14),('7643','2013-12-25','10:00:00',1.57),('7643','2013-12-25','10:55:00',1.08),('7643','2013-12-25','11:00:00',1.22),('7643','2013-12-25','11:05:00',2.25),('7643','2013-12-25','11:10:00',1.68),('7643','2013-12-25','11:45:00',1.12),('7643','2013-12-25','11:50:00',1.11),('7643','2013-12-24','08:45:00',1.12),('7643','2013-12-24','08:50:00',1.19),('7643','2013-12-24','08:55:00',1.43),('7643','2013-12-24','09:00:00',1.62),('7643','2013-12-24','09:05:00',1.82),('7643','2013-12-24','09:10:00',2.1),('7643','2013-12-24','09:15:00',2.25),('7643','2013-12-24','09:20:00',2.23),('7643','2013-12-24','09:25:00',2.91),('7643','2013-12-24','09:30:00',3.24),('7643','2013-12-24','09:35:00',2.52),('7643','2013-12-24','09:40:00',2.24),('7643','2013-12-24','09:45:00',1.86),('7643','2013-12-24','09:50:00',1.44),('7643','2013-12-24','09:55:00',1.28),('7643','2013-12-24','10:00:00',1.15),('7643','2013-12-24','10:15:00',1),('7643','2013-12-24','10:20:00',1.43),('7643','2013-12-24','10:25:00',3.21),('7643','2013-12-24','10:30:00',5.63),('7643','2013-12-24','10:35:00',6.36),('7643','2013-12-24','10:40:00',5.55),('7643','2013-12-24','10:45:00',4.82),('7643','2013-12-24','10:50:00',5.82),('7643','2013-12-24','10:55:00',3.33),('7643','2013-12-24','11:00:00',3.09),('7643','2013-12-24','11:05:00',3.16),('7643','2013-12-24','11:10:00',3.46),('7643','2013-12-24','11:15:00',4.03),('7643','2013-12-24','11:20:00',6.38),('7643','2013-12-24','11:25:00',5.12),('7643','2013-12-24','11:30:00',8.88),('7643','2013-12-24','11:35:00',5.14),('7643','2013-12-24','11:40:00',6.41),('7643','2013-12-24','11:45:00',9.51),('7643','2013-12-24','11:50:00',5.52),('7643','2013-12-24','11:55:00',7.48),('7643','2013-12-24','12:00:00',9.47),('7643','2013-12-24','12:05:00',3.68),('7643','2013-12-24','12:10:00',3.64),('7643','2013-12-24','12:15:00',5.69),('7643','2013-12-24','12:20:00',7.38),('7643','2013-12-24','12:25:00',4.55),('7643','2013-12-24','12:30:00',9),('7643','2013-12-24','12:35:00',5.43),('7643','2013-12-24','12:40:00',4.58),('7643','2013-12-24','12:45:00',2.84),('7643','2013-12-24','12:50:00',4.76),('7643','2013-12-24','12:55:00',2.53),('7643','2013-12-24','13:00:00',1.78),('7643','2013-12-24','13:05:00',2.47),('7643','2013-12-24','13:10:00',2.94),('7643','2013-12-24','13:15:00',2.21),('7643','2013-12-24','13:20:00',1.7),('7643','2013-12-24','13:25:00',4.74),('7643','2013-12-24','13:30:00',4.76),('7643','2013-12-24','13:35:00',3.54),('7643','2013-12-24','13:40:00',4.13),('7643','2013-12-24','13:45:00',4.28),('7643','2013-12-24','13:50:00',4.94),('7643','2013-12-24','13:55:00',4.71),('7643','2013-12-24','14:00:00',3.87),('7643','2013-12-24','14:05:00',3.11),('7643','2013-12-24','14:10:00',2.82),('7643','2013-12-24','14:15:00',2.71),('7643','2013-12-24','14:20:00',2.47),('7643','2013-12-24','14:25:00',2.27),('7643','2013-12-24','14:30:00',2.23),('7643','2013-12-24','14:35:00',2.31),('7643','2013-12-24','14:40:00',2.27),('7643','2013-12-24','14:45:00',2.27),('7643','2013-12-24','14:50:00',2.28),('7643','2013-12-24','14:55:00',2.14),('7643','2013-12-24','15:00:00',1.86),('7643','2013-12-24','15:05:00',1.82),('7643','2013-12-24','15:10:00',2.11),('7643','2013-12-24','15:15:00',3.07),('7643','2013-12-24','15:20:00',3.05),('7643','2013-12-24','15:25:00',2.3),('7643','2013-12-24','15:30:00',1.48),('7643','2013-12-24','15:35:00',1.2),('7643','2013-12-24','15:40:00',1.13),('7643','2013-12-24','15:50:00',1.33),('7643','2013-12-24','16:05:00',1.01),('7643','2013-12-23','08:15:00',1.26),('7643','2013-12-23','08:20:00',1.8),('7643','2013-12-23','08:25:00',1.64),('7643','2013-12-23','08:40:00',1.36),('7643','2013-12-23','08:45:00',2),('7643','2013-12-23','08:50:00',2.56),('7643','2013-12-23','08:55:00',3.33),('7643','2013-12-23','09:00:00',3.86),('7643','2013-12-23','09:05:00',4.22),('7643','2013-12-23','09:10:00',4.48),('7643','2013-12-23','09:15:00',4.79),('7643','2013-12-23','09:20:00',5.02),('7643','2013-12-23','09:25:00',5.28),('7643','2013-12-23','09:30:00',5.52),('7643','2013-12-23','09:35:00',5.88),('7643','2013-12-23','09:40:00',6.19),('7643','2013-12-23','09:45:00',6.16),('7643','2013-12-23','09:50:00',6),('7643','2013-12-23','09:55:00',5.97),('7643','2013-12-23','10:00:00',6.72),('7643','2013-12-23','10:05:00',6.82),('7643','2013-12-23','10:10:00',7.05),('7643','2013-12-23','10:15:00',7.6),('7643','2013-12-23','10:20:00',7.74),('7643','2013-12-23','10:25:00',7.86),('7643','2013-12-23','10:30:00',7.89),('7643','2013-12-23','10:35:00',8.02),('7643','2013-12-23','10:40:00',8.19),('7643','2013-12-23','10:45:00',8.29),('7643','2013-12-23','10:50:00',8.39),('7643','2013-12-23','10:55:00',8.32),('7643','2013-12-23','11:00:00',8.56),('7643','2013-12-23','11:05:00',8.58),('7643','2013-12-23','11:10:00',8.63),('7643','2013-12-23','11:15:00',8.82),('7643','2013-12-23','11:20:00',8.93),('7643','2013-12-23','11:25:00',9.01),('7643','2013-12-23','11:30:00',9.09),('7643','2013-12-23','11:35:00',9.11),('7643','2013-12-23','11:40:00',9.08),('7643','2013-12-23','11:45:00',9.09),('7643','2013-12-23','11:50:00',9.06),('7643','2013-12-23','11:55:00',8.99),('7643','2013-12-23','12:00:00',8.88),('7643','2013-12-23','12:05:00',8.93),('7643','2013-12-23','12:10:00',8.94),('7643','2013-12-23','12:15:00',8.89),('7643','2013-12-23','12:20:00',8.86),('7643','2013-12-23','12:25:00',8.73),('7643','2013-12-23','12:30:00',8.63),('7643','2013-12-23','12:35:00',8.52),('7643','2013-12-23','12:40:00',8.37),('7643','2013-12-23','12:45:00',8.29),('7643','2013-12-23','12:50:00',8.27),('7643','2013-12-23','12:55:00',8.19),('7643','2013-12-23','13:00:00',8.06),('7643','2013-12-23','13:05:00',7.92),('7643','2013-12-23','13:10:00',7.79),('7643','2013-12-23','13:15:00',7.74),('7643','2013-12-23','13:20:00',7.62),('7643','2013-12-23','13:25:00',7.31),('7643','2013-12-23','13:30:00',7.04),('7643','2013-12-23','13:35:00',7),('7643','2013-12-23','13:40:00',6.6),('7643','2013-12-23','13:45:00',6.52),('7643','2013-12-23','13:50:00',6.43),('7643','2013-12-23','13:55:00',6.29),('7643','2013-12-23','14:00:00',6.07),('7643','2013-12-23','14:05:00',5.91),('7643','2013-12-23','14:10:00',5.72),('7643','2013-12-23','14:15:00',5.6),('7643','2013-12-23','14:20:00',5.44),('7643','2013-12-23','14:25:00',5.12),('7643','2013-12-23','14:30:00',4.77),('7643','2013-12-23','14:35:00',4.37),('7643','2013-12-23','14:40:00',4.08),('7643','2013-12-23','14:45:00',3.84),('7643','2013-12-23','14:50:00',3.61),('7643','2013-12-23','14:55:00',3.25),('7643','2013-12-23','15:00:00',2.8),('7643','2013-12-23','15:05:00',2.38),('7643','2013-12-23','15:10:00',1.86),('7643','2013-12-23','15:15:00',1.7),('7643','2013-12-23','15:20:00',1.84),('7643','2013-12-23','15:25:00',1.73),('7643','2013-12-23','15:30:00',1.68),('7643','2013-12-23','15:35:00',1.62),('7643','2013-12-23','15:40:00',1.51),('7643','2013-12-23','15:45:00',1.39),('7643','2013-12-23','15:50:00',1.28),('7643','2013-12-23','15:55:00',1.11),('7643','2013-12-22','08:25:00',1.01),('7643','2013-12-22','08:30:00',1.1),('7643','2013-12-22','08:35:00',1.21),('7643','2013-12-22','08:40:00',1.36),('7643','2013-12-22','08:45:00',1.53),('7643','2013-12-22','08:50:00',1.72),('7643','2013-12-22','08:55:00',1.86),('7643','2013-12-22','09:00:00',2.01),('7643','2013-12-22','09:05:00',2.13),('7643','2013-12-22','09:10:00',2.15),('7643','2013-12-22','09:15:00',2.26),('7643','2013-12-22','09:20:00',2.52),('7643','2013-12-22','09:25:00',3.03),('7643','2013-12-22','09:30:00',3.46),('7643','2013-12-22','09:35:00',3.8),('7643','2013-12-22','09:40:00',3.98),('7643','2013-12-22','09:45:00',4.05),('7643','2013-12-22','09:50:00',4.86),('7643','2013-12-22','09:55:00',6.23),('7643','2013-12-22','10:00:00',7.03),('7643','2013-12-22','10:05:00',7.58),('7643','2013-12-22','10:10:00',7.26),('7643','2013-12-22','10:15:00',7.32),('7643','2013-12-22','10:20:00',8.08),('7643','2013-12-22','10:25:00',7.89),('7643','2013-12-22','10:30:00',7.34),('7643','2013-12-22','10:35:00',7.55),('7643','2013-12-22','10:40:00',8.03),('7643','2013-12-22','10:45:00',8.21),('7643','2013-12-22','10:50:00',7.32),('7643','2013-12-22','10:55:00',8.74),('7643','2013-12-22','11:00:00',9.66),('7643','2013-12-22','11:05:00',9.67),('7643','2013-12-22','11:10:00',9.86),('7643','2013-12-22','11:15:00',9.65),('7643','2013-12-22','11:20:00',9.38),('7643','2013-12-22','11:25:00',9.56),('7643','2013-12-22','11:30:00',9.48),('7643','2013-12-22','11:35:00',9.47),('7643','2013-12-22','11:40:00',9.63),('7643','2013-12-22','11:45:00',8.61),('7643','2013-12-22','11:50:00',8.78),('7643','2013-12-22','11:55:00',9.01),('7643','2013-12-22','12:00:00',9.56),('7643','2013-12-22','12:05:00',9.48),('7643','2013-12-22','12:10:00',9.33),('7643','2013-12-22','12:15:00',9.28),('7643','2013-12-22','12:20:00',9.11),('7643','2013-12-22','12:25:00',9.25),('7643','2013-12-22','12:30:00',9.39),('7643','2013-12-22','12:35:00',9.42),('7643','2013-12-22','12:40:00',9.47),('7643','2013-12-22','12:45:00',9.34),('7643','2013-12-22','12:50:00',9.28),('7643','2013-12-22','12:55:00',9.23),('7643','2013-12-22','13:00:00',9.19),('7643','2013-12-22','13:05:00',9.02),('7643','2013-12-22','13:10:00',8.86),('7643','2013-12-22','13:15:00',7.56),('7643','2013-12-22','13:20:00',7.01),('7643','2013-12-22','13:25:00',7.22),('7643','2013-12-22','13:30:00',8),('7643','2013-12-22','13:35:00',3.18),('7643','2013-12-22','13:40:00',6.2),('7643','2013-12-22','13:45:00',5.73),('7643','2013-12-22','13:50:00',6.51),('7643','2013-12-22','13:55:00',6.62),('7643','2013-12-22','14:00:00',7.41),('7643','2013-12-22','14:05:00',7.06),('7643','2013-12-22','14:10:00',6.87),('7643','2013-12-22','14:15:00',6.31),('7643','2013-12-22','14:20:00',6.21),('7643','2013-12-22','14:25:00',6.04),('7643','2013-12-22','14:30:00',5.36),('7643','2013-12-22','14:35:00',5.34),('7643','2013-12-22','14:40:00',5.05),('7643','2013-12-22','14:45:00',4.85),('7643','2013-12-22','14:50:00',4.63),('7643','2013-12-22','14:55:00',4.41),('7643','2013-12-22','15:00:00',4.21),('7643','2013-12-22','15:05:00',4.03),('7643','2013-12-22','15:10:00',3.72),('7643','2013-12-22','15:15:00',3.36),('7643','2013-12-22','15:20:00',3.01),('7643','2013-12-22','15:25:00',2.77),('7643','2013-12-22','15:30:00',2.45),('7643','2013-12-22','15:35:00',2.22),('7643','2013-12-22','15:40:00',1.99),('7643','2013-12-22','15:45:00',1.75),('7643','2013-12-22','15:50:00',1.49),('7643','2013-12-22','15:55:00',1.27),('7643','2013-12-22','16:00:00',1.05),('7643','2013-12-21','08:00:00',1.09),('7643','2013-12-21','08:05:00',1.32),('7643','2013-12-21','08:10:00',1.48),('7643','2013-12-21','08:15:00',1.57),('7643','2013-12-21','08:20:00',1.6),('7643','2013-12-21','08:25:00',1.71),('7643','2013-12-21','08:30:00',1.9),('7643','2013-12-21','08:35:00',2.07),('7643','2013-12-21','08:40:00',2.43),('7643','2013-12-21','08:47:00',2.51),('7643','2013-12-21','08:50:00',2.57),('7643','2013-12-21','08:55:00',2.62),('7643','2013-12-21','09:00:00',3.33),('7643','2013-12-21','09:05:00',4.24),('7643','2013-12-21','09:10:00',4.09),('7643','2013-12-21','09:15:00',4.23),('7643','2013-12-21','09:20:00',4.88),('7643','2013-12-21','09:25:00',4.74),('7643','2013-12-21','09:30:00',4.91),('7643','2013-12-21','09:35:00',6.78),('7643','2013-12-21','09:40:00',7.98),('7643','2013-12-21','09:45:00',8.3),('7643','2013-12-21','09:50:00',8.9),('7643','2013-12-21','09:55:00',8.9),('7643','2013-12-21','10:00:00',8.91),('7643','2013-12-21','10:05:00',9),('7643','2013-12-21','10:10:00',9.12),('7643','2013-12-21','10:15:00',8.94),('7643','2013-12-21','10:20:00',8.68),('7643','2013-12-21','10:25:00',8.73),('7643','2013-12-21','10:30:00',9.1),('7643','2013-12-21','10:35:00',8.46),('7643','2013-12-21','10:40:00',7.92),('7643','2013-12-21','10:45:00',8.45),('7643','2013-12-21','10:50:00',8.2),('7643','2013-12-21','10:55:00',7.85),('7643','2013-12-21','11:00:00',6.87),('7643','2013-12-21','11:05:00',7.73),('7643','2013-12-21','11:10:00',9.69),('7643','2013-12-21','11:15:00',9.41),('7643','2013-12-21','11:20:00',8.47),('7643','2013-12-21','11:25:00',8.74),('7643','2013-12-21','11:30:00',8.17),('7643','2013-12-21','11:35:00',8.08),('7643','2013-12-21','11:40:00',8.69),('7643','2013-12-21','11:45:00',8.09),('7643','2013-12-21','11:50:00',5.9),('7643','2013-12-21','11:55:00',4.39),('7643','2013-12-21','12:00:00',3.5),('7643','2013-12-21','12:05:00',3.19),('7643','2013-12-21','12:10:00',3.31),('7643','2013-12-21','12:15:00',3.64),('7643','2013-12-21','12:20:00',4.55),('7643','2013-12-21','12:25:00',4.78),('7643','2013-12-21','12:30:00',5.92),('7643','2013-12-21','12:35:00',6.78),('7643','2013-12-21','12:40:00',6.28),('7643','2013-12-21','12:45:00',6.27),('7643','2013-12-21','12:50:00',7.61),('7643','2013-12-21','12:55:00',9.49),('7643','2013-12-21','13:00:00',9.35),('7643','2013-12-21','13:05:00',10.68),('7643','2013-12-21','13:10:00',10.54),('7643','2013-12-21','13:15:00',7.83),('7643','2013-12-21','13:20:00',7.66),('7643','2013-12-21','13:25:00',7.56),('7643','2013-12-21','13:30:00',7.34),('7643','2013-12-21','13:35:00',6.68),('7643','2013-12-21','13:40:00',5.18),('7643','2013-12-21','13:45:00',6.39),('7643','2013-12-21','13:50:00',5.65),('7643','2013-12-21','13:55:00',5.33),('7643','2013-12-21','14:00:00',4.43),('7643','2013-12-21','14:05:00',5.33),('7643','2013-12-21','14:10:00',5.79),('7643','2013-12-21','14:15:00',4.31),('7643','2013-12-21','14:20:00',4.46),('7643','2013-12-21','14:25:00',3.9),('7643','2013-12-21','14:30:00',3.83),('7643','2013-12-21','14:35:00',4.46),('7643','2013-12-21','14:40:00',4.77),('7643','2013-12-21','14:45:00',4.56),('7643','2013-12-21','14:50:00',2.81),('7643','2013-12-21','14:55:00',2.74),('7643','2013-12-21','15:00:00',3),('7643','2013-12-21','15:05:00',2.7),('7643','2013-12-21','15:10:00',3.15),('7643','2013-12-21','15:15:00',2.02),('7643','2013-12-21','15:20:00',1.97),('7643','2013-12-21','15:25:00',1.69),('7643','2013-12-21','15:30:00',1.5),('7643','2013-12-21','15:35:00',1.28),('7643','2013-12-21','15:40:00',1.24),('7643','2013-12-21','15:45:00',1.44),('7643','2013-12-21','15:50:00',1.14),('7643','2013-12-21','15:55:00',1.04),('7643','2013-12-20','08:05:00',1.07),('7643','2013-12-20','08:10:00',1.37),('7643','2013-12-20','08:15:00',1.67),('7643','2013-12-20','08:20:00',1.96),('7643','2013-12-20','08:25:00',2.29),('7643','2013-12-20','08:30:00',2.59),('7643','2013-12-20','08:35:00',2.91),('7643','2013-12-20','08:40:00',3.19),('7643','2013-12-20','08:45:00',3.37),('7643','2013-12-20','08:50:00',3.73),('7643','2013-12-20','08:55:00',4.03),('7643','2013-12-20','09:00:00',4.35),('7643','2013-12-20','09:05:00',4.61),('7643','2013-12-20','09:10:00',4.8),('7643','2013-12-20','09:15:00',5.05),('7643','2013-12-20','09:20:00',5.37),('7643','2013-12-20','09:25:00',5.57),('7643','2013-12-20','09:30:00',5.83),('7643','2013-12-20','09:35:00',6.13),('7643','2013-12-20','09:40:00',6.43),('7643','2013-12-20','09:45:00',6.66),('7643','2013-12-20','09:50:00',6.91),('7643','2013-12-20','09:55:00',7.11),('7643','2013-12-20','10:00:00',7.33),('7643','2013-12-20','10:05:00',7.51),('7643','2013-12-20','10:10:00',7.71),('7643','2013-12-20','10:15:00',7.91),('7643','2013-12-20','10:20:00',8.06),('7643','2013-12-20','10:25:00',8.21),('7643','2013-12-20','10:30:00',8.4),('7643','2013-12-20','10:35:00',8.55),('7643','2013-12-20','10:40:00',8.67),('7643','2013-12-20','10:45:00',8.81),('7643','2013-12-20','10:50:00',8.92),('7643','2013-12-20','10:55:00',9.01),('7643','2013-12-20','11:00:00',9.2),('7643','2013-12-20','11:05:00',9.31),('7643','2013-12-20','11:10:00',9.35),('7643','2013-12-20','11:15:00',9.48),('7643','2013-12-20','11:20:00',9.55),('7643','2013-12-20','11:25:00',9.69),('7643','2013-12-20','11:30:00',9.77),('7643','2013-12-20','11:35:00',9.8),('7643','2013-12-20','11:40:00',9.85),('7643','2013-12-20','11:45:00',9.87),('7643','2013-12-20','11:50:00',9.9),('7643','2013-12-20','11:55:00',9.93),('7643','2013-12-20','12:00:00',9.97),('7643','2013-12-20','12:05:00',9.97),('7643','2013-12-20','12:10:00',9.92),('7643','2013-12-20','12:15:00',9.91),('7643','2013-12-20','12:20:00',9.87),('7643','2013-12-20','12:25:00',9.79),('7643','2013-12-20','12:30:00',9.75),('7643','2013-12-20','12:35:00',9.72),('7643','2013-12-20','12:40:00',9.64),('7643','2013-12-20','12:45:00',9.55),('7643','2013-12-20','12:50:00',9.53),('7643','2013-12-20','12:55:00',9.47),('7643','2013-12-20','13:00:00',9.28),('7643','2013-12-20','13:05:00',9.16),('7643','2013-12-20','13:10:00',9.02),('7643','2013-12-20','13:15:00',8.88),('7643','2013-12-20','13:20:00',8.68),('7643','2013-12-20','13:25:00',8.59),('7643','2013-12-20','13:30:00',8.39),('7643','2013-12-20','13:35:00',8.22),('7643','2013-12-20','13:40:00',8.06),('7643','2013-12-20','13:45:00',7.91),('7643','2013-12-20','13:50:00',7.73),('7643','2013-12-20','13:55:00',7.58),('7643','2013-12-20','14:00:00',7.38),('7643','2013-12-20','14:05:00',7.11),('7643','2013-12-20','14:10:00',6.89),('7643','2013-12-20','14:15:00',6.71),('7643','2013-12-20','14:20:00',6.62),('7643','2013-12-20','14:25:00',6.34),('7643','2013-12-20','14:30:00',6.12),('7643','2013-12-20','14:35:00',5.86),('7643','2013-12-20','14:40:00',5.6),('7643','2013-12-20','14:45:00',5.31),('7643','2013-12-20','14:50:00',5),('7643','2013-12-20','14:55:00',4.72),('7643','2013-12-20','15:00:00',4.45),('7643','2013-12-20','15:05:00',4.22),('7643','2013-12-20','15:10:00',3.92),('7643','2013-12-20','15:15:00',3.63),('7643','2013-12-20','15:20:00',3.37),('7643','2013-12-20','15:25:00',3.07),('7643','2013-12-20','15:30:00',2.75),('7643','2013-12-20','15:35:00',2.45),('7643','2013-12-20','15:40:00',2.18),('7643','2013-12-20','15:45:00',1.91),('7643','2013-12-20','15:50:00',1.67),('7643','2013-12-20','15:55:00',1.39),('7643','2013-12-20','16:00:00',1.13),('7643','2013-12-19','08:10:00',1.12),('7643','2013-12-19','08:15:00',1.94),('7643','2013-12-19','08:20:00',2.44),('7643','2013-12-19','08:25:00',2.66),('7643','2013-12-19','08:30:00',2.83),('7643','2013-12-19','08:35:00',2.91),('7643','2013-12-19','08:40:00',3.25),('7643','2013-12-19','08:45:00',3.43),('7643','2013-12-19','08:50:00',3.62),('7643','2013-12-19','08:55:00',3.81),('7643','2013-12-19','09:00:00',4.02),('7643','2013-12-19','09:05:00',4.36),('7643','2013-12-19','09:10:00',4.67),('7643','2013-12-19','09:15:00',4.94),('7643','2013-12-19','09:20:00',5.22),('7643','2013-12-19','09:25:00',5.53),('7643','2013-12-19','09:30:00',5.78),('7643','2013-12-19','09:35:00',6.02),('7643','2013-12-19','09:40:00',6.25),('7643','2013-12-19','09:45:00',6.45),('7643','2013-12-19','09:50:00',6.7),('7643','2013-12-19','09:55:00',6.85),('7643','2013-12-19','10:00:00',6.99),('7643','2013-12-19','10:05:00',7.3),('7643','2013-12-19','10:10:00',7.45),('7643','2013-12-19','10:15:00',7.56),('7643','2013-12-19','10:20:00',7.7),('7643','2013-12-19','10:25:00',7.87),('7643','2013-12-19','10:30:00',7.97),('7643','2013-12-19','10:35:00',8.07),('7643','2013-12-19','10:40:00',8.25),('7643','2013-12-19','10:45:00',8.41),('7643','2013-12-19','10:50:00',8.55),('7643','2013-12-19','10:55:00',8.66),('7643','2013-12-19','11:00:00',8.73),('7643','2013-12-19','11:05:00',8.88),('7643','2013-12-19','11:10:00',8.94),('7643','2013-12-19','11:15:00',8.99),('7643','2013-12-19','11:20:00',9.14),('7643','2013-12-19','11:25:00',9.18),('7643','2013-12-19','11:30:00',9.25),('7643','2013-12-19','11:35:00',9.3),('7643','2013-12-19','11:40:00',9.3),('7643','2013-12-19','11:45:00',9.37),('7643','2013-12-19','11:50:00',9.31),('7643','2013-12-19','11:55:00',9.34),('7643','2013-12-19','12:00:00',9.44),('7643','2013-12-19','12:05:00',9.3),('7643','2013-12-19','12:10:00',9.37),('7643','2013-12-19','12:15:00',9.28),('7643','2013-12-19','12:20:00',9.29),('7643','2013-12-19','12:25:00',9.18),('7643','2013-12-19','12:30:00',9.26),('7643','2013-12-19','12:35:00',9.13),('7643','2013-12-19','12:40:00',8.94),('7643','2013-12-19','12:45:00',8.9),('7643','2013-12-19','12:50:00',8.74),('7643','2013-12-19','12:55:00',8.58),('7643','2013-12-19','13:00:00',8.57),('7643','2013-12-19','13:05:00',8.55),('7643','2013-12-19','13:10:00',8.43),('7643','2013-12-19','13:15:00',8.2),('7643','2013-12-19','13:20:00',7.76),('7643','2013-12-19','13:25:00',7.58),('7643','2013-12-19','13:30:00',7.49),('7643','2013-12-19','13:35:00',7.59),('7643','2013-12-19','13:40:00',7.1),('7643','2013-12-19','13:45:00',7.01),('7643','2013-12-19','13:50:00',6.9),('7643','2013-12-19','13:55:00',6.49),('7643','2013-12-19','14:00:00',6.23),('7643','2013-12-19','14:05:00',2.45),('7643','2013-12-19','14:10:00',2.12),('7643','2013-12-19','14:15:00',1.81),('7643','2013-12-19','14:20:00',1.69),('7643','2013-12-19','14:25:00',1.7),('7643','2013-12-19','14:30:00',2.11),('7643','2013-12-19','14:35:00',1.62),('7643','2013-12-19','14:40:00',3.07),('7643','2013-12-19','14:45:00',2.75),('7643','2013-12-19','14:50:00',1.77),('7643','2013-12-19','14:55:00',1.43),('7643','2013-12-19','15:00:00',1.32),('7643','2013-12-19','15:05:00',1.21),('7643','2013-12-18','08:25:00',1.38),('7643','2013-12-18','08:30:00',1.35),('7643','2013-12-18','08:35:00',1.35),('7643','2013-12-18','08:40:00',1.53),('7643','2013-12-18','08:45:00',2.49),('7643','2013-12-18','08:50:00',3.62),('7643','2013-12-18','08:55:00',4.07),('7643','2013-12-18','09:00:00',4.68),('7643','2013-12-18','09:05:00',5.22),('7643','2013-12-18','09:10:00',5.03),('7643','2013-12-18','09:15:00',4.09),('7643','2013-12-18','09:20:00',6.34),('7643','2013-12-18','09:25:00',6.31),('7643','2013-12-18','09:30:00',6.11),('7643','2013-12-18','09:35:00',6.88),('7643','2013-12-18','09:40:00',4.61),('7643','2013-12-18','09:45:00',3.54),('7643','2013-12-18','09:50:00',6.84),('7643','2013-12-18','09:55:00',8.38),('7643','2013-12-18','10:00:00',7.76),('7643','2013-12-18','10:05:00',7.35),('7643','2013-12-18','10:10:00',7.87),('7643','2013-12-18','10:15:00',7.92),('7643','2013-12-18','10:20:00',4.85),('7643','2013-12-18','10:25:00',3.09),('7643','2013-12-18','10:30:00',4.19),('7643','2013-12-18','10:35:00',3.5),('7643','2013-12-18','10:40:00',5.03),('7643','2013-12-18','10:45:00',5.9),('7643','2013-12-18','10:50:00',9.53),('7643','2013-12-18','10:55:00',5.36),('7643','2013-12-18','11:00:00',2.48),('7643','2013-12-18','11:05:00',2.32),('7643','2013-12-18','11:10:00',3.4),('7643','2013-12-18','11:15:00',6.95),('7643','2013-12-18','11:20:00',4.74),('7643','2013-12-18','11:25:00',3.29),('7643','2013-12-18','11:30:00',2.49),('7643','2013-12-18','11:35:00',2.15),('7643','2013-12-18','11:40:00',1.88),('7643','2013-12-18','11:45:00',1.5),('7643','2013-12-18','11:50:00',1.13),('7643','2013-12-18','11:55:00',1.23),('7643','2013-12-18','12:00:00',1.03),('7643','2013-12-18','12:10:00',1.12),('7643','2013-12-18','12:15:00',1.25),('7643','2013-12-18','12:20:00',1.5),('7643','2013-12-18','12:25:00',1.96),('7643','2013-12-18','12:30:00',2),('7643','2013-12-18','12:35:00',2.34),('7643','2013-12-18','12:40:00',2.7),('7643','2013-12-18','12:45:00',2.7),('7643','2013-12-18','12:50:00',2.44),('7643','2013-12-18','12:55:00',2.2),('7643','2013-12-18','13:00:00',2.19),('7643','2013-12-18','13:05:00',2),('7643','2013-12-18','13:10:00',1.8),('7643','2013-12-18','13:15:00',1.76),('7643','2013-12-18','13:20:00',1.87),('7643','2013-12-18','13:25:00',1.79),('7643','2013-12-18','13:30:00',1.78),('7643','2013-12-18','13:35:00',1.74),('7643','2013-12-18','13:40:00',1.82),('7643','2013-12-18','13:45:00',1.94),('7643','2013-12-18','13:50:00',2.06),('7643','2013-12-18','13:55:00',2.27),('7643','2013-12-18','14:00:00',2.68),('7643','2013-12-18','14:05:00',2.82),('7643','2013-12-18','14:10:00',2.73),('7643','2013-12-18','14:15:00',2.69),('7643','2013-12-18','14:20:00',4.42),('7643','2013-12-18','14:25:00',4.74),('7643','2013-12-18','14:30:00',6.68),('7643','2013-12-18','14:35:00',5.22),('7643','2013-12-18','14:40:00',5.22),('7643','2013-12-18','14:45:00',4.55),('7643','2013-12-18','14:50:00',2.56),('7643','2013-12-18','14:55:00',1.82),('7643','2013-12-18','15:00:00',1.27),('7643','2013-12-18','15:05:00',1.46),('7643','2013-12-18','15:10:00',1.51),('7643','2013-12-18','15:15:00',1.38),('7643','2013-12-18','15:20:00',1.37),('7643','2013-12-18','15:25:00',1.61),('7643','2013-12-18','15:30:00',1.53),('7643','2013-12-18','15:35:00',1.31),('7643','2013-12-18','15:40:00',1.26),('7643','2013-12-18','15:45:00',1.01),('7643','2013-12-17','08:00:00',1.12),('7643','2013-12-17','08:05:00',1.38),('7643','2013-12-17','08:10:00',1.65),('7643','2013-12-17','08:15:00',1.96),('7643','2013-12-17','08:20:00',2.21),('7643','2013-12-17','08:25:00',2.57),('7643','2013-12-17','08:30:00',2.79),('7643','2013-12-17','08:35:00',3.03),('7643','2013-12-17','08:40:00',3.3),('7643','2013-12-17','08:45:00',3.62),('7643','2013-12-17','08:50:00',3.91),('7643','2013-12-17','08:55:00',4.21),('7643','2013-12-17','09:00:00',4.5),('7643','2013-12-17','09:05:00',4.78),('7643','2013-12-17','09:10:00',5.08),('7643','2013-12-17','09:15:00',5.32),('7643','2013-12-17','09:20:00',5.59),('7643','2013-12-17','09:25:00',5.87),('7643','2013-12-17','09:30:00',6.11),('7643','2013-12-17','09:35:00',6.34),('7643','2013-12-17','09:40:00',6.58),('7643','2013-12-17','09:45:00',6.83),('7643','2013-12-17','09:50:00',7.05),('7643','2013-12-17','09:55:00',7.28),('7643','2013-12-17','10:00:00',7.54),('7643','2013-12-17','10:05:00',7.7),('7643','2013-12-17','10:10:00',7.91),('7643','2013-12-17','10:15:00',8.13),('7643','2013-12-17','10:20:00',8.27),('7643','2013-12-17','10:25:00',8.42),('7643','2013-12-17','10:30:00',8.61),('7643','2013-12-17','10:35:00',8.77),('7643','2013-12-17','10:40:00',8.87),('7643','2013-12-17','10:45:00',8.95),('7643','2013-12-17','10:50:00',9.07),('7643','2013-12-17','10:55:00',9.12),('7643','2013-12-17','11:00:00',9.19),('7643','2013-12-17','11:05:00',9.32),('7643','2013-12-17','11:10:00',9.43),('7643','2013-12-17','11:15:00',9.48),('7643','2013-12-17','11:20:00',9.47),('7643','2013-12-17','11:25:00',9.51),('7643','2013-12-17','11:30:00',9.49),('7643','2013-12-17','11:35:00',9.6),('7643','2013-12-17','11:40:00',9.62),('7643','2013-12-17','11:45:00',9.61),('7643','2013-12-17','11:50:00',9.61),('7643','2013-12-17','11:55:00',9.6),('7643','2013-12-17','12:00:00',9.59),('7643','2013-12-17','12:05:00',9.58),('7643','2013-12-17','12:10:00',9.63),('7643','2013-12-17','12:15:00',9.62),('7643','2013-12-17','12:20:00',9.56),('7643','2013-12-17','12:25:00',9.53),('7643','2013-12-17','12:30:00',9.48),('7643','2013-12-17','12:35:00',9.44),('7643','2013-12-17','12:40:00',9.42),('7643','2013-12-17','12:45:00',9.26),('7643','2013-12-17','12:50:00',9.24),('7643','2013-12-17','12:55:00',9.15),('7643','2013-12-17','13:00:00',9.15),('7643','2013-12-17','13:05:00',8.92),('7643','2013-12-17','13:10:00',8.55),('7643','2013-12-17','13:15:00',8.43),('7643','2013-12-17','13:20:00',8.31),('7643','2013-12-17','13:25:00',8.22),('7643','2013-12-17','13:30:00',8.17),('7643','2013-12-17','13:35:00',7.91),('7643','2013-12-17','13:40:00',7.74),('7643','2013-12-17','13:45:00',7.51),('7643','2013-12-17','13:50:00',7.22),('7643','2013-12-17','13:55:00',6.92),('7643','2013-12-17','14:00:00',6.87),('7643','2013-12-17','14:05:00',6.65),('7643','2013-12-17','14:10:00',6.35),('7643','2013-12-17','14:15:00',6.16),('7643','2013-12-17','14:20:00',6.16),('7643','2013-12-17','14:25:00',5.96),('7643','2013-12-17','14:30:00',5.82),('7643','2013-12-17','14:35:00',5.62),('7643','2013-12-17','14:40:00',5.38),('7643','2013-12-17','14:45:00',5.1),('7643','2013-12-17','14:50:00',4.82),('7643','2013-12-17','14:55:00',4.61),('7643','2013-12-17','15:00:00',4.37),('7643','2013-12-17','15:05:00',4.1),('7643','2013-12-17','15:10:00',3.81),('7643','2013-12-17','15:15:00',3.53),('7643','2013-12-17','15:20:00',3.3),('7643','2013-12-17','15:25:00',2.93),('7643','2013-12-17','15:30:00',2.69),('7643','2013-12-17','15:35:00',2.41),('7643','2013-12-17','15:40:00',2.09),('7643','2013-12-17','15:45:00',1.8),('7643','2013-12-17','15:50:00',1.38),('7643','2013-12-17','15:55:00',1.13),('7643','2014-04-21','07:05:00',1.04),('7643','2014-04-21','07:10:00',1.28),('7643','2014-04-21','07:15:00',1.53),('7643','2014-04-21','07:20:00',1.78),('7643','2014-04-21','07:25:00',2.02),('7643','2014-04-21','07:30:00',2.3),('7643','2014-04-21','07:35:00',2.59),('7643','2014-04-21','07:40:00',2.91),('7643','2014-04-21','07:45:00',3.22),('7643','2014-04-21','07:50:00',3.59),('7643','2014-04-21','07:55:00',3.95),('7643','2014-04-21','08:00:00',4.28),('7643','2014-04-21','08:05:00',4.65),('7643','2014-04-21','08:10:00',5.07),('7643','2014-04-21','08:15:00',5.45),('7643','2014-04-21','08:20:00',5.83),('7643','2014-04-21','08:25:00',6.2),('7643','2014-04-21','08:30:00',6.58),('7643','2014-04-21','08:35:00',6.97),('7643','2014-04-21','08:40:00',7.39),('7643','2014-04-21','08:45:00',7.62),('7643','2014-04-21','08:50:00',7.86),('7643','2014-04-21','08:55:00',8.12),('7643','2014-04-21','09:00:00',8.49),('7643','2014-04-21','09:05:00',9.29),('7643','2014-04-21','09:10:00',9.1),('7643','2014-04-21','09:15:00',8.65),('7643','2014-04-21','09:20:00',9.58),('7643','2014-04-21','09:25:00',10.43),('7643','2014-04-21','09:30:00',10.39),('7643','2014-04-21','09:35:00',10.89),('7643','2014-04-21','09:40:00',10.64),('7643','2014-04-21','09:45:00',11.5),('7643','2014-04-21','09:50:00',9.67),('7643','2014-04-21','09:55:00',5.65),('7643','2014-04-21','10:00:00',5.19),('7643','2014-04-21','10:05:00',5.47),('7643','2014-04-21','10:10:00',7.14),('7643','2014-04-21','10:15:00',8.51),('7643','2014-04-21','10:20:00',12.2),('7643','2014-04-21','10:25:00',8.36),('7643','2014-04-21','10:30:00',13.89),('7643','2014-04-21','10:35:00',14.79),('7643','2014-04-21','10:40:00',13.49),('7643','2014-04-21','10:45:00',13.8),('7643','2014-04-21','10:50:00',14.96),('7643','2014-04-21','10:55:00',11.8),('7643','2014-04-21','11:00:00',7.73),('7643','2014-04-21','11:05:00',9.4),('7643','2014-04-21','11:10:00',6.4),('7643','2014-04-21','11:15:00',5.26),('7643','2014-04-21','11:20:00',4.54),('7643','2014-04-21','11:25:00',4.74),('7643','2014-04-21','11:30:00',4.23),('7643','2014-04-21','11:35:00',4.47),('7643','2014-04-21','11:40:00',4.08),('7643','2014-04-21','11:45:00',3.44),('7643','2014-04-21','11:50:00',3.39),('7643','2014-04-21','11:55:00',3.16),('7643','2014-04-21','12:00:00',3.54),('7643','2014-04-21','12:05:00',4.35),('7643','2014-04-21','12:10:00',4.54),('7643','2014-04-21','12:15:00',4.66),('7643','2014-04-21','12:20:00',4.91),('7643','2014-04-21','12:25:00',5.29),('7643','2014-04-21','12:30:00',6.18),('7643','2014-04-21','12:35:00',5.46),('7643','2014-04-21','12:40:00',4.01),('7643','2014-04-21','12:45:00',3.28),('7643','2014-04-21','12:50:00',2.82),('7643','2014-04-21','12:55:00',2.65),('7643','2014-04-21','13:00:00',2.61),('7643','2014-04-21','13:05:00',2.82),('7643','2014-04-21','13:10:00',3.33),('7643','2014-04-21','13:15:00',5.32),('7643','2014-04-21','13:20:00',9.03),('7643','2014-04-21','13:25:00',10.23),('7643','2014-04-21','13:30:00',11.52),('7643','2014-04-21','13:35:00',10.26),('7643','2014-04-21','13:40:00',13.02),('7643','2014-04-21','13:45:00',13.33),('7643','2014-04-21','13:50:00',10.93),('7643','2014-04-21','13:55:00',6),('7643','2014-04-21','14:00:00',5.17),('7643','2014-04-21','14:05:00',6.1),('7643','2014-04-21','14:10:00',13.28),('7643','2014-04-21','14:15:00',13.22),('7643','2014-04-21','14:20:00',15.71),('7643','2014-04-21','14:25:00',9.93),('7643','2014-04-21','14:30:00',7.93),('7643','2014-04-21','14:35:00',9.36),('7643','2014-04-21','14:40:00',12.44),('7643','2014-04-21','14:45:00',15.97),('7643','2014-04-21','14:50:00',12.24),('7643','2014-04-21','14:55:00',10.94),('7643','2014-04-21','15:00:00',5),('7643','2014-04-21','15:05:00',4.89),('7643','2014-04-21','15:10:00',4.42),('7643','2014-04-21','15:15:00',4.31),('7643','2014-04-21','15:20:00',4.77),('7643','2014-04-21','15:25:00',5.53),('7643','2014-04-21','15:30:00',6.82),('7643','2014-04-21','15:35:00',10.13),('7643','2014-04-21','15:40:00',8.84),('7643','2014-04-21','15:45:00',6.97),('7643','2014-04-21','15:50:00',8.38),('7643','2014-04-21','15:55:00',6.83),('7643','2014-04-21','16:00:00',8.09),('7643','2014-04-21','16:05:00',5.68),('7643','2014-04-21','16:10:00',5.35),('7643','2014-04-21','16:15:00',5.14),('7643','2014-04-21','16:20:00',6.26),('7643','2014-04-21','16:25:00',5.73),('7643','2014-04-21','16:30:00',4.8),('7643','2014-04-21','16:35:00',4.8),('7643','2014-04-21','16:40:00',6.53),('7643','2014-04-21','16:45:00',6.64),('7643','2014-04-21','16:50:00',4.98),('7643','2014-04-21','16:55:00',4.29),('7643','2014-04-21','17:00:00',4.69),('7643','2014-04-21','17:05:00',5.25),('7643','2014-04-21','17:10:00',4.24),('7643','2014-04-21','17:15:00',3.78),('7643','2014-04-21','17:20:00',2.84),('7643','2014-04-21','17:25:00',2.41),('7643','2014-04-21','17:30:00',2.28),('7643','2014-04-21','17:35:00',2.6),('7643','2014-04-21','17:40:00',2.55),('7643','2014-04-21','17:45:00',2.28),('7643','2014-04-21','17:50:00',2.17),('7643','2014-04-21','17:55:00',1.82),('7643','2014-04-21','18:00:00',1.42),('7643','2014-04-21','18:05:00',1.07),('7643','2013-12-16','08:00:00',1.33),('7643','2013-12-16','08:05:00',1.61),('7643','2013-12-16','08:10:00',1.92),('7643','2013-12-16','08:15:00',2.24),('7643','2013-12-16','08:20:00',2.53),('7643','2013-12-16','08:25:00',2.81),('7643','2013-12-16','08:30:00',3.11),('7643','2013-12-16','08:35:00',3.43),('7643','2013-12-16','08:40:00',3.75),('7643','2013-12-16','08:45:00',4.09),('7643','2013-12-16','08:50:00',4.37),('7643','2013-12-16','08:55:00',4.68),('7643','2013-12-16','09:00:00',4.98),('7643','2013-12-16','09:05:00',5.23),('7643','2013-12-16','09:10:00',5.56),('7643','2013-12-16','09:15:00',5.76),('7643','2013-12-16','09:20:00',6.04),('7643','2013-12-16','09:25:00',6.27),('7643','2013-12-16','09:30:00',6.51),('7643','2013-12-16','09:35:00',6.74),('7643','2013-12-16','09:40:00',6.98),('7643','2013-12-16','09:45:00',7.2),('7643','2013-12-16','09:50:00',7.46),('7643','2013-12-16','09:55:00',7.65),('7643','2013-12-16','10:00:00',7.88),('7643','2013-12-16','10:05:00',8.07),('7643','2013-12-16','10:10:00',8.24),('7643','2013-12-16','10:15:00',8.43),('7643','2013-12-16','10:20:00',8.59),('7643','2013-12-16','10:25:00',8.8),('7643','2013-12-16','10:30:00',9.03),('7643','2013-12-16','10:35:00',9.13),('7643','2013-12-16','10:40:00',9.23),('7643','2013-12-16','10:45:00',9.39),('7643','2013-12-16','10:50:00',9.41),('7643','2013-12-16','10:55:00',9.5),('7643','2013-12-16','11:00:00',9.61),('7643','2013-12-16','11:05:00',9.71),('7643','2013-12-16','11:10:00',9.78),('7643','2013-12-16','11:15:00',9.81),('7643','2013-12-16','11:20:00',9.87),('7643','2013-12-16','11:25:00',9.9),('7643','2013-12-16','11:30:00',9.99),('7643','2013-12-16','11:35:00',10.04),('7643','2013-12-16','11:40:00',10.07),('7643','2013-12-16','11:45:00',10.09),('7643','2013-12-16','11:50:00',10.27),('7643','2013-12-16','11:55:00',10.2),('7643','2013-12-16','12:00:00',10.18),('7643','2013-12-16','12:05:00',10.16),('7643','2013-12-16','12:10:00',10.12),('7643','2013-12-16','12:15:00',10.1),('7643','2013-12-16','12:20:00',10.1),('7643','2013-12-16','12:25:00',10.04),('7643','2013-12-16','12:30:00',9.98),('7643','2013-12-16','12:35:00',9.88),('7643','2013-12-16','12:40:00',9.9),('7643','2013-12-16','12:45:00',9.82),('7643','2013-12-16','12:50:00',9.69),('7643','2013-12-16','12:55:00',9.58),('7643','2013-12-16','13:00:00',9.45),('7643','2013-12-16','13:05:00',9.33),('7643','2013-12-16','13:10:00',9.12),('7643','2013-12-16','13:15:00',8.98),('7643','2013-12-16','13:20:00',8.77),('7643','2013-12-16','13:25:00',8.59),('7643','2013-12-16','13:30:00',8.54),('7643','2013-12-16','13:35:00',8.49),('7643','2013-12-16','13:40:00',8.36),('7643','2013-12-16','13:45:00',8.13),('7643','2013-12-16','13:50:00',7.93),('7643','2013-12-16','13:55:00',7.76),('7643','2013-12-16','14:00:00',7.55),('7643','2013-12-16','14:05:00',7.26),('7643','2013-12-16','14:10:00',7.05),('7643','2013-12-16','14:15:00',6.79),('7643','2013-12-16','14:20:00',6.56),('7643','2013-12-16','14:25:00',6.28),('7643','2013-12-16','14:30:00',6.07),('7643','2013-12-16','14:35:00',5.88),('7643','2013-12-16','14:40:00',5.6),('7643','2013-12-16','14:45:00',5.26),('7643','2013-12-16','14:50:00',5.01),('7643','2013-12-16','14:55:00',4.83),('7643','2013-12-16','15:00:00',4.67),('7643','2013-12-16','15:05:00',4.39),('7643','2013-12-16','15:10:00',4.13),('7643','2013-12-16','15:15:00',3.82),('7643','2013-12-16','15:20:00',3.52),('7643','2013-12-16','15:25:00',3.23),('7643','2013-12-16','15:30:00',2.91),('7643','2013-12-16','15:35:00',2.62),('7643','2013-12-16','15:40:00',2.33),('7643','2013-12-16','15:45:00',2.05),('7643','2013-12-16','15:50:00',1.76),('7643','2013-12-16','15:55:00',1.5),('7643','2013-12-16','16:00:00',1.23),('7643','2013-12-15','08:00:00',1.28),('7643','2013-12-15','08:05:00',1.56),('7643','2013-12-15','08:10:00',1.85),('7643','2013-12-15','08:15:00',2.15),('7643','2013-12-15','08:20:00',2.45),('7643','2013-12-15','08:25:00',2.78),('7643','2013-12-15','08:30:00',3.09),('7643','2013-12-15','08:35:00',3.4),('7643','2013-12-15','08:40:00',3.7),('7643','2013-12-15','08:45:00',3.99),('7643','2013-12-15','08:50:00',4.29),('7643','2013-12-15','08:55:00',4.58),('7643','2013-12-15','09:00:00',4.89),('7643','2013-12-15','09:05:00',5.2),('7643','2013-12-15','09:10:00',5.48),('7643','2013-12-15','09:15:00',5.72),('7643','2013-12-15','09:20:00',5.93),('7643','2013-12-15','09:25:00',6.19),('7643','2013-12-15','09:30:00',6.46),('7643','2013-12-15','09:35:00',6.71),('7643','2013-12-15','09:40:00',6.95),('7643','2013-12-15','09:45:00',7.19),('7643','2013-12-15','09:50:00',7.4),('7643','2013-12-15','09:55:00',7.58),('7643','2013-12-15','10:00:00',7.74),('7643','2013-12-15','10:05:00',7.96),('7643','2013-12-15','10:10:00',8.1),('7643','2013-12-15','10:15:00',8.25),('7643','2013-12-15','10:20:00',8.28),('7643','2013-12-15','10:25:00',8.38),('7643','2013-12-15','10:30:00',8.53),('7643','2013-12-15','10:35:00',8.64),('7643','2013-12-15','10:40:00',8.81),('7643','2013-12-15','10:45:00',8.94),('7643','2013-12-15','10:50:00',9.05),('7643','2013-12-15','10:55:00',9.19),('7643','2013-12-15','11:00:00',9.31),('7643','2013-12-15','11:05:00',9.37),('7643','2013-12-15','11:10:00',9.43),('7643','2013-12-15','11:15:00',9.44),('7643','2013-12-15','11:20:00',9.49),('7643','2013-12-15','11:25:00',9.63),('7643','2013-12-15','11:30:00',9.68),('7643','2013-12-15','11:35:00',9.7),('7643','2013-12-15','11:40:00',9.8),('7643','2013-12-15','11:45:00',9.75),('7643','2013-12-15','11:50:00',9.8),('7643','2013-12-15','11:55:00',9.83),('7643','2013-12-15','12:00:00',9.96),('7643','2013-12-15','12:05:00',10.02),('7643','2013-12-15','12:10:00',10.11),('7643','2013-12-15','12:15:00',10.05),('7643','2013-12-15','12:20:00',10.1),('7643','2013-12-15','12:25:00',10.01),('7643','2013-12-15','12:30:00',9.88),('7643','2013-12-15','12:35:00',9.75),('7643','2013-12-15','12:40:00',9.71),('7643','2013-12-15','12:45:00',9.62),('7643','2013-12-15','12:50:00',9.63),('7643','2013-12-15','12:55:00',9.52),('7643','2013-12-15','13:00:00',9.49),('7643','2013-12-15','13:05:00',9.37),('7643','2013-12-15','13:10:00',9.18),('7643','2013-12-15','13:15:00',9.02),('7643','2013-12-15','13:20:00',8.82),('7643','2013-12-15','13:25:00',8.6),('7643','2013-12-15','13:30:00',8.45),('7643','2013-12-15','13:35:00',8.24),('7643','2013-12-15','13:40:00',8.06),('7643','2013-12-15','13:45:00',7.92),('7643','2013-12-15','13:50:00',7.81),('7643','2013-12-15','13:55:00',7.64),('7643','2013-12-15','14:00:00',7.27),('7643','2013-12-15','14:05:00',7.13),('7643','2013-12-15','14:10:00',6.91),('7643','2013-12-15','14:15:00',6.7),('7643','2013-12-15','14:20:00',6.5),('7643','2013-12-15','14:25:00',6.28),('7643','2013-12-15','14:30:00',6.01),('7643','2013-12-15','14:35:00',5.77),('7643','2013-12-15','14:40:00',5.5),('7643','2013-12-15','14:45:00',5.22),('7643','2013-12-15','14:50:00',4.94),('7643','2013-12-15','14:55:00',4.67),('7643','2013-12-15','15:00:00',4.44),('7643','2013-12-15','15:05:00',4.09),('7643','2013-12-15','15:10:00',3.84),('7643','2013-12-15','15:15:00',3.62),('7643','2013-12-15','15:20:00',3.39),('7643','2013-12-15','15:25:00',3.09),('7643','2013-12-15','15:30:00',2.8),('7643','2013-12-15','15:35:00',2.46),('7643','2013-12-15','15:40:00',2.12),('7643','2013-12-15','15:45:00',1.85),('7643','2013-12-15','15:50:00',1.57),('7643','2013-12-15','15:55:00',1.3),('7643','2013-12-15','16:00:00',1.08),('7643','2013-12-14','08:50:00',1.09),('7643','2013-12-14','08:55:00',1.3),('7643','2013-12-14','09:00:00',1.51),('7643','2013-12-14','09:05:00',1.55),('7643','2013-12-14','09:10:00',1.26),('7643','2013-12-14','09:15:00',1.22),('7643','2013-12-14','09:20:00',1.27),('7643','2013-12-14','09:25:00',1.49),('7643','2013-12-14','09:30:00',1.46),('7643','2013-12-14','09:35:00',1.5),('7643','2013-12-14','09:40:00',1.72),('7643','2013-12-14','09:45:00',2.18),('7643','2013-12-14','09:50:00',2.54),('7643','2013-12-14','09:55:00',2.59),('7643','2013-12-14','10:00:00',2.6),('7643','2013-12-14','10:05:00',2.63),('7643','2013-12-14','10:10:00',2.76),('7643','2013-12-14','10:15:00',3.09),('7643','2013-12-14','10:20:00',5.46),('7643','2013-12-14','10:25:00',4.93),('7643','2013-12-14','10:30:00',4.15),('7643','2013-12-14','10:35:00',4.7),('7643','2013-12-14','10:40:00',4.64),('7643','2013-12-14','10:45:00',4.74),('7643','2013-12-14','10:50:00',3.76),('7643','2013-12-14','10:55:00',3.03),('7643','2013-12-14','11:00:00',2.96),('7643','2013-12-14','11:05:00',2.87),('7643','2013-12-14','11:10:00',2.76),('7643','2013-12-14','11:15:00',2.79),('7643','2013-12-14','11:20:00',3.13),('7643','2013-12-14','11:25:00',3.17),('7643','2013-12-14','11:30:00',3.09),('7643','2013-12-14','11:35:00',3.22),('7643','2013-12-14','11:40:00',3.33),('7643','2013-12-14','11:45:00',3.46),('7643','2013-12-14','11:50:00',3.39),('7643','2013-12-14','11:55:00',3.37),('7643','2013-12-14','12:00:00',3.4),('7643','2013-12-14','12:05:00',3.46),('7643','2013-12-14','12:10:00',3.21),('7643','2013-12-14','12:15:00',2.96),('7643','2013-12-14','12:20:00',3.21),('7643','2013-12-14','12:25:00',2.61),('7643','2013-12-14','12:30:00',1.86),('7643','2013-12-14','12:35:00',1.93),('7643','2013-12-14','12:40:00',2.13),('7643','2013-12-14','12:45:00',2.46),('7643','2013-12-14','12:50:00',2.54),('7643','2013-12-14','12:55:00',2.01),('7643','2013-12-14','13:00:00',1.46),('7643','2013-12-14','13:05:00',1.37),('7643','2013-12-14','13:10:00',1.44),('7643','2013-12-14','13:15:00',1.32),('7643','2013-12-14','13:20:00',1.09),('7643','2013-12-13','08:00:00',1.18),('7643','2013-12-13','08:05:00',1.44),('7643','2013-12-13','08:10:00',1.71),('7643','2013-12-13','08:15:00',2),('7643','2013-12-13','08:20:00',2.27),('7643','2013-12-13','08:25:00',2.54),('7643','2013-12-13','08:30:00',2.73),('7643','2013-12-13','08:35:00',3.01),('7643','2013-12-13','08:40:00',3.29),('7643','2013-12-13','08:45:00',3.59),('7643','2013-12-13','08:50:00',3.86),('7643','2013-12-13','08:55:00',4.21),('7643','2013-12-13','09:00:00',4.59),('7643','2013-12-13','09:05:00',4.96),('7643','2013-12-13','09:10:00',5.25),('7643','2013-12-13','09:15:00',5.53),('7643','2013-12-13','09:20:00',5.84),('7643','2013-12-13','09:25:00',6.09),('7643','2013-12-13','09:30:00',6.33),('7643','2013-12-13','09:35:00',6.57),('7643','2013-12-13','09:40:00',6.76),('7643','2013-12-13','09:45:00',6.98),('7643','2013-12-13','09:50:00',7.2),('7643','2013-12-13','09:55:00',7.41),('7643','2013-12-13','10:00:00',7.58),('7643','2013-12-13','10:05:00',7.76),('7643','2013-12-13','10:10:00',7.93),('7643','2013-12-13','10:15:00',8.15),('7643','2013-12-13','10:20:00',8.29),('7643','2013-12-13','10:25:00',8.37),('7643','2013-12-13','10:30:00',8.53),('7643','2013-12-13','10:35:00',8.67),('7643','2013-12-13','10:40:00',8.79),('7643','2013-12-13','10:45:00',8.85),('7643','2013-12-13','10:50:00',8.93),('7643','2013-12-13','10:55:00',9.07),('7643','2013-12-13','11:00:00',9.06),('7643','2013-12-13','11:05:00',9.02),('7643','2013-12-13','11:10:00',9.14),('7643','2013-12-13','11:15:00',9.24),('7643','2013-12-13','11:20:00',9.34),('7643','2013-12-13','11:25:00',9.32),('7643','2013-12-13','11:30:00',9.4),('7643','2013-12-13','11:35:00',9.28),('7643','2013-12-13','11:40:00',9.4),('7643','2013-12-13','11:45:00',9.43),('7643','2013-12-13','11:50:00',9.3),('7643','2013-12-13','11:55:00',9.31),('7643','2013-12-13','12:00:00',9.19),('7643','2013-12-13','12:05:00',9.09),('7643','2013-12-13','12:10:00',9.2),('7643','2013-12-13','12:15:00',9.19),('7643','2013-12-13','12:20:00',9.16),('7643','2013-12-13','12:25:00',9.06),('7643','2013-12-13','12:30:00',8.78),('7643','2013-12-13','12:35:00',9.23),('7643','2013-12-13','12:40:00',9.06),('7643','2013-12-13','12:45:00',9.07),('7643','2013-12-13','12:50:00',9.13),('7643','2013-12-13','12:55:00',8.89),('7643','2013-12-13','13:00:00',8.65),('7643','2013-12-13','13:05:00',8.63),('7643','2013-12-13','13:10:00',8.69),('7643','2013-12-13','13:15:00',8.53),('7643','2013-12-13','13:20:00',8.38),('7643','2013-12-13','13:25:00',8.35),('7643','2013-12-13','13:30:00',8.36),('7643','2013-12-13','13:35:00',8.04),('7643','2013-12-13','13:40:00',7.9),('7643','2013-12-13','13:45:00',7.88),('7643','2013-12-13','13:50:00',7.58),('7643','2013-12-13','13:55:00',7.38),('7643','2013-12-13','14:00:00',7.24),('7643','2013-12-13','14:05:00',7.02),('7643','2013-12-13','14:10:00',6.89),('7643','2013-12-13','14:15:00',6.61),('7643','2013-12-13','14:20:00',6.32),('7643','2013-12-13','14:25:00',6.11),('7643','2013-12-13','14:30:00',5.86),('7643','2013-12-13','14:35:00',5.63),('7643','2013-12-13','14:40:00',5.32),('7643','2013-12-13','14:45:00',5.04),('7643','2013-12-13','14:50:00',4.72),('7643','2013-12-13','14:55:00',4.35),('7643','2013-12-13','15:00:00',4.16),('7643','2013-12-13','15:05:00',3.95),('7643','2013-12-13','15:10:00',3.67),('7643','2013-12-13','15:15:00',3.5),('7643','2013-12-13','15:20:00',3.24),('7643','2013-12-13','15:25:00',3.02),('7643','2013-12-13','15:30:00',2.71),('7643','2013-12-13','15:35:00',2.47),('7643','2013-12-13','15:40:00',2.17),('7643','2013-12-13','15:45:00',1.84),('7643','2013-12-13','15:50:00',1.6),('7643','2013-12-13','15:55:00',1.32),('7643','2013-12-13','16:00:00',1.08),('7643','2013-12-12','08:05:00',1.21),('7643','2013-12-12','08:10:00',1.52),('7643','2013-12-12','08:15:00',1.77),('7643','2013-12-12','08:20:00',2.06),('7643','2013-12-12','08:25:00',2.34),('7643','2013-12-12','08:30:00',2.61),('7643','2013-12-12','08:35:00',2.86),('7643','2013-12-12','08:40:00',3.14),('7643','2013-12-12','08:45:00',3.45),('7643','2013-12-12','08:50:00',3.71),('7643','2013-12-12','08:55:00',3.99),('7643','2013-12-12','09:00:00',4.27),('7643','2013-12-12','09:05:00',4.53),('7643','2013-12-12','09:10:00',4.78),('7643','2013-12-12','09:15:00',5.12),('7643','2013-12-12','09:20:00',5.33),('7643','2013-12-12','09:25:00',5.5),('7643','2013-12-12','09:30:00',5.68),('7643','2013-12-12','09:35:00',5.81),('7643','2013-12-12','09:40:00',6.1),('7643','2013-12-12','09:45:00',6.35),('7643','2013-12-12','09:50:00',6.57),('7643','2013-12-12','09:55:00',6.84),('7643','2013-12-12','10:00:00',7),('7643','2013-12-12','10:05:00',7.17),('7643','2013-12-12','10:10:00',7.33),('7643','2013-12-12','10:15:00',7.49),('7643','2013-12-12','10:20:00',7.65),('7643','2013-12-12','10:25:00',7.72),('7643','2013-12-12','10:30:00',7.94),('7643','2013-12-12','10:35:00',8.09),('7643','2013-12-12','10:40:00',8.27),('7643','2013-12-12','10:45:00',8.38),('7643','2013-12-12','10:50:00',8.49),('7643','2013-12-12','10:55:00',8.68),('7643','2013-12-12','11:00:00',8.82),('7643','2013-12-12','11:05:00',8.91),('7643','2013-12-12','11:10:00',8.89),('7643','2013-12-12','11:15:00',8.95),('7643','2013-12-12','11:20:00',9.01),('7643','2013-12-12','11:25:00',8.95),('7643','2013-12-12','11:30:00',9.01),('7643','2013-12-12','11:35:00',9.07),('7643','2013-12-12','11:40:00',8.93),('7643','2013-12-12','11:45:00',9.07),('7643','2013-12-12','11:50:00',9.14),('7643','2013-12-12','11:55:00',9.19),('7643','2013-12-12','12:00:00',9.1),('7643','2013-12-12','12:05:00',9.14),('7643','2013-12-12','12:10:00',9.25),('7643','2013-12-12','12:15:00',9.13),('7643','2013-12-12','12:20:00',9.02),('7643','2013-12-12','12:25:00',9.2),('7643','2013-12-12','12:30:00',9.03),('7643','2013-12-12','12:35:00',9.03),('7643','2013-12-12','12:40:00',8.38),('7643','2013-12-12','12:45:00',9.04),('7643','2013-12-12','12:50:00',8.8),('7643','2013-12-12','12:55:00',8.63),('7643','2013-12-12','13:00:00',8.58),('7643','2013-12-12','13:05:00',8.52),('7643','2013-12-12','13:10:00',8.51),('7643','2013-12-12','13:15:00',8.55),('7643','2013-12-12','13:20:00',8.2),('7643','2013-12-12','13:25:00',8.34),('7643','2013-12-12','13:30:00',8.34),('7643','2013-12-12','13:35:00',8.14),('7643','2013-12-12','13:40:00',7.85),('7643','2013-12-12','13:45:00',7.66),('7643','2013-12-12','13:50:00',7.48),('7643','2013-12-12','13:55:00',7.23),('7643','2013-12-12','14:00:00',7.18),('7643','2013-12-12','14:05:00',7),('7643','2013-12-12','14:10:00',6.8),('7643','2013-12-12','14:15:00',6.6),('7643','2013-12-12','14:20:00',6.34),('7643','2013-12-12','14:25:00',6.09),('7643','2013-12-12','14:30:00',5.85),('7643','2013-12-12','14:35:00',5.76),('7643','2013-12-12','14:40:00',5.5),('7643','2013-12-12','14:45:00',5.26),('7643','2013-12-12','14:50:00',5.08),('7643','2013-12-12','14:55:00',4.8),('7643','2013-12-12','15:00:00',4.26),('7643','2013-12-12','15:05:00',3.97),('7643','2013-12-12','15:10:00',3.68),('7643','2013-12-12','15:15:00',3.31),('7643','2013-12-12','15:20:00',3.08),('7643','2013-12-12','15:25:00',2.85),('7643','2013-12-12','15:30:00',2.58),('7643','2013-12-12','15:35:00',2.33),('7643','2013-12-12','15:40:00',2.05),('7643','2013-12-12','15:45:00',1.8),('7643','2013-12-12','15:50:00',1.5),('7643','2013-12-12','15:55:00',1.25),('7643','2013-12-12','16:00:00',1.01),('7643','2013-12-11','08:00:00',1.13),('7643','2013-12-11','08:05:00',1.42),('7643','2013-12-11','08:10:00',1.7),('7643','2013-12-11','08:15:00',1.98),('7643','2013-12-11','08:20:00',2.29),('7643','2013-12-11','08:25:00',2.59),('7643','2013-12-11','08:30:00',2.91),('7643','2013-12-11','08:35:00',3.18),('7643','2013-12-11','08:40:00',3.49),('7643','2013-12-11','08:45:00',3.78),('7643','2013-12-11','08:50:00',4.07),('7643','2013-12-11','08:55:00',4.38),('7643','2013-12-11','09:00:00',4.62),('7643','2013-12-11','09:05:00',4.89),('7643','2013-12-11','09:10:00',5.16),('7643','2013-12-11','09:15:00',5.41),('7643','2013-12-11','09:20:00',5.65),('7643','2013-12-11','09:25:00',5.94),('7643','2013-12-11','09:30:00',6.2),('7643','2013-12-11','09:35:00',6.47),('7643','2013-12-11','09:40:00',6.73),('7643','2013-12-11','09:45:00',6.91),('7643','2013-12-11','09:50:00',7.1),('7643','2013-12-11','09:55:00',7.28),('7643','2013-12-11','10:00:00',7.45),('7643','2013-12-11','10:05:00',7.64),('7643','2013-12-11','10:10:00',7.9),('7643','2013-12-11','10:15:00',8.11),('7643','2013-12-11','10:20:00',8.25),('7643','2013-12-11','10:25:00',8.43),('7643','2013-12-11','10:30:00',8.56),('7643','2013-12-11','10:35:00',8.69),('7643','2013-12-11','10:40:00',8.83),('7643','2013-12-11','10:45:00',8.93),('7643','2013-12-11','10:50:00',9.05),('7643','2013-12-11','10:55:00',9.14),('7643','2013-12-11','11:00:00',9.17),('7643','2013-12-11','11:05:00',9.18),('7643','2013-12-11','11:10:00',9.19),('7643','2013-12-11','11:15:00',9.3),('7643','2013-12-11','11:20:00',9.31),('7643','2013-12-11','11:25:00',9.34),('7643','2013-12-11','11:30:00',9.32),('7643','2013-12-11','11:35:00',9.33),('7643','2013-12-11','11:40:00',9.38),('7643','2013-12-11','11:45:00',9.36),('7643','2013-12-11','11:50:00',9.38),('7643','2013-12-11','11:55:00',9.47),('7643','2013-12-11','12:00:00',9.42),('7643','2013-12-11','12:05:00',9.52),('7643','2013-12-11','12:10:00',9.51),('7643','2013-12-11','12:15:00',9.46),('7643','2013-12-11','12:20:00',9.51),('7643','2013-12-11','12:25:00',9.43),('7643','2013-12-11','12:30:00',9.37),('7643','2013-12-11','12:35:00',9.32),('7643','2013-12-11','12:40:00',9.23),('7643','2013-12-11','12:45:00',9.04),('7643','2013-12-11','12:50:00',9.16),('7643','2013-12-11','12:55:00',8.88),('7643','2013-12-11','13:00:00',8.62),('7643','2013-12-11','13:05:00',8.45),('7643','2013-12-11','13:10:00',8.27),('7643','2013-12-11','13:15:00',8.45),('7643','2013-12-11','13:20:00',8.45),('7643','2013-12-11','13:25:00',8.24),('7643','2013-12-11','13:30:00',8.03),('7643','2013-12-11','13:35:00',8.01),('7643','2013-12-11','13:40:00',7.8),('7643','2013-12-11','13:45:00',7.63),('7643','2013-12-11','13:50:00',7.49),('7643','2013-12-11','13:55:00',7.38),('7643','2013-12-11','14:00:00',7.13),('7643','2013-12-11','14:05:00',6.92),('7643','2013-12-11','14:10:00',6.72),('7643','2013-12-11','14:15:00',6.35),('7643','2013-12-11','14:20:00',6.11),('7643','2013-12-11','14:25:00',5.84),('7643','2013-12-11','14:30:00',5.53),('7643','2013-12-11','14:35:00',5.27),('7643','2013-12-11','14:40:00',5.13),('7643','2013-12-11','14:45:00',4.81),('7643','2013-12-11','14:50:00',4.49),('7643','2013-12-11','14:55:00',4.32),('7643','2013-12-11','15:00:00',3.99),('7643','2013-12-11','15:05:00',3.71),('7643','2013-12-11','15:10:00',3.4),('7643','2013-12-11','15:15:00',3.19),('7643','2013-12-11','15:20:00',2.94),('7643','2013-12-11','15:25:00',2.68),('7643','2013-12-11','15:30:00',2.43),('7643','2013-12-11','15:35:00',2.17),('7643','2013-12-11','15:40:00',1.91),('7643','2013-12-11','15:45:00',1.65),('7643','2013-12-11','15:50:00',1.38),('7643','2013-12-11','15:55:00',1.12),('7643','2013-12-10','08:00:00',1.26),('7643','2013-12-10','08:05:00',1.2),('7643','2013-12-10','08:10:00',1.77),('7643','2013-12-10','08:15:00',1.95),('7643','2013-12-10','08:20:00',2.27),('7643','2013-12-10','08:25:00',2.75),('7643','2013-12-10','08:30:00',3.08),('7643','2013-12-10','08:35:00',3.34),('7643','2013-12-10','08:40:00',3.62),('7643','2013-12-10','08:45:00',3.89),('7643','2013-12-10','08:50:00',4.24),('7643','2013-12-10','08:55:00',4.56),('7643','2013-12-10','09:00:00',4.82),('7643','2013-12-10','09:05:00',5.08),('7643','2013-12-10','09:10:00',5.35),('7643','2013-12-10','09:15:00',5.59),('7643','2013-12-10','09:20:00',5.9),('7643','2013-12-10','09:25:00',6.18),('7643','2013-12-10','09:30:00',6.4),('7643','2013-12-10','09:35:00',6.65),('7643','2013-12-10','09:40:00',6.93),('7643','2013-12-10','09:45:00',7.2),('7643','2013-12-10','09:50:00',7.44),('7643','2013-12-10','09:55:00',7.57),('7643','2013-12-10','10:00:00',7.78),('7643','2013-12-10','10:05:00',8.02),('7643','2013-12-10','10:10:00',8.15),('7643','2013-12-10','10:15:00',8.36),('7643','2013-12-10','10:20:00',8.51),('7643','2013-12-10','10:25:00',8.71),('7643','2013-12-10','10:30:00',8.94),('7643','2013-12-10','10:35:00',9.2),('7643','2013-12-10','10:40:00',9.28),('7643','2013-12-10','10:45:00',9.23),('7643','2013-12-10','10:50:00',9.34),('7643','2013-12-10','10:55:00',9.43),('7643','2013-12-10','11:00:00',9.6),('7643','2013-12-10','11:05:00',9.78),('7643','2013-12-10','11:10:00',9.81),('7643','2013-12-10','11:15:00',9.82),('7643','2013-12-10','11:20:00',9.85),('7643','2013-12-10','11:25:00',9.81),('7643','2013-12-10','11:30:00',9.61),('7643','2013-12-10','11:35:00',9.8),('7643','2013-12-10','11:40:00',10),('7643','2013-12-10','11:45:00',10.02),('7643','2013-12-10','11:50:00',10.07),('7643','2013-12-10','11:55:00',10.05),('7643','2013-12-10','12:00:00',10.04),('7643','2013-12-10','12:05:00',10.15),('7643','2013-12-10','12:10:00',10.05),('7643','2013-12-10','12:15:00',9.97),('7643','2013-12-10','12:20:00',9.97),('7643','2013-12-10','12:25:00',9.66),('7643','2013-12-10','12:30:00',9.62),('7643','2013-12-10','12:35:00',9.63),('7643','2013-12-10','12:40:00',9.59),('7643','2013-12-10','12:45:00',9.64),('7643','2013-12-10','12:50:00',9.5),('7643','2013-12-10','12:55:00',9.45),('7643','2013-12-10','13:00:00',9.43),('7643','2013-12-10','13:05:00',9.22),('7643','2013-12-10','13:10:00',9.04),('7643','2013-12-10','13:15:00',8.84),('7643','2013-12-10','13:20:00',8.74),('7643','2013-12-10','13:25:00',8.7),('7643','2013-12-10','13:30:00',8.61),('7643','2013-12-10','13:35:00',8.4),('7643','2013-12-10','13:40:00',8.18),('7643','2013-12-10','13:45:00',7.96),('7643','2013-12-10','13:50:00',7.74),('7643','2013-12-10','13:55:00',7.51),('7643','2013-12-10','14:00:00',7.33),('7643','2013-12-10','14:05:00',7.22),('7643','2013-12-10','14:10:00',7.11),('7643','2013-12-10','14:15:00',6.86),('7643','2013-12-10','14:20:00',6.57),('7643','2013-12-10','14:25:00',6.37),('7643','2013-12-10','14:30:00',6.14),('7643','2013-12-10','14:35:00',5.85),('7643','2013-12-10','14:40:00',5.59),('7643','2013-12-10','14:45:00',5.28),('7643','2013-12-10','14:50:00',5.03),('7643','2013-12-10','14:55:00',4.78),('7643','2013-12-10','15:00:00',4.5),('7643','2013-12-10','15:05:00',4.19),('7643','2013-12-10','15:10:00',3.86),('7643','2013-12-10','15:15:00',3.52),('7643','2013-12-10','15:20:00',3.27),('7643','2013-12-10','15:25:00',2.94),('7643','2013-12-10','15:30:00',2.59),('7643','2013-12-10','15:35:00',2.3),('7643','2013-12-10','15:40:00',2.06),('7643','2013-12-10','15:45:00',1.8),('7643','2013-12-10','15:50:00',1.51),('7643','2013-12-10','15:55:00',1.26),('7643','2013-12-10','16:00:00',1.02),('7643','2013-12-09','08:00:00',1.41),('7643','2013-12-09','08:05:00',1.69),('7643','2013-12-09','08:10:00',1.96),('7643','2013-12-09','08:15:00',2.26),('7643','2013-12-09','08:20:00',2.57),('7643','2013-12-09','08:25:00',2.86),('7643','2013-12-09','08:30:00',3.17),('7643','2013-12-09','08:35:00',3.43),('7643','2013-12-09','08:40:00',3.77),('7643','2013-12-09','08:45:00',4.08),('7643','2013-12-09','08:50:00',4.41),('7643','2013-12-09','08:55:00',4.73),('7643','2013-12-09','09:00:00',5.05),('7643','2013-12-09','09:05:00',5.31),('7643','2013-12-09','09:10:00',5.59),('7643','2013-12-09','09:15:00',5.87),('7643','2013-12-09','09:20:00',6.18),('7643','2013-12-09','09:25:00',6.45),('7643','2013-12-09','09:30:00',6.58),('7643','2013-12-09','09:35:00',6.81),('7643','2013-12-09','09:40:00',7.04),('7643','2013-12-09','09:45:00',7.23),('7643','2013-12-09','09:50:00',7.55),('7643','2013-12-09','09:55:00',7.78),('7643','2013-12-09','10:00:00',7.98),('7643','2013-12-09','10:05:00',8.16),('7643','2013-12-09','10:10:00',8.4),('7643','2013-12-09','10:15:00',8.56),('7643','2013-12-09','10:20:00',8.73),('7643','2013-12-09','10:25:00',8.87),('7643','2013-12-09','10:30:00',8.98),('7643','2013-12-09','10:35:00',9.13),('7643','2013-12-09','10:40:00',9.17),('7643','2013-12-09','10:45:00',9.31),('7643','2013-12-09','10:50:00',9.52),('7643','2013-12-09','10:55:00',9.6),('7643','2013-12-09','11:00:00',9.72),('7643','2013-12-09','11:05:00',9.81),('7643','2013-12-09','11:10:00',9.89),('7643','2013-12-09','11:15:00',9.9),('7643','2013-12-09','11:20:00',9.99),('7643','2013-12-09','11:25:00',10.07),('7643','2013-12-09','11:30:00',10.15),('7643','2013-12-09','11:35:00',10.2),('7643','2013-12-09','11:40:00',10.23),('7643','2013-12-09','11:45:00',10.22),('7643','2013-12-09','11:50:00',10.21),('7643','2013-12-09','11:55:00',10.21),('7643','2013-12-09','12:00:00',10.19),('7643','2013-12-09','12:05:00',10.16),('7643','2013-12-09','12:10:00',10.09),('7643','2013-12-09','12:15:00',10.07),('7643','2013-12-09','12:20:00',10.05),('7643','2013-12-09','12:25:00',9.91),('7643','2013-12-09','12:30:00',9.81),('7643','2013-12-09','12:35:00',9.72),('7643','2013-12-09','12:40:00',9.53),('7643','2013-12-09','12:45:00',9.53),('7643','2013-12-09','12:50:00',9.38),('7643','2013-12-09','12:55:00',9.25),('7643','2013-12-09','13:00:00',9.07),('7643','2013-12-09','13:05:00',9.05),('7643','2013-12-09','13:10:00',8.79),('7643','2013-12-09','13:15:00',8.54),('7643','2013-12-09','13:20:00',8.62),('7643','2013-12-09','13:25:00',8.53),('7643','2013-12-09','13:30:00',8.39),('7643','2013-12-09','13:35:00',8.36),('7643','2013-12-09','13:40:00',8.32),('7643','2013-12-09','13:45:00',8.18),('7643','2013-12-09','13:50:00',7.98),('7643','2013-12-09','13:55:00',7.79),('7643','2013-12-09','14:00:00',7.55),('7643','2013-12-09','14:05:00',7.34),('7643','2013-12-09','14:10:00',7.12),('7643','2013-12-09','14:15:00',6.93),('7643','2013-12-09','14:20:00',6.72),('7643','2013-12-09','14:25:00',6.55),('7643','2013-12-09','14:30:00',6.33),('7643','2013-12-09','14:35:00',6.04),('7643','2013-12-09','14:40:00',5.79),('7643','2013-12-09','14:45:00',5.43),('7643','2013-12-09','14:50:00',5.27),('7643','2013-12-09','14:55:00',4.97),('7643','2013-12-09','15:00:00',4.66),('7643','2013-12-09','15:05:00',4.33),('7643','2013-12-09','15:10:00',4.02),('7643','2013-12-09','15:15:00',3.72),('7643','2013-12-09','15:20:00',3.39),('7643','2013-12-09','15:25:00',3.07),('7643','2013-12-09','15:30:00',2.76),('7643','2013-12-09','15:35:00',2.47),('7643','2013-12-09','15:40:00',2.18),('7643','2013-12-09','15:45:00',1.89),('7643','2013-12-09','15:50:00',1.61),('7643','2013-12-09','15:55:00',1.39),('7643','2013-12-09','16:00:00',1.18),('7643','2013-12-08','09:05:00',1.02),('7643','2013-12-08','09:10:00',1.66),('7643','2013-12-08','09:15:00',1.28),('7643','2013-12-08','09:20:00',1.03),('7643','2013-12-08','09:30:00',2.35),('7643','2013-12-08','09:35:00',6.62),('7643','2013-12-08','09:40:00',6.9),('7643','2013-12-08','09:45:00',7.11),('7643','2013-12-08','09:50:00',7.33),('7643','2013-12-08','09:55:00',7.58),('7643','2013-12-08','10:00:00',7.84),('7643','2013-12-08','10:05:00',8.12),('7643','2013-12-08','10:10:00',9.45),('7643','2013-12-08','10:15:00',10.27),('7643','2013-12-08','10:20:00',11.07),('7643','2013-12-08','10:25:00',9.21),('7643','2013-12-08','10:30:00',3.19),('7643','2013-12-08','10:35:00',2.58),('7643','2013-12-08','10:40:00',2.22),('7643','2013-12-08','10:45:00',1.84),('7643','2013-12-08','10:50:00',1.44),('7643','2013-12-08','10:55:00',1.52),('7643','2013-12-08','11:00:00',1.39),('7643','2013-12-08','11:05:00',1.5),('7643','2013-12-08','11:10:00',1.46),('7643','2013-12-08','11:15:00',1.46),('7643','2013-12-08','11:20:00',1.51),('7643','2013-12-08','11:25:00',1.55),('7643','2013-12-08','11:30:00',1.68),('7643','2013-12-08','11:35:00',1.6),('7643','2013-12-08','11:40:00',1.76),('7643','2013-12-08','11:45:00',2),('7643','2013-12-08','11:50:00',2.09),('7643','2013-12-08','11:55:00',2.27),('7643','2013-12-08','12:00:00',2.45),('7643','2013-12-08','12:05:00',2.6),('7643','2013-12-08','12:10:00',2.56),('7643','2013-12-08','12:15:00',2.47),('7643','2013-12-08','12:20:00',2.67),('7643','2013-12-08','12:25:00',3.44),('7643','2013-12-08','12:30:00',6.94),('7643','2013-12-08','12:35:00',4.45),('7643','2013-12-08','12:40:00',4.34),('7643','2013-12-08','12:45:00',7),('7643','2013-12-08','12:50:00',6.24),('7643','2013-12-08','12:55:00',6.63),('7643','2013-12-08','13:00:00',7.87),('7643','2013-12-08','13:05:00',6.81),('7643','2013-12-08','13:10:00',5.88),('7643','2013-12-08','13:15:00',7.51),('7643','2013-12-08','13:20:00',6.66),('7643','2013-12-08','13:25:00',4.93),('7643','2013-12-08','13:30:00',2.76),('7643','2013-12-08','13:35:00',2.07),('7643','2013-12-08','13:40:00',2.56),('7643','2013-12-08','13:45:00',3.39),('7643','2013-12-08','13:50:00',4.01),('7643','2013-12-08','13:55:00',4.37),('7643','2013-12-08','14:00:00',3.68),('7643','2013-12-08','14:05:00',2.88),('7643','2013-12-08','14:10:00',2.45),('7643','2013-12-08','14:15:00',2.13),('7643','2013-12-08','14:20:00',1.87),('7643','2013-12-08','14:25:00',1.79),('7643','2013-12-08','14:30:00',1.71),('7643','2013-12-08','14:35:00',1.78),('7643','2013-12-08','14:40:00',1.99),('7643','2013-12-08','14:45:00',2.1),('7643','2013-12-08','14:50:00',1.99),('7643','2013-12-08','14:55:00',1.99),('7643','2013-12-08','15:00:00',1.9),('7643','2013-12-08','15:05:00',1.78),('7643','2013-12-08','15:10:00',1.63),('7643','2013-12-08','15:15:00',1.44),('7643','2013-12-08','15:20:00',1.36),('7643','2013-12-08','15:25:00',1.29),('7643','2013-12-08','15:30:00',1.2),('7643','2013-12-08','15:35:00',1.19),('7643','2013-12-08','15:40:00',1.09),('7643','2013-12-07','08:00:00',1.33),('7643','2013-12-07','08:05:00',1.11),('7643','2013-12-07','08:25:00',1.1),('7643','2013-12-07','08:30:00',1.93),('7643','2013-12-07','08:35:00',1.98),('7643','2013-12-07','08:40:00',2.35),('7643','2013-12-07','08:45:00',2.63),('7643','2013-12-07','08:50:00',2.32),('7643','2013-12-07','08:55:00',2.27),('7643','2013-12-07','09:00:00',2.29),('7643','2013-12-07','09:05:00',2.34),('7643','2013-12-07','09:10:00',2.15),('7643','2013-12-07','09:15:00',2.21),('7643','2013-12-07','09:20:00',2.1),('7643','2013-12-07','09:25:00',2.13),('7643','2013-12-07','09:30:00',2.16),('7643','2013-12-07','09:35:00',2.84),('7643','2013-12-07','09:40:00',3.08),('7643','2013-12-07','09:45:00',2.95),('7643','2013-12-07','09:50:00',3.4),('7643','2013-12-07','09:55:00',3.67),('7643','2013-12-07','10:00:00',3.71),('7643','2013-12-07','10:05:00',3.53),('7643','2013-12-07','10:10:00',3.72),('7643','2013-12-07','10:15:00',3.83),('7643','2013-12-07','10:20:00',3.55),('7643','2013-12-07','10:25:00',3.5),('7643','2013-12-07','10:30:00',3.55),('7643','2013-12-07','10:35:00',4.09),('7643','2013-12-07','10:40:00',4.3),('7643','2013-12-07','10:45:00',4.45),('7643','2013-12-07','10:50:00',4.31),('7643','2013-12-07','10:55:00',4.97),('7643','2013-12-07','11:00:00',5.46),('7643','2013-12-07','11:05:00',4.94),('7643','2013-12-07','11:10:00',5.17),('7643','2013-12-07','11:15:00',7.91),('7643','2013-12-07','11:20:00',5.98),('7643','2013-12-07','11:25:00',5.28),('7643','2013-12-07','11:30:00',3.41),('7643','2013-12-07','11:35:00',3.07),('7643','2013-12-07','11:40:00',2.97),('7643','2013-12-07','11:45:00',2.87),('7643','2013-12-07','11:50:00',2.93),('7643','2013-12-07','11:55:00',2.93),('7643','2013-12-07','12:00:00',2.78),('7643','2013-12-07','12:05:00',2.89),('7643','2013-12-07','12:10:00',2.61),('7643','2013-12-07','12:15:00',2.37),('7643','2013-12-07','12:20:00',2.38),('7643','2013-12-07','12:25:00',2.46),('7643','2013-12-07','12:30:00',2.23),('7643','2013-12-07','12:35:00',2.18),('7643','2013-12-07','12:40:00',2.14),('7643','2013-12-07','12:45:00',2),('7643','2013-12-07','12:50:00',2.39),('7643','2013-12-07','12:55:00',4.6),('7643','2013-12-07','13:00:00',3.04),('7643','2013-12-07','13:05:00',3.75),('7643','2013-12-07','13:10:00',3.94),('7643','2013-12-07','13:15:00',3.68),('7643','2013-12-07','13:20:00',4.48),('7643','2013-12-07','13:25:00',3.62),('7643','2013-12-07','13:30:00',2.72),('7643','2013-12-07','13:35:00',2.46),('7643','2013-12-07','13:40:00',1.87),('7643','2013-12-07','13:45:00',1.23),('7643','2013-12-07','13:50:00',1.02),('7643','2013-12-07','14:20:00',1.15),('7643','2013-12-07','14:25:00',1.35),('7643','2013-12-07','14:30:00',1.31),('7643','2013-12-07','14:35:00',1.08),('7643','2013-12-07','15:05:00',1.23),('7643','2013-12-07','15:10:00',1.49),('7643','2013-12-07','15:15:00',1.32),('7643','2013-12-07','15:20:00',1.87),('7643','2013-12-07','15:25:00',2.84),('7643','2013-12-07','15:30:00',3.43),('7643','2013-12-07','15:35:00',2.36),('7643','2013-12-07','15:40:00',1.51),('7643','2014-04-20','08:00:00',1.04),('7643','2014-04-20','08:05:00',1.12),('7643','2014-04-20','08:10:00',1.36),('7643','2014-04-20','08:15:00',1.57),('7643','2014-04-20','08:20:00',2.06),('7643','2014-04-20','08:25:00',2.26),('7643','2014-04-20','08:30:00',2.99),('7643','2014-04-20','08:35:00',3.1),('7643','2014-04-20','08:40:00',3.23),('7643','2014-04-20','08:45:00',3.06),('7643','2014-04-20','08:50:00',2.94),('7643','2014-04-20','08:55:00',2.87),('7643','2014-04-20','09:00:00',3.29),('7643','2014-04-20','09:05:00',3.28),('7643','2014-04-20','09:10:00',3.45),('7643','2014-04-20','09:15:00',3.69),('7643','2014-04-20','09:20:00',5.43),('7643','2014-04-20','09:25:00',3.8),('7643','2014-04-20','09:30:00',1.94),('7643','2014-04-20','09:35:00',1.89),('7643','2014-04-20','09:40:00',2.62),('7643','2014-04-20','09:45:00',3.09),('7643','2014-04-20','09:50:00',3.39),('7643','2014-04-20','09:55:00',4.04),('7643','2014-04-20','10:00:00',5.98),('7643','2014-04-20','10:05:00',10.25),('7643','2014-04-20','10:10:00',14.31),('7643','2014-04-20','10:15:00',13.44),('7643','2014-04-20','10:20:00',13.03),('7643','2014-04-20','10:25:00',13.1),('7643','2014-04-20','10:30:00',13.13),('7643','2014-04-20','10:35:00',13.03),('7643','2014-04-20','10:40:00',13.41),('7643','2014-04-20','10:45:00',13.53),('7643','2014-04-20','10:50:00',13.66),('7643','2014-04-20','10:55:00',13.79),('7643','2014-04-20','11:00:00',13.94),('7643','2014-04-20','11:05:00',14.06),('7643','2014-04-20','11:10:00',14.14),('7643','2014-04-20','11:15:00',14.25),('7643','2014-04-20','11:20:00',14.46),('7643','2014-04-20','11:25:00',14.62),('7643','2014-04-20','11:30:00',14.72),('7643','2014-04-20','11:35:00',14.82),('7643','2014-04-20','11:40:00',14.92),('7643','2014-04-20','11:45:00',15.13),('7643','2014-04-20','11:50:00',15.19),('7643','2014-04-20','11:55:00',15.22),('7643','2014-04-20','12:00:00',15.43),('7643','2014-04-20','12:05:00',15.54),('7643','2014-04-20','12:10:00',15.62),('7643','2014-04-20','12:15:00',15.72),('7643','2014-04-20','12:20:00',15.86),('7643','2014-04-20','12:25:00',15.95),('7643','2014-04-20','12:30:00',15.99),('7643','2014-04-20','12:35:00',16.04),('7643','2014-04-20','12:40:00',16.04),('7643','2014-04-20','12:45:00',16.12),('7643','2014-04-20','12:50:00',16.16),('7643','2014-04-20','12:55:00',16.25),('7643','2014-04-20','13:00:00',16.2),('7643','2014-04-20','13:05:00',16.16),('7643','2014-04-20','13:10:00',16.14),('7643','2014-04-20','13:15:00',16.06),('7643','2014-04-20','13:20:00',16.13),('7643','2014-04-20','13:25:00',16.17),('7643','2014-04-20','13:30:00',16.19),('7643','2014-04-20','13:35:00',16.16),('7643','2014-04-20','13:40:00',16.17),('7643','2014-04-20','13:45:00',16.39),('7643','2014-04-20','13:50:00',16.46),('7643','2014-04-20','13:55:00',16.46),('7643','2014-04-20','14:00:00',16.45),('7643','2014-04-20','14:05:00',16.41),('7643','2014-04-20','14:10:00',16.23),('7643','2014-04-20','14:15:00',16.24),('7643','2014-04-20','14:20:00',16.18),('7643','2014-04-20','14:25:00',16.02),('7643','2014-04-20','14:30:00',15.85),('7643','2014-04-20','14:35:00',15.69),('7643','2014-04-20','14:40:00',15.56),('7643','2014-04-20','14:45:00',15.41),('7643','2014-04-20','14:50:00',15.2),('7643','2014-04-20','14:55:00',15.15),('7643','2014-04-20','15:00:00',14.99),('7643','2014-04-20','15:05:00',14.79),('7643','2014-04-20','15:10:00',14.61),('7643','2014-04-20','15:15:00',14.4),('7643','2014-04-20','15:20:00',14.14),('7643','2014-04-20','15:25:00',13.82),('7643','2014-04-20','15:30:00',13.68),('7643','2014-04-20','15:35:00',13.45),('7643','2014-04-20','15:40:00',13.21),('7643','2014-04-20','15:45:00',13.07),('7643','2014-04-20','15:50:00',12.9),('7643','2014-04-20','15:55:00',12.69),('7643','2014-04-20','16:00:00',12.46),('7643','2014-04-20','16:05:00',12.13),('7643','2014-04-20','16:10:00',11.88),('7643','2014-04-20','16:15:00',9.36),('7643','2014-04-20','16:20:00',11.8),('7643','2014-04-20','16:25:00',11.24),('7643','2014-04-20','16:30:00',10.64),('7643','2014-04-20','16:35:00',10.7),('7643','2014-04-20','16:40:00',10.46),('7643','2014-04-20','16:45:00',10.24),('7643','2014-04-20','16:50:00',9.94),('7643','2014-04-20','16:55:00',9.59),('7643','2014-04-20','17:00:00',9.22),('7643','2014-04-20','17:05:00',8.91),('7643','2014-04-20','17:10:00',8.59),('7643','2014-04-20','17:15:00',8.26),('7643','2014-04-20','17:20:00',7.95),('7643','2014-04-20','17:25:00',7.59),('7643','2014-04-20','17:30:00',7.24),('7643','2014-04-20','17:35:00',6.85),('7643','2014-04-20','17:40:00',6.14),('7643','2014-04-20','17:45:00',6.11),('7643','2014-04-20','17:50:00',5.74),('7643','2014-04-20','17:55:00',5.32),('7643','2014-04-20','18:00:00',4.96),('7643','2014-04-20','18:05:00',4.51),('7643','2014-04-20','18:10:00',4.05),('7643','2014-04-20','18:15:00',3.76),('7643','2014-04-20','18:20:00',3.38),('7643','2014-04-20','18:25:00',3),('7643','2014-04-20','18:30:00',2.7),('7643','2014-04-20','18:35:00',2.35),('7643','2014-04-20','18:40:00',2.05),('7643','2014-04-20','18:45:00',1.78),('7643','2014-04-20','18:50:00',1.5),('7643','2014-04-20','18:55:00',1.27),('7643','2014-04-20','19:00:00',1.22),('7643','2014-04-20','19:05:00',1.18),('7643','2014-04-20','19:10:00',1),('7643','2013-12-06','08:00:00',1.55),('7643','2013-12-06','08:05:00',1.75),('7643','2013-12-06','08:10:00',2.1),('7643','2013-12-06','08:15:00',2.41),('7643','2013-12-06','08:20:00',2.68),('7643','2013-12-06','08:25:00',3.02),('7643','2013-12-06','08:30:00',3.34),('7643','2013-12-06','08:35:00',3.62),('7643','2013-12-06','08:40:00',3.84),('7643','2013-12-06','08:45:00',4.08),('7643','2013-12-06','08:50:00',4.36),('7643','2013-12-06','08:55:00',4.71),('7643','2013-12-06','09:00:00',5.01),('7643','2013-12-06','09:05:00',5.28),('7643','2013-12-06','09:10:00',5.58),('7643','2013-12-06','09:15:00',5.87),('7643','2013-12-06','09:20:00',6.08),('7643','2013-12-06','09:25:00',6.33),('7643','2013-12-06','09:30:00',6.57),('7643','2013-12-06','09:35:00',6.87),('7643','2013-12-06','09:40:00',7.11),('7643','2013-12-06','09:45:00',7.33),('7643','2013-12-06','09:50:00',7.52),('7643','2013-12-06','09:55:00',7.66),('7643','2013-12-06','10:00:00',7.82),('7643','2013-12-06','10:05:00',7.98),('7643','2013-12-06','10:10:00',8.07),('7643','2013-12-06','10:15:00',8.2),('7643','2013-12-06','10:20:00',8.37),('7643','2013-12-06','10:25:00',8.6),('7643','2013-12-06','10:30:00',8.66),('7643','2013-12-06','10:35:00',8.89),('7643','2013-12-06','10:40:00',9.15),('7643','2013-12-06','10:45:00',9.18),('7643','2013-12-06','10:50:00',9.13),('7643','2013-12-06','10:55:00',9.16),('7643','2013-12-06','11:00:00',9.28),('7643','2013-12-06','11:05:00',9.25),('7643','2013-12-06','11:10:00',9.39),('7643','2013-12-06','11:15:00',9.43),('7643','2013-12-06','11:20:00',9.54),('7643','2013-12-06','11:25:00',9.53),('7643','2013-12-06','11:30:00',9.55),('7643','2013-12-06','11:35:00',9.59),('7643','2013-12-06','11:40:00',9.6),('7643','2013-12-06','11:45:00',9.54),('7643','2013-12-06','11:50:00',9.53),('7643','2013-12-06','11:55:00',9.53),('7643','2013-12-06','12:00:00',9.49),('7643','2013-12-06','12:05:00',9.48),('7643','2013-12-06','12:10:00',9.51),('7643','2013-12-06','12:15:00',9.45),('7643','2013-12-06','12:20:00',9.42),('7643','2013-12-06','12:25:00',9.36),('7643','2013-12-06','12:30:00',9.3),('7643','2013-12-06','12:35:00',9.34),('7643','2013-12-06','12:40:00',9.27),('7643','2013-12-06','12:45:00',9.11),('7643','2013-12-06','12:50:00',9.13),('7643','2013-12-06','12:55:00',8.97),('7643','2013-12-06','13:00:00',9.07),('7643','2013-12-06','13:05:00',8.95),('7643','2013-12-06','13:10:00',8.89),('7643','2013-12-06','13:15:00',8.81),('7643','2013-12-06','13:20:00',8.67),('7643','2013-12-06','13:25:00',8.47),('7643','2013-12-06','13:30:00',8.36),('7643','2013-12-06','13:35:00',8.34),('7643','2013-12-06','13:40:00',8.19),('7643','2013-12-06','13:45:00',7.9),('7643','2013-12-06','13:50:00',7.76),('7643','2013-12-06','13:55:00',7.49),('7643','2013-12-06','14:00:00',7.3),('7643','2013-12-06','14:05:00',7.16),('7643','2013-12-06','14:10:00',6.84),('7643','2013-12-06','14:15:00',6.52),('7643','2013-12-06','14:20:00',6.17),('7643','2013-12-06','14:25:00',5.97),('7643','2013-12-06','14:30:00',5.7),('7643','2013-12-06','14:35:00',5.45),('7643','2013-12-06','14:40:00',5.13),('7643','2013-12-06','14:45:00',4.89),('7643','2013-12-06','14:50:00',4.66),('7643','2013-12-06','14:55:00',4.41),('7643','2013-12-06','15:00:00',4.06),('7643','2013-12-06','15:05:00',3.86),('7643','2013-12-06','15:10:00',3.55),('7643','2013-12-06','15:15:00',3.22),('7643','2013-12-06','15:20:00',2.99),('7643','2013-12-06','15:25:00',2.75),('7643','2013-12-06','15:30:00',2.54),('7643','2013-12-06','15:35:00',2.28),('7643','2013-12-06','15:40:00',2.03),('7643','2013-12-06','15:45:00',1.78),('7643','2013-12-06','15:50:00',1.51),('7643','2013-12-06','15:55:00',1.26),('7643','2013-12-06','16:00:00',1.01),('7643','2013-12-05','08:45:00',1.15),('7643','2013-12-05','08:55:00',1.2),('7643','2013-12-05','09:00:00',1.39),('7643','2013-12-05','09:05:00',1.57),('7643','2013-12-05','09:10:00',1.66),('7643','2013-12-05','09:15:00',2.01),('7643','2013-12-05','09:20:00',2.21),('7643','2013-12-05','09:25:00',2.2),('7643','2013-12-05','09:30:00',1.99),('7643','2013-12-05','09:35:00',1.89),('7643','2013-12-05','09:40:00',2.26),('7643','2013-12-05','09:45:00',2.4),('7643','2013-12-05','09:50:00',2.44),('7643','2013-12-05','09:55:00',2.56),('7643','2013-12-05','10:00:00',2.61),('7643','2013-12-05','10:05:00',3.01),('7643','2013-12-05','10:10:00',3.72),('7643','2013-12-05','10:15:00',3.87),('7643','2013-12-05','10:20:00',3.13),('7643','2013-12-05','10:25:00',2.75),('7643','2013-12-05','10:30:00',2.42),('7643','2013-12-05','10:35:00',2.12),('7643','2013-12-05','10:40:00',1.81),('7643','2013-12-05','10:45:00',1.79),('7643','2013-12-05','10:50:00',2.18),('7643','2013-12-05','10:55:00',2.49),('7643','2013-12-05','11:00:00',2.96),('7643','2013-12-05','11:05:00',3.45),('7643','2013-12-05','11:10:00',3.25),('7643','2013-12-05','11:15:00',3.09),('7643','2013-12-05','11:20:00',3.5),('7643','2013-12-05','11:25:00',3.68),('7643','2013-12-05','11:30:00',3.84),('7643','2013-12-05','11:35:00',4.7),('7643','2013-12-05','11:40:00',5.79),('7643','2013-12-05','11:45:00',6.48),('7643','2013-12-05','11:50:00',7.87),('7643','2013-12-05','11:55:00',7.78),('7643','2013-12-05','12:00:00',7),('7643','2013-12-05','12:05:00',5.96),('7643','2013-12-05','12:10:00',5.76),('7643','2013-12-05','12:15:00',5.53),('7643','2013-12-05','12:20:00',8.31),('7643','2013-12-05','12:25:00',5.64),('7643','2013-12-05','12:30:00',5.8),('7643','2013-12-05','12:35:00',5.77),('7643','2013-12-05','12:40:00',7.56),('7643','2013-12-05','12:45:00',4.71),('7643','2013-12-05','12:50:00',3.85),('7643','2013-12-05','12:55:00',3.37),('7643','2013-12-05','13:00:00',3.2),('7643','2013-12-05','13:05:00',2.86),('7643','2013-12-05','13:10:00',2.49),('7643','2013-12-05','13:15:00',2.41),('7643','2013-12-05','13:20:00',2.27),('7643','2013-12-05','13:25:00',2.44),('7643','2013-12-05','13:30:00',2.82),('7643','2013-12-05','13:35:00',2.92),('7643','2013-12-05','13:40:00',3.45),('7643','2013-12-05','13:45:00',3.55),('7643','2013-12-05','13:50:00',3.46),('7643','2013-12-05','13:55:00',3.06),('7643','2013-12-05','14:00:00',2.63),('7643','2013-12-05','14:05:00',2.51),('7643','2013-12-05','14:10:00',2.69),('7643','2013-12-05','14:15:00',2.58),('7643','2013-12-05','14:20:00',2.76),('7643','2013-12-05','14:25:00',3.14),('7643','2013-12-05','14:30:00',3.05),('7643','2013-12-05','14:35:00',3.09),('7643','2013-12-05','14:40:00',3.51),('7643','2013-12-05','14:45:00',4.76),('7643','2013-12-05','14:50:00',2.96),('7643','2013-12-05','14:55:00',2.58),('7643','2013-12-05','15:00:00',2.36),('7643','2013-12-05','15:05:00',2.44),('7643','2013-12-05','15:10:00',3.49),('7643','2013-12-05','15:15:00',3.02),('7643','2013-12-05','15:20:00',2.01),('7643','2013-12-05','15:25:00',1.9),('7643','2013-12-05','15:30:00',2.68),('7643','2013-12-05','15:35:00',2.62),('7643','2013-12-05','15:40:00',2.69),('7643','2013-12-05','15:45:00',2.25),('7643','2013-12-05','15:50:00',1.97),('7643','2013-12-05','15:55:00',1.19),('7643','2013-12-05','16:00:00',1.1),('7643','2013-12-04','08:00:00',1.68),('7643','2013-12-04','08:05:00',1.92),('7643','2013-12-04','08:10:00',2.23),('7643','2013-12-04','08:15:00',2.52),('7643','2013-12-04','08:20:00',2.84),('7643','2013-12-04','08:25:00',3.11),('7643','2013-12-04','08:30:00',3.43),('7643','2013-12-04','08:35:00',3.76),('7643','2013-12-04','08:40:00',4.08),('7643','2013-12-04','08:45:00',4.41),('7643','2013-12-04','08:50:00',4.71),('7643','2013-12-04','08:55:00',4.98),('7643','2013-12-04','09:00:00',5.27),('7643','2013-12-04','09:05:00',5.58),('7643','2013-12-04','09:10:00',5.86),('7643','2013-12-04','09:15:00',6.11),('7643','2013-12-04','09:20:00',6.38),('7643','2013-12-04','09:25:00',6.6),('7643','2013-12-04','09:30:00',6.83),('7643','2013-12-04','09:35:00',7.04),('7643','2013-12-04','09:40:00',7.28),('7643','2013-12-04','09:45:00',7.49),('7643','2013-12-04','09:50:00',7.75),('7643','2013-12-04','09:55:00',7.94),('7643','2013-12-04','10:00:00',8.11),('7643','2013-12-04','10:05:00',8.3),('7643','2013-12-04','10:10:00',8.46),('7643','2013-12-04','10:15:00',8.64),('7643','2013-12-04','10:20:00',8.87),('7643','2013-12-04','10:25:00',9.01),('7643','2013-12-04','10:30:00',9.19),('7643','2013-12-04','10:35:00',9.24),('7643','2013-12-04','10:40:00',9.34),('7643','2013-12-04','10:45:00',9.34),('7643','2013-12-04','10:50:00',9.6),('7643','2013-12-04','10:55:00',9.65),('7643','2013-12-04','11:00:00',9.72),('7643','2013-12-04','11:05:00',9.81),('7643','2013-12-04','11:10:00',9.77),('7643','2013-12-04','11:15:00',9.95),('7643','2013-12-04','11:20:00',9.93),('7643','2013-12-04','11:25:00',9.99),('7643','2013-12-04','11:30:00',10.07),('7643','2013-12-04','11:35:00',10.07),('7643','2013-12-04','11:40:00',10),('7643','2013-12-04','11:45:00',10),('7643','2013-12-04','11:50:00',9.99),('7643','2013-12-04','11:55:00',10.11),('7643','2013-12-04','12:00:00',9.94),('7643','2013-12-04','12:05:00',9.88),('7643','2013-12-04','12:10:00',9.81),('7643','2013-12-04','12:15:00',9.87),('7643','2013-12-04','12:20:00',9.81),('7643','2013-12-04','12:25:00',9.67),('7643','2013-12-04','12:30:00',9.57),('7643','2013-12-04','12:35:00',9.13),('7643','2013-12-04','12:40:00',9.5),('7643','2013-12-04','12:45:00',9.35),('7643','2013-12-04','12:50:00',8.77),('7643','2013-12-04','12:55:00',8.76),('7643','2013-12-04','13:00:00',8.33),('7643','2013-12-04','13:05:00',9.28),('7643','2013-12-04','13:10:00',9.46),('7643','2013-12-04','13:15:00',9.22),('7643','2013-12-04','13:20:00',9.05),('7643','2013-12-04','13:25:00',8.73),('7643','2013-12-04','13:30:00',8.47),('7643','2013-12-04','13:35:00',8.32),('7643','2013-12-04','13:40:00',7.98),('7643','2013-12-04','13:45:00',7.87),('7643','2013-12-04','13:50:00',7.48),('7643','2013-12-04','13:55:00',7.39),('7643','2013-12-04','14:00:00',7.13),('7643','2013-12-04','14:05:00',6.94),('7643','2013-12-04','14:10:00',6.69),('7643','2013-12-04','14:15:00',6.44),('7643','2013-12-04','14:20:00',6.19),('7643','2013-12-04','14:25:00',6.17),('7643','2013-12-04','14:30:00',5.7),('7643','2013-12-04','14:35:00',5.67),('7643','2013-12-04','14:40:00',5.39),('7643','2013-12-04','14:45:00',5.18),('7643','2013-12-04','14:50:00',4.84),('7643','2013-12-04','14:55:00',4.64),('7643','2013-12-04','15:00:00',4.39),('7643','2013-12-04','15:05:00',4.06),('7643','2013-12-04','15:10:00',3.72),('7643','2013-12-04','15:15:00',3.37),('7643','2013-12-04','15:20:00',3.12),('7643','2013-12-04','15:25:00',2.84),('7643','2013-12-04','15:30:00',2.48),('7643','2013-12-04','15:35:00',2.12),('7643','2013-12-04','15:40:00',1.85),('7643','2013-12-04','15:45:00',1.55),('7643','2013-12-04','15:50:00',1.29),('7643','2013-12-04','15:55:00',1.06),('7643','2013-12-03','08:00:00',1.99),('7643','2013-12-03','08:05:00',2.31),('7643','2013-12-03','08:10:00',2.64),('7643','2013-12-03','08:15:00',2.99),('7643','2013-12-03','08:20:00',3.31),('7643','2013-12-03','08:25:00',3.61),('7643','2013-12-03','08:30:00',3.95),('7643','2013-12-03','08:35:00',4.29),('7643','2013-12-03','08:40:00',4.6),('7643','2013-12-03','08:45:00',4.92),('7643','2013-12-03','08:50:00',5.21),('7643','2013-12-03','08:55:00',5.53),('7643','2013-12-03','09:00:00',5.87),('7643','2013-12-03','09:05:00',6.17),('7643','2013-12-03','09:10:00',6.45),('7643','2013-12-03','09:15:00',6.69),('7643','2013-12-03','09:20:00',6.93),('7643','2013-12-03','09:25:00',7.15),('7643','2013-12-03','09:30:00',7.4),('7643','2013-12-03','09:35:00',7.65),('7643','2013-12-03','09:40:00',7.89),('7643','2013-12-03','09:45:00',8.15),('7643','2013-12-03','09:50:00',8.36),('7643','2013-12-03','09:55:00',8.57),('7643','2013-12-03','10:00:00',8.75),('7643','2013-12-03','10:05:00',8.9),('7643','2013-12-03','10:10:00',9.07),('7643','2013-12-03','10:15:00',9.21),('7643','2013-12-03','10:20:00',9.33),('7643','2013-12-03','10:25:00',9.55),('7643','2013-12-03','10:30:00',9.72),('7643','2013-12-03','10:35:00',9.84),('7643','2013-12-03','10:40:00',9.95),('7643','2013-12-03','10:45:00',10.04),('7643','2013-12-03','10:50:00',10.12),('7643','2013-12-03','10:55:00',10.24),('7643','2013-12-03','11:00:00',10.29),('7643','2013-12-03','11:05:00',10.36),('7643','2013-12-03','11:10:00',10.42),('7643','2013-12-03','11:15:00',10.46),('7643','2013-12-03','11:20:00',10.51),('7643','2013-12-03','11:25:00',10.55),('7643','2013-12-03','11:30:00',10.57),('7643','2013-12-03','11:35:00',10.6),('7643','2013-12-03','11:40:00',10.66),('7643','2013-12-03','11:45:00',10.66),('7643','2013-12-03','11:50:00',10.64),('7643','2013-12-03','11:55:00',10.6),('7643','2013-12-03','12:00:00',10.6),('7643','2013-12-03','12:05:00',10.61),('7643','2013-12-03','12:10:00',10.58),('7643','2013-12-03','12:15:00',10.54),('7643','2013-12-03','12:20:00',10.46),('7643','2013-12-03','12:25:00',10.42),('7643','2013-12-03','12:30:00',10.35),('7643','2013-12-03','12:35:00',10.31),('7643','2013-12-03','12:40:00',10.18),('7643','2013-12-03','12:45:00',10.14),('7643','2013-12-03','12:50:00',10.03),('7643','2013-12-03','12:55:00',9.94),('7643','2013-12-03','13:00:00',9.83),('7643','2013-12-03','13:05:00',9.69),('7643','2013-12-03','13:10:00',9.6),('7643','2013-12-03','13:15:00',9.41),('7643','2013-12-03','13:20:00',9.28),('7643','2013-12-03','13:25:00',9.1),('7643','2013-12-03','13:30:00',8.98),('7643','2013-12-03','13:35:00',8.86),('7643','2013-12-03','13:40:00',8.63),('7643','2013-12-03','13:45:00',8.48),('7643','2013-12-03','13:50:00',8.25),('7643','2013-12-03','13:55:00',8.05),('7643','2013-12-03','14:00:00',7.93),('7643','2013-12-03','14:05:00',7.68),('7643','2013-12-03','14:10:00',7.46),('7643','2013-12-03','14:15:00',7.24),('7643','2013-12-03','14:20:00',7),('7643','2013-12-03','14:25:00',6.68),('7643','2013-12-03','14:30:00',6.41),('7643','2013-12-03','14:35:00',6.19),('7643','2013-12-03','14:40:00',6.04),('7643','2013-12-03','14:45:00',5.78),('7643','2013-12-03','14:50:00',5.46),('7643','2013-12-03','14:55:00',5.2),('7643','2013-12-03','15:00:00',4.88),('7643','2013-12-03','15:05:00',4.51),('7643','2013-12-03','15:10:00',4.19),('7643','2013-12-03','15:15:00',3.88),('7643','2013-12-03','15:20:00',3.57),('7643','2013-12-03','15:25:00',3.27),('7643','2013-12-03','15:30:00',2.96),('7643','2013-12-03','15:35:00',2.66),('7643','2013-12-03','15:40:00',2.38),('7643','2013-12-03','15:45:00',2.07),('7643','2013-12-03','15:50:00',1.77),('7643','2013-12-03','15:55:00',1.51),('7643','2013-12-03','16:00:00',1.24),('7643','2013-12-02','08:50:00',1.11),('7643','2013-12-02','08:55:00',1.31),('7643','2013-12-02','09:00:00',1.36),('7643','2013-12-02','09:05:00',1.74),('7643','2013-12-02','09:10:00',2.43),('7643','2013-12-02','09:15:00',3.39),('7643','2013-12-02','09:20:00',3.67),('7643','2013-12-02','09:25:00',4.34),('7643','2013-12-02','09:30:00',4.91),('7643','2013-12-02','09:35:00',5.11),('7643','2013-12-02','09:40:00',6.26),('7643','2013-12-02','09:45:00',6.52),('7643','2013-12-02','09:50:00',7),('7643','2013-12-02','09:55:00',6.56),('7643','2013-12-02','10:00:00',8.69),('7643','2013-12-02','10:05:00',8.9),('7643','2013-12-02','10:10:00',9.06),('7643','2013-12-02','10:15:00',9.23),('7643','2013-12-02','10:20:00',9.32),('7643','2013-12-02','10:25:00',9.51),('7643','2013-12-02','10:30:00',9.62),('7643','2013-12-02','10:35:00',9.75),('7643','2013-12-02','10:40:00',9.87),('7643','2013-12-02','10:45:00',9.99),('7643','2013-12-02','10:50:00',10.14),('7643','2013-12-02','10:55:00',10.35),('7643','2013-12-02','11:00:00',10.52),('7643','2013-12-02','11:05:00',10.64),('7643','2013-12-02','11:10:00',10.74),('7643','2013-12-02','11:15:00',10.79),('7643','2013-12-02','11:20:00',10.81),('7643','2013-12-02','11:25:00',10.8),('7643','2013-12-02','11:30:00',10.81),('7643','2013-12-02','11:35:00',10.8),('7643','2013-12-02','11:40:00',10.82),('7643','2013-12-02','11:45:00',10.87),('7643','2013-12-02','11:50:00',10.97),('7643','2013-12-02','11:55:00',11),('7643','2013-12-02','12:00:00',10.99),('7643','2013-12-02','12:05:00',11.02),('7643','2013-12-02','12:10:00',11.03),('7643','2013-12-02','12:15:00',11.1),('7643','2013-12-02','12:20:00',11.17),('7643','2013-12-02','12:25:00',11.25),('7643','2013-12-02','12:30:00',11.35),('7643','2013-12-02','12:35:00',11.38),('7643','2013-12-02','12:40:00',11.5),('7643','2013-12-02','12:45:00',11.67),('7643','2013-12-02','12:50:00',12.02),('7643','2013-12-02','12:55:00',12.36),('7643','2013-12-02','13:00:00',12.48),('7643','2013-12-02','13:05:00',12.59),('7643','2013-12-02','13:10:00',12.55),('7643','2013-12-02','13:15:00',12.11),('7643','2013-12-02','13:20:00',11.86),('7643','2013-12-02','13:25:00',11.43),('7643','2013-12-02','13:30:00',10.45),('7643','2013-12-02','13:35:00',10.71),('7643','2013-12-02','13:40:00',10.26),('7643','2013-12-02','13:45:00',9.69),('7643','2013-12-02','13:50:00',9.13),('7643','2013-12-02','13:55:00',8.93),('7643','2013-12-02','14:00:00',8.63),('7643','2013-12-02','14:05:00',8),('7643','2013-12-02','14:10:00',7.76),('7643','2013-12-02','14:15:00',7.24),('7643','2013-12-02','14:20:00',6.18),('7643','2013-12-02','14:25:00',5.74),('7643','2013-12-02','14:30:00',6.2),('7643','2013-12-02','14:35:00',6.23),('7643','2013-12-02','14:40:00',5.97),('7643','2013-12-02','14:45:00',5.67),('7643','2013-12-02','14:50:00',5.37),('7643','2013-12-02','14:55:00',5.06),('7643','2013-12-02','15:00:00',4.75),('7643','2013-12-02','15:05:00',4.45),('7643','2013-12-02','15:10:00',4.15),('7643','2013-12-02','15:15:00',3.83),('7643','2013-12-02','15:20:00',3.53),('7643','2013-12-02','15:25:00',3.18),('7643','2013-12-02','15:30:00',2.88),('7643','2013-12-02','15:35:00',2.57),('7643','2013-12-02','15:40:00',2.25),('7643','2013-12-02','15:45:00',1.94),('7643','2013-12-02','15:50:00',1.64),('7643','2013-12-02','15:55:00',1.38),('7643','2013-12-02','16:00:00',1.1),('7643','2013-12-01','09:35:00',1.06),('7643','2013-12-01','09:40:00',1.39),('7643','2013-12-01','09:45:00',1.12),('7643','2013-12-01','11:15:00',1.24),('7643','2013-12-01','11:20:00',1.45),('7643','2013-12-01','11:25:00',1.54),('7643','2013-12-01','11:30:00',1.6),('7643','2013-12-01','11:35:00',1.49),('7643','2013-12-01','11:40:00',1.29),('7643','2013-12-01','11:45:00',1.1),('7643','2013-12-01','11:50:00',1.15),('7643','2013-12-01','11:55:00',1.59),('7643','2013-12-01','12:00:00',1.83),('7643','2013-12-01','12:05:00',1.62),('7643','2013-12-01','12:10:00',1.44),('7643','2013-12-01','12:15:00',1.31),('7643','2013-12-01','12:20:00',1.3),('7643','2013-12-01','12:25:00',1.42),('7643','2013-12-01','12:30:00',1.67),('7643','2013-12-01','12:35:00',1.81),('7643','2013-12-01','12:40:00',1.66),('7643','2013-12-01','12:45:00',1.31),('7643','2013-12-01','12:50:00',1.07),('7643','2013-12-01','12:55:00',1.13),('7643','2013-12-01','13:00:00',1.33),('7643','2013-12-01','13:05:00',1.34),('7643','2013-12-01','13:10:00',1.12),('7643','2013-12-01','13:30:00',1.05),('7643','2013-12-01','13:35:00',1.57),('7643','2013-12-01','13:40:00',2.07),('7643','2013-12-01','13:45:00',2.11),('7643','2013-12-01','13:50:00',2.1),('7643','2013-12-01','13:55:00',2.32),('7643','2013-12-01','14:00:00',2.28),('7643','2013-12-01','14:05:00',2.11),('7643','2013-12-01','14:10:00',1.56),('7643','2013-12-01','14:15:00',1.31),('7643','2013-12-01','14:20:00',1.48),('7643','2013-12-01','14:25:00',1.44),('7643','2013-11-30','09:10:00',1.07),('7643','2013-11-30','10:50:00',1.1),('7643','2013-11-30','10:55:00',1.29),('7643','2013-11-30','11:00:00',1.91),('7643','2013-11-30','11:05:00',2.14),('7643','2013-11-30','11:10:00',2.02),('7643','2013-11-30','11:15:00',1.69),('7643','2013-11-30','11:20:00',1.77),('7643','2013-11-30','11:25:00',2.18),('7643','2013-11-30','11:30:00',2.94),('7643','2013-11-30','11:35:00',3.76),('7643','2013-11-30','11:40:00',3.63),('7643','2013-11-30','11:45:00',2.81),('7643','2013-11-30','11:50:00',2.93),('7643','2013-11-30','11:55:00',4.4),('7643','2013-11-30','12:00:00',3.84),('7643','2013-11-30','12:05:00',4.67),('7643','2013-11-30','12:10:00',5.98),('7643','2013-11-30','12:15:00',4.05),('7643','2013-11-30','12:20:00',2.12),('7643','2013-11-30','12:25:00',1.71),('7643','2013-11-30','12:30:00',1.53),('7643','2013-11-30','12:35:00',1.42),('7643','2013-11-30','12:40:00',1.71),('7643','2013-11-30','12:45:00',2.62),('7643','2013-11-30','12:50:00',2.6),('7643','2013-11-30','12:55:00',2.6),('7643','2013-11-30','13:00:00',2.65),('7643','2013-11-30','13:05:00',2.14),('7643','2013-11-30','13:10:00',1.54),('7643','2013-11-30','13:15:00',1.59),('7643','2013-11-30','13:20:00',1.55),('7643','2013-11-30','13:25:00',1.31),('7643','2013-11-30','13:30:00',1.42),('7643','2013-11-30','13:35:00',1.7),('7643','2013-11-30','13:40:00',1.66),('7643','2013-11-30','13:45:00',1.47),('7643','2013-11-30','13:50:00',1.79),('7643','2013-11-30','13:55:00',1.87),('7643','2013-11-30','14:00:00',1.9),('7643','2013-11-30','14:05:00',2.1),('7643','2013-11-30','14:10:00',1.99),('7643','2013-11-30','14:15:00',1.22),('7643','2013-11-30','14:25:00',1.12),('7643','2013-11-30','15:00:00',1.3),('7643','2013-11-30','15:05:00',1.7),('7643','2013-11-30','15:10:00',1.66),('7643','2013-11-30','15:15:00',1.2),('7643','2013-11-29','08:45:00',1.6),('7643','2013-11-29','08:50:00',1.98),('7643','2013-11-29','08:55:00',2.82),('7643','2013-11-29','09:00:00',2.92),('7643','2013-11-29','09:05:00',3.56),('7643','2013-11-29','09:10:00',5.79),('7643','2013-11-29','09:15:00',6.55),('7643','2013-11-29','09:20:00',7.17),('7643','2013-11-29','09:25:00',7.22),('7643','2013-11-29','09:30:00',7.42),('7643','2013-11-29','09:35:00',9.27),('7643','2013-11-29','09:40:00',8.31),('7643','2013-11-29','09:45:00',7.3),('7643','2013-11-29','09:50:00',5.48),('7643','2013-11-29','09:55:00',4.81),('7643','2013-11-29','10:00:00',4.69),('7643','2013-11-29','10:05:00',4.01),('7643','2013-11-29','10:10:00',3.81),('7643','2013-11-29','10:15:00',4.15),('7643','2013-11-29','10:20:00',4.5),('7643','2013-11-29','10:25:00',4.4),('7643','2013-11-29','10:30:00',4.6),('7643','2013-11-29','10:35:00',4.93),('7643','2013-11-29','10:40:00',5.36),('7643','2013-11-29','10:45:00',5.38),('7643','2013-11-29','10:50:00',5.44),('7643','2013-11-29','10:55:00',4.43),('7643','2013-11-29','11:00:00',4.13),('7643','2013-11-29','11:05:00',5),('7643','2013-11-29','11:10:00',5.33),('7643','2013-11-29','11:15:00',5.29),('7643','2013-11-29','11:20:00',4.64),('7643','2013-11-29','11:25:00',4.69),('7643','2013-11-29','11:30:00',4.23),('7643','2013-11-29','11:35:00',3.95),('7643','2013-11-29','11:40:00',3.75),('7643','2013-11-29','11:45:00',3.38),('7643','2013-11-29','11:50:00',3.24),('7643','2013-11-29','11:55:00',2.85),('7643','2013-11-29','12:00:00',2.68),('7643','2013-11-29','12:05:00',2.6),('7643','2013-11-29','12:10:00',2.42),('7643','2013-11-29','12:15:00',2.33),('7643','2013-11-29','12:20:00',2.35),('7643','2013-11-29','12:25:00',2.49),('7643','2013-11-29','12:30:00',2.34),('7643','2013-11-29','12:35:00',2.22),('7643','2013-11-29','12:40:00',2.01),('7643','2013-11-29','12:45:00',1.91),('7643','2013-11-29','12:50:00',1.81),('7643','2013-11-29','12:55:00',1.43),('7643','2013-11-29','13:00:00',1.45),('7643','2013-11-29','13:05:00',1.6),('7643','2013-11-29','13:10:00',1.49),('7643','2013-11-29','13:15:00',1.53),('7643','2013-11-29','13:20:00',1.74),('7643','2013-11-29','13:25:00',1.7),('7643','2013-11-29','13:30:00',1.79),('7643','2013-11-29','13:35:00',1.84),('7643','2013-11-29','13:40:00',2.06),('7643','2013-11-29','13:45:00',2.3),('7643','2013-11-29','13:50:00',2.84),('7643','2013-11-29','13:55:00',2.74),('7643','2013-11-29','14:00:00',2.32),('7643','2013-11-29','14:05:00',1.86),('7643','2013-11-29','14:10:00',1.23),('7643','2013-11-29','14:15:00',1),('7643','2013-11-28','07:40:00',1.01),('7643','2013-11-28','07:45:00',1.28),('7643','2013-11-28','07:50:00',1.57),('7643','2013-11-28','07:55:00',1.88),('7643','2013-11-28','08:00:00',2.19),('7643','2013-11-28','08:05:00',2.51),('7643','2013-11-28','08:10:00',2.85),('7643','2013-11-28','08:15:00',3.17),('7643','2013-11-28','08:20:00',3.5),('7643','2013-11-28','08:25:00',3.84),('7643','2013-11-28','08:30:00',4.14),('7643','2013-11-28','08:35:00',4.45),('7643','2013-11-28','08:40:00',4.77),('7643','2013-11-28','08:45:00',5.07),('7643','2013-11-28','08:50:00',5.38),('7643','2013-11-28','08:55:00',5.68),('7643','2013-11-28','09:00:00',5.97),('7643','2013-11-28','09:05:00',6.28),('7643','2013-11-28','09:10:00',6.56),('7643','2013-11-28','09:15:00',6.79),('7643','2013-11-28','09:20:00',7.09),('7643','2013-11-28','09:25:00',7.34),('7643','2013-11-28','09:30:00',7.59),('7643','2013-11-28','09:35:00',7.83),('7643','2013-11-28','09:40:00',8.08),('7643','2013-11-28','09:45:00',8.33),('7643','2013-11-28','09:50:00',8.55),('7643','2013-11-28','09:55:00',8.78),('7643','2013-11-28','10:00:00',8.98),('7643','2013-11-28','10:05:00',9.15),('7643','2013-11-28','10:10:00',9.3),('7643','2013-11-28','10:15:00',9.48),('7643','2013-11-28','10:20:00',9.65),('7643','2013-11-28','10:25:00',9.82),('7643','2013-11-28','10:30:00',9.95),('7643','2013-11-28','10:35:00',10.07),('7643','2013-11-28','10:40:00',10.2),('7643','2013-11-28','10:45:00',10.32),('7643','2013-11-28','10:50:00',10.42),('7643','2013-11-28','10:55:00',10.5),('7643','2013-11-28','11:00:00',10.58),('7643','2013-11-28','11:05:00',10.67),('7643','2013-11-28','11:10:00',10.78),('7643','2013-11-28','11:15:00',10.82),('7643','2013-11-28','11:20:00',10.89),('7643','2013-11-28','11:25:00',10.94),('7643','2013-11-28','11:30:00',10.96),('7643','2013-11-28','11:35:00',11.01),('7643','2013-11-28','11:40:00',11.03),('7643','2013-11-28','11:45:00',11.08),('7643','2013-11-28','11:50:00',11.04),('7643','2013-11-28','11:55:00',11.09),('7643','2013-11-28','12:00:00',11.04),('7643','2013-11-28','12:05:00',10.96),('7643','2013-11-28','12:10:00',10.96),('7643','2013-11-28','12:15:00',10.94),('7643','2013-11-28','12:20:00',10.87),('7643','2013-11-28','12:25:00',10.85),('7643','2013-11-28','12:30:00',10.75),('7643','2013-11-28','12:35:00',10.69),('7643','2013-11-28','12:40:00',10.6),('7643','2013-11-28','12:45:00',10.52),('7643','2013-11-28','12:50:00',10.39),('7643','2013-11-28','12:55:00',10.28),('7643','2013-11-28','13:00:00',10.19),('7643','2013-11-28','13:05:00',10.03),('7643','2013-11-28','13:10:00',9.9),('7643','2013-11-28','13:15:00',9.73),('7643','2013-11-28','13:20:00',9.56),('7643','2013-11-28','13:25:00',9.4),('7643','2013-11-28','13:30:00',9.22),('7643','2013-11-28','13:35:00',9.07),('7643','2013-11-28','13:40:00',8.91),('7643','2013-11-28','13:45:00',8.71),('7643','2013-11-28','13:50:00',8.46),('7643','2013-11-28','13:55:00',8.26),('7643','2013-11-28','14:00:00',8.03),('7643','2013-11-28','14:05:00',7.8),('7643','2013-11-28','14:10:00',7.59),('7643','2013-11-28','14:15:00',7.33),('7643','2013-11-28','14:20:00',7.08),('7643','2013-11-28','14:25:00',6.79),('7643','2013-11-28','14:30:00',6.54),('7643','2013-11-28','14:35:00',6.28),('7643','2013-11-28','14:40:00',5.98),('7643','2013-11-28','14:45:00',5.69),('7643','2013-11-28','14:50:00',5.41),('7643','2013-11-28','14:55:00',5.1),('7643','2013-11-28','15:00:00',4.78),('7643','2013-11-28','15:05:00',4.47),('7643','2013-11-28','15:10:00',4.17),('7643','2013-11-28','15:15:00',3.9),('7643','2013-11-28','15:20:00',3.58),('7643','2013-11-28','15:25:00',3.27),('7643','2013-11-28','15:30:00',2.96),('7643','2013-11-28','15:35:00',2.64),('7643','2013-11-28','15:40:00',2.33),('7643','2013-11-28','15:45:00',2.03),('7643','2013-11-28','15:50:00',1.74),('7643','2013-11-28','15:55:00',1.46),('7643','2013-11-28','16:00:00',1.19),('7643','2013-11-27','09:00:00',1.05),('7643','2013-11-27','09:05:00',1.21),('7643','2013-11-27','09:10:00',1.41),('7643','2013-11-27','09:15:00',1.62),('7643','2013-11-27','09:20:00',1.85),('7643','2013-11-27','09:25:00',2.18),('7643','2013-11-27','09:30:00',2.54),('7643','2013-11-27','09:35:00',2.86),('7643','2013-11-27','09:40:00',3.41),('7643','2013-11-27','09:45:00',3.62),('7643','2013-11-27','09:50:00',3.65),('7643','2013-11-27','09:55:00',3.46),('7643','2013-11-27','10:00:00',2.85),('7643','2013-11-27','10:05:00',2.37),('7643','2013-11-27','10:10:00',1.65),('7643','2013-11-27','10:35:00',1.01),('7643','2013-11-27','10:40:00',1.07),('7643','2013-11-27','10:45:00',1.2),('7643','2013-11-27','10:50:00',1.5),('7643','2013-11-27','10:55:00',1.73),('7643','2013-11-27','11:00:00',1.72),('7643','2013-11-27','11:05:00',1.39),('7643','2013-11-27','11:10:00',1.31),('7643','2013-11-27','11:15:00',1.67),('7643','2013-11-27','11:20:00',2.24),('7643','2013-11-27','11:25:00',2.36),('7643','2013-11-27','11:30:00',1.71),('7643','2013-11-27','11:35:00',1.48),('7643','2013-11-27','11:40:00',1.56),('7643','2013-11-27','11:45:00',1.35),('7643','2013-11-27','11:50:00',1.01),('7643','2013-11-27','11:55:00',1.05),('7643','2013-11-27','12:00:00',1.39),('7643','2013-11-27','12:05:00',1.67),('7643','2013-11-27','12:10:00',1.55),('7643','2013-11-27','12:15:00',1.26),('7643','2013-11-27','12:20:00',1.35),('7643','2013-11-27','12:25:00',1.88),('7643','2013-11-27','12:30:00',2.01),('7643','2013-11-27','12:35:00',1.99),('7643','2013-11-27','12:40:00',2.25),('7643','2013-11-27','12:45:00',2.55),('7643','2013-11-27','12:50:00',3.09),('7643','2013-11-27','12:55:00',3.87),('7643','2013-11-27','13:00:00',3.11),('7643','2013-11-27','13:05:00',1.75),('7643','2013-11-27','13:10:00',1.39),('7643','2013-11-27','13:15:00',1.49),('7643','2013-11-27','13:20:00',1.65),('7643','2013-11-27','13:25:00',3.15),('7643','2013-11-27','13:30:00',2.86),('7643','2013-11-27','13:35:00',3.18),('7643','2013-11-27','13:40:00',3.02),('7643','2013-11-27','13:45:00',2.54),('7643','2013-11-27','13:50:00',2.62),('7643','2013-11-27','13:55:00',1.49),('7643','2013-11-27','14:05:00',1.41),('7643','2013-11-27','14:10:00',2.8),('7643','2013-11-27','14:15:00',2.1),('7643','2013-11-27','14:20:00',1.05),('7643','2013-11-27','14:30:00',1.04),('7643','2014-04-19','07:15:00',1.15),('7643','2014-04-19','07:20:00',1.64),('7643','2014-04-19','07:40:00',2.69),('7643','2014-04-19','07:45:00',2.78),('7643','2014-04-19','07:50:00',3.72),('7643','2014-04-19','07:55:00',4.21),('7643','2014-04-19','08:00:00',4.39),('7643','2014-04-19','08:05:00',4.47),('7643','2014-04-19','08:10:00',4.83),('7643','2014-04-19','08:15:00',5.46),('7643','2014-04-19','08:20:00',6.44),('7643','2014-04-19','08:25:00',8.34),('7643','2014-04-19','08:30:00',8.61),('7643','2014-04-19','08:35:00',9.46),('7643','2014-04-19','08:40:00',9.03),('7643','2014-04-19','08:45:00',6.65),('7643','2014-04-19','08:50:00',6.54),('7643','2014-04-19','08:55:00',3.63),('7643','2014-04-19','09:00:00',6.18),('7643','2014-04-19','09:05:00',2.83),('7643','2014-04-19','09:10:00',7.03),('7643','2014-04-19','09:15:00',10.6),('7643','2014-04-19','09:20:00',10.12),('7643','2014-04-19','09:25:00',11.7),('7643','2014-04-19','09:30:00',13.12),('7643','2014-04-19','09:35:00',10.14),('7643','2014-04-19','09:40:00',7.76),('7643','2014-04-19','09:45:00',5.39),('7643','2014-04-19','09:50:00',6.11),('7643','2014-04-19','09:55:00',7.15),('7643','2014-04-19','10:00:00',8.78),('7643','2014-04-19','10:05:00',10.95),('7643','2014-04-19','10:10:00',10.84),('7643','2014-04-19','10:15:00',12.51),('7643','2014-04-19','10:20:00',12.11),('7643','2014-04-19','10:25:00',10.78),('7643','2014-04-19','10:30:00',9.75),('7643','2014-04-19','10:35:00',10.69),('7643','2014-04-19','10:40:00',10.27),('7643','2014-04-19','10:45:00',10.78),('7643','2014-04-19','10:50:00',11.62),('7643','2014-04-19','10:55:00',11.52),('7643','2014-04-19','11:00:00',11.78),('7643','2014-04-19','11:05:00',13.46),('7643','2014-04-19','11:10:00',13.41),('7643','2014-04-19','11:15:00',15.78),('7643','2014-04-19','11:20:00',15.02),('7643','2014-04-19','11:25:00',7.31),('7643','2014-04-19','11:30:00',17.68),('7643','2014-04-19','11:35:00',13.37),('7643','2014-04-19','11:40:00',10.32),('7643','2014-04-19','11:45:00',14.19),('7643','2014-04-19','11:50:00',9.32),('7643','2014-04-19','11:55:00',6.74),('7643','2014-04-19','12:00:00',11.27),('7643','2014-04-19','12:05:00',14.52),('7643','2014-04-19','12:10:00',10.56),('7643','2014-04-19','12:15:00',6.24),('7643','2014-04-19','12:20:00',8.77),('7643','2014-04-19','12:25:00',19.28),('7643','2014-04-19','12:30:00',17.56),('7643','2014-04-19','12:35:00',16.97),('7643','2014-04-19','12:40:00',17.09),('7643','2014-04-19','12:45:00',17.07),('7643','2014-04-19','12:50:00',17.17),('7643','2014-04-19','12:55:00',17.23),('7643','2014-04-19','13:00:00',17.34),('7643','2014-04-19','13:05:00',17.36),('7643','2014-04-19','13:10:00',17.8),('7643','2014-04-19','13:15:00',17.7),('7643','2014-04-19','13:20:00',17.06),('7643','2014-04-19','13:25:00',16.96),('7643','2014-04-19','13:30:00',16.98),('7643','2014-04-19','13:35:00',17.06),('7643','2014-04-19','13:40:00',17.05),('7643','2014-04-19','13:45:00',17.01),('7643','2014-04-19','13:50:00',16.97),('7643','2014-04-19','13:55:00',16.87),('7643','2014-04-19','14:00:00',16.78),('7643','2014-04-19','14:05:00',16.84),('7643','2014-04-19','14:10:00',16.76),('7643','2014-04-19','14:15:00',17.26),('7643','2014-04-19','14:20:00',13.43),('7643','2014-04-19','14:25:00',12.86),('7643','2014-04-19','14:30:00',12.17),('7643','2014-04-19','14:35:00',9.63),('7643','2014-04-19','14:40:00',9.53),('7643','2014-04-19','14:45:00',10.28),('7643','2014-04-19','14:50:00',10.03),('7643','2014-04-19','14:55:00',11.22),('7643','2014-04-19','15:00:00',14.03),('7643','2014-04-19','15:05:00',13.85),('7643','2014-04-19','15:10:00',15.08),('7643','2014-04-19','15:15:00',14.97),('7643','2014-04-19','15:20:00',14.32),('7643','2014-04-19','15:25:00',14.45),('7643','2014-04-19','15:30:00',14.15),('7643','2014-04-19','15:35:00',13.69),('7643','2014-04-19','15:40:00',14.18),('7643','2014-04-19','15:45:00',12.57),('7643','2014-04-19','15:50:00',9.95),('7643','2014-04-19','15:55:00',13.54),('7643','2014-04-19','16:00:00',12.99),('7643','2014-04-19','16:05:00',12.76),('7643','2014-04-19','16:10:00',12.54),('7643','2014-04-19','16:15:00',12.39),('7643','2014-04-19','16:20:00',12.4),('7643','2014-04-19','16:25:00',10.25),('7643','2014-04-19','16:30:00',12.23),('7643','2014-04-19','16:35:00',11.07),('7643','2014-04-19','16:40:00',9.53),('7643','2014-04-19','16:45:00',8.95),('7643','2014-04-19','16:50:00',9.58),('7643','2014-04-19','16:55:00',10.44),('7643','2014-04-19','17:00:00',9.82),('7643','2014-04-19','17:05:00',9.33),('7643','2014-04-19','17:10:00',8.85),('7643','2014-04-19','17:15:00',8.4),('7643','2014-04-19','17:20:00',8.06),('7643','2014-04-19','17:25:00',7.69),('7643','2014-04-19','17:30:00',7.32),('7643','2014-04-19','17:35:00',6.91),('7643','2014-04-19','17:40:00',6.51),('7643','2014-04-19','17:45:00',6.11),('7643','2014-04-19','17:50:00',5.68),('7643','2014-04-19','17:55:00',5.32),('7643','2014-04-19','18:00:00',4.89),('7643','2014-04-19','18:05:00',4.48),('7643','2014-04-19','18:10:00',4.15),('7643','2014-04-19','18:15:00',3.68),('7643','2014-04-19','18:20:00',2.47),('7643','2014-04-19','18:25:00',1.7),('7643','2014-04-19','18:30:00',2.69),('7643','2014-04-19','18:35:00',2.6),('7643','2014-04-19','18:40:00',2.14),('7643','2014-04-19','18:45:00',1.37),('7643','2013-11-26','08:15:00',1.06),('7643','2013-11-26','08:20:00',1.23),('7643','2013-11-26','08:25:00',1.31),('7643','2013-11-26','08:30:00',1.5),('7643','2013-11-26','08:35:00',1.69),('7643','2013-11-26','08:40:00',1.98),('7643','2013-11-26','08:45:00',2.36),('7643','2013-11-26','08:50:00',2.83),('7643','2013-11-26','08:55:00',2.98),('7643','2013-11-26','09:00:00',2.67),('7643','2013-11-26','09:05:00',2.47),('7643','2013-11-26','09:10:00',2.33),('7643','2013-11-26','09:15:00',2.52),('7643','2013-11-26','09:20:00',3.87),('7643','2013-11-26','09:25:00',3.89),('7643','2013-11-26','09:30:00',3.65),('7643','2013-11-26','09:35:00',3.62),('7643','2013-11-26','09:40:00',4.52),('7643','2013-11-26','09:45:00',3.61),('7643','2013-11-26','09:50:00',3.91),('7643','2013-11-26','09:55:00',5.59),('7643','2013-11-26','10:00:00',4.68),('7643','2013-11-26','10:05:00',4.74),('7643','2013-11-26','10:10:00',4.57),('7643','2013-11-26','10:15:00',4.39),('7643','2013-11-26','10:20:00',4.21),('7643','2013-11-26','10:25:00',4.48),('7643','2013-11-26','10:30:00',4.07),('7643','2013-11-26','10:35:00',4.42),('7643','2013-11-26','10:40:00',5.21),('7643','2013-11-26','10:45:00',5.74),('7643','2013-11-26','10:50:00',5.3),('7643','2013-11-26','10:55:00',4.9),('7643','2013-11-26','11:00:00',5.32),('7643','2013-11-26','11:05:00',5.87),('7643','2013-11-26','11:10:00',8.8),('7643','2013-11-26','11:15:00',5.38),('7643','2013-11-26','11:20:00',5.25),('7643','2013-11-26','11:25:00',5.62),('7643','2013-11-26','11:30:00',9.68),('7643','2013-11-26','11:35:00',7.4),('7643','2013-11-26','11:40:00',6.4),('7643','2013-11-26','11:45:00',5.95),('7643','2013-11-26','11:50:00',9.01),('7643','2013-11-26','11:55:00',13),('7643','2013-11-26','12:00:00',12.36),('7643','2013-11-26','12:05:00',10.59),('7643','2013-11-26','12:10:00',5.08),('7643','2013-11-26','12:15:00',8.09),('7643','2013-11-26','12:20:00',8.45),('7643','2013-11-26','12:25:00',5.29),('7643','2013-11-26','12:30:00',10.1),('7643','2013-11-26','12:35:00',8.27),('7643','2013-11-26','12:40:00',4.61),('7643','2013-11-26','12:45:00',3.72),('7643','2013-11-26','12:50:00',3.7),('7643','2013-11-26','12:55:00',3.71),('7643','2013-11-26','13:00:00',3.81),('7643','2013-11-26','13:05:00',3.81),('7643','2013-11-26','13:10:00',3.78),('7643','2013-11-26','13:15:00',3.64),('7643','2013-11-26','13:20:00',3.51),('7643','2013-11-26','13:25:00',3.39),('7643','2013-11-26','13:30:00',3.51),('7643','2013-11-26','13:35:00',3.53),('7643','2013-11-26','13:40:00',3.89),('7643','2013-11-26','13:45:00',3.61),('7643','2013-11-26','13:50:00',2.8),('7643','2013-11-26','13:55:00',2.4),('7643','2013-11-26','14:00:00',2.51),('7643','2013-11-26','14:05:00',2.16),('7643','2013-11-26','14:10:00',1.83),('7643','2013-11-26','14:15:00',1.57),('7643','2013-11-26','14:20:00',1.54),('7643','2013-11-26','14:25:00',1.27),('7643','2013-11-26','14:35:00',1.02),('7643','2013-11-26','15:45:00',1.02),('7643','2013-11-25','08:00:00',2.52),('7643','2013-11-25','08:05:00',3.25),('7643','2013-11-25','08:10:00',3.54),('7643','2013-11-25','08:15:00',3.23),('7643','2013-11-25','08:20:00',2.62),('7643','2013-11-25','08:25:00',1.06),('7643','2013-11-25','08:30:00',1.36),('7643','2013-11-25','08:35:00',1.66),('7643','2013-11-25','08:40:00',1.84),('7643','2013-11-25','08:45:00',2.95),('7643','2013-11-25','08:50:00',2.91),('7643','2013-11-25','08:55:00',3.32),('7643','2013-11-25','09:00:00',3.35),('7643','2013-11-25','09:05:00',3.97),('7643','2013-11-25','09:10:00',4.84),('7643','2013-11-25','09:15:00',5.68),('7643','2013-11-25','09:20:00',5.03),('7643','2013-11-25','09:25:00',5.12),('7643','2013-11-25','09:30:00',4.7),('7643','2013-11-25','09:35:00',5.51),('7643','2013-11-25','09:40:00',8.02),('7643','2013-11-25','09:45:00',5.44),('7643','2013-11-25','09:50:00',5.77),('7643','2013-11-25','09:55:00',7.75),('7643','2013-11-25','10:00:00',8.89),('7643','2013-11-25','10:05:00',8.66),('7643','2013-11-25','10:10:00',5.29),('7643','2013-11-25','10:15:00',3.49),('7643','2013-11-25','10:20:00',3.11),('7643','2013-11-25','10:25:00',5.92),('7643','2013-11-25','10:30:00',9.85),('7643','2013-11-25','10:35:00',11.09),('7643','2013-11-25','10:40:00',10.99),('7643','2013-11-25','10:45:00',11.23),('7643','2013-11-25','10:50:00',11.22),('7643','2013-11-25','10:55:00',11.56),('7643','2013-11-25','11:00:00',12.24),('7643','2013-11-25','11:05:00',11.66),('7643','2013-11-25','11:10:00',12.72),('7643','2013-11-25','11:15:00',13.74),('7643','2013-11-25','11:20:00',13.25),('7643','2013-11-25','11:25:00',12.9),('7643','2013-11-25','11:30:00',13.15),('7643','2013-11-25','11:35:00',13.7),('7643','2013-11-25','11:40:00',13.04),('7643','2013-11-25','11:45:00',12.86),('7643','2013-11-25','11:50:00',12.17),('7643','2013-11-25','11:55:00',7.06),('7643','2013-11-25','12:00:00',4.2),('7643','2013-11-25','12:05:00',6.64),('7643','2013-11-25','12:10:00',2.99),('7643','2013-11-25','12:15:00',4.35),('7643','2013-11-25','12:20:00',11.94),('7643','2013-11-25','12:25:00',11.83),('7643','2013-11-25','12:30:00',11.48),('7643','2013-11-25','12:35:00',11.46),('7643','2013-11-25','12:40:00',11.47),('7643','2013-11-25','12:45:00',11.31),('7643','2013-11-25','12:50:00',11.29),('7643','2013-11-25','12:55:00',11.19),('7643','2013-11-25','13:00:00',11.12),('7643','2013-11-25','13:05:00',10.98),('7643','2013-11-25','13:10:00',10.84),('7643','2013-11-25','13:15:00',10.68),('7643','2013-11-25','13:20:00',10.51),('7643','2013-11-25','13:25:00',10.35),('7643','2013-11-25','13:30:00',10.17),('7643','2013-11-25','13:35:00',9.98),('7643','2013-11-25','13:40:00',9.85),('7643','2013-11-25','13:45:00',9.7),('7643','2013-11-25','13:50:00',9.76),('7643','2013-11-25','13:55:00',9.35),('7643','2013-11-25','14:00:00',9.55),('7643','2013-11-25','14:05:00',7.49),('7643','2013-11-25','14:10:00',10.94),('7643','2013-11-25','14:15:00',11.32),('7643','2013-11-25','14:20:00',9.43),('7643','2013-11-25','14:25:00',6.37),('7643','2013-11-25','14:30:00',5.08),('7643','2013-11-25','14:35:00',6.84),('7643','2013-11-25','14:40:00',7.1),('7643','2013-11-25','14:45:00',7.33),('7643','2013-11-25','14:50:00',7.78),('7643','2013-11-25','14:55:00',8.2),('7643','2013-11-25','15:00:00',7.7),('7643','2013-11-25','15:05:00',6.75),('7643','2013-11-25','15:10:00',5.65),('7643','2013-11-25','15:15:00',5.05),('7643','2013-11-25','15:20:00',4.59),('7643','2013-11-25','15:25:00',4.17),('7643','2013-11-25','15:30:00',3.73),('7643','2013-11-25','15:35:00',3.37),('7643','2013-11-25','15:40:00',2.97),('7643','2013-11-25','15:45:00',2.67),('7643','2013-11-25','15:50:00',2.5),('7643','2013-11-25','15:55:00',2.19),('7643','2013-11-25','16:00:00',1.26),('7643','2013-11-24','07:40:00',1.31),('7643','2013-11-24','07:45:00',1.78),('7643','2013-11-24','07:50:00',2.03),('7643','2013-11-24','07:55:00',2.33),('7643','2013-11-24','08:00:00',2.64),('7643','2013-11-24','08:05:00',2.96),('7643','2013-11-24','08:10:00',3.3),('7643','2013-11-24','08:15:00',3.64),('7643','2013-11-24','08:20:00',4.18),('7643','2013-11-24','08:25:00',4.71),('7643','2013-11-24','08:30:00',4.97),('7643','2013-11-24','08:35:00',5.38),('7643','2013-11-24','08:40:00',5.68),('7643','2013-11-24','08:45:00',6.18),('7643','2013-11-24','08:50:00',6.71),('7643','2013-11-24','08:55:00',7.35),('7643','2013-11-24','09:00:00',8.11),('7643','2013-11-24','09:05:00',8.38),('7643','2013-11-24','09:10:00',8.57),('7643','2013-11-24','09:15:00',9.03),('7643','2013-11-24','09:20:00',8.82),('7643','2013-11-24','09:25:00',6.09),('7643','2013-11-24','09:30:00',5.96),('7643','2013-11-24','09:35:00',10.05),('7643','2013-11-24','09:40:00',8.86),('7643','2013-11-24','09:45:00',5.48),('7643','2013-11-24','09:50:00',6.9),('7643','2013-11-24','09:55:00',6.16),('7643','2013-11-24','10:00:00',7.19),('7643','2013-11-24','10:05:00',5.87),('7643','2013-11-24','10:10:00',9.31),('7643','2013-11-24','10:15:00',10.21),('7643','2013-11-24','10:20:00',7.28),('7643','2013-11-24','10:25:00',8.14),('7643','2013-11-24','10:30:00',8.58),('7643','2013-11-24','10:35:00',8.02),('7643','2013-11-24','10:40:00',13.2),('7643','2013-11-24','10:45:00',11.57),('7643','2013-11-24','10:50:00',11.56),('7643','2013-11-24','10:55:00',6.72),('7643','2013-11-24','11:00:00',11.38),('7643','2013-11-24','11:05:00',11.84),('7643','2013-11-24','11:10:00',13.49),('7643','2013-11-24','11:15:00',10.95),('7643','2013-11-24','11:20:00',8.55),('7643','2013-11-24','11:25:00',5.2),('7643','2013-11-24','11:30:00',5.47),('7643','2013-11-24','11:35:00',5.15),('7643','2013-11-24','11:40:00',4.62),('7643','2013-11-24','11:45:00',5.19),('7643','2013-11-24','11:50:00',5.22),('7643','2013-11-24','11:55:00',6.11),('7643','2013-11-24','12:00:00',6.58),('7643','2013-11-24','12:05:00',6.73),('7643','2013-11-24','12:10:00',6.58),('7643','2013-11-24','12:15:00',6.49),('7643','2013-11-24','12:20:00',5.72),('7643','2013-11-24','12:25:00',5.71),('7643','2013-11-24','12:30:00',5.06),('7643','2013-11-24','12:35:00',4.6),('7643','2013-11-24','12:40:00',10.71),('7643','2013-11-24','12:45:00',11.78),('7643','2013-11-24','12:50:00',9.44),('7643','2013-11-24','12:55:00',10),('7643','2013-11-24','13:00:00',12.82),('7643','2013-11-24','13:05:00',13.48),('7643','2013-11-24','13:10:00',9.85),('7643','2013-11-24','13:15:00',9.66),('7643','2013-11-24','13:20:00',11.53),('7643','2013-11-24','13:25:00',7.77),('7643','2013-11-24','13:30:00',5.17),('7643','2013-11-24','13:35:00',3.81),('7643','2013-11-24','13:40:00',3.42),('7643','2013-11-24','13:45:00',3.55),('7643','2013-11-24','13:50:00',3.18),('7643','2013-11-24','13:55:00',2.55),('7643','2013-11-24','14:00:00',2.05),('7643','2013-11-24','14:05:00',1.58),('7643','2013-11-24','14:10:00',1.34),('7643','2013-11-24','14:15:00',1.15),('7643','2013-11-24','14:20:00',1.04),('7643','2013-11-24','14:50:00',1.08),('7643','2013-11-24','14:55:00',1.26),('7643','2013-11-24','15:00:00',1.28),('7643','2013-11-24','15:05:00',1.38),('7643','2013-11-24','15:10:00',1.29),('7643','2013-11-24','15:15:00',1.35),('7643','2013-11-24','15:20:00',1.51),('7643','2013-11-24','15:25:00',1.3),('7643','2013-11-23','09:40:00',1.12),('7643','2013-11-23','09:45:00',1.66),('7643','2013-11-23','09:50:00',2.8),('7643','2013-11-23','09:55:00',4.04),('7643','2013-11-23','10:00:00',4.97),('7643','2013-11-23','10:05:00',5.29),('7643','2013-11-23','10:10:00',5.42),('7643','2013-11-23','10:15:00',4.67),('7643','2013-11-23','10:20:00',4.39),('7643','2013-11-23','10:25:00',6.19),('7643','2013-11-23','10:30:00',5.51),('7643','2013-11-23','10:35:00',5.11),('7643','2013-11-23','10:40:00',4.24),('7643','2013-11-23','10:45:00',3.87),('7643','2013-11-23','10:50:00',3.95),('7643','2013-11-23','10:55:00',4.25),('7643','2013-11-23','11:00:00',4.32),('7643','2013-11-23','11:05:00',4.48),('7643','2013-11-23','11:10:00',4.76),('7643','2013-11-23','11:15:00',4.88),('7643','2013-11-23','11:20:00',5.81),('7643','2013-11-23','11:25:00',5.71),('7643','2013-11-23','11:30:00',5.09),('7643','2013-11-23','11:35:00',4.53),('7643','2013-11-23','11:40:00',4.86),('7643','2013-11-23','11:45:00',4.36),('7643','2013-11-23','11:50:00',4.72),('7643','2013-11-23','11:55:00',3.96),('7643','2013-11-23','12:00:00',2.98),('7643','2013-11-23','12:05:00',2.26),('7643','2013-11-23','12:10:00',2.18),('7643','2013-11-23','12:15:00',2.83),('7643','2013-11-23','12:20:00',3.17),('7643','2013-11-23','12:25:00',3.36),('7643','2013-11-23','12:30:00',3.25),('7643','2013-11-23','12:35:00',3.33),('7643','2013-11-23','12:40:00',3.39),('7643','2013-11-23','12:45:00',3.35),('7643','2013-11-23','12:50:00',3.37),('7643','2013-11-23','12:55:00',3.56),('7643','2013-11-23','13:00:00',4.05),('7643','2013-11-23','13:05:00',4.73),('7643','2013-11-23','13:10:00',5.55),('7643','2013-11-23','13:15:00',5.56),('7643','2013-11-23','13:20:00',4.23),('7643','2013-11-23','13:25:00',3.43),('7643','2013-11-23','13:30:00',2.99),('7643','2013-11-23','13:35:00',2.93),('7643','2013-11-23','13:40:00',2.72),('7643','2013-11-23','13:45:00',2.45),('7643','2013-11-23','13:50:00',2.22),('7643','2013-11-23','13:55:00',2.07),('7643','2013-11-23','14:00:00',2.17),('7643','2013-11-23','14:05:00',2.23),('7643','2013-11-23','14:10:00',2.14),('7643','2013-11-23','14:15:00',2.12),('7643','2013-11-23','14:20:00',2.15),('7643','2013-11-23','14:25:00',2.14),('7643','2013-11-23','14:30:00',2.03),('7643','2013-11-23','14:35:00',1.88),('7643','2013-11-23','14:40:00',1.83),('7643','2013-11-23','14:45:00',1.72),('7643','2013-11-23','14:50:00',1.59),('7643','2013-11-23','14:55:00',1.47),('7643','2013-11-23','15:00:00',1.39),('7643','2013-11-23','15:05:00',1.33),('7643','2013-11-23','15:10:00',1.25),('7643','2013-11-23','15:15:00',1.15),('7643','2013-11-23','15:20:00',1.06),('7643','2013-11-22','08:15:00',1.34),('7643','2013-11-22','08:20:00',2.03),('7643','2013-11-22','08:25:00',2.32),('7643','2013-11-22','08:30:00',1.79),('7643','2013-11-22','08:35:00',1.98),('7643','2013-11-22','08:40:00',2.42),('7643','2013-11-22','08:45:00',2.08),('7643','2013-11-22','08:50:00',1.49),('7643','2013-11-22','08:55:00',1.12),('7643','2013-11-22','09:50:00',1.12),('7643','2013-11-22','09:55:00',1.62),('7643','2013-11-22','10:00:00',2.03),('7643','2013-11-22','10:05:00',2.36),('7643','2013-11-22','10:10:00',2.55),('7643','2013-11-22','10:15:00',4.48),('7643','2013-11-22','10:20:00',4.67),('7643','2013-11-22','10:25:00',4.97),('7643','2013-11-22','10:30:00',6.7),('7643','2013-11-22','10:35:00',3.99),('7643','2013-11-22','10:40:00',11.44),('7643','2013-11-22','10:45:00',2.38),('7643','2013-11-22','11:10:00',1.09),('7643','2013-11-22','11:15:00',1.96),('7643','2013-11-22','11:20:00',2.22),('7643','2013-11-22','11:25:00',2.68),('7643','2013-11-22','11:30:00',2.47),('7643','2013-11-22','11:35:00',2.33),('7643','2013-11-22','11:40:00',2.69),('7643','2013-11-22','11:45:00',2.53),('7643','2013-11-22','11:50:00',1.82),('7643','2013-11-22','11:55:00',1.02),('7643','2013-11-22','13:15:00',1.84),('7643','2013-11-22','13:20:00',3.08),('7643','2013-11-22','13:25:00',5.48),('7643','2013-11-22','13:30:00',3.73),('7643','2013-11-22','13:35:00',4.72),('7643','2013-11-22','13:40:00',4.46),('7643','2013-11-22','13:45:00',3.56),('7643','2013-11-22','13:50:00',3.62),('7643','2013-11-22','13:55:00',3.54),('7643','2013-11-22','14:00:00',4.25),('7643','2013-11-22','14:05:00',5.81),('7643','2013-11-22','14:10:00',2.23),('7643','2013-11-22','14:15:00',1.11),('7643','2013-11-22','14:45:00',1.51),('7643','2013-11-22','14:50:00',2.42),('7643','2013-11-22','14:55:00',2.82),('7643','2013-11-22','15:00:00',2.43),('7643','2013-11-22','15:05:00',2.12),('7643','2013-11-22','15:10:00',1.69),('7643','2013-11-22','15:15:00',1.98),('7643','2013-11-22','15:20:00',1.93),('7643','2013-11-22','15:25:00',1.1),('7643','2013-11-22','16:15:00',1.59),('7643','2013-11-22','16:20:00',1.01),('7643','2013-11-21','09:10:00',1.11),('7643','2013-11-21','09:15:00',1.43),('7643','2013-11-21','09:20:00',2),('7643','2013-11-21','09:25:00',1.82),('7643','2013-11-21','09:30:00',1.75),('7643','2013-11-21','09:35:00',1.75),('7643','2013-11-21','09:40:00',1.36),('7643','2013-11-21','09:45:00',1.44),('7643','2013-11-21','09:50:00',1.18),('7643','2013-11-21','09:55:00',1.21),('7643','2013-11-21','10:00:00',1.99),('7643','2013-11-21','10:05:00',1.77),('7643','2013-11-21','10:10:00',1.47),('7643','2013-11-21','11:45:00',1.19),('7643','2013-11-21','12:20:00',1.19),('7643','2013-11-21','13:10:00',1.34),('7643','2013-11-21','13:15:00',1.08),('7643','2013-11-20','08:00:00',1.13),('7643','2013-11-20','08:05:00',1.76),('7643','2013-11-20','08:10:00',3.92),('7643','2013-11-20','08:15:00',4.35),('7643','2013-11-20','08:20:00',2.52),('7643','2013-11-20','08:50:00',1),('7643','2013-11-20','08:55:00',1.18),('7643','2013-11-20','09:05:00',1.88),('7643','2013-11-20','09:10:00',3.4),('7643','2013-11-20','09:15:00',3.93),('7643','2013-11-20','09:20:00',4.81),('7643','2013-11-20','09:25:00',4.09),('7643','2013-11-20','09:30:00',4.52),('7643','2013-11-20','09:35:00',3.45),('7643','2013-11-20','09:40:00',5.56),('7643','2013-11-20','09:45:00',8.68),('7643','2013-11-20','09:50:00',6.7),('7643','2013-11-20','09:55:00',6.81),('7643','2013-11-20','10:00:00',7.86),('7643','2013-11-20','10:05:00',9.88),('7643','2013-11-20','10:10:00',8.48),('7643','2013-11-20','10:15:00',9.11),('7643','2013-11-20','10:20:00',9.5),('7643','2013-11-20','10:25:00',6.2),('7643','2013-11-20','10:30:00',7.18),('7643','2013-11-20','10:35:00',8.85),('7643','2013-11-20','10:40:00',9.27),('7643','2013-11-20','10:45:00',8.94),('7643','2013-11-20','10:50:00',2.43),('7643','2013-11-20','10:55:00',2.09),('7643','2013-11-20','11:00:00',2.46),('7643','2013-11-20','11:05:00',2.49),('7643','2013-11-20','11:10:00',2.8),('7643','2013-11-20','11:15:00',3.32),('7643','2013-11-20','11:20:00',5.32),('7643','2013-11-20','11:25:00',7.47),('7643','2013-11-20','11:30:00',7.95),('7643','2013-11-20','11:35:00',9.87),('7643','2013-11-20','11:40:00',10.51),('7643','2013-11-20','11:45:00',3.24),('7643','2013-11-20','11:50:00',11.04),('7643','2013-11-20','11:55:00',9.01),('7643','2013-11-20','12:00:00',8.01),('7643','2013-11-20','12:05:00',9.06),('7643','2013-11-20','12:10:00',10.84),('7643','2013-11-20','12:15:00',10.71),('7643','2013-11-20','12:20:00',10.76),('7643','2013-11-20','12:25:00',11),('7643','2013-11-20','12:30:00',11.61),('7643','2013-11-20','12:35:00',11.6),('7643','2013-11-20','12:40:00',12.01),('7643','2013-11-20','12:45:00',11.97),('7643','2013-11-20','12:50:00',10.35),('7643','2013-11-20','12:55:00',12.17),('7643','2013-11-20','13:00:00',11.78),('7643','2013-11-20','13:05:00',11.77),('7643','2013-11-20','13:10:00',11.01),('7643','2013-11-20','13:15:00',11.26),('7643','2013-11-20','13:20:00',10.66),('7643','2013-11-20','13:25:00',9.55),('7643','2013-11-20','13:30:00',4.97),('7643','2013-11-20','13:35:00',3.69),('7643','2013-11-20','13:40:00',8),('7643','2013-11-20','13:45:00',9.41),('7643','2013-11-20','13:50:00',4.76),('7643','2013-11-20','13:55:00',4.72),('7643','2013-11-20','14:00:00',9.08),('7643','2013-11-20','14:05:00',7.55),('7643','2013-11-20','14:10:00',4.99),('7643','2013-11-20','14:15:00',2.77),('7643','2013-11-20','14:20:00',1.92),('7643','2013-11-20','14:25:00',3.9),('7643','2013-11-20','14:30:00',1.93),('7643','2013-11-20','14:35:00',1.15),('7643','2013-11-20','14:40:00',3.85),('7643','2013-11-20','14:45:00',5.6),('7643','2013-11-20','14:50:00',5.24),('7643','2013-11-20','14:55:00',3.7),('7643','2013-11-20','15:00:00',4.84),('7643','2013-11-20','15:05:00',4.5),('7643','2013-11-20','15:10:00',4.18),('7643','2013-11-20','15:15:00',3.79),('7643','2013-11-20','15:20:00',3.38),('7643','2013-11-20','15:25:00',3.26),('7643','2013-11-20','15:30:00',1.94),('7643','2013-11-20','15:35:00',1.26),('7643','2013-11-20','15:55:00',1.07),('7643','2013-11-19','08:15:00',1.69),('7643','2013-11-19','08:20:00',4.48),('7643','2013-11-19','08:50:00',1.52),('7643','2013-11-19','08:55:00',3.64),('7643','2013-11-19','09:00:00',4.38),('7643','2013-11-19','09:05:00',1.06),('7643','2013-11-19','09:10:00',1.41),('7643','2013-11-19','09:15:00',6.38),('7643','2013-11-19','09:20:00',6.47),('7643','2013-11-19','09:25:00',6.95),('7643','2013-11-19','09:30:00',8.23),('7643','2013-11-19','09:35:00',4.51),('7643','2013-11-19','09:40:00',2.94),('7643','2013-11-19','09:45:00',1.11),('7643','2013-11-19','09:50:00',1.52),('7643','2013-11-19','09:55:00',2.01),('7643','2013-11-19','10:00:00',5.1),('7643','2013-11-19','10:05:00',3.79),('7643','2013-11-19','10:10:00',3.92),('7643','2013-11-19','10:15:00',7.46),('7643','2013-11-19','10:20:00',2.44),('7643','2013-11-19','10:25:00',2.65),('7643','2013-11-19','10:30:00',3.29),('7643','2013-11-19','10:35:00',2.69),('7643','2013-11-19','10:40:00',2.45),('7643','2013-11-19','10:45:00',1.88),('7643','2013-11-19','10:50:00',2.7),('7643','2013-11-19','10:55:00',2.9),('7643','2013-11-19','11:00:00',2.55),('7643','2013-11-19','11:05:00',2.48),('7643','2013-11-19','11:10:00',2.3),('7643','2013-11-19','11:15:00',2.14),('7643','2013-11-19','11:20:00',3.24),('7643','2013-11-19','11:25:00',3.92),('7643','2013-11-19','11:30:00',3.95),('7643','2013-11-19','11:35:00',3.27),('7643','2013-11-19','11:40:00',3.25),('7643','2013-11-19','11:45:00',11.72),('7643','2013-11-19','11:50:00',13.77),('7643','2013-11-19','11:55:00',8.26),('7643','2013-11-19','12:00:00',4.54),('7643','2013-11-19','12:05:00',1.83),('7643','2013-11-19','12:10:00',1.86),('7643','2013-11-19','12:15:00',3.24),('7643','2013-11-19','12:20:00',5.86),('7643','2013-11-19','12:25:00',3.83),('7643','2013-11-19','12:30:00',3),('7643','2013-11-19','12:35:00',2.42),('7643','2013-11-19','12:40:00',4.49),('7643','2013-11-19','12:45:00',4.38),('7643','2013-11-19','12:50:00',8.13),('7643','2013-11-19','12:55:00',10.04),('7643','2013-11-19','13:00:00',10.92),('7643','2013-11-19','13:05:00',7.19),('7643','2013-11-19','13:10:00',5.13),('7643','2013-11-19','13:15:00',2.44),('7643','2013-11-19','13:20:00',6.52),('7643','2013-11-19','13:25:00',5.59),('7643','2013-11-19','13:30:00',4.73),('7643','2013-11-19','13:35:00',2.01),('7643','2013-11-19','13:40:00',6.52),('7643','2013-11-19','13:45:00',4.24),('7643','2013-11-19','13:50:00',5.23),('7643','2013-11-19','13:55:00',4.67),('7643','2013-11-19','14:00:00',3.32),('7643','2013-11-19','14:05:00',3.43),('7643','2013-11-19','14:10:00',2.92),('7643','2013-11-19','14:15:00',2.5),('7643','2013-11-19','14:20:00',2.87),('7643','2013-11-19','14:25:00',4.11),('7643','2013-11-19','14:30:00',3.57),('7643','2013-11-19','14:35:00',2.74),('7643','2013-11-19','14:40:00',4.2),('7643','2013-11-19','14:45:00',5.6),('7643','2013-11-19','14:50:00',1.64),('7643','2013-11-19','14:55:00',1.1),('7643','2013-11-19','15:00:00',1.19),('7643','2013-11-19','15:05:00',4.02),('7643','2013-11-19','15:10:00',4.87),('7643','2013-11-19','15:15:00',3.53),('7643','2013-11-19','15:20:00',3.46),('7643','2013-11-19','15:25:00',3.31),('7643','2013-11-19','15:30:00',1.68),('7643','2013-11-19','15:35:00',2.09),('7643','2013-11-19','15:40:00',1.34),('7643','2013-11-18','07:50:00',1.2),('7643','2013-11-18','07:55:00',1.19),('7643','2013-11-18','08:10:00',1.3),('7643','2013-11-18','08:25:00',1.18),('7643','2013-11-18','08:30:00',1.81),('7643','2013-11-18','08:35:00',1.36),('7643','2013-11-18','08:55:00',1.15),('7643','2013-11-18','09:00:00',1.82),('7643','2013-11-18','09:05:00',1.79),('7643','2013-11-18','09:10:00',1.61),('7643','2013-11-18','09:15:00',1.57),('7643','2013-11-18','09:20:00',1.09),('7643','2013-11-18','09:30:00',1.55),('7643','2013-11-18','09:35:00',4.08),('7643','2013-11-18','09:40:00',8.1),('7643','2013-11-18','09:45:00',7.79),('7643','2013-11-18','09:50:00',4.58),('7643','2013-11-18','09:55:00',2.58),('7643','2013-11-18','10:00:00',5.24),('7643','2013-11-18','10:05:00',6.03),('7643','2013-11-18','10:10:00',1.92),('7643','2013-11-18','10:15:00',1.59),('7643','2013-11-18','10:20:00',2.34),('7643','2013-11-18','10:25:00',2.18),('7643','2013-11-18','10:30:00',1.49),('7643','2013-11-18','10:45:00',3.28),('7643','2013-11-18','10:50:00',5.69),('7643','2013-11-18','10:55:00',3.36),('7643','2013-11-18','11:00:00',1.88),('7643','2013-11-18','11:05:00',2.47),('7643','2013-11-18','11:10:00',3.29),('7643','2013-11-18','11:15:00',2.92),('7643','2013-11-18','11:20:00',9.54),('7643','2013-11-18','11:25:00',8.86),('7643','2013-11-18','11:30:00',10.41),('7643','2013-11-18','11:35:00',10.43),('7643','2013-11-18','11:40:00',9.04),('7643','2013-11-18','11:45:00',9.98),('7643','2013-11-18','11:50:00',9.68),('7643','2013-11-18','11:55:00',9.92),('7643','2013-11-18','12:00:00',7.8),('7643','2013-11-18','12:05:00',9.19),('7643','2013-11-18','12:10:00',9.5),('7643','2013-11-18','12:15:00',9.78),('7643','2013-11-18','12:20:00',5.11),('7643','2013-11-18','12:25:00',2.36),('7643','2013-11-18','12:30:00',5.73),('7643','2013-11-18','12:35:00',2.06),('7643','2013-11-18','12:40:00',2.23),('7643','2013-11-18','12:45:00',7.37),('7643','2013-11-18','12:50:00',5.84),('7643','2013-11-18','12:55:00',10.97),('7643','2013-11-18','13:00:00',9.5),('7643','2013-11-18','13:05:00',3.07),('7643','2013-11-18','13:10:00',6.84),('7643','2013-11-18','13:15:00',7.42),('7643','2013-11-18','13:20:00',9.28),('7643','2013-11-18','13:25:00',4.22),('7643','2013-11-18','13:30:00',2.43),('7643','2013-11-18','13:35:00',1.71),('7643','2013-11-18','14:25:00',1.32),('7643','2013-11-18','14:30:00',1.85),('7643','2013-11-18','14:35:00',1.76),('7643','2013-11-18','14:40:00',2.08),('7643','2013-11-18','14:45:00',2.15),('7643','2013-11-18','14:50:00',2.11),('7643','2013-11-18','14:55:00',2.33),('7643','2013-11-18','15:00:00',1.32),('7643','2013-11-18','15:15:00',1.06),('7643','2013-11-18','15:20:00',1.59),('7643','2013-11-18','15:25:00',4.63),('7643','2013-11-18','15:30:00',5.79),('7643','2013-11-18','15:35:00',4.29),('7643','2013-11-18','15:40:00',3.44),('7643','2013-11-18','15:45:00',2.93),('7643','2013-11-18','15:50:00',2.32),('7643','2013-11-18','15:55:00',1.7),('7643','2013-11-18','16:00:00',1.25),('7643','2013-11-17','07:35:00',1.36),('7643','2013-11-17','07:40:00',1.39),('7643','2013-11-17','07:45:00',1.26),('7643','2013-11-17','07:50:00',1.56),('7643','2013-11-17','07:55:00',2.25),('7643','2013-11-17','08:00:00',3.11),('7643','2013-11-17','08:05:00',3.22),('7643','2013-11-17','08:10:00',3.31),('7643','2013-11-17','08:15:00',3.46),('7643','2013-11-17','08:20:00',3.6),('7643','2013-11-17','08:25:00',3.86),('7643','2013-11-17','08:30:00',4.39),('7643','2013-11-17','08:35:00',4.24),('7643','2013-11-17','08:40:00',4.11),('7643','2013-11-17','08:45:00',3.94),('7643','2013-11-17','08:50:00',3.5),('7643','2013-11-17','08:55:00',3.47),('7643','2013-11-17','09:00:00',3.49),('7643','2013-11-17','09:05:00',3.17),('7643','2013-11-17','09:10:00',3.05),('7643','2013-11-17','09:15:00',4.61),('7643','2013-11-17','09:20:00',6.06),('7643','2013-11-17','09:25:00',6.35),('7643','2013-11-17','09:30:00',5.67),('7643','2013-11-17','09:35:00',7.62),('7643','2013-11-17','09:40:00',5.92),('7643','2013-11-17','09:45:00',5.06),('7643','2013-11-17','09:50:00',3.95),('7643','2013-11-17','09:55:00',4),('7643','2013-11-17','10:00:00',4.55),('7643','2013-11-17','10:05:00',5.11),('7643','2013-11-17','10:10:00',5.57),('7643','2013-11-17','10:15:00',6.77),('7643','2013-11-17','10:20:00',5.5),('7643','2013-11-17','10:25:00',5.01),('7643','2013-11-17','10:30:00',4.49),('7643','2013-11-17','10:35:00',4.34),('7643','2013-11-17','10:40:00',4.52),('7643','2013-11-17','10:45:00',4.7),('7643','2013-11-17','10:50:00',4.45),('7643','2013-11-17','10:55:00',3.9),('7643','2013-11-17','11:00:00',3.49),('7643','2013-11-17','11:05:00',3.18),('7643','2013-11-17','11:10:00',2.89),('7643','2013-11-17','11:15:00',2.68),('7643','2013-11-17','11:20:00',2.85),('7643','2013-11-17','11:25:00',3.34),('7643','2013-11-17','11:30:00',3.79),('7643','2013-11-17','11:35:00',4.02),('7643','2013-11-17','11:40:00',4.18),('7643','2013-11-17','11:45:00',4.32),('7643','2013-11-17','11:50:00',4.53),('7643','2013-11-17','11:55:00',4.9),('7643','2013-11-17','12:00:00',5.17),('7643','2013-11-17','12:05:00',5.46),('7643','2013-11-17','12:10:00',5.45),('7643','2013-11-17','12:15:00',5.61),('7643','2013-11-17','12:20:00',5.94),('7643','2013-11-17','12:25:00',6.28),('7643','2013-11-17','12:30:00',5.32),('7643','2013-11-17','12:35:00',4.55),('7643','2013-11-17','12:40:00',3.98),('7643','2013-11-17','12:45:00',3.56),('7643','2013-11-17','12:50:00',3.29),('7643','2013-11-17','12:55:00',3.17),('7643','2013-11-17','13:00:00',3.14),('7643','2013-11-17','13:05:00',3.38),('7643','2013-11-17','13:10:00',3.92),('7643','2013-11-17','13:15:00',3.68),('7643','2013-11-17','13:20:00',3.41),('7643','2013-11-17','13:25:00',3.03),('7643','2013-11-17','13:30:00',3.39),('7643','2013-11-17','13:35:00',4.16),('7643','2013-11-17','13:40:00',4.3),('7643','2013-11-17','13:45:00',3.85),('7643','2013-11-17','13:50:00',3.72),('7643','2013-11-17','13:55:00',3.13),('7643','2013-11-17','14:00:00',2.64),('7643','2013-11-17','14:05:00',2.12),('7643','2013-11-17','14:10:00',1.81),('7643','2013-11-17','14:15:00',1.54),('7643','2013-11-17','14:20:00',1.52),('7643','2013-11-17','14:25:00',1.77),('7643','2013-11-17','14:30:00',1.74),('7643','2013-11-17','14:35:00',1.6),('7643','2013-11-17','14:40:00',1.56),('7643','2013-11-17','14:45:00',1.58),('7643','2013-11-17','14:50:00',1.57),('7643','2013-11-17','14:55:00',1.43),('7643','2013-11-17','15:00:00',1.12),('7643','2013-11-17','15:05:00',1.14),('7643','2013-11-17','15:10:00',1.26),('7643','2013-11-17','15:15:00',1.28),('7643','2013-11-17','15:20:00',1.26),('7643','2013-11-17','15:25:00',1.04),('7643','2014-04-18','07:15:00',1.44),('7643','2014-04-18','07:20:00',1.9),('7643','2014-04-18','07:25:00',2.35),('7643','2014-04-18','07:30:00',2.93),('7643','2014-04-18','07:35:00',3.45),('7643','2014-04-18','07:40:00',4.09),('7643','2014-04-18','07:45:00',2.57),('7643','2014-04-18','07:50:00',2.89),('7643','2014-04-18','07:55:00',6.07),('7643','2014-04-18','08:00:00',6.28),('7643','2014-04-18','08:05:00',4.11),('7643','2014-04-18','08:10:00',4.92),('7643','2014-04-18','08:15:00',3.96),('7643','2014-04-18','08:20:00',4.26),('7643','2014-04-18','08:25:00',5.75),('7643','2014-04-18','08:30:00',8.06),('7643','2014-04-18','08:35:00',9.23),('7643','2014-04-18','08:40:00',7.28),('7643','2014-04-18','08:45:00',7.8),('7643','2014-04-18','08:50:00',5.87),('7643','2014-04-18','08:55:00',4.09),('7643','2014-04-18','09:00:00',2.54),('7643','2014-04-18','09:05:00',2.17),('7643','2014-04-18','09:10:00',2.52),('7643','2014-04-18','09:15:00',3.18),('7643','2014-04-18','09:20:00',3.77),('7643','2014-04-18','09:25:00',5.16),('7643','2014-04-18','09:30:00',7.98),('7643','2014-04-18','09:35:00',7.94),('7643','2014-04-18','09:40:00',4.8),('7643','2014-04-18','09:45:00',3.54),('7643','2014-04-18','09:50:00',3.02),('7643','2014-04-18','09:55:00',2.8),('7643','2014-04-18','10:00:00',2.98),('7643','2014-04-18','10:05:00',2.49),('7643','2014-04-18','10:10:00',2.24),('7643','2014-04-18','10:15:00',2.52),('7643','2014-04-18','10:20:00',3.18),('7643','2014-04-18','10:25:00',2.94),('7643','2014-04-18','10:30:00',2.86),('7643','2014-04-18','10:35:00',3.38),('7643','2014-04-18','10:40:00',4.62),('7643','2014-04-18','10:45:00',4.43),('7643','2014-04-18','10:50:00',4.47),('7643','2014-04-18','10:55:00',5.66),('7643','2014-04-18','11:00:00',6.13),('7643','2014-04-18','11:05:00',4.97),('7643','2014-04-18','11:10:00',4.55),('7643','2014-04-18','11:15:00',6.73),('7643','2014-04-18','11:20:00',11.29),('7643','2014-04-18','11:25:00',10.21),('7643','2014-04-18','11:30:00',10.73),('7643','2014-04-18','11:35:00',9.16),('7643','2014-04-18','11:40:00',8.3),('7643','2014-04-18','11:45:00',9.14),('7643','2014-04-18','11:50:00',7.25),('7643','2014-04-18','11:55:00',4.13),('7643','2014-04-18','12:00:00',3.17),('7643','2014-04-18','12:05:00',2.57),('7643','2014-04-18','12:10:00',1.98),('7643','2014-04-18','12:15:00',1.59),('7643','2014-04-18','12:20:00',1.55),('7643','2014-04-18','12:25:00',1.24),('7643','2014-04-18','12:35:00',1.29),('7643','2014-04-18','12:40:00',1.29),('7643','2014-04-18','12:45:00',1.12),('7643','2014-04-18','13:00:00',1.19),('7643','2014-04-18','13:05:00',1.69),('7643','2014-04-18','13:10:00',1.85),('7643','2014-04-18','13:15:00',5.49),('7643','2014-04-18','13:20:00',3.97),('7643','2014-04-18','13:25:00',1.83),('7643','2014-04-18','13:30:00',1.21),('7643','2014-04-18','13:35:00',2.5),('7643','2014-04-18','13:40:00',2.54),('7643','2014-04-18','13:45:00',2.03),('7643','2014-04-18','13:50:00',3.16),('7643','2014-04-18','13:55:00',2.43),('7643','2014-04-18','14:10:00',1.26),('7643','2014-04-18','14:15:00',1.8),('7643','2014-04-18','14:20:00',2.07),('7643','2014-04-18','14:25:00',2.34),('7643','2014-04-18','14:30:00',4.84),('7643','2014-04-18','14:35:00',5.77),('7643','2014-04-18','14:40:00',6.76),('7643','2014-04-18','14:45:00',7.26),('7643','2014-04-18','14:50:00',5.21),('7643','2014-04-18','14:55:00',4.28),('7643','2014-04-18','15:00:00',5.47),('7643','2014-04-18','15:05:00',4.66),('7643','2014-04-18','15:10:00',2.33),('7643','2014-04-18','15:15:00',1),('7643','2014-04-18','15:20:00',2.55),('7643','2014-04-18','15:25:00',4.06),('7643','2014-04-18','15:30:00',4.26),('7643','2014-04-18','15:35:00',2.63),('7643','2014-04-18','15:40:00',1.72),('7643','2014-04-18','15:45:00',3.27),('7643','2014-04-18','15:50:00',13.14),('7643','2014-04-18','15:55:00',11.9),('7643','2014-04-18','16:00:00',6.64),('7643','2014-04-18','16:05:00',6.42),('7643','2014-04-18','16:10:00',6.15),('7643','2014-04-18','16:15:00',6.53),('7643','2014-04-18','16:20:00',8.33),('7643','2014-04-18','16:25:00',8.25),('7643','2014-04-18','16:30:00',11.23),('7643','2014-04-18','16:35:00',6.19),('7643','2014-04-18','16:40:00',4.25),('7643','2014-04-18','16:45:00',3.55),('7643','2014-04-18','16:50:00',2.88),('7643','2014-04-18','16:55:00',1.92),('7643','2014-04-18','17:00:00',2.05),('7643','2014-04-18','17:05:00',2.97),('7643','2014-04-18','17:10:00',3.58),('7643','2014-04-18','17:15:00',3.76),('7643','2014-04-18','17:20:00',6.16),('7643','2014-04-18','17:25:00',5.34),('7643','2014-04-18','17:30:00',4.58),('7643','2014-04-18','17:35:00',3.67),('7643','2014-04-18','17:40:00',2.27),('7643','2014-04-18','17:45:00',1.77),('7643','2014-04-18','17:50:00',1.69),('7643','2014-04-18','17:55:00',1.58),('7643','2014-04-18','18:00:00',1.23),('7643','2014-04-18','18:05:00',1.08),('7643','2013-11-16','08:20:00',1.11),('7643','2013-11-16','08:25:00',1.35),('7643','2013-11-16','08:30:00',1.52),('7643','2013-11-16','08:35:00',1.72),('7643','2013-11-16','08:40:00',2),('7643','2013-11-16','08:45:00',6.21),('7643','2013-11-16','08:50:00',7.11),('7643','2013-11-16','08:55:00',7.71),('7643','2013-11-16','09:00:00',6.26),('7643','2013-11-16','09:05:00',6.63),('7643','2013-11-16','09:10:00',6.78),('7643','2013-11-16','09:15:00',7.26),('7643','2013-11-16','09:20:00',7.35),('7643','2013-11-16','09:25:00',7.55),('7643','2013-11-16','09:30:00',7.68),('7643','2013-11-16','09:35:00',7.74),('7643','2013-11-16','09:40:00',7.92),('7643','2013-11-16','09:45:00',8.06),('7643','2013-11-16','09:50:00',8.24),('7643','2013-11-16','09:55:00',8.4),('7643','2013-11-16','10:00:00',8.6),('7643','2013-11-16','10:05:00',8.77),('7643','2013-11-16','10:10:00',8.94),('7643','2013-11-16','10:15:00',9.1),('7643','2013-11-16','10:20:00',9.21),('7643','2013-11-16','10:25:00',9.33),('7643','2013-11-16','10:30:00',9.45),('7643','2013-11-16','10:35:00',9.54),('7643','2013-11-16','10:40:00',9.63),('7643','2013-11-16','10:45:00',9.72),('7643','2013-11-16','10:50:00',9.76),('7643','2013-11-16','10:55:00',9.79),('7643','2013-11-16','11:00:00',9.89),('7643','2013-11-16','11:05:00',9.93),('7643','2013-11-16','11:10:00',9.99),('7643','2013-11-16','11:15:00',10.03),('7643','2013-11-16','11:20:00',10.01),('7643','2013-11-16','11:25:00',10.04),('7643','2013-11-16','11:30:00',10.08),('7643','2013-11-16','11:35:00',10.09),('7643','2013-11-16','11:40:00',10.1),('7643','2013-11-16','11:45:00',10.12),('7643','2013-11-16','11:50:00',10.11),('7643','2013-11-16','11:55:00',10.07),('7643','2013-11-16','12:00:00',10.03),('7643','2013-11-16','12:05:00',9.99),('7643','2013-11-16','12:10:00',9.95),('7643','2013-11-16','12:15:00',9.92),('7643','2013-11-16','12:20:00',9.94),('7643','2013-11-16','12:25:00',9.93),('7643','2013-11-16','12:30:00',9.9),('7643','2013-11-16','12:35:00',9.86),('7643','2013-11-16','12:40:00',9.72),('7643','2013-11-16','12:45:00',9.64),('7643','2013-11-16','12:50:00',9.52),('7643','2013-11-16','12:55:00',9.41),('7643','2013-11-16','13:00:00',9.24),('7643','2013-11-16','13:05:00',9.12),('7643','2013-11-16','13:10:00',9),('7643','2013-11-16','13:15:00',8.85),('7643','2013-11-16','13:20:00',8.79),('7643','2013-11-16','13:25:00',7.25),('7643','2013-11-16','13:30:00',4.05),('7643','2013-11-16','13:35:00',5.55),('7643','2013-11-16','13:40:00',4.51),('7643','2013-11-16','13:45:00',1.9),('7643','2013-11-16','13:50:00',1.99),('7643','2013-11-16','13:55:00',4.34),('7643','2013-11-16','14:00:00',4.6),('7643','2013-11-16','14:05:00',5.89),('7643','2013-11-16','14:10:00',7.08),('7643','2013-11-16','14:15:00',6.86),('7643','2013-11-16','14:20:00',6.58),('7643','2013-11-16','14:25:00',6.16),('7643','2013-11-16','14:30:00',5.64),('7643','2013-11-16','14:35:00',5.52),('7643','2013-11-16','14:40:00',4.74),('7643','2013-11-16','14:45:00',1.69),('7643','2013-11-16','14:50:00',2.64),('7643','2013-11-16','14:55:00',1.35),('7643','2013-11-16','15:00:00',1.34),('7643','2013-11-16','15:05:00',1.14),('7643','2013-11-16','15:20:00',1.14),('7643','2013-11-16','15:25:00',1.38),('7643','2013-11-16','15:30:00',3.07),('7643','2013-11-16','15:35:00',2.78),('7643','2013-11-16','15:40:00',2.46),('7643','2013-11-16','15:45:00',2.19),('7643','2013-11-16','15:50:00',1.92),('7643','2013-11-16','15:55:00',1.84),('7643','2013-11-16','16:00:00',1.53),('7643','2013-11-15','09:40:00',1.09),('7643','2013-11-15','09:45:00',1.11),('7643','2013-11-15','09:50:00',1.29),('7643','2013-11-15','09:55:00',1.09),('7643','2013-11-15','10:40:00',1.19),('7643','2013-11-15','10:45:00',1.22),('7643','2013-11-15','10:50:00',1.01),('7643','2013-11-15','11:05:00',1.37),('7643','2013-11-15','11:10:00',1.5),('7643','2013-11-15','11:15:00',1.29),('7643','2013-11-15','12:35:00',1.12),('7643','2013-11-15','12:40:00',1.41),('7643','2013-11-15','12:45:00',1.76),('7643','2013-11-15','12:50:00',2.12),('7643','2013-11-15','12:55:00',2.29),('7643','2013-11-15','13:00:00',2.51),('7643','2013-11-15','13:05:00',3.1),('7643','2013-11-15','13:10:00',2.72),('7643','2013-11-15','13:15:00',2.2),('7643','2013-11-15','13:20:00',1.95),('7643','2013-11-15','13:25:00',1.96),('7643','2013-11-15','13:30:00',1.81),('7643','2013-11-15','13:35:00',1.52),('7643','2013-11-15','13:40:00',1.47),('7643','2013-11-15','13:45:00',1.66),('7643','2013-11-15','13:50:00',1.81),('7643','2013-11-15','13:55:00',1.85),('7643','2013-11-15','14:00:00',1.71),('7643','2013-11-15','14:05:00',1.54),('7643','2013-11-15','14:10:00',1.32),('7643','2013-11-15','14:15:00',1.13),('7643','2013-11-15','14:20:00',1.1),('7643','2013-11-15','14:25:00',1.21),('7643','2013-11-15','14:30:00',1.27),('7643','2013-11-15','14:35:00',1.35),('7643','2013-11-15','14:40:00',1.35),('7643','2013-11-15','14:45:00',1.12),('7643','2013-11-14','07:45:00',1.38),('7643','2013-11-14','07:50:00',1.34),('7643','2013-11-14','07:55:00',1.24),('7643','2013-11-14','08:00:00',1.08),('7643','2013-11-14','08:05:00',2.04),('7643','2013-11-14','08:10:00',2.79),('7643','2013-11-14','08:15:00',3.39),('7643','2013-11-14','08:20:00',3.06),('7643','2013-11-14','08:25:00',1.34),('7643','2013-11-14','08:30:00',1.3),('7643','2013-11-14','08:35:00',1.51),('7643','2013-11-14','08:40:00',1.78),('7643','2013-11-14','08:45:00',2.11),('7643','2013-11-14','08:50:00',2.3),('7643','2013-11-14','08:55:00',2.58),('7643','2013-11-14','09:00:00',2.83),('7643','2013-11-14','09:05:00',3.28),('7643','2013-11-14','09:10:00',3.86),('7643','2013-11-14','09:15:00',3.98),('7643','2013-11-14','09:20:00',3.02),('7643','2013-11-14','09:25:00',3.14),('7643','2013-11-14','09:30:00',3.98),('7643','2013-11-14','09:35:00',4.08),('7643','2013-11-14','09:40:00',3.36),('7643','2013-11-14','09:45:00',2.27),('7643','2013-11-14','09:50:00',1.78),('7643','2013-11-14','09:55:00',1.74),('7643','2013-11-14','10:00:00',2.05),('7643','2013-11-14','10:05:00',2.44),('7643','2013-11-14','10:10:00',3.57),('7643','2013-11-14','10:15:00',4.7),('7643','2013-11-14','10:20:00',4.42),('7643','2013-11-14','10:25:00',3.46),('7643','2013-11-14','10:30:00',3.1),('7643','2013-11-14','10:35:00',2.95),('7643','2013-11-14','10:40:00',2.63),('7643','2013-11-14','10:45:00',2.93),('7643','2013-11-14','10:50:00',5.21),('7643','2013-11-14','10:55:00',6.8),('7643','2013-11-14','11:00:00',5.12),('7643','2013-11-14','11:05:00',4.5),('7643','2013-11-14','11:10:00',4.32),('7643','2013-11-14','11:15:00',5.21),('7643','2013-11-14','11:20:00',6.82),('7643','2013-11-14','11:25:00',9.69),('7643','2013-11-14','11:30:00',6.18),('7643','2013-11-14','11:35:00',7.27),('7643','2013-11-14','11:40:00',6.89),('7643','2013-11-14','11:45:00',5.72),('7643','2013-11-14','11:50:00',4.91),('7643','2013-11-14','11:55:00',4.55),('7643','2013-11-14','12:00:00',5),('7643','2013-11-14','12:05:00',4.58),('7643','2013-11-14','12:10:00',4.49),('7643','2013-11-14','12:15:00',4.29),('7643','2013-11-14','12:20:00',5.57),('7643','2013-11-14','12:25:00',7.06),('7643','2013-11-14','12:30:00',5.35),('7643','2013-11-14','12:35:00',4.78),('7643','2013-11-14','12:40:00',4.38),('7643','2013-11-14','12:45:00',4.37),('7643','2013-11-14','12:50:00',5.8),('7643','2013-11-14','12:55:00',5.49),('7643','2013-11-14','13:00:00',5.44),('7643','2013-11-14','13:05:00',4.79),('7643','2013-11-14','13:10:00',4.63),('7643','2013-11-14','13:15:00',3.27),('7643','2013-11-14','13:20:00',3.18),('7643','2013-11-14','13:25:00',3.59),('7643','2013-11-14','13:30:00',4.27),('7643','2013-11-14','13:35:00',4.39),('7643','2013-11-14','13:40:00',5.13),('7643','2013-11-14','13:45:00',6.8),('7643','2013-11-14','13:50:00',7.21),('7643','2013-11-14','13:55:00',4.07),('7643','2013-11-14','14:00:00',4.55),('7643','2013-11-14','14:05:00',3.54),('7643','2013-11-14','14:10:00',2.96),('7643','2013-11-14','14:15:00',2.35),('7643','2013-11-14','14:20:00',1.74),('7643','2013-11-14','14:25:00',1.43),('7643','2013-11-14','14:30:00',1.36),('7643','2013-11-14','14:35:00',1.31),('7643','2013-11-14','14:40:00',1.22),('7643','2013-11-14','14:45:00',1.16),('7643','2013-11-14','14:50:00',1.08),('7643','2013-11-14','14:55:00',1.07),('7643','2013-11-14','15:00:00',1.08),('7643','2013-11-14','15:05:00',1.03),('7643','2013-11-13','08:05:00',1.24),('7643','2013-11-13','08:10:00',1.46),('7643','2013-11-13','08:15:00',2.98),('7643','2013-11-13','08:20:00',4.07),('7643','2013-11-13','08:25:00',4.19),('7643','2013-11-13','08:30:00',2.63),('7643','2013-11-13','08:35:00',2.96),('7643','2013-11-13','08:40:00',3.74),('7643','2013-11-13','08:45:00',2.18),('7643','2013-11-13','08:50:00',3.12),('7643','2013-11-13','08:55:00',4.33),('7643','2013-11-13','09:00:00',5.07),('7643','2013-11-13','09:05:00',7.27),('7643','2013-11-13','09:10:00',6.65),('7643','2013-11-13','09:15:00',7.2),('7643','2013-11-13','09:20:00',7.35),('7643','2013-11-13','09:25:00',7.32),('7643','2013-11-13','09:30:00',7.62),('7643','2013-11-13','09:35:00',7.78),('7643','2013-11-13','09:40:00',7.93),('7643','2013-11-13','09:45:00',8.01),('7643','2013-11-13','09:50:00',1.8),('7643','2013-11-13','09:55:00',2.44),('7643','2013-11-13','10:00:00',3.01),('7643','2013-11-13','10:05:00',6.21),('7643','2013-11-13','10:10:00',2.61),('7643','2013-11-13','10:15:00',8.91),('7643','2013-11-13','10:20:00',9.45),('7643','2013-11-13','10:25:00',9.44),('7643','2013-11-13','10:30:00',9.44),('7643','2013-11-13','10:35:00',9.38),('7643','2013-11-13','10:40:00',9.44),('7643','2013-11-13','10:45:00',9.65),('7643','2013-11-13','10:50:00',9.64),('7643','2013-11-13','10:55:00',9.8),('7643','2013-11-13','11:00:00',9.76),('7643','2013-11-13','11:05:00',10.06),('7643','2013-11-13','11:10:00',10.3),('7643','2013-11-13','11:15:00',10.57),('7643','2013-11-13','11:20:00',10.68),('7643','2013-11-13','11:25:00',10.78),('7643','2013-11-13','11:30:00',10.79),('7643','2013-11-13','11:35:00',10.38),('7643','2013-11-13','11:40:00',9.44),('7643','2013-11-13','11:45:00',6.63),('7643','2013-11-13','11:50:00',6.71),('7643','2013-11-13','11:55:00',5.86),('7643','2013-11-13','12:00:00',12.07),('7643','2013-11-13','12:05:00',7.61),('7643','2013-11-13','12:10:00',4.84),('7643','2013-11-13','12:15:00',5.12),('7643','2013-11-13','12:20:00',4.86),('7643','2013-11-13','12:25:00',4.17),('7643','2013-11-13','12:30:00',3.97),('7643','2013-11-13','12:35:00',4.12),('7643','2013-11-13','12:40:00',3.95),('7643','2013-11-13','12:45:00',4.07),('7643','2013-11-13','12:50:00',4.29),('7643','2013-11-13','12:55:00',4.12),('7643','2013-11-13','13:00:00',4.05),('7643','2013-11-13','13:05:00',3.58),('7643','2013-11-13','13:10:00',3.24),('7643','2013-11-13','13:15:00',3.31),('7643','2013-11-13','13:20:00',3.32),('7643','2013-11-13','13:25:00',3.13),('7643','2013-11-13','13:30:00',3.33),('7643','2013-11-13','13:35:00',3.13),('7643','2013-11-13','13:40:00',2.85),('7643','2013-11-13','13:45:00',2.67),('7643','2013-11-13','13:50:00',2.59),('7643','2013-11-13','13:55:00',2.71),('7643','2013-11-13','14:00:00',2.68),('7643','2013-11-13','14:05:00',3),('7643','2013-11-13','14:10:00',2.78),('7643','2013-11-13','14:15:00',2.56),('7643','2013-11-13','14:20:00',2.5),('7643','2013-11-13','14:25:00',2.36),('7643','2013-11-13','14:30:00',2.27),('7643','2013-11-13','14:35:00',2.04),('7643','2013-11-13','14:40:00',1.82),('7643','2013-11-13','14:45:00',1.66),('7643','2013-11-13','14:50:00',1.53),('7643','2013-11-13','14:55:00',1.53),('7643','2013-11-13','15:00:00',1.55),('7643','2013-11-13','15:05:00',1.64),('7643','2013-11-13','15:10:00',1.52),('7643','2013-11-13','15:15:00',1.39),('7643','2013-11-13','15:20:00',1.31),('7643','2013-11-13','15:35:00',1.17),('7643','2013-11-13','15:40:00',1.12),('7643','2013-11-13','15:45:00',1.04),('7643','2013-11-12','08:05:00',1.19),('7643','2013-11-12','08:10:00',1.52),('7643','2013-11-12','08:15:00',1.93),('7643','2013-11-12','08:20:00',2.17),('7643','2013-11-12','08:25:00',2.16),('7643','2013-11-12','08:30:00',2.8),('7643','2013-11-12','08:35:00',2.78),('7643','2013-11-12','08:40:00',1.53),('7643','2013-11-12','08:45:00',1.27),('7643','2013-11-12','08:50:00',1.18),('7643','2013-11-12','08:55:00',1.15),('7643','2013-11-12','09:50:00',1.1),('7643','2013-11-12','09:55:00',1.99),('7643','2013-11-12','10:00:00',4.38),('7643','2013-11-12','10:05:00',3.74),('7643','2013-11-12','10:10:00',3.74),('7643','2013-11-12','10:15:00',3.62),('7643','2013-11-12','10:20:00',8.81),('7643','2013-11-12','10:25:00',11.09),('7643','2013-11-12','10:30:00',10.71),('7643','2013-11-12','10:35:00',13.52),('7643','2013-11-12','10:40:00',8.6),('7643','2013-11-12','10:45:00',11.1),('7643','2013-11-12','10:50:00',13.33),('7643','2013-11-12','10:55:00',12.15),('7643','2013-11-12','11:00:00',10.37),('7643','2013-11-12','11:05:00',3.43),('7643','2013-11-12','11:10:00',3.4),('7643','2013-11-12','11:15:00',3.66),('7643','2013-11-12','11:20:00',3.57),('7643','2013-11-12','11:25:00',3.85),('7643','2013-11-12','11:30:00',5.87),('7643','2013-11-12','11:35:00',5.03),('7643','2013-11-12','11:40:00',3.47),('7643','2013-11-12','11:45:00',4.1),('7643','2013-11-12','11:50:00',4.49),('7643','2013-11-12','11:55:00',3.87),('7643','2013-11-12','12:00:00',2.77),('7643','2013-11-12','12:05:00',2.6),('7643','2013-11-12','12:10:00',2.86),('7643','2013-11-12','12:15:00',3.13),('7643','2013-11-12','12:20:00',2.8),('7643','2013-11-12','12:25:00',2.58),('7643','2013-11-12','12:30:00',2.15),('7643','2013-11-12','12:35:00',2.35),('7643','2013-11-12','12:40:00',2.65),('7643','2013-11-12','12:45:00',2.34),('7643','2013-11-12','12:50:00',2.39),('7643','2013-11-12','12:55:00',3.51),('7643','2013-11-12','13:00:00',4.13),('7643','2013-11-12','13:05:00',5.08),('7643','2013-11-12','13:10:00',4.51),('7643','2013-11-12','13:15:00',4.06),('7643','2013-11-12','13:20:00',3.1),('7643','2013-11-12','13:25:00',2.65),('7643','2013-11-12','13:30:00',2.79),('7643','2013-11-12','13:35:00',3.13),('7643','2013-11-12','13:40:00',3.67),('7643','2013-11-12','13:45:00',3.38),('7643','2013-11-12','13:50:00',3.28),('7643','2013-11-12','13:55:00',6.55),('7643','2013-11-12','14:00:00',7.03),('7643','2013-11-12','14:05:00',6.88),('7643','2013-11-12','14:10:00',6.12),('7643','2013-11-12','14:15:00',6.55),('7643','2013-11-12','14:20:00',5.85),('7643','2013-11-12','14:25:00',6.12),('7643','2013-11-12','14:30:00',5.55),('7643','2013-11-12','14:35:00',4.08),('7643','2013-11-12','14:40:00',3.35),('7643','2013-11-12','14:45:00',2.99),('7643','2013-11-12','14:50:00',2.77),('7643','2013-11-12','14:55:00',1.61),('7643','2013-11-12','15:00:00',2.35),('7643','2013-11-12','15:05:00',2.03),('7643','2013-11-12','15:10:00',1.13),('7643','2013-11-12','15:15:00',1.24),('7643','2013-11-12','15:20:00',1.18),('7643','2013-11-12','15:25:00',1.16),('7643','2013-11-12','15:30:00',1.06),('7643','2013-11-12','15:35:00',1.06),('7643','2013-11-12','15:40:00',1.18),('7643','2013-11-12','15:45:00',1.09),('7643','2013-11-11','09:05:00',1.18),('7643','2013-11-11','09:10:00',1.64),('7643','2013-11-11','09:15:00',1.68),('7643','2013-11-11','09:20:00',1.25),('7643','2013-11-11','09:25:00',1.45),('7643','2013-11-11','09:30:00',1.68),('7643','2013-11-11','09:35:00',1.73),('7643','2013-11-11','09:40:00',1.49),('7643','2013-11-11','09:45:00',1.23),('7643','2013-11-11','09:50:00',1.16),('7643','2013-11-11','09:55:00',1.46),('7643','2013-11-11','10:00:00',2.81),('7643','2013-11-11','10:05:00',2.15),('7643','2013-11-11','10:20:00',1.13),('7643','2013-11-11','10:25:00',1.26),('7643','2013-11-11','10:30:00',1.2),('7643','2013-11-11','10:35:00',1.23),('7643','2013-11-11','10:40:00',1.51),('7643','2013-11-11','10:45:00',1.82),('7643','2013-11-11','10:50:00',2.12),('7643','2013-11-11','10:55:00',2.38),('7643','2013-11-11','11:00:00',2.59),('7643','2013-11-11','11:05:00',2.38),('7643','2013-11-11','11:10:00',2.94),('7643','2013-11-11','11:15:00',2.93),('7643','2013-11-11','11:20:00',2.91),('7643','2013-11-11','11:25:00',5.43),('7643','2013-11-11','11:30:00',3.19),('7643','2013-11-11','11:35:00',4.29),('7643','2013-11-11','11:40:00',9.87),('7643','2013-11-11','11:45:00',5.91),('7643','2013-11-11','11:50:00',7.22),('7643','2013-11-11','11:55:00',3.86),('7643','2013-11-11','12:00:00',10.41),('7643','2013-11-11','12:05:00',5.02),('7643','2013-11-11','12:10:00',2.78),('7643','2013-11-11','12:15:00',2.83),('7643','2013-11-11','12:20:00',3.1),('7643','2013-11-11','12:25:00',4.12),('7643','2013-11-11','12:30:00',14.82),('7643','2013-11-11','12:35:00',12.28),('7643','2013-11-11','12:40:00',7.45),('7643','2013-11-11','12:45:00',7.12),('7643','2013-11-11','12:50:00',6.65),('7643','2013-11-11','12:55:00',7.2),('7643','2013-11-11','13:00:00',6.68),('7643','2013-11-11','13:05:00',7.15),('7643','2013-11-11','13:10:00',12.56),('7643','2013-11-11','13:15:00',10.23),('7643','2013-11-11','13:20:00',8.22),('7643','2013-11-11','13:25:00',8.52),('7643','2013-11-11','13:30:00',6.51),('7643','2013-11-11','13:35:00',7.44),('7643','2013-11-11','13:40:00',8.97),('7643','2013-11-11','13:45:00',6.71),('7643','2013-11-11','13:50:00',5.43),('7643','2013-11-11','13:55:00',5.2),('7643','2013-11-11','14:00:00',4.92),('7643','2013-11-11','14:05:00',3.91),('7643','2013-11-11','14:10:00',7.14),('7643','2013-11-11','14:15:00',10.11),('7643','2013-11-11','14:20:00',9.89),('7643','2013-11-11','14:25:00',7.98),('7643','2013-11-11','14:30:00',7.96),('7643','2013-11-11','14:35:00',3.39),('7643','2013-11-11','14:40:00',7.03),('7643','2013-11-11','14:45:00',5.95),('7643','2013-11-11','14:50:00',5.9),('7643','2013-11-11','14:55:00',4.59),('7643','2013-11-11','15:00:00',2.91),('7643','2013-11-11','15:05:00',1.97),('7643','2013-11-11','15:10:00',1.88),('7643','2013-11-11','15:15:00',3.42),('7643','2013-11-11','15:20:00',1.86),('7643','2013-11-11','15:25:00',1.16),('7643','2013-11-10','09:15:00',1.17),('7643','2013-11-10','09:25:00',1.31),('7643','2013-11-10','09:31:00',1.59),('7643','2013-11-10','09:35:00',1.34),('7643','2013-11-10','09:40:00',1.28),('7643','2013-11-10','09:45:00',2.61),('7643','2013-11-10','09:50:00',4.67),('7643','2013-11-10','09:55:00',4.32),('7643','2013-11-10','10:00:00',2.98),('7643','2013-11-10','10:05:00',3.31),('7643','2013-11-10','10:10:00',4.55),('7643','2013-11-10','10:15:00',7.31),('7643','2013-11-10','10:20:00',10.25),('7643','2013-11-10','10:25:00',4.57),('7643','2013-11-10','10:31:00',2.6),('7643','2013-11-10','10:35:00',3.16),('7643','2013-11-10','10:40:00',2.12),('7643','2013-11-10','10:45:00',1.76),('7643','2013-11-10','10:50:00',1.79),('7643','2013-11-10','10:55:00',1.95),('7643','2013-11-10','11:00:00',2.94),('7643','2013-11-10','11:05:00',5.14),('7643','2013-11-10','11:10:00',12.02),('7643','2013-11-10','11:15:00',7.1),('7643','2013-11-10','11:20:00',5.89),('7643','2013-11-10','11:25:00',12.04),('7643','2013-11-10','11:31:00',8.49),('7643','2013-11-10','11:35:00',14.08),('7643','2013-11-10','11:40:00',15.11),('7643','2013-11-10','11:45:00',13.42),('7643','2013-11-10','11:50:00',13.52),('7643','2013-11-10','11:55:00',12.52),('7643','2013-11-10','12:00:00',11.93),('7643','2013-11-10','12:05:00',11.64),('7643','2013-11-10','12:10:00',11.17),('7643','2013-11-10','12:15:00',10.7),('7643','2013-11-10','12:20:00',11.89),('7643','2013-11-10','12:25:00',10.39),('7643','2013-11-10','12:31:00',7.64),('7643','2013-11-10','12:35:00',5.19),('7643','2013-11-10','12:40:00',7.95),('7643','2013-11-10','12:45:00',3.27),('7643','2013-11-10','12:50:00',3.09),('7643','2013-11-10','12:55:00',2.88),('7643','2013-11-10','13:00:00',5.19),('7643','2013-11-10','13:05:00',4.34),('7643','2013-11-10','13:10:00',10.84),('7643','2013-11-10','13:15:00',2.57),('7643','2013-11-10','13:20:00',1.22),('7643','2013-11-10','13:25:00',1.76),('7643','2013-11-10','13:31:00',2.7),('7643','2013-11-10','13:35:00',5.33),('7643','2013-11-10','13:40:00',6.39),('7643','2013-11-10','13:45:00',2.47),('7643','2013-11-10','13:50:00',2.66),('7643','2013-11-10','13:55:00',3.03),('7643','2013-11-10','14:00:00',4.17),('7643','2013-11-10','14:05:00',2.9),('7643','2013-11-10','14:10:00',3.46),('7643','2013-11-10','14:15:00',3.82),('7643','2013-11-10','14:20:00',7.25),('7643','2013-11-10','14:25:00',8.17),('7643','2013-11-10','14:30:00',7.52),('7643','2013-11-10','14:35:00',7.25),('7643','2013-11-10','14:40:00',6.06),('7643','2013-11-10','14:45:00',3.29),('7643','2013-11-10','14:50:00',1.99),('7643','2013-11-10','14:55:00',2.15),('7643','2013-11-10','15:00:00',1.77),('7643','2013-11-10','15:05:00',1.46),('7643','2013-11-10','15:10:00',1.02),('7643','2013-11-09','07:25:00',1.11),('7643','2013-11-09','07:30:00',1.6),('7643','2013-11-09','07:35:00',2.39),('7643','2013-11-09','07:40:00',2.84),('7643','2013-11-09','07:45:00',3.33),('7643','2013-11-09','07:50:00',4.02),('7643','2013-11-09','07:55:00',4.1),('7643','2013-11-09','08:00:00',4.21),('7643','2013-11-09','08:05:00',2.77),('7643','2013-11-09','08:10:00',2.27),('7643','2013-11-09','08:15:00',2.7),('7643','2013-11-09','08:20:00',3.02),('7643','2013-11-09','08:25:00',2.69),('7643','2013-11-09','08:30:00',3.67),('7643','2013-11-09','08:35:00',3.47),('7643','2013-11-09','08:40:00',4.94),('7643','2013-11-09','08:45:00',6.32),('7643','2013-11-09','08:50:00',5.97),('7643','2013-11-09','08:55:00',6.99),('7643','2013-11-09','09:00:00',5.87),('7643','2013-11-09','09:05:00',4.88),('7643','2013-11-09','09:10:00',3.77),('7643','2013-11-09','09:15:00',5.7),('7643','2013-11-09','09:20:00',7.1),('7643','2013-11-09','09:25:00',8.1),('7643','2013-11-09','09:30:00',6.83),('7643','2013-11-09','09:35:00',7.01),('7643','2013-11-09','09:40:00',7.62),('7643','2013-11-09','09:45:00',8.37),('7643','2013-11-09','09:50:00',8.74),('7643','2013-11-09','09:55:00',8.57),('7643','2013-11-09','10:00:00',7.92),('7643','2013-11-09','10:05:00',9.06),('7643','2013-11-09','10:10:00',9.57),('7643','2013-11-09','10:15:00',10.07),('7643','2013-11-09','10:20:00',9.16),('7643','2013-11-09','10:25:00',10.61),('7643','2013-11-09','10:30:00',11.44),('7643','2013-11-09','10:35:00',9.66),('7643','2013-11-09','10:40:00',6.8),('7643','2013-11-09','10:45:00',11.16),('7643','2013-11-09','10:50:00',10.48),('7643','2013-11-09','10:55:00',12.25),('7643','2013-11-09','11:00:00',7.54),('7643','2013-11-09','11:05:00',5.04),('7643','2013-11-09','11:10:00',3.91),('7643','2013-11-09','11:15:00',2.31),('7643','2013-11-09','11:20:00',2.94),('7643','2013-11-09','11:25:00',6.64),('7643','2013-11-09','11:30:00',3.37),('7643','2013-11-09','11:35:00',3.73),('7643','2013-11-09','11:40:00',8.25),('7643','2013-11-09','11:45:00',9.17),('7643','2013-11-09','11:50:00',6.18),('7643','2013-11-09','11:55:00',5.16),('7643','2013-11-09','12:00:00',4.22),('7643','2013-11-09','12:05:00',3.88),('7643','2013-11-09','12:10:00',5.66),('7643','2013-11-09','12:15:00',11.36),('7643','2013-11-09','12:20:00',8.87),('7643','2013-11-09','12:25:00',10.64),('7643','2013-11-09','12:30:00',6.89),('7643','2013-11-09','12:35:00',7.33),('7643','2013-11-09','12:40:00',11.34),('7643','2013-11-09','12:45:00',12.16),('7643','2013-11-09','12:50:00',13.07),('7643','2013-11-09','12:55:00',8.32),('7643','2013-11-09','13:00:00',5.14),('7643','2013-11-09','13:05:00',2.61),('7643','2013-11-09','13:10:00',2.9),('7643','2013-11-09','13:15:00',1.95),('7643','2013-11-09','13:20:00',1.43),('7643','2013-11-09','13:30:00',1.29),('7643','2013-11-09','13:35:00',2.95),('7643','2013-11-09','13:40:00',2.47),('7643','2013-11-09','13:45:00',4.52),('7643','2013-11-09','13:50:00',6.71),('7643','2013-11-09','13:55:00',7.78),('7643','2013-11-09','14:00:00',1.83),('7643','2013-11-09','14:05:00',1.63),('7643','2013-11-09','14:10:00',1.06),('7643','2013-11-09','14:15:00',1.17),('7643','2013-11-09','14:20:00',2.15),('7643','2013-11-09','14:25:00',2.13),('7643','2013-11-09','14:30:00',3.09),('7643','2013-11-09','14:35:00',2.25),('7643','2013-11-09','14:45:00',1.09),('7643','2013-11-09','14:50:00',1.39),('7643','2013-11-09','15:00:00',1.17),('7643','2013-11-09','15:05:00',1.63),('7643','2013-11-09','15:10:00',1.39),('7643','2013-11-09','15:30:00',1.33),('7643','2013-11-09','15:35:00',1.24),('7643','2013-11-09','15:40:00',1.18),('7643','2013-11-08','07:40:00',1.11),('7643','2013-11-08','07:45:00',1.02),('7643','2013-11-08','07:50:00',1.05),('7643','2013-11-08','08:35:00',1.09),('7643','2013-11-08','09:00:00',1.07),('7643','2013-11-08','09:05:00',1.07),('7643','2013-11-08','09:10:00',2.69),('7643','2013-11-08','09:15:00',3.37),('7643','2013-11-08','09:20:00',2.75),('7643','2013-11-08','09:25:00',1.23),('7643','2013-11-08','09:30:00',3.2),('7643','2013-11-08','09:35:00',2.93),('7643','2013-11-08','09:40:00',6.85),('7643','2013-11-08','09:45:00',6.19),('7643','2013-11-08','09:50:00',6.86),('7643','2013-11-08','09:55:00',10.46),('7643','2013-11-08','10:00:00',10.02),('7643','2013-11-08','10:05:00',9.93),('7643','2013-11-08','10:10:00',9.39),('7643','2013-11-08','10:15:00',8.82),('7643','2013-11-08','10:20:00',9.29),('7643','2013-11-08','10:25:00',8.41),('7643','2013-11-08','10:30:00',4.02),('7643','2013-11-08','10:35:00',4.8),('7643','2013-11-08','10:40:00',4.79),('7643','2013-11-08','10:45:00',5.26),('7643','2013-11-08','10:50:00',5.94),('7643','2013-11-08','10:55:00',6.95),('7643','2013-11-08','11:00:00',9.38),('7643','2013-11-08','11:05:00',12.62),('7643','2013-11-08','11:10:00',12.13),('7643','2013-11-08','11:15:00',11.09),('7643','2013-11-08','11:20:00',7.31),('7643','2013-11-08','11:25:00',5.19),('7643','2013-11-08','11:30:00',10.09),('7643','2013-11-08','11:35:00',9.4),('7643','2013-11-08','11:40:00',5.1),('7643','2013-11-08','11:45:00',6.55),('7643','2013-11-08','11:50:00',4.57),('7643','2013-11-08','11:55:00',9.94),('7643','2013-11-08','12:00:00',10.04),('7643','2013-11-08','12:05:00',11.57),('7643','2013-11-08','12:10:00',4.23),('7643','2013-11-08','12:15:00',7.41),('7643','2013-11-08','12:20:00',4.2),('7643','2013-11-08','12:25:00',6.46),('7643','2013-11-08','12:30:00',8.07),('7643','2013-11-08','12:35:00',12.34),('7643','2013-11-08','12:40:00',7.32),('7643','2013-11-08','12:45:00',4.34),('7643','2013-11-08','12:50:00',7.73),('7643','2013-11-08','12:55:00',10.34),('7643','2013-11-08','13:00:00',11.49),('7643','2013-11-08','13:05:00',9.22),('7643','2013-11-08','13:10:00',11.25),('7643','2013-11-08','13:15:00',10.95),('7643','2013-11-08','13:20:00',6.42),('7643','2013-11-08','13:25:00',8.22),('7643','2013-11-08','13:30:00',9.87),('7643','2013-11-08','13:35:00',9.64),('7643','2013-11-08','13:40:00',8.88),('7643','2013-11-08','13:45:00',8.72),('7643','2013-11-08','13:50:00',8.72),('7643','2013-11-08','13:55:00',8.62),('7643','2013-11-08','14:00:00',7.91),('7643','2013-11-08','14:05:00',7.37),('7643','2013-11-08','14:10:00',5.15),('7643','2013-11-08','14:15:00',4.51),('7643','2013-11-08','14:20:00',7.99),('7643','2013-11-08','14:25:00',5.56),('7643','2013-11-08','14:30:00',1.93),('7643','2013-11-08','14:35:00',4.21),('7643','2013-11-08','14:40:00',5.03),('7643','2013-11-08','14:45:00',5.21),('7643','2013-11-08','14:50:00',5.55),('7643','2013-11-08','14:55:00',2.31),('7643','2013-11-08','15:00:00',1.2),('7643','2013-11-08','15:05:00',1.29),('7643','2013-11-08','15:10:00',1.29),('7643','2013-11-08','15:15:00',1.19),('7643','2013-11-08','15:20:00',1.19),('7643','2013-11-08','15:30:00',2.4),('7643','2013-11-08','15:35:00',4.1),('7643','2013-11-08','15:40:00',1.61),('7643','2013-11-08','15:45:00',2.59),('7643','2013-11-08','15:50:00',2.11),('7643','2013-11-08','15:55:00',1.08),('7643','2013-11-08','16:00:00',1.32),('7643','2013-11-07','07:55:00',1.08),('7643','2013-11-07','08:00:00',1.01),('7643','2013-11-07','08:25:00',1.04),('7643','2013-11-07','08:45:00',1.55),('7643','2013-11-07','08:50:00',1.59),('7643','2013-11-07','08:55:00',1.26),('7643','2013-11-07','09:00:00',2.08),('7643','2013-11-07','09:05:00',3.46),('7643','2013-11-07','09:10:00',4.93),('7643','2013-11-07','09:15:00',4.21),('7643','2013-11-07','09:20:00',3.13),('7643','2013-11-07','09:25:00',3.72),('7643','2013-11-07','09:30:00',5.6),('7643','2013-11-07','09:35:00',6.15),('7643','2013-11-07','09:40:00',5.94),('7643','2013-11-07','09:45:00',4.65),('7643','2013-11-07','09:50:00',8.75),('7643','2013-11-07','09:55:00',4.79),('7643','2013-11-07','10:00:00',4.8),('7643','2013-11-07','10:05:00',5.41),('7643','2013-11-07','10:10:00',8.89),('7643','2013-11-07','10:15:00',7.22),('7643','2013-11-07','10:20:00',1.6),('7643','2013-11-07','10:25:00',2.02),('7643','2013-11-07','10:30:00',1.8),('7643','2013-11-07','10:35:00',1.12),('7643','2013-11-07','10:40:00',2.62),('7643','2013-11-07','10:45:00',2.52),('7643','2013-11-07','10:50:00',2.72),('7643','2013-11-07','10:55:00',8.26),('7643','2013-11-07','11:00:00',5.95),('7643','2013-11-07','11:05:00',3.73),('7643','2013-11-07','11:10:00',2.27),('7643','2013-11-07','11:15:00',2.18),('7643','2013-11-07','11:20:00',2.38),('7643','2013-11-07','11:25:00',2.19),('7643','2013-11-07','11:30:00',6.84),('7643','2013-11-07','11:35:00',3.72),('7643','2013-11-07','11:40:00',8.05),('7643','2013-11-07','11:45:00',8.64),('7643','2013-11-07','11:50:00',10.75),('7643','2013-11-07','11:55:00',12.21),('7643','2013-11-07','12:00:00',11.49),('7643','2013-11-07','12:05:00',10.69),('7643','2013-11-07','12:10:00',10.65),('7643','2013-11-07','12:15:00',7.35),('7643','2013-11-07','12:20:00',1.42),('7643','2013-11-07','12:25:00',5.15),('7643','2013-11-07','12:30:00',2.2),('7643','2013-11-07','12:35:00',9.4),('7643','2013-11-07','12:40:00',11.58),('7643','2013-11-07','12:45:00',11.29),('7643','2013-11-07','12:50:00',11.47),('7643','2013-11-07','12:55:00',11.4),('7643','2013-11-07','13:00:00',10.72),('7643','2013-11-07','13:05:00',10.3),('7643','2013-11-07','13:10:00',10.54),('7643','2013-11-07','13:15:00',7.48),('7643','2013-11-07','13:20:00',4.97),('7643','2013-11-07','13:25:00',5.23),('7643','2013-11-07','13:30:00',2.87),('7643','2013-11-07','13:35:00',6.86),('7643','2013-11-07','13:40:00',9.44),('7643','2013-11-07','13:45:00',8.96),('7643','2013-11-07','13:50:00',8.32),('7643','2013-11-07','13:55:00',8.58),('7643','2013-11-07','14:00:00',8.25),('7643','2013-11-07','14:05:00',8.01),('7643','2013-11-07','14:10:00',7.77),('7643','2013-11-07','14:15:00',7.57),('7643','2013-11-07','14:20:00',7.2),('7643','2013-11-07','14:25:00',7.04),('7643','2013-11-07','14:30:00',6.95),('7643','2013-11-07','14:35:00',6.82),('7643','2013-11-07','14:40:00',6.42),('7643','2013-11-07','14:45:00',6.16),('7643','2013-11-07','14:50:00',5.9),('7643','2013-11-07','14:55:00',4.8),('7643','2013-11-07','15:00:00',4.8),('7643','2013-11-07','15:05:00',4.96),('7643','2013-11-07','15:10:00',4.81),('7643','2013-11-07','15:15:00',4.49),('7643','2013-11-07','15:20:00',4.09),('7643','2013-11-07','15:25:00',2.27),('7643','2013-11-07','15:30:00',2.49),('7643','2013-11-07','15:35:00',1.02),('7643','2013-11-07','15:55:00',1.71),('7643','2013-11-07','16:00:00',1.37),('7643','2013-11-07','16:05:00',1.39),('7643','2013-11-07','16:10:00',1.19),('7643','2013-11-07','16:15:00',1.02),('7643','2014-04-17','07:15:00',1.07),('7643','2014-04-17','07:20:00',1.37),('7643','2014-04-17','07:25:00',1.57),('7643','2014-04-17','07:30:00',1.55),('7643','2014-04-17','07:35:00',1.53),('7643','2014-04-17','07:40:00',2.07),('7643','2014-04-17','07:45:00',2.01),('7643','2014-04-17','07:50:00',1.73),('7643','2014-04-17','07:55:00',2.09),('7643','2014-04-17','08:00:00',3.53),('7643','2014-04-17','08:05:00',6.57),('7643','2014-04-17','08:10:00',6.06),('7643','2014-04-17','08:15:00',2.69),('7643','2014-04-17','08:20:00',1.99),('7643','2014-04-17','08:25:00',2.18),('7643','2014-04-17','08:30:00',2.39),('7643','2014-04-17','08:35:00',3.87),('7643','2014-04-17','08:40:00',5.51),('7643','2014-04-17','08:45:00',6),('7643','2014-04-17','08:50:00',4.23),('7643','2014-04-17','08:55:00',3.79),('7643','2014-04-17','09:00:00',4.6),('7643','2014-04-17','09:05:00',10.11),('7643','2014-04-17','09:10:00',12.82),('7643','2014-04-17','09:15:00',11.79),('7643','2014-04-17','09:20:00',11.1),('7643','2014-04-17','09:25:00',7.62),('7643','2014-04-17','09:30:00',12.54),('7643','2014-04-17','09:35:00',7.51),('7643','2014-04-17','09:40:00',5.37),('7643','2014-04-17','09:45:00',7.31),('7643','2014-04-17','09:50:00',11.57),('7643','2014-04-17','09:55:00',10.82),('7643','2014-04-17','10:00:00',10.4),('7643','2014-04-17','10:05:00',6.95),('7643','2014-04-17','10:10:00',6.02),('7643','2014-04-17','10:15:00',7.04),('7643','2014-04-17','10:20:00',5.65),('7643','2014-04-17','10:25:00',5.89),('7643','2014-04-17','10:30:00',4.96),('7643','2014-04-17','10:35:00',4.47),('7643','2014-04-17','10:40:00',5.34),('7643','2014-04-17','10:45:00',10.68),('7643','2014-04-17','10:50:00',10.76),('7643','2014-04-17','10:55:00',11.66),('7643','2014-04-17','11:00:00',6.92),('7643','2014-04-17','11:05:00',6.23),('7643','2014-04-17','11:10:00',8.33),('7643','2014-04-17','11:15:00',11.79),('7643','2014-04-17','11:20:00',7.39),('7643','2014-04-17','11:25:00',5.16),('7643','2014-04-17','11:30:00',6.29),('7643','2014-04-17','11:35:00',6.21),('7643','2014-04-17','11:40:00',6.52),('7643','2014-04-17','11:45:00',6.02),('7643','2014-04-17','11:50:00',7.29),('7643','2014-04-17','11:55:00',6.77),('7643','2014-04-17','12:00:00',6.81),('7643','2014-04-17','12:05:00',11.06),('7643','2014-04-17','12:10:00',12.4),('7643','2014-04-17','12:15:00',13.24),('7643','2014-04-17','12:20:00',15.87),('7643','2014-04-17','12:25:00',13.41),('7643','2014-04-17','12:30:00',17.7),('7643','2014-04-17','12:35:00',16.91),('7643','2014-04-17','12:40:00',17.91),('7643','2014-04-17','12:45:00',13.72),('7643','2014-04-17','12:50:00',15.33),('7643','2014-04-17','12:55:00',10.32),('7643','2014-04-17','13:00:00',18.16),('7643','2014-04-17','13:05:00',11.95),('7643','2014-04-17','13:10:00',9.44),('7643','2014-04-17','13:15:00',9.31),('7643','2014-04-17','13:20:00',8.38),('7643','2014-04-17','13:25:00',6.34),('7643','2014-04-17','13:30:00',5.45),('7643','2014-04-17','13:35:00',5.48),('7643','2014-04-17','13:40:00',4.77),('7643','2014-04-17','13:45:00',4.11),('7643','2014-04-17','13:50:00',5.08),('7643','2014-04-17','13:55:00',7.99),('7643','2014-04-17','14:00:00',7.4),('7643','2014-04-17','14:05:00',6.34),('7643','2014-04-17','14:10:00',5.58),('7643','2014-04-17','14:15:00',4.95),('7643','2014-04-17','14:20:00',5.9),('7643','2014-04-17','14:25:00',7.73),('7643','2014-04-17','14:30:00',8.63),('7643','2014-04-17','14:35:00',9.69),('7643','2014-04-17','14:40:00',8.77),('7643','2014-04-17','14:45:00',10.36),('7643','2014-04-17','14:50:00',12.16),('7643','2014-04-17','14:55:00',8.44),('7643','2014-04-17','15:00:00',13.74),('7643','2014-04-17','15:05:00',10.45),('7643','2014-04-17','15:10:00',8.36),('7643','2014-04-17','15:15:00',9.18),('7643','2014-04-17','15:20:00',7.69),('7643','2014-04-17','15:25:00',8.16),('7643','2014-04-17','15:30:00',11.88),('7643','2014-04-17','15:35:00',17.23),('7643','2014-04-17','15:40:00',8.1),('7643','2014-04-17','15:45:00',8.92),('7643','2014-04-17','15:50:00',11.67),('7643','2014-04-17','15:55:00',9.65),('7643','2014-04-17','16:00:00',8.53),('7643','2014-04-17','16:05:00',6.61),('7643','2014-04-17','16:10:00',5.49),('7643','2014-04-17','16:15:00',4.73),('7643','2014-04-17','16:20:00',4.81),('7643','2014-04-17','16:25:00',8.39),('7643','2014-04-17','16:30:00',7.86),('7643','2014-04-17','16:35:00',13.06),('7643','2014-04-17','16:40:00',11.39),('7643','2014-04-17','16:45:00',10.93),('7643','2014-04-17','16:50:00',8.78),('7643','2014-04-17','16:55:00',6.59),('7643','2014-04-17','17:00:00',7.21),('7643','2014-04-17','17:05:00',10.76),('7643','2014-04-17','17:10:00',8.01),('7643','2014-04-17','17:15:00',8.79),('7643','2014-04-17','17:20:00',7.67),('7643','2014-04-17','17:25:00',8.05),('7643','2014-04-17','17:30:00',7.36),('7643','2014-04-17','17:35:00',6.85),('7643','2014-04-17','17:40:00',6.54),('7643','2014-04-17','17:45:00',6.13),('7643','2014-04-17','17:50:00',5.79),('7643','2014-04-17','17:55:00',5.36),('7643','2014-04-17','18:00:00',4.96),('7643','2014-04-17','18:05:00',4.46),('7643','2014-04-17','18:10:00',4.02),('7643','2014-04-17','18:15:00',3.45),('7643','2014-04-17','18:20:00',2.61),('7643','2014-04-17','18:25:00',2.75),('7643','2014-04-17','18:30:00',1.95),('7643','2014-04-17','18:35:00',2.13),('7643','2014-04-17','18:40:00',1.82),('7643','2014-04-17','18:45:00',1.67),('7643','2014-04-17','18:50:00',1.35),('7643','2014-04-17','18:55:00',1.05),('7643','2013-11-06','07:20:00',1.1),('7643','2013-11-06','07:25:00',1.37),('7643','2013-11-06','07:30:00',1.64),('7643','2013-11-06','07:35:00',1.93),('7643','2013-11-06','07:40:00',2.22),('7643','2013-11-06','07:45:00',2.52),('7643','2013-11-06','07:50:00',2.83),('7643','2013-11-06','07:55:00',3.14),('7643','2013-11-06','08:00:00',3.42),('7643','2013-11-06','08:05:00',3.75),('7643','2013-11-06','08:10:00',4.06),('7643','2013-11-06','08:15:00',4.36),('7643','2013-11-06','08:20:00',4.63),('7643','2013-11-06','08:25:00',4.92),('7643','2013-11-06','08:30:00',5.22),('7643','2013-11-06','08:35:00',5.5),('7643','2013-11-06','08:40:00',5.79),('7643','2013-11-06','08:45:00',6.06),('7643','2013-11-06','08:50:00',6.29),('7643','2013-11-06','08:55:00',6.54),('7643','2013-11-06','09:00:00',6.79),('7643','2013-11-06','09:05:00',7.01),('7643','2013-11-06','09:10:00',7.22),('7643','2013-11-06','09:15:00',7.43),('7643','2013-11-06','09:20:00',7.59),('7643','2013-11-06','09:25:00',7.8),('7643','2013-11-06','09:30:00',8.02),('7643','2013-11-06','09:35:00',8.21),('7643','2013-11-06','09:40:00',8.39),('7643','2013-11-06','09:45:00',8.59),('7643','2013-11-06','09:50:00',8.73),('7643','2013-11-06','09:55:00',8.88),('7643','2013-11-06','10:00:00',9.02),('7643','2013-11-06','10:05:00',9.12),('7643','2013-11-06','10:10:00',9.17),('7643','2013-11-06','10:15:00',9.23),('7643','2013-11-06','10:20:00',9.32),('7643','2013-11-06','10:25:00',9.42),('7643','2013-11-06','10:30:00',9.49),('7643','2013-11-06','10:35:00',9.65),('7643','2013-11-06','10:40:00',9.76),('7643','2013-11-06','10:45:00',9.77),('7643','2013-11-06','10:50:00',9.84),('7643','2013-11-06','10:55:00',9.8),('7643','2013-11-06','11:00:00',9.89),('7643','2013-11-06','11:05:00',9.95),('7643','2013-11-06','11:10:00',10.03),('7643','2013-11-06','11:15:00',10.01),('7643','2013-11-06','11:20:00',9.97),('7643','2013-11-06','11:25:00',10),('7643','2013-11-06','11:30:00',9.95),('7643','2013-11-06','11:35:00',9.98),('7643','2013-11-06','11:40:00',9.99),('7643','2013-11-06','11:45:00',10.04),('7643','2013-11-06','11:50:00',9.99),('7643','2013-11-06','11:55:00',10.02),('7643','2013-11-06','12:00:00',9.96),('7643','2013-11-06','12:05:00',9.86),('7643','2013-11-06','12:10:00',9.78),('7643','2013-11-06','12:15:00',9.77),('7643','2013-11-06','12:20:00',9.85),('7643','2013-11-06','12:25:00',9.57),('7643','2013-11-06','12:30:00',9.63),('7643','2013-11-06','12:35:00',9.48),('7643','2013-11-06','12:40:00',9.48),('7643','2013-11-06','12:45:00',9.25),('7643','2013-11-06','12:50:00',9.56),('7643','2013-11-06','12:55:00',9.68),('7643','2013-11-06','13:00:00',10.03),('7643','2013-11-06','13:05:00',9.8),('7643','2013-11-06','13:10:00',9.9),('7643','2013-11-06','13:15:00',10.22),('7643','2013-11-06','13:20:00',4.48),('7643','2013-11-06','13:25:00',2.95),('7643','2013-11-06','13:30:00',3.39),('7643','2013-11-06','13:35:00',7.22),('7643','2013-11-06','13:40:00',5.38),('7643','2013-11-06','13:45:00',5.12),('7643','2013-11-06','13:50:00',9.45),('7643','2013-11-06','13:55:00',6.11),('7643','2013-11-06','14:00:00',4.67),('7643','2013-11-06','14:05:00',5.91),('7643','2013-11-06','14:10:00',4.2),('7643','2013-11-06','14:15:00',3.64),('7643','2013-11-06','14:20:00',4.35),('7643','2013-11-06','14:25:00',3.15),('7643','2013-11-06','14:30:00',4.93),('7643','2013-11-06','14:35:00',6.85),('7643','2013-11-06','14:40:00',6.83),('7643','2013-11-06','14:45:00',6.11),('7643','2013-11-06','14:50:00',5.79),('7643','2013-11-06','14:55:00',5.54),('7643','2013-11-06','15:00:00',5.23),('7643','2013-11-06','15:05:00',4.95),('7643','2013-11-06','15:10:00',4.7),('7643','2013-11-06','15:15:00',4.28),('7643','2013-11-06','15:20:00',4.02),('7643','2013-11-06','15:25:00',3.75),('7643','2013-11-06','15:30:00',3.5),('7643','2013-11-06','15:35:00',3.16),('7643','2013-11-06','15:40:00',2.87),('7643','2013-11-06','15:45:00',2.56),('7643','2013-11-06','15:50:00',2.27),('7643','2013-11-06','15:55:00',2),('7643','2013-11-06','16:00:00',1.73),('7643','2013-11-06','16:05:00',1.47),('7643','2013-11-06','16:10:00',1.22),('7643','2013-11-05','07:55:00',1.49),('7643','2013-11-05','08:00:00',2.69),('7643','2013-11-05','08:05:00',2.91),('7643','2013-11-05','08:10:00',4.18),('7643','2013-11-05','08:15:00',4.89),('7643','2013-11-05','08:20:00',4.58),('7643','2013-11-05','08:25:00',2.11),('7643','2013-11-05','08:30:00',2.22),('7643','2013-11-05','08:35:00',5.81),('7643','2013-11-05','08:40:00',5.97),('7643','2013-11-05','08:45:00',6.29),('7643','2013-11-05','08:50:00',6.84),('7643','2013-11-05','08:55:00',6.55),('7643','2013-11-05','09:00:00',4.57),('7643','2013-11-05','09:05:00',4.84),('7643','2013-11-05','09:10:00',4.2),('7643','2013-11-05','09:15:00',6.2),('7643','2013-11-05','09:20:00',7.4),('7643','2013-11-05','09:25:00',7.86),('7643','2013-11-05','09:30:00',8.37),('7643','2013-11-05','09:35:00',8.55),('7643','2013-11-05','09:40:00',8.73),('7643','2013-11-05','09:45:00',8.91),('7643','2013-11-05','09:50:00',9.06),('7643','2013-11-05','09:55:00',9.23),('7643','2013-11-05','10:00:00',9.35),('7643','2013-11-05','10:05:00',9.47),('7643','2013-11-05','10:10:00',9.65),('7643','2013-11-05','10:15:00',9.77),('7643','2013-11-05','10:20:00',9.89),('7643','2013-11-05','10:25:00',10.1),('7643','2013-11-05','10:30:00',10.21),('7643','2013-11-05','10:35:00',10.28),('7643','2013-11-05','10:40:00',10.35),('7643','2013-11-05','10:45:00',10.42),('7643','2013-11-05','10:50:00',10.5),('7643','2013-11-05','10:55:00',10.53),('7643','2013-11-05','11:00:00',10.65),('7643','2013-11-05','11:05:00',10.71),('7643','2013-11-05','11:10:00',10.69),('7643','2013-11-05','11:15:00',10.76),('7643','2013-11-05','11:20:00',10.75),('7643','2013-11-05','11:25:00',10.83),('7643','2013-11-05','11:30:00',10.88),('7643','2013-11-05','11:35:00',10.84),('7643','2013-11-05','11:40:00',10.84),('7643','2013-11-05','11:45:00',10.9),('7643','2013-11-05','11:50:00',10.95),('7643','2013-11-05','11:55:00',10.89),('7643','2013-11-05','12:00:00',10.87),('7643','2013-11-05','12:05:00',10.84),('7643','2013-11-05','12:10:00',10.81),('7643','2013-11-05','12:15:00',10.7),('7643','2013-11-05','12:20:00',10.68),('7643','2013-11-05','12:25:00',10.64),('7643','2013-11-05','12:30:00',10.56),('7643','2013-11-05','12:35:00',10.54),('7643','2013-11-05','12:40:00',10.46),('7643','2013-11-05','12:45:00',10.42),('7643','2013-11-05','12:50:00',10.35),('7643','2013-11-05','12:55:00',10.23),('7643','2013-11-05','13:00:00',10.1),('7643','2013-11-05','13:05:00',9.98),('7643','2013-11-05','13:10:00',9.79),('7643','2013-11-05','13:15:00',9.65),('7643','2013-11-05','13:20:00',9.52),('7643','2013-11-05','13:25:00',9.42),('7643','2013-11-05','13:30:00',9.31),('7643','2013-11-05','13:35:00',9.09),('7643','2013-11-05','13:40:00',8.88),('7643','2013-11-05','13:45:00',8.75),('7643','2013-11-05','13:50:00',8.51),('7643','2013-11-05','13:55:00',8.45),('7643','2013-11-05','14:00:00',8.3),('7643','2013-11-05','14:05:00',8.06),('7643','2013-11-05','14:10:00',7.86),('7643','2013-11-05','14:15:00',7.71),('7643','2013-11-05','14:20:00',7.49),('7643','2013-11-05','14:25:00',7.28),('7643','2013-11-05','14:30:00',7.02),('7643','2013-11-05','14:35:00',6.77),('7643','2013-11-05','14:40:00',6.53),('7643','2013-11-05','14:45:00',6.27),('7643','2013-11-05','14:50:00',5.98),('7643','2013-11-05','14:55:00',5.66),('7643','2013-11-05','15:00:00',5.37),('7643','2013-11-05','15:05:00',5.09),('7643','2013-11-05','15:10:00',4.82),('7643','2013-11-05','15:15:00',4.55),('7643','2013-11-05','15:20:00',4.25),('7643','2013-11-05','15:25:00',3.95),('7643','2013-11-05','15:30:00',3.61),('7643','2013-11-05','15:35:00',3.29),('7643','2013-11-05','15:40:00',2.97),('7643','2013-11-05','15:45:00',2.65),('7643','2013-11-05','15:50:00',2.37),('7643','2013-11-05','15:55:00',2.09),('7643','2013-11-05','16:00:00',1.82),('7643','2013-11-05','16:05:00',1.55),('7643','2013-11-05','16:10:00',1.32),('7643','2013-11-05','16:15:00',1.09),('7643','2013-11-04','08:10:00',1.23),('7643','2013-11-04','08:15:00',2.02),('7643','2013-11-04','08:20:00',2.45),('7643','2013-11-04','08:25:00',4.68),('7643','2013-11-04','08:30:00',6.09),('7643','2013-11-04','08:35:00',6.81),('7643','2013-11-04','08:40:00',6.99),('7643','2013-11-04','08:45:00',4.72),('7643','2013-11-04','08:50:00',2.32),('7643','2013-11-04','08:55:00',1.85),('7643','2013-11-04','09:00:00',1.07),('7643','2013-11-04','09:30:00',1.15),('7643','2013-11-04','09:35:00',1.54),('7643','2013-11-04','09:40:00',1.51),('7643','2013-11-04','09:45:00',1.71),('7643','2013-11-04','09:50:00',1.93),('7643','2013-11-04','09:55:00',2.2),('7643','2013-11-04','10:00:00',2.54),('7643','2013-11-04','10:05:00',2.22),('7643','2013-11-04','10:10:00',2.13),('7643','2013-11-04','10:15:00',3.38),('7643','2013-11-04','10:20:00',6.42),('7643','2013-11-04','10:25:00',7.99),('7643','2013-11-04','10:30:00',6.54),('7643','2013-11-04','10:35:00',8.02),('7643','2013-11-04','10:40:00',5.62),('7643','2013-11-04','10:45:00',7.82),('7643','2013-11-04','10:50:00',5.57),('7643','2013-11-04','10:55:00',5.16),('7643','2013-11-04','11:00:00',4.09),('7643','2013-11-04','11:05:00',3.05),('7643','2013-11-04','11:10:00',2.37),('7643','2013-11-04','11:15:00',1.91),('7643','2013-11-04','11:20:00',2.09),('7643','2013-11-04','11:25:00',2.45),('7643','2013-11-04','11:30:00',2.8),('7643','2013-11-04','11:35:00',3.8),('7643','2013-11-04','11:40:00',5.11),('7643','2013-11-04','11:45:00',5.21),('7643','2013-11-04','11:50:00',4.74),('7643','2013-11-04','11:55:00',3.88),('7643','2013-11-04','12:00:00',3.88),('7643','2013-11-04','12:05:00',4.72),('7643','2013-11-04','12:10:00',5.77),('7643','2013-11-04','12:15:00',5.5),('7643','2013-11-04','12:20:00',6.77),('7643','2013-11-04','12:25:00',6.2),('7643','2013-11-04','12:30:00',3.89),('7643','2013-11-04','12:35:00',3.06),('7643','2013-11-04','12:40:00',2.68),('7643','2013-11-04','12:45:00',2.43),('7643','2013-11-04','12:50:00',2.14),('7643','2013-11-04','12:55:00',2.95),('7643','2013-11-04','13:00:00',3.37),('7643','2013-11-04','13:05:00',3.02),('7643','2013-11-04','13:10:00',3.05),('7643','2013-11-04','13:15:00',2.31),('7643','2013-11-04','13:20:00',1.96),('7643','2013-11-04','13:25:00',2.32),('7643','2013-11-04','13:30:00',3.79),('7643','2013-11-04','13:35:00',8.02),('7643','2013-11-04','13:40:00',8.33),('7643','2013-11-04','13:45:00',6.67),('7643','2013-11-04','13:50:00',5.86),('7643','2013-11-04','13:55:00',4.06),('7643','2013-11-04','14:00:00',4.55),('7643','2013-11-04','14:05:00',3.52),('7643','2013-11-04','14:10:00',8.53),('7643','2013-11-04','14:15:00',4.26),('7643','2013-11-04','14:20:00',2.49),('7643','2013-11-04','14:25:00',6.48),('7643','2013-11-04','14:30:00',7.23),('7643','2013-11-04','14:35:00',7.19),('7643','2013-11-04','14:40:00',3.9),('7643','2013-11-04','14:45:00',4.48),('7643','2013-11-04','14:50:00',5.38),('7643','2013-11-04','14:55:00',1.14),('7643','2013-11-04','15:00:00',1.59),('7643','2013-11-04','15:05:00',3.85),('7643','2013-11-04','15:10:00',1.42),('7643','2013-11-04','15:15:00',1.41),('7643','2013-11-04','15:20:00',3.04),('7643','2013-11-04','15:30:00',3.05),('7643','2013-11-04','15:35:00',4.18),('7643','2013-11-04','15:40:00',1.37),('7643','2013-11-04','15:45:00',1.15),('7643','2013-11-04','15:50:00',1.19),('7643','2013-11-04','15:55:00',1.19),('7643','2013-11-04','16:00:00',1.22),('7643','2013-11-04','16:05:00',2.62),('7643','2013-11-04','16:10:00',2.38),('7643','2013-11-04','16:15:00',1.21),('7643','2013-11-03','07:50:00',1.44),('7643','2013-11-03','07:55:00',3.08),('7643','2013-11-03','08:00:00',3.43),('7643','2013-11-03','08:05:00',3.68),('7643','2013-11-03','08:10:00',3.96),('7643','2013-11-03','08:15:00',4.26),('7643','2013-11-03','08:20:00',4.85),('7643','2013-11-03','08:25:00',5.04),('7643','2013-11-03','08:30:00',5.08),('7643','2013-11-03','08:35:00',4.7),('7643','2013-11-03','08:40:00',4.54),('7643','2013-11-03','08:45:00',2.59),('7643','2013-11-03','08:50:00',3.85),('7643','2013-11-03','09:00:00',1),('7643','2013-11-03','09:05:00',1.89),('7643','2013-11-03','09:10:00',5.1),('7643','2013-11-03','09:15:00',8.06),('7643','2013-11-03','09:20:00',9.37),('7643','2013-11-03','09:25:00',10.27),('7643','2013-11-03','09:30:00',5.23),('7643','2013-11-03','09:35:00',1.36),('7643','2013-11-03','10:00:00',1.07),('7643','2013-11-03','10:05:00',9.2),('7643','2013-11-03','10:10:00',10.1),('7643','2013-11-03','10:15:00',10.19),('7643','2013-11-03','10:20:00',10.51),('7643','2013-11-03','10:25:00',11.18),('7643','2013-11-03','10:30:00',9.41),('7643','2013-11-03','10:35:00',8.4),('7643','2013-11-03','10:40:00',12.26),('7643','2013-11-03','10:45:00',6.57),('7643','2013-11-03','10:50:00',5.39),('7643','2013-11-03','10:55:00',6.72),('7643','2013-11-03','11:00:00',9.95),('7643','2013-11-03','11:05:00',14.45),('7643','2013-11-03','11:10:00',12.69),('7643','2013-11-03','11:15:00',13.5),('7643','2013-11-03','11:20:00',9.43),('7643','2013-11-03','11:25:00',6.32),('7643','2013-11-03','11:30:00',7.95),('7643','2013-11-03','11:35:00',10.27),('7643','2013-11-03','11:40:00',7.11),('7643','2013-11-03','11:45:00',8.91),('7643','2013-11-03','11:50:00',13.83),('7643','2013-11-03','11:55:00',12.14),('7643','2013-11-03','12:00:00',11.85),('7643','2013-11-03','12:05:00',11.44),('7643','2013-11-03','12:10:00',10.75),('7643','2013-11-03','12:15:00',11.56),('7643','2013-11-03','12:20:00',11.66),('7643','2013-11-03','12:25:00',11.46),('7643','2013-11-03','12:30:00',11.37),('7643','2013-11-03','12:35:00',11.1),('7643','2013-11-03','12:40:00',8.96),('7643','2013-11-03','12:45:00',10.35),('7643','2013-11-03','12:50:00',10.8),('7643','2013-11-03','12:55:00',10.66),('7643','2013-11-03','13:00:00',10.62),('7643','2013-11-03','13:05:00',10.44),('7643','2013-11-03','13:10:00',9.94),('7643','2013-11-03','13:15:00',9.83),('7643','2013-11-03','13:20:00',10.11),('7643','2013-11-03','13:25:00',10.17),('7643','2013-11-03','13:30:00',9.88),('7643','2013-11-03','13:35:00',9.65),('7643','2013-11-03','13:40:00',9.17),('7643','2013-11-03','13:45:00',7.75),('7643','2013-11-03','13:50:00',9.56),('7643','2013-11-03','13:55:00',9.42),('7643','2013-11-03','14:00:00',6.4),('7643','2013-11-03','14:05:00',9.72),('7643','2013-11-03','14:10:00',5.53),('7643','2013-11-03','14:15:00',8.5),('7643','2013-11-03','14:20:00',7.58),('7643','2013-11-03','14:25:00',8.59),('7643','2013-11-03','14:30:00',7.68),('7643','2013-11-03','14:35:00',6.59),('7643','2013-11-03','14:40:00',7.43),('7643','2013-11-03','14:45:00',4.25),('7643','2013-11-03','14:50:00',5.18),('7643','2013-11-03','14:55:00',6.31),('7643','2013-11-03','15:00:00',6.16),('7643','2013-11-03','15:05:00',3.79),('7643','2013-11-03','15:10:00',3.07),('7643','2013-11-03','15:15:00',4.75),('7643','2013-11-03','15:20:00',4.18),('7643','2013-11-03','15:25:00',4.86),('7643','2013-11-03','15:30:00',4.53),('7643','2013-11-03','15:35:00',4.3),('7643','2013-11-03','15:40:00',4.26),('7643','2013-11-03','15:45:00',3.9),('7643','2013-11-03','15:50:00',2.95),('7643','2013-11-03','15:55:00',1.24),('7643','2013-11-02','07:30:00',1.8),('7643','2013-11-02','07:35:00',2.76),('7643','2013-11-02','07:40:00',2.48),('7643','2013-11-02','07:45:00',3.03),('7643','2013-11-02','07:50:00',2.99),('7643','2013-11-02','07:55:00',2.58),('7643','2013-11-02','08:00:00',3.2),('7643','2013-11-02','08:05:00',3.6),('7643','2013-11-02','08:10:00',1.76),('7643','2013-11-02','08:15:00',1.71),('7643','2013-11-02','08:20:00',4.42),('7643','2013-11-02','08:25:00',3.5),('7643','2013-11-02','08:30:00',2.57),('7643','2013-11-02','08:35:00',4.74),('7643','2013-11-02','08:40:00',4.15),('7643','2013-11-02','08:45:00',5.47),('7643','2013-11-02','08:50:00',5.56),('7643','2013-11-02','08:55:00',3.07),('7643','2013-11-02','09:00:00',2.64),('7643','2013-11-02','09:05:00',2.25),('7643','2013-11-02','09:10:00',1.88),('7643','2013-11-02','09:15:00',1.52),('7643','2013-11-02','09:30:00',1.02),('7643','2013-11-02','09:35:00',2.81),('7643','2013-11-02','09:40:00',7.98),('7643','2013-11-02','09:45:00',7.22),('7643','2013-11-02','09:50:00',3.23),('7643','2013-11-02','09:55:00',1.99),('7643','2013-11-02','10:00:00',1.46),('7643','2013-11-02','10:05:00',2.79),('7643','2013-11-02','10:10:00',7.2),('7643','2013-11-02','10:15:00',2.2),('7643','2013-11-02','10:20:00',6.12),('7643','2013-11-02','10:25:00',6.95),('7643','2013-11-02','10:30:00',5.47),('7643','2013-11-02','10:35:00',5.94),('7643','2013-11-02','10:40:00',1.79),('7643','2013-11-02','10:45:00',1.48),('7643','2013-11-02','10:50:00',1.26),('7643','2013-11-02','10:55:00',1.68),('7643','2013-11-02','11:00:00',1.54),('7643','2013-11-02','11:05:00',1.7),('7643','2013-11-02','11:10:00',2.24),('7643','2013-11-02','11:15:00',3.41),('7643','2013-11-02','11:20:00',5.97),('7643','2013-11-02','11:25:00',6.23),('7643','2013-11-02','11:30:00',6.87),('7643','2013-11-02','11:35:00',10.36),('7643','2013-11-02','11:40:00',11.44),('7643','2013-11-02','11:45:00',11.76),('7643','2013-11-02','11:50:00',12.12),('7643','2013-11-02','11:55:00',12.64),('7643','2013-11-02','12:00:00',10.29),('7643','2013-11-02','12:05:00',13.87),('7643','2013-11-02','12:10:00',14.31),('7643','2013-11-02','12:15:00',6.05),('7643','2013-11-02','12:20:00',4.5),('7643','2013-11-02','12:25:00',7.08),('7643','2013-11-02','12:30:00',7.91),('7643','2013-11-02','12:35:00',5.63),('7643','2013-11-02','12:40:00',4.48),('7643','2013-11-02','12:45:00',4.02),('7643','2013-11-02','12:50:00',3.46),('7643','2013-11-02','12:55:00',2.47),('7643','2013-11-02','13:00:00',1.75),('7643','2013-11-02','13:05:00',2.06),('7643','2013-11-02','13:10:00',2.86),('7643','2013-11-02','13:15:00',2.81),('7643','2013-11-02','13:20:00',2.82),('7643','2013-11-02','13:25:00',3.43),('7643','2013-11-02','13:30:00',3.4),('7643','2013-11-02','13:35:00',2.77),('7643','2013-11-02','13:40:00',4.7),('7643','2013-11-02','13:45:00',7.09),('7643','2013-11-02','13:50:00',8.11),('7643','2013-11-02','13:55:00',3.22),('7643','2013-11-02','14:00:00',5.06),('7643','2013-11-02','14:05:00',6.44),('7643','2013-11-02','14:10:00',5.93),('7643','2013-11-02','14:15:00',3.45),('7643','2013-11-02','14:20:00',4.44),('7643','2013-11-02','14:25:00',5.82),('7643','2013-11-02','14:30:00',4.12),('7643','2013-11-02','14:35:00',2.63),('7643','2013-11-02','14:40:00',7.02),('7643','2013-11-02','14:45:00',3.33),('7643','2013-11-02','14:50:00',2.2),('7643','2013-11-02','14:55:00',2.15),('7643','2013-11-02','15:00:00',1.89),('7643','2013-11-02','15:05:00',1.89),('7643','2013-11-02','15:10:00',1.77),('7643','2013-11-02','15:15:00',1.9),('7643','2013-11-02','15:20:00',2.78),('7643','2013-11-02','15:25:00',1.3),('7643','2013-11-02','15:55:00',1.25),('7643','2013-11-02','16:00:00',1.14),('7643','2013-11-02','16:05:00',1.38),('7643','2013-11-02','16:10:00',1.34),('7643','2013-11-01','07:50:00',1.92),('7643','2013-11-01','07:55:00',2.89),('7643','2013-11-01','08:00:00',3.29),('7643','2013-11-01','08:05:00',3.54),('7643','2013-11-01','08:10:00',3.89),('7643','2013-11-01','08:15:00',4.24),('7643','2013-11-01','08:20:00',4.5),('7643','2013-11-01','08:25:00',4.76),('7643','2013-11-01','08:30:00',5.08),('7643','2013-11-01','08:35:00',5.34),('7643','2013-11-01','08:40:00',5.64),('7643','2013-11-01','08:45:00',5.9),('7643','2013-11-01','08:50:00',6.13),('7643','2013-11-01','08:55:00',6.41),('7643','2013-11-01','09:00:00',6.68),('7643','2013-11-01','09:05:00',7.24),('7643','2013-11-01','09:10:00',7.82),('7643','2013-11-01','09:15:00',6.43),('7643','2013-11-01','09:20:00',7.1),('7643','2013-11-01','09:25:00',6.86),('7643','2013-11-01','09:30:00',8.25),('7643','2013-11-01','09:35:00',8.13),('7643','2013-11-01','09:40:00',8.12),('7643','2013-11-01','09:45:00',8.47),('7643','2013-11-01','09:50:00',9.58),('7643','2013-11-01','09:55:00',9.45),('7643','2013-11-01','10:00:00',10.27),('7643','2013-11-01','10:05:00',11.27),('7643','2013-11-01','10:10:00',5.16),('7643','2013-11-01','10:15:00',4.64),('7643','2013-11-01','10:20:00',3.29),('7643','2013-11-01','10:25:00',2.46),('7643','2013-11-01','10:30:00',2.24),('7643','2013-11-01','10:35:00',2.79),('7643','2013-11-01','10:40:00',2.78),('7643','2013-11-01','10:45:00',2.69),('7643','2013-11-01','10:50:00',2.44),('7643','2013-11-01','10:55:00',3.02),('7643','2013-11-01','11:00:00',4.43),('7643','2013-11-01','11:05:00',4.83),('7643','2013-11-01','11:10:00',3.96),('7643','2013-11-01','11:15:00',2.71),('7643','2013-11-01','11:20:00',1.71),('7643','2013-11-01','11:25:00',2.13),('7643','2013-11-01','11:30:00',2.54),('7643','2013-11-01','11:35:00',2.82),('7643','2013-11-01','11:40:00',3.41),('7643','2013-11-01','11:45:00',3.43),('7643','2013-11-01','11:50:00',4.03),('7643','2013-11-01','11:55:00',8.19),('7643','2013-11-01','12:00:00',11.46),('7643','2013-11-01','12:05:00',12.48),('7643','2013-11-01','12:10:00',10.86),('7643','2013-11-01','12:15:00',9.81),('7643','2013-11-01','12:20:00',13.19),('7643','2013-11-01','12:25:00',12.22),('7643','2013-11-01','12:30:00',12.79),('7643','2013-11-01','12:35:00',12.63),('7643','2013-11-01','12:40:00',11.38),('7643','2013-11-01','12:45:00',8.66),('7643','2013-11-01','12:50:00',9.98),('7643','2013-11-01','12:55:00',11.35),('7643','2013-11-01','13:00:00',9.88),('7643','2013-11-01','13:05:00',11.26),('7643','2013-11-01','13:10:00',11.53),('7643','2013-11-01','13:15:00',9.43),('7643','2013-11-01','13:20:00',3.22),('7643','2013-11-01','13:25:00',3.39),('7643','2013-11-01','13:30:00',7.67),('7643','2013-11-01','13:35:00',12.02),('7643','2013-11-01','13:40:00',11.29),('7643','2013-11-01','13:45:00',10.23),('7643','2013-11-01','13:50:00',11.47),('7643','2013-11-01','13:55:00',11.07),('7643','2013-11-01','14:00:00',10.1),('7643','2013-11-01','14:05:00',8.95),('7643','2013-11-01','14:10:00',8.23),('7643','2013-11-01','14:15:00',7.88),('7643','2013-11-01','14:20:00',7.53),('7643','2013-11-01','14:25:00',7.23),('7643','2013-11-01','14:30:00',7.04),('7643','2013-11-01','14:35:00',6.84),('7643','2013-11-01','14:40:00',6.61),('7643','2013-11-01','14:45:00',6.27),('7643','2013-11-01','14:50:00',6.09),('7643','2013-11-01','14:55:00',5.84),('7643','2013-11-01','15:00:00',5.46),('7643','2013-11-01','15:05:00',5.04),('7643','2013-11-01','15:10:00',4.73),('7643','2013-11-01','15:15:00',3.83),('7643','2013-11-01','15:20:00',1.3),('7643','2013-11-01','15:25:00',1.36),('7643','2013-11-01','15:30:00',1.47),('7643','2013-11-01','15:35:00',2.26),('7643','2013-11-01','15:40:00',2.59),('7643','2013-11-01','15:45:00',3.31),('7643','2013-11-01','15:50:00',2.77),('7643','2013-11-01','15:55:00',2.11),('7643','2013-11-01','16:00:00',1.46),('7643','2013-11-01','16:05:00',1.35),('7643','2013-11-01','16:10:00',1.53),('7643','2013-11-01','16:15:00',1.59),('7643','2013-11-01','16:20:00',1.16),('7643','2013-10-31','07:20:00',1.22),('7643','2013-10-31','07:25:00',1.47),('7643','2013-10-31','07:30:00',1.74),('7643','2013-10-31','07:35:00',2.02),('7643','2013-10-31','07:40:00',2.32),('7643','2013-10-31','07:45:00',2.62),('7643','2013-10-31','07:50:00',2.78),('7643','2013-10-31','07:55:00',2.85),('7643','2013-10-31','08:00:00',3.05),('7643','2013-10-31','08:05:00',2.85),('7643','2013-10-31','08:10:00',2.92),('7643','2013-10-31','08:15:00',3.34),('7643','2013-10-31','08:20:00',3.96),('7643','2013-10-31','08:25:00',4.13),('7643','2013-10-31','08:30:00',4.79),('7643','2013-10-31','08:35:00',5.18),('7643','2013-10-31','08:40:00',5.67),('7643','2013-10-31','08:45:00',5.82),('7643','2013-10-31','08:50:00',5.66),('7643','2013-10-31','08:55:00',5.92),('7643','2013-10-31','09:00:00',6.06),('7643','2013-10-31','09:05:00',6.91),('7643','2013-10-31','09:10:00',7.2),('7643','2013-10-31','09:15:00',7.4),('7643','2013-10-31','09:20:00',7.59),('7643','2013-10-31','09:25:00',7.8),('7643','2013-10-31','09:30:00',8),('7643','2013-10-31','09:35:00',8.17),('7643','2013-10-31','09:40:00',8.33),('7643','2013-10-31','09:45:00',8.57),('7643','2013-10-31','09:50:00',8.79),('7643','2013-10-31','09:55:00',8.97),('7643','2013-10-31','10:00:00',9.12),('7643','2013-10-31','10:05:00',9.27),('7643','2013-10-31','10:10:00',9.44),('7643','2013-10-31','10:15:00',9.49),('7643','2013-10-31','10:20:00',9.68),('7643','2013-10-31','10:25:00',9.85),('7643','2013-10-31','10:30:00',9.76),('7643','2013-10-31','10:35:00',9.78),('7643','2013-10-31','10:40:00',10.03),('7643','2013-10-31','10:45:00',9.68),('7643','2013-10-31','10:50:00',9.81),('7643','2013-10-31','10:55:00',9.88),('7643','2013-10-31','11:00:00',10.04),('7643','2013-10-31','11:05:00',9.61),('7643','2013-10-31','11:10:00',8.55),('7643','2013-10-31','11:15:00',9.41),('7643','2013-10-31','11:20:00',10.48),('7643','2013-10-31','11:25:00',11.07),('7643','2013-10-31','11:30:00',11.17),('7643','2013-10-31','11:35:00',10.84),('7643','2013-10-31','11:40:00',10.22),('7643','2013-10-31','11:45:00',9.15),('7643','2013-10-31','11:50:00',10.68),('7643','2013-10-31','11:55:00',11.19),('7643','2013-10-31','12:00:00',11.23),('7643','2013-10-31','12:05:00',10.97),('7643','2013-10-31','12:10:00',9.96),('7643','2013-10-31','12:15:00',10.16),('7643','2013-10-31','12:20:00',4.38),('7643','2013-10-31','12:25:00',7),('7643','2013-10-31','12:30:00',6.89),('7643','2013-10-31','12:35:00',5.9),('7643','2013-10-31','12:40:00',2.13),('7643','2013-10-31','12:45:00',1.81),('7643','2013-10-31','12:50:00',1.84),('7643','2013-10-31','12:55:00',1.88),('7643','2013-10-31','13:00:00',1.93),('7643','2013-10-31','13:05:00',2.32),('7643','2013-10-31','13:10:00',2.79),('7643','2013-10-31','13:15:00',3.69),('7643','2013-10-31','13:20:00',4.96),('7643','2013-10-31','13:25:00',4.73),('7643','2013-10-31','13:30:00',5.85),('7643','2013-10-31','13:35:00',4.76),('7643','2013-10-31','13:40:00',3.82),('7643','2013-10-31','13:45:00',4.44),('7643','2013-10-31','13:50:00',3.18),('7643','2013-10-31','13:55:00',3.48),('7643','2013-10-31','14:00:00',2.82),('7643','2013-10-31','14:05:00',2.72),('7643','2013-10-31','14:10:00',2.71),('7643','2013-10-31','14:15:00',2.69),('7643','2013-10-31','14:20:00',2.43),('7643','2013-10-31','14:25:00',1.96),('7643','2013-10-31','14:30:00',1.75),('7643','2013-10-31','14:35:00',1.54),('7643','2013-10-31','14:40:00',1.41),('7643','2013-10-31','14:45:00',1.38),('7643','2013-10-31','14:50:00',1.32),('7643','2013-10-31','14:55:00',1.27),('7643','2013-10-31','15:00:00',1.23),('7643','2013-10-31','15:05:00',1.21),('7643','2013-10-31','15:10:00',1.19),('7643','2013-10-31','15:15:00',1.14),('7643','2013-10-31','15:20:00',1.12),('7643','2013-10-31','15:25:00',1.12),('7643','2013-10-31','15:30:00',1.11),('7643','2013-10-31','15:35:00',1.1),('7643','2013-10-31','15:40:00',1.07),('7643','2013-10-31','15:45:00',1.04),('7643','2013-10-31','15:50:00',1),('7643','2013-10-30','08:00:00',1.46),('7643','2013-10-30','08:05:00',2.2),('7643','2013-10-30','08:10:00',2.56),('7643','2013-10-30','08:15:00',3.23),('7643','2013-10-30','08:20:00',3.57),('7643','2013-10-30','08:25:00',4.19),('7643','2013-10-30','08:30:00',4.83),('7643','2013-10-30','08:35:00',5.14),('7643','2013-10-30','08:40:00',5.91),('7643','2013-10-30','08:45:00',5.93),('7643','2013-10-30','08:50:00',5.28),('7643','2013-10-30','08:55:00',4.99),('7643','2013-10-30','09:00:00',6.34),('7643','2013-10-30','09:05:00',4.31),('7643','2013-10-30','09:10:00',3.24),('7643','2013-10-30','09:15:00',3.69),('7643','2013-10-30','09:20:00',3.02),('7643','2013-10-30','09:25:00',4.98),('7643','2013-10-30','09:30:00',6.37),('7643','2013-10-30','09:35:00',6.73),('7643','2013-10-30','09:40:00',6.09),('7643','2013-10-30','09:45:00',4.58),('7643','2013-10-30','09:50:00',5.3),('7643','2013-10-30','09:55:00',7.17),('7643','2013-10-30','10:00:00',7.2),('7643','2013-10-30','10:05:00',6.48),('7643','2013-10-30','10:10:00',5.72),('7643','2013-10-30','10:15:00',4.75),('7643','2013-10-30','10:20:00',6.27),('7643','2013-10-30','10:25:00',6.33),('7643','2013-10-30','10:30:00',6.27),('7643','2013-10-30','10:35:00',6.61),('7643','2013-10-30','10:40:00',6.72),('7643','2013-10-30','10:45:00',6.47),('7643','2013-10-30','10:50:00',6.53),('7643','2013-10-30','10:55:00',7.85),('7643','2013-10-30','11:00:00',10.09),('7643','2013-10-30','11:05:00',10.41),('7643','2013-10-30','11:10:00',9.78),('7643','2013-10-30','11:15:00',9.7),('7643','2013-10-30','11:20:00',9.33),('7643','2013-10-30','11:25:00',8.98),('7643','2013-10-30','11:30:00',9.49),('7643','2013-10-30','11:35:00',9.11),('7643','2013-10-30','11:40:00',9.88),('7643','2013-10-30','11:45:00',10.46),('7643','2013-10-30','11:50:00',10.51),('7643','2013-10-30','11:55:00',10.51),('7643','2013-10-30','12:00:00',10.34),('7643','2013-10-30','12:05:00',10.15),('7643','2013-10-30','12:10:00',9.95),('7643','2013-10-30','12:15:00',10.19),('7643','2013-10-30','12:20:00',9.97),('7643','2013-10-30','12:25:00',10.04),('7643','2013-10-30','12:30:00',9.73),('7643','2013-10-30','12:35:00',9.7),('7643','2013-10-30','12:40:00',9.78),('7643','2013-10-30','12:45:00',10.2),('7643','2013-10-30','12:50:00',10.3),('7643','2013-10-30','12:55:00',10.36),('7643','2013-10-30','13:00:00',9.95),('7643','2013-10-30','13:05:00',9.83),('7643','2013-10-30','13:10:00',9.74),('7643','2013-10-30','13:15:00',9.63),('7643','2013-10-30','13:20:00',9.55),('7643','2013-10-30','13:25:00',9.38),('7643','2013-10-30','13:30:00',9.07),('7643','2013-10-30','13:35:00',8.33),('7643','2013-10-30','13:40:00',7.22),('7643','2013-10-30','13:45:00',7.94),('7643','2013-10-30','13:50:00',5.54),('7643','2013-10-30','13:55:00',6.64),('7643','2013-10-30','14:00:00',8.06),('7643','2013-10-30','14:05:00',8.01),('7643','2013-10-30','14:10:00',7.37),('7643','2013-10-30','14:15:00',4.47),('7643','2013-10-30','14:20:00',3.96),('7643','2013-10-30','14:25:00',5.8),('7643','2013-10-30','14:30:00',4.61),('7643','2013-10-30','14:35:00',4.41),('7643','2013-10-30','14:40:00',4.36),('7643','2013-10-30','14:45:00',3.3),('7643','2013-10-30','14:50:00',4.45),('7643','2013-10-30','14:55:00',3.84),('7643','2013-10-30','15:00:00',3.94),('7643','2013-10-30','15:05:00',3.68),('7643','2013-10-30','15:10:00',3.55),('7643','2013-10-30','15:15:00',3.27),('7643','2013-10-30','15:20:00',3.05),('7643','2013-10-30','15:25:00',2.89),('7643','2013-10-30','15:30:00',2.68),('7643','2013-10-30','15:35:00',2.6),('7643','2013-10-30','15:40:00',2.55),('7643','2013-10-30','15:45:00',2.22),('7643','2013-10-30','15:50:00',2.06),('7643','2013-10-30','15:55:00',1.92),('7643','2013-10-30','16:00:00',1.66),('7643','2013-10-30','16:05:00',1.38),('7643','2013-10-30','16:10:00',1.19),('7643','2013-10-30','16:15:00',1.07),('7643','2013-10-30','16:20:00',1.02),('7643','2013-10-29','07:20:00',1.07),('7643','2013-10-29','07:25:00',1.29),('7643','2013-10-29','07:30:00',1.54),('7643','2013-10-29','07:35:00',1.76),('7643','2013-10-29','07:40:00',1.99),('7643','2013-10-29','07:45:00',2.31),('7643','2013-10-29','07:50:00',2.62),('7643','2013-10-29','07:55:00',2.84),('7643','2013-10-29','08:00:00',3.08),('7643','2013-10-29','08:05:00',3.39),('7643','2013-10-29','08:10:00',3.73),('7643','2013-10-29','08:15:00',3.98),('7643','2013-10-29','08:20:00',4.28),('7643','2013-10-29','08:25:00',4.53),('7643','2013-10-29','08:30:00',4.75),('7643','2013-10-29','08:35:00',5.1),('7643','2013-10-29','08:40:00',5.46),('7643','2013-10-29','08:45:00',5.78),('7643','2013-10-29','08:50:00',5.9),('7643','2013-10-29','08:55:00',5.82),('7643','2013-10-29','09:00:00',6.06),('7643','2013-10-29','09:05:00',6.59),('7643','2013-10-29','09:10:00',7.02),('7643','2013-10-29','09:15:00',7.23),('7643','2013-10-29','09:20:00',7.44),('7643','2013-10-29','09:25:00',7.73),('7643','2013-10-29','09:30:00',7.84),('7643','2013-10-29','09:35:00',8.02),('7643','2013-10-29','09:40:00',8.19),('7643','2013-10-29','09:45:00',8.38),('7643','2013-10-29','09:50:00',8.58),('7643','2013-10-29','09:55:00',8.41),('7643','2013-10-29','10:00:00',8.11),('7643','2013-10-29','10:05:00',8.48),('7643','2013-10-29','10:10:00',8.61),('7643','2013-10-29','10:15:00',9.11),('7643','2013-10-29','10:20:00',9.01),('7643','2013-10-29','10:25:00',8.98),('7643','2013-10-29','10:30:00',9.12),('7643','2013-10-29','10:35:00',9.01),('7643','2013-10-29','10:40:00',7.6),('7643','2013-10-29','10:45:00',7),('7643','2013-10-29','10:50:00',3.95),('7643','2013-10-29','10:55:00',4.05),('7643','2013-10-29','11:00:00',6.93),('7643','2013-10-29','11:05:00',8.64),('7643','2013-10-29','11:10:00',8.73),('7643','2013-10-29','11:15:00',9.34),('7643','2013-10-29','11:20:00',9.12),('7643','2013-10-29','11:25:00',4.2),('7643','2013-10-29','11:30:00',4.5),('7643','2013-10-29','11:35:00',5.23),('7643','2013-10-29','11:40:00',4.29),('7643','2013-10-29','11:45:00',4.72),('7643','2013-10-29','11:50:00',9.24),('7643','2013-10-29','11:55:00',3.9),('7643','2013-10-29','12:00:00',3.27),('7643','2013-10-29','12:05:00',3.65),('7643','2013-10-29','12:10:00',3.73),('7643','2013-10-29','12:15:00',3.72),('7643','2013-10-29','12:20:00',3.9),('7643','2013-10-29','12:25:00',7.49),('7643','2013-10-29','12:30:00',10.7),('7643','2013-10-29','12:35:00',6.23),('7643','2013-10-29','12:40:00',4.63),('7643','2013-10-29','12:45:00',8.18),('7643','2013-10-29','12:50:00',8.18),('7643','2013-10-29','12:55:00',7.78),('7643','2013-10-29','13:00:00',5.36),('7643','2013-10-29','13:05:00',8.12),('7643','2013-10-29','13:10:00',9.61),('7643','2013-10-29','13:15:00',9.59),('7643','2013-10-29','13:20:00',9.21),('7643','2013-10-29','13:25:00',9.21),('7643','2013-10-29','13:30:00',9.49),('7643','2013-10-29','13:35:00',8.73),('7643','2013-10-29','13:40:00',8.44),('7643','2013-10-29','13:45:00',9.29),('7643','2013-10-29','13:50:00',9.3),('7643','2013-10-29','13:55:00',8),('7643','2013-10-29','14:00:00',6.05),('7643','2013-10-29','14:05:00',9.18),('7643','2013-10-29','14:10:00',7.6),('7643','2013-10-29','14:15:00',3.42),('7643','2013-10-29','14:20:00',2.65),('7643','2013-10-29','14:25:00',2.95),('7643','2013-10-29','14:30:00',2.18),('7643','2013-10-29','14:35:00',2.12),('7643','2013-10-29','14:40:00',2.5),('7643','2013-10-29','14:45:00',5.72),('7643','2013-10-29','14:50:00',5.8),('7643','2013-10-29','14:55:00',2.64),('7643','2013-10-29','15:00:00',1.63),('7643','2013-10-29','15:05:00',1.57),('7643','2013-10-29','15:10:00',1.26),('7643','2013-10-29','15:15:00',1.85),('7643','2013-10-29','15:20:00',3.11),('7643','2013-10-29','15:25:00',3.54),('7643','2013-10-29','15:30:00',2.31),('7643','2013-10-29','15:35:00',1.07),('7643','2013-10-29','15:55:00',1.5),('7643','2013-10-29','16:00:00',1.81),('7643','2013-10-29','16:05:00',1.4),('7643','2013-10-28','07:45:00',1.16),('7643','2013-10-28','07:50:00',1.43),('7643','2013-10-28','07:55:00',1.63),('7643','2013-10-28','08:00:00',1.83),('7643','2013-10-28','08:05:00',1.87),('7643','2013-10-28','08:10:00',2.15),('7643','2013-10-28','08:15:00',2.47),('7643','2013-10-28','08:20:00',2.83),('7643','2013-10-28','08:25:00',3.21),('7643','2013-10-28','08:30:00',4.38),('7643','2013-10-28','08:35:00',3.79),('7643','2013-10-28','08:40:00',3.97),('7643','2013-10-28','08:45:00',4.21),('7643','2013-10-28','08:50:00',6.22),('7643','2013-10-28','08:55:00',6.61),('7643','2013-10-28','09:00:00',6.81),('7643','2013-10-28','09:05:00',7.07),('7643','2013-10-28','09:10:00',7.31),('7643','2013-10-28','09:15:00',7.38),('7643','2013-10-28','09:20:00',7.32),('7643','2013-10-28','09:25:00',7.87),('7643','2013-10-28','09:30:00',8.13),('7643','2013-10-28','09:35:00',8.36),('7643','2013-10-28','09:40:00',8.66),('7643','2013-10-28','09:45:00',8.81),('7643','2013-10-28','09:50:00',9.05),('7643','2013-10-28','09:55:00',9.27),('7643','2013-10-28','10:00:00',7.82),('7643','2013-10-28','10:05:00',7.89),('7643','2013-10-28','10:10:00',4.82),('7643','2013-10-28','10:15:00',6.41),('7643','2013-10-28','10:20:00',3.98),('7643','2013-10-28','10:25:00',3.81),('7643','2013-10-28','10:30:00',6.91),('7643','2013-10-28','10:35:00',10.71),('7643','2013-10-28','10:40:00',10.9),('7643','2013-10-28','10:45:00',10.9),('7643','2013-10-28','10:50:00',11.21),('7643','2013-10-28','10:55:00',11.53),('7643','2013-10-28','11:00:00',11.34),('7643','2013-10-28','11:05:00',11.57),('7643','2013-10-28','11:10:00',11.32),('7643','2013-10-28','11:15:00',11.21),('7643','2013-10-28','11:20:00',8.07),('7643','2013-10-28','11:25:00',4.5),('7643','2013-10-28','11:30:00',6.62),('7643','2013-10-28','11:35:00',10.96),('7643','2013-10-28','11:40:00',11.09),('7643','2013-10-28','11:45:00',11.1),('7643','2013-10-28','11:50:00',10.97),('7643','2013-10-28','11:55:00',10.67),('7643','2013-10-28','12:00:00',10.46),('7643','2013-10-28','12:05:00',10.59),('7643','2013-10-28','12:10:00',10.35),('7643','2013-10-28','12:15:00',10.57),('7643','2013-10-28','12:20:00',10.24),('7643','2013-10-28','12:25:00',10.34),('7643','2013-10-28','12:30:00',10.02),('7643','2013-10-28','12:35:00',9.53),('7643','2013-10-28','12:40:00',9.94),('7643','2013-10-28','12:45:00',10.03),('7643','2013-10-28','12:50:00',9.92),('7643','2013-10-28','12:55:00',9.7),('7643','2013-10-28','13:00:00',9.4),('7643','2013-10-28','13:05:00',9.09),('7643','2013-10-28','13:10:00',8.95),('7643','2013-10-28','13:15:00',9.31),('7643','2013-10-28','13:20:00',9.13),('7643','2013-10-28','13:25:00',9.12),('7643','2013-10-28','13:30:00',8.9),('7643','2013-10-28','13:35:00',8.97),('7643','2013-10-28','13:40:00',8.89),('7643','2013-10-28','13:45:00',8.57),('7643','2013-10-28','13:50:00',8.07),('7643','2013-10-28','13:55:00',8.08),('7643','2013-10-28','14:00:00',7.88),('7643','2013-10-28','14:05:00',7.64),('7643','2013-10-28','14:10:00',7.47),('7643','2013-10-28','14:15:00',7.28),('7643','2013-10-28','14:20:00',7.07),('7643','2013-10-28','14:25:00',6.73),('7643','2013-10-28','14:30:00',6.53),('7643','2013-10-28','14:35:00',6.31),('7643','2013-10-28','14:40:00',6.06),('7643','2013-10-28','14:45:00',5.84),('7643','2013-10-28','14:50:00',5.57),('7643','2013-10-28','14:55:00',5.26),('7643','2013-10-28','15:00:00',4.9),('7643','2013-10-28','15:05:00',4.66),('7643','2013-10-28','15:10:00',4.58),('7643','2013-10-28','15:15:00',4.35),('7643','2013-10-28','15:20:00',4.04),('7643','2013-10-28','15:25:00',3.69),('7643','2013-10-28','15:30:00',3.47),('7643','2013-10-28','15:35:00',3.19),('7643','2013-10-28','15:40:00',2.9),('7643','2013-10-28','15:45:00',2.61),('7643','2013-10-28','15:50:00',2.34),('7643','2013-10-28','15:55:00',2.12),('7643','2013-10-28','16:00:00',1.89),('7643','2013-10-28','16:05:00',1.63),('7643','2013-10-28','16:10:00',1.41),('7643','2013-10-28','16:15:00',1.2),('7643','2014-04-16','07:20:00',1.09),('7643','2014-04-16','07:25:00',1.38),('7643','2014-04-16','07:30:00',1.39),('7643','2014-04-16','07:35:00',1.18),('7643','2014-04-16','07:40:00',1.25),('7643','2014-04-16','07:45:00',1.55),('7643','2014-04-16','07:50:00',1.7),('7643','2014-04-16','07:55:00',3.26),('7643','2014-04-16','08:00:00',4.56),('7643','2014-04-16','08:05:00',5.06),('7643','2014-04-16','08:10:00',5.49),('7643','2014-04-16','08:15:00',5.88),('7643','2014-04-16','08:20:00',6.02),('7643','2014-04-16','08:25:00',6.65),('7643','2014-04-16','08:30:00',7.05),('7643','2014-04-16','08:35:00',7.39),('7643','2014-04-16','08:40:00',7.75),('7643','2014-04-16','08:45:00',8.09),('7643','2014-04-16','08:50:00',8.51),('7643','2014-04-16','08:55:00',7.75),('7643','2014-04-16','09:00:00',7.49),('7643','2014-04-16','09:05:00',8.76),('7643','2014-04-16','09:10:00',9.9),('7643','2014-04-16','09:15:00',9.56),('7643','2014-04-16','09:20:00',10.56),('7643','2014-04-16','09:25:00',10.99),('7643','2014-04-16','09:30:00',11.3),('7643','2014-04-16','09:35:00',11.57),('7643','2014-04-16','09:40:00',11.94),('7643','2014-04-16','09:45:00',12.31),('7643','2014-04-16','09:50:00',12.53),('7643','2014-04-16','09:55:00',12.96),('7643','2014-04-16','10:00:00',13.46),('7643','2014-04-16','10:05:00',14.5),('7643','2014-04-16','10:10:00',13.78),('7643','2014-04-16','10:15:00',11.65),('7643','2014-04-16','10:20:00',13.81),('7643','2014-04-16','10:25:00',15.65),('7643','2014-04-16','10:30:00',16.66),('7643','2014-04-16','10:35:00',17.28),('7643','2014-04-16','10:40:00',16.18),('7643','2014-04-16','10:45:00',13.94),('7643','2014-04-16','10:50:00',9.99),('7643','2014-04-16','10:55:00',10.2),('7643','2014-04-16','11:00:00',10.2),('7643','2014-04-16','11:05:00',13.72),('7643','2014-04-16','11:10:00',13.52),('7643','2014-04-16','11:15:00',11.2),('7643','2014-04-16','11:20:00',13.3),('7643','2014-04-16','11:25:00',14.98),('7643','2014-04-16','11:30:00',9.76),('7643','2014-04-16','11:35:00',11.32),('7643','2014-04-16','11:40:00',10.08),('7643','2014-04-16','11:45:00',14.34),('7643','2014-04-16','11:50:00',10.45),('7643','2014-04-16','11:55:00',7.9),('7643','2014-04-16','12:00:00',8.55),('7643','2014-04-16','12:05:00',11.53),('7643','2014-04-16','12:10:00',10.73),('7643','2014-04-16','12:15:00',9.69),('7643','2014-04-16','12:20:00',9.16),('7643','2014-04-16','12:25:00',9.7),('7643','2014-04-16','12:30:00',12.44),('7643','2014-04-16','12:35:00',15.13),('7643','2014-04-16','12:40:00',17.74),('7643','2014-04-16','12:45:00',16.82),('7643','2014-04-16','12:50:00',17.66),('7643','2014-04-16','12:55:00',17.89),('7643','2014-04-16','13:00:00',17.88),('7643','2014-04-16','13:05:00',10.24),('7643','2014-04-16','13:10:00',3.91),('7643','2014-04-16','13:15:00',4.49),('7643','2014-04-16','13:20:00',3.84),('7643','2014-04-16','13:25:00',15.67),('7643','2014-04-16','13:30:00',19.21),('7643','2014-04-16','13:35:00',4.25),('7643','2014-04-16','13:40:00',3.73),('7643','2014-04-16','13:45:00',3.43),('7643','2014-04-16','13:50:00',3.85),('7643','2014-04-16','13:55:00',4.36),('7643','2014-04-16','14:00:00',4.28),('7643','2014-04-16','14:05:00',4.46),('7643','2014-04-16','14:10:00',8.76),('7643','2014-04-16','14:15:00',7.57),('7643','2014-04-16','14:20:00',4.99),('7643','2014-04-16','14:25:00',6.38),('7643','2014-04-16','14:30:00',6.01),('7643','2014-04-16','14:35:00',7.03),('7643','2014-04-16','14:40:00',12.49),('7643','2014-04-16','14:45:00',6.18),('7643','2014-04-16','14:50:00',3.53),('7643','2014-04-16','14:55:00',2.95),('7643','2014-04-16','15:00:00',3.23),('7643','2014-04-16','15:05:00',3.7),('7643','2014-04-16','15:10:00',3.66),('7643','2014-04-16','15:15:00',3.34),('7643','2014-04-16','15:20:00',3.29),('7643','2014-04-16','15:25:00',4.09),('7643','2014-04-16','15:30:00',6.38),('7643','2014-04-16','15:35:00',8.73),('7643','2014-04-16','15:40:00',6.82),('7643','2014-04-16','15:45:00',4.84),('7643','2014-04-16','15:50:00',4.34),('7643','2014-04-16','15:55:00',4.95),('7643','2014-04-16','16:00:00',4.51),('7643','2014-04-16','16:05:00',3.6),('7643','2014-04-16','16:10:00',4.01),('7643','2014-04-16','16:15:00',4.26),('7643','2014-04-16','16:20:00',4.16),('7643','2014-04-16','16:25:00',4.4),('7643','2014-04-16','16:30:00',4.7),('7643','2014-04-16','16:35:00',4.17),('7643','2014-04-16','16:40:00',4.68),('7643','2014-04-16','16:45:00',5.96),('7643','2014-04-16','16:50:00',6.24),('7643','2014-04-16','16:55:00',4.58),('7643','2014-04-16','17:00:00',3.8),('7643','2014-04-16','17:05:00',3.2),('7643','2014-04-16','17:10:00',3.14),('7643','2014-04-16','17:15:00',3.49),('7643','2014-04-16','17:20:00',4.22),('7643','2014-04-16','17:25:00',3.61),('7643','2014-04-16','17:30:00',3.64),('7643','2014-04-16','17:35:00',3.62),('7643','2014-04-16','17:40:00',3.54),('7643','2014-04-16','17:45:00',3.22),('7643','2014-04-16','17:50:00',2.63),('7643','2014-04-16','17:55:00',2.54),('7643','2014-04-16','18:00:00',2.07),('7643','2014-04-16','18:05:00',1.52),('7643','2013-10-27','07:20:00',1.23),('7643','2013-10-27','07:25:00',1.87),('7643','2013-10-27','07:30:00',2.61),('7643','2013-10-27','07:35:00',3.09),('7643','2013-10-27','07:40:00',3.03),('7643','2013-10-27','07:45:00',2.01),('7643','2013-10-27','07:50:00',1.28),('7643','2013-10-27','07:55:00',1.36),('7643','2013-10-27','08:00:00',1.37),('7643','2013-10-27','08:05:00',1.97),('7643','2013-10-27','08:10:00',3.11),('7643','2013-10-27','08:15:00',2.27),('7643','2013-10-27','08:20:00',2.36),('7643','2013-10-27','08:25:00',2.14),('7643','2013-10-27','08:30:00',2.14),('7643','2013-10-27','08:35:00',2.28),('7643','2013-10-27','08:40:00',2.27),('7643','2013-10-27','08:45:00',3.16),('7643','2013-10-27','08:50:00',4.83),('7643','2013-10-27','08:55:00',6.33),('7643','2013-10-27','09:00:00',7.14),('7643','2013-10-27','09:05:00',7.87),('7643','2013-10-27','09:10:00',8.46),('7643','2013-10-27','09:15:00',8.72),('7643','2013-10-27','09:20:00',8.47),('7643','2013-10-27','09:25:00',7.81),('7643','2013-10-27','09:30:00',8.83),('7643','2013-10-27','09:35:00',7.19),('7643','2013-10-27','09:40:00',7.07),('7643','2013-10-27','09:45:00',6.45),('7643','2013-10-27','09:50:00',8.88),('7643','2013-10-27','09:55:00',7.63),('7643','2013-10-27','10:00:00',3.69),('7643','2013-10-27','10:05:00',2.89),('7643','2013-10-27','10:10:00',2.96),('7643','2013-10-27','10:15:00',2.87),('7643','2013-10-27','10:20:00',3.08),('7643','2013-10-27','10:25:00',3.1),('7643','2013-10-27','10:30:00',3.15),('7643','2013-10-27','10:35:00',3.13),('7643','2013-10-27','10:40:00',2.59),('7643','2013-10-27','10:45:00',1.83),('7643','2013-10-27','10:50:00',10.98),('7643','2013-10-27','10:55:00',10.77),('7643','2013-10-27','11:00:00',10.76),('7643','2013-10-27','11:05:00',10.89),('7643','2013-10-27','11:10:00',10.84),('7643','2013-10-27','11:15:00',10.9),('7643','2013-10-27','11:20:00',10.95),('7643','2013-10-27','11:25:00',10.93),('7643','2013-10-27','11:30:00',10.71),('7643','2013-10-27','11:35:00',10.88),('7643','2013-10-27','11:40:00',10.81),('7643','2013-10-27','11:45:00',10.84),('7643','2013-10-27','11:50:00',11.02),('7643','2013-10-27','11:55:00',8.66),('7643','2013-10-27','12:00:00',8.05),('7643','2013-10-27','12:05:00',9.2),('7643','2013-10-27','12:10:00',11.34),('7643','2013-10-27','12:15:00',11.44),('7643','2013-10-27','12:20:00',11.74),('7643','2013-10-27','12:25:00',6.52),('7643','2013-10-27','12:30:00',10.57),('7643','2013-10-27','12:35:00',12.93),('7643','2013-10-27','12:40:00',11.88),('7643','2013-10-27','12:45:00',11.61),('7643','2013-10-27','12:50:00',11.92),('7643','2013-10-27','12:55:00',11.29),('7643','2013-10-27','13:00:00',10.54),('7643','2013-10-27','13:05:00',10.35),('7643','2013-10-27','13:10:00',10.38),('7643','2013-10-27','13:15:00',9.95),('7643','2013-10-27','13:20:00',10.08),('7643','2013-10-27','13:25:00',9.03),('7643','2013-10-27','13:30:00',9.77),('7643','2013-10-27','13:35:00',9.34),('7643','2013-10-27','13:40:00',9.39),('7643','2013-10-27','13:45:00',9.37),('7643','2013-10-27','13:50:00',6.96),('7643','2013-10-27','13:55:00',9.03),('7643','2013-10-27','14:00:00',8.84),('7643','2013-10-27','14:05:00',8.75),('7643','2013-10-27','14:10:00',9.13),('7643','2013-10-27','14:15:00',8.47),('7643','2013-10-27','14:20:00',8.18),('7643','2013-10-27','14:25:00',8.45),('7643','2013-10-27','14:30:00',6.94),('7643','2013-10-27','14:35:00',6.01),('7643','2013-10-27','14:40:00',2.97),('7643','2013-10-27','14:45:00',5.64),('7643','2013-10-27','14:50:00',6.49),('7643','2013-10-27','14:55:00',6.07),('7643','2013-10-27','15:00:00',5.9),('7643','2013-10-27','15:05:00',5.63),('7643','2013-10-27','15:10:00',5.27),('7643','2013-10-27','15:15:00',3.69),('7643','2013-10-27','15:20:00',2.21),('7643','2013-10-27','15:25:00',3.87),('7643','2013-10-27','15:30:00',3.54),('7643','2013-10-27','15:35:00',1.62),('7643','2013-10-27','15:40:00',1.79),('7643','2013-10-27','15:45:00',2.87),('7643','2013-10-27','15:50:00',3.54),('7643','2013-10-27','15:55:00',2.74),('7643','2013-10-27','16:00:00',2.28),('7643','2013-10-27','16:05:00',1.37),('7643','2013-10-27','16:10:00',1.37),('7643','2013-10-27','16:15:00',1.3),('7643','2013-10-27','16:20:00',1.29),('7643','2013-10-27','16:25:00',1.01),('7643','2013-10-26','08:00:00',1.16),('7643','2013-10-26','08:05:00',1.24),('7643','2013-10-26','08:10:00',1.46),('7643','2013-10-26','08:15:00',1.63),('7643','2013-10-26','08:20:00',1.79),('7643','2013-10-26','08:25:00',1.6),('7643','2013-10-26','08:30:00',1.39),('7643','2013-10-26','08:35:00',1.43),('7643','2013-10-26','08:40:00',1.65),('7643','2013-10-26','08:45:00',1.92),('7643','2013-10-26','08:50:00',1.99),('7643','2013-10-26','08:55:00',2.21),('7643','2013-10-26','09:00:00',2.53),('7643','2013-10-26','09:05:00',2.4),('7643','2013-10-26','09:10:00',1.91),('7643','2013-10-26','09:15:00',1.69),('7643','2013-10-26','09:20:00',1.8),('7643','2013-10-26','09:25:00',1.96),('7643','2013-10-26','09:30:00',2.21),('7643','2013-10-26','09:35:00',2.43),('7643','2013-10-26','09:40:00',2.71),('7643','2013-10-26','09:45:00',3.05),('7643','2013-10-26','09:50:00',3.25),('7643','2013-10-26','09:55:00',3.49),('7643','2013-10-26','10:00:00',3.78),('7643','2013-10-26','10:05:00',3.99),('7643','2013-10-26','10:10:00',4.22),('7643','2013-10-26','10:15:00',4.33),('7643','2013-10-26','10:20:00',4.99),('7643','2013-10-26','10:25:00',4.77),('7643','2013-10-26','10:30:00',4.7),('7643','2013-10-26','10:35:00',4.6),('7643','2013-10-26','10:40:00',4.47),('7643','2013-10-26','10:45:00',5.02),('7643','2013-10-26','10:50:00',5.1),('7643','2013-10-26','10:55:00',4.64),('7643','2013-10-26','11:00:00',4.21),('7643','2013-10-26','11:05:00',3.61),('7643','2013-10-26','11:10:00',2.86),('7643','2013-10-26','11:15:00',2.27),('7643','2013-10-26','11:20:00',2.03),('7643','2013-10-26','11:25:00',2.33),('7643','2013-10-26','11:30:00',3.18),('7643','2013-10-26','11:35:00',4.5),('7643','2013-10-26','11:40:00',6.81),('7643','2013-10-26','11:45:00',6.79),('7643','2013-10-26','11:50:00',8.32),('7643','2013-10-26','11:55:00',4.13),('7643','2013-10-26','12:00:00',3.72),('7643','2013-10-26','12:05:00',4.3),('7643','2013-10-26','12:10:00',4.52),('7643','2013-10-26','12:15:00',6.08),('7643','2013-10-26','12:20:00',9.03),('7643','2013-10-26','12:25:00',9.36),('7643','2013-10-26','12:30:00',8.28),('7643','2013-10-26','12:35:00',10.67),('7643','2013-10-26','12:40:00',9.73),('7643','2013-10-26','12:45:00',10.48),('7643','2013-10-26','12:50:00',11.28),('7643','2013-10-26','12:55:00',11),('7643','2013-10-26','13:00:00',9.52),('7643','2013-10-26','13:05:00',5.76),('7643','2013-10-26','13:10:00',6.29),('7643','2013-10-26','13:15:00',4.61),('7643','2013-10-26','13:20:00',3.52),('7643','2013-10-26','13:25:00',5.27),('7643','2013-10-26','13:30:00',7.8),('7643','2013-10-26','13:35:00',6.98),('7643','2013-10-26','13:40:00',4.67),('7643','2013-10-26','13:45:00',3.01),('7643','2013-10-26','13:50:00',2.42),('7643','2013-10-26','13:55:00',2.37),('7643','2013-10-26','14:00:00',3.16),('7643','2013-10-26','14:05:00',4.55),('7643','2013-10-26','14:10:00',3.63),('7643','2013-10-26','14:15:00',3.35),('7643','2013-10-26','14:20:00',3.7),('7643','2013-10-26','14:25:00',3.85),('7643','2013-10-26','14:30:00',3.22),('7643','2013-10-26','14:35:00',3.81),('7643','2013-10-26','14:40:00',5.64),('7643','2013-10-26','14:45:00',6.53),('7643','2013-10-26','14:50:00',5.48),('7643','2013-10-26','14:55:00',5.52),('7643','2013-10-26','15:00:00',5.72),('7643','2013-10-26','15:05:00',4.72),('7643','2013-10-26','15:10:00',4.82),('7643','2013-10-26','15:15:00',4.93),('7643','2013-10-26','15:20:00',4.69),('7643','2013-10-26','15:25:00',4.38),('7643','2013-10-26','15:30:00',3.51),('7643','2013-10-26','15:35:00',2.89),('7643','2013-10-26','15:40:00',1.04),('7643','2013-10-26','15:45:00',1.1),('7643','2013-10-26','15:50:00',2.55),('7643','2013-10-26','15:55:00',1.86),('7643','2013-10-26','16:00:00',2.13),('7643','2013-10-26','16:05:00',1.92),('7643','2013-10-26','16:10:00',1.67),('7643','2013-10-26','16:15:00',1.34),('7643','2013-10-25','08:15:00',1.21),('7643','2013-10-25','08:20:00',1.47),('7643','2013-10-25','08:25:00',1.72),('7643','2013-10-25','08:30:00',2.01),('7643','2013-10-25','08:35:00',2.33),('7643','2013-10-25','08:40:00',2.61),('7643','2013-10-25','08:45:00',2.88),('7643','2013-10-25','08:50:00',3.17),('7643','2013-10-25','08:55:00',3.44),('7643','2013-10-25','09:00:00',3.71),('7643','2013-10-25','09:05:00',3.98),('7643','2013-10-25','09:10:00',4.3),('7643','2013-10-25','09:15:00',4.6),('7643','2013-10-25','09:20:00',4.91),('7643','2013-10-25','09:25:00',5.2),('7643','2013-10-25','09:30:00',5.49),('7643','2013-10-25','09:35:00',5.71),('7643','2013-10-25','09:40:00',5.98),('7643','2013-10-25','09:45:00',6.23),('7643','2013-10-25','09:50:00',6.47),('7643','2013-10-25','09:55:00',6.74),('7643','2013-10-25','10:00:00',6.97),('7643','2013-10-25','10:05:00',7.28),('7643','2013-10-25','10:10:00',7.49),('7643','2013-10-25','10:15:00',7.65),('7643','2013-10-25','10:20:00',7.88),('7643','2013-10-25','10:25:00',8.07),('7643','2013-10-25','10:30:00',8.25),('7643','2013-10-25','10:35:00',8.42),('7643','2013-10-25','10:40:00',8.61),('7643','2013-10-25','10:45:00',8.84),('7643','2013-10-25','10:50:00',9.04),('7643','2013-10-25','10:55:00',9.15),('7643','2013-10-25','11:00:00',9.25),('7643','2013-10-25','11:05:00',9.47),('7643','2013-10-25','11:10:00',9.69),('7643','2013-10-25','11:15:00',9.79),('7643','2013-10-25','11:20:00',9.88),('7643','2013-10-25','11:25:00',10.02),('7643','2013-10-25','11:30:00',10.06),('7643','2013-10-25','11:35:00',10.15),('7643','2013-10-25','11:40:00',10.26),('7643','2013-10-25','11:45:00',10.36),('7643','2013-10-25','11:50:00',10.38),('7643','2013-10-25','11:55:00',10.38),('7643','2013-10-25','12:00:00',10.54),('7643','2013-10-25','12:05:00',10.44),('7643','2013-10-25','12:10:00',10.32),('7643','2013-10-25','12:15:00',10.5),('7643','2013-10-25','12:20:00',10.54),('7643','2013-10-25','12:25:00',10.75),('7643','2013-10-25','12:30:00',10.66),('7643','2013-10-25','12:35:00',10.59),('7643','2013-10-25','12:40:00',10.54),('7643','2013-10-25','12:45:00',10.56),('7643','2013-10-25','12:50:00',10.53),('7643','2013-10-25','12:55:00',9.35),('7643','2013-10-25','13:00:00',8.37),('7643','2013-10-25','13:05:00',7.22),('7643','2013-10-25','13:10:00',10.7),('7643','2013-10-25','13:15:00',10.44),('7643','2013-10-25','13:20:00',10.58),('7643','2013-10-25','13:25:00',10.3),('7643','2013-10-25','13:30:00',10.17),('7643','2013-10-25','13:35:00',10.49),('7643','2013-10-25','13:40:00',10.22),('7643','2013-10-25','13:45:00',8.88),('7643','2013-10-25','13:50:00',9.71),('7643','2013-10-25','13:55:00',9.93),('7643','2013-10-25','14:00:00',9.25),('7643','2013-10-25','14:05:00',8.81),('7643','2013-10-25','14:10:00',9.28),('7643','2013-10-25','14:15:00',6.34),('7643','2013-10-25','14:20:00',3.91),('7643','2013-10-25','14:25:00',7.79),('7643','2013-10-25','14:30:00',7.73),('7643','2013-10-25','14:35:00',8.17),('7643','2013-10-25','14:40:00',8.36),('7643','2013-10-25','14:45:00',7.65),('7643','2013-10-25','14:50:00',8.11),('7643','2013-10-25','14:55:00',7.79),('7643','2013-10-25','15:00:00',7.93),('7643','2013-10-25','15:05:00',7.66),('7643','2013-10-25','15:10:00',7.69),('7643','2013-10-25','15:15:00',7.14),('7643','2013-10-25','15:20:00',6.88),('7643','2013-10-25','15:25:00',6.52),('7643','2013-10-25','15:30:00',6.12),('7643','2013-10-25','15:35:00',6.15),('7643','2013-10-25','15:40:00',6.47),('7643','2013-10-25','15:45:00',6.04),('7643','2013-10-25','15:50:00',6.05),('7643','2013-10-25','15:55:00',5.4),('7643','2013-10-25','16:00:00',4.76),('7643','2013-10-25','16:05:00',4.56),('7643','2013-10-25','16:10:00',4.7),('7643','2013-10-25','16:15:00',4.26),('7643','2013-10-25','16:20:00',4.1),('7643','2013-10-25','16:25:00',3.72),('7643','2013-10-25','16:30:00',3.57),('7643','2013-10-25','16:35:00',3.23),('7643','2013-10-25','16:40:00',3.01),('7643','2013-10-25','16:45:00',2.78),('7643','2013-10-25','16:50:00',2.48),('7643','2013-10-25','16:55:00',2.27),('7643','2013-10-25','17:00:00',1.99),('7643','2013-10-25','17:05:00',1.75),('7643','2013-10-25','17:10:00',1.53),('7643','2013-10-25','17:15:00',1.32),('7643','2013-10-25','17:20:00',1.09),('7643','2013-10-24','08:10:00',1.02),('7643','2013-10-24','08:15:00',1.25),('7643','2013-10-24','08:20:00',1.52),('7643','2013-10-24','08:25:00',1.77),('7643','2013-10-24','08:30:00',2.05),('7643','2013-10-24','08:35:00',2.34),('7643','2013-10-24','08:40:00',2.63),('7643','2013-10-24','08:45:00',2.94),('7643','2013-10-24','08:50:00',3.25),('7643','2013-10-24','08:55:00',3.48),('7643','2013-10-24','09:00:00',3.78),('7643','2013-10-24','09:05:00',4.09),('7643','2013-10-24','09:10:00',4.38),('7643','2013-10-24','09:15:00',4.67),('7643','2013-10-24','09:20:00',4.99),('7643','2013-10-24','09:25:00',5.28),('7643','2013-10-24','09:30:00',5.52),('7643','2013-10-24','09:35:00',5.78),('7643','2013-10-24','09:40:00',6.07),('7643','2013-10-24','09:45:00',6.36),('7643','2013-10-24','09:50:00',6.62),('7643','2013-10-24','09:55:00',6.88),('7643','2013-10-24','10:00:00',7.12),('7643','2013-10-24','10:05:00',7.36),('7643','2013-10-24','10:10:00',7.59),('7643','2013-10-24','10:15:00',7.81),('7643','2013-10-24','10:20:00',7.98),('7643','2013-10-24','10:25:00',8.24),('7643','2013-10-24','10:30:00',8.5),('7643','2013-10-24','10:35:00',8.64),('7643','2013-10-24','10:40:00',8.86),('7643','2013-10-24','10:45:00',9.05),('7643','2013-10-24','10:50:00',9.14),('7643','2013-10-24','10:55:00',9.34),('7643','2013-10-24','11:00:00',9.55),('7643','2013-10-24','11:05:00',9.63),('7643','2013-10-24','11:10:00',9.81),('7643','2013-10-24','11:15:00',9.88),('7643','2013-10-24','11:20:00',9.91),('7643','2013-10-24','11:25:00',9.94),('7643','2013-10-24','11:30:00',10.1),('7643','2013-10-24','11:35:00',10.18),('7643','2013-10-24','11:40:00',10.48),('7643','2013-10-24','11:45:00',10.62),('7643','2013-10-24','11:50:00',10.6),('7643','2013-10-24','11:55:00',10.77),('7643','2013-10-24','12:00:00',10.82),('7643','2013-10-24','12:05:00',10.92),('7643','2013-10-24','12:10:00',10.88),('7643','2013-10-24','12:15:00',10.98),('7643','2013-10-24','12:20:00',11.02),('7643','2013-10-24','12:25:00',11.08),('7643','2013-10-24','12:30:00',11.11),('7643','2013-10-24','12:35:00',11),('7643','2013-10-24','12:40:00',11.1),('7643','2013-10-24','12:45:00',11.12),('7643','2013-10-24','12:50:00',11.14),('7643','2013-10-24','12:55:00',11.05),('7643','2013-10-24','13:00:00',10.98),('7643','2013-10-24','13:05:00',10.97),('7643','2013-10-24','13:10:00',10.91),('7643','2013-10-24','13:15:00',10.93),('7643','2013-10-24','13:20:00',10.84),('7643','2013-10-24','13:25:00',10.87),('7643','2013-10-24','13:30:00',10.66),('7643','2013-10-24','13:35:00',10.57),('7643','2013-10-24','13:40:00',10.59),('7643','2013-10-24','13:45:00',10.39),('7643','2013-10-24','13:50:00',10.24),('7643','2013-10-24','13:55:00',10.21),('7643','2013-10-24','14:00:00',10.2),('7643','2013-10-24','14:05:00',9.98),('7643','2013-10-24','14:10:00',9.93),('7643','2013-10-24','14:15:00',9.73),('7643','2013-10-24','14:20:00',9.73),('7643','2013-10-24','14:25:00',9.65),('7643','2013-10-24','14:30:00',9.45),('7643','2013-10-24','14:35:00',9.37),('7643','2013-10-24','14:40:00',9.13),('7643','2013-10-24','14:45:00',8.99),('7643','2013-10-24','14:50:00',8.82),('7643','2013-10-24','14:55:00',8.68),('7643','2013-10-24','15:00:00',8.32),('7643','2013-10-24','15:05:00',8.2),('7643','2013-10-24','15:10:00',8.11),('7643','2013-10-24','15:15:00',7.88),('7643','2013-10-24','15:20:00',7.55),('7643','2013-10-24','15:25:00',7.36),('7643','2013-10-24','15:30:00',7.02),('7643','2013-10-24','15:35:00',6.7),('7643','2013-10-24','15:40:00',6.6),('7643','2013-10-24','15:45:00',6.35),('7643','2013-10-24','15:50:00',6.13),('7643','2013-10-24','15:55:00',5.78),('7643','2013-10-24','16:00:00',5.59),('7643','2013-10-24','16:05:00',5.36),('7643','2013-10-24','16:10:00',5.11),('7643','2013-10-24','16:15:00',4.87),('7643','2013-10-24','16:20:00',4.65),('7643','2013-10-24','16:25:00',4.39),('7643','2013-10-24','16:30:00',4.13),('7643','2013-10-24','16:35:00',3.82),('7643','2013-10-24','16:40:00',3.54),('7643','2013-10-24','16:45:00',3.24),('7643','2013-10-24','16:50:00',2.99),('7643','2013-10-24','16:55:00',2.74),('7643','2013-10-24','17:00:00',2.44),('7643','2013-10-24','17:05:00',2.15),('7643','2013-10-24','17:10:00',1.86),('7643','2013-10-24','17:15:00',1.59),('7643','2013-10-24','17:20:00',1.36),('7643','2013-10-24','17:25:00',1.13),('7643','2013-10-23','08:20:00',1.29),('7643','2013-10-23','08:25:00',2.17),('7643','2013-10-23','08:30:00',2.72),('7643','2013-10-23','08:35:00',1.8),('7643','2013-10-23','08:40:00',1.43),('7643','2013-10-23','08:45:00',1.57),('7643','2013-10-23','08:50:00',2.12),('7643','2013-10-23','08:55:00',3.04),('7643','2013-10-23','09:00:00',3.1),('7643','2013-10-23','09:05:00',3.38),('7643','2013-10-23','09:10:00',3.99),('7643','2013-10-23','09:15:00',5.38),('7643','2013-10-23','09:20:00',5.39),('7643','2013-10-23','09:25:00',3.26),('7643','2013-10-23','09:30:00',3.39),('7643','2013-10-23','09:35:00',3.73),('7643','2013-10-23','09:40:00',3.99),('7643','2013-10-23','09:45:00',4.14),('7643','2013-10-23','09:50:00',4.43),('7643','2013-10-23','09:55:00',4.05),('7643','2013-10-23','10:00:00',3.97),('7643','2013-10-23','10:05:00',3.87),('7643','2013-10-23','10:10:00',3.6),('7643','2013-10-23','10:15:00',3.38),('7643','2013-10-23','10:20:00',5.64),('7643','2013-10-23','10:25:00',3.55),('7643','2013-10-23','10:30:00',2.61),('7643','2013-10-23','10:35:00',5.39),('7643','2013-10-23','10:40:00',4.67),('7643','2013-10-23','10:45:00',7.47),('7643','2013-10-23','10:50:00',5.66),('7643','2013-10-23','10:55:00',7.78),('7643','2013-10-23','11:00:00',9.97),('7643','2013-10-23','11:05:00',12.97),('7643','2013-10-23','11:10:00',10.31),('7643','2013-10-23','11:15:00',8.23),('7643','2013-10-23','11:20:00',6.71),('7643','2013-10-23','11:25:00',6.15),('7643','2013-10-23','11:30:00',5.72),('7643','2013-10-23','11:35:00',4.3),('7643','2013-10-23','11:40:00',4.43),('7643','2013-10-23','11:45:00',4.28),('7643','2013-10-23','11:50:00',5.4),('7643','2013-10-23','11:55:00',10.16),('7643','2013-10-23','12:00:00',6.91),('7643','2013-10-23','12:05:00',5.09),('7643','2013-10-23','12:10:00',4.75),('7643','2013-10-23','12:15:00',4.67),('7643','2013-10-23','12:20:00',4.81),('7643','2013-10-23','12:25:00',5.26),('7643','2013-10-23','12:30:00',5.59),('7643','2013-10-23','12:35:00',6.01),('7643','2013-10-23','12:40:00',6.97),('7643','2013-10-23','12:45:00',9.36),('7643','2013-10-23','12:50:00',8.58),('7643','2013-10-23','12:55:00',9.92),('7643','2013-10-23','13:00:00',13.67),('7643','2013-10-23','13:05:00',12.21),('7643','2013-10-23','13:10:00',10.4),('7643','2013-10-23','13:15:00',8.85),('7643','2013-10-23','13:20:00',9.13),('7643','2013-10-23','13:25:00',6.51),('7643','2013-10-23','13:30:00',5.13),('7643','2013-10-23','13:35:00',4.79),('7643','2013-10-23','13:40:00',4.77),('7643','2013-10-23','13:45:00',4.97),('7643','2013-10-23','13:50:00',6.84),('7643','2013-10-23','13:55:00',6.85),('7643','2013-10-23','14:00:00',8.91),('7643','2013-10-23','14:05:00',6.82),('7643','2013-10-23','14:10:00',5.2),('7643','2013-10-23','14:15:00',4.97),('7643','2013-10-23','14:20:00',5.27),('7643','2013-10-23','14:25:00',5.33),('7643','2013-10-23','14:30:00',5.37),('7643','2013-10-23','14:35:00',5.94),('7643','2013-10-23','14:40:00',5.89),('7643','2013-10-23','14:45:00',6.63),('7643','2013-10-23','14:50:00',7.4),('7643','2013-10-23','14:55:00',3.47),('7643','2013-10-23','15:00:00',3.72),('7643','2013-10-23','15:05:00',3.9),('7643','2013-10-23','15:10:00',8.14),('7643','2013-10-23','15:15:00',5.14),('7643','2013-10-23','15:20:00',4.43),('7643','2013-10-23','15:25:00',4.54),('7643','2013-10-23','15:30:00',3.96),('7643','2013-10-23','15:35:00',9.12),('7643','2013-10-23','15:40:00',7.69),('7643','2013-10-23','15:45:00',6.1),('7643','2013-10-23','15:50:00',4.97),('7643','2013-10-23','15:55:00',2.76),('7643','2013-10-23','16:00:00',2.58),('7643','2013-10-23','16:05:00',2.51),('7643','2013-10-23','16:10:00',2.39),('7643','2013-10-23','16:15:00',2.36),('7643','2013-10-23','16:20:00',2.27),('7643','2013-10-23','16:25:00',1.95),('7643','2013-10-23','16:30:00',1.6),('7643','2013-10-23','16:35:00',1.38),('7643','2013-10-23','16:40:00',1.2),('7643','2013-10-23','16:45:00',1.03),('7643','2013-10-22','09:20:00',1.27),('7643','2013-10-22','09:25:00',1.42),('7643','2013-10-22','09:30:00',1.52),('7643','2013-10-22','09:35:00',1.67),('7643','2013-10-22','09:40:00',1.69),('7643','2013-10-22','09:45:00',2.52),('7643','2013-10-22','09:50:00',2.22),('7643','2013-10-22','09:55:00',2.05),('7643','2013-10-22','10:00:00',2.26),('7643','2013-10-22','10:05:00',2.55),('7643','2013-10-22','10:10:00',2.45),('7643','2013-10-22','10:15:00',3),('7643','2013-10-22','10:20:00',3.3),('7643','2013-10-22','10:25:00',4.13),('7643','2013-10-22','10:30:00',3.92),('7643','2013-10-22','10:35:00',3.68),('7643','2013-10-22','10:40:00',3.37),('7643','2013-10-22','10:45:00',4.44),('7643','2013-10-22','10:50:00',4.31),('7643','2013-10-22','10:55:00',6.03),('7643','2013-10-22','11:00:00',6.83),('7643','2013-10-22','11:05:00',6.37),('7643','2013-10-22','11:10:00',5.68),('7643','2013-10-22','11:15:00',7.16),('7643','2013-10-22','11:20:00',7.71),('7643','2013-10-22','11:25:00',9.34),('7643','2013-10-22','11:30:00',10.62),('7643','2013-10-22','11:35:00',9.71),('7643','2013-10-22','11:40:00',10.35),('7643','2013-10-22','11:45:00',10.25),('7643','2013-10-22','11:50:00',10.52),('7643','2013-10-22','11:55:00',10.38),('7643','2013-10-22','12:00:00',10.49),('7643','2013-10-22','12:05:00',10.83),('7643','2013-10-22','12:10:00',10.8),('7643','2013-10-22','12:15:00',10.55),('7643','2013-10-22','12:20:00',10.16),('7643','2013-10-22','12:25:00',10.58),('7643','2013-10-22','12:30:00',10.16),('7643','2013-10-22','12:35:00',10.43),('7643','2013-10-22','12:40:00',10.68),('7643','2013-10-22','12:45:00',10.26),('7643','2013-10-22','12:50:00',10.01),('7643','2013-10-22','12:55:00',7.36),('7643','2013-10-22','13:00:00',9.51),('7643','2013-10-22','13:05:00',8.73),('7643','2013-10-22','13:10:00',9.84),('7643','2013-10-22','13:15:00',9.19),('7643','2013-10-22','13:20:00',10.08),('7643','2013-10-22','13:25:00',9.94),('7643','2013-10-22','13:30:00',9.88),('7643','2013-10-22','13:35:00',9.7),('7643','2013-10-22','13:40:00',9.47),('7643','2013-10-22','13:45:00',9.49),('7643','2013-10-22','13:50:00',9.83),('7643','2013-10-22','13:55:00',9.73),('7643','2013-10-22','14:00:00',8.09),('7643','2013-10-22','14:05:00',8.6),('7643','2013-10-22','14:10:00',8.98),('7643','2013-10-22','14:15:00',8.85),('7643','2013-10-22','14:20:00',9.1),('7643','2013-10-22','14:25:00',9.28),('7643','2013-10-22','14:30:00',8.98),('7643','2013-10-22','14:35:00',8.9),('7643','2013-10-22','14:40:00',8.23),('7643','2013-10-22','14:45:00',8.38),('7643','2013-10-22','14:50:00',7.94),('7643','2013-10-22','14:55:00',8.63),('7643','2013-10-22','15:00:00',8.39),('7643','2013-10-22','15:05:00',8.29),('7643','2013-10-22','15:10:00',7.8),('7643','2013-10-22','15:15:00',7.77),('7643','2013-10-22','15:20:00',7.76),('7643','2013-10-22','15:25:00',7.71),('7643','2013-10-22','15:30:00',7.27),('7643','2013-10-22','15:35:00',6.82),('7643','2013-10-22','15:40:00',7.1),('7643','2013-10-22','15:45:00',6.98),('7643','2013-10-22','15:50:00',6.18),('7643','2013-10-22','15:55:00',4.75),('7643','2013-10-22','16:00:00',3.99),('7643','2013-10-22','16:05:00',3.44),('7643','2013-10-22','16:10:00',3.28),('7643','2013-10-22','16:15:00',3.56),('7643','2013-10-22','16:20:00',3.2),('7643','2013-10-22','16:25:00',3.09),('7643','2013-10-22','16:30:00',2.79),('7643','2013-10-22','16:35:00',3.53),('7643','2013-10-22','16:40:00',3.6),('7643','2013-10-22','16:45:00',3.09),('7643','2013-10-22','16:50:00',2.7),('7643','2013-10-22','16:55:00',2.39),('7643','2013-10-22','17:00:00',2.28),('7643','2013-10-22','17:05:00',1.88),('7643','2013-10-22','17:10:00',1.58),('7643','2013-10-22','17:15:00',1.22),('7643','2013-10-21','08:10:00',1.11),('7643','2013-10-21','08:15:00',1.35),('7643','2013-10-21','08:20:00',1.6),('7643','2013-10-21','08:25:00',1.85),('7643','2013-10-21','08:30:00',2.11),('7643','2013-10-21','08:35:00',2.4),('7643','2013-10-21','08:40:00',2.69),('7643','2013-10-21','08:45:00',2.97),('7643','2013-10-21','08:50:00',3.27),('7643','2013-10-21','08:55:00',3.57),('7643','2013-10-21','09:00:00',3.84),('7643','2013-10-21','09:05:00',4.13),('7643','2013-10-21','09:10:00',4.46),('7643','2013-10-21','09:15:00',4.73),('7643','2013-10-21','09:20:00',4.99),('7643','2013-10-21','09:25:00',5.27),('7643','2013-10-21','09:30:00',5.56),('7643','2013-10-21','09:35:00',5.86),('7643','2013-10-21','09:40:00',6.15),('7643','2013-10-21','09:45:00',6.41),('7643','2013-10-21','09:50:00',6.65),('7643','2013-10-21','09:55:00',6.92),('7643','2013-10-21','10:00:00',7.13),('7643','2013-10-21','10:05:00',7.42),('7643','2013-10-21','10:10:00',7.58),('7643','2013-10-21','10:15:00',7.77),('7643','2013-10-21','10:20:00',7.98),('7643','2013-10-21','10:25:00',8.23),('7643','2013-10-21','10:30:00',8.45),('7643','2013-10-21','10:35:00',8.61),('7643','2013-10-21','10:40:00',8.77),('7643','2013-10-21','10:45:00',8.92),('7643','2013-10-21','10:50:00',9.08),('7643','2013-10-21','10:55:00',9.31),('7643','2013-10-21','11:00:00',9.27),('7643','2013-10-21','11:05:00',9.54),('7643','2013-10-21','11:10:00',9.48),('7643','2013-10-21','11:15:00',9.77),('7643','2013-10-21','11:20:00',9.8),('7643','2013-10-21','11:25:00',9.93),('7643','2013-10-21','11:30:00',10.02),('7643','2013-10-21','11:35:00',9.98),('7643','2013-10-21','11:40:00',10),('7643','2013-10-21','11:45:00',10.12),('7643','2013-10-21','11:50:00',10.2),('7643','2013-10-21','11:55:00',10.3),('7643','2013-10-21','12:00:00',10.45),('7643','2013-10-21','12:05:00',10.58),('7643','2013-10-21','12:10:00',10.5),('7643','2013-10-21','12:15:00',10.51),('7643','2013-10-21','12:20:00',10.52),('7643','2013-10-21','12:25:00',10.18),('7643','2013-10-21','12:30:00',10.44),('7643','2013-10-21','12:35:00',10.21),('7643','2013-10-21','12:40:00',10.05),('7643','2013-10-21','12:45:00',10.28),('7643','2013-10-21','12:50:00',9.75),('7643','2013-10-21','12:55:00',10.24),('7643','2013-10-21','13:00:00',10.67),('7643','2013-10-21','13:05:00',10.75),('7643','2013-10-21','13:10:00',10.53),('7643','2013-10-21','13:15:00',10.42),('7643','2013-10-21','13:20:00',10.45),('7643','2013-10-21','13:25:00',10.58),('7643','2013-10-21','13:30:00',9.53),('7643','2013-10-21','13:35:00',9.47),('7643','2013-10-21','13:40:00',9.98),('7643','2013-10-21','13:45:00',10.46),('7643','2013-10-21','13:50:00',10.04),('7643','2013-10-21','13:55:00',9.4),('7643','2013-10-21','14:00:00',9.25),('7643','2013-10-21','14:05:00',8.4),('7643','2013-10-21','14:10:00',4.17),('7643','2013-10-21','14:15:00',7.56),('7643','2013-10-21','14:20:00',9.99),('7643','2013-10-21','14:25:00',9.85),('7643','2013-10-21','14:30:00',9.06),('7643','2013-10-21','14:35:00',6.74),('7643','2013-10-21','14:40:00',8.07),('7643','2013-10-21','14:45:00',8.5),('7643','2013-10-21','14:50:00',8.13),('7643','2013-10-21','14:55:00',8.2),('7643','2013-10-21','15:00:00',7.96),('7643','2013-10-21','15:05:00',7.95),('7643','2013-10-21','15:10:00',7.71),('7643','2013-10-21','15:15:00',7.48),('7643','2013-10-21','15:20:00',7.08),('7643','2013-10-21','15:25:00',7.02),('7643','2013-10-21','15:30:00',6.97),('7643','2013-10-21','15:35:00',7.07),('7643','2013-10-21','15:40:00',7.12),('7643','2013-10-21','15:45:00',6.86),('7643','2013-10-21','15:50:00',5.66),('7643','2013-10-21','15:55:00',5.9),('7643','2013-10-21','16:00:00',5.42),('7643','2013-10-21','16:05:00',5.02),('7643','2013-10-21','16:10:00',4.79),('7643','2013-10-21','16:15:00',4.62),('7643','2013-10-21','16:20:00',4.37),('7643','2013-10-21','16:25:00',4.06),('7643','2013-10-21','16:30:00',3.98),('7643','2013-10-21','16:35:00',3.69),('7643','2013-10-21','16:40:00',3.41),('7643','2013-10-21','16:45:00',3.17),('7643','2013-10-21','16:50:00',2.91),('7643','2013-10-21','16:55:00',2.7),('7643','2013-10-21','17:00:00',2.43),('7643','2013-10-21','17:05:00',2.16),('7643','2013-10-21','17:10:00',1.88),('7643','2013-10-21','17:15:00',1.6),('7643','2013-10-21','17:20:00',1.34),('7643','2013-10-21','17:25:00',1.11),('7643','2013-10-20','07:55:00',1.03),('7643','2013-10-20','08:00:00',1.24),('7643','2013-10-20','08:05:00',1.43),('7643','2013-10-20','08:10:00',1.7),('7643','2013-10-20','08:15:00',1.73),('7643','2013-10-20','08:20:00',2.2),('7643','2013-10-20','08:25:00',2.29),('7643','2013-10-20','08:30:00',2.47),('7643','2013-10-20','08:35:00',2.57),('7643','2013-10-20','08:40:00',2.91),('7643','2013-10-20','08:45:00',3.09),('7643','2013-10-20','08:50:00',2.77),('7643','2013-10-20','08:55:00',3.33),('7643','2013-10-20','09:00:00',2.62),('7643','2013-10-20','09:05:00',2.99),('7643','2013-10-20','09:10:00',4.11),('7643','2013-10-20','09:15:00',4.47),('7643','2013-10-20','09:20:00',5.5),('7643','2013-10-20','09:25:00',5.86),('7643','2013-10-20','09:30:00',5.47),('7643','2013-10-20','09:35:00',5.09),('7643','2013-10-20','09:40:00',6.17),('7643','2013-10-20','09:45:00',5.16),('7643','2013-10-20','09:50:00',5.78),('7643','2013-10-20','09:55:00',6.75),('7643','2013-10-20','10:00:00',6.71),('7643','2013-10-20','10:05:00',7.47),('7643','2013-10-20','10:10:00',7.9),('7643','2013-10-20','10:15:00',8.17),('7643','2013-10-20','10:20:00',8.26),('7643','2013-10-20','10:25:00',8.55),('7643','2013-10-20','10:30:00',8.41),('7643','2013-10-20','10:35:00',8.51),('7643','2013-10-20','10:40:00',8.35),('7643','2013-10-20','10:45:00',8.63),('7643','2013-10-20','10:50:00',9.23),('7643','2013-10-20','10:55:00',9.07),('7643','2013-10-20','11:00:00',9.69),('7643','2013-10-20','11:05:00',9.28),('7643','2013-10-20','11:10:00',8.39),('7643','2013-10-20','11:15:00',10.3),('7643','2013-10-20','11:20:00',10.2),('7643','2013-10-20','11:25:00',10.2),('7643','2013-10-20','11:30:00',10.51),('7643','2013-10-20','11:35:00',10.54),('7643','2013-10-20','11:40:00',10.38),('7643','2013-10-20','11:45:00',10.76),('7643','2013-10-20','11:50:00',10.79),('7643','2013-10-20','11:55:00',10.88),('7643','2013-10-20','12:00:00',11.08),('7643','2013-10-20','12:05:00',11.22),('7643','2013-10-20','12:10:00',11.33),('7643','2013-10-20','12:15:00',11.27),('7643','2013-10-20','12:20:00',11.18),('7643','2013-10-20','12:25:00',11.26),('7643','2013-10-20','12:30:00',10.84),('7643','2013-10-20','12:35:00',10.98),('7643','2013-10-20','12:40:00',11.26),('7643','2013-10-20','12:45:00',11.32),('7643','2013-10-20','12:50:00',11.22),('7643','2013-10-20','12:55:00',11.2),('7643','2013-10-20','13:00:00',11.09),('7643','2013-10-20','13:05:00',10.95),('7643','2013-10-20','13:10:00',10.43),('7643','2013-10-20','13:15:00',10.96),('7643','2013-10-20','13:20:00',10.66),('7643','2013-10-20','13:25:00',10.91),('7643','2013-10-20','13:30:00',11.06),('7643','2013-10-20','13:35:00',11.04),('7643','2013-10-20','13:40:00',10.95),('7643','2013-10-20','13:45:00',10.84),('7643','2013-10-20','13:50:00',10.68),('7643','2013-10-20','13:55:00',10.22),('7643','2013-10-20','14:00:00',10.02),('7643','2013-10-20','14:05:00',10.28),('7643','2013-10-20','14:10:00',10.16),('7643','2013-10-20','14:15:00',9.99),('7643','2013-10-20','14:20:00',9.95),('7643','2013-10-20','14:25:00',9.63),('7643','2013-10-20','14:30:00',9.32),('7643','2013-10-20','14:35:00',9.21),('7643','2013-10-20','14:40:00',8.76),('7643','2013-10-20','14:45:00',8.65),('7643','2013-10-20','14:50:00',8.41),('7643','2013-10-20','14:55:00',8.36),('7643','2013-10-20','15:00:00',8.53),('7643','2013-10-20','15:05:00',8.46),('7643','2013-10-20','15:10:00',8.07),('7643','2013-10-20','15:15:00',7.97),('7643','2013-10-20','15:20:00',7.85),('7643','2013-10-20','15:25:00',7.56),('7643','2013-10-20','15:30:00',7.3),('7643','2013-10-20','15:35:00',6.86),('7643','2013-10-20','15:40:00',6.85),('7643','2013-10-20','15:45:00',6.59),('7643','2013-10-20','15:50:00',6.33),('7643','2013-10-20','15:55:00',6.15),('7643','2013-10-20','16:00:00',5.93),('7643','2013-10-20','16:05:00',5.62),('7643','2013-10-20','16:10:00',5.47),('7643','2013-10-20','16:15:00',5.16),('7643','2013-10-20','16:20:00',4.83),('7643','2013-10-20','16:25:00',4.58),('7643','2013-10-20','16:30:00',4.3),('7643','2013-10-20','16:35:00',3.98),('7643','2013-10-20','16:40:00',3.66),('7643','2013-10-20','16:45:00',3.4),('7643','2013-10-20','16:50:00',3.11),('7643','2013-10-20','16:55:00',2.73),('7643','2013-10-20','17:00:00',2.51),('7643','2013-10-20','17:05:00',2.25),('7643','2013-10-20','17:10:00',2.18),('7643','2013-10-20','17:15:00',1.96),('7643','2013-10-20','17:20:00',1.6),('7643','2013-10-20','17:25:00',1.44),('7643','2013-10-20','17:30:00',1.27),('7643','2013-10-20','17:35:00',1.04),('7643','2013-10-19','08:15:00',1.29),('7643','2013-10-19','08:20:00',2.01),('7643','2013-10-19','08:25:00',2.44),('7643','2013-10-19','08:30:00',2.75),('7643','2013-10-19','08:35:00',2.98),('7643','2013-10-19','08:40:00',3.19),('7643','2013-10-19','08:45:00',3.44),('7643','2013-10-19','08:50:00',3.74),('7643','2013-10-19','08:55:00',4.04),('7643','2013-10-19','09:00:00',4.31),('7643','2013-10-19','09:05:00',4.5),('7643','2013-10-19','09:10:00',4.91),('7643','2013-10-19','09:15:00',5.18),('7643','2013-10-19','09:20:00',5.58),('7643','2013-10-19','09:25:00',5.84),('7643','2013-10-19','09:30:00',6.1),('7643','2013-10-19','09:35:00',6.34),('7643','2013-10-19','09:40:00',6.65),('7643','2013-10-19','09:45:00',6.94),('7643','2013-10-19','09:50:00',7.17),('7643','2013-10-19','09:55:00',7.28),('7643','2013-10-19','10:00:00',7.68),('7643','2013-10-19','10:05:00',7.93),('7643','2013-10-19','10:10:00',8.16),('7643','2013-10-19','10:15:00',8.41),('7643','2013-10-19','10:20:00',8.61),('7643','2013-10-19','10:25:00',8.8),('7643','2013-10-19','10:30:00',9.01),('7643','2013-10-19','10:35:00',9.21),('7643','2013-10-19','10:40:00',9.39),('7643','2013-10-19','10:45:00',9.51),('7643','2013-10-19','10:50:00',9.66),('7643','2013-10-19','10:55:00',9.86),('7643','2013-10-19','11:00:00',9.98),('7643','2013-10-19','11:05:00',10.17),('7643','2013-10-19','11:10:00',10.3),('7643','2013-10-19','11:15:00',10.44),('7643','2013-10-19','11:20:00',10.58),('7643','2013-10-19','11:25:00',10.71),('7643','2013-10-19','11:30:00',10.72),('7643','2013-10-19','11:35:00',10.82),('7643','2013-10-19','11:40:00',11),('7643','2013-10-19','11:45:00',10.94),('7643','2013-10-19','11:50:00',10.72),('7643','2013-10-19','11:55:00',11.08),('7643','2013-10-19','12:00:00',11.17),('7643','2013-10-19','12:05:00',11.39),('7643','2013-10-19','12:10:00',10.92),('7643','2013-10-19','12:15:00',4.14),('7643','2013-10-19','12:20:00',3.49),('7643','2013-10-19','12:25:00',9.41),('7643','2013-10-19','12:30:00',7.43),('7643','2013-10-19','12:35:00',13.31),('7643','2013-10-19','12:40:00',7.09),('7643','2013-10-19','12:45:00',10.37),('7643','2013-10-19','12:50:00',7.81),('7643','2013-10-19','12:55:00',8.13),('7643','2013-10-19','13:00:00',6.2),('7643','2013-10-19','13:05:00',6.19),('7643','2013-10-19','13:10:00',8.51),('7643','2013-10-19','13:15:00',7.62),('7643','2013-10-19','13:20:00',5.37),('7643','2013-10-19','13:25:00',7.79),('7643','2013-10-19','13:30:00',6.54),('7643','2013-10-19','13:35:00',4.09),('7643','2013-10-19','13:40:00',8.05),('7643','2013-10-19','13:45:00',6.99),('7643','2013-10-19','13:50:00',4.45),('7643','2013-10-19','13:55:00',4.5),('7643','2013-10-19','14:00:00',7.48),('7643','2013-10-19','14:05:00',3.47),('7643','2013-10-19','14:10:00',4.19),('7643','2013-10-19','14:15:00',6.26),('7643','2013-10-19','14:20:00',3.96),('7643','2013-10-19','14:25:00',2.01),('7643','2013-10-19','14:30:00',1.83),('7643','2013-10-19','14:35:00',1.8),('7643','2013-10-19','14:40:00',2.16),('7643','2013-10-19','14:45:00',2.57),('7643','2013-10-19','14:50:00',2.63),('7643','2013-10-19','14:55:00',2.38),('7643','2013-10-19','15:00:00',2.18),('7643','2013-10-19','15:05:00',1.97),('7643','2013-10-19','15:10:00',1.91),('7643','2013-10-19','15:15:00',1.93),('7643','2013-10-19','15:20:00',1.71),('7643','2013-10-19','15:25:00',1.61),('7643','2013-10-19','15:30:00',1.46),('7643','2013-10-19','15:35:00',1.45),('7643','2013-10-19','15:40:00',1.23),('7643','2013-10-19','15:45:00',1.4),('7643','2013-10-19','15:50:00',1.39),('7643','2013-10-19','15:55:00',1.41),('7643','2013-10-19','16:00:00',1.59),('7643','2013-10-19','16:05:00',1.39),('7643','2013-10-19','16:10:00',1.32),('7643','2013-10-19','16:15:00',1.3),('7643','2013-10-19','16:20:00',1.3),('7643','2013-10-19','16:25:00',1.55),('7643','2013-10-19','16:30:00',1.63),('7643','2013-10-19','16:35:00',1.59),('7643','2013-10-19','16:40:00',2.53),('7643','2013-10-19','16:45:00',3.82),('7643','2013-10-19','16:50:00',4.34),('7643','2013-10-19','16:55:00',4.42),('7643','2013-10-19','17:00:00',4.15),('7643','2013-10-19','17:05:00',3.82),('7643','2013-10-19','17:10:00',3),('7643','2013-10-19','17:15:00',2.46),('7643','2013-10-19','17:20:00',2.02),('7643','2013-10-19','17:25:00',1.62),('7643','2013-10-19','17:30:00',1.28),('7643','2013-10-18','08:15:00',1.36),('7643','2013-10-18','08:20:00',2.16),('7643','2013-10-18','08:25:00',2.47),('7643','2013-10-18','08:30:00',2.62),('7643','2013-10-18','08:35:00',3.28),('7643','2013-10-18','08:40:00',3.79),('7643','2013-10-18','08:45:00',3.89),('7643','2013-10-18','08:50:00',4.63),('7643','2013-10-18','08:55:00',3.47),('7643','2013-10-18','09:00:00',3.4),('7643','2013-10-18','09:05:00',4.22),('7643','2013-10-18','09:10:00',5.59),('7643','2013-10-18','09:15:00',6.55),('7643','2013-10-18','09:20:00',6.79),('7643','2013-10-18','09:25:00',6.91),('7643','2013-10-18','09:30:00',7.11),('7643','2013-10-18','09:35:00',7.32),('7643','2013-10-18','09:40:00',7.67),('7643','2013-10-18','09:45:00',7.95),('7643','2013-10-18','09:50:00',8.21),('7643','2013-10-18','09:55:00',8.74),('7643','2013-10-18','10:00:00',8.23),('7643','2013-10-18','10:05:00',8.33),('7643','2013-10-18','10:10:00',9.09),('7643','2013-10-18','10:15:00',8.51),('7643','2013-10-18','10:20:00',8.77),('7643','2013-10-18','10:25:00',10.22),('7643','2013-10-18','10:30:00',10.38),('7643','2013-10-18','10:35:00',10.42),('7643','2013-10-18','10:40:00',10.45),('7643','2013-10-18','10:45:00',10.26),('7643','2013-10-18','10:50:00',10.53),('7643','2013-10-18','10:55:00',10.78),('7643','2013-10-18','11:00:00',10.93),('7643','2013-10-18','11:05:00',10.9),('7643','2013-10-18','11:10:00',4.9),('7643','2013-10-18','11:15:00',4.5),('7643','2013-10-18','11:20:00',9.47),('7643','2013-10-18','11:25:00',10.54),('7643','2013-10-18','11:30:00',11.96),('7643','2013-10-18','11:35:00',12.2),('7643','2013-10-18','11:40:00',11.72),('7643','2013-10-18','11:45:00',12.21),('7643','2013-10-18','11:50:00',12.25),('7643','2013-10-18','11:55:00',11.73),('7643','2013-10-18','12:00:00',12.47),('7643','2013-10-18','12:05:00',12.43),('7643','2013-10-18','12:10:00',12.22),('7643','2013-10-18','12:15:00',12.2),('7643','2013-10-18','12:20:00',12.43),('7643','2013-10-18','12:25:00',11.43),('7643','2013-10-18','12:30:00',12.22),('7643','2013-10-18','12:35:00',12.49),('7643','2013-10-18','12:40:00',12.84),('7643','2013-10-18','12:45:00',12.97),('7643','2013-10-18','12:50:00',13.27),('7643','2013-10-18','12:55:00',13.19),('7643','2013-10-18','13:00:00',14.27),('7643','2013-10-18','13:05:00',12.38),('7643','2013-10-18','13:10:00',11.87),('7643','2013-10-18','13:15:00',11.76),('7643','2013-10-18','13:20:00',11.56),('7643','2013-10-18','13:25:00',12.38),('7643','2013-10-18','13:30:00',13.84),('7643','2013-10-18','13:35:00',9.9),('7643','2013-10-18','13:40:00',8.34),('7643','2013-10-18','13:45:00',7.07),('7643','2013-10-18','13:50:00',9.34),('7643','2013-10-18','13:55:00',12.04),('7643','2013-10-18','14:00:00',10.62),('7643','2013-10-18','14:05:00',9.02),('7643','2013-10-18','14:10:00',6.34),('7643','2013-10-18','14:15:00',9.03),('7643','2013-10-18','14:20:00',8.53),('7643','2013-10-18','14:25:00',6.55),('7643','2013-10-18','14:30:00',7.85),('7643','2013-10-18','14:35:00',11.5),('7643','2013-10-18','14:40:00',9.59),('7643','2013-10-18','14:45:00',7.41),('7643','2013-10-18','14:50:00',10.96),('7643','2013-10-18','14:55:00',10.57),('7643','2013-10-18','15:00:00',10.25),('7643','2013-10-18','15:05:00',9.8),('7643','2013-10-18','15:10:00',9.68),('7643','2013-10-18','15:15:00',9.48),('7643','2013-10-18','15:20:00',8.72),('7643','2013-10-18','15:25:00',8.39),('7643','2013-10-18','15:30:00',8.01),('7643','2013-10-18','15:35:00',7.87),('7643','2013-10-18','15:40:00',7.39),('7643','2013-10-18','15:45:00',6.45),('7643','2013-10-18','15:50:00',6.4),('7643','2013-10-18','15:55:00',7.3),('7643','2013-10-18','16:00:00',6.03),('7643','2013-10-18','16:05:00',6.35),('7643','2013-10-18','16:10:00',6.16),('7643','2013-10-18','16:15:00',6.32),('7643','2013-10-18','16:20:00',6.14),('7643','2013-10-18','16:25:00',4.24),('7643','2013-10-18','16:30:00',5.44),('7643','2013-10-18','16:35:00',5.49),('7643','2013-10-18','16:40:00',5.22),('7643','2013-10-18','16:45:00',4.98),('7643','2013-10-18','16:50:00',4.53),('7643','2013-10-18','16:55:00',2.09),('7643','2013-10-18','17:00:00',1.8),('7643','2013-10-18','17:05:00',1.91),('7643','2013-10-18','17:10:00',2.1),('7643','2013-10-18','17:15:00',1.46),('7643','2013-10-18','17:20:00',2.3),('7643','2013-10-18','17:25:00',1.67),('7643','2013-10-18','17:30:00',1.49),('7643','2013-10-18','17:35:00',1.21),('7643','2013-10-18','17:40:00',1),('7643','2014-05-03','07:10:00',1.97),('7643','2014-05-03','07:15:00',2.19),('7643','2014-05-03','07:20:00',2.31),('7643','2014-05-03','07:25:00',2.35),('7643','2014-05-03','07:35:00',1.72),('7643','2014-05-03','07:40:00',2.7),('7643','2014-05-03','07:45:00',4.04),('7643','2014-05-03','07:50:00',4.82),('7643','2014-05-03','07:55:00',5.33),('7643','2014-05-03','08:00:00',5.78),('7643','2014-05-03','08:05:00',6.27),('7643','2014-05-03','08:10:00',6.65),('7643','2014-05-03','08:15:00',7.1),('7643','2014-05-03','08:20:00',7.58),('7643','2014-05-03','08:25:00',7.94),('7643','2014-05-03','08:30:00',8.67),('7643','2014-05-03','08:35:00',8.41),('7643','2014-05-03','08:40:00',6.55),('7643','2014-05-03','08:45:00',3.72),('7643','2014-05-03','08:50:00',7.49),('7643','2014-05-03','08:55:00',5.76),('7643','2014-05-03','09:00:00',6.07),('7643','2014-05-03','09:05:00',8.81),('7643','2014-05-03','09:10:00',10.04),('7643','2014-05-03','09:15:00',8.62),('7643','2014-05-03','09:20:00',15.13),('7643','2014-05-03','09:25:00',12.9),('7643','2014-05-03','09:30:00',5.51),('7643','2014-05-03','09:35:00',5.12),('7643','2014-05-03','09:40:00',5.78),('7643','2014-05-03','09:45:00',8.44),('7643','2014-05-03','09:50:00',10.11),('7643','2014-05-03','09:55:00',9.19),('7643','2014-05-03','10:00:00',15.45),('7643','2014-05-03','10:05:00',16.14),('7643','2014-05-03','10:10:00',13.82),('7643','2014-05-03','10:15:00',10.36),('7643','2014-05-03','10:20:00',7.78),('7643','2014-05-03','10:25:00',7.75),('7643','2014-05-03','10:30:00',8.07),('7643','2014-05-03','10:35:00',8.4),('7643','2014-05-03','10:40:00',8.93),('7643','2014-05-03','10:45:00',10.99),('7643','2014-05-03','10:50:00',11.69),('7643','2014-05-03','10:55:00',12.12),('7643','2014-05-03','11:00:00',12.09),('7643','2014-05-03','11:05:00',12.87),('7643','2014-05-03','11:10:00',16.39),('7643','2014-05-03','11:15:00',14.57),('7643','2014-05-03','11:20:00',18.12),('7643','2014-05-03','11:25:00',14.4),('7643','2014-05-03','11:30:00',16.23),('7643','2014-05-03','11:35:00',16.39),('7643','2014-05-03','11:40:00',13.16),('7643','2014-05-03','11:45:00',18.19),('7643','2014-05-03','11:50:00',12),('7643','2014-05-03','11:55:00',14.73),('7643','2014-05-03','12:00:00',13.27),('7643','2014-05-03','12:05:00',13.96),('7643','2014-05-03','12:10:00',7.32),('7643','2014-05-03','12:15:00',6.25),('7643','2014-05-03','12:20:00',6.93),('7643','2014-05-03','12:25:00',6.94),('7643','2014-05-03','12:30:00',17.75),('7643','2014-05-03','12:35:00',16.72),('7643','2014-05-03','12:40:00',11.47),('7643','2014-05-03','12:45:00',13.82),('7643','2014-05-03','12:50:00',12.73),('7643','2014-05-03','12:55:00',9.52),('7643','2014-05-03','13:00:00',7.83),('7643','2014-05-03','13:05:00',7.74),('7643','2014-05-03','13:10:00',7.93),('7643','2014-05-03','13:15:00',7.44),('7643','2014-05-03','13:20:00',6.93),('7643','2014-05-03','13:25:00',5.97),('7643','2014-05-03','13:30:00',6.17),('7643','2014-05-03','13:35:00',6.62),('7643','2014-05-03','13:40:00',6.34),('7643','2014-05-03','13:45:00',5.59),('7643','2014-05-03','13:50:00',5.26),('7643','2014-05-03','13:55:00',5.35),('7643','2014-05-03','14:00:00',5.21),('7643','2014-05-03','14:05:00',5.32),('7643','2014-05-03','14:10:00',5.42),('7643','2014-05-03','14:15:00',5.22),('7643','2014-05-03','14:20:00',4.29),('7643','2014-05-03','14:25:00',3.15),('7643','2014-05-03','14:30:00',2.62),('7643','2014-05-03','14:35:00',2.6),('7643','2014-05-03','14:40:00',2.87),('7643','2014-05-03','14:45:00',3.26),('7643','2014-05-03','14:50:00',4.31),('7643','2014-05-03','14:55:00',6.09),('7643','2014-05-03','15:00:00',7.03),('7643','2014-05-03','15:05:00',11.27),('7643','2014-05-03','15:10:00',15.09),('7643','2014-05-03','15:15:00',12.47),('7643','2014-05-03','15:20:00',6.21),('7643','2014-05-03','15:25:00',5.47),('7643','2014-05-03','15:30:00',4.13),('7643','2014-05-03','15:35:00',3.03),('7643','2014-05-03','15:40:00',2.88),('7643','2014-05-03','15:45:00',3.56),('7643','2014-05-03','15:50:00',4.7),('7643','2014-05-03','15:55:00',4.91),('7643','2014-05-03','16:00:00',4),('7643','2014-05-03','16:05:00',4.21),('7643','2014-05-03','16:10:00',5.23),('7643','2014-05-03','16:15:00',5.14),('7643','2014-05-03','16:20:00',4.33),('7643','2014-05-03','16:25:00',3.49),('7643','2014-05-03','16:30:00',2.66),('7643','2014-05-03','16:35:00',2.18),('7643','2014-05-03','16:40:00',1.93),('7643','2014-05-03','16:45:00',1.83),('7643','2014-05-03','16:50:00',1.92),('7643','2014-05-03','16:55:00',2.07),('7643','2014-05-03','17:00:00',1.83),('7643','2014-05-03','17:05:00',1.51),('7643','2014-05-03','17:10:00',1.73),('7643','2014-05-03','17:15:00',2.17),('7643','2014-05-03','17:20:00',2.54),('7643','2014-05-03','17:25:00',3.68),('7643','2014-05-03','17:30:00',3.53),('7643','2014-05-03','17:35:00',3.44),('7643','2014-05-03','17:40:00',3.81),('7643','2014-05-03','17:45:00',2.87),('7643','2014-05-03','17:50:00',2.37),('7643','2014-05-03','17:55:00',1.88),('7643','2014-05-03','18:00:00',2.04),('7643','2014-05-03','18:05:00',2.55),('7643','2014-05-03','18:10:00',2.21),('7643','2014-05-03','18:15:00',1.62),('7643','2014-05-03','18:20:00',1.57),('7643','2014-05-03','18:25:00',1.66),('7643','2014-05-03','18:30:00',1.17),('7643','2014-04-15','07:15:00',1.2),('7643','2014-04-15','07:20:00',1.54),('7643','2014-04-15','07:25:00',1.82),('7643','2014-04-15','07:30:00',2.01),('7643','2014-04-15','07:35:00',1.6),('7643','2014-04-15','07:40:00',1.51),('7643','2014-04-15','07:45:00',3.19),('7643','2014-04-15','07:50:00',3.52),('7643','2014-04-15','07:55:00',4.1),('7643','2014-04-15','08:00:00',4.49),('7643','2014-04-15','08:05:00',4.88),('7643','2014-04-15','08:10:00',5.31),('7643','2014-04-15','08:15:00',5.79),('7643','2014-04-15','08:20:00',6.26),('7643','2014-04-15','08:25:00',6.76),('7643','2014-04-15','08:30:00',5.08),('7643','2014-04-15','08:35:00',4),('7643','2014-04-15','08:40:00',4.33),('7643','2014-04-15','08:45:00',7.38),('7643','2014-04-15','08:50:00',8.41),('7643','2014-04-15','08:55:00',8.9),('7643','2014-04-15','09:00:00',9.25),('7643','2014-04-15','09:05:00',9.64),('7643','2014-04-15','09:10:00',9.96),('7643','2014-04-15','09:15:00',10.19),('7643','2014-04-15','09:20:00',10.54),('7643','2014-04-15','09:25:00',11.04),('7643','2014-04-15','09:30:00',9.41),('7643','2014-04-15','09:35:00',3.36),('7643','2014-04-15','09:40:00',3.06),('7643','2014-04-15','09:45:00',3.38),('7643','2014-04-15','09:50:00',8.18),('7643','2014-04-15','09:55:00',13.97),('7643','2014-04-15','10:00:00',13.44),('7643','2014-04-15','10:05:00',13.54),('7643','2014-04-15','10:10:00',13.87),('7643','2014-04-15','10:15:00',14.19),('7643','2014-04-15','10:20:00',14.47),('7643','2014-04-15','10:25:00',14.69),('7643','2014-04-15','10:30:00',14.87),('7643','2014-04-15','10:35:00',15.09),('7643','2014-04-15','10:40:00',15.32),('7643','2014-04-15','10:45:00',15.62),('7643','2014-04-15','10:50:00',16.15),('7643','2014-04-15','10:55:00',14.85),('7643','2014-04-15','11:00:00',15.8),('7643','2014-04-15','11:05:00',12.52),('7643','2014-04-15','11:10:00',5.86),('7643','2014-04-15','11:15:00',8.83),('7643','2014-04-15','11:20:00',15.67),('7643','2014-04-15','11:25:00',14.03),('7643','2014-04-15','11:30:00',14.51),('7643','2014-04-15','11:35:00',12.49),('7643','2014-04-15','11:40:00',14.11),('7643','2014-04-15','11:45:00',16.18),('7643','2014-04-15','11:50:00',18.49),('7643','2014-04-15','11:55:00',18.67),('7643','2014-04-15','12:00:00',19),('7643','2014-04-15','12:05:00',11.91),('7643','2014-04-15','12:10:00',13.36),('7643','2014-04-15','12:15:00',9.02),('7643','2014-04-15','12:20:00',15.95),('7643','2014-04-15','12:25:00',6.4),('7643','2014-04-15','12:30:00',8.18),('7643','2014-04-15','12:35:00',17.75),('7643','2014-04-15','12:40:00',19.2),('7643','2014-04-15','12:45:00',18.71),('7643','2014-04-15','12:50:00',17.89),('7643','2014-04-15','12:55:00',12.44),('7643','2014-04-15','13:00:00',9.59),('7643','2014-04-15','13:05:00',4.09),('7643','2014-04-15','13:10:00',2.78),('7643','2014-04-15','13:15:00',3.09),('7643','2014-04-15','13:20:00',5.67),('7643','2014-04-15','13:25:00',4.12),('7643','2014-04-15','13:30:00',3.41),('7643','2014-04-15','13:35:00',5.43),('7643','2014-04-15','13:40:00',9.92),('7643','2014-04-15','13:45:00',17.24),('7643','2014-04-15','13:50:00',15.89),('7643','2014-04-15','13:55:00',12.62),('7643','2014-04-15','14:00:00',6.93),('7643','2014-04-15','14:05:00',10.25),('7643','2014-04-15','14:10:00',17.84),('7643','2014-04-15','14:15:00',19.7),('7643','2014-04-15','14:20:00',18.5),('7643','2014-04-15','14:25:00',14.02),('7643','2014-04-15','14:30:00',15.5),('7643','2014-04-15','14:35:00',17.51),('7643','2014-04-15','14:40:00',17.17),('7643','2014-04-15','14:45:00',14.89),('7643','2014-04-15','14:50:00',16.94),('7643','2014-04-15','14:55:00',7.58),('7643','2014-04-15','15:00:00',6.49),('7643','2014-04-15','15:05:00',12.47),('7643','2014-04-15','15:10:00',19.28),('7643','2014-04-15','15:15:00',12.68),('7643','2014-04-15','15:20:00',2.26),('7643','2014-04-15','15:25:00',4.59),('7643','2014-04-15','15:30:00',12.41),('7643','2014-04-15','15:35:00',16.65),('7643','2014-04-15','15:40:00',16.1),('7643','2014-04-15','15:45:00',15.31),('7643','2014-04-15','15:50:00',14.87),('7643','2014-04-15','15:55:00',14.46),('7643','2014-04-15','16:00:00',13.92),('7643','2014-04-15','16:05:00',13.53),('7643','2014-04-15','16:10:00',13.23),('7643','2014-04-15','16:15:00',12.98),('7643','2014-04-15','16:20:00',12.54),('7643','2014-04-15','16:25:00',12.37),('7643','2014-04-15','16:30:00',12.15),('7643','2014-04-15','16:35:00',11.87),('7643','2014-04-15','16:40:00',11.54),('7643','2014-04-15','16:45:00',11.28),('7643','2014-04-15','16:50:00',10.84),('7643','2014-04-15','16:55:00',10.44),('7643','2014-04-15','17:00:00',10.12),('7643','2014-04-15','17:05:00',9.73),('7643','2014-04-15','17:10:00',9.35),('7643','2014-04-15','17:15:00',9.13),('7643','2014-04-15','17:20:00',8.59),('7643','2014-04-15','17:25:00',8.12),('7643','2014-04-15','17:30:00',7.82),('7643','2014-04-15','17:35:00',7.55),('7643','2014-04-15','17:40:00',7.06),('7643','2014-04-15','17:45:00',6.76),('7643','2014-04-15','17:50:00',6.76),('7643','2014-04-15','17:55:00',6.73),('7643','2014-04-15','18:00:00',5.97),('7643','2014-04-15','18:05:00',5.5),('7643','2014-04-15','18:10:00',4.97),('7643','2014-04-15','18:15:00',4.27),('7643','2014-04-15','18:20:00',4.15),('7643','2014-04-15','18:25:00',3.49),('7643','2014-04-15','18:30:00',3),('7643','2014-04-15','18:35:00',2.56),('7643','2014-04-15','18:40:00',2.62),('7643','2014-04-15','18:45:00',2.75),('7643','2014-04-15','18:50:00',2.67),('7643','2014-04-15','18:55:00',2.15),('7643','2014-04-15','19:00:00',1.21),('7643','2014-04-15','19:05:00',1.18),('7643','2013-10-17','07:55:00',1.09),('7643','2013-10-17','08:00:00',1.4),('7643','2013-10-17','08:05:00',1.71),('7643','2013-10-17','08:10:00',1.99),('7643','2013-10-17','08:15:00',2.12),('7643','2013-10-17','08:20:00',2.32),('7643','2013-10-17','08:25:00',2.64),('7643','2013-10-17','08:30:00',2.63),('7643','2013-10-17','08:35:00',3.07),('7643','2013-10-17','08:40:00',3.5),('7643','2013-10-17','08:45:00',3.92),('7643','2013-10-17','08:50:00',4.09),('7643','2013-10-17','08:55:00',4.26),('7643','2013-10-17','09:00:00',4.78),('7643','2013-10-17','09:05:00',5.33),('7643','2013-10-17','09:10:00',5.72),('7643','2013-10-17','09:15:00',5.91),('7643','2013-10-17','09:20:00',6.44),('7643','2013-10-17','09:25:00',6.64),('7643','2013-10-17','09:30:00',7.01),('7643','2013-10-17','09:35:00',7.33),('7643','2013-10-17','09:40:00',7.65),('7643','2013-10-17','09:45:00',7.91),('7643','2013-10-17','09:50:00',8.13),('7643','2013-10-17','09:55:00',8.43),('7643','2013-10-17','10:00:00',8.62),('7643','2013-10-17','10:05:00',8.85),('7643','2013-10-17','10:10:00',9.05),('7643','2013-10-17','10:15:00',9.24),('7643','2013-10-17','10:20:00',9.37),('7643','2013-10-17','10:25:00',9.65),('7643','2013-10-17','10:30:00',9.92),('7643','2013-10-17','10:35:00',10.13),('7643','2013-10-17','10:40:00',10.33),('7643','2013-10-17','10:45:00',10.43),('7643','2013-10-17','10:50:00',10.61),('7643','2013-10-17','10:55:00',10.73),('7643','2013-10-17','11:00:00',10.74),('7643','2013-10-17','11:05:00',10.47),('7643','2013-10-17','11:10:00',10.43),('7643','2013-10-17','11:15:00',10.47),('7643','2013-10-17','11:20:00',11.44),('7643','2013-10-17','11:25:00',11.19),('7643','2013-10-17','11:30:00',11.41),('7643','2013-10-17','11:35:00',11.57),('7643','2013-10-17','11:40:00',11.93),('7643','2013-10-17','11:45:00',8.64),('7643','2013-10-17','11:50:00',11.5),('7643','2013-10-17','11:55:00',12.11),('7643','2013-10-17','12:00:00',11.79),('7643','2013-10-17','12:05:00',11.96),('7643','2013-10-17','12:10:00',12),('7643','2013-10-17','12:15:00',11.91),('7643','2013-10-17','12:20:00',11.73),('7643','2013-10-17','12:25:00',11.93),('7643','2013-10-17','12:30:00',12.1),('7643','2013-10-17','12:35:00',11.86),('7643','2013-10-17','12:40:00',11.97),('7643','2013-10-17','12:45:00',11.72),('7643','2013-10-17','12:50:00',11.7),('7643','2013-10-17','12:55:00',11.97),('7643','2013-10-17','13:00:00',11.83),('7643','2013-10-17','13:05:00',11.6),('7643','2013-10-17','13:10:00',11.01),('7643','2013-10-17','13:15:00',11.48),('7643','2013-10-17','13:20:00',11.63),('7643','2013-10-17','13:25:00',11.87),('7643','2013-10-17','13:30:00',11.88),('7643','2013-10-17','13:35:00',11.74),('7643','2013-10-17','13:40:00',11.6),('7643','2013-10-17','13:45:00',11.35),('7643','2013-10-17','13:50:00',11.32),('7643','2013-10-17','13:55:00',11.37),('7643','2013-10-17','14:00:00',10.65),('7643','2013-10-17','14:05:00',10.63),('7643','2013-10-17','14:10:00',10.58),('7643','2013-10-17','14:15:00',10.84),('7643','2013-10-17','14:20:00',10.7),('7643','2013-10-17','14:25:00',10.56),('7643','2013-10-17','14:30:00',10.53),('7643','2013-10-17','14:35:00',10),('7643','2013-10-17','14:40:00',10.06),('7643','2013-10-17','14:45:00',9.68),('7643','2013-10-17','14:50:00',9.36),('7643','2013-10-17','14:55:00',9.55),('7643','2013-10-17','15:00:00',8.26),('7643','2013-10-17','15:05:00',7.49),('7643','2013-10-17','15:10:00',8.34),('7643','2013-10-17','15:15:00',8.3),('7643','2013-10-17','15:20:00',8.53),('7643','2013-10-17','15:25:00',8.11),('7643','2013-10-17','15:30:00',7.64),('7643','2013-10-17','15:35:00',7.67),('7643','2013-10-17','15:40:00',7.27),('7643','2013-10-17','15:45:00',6.74),('7643','2013-10-17','15:50:00',6.45),('7643','2013-10-17','15:55:00',5.86),('7643','2013-10-17','16:00:00',6.29),('7643','2013-10-17','16:05:00',5.84),('7643','2013-10-17','16:10:00',5.66),('7643','2013-10-17','16:15:00',5.09),('7643','2013-10-17','16:20:00',4.84),('7643','2013-10-17','16:25:00',4.24),('7643','2013-10-17','16:30:00',3.81),('7643','2013-10-17','16:35:00',3.64),('7643','2013-10-17','16:40:00',2.87),('7643','2013-10-17','16:45:00',2.71),('7643','2013-10-17','16:50:00',2.29),('7643','2013-10-17','16:55:00',2.87),('7643','2013-10-17','17:00:00',2.24),('7643','2013-10-17','17:05:00',2.03),('7643','2013-10-17','17:10:00',2.16),('7643','2013-10-17','17:15:00',1.83),('7643','2013-10-17','17:20:00',1.73),('7643','2013-10-17','17:25:00',1.4),('7643','2013-10-17','17:30:00',1.04),('7643','2013-10-16','08:00:00',1.25),('7643','2013-10-16','08:05:00',1.5),('7643','2013-10-16','08:10:00',1.81),('7643','2013-10-16','08:15:00',2.13),('7643','2013-10-16','08:20:00',2.47),('7643','2013-10-16','08:25:00',2.8),('7643','2013-10-16','08:30:00',3.13),('7643','2013-10-16','08:35:00',3.48),('7643','2013-10-16','08:40:00',3.81),('7643','2013-10-16','08:45:00',4.14),('7643','2013-10-16','08:50:00',4.49),('7643','2013-10-16','08:55:00',4.82),('7643','2013-10-16','09:00:00',5.14),('7643','2013-10-16','09:05:00',5.51),('7643','2013-10-16','09:10:00',5.81),('7643','2013-10-16','09:15:00',6.14),('7643','2013-10-16','09:20:00',6.45),('7643','2013-10-16','09:25:00',6.76),('7643','2013-10-16','09:30:00',7.06),('7643','2013-10-16','09:35:00',7.35),('7643','2013-10-16','09:40:00',7.61),('7643','2013-10-16','09:45:00',7.87),('7643','2013-10-16','09:50:00',8.15),('7643','2013-10-16','09:55:00',8.38),('7643','2013-10-16','10:00:00',8.61),('7643','2013-10-16','10:05:00',8.79),('7643','2013-10-16','10:10:00',8.99),('7643','2013-10-16','10:15:00',9.24),('7643','2013-10-16','10:20:00',9.51),('7643','2013-10-16','10:25:00',9.73),('7643','2013-10-16','10:30:00',9.97),('7643','2013-10-16','10:35:00',10.2),('7643','2013-10-16','10:40:00',10.4),('7643','2013-10-16','10:45:00',10.58),('7643','2013-10-16','10:50:00',10.79),('7643','2013-10-16','10:55:00',10.95),('7643','2013-10-16','11:00:00',11.14),('7643','2013-10-16','11:05:00',11.26),('7643','2013-10-16','11:10:00',11.38),('7643','2013-10-16','11:15:00',11.52),('7643','2013-10-16','11:20:00',11.59),('7643','2013-10-16','11:25:00',11.7),('7643','2013-10-16','11:30:00',11.84),('7643','2013-10-16','11:35:00',12),('7643','2013-10-16','11:40:00',12.16),('7643','2013-10-16','11:45:00',12.19),('7643','2013-10-16','11:50:00',12.25),('7643','2013-10-16','11:55:00',12.32),('7643','2013-10-16','12:00:00',12.35),('7643','2013-10-16','12:05:00',12.36),('7643','2013-10-16','12:10:00',12.45),('7643','2013-10-16','12:15:00',12.49),('7643','2013-10-16','12:20:00',12.49),('7643','2013-10-16','12:25:00',12.56),('7643','2013-10-16','12:30:00',12.54),('7643','2013-10-16','12:35:00',12.61),('7643','2013-10-16','12:40:00',12.68),('7643','2013-10-16','12:45:00',12.66),('7643','2013-10-16','12:50:00',12.63),('7643','2013-10-16','12:55:00',12.63),('7643','2013-10-16','13:00:00',12.62),('7643','2013-10-16','13:05:00',12.62),('7643','2013-10-16','13:10:00',12.46),('7643','2013-10-16','13:15:00',12.38),('7643','2013-10-16','13:20:00',12.44),('7643','2013-10-16','13:25:00',12.37),('7643','2013-10-16','13:30:00',12.22),('7643','2013-10-16','13:35:00',12.23),('7643','2013-10-16','13:40:00',12.1),('7643','2013-10-16','13:45:00',12.04),('7643','2013-10-16','13:50:00',12),('7643','2013-10-16','13:55:00',11.98),('7643','2013-10-16','14:00:00',11.86),('7643','2013-10-16','14:05:00',11.72),('7643','2013-10-16','14:10:00',11.58),('7643','2013-10-16','14:15:00',11.5),('7643','2013-10-16','14:20:00',11.39),('7643','2013-10-16','14:25:00',11.28),('7643','2013-10-16','14:30:00',11.11),('7643','2013-10-16','14:35:00',10.86),('7643','2013-10-16','14:40:00',10.72),('7643','2013-10-16','14:45:00',10.59),('7643','2013-10-16','14:50:00',10.4),('7643','2013-10-16','14:55:00',10.24),('7643','2013-10-16','15:00:00',10.02),('7643','2013-10-16','15:05:00',9.8),('7643','2013-10-16','15:10:00',9.57),('7643','2013-10-16','15:15:00',9.42),('7643','2013-10-16','15:20:00',9.23),('7643','2013-10-16','15:25:00',9),('7643','2013-10-16','15:30:00',8.75),('7643','2013-10-16','15:35:00',8.45),('7643','2013-10-16','15:40:00',8.18),('7643','2013-10-16','15:45:00',7.93),('7643','2013-10-16','15:50:00',7.66),('7643','2013-10-16','15:55:00',7.38),('7643','2013-10-16','16:00:00',7.1),('7643','2013-10-16','16:05:00',6.75),('7643','2013-10-16','16:10:00',6.54),('7643','2013-10-16','16:15:00',6.27),('7643','2013-10-16','16:20:00',6),('7643','2013-10-16','16:25:00',5.73),('7643','2013-10-16','16:30:00',5.42),('7643','2013-10-16','16:35:00',5.09),('7643','2013-10-16','16:40:00',4.76),('7643','2013-10-16','16:45:00',4.42),('7643','2013-10-16','16:50:00',4.08),('7643','2013-10-16','16:55:00',3.76),('7643','2013-10-16','17:00:00',3.44),('7643','2013-10-16','17:05:00',3.14),('7643','2013-10-16','17:10:00',2.83),('7643','2013-10-16','17:15:00',2.52),('7643','2013-10-16','17:20:00',2.19),('7643','2013-10-16','17:25:00',1.89),('7643','2013-10-16','17:30:00',1.6),('7643','2013-10-16','17:35:00',1.33),('7643','2013-10-16','17:40:00',1.08),('7643','2013-10-15','07:50:00',1.07),('7643','2013-10-15','07:55:00',1.26),('7643','2013-10-15','08:00:00',1.41),('7643','2013-10-15','08:30:00',1.61),('7643','2013-10-15','08:35:00',1.48),('7643','2013-10-15','09:00:00',1.07),('7643','2013-10-15','09:05:00',1.2),('7643','2013-10-15','09:10:00',1.14),('7643','2013-10-15','09:15:00',1.41),('7643','2013-10-15','09:20:00',1.54),('7643','2013-10-15','09:25:00',1.17),('7643','2013-10-15','09:30:00',1.29),('7643','2013-10-15','09:35:00',1.83),('7643','2013-10-15','09:40:00',2.1),('7643','2013-10-15','09:45:00',4.92),('7643','2013-10-15','09:50:00',7.32),('7643','2013-10-15','09:55:00',3.06),('7643','2013-10-15','10:00:00',2.94),('7643','2013-10-15','10:05:00',1.84),('7643','2013-10-15','10:15:00',1.24),('7643','2013-10-15','11:05:00',2.48),('7643','2013-10-15','11:10:00',3.12),('7643','2013-10-15','11:15:00',4.56),('7643','2013-10-15','11:20:00',3.87),('7643','2013-10-15','11:25:00',2.24),('7643','2013-10-15','11:30:00',1.97),('7643','2013-10-15','11:35:00',1.23),('7643','2013-10-15','11:50:00',1.38),('7643','2013-10-15','11:55:00',3.86),('7643','2013-10-15','12:00:00',3.6),('7643','2013-10-15','12:05:00',1.26),('7643','2013-10-15','12:10:00',3.02),('7643','2013-10-15','12:15:00',9.41),('7643','2013-10-15','12:20:00',10.99),('7643','2013-10-15','12:25:00',3.63),('7643','2013-10-15','12:30:00',4.39),('7643','2013-10-15','12:35:00',6.21),('7643','2013-10-15','12:40:00',13.2),('7643','2013-10-15','12:45:00',12.39),('7643','2013-10-15','12:50:00',11.89),('7643','2013-10-15','12:55:00',10.48),('7643','2013-10-15','13:00:00',11.13),('7643','2013-10-15','13:05:00',12.27),('7643','2013-10-15','13:10:00',9.43),('7643','2013-10-15','13:15:00',12.51),('7643','2013-10-15','13:20:00',13.18),('7643','2013-10-15','13:25:00',11.75),('7643','2013-10-15','13:30:00',13.25),('7643','2013-10-15','13:35:00',12.63),('7643','2013-10-15','13:40:00',12.38),('7643','2013-10-15','13:45:00',12.37),('7643','2013-10-15','13:50:00',11.68),('7643','2013-10-15','13:55:00',12.74),('7643','2013-10-15','14:00:00',10.79),('7643','2013-10-15','14:05:00',7.19),('7643','2013-10-15','14:10:00',13.24),('7643','2013-10-15','14:15:00',12.6),('7643','2013-10-15','14:20:00',9.71),('7643','2013-10-15','14:25:00',12.62),('7643','2013-10-15','14:30:00',12.24),('7643','2013-10-15','14:35:00',10.89),('7643','2013-10-15','14:40:00',11.11),('7643','2013-10-15','14:45:00',11.28),('7643','2013-10-15','14:50:00',7.03),('7643','2013-10-15','14:55:00',10.73),('7643','2013-10-15','15:00:00',10.86),('7643','2013-10-15','15:05:00',7.87),('7643','2013-10-15','15:10:00',8.14),('7643','2013-10-15','15:15:00',9.35),('7643','2013-10-15','15:20:00',8.07),('7643','2013-10-15','15:25:00',8.56),('7643','2013-10-15','15:30:00',2.81),('7643','2013-10-15','15:35:00',3.32),('7643','2013-10-15','15:40:00',8.96),('7643','2013-10-15','15:45:00',8.24),('7643','2013-10-15','15:50:00',7.78),('7643','2013-10-15','15:55:00',7.52),('7643','2013-10-15','16:00:00',7.21),('7643','2013-10-15','16:05:00',6.98),('7643','2013-10-15','16:10:00',6.54),('7643','2013-10-15','16:15:00',5.97),('7643','2013-10-15','16:20:00',5.99),('7643','2013-10-15','16:25:00',5.63),('7643','2013-10-15','16:30:00',5.27),('7643','2013-10-15','16:35:00',4.16),('7643','2013-10-15','16:40:00',4.87),('7643','2013-10-15','16:45:00',4.44),('7643','2013-10-15','16:50:00',4.16),('7643','2013-10-15','16:55:00',3.86),('7643','2013-10-15','17:00:00',3.5),('7643','2013-10-15','17:05:00',3.19),('7643','2013-10-15','17:10:00',2.88),('7643','2013-10-15','17:15:00',2.56),('7643','2013-10-15','17:20:00',2.3),('7643','2013-10-15','17:25:00',2.09),('7643','2013-10-15','17:30:00',1.83),('7643','2013-10-15','17:35:00',1.72),('7643','2013-10-15','17:40:00',2.12),('7643','2013-10-15','17:45:00',2.13),('7643','2013-10-15','17:50:00',1.65),('7643','2013-10-14','08:00:00',1.21),('7643','2013-10-14','08:05:00',1.37),('7643','2013-10-14','08:10:00',1.25),('7643','2013-10-14','08:15:00',1.35),('7643','2013-10-14','08:20:00',1.62),('7643','2013-10-14','08:25:00',1.81),('7643','2013-10-14','08:30:00',1.96),('7643','2013-10-14','08:35:00',2.03),('7643','2013-10-14','08:40:00',2),('7643','2013-10-14','08:45:00',1.96),('7643','2013-10-14','08:50:00',1.85),('7643','2013-10-14','08:55:00',2.08),('7643','2013-10-14','09:00:00',2.67),('7643','2013-10-14','09:05:00',3.4),('7643','2013-10-14','09:10:00',3.65),('7643','2013-10-14','09:15:00',3.38),('7643','2013-10-14','09:20:00',3.81),('7643','2013-10-14','09:25:00',3.97),('7643','2013-10-14','09:30:00',6.02),('7643','2013-10-14','09:35:00',3.71),('7643','2013-10-14','09:40:00',5.44),('7643','2013-10-14','09:45:00',6.98),('7643','2013-10-14','09:50:00',7.87),('7643','2013-10-14','09:55:00',8.19),('7643','2013-10-14','10:00:00',8.32),('7643','2013-10-14','10:05:00',9.18),('7643','2013-10-14','10:10:00',7.14),('7643','2013-10-14','10:15:00',4.39),('7643','2013-10-14','10:20:00',4.38),('7643','2013-10-14','10:25:00',5.04),('7643','2013-10-14','10:30:00',7.63),('7643','2013-10-14','10:35:00',6.02),('7643','2013-10-14','10:40:00',7.05),('7643','2013-10-14','10:45:00',8.24),('7643','2013-10-14','10:50:00',8.4),('7643','2013-10-14','10:55:00',7.08),('7643','2013-10-14','11:00:00',7.05),('7643','2013-10-14','11:05:00',7.38),('7643','2013-10-14','11:10:00',9.6),('7643','2013-10-14','11:15:00',10.64),('7643','2013-10-14','11:20:00',10.7),('7643','2013-10-14','11:25:00',9.99),('7643','2013-10-14','11:30:00',10.42),('7643','2013-10-14','11:35:00',8.76),('7643','2013-10-14','11:40:00',7.01),('7643','2013-10-14','11:45:00',5.48),('7643','2013-10-14','11:50:00',5.17),('7643','2013-10-14','11:55:00',5.14),('7643','2013-10-14','12:00:00',5.37),('7643','2013-10-14','12:05:00',5.4),('7643','2013-10-14','12:10:00',5.6),('7643','2013-10-14','12:15:00',5.52),('7643','2013-10-14','12:20:00',5.8),('7643','2013-10-14','12:25:00',5.35),('7643','2013-10-14','12:30:00',4.83),('7643','2013-10-14','12:35:00',4.66),('7643','2013-10-14','12:40:00',4.66),('7643','2013-10-14','12:45:00',4.96),('7643','2013-10-14','12:50:00',4.67),('7643','2013-10-14','12:55:00',4.23),('7643','2013-10-14','13:00:00',4.21),('7643','2013-10-14','13:05:00',5.55),('7643','2013-10-14','13:10:00',6.68),('7643','2013-10-14','13:15:00',6.73),('7643','2013-10-14','13:20:00',9.57),('7643','2013-10-14','13:25:00',11.34),('7643','2013-10-14','13:30:00',7.34),('7643','2013-10-14','13:35:00',6.07),('7643','2013-10-14','13:40:00',5.63),('7643','2013-10-14','13:45:00',5.81),('7643','2013-10-14','13:50:00',5.21),('7643','2013-10-14','13:55:00',4.65),('7643','2013-10-14','14:00:00',4.14),('7643','2013-10-14','14:05:00',4.06),('7643','2013-10-14','14:10:00',4.5),('7643','2013-10-14','14:15:00',6.17),('7643','2013-10-14','14:20:00',7.27),('7643','2013-10-14','14:25:00',7.98),('7643','2013-10-14','14:30:00',8.11),('7643','2013-10-14','14:35:00',5.16),('7643','2013-10-14','14:40:00',5.62),('7643','2013-10-14','14:45:00',6.5),('7643','2013-10-14','14:50:00',9.32),('7643','2013-10-14','14:55:00',7.56),('7643','2013-10-14','15:00:00',4.77),('7643','2013-10-14','15:05:00',4.75),('7643','2013-10-14','15:10:00',4.99),('7643','2013-10-14','15:15:00',4.58),('7643','2013-10-14','15:20:00',4.14),('7643','2013-10-14','15:25:00',3.64),('7643','2013-10-14','15:30:00',3.47),('7643','2013-10-14','15:35:00',3.61),('7643','2013-10-14','15:40:00',3.78),('7643','2013-10-14','15:45:00',3.66),('7643','2013-10-14','15:50:00',3.22),('7643','2013-10-14','15:55:00',2.8),('7643','2013-10-14','16:00:00',2.55),('7643','2013-10-14','16:05:00',2.57),('7643','2013-10-14','16:10:00',2.66),('7643','2013-10-14','16:15:00',2.51),('7643','2013-10-14','16:20:00',2.26),('7643','2013-10-14','16:25:00',3.02),('7643','2013-10-14','16:30:00',4.01),('7643','2013-10-14','16:35:00',4.22),('7643','2013-10-14','16:40:00',3.36),('7643','2013-10-14','16:45:00',2.96),('7643','2013-10-14','16:50:00',2.23),('7643','2013-10-14','16:55:00',2.22),('7643','2013-10-14','17:00:00',2.22),('7643','2013-10-14','17:05:00',2.05),('7643','2013-10-14','17:10:00',1.82),('7643','2013-10-14','17:15:00',1.35),('7643','2013-10-13','07:55:00',1.05),('7643','2013-10-13','08:00:00',1.4),('7643','2013-10-13','08:05:00',1.81),('7643','2013-10-13','08:10:00',2.01),('7643','2013-10-13','08:15:00',1.86),('7643','2013-10-13','08:20:00',2.5),('7643','2013-10-13','08:25:00',3.18),('7643','2013-10-13','08:30:00',3.37),('7643','2013-10-13','08:35:00',3.78),('7643','2013-10-13','08:40:00',3.43),('7643','2013-10-13','08:45:00',4.28),('7643','2013-10-13','08:50:00',4.01),('7643','2013-10-13','08:55:00',4.57),('7643','2013-10-13','09:00:00',4.17),('7643','2013-10-13','09:05:00',4.34),('7643','2013-10-13','09:10:00',4.06),('7643','2013-10-13','09:15:00',2.97),('7643','2013-10-13','09:20:00',3.97),('7643','2013-10-13','09:25:00',5.98),('7643','2013-10-13','09:30:00',6.85),('7643','2013-10-13','09:35:00',6.48),('7643','2013-10-13','09:40:00',5.71),('7643','2013-10-13','09:45:00',5.12),('7643','2013-10-13','09:50:00',6.04),('7643','2013-10-13','09:55:00',7.44),('7643','2013-10-13','10:00:00',7.21),('7643','2013-10-13','10:05:00',7.96),('7643','2013-10-13','10:10:00',8.27),('7643','2013-10-13','10:15:00',8.98),('7643','2013-10-13','10:20:00',9.09),('7643','2013-10-13','10:25:00',9.25),('7643','2013-10-13','10:30:00',9.39),('7643','2013-10-13','10:35:00',9.46),('7643','2013-10-13','10:40:00',9.42),('7643','2013-10-13','10:45:00',9.65),('7643','2013-10-13','10:50:00',10.07),('7643','2013-10-13','10:55:00',10.3),('7643','2013-10-13','11:00:00',10.5),('7643','2013-10-13','11:05:00',10.48),('7643','2013-10-13','11:10:00',10.95),('7643','2013-10-13','11:15:00',10.94),('7643','2013-10-13','11:20:00',10.92),('7643','2013-10-13','11:25:00',11.15),('7643','2013-10-13','11:30:00',11.44),('7643','2013-10-13','11:35:00',11.14),('7643','2013-10-13','11:40:00',11.3),('7643','2013-10-13','11:45:00',11.3),('7643','2013-10-13','11:50:00',11.32),('7643','2013-10-13','11:55:00',11.45),('7643','2013-10-13','12:00:00',11.56),('7643','2013-10-13','12:05:00',11.64),('7643','2013-10-13','12:10:00',11.85),('7643','2013-10-13','12:15:00',11.75),('7643','2013-10-13','12:20:00',10.96),('7643','2013-10-13','12:25:00',11.43),('7643','2013-10-13','12:30:00',12.02),('7643','2013-10-13','12:35:00',11.85),('7643','2013-10-13','12:40:00',11.87),('7643','2013-10-13','12:45:00',11.94),('7643','2013-10-13','12:50:00',11.83),('7643','2013-10-13','12:55:00',11.82),('7643','2013-10-13','13:00:00',11.88),('7643','2013-10-13','13:05:00',11.84),('7643','2013-10-13','13:10:00',11.69),('7643','2013-10-13','13:15:00',11.58),('7643','2013-10-13','13:20:00',11.68),('7643','2013-10-13','13:25:00',11.59),('7643','2013-10-13','13:30:00',11.53),('7643','2013-10-13','13:35:00',11.4),('7643','2013-10-13','13:40:00',11.38),('7643','2013-10-13','13:45:00',11.31),('7643','2013-10-13','13:50:00',11.24),('7643','2013-10-13','13:55:00',11.13),('7643','2013-10-13','14:00:00',11.04),('7643','2013-10-13','14:05:00',10.99),('7643','2013-10-13','14:10:00',10.85),('7643','2013-10-13','14:15:00',10.74),('7643','2013-10-13','14:20:00',10.64),('7643','2013-10-13','14:25:00',10.53),('7643','2013-10-13','14:30:00',10.44),('7643','2013-10-13','14:35:00',10.3),('7643','2013-10-13','14:40:00',10.07),('7643','2013-10-13','14:45:00',9.98),('7643','2013-10-13','14:50:00',9.85),('7643','2013-10-13','14:55:00',9.66),('7643','2013-10-13','15:00:00',9.52),('7643','2013-10-13','15:05:00',9.26),('7643','2013-10-13','15:10:00',8.98),('7643','2013-10-13','15:15:00',8.71),('7643','2013-10-13','15:20:00',8.52),('7643','2013-10-13','15:25:00',8.26),('7643','2013-10-13','15:30:00',7.99),('7643','2013-10-13','15:35:00',7.65),('7643','2013-10-13','15:40:00',6.92),('7643','2013-10-13','15:45:00',6.38),('7643','2013-10-13','15:50:00',5.66),('7643','2013-10-13','15:55:00',3.7),('7643','2013-10-13','16:00:00',5.05),('7643','2013-10-13','16:05:00',3.82),('7643','2013-10-13','16:10:00',3.48),('7643','2013-10-13','16:15:00',3.31),('7643','2013-10-13','16:20:00',2.81),('7643','2013-10-13','16:25:00',3.96),('7643','2013-10-13','16:30:00',2.87),('7643','2013-10-13','16:35:00',1.97),('7643','2013-10-13','16:40:00',1.52),('7643','2013-10-13','16:45:00',2.75),('7643','2013-10-13','16:50:00',2.39),('7643','2013-10-13','16:55:00',1.52),('7643','2013-10-13','17:00:00',1.26),('7643','2013-10-13','17:05:00',1.21),('7643','2013-10-13','17:10:00',1.73),('7643','2013-10-13','17:15:00',1.66),('7643','2013-10-13','17:20:00',1.46),('7643','2013-10-13','17:35:00',1.21),('7643','2013-10-13','17:40:00',1.23),('7643','2013-10-12','08:05:00',1.04),('7643','2013-10-12','08:10:00',1.43),('7643','2013-10-12','08:15:00',1.6),('7643','2013-10-12','08:20:00',1.81),('7643','2013-10-12','08:25:00',1.87),('7643','2013-10-12','08:30:00',2.18),('7643','2013-10-12','08:35:00',2.74),('7643','2013-10-12','08:40:00',2.71),('7643','2013-10-12','08:45:00',2.63),('7643','2013-10-12','08:50:00',2.9),('7643','2013-10-12','08:55:00',3.43),('7643','2013-10-12','09:00:00',3.96),('7643','2013-10-12','09:05:00',4.21),('7643','2013-10-12','09:10:00',4.03),('7643','2013-10-12','09:15:00',6.15),('7643','2013-10-12','09:20:00',6.72),('7643','2013-10-12','09:25:00',6.38),('7643','2013-10-12','09:30:00',4.65),('7643','2013-10-12','09:35:00',5.52),('7643','2013-10-12','09:40:00',8.04),('7643','2013-10-12','09:45:00',9.88),('7643','2013-10-12','09:50:00',9.74),('7643','2013-10-12','09:55:00',10.07),('7643','2013-10-12','10:00:00',7.68),('7643','2013-10-12','10:05:00',5.59),('7643','2013-10-12','10:10:00',7.6),('7643','2013-10-12','10:15:00',8.52),('7643','2013-10-12','10:20:00',7.17),('7643','2013-10-12','10:25:00',8.29),('7643','2013-10-12','10:30:00',9.94),('7643','2013-10-12','10:35:00',11.5),('7643','2013-10-12','10:40:00',11.9),('7643','2013-10-12','10:45:00',12.11),('7643','2013-10-12','10:50:00',9.64),('7643','2013-10-12','10:55:00',8.53),('7643','2013-10-12','11:00:00',10.48),('7643','2013-10-12','11:05:00',11.48),('7643','2013-10-12','11:10:00',11.16),('7643','2013-10-12','11:15:00',11.92),('7643','2013-10-12','11:20:00',11.39),('7643','2013-10-12','11:25:00',11.15),('7643','2013-10-12','11:30:00',11.45),('7643','2013-10-12','11:35:00',11.48),('7643','2013-10-12','11:40:00',11.5),('7643','2013-10-12','11:45:00',11.53),('7643','2013-10-12','11:50:00',11.7),('7643','2013-10-12','11:55:00',11.67),('7643','2013-10-12','12:00:00',11.74),('7643','2013-10-12','12:05:00',11.82),('7643','2013-10-12','12:10:00',11.82),('7643','2013-10-12','12:15:00',11.92),('7643','2013-10-12','12:20:00',11.54),('7643','2013-10-12','12:25:00',11.41),('7643','2013-10-12','12:30:00',12),('7643','2013-10-12','12:35:00',12.16),('7643','2013-10-12','12:40:00',12.16),('7643','2013-10-12','12:45:00',11.94),('7643','2013-10-12','12:50:00',11.78),('7643','2013-10-12','12:55:00',11.81),('7643','2013-10-12','13:00:00',11.95),('7643','2013-10-12','13:05:00',11.82),('7643','2013-10-12','13:10:00',11.88),('7643','2013-10-12','13:15:00',12),('7643','2013-10-12','13:20:00',12.08),('7643','2013-10-12','13:25:00',10.43),('7643','2013-10-12','13:30:00',8.93),('7643','2013-10-12','13:35:00',9.53),('7643','2013-10-12','13:40:00',6.77),('7643','2013-10-12','13:45:00',7.04),('7643','2013-10-12','13:50:00',7.9),('7643','2013-10-12','13:55:00',9.23),('7643','2013-10-12','14:00:00',11.77),('7643','2013-10-12','14:05:00',11.48),('7643','2013-10-12','14:10:00',11.14),('7643','2013-10-12','14:15:00',10.48),('7643','2013-10-12','14:20:00',11.33),('7643','2013-10-12','14:25:00',11.38),('7643','2013-10-12','14:30:00',9.98),('7643','2013-10-12','14:35:00',8.81),('7643','2013-10-12','14:40:00',10.03),('7643','2013-10-12','14:45:00',7.67),('7643','2013-10-12','14:50:00',6.24),('7643','2013-10-12','14:55:00',7.63),('7643','2013-10-12','15:00:00',9.12),('7643','2013-10-12','15:05:00',8.01),('7643','2013-10-12','15:10:00',5.54),('7643','2013-10-12','15:15:00',6.98),('7643','2013-10-12','15:20:00',7.71),('7643','2013-10-12','15:25:00',8.66),('7643','2013-10-12','15:30:00',6.34),('7643','2013-10-12','15:35:00',5.56),('7643','2013-10-12','15:40:00',5.31),('7643','2013-10-12','15:45:00',5.36),('7643','2013-10-12','15:50:00',4.75),('7643','2013-10-12','15:55:00',4.53),('7643','2013-10-12','16:00:00',4.63),('7643','2013-10-12','16:05:00',6.26),('7643','2013-10-12','16:10:00',5.49),('7643','2013-10-12','16:15:00',4.61),('7643','2013-10-12','16:20:00',5.37),('7643','2013-10-12','16:25:00',6.51),('7643','2013-10-12','16:30:00',6.28),('7643','2013-10-12','16:35:00',5.24),('7643','2013-10-12','16:40:00',4.25),('7643','2013-10-12','16:45:00',3.16),('7643','2013-10-12','16:50:00',3.41),('7643','2013-10-12','16:55:00',2.86),('7643','2013-10-12','17:00:00',2.05),('7643','2013-10-12','17:05:00',1.95),('7643','2013-10-12','17:10:00',1.62),('7643','2013-10-12','17:15:00',1.58),('7643','2013-10-12','17:20:00',2.29),('7643','2013-10-12','17:25:00',2.86),('7643','2013-10-12','17:30:00',2.01),('7643','2013-10-12','17:35:00',2.24),('7643','2013-10-12','17:40:00',1.83),('7643','2013-10-12','17:45:00',1.41),('7643','2013-10-12','17:50:00',1.11),('7643','2013-10-11','10:35:00',1.24),('7643','2013-10-11','10:40:00',1.54),('7643','2013-10-11','10:45:00',1.75),('7643','2013-10-11','10:50:00',1.93),('7643','2013-10-11','10:55:00',2.11),('7643','2013-10-11','11:00:00',2.37),('7643','2013-10-11','11:05:00',2.57),('7643','2013-10-11','11:10:00',2.72),('7643','2013-10-11','11:15:00',3.09),('7643','2013-10-11','11:20:00',3.65),('7643','2013-10-11','11:25:00',4.04),('7643','2013-10-11','11:30:00',4.73),('7643','2013-10-11','11:35:00',6.11),('7643','2013-10-11','11:40:00',11.1),('7643','2013-10-11','11:45:00',6.13),('7643','2013-10-11','11:50:00',5.31),('7643','2013-10-11','11:55:00',4.65),('7643','2013-10-11','12:00:00',3.09),('7643','2013-10-11','12:05:00',2.16),('7643','2013-10-11','12:10:00',2.69),('7643','2013-10-11','12:15:00',3.91),('7643','2013-10-11','12:20:00',6.88),('7643','2013-10-11','12:25:00',13.81),('7643','2013-10-11','12:30:00',10.54),('7643','2013-10-11','12:35:00',12.12),('7643','2013-10-11','12:40:00',12.14),('7643','2013-10-11','12:45:00',10.85),('7643','2013-10-11','12:50:00',10.12),('7643','2013-10-11','12:55:00',8.66),('7643','2013-10-11','13:00:00',6.61),('7643','2013-10-11','13:05:00',5.24),('7643','2013-10-11','13:10:00',3.05),('7643','2013-10-11','13:15:00',4.15),('7643','2013-10-11','13:20:00',4.97),('7643','2013-10-11','13:25:00',5.47),('7643','2013-10-11','13:30:00',14.87),('7643','2013-10-11','13:35:00',6.25),('7643','2013-10-11','13:40:00',2.54),('7643','2013-10-11','13:45:00',1.31),('7643','2013-10-11','13:50:00',1.08),('7643','2013-10-11','13:55:00',1.87),('7643','2013-10-11','14:00:00',2.44),('7643','2013-10-11','14:05:00',1.06),('7643','2013-10-11','14:50:00',1.14),('7643','2013-10-11','14:55:00',1.14),('7643','2013-10-11','15:00:00',1.29),('7643','2013-10-11','15:05:00',1.74),('7643','2013-10-11','15:10:00',1.95),('7643','2013-10-11','15:15:00',2.11),('7643','2013-10-11','15:20:00',2.24),('7643','2013-10-11','15:25:00',2.63),('7643','2013-10-11','15:30:00',2.84),('7643','2013-10-11','15:35:00',2.67),('7643','2013-10-11','15:40:00',2.41),('7643','2013-10-11','15:45:00',2.28),('7643','2013-10-11','15:50:00',2.56),('7643','2013-10-11','15:55:00',3.34),('7643','2013-10-11','16:00:00',4.08),('7643','2013-10-11','16:05:00',3.84),('7643','2013-10-11','16:10:00',3.98),('7643','2013-10-11','16:15:00',5.94),('7643','2013-10-11','16:20:00',5.56),('7643','2013-10-11','16:25:00',3.27),('7643','2013-10-11','16:30:00',2.08),('7643','2013-10-11','16:35:00',1.63),('7643','2013-10-11','16:40:00',1.39),('7643','2013-10-11','16:45:00',1.5),('7643','2013-10-11','16:50:00',1.36),('7643','2013-10-11','16:55:00',1.77),('7643','2013-10-11','17:00:00',3.38),('7643','2013-10-11','17:05:00',1.93),('7643','2013-10-11','17:10:00',1.88),('7643','2013-10-11','17:15:00',1.1),('7643','2013-10-11','17:20:00',1.81),('7643','2013-10-11','17:25:00',2.02),('7643','2013-10-11','17:30:00',1.16),('7643','2013-10-11','17:35:00',1.26),('7643','2013-10-11','17:40:00',1.26),('7643','2013-10-11','17:45:00',1.05),('7643','2013-10-10','08:10:00',1.54),('7643','2013-10-10','08:15:00',2.04),('7643','2013-10-10','08:20:00',2.12),('7643','2013-10-10','08:25:00',1.41),('7643','2013-10-10','08:30:00',1.03),('7643','2013-10-10','08:35:00',2.48),('7643','2013-10-10','08:40:00',1.31),('7643','2013-10-10','08:50:00',1.09),('7643','2013-10-10','09:05:00',2.33),('7643','2013-10-10','09:15:00',2.49),('7643','2013-10-10','09:20:00',1.84),('7643','2013-10-10','09:25:00',1.43),('7643','2013-10-10','09:30:00',1.01),('7643','2013-10-10','09:35:00',2.98),('7643','2013-10-10','09:40:00',2.15),('7643','2013-10-10','09:45:00',8.27),('7643','2013-10-10','09:50:00',6.94),('7643','2013-10-10','09:55:00',8.7),('7643','2013-10-10','10:00:00',8.91),('7643','2013-10-10','10:05:00',9.17),('7643','2013-10-10','10:10:00',9.35),('7643','2013-10-10','10:15:00',6.68),('7643','2013-10-10','10:20:00',7.23),('7643','2013-10-10','10:25:00',5.82),('7643','2013-10-10','10:30:00',6.44),('7643','2013-10-10','10:35:00',8.14),('7643','2013-10-10','10:40:00',6.1),('7643','2013-10-10','10:45:00',2.51),('7643','2013-10-10','10:50:00',1.65),('7643','2013-10-10','10:55:00',1.57),('7643','2013-10-10','11:00:00',3.81),('7643','2013-10-10','11:05:00',10.39),('7643','2013-10-10','11:10:00',8.38),('7643','2013-10-10','11:15:00',4.13),('7643','2013-10-10','11:20:00',4.13),('7643','2013-10-10','11:25:00',4.09),('7643','2013-10-10','11:30:00',3.38),('7643','2013-10-10','11:35:00',4.2),('7643','2013-10-10','11:40:00',5.42),('7643','2013-10-10','11:45:00',6.02),('7643','2013-10-10','11:50:00',9.02),('7643','2013-10-10','11:55:00',6.26),('7643','2013-10-10','12:00:00',11.41),('7643','2013-10-10','12:05:00',15.47),('7643','2013-10-10','12:10:00',6.37),('7643','2013-10-10','12:15:00',3.7),('7643','2013-10-10','12:20:00',3.77),('7643','2013-10-10','12:25:00',3.75),('7643','2013-10-10','12:30:00',4.56),('7643','2013-10-10','12:35:00',2.17),('7643','2013-10-10','12:40:00',1.93),('7643','2013-10-10','12:45:00',1.43),('7643','2013-10-10','12:55:00',1.44),('7643','2013-10-10','13:00:00',2.53),('7643','2013-10-10','13:05:00',8.95),('7643','2013-10-10','13:10:00',8.36),('7643','2013-10-10','13:15:00',7.5),('7643','2013-10-10','13:20:00',10.54),('7643','2013-10-10','13:25:00',15.29),('7643','2013-10-10','13:30:00',4.45),('7643','2013-10-10','13:35:00',1.93),('7643','2013-10-10','13:40:00',6.64),('7643','2013-10-10','13:45:00',10.91),('7643','2013-10-10','13:50:00',2.42),('7643','2013-10-10','14:35:00',1.47),('7643','2013-10-10','14:50:00',1.16),('7643','2013-10-10','14:55:00',1.54),('7643','2013-10-10','15:10:00',3.07),('7643','2013-10-10','15:15:00',2.19),('7643','2013-10-10','15:25:00',2.36),('7643','2013-10-10','15:30:00',4.36),('7643','2013-10-10','15:35:00',3.78),('7643','2013-10-10','15:40:00',4.31),('7643','2013-10-10','15:45:00',3.32),('7643','2013-10-10','15:50:00',2.39),('7643','2013-10-10','15:55:00',2.94),('7643','2013-10-10','16:00:00',5.95),('7643','2013-10-10','16:05:00',3.61),('7643','2013-10-10','16:10:00',3.21),('7643','2013-10-10','16:15:00',1.65),('7643','2013-10-10','16:20:00',1.42),('7643','2013-10-10','16:25:00',3.09),('7643','2013-10-10','16:30:00',2.98),('7643','2013-10-10','16:35:00',5.86),('7643','2013-10-10','16:40:00',2.18),('7643','2013-10-10','16:45:00',1.14),('7643','2013-10-10','16:50:00',1.24),('7643','2013-10-10','16:55:00',2.53),('7643','2013-10-10','17:00:00',2.07),('7643','2013-10-10','17:05:00',1.04),('7643','2013-10-10','17:15:00',1.41),('7643','2013-10-10','17:45:00',1.62),('7643','2013-10-09','07:55:00',1.22),('7643','2013-10-09','08:00:00',1.33),('7643','2013-10-09','08:10:00',1.25),('7643','2013-10-09','08:35:00',2),('7643','2013-10-09','08:40:00',3.67),('7643','2013-10-09','08:45:00',4.63),('7643','2013-10-09','08:50:00',4.15),('7643','2013-10-09','08:55:00',5.57),('7643','2013-10-09','09:00:00',3.27),('7643','2013-10-09','09:05:00',2.23),('7643','2013-10-09','09:10:00',3.77),('7643','2013-10-09','09:15:00',6.57),('7643','2013-10-09','09:20:00',6.68),('7643','2013-10-09','09:25:00',7.03),('7643','2013-10-09','09:30:00',7.28),('7643','2013-10-09','09:35:00',7.35),('7643','2013-10-09','09:40:00',6.06),('7643','2013-10-09','09:45:00',3.68),('7643','2013-10-09','09:50:00',3.35),('7643','2013-10-09','09:55:00',4.03),('7643','2013-10-09','10:00:00',1.9),('7643','2013-10-09','10:05:00',1.71),('7643','2013-10-09','10:10:00',1.43),('7643','2013-10-09','10:15:00',6),('7643','2013-10-09','10:20:00',9.89),('7643','2013-10-09','10:25:00',9.15),('7643','2013-10-09','10:30:00',8.53),('7643','2013-10-09','10:35:00',1.39),('7643','2013-10-09','10:40:00',2.96),('7643','2013-10-09','10:45:00',6.97),('7643','2013-10-09','10:50:00',4.21),('7643','2013-10-09','10:55:00',2.71),('7643','2013-10-09','11:00:00',1.96),('7643','2013-10-09','11:05:00',3.45),('7643','2013-10-09','11:10:00',3.06),('7643','2013-10-09','11:15:00',5.33),('7643','2013-10-09','11:20:00',9.37),('7643','2013-10-09','11:25:00',14.42),('7643','2013-10-09','11:30:00',4.83),('7643','2013-10-09','11:35:00',2.79),('7643','2013-10-09','11:40:00',6.61),('7643','2013-10-09','11:45:00',11.87),('7643','2013-10-09','11:50:00',7.9),('7643','2013-10-09','11:55:00',10.78),('7643','2013-10-09','12:00:00',4.11),('7643','2013-10-09','12:05:00',3.29),('7643','2013-10-09','12:10:00',2.6),('7643','2013-10-09','12:15:00',2.13),('7643','2013-10-09','12:20:00',3.36),('7643','2013-10-09','12:25:00',11.73),('7643','2013-10-09','12:30:00',10.4),('7643','2013-10-09','12:35:00',15.66),('7643','2013-10-09','12:40:00',12.7),('7643','2013-10-09','12:45:00',13.39),('7643','2013-10-09','12:50:00',7.21),('7643','2013-10-09','12:55:00',7.08),('7643','2013-10-09','13:00:00',7.1),('7643','2013-10-09','13:05:00',14.3),('7643','2013-10-09','13:10:00',4.61),('7643','2013-10-09','13:15:00',5.14),('7643','2013-10-09','13:20:00',7.14),('7643','2013-10-09','13:25:00',8.33),('7643','2013-10-09','13:30:00',9.29),('7643','2013-10-09','13:35:00',5.66),('7643','2013-10-09','13:40:00',12.19),('7643','2013-10-09','13:45:00',11.97),('7643','2013-10-09','13:50:00',13.25),('7643','2013-10-09','13:55:00',13.05),('7643','2013-10-09','14:00:00',11.71),('7643','2013-10-09','14:05:00',6.35),('7643','2013-10-09','14:10:00',7.78),('7643','2013-10-09','14:15:00',8.75),('7643','2013-10-09','14:20:00',13.83),('7643','2013-10-09','14:25:00',8.77),('7643','2013-10-09','14:30:00',10.37),('7643','2013-10-09','14:35:00',9.69),('7643','2013-10-09','14:40:00',12.72),('7643','2013-10-09','14:45:00',8.72),('7643','2013-10-09','14:50:00',10.53),('7643','2013-10-09','14:55:00',11.21),('7643','2013-10-09','15:00:00',11.46),('7643','2013-10-09','15:05:00',11.43),('7643','2013-10-09','15:10:00',11.05),('7643','2013-10-09','15:15:00',8.13),('7643','2013-10-09','15:20:00',8.21),('7643','2013-10-09','15:25:00',4.54),('7643','2013-10-09','15:30:00',8.74),('7643','2013-10-09','15:35:00',4.65),('7643','2013-10-09','15:40:00',3.31),('7643','2013-10-09','15:45:00',4.09),('7643','2013-10-09','15:50:00',2.42),('7643','2013-10-09','15:55:00',2.69),('7643','2013-10-09','16:00:00',4.44),('7643','2013-10-09','16:05:00',2.59),('7643','2013-10-09','16:10:00',3.71),('7643','2013-10-09','16:15:00',8.24),('7643','2013-10-09','16:20:00',4.31),('7643','2013-10-09','16:25:00',6.81),('7643','2013-10-09','16:30:00',4.32),('7643','2013-10-09','16:40:00',4.22),('7643','2013-10-09','16:45:00',5.43),('7643','2013-10-09','16:50:00',5.01),('7643','2013-10-09','16:55:00',4.59),('7643','2013-10-09','17:00:00',4.24),('7643','2013-10-09','17:05:00',3.33),('7643','2013-10-09','17:15:00',2.4),('7643','2013-10-09','17:20:00',3.53),('7643','2013-10-09','17:25:00',1.54),('7643','2013-10-09','17:30:00',1.38),('7643','2013-10-09','17:35:00',1.23),('7643','2013-10-09','17:40:00',1.27),('7643','2013-10-09','17:45:00',1.3),('7643','2013-10-08','08:00:00',1.3),('7643','2013-10-08','08:25:00',2.98),('7643','2013-10-08','08:30:00',3.67),('7643','2013-10-08','08:35:00',3.66),('7643','2013-10-08','08:40:00',4.26),('7643','2013-10-08','08:45:00',4.59),('7643','2013-10-08','08:50:00',4.9),('7643','2013-10-08','08:55:00',5.2),('7643','2013-10-08','09:00:00',5.55),('7643','2013-10-08','09:05:00',5.95),('7643','2013-10-08','09:10:00',6.32),('7643','2013-10-08','09:15:00',6.16),('7643','2013-10-08','09:20:00',5.81),('7643','2013-10-08','09:25:00',7.25),('7643','2013-10-08','09:30:00',7.51),('7643','2013-10-08','09:35:00',7.7),('7643','2013-10-08','09:40:00',7.97),('7643','2013-10-08','09:45:00',8.49),('7643','2013-10-08','09:50:00',8.79),('7643','2013-10-08','09:55:00',9.15),('7643','2013-10-08','10:00:00',9.67),('7643','2013-10-08','10:05:00',10.42),('7643','2013-10-08','10:10:00',10.61),('7643','2013-10-08','10:15:00',8.16),('7643','2013-10-08','10:20:00',3.67),('7643','2013-10-08','10:25:00',4.74),('7643','2013-10-08','10:30:00',6.09),('7643','2013-10-08','10:35:00',6.13),('7643','2013-10-08','10:40:00',7.87),('7643','2013-10-08','10:45:00',9.63),('7643','2013-10-08','10:50:00',11.51),('7643','2013-10-08','10:55:00',8.87),('7643','2013-10-08','11:00:00',11.44),('7643','2013-10-08','11:05:00',13.84),('7643','2013-10-08','11:10:00',14.26),('7643','2013-10-08','11:15:00',14.19),('7643','2013-10-08','11:20:00',12.14),('7643','2013-10-08','11:25:00',12.83),('7643','2013-10-08','11:30:00',13.68),('7643','2013-10-08','11:35:00',14.87),('7643','2013-10-08','11:40:00',9.15),('7643','2013-10-08','11:45:00',11.16),('7643','2013-10-08','11:50:00',12.37),('7643','2013-10-08','11:55:00',10.39),('7643','2013-10-08','12:00:00',11.61),('7643','2013-10-08','12:05:00',4.99),('7643','2013-10-08','12:10:00',8.46),('7643','2013-10-08','12:15:00',5.62),('7643','2013-10-08','12:20:00',7.49),('7643','2013-10-08','12:25:00',13.87),('7643','2013-10-08','12:30:00',12.24),('7643','2013-10-08','12:35:00',9.39),('7643','2013-10-08','12:40:00',6.06),('7643','2013-10-08','12:45:00',4.3),('7643','2013-10-08','12:50:00',2.68),('7643','2013-10-08','12:55:00',4.8),('7643','2013-10-08','13:00:00',3.95),('7643','2013-10-08','13:05:00',3.09),('7643','2013-10-08','13:10:00',5.23),('7643','2013-10-08','13:15:00',8.27),('7643','2013-10-08','13:20:00',7.21),('7643','2013-10-08','13:25:00',9.77),('7643','2013-10-08','13:30:00',7.22),('7643','2013-10-08','13:35:00',7.27),('7643','2013-10-08','13:40:00',7.88),('7643','2013-10-08','13:45:00',12.17),('7643','2013-10-08','13:50:00',12.36),('7643','2013-10-08','13:55:00',15.95),('7643','2013-10-08','14:00:00',10.05),('7643','2013-10-08','14:05:00',4.02),('7643','2013-10-08','14:10:00',4.72),('7643','2013-10-08','14:15:00',2.64),('7643','2013-10-08','14:20:00',2.15),('7643','2013-10-08','14:25:00',2.35),('7643','2013-10-08','14:30:00',2.14),('7643','2013-10-08','14:35:00',1.69),('7643','2013-10-08','14:40:00',1.2),('7643','2013-10-08','14:45:00',1.85),('7643','2013-10-08','14:50:00',2.76),('7643','2013-10-08','14:55:00',4.37),('7643','2013-10-08','15:00:00',6.72),('7643','2013-10-08','15:05:00',12.37),('7643','2013-10-08','15:10:00',11.15),('7643','2013-10-08','15:15:00',11.84),('7643','2013-10-08','15:20:00',10.12),('7643','2013-10-08','15:25:00',4.63),('7643','2013-10-08','15:30:00',9.32),('7643','2013-10-08','15:35:00',6.43),('7643','2013-10-08','15:40:00',9.33),('7643','2013-10-08','15:45:00',3.97),('7643','2013-10-08','15:50:00',6.78),('7643','2013-10-08','15:55:00',1.72),('7643','2013-10-08','16:00:00',1.52),('7643','2013-10-08','16:05:00',1.99),('7643','2013-10-08','16:10:00',3.11),('7643','2013-10-08','16:15:00',4.7),('7643','2013-10-08','16:20:00',5.79),('7643','2013-10-08','16:25:00',4.89),('7643','2013-10-08','16:30:00',5.82),('7643','2013-10-08','16:35:00',3.28),('7643','2013-10-08','16:40:00',7.98),('7643','2013-10-08','16:45:00',2.46),('7643','2013-10-08','16:50:00',1.57),('7643','2013-10-08','16:55:00',1.22),('7643','2013-10-08','17:00:00',1.09),('7643','2013-10-08','17:20:00',1.96),('7643','2013-10-08','17:25:00',2.58),('7643','2013-10-08','17:30:00',3.24),('7643','2013-10-08','17:35:00',3.35),('7643','2013-10-08','17:40:00',2.53),('7643','2013-10-08','17:45:00',2.42),('7643','2013-10-08','17:50:00',1.7),('7643','2013-10-08','17:55:00',1.07),('7643','2014-04-14','07:40:00',1.2),('7643','2014-04-14','07:45:00',1.35),('7643','2014-04-14','07:50:00',1.63),('7643','2014-04-14','07:55:00',2.08),('7643','2014-04-14','08:00:00',2.55),('7643','2014-04-14','08:05:00',2.21),('7643','2014-04-14','08:10:00',1.84),('7643','2014-04-14','08:15:00',1.17),('7643','2014-04-14','08:50:00',1.73),('7643','2014-04-14','08:55:00',2.82),('7643','2014-04-14','09:00:00',5.93),('7643','2014-04-14','09:05:00',7.18),('7643','2014-04-14','09:10:00',7.87),('7643','2014-04-14','09:15:00',5.13),('7643','2014-04-14','09:20:00',6.8),('7643','2014-04-14','09:25:00',8.64),('7643','2014-04-14','09:30:00',5.6),('7643','2014-04-14','09:35:00',3.42),('7643','2014-04-14','09:40:00',2.49),('7643','2014-04-14','09:45:00',4.31),('7643','2014-04-14','09:50:00',10.39),('7643','2014-04-14','09:55:00',5.26),('7643','2014-04-14','10:00:00',9.56),('7643','2014-04-14','10:05:00',5.62),('7643','2014-04-14','10:10:00',6.1),('7643','2014-04-14','10:15:00',6.87),('7643','2014-04-14','10:20:00',5.45),('7643','2014-04-14','10:25:00',5.5),('7643','2014-04-14','10:30:00',15.29),('7643','2014-04-14','10:35:00',12.03),('7643','2014-04-14','10:40:00',9),('7643','2014-04-14','10:45:00',13.98),('7643','2014-04-14','10:50:00',9.61),('7643','2014-04-14','10:55:00',4.34),('7643','2014-04-14','11:00:00',9.86),('7643','2014-04-14','11:05:00',16.12),('7643','2014-04-14','11:10:00',10.67),('7643','2014-04-14','11:15:00',7.42),('7643','2014-04-14','11:20:00',4.78),('7643','2014-04-14','11:25:00',5.98),('7643','2014-04-14','11:30:00',4.18),('7643','2014-04-14','11:35:00',3.55),('7643','2014-04-14','11:40:00',2.51),('7643','2014-04-14','11:45:00',4.5),('7643','2014-04-14','11:50:00',5.48),('7643','2014-04-14','11:55:00',4.13),('7643','2014-04-14','12:00:00',2.73),('7643','2014-04-14','12:05:00',2.79),('7643','2014-04-14','12:10:00',3.96),('7643','2014-04-14','12:15:00',5.42),('7643','2014-04-14','12:20:00',7.39),('7643','2014-04-14','12:25:00',3.62),('7643','2014-04-14','12:30:00',2.15),('7643','2014-04-14','12:35:00',2.73),('7643','2014-04-14','12:40:00',2.28),('7643','2014-04-14','12:45:00',1.69),('7643','2014-04-14','12:50:00',1.74),('7643','2014-04-14','12:55:00',1.65),('7643','2014-04-14','13:00:00',2.24),('7643','2014-04-14','13:05:00',3.73),('7643','2014-04-14','13:10:00',6.15),('7643','2014-04-14','13:15:00',6.31),('7643','2014-04-14','13:20:00',12.51),('7643','2014-04-14','13:25:00',7.7),('7643','2014-04-14','13:30:00',8.03),('7643','2014-04-14','13:35:00',9.98),('7643','2014-04-14','13:40:00',13.16),('7643','2014-04-14','13:45:00',5.56),('7643','2014-04-14','13:50:00',4.39),('7643','2014-04-14','13:55:00',4.23),('7643','2014-04-14','14:00:00',5.41),('7643','2014-04-14','14:05:00',14.06),('7643','2014-04-14','14:10:00',14.83),('7643','2014-04-14','14:15:00',13.9),('7643','2014-04-14','14:20:00',10.42),('7643','2014-04-14','14:25:00',14.56),('7643','2014-04-14','14:30:00',8.99),('7643','2014-04-14','14:35:00',7.9),('7643','2014-04-14','14:40:00',5.38),('7643','2014-04-14','14:45:00',4.19),('7643','2014-04-14','14:50:00',3.34),('7643','2014-04-14','14:55:00',2.87),('7643','2014-04-14','15:00:00',3.53),('7643','2014-04-14','15:05:00',2.52),('7643','2014-04-14','15:10:00',3.63),('7643','2014-04-14','15:15:00',5.36),('7643','2014-04-14','15:20:00',7.48),('7643','2014-04-14','15:25:00',6.66),('7643','2014-04-14','15:30:00',5.21),('7643','2014-04-14','15:35:00',5.09),('7643','2014-04-14','15:40:00',5.29),('7643','2014-04-14','15:45:00',5.05),('7643','2014-04-14','15:50:00',4.83),('7643','2014-04-14','15:55:00',5.32),('7643','2014-04-14','16:00:00',6.04),('7643','2014-04-14','16:05:00',5.27),('7643','2014-04-14','16:10:00',3.41),('7643','2014-04-14','16:15:00',2.58),('7643','2014-04-14','16:20:00',1.67),('7643','2014-04-14','16:25:00',1.05),('7643','2013-10-07','07:45:00',1.09),('7643','2013-10-07','07:50:00',1.29),('7643','2013-10-07','07:55:00',1.94),('7643','2013-10-07','08:00:00',1.73),('7643','2013-10-07','08:05:00',2.6),('7643','2013-10-07','08:10:00',3.18),('7643','2013-10-07','08:15:00',4.17),('7643','2013-10-07','08:20:00',4.38),('7643','2013-10-07','08:25:00',2.38),('7643','2013-10-07','08:30:00',2.38),('7643','2013-10-07','08:35:00',1.53),('7643','2013-10-07','09:25:00',1.06),('7643','2013-10-07','09:30:00',1.07),('7643','2013-10-07','09:35:00',1.2),('7643','2013-10-07','09:40:00',1.31),('7643','2013-10-07','09:45:00',1.5),('7643','2013-10-07','09:50:00',1.97),('7643','2013-10-07','09:55:00',2.5),('7643','2013-10-07','10:00:00',3.53),('7643','2013-10-07','10:05:00',3.41),('7643','2013-10-07','10:10:00',3.36),('7643','2013-10-07','10:15:00',2.6),('7643','2013-10-07','10:20:00',1.88),('7643','2013-10-07','10:25:00',1.49),('7643','2013-10-07','10:30:00',1.65),('7643','2013-10-07','10:35:00',1.71),('7643','2013-10-07','10:40:00',1.51),('7643','2013-10-07','10:45:00',1.04),('7643','2013-10-07','10:50:00',1.18),('7643','2013-10-07','10:55:00',2.63),('7643','2013-10-07','11:00:00',5.48),('7643','2013-10-07','11:05:00',5.25),('7643','2013-10-07','11:10:00',9.28),('7643','2013-10-07','11:15:00',16.15),('7643','2013-10-07','11:20:00',13.12),('7643','2013-10-07','11:25:00',6.33),('7643','2013-10-07','11:30:00',12.36),('7643','2013-10-07','11:35:00',9.81),('7643','2013-10-07','11:40:00',6.05),('7643','2013-10-07','11:45:00',5.38),('7643','2013-10-07','11:50:00',4.01),('7643','2013-10-07','11:55:00',3.36),('7643','2013-10-07','12:00:00',2.3),('7643','2013-10-07','12:05:00',2.86),('7643','2013-10-07','12:10:00',3.79),('7643','2013-10-07','12:15:00',3.97),('7643','2013-10-07','12:20:00',4.09),('7643','2013-10-07','12:25:00',5.18),('7643','2013-10-07','12:30:00',10.19),('7643','2013-10-07','12:35:00',8.83),('7643','2013-10-07','12:40:00',16.51),('7643','2013-10-07','12:45:00',10.87),('7643','2013-10-07','12:50:00',15.24),('7643','2013-10-07','12:55:00',14.92),('7643','2013-10-07','13:00:00',13.09),('7643','2013-10-07','13:05:00',13.81),('7643','2013-10-07','13:10:00',8.63),('7643','2013-10-07','13:15:00',11.73),('7643','2013-10-07','13:20:00',6.97),('7643','2013-10-07','13:25:00',12.02),('7643','2013-10-07','13:30:00',7.21),('7643','2013-10-07','13:35:00',4.23),('7643','2013-10-07','13:40:00',4.29),('7643','2013-10-07','13:45:00',2.98),('7643','2013-10-07','13:50:00',2.72),('7643','2013-10-07','13:55:00',3.46),('7643','2013-10-07','14:00:00',2.96),('7643','2013-10-07','14:05:00',5.61),('7643','2013-10-07','14:10:00',8.25),('7643','2013-10-07','14:15:00',9.18),('7643','2013-10-07','14:20:00',10.34),('7643','2013-10-07','14:25:00',10.57),('7643','2013-10-07','14:30:00',10.12),('7643','2013-10-07','14:35:00',4.01),('7643','2013-10-07','14:40:00',4.81),('7643','2013-10-07','14:45:00',11.74),('7643','2013-10-07','14:50:00',12.25),('7643','2013-10-07','14:55:00',11.43),('7643','2013-10-07','15:00:00',11.12),('7643','2013-10-07','15:05:00',11.07),('7643','2013-10-07','15:10:00',10.27),('7643','2013-10-07','15:15:00',10.82),('7643','2013-10-07','15:20:00',9.38),('7643','2013-10-07','15:25:00',9.16),('7643','2013-10-07','15:30:00',12.34),('7643','2013-10-07','15:35:00',10.89),('7643','2013-10-07','15:40:00',7.89),('7643','2013-10-07','15:45:00',6.76),('7643','2013-10-07','15:50:00',9.63),('7643','2013-10-07','15:55:00',4.85),('7643','2013-10-07','16:00:00',4.71),('7643','2013-10-07','16:05:00',6.11),('7643','2013-10-07','16:10:00',3.95),('7643','2013-10-07','16:15:00',2.43),('7643','2013-10-07','16:20:00',1.5),('7643','2013-10-07','16:25:00',1.6),('7643','2013-10-07','16:30:00',2.53),('7643','2013-10-07','16:35:00',2.35),('7643','2013-10-07','16:40:00',2.28),('7643','2013-10-07','16:45:00',2.83),('7643','2013-10-07','16:50:00',2.28),('7643','2013-10-07','16:55:00',1.23),('7643','2013-10-06','07:45:00',1.07),('7643','2013-10-06','07:50:00',1.36),('7643','2013-10-06','07:55:00',1.63),('7643','2013-10-06','08:00:00',1.89),('7643','2013-10-06','08:05:00',2.15),('7643','2013-10-06','08:10:00',2.43),('7643','2013-10-06','08:15:00',2.42),('7643','2013-10-06','08:20:00',2.89),('7643','2013-10-06','08:25:00',3.28),('7643','2013-10-06','08:30:00',3.69),('7643','2013-10-06','08:35:00',4.74),('7643','2013-10-06','08:40:00',5.34),('7643','2013-10-06','08:45:00',2.59),('7643','2013-10-06','08:50:00',2.24),('7643','2013-10-06','08:55:00',3.98),('7643','2013-10-06','09:00:00',5.94),('7643','2013-10-06','09:05:00',6.21),('7643','2013-10-06','09:10:00',6.45),('7643','2013-10-06','09:15:00',6.71),('7643','2013-10-06','09:20:00',6.73),('7643','2013-10-06','09:25:00',7.24),('7643','2013-10-06','09:30:00',7.52),('7643','2013-10-06','09:35:00',7.8),('7643','2013-10-06','09:40:00',8.04),('7643','2013-10-06','09:45:00',8.28),('7643','2013-10-06','09:50:00',8.57),('7643','2013-10-06','09:55:00',8.78),('7643','2013-10-06','10:00:00',9.03),('7643','2013-10-06','10:05:00',9.28),('7643','2013-10-06','10:10:00',9.44),('7643','2013-10-06','10:15:00',9.69),('7643','2013-10-06','10:20:00',9.91),('7643','2013-10-06','10:25:00',10.24),('7643','2013-10-06','10:30:00',10.48),('7643','2013-10-06','10:35:00',10.82),('7643','2013-10-06','10:40:00',10.87),('7643','2013-10-06','10:45:00',11.14),('7643','2013-10-06','10:50:00',11.3),('7643','2013-10-06','10:55:00',11.4),('7643','2013-10-06','11:00:00',10.23),('7643','2013-10-06','11:05:00',11.26),('7643','2013-10-06','11:10:00',6.09),('7643','2013-10-06','11:15:00',10.12),('7643','2013-10-06','11:20:00',10.96),('7643','2013-10-06','11:25:00',12.27),('7643','2013-10-06','11:30:00',11.79),('7643','2013-10-06','11:35:00',12.29),('7643','2013-10-06','11:40:00',12.4),('7643','2013-10-06','11:45:00',12.58),('7643','2013-10-06','11:50:00',12.61),('7643','2013-10-06','11:55:00',12.85),('7643','2013-10-06','12:00:00',12.76),('7643','2013-10-06','12:05:00',13.18),('7643','2013-10-06','12:10:00',13.59),('7643','2013-10-06','12:15:00',12.02),('7643','2013-10-06','12:20:00',8.43),('7643','2013-10-06','12:25:00',14.87),('7643','2013-10-06','12:30:00',14.07),('7643','2013-10-06','12:35:00',13.69),('7643','2013-10-06','12:40:00',13.93),('7643','2013-10-06','12:45:00',13.84),('7643','2013-10-06','12:50:00',13.87),('7643','2013-10-06','12:55:00',14.09),('7643','2013-10-06','13:00:00',13.75),('7643','2013-10-06','13:05:00',13.72),('7643','2013-10-06','13:10:00',13.85),('7643','2013-10-06','13:15:00',13.47),('7643','2013-10-06','13:20:00',13.27),('7643','2013-10-06','13:25:00',7.41),('7643','2013-10-06','13:30:00',11.3),('7643','2013-10-06','13:35:00',11.05),('7643','2013-10-06','13:40:00',6.93),('7643','2013-10-06','13:45:00',5.25),('7643','2013-10-06','13:50:00',11.18),('7643','2013-10-06','13:55:00',15.99),('7643','2013-10-06','14:00:00',15.24),('7643','2013-10-06','14:05:00',3.54),('7643','2013-10-06','14:10:00',6.37),('7643','2013-10-06','14:15:00',3.56),('7643','2013-10-06','14:20:00',4.61),('7643','2013-10-06','14:25:00',11.4),('7643','2013-10-06','14:30:00',7.3),('7643','2013-10-06','14:35:00',5.52),('7643','2013-10-06','14:40:00',10.16),('7643','2013-10-06','14:45:00',13.52),('7643','2013-10-06','14:50:00',13.39),('7643','2013-10-06','14:55:00',11.63),('7643','2013-10-06','15:00:00',9.26),('7643','2013-10-06','15:05:00',7.02),('7643','2013-10-06','15:10:00',6.47),('7643','2013-10-06','15:15:00',6.06),('7643','2013-10-06','15:20:00',3.4),('7643','2013-10-06','15:25:00',3.22),('7643','2013-10-06','15:30:00',10.37),('7643','2013-10-06','15:35:00',6.63),('7643','2013-10-06','15:40:00',5.06),('7643','2013-10-06','15:45:00',4.63),('7643','2013-10-06','15:50:00',8.39),('7643','2013-10-06','15:55:00',7.32),('7643','2013-10-06','16:00:00',2.04),('7643','2013-10-06','16:05:00',2.09),('7643','2013-10-06','16:10:00',8.16),('7643','2013-10-06','16:15:00',8.49),('7643','2013-10-06','16:20:00',8.04),('7643','2013-10-06','16:25:00',7.67),('7643','2013-10-06','16:30:00',7.18),('7643','2013-10-06','16:35:00',6.9),('7643','2013-10-06','16:40:00',6.65),('7643','2013-10-06','16:45:00',6.17),('7643','2013-10-06','16:50:00',5.93),('7643','2013-10-06','16:55:00',5.26),('7643','2013-10-06','17:00:00',4.72),('7643','2013-10-06','17:05:00',4.26),('7643','2013-10-06','17:10:00',3.82),('7643','2013-10-06','17:15:00',3.46),('7643','2013-10-06','17:20:00',3.13),('7643','2013-10-06','17:25:00',2.88),('7643','2013-10-06','17:30:00',2.56),('7643','2013-10-06','17:35:00',2.23),('7643','2013-10-06','17:40:00',1.9),('7643','2013-10-06','17:45:00',1.61),('7643','2013-10-06','17:50:00',1.33),('7643','2013-10-06','17:55:00',1.06),('7643','2013-10-05','08:25:00',1.04),('7643','2013-10-05','08:35:00',1.12),('7643','2013-10-05','08:40:00',1.26),('7643','2013-10-05','08:45:00',1.24),('7643','2013-10-05','08:50:00',1.92),('7643','2013-10-05','08:55:00',1.78),('7643','2013-10-05','09:00:00',2.1),('7643','2013-10-05','09:05:00',3.7),('7643','2013-10-05','09:10:00',3.24),('7643','2013-10-05','09:15:00',1.94),('7643','2013-10-05','09:20:00',1.61),('7643','2013-10-05','09:25:00',2.2),('7643','2013-10-05','09:30:00',3.9),('7643','2013-10-05','09:35:00',5.33),('7643','2013-10-05','09:40:00',5.03),('7643','2013-10-05','09:45:00',4),('7643','2013-10-05','09:50:00',7.75),('7643','2013-10-05','09:55:00',9.22),('7643','2013-10-05','10:00:00',10.82),('7643','2013-10-05','10:05:00',11.05),('7643','2013-10-05','10:10:00',10.9),('7643','2013-10-05','10:15:00',9.97),('7643','2013-10-05','10:20:00',9.99),('7643','2013-10-05','10:25:00',11.27),('7643','2013-10-05','10:30:00',11),('7643','2013-10-05','10:35:00',10.73),('7643','2013-10-05','10:40:00',9.35),('7643','2013-10-05','10:45:00',7.79),('7643','2013-10-05','10:50:00',8.5),('7643','2013-10-05','10:55:00',9.5),('7643','2013-10-05','11:00:00',9.69),('7643','2013-10-05','11:05:00',10.36),('7643','2013-10-05','11:10:00',10.63),('7643','2013-10-05','11:15:00',9.79),('7643','2013-10-05','11:20:00',10.18),('7643','2013-10-05','11:25:00',11.05),('7643','2013-10-05','11:30:00',10.85),('7643','2013-10-05','11:35:00',10.65),('7643','2013-10-05','11:40:00',9.89),('7643','2013-10-05','11:45:00',7.38),('7643','2013-10-05','11:50:00',7.45),('7643','2013-10-05','11:55:00',9.57),('7643','2013-10-05','12:00:00',9.76),('7643','2013-10-05','12:05:00',9.78),('7643','2013-10-05','12:10:00',11.92),('7643','2013-10-05','12:15:00',11.35),('7643','2013-10-05','12:20:00',11.8),('7643','2013-10-05','12:25:00',10.16),('7643','2013-10-05','12:30:00',9.81),('7643','2013-10-05','12:35:00',10.12),('7643','2013-10-05','12:40:00',9.46),('7643','2013-10-05','12:45:00',9.3),('7643','2013-10-05','12:50:00',10.52),('7643','2013-10-05','12:55:00',12.08),('7643','2013-10-05','13:00:00',12.26),('7643','2013-10-05','13:05:00',12.11),('7643','2013-10-05','13:10:00',10.78),('7643','2013-10-05','13:15:00',10.51),('7643','2013-10-05','13:20:00',9.29),('7643','2013-10-05','13:25:00',4.13),('7643','2013-10-05','13:30:00',2.85),('7643','2013-10-05','13:35:00',2.08),('7643','2013-10-05','13:40:00',2.66),('7643','2013-10-05','13:45:00',7.25),('7643','2013-10-05','13:50:00',13.64),('7643','2013-10-05','13:55:00',10.21),('7643','2013-10-05','14:00:00',7.04),('7643','2013-10-05','14:05:00',6.57),('7643','2013-10-05','14:10:00',7.4),('7643','2013-10-05','14:15:00',5.71),('7643','2013-10-05','14:20:00',5.62),('7643','2013-10-05','14:25:00',6.19),('7643','2013-10-05','14:30:00',7.84),('7643','2013-10-05','14:35:00',8.02),('7643','2013-10-05','14:40:00',6.49),('7643','2013-10-05','14:45:00',6.04),('7643','2013-10-05','14:50:00',6.45),('7643','2013-10-05','14:55:00',9.31),('7643','2013-10-05','15:00:00',7.19),('7643','2013-10-05','15:05:00',5.13),('7643','2013-10-05','15:10:00',4.31),('7643','2013-10-05','15:15:00',3.91),('7643','2013-10-05','15:20:00',3.43),('7643','2013-10-05','15:25:00',2.69),('7643','2013-10-05','15:30:00',2.53),('7643','2013-10-05','15:35:00',2.57),('7643','2013-10-05','15:40:00',2.8),('7643','2013-10-05','15:45:00',3.13),('7643','2013-10-05','15:50:00',3.18),('7643','2013-10-05','15:55:00',4.03),('7643','2013-10-05','16:00:00',3.95),('7643','2013-10-05','16:05:00',2.81),('7643','2013-10-05','16:10:00',2.13),('7643','2013-10-05','16:15:00',1.75),('7643','2013-10-05','16:20:00',2.03),('7643','2013-10-05','16:25:00',1.8),('7643','2013-10-05','16:30:00',1.39),('7643','2013-10-05','16:35:00',1.42),('7643','2013-10-05','16:40:00',1.4),('7643','2013-10-05','16:45:00',1.37),('7643','2013-10-05','16:50:00',1.42),('7643','2013-10-05','16:55:00',1.57),('7643','2013-10-05','17:00:00',2.01),('7643','2013-10-05','17:05:00',2.29),('7643','2013-10-05','17:10:00',3.23),('7643','2013-10-05','17:15:00',3.33),('7643','2013-10-05','17:20:00',2.98),('7643','2013-10-05','17:25:00',2.23),('7643','2013-10-05','17:30:00',1.96),('7643','2013-10-05','17:35:00',1.88),('7643','2013-10-05','17:40:00',1.44),('7643','2013-10-05','17:45:00',1.4),('7643','2013-10-05','17:50:00',1.14),('7643','2013-10-04','07:45:00',1.52),('7643','2013-10-04','07:50:00',1.66),('7643','2013-10-04','07:55:00',1.61),('7643','2013-10-04','08:00:00',1.09),('7643','2013-10-04','08:35:00',1.46),('7643','2013-10-04','08:40:00',2.02),('7643','2013-10-04','08:45:00',1.54),('7643','2013-10-04','08:50:00',1.56),('7643','2013-10-04','08:55:00',1.24),('7643','2013-10-04','09:10:00',1.27),('7643','2013-10-04','14:20:00',1.03),('7643','2013-10-04','14:25:00',1.41),('7643','2013-10-04','14:30:00',1.34),('7643','2013-10-04','14:35:00',1.41),('7643','2013-10-04','14:40:00',1.77),('7643','2013-10-04','14:45:00',1.85),('7643','2013-10-04','14:50:00',2.08),('7643','2013-10-04','14:55:00',1.7),('7643','2013-10-04','15:00:00',1.98),('7643','2013-10-04','15:05:00',2.07),('7643','2013-10-04','15:10:00',1.98),('7643','2013-10-04','15:15:00',1.92),('7643','2013-10-04','15:20:00',1.96),('7643','2013-10-04','15:25:00',2.03),('7643','2013-10-04','15:30:00',2.04),('7643','2013-10-04','15:35:00',2.17),('7643','2013-10-04','15:40:00',2.52),('7643','2013-10-04','15:45:00',2.63),('7643','2013-10-04','15:50:00',2.72),('7643','2013-10-04','15:55:00',2.98),('7643','2013-10-04','16:00:00',3.38),('7643','2013-10-04','16:05:00',4.2),('7643','2013-10-04','16:10:00',4.19),('7643','2013-10-04','16:15:00',3.76),('7643','2013-10-04','16:20:00',3.97),('7643','2013-10-04','16:25:00',3.99),('7643','2013-10-04','16:30:00',3.36),('7643','2013-10-04','16:35:00',3.14),('7643','2013-10-04','16:40:00',3.42),('7643','2013-10-04','16:45:00',3.25),('7643','2013-10-04','16:50:00',3.25),('7643','2013-10-04','16:55:00',2.94),('7643','2013-10-04','17:00:00',2.96),('7643','2013-10-04','17:05:00',2.73),('7643','2013-10-04','17:10:00',2.49),('7643','2013-10-04','17:15:00',2.59),('7643','2013-10-04','17:20:00',2.19),('7643','2013-10-04','17:25:00',1.67),('7643','2013-10-04','17:30:00',1.03),('7643','2013-10-03','07:40:00',1.19),('7643','2013-10-03','07:45:00',1.13),('7643','2013-10-03','08:05:00',1.08),('7643','2013-10-03','08:10:00',1.26),('7643','2013-10-03','08:15:00',1.75),('7643','2013-10-03','08:20:00',1.54),('7643','2013-10-03','08:25:00',1.59),('7643','2013-10-03','08:30:00',2.36),('7643','2013-10-03','08:35:00',2.3),('7643','2013-10-03','08:40:00',2.2),('7643','2013-10-03','08:45:00',2.86),('7643','2013-10-03','08:50:00',2.5),('7643','2013-10-03','08:55:00',2.54),('7643','2013-10-03','09:00:00',2.73),('7643','2013-10-03','09:05:00',2.28),('7643','2013-10-03','09:10:00',2.48),('7643','2013-10-03','09:15:00',2.34),('7643','2013-10-03','09:20:00',2.59),('7643','2013-10-03','09:25:00',3.55),('7643','2013-10-03','09:30:00',4.11),('7643','2013-10-03','09:35:00',4.14),('7643','2013-10-03','09:40:00',4.04),('7643','2013-10-03','09:45:00',4.07),('7643','2013-10-03','09:50:00',4.79),('7643','2013-10-03','09:55:00',10.29),('7643','2013-10-03','10:00:00',7.44),('7643','2013-10-03','10:05:00',5.62),('7643','2013-10-03','10:10:00',5.48),('7643','2013-10-03','10:15:00',6.88),('7643','2013-10-03','10:20:00',5.43),('7643','2013-10-03','10:25:00',6.64),('7643','2013-10-03','10:30:00',9.5),('7643','2013-10-03','10:35:00',7.02),('7643','2013-10-03','10:40:00',9.68),('7643','2013-10-03','10:45:00',7.5),('7643','2013-10-03','10:50:00',6.66),('7643','2013-10-03','10:55:00',10.91),('7643','2013-10-03','11:00:00',7.63),('7643','2013-10-03','11:05:00',6.36),('7643','2013-10-03','11:10:00',5.81),('7643','2013-10-03','11:15:00',11.37),('7643','2013-10-03','11:20:00',11.33),('7643','2013-10-03','11:25:00',10.23),('7643','2013-10-03','11:30:00',13.91),('7643','2013-10-03','11:35:00',13.91),('7643','2013-10-03','11:40:00',13.67),('7643','2013-10-03','11:45:00',13.42),('7643','2013-10-03','11:50:00',13.29),('7643','2013-10-03','11:55:00',13.22),('7643','2013-10-03','12:00:00',13.37),('7643','2013-10-03','12:05:00',13.45),('7643','2013-10-03','12:10:00',13.54),('7643','2013-10-03','12:15:00',12.85),('7643','2013-10-03','12:20:00',12.48),('7643','2013-10-03','12:25:00',13.75),('7643','2013-10-03','12:30:00',13.73),('7643','2013-10-03','12:35:00',12.39),('7643','2013-10-03','12:40:00',13.51),('7643','2013-10-03','12:45:00',13.5),('7643','2013-10-03','12:50:00',12.99),('7643','2013-10-03','12:55:00',13.09),('7643','2013-10-03','13:00:00',13.18),('7643','2013-10-03','13:05:00',13.37),('7643','2013-10-03','13:10:00',13.41),('7643','2013-10-03','13:15:00',14.22),('7643','2013-10-03','13:20:00',13.79),('7643','2013-10-03','13:25:00',12.84),('7643','2013-10-03','13:30:00',13.57),('7643','2013-10-03','13:35:00',12.26),('7643','2013-10-03','13:40:00',13),('7643','2013-10-03','13:45:00',12.74),('7643','2013-10-03','13:50:00',12.63),('7643','2013-10-03','13:55:00',12.59),('7643','2013-10-03','14:00:00',12.57),('7643','2013-10-03','14:05:00',12.41),('7643','2013-10-03','14:10:00',11.33),('7643','2013-10-03','14:15:00',10.21),('7643','2013-10-03','14:20:00',11.15),('7643','2013-10-03','14:25:00',11.94),('7643','2013-10-03','14:30:00',10.51),('7643','2013-10-03','14:35:00',7.57),('7643','2013-10-03','14:40:00',5.95),('7643','2013-10-03','14:45:00',6.88),('7643','2013-10-03','14:50:00',9.05),('7643','2013-10-03','14:55:00',9.32),('7643','2013-10-03','15:00:00',7.88),('7643','2013-10-03','15:05:00',8.87),('7643','2013-10-03','15:10:00',7.71),('7643','2013-10-03','15:15:00',5.98),('7643','2013-10-03','15:20:00',5.2),('7643','2013-10-03','15:25:00',8.27),('7643','2013-10-03','15:30:00',10.02),('7643','2013-10-03','15:35:00',5.5),('7643','2013-10-03','15:40:00',3.17),('7643','2013-10-03','15:45:00',2.64),('7643','2013-10-03','15:50:00',2.46),('7643','2013-10-03','15:55:00',2.77),('7643','2013-10-03','16:00:00',3.44),('7643','2013-10-03','16:05:00',3.89),('7643','2013-10-03','16:10:00',3.66),('7643','2013-10-03','16:15:00',3.27),('7643','2013-10-03','16:20:00',2.81),('7643','2013-10-03','16:25:00',2.35),('7643','2013-10-03','16:30:00',2.18),('7643','2013-10-03','16:35:00',2.17),('7643','2013-10-03','16:40:00',2.07),('7643','2013-10-03','16:45:00',1.94),('7643','2013-10-03','16:50:00',1.92),('7643','2013-10-03','16:55:00',1.85),('7643','2013-10-03','17:00:00',1.74),('7643','2013-10-03','17:05:00',1.78),('7643','2013-10-03','17:10:00',1.59),('7643','2013-10-03','17:15:00',1.18),('7643','2013-10-03','17:20:00',1.01),('7643','2013-10-03','17:25:00',1.01),('7643','2013-10-02','07:45:00',1.1),('7643','2013-10-02','07:50:00',1.38),('7643','2013-10-02','07:55:00',1.69),('7643','2013-10-02','08:00:00',2.01),('7643','2013-10-02','08:05:00',2.34),('7643','2013-10-02','08:10:00',2),('7643','2013-10-02','08:15:00',3.05),('7643','2013-10-02','08:20:00',3.41),('7643','2013-10-02','08:25:00',3.77),('7643','2013-10-02','08:30:00',4.13),('7643','2013-10-02','08:35:00',4.46),('7643','2013-10-02','08:40:00',4.82),('7643','2013-10-02','08:45:00',5.19),('7643','2013-10-02','08:50:00',5.54),('7643','2013-10-02','08:55:00',5.92),('7643','2013-10-02','09:00:00',6.26),('7643','2013-10-02','09:05:00',6.57),('7643','2013-10-02','09:10:00',6.95),('7643','2013-10-02','09:15:00',7.31),('7643','2013-10-02','09:20:00',7.61),('7643','2013-10-02','09:25:00',7.94),('7643','2013-10-02','09:30:00',8.25),('7643','2013-10-02','09:35:00',8.55),('7643','2013-10-02','09:40:00',8.87),('7643','2013-10-02','09:45:00',9.17),('7643','2013-10-02','09:50:00',9.45),('7643','2013-10-02','09:55:00',9.72),('7643','2013-10-02','10:00:00',10.02),('7643','2013-10-02','10:05:00',10.28),('7643','2013-10-02','10:10:00',10.51),('7643','2013-10-02','10:15:00',10.76),('7643','2013-10-02','10:20:00',11),('7643','2013-10-02','10:25:00',11.26),('7643','2013-10-02','10:30:00',11.45),('7643','2013-10-02','10:35:00',11.68),('7643','2013-10-02','10:40:00',11.87),('7643','2013-10-02','10:45:00',12.06),('7643','2013-10-02','10:50:00',12.23),('7643','2013-10-02','10:55:00',12.39),('7643','2013-10-02','11:00:00',12.56),('7643','2013-10-02','11:05:00',12.78),('7643','2013-10-02','11:10:00',12.97),('7643','2013-10-02','11:15:00',13.09),('7643','2013-10-02','11:20:00',13.21),('7643','2013-10-02','11:25:00',13.39),('7643','2013-10-02','11:30:00',13.45),('7643','2013-10-02','11:35:00',13.61),('7643','2013-10-02','11:40:00',13.74),('7643','2013-10-02','11:45:00',13.84),('7643','2013-10-02','11:50:00',13.97),('7643','2013-10-02','11:55:00',14.1),('7643','2013-10-02','12:00:00',14.13),('7643','2013-10-02','12:05:00',14.17),('7643','2013-10-02','12:10:00',14.21),('7643','2013-10-02','12:15:00',14.17),('7643','2013-10-02','12:20:00',14.24),('7643','2013-10-02','12:25:00',14.26),('7643','2013-10-02','12:30:00',14.29),('7643','2013-10-02','12:35:00',14.31),('7643','2013-10-02','12:40:00',14.29),('7643','2013-10-02','12:45:00',14.27),('7643','2013-10-02','12:50:00',14.25),('7643','2013-10-02','12:55:00',14.22),('7643','2013-10-02','13:00:00',14.07),('7643','2013-10-02','13:05:00',13.81),('7643','2013-10-02','13:10:00',14.08),('7643','2013-10-02','13:15:00',14.09),('7643','2013-10-02','13:20:00',14.03),('7643','2013-10-02','13:25:00',13.96),('7643','2013-10-02','13:30:00',14),('7643','2013-10-02','13:35:00',13.98),('7643','2013-10-02','13:40:00',13.9),('7643','2013-10-02','13:45:00',13.75),('7643','2013-10-02','13:50:00',13.75),('7643','2013-10-02','13:55:00',13.73),('7643','2013-10-02','14:00:00',13.62),('7643','2013-10-02','14:05:00',13.45),('7643','2013-10-02','14:10:00',13.37),('7643','2013-10-02','14:15:00',13.23),('7643','2013-10-02','14:20:00',13.1),('7643','2013-10-02','14:25:00',12.95),('7643','2013-10-02','14:30:00',12.86),('7643','2013-10-02','14:35:00',12.72),('7643','2013-10-02','14:40:00',12.48),('7643','2013-10-02','14:45:00',12.27),('7643','2013-10-02','14:50:00',12.08),('7643','2013-10-02','14:55:00',11.85),('7643','2013-10-02','15:00:00',11.7),('7643','2013-10-02','15:05:00',11.51),('7643','2013-10-02','15:10:00',11.28),('7643','2013-10-02','15:15:00',11.14),('7643','2013-10-02','15:20:00',10.93),('7643','2013-10-02','15:25:00',10.65),('7643','2013-10-02','15:30:00',10.46),('7643','2013-10-02','15:35:00',10.18),('7643','2013-10-02','15:40:00',9.9),('7643','2013-10-02','15:45:00',9.61),('7643','2013-10-02','15:50:00',9.36),('7643','2013-10-02','15:55:00',9.12),('7643','2013-10-02','16:00:00',8.82),('7643','2013-10-02','16:05:00',8.51),('7643','2013-10-02','16:10:00',8.24),('7643','2013-10-02','16:15:00',7.91),('7643','2013-10-02','16:20:00',7.62),('7643','2013-10-02','16:25:00',7.3),('7643','2013-10-02','16:30:00',7.01),('7643','2013-10-02','16:35:00',6.66),('7643','2013-10-02','16:40:00',6.33),('7643','2013-10-02','16:45:00',6),('7643','2013-10-02','16:50:00',5.65),('7643','2013-10-02','16:55:00',5.29),('7643','2013-10-02','17:00:00',4.94),('7643','2013-10-02','17:05:00',4.61),('7643','2013-10-02','17:10:00',4.25),('7643','2013-10-02','17:15:00',3.89),('7643','2013-10-02','17:20:00',3.54),('7643','2013-10-02','17:25:00',3.19),('7643','2013-10-02','17:30:00',2.86),('7643','2013-10-02','17:35:00',2.52),('7643','2013-10-02','17:40:00',2.2),('7643','2013-10-02','17:45:00',1.89),('7643','2013-10-02','17:50:00',1.59),('7643','2013-10-02','17:55:00',1.31),('7643','2013-10-02','18:00:00',1.06),('7643','2013-10-01','07:50:00',1.22),('7643','2013-10-01','08:00:00',1.33),('7643','2013-10-01','08:05:00',1.65),('7643','2013-10-01','08:10:00',2.3),('7643','2013-10-01','08:15:00',3.09),('7643','2013-10-01','08:20:00',3.96),('7643','2013-10-01','08:25:00',4.15),('7643','2013-10-01','08:30:00',4.04),('7643','2013-10-01','08:35:00',4.12),('7643','2013-10-01','08:40:00',4.5),('7643','2013-10-01','08:45:00',4.88),('7643','2013-10-01','08:50:00',5.22),('7643','2013-10-01','08:55:00',5.56),('7643','2013-10-01','09:00:00',5.92),('7643','2013-10-01','09:05:00',6.25),('7643','2013-10-01','09:10:00',6.57),('7643','2013-10-01','09:15:00',6.9),('7643','2013-10-01','09:20:00',7.2),('7643','2013-10-01','09:25:00',7.51),('7643','2013-10-01','09:30:00',7.81),('7643','2013-10-01','09:35:00',8.08),('7643','2013-10-01','09:40:00',8.37),('7643','2013-10-01','09:45:00',8.63),('7643','2013-10-01','09:50:00',8.87),('7643','2013-10-01','09:55:00',9.11),('7643','2013-10-01','10:00:00',9.35),('7643','2013-10-01','10:05:00',9.52),('7643','2013-10-01','10:10:00',9.75),('7643','2013-10-01','10:15:00',9.99),('7643','2013-10-01','10:20:00',10.28),('7643','2013-10-01','10:25:00',10.5),('7643','2013-10-01','10:30:00',10.77),('7643','2013-10-01','10:35:00',11.02),('7643','2013-10-01','10:40:00',11.26),('7643','2013-10-01','10:45:00',11.51),('7643','2013-10-01','10:50:00',11.67),('7643','2013-10-01','10:55:00',11.93),('7643','2013-10-01','11:00:00',12.12),('7643','2013-10-01','11:05:00',12.29),('7643','2013-10-01','11:10:00',12.45),('7643','2013-10-01','11:15:00',12.57),('7643','2013-10-01','11:20:00',12.69),('7643','2013-10-01','11:25:00',12.8),('7643','2013-10-01','11:30:00',12.93),('7643','2013-10-01','11:35:00',13.06),('7643','2013-10-01','11:40:00',13.15),('7643','2013-10-01','11:45:00',13.23),('7643','2013-10-01','11:50:00',13.35),('7643','2013-10-01','11:55:00',13.46),('7643','2013-10-01','12:00:00',13.5),('7643','2013-10-01','12:05:00',13.51),('7643','2013-10-01','12:10:00',13.57),('7643','2013-10-01','12:15:00',13.62),('7643','2013-10-01','12:20:00',13.66),('7643','2013-10-01','12:25:00',13.61),('7643','2013-10-01','12:30:00',13.66),('7643','2013-10-01','12:35:00',13.69),('7643','2013-10-01','12:40:00',13.72),('7643','2013-10-01','12:45:00',13.78),('7643','2013-10-01','12:50:00',13.81),('7643','2013-10-01','12:55:00',13.83),('7643','2013-10-01','13:00:00',13.85),('7643','2013-10-01','13:05:00',13.83),('7643','2013-10-01','13:10:00',13.86),('7643','2013-10-01','13:15:00',13.83),('7643','2013-10-01','13:20:00',13.73),('7643','2013-10-01','13:25:00',13.75),('7643','2013-10-01','13:30:00',13.66),('7643','2013-10-01','13:35:00',13.53),('7643','2013-10-01','13:40:00',13.49),('7643','2013-10-01','13:45:00',13.44),('7643','2013-10-01','13:50:00',13.34),('7643','2013-10-01','13:55:00',13.31),('7643','2013-10-01','14:00:00',13.23),('7643','2013-10-01','14:05:00',13.1),('7643','2013-10-01','14:10:00',12.99),('7643','2013-10-01','14:15:00',12.87),('7643','2013-10-01','14:20:00',12.71),('7643','2013-10-01','14:25:00',12.62),('7643','2013-10-01','14:30:00',12.47),('7643','2013-10-01','14:35:00',12.36),('7643','2013-10-01','14:40:00',12.19),('7643','2013-10-01','14:45:00',12.02),('7643','2013-10-01','14:50:00',11.87),('7643','2013-10-01','14:55:00',11.67),('7643','2013-10-01','15:00:00',11.48),('7643','2013-10-01','15:05:00',11.29),('7643','2013-10-01','15:10:00',11.06),('7643','2013-10-01','15:15:00',10.88),('7643','2013-10-01','15:20:00',10.67),('7643','2013-10-01','15:25:00',10.38),('7643','2013-10-01','15:30:00',10.17),('7643','2013-10-01','15:35:00',9.94),('7643','2013-10-01','15:40:00',9.69),('7643','2013-10-01','15:45:00',9.47),('7643','2013-10-01','15:50:00',9.2),('7643','2013-10-01','15:55:00',8.92),('7643','2013-10-01','16:00:00',8.62),('7643','2013-10-01','16:05:00',8.38),('7643','2013-10-01','16:10:00',8.04),('7643','2013-10-01','16:15:00',7.74),('7643','2013-10-01','16:20:00',7.43),('7643','2013-10-01','16:25:00',7.13),('7643','2013-10-01','16:30:00',6.84),('7643','2013-10-01','16:35:00',6.56),('7643','2013-10-01','16:40:00',6.22),('7643','2013-10-01','16:45:00',5.86),('7643','2013-10-01','16:50:00',5.54),('7643','2013-10-01','16:55:00',5.2),('7643','2013-10-01','17:00:00',4.88),('7643','2013-10-01','17:05:00',4.55),('7643','2013-10-01','17:10:00',4.19),('7643','2013-10-01','17:15:00',3.82),('7643','2013-10-01','17:20:00',3.51),('7643','2013-10-01','17:25:00',3.17),('7643','2013-10-01','17:30:00',2.77),('7643','2013-10-01','17:35:00',2.44),('7643','2013-10-01','17:40:00',2.01),('7643','2013-10-01','17:45:00',1.59),('7643','2013-10-01','17:50:00',1.61),('7643','2013-10-01','17:55:00',1.35),('7643','2013-10-01','18:00:00',1.03),('7643','2013-09-30','07:55:00',1.45),('7643','2013-09-30','08:00:00',2.03),('7643','2013-09-30','08:05:00',2.39),('7643','2013-09-30','08:10:00',2.39),('7643','2013-09-30','08:15:00',1.54),('7643','2013-09-30','08:20:00',1.69),('7643','2013-09-30','08:25:00',3.71),('7643','2013-09-30','08:30:00',3.5),('7643','2013-09-30','08:35:00',4.01),('7643','2013-09-30','08:40:00',4.5),('7643','2013-09-30','08:45:00',4.98),('7643','2013-09-30','08:50:00',5.3),('7643','2013-09-30','08:55:00',5.63),('7643','2013-09-30','09:00:00',5.98),('7643','2013-09-30','09:05:00',6.31),('7643','2013-09-30','09:10:00',6.6),('7643','2013-09-30','09:15:00',6.94),('7643','2013-09-30','09:20:00',7.21),('7643','2013-09-30','09:25:00',7.46),('7643','2013-09-30','09:30:00',7.73),('7643','2013-09-30','09:35:00',7.93),('7643','2013-09-30','09:40:00',8.19),('7643','2013-09-30','09:45:00',8.4),('7643','2013-09-30','09:50:00',8.65),('7643','2013-09-30','09:55:00',8.85),('7643','2013-09-30','10:00:00',9.22),('7643','2013-09-30','10:05:00',9.37),('7643','2013-09-30','10:10:00',9.63),('7643','2013-09-30','10:15:00',9.84),('7643','2013-09-30','10:20:00',9.83),('7643','2013-09-30','10:25:00',10.1),('7643','2013-09-30','10:30:00',10.57),('7643','2013-09-30','10:35:00',10.68),('7643','2013-09-30','10:40:00',10.86),('7643','2013-09-30','10:45:00',11.14),('7643','2013-09-30','10:50:00',11.46),('7643','2013-09-30','10:55:00',11.69),('7643','2013-09-30','11:00:00',11.78),('7643','2013-09-30','11:05:00',12.38),('7643','2013-09-30','11:10:00',13.33),('7643','2013-09-30','11:15:00',11.63),('7643','2013-09-30','11:20:00',9.07),('7643','2013-09-30','11:25:00',10.99),('7643','2013-09-30','11:30:00',13.4),('7643','2013-09-30','11:35:00',7.2),('7643','2013-09-30','11:40:00',5.76),('7643','2013-09-30','11:45:00',13.8),('7643','2013-09-30','11:50:00',13.68),('7643','2013-09-30','11:55:00',13.68),('7643','2013-09-30','12:00:00',13.45),('7643','2013-09-30','12:05:00',13.57),('7643','2013-09-30','12:10:00',12.73),('7643','2013-09-30','12:15:00',13.25),('7643','2013-09-30','12:20:00',13.58),('7643','2013-09-30','12:25:00',13.98),('7643','2013-09-30','12:30:00',14.25),('7643','2013-09-30','12:35:00',14.51),('7643','2013-09-30','12:40:00',4.21),('7643','2013-09-30','12:45:00',14.72),('7643','2013-09-30','12:50:00',9.75),('7643','2013-09-30','12:55:00',10.97),('7643','2013-09-30','13:00:00',12.79),('7643','2013-09-30','13:05:00',13.6),('7643','2013-09-30','13:10:00',2.85),('7643','2013-09-30','13:15:00',2.71),('7643','2013-09-30','13:20:00',9.88),('7643','2013-09-30','13:25:00',15.15),('7643','2013-09-30','13:30:00',15.32),('7643','2013-09-30','13:35:00',12.68),('7643','2013-09-30','13:40:00',14.66),('7643','2013-09-30','13:45:00',14.34),('7643','2013-09-30','13:50:00',14),('7643','2013-09-30','13:55:00',13.61),('7643','2013-09-30','14:00:00',12.98),('7643','2013-09-30','14:05:00',12.66),('7643','2013-09-30','14:10:00',12.61),('7643','2013-09-30','14:15:00',12.38),('7643','2013-09-30','14:20:00',12.23),('7643','2013-09-30','14:25:00',12.22),('7643','2013-09-30','14:30:00',11.87),('7643','2013-09-30','14:35:00',11.74),('7643','2013-09-30','14:40:00',11.55),('7643','2013-09-30','14:45:00',11.68),('7643','2013-09-30','14:50:00',11.05),('7643','2013-09-30','14:55:00',11.83),('7643','2013-09-30','15:00:00',11.57),('7643','2013-09-30','15:05:00',11.14),('7643','2013-09-30','15:10:00',10.96),('7643','2013-09-30','15:15:00',10.77),('7643','2013-09-30','15:20:00',10.6),('7643','2013-09-30','15:25:00',10.39),('7643','2013-09-30','15:30:00',10.13),('7643','2013-09-30','15:35:00',9.9),('7643','2013-09-30','15:40:00',9.67),('7643','2013-09-30','15:45:00',9.37),('7643','2013-09-30','15:50:00',9.11),('7643','2013-09-30','15:55:00',8.86),('7643','2013-09-30','16:00:00',8.53),('7643','2013-09-30','16:05:00',8.32),('7643','2013-09-30','16:10:00',8.02),('7643','2013-09-30','16:15:00',7.76),('7643','2013-09-30','16:20:00',7.49),('7643','2013-09-30','16:25:00',7.21),('7643','2013-09-30','16:30:00',6.88),('7643','2013-09-30','16:35:00',6.57),('7643','2013-09-30','16:40:00',6.23),('7643','2013-09-30','16:45:00',5.86),('7643','2013-09-30','16:50:00',5.57),('7643','2013-09-30','16:55:00',5.28),('7643','2013-09-30','17:00:00',4.99),('7643','2013-09-30','17:05:00',4.62),('7643','2013-09-30','17:10:00',4.28),('7643','2013-09-30','17:15:00',3.95),('7643','2013-09-30','17:20:00',3.58),('7643','2013-09-30','17:25:00',3.3),('7643','2013-09-30','17:30:00',2.96),('7643','2013-09-30','17:35:00',2.63),('7643','2013-09-30','17:40:00',2.29),('7643','2013-09-30','17:45:00',1.96),('7643','2013-09-30','17:50:00',1.67),('7643','2013-09-30','17:55:00',1.4),('7643','2013-09-30','18:00:00',1.14),('7643','2013-09-29','08:45:00',1.12),('7643','2013-09-29','08:50:00',1.01),('7643','2013-09-29','08:55:00',1.23),('7643','2013-09-29','09:00:00',1.19),('7643','2013-09-29','09:05:00',1.2),('7643','2013-09-29','09:10:00',1.16),('7643','2013-09-29','09:15:00',1.33),('7643','2013-09-29','09:20:00',1.63),('7643','2013-09-29','09:25:00',1.92),('7643','2013-09-29','09:30:00',1.6),('7643','2013-09-29','09:35:00',2.34),('7643','2013-09-29','09:40:00',2.59),('7643','2013-09-29','09:45:00',3.39),('7643','2013-09-29','09:50:00',4.47),('7643','2013-09-29','09:55:00',3.8),('7643','2013-09-29','10:00:00',3.66),('7643','2013-09-29','10:05:00',3.52),('7643','2013-09-29','10:10:00',3.82),('7643','2013-09-29','10:15:00',3.88),('7643','2013-09-29','10:20:00',3.91),('7643','2013-09-29','10:25:00',4.65),('7643','2013-09-29','10:30:00',5.31),('7643','2013-09-29','10:35:00',6.09),('7643','2013-09-29','10:40:00',7.97),('7643','2013-09-29','10:45:00',11.97),('7643','2013-09-29','10:50:00',12.47),('7643','2013-09-29','10:55:00',11.35),('7643','2013-09-29','11:00:00',7.93),('7643','2013-09-29','11:05:00',10.68),('7643','2013-09-29','11:10:00',7.77),('7643','2013-09-29','11:15:00',10.59),('7643','2013-09-29','11:20:00',10.29),('7643','2013-09-29','11:25:00',11.02),('7643','2013-09-29','11:30:00',6.77),('7643','2013-09-29','11:35:00',6.71),('7643','2013-09-29','11:40:00',13.52),('7643','2013-09-29','11:45:00',8.09),('7643','2013-09-29','11:50:00',6.14),('7643','2013-09-29','11:55:00',5.87),('7643','2013-09-29','12:00:00',5.81),('7643','2013-09-29','12:05:00',7.52),('7643','2013-09-29','12:10:00',4.98),('7643','2013-09-29','12:15:00',12.96),('7643','2013-09-29','12:20:00',14.66),('7643','2013-09-29','12:25:00',14.59),('7643','2013-09-29','12:30:00',14.24),('7643','2013-09-29','12:35:00',11.78),('7643','2013-09-29','12:40:00',14.57),('7643','2013-09-29','12:45:00',6.61),('7643','2013-09-29','12:50:00',14.5),('7643','2013-09-29','12:55:00',14.62),('7643','2013-09-29','13:00:00',14.55),('7643','2013-09-29','13:05:00',14.99),('7643','2013-09-29','13:10:00',14.87),('7643','2013-09-29','13:15:00',15.01),('7643','2013-09-29','13:20:00',15.59),('7643','2013-09-29','13:25:00',15.49),('7643','2013-09-29','13:30:00',15.83),('7643','2013-09-29','13:35:00',12.9),('7643','2013-09-29','13:40:00',14.3),('7643','2013-09-29','13:45:00',10.98),('7643','2013-09-29','13:50:00',8.96),('7643','2013-09-29','13:55:00',6.47),('7643','2013-09-29','14:00:00',8.73),('7643','2013-09-29','14:05:00',5.13),('7643','2013-09-29','14:10:00',4.71),('7643','2013-09-29','14:15:00',4.52),('7643','2013-09-29','14:20:00',3.78),('7643','2013-09-29','14:25:00',4.23),('7643','2013-09-29','14:30:00',9.35),('7643','2013-09-29','14:35:00',9.94),('7643','2013-09-29','14:40:00',13.18),('7643','2013-09-29','14:45:00',14.54),('7643','2013-09-29','14:50:00',10.15),('7643','2013-09-29','14:55:00',9.35),('7643','2013-09-29','15:00:00',6.18),('7643','2013-09-29','15:05:00',7.33),('7643','2013-09-29','15:10:00',13.86),('7643','2013-09-29','15:15:00',12.74),('7643','2013-09-29','15:20:00',5.69),('7643','2013-09-29','15:25:00',10.09),('7643','2013-09-29','15:30:00',10.1),('7643','2013-09-29','15:35:00',10.71),('7643','2013-09-29','15:40:00',11.63),('7643','2013-09-29','15:45:00',8.43),('7643','2013-09-29','15:50:00',1.76),('7643','2013-09-29','15:55:00',1.9),('7643','2013-09-29','16:00:00',1.89),('7643','2013-09-29','16:05:00',1.49),('7643','2013-09-29','16:10:00',3.16),('7643','2013-09-29','16:15:00',4.56),('7643','2013-09-29','16:20:00',8.36),('7643','2013-09-29','16:25:00',4.55),('7643','2013-09-29','16:30:00',2.52),('7643','2013-09-29','16:35:00',2.32),('7643','2013-09-29','16:40:00',5.84),('7643','2013-09-29','16:45:00',5.8),('7643','2013-09-29','16:50:00',4.88),('7643','2013-09-29','16:55:00',3.05),('7643','2013-09-29','17:00:00',3.26),('7643','2013-09-29','17:05:00',2.78),('7643','2013-09-29','17:10:00',2.07),('7643','2013-09-29','17:15:00',2.46),('7643','2013-09-29','17:20:00',4.78),('7643','2013-09-29','17:25:00',3.64),('7643','2013-09-29','17:30:00',3.01),('7643','2013-09-29','17:35:00',2.05),('7643','2013-09-29','17:40:00',1.67),('7643','2013-09-29','17:45:00',1.55),('7643','2013-09-29','17:50:00',1.34),('7643','2013-09-29','17:55:00',1.28),('7643','2013-09-28','07:45:00',1.19),('7643','2013-09-28','07:50:00',1.43),('7643','2013-09-28','07:55:00',1.4),('7643','2013-09-28','08:00:00',1.27),('7643','2013-09-28','08:05:00',1.2),('7643','2013-09-28','08:10:00',1.21),('7643','2013-09-28','08:15:00',1.4),('7643','2013-09-28','08:20:00',1.54),('7643','2013-09-28','08:25:00',1.63),('7643','2013-09-28','08:30:00',1.62),('7643','2013-09-28','08:35:00',1.89),('7643','2013-09-28','08:40:00',2.56),('7643','2013-09-28','08:45:00',3.34),('7643','2013-09-28','08:50:00',4.41),('7643','2013-09-28','08:55:00',3.82),('7643','2013-09-28','09:00:00',3.66),('7643','2013-09-28','09:05:00',3.16),('7643','2013-09-28','09:10:00',3.56),('7643','2013-09-28','09:15:00',4.7),('7643','2013-09-28','09:20:00',3.14),('7643','2013-09-28','09:25:00',3.18),('7643','2013-09-28','09:30:00',3.1),('7643','2013-09-28','09:35:00',2.99),('7643','2013-09-28','09:40:00',2.92),('7643','2013-09-28','09:45:00',3.36),('7643','2013-09-28','09:50:00',3.64),('7643','2013-09-28','09:55:00',3.72),('7643','2013-09-28','10:00:00',4.35),('7643','2013-09-28','10:05:00',6.06),('7643','2013-09-28','10:10:00',7.2),('7643','2013-09-28','10:15:00',9.16),('7643','2013-09-28','10:20:00',8.35),('7643','2013-09-28','10:25:00',7.43),('7643','2013-09-28','10:30:00',8.33),('7643','2013-09-28','10:35:00',8.81),('7643','2013-09-28','10:40:00',8.98),('7643','2013-09-28','10:45:00',9.73),('7643','2013-09-28','10:50:00',10.3),('7643','2013-09-28','10:55:00',10.29),('7643','2013-09-28','11:00:00',10.5),('7643','2013-09-28','11:05:00',10.15),('7643','2013-09-28','11:10:00',10.15),('7643','2013-09-28','11:15:00',10.97),('7643','2013-09-28','11:20:00',10.89),('7643','2013-09-28','11:25:00',10.02),('7643','2013-09-28','11:30:00',10.92),('7643','2013-09-28','11:35:00',10.89),('7643','2013-09-28','11:40:00',11.27),('7643','2013-09-28','11:45:00',11.72),('7643','2013-09-28','11:50:00',12.16),('7643','2013-09-28','11:55:00',12.11),('7643','2013-09-28','12:00:00',12.03),('7643','2013-09-28','12:05:00',11.82),('7643','2013-09-28','12:10:00',10.8),('7643','2013-09-28','12:15:00',13.39),('7643','2013-09-28','12:20:00',10.96),('7643','2013-09-28','12:25:00',6.64),('7643','2013-09-28','12:30:00',6.89),('7643','2013-09-28','12:35:00',6.95),('7643','2013-09-28','12:40:00',5.92),('7643','2013-09-28','12:45:00',5.29),('7643','2013-09-28','12:50:00',5.41),('7643','2013-09-28','12:55:00',4.62),('7643','2013-09-28','13:00:00',4.85),('7643','2013-09-28','13:05:00',3.91),('7643','2013-09-28','13:10:00',4.09),('7643','2013-09-28','13:15:00',3.24),('7643','2013-09-28','13:20:00',3.32),('7643','2013-09-28','13:25:00',5.1),('7643','2013-09-28','13:30:00',8.39),('7643','2013-09-28','13:35:00',5.76),('7643','2013-09-28','13:40:00',5.65),('7643','2013-09-28','13:45:00',5.39),('7643','2013-09-28','13:50:00',5.8),('7643','2013-09-28','13:55:00',8.34),('7643','2013-09-28','14:00:00',7.54),('7643','2013-09-28','14:05:00',10.31),('7643','2013-09-28','14:10:00',4.89),('7643','2013-09-28','14:15:00',6.02),('7643','2013-09-28','14:20:00',7.57),('7643','2013-09-28','14:25:00',5.78),('7643','2013-09-28','14:30:00',4.66),('7643','2013-09-28','14:35:00',4.58),('7643','2013-09-28','14:40:00',4.26),('7643','2013-09-28','14:45:00',2.95),('7643','2013-09-28','14:50:00',3.4),('7643','2013-09-28','14:55:00',3.76),('7643','2013-09-28','15:00:00',4.65),('7643','2013-09-28','15:05:00',2.05),('7643','2013-09-28','15:10:00',1.09),('7643','2013-09-28','15:15:00',2.36),('7643','2013-09-28','15:20:00',3.54),('7643','2013-09-28','15:25:00',2.85),('7643','2013-09-28','15:30:00',2.68),('7643','2013-09-28','15:35:00',2.43),('7643','2013-09-28','15:40:00',3.01),('7643','2013-09-28','15:45:00',2.42),('7643','2013-09-28','15:50:00',2.12),('7643','2013-09-28','15:55:00',3.16),('7643','2013-09-28','16:00:00',4.19),('7643','2013-09-28','16:05:00',3.39),('7643','2013-09-28','16:10:00',2.32),('7643','2013-09-28','16:15:00',1.71),('7643','2013-09-28','16:20:00',2.27),('7643','2013-09-28','16:25:00',2.76),('7643','2013-09-28','16:30:00',3.75),('7643','2013-09-28','16:35:00',3.51),('7643','2013-09-28','16:40:00',3.03),('7643','2013-09-28','16:45:00',2.8),('7643','2013-09-28','16:50:00',1.7),('7643','2013-09-28','16:55:00',1.31),('7643','2013-09-28','17:00:00',1.53),('7643','2013-09-28','17:05:00',2.18),('7643','2013-09-28','17:10:00',1.51),('7643','2013-09-28','17:15:00',1.6),('7643','2013-09-28','17:20:00',1.81),('7643','2013-09-28','17:25:00',1.69),('7643','2013-09-28','17:30:00',1.27),('7643','2014-04-13','07:15:00',1.13),('7643','2014-04-13','07:20:00',1.37),('7643','2014-04-13','07:25:00',1.65),('7643','2014-04-13','07:30:00',1.94),('7643','2014-04-13','07:35:00',2.27),('7643','2014-04-13','07:40:00',2.6),('7643','2014-04-13','07:45:00',2.95),('7643','2014-04-13','07:50:00',3.32),('7643','2014-04-13','07:55:00',3.68),('7643','2014-04-13','08:00:00',4.1),('7643','2014-04-13','08:05:00',4.52),('7643','2014-04-13','08:10:00',4.91),('7643','2014-04-13','08:15:00',5.33),('7643','2014-04-13','08:20:00',5.74),('7643','2014-04-13','08:25:00',6.12),('7643','2014-04-13','08:30:00',6.51),('7643','2014-04-13','08:35:00',6.89),('7643','2014-04-13','08:40:00',7.26),('7643','2014-04-13','08:45:00',7.6),('7643','2014-04-13','08:50:00',7.91),('7643','2014-04-13','08:55:00',8.24),('7643','2014-04-13','09:00:00',8.57),('7643','2014-04-13','09:05:00',8.95),('7643','2014-04-13','09:10:00',9.28),('7643','2014-04-13','09:15:00',9.57),('7643','2014-04-13','09:20:00',9.86),('7643','2014-04-13','09:25:00',10.16),('7643','2014-04-13','09:30:00',10.45),('7643','2014-04-13','09:35:00',10.67),('7643','2014-04-13','09:40:00',10.92),('7643','2014-04-13','09:45:00',11.23),('7643','2014-04-13','09:50:00',11.49),('7643','2014-04-13','09:55:00',11.79),('7643','2014-04-13','10:00:00',12.08),('7643','2014-04-13','10:05:00',12.32),('7643','2014-04-13','10:10:00',12.58),('7643','2014-04-13','10:15:00',12.86),('7643','2014-04-13','10:20:00',13.08),('7643','2014-04-13','10:25:00',13.34),('7643','2014-04-13','10:30:00',13.5),('7643','2014-04-13','10:35:00',13.7),('7643','2014-04-13','10:40:00',13.89),('7643','2014-04-13','10:45:00',14.04),('7643','2014-04-13','10:50:00',14.24),('7643','2014-04-13','10:55:00',14.37),('7643','2014-04-13','11:00:00',14.53),('7643','2014-04-13','11:05:00',14.63),('7643','2014-04-13','11:10:00',14.71),('7643','2014-04-13','11:15:00',14.93),('7643','2014-04-13','11:20:00',15.11),('7643','2014-04-13','11:25:00',15.22),('7643','2014-04-13','11:30:00',15.39),('7643','2014-04-13','11:35:00',15.52),('7643','2014-04-13','11:40:00',15.6),('7643','2014-04-13','11:45:00',15.75),('7643','2014-04-13','11:50:00',15.88),('7643','2014-04-13','11:55:00',15.87),('7643','2014-04-13','12:00:00',15.99),('7643','2014-04-13','12:05:00',16.02),('7643','2014-04-13','12:10:00',16.06),('7643','2014-04-13','12:15:00',16.2),('7643','2014-04-13','12:20:00',16.26),('7643','2014-04-13','12:25:00',16.23),('7643','2014-04-13','12:30:00',16.37),('7643','2014-04-13','12:35:00',16.21),('7643','2014-04-13','12:40:00',16.3),('7643','2014-04-13','12:45:00',16.36),('7643','2014-04-13','12:50:00',16.41),('7643','2014-04-13','12:55:00',16.56),('7643','2014-04-13','13:00:00',16.68),('7643','2014-04-13','13:05:00',16.65),('7643','2014-04-13','13:10:00',16.62),('7643','2014-04-13','13:15:00',16.53),('7643','2014-04-13','13:20:00',16.63),('7643','2014-04-13','13:25:00',16.63),('7643','2014-04-13','13:30:00',16.64),('7643','2014-04-13','13:35:00',16.66),('7643','2014-04-13','13:40:00',16.58),('7643','2014-04-13','13:45:00',16.71),('7643','2014-04-13','13:50:00',16.74),('7643','2014-04-13','13:55:00',16.63),('7643','2014-04-13','14:00:00',16.62),('7643','2014-04-13','14:05:00',16.45),('7643','2014-04-13','14:10:00',16.36),('7643','2014-04-13','14:15:00',16.28),('7643','2014-04-13','14:20:00',16.26),('7643','2014-04-13','14:25:00',16.21),('7643','2014-04-13','14:30:00',16.06),('7643','2014-04-13','14:35:00',16.02),('7643','2014-04-13','14:40:00',15.84),('7643','2014-04-13','14:45:00',15.71),('7643','2014-04-13','14:50:00',15.61),('7643','2014-04-13','14:55:00',15.51),('7643','2014-04-13','15:00:00',15.38),('7643','2014-04-13','15:05:00',15.24),('7643','2014-04-13','15:10:00',15.01),('7643','2014-04-13','15:15:00',14.86),('7643','2014-04-13','15:20:00',14.59),('7643','2014-04-13','15:25:00',14.43),('7643','2014-04-13','15:30:00',14.26),('7643','2014-04-13','15:35:00',13.95),('7643','2014-04-13','15:40:00',13.73),('7643','2014-04-13','15:45:00',13.55),('7643','2014-04-13','15:50:00',13.37),('7643','2014-04-13','15:55:00',13.16),('7643','2014-04-13','16:00:00',12.92),('7643','2014-04-13','16:05:00',12.62),('7643','2014-04-13','16:10:00',12.34),('7643','2014-04-13','16:15:00',12.08),('7643','2014-04-13','16:20:00',11.75),('7643','2014-04-13','16:25:00',11.45),('7643','2014-04-13','16:30:00',11.13),('7643','2014-04-13','16:35:00',10.92),('7643','2014-04-13','16:40:00',10.59),('7643','2014-04-13','16:45:00',10.24),('7643','2014-04-13','16:50:00',9.92),('7643','2014-04-13','16:55:00',9.59),('7643','2014-04-13','17:00:00',9.25),('7643','2014-04-13','17:05:00',8.9),('7643','2014-04-13','17:10:00',8.57),('7643','2014-04-13','17:15:00',8.18),('7643','2014-04-13','17:20:00',7.87),('7643','2014-04-13','17:25:00',7.52),('7643','2014-04-13','17:30:00',7.13),('7643','2014-04-13','17:35:00',6.71),('7643','2014-04-13','17:40:00',6.29),('7643','2014-04-13','17:45:00',5.89),('7643','2014-04-13','17:50:00',5.47),('7643','2014-04-13','17:55:00',5.04),('7643','2014-04-13','18:00:00',4.63),('7643','2014-04-13','18:05:00',4.17),('7643','2014-04-13','18:10:00',3.79),('7643','2014-04-13','18:15:00',3.46),('7643','2014-04-13','18:20:00',3.09),('7643','2014-04-13','18:25:00',2.75),('7643','2014-04-13','18:30:00',2.43),('7643','2014-04-13','18:35:00',2.1),('7643','2014-04-13','18:40:00',1.76),('7643','2014-04-13','18:45:00',1.48),('7643','2014-04-13','18:50:00',1.21),('7643','2013-09-27','07:45:00',1.03),('7643','2013-09-27','07:50:00',1.29),('7643','2013-09-27','07:55:00',1.5),('7643','2013-09-27','08:00:00',1.83),('7643','2013-09-27','08:05:00',2.12),('7643','2013-09-27','08:10:00',2.47),('7643','2013-09-27','08:15:00',2.85),('7643','2013-09-27','08:20:00',3.26),('7643','2013-09-27','08:25:00',2.91),('7643','2013-09-27','08:30:00',3.75),('7643','2013-09-27','08:35:00',3.96),('7643','2013-09-27','08:40:00',4.31),('7643','2013-09-27','08:45:00',4.6),('7643','2013-09-27','08:50:00',4.89),('7643','2013-09-27','08:55:00',5.15),('7643','2013-09-27','09:00:00',5.4),('7643','2013-09-27','09:05:00',5.84),('7643','2013-09-27','09:10:00',6.17),('7643','2013-09-27','09:15:00',6.37),('7643','2013-09-27','09:20:00',6.67),('7643','2013-09-27','09:25:00',7.06),('7643','2013-09-27','09:30:00',7.42),('7643','2013-09-27','09:35:00',6.18),('7643','2013-09-27','09:40:00',7.92),('7643','2013-09-27','09:45:00',7.51),('7643','2013-09-27','09:50:00',3.78),('7643','2013-09-27','09:55:00',9.21),('7643','2013-09-27','10:00:00',8.53),('7643','2013-09-27','10:05:00',5.87),('7643','2013-09-27','10:10:00',4.67),('7643','2013-09-27','10:15:00',3.55),('7643','2013-09-27','10:20:00',3.97),('7643','2013-09-27','10:25:00',7.05),('7643','2013-09-27','10:30:00',7.27),('7643','2013-09-27','10:35:00',10.77),('7643','2013-09-27','10:40:00',10.74),('7643','2013-09-27','10:45:00',9.37),('7643','2013-09-27','10:50:00',6.37),('7643','2013-09-27','10:55:00',8.74),('7643','2013-09-27','11:00:00',13.22),('7643','2013-09-27','11:05:00',9.26),('7643','2013-09-27','11:10:00',11.84),('7643','2013-09-27','11:15:00',12.68),('7643','2013-09-27','11:20:00',7.26),('7643','2013-09-27','11:25:00',12.93),('7643','2013-09-27','11:30:00',13.24),('7643','2013-09-27','11:35:00',13.6),('7643','2013-09-27','11:40:00',12.41),('7643','2013-09-27','11:45:00',5.4),('7643','2013-09-27','11:50:00',6.58),('7643','2013-09-27','11:55:00',4.28),('7643','2013-09-27','12:00:00',14.65),('7643','2013-09-27','12:05:00',13.49),('7643','2013-09-27','12:10:00',8.43),('7643','2013-09-27','12:15:00',9.17),('7643','2013-09-27','12:20:00',13.9),('7643','2013-09-27','12:25:00',5.9),('7643','2013-09-27','12:30:00',4.01),('7643','2013-09-27','12:35:00',9.67),('7643','2013-09-27','12:40:00',5.93),('7643','2013-09-27','12:45:00',4.64),('7643','2013-09-27','12:50:00',13.57),('7643','2013-09-27','12:55:00',15.57),('7643','2013-09-27','13:00:00',14.93),('7643','2013-09-27','13:05:00',14.51),('7643','2013-09-27','13:10:00',8.63),('7643','2013-09-27','13:15:00',8.26),('7643','2013-09-27','13:20:00',14.12),('7643','2013-09-27','13:25:00',14.76),('7643','2013-09-27','13:30:00',13.62),('7643','2013-09-27','13:35:00',7.24),('7643','2013-09-27','13:40:00',5.62),('7643','2013-09-27','13:45:00',9.11),('7643','2013-09-27','13:50:00',10.15),('7643','2013-09-27','13:55:00',5.76),('7643','2013-09-27','14:00:00',7.4),('7643','2013-09-27','14:05:00',10.24),('7643','2013-09-27','14:10:00',13.81),('7643','2013-09-27','14:15:00',14.26),('7643','2013-09-27','14:20:00',14.35),('7643','2013-09-27','14:25:00',14.26),('7643','2013-09-27','14:30:00',13.5),('7643','2013-09-27','14:35:00',13.47),('7643','2013-09-27','14:40:00',13.32),('7643','2013-09-27','14:45:00',13.14),('7643','2013-09-27','14:50:00',12.34),('7643','2013-09-27','14:55:00',11.9),('7643','2013-09-27','15:00:00',12.71),('7643','2013-09-27','15:05:00',12.57),('7643','2013-09-27','15:10:00',12.01),('7643','2013-09-27','15:15:00',11.52),('7643','2013-09-27','15:20:00',12.02),('7643','2013-09-27','15:25:00',11.98),('7643','2013-09-27','15:30:00',11.09),('7643','2013-09-27','15:35:00',10.48),('7643','2013-09-27','15:40:00',9.78),('7643','2013-09-27','15:45:00',7.54),('7643','2013-09-27','15:50:00',5.83),('7643','2013-09-27','15:55:00',8.37),('7643','2013-09-27','16:00:00',9.6),('7643','2013-09-27','16:05:00',9.43),('7643','2013-09-27','16:10:00',9.15),('7643','2013-09-27','16:15:00',9.01),('7643','2013-09-27','16:20:00',8.25),('7643','2013-09-27','16:25:00',7.21),('7643','2013-09-27','16:30:00',6.56),('7643','2013-09-27','16:35:00',6.53),('7643','2013-09-27','16:40:00',6.24),('7643','2013-09-27','16:45:00',5.82),('7643','2013-09-27','16:50:00',5.52),('7643','2013-09-27','16:55:00',5.13),('7643','2013-09-27','17:00:00',4.84),('7643','2013-09-27','17:05:00',4.51),('7643','2013-09-27','17:10:00',4.19),('7643','2013-09-27','17:15:00',3.9),('7643','2013-09-27','17:20:00',3.57),('7643','2013-09-27','17:25:00',3.3),('7643','2013-09-27','17:30:00',3.01),('7643','2013-09-27','17:35:00',2.72),('7643','2013-09-27','17:40:00',2.4),('7643','2013-09-27','17:45:00',1.37),('7643','2013-09-26','07:50:00',1.08),('7643','2013-09-26','07:55:00',1.48),('7643','2013-09-26','08:00:00',1.52),('7643','2013-09-26','08:05:00',1.15),('7643','2013-09-26','08:10:00',1.98),('7643','2013-09-26','08:15:00',1.95),('7643','2013-09-26','08:20:00',2.64),('7643','2013-09-26','08:25:00',3.81),('7643','2013-09-26','08:30:00',3.78),('7643','2013-09-26','08:35:00',4.29),('7643','2013-09-26','08:40:00',4.67),('7643','2013-09-26','08:45:00',4.31),('7643','2013-09-26','08:50:00',4.82),('7643','2013-09-26','08:55:00',5.66),('7643','2013-09-26','09:00:00',6.33),('7643','2013-09-26','09:05:00',4.58),('7643','2013-09-26','09:10:00',3.54),('7643','2013-09-26','09:15:00',4.18),('7643','2013-09-26','09:20:00',2.87),('7643','2013-09-26','09:25:00',3.41),('7643','2013-09-26','09:30:00',2.64),('7643','2013-09-26','09:35:00',2.81),('7643','2013-09-26','09:40:00',3),('7643','2013-09-26','09:45:00',2.95),('7643','2013-09-26','09:50:00',5.6),('7643','2013-09-26','09:55:00',9.54),('7643','2013-09-26','10:00:00',7.74),('7643','2013-09-26','10:05:00',9.05),('7643','2013-09-26','10:10:00',6.63),('7643','2013-09-26','10:15:00',6.54),('7643','2013-09-26','10:20:00',10.85),('7643','2013-09-26','10:25:00',7.05),('7643','2013-09-26','10:30:00',6.49),('7643','2013-09-26','10:35:00',6.63),('7643','2013-09-26','10:40:00',6.84),('7643','2013-09-26','10:45:00',7.53),('7643','2013-09-26','10:50:00',3.72),('7643','2013-09-26','10:55:00',6.27),('7643','2013-09-26','11:00:00',9.23),('7643','2013-09-26','11:05:00',9.69),('7643','2013-09-26','11:10:00',10.35),('7643','2013-09-26','11:15:00',6.33),('7643','2013-09-26','11:20:00',8.17),('7643','2013-09-26','11:25:00',7.27),('7643','2013-09-26','11:30:00',4.96),('7643','2013-09-26','11:35:00',3.56),('7643','2013-09-26','11:40:00',3.87),('7643','2013-09-26','11:45:00',4.58),('7643','2013-09-26','11:50:00',3.62),('7643','2013-09-26','11:55:00',3.66),('7643','2013-09-26','12:00:00',11.78),('7643','2013-09-26','12:05:00',10.16),('7643','2013-09-26','12:10:00',13.75),('7643','2013-09-26','12:15:00',9.35),('7643','2013-09-26','12:20:00',5.46),('7643','2013-09-26','12:25:00',4.19),('7643','2013-09-26','12:30:00',4.06),('7643','2013-09-26','12:35:00',3.9),('7643','2013-09-26','12:40:00',3.16),('7643','2013-09-26','12:45:00',3.47),('7643','2013-09-26','12:50:00',6.48),('7643','2013-09-26','12:55:00',13.37),('7643','2013-09-26','13:00:00',13.28),('7643','2013-09-26','13:05:00',13.04),('7643','2013-09-26','13:10:00',14.06),('7643','2013-09-26','13:15:00',10.42),('7643','2013-09-26','13:20:00',7.77),('7643','2013-09-26','13:25:00',8.14),('7643','2013-09-26','13:30:00',2.99),('7643','2013-09-26','13:35:00',3.09),('7643','2013-09-26','13:40:00',3.12),('7643','2013-09-26','13:45:00',4.13),('7643','2013-09-26','13:50:00',3.23),('7643','2013-09-26','13:55:00',5.48),('7643','2013-09-26','14:00:00',11.61),('7643','2013-09-26','14:05:00',7.14),('7643','2013-09-26','14:10:00',8.62),('7643','2013-09-26','14:15:00',14.09),('7643','2013-09-26','14:20:00',11.21),('7643','2013-09-26','14:25:00',13.02),('7643','2013-09-26','14:30:00',11.69),('7643','2013-09-26','14:35:00',12.02),('7643','2013-09-26','14:40:00',11.29),('7643','2013-09-26','14:45:00',11.97),('7643','2013-09-26','14:50:00',11.82),('7643','2013-09-26','14:55:00',11.57),('7643','2013-09-26','15:00:00',11.6),('7643','2013-09-26','15:05:00',9.03),('7643','2013-09-26','15:10:00',9.5),('7643','2013-09-26','15:15:00',10.81),('7643','2013-09-26','15:20:00',10.65),('7643','2013-09-26','15:25:00',10.27),('7643','2013-09-26','15:30:00',10.25),('7643','2013-09-26','15:35:00',9.81),('7643','2013-09-26','15:40:00',9.74),('7643','2013-09-26','15:45:00',9.46),('7643','2013-09-26','15:50:00',8.86),('7643','2013-09-26','15:55:00',9.18),('7643','2013-09-26','16:00:00',8.58),('7643','2013-09-26','16:05:00',8.45),('7643','2013-09-26','16:10:00',5.62),('7643','2013-09-26','16:15:00',7.89),('7643','2013-09-26','16:20:00',6.08),('7643','2013-09-26','16:25:00',7.32),('7643','2013-09-26','16:30:00',6.92),('7643','2013-09-26','16:35:00',5.88),('7643','2013-09-26','16:40:00',6.51),('7643','2013-09-26','16:45:00',6.23),('7643','2013-09-26','16:50:00',5.39),('7643','2013-09-26','16:55:00',4.81),('7643','2013-09-26','17:00:00',2.77),('7643','2013-09-26','17:05:00',3.34),('7643','2013-09-26','17:10:00',3.02),('7643','2013-09-26','17:15:00',4.38),('7643','2013-09-26','17:20:00',3.97),('7643','2013-09-26','17:25:00',3.69),('7643','2013-09-26','17:30:00',3.43),('7643','2013-09-26','17:35:00',2.96),('7643','2013-09-26','17:40:00',2.44),('7643','2013-09-26','17:45:00',2.22),('7643','2013-09-26','17:50:00',2.09),('7643','2013-09-26','17:55:00',1.79),('7643','2013-09-26','18:00:00',1.46),('7643','2013-09-26','18:05:00',1.17),('7643','2013-09-25','07:45:00',1.29),('7643','2013-09-25','07:50:00',1.76),('7643','2013-09-25','07:55:00',1.96),('7643','2013-09-25','08:00:00',2.15),('7643','2013-09-25','08:05:00',2.32),('7643','2013-09-25','08:10:00',2.75),('7643','2013-09-25','08:15:00',2.92),('7643','2013-09-25','08:20:00',2.29),('7643','2013-09-25','08:25:00',3.65),('7643','2013-09-25','08:30:00',3.31),('7643','2013-09-25','08:35:00',3.58),('7643','2013-09-25','08:40:00',4.74),('7643','2013-09-25','08:45:00',5.05),('7643','2013-09-25','08:50:00',5.45),('7643','2013-09-25','08:55:00',5.77),('7643','2013-09-25','09:00:00',6.07),('7643','2013-09-25','09:05:00',6.35),('7643','2013-09-25','09:10:00',6.77),('7643','2013-09-25','09:15:00',7.09),('7643','2013-09-25','09:20:00',7.36),('7643','2013-09-25','09:25:00',7.58),('7643','2013-09-25','09:30:00',7.88),('7643','2013-09-25','09:35:00',8.15),('7643','2013-09-25','09:40:00',8.4),('7643','2013-09-25','09:45:00',8.71),('7643','2013-09-25','09:50:00',8.93),('7643','2013-09-25','09:55:00',9.18),('7643','2013-09-25','10:00:00',9.45),('7643','2013-09-25','10:05:00',9.61),('7643','2013-09-25','10:10:00',9.77),('7643','2013-09-25','10:15:00',9.94),('7643','2013-09-25','10:20:00',10.17),('7643','2013-09-25','10:25:00',9.94),('7643','2013-09-25','10:30:00',10.34),('7643','2013-09-25','10:35:00',10.69),('7643','2013-09-25','10:40:00',10.88),('7643','2013-09-25','10:45:00',11.08),('7643','2013-09-25','10:50:00',11.08),('7643','2013-09-25','10:55:00',11.22),('7643','2013-09-25','11:00:00',11.19),('7643','2013-09-25','11:05:00',11.44),('7643','2013-09-25','11:10:00',11.55),('7643','2013-09-25','11:15:00',11.66),('7643','2013-09-25','11:20:00',12.05),('7643','2013-09-25','11:25:00',12.12),('7643','2013-09-25','11:30:00',12.09),('7643','2013-09-25','11:35:00',12.22),('7643','2013-09-25','11:40:00',12.41),('7643','2013-09-25','11:45:00',11.92),('7643','2013-09-25','11:50:00',12.56),('7643','2013-09-25','11:55:00',11.9),('7643','2013-09-25','12:00:00',12.61),('7643','2013-09-25','12:05:00',8.68),('7643','2013-09-25','12:10:00',4.4),('7643','2013-09-25','12:15:00',5.51),('7643','2013-09-25','12:20:00',7.39),('7643','2013-09-25','12:25:00',5.23),('7643','2013-09-25','12:30:00',4.69),('7643','2013-09-25','12:35:00',4.69),('7643','2013-09-25','12:40:00',5.04),('7643','2013-09-25','12:45:00',5.92),('7643','2013-09-25','12:50:00',5.67),('7643','2013-09-25','12:55:00',9.79),('7643','2013-09-25','13:00:00',12.6),('7643','2013-09-25','13:05:00',8.38),('7643','2013-09-25','13:10:00',6.05),('7643','2013-09-25','13:15:00',14.1),('7643','2013-09-25','13:20:00',12.26),('7643','2013-09-25','13:25:00',13.07),('7643','2013-09-25','13:30:00',6.91),('7643','2013-09-25','13:35:00',6.72),('7643','2013-09-25','13:40:00',5.65),('7643','2013-09-25','13:45:00',4.75),('7643','2013-09-25','13:50:00',6.49),('7643','2013-09-25','13:55:00',10.52),('7643','2013-09-25','14:00:00',9.07),('7643','2013-09-25','14:05:00',11.72),('7643','2013-09-25','14:10:00',9.88),('7643','2013-09-25','14:15:00',13.1),('7643','2013-09-25','14:20:00',8.03),('7643','2013-09-25','14:25:00',3.06),('7643','2013-09-25','14:30:00',3.76),('7643','2013-09-25','14:35:00',9.09),('7643','2013-09-25','14:40:00',3.47),('7643','2013-09-25','14:45:00',11.65),('7643','2013-09-25','14:50:00',14.14),('7643','2013-09-25','14:55:00',11.58),('7643','2013-09-25','15:00:00',8.31),('7643','2013-09-25','15:05:00',6.88),('7643','2013-09-25','15:10:00',5.83),('7643','2013-09-25','15:15:00',5.22),('7643','2013-09-25','15:20:00',6.29),('7643','2013-09-25','15:25:00',11.75),('7643','2013-09-25','15:30:00',2.79),('7643','2013-09-25','15:35:00',6.03),('7643','2013-09-25','15:40:00',7.7),('7643','2013-09-25','15:45:00',5.2),('7643','2013-09-25','15:50:00',7.05),('7643','2013-09-25','15:55:00',9.68),('7643','2013-09-25','16:00:00',8.93),('7643','2013-09-25','16:05:00',6.89),('7643','2013-09-25','16:10:00',8.51),('7643','2013-09-25','16:15:00',8.05),('7643','2013-09-25','16:20:00',7.59),('7643','2013-09-25','16:25:00',7.31),('7643','2013-09-25','16:30:00',7.19),('7643','2013-09-25','16:35:00',6.78),('7643','2013-09-25','16:40:00',6.51),('7643','2013-09-25','16:45:00',6.14),('7643','2013-09-25','16:50:00',5.79),('7643','2013-09-25','16:55:00',5.49),('7643','2013-09-25','17:00:00',5.1),('7643','2013-09-25','17:05:00',5.05),('7643','2013-09-25','17:10:00',4.8),('7643','2013-09-25','17:15:00',4.37),('7643','2013-09-25','17:20:00',4.17),('7643','2013-09-25','17:25:00',3.91),('7643','2013-09-25','17:30:00',3.48),('7643','2013-09-25','17:35:00',3.05),('7643','2013-09-25','17:40:00',3.07),('7643','2013-09-25','17:45:00',2.67),('7643','2013-09-25','17:50:00',2.32),('7643','2013-09-25','17:55:00',1.79),('7643','2013-09-25','18:00:00',1.46),('7643','2013-09-25','18:05:00',1.18),('7643','2013-09-24','08:00:00',1.17),('7643','2013-09-24','08:05:00',1.77),('7643','2013-09-24','08:10:00',2.68),('7643','2013-09-24','08:15:00',2.22),('7643','2013-09-24','08:20:00',2.29),('7643','2013-09-24','08:25:00',2.74),('7643','2013-09-24','08:30:00',2.53),('7643','2013-09-24','08:35:00',1.94),('7643','2013-09-24','08:40:00',2.27),('7643','2013-09-24','08:45:00',5.63),('7643','2013-09-24','08:50:00',5.39),('7643','2013-09-24','08:55:00',3.06),('7643','2013-09-24','09:00:00',2.46),('7643','2013-09-24','09:05:00',4.01),('7643','2013-09-24','09:10:00',3.77),('7643','2013-09-24','09:15:00',5.4),('7643','2013-09-24','09:20:00',3.53),('7643','2013-09-24','09:25:00',5.04),('7643','2013-09-24','09:30:00',5.05),('7643','2013-09-24','09:35:00',7.9),('7643','2013-09-24','09:40:00',7.58),('7643','2013-09-24','09:45:00',6.79),('7643','2013-09-24','09:50:00',8.89),('7643','2013-09-24','09:55:00',10.03),('7643','2013-09-24','10:00:00',9.37),('7643','2013-09-24','10:05:00',5.52),('7643','2013-09-24','10:10:00',3.06),('7643','2013-09-24','10:15:00',2.63),('7643','2013-09-24','10:20:00',4.21),('7643','2013-09-24','10:25:00',3.55),('7643','2013-09-24','10:30:00',3.21),('7643','2013-09-24','10:35:00',2.5),('7643','2013-09-24','10:40:00',2.56),('7643','2013-09-24','10:45:00',7.11),('7643','2013-09-24','10:50:00',13.46),('7643','2013-09-24','10:55:00',13.93),('7643','2013-09-24','11:00:00',13.38),('7643','2013-09-24','11:05:00',13.02),('7643','2013-09-24','11:10:00',13.35),('7643','2013-09-24','11:15:00',6.85),('7643','2013-09-24','11:20:00',4.49),('7643','2013-09-24','11:25:00',8.48),('7643','2013-09-24','11:30:00',13.11),('7643','2013-09-24','11:35:00',12.94),('7643','2013-09-24','11:40:00',12.73),('7643','2013-09-24','11:45:00',11.2),('7643','2013-09-24','11:50:00',5.94),('7643','2013-09-24','11:55:00',4.14),('7643','2013-09-24','12:00:00',3.29),('7643','2013-09-24','12:05:00',2.95),('7643','2013-09-24','12:10:00',3.76),('7643','2013-09-24','12:15:00',9.29),('7643','2013-09-24','12:20:00',12.39),('7643','2013-09-24','12:25:00',3.25),('7643','2013-09-24','12:30:00',5.78),('7643','2013-09-24','12:35:00',5.3),('7643','2013-09-24','12:40:00',10.02),('7643','2013-09-24','12:45:00',4.28),('7643','2013-09-24','12:50:00',3.63),('7643','2013-09-24','12:55:00',2.86),('7643','2013-09-24','13:00:00',3.33),('7643','2013-09-24','13:05:00',3.33),('7643','2013-09-24','13:10:00',3.29),('7643','2013-09-24','13:15:00',3.45),('7643','2013-09-24','13:20:00',3.94),('7643','2013-09-24','13:25:00',4.04),('7643','2013-09-24','13:30:00',7),('7643','2013-09-24','13:35:00',15.31),('7643','2013-09-24','13:40:00',15.98),('7643','2013-09-24','13:45:00',15.79),('7643','2013-09-24','13:50:00',15.02),('7643','2013-09-24','13:55:00',11.8),('7643','2013-09-24','14:00:00',3.27),('7643','2013-09-24','14:05:00',3.22),('7643','2013-09-24','14:10:00',4.08),('7643','2013-09-24','14:15:00',3.46),('7643','2013-09-24','14:20:00',3.32),('7643','2013-09-24','14:25:00',4.43),('7643','2013-09-24','14:30:00',14.15),('7643','2013-09-24','14:35:00',15.29),('7643','2013-09-24','14:40:00',14.89),('7643','2013-09-24','14:45:00',7.35),('7643','2013-09-24','14:50:00',12.85),('7643','2013-09-24','14:55:00',14.58),('7643','2013-09-24','15:00:00',9.31),('7643','2013-09-24','15:05:00',12.53),('7643','2013-09-24','15:10:00',12.29),('7643','2013-09-24','15:15:00',12.12),('7643','2013-09-24','15:20:00',11.69),('7643','2013-09-24','15:25:00',10.17),('7643','2013-09-24','15:30:00',11.38),('7643','2013-09-24','15:35:00',11.41),('7643','2013-09-24','15:40:00',11.31),('7643','2013-09-24','15:45:00',10.04),('7643','2013-09-24','15:50:00',10.18),('7643','2013-09-24','15:55:00',9.98),('7643','2013-09-24','16:00:00',9.62),('7643','2013-09-24','16:05:00',9.24),('7643','2013-09-24','16:10:00',8.81),('7643','2013-09-24','16:15:00',8.72),('7643','2013-09-24','16:20:00',8.23),('7643','2013-09-24','16:25:00',7.93),('7643','2013-09-24','16:30:00',7.74),('7643','2013-09-24','16:35:00',7.34),('7643','2013-09-24','16:40:00',6.86),('7643','2013-09-24','16:45:00',6.68),('7643','2013-09-24','16:50:00',6.29),('7643','2013-09-24','16:55:00',5.94),('7643','2013-09-24','17:00:00',5.68),('7643','2013-09-24','17:05:00',5.35),('7643','2013-09-24','17:10:00',5.07),('7643','2013-09-24','17:15:00',4.68),('7643','2013-09-24','17:20:00',4.3),('7643','2013-09-24','17:25:00',3.95),('7643','2013-09-24','17:30:00',3.64),('7643','2013-09-24','17:35:00',3.29),('7643','2013-09-24','17:40:00',2.9),('7643','2013-09-24','17:45:00',2.6),('7643','2013-09-24','17:50:00',2.29),('7643','2013-09-24','17:55:00',2.02),('7643','2013-09-24','18:00:00',1.73),('7643','2013-09-24','18:05:00',1.44),('7643','2013-09-24','18:10:00',1.18),('7643','2013-09-23','07:40:00',1.18),('7643','2013-09-23','07:45:00',1.44),('7643','2013-09-23','07:50:00',1.76),('7643','2013-09-23','07:55:00',2.07),('7643','2013-09-23','08:00:00',2.41),('7643','2013-09-23','08:05:00',2.74),('7643','2013-09-23','08:10:00',3.07),('7643','2013-09-23','08:15:00',3.44),('7643','2013-09-23','08:20:00',3.79),('7643','2013-09-23','08:25:00',4.13),('7643','2013-09-23','08:30:00',4.47),('7643','2013-09-23','08:35:00',4.84),('7643','2013-09-23','08:40:00',5.17),('7643','2013-09-23','08:45:00',5.51),('7643','2013-09-23','08:50:00',5.78),('7643','2013-09-23','08:55:00',6.1),('7643','2013-09-23','09:00:00',6.46),('7643','2013-09-23','09:05:00',6.77),('7643','2013-09-23','09:10:00',7.14),('7643','2013-09-23','09:15:00',7.46),('7643','2013-09-23','09:20:00',7.76),('7643','2013-09-23','09:25:00',8.07),('7643','2013-09-23','09:30:00',8.36),('7643','2013-09-23','09:35:00',8.63),('7643','2013-09-23','09:40:00',8.86),('7643','2013-09-23','09:45:00',9.1),('7643','2013-09-23','09:50:00',9.33),('7643','2013-09-23','09:55:00',9.56),('7643','2013-09-23','10:00:00',9.8),('7643','2013-09-23','10:05:00',9.95),('7643','2013-09-23','10:10:00',10.22),('7643','2013-09-23','10:15:00',10.48),('7643','2013-09-23','10:20:00',10.74),('7643','2013-09-23','10:25:00',11.01),('7643','2013-09-23','10:30:00',11.19),('7643','2013-09-23','10:35:00',11.34),('7643','2013-09-23','10:40:00',11.52),('7643','2013-09-23','10:45:00',11.69),('7643','2013-09-23','10:50:00',11.81),('7643','2013-09-23','10:55:00',11.97),('7643','2013-09-23','11:00:00',12.12),('7643','2013-09-23','11:05:00',12.22),('7643','2013-09-23','11:10:00',12.38),('7643','2013-09-23','11:15:00',12.43),('7643','2013-09-23','11:20:00',12.54),('7643','2013-09-23','11:25:00',12.63),('7643','2013-09-23','11:30:00',12.75),('7643','2013-09-23','11:35:00',12.83),('7643','2013-09-23','11:40:00',12.89),('7643','2013-09-23','11:45:00',13.1),('7643','2013-09-23','11:50:00',13.2),('7643','2013-09-23','11:55:00',13.21),('7643','2013-09-23','12:00:00',13.29),('7643','2013-09-23','12:05:00',13.26),('7643','2013-09-23','12:10:00',13.38),('7643','2013-09-23','12:15:00',13.41),('7643','2013-09-23','12:20:00',13.26),('7643','2013-09-23','12:25:00',13.34),('7643','2013-09-23','12:30:00',13.26),('7643','2013-09-23','12:35:00',13.5),('7643','2013-09-23','12:40:00',13.61),('7643','2013-09-23','12:45:00',13.63),('7643','2013-09-23','12:50:00',13.74),('7643','2013-09-23','12:55:00',13.67),('7643','2013-09-23','13:00:00',13.63),('7643','2013-09-23','13:05:00',13.6),('7643','2013-09-23','13:10:00',13.56),('7643','2013-09-23','13:15:00',13.59),('7643','2013-09-23','13:20:00',13.57),('7643','2013-09-23','13:25:00',13.49),('7643','2013-09-23','13:30:00',13.41),('7643','2013-09-23','13:35:00',13.31),('7643','2013-09-23','13:40:00',13.52),('7643','2013-09-23','13:45:00',13.55),('7643','2013-09-23','13:50:00',13.24),('7643','2013-09-23','13:55:00',13.21),('7643','2013-09-23','14:00:00',13.13),('7643','2013-09-23','14:05:00',13.08),('7643','2013-09-23','14:10:00',12.89),('7643','2013-09-23','14:15:00',12.88),('7643','2013-09-23','14:20:00',12.81),('7643','2013-09-23','14:25:00',12.73),('7643','2013-09-23','14:30:00',12.54),('7643','2013-09-23','14:35:00',12.29),('7643','2013-09-23','14:40:00',12.28),('7643','2013-09-23','14:45:00',12.15),('7643','2013-09-23','14:50:00',12.04),('7643','2013-09-23','14:55:00',11.95),('7643','2013-09-23','15:00:00',11.6),('7643','2013-09-23','15:05:00',11.56),('7643','2013-09-23','15:10:00',11.38),('7643','2013-09-23','15:15:00',11.11),('7643','2013-09-23','15:20:00',11.05),('7643','2013-09-23','15:25:00',10.91),('7643','2013-09-23','15:30:00',10.74),('7643','2013-09-23','15:35:00',10.54),('7643','2013-09-23','15:40:00',10.29),('7643','2013-09-23','15:45:00',10.08),('7643','2013-09-23','15:50:00',9.8),('7643','2013-09-23','15:55:00',9.55),('7643','2013-09-23','16:00:00',9.31),('7643','2013-09-23','16:05:00',9.04),('7643','2013-09-23','16:10:00',8.74),('7643','2013-09-23','16:15:00',8.52),('7643','2013-09-23','16:20:00',8.3),('7643','2013-09-23','16:25:00',7.91),('7643','2013-09-23','16:30:00',7.64),('7643','2013-09-23','16:35:00',7.31),('7643','2013-09-23','16:40:00',6.99),('7643','2013-09-23','16:45:00',6.72),('7643','2013-09-23','16:50:00',6.48),('7643','2013-09-23','16:55:00',6.21),('7643','2013-09-23','17:00:00',5.87),('7643','2013-09-23','17:05:00',5.49),('7643','2013-09-23','17:10:00',5.17),('7643','2013-09-23','17:15:00',4.82),('7643','2013-09-23','17:20:00',4.45),('7643','2013-09-23','17:25:00',4.09),('7643','2013-09-23','17:30:00',3.65),('7643','2013-09-23','17:35:00',3.27),('7643','2013-09-23','17:40:00',2.88),('7643','2013-09-23','17:45:00',2.61),('7643','2013-09-23','17:50:00',2.29),('7643','2013-09-23','17:55:00',1.98),('7643','2013-09-23','18:00:00',1.68),('7643','2013-09-23','18:05:00',1.44),('7643','2013-09-23','18:10:00',1.2),('7643','2013-09-22','07:40:00',1.22),('7643','2013-09-22','07:45:00',1.51),('7643','2013-09-22','07:50:00',1.83),('7643','2013-09-22','07:55:00',2.15),('7643','2013-09-22','08:00:00',2.5),('7643','2013-09-22','08:05:00',2.84),('7643','2013-09-22','08:10:00',3.18),('7643','2013-09-22','08:15:00',3.54),('7643','2013-09-22','08:20:00',3.9),('7643','2013-09-22','08:25:00',4.28),('7643','2013-09-22','08:30:00',4.62),('7643','2013-09-22','08:35:00',4.96),('7643','2013-09-22','08:40:00',5.33),('7643','2013-09-22','08:45:00',5.67),('7643','2013-09-22','08:50:00',6),('7643','2013-09-22','08:55:00',6.32),('7643','2013-09-22','09:00:00',6.63),('7643','2013-09-22','09:05:00',7),('7643','2013-09-22','09:10:00',7.34),('7643','2013-09-22','09:15:00',7.61),('7643','2013-09-22','09:20:00',7.94),('7643','2013-09-22','09:25:00',8.21),('7643','2013-09-22','09:30:00',8.49),('7643','2013-09-22','09:35:00',8.76),('7643','2013-09-22','09:40:00',9.06),('7643','2013-09-22','09:45:00',9.31),('7643','2013-09-22','09:50:00',9.55),('7643','2013-09-22','09:55:00',9.82),('7643','2013-09-22','10:00:00',10.04),('7643','2013-09-22','10:05:00',10.26),('7643','2013-09-22','10:10:00',10.5),('7643','2013-09-22','10:15:00',10.67),('7643','2013-09-22','10:20:00',10.93),('7643','2013-09-22','10:25:00',11.08),('7643','2013-09-22','10:30:00',11.29),('7643','2013-09-22','10:35:00',11.52),('7643','2013-09-22','10:40:00',11.71),('7643','2013-09-22','10:45:00',11.89),('7643','2013-09-22','10:50:00',11.99),('7643','2013-09-22','10:55:00',12.16),('7643','2013-09-22','11:00:00',12.32),('7643','2013-09-22','11:05:00',12.55),('7643','2013-09-22','11:10:00',12.73),('7643','2013-09-22','11:15:00',12.92),('7643','2013-09-22','11:20:00',13.1),('7643','2013-09-22','11:25:00',13.3),('7643','2013-09-22','11:30:00',13.36),('7643','2013-09-22','11:35:00',13.46),('7643','2013-09-22','11:40:00',13.61),('7643','2013-09-22','11:45:00',13.65),('7643','2013-09-22','11:50:00',13.8),('7643','2013-09-22','11:55:00',13.89),('7643','2013-09-22','12:00:00',14.04),('7643','2013-09-22','12:05:00',14.2),('7643','2013-09-22','12:10:00',14.29),('7643','2013-09-22','12:15:00',14.31),('7643','2013-09-22','12:20:00',14.32),('7643','2013-09-22','12:25:00',14.28),('7643','2013-09-22','12:30:00',14.25),('7643','2013-09-22','12:35:00',14.19),('7643','2013-09-22','12:40:00',14.14),('7643','2013-09-22','12:45:00',14.17),('7643','2013-09-22','12:50:00',14.06),('7643','2013-09-22','12:55:00',14.21),('7643','2013-09-22','13:00:00',14.26),('7643','2013-09-22','13:05:00',14.22),('7643','2013-09-22','13:10:00',14.15),('7643','2013-09-22','13:15:00',14.05),('7643','2013-09-22','13:20:00',13.86),('7643','2013-09-22','13:25:00',13.96),('7643','2013-09-22','13:30:00',13.94),('7643','2013-09-22','13:35:00',13.89),('7643','2013-09-22','13:40:00',13.78),('7643','2013-09-22','13:45:00',13.8),('7643','2013-09-22','13:50:00',13.66),('7643','2013-09-22','13:55:00',13.51),('7643','2013-09-22','14:00:00',13.29),('7643','2013-09-22','14:05:00',13.11),('7643','2013-09-22','14:10:00',13.14),('7643','2013-09-22','14:15:00',13.23),('7643','2013-09-22','14:20:00',12.92),('7643','2013-09-22','14:25:00',12.87),('7643','2013-09-22','14:30:00',13.2),('7643','2013-09-22','14:35:00',12.69),('7643','2013-09-22','14:40:00',12.14),('7643','2013-09-22','14:45:00',12.39),('7643','2013-09-22','14:50:00',12.33),('7643','2013-09-22','14:55:00',12.11),('7643','2013-09-22','15:00:00',11.89),('7643','2013-09-22','15:05:00',11.91),('7643','2013-09-22','15:10:00',9.21),('7643','2013-09-22','15:15:00',11.14),('7643','2013-09-22','15:20:00',11.06),('7643','2013-09-22','15:25:00',10.79),('7643','2013-09-22','15:30:00',10.66),('7643','2013-09-22','15:35:00',10.3),('7643','2013-09-22','15:40:00',9.95),('7643','2013-09-22','15:45:00',9.89),('7643','2013-09-22','15:50:00',9.87),('7643','2013-09-22','15:55:00',9.35),('7643','2013-09-22','16:00:00',7.42),('7643','2013-09-22','16:05:00',9.03),('7643','2013-09-22','16:10:00',3.66),('7643','2013-09-22','16:15:00',6.61),('7643','2013-09-22','16:20:00',5.86),('7643','2013-09-22','16:25:00',8.18),('7643','2013-09-22','16:30:00',6.46),('7643','2013-09-22','16:35:00',7.12),('7643','2013-09-22','16:40:00',6.79),('7643','2013-09-22','16:45:00',6.57),('7643','2013-09-22','16:50:00',6.19),('7643','2013-09-22','16:55:00',5.93),('7643','2013-09-22','17:00:00',5.67),('7643','2013-09-22','17:05:00',5.37),('7643','2013-09-22','17:10:00',5.04),('7643','2013-09-22','17:15:00',4.7),('7643','2013-09-22','17:20:00',4.38),('7643','2013-09-22','17:25:00',4.05),('7643','2013-09-22','17:30:00',3.73),('7643','2013-09-22','17:35:00',3.42),('7643','2013-09-22','17:40:00',3.06),('7643','2013-09-22','17:45:00',2.71),('7643','2013-09-22','17:50:00',2.33),('7643','2013-09-22','17:55:00',2.02),('7643','2013-09-22','18:00:00',1.75),('7643','2013-09-22','18:05:00',1.48),('7643','2013-09-22','18:10:00',1.23),('7643','2013-09-21','07:35:00',1.22),('7643','2013-09-21','07:40:00',1.47),('7643','2013-09-21','07:45:00',1.73),('7643','2013-09-21','07:50:00',1.97),('7643','2013-09-21','07:55:00',2.29),('7643','2013-09-21','08:00:00',2.62),('7643','2013-09-21','08:05:00',3.03),('7643','2013-09-21','08:10:00',3.46),('7643','2013-09-21','08:15:00',3.38),('7643','2013-09-21','08:20:00',3.38),('7643','2013-09-21','08:25:00',4.34),('7643','2013-09-21','08:30:00',4.6),('7643','2013-09-21','08:35:00',4.89),('7643','2013-09-21','08:40:00',5.18),('7643','2013-09-21','08:45:00',5.53),('7643','2013-09-21','08:50:00',5.86),('7643','2013-09-21','08:55:00',6.23),('7643','2013-09-21','09:00:00',6.54),('7643','2013-09-21','09:05:00',6.87),('7643','2013-09-21','09:10:00',7.24),('7643','2013-09-21','09:15:00',7.58),('7643','2013-09-21','09:20:00',7.89),('7643','2013-09-21','09:25:00',8.22),('7643','2013-09-21','09:30:00',8.52),('7643','2013-09-21','09:35:00',8.79),('7643','2013-09-21','09:40:00',9.02),('7643','2013-09-21','09:45:00',9.27),('7643','2013-09-21','09:50:00',9.55),('7643','2013-09-21','09:55:00',9.85),('7643','2013-09-21','10:00:00',10.11),('7643','2013-09-21','10:05:00',10.39),('7643','2013-09-21','10:10:00',10.62),('7643','2013-09-21','10:15:00',10.88),('7643','2013-09-21','10:20:00',11.13),('7643','2013-09-21','10:25:00',11.38),('7643','2013-09-21','10:30:00',11.6),('7643','2013-09-21','10:35:00',11.78),('7643','2013-09-21','10:40:00',12),('7643','2013-09-21','10:45:00',12.14),('7643','2013-09-21','10:50:00',12.29),('7643','2013-09-21','10:55:00',12.46),('7643','2013-09-21','11:00:00',12.6),('7643','2013-09-21','11:05:00',12.74),('7643','2013-09-21','11:10:00',12.85),('7643','2013-09-21','11:15:00',13.06),('7643','2013-09-21','11:20:00',13.08),('7643','2013-09-21','11:25:00',13.21),('7643','2013-09-21','11:30:00',13.38),('7643','2013-09-21','11:35:00',13.64),('7643','2013-09-21','11:40:00',13.83),('7643','2013-09-21','11:45:00',14),('7643','2013-09-21','11:50:00',14.15),('7643','2013-09-21','11:55:00',14.27),('7643','2013-09-21','12:00:00',14.4),('7643','2013-09-21','12:05:00',14.46),('7643','2013-09-21','12:10:00',14.5),('7643','2013-09-21','12:15:00',14.52),('7643','2013-09-21','12:20:00',14.53),('7643','2013-09-21','12:25:00',14.56),('7643','2013-09-21','12:30:00',14.64),('7643','2013-09-21','12:35:00',14.55),('7643','2013-09-21','12:40:00',14.66),('7643','2013-09-21','12:45:00',14.21),('7643','2013-09-21','12:50:00',14.86),('7643','2013-09-21','12:55:00',14.99),('7643','2013-09-21','13:00:00',14.81),('7643','2013-09-21','13:05:00',14.77),('7643','2013-09-21','13:10:00',12.22),('7643','2013-09-21','13:15:00',13.75),('7643','2013-09-21','13:20:00',14.54),('7643','2013-09-21','13:25:00',14.43),('7643','2013-09-21','13:30:00',14.31),('7643','2013-09-21','13:35:00',14.24),('7643','2013-09-21','13:40:00',14.23),('7643','2013-09-21','13:45:00',14.1),('7643','2013-09-21','13:50:00',14.17),('7643','2013-09-21','13:55:00',13.92),('7643','2013-09-21','14:00:00',13.76),('7643','2013-09-21','14:05:00',13.99),('7643','2013-09-21','14:10:00',13.98),('7643','2013-09-21','14:15:00',13.32),('7643','2013-09-21','14:20:00',10.93),('7643','2013-09-21','14:25:00',13.92),('7643','2013-09-21','14:30:00',14.26),('7643','2013-09-21','14:35:00',13.44),('7643','2013-09-21','14:40:00',9.42),('7643','2013-09-21','14:45:00',11.65),('7643','2013-09-21','14:50:00',12.97),('7643','2013-09-21','14:55:00',12.81),('7643','2013-09-21','15:00:00',12.8),('7643','2013-09-21','15:05:00',13.07),('7643','2013-09-21','15:10:00',12.75),('7643','2013-09-21','15:15:00',13.03),('7643','2013-09-21','15:20:00',13.7),('7643','2013-09-21','15:25:00',8.29),('7643','2013-09-21','15:30:00',4.64),('7643','2013-09-21','15:35:00',3.74),('7643','2013-09-21','15:40:00',8.82),('7643','2013-09-21','15:45:00',11.33),('7643','2013-09-21','15:50:00',10.68),('7643','2013-09-21','15:55:00',10.46),('7643','2013-09-21','16:00:00',11.23),('7643','2013-09-21','16:05:00',11.2),('7643','2013-09-21','16:10:00',10.52),('7643','2013-09-21','16:15:00',11.52),('7643','2013-09-21','16:20:00',8.98),('7643','2013-09-21','16:25:00',5.63),('7643','2013-09-21','16:30:00',4.07),('7643','2013-09-21','16:35:00',3.88),('7643','2013-09-21','16:40:00',3.71),('7643','2013-09-21','16:45:00',7.62),('7643','2013-09-21','16:50:00',8.31),('7643','2013-09-21','16:55:00',6.3),('7643','2013-09-21','17:00:00',3.96),('7643','2013-09-21','17:05:00',6.53),('7643','2013-09-21','17:10:00',5.41),('7643','2013-09-21','17:15:00',4.78),('7643','2013-09-21','17:20:00',1.85),('7643','2013-09-21','17:25:00',1.3),('7643','2013-09-21','17:30:00',2.01),('7643','2013-09-21','17:35:00',3.07),('7643','2013-09-21','17:40:00',2.32),('7643','2013-09-21','18:00:00',1.62),('7643','2013-09-21','18:05:00',1.27),('7643','2013-09-20','07:35:00',1.06),('7643','2013-09-20','07:40:00',1.28),('7643','2013-09-20','07:45:00',1.58),('7643','2013-09-20','07:50:00',1.86),('7643','2013-09-20','07:55:00',2.16),('7643','2013-09-20','08:00:00',2.47),('7643','2013-09-20','08:05:00',2.78),('7643','2013-09-20','08:10:00',3.09),('7643','2013-09-20','08:15:00',3.44),('7643','2013-09-20','08:20:00',3.78),('7643','2013-09-20','08:25:00',4.17),('7643','2013-09-20','08:30:00',4.49),('7643','2013-09-20','08:35:00',4.87),('7643','2013-09-20','08:40:00',5.15),('7643','2013-09-20','08:45:00',5.49),('7643','2013-09-20','08:50:00',5.86),('7643','2013-09-20','08:55:00',6.17),('7643','2013-09-20','09:00:00',6.49),('7643','2013-09-20','09:05:00',6.85),('7643','2013-09-20','09:10:00',7.14),('7643','2013-09-20','09:15:00',7.41),('7643','2013-09-20','09:20:00',7.65),('7643','2013-09-20','09:25:00',8),('7643','2013-09-20','09:30:00',8.31),('7643','2013-09-20','09:35:00',8.56),('7643','2013-09-20','09:40:00',8.8),('7643','2013-09-20','09:45:00',9.12),('7643','2013-09-20','09:50:00',9.41),('7643','2013-09-20','09:55:00',9.62),('7643','2013-09-20','10:00:00',9.81),('7643','2013-09-20','10:05:00',10.05),('7643','2013-09-20','10:10:00',10.34),('7643','2013-09-20','10:15:00',10.55),('7643','2013-09-20','10:20:00',10.78),('7643','2013-09-20','10:25:00',10.98),('7643','2013-09-20','10:30:00',11.14),('7643','2013-09-20','10:35:00',11.29),('7643','2013-09-20','10:40:00',11.5),('7643','2013-09-20','10:45:00',11.71),('7643','2013-09-20','10:50:00',11.91),('7643','2013-09-20','10:55:00',12.08),('7643','2013-09-20','11:00:00',12.24),('7643','2013-09-20','11:05:00',12.37),('7643','2013-09-20','11:10:00',12.55),('7643','2013-09-20','11:15:00',12.67),('7643','2013-09-20','11:20:00',12.83),('7643','2013-09-20','11:25:00',12.96),('7643','2013-09-20','11:30:00',13.16),('7643','2013-09-20','11:35:00',13.18),('7643','2013-09-20','11:40:00',13.26),('7643','2013-09-20','11:45:00',13.4),('7643','2013-09-20','11:50:00',13.53),('7643','2013-09-20','11:55:00',13.36),('7643','2013-09-20','12:00:00',13.63),('7643','2013-09-20','12:05:00',13.89),('7643','2013-09-20','12:10:00',13.93),('7643','2013-09-20','12:15:00',13.82),('7643','2013-09-20','12:20:00',13.77),('7643','2013-09-20','12:25:00',12.54),('7643','2013-09-20','12:30:00',14.23),('7643','2013-09-20','12:35:00',13.97),('7643','2013-09-20','12:40:00',13.34),('7643','2013-09-20','12:45:00',13.7),('7643','2013-09-20','12:50:00',14.01),('7643','2013-09-20','12:55:00',14.12),('7643','2013-09-20','13:00:00',14.11),('7643','2013-09-20','13:05:00',13.75),('7643','2013-09-20','13:10:00',14.09),('7643','2013-09-20','13:15:00',14.41),('7643','2013-09-20','13:20:00',11.87),('7643','2013-09-20','13:25:00',13.41),('7643','2013-09-20','13:30:00',13.68),('7643','2013-09-20','13:35:00',13.64),('7643','2013-09-20','13:40:00',12.36),('7643','2013-09-20','13:45:00',11.99),('7643','2013-09-20','13:50:00',12.34),('7643','2013-09-20','13:55:00',12.26),('7643','2013-09-20','14:00:00',12.71),('7643','2013-09-20','14:05:00',13.42),('7643','2013-09-20','14:10:00',12.82),('7643','2013-09-20','14:15:00',13.48),('7643','2013-09-20','14:20:00',13.4),('7643','2013-09-20','14:25:00',13.14),('7643','2013-09-20','14:30:00',12.93),('7643','2013-09-20','14:35:00',12.79),('7643','2013-09-20','14:40:00',12.67),('7643','2013-09-20','14:45:00',12.44),('7643','2013-09-20','14:50:00',12.3),('7643','2013-09-20','14:55:00',12.11),('7643','2013-09-20','15:00:00',11.94),('7643','2013-09-20','15:05:00',11.79),('7643','2013-09-20','15:10:00',11.44),('7643','2013-09-20','15:15:00',11.24),('7643','2013-09-20','15:20:00',11.23),('7643','2013-09-20','15:25:00',11),('7643','2013-09-20','15:30:00',10.82),('7643','2013-09-20','15:35:00',10.58),('7643','2013-09-20','15:40:00',9.71),('7643','2013-09-20','15:45:00',6.33),('7643','2013-09-20','15:50:00',9.79),('7643','2013-09-20','15:55:00',9.45),('7643','2013-09-20','16:00:00',7.36),('7643','2013-09-20','16:05:00',5.08),('7643','2013-09-20','16:10:00',5.78),('7643','2013-09-20','16:15:00',4.92),('7643','2013-09-20','16:20:00',6.4),('7643','2013-09-20','16:25:00',2.99),('7643','2013-09-20','16:30:00',4.07),('7643','2013-09-20','16:35:00',5.25),('7643','2013-09-20','16:40:00',3.84),('7643','2013-09-20','16:45:00',3),('7643','2013-09-20','16:50:00',3.14),('7643','2013-09-20','16:55:00',4.05),('7643','2013-09-20','17:00:00',3.15),('7643','2013-09-20','17:05:00',3.52),('7643','2013-09-20','17:10:00',3.45),('7643','2013-09-20','17:15:00',3.76),('7643','2013-09-20','17:20:00',2.37),('7643','2013-09-20','17:25:00',1.74),('7643','2013-09-20','17:30:00',2.94),('7643','2013-09-20','17:35:00',3.49),('7643','2013-09-20','17:40:00',3.15),('7643','2013-09-20','17:45:00',3.25),('7643','2013-09-20','17:50:00',2.58),('7643','2013-09-20','17:55:00',2.34),('7643','2013-09-20','18:00:00',2.01),('7643','2013-09-20','18:05:00',1.71),('7643','2013-09-20','18:10:00',1.38),('7643','2013-09-20','18:15:00',1.18),('7643','2013-09-19','08:00:00',1.03),('7643','2013-09-19','08:05:00',1.19),('7643','2013-09-19','08:10:00',1.4),('7643','2013-09-19','08:15:00',1.65),('7643','2013-09-19','08:20:00',1.9),('7643','2013-09-19','08:25:00',2.03),('7643','2013-09-19','08:30:00',3.4),('7643','2013-09-19','08:35:00',6.13),('7643','2013-09-19','08:40:00',6.4),('7643','2013-09-19','08:45:00',5.37),('7643','2013-09-19','08:50:00',3.71),('7643','2013-09-19','08:55:00',3.71),('7643','2013-09-19','09:00:00',4.2),('7643','2013-09-19','09:05:00',4.33),('7643','2013-09-19','09:10:00',4.75),('7643','2013-09-19','09:15:00',5.9),('7643','2013-09-19','09:20:00',4.72),('7643','2013-09-19','09:25:00',5.1),('7643','2013-09-19','09:30:00',4.71),('7643','2013-09-19','09:35:00',4.52),('7643','2013-09-19','09:40:00',4.46),('7643','2013-09-19','09:45:00',4.59),('7643','2013-09-19','09:50:00',4.67),('7643','2013-09-19','09:55:00',6.5),('7643','2013-09-19','10:00:00',6.36),('7643','2013-09-19','10:05:00',8.52),('7643','2013-09-19','10:10:00',7.6),('7643','2013-09-19','10:15:00',12.12),('7643','2013-09-19','10:20:00',12.8),('7643','2013-09-19','10:25:00',13.83),('7643','2013-09-19','10:30:00',15.21),('7643','2013-09-19','10:35:00',13.94),('7643','2013-09-19','10:40:00',13.99),('7643','2013-09-19','10:45:00',15.13),('7643','2013-09-19','10:50:00',11.83),('7643','2013-09-19','10:55:00',10.19),('7643','2013-09-19','11:00:00',6.99),('7643','2013-09-19','11:05:00',6.93),('7643','2013-09-19','11:10:00',7.9),('7643','2013-09-19','11:15:00',11.45),('7643','2013-09-19','11:20:00',9.63),('7643','2013-09-19','11:25:00',8.55),('7643','2013-09-19','11:30:00',8.28),('7643','2013-09-19','11:35:00',13.36),('7643','2013-09-19','11:40:00',10.4),('7643','2013-09-19','11:45:00',15.06),('7643','2013-09-19','11:50:00',14.71),('7643','2013-09-19','11:55:00',14.21),('7643','2013-09-19','12:00:00',13.99),('7643','2013-09-19','12:05:00',14.01),('7643','2013-09-19','12:10:00',14.18),('7643','2013-09-19','12:15:00',14.45),('7643','2013-09-19','12:20:00',14.82),('7643','2013-09-19','12:25:00',13.6),('7643','2013-09-19','12:30:00',14.81),('7643','2013-09-19','12:35:00',9.49),('7643','2013-09-19','12:40:00',12.9),('7643','2013-09-19','12:45:00',6.58),('7643','2013-09-19','12:50:00',12.05),('7643','2013-09-19','12:55:00',14.91),('7643','2013-09-19','13:00:00',14.48),('7643','2013-09-19','13:05:00',14.46),('7643','2013-09-19','13:10:00',14.67),('7643','2013-09-19','13:15:00',9.36),('7643','2013-09-19','13:20:00',9.43),('7643','2013-09-19','13:25:00',12.94),('7643','2013-09-19','13:30:00',14.69),('7643','2013-09-19','13:35:00',10.58),('7643','2013-09-19','13:40:00',14.42),('7643','2013-09-19','13:45:00',14.15),('7643','2013-09-19','13:50:00',13.66),('7643','2013-09-19','13:55:00',12.23),('7643','2013-09-19','14:00:00',13.69),('7643','2013-09-19','14:05:00',13.84),('7643','2013-09-19','14:10:00',12.07),('7643','2013-09-19','14:15:00',7.91),('7643','2013-09-19','14:20:00',4.97),('7643','2013-09-19','14:25:00',12.66),('7643','2013-09-19','14:30:00',14.29),('7643','2013-09-19','14:35:00',14.09),('7643','2013-09-19','14:40:00',13.91),('7643','2013-09-19','14:45:00',13.76),('7643','2013-09-19','14:50:00',13.76),('7643','2013-09-19','14:55:00',13.57),('7643','2013-09-19','15:00:00',9.18),('7643','2013-09-19','15:05:00',6.63),('7643','2013-09-19','15:10:00',11.89),('7643','2013-09-19','15:15:00',11.42),('7643','2013-09-19','15:20:00',9.84),('7643','2013-09-19','15:25:00',7.85),('7643','2013-09-19','15:30:00',9.29),('7643','2013-09-19','15:35:00',11.58),('7643','2013-09-19','15:40:00',11.68),('7643','2013-09-19','15:45:00',11.13),('7643','2013-09-19','15:50:00',10.85),('7643','2013-09-19','15:55:00',11.13),('7643','2013-09-19','16:00:00',6.88),('7643','2013-09-19','16:05:00',5.73),('7643','2013-09-19','16:10:00',6.03),('7643','2013-09-19','16:15:00',7.8),('7643','2013-09-19','16:20:00',7.14),('7643','2013-09-19','16:25:00',5.7),('7643','2013-09-19','16:30:00',2.79),('7643','2013-09-19','16:35:00',2.9),('7643','2013-09-19','16:40:00',3.34),('7643','2013-09-19','16:45:00',6.08),('7643','2013-09-19','16:50:00',7.64),('7643','2013-09-19','16:55:00',6.95),('7643','2013-09-19','17:00:00',5.54),('7643','2013-09-19','17:05:00',8.14),('7643','2013-09-19','17:10:00',8.07),('7643','2013-09-19','17:15:00',7.41),('7643','2013-09-19','17:20:00',7.02),('7643','2013-09-19','17:25:00',5.97),('7643','2013-09-19','17:30:00',5.05),('7643','2013-09-19','17:35:00',3.99),('7643','2013-09-19','17:40:00',3.36),('7643','2013-09-19','17:45:00',3.68),('7643','2013-09-19','17:50:00',3.25),('7643','2013-09-19','17:55:00',2.84),('7643','2013-09-19','18:00:00',3.09),('7643','2013-09-19','18:05:00',2.87),('7643','2013-09-19','18:10:00',3),('7643','2013-09-19','18:15:00',2.81),('7643','2013-09-19','18:20:00',2.09),('7643','2013-09-19','18:25:00',1.6),('7643','2013-09-19','18:30:00',1.03),('7643','2013-09-18','07:35:00',1.1),('7643','2013-09-18','07:40:00',1.71),('7643','2013-09-18','07:45:00',1.61),('7643','2013-09-18','08:00:00',1.09),('7643','2013-09-18','08:05:00',1.68),('7643','2013-09-18','08:10:00',2.66),('7643','2013-09-18','08:15:00',3.61),('7643','2013-09-18','08:20:00',3.83),('7643','2013-09-18','08:25:00',3.72),('7643','2013-09-18','08:30:00',4.66),('7643','2013-09-18','08:35:00',5.22),('7643','2013-09-18','08:40:00',4.21),('7643','2013-09-18','08:45:00',4.82),('7643','2013-09-18','08:50:00',3.26),('7643','2013-09-18','08:55:00',4.82),('7643','2013-09-18','09:00:00',5.92),('7643','2013-09-18','09:05:00',3.76),('7643','2013-09-18','09:10:00',4.91),('7643','2013-09-18','09:15:00',6.43),('7643','2013-09-18','09:20:00',4.83),('7643','2013-09-18','09:25:00',4.28),('7643','2013-09-18','09:30:00',3.1),('7643','2013-09-18','09:35:00',3.1),('7643','2013-09-18','09:40:00',3.11),('7643','2013-09-18','09:45:00',2.82),('7643','2013-09-18','09:50:00',2.48),('7643','2013-09-18','09:55:00',2.59),('7643','2013-09-18','10:00:00',2.61),('7643','2013-09-18','10:05:00',7.88),('7643','2013-09-18','10:10:00',6.67),('7643','2013-09-18','10:15:00',7.78),('7643','2013-09-18','10:20:00',3.28),('7643','2013-09-18','10:25:00',5.24),('7643','2013-09-18','10:30:00',3.43),('7643','2013-09-18','10:35:00',8.62),('7643','2013-09-18','10:40:00',8.62),('7643','2013-09-18','10:45:00',11.29),('7643','2013-09-18','10:50:00',6.97),('7643','2013-09-18','10:55:00',11.5),('7643','2013-09-18','11:00:00',15.28),('7643','2013-09-18','11:05:00',15.14),('7643','2013-09-18','11:10:00',11.83),('7643','2013-09-18','11:15:00',5.77),('7643','2013-09-18','11:20:00',8.22),('7643','2013-09-18','11:25:00',6.39),('7643','2013-09-18','11:30:00',9.54),('7643','2013-09-18','11:35:00',7.09),('7643','2013-09-18','11:40:00',8.64),('7643','2013-09-18','11:45:00',13.14),('7643','2013-09-18','11:50:00',14.13),('7643','2013-09-18','11:55:00',14.93),('7643','2013-09-18','12:00:00',5.36),('7643','2013-09-18','12:05:00',5.16),('7643','2013-09-18','12:10:00',8.07),('7643','2013-09-18','12:15:00',8.92),('7643','2013-09-18','12:20:00',16.46),('7643','2013-09-18','12:25:00',16.02),('7643','2013-09-18','12:30:00',14.75),('7643','2013-09-18','12:35:00',14.98),('7643','2013-09-18','12:40:00',15.23),('7643','2013-09-18','12:45:00',13.01),('7643','2013-09-18','12:50:00',15.7),('7643','2013-09-18','12:55:00',15.31),('7643','2013-09-18','13:00:00',15.3),('7643','2013-09-18','13:05:00',15.34),('7643','2013-09-18','13:10:00',15.96),('7643','2013-09-18','13:15:00',16.01),('7643','2013-09-18','13:20:00',15.4),('7643','2013-09-18','13:25:00',13.28),('7643','2013-09-18','13:30:00',15.33),('7643','2013-09-18','13:35:00',15.3),('7643','2013-09-18','13:40:00',15.99),('7643','2013-09-18','13:45:00',16.49),('7643','2013-09-18','13:50:00',16.44),('7643','2013-09-18','13:55:00',7.96),('7643','2013-09-18','14:00:00',4.9),('7643','2013-09-18','14:05:00',11.87),('7643','2013-09-18','14:10:00',14.75),('7643','2013-09-18','14:15:00',13.4),('7643','2013-09-18','14:20:00',14.05),('7643','2013-09-18','14:25:00',13.69),('7643','2013-09-18','14:30:00',13.49),('7643','2013-09-18','14:35:00',13.38),('7643','2013-09-18','14:40:00',12.96),('7643','2013-09-18','14:45:00',12.96),('7643','2013-09-18','14:50:00',12.78),('7643','2013-09-18','14:55:00',13.31),('7643','2013-09-18','15:00:00',12.88),('7643','2013-09-18','15:05:00',12.4),('7643','2013-09-18','15:10:00',11.43),('7643','2013-09-18','15:15:00',13.04),('7643','2013-09-18','15:20:00',12.03),('7643','2013-09-18','15:25:00',11.61),('7643','2013-09-18','15:30:00',11.06),('7643','2013-09-18','15:35:00',7.94),('7643','2013-09-18','15:40:00',11.79),('7643','2013-09-18','15:45:00',11.47),('7643','2013-09-18','15:50:00',10.77),('7643','2013-09-18','15:55:00',9.64),('7643','2013-09-18','16:00:00',9.88),('7643','2013-09-18','16:05:00',9.72),('7643','2013-09-18','16:10:00',9.17),('7643','2013-09-18','16:15:00',8.95),('7643','2013-09-18','16:20:00',9.36),('7643','2013-09-18','16:25:00',9.1),('7643','2013-09-18','16:30:00',6.76),('7643','2013-09-18','16:35:00',7.11),('7643','2013-09-18','16:40:00',6.94),('7643','2013-09-18','16:45:00',6.42),('7643','2013-09-18','16:50:00',7.63),('7643','2013-09-18','16:55:00',7.24),('7643','2013-09-18','17:00:00',6.14),('7643','2013-09-18','17:05:00',5.69),('7643','2013-09-18','17:10:00',5.68),('7643','2013-09-18','17:15:00',5.25),('7643','2013-09-18','17:20:00',5.02),('7643','2013-09-18','17:25:00',4.36),('7643','2013-09-18','17:30:00',4.04),('7643','2013-09-18','17:35:00',3.33),('7643','2013-09-18','17:40:00',3.17),('7643','2013-09-18','17:45:00',2.79),('7643','2013-09-18','17:50:00',2.8),('7643','2013-09-18','17:55:00',2.57),('7643','2013-09-18','18:00:00',2.25),('7643','2013-09-18','18:05:00',2.04),('7643','2013-09-18','18:10:00',1.73),('7643','2013-09-18','18:15:00',1.6),('7643','2013-09-18','18:20:00',1.36),('7643','2013-09-18','18:25:00',1.14),('7643','2014-04-12','07:40:00',1.06),('7643','2014-04-12','07:45:00',1.13),('7643','2014-04-12','07:50:00',1.26),('7643','2014-04-12','07:55:00',1.59),('7643','2014-04-12','08:00:00',1.76),('7643','2014-04-12','08:05:00',1.92),('7643','2014-04-12','08:10:00',1.66),('7643','2014-04-12','08:15:00',1.6),('7643','2014-04-12','08:20:00',1.37),('7643','2014-04-12','08:25:00',1.71),('7643','2014-04-12','08:30:00',2.42),('7643','2014-04-12','08:35:00',2.44),('7643','2014-04-12','08:40:00',2.28),('7643','2014-04-12','08:45:00',2.42),('7643','2014-04-12','08:50:00',2.51),('7643','2014-04-12','08:55:00',2.74),('7643','2014-04-12','09:00:00',3.49),('7643','2014-04-12','09:05:00',4.55),('7643','2014-04-12','09:10:00',5.6),('7643','2014-04-12','09:15:00',4.98),('7643','2014-04-12','09:20:00',5.59),('7643','2014-04-12','09:25:00',7.73),('7643','2014-04-12','09:30:00',7.28),('7643','2014-04-12','09:35:00',5.59),('7643','2014-04-12','09:40:00',8.26),('7643','2014-04-12','09:45:00',7.62),('7643','2014-04-12','09:50:00',5.83),('7643','2014-04-12','09:55:00',6.04),('7643','2014-04-12','10:00:00',10.35),('7643','2014-04-12','10:05:00',15.31),('7643','2014-04-12','10:10:00',9.43),('7643','2014-04-12','10:15:00',8.65),('7643','2014-04-12','10:20:00',11.94),('7643','2014-04-12','10:25:00',7.34),('7643','2014-04-12','10:30:00',12.63),('7643','2014-04-12','10:35:00',13.88),('7643','2014-04-12','10:40:00',13.59),('7643','2014-04-12','10:45:00',14.41),('7643','2014-04-12','10:50:00',14.47),('7643','2014-04-12','10:55:00',14.37),('7643','2014-04-12','11:00:00',14.53),('7643','2014-04-12','11:05:00',14.67),('7643','2014-04-12','11:10:00',14.02),('7643','2014-04-12','11:15:00',13.09),('7643','2014-04-12','11:20:00',17.84),('7643','2014-04-12','11:25:00',12.57),('7643','2014-04-12','11:30:00',7.08),('7643','2014-04-12','11:35:00',13.49),('7643','2014-04-12','11:40:00',15.58),('7643','2014-04-12','11:45:00',15.11),('7643','2014-04-12','11:50:00',15.36),('7643','2014-04-12','11:55:00',10.83),('7643','2014-04-12','12:00:00',9.91),('7643','2014-04-12','12:05:00',6.55),('7643','2014-04-12','12:10:00',5.81),('7643','2014-04-12','12:15:00',5.46),('7643','2014-04-12','12:20:00',4.79),('7643','2014-04-12','12:25:00',3.54),('7643','2014-04-12','12:30:00',2.46),('7643','2014-04-12','12:35:00',1.9),('7643','2014-04-12','12:40:00',1.66),('7643','2014-04-12','12:45:00',2.01),('7643','2014-04-12','12:50:00',2.39),('7643','2014-04-12','12:55:00',2.72),('7643','2014-04-12','13:00:00',2.86),('7643','2014-04-12','13:05:00',4.55),('7643','2014-04-12','13:10:00',7.36),('7643','2014-04-12','13:15:00',7.11),('7643','2014-04-12','13:20:00',9.09),('7643','2014-04-12','13:25:00',9.94),('7643','2014-04-12','13:30:00',16.64),('7643','2014-04-12','13:35:00',16.23),('7643','2014-04-12','13:40:00',17.33),('7643','2014-04-12','13:45:00',8.37),('7643','2014-04-12','13:50:00',12.55),('7643','2014-04-12','13:55:00',11.98),('7643','2014-04-12','14:00:00',16),('7643','2014-04-12','14:05:00',14.46),('7643','2014-04-12','14:10:00',13.62),('7643','2014-04-12','14:15:00',14.47),('7643','2014-04-12','14:20:00',7.03),('7643','2014-04-12','14:25:00',6.14),('7643','2014-04-12','14:30:00',6.86),('7643','2014-04-12','14:35:00',5.7),('7643','2014-04-12','14:40:00',4.65),('7643','2014-04-12','14:45:00',6.64),('7643','2014-04-12','14:50:00',15.53),('7643','2014-04-12','14:55:00',6.03),('7643','2014-04-12','15:00:00',12.95),('7643','2014-04-12','15:05:00',14.65),('7643','2014-04-12','15:10:00',15.08),('7643','2014-04-12','15:15:00',13.46),('7643','2014-04-12','15:20:00',13.1),('7643','2014-04-12','15:25:00',13.81),('7643','2014-04-12','15:30:00',13.8),('7643','2014-04-12','15:35:00',9.26),('7643','2014-04-12','15:40:00',4.95),('7643','2014-04-12','15:45:00',5.09),('7643','2014-04-12','15:50:00',7.01),('7643','2014-04-12','15:55:00',8.01),('7643','2014-04-12','16:00:00',13.98),('7643','2014-04-12','16:05:00',11.75),('7643','2014-04-12','16:10:00',5.28),('7643','2014-04-12','16:15:00',5.15),('7643','2014-04-12','16:20:00',5.81),('7643','2014-04-12','16:25:00',6.29),('7643','2014-04-12','16:30:00',5.3),('7643','2014-04-12','16:35:00',7.67),('7643','2014-04-12','16:40:00',9.73),('7643','2014-04-12','16:45:00',12.24),('7643','2014-04-12','16:50:00',8.88),('7643','2014-04-12','16:55:00',10.23),('7643','2014-04-12','17:00:00',8.98),('7643','2014-04-12','17:05:00',6.63),('7643','2014-04-12','17:10:00',3.46),('7643','2014-04-12','17:15:00',3.58),('7643','2014-04-12','17:20:00',5.15),('7643','2014-04-12','17:25:00',4.75),('7643','2014-04-12','17:30:00',3.08),('7643','2014-04-12','17:35:00',2.55),('7643','2014-04-12','17:40:00',2.18),('7643','2014-04-12','17:45:00',2.62),('7643','2014-04-12','17:50:00',3.89),('7643','2014-04-12','17:55:00',3.91),('7643','2014-04-12','18:00:00',4.21),('7643','2014-04-12','18:05:00',2.82),('7643','2014-04-12','18:10:00',2.04),('7643','2014-04-12','18:15:00',1.74),('7643','2014-04-12','18:20:00',1.78),('7643','2014-04-12','18:25:00',1.6),('7643','2014-04-12','18:30:00',1.39),('7643','2013-09-17','07:35:00',1.12),('7643','2013-09-17','07:40:00',1.36),('7643','2013-09-17','07:45:00',1.64),('7643','2013-09-17','07:50:00',1.91),('7643','2013-09-17','07:55:00',2.19),('7643','2013-09-17','08:00:00',2.48),('7643','2013-09-17','08:05:00',2.79),('7643','2013-09-17','08:10:00',3.12),('7643','2013-09-17','08:15:00',3.05),('7643','2013-09-17','08:20:00',2.02),('7643','2013-09-17','08:25:00',3.1),('7643','2013-09-17','08:30:00',3.7),('7643','2013-09-17','08:35:00',2.78),('7643','2013-09-17','08:40:00',2.83),('7643','2013-09-17','08:45:00',5.89),('7643','2013-09-17','08:50:00',2.67),('7643','2013-09-17','08:55:00',3.03),('7643','2013-09-17','09:00:00',3.48),('7643','2013-09-17','09:05:00',4.66),('7643','2013-09-17','09:10:00',3.18),('7643','2013-09-17','09:15:00',4.43),('7643','2013-09-17','09:20:00',7.63),('7643','2013-09-17','09:25:00',4.31),('7643','2013-09-17','09:30:00',3.71),('7643','2013-09-17','09:35:00',9.89),('7643','2013-09-17','09:40:00',4.3),('7643','2013-09-17','09:45:00',4.8),('7643','2013-09-17','09:50:00',6.89),('7643','2013-09-17','09:55:00',10.36),('7643','2013-09-17','10:00:00',12.02),('7643','2013-09-17','10:05:00',11.71),('7643','2013-09-17','10:10:00',11.16),('7643','2013-09-17','10:15:00',10.77),('7643','2013-09-17','10:20:00',10.83),('7643','2013-09-17','10:25:00',10.99),('7643','2013-09-17','10:30:00',11.14),('7643','2013-09-17','10:35:00',11.17),('7643','2013-09-17','10:40:00',11.45),('7643','2013-09-17','10:45:00',10.71),('7643','2013-09-17','10:50:00',9.4),('7643','2013-09-17','10:55:00',12.26),('7643','2013-09-17','11:00:00',12.62),('7643','2013-09-17','11:05:00',10.52),('7643','2013-09-17','11:10:00',13.25),('7643','2013-09-17','11:15:00',6.9),('7643','2013-09-17','11:20:00',2.53),('7643','2013-09-17','11:25:00',11.08),('7643','2013-09-17','11:30:00',13.36),('7643','2013-09-17','11:35:00',14.78),('7643','2013-09-17','11:40:00',5.36),('7643','2013-09-17','11:45:00',12.36),('7643','2013-09-17','11:50:00',14.3),('7643','2013-09-17','11:55:00',14.4),('7643','2013-09-17','12:00:00',14.52),('7643','2013-09-17','12:05:00',14.91),('7643','2013-09-17','12:10:00',14.85),('7643','2013-09-17','12:15:00',14.73),('7643','2013-09-17','12:20:00',14.77),('7643','2013-09-17','12:25:00',14.24),('7643','2013-09-17','12:30:00',6.54),('7643','2013-09-17','12:35:00',14.83),('7643','2013-09-17','12:40:00',16.05),('7643','2013-09-17','12:45:00',9.42),('7643','2013-09-17','12:50:00',5.52),('7643','2013-09-17','12:55:00',14.4),('7643','2013-09-17','13:00:00',9.54),('7643','2013-09-17','13:05:00',11.53),('7643','2013-09-17','13:10:00',15.43),('7643','2013-09-17','13:15:00',15.64),('7643','2013-09-17','13:20:00',15.22),('7643','2013-09-17','13:25:00',15.03),('7643','2013-09-17','13:30:00',15.1),('7643','2013-09-17','13:35:00',14.73),('7643','2013-09-17','13:40:00',14.74),('7643','2013-09-17','13:45:00',14.82),('7643','2013-09-17','13:50:00',15.04),('7643','2013-09-17','13:55:00',14.6),('7643','2013-09-17','14:00:00',14.75),('7643','2013-09-17','14:05:00',10.87),('7643','2013-09-17','14:10:00',13.81),('7643','2013-09-17','14:15:00',14.11),('7643','2013-09-17','14:20:00',14.13),('7643','2013-09-17','14:25:00',13.87),('7643','2013-09-17','14:30:00',13.69),('7643','2013-09-17','14:35:00',13.57),('7643','2013-09-17','14:40:00',12.92),('7643','2013-09-17','14:45:00',13.07),('7643','2013-09-17','14:50:00',7.53),('7643','2013-09-17','14:55:00',12.26),('7643','2013-09-17','15:00:00',12.94),('7643','2013-09-17','15:05:00',11.91),('7643','2013-09-17','15:10:00',4.64),('7643','2013-09-17','15:15:00',7.07),('7643','2013-09-17','15:20:00',7.99),('7643','2013-09-17','15:25:00',8.94),('7643','2013-09-17','15:30:00',12.36),('7643','2013-09-17','15:35:00',11.77),('7643','2013-09-17','15:40:00',11.62),('7643','2013-09-17','15:45:00',10.9),('7643','2013-09-17','15:50:00',9.64),('7643','2013-09-17','15:55:00',6.73),('7643','2013-09-17','16:00:00',10.95),('7643','2013-09-17','16:05:00',10.92),('7643','2013-09-17','16:10:00',10.26),('7643','2013-09-17','16:15:00',9.59),('7643','2013-09-17','16:20:00',9.24),('7643','2013-09-17','16:25:00',8.09),('7643','2013-09-17','16:30:00',7.75),('7643','2013-09-17','16:35:00',7.15),('7643','2013-09-17','16:40:00',7.15),('7643','2013-09-17','16:45:00',7.29),('7643','2013-09-17','16:50:00',6.55),('7643','2013-09-17','16:55:00',6.08),('7643','2013-09-17','17:00:00',6.48),('7643','2013-09-17','17:05:00',5.79),('7643','2013-09-17','17:10:00',5.71),('7643','2013-09-17','17:15:00',5.49),('7643','2013-09-17','17:20:00',5.15),('7643','2013-09-17','17:25:00',3.93),('7643','2013-09-17','17:30:00',4.22),('7643','2013-09-17','17:35:00',4.14),('7643','2013-09-17','17:40:00',3.73),('7643','2013-09-17','17:45:00',3.38),('7643','2013-09-17','17:50:00',3.04),('7643','2013-09-17','17:55:00',2.7),('7643','2013-09-17','18:00:00',1.85),('7643','2013-09-17','18:05:00',1.82),('7643','2013-09-17','18:10:00',1.63),('7643','2013-09-17','18:15:00',1.41),('7643','2013-09-17','18:20:00',1.13),('7643','2013-09-16','08:15:00',1.45),('7643','2013-09-16','08:20:00',1.79),('7643','2013-09-16','08:25:00',1.73),('7643','2013-09-16','08:30:00',1.4),('7643','2013-09-16','08:35:00',1.62),('7643','2013-09-16','08:40:00',2.27),('7643','2013-09-16','08:45:00',2.04),('7643','2013-09-16','08:50:00',2),('7643','2013-09-16','08:55:00',2.32),('7643','2013-09-16','09:00:00',2.54),('7643','2013-09-16','09:05:00',2.53),('7643','2013-09-16','09:10:00',2.44),('7643','2013-09-16','09:15:00',2.76),('7643','2013-09-16','09:20:00',5.23),('7643','2013-09-16','09:25:00',3.31),('7643','2013-09-16','09:30:00',4.34),('7643','2013-09-16','09:35:00',3.05),('7643','2013-09-16','09:40:00',4.83),('7643','2013-09-16','09:45:00',7.47),('7643','2013-09-16','09:50:00',5.6),('7643','2013-09-16','09:55:00',5.18),('7643','2013-09-16','10:00:00',8.93),('7643','2013-09-16','10:05:00',7.13),('7643','2013-09-16','10:10:00',6.66),('7643','2013-09-16','10:15:00',2.74),('7643','2013-09-16','10:20:00',3.79),('7643','2013-09-16','10:25:00',9.87),('7643','2013-09-16','10:30:00',13.01),('7643','2013-09-16','10:35:00',6.83),('7643','2013-09-16','10:40:00',8.17),('7643','2013-09-16','10:45:00',7.25),('7643','2013-09-16','10:50:00',14.07),('7643','2013-09-16','10:55:00',11.25),('7643','2013-09-16','11:00:00',8.51),('7643','2013-09-16','11:05:00',9.15),('7643','2013-09-16','11:10:00',12.62),('7643','2013-09-16','11:15:00',10.51),('7643','2013-09-16','11:20:00',9.07),('7643','2013-09-16','11:25:00',6.67),('7643','2013-09-16','11:30:00',6.92),('7643','2013-09-16','11:35:00',11.93),('7643','2013-09-16','11:40:00',12.59),('7643','2013-09-16','11:45:00',12.04),('7643','2013-09-16','11:50:00',13.86),('7643','2013-09-16','11:55:00',10.29),('7643','2013-09-16','12:00:00',13.63),('7643','2013-09-16','12:05:00',9.28),('7643','2013-09-16','12:10:00',6.93),('7643','2013-09-16','12:15:00',7.24),('7643','2013-09-16','12:20:00',7.02),('7643','2013-09-16','12:25:00',14.15),('7643','2013-09-16','12:30:00',10.83),('7643','2013-09-16','12:35:00',8.78),('7643','2013-09-16','12:40:00',12.74),('7643','2013-09-16','12:45:00',14.25),('7643','2013-09-16','12:50:00',12.53),('7643','2013-09-16','12:55:00',9.94),('7643','2013-09-16','13:00:00',9.11),('7643','2013-09-16','13:05:00',4.95),('7643','2013-09-16','13:10:00',9.29),('7643','2013-09-16','13:15:00',11.62),('7643','2013-09-16','13:20:00',9.48),('7643','2013-09-16','13:25:00',8.05),('7643','2013-09-16','13:30:00',5.79),('7643','2013-09-16','13:35:00',6.95),('7643','2013-09-16','13:40:00',10.1),('7643','2013-09-16','13:45:00',5.45),('7643','2013-09-16','13:50:00',3.4),('7643','2013-09-16','13:55:00',4.85),('7643','2013-09-16','14:00:00',7.6),('7643','2013-09-16','14:05:00',4.97),('7643','2013-09-16','14:10:00',3.52),('7643','2013-09-16','14:15:00',4.88),('7643','2013-09-16','14:20:00',3.54),('7643','2013-09-16','14:25:00',7.26),('7643','2013-09-16','14:30:00',4.45),('7643','2013-09-16','14:35:00',4.23),('7643','2013-09-16','14:40:00',3.21),('7643','2013-09-16','14:45:00',2.92),('7643','2013-09-16','14:50:00',5.02),('7643','2013-09-16','14:55:00',11.96),('7643','2013-09-16','15:00:00',13.33),('7643','2013-09-16','15:05:00',10.1),('7643','2013-09-16','15:10:00',9.37),('7643','2013-09-16','15:15:00',10.65),('7643','2013-09-16','15:20:00',11.42),('7643','2013-09-16','15:25:00',10.36),('7643','2013-09-16','15:30:00',10.15),('7643','2013-09-16','15:35:00',4.94),('7643','2013-09-16','15:40:00',3.23),('7643','2013-09-16','15:45:00',3.98),('7643','2013-09-16','15:50:00',6.41),('7643','2013-09-16','15:55:00',8.39),('7643','2013-09-16','16:00:00',4.47),('7643','2013-09-16','16:05:00',7.17),('7643','2013-09-16','16:10:00',5.99),('7643','2013-09-16','16:15:00',6.29),('7643','2013-09-16','16:20:00',3.92),('7643','2013-09-16','16:25:00',2.5),('7643','2013-09-16','16:30:00',1.62),('7643','2013-09-16','16:35:00',2.5),('7643','2013-09-16','16:40:00',4.48),('7643','2013-09-16','16:45:00',5.35),('7643','2013-09-16','16:50:00',4.69),('7643','2013-09-16','16:55:00',3.44),('7643','2013-09-16','17:00:00',5.52),('7643','2013-09-16','17:05:00',6.16),('7643','2013-09-16','17:10:00',5.67),('7643','2013-09-16','17:15:00',5.83),('7643','2013-09-16','17:20:00',4.89),('7643','2013-09-16','17:25:00',4.5),('7643','2013-09-16','17:30:00',4.42),('7643','2013-09-16','17:35:00',3.25),('7643','2013-09-16','17:40:00',3.54),('7643','2013-09-16','17:45:00',2.33),('7643','2013-09-16','17:50:00',2.58),('7643','2013-09-16','17:55:00',2.58),('7643','2013-09-16','18:00:00',1.9),('7643','2013-09-16','18:05:00',2.06),('7643','2013-09-16','18:10:00',1.3),('7643','2013-09-16','18:15:00',1),('7643','2013-09-16','18:20:00',1.43),('7643','2013-09-15','07:25:00',1.19),('7643','2013-09-15','08:05:00',2.29),('7643','2013-09-15','08:10:00',3.8),('7643','2013-09-15','08:15:00',3.87),('7643','2013-09-15','08:20:00',4.06),('7643','2013-09-15','08:25:00',4.44),('7643','2013-09-15','08:30:00',4.7),('7643','2013-09-15','08:35:00',5.16),('7643','2013-09-15','08:40:00',5.83),('7643','2013-09-15','08:45:00',6.2),('7643','2013-09-15','08:50:00',5.48),('7643','2013-09-15','08:55:00',3.7),('7643','2013-09-15','09:00:00',2.72),('7643','2013-09-15','09:05:00',6.88),('7643','2013-09-15','09:10:00',4.92),('7643','2013-09-15','09:15:00',8.67),('7643','2013-09-15','09:20:00',8.16),('7643','2013-09-15','09:25:00',8.49),('7643','2013-09-15','09:30:00',8.16),('7643','2013-09-15','09:35:00',6.72),('7643','2013-09-15','09:40:00',9.33),('7643','2013-09-15','09:45:00',9.59),('7643','2013-09-15','09:50:00',9.67),('7643','2013-09-15','09:55:00',10.04),('7643','2013-09-15','10:00:00',9.33),('7643','2013-09-15','10:05:00',10.73),('7643','2013-09-15','10:10:00',11.76),('7643','2013-09-15','10:15:00',3.91),('7643','2013-09-15','10:20:00',3.73),('7643','2013-09-15','10:25:00',6.2),('7643','2013-09-15','10:30:00',12.91),('7643','2013-09-15','10:35:00',12.99),('7643','2013-09-15','10:40:00',13.76),('7643','2013-09-15','10:45:00',14.37),('7643','2013-09-15','10:50:00',12.47),('7643','2013-09-15','10:55:00',2.83),('7643','2013-09-15','11:00:00',2.7),('7643','2013-09-15','11:05:00',6.71),('7643','2013-09-15','11:10:00',2.78),('7643','2013-09-15','11:15:00',4.49),('7643','2013-09-15','11:20:00',3.35),('7643','2013-09-15','11:25:00',9.78),('7643','2013-09-15','11:30:00',14.75),('7643','2013-09-15','11:35:00',14.46),('7643','2013-09-15','11:40:00',14.53),('7643','2013-09-15','11:45:00',14.63),('7643','2013-09-15','11:50:00',11.12),('7643','2013-09-15','11:55:00',15.02),('7643','2013-09-15','12:00:00',15.31),('7643','2013-09-15','12:05:00',15.94),('7643','2013-09-15','12:10:00',17.02),('7643','2013-09-15','12:15:00',13),('7643','2013-09-15','12:20:00',15.07),('7643','2013-09-15','12:25:00',14.95),('7643','2013-09-15','12:30:00',14.82),('7643','2013-09-15','12:35:00',14.98),('7643','2013-09-15','12:40:00',15.36),('7643','2013-09-15','12:45:00',16.23),('7643','2013-09-15','12:50:00',10.13),('7643','2013-09-15','12:55:00',15.57),('7643','2013-09-15','13:00:00',16.17),('7643','2013-09-15','13:05:00',15.84),('7643','2013-09-15','13:10:00',15.97),('7643','2013-09-15','13:15:00',14.36),('7643','2013-09-15','13:20:00',14.96),('7643','2013-09-15','13:25:00',14.82),('7643','2013-09-15','13:30:00',14.62),('7643','2013-09-15','13:35:00',14.64),('7643','2013-09-15','13:40:00',14.59),('7643','2013-09-15','13:45:00',14.52),('7643','2013-09-15','13:50:00',14.59),('7643','2013-09-15','13:55:00',14.91),('7643','2013-09-15','14:00:00',14.86),('7643','2013-09-15','14:05:00',14.38),('7643','2013-09-15','14:10:00',14.09),('7643','2013-09-15','14:15:00',13.88),('7643','2013-09-15','14:20:00',13.78),('7643','2013-09-15','14:25:00',13.61),('7643','2013-09-15','14:30:00',13.56),('7643','2013-09-15','14:35:00',13.4),('7643','2013-09-15','14:40:00',13.22),('7643','2013-09-15','14:45:00',13.08),('7643','2013-09-15','14:50:00',12.97),('7643','2013-09-15','14:55:00',12.87),('7643','2013-09-15','15:00:00',12.73),('7643','2013-09-15','15:05:00',12.66),('7643','2013-09-15','15:10:00',12.47),('7643','2013-09-15','15:15:00',12.26),('7643','2013-09-15','15:20:00',12.12),('7643','2013-09-15','15:25:00',11.87),('7643','2013-09-15','15:30:00',11.64),('7643','2013-09-15','15:35:00',11.43),('7643','2013-09-15','15:40:00',11.33),('7643','2013-09-15','15:45:00',11.06),('7643','2013-09-15','15:50:00',10.82),('7643','2013-09-15','15:55:00',10.59),('7643','2013-09-15','16:00:00',10.5),('7643','2013-09-15','16:05:00',10.17),('7643','2013-09-15','16:10:00',10.27),('7643','2013-09-15','16:15:00',9.66),('7643','2013-09-15','16:20:00',9.36),('7643','2013-09-15','16:25:00',9.03),('7643','2013-09-15','16:30:00',8.74),('7643','2013-09-15','16:35:00',8.36),('7643','2013-09-15','16:40:00',8.15),('7643','2013-09-15','16:45:00',7.85),('7643','2013-09-15','16:50:00',7.51),('7643','2013-09-15','16:55:00',7.17),('7643','2013-09-15','17:00:00',6.87),('7643','2013-09-15','17:05:00',6.55),('7643','2013-09-15','17:10:00',6.2),('7643','2013-09-15','17:15:00',5.82),('7643','2013-09-15','17:20:00',5.46),('7643','2013-09-15','17:25:00',5.13),('7643','2013-09-15','17:30:00',4.53),('7643','2013-09-15','17:35:00',3.13),('7643','2013-09-15','17:40:00',2.45),('7643','2013-09-15','17:45:00',3.84),('7643','2013-09-15','17:50:00',3.35),('7643','2013-09-15','17:55:00',2.89),('7643','2013-09-15','18:00:00',2.58),('7643','2013-09-15','18:05:00',2.32),('7643','2013-09-15','18:10:00',2.02),('7643','2013-09-15','18:15:00',1.65),('7643','2013-09-15','18:20:00',1.34),('7643','2013-09-15','18:25:00',1.06),('7643','2013-09-14','07:20:00',1.08),('7643','2013-09-14','07:25:00',1.14),('7643','2013-09-14','07:30:00',1.16),('7643','2013-09-14','07:35:00',1.68),('7643','2013-09-14','07:40:00',2.01),('7643','2013-09-14','07:45:00',2.08),('7643','2013-09-14','07:50:00',2.21),('7643','2013-09-14','07:55:00',2.53),('7643','2013-09-14','08:00:00',2.86),('7643','2013-09-14','08:05:00',3.19),('7643','2013-09-14','08:10:00',3.54),('7643','2013-09-14','08:15:00',3.94),('7643','2013-09-14','08:20:00',4.29),('7643','2013-09-14','08:25:00',4.65),('7643','2013-09-14','08:30:00',4.99),('7643','2013-09-14','08:35:00',5.38),('7643','2013-09-14','08:40:00',5.85),('7643','2013-09-14','08:45:00',6.22),('7643','2013-09-14','08:50:00',6.35),('7643','2013-09-14','08:55:00',6.12),('7643','2013-09-14','09:00:00',6.59),('7643','2013-09-14','09:05:00',6.77),('7643','2013-09-14','09:10:00',7.45),('7643','2013-09-14','09:15:00',8.13),('7643','2013-09-14','09:20:00',7.94),('7643','2013-09-14','09:25:00',8.28),('7643','2013-09-14','09:30:00',8.33),('7643','2013-09-14','09:35:00',9.05),('7643','2013-09-14','09:40:00',9.21),('7643','2013-09-14','09:45:00',9.32),('7643','2013-09-14','09:50:00',9.71),('7643','2013-09-14','09:55:00',9.8),('7643','2013-09-14','10:00:00',10.28),('7643','2013-09-14','10:05:00',10.56),('7643','2013-09-14','10:10:00',10.64),('7643','2013-09-14','10:15:00',10.52),('7643','2013-09-14','10:20:00',10.65),('7643','2013-09-14','10:25:00',11.01),('7643','2013-09-14','10:30:00',10.44),('7643','2013-09-14','10:35:00',8.4),('7643','2013-09-14','10:40:00',4.42),('7643','2013-09-14','10:45:00',4.43),('7643','2013-09-14','10:50:00',3.29),('7643','2013-09-14','10:55:00',2.58),('7643','2013-09-14','11:00:00',9.19),('7643','2013-09-14','11:05:00',14.3),('7643','2013-09-14','11:10:00',12.32),('7643','2013-09-14','11:15:00',7.01),('7643','2013-09-14','11:20:00',4.18),('7643','2013-09-14','11:25:00',3.34),('7643','2013-09-14','11:30:00',4.18),('7643','2013-09-14','11:35:00',14.69),('7643','2013-09-14','11:40:00',5.62),('7643','2013-09-14','11:45:00',4.35),('7643','2013-09-14','11:50:00',11.05),('7643','2013-09-14','11:55:00',5.01),('7643','2013-09-14','12:00:00',5.4),('7643','2013-09-14','12:05:00',5.57),('7643','2013-09-14','12:10:00',4.09),('7643','2013-09-14','12:15:00',4.15),('7643','2013-09-14','12:20:00',4.92),('7643','2013-09-14','12:25:00',5.7),('7643','2013-09-14','12:30:00',5.9),('7643','2013-09-14','12:35:00',5.98),('7643','2013-09-14','12:40:00',6.13),('7643','2013-09-14','12:45:00',4.7),('7643','2013-09-14','12:50:00',4.76),('7643','2013-09-14','12:55:00',5.15),('7643','2013-09-14','13:00:00',4.47),('7643','2013-09-14','13:05:00',4.07),('7643','2013-09-14','13:10:00',3.11),('7643','2013-09-14','13:15:00',2.34),('7643','2013-09-14','13:20:00',2.31),('7643','2013-09-14','13:25:00',3.37),('7643','2013-09-14','13:30:00',3.64),('7643','2013-09-14','13:35:00',4.53),('7643','2013-09-14','13:40:00',5.07),('7643','2013-09-14','13:45:00',6.37),('7643','2013-09-14','13:50:00',6.96),('7643','2013-09-14','13:55:00',4.82),('7643','2013-09-14','14:00:00',6.81),('7643','2013-09-14','14:05:00',6.32),('7643','2013-09-14','14:10:00',5.28),('7643','2013-09-14','14:15:00',4.76),('7643','2013-09-14','14:20:00',4.59),('7643','2013-09-14','14:25:00',4.59),('7643','2013-09-14','14:30:00',4.55),('7643','2013-09-14','14:35:00',3.89),('7643','2013-09-14','14:40:00',3.84),('7643','2013-09-14','14:45:00',3.26),('7643','2013-09-14','14:50:00',3.53),('7643','2013-09-14','14:55:00',3.79),('7643','2013-09-14','15:00:00',3.89),('7643','2013-09-14','15:05:00',4.17),('7643','2013-09-14','15:10:00',4.77),('7643','2013-09-14','15:15:00',11.16),('7643','2013-09-14','15:20:00',8.1),('7643','2013-09-14','15:25:00',5.56),('7643','2013-09-14','15:30:00',4.1),('7643','2013-09-14','15:35:00',3.9),('7643','2013-09-14','15:40:00',3.61),('7643','2013-09-14','15:45:00',3.46),('7643','2013-09-14','15:50:00',3.49),('7643','2013-09-14','15:55:00',3.51),('7643','2013-09-14','16:00:00',2.99),('7643','2013-09-14','16:05:00',3.46),('7643','2013-09-14','16:10:00',2.82),('7643','2013-09-14','16:15:00',1.91),('7643','2013-09-14','16:20:00',1.46),('7643','2013-09-14','16:25:00',1.87),('7643','2013-09-14','16:30:00',2.37),('7643','2013-09-14','16:35:00',2.36),('7643','2013-09-14','16:40:00',2.86),('7643','2013-09-14','16:45:00',2.39),('7643','2013-09-14','16:50:00',1.81),('7643','2013-09-14','16:55:00',1.54),('7643','2013-09-14','17:00:00',2.01),('7643','2013-09-14','17:05:00',2.06),('7643','2013-09-14','17:10:00',1.8),('7643','2013-09-14','17:15:00',2.11),('7643','2013-09-14','17:20:00',2.72),('7643','2013-09-14','17:25:00',2.14),('7643','2013-09-14','17:30:00',2.01),('7643','2013-09-14','17:35:00',1.77),('7643','2013-09-14','17:40:00',1.25),('7643','2013-09-14','17:55:00',1.32),('7643','2013-09-14','18:00:00',2.11),('7643','2013-09-14','18:05:00',1.42),('7643','2013-09-14','18:10:00',1.19),('7643','2013-09-14','18:15:00',1.08),('7643','2013-09-13','07:30:00',1.04),('7643','2013-09-13','07:35:00',1.25),('7643','2013-09-13','07:40:00',1.53),('7643','2013-09-13','07:45:00',1.83),('7643','2013-09-13','07:50:00',2.14),('7643','2013-09-13','07:55:00',2.45),('7643','2013-09-13','08:00:00',2.78),('7643','2013-09-13','08:05:00',3.1),('7643','2013-09-13','08:10:00',3.46),('7643','2013-09-13','08:15:00',3.79),('7643','2013-09-13','08:20:00',4.16),('7643','2013-09-13','08:25:00',4.47),('7643','2013-09-13','08:30:00',4.86),('7643','2013-09-13','08:35:00',5.21),('7643','2013-09-13','08:40:00',5.55),('7643','2013-09-13','08:45:00',5.9),('7643','2013-09-13','08:50:00',6.22),('7643','2013-09-13','08:55:00',6.55),('7643','2013-09-13','09:00:00',6.87),('7643','2013-09-13','09:05:00',7.21),('7643','2013-09-13','09:10:00',7.52),('7643','2013-09-13','09:15:00',7.82),('7643','2013-09-13','09:20:00',8.12),('7643','2013-09-13','09:25:00',8.4),('7643','2013-09-13','09:30:00',8.7),('7643','2013-09-13','09:35:00',8.86),('7643','2013-09-13','09:40:00',8.99),('7643','2013-09-13','09:45:00',9.27),('7643','2013-09-13','09:50:00',9.6),('7643','2013-09-13','09:55:00',9.6),('7643','2013-09-13','10:00:00',10.07),('7643','2013-09-13','10:05:00',10.21),('7643','2013-09-13','10:10:00',9.56),('7643','2013-09-13','10:15:00',10),('7643','2013-09-13','10:20:00',10.82),('7643','2013-09-13','10:25:00',11.13),('7643','2013-09-13','10:30:00',11.08),('7643','2013-09-13','10:35:00',11.45),('7643','2013-09-13','10:40:00',12.15),('7643','2013-09-13','10:45:00',13.07),('7643','2013-09-13','10:50:00',12.04),('7643','2013-09-13','10:55:00',13.72),('7643','2013-09-13','11:00:00',14.46),('7643','2013-09-13','11:05:00',11.71),('7643','2013-09-13','11:10:00',8.11),('7643','2013-09-13','11:15:00',3.53),('7643','2013-09-13','11:20:00',2.12),('7643','2013-09-13','11:25:00',9.94),('7643','2013-09-13','11:30:00',14.03),('7643','2013-09-13','11:35:00',9.12),('7643','2013-09-13','11:40:00',9.23),('7643','2013-09-13','11:45:00',12.16),('7643','2013-09-13','11:50:00',13.99),('7643','2013-09-13','11:55:00',14.26),('7643','2013-09-13','12:00:00',12.21),('7643','2013-09-13','12:05:00',13.67),('7643','2013-09-13','12:10:00',11.9),('7643','2013-09-13','12:15:00',12.54),('7643','2013-09-13','12:20:00',6.99),('7643','2013-09-13','12:25:00',2.18),('7643','2013-09-13','12:30:00',2.78),('7643','2013-09-13','12:35:00',5.86),('7643','2013-09-13','12:40:00',13.9),('7643','2013-09-13','12:45:00',5.44),('7643','2013-09-13','12:50:00',3.5),('7643','2013-09-13','12:55:00',3.2),('7643','2013-09-13','13:00:00',3.22),('7643','2013-09-13','13:05:00',2.58),('7643','2013-09-13','13:10:00',3.34),('7643','2013-09-13','13:15:00',8.6),('7643','2013-09-13','13:20:00',13.42),('7643','2013-09-13','13:25:00',10.96),('7643','2013-09-13','13:30:00',16.55),('7643','2013-09-13','13:35:00',5),('7643','2013-09-13','13:40:00',5.45),('7643','2013-09-13','13:45:00',8.76),('7643','2013-09-13','13:50:00',8.66),('7643','2013-09-13','13:55:00',15.48),('7643','2013-09-13','14:00:00',16.14),('7643','2013-09-13','14:05:00',14.89),('7643','2013-09-13','14:10:00',14.6),('7643','2013-09-13','14:15:00',14.42),('7643','2013-09-13','14:20:00',14.12),('7643','2013-09-13','14:25:00',14.01),('7643','2013-09-13','14:30:00',13.99),('7643','2013-09-13','14:35:00',13.66),('7643','2013-09-13','14:40:00',13.5),('7643','2013-09-13','14:45:00',11.69),('7643','2013-09-13','14:50:00',13.33),('7643','2013-09-13','14:55:00',13.15),('7643','2013-09-13','15:00:00',12.97),('7643','2013-09-13','15:05:00',12.65),('7643','2013-09-13','15:10:00',12.45),('7643','2013-09-13','15:15:00',12.23),('7643','2013-09-13','15:20:00',12.11),('7643','2013-09-13','15:25:00',12.01),('7643','2013-09-13','15:30:00',10.85),('7643','2013-09-13','15:35:00',11.61),('7643','2013-09-13','15:40:00',11.4),('7643','2013-09-13','15:45:00',10.15),('7643','2013-09-13','15:50:00',10.93),('7643','2013-09-13','15:55:00',10.61),('7643','2013-09-13','16:00:00',10.3),('7643','2013-09-13','16:05:00',9.92),('7643','2013-09-13','16:10:00',9.7),('7643','2013-09-13','16:15:00',9.39),('7643','2013-09-13','16:20:00',9.24),('7643','2013-09-13','16:25:00',8.94),('7643','2013-09-13','16:30:00',8.71),('7643','2013-09-13','16:35:00',8.41),('7643','2013-09-13','16:40:00',8.08),('7643','2013-09-13','16:45:00',7.8),('7643','2013-09-13','16:50:00',7.52),('7643','2013-09-13','16:55:00',7.23),('7643','2013-09-13','17:00:00',6.95),('7643','2013-09-13','17:05:00',6.7),('7643','2013-09-13','17:10:00',6.25),('7643','2013-09-13','17:15:00',6.03),('7643','2013-09-13','17:20:00',5.62),('7643','2013-09-13','17:25:00',5.29),('7643','2013-09-13','17:30:00',4.85),('7643','2013-09-13','17:35:00',3.85),('7643','2013-09-13','17:40:00',3.77),('7643','2013-09-13','17:45:00',3.89),('7643','2013-09-13','17:50:00',3.54),('7643','2013-09-13','17:55:00',3.15),('7643','2013-09-13','18:00:00',2.71),('7643','2013-09-13','18:05:00',2.39),('7643','2013-09-13','18:10:00',2.06),('7643','2013-09-13','18:15:00',1.89),('7643','2013-09-13','18:20:00',1.54),('7643','2013-09-13','18:25:00',1.19),('7643','2013-09-12','08:00:00',1.03),('7643','2013-09-12','08:05:00',1.22),('7643','2013-09-12','08:10:00',1.64),('7643','2013-09-12','08:15:00',2.08),('7643','2013-09-12','08:20:00',2.55),('7643','2013-09-12','08:25:00',2.94),('7643','2013-09-12','08:30:00',3.8),('7643','2013-09-12','08:35:00',2.57),('7643','2013-09-12','08:40:00',2.65),('7643','2013-09-12','08:45:00',3.06),('7643','2013-09-12','08:50:00',3.45),('7643','2013-09-12','08:55:00',3.8),('7643','2013-09-12','09:00:00',3.72),('7643','2013-09-12','09:05:00',3.6),('7643','2013-09-12','09:10:00',3.54),('7643','2013-09-12','09:15:00',3.72),('7643','2013-09-12','09:20:00',3.71),('7643','2013-09-12','09:25:00',4.03),('7643','2013-09-12','09:30:00',4.39),('7643','2013-09-12','09:35:00',4.79),('7643','2013-09-12','09:40:00',5.21),('7643','2013-09-12','09:45:00',5.1),('7643','2013-09-12','09:50:00',5.94),('7643','2013-09-12','09:55:00',11.45),('7643','2013-09-12','10:00:00',9.07),('7643','2013-09-12','10:05:00',5.71),('7643','2013-09-12','10:10:00',7.58),('7643','2013-09-12','10:15:00',12.57),('7643','2013-09-12','10:20:00',14.19),('7643','2013-09-12','10:25:00',8.34),('7643','2013-09-12','10:30:00',7.32),('7643','2013-09-12','10:35:00',11.99),('7643','2013-09-12','10:40:00',12.3),('7643','2013-09-12','10:45:00',12.27),('7643','2013-09-12','10:50:00',12.43),('7643','2013-09-12','10:55:00',12.59),('7643','2013-09-12','11:00:00',12.72),('7643','2013-09-12','11:05:00',12.88),('7643','2013-09-12','11:10:00',12.93),('7643','2013-09-12','11:15:00',13.07),('7643','2013-09-12','11:20:00',13.25),('7643','2013-09-12','11:25:00',13.34),('7643','2013-09-12','11:30:00',13.53),('7643','2013-09-12','11:35:00',13.62),('7643','2013-09-12','11:40:00',13.75),('7643','2013-09-12','11:45:00',13.86),('7643','2013-09-12','11:50:00',13.85),('7643','2013-09-12','11:55:00',13.98),('7643','2013-09-12','12:00:00',14.14),('7643','2013-09-12','12:05:00',14.45),('7643','2013-09-12','12:10:00',14.59),('7643','2013-09-12','12:15:00',14.6),('7643','2013-09-12','12:20:00',14.61),('7643','2013-09-12','12:25:00',14.78),('7643','2013-09-12','12:30:00',15.17),('7643','2013-09-12','12:35:00',14.82),('7643','2013-09-12','12:40:00',14.73),('7643','2013-09-12','12:45:00',14.83),('7643','2013-09-12','12:50:00',14.93),('7643','2013-09-12','12:55:00',14.87),('7643','2013-09-12','13:00:00',14.65),('7643','2013-09-12','13:05:00',14.53),('7643','2013-09-12','13:10:00',14.57),('7643','2013-09-12','13:15:00',14.46),('7643','2013-09-12','13:20:00',14.41),('7643','2013-09-12','13:25:00',14.47),('7643','2013-09-12','13:30:00',14.41),('7643','2013-09-12','13:35:00',14.38),('7643','2013-09-12','13:40:00',14.36),('7643','2013-09-12','13:45:00',14.26),('7643','2013-09-12','13:50:00',14.19),('7643','2013-09-12','13:55:00',14.19),('7643','2013-09-12','14:00:00',14.13),('7643','2013-09-12','14:05:00',13.99),('7643','2013-09-12','14:10:00',13.79),('7643','2013-09-12','14:15:00',13.6),('7643','2013-09-12','14:20:00',13.6),('7643','2013-09-12','14:25:00',13.7),('7643','2013-09-12','14:30:00',8.21),('7643','2013-09-12','14:35:00',12.49),('7643','2013-09-12','14:40:00',12.99),('7643','2013-09-12','14:45:00',8.46),('7643','2013-09-12','14:50:00',13.58),('7643','2013-09-12','14:55:00',12.78),('7643','2013-09-12','15:00:00',12.64),('7643','2013-09-12','15:05:00',12.51),('7643','2013-09-12','15:10:00',12.51),('7643','2013-09-12','15:15:00',12.3),('7643','2013-09-12','15:20:00',12.03),('7643','2013-09-12','15:25:00',11.89),('7643','2013-09-12','15:30:00',11.79),('7643','2013-09-12','15:35:00',11.62),('7643','2013-09-12','15:40:00',11.45),('7643','2013-09-12','15:45:00',11.24),('7643','2013-09-12','15:50:00',10.99),('7643','2013-09-12','15:55:00',10.73),('7643','2013-09-12','16:00:00',10.44),('7643','2013-09-12','16:05:00',10.19),('7643','2013-09-12','16:10:00',9.95),('7643','2013-09-12','16:15:00',9.68),('7643','2013-09-12','16:20:00',9.41),('7643','2013-09-12','16:25:00',9.18),('7643','2013-09-12','16:30:00',8.87),('7643','2013-09-12','16:35:00',8.54),('7643','2013-09-12','16:40:00',8.21),('7643','2013-09-12','16:45:00',7.9),('7643','2013-09-12','16:50:00',7.59),('7643','2013-09-12','16:55:00',7.23),('7643','2013-09-12','17:00:00',6.89),('7643','2013-09-12','17:05:00',6.6),('7643','2013-09-12','17:10:00',6.24),('7643','2013-09-12','17:15:00',5.94),('7643','2013-09-12','17:20:00',5.59),('7643','2013-09-12','17:25:00',5.23),('7643','2013-09-12','17:30:00',4.86),('7643','2013-09-12','17:35:00',4.52),('7643','2013-09-12','17:40:00',4.17),('7643','2013-09-12','17:45:00',3.85),('7643','2013-09-12','17:50:00',3.5),('7643','2013-09-12','17:55:00',3.17),('7643','2013-09-12','18:00:00',2.84),('7643','2013-09-12','18:05:00',2.5),('7643','2013-09-12','18:10:00',2.17),('7643','2013-09-12','18:15:00',1.87),('7643','2013-09-12','18:20:00',1.56),('7643','2013-09-12','18:25:00',1.29),('7643','2013-09-12','18:30:00',1.01),('7643','2013-09-11','07:25:00',1.28),('7643','2013-09-11','07:30:00',1.44),('7643','2013-09-11','07:35:00',1.31),('7643','2013-09-11','07:40:00',1.45),('7643','2013-09-11','07:45:00',1.72),('7643','2013-09-11','07:50:00',1.74),('7643','2013-09-11','07:55:00',2.49),('7643','2013-09-11','08:00:00',3.45),('7643','2013-09-11','08:05:00',2.84),('7643','2013-09-11','08:10:00',2.24),('7643','2013-09-11','08:15:00',4.52),('7643','2013-09-11','08:20:00',4.5),('7643','2013-09-11','08:25:00',5.4),('7643','2013-09-11','08:30:00',6.13),('7643','2013-09-11','08:35:00',6.06),('7643','2013-09-11','08:40:00',4.58),('7643','2013-09-11','08:45:00',2.71),('7643','2013-09-11','08:50:00',2.42),('7643','2013-09-11','08:55:00',5.92),('7643','2013-09-11','09:00:00',6.89),('7643','2013-09-11','09:05:00',6.67),('7643','2013-09-11','09:10:00',5.04),('7643','2013-09-11','09:15:00',7.75),('7643','2013-09-11','09:20:00',7.85),('7643','2013-09-11','09:25:00',8.47),('7643','2013-09-11','09:30:00',9.06),('7643','2013-09-11','09:35:00',7.05),('7643','2013-09-11','09:40:00',6.88),('7643','2013-09-11','09:45:00',7.51),('7643','2013-09-11','09:50:00',10.3),('7643','2013-09-11','09:55:00',6.14),('7643','2013-09-11','10:00:00',3.99),('7643','2013-09-11','10:05:00',5.19),('7643','2013-09-11','10:10:00',6.32),('7643','2013-09-11','10:15:00',6.52),('7643','2013-09-11','10:20:00',4.67),('7643','2013-09-11','10:25:00',3.38),('7643','2013-09-11','10:30:00',5.64),('7643','2013-09-11','10:35:00',7.34),('7643','2013-09-11','10:40:00',2.99),('7643','2013-09-11','10:45:00',1.37),('7643','2013-09-11','10:50:00',2.28),('7643','2013-09-11','10:55:00',7.34),('7643','2013-09-11','11:00:00',8.38),('7643','2013-09-11','11:05:00',11.12),('7643','2013-09-11','11:10:00',8.81),('7643','2013-09-11','11:15:00',10.99),('7643','2013-09-11','11:20:00',5.5),('7643','2013-09-11','11:25:00',1.09),('7643','2013-09-11','11:40:00',3.55),('7643','2013-09-11','11:45:00',9.88),('7643','2013-09-11','11:50:00',6.17),('7643','2013-09-11','11:55:00',6.25),('7643','2013-09-11','12:00:00',12.49),('7643','2013-09-11','12:05:00',14.16),('7643','2013-09-11','12:10:00',11.7),('7643','2013-09-11','12:15:00',10.42),('7643','2013-09-11','12:20:00',5.14),('7643','2013-09-11','12:25:00',5.93),('7643','2013-09-11','12:30:00',5.46),('7643','2013-09-11','12:35:00',10.47),('7643','2013-09-11','12:40:00',11.97),('7643','2013-09-11','12:45:00',4.1),('7643','2013-09-11','12:50:00',6.61),('7643','2013-09-11','12:55:00',5.87),('7643','2013-09-11','13:00:00',16.86),('7643','2013-09-11','13:05:00',8.3),('7643','2013-09-11','13:10:00',12.93),('7643','2013-09-11','13:15:00',17.03),('7643','2013-09-11','13:20:00',16.95),('7643','2013-09-11','13:25:00',17.02),('7643','2013-09-11','13:30:00',13.84),('7643','2013-09-11','13:35:00',12.15),('7643','2013-09-11','13:40:00',9.9),('7643','2013-09-11','13:45:00',10.02),('7643','2013-09-11','13:50:00',15.77),('7643','2013-09-11','13:55:00',15.22),('7643','2013-09-11','14:00:00',15.28),('7643','2013-09-11','14:05:00',14.35),('7643','2013-09-11','14:10:00',13.11),('7643','2013-09-11','14:15:00',13.82),('7643','2013-09-11','14:20:00',15.25),('7643','2013-09-11','14:25:00',14.89),('7643','2013-09-11','14:30:00',14.8),('7643','2013-09-11','14:35:00',11.39),('7643','2013-09-11','14:40:00',8.94),('7643','2013-09-11','14:45:00',14.17),('7643','2013-09-11','14:50:00',13.76),('7643','2013-09-11','14:55:00',13.43),('7643','2013-09-11','15:00:00',12.78),('7643','2013-09-11','15:05:00',9.36),('7643','2013-09-11','15:10:00',10.64),('7643','2013-09-11','15:15:00',12.47),('7643','2013-09-11','15:20:00',12.37),('7643','2013-09-11','15:25:00',12.09),('7643','2013-09-11','15:30:00',12.15),('7643','2013-09-11','15:35:00',11.89),('7643','2013-09-11','15:40:00',11.71),('7643','2013-09-11','15:45:00',11.59),('7643','2013-09-11','15:50:00',11.28),('7643','2013-09-11','15:55:00',10.99),('7643','2013-09-11','16:00:00',10.94),('7643','2013-09-11','16:05:00',9.39),('7643','2013-09-11','16:10:00',10.4),('7643','2013-09-11','16:15:00',7.04),('7643','2013-09-11','16:20:00',7.73),('7643','2013-09-11','16:25:00',8.09),('7643','2013-09-11','16:30:00',7.52),('7643','2013-09-11','16:35:00',4.71),('7643','2013-09-11','16:40:00',6.88),('7643','2013-09-11','16:45:00',8.48),('7643','2013-09-11','16:50:00',1.8),('7643','2013-09-11','16:55:00',5.85),('7643','2013-09-11','17:00:00',6.38),('7643','2013-09-11','17:05:00',6.5),('7643','2013-09-11','17:10:00',5.86),('7643','2013-09-11','17:15:00',6.5),('7643','2013-09-11','17:20:00',2.94),('7643','2013-09-11','17:25:00',1.62),('7643','2013-09-11','17:30:00',4.6),('7643','2013-09-11','17:35:00',5.35),('7643','2013-09-11','17:40:00',4.71),('7643','2013-09-11','17:45:00',4.53),('7643','2013-09-11','17:50:00',3.49),('7643','2013-09-11','17:55:00',3.51),('7643','2013-09-11','18:00:00',3.02),('7643','2013-09-11','18:10:00',1.66),('7643','2013-09-11','18:15:00',2.36),('7643','2013-09-11','18:20:00',1.96),('7643','2013-09-10','08:00:00',3.02),('7643','2013-09-10','08:05:00',4.07),('7643','2013-09-10','08:10:00',4.38),('7643','2013-09-10','08:15:00',3.58),('7643','2013-09-10','08:20:00',2.11),('7643','2013-09-10','08:25:00',2.16),('7643','2013-09-10','08:30:00',3.24),('7643','2013-09-10','08:35:00',2.73),('7643','2013-09-10','08:40:00',2.78),('7643','2013-09-10','08:45:00',2.35),('7643','2013-09-10','08:50:00',3.63),('7643','2013-09-10','08:55:00',3.68),('7643','2013-09-10','09:00:00',7.53),('7643','2013-09-10','09:05:00',7.11),('7643','2013-09-10','09:10:00',6.56),('7643','2013-09-10','09:15:00',8.49),('7643','2013-09-10','09:20:00',8.12),('7643','2013-09-10','09:25:00',7.19),('7643','2013-09-10','09:30:00',5.38),('7643','2013-09-10','09:35:00',6.31),('7643','2013-09-10','09:40:00',7.31),('7643','2013-09-10','09:45:00',2.72),('7643','2013-09-10','09:50:00',3.16),('7643','2013-09-10','09:55:00',3.09),('7643','2013-09-10','10:00:00',4.12),('7643','2013-09-10','10:05:00',10.58),('7643','2013-09-10','10:10:00',2.36),('7643','2013-09-10','10:15:00',5.96),('7643','2013-09-10','10:20:00',10.14),('7643','2013-09-10','10:25:00',7.49),('7643','2013-09-10','10:30:00',9.71),('7643','2013-09-10','10:35:00',12.48),('7643','2013-09-10','10:40:00',13.24),('7643','2013-09-10','10:45:00',9.85),('7643','2013-09-10','10:50:00',10.96),('7643','2013-09-10','10:55:00',6.27),('7643','2013-09-10','11:00:00',5.63),('7643','2013-09-10','11:05:00',12.11),('7643','2013-09-10','11:10:00',15.42),('7643','2013-09-10','11:15:00',10.71),('7643','2013-09-10','11:20:00',14.12),('7643','2013-09-10','11:25:00',11.24),('7643','2013-09-10','11:30:00',3.51),('7643','2013-09-10','11:35:00',12.6),('7643','2013-09-10','11:40:00',10.42),('7643','2013-09-10','11:45:00',14.75),('7643','2013-09-10','11:50:00',14.83),('7643','2013-09-10','11:55:00',13.31),('7643','2013-09-10','12:00:00',10.7),('7643','2013-09-10','12:05:00',14.86),('7643','2013-09-10','12:10:00',8.11),('7643','2013-09-10','12:15:00',10.52),('7643','2013-09-10','12:20:00',10.91),('7643','2013-09-10','12:25:00',6.74),('7643','2013-09-10','12:30:00',11.69),('7643','2013-09-10','12:35:00',8.03),('7643','2013-09-10','12:40:00',8.22),('7643','2013-09-10','12:45:00',13.53),('7643','2013-09-10','12:50:00',16.5),('7643','2013-09-10','12:55:00',14.9),('7643','2013-09-10','13:00:00',13.52),('7643','2013-09-10','13:05:00',15.58),('7643','2013-09-10','13:10:00',15.57),('7643','2013-09-10','13:15:00',15.85),('7643','2013-09-10','13:20:00',16.34),('7643','2013-09-10','13:25:00',13.33),('7643','2013-09-10','13:30:00',11.72),('7643','2013-09-10','13:35:00',13.61),('7643','2013-09-10','13:40:00',15.49),('7643','2013-09-10','13:45:00',11.08),('7643','2013-09-10','13:50:00',15.07),('7643','2013-09-10','13:55:00',9.53),('7643','2013-09-10','14:00:00',14.47),('7643','2013-09-10','14:05:00',15.03),('7643','2013-09-10','14:10:00',8.32),('7643','2013-09-10','14:15:00',14.83),('7643','2013-09-10','14:20:00',11.55),('7643','2013-09-10','14:25:00',13.01),('7643','2013-09-10','14:30:00',13.82),('7643','2013-09-10','14:35:00',13.92),('7643','2013-09-10','14:40:00',9.61),('7643','2013-09-10','14:45:00',10.07),('7643','2013-09-10','14:50:00',10.99),('7643','2013-09-10','14:55:00',8.76),('7643','2013-09-10','15:00:00',13.39),('7643','2013-09-10','15:05:00',11.08),('7643','2013-09-10','15:10:00',9.77),('7643','2013-09-10','15:15:00',12.83),('7643','2013-09-10','15:20:00',12.8),('7643','2013-09-10','15:25:00',5.06),('7643','2013-09-10','15:30:00',10.04),('7643','2013-09-10','15:35:00',4.62),('7643','2013-09-10','15:40:00',4.24),('7643','2013-09-10','15:45:00',7.86),('7643','2013-09-10','15:50:00',10.17),('7643','2013-09-10','15:55:00',11.44),('7643','2013-09-10','16:00:00',10.91),('7643','2013-09-10','16:05:00',10.07),('7643','2013-09-10','16:10:00',10.65),('7643','2013-09-10','16:15:00',10.45),('7643','2013-09-10','16:20:00',9.71),('7643','2013-09-10','16:25:00',7.39),('7643','2013-09-10','16:30:00',8.11),('7643','2013-09-10','16:35:00',7.57),('7643','2013-09-10','16:40:00',7.43),('7643','2013-09-10','16:45:00',8.64),('7643','2013-09-10','16:50:00',7.55),('7643','2013-09-10','16:55:00',7.03),('7643','2013-09-10','17:00:00',5.9),('7643','2013-09-10','17:05:00',6.91),('7643','2013-09-10','17:10:00',6.53),('7643','2013-09-10','17:15:00',6.1),('7643','2013-09-10','17:20:00',5.78),('7643','2013-09-10','17:25:00',5.44),('7643','2013-09-10','17:30:00',5.06),('7643','2013-09-10','17:35:00',4.73),('7643','2013-09-10','17:40:00',3.8),('7643','2013-09-10','17:45:00',3.85),('7643','2013-09-10','17:50:00',3.83),('7643','2013-09-10','17:55:00',2.71),('7643','2013-09-10','18:00:00',3.29),('7643','2013-09-10','18:05:00',2.84),('7643','2013-09-10','18:10:00',2.48),('7643','2013-09-10','18:15:00',2.09),('7643','2013-09-10','18:20:00',1.4),('7643','2013-09-10','18:25:00',1.42),('7643','2013-09-10','18:30:00',1.15),('7643','2013-09-09','07:45:00',1.34),('7643','2013-09-09','07:50:00',1.9),('7643','2013-09-09','07:55:00',2.61),('7643','2013-09-09','08:00:00',2.84),('7643','2013-09-09','08:05:00',2.23),('7643','2013-09-09','08:10:00',2.62),('7643','2013-09-09','08:15:00',3.15),('7643','2013-09-09','08:20:00',2.48),('7643','2013-09-09','08:25:00',2.01),('7643','2013-09-09','08:30:00',1.83),('7643','2013-09-09','08:35:00',1.75),('7643','2013-09-09','08:40:00',2.18),('7643','2013-09-09','08:45:00',2.74),('7643','2013-09-09','08:50:00',2.92),('7643','2013-09-09','08:55:00',6.29),('7643','2013-09-09','09:00:00',6.61),('7643','2013-09-09','09:05:00',7.56),('7643','2013-09-09','09:10:00',8.74),('7643','2013-09-09','09:15:00',7.36),('7643','2013-09-09','09:20:00',5.3),('7643','2013-09-09','09:25:00',5.46),('7643','2013-09-09','09:30:00',9.49),('7643','2013-09-09','09:35:00',10.84),('7643','2013-09-09','09:40:00',6.31),('7643','2013-09-09','09:45:00',4.94),('7643','2013-09-09','09:50:00',4.44),('7643','2013-09-09','09:55:00',4.13),('7643','2013-09-09','10:00:00',3.07),('7643','2013-09-09','10:05:00',2.74),('7643','2013-09-09','10:10:00',2.3),('7643','2013-09-09','10:15:00',2.21),('7643','2013-09-09','10:20:00',3.16),('7643','2013-09-09','10:25:00',3.51),('7643','2013-09-09','10:30:00',3.66),('7643','2013-09-09','10:35:00',4.15),('7643','2013-09-09','10:40:00',5.37),('7643','2013-09-09','10:45:00',7.29),('7643','2013-09-09','10:50:00',4.45),('7643','2013-09-09','10:55:00',4.65),('7643','2013-09-09','11:00:00',5.49),('7643','2013-09-09','11:05:00',4.54),('7643','2013-09-09','11:10:00',4.93),('7643','2013-09-09','11:15:00',4.31),('7643','2013-09-09','11:20:00',4.62),('7643','2013-09-09','11:25:00',5.29),('7643','2013-09-09','11:30:00',4),('7643','2013-09-09','11:35:00',2.75),('7643','2013-09-09','11:40:00',2.91),('7643','2013-09-09','11:45:00',4.41),('7643','2013-09-09','11:50:00',4.52),('7643','2013-09-09','11:55:00',5.66),('7643','2013-09-09','12:00:00',4.51),('7643','2013-09-09','12:05:00',3.73),('7643','2013-09-09','12:10:00',3.53),('7643','2013-09-09','12:15:00',3.63),('7643','2013-09-09','12:20:00',3.97),('7643','2013-09-09','12:25:00',3.84),('7643','2013-09-09','12:30:00',3.19),('7643','2013-09-09','12:35:00',3.18),('7643','2013-09-09','12:40:00',2.56),('7643','2013-09-09','12:45:00',2.33),('7643','2013-09-09','12:50:00',2.22),('7643','2013-09-09','12:55:00',1.98),('7643','2013-09-09','13:00:00',2.32),('7643','2013-09-09','13:05:00',2.08),('7643','2013-09-09','13:10:00',2),('7643','2013-09-09','13:15:00',2.91),('7643','2013-09-09','13:20:00',3.14),('7643','2013-09-09','13:25:00',3.7),('7643','2013-09-09','13:30:00',3.45),('7643','2013-09-09','13:35:00',3.66),('7643','2013-09-09','13:40:00',6.19),('7643','2013-09-09','13:45:00',10.09),('7643','2013-09-09','13:50:00',6.42),('7643','2013-09-09','13:55:00',5.52),('7643','2013-09-09','14:00:00',3.83),('7643','2013-09-09','14:05:00',4.56),('7643','2013-09-09','14:10:00',4.66),('7643','2013-09-09','14:15:00',5.66),('7643','2013-09-09','14:20:00',5.68),('7643','2013-09-09','14:25:00',7.8),('7643','2013-09-09','14:30:00',7.15),('7643','2013-09-09','14:35:00',5.29),('7643','2013-09-09','14:40:00',6.51),('7643','2013-09-09','14:45:00',6.7),('7643','2013-09-09','14:50:00',7.61),('7643','2013-09-09','14:55:00',6.81),('7643','2013-09-09','15:00:00',9.05),('7643','2013-09-09','15:05:00',8.26),('7643','2013-09-09','15:10:00',5.81),('7643','2013-09-09','15:15:00',5.9),('7643','2013-09-09','15:20:00',7.09),('7643','2013-09-09','15:25:00',6.37),('7643','2013-09-09','15:30:00',7.34),('7643','2013-09-09','15:35:00',6.4),('7643','2013-09-09','15:40:00',4.14),('7643','2013-09-09','15:45:00',3.7),('7643','2013-09-09','15:50:00',3.68),('7643','2013-09-09','15:55:00',3.55),('7643','2013-09-09','16:00:00',3.66),('7643','2013-09-09','16:05:00',4.1),('7643','2013-09-09','16:10:00',4.52),('7643','2013-09-09','16:15:00',5.06),('7643','2013-09-09','16:20:00',3.73),('7643','2013-09-09','16:25:00',3.43),('7643','2013-09-09','16:30:00',2.77),('7643','2013-09-09','16:35:00',1.51),('7643','2013-09-09','16:40:00',1.37),('7643','2013-09-09','16:45:00',1.97),('7643','2013-09-09','16:50:00',2.59),('7643','2013-09-09','16:55:00',2.66),('7643','2013-09-09','17:00:00',2.34),('7643','2013-09-09','17:05:00',2.17),('7643','2013-09-09','17:10:00',2.41),('7643','2013-09-09','17:15:00',2.78),('7643','2013-09-09','17:20:00',2.84),('7643','2013-09-09','17:25:00',2.73),('7643','2013-09-09','17:30:00',2.4),('7643','2013-09-09','17:35:00',1.95),('7643','2013-09-09','17:40:00',1.82),('7643','2013-09-09','17:45:00',2.28),('7643','2013-09-09','17:50:00',2.59),('7643','2013-09-09','17:55:00',2.17),('7643','2013-09-09','18:00:00',1.85),('7643','2013-09-09','18:05:00',1.49),('7643','2013-09-09','18:10:00',1.14),('7643','2013-09-08','07:25:00',1.03),('7643','2013-09-08','07:30:00',1.64),('7643','2013-09-08','07:35:00',2.26),('7643','2013-09-08','07:40:00',2.94),('7643','2013-09-08','07:45:00',3.32),('7643','2013-09-08','07:50:00',3.56),('7643','2013-09-08','07:55:00',3.29),('7643','2013-09-08','08:00:00',3),('7643','2013-09-08','08:05:00',2.16),('7643','2013-09-08','08:10:00',1.98),('7643','2013-09-08','08:15:00',1.95),('7643','2013-09-08','08:20:00',2.01),('7643','2013-09-08','08:25:00',2.12),('7643','2013-09-08','08:30:00',2.1),('7643','2013-09-08','08:35:00',2.01),('7643','2013-09-08','08:40:00',2.31),('7643','2013-09-08','08:45:00',3.02),('7643','2013-09-08','08:50:00',3.47),('7643','2013-09-08','08:55:00',4.08),('7643','2013-09-08','09:00:00',4.12),('7643','2013-09-08','09:05:00',3.7),('7643','2013-09-08','09:10:00',3.1),('7643','2013-09-08','09:15:00',2.04),('7643','2013-09-08','09:20:00',2.63),('7643','2013-09-08','09:25:00',2.54),('7643','2013-09-08','09:30:00',2.59),('7643','2013-09-08','09:35:00',3.84),('7643','2013-09-08','09:40:00',3.57),('7643','2013-09-08','09:45:00',2.83),('7643','2013-09-08','09:50:00',3.05),('7643','2013-09-08','09:55:00',2.82),('7643','2013-09-08','10:00:00',5.24),('7643','2013-09-08','10:05:00',6.48),('7643','2013-09-08','10:10:00',6.56),('7643','2013-09-08','10:15:00',6.3),('7643','2013-09-08','10:20:00',4.87),('7643','2013-09-08','10:25:00',4.57),('7643','2013-09-08','10:30:00',5.83),('7643','2013-09-08','10:35:00',6.35),('7643','2013-09-08','10:40:00',6.4),('7643','2013-09-08','10:45:00',7.04),('7643','2013-09-08','10:50:00',9.04),('7643','2013-09-08','10:55:00',8.97),('7643','2013-09-08','11:00:00',9.76),('7643','2013-09-08','11:05:00',7.76),('7643','2013-09-08','11:10:00',7.02),('7643','2013-09-08','11:15:00',7.06),('7643','2013-09-08','11:20:00',8.39),('7643','2013-09-08','11:25:00',10.02),('7643','2013-09-08','11:30:00',7.96),('7643','2013-09-08','11:35:00',6.9),('7643','2013-09-08','11:40:00',11.57),('7643','2013-09-08','11:45:00',12.88),('7643','2013-09-08','11:50:00',11.87),('7643','2013-09-08','11:55:00',11.01),('7643','2013-09-08','12:00:00',12),('7643','2013-09-08','12:05:00',11.58),('7643','2013-09-08','12:10:00',8.42),('7643','2013-09-08','12:15:00',6.61),('7643','2013-09-08','12:20:00',7.17),('7643','2013-09-08','12:25:00',4.98),('7643','2013-09-08','12:30:00',4.56),('7643','2013-09-08','12:35:00',4.17),('7643','2013-09-08','12:40:00',5.14),('7643','2013-09-08','12:45:00',6.67),('7643','2013-09-08','12:50:00',4.77),('7643','2013-09-08','12:55:00',6.27),('7643','2013-09-08','13:00:00',6.18),('7643','2013-09-08','13:05:00',8.78),('7643','2013-09-08','13:10:00',11.82),('7643','2013-09-08','13:15:00',9.71),('7643','2013-09-08','13:20:00',6.91),('7643','2013-09-08','13:25:00',9.59),('7643','2013-09-08','13:30:00',8.59),('7643','2013-09-08','13:35:00',14.64),('7643','2013-09-08','13:40:00',14.13),('7643','2013-09-08','13:45:00',14.32),('7643','2013-09-08','13:50:00',12.8),('7643','2013-09-08','13:55:00',8.93),('7643','2013-09-08','14:00:00',13.55),('7643','2013-09-08','14:05:00',11.72),('7643','2013-09-08','14:10:00',10.34),('7643','2013-09-08','14:15:00',8.83),('7643','2013-09-08','14:20:00',8.07),('7643','2013-09-08','14:25:00',6.33),('7643','2013-09-08','14:30:00',7.66),('7643','2013-09-08','14:35:00',13.81),('7643','2013-09-08','14:40:00',10.11),('7643','2013-09-08','14:45:00',7.43),('7643','2013-09-08','14:50:00',11.86),('7643','2013-09-08','14:55:00',11.66),('7643','2013-09-08','15:00:00',8.79),('7643','2013-09-08','15:05:00',8.88),('7643','2013-09-08','15:10:00',10.85),('7643','2013-09-08','15:15:00',5.74),('7643','2013-09-08','15:20:00',6.84),('7643','2013-09-08','15:25:00',4.44),('7643','2013-09-08','15:30:00',9.61),('7643','2013-09-08','15:35:00',8.51),('7643','2013-09-08','15:40:00',7.97),('7643','2013-09-08','15:45:00',4.03),('7643','2013-09-08','15:50:00',4.01),('7643','2013-09-08','15:55:00',4.92),('7643','2013-09-08','16:00:00',5.86),('7643','2013-09-08','16:05:00',4.64),('7643','2013-09-08','16:10:00',5.85),('7643','2013-09-08','16:15:00',8.04),('7643','2013-09-08','16:20:00',6.55),('7643','2013-09-08','16:25:00',3.68),('7643','2013-09-08','16:30:00',3.68),('7643','2013-09-08','16:35:00',4.13),('7643','2013-09-08','16:40:00',4.51),('7643','2013-09-08','16:45:00',7.57),('7643','2013-09-08','16:50:00',3.18),('7643','2013-09-08','16:55:00',2.43),('7643','2013-09-08','17:00:00',3.41),('7643','2013-09-08','17:05:00',2.94),('7643','2013-09-08','17:10:00',2.9),('7643','2013-09-08','17:15:00',2.05),('7643','2013-09-08','17:20:00',1.8),('7643','2013-09-08','17:25:00',1.29),('7643','2013-09-08','17:30:00',1.47),('7643','2013-09-08','17:35:00',2.16),('7643','2013-09-08','17:40:00',2.22),('7643','2013-09-08','17:45:00',1.28),('7643','2013-09-08','18:00:00',1.26),('7643','2013-09-08','18:05:00',1.68),('7643','2013-09-08','18:10:00',2.28),('7643','2013-09-08','18:15:00',3.21),('7643','2013-09-08','18:20:00',2.67),('7643','2013-09-08','18:25:00',2.12),('7643','2013-09-08','18:30:00',1.77),('7643','2014-04-11','07:05:00',1.12),('7643','2014-04-11','07:10:00',1.29),('7643','2014-04-11','07:15:00',1.3),('7643','2014-04-11','07:20:00',1.41),('7643','2014-04-11','07:25:00',1.49),('7643','2014-04-11','07:30:00',1.31),('7643','2014-04-11','07:35:00',1.15),('7643','2014-04-11','07:40:00',1.25),('7643','2014-04-11','07:45:00',1.26),('7643','2014-04-11','07:50:00',1.01),('7643','2014-04-11','07:55:00',1.02),('7643','2014-04-11','08:00:00',1.38),('7643','2014-04-11','08:05:00',1.81),('7643','2014-04-11','08:10:00',2.52),('7643','2014-04-11','08:15:00',2.7),('7643','2014-04-11','08:20:00',3.12),('7643','2014-04-11','08:25:00',3.89),('7643','2014-04-11','08:30:00',2.4),('7643','2014-04-11','08:35:00',2.17),('7643','2014-04-11','08:40:00',2.3),('7643','2014-04-11','08:45:00',2.27),('7643','2014-04-11','08:50:00',2.44),('7643','2014-04-11','08:55:00',2.52),('7643','2014-04-11','09:00:00',2.58),('7643','2014-04-11','09:05:00',3.15),('7643','2014-04-11','09:10:00',3.92),('7643','2014-04-11','09:15:00',5.07),('7643','2014-04-11','09:20:00',7.42),('7643','2014-04-11','09:25:00',9.6),('7643','2014-04-11','09:30:00',6.43),('7643','2014-04-11','09:35:00',5.37),('7643','2014-04-11','09:40:00',4.38),('7643','2014-04-11','09:45:00',4.12),('7643','2014-04-11','09:50:00',4.1),('7643','2014-04-11','09:55:00',4.06),('7643','2014-04-11','10:00:00',4.08),('7643','2014-04-11','10:05:00',4.27),('7643','2014-04-11','10:10:00',4.71),('7643','2014-04-11','10:15:00',5.36),('7643','2014-04-11','10:20:00',5.94),('7643','2014-04-11','10:25:00',6.84),('7643','2014-04-11','10:30:00',7.61),('7643','2014-04-11','10:35:00',9.13),('7643','2014-04-11','10:40:00',9.03),('7643','2014-04-11','10:45:00',9.96),('7643','2014-04-11','10:50:00',8.64),('7643','2014-04-11','10:55:00',10.46),('7643','2014-04-11','11:00:00',11.03),('7643','2014-04-11','11:05:00',11.62),('7643','2014-04-11','11:10:00',12.42),('7643','2014-04-11','11:15:00',16.28),('7643','2014-04-11','11:20:00',15.85),('7643','2014-04-11','11:25:00',14.47),('7643','2014-04-11','11:30:00',13.95),('7643','2014-04-11','11:35:00',14.05),('7643','2014-04-11','11:40:00',14.76),('7643','2014-04-11','11:45:00',15.1),('7643','2014-04-11','11:50:00',11.05),('7643','2014-04-11','11:55:00',7.79),('7643','2014-04-11','12:00:00',7.36),('7643','2014-04-11','12:05:00',7.43),('7643','2014-04-11','12:10:00',6.07),('7643','2014-04-11','12:15:00',5.86),('7643','2014-04-11','12:20:00',6.16),('7643','2014-04-11','12:25:00',7.16),('7643','2014-04-11','12:30:00',7.92),('7643','2014-04-11','12:35:00',9.89),('7643','2014-04-11','12:40:00',11.39),('7643','2014-04-11','12:45:00',12.38),('7643','2014-04-11','12:50:00',11.07),('7643','2014-04-11','12:55:00',6.79),('7643','2014-04-11','13:00:00',5.23),('7643','2014-04-11','13:05:00',6.31),('7643','2014-04-11','13:10:00',11.18),('7643','2014-04-11','13:15:00',13.57),('7643','2014-04-11','13:20:00',16.97),('7643','2014-04-11','13:25:00',12.6),('7643','2014-04-11','13:30:00',8.78),('7643','2014-04-11','13:35:00',6.8),('7643','2014-04-11','13:40:00',7.76),('7643','2014-04-11','13:45:00',6.65),('7643','2014-04-11','13:50:00',7.36),('7643','2014-04-11','13:55:00',5.71),('7643','2014-04-11','14:00:00',5.66),('7643','2014-04-11','14:05:00',14.82),('7643','2014-04-11','14:10:00',15.64),('7643','2014-04-11','14:15:00',7.26),('7643','2014-04-11','14:20:00',10.51),('7643','2014-04-11','14:25:00',16.35),('7643','2014-04-11','14:30:00',13.22),('7643','2014-04-11','14:35:00',9.4),('7643','2014-04-11','14:40:00',9.29),('7643','2014-04-11','14:45:00',12.19),('7643','2014-04-11','14:50:00',14.88),('7643','2014-04-11','14:55:00',15.43),('7643','2014-04-11','15:00:00',13.21),('7643','2014-04-11','15:05:00',14.1),('7643','2014-04-11','15:10:00',14.09),('7643','2014-04-11','15:15:00',14.19),('7643','2014-04-11','15:20:00',11.79),('7643','2014-04-11','15:25:00',10.89),('7643','2014-04-11','15:30:00',8.05),('7643','2014-04-11','15:35:00',9.3),('7643','2014-04-11','15:40:00',11.21),('7643','2014-04-11','15:45:00',11.96),('7643','2014-04-11','15:50:00',13.65),('7643','2014-04-11','15:55:00',13.17),('7643','2014-04-11','16:00:00',13.2),('7643','2014-04-11','16:05:00',12.98),('7643','2014-04-11','16:10:00',12.49),('7643','2014-04-11','16:15:00',12.18),('7643','2014-04-11','16:20:00',12.84),('7643','2014-04-11','16:25:00',11.6),('7643','2014-04-11','16:30:00',11.15),('7643','2014-04-11','16:35:00',10.55),('7643','2014-04-11','16:40:00',6.79),('7643','2014-04-11','16:45:00',6.7),('7643','2014-04-11','16:50:00',5.66),('7643','2014-04-11','16:55:00',7.77),('7643','2014-04-11','17:00:00',9.22),('7643','2014-04-11','17:05:00',8.44),('7643','2014-04-11','17:10:00',8.26),('7643','2014-04-11','17:15:00',7.84),('7643','2014-04-11','17:20:00',6.44),('7643','2014-04-11','17:25:00',6.6),('7643','2014-04-11','17:30:00',5.71),('7643','2014-04-11','17:35:00',4.16),('7643','2014-04-11','17:40:00',4.59),('7643','2014-04-11','17:45:00',6.46),('7643','2014-04-11','17:50:00',6.13),('7643','2014-04-11','17:55:00',4.63),('7643','2014-04-11','18:00:00',5.21),('7643','2014-04-11','18:05:00',3.7),('7643','2014-04-11','18:10:00',2.22),('7643','2014-04-11','18:15:00',1.82),('7643','2014-04-11','18:20:00',1.73),('7643','2014-04-11','18:25:00',1.39),('7643','2014-04-11','18:30:00',1.65),('7643','2014-04-11','18:35:00',1.05),('7643','2014-04-11','18:40:00',1.22),('7643','2014-04-11','18:45:00',1.51),('7643','2014-04-11','18:50:00',1.42),('7643','2014-04-11','18:55:00',1.13),('7643','2013-09-07','07:30:00',1.09),('7643','2013-09-07','07:35:00',1.35),('7643','2013-09-07','07:40:00',1.58),('7643','2013-09-07','07:45:00',1.79),('7643','2013-09-07','07:50:00',2),('7643','2013-09-07','07:55:00',2.47),('7643','2013-09-07','08:00:00',2.1),('7643','2013-09-07','08:05:00',1.36),('7643','2013-09-07','08:10:00',1.44),('7643','2013-09-07','08:15:00',1.52),('7643','2013-09-07','08:20:00',2.14),('7643','2013-09-07','08:25:00',2.83),('7643','2013-09-07','08:30:00',2.37),('7643','2013-09-07','08:35:00',2.46),('7643','2013-09-07','08:40:00',2.84),('7643','2013-09-07','08:45:00',3.14),('7643','2013-09-07','08:50:00',3.51),('7643','2013-09-07','08:55:00',3.28),('7643','2013-09-07','09:00:00',4.04),('7643','2013-09-07','09:05:00',3.9),('7643','2013-09-07','09:10:00',4.17),('7643','2013-09-07','09:15:00',4.09),('7643','2013-09-07','09:20:00',4.16),('7643','2013-09-07','09:25:00',6.76),('7643','2013-09-07','09:30:00',6.69),('7643','2013-09-07','09:35:00',7.72),('7643','2013-09-07','09:40:00',6.87),('7643','2013-09-07','09:45:00',8.14),('7643','2013-09-07','09:50:00',9.04),('7643','2013-09-07','09:55:00',9.2),('7643','2013-09-07','10:00:00',9.48),('7643','2013-09-07','10:05:00',9.57),('7643','2013-09-07','10:10:00',9.91),('7643','2013-09-07','10:15:00',9.81),('7643','2013-09-07','10:20:00',9.91),('7643','2013-09-07','10:25:00',10.42),('7643','2013-09-07','10:30:00',7.96),('7643','2013-09-07','10:35:00',10.62),('7643','2013-09-07','10:40:00',11.14),('7643','2013-09-07','10:45:00',11.26),('7643','2013-09-07','10:50:00',11.16),('7643','2013-09-07','10:55:00',11.43),('7643','2013-09-07','11:00:00',11.68),('7643','2013-09-07','11:05:00',11.62),('7643','2013-09-07','11:10:00',11.81),('7643','2013-09-07','11:15:00',11.78),('7643','2013-09-07','11:20:00',10.68),('7643','2013-09-07','11:25:00',11.53),('7643','2013-09-07','11:30:00',12.45),('7643','2013-09-07','11:35:00',12.46),('7643','2013-09-07','11:40:00',12.47),('7643','2013-09-07','11:45:00',12.39),('7643','2013-09-07','11:50:00',12.54),('7643','2013-09-07','11:55:00',12.36),('7643','2013-09-07','12:00:00',12.14),('7643','2013-09-07','12:05:00',12.33),('7643','2013-09-07','12:10:00',12.36),('7643','2013-09-07','12:15:00',12.52),('7643','2013-09-07','12:20:00',12.68),('7643','2013-09-07','12:25:00',13.01),('7643','2013-09-07','12:30:00',13.02),('7643','2013-09-07','12:35:00',13.17),('7643','2013-09-07','12:40:00',9.96),('7643','2013-09-07','12:45:00',12.6),('7643','2013-09-07','12:50:00',12.92),('7643','2013-09-07','12:55:00',13.09),('7643','2013-09-07','13:00:00',13.01),('7643','2013-09-07','13:05:00',13.15),('7643','2013-09-07','13:10:00',13.08),('7643','2013-09-07','13:15:00',12.83),('7643','2013-09-07','13:20:00',12.93),('7643','2013-09-07','13:25:00',12.41),('7643','2013-09-07','13:30:00',11.67),('7643','2013-09-07','13:35:00',9.81),('7643','2013-09-07','13:40:00',8.97),('7643','2013-09-07','13:45:00',7.46),('7643','2013-09-07','13:50:00',9.83),('7643','2013-09-07','13:55:00',10.46),('7643','2013-09-07','14:00:00',12.16),('7643','2013-09-07','14:05:00',12.15),('7643','2013-09-07','14:10:00',13.42),('7643','2013-09-07','14:15:00',11.89),('7643','2013-09-07','14:20:00',12.94),('7643','2013-09-07','14:25:00',14.38),('7643','2013-09-07','14:30:00',12.59),('7643','2013-09-07','14:35:00',13.27),('7643','2013-09-07','14:40:00',12.8),('7643','2013-09-07','14:45:00',12.65),('7643','2013-09-07','14:50:00',12.57),('7643','2013-09-07','14:55:00',12.37),('7643','2013-09-07','15:00:00',12.32),('7643','2013-09-07','15:05:00',10.41),('7643','2013-09-07','15:10:00',6.74),('7643','2013-09-07','15:15:00',8.73),('7643','2013-09-07','15:20:00',11.69),('7643','2013-09-07','15:25:00',11.63),('7643','2013-09-07','15:30:00',11.92),('7643','2013-09-07','15:35:00',11.42),('7643','2013-09-07','15:40:00',10.63),('7643','2013-09-07','15:45:00',10.63),('7643','2013-09-07','15:50:00',10.74),('7643','2013-09-07','15:55:00',8.55),('7643','2013-09-07','16:00:00',8.82),('7643','2013-09-07','16:05:00',8.94),('7643','2013-09-07','16:10:00',8.45),('7643','2013-09-07','16:15:00',8.8),('7643','2013-09-07','16:20:00',8.32),('7643','2013-09-07','16:25:00',8.09),('7643','2013-09-07','16:30:00',8.03),('7643','2013-09-07','16:35:00',7.72),('7643','2013-09-07','16:40:00',6.8),('7643','2013-09-07','16:45:00',4.47),('7643','2013-09-07','16:50:00',4.48),('7643','2013-09-07','16:55:00',4.15),('7643','2013-09-07','17:00:00',4.76),('7643','2013-09-07','17:05:00',6.99),('7643','2013-09-07','17:10:00',6.75),('7643','2013-09-07','17:15:00',6.09),('7643','2013-09-07','17:20:00',5.2),('7643','2013-09-07','17:25:00',5.15),('7643','2013-09-07','17:30:00',4.74),('7643','2013-09-07','17:35:00',2.74),('7643','2013-09-07','17:40:00',2.41),('7643','2013-09-07','17:45:00',3.51),('7643','2013-09-07','17:50:00',3.53),('7643','2013-09-07','17:55:00',3.27),('7643','2013-09-07','18:00:00',2.85),('7643','2013-09-07','18:05:00',2.39),('7643','2013-09-07','18:10:00',2.14),('7643','2013-09-07','18:15:00',1.82),('7643','2013-09-07','18:20:00',1.62),('7643','2013-09-07','18:25:00',1.46),('7643','2013-09-07','18:30:00',1.26),('7643','2013-09-07','18:35:00',1.01),('7643','2013-09-06','07:30:00',1.14),('7643','2013-09-06','07:35:00',1.38),('7643','2013-09-06','07:40:00',1.61),('7643','2013-09-06','07:45:00',1.91),('7643','2013-09-06','07:50:00',2.2),('7643','2013-09-06','07:55:00',2.51),('7643','2013-09-06','08:00:00',2.8),('7643','2013-09-06','08:05:00',3.13),('7643','2013-09-06','08:10:00',3.46),('7643','2013-09-06','08:15:00',3.77),('7643','2013-09-06','08:20:00',4.08),('7643','2013-09-06','08:25:00',4.41),('7643','2013-09-06','08:30:00',4.74),('7643','2013-09-06','08:35:00',5.06),('7643','2013-09-06','08:40:00',5.36),('7643','2013-09-06','08:45:00',5.63),('7643','2013-09-06','08:50:00',5.93),('7643','2013-09-06','08:55:00',6.31),('7643','2013-09-06','09:00:00',6.57),('7643','2013-09-06','09:05:00',6.86),('7643','2013-09-06','09:10:00',7.2),('7643','2013-09-06','09:15:00',7.55),('7643','2013-09-06','09:20:00',7.77),('7643','2013-09-06','09:25:00',8.06),('7643','2013-09-06','09:30:00',8.35),('7643','2013-09-06','09:35:00',8.59),('7643','2013-09-06','09:40:00',8.78),('7643','2013-09-06','09:45:00',9),('7643','2013-09-06','09:50:00',9.27),('7643','2013-09-06','09:55:00',9.55),('7643','2013-09-06','10:00:00',9.77),('7643','2013-09-06','10:05:00',9.94),('7643','2013-09-06','10:10:00',10.16),('7643','2013-09-06','10:15:00',10.21),('7643','2013-09-06','10:20:00',10.49),('7643','2013-09-06','10:25:00',10.63),('7643','2013-09-06','10:30:00',10.86),('7643','2013-09-06','10:35:00',11.14),('7643','2013-09-06','10:40:00',11.22),('7643','2013-09-06','10:45:00',11.29),('7643','2013-09-06','10:50:00',11.42),('7643','2013-09-06','10:55:00',11.64),('7643','2013-09-06','11:00:00',11.84),('7643','2013-09-06','11:05:00',11.99),('7643','2013-09-06','11:10:00',12.15),('7643','2013-09-06','11:15:00',12.32),('7643','2013-09-06','11:20:00',12.32),('7643','2013-09-06','11:25:00',12.49),('7643','2013-09-06','11:30:00',12.64),('7643','2013-09-06','11:35:00',12.87),('7643','2013-09-06','11:40:00',12.91),('7643','2013-09-06','11:45:00',13),('7643','2013-09-06','11:50:00',13.1),('7643','2013-09-06','11:55:00',13.19),('7643','2013-09-06','12:00:00',13.15),('7643','2013-09-06','12:05:00',13.34),('7643','2013-09-06','12:10:00',13.48),('7643','2013-09-06','12:15:00',13.58),('7643','2013-09-06','12:20:00',13.51),('7643','2013-09-06','12:25:00',13.47),('7643','2013-09-06','12:30:00',13.66),('7643','2013-09-06','12:35:00',13.7),('7643','2013-09-06','12:40:00',13.54),('7643','2013-09-06','12:45:00',13.41),('7643','2013-09-06','12:50:00',13.54),('7643','2013-09-06','12:55:00',13.69),('7643','2013-09-06','13:00:00',13.82),('7643','2013-09-06','13:05:00',13.61),('7643','2013-09-06','13:10:00',13.48),('7643','2013-09-06','13:15:00',12.53),('7643','2013-09-06','13:20:00',13.6),('7643','2013-09-06','13:25:00',13.47),('7643','2013-09-06','13:30:00',13.62),('7643','2013-09-06','13:35:00',13.97),('7643','2013-09-06','13:40:00',13.73),('7643','2013-09-06','13:45:00',9.52),('7643','2013-09-06','13:50:00',12.39),('7643','2013-09-06','13:55:00',13.11),('7643','2013-09-06','14:00:00',13.93),('7643','2013-09-06','14:05:00',13.67),('7643','2013-09-06','14:10:00',13.79),('7643','2013-09-06','14:15:00',13.62),('7643','2013-09-06','14:20:00',13.35),('7643','2013-09-06','14:25:00',12.96),('7643','2013-09-06','14:30:00',12.54),('7643','2013-09-06','14:35:00',12.86),('7643','2013-09-06','14:40:00',12.91),('7643','2013-09-06','14:45:00',12.86),('7643','2013-09-06','14:50:00',12.68),('7643','2013-09-06','14:55:00',12.43),('7643','2013-09-06','15:00:00',12.42),('7643','2013-09-06','15:05:00',12.22),('7643','2013-09-06','15:10:00',12.06),('7643','2013-09-06','15:15:00',11.99),('7643','2013-09-06','15:20:00',11.74),('7643','2013-09-06','15:25:00',11.64),('7643','2013-09-06','15:30:00',11.45),('7643','2013-09-06','15:35:00',11.21),('7643','2013-09-06','15:40:00',10.9),('7643','2013-09-06','15:45:00',10.71),('7643','2013-09-06','15:50:00',10.54),('7643','2013-09-06','15:55:00',10.24),('7643','2013-09-06','16:00:00',10.06),('7643','2013-09-06','16:05:00',9.79),('7643','2013-09-06','16:10:00',9.53),('7643','2013-09-06','16:15:00',9.19),('7643','2013-09-06','16:20:00',8.93),('7643','2013-09-06','16:25:00',8.61),('7643','2013-09-06','16:30:00',8.32),('7643','2013-09-06','16:35:00',8.12),('7643','2013-09-06','16:40:00',7.81),('7643','2013-09-06','16:45:00',7.58),('7643','2013-09-06','16:50:00',7.32),('7643','2013-09-06','16:55:00',7.01),('7643','2013-09-06','17:00:00',6.7),('7643','2013-09-06','17:05:00',6.38),('7643','2013-09-06','17:10:00',6.05),('7643','2013-09-06','17:15:00',5.78),('7643','2013-09-06','17:20:00',5.5),('7643','2013-09-06','17:25:00',5.15),('7643','2013-09-06','17:30:00',4.8),('7643','2013-09-06','17:35:00',4.51),('7643','2013-09-06','17:40:00',4.23),('7643','2013-09-06','17:45:00',3.93),('7643','2013-09-06','17:50:00',3.6),('7643','2013-09-06','17:55:00',3.28),('7643','2013-09-06','18:00:00',2.97),('7643','2013-09-06','18:05:00',2.63),('7643','2013-09-06','18:10:00',2.31),('7643','2013-09-06','18:15:00',2.05),('7643','2013-09-06','18:20:00',1.79),('7643','2013-09-06','18:25:00',1.54),('7643','2013-09-06','18:30:00',1.33),('7643','2013-09-06','18:35:00',1.13),('7643','2013-09-05','07:25:00',1.06),('7643','2013-09-05','07:30:00',1.27),('7643','2013-09-05','07:35:00',1.47),('7643','2013-09-05','07:40:00',1.72),('7643','2013-09-05','07:45:00',2),('7643','2013-09-05','07:50:00',2.27),('7643','2013-09-05','07:55:00',2.56),('7643','2013-09-05','08:00:00',2.87),('7643','2013-09-05','08:05:00',3.24),('7643','2013-09-05','08:10:00',3.57),('7643','2013-09-05','08:15:00',3.88),('7643','2013-09-05','08:20:00',4.24),('7643','2013-09-05','08:25:00',4.55),('7643','2013-09-05','08:30:00',4.87),('7643','2013-09-05','08:35:00',5.18),('7643','2013-09-05','08:40:00',5.51),('7643','2013-09-05','08:45:00',5.86),('7643','2013-09-05','08:50:00',6.15),('7643','2013-09-05','08:55:00',6.48),('7643','2013-09-05','09:00:00',6.77),('7643','2013-09-05','09:05:00',7.11),('7643','2013-09-05','09:10:00',7.37),('7643','2013-09-05','09:15:00',7.64),('7643','2013-09-05','09:20:00',7.9),('7643','2013-09-05','09:25:00',8.14),('7643','2013-09-05','09:30:00',8.41),('7643','2013-09-05','09:35:00',8.7),('7643','2013-09-05','09:40:00',8.97),('7643','2013-09-05','09:45:00',9.22),('7643','2013-09-05','09:50:00',9.34),('7643','2013-09-05','09:55:00',9.54),('7643','2013-09-05','10:00:00',9.8),('7643','2013-09-05','10:05:00',10.09),('7643','2013-09-05','10:10:00',10.27),('7643','2013-09-05','10:15:00',10.46),('7643','2013-09-05','10:20:00',10.62),('7643','2013-09-05','10:25:00',10.83),('7643','2013-09-05','10:30:00',11.16),('7643','2013-09-05','10:35:00',11.42),('7643','2013-09-05','10:40:00',11.62),('7643','2013-09-05','10:45:00',11.77),('7643','2013-09-05','10:50:00',11.91),('7643','2013-09-05','10:55:00',12.03),('7643','2013-09-05','11:00:00',12.24),('7643','2013-09-05','11:05:00',12.41),('7643','2013-09-05','11:10:00',12.5),('7643','2013-09-05','11:15:00',12.53),('7643','2013-09-05','11:20:00',12.67),('7643','2013-09-05','11:25:00',12.86),('7643','2013-09-05','11:30:00',12.89),('7643','2013-09-05','11:35:00',12.92),('7643','2013-09-05','11:40:00',13),('7643','2013-09-05','11:45:00',13.12),('7643','2013-09-05','11:50:00',13.14),('7643','2013-09-05','11:55:00',13.22),('7643','2013-09-05','12:00:00',13.34),('7643','2013-09-05','12:05:00',13.51),('7643','2013-09-05','12:10:00',13.57),('7643','2013-09-05','12:15:00',13.49),('7643','2013-09-05','12:20:00',13.84),('7643','2013-09-05','12:25:00',13.97),('7643','2013-09-05','12:30:00',14.08),('7643','2013-09-05','12:35:00',14.08),('7643','2013-09-05','12:40:00',13.86),('7643','2013-09-05','12:45:00',13.77),('7643','2013-09-05','12:50:00',13.78),('7643','2013-09-05','12:55:00',13.79),('7643','2013-09-05','13:00:00',13.87),('7643','2013-09-05','13:05:00',13.91),('7643','2013-09-05','13:10:00',13.88),('7643','2013-09-05','13:15:00',13.79),('7643','2013-09-05','13:20:00',13.81),('7643','2013-09-05','13:25:00',13.82),('7643','2013-09-05','13:30:00',13.68),('7643','2013-09-05','13:35:00',13.62),('7643','2013-09-05','13:40:00',13.59),('7643','2013-09-05','13:45:00',13.52),('7643','2013-09-05','13:50:00',13.53),('7643','2013-09-05','13:55:00',13.4),('7643','2013-09-05','14:00:00',13.23),('7643','2013-09-05','14:05:00',13.03),('7643','2013-09-05','14:10:00',13.12),('7643','2013-09-05','14:15:00',13.09),('7643','2013-09-05','14:20:00',13.02),('7643','2013-09-05','14:25:00',12.73),('7643','2013-09-05','14:30:00',12.64),('7643','2013-09-05','14:35:00',12.28),('7643','2013-09-05','14:40:00',12.02),('7643','2013-09-05','14:45:00',12.44),('7643','2013-09-05','14:50:00',12.93),('7643','2013-09-05','14:55:00',12.62),('7643','2013-09-05','15:00:00',12.27),('7643','2013-09-05','15:05:00',12.08),('7643','2013-09-05','15:10:00',11.9),('7643','2013-09-05','15:15:00',11.7),('7643','2013-09-05','15:20:00',11.58),('7643','2013-09-05','15:25:00',11.29),('7643','2013-09-05','15:30:00',11.04),('7643','2013-09-05','15:35:00',10.85),('7643','2013-09-05','15:40:00',10.82),('7643','2013-09-05','15:45:00',10.61),('7643','2013-09-05','15:50:00',10.44),('7643','2013-09-05','15:55:00',10.19),('7643','2013-09-05','16:00:00',9.99),('7643','2013-09-05','16:05:00',9.68),('7643','2013-09-05','16:10:00',9.44),('7643','2013-09-05','16:15:00',9.2),('7643','2013-09-05','16:20:00',8.98),('7643','2013-09-05','16:25:00',8.82),('7643','2013-09-05','16:30:00',8.62),('7643','2013-09-05','16:35:00',8.38),('7643','2013-09-05','16:40:00',8.07),('7643','2013-09-05','16:45:00',7.72),('7643','2013-09-05','16:50:00',7.35),('7643','2013-09-05','16:55:00',7.04),('7643','2013-09-05','17:00:00',6.84),('7643','2013-09-05','17:05:00',6.44),('7643','2013-09-05','17:10:00',6.22),('7643','2013-09-05','17:15:00',5.91),('7643','2013-09-05','17:20:00',5.55),('7643','2013-09-05','17:25:00',5.2),('7643','2013-09-05','17:30:00',4.85),('7643','2013-09-05','17:35:00',4.57),('7643','2013-09-05','17:40:00',4.26),('7643','2013-09-05','17:45:00',3.91),('7643','2013-09-05','17:50:00',3.5),('7643','2013-09-05','17:55:00',3.28),('7643','2013-09-05','18:00:00',3.04),('7643','2013-09-05','18:05:00',2.74),('7643','2013-09-05','18:10:00',2.44),('7643','2013-09-05','18:15:00',2.13),('7643','2013-09-05','18:20:00',1.82),('7643','2013-09-05','18:25:00',1.56),('7643','2013-09-05','18:30:00',1.34),('7643','2013-09-05','18:35:00',1.14),('7643','2013-09-04','07:25:00',1.1),('7643','2013-09-04','07:30:00',1.36),('7643','2013-09-04','07:35:00',1.63),('7643','2013-09-04','07:40:00',1.93),('7643','2013-09-04','07:45:00',2.25),('7643','2013-09-04','07:50:00',2.55),('7643','2013-09-04','07:55:00',2.88),('7643','2013-09-04','08:00:00',3.21),('7643','2013-09-04','08:05:00',3.58),('7643','2013-09-04','08:10:00',3.94),('7643','2013-09-04','08:15:00',4.3),('7643','2013-09-04','08:20:00',4.66),('7643','2013-09-04','08:25:00',5),('7643','2013-09-04','08:30:00',5.33),('7643','2013-09-04','08:35:00',5.67),('7643','2013-09-04','08:40:00',6.02),('7643','2013-09-04','08:45:00',6.35),('7643','2013-09-04','08:50:00',6.65),('7643','2013-09-04','08:55:00',6.93),('7643','2013-09-04','09:00:00',7.21),('7643','2013-09-04','09:05:00',7.59),('7643','2013-09-04','09:10:00',7.9),('7643','2013-09-04','09:15:00',8.18),('7643','2013-09-04','09:20:00',8.48),('7643','2013-09-04','09:25:00',8.76),('7643','2013-09-04','09:30:00',8.97),('7643','2013-09-04','09:35:00',9.18),('7643','2013-09-04','09:40:00',9.48),('7643','2013-09-04','09:45:00',9.73),('7643','2013-09-04','09:50:00',10),('7643','2013-09-04','09:55:00',10.27),('7643','2013-09-04','10:00:00',10.47),('7643','2013-09-04','10:05:00',10.64),('7643','2013-09-04','10:10:00',10.87),('7643','2013-09-04','10:15:00',11.07),('7643','2013-09-04','10:20:00',11.3),('7643','2013-09-04','10:25:00',11.45),('7643','2013-09-04','10:30:00',11.64),('7643','2013-09-04','10:35:00',11.77),('7643','2013-09-04','10:40:00',11.93),('7643','2013-09-04','10:45:00',12.1),('7643','2013-09-04','10:50:00',12.21),('7643','2013-09-04','10:55:00',12.42),('7643','2013-09-04','11:00:00',12.54),('7643','2013-09-04','11:05:00',12.67),('7643','2013-09-04','11:10:00',12.77),('7643','2013-09-04','11:15:00',12.96),('7643','2013-09-04','11:20:00',13.05),('7643','2013-09-04','11:25:00',13.18),('7643','2013-09-04','11:30:00',13.23),('7643','2013-09-04','11:35:00',13.33),('7643','2013-09-04','11:40:00',13.22),('7643','2013-09-04','11:45:00',13.12),('7643','2013-09-04','11:50:00',13.55),('7643','2013-09-04','11:55:00',13.63),('7643','2013-09-04','12:00:00',13.76),('7643','2013-09-04','12:05:00',13.87),('7643','2013-09-04','12:10:00',13.91),('7643','2013-09-04','12:15:00',14),('7643','2013-09-04','12:20:00',14.11),('7643','2013-09-04','12:25:00',14.11),('7643','2013-09-04','12:30:00',14.11),('7643','2013-09-04','12:35:00',14.19),('7643','2013-09-04','12:40:00',14.22),('7643','2013-09-04','12:45:00',14.22),('7643','2013-09-04','12:50:00',14.18),('7643','2013-09-04','12:55:00',14.18),('7643','2013-09-04','13:00:00',14.18),('7643','2013-09-04','13:05:00',14.2),('7643','2013-09-04','13:10:00',14.2),('7643','2013-09-04','16:30:00',6.88),('7643','2013-09-04','16:35:00',8.91),('7643','2013-09-04','16:40:00',8.8),('7643','2013-09-04','16:45:00',8.61),('7643','2013-09-04','16:50:00',7.14),('7643','2013-09-04','16:55:00',5.74),('7643','2013-09-04','17:00:00',4.58),('7643','2013-09-04','17:05:00',5.07),('7643','2013-09-04','17:10:00',4.93),('7643','2013-09-04','17:15:00',4.49),('7643','2013-09-04','17:20:00',5.04),('7643','2013-09-04','17:25:00',4.99),('7643','2013-09-04','17:30:00',5.08),('7643','2013-09-04','17:35:00',5.11),('7643','2013-09-04','17:40:00',5.43),('7643','2013-09-04','17:45:00',4.75),('7643','2013-09-04','17:50:00',4.15),('7643','2013-09-04','17:55:00',3.6),('7643','2013-09-04','18:00:00',2.74),('7643','2013-09-04','18:05:00',2.42),('7643','2013-09-04','18:10:00',2.22),('7643','2013-09-04','18:15:00',2.08),('7643','2013-09-04','18:20:00',2.42),('7643','2013-09-04','18:25:00',1.93),('7643','2013-09-04','18:30:00',1.45),('7643','2013-09-04','18:35:00',1.35),('7643','2013-09-04','18:40:00',1.17),('7643','2013-09-03','07:25:00',1.1),('7643','2013-09-03','07:30:00',1.37),('7643','2013-09-03','07:35:00',1.64),('7643','2013-09-03','07:40:00',1.94),('7643','2013-09-03','07:45:00',2.26),('7643','2013-09-03','07:50:00',2.58),('7643','2013-09-03','07:55:00',2.92),('7643','2013-09-03','08:00:00',3.25),('7643','2013-09-03','08:05:00',3.62),('7643','2013-09-03','08:10:00',3.97),('7643','2013-09-03','08:15:00',4.33),('7643','2013-09-03','08:20:00',4.67),('7643','2013-09-03','08:25:00',5.01),('7643','2013-09-03','08:30:00',5.34),('7643','2013-09-03','08:35:00',5.67),('7643','2013-09-03','08:40:00',6.01),('7643','2013-09-03','08:45:00',6.35),('7643','2013-09-03','08:50:00',6.69),('7643','2013-09-03','08:55:00',7.01),('7643','2013-09-03','09:00:00',7.31),('7643','2013-09-03','09:05:00',7.67),('7643','2013-09-03','09:10:00',8),('7643','2013-09-03','09:15:00',8.35),('7643','2013-09-03','09:20:00',8.68),('7643','2013-09-03','09:25:00',8.98),('7643','2013-09-03','09:30:00',9.26),('7643','2013-09-03','09:35:00',9.55),('7643','2013-09-03','09:40:00',9.84),('7643','2013-09-03','09:45:00',10.11),('7643','2013-09-03','09:50:00',10.35),('7643','2013-09-03','09:55:00',10.61),('7643','2013-09-03','10:00:00',10.84),('7643','2013-09-03','10:05:00',11.11),('7643','2013-09-03','10:10:00',11.35),('7643','2013-09-03','10:15:00',11.48),('7643','2013-09-03','10:20:00',11.72),('7643','2013-09-03','10:25:00',11.93),('7643','2013-09-03','10:30:00',12.14),('7643','2013-09-03','10:35:00',12.33),('7643','2013-09-03','10:40:00',12.48),('7643','2013-09-03','10:45:00',12.57),('7643','2013-09-03','10:50:00',12.7),('7643','2013-09-03','10:55:00',12.93),('7643','2013-09-03','11:00:00',13.12),('7643','2013-09-03','11:05:00',13.25),('7643','2013-09-03','11:10:00',13.41),('7643','2013-09-03','11:15:00',13.58),('7643','2013-09-03','11:20:00',13.74),('7643','2013-09-03','11:25:00',13.81),('7643','2013-09-03','11:30:00',13.94),('7643','2013-09-03','11:35:00',14.07),('7643','2013-09-03','11:40:00',14.17),('7643','2013-09-03','11:45:00',14.23),('7643','2013-09-03','11:50:00',14.41),('7643','2013-09-03','11:55:00',14.59),('7643','2013-09-03','12:00:00',14.63),('7643','2013-09-03','12:05:00',14.62),('7643','2013-09-03','12:10:00',14.68),('7643','2013-09-03','12:15:00',14.72),('7643','2013-09-03','12:20:00',14.85),('7643','2013-09-03','12:25:00',14.84),('7643','2013-09-03','12:30:00',14.93),('7643','2013-09-03','12:35:00',15.08),('7643','2013-09-03','12:40:00',15.12),('7643','2013-09-03','12:45:00',15.1),('7643','2013-09-03','12:50:00',14.95),('7643','2013-09-03','12:55:00',14.96),('7643','2013-09-03','13:00:00',14.97),('7643','2013-09-03','13:05:00',15.01),('7643','2013-09-03','13:10:00',14.94),('7643','2013-09-03','13:15:00',14.87),('7643','2013-09-03','13:20:00',14.84),('7643','2013-09-03','13:25:00',14.8),('7643','2013-09-03','13:30:00',14.77),('7643','2013-09-03','13:35:00',14.81),('7643','2013-09-03','13:40:00',14.78),('7643','2013-09-03','13:45:00',14.73),('7643','2013-09-03','13:50:00',14.71),('7643','2013-09-03','13:55:00',14.6),('7643','2013-09-03','14:00:00',14.56),('7643','2013-09-03','14:05:00',14.44),('7643','2013-09-03','14:10:00',14.37),('7643','2013-09-03','14:15:00',14.29),('7643','2013-09-03','14:20:00',14.13),('7643','2013-09-03','14:25:00',14.08),('7643','2013-09-03','14:30:00',13.98),('7643','2013-09-03','14:35:00',13.86),('7643','2013-09-03','14:40:00',13.74),('7643','2013-09-03','14:45:00',13.61),('7643','2013-09-03','14:50:00',13.49),('7643','2013-09-03','14:55:00',13.28),('7643','2013-09-03','15:00:00',13.08),('7643','2013-09-03','15:05:00',12.93),('7643','2013-09-03','15:10:00',12.78),('7643','2013-09-03','15:15:00',12.61),('7643','2013-09-03','15:20:00',12.45),('7643','2013-09-03','15:25:00',12.22),('7643','2013-09-03','15:30:00',12.07),('7643','2013-09-03','15:35:00',11.83),('7643','2013-09-03','15:40:00',11.68),('7643','2013-09-03','15:45:00',11.49),('7643','2013-09-03','15:50:00',11.24),('7643','2013-09-03','15:55:00',11.04),('7643','2013-09-03','16:00:00',10.76),('7643','2013-09-03','16:05:00',10.46),('7643','2013-09-03','16:10:00',10.21),('7643','2013-09-03','16:15:00',9.98),('7643','2013-09-03','16:20:00',9.73),('7643','2013-09-03','16:25:00',9.43),('7643','2013-09-03','16:30:00',9.2),('7643','2013-09-03','16:35:00',8.92),('7643','2013-09-03','16:40:00',8.62),('7643','2013-09-03','16:45:00',8.38),('7643','2013-09-03','16:50:00',8.09),('7643','2013-09-03','16:55:00',7.76),('7643','2013-09-03','17:00:00',7.47),('7643','2013-09-03','17:05:00',7.17),('7643','2013-09-03','17:10:00',6.84),('7643','2013-09-03','17:15:00',6.52),('7643','2013-09-03','17:20:00',6.18),('7643','2013-09-03','17:25:00',5.85),('7643','2013-09-03','17:30:00',5.51),('7643','2013-09-03','17:35:00',5.19),('7643','2013-09-03','17:40:00',4.83),('7643','2013-09-03','17:45:00',4.47),('7643','2013-09-03','17:50:00',4.1),('7643','2013-09-03','17:55:00',3.77),('7643','2013-09-03','18:00:00',3.38),('7643','2013-09-03','18:05:00',3.03),('7643','2013-09-03','18:10:00',2.66),('7643','2013-09-03','18:15:00',2.3),('7643','2013-09-03','18:20:00',1.96),('7643','2013-09-03','18:25:00',1.66),('7643','2013-09-03','18:30:00',1.41),('7643','2013-09-03','18:35:00',1.2),('7643','2013-09-02','07:25:00',1.05),('7643','2013-09-02','07:30:00',1.27),('7643','2013-09-02','07:35:00',1.5),('7643','2013-09-02','07:40:00',1.77),('7643','2013-09-02','07:45:00',2.05),('7643','2013-09-02','07:50:00',2.33),('7643','2013-09-02','07:55:00',2.63),('7643','2013-09-02','08:00:00',2.92),('7643','2013-09-02','08:05:00',3.25),('7643','2013-09-02','08:10:00',3.56),('7643','2013-09-02','08:15:00',3.86),('7643','2013-09-02','08:20:00',4.18),('7643','2013-09-02','08:25:00',4.49),('7643','2013-09-02','08:30:00',4.82),('7643','2013-09-02','08:35:00',5.15),('7643','2013-09-02','08:40:00',5.42),('7643','2013-09-02','08:45:00',5.74),('7643','2013-09-02','08:50:00',6.08),('7643','2013-09-02','08:55:00',6.43),('7643','2013-09-02','09:00:00',6.74),('7643','2013-09-02','09:05:00',7.1),('7643','2013-09-02','09:10:00',7.4),('7643','2013-09-02','09:15:00',7.69),('7643','2013-09-02','09:20:00',8.06),('7643','2013-09-02','09:25:00',8.35),('7643','2013-09-02','09:30:00',8.63),('7643','2013-09-02','09:35:00',8.93),('7643','2013-09-02','09:40:00',9.13),('7643','2013-09-02','09:45:00',9.38),('7643','2013-09-02','09:50:00',9.59),('7643','2013-09-02','09:55:00',9.78),('7643','2013-09-02','10:00:00',9.99),('7643','2013-09-02','10:05:00',10.17),('7643','2013-09-02','10:10:00',10.4),('7643','2013-09-02','10:15:00',10.65),('7643','2013-09-02','10:20:00',10.88),('7643','2013-09-02','10:25:00',11.15),('7643','2013-09-02','10:30:00',11.38),('7643','2013-09-02','10:35:00',11.65),('7643','2013-09-02','10:40:00',11.99),('7643','2013-09-02','10:45:00',12.29),('7643','2013-09-02','10:50:00',12.41),('7643','2013-09-02','10:55:00',12.42),('7643','2013-09-02','11:00:00',12.55),('7643','2013-09-02','11:05:00',12.68),('7643','2013-09-02','11:10:00',12.86),('7643','2013-09-02','11:15:00',13.04),('7643','2013-09-02','11:20:00',13.12),('7643','2013-09-02','11:25:00',13.24),('7643','2013-09-02','11:30:00',13.32),('7643','2013-09-02','11:35:00',13.39),('7643','2013-09-02','11:40:00',13.46),('7643','2013-09-02','11:45:00',13.64),('7643','2013-09-02','11:50:00',13.76),('7643','2013-09-02','11:55:00',13.98),('7643','2013-09-02','12:00:00',13.98),('7643','2013-09-02','12:05:00',14.07),('7643','2013-09-02','12:10:00',14.2),('7643','2013-09-02','12:15:00',14.3),('7643','2013-09-02','12:20:00',14.38),('7643','2013-09-02','12:25:00',14.53),('7643','2013-09-02','12:30:00',14.59),('7643','2013-09-02','12:35:00',14.5),('7643','2013-09-02','12:40:00',14.57),('7643','2013-09-02','12:45:00',14.61),('7643','2013-09-02','12:50:00',14.56),('7643','2013-09-02','12:55:00',14.56),('7643','2013-09-02','13:00:00',14.6),('7643','2013-09-02','13:05:00',14.7),('7643','2013-09-02','13:10:00',14.64),('7643','2013-09-02','13:15:00',14.59),('7643','2013-09-02','13:20:00',14.58),('7643','2013-09-02','13:25:00',14.47),('7643','2013-09-02','13:30:00',14.53),('7643','2013-09-02','13:35:00',14.46),('7643','2013-09-02','13:40:00',14.29),('7643','2013-09-02','13:45:00',14.37),('7643','2013-09-02','13:50:00',14.38),('7643','2013-09-02','13:55:00',14.23),('7643','2013-09-02','14:00:00',13.94),('7643','2013-09-02','14:05:00',13.83),('7643','2013-09-02','14:10:00',13.68),('7643','2013-09-02','14:15:00',13.68),('7643','2013-09-02','14:20:00',13.68),('7643','2013-09-02','14:25:00',13.54),('7643','2013-09-02','14:30:00',13.59),('7643','2013-09-02','14:35:00',13.51),('7643','2013-09-02','14:40:00',13.35),('7643','2013-09-02','14:45:00',13.37),('7643','2013-09-02','14:50:00',13.35),('7643','2013-09-02','14:55:00',13.13),('7643','2013-09-02','15:00:00',12.89),('7643','2013-09-02','15:05:00',12.54),('7643','2013-09-02','15:10:00',12.46),('7643','2013-09-02','15:15:00',12.4),('7643','2013-09-02','15:20:00',12.13),('7643','2013-09-02','15:25:00',11.92),('7643','2013-09-02','15:30:00',11.69),('7643','2013-09-02','15:35:00',11.45),('7643','2013-09-02','15:40:00',11.22),('7643','2013-09-02','15:45:00',11.04),('7643','2013-09-02','15:50:00',10.95),('7643','2013-09-02','15:55:00',10.72),('7643','2013-09-02','16:00:00',10.54),('7643','2013-09-02','16:05:00',10.29),('7643','2013-09-02','16:10:00',10.05),('7643','2013-09-02','16:15:00',9.78),('7643','2013-09-02','16:20:00',9.59),('7643','2013-09-02','16:25:00',9.34),('7643','2013-09-02','16:30:00',9.07),('7643','2013-09-02','16:35:00',8.8),('7643','2013-09-02','16:40:00',8.53),('7643','2013-09-02','16:45:00',8.24),('7643','2013-09-02','16:50:00',7.96),('7643','2013-09-02','16:55:00',7.77),('7643','2013-09-02','17:00:00',7.48),('7643','2013-09-02','17:05:00',7.12),('7643','2013-09-02','17:10:00',6.82),('7643','2013-09-02','17:15:00',6.5),('7643','2013-09-02','17:20:00',6.21),('7643','2013-09-02','17:25:00',5.88),('7643','2013-09-02','17:30:00',5.55),('7643','2013-09-02','17:35:00',5.23),('7643','2013-09-02','17:40:00',4.89),('7643','2013-09-02','17:45:00',4.55),('7643','2013-09-02','17:50:00',4.24),('7643','2013-09-02','17:55:00',3.92),('7643','2013-09-02','18:00:00',3.47),('7643','2013-09-02','18:05:00',2.91),('7643','2013-09-02','18:10:00',2.46),('7643','2013-09-02','18:15:00',2.21),('7643','2013-09-02','18:20:00',1.98),('7643','2013-09-02','18:25:00',1.74),('7643','2013-09-02','18:30:00',1.5),('7643','2013-09-02','18:35:00',1.27),('7643','2013-09-02','18:40:00',1.08),('7643','2013-09-01','07:25:00',1.14),('7643','2013-09-01','07:30:00',1.37),('7643','2013-09-01','07:35:00',1.61),('7643','2013-09-01','07:40:00',1.88),('7643','2013-09-01','07:45:00',2.17),('7643','2013-09-01','07:50:00',2.45),('7643','2013-09-01','07:55:00',2.73),('7643','2013-09-01','08:00:00',3.04),('7643','2013-09-01','08:05:00',3.39),('7643','2013-09-01','08:10:00',3.72),('7643','2013-09-01','08:15:00',4.04),('7643','2013-09-01','08:20:00',4.37),('7643','2013-09-01','08:25:00',4.67),('7643','2013-09-01','08:30:00',4.93),('7643','2013-09-01','08:35:00',5.3),('7643','2013-09-01','08:40:00',5.67),('7643','2013-09-01','08:45:00',6.01),('7643','2013-09-01','08:50:00',6.32),('7643','2013-09-01','08:55:00',6.62),('7643','2013-09-01','09:00:00',6.99),('7643','2013-09-01','09:05:00',7.36),('7643','2013-09-01','09:10:00',7.66),('7643','2013-09-01','09:15:00',7.93),('7643','2013-09-01','09:20:00',8.21),('7643','2013-09-01','09:25:00',8.52),('7643','2013-09-01','09:30:00',8.8),('7643','2013-09-01','09:35:00',9.1),('7643','2013-09-01','09:40:00',9.36),('7643','2013-09-01','09:45:00',9.63),('7643','2013-09-01','09:50:00',9.9),('7643','2013-09-01','09:55:00',10.09),('7643','2013-09-01','10:00:00',10.36),('7643','2013-09-01','10:05:00',10.61),('7643','2013-09-01','10:10:00',10.83),('7643','2013-09-01','10:15:00',11.07),('7643','2013-09-01','10:20:00',11.25),('7643','2013-09-01','10:25:00',11.44),('7643','2013-09-01','10:30:00',11.61),('7643','2013-09-01','10:35:00',11.76),('7643','2013-09-01','10:40:00',11.91),('7643','2013-09-01','10:45:00',12.08),('7643','2013-09-01','10:50:00',12.24),('7643','2013-09-01','10:55:00',12.37),('7643','2013-09-01','11:00:00',12.49),('7643','2013-09-01','11:05:00',12.69),('7643','2013-09-01','11:10:00',12.83),('7643','2013-09-01','11:15:00',12.97),('7643','2013-09-01','11:20:00',13.01),('7643','2013-09-01','11:25:00',13.17),('7643','2013-09-01','11:30:00',13.27),('7643','2013-09-01','11:35:00',13.35),('7643','2013-09-01','11:40:00',13.46),('7643','2013-09-01','11:45:00',13.62),('7643','2013-09-01','11:50:00',13.74),('7643','2013-09-01','11:55:00',13.88),('7643','2013-09-01','12:00:00',13.89),('7643','2013-09-01','12:05:00',13.97),('7643','2013-09-01','12:10:00',14.14),('7643','2013-09-01','12:15:00',14.26),('7643','2013-09-01','12:20:00',14.28),('7643','2013-09-01','12:25:00',14.27),('7643','2013-09-01','12:30:00',14.15),('7643','2013-09-01','12:35:00',14.18),('7643','2013-09-01','12:40:00',14.25),('7643','2013-09-01','12:45:00',14.24),('7643','2013-09-01','12:50:00',14.19),('7643','2013-09-01','12:55:00',14.3),('7643','2013-09-01','13:00:00',14.42),('7643','2013-09-01','13:05:00',14.37),('7643','2013-09-01','13:10:00',14.45),('7643','2013-09-01','13:15:00',14.59),('7643','2013-09-01','13:20:00',14.43),('7643','2013-09-01','13:25:00',14.32),('7643','2013-09-01','13:30:00',14.24),('7643','2013-09-01','13:35:00',14.1),('7643','2013-09-01','13:40:00',14.16),('7643','2013-09-01','13:45:00',9.36),('7643','2013-09-01','13:50:00',2.17),('7643','2013-09-01','13:55:00',4.64),('7643','2013-09-01','14:00:00',7.52),('7643','2013-09-01','14:05:00',15.04),('7643','2013-09-01','14:10:00',13.54),('7643','2013-09-01','14:15:00',14.24),('7643','2013-09-01','14:20:00',14.04),('7643','2013-09-01','14:25:00',13.9),('7643','2013-09-01','14:30:00',13.95),('7643','2013-09-01','14:35:00',13.32),('7643','2013-09-01','14:40:00',13.11),('7643','2013-09-01','14:45:00',13.73),('7643','2013-09-01','14:50:00',13.68),('7643','2013-09-01','14:55:00',10.37),('7643','2013-09-01','15:00:00',4.88),('7643','2013-09-01','15:05:00',11.85),('7643','2013-09-01','15:10:00',12.08),('7643','2013-09-01','15:15:00',12.7),('7643','2013-09-01','15:20:00',12.75),('7643','2013-09-01','15:25:00',11.51),('7643','2013-09-01','15:30:00',9.08),('7643','2013-09-01','15:35:00',10.47),('7643','2013-09-01','15:40:00',11.87),('7643','2013-09-01','15:45:00',11.61),('7643','2013-09-01','15:50:00',11.34),('7643','2013-09-01','15:55:00',11.12),('7643','2013-09-01','16:00:00',10.86),('7643','2013-09-01','16:05:00',10.42),('7643','2013-09-01','16:10:00',10.26),('7643','2013-09-01','16:15:00',10.27),('7643','2013-09-01','16:20:00',10.13),('7643','2013-09-01','16:25:00',9.68),('7643','2013-09-01','16:30:00',9.33),('7643','2013-09-01','16:35:00',8.9),('7643','2013-09-01','16:40:00',8.47),('7643','2013-09-01','16:45:00',8.13),('7643','2013-09-01','16:50:00',7.89),('7643','2013-09-01','16:55:00',7.44),('7643','2013-09-01','17:00:00',7),('7643','2013-09-01','17:05:00',6.88),('7643','2013-09-01','17:10:00',6.55),('7643','2013-09-01','17:15:00',6.31),('7643','2013-09-01','17:20:00',5.96),('7643','2013-09-01','17:25:00',5.71),('7643','2013-09-01','17:30:00',5.39),('7643','2013-09-01','17:35:00',5.05),('7643','2013-09-01','17:40:00',4.71),('7643','2013-09-01','17:45:00',4.43),('7643','2013-09-01','17:50:00',4.11),('7643','2013-09-01','17:55:00',3.82),('7643','2013-09-01','18:00:00',3.47),('7643','2013-09-01','18:05:00',3.12),('7643','2013-09-01','18:10:00',2.77),('7643','2013-09-01','18:15:00',2.44),('7643','2013-09-01','18:20:00',2.15),('7643','2013-09-01','18:25:00',1.85),('7643','2013-09-01','18:30:00',1.61),('7643','2013-09-01','18:35:00',1.36),('7643','2013-09-01','18:40:00',1.15),('7643','2013-08-31','07:20:00',1.02),('7643','2013-08-31','07:25:00',1.25),('7643','2013-08-31','07:30:00',1.49),('7643','2013-08-31','07:35:00',1.74),('7643','2013-08-31','07:40:00',2.02),('7643','2013-08-31','07:45:00',2.33),('7643','2013-08-31','07:50:00',2.64),('7643','2013-08-31','07:55:00',2.97),('7643','2013-08-31','08:00:00',3.3),('7643','2013-08-31','08:05:00',3.68),('7643','2013-08-31','08:10:00',4.02),('7643','2013-08-31','08:15:00',4.34),('7643','2013-08-31','08:20:00',4.66),('7643','2013-08-31','08:25:00',4.92),('7643','2013-08-31','08:30:00',4.88),('7643','2013-08-31','08:35:00',5.57),('7643','2013-08-31','08:40:00',5.97),('7643','2013-08-31','08:45:00',6.27),('7643','2013-08-31','08:50:00',6.57),('7643','2013-08-31','08:55:00',6.88),('7643','2013-08-31','09:00:00',7.15),('7643','2013-08-31','09:05:00',7.46),('7643','2013-08-31','09:10:00',7.83),('7643','2013-08-31','09:15:00',8.14),('7643','2013-08-31','09:20:00',8.4),('7643','2013-08-31','09:25:00',8.69),('7643','2013-08-31','09:30:00',9.01),('7643','2013-08-31','09:35:00',9.26),('7643','2013-08-31','09:40:00',9.54),('7643','2013-08-31','09:45:00',9.76),('7643','2013-08-31','09:50:00',10.01),('7643','2013-08-31','09:55:00',10.21),('7643','2013-08-31','10:00:00',10.42),('7643','2013-08-31','10:05:00',10.63),('7643','2013-08-31','10:10:00',10.86),('7643','2013-08-31','10:15:00',11.02),('7643','2013-08-31','10:20:00',11.2),('7643','2013-08-31','10:25:00',11.44),('7643','2013-08-31','10:30:00',11.6),('7643','2013-08-31','10:35:00',11.77),('7643','2013-08-31','10:40:00',11.98),('7643','2013-08-31','10:45:00',12.11),('7643','2013-08-31','10:50:00',12.25),('7643','2013-08-31','10:55:00',12.36),('7643','2013-08-31','11:00:00',12.56),('7643','2013-08-31','11:05:00',12.91),('7643','2013-08-31','11:10:00',12.98),('7643','2013-08-31','11:15:00',13.05),('7643','2013-08-31','11:20:00',12.98),('7643','2013-08-31','11:25:00',13.12),('7643','2013-08-31','11:30:00',13.18),('7643','2013-08-31','11:35:00',13.47),('7643','2013-08-31','11:40:00',13.75),('7643','2013-08-31','11:45:00',13.91),('7643','2013-08-31','11:50:00',13.96),('7643','2013-08-31','11:55:00',14.05),('7643','2013-08-31','12:00:00',14.04),('7643','2013-08-31','12:05:00',13.44),('7643','2013-08-31','12:10:00',14.07),('7643','2013-08-31','12:15:00',14.2),('7643','2013-08-31','12:20:00',14.3),('7643','2013-08-31','12:25:00',13.91),('7643','2013-08-31','12:30:00',14.24),('7643','2013-08-31','12:35:00',14.33),('7643','2013-08-31','12:40:00',14.5),('7643','2013-08-31','12:45:00',14.33),('7643','2013-08-31','12:50:00',14.47),('7643','2013-08-31','12:55:00',14.41),('7643','2013-08-31','13:00:00',14.66),('7643','2013-08-31','13:05:00',14.78),('7643','2013-08-31','13:10:00',14.75),('7643','2013-08-31','13:15:00',12.21),('7643','2013-08-31','13:20:00',14.9),('7643','2013-08-31','13:25:00',14.88),('7643','2013-08-31','13:30:00',14.76),('7643','2013-08-31','13:35:00',14.54),('7643','2013-08-31','13:40:00',14.48),('7643','2013-08-31','13:45:00',14.22),('7643','2013-08-31','13:50:00',12.68),('7643','2013-08-31','13:55:00',12.54),('7643','2013-08-31','14:00:00',11.57),('7643','2013-08-31','14:05:00',10.79),('7643','2013-08-31','14:10:00',12.97),('7643','2013-08-31','14:15:00',13.1),('7643','2013-08-31','14:20:00',12.45),('7643','2013-08-31','14:25:00',11.9),('7643','2013-08-31','14:30:00',12.33),('7643','2013-08-31','14:35:00',12.03),('7643','2013-08-31','14:40:00',12.09),('7643','2013-08-31','14:45:00',12.29),('7643','2013-08-31','14:50:00',12.42),('7643','2013-08-31','14:55:00',11.87),('7643','2013-08-31','15:00:00',11.85),('7643','2013-08-31','15:05:00',11.82),('7643','2013-08-31','15:10:00',11.35),('7643','2013-08-31','15:15:00',10.93),('7643','2013-08-31','15:20:00',10.53),('7643','2013-08-31','15:25:00',9.47),('7643','2013-08-31','15:30:00',7.47),('7643','2013-08-31','15:35:00',8.91),('7643','2013-08-31','15:40:00',10.37),('7643','2013-08-31','15:45:00',8.54),('7643','2013-08-31','15:50:00',6.51),('7643','2013-08-31','15:55:00',8.48),('7643','2013-08-31','16:00:00',9.59),('7643','2013-08-31','16:05:00',9.95),('7643','2013-08-31','16:10:00',10.49),('7643','2013-08-31','16:15:00',9.86),('7643','2013-08-31','16:20:00',9.2),('7643','2013-08-31','16:25:00',8.92),('7643','2013-08-31','16:30:00',9.95),('7643','2013-08-31','16:35:00',9.27),('7643','2013-08-31','16:40:00',9.04),('7643','2013-08-31','16:45:00',8.52),('7643','2013-08-31','16:50:00',7.87),('7643','2013-08-31','16:55:00',7.27),('7643','2013-08-31','17:00:00',6.04),('7643','2013-08-31','17:05:00',6.01),('7643','2013-08-31','17:10:00',5.4),('7643','2013-08-31','17:15:00',4.98),('7643','2013-08-31','17:20:00',5.42),('7643','2013-08-31','17:25:00',5.14),('7643','2013-08-31','17:30:00',4.76),('7643','2013-08-31','17:35:00',4.57),('7643','2013-08-31','17:40:00',4.67),('7643','2013-08-31','17:45:00',3.8),('7643','2013-08-31','17:50:00',3.59),('7643','2013-08-31','17:55:00',3.33),('7643','2013-08-31','18:00:00',3.34),('7643','2013-08-31','18:05:00',3.28),('7643','2013-08-31','18:10:00',3.31),('7643','2013-08-31','18:15:00',3.15),('7643','2013-08-31','18:20:00',2.71),('7643','2013-08-31','18:25:00',2.57),('7643','2013-08-31','18:30:00',2.39),('7643','2013-08-31','18:35:00',2.03),('7643','2013-08-31','18:40:00',2.04),('7643','2013-08-31','18:45:00',1.88),('7643','2013-08-31','18:50:00',1.67),('7643','2013-08-31','18:55:00',1.45),('7643','2013-08-31','19:00:00',1.23),('7643','2013-08-31','19:05:00',1.01),('7643','2013-08-30','07:10:00',1.02),('7643','2013-08-30','07:15:00',1.3),('7643','2013-08-30','07:20:00',1.59),('7643','2013-08-30','07:25:00',1.83),('7643','2013-08-30','07:30:00',1.74),('7643','2013-08-30','07:35:00',1.55),('7643','2013-08-30','07:40:00',1.56),('7643','2013-08-30','07:45:00',1.66),('7643','2013-08-30','07:50:00',2.2),('7643','2013-08-30','07:55:00',2.33),('7643','2013-08-30','08:00:00',2.2),('7643','2013-08-30','08:05:00',2.2),('7643','2013-08-30','08:10:00',1.83),('7643','2013-08-30','08:15:00',2.44),('7643','2013-08-30','08:20:00',3.72),('7643','2013-08-30','08:25:00',4.48),('7643','2013-08-30','08:30:00',5.37),('7643','2013-08-30','08:35:00',5.65),('7643','2013-08-30','08:40:00',6.09),('7643','2013-08-30','08:45:00',6.57),('7643','2013-08-30','08:50:00',7.16),('7643','2013-08-30','08:55:00',7.74),('7643','2013-08-30','09:00:00',8.17),('7643','2013-08-30','09:05:00',7.4),('7643','2013-08-30','09:10:00',6.19),('7643','2013-08-30','09:15:00',7.54),('7643','2013-08-30','09:20:00',8.32),('7643','2013-08-30','09:25:00',9.26),('7643','2013-08-30','09:30:00',9.42),('7643','2013-08-30','09:35:00',9.8),('7643','2013-08-30','09:40:00',10.07),('7643','2013-08-30','09:45:00',9.54),('7643','2013-08-30','09:50:00',9.58),('7643','2013-08-30','09:55:00',10.21),('7643','2013-08-30','10:00:00',10.93),('7643','2013-08-30','10:05:00',10.88),('7643','2013-08-30','10:10:00',11.39),('7643','2013-08-30','10:15:00',11.43),('7643','2013-08-30','10:20:00',11.64),('7643','2013-08-30','10:25:00',11.73),('7643','2013-08-30','10:30:00',12.04),('7643','2013-08-30','10:35:00',12.41),('7643','2013-08-30','10:40:00',12.42),('7643','2013-08-30','10:45:00',12.68),('7643','2013-08-30','10:50:00',13.02),('7643','2013-08-30','10:55:00',13.17),('7643','2013-08-30','11:00:00',13.41),('7643','2013-08-30','11:05:00',13.54),('7643','2013-08-30','11:10:00',13.66),('7643','2013-08-30','11:15:00',13.86),('7643','2013-08-30','11:20:00',13.94),('7643','2013-08-30','11:25:00',14.07),('7643','2013-08-30','11:30:00',14.22),('7643','2013-08-30','11:35:00',14.38),('7643','2013-08-30','11:40:00',14.53),('7643','2013-08-30','11:45:00',14.64),('7643','2013-08-30','11:50:00',14.84),('7643','2013-08-30','11:55:00',14.91),('7643','2013-08-30','12:00:00',12.45),('7643','2013-08-30','12:05:00',11.26),('7643','2013-08-30','12:10:00',12.71),('7643','2013-08-30','12:15:00',14.78),('7643','2013-08-30','12:20:00',14.83),('7643','2013-08-30','12:25:00',14.84),('7643','2013-08-30','12:30:00',14.78),('7643','2013-08-30','12:35:00',14.54),('7643','2013-08-30','12:40:00',14.89),('7643','2013-08-30','12:45:00',14.71),('7643','2013-08-30','12:50:00',14.78),('7643','2013-08-30','12:55:00',14.93),('7643','2013-08-30','13:00:00',14.87),('7643','2013-08-30','13:05:00',14.96),('7643','2013-08-30','13:10:00',14.86),('7643','2013-08-30','13:15:00',14.91),('7643','2013-08-30','13:20:00',14.97),('7643','2013-08-30','13:25:00',14.83),('7643','2013-08-30','13:30:00',14.74),('7643','2013-08-30','13:35:00',14.58),('7643','2013-08-30','13:40:00',14.6),('7643','2013-08-30','13:45:00',14.48),('7643','2013-08-30','13:50:00',14.55),('7643','2013-08-30','13:55:00',14.41),('7643','2013-08-30','14:00:00',14.41),('7643','2013-08-30','14:05:00',14.28),('7643','2013-08-30','14:10:00',14.1),('7643','2013-08-30','14:15:00',13.95),('7643','2013-08-30','14:20:00',13.77),('7643','2013-08-30','14:25:00',13.58),('7643','2013-08-30','14:30:00',13.48),('7643','2013-08-30','14:35:00',12.89),('7643','2013-08-30','14:40:00',13.06),('7643','2013-08-30','14:45:00',13.03),('7643','2013-08-30','14:50:00',13.03),('7643','2013-08-30','14:55:00',12.68),('7643','2013-08-30','15:00:00',12.57),('7643','2013-08-30','15:05:00',12.68),('7643','2013-08-30','15:10:00',12.46),('7643','2013-08-30','15:15:00',12.22),('7643','2013-08-30','15:20:00',12),('7643','2013-08-30','15:25:00',11.81),('7643','2013-08-30','15:30:00',11.74),('7643','2013-08-30','15:35:00',11.34),('7643','2013-08-30','15:40:00',11.42),('7643','2013-08-30','15:45:00',11.27),('7643','2013-08-30','15:50:00',10.96),('7643','2013-08-30','15:55:00',10.64),('7643','2013-08-30','16:00:00',10.48),('7643','2013-08-30','16:05:00',10.2),('7643','2013-08-30','16:10:00',10.08),('7643','2013-08-30','16:15:00',9.92),('7643','2013-08-30','16:20:00',9.66),('7643','2013-08-30','16:25:00',9.38),('7643','2013-08-30','16:30:00',8.95),('7643','2013-08-30','16:35:00',8.93),('7643','2013-08-30','16:40:00',8.68),('7643','2013-08-30','16:45:00',8.18),('7643','2013-08-30','16:50:00',7.84),('7643','2013-08-30','16:55:00',7.65),('7643','2013-08-30','17:00:00',7.3),('7643','2013-08-30','17:05:00',7.25),('7643','2013-08-30','17:10:00',6.99),('7643','2013-08-30','17:15:00',6.55),('7643','2013-08-30','17:20:00',6.2),('7643','2013-08-30','17:25:00',5.89),('7643','2013-08-30','17:30:00',5.53),('7643','2013-08-30','17:35:00',5.05),('7643','2013-08-30','17:40:00',4.86),('7643','2013-08-30','17:45:00',4.47),('7643','2013-08-30','17:50:00',4.07),('7643','2013-08-30','17:55:00',3.54),('7643','2013-08-30','18:00:00',2.22),('7643','2013-08-30','18:05:00',2.36),('7643','2013-08-30','18:10:00',2.41),('7643','2013-08-30','18:15:00',2.07),('7643','2013-08-30','18:20:00',2.11),('7643','2013-08-30','18:25:00',1.74),('7643','2013-08-29','07:20:00',1.25),('7643','2013-08-29','07:25:00',1.52),('7643','2013-08-29','07:30:00',1.82),('7643','2013-08-29','07:35:00',2.14),('7643','2013-08-29','07:40:00',2.52),('7643','2013-08-29','07:45:00',2.67),('7643','2013-08-29','07:50:00',2.74),('7643','2013-08-29','07:55:00',2.95),('7643','2013-08-29','08:00:00',3.39),('7643','2013-08-29','08:05:00',4.21),('7643','2013-08-29','08:10:00',4.75),('7643','2013-08-29','08:15:00',4.58),('7643','2013-08-29','08:20:00',4.88),('7643','2013-08-29','08:25:00',5.05),('7643','2013-08-29','08:30:00',5.24),('7643','2013-08-29','08:35:00',5.53),('7643','2013-08-29','08:40:00',5.68),('7643','2013-08-29','08:45:00',5.13),('7643','2013-08-29','08:50:00',4.66),('7643','2013-08-29','08:55:00',4.63),('7643','2013-08-29','09:00:00',5.34),('7643','2013-08-29','09:05:00',5.93),('7643','2013-08-29','09:10:00',5.23),('7643','2013-08-29','09:15:00',4.89),('7643','2013-08-29','09:20:00',4.38),('7643','2013-08-29','09:25:00',4.62),('7643','2013-08-29','09:30:00',5.99),('7643','2013-08-29','09:35:00',6.86),('7643','2013-08-29','09:40:00',6.55),('7643','2013-08-29','09:45:00',6.71),('7643','2013-08-29','09:50:00',6.73),('7643','2013-08-29','09:55:00',7.07),('7643','2013-08-29','10:00:00',7.11),('7643','2013-08-29','10:05:00',7.19),('7643','2013-08-29','10:10:00',7.11),('7643','2013-08-29','10:15:00',7.51),('7643','2013-08-29','10:20:00',8.13),('7643','2013-08-29','10:25:00',7.38),('7643','2013-08-29','10:30:00',8.18),('7643','2013-08-29','10:35:00',7.82),('7643','2013-08-29','10:40:00',7.35),('7643','2013-08-29','10:45:00',7.13),('7643','2013-08-29','10:50:00',7.64),('7643','2013-08-29','10:55:00',7.27),('7643','2013-08-29','11:00:00',7.67),('7643','2013-08-29','11:05:00',8.13),('7643','2013-08-29','11:10:00',8.48),('7643','2013-08-29','11:15:00',8.61),('7643','2013-08-29','11:20:00',8.65),('7643','2013-08-29','11:25:00',8.98),('7643','2013-08-29','11:30:00',9.5),('7643','2013-08-29','11:35:00',9.13),('7643','2013-08-29','11:40:00',9.82),('7643','2013-08-29','11:45:00',9.6),('7643','2013-08-29','11:50:00',11.06),('7643','2013-08-29','11:55:00',9.83),('7643','2013-08-29','12:00:00',8.84),('7643','2013-08-29','12:05:00',7.45),('7643','2013-08-29','12:10:00',8.03),('7643','2013-08-29','12:15:00',8.9),('7643','2013-08-29','12:20:00',9.7),('7643','2013-08-29','12:25:00',10.91),('7643','2013-08-29','12:30:00',12.12),('7643','2013-08-29','12:35:00',11.6),('7643','2013-08-29','12:40:00',11.18),('7643','2013-08-29','12:45:00',11.64),('7643','2013-08-29','12:50:00',11.52),('7643','2013-08-29','12:55:00',10.74),('7643','2013-08-29','13:00:00',10.4),('7643','2013-08-29','13:05:00',10.33),('7643','2013-08-29','13:10:00',10.39),('7643','2013-08-29','13:15:00',9.61),('7643','2013-08-29','13:20:00',11.31),('7643','2013-08-29','13:25:00',13.25),('7643','2013-08-29','13:30:00',14.59),('7643','2013-08-29','13:35:00',13.55),('7643','2013-08-29','13:40:00',14.49),('7643','2013-08-29','13:45:00',12.89),('7643','2013-08-29','13:50:00',12.94),('7643','2013-08-29','13:55:00',14.31),('7643','2013-08-29','14:00:00',14.76),('7643','2013-08-29','14:05:00',14.1),('7643','2013-08-29','14:10:00',14.36),('7643','2013-08-29','14:15:00',14.29),('7643','2013-08-29','14:20:00',14.18),('7643','2013-08-29','14:25:00',14.18),('7643','2013-08-29','14:30:00',14.02),('7643','2013-08-29','14:35:00',14.17),('7643','2013-08-29','14:40:00',13.6),('7643','2013-08-29','14:45:00',10.77),('7643','2013-08-29','14:50:00',9.08),('7643','2013-08-29','14:55:00',10.51),('7643','2013-08-29','15:00:00',9.29),('7643','2013-08-29','15:05:00',8.38),('7643','2013-08-29','15:10:00',8.48),('7643','2013-08-29','15:15:00',10.38),('7643','2013-08-29','15:20:00',9.01),('7643','2013-08-29','15:25:00',7.96),('7643','2013-08-29','15:30:00',7.86),('7643','2013-08-29','15:35:00',6.31),('7643','2013-08-29','15:40:00',6.74),('7643','2013-08-29','15:45:00',7.88),('7643','2013-08-29','15:50:00',8.66),('7643','2013-08-29','15:55:00',8.71),('7643','2013-08-29','16:00:00',8.1),('7643','2013-08-29','16:05:00',7.1),('7643','2013-08-29','16:10:00',5.9),('7643','2013-08-29','16:15:00',5.18),('7643','2013-08-29','16:20:00',5.81),('7643','2013-08-29','16:25:00',5.94),('7643','2013-08-29','16:30:00',5.86),('7643','2013-08-29','16:35:00',4.86),('7643','2013-08-29','16:40:00',8.96),('7643','2013-08-29','16:45:00',8.95),('7643','2013-08-29','16:50:00',8.31),('7643','2013-08-29','16:55:00',5.53),('7643','2013-08-29','17:00:00',6.85),('7643','2013-08-29','17:05:00',4.85),('7643','2013-08-29','17:10:00',5.52),('7643','2013-08-29','17:15:00',5),('7643','2013-08-29','17:20:00',4.29),('7643','2013-08-29','17:25:00',4.22),('7643','2013-08-29','17:30:00',4.63),('7643','2013-08-29','17:35:00',4.24),('7643','2013-08-29','17:40:00',4.74),('7643','2013-08-29','17:45:00',4.99),('7643','2013-08-29','17:50:00',3.49),('7643','2013-08-29','17:55:00',4.53),('7643','2013-08-29','18:00:00',3.69),('7643','2013-08-29','18:05:00',1.67),('7643','2013-08-29','18:10:00',1.13),('7643','2013-08-29','18:15:00',1.05),('7643','2013-08-29','18:20:00',1.12),('7643','2013-08-29','18:25:00',1.12),('7643','2013-08-29','18:30:00',1.01),('7643','2014-04-10','07:40:00',1.78),('7643','2014-04-10','07:45:00',2.52),('7643','2014-04-10','07:50:00',3.42),('7643','2014-04-10','07:55:00',3.78),('7643','2014-04-10','08:00:00',2.54),('7643','2014-04-10','08:05:00',2.04),('7643','2014-04-10','08:10:00',1.49),('7643','2014-04-10','08:15:00',1.56),('7643','2014-04-10','08:20:00',1.61),('7643','2014-04-10','08:25:00',1.58),('7643','2014-04-10','08:30:00',3.88),('7643','2014-04-10','08:35:00',6.26),('7643','2014-04-10','08:40:00',6.98),('7643','2014-04-10','08:45:00',7.63),('7643','2014-04-10','08:50:00',7.88),('7643','2014-04-10','08:55:00',8.12),('7643','2014-04-10','09:00:00',8.36),('7643','2014-04-10','09:05:00',8.61),('7643','2014-04-10','09:10:00',8.8),('7643','2014-04-10','09:15:00',9.14),('7643','2014-04-10','09:20:00',9.52),('7643','2014-04-10','09:25:00',9.86),('7643','2014-04-10','09:30:00',10.12),('7643','2014-04-10','09:35:00',10.38),('7643','2014-04-10','09:40:00',10.74),('7643','2014-04-10','09:45:00',10.92),('7643','2014-04-10','09:50:00',11.23),('7643','2014-04-10','09:55:00',11.42),('7643','2014-04-10','10:00:00',11.77),('7643','2014-04-10','10:05:00',11.95),('7643','2014-04-10','10:10:00',12.47),('7643','2014-04-10','10:15:00',12.69),('7643','2014-04-10','10:20:00',12.82),('7643','2014-04-10','10:25:00',13.12),('7643','2014-04-10','10:30:00',13.31),('7643','2014-04-10','10:35:00',13.52),('7643','2014-04-10','10:40:00',13.63),('7643','2014-04-10','10:45:00',13.83),('7643','2014-04-10','12:00:00',11.25),('7643','2014-04-10','12:05:00',15.78),('7643','2014-04-10','12:10:00',17.07),('7643','2014-04-10','12:15:00',16.43),('7643','2014-04-10','12:20:00',16.54),('7643','2014-04-10','12:25:00',16.82),('7643','2014-04-10','12:30:00',16.7),('7643','2014-04-10','12:35:00',16.97),('7643','2014-04-10','12:40:00',17.53),('7643','2014-04-10','12:45:00',15.44),('7643','2014-04-10','12:50:00',16.14),('7643','2014-04-10','12:55:00',17.39),('7643','2014-04-10','13:00:00',17.44),('7643','2014-04-10','13:05:00',17.14),('7643','2014-04-10','13:10:00',17.22),('7643','2014-04-10','13:15:00',15.9),('7643','2014-04-10','13:20:00',11.74),('7643','2014-04-10','13:25:00',15.3),('7643','2014-04-10','13:30:00',14.54),('7643','2014-04-10','13:35:00',9.94),('7643','2014-04-10','13:40:00',12.58),('7643','2014-04-10','13:45:00',13.8),('7643','2014-04-10','13:50:00',15.65),('7643','2014-04-10','13:55:00',18.17),('7643','2014-04-10','14:00:00',14.52),('7643','2014-04-10','14:05:00',15.01),('7643','2014-04-10','14:10:00',7.73),('7643','2014-04-10','14:15:00',10.28),('7643','2014-04-10','14:20:00',8.58),('7643','2014-04-10','14:25:00',10.44),('7643','2014-04-10','14:30:00',16.41),('7643','2014-04-10','14:35:00',13.81),('7643','2014-04-10','14:40:00',14.99),('7643','2014-04-10','14:45:00',14.3),('7643','2014-04-10','14:50:00',15.64),('7643','2014-04-10','14:55:00',10.7),('7643','2014-04-10','15:00:00',6.88),('7643','2014-04-10','15:05:00',8.98),('7643','2014-04-10','15:10:00',9.45),('7643','2014-04-10','15:15:00',15.21),('7643','2014-04-10','15:20:00',14.46),('7643','2014-04-10','15:25:00',12.84),('7643','2014-04-10','15:30:00',14.22),('7643','2014-04-10','15:35:00',14),('7643','2014-04-10','15:40:00',13.62),('7643','2014-04-10','15:45:00',13.3),('7643','2014-04-10','15:50:00',13.13),('7643','2014-04-10','15:55:00',13.06),('7643','2014-04-10','16:00:00',12.59),('7643','2014-04-10','16:05:00',12.35),('7643','2014-04-10','16:10:00',12.09),('7643','2014-04-10','16:15:00',11.69),('7643','2014-04-10','16:20:00',11.37),('7643','2014-04-10','16:25:00',11.14),('7643','2014-04-10','16:30:00',10.87),('7643','2014-04-10','16:35:00',10.01),('7643','2014-04-10','16:40:00',9.32),('7643','2014-04-10','16:45:00',10.05),('7643','2014-04-10','16:50:00',9.71),('7643','2014-04-10','16:55:00',6.21),('7643','2014-04-10','17:00:00',8.89),('7643','2014-04-10','17:05:00',5.6),('7643','2014-04-10','17:10:00',7.43),('7643','2014-04-10','17:15:00',6.1),('7643','2014-04-10','17:20:00',6.7),('7643','2014-04-10','17:25:00',7.29),('7643','2014-04-10','17:30:00',7.3),('7643','2014-04-10','17:35:00',7.11),('7643','2014-04-10','17:40:00',6.72),('7643','2014-04-10','17:45:00',6.07),('7643','2014-04-10','17:50:00',5.51),('7643','2014-04-10','17:55:00',5.01),('7643','2014-04-10','18:00:00',4.47),('7643','2014-04-10','18:05:00',4),('7643','2014-04-10','18:10:00',3.67),('7643','2014-04-10','18:15:00',3.51),('7643','2014-04-10','18:20:00',3.25),('7643','2014-04-10','18:25:00',2.91),('7643','2014-04-10','18:30:00',3.03),('7643','2014-04-10','18:35:00',2.81),('7643','2014-04-10','18:40:00',2.43),('7643','2014-04-10','18:45:00',2.02),('7643','2014-04-10','18:50:00',1.76),('7643','2014-04-10','18:55:00',1.48),('7643','2014-04-10','19:00:00',1.06),('7643','2013-08-28','07:20:00',1.01),('7643','2013-08-28','07:25:00',1.37),('7643','2013-08-28','07:30:00',1.77),('7643','2013-08-28','07:35:00',2.11),('7643','2013-08-28','07:40:00',2.43),('7643','2013-08-28','07:45:00',2.65),('7643','2013-08-28','07:50:00',2.92),('7643','2013-08-28','07:55:00',3.25),('7643','2013-08-28','08:00:00',3.67),('7643','2013-08-28','08:05:00',3.97),('7643','2013-08-28','08:10:00',4.45),('7643','2013-08-28','08:15:00',4.91),('7643','2013-08-28','08:20:00',5.5),('7643','2013-08-28','08:25:00',6.19),('7643','2013-08-28','08:30:00',6.98),('7643','2013-08-28','08:35:00',6.76),('7643','2013-08-28','08:40:00',5.23),('7643','2013-08-28','08:45:00',3.95),('7643','2013-08-28','08:50:00',4.61),('7643','2013-08-28','08:55:00',6.24),('7643','2013-08-28','09:00:00',6.05),('7643','2013-08-28','09:05:00',5.91),('7643','2013-08-28','09:10:00',5.77),('7643','2013-08-28','09:15:00',6.13),('7643','2013-08-28','09:20:00',6.06),('7643','2013-08-28','09:25:00',5.49),('7643','2013-08-28','09:30:00',5.68),('7643','2013-08-28','09:35:00',6.22),('7643','2013-08-28','09:40:00',6.21),('7643','2013-08-28','09:45:00',5.58),('7643','2013-08-28','09:50:00',5.34),('7643','2013-08-28','09:55:00',5.6),('7643','2013-08-28','10:00:00',5.98),('7643','2013-08-28','10:05:00',5.63),('7643','2013-08-28','10:10:00',5.5),('7643','2013-08-28','10:15:00',5.44),('7643','2013-08-28','10:20:00',5.49),('7643','2013-08-28','10:25:00',5.56),('7643','2013-08-28','10:30:00',5.69),('7643','2013-08-28','10:35:00',5.36),('7643','2013-08-28','10:40:00',4.96),('7643','2013-08-28','10:45:00',4.58),('7643','2013-08-28','10:50:00',4.49),('7643','2013-08-28','10:55:00',4.95),('7643','2013-08-28','11:00:00',5.32),('7643','2013-08-28','11:05:00',5.36),('7643','2013-08-28','11:10:00',8.02),('7643','2013-08-28','11:15:00',10.09),('7643','2013-08-28','11:20:00',9.57),('7643','2013-08-28','11:25:00',6.81),('7643','2013-08-28','11:30:00',5.84),('7643','2013-08-28','11:35:00',5.08),('7643','2013-08-28','11:40:00',5.61),('7643','2013-08-28','11:45:00',6.65),('7643','2013-08-28','11:50:00',7.01),('7643','2013-08-28','11:55:00',6.73),('7643','2013-08-28','12:00:00',6.73),('7643','2013-08-28','12:05:00',8),('7643','2013-08-28','12:10:00',9.35),('7643','2013-08-28','12:15:00',11.26),('7643','2013-08-28','12:20:00',9.59),('7643','2013-08-28','12:25:00',9.96),('7643','2013-08-28','12:30:00',10.14),('7643','2013-08-28','12:35:00',12.47),('7643','2013-08-28','12:40:00',16.55),('7643','2013-08-28','12:45:00',16.65),('7643','2013-08-28','12:50:00',10.47),('7643','2013-08-28','12:55:00',14.61),('7643','2013-08-28','13:00:00',10.42),('7643','2013-08-28','13:05:00',9.07),('7643','2013-08-28','13:10:00',8.98),('7643','2013-08-28','13:15:00',8.75),('7643','2013-08-28','13:20:00',8.47),('7643','2013-08-28','13:25:00',7.4),('7643','2013-08-28','13:30:00',6.72),('7643','2013-08-28','13:35:00',6.25),('7643','2013-08-28','13:40:00',5.91),('7643','2013-08-28','13:45:00',5.59),('7643','2013-08-28','13:50:00',5.47),('7643','2013-08-28','13:55:00',6.24),('7643','2013-08-28','14:00:00',8.26),('7643','2013-08-28','14:05:00',6.39),('7643','2013-08-28','14:10:00',5.68),('7643','2013-08-28','14:15:00',4.79),('7643','2013-08-28','14:20:00',3.8),('7643','2013-08-28','14:25:00',3.33),('7643','2013-08-28','14:30:00',3.07),('7643','2013-08-28','14:35:00',3.09),('7643','2013-08-28','14:40:00',3.14),('7643','2013-08-28','14:45:00',3.45),('7643','2013-08-28','14:50:00',4.06),('7643','2013-08-28','14:55:00',4.82),('7643','2013-08-28','15:00:00',5.42),('7643','2013-08-28','15:05:00',6.13),('7643','2013-08-28','15:10:00',5.11),('7643','2013-08-28','15:15:00',4.23),('7643','2013-08-28','15:20:00',4.48),('7643','2013-08-28','15:25:00',5.13),('7643','2013-08-28','15:30:00',8.14),('7643','2013-08-28','15:35:00',8.94),('7643','2013-08-28','15:40:00',7.75),('7643','2013-08-28','15:45:00',9.39),('7643','2013-08-28','15:50:00',10.76),('7643','2013-08-28','15:55:00',11.53),('7643','2013-08-28','16:00:00',12.19),('7643','2013-08-28','16:05:00',12.03),('7643','2013-08-28','16:10:00',11.99),('7643','2013-08-28','16:15:00',11.06),('7643','2013-08-28','16:20:00',10.47),('7643','2013-08-28','16:25:00',10.03),('7643','2013-08-28','16:30:00',9.73),('7643','2013-08-28','16:35:00',9.44),('7643','2013-08-28','16:40:00',9.16),('7643','2013-08-28','16:45:00',8.85),('7643','2013-08-28','16:50:00',8.55),('7643','2013-08-28','16:55:00',8.26),('7643','2013-08-28','17:00:00',8),('7643','2013-08-28','17:05:00',7.68),('7643','2013-08-28','17:10:00',7.35),('7643','2013-08-28','17:15:00',6.99),('7643','2013-08-28','17:20:00',6.67),('7643','2013-08-28','17:25:00',6.4),('7643','2013-08-28','17:30:00',6.03),('7643','2013-08-28','17:35:00',5.69),('7643','2013-08-28','17:40:00',5.34),('7643','2013-08-28','17:45:00',4.96),('7643','2013-08-28','17:50:00',4.62),('7643','2013-08-28','17:55:00',4.28),('7643','2013-08-28','18:00:00',3.92),('7643','2013-08-28','18:05:00',3.58),('7643','2013-08-28','18:10:00',3.2),('7643','2013-08-28','18:15:00',2.93),('7643','2013-08-28','18:20:00',2.58),('7643','2013-08-28','18:25:00',2.29),('7643','2013-08-28','18:30:00',2.01),('7643','2013-08-28','18:35:00',1.69),('7643','2013-08-28','18:40:00',1.44),('7643','2013-08-28','18:45:00',1.25),('7643','2013-08-27','07:35:00',1.91),('7643','2013-08-27','07:40:00',2.26),('7643','2013-08-27','07:45:00',1.94),('7643','2013-08-27','07:50:00',2.85),('7643','2013-08-27','07:55:00',3.24),('7643','2013-08-27','08:00:00',3.44),('7643','2013-08-27','08:05:00',3.84),('7643','2013-08-27','08:10:00',4.15),('7643','2013-08-27','08:15:00',4.5),('7643','2013-08-27','08:20:00',4.84),('7643','2013-08-27','08:25:00',5.04),('7643','2013-08-27','08:30:00',5.42),('7643','2013-08-27','08:35:00',6.06),('7643','2013-08-27','08:40:00',3.82),('7643','2013-08-27','08:45:00',4.43),('7643','2013-08-27','08:50:00',5.64),('7643','2013-08-27','08:55:00',3.33),('7643','2013-08-27','09:00:00',6.6),('7643','2013-08-27','09:05:00',5.04),('7643','2013-08-27','09:10:00',4.6),('7643','2013-08-27','09:15:00',7.04),('7643','2013-08-27','09:20:00',4.09),('7643','2013-08-27','09:25:00',2.77),('7643','2013-08-27','09:30:00',2.98),('7643','2013-08-27','09:35:00',8.33),('7643','2013-08-27','09:40:00',10.01),('7643','2013-08-27','09:45:00',10.12),('7643','2013-08-27','09:50:00',10.4),('7643','2013-08-27','09:55:00',10.42),('7643','2013-08-27','10:00:00',10.51),('7643','2013-08-27','10:05:00',10.76),('7643','2013-08-27','10:10:00',11.29),('7643','2013-08-27','10:15:00',9.1),('7643','2013-08-27','10:20:00',11.2),('7643','2013-08-27','10:25:00',12.3),('7643','2013-08-27','10:30:00',6.64),('7643','2013-08-27','10:35:00',4.94),('7643','2013-08-27','10:40:00',6.56),('7643','2013-08-27','10:45:00',9.65),('7643','2013-08-27','10:50:00',13.35),('7643','2013-08-27','10:55:00',13.76),('7643','2013-08-27','11:00:00',8.15),('7643','2013-08-27','11:05:00',9.88),('7643','2013-08-27','11:10:00',14.75),('7643','2013-08-27','11:15:00',9.43),('7643','2013-08-27','11:20:00',14.85),('7643','2013-08-27','11:25:00',14.44),('7643','2013-08-27','11:30:00',14.56),('7643','2013-08-27','11:35:00',14.89),('7643','2013-08-27','11:40:00',15.44),('7643','2013-08-27','11:45:00',15.76),('7643','2013-08-27','11:50:00',13.09),('7643','2013-08-27','11:55:00',12.05),('7643','2013-08-27','12:00:00',6.26),('7643','2013-08-27','12:05:00',16.42),('7643','2013-08-27','12:10:00',15.64),('7643','2013-08-27','12:15:00',9.56),('7643','2013-08-27','12:20:00',15.65),('7643','2013-08-27','12:25:00',15.54),('7643','2013-08-27','12:30:00',15.31),('7643','2013-08-27','12:35:00',15.28),('7643','2013-08-27','12:40:00',15.41),('7643','2013-08-27','12:45:00',15.07),('7643','2013-08-27','12:50:00',15.78),('7643','2013-08-27','12:55:00',15.68),('7643','2013-08-27','13:00:00',15.75),('7643','2013-08-27','13:05:00',16.08),('7643','2013-08-27','13:10:00',16.05),('7643','2013-08-27','13:15:00',16),('7643','2013-08-27','13:20:00',15.66),('7643','2013-08-27','13:25:00',15.57),('7643','2013-08-27','13:30:00',13.05),('7643','2013-08-27','13:35:00',15.68),('7643','2013-08-27','13:40:00',13.06),('7643','2013-08-27','13:45:00',15.17),('7643','2013-08-27','13:50:00',15.69),('7643','2013-08-27','13:55:00',13.33),('7643','2013-08-27','14:00:00',14.81),('7643','2013-08-27','14:05:00',15.37),('7643','2013-08-27','14:10:00',14),('7643','2013-08-27','14:15:00',14.94),('7643','2013-08-27','14:20:00',15.03),('7643','2013-08-27','14:25:00',14.91),('7643','2013-08-27','14:30:00',14.8),('7643','2013-08-27','14:35:00',13.74),('7643','2013-08-27','14:40:00',15.32),('7643','2013-08-27','14:45:00',14.53),('7643','2013-08-27','14:50:00',14.27),('7643','2013-08-27','14:55:00',14.16),('7643','2013-08-27','15:00:00',13.98),('7643','2013-08-27','15:05:00',11.94),('7643','2013-08-27','15:10:00',12.71),('7643','2013-08-27','15:15:00',13.95),('7643','2013-08-27','15:20:00',13.67),('7643','2013-08-27','15:25:00',12.96),('7643','2013-08-27','15:30:00',8.96),('7643','2013-08-27','15:35:00',13.11),('7643','2013-08-27','15:40:00',8.96),('7643','2013-08-27','15:45:00',3.54),('7643','2013-08-27','15:50:00',5.11),('7643','2013-08-27','15:55:00',9.51),('7643','2013-08-27','16:00:00',12.51),('7643','2013-08-27','16:05:00',7.97),('7643','2013-08-27','16:10:00',11.49),('7643','2013-08-27','16:15:00',11.41),('7643','2013-08-27','16:20:00',6.43),('7643','2013-08-27','16:25:00',11.43),('7643','2013-08-27','16:30:00',9.55),('7643','2013-08-27','16:35:00',10.28),('7643','2013-08-27','16:40:00',9.97),('7643','2013-08-27','16:45:00',9.41),('7643','2013-08-27','16:50:00',8.98),('7643','2013-08-27','16:55:00',8.46),('7643','2013-08-27','17:00:00',8.51),('7643','2013-08-27','17:05:00',7.94),('7643','2013-08-27','17:10:00',7.7),('7643','2013-08-27','17:15:00',7.74),('7643','2013-08-27','17:20:00',4.48),('7643','2013-08-27','17:25:00',6.13),('7643','2013-08-27','17:30:00',6.5),('7643','2013-08-27','17:35:00',4.89),('7643','2013-08-27','17:40:00',6),('7643','2013-08-27','17:45:00',3.9),('7643','2013-08-27','17:50:00',1.26),('7643','2013-08-27','17:55:00',2.06),('7643','2013-08-27','18:00:00',2.38),('7643','2013-08-27','18:05:00',2.1),('7643','2013-08-27','18:10:00',2.66),('7643','2013-08-27','18:15:00',3.38),('7643','2013-08-27','18:20:00',1.73),('7643','2013-08-27','18:25:00',2.74),('7643','2013-08-27','18:30:00',1.14),('7643','2013-08-27','18:50:00',1.5),('7643','2013-08-27','18:55:00',1.27),('7643','2013-08-27','19:00:00',1.29),('7643','2013-08-26','07:40:00',1.06),('7643','2013-08-26','07:45:00',1.25),('7643','2013-08-26','07:50:00',1.35),('7643','2013-08-26','07:55:00',1.46),('7643','2013-08-26','08:00:00',1.58),('7643','2013-08-26','08:05:00',1.94),('7643','2013-08-26','08:10:00',2.36),('7643','2013-08-26','08:15:00',2.97),('7643','2013-08-26','08:20:00',4.26),('7643','2013-08-26','08:25:00',5.71),('7643','2013-08-26','08:30:00',5.8),('7643','2013-08-26','08:35:00',4.01),('7643','2013-08-26','08:40:00',3.67),('7643','2013-08-26','08:45:00',4.62),('7643','2013-08-26','08:50:00',3.31),('7643','2013-08-26','08:55:00',3),('7643','2013-08-26','09:00:00',3.53),('7643','2013-08-26','09:05:00',3.76),('7643','2013-08-26','09:10:00',4.97),('7643','2013-08-26','09:15:00',4.93),('7643','2013-08-26','09:20:00',5.73),('7643','2013-08-26','09:25:00',7.58),('7643','2013-08-26','09:30:00',8.23),('7643','2013-08-26','09:35:00',4.99),('7643','2013-08-26','09:40:00',3.77),('7643','2013-08-26','09:45:00',3.85),('7643','2013-08-26','09:50:00',4.04),('7643','2013-08-26','09:55:00',5.26),('7643','2013-08-26','10:00:00',7),('7643','2013-08-26','10:05:00',8.89),('7643','2013-08-26','10:10:00',10.77),('7643','2013-08-26','10:15:00',11.13),('7643','2013-08-26','10:20:00',11.46),('7643','2013-08-26','10:25:00',11.53),('7643','2013-08-26','10:30:00',11.68),('7643','2013-08-26','10:35:00',11.89),('7643','2013-08-26','10:40:00',11.78),('7643','2013-08-26','10:45:00',12),('7643','2013-08-26','10:50:00',12.41),('7643','2013-08-26','10:55:00',12.38),('7643','2013-08-26','11:00:00',12.56),('7643','2013-08-26','11:05:00',12.83),('7643','2013-08-26','11:10:00',12.8),('7643','2013-08-26','11:15:00',12.62),('7643','2013-08-26','11:20:00',12.63),('7643','2013-08-26','11:25:00',12.62),('7643','2013-08-26','11:30:00',12.86),('7643','2013-08-26','11:35:00',13.22),('7643','2013-08-26','11:40:00',12.85),('7643','2013-08-26','11:45:00',15.78),('7643','2013-08-26','11:50:00',10.87),('7643','2013-08-26','11:55:00',14.41),('7643','2013-08-26','12:00:00',15.81),('7643','2013-08-26','12:05:00',14.37),('7643','2013-08-26','12:10:00',13.05),('7643','2013-08-26','12:15:00',13.26),('7643','2013-08-26','12:20:00',13.99),('7643','2013-08-26','12:25:00',13.4),('7643','2013-08-26','12:30:00',13.66),('7643','2013-08-26','12:35:00',11.98),('7643','2013-08-26','12:40:00',15.6),('7643','2013-08-26','12:45:00',11.61),('7643','2013-08-26','12:50:00',9.01),('7643','2013-08-26','12:55:00',8.65),('7643','2013-08-26','13:00:00',5.15),('7643','2013-08-26','13:05:00',6.99),('7643','2013-08-26','13:10:00',8.15),('7643','2013-08-26','13:15:00',10.54),('7643','2013-08-26','13:20:00',8.26),('7643','2013-08-26','13:25:00',6.55),('7643','2013-08-26','13:30:00',8.51),('7643','2013-08-26','13:35:00',6.86),('7643','2013-08-26','13:40:00',8.32),('7643','2013-08-26','13:45:00',10.38),('7643','2013-08-26','13:50:00',14.91),('7643','2013-08-26','13:55:00',12.13),('7643','2013-08-26','14:00:00',16.32),('7643','2013-08-26','14:05:00',10.5),('7643','2013-08-26','14:10:00',6.52),('7643','2013-08-26','14:15:00',8.7),('7643','2013-08-26','14:20:00',9.45),('7643','2013-08-26','14:25:00',5.19),('7643','2013-08-26','14:30:00',3.79),('7643','2013-08-26','14:35:00',4.13),('7643','2013-08-26','14:40:00',4.36),('7643','2013-08-26','14:45:00',4.57),('7643','2013-08-26','14:50:00',3.52),('7643','2013-08-26','14:55:00',2.63),('7643','2013-08-26','15:00:00',2.67),('7643','2013-08-26','15:05:00',2.42),('7643','2013-08-26','15:10:00',2.14),('7643','2013-08-26','15:15:00',2.41),('7643','2013-08-26','15:20:00',2.44),('7643','2013-08-26','15:25:00',2),('7643','2013-08-26','15:30:00',2.02),('7643','2013-08-26','15:35:00',2.11),('7643','2013-08-26','15:40:00',1.78),('7643','2013-08-26','15:45:00',1.58),('7643','2013-08-26','15:50:00',1.57),('7643','2013-08-26','15:55:00',3.63),('7643','2013-08-26','16:00:00',4.85),('7643','2013-08-26','16:05:00',4.95),('7643','2013-08-26','16:10:00',11.89),('7643','2013-08-26','16:15:00',9.89),('7643','2013-08-26','16:20:00',7.94),('7643','2013-08-26','16:25:00',6.58),('7643','2013-08-26','16:30:00',4.02),('7643','2013-08-26','16:35:00',3.73),('7643','2013-08-26','16:40:00',3.47),('7643','2013-08-26','16:45:00',3.39),('7643','2013-08-26','16:50:00',4.06),('7643','2013-08-26','16:55:00',4.66),('7643','2013-08-26','17:00:00',2.33),('7643','2013-08-26','17:05:00',3.82),('7643','2013-08-26','17:10:00',9.43),('7643','2013-08-26','17:15:00',4.73),('7643','2013-08-26','17:20:00',3.23),('7643','2013-08-26','17:25:00',3.17),('7643','2013-08-26','17:30:00',2.46),('7643','2013-08-26','17:35:00',3.13),('7643','2013-08-26','17:40:00',3.17),('7643','2013-08-26','17:45:00',4.22),('7643','2013-08-26','17:50:00',5.28),('7643','2013-08-26','17:55:00',5.27),('7643','2013-08-26','18:00:00',4.46),('7643','2013-08-26','18:05:00',3.41),('7643','2013-08-26','18:10:00',1.22),('7643','2013-08-26','18:15:00',1.39),('7643','2013-08-25','07:20:00',1.4),('7643','2013-08-25','07:25:00',1.91),('7643','2013-08-25','07:30:00',1.89),('7643','2013-08-25','07:35:00',1.61),('7643','2013-08-25','07:40:00',2.12),('7643','2013-08-25','07:45:00',1.9),('7643','2013-08-25','07:50:00',1.62),('7643','2013-08-25','07:55:00',3.16),('7643','2013-08-25','08:00:00',3.01),('7643','2013-08-25','08:05:00',4.85),('7643','2013-08-25','08:10:00',5.19),('7643','2013-08-25','08:15:00',2.96),('7643','2013-08-25','08:20:00',5.75),('7643','2013-08-25','08:25:00',5.07),('7643','2013-08-25','08:30:00',5.91),('7643','2013-08-25','08:35:00',5.13),('7643','2013-08-25','08:40:00',6.08),('7643','2013-08-25','08:45:00',6.42),('7643','2013-08-25','08:50:00',6.65),('7643','2013-08-25','08:55:00',6.96),('7643','2013-08-25','09:00:00',7.28),('7643','2013-08-25','09:05:00',7.6),('7643','2013-08-25','09:10:00',7.92),('7643','2013-08-25','09:15:00',8.17),('7643','2013-08-25','09:20:00',8.29),('7643','2013-08-25','09:25:00',7.31),('7643','2013-08-25','09:30:00',8.46),('7643','2013-08-25','09:35:00',9.15),('7643','2013-08-25','09:40:00',9.43),('7643','2013-08-25','09:45:00',9.59),('7643','2013-08-25','09:50:00',9.91),('7643','2013-08-25','09:55:00',10.22),('7643','2013-08-25','10:00:00',10.22),('7643','2013-08-25','10:05:00',10.49),('7643','2013-08-25','10:10:00',10.74),('7643','2013-08-25','10:15:00',11.01),('7643','2013-08-25','10:20:00',11.16),('7643','2013-08-25','10:25:00',11.45),('7643','2013-08-25','10:30:00',11.59),('7643','2013-08-25','10:35:00',11.64),('7643','2013-08-25','10:40:00',11.88),('7643','2013-08-25','10:45:00',12.23),('7643','2013-08-25','10:50:00',12.35),('7643','2013-08-25','10:55:00',12.5),('7643','2013-08-25','11:00:00',12.71),('7643','2013-08-25','11:05:00',12.77),('7643','2013-08-25','11:10:00',12.8),('7643','2013-08-25','11:15:00',13.08),('7643','2013-08-25','11:20:00',13.16),('7643','2013-08-25','11:25:00',13.13),('7643','2013-08-25','11:30:00',13.34),('7643','2013-08-25','11:35:00',13.56),('7643','2013-08-25','11:40:00',13.64),('7643','2013-08-25','11:45:00',13.74),('7643','2013-08-25','11:50:00',13.9),('7643','2013-08-25','11:55:00',14.05),('7643','2013-08-25','12:00:00',14.09),('7643','2013-08-25','12:05:00',14.15),('7643','2013-08-25','12:10:00',14.22),('7643','2013-08-25','12:15:00',14.28),('7643','2013-08-25','12:20:00',14.3),('7643','2013-08-25','12:25:00',14.15),('7643','2013-08-25','12:30:00',14.11),('7643','2013-08-25','12:35:00',14.2),('7643','2013-08-25','12:40:00',14.4),('7643','2013-08-25','12:45:00',14.49),('7643','2013-08-25','12:50:00',14.52),('7643','2013-08-25','12:55:00',14.61),('7643','2013-08-25','13:00:00',15.18),('7643','2013-08-25','13:05:00',15.12),('7643','2013-08-25','13:10:00',14.17),('7643','2013-08-25','13:15:00',7.63),('7643','2013-08-25','13:20:00',7.68),('7643','2013-08-25','13:25:00',11.85),('7643','2013-08-25','13:30:00',10.72),('7643','2013-08-25','13:35:00',13.71),('7643','2013-08-25','13:40:00',14.72),('7643','2013-08-25','13:45:00',14.59),('7643','2013-08-25','13:50:00',14.64),('7643','2013-08-25','13:55:00',11.07),('7643','2013-08-25','14:00:00',10.83),('7643','2013-08-25','14:05:00',12.48),('7643','2013-08-25','14:10:00',8.92),('7643','2013-08-25','14:15:00',13.67),('7643','2013-08-25','14:20:00',14.04),('7643','2013-08-25','14:25:00',13.87),('7643','2013-08-25','14:30:00',14.01),('7643','2013-08-25','14:35:00',13.13),('7643','2013-08-25','14:40:00',11.83),('7643','2013-08-25','14:45:00',9),('7643','2013-08-25','14:50:00',8.13),('7643','2013-08-25','14:55:00',7.4),('7643','2013-08-25','15:00:00',7.12),('7643','2013-08-25','15:05:00',5.03),('7643','2013-08-25','15:10:00',3.86),('7643','2013-08-25','15:15:00',3.36),('7643','2013-08-25','15:20:00',2.75),('7643','2013-08-25','15:25:00',2.53),('7643','2013-08-25','15:30:00',2.73),('7643','2013-08-25','15:35:00',3.5),('7643','2013-08-25','15:40:00',5.75),('7643','2013-08-25','15:45:00',6.27),('7643','2013-08-25','15:50:00',6.04),('7643','2013-08-25','15:55:00',5.67),('7643','2013-08-25','16:00:00',9.6),('7643','2013-08-25','16:05:00',12.01),('7643','2013-08-25','16:10:00',10.62),('7643','2013-08-25','16:15:00',9.87),('7643','2013-08-25','16:20:00',9.8),('7643','2013-08-25','16:25:00',9.46),('7643','2013-08-25','16:30:00',9.14),('7643','2013-08-25','16:35:00',8.92),('7643','2013-08-25','16:40:00',8.63),('7643','2013-08-25','16:45:00',8.61),('7643','2013-08-25','16:50:00',7.93),('7643','2013-08-25','16:55:00',7.69),('7643','2013-08-25','17:00:00',7.59),('7643','2013-08-25','17:05:00',6.97),('7643','2013-08-25','17:10:00',6.93),('7643','2013-08-25','17:15:00',6.6),('7643','2013-08-25','17:20:00',4.64),('7643','2013-08-25','17:25:00',2.08),('7643','2013-08-25','17:30:00',4.38),('7643','2013-08-25','17:35:00',3.65),('7643','2013-08-25','17:40:00',3.56),('7643','2013-08-25','17:45:00',4.42),('7643','2013-08-25','17:50:00',4.75),('7643','2013-08-25','17:55:00',4.83),('7643','2013-08-25','18:00:00',4.17),('7643','2013-08-25','18:05:00',3.6),('7643','2013-08-25','18:10:00',3.18),('7643','2013-08-25','18:15:00',2.76),('7643','2013-08-25','18:20:00',2.48),('7643','2013-08-25','18:25:00',2.27),('7643','2013-08-25','18:30:00',1.97),('7643','2013-08-25','18:35:00',1.74),('7643','2013-08-25','18:40:00',1.56),('7643','2013-08-25','18:45:00',1.35),('7643','2013-08-25','18:50:00',1.12),('7643','2013-08-24','07:15:00',1.02),('7643','2013-08-24','07:20:00',1.17),('7643','2013-08-24','07:25:00',1.36),('7643','2013-08-24','07:30:00',1.61),('7643','2013-08-24','07:35:00',1.69),('7643','2013-08-24','07:40:00',1.94),('7643','2013-08-24','07:45:00',2.13),('7643','2013-08-24','07:50:00',2.54),('7643','2013-08-24','07:55:00',2.9),('7643','2013-08-24','08:00:00',3.18),('7643','2013-08-24','08:05:00',3.64),('7643','2013-08-24','08:10:00',4.33),('7643','2013-08-24','08:15:00',4.16),('7643','2013-08-24','08:20:00',4.22),('7643','2013-08-24','08:25:00',4.42),('7643','2013-08-24','08:30:00',3.03),('7643','2013-08-24','08:35:00',3.05),('7643','2013-08-24','08:40:00',4.14),('7643','2013-08-24','08:45:00',5.44),('7643','2013-08-24','08:50:00',2.41),('7643','2013-08-24','08:55:00',3.62),('7643','2013-08-24','09:00:00',1.67),('7643','2013-08-24','09:05:00',2.23),('7643','2013-08-24','09:10:00',3.8),('7643','2013-08-24','09:15:00',3.94),('7643','2013-08-24','09:20:00',7.44),('7643','2013-08-24','09:25:00',7.74),('7643','2013-08-24','09:30:00',5.09),('7643','2013-08-24','09:35:00',6.75),('7643','2013-08-24','09:40:00',11.11),('7643','2013-08-24','09:45:00',11.67),('7643','2013-08-24','09:50:00',10.91),('7643','2013-08-24','09:55:00',11.72),('7643','2013-08-24','10:00:00',8.92),('7643','2013-08-24','10:05:00',6.24),('7643','2013-08-24','10:10:00',3.54),('7643','2013-08-24','10:15:00',2.61),('7643','2013-08-24','10:20:00',2.58),('7643','2013-08-24','10:25:00',1.93),('7643','2013-08-24','10:30:00',1.39),('7643','2013-08-24','10:35:00',1.14),('7643','2013-08-24','14:50:00',1.03),('7643','2013-08-24','14:55:00',1.75),('7643','2013-08-24','15:00:00',2.48),('7643','2013-08-24','15:05:00',3.16),('7643','2013-08-24','15:10:00',3.5),('7643','2013-08-24','15:15:00',4.14),('7643','2013-08-24','15:20:00',5.01),('7643','2013-08-24','15:25:00',5.54),('7643','2013-08-24','15:30:00',7.62),('7643','2013-08-24','15:35:00',11.69),('7643','2013-08-24','15:40:00',13.45),('7643','2013-08-24','15:45:00',13.82),('7643','2013-08-24','15:50:00',9.07),('7643','2013-08-24','15:55:00',10.82),('7643','2013-08-24','16:00:00',12.4),('7643','2013-08-24','16:05:00',11.77),('7643','2013-08-24','16:10:00',11.22),('7643','2013-08-24','16:15:00',10.81),('7643','2013-08-24','16:20:00',10.43),('7643','2013-08-24','16:25:00',10.3),('7643','2013-08-24','16:30:00',10),('7643','2013-08-24','16:40:00',5.95),('7643','2013-08-24','16:45:00',4.58),('7643','2013-08-24','16:50:00',6.8),('7643','2013-08-24','16:55:00',9.81),('7643','2013-08-24','17:00:00',8.93),('7643','2013-08-24','17:05:00',8.34),('7643','2013-08-24','17:10:00',7.87),('7643','2013-08-24','17:15:00',7.21),('7643','2013-08-24','17:20:00',6.84),('7643','2013-08-24','17:25:00',6.45),('7643','2013-08-24','17:30:00',6.1),('7643','2013-08-24','17:35:00',5.43),('7643','2013-08-24','17:40:00',4.64),('7643','2013-08-24','17:45:00',5.18),('7643','2013-08-24','17:50:00',4.61),('7643','2013-08-24','17:55:00',4),('7643','2013-08-24','18:00:00',2.97),('7643','2013-08-24','18:05:00',2.74),('7643','2013-08-24','18:10:00',3.06),('7643','2013-08-24','18:15:00',3.19),('7643','2013-08-24','18:20:00',2.99),('7643','2013-08-24','18:25:00',2.68),('7643','2013-08-24','18:30:00',2.17),('7643','2013-08-24','18:35:00',1.62),('7643','2013-08-24','18:40:00',1.05),('7643','2013-08-23','07:20:00',1.19),('7643','2013-08-23','07:25:00',1.36),('7643','2013-08-23','07:30:00',1.57),('7643','2013-08-23','07:35:00',1.79),('7643','2013-08-23','07:40:00',2.04),('7643','2013-08-23','07:45:00',2.32),('7643','2013-08-23','07:50:00',2.45),('7643','2013-08-23','07:55:00',1.82),('7643','2013-08-23','08:00:00',2.26),('7643','2013-08-23','08:05:00',2.82),('7643','2013-08-23','08:10:00',2.78),('7643','2013-08-23','08:15:00',2.9),('7643','2013-08-23','08:20:00',2.23),('7643','2013-08-23','08:25:00',4.07),('7643','2013-08-23','08:30:00',4.93),('7643','2013-08-23','08:35:00',5.08),('7643','2013-08-23','08:40:00',5.5),('7643','2013-08-23','08:45:00',5.98),('7643','2013-08-23','08:50:00',5.58),('7643','2013-08-23','08:55:00',6.5),('7643','2013-08-23','09:00:00',6.92),('7643','2013-08-23','09:05:00',7),('7643','2013-08-23','09:10:00',5.72),('7643','2013-08-23','09:15:00',7.6),('7643','2013-08-23','09:20:00',8.58),('7643','2013-08-23','09:25:00',8.23),('7643','2013-08-23','09:30:00',6.62),('7643','2013-08-23','09:35:00',9.38),('7643','2013-08-23','09:40:00',9.58),('7643','2013-08-23','09:45:00',6.13),('7643','2013-08-23','09:50:00',9.18),('7643','2013-08-23','09:55:00',3.59),('7643','2013-08-23','10:00:00',5),('7643','2013-08-23','10:05:00',9.23),('7643','2013-08-23','10:10:00',10.62),('7643','2013-08-23','10:15:00',10.7),('7643','2013-08-23','10:20:00',11.09),('7643','2013-08-23','10:25:00',11.21),('7643','2013-08-23','10:30:00',11.37),('7643','2013-08-23','10:35:00',11.57),('7643','2013-08-23','10:40:00',11.73),('7643','2013-08-23','10:45:00',11.96),('7643','2013-08-23','10:50:00',10.35),('7643','2013-08-23','10:55:00',12.47),('7643','2013-08-23','11:00:00',12.31),('7643','2013-08-23','11:05:00',12.37),('7643','2013-08-23','11:10:00',12.94),('7643','2013-08-23','11:15:00',12.86),('7643','2013-08-23','11:20:00',12.86),('7643','2013-08-23','11:25:00',13.01),('7643','2013-08-23','11:30:00',13.18),('7643','2013-08-23','11:35:00',13.31),('7643','2013-08-23','11:40:00',13.47),('7643','2013-08-23','11:45:00',13.48),('7643','2013-08-23','11:50:00',13.59),('7643','2013-08-23','11:55:00',13.55),('7643','2013-08-23','12:00:00',13.81),('7643','2013-08-23','12:05:00',13.92),('7643','2013-08-23','12:10:00',14.12),('7643','2013-08-23','12:15:00',14.12),('7643','2013-08-23','12:20:00',14.23),('7643','2013-08-23','12:25:00',14.24),('7643','2013-08-23','12:30:00',14.1),('7643','2013-08-23','12:35:00',14.12),('7643','2013-08-23','12:40:00',14.21),('7643','2013-08-23','12:45:00',14.14),('7643','2013-08-23','12:50:00',14.17),('7643','2013-08-23','12:55:00',14.19),('7643','2013-08-23','13:00:00',13.95),('7643','2013-08-23','13:05:00',14.14),('7643','2013-08-23','13:10:00',14.27),('7643','2013-08-23','13:15:00',14.38),('7643','2013-08-23','13:20:00',14.35),('7643','2013-08-23','13:25:00',14.44),('7643','2013-08-23','13:30:00',14.45),('7643','2013-08-23','13:35:00',14.4),('7643','2013-08-23','13:40:00',14.32),('7643','2013-08-23','13:45:00',14.29),('7643','2013-08-23','13:50:00',14.22),('7643','2013-08-23','13:55:00',14.16),('7643','2013-08-23','14:00:00',14.12),('7643','2013-08-23','14:05:00',14.06),('7643','2013-08-23','14:10:00',13.99),('7643','2013-08-23','14:15:00',13.85),('7643','2013-08-23','14:20:00',13.81),('7643','2013-08-23','14:25:00',13.62),('7643','2013-08-23','14:30:00',13.51),('7643','2013-08-23','14:35:00',13.46),('7643','2013-08-23','14:40:00',13.3),('7643','2013-08-23','14:45:00',13.25),('7643','2013-08-23','14:50:00',13.05),('7643','2013-08-23','14:55:00',13.01),('7643','2013-08-23','15:00:00',12.88),('7643','2013-08-23','15:05:00',12.7),('7643','2013-08-23','15:10:00',12.43),('7643','2013-08-23','15:15:00',12.3),('7643','2013-08-23','15:20:00',12.13),('7643','2013-08-23','15:25:00',12.02),('7643','2013-08-23','15:30:00',11.82),('7643','2013-08-23','15:35:00',11.64),('7643','2013-08-23','15:40:00',11.46),('7643','2013-08-23','15:45:00',11.18),('7643','2013-08-23','15:50:00',10.99),('7643','2013-08-23','15:55:00',10.78),('7643','2013-08-23','16:00:00',10.58),('7643','2013-08-23','16:05:00',10.35),('7643','2013-08-23','16:10:00',10.13),('7643','2013-08-23','16:15:00',9.91),('7643','2013-08-23','16:20:00',9.73),('7643','2013-08-23','16:25:00',9.51),('7643','2013-08-23','16:30:00',9.21),('7643','2013-08-23','16:35:00',8.94),('7643','2013-08-23','16:40:00',8.66),('7643','2013-08-23','16:45:00',8.43),('7643','2013-08-23','16:50:00',8.16),('7643','2013-08-23','16:55:00',7.88),('7643','2013-08-23','17:00:00',7.63),('7643','2013-08-23','17:05:00',7.32),('7643','2013-08-23','17:10:00',7.04),('7643','2013-08-23','17:15:00',6.77),('7643','2013-08-23','17:20:00',6.48),('7643','2013-08-23','17:25:00',6.19),('7643','2013-08-23','17:30:00',5.87),('7643','2013-08-23','17:35:00',5.56),('7643','2013-08-23','17:40:00',5.25),('7643','2013-08-23','17:45:00',4.93),('7643','2013-08-23','17:50:00',4.62),('7643','2013-08-23','17:55:00',4.23),('7643','2013-08-23','18:00:00',3.89),('7643','2013-08-23','18:05:00',3.53),('7643','2013-08-23','18:10:00',3.21),('7643','2013-08-23','18:15:00',2.94),('7643','2013-08-23','18:20:00',2.61),('7643','2013-08-23','18:25:00',2.31),('7643','2013-08-23','18:30:00',2.07),('7643','2013-08-23','18:35:00',1.77),('7643','2013-08-23','18:40:00',1.49),('7643','2013-08-23','18:45:00',1.35),('7643','2013-08-23','18:50:00',1.14),('7643','2013-08-22','07:20:00',1.1),('7643','2013-08-22','07:25:00',1.28),('7643','2013-08-22','07:30:00',1.46),('7643','2013-08-22','07:35:00',1.67),('7643','2013-08-22','07:40:00',1.89),('7643','2013-08-22','07:45:00',2.11),('7643','2013-08-22','07:50:00',2.36),('7643','2013-08-22','07:55:00',2.61),('7643','2013-08-22','08:00:00',2.87),('7643','2013-08-22','08:05:00',3.13),('7643','2013-08-22','08:10:00',3.4),('7643','2013-08-22','08:15:00',3.68),('7643','2013-08-22','08:20:00',4.03),('7643','2013-08-22','08:25:00',4.34),('7643','2013-08-22','08:30:00',4.71),('7643','2013-08-22','08:35:00',4.92),('7643','2013-08-22','08:40:00',5.09),('7643','2013-08-22','08:45:00',5.44),('7643','2013-08-22','08:50:00',5.72),('7643','2013-08-22','08:55:00',5.92),('7643','2013-08-22','09:00:00',6.08),('7643','2013-08-22','09:05:00',6.43),('7643','2013-08-22','09:10:00',6.81),('7643','2013-08-22','09:15:00',7.1),('7643','2013-08-22','09:20:00',7.4),('7643','2013-08-22','09:25:00',7.63),('7643','2013-08-22','09:30:00',7.84),('7643','2013-08-22','09:35:00',8),('7643','2013-08-22','09:40:00',8.18),('7643','2013-08-22','09:45:00',8.49),('7643','2013-08-22','09:50:00',8.78),('7643','2013-08-22','09:55:00',9.02),('7643','2013-08-22','10:00:00',9.21),('7643','2013-08-22','10:05:00',9.43),('7643','2013-08-22','10:10:00',9.66),('7643','2013-08-22','10:15:00',9.86),('7643','2013-08-22','10:20:00',10.03),('7643','2013-08-22','10:25:00',10.25),('7643','2013-08-22','10:30:00',10.14),('7643','2013-08-22','10:35:00',10.16),('7643','2013-08-22','10:40:00',10.64),('7643','2013-08-22','10:45:00',10.92),('7643','2013-08-22','10:50:00',10.84),('7643','2013-08-22','10:55:00',10.85),('7643','2013-08-22','11:00:00',11.5),('7643','2013-08-22','11:05:00',11.79),('7643','2013-08-22','11:10:00',10.92),('7643','2013-08-22','11:15:00',7.04),('7643','2013-08-22','11:20:00',5.86),('7643','2013-08-22','11:25:00',8.82),('7643','2013-08-22','11:30:00',5.82),('7643','2013-08-22','11:35:00',9.24),('7643','2013-08-22','11:40:00',12.96),('7643','2013-08-22','11:45:00',13.5),('7643','2013-08-22','11:50:00',13.41),('7643','2013-08-22','11:55:00',13.47),('7643','2013-08-22','12:00:00',13.79),('7643','2013-08-22','12:05:00',13.59),('7643','2013-08-22','12:10:00',6.11),('7643','2013-08-22','12:15:00',11.34),('7643','2013-08-22','12:20:00',3.68),('7643','2013-08-22','12:25:00',3.45),('7643','2013-08-22','12:30:00',3.06),('7643','2013-08-22','12:35:00',4.49),('7643','2013-08-22','12:40:00',7.29),('7643','2013-08-22','12:45:00',3.26),('7643','2013-08-22','12:50:00',3.15),('7643','2013-08-22','12:55:00',2.91),('7643','2013-08-22','13:00:00',3.29),('7643','2013-08-22','13:05:00',4),('7643','2013-08-22','13:10:00',8.74),('7643','2013-08-22','13:15:00',13.43),('7643','2013-08-22','13:20:00',6.57),('7643','2013-08-22','13:25:00',15.45),('7643','2013-08-22','13:30:00',15.89),('7643','2013-08-22','13:35:00',14.78),('7643','2013-08-22','13:40:00',15.16),('7643','2013-08-22','13:45:00',14.72),('7643','2013-08-22','13:50:00',14.4),('7643','2013-08-22','13:55:00',14.75),('7643','2013-08-22','14:00:00',9.79),('7643','2013-08-22','14:05:00',14.94),('7643','2013-08-22','14:10:00',14.63),('7643','2013-08-22','14:15:00',14.34),('7643','2013-08-22','14:20:00',14),('7643','2013-08-22','14:25:00',11.56),('7643','2013-08-22','14:30:00',13.79),('7643','2013-08-22','14:35:00',13.4),('7643','2013-08-22','14:40:00',13.16),('7643','2013-08-22','14:45:00',13.26),('7643','2013-08-22','14:50:00',13.06),('7643','2013-08-22','14:55:00',13.11),('7643','2013-08-22','15:00:00',12.58),('7643','2013-08-22','15:05:00',11.91),('7643','2013-08-22','15:10:00',12.45),('7643','2013-08-22','15:15:00',12.21),('7643','2013-08-22','15:20:00',11.98),('7643','2013-08-22','15:25:00',11.94),('7643','2013-08-22','15:30:00',12.19),('7643','2013-08-22','15:35:00',11.39),('7643','2013-08-22','15:40:00',11.12),('7643','2013-08-22','15:45:00',11.33),('7643','2013-08-22','15:50:00',10.25),('7643','2013-08-22','15:55:00',10.91),('7643','2013-08-22','16:00:00',10.44),('7643','2013-08-22','16:05:00',9.84),('7643','2013-08-22','16:10:00',9.13),('7643','2013-08-22','16:15:00',9.18),('7643','2013-08-22','16:20:00',10.18),('7643','2013-08-22','16:25:00',9.93),('7643','2013-08-22','16:30:00',9.61),('7643','2013-08-22','16:35:00',9.42),('7643','2013-08-22','16:40:00',9.14),('7643','2013-08-22','16:45:00',8.85),('7643','2013-08-22','16:50:00',8.52),('7643','2013-08-22','16:55:00',8.09),('7643','2013-08-22','17:00:00',7.71),('7643','2013-08-22','17:05:00',7.44),('7643','2013-08-22','17:10:00',7.05),('7643','2013-08-22','17:15:00',6.65),('7643','2013-08-22','17:20:00',6.32),('7643','2013-08-22','17:25:00',6.08),('7643','2013-08-22','17:30:00',5.65),('7643','2013-08-22','17:35:00',5.36),('7643','2013-08-22','17:40:00',5.03),('7643','2013-08-22','17:45:00',4.72),('7643','2013-08-22','17:50:00',4.41),('7643','2013-08-22','17:55:00',4.13),('7643','2013-08-22','18:00:00',3.83),('7643','2013-08-22','18:05:00',3.45),('7643','2013-08-22','18:10:00',2.9),('7643','2013-08-22','18:15:00',2.51),('7643','2013-08-22','18:20:00',2.63),('7643','2013-08-22','18:25:00',2.43),('7643','2013-08-22','18:30:00',2.23),('7643','2013-08-22','18:35:00',1.92),('7643','2013-08-22','18:40:00',1.64),('7643','2013-08-22','18:45:00',1.48),('7643','2013-08-22','18:50:00',1.27),('7643','2013-08-22','18:55:00',1.03),('7643','2013-08-21','07:20:00',1.13),('7643','2013-08-21','07:25:00',1.37),('7643','2013-08-21','07:30:00',1.61),('7643','2013-08-21','07:35:00',1.85),('7643','2013-08-21','07:40:00',2.05),('7643','2013-08-21','07:45:00',2.31),('7643','2013-08-21','07:50:00',2.55),('7643','2013-08-21','07:55:00',2.82),('7643','2013-08-21','08:00:00',3.07),('7643','2013-08-21','08:05:00',3.31),('7643','2013-08-21','08:10:00',3.63),('7643','2013-08-21','08:15:00',3.84),('7643','2013-08-21','08:20:00',4.22),('7643','2013-08-21','08:25:00',4.46),('7643','2013-08-21','08:30:00',4.82),('7643','2013-08-21','08:35:00',5.16),('7643','2013-08-21','08:40:00',5.35),('7643','2013-08-21','08:45:00',5.78),('7643','2013-08-21','08:50:00',6.04),('7643','2013-08-21','08:55:00',6.43),('7643','2013-08-21','09:00:00',6.78),('7643','2013-08-21','09:05:00',7.42),('7643','2013-08-21','09:10:00',7.84),('7643','2013-08-21','09:15:00',8.23),('7643','2013-08-21','09:20:00',8.7),('7643','2013-08-21','09:25:00',8.79),('7643','2013-08-21','09:30:00',6.98),('7643','2013-08-21','09:35:00',4.68),('7643','2013-08-21','09:40:00',5.81),('7643','2013-08-21','09:45:00',7.24),('7643','2013-08-21','09:50:00',9.24),('7643','2013-08-21','09:55:00',9.83),('7643','2013-08-21','10:00:00',10.44),('7643','2013-08-21','10:05:00',10.65),('7643','2013-08-21','10:10:00',10.7),('7643','2013-08-21','10:15:00',10.74),('7643','2013-08-21','10:20:00',10.74),('7643','2013-08-21','10:25:00',10.97),('7643','2013-08-21','10:30:00',11.16),('7643','2013-08-21','10:35:00',11.26),('7643','2013-08-21','10:40:00',11.46),('7643','2013-08-21','10:45:00',11.59),('7643','2013-08-21','10:50:00',11.73),('7643','2013-08-21','10:55:00',11.89),('7643','2013-08-21','11:00:00',12.03),('7643','2013-08-21','11:05:00',12.18),('7643','2013-08-21','11:10:00',12.12),('7643','2013-08-21','11:15:00',12.31),('7643','2013-08-21','11:20:00',12.46),('7643','2013-08-21','11:25:00',12.54),('7643','2013-08-21','11:30:00',12.75),('7643','2013-08-21','11:35:00',12.86),('7643','2013-08-21','11:40:00',12.93),('7643','2013-08-21','11:45:00',13.01),('7643','2013-08-21','11:50:00',13.15),('7643','2013-08-21','11:55:00',13.21),('7643','2013-08-21','12:00:00',13.32),('7643','2013-08-21','12:05:00',13.42),('7643','2013-08-21','12:10:00',13.49),('7643','2013-08-21','12:15:00',13.54),('7643','2013-08-21','12:20:00',13.6),('7643','2013-08-21','12:25:00',13.52),('7643','2013-08-21','12:30:00',13.58),('7643','2013-08-21','12:35:00',13.69),('7643','2013-08-21','12:40:00',13.72),('7643','2013-08-21','12:45:00',13.79),('7643','2013-08-21','12:50:00',13.72),('7643','2013-08-21','12:55:00',13.74),('7643','2013-08-21','13:00:00',13.74),('7643','2013-08-21','13:05:00',13.46),('7643','2013-08-21','13:10:00',13.25),('7643','2013-08-21','13:15:00',13.29),('7643','2013-08-21','13:20:00',13.42),('7643','2013-08-21','13:25:00',13.4),('7643','2013-08-21','13:30:00',13.4),('7643','2013-08-21','13:35:00',13.4),('7643','2013-08-21','13:40:00',13.46),('7643','2013-08-21','13:45:00',13.59),('7643','2013-08-21','13:50:00',13.49),('7643','2013-08-21','13:55:00',13.4),('7643','2013-08-21','14:00:00',13.38),('7643','2013-08-21','14:05:00',13.29),('7643','2013-08-21','14:10:00',13.27),('7643','2013-08-21','14:15:00',13.26),('7643','2013-08-21','14:20:00',13.18),('7643','2013-08-21','14:25:00',13.39),('7643','2013-08-21','14:30:00',13.31),('7643','2013-08-21','14:35:00',13.01),('7643','2013-08-21','14:40:00',12.91),('7643','2013-08-21','14:45:00',12.79),('7643','2013-08-21','14:50:00',12.53),('7643','2013-08-21','14:55:00',9.5),('7643','2013-08-21','15:00:00',12.1),('7643','2013-08-21','15:05:00',12.3),('7643','2013-08-21','15:10:00',12.15),('7643','2013-08-21','15:15:00',11.99),('7643','2013-08-21','15:20:00',11.82),('7643','2013-08-21','15:25:00',11.62),('7643','2013-08-21','15:30:00',11.43),('7643','2013-08-21','15:35:00',11.27),('7643','2013-08-21','15:40:00',11.18),('7643','2013-08-21','15:45:00',11),('7643','2013-08-21','15:50:00',10.84),('7643','2013-08-21','15:55:00',10.58),('7643','2013-08-21','16:00:00',10.26),('7643','2013-08-21','16:05:00',9.91),('7643','2013-08-21','16:10:00',9.72),('7643','2013-08-21','16:15:00',9.59),('7643','2013-08-21','16:20:00',9.32),('7643','2013-08-21','16:25:00',9.11),('7643','2013-08-21','16:30:00',8.9),('7643','2013-08-21','16:35:00',8.58),('7643','2013-08-21','16:40:00',8.29),('7643','2013-08-21','16:45:00',7.98),('7643','2013-08-21','16:50:00',7.77),('7643','2013-08-21','16:55:00',7.53),('7643','2013-08-21','17:00:00',7.16),('7643','2013-08-21','17:05:00',6.92),('7643','2013-08-21','17:10:00',6.57),('7643','2013-08-21','17:15:00',6.27),('7643','2013-08-21','17:20:00',6.01),('7643','2013-08-21','17:25:00',5.76),('7643','2013-08-21','17:30:00',5.47),('7643','2013-08-21','17:35:00',5.17),('7643','2013-08-21','17:40:00',4.88),('7643','2013-08-21','17:45:00',4.56),('7643','2013-08-21','17:50:00',4.21),('7643','2013-08-21','17:55:00',3.99),('7643','2013-08-21','18:00:00',3.74),('7643','2013-08-21','18:05:00',3.42),('7643','2013-08-21','18:10:00',3.27),('7643','2013-08-21','18:15:00',3.32),('7643','2013-08-21','18:20:00',2.93),('7643','2013-08-21','18:25:00',2.2),('7643','2013-08-21','18:30:00',1.91),('7643','2013-08-21','18:35:00',1.7),('7643','2013-08-21','18:40:00',1.67),('7643','2013-08-21','18:45:00',1.54),('7643','2013-08-21','18:50:00',1.32),('7643','2013-08-21','18:55:00',1.13),('7643','2013-08-21','19:00:00',1.03),('7643','2013-08-20','07:45:00',1.03),('7643','2013-08-20','07:50:00',1.24),('7643','2013-08-20','07:55:00',1.36),('7643','2013-08-20','08:00:00',1.43),('7643','2013-08-20','08:05:00',1.53),('7643','2013-08-20','08:10:00',1.67),('7643','2013-08-20','08:15:00',1.95),('7643','2013-08-20','08:20:00',2.31),('7643','2013-08-20','08:25:00',2.81),('7643','2013-08-20','08:30:00',2.86),('7643','2013-08-20','08:35:00',3),('7643','2013-08-20','08:40:00',2.84),('7643','2013-08-20','08:45:00',2.65),('7643','2013-08-20','08:50:00',2.45),('7643','2013-08-20','08:55:00',2.66),('7643','2013-08-20','09:00:00',3.29),('7643','2013-08-20','09:05:00',4.99),('7643','2013-08-20','09:10:00',4.79),('7643','2013-08-20','09:15:00',9.02),('7643','2013-08-20','09:20:00',8.48),('7643','2013-08-20','09:25:00',4.43),('7643','2013-08-20','09:30:00',2.84),('7643','2013-08-20','09:35:00',3.71),('7643','2013-08-20','09:40:00',4.02),('7643','2013-08-20','09:45:00',4.8),('7643','2013-08-20','09:50:00',11.22),('7643','2013-08-20','09:55:00',12.64),('7643','2013-08-20','10:00:00',11.9),('7643','2013-08-20','10:05:00',8.37),('7643','2013-08-20','10:10:00',10.15),('7643','2013-08-20','10:15:00',7.42),('7643','2013-08-20','10:20:00',6.43),('7643','2013-08-20','10:25:00',5.95),('7643','2013-08-20','10:30:00',9.26),('7643','2013-08-20','10:35:00',12.09),('7643','2013-08-20','10:40:00',9.39),('7643','2013-08-20','10:45:00',8.1),('7643','2013-08-20','10:50:00',7.41),('7643','2013-08-20','10:55:00',6.29),('7643','2013-08-20','11:00:00',8.15),('7643','2013-08-20','11:05:00',6.72),('7643','2013-08-20','11:10:00',6.4),('7643','2013-08-20','11:15:00',8.49),('7643','2013-08-20','11:20:00',12.88),('7643','2013-08-20','11:25:00',8.93),('7643','2013-08-20','11:30:00',10.65),('7643','2013-08-20','11:35:00',15.32),('7643','2013-08-20','11:40:00',14.77),('7643','2013-08-20','11:45:00',14.34),('7643','2013-08-20','11:50:00',10.81),('7643','2013-08-20','11:55:00',13.76),('7643','2013-08-20','12:00:00',14.68),('7643','2013-08-20','12:05:00',14.64),('7643','2013-08-20','12:10:00',14.7),('7643','2013-08-20','12:15:00',14.81),('7643','2013-08-20','12:20:00',13.57),('7643','2013-08-20','12:25:00',11.39),('7643','2013-08-20','12:30:00',11.09),('7643','2013-08-20','12:35:00',10.07),('7643','2013-08-20','12:40:00',13.15),('7643','2013-08-20','12:45:00',14.09),('7643','2013-08-20','12:50:00',13.72),('7643','2013-08-20','12:55:00',13.24),('7643','2013-08-20','13:00:00',14),('7643','2013-08-20','13:05:00',14.2),('7643','2013-08-20','13:10:00',14.36),('7643','2013-08-20','13:15:00',14.66),('7643','2013-08-20','13:20:00',14.54),('7643','2013-08-20','13:25:00',14.65),('7643','2013-08-20','13:30:00',14.67),('7643','2013-08-20','13:35:00',14.13),('7643','2013-08-20','13:40:00',13.83),('7643','2013-08-20','13:45:00',12.5),('7643','2013-08-20','13:50:00',13.84),('7643','2013-08-20','13:55:00',13.67),('7643','2013-08-20','14:00:00',12.26),('7643','2013-08-20','14:05:00',13.9),('7643','2013-08-20','14:10:00',13.94),('7643','2013-08-20','14:15:00',12.44),('7643','2013-08-20','14:20:00',8.07),('7643','2013-08-20','14:25:00',8.45),('7643','2013-08-20','14:30:00',12.37),('7643','2013-08-20','14:35:00',12.11),('7643','2013-08-20','14:40:00',12.41),('7643','2013-08-20','14:45:00',12.41),('7643','2013-08-20','14:50:00',11.72),('7643','2013-08-20','14:55:00',11.79),('7643','2013-08-20','15:00:00',12.16),('7643','2013-08-20','15:05:00',12.19),('7643','2013-08-20','15:10:00',11.84),('7643','2013-08-20','15:15:00',11.82),('7643','2013-08-20','15:20:00',11.36),('7643','2013-08-20','15:25:00',11.02),('7643','2013-08-20','15:30:00',10.72),('7643','2013-08-20','15:35:00',10.38),('7643','2013-08-20','15:40:00',9.87),('7643','2013-08-20','15:45:00',9.7),('7643','2013-08-20','15:50:00',10.09),('7643','2013-08-20','15:55:00',9.76),('7643','2013-08-20','16:00:00',9.07),('7643','2013-08-20','16:05:00',8.49),('7643','2013-08-20','16:10:00',8.54),('7643','2013-08-20','16:15:00',8.53),('7643','2013-08-20','16:20:00',9.04),('7643','2013-08-20','16:25:00',8.85),('7643','2013-08-20','16:30:00',9.32),('7643','2013-08-20','16:35:00',9.25),('7643','2013-08-20','16:40:00',8.87),('7643','2013-08-20','16:45:00',8.48),('7643','2013-08-20','16:50:00',8.24),('7643','2013-08-20','16:55:00',7.99),('7643','2013-08-20','17:00:00',7.76),('7643','2013-08-20','17:05:00',7.61),('7643','2013-08-20','17:10:00',7.38),('7643','2013-08-20','17:15:00',7.23),('7643','2013-08-20','17:20:00',7.08),('7643','2013-08-20','17:25:00',6.83),('7643','2013-08-20','17:30:00',6.47),('7643','2013-08-20','17:35:00',6.22),('7643','2013-08-20','17:40:00',5.88),('7643','2013-08-20','17:45:00',5.65),('7643','2013-08-20','17:50:00',5.51),('7643','2013-08-20','17:55:00',5.2),('7643','2013-08-20','18:00:00',4.87),('7643','2013-08-20','18:05:00',4.52),('7643','2013-08-20','18:10:00',4.17),('7643','2013-08-20','18:15:00',3.75),('7643','2013-08-20','18:20:00',3.38),('7643','2013-08-20','18:25:00',3.03),('7643','2013-08-20','18:30:00',2.66),('7643','2013-08-20','18:35:00',2.15),('7643','2013-08-20','18:40:00',1.85),('7643','2013-08-20','18:45:00',1.73),('7643','2013-08-20','18:50:00',1.45),('7643','2013-08-20','18:55:00',1.29),('7643','2013-08-20','19:00:00',1.08),('7643','2013-08-19','07:20:00',1.09),('7643','2013-08-19','07:25:00',1.28),('7643','2013-08-19','07:30:00',1.55),('7643','2013-08-19','07:35:00',1.88),('7643','2013-08-19','07:40:00',2.23),('7643','2013-08-19','07:45:00',2.31),('7643','2013-08-19','07:50:00',2.91),('7643','2013-08-19','07:55:00',3.76),('7643','2013-08-19','08:00:00',3.42),('7643','2013-08-19','08:05:00',2.99),('7643','2013-08-19','08:10:00',2.28),('7643','2013-08-19','08:15:00',2.3),('7643','2013-08-19','08:20:00',2.47),('7643','2013-08-19','08:25:00',2.59),('7643','2013-08-19','08:30:00',2.42),('7643','2013-08-19','08:35:00',2.37),('7643','2013-08-19','08:40:00',2.55),('7643','2013-08-19','08:45:00',2.83),('7643','2013-08-19','08:50:00',3.41),('7643','2013-08-19','08:55:00',3.68),('7643','2013-08-19','09:00:00',3.81),('7643','2013-08-19','09:05:00',4.09),('7643','2013-08-19','09:10:00',3.99),('7643','2013-08-19','09:15:00',3.95),('7643','2013-08-19','09:20:00',3.62),('7643','2013-08-19','09:25:00',6.14),('7643','2013-08-19','09:30:00',8.31),('7643','2013-08-19','09:35:00',8.58),('7643','2013-08-19','09:40:00',9.79),('7643','2013-08-19','09:45:00',11.4),('7643','2013-08-19','09:50:00',8.71),('7643','2013-08-19','09:55:00',8.72),('7643','2013-08-19','10:00:00',5.73),('7643','2013-08-19','10:05:00',5.5),('7643','2013-08-19','10:10:00',11.62),('7643','2013-08-19','10:15:00',8.5),('7643','2013-08-19','10:20:00',8.12),('7643','2013-08-19','10:25:00',7.22),('7643','2013-08-19','10:30:00',3.4),('7643','2013-08-19','10:35:00',3.15),('7643','2013-08-19','10:40:00',3.22),('7643','2013-08-19','10:45:00',3.26),('7643','2013-08-19','10:50:00',9.72),('7643','2013-08-19','10:55:00',8.44),('7643','2013-08-19','11:00:00',2.8),('7643','2013-08-19','11:05:00',2.14),('7643','2013-08-19','11:10:00',2.67),('7643','2013-08-19','11:15:00',10.71),('7643','2013-08-19','11:20:00',14.56),('7643','2013-08-19','11:25:00',12.15),('7643','2013-08-19','11:30:00',3.14),('7643','2013-08-19','11:35:00',8.21),('7643','2013-08-19','11:40:00',14.75),('7643','2013-08-19','11:45:00',15.23),('7643','2013-08-19','11:50:00',16.45),('7643','2013-08-19','11:55:00',12.15),('7643','2013-08-19','12:00:00',5.46),('7643','2013-08-19','12:05:00',5.84),('7643','2013-08-19','12:10:00',4.76),('7643','2013-08-19','12:15:00',3.26),('7643','2013-08-19','12:20:00',3.39),('7643','2013-08-19','12:25:00',4),('7643','2013-08-19','12:30:00',4.71),('7643','2013-08-19','12:35:00',5.02),('7643','2013-08-19','12:40:00',6.02),('7643','2013-08-19','12:45:00',6.07),('7643','2013-08-19','12:50:00',6.23),('7643','2013-08-19','12:55:00',6.49),('7643','2013-08-19','13:00:00',6.17),('7643','2013-08-19','13:05:00',5.82),('7643','2013-08-19','13:10:00',5.68),('7643','2013-08-19','13:15:00',5.98),('7643','2013-08-19','13:20:00',6.16),('7643','2013-08-19','13:25:00',6.48),('7643','2013-08-19','13:30:00',6.89),('7643','2013-08-19','13:35:00',8.72),('7643','2013-08-19','13:40:00',15.01),('7643','2013-08-19','13:45:00',14.53),('7643','2013-08-19','13:50:00',15.65),('7643','2013-08-19','13:55:00',15.05),('7643','2013-08-19','14:00:00',14.76),('7643','2013-08-19','14:05:00',14.45),('7643','2013-08-19','14:10:00',14.71),('7643','2013-08-19','14:15:00',14.35),('7643','2013-08-19','14:20:00',14.23),('7643','2013-08-19','14:25:00',13.13),('7643','2013-08-19','14:30:00',9.96),('7643','2013-08-19','14:35:00',13.3),('7643','2013-08-19','14:40:00',15.27),('7643','2013-08-19','14:45:00',14.66),('7643','2013-08-19','14:50:00',14.25),('7643','2013-08-19','14:55:00',10.31),('7643','2013-08-19','15:00:00',10.78),('7643','2013-08-19','15:05:00',14.34),('7643','2013-08-19','15:10:00',14.18),('7643','2013-08-19','15:15:00',13.95),('7643','2013-08-19','15:20:00',13.46),('7643','2013-08-19','15:25:00',13.29),('7643','2013-08-19','15:30:00',13.34),('7643','2013-08-19','15:35:00',13.3),('7643','2013-08-19','15:40:00',13.44),('7643','2013-08-19','15:45:00',13.97),('7643','2013-08-19','15:50:00',12.56),('7643','2013-08-19','15:55:00',14.26),('7643','2013-08-19','16:00:00',12.73),('7643','2013-08-19','16:05:00',13.31),('7643','2013-08-19','16:10:00',13.1),('7643','2013-08-19','16:15:00',12.83),('7643','2013-08-19','16:20:00',12.57),('7643','2013-08-19','16:25:00',12.1),('7643','2013-08-19','16:30:00',11.18),('7643','2013-08-19','16:35:00',11.27),('7643','2013-08-19','16:40:00',11.48),('7643','2013-08-19','16:45:00',11.11),('7643','2013-08-19','16:50:00',10.09),('7643','2013-08-19','16:55:00',9.48),('7643','2013-08-19','17:00:00',8.71),('7643','2013-08-19','17:05:00',8.2),('7643','2013-08-19','17:10:00',7.78),('7643','2013-08-19','17:15:00',7.29),('7643','2013-08-19','17:20:00',7.05),('7643','2013-08-19','17:25:00',6.78),('7643','2013-08-19','17:30:00',6.46),('7643','2013-08-19','17:35:00',6.19),('7643','2013-08-19','17:40:00',5.91),('7643','2013-08-19','17:45:00',5.59),('7643','2013-08-19','17:50:00',5.04),('7643','2013-08-19','17:55:00',4.62),('7643','2013-08-19','18:00:00',2.93),('7643','2013-08-19','18:05:00',4.06),('7643','2013-08-19','18:10:00',4.13),('7643','2013-08-19','18:15:00',4.05),('7643','2013-08-19','18:20:00',3.85),('7643','2013-08-19','18:25:00',3.61),('7643','2013-08-19','18:30:00',3.52),('7643','2013-08-19','18:35:00',3.19),('7643','2013-08-19','18:40:00',3.01),('7643','2013-08-19','18:45:00',2.89),('7643','2013-08-19','18:50:00',2.51),('7643','2013-08-19','18:55:00',2.36),('7643','2013-08-19','19:00:00',2.13),('7643','2013-08-19','19:05:00',1.72),('7643','2013-08-19','19:10:00',1.4),('7643','2013-08-19','19:15:00',1.11),('7643','2014-04-09','07:20:00',1.13),('7643','2014-04-09','07:25:00',1.4),('7643','2014-04-09','07:30:00',1.75),('7643','2014-04-09','07:35:00',2.08),('7643','2014-04-09','07:40:00',2.35),('7643','2014-04-09','07:45:00',2.77),('7643','2014-04-09','07:50:00',3.25),('7643','2014-04-09','07:55:00',3.58),('7643','2014-04-09','08:00:00',3.95),('7643','2014-04-09','08:05:00',4.41),('7643','2014-04-09','08:10:00',4.82),('7643','2014-04-09','08:15:00',5.23),('7643','2014-04-09','08:20:00',5.63),('7643','2014-04-09','08:25:00',6.06),('7643','2014-04-09','08:30:00',6.45),('7643','2014-04-09','08:35:00',6.83),('7643','2014-04-09','08:40:00',7.24),('7643','2014-04-09','08:45:00',7.63),('7643','2014-04-09','08:50:00',7.95),('7643','2014-04-09','08:55:00',8.25),('7643','2014-04-09','09:00:00',8.52),('7643','2014-04-09','09:05:00',9.06),('7643','2014-04-09','09:10:00',9.39),('7643','2014-04-09','09:15:00',9.57),('7643','2014-04-09','09:20:00',9.62),('7643','2014-04-09','09:25:00',10.31),('7643','2014-04-09','09:30:00',10.69),('7643','2014-04-09','09:35:00',10.98),('7643','2014-04-09','09:40:00',11.22),('7643','2014-04-09','09:45:00',11.45),('7643','2014-04-09','09:50:00',11.77),('7643','2014-04-09','09:55:00',12.05),('7643','2014-04-09','10:00:00',12.33),('7643','2014-04-09','10:05:00',12.47),('7643','2014-04-09','10:10:00',12.84),('7643','2014-04-09','10:15:00',12.82),('7643','2014-04-09','10:20:00',13.11),('7643','2014-04-09','10:25:00',13.33),('7643','2014-04-09','10:30:00',13.45),('7643','2014-04-09','10:35:00',13.97),('7643','2014-04-09','10:40:00',14.18),('7643','2014-04-09','10:45:00',14.13),('7643','2014-04-09','10:50:00',14.06),('7643','2014-04-09','10:55:00',14.35),('7643','2014-04-09','11:00:00',14.51),('7643','2014-04-09','11:05:00',15.04),('7643','2014-04-09','11:10:00',14.59),('7643','2014-04-09','11:15:00',15.23),('7643','2014-04-09','11:20:00',15.62),('7643','2014-04-09','11:25:00',15.84),('7643','2014-04-09','11:30:00',15.84),('7643','2014-04-09','11:35:00',16.01),('7643','2014-04-09','11:40:00',15.66),('7643','2014-04-09','11:45:00',16.02),('7643','2014-04-09','11:50:00',15.5),('7643','2014-04-09','11:55:00',16.29),('7643','2014-04-09','12:00:00',16.14),('7643','2014-04-09','12:05:00',15.11),('7643','2014-04-09','12:10:00',15.7),('7643','2014-04-09','12:15:00',15.9),('7643','2014-04-09','12:20:00',16.05),('7643','2014-04-09','12:25:00',15.6),('7643','2014-04-09','12:30:00',15.88),('7643','2014-04-09','12:35:00',16.66),('7643','2014-04-09','12:40:00',16.4),('7643','2014-04-09','12:45:00',16.47),('7643','2014-04-09','12:50:00',16.15),('7643','2014-04-09','12:55:00',15.93),('7643','2014-04-09','13:00:00',15.76),('7643','2014-04-09','13:05:00',15.16),('7643','2014-04-09','13:10:00',15.69),('7643','2014-04-09','13:15:00',15.95),('7643','2014-04-09','13:20:00',15.22),('7643','2014-04-09','13:25:00',16.8),('7643','2014-04-09','13:30:00',16.28),('7643','2014-04-09','13:35:00',16.66),('7643','2014-04-09','13:40:00',16.01),('7643','2014-04-09','13:45:00',16.61),('7643','2014-04-09','13:50:00',16.46),('7643','2014-04-09','13:55:00',16.3),('7643','2014-04-09','14:00:00',16.15),('7643','2014-04-09','14:05:00',16.06),('7643','2014-04-09','14:10:00',16.01),('7643','2014-04-09','14:15:00',15.93),('7643','2014-04-09','14:20:00',15.94),('7643','2014-04-09','14:25:00',15.94),('7643','2014-04-09','14:30:00',15.81),('7643','2014-04-09','14:35:00',15.67),('7643','2014-04-09','14:40:00',15.52),('7643','2014-04-09','14:45:00',14.11),('7643','2014-04-09','14:50:00',15.58),('7643','2014-04-09','14:55:00',15.21),('7643','2014-04-09','15:00:00',15.01),('7643','2014-04-09','15:05:00',14.79),('7643','2014-04-09','15:10:00',14.48),('7643','2014-04-09','15:15:00',14.37),('7643','2014-04-09','15:20:00',14.25),('7643','2014-04-09','15:25:00',14.02),('7643','2014-04-09','15:30:00',12.69),('7643','2014-04-09','15:35:00',12.43),('7643','2014-04-09','15:40:00',12.72),('7643','2014-04-09','15:45:00',12.54),('7643','2014-04-09','15:50:00',12.73),('7643','2014-04-09','15:55:00',12.5),('7643','2014-04-09','16:00:00',12),('7643','2014-04-09','16:05:00',12.22),('7643','2014-04-09','16:10:00',12.14),('7643','2014-04-09','16:15:00',12.4),('7643','2014-04-09','16:20:00',11.67),('7643','2014-04-09','16:25:00',11.83),('7643','2014-04-09','16:30:00',11.53),('7643','2014-04-09','16:35:00',11.18),('7643','2014-04-09','16:40:00',10.89),('7643','2014-04-09','16:45:00',10.92),('7643','2014-04-09','16:50:00',10.34),('7643','2014-04-09','16:55:00',9.95),('7643','2014-04-09','17:00:00',9.46),('7643','2014-04-09','17:05:00',9.17),('7643','2014-04-09','17:10:00',8.66),('7643','2014-04-09','17:15:00',8.17),('7643','2014-04-09','17:20:00',7.98),('7643','2014-04-09','17:25:00',7.51),('7643','2014-04-09','17:30:00',7.08),('7643','2014-04-09','17:35:00',6.67),('7643','2014-04-09','17:40:00',6.26),('7643','2014-04-09','17:45:00',5.87),('7643','2014-04-09','17:50:00',5.45),('7643','2014-04-09','17:55:00',5),('7643','2014-04-09','18:00:00',4.56),('7643','2014-04-09','18:05:00',4.14),('7643','2014-04-09','18:10:00',3.73),('7643','2014-04-09','18:15:00',3.31),('7643','2014-04-09','18:20:00',2.96),('7643','2014-04-09','18:25:00',2.62),('7643','2014-04-09','18:30:00',2.27),('7643','2014-04-09','18:35:00',1.88),('7643','2014-04-09','18:40:00',1.61),('7643','2014-04-09','18:45:00',1.31),('7643','2013-08-18','07:15:00',1.21),('7643','2013-08-18','07:20:00',1.55),('7643','2013-08-18','07:25:00',1.71),('7643','2013-08-18','07:30:00',1.98),('7643','2013-08-18','07:35:00',1.87),('7643','2013-08-18','07:40:00',2.71),('7643','2013-08-18','07:45:00',2.69),('7643','2013-08-18','07:50:00',2.89),('7643','2013-08-18','07:55:00',3.2),('7643','2013-08-18','08:00:00',3.5),('7643','2013-08-18','08:05:00',3.79),('7643','2013-08-18','08:10:00',4.01),('7643','2013-08-18','08:15:00',4.31),('7643','2013-08-18','08:20:00',4.67),('7643','2013-08-18','08:25:00',5),('7643','2013-08-18','08:30:00',5.26),('7643','2013-08-18','08:35:00',5.47),('7643','2013-08-18','08:40:00',5.79),('7643','2013-08-18','08:45:00',6.17),('7643','2013-08-18','08:50:00',6.54),('7643','2013-08-18','08:55:00',6.88),('7643','2013-08-18','09:00:00',7.19),('7643','2013-08-18','09:05:00',7.47),('7643','2013-08-18','09:10:00',7.71),('7643','2013-08-18','09:15:00',7.92),('7643','2013-08-18','09:20:00',8.21),('7643','2013-08-18','09:25:00',8.41),('7643','2013-08-18','09:30:00',8.68),('7643','2013-08-18','09:35:00',8.99),('7643','2013-08-18','09:40:00',9.17),('7643','2013-08-18','09:45:00',9.41),('7643','2013-08-18','09:50:00',9.67),('7643','2013-08-18','09:55:00',9.93),('7643','2013-08-18','10:00:00',10.18),('7643','2013-08-18','10:05:00',10.35),('7643','2013-08-18','10:10:00',10.57),('7643','2013-08-18','10:15:00',10.67),('7643','2013-08-18','10:20:00',10.91),('7643','2013-08-18','10:25:00',11.1),('7643','2013-08-18','10:30:00',11.26),('7643','2013-08-18','10:35:00',11.51),('7643','2013-08-18','10:40:00',11.64),('7643','2013-08-18','10:45:00',11.9),('7643','2013-08-18','10:50:00',11.97),('7643','2013-08-18','10:55:00',12.14),('7643','2013-08-18','11:00:00',12.25),('7643','2013-08-18','11:05:00',12.3),('7643','2013-08-18','11:10:00',12.54),('7643','2013-08-18','11:15:00',12.58),('7643','2013-08-18','11:20:00',12.53),('7643','2013-08-18','11:25:00',12.45),('7643','2013-08-18','11:30:00',12.86),('7643','2013-08-18','11:35:00',12.75),('7643','2013-08-18','11:40:00',13.12),('7643','2013-08-18','11:45:00',13.2),('7643','2013-08-18','11:50:00',13.29),('7643','2013-08-18','11:55:00',13.38),('7643','2013-08-18','12:00:00',13.29),('7643','2013-08-18','12:05:00',13.41),('7643','2013-08-18','12:10:00',13.58),('7643','2013-08-18','12:15:00',13.79),('7643','2013-08-18','12:20:00',13.96),('7643','2013-08-18','12:25:00',13.88),('7643','2013-08-18','12:30:00',13.83),('7643','2013-08-18','12:35:00',14.03),('7643','2013-08-18','12:40:00',13.98),('7643','2013-08-18','12:45:00',14.19),('7643','2013-08-18','12:50:00',14.26),('7643','2013-08-18','12:55:00',14.35),('7643','2013-08-18','13:00:00',14.34),('7643','2013-08-18','13:05:00',14.48),('7643','2013-08-18','13:10:00',14.46),('7643','2013-08-18','13:15:00',14.39),('7643','2013-08-18','13:20:00',14.52),('7643','2013-08-18','13:25:00',14.49),('7643','2013-08-18','13:30:00',14.44),('7643','2013-08-18','13:35:00',14.45),('7643','2013-08-18','13:40:00',14.29),('7643','2013-08-18','13:45:00',14.35),('7643','2013-08-18','13:50:00',14.34),('7643','2013-08-18','13:55:00',14.32),('7643','2013-08-18','14:00:00',14.19),('7643','2013-08-18','14:05:00',14.11),('7643','2013-08-18','14:10:00',14.17),('7643','2013-08-18','14:15:00',14.08),('7643','2013-08-18','14:20:00',14.06),('7643','2013-08-18','14:25:00',13.96),('7643','2013-08-18','14:30:00',13.78),('7643','2013-08-18','14:35:00',13.77),('7643','2013-08-18','14:40:00',13.69),('7643','2013-08-18','14:45:00',13.58),('7643','2013-08-18','14:50:00',13.47),('7643','2013-08-18','14:55:00',13.36),('7643','2013-08-18','15:00:00',13.2),('7643','2013-08-18','15:05:00',13.05),('7643','2013-08-18','15:10:00',12.94),('7643','2013-08-18','15:15:00',12.83),('7643','2013-08-18','15:20:00',12.67),('7643','2013-08-18','15:25:00',12.45),('7643','2013-08-18','15:30:00',12.27),('7643','2013-08-18','15:35:00',12.07),('7643','2013-08-18','15:40:00',11.92),('7643','2013-08-18','15:45:00',11.7),('7643','2013-08-18','15:50:00',11.52),('7643','2013-08-18','15:55:00',11.31),('7643','2013-08-18','16:00:00',11.09),('7643','2013-08-18','16:05:00',10.9),('7643','2013-08-18','16:10:00',10.69),('7643','2013-08-18','16:15:00',10.51),('7643','2013-08-18','16:20:00',10.24),('7643','2013-08-18','16:25:00',9.91),('7643','2013-08-18','16:30:00',9.7),('7643','2013-08-18','16:35:00',9.46),('7643','2013-08-18','16:40:00',9.21),('7643','2013-08-18','16:45:00',8.96),('7643','2013-08-18','16:50:00',8.72),('7643','2013-08-18','16:55:00',8.43),('7643','2013-08-18','17:00:00',8.12),('7643','2013-08-18','17:05:00',7.84),('7643','2013-08-18','17:10:00',7.52),('7643','2013-08-18','17:15:00',7.25),('7643','2013-08-18','17:20:00',6.95),('7643','2013-08-18','17:25:00',6.65),('7643','2013-08-18','17:30:00',6.33),('7643','2013-08-18','17:35:00',6.04),('7643','2013-08-18','17:40:00',5.77),('7643','2013-08-18','17:45:00',5.41),('7643','2013-08-18','17:50:00',5.05),('7643','2013-08-18','17:55:00',4.74),('7643','2013-08-18','18:00:00',4.36),('7643','2013-08-18','18:05:00',4.01),('7643','2013-08-18','18:10:00',3.72),('7643','2013-08-18','18:15:00',3.35),('7643','2013-08-18','18:20:00',3.05),('7643','2013-08-18','18:25:00',2.79),('7643','2013-08-18','18:30:00',2.47),('7643','2013-08-18','18:35:00',2.15),('7643','2013-08-18','18:40:00',1.96),('7643','2013-08-18','18:45:00',1.72),('7643','2013-08-18','18:50:00',1.47),('7643','2013-08-18','18:55:00',1.2),('7643','2013-08-17','07:15:00',1.12),('7643','2013-08-17','07:20:00',1.33),('7643','2013-08-17','07:25:00',1.57),('7643','2013-08-17','07:30:00',1.83),('7643','2013-08-17','07:35:00',2.06),('7643','2013-08-17','07:40:00',2.34),('7643','2013-08-17','07:45:00',2.65),('7643','2013-08-17','07:50:00',2.97),('7643','2013-08-17','07:55:00',3.29),('7643','2013-08-17','08:00:00',3.6),('7643','2013-08-17','08:05:00',3.91),('7643','2013-08-17','08:10:00',4.23),('7643','2013-08-17','08:15:00',4.57),('7643','2013-08-17','08:20:00',4.9),('7643','2013-08-17','08:25:00',5.21),('7643','2013-08-17','08:30:00',5.5),('7643','2013-08-17','08:35:00',5.81),('7643','2013-08-17','08:40:00',6.14),('7643','2013-08-17','08:45:00',6.37),('7643','2013-08-17','08:50:00',6.69),('7643','2013-08-17','08:55:00',6.97),('7643','2013-08-17','09:00:00',7.25),('7643','2013-08-17','09:05:00',7.59),('7643','2013-08-17','09:10:00',7.91),('7643','2013-08-17','09:15:00',8.23),('7643','2013-08-17','09:20:00',8.5),('7643','2013-08-17','09:25:00',8.78),('7643','2013-08-17','09:30:00',9.08),('7643','2013-08-17','09:35:00',9.27),('7643','2013-08-17','09:40:00',9.66),('7643','2013-08-17','09:45:00',9.69),('7643','2013-08-17','09:50:00',9.31),('7643','2013-08-17','09:55:00',7.4),('7643','2013-08-17','10:00:00',10.42),('7643','2013-08-17','10:05:00',9.32),('7643','2013-08-17','10:10:00',9.67),('7643','2013-08-17','10:15:00',10.95),('7643','2013-08-17','10:20:00',11.06),('7643','2013-08-17','10:25:00',11.17),('7643','2013-08-17','10:30:00',11.34),('7643','2013-08-17','10:35:00',11.48),('7643','2013-08-17','10:40:00',11.65),('7643','2013-08-17','10:45:00',11.66),('7643','2013-08-17','10:50:00',11.76),('7643','2013-08-17','10:55:00',12.1),('7643','2013-08-17','11:00:00',12.22),('7643','2013-08-17','11:05:00',12.36),('7643','2013-08-17','11:10:00',12.3),('7643','2013-08-17','11:15:00',12.47),('7643','2013-08-17','11:20:00',12.71),('7643','2013-08-17','11:25:00',12.63),('7643','2013-08-17','11:30:00',12.68),('7643','2013-08-17','11:35:00',13.03),('7643','2013-08-17','11:40:00',13.25),('7643','2013-08-17','11:45:00',13.19),('7643','2013-08-17','11:50:00',13.32),('7643','2013-08-17','11:55:00',13.49),('7643','2013-08-17','12:00:00',13.54),('7643','2013-08-17','12:05:00',13.96),('7643','2013-08-17','12:10:00',13.76),('7643','2013-08-17','12:15:00',13.95),('7643','2013-08-17','12:20:00',13.99),('7643','2013-08-17','12:25:00',14.3),('7643','2013-08-17','12:30:00',14.57),('7643','2013-08-17','12:35:00',12.6),('7643','2013-08-17','12:40:00',5.92),('7643','2013-08-17','12:45:00',6.79),('7643','2013-08-17','12:50:00',4.81),('7643','2013-08-17','12:55:00',3.84),('7643','2013-08-17','13:00:00',4.43),('7643','2013-08-17','13:05:00',14.87),('7643','2013-08-17','13:10:00',7.91),('7643','2013-08-17','13:15:00',14.6),('7643','2013-08-17','13:20:00',12.44),('7643','2013-08-17','13:25:00',14.84),('7643','2013-08-17','13:30:00',14.64),('7643','2013-08-17','13:35:00',14.55),('7643','2013-08-17','13:40:00',14.48),('7643','2013-08-17','13:45:00',14.32),('7643','2013-08-17','13:50:00',14.3),('7643','2013-08-17','13:55:00',14.19),('7643','2013-08-17','14:00:00',14.17),('7643','2013-08-17','14:05:00',14.29),('7643','2013-08-17','14:10:00',14.01),('7643','2013-08-17','14:15:00',13.98),('7643','2013-08-17','14:20:00',13.97),('7643','2013-08-17','14:25:00',13.77),('7643','2013-08-17','14:30:00',13.8),('7643','2013-08-17','14:35:00',13.77),('7643','2013-08-17','14:40:00',13.66),('7643','2013-08-17','14:45:00',13.58),('7643','2013-08-17','14:50:00',13.41),('7643','2013-08-17','14:55:00',13.28),('7643','2013-08-17','15:00:00',13.13),('7643','2013-08-17','15:05:00',13.05),('7643','2013-08-17','15:10:00',12.91),('7643','2013-08-17','15:15:00',12.83),('7643','2013-08-17','15:20:00',12.6),('7643','2013-08-17','15:25:00',12.41),('7643','2013-08-17','15:30:00',12.24),('7643','2013-08-17','15:35:00',12.03),('7643','2013-08-17','15:40:00',11.83),('7643','2013-08-17','15:45:00',11.67),('7643','2013-08-17','15:50:00',11.52),('7643','2013-08-17','15:55:00',11.3),('7643','2013-08-17','16:00:00',11.04),('7643','2013-08-17','16:05:00',10.83),('7643','2013-08-17','16:10:00',10.63),('7643','2013-08-17','16:15:00',10.39),('7643','2013-08-17','16:20:00',10.15),('7643','2013-08-17','16:25:00',9.9),('7643','2013-08-17','16:30:00',9.69),('7643','2013-08-17','16:35:00',9.47),('7643','2013-08-17','16:40:00',9.19),('7643','2013-08-17','16:45:00',8.96),('7643','2013-08-17','16:50:00',8.71),('7643','2013-08-17','16:55:00',8.46),('7643','2013-08-17','17:00:00',8.2),('7643','2013-08-17','17:05:00',7.89),('7643','2013-08-17','17:10:00',7.58),('7643','2013-08-17','17:15:00',7.31),('7643','2013-08-17','17:20:00',7.05),('7643','2013-08-17','17:25:00',6.76),('7643','2013-08-17','17:30:00',6.44),('7643','2013-08-17','17:35:00',6.12),('7643','2013-08-17','17:40:00',5.79),('7643','2013-08-17','17:45:00',5.4),('7643','2013-08-17','17:50:00',5.04),('7643','2013-08-17','17:55:00',4.73),('7643','2013-08-17','18:00:00',4.36),('7643','2013-08-17','18:05:00',4.08),('7643','2013-08-17','18:10:00',3.76),('7643','2013-08-17','18:15:00',3.46),('7643','2013-08-17','18:20:00',3.17),('7643','2013-08-17','18:25:00',2.85),('7643','2013-08-17','18:30:00',2.51),('7643','2013-08-17','18:35:00',2.27),('7643','2013-08-17','18:40:00',2.03),('7643','2013-08-17','18:45:00',1.77),('7643','2013-08-17','18:50:00',1.54),('7643','2013-08-17','18:55:00',1.28),('7643','2013-08-17','19:00:00',1.02),('7643','2013-08-16','07:15:00',1.12),('7643','2013-08-16','07:20:00',1.34),('7643','2013-08-16','07:25:00',1.56),('7643','2013-08-16','07:30:00',1.8),('7643','2013-08-16','07:35:00',2.02),('7643','2013-08-16','07:40:00',2.29),('7643','2013-08-16','07:45:00',2.58),('7643','2013-08-16','07:50:00',2.9),('7643','2013-08-16','07:55:00',3.22),('7643','2013-08-16','08:00:00',3.49),('7643','2013-08-16','08:05:00',3.75),('7643','2013-08-16','08:10:00',4.06),('7643','2013-08-16','08:15:00',4.38),('7643','2013-08-16','08:20:00',4.67),('7643','2013-08-16','08:25:00',4.98),('7643','2013-08-16','08:30:00',5.28),('7643','2013-08-16','08:35:00',5.6),('7643','2013-08-16','08:40:00',5.97),('7643','2013-08-16','08:45:00',6.26),('7643','2013-08-16','08:50:00',6.59),('7643','2013-08-16','08:55:00',6.92),('7643','2013-08-16','09:00:00',7.23),('7643','2013-08-16','09:05:00',7.56),('7643','2013-08-16','09:10:00',7.86),('7643','2013-08-16','09:15:00',8.07),('7643','2013-08-16','09:20:00',8.37),('7643','2013-08-16','09:25:00',8.68),('7643','2013-08-16','09:30:00',8.93),('7643','2013-08-16','09:35:00',9.18),('7643','2013-08-16','09:40:00',9.44),('7643','2013-08-16','09:45:00',9.62),('7643','2013-08-16','09:50:00',9.89),('7643','2013-08-16','09:55:00',10.12),('7643','2013-08-16','10:00:00',10.36),('7643','2013-08-16','10:05:00',10.57),('7643','2013-08-16','10:10:00',10.74),('7643','2013-08-16','10:15:00',10.95),('7643','2013-08-16','10:20:00',11.14),('7643','2013-08-16','10:25:00',11.31),('7643','2013-08-16','10:30:00',11.44),('7643','2013-08-16','10:35:00',11.61),('7643','2013-08-16','10:40:00',11.74),('7643','2013-08-16','10:45:00',11.89),('7643','2013-08-16','10:50:00',12.19),('7643','2013-08-16','10:55:00',12.38),('7643','2013-08-16','11:00:00',12.41),('7643','2013-08-16','11:05:00',12.45),('7643','2013-08-16','11:10:00',12.61),('7643','2013-08-16','11:15:00',12.86),('7643','2013-08-16','11:20:00',12.89),('7643','2013-08-16','11:25:00',13.01),('7643','2013-08-16','11:30:00',12.98),('7643','2013-08-16','11:35:00',13.11),('7643','2013-08-16','11:40:00',13.18),('7643','2013-08-16','11:45:00',13.46),('7643','2013-08-16','11:50:00',13.72),('7643','2013-08-16','11:55:00',13.64),('7643','2013-08-16','12:00:00',13.57),('7643','2013-08-16','12:05:00',13.35),('7643','2013-08-16','12:10:00',13.8),('7643','2013-08-16','12:15:00',14.16),('7643','2013-08-16','12:20:00',14.26),('7643','2013-08-16','12:25:00',12.46),('7643','2013-08-16','12:30:00',3.85),('7643','2013-08-16','12:35:00',14.14),('7643','2013-08-16','12:40:00',14.9),('7643','2013-08-16','12:45:00',14.47),('7643','2013-08-16','12:50:00',14.31),('7643','2013-08-16','12:55:00',14.49),('7643','2013-08-16','13:00:00',14.49),('7643','2013-08-16','13:05:00',14.53),('7643','2013-08-16','13:10:00',14.69),('7643','2013-08-16','13:15:00',14.22),('7643','2013-08-16','13:20:00',14.39),('7643','2013-08-16','13:25:00',14.93),('7643','2013-08-16','13:30:00',14.97),('7643','2013-08-16','13:35:00',15.11),('7643','2013-08-16','13:40:00',10.96),('7643','2013-08-16','13:45:00',5.92),('7643','2013-08-16','13:50:00',15.38),('7643','2013-08-16','13:55:00',8.99),('7643','2013-08-16','14:00:00',14.16),('7643','2013-08-16','14:05:00',14.56),('7643','2013-08-16','14:10:00',14.34),('7643','2013-08-16','14:15:00',13.89),('7643','2013-08-16','14:20:00',14.35),('7643','2013-08-16','14:25:00',14.07),('7643','2013-08-16','14:30:00',13.93),('7643','2013-08-16','14:35:00',13.62),('7643','2013-08-16','14:40:00',13.68),('7643','2013-08-16','14:45:00',13.46),('7643','2013-08-16','14:50:00',13.43),('7643','2013-08-16','14:55:00',13.14),('7643','2013-08-16','15:00:00',13.15),('7643','2013-08-16','15:05:00',13.07),('7643','2013-08-16','15:10:00',12.84),('7643','2013-08-16','15:15:00',12.52),('7643','2013-08-16','15:20:00',12.52),('7643','2013-08-16','15:25:00',12.33),('7643','2013-08-16','15:30:00',12.27),('7643','2013-08-16','15:35:00',12.06),('7643','2013-08-16','15:40:00',11.88),('7643','2013-08-16','15:45:00',11.7),('7643','2013-08-16','15:50:00',11.48),('7643','2013-08-16','15:55:00',11.33),('7643','2013-08-16','16:00:00',11.1),('7643','2013-08-16','16:05:00',10.9),('7643','2013-08-16','16:10:00',10.78),('7643','2013-08-16','16:15:00',10.59),('7643','2013-08-16','16:20:00',10.21),('7643','2013-08-16','16:25:00',10.15),('7643','2013-08-16','16:30:00',9.54),('7643','2013-08-16','16:35:00',9.56),('7643','2013-08-16','16:40:00',9.48),('7643','2013-08-16','16:45:00',9.13),('7643','2013-08-16','16:50:00',8.69),('7643','2013-08-16','16:55:00',8.63),('7643','2013-08-16','17:00:00',8.39),('7643','2013-08-16','17:05:00',7.99),('7643','2013-08-16','17:10:00',7.66),('7643','2013-08-16','17:15:00',6.7),('7643','2013-08-16','17:20:00',6.91),('7643','2013-08-16','17:25:00',6.98),('7643','2013-08-16','17:30:00',6.81),('7643','2013-08-16','17:35:00',6.54),('7643','2013-08-16','17:40:00',6.2),('7643','2013-08-16','17:45:00',5.84),('7643','2013-08-16','17:50:00',5.44),('7643','2013-08-16','17:55:00',5.07),('7643','2013-08-16','18:00:00',4.65),('7643','2013-08-16','18:05:00',4.37),('7643','2013-08-16','18:10:00',4.02),('7643','2013-08-16','18:15:00',3.72),('7643','2013-08-16','18:20:00',3.4),('7643','2013-08-16','18:25:00',3.04),('7643','2013-08-16','18:30:00',2.67),('7643','2013-08-16','18:35:00',2.42),('7643','2013-08-16','18:40:00',2.15),('7643','2013-08-16','18:45:00',1.89),('7643','2013-08-16','18:50:00',1.63),('7643','2013-08-16','18:55:00',1.34),('7643','2013-08-16','19:00:00',1.07),('7643','2013-08-15','07:15:00',1.16),('7643','2013-08-15','07:20:00',1.37),('7643','2013-08-15','07:25:00',1.62),('7643','2013-08-15','07:30:00',1.85),('7643','2013-08-15','07:35:00',2.09),('7643','2013-08-15','07:40:00',2.36),('7643','2013-08-15','07:45:00',2.64),('7643','2013-08-15','07:50:00',2.94),('7643','2013-08-15','07:55:00',3.25),('7643','2013-08-15','08:00:00',3.55),('7643','2013-08-15','08:05:00',3.86),('7643','2013-08-15','08:10:00',4.19),('7643','2013-08-15','08:15:00',4.53),('7643','2013-08-15','08:20:00',4.85),('7643','2013-08-15','08:25:00',5.19),('7643','2013-08-15','08:30:00',5.51),('7643','2013-08-15','08:35:00',5.83),('7643','2013-08-15','08:40:00',6.14),('7643','2013-08-15','08:45:00',6.36),('7643','2013-08-15','08:50:00',6.69),('7643','2013-08-15','08:55:00',7.08),('7643','2013-08-15','09:00:00',7.4),('7643','2013-08-15','09:05:00',7.74),('7643','2013-08-15','09:10:00',8.02),('7643','2013-08-15','09:15:00',8.38),('7643','2013-08-15','09:20:00',8.68),('7643','2013-08-15','09:25:00',8.96),('7643','2013-08-15','09:30:00',9.22),('7643','2013-08-15','09:35:00',9.52),('7643','2013-08-15','09:40:00',9.8),('7643','2013-08-15','09:45:00',10.01),('7643','2013-08-15','09:50:00',10.28),('7643','2013-08-15','09:55:00',10.51),('7643','2013-08-15','10:00:00',10.76),('7643','2013-08-15','10:05:00',10.99),('7643','2013-08-15','10:10:00',11.21),('7643','2013-08-15','10:15:00',11.4),('7643','2013-08-15','10:20:00',11.56),('7643','2013-08-15','10:25:00',11.75),('7643','2013-08-15','10:30:00',11.96),('7643','2013-08-15','10:35:00',12.15),('7643','2013-08-15','10:40:00',12.32),('7643','2013-08-15','10:45:00',12.43),('7643','2013-08-15','10:50:00',12.59),('7643','2013-08-15','10:55:00',12.77),('7643','2013-08-15','11:00:00',12.87),('7643','2013-08-15','11:05:00',13.02),('7643','2013-08-15','11:10:00',13.18),('7643','2013-08-15','11:15:00',13.31),('7643','2013-08-15','11:20:00',13.39),('7643','2013-08-15','11:25:00',13.42),('7643','2013-08-15','11:30:00',13.54),('7643','2013-08-15','11:35:00',13.72),('7643','2013-08-15','11:40:00',13.81),('7643','2013-08-15','11:45:00',13.87),('7643','2013-08-15','11:50:00',13.86),('7643','2013-08-15','11:55:00',13.99),('7643','2013-08-15','12:00:00',14.12),('7643','2013-08-15','12:05:00',14.25),('7643','2013-08-15','12:10:00',14.25),('7643','2013-08-15','12:15:00',14.28),('7643','2013-08-15','12:20:00',14.29),('7643','2013-08-15','12:25:00',14.38),('7643','2013-08-15','12:30:00',14.41),('7643','2013-08-15','12:35:00',14.41),('7643','2013-08-15','12:40:00',14.37),('7643','2013-08-15','12:45:00',14.51),('7643','2013-08-15','12:50:00',14.59),('7643','2013-08-15','12:55:00',14.58),('7643','2013-08-15','13:00:00',14.56),('7643','2013-08-15','13:05:00',14.45),('7643','2013-08-15','13:10:00',14.47),('7643','2013-08-15','13:15:00',14.54),('7643','2013-08-15','13:20:00',14.5),('7643','2013-08-15','13:25:00',14.4),('7643','2013-08-15','13:30:00',14.3),('7643','2013-08-15','13:35:00',14.28),('7643','2013-08-15','13:40:00',14.23),('7643','2013-08-15','13:45:00',14.15),('7643','2013-08-15','13:50:00',14.24),('7643','2013-08-15','13:55:00',14.19),('7643','2013-08-15','14:00:00',14.11),('7643','2013-08-15','14:05:00',14.11),('7643','2013-08-15','14:10:00',14.08),('7643','2013-08-15','14:15:00',13.97),('7643','2013-08-15','14:20:00',13.86),('7643','2013-08-15','14:25:00',13.76),('7643','2013-08-15','14:30:00',13.71),('7643','2013-08-15','14:35:00',13.56),('7643','2013-08-15','14:40:00',13.37),('7643','2013-08-15','14:45:00',13.32),('7643','2013-08-15','14:50:00',13.25),('7643','2013-08-15','14:55:00',13.05),('7643','2013-08-15','15:00:00',12.83),('7643','2013-08-15','15:05:00',12.51),('7643','2013-08-15','15:10:00',12.48),('7643','2013-08-15','15:15:00',12.52),('7643','2013-08-15','15:20:00',12.43),('7643','2013-08-15','15:25:00',12.39),('7643','2013-08-15','15:30:00',12.27),('7643','2013-08-15','15:35:00',12.09),('7643','2013-08-15','15:40:00',11.89),('7643','2013-08-15','15:45:00',11.75),('7643','2013-08-15','15:50:00',11.57),('7643','2013-08-15','15:55:00',11.41),('7643','2013-08-15','16:00:00',11.27),('7643','2013-08-15','16:05:00',11.02),('7643','2013-08-15','16:10:00',10.75),('7643','2013-08-15','16:15:00',10.52),('7643','2013-08-15','16:20:00',10.32),('7643','2013-08-15','16:25:00',10.13),('7643','2013-08-15','16:30:00',9.87),('7643','2013-08-15','16:35:00',9.61),('7643','2013-08-15','16:40:00',9.4),('7643','2013-08-15','16:45:00',9.12),('7643','2013-08-15','16:50:00',8.8),('7643','2013-08-15','16:55:00',8.52),('7643','2013-08-15','17:00:00',8.24),('7643','2013-08-15','17:05:00',7.99),('7643','2013-08-15','17:10:00',7.68),('7643','2013-08-15','17:15:00',7.32),('7643','2013-08-15','17:20:00',7.02),('7643','2013-08-15','17:25:00',6.72),('7643','2013-08-15','17:30:00',6.42),('7643','2013-08-15','17:35:00',6.11),('7643','2013-08-15','17:40:00',5.76),('7643','2013-08-15','17:45:00',5.4),('7643','2013-08-15','17:50:00',5.07),('7643','2013-08-15','17:55:00',4.66),('7643','2013-08-15','18:00:00',4.32),('7643','2013-08-15','18:05:00',4.11),('7643','2013-08-15','18:10:00',3.79),('7643','2013-08-15','18:15:00',3.5),('7643','2013-08-15','18:20:00',3.22),('7643','2013-08-15','18:25:00',2.91),('7643','2013-08-15','18:30:00',2.5),('7643','2013-08-15','18:35:00',1.77),('7643','2013-08-15','18:40:00',1.33),('7643','2013-08-15','18:50:00',1.41),('7643','2013-08-15','18:55:00',1.26),('7643','2013-08-15','19:00:00',1.06),('7643','2013-08-14','07:35:00',1.05),('7643','2013-08-14','07:40:00',1.27),('7643','2013-08-14','07:45:00',1.74),('7643','2013-08-14','07:50:00',2.19),('7643','2013-08-14','07:55:00',2.56),('7643','2013-08-14','08:00:00',4.57),('7643','2013-08-14','08:05:00',4.77),('7643','2013-08-14','08:10:00',4.76),('7643','2013-08-14','08:15:00',4.56),('7643','2013-08-14','08:20:00',5.11),('7643','2013-08-14','08:25:00',5.36),('7643','2013-08-14','08:30:00',5.68),('7643','2013-08-14','08:35:00',5.98),('7643','2013-08-14','08:40:00',6.3),('7643','2013-08-14','08:45:00',6.55),('7643','2013-08-14','08:50:00',7.02),('7643','2013-08-14','08:55:00',7.21),('7643','2013-08-14','09:00:00',7.61),('7643','2013-08-14','09:05:00',7.09),('7643','2013-08-14','09:10:00',4.25),('7643','2013-08-14','09:15:00',5.76),('7643','2013-08-14','09:20:00',9.29),('7643','2013-08-14','09:25:00',9.12),('7643','2013-08-14','09:30:00',9.29),('7643','2013-08-14','09:35:00',9.55),('7643','2013-08-14','09:40:00',9.84),('7643','2013-08-14','09:45:00',10.08),('7643','2013-08-14','09:50:00',10.4),('7643','2013-08-14','09:55:00',10.63),('7643','2013-08-14','10:00:00',10.85),('7643','2013-08-14','10:05:00',11.06),('7643','2013-08-14','10:10:00',11.22),('7643','2013-08-14','10:15:00',11.46),('7643','2013-08-14','10:20:00',11.72),('7643','2013-08-14','10:25:00',11.94),('7643','2013-08-14','10:30:00',12.14),('7643','2013-08-14','10:35:00',12.28),('7643','2013-08-14','10:40:00',12.51),('7643','2013-08-14','10:45:00',12.51),('7643','2013-08-14','10:50:00',12.27),('7643','2013-08-14','10:55:00',12.64),('7643','2013-08-14','11:00:00',11.28),('7643','2013-08-14','11:05:00',8.92),('7643','2013-08-14','11:10:00',8.99),('7643','2013-08-14','11:15:00',10.36),('7643','2013-08-14','11:20:00',11.52),('7643','2013-08-14','11:25:00',12.26),('7643','2013-08-14','11:30:00',13.34),('7643','2013-08-14','11:35:00',13.99),('7643','2013-08-14','11:40:00',14.86),('7643','2013-08-14','11:45:00',15.07),('7643','2013-08-14','11:50:00',15.42),('7643','2013-08-14','11:55:00',15.28),('7643','2013-08-14','12:00:00',15.26),('7643','2013-08-14','12:05:00',15.26),('7643','2013-08-14','12:10:00',15.11),('7643','2013-08-14','12:15:00',15.18),('7643','2013-08-14','12:20:00',15.19),('7643','2013-08-14','12:25:00',15.2),('7643','2013-08-14','12:30:00',15.09),('7643','2013-08-14','12:35:00',15.21),('7643','2013-08-14','12:40:00',15.13),('7643','2013-08-14','12:45:00',15.19),('7643','2013-08-14','12:50:00',15.05),('7643','2013-08-14','12:55:00',14.68),('7643','2013-08-14','13:00:00',14.71),('7643','2013-08-14','13:05:00',14.33),('7643','2013-08-14','13:10:00',14.25),('7643','2013-08-14','13:15:00',14),('7643','2013-08-14','13:20:00',14.47),('7643','2013-08-14','13:25:00',14.94),('7643','2013-08-14','13:30:00',15),('7643','2013-08-14','13:35:00',14.96),('7643','2013-08-14','13:40:00',14.84),('7643','2013-08-14','13:45:00',14.65),('7643','2013-08-14','13:50:00',14.46),('7643','2013-08-14','13:55:00',14.6),('7643','2013-08-14','14:00:00',14.71),('7643','2013-08-14','14:05:00',14.6),('7643','2013-08-14','14:10:00',14.48),('7643','2013-08-14','14:15:00',14.42),('7643','2013-08-14','14:20:00',14.21),('7643','2013-08-14','14:25:00',13.67),('7643','2013-08-14','14:30:00',13.42),('7643','2013-08-14','14:35:00',13.77),('7643','2013-08-14','14:40:00',13.61),('7643','2013-08-14','14:45:00',13.41),('7643','2013-08-14','14:50:00',13.35),('7643','2013-08-14','14:55:00',13.25),('7643','2013-08-14','15:00:00',13.09),('7643','2013-08-14','15:05:00',12.88),('7643','2013-08-14','15:10:00',12.67),('7643','2013-08-14','15:15:00',12.53),('7643','2013-08-14','15:20:00',12.37),('7643','2013-08-14','15:25:00',12.02),('7643','2013-08-14','15:30:00',12.01),('7643','2013-08-14','15:35:00',11.94),('7643','2013-08-14','15:40:00',11.69),('7643','2013-08-14','15:45:00',11.46),('7643','2013-08-14','15:50:00',11.17),('7643','2013-08-14','15:55:00',11.14),('7643','2013-08-14','16:00:00',10.96),('7643','2013-08-14','16:05:00',10.72),('7643','2013-08-14','16:10:00',10.33),('7643','2013-08-14','16:15:00',10.04),('7643','2013-08-14','16:20:00',10.15),('7643','2013-08-14','16:25:00',9.83),('7643','2013-08-14','16:30:00',9.3),('7643','2013-08-14','16:35:00',9),('7643','2013-08-14','16:40:00',9.03),('7643','2013-08-14','16:45:00',8.78),('7643','2013-08-14','16:50:00',8.42),('7643','2013-08-14','16:55:00',8.12),('7643','2013-08-14','17:00:00',7.9),('7643','2013-08-14','17:05:00',7.65),('7643','2013-08-14','17:10:00',7.28),('7643','2013-08-14','17:15:00',4.88),('7643','2013-08-14','17:20:00',6.49),('7643','2013-08-14','17:25:00',6.68),('7643','2013-08-14','17:30:00',6.4),('7643','2013-08-14','17:35:00',6.03),('7643','2013-08-14','17:40:00',5.64),('7643','2013-08-14','17:45:00',5.44),('7643','2013-08-14','17:50:00',5.12),('7643','2013-08-14','17:55:00',4.72),('7643','2013-08-14','18:00:00',4.39),('7643','2013-08-14','18:05:00',4.1),('7643','2013-08-14','18:10:00',3.73),('7643','2013-08-14','18:15:00',3.43),('7643','2013-08-14','18:20:00',3.23),('7643','2013-08-14','18:25:00',2.95),('7643','2013-08-14','18:30:00',2.66),('7643','2013-08-14','18:35:00',2.44),('7643','2013-08-14','18:40:00',2.29),('7643','2013-08-14','18:45:00',1.87),('7643','2013-08-14','18:50:00',1.16),('7643','2013-08-14','18:55:00',1.03),('7643','2013-08-13','07:15:00',1.14),('7643','2013-08-13','07:20:00',1.39),('7643','2013-08-13','07:25:00',1.65),('7643','2013-08-13','07:30:00',1.89),('7643','2013-08-13','07:35:00',2.13),('7643','2013-08-13','07:40:00',2.43),('7643','2013-08-13','07:45:00',2.7),('7643','2013-08-13','07:50:00',3.05),('7643','2013-08-13','07:55:00',3.38),('7643','2013-08-13','08:00:00',3.63),('7643','2013-08-13','08:05:00',3.9),('7643','2013-08-13','08:10:00',4.27),('7643','2013-08-13','08:15:00',4.57),('7643','2013-08-13','08:20:00',4.49),('7643','2013-08-13','08:25:00',5.05),('7643','2013-08-13','08:30:00',5.41),('7643','2013-08-13','08:35:00',5.72),('7643','2013-08-13','08:40:00',6.17),('7643','2013-08-13','08:45:00',6.29),('7643','2013-08-13','08:50:00',5.55),('7643','2013-08-13','08:55:00',6.55),('7643','2013-08-13','09:00:00',7.42),('7643','2013-08-13','09:05:00',7.66),('7643','2013-08-13','09:10:00',7.88),('7643','2013-08-13','09:15:00',8.35),('7643','2013-08-13','09:20:00',8.69),('7643','2013-08-13','09:25:00',8.28),('7643','2013-08-13','09:30:00',9.24),('7643','2013-08-13','09:35:00',9.51),('7643','2013-08-13','09:40:00',3.92),('7643','2013-08-13','09:45:00',3.64),('7643','2013-08-13','09:50:00',6.72),('7643','2013-08-13','09:55:00',9.38),('7643','2013-08-13','10:00:00',7.19),('7643','2013-08-13','10:05:00',10.87),('7643','2013-08-13','10:10:00',10.34),('7643','2013-08-13','10:15:00',5.8),('7643','2013-08-13','10:20:00',3.46),('7643','2013-08-13','10:25:00',3.66),('7643','2013-08-13','10:30:00',9.32),('7643','2013-08-13','10:35:00',13.14),('7643','2013-08-13','10:40:00',13.2),('7643','2013-08-13','10:45:00',12.94),('7643','2013-08-13','10:50:00',8.75),('7643','2013-08-13','10:55:00',4.89),('7643','2013-08-13','11:00:00',8.67),('7643','2013-08-13','11:05:00',12.28),('7643','2013-08-13','11:10:00',12.76),('7643','2013-08-13','11:15:00',12.59),('7643','2013-08-13','11:20:00',11.85),('7643','2013-08-13','11:25:00',9.73),('7643','2013-08-13','11:30:00',14.05),('7643','2013-08-13','11:35:00',13.79),('7643','2013-08-13','11:40:00',13.64),('7643','2013-08-13','11:45:00',12.47),('7643','2013-08-13','11:50:00',12.78),('7643','2013-08-13','11:55:00',13.26),('7643','2013-08-13','12:00:00',10.44),('7643','2013-08-13','12:05:00',6.74),('7643','2013-08-13','12:10:00',7.52),('7643','2013-08-13','12:15:00',8.72),('7643','2013-08-13','12:20:00',4.29),('7643','2013-08-13','12:25:00',4.59),('7643','2013-08-13','12:30:00',4.41),('7643','2013-08-13','12:35:00',4.38),('7643','2013-08-13','12:40:00',4.61),('7643','2013-08-13','12:45:00',7.37),('7643','2013-08-13','12:50:00',8.7),('7643','2013-08-13','12:55:00',5.94),('7643','2013-08-13','13:00:00',8.18),('7643','2013-08-13','13:05:00',4.3),('7643','2013-08-13','13:10:00',4.2),('7643','2013-08-13','13:15:00',3.4),('7643','2013-08-13','13:20:00',3.22),('7643','2013-08-13','13:25:00',9.55),('7643','2013-08-13','13:30:00',11.59),('7643','2013-08-13','13:35:00',12.3),('7643','2013-08-13','13:40:00',12.64),('7643','2013-08-13','13:45:00',16.13),('7643','2013-08-13','13:50:00',15.95),('7643','2013-08-13','13:55:00',16.42),('7643','2013-08-13','14:00:00',14.96),('7643','2013-08-13','14:05:00',15.43),('7643','2013-08-13','14:10:00',15.41),('7643','2013-08-13','14:15:00',15.02),('7643','2013-08-13','14:20:00',14.67),('7643','2013-08-13','14:25:00',14.85),('7643','2013-08-13','14:30:00',11.02),('7643','2013-08-13','14:35:00',13.18),('7643','2013-08-13','14:40:00',14.27),('7643','2013-08-13','14:45:00',13.91),('7643','2013-08-13','14:50:00',13.5),('7643','2013-08-13','14:55:00',13.71),('7643','2013-08-13','15:00:00',13.83),('7643','2013-08-13','15:05:00',13.25),('7643','2013-08-13','15:10:00',13.41),('7643','2013-08-13','15:15:00',13.28),('7643','2013-08-13','15:20:00',12.27),('7643','2013-08-13','15:25:00',12.56),('7643','2013-08-13','15:30:00',12.54),('7643','2013-08-13','15:35:00',12.27),('7643','2013-08-13','15:40:00',12.18),('7643','2013-08-13','15:45:00',11.99),('7643','2013-08-13','15:50:00',11.89),('7643','2013-08-13','15:55:00',11.53),('7643','2013-08-13','16:00:00',11.26),('7643','2013-08-13','16:05:00',11.13),('7643','2013-08-13','16:10:00',11.05),('7643','2013-08-13','16:15:00',10.87),('7643','2013-08-13','16:20:00',10.73),('7643','2013-08-13','16:25:00',10.3),('7643','2013-08-13','16:30:00',10.16),('7643','2013-08-13','16:35:00',9.93),('7643','2013-08-13','16:40:00',9.6),('7643','2013-08-13','16:45:00',9.36),('7643','2013-08-13','16:50:00',9.08),('7643','2013-08-13','16:55:00',8.84),('7643','2013-08-13','17:00:00',8.53),('7643','2013-08-13','17:05:00',8.23),('7643','2013-08-13','17:10:00',7.93),('7643','2013-08-13','17:15:00',7.66),('7643','2013-08-13','17:20:00',7.34),('7643','2013-08-13','17:25:00',7.03),('7643','2013-08-13','17:30:00',6.71),('7643','2013-08-13','17:35:00',6.42),('7643','2013-08-13','17:40:00',6.06),('7643','2013-08-13','17:45:00',5.69),('7643','2013-08-13','17:50:00',5.36),('7643','2013-08-13','17:55:00',5.03),('7643','2013-08-13','18:00:00',4.65),('7643','2013-08-13','18:05:00',4.42),('7643','2013-08-13','18:10:00',4.05),('7643','2013-08-13','18:15:00',3.74),('7643','2013-08-13','18:20:00',3.74),('7643','2013-08-13','18:25:00',3.61),('7643','2013-08-13','18:30:00',3.19),('7643','2013-08-13','18:35:00',2.82),('7643','2013-08-13','18:40:00',2.55),('7643','2013-08-13','18:45:00',2.59),('7643','2013-08-13','18:50:00',2.55),('7643','2013-08-13','18:55:00',2.31),('7643','2013-08-13','19:00:00',2.11),('7643','2013-08-13','19:05:00',1.59),('7643','2013-08-13','19:10:00',1.24),('7643','2013-08-12','07:10:00',1.09),('7643','2013-08-12','07:15:00',1.29),('7643','2013-08-12','07:20:00',1.47),('7643','2013-08-12','07:25:00',1.72),('7643','2013-08-12','07:30:00',1.99),('7643','2013-08-12','07:35:00',2.23),('7643','2013-08-12','07:40:00',2.5),('7643','2013-08-12','07:45:00',2.76),('7643','2013-08-12','07:50:00',3.12),('7643','2013-08-12','07:55:00',3.45),('7643','2013-08-12','08:00:00',3.7),('7643','2013-08-12','08:05:00',4.08),('7643','2013-08-12','08:10:00',4.29),('7643','2013-08-12','08:15:00',4.64),('7643','2013-08-12','08:20:00',4.91),('7643','2013-08-12','08:25:00',5.27),('7643','2013-08-12','08:30:00',5.6),('7643','2013-08-12','08:35:00',5.94),('7643','2013-08-12','08:40:00',6.24),('7643','2013-08-12','08:45:00',6.44),('7643','2013-08-12','08:50:00',6.84),('7643','2013-08-12','08:55:00',7.12),('7643','2013-08-12','09:00:00',7.47),('7643','2013-08-12','09:05:00',7.73),('7643','2013-08-12','09:10:00',8.07),('7643','2013-08-12','09:15:00',8.36),('7643','2013-08-12','09:20:00',8.62),('7643','2013-08-12','09:25:00',8.94),('7643','2013-08-12','09:30:00',9.18),('7643','2013-08-12','09:35:00',7.82),('7643','2013-08-12','09:40:00',8.59),('7643','2013-08-12','09:45:00',9.84),('7643','2013-08-12','09:50:00',10.09),('7643','2013-08-12','09:55:00',9.84),('7643','2013-08-12','10:00:00',10.5),('7643','2013-08-12','10:05:00',10.77),('7643','2013-08-12','10:10:00',11.03),('7643','2013-08-12','10:15:00',11.21),('7643','2013-08-12','10:20:00',11.19),('7643','2013-08-12','10:25:00',11.3),('7643','2013-08-12','10:30:00',11.21),('7643','2013-08-12','10:35:00',11.58),('7643','2013-08-12','10:40:00',12.07),('7643','2013-08-12','10:45:00',12.17),('7643','2013-08-12','10:50:00',12.29),('7643','2013-08-12','10:55:00',12.4),('7643','2013-08-12','11:00:00',12.68),('7643','2013-08-12','11:05:00',12.76),('7643','2013-08-12','11:10:00',12.91),('7643','2013-08-12','11:15:00',12.96),('7643','2013-08-12','11:20:00',13.18),('7643','2013-08-12','11:25:00',13.26),('7643','2013-08-12','11:30:00',13.31),('7643','2013-08-12','11:35:00',13.29),('7643','2013-08-12','11:40:00',13.46),('7643','2013-08-12','11:45:00',13.37),('7643','2013-08-12','11:50:00',13.88),('7643','2013-08-12','11:55:00',14.16),('7643','2013-08-12','12:00:00',14.22),('7643','2013-08-12','12:05:00',14.34),('7643','2013-08-12','12:10:00',14.66),('7643','2013-08-12','12:15:00',14.61),('7643','2013-08-12','12:20:00',14.63),('7643','2013-08-12','12:25:00',15.13),('7643','2013-08-12','12:30:00',14.95),('7643','2013-08-12','12:35:00',15.13),('7643','2013-08-12','12:40:00',13.48),('7643','2013-08-12','12:45:00',6.75),('7643','2013-08-12','12:50:00',4.4),('7643','2013-08-12','12:55:00',5.94),('7643','2013-08-12','13:00:00',16.69),('7643','2013-08-12','13:05:00',12.73),('7643','2013-08-12','13:10:00',4.17),('7643','2013-08-12','13:15:00',8.99),('7643','2013-08-12','13:20:00',15.96),('7643','2013-08-12','13:25:00',16.39),('7643','2013-08-12','13:30:00',9.35),('7643','2013-08-12','13:35:00',15.19),('7643','2013-08-12','13:40:00',10.36),('7643','2013-08-12','13:45:00',10.93),('7643','2013-08-12','13:50:00',12.15),('7643','2013-08-12','13:55:00',16.5),('7643','2013-08-12','14:00:00',10.01),('7643','2013-08-12','14:05:00',12.88),('7643','2013-08-12','14:10:00',16.52),('7643','2013-08-12','14:15:00',12.27),('7643','2013-08-12','14:20:00',15.38),('7643','2013-08-12','14:25:00',6.36),('7643','2013-08-12','14:30:00',8.67),('7643','2013-08-12','14:35:00',16.22),('7643','2013-08-12','14:40:00',7.1),('7643','2013-08-12','14:45:00',8.15),('7643','2013-08-12','14:50:00',14.27),('7643','2013-08-12','14:55:00',15.57),('7643','2013-08-12','15:00:00',14.21),('7643','2013-08-12','15:05:00',10.82),('7643','2013-08-12','15:10:00',13.46),('7643','2013-08-12','15:15:00',8.34),('7643','2013-08-12','15:20:00',12.59),('7643','2013-08-12','15:25:00',13.18),('7643','2013-08-12','15:30:00',12.31),('7643','2013-08-12','15:35:00',12.55),('7643','2013-08-12','15:40:00',12.74),('7643','2013-08-12','15:45:00',12.14),('7643','2013-08-12','15:50:00',11.86),('7643','2013-08-12','15:55:00',11.59),('7643','2013-08-12','16:00:00',11.43),('7643','2013-08-12','16:05:00',11.21),('7643','2013-08-12','16:10:00',10.96),('7643','2013-08-12','16:15:00',10.73),('7643','2013-08-12','16:20:00',10.51),('7643','2013-08-12','16:25:00',10.31),('7643','2013-08-12','16:30:00',10.06),('7643','2013-08-12','16:35:00',9.8),('7643','2013-08-12','16:40:00',9.51),('7643','2013-08-12','16:45:00',9.24),('7643','2013-08-12','16:50:00',9.01),('7643','2013-08-12','16:55:00',8.73),('7643','2013-08-12','17:00:00',8.5),('7643','2013-08-12','17:05:00',8.25),('7643','2013-08-12','17:10:00',7.98),('7643','2013-08-12','17:15:00',7.66),('7643','2013-08-12','17:20:00',7.35),('7643','2013-08-12','17:25:00',7.09),('7643','2013-08-12','17:30:00',6.76),('7643','2013-08-12','17:35:00',6.42),('7643','2013-08-12','17:40:00',6.02),('7643','2013-08-12','17:45:00',5.69),('7643','2013-08-12','17:50:00',5.4),('7643','2013-08-12','17:55:00',5.02),('7643','2013-08-12','18:00:00',4.68),('7643','2013-08-12','18:05:00',4.39),('7643','2013-08-12','18:10:00',4.01),('7643','2013-08-12','18:15:00',3.73),('7643','2013-08-12','18:20:00',3.47),('7643','2013-08-12','18:25:00',3.13),('7643','2013-08-12','18:30:00',2.84),('7643','2013-08-12','18:35:00',2.56),('7643','2013-08-12','18:40:00',2.29),('7643','2013-08-12','18:45:00',2.03),('7643','2013-08-12','18:50:00',1.77),('7643','2013-08-12','18:55:00',1.51),('7643','2013-08-12','19:00:00',1.26),('7643','2013-08-12','19:05:00',1.05),('7643','2013-08-11','07:10:00',1.08),('7643','2013-08-11','07:15:00',1.28),('7643','2013-08-11','07:20:00',1.49),('7643','2013-08-11','07:25:00',1.72),('7643','2013-08-11','07:30:00',1.96),('7643','2013-08-11','07:35:00',2.23),('7643','2013-08-11','07:40:00',2.5),('7643','2013-08-11','07:45:00',2.77),('7643','2013-08-11','07:50:00',3.07),('7643','2013-08-11','07:55:00',3.4),('7643','2013-08-11','08:00:00',3.69),('7643','2013-08-11','08:05:00',4.01),('7643','2013-08-11','08:10:00',4.32),('7643','2013-08-11','08:15:00',4.62),('7643','2013-08-11','08:20:00',4.94),('7643','2013-08-11','08:25:00',5.25),('7643','2013-08-11','08:30:00',5.56),('7643','2013-08-11','08:35:00',5.86),('7643','2013-08-11','08:40:00',6.14),('7643','2013-08-11','08:45:00',6.38),('7643','2013-08-11','08:50:00',6.73),('7643','2013-08-11','08:55:00',7.05),('7643','2013-08-11','09:00:00',7.35),('7643','2013-08-11','09:05:00',7.6),('7643','2013-08-11','09:10:00',7.94),('7643','2013-08-11','09:15:00',8.2),('7643','2013-08-11','09:20:00',8.47),('7643','2013-08-11','09:25:00',8.77),('7643','2013-08-11','09:30:00',9.01),('7643','2013-08-11','09:35:00',9.28),('7643','2013-08-11','09:40:00',9.5),('7643','2013-08-11','09:45:00',9.71),('7643','2013-08-11','09:50:00',9.94),('7643','2013-08-11','09:55:00',10.19),('7643','2013-08-11','10:00:00',10.36),('7643','2013-08-11','10:05:00',10.56),('7643','2013-08-11','10:10:00',10.74),('7643','2013-08-11','10:15:00',10.94),('7643','2013-08-11','10:20:00',11.14),('7643','2013-08-11','10:25:00',11.37),('7643','2013-08-11','10:30:00',11.57),('7643','2013-08-11','10:35:00',11.72),('7643','2013-08-11','10:40:00',11.83),('7643','2013-08-11','10:45:00',11.95),('7643','2013-08-11','10:50:00',12.11),('7643','2013-08-11','10:55:00',12.3),('7643','2013-08-11','11:00:00',12.44),('7643','2013-08-11','11:05:00',12.52),('7643','2013-08-11','11:10:00',12.46),('7643','2013-08-11','11:15:00',12.82),('7643','2013-08-11','11:20:00',12.71),('7643','2013-08-11','11:25:00',12.98),('7643','2013-08-11','11:30:00',13.24),('7643','2013-08-11','11:35:00',13.37),('7643','2013-08-11','11:40:00',13.53),('7643','2013-08-11','11:45:00',13.6),('7643','2013-08-11','11:50:00',13.72),('7643','2013-08-11','11:55:00',13.8),('7643','2013-08-11','12:00:00',14.28),('7643','2013-08-11','12:05:00',14.36),('7643','2013-08-11','12:10:00',14.43),('7643','2013-08-11','12:15:00',13.11),('7643','2013-08-11','12:20:00',12.15),('7643','2013-08-11','12:25:00',6.36),('7643','2013-08-11','12:30:00',3.16),('7643','2013-08-11','12:35:00',3.48),('7643','2013-08-11','12:40:00',4.3),('7643','2013-08-11','12:45:00',6.07),('7643','2013-08-11','12:50:00',11.68),('7643','2013-08-11','12:55:00',5.3),('7643','2013-08-11','13:00:00',4.81),('7643','2013-08-11','13:05:00',3.07),('7643','2013-08-11','13:10:00',2.69),('7643','2013-08-11','13:15:00',2.65),('7643','2013-08-11','13:20:00',3.32),('7643','2013-08-11','13:25:00',7.39),('7643','2013-08-11','13:30:00',4.27),('7643','2013-08-11','13:35:00',4.69),('7643','2013-08-11','13:40:00',3.77),('7643','2013-08-11','13:45:00',3.54),('7643','2013-08-11','13:50:00',12.86),('7643','2013-08-11','13:55:00',8.48),('7643','2013-08-11','14:00:00',4.37),('7643','2013-08-11','14:05:00',3.45),('7643','2013-08-11','14:10:00',7.77),('7643','2013-08-11','14:15:00',6.09),('7643','2013-08-11','14:20:00',3.82),('7643','2013-08-11','14:25:00',3.05),('7643','2013-08-11','14:30:00',3.11),('7643','2013-08-11','14:35:00',3.77),('7643','2013-08-11','14:40:00',4.13),('7643','2013-08-11','14:45:00',4.96),('7643','2013-08-11','14:50:00',12.48),('7643','2013-08-11','14:55:00',15.82),('7643','2013-08-11','15:00:00',15.09),('7643','2013-08-11','15:05:00',14.51),('7643','2013-08-11','15:10:00',14.04),('7643','2013-08-11','15:15:00',10.52),('7643','2013-08-11','15:20:00',13.13),('7643','2013-08-11','15:25:00',13.2),('7643','2013-08-11','15:30:00',12.71),('7643','2013-08-11','15:35:00',12.23),('7643','2013-08-11','15:40:00',12.26),('7643','2013-08-11','15:45:00',11.86),('7643','2013-08-11','15:50:00',11.95),('7643','2013-08-11','15:55:00',11.72),('7643','2013-08-11','16:00:00',11.38),('7643','2013-08-11','16:05:00',11.19),('7643','2013-08-11','16:10:00',10.98),('7643','2013-08-11','16:15:00',10.7),('7643','2013-08-11','16:20:00',10.37),('7643','2013-08-11','16:25:00',10.17),('7643','2013-08-11','16:30:00',9.93),('7643','2013-08-11','16:35:00',9.79),('7643','2013-08-11','16:40:00',9.33),('7643','2013-08-11','16:45:00',9.15),('7643','2013-08-11','16:50:00',9.03),('7643','2013-08-11','16:55:00',7.93),('7643','2013-08-11','17:00:00',8.18),('7643','2013-08-11','17:05:00',8.12),('7643','2013-08-11','17:10:00',7.88),('7643','2013-08-11','17:15:00',7.53),('7643','2013-08-11','17:20:00',7.2),('7643','2013-08-11','17:25:00',6.92),('7643','2013-08-11','17:30:00',6.71),('7643','2013-08-11','17:35:00',6.32),('7643','2013-08-11','17:40:00',6.05),('7643','2013-08-11','17:45:00',5.71),('7643','2013-08-11','17:50:00',5.35),('7643','2013-08-11','17:55:00',4.95),('7643','2013-08-11','18:00:00',4.72),('7643','2013-08-11','18:05:00',4.48),('7643','2013-08-11','18:10:00',4.07),('7643','2013-08-11','18:15:00',3.79),('7643','2013-08-11','18:20:00',3.57),('7643','2013-08-11','18:25:00',3.32),('7643','2013-08-11','18:30:00',3.04),('7643','2013-08-11','18:35:00',2.76),('7643','2013-08-11','18:40:00',2.5),('7643','2013-08-11','18:45:00',2.26),('7643','2013-08-11','18:50:00',2.04),('7643','2013-08-11','18:55:00',1.74),('7643','2013-08-11','19:00:00',1.47),('7643','2013-08-11','19:05:00',1.25),('7643','2013-08-11','19:10:00',1.03),('7643','2013-08-10','07:10:00',1.09),('7643','2013-08-10','07:15:00',1.27),('7643','2013-08-10','07:20:00',1.51),('7643','2013-08-10','07:25:00',1.76),('7643','2013-08-10','07:30:00',1.97),('7643','2013-08-10','07:35:00',2.24),('7643','2013-08-10','07:40:00',2.52),('7643','2013-08-10','07:45:00',2.85),('7643','2013-08-10','07:50:00',3.19),('7643','2013-08-10','07:55:00',3.53),('7643','2013-08-10','08:00:00',3.84),('7643','2013-08-10','08:05:00',4.17),('7643','2013-08-10','08:10:00',4.47),('7643','2013-08-10','08:15:00',4.79),('7643','2013-08-10','08:20:00',5.11),('7643','2013-08-10','08:25:00',5.38),('7643','2013-08-10','08:30:00',5.7),('7643','2013-08-10','08:35:00',5.96),('7643','2013-08-10','08:40:00',6.29),('7643','2013-08-10','08:45:00',6.6),('7643','2013-08-10','08:50:00',6.91),('7643','2013-08-10','08:55:00',7.18),('7643','2013-08-10','09:00:00',7.52),('7643','2013-08-10','09:05:00',7.75),('7643','2013-08-10','09:10:00',8.08),('7643','2013-08-10','09:15:00',8.27),('7643','2013-08-10','09:20:00',8.59),('7643','2013-08-10','09:25:00',8.95),('7643','2013-08-10','09:30:00',9.16),('7643','2013-08-10','09:35:00',9.46),('7643','2013-08-10','09:40:00',9.73),('7643','2013-08-10','09:45:00',9.99),('7643','2013-08-10','09:50:00',10.22),('7643','2013-08-10','09:55:00',10.49),('7643','2013-08-10','10:00:00',10.71),('7643','2013-08-10','10:05:00',10.97),('7643','2013-08-10','10:10:00',11.23),('7643','2013-08-10','10:15:00',11.45),('7643','2013-08-10','10:20:00',11.62),('7643','2013-08-10','10:25:00',11.79),('7643','2013-08-10','10:30:00',12.07),('7643','2013-08-10','10:35:00',12.14),('7643','2013-08-10','10:40:00',12.31),('7643','2013-08-10','10:45:00',12.49),('7643','2013-08-10','10:50:00',12.71),('7643','2013-08-10','10:55:00',12.81),('7643','2013-08-10','11:00:00',13),('7643','2013-08-10','11:05:00',13.2),('7643','2013-08-10','11:10:00',13.33),('7643','2013-08-10','11:15:00',13.39),('7643','2013-08-10','11:20:00',13.51),('7643','2013-08-10','11:25:00',13.66),('7643','2013-08-10','11:30:00',13.74),('7643','2013-08-10','11:35:00',13.88),('7643','2013-08-10','11:40:00',14.02),('7643','2013-08-10','11:45:00',14.04),('7643','2013-08-10','11:50:00',14.21),('7643','2013-08-10','11:55:00',14.26),('7643','2013-08-10','12:00:00',14.18),('7643','2013-08-10','12:05:00',14.3),('7643','2013-08-10','12:10:00',14.45),('7643','2013-08-10','12:15:00',14.48),('7643','2013-08-10','12:20:00',14.46),('7643','2013-08-10','12:25:00',14.59),('7643','2013-08-10','12:30:00',14.69),('7643','2013-08-10','12:35:00',14.74),('7643','2013-08-10','12:40:00',14.6),('7643','2013-08-10','12:45:00',14.56),('7643','2013-08-10','12:50:00',14.61),('7643','2013-08-10','12:55:00',14.82),('7643','2013-08-10','13:00:00',14.86),('7643','2013-08-10','13:05:00',14.69),('7643','2013-08-10','13:10:00',14.64),('7643','2013-08-10','13:15:00',14.67),('7643','2013-08-10','13:20:00',14.62),('7643','2013-08-10','13:25:00',14.8),('7643','2013-08-10','13:30:00',14.85),('7643','2013-08-10','13:35:00',14.63),('7643','2013-08-10','13:40:00',14.49),('7643','2013-08-10','13:45:00',14.52),('7643','2013-08-10','13:50:00',14.48),('7643','2013-08-10','13:55:00',14.44),('7643','2013-08-10','14:00:00',14.43),('7643','2013-08-10','14:05:00',14.33),('7643','2013-08-10','14:10:00',14.33),('7643','2013-08-10','14:15:00',13.91),('7643','2013-08-10','14:20:00',13.69),('7643','2013-08-10','14:25:00',13.67),('7643','2013-08-10','14:30:00',13.61),('7643','2013-08-10','14:35:00',13.65),('7643','2013-08-10','14:40:00',13.71),('7643','2013-08-10','14:45:00',13.52),('7643','2013-08-10','14:50:00',13.19),('7643','2013-08-10','14:55:00',13.17),('7643','2013-08-10','15:00:00',13.25),('7643','2013-08-10','15:05:00',13),('7643','2013-08-10','15:10:00',12.85),('7643','2013-08-10','15:15:00',12.57),('7643','2013-08-10','15:20:00',12.6),('7643','2013-08-10','15:25:00',12.44),('7643','2013-08-10','15:30:00',12.35),('7643','2013-08-10','15:35:00',11.7),('7643','2013-08-10','15:40:00',11.77),('7643','2013-08-10','15:45:00',11.63),('7643','2013-08-10','15:50:00',11.73),('7643','2013-08-10','15:55:00',11.61),('7643','2013-08-10','16:00:00',11.37),('7643','2013-08-10','16:05:00',11.09),('7643','2013-08-10','16:10:00',10.87),('7643','2013-08-10','16:15:00',10.64),('7643','2013-08-10','16:20:00',10.37),('7643','2013-08-10','16:25:00',10.08),('7643','2013-08-10','16:30:00',9.94),('7643','2013-08-10','16:35:00',9.68),('7643','2013-08-10','16:40:00',9.4),('7643','2013-08-10','16:45:00',9.18),('7643','2013-08-10','16:50:00',8.9),('7643','2013-08-10','16:55:00',8.64),('7643','2013-08-10','17:00:00',8.35),('7643','2013-08-10','17:05:00',8.09),('7643','2013-08-10','17:10:00',7.79),('7643','2013-08-10','17:15:00',7.51),('7643','2013-08-10','17:20:00',7.25),('7643','2013-08-10','17:25:00',6.94),('7643','2013-08-10','17:30:00',6.68),('7643','2013-08-10','17:35:00',6.33),('7643','2013-08-10','17:40:00',5.96),('7643','2013-08-10','17:45:00',5.68),('7643','2013-08-10','17:50:00',5.33),('7643','2013-08-10','17:55:00',4.95),('7643','2013-08-10','18:00:00',4.67),('7643','2013-08-10','18:05:00',4.4),('7643','2013-08-10','18:10:00',3.97),('7643','2013-08-10','18:15:00',3.64),('7643','2013-08-10','18:20:00',3.46),('7643','2013-08-10','18:25:00',3.18),('7643','2013-08-10','18:30:00',2.92),('7643','2013-08-10','18:35:00',2.64),('7643','2013-08-10','18:40:00',2.37),('7643','2013-08-10','18:45:00',2.1),('7643','2013-08-10','18:50:00',1.85),('7643','2013-08-10','18:55:00',1.58),('7643','2013-08-10','19:00:00',1.32),('7643','2013-08-10','19:05:00',1.11),('7643','2013-08-09','07:10:00',1.13),('7643','2013-08-09','07:15:00',1.34),('7643','2013-08-09','07:20:00',1.57),('7643','2013-08-09','07:25:00',1.84),('7643','2013-08-09','07:30:00',2.05),('7643','2013-08-09','07:35:00',2.35),('7643','2013-08-09','07:40:00',2.65),('7643','2013-08-09','07:45:00',2.95),('7643','2013-08-09','07:50:00',3.25),('7643','2013-08-09','07:55:00',3.6),('7643','2013-08-09','08:00:00',3.96),('7643','2013-08-09','08:05:00',4.32),('7643','2013-08-09','08:10:00',4.61),('7643','2013-08-09','08:15:00',4.96),('7643','2013-08-09','08:20:00',5.32),('7643','2013-08-09','08:25:00',5.67),('7643','2013-08-09','08:30:00',5.99),('7643','2013-08-09','08:35:00',6.3),('7643','2013-08-09','08:40:00',6.56),('7643','2013-08-09','08:45:00',6.84),('7643','2013-08-09','08:50:00',7.16),('7643','2013-08-09','08:55:00',7.44),('7643','2013-08-09','09:00:00',7.7),('7643','2013-08-09','09:05:00',7.98),('7643','2013-08-09','09:10:00',8.24),('7643','2013-08-09','09:15:00',8.51),('7643','2013-08-09','09:20:00',8.87),('7643','2013-08-09','09:25:00',9.13),('7643','2013-08-09','09:30:00',7.37),('7643','2013-08-09','09:35:00',9.66),('7643','2013-08-09','09:40:00',9.95),('7643','2013-08-09','09:45:00',10.18),('7643','2013-08-09','09:50:00',10.37),('7643','2013-08-09','09:55:00',10.55),('7643','2013-08-09','10:00:00',10.79),('7643','2013-08-09','10:05:00',10.99),('7643','2013-08-09','10:10:00',11.22),('7643','2013-08-09','10:15:00',11.47),('7643','2013-08-09','10:20:00',11.66),('7643','2013-08-09','10:25:00',11.86),('7643','2013-08-09','10:30:00',12.01),('7643','2013-08-09','10:35:00',12.19),('7643','2013-08-09','10:40:00',12.36),('7643','2013-08-09','10:45:00',12.52),('7643','2013-08-09','10:50:00',12.63),('7643','2013-08-09','10:55:00',12.89),('7643','2013-08-09','11:00:00',13.27),('7643','2013-08-09','11:05:00',13.42),('7643','2013-08-09','11:10:00',13.99),('7643','2013-08-09','11:15:00',8.37),('7643','2013-08-09','11:20:00',13.24),('7643','2013-08-09','11:25:00',7.94),('7643','2013-08-09','11:30:00',11.42),('7643','2013-08-09','11:35:00',14.35),('7643','2013-08-09','11:40:00',14.21),('7643','2013-08-09','11:45:00',14.25),('7643','2013-08-09','11:50:00',14.26),('7643','2013-08-09','11:55:00',14.31),('7643','2013-08-09','12:00:00',14.5),('7643','2013-08-09','12:05:00',14.57),('7643','2013-08-09','12:10:00',14.54),('7643','2013-08-09','12:15:00',14.59),('7643','2013-08-09','12:20:00',14.67),('7643','2013-08-09','12:25:00',14.8),('7643','2013-08-09','12:30:00',14.83),('7643','2013-08-09','12:35:00',14.81),('7643','2013-08-09','12:40:00',14.96),('7643','2013-08-09','12:45:00',15.25),('7643','2013-08-09','12:50:00',15.51),('7643','2013-08-09','12:55:00',15.5),('7643','2013-08-09','13:00:00',15.3),('7643','2013-08-09','13:05:00',15.17),('7643','2013-08-09','13:10:00',15.26),('7643','2013-08-09','13:15:00',15.49),('7643','2013-08-09','13:20:00',15.7),('7643','2013-08-09','13:25:00',15.67),('7643','2013-08-09','13:30:00',15.06),('7643','2013-08-09','13:35:00',12.84),('7643','2013-08-09','13:40:00',4.29),('7643','2013-08-09','13:45:00',2.48),('7643','2013-08-09','13:50:00',16.24),('7643','2013-08-09','13:55:00',15.66),('7643','2013-08-09','14:00:00',12.67),('7643','2013-08-09','14:05:00',7.06),('7643','2013-08-09','14:10:00',11.6),('7643','2013-08-09','14:15:00',15.4),('7643','2013-08-09','14:20:00',9.67),('7643','2013-08-09','14:25:00',4.63),('7643','2013-08-09','14:30:00',4.6),('7643','2013-08-09','14:35:00',4.1),('7643','2013-08-09','14:40:00',3.78),('7643','2013-08-09','14:45:00',3.53),('7643','2013-08-09','14:50:00',3.24),('7643','2013-08-09','14:55:00',3.08),('7643','2013-08-09','15:00:00',3.44),('7643','2013-08-09','15:05:00',3.77),('7643','2013-08-09','15:10:00',4.02),('7643','2013-08-09','15:15:00',4.6),('7643','2013-08-09','15:20:00',4.69),('7643','2013-08-09','15:25:00',4.26),('7643','2013-08-09','15:30:00',4.07),('7643','2013-08-09','15:35:00',4.97),('7643','2013-08-09','15:40:00',4.86),('7643','2013-08-09','15:45:00',5.12),('7643','2013-08-09','15:50:00',6.05),('7643','2013-08-09','15:55:00',7.01),('7643','2013-08-09','16:00:00',6.91),('7643','2013-08-09','16:05:00',13.84),('7643','2013-08-09','16:10:00',7.62),('7643','2013-08-09','16:15:00',6.51),('7643','2013-08-09','16:20:00',10.03),('7643','2013-08-09','16:25:00',4.69),('7643','2013-08-09','16:30:00',6.24),('7643','2013-08-09','16:35:00',11.64),('7643','2013-08-09','16:40:00',10.73),('7643','2013-08-09','16:45:00',10.49),('7643','2013-08-09','16:50:00',9.9),('7643','2013-08-09','16:55:00',9.13),('7643','2013-08-09','17:00:00',8.79),('7643','2013-08-09','17:05:00',4.97),('7643','2013-08-09','17:10:00',3.07),('7643','2013-08-09','17:15:00',3.63),('7643','2013-08-09','17:20:00',3.87),('7643','2013-08-09','17:25:00',4.54),('7643','2013-08-09','17:30:00',2.42),('7643','2013-08-09','17:35:00',1.6),('7643','2013-08-09','17:40:00',1.51),('7643','2013-08-09','17:45:00',1.82),('7643','2013-08-09','17:50:00',2.16),('7643','2013-08-09','17:55:00',3.02),('7643','2013-08-09','18:00:00',2.76),('7643','2013-08-09','18:05:00',1.02),('7643','2013-08-09','18:10:00',1.08),('7643','2013-08-09','18:15:00',1.06),('7643','2013-08-09','18:20:00',1.4),('7643','2013-08-09','18:25:00',1.8),('7643','2013-08-09','18:30:00',1.47),('7643','2013-08-09','18:35:00',1.32),('7643','2014-04-08','07:30:00',1.14),('7643','2014-04-08','07:35:00',1.16),('7643','2014-04-08','07:40:00',1.45),('7643','2014-04-08','07:45:00',1.71),('7643','2014-04-08','07:50:00',1.38),('7643','2014-04-08','07:55:00',2.03),('7643','2014-04-08','08:00:00',3.26),('7643','2014-04-08','08:05:00',4.06),('7643','2014-04-08','08:10:00',3.82),('7643','2014-04-08','08:15:00',3.14),('7643','2014-04-08','08:20:00',4.72),('7643','2014-04-08','08:25:00',3.27),('7643','2014-04-08','08:30:00',2.99),('7643','2014-04-08','08:35:00',2.08),('7643','2014-04-08','08:40:00',1.09),('7643','2014-04-08','08:45:00',1.24),('7643','2014-04-08','08:50:00',1.76),('7643','2014-04-08','08:55:00',2.82),('7643','2014-04-08','09:00:00',3.51),('7643','2014-04-08','09:05:00',3.2),('7643','2014-04-08','09:10:00',3.08),('7643','2014-04-08','09:15:00',3.04),('7643','2014-04-08','09:20:00',3.13),('7643','2014-04-08','09:25:00',3.51),('7643','2014-04-08','09:30:00',3.78),('7643','2014-04-08','09:35:00',3.49),('7643','2014-04-08','09:40:00',3.6),('7643','2014-04-08','09:45:00',4.22),('7643','2014-04-08','09:50:00',8.06),('7643','2014-04-08','09:55:00',11.92),('7643','2014-04-08','10:00:00',11.72),('7643','2014-04-08','10:05:00',11.91),('7643','2014-04-08','10:10:00',12.22),('7643','2014-04-08','10:15:00',12.72),('7643','2014-04-08','10:20:00',12.87),('7643','2014-04-08','10:25:00',11.82),('7643','2014-04-08','10:30:00',13.64),('7643','2014-04-08','10:35:00',15.47),('7643','2014-04-08','10:40:00',6.8),('7643','2014-04-08','10:45:00',4.58),('7643','2014-04-08','10:50:00',3.71),('7643','2014-04-08','10:55:00',6.13),('7643','2014-04-08','11:00:00',16.65),('7643','2014-04-08','11:05:00',16),('7643','2014-04-08','11:10:00',16.11),('7643','2014-04-08','11:15:00',16.87),('7643','2014-04-08','11:20:00',15.46),('7643','2014-04-08','11:25:00',9.55),('7643','2014-04-08','11:30:00',5.77),('7643','2014-04-08','11:35:00',9.95),('7643','2014-04-08','11:40:00',17.76),('7643','2014-04-08','11:45:00',17.88),('7643','2014-04-08','11:50:00',16.62),('7643','2014-04-08','11:55:00',17.12),('7643','2014-04-08','12:00:00',17.76),('7643','2014-04-08','12:05:00',13.94),('7643','2014-04-08','12:10:00',7.58),('7643','2014-04-08','12:15:00',14.39),('7643','2014-04-08','12:20:00',8.07),('7643','2014-04-08','12:25:00',4.1),('7643','2014-04-08','12:30:00',3.28),('7643','2014-04-08','12:35:00',2.93),('7643','2014-04-08','12:40:00',2.72),('7643','2014-04-08','12:45:00',2.33),('7643','2014-04-08','12:50:00',2.15),('7643','2014-04-08','12:55:00',2.35),('7643','2014-04-08','13:00:00',2.25),('7643','2014-04-08','13:05:00',2.15),('7643','2014-04-08','13:10:00',2.36),('7643','2014-04-08','13:15:00',3.09),('7643','2014-04-08','13:20:00',4.8),('7643','2014-04-08','13:25:00',5.53),('7643','2014-04-08','13:30:00',4.79),('7643','2014-04-08','13:35:00',4.53),('7643','2014-04-08','13:40:00',4.31),('7643','2014-04-08','13:45:00',3.89),('7643','2014-04-08','13:50:00',3.32),('7643','2014-04-08','13:55:00',2.78),('7643','2014-04-08','14:00:00',3.4),('7643','2014-04-08','14:05:00',5.79),('7643','2014-04-08','14:10:00',6.77),('7643','2014-04-08','14:15:00',6.3),('7643','2014-04-08','14:20:00',7.08),('7643','2014-04-08','14:25:00',5.67),('7643','2014-04-08','14:30:00',7.6),('7643','2014-04-08','14:35:00',10.7),('7643','2014-04-08','14:40:00',7.48),('7643','2014-04-08','14:45:00',6.39),('7643','2014-04-08','14:50:00',9.36),('7643','2014-04-08','14:55:00',12.76),('7643','2014-04-08','15:00:00',13.78),('7643','2014-04-08','15:05:00',17.08),('7643','2014-04-08','15:10:00',13.28),('7643','2014-04-08','15:15:00',10.21),('7643','2014-04-08','15:20:00',13.71),('7643','2014-04-08','15:25:00',11.56),('7643','2014-04-08','15:30:00',11.63),('7643','2014-04-08','15:35:00',11.23),('7643','2014-04-08','15:40:00',8.41),('7643','2014-04-08','15:45:00',6.74),('7643','2014-04-08','15:50:00',7.91),('7643','2014-04-08','15:55:00',5.11),('7643','2014-04-08','16:00:00',5.28),('7643','2014-04-08','16:05:00',6.27),('7643','2014-04-08','16:10:00',9.93),('7643','2014-04-08','16:15:00',12.58),('7643','2014-04-08','16:20:00',12.28),('7643','2014-04-08','16:25:00',11.53),('7643','2014-04-08','16:30:00',11.75),('7643','2014-04-08','16:35:00',7.74),('7643','2014-04-08','16:40:00',6.19),('7643','2014-04-08','16:45:00',6.27),('7643','2014-04-08','16:50:00',8.61),('7643','2014-04-08','16:55:00',8.04),('7643','2014-04-08','17:00:00',7.4),('7643','2014-04-08','17:05:00',10.69),('7643','2014-04-08','17:10:00',9.05),('7643','2014-04-08','17:15:00',6.33),('7643','2014-04-08','17:20:00',7.84),('7643','2014-04-08','17:25:00',7.74),('7643','2014-04-08','17:30:00',5.37),('7643','2014-04-08','17:35:00',2.51),('7643','2014-04-08','17:40:00',2.66),('7643','2014-04-08','17:45:00',4.19),('7643','2014-04-08','17:50:00',4.39),('7643','2014-04-08','17:55:00',4.33),('7643','2014-04-08','18:00:00',3.83),('7643','2014-04-08','18:05:00',2.68),('7643','2014-04-08','18:10:00',2.57),('7643','2014-04-08','18:15:00',2.24),('7643','2014-04-08','18:20:00',1.42),('7643','2013-08-08','07:10:00',1.22),('7643','2013-08-08','07:15:00',1.5),('7643','2013-08-08','07:20:00',1.78),('7643','2013-08-08','07:25:00',2.13),('7643','2013-08-08','07:30:00',1.67),('7643','2013-08-08','07:35:00',1.96),('7643','2013-08-08','07:40:00',2.04),('7643','2013-08-08','07:45:00',1.64),('7643','2013-08-08','07:50:00',1.62),('7643','2013-08-08','07:55:00',1.87),('7643','2013-08-08','08:00:00',2.82),('7643','2013-08-08','08:05:00',4.44),('7643','2013-08-08','08:10:00',3.25),('7643','2013-08-08','08:15:00',3.09),('7643','2013-08-08','08:20:00',2.86),('7643','2013-08-08','08:25:00',2.88),('7643','2013-08-08','08:30:00',3.47),('7643','2013-08-08','08:35:00',4.09),('7643','2013-08-08','08:40:00',5.31),('7643','2013-08-08','08:45:00',6.17),('7643','2013-08-08','08:50:00',6.42),('7643','2013-08-08','08:55:00',6),('7643','2013-08-08','09:00:00',6.86),('7643','2013-08-08','09:05:00',7.58),('7643','2013-08-08','09:10:00',8.24),('7643','2013-08-08','09:15:00',6.81),('7643','2013-08-08','09:20:00',7.73),('7643','2013-08-08','09:25:00',5.2),('7643','2013-08-08','09:30:00',9.65),('7643','2013-08-08','09:35:00',8.78),('7643','2013-08-08','09:40:00',5.71),('7643','2013-08-08','09:45:00',9.06),('7643','2013-08-08','09:50:00',8.98),('7643','2013-08-08','09:55:00',6.72),('7643','2013-08-08','10:00:00',7.8),('7643','2013-08-08','10:05:00',7.75),('7643','2013-08-08','10:10:00',9.05),('7643','2013-08-08','10:15:00',10.39),('7643','2013-08-08','10:20:00',10.3),('7643','2013-08-08','10:25:00',8.97),('7643','2013-08-08','10:30:00',8.68),('7643','2013-08-08','10:35:00',11.23),('7643','2013-08-08','10:40:00',11.65),('7643','2013-08-08','10:45:00',11.65),('7643','2013-08-08','10:50:00',11.55),('7643','2013-08-08','10:55:00',11.98),('7643','2013-08-08','11:00:00',12.25),('7643','2013-08-08','11:05:00',12.3),('7643','2013-08-08','11:10:00',12.56),('7643','2013-08-08','11:15:00',12.56),('7643','2013-08-08','11:20:00',12.55),('7643','2013-08-08','11:25:00',12.59),('7643','2013-08-08','11:30:00',12.81),('7643','2013-08-08','11:35:00',13.02),('7643','2013-08-08','11:40:00',13.06),('7643','2013-08-08','11:45:00',13.04),('7643','2013-08-08','11:50:00',13.22),('7643','2013-08-08','11:55:00',13.36),('7643','2013-08-08','12:00:00',13.51),('7643','2013-08-08','12:05:00',13.46),('7643','2013-08-08','12:10:00',13.48),('7643','2013-08-08','12:15:00',13.67),('7643','2013-08-08','12:20:00',14.17),('7643','2013-08-08','12:25:00',12.73),('7643','2013-08-08','12:30:00',9.89),('7643','2013-08-08','12:35:00',12.27),('7643','2013-08-08','12:40:00',15.51),('7643','2013-08-08','12:45:00',9.35),('7643','2013-08-08','12:50:00',9.15),('7643','2013-08-08','12:55:00',10.74),('7643','2013-08-08','13:00:00',4.71),('7643','2013-08-08','13:05:00',3.23),('7643','2013-08-08','13:10:00',3.04),('7643','2013-08-08','13:15:00',3.66),('7643','2013-08-08','13:20:00',5.13),('7643','2013-08-08','13:25:00',9.96),('7643','2013-08-08','13:30:00',6.98),('7643','2013-08-08','13:35:00',5.66),('7643','2013-08-08','13:40:00',5.51),('7643','2013-08-08','13:45:00',5.23),('7643','2013-08-08','13:50:00',5.47),('7643','2013-08-08','13:55:00',4.63),('7643','2013-08-08','14:00:00',4.32),('7643','2013-08-08','14:05:00',5.14),('7643','2013-08-08','14:10:00',4.82),('7643','2013-08-08','14:15:00',3.54),('7643','2013-08-08','14:20:00',3.33),('7643','2013-08-08','14:25:00',3.97),('7643','2013-08-08','14:30:00',3.87),('7643','2013-08-08','14:35:00',2.91),('7643','2013-08-08','14:40:00',2.04),('7643','2013-08-08','14:45:00',1.42),('7643','2013-08-08','14:50:00',1.06),('7643','2013-08-08','14:55:00',1.08),('7643','2013-08-08','15:00:00',1.93),('7643','2013-08-08','15:05:00',5.35),('7643','2013-08-08','15:10:00',10.11),('7643','2013-08-08','15:15:00',8.96),('7643','2013-08-08','15:20:00',5.65),('7643','2013-08-08','15:25:00',4.51),('7643','2013-08-08','15:30:00',4.22),('7643','2013-08-08','15:35:00',8.03),('7643','2013-08-08','15:40:00',5.75),('7643','2013-08-08','15:45:00',12.82),('7643','2013-08-08','15:50:00',8),('7643','2013-08-08','15:55:00',8.42),('7643','2013-08-08','16:00:00',4.07),('7643','2013-08-08','16:05:00',2.64),('7643','2013-08-08','16:10:00',2.34),('7643','2013-08-08','16:15:00',2.65),('7643','2013-08-08','16:20:00',2.73),('7643','2013-08-08','16:25:00',3.02),('7643','2013-08-08','16:30:00',2.16),('7643','2013-08-08','16:35:00',2.24),('7643','2013-08-08','16:40:00',2.43),('7643','2013-08-08','16:45:00',3.04),('7643','2013-08-08','16:50:00',5.05),('7643','2013-08-08','16:55:00',7.02),('7643','2013-08-08','17:00:00',5.66),('7643','2013-08-08','17:05:00',6.54),('7643','2013-08-08','17:10:00',3.41),('7643','2013-08-08','17:15:00',2.6),('7643','2013-08-08','17:20:00',2.32),('7643','2013-08-08','17:25:00',2.63),('7643','2013-08-08','17:30:00',3.1),('7643','2013-08-08','17:35:00',3.14),('7643','2013-08-08','17:40:00',2.95),('7643','2013-08-08','17:45:00',2.8),('7643','2013-08-08','17:50:00',2.13),('7643','2013-08-08','17:55:00',1.49),('7643','2013-08-08','18:00:00',1.2),('7643','2013-08-08','18:05:00',1.05),('7643','2013-08-08','18:10:00',1.2),('7643','2013-08-08','18:15:00',1.74),('7643','2013-08-08','18:20:00',1.79),('7643','2013-08-08','18:25:00',1.37),('7643','2013-08-08','18:55:00',1.3),('7643','2013-08-08','19:00:00',1.91),('7643','2013-08-08','19:05:00',2.67),('7643','2013-08-08','19:10:00',2.8),('7643','2013-08-08','19:15:00',2.99),('7643','2013-08-08','19:20:00',3.54),('7643','2013-08-08','19:25:00',3.28),('7643','2013-08-08','19:30:00',1.56),('7643','2013-08-08','19:35:00',1.19),('7643','2013-08-07','07:10:00',1.1),('7643','2013-08-07','07:15:00',1.29),('7643','2013-08-07','07:20:00',1.47),('7643','2013-08-07','07:25:00',1.67),('7643','2013-08-07','07:30:00',1.89),('7643','2013-08-07','07:35:00',2.12),('7643','2013-08-07','07:40:00',2.36),('7643','2013-08-07','07:45:00',2.63),('7643','2013-08-07','07:50:00',2.94),('7643','2013-08-07','07:55:00',3.2),('7643','2013-08-07','08:00:00',3.53),('7643','2013-08-07','08:05:00',3.81),('7643','2013-08-07','08:10:00',4.13),('7643','2013-08-07','08:15:00',4.43),('7643','2013-08-07','08:20:00',4.71),('7643','2013-08-07','08:25:00',5.07),('7643','2013-08-07','08:30:00',5.34),('7643','2013-08-07','08:35:00',5.65),('7643','2013-08-07','08:40:00',5.88),('7643','2013-08-07','08:45:00',6.1),('7643','2013-08-07','08:50:00',6.39),('7643','2013-08-07','08:55:00',6.64),('7643','2013-08-07','09:00:00',6.99),('7643','2013-08-07','09:05:00',7.27),('7643','2013-08-07','09:10:00',7.61),('7643','2013-08-07','09:15:00',7.9),('7643','2013-08-07','09:20:00',8.18),('7643','2013-08-07','09:25:00',8.44),('7643','2013-08-07','09:30:00',8.68),('7643','2013-08-07','09:35:00',8.99),('7643','2013-08-07','09:40:00',9.35),('7643','2013-08-07','09:45:00',9.51),('7643','2013-08-07','09:50:00',9.74),('7643','2013-08-07','09:55:00',10),('7643','2013-08-07','10:00:00',10.15),('7643','2013-08-07','10:05:00',10.35),('7643','2013-08-07','10:10:00',10.54),('7643','2013-08-07','10:15:00',10.72),('7643','2013-08-07','10:20:00',10.88),('7643','2013-08-07','10:25:00',11.04),('7643','2013-08-07','10:30:00',11.23),('7643','2013-08-07','10:35:00',11.4),('7643','2013-08-07','10:40:00',11.6),('7643','2013-08-07','10:45:00',11.73),('7643','2013-08-07','10:50:00',11.88),('7643','2013-08-07','10:55:00',12.01),('7643','2013-08-07','11:00:00',12.25),('7643','2013-08-07','11:05:00',12.36),('7643','2013-08-07','11:10:00',12.45),('7643','2013-08-07','11:15:00',12.57),('7643','2013-08-07','11:20:00',12.66),('7643','2013-08-07','11:25:00',12.66),('7643','2013-08-07','11:30:00',12.76),('7643','2013-08-07','11:35:00',12.83),('7643','2013-08-07','11:40:00',12.89),('7643','2013-08-07','11:45:00',12.96),('7643','2013-08-07','11:50:00',12.99),('7643','2013-08-07','11:55:00',13.18),('7643','2013-08-07','12:00:00',13.26),('7643','2013-08-07','12:05:00',13.42),('7643','2013-08-07','12:10:00',13.21),('7643','2013-08-07','12:15:00',13.42),('7643','2013-08-07','12:20:00',13.53),('7643','2013-08-07','12:25:00',13.61),('7643','2013-08-07','12:30:00',13.6),('7643','2013-08-07','12:35:00',13.49),('7643','2013-08-07','12:40:00',13.78),('7643','2013-08-07','12:45:00',13.94),('7643','2013-08-07','12:50:00',14.1),('7643','2013-08-07','12:55:00',14.08),('7643','2013-08-07','13:00:00',14.05),('7643','2013-08-07','13:05:00',13.87),('7643','2013-08-07','13:10:00',14.03),('7643','2013-08-07','13:15:00',14.15),('7643','2013-08-07','13:20:00',14),('7643','2013-08-07','13:25:00',14.07),('7643','2013-08-07','13:30:00',14.14),('7643','2013-08-07','13:35:00',14.06),('7643','2013-08-07','13:40:00',14.01),('7643','2013-08-07','13:45:00',13.99),('7643','2013-08-07','13:50:00',13.89),('7643','2013-08-07','13:55:00',13.77),('7643','2013-08-07','14:00:00',13.81),('7643','2013-08-07','14:05:00',13.77),('7643','2013-08-07','14:10:00',13.67),('7643','2013-08-07','14:15:00',13.51),('7643','2013-08-07','14:20:00',13.35),('7643','2013-08-07','14:25:00',13.4),('7643','2013-08-07','14:30:00',13.36),('7643','2013-08-07','14:35:00',13.19),('7643','2013-08-07','14:40:00',13.05),('7643','2013-08-07','14:45:00',12.83),('7643','2013-08-07','14:50:00',12.86),('7643','2013-08-07','14:55:00',12.61),('7643','2013-08-07','15:00:00',12.55),('7643','2013-08-07','15:05:00',12.38),('7643','2013-08-07','15:10:00',12.28),('7643','2013-08-07','15:15:00',12.09),('7643','2013-08-07','15:20:00',12),('7643','2013-08-07','15:25:00',11.89),('7643','2013-08-07','15:30:00',11.72),('7643','2013-08-07','15:35:00',11.55),('7643','2013-08-07','15:40:00',11.48),('7643','2013-08-07','15:45:00',11.33),('7643','2013-08-07','15:50:00',11.09),('7643','2013-08-07','15:55:00',10.89),('7643','2013-08-07','16:00:00',10.77),('7643','2013-08-07','16:05:00',10.69),('7643','2013-08-07','16:10:00',10.55),('7643','2013-08-07','16:15:00',10.38),('7643','2013-08-07','16:20:00',10.21),('7643','2013-08-07','16:25:00',9.96),('7643','2013-08-07','16:30:00',9.71),('7643','2013-08-07','16:35:00',9.51),('7643','2013-08-07','16:40:00',9.35),('7643','2013-08-07','16:45:00',9.02),('7643','2013-08-07','16:50:00',8.77),('7643','2013-08-07','16:55:00',8.49),('7643','2013-08-07','17:00:00',8.23),('7643','2013-08-07','17:05:00',7.95),('7643','2013-08-07','17:10:00',7.65),('7643','2013-08-07','17:15:00',7.32),('7643','2013-08-07','17:20:00',6.99),('7643','2013-08-07','17:25:00',6.72),('7643','2013-08-07','17:30:00',6.38),('7643','2013-08-07','17:35:00',6.06),('7643','2013-08-07','17:40:00',5.76),('7643','2013-08-07','17:45:00',5.5),('7643','2013-08-07','17:50:00',5.19),('7643','2013-08-07','17:55:00',4.87),('7643','2013-08-07','18:00:00',4.61),('7643','2013-08-07','18:05:00',4.26),('7643','2013-08-07','18:10:00',3.98),('7643','2013-08-07','18:15:00',3.75),('7643','2013-08-07','18:20:00',3.43),('7643','2013-08-07','18:25:00',3.13),('7643','2013-08-07','18:30:00',2.89),('7643','2013-08-07','18:35:00',2.62),('7643','2013-08-07','18:40:00',2.39),('7643','2013-08-07','18:45:00',2.14),('7643','2013-08-07','18:50:00',1.88),('7643','2013-08-07','18:55:00',1.63),('7643','2013-08-07','19:00:00',1.39),('7643','2013-08-07','19:05:00',1.21),('7643','2013-08-07','19:10:00',1.04),('7643','2013-08-06','07:05:00',1.02),('7643','2013-08-06','07:10:00',1.2),('7643','2013-08-06','07:15:00',1.39),('7643','2013-08-06','07:20:00',1.6),('7643','2013-08-06','07:25:00',1.83),('7643','2013-08-06','07:30:00',2.05),('7643','2013-08-06','07:35:00',2.27),('7643','2013-08-06','07:40:00',2.5),('7643','2013-08-06','07:45:00',2.77),('7643','2013-08-06','07:50:00',3.09),('7643','2013-08-06','07:55:00',3.37),('7643','2013-08-06','08:00:00',3.67),('7643','2013-08-06','08:05:00',4),('7643','2013-08-06','08:10:00',4.33),('7643','2013-08-06','08:15:00',4.63),('7643','2013-08-06','08:20:00',4.95),('7643','2013-08-06','08:25:00',5.29),('7643','2013-08-06','08:30:00',5.57),('7643','2013-08-06','08:35:00',5.83),('7643','2013-08-06','08:40:00',6.15),('7643','2013-08-06','08:45:00',6.48),('7643','2013-08-06','08:50:00',6.8),('7643','2013-08-06','08:55:00',7.05),('7643','2013-08-06','09:00:00',7.34),('7643','2013-08-06','09:05:00',7.61),('7643','2013-08-06','09:10:00',7.89),('7643','2013-08-06','09:15:00',8.18),('7643','2013-08-06','09:20:00',8.35),('7643','2013-08-06','09:25:00',8.55),('7643','2013-08-06','09:30:00',8.89),('7643','2013-08-06','09:35:00',9.11),('7643','2013-08-06','09:40:00',9.52),('7643','2013-08-06','09:45:00',9.73),('7643','2013-08-06','09:50:00',10.03),('7643','2013-08-06','09:55:00',10.14),('7643','2013-08-06','10:00:00',10.28),('7643','2013-08-06','10:05:00',10.47),('7643','2013-08-06','10:10:00',10.71),('7643','2013-08-06','10:15:00',10.93),('7643','2013-08-06','10:20:00',11.15),('7643','2013-08-06','10:25:00',11.32),('7643','2013-08-06','10:30:00',11.51),('7643','2013-08-06','10:35:00',11.63),('7643','2013-08-06','10:40:00',11.73),('7643','2013-08-06','10:45:00',11.92),('7643','2013-08-06','10:50:00',12.05),('7643','2013-08-06','10:55:00',12.13),('7643','2013-08-06','11:00:00',12.27),('7643','2013-08-06','11:05:00',12.43),('7643','2013-08-06','11:10:00',12.52),('7643','2013-08-06','11:15:00',12.71),('7643','2013-08-06','11:20:00',12.75),('7643','2013-08-06','11:25:00',12.88),('7643','2013-08-06','11:30:00',12.99),('7643','2013-08-06','11:35:00',13.04),('7643','2013-08-06','11:40:00',13.06),('7643','2013-08-06','11:45:00',13.2),('7643','2013-08-06','11:50:00',13.18),('7643','2013-08-06','11:55:00',13.22),('7643','2013-08-06','12:00:00',13.43),('7643','2013-08-06','12:05:00',13.64),('7643','2013-08-06','12:10:00',13.74),('7643','2013-08-06','12:15:00',13.84),('7643','2013-08-06','12:20:00',13.59),('7643','2013-08-06','12:25:00',13.67),('7643','2013-08-06','12:30:00',13.66),('7643','2013-08-06','12:35:00',13.74),('7643','2013-08-06','12:40:00',13.8),('7643','2013-08-06','12:45:00',13.6),('7643','2013-08-06','12:50:00',14.01),('7643','2013-08-06','12:55:00',13.97),('7643','2013-08-06','13:00:00',13.91),('7643','2013-08-06','13:05:00',13.87),('7643','2013-08-06','13:10:00',13.83),('7643','2013-08-06','13:15:00',13.8),('7643','2013-08-06','13:20:00',14.13),('7643','2013-08-06','13:25:00',13.84),('7643','2013-08-06','13:30:00',14.14),('7643','2013-08-06','13:35:00',14.01),('7643','2013-08-06','13:40:00',14.03),('7643','2013-08-06','13:45:00',14.29),('7643','2013-08-06','13:50:00',14),('7643','2013-08-06','13:55:00',14.11),('7643','2013-08-06','14:00:00',14.02),('7643','2013-08-06','14:05:00',13.91),('7643','2013-08-06','14:10:00',13.76),('7643','2013-08-06','14:15:00',13.55),('7643','2013-08-06','14:20:00',13.34),('7643','2013-08-06','14:25:00',13.42),('7643','2013-08-06','14:30:00',13.32),('7643','2013-08-06','14:35:00',13.11),('7643','2013-08-06','14:40:00',12.97),('7643','2013-08-06','14:45:00',13.14),('7643','2013-08-06','14:50:00',13.06),('7643','2013-08-06','14:55:00',12.93),('7643','2013-08-06','15:00:00',12.77),('7643','2013-08-06','15:05:00',12.65),('7643','2013-08-06','15:10:00',12.45),('7643','2013-08-06','15:15:00',12.35),('7643','2013-08-06','15:20:00',12.21),('7643','2013-08-06','15:25:00',12.12),('7643','2013-08-06','15:30:00',11.83),('7643','2013-08-06','15:35:00',11.84),('7643','2013-08-06','15:40:00',11.67),('7643','2013-08-06','15:45:00',11.63),('7643','2013-08-06','15:50:00',11.41),('7643','2013-08-06','15:55:00',11.2),('7643','2013-08-06','16:00:00',11.06),('7643','2013-08-06','16:05:00',10.77),('7643','2013-08-06','16:10:00',10.41),('7643','2013-08-06','16:15:00',10.2),('7643','2013-08-06','16:20:00',10.13),('7643','2013-08-06','16:25:00',9.9),('7643','2013-08-06','16:30:00',9.71),('7643','2013-08-06','16:35:00',9.54),('7643','2013-08-06','16:40:00',9.38),('7643','2013-08-06','16:45:00',9.2),('7643','2013-08-06','16:50:00',8.96),('7643','2013-08-06','16:55:00',8.72),('7643','2013-08-06','17:00:00',8.49),('7643','2013-08-06','17:05:00',8.23),('7643','2013-08-06','17:10:00',7.9),('7643','2013-08-06','17:15:00',7.55),('7643','2013-08-06','17:20:00',7.31),('7643','2013-08-06','17:25:00',7.03),('7643','2013-08-06','17:30:00',6.6),('7643','2013-08-06','17:35:00',6.27),('7643','2013-08-06','17:40:00',5.92),('7643','2013-08-06','17:45:00',5.61),('7643','2013-08-06','17:50:00',5.26),('7643','2013-08-06','17:55:00',5.01),('7643','2013-08-06','18:00:00',4.65),('7643','2013-08-06','18:05:00',4.28),('7643','2013-08-06','18:10:00',3.96),('7643','2013-08-06','18:15:00',3.71),('7643','2013-08-06','18:20:00',3.43),('7643','2013-08-06','18:25:00',3.17),('7643','2013-08-06','18:30:00',2.96),('7643','2013-08-06','18:35:00',2.73),('7643','2013-08-06','18:40:00',2.5),('7643','2013-08-06','18:45:00',2.27),('7643','2013-08-06','18:50:00',2.02),('7643','2013-08-06','18:55:00',1.73),('7643','2013-08-06','19:00:00',1.46),('7643','2013-08-06','19:05:00',1.25),('7643','2013-08-06','19:10:00',1.08),('7643','2013-08-05','07:10:00',1.14),('7643','2013-08-05','07:15:00',1.33),('7643','2013-08-05','07:20:00',1.51),('7643','2013-08-05','07:25:00',1.72),('7643','2013-08-05','07:30:00',1.96),('7643','2013-08-05','07:35:00',2.19),('7643','2013-08-05','07:40:00',2.42),('7643','2013-08-05','07:45:00',2.7),('7643','2013-08-05','07:50:00',2.99),('7643','2013-08-05','07:55:00',3.25),('7643','2013-08-05','08:00:00',3.53),('7643','2013-08-05','08:05:00',3.89),('7643','2013-08-05','08:10:00',4.22),('7643','2013-08-05','08:15:00',4.53),('7643','2013-08-05','08:20:00',4.84),('7643','2013-08-05','08:25:00',5.14),('7643','2013-08-05','08:30:00',5.45),('7643','2013-08-05','08:35:00',5.74),('7643','2013-08-05','08:40:00',6.02),('7643','2013-08-05','08:45:00',6.31),('7643','2013-08-05','08:50:00',6.68),('7643','2013-08-05','08:55:00',6.96),('7643','2013-08-05','09:00:00',7.22),('7643','2013-08-05','09:05:00',7.45),('7643','2013-08-05','09:10:00',7.69),('7643','2013-08-05','09:15:00',7.91),('7643','2013-08-05','09:20:00',8.27),('7643','2013-08-05','09:25:00',8.57),('7643','2013-08-05','09:30:00',8.71),('7643','2013-08-05','09:35:00',9),('7643','2013-08-05','09:40:00',9.34),('7643','2013-08-05','09:45:00',9.53),('7643','2013-08-05','09:50:00',9.76),('7643','2013-08-05','09:55:00',10.03),('7643','2013-08-05','10:00:00',10.31),('7643','2013-08-05','10:05:00',10.45),('7643','2013-08-05','10:10:00',10.65),('7643','2013-08-05','10:15:00',10.83),('7643','2013-08-05','10:20:00',10.97),('7643','2013-08-05','10:25:00',11.17),('7643','2013-08-05','10:30:00',11.35),('7643','2013-08-05','10:35:00',11.54),('7643','2013-08-05','10:40:00',11.71),('7643','2013-08-05','10:45:00',11.81),('7643','2013-08-05','10:50:00',11.97),('7643','2013-08-05','10:55:00',12.15),('7643','2013-08-05','11:00:00',12.29),('7643','2013-08-05','11:05:00',12.34),('7643','2013-08-05','11:10:00',12.52),('7643','2013-08-05','11:15:00',12.69),('7643','2013-08-05','11:20:00',12.77),('7643','2013-08-05','11:25:00',12.69),('7643','2013-08-05','11:30:00',12.96),('7643','2013-08-05','11:35:00',13.15),('7643','2013-08-05','11:40:00',13.19),('7643','2013-08-05','11:45:00',13.22),('7643','2013-08-05','11:50:00',13.27),('7643','2013-08-05','11:55:00',13.41),('7643','2013-08-05','12:00:00',13.43),('7643','2013-08-05','12:05:00',13.48),('7643','2013-08-05','12:10:00',13.5),('7643','2013-08-05','12:15:00',13.44),('7643','2013-08-05','12:20:00',13.59),('7643','2013-08-05','12:25:00',13.66),('7643','2013-08-05','12:30:00',13.57),('7643','2013-08-05','12:35:00',13.57),('7643','2013-08-05','12:40:00',13.63),('7643','2013-08-05','12:45:00',13.48),('7643','2013-08-05','12:50:00',13.62),('7643','2013-08-05','12:55:00',13.86),('7643','2013-08-05','13:00:00',13.87),('7643','2013-08-05','13:05:00',13.86),('7643','2013-08-05','13:10:00',13.95),('7643','2013-08-05','13:15:00',14.02),('7643','2013-08-05','13:20:00',13.97),('7643','2013-08-05','13:25:00',14.06),('7643','2013-08-05','13:30:00',14.07),('7643','2013-08-05','13:35:00',14.26),('7643','2013-08-05','13:40:00',14.36),('7643','2013-08-05','13:45:00',14.36),('7643','2013-08-05','13:50:00',14.44),('7643','2013-08-05','13:55:00',14.5),('7643','2013-08-05','14:00:00',14.41),('7643','2013-08-05','14:05:00',14.49),('7643','2013-08-05','14:10:00',14.33),('7643','2013-08-05','14:15:00',14.27),('7643','2013-08-05','14:20:00',14.19),('7643','2013-08-05','14:25:00',14.15),('7643','2013-08-05','14:30:00',14.08),('7643','2013-08-05','14:35:00',14.01),('7643','2013-08-05','14:40:00',13.89),('7643','2013-08-05','14:45:00',13.76),('7643','2013-08-05','14:50:00',13.66),('7643','2013-08-05','14:55:00',13.56),('7643','2013-08-05','15:00:00',13.43),('7643','2013-08-05','15:05:00',13.3),('7643','2013-08-05','15:10:00',13.2),('7643','2013-08-05','15:15:00',13.12),('7643','2013-08-05','15:20:00',13.01),('7643','2013-08-05','15:25:00',12.86),('7643','2013-08-05','15:30:00',12.72),('7643','2013-08-05','15:35:00',12.57),('7643','2013-08-05','15:40:00',12.36),('7643','2013-08-05','15:45:00',12.12),('7643','2013-08-05','15:50:00',11.9),('7643','2013-08-05','15:55:00',11.68),('7643','2013-08-05','16:00:00',11.48),('7643','2013-08-05','16:05:00',11.29),('7643','2013-08-05','16:10:00',11.11),('7643','2013-08-05','16:15:00',10.9),('7643','2013-08-05','16:20:00',10.67),('7643','2013-08-05','16:25:00',10.38),('7643','2013-08-05','16:30:00',10.2),('7643','2013-08-05','16:35:00',9.94),('7643','2013-08-05','16:40:00',9.67),('7643','2013-08-05','16:45:00',9.38),('7643','2013-08-05','16:50:00',9.14),('7643','2013-08-05','16:55:00',8.94),('7643','2013-08-05','17:00:00',8.66),('7643','2013-08-05','17:05:00',8.42),('7643','2013-08-05','17:10:00',8.07),('7643','2013-08-05','17:15:00',7.68),('7643','2013-08-05','17:20:00',7.39),('7643','2013-08-05','17:25:00',7.08),('7643','2013-08-05','17:30:00',6.8),('7643','2013-08-05','17:35:00',6.44),('7643','2013-08-05','17:40:00',6.11),('7643','2013-08-05','17:45:00',5.83),('7643','2013-08-05','17:50:00',5.48),('7643','2013-08-05','17:55:00',5.15),('7643','2013-08-05','18:00:00',4.82),('7643','2013-08-05','18:05:00',4.47),('7643','2013-08-05','18:10:00',4.24),('7643','2013-08-05','18:15:00',3.99),('7643','2013-08-05','18:20:00',3.64),('7643','2013-08-05','18:25:00',3.34),('7643','2013-08-05','18:30:00',3.12),('7643','2013-08-05','18:35:00',2.85),('7643','2013-08-05','18:40:00',2.54),('7643','2013-08-05','18:45:00',2.27),('7643','2013-08-05','18:50:00',1.98),('7643','2013-08-05','18:55:00',1.68),('7643','2013-08-05','19:00:00',1.41),('7643','2013-08-05','19:05:00',1.2),('7643','2013-08-05','19:10:00',1.05),('7643','2013-08-04','07:05:00',1.12),('7643','2013-08-04','07:10:00',1.29),('7643','2013-08-04','07:15:00',1.47),('7643','2013-08-04','07:20:00',1.66),('7643','2013-08-04','07:25:00',1.89),('7643','2013-08-04','07:30:00',2.13),('7643','2013-08-04','07:35:00',2.36),('7643','2013-08-04','07:40:00',2.6),('7643','2013-08-04','07:45:00',2.92),('7643','2013-08-04','07:50:00',3.22),('7643','2013-08-04','07:55:00',3.52),('7643','2013-08-04','08:00:00',3.81),('7643','2013-08-04','08:05:00',4.17),('7643','2013-08-04','08:10:00',4.49),('7643','2013-08-04','08:15:00',4.79),('7643','2013-08-04','08:20:00',5.06),('7643','2013-08-04','08:25:00',5.37),('7643','2013-08-04','08:30:00',5.65),('7643','2013-08-04','08:35:00',5.93),('7643','2013-08-04','08:40:00',6.24),('7643','2013-08-04','08:45:00',6.56),('7643','2013-08-04','08:50:00',6.89),('7643','2013-08-04','08:55:00',7.16),('7643','2013-08-04','09:00:00',7.44),('7643','2013-08-04','09:05:00',7.69),('7643','2013-08-04','09:10:00',7.93),('7643','2013-08-04','09:15:00',8.18),('7643','2013-08-04','09:20:00',8.42),('7643','2013-08-04','09:25:00',8.67),('7643','2013-08-04','09:30:00',8.87),('7643','2013-08-04','09:35:00',9.15),('7643','2013-08-04','09:40:00',9.37),('7643','2013-08-04','09:45:00',9.58),('7643','2013-08-04','09:50:00',9.85),('7643','2013-08-04','09:55:00',10.08),('7643','2013-08-04','10:00:00',10.37),('7643','2013-08-04','10:05:00',10.62),('7643','2013-08-04','10:10:00',10.79),('7643','2013-08-04','10:15:00',11.08),('7643','2013-08-04','10:20:00',11.23),('7643','2013-08-04','10:25:00',11.38),('7643','2013-08-04','10:30:00',11.52),('7643','2013-08-04','10:35:00',11.72),('7643','2013-08-04','10:40:00',11.89),('7643','2013-08-04','10:45:00',12.06),('7643','2013-08-04','10:50:00',12.2),('7643','2013-08-04','10:55:00',12.32),('7643','2013-08-04','11:00:00',12.57),('7643','2013-08-04','11:05:00',12.62),('7643','2013-08-04','11:10:00',12.92),('7643','2013-08-04','11:15:00',12.9),('7643','2013-08-04','11:20:00',13.01),('7643','2013-08-04','11:25:00',13.19),('7643','2013-08-04','11:30:00',13.29),('7643','2013-08-04','11:35:00',13.37),('7643','2013-08-04','11:40:00',13.51),('7643','2013-08-04','11:45:00',13.59),('7643','2013-08-04','11:50:00',13.68),('7643','2013-08-04','11:55:00',13.71),('7643','2013-08-04','12:00:00',13.86),('7643','2013-08-04','12:05:00',13.99),('7643','2013-08-04','12:10:00',14.02),('7643','2013-08-04','12:15:00',14.1),('7643','2013-08-04','12:20:00',14.18),('7643','2013-08-04','12:25:00',14.17),('7643','2013-08-04','12:30:00',14.14),('7643','2013-08-04','12:35:00',14.18),('7643','2013-08-04','12:40:00',14.2),('7643','2013-08-04','12:45:00',14.11),('7643','2013-08-04','12:50:00',14.35),('7643','2013-08-04','12:55:00',14.23),('7643','2013-08-04','13:00:00',14.2),('7643','2013-08-04','13:05:00',14.25),('7643','2013-08-04','13:10:00',14.31),('7643','2013-08-04','13:15:00',14.29),('7643','2013-08-04','13:20:00',14.16),('7643','2013-08-04','13:25:00',14.12),('7643','2013-08-04','13:30:00',14.14),('7643','2013-08-04','13:35:00',14.22),('7643','2013-08-04','13:40:00',14.12),('7643','2013-08-04','13:45:00',13.99),('7643','2013-08-04','13:50:00',13.8),('7643','2013-08-04','13:55:00',13.94),('7643','2013-08-04','14:00:00',14.06),('7643','2013-08-04','14:05:00',14),('7643','2013-08-04','14:10:00',13.95),('7643','2013-08-04','14:15:00',13.74),('7643','2013-08-04','14:20:00',13.74),('7643','2013-08-04','14:25:00',13.51),('7643','2013-08-04','14:30:00',13.47),('7643','2013-08-04','14:35:00',13.46),('7643','2013-08-04','14:40:00',13.34),('7643','2013-08-04','14:45:00',13.35),('7643','2013-08-04','14:50:00',13.22),('7643','2013-08-04','14:55:00',13.17),('7643','2013-08-04','15:00:00',13.05),('7643','2013-08-04','15:05:00',12.98),('7643','2013-08-04','15:10:00',12.96),('7643','2013-08-04','15:15:00',12.85),('7643','2013-08-04','15:20:00',12.66),('7643','2013-08-04','15:25:00',12.54),('7643','2013-08-04','15:30:00',12.4),('7643','2013-08-04','15:35:00',12.24),('7643','2013-08-04','15:40:00',12.1),('7643','2013-08-04','15:45:00',11.91),('7643','2013-08-04','15:50:00',11.83),('7643','2013-08-04','15:55:00',11.69),('7643','2013-08-04','16:00:00',11.52),('7643','2013-08-04','16:05:00',11.31),('7643','2013-08-04','16:10:00',11.15),('7643','2013-08-04','16:15:00',10.88),('7643','2013-08-04','16:20:00',10.54),('7643','2013-08-04','16:25:00',10.29),('7643','2013-08-04','16:30:00',10.09),('7643','2013-08-04','16:35:00',9.91),('7643','2013-08-04','16:40:00',9.65),('7643','2013-08-04','16:45:00',9.36),('7643','2013-08-04','16:50:00',9.12),('7643','2013-08-04','16:55:00',8.82),('7643','2013-08-04','17:00:00',8.6),('7643','2013-08-04','17:05:00',8.32),('7643','2013-08-04','17:10:00',7.97),('7643','2013-08-04','17:15:00',7.69),('7643','2013-08-04','17:20:00',7.36),('7643','2013-08-04','17:25:00',7),('7643','2013-08-04','17:30:00',6.71),('7643','2013-08-04','17:35:00',6.37),('7643','2013-08-04','17:40:00',6.1),('7643','2013-08-04','17:45:00',5.81),('7643','2013-08-04','17:50:00',5.46),('7643','2013-08-04','17:55:00',5.15),('7643','2013-08-04','18:00:00',4.84),('7643','2013-08-04','18:05:00',4.49),('7643','2013-08-04','18:10:00',4.17),('7643','2013-08-04','18:15:00',3.87),('7643','2013-08-04','18:20:00',3.55),('7643','2013-08-04','18:25:00',3.3),('7643','2013-08-04','18:30:00',3.04),('7643','2013-08-04','18:35:00',2.8),('7643','2013-08-04','18:40:00',2.53),('7643','2013-08-04','18:45:00',2.29),('7643','2013-08-04','18:50:00',2.03),('7643','2013-08-04','18:55:00',1.75),('7643','2013-08-04','19:00:00',1.49),('7643','2013-08-04','19:05:00',1.29),('7643','2013-08-04','19:10:00',1.12),('7643','2013-08-03','07:10:00',1.23),('7643','2013-08-03','07:15:00',1.46),('7643','2013-08-03','07:20:00',1.69),('7643','2013-08-03','07:25:00',1.93),('7643','2013-08-03','07:30:00',2.21),('7643','2013-08-03','07:35:00',2.44),('7643','2013-08-03','07:40:00',2.72),('7643','2013-08-03','07:45:00',3.06),('7643','2013-08-03','07:50:00',3.39),('7643','2013-08-03','07:55:00',3.73),('7643','2013-08-03','08:00:00',4.05),('7643','2013-08-03','08:05:00',4.4),('7643','2013-08-03','08:10:00',4.75),('7643','2013-08-03','08:15:00',5.08),('7643','2013-08-03','08:20:00',5.44),('7643','2013-08-03','08:25:00',5.81),('7643','2013-08-03','08:30:00',6.12),('7643','2013-08-03','08:35:00',6.38),('7643','2013-08-03','08:40:00',6.74),('7643','2013-08-03','08:45:00',7.03),('7643','2013-08-03','08:50:00',7.38),('7643','2013-08-03','08:55:00',7.65),('7643','2013-08-03','09:00:00',7.95),('7643','2013-08-03','09:05:00',8.23),('7643','2013-08-03','09:10:00',8.46),('7643','2013-08-03','09:15:00',8.71),('7643','2013-08-03','09:20:00',8.89),('7643','2013-08-03','09:25:00',9.17),('7643','2013-08-03','09:30:00',9.44),('7643','2013-08-03','09:35:00',9.74),('7643','2013-08-03','09:40:00',10.02),('7643','2013-08-03','09:45:00',10.22),('7643','2013-08-03','09:50:00',10.52),('7643','2013-08-03','09:55:00',10.73),('7643','2013-08-03','10:00:00',10.97),('7643','2013-08-03','10:05:00',11.19),('7643','2013-08-03','10:10:00',11.39),('7643','2013-08-03','10:15:00',11.57),('7643','2013-08-03','10:20:00',11.72),('7643','2013-08-03','10:25:00',11.94),('7643','2013-08-03','10:30:00',12.11),('7643','2013-08-03','10:35:00',12.22),('7643','2013-08-03','10:40:00',12.4),('7643','2013-08-03','10:45:00',12.54),('7643','2013-08-03','10:50:00',9.72),('7643','2013-08-03','10:55:00',12.74),('7643','2013-08-03','11:00:00',12.82),('7643','2013-08-03','11:05:00',12.91),('7643','2013-08-03','11:10:00',13.05),('7643','2013-08-03','11:15:00',13.16),('7643','2013-08-03','11:20:00',13.26),('7643','2013-08-03','11:25:00',13.37),('7643','2013-08-03','11:30:00',13.62),('7643','2013-08-03','11:35:00',13.84),('7643','2013-08-03','11:40:00',13.96),('7643','2013-08-03','11:45:00',13.92),('7643','2013-08-03','11:50:00',14.08),('7643','2013-08-03','11:55:00',14.24),('7643','2013-08-03','12:00:00',14.39),('7643','2013-08-03','12:05:00',14.46),('7643','2013-08-03','12:10:00',14.47),('7643','2013-08-03','12:15:00',14.53),('7643','2013-08-03','12:20:00',14.48),('7643','2013-08-03','12:25:00',14.44),('7643','2013-08-03','12:30:00',14.45),('7643','2013-08-03','12:35:00',14.47),('7643','2013-08-03','12:40:00',14.45),('7643','2013-08-03','12:45:00',14.66),('7643','2013-08-03','12:50:00',14.76),('7643','2013-08-03','12:55:00',14.82),('7643','2013-08-03','13:00:00',14.78),('7643','2013-08-03','13:05:00',14.61),('7643','2013-08-03','13:10:00',14.45),('7643','2013-08-03','13:15:00',14.58),('7643','2013-08-03','13:20:00',14.53),('7643','2013-08-03','13:25:00',14.55),('7643','2013-08-03','13:30:00',14.55),('7643','2013-08-03','13:35:00',14.71),('7643','2013-08-03','13:40:00',14.91),('7643','2013-08-03','13:45:00',14.86),('7643','2013-08-03','13:50:00',14.87),('7643','2013-08-03','13:55:00',14.9),('7643','2013-08-03','14:00:00',14.92),('7643','2013-08-03','14:05:00',14.86),('7643','2013-08-03','14:10:00',14.78),('7643','2013-08-03','14:15:00',14.72),('7643','2013-08-03','14:20:00',14.44),('7643','2013-08-03','14:25:00',14.33),('7643','2013-08-03','14:30:00',14.27),('7643','2013-08-03','14:35:00',14.11),('7643','2013-08-03','14:40:00',14.04),('7643','2013-08-03','14:45:00',14.06),('7643','2013-08-03','14:50:00',13.95),('7643','2013-08-03','14:55:00',13.82),('7643','2013-08-03','15:00:00',13.64),('7643','2013-08-03','15:05:00',13.5),('7643','2013-08-03','15:10:00',13.39),('7643','2013-08-03','15:15:00',13.23),('7643','2013-08-03','15:20:00',13.08),('7643','2013-08-03','15:25:00',12.84),('7643','2013-08-03','15:30:00',12.61),('7643','2013-08-03','15:35:00',12.7),('7643','2013-08-03','15:40:00',12.51),('7643','2013-08-03','15:45:00',12.35),('7643','2013-08-03','15:50:00',12.05),('7643','2013-08-03','15:55:00',11.82),('7643','2013-08-03','16:00:00',11.62),('7643','2013-08-03','16:05:00',11.57),('7643','2013-08-03','16:10:00',11.32),('7643','2013-08-03','16:15:00',11.19),('7643','2013-08-03','16:20:00',10.98),('7643','2013-08-03','16:25:00',10.75),('7643','2013-08-03','16:30:00',10.49),('7643','2013-08-03','16:35:00',10.23),('7643','2013-08-03','16:40:00',10.1),('7643','2013-08-03','16:45:00',9.79),('7643','2013-08-03','16:50:00',9.46),('7643','2013-08-03','16:55:00',9.22),('7643','2013-08-03','17:00:00',8.87),('7643','2013-08-03','17:05:00',8.71),('7643','2013-08-03','17:10:00',8.39),('7643','2013-08-03','17:15:00',8.05),('7643','2013-08-03','17:20:00',7.72),('7643','2013-08-03','17:25:00',7.31),('7643','2013-08-03','17:30:00',6.99),('7643','2013-08-03','17:35:00',6.71),('7643','2013-08-03','17:40:00',6.37),('7643','2013-08-03','17:45:00',6.02),('7643','2013-08-03','17:50:00',5.73),('7643','2013-08-03','17:55:00',5.34),('7643','2013-08-03','18:00:00',4.97),('7643','2013-08-03','18:05:00',4.71),('7643','2013-08-03','18:10:00',4.38),('7643','2013-08-03','18:15:00',4.06),('7643','2013-08-03','18:20:00',3.76),('7643','2013-08-03','18:25:00',3.39),('7643','2013-08-03','18:30:00',3.09),('7643','2013-08-03','18:35:00',2.91),('7643','2013-08-03','18:40:00',2.59),('7643','2013-08-03','18:45:00',2.25),('7643','2013-08-03','18:50:00',2.03),('7643','2013-08-03','18:55:00',1.75),('7643','2013-08-03','19:00:00',1.49),('7643','2013-08-03','19:05:00',1.07),('7643','2013-08-03','19:10:00',1.07),('7643','2013-08-02','07:05:00',1.03),('7643','2013-08-02','07:10:00',1.27),('7643','2013-08-02','07:15:00',1.5),('7643','2013-08-02','07:20:00',1.72),('7643','2013-08-02','07:25:00',1.97),('7643','2013-08-02','07:30:00',2.24),('7643','2013-08-02','07:35:00',2.48),('7643','2013-08-02','07:40:00',2.77),('7643','2013-08-02','07:45:00',3.08),('7643','2013-08-02','07:50:00',3.41),('7643','2013-08-02','07:55:00',3.74),('7643','2013-08-02','08:00:00',4.06),('7643','2013-08-02','08:05:00',4.39),('7643','2013-08-02','08:10:00',4.74),('7643','2013-08-02','08:15:00',5.07),('7643','2013-08-02','08:20:00',5.39),('7643','2013-08-02','08:25:00',5.74),('7643','2013-08-02','08:30:00',6.04),('7643','2013-08-02','08:35:00',6.3),('7643','2013-08-02','08:40:00',6.66),('7643','2013-08-02','08:45:00',6.97),('7643','2013-08-02','08:50:00',7.33),('7643','2013-08-02','08:55:00',7.6),('7643','2013-08-02','09:00:00',7.85),('7643','2013-08-02','09:05:00',8.12),('7643','2013-08-02','09:10:00',8.4),('7643','2013-08-02','09:15:00',8.64),('7643','2013-08-02','09:20:00',8.88),('7643','2013-08-02','09:25:00',9.13),('7643','2013-08-02','09:30:00',9.47),('7643','2013-08-02','09:35:00',9.8),('7643','2013-08-02','09:40:00',9.99),('7643','2013-08-02','09:45:00',10.19),('7643','2013-08-02','09:50:00',10.41),('7643','2013-08-02','09:55:00',10.61),('7643','2013-08-02','10:00:00',10.84),('7643','2013-08-02','10:05:00',11.07),('7643','2013-08-02','10:10:00',11.27),('7643','2013-08-02','10:15:00',11.47),('7643','2013-08-02','10:20:00',11.69),('7643','2013-08-02','10:25:00',11.86),('7643','2013-08-02','10:30:00',12.04),('7643','2013-08-02','10:35:00',12.28),('7643','2013-08-02','10:40:00',12.44),('7643','2013-08-02','10:45:00',12.52),('7643','2013-08-02','10:50:00',12.59),('7643','2013-08-02','10:55:00',12.75),('7643','2013-08-02','11:00:00',12.91),('7643','2013-08-02','11:05:00',12.97),('7643','2013-08-02','11:10:00',13.18),('7643','2013-08-02','11:15:00',13.23),('7643','2013-08-02','11:20:00',13.25),('7643','2013-08-02','11:25:00',13.27),('7643','2013-08-02','11:30:00',13.45),('7643','2013-08-02','11:35:00',13.72),('7643','2013-08-02','11:40:00',13.8),('7643','2013-08-02','11:45:00',13.93),('7643','2013-08-02','11:50:00',14.07),('7643','2013-08-02','11:55:00',14.05),('7643','2013-08-02','12:00:00',14.04),('7643','2013-08-02','12:05:00',14.15),('7643','2013-08-02','12:10:00',14.39),('7643','2013-08-02','12:15:00',14.38),('7643','2013-08-02','12:20:00',14.27),('7643','2013-08-02','12:25:00',14.3),('7643','2013-08-02','12:30:00',14.37),('7643','2013-08-02','12:35:00',14.34),('7643','2013-08-02','12:40:00',14.44),('7643','2013-08-02','12:45:00',14.42),('7643','2013-08-02','12:50:00',14.36),('7643','2013-08-02','12:55:00',14.33),('7643','2013-08-02','13:00:00',14.42),('7643','2013-08-02','13:05:00',14.39),('7643','2013-08-02','13:10:00',14.4),('7643','2013-08-02','13:15:00',14.38),('7643','2013-08-02','13:20:00',14.11),('7643','2013-08-02','13:25:00',14.04),('7643','2013-08-02','13:30:00',14.02),('7643','2013-08-02','13:35:00',13.94),('7643','2013-08-02','13:40:00',14.05),('7643','2013-08-02','13:45:00',14.34),('7643','2013-08-02','13:50:00',14.2),('7643','2013-08-02','13:55:00',14.05),('7643','2013-08-02','14:00:00',14),('7643','2013-08-02','14:05:00',13.92),('7643','2013-08-02','14:10:00',13.87),('7643','2013-08-02','14:15:00',13.63),('7643','2013-08-02','14:20:00',13.64),('7643','2013-08-02','14:25:00',13.57),('7643','2013-08-02','14:30:00',13.74),('7643','2013-08-02','14:35:00',14),('7643','2013-08-02','14:40:00',13.88),('7643','2013-08-02','14:45:00',13.89),('7643','2013-08-02','14:50:00',13.73),('7643','2013-08-02','14:55:00',13.62),('7643','2013-08-02','15:00:00',13.52),('7643','2013-08-02','15:05:00',13.38),('7643','2013-08-02','15:10:00',13.24),('7643','2013-08-02','15:15:00',13.13),('7643','2013-08-02','15:20:00',12.94),('7643','2013-08-02','15:25:00',12.9),('7643','2013-08-02','15:30:00',12.82),('7643','2013-08-02','15:35:00',12.63),('7643','2013-08-02','15:40:00',12.45),('7643','2013-08-02','15:45:00',12.25),('7643','2013-08-02','15:50:00',12.07),('7643','2013-08-02','15:55:00',11.9),('7643','2013-08-02','16:00:00',11.65),('7643','2013-08-02','16:05:00',11.37),('7643','2013-08-02','16:10:00',11.16),('7643','2013-08-02','16:15:00',10.83),('7643','2013-08-02','16:20:00',10.65),('7643','2013-08-02','16:25:00',10.45),('7643','2013-08-02','16:30:00',10.31),('7643','2013-08-02','16:35:00',10.1),('7643','2013-08-02','16:40:00',9.85),('7643','2013-08-02','16:45:00',9.51),('7643','2013-08-02','16:50:00',9.3),('7643','2013-08-02','16:55:00',9),('7643','2013-08-02','17:00:00',7.91),('7643','2013-08-02','17:05:00',8.48),('7643','2013-08-02','17:10:00',8.16),('7643','2013-08-02','17:15:00',7.92),('7643','2013-08-02','17:20:00',7.61),('7643','2013-08-02','17:25:00',7.25),('7643','2013-08-02','17:30:00',6.98),('7643','2013-08-02','17:35:00',6.7),('7643','2013-08-02','17:40:00',6.37),('7643','2013-08-02','17:45:00',6),('7643','2013-08-02','17:50:00',5.68),('7643','2013-08-02','17:55:00',5.37),('7643','2013-08-02','18:00:00',4.99),('7643','2013-08-02','18:05:00',4.74),('7643','2013-08-02','18:10:00',4.5),('7643','2013-08-02','18:15:00',4.19),('7643','2013-08-02','18:20:00',3.87),('7643','2013-08-02','18:25:00',3.58),('7643','2013-08-02','18:30:00',3.3),('7643','2013-08-02','18:35:00',3.03),('7643','2013-08-02','18:40:00',2.74),('7643','2013-08-02','18:45:00',2.47),('7643','2013-08-02','18:50:00',2.17),('7643','2013-08-02','18:55:00',1.86),('7643','2013-08-02','19:00:00',1.55),('7643','2013-08-02','19:05:00',1.36),('7643','2013-08-02','19:10:00',1.13),('7643','2013-08-01','07:05:00',1.07),('7643','2013-08-01','07:10:00',1.33),('7643','2013-08-01','07:15:00',1.59),('7643','2013-08-01','07:20:00',1.84),('7643','2013-08-01','07:25:00',2.11),('7643','2013-08-01','07:30:00',2.39),('7643','2013-08-01','07:35:00',2.64),('7643','2013-08-01','07:40:00',3),('7643','2013-08-01','07:45:00',3.29),('7643','2013-08-01','07:50:00',3.61),('7643','2013-08-01','07:55:00',3.96),('7643','2013-08-01','08:00:00',4.31),('7643','2013-08-01','08:05:00',4.67),('7643','2013-08-01','08:10:00',5.02),('7643','2013-08-01','08:15:00',5.37),('7643','2013-08-01','08:20:00',5.71),('7643','2013-08-01','08:25:00',6.06),('7643','2013-08-01','08:30:00',6.39),('7643','2013-08-01','08:35:00',6.64),('7643','2013-08-01','08:40:00',7),('7643','2013-08-01','08:45:00',7.3),('7643','2013-08-01','08:50:00',7.62),('7643','2013-08-01','08:55:00',7.9),('7643','2013-08-01','09:00:00',8.18),('7643','2013-08-01','09:05:00',8.46),('7643','2013-08-01','09:10:00',8.73),('7643','2013-08-01','09:15:00',8.98),('7643','2013-08-01','09:20:00',9.24),('7643','2013-08-01','09:25:00',9.53),('7643','2013-08-01','09:30:00',9.78),('7643','2013-08-01','09:35:00',10.04),('7643','2013-08-01','09:40:00',10.29),('7643','2013-08-01','09:45:00',10.49),('7643','2013-08-01','09:50:00',10.65),('7643','2013-08-01','09:55:00',10.89),('7643','2013-08-01','10:00:00',11.05),('7643','2013-08-01','10:05:00',11.18),('7643','2013-08-01','10:10:00',11.39),('7643','2013-08-01','10:15:00',11.62),('7643','2013-08-01','10:20:00',11.82),('7643','2013-08-01','10:25:00',11.97),('7643','2013-08-01','10:30:00',12.22),('7643','2013-08-01','10:35:00',12.42),('7643','2013-08-01','10:40:00',12.55),('7643','2013-08-01','10:45:00',12.7),('7643','2013-08-01','10:50:00',12.83),('7643','2013-08-01','10:55:00',13.01),('7643','2013-08-01','11:00:00',13.14),('7643','2013-08-01','11:05:00',13.34),('7643','2013-08-01','11:10:00',13.39),('7643','2013-08-01','11:15:00',13.51),('7643','2013-08-01','11:20:00',13.66),('7643','2013-08-01','11:25:00',13.84),('7643','2013-08-01','11:30:00',13.97),('7643','2013-08-01','11:35:00',13.97),('7643','2013-08-01','11:40:00',14.03),('7643','2013-08-01','11:45:00',14.09),('7643','2013-08-01','11:50:00',14.12),('7643','2013-08-01','11:55:00',14.25),('7643','2013-08-01','12:00:00',14.49),('7643','2013-08-01','12:05:00',14.67),('7643','2013-08-01','12:10:00',14.7),('7643','2013-08-01','12:15:00',14.8),('7643','2013-08-01','12:20:00',14.77),('7643','2013-08-01','12:25:00',14.71),('7643','2013-08-01','12:30:00',14.73),('7643','2013-08-01','12:35:00',14.86),('7643','2013-08-01','12:40:00',14.71),('7643','2013-08-01','12:45:00',14.72),('7643','2013-08-01','12:50:00',14.67),('7643','2013-08-01','12:55:00',14.59),('7643','2013-08-01','13:00:00',14.63),('7643','2013-08-01','13:05:00',14.98),('7643','2013-08-01','13:10:00',15.07),('7643','2013-08-01','13:15:00',15.06),('7643','2013-08-01','13:20:00',14.85),('7643','2013-08-01','13:25:00',14.74),('7643','2013-08-01','13:30:00',14.77),('7643','2013-08-01','13:35:00',14.76),('7643','2013-08-01','13:40:00',14.67),('7643','2013-08-01','13:45:00',14.7),('7643','2013-08-01','13:50:00',14.8),('7643','2013-08-01','13:55:00',14.63),('7643','2013-08-01','14:00:00',14.81),('7643','2013-08-01','14:05:00',14.71),('7643','2013-08-01','14:10:00',14.62),('7643','2013-08-01','14:15:00',14.35),('7643','2013-08-01','14:20:00',14.14),('7643','2013-08-01','14:25:00',13.95),('7643','2013-08-01','14:30:00',13.98),('7643','2013-08-01','14:35:00',14.09),('7643','2013-08-01','14:40:00',14.17),('7643','2013-08-01','14:45:00',13.96),('7643','2013-08-01','14:50:00',13.98),('7643','2013-08-01','14:55:00',13.91),('7643','2013-08-01','15:00:00',13.78),('7643','2013-08-01','15:05:00',13.67),('7643','2013-08-01','15:10:00',13.44),('7643','2013-08-01','15:15:00',13.2),('7643','2013-08-01','15:20:00',13.31),('7643','2013-08-01','15:25:00',13.28),('7643','2013-08-01','15:30:00',13.09),('7643','2013-08-01','15:35:00',12.95),('7643','2013-08-01','15:40:00',12.78),('7643','2013-08-01','15:45:00',12.6),('7643','2013-08-01','15:50:00',12.34),('7643','2013-08-01','15:55:00',12.16),('7643','2013-08-01','16:00:00',12.05),('7643','2013-08-01','16:05:00',11.85),('7643','2013-08-01','16:10:00',11.58),('7643','2013-08-01','16:15:00',11.31),('7643','2013-08-01','16:20:00',11.11),('7643','2013-08-01','16:25:00',7.98),('7643','2013-08-01','16:30:00',10.63),('7643','2013-08-01','16:35:00',10.42),('7643','2013-08-01','16:40:00',10.23),('7643','2013-08-01','16:45:00',10),('7643','2013-08-01','16:50:00',9.74),('7643','2013-08-01','16:55:00',9.47),('7643','2013-08-01','17:00:00',9.17),('7643','2013-08-01','17:05:00',8.75),('7643','2013-08-01','17:10:00',8.48),('7643','2013-08-01','17:15:00',8.27),('7643','2013-08-01','17:20:00',8),('7643','2013-08-01','17:25:00',7.66),('7643','2013-08-01','17:30:00',7.28),('7643','2013-08-01','17:35:00',6.87),('7643','2013-08-01','17:40:00',6.57),('7643','2013-08-01','17:45:00',6.17),('7643','2013-08-01','17:50:00',5.77),('7643','2013-08-01','17:55:00',5.54),('7643','2013-08-01','18:00:00',5.23),('7643','2013-08-01','18:05:00',5.02),('7643','2013-08-01','18:10:00',4.7),('7643','2013-08-01','18:15:00',4.34),('7643','2013-08-01','18:20:00',3.99),('7643','2013-08-01','18:25:00',3.74),('7643','2013-08-01','18:30:00',3.44),('7643','2013-08-01','18:35:00',3.13),('7643','2013-08-01','18:40:00',2.84),('7643','2013-08-01','18:45:00',2.55),('7643','2013-08-01','18:50:00',2.26),('7643','2013-08-01','18:55:00',1.94),('7643','2013-08-01','19:00:00',1.62),('7643','2013-08-01','19:05:00',1.38),('7643','2013-08-01','19:10:00',1.24),('7643','2013-08-01','19:15:00',1.04),('7643','2013-07-31','07:05:00',1.1),('7643','2013-07-31','07:10:00',1.37),('7643','2013-07-31','07:15:00',1.62),('7643','2013-07-31','07:20:00',1.89),('7643','2013-07-31','07:25:00',2.17),('7643','2013-07-31','07:30:00',2.44),('7643','2013-07-31','07:35:00',2.76),('7643','2013-07-31','07:40:00',3.08),('7643','2013-07-31','07:45:00',3.36),('7643','2013-07-31','07:50:00',3.66),('7643','2013-07-31','07:55:00',4.01),('7643','2013-07-31','08:00:00',4.37),('7643','2013-07-31','08:05:00',4.72),('7643','2013-07-31','08:10:00',5.05),('7643','2013-07-31','08:15:00',5.4),('7643','2013-07-31','08:20:00',5.77),('7643','2013-07-31','08:25:00',6.14),('7643','2013-07-31','08:30:00',6.49),('7643','2013-07-31','08:35:00',6.83),('7643','2013-07-31','08:40:00',7.2),('7643','2013-07-31','08:45:00',7.5),('7643','2013-07-31','08:50:00',7.83),('7643','2013-07-31','08:55:00',8.1),('7643','2013-07-31','09:00:00',8.35),('7643','2013-07-31','09:05:00',8.68),('7643','2013-07-31','09:10:00',9),('7643','2013-07-31','09:15:00',9.33),('7643','2013-07-31','09:20:00',9.6),('7643','2013-07-31','09:25:00',9.86),('7643','2013-07-31','09:30:00',10.15),('7643','2013-07-31','09:35:00',10.45),('7643','2013-07-31','09:40:00',10.71),('7643','2013-07-31','09:45:00',10.92),('7643','2013-07-31','09:50:00',11.2),('7643','2013-07-31','09:55:00',11.42),('7643','2013-07-31','10:00:00',11.54),('7643','2013-07-31','10:05:00',11.8),('7643','2013-07-31','10:10:00',12.04),('7643','2013-07-31','10:15:00',12.27),('7643','2013-07-31','10:20:00',12.44),('7643','2013-07-31','10:25:00',12.75),('7643','2013-07-31','10:30:00',13),('7643','2013-07-31','10:35:00',13.15),('7643','2013-07-31','10:40:00',13.27),('7643','2013-07-31','10:45:00',13.41),('7643','2013-07-31','10:50:00',13.6),('7643','2013-07-31','10:55:00',13.76),('7643','2013-07-31','11:00:00',13.93),('7643','2013-07-31','11:05:00',14.08),('7643','2013-07-31','11:10:00',14.28),('7643','2013-07-31','11:15:00',14.53),('7643','2013-07-31','11:20:00',14.62),('7643','2013-07-31','11:25:00',14.7),('7643','2013-07-31','11:30:00',14.8),('7643','2013-07-31','11:35:00',14.96),('7643','2013-07-31','11:40:00',15.08),('7643','2013-07-31','11:45:00',15.22),('7643','2013-07-31','11:50:00',15.35),('7643','2013-07-31','11:55:00',15.32),('7643','2013-07-31','12:00:00',15.42),('7643','2013-07-31','12:05:00',15.48),('7643','2013-07-31','12:10:00',15.59),('7643','2013-07-31','12:15:00',15.69),('7643','2013-07-31','12:20:00',15.66),('7643','2013-07-31','12:25:00',15.73),('7643','2013-07-31','12:30:00',15.79),('7643','2013-07-31','12:35:00',15.94),('7643','2013-07-31','12:40:00',15.95),('7643','2013-07-31','12:45:00',15.82),('7643','2013-07-31','12:50:00',16.01),('7643','2013-07-31','12:55:00',15.96),('7643','2013-07-31','13:00:00',15.93),('7643','2013-07-31','13:05:00',15.93),('7643','2013-07-31','13:10:00',15.96),('7643','2013-07-31','13:15:00',15.22),('7643','2013-07-31','13:20:00',16.04),('7643','2013-07-31','13:25:00',15.96),('7643','2013-07-31','13:30:00',15.95),('7643','2013-07-31','13:35:00',15.93),('7643','2013-07-31','13:40:00',15.95),('7643','2013-07-31','13:45:00',14.45),('7643','2013-07-31','13:50:00',15.61),('7643','2013-07-31','13:55:00',15.68),('7643','2013-07-31','14:00:00',14.36),('7643','2013-07-31','14:05:00',15.68),('7643','2013-07-31','14:10:00',15.15),('7643','2013-07-31','14:15:00',15.56),('7643','2013-07-31','14:20:00',13.99),('7643','2013-07-31','14:25:00',14.89),('7643','2013-07-31','14:30:00',14.9),('7643','2013-07-31','14:35:00',12.38),('7643','2013-07-31','14:40:00',14.94),('7643','2013-07-31','14:45:00',14.83),('7643','2013-07-31','14:50:00',14.47),('7643','2013-07-31','14:55:00',14.38),('7643','2013-07-31','15:00:00',14.09),('7643','2013-07-31','15:05:00',13.57),('7643','2013-07-31','15:10:00',14.29),('7643','2013-07-31','15:15:00',12.4),('7643','2013-07-31','15:20:00',9.72),('7643','2013-07-31','15:25:00',13.36),('7643','2013-07-31','15:30:00',13.47),('7643','2013-07-31','15:35:00',13.61),('7643','2013-07-31','15:40:00',8.27),('7643','2013-07-31','15:45:00',13.16),('7643','2013-07-31','15:50:00',12.77),('7643','2013-07-31','15:55:00',12.69),('7643','2013-07-31','16:00:00',12.6),('7643','2013-07-31','16:05:00',12.31),('7643','2013-07-31','16:10:00',11.86),('7643','2013-07-31','16:15:00',11.69),('7643','2013-07-31','16:20:00',11.52),('7643','2013-07-31','16:25:00',11.29),('7643','2013-07-31','16:30:00',10.93),('7643','2013-07-31','16:35:00',10.73),('7643','2013-07-31','16:40:00',10.53),('7643','2013-07-31','16:45:00',10.26),('7643','2013-07-31','16:50:00',10),('7643','2013-07-31','16:55:00',9.74),('7643','2013-07-31','17:00:00',9.4),('7643','2013-07-31','17:05:00',9.07),('7643','2013-07-31','17:10:00',8.74),('7643','2013-07-31','17:15:00',8.48),('7643','2013-07-31','17:20:00',8.11),('7643','2013-07-31','17:25:00',7.78),('7643','2013-07-31','17:30:00',7.44),('7643','2013-07-31','17:35:00',7.23),('7643','2013-07-31','17:40:00',6.86),('7643','2013-07-31','17:45:00',6.48),('7643','2013-07-31','17:50:00',6.19),('7643','2013-07-31','17:55:00',5.84),('7643','2013-07-31','18:00:00',5.47),('7643','2013-07-31','18:05:00',5.26),('7643','2013-07-31','18:10:00',4.9),('7643','2013-07-31','18:15:00',4.56),('7643','2013-07-31','18:20:00',4.26),('7643','2013-07-31','18:25:00',3.93),('7643','2013-07-31','18:30:00',3.62),('7643','2013-07-31','18:35:00',3.31),('7643','2013-07-31','18:40:00',2.99),('7643','2013-07-31','18:45:00',2.69),('7643','2013-07-31','18:50:00',2.36),('7643','2013-07-31','18:55:00',2),('7643','2013-07-31','19:00:00',1.67),('7643','2013-07-31','19:05:00',1.46),('7643','2013-07-31','19:10:00',1.16),('7643','2013-07-30','07:05:00',1.2),('7643','2013-07-30','07:10:00',1.37),('7643','2013-07-30','07:15:00',1.65),('7643','2013-07-30','07:20:00',1.92),('7643','2013-07-30','07:25:00',2.18),('7643','2013-07-30','07:30:00',2.57),('7643','2013-07-30','07:35:00',2.86),('7643','2013-07-30','07:40:00',3.19),('7643','2013-07-30','07:45:00',3.49),('7643','2013-07-30','07:50:00',3.79),('7643','2013-07-30','07:55:00',4.11),('7643','2013-07-30','08:00:00',4.49),('7643','2013-07-30','08:05:00',4.86),('7643','2013-07-30','08:10:00',5.21),('7643','2013-07-30','08:15:00',5.54),('7643','2013-07-30','08:20:00',5.91),('7643','2013-07-30','08:25:00',6.3),('7643','2013-07-30','08:30:00',6.62),('7643','2013-07-30','08:35:00',6.93),('7643','2013-07-30','08:40:00',7.33),('7643','2013-07-30','08:45:00',7.63),('7643','2013-07-30','08:50:00',7.93),('7643','2013-07-30','08:55:00',8.29),('7643','2013-07-30','09:00:00',8.57),('7643','2013-07-30','09:05:00',8.89),('7643','2013-07-30','09:10:00',9.18),('7643','2013-07-30','09:15:00',9.42),('7643','2013-07-30','09:20:00',9.66),('7643','2013-07-30','09:25:00',9.93),('7643','2013-07-30','09:30:00',10.26),('7643','2013-07-30','09:35:00',10.55),('7643','2013-07-30','09:40:00',10.74),('7643','2013-07-30','09:45:00',11.06),('7643','2013-07-30','09:50:00',11.26),('7643','2013-07-30','09:55:00',11.5),('7643','2013-07-30','10:00:00',11.71),('7643','2013-07-30','10:05:00',11.94),('7643','2013-07-30','10:10:00',12.09),('7643','2013-07-30','10:15:00',12.29),('7643','2013-07-30','10:20:00',12.63),('7643','2013-07-30','10:25:00',12.74),('7643','2013-07-30','10:30:00',12.98),('7643','2013-07-30','10:35:00',13.23),('7643','2013-07-30','10:40:00',13.5),('7643','2013-07-30','10:45:00',13.71),('7643','2013-07-30','10:50:00',13.9),('7643','2013-07-30','10:55:00',13.97),('7643','2013-07-30','11:00:00',14.13),('7643','2013-07-30','11:05:00',14.3),('7643','2013-07-30','11:10:00',14.43),('7643','2013-07-30','11:15:00',14.59),('7643','2013-07-30','11:20:00',14.65),('7643','2013-07-30','11:25:00',14.74),('7643','2013-07-30','11:30:00',14.84),('7643','2013-07-30','11:35:00',15),('7643','2013-07-30','11:40:00',15.07),('7643','2013-07-30','11:45:00',15.32),('7643','2013-07-30','11:50:00',15.45),('7643','2013-07-30','11:55:00',15.57),('7643','2013-07-30','12:00:00',15.58),('7643','2013-07-30','12:05:00',15.63),('7643','2013-07-30','12:10:00',15.71),('7643','2013-07-30','12:15:00',15.89),('7643','2013-07-30','12:20:00',15.82),('7643','2013-07-30','12:25:00',16),('7643','2013-07-30','12:30:00',16),('7643','2013-07-30','12:35:00',15.87),('7643','2013-07-30','12:40:00',15.97),('7643','2013-07-30','12:45:00',16.37),('7643','2013-07-30','12:50:00',12.24),('7643','2013-07-30','12:55:00',16.4),('7643','2013-07-30','13:00:00',6.87),('7643','2013-07-30','13:05:00',15.06),('7643','2013-07-30','13:10:00',16.38),('7643','2013-07-30','13:15:00',16.16),('7643','2013-07-30','13:20:00',15.04),('7643','2013-07-30','13:25:00',15.08),('7643','2013-07-30','13:30:00',15.17),('7643','2013-07-30','13:35:00',16.05),('7643','2013-07-30','13:40:00',12.87),('7643','2013-07-30','13:45:00',13.72),('7643','2013-07-30','13:50:00',14.25),('7643','2013-07-30','13:55:00',10.15),('7643','2013-07-30','14:00:00',12.38),('7643','2013-07-30','14:05:00',16.59),('7643','2013-07-30','14:10:00',15.72),('7643','2013-07-30','14:15:00',15.86),('7643','2013-07-30','14:20:00',16.21),('7643','2013-07-30','14:25:00',15.79),('7643','2013-07-30','14:30:00',15.34),('7643','2013-07-30','14:35:00',15.11),('7643','2013-07-30','14:40:00',15.27),('7643','2013-07-30','14:45:00',15.27),('7643','2013-07-30','14:50:00',9.91),('7643','2013-07-30','14:55:00',6.28),('7643','2013-07-30','15:00:00',5.06),('7643','2013-07-30','15:05:00',15.48),('7643','2013-07-30','15:10:00',14.65),('7643','2013-07-30','15:15:00',11.51),('7643','2013-07-30','15:20:00',15),('7643','2013-07-30','15:25:00',13.31),('7643','2013-07-30','15:30:00',13.91),('7643','2013-07-30','15:35:00',12.84),('7643','2013-07-30','15:40:00',9),('7643','2013-07-30','15:45:00',13.39),('7643','2013-07-30','15:50:00',12.94),('7643','2013-07-30','15:55:00',12.62),('7643','2013-07-30','16:00:00',12.38),('7643','2013-07-30','16:05:00',12.4),('7643','2013-07-30','16:10:00',12.23),('7643','2013-07-30','16:15:00',11.96),('7643','2013-07-30','16:20:00',12.02),('7643','2013-07-30','16:25:00',10.42),('7643','2013-07-30','16:30:00',11.17),('7643','2013-07-30','16:35:00',4.97),('7643','2013-07-30','16:40:00',10.58),('7643','2013-07-30','16:45:00',10.17),('7643','2013-07-30','16:50:00',10.07),('7643','2013-07-30','16:55:00',9.77),('7643','2013-07-30','17:00:00',9.54),('7643','2013-07-30','17:05:00',9.21),('7643','2013-07-30','17:10:00',8.63),('7643','2013-07-30','17:15:00',8.44),('7643','2013-07-30','17:20:00',7.98),('7643','2013-07-30','17:25:00',7.74),('7643','2013-07-30','17:30:00',7.36),('7643','2013-07-30','17:35:00',6.99),('7643','2013-07-30','17:40:00',6.77),('7643','2013-07-30','17:45:00',6.33),('7643','2013-07-30','17:50:00',6.17),('7643','2013-07-30','17:55:00',5.76),('7643','2013-07-30','18:00:00',5.43),('7643','2013-07-30','18:05:00',5.26),('7643','2013-07-30','18:10:00',4.89),('7643','2013-07-30','18:15:00',4.6),('7643','2013-07-30','18:20:00',4.31),('7643','2013-07-30','18:25:00',4.03),('7643','2013-07-30','18:30:00',3.74),('7643','2013-07-30','18:35:00',3.42),('7643','2013-07-30','18:40:00',3.1),('7643','2013-07-30','18:45:00',2.81),('7643','2013-07-30','18:50:00',2.47),('7643','2013-07-30','18:55:00',2.11),('7643','2013-07-30','19:00:00',1.77),('7643','2013-07-30','19:05:00',1.55),('7643','2013-07-30','19:10:00',1.24),('7643','2013-07-30','19:15:00',1.06),('7643','2014-04-07','07:25:00',1.02),('7643','2014-04-07','07:35:00',1.04),('7643','2014-04-07','07:40:00',1.36),('7643','2014-04-07','07:45:00',1.82),('7643','2014-04-07','07:50:00',2.91),('7643','2014-04-07','07:55:00',2.44),('7643','2014-04-07','08:00:00',2.48),('7643','2014-04-07','08:05:00',2.38),('7643','2014-04-07','08:10:00',3.01),('7643','2014-04-07','08:15:00',5),('7643','2014-04-07','08:20:00',4.84),('7643','2014-04-07','08:25:00',4.22),('7643','2014-04-07','08:30:00',5.97),('7643','2014-04-07','08:35:00',5.9),('7643','2014-04-07','08:40:00',5.35),('7643','2014-04-07','08:45:00',6.43),('7643','2014-04-07','08:50:00',6.72),('7643','2014-04-07','08:55:00',7.13),('7643','2014-04-07','09:00:00',7.52),('7643','2014-04-07','09:05:00',7.9),('7643','2014-04-07','09:10:00',8.21),('7643','2014-04-07','09:15:00',8.53),('7643','2014-04-07','09:20:00',8.86),('7643','2014-04-07','09:25:00',9.16),('7643','2014-04-07','09:30:00',9.49),('7643','2014-04-07','09:35:00',9.69),('7643','2014-04-07','09:40:00',9.82),('7643','2014-04-07','09:45:00',10.1),('7643','2014-04-07','09:50:00',10.32),('7643','2014-04-07','09:55:00',10.49),('7643','2014-04-07','10:00:00',10.66),('7643','2014-04-07','10:05:00',10.71),('7643','2014-04-07','10:10:00',10.99),('7643','2014-04-07','10:15:00',11.74),('7643','2014-04-07','10:20:00',11.98),('7643','2014-04-07','10:25:00',12.1),('7643','2014-04-07','10:30:00',12.25),('7643','2014-04-07','10:35:00',12.4),('7643','2014-04-07','10:40:00',12.77),('7643','2014-04-07','10:45:00',13.14),('7643','2014-04-07','10:50:00',13.27),('7643','2014-04-07','10:55:00',13.56),('7643','2014-04-07','11:00:00',13.76),('7643','2014-04-07','11:05:00',13.8),('7643','2014-04-07','11:10:00',14.04),('7643','2014-04-07','11:15:00',14.1),('7643','2014-04-07','11:20:00',12.91),('7643','2014-04-07','11:25:00',13.15),('7643','2014-04-07','11:30:00',14.63),('7643','2014-04-07','11:35:00',13.57),('7643','2014-04-07','11:40:00',14.29),('7643','2014-04-07','11:45:00',14.53),('7643','2014-04-07','11:50:00',14.41),('7643','2014-04-07','11:55:00',14.71),('7643','2014-04-07','12:00:00',14.93),('7643','2014-04-07','12:05:00',14.37),('7643','2014-04-07','12:10:00',14.26),('7643','2014-04-07','12:15:00',13.86),('7643','2014-04-07','12:20:00',13.97),('7643','2014-04-07','12:25:00',14.13),('7643','2014-04-07','12:30:00',15.12),('7643','2014-04-07','12:35:00',15.88),('7643','2014-04-07','12:40:00',13.86),('7643','2014-04-07','12:45:00',12.47),('7643','2014-04-07','12:50:00',13.98),('7643','2014-04-07','12:55:00',15.83),('7643','2014-04-07','13:00:00',14.96),('7643','2014-04-07','13:05:00',15.93),('7643','2014-04-07','13:10:00',16.06),('7643','2014-04-07','13:15:00',16.29),('7643','2014-04-07','13:20:00',16.08),('7643','2014-04-07','13:25:00',15.99),('7643','2014-04-07','13:30:00',16.2),('7643','2014-04-07','13:35:00',16.18),('7643','2014-04-07','13:40:00',16.1),('7643','2014-04-07','13:45:00',15.84),('7643','2014-04-07','13:50:00',15.93),('7643','2014-04-07','13:55:00',15.98),('7643','2014-04-07','14:00:00',15.88),('7643','2014-04-07','14:05:00',15.81),('7643','2014-04-07','14:10:00',15.75),('7643','2014-04-07','14:15:00',15.62),('7643','2014-04-07','14:20:00',14.81),('7643','2014-04-07','14:25:00',15.02),('7643','2014-04-07','14:30:00',15.39),('7643','2014-04-07','14:35:00',14.67),('7643','2014-04-07','14:40:00',13.67),('7643','2014-04-07','14:45:00',12.88),('7643','2014-04-07','14:50:00',14.59),('7643','2014-04-07','14:55:00',14.95),('7643','2014-04-07','15:00:00',14.6),('7643','2014-04-07','15:05:00',14.09),('7643','2014-04-07','15:10:00',14.14),('7643','2014-04-07','15:15:00',13.91),('7643','2014-04-07','15:20:00',13.51),('7643','2014-04-07','15:25:00',13.52),('7643','2014-04-07','15:30:00',13.05),('7643','2014-04-07','15:35:00',12.83),('7643','2014-04-07','15:40:00',12.86),('7643','2014-04-07','15:45:00',12.04),('7643','2014-04-07','15:50:00',12.33),('7643','2014-04-07','15:55:00',12.18),('7643','2014-04-07','16:00:00',11.73),('7643','2014-04-07','16:05:00',11.46),('7643','2014-04-07','16:10:00',10.93),('7643','2014-04-07','16:15:00',10.24),('7643','2014-04-07','16:20:00',9.39),('7643','2014-04-07','16:25:00',10.23),('7643','2014-04-07','16:30:00',10.59),('7643','2014-04-07','16:35:00',10.36),('7643','2014-04-07','16:40:00',9.63),('7643','2014-04-07','16:45:00',9.08),('7643','2014-04-07','16:50:00',9.24),('7643','2014-04-07','16:55:00',8.53),('7643','2014-04-07','17:00:00',7.75),('7643','2014-04-07','17:05:00',8.14),('7643','2014-04-07','17:10:00',7.66),('7643','2014-04-07','17:15:00',7.42),('7643','2014-04-07','17:20:00',7.09),('7643','2014-04-07','17:25:00',6.49),('7643','2014-04-07','17:30:00',6.04),('7643','2014-04-07','17:35:00',5.26),('7643','2014-04-07','17:40:00',5.31),('7643','2014-04-07','17:45:00',4.97),('7643','2014-04-07','17:50:00',4.7),('7643','2014-04-07','17:55:00',4.13),('7643','2014-04-07','18:00:00',3.97),('7643','2014-04-07','18:05:00',3.78),('7643','2014-04-07','18:10:00',3.35),('7643','2014-04-07','18:15:00',3.14),('7643','2014-04-07','18:20:00',2.71),('7643','2014-04-07','18:25:00',2.23),('7643','2014-04-07','18:30:00',1.77),('7643','2014-04-07','18:35:00',1.51),('7643','2014-04-07','18:40:00',1.17),('7643','2013-07-29','06:55:00',1.32),('7643','2013-07-29','07:00:00',1.33),('7643','2013-07-29','07:05:00',1.77),('7643','2013-07-29','07:10:00',1.62),('7643','2013-07-29','07:15:00',1.09),('7643','2013-07-29','07:20:00',1.3),('7643','2013-07-29','07:25:00',1.98),('7643','2013-07-29','07:30:00',2.79),('7643','2013-07-29','07:35:00',2.73),('7643','2013-07-29','07:40:00',3.07),('7643','2013-07-29','07:45:00',1.7),('7643','2013-07-29','07:50:00',1.54),('7643','2013-07-29','07:55:00',3.95),('7643','2013-07-29','08:00:00',4.41),('7643','2013-07-29','08:05:00',4.82),('7643','2013-07-29','08:10:00',5.05),('7643','2013-07-29','08:15:00',5.36),('7643','2013-07-29','08:20:00',6.11),('7643','2013-07-29','08:25:00',6.56),('7643','2013-07-29','08:30:00',6.54),('7643','2013-07-29','08:35:00',6.75),('7643','2013-07-29','08:40:00',6.95),('7643','2013-07-29','08:45:00',7.31),('7643','2013-07-29','08:50:00',7.7),('7643','2013-07-29','08:55:00',8.03),('7643','2013-07-29','09:00:00',8.42),('7643','2013-07-29','09:05:00',8.75),('7643','2013-07-29','09:10:00',9),('7643','2013-07-29','09:15:00',9.12),('7643','2013-07-29','09:20:00',9.84),('7643','2013-07-29','09:25:00',10.23),('7643','2013-07-29','09:30:00',10.49),('7643','2013-07-29','09:35:00',10.86),('7643','2013-07-29','09:40:00',11.37),('7643','2013-07-29','09:45:00',11.69),('7643','2013-07-29','09:50:00',11.98),('7643','2013-07-29','09:55:00',12.09),('7643','2013-07-29','10:00:00',11.68),('7643','2013-07-29','10:05:00',12.19),('7643','2013-07-29','10:10:00',12.31),('7643','2013-07-29','10:15:00',12.4),('7643','2013-07-29','10:20:00',10.75),('7643','2013-07-29','10:25:00',11.69),('7643','2013-07-29','10:30:00',12.92),('7643','2013-07-29','10:35:00',6.3),('7643','2013-07-29','10:40:00',13.05),('7643','2013-07-29','10:45:00',13.29),('7643','2013-07-29','10:50:00',13.53),('7643','2013-07-29','10:55:00',12.42),('7643','2013-07-29','11:00:00',13.99),('7643','2013-07-29','11:05:00',14.13),('7643','2013-07-29','11:10:00',14.37),('7643','2013-07-29','11:15:00',14.52),('7643','2013-07-29','11:20:00',12.9),('7643','2013-07-29','11:25:00',2.35),('7643','2013-07-29','11:30:00',2.44),('7643','2013-07-29','11:35:00',7.81),('7643','2013-07-29','11:40:00',15.36),('7643','2013-07-29','11:45:00',15.27),('7643','2013-07-29','11:50:00',14.97),('7643','2013-07-29','11:55:00',14.68),('7643','2013-07-29','12:00:00',14.95),('7643','2013-07-29','12:05:00',14.79),('7643','2013-07-29','12:10:00',15.19),('7643','2013-07-29','12:15:00',15.06),('7643','2013-07-29','12:20:00',14.84),('7643','2013-07-29','12:25:00',15.02),('7643','2013-07-29','12:30:00',15.35),('7643','2013-07-29','12:35:00',15.62),('7643','2013-07-29','12:40:00',13.77),('7643','2013-07-29','12:45:00',7.41),('7643','2013-07-29','12:50:00',16.31),('7643','2013-07-29','12:55:00',16.58),('7643','2013-07-29','13:00:00',16.66),('7643','2013-07-29','13:05:00',11.78),('7643','2013-07-29','13:10:00',15.94),('7643','2013-07-29','13:15:00',9.45),('7643','2013-07-29','13:20:00',17.18),('7643','2013-07-29','13:25:00',16.37),('7643','2013-07-29','13:30:00',15.86),('7643','2013-07-29','13:35:00',16.22),('7643','2013-07-29','13:40:00',14.65),('7643','2013-07-29','13:45:00',15.89),('7643','2013-07-29','13:50:00',16.08),('7643','2013-07-29','13:55:00',16.09),('7643','2013-07-29','14:00:00',15.93),('7643','2013-07-29','14:05:00',16.42),('7643','2013-07-29','14:10:00',16.22),('7643','2013-07-29','14:15:00',15.84),('7643','2013-07-29','14:20:00',15.11),('7643','2013-07-29','14:25:00',15.31),('7643','2013-07-29','14:30:00',15.38),('7643','2013-07-29','14:35:00',15.05),('7643','2013-07-29','14:40:00',14.58),('7643','2013-07-29','14:45:00',14.61),('7643','2013-07-29','14:50:00',14.58),('7643','2013-07-29','14:55:00',14.41),('7643','2013-07-29','15:00:00',14.06),('7643','2013-07-29','15:05:00',13.83),('7643','2013-07-29','15:10:00',13.71),('7643','2013-07-29','15:15:00',13.6),('7643','2013-07-29','15:20:00',13.16),('7643','2013-07-29','15:25:00',12.86),('7643','2013-07-29','15:30:00',12.99),('7643','2013-07-29','15:35:00',12.89),('7643','2013-07-29','15:40:00',12.74),('7643','2013-07-29','15:45:00',12.56),('7643','2013-07-29','15:50:00',12.46),('7643','2013-07-29','15:55:00',12.19),('7643','2013-07-29','16:00:00',12.02),('7643','2013-07-29','16:05:00',11.76),('7643','2013-07-29','16:10:00',11.58),('7643','2013-07-29','16:15:00',11.36),('7643','2013-07-29','16:20:00',11.23),('7643','2013-07-29','16:25:00',10.91),('7643','2013-07-29','16:30:00',10.62),('7643','2013-07-29','16:35:00',10.48),('7643','2013-07-29','16:40:00',10.33),('7643','2013-07-29','16:45:00',9.98),('7643','2013-07-29','16:50:00',9.74),('7643','2013-07-29','16:55:00',9.45),('7643','2013-07-29','17:00:00',9.16),('7643','2013-07-29','17:05:00',8.82),('7643','2013-07-29','17:10:00',8.54),('7643','2013-07-29','17:15:00',8.23),('7643','2013-07-29','17:20:00',7.96),('7643','2013-07-29','17:25:00',7.65),('7643','2013-07-29','17:30:00',7.25),('7643','2013-07-29','17:35:00',7),('7643','2013-07-29','17:40:00',6.72),('7643','2013-07-29','17:45:00',6.34),('7643','2013-07-29','17:50:00',5.95),('7643','2013-07-29','17:55:00',5.63),('7643','2013-07-29','18:00:00',5.35),('7643','2013-07-29','18:05:00',5.01),('7643','2013-07-29','18:10:00',4.74),('7643','2013-07-29','18:15:00',4.38),('7643','2013-07-29','18:20:00',4.11),('7643','2013-07-29','18:25:00',3.88),('7643','2013-07-29','18:30:00',3.52),('7643','2013-07-29','18:35:00',3.23),('7643','2013-07-29','18:40:00',2.96),('7643','2013-07-29','18:45:00',2.69),('7643','2013-07-29','18:50:00',2.36),('7643','2013-07-29','18:55:00',2.04),('7643','2013-07-29','19:00:00',1.76),('7643','2013-07-29','19:05:00',1.53),('7643','2013-07-29','19:10:00',1.36),('7643','2013-07-29','19:15:00',1.16),('7643','2013-07-28','07:00:00',1.12),('7643','2013-07-28','07:05:00',1.3),('7643','2013-07-28','07:10:00',1.51),('7643','2013-07-28','07:15:00',1.68),('7643','2013-07-28','07:20:00',1.87),('7643','2013-07-28','07:25:00',2.08),('7643','2013-07-28','07:30:00',2.34),('7643','2013-07-28','07:35:00',2.61),('7643','2013-07-28','07:40:00',2.88),('7643','2013-07-28','07:45:00',3.15),('7643','2013-07-28','07:50:00',3.42),('7643','2013-07-28','07:55:00',3.74),('7643','2013-07-28','08:00:00',4.05),('7643','2013-07-28','08:05:00',4.36),('7643','2013-07-28','08:10:00',4.62),('7643','2013-07-28','08:15:00',4.92),('7643','2013-07-28','08:20:00',5.25),('7643','2013-07-28','08:25:00',5.49),('7643','2013-07-28','08:30:00',5.72),('7643','2013-07-28','08:35:00',5.98),('7643','2013-07-28','08:40:00',6.32),('7643','2013-07-28','08:45:00',6.62),('7643','2013-07-28','08:50:00',6.89),('7643','2013-07-28','08:55:00',7.18),('7643','2013-07-28','09:00:00',7.56),('7643','2013-07-28','09:05:00',7.83),('7643','2013-07-28','09:10:00',8.09),('7643','2013-07-28','09:15:00',8.34),('7643','2013-07-28','09:20:00',8.62),('7643','2013-07-28','09:25:00',8.82),('7643','2013-07-28','09:30:00',9.07),('7643','2013-07-28','09:35:00',9.39),('7643','2013-07-28','09:40:00',9.73),('7643','2013-07-28','09:45:00',9.99),('7643','2013-07-28','09:50:00',10.15),('7643','2013-07-28','09:55:00',10.37),('7643','2013-07-28','10:00:00',10.61),('7643','2013-07-28','10:05:00',10.91),('7643','2013-07-28','10:10:00',11.11),('7643','2013-07-28','10:15:00',11.22),('7643','2013-07-28','10:20:00',11.56),('7643','2013-07-28','10:25:00',11.63),('7643','2013-07-28','10:30:00',11.79),('7643','2013-07-28','10:35:00',12.01),('7643','2013-07-28','10:40:00',12.34),('7643','2013-07-28','10:45:00',12.4),('7643','2013-07-28','10:50:00',12.46),('7643','2013-07-28','10:55:00',12.7),('7643','2013-07-28','11:00:00',12.82),('7643','2013-07-28','11:05:00',12.73),('7643','2013-07-28','11:10:00',12.84),('7643','2013-07-28','11:15:00',13.1),('7643','2013-07-28','11:20:00',13.15),('7643','2013-07-28','11:25:00',13.34),('7643','2013-07-28','11:30:00',13.41),('7643','2013-07-28','11:35:00',13.4),('7643','2013-07-28','11:40:00',13.49),('7643','2013-07-28','11:45:00',13.61),('7643','2013-07-28','11:50:00',13.7),('7643','2013-07-28','11:55:00',13.79),('7643','2013-07-28','12:00:00',13.88),('7643','2013-07-28','12:05:00',13.85),('7643','2013-07-28','12:10:00',13.95),('7643','2013-07-28','12:15:00',14.29),('7643','2013-07-28','12:20:00',14.14),('7643','2013-07-28','12:25:00',14.11),('7643','2013-07-28','12:30:00',14.22),('7643','2013-07-28','12:35:00',14.23),('7643','2013-07-28','12:40:00',14.42),('7643','2013-07-28','12:45:00',14.52),('7643','2013-07-28','12:50:00',14.49),('7643','2013-07-28','12:55:00',14.21),('7643','2013-07-28','13:00:00',14.21),('7643','2013-07-28','13:05:00',14.39),('7643','2013-07-28','13:10:00',14.35),('7643','2013-07-28','13:15:00',14.49),('7643','2013-07-28','13:20:00',14.72),('7643','2013-07-28','13:25:00',15.02),('7643','2013-07-28','13:30:00',15.06),('7643','2013-07-28','13:35:00',15.16),('7643','2013-07-28','13:40:00',15.15),('7643','2013-07-28','13:45:00',15.2),('7643','2013-07-28','13:50:00',15.17),('7643','2013-07-28','13:55:00',15.11),('7643','2013-07-28','14:00:00',15.02),('7643','2013-07-28','14:05:00',14.88),('7643','2013-07-28','14:10:00',14.85),('7643','2013-07-28','14:15:00',14.81),('7643','2013-07-28','14:20:00',14.8),('7643','2013-07-28','14:25:00',14.52),('7643','2013-07-28','14:30:00',14.39),('7643','2013-07-28','14:35:00',14.32),('7643','2013-07-28','14:40:00',14.21),('7643','2013-07-28','14:45:00',14.2),('7643','2013-07-28','14:50:00',14.07),('7643','2013-07-28','14:55:00',14),('7643','2013-07-28','15:00:00',13.91),('7643','2013-07-28','15:05:00',13.72),('7643','2013-07-28','15:10:00',13.44),('7643','2013-07-28','15:15:00',13.42),('7643','2013-07-28','15:20:00',13.24),('7643','2013-07-28','15:25:00',13.17),('7643','2013-07-28','15:30:00',13),('7643','2013-07-28','15:35:00',12.89),('7643','2013-07-28','15:40:00',12.94),('7643','2013-07-28','15:45:00',13.14),('7643','2013-07-28','15:50:00',11.08),('7643','2013-07-28','15:55:00',7.53),('7643','2013-07-28','16:00:00',6.41),('7643','2013-07-28','16:05:00',9.85),('7643','2013-07-28','16:10:00',11.64),('7643','2013-07-28','16:15:00',8.99),('7643','2013-07-28','16:20:00',9.35),('7643','2013-07-28','16:25:00',8.76),('7643','2013-07-28','16:30:00',11.57),('7643','2013-07-28','16:35:00',9.75),('7643','2013-07-28','16:40:00',7.95),('7643','2013-07-28','16:45:00',10.99),('7643','2013-07-28','16:50:00',9.8),('7643','2013-07-28','16:55:00',6.53),('7643','2013-07-28','17:00:00',4.85),('7643','2013-07-28','17:05:00',6.37),('7643','2013-07-28','17:10:00',4.86),('7643','2013-07-28','17:15:00',3.28),('7643','2013-07-28','17:20:00',7.31),('7643','2013-07-28','17:25:00',7.54),('7643','2013-07-28','17:30:00',4.55),('7643','2013-07-28','17:35:00',3.16),('7643','2013-07-28','17:40:00',3.83),('7643','2013-07-28','17:45:00',6.81),('7643','2013-07-28','17:50:00',6.14),('7643','2013-07-28','17:55:00',5.49),('7643','2013-07-28','18:00:00',4.14),('7643','2013-07-28','18:05:00',2.9),('7643','2013-07-28','18:10:00',4.14),('7643','2013-07-28','18:15:00',3.83),('7643','2013-07-28','18:20:00',4.14),('7643','2013-07-28','18:25:00',3.8),('7643','2013-07-28','18:30:00',3.67),('7643','2013-07-28','18:35:00',3.22),('7643','2013-07-28','18:40:00',2.37),('7643','2013-07-28','18:45:00',1.37),('7643','2013-07-28','18:50:00',1.79),('7643','2013-07-28','18:55:00',1.82),('7643','2013-07-28','19:00:00',2.39),('7643','2013-07-28','19:05:00',2.38),('7643','2013-07-28','19:10:00',1.97),('7643','2013-07-28','19:15:00',1.19),('7643','2013-07-27','07:00:00',1),('7643','2013-07-27','07:05:00',1.19),('7643','2013-07-27','07:10:00',1.41),('7643','2013-07-27','07:15:00',1.61),('7643','2013-07-27','07:20:00',1.81),('7643','2013-07-27','07:25:00',2.07),('7643','2013-07-27','07:30:00',2.32),('7643','2013-07-27','07:35:00',2.62),('7643','2013-07-27','07:40:00',2.82),('7643','2013-07-27','07:45:00',3.13),('7643','2013-07-27','07:50:00',3.38),('7643','2013-07-27','07:55:00',3.67),('7643','2013-07-27','08:00:00',3.99),('7643','2013-07-27','08:05:00',4.34),('7643','2013-07-27','08:10:00',4.64),('7643','2013-07-27','08:15:00',4.96),('7643','2013-07-27','08:20:00',5.29),('7643','2013-07-27','08:25:00',5.6),('7643','2013-07-27','08:30:00',5.89),('7643','2013-07-27','08:35:00',6.25),('7643','2013-07-27','08:40:00',6.54),('7643','2013-07-27','08:45:00',6.86),('7643','2013-07-27','08:50:00',7.13),('7643','2013-07-27','08:55:00',7.44),('7643','2013-07-27','09:00:00',7.7),('7643','2013-07-27','09:05:00',8.02),('7643','2013-07-27','09:10:00',8.36),('7643','2013-07-27','09:15:00',8.63),('7643','2013-07-27','09:20:00',8.78),('7643','2013-07-27','09:25:00',9.11),('7643','2013-07-27','09:30:00',9.4),('7643','2013-07-27','09:35:00',9.63),('7643','2013-07-27','09:40:00',9.92),('7643','2013-07-27','09:45:00',10.01),('7643','2013-07-27','09:50:00',10.2),('7643','2013-07-27','09:55:00',10.41),('7643','2013-07-27','10:00:00',10.61),('7643','2013-07-27','10:05:00',10.84),('7643','2013-07-27','10:10:00',11.02),('7643','2013-07-27','10:15:00',11.11),('7643','2013-07-27','10:20:00',11.36),('7643','2013-07-27','10:25:00',11.52),('7643','2013-07-27','10:30:00',11.82),('7643','2013-07-27','10:35:00',12.03),('7643','2013-07-27','10:40:00',12.16),('7643','2013-07-27','10:45:00',12.41),('7643','2013-07-27','10:50:00',12.54),('7643','2013-07-27','10:55:00',12.68),('7643','2013-07-27','11:00:00',12.85),('7643','2013-07-27','11:05:00',12.94),('7643','2013-07-27','11:10:00',13.01),('7643','2013-07-27','11:15:00',13.09),('7643','2013-07-27','11:20:00',13.22),('7643','2013-07-27','11:25:00',13.18),('7643','2013-07-27','11:30:00',13.24),('7643','2013-07-27','11:35:00',13.19),('7643','2013-07-27','11:40:00',13.52),('7643','2013-07-27','11:45:00',13.64),('7643','2013-07-27','11:50:00',13.72),('7643','2013-07-27','11:55:00',13.83),('7643','2013-07-27','12:00:00',14.03),('7643','2013-07-27','12:05:00',14.03),('7643','2013-07-27','12:10:00',14.09),('7643','2013-07-27','12:15:00',14.31),('7643','2013-07-27','12:20:00',14.19),('7643','2013-07-27','12:25:00',14.13),('7643','2013-07-27','12:30:00',14.04),('7643','2013-07-27','12:35:00',14.5),('7643','2013-07-27','12:40:00',14.53),('7643','2013-07-27','12:45:00',14.38),('7643','2013-07-27','12:50:00',14.21),('7643','2013-07-27','12:55:00',14.25),('7643','2013-07-27','13:00:00',14.48),('7643','2013-07-27','13:05:00',14.16),('7643','2013-07-27','13:10:00',14.57),('7643','2013-07-27','13:15:00',14.96),('7643','2013-07-27','13:20:00',14.82),('7643','2013-07-27','13:25:00',14.8),('7643','2013-07-27','13:30:00',14.73),('7643','2013-07-27','13:35:00',14.92),('7643','2013-07-27','13:40:00',15.07),('7643','2013-07-27','13:45:00',14.79),('7643','2013-07-27','13:50:00',14.83),('7643','2013-07-27','13:55:00',14.75),('7643','2013-07-27','14:00:00',14.66),('7643','2013-07-27','14:05:00',14.49),('7643','2013-07-27','14:10:00',14.36),('7643','2013-07-27','14:15:00',14.52),('7643','2013-07-27','14:20:00',14.26),('7643','2013-07-27','14:25:00',14.29),('7643','2013-07-27','14:30:00',14.21),('7643','2013-07-27','14:35:00',14.18),('7643','2013-07-27','14:40:00',14.04),('7643','2013-07-27','14:45:00',13.87),('7643','2013-07-27','14:50:00',13.82),('7643','2013-07-27','14:55:00',13.69),('7643','2013-07-27','15:00:00',13.41),('7643','2013-07-27','15:05:00',13.36),('7643','2013-07-27','15:10:00',13.31),('7643','2013-07-27','15:15:00',13.16),('7643','2013-07-27','15:20:00',12.83),('7643','2013-07-27','15:25:00',12.75),('7643','2013-07-27','15:30:00',12.64),('7643','2013-07-27','15:35:00',12.54),('7643','2013-07-27','15:40:00',12.4),('7643','2013-07-27','15:45:00',12.2),('7643','2013-07-27','15:50:00',12.09),('7643','2013-07-27','15:55:00',11.87),('7643','2013-07-27','16:00:00',11.66),('7643','2013-07-27','16:05:00',11.64),('7643','2013-07-27','16:10:00',11.46),('7643','2013-07-27','16:15:00',11.26),('7643','2013-07-27','16:20:00',11.12),('7643','2013-07-27','16:25:00',10.9),('7643','2013-07-27','16:30:00',10.77),('7643','2013-07-27','16:35:00',10.6),('7643','2013-07-27','16:40:00',10.37),('7643','2013-07-27','16:45:00',10.04),('7643','2013-07-27','16:50:00',9.74),('7643','2013-07-27','16:55:00',9.52),('7643','2013-07-27','17:00:00',9.25),('7643','2013-07-27','17:05:00',8.94),('7643','2013-07-27','17:10:00',8.64),('7643','2013-07-27','17:15:00',8.38),('7643','2013-07-27','17:20:00',8.08),('7643','2013-07-27','17:25:00',7.71),('7643','2013-07-27','17:30:00',7.4),('7643','2013-07-27','17:35:00',7.14),('7643','2013-07-27','17:40:00',6.81),('7643','2013-07-27','17:45:00',6.53),('7643','2013-07-27','17:50:00',6.16),('7643','2013-07-27','17:55:00',5.77),('7643','2013-07-27','18:00:00',5.46),('7643','2013-07-27','18:05:00',5.18),('7643','2013-07-27','18:10:00',4.86),('7643','2013-07-27','18:15:00',4.52),('7643','2013-07-27','18:20:00',4.18),('7643','2013-07-27','18:25:00',3.81),('7643','2013-07-27','18:30:00',3.62),('7643','2013-07-27','18:35:00',3.31),('7643','2013-07-27','18:40:00',3.01),('7643','2013-07-27','18:45:00',2.73),('7643','2013-07-27','18:50:00',2.44),('7643','2013-07-27','18:55:00',2.13),('7643','2013-07-27','19:00:00',1.84),('7643','2013-07-27','19:05:00',1.6),('7643','2013-07-27','19:10:00',1.35),('7643','2013-07-27','19:15:00',1.19),('7643','2013-07-26','07:00:00',1.1),('7643','2013-07-26','07:05:00',1.29),('7643','2013-07-26','07:10:00',1.49),('7643','2013-07-26','07:15:00',1.67),('7643','2013-07-26','07:20:00',1.85),('7643','2013-07-26','07:25:00',2.12),('7643','2013-07-26','07:30:00',2.36),('7643','2013-07-26','07:35:00',2.64),('7643','2013-07-26','07:40:00',2.88),('7643','2013-07-26','07:45:00',3.17),('7643','2013-07-26','07:50:00',3.49),('7643','2013-07-26','07:55:00',3.81),('7643','2013-07-26','08:00:00',4.14),('7643','2013-07-26','08:05:00',4.49),('7643','2013-07-26','08:10:00',4.76),('7643','2013-07-26','08:15:00',5.12),('7643','2013-07-26','08:20:00',5.47),('7643','2013-07-26','08:25:00',5.78),('7643','2013-07-26','08:30:00',6.05),('7643','2013-07-26','08:35:00',6.4),('7643','2013-07-26','08:40:00',6.68),('7643','2013-07-26','08:45:00',6.93),('7643','2013-07-26','08:50:00',7.23),('7643','2013-07-26','08:55:00',7.57),('7643','2013-07-26','09:00:00',7.93),('7643','2013-07-26','09:05:00',8.17),('7643','2013-07-26','09:10:00',8.45),('7643','2013-07-26','09:15:00',8.71),('7643','2013-07-26','09:20:00',9.05),('7643','2013-07-26','09:25:00',9.3),('7643','2013-07-26','09:30:00',9.52),('7643','2013-07-26','09:35:00',9.76),('7643','2013-07-26','09:40:00',10.03),('7643','2013-07-26','09:45:00',10.3),('7643','2013-07-26','09:50:00',10.49),('7643','2013-07-26','09:55:00',10.76),('7643','2013-07-26','10:00:00',10.98),('7643','2013-07-26','10:05:00',11.23),('7643','2013-07-26','10:10:00',11.46),('7643','2013-07-26','10:15:00',11.67),('7643','2013-07-26','10:20:00',11.76),('7643','2013-07-26','10:25:00',11.89),('7643','2013-07-26','10:30:00',12.03),('7643','2013-07-26','10:35:00',12.24),('7643','2013-07-26','10:40:00',12.37),('7643','2013-07-26','10:45:00',12.46),('7643','2013-07-26','10:50:00',12.73),('7643','2013-07-26','10:55:00',12.85),('7643','2013-07-26','11:00:00',12.87),('7643','2013-07-26','11:05:00',13.05),('7643','2013-07-26','11:10:00',13.02),('7643','2013-07-26','11:15:00',13.13),('7643','2013-07-26','11:20:00',13.38),('7643','2013-07-26','11:25:00',13.74),('7643','2013-07-26','11:30:00',13.91),('7643','2013-07-26','11:35:00',14),('7643','2013-07-26','11:40:00',13.96),('7643','2013-07-26','11:45:00',14.15),('7643','2013-07-26','11:50:00',14.16),('7643','2013-07-26','11:55:00',14.21),('7643','2013-07-26','12:00:00',14.22),('7643','2013-07-26','12:05:00',14.62),('7643','2013-07-26','12:10:00',14.46),('7643','2013-07-26','12:15:00',14.52),('7643','2013-07-26','12:20:00',14.84),('7643','2013-07-26','12:25:00',14.59),('7643','2013-07-26','12:30:00',14.36),('7643','2013-07-26','12:35:00',14.27),('7643','2013-07-26','12:40:00',14.08),('7643','2013-07-26','12:45:00',14.56),('7643','2013-07-26','12:50:00',14.45),('7643','2013-07-26','12:55:00',14.58),('7643','2013-07-26','13:00:00',15.01),('7643','2013-07-26','13:05:00',15.13),('7643','2013-07-26','13:10:00',15.28),('7643','2013-07-26','13:15:00',15.42),('7643','2013-07-26','13:20:00',14.88),('7643','2013-07-26','13:25:00',15.08),('7643','2013-07-26','13:30:00',15.03),('7643','2013-07-26','13:35:00',15.48),('7643','2013-07-26','13:40:00',14.51),('7643','2013-07-26','13:45:00',15.45),('7643','2013-07-26','13:50:00',15.19),('7643','2013-07-26','13:55:00',15.14),('7643','2013-07-26','14:00:00',13.31),('7643','2013-07-26','14:05:00',14.48),('7643','2013-07-26','14:10:00',15.27),('7643','2013-07-26','14:15:00',14.62),('7643','2013-07-26','14:20:00',14.41),('7643','2013-07-26','14:25:00',14.23),('7643','2013-07-26','14:30:00',14.15),('7643','2013-07-26','14:35:00',14.26),('7643','2013-07-26','14:40:00',14.43),('7643','2013-07-26','14:45:00',14.22),('7643','2013-07-26','14:50:00',13.98),('7643','2013-07-26','14:55:00',13.87),('7643','2013-07-26','15:00:00',13.75);
INSERT INTO `solarlogmod` VALUES ('7643','2013-07-26','15:05:00',13.56),('7643','2013-07-26','15:10:00',13.52),('7643','2013-07-26','15:15:00',13.33),('7643','2013-07-26','15:20:00',13.27),('7643','2013-07-26','15:25:00',13.16),('7643','2013-07-26','15:30:00',12.94),('7643','2013-07-26','15:35:00',12.85),('7643','2013-07-26','15:40:00',12.7),('7643','2013-07-26','15:45:00',12.5),('7643','2013-07-26','15:50:00',12.31),('7643','2013-07-26','15:55:00',12.11),('7643','2013-07-26','16:00:00',11.85),('7643','2013-07-26','16:05:00',11.83),('7643','2013-07-26','16:10:00',11.54),('7643','2013-07-26','16:15:00',11.32),('7643','2013-07-26','16:20:00',11.07),('7643','2013-07-26','16:25:00',10.97),('7643','2013-07-26','16:30:00',10.79),('7643','2013-07-26','16:35:00',10.55),('7643','2013-07-26','16:40:00',10.36),('7643','2013-07-26','16:45:00',10.13),('7643','2013-07-26','16:50:00',9.89),('7643','2013-07-26','16:55:00',9.53),('7643','2013-07-26','17:00:00',9.2),('7643','2013-07-26','17:05:00',8.87),('7643','2013-07-26','17:10:00',8.62),('7643','2013-07-26','17:15:00',8.28),('7643','2013-07-26','17:20:00',8.02),('7643','2013-07-26','17:25:00',7.67),('7643','2013-07-26','17:30:00',7.36),('7643','2013-07-26','17:35:00',7.06),('7643','2013-07-26','17:40:00',6.67),('7643','2013-07-26','17:45:00',6.38),('7643','2013-07-26','17:50:00',6.09),('7643','2013-07-26','17:55:00',5.77),('7643','2013-07-26','18:00:00',5.56),('7643','2013-07-26','18:05:00',5.28),('7643','2013-07-26','18:10:00',4.94),('7643','2013-07-26','18:15:00',4.57),('7643','2013-07-26','18:20:00',4.24),('7643','2013-07-26','18:25:00',3.86),('7643','2013-07-26','18:30:00',3.76),('7643','2013-07-26','18:35:00',3.45),('7643','2013-07-26','18:40:00',3.16),('7643','2013-07-26','18:45:00',2.87),('7643','2013-07-26','18:50:00',2.56),('7643','2013-07-26','18:55:00',2.21),('7643','2013-07-26','19:00:00',1.95),('7643','2013-07-26','19:05:00',1.69),('7643','2013-07-26','19:10:00',1.44),('7643','2013-07-26','19:15:00',1.27),('7643','2013-07-26','19:20:00',1.04),('7643','2013-07-25','07:00:00',1.11),('7643','2013-07-25','07:05:00',1.27),('7643','2013-07-25','07:10:00',1.49),('7643','2013-07-25','07:15:00',1.7),('7643','2013-07-25','07:20:00',1.93),('7643','2013-07-25','07:25:00',2.16),('7643','2013-07-25','07:30:00',2.42),('7643','2013-07-25','07:35:00',2.72),('7643','2013-07-25','07:40:00',2.98),('7643','2013-07-25','07:45:00',3.27),('7643','2013-07-25','07:50:00',3.47),('7643','2013-07-25','07:55:00',3.69),('7643','2013-07-25','08:00:00',3.96),('7643','2013-07-25','08:05:00',4.33),('7643','2013-07-25','08:10:00',4.7),('7643','2013-07-25','08:15:00',4.97),('7643','2013-07-25','08:20:00',5.2),('7643','2013-07-25','08:25:00',5.56),('7643','2013-07-25','08:30:00',5.87),('7643','2013-07-25','08:35:00',6.23),('7643','2013-07-25','08:40:00',6.54),('7643','2013-07-25','08:45:00',6.81),('7643','2013-07-25','08:50:00',7.03),('7643','2013-07-25','08:55:00',7.53),('7643','2013-07-25','09:00:00',7.76),('7643','2013-07-25','09:05:00',8),('7643','2013-07-25','09:10:00',8.27),('7643','2013-07-25','09:15:00',8.57),('7643','2013-07-25','09:20:00',8.79),('7643','2013-07-25','09:25:00',9.05),('7643','2013-07-25','09:30:00',9.42),('7643','2013-07-25','09:35:00',9.28),('7643','2013-07-25','09:40:00',9.65),('7643','2013-07-25','09:45:00',10.08),('7643','2013-07-25','09:50:00',10.4),('7643','2013-07-25','09:55:00',10.58),('7643','2013-07-25','10:00:00',10.81),('7643','2013-07-25','10:05:00',10.81),('7643','2013-07-25','10:10:00',11.02),('7643','2013-07-25','10:15:00',11.13),('7643','2013-07-25','10:20:00',11.59),('7643','2013-07-25','10:25:00',11.78),('7643','2013-07-25','10:30:00',11.84),('7643','2013-07-25','10:35:00',12.1),('7643','2013-07-25','10:40:00',12.3),('7643','2013-07-25','10:45:00',12.39),('7643','2013-07-25','10:50:00',12.63),('7643','2013-07-25','10:55:00',12.89),('7643','2013-07-25','11:00:00',12.85),('7643','2013-07-25','11:05:00',12.28),('7643','2013-07-25','11:10:00',11.58),('7643','2013-07-25','11:15:00',13.21),('7643','2013-07-25','11:20:00',13.33),('7643','2013-07-25','11:25:00',13.79),('7643','2013-07-25','11:30:00',13.9),('7643','2013-07-25','11:35:00',13.36),('7643','2013-07-25','11:40:00',14.1),('7643','2013-07-25','11:45:00',14.33),('7643','2013-07-25','11:50:00',14.29),('7643','2013-07-25','11:55:00',14.61),('7643','2013-07-25','12:00:00',2.9),('7643','2013-07-25','13:45:00',13.62),('7643','2013-07-25','13:50:00',14.81),('7643','2013-07-25','14:30:00',14.67),('7643','2013-07-25','14:35:00',14.67),('7643','2013-07-25','14:40:00',14.7),('7643','2013-07-25','14:45:00',14.31),('7643','2013-07-25','14:50:00',14.33),('7643','2013-07-25','14:55:00',13.95),('7643','2013-07-25','15:00:00',13.98),('7643','2013-07-25','15:05:00',13.8),('7643','2013-07-25','15:10:00',13.63),('7643','2013-07-25','15:15:00',13.65),('7643','2013-07-25','15:20:00',13.4),('7643','2013-07-25','15:25:00',13.14),('7643','2013-07-25','15:30:00',12.99),('7643','2013-07-25','15:35:00',12.92),('7643','2013-07-25','15:40:00',12.87),('7643','2013-07-25','15:45:00',12.79),('7643','2013-07-25','15:50:00',12.52),('7643','2013-07-25','15:55:00',12.25),('7643','2013-07-25','16:00:00',12.01),('7643','2013-07-25','16:05:00',11.86),('7643','2013-07-25','16:10:00',11.62),('7643','2013-07-25','16:15:00',11.4),('7643','2013-07-25','16:20:00',11.23),('7643','2013-07-25','16:25:00',11.02),('7643','2013-07-25','16:30:00',10.81),('7643','2013-07-25','16:35:00',10.51),('7643','2013-07-25','16:40:00',10.33),('7643','2013-07-25','16:45:00',10.14),('7643','2013-07-25','16:50:00',9.77),('7643','2013-07-25','16:55:00',9.38),('7643','2013-07-25','17:00:00',9.08),('7643','2013-07-25','17:05:00',8.86),('7643','2013-07-25','17:10:00',8.65),('7643','2013-07-25','17:15:00',8.21),('7643','2013-07-25','17:20:00',7.92),('7643','2013-07-25','17:25:00',7.67),('7643','2013-07-25','17:30:00',7.22),('7643','2013-07-25','17:35:00',6.95),('7643','2013-07-25','17:40:00',6.7),('7643','2013-07-25','17:45:00',6.37),('7643','2013-07-25','17:50:00',5.89),('7643','2013-07-25','17:55:00',5.6),('7643','2013-07-25','18:00:00',5.24),('7643','2013-07-25','18:05:00',5.03),('7643','2013-07-25','18:10:00',4.74),('7643','2013-07-25','18:15:00',4.4),('7643','2013-07-25','18:20:00',4.05),('7643','2013-07-25','18:25:00',3.88),('7643','2013-07-25','18:30:00',3.63),('7643','2013-07-25','18:35:00',3.31),('7643','2013-07-25','18:40:00',3.03),('7643','2013-07-25','18:45:00',2.75),('7643','2013-07-25','18:50:00',2.5),('7643','2013-07-25','18:55:00',2.19),('7643','2013-07-25','19:00:00',1.89),('7643','2013-07-25','19:05:00',1.66),('7643','2013-07-25','19:10:00',1.48),('7643','2013-07-25','19:15:00',1.3),('7643','2013-07-25','19:20:00',1.11),('7643','2013-07-24','06:55:00',1.02),('7643','2013-07-24','07:00:00',1.19),('7643','2013-07-24','07:05:00',1.35),('7643','2013-07-24','07:10:00',1.57),('7643','2013-07-24','07:15:00',1.74),('7643','2013-07-24','07:20:00',1.95),('7643','2013-07-24','07:25:00',2.21),('7643','2013-07-24','07:30:00',2.43),('7643','2013-07-24','07:35:00',2.66),('7643','2013-07-24','07:40:00',2.95),('7643','2013-07-24','07:45:00',3.25),('7643','2013-07-24','07:50:00',3.55),('7643','2013-07-24','07:55:00',3.82),('7643','2013-07-24','08:00:00',4.13),('7643','2013-07-24','08:05:00',4.42),('7643','2013-07-24','08:10:00',4.7),('7643','2013-07-24','08:15:00',5.04),('7643','2013-07-24','08:20:00',5.28),('7643','2013-07-24','08:25:00',5.74),('7643','2013-07-24','08:30:00',5.9),('7643','2013-07-24','08:35:00',6.11),('7643','2013-07-24','08:40:00',6.54),('7643','2013-07-24','08:45:00',6.68),('7643','2013-07-24','08:50:00',7.35),('7643','2013-07-24','08:55:00',7.54),('7643','2013-07-24','09:00:00',7.84),('7643','2013-07-24','09:05:00',8.4),('7643','2013-07-24','09:10:00',8.51),('7643','2013-07-24','09:15:00',9.05),('7643','2013-07-24','09:20:00',9.31),('7643','2013-07-24','09:25:00',5.14),('7643','2013-07-24','09:30:00',7.23),('7643','2013-07-24','09:35:00',4.99),('7643','2013-07-24','09:40:00',10.2),('7643','2013-07-24','09:45:00',11.47),('7643','2013-07-24','09:50:00',7.38),('7643','2013-07-24','09:55:00',3.32),('7643','2013-07-24','10:00:00',3.25),('7643','2013-07-24','10:05:00',3.92),('7643','2013-07-24','10:10:00',11.22),('7643','2013-07-24','10:15:00',12.18),('7643','2013-07-24','10:20:00',12.49),('7643','2013-07-24','10:25:00',12.83),('7643','2013-07-24','10:30:00',12.08),('7643','2013-07-24','10:35:00',10.48),('7643','2013-07-24','10:40:00',10.16),('7643','2013-07-24','10:45:00',7.71),('7643','2013-07-24','10:50:00',5.73),('7643','2013-07-24','10:55:00',4.51),('7643','2013-07-24','11:00:00',7.05),('7643','2013-07-24','11:05:00',9.79),('7643','2013-07-24','11:10:00',14.68),('7643','2013-07-24','11:15:00',14.24),('7643','2013-07-24','11:20:00',14.29),('7643','2013-07-24','11:25:00',14.52),('7643','2013-07-24','11:30:00',14.76),('7643','2013-07-24','11:35:00',14.43),('7643','2013-07-24','11:40:00',9.77),('7643','2013-07-24','11:45:00',7.39),('7643','2013-07-24','11:50:00',10.69),('7643','2013-07-24','11:55:00',6.6),('7643','2013-07-24','12:00:00',12.78),('7643','2013-07-24','12:05:00',12.95),('7643','2013-07-24','12:10:00',4.5),('7643','2013-07-24','12:15:00',9.05),('7643','2013-07-24','12:20:00',9.93),('7643','2013-07-24','12:25:00',6.76),('7643','2013-07-24','12:30:00',5.49),('7643','2013-07-24','12:35:00',10.92),('7643','2013-07-24','12:40:00',5.32),('7643','2013-07-24','12:45:00',4.63),('7643','2013-07-24','12:50:00',6.95),('7643','2013-07-24','12:55:00',6.01),('7643','2013-07-24','13:00:00',4.78),('7643','2013-07-24','13:05:00',17.19),('7643','2013-07-24','13:10:00',16.69),('7643','2013-07-24','13:15:00',16.2),('7643','2013-07-24','13:20:00',16.36),('7643','2013-07-24','13:25:00',15.87),('7643','2013-07-24','13:30:00',16.08),('7643','2013-07-24','13:35:00',15.51),('7643','2013-07-24','13:40:00',15.65),('7643','2013-07-24','13:45:00',15.08),('7643','2013-07-24','13:50:00',15.38),('7643','2013-07-24','13:55:00',15.59),('7643','2013-07-24','14:00:00',15.28),('7643','2013-07-24','14:05:00',15.53),('7643','2013-07-24','14:10:00',15.68),('7643','2013-07-24','14:15:00',15.74),('7643','2013-07-24','14:20:00',15.61),('7643','2013-07-24','14:25:00',15.55),('7643','2013-07-24','14:30:00',15.33),('7643','2013-07-24','14:35:00',15.19),('7643','2013-07-24','14:40:00',15),('7643','2013-07-24','14:45:00',15),('7643','2013-07-24','14:50:00',15),('7643','2013-07-24','14:55:00',14.87),('7643','2013-07-24','15:00:00',14.74),('7643','2013-07-24','15:05:00',14.51),('7643','2013-07-24','15:10:00',14.28),('7643','2013-07-24','15:15:00',14.05),('7643','2013-07-24','15:20:00',13.9),('7643','2013-07-24','15:25:00',13.74),('7643','2013-07-24','15:30:00',13.72),('7643','2013-07-24','15:35:00',13.61),('7643','2013-07-24','15:40:00',13.35),('7643','2013-07-24','15:45:00',13.14),('7643','2013-07-24','15:50:00',12.91),('7643','2013-07-24','15:55:00',12.82),('7643','2013-07-24','16:00:00',12.67),('7643','2013-07-24','16:05:00',12.45),('7643','2013-07-24','16:10:00',12.21),('7643','2013-07-24','16:15:00',12),('7643','2013-07-24','16:20:00',11.75),('7643','2013-07-24','16:25:00',11.53),('7643','2013-07-24','16:30:00',11.22),('7643','2013-07-24','16:35:00',10.94),('7643','2013-07-24','16:40:00',10.73),('7643','2013-07-24','16:45:00',10.56),('7643','2013-07-24','16:50:00',10.31),('7643','2013-07-24','16:55:00',9.96),('7643','2013-07-24','17:00:00',9.69),('7643','2013-07-24','17:05:00',9.46),('7643','2013-07-24','17:10:00',9.09),('7643','2013-07-24','17:15:00',8.78),('7643','2013-07-24','17:20:00',8.47),('7643','2013-07-24','17:25:00',8.09),('7643','2013-07-24','17:30:00',7.91),('7643','2013-07-24','17:35:00',7.51),('7643','2013-07-24','17:40:00',7.15),('7643','2013-07-24','17:45:00',6.85),('7643','2013-07-24','17:50:00',6.43),('7643','2013-07-24','17:55:00',6.11),('7643','2013-07-24','18:00:00',5.91),('7643','2013-07-24','18:05:00',5.58),('7643','2013-07-24','18:10:00',5.25),('7643','2013-07-24','18:15:00',4.74),('7643','2013-07-24','18:20:00',4.35),('7643','2013-07-24','18:25:00',4.15),('7643','2013-07-24','18:30:00',3.89),('7643','2013-07-24','18:35:00',3.59),('7643','2013-07-24','18:40:00',3.25),('7643','2013-07-24','18:45:00',2.84),('7643','2013-07-24','18:50:00',2.63),('7643','2013-07-24','18:55:00',2.24),('7643','2013-07-24','19:00:00',1.92),('7643','2013-07-24','19:05:00',1.61),('7643','2013-07-24','19:10:00',1.44),('7643','2013-07-24','19:15:00',1.29),('7643','2013-07-24','19:20:00',1.05),('7643','2013-07-23','07:15:00',1.13),('7643','2013-07-23','07:20:00',1.52),('7643','2013-07-23','07:25:00',1.74),('7643','2013-07-23','07:30:00',1.52),('7643','2013-07-23','07:35:00',1.63),('7643','2013-07-23','07:40:00',1.87),('7643','2013-07-23','07:45:00',2.13),('7643','2013-07-23','07:50:00',2.72),('7643','2013-07-23','07:55:00',3.15),('7643','2013-07-23','08:00:00',3.47),('7643','2013-07-23','08:05:00',3.29),('7643','2013-07-23','08:10:00',3.27),('7643','2013-07-23','08:15:00',4.59),('7643','2013-07-23','08:20:00',4.5),('7643','2013-07-23','08:25:00',6.12),('7643','2013-07-23','08:30:00',5.68),('7643','2013-07-23','08:35:00',4.09),('7643','2013-07-23','08:40:00',5.42),('7643','2013-07-23','08:45:00',5.57),('7643','2013-07-23','08:50:00',7.25),('7643','2013-07-23','08:55:00',5.75),('7643','2013-07-23','09:00:00',6.41),('7643','2013-07-23','09:05:00',8.11),('7643','2013-07-23','09:10:00',8.9),('7643','2013-07-23','09:15:00',7.12),('7643','2013-07-23','09:20:00',4.36),('7643','2013-07-23','09:25:00',3.99),('7643','2013-07-23','09:30:00',6.69),('7643','2013-07-23','09:35:00',8.62),('7643','2013-07-23','09:40:00',10.34),('7643','2013-07-23','09:45:00',6.31),('7643','2013-07-23','09:50:00',5.21),('7643','2013-07-23','09:55:00',4.66),('7643','2013-07-23','10:00:00',3.93),('7643','2013-07-23','10:05:00',4.5),('7643','2013-07-23','10:10:00',3.63),('7643','2013-07-23','10:15:00',3.65),('7643','2013-07-23','10:20:00',3.85),('7643','2013-07-23','10:25:00',8.83),('7643','2013-07-23','10:30:00',12.89),('7643','2013-07-23','10:35:00',13.11),('7643','2013-07-23','10:40:00',14.24),('7643','2013-07-23','10:45:00',11.57),('7643','2013-07-23','10:50:00',6.55),('7643','2013-07-23','10:55:00',7.83),('7643','2013-07-23','11:00:00',9.86),('7643','2013-07-23','11:05:00',12.26),('7643','2013-07-23','11:10:00',13.08),('7643','2013-07-23','11:15:00',8.97),('7643','2013-07-23','11:20:00',9.85),('7643','2013-07-23','11:25:00',15.11),('7643','2013-07-23','11:30:00',14.61),('7643','2013-07-23','11:35:00',14.9),('7643','2013-07-23','11:40:00',14.75),('7643','2013-07-23','11:45:00',14.79),('7643','2013-07-23','11:50:00',14.49),('7643','2013-07-23','11:55:00',14.95),('7643','2013-07-23','12:00:00',15.32),('7643','2013-07-23','12:05:00',14.98),('7643','2013-07-23','12:10:00',6.15),('7643','2013-07-23','12:15:00',8.99),('7643','2013-07-23','12:20:00',16.31),('7643','2013-07-23','12:25:00',6.85),('7643','2013-07-23','12:30:00',4.58),('7643','2013-07-23','12:35:00',4.01),('7643','2013-07-23','12:40:00',4.17),('7643','2013-07-23','12:45:00',13.12),('7643','2013-07-23','12:50:00',6.73),('7643','2013-07-23','12:55:00',4.81),('7643','2013-07-23','13:00:00',6.19),('7643','2013-07-23','13:05:00',17.31),('7643','2013-07-23','13:10:00',16.71),('7643','2013-07-23','13:15:00',15.15),('7643','2013-07-23','13:20:00',10.08),('7643','2013-07-23','13:25:00',2.99),('7643','2013-07-23','13:30:00',3.06),('7643','2013-07-23','13:35:00',5.37),('7643','2013-07-23','13:40:00',3.92),('7643','2013-07-23','13:45:00',3.7),('7643','2013-07-23','13:50:00',6.53),('7643','2013-07-23','13:55:00',15.13),('7643','2013-07-23','14:00:00',10.95),('7643','2013-07-23','14:05:00',15.89),('7643','2013-07-23','14:10:00',9.99),('7643','2013-07-23','14:15:00',16.64),('7643','2013-07-23','14:20:00',15.87),('7643','2013-07-23','14:25:00',12),('7643','2013-07-23','14:30:00',11.83),('7643','2013-07-23','14:35:00',9),('7643','2013-07-23','14:40:00',14.52),('7643','2013-07-23','14:45:00',16.08),('7643','2013-07-23','14:50:00',15.74),('7643','2013-07-23','14:55:00',15.5),('7643','2013-07-23','15:00:00',15.18),('7643','2013-07-23','15:05:00',14.96),('7643','2013-07-23','15:10:00',14.77),('7643','2013-07-23','15:15:00',14.67),('7643','2013-07-23','15:20:00',14.39),('7643','2013-07-23','15:25:00',14.24),('7643','2013-07-23','15:30:00',13.49),('7643','2013-07-23','15:35:00',13.12),('7643','2013-07-23','15:40:00',13.68),('7643','2013-07-23','15:45:00',13.26),('7643','2013-07-23','15:50:00',13.03),('7643','2013-07-23','15:55:00',12.94),('7643','2013-07-23','16:00:00',12.79),('7643','2013-07-23','16:05:00',12.38),('7643','2013-07-23','16:10:00',12.24),('7643','2013-07-23','16:15:00',12.19),('7643','2013-07-23','16:20:00',12.32),('7643','2013-07-23','16:25:00',12.04),('7643','2013-07-23','16:30:00',11.67),('7643','2013-07-23','16:35:00',11.46),('7643','2013-07-23','16:40:00',11.25),('7643','2013-07-23','16:45:00',10.85),('7643','2013-07-23','16:50:00',10.49),('7643','2013-07-23','16:55:00',10.74),('7643','2013-07-23','17:00:00',10.48),('7643','2013-07-23','17:05:00',10.09),('7643','2013-07-23','17:10:00',7.78),('7643','2013-07-23','17:15:00',8.44),('7643','2013-07-23','17:20:00',8.77),('7643','2013-07-23','17:25:00',8.28),('7643','2013-07-23','17:30:00',8),('7643','2013-07-23','17:35:00',7.63),('7643','2013-07-23','17:40:00',7.15),('7643','2013-07-23','17:45:00',6.78),('7643','2013-07-23','17:50:00',6.38),('7643','2013-07-23','17:55:00',6.01),('7643','2013-07-23','18:00:00',5.73),('7643','2013-07-23','18:05:00',5.35),('7643','2013-07-23','18:10:00',5.08),('7643','2013-07-23','18:15:00',4.68),('7643','2013-07-23','18:20:00',4.09),('7643','2013-07-23','18:25:00',4.11),('7643','2013-07-23','18:30:00',3.89),('7643','2013-07-23','18:35:00',3.7),('7643','2013-07-23','18:40:00',3.4),('7643','2013-07-23','18:45:00',3.06),('7643','2013-07-23','18:50:00',2.64),('7643','2013-07-23','18:55:00',2.25),('7643','2013-07-23','19:00:00',1.86),('7643','2013-07-23','19:05:00',1.81),('7643','2013-07-23','19:10:00',1.52),('7643','2013-07-23','19:15:00',1.22),('7643','2013-07-23','19:20:00',1.19),('7643','2013-07-23','19:25:00',1.04),('7643','2013-07-22','06:55:00',1.07),('7643','2013-07-22','07:00:00',1.23),('7643','2013-07-22','07:05:00',1.44),('7643','2013-07-22','07:10:00',1.69),('7643','2013-07-22','07:15:00',1.93),('7643','2013-07-22','07:20:00',2.22),('7643','2013-07-22','07:25:00',2.5),('7643','2013-07-22','07:30:00',2.75),('7643','2013-07-22','07:35:00',3.06),('7643','2013-07-22','07:40:00',3.3),('7643','2013-07-22','07:45:00',3.56),('7643','2013-07-22','07:50:00',3.83),('7643','2013-07-22','07:55:00',4.22),('7643','2013-07-22','08:00:00',4.66),('7643','2013-07-22','08:05:00',5.01),('7643','2013-07-22','08:10:00',5.34),('7643','2013-07-22','08:15:00',5.64),('7643','2013-07-22','08:20:00',5.92),('7643','2013-07-22','08:25:00',6.2),('7643','2013-07-22','08:30:00',6.51),('7643','2013-07-22','08:35:00',6.86),('7643','2013-07-22','08:40:00',7.24),('7643','2013-07-22','08:45:00',7.57),('7643','2013-07-22','08:50:00',7.85),('7643','2013-07-22','08:55:00',8.19),('7643','2013-07-22','09:00:00',8.49),('7643','2013-07-22','09:05:00',8.78),('7643','2013-07-22','09:10:00',9.02),('7643','2013-07-22','09:15:00',9.22),('7643','2013-07-22','09:20:00',9.4),('7643','2013-07-22','09:25:00',9.6),('7643','2013-07-22','09:30:00',9.83),('7643','2013-07-22','09:35:00',10.09),('7643','2013-07-22','09:40:00',10.31),('7643','2013-07-22','09:45:00',10.53),('7643','2013-07-22','09:50:00',10.68),('7643','2013-07-22','09:55:00',10.7),('7643','2013-07-22','10:00:00',11.09),('7643','2013-07-22','10:05:00',11.27),('7643','2013-07-22','10:10:00',11.44),('7643','2013-07-22','10:15:00',11.72),('7643','2013-07-22','10:20:00',11.95),('7643','2013-07-22','10:25:00',12.41),('7643','2013-07-22','10:30:00',12.61),('7643','2013-07-22','10:35:00',12.78),('7643','2013-07-22','10:40:00',12.93),('7643','2013-07-22','10:45:00',12.95),('7643','2013-07-22','10:50:00',13.17),('7643','2013-07-22','10:55:00',13.36),('7643','2013-07-22','11:00:00',13.48),('7643','2013-07-22','11:05:00',13.51),('7643','2013-07-22','11:10:00',13.7),('7643','2013-07-22','11:15:00',13.92),('7643','2013-07-22','11:20:00',14.04),('7643','2013-07-22','11:25:00',14.07),('7643','2013-07-22','11:30:00',14.24),('7643','2013-07-22','11:35:00',14.39),('7643','2013-07-22','11:40:00',14.45),('7643','2013-07-22','11:45:00',14.42),('7643','2013-07-22','11:50:00',14.49),('7643','2013-07-22','11:55:00',14.71),('7643','2013-07-22','12:00:00',14.74),('7643','2013-07-22','12:05:00',14.93),('7643','2013-07-22','12:10:00',15.08),('7643','2013-07-22','12:15:00',15.06),('7643','2013-07-22','12:20:00',15.11),('7643','2013-07-22','12:25:00',15.19),('7643','2013-07-22','12:30:00',15.16),('7643','2013-07-22','12:35:00',15.12),('7643','2013-07-22','12:40:00',14.93),('7643','2013-07-22','12:45:00',12.25),('7643','2013-07-22','12:50:00',10.49),('7643','2013-07-22','12:55:00',9.73),('7643','2013-07-22','13:00:00',16.51),('7643','2013-07-22','13:05:00',4.93),('7643','2013-07-22','13:10:00',7.17),('7643','2013-07-22','13:15:00',6.13),('7643','2013-07-22','13:20:00',3.59),('7643','2013-07-22','13:25:00',3.39),('7643','2013-07-22','13:30:00',12.62),('7643','2013-07-22','13:35:00',16.97),('7643','2013-07-22','13:40:00',12.64),('7643','2013-07-22','13:45:00',5.24),('7643','2013-07-22','13:50:00',14.63),('7643','2013-07-22','13:55:00',14.13),('7643','2013-07-22','14:00:00',16.61),('7643','2013-07-22','14:05:00',11.79),('7643','2013-07-22','14:10:00',2.1),('7643','2013-07-22','14:15:00',1.19),('7643','2013-07-22','14:20:00',1.29),('7643','2013-07-22','14:25:00',2.44),('7643','2013-07-22','14:30:00',1.84),('7643','2013-07-22','14:35:00',2.54),('7643','2013-07-22','14:40:00',4.42),('7643','2013-07-22','14:45:00',10.04),('7643','2013-07-22','14:50:00',9.47),('7643','2013-07-22','14:55:00',11.82),('7643','2013-07-22','15:00:00',17.18),('7643','2013-07-22','15:05:00',16.22),('7643','2013-07-22','15:10:00',11.55),('7643','2013-07-22','15:15:00',14.62),('7643','2013-07-22','15:20:00',14.1),('7643','2013-07-22','15:25:00',13.86),('7643','2013-07-22','15:30:00',13.42),('7643','2013-07-22','15:35:00',13.19),('7643','2013-07-22','15:40:00',13.19),('7643','2013-07-22','15:45:00',12.92),('7643','2013-07-22','15:50:00',12.97),('7643','2013-07-22','15:55:00',12.81),('7643','2013-07-22','16:00:00',12.48),('7643','2013-07-22','16:05:00',12.13),('7643','2013-07-22','16:10:00',12.06),('7643','2013-07-22','16:15:00',11.65),('7643','2013-07-22','16:20:00',11.54),('7643','2013-07-22','16:25:00',11.33),('7643','2013-07-22','16:30:00',11.13),('7643','2013-07-22','16:35:00',10.76),('7643','2013-07-22','16:40:00',10.57),('7643','2013-07-22','16:45:00',10.27),('7643','2013-07-22','16:50:00',10.05),('7643','2013-07-22','16:55:00',9.73),('7643','2013-07-22','17:00:00',9.44),('7643','2013-07-22','17:05:00',9.19),('7643','2013-07-22','17:10:00',8.97),('7643','2013-07-22','17:15:00',8.61),('7643','2013-07-22','17:20:00',8.38),('7643','2013-07-22','17:25:00',8.2),('7643','2013-07-22','17:30:00',7.91),('7643','2013-07-22','17:35:00',7.61),('7643','2013-07-22','17:40:00',7.26),('7643','2013-07-22','17:45:00',6.94),('7643','2013-07-22','17:50:00',6.6),('7643','2013-07-22','17:55:00',6.37),('7643','2013-07-22','18:00:00',6.12),('7643','2013-07-22','18:05:00',5.77),('7643','2013-07-22','18:10:00',5.41),('7643','2013-07-22','18:15:00',5.05),('7643','2013-07-22','18:20:00',4.68),('7643','2013-07-22','18:25:00',4.44),('7643','2013-07-22','18:30:00',4.15),('7643','2013-07-22','18:35:00',3.76),('7643','2013-07-22','18:40:00',2.89),('7643','2013-07-22','18:45:00',2.42),('7643','2013-07-22','18:50:00',2.01),('7643','2013-07-22','18:55:00',2.21),('7643','2013-07-22','19:00:00',2),('7643','2013-07-22','19:05:00',1.74),('7643','2013-07-22','19:10:00',1.61),('7643','2013-07-22','19:15:00',1.4),('7643','2013-07-22','19:20:00',1.18),('7643','2013-07-22','19:25:00',1.02),('7643','2013-07-21','06:55:00',1.09),('7643','2013-07-21','07:00:00',1.27),('7643','2013-07-21','07:05:00',1.46),('7643','2013-07-21','07:10:00',1.7),('7643','2013-07-21','07:15:00',1.94),('7643','2013-07-21','07:20:00',2.16),('7643','2013-07-21','07:25:00',2.42),('7643','2013-07-21','07:30:00',2.69),('7643','2013-07-21','07:35:00',2.99),('7643','2013-07-21','07:40:00',3.24),('7643','2013-07-21','07:45:00',3.53),('7643','2013-07-21','07:50:00',3.82),('7643','2013-07-21','07:55:00',4.16),('7643','2013-07-21','08:00:00',4.47),('7643','2013-07-21','08:05:00',4.81),('7643','2013-07-21','08:10:00',5.14),('7643','2013-07-21','08:15:00',5.44),('7643','2013-07-21','08:20:00',5.76),('7643','2013-07-21','08:25:00',6.11),('7643','2013-07-21','08:30:00',6.42),('7643','2013-07-21','08:35:00',6.76),('7643','2013-07-21','08:40:00',7.11),('7643','2013-07-21','08:45:00',7.44),('7643','2013-07-21','08:50:00',7.76),('7643','2013-07-21','08:55:00',8.03),('7643','2013-07-21','09:00:00',8.35),('7643','2013-07-21','09:05:00',8.67),('7643','2013-07-21','09:10:00',8.94),('7643','2013-07-21','09:15:00',9.2),('7643','2013-07-21','09:20:00',9.43),('7643','2013-07-21','09:25:00',9.74),('7643','2013-07-21','09:30:00',9.98),('7643','2013-07-21','09:35:00',10.18),('7643','2013-07-21','09:40:00',10.43),('7643','2013-07-21','09:45:00',10.71),('7643','2013-07-21','09:50:00',11.02),('7643','2013-07-21','09:55:00',11.21),('7643','2013-07-21','10:00:00',11.51),('7643','2013-07-21','10:05:00',11.7),('7643','2013-07-21','10:10:00',11.84),('7643','2013-07-21','10:15:00',12.07),('7643','2013-07-21','10:20:00',12.23),('7643','2013-07-21','10:25:00',12.45),('7643','2013-07-21','10:30:00',12.54),('7643','2013-07-21','10:35:00',12.78),('7643','2013-07-21','10:40:00',12.92),('7643','2013-07-21','10:45:00',12.96),('7643','2013-07-21','10:50:00',13.1),('7643','2013-07-21','10:55:00',13.25),('7643','2013-07-21','11:00:00',13.48),('7643','2013-07-21','11:05:00',13.67),('7643','2013-07-21','11:10:00',13.87),('7643','2013-07-21','11:15:00',13.88),('7643','2013-07-21','11:20:00',13.82),('7643','2013-07-21','11:25:00',13.92),('7643','2013-07-21','11:30:00',14.12),('7643','2013-07-21','11:35:00',14.22),('7643','2013-07-21','11:40:00',14.44),('7643','2013-07-21','11:45:00',14.47),('7643','2013-07-21','11:50:00',14.65),('7643','2013-07-21','11:55:00',14.68),('7643','2013-07-21','12:00:00',14.72),('7643','2013-07-21','12:05:00',14.79),('7643','2013-07-21','12:10:00',14.89),('7643','2013-07-21','12:15:00',15),('7643','2013-07-21','12:20:00',15.01),('7643','2013-07-21','12:25:00',14.95),('7643','2013-07-21','12:30:00',15.08),('7643','2013-07-21','12:35:00',15.2),('7643','2013-07-21','12:40:00',15.14),('7643','2013-07-21','12:45:00',15.12),('7643','2013-07-21','12:50:00',15.15),('7643','2013-07-21','12:55:00',15.21),('7643','2013-07-21','13:00:00',15.32),('7643','2013-07-21','13:05:00',15.52),('7643','2013-07-21','13:10:00',15.51),('7643','2013-07-21','13:15:00',15.29),('7643','2013-07-21','13:20:00',15.15),('7643','2013-07-21','13:25:00',15.19),('7643','2013-07-21','13:30:00',15.09),('7643','2013-07-21','13:35:00',14.97),('7643','2013-07-21','13:40:00',15.29),('7643','2013-07-21','13:45:00',15.27),('7643','2013-07-21','13:50:00',15.23),('7643','2013-07-21','13:55:00',15.14),('7643','2013-07-21','14:00:00',14.88),('7643','2013-07-21','14:05:00',15.12),('7643','2013-07-21','14:10:00',14.95),('7643','2013-07-21','14:15:00',14.82),('7643','2013-07-21','14:20:00',14.84),('7643','2013-07-21','14:25:00',14.63),('7643','2013-07-21','14:30:00',14.66),('7643','2013-07-21','14:35:00',14.73),('7643','2013-07-21','14:40:00',14.73),('7643','2013-07-21','14:45:00',14.57),('7643','2013-07-21','14:50:00',14.29),('7643','2013-07-21','14:55:00',14.14),('7643','2013-07-21','15:00:00',12.13),('7643','2013-07-21','15:05:00',14.17),('7643','2013-07-21','15:10:00',13.94),('7643','2013-07-21','15:15:00',13.75),('7643','2013-07-21','15:20:00',13.45),('7643','2013-07-21','15:25:00',13.53),('7643','2013-07-21','15:30:00',8.1),('7643','2013-07-21','15:35:00',3.5),('7643','2013-07-21','15:40:00',6.93),('7643','2013-07-21','15:45:00',12.88),('7643','2013-07-21','15:50:00',13.81),('7643','2013-07-21','15:55:00',14.08),('7643','2013-07-21','16:00:00',12.61),('7643','2013-07-21','16:05:00',12.17),('7643','2013-07-21','16:10:00',5.68),('7643','2013-07-21','16:15:00',6.68),('7643','2013-07-21','16:20:00',10.97),('7643','2013-07-21','16:25:00',12.71),('7643','2013-07-21','16:30:00',11.81),('7643','2013-07-21','16:35:00',11.13),('7643','2013-07-21','16:40:00',10.46),('7643','2013-07-21','16:45:00',10.24),('7643','2013-07-21','16:50:00',9.92),('7643','2013-07-21','16:55:00',9.89),('7643','2013-07-21','17:00:00',9.5),('7643','2013-07-21','17:05:00',9.25),('7643','2013-07-21','17:10:00',8.95),('7643','2013-07-21','17:15:00',8.68),('7643','2013-07-21','17:20:00',8.29),('7643','2013-07-21','17:25:00',7.6),('7643','2013-07-21','17:30:00',7.51),('7643','2013-07-21','17:35:00',7.48),('7643','2013-07-21','17:40:00',6.83),('7643','2013-07-21','17:45:00',6.01),('7643','2013-07-21','17:50:00',6.06),('7643','2013-07-21','17:55:00',5.91),('7643','2013-07-21','18:00:00',5.84),('7643','2013-07-21','18:05:00',5.46),('7643','2013-07-21','18:10:00',4.95),('7643','2013-07-21','18:15:00',4.53),('7643','2013-07-21','18:20:00',4.27),('7643','2013-07-21','18:25:00',4.06),('7643','2013-07-21','18:30:00',3.82),('7643','2013-07-21','18:35:00',3.52),('7643','2013-07-21','18:40:00',3.16),('7643','2013-07-21','18:45:00',2.94),('7643','2013-07-21','18:50:00',2.63),('7643','2013-07-21','18:55:00',2.29),('7643','2013-07-21','19:00:00',1.79),('7643','2013-07-21','19:05:00',1.88),('7643','2013-07-21','19:10:00',1.78),('7643','2013-07-21','19:15:00',1.5),('7643','2013-07-21','19:20:00',1.23),('7643','2013-07-21','19:25:00',1.15),('7643','2013-07-21','19:30:00',1),('7643','2013-07-20','06:55:00',1.07),('7643','2013-07-20','07:00:00',1.25),('7643','2013-07-20','07:05:00',1.43),('7643','2013-07-20','07:10:00',1.64),('7643','2013-07-20','07:15:00',1.9),('7643','2013-07-20','07:20:00',2.1),('7643','2013-07-20','07:25:00',2.33),('7643','2013-07-20','07:30:00',2.59),('7643','2013-07-20','07:35:00',2.9),('7643','2013-07-20','07:40:00',3.19),('7643','2013-07-20','07:45:00',3.56),('7643','2013-07-20','07:50:00',3.76),('7643','2013-07-20','07:55:00',3.9),('7643','2013-07-20','08:00:00',4.2),('7643','2013-07-20','08:05:00',4.47),('7643','2013-07-20','08:10:00',4.91),('7643','2013-07-20','08:15:00',5.21),('7643','2013-07-20','08:20:00',5.4),('7643','2013-07-20','08:25:00',5.78),('7643','2013-07-20','08:30:00',6.16),('7643','2013-07-20','08:35:00',6.45),('7643','2013-07-20','08:40:00',6.74),('7643','2013-07-20','08:45:00',6.98),('7643','2013-07-20','08:50:00',7.33),('7643','2013-07-20','08:55:00',7.65),('7643','2013-07-20','09:00:00',8.04),('7643','2013-07-20','09:05:00',8.28),('7643','2013-07-20','09:10:00',8.59),('7643','2013-07-20','09:15:00',8.89),('7643','2013-07-20','09:20:00',9.14),('7643','2013-07-20','09:25:00',9.42),('7643','2013-07-20','09:30:00',9.72),('7643','2013-07-20','09:35:00',9.89),('7643','2013-07-20','09:40:00',10.15),('7643','2013-07-20','09:45:00',10.35),('7643','2013-07-20','09:50:00',10.52),('7643','2013-07-20','09:55:00',10.78),('7643','2013-07-20','10:00:00',11.09),('7643','2013-07-20','10:05:00',11.32),('7643','2013-07-20','10:10:00',11.47),('7643','2013-07-20','10:15:00',11.7),('7643','2013-07-20','10:20:00',11.88),('7643','2013-07-20','10:25:00',11.95),('7643','2013-07-20','10:30:00',12.1),('7643','2013-07-20','10:35:00',12.32),('7643','2013-07-20','10:40:00',12.58),('7643','2013-07-20','10:45:00',12.75),('7643','2013-07-20','10:50:00',12.86),('7643','2013-07-20','10:55:00',12.91),('7643','2013-07-20','11:00:00',13.17),('7643','2013-07-20','11:05:00',13.4),('7643','2013-07-20','11:10:00',13.48),('7643','2013-07-20','11:15:00',13.59),('7643','2013-07-20','11:20:00',13.75),('7643','2013-07-20','11:25:00',13.91),('7643','2013-07-20','11:30:00',14.1),('7643','2013-07-20','11:35:00',14.3),('7643','2013-07-20','11:40:00',14.81),('7643','2013-07-20','11:45:00',14.93),('7643','2013-07-20','11:50:00',14.67),('7643','2013-07-20','11:55:00',14.64),('7643','2013-07-20','12:00:00',14.72),('7643','2013-07-20','12:05:00',15.01),('7643','2013-07-20','12:10:00',15.09),('7643','2013-07-20','12:15:00',15.66),('7643','2013-07-20','12:20:00',16.24),('7643','2013-07-20','12:25:00',16.33),('7643','2013-07-20','12:30:00',16.45),('7643','2013-07-20','12:35:00',17),('7643','2013-07-20','12:40:00',17.17),('7643','2013-07-20','12:45:00',16.14),('7643','2013-07-20','12:50:00',14.29),('7643','2013-07-20','12:55:00',17.85),('7643','2013-07-20','13:00:00',15.86),('7643','2013-07-20','13:05:00',17.68),('7643','2013-07-20','13:10:00',16.21),('7643','2013-07-20','13:15:00',12.62),('7643','2013-07-20','13:20:00',16.14),('7643','2013-07-20','13:25:00',17.06),('7643','2013-07-20','13:30:00',16.27),('7643','2013-07-20','13:35:00',15.41),('7643','2013-07-20','13:40:00',12.55),('7643','2013-07-20','13:45:00',4.17),('7643','2013-07-20','13:50:00',3.53),('7643','2013-07-20','13:55:00',2.87),('7643','2013-07-20','14:00:00',2.83),('7643','2013-07-20','14:05:00',3.01),('7643','2013-07-20','14:10:00',2.75),('7643','2013-07-20','14:15:00',2.79),('7643','2013-07-20','14:20:00',3.74),('7643','2013-07-20','14:25:00',4.31),('7643','2013-07-20','14:30:00',4.14),('7643','2013-07-20','14:35:00',4.74),('7643','2013-07-20','14:40:00',4.79),('7643','2013-07-20','14:45:00',7.18),('7643','2013-07-20','14:50:00',14.37),('7643','2013-07-20','14:55:00',7.05),('7643','2013-07-20','15:00:00',7.7),('7643','2013-07-20','15:05:00',6.31),('7643','2013-07-20','15:10:00',5.87),('7643','2013-07-20','15:15:00',15.37),('7643','2013-07-20','15:20:00',16.19),('7643','2013-07-20','15:25:00',6.7),('7643','2013-07-20','15:30:00',5.27),('7643','2013-07-20','15:35:00',5.85),('7643','2013-07-20','15:40:00',9.97),('7643','2013-07-20','15:45:00',10.04),('7643','2013-07-20','15:50:00',12.33),('7643','2013-07-20','15:55:00',8.74),('7643','2013-07-20','16:00:00',5.23),('7643','2013-07-20','16:05:00',3.96),('7643','2013-07-20','16:10:00',3.35),('7643','2013-07-20','16:15:00',2.92),('7643','2013-07-20','16:20:00',2.71),('7643','2013-07-20','16:25:00',2.82),('7643','2013-07-20','16:30:00',2.95),('7643','2013-07-20','16:35:00',3.13),('7643','2013-07-20','16:40:00',3.23),('7643','2013-07-20','16:45:00',3.21),('7643','2013-07-20','16:50:00',3.32),('7643','2013-07-20','16:55:00',3.72),('7643','2013-07-20','17:00:00',4.2),('7643','2013-07-20','17:05:00',4.63),('7643','2013-07-20','17:10:00',4.68),('7643','2013-07-20','17:15:00',3.96),('7643','2013-07-20','17:20:00',3.59),('7643','2013-07-20','17:25:00',3.29),('7643','2013-07-20','17:30:00',3.07),('7643','2013-07-20','17:35:00',2.92),('7643','2013-07-20','17:40:00',2.89),('7643','2013-07-20','17:45:00',2.85),('7643','2013-07-20','17:50:00',2.92),('7643','2013-07-20','17:55:00',3.01),('7643','2013-07-20','18:00:00',3.01),('7643','2013-07-20','18:05:00',2.84),('7643','2013-07-20','18:10:00',2.44),('7643','2013-07-20','18:15:00',2.1),('7643','2013-07-20','18:20:00',1.85),('7643','2013-07-20','18:25:00',1.65),('7643','2013-07-20','18:30:00',1.5),('7643','2013-07-20','18:35:00',1.33),('7643','2013-07-20','18:40:00',1.2),('7643','2013-07-20','18:45:00',1.18),('7643','2013-07-20','18:50:00',1.24),('7643','2013-07-20','18:55:00',1.38),('7643','2013-07-20','19:00:00',1.46),('7643','2013-07-20','19:05:00',1.52),('7643','2013-07-20','19:10:00',1.42),('7643','2013-07-20','19:15:00',1.18),('7643','2014-04-06','07:20:00',1.15),('7643','2014-04-06','07:25:00',1.37),('7643','2014-04-06','07:30:00',1.64),('7643','2014-04-06','07:35:00',1.9),('7643','2014-04-06','07:40:00',2.07),('7643','2014-04-06','07:45:00',2.09),('7643','2014-04-06','07:50:00',1.86),('7643','2014-04-06','07:55:00',1.69),('7643','2014-04-06','08:00:00',1.83),('7643','2014-04-06','08:05:00',2.06),('7643','2014-04-06','08:10:00',2.68),('7643','2014-04-06','08:15:00',3.19),('7643','2014-04-06','08:20:00',3.99),('7643','2014-04-06','08:25:00',3.96),('7643','2014-04-06','08:30:00',4.35),('7643','2014-04-06','08:35:00',6.07),('7643','2014-04-06','08:40:00',6.76),('7643','2014-04-06','08:45:00',6.99),('7643','2014-04-06','08:50:00',5.76),('7643','2014-04-06','08:55:00',4.91),('7643','2014-04-06','09:00:00',4.6),('7643','2014-04-06','09:05:00',4.78),('7643','2014-04-06','09:10:00',5.35),('7643','2014-04-06','09:15:00',6.09),('7643','2014-04-06','09:20:00',5.44),('7643','2014-04-06','09:25:00',5.03),('7643','2014-04-06','09:30:00',4.94),('7643','2014-04-06','09:35:00',4.41),('7643','2014-04-06','09:40:00',4.52),('7643','2014-04-06','09:45:00',4.74),('7643','2014-04-06','09:50:00',4.98),('7643','2014-04-06','09:55:00',5.68),('7643','2014-04-06','10:00:00',5.37),('7643','2014-04-06','10:05:00',5.25),('7643','2014-04-06','10:10:00',5.7),('7643','2014-04-06','10:15:00',5.11),('7643','2014-04-06','10:20:00',5.02),('7643','2014-04-06','10:25:00',5.17),('7643','2014-04-06','10:30:00',5.32),('7643','2014-04-06','10:35:00',5.69),('7643','2014-04-06','10:40:00',5.89),('7643','2014-04-06','10:45:00',6.08),('7643','2014-04-06','10:50:00',6.21),('7643','2014-04-06','10:55:00',6.59),('7643','2014-04-06','11:00:00',7.02),('7643','2014-04-06','11:05:00',7.38),('7643','2014-04-06','11:10:00',8.49),('7643','2014-04-06','11:15:00',9.5),('7643','2014-04-06','11:20:00',8.57),('7643','2014-04-06','11:25:00',7.97),('7643','2014-04-06','11:30:00',8.2),('7643','2014-04-06','11:35:00',7.89),('7643','2014-04-06','11:40:00',7.62),('7643','2014-04-06','11:45:00',7.19),('7643','2014-04-06','11:50:00',6.94),('7643','2014-04-06','11:55:00',6.86),('7643','2014-04-06','12:00:00',7.39),('7643','2014-04-06','12:05:00',9.32),('7643','2014-04-06','12:10:00',10.52),('7643','2014-04-06','12:15:00',13.8),('7643','2014-04-06','12:20:00',16.85),('7643','2014-04-06','12:25:00',16.48),('7643','2014-04-06','12:30:00',10.22),('7643','2014-04-06','12:35:00',9.37),('7643','2014-04-06','12:40:00',10.87),('7643','2014-04-06','12:45:00',15.59),('7643','2014-04-06','12:50:00',15.9),('7643','2014-04-06','12:55:00',15.68),('7643','2014-04-06','13:00:00',15.73),('7643','2014-04-06','13:05:00',15.71),('7643','2014-04-06','13:10:00',15.51),('7643','2014-04-06','13:15:00',15.45),('7643','2014-04-06','13:20:00',15.51),('7643','2014-04-06','13:25:00',15.43),('7643','2014-04-06','13:30:00',15.36),('7643','2014-04-06','13:35:00',15.29),('7643','2014-04-06','13:40:00',15.29),('7643','2014-04-06','13:45:00',15.37),('7643','2014-04-06','13:50:00',15.43),('7643','2014-04-06','13:55:00',15.27),('7643','2014-04-06','14:00:00',15.3),('7643','2014-04-06','14:05:00',15.26),('7643','2014-04-06','14:10:00',14.99),('7643','2014-04-06','14:15:00',14.94),('7643','2014-04-06','14:20:00',14.85),('7643','2014-04-06','14:25:00',15.32),('7643','2014-04-06','14:30:00',15.34),('7643','2014-04-06','14:35:00',14.89),('7643','2014-04-06','14:40:00',14.73),('7643','2014-04-06','14:45:00',14.46),('7643','2014-04-06','14:50:00',13.64),('7643','2014-04-06','14:55:00',12.81),('7643','2014-04-06','15:00:00',12.73),('7643','2014-04-06','15:05:00',14.46),('7643','2014-04-06','15:10:00',14.32),('7643','2014-04-06','15:15:00',12.05),('7643','2014-04-06','15:20:00',14.09),('7643','2014-04-06','15:25:00',14.21),('7643','2014-04-06','15:30:00',13.7),('7643','2014-04-06','15:35:00',13.92),('7643','2014-04-06','15:40:00',13.52),('7643','2014-04-06','15:45:00',13.68),('7643','2014-04-06','15:50:00',14.39),('7643','2014-04-06','15:55:00',13.79),('7643','2014-04-06','16:00:00',9.11),('7643','2014-04-06','16:05:00',5.71),('7643','2014-04-06','16:10:00',12.16),('7643','2014-04-06','16:15:00',11.31),('7643','2014-04-06','16:20:00',10.51),('7643','2014-04-06','16:25:00',10.22),('7643','2014-04-06','16:30:00',9.87),('7643','2014-04-06','16:35:00',7.98),('7643','2014-04-06','16:40:00',4.81),('7643','2014-04-06','16:45:00',7.88),('7643','2014-04-06','16:50:00',7.49),('7643','2014-04-06','16:55:00',9.66),('7643','2014-04-06','17:00:00',9.78),('7643','2014-04-06','17:05:00',8.9),('7643','2014-04-06','17:10:00',5.62),('7643','2014-04-06','17:15:00',6.87),('7643','2014-04-06','17:20:00',3.5),('7643','2014-04-06','17:25:00',2.9),('7643','2014-04-06','17:30:00',2.56),('7643','2014-04-06','17:35:00',2.1),('7643','2014-04-06','17:40:00',1.59),('7643','2014-04-06','17:45:00',1.67),('7643','2014-04-06','17:50:00',2.03),('7643','2014-04-06','17:55:00',4.13),('7643','2014-04-06','18:00:00',3.84),('7643','2014-04-06','18:05:00',3.49),('7643','2014-04-06','18:10:00',3.43),('7643','2014-04-06','18:15:00',3.23),('7643','2014-04-06','18:20:00',2.72),('7643','2014-04-06','18:25:00',2.32),('7643','2014-04-06','18:30:00',2.12),('7643','2014-04-06','18:35:00',1.73),('7643','2014-04-06','18:40:00',1.48),('7643','2014-04-06','18:45:00',1.24),('7643','2014-04-06','18:50:00',1.02),('7643','2013-07-19','06:50:00',1.02),('7643','2013-07-19','06:55:00',1.17),('7643','2013-07-19','07:00:00',1.22),('7643','2013-07-19','07:05:00',1.38),('7643','2013-07-19','07:10:00',1.45),('7643','2013-07-19','07:15:00',1.78),('7643','2013-07-19','07:20:00',1.98),('7643','2013-07-19','07:25:00',2.32),('7643','2013-07-19','07:30:00',2.75),('7643','2013-07-19','07:35:00',3.09),('7643','2013-07-19','07:40:00',3.33),('7643','2013-07-19','07:45:00',3.63),('7643','2013-07-19','07:50:00',3.9),('7643','2013-07-19','07:55:00',4.23),('7643','2013-07-19','08:00:00',4.48),('7643','2013-07-19','08:05:00',4.84),('7643','2013-07-19','08:10:00',5.18),('7643','2013-07-19','08:15:00',5.43),('7643','2013-07-19','08:20:00',5.76),('7643','2013-07-19','08:25:00',6.12),('7643','2013-07-19','08:30:00',6.44),('7643','2013-07-19','08:35:00',6.81),('7643','2013-07-19','08:40:00',7.15),('7643','2013-07-19','08:45:00',7.54),('7643','2013-07-19','08:50:00',7.82),('7643','2013-07-19','08:55:00',8.18),('7643','2013-07-19','09:00:00',8.52),('7643','2013-07-19','09:05:00',8.82),('7643','2013-07-19','09:10:00',9.31),('7643','2013-07-19','09:15:00',9.7),('7643','2013-07-19','09:20:00',9.87),('7643','2013-07-19','09:25:00',9.74),('7643','2013-07-19','09:30:00',9.7),('7643','2013-07-19','09:35:00',9.85),('7643','2013-07-19','09:40:00',9.8),('7643','2013-07-19','09:45:00',10.79),('7643','2013-07-19','09:50:00',10.53),('7643','2013-07-19','09:55:00',10.46),('7643','2013-07-19','10:00:00',11.33),('7643','2013-07-19','10:05:00',11.55),('7643','2013-07-19','10:10:00',11.65),('7643','2013-07-19','10:15:00',11.76),('7643','2013-07-19','10:20:00',12.09),('7643','2013-07-19','10:25:00',12.33),('7643','2013-07-19','10:30:00',12.54),('7643','2013-07-19','10:35:00',12.71),('7643','2013-07-19','10:40:00',12.81),('7643','2013-07-19','10:45:00',12.98),('7643','2013-07-19','10:50:00',13.17),('7643','2013-07-19','10:55:00',13.3),('7643','2013-07-19','11:00:00',13.57),('7643','2013-07-19','11:05:00',13.72),('7643','2013-07-19','11:10:00',13.79),('7643','2013-07-19','11:15:00',13.74),('7643','2013-07-19','11:20:00',13.92),('7643','2013-07-19','11:25:00',14.09),('7643','2013-07-19','11:30:00',13.97),('7643','2013-07-19','11:35:00',14.19),('7643','2013-07-19','11:40:00',14.56),('7643','2013-07-19','11:45:00',14.67),('7643','2013-07-19','11:50:00',14.76),('7643','2013-07-19','11:55:00',14.99),('7643','2013-07-19','12:00:00',14.93),('7643','2013-07-19','12:05:00',15.18),('7643','2013-07-19','12:10:00',15.33),('7643','2013-07-19','12:15:00',15.49),('7643','2013-07-19','12:20:00',15),('7643','2013-07-19','12:25:00',12.68),('7643','2013-07-19','12:30:00',11.78),('7643','2013-07-19','12:35:00',15.54),('7643','2013-07-19','12:40:00',15.34),('7643','2013-07-19','12:45:00',15.48),('7643','2013-07-19','12:50:00',15.68),('7643','2013-07-19','12:55:00',15.98),('7643','2013-07-19','13:00:00',16.06),('7643','2013-07-19','13:05:00',16.23),('7643','2013-07-19','13:10:00',16.13),('7643','2013-07-19','13:15:00',14.09),('7643','2013-07-19','13:20:00',3.8),('7643','2013-07-19','13:25:00',5.11),('7643','2013-07-19','13:30:00',10.7),('7643','2013-07-19','13:35:00',16.99),('7643','2013-07-19','13:40:00',16.85),('7643','2013-07-19','13:45:00',16.58),('7643','2013-07-19','13:50:00',12.5),('7643','2013-07-19','13:55:00',4.11),('7643','2013-07-19','14:00:00',5.14),('7643','2013-07-19','14:05:00',17.13),('7643','2013-07-19','14:10:00',16.13),('7643','2013-07-19','14:15:00',11.32),('7643','2013-07-19','14:20:00',16.19),('7643','2013-07-19','14:25:00',15.72),('7643','2013-07-19','14:30:00',15.38),('7643','2013-07-19','14:35:00',15.74),('7643','2013-07-19','14:40:00',15.96),('7643','2013-07-19','14:45:00',9.8),('7643','2013-07-19','14:50:00',13.47),('7643','2013-07-19','14:55:00',4.31),('7643','2013-07-19','15:00:00',13),('7643','2013-07-19','15:05:00',15.34),('7643','2013-07-19','15:10:00',15.04),('7643','2013-07-19','15:15:00',14.53),('7643','2013-07-19','15:20:00',14.15),('7643','2013-07-19','15:25:00',13.74),('7643','2013-07-19','15:30:00',13.54),('7643','2013-07-19','15:35:00',13.34),('7643','2013-07-19','15:40:00',13.15),('7643','2013-07-19','15:45:00',12.99),('7643','2013-07-19','15:50:00',12.78),('7643','2013-07-19','15:55:00',12.7),('7643','2013-07-19','16:00:00',12.52),('7643','2013-07-19','16:05:00',12.23),('7643','2013-07-19','16:10:00',12.16),('7643','2013-07-19','16:15:00',11.99),('7643','2013-07-19','16:20:00',11.8),('7643','2013-07-19','16:25:00',11.54),('7643','2013-07-19','16:30:00',11.32),('7643','2013-07-19','16:35:00',10.91),('7643','2013-07-19','16:40:00',10.72),('7643','2013-07-19','16:45:00',10.34),('7643','2013-07-19','16:50:00',9.98),('7643','2013-07-19','16:55:00',9.7),('7643','2013-07-19','17:00:00',9.41),('7643','2013-07-19','17:05:00',9.17),('7643','2013-07-19','17:10:00',8.86),('7643','2013-07-19','17:15:00',8.57),('7643','2013-07-19','17:20:00',8.29),('7643','2013-07-19','17:25:00',8.01),('7643','2013-07-19','17:30:00',7.72),('7643','2013-07-19','17:35:00',7.4),('7643','2013-07-19','17:40:00',7.11),('7643','2013-07-19','17:45:00',6.75),('7643','2013-07-19','17:50:00',6.44),('7643','2013-07-19','17:55:00',6.19),('7643','2013-07-19','18:00:00',5.92),('7643','2013-07-19','18:05:00',5.58),('7643','2013-07-19','18:10:00',5.2),('7643','2013-07-19','18:15:00',4.87),('7643','2013-07-19','18:20:00',4.57),('7643','2013-07-19','18:25:00',4.35),('7643','2013-07-19','18:30:00',4.05),('7643','2013-07-19','18:35:00',3.75),('7643','2013-07-19','18:40:00',3.41),('7643','2013-07-19','18:45:00',3.08),('7643','2013-07-19','18:50:00',2.73),('7643','2013-07-19','18:55:00',2.42),('7643','2013-07-19','19:00:00',2.08),('7643','2013-07-19','19:05:00',1.83),('7643','2013-07-19','19:10:00',1.66),('7643','2013-07-19','19:15:00',1.45),('7643','2013-07-19','19:20:00',1.24),('7643','2013-07-19','19:25:00',1.06),('7643','2013-07-18','06:50:00',1.02),('7643','2013-07-18','06:55:00',1.18),('7643','2013-07-18','07:00:00',1.34),('7643','2013-07-18','07:05:00',1.52),('7643','2013-07-18','07:10:00',1.75),('7643','2013-07-18','07:15:00',2.01),('7643','2013-07-18','07:20:00',2.2),('7643','2013-07-18','07:25:00',2.42),('7643','2013-07-18','07:30:00',2.68),('7643','2013-07-18','07:35:00',2.97),('7643','2013-07-18','07:40:00',3.23),('7643','2013-07-18','07:45:00',3.5),('7643','2013-07-18','07:50:00',3.81),('7643','2013-07-18','07:55:00',4.12),('7643','2013-07-18','08:00:00',4.4),('7643','2013-07-18','08:05:00',4.71),('7643','2013-07-18','08:10:00',5),('7643','2013-07-18','08:15:00',5.3),('7643','2013-07-18','08:20:00',5.54),('7643','2013-07-18','08:25:00',5.81),('7643','2013-07-18','08:30:00',6.1),('7643','2013-07-18','08:35:00',6.46),('7643','2013-07-18','08:40:00',6.83),('7643','2013-07-18','08:45:00',7.19),('7643','2013-07-18','08:50:00',7.52),('7643','2013-07-18','08:55:00',7.83),('7643','2013-07-18','09:00:00',8.06),('7643','2013-07-18','09:05:00',8.33),('7643','2013-07-18','09:10:00',8.66),('7643','2013-07-18','09:15:00',8.91),('7643','2013-07-18','09:20:00',9.15),('7643','2013-07-18','09:25:00',9.31),('7643','2013-07-18','09:30:00',9.57),('7643','2013-07-18','09:35:00',9.9),('7643','2013-07-18','09:40:00',9.96),('7643','2013-07-18','09:45:00',10.18),('7643','2013-07-18','09:50:00',10.42),('7643','2013-07-18','09:55:00',10.63),('7643','2013-07-18','10:00:00',10.68),('7643','2013-07-18','10:05:00',10.98),('7643','2013-07-18','10:10:00',11.14),('7643','2013-07-18','10:15:00',11.39),('7643','2013-07-18','10:20:00',11.49),('7643','2013-07-18','10:25:00',11.81),('7643','2013-07-18','10:30:00',11.68),('7643','2013-07-18','10:35:00',12.18),('7643','2013-07-18','10:40:00',12.3),('7643','2013-07-18','10:45:00',12.38),('7643','2013-07-18','10:50:00',12.43),('7643','2013-07-18','10:55:00',12.71),('7643','2013-07-18','11:00:00',12.93),('7643','2013-07-18','11:05:00',13.06),('7643','2013-07-18','11:10:00',13.09),('7643','2013-07-18','11:15:00',13.06),('7643','2013-07-18','11:20:00',13.28),('7643','2013-07-18','11:25:00',13.27),('7643','2013-07-18','11:30:00',13.39),('7643','2013-07-18','11:35:00',13.49),('7643','2013-07-18','11:40:00',13.78),('7643','2013-07-18','11:45:00',14.33),('7643','2013-07-18','11:50:00',14.29),('7643','2013-07-18','11:55:00',14.55),('7643','2013-07-18','12:00:00',8.87),('7643','2013-07-18','12:05:00',11.94),('7643','2013-07-18','12:10:00',12.09),('7643','2013-07-18','12:15:00',15.15),('7643','2013-07-18','12:20:00',15.35),('7643','2013-07-18','12:25:00',14.37),('7643','2013-07-18','12:30:00',13.02),('7643','2013-07-18','12:35:00',15.31),('7643','2013-07-18','12:40:00',14.92),('7643','2013-07-18','12:45:00',15.06),('7643','2013-07-18','12:50:00',15.07),('7643','2013-07-18','12:55:00',13.81),('7643','2013-07-18','13:00:00',10.42),('7643','2013-07-18','13:05:00',15.22),('7643','2013-07-18','13:10:00',14.96),('7643','2013-07-18','13:15:00',12.55),('7643','2013-07-18','13:20:00',7.07),('7643','2013-07-18','13:25:00',14.8),('7643','2013-07-18','13:30:00',16.84),('7643','2013-07-18','13:35:00',16.38),('7643','2013-07-18','13:40:00',16.06),('7643','2013-07-18','13:45:00',16.26),('7643','2013-07-18','13:50:00',14.4),('7643','2013-07-18','13:55:00',13.8),('7643','2013-07-18','14:00:00',14.58),('7643','2013-07-18','14:05:00',16.24),('7643','2013-07-18','14:10:00',13.14),('7643','2013-07-18','14:15:00',15.58),('7643','2013-07-18','14:20:00',15.7),('7643','2013-07-18','14:25:00',16.15),('7643','2013-07-18','14:30:00',16.21),('7643','2013-07-18','14:35:00',14.08),('7643','2013-07-18','14:40:00',12.87),('7643','2013-07-18','14:45:00',10.75),('7643','2013-07-18','14:50:00',12.79),('7643','2013-07-18','14:55:00',14.74),('7643','2013-07-18','15:00:00',15.36),('7643','2013-07-18','15:05:00',14.87),('7643','2013-07-18','15:10:00',15),('7643','2013-07-18','15:15:00',8.07),('7643','2013-07-18','15:20:00',12.6),('7643','2013-07-18','15:25:00',11.56),('7643','2013-07-18','15:30:00',13.76),('7643','2013-07-18','15:35:00',13.84),('7643','2013-07-18','15:40:00',14.45),('7643','2013-07-18','15:45:00',14.08),('7643','2013-07-18','15:50:00',13.75),('7643','2013-07-18','15:55:00',13.34),('7643','2013-07-18','16:00:00',13.14),('7643','2013-07-18','16:05:00',12.83),('7643','2013-07-18','16:10:00',12.77),('7643','2013-07-18','16:15:00',12.59),('7643','2013-07-18','16:20:00',12.42),('7643','2013-07-18','16:25:00',12.14),('7643','2013-07-18','16:30:00',11.91),('7643','2013-07-18','16:35:00',11.74),('7643','2013-07-18','16:40:00',11.51),('7643','2013-07-18','16:45:00',11.16),('7643','2013-07-18','16:50:00',11.04),('7643','2013-07-18','16:55:00',10.97),('7643','2013-07-18','17:00:00',10.17),('7643','2013-07-18','17:05:00',10.29),('7643','2013-07-18','17:10:00',9.15),('7643','2013-07-18','17:15:00',8.29),('7643','2013-07-18','17:20:00',8.37),('7643','2013-07-18','17:25:00',7.16),('7643','2013-07-18','17:30:00',7.72),('7643','2013-07-18','17:35:00',8.25),('7643','2013-07-18','17:40:00',6.23),('7643','2013-07-18','17:45:00',4.71),('7643','2013-07-18','17:50:00',3.41),('7643','2013-07-18','17:55:00',3.13),('7643','2013-07-18','18:00:00',2.81),('7643','2013-07-18','18:05:00',2.42),('7643','2013-07-18','18:10:00',2.06),('7643','2013-07-18','18:15:00',1.7),('7643','2013-07-18','18:20:00',1.38),('7643','2013-07-18','18:25:00',1.55),('7643','2013-07-18','18:30:00',1.74),('7643','2013-07-18','18:35:00',1.86),('7643','2013-07-18','18:40:00',1.94),('7643','2013-07-18','18:45:00',1.92),('7643','2013-07-18','18:50:00',1.84),('7643','2013-07-18','18:55:00',1.79),('7643','2013-07-18','19:00:00',1.71),('7643','2013-07-18','19:05:00',1.58),('7643','2013-07-18','19:10:00',1.43),('7643','2013-07-18','19:15:00',1.29),('7643','2013-07-18','19:20:00',1.12),('7643','2013-07-18','19:25:00',1),('7643','2013-07-18','19:30:00',1),('7643','2013-07-18','19:35:00',1.1),('7643','2013-07-18','19:40:00',1.17),('7643','2013-07-18','19:45:00',1.12),('7643','2013-07-18','19:50:00',1),('7643','2013-07-17','06:55:00',1.15),('7643','2013-07-17','07:00:00',1.33),('7643','2013-07-17','07:05:00',1.52),('7643','2013-07-17','07:10:00',1.79),('7643','2013-07-17','07:15:00',2.03),('7643','2013-07-17','07:20:00',2.27),('7643','2013-07-17','07:25:00',2.55),('7643','2013-07-17','07:30:00',2.84),('7643','2013-07-17','07:35:00',3.14),('7643','2013-07-17','07:40:00',3.44),('7643','2013-07-17','07:45:00',3.77),('7643','2013-07-17','07:50:00',4.1),('7643','2013-07-17','07:55:00',4.43),('7643','2013-07-17','08:00:00',4.69),('7643','2013-07-17','08:05:00',5.03),('7643','2013-07-17','08:10:00',5.35),('7643','2013-07-17','08:15:00',5.65),('7643','2013-07-17','08:20:00',5.89),('7643','2013-07-17','08:25:00',6.22),('7643','2013-07-17','08:30:00',6.57),('7643','2013-07-17','08:35:00',6.91),('7643','2013-07-17','08:40:00',7.24),('7643','2013-07-17','08:45:00',7.58),('7643','2013-07-17','08:50:00',7.87),('7643','2013-07-17','08:55:00',8.2),('7643','2013-07-17','09:00:00',8.46),('7643','2013-07-17','09:05:00',8.75),('7643','2013-07-17','09:10:00',9.02),('7643','2013-07-17','09:15:00',9.27),('7643','2013-07-17','09:20:00',9.5),('7643','2013-07-17','09:25:00',9.78),('7643','2013-07-17','09:30:00',10.05),('7643','2013-07-17','09:35:00',10.31),('7643','2013-07-17','09:40:00',10.56),('7643','2013-07-17','09:45:00',10.74),('7643','2013-07-17','09:50:00',10.94),('7643','2013-07-17','09:55:00',11.13),('7643','2013-07-17','10:00:00',11.35),('7643','2013-07-17','10:05:00',11.55),('7643','2013-07-17','10:10:00',11.81),('7643','2013-07-17','10:15:00',11.9),('7643','2013-07-17','10:20:00',12.09),('7643','2013-07-17','10:25:00',12.32),('7643','2013-07-17','10:30:00',12.56),('7643','2013-07-17','10:35:00',12.76),('7643','2013-07-17','10:40:00',12.99),('7643','2013-07-17','10:45:00',13.03),('7643','2013-07-17','10:50:00',13.24),('7643','2013-07-17','10:55:00',13.36),('7643','2013-07-17','11:00:00',13.47),('7643','2013-07-17','11:05:00',13.6),('7643','2013-07-17','11:10:00',13.72),('7643','2013-07-17','11:15:00',13.75),('7643','2013-07-17','11:20:00',13.92),('7643','2013-07-17','11:25:00',14.13),('7643','2013-07-17','11:30:00',14.31),('7643','2013-07-17','11:35:00',14.26),('7643','2013-07-17','11:40:00',14.22),('7643','2013-07-17','11:45:00',14.34),('7643','2013-07-17','11:50:00',14.55),('7643','2013-07-17','11:55:00',14.9),('7643','2013-07-17','12:00:00',14.9),('7643','2013-07-17','12:05:00',14.79),('7643','2013-07-17','12:10:00',14.86),('7643','2013-07-17','12:15:00',14.93),('7643','2013-07-17','12:20:00',14.88),('7643','2013-07-17','12:25:00',13.59),('7643','2013-07-17','12:30:00',5.87),('7643','2013-07-17','12:35:00',12.58),('7643','2013-07-17','12:40:00',12.52),('7643','2013-07-17','12:45:00',16.3),('7643','2013-07-17','12:50:00',12.57),('7643','2013-07-17','12:55:00',13.11),('7643','2013-07-17','13:00:00',16.08),('7643','2013-07-17','13:05:00',15.77),('7643','2013-07-17','13:10:00',15.6),('7643','2013-07-17','13:15:00',15.51),('7643','2013-07-17','13:20:00',14.54),('7643','2013-07-17','13:25:00',11.69),('7643','2013-07-17','13:30:00',16.4),('7643','2013-07-17','13:35:00',15.68),('7643','2013-07-17','13:40:00',16.19),('7643','2013-07-17','13:45:00',16.41),('7643','2013-07-17','13:50:00',16.07),('7643','2013-07-17','13:55:00',15.72),('7643','2013-07-17','14:00:00',15.56),('7643','2013-07-17','14:05:00',15.46),('7643','2013-07-17','14:10:00',15.14),('7643','2013-07-17','14:15:00',15.21),('7643','2013-07-17','14:20:00',15.38),('7643','2013-07-17','14:25:00',14.97),('7643','2013-07-17','14:30:00',14.84),('7643','2013-07-17','14:35:00',15.07),('7643','2013-07-17','14:40:00',15.01),('7643','2013-07-17','14:45:00',14.67),('7643','2013-07-17','14:50:00',14.44),('7643','2013-07-17','14:55:00',14.23),('7643','2013-07-17','15:00:00',14.34),('7643','2013-07-17','15:05:00',14.46),('7643','2013-07-17','15:10:00',14.33),('7643','2013-07-17','15:15:00',14.05),('7643','2013-07-17','15:20:00',13.96),('7643','2013-07-17','15:25:00',13.83),('7643','2013-07-17','15:30:00',13.63),('7643','2013-07-17','15:35:00',13.5),('7643','2013-07-17','15:40:00',13.35),('7643','2013-07-17','15:45:00',13.16),('7643','2013-07-17','15:50:00',12.93),('7643','2013-07-17','15:55:00',12.64),('7643','2013-07-17','16:00:00',12.52),('7643','2013-07-17','16:05:00',12.27),('7643','2013-07-17','16:10:00',12.04),('7643','2013-07-17','16:15:00',11.84),('7643','2013-07-17','16:20:00',11.56),('7643','2013-07-17','16:25:00',11.36),('7643','2013-07-17','16:30:00',11.05),('7643','2013-07-17','16:35:00',10.79),('7643','2013-07-17','16:40:00',10.49),('7643','2013-07-17','16:45:00',10.17),('7643','2013-07-17','16:50:00',9.94),('7643','2013-07-17','16:55:00',9.74),('7643','2013-07-17','17:00:00',9.4),('7643','2013-07-17','17:05:00',9.12),('7643','2013-07-17','17:10:00',8.81),('7643','2013-07-17','17:15:00',8.44),('7643','2013-07-17','17:20:00',8.18),('7643','2013-07-17','17:25:00',7.91),('7643','2013-07-17','17:30:00',7.46),('7643','2013-07-17','17:35:00',7.12),('7643','2013-07-17','17:40:00',6.63),('7643','2013-07-17','17:45:00',6.23),('7643','2013-07-17','17:50:00',6.14),('7643','2013-07-17','17:55:00',5.77),('7643','2013-07-17','18:00:00',5.31),('7643','2013-07-17','18:05:00',5.1),('7643','2013-07-17','18:10:00',4.67),('7643','2013-07-17','18:15:00',4.52),('7643','2013-07-17','18:20:00',4.12),('7643','2013-07-17','18:25:00',3.96),('7643','2013-07-17','18:30:00',2.63),('7643','2013-07-17','18:35:00',1.38),('7643','2013-07-17','18:40:00',1.28),('7643','2013-07-17','18:45:00',1.79),('7643','2013-07-17','18:50:00',1.84),('7643','2013-07-17','18:55:00',1.5),('7643','2013-07-17','19:00:00',2.13),('7643','2013-07-17','19:05:00',1.69),('7643','2013-07-17','19:10:00',1.18),('7643','2013-07-17','19:15:00',1.49),('7643','2013-07-17','19:20:00',1.49),('7643','2013-07-17','19:25:00',1.17),('7643','2013-07-16','06:50:00',1.05),('7643','2013-07-16','06:55:00',1.23),('7643','2013-07-16','07:00:00',1.43),('7643','2013-07-16','07:05:00',1.64),('7643','2013-07-16','07:10:00',1.88),('7643','2013-07-16','07:15:00',2.16),('7643','2013-07-16','07:20:00',2.36),('7643','2013-07-16','07:25:00',2.6),('7643','2013-07-16','07:30:00',2.91),('7643','2013-07-16','07:35:00',3.21),('7643','2013-07-16','07:40:00',3.46),('7643','2013-07-16','07:45:00',3.83),('7643','2013-07-16','07:50:00',4.15),('7643','2013-07-16','07:55:00',4.51),('7643','2013-07-16','08:00:00',4.79),('7643','2013-07-16','08:05:00',5.22),('7643','2013-07-16','08:10:00',5.57),('7643','2013-07-16','08:15:00',5.87),('7643','2013-07-16','08:20:00',6.19),('7643','2013-07-16','08:25:00',6.5),('7643','2013-07-16','08:30:00',6.77),('7643','2013-07-16','08:35:00',7.23),('7643','2013-07-16','08:40:00',7.61),('7643','2013-07-16','08:45:00',7.93),('7643','2013-07-16','08:50:00',8.3),('7643','2013-07-16','08:55:00',8.59),('7643','2013-07-16','09:00:00',8.9),('7643','2013-07-16','09:05:00',9.18),('7643','2013-07-16','09:10:00',9.53),('7643','2013-07-16','09:15:00',9.85),('7643','2013-07-16','09:20:00',10.14),('7643','2013-07-16','09:25:00',10.5),('7643','2013-07-16','09:30:00',10.71),('7643','2013-07-16','09:35:00',10.91),('7643','2013-07-16','09:40:00',11.23),('7643','2013-07-16','09:45:00',11.48),('7643','2013-07-16','09:50:00',11.6),('7643','2013-07-16','09:55:00',11.74),('7643','2013-07-16','10:00:00',11.96),('7643','2013-07-16','10:05:00',12.18),('7643','2013-07-16','10:10:00',12.33),('7643','2013-07-16','10:15:00',12.55),('7643','2013-07-16','10:20:00',12.73),('7643','2013-07-16','10:25:00',12.91),('7643','2013-07-16','10:30:00',13.13),('7643','2013-07-16','10:35:00',13.31),('7643','2013-07-16','10:40:00',13.36),('7643','2013-07-16','10:45:00',13.62),('7643','2013-07-16','10:50:00',13.81),('7643','2013-07-16','10:55:00',13.86),('7643','2013-07-16','11:00:00',14.09),('7643','2013-07-16','11:05:00',14.3),('7643','2013-07-16','11:10:00',14.41),('7643','2013-07-16','11:15:00',14.47),('7643','2013-07-16','11:20:00',14.63),('7643','2013-07-16','11:25:00',14.66),('7643','2013-07-16','11:30:00',14.73),('7643','2013-07-16','11:35:00',14.84),('7643','2013-07-16','11:40:00',14.91),('7643','2013-07-16','11:45:00',15.02),('7643','2013-07-16','11:50:00',15.17),('7643','2013-07-16','11:55:00',15.34),('7643','2013-07-16','12:00:00',15.43),('7643','2013-07-16','12:05:00',15.48),('7643','2013-07-16','12:10:00',15.63),('7643','2013-07-16','12:15:00',15.54),('7643','2013-07-16','12:20:00',15.57),('7643','2013-07-16','12:25:00',15.74),('7643','2013-07-16','12:30:00',15.83),('7643','2013-07-16','12:35:00',15.84),('7643','2013-07-16','12:40:00',15.8),('7643','2013-07-16','12:45:00',15.88),('7643','2013-07-16','12:50:00',15.79),('7643','2013-07-16','12:55:00',15.88),('7643','2013-07-16','13:00:00',15.86),('7643','2013-07-16','13:05:00',15.67),('7643','2013-07-16','13:10:00',15.71),('7643','2013-07-16','13:15:00',15.65),('7643','2013-07-16','13:20:00',15.6),('7643','2013-07-16','13:25:00',15.43),('7643','2013-07-16','13:30:00',15.54),('7643','2013-07-16','13:35:00',15.46),('7643','2013-07-16','13:40:00',15.5),('7643','2013-07-16','13:45:00',15.49),('7643','2013-07-16','13:50:00',15.55),('7643','2013-07-16','13:55:00',15.55),('7643','2013-07-16','14:00:00',15.66),('7643','2013-07-16','14:05:00',15.56),('7643','2013-07-16','14:10:00',15.39),('7643','2013-07-16','14:15:00',15.29),('7643','2013-07-16','14:20:00',15.1),('7643','2013-07-16','14:25:00',14.91),('7643','2013-07-16','14:30:00',14.82),('7643','2013-07-16','14:35:00',14.69),('7643','2013-07-16','14:40:00',15.28),('7643','2013-07-16','14:45:00',15.05),('7643','2013-07-16','14:50:00',14.58),('7643','2013-07-16','14:55:00',14.27),('7643','2013-07-16','15:00:00',14.3),('7643','2013-07-16','15:05:00',14.22),('7643','2013-07-16','15:10:00',10.94),('7643','2013-07-16','15:15:00',14.22),('7643','2013-07-16','15:20:00',14.22),('7643','2013-07-16','15:25:00',11.12),('7643','2013-07-16','15:30:00',13.86),('7643','2013-07-16','15:35:00',13.7),('7643','2013-07-16','15:40:00',11.99),('7643','2013-07-16','15:45:00',13.35),('7643','2013-07-16','15:50:00',12.67),('7643','2013-07-16','15:55:00',13.24),('7643','2013-07-16','16:00:00',12.84),('7643','2013-07-16','16:05:00',12.7),('7643','2013-07-16','16:10:00',12.54),('7643','2013-07-16','16:15:00',12.24),('7643','2013-07-16','16:20:00',11.89),('7643','2013-07-16','16:25:00',11.53),('7643','2013-07-16','16:30:00',11.29),('7643','2013-07-16','16:35:00',10.24),('7643','2013-07-16','16:40:00',10.58),('7643','2013-07-16','16:45:00',10.44),('7643','2013-07-16','16:50:00',10),('7643','2013-07-16','16:55:00',9.7),('7643','2013-07-16','17:00:00',9.86),('7643','2013-07-16','17:05:00',9.76),('7643','2013-07-16','17:10:00',9.51),('7643','2013-07-16','17:15:00',8.88),('7643','2013-07-16','17:20:00',8.57),('7643','2013-07-16','17:25:00',7.92),('7643','2013-07-16','17:30:00',7.79),('7643','2013-07-16','17:35:00',7.49),('7643','2013-07-16','17:40:00',7.13),('7643','2013-07-16','17:45:00',6.78),('7643','2013-07-16','17:50:00',6.66),('7643','2013-07-16','17:55:00',6.26),('7643','2013-07-16','18:00:00',6),('7643','2013-07-16','18:05:00',5.63),('7643','2013-07-16','18:10:00',5.33),('7643','2013-07-16','18:15:00',4.94),('7643','2013-07-16','18:20:00',4.65),('7643','2013-07-16','18:25:00',4.39),('7643','2013-07-16','18:30:00',4.09),('7643','2013-07-16','18:35:00',3.78),('7643','2013-07-16','18:40:00',3.5),('7643','2013-07-16','18:45:00',3.17),('7643','2013-07-16','18:50:00',2.85),('7643','2013-07-16','18:55:00',2.45),('7643','2013-07-16','19:00:00',2.13),('7643','2013-07-16','19:05:00',1.94),('7643','2013-07-16','19:10:00',1.66),('7643','2013-07-16','19:15:00',1.44),('7643','2013-07-16','19:20:00',1.26),('7643','2013-07-16','19:25:00',1.09),('7643','2013-07-15','06:50:00',1.04),('7643','2013-07-15','06:55:00',1.21),('7643','2013-07-15','07:00:00',1.39),('7643','2013-07-15','07:05:00',1.59),('7643','2013-07-15','07:10:00',1.87),('7643','2013-07-15','07:15:00',2.14),('7643','2013-07-15','07:20:00',2.34),('7643','2013-07-15','07:25:00',2.65),('7643','2013-07-15','07:30:00',3),('7643','2013-07-15','07:35:00',3.31),('7643','2013-07-15','07:40:00',3.57),('7643','2013-07-15','07:45:00',3.89),('7643','2013-07-15','07:50:00',4.2),('7643','2013-07-15','07:55:00',4.47),('7643','2013-07-15','08:00:00',4.7),('7643','2013-07-15','08:05:00',5.02),('7643','2013-07-15','08:10:00',5.34),('7643','2013-07-15','08:15:00',5.66),('7643','2013-07-15','08:20:00',5.9),('7643','2013-07-15','08:25:00',6.24),('7643','2013-07-15','08:30:00',6.58),('7643','2013-07-15','08:35:00',6.89),('7643','2013-07-15','08:40:00',7.18),('7643','2013-07-15','08:45:00',7.49),('7643','2013-07-15','08:50:00',7.79),('7643','2013-07-15','08:55:00',8.17),('7643','2013-07-15','09:00:00',8.48),('7643','2013-07-15','09:05:00',8.69),('7643','2013-07-15','09:10:00',8.99),('7643','2013-07-15','09:15:00',9.26),('7643','2013-07-15','09:20:00',9.51),('7643','2013-07-15','09:25:00',9.8),('7643','2013-07-15','09:30:00',10.1),('7643','2013-07-15','09:35:00',10.3),('7643','2013-07-15','09:40:00',10.63),('7643','2013-07-15','09:45:00',10.86),('7643','2013-07-15','09:50:00',11.18),('7643','2013-07-15','09:55:00',11.44),('7643','2013-07-15','10:00:00',11.61),('7643','2013-07-15','10:05:00',11.86),('7643','2013-07-15','10:10:00',12.1),('7643','2013-07-15','10:15:00',12.33),('7643','2013-07-15','10:20:00',12.5),('7643','2013-07-15','10:25:00',12.68),('7643','2013-07-15','10:30:00',12.89),('7643','2013-07-15','10:35:00',13.04),('7643','2013-07-15','10:40:00',13.25),('7643','2013-07-15','10:45:00',13.39),('7643','2013-07-15','10:50:00',13.54),('7643','2013-07-15','10:55:00',13.7),('7643','2013-07-15','11:00:00',13.87),('7643','2013-07-15','11:05:00',14.05),('7643','2013-07-15','11:10:00',14.21),('7643','2013-07-15','11:15:00',14.22),('7643','2013-07-15','11:20:00',14.28),('7643','2013-07-15','11:25:00',14.51),('7643','2013-07-15','11:30:00',14.74),('7643','2013-07-15','11:35:00',14.8),('7643','2013-07-15','11:40:00',14.88),('7643','2013-07-15','11:45:00',14.98),('7643','2013-07-15','11:50:00',15.32),('7643','2013-07-15','11:55:00',15.44),('7643','2013-07-15','12:00:00',15.49),('7643','2013-07-15','12:05:00',15.52),('7643','2013-07-15','12:10:00',15.55),('7643','2013-07-15','12:15:00',15.68),('7643','2013-07-15','12:20:00',15.75),('7643','2013-07-15','12:25:00',15.72),('7643','2013-07-15','12:30:00',15.69),('7643','2013-07-15','12:35:00',15.62),('7643','2013-07-15','12:40:00',15.6),('7643','2013-07-15','12:45:00',15.55),('7643','2013-07-15','12:50:00',15.5),('7643','2013-07-15','12:55:00',15.41),('7643','2013-07-15','13:00:00',15.31),('7643','2013-07-15','13:05:00',15.43),('7643','2013-07-15','13:10:00',15.53),('7643','2013-07-15','13:15:00',15.75),('7643','2013-07-15','13:20:00',15.52),('7643','2013-07-15','13:25:00',15.47),('7643','2013-07-15','13:30:00',15.35),('7643','2013-07-15','13:35:00',15.41),('7643','2013-07-15','13:40:00',15.55),('7643','2013-07-15','13:45:00',15.89),('7643','2013-07-15','13:50:00',16.07),('7643','2013-07-15','13:55:00',15.83),('7643','2013-07-15','14:00:00',15.38),('7643','2013-07-15','14:05:00',15.2),('7643','2013-07-15','14:10:00',15.74),('7643','2013-07-15','14:15:00',15.7),('7643','2013-07-15','14:20:00',4.57),('7643','2013-07-15','14:25:00',11.55),('7643','2013-07-15','14:30:00',15.58),('7643','2013-07-15','14:35:00',15.38),('7643','2013-07-15','14:40:00',15.29),('7643','2013-07-15','14:45:00',15.08),('7643','2013-07-15','14:50:00',15.1),('7643','2013-07-15','14:55:00',15.02),('7643','2013-07-15','15:00:00',14.96),('7643','2013-07-15','15:05:00',14.57),('7643','2013-07-15','15:10:00',14.31),('7643','2013-07-15','15:15:00',14.12),('7643','2013-07-15','15:20:00',14.06),('7643','2013-07-15','15:25:00',13.89),('7643','2013-07-15','15:30:00',13.88),('7643','2013-07-15','15:35:00',14),('7643','2013-07-15','15:40:00',13.67),('7643','2013-07-15','15:45:00',11.34),('7643','2013-07-15','15:50:00',11.78),('7643','2013-07-15','15:55:00',10.62),('7643','2013-07-15','16:00:00',10.32),('7643','2013-07-15','16:05:00',2.79),('7643','2013-07-15','16:10:00',11.02),('7643','2013-07-15','16:15:00',12.56),('7643','2013-07-15','16:20:00',8.45),('7643','2013-07-15','16:25:00',7.32),('7643','2013-07-15','16:30:00',4.85),('7643','2013-07-15','16:35:00',3.01),('7643','2013-07-15','16:40:00',2.86),('7643','2013-07-15','16:45:00',4.66),('7643','2013-07-15','16:50:00',3.94),('7643','2013-07-15','16:55:00',4.38),('7643','2013-07-15','17:00:00',10.01),('7643','2013-07-15','17:05:00',10.37),('7643','2013-07-15','17:10:00',10.21),('7643','2013-07-15','17:15:00',9.63),('7643','2013-07-15','17:20:00',8.47),('7643','2013-07-15','17:25:00',5.35),('7643','2013-07-15','17:30:00',5.52),('7643','2013-07-15','17:35:00',4.59),('7643','2013-07-15','17:40:00',6.5),('7643','2013-07-15','17:45:00',7.48),('7643','2013-07-15','17:50:00',7.04),('7643','2013-07-15','17:55:00',5.98),('7643','2013-07-15','18:00:00',5.5),('7643','2013-07-15','18:05:00',3.51),('7643','2013-07-15','18:10:00',4.01),('7643','2013-07-15','18:15:00',4.95),('7643','2013-07-15','18:20:00',4.5),('7643','2013-07-15','18:25:00',4.31),('7643','2013-07-15','18:30:00',4.05),('7643','2013-07-15','18:35:00',3.69),('7643','2013-07-15','18:40:00',3.32),('7643','2013-07-15','18:45:00',3.03),('7643','2013-07-15','18:50:00',2.74),('7643','2013-07-15','18:55:00',2.4),('7643','2013-07-15','19:00:00',2.09),('7643','2013-07-15','19:05:00',1.83),('7643','2013-07-15','19:10:00',1.64),('7643','2013-07-15','19:15:00',1.46),('7643','2013-07-15','19:20:00',1.29),('7643','2013-07-15','19:25:00',1.07),('7643','2013-07-14','06:50:00',1.08),('7643','2013-07-14','06:55:00',1.25),('7643','2013-07-14','07:00:00',1.43),('7643','2013-07-14','07:05:00',1.67),('7643','2013-07-14','07:10:00',1.95),('7643','2013-07-14','07:15:00',2.19),('7643','2013-07-14','07:20:00',2.38),('7643','2013-07-14','07:25:00',2.73),('7643','2013-07-14','07:30:00',3.02),('7643','2013-07-14','07:35:00',3.35),('7643','2013-07-14','07:40:00',3.65),('7643','2013-07-14','07:45:00',3.99),('7643','2013-07-14','07:50:00',4.33),('7643','2013-07-14','07:55:00',4.65),('7643','2013-07-14','08:00:00',4.95),('7643','2013-07-14','08:05:00',5.28),('7643','2013-07-14','08:10:00',5.6),('7643','2013-07-14','08:15:00',5.91),('7643','2013-07-14','08:20:00',6.21),('7643','2013-07-14','08:25:00',6.54),('7643','2013-07-14','08:30:00',6.89),('7643','2013-07-14','08:35:00',7.23),('7643','2013-07-14','08:40:00',7.59),('7643','2013-07-14','08:45:00',7.91),('7643','2013-07-14','08:50:00',8.21),('7643','2013-07-14','08:55:00',8.56),('7643','2013-07-14','09:00:00',8.86),('7643','2013-07-14','09:05:00',9.12),('7643','2013-07-14','09:10:00',9.44),('7643','2013-07-14','09:15:00',9.73),('7643','2013-07-14','09:20:00',10.05),('7643','2013-07-14','09:25:00',10.31),('7643','2013-07-14','09:30:00',10.57),('7643','2013-07-14','09:35:00',10.8),('7643','2013-07-14','09:40:00',11.03),('7643','2013-07-14','09:45:00',11.24),('7643','2013-07-14','09:50:00',11.46),('7643','2013-07-14','09:55:00',11.68),('7643','2013-07-14','10:00:00',11.85),('7643','2013-07-14','10:05:00',11.98),('7643','2013-07-14','10:10:00',12.23),('7643','2013-07-14','10:15:00',12.45),('7643','2013-07-14','10:20:00',12.68),('7643','2013-07-14','10:25:00',12.82),('7643','2013-07-14','10:30:00',12.97),('7643','2013-07-14','10:35:00',13.04),('7643','2013-07-14','10:40:00',13.14),('7643','2013-07-14','10:45:00',13.3),('7643','2013-07-14','10:50:00',13.47),('7643','2013-07-14','10:55:00',13.61),('7643','2013-07-14','11:00:00',13.82),('7643','2013-07-14','11:05:00',14.03),('7643','2013-07-14','11:10:00',14.12),('7643','2013-07-14','11:15:00',14.18),('7643','2013-07-14','11:20:00',14.28),('7643','2013-07-14','11:25:00',14.4),('7643','2013-07-14','11:30:00',14.47),('7643','2013-07-14','11:35:00',14.6),('7643','2013-07-14','11:40:00',14.65),('7643','2013-07-14','11:45:00',14.65),('7643','2013-07-14','11:50:00',14.8),('7643','2013-07-14','11:55:00',14.88),('7643','2013-07-14','12:00:00',15.14),('7643','2013-07-14','12:05:00',15.33),('7643','2013-07-14','12:10:00',15.35),('7643','2013-07-14','12:15:00',15.32),('7643','2013-07-14','12:20:00',15.51),('7643','2013-07-14','12:25:00',15.52),('7643','2013-07-14','12:30:00',15.6),('7643','2013-07-14','12:35:00',15.66),('7643','2013-07-14','12:40:00',15.58),('7643','2013-07-14','12:45:00',15.46),('7643','2013-07-14','12:50:00',15.56),('7643','2013-07-14','12:55:00',15.59),('7643','2013-07-14','13:00:00',15.69),('7643','2013-07-14','13:05:00',13.42),('7643','2013-07-14','13:10:00',16.11),('7643','2013-07-14','13:15:00',15.73),('7643','2013-07-14','13:20:00',15.5),('7643','2013-07-14','13:25:00',16.1),('7643','2013-07-14','13:30:00',15.63),('7643','2013-07-14','13:35:00',14.04),('7643','2013-07-14','13:40:00',4.28),('7643','2013-07-14','13:45:00',7.07),('7643','2013-07-14','13:50:00',17),('7643','2013-07-14','13:55:00',17.17),('7643','2013-07-14','14:00:00',16.9),('7643','2013-07-14','14:05:00',14.82),('7643','2013-07-14','14:10:00',3.77),('7643','2013-07-14','14:15:00',5.71),('7643','2013-07-14','14:20:00',8.83),('7643','2013-07-14','14:25:00',16.66),('7643','2013-07-14','14:30:00',15.69),('7643','2013-07-14','14:35:00',9.92),('7643','2013-07-14','14:40:00',15.88),('7643','2013-07-14','14:45:00',15.53),('7643','2013-07-14','14:50:00',15.39),('7643','2013-07-14','14:55:00',15.36),('7643','2013-07-14','15:00:00',15.43),('7643','2013-07-14','15:05:00',14.92),('7643','2013-07-14','15:10:00',14.74),('7643','2013-07-14','15:15:00',14.5),('7643','2013-07-14','15:20:00',13.54),('7643','2013-07-14','15:25:00',13.38),('7643','2013-07-14','15:30:00',13.45),('7643','2013-07-14','15:35:00',7.8),('7643','2013-07-14','15:40:00',14.16),('7643','2013-07-14','15:45:00',13.69),('7643','2013-07-14','15:50:00',13.65),('7643','2013-07-14','15:55:00',13.23),('7643','2013-07-14','16:00:00',12.7),('7643','2013-07-14','16:05:00',12.58),('7643','2013-07-14','16:10:00',12.23),('7643','2013-07-14','16:15:00',12.06),('7643','2013-07-14','16:20:00',11.57),('7643','2013-07-14','16:25:00',11.34),('7643','2013-07-14','16:30:00',11.13),('7643','2013-07-14','16:35:00',11.03),('7643','2013-07-14','16:40:00',10.63),('7643','2013-07-14','16:45:00',10.32),('7643','2013-07-14','16:50:00',10.07),('7643','2013-07-14','16:55:00',9.87),('7643','2013-07-14','17:00:00',9.52),('7643','2013-07-14','17:05:00',9.35),('7643','2013-07-14','17:10:00',9.05),('7643','2013-07-14','17:15:00',8.74),('7643','2013-07-14','17:20:00',8.38),('7643','2013-07-14','17:25:00',8.1),('7643','2013-07-14','17:30:00',7.74),('7643','2013-07-14','17:35:00',7.45),('7643','2013-07-14','17:40:00',7.08),('7643','2013-07-14','17:45:00',6.69),('7643','2013-07-14','17:50:00',6.5),('7643','2013-07-14','17:55:00',6.17),('7643','2013-07-14','18:00:00',5.82),('7643','2013-07-14','18:05:00',5.47),('7643','2013-07-14','18:10:00',5.14),('7643','2013-07-14','18:15:00',4.78),('7643','2013-07-14','18:20:00',4.56),('7643','2013-07-14','18:25:00',4.3),('7643','2013-07-14','18:30:00',4.02),('7643','2013-07-14','18:35:00',3.68),('7643','2013-07-14','18:40:00',3.45),('7643','2013-07-14','18:45:00',3.19),('7643','2013-07-14','18:50:00',2.88),('7643','2013-07-14','18:55:00',2.55),('7643','2013-07-14','19:00:00',2.27),('7643','2013-07-14','19:05:00',2.06),('7643','2013-07-14','19:10:00',1.79),('7643','2013-07-14','19:15:00',1.58),('7643','2013-07-14','19:20:00',1.38),('7643','2013-07-14','19:25:00',1.23),('7643','2013-07-14','19:30:00',1.08),('7643','2013-07-13','07:20:00',1.08),('7643','2013-07-13','07:25:00',1.41),('7643','2013-07-13','07:30:00',1.27),('7643','2013-07-13','07:35:00',1.8),('7643','2013-07-13','07:40:00',2.57),('7643','2013-07-13','07:45:00',2.92),('7643','2013-07-13','07:50:00',4.25),('7643','2013-07-13','07:55:00',5.56),('7643','2013-07-13','08:00:00',4.92),('7643','2013-07-13','08:05:00',6.1),('7643','2013-07-13','08:10:00',6.95),('7643','2013-07-13','08:15:00',5.52),('7643','2013-07-13','08:20:00',7.02),('7643','2013-07-13','08:25:00',5.7),('7643','2013-07-13','08:30:00',3.58),('7643','2013-07-13','08:35:00',4.36),('7643','2013-07-13','08:40:00',4.35),('7643','2013-07-13','08:45:00',3.57),('7643','2013-07-13','08:50:00',3.9),('7643','2013-07-13','08:55:00',4),('7643','2013-07-13','09:00:00',3.75),('7643','2013-07-13','09:05:00',4.5),('7643','2013-07-13','09:10:00',5.52),('7643','2013-07-13','09:15:00',6.9),('7643','2013-07-13','09:20:00',7.71),('7643','2013-07-13','09:25:00',7.89),('7643','2013-07-13','09:30:00',8.73),('7643','2013-07-13','09:35:00',7.22),('7643','2013-07-13','09:40:00',6.33),('7643','2013-07-13','09:45:00',6.38),('7643','2013-07-13','09:50:00',6.12),('7643','2013-07-13','09:55:00',6.24),('7643','2013-07-13','10:00:00',6.22),('7643','2013-07-13','10:05:00',6.86),('7643','2013-07-13','10:10:00',6.65),('7643','2013-07-13','10:15:00',7.03),('7643','2013-07-13','10:20:00',9.36),('7643','2013-07-13','10:25:00',9.99),('7643','2013-07-13','10:30:00',9.98),('7643','2013-07-13','10:35:00',13.03),('7643','2013-07-13','10:40:00',13.87),('7643','2013-07-13','10:45:00',10.48),('7643','2013-07-13','10:50:00',14.96),('7643','2013-07-13','10:55:00',13.06),('7643','2013-07-13','11:00:00',12.74),('7643','2013-07-13','11:05:00',12.24),('7643','2013-07-13','11:10:00',15.11),('7643','2013-07-13','11:15:00',11.04),('7643','2013-07-13','11:20:00',16.26),('7643','2013-07-13','11:25:00',15.45),('7643','2013-07-13','11:30:00',16.25),('7643','2013-07-13','11:35:00',16.2),('7643','2013-07-13','11:40:00',13.31),('7643','2013-07-13','11:45:00',5.47),('7643','2013-07-13','11:50:00',5.82),('7643','2013-07-13','11:55:00',5.78),('7643','2013-07-13','12:00:00',5.96),('7643','2013-07-13','12:05:00',12.77),('7643','2013-07-13','12:10:00',12.64),('7643','2013-07-13','12:15:00',12.73),('7643','2013-07-13','12:20:00',11.81),('7643','2013-07-13','12:25:00',9.38),('7643','2013-07-13','12:30:00',6.82),('7643','2013-07-13','12:35:00',15.55),('7643','2013-07-13','12:40:00',17.49),('7643','2013-07-13','12:45:00',16.34),('7643','2013-07-13','12:50:00',13.92),('7643','2013-07-13','12:55:00',5.62),('7643','2013-07-13','13:00:00',6.11),('7643','2013-07-13','13:05:00',15.51),('7643','2013-07-13','13:10:00',17.23),('7643','2013-07-13','13:15:00',12.68),('7643','2013-07-13','13:20:00',15.78),('7643','2013-07-13','13:25:00',16.8),('7643','2013-07-13','13:30:00',16.37),('7643','2013-07-13','13:35:00',16.47),('7643','2013-07-13','13:40:00',16.57),('7643','2013-07-13','13:45:00',16.4),('7643','2013-07-13','13:50:00',16.52),('7643','2013-07-13','13:55:00',16.31),('7643','2013-07-13','14:00:00',16.34),('7643','2013-07-13','14:05:00',16.45),('7643','2013-07-13','14:10:00',16.36),('7643','2013-07-13','14:15:00',16.24),('7643','2013-07-13','14:20:00',16.11),('7643','2013-07-13','14:25:00',16.04),('7643','2013-07-13','14:30:00',15.92),('7643','2013-07-13','14:35:00',15.74),('7643','2013-07-13','14:40:00',15.48),('7643','2013-07-13','14:45:00',15.21),('7643','2013-07-13','14:50:00',14.95),('7643','2013-07-13','14:55:00',15.11),('7643','2013-07-13','15:00:00',14.85),('7643','2013-07-13','15:05:00',14.76),('7643','2013-07-13','15:10:00',14.62),('7643','2013-07-13','15:15:00',14.46),('7643','2013-07-13','15:20:00',14.25),('7643','2013-07-13','15:25:00',14.08),('7643','2013-07-13','15:30:00',13.87),('7643','2013-07-13','15:35:00',13.61),('7643','2013-07-13','15:40:00',13.54),('7643','2013-07-13','15:45:00',13.33),('7643','2013-07-13','15:50:00',12.1),('7643','2013-07-13','15:55:00',13.11),('7643','2013-07-13','16:00:00',12.72),('7643','2013-07-13','16:05:00',12.68),('7643','2013-07-13','16:10:00',12.5),('7643','2013-07-13','16:15:00',12.34),('7643','2013-07-13','16:20:00',11.25),('7643','2013-07-13','16:25:00',11.9),('7643','2013-07-13','16:30:00',8.78),('7643','2013-07-13','16:35:00',10.98),('7643','2013-07-13','16:40:00',11.51),('7643','2013-07-13','16:45:00',11.21),('7643','2013-07-13','16:50:00',6.98),('7643','2013-07-13','16:55:00',7.79),('7643','2013-07-13','17:00:00',8.34),('7643','2013-07-13','17:05:00',8.57),('7643','2013-07-13','17:10:00',8.4),('7643','2013-07-13','17:15:00',9.57),('7643','2013-07-13','17:20:00',5.49),('7643','2013-07-13','17:25:00',8.35),('7643','2013-07-13','17:30:00',8.44),('7643','2013-07-13','17:35:00',8.27),('7643','2013-07-13','17:40:00',3.53),('7643','2013-07-13','17:45:00',3.98),('7643','2013-07-13','17:50:00',5),('7643','2013-07-13','17:55:00',5.63),('7643','2013-07-13','18:00:00',5.2),('7643','2013-07-13','18:05:00',3.42),('7643','2013-07-13','18:10:00',3.59),('7643','2013-07-13','18:15:00',1.27),('7643','2013-07-13','18:35:00',1.29),('7643','2013-07-13','18:40:00',2.17),('7643','2013-07-13','18:45:00',2.68),('7643','2013-07-13','18:50:00',2.5),('7643','2013-07-13','18:55:00',2.09),('7643','2013-07-13','19:00:00',1.63),('7643','2013-07-13','19:05:00',1.68),('7643','2013-07-13','19:10:00',2.24),('7643','2013-07-13','19:15:00',2.63),('7643','2013-07-13','19:20:00',2.81),('7643','2013-07-13','19:25:00',2.05),('7643','2013-07-13','19:30:00',1.27),('7643','2013-07-12','07:10:00',1.22),('7643','2013-07-12','07:15:00',1.41),('7643','2013-07-12','07:20:00',1.78),('7643','2013-07-12','07:25:00',2.36),('7643','2013-07-12','07:30:00',3.09),('7643','2013-07-12','07:35:00',3.34),('7643','2013-07-12','07:40:00',3.42),('7643','2013-07-12','07:45:00',3.64),('7643','2013-07-12','07:50:00',3.92),('7643','2013-07-12','07:55:00',4.22),('7643','2013-07-12','08:00:00',4.53),('7643','2013-07-12','08:05:00',4.95),('7643','2013-07-12','08:10:00',5.22),('7643','2013-07-12','08:15:00',5.52),('7643','2013-07-12','08:20:00',5.8),('7643','2013-07-12','08:25:00',6.12),('7643','2013-07-12','08:30:00',6.4),('7643','2013-07-12','08:35:00',6.72),('7643','2013-07-12','08:40:00',7.01),('7643','2013-07-12','08:45:00',7.35),('7643','2013-07-12','08:50:00',7.63),('7643','2013-07-12','08:55:00',7.97),('7643','2013-07-12','09:00:00',8.37),('7643','2013-07-12','09:05:00',8.73),('7643','2013-07-12','09:10:00',9.03),('7643','2013-07-12','09:15:00',9.21),('7643','2013-07-12','09:20:00',9.5),('7643','2013-07-12','09:25:00',9.77),('7643','2013-07-12','09:30:00',10.02),('7643','2013-07-12','09:35:00',10.11),('7643','2013-07-12','09:40:00',10.45),('7643','2013-07-12','09:45:00',10.74),('7643','2013-07-12','09:50:00',11.06),('7643','2013-07-12','09:55:00',11.33),('7643','2013-07-12','10:00:00',11.45),('7643','2013-07-12','10:05:00',11.49),('7643','2013-07-12','10:10:00',12),('7643','2013-07-12','10:15:00',12.21),('7643','2013-07-12','10:20:00',12.24),('7643','2013-07-12','10:25:00',12.46),('7643','2013-07-12','10:30:00',12.86),('7643','2013-07-12','10:35:00',12.66),('7643','2013-07-12','10:40:00',12.97),('7643','2013-07-12','10:45:00',8.55),('7643','2013-07-12','10:50:00',8.61),('7643','2013-07-12','10:55:00',14.38),('7643','2013-07-12','11:00:00',14.66),('7643','2013-07-12','11:05:00',14.48),('7643','2013-07-12','11:10:00',14.63),('7643','2013-07-12','11:15:00',10.7),('7643','2013-07-12','11:20:00',13.67),('7643','2013-07-12','11:25:00',11.06),('7643','2013-07-12','11:30:00',15.58),('7643','2013-07-12','11:35:00',14.49),('7643','2013-07-12','11:40:00',11.64),('7643','2013-07-12','11:45:00',11.2),('7643','2013-07-12','11:50:00',4.69),('7643','2013-07-12','11:55:00',11.02),('7643','2013-07-12','12:00:00',14.74),('7643','2013-07-12','12:05:00',4.53),('7643','2013-07-12','12:10:00',13.31),('7643','2013-07-12','12:15:00',16.04),('7643','2013-07-12','12:20:00',8.33),('7643','2013-07-12','12:25:00',14.91),('7643','2013-07-12','12:30:00',13.98),('7643','2013-07-12','12:35:00',15.89),('7643','2013-07-12','12:40:00',16.05),('7643','2013-07-12','12:45:00',16.86),('7643','2013-07-12','12:50:00',16.82),('7643','2013-07-12','12:55:00',10.34),('7643','2013-07-12','13:00:00',14.1),('7643','2013-07-12','13:05:00',15.23),('7643','2013-07-12','13:10:00',16.65),('7643','2013-07-12','13:15:00',16.58),('7643','2013-07-12','13:20:00',16.59),('7643','2013-07-12','13:25:00',16.41),('7643','2013-07-12','13:30:00',16.01),('7643','2013-07-12','13:35:00',16.24),('7643','2013-07-12','13:40:00',16.31),('7643','2013-07-12','13:45:00',16.07),('7643','2013-07-12','13:50:00',16.17),('7643','2013-07-12','13:55:00',15.95),('7643','2013-07-12','14:00:00',16),('7643','2013-07-12','14:05:00',15.97),('7643','2013-07-12','14:10:00',15.95),('7643','2013-07-12','14:15:00',15.75),('7643','2013-07-12','14:20:00',15.59),('7643','2013-07-12','14:25:00',15.5),('7643','2013-07-12','14:30:00',15.49),('7643','2013-07-12','14:35:00',15.46),('7643','2013-07-12','14:40:00',15.29),('7643','2013-07-12','14:45:00',15.27),('7643','2013-07-12','14:50:00',15.31),('7643','2013-07-12','14:55:00',15.01),('7643','2013-07-12','15:00:00',14.94),('7643','2013-07-12','15:05:00',15.02),('7643','2013-07-12','15:10:00',14.9),('7643','2013-07-12','15:15:00',14.74),('7643','2013-07-12','15:20:00',14),('7643','2013-07-12','15:25:00',14.6),('7643','2013-07-12','15:30:00',14.26),('7643','2013-07-12','15:35:00',14.38),('7643','2013-07-12','15:40:00',14.13),('7643','2013-07-12','15:45:00',13.87),('7643','2013-07-12','15:50:00',13.62),('7643','2013-07-12','15:55:00',13.43),('7643','2013-07-12','16:00:00',13.28),('7643','2013-07-12','16:05:00',13),('7643','2013-07-12','16:10:00',12.67),('7643','2013-07-12','16:15:00',12.44),('7643','2013-07-12','16:20:00',12.19),('7643','2013-07-12','16:25:00',12.13),('7643','2013-07-12','16:30:00',11.84),('7643','2013-07-12','16:35:00',11.5),('7643','2013-07-12','16:40:00',11.19),('7643','2013-07-12','16:45:00',10.85),('7643','2013-07-12','16:50:00',10.59),('7643','2013-07-12','16:55:00',10.33),('7643','2013-07-12','17:00:00',10),('7643','2013-07-12','17:05:00',9.54),('7643','2013-07-12','17:10:00',9.5),('7643','2013-07-12','17:15:00',9.11),('7643','2013-07-12','17:20:00',8.51),('7643','2013-07-12','17:25:00',8.54),('7643','2013-07-12','17:30:00',8.01),('7643','2013-07-12','17:35:00',7.64),('7643','2013-07-12','17:40:00',7.43),('7643','2013-07-12','17:45:00',7.1),('7643','2013-07-12','17:50:00',6.77),('7643','2013-07-12','17:55:00',6.74),('7643','2013-07-12','18:00:00',6.23),('7643','2013-07-12','18:05:00',5.75),('7643','2013-07-12','18:10:00',5.53),('7643','2013-07-12','18:15:00',5.14),('7643','2013-07-12','18:20:00',4.92),('7643','2013-07-12','18:25:00',4.73),('7643','2013-07-12','18:30:00',4.3),('7643','2013-07-12','18:35:00',3.92),('7643','2013-07-12','18:40:00',2.74),('7643','2013-07-12','18:45:00',1.87),('7643','2013-07-12','18:50:00',2.62),('7643','2013-07-12','18:55:00',2.88),('7643','2013-07-12','19:00:00',2.59),('7643','2013-07-12','19:05:00',2.24),('7643','2013-07-12','19:10:00',1.88),('7643','2013-07-12','19:15:00',1.24),('7643','2013-07-12','19:20:00',1.04),('7643','2013-07-11','06:45:00',1.01),('7643','2013-07-11','06:50:00',1.24),('7643','2013-07-11','06:55:00',1.51),('7643','2013-07-11','07:00:00',1.59),('7643','2013-07-11','07:05:00',1.79),('7643','2013-07-11','07:10:00',1.85),('7643','2013-07-11','07:15:00',1.9),('7643','2013-07-11','07:20:00',2.34),('7643','2013-07-11','07:25:00',2.56),('7643','2013-07-11','07:30:00',2.65),('7643','2013-07-11','07:35:00',2.6),('7643','2013-07-11','07:40:00',2.13),('7643','2013-07-11','07:45:00',2.51),('7643','2013-07-11','07:50:00',2.79),('7643','2013-07-11','07:55:00',1.97),('7643','2013-07-11','08:00:00',1.59),('7643','2013-07-11','08:05:00',2.57),('7643','2013-07-11','08:10:00',4.99),('7643','2013-07-11','08:15:00',6.2),('7643','2013-07-11','08:20:00',6.99),('7643','2013-07-11','08:25:00',3.4),('7643','2013-07-11','08:30:00',2.61),('7643','2013-07-11','08:35:00',3.18),('7643','2013-07-11','08:40:00',4.24),('7643','2013-07-11','08:45:00',5.47),('7643','2013-07-11','08:50:00',3.76),('7643','2013-07-11','08:55:00',2.73),('7643','2013-07-11','09:00:00',2.54),('7643','2013-07-11','09:05:00',3.13),('7643','2013-07-11','09:10:00',4.26),('7643','2013-07-11','09:15:00',5.52),('7643','2013-07-11','09:20:00',6.22),('7643','2013-07-11','09:25:00',9.19),('7643','2013-07-11','09:30:00',6.87),('7643','2013-07-11','09:35:00',8.53),('7643','2013-07-11','09:40:00',8.01),('7643','2013-07-11','09:45:00',10.22),('7643','2013-07-11','09:50:00',10.67),('7643','2013-07-11','09:55:00',11.14),('7643','2013-07-11','10:00:00',10.89),('7643','2013-07-11','10:05:00',11.71),('7643','2013-07-11','10:10:00',10.6),('7643','2013-07-11','10:15:00',4.72),('7643','2013-07-11','10:20:00',4.46),('7643','2013-07-11','10:25:00',6.72),('7643','2013-07-11','10:30:00',9.09),('7643','2013-07-11','10:35:00',8.33),('7643','2013-07-11','10:40:00',3.46),('7643','2013-07-11','10:45:00',3.2),('7643','2013-07-11','10:50:00',4.03),('7643','2013-07-11','10:55:00',12.13),('7643','2013-07-11','11:00:00',15.86),('7643','2013-07-11','11:05:00',8.38),('7643','2013-07-11','11:10:00',6.03),('7643','2013-07-11','11:15:00',12.11),('7643','2013-07-11','11:20:00',8.25),('7643','2013-07-11','11:25:00',11.84),('7643','2013-07-11','11:30:00',16.51),('7643','2013-07-11','11:35:00',12.31),('7643','2013-07-11','11:40:00',8.8),('7643','2013-07-11','11:45:00',10.61),('7643','2013-07-11','11:50:00',9.12),('7643','2013-07-11','11:55:00',15.37),('7643','2013-07-11','12:00:00',16.48),('7643','2013-07-11','12:05:00',14.59),('7643','2013-07-11','12:10:00',11.56),('7643','2013-07-11','12:15:00',6.09),('7643','2013-07-11','12:20:00',15.04),('7643','2013-07-11','12:25:00',16.72),('7643','2013-07-11','12:30:00',14.84),('7643','2013-07-11','12:35:00',17.79),('7643','2013-07-11','12:40:00',7.95),('7643','2013-07-11','12:45:00',14.29),('7643','2013-07-11','12:50:00',12.51),('7643','2013-07-11','12:55:00',13.28),('7643','2013-07-11','13:00:00',16.89),('7643','2013-07-11','13:05:00',15.13),('7643','2013-07-11','13:10:00',16.53),('7643','2013-07-11','13:15:00',16.45),('7643','2013-07-11','13:20:00',16.45),('7643','2013-07-11','13:25:00',16.03),('7643','2013-07-11','13:30:00',15.66),('7643','2013-07-11','13:35:00',16.06),('7643','2013-07-11','13:40:00',15.59),('7643','2013-07-11','13:45:00',16.14),('7643','2013-07-11','13:50:00',14.39),('7643','2013-07-11','13:55:00',16.61),('7643','2013-07-11','14:00:00',15.17),('7643','2013-07-11','14:05:00',16.86),('7643','2013-07-11','14:10:00',12.58),('7643','2013-07-11','14:15:00',12.55),('7643','2013-07-11','14:20:00',17.14),('7643','2013-07-11','14:25:00',16.55),('7643','2013-07-11','14:30:00',15.87),('7643','2013-07-11','14:35:00',15.13),('7643','2013-07-11','14:40:00',15.01),('7643','2013-07-11','14:45:00',14.95),('7643','2013-07-11','14:50:00',14.79),('7643','2013-07-11','14:55:00',14.98),('7643','2013-07-11','15:00:00',14.64),('7643','2013-07-11','15:05:00',14.45),('7643','2013-07-11','15:10:00',14.59),('7643','2013-07-11','15:15:00',14.38),('7643','2013-07-11','15:20:00',14.22),('7643','2013-07-11','15:25:00',13.99),('7643','2013-07-11','15:30:00',13.8),('7643','2013-07-11','15:35:00',13.47),('7643','2013-07-11','15:40:00',13.75),('7643','2013-07-11','15:45:00',13.48),('7643','2013-07-11','15:50:00',13.04),('7643','2013-07-11','15:55:00',12.92),('7643','2013-07-11','16:00:00',12.73),('7643','2013-07-11','16:05:00',12.33),('7643','2013-07-11','16:10:00',12.19),('7643','2013-07-11','16:15:00',12.02),('7643','2013-07-11','16:20:00',11.82),('7643','2013-07-11','16:25:00',11.65),('7643','2013-07-11','16:30:00',11.34),('7643','2013-07-11','16:35:00',11.12),('7643','2013-07-11','16:40:00',10.78),('7643','2013-07-11','16:45:00',10.61),('7643','2013-07-11','16:50:00',10.36),('7643','2013-07-11','16:55:00',10.05),('7643','2013-07-11','17:00:00',9.74),('7643','2013-07-11','17:05:00',9.46),('7643','2013-07-11','17:10:00',9.17),('7643','2013-07-11','17:15:00',8.86),('7643','2013-07-11','17:20:00',8.37),('7643','2013-07-11','17:25:00',7.98),('7643','2013-07-11','17:30:00',7.75),('7643','2013-07-11','17:35:00',7.43),('7643','2013-07-11','17:40:00',7.14),('7643','2013-07-11','17:45:00',6.76),('7643','2013-07-11','17:50:00',6.53),('7643','2013-07-11','17:55:00',6.35),('7643','2013-07-11','18:00:00',5.93),('7643','2013-07-11','18:05:00',5.63),('7643','2013-07-11','18:10:00',5.29),('7643','2013-07-11','18:15:00',4.93),('7643','2013-07-11','18:20:00',4.66),('7643','2013-07-11','18:25:00',4.43),('7643','2013-07-11','18:30:00',4.09),('7643','2013-07-11','18:35:00',3.82),('7643','2013-07-11','18:40:00',3.53),('7643','2013-07-11','18:45:00',3.22),('7643','2013-07-11','18:50:00',2.85),('7643','2013-07-11','18:55:00',2.53),('7643','2013-07-11','19:00:00',2.26),('7643','2013-07-11','19:05:00',2.03),('7643','2013-07-11','19:10:00',1.76),('7643','2013-07-11','19:15:00',1.59),('7643','2013-07-11','19:20:00',1.32),('7643','2013-07-11','19:30:00',1.08),('7643','2013-07-10','06:45:00',1.01),('7643','2013-07-10','06:50:00',1.18),('7643','2013-07-10','06:55:00',1.34),('7643','2013-07-10','07:00:00',1.51),('7643','2013-07-10','07:05:00',1.7),('7643','2013-07-10','07:10:00',1.88),('7643','2013-07-10','07:15:00',2.15),('7643','2013-07-10','07:20:00',2.4),('7643','2013-07-10','07:25:00',2.67),('7643','2013-07-10','07:30:00',2.94),('7643','2013-07-10','07:35:00',3.22),('7643','2013-07-10','07:40:00',3.55),('7643','2013-07-10','07:45:00',3.72),('7643','2013-07-10','07:50:00',4.04),('7643','2013-07-10','07:55:00',4.36),('7643','2013-07-10','08:00:00',4.67),('7643','2013-07-10','08:05:00',5),('7643','2013-07-10','08:10:00',5.22),('7643','2013-07-10','08:15:00',5.54),('7643','2013-07-10','08:20:00',5.91),('7643','2013-07-10','08:25:00',6.19),('7643','2013-07-10','08:30:00',6.48),('7643','2013-07-10','08:35:00',6.71),('7643','2013-07-10','08:40:00',6.88),('7643','2013-07-10','08:45:00',7.37),('7643','2013-07-10','08:50:00',7.81),('7643','2013-07-10','08:55:00',7.82),('7643','2013-07-10','09:00:00',8.36),('7643','2013-07-10','09:05:00',8.56),('7643','2013-07-10','09:10:00',9.02),('7643','2013-07-10','09:15:00',9.28),('7643','2013-07-10','09:20:00',8.41),('7643','2013-07-10','09:25:00',9.44),('7643','2013-07-10','09:30:00',6.84),('7643','2013-07-10','09:35:00',8),('7643','2013-07-10','09:40:00',11.06),('7643','2013-07-10','09:45:00',10.3),('7643','2013-07-10','09:50:00',9.38),('7643','2013-07-10','09:55:00',7.1),('7643','2013-07-10','10:00:00',5.58),('7643','2013-07-10','10:05:00',9.44),('7643','2013-07-10','10:10:00',11.19),('7643','2013-07-10','10:15:00',11.89),('7643','2013-07-10','10:20:00',12.89),('7643','2013-07-10','10:25:00',13.21),('7643','2013-07-10','10:30:00',9.23),('7643','2013-07-10','10:35:00',4.6),('7643','2013-07-10','10:40:00',4.52),('7643','2013-07-10','10:45:00',4.64),('7643','2013-07-10','10:50:00',13),('7643','2013-07-10','10:55:00',14.93),('7643','2013-07-10','11:00:00',11.51),('7643','2013-07-10','11:05:00',5.73),('7643','2013-07-10','11:10:00',15.65),('7643','2013-07-10','11:15:00',16.03),('7643','2013-07-10','11:20:00',12.08),('7643','2013-07-10','11:25:00',14.62),('7643','2013-07-10','11:30:00',15.5),('7643','2013-07-10','11:35:00',13.54),('7643','2013-07-10','11:40:00',6.43),('7643','2013-07-10','11:45:00',14.1),('7643','2013-07-10','11:50:00',13.73),('7643','2013-07-10','11:55:00',11.35),('7643','2013-07-10','12:00:00',12.21),('7643','2013-07-10','12:05:00',12.74),('7643','2013-07-10','12:10:00',4.48),('7643','2013-07-10','12:15:00',8.99),('7643','2013-07-10','12:20:00',16.31),('7643','2013-07-10','12:25:00',17.19),('7643','2013-07-10','12:30:00',16.95),('7643','2013-07-10','12:35:00',17.03),('7643','2013-07-10','12:40:00',16.89),('7643','2013-07-10','12:45:00',16.74),('7643','2013-07-10','12:50:00',17.05),('7643','2013-07-10','12:55:00',12.91),('7643','2013-07-10','13:00:00',15.28),('7643','2013-07-10','13:05:00',7.32),('7643','2013-07-10','13:10:00',15.82),('7643','2013-07-10','13:15:00',16.67),('7643','2013-07-10','13:20:00',16.73),('7643','2013-07-10','13:25:00',16.39),('7643','2013-07-10','13:30:00',16.62),('7643','2013-07-10','13:35:00',17.04),('7643','2013-07-10','13:40:00',16.79),('7643','2013-07-10','13:45:00',15.37),('7643','2013-07-10','13:50:00',11.13),('7643','2013-07-10','13:55:00',5.14),('7643','2013-07-10','14:00:00',13.81),('7643','2013-07-10','14:05:00',17.13),('7643','2013-07-10','14:10:00',16.37),('7643','2013-07-10','14:15:00',16.65),('7643','2013-07-10','14:20:00',15.79),('7643','2013-07-10','14:25:00',15.66),('7643','2013-07-10','14:30:00',13.04),('7643','2013-07-10','14:35:00',15.76),('7643','2013-07-10','14:40:00',15.64),('7643','2013-07-10','14:45:00',16.08),('7643','2013-07-10','14:50:00',15.31),('7643','2013-07-10','14:55:00',8.04),('7643','2013-07-10','15:00:00',14.33),('7643','2013-07-10','15:05:00',15.19),('7643','2013-07-10','15:10:00',9.13),('7643','2013-07-10','15:15:00',7.7),('7643','2013-07-10','15:20:00',11.52),('7643','2013-07-10','15:25:00',10.84),('7643','2013-07-10','15:30:00',10.24),('7643','2013-07-10','15:35:00',14.26),('7643','2013-07-10','15:40:00',11.04),('7643','2013-07-10','15:45:00',8.73),('7643','2013-07-10','15:50:00',10.78),('7643','2013-07-10','15:55:00',6.57),('7643','2013-07-10','16:00:00',9.62),('7643','2013-07-10','16:05:00',13.45),('7643','2013-07-10','16:10:00',9.47),('7643','2013-07-10','16:15:00',12.57),('7643','2013-07-10','16:20:00',12.37),('7643','2013-07-10','16:25:00',9.86),('7643','2013-07-10','16:30:00',12.18),('7643','2013-07-10','16:35:00',12.02),('7643','2013-07-10','16:40:00',11.76),('7643','2013-07-10','16:45:00',9.3),('7643','2013-07-10','16:50:00',11.5),('7643','2013-07-10','16:55:00',10.17),('7643','2013-07-10','17:00:00',9.63),('7643','2013-07-10','17:05:00',10.45),('7643','2013-07-10','17:10:00',10.08),('7643','2013-07-10','17:15:00',7.22),('7643','2013-07-10','17:20:00',10.01),('7643','2013-07-10','17:25:00',5.99),('7643','2013-07-10','17:30:00',9.04),('7643','2013-07-10','17:35:00',7.42),('7643','2013-07-10','17:40:00',6.89),('7643','2013-07-10','17:45:00',7.3),('7643','2013-07-10','17:50:00',7.06),('7643','2013-07-10','17:55:00',6.77),('7643','2013-07-10','18:00:00',7.37),('7643','2013-07-10','18:05:00',5.37),('7643','2013-07-10','18:10:00',5.67),('7643','2013-07-10','18:15:00',5.77),('7643','2013-07-10','18:20:00',4.31),('7643','2013-07-10','18:25:00',4.32),('7643','2013-07-10','18:30:00',4.42),('7643','2013-07-10','18:35:00',4.15),('7643','2013-07-10','18:40:00',2.86),('7643','2013-07-10','18:45:00',2.49),('7643','2013-07-10','18:50:00',2.09),('7643','2013-07-10','18:55:00',1.75),('7643','2013-07-10','19:00:00',2.32),('7643','2013-07-10','19:05:00',1.88),('7643','2013-07-10','19:10:00',1.57),('7643','2013-07-10','19:15:00',1.54),('7643','2013-07-10','19:20:00',1.34),('7643','2013-07-10','19:25:00',1.2),('7643','2014-05-02','07:05:00',1.52),('7643','2014-05-02','07:10:00',1.8),('7643','2014-05-02','07:15:00',2.1),('7643','2014-05-02','07:20:00',2.41),('7643','2014-05-02','07:25:00',2.76),('7643','2014-05-02','07:30:00',3.13),('7643','2014-05-02','07:35:00',3.51),('7643','2014-05-02','07:40:00',3.95),('7643','2014-05-02','07:45:00',4.37),('7643','2014-05-02','07:50:00',4.82),('7643','2014-05-02','07:55:00',5.43),('7643','2014-05-02','08:00:00',5.67),('7643','2014-05-02','08:05:00',6.69),('7643','2014-05-02','08:10:00',6.54),('7643','2014-05-02','08:15:00',7.03),('7643','2014-05-02','08:20:00',4.53),('7643','2014-05-02','08:25:00',4.01),('7643','2014-05-02','08:30:00',4.08),('7643','2014-05-02','08:35:00',4.11),('7643','2014-05-02','08:40:00',6.14),('7643','2014-05-02','08:45:00',8.81),('7643','2014-05-02','08:50:00',10.24),('7643','2014-05-02','08:55:00',10.72),('7643','2014-05-02','09:00:00',12.21),('7643','2014-05-02','09:05:00',10.15),('7643','2014-05-02','09:10:00',5.58),('7643','2014-05-02','09:15:00',6.63),('7643','2014-05-02','09:20:00',9.23),('7643','2014-05-02','09:25:00',12.01),('7643','2014-05-02','09:30:00',13.9),('7643','2014-05-02','09:35:00',8.56),('7643','2014-05-02','09:40:00',4.88),('7643','2014-05-02','09:45:00',10.95),('7643','2014-05-02','09:50:00',6.44),('7643','2014-05-02','09:55:00',14.77),('7643','2014-05-02','10:00:00',14.32),('7643','2014-05-02','10:05:00',14.31),('7643','2014-05-02','10:10:00',14.85),('7643','2014-05-02','10:15:00',12.11),('7643','2014-05-02','10:20:00',11.88),('7643','2014-05-02','10:25:00',17.83),('7643','2014-05-02','10:30:00',6.33),('7643','2014-05-02','10:35:00',3.57),('7643','2014-05-02','10:40:00',4.09),('7643','2014-05-02','10:45:00',6.85),('7643','2014-05-02','10:50:00',4.64),('7643','2014-05-02','10:55:00',9.08),('7643','2014-05-02','11:00:00',5.32),('7643','2014-05-02','11:05:00',15.34),('7643','2014-05-02','11:10:00',19.71),('7643','2014-05-02','11:15:00',10.96),('7643','2014-05-02','11:20:00',13.96),('7643','2014-05-02','11:25:00',15.74),('7643','2014-05-02','11:30:00',15.93),('7643','2014-05-02','11:35:00',10.25),('7643','2014-05-02','11:40:00',11.79),('7643','2014-05-02','11:45:00',8.76),('7643','2014-05-02','11:50:00',8.78),('7643','2014-05-02','11:55:00',8.59),('7643','2014-05-02','12:00:00',7.19),('7643','2014-05-02','12:05:00',6.17),('7643','2014-05-02','12:10:00',5.62),('7643','2014-05-02','12:15:00',5.04),('7643','2014-05-02','12:20:00',4.64),('7643','2014-05-02','12:25:00',5.1),('7643','2014-05-02','12:30:00',7.07),('7643','2014-05-02','12:35:00',8.4),('7643','2014-05-02','12:40:00',7.55),('7643','2014-05-02','12:45:00',7.66),('7643','2014-05-02','12:50:00',7.45),('7643','2014-05-02','12:55:00',7.51),('7643','2014-05-02','13:00:00',7.58),('7643','2014-05-02','13:05:00',8.1),('7643','2014-05-02','13:10:00',12.57),('7643','2014-05-02','13:15:00',9.59),('7643','2014-05-02','13:20:00',10.58),('7643','2014-05-02','13:25:00',11.73),('7643','2014-05-02','13:30:00',11.23),('7643','2014-05-02','13:35:00',7.67),('7643','2014-05-02','13:40:00',6.65),('7643','2014-05-02','13:45:00',6.57),('7643','2014-05-02','13:50:00',6.67),('7643','2014-05-02','13:55:00',6.8),('7643','2014-05-02','14:00:00',6.79),('7643','2014-05-02','14:05:00',6.99),('7643','2014-05-02','14:10:00',7.77),('7643','2014-05-02','14:15:00',9.41),('7643','2014-05-02','14:20:00',12.09),('7643','2014-05-02','14:25:00',15.49),('7643','2014-05-02','14:30:00',7.18),('7643','2014-05-02','14:35:00',6.26),('7643','2014-05-02','14:40:00',5.01),('7643','2014-05-02','14:45:00',2.78),('7643','2014-05-02','14:50:00',3.09),('7643','2014-05-02','14:55:00',12.87),('7643','2014-05-02','15:00:00',7.43),('7643','2014-05-02','15:05:00',5.02),('7643','2014-05-02','15:10:00',3.8),('7643','2014-05-02','15:15:00',2.62),('7643','2014-05-02','15:20:00',2.19),('7643','2014-05-02','15:25:00',2.1),('7643','2014-05-02','15:30:00',2.12),('7643','2014-05-02','15:35:00',2.13),('7643','2014-05-02','15:40:00',2.09),('7643','2014-05-02','15:45:00',1.82),('7643','2014-05-02','15:50:00',1.46),('7643','2014-05-02','15:55:00',1.26),('7643','2014-05-02','16:00:00',1.13),('7643','2014-05-02','16:05:00',1.12),('7643','2014-05-02','16:10:00',1.26),('7643','2014-05-02','16:15:00',1.54),('7643','2014-05-02','16:20:00',1.87),('7643','2014-05-02','16:25:00',2.24),('7643','2014-05-02','16:30:00',2.58),('7643','2014-05-02','16:35:00',2.9),('7643','2014-05-02','16:40:00',3.23),('7643','2014-05-02','16:45:00',3.49),('7643','2014-05-02','16:50:00',3.6),('7643','2014-05-02','16:55:00',3.62),('7643','2014-05-02','17:00:00',3.66),('7643','2014-05-02','17:05:00',3.65),('7643','2014-05-02','17:10:00',3.67),('7643','2014-05-02','17:15:00',3.64),('7643','2014-05-02','17:20:00',3.58),('7643','2014-05-02','17:25:00',3.59),('7643','2014-05-02','17:30:00',3.5),('7643','2014-05-02','17:35:00',3.3),('7643','2014-05-02','17:40:00',3.31),('7643','2014-05-02','17:45:00',3.47),('7643','2014-05-02','17:50:00',4),('7643','2014-05-02','17:55:00',4.19),('7643','2014-05-02','18:00:00',3.47),('7643','2014-05-02','18:05:00',2.93),('7643','2014-05-02','18:10:00',3.39),('7643','2014-05-02','18:15:00',2.35),('7643','2014-05-02','18:20:00',1.95),('7643','2014-05-02','18:25:00',1.95),('7643','2014-05-02','18:30:00',1.78),('7643','2014-05-02','18:35:00',1.51),('7643','2014-05-02','18:40:00',1.79),('7643','2014-05-02','18:45:00',2.19),('7643','2014-05-02','18:50:00',1.89),('7643','2014-05-02','18:55:00',1.75),('7643','2014-05-02','19:00:00',1.35),('7643','2014-05-02','19:05:00',1.02),('7643','2014-04-05','07:30:00',1),('7643','2014-04-05','07:45:00',1.1),('7643','2014-04-05','07:50:00',2.17),('7643','2014-04-05','07:55:00',1.92),('7643','2014-04-05','08:00:00',1.45),('7643','2014-04-05','08:10:00',1.75),('7643','2014-04-05','08:15:00',4.74),('7643','2014-04-05','08:20:00',5.05),('7643','2014-04-05','08:25:00',5.54),('7643','2014-04-05','08:30:00',5.86),('7643','2014-04-05','08:35:00',6.32),('7643','2014-04-05','08:40:00',6.78),('7643','2014-04-05','08:45:00',6.98),('7643','2014-04-05','08:50:00',6.82),('7643','2014-04-05','08:55:00',4.25),('7643','2014-04-05','09:00:00',6.43),('7643','2014-04-05','09:05:00',8),('7643','2014-04-05','09:10:00',8),('7643','2014-04-05','09:15:00',9.74),('7643','2014-04-05','09:20:00',7.1),('7643','2014-04-05','09:25:00',7.51),('7643','2014-04-05','09:30:00',7.31),('7643','2014-04-05','09:35:00',9.74),('7643','2014-04-05','09:40:00',10.25),('7643','2014-04-05','09:45:00',13.9),('7643','2014-04-05','09:50:00',14.43),('7643','2014-04-05','09:55:00',14.2),('7643','2014-04-05','10:00:00',13.23),('7643','2014-04-05','10:05:00',9.19),('7643','2014-04-05','10:10:00',9.81),('7643','2014-04-05','10:15:00',7.06),('7643','2014-04-05','10:20:00',5.56),('7643','2014-04-05','10:25:00',4.78),('7643','2014-04-05','10:30:00',5.29),('7643','2014-04-05','10:35:00',5.92),('7643','2014-04-05','10:40:00',6.31),('7643','2014-04-05','10:45:00',13.96),('7643','2014-04-05','10:50:00',12.11),('7643','2014-04-05','10:55:00',6.18),('7643','2014-04-05','11:00:00',9.32),('7643','2014-04-05','11:05:00',8.54),('7643','2014-04-05','11:10:00',12.71),('7643','2014-04-05','11:15:00',12.09),('7643','2014-04-05','11:20:00',16.39),('7643','2014-04-05','11:25:00',16.13),('7643','2014-04-05','11:30:00',16.68),('7643','2014-04-05','11:35:00',17.55),('7643','2014-04-05','11:40:00',17.32),('7643','2014-04-05','11:45:00',16.97),('7643','2014-04-05','11:50:00',17.23),('7643','2014-04-05','11:55:00',17.33),('7643','2014-04-05','12:00:00',16.82),('7643','2014-04-05','12:05:00',16.64),('7643','2014-04-05','12:10:00',16.57),('7643','2014-04-05','12:15:00',17.17),('7643','2014-04-05','12:20:00',12.24),('7643','2014-04-05','12:25:00',14.85),('7643','2014-04-05','12:30:00',13.55),('7643','2014-04-05','12:35:00',13.93),('7643','2014-04-05','12:40:00',13.42),('7643','2014-04-05','12:45:00',9.6),('7643','2014-04-05','12:50:00',6.37),('7643','2014-04-05','12:55:00',11.34),('7643','2014-04-05','13:00:00',17.8),('7643','2014-04-05','13:05:00',15.78),('7643','2014-04-05','13:10:00',18.56),('7643','2014-04-05','13:15:00',17.32),('7643','2014-04-05','13:20:00',8.2),('7643','2014-04-05','13:25:00',5.19),('7643','2014-04-05','13:30:00',16.25),('7643','2014-04-05','13:35:00',6.85),('7643','2014-04-05','13:40:00',13.89),('7643','2014-04-05','13:45:00',18.13),('7643','2014-04-05','13:50:00',17.19),('7643','2014-04-05','13:55:00',17.17),('7643','2014-04-05','14:00:00',16.8),('7643','2014-04-05','14:05:00',16.7),('7643','2014-04-05','14:10:00',16.81),('7643','2014-04-05','14:15:00',17.17),('7643','2014-04-05','14:20:00',15.84),('7643','2014-04-05','14:25:00',10.68),('7643','2014-04-05','14:30:00',4.17),('7643','2014-04-05','14:35:00',11.81),('7643','2014-04-05','14:40:00',11.22),('7643','2014-04-05','14:45:00',18.29),('7643','2014-04-05','14:50:00',10.29),('7643','2014-04-05','14:55:00',10.31),('7643','2014-04-05','15:00:00',10.54),('7643','2014-04-05','15:05:00',5.6),('7643','2014-04-05','15:10:00',11.41),('7643','2014-04-05','15:15:00',11.8),('7643','2014-04-05','15:20:00',6.82),('7643','2014-04-05','15:25:00',4.07),('7643','2014-04-05','15:30:00',3.2),('7643','2014-04-05','15:35:00',2.6),('7643','2014-04-05','15:40:00',2.72),('7643','2014-04-05','15:45:00',3.57),('7643','2014-04-05','15:50:00',5.16),('7643','2014-04-05','15:55:00',16.19),('7643','2014-04-05','16:00:00',12.53),('7643','2014-04-05','16:05:00',3.97),('7643','2014-04-05','16:10:00',5.86),('7643','2014-04-05','16:15:00',2.44),('7643','2014-04-05','16:20:00',2.05),('7643','2014-04-05','16:25:00',3.09),('7643','2014-04-05','16:30:00',3.38),('7643','2014-04-05','16:35:00',8.45),('7643','2014-04-05','16:40:00',8.17),('7643','2014-04-05','16:45:00',12.12),('7643','2014-04-05','16:50:00',11.69),('7643','2014-04-05','16:55:00',6.3),('7643','2014-04-05','17:00:00',2.98),('7643','2014-04-05','17:05:00',2.95),('7643','2014-04-05','17:10:00',2.47),('7643','2014-04-05','17:15:00',2.09),('7643','2014-04-05','17:20:00',3.24),('7643','2014-04-05','17:25:00',7.34),('7643','2014-04-05','17:30:00',7.12),('7643','2014-04-05','17:35:00',6.27),('7643','2014-04-05','17:40:00',4.3),('7643','2014-04-05','17:45:00',5.53),('7643','2014-04-05','17:50:00',5.61),('7643','2014-04-05','17:55:00',5.08),('7643','2014-04-05','18:00:00',4.64),('7643','2014-04-05','18:05:00',4.25),('7643','2014-04-05','18:10:00',3.9),('7643','2014-04-05','18:15:00',3.72),('7643','2014-04-05','18:20:00',3.69),('7643','2014-04-05','18:25:00',3.09),('7643','2014-04-05','18:30:00',1.62),('7643','2014-04-05','18:35:00',1.53),('7643','2014-04-05','18:40:00',1.38),('7643','2014-04-05','18:45:00',1.1),('7643','2013-07-09','06:50:00',1.1),('7643','2013-07-09','06:55:00',1.31),('7643','2013-07-09','07:00:00',1.51),('7643','2013-07-09','07:05:00',1.8),('7643','2013-07-09','07:10:00',2.15),('7643','2013-07-09','07:15:00',2.55),('7643','2013-07-09','07:20:00',3.18),('7643','2013-07-09','07:25:00',3.91),('7643','2013-07-09','07:30:00',4.43),('7643','2013-07-09','07:35:00',5.01),('7643','2013-07-09','07:40:00',5.6),('7643','2013-07-09','07:45:00',5.91),('7643','2013-07-09','07:50:00',6.4),('7643','2013-07-09','07:55:00',6.99),('7643','2013-07-09','08:00:00',7.3),('7643','2013-07-09','08:05:00',5.07),('7643','2013-07-09','08:10:00',6.63),('7643','2013-07-09','08:15:00',6.73),('7643','2013-07-09','08:20:00',7.19),('7643','2013-07-09','08:25:00',8.9),('7643','2013-07-09','08:30:00',8.43),('7643','2013-07-09','08:35:00',6.52),('7643','2013-07-09','08:40:00',8.58),('7643','2013-07-09','08:45:00',8.59),('7643','2013-07-09','08:50:00',8.45),('7643','2013-07-09','08:55:00',8.7),('7643','2013-07-09','09:00:00',8.92),('7643','2013-07-09','09:05:00',9.37),('7643','2013-07-09','09:10:00',9.75),('7643','2013-07-09','09:15:00',10.16),('7643','2013-07-09','09:20:00',10.36),('7643','2013-07-09','09:25:00',10.61),('7643','2013-07-09','09:30:00',10.54),('7643','2013-07-09','09:35:00',10.4),('7643','2013-07-09','09:40:00',10.81),('7643','2013-07-09','09:45:00',11.03),('7643','2013-07-09','09:50:00',11.19),('7643','2013-07-09','09:55:00',10.98),('7643','2013-07-09','10:00:00',11.19),('7643','2013-07-09','10:05:00',11.79),('7643','2013-07-09','10:10:00',11.93),('7643','2013-07-09','10:15:00',12.18),('7643','2013-07-09','10:20:00',12.5),('7643','2013-07-09','10:25:00',12.69),('7643','2013-07-09','10:30:00',12.77),('7643','2013-07-09','10:35:00',13.03),('7643','2013-07-09','10:40:00',13.09),('7643','2013-07-09','10:45:00',13.32),('7643','2013-07-09','10:50:00',13.45),('7643','2013-07-09','10:55:00',13.48),('7643','2013-07-09','11:00:00',13.65),('7643','2013-07-09','11:05:00',13.75),('7643','2013-07-09','11:10:00',13.79),('7643','2013-07-09','11:15:00',13.95),('7643','2013-07-09','11:20:00',14),('7643','2013-07-09','11:25:00',14.13),('7643','2013-07-09','11:30:00',14.14),('7643','2013-07-09','11:35:00',14.32),('7643','2013-07-09','11:40:00',14.43),('7643','2013-07-09','11:45:00',14.55),('7643','2013-07-09','11:50:00',14.72),('7643','2013-07-09','11:55:00',14.92),('7643','2013-07-09','12:00:00',14.98),('7643','2013-07-09','12:05:00',15.16),('7643','2013-07-09','12:10:00',15.2),('7643','2013-07-09','12:15:00',15.28),('7643','2013-07-09','12:20:00',15.37),('7643','2013-07-09','12:25:00',15.42),('7643','2013-07-09','12:30:00',15.58),('7643','2013-07-09','12:35:00',15.71),('7643','2013-07-09','12:40:00',15.8),('7643','2013-07-09','12:45:00',15.94),('7643','2013-07-09','12:50:00',15.76),('7643','2013-07-09','12:55:00',15.69),('7643','2013-07-09','13:00:00',15.81),('7643','2013-07-09','13:05:00',15.88),('7643','2013-07-09','13:10:00',15.98),('7643','2013-07-09','13:15:00',15.95),('7643','2013-07-09','13:20:00',15.81),('7643','2013-07-09','13:25:00',15.89),('7643','2013-07-09','13:30:00',15.9),('7643','2013-07-09','13:35:00',15.9),('7643','2013-07-09','13:40:00',15.95),('7643','2013-07-09','13:45:00',16.09),('7643','2013-07-09','13:50:00',16.09),('7643','2013-07-09','13:55:00',16.04),('7643','2013-07-09','14:00:00',16.04),('7643','2013-07-09','14:05:00',15.94),('7643','2013-07-09','14:10:00',15.87),('7643','2013-07-09','14:15:00',15.77),('7643','2013-07-09','14:20:00',15.7),('7643','2013-07-09','14:25:00',15.64),('7643','2013-07-09','14:30:00',15.65),('7643','2013-07-09','14:35:00',15.55),('7643','2013-07-09','14:40:00',15.41),('7643','2013-07-09','14:45:00',15.35),('7643','2013-07-09','14:50:00',15.26),('7643','2013-07-09','14:55:00',15.18),('7643','2013-07-09','15:00:00',15.05),('7643','2013-07-09','15:05:00',14.99),('7643','2013-07-09','15:10:00',14.88),('7643','2013-07-09','15:15:00',14.67),('7643','2013-07-09','15:20:00',14.43),('7643','2013-07-09','15:25:00',14.24),('7643','2013-07-09','15:30:00',14.11),('7643','2013-07-09','15:35:00',14.05),('7643','2013-07-09','15:40:00',13.85),('7643','2013-07-09','15:45:00',13.63),('7643','2013-07-09','15:50:00',13.47),('7643','2013-07-09','15:55:00',13.25),('7643','2013-07-09','16:00:00',13.04),('7643','2013-07-09','16:05:00',12.74),('7643','2013-07-09','16:10:00',12.59),('7643','2013-07-09','16:15:00',12.41),('7643','2013-07-09','16:20:00',12.13),('7643','2013-07-09','16:25:00',11.85),('7643','2013-07-09','16:30:00',11.55),('7643','2013-07-09','16:35:00',11.26),('7643','2013-07-09','16:40:00',10.91),('7643','2013-07-09','16:45:00',10.69),('7643','2013-07-09','16:50:00',10.52),('7643','2013-07-09','16:55:00',10.33),('7643','2013-07-09','17:00:00',10.26),('7643','2013-07-09','17:05:00',10.52),('7643','2013-07-09','17:10:00',8.78),('7643','2013-07-09','17:15:00',5.46),('7643','2013-07-09','17:20:00',6.46),('7643','2013-07-09','17:25:00',4),('7643','2013-07-09','17:30:00',2.44),('7643','2013-07-09','17:35:00',7.99),('7643','2013-07-09','17:40:00',7.26),('7643','2013-07-09','17:45:00',6.83),('7643','2013-07-09','17:50:00',6.83),('7643','2013-07-09','17:55:00',6.52),('7643','2013-07-09','18:00:00',5.2),('7643','2013-07-09','18:05:00',3.78),('7643','2013-07-09','18:10:00',4.63),('7643','2013-07-09','18:15:00',2.29),('7643','2013-07-09','18:20:00',2.55),('7643','2013-07-09','18:25:00',3.82),('7643','2013-07-09','18:30:00',2.03),('7643','2013-07-09','18:35:00',1.72),('7643','2013-07-09','18:40:00',1.7),('7643','2013-07-09','18:45:00',1.48),('7643','2013-07-09','18:50:00',1.25),('7643','2013-07-09','18:55:00',1.09),('7643','2013-07-09','19:00:00',1.45),('7643','2013-07-09','19:05:00',2.11),('7643','2013-07-09','19:10:00',2.09),('7643','2013-07-09','19:15:00',1.92),('7643','2013-07-09','19:20:00',1.55),('7643','2013-07-09','19:25:00',1.2),('7643','2013-07-09','19:30:00',1.01),('7643','2013-07-08','06:55:00',1.24),('7643','2013-07-08','07:00:00',1.49),('7643','2013-07-08','07:05:00',1.81),('7643','2013-07-08','07:10:00',2.15),('7643','2013-07-08','07:15:00',2.37),('7643','2013-07-08','07:20:00',2.61),('7643','2013-07-08','07:25:00',2.3),('7643','2013-07-08','07:30:00',1.81),('7643','2013-07-08','07:35:00',3.46),('7643','2013-07-08','07:40:00',3.8),('7643','2013-07-08','07:45:00',3.98),('7643','2013-07-08','07:50:00',4.32),('7643','2013-07-08','07:55:00',4.63),('7643','2013-07-08','08:00:00',4.9),('7643','2013-07-08','08:05:00',5.23),('7643','2013-07-08','08:10:00',5.51),('7643','2013-07-08','08:15:00',5.81),('7643','2013-07-08','08:20:00',6.07),('7643','2013-07-08','08:25:00',6.38),('7643','2013-07-08','08:30:00',6.69),('7643','2013-07-08','08:35:00',7.05),('7643','2013-07-08','08:40:00',7.37),('7643','2013-07-08','08:45:00',7.65),('7643','2013-07-08','08:50:00',7.97),('7643','2013-07-08','08:55:00',8.27),('7643','2013-07-08','09:00:00',8.56),('7643','2013-07-08','09:05:00',8.87),('7643','2013-07-08','09:10:00',9.16),('7643','2013-07-08','09:15:00',9.43),('7643','2013-07-08','09:20:00',9.7),('7643','2013-07-08','09:25:00',9.92),('7643','2013-07-08','09:30:00',10.27),('7643','2013-07-08','09:35:00',10.55),('7643','2013-07-08','09:40:00',10.75),('7643','2013-07-08','09:45:00',10.97),('7643','2013-07-08','09:50:00',11.21),('7643','2013-07-08','09:55:00',11.46),('7643','2013-07-08','10:00:00',11.57),('7643','2013-07-08','10:05:00',11.73),('7643','2013-07-08','10:10:00',11.97),('7643','2013-07-08','10:15:00',12.1),('7643','2013-07-08','10:20:00',12.27),('7643','2013-07-08','10:25:00',12.42),('7643','2013-07-08','10:30:00',12.62),('7643','2013-07-08','10:35:00',12.89),('7643','2013-07-08','10:40:00',13.01),('7643','2013-07-08','10:45:00',13.17),('7643','2013-07-08','10:50:00',13.45),('7643','2013-07-08','10:55:00',13.64),('7643','2013-07-08','11:00:00',13.88),('7643','2013-07-08','11:05:00',13.81),('7643','2013-07-08','11:10:00',13.54),('7643','2013-07-08','11:15:00',12.01),('7643','2013-07-08','11:20:00',13.22),('7643','2013-07-08','11:25:00',12.55),('7643','2013-07-08','11:30:00',6.91),('7643','2013-07-08','11:35:00',10.23),('7643','2013-07-08','11:40:00',12.03),('7643','2013-07-08','11:45:00',15.87),('7643','2013-07-08','11:50:00',16.4),('7643','2013-07-08','11:55:00',16.58),('7643','2013-07-08','12:00:00',16.57),('7643','2013-07-08','12:05:00',16.53),('7643','2013-07-08','12:10:00',15.78),('7643','2013-07-08','12:15:00',14.7),('7643','2013-07-08','12:20:00',15.21),('7643','2013-07-08','12:25:00',15.12),('7643','2013-07-08','12:30:00',15.18),('7643','2013-07-08','12:35:00',15.11),('7643','2013-07-08','12:40:00',15.14),('7643','2013-07-08','12:45:00',15.47),('7643','2013-07-08','12:50:00',15.68),('7643','2013-07-08','12:55:00',15.73),('7643','2013-07-08','13:00:00',15.83),('7643','2013-07-08','13:05:00',15.99),('7643','2013-07-08','13:10:00',16.3),('7643','2013-07-08','13:15:00',16.07),('7643','2013-07-08','13:20:00',16.04),('7643','2013-07-08','13:25:00',16.2),('7643','2013-07-08','13:30:00',16.58),('7643','2013-07-08','13:35:00',15.3),('7643','2013-07-08','13:40:00',14.81),('7643','2013-07-08','13:45:00',13.09),('7643','2013-07-08','13:50:00',11.75),('7643','2013-07-08','13:55:00',11.29),('7643','2013-07-08','14:00:00',12),('7643','2013-07-08','14:05:00',11.35),('7643','2013-07-08','14:10:00',12.87),('7643','2013-07-08','14:15:00',13.64),('7643','2013-07-08','14:20:00',12.47),('7643','2013-07-08','14:25:00',9.07),('7643','2013-07-08','14:30:00',5.46),('7643','2013-07-08','14:35:00',3.97),('7643','2013-07-08','14:40:00',3.64),('7643','2013-07-08','14:45:00',2.96),('7643','2013-07-08','14:50:00',1.18),('7643','2013-07-08','15:15:00',1.12),('7643','2013-07-08','15:20:00',1.12),('7643','2013-07-08','15:25:00',1.2),('7643','2013-07-08','15:30:00',1.07),('7643','2013-07-08','16:15:00',1.09),('7643','2013-07-08','16:20:00',1.25),('7643','2013-07-08','16:25:00',1.38),('7643','2013-07-08','16:30:00',1.48),('7643','2013-07-08','16:35:00',1.56),('7643','2013-07-08','16:40:00',1.63),('7643','2013-07-08','16:45:00',1.65),('7643','2013-07-08','16:50:00',1.64),('7643','2013-07-08','16:55:00',1.62),('7643','2013-07-08','17:00:00',1.63),('7643','2013-07-08','17:05:00',1.64),('7643','2013-07-08','17:10:00',1.64),('7643','2013-07-08','17:15:00',1.67),('7643','2013-07-08','17:20:00',1.78),('7643','2013-07-08','17:25:00',1.98),('7643','2013-07-08','17:30:00',2.14),('7643','2013-07-08','17:35:00',2.21),('7643','2013-07-08','17:40:00',2.12),('7643','2013-07-08','17:45:00',1.85),('7643','2013-07-08','17:50:00',1.54),('7643','2013-07-08','17:55:00',1.37),('7643','2013-07-08','18:00:00',1.3),('7643','2013-07-08','18:05:00',1.23),('7643','2013-07-08','18:10:00',1.13),('7643','2013-07-08','18:15:00',1.1),('7643','2013-07-08','18:20:00',1.07),('7643','2013-07-08','18:25:00',1.02),('7643','2013-07-07','07:05:00',1.17),('7643','2013-07-07','07:10:00',1.23),('7643','2013-07-07','07:20:00',1.11),('7643','2013-07-07','07:25:00',1.33),('7643','2013-07-07','07:30:00',1.57),('7643','2013-07-07','07:35:00',2.7),('7643','2013-07-07','07:40:00',4.9),('7643','2013-07-07','07:45:00',4.52),('7643','2013-07-07','07:50:00',3.65),('7643','2013-07-07','07:55:00',3.96),('7643','2013-07-07','08:00:00',4.05),('7643','2013-07-07','08:05:00',4.5),('7643','2013-07-07','08:10:00',5.07),('7643','2013-07-07','08:15:00',5.76),('7643','2013-07-07','08:20:00',6.15),('7643','2013-07-07','08:25:00',6.45),('7643','2013-07-07','08:30:00',6.78),('7643','2013-07-07','08:35:00',7.12),('7643','2013-07-07','08:40:00',7.46),('7643','2013-07-07','08:45:00',7.72),('7643','2013-07-07','08:50:00',8.02),('7643','2013-07-07','08:55:00',8.23),('7643','2013-07-07','09:00:00',8.53),('7643','2013-07-07','09:05:00',8.8),('7643','2013-07-07','09:10:00',9.01),('7643','2013-07-07','09:15:00',9.17),('7643','2013-07-07','09:20:00',9.42),('7643','2013-07-07','09:25:00',9.42),('7643','2013-07-07','09:30:00',9.99),('7643','2013-07-07','09:35:00',10.65),('7643','2013-07-07','09:40:00',10.93),('7643','2013-07-07','09:45:00',11.11),('7643','2013-07-07','09:50:00',11.18),('7643','2013-07-07','09:55:00',11.53),('7643','2013-07-07','10:00:00',11.78),('7643','2013-07-07','10:05:00',12.01),('7643','2013-07-07','10:10:00',12.04),('7643','2013-07-07','10:15:00',12.36),('7643','2013-07-07','10:20:00',12.46),('7643','2013-07-07','10:25:00',12.75),('7643','2013-07-07','10:30:00',12.94),('7643','2013-07-07','10:35:00',12.96),('7643','2013-07-07','10:40:00',13.16),('7643','2013-07-07','10:45:00',13.32),('7643','2013-07-07','10:50:00',13.38),('7643','2013-07-07','10:55:00',13.5),('7643','2013-07-07','11:00:00',13.63),('7643','2013-07-07','11:05:00',13.84),('7643','2013-07-07','11:10:00',14.06),('7643','2013-07-07','11:15:00',14.25),('7643','2013-07-07','11:20:00',14.53),('7643','2013-07-07','11:25:00',14.63),('7643','2013-07-07','11:30:00',14.81),('7643','2013-07-07','11:35:00',15.03),('7643','2013-07-07','11:40:00',14.22),('7643','2013-07-07','11:45:00',14.96),('7643','2013-07-07','11:50:00',15.19),('7643','2013-07-07','11:55:00',14.94),('7643','2013-07-07','12:00:00',15.28),('7643','2013-07-07','12:05:00',15.75),('7643','2013-07-07','12:10:00',15.96),('7643','2013-07-07','12:15:00',16.16),('7643','2013-07-07','12:20:00',16.63),('7643','2013-07-07','12:25:00',16.25),('7643','2013-07-07','12:30:00',15.03),('7643','2013-07-07','12:35:00',16.22),('7643','2013-07-07','12:40:00',15.97),('7643','2013-07-07','12:45:00',15.92),('7643','2013-07-07','12:50:00',16.03),('7643','2013-07-07','12:55:00',16.29),('7643','2013-07-07','13:00:00',16.72),('7643','2013-07-07','13:05:00',16.22),('7643','2013-07-07','13:10:00',17.23),('7643','2013-07-07','13:15:00',17.26),('7643','2013-07-07','13:20:00',13.04),('7643','2013-07-07','13:25:00',4.57),('7643','2013-07-07','13:30:00',2.69),('7643','2013-07-07','13:35:00',1.55),('7643','2013-07-07','13:40:00',1.27),('7643','2013-07-07','13:45:00',1.31),('7643','2013-07-07','13:50:00',1.45),('7643','2013-07-07','13:55:00',1.7),('7643','2013-07-07','14:00:00',2.19),('7643','2013-07-07','14:05:00',2.71),('7643','2013-07-07','14:10:00',2.89),('7643','2013-07-07','14:15:00',2.94),('7643','2013-07-07','14:20:00',2.97),('7643','2013-07-07','14:25:00',3.15),('7643','2013-07-07','14:30:00',3.51),('7643','2013-07-07','14:35:00',4),('7643','2013-07-07','14:40:00',4.1),('7643','2013-07-07','14:45:00',3.87),('7643','2013-07-07','14:50:00',3.75),('7643','2013-07-07','14:55:00',3.68),('7643','2013-07-07','15:00:00',3.41),('7643','2013-07-07','15:05:00',3.08),('7643','2013-07-07','15:10:00',2.81),('7643','2013-07-07','15:15:00',2.51),('7643','2013-07-07','15:20:00',1.93),('7643','2013-07-07','15:25:00',1.6),('7643','2013-07-07','15:30:00',1.27),('7643','2013-07-07','16:05:00',1.03),('7643','2013-07-07','16:10:00',1.2),('7643','2013-07-07','16:15:00',1.03),('7643','2013-07-07','17:10:00',1.16),('7643','2013-07-07','17:15:00',1.77),('7643','2013-07-07','17:20:00',2.38),('7643','2013-07-07','17:25:00',2.94),('7643','2013-07-07','17:30:00',3.42),('7643','2013-07-07','17:35:00',3.73),('7643','2013-07-07','17:40:00',3.84),('7643','2013-07-07','17:45:00',3.84),('7643','2013-07-07','17:50:00',3.84),('7643','2013-07-07','17:55:00',3.68),('7643','2013-07-07','18:00:00',3.44),('7643','2013-07-07','18:05:00',3.07),('7643','2013-07-07','18:10:00',2.89),('7643','2013-07-07','18:15:00',3.04),('7643','2013-07-07','18:20:00',3.21),('7643','2013-07-07','18:25:00',2.94),('7643','2013-07-07','18:30:00',2.92),('7643','2013-07-07','18:35:00',3.2),('7643','2013-07-07','18:40:00',4.59),('7643','2013-07-07','18:45:00',4.34),('7643','2013-07-07','18:50:00',3.69),('7643','2013-07-07','18:55:00',3.15),('7643','2013-07-07','19:00:00',2.74),('7643','2013-07-07','19:05:00',2.11),('7643','2013-07-07','19:10:00',1.71),('7643','2013-07-07','19:15:00',1.35),('7643','2013-07-07','19:20:00',1.25),('7643','2013-07-06','06:50:00',1.13),('7643','2013-07-06','06:55:00',1.31),('7643','2013-07-06','07:00:00',1.58),('7643','2013-07-06','07:05:00',1.82),('7643','2013-07-06','07:10:00',2.13),('7643','2013-07-06','07:15:00',2.39),('7643','2013-07-06','07:20:00',2.69),('7643','2013-07-06','07:25:00',3.01),('7643','2013-07-06','07:30:00',3.3),('7643','2013-07-06','07:35:00',3.63),('7643','2013-07-06','07:40:00',3.96),('7643','2013-07-06','07:45:00',4.32),('7643','2013-07-06','07:50:00',4.64),('7643','2013-07-06','07:55:00',4.95),('7643','2013-07-06','08:00:00',5.3),('7643','2013-07-06','08:05:00',5.6),('7643','2013-07-06','08:10:00',5.9),('7643','2013-07-06','08:15:00',5.48),('7643','2013-07-06','08:20:00',4.67),('7643','2013-07-06','08:25:00',5.25),('7643','2013-07-06','08:30:00',6.56),('7643','2013-07-06','08:35:00',7.85),('7643','2013-07-06','08:40:00',5.72),('7643','2013-07-06','08:45:00',3),('7643','2013-07-06','08:50:00',7.58),('7643','2013-07-06','08:55:00',8.77),('7643','2013-07-06','09:00:00',9.24),('7643','2013-07-06','09:05:00',8.52),('7643','2013-07-06','09:10:00',8.94),('7643','2013-07-06','09:15:00',9.03),('7643','2013-07-06','09:20:00',5.37),('7643','2013-07-06','09:25:00',8.47),('7643','2013-07-06','09:30:00',10.68),('7643','2013-07-06','09:35:00',10.92),('7643','2013-07-06','09:40:00',10.23),('7643','2013-07-06','09:45:00',12.07),('7643','2013-07-06','09:50:00',11.94),('7643','2013-07-06','09:55:00',12.27),('7643','2013-07-06','10:00:00',12.28),('7643','2013-07-06','10:05:00',11.68),('7643','2013-07-06','10:10:00',12.33),('7643','2013-07-06','10:15:00',12.2),('7643','2013-07-06','10:20:00',11.78),('7643','2013-07-06','10:25:00',11.26),('7643','2013-07-06','10:30:00',11.95),('7643','2013-07-06','10:35:00',13.93),('7643','2013-07-06','10:40:00',12.5),('7643','2013-07-06','10:45:00',13.44),('7643','2013-07-06','10:50:00',13.88),('7643','2013-07-06','10:55:00',13.98),('7643','2013-07-06','11:00:00',14.2),('7643','2013-07-06','11:05:00',14.43),('7643','2013-07-06','11:10:00',14.62),('7643','2013-07-06','11:15:00',14.57),('7643','2013-07-06','11:20:00',13.71),('7643','2013-07-06','11:25:00',12.48),('7643','2013-07-06','11:30:00',13.16),('7643','2013-07-06','11:35:00',12.71),('7643','2013-07-06','11:40:00',13.26),('7643','2013-07-06','11:45:00',10.49),('7643','2013-07-06','11:50:00',10.49),('7643','2013-07-06','11:55:00',7.55),('7643','2013-07-06','12:00:00',9.91),('7643','2013-07-06','12:05:00',14.95),('7643','2013-07-06','12:10:00',15.34),('7643','2013-07-06','12:15:00',16.25),('7643','2013-07-06','12:20:00',15.95),('7643','2013-07-06','12:25:00',14.83),('7643','2013-07-06','12:30:00',15.3),('7643','2013-07-06','12:35:00',15.91),('7643','2013-07-06','12:40:00',16.34),('7643','2013-07-06','12:45:00',16.34),('7643','2013-07-06','12:50:00',15.87),('7643','2013-07-06','12:55:00',16.69),('7643','2013-07-06','13:00:00',15.95),('7643','2013-07-06','13:05:00',15.59),('7643','2013-07-06','13:10:00',16.3),('7643','2013-07-06','13:15:00',15.92),('7643','2013-07-06','13:20:00',16),('7643','2013-07-06','13:25:00',10.22),('7643','2013-07-06','13:30:00',15.76),('7643','2013-07-06','13:35:00',16.61),('7643','2013-07-06','13:40:00',16.73),('7643','2013-07-06','13:45:00',17.16),('7643','2013-07-06','13:50:00',17.55),('7643','2013-07-06','13:55:00',8.36),('7643','2013-07-06','14:00:00',10.37),('7643','2013-07-06','14:05:00',16.15),('7643','2013-07-06','14:10:00',7.91),('7643','2013-07-06','14:15:00',7.85),('7643','2013-07-06','14:20:00',4.12),('7643','2013-07-06','14:25:00',3.44),('7643','2013-07-06','14:30:00',3.18),('7643','2013-07-06','14:35:00',3.04),('7643','2013-07-06','14:40:00',2.85),('7643','2013-07-06','14:45:00',2.66),('7643','2013-07-06','14:50:00',2.61),('7643','2013-07-06','14:55:00',2.89),('7643','2013-07-06','15:00:00',3.47),('7643','2013-07-06','15:05:00',3.96),('7643','2013-07-06','15:10:00',3.39),('7643','2013-07-06','15:15:00',2.46),('7643','2013-07-06','15:20:00',2.59),('7643','2013-07-06','15:25:00',2.26),('7643','2013-07-06','15:30:00',1.55),('7643','2013-07-06','15:35:00',1.09),('7643','2013-07-06','16:30:00',1.21),('7643','2013-07-06','16:35:00',1.59),('7643','2013-07-06','16:40:00',1.87),('7643','2013-07-06','16:45:00',2.15),('7643','2013-07-06','16:50:00',2.59),('7643','2013-07-06','16:55:00',3.06),('7643','2013-07-06','17:00:00',3.38),('7643','2013-07-06','17:05:00',3.59),('7643','2013-07-06','17:10:00',3.71),('7643','2013-07-06','17:15:00',3.79),('7643','2013-07-06','17:20:00',3.8),('7643','2013-07-06','17:25:00',3.72),('7643','2013-07-06','17:30:00',3.59),('7643','2013-07-06','17:35:00',3.37),('7643','2013-07-06','17:40:00',3.22),('7643','2013-07-06','17:45:00',3.16),('7643','2013-07-06','17:50:00',3.1),('7643','2013-07-06','17:55:00',2.99),('7643','2013-07-06','18:00:00',2.92),('7643','2013-07-06','18:05:00',2.9),('7643','2013-07-06','18:10:00',2.83),('7643','2013-07-06','18:15:00',2.78),('7643','2013-07-06','18:20:00',2.8),('7643','2013-07-06','18:25:00',2.72),('7643','2013-07-06','18:30:00',2.58),('7643','2013-07-06','18:35:00',2.39),('7643','2013-07-06','18:40:00',2.21),('7643','2013-07-06','18:45:00',2.05),('7643','2013-07-06','18:50:00',2),('7643','2013-07-06','18:55:00',1.96),('7643','2013-07-06','19:00:00',1.82),('7643','2013-07-06','19:05:00',1.6),('7643','2013-07-06','19:10:00',1.38),('7643','2013-07-06','19:15:00',1.16),('7643','2013-07-05','06:45:00',1.02),('7643','2013-07-05','06:50:00',1.19),('7643','2013-07-05','06:55:00',1.36),('7643','2013-07-05','07:00:00',1.56),('7643','2013-07-05','07:05:00',1.82),('7643','2013-07-05','07:10:00',2.13),('7643','2013-07-05','07:15:00',2.39),('7643','2013-07-05','07:20:00',2.65),('7643','2013-07-05','07:25:00',2.91),('7643','2013-07-05','07:30:00',3.18),('7643','2013-07-05','07:35:00',3.46),('7643','2013-07-05','07:40:00',3.77),('7643','2013-07-05','07:45:00',4.12),('7643','2013-07-05','07:50:00',4.45),('7643','2013-07-05','07:55:00',4.74),('7643','2013-07-05','08:00:00',5.1),('7643','2013-07-05','08:05:00',5.38),('7643','2013-07-05','08:10:00',5.67),('7643','2013-07-05','08:15:00',5.98),('7643','2013-07-05','08:20:00',6.26),('7643','2013-07-05','08:25:00',6.54),('7643','2013-07-05','08:30:00',6.85),('7643','2013-07-05','08:35:00',7.23),('7643','2013-07-05','08:40:00',7.58),('7643','2013-07-05','08:45:00',7.82),('7643','2013-07-05','08:50:00',8.18),('7643','2013-07-05','08:55:00',8.49),('7643','2013-07-05','09:00:00',8.75),('7643','2013-07-05','09:05:00',9.1),('7643','2013-07-05','09:10:00',9.4),('7643','2013-07-05','09:15:00',9.69),('7643','2013-07-05','09:20:00',10.01),('7643','2013-07-05','09:25:00',10.32),('7643','2013-07-05','09:30:00',10.48),('7643','2013-07-05','09:35:00',10.67),('7643','2013-07-05','09:40:00',10.89),('7643','2013-07-05','09:45:00',11.15),('7643','2013-07-05','09:50:00',11.45),('7643','2013-07-05','09:55:00',11.63),('7643','2013-07-05','10:00:00',11.86),('7643','2013-07-05','10:05:00',12.1),('7643','2013-07-05','10:10:00',12.34),('7643','2013-07-05','10:15:00',12.61),('7643','2013-07-05','10:20:00',12.77),('7643','2013-07-05','10:25:00',12.89),('7643','2013-07-05','10:30:00',13.06),('7643','2013-07-05','10:35:00',13.25),('7643','2013-07-05','10:40:00',13.41),('7643','2013-07-05','10:45:00',13.62),('7643','2013-07-05','10:50:00',13.87),('7643','2013-07-05','10:55:00',14.08),('7643','2013-07-05','11:00:00',14.15),('7643','2013-07-05','11:05:00',14.29),('7643','2013-07-05','11:10:00',14.38),('7643','2013-07-05','11:15:00',14.43),('7643','2013-07-05','11:20:00',14.55),('7643','2013-07-05','11:25:00',14.76),('7643','2013-07-05','11:30:00',14.65),('7643','2013-07-05','11:35:00',14.8),('7643','2013-07-05','11:40:00',14.91),('7643','2013-07-05','11:45:00',15.08),('7643','2013-07-05','11:50:00',15.19),('7643','2013-07-05','11:55:00',15.25),('7643','2013-07-05','12:00:00',15.23),('7643','2013-07-05','12:05:00',15.59),('7643','2013-07-05','12:10:00',15.85),('7643','2013-07-05','12:15:00',15.78),('7643','2013-07-05','12:20:00',16.05),('7643','2013-07-05','12:25:00',16.17),('7643','2013-07-05','12:30:00',16.26),('7643','2013-07-05','12:35:00',16.09),('7643','2013-07-05','12:40:00',16.09),('7643','2013-07-05','12:45:00',16.22),('7643','2013-07-05','12:50:00',16.14),('7643','2013-07-05','12:55:00',16.21),('7643','2013-07-05','13:00:00',16.23),('7643','2013-07-05','13:05:00',16.4),('7643','2013-07-05','13:10:00',16.49),('7643','2013-07-05','13:15:00',16.5),('7643','2013-07-05','13:20:00',16.33),('7643','2013-07-05','13:25:00',16.14),('7643','2013-07-05','13:30:00',16.31),('7643','2013-07-05','13:35:00',16.27),('7643','2013-07-05','13:40:00',16.33),('7643','2013-07-05','13:45:00',16.28),('7643','2013-07-05','13:50:00',16.12),('7643','2013-07-05','13:55:00',16.15),('7643','2013-07-05','14:00:00',16.23),('7643','2013-07-05','14:05:00',16.16),('7643','2013-07-05','14:10:00',16.04),('7643','2013-07-05','14:15:00',9.78),('7643','2013-07-05','14:20:00',12.17),('7643','2013-07-05','14:25:00',16.24),('7643','2013-07-05','14:30:00',15.8),('7643','2013-07-05','14:35:00',15.73),('7643','2013-07-05','14:40:00',15.53),('7643','2013-07-05','14:45:00',15.49),('7643','2013-07-05','14:50:00',15.19),('7643','2013-07-05','14:55:00',14.82),('7643','2013-07-05','15:00:00',13.48),('7643','2013-07-05','15:05:00',12.84),('7643','2013-07-05','15:10:00',15.42),('7643','2013-07-05','15:15:00',14.96),('7643','2013-07-05','15:20:00',14.6),('7643','2013-07-05','15:25:00',14.7),('7643','2013-07-05','15:30:00',14.71),('7643','2013-07-05','15:35:00',9.48),('7643','2013-07-05','15:40:00',3.12),('7643','2013-07-05','15:45:00',2.22),('7643','2013-07-05','15:50:00',1.15),('7643','2013-07-05','16:15:00',1.24),('7643','2013-07-05','16:20:00',1.52),('7643','2013-07-05','16:40:00',1.63),('7643','2013-07-05','16:45:00',2.29),('7643','2013-07-05','16:50:00',3.38),('7643','2013-07-05','16:55:00',4.3),('7643','2013-07-05','17:00:00',3.48),('7643','2013-07-05','17:05:00',3.65),('7643','2013-07-05','17:10:00',3.33),('7643','2013-07-05','17:15:00',3.62),('7643','2013-07-05','17:20:00',3.7),('7643','2013-07-05','17:25:00',3.67),('7643','2013-07-05','17:30:00',4.18),('7643','2013-07-05','17:35:00',4.03),('7643','2013-07-05','17:40:00',3.46),('7643','2013-07-05','17:45:00',3.21),('7643','2013-07-05','17:50:00',2.78),('7643','2013-07-05','17:55:00',2.68),('7643','2013-07-05','18:00:00',2.54),('7643','2013-07-05','18:05:00',2.38),('7643','2013-07-05','18:10:00',2.29),('7643','2013-07-05','18:15:00',2.03),('7643','2013-07-05','18:20:00',1.88),('7643','2013-07-05','18:25:00',1.86),('7643','2013-07-05','18:30:00',1.77),('7643','2013-07-05','18:35:00',1.7),('7643','2013-07-05','18:40:00',1.64),('7643','2013-07-05','18:45:00',1.52),('7643','2013-07-05','18:50:00',1.3),('7643','2013-07-05','19:15:00',1.8),('7643','2013-07-05','19:20:00',1.73),('7643','2013-07-05','19:25:00',1.28),('7643','2013-07-05','19:30:00',1.1),('7643','2013-07-04','06:50:00',1.2),('7643','2013-07-04','06:55:00',1.4),('7643','2013-07-04','07:00:00',1.6),('7643','2013-07-04','07:05:00',1.85),('7643','2013-07-04','07:10:00',2.18),('7643','2013-07-04','07:15:00',2.46),('7643','2013-07-04','07:20:00',2.71),('7643','2013-07-04','07:25:00',2.61),('7643','2013-07-04','07:30:00',3.19),('7643','2013-07-04','07:35:00',3.63),('7643','2013-07-04','07:40:00',3.95),('7643','2013-07-04','07:45:00',4.27),('7643','2013-07-04','07:50:00',4.55),('7643','2013-07-04','07:55:00',4.83),('7643','2013-07-04','08:00:00',5.24),('7643','2013-07-04','08:05:00',5.54),('7643','2013-07-04','08:10:00',5.79),('7643','2013-07-04','08:15:00',6.08),('7643','2013-07-04','08:20:00',6.28),('7643','2013-07-04','08:25:00',6.56),('7643','2013-07-04','08:30:00',6.89),('7643','2013-07-04','08:35:00',7.25),('7643','2013-07-04','08:40:00',7.53),('7643','2013-07-04','08:45:00',7.73),('7643','2013-07-04','08:50:00',8.11),('7643','2013-07-04','08:55:00',8.41),('7643','2013-07-04','09:00:00',8.72),('7643','2013-07-04','09:05:00',9.02),('7643','2013-07-04','09:10:00',9.32),('7643','2013-07-04','09:15:00',9.65),('7643','2013-07-04','09:20:00',9.95),('7643','2013-07-04','09:25:00',10.27),('7643','2013-07-04','09:30:00',10.55),('7643','2013-07-04','09:35:00',10.79),('7643','2013-07-04','09:40:00',11.04),('7643','2013-07-04','09:45:00',11.24),('7643','2013-07-04','09:50:00',11.44),('7643','2013-07-04','09:55:00',11.61),('7643','2013-07-04','10:00:00',11.86),('7643','2013-07-04','10:05:00',12.06),('7643','2013-07-04','10:10:00',12.28),('7643','2013-07-04','10:15:00',12.44),('7643','2013-07-04','10:20:00',12.65),('7643','2013-07-04','10:25:00',12.8),('7643','2013-07-04','10:30:00',12.99),('7643','2013-07-04','10:35:00',13.14),('7643','2013-07-04','10:40:00',13.2),('7643','2013-07-04','10:45:00',13.27),('7643','2013-07-04','10:50:00',13.43),('7643','2013-07-04','10:55:00',13.64),('7643','2013-07-04','11:00:00',13.79),('7643','2013-07-04','11:05:00',13.85),('7643','2013-07-04','11:10:00',13.89),('7643','2013-07-04','11:15:00',14.08),('7643','2013-07-04','11:20:00',14.05),('7643','2013-07-04','11:25:00',14.37),('7643','2013-07-04','11:30:00',14.59),('7643','2013-07-04','11:35:00',14.77),('7643','2013-07-04','11:40:00',14.83),('7643','2013-07-04','11:45:00',14.94),('7643','2013-07-04','11:50:00',15.05),('7643','2013-07-04','11:55:00',15.15),('7643','2013-07-04','12:00:00',15.11),('7643','2013-07-04','12:05:00',15.22),('7643','2013-07-04','12:10:00',15.25),('7643','2013-07-04','12:15:00',15.28),('7643','2013-07-04','12:20:00',15.65),('7643','2013-07-04','12:25:00',8.87),('7643','2013-07-04','12:30:00',15.6),('7643','2013-07-04','12:35:00',16.1),('7643','2013-07-04','12:40:00',15.33),('7643','2013-07-04','12:45:00',15.7),('7643','2013-07-04','12:50:00',15.67),('7643','2013-07-04','12:55:00',15.81),('7643','2013-07-04','13:00:00',16.04),('7643','2013-07-04','13:05:00',5.78),('7643','2013-07-04','13:10:00',14.23),('7643','2013-07-04','13:15:00',16.58),('7643','2013-07-04','13:20:00',14.16),('7643','2013-07-04','13:25:00',13.32),('7643','2013-07-04','13:30:00',16.42),('7643','2013-07-04','13:35:00',16.3),('7643','2013-07-04','13:40:00',16.17),('7643','2013-07-04','13:45:00',16.41),('7643','2013-07-04','13:50:00',16.01),('7643','2013-07-04','13:55:00',16.23),('7643','2013-07-04','14:00:00',16.45),('7643','2013-07-04','14:05:00',15.48),('7643','2013-07-04','14:10:00',15.93),('7643','2013-07-04','14:15:00',15.78),('7643','2013-07-04','14:20:00',15.56),('7643','2013-07-04','14:25:00',15.91),('7643','2013-07-04','14:30:00',15.34),('7643','2013-07-04','14:35:00',15.6),('7643','2013-07-04','14:40:00',15.4),('7643','2013-07-04','14:45:00',11.11),('7643','2013-07-04','14:50:00',15.47),('7643','2013-07-04','14:55:00',15.01),('7643','2013-07-04','15:00:00',11.36),('7643','2013-07-04','15:05:00',9.16),('7643','2013-07-04','15:10:00',15.39),('7643','2013-07-04','15:15:00',11.99),('7643','2013-07-04','15:20:00',14.43),('7643','2013-07-04','15:25:00',9.8),('7643','2013-07-04','15:30:00',11.63),('7643','2013-07-04','15:35:00',14.42),('7643','2013-07-04','15:40:00',14.03),('7643','2013-07-04','15:45:00',14.1),('7643','2013-07-04','15:50:00',13.77),('7643','2013-07-04','15:55:00',13.36),('7643','2013-07-04','16:00:00',13.03),('7643','2013-07-04','16:05:00',12.93),('7643','2013-07-04','16:10:00',12.45),('7643','2013-07-04','16:15:00',12.31),('7643','2013-07-04','16:20:00',12.16),('7643','2013-07-04','16:25:00',11.88),('7643','2013-07-04','16:30:00',11.65),('7643','2013-07-04','16:35:00',11.4),('7643','2013-07-04','16:40:00',11.08),('7643','2013-07-04','16:45:00',11),('7643','2013-07-04','16:50:00',10.48),('7643','2013-07-04','16:55:00',10.12),('7643','2013-07-04','17:00:00',8.48),('7643','2013-07-04','17:05:00',9.65),('7643','2013-07-04','17:10:00',9.58),('7643','2013-07-04','17:15:00',9.4),('7643','2013-07-04','17:20:00',9.11),('7643','2013-07-04','17:25:00',8.64),('7643','2013-07-04','17:30:00',8.29),('7643','2013-07-04','17:35:00',7.72),('7643','2013-07-04','17:40:00',7.19),('7643','2013-07-04','17:45:00',6.9),('7643','2013-07-04','17:50:00',6.62),('7643','2013-07-04','17:55:00',6.56),('7643','2013-07-04','18:00:00',6.36),('7643','2013-07-04','18:05:00',5.98),('7643','2013-07-04','18:10:00',5.09),('7643','2013-07-04','18:15:00',1.58),('7643','2013-07-04','18:20:00',3.15),('7643','2013-07-04','18:25:00',1.14),('7643','2013-07-04','18:30:00',1.62),('7643','2013-07-04','18:35:00',3.58),('7643','2013-07-04','18:40:00',3.55),('7643','2013-07-04','18:45:00',3.3),('7643','2013-07-04','18:50:00',2.96),('7643','2013-07-04','18:55:00',2.58),('7643','2013-07-04','19:00:00',2.31),('7643','2013-07-04','19:05:00',2.04),('7643','2013-07-04','19:10:00',1.81),('7643','2013-07-04','19:15:00',1.63),('7643','2013-07-04','19:20:00',1.37),('7643','2013-07-04','19:25:00',1.16),('7643','2013-07-03','07:15:00',1.04),('7643','2013-07-03','07:20:00',1.34),('7643','2013-07-03','07:25:00',1.26),('7643','2013-07-03','07:45:00',1.28),('7643','2013-07-03','07:50:00',1.55),('7643','2013-07-03','07:55:00',1.72),('7643','2013-07-03','08:00:00',1.87),('7643','2013-07-03','08:05:00',1.75),('7643','2013-07-03','08:10:00',1.36),('7643','2013-07-03','08:15:00',1.16),('7643','2013-07-03','08:20:00',1.18),('7643','2013-07-03','08:25:00',1.24),('7643','2013-07-03','08:30:00',1.46),('7643','2013-07-03','08:35:00',1.68),('7643','2013-07-03','08:40:00',1.79),('7643','2013-07-03','08:45:00',2.07),('7643','2013-07-03','08:50:00',2.74),('7643','2013-07-03','08:55:00',3.46),('7643','2013-07-03','09:00:00',3.43),('7643','2013-07-03','09:05:00',2.83),('7643','2013-07-03','09:10:00',2.49),('7643','2013-07-03','09:15:00',2.56),('7643','2013-07-03','09:20:00',2.47),('7643','2013-07-03','09:25:00',2.68),('7643','2013-07-03','09:30:00',2.82),('7643','2013-07-03','09:35:00',2.77),('7643','2013-07-03','09:40:00',2.33),('7643','2013-07-03','09:45:00',1.9),('7643','2013-07-03','09:50:00',1.66),('7643','2013-07-03','09:55:00',1.52),('7643','2013-07-03','10:00:00',1.46),('7643','2013-07-03','10:05:00',1.57),('7643','2013-07-03','10:10:00',1.92),('7643','2013-07-03','10:15:00',2.25),('7643','2013-07-03','10:20:00',2.5),('7643','2013-07-03','10:25:00',2.59),('7643','2013-07-03','10:30:00',2.6),('7643','2013-07-03','10:35:00',2.72),('7643','2013-07-03','10:40:00',2.65),('7643','2013-07-03','10:45:00',2.34),('7643','2013-07-03','10:50:00',2.09),('7643','2013-07-03','10:55:00',2.25),('7643','2013-07-03','11:00:00',2.67),('7643','2013-07-03','11:05:00',3.03),('7643','2013-07-03','11:10:00',3.63),('7643','2013-07-03','11:15:00',3.97),('7643','2013-07-03','11:20:00',3.77),('7643','2013-07-03','11:25:00',3.96),('7643','2013-07-03','11:30:00',4.34),('7643','2013-07-03','11:35:00',4.98),('7643','2013-07-03','11:40:00',5.63),('7643','2013-07-03','11:45:00',6.17),('7643','2013-07-03','11:50:00',6.38),('7643','2013-07-03','11:55:00',5.73),('7643','2013-07-03','12:00:00',5.14),('7643','2013-07-03','12:05:00',5.94),('7643','2013-07-03','12:10:00',7.72),('7643','2013-07-03','12:15:00',9.06),('7643','2013-07-03','12:20:00',10),('7643','2013-07-03','12:25:00',15.38),('7643','2013-07-03','12:30:00',10.71),('7643','2013-07-03','12:35:00',10.69),('7643','2013-07-03','12:40:00',6.88),('7643','2013-07-03','12:45:00',5.35),('7643','2013-07-03','12:50:00',4.22),('7643','2013-07-03','12:55:00',3.7),('7643','2013-07-03','13:00:00',3.86),('7643','2013-07-03','13:05:00',4.54),('7643','2013-07-03','13:10:00',5.7),('7643','2013-07-03','13:15:00',6.7),('7643','2013-07-03','13:20:00',7.43),('7643','2013-07-03','13:25:00',9.13),('7643','2013-07-03','13:30:00',8.54),('7643','2013-07-03','13:35:00',8.16),('7643','2013-07-03','13:40:00',11.55),('7643','2013-07-03','13:45:00',8.51),('7643','2013-07-03','13:50:00',10.12),('7643','2013-07-03','13:55:00',10.65),('7643','2013-07-03','14:00:00',8.55),('7643','2013-07-03','14:05:00',8.07),('7643','2013-07-03','14:10:00',7.98),('7643','2013-07-03','14:15:00',8.24),('7643','2013-07-03','14:20:00',11.38),('7643','2013-07-03','14:25:00',7.26),('7643','2013-07-03','14:30:00',7.44),('7643','2013-07-03','14:35:00',7.82),('7643','2013-07-03','14:40:00',11.32),('7643','2013-07-03','14:45:00',18.38),('7643','2013-07-03','14:50:00',12),('7643','2013-07-03','14:55:00',8.15),('7643','2013-07-03','15:00:00',12.53),('7643','2013-07-03','15:05:00',11.09),('7643','2013-07-03','15:10:00',9.17),('7643','2013-07-03','15:15:00',15.19),('7643','2013-07-03','15:20:00',13.92),('7643','2013-07-03','15:25:00',13.16),('7643','2013-07-03','15:30:00',11.15),('7643','2013-07-03','15:35:00',9.72),('7643','2013-07-03','15:40:00',10.2),('7643','2013-07-03','15:45:00',14.19),('7643','2013-07-03','15:50:00',8.76),('7643','2013-07-03','15:55:00',8.32),('7643','2013-07-03','16:00:00',8.49),('7643','2013-07-03','16:05:00',8.98),('7643','2013-07-03','16:10:00',7.25),('7643','2013-07-03','16:15:00',6.2),('7643','2013-07-03','16:20:00',6.8),('7643','2013-07-03','16:25:00',7.69),('7643','2013-07-03','16:30:00',8.95),('7643','2013-07-03','16:35:00',8.45),('7643','2013-07-03','16:40:00',7.26),('7643','2013-07-03','16:45:00',5.73),('7643','2013-07-03','16:50:00',5.64),('7643','2013-07-03','16:55:00',5.52),('7643','2013-07-03','17:00:00',4.84),('7643','2013-07-03','17:05:00',4.56),('7643','2013-07-03','17:10:00',6.14),('7643','2013-07-03','17:15:00',8.63),('7643','2013-07-03','17:20:00',9.15),('7643','2013-07-03','17:25:00',9.2),('7643','2013-07-03','17:30:00',8.54),('7643','2013-07-03','17:35:00',8.61),('7643','2013-07-03','17:40:00',8.61),('7643','2013-07-03','17:45:00',8.16),('7643','2013-07-03','17:50:00',8.05),('7643','2013-07-03','17:55:00',7.77),('7643','2013-07-03','18:00:00',7.51),('7643','2013-07-03','18:05:00',7.2),('7643','2013-07-03','18:10:00',6.97),('7643','2013-07-03','18:15:00',6.62),('7643','2013-07-03','18:20:00',6.16),('7643','2013-07-03','18:25:00',5.69),('7643','2013-07-03','18:30:00',3.77),('7643','2013-07-03','18:35:00',3.02),('7643','2013-07-03','18:40:00',1.5),('7643','2013-07-02','06:45:00',1.01),('7643','2013-07-02','06:50:00',1.2),('7643','2013-07-02','06:55:00',1.41),('7643','2013-07-02','07:00:00',1.68),('7643','2013-07-02','07:05:00',1.91),('7643','2013-07-02','07:10:00',2.23),('7643','2013-07-02','07:15:00',2.52),('7643','2013-07-02','07:20:00',2.8),('7643','2013-07-02','07:25:00',3.12),('7643','2013-07-02','07:30:00',3.44),('7643','2013-07-02','07:35:00',3.76),('7643','2013-07-02','07:40:00',4.08),('7643','2013-07-02','07:45:00',4.44),('7643','2013-07-02','07:50:00',4.79),('7643','2013-07-02','07:55:00',5.08),('7643','2013-07-02','08:00:00',5.43),('7643','2013-07-02','08:05:00',5.77),('7643','2013-07-02','08:10:00',6.01),('7643','2013-07-02','08:15:00',6.33),('7643','2013-07-02','08:20:00',6.62),('7643','2013-07-02','08:25:00',6.89),('7643','2013-07-02','08:30:00',7.24),('7643','2013-07-02','08:35:00',7.64),('7643','2013-07-02','08:40:00',7.95),('7643','2013-07-02','08:45:00',8.25),('7643','2013-07-02','08:50:00',8.61),('7643','2013-07-02','08:55:00',8.87),('7643','2013-07-02','09:00:00',9.04),('7643','2013-07-02','09:05:00',9.48),('7643','2013-07-02','09:10:00',9.76),('7643','2013-07-02','09:15:00',10.03),('7643','2013-07-02','09:20:00',10.28),('7643','2013-07-02','09:25:00',10.53),('7643','2013-07-02','09:30:00',10.68),('7643','2013-07-02','09:35:00',10.9),('7643','2013-07-02','09:40:00',11.09),('7643','2013-07-02','09:45:00',11.32),('7643','2013-07-02','09:50:00',11.57),('7643','2013-07-02','09:55:00',11.74),('7643','2013-07-02','10:00:00',11.96),('7643','2013-07-02','10:05:00',11.95),('7643','2013-07-02','10:10:00',12.21),('7643','2013-07-02','10:15:00',12.45),('7643','2013-07-02','10:20:00',12.63),('7643','2013-07-02','10:25:00',12.8),('7643','2013-07-02','10:30:00',12.94),('7643','2013-07-02','10:35:00',13.01),('7643','2013-07-02','10:40:00',13.25),('7643','2013-07-02','10:45:00',13.45),('7643','2013-07-02','10:50:00',13.51),('7643','2013-07-02','10:55:00',13.67),('7643','2013-07-02','11:00:00',13.89),('7643','2013-07-02','11:05:00',13.96),('7643','2013-07-02','11:10:00',14.08),('7643','2013-07-02','11:15:00',14.34),('7643','2013-07-02','11:20:00',14.6),('7643','2013-07-02','11:25:00',14.77),('7643','2013-07-02','11:30:00',14.61),('7643','2013-07-02','11:35:00',14.56),('7643','2013-07-02','11:40:00',14.75),('7643','2013-07-02','11:45:00',12.23),('7643','2013-07-02','11:50:00',15.67),('7643','2013-07-02','11:55:00',15.4),('7643','2013-07-02','12:00:00',15.54),('7643','2013-07-02','12:05:00',15.73),('7643','2013-07-02','12:10:00',15.8),('7643','2013-07-02','12:15:00',15.79),('7643','2013-07-02','12:20:00',15.84),('7643','2013-07-02','12:25:00',15.88),('7643','2013-07-02','12:30:00',16.07),('7643','2013-07-02','12:35:00',16.15),('7643','2013-07-02','12:40:00',16.13),('7643','2013-07-02','12:45:00',16.24),('7643','2013-07-02','12:50:00',16.19),('7643','2013-07-02','12:55:00',16.39),('7643','2013-07-02','13:00:00',16.43),('7643','2013-07-02','13:05:00',16.55),('7643','2013-07-02','13:10:00',16.47),('7643','2013-07-02','13:15:00',16.42),('7643','2013-07-02','13:20:00',16.34),('7643','2013-07-02','13:25:00',16.24),('7643','2013-07-02','13:30:00',16.31),('7643','2013-07-02','13:35:00',16.2),('7643','2013-07-02','13:40:00',16.23),('7643','2013-07-02','13:45:00',16.25),('7643','2013-07-02','13:50:00',16.23),('7643','2013-07-02','13:55:00',16.18),('7643','2013-07-02','14:00:00',16.05),('7643','2013-07-02','14:05:00',16.07),('7643','2013-07-02','14:10:00',16.04),('7643','2013-07-02','14:15:00',15.99),('7643','2013-07-02','14:20:00',16.03),('7643','2013-07-02','14:25:00',16.01),('7643','2013-07-02','14:30:00',16),('7643','2013-07-02','14:35:00',15.9),('7643','2013-07-02','14:40:00',15.81),('7643','2013-07-02','14:45:00',15.59),('7643','2013-07-02','14:50:00',15.51),('7643','2013-07-02','14:55:00',15.41),('7643','2013-07-02','15:00:00',15.27),('7643','2013-07-02','15:05:00',15.15),('7643','2013-07-02','15:10:00',15),('7643','2013-07-02','15:15:00',14.92),('7643','2013-07-02','15:20:00',14.77),('7643','2013-07-02','15:25:00',14.6),('7643','2013-07-02','15:30:00',14.43),('7643','2013-07-02','15:35:00',14.2),('7643','2013-07-02','15:40:00',14.05),('7643','2013-07-02','15:45:00',13.82),('7643','2013-07-02','15:50:00',13.68),('7643','2013-07-02','15:55:00',13.51),('7643','2013-07-02','16:00:00',13.29),('7643','2013-07-02','16:05:00',13.13),('7643','2013-07-02','16:10:00',12.93),('7643','2013-07-02','16:15:00',12.69),('7643','2013-07-02','16:20:00',12.47),('7643','2013-07-02','16:25:00',12.18),('7643','2013-07-02','16:30:00',11.95),('7643','2013-07-02','16:35:00',11.7),('7643','2013-07-02','16:40:00',11.46),('7643','2013-07-02','16:45:00',11.22),('7643','2013-07-02','16:50:00',10.87),('7643','2013-07-02','16:55:00',10.65),('7643','2013-07-02','17:00:00',10.39),('7643','2013-07-02','17:05:00',10.12),('7643','2013-07-02','17:10:00',9.82),('7643','2013-07-02','17:15:00',9.45),('7643','2013-07-02','17:20:00',9.09),('7643','2013-07-02','17:25:00',8.81),('7643','2013-07-02','17:30:00',8.53),('7643','2013-07-02','17:35:00',8.14),('7643','2013-07-02','17:40:00',7.88),('7643','2013-07-02','17:45:00',7.62),('7643','2013-07-02','17:50:00',7.31),('7643','2013-07-02','17:55:00',6.96),('7643','2013-07-02','18:00:00',6.61),('7643','2013-07-02','18:05:00',6.15),('7643','2013-07-02','18:10:00',5.81),('7643','2013-07-02','18:15:00',5.63),('7643','2013-07-02','18:20:00',5.32),('7643','2013-07-02','18:25:00',5),('7643','2013-07-02','18:30:00',4.68),('7643','2013-07-02','18:35:00',4.36),('7643','2013-07-02','18:40:00',4.01),('7643','2013-07-02','18:45:00',3.64),('7643','2013-07-02','18:50:00',3.2),('7643','2013-07-02','18:55:00',2.87),('7643','2013-07-02','19:00:00',2.58),('7643','2013-07-02','19:05:00',2.22),('7643','2013-07-02','19:10:00',2),('7643','2013-07-02','19:15:00',1.75),('7643','2013-07-02','19:20:00',1.43),('7643','2013-07-02','19:25:00',1.19),('7643','2013-07-02','19:30:00',1.02),('7643','2013-07-01','06:45:00',1.04),('7643','2013-07-01','06:50:00',1.21),('7643','2013-07-01','06:55:00',1.39),('7643','2013-07-01','07:00:00',1.6),('7643','2013-07-01','07:05:00',1.89),('7643','2013-07-01','07:10:00',2.2),('7643','2013-07-01','07:15:00',2.49),('7643','2013-07-01','07:20:00',2.76),('7643','2013-07-01','07:25:00',3.07),('7643','2013-07-01','07:30:00',3.37),('7643','2013-07-01','07:35:00',3.69),('7643','2013-07-01','07:40:00',3.98),('7643','2013-07-01','07:45:00',4.37),('7643','2013-07-01','07:50:00',4.69),('7643','2013-07-01','07:55:00',4.99),('7643','2013-07-01','08:00:00',5.32),('7643','2013-07-01','08:05:00',5.6),('7643','2013-07-01','08:10:00',5.92),('7643','2013-07-01','08:15:00',6.25),('7643','2013-07-01','08:20:00',6.49),('7643','2013-07-01','08:25:00',6.8),('7643','2013-07-01','08:30:00',7.13),('7643','2013-07-01','08:35:00',7.53),('7643','2013-07-01','08:40:00',7.84),('7643','2013-07-01','08:45:00',8.15),('7643','2013-07-01','08:50:00',8.5),('7643','2013-07-01','08:55:00',8.82),('7643','2013-07-01','09:00:00',9.04),('7643','2013-07-01','09:05:00',9.32),('7643','2013-07-01','09:10:00',9.65),('7643','2013-07-01','09:15:00',9.93),('7643','2013-07-01','09:20:00',10.23),('7643','2013-07-01','09:25:00',10.44),('7643','2013-07-01','09:30:00',10.64),('7643','2013-07-01','09:35:00',10.88),('7643','2013-07-01','09:40:00',11.08),('7643','2013-07-01','09:45:00',11.3),('7643','2013-07-01','09:50:00',11.55),('7643','2013-07-01','09:55:00',11.77),('7643','2013-07-01','10:00:00',12),('7643','2013-07-01','10:05:00',12.08),('7643','2013-07-01','10:10:00',12.24),('7643','2013-07-01','10:15:00',12.4),('7643','2013-07-01','10:20:00',12.56),('7643','2013-07-01','10:25:00',12.75),('7643','2013-07-01','10:30:00',12.9),('7643','2013-07-01','10:35:00',13.07),('7643','2013-07-01','10:40:00',13.22),('7643','2013-07-01','10:45:00',13.37),('7643','2013-07-01','10:50:00',13.53),('7643','2013-07-01','10:55:00',13.61),('7643','2013-07-01','11:00:00',13.65),('7643','2013-07-01','11:05:00',13.79),('7643','2013-07-01','11:10:00',13.86),('7643','2013-07-01','11:15:00',13.92),('7643','2013-07-01','11:20:00',14.01),('7643','2013-07-01','11:25:00',14.11),('7643','2013-07-01','11:30:00',14.45),('7643','2013-07-01','11:35:00',14.59),('7643','2013-07-01','11:40:00',14.52),('7643','2013-07-01','11:45:00',14.64),('7643','2013-07-01','11:50:00',14.92),('7643','2013-07-01','11:55:00',14.85),('7643','2013-07-01','12:00:00',14.78),('7643','2013-07-01','12:05:00',14.82),('7643','2013-07-01','12:10:00',15.05),('7643','2013-07-01','12:15:00',15.38),('7643','2013-07-01','12:20:00',15.44),('7643','2013-07-01','12:25:00',15.56),('7643','2013-07-01','12:30:00',15.66),('7643','2013-07-01','12:35:00',15.64),('7643','2013-07-01','12:40:00',15.75),('7643','2013-07-01','12:45:00',16.11),('7643','2013-07-01','12:50:00',16.72),('7643','2013-07-01','12:55:00',13.02),('7643','2013-07-01','13:00:00',8.47),('7643','2013-07-01','13:05:00',6.2),('7643','2013-07-01','13:10:00',10.49),('7643','2013-07-01','13:15:00',16.44),('7643','2013-07-01','13:20:00',16.55),('7643','2013-07-01','13:25:00',16.66),('7643','2013-07-01','13:30:00',16.2),('7643','2013-07-01','13:35:00',16.21),('7643','2013-07-01','13:40:00',16.47),('7643','2013-07-01','13:45:00',16.05),('7643','2013-07-01','13:50:00',15.38),('7643','2013-07-01','13:55:00',15.58),('7643','2013-07-01','14:00:00',15.79),('7643','2013-07-01','14:05:00',15.64),('7643','2013-07-01','14:10:00',15.36),('7643','2013-07-01','14:15:00',15.44),('7643','2013-07-01','14:20:00',15.7),('7643','2013-07-01','14:25:00',15.68),('7643','2013-07-01','14:30:00',15.52),('7643','2013-07-01','14:35:00',15.38),('7643','2013-07-01','14:40:00',15.34),('7643','2013-07-01','14:45:00',15.18),('7643','2013-07-01','14:50:00',15.07),('7643','2013-07-01','14:55:00',14.93),('7643','2013-07-01','15:00:00',14.85),('7643','2013-07-01','15:05:00',14.87),('7643','2013-07-01','15:10:00',14.75),('7643','2013-07-01','15:15:00',14.53),('7643','2013-07-01','15:20:00',14.44),('7643','2013-07-01','15:25:00',14.29),('7643','2013-07-01','15:30:00',14.07),('7643','2013-07-01','15:35:00',14.05),('7643','2013-07-01','15:40:00',13.84),('7643','2013-07-01','15:45:00',13.6),('7643','2013-07-01','15:50:00',13.44),('7643','2013-07-01','15:55:00',13.22),('7643','2013-07-01','16:00:00',13.02),('7643','2013-07-01','16:05:00',12.86),('7643','2013-07-01','16:10:00',12.62),('7643','2013-07-01','16:15:00',12.37),('7643','2013-07-01','16:20:00',12.11),('7643','2013-07-01','16:25:00',11.83),('7643','2013-07-01','16:30:00',11.52),('7643','2013-07-01','16:35:00',11.25),('7643','2013-07-01','16:40:00',11.09),('7643','2013-07-01','16:45:00',10.78),('7643','2013-07-01','16:50:00',10.4),('7643','2013-07-01','16:55:00',10.22),('7643','2013-07-01','17:00:00',10.11),('7643','2013-07-01','17:05:00',9.72),('7643','2013-07-01','17:10:00',9.41),('7643','2013-07-01','17:15:00',9.08),('7643','2013-07-01','17:20:00',8.67),('7643','2013-07-01','17:25:00',8.37),('7643','2013-07-01','17:30:00',8.09),('7643','2013-07-01','17:35:00',7.74),('7643','2013-07-01','17:40:00',7.46),('7643','2013-07-01','17:45:00',7.18),('7643','2013-07-01','17:50:00',6.91),('7643','2013-07-01','17:55:00',6.59),('7643','2013-07-01','18:00:00',6.25),('7643','2013-07-01','18:05:00',5.9),('7643','2013-07-01','18:10:00',5.65),('7643','2013-07-01','18:15:00',5.39),('7643','2013-07-01','18:20:00',5.09),('7643','2013-07-01','18:25:00',4.74),('7643','2013-07-01','18:30:00',4.41),('7643','2013-07-01','18:35:00',4.12),('7643','2013-07-01','18:40:00',3.81),('7643','2013-07-01','18:45:00',3.44),('7643','2013-07-01','18:50:00',3.05),('7643','2013-07-01','18:55:00',2.77),('7643','2013-07-01','19:00:00',2.5),('7643','2013-07-01','19:05:00',2.17),('7643','2013-07-01','19:10:00',1.96),('7643','2013-07-01','19:15:00',1.73),('7643','2013-07-01','19:20:00',1.46),('7643','2013-07-01','19:25:00',1.26),('7643','2013-07-01','19:30:00',1.08),('7643','2013-06-30','06:45:00',1.12),('7643','2013-06-30','06:50:00',1.3),('7643','2013-06-30','06:55:00',1.47),('7643','2013-06-30','07:00:00',1.66),('7643','2013-06-30','07:05:00',1.93),('7643','2013-06-30','07:10:00',2.25),('7643','2013-06-30','07:15:00',2.58),('7643','2013-06-30','07:20:00',2.9),('7643','2013-06-30','07:25:00',3.16),('7643','2013-06-30','07:30:00',3.46),('7643','2013-06-30','07:35:00',3.82),('7643','2013-06-30','07:40:00',4.06),('7643','2013-06-30','07:45:00',4.4),('7643','2013-06-30','07:50:00',4.75),('7643','2013-06-30','07:55:00',5.09),('7643','2013-06-30','08:00:00',5.46),('7643','2013-06-30','08:05:00',5.73),('7643','2013-06-30','08:10:00',6.07),('7643','2013-06-30','08:15:00',6.4),('7643','2013-06-30','08:20:00',6.63),('7643','2013-06-30','08:25:00',6.95),('7643','2013-06-30','08:30:00',7.29),('7643','2013-06-30','08:35:00',7.72),('7643','2013-06-30','08:40:00',8.04),('7643','2013-06-30','08:45:00',8.33),('7643','2013-06-30','08:50:00',8.67),('7643','2013-06-30','08:55:00',8.98),('7643','2013-06-30','09:00:00',9.3),('7643','2013-06-30','09:05:00',9.57),('7643','2013-06-30','09:10:00',9.93),('7643','2013-06-30','09:15:00',10.28),('7643','2013-06-30','09:20:00',10.57),('7643','2013-06-30','09:25:00',10.82),('7643','2013-06-30','09:30:00',11.11),('7643','2013-06-30','09:35:00',11.35),('7643','2013-06-30','09:40:00',11.5),('7643','2013-06-30','09:45:00',11.69),('7643','2013-06-30','09:50:00',11.9),('7643','2013-06-30','09:55:00',12.08),('7643','2013-06-30','10:00:00',12.22),('7643','2013-06-30','10:05:00',12.37),('7643','2013-06-30','10:10:00',12.56),('7643','2013-06-30','10:15:00',12.76),('7643','2013-06-30','10:20:00',13),('7643','2013-06-30','10:25:00',13.26),('7643','2013-06-30','10:30:00',13.46),('7643','2013-06-30','10:35:00',13.68),('7643','2013-06-30','10:40:00',13.99),('7643','2013-06-30','10:45:00',14.1),('7643','2013-06-30','10:50:00',14.14),('7643','2013-06-30','10:55:00',14.22),('7643','2013-06-30','11:00:00',14.28),('7643','2013-06-30','11:05:00',14.6),('7643','2013-06-30','11:10:00',14.81),('7643','2013-06-30','11:15:00',15.02),('7643','2013-06-30','11:20:00',15.01),('7643','2013-06-30','11:25:00',14.98),('7643','2013-06-30','11:30:00',15.1),('7643','2013-06-30','11:35:00',15.43),('7643','2013-06-30','11:40:00',15.66),('7643','2013-06-30','11:45:00',15.74),('7643','2013-06-30','11:50:00',15.71),('7643','2013-06-30','11:55:00',15.69),('7643','2013-06-30','12:00:00',15.7),('7643','2013-06-30','12:05:00',15.83),('7643','2013-06-30','12:10:00',15.83),('7643','2013-06-30','12:15:00',15.77),('7643','2013-06-30','12:20:00',15.81),('7643','2013-06-30','12:25:00',15.94),('7643','2013-06-30','12:30:00',15.95),('7643','2013-06-30','12:35:00',16.03),('7643','2013-06-30','12:40:00',16.04),('7643','2013-06-30','12:45:00',16.07),('7643','2013-06-30','12:50:00',16.03),('7643','2013-06-30','12:55:00',16),('7643','2013-06-30','13:00:00',16),('7643','2013-06-30','13:05:00',16.19),('7643','2013-06-30','13:10:00',16.26),('7643','2013-06-30','13:15:00',16.23),('7643','2013-06-30','13:20:00',16.05),('7643','2013-06-30','13:25:00',16.16),('7643','2013-06-30','13:30:00',16.23),('7643','2013-06-30','13:35:00',16.18),('7643','2013-06-30','13:40:00',15.98),('7643','2013-06-30','13:45:00',15.82),('7643','2013-06-30','13:50:00',15.73),('7643','2013-06-30','13:55:00',16.02),('7643','2013-06-30','14:00:00',15.86),('7643','2013-06-30','14:05:00',16.14),('7643','2013-06-30','14:10:00',16.12),('7643','2013-06-30','14:15:00',16.11),('7643','2013-06-30','14:20:00',16.01),('7643','2013-06-30','14:25:00',15.78),('7643','2013-06-30','14:30:00',15.63),('7643','2013-06-30','14:35:00',15.58),('7643','2013-06-30','14:40:00',15.59),('7643','2013-06-30','14:45:00',15.43),('7643','2013-06-30','14:50:00',15.23),('7643','2013-06-30','14:55:00',15.11),('7643','2013-06-30','15:00:00',14.94),('7643','2013-06-30','15:05:00',14.62),('7643','2013-06-30','15:10:00',14.63),('7643','2013-06-30','15:15:00',14.54),('7643','2013-06-30','15:20:00',14.33),('7643','2013-06-30','15:25:00',14.19),('7643','2013-06-30','15:30:00',14.07),('7643','2013-06-30','15:35:00',13.75),('7643','2013-06-30','15:40:00',13.58),('7643','2013-06-30','15:45:00',13.56),('7643','2013-06-30','15:50:00',13.29),('7643','2013-06-30','15:55:00',13.07),('7643','2013-06-30','16:00:00',12.86),('7643','2013-06-30','16:05:00',12.71),('7643','2013-06-30','16:10:00',12.44),('7643','2013-06-30','16:15:00',12.15),('7643','2013-06-30','16:20:00',11.82),('7643','2013-06-30','16:25:00',11.52),('7643','2013-06-30','16:30:00',11.34),('7643','2013-06-30','16:35:00',11.14),('7643','2013-06-30','16:40:00',10.88),('7643','2013-06-30','16:45:00',10.64),('7643','2013-06-30','16:50:00',10.41),('7643','2013-06-30','16:55:00',10.22),('7643','2013-06-30','17:00:00',10.02),('7643','2013-06-30','17:05:00',9.71),('7643','2013-06-30','17:10:00',9.4),('7643','2013-06-30','17:15:00',9.04),('7643','2013-06-30','17:20:00',8.6),('7643','2013-06-30','17:25:00',8.28),('7643','2013-06-30','17:30:00',7.97),('7643','2013-06-30','17:35:00',7.62),('7643','2013-06-30','17:40:00',7.38),('7643','2013-06-30','17:45:00',7.21),('7643','2013-06-30','17:50:00',6.95),('7643','2013-06-30','17:55:00',6.65),('7643','2013-06-30','18:00:00',5.79),('7643','2013-06-30','18:05:00',5.78),('7643','2013-06-30','18:10:00',5.55),('7643','2013-06-30','18:15:00',4.51),('7643','2013-06-30','18:20:00',4.53),('7643','2013-06-30','18:25:00',4.9),('7643','2013-06-30','18:30:00',4.62),('7643','2013-06-30','18:35:00',4.25),('7643','2013-06-30','18:40:00',3.74),('7643','2013-06-30','18:45:00',3.44),('7643','2013-06-30','18:50:00',3.04),('7643','2013-06-30','18:55:00',2.61),('7643','2013-06-30','19:00:00',2.43),('7643','2013-06-30','19:05:00',2.17),('7643','2013-06-30','19:10:00',1.97),('7643','2013-06-30','19:15:00',1.51),('7643','2013-06-30','19:20:00',1.51),('7643','2013-06-30','19:25:00',1.35),('7643','2013-06-30','19:30:00',1.13),('7643','2014-04-04','07:20:00',1.03),('7643','2014-04-04','07:25:00',1.23),('7643','2014-04-04','07:30:00',1.09),('7643','2014-04-04','07:35:00',1.18),('7643','2014-04-04','07:40:00',1.13),('7643','2014-04-04','08:30:00',1.36),('7643','2014-04-04','08:35:00',2.26),('7643','2014-04-04','08:40:00',2.11),('7643','2014-04-04','08:45:00',1.98),('7643','2014-04-04','08:50:00',1.79),('7643','2014-04-04','08:55:00',1.93),('7643','2014-04-04','09:00:00',2.53),('7643','2014-04-04','09:05:00',3.29),('7643','2014-04-04','09:10:00',3.7),('7643','2014-04-04','09:15:00',5.16),('7643','2014-04-04','09:20:00',6.43),('7643','2014-04-04','09:25:00',10.18),('7643','2014-04-04','09:30:00',13.86),('7643','2014-04-04','09:35:00',13.35),('7643','2014-04-04','09:40:00',12.89),('7643','2014-04-04','09:45:00',11.23),('7643','2014-04-04','09:50:00',6.49),('7643','2014-04-04','09:55:00',7.14),('7643','2014-04-04','10:00:00',8.95),('7643','2014-04-04','10:05:00',9.2),('7643','2014-04-04','10:10:00',8.64),('7643','2014-04-04','10:15:00',8.05),('7643','2014-04-04','10:20:00',11.1),('7643','2014-04-04','10:25:00',10.53),('7643','2014-04-04','10:30:00',10.71),('7643','2014-04-04','10:35:00',12.48),('7643','2014-04-04','10:40:00',13.71),('7643','2014-04-04','10:45:00',12.3),('7643','2014-04-04','10:50:00',9.22),('7643','2014-04-04','10:55:00',11.56),('7643','2014-04-04','11:00:00',14.2),('7643','2014-04-04','11:05:00',15.1),('7643','2014-04-04','11:10:00',15.6),('7643','2014-04-04','11:15:00',16.5),('7643','2014-04-04','11:20:00',16.56),('7643','2014-04-04','11:25:00',10.88),('7643','2014-04-04','11:30:00',8.2),('7643','2014-04-04','11:35:00',11.07),('7643','2014-04-04','11:40:00',14.61),('7643','2014-04-04','11:45:00',16.5),('7643','2014-04-04','11:50:00',17.62),('7643','2014-04-04','11:55:00',16.46),('7643','2014-04-04','12:00:00',11.81),('7643','2014-04-04','12:05:00',12.01),('7643','2014-04-04','12:10:00',13.05),('7643','2014-04-04','12:15:00',14.49),('7643','2014-04-04','12:20:00',13.81),('7643','2014-04-04','12:25:00',10.64),('7643','2014-04-04','12:30:00',10.66),('7643','2014-04-04','12:35:00',11.81),('7643','2014-04-04','12:40:00',16.87),('7643','2014-04-04','12:45:00',19.05),('7643','2014-04-04','12:50:00',18.78),('7643','2014-04-04','12:55:00',14.76),('7643','2014-04-04','13:00:00',15.67),('7643','2014-04-04','13:05:00',15.79),('7643','2014-04-04','13:10:00',15.06),('7643','2014-04-04','13:15:00',5.98),('7643','2014-04-04','13:20:00',14.66),('7643','2014-04-04','13:25:00',17.54),('7643','2014-04-04','13:30:00',13.66),('7643','2014-04-04','13:35:00',17.71),('7643','2014-04-04','13:40:00',11.41),('7643','2014-04-04','13:45:00',7.97),('7643','2014-04-04','13:50:00',15.12),('7643','2014-04-04','13:55:00',13.64),('7643','2014-04-04','14:00:00',13.03),('7643','2014-04-04','14:05:00',19.28),('7643','2014-04-04','14:10:00',10.08),('7643','2014-04-04','14:15:00',3.48),('7643','2014-04-04','14:20:00',3.77),('7643','2014-04-04','14:25:00',11.49),('7643','2014-04-04','14:30:00',7.43),('7643','2014-04-04','14:35:00',4.98),('7643','2014-04-04','14:40:00',3.16),('7643','2014-04-04','14:45:00',2.84),('7643','2014-04-04','14:50:00',3.49),('7643','2014-04-04','14:55:00',16.11),('7643','2014-04-04','15:00:00',13.61),('7643','2014-04-04','15:05:00',14.41),('7643','2014-04-04','15:10:00',9.09),('7643','2014-04-04','15:15:00',9.52),('7643','2014-04-04','15:20:00',17.42),('7643','2014-04-04','15:25:00',11.5),('7643','2014-04-04','15:30:00',5.59),('7643','2014-04-04','15:35:00',5.8),('7643','2014-04-04','15:40:00',13.41),('7643','2014-04-04','15:45:00',5.86),('7643','2014-04-04','15:50:00',6.9),('7643','2014-04-04','15:55:00',4.79),('7643','2014-04-04','16:00:00',5.03),('7643','2014-04-04','16:05:00',5.86),('7643','2014-04-04','16:10:00',4.9),('7643','2014-04-04','16:15:00',11.42),('7643','2014-04-04','16:20:00',13.68),('7643','2014-04-04','16:25:00',11.31),('7643','2014-04-04','16:30:00',6.67),('7643','2014-04-04','16:35:00',11.86),('7643','2014-04-04','16:40:00',6.16),('7643','2014-04-04','16:45:00',7.58),('7643','2014-04-04','16:50:00',5.99),('7643','2014-04-04','16:55:00',6.92),('7643','2014-04-04','17:00:00',8.19),('7643','2014-04-04','17:05:00',8.05),('7643','2014-04-04','17:10:00',7.25),('7643','2014-04-04','17:15:00',5.67),('7643','2014-04-04','17:20:00',5.23),('7643','2014-04-04','17:25:00',5.43),('7643','2014-04-04','17:30:00',5.02),('7643','2014-04-04','17:35:00',4.62),('7643','2014-04-04','17:40:00',4.44),('7643','2014-04-04','17:45:00',3.61),('7643','2014-04-04','17:50:00',4.8),('7643','2014-04-04','17:55:00',4.75),('7643','2014-04-04','18:00:00',4.58),('7643','2014-04-04','18:05:00',4.05),('7643','2014-04-04','18:10:00',3.98),('7643','2014-04-04','18:15:00',4.07),('7643','2014-04-04','18:20:00',3.82),('7643','2014-04-04','18:25:00',2.9),('7643','2014-04-04','18:30:00',1.89),('7643','2014-04-04','18:35:00',1.69),('7643','2014-04-04','18:40:00',1.48),('7643','2014-04-04','18:45:00',1.08),('7643','2013-06-29','06:45:00',1.11),('7643','2013-06-29','06:50:00',1.31),('7643','2013-06-29','06:55:00',1.53),('7643','2013-06-29','07:00:00',1.79),('7643','2013-06-29','07:05:00',2.06),('7643','2013-06-29','07:10:00',2.37),('7643','2013-06-29','07:15:00',2.7),('7643','2013-06-29','07:20:00',2.97),('7643','2013-06-29','07:25:00',3.33),('7643','2013-06-29','07:30:00',3.65),('7643','2013-06-29','07:35:00',4.04),('7643','2013-06-29','07:40:00',4.38),('7643','2013-06-29','07:45:00',4.74),('7643','2013-06-29','07:50:00',5.04),('7643','2013-06-29','07:55:00',5.4),('7643','2013-06-29','08:00:00',5.75),('7643','2013-06-29','08:05:00',6.06),('7643','2013-06-29','08:10:00',6.38),('7643','2013-06-29','08:15:00',6.67),('7643','2013-06-29','08:20:00',6.9),('7643','2013-06-29','08:25:00',7.27),('7643','2013-06-29','08:30:00',7.65),('7643','2013-06-29','08:35:00',8.03),('7643','2013-06-29','08:40:00',8.32),('7643','2013-06-29','08:45:00',8.64),('7643','2013-06-29','08:50:00',8.95),('7643','2013-06-29','08:55:00',9.27),('7643','2013-06-29','09:00:00',9.58),('7643','2013-06-29','09:05:00',9.86),('7643','2013-06-29','09:10:00',10.21),('7643','2013-06-29','09:15:00',10.52),('7643','2013-06-29','09:20:00',10.82),('7643','2013-06-29','09:25:00',11.07),('7643','2013-06-29','09:30:00',11.31),('7643','2013-06-29','09:35:00',11.6),('7643','2013-06-29','09:40:00',11.82),('7643','2013-06-29','09:45:00',12.02),('7643','2013-06-29','09:50:00',12.29),('7643','2013-06-29','09:55:00',12.53),('7643','2013-06-29','10:00:00',12.67),('7643','2013-06-29','10:05:00',12.85),('7643','2013-06-29','10:10:00',13.08),('7643','2013-06-29','10:15:00',13.26),('7643','2013-06-29','10:20:00',13.47),('7643','2013-06-29','10:25:00',13.67),('7643','2013-06-29','10:30:00',13.79),('7643','2013-06-29','10:35:00',13.96),('7643','2013-06-29','10:40:00',14.13),('7643','2013-06-29','10:45:00',14.31),('7643','2013-06-29','10:50:00',14.42),('7643','2013-06-29','10:55:00',14.53),('7643','2013-06-29','11:00:00',14.82),('7643','2013-06-29','11:05:00',14.9),('7643','2013-06-29','11:10:00',14.96),('7643','2013-06-29','11:15:00',14.99),('7643','2013-06-29','11:20:00',15.04),('7643','2013-06-29','11:25:00',15.09),('7643','2013-06-29','11:30:00',15.29),('7643','2013-06-29','11:35:00',15.46),('7643','2013-06-29','11:40:00',15.58),('7643','2013-06-29','11:45:00',15.66),('7643','2013-06-29','11:50:00',15.74),('7643','2013-06-29','11:55:00',15.87),('7643','2013-06-29','12:00:00',15.9),('7643','2013-06-29','12:05:00',15.94),('7643','2013-06-29','12:10:00',16.04),('7643','2013-06-29','12:15:00',16.15),('7643','2013-06-29','12:20:00',16.2),('7643','2013-06-29','12:25:00',16.27),('7643','2013-06-29','12:30:00',16.28),('7643','2013-06-29','12:35:00',16.36),('7643','2013-06-29','12:40:00',16.31),('7643','2013-06-29','12:45:00',16.42),('7643','2013-06-29','12:50:00',16.71),('7643','2013-06-29','12:55:00',16.74),('7643','2013-06-29','13:00:00',16.68),('7643','2013-06-29','13:05:00',16.63),('7643','2013-06-29','13:10:00',16.63),('7643','2013-06-29','13:15:00',16.63),('7643','2013-06-29','13:20:00',16.59),('7643','2013-06-29','13:25:00',16.73),('7643','2013-06-29','13:30:00',16.67),('7643','2013-06-29','13:35:00',16.49),('7643','2013-06-29','13:40:00',16.64),('7643','2013-06-29','13:45:00',16.64),('7643','2013-06-29','13:50:00',16.72),('7643','2013-06-29','13:55:00',16.26),('7643','2013-06-29','14:00:00',16.23),('7643','2013-06-29','14:05:00',16.38),('7643','2013-06-29','14:10:00',16.34),('7643','2013-06-29','14:15:00',16.11),('7643','2013-06-29','14:20:00',16),('7643','2013-06-29','14:25:00',15.81),('7643','2013-06-29','14:30:00',15.7),('7643','2013-06-29','14:35:00',15.58),('7643','2013-06-29','14:40:00',15.63),('7643','2013-06-29','14:45:00',15.52),('7643','2013-06-29','14:50:00',15.45),('7643','2013-06-29','14:55:00',15.41),('7643','2013-06-29','15:00:00',15.22),('7643','2013-06-29','15:05:00',14.93),('7643','2013-06-29','15:10:00',14.93),('7643','2013-06-29','15:15:00',14.86),('7643','2013-06-29','15:20:00',14.89),('7643','2013-06-29','15:25:00',14.64),('7643','2013-06-29','15:30:00',14.4),('7643','2013-06-29','15:35:00',14.37),('7643','2013-06-29','15:40:00',14.23),('7643','2013-06-29','15:45:00',14.16),('7643','2013-06-29','15:50:00',13.98),('7643','2013-06-29','15:55:00',13.61),('7643','2013-06-29','16:00:00',13.45),('7643','2013-06-29','16:05:00',13.3),('7643','2013-06-29','16:10:00',13.2),('7643','2013-06-29','16:15:00',12.95),('7643','2013-06-29','16:20:00',12.85),('7643','2013-06-29','16:25:00',13.14),('7643','2013-06-29','16:30:00',13.26),('7643','2013-06-29','16:35:00',11.97),('7643','2013-06-29','16:40:00',11.19),('7643','2013-06-29','16:45:00',11.1),('7643','2013-06-29','16:50:00',10.8),('7643','2013-06-29','16:55:00',10.45),('7643','2013-06-29','17:00:00',10.1),('7643','2013-06-29','17:05:00',9.84),('7643','2013-06-29','17:10:00',9.61),('7643','2013-06-29','17:15:00',9.18),('7643','2013-06-29','17:20:00',8.78),('7643','2013-06-29','17:25:00',8.41),('7643','2013-06-29','17:30:00',7.99),('7643','2013-06-29','17:35:00',7.54),('7643','2013-06-29','17:40:00',7.49),('7643','2013-06-29','17:45:00',7.22),('7643','2013-06-29','17:50:00',6.98),('7643','2013-06-29','17:55:00',6.62),('7643','2013-06-29','18:00:00',6.29),('7643','2013-06-29','18:05:00',5.79),('7643','2013-06-29','18:10:00',5.62),('7643','2013-06-29','18:15:00',5.41),('7643','2013-06-29','18:20:00',5.12),('7643','2013-06-29','18:25:00',4.77),('7643','2013-06-29','18:30:00',4.42),('7643','2013-06-29','18:35:00',4.1),('7643','2013-06-29','18:40:00',3.87),('7643','2013-06-29','18:45:00',3.5),('7643','2013-06-29','18:50:00',3.12),('7643','2013-06-29','18:55:00',2.82),('7643','2013-06-29','19:00:00',2.49),('7643','2013-06-29','19:05:00',2.25),('7643','2013-06-29','19:10:00',2.11),('7643','2013-06-29','19:15:00',1.86),('7643','2013-06-29','19:20:00',1.57),('7643','2013-06-29','19:25:00',1.38),('7643','2013-06-29','19:30:00',1.2),('7643','2013-06-29','19:35:00',1.03),('7643','2013-06-28','07:20:00',1.76),('7643','2013-06-28','07:25:00',2.75),('7643','2013-06-28','07:30:00',4.2),('7643','2013-06-28','07:35:00',5.26),('7643','2013-06-28','07:40:00',5.55),('7643','2013-06-28','07:45:00',5.58),('7643','2013-06-28','07:50:00',5.77),('7643','2013-06-28','07:55:00',6.36),('7643','2013-06-28','08:00:00',7.21),('7643','2013-06-28','08:05:00',7.81),('7643','2013-06-28','08:10:00',8.19),('7643','2013-06-28','08:15:00',6.86),('7643','2013-06-28','08:20:00',4.76),('7643','2013-06-28','08:25:00',8),('7643','2013-06-28','08:30:00',8.12),('7643','2013-06-28','08:35:00',8.33),('7643','2013-06-28','08:40:00',5.79),('7643','2013-06-28','08:45:00',8.2),('7643','2013-06-28','08:50:00',9.06),('7643','2013-06-28','08:55:00',9.29),('7643','2013-06-28','09:00:00',9.45),('7643','2013-06-28','09:05:00',9.78),('7643','2013-06-28','09:10:00',10.11),('7643','2013-06-28','09:15:00',10.4),('7643','2013-06-28','09:20:00',10.72),('7643','2013-06-28','09:25:00',10.95),('7643','2013-06-28','09:30:00',11.03),('7643','2013-06-28','09:35:00',11.33),('7643','2013-06-28','09:40:00',11.71),('7643','2013-06-28','09:45:00',11.84),('7643','2013-06-28','09:50:00',12.11),('7643','2013-06-28','09:55:00',12.39),('7643','2013-06-28','10:00:00',12.51),('7643','2013-06-28','10:05:00',12.73),('7643','2013-06-28','10:10:00',12.86),('7643','2013-06-28','10:15:00',13.15),('7643','2013-06-28','10:20:00',13.24),('7643','2013-06-28','10:25:00',13.52),('7643','2013-06-28','10:30:00',13.75),('7643','2013-06-28','10:35:00',13.89),('7643','2013-06-28','10:40:00',14.02),('7643','2013-06-28','10:45:00',14.25),('7643','2013-06-28','10:50:00',14.42),('7643','2013-06-28','10:55:00',14.55),('7643','2013-06-28','11:00:00',14.72),('7643','2013-06-28','11:05:00',15.02),('7643','2013-06-28','11:10:00',15.38),('7643','2013-06-28','11:15:00',15.69),('7643','2013-06-28','11:20:00',10.87),('7643','2013-06-28','11:25:00',16.69),('7643','2013-06-28','11:30:00',16.7),('7643','2013-06-28','11:35:00',12.73),('7643','2013-06-28','11:40:00',13.76),('7643','2013-06-28','11:45:00',10.01),('7643','2013-06-28','11:50:00',9.2),('7643','2013-06-28','11:55:00',18.32),('7643','2013-06-28','12:00:00',12.44),('7643','2013-06-28','12:05:00',17.1),('7643','2013-06-28','12:10:00',17.28),('7643','2013-06-28','12:15:00',17.64),('7643','2013-06-28','12:20:00',6.31),('7643','2013-06-28','12:25:00',12.19),('7643','2013-06-28','12:30:00',17.79),('7643','2013-06-28','12:35:00',17.53),('7643','2013-06-28','12:40:00',17.63),('7643','2013-06-28','12:45:00',18.21),('7643','2013-06-28','12:50:00',10.9),('7643','2013-06-28','12:55:00',10.86),('7643','2013-06-28','13:00:00',12.47),('7643','2013-06-28','13:05:00',11.94),('7643','2013-06-28','13:10:00',16.58),('7643','2013-06-28','13:15:00',14.56),('7643','2013-06-28','13:20:00',8.52),('7643','2013-06-28','13:25:00',16.58),('7643','2013-06-28','13:30:00',13.81),('7643','2013-06-28','13:35:00',3.27),('7643','2013-06-28','13:40:00',3.27),('7643','2013-06-28','13:45:00',6.54),('7643','2013-06-28','13:50:00',11.77),('7643','2013-06-28','13:55:00',13.36),('7643','2013-06-28','14:00:00',17.73),('7643','2013-06-28','14:05:00',18.23),('7643','2013-06-28','14:10:00',18.47),('7643','2013-06-28','14:15:00',18.44),('7643','2013-06-28','14:20:00',18.75),('7643','2013-06-28','14:25:00',11.58),('7643','2013-06-28','14:30:00',18.73),('7643','2013-06-28','14:35:00',17.75),('7643','2013-06-28','14:40:00',17.84),('7643','2013-06-28','14:45:00',17.98),('7643','2013-06-28','14:50:00',18.21),('7643','2013-06-28','14:55:00',5),('7643','2013-06-28','15:00:00',9.26),('7643','2013-06-28','15:05:00',9.63),('7643','2013-06-28','15:10:00',6.3),('7643','2013-06-28','15:15:00',5.96),('7643','2013-06-28','15:20:00',3.69),('7643','2013-06-28','15:25:00',2.5),('7643','2013-06-28','15:30:00',2.03),('7643','2013-06-28','15:35:00',2.03),('7643','2013-06-28','15:40:00',2.06),('7643','2013-06-28','15:45:00',1.77),('7643','2013-06-28','16:20:00',1.31),('7643','2013-06-28','16:25:00',1.67),('7643','2013-06-28','16:30:00',2.11),('7643','2013-06-28','16:35:00',2.93),('7643','2013-06-28','16:40:00',4.17),('7643','2013-06-28','16:45:00',5.74),('7643','2013-06-28','16:50:00',9.42),('7643','2013-06-28','16:55:00',6.77),('7643','2013-06-28','17:00:00',3.94),('7643','2013-06-28','17:05:00',4.92),('7643','2013-06-28','17:10:00',4.34),('7643','2013-06-28','17:15:00',3.78),('7643','2013-06-28','17:20:00',4.44),('7643','2013-06-28','17:25:00',5.1),('7643','2013-06-28','17:30:00',9.44),('7643','2013-06-28','17:35:00',9.58),('7643','2013-06-28','17:40:00',3.85),('7643','2013-06-28','17:45:00',6.88),('7643','2013-06-28','17:50:00',7.45),('7643','2013-06-28','17:55:00',7.04),('7643','2013-06-28','18:00:00',6.56),('7643','2013-06-28','18:05:00',6.26),('7643','2013-06-28','18:10:00',5.87),('7643','2013-06-28','18:15:00',5.67),('7643','2013-06-28','18:20:00',5.23),('7643','2013-06-28','18:25:00',4.85),('7643','2013-06-28','18:30:00',4.25),('7643','2013-06-28','18:35:00',4.49),('7643','2013-06-28','18:40:00',4.49),('7643','2013-06-28','18:45:00',2.88),('7643','2013-06-28','18:50:00',1.38),('7643','2013-06-28','18:55:00',1.21),('7643','2013-06-28','19:00:00',1.32),('7643','2013-06-28','19:05:00',1.89),('7643','2013-06-28','19:10:00',2.23),('7643','2013-06-28','19:15:00',1.59),('7643','2013-06-28','19:20:00',1.27),('7643','2013-06-28','19:25:00',1.29),('7643','2013-06-28','19:30:00',1.02),('7643','2013-06-27','06:55:00',1.17),('7643','2013-06-27','07:00:00',1.39),('7643','2013-06-27','07:05:00',1.67),('7643','2013-06-27','07:10:00',2.54),('7643','2013-06-27','07:15:00',2.76),('7643','2013-06-27','07:20:00',2.97),('7643','2013-06-27','07:25:00',3.28),('7643','2013-06-27','07:30:00',3.69),('7643','2013-06-27','07:35:00',3.85),('7643','2013-06-27','07:40:00',3.99),('7643','2013-06-27','07:45:00',4.68),('7643','2013-06-27','07:50:00',5),('7643','2013-06-27','07:55:00',5.3),('7643','2013-06-27','08:00:00',5.47),('7643','2013-06-27','08:05:00',5.36),('7643','2013-06-27','08:10:00',5.47),('7643','2013-06-27','08:15:00',6.24),('7643','2013-06-27','08:20:00',6.58),('7643','2013-06-27','08:25:00',6.37),('7643','2013-06-27','08:30:00',7.11),('7643','2013-06-27','08:35:00',7.57),('7643','2013-06-27','08:40:00',7.87),('7643','2013-06-27','08:45:00',8.14),('7643','2013-06-27','08:50:00',8.54),('7643','2013-06-27','08:55:00',8.8),('7643','2013-06-27','09:00:00',9.04),('7643','2013-06-27','09:05:00',9.58),('7643','2013-06-27','09:10:00',10.27),('7643','2013-06-27','09:15:00',5.34),('7643','2013-06-27','09:20:00',4.18),('7643','2013-06-27','09:25:00',3.38),('7643','2013-06-27','09:30:00',12),('7643','2013-06-27','09:35:00',10.88),('7643','2013-06-27','09:40:00',12.1),('7643','2013-06-27','09:45:00',6.56),('7643','2013-06-27','09:50:00',10.28),('7643','2013-06-27','09:55:00',13.86),('7643','2013-06-27','10:00:00',10.56),('7643','2013-06-27','10:05:00',11.08),('7643','2013-06-27','10:10:00',13.86),('7643','2013-06-27','10:15:00',14.59),('7643','2013-06-27','10:20:00',13.61),('7643','2013-06-27','10:25:00',4.97),('7643','2013-06-27','10:30:00',4.91),('7643','2013-06-27','10:35:00',15.89),('7643','2013-06-27','10:40:00',12.8),('7643','2013-06-27','10:45:00',9.45),('7643','2013-06-27','10:50:00',14.88),('7643','2013-06-27','10:55:00',7.41),('7643','2013-06-27','11:00:00',9.25),('7643','2013-06-27','11:05:00',15.91),('7643','2013-06-27','11:10:00',9.85),('7643','2013-06-27','11:15:00',7.93),('7643','2013-06-27','11:20:00',4.71),('7643','2013-06-27','11:25:00',9.86),('7643','2013-06-27','11:30:00',16.42),('7643','2013-06-27','11:35:00',11.44),('7643','2013-06-27','11:40:00',6.9),('7643','2013-06-27','11:45:00',13.63),('7643','2013-06-27','11:50:00',16.8),('7643','2013-06-27','11:55:00',17.89),('7643','2013-06-27','12:00:00',14.19),('7643','2013-06-27','12:05:00',18.36),('7643','2013-06-27','12:10:00',14.84),('7643','2013-06-27','12:15:00',17.64),('7643','2013-06-27','12:20:00',15.2),('7643','2013-06-27','12:25:00',17.45),('7643','2013-06-27','12:30:00',15.84),('7643','2013-06-27','12:35:00',17.64),('7643','2013-06-27','12:40:00',17.63),('7643','2013-06-27','12:45:00',16.8),('7643','2013-06-27','12:50:00',11.06),('7643','2013-06-27','12:55:00',16.32),('7643','2013-06-27','13:00:00',9.16),('7643','2013-06-27','13:05:00',15.8),('7643','2013-06-27','13:10:00',15.96),('7643','2013-06-27','13:15:00',17.51),('7643','2013-06-27','13:20:00',17.27),('7643','2013-06-27','13:25:00',17.02),('7643','2013-06-27','13:30:00',15.98),('7643','2013-06-27','13:35:00',17.39),('7643','2013-06-27','13:40:00',16.5),('7643','2013-06-27','13:45:00',16.6),('7643','2013-06-27','13:50:00',14.79),('7643','2013-06-27','13:55:00',16.19),('7643','2013-06-27','14:00:00',13.82),('7643','2013-06-27','14:05:00',15.33),('7643','2013-06-27','14:10:00',14.59),('7643','2013-06-27','14:15:00',16.17),('7643','2013-06-27','14:20:00',18.02),('7643','2013-06-27','14:25:00',17.36),('7643','2013-06-27','14:30:00',14.24),('7643','2013-06-27','14:35:00',16.28),('7643','2013-06-27','14:40:00',12.1),('7643','2013-06-27','14:45:00',12.87),('7643','2013-06-27','14:50:00',15.21),('7643','2013-06-27','14:55:00',13.42),('7643','2013-06-27','15:00:00',14.23),('7643','2013-06-27','15:05:00',15.9),('7643','2013-06-27','15:10:00',11.43),('7643','2013-06-27','15:15:00',7.15),('7643','2013-06-27','15:20:00',4.54),('7643','2013-06-27','15:25:00',13.63),('7643','2013-06-27','15:30:00',13.87),('7643','2013-06-27','15:35:00',16.06),('7643','2013-06-27','15:40:00',11.24),('7643','2013-06-27','15:45:00',8.15),('7643','2013-06-27','15:50:00',14.26),('7643','2013-06-27','15:55:00',10.72),('7643','2013-06-27','16:00:00',13.11),('7643','2013-06-27','16:05:00',14.79),('7643','2013-06-27','16:10:00',11.41),('7643','2013-06-27','16:15:00',12.81),('7643','2013-06-27','16:20:00',7.87),('7643','2013-06-27','16:25:00',6.3),('7643','2013-06-27','16:30:00',5.9),('7643','2013-06-27','16:35:00',7.52),('7643','2013-06-27','16:40:00',5.81),('7643','2013-06-27','16:45:00',3),('7643','2013-06-27','16:50:00',4.31),('7643','2013-06-27','16:55:00',5.29),('7643','2013-06-27','17:00:00',10.69),('7643','2013-06-27','17:05:00',10.16),('7643','2013-06-27','17:10:00',9.7),('7643','2013-06-27','17:15:00',8.56),('7643','2013-06-27','17:20:00',8.71),('7643','2013-06-27','17:25:00',8.69),('7643','2013-06-27','17:30:00',7.94),('7643','2013-06-27','17:35:00',7.81),('7643','2013-06-27','17:40:00',7.52),('7643','2013-06-27','17:45:00',7.37),('7643','2013-06-27','17:50:00',7.12),('7643','2013-06-27','17:55:00',6.72),('7643','2013-06-27','18:00:00',6.39),('7643','2013-06-27','18:05:00',5.98),('7643','2013-06-27','18:10:00',5.69),('7643','2013-06-27','18:15:00',5.65),('7643','2013-06-27','18:20:00',5.41),('7643','2013-06-27','18:25:00',5.08),('7643','2013-06-27','18:30:00',4.58),('7643','2013-06-27','18:35:00',4.18),('7643','2013-06-27','18:40:00',3.81),('7643','2013-06-27','18:45:00',3.61),('7643','2013-06-27','18:50:00',3.1),('7643','2013-06-27','18:55:00',2.72),('7643','2013-06-27','19:00:00',2.48),('7643','2013-06-27','19:05:00',2.2),('7643','2013-06-27','19:10:00',1.81),('7643','2013-06-27','19:15:00',1.22),('7643','2013-06-27','19:20:00',1.43),('7643','2013-06-27','19:25:00',1.55),('7643','2013-06-27','19:30:00',1.18),('7643','2013-06-27','19:35:00',1.02),('7643','2013-06-27','19:40:00',1.08),('7643','2013-06-27','19:45:00',1.11),('7643','2013-06-26','07:25:00',2.26),('7643','2013-06-26','07:30:00',3.33),('7643','2013-06-26','07:35:00',3.81),('7643','2013-06-26','07:40:00',4.08),('7643','2013-06-26','07:45:00',4.43),('7643','2013-06-26','07:50:00',4.88),('7643','2013-06-26','07:55:00',5.3),('7643','2013-06-26','08:00:00',5.57),('7643','2013-06-26','08:05:00',5.86),('7643','2013-06-26','08:10:00',6.23),('7643','2013-06-26','08:15:00',6.43),('7643','2013-06-26','08:20:00',6.75),('7643','2013-06-26','08:25:00',7.02),('7643','2013-06-26','08:30:00',7.32),('7643','2013-06-26','08:35:00',7.62),('7643','2013-06-26','08:40:00',7.9),('7643','2013-06-26','08:45:00',8.25),('7643','2013-06-26','08:50:00',8.58),('7643','2013-06-26','08:55:00',9.02),('7643','2013-06-26','09:00:00',9.44),('7643','2013-06-26','09:05:00',9.7),('7643','2013-06-26','09:10:00',10.03),('7643','2013-06-26','09:15:00',10.37),('7643','2013-06-26','09:20:00',10.79),('7643','2013-06-26','09:25:00',10.9),('7643','2013-06-26','09:30:00',11.2),('7643','2013-06-26','09:35:00',11.47),('7643','2013-06-26','09:40:00',11.66),('7643','2013-06-26','09:45:00',11.83),('7643','2013-06-26','09:50:00',12.23),('7643','2013-06-26','09:55:00',12.62),('7643','2013-06-26','10:00:00',13.01),('7643','2013-06-26','10:05:00',13.43),('7643','2013-06-26','10:10:00',13.1),('7643','2013-06-26','10:15:00',13.46),('7643','2013-06-26','10:20:00',13.52),('7643','2013-06-26','10:25:00',13.5),('7643','2013-06-26','10:30:00',13.77),('7643','2013-06-26','10:35:00',14.15),('7643','2013-06-26','10:40:00',14.72),('7643','2013-06-26','10:45:00',15),('7643','2013-06-26','10:50:00',14.98),('7643','2013-06-26','10:55:00',15.03),('7643','2013-06-26','11:00:00',14.99),('7643','2013-06-26','11:05:00',15.3),('7643','2013-06-26','11:10:00',10.89),('7643','2013-06-26','11:15:00',15.34),('7643','2013-06-26','11:20:00',15.88),('7643','2013-06-26','11:25:00',15.65),('7643','2013-06-26','11:30:00',15.66),('7643','2013-06-26','11:35:00',16.15),('7643','2013-06-26','11:40:00',16.55),('7643','2013-06-26','11:45:00',7.22),('7643','2013-06-26','11:50:00',4.64),('7643','2013-06-26','11:55:00',5.69),('7643','2013-06-26','12:00:00',8.05),('7643','2013-06-26','12:05:00',4.79),('7643','2013-06-26','12:10:00',5.02),('7643','2013-06-26','12:15:00',4.33),('7643','2013-06-26','12:20:00',4.53),('7643','2013-06-26','12:25:00',5.66),('7643','2013-06-26','12:30:00',5.79),('7643','2013-06-26','12:35:00',8.19),('7643','2013-06-26','12:40:00',8.16),('7643','2013-06-26','12:45:00',9.55),('7643','2013-06-26','12:50:00',6.33),('7643','2013-06-26','12:55:00',5.06),('7643','2013-06-26','13:00:00',3.51),('7643','2013-06-26','13:05:00',3.78),('7643','2013-06-26','13:10:00',4.72),('7643','2013-06-26','13:15:00',5.33),('7643','2013-06-26','13:20:00',5.44),('7643','2013-06-26','13:25:00',5.78),('7643','2013-06-26','13:30:00',5.14),('7643','2013-06-26','13:35:00',5.25),('7643','2013-06-26','13:40:00',4.29),('7643','2013-06-26','13:45:00',4.15),('7643','2013-06-26','13:50:00',4.5),('7643','2013-06-26','13:55:00',4.48),('7643','2013-06-26','14:00:00',4.92),('7643','2013-06-26','14:05:00',5.03),('7643','2013-06-26','14:10:00',7.93),('7643','2013-06-26','14:15:00',12.04),('7643','2013-06-26','14:20:00',7.59),('7643','2013-06-26','14:25:00',9),('7643','2013-06-26','14:30:00',15.7),('7643','2013-06-26','14:35:00',11.27),('7643','2013-06-26','14:40:00',8.23),('7643','2013-06-26','14:45:00',5.53),('7643','2013-06-26','14:50:00',6.46),('7643','2013-06-26','14:55:00',16.01),('7643','2013-06-26','15:00:00',15.4),('7643','2013-06-26','15:05:00',14.9),('7643','2013-06-26','15:10:00',14.6),('7643','2013-06-26','15:15:00',14.48),('7643','2013-06-26','15:20:00',14.31),('7643','2013-06-26','15:25:00',14.44),('7643','2013-06-26','15:30:00',14.18),('7643','2013-06-26','15:35:00',14.07),('7643','2013-06-26','15:40:00',13.85),('7643','2013-06-26','15:45:00',13.64),('7643','2013-06-26','15:50:00',13.46),('7643','2013-06-26','15:55:00',13.26),('7643','2013-06-26','16:00:00',12.85),('7643','2013-06-26','16:05:00',12.53),('7643','2013-06-26','16:10:00',12.34),('7643','2013-06-26','16:15:00',12.14),('7643','2013-06-26','16:20:00',11.95),('7643','2013-06-26','16:25:00',11.76),('7643','2013-06-26','16:30:00',11.57),('7643','2013-06-26','16:35:00',10.73),('7643','2013-06-26','16:40:00',10.64),('7643','2013-06-26','16:45:00',10.72),('7643','2013-06-26','16:50:00',10.3),('7643','2013-06-26','16:55:00',10.06),('7643','2013-06-26','17:00:00',9.87),('7643','2013-06-26','17:05:00',9.52),('7643','2013-06-26','17:10:00',8.96),('7643','2013-06-26','17:15:00',8.52),('7643','2013-06-26','17:20:00',8.69),('7643','2013-06-26','17:25:00',8.39),('7643','2013-06-26','17:30:00',8.2),('7643','2013-06-26','17:35:00',7.87),('7643','2013-06-26','17:40:00',5.18),('7643','2013-06-26','17:45:00',2.85),('7643','2013-06-26','17:50:00',6.57),('7643','2013-06-26','17:55:00',6.47),('7643','2013-06-26','18:00:00',6.06),('7643','2013-06-26','18:05:00',5.69),('7643','2013-06-26','18:10:00',5.31),('7643','2013-06-26','18:15:00',5.03),('7643','2013-06-26','18:20:00',4.78),('7643','2013-06-26','18:25:00',4.75),('7643','2013-06-26','18:30:00',4.44),('7643','2013-06-26','18:35:00',4.11),('7643','2013-06-26','18:40:00',3.57),('7643','2013-06-26','18:45:00',3.25),('7643','2013-06-26','18:50:00',2.99),('7643','2013-06-26','18:55:00',2.74),('7643','2013-06-26','19:00:00',2.45),('7643','2013-06-26','19:05:00',2.14),('7643','2013-06-26','19:10:00',1.91),('7643','2013-06-26','19:15:00',1.71),('7643','2013-06-26','19:20:00',1.44),('7643','2013-06-26','19:25:00',1.05),('7643','2013-06-25','06:45:00',1.08),('7643','2013-06-25','06:50:00',1.28),('7643','2013-06-25','06:55:00',1.54),('7643','2013-06-25','07:00:00',1.77),('7643','2013-06-25','07:05:00',2.05),('7643','2013-06-25','07:10:00',2.35),('7643','2013-06-25','07:15:00',2.65),('7643','2013-06-25','07:20:00',2.96),('7643','2013-06-25','07:25:00',3.26),('7643','2013-06-25','07:30:00',3.59),('7643','2013-06-25','07:35:00',3.97),('7643','2013-06-25','07:40:00',4.28),('7643','2013-06-25','07:45:00',4.66),('7643','2013-06-25','07:50:00',5.02),('7643','2013-06-25','07:55:00',5.28),('7643','2013-06-25','08:00:00',5.52),('7643','2013-06-25','08:05:00',5.81),('7643','2013-06-25','08:10:00',6.18),('7643','2013-06-25','08:15:00',6.45),('7643','2013-06-25','08:20:00',6.64),('7643','2013-06-25','08:25:00',7.02),('7643','2013-06-25','08:30:00',7.34),('7643','2013-06-25','08:35:00',7.66),('7643','2013-06-25','08:40:00',7.93),('7643','2013-06-25','08:45:00',8.26),('7643','2013-06-25','08:50:00',8.54),('7643','2013-06-25','08:55:00',8.82),('7643','2013-06-25','09:00:00',9.09),('7643','2013-06-25','09:05:00',9.42),('7643','2013-06-25','09:10:00',9.7),('7643','2013-06-25','09:15:00',10),('7643','2013-06-25','09:20:00',10.26),('7643','2013-06-25','09:25:00',10.64),('7643','2013-06-25','09:30:00',10.92),('7643','2013-06-25','09:35:00',11.14),('7643','2013-06-25','09:40:00',11.35),('7643','2013-06-25','09:45:00',11.57),('7643','2013-06-25','09:50:00',11.63),('7643','2013-06-25','09:55:00',11.87),('7643','2013-06-25','10:00:00',12.12),('7643','2013-06-25','10:05:00',12.39),('7643','2013-06-25','10:10:00',12.5),('7643','2013-06-25','10:15:00',12.72),('7643','2013-06-25','10:20:00',12.98),('7643','2013-06-25','10:25:00',13.13),('7643','2013-06-25','10:30:00',13.27),('7643','2013-06-25','10:35:00',13.51),('7643','2013-06-25','10:40:00',13.73),('7643','2013-06-25','10:45:00',13.82),('7643','2013-06-25','10:50:00',13.93),('7643','2013-06-25','10:55:00',14.07),('7643','2013-06-25','11:00:00',14.27),('7643','2013-06-25','11:05:00',14.36),('7643','2013-06-25','11:10:00',14.48),('7643','2013-06-25','11:15:00',14.53),('7643','2013-06-25','11:20:00',14.61),('7643','2013-06-25','11:25:00',14.76),('7643','2013-06-25','11:30:00',14.88),('7643','2013-06-25','11:35:00',14.99),('7643','2013-06-25','11:40:00',15.12),('7643','2013-06-25','11:45:00',15.33),('7643','2013-06-25','11:50:00',15.42),('7643','2013-06-25','11:55:00',15.53),('7643','2013-06-25','12:00:00',15.41),('7643','2013-06-25','12:05:00',15.29),('7643','2013-06-25','12:10:00',15.52),('7643','2013-06-25','12:15:00',15.74),('7643','2013-06-25','12:20:00',15.63),('7643','2013-06-25','12:25:00',15.45),('7643','2013-06-25','12:30:00',15.2),('7643','2013-06-25','12:35:00',12.46),('7643','2013-06-25','12:40:00',16),('7643','2013-06-25','12:45:00',16.73),('7643','2013-06-25','12:50:00',16.24),('7643','2013-06-25','12:55:00',15.24),('7643','2013-06-25','13:00:00',3.57),('7643','2013-06-25','13:05:00',9.11),('7643','2013-06-25','13:10:00',12.74),('7643','2013-06-25','13:15:00',17.52),('7643','2013-06-25','13:20:00',17.12),('7643','2013-06-25','13:25:00',15.57),('7643','2013-06-25','13:30:00',6.89),('7643','2013-06-25','13:35:00',3.57),('7643','2013-06-25','13:40:00',3.59),('7643','2013-06-25','13:45:00',4.07),('7643','2013-06-25','13:50:00',4.45),('7643','2013-06-25','13:55:00',6.1),('7643','2013-06-25','14:00:00',9.89),('7643','2013-06-25','14:05:00',15.61),('7643','2013-06-25','14:10:00',5.19),('7643','2013-06-25','14:15:00',9.23),('7643','2013-06-25','14:20:00',16.45),('7643','2013-06-25','14:25:00',9.37),('7643','2013-06-25','14:30:00',9.02),('7643','2013-06-25','14:35:00',6.16),('7643','2013-06-25','14:40:00',4.9),('7643','2013-06-25','14:45:00',9.92),('7643','2013-06-25','14:50:00',15.45),('7643','2013-06-25','14:55:00',16.74),('7643','2013-06-25','15:00:00',15.51),('7643','2013-06-25','15:05:00',15.18),('7643','2013-06-25','15:10:00',14.82),('7643','2013-06-25','15:15:00',14.58),('7643','2013-06-25','15:20:00',14.3),('7643','2013-06-25','15:25:00',14.16),('7643','2013-06-25','15:30:00',14.04),('7643','2013-06-25','15:35:00',14.29),('7643','2013-06-25','15:40:00',13.84),('7643','2013-06-25','15:45:00',13.5),('7643','2013-06-25','15:50:00',8.56),('7643','2013-06-25','15:55:00',13.37),('7643','2013-06-25','16:00:00',13.33),('7643','2013-06-25','16:05:00',12.92),('7643','2013-06-25','16:10:00',12.78),('7643','2013-06-25','16:15:00',12.56),('7643','2013-06-25','16:20:00',12.19),('7643','2013-06-25','16:25:00',11.95),('7643','2013-06-25','16:30:00',11.7),('7643','2013-06-25','16:35:00',11.49),('7643','2013-06-25','16:40:00',11.02),('7643','2013-06-25','16:45:00',10.78),('7643','2013-06-25','16:50:00',10.53),('7643','2013-06-25','16:55:00',10.23),('7643','2013-06-25','17:00:00',10.04),('7643','2013-06-25','17:05:00',9.82),('7643','2013-06-25','17:10:00',9.49),('7643','2013-06-25','17:15:00',9.02),('7643','2013-06-25','17:20:00',8.61),('7643','2013-06-25','17:25:00',8.31),('7643','2013-06-25','17:30:00',8.03),('7643','2013-06-25','17:35:00',7.74),('7643','2013-06-25','17:40:00',7.49),('7643','2013-06-25','17:45:00',7.17),('7643','2013-06-25','17:50:00',6.84),('7643','2013-06-25','17:55:00',6.51),('7643','2013-06-25','18:00:00',6.27),('7643','2013-06-25','18:05:00',6.42),('7643','2013-06-25','18:10:00',6.66),('7643','2013-06-25','18:15:00',2.83),('7643','2013-06-25','18:20:00',2.95),('7643','2013-06-25','18:25:00',2.87),('7643','2013-06-25','18:30:00',1.75),('7643','2013-06-25','18:35:00',1.51),('7643','2013-06-25','18:40:00',1.29),('7643','2013-06-25','18:45:00',1.13),('7643','2013-06-25','18:50:00',1.19),('7643','2013-06-25','18:55:00',1.25),('7643','2013-06-25','19:00:00',2.06),('7643','2013-06-25','19:05:00',1.54),('7643','2013-06-25','19:10:00',1.74),('7643','2013-06-25','19:15:00',2.06),('7643','2013-06-25','19:20:00',2.15),('7643','2013-06-25','19:25:00',1.88),('7643','2013-06-25','19:30:00',1.35),('7643','2013-06-25','19:35:00',1),('7643','2013-06-24','06:40:00',1.02),('7643','2013-06-24','06:45:00',1.2),('7643','2013-06-24','06:50:00',1.36),('7643','2013-06-24','06:55:00',1.54),('7643','2013-06-24','07:00:00',1.78),('7643','2013-06-24','07:05:00',2.04),('7643','2013-06-24','07:10:00',2.36),('7643','2013-06-24','07:15:00',2.62),('7643','2013-06-24','07:20:00',2.91),('7643','2013-06-24','07:25:00',3.13),('7643','2013-06-24','07:30:00',3.49),('7643','2013-06-24','07:35:00',3.89),('7643','2013-06-24','07:40:00',4.26),('7643','2013-06-24','07:45:00',4.62),('7643','2013-06-24','07:50:00',3.96),('7643','2013-06-24','07:55:00',5.62),('7643','2013-06-24','08:00:00',6.02),('7643','2013-06-24','08:05:00',6.85),('7643','2013-06-24','08:10:00',6.32),('7643','2013-06-24','08:15:00',4),('7643','2013-06-24','08:20:00',3.22),('7643','2013-06-24','08:25:00',6.93),('7643','2013-06-24','08:30:00',7.5),('7643','2013-06-24','08:35:00',7.82),('7643','2013-06-24','08:40:00',8.19),('7643','2013-06-24','08:45:00',8.53),('7643','2013-06-24','08:50:00',8.67),('7643','2013-06-24','08:55:00',8.99),('7643','2013-06-24','09:00:00',9.47),('7643','2013-06-24','09:05:00',9.79),('7643','2013-06-24','09:10:00',10.04),('7643','2013-06-24','09:15:00',10.4),('7643','2013-06-24','09:20:00',10.7),('7643','2013-06-24','09:25:00',10.99),('7643','2013-06-24','09:30:00',11.04),('7643','2013-06-24','09:35:00',10.29),('7643','2013-06-24','09:40:00',2.64),('7643','2013-06-24','09:45:00',2.8),('7643','2013-06-24','09:50:00',12.52),('7643','2013-06-24','09:55:00',13.56),('7643','2013-06-24','10:00:00',6.64),('7643','2013-06-24','10:05:00',13.99),('7643','2013-06-24','10:10:00',12.75),('7643','2013-06-24','10:15:00',14.6),('7643','2013-06-24','10:20:00',13.85),('7643','2013-06-24','10:25:00',9.96),('7643','2013-06-24','10:30:00',14.76),('7643','2013-06-24','10:35:00',15.06),('7643','2013-06-24','10:40:00',15.35),('7643','2013-06-24','10:45:00',14.84),('7643','2013-06-24','10:50:00',15.1),('7643','2013-06-24','10:55:00',14.96),('7643','2013-06-24','11:00:00',15.55),('7643','2013-06-24','11:05:00',16.33),('7643','2013-06-24','11:10:00',16.54),('7643','2013-06-24','11:15:00',14.5),('7643','2013-06-24','11:20:00',7.87),('7643','2013-06-24','11:25:00',8.86),('7643','2013-06-24','11:30:00',9.76),('7643','2013-06-24','11:35:00',18.34),('7643','2013-06-24','11:40:00',17.53),('7643','2013-06-24','11:45:00',17.32),('7643','2013-06-24','11:50:00',17.36),('7643','2013-06-24','11:55:00',16.75),('7643','2013-06-24','12:00:00',13.14),('7643','2013-06-24','12:05:00',5.34),('7643','2013-06-24','12:10:00',5.3),('7643','2013-06-24','12:15:00',4.74),('7643','2013-06-24','12:20:00',4.33),('7643','2013-06-24','12:25:00',3.83),('7643','2013-06-24','12:30:00',3.65),('7643','2013-06-24','12:35:00',4.08),('7643','2013-06-24','12:40:00',6.08),('7643','2013-06-24','12:45:00',5.42),('7643','2013-06-24','12:50:00',5.13),('7643','2013-06-24','12:55:00',6.41),('7643','2013-06-24','13:00:00',16.85),('7643','2013-06-24','13:05:00',16.39),('7643','2013-06-24','13:10:00',15.93),('7643','2013-06-24','13:15:00',17.33),('7643','2013-06-24','13:20:00',17.37),('7643','2013-06-24','13:25:00',17.2),('7643','2013-06-24','13:30:00',12.91),('7643','2013-06-24','13:35:00',15.19),('7643','2013-06-24','13:40:00',16.44),('7643','2013-06-24','13:45:00',12.88),('7643','2013-06-24','13:50:00',13.01),('7643','2013-06-24','13:55:00',8),('7643','2013-06-24','14:00:00',13.83),('7643','2013-06-24','14:05:00',17.77),('7643','2013-06-24','14:10:00',14.93),('7643','2013-06-24','14:15:00',15.22),('7643','2013-06-24','14:20:00',17.01),('7643','2013-06-24','14:25:00',16.51),('7643','2013-06-24','14:30:00',15.63),('7643','2013-06-24','14:35:00',15.93),('7643','2013-06-24','14:40:00',13.9),('7643','2013-06-24','14:45:00',16.01),('7643','2013-06-24','14:50:00',15.79),('7643','2013-06-24','14:55:00',15.7),('7643','2013-06-24','15:00:00',15.37),('7643','2013-06-24','15:05:00',15.06),('7643','2013-06-24','15:10:00',15.06),('7643','2013-06-24','15:15:00',15.15),('7643','2013-06-24','15:20:00',14.82),('7643','2013-06-24','15:25:00',14.48),('7643','2013-06-24','15:30:00',14.2),('7643','2013-06-24','15:35:00',13.95),('7643','2013-06-24','15:40:00',13.75),('7643','2013-06-24','15:45:00',13.46),('7643','2013-06-24','15:50:00',13.3),('7643','2013-06-24','15:55:00',13.08),('7643','2013-06-24','16:00:00',12.97),('7643','2013-06-24','16:05:00',12.78),('7643','2013-06-24','16:10:00',12.55),('7643','2013-06-24','16:15:00',12.33),('7643','2013-06-24','16:20:00',12),('7643','2013-06-24','16:25:00',11.72),('7643','2013-06-24','16:30:00',11.47),('7643','2013-06-24','16:35:00',11.23),('7643','2013-06-24','16:40:00',10.97),('7643','2013-06-24','16:45:00',10.75),('7643','2013-06-24','16:50:00',10.43),('7643','2013-06-24','16:55:00',10.2),('7643','2013-06-24','17:00:00',9.92),('7643','2013-06-24','17:05:00',9.65),('7643','2013-06-24','17:10:00',9.3),('7643','2013-06-24','17:15:00',8.97),('7643','2013-06-24','17:20:00',8.6),('7643','2013-06-24','17:25:00',8.32),('7643','2013-06-24','17:30:00',8),('7643','2013-06-24','17:35:00',7.64),('7643','2013-06-24','17:40:00',7.43),('7643','2013-06-24','17:45:00',7.09),('7643','2013-06-24','17:50:00',6.79),('7643','2013-06-24','17:55:00',6.51),('7643','2013-06-24','18:00:00',6.18),('7643','2013-06-24','18:05:00',5.79),('7643','2013-06-24','18:10:00',5.51),('7643','2013-06-24','18:15:00',5.18),('7643','2013-06-24','18:20:00',4.91),('7643','2013-06-24','18:25:00',4.6),('7643','2013-06-24','18:30:00',4.31),('7643','2013-06-24','18:35:00',4.04),('7643','2013-06-24','18:40:00',3.73),('7643','2013-06-24','18:45:00',3.34),('7643','2013-06-24','18:50:00',2.95),('7643','2013-06-24','18:55:00',2.65),('7643','2013-06-24','19:00:00',2.43),('7643','2013-06-24','19:05:00',2.14),('7643','2013-06-24','19:10:00',1.96),('7643','2013-06-24','19:15:00',1.72),('7643','2013-06-24','19:20:00',1.47),('7643','2013-06-24','19:25:00',1.3),('7643','2013-06-24','19:30:00',1.12),('7643','2013-06-23','07:00:00',1.06),('7643','2013-06-23','07:05:00',1.57),('7643','2013-06-23','07:10:00',2.96),('7643','2013-06-23','07:15:00',1.35),('7643','2013-06-23','07:20:00',1.57),('7643','2013-06-23','07:25:00',2.78),('7643','2013-06-23','07:30:00',2.54),('7643','2013-06-23','07:35:00',1.62),('7643','2013-06-23','07:40:00',1.91),('7643','2013-06-23','07:45:00',1.18),('7643','2013-06-23','07:50:00',2.92),('7643','2013-06-23','07:55:00',2.44),('7643','2013-06-23','08:15:00',1.16),('7643','2013-06-23','08:20:00',1.64),('7643','2013-06-23','08:25:00',1.28),('7643','2013-06-23','08:30:00',1.53),('7643','2013-06-23','08:35:00',2.9),('7643','2013-06-23','08:40:00',3.9),('7643','2013-06-23','08:45:00',9.25),('7643','2013-06-23','08:50:00',9.54),('7643','2013-06-23','08:55:00',9.88),('7643','2013-06-23','09:00:00',8.54),('7643','2013-06-23','09:05:00',10.55),('7643','2013-06-23','09:10:00',7.19),('7643','2013-06-23','09:15:00',10.69),('7643','2013-06-23','09:20:00',11.98),('7643','2013-06-23','09:25:00',11.61),('7643','2013-06-23','09:30:00',13.87),('7643','2013-06-23','09:35:00',8.65),('7643','2013-06-23','09:40:00',4.85),('7643','2013-06-23','09:45:00',10.8),('7643','2013-06-23','09:50:00',13.12),('7643','2013-06-23','09:55:00',12.95),('7643','2013-06-23','10:00:00',13.18),('7643','2013-06-23','10:05:00',13.38),('7643','2013-06-23','10:10:00',12.84),('7643','2013-06-23','10:15:00',12.47),('7643','2013-06-23','10:20:00',10.68),('7643','2013-06-23','10:25:00',15.41),('7643','2013-06-23','10:30:00',14.87),('7643','2013-06-23','10:35:00',15.63),('7643','2013-06-23','10:40:00',11.94),('7643','2013-06-23','10:45:00',8.06),('7643','2013-06-23','10:50:00',16.17),('7643','2013-06-23','10:55:00',7.96),('7643','2013-06-23','11:00:00',17.5),('7643','2013-06-23','11:05:00',16.51),('7643','2013-06-23','11:10:00',6.42),('7643','2013-06-23','11:15:00',9.09),('7643','2013-06-23','11:20:00',16.58),('7643','2013-06-23','11:25:00',5.59),('7643','2013-06-23','11:30:00',9.26),('7643','2013-06-23','11:35:00',5.46),('7643','2013-06-23','11:40:00',4.93),('7643','2013-06-23','11:45:00',6.04),('7643','2013-06-23','11:50:00',11.28),('7643','2013-06-23','11:55:00',8.18),('7643','2013-06-23','12:00:00',14.99),('7643','2013-06-23','12:05:00',16.32),('7643','2013-06-23','12:10:00',11.09),('7643','2013-06-23','12:15:00',11.67),('7643','2013-06-23','12:20:00',16.72),('7643','2013-06-23','12:25:00',19.37),('7643','2013-06-23','12:30:00',12.37),('7643','2013-06-23','12:35:00',14.93),('7643','2013-06-23','12:40:00',16.26),('7643','2013-06-23','12:45:00',11.89),('7643','2013-06-23','12:50:00',14.98),('7643','2013-06-23','12:55:00',17.03),('7643','2013-06-23','13:00:00',11.66),('7643','2013-06-23','13:05:00',15.68),('7643','2013-06-23','13:10:00',15.78),('7643','2013-06-23','13:15:00',13.09),('7643','2013-06-23','13:20:00',11.48),('7643','2013-06-23','13:25:00',11.99),('7643','2013-06-23','13:30:00',17.31),('7643','2013-06-23','13:35:00',16.25),('7643','2013-06-23','13:40:00',16.35),('7643','2013-06-23','13:45:00',14.31),('7643','2013-06-23','13:50:00',17.58),('7643','2013-06-23','13:55:00',17.14),('7643','2013-06-23','14:00:00',16.85),('7643','2013-06-23','14:05:00',16.99),('7643','2013-06-23','14:10:00',16.94),('7643','2013-06-23','14:15:00',16.87),('7643','2013-06-23','14:20:00',16.79),('7643','2013-06-23','14:25:00',16.76),('7643','2013-06-23','14:30:00',15.09),('7643','2013-06-23','14:35:00',16.85),('7643','2013-06-23','14:40:00',16.82),('7643','2013-06-23','14:45:00',16.48),('7643','2013-06-23','14:50:00',12.72),('7643','2013-06-23','14:55:00',14.37),('7643','2013-06-23','15:00:00',11.97),('7643','2013-06-23','15:05:00',10.67),('7643','2013-06-23','15:10:00',12.14),('7643','2013-06-23','15:15:00',14.82),('7643','2013-06-23','15:20:00',12.74),('7643','2013-06-23','15:25:00',11.86),('7643','2013-06-23','15:30:00',11.18),('7643','2013-06-23','15:35:00',11.84),('7643','2013-06-23','15:40:00',6.52),('7643','2013-06-23','15:45:00',15.81),('7643','2013-06-23','15:50:00',12.34),('7643','2013-06-23','15:55:00',14.5),('7643','2013-06-23','16:00:00',15.67),('7643','2013-06-23','16:05:00',12.97),('7643','2013-06-23','16:10:00',15.08),('7643','2013-06-23','16:15:00',14.34),('7643','2013-06-23','16:20:00',9.99),('7643','2013-06-23','16:25:00',7.61),('7643','2013-06-23','16:30:00',7.38),('7643','2013-06-23','16:35:00',11.14),('7643','2013-06-23','16:40:00',9.57),('7643','2013-06-23','16:45:00',7.5),('7643','2013-06-23','16:50:00',6.42),('7643','2013-06-23','16:55:00',5.03),('7643','2013-06-23','17:00:00',4.16),('7643','2013-06-23','17:05:00',8.42),('7643','2013-06-23','17:10:00',4.59),('7643','2013-06-23','17:15:00',11.21),('7643','2013-06-23','17:20:00',7.16),('7643','2013-06-23','17:25:00',6.87),('7643','2013-06-23','17:30:00',4.86),('7643','2013-06-23','17:35:00',3.56),('7643','2013-06-23','17:40:00',3.07),('7643','2013-06-23','17:45:00',2.94),('7643','2013-06-23','17:50:00',4.67),('7643','2013-06-23','17:55:00',4.25),('7643','2013-06-23','18:00:00',7.46),('7643','2013-06-23','18:05:00',7.25),('7643','2013-06-23','18:10:00',6.41),('7643','2013-06-23','18:15:00',5.21),('7643','2013-06-23','18:20:00',5.57),('7643','2013-06-23','18:25:00',3.63),('7643','2013-06-23','18:30:00',4.06),('7643','2013-06-23','18:35:00',4.57),('7643','2013-06-23','18:40:00',2.86),('7643','2013-06-23','18:45:00',3.81),('7643','2013-06-23','18:50:00',3.33),('7643','2013-06-23','18:55:00',2.76),('7643','2013-06-23','19:00:00',2.58),('7643','2013-06-23','19:05:00',2.42),('7643','2013-06-23','19:10:00',2.27),('7643','2013-06-23','19:15:00',2),('7643','2013-06-23','19:20:00',1.6),('7643','2013-06-23','19:25:00',1.43),('7643','2013-06-23','19:30:00',1.3),('7643','2013-06-23','19:35:00',1.09),('7643','2013-06-22','07:30:00',1.41),('7643','2013-06-22','07:35:00',1.54),('7643','2013-06-22','07:40:00',1.41),('7643','2013-06-22','07:45:00',1.04),('7643','2013-06-22','07:50:00',1.01),('7643','2013-06-22','07:55:00',1.04),('7643','2013-06-22','08:25:00',1.13),('7643','2013-06-22','08:30:00',1.74),('7643','2013-06-22','08:35:00',2.24),('7643','2013-06-22','08:40:00',2.68),('7643','2013-06-22','08:45:00',3.89),('7643','2013-06-22','08:50:00',5.6),('7643','2013-06-22','08:55:00',3.8),('7643','2013-06-22','09:00:00',6.35),('7643','2013-06-22','09:05:00',6.34),('7643','2013-06-22','09:10:00',2.1),('7643','2013-06-22','09:15:00',2.75),('7643','2013-06-22','09:20:00',6.6),('7643','2013-06-22','09:25:00',9.86),('7643','2013-06-22','09:30:00',11.03),('7643','2013-06-22','09:35:00',11.58),('7643','2013-06-22','09:40:00',12.74),('7643','2013-06-22','09:45:00',8.47),('7643','2013-06-22','09:50:00',4.4),('7643','2013-06-22','09:55:00',6.84),('7643','2013-06-22','10:00:00',13.8),('7643','2013-06-22','10:05:00',12.49),('7643','2013-06-22','10:10:00',13.77),('7643','2013-06-22','10:15:00',11.83),('7643','2013-06-22','10:20:00',7.05),('7643','2013-06-22','10:25:00',9.39),('7643','2013-06-22','10:30:00',5.58),('7643','2013-06-22','10:35:00',11.8),('7643','2013-06-22','10:40:00',14.75),('7643','2013-06-22','10:45:00',13.81),('7643','2013-06-22','10:50:00',13.76),('7643','2013-06-22','10:55:00',13.87),('7643','2013-06-22','11:00:00',14.15),('7643','2013-06-22','11:05:00',14.26),('7643','2013-06-22','11:10:00',14.45),('7643','2013-06-22','11:15:00',14.45),('7643','2013-06-22','11:20:00',14.9),('7643','2013-06-22','11:25:00',14.88),('7643','2013-06-22','11:30:00',14.73),('7643','2013-06-22','11:35:00',14.45),('7643','2013-06-22','11:40:00',14.78),('7643','2013-06-22','11:45:00',15.01),('7643','2013-06-22','11:50:00',15.48),('7643','2013-06-22','11:55:00',15.24),('7643','2013-06-22','12:00:00',15.35),('7643','2013-06-22','12:05:00',16.1),('7643','2013-06-22','12:10:00',15.89),('7643','2013-06-22','12:15:00',15.85),('7643','2013-06-22','12:20:00',16.13),('7643','2013-06-22','12:25:00',16.36),('7643','2013-06-22','12:30:00',16.29),('7643','2013-06-22','12:35:00',16.16),('7643','2013-06-22','12:40:00',16.18),('7643','2013-06-22','12:45:00',16.22),('7643','2013-06-22','12:50:00',16.27),('7643','2013-06-22','12:55:00',16.43),('7643','2013-06-22','13:00:00',16.47),('7643','2013-06-22','13:05:00',16.46),('7643','2013-06-22','13:10:00',16.43),('7643','2013-06-22','13:15:00',16.37),('7643','2013-06-22','13:20:00',16.26),('7643','2013-06-22','13:25:00',16.34),('7643','2013-06-22','13:30:00',16.27),('7643','2013-06-22','13:35:00',16.38),('7643','2013-06-22','13:40:00',16.48),('7643','2013-06-22','13:45:00',16.43),('7643','2013-06-22','13:50:00',16.39),('7643','2013-06-22','13:55:00',16.43),('7643','2013-06-22','14:00:00',16.38),('7643','2013-06-22','14:05:00',16.19),('7643','2013-06-22','14:10:00',16.2),('7643','2013-06-22','14:15:00',16.18),('7643','2013-06-22','14:20:00',15.95),('7643','2013-06-22','14:25:00',15.91),('7643','2013-06-22','14:30:00',15.95),('7643','2013-06-22','14:35:00',15.89),('7643','2013-06-22','14:40:00',15.82),('7643','2013-06-22','14:45:00',15.78),('7643','2013-06-22','14:50:00',15.67),('7643','2013-06-22','14:55:00',15.44),('7643','2013-06-22','15:00:00',15.39),('7643','2013-06-22','15:05:00',15.26),('7643','2013-06-22','15:10:00',15.08),('7643','2013-06-22','15:15:00',14.91),('7643','2013-06-22','15:20:00',14.68),('7643','2013-06-22','15:25:00',14.65),('7643','2013-06-22','15:30:00',14.47),('7643','2013-06-22','15:35:00',14.29),('7643','2013-06-22','15:40:00',14.01),('7643','2013-06-22','15:45:00',13.82),('7643','2013-06-22','15:50:00',13.62),('7643','2013-06-22','15:55:00',13.42),('7643','2013-06-22','16:00:00',13.19),('7643','2013-06-22','16:05:00',12.92),('7643','2013-06-22','16:10:00',12.71),('7643','2013-06-22','16:15:00',12.46),('7643','2013-06-22','16:20:00',12.28),('7643','2013-06-22','16:25:00',11.92),('7643','2013-06-22','16:30:00',11.71),('7643','2013-06-22','16:35:00',11.43),('7643','2013-06-22','16:40:00',11.21),('7643','2013-06-22','16:45:00',11.02),('7643','2013-06-22','16:50:00',10.74),('7643','2013-06-22','16:55:00',10.37),('7643','2013-06-22','17:00:00',10.13),('7643','2013-06-22','17:05:00',9.88),('7643','2013-06-22','17:10:00',9.58),('7643','2013-06-22','17:15:00',9.22),('7643','2013-06-22','17:20:00',8.35),('7643','2013-06-22','17:25:00',8.56),('7643','2013-06-22','17:30:00',8.16),('7643','2013-06-22','17:35:00',7.96),('7643','2013-06-22','17:40:00',7.67),('7643','2013-06-22','17:45:00',7.44),('7643','2013-06-22','17:50:00',7.11),('7643','2013-06-22','17:55:00',6.75),('7643','2013-06-22','18:00:00',6.45),('7643','2013-06-22','18:05:00',6.11),('7643','2013-06-22','18:10:00',5.79),('7643','2013-06-22','18:15:00',5.39),('7643','2013-06-22','18:20:00',5.07),('7643','2013-06-22','18:25:00',4.84),('7643','2013-06-22','18:30:00',4.44),('7643','2013-06-22','18:35:00',4.03),('7643','2013-06-22','18:40:00',3.2),('7643','2013-06-22','18:45:00',3.45),('7643','2013-06-22','18:50:00',3.11),('7643','2013-06-22','18:55:00',2.67),('7643','2013-06-22','19:00:00',2.13),('7643','2013-06-22','19:05:00',2.05),('7643','2013-06-22','19:10:00',1.84),('7643','2013-06-22','19:15:00',1.63),('7643','2013-06-21','06:40:00',1.04),('7643','2013-06-21','06:45:00',1.21),('7643','2013-06-21','06:50:00',1.37),('7643','2013-06-21','06:55:00',1.54),('7643','2013-06-21','07:00:00',1.77),('7643','2013-06-21','07:05:00',2.02),('7643','2013-06-21','07:10:00',2.3),('7643','2013-06-21','07:15:00',2.56),('7643','2013-06-21','07:20:00',2.84),('7643','2013-06-21','07:25:00',3.11),('7643','2013-06-21','07:30:00',3.42),('7643','2013-06-21','07:35:00',3.69),('7643','2013-06-21','07:40:00',3.96),('7643','2013-06-21','07:45:00',4.29),('7643','2013-06-21','07:50:00',4.59),('7643','2013-06-21','07:55:00',4.89),('7643','2013-06-21','08:00:00',5.17),('7643','2013-06-21','08:05:00',5.39),('7643','2013-06-21','08:10:00',5.66),('7643','2013-06-21','08:15:00',5.9),('7643','2013-06-21','08:20:00',6.26),('7643','2013-06-21','08:25:00',6.61),('7643','2013-06-21','08:30:00',7.04),('7643','2013-06-21','08:35:00',7.32),('7643','2013-06-21','08:40:00',7.69),('7643','2013-06-21','08:45:00',8.07),('7643','2013-06-21','08:50:00',8.32),('7643','2013-06-21','08:55:00',8.6),('7643','2013-06-21','09:00:00',8.85),('7643','2013-06-21','09:05:00',9.07),('7643','2013-06-21','09:10:00',9.36),('7643','2013-06-21','09:15:00',9.64),('7643','2013-06-21','09:20:00',9.89),('7643','2013-06-21','09:25:00',10.08),('7643','2013-06-21','09:30:00',10.3),('7643','2013-06-21','09:35:00',10.6),('7643','2013-06-21','09:40:00',10.85),('7643','2013-06-21','09:45:00',11.05),('7643','2013-06-21','09:50:00',11.25),('7643','2013-06-21','09:55:00',11.51),('7643','2013-06-21','10:00:00',11.69),('7643','2013-06-21','10:05:00',12.06),('7643','2013-06-21','10:10:00',12.26),('7643','2013-06-21','10:15:00',12.41),('7643','2013-06-21','10:20:00',12.72),('7643','2013-06-21','10:25:00',12.92),('7643','2013-06-21','10:30:00',12.9),('7643','2013-06-21','10:35:00',13.07),('7643','2013-06-21','10:40:00',13.3),('7643','2013-06-21','10:45:00',13.54),('7643','2013-06-21','10:50:00',13.76),('7643','2013-06-21','10:55:00',13.93),('7643','2013-06-21','11:00:00',14.01),('7643','2013-06-21','11:05:00',14.12),('7643','2013-06-21','11:10:00',14.25),('7643','2013-06-21','11:15:00',14.33),('7643','2013-06-21','11:20:00',14.48),('7643','2013-06-21','11:25:00',14.64),('7643','2013-06-21','11:30:00',14.71),('7643','2013-06-21','11:35:00',14.9),('7643','2013-06-21','11:40:00',15.02),('7643','2013-06-21','11:45:00',15.06),('7643','2013-06-21','11:50:00',15.14),('7643','2013-06-21','11:55:00',15.26),('7643','2013-06-21','12:00:00',15.28),('7643','2013-06-21','12:05:00',15.12),('7643','2013-06-21','12:10:00',14.87),('7643','2013-06-21','12:15:00',15.5),('7643','2013-06-21','12:20:00',15.45),('7643','2013-06-21','12:25:00',15.25),('7643','2013-06-21','12:30:00',15.62),('7643','2013-06-21','12:35:00',15.8),('7643','2013-06-21','12:40:00',15.9),('7643','2013-06-21','12:45:00',15.66),('7643','2013-06-21','12:50:00',15.51),('7643','2013-06-21','12:55:00',15.37),('7643','2013-06-21','13:00:00',15.29),('7643','2013-06-21','13:05:00',15.34),('7643','2013-06-21','13:10:00',15.01),('7643','2013-06-21','13:15:00',14.83),('7643','2013-06-21','13:20:00',14.48),('7643','2013-06-21','13:25:00',14.69),('7643','2013-06-21','13:30:00',16.21),('7643','2013-06-21','13:35:00',16.54),('7643','2013-06-21','13:40:00',15.24),('7643','2013-06-21','13:45:00',15.34),('7643','2013-06-21','13:50:00',16.03),('7643','2013-06-21','13:55:00',13.4),('7643','2013-06-21','14:00:00',9.06),('7643','2013-06-21','14:05:00',17.5),('7643','2013-06-21','14:10:00',16.63),('7643','2013-06-21','14:15:00',16.46),('7643','2013-06-21','14:20:00',13.76),('7643','2013-06-21','14:25:00',16.39),('7643','2013-06-21','14:30:00',12.24),('7643','2013-06-21','14:35:00',8.61),('7643','2013-06-21','14:40:00',6.58),('7643','2013-06-21','14:45:00',7.32),('7643','2013-06-21','14:50:00',14.13),('7643','2013-06-21','14:55:00',13.81),('7643','2013-06-21','15:00:00',14.99),('7643','2013-06-21','15:05:00',12.48),('7643','2013-06-21','15:10:00',14.34),('7643','2013-06-21','15:15:00',15.68),('7643','2013-06-21','15:20:00',14.19),('7643','2013-06-21','15:25:00',13.18),('7643','2013-06-21','15:30:00',8.71),('7643','2013-06-21','15:35:00',7.45),('7643','2013-06-21','15:40:00',6.77),('7643','2013-06-21','15:45:00',9.6),('7643','2013-06-21','15:50:00',9.74),('7643','2013-06-21','15:55:00',9.22),('7643','2013-06-21','16:00:00',7.66),('7643','2013-06-21','16:05:00',4.77),('7643','2013-06-21','16:10:00',4.62),('7643','2013-06-21','16:15:00',5.94),('7643','2013-06-21','16:20:00',7.14),('7643','2013-06-21','16:25:00',4.99),('7643','2013-06-21','16:30:00',3.81),('7643','2013-06-21','16:35:00',3.21),('7643','2013-06-21','16:40:00',2.92),('7643','2013-06-21','16:45:00',2.78),('7643','2013-06-21','16:50:00',3.03),('7643','2013-06-21','16:55:00',4.23),('7643','2013-06-21','17:00:00',5.54),('7643','2013-06-21','17:05:00',5.27),('7643','2013-06-21','17:10:00',7.27),('7643','2013-06-21','17:15:00',10.72),('7643','2013-06-21','17:20:00',9.99),('7643','2013-06-21','17:25:00',10.01),('7643','2013-06-21','17:30:00',7.66),('7643','2013-06-21','17:35:00',7.39),('7643','2013-06-21','17:40:00',8.05),('7643','2013-06-21','17:45:00',7.85),('7643','2013-06-21','17:50:00',7.23),('7643','2013-06-21','17:55:00',6.91),('7643','2013-06-21','18:00:00',6.33),('7643','2013-06-21','18:05:00',5.17),('7643','2013-06-21','18:10:00',3.63),('7643','2013-06-21','18:15:00',3.44),('7643','2013-06-21','18:20:00',3.53),('7643','2013-06-21','18:25:00',2.24),('7643','2013-06-21','18:30:00',1.7),('7643','2013-06-21','18:35:00',2.05),('7643','2013-06-21','18:40:00',2.1),('7643','2013-06-21','18:45:00',1.61),('7643','2013-06-21','18:50:00',1.4),('7643','2013-06-21','18:55:00',1.44),('7643','2013-06-21','19:00:00',1.68),('7643','2013-06-21','19:05:00',1.36),('7643','2013-06-21','19:10:00',1.39),('7643','2013-06-21','19:15:00',1.85),('7643','2013-06-21','19:20:00',1.82),('7643','2013-06-21','19:25:00',1.76),('7643','2013-06-21','19:30:00',1.4),('7643','2013-06-21','19:35:00',1.31),('7643','2013-06-21','19:40:00',1.25),('7643','2013-06-21','19:45:00',1.05),('7643','2013-06-20','06:40:00',1.02),('7643','2013-06-20','06:45:00',1.18),('7643','2013-06-20','06:50:00',1.36),('7643','2013-06-20','06:55:00',1.54),('7643','2013-06-20','07:00:00',1.76),('7643','2013-06-20','07:05:00',2.02),('7643','2013-06-20','07:10:00',2.32),('7643','2013-06-20','07:15:00',2.57),('7643','2013-06-20','07:20:00',2.82),('7643','2013-06-20','07:25:00',3.09),('7643','2013-06-20','07:30:00',3.37),('7643','2013-06-20','07:35:00',3.65),('7643','2013-06-20','07:40:00',3.94),('7643','2013-06-20','07:45:00',4.28),('7643','2013-06-20','07:50:00',4.57),('7643','2013-06-20','07:55:00',4.9),('7643','2013-06-20','08:00:00',5.18),('7643','2013-06-20','08:05:00',5.45),('7643','2013-06-20','08:10:00',5.71),('7643','2013-06-20','08:15:00',5.96),('7643','2013-06-20','08:20:00',6.27),('7643','2013-06-20','08:25:00',6.51),('7643','2013-06-20','08:30:00',6.86),('7643','2013-06-20','08:35:00',7.23),('7643','2013-06-20','08:40:00',7.51),('7643','2013-06-20','08:45:00',7.72),('7643','2013-06-20','08:50:00',7.94),('7643','2013-06-20','08:55:00',8.22),('7643','2013-06-20','09:00:00',8.48),('7643','2013-06-20','09:05:00',8.79),('7643','2013-06-20','09:10:00',8.98),('7643','2013-06-20','09:15:00',9.3),('7643','2013-06-20','09:20:00',9.64),('7643','2013-06-20','09:25:00',9.81),('7643','2013-06-20','09:30:00',9.96),('7643','2013-06-20','09:35:00',10.23),('7643','2013-06-20','09:40:00',10.39),('7643','2013-06-20','09:45:00',10.43),('7643','2013-06-20','09:50:00',10.69),('7643','2013-06-20','09:55:00',10.85),('7643','2013-06-20','10:00:00',11.09),('7643','2013-06-20','10:05:00',11.32),('7643','2013-06-20','10:10:00',11.15),('7643','2013-06-20','10:15:00',11.28),('7643','2013-06-20','10:20:00',11.66),('7643','2013-06-20','10:25:00',11.97),('7643','2013-06-20','10:30:00',12.15),('7643','2013-06-20','10:35:00',12.27),('7643','2013-06-20','10:40:00',12.39),('7643','2013-06-20','10:45:00',12.59),('7643','2013-06-20','10:50:00',12.8),('7643','2013-06-20','10:55:00',12.91),('7643','2013-06-20','11:00:00',12.96),('7643','2013-06-20','11:05:00',13),('7643','2013-06-20','11:10:00',13.02),('7643','2013-06-20','11:15:00',13.43),('7643','2013-06-20','11:20:00',13.64),('7643','2013-06-20','11:25:00',13.75),('7643','2013-06-20','11:30:00',13.9),('7643','2013-06-20','11:35:00',13.96),('7643','2013-06-20','11:40:00',13.95),('7643','2013-06-20','11:45:00',14.02),('7643','2013-06-20','11:50:00',14.26),('7643','2013-06-20','11:55:00',14.36),('7643','2013-06-20','12:00:00',14.46),('7643','2013-06-20','12:05:00',14.62),('7643','2013-06-20','12:10:00',14.5),('7643','2013-06-20','12:15:00',14.34),('7643','2013-06-20','12:20:00',14.5),('7643','2013-06-20','12:25:00',14.58),('7643','2013-06-20','12:30:00',14.77),('7643','2013-06-20','12:35:00',14.62),('7643','2013-06-20','12:40:00',14.52),('7643','2013-06-20','12:45:00',14.45),('7643','2013-06-20','12:50:00',14.71),('7643','2013-06-20','12:55:00',14.36),('7643','2013-06-20','13:00:00',14.55),('7643','2013-06-20','13:05:00',14.67),('7643','2013-06-20','13:10:00',14.29),('7643','2013-06-20','13:15:00',14.56),('7643','2013-06-20','13:20:00',14.74),('7643','2013-06-20','13:25:00',14.89),('7643','2013-06-20','13:30:00',14.98),('7643','2013-06-20','13:35:00',15.12),('7643','2013-06-20','13:40:00',15.12),('7643','2013-06-20','13:45:00',15.19),('7643','2013-06-20','13:50:00',15.2),('7643','2013-06-20','13:55:00',14.89),('7643','2013-06-20','14:00:00',14.88),('7643','2013-06-20','14:05:00',14.96),('7643','2013-06-20','14:10:00',14.9),('7643','2013-06-20','14:15:00',14.81),('7643','2013-06-20','14:20:00',14.94),('7643','2013-06-20','14:25:00',14.95),('7643','2013-06-20','14:30:00',14.97),('7643','2013-06-20','14:35:00',14.87),('7643','2013-06-20','14:40:00',14.7),('7643','2013-06-20','14:45:00',14.68),('7643','2013-06-20','14:50:00',14.73),('7643','2013-06-20','14:55:00',14.61),('7643','2013-06-20','15:00:00',14.48),('7643','2013-06-20','15:05:00',14.37),('7643','2013-06-20','15:10:00',14.16),('7643','2013-06-20','15:15:00',13.92),('7643','2013-06-20','15:20:00',13.77),('7643','2013-06-20','15:25:00',13.66),('7643','2013-06-20','15:30:00',13.59),('7643','2013-06-20','15:35:00',13.46),('7643','2013-06-20','15:40:00',13.29),('7643','2013-06-20','15:45:00',13.09),('7643','2013-06-20','15:50:00',12.93),('7643','2013-06-20','15:55:00',12.73),('7643','2013-06-20','16:00:00',12.56),('7643','2013-06-20','16:05:00',12.36),('7643','2013-06-20','16:10:00',12.17),('7643','2013-06-20','16:15:00',11.9),('7643','2013-06-20','16:20:00',11.61),('7643','2013-06-20','16:25:00',11.38),('7643','2013-06-20','16:30:00',11.16),('7643','2013-06-20','16:35:00',10.96),('7643','2013-06-20','16:40:00',10.67),('7643','2013-06-20','16:45:00',10.4),('7643','2013-06-20','16:50:00',10.14),('7643','2013-06-20','16:55:00',9.94),('7643','2013-06-20','17:00:00',9.69),('7643','2013-06-20','17:05:00',9.4),('7643','2013-06-20','17:10:00',9.08),('7643','2013-06-20','17:15:00',8.74),('7643','2013-06-20','17:20:00',8.4),('7643','2013-06-20','17:25:00',8.12),('7643','2013-06-20','17:30:00',7.75),('7643','2013-06-20','17:35:00',7.56),('7643','2013-06-20','17:40:00',7.3),('7643','2013-06-20','17:45:00',6.99),('7643','2013-06-20','17:50:00',6.68),('7643','2013-06-20','17:55:00',6.34),('7643','2013-06-20','18:00:00',5.98),('7643','2013-06-20','18:05:00',5.68),('7643','2013-06-20','18:10:00',5.42),('7643','2013-06-20','18:15:00',5.13),('7643','2013-06-20','18:20:00',4.78),('7643','2013-06-20','18:25:00',4.46),('7643','2013-06-20','18:30:00',4.15),('7643','2013-06-20','18:35:00',3.84),('7643','2013-06-20','18:40:00',3.49),('7643','2013-06-20','18:45:00',3.12),('7643','2013-06-20','18:50:00',2.78),('7643','2013-06-20','18:55:00',2.52),('7643','2013-06-20','19:00:00',2.24),('7643','2013-06-20','19:05:00',2.02),('7643','2013-06-20','19:10:00',1.79),('7643','2013-06-20','19:15:00',1.53),('7643','2013-06-20','19:20:00',1.3),('7643','2013-06-20','19:25:00',1.14),('7643','2014-04-03','08:30:00',1.35),('7643','2014-04-03','08:35:00',2.12),('7643','2014-04-03','08:40:00',2.89),('7643','2014-04-03','08:45:00',2.99),('7643','2014-04-03','08:50:00',3.27),('7643','2014-04-03','08:55:00',3.2),('7643','2014-04-03','09:00:00',3.23),('7643','2014-04-03','09:05:00',5.15),('7643','2014-04-03','09:10:00',7.03),('7643','2014-04-03','09:15:00',6.25),('7643','2014-04-03','09:20:00',4.27),('7643','2014-04-03','09:25:00',3.61),('7643','2014-04-03','09:30:00',3.47),('7643','2014-04-03','09:35:00',3.56),('7643','2014-04-03','09:40:00',3.39),('7643','2014-04-03','09:45:00',3.42),('7643','2014-04-03','09:50:00',3.14),('7643','2014-04-03','09:55:00',2.19),('7643','2014-04-03','10:00:00',1.46),('7643','2014-04-03','10:05:00',1.3),('7643','2014-04-03','10:10:00',1.12),('7643','2014-04-03','10:15:00',1.53),('7643','2014-04-03','10:20:00',1.23),('7643','2014-04-03','10:25:00',1.11),('7643','2014-04-03','10:30:00',1.19),('7643','2014-04-03','10:55:00',1.77),('7643','2014-04-03','11:00:00',1.17),('7643','2014-04-03','11:15:00',2.05),('7643','2014-04-03','11:20:00',2.12),('7643','2014-04-03','11:25:00',1.47),('7643','2014-04-03','11:30:00',1.08),('7643','2014-04-03','12:15:00',1.79),('7643','2014-04-03','12:20:00',1.28),('7643','2014-04-03','12:30:00',1.12),('7643','2014-04-03','12:40:00',1.25),('7643','2014-04-03','12:45:00',1.88),('7643','2014-04-03','12:50:00',2.59),('7643','2014-04-03','12:55:00',2.3),('7643','2014-04-03','13:00:00',2.68),('7643','2014-04-03','13:05:00',2.04),('7643','2014-04-03','13:10:00',2.56),('7643','2014-04-03','13:15:00',2.71),('7643','2014-04-03','13:20:00',6.18),('7643','2014-04-03','13:25:00',9.92),('7643','2014-04-03','13:30:00',9.93),('7643','2014-04-03','13:35:00',11.67),('7643','2014-04-03','13:40:00',17.04),('7643','2014-04-03','13:45:00',14.9),('7643','2014-04-03','13:50:00',14.31),('7643','2014-04-03','13:55:00',10.11),('7643','2014-04-03','14:00:00',9.12),('7643','2014-04-03','14:05:00',16.35),('7643','2014-04-03','14:10:00',11.1),('7643','2014-04-03','14:15:00',16.88),('7643','2014-04-03','14:20:00',12.19),('7643','2014-04-03','14:25:00',13.39),('7643','2014-04-03','14:30:00',5.58),('7643','2014-04-03','14:35:00',13.73),('7643','2014-04-03','14:40:00',6.45),('7643','2014-04-03','14:45:00',12.95),('7643','2014-04-03','14:50:00',13.7),('7643','2014-04-03','14:55:00',15.49),('7643','2014-04-03','15:00:00',15.66),('7643','2014-04-03','15:05:00',15.78),('7643','2014-04-03','15:10:00',15.99),('7643','2014-04-03','15:15:00',13.85),('7643','2014-04-03','15:20:00',9.06),('7643','2014-04-03','15:25:00',7.43),('7643','2014-04-03','15:30:00',7.19),('7643','2014-04-03','15:35:00',6.81),('7643','2014-04-03','15:40:00',11.23),('7643','2014-04-03','15:45:00',8.32),('7643','2014-04-03','15:50:00',7.9),('7643','2014-04-03','15:55:00',11.92),('7643','2014-04-03','16:00:00',9.6),('7643','2014-04-03','16:05:00',6.13),('7643','2014-04-03','16:10:00',7.51),('7643','2014-04-03','16:15:00',6.42),('7643','2014-04-03','16:20:00',3.98),('7643','2014-04-03','16:25:00',3.67),('7643','2014-04-03','16:30:00',9.48),('7643','2014-04-03','16:35:00',7.25),('7643','2014-04-03','16:40:00',5.22),('7643','2014-04-03','16:45:00',10.95),('7643','2014-04-03','16:50:00',11.85),('7643','2014-04-03','16:55:00',8.67),('7643','2014-04-03','17:00:00',7.76),('7643','2014-04-03','17:05:00',7.93),('7643','2014-04-03','17:10:00',8.28),('7643','2014-04-03','17:15:00',8.63),('7643','2014-04-03','17:20:00',6.78),('7643','2014-04-03','17:25:00',7.35),('7643','2014-04-03','17:30:00',7.3),('7643','2014-04-03','17:35:00',5.22),('7643','2014-04-03','17:40:00',6.41),('7643','2014-04-03','17:45:00',5.95),('7643','2014-04-03','17:50:00',5.66),('7643','2014-04-03','17:55:00',5.16),('7643','2014-04-03','18:00:00',4.53),('7643','2014-04-03','18:05:00',4.07),('7643','2014-04-03','18:10:00',3.6),('7643','2014-04-03','18:15:00',3.18),('7643','2014-04-03','18:20:00',2.73),('7643','2014-04-03','18:25:00',2.39),('7643','2014-04-03','18:30:00',2.12),('7643','2014-04-03','18:35:00',1.83),('7643','2014-04-03','18:40:00',1.54),('7643','2014-04-03','18:45:00',1.17),('7643','2014-04-03','18:50:00',1.13),('7643','2013-06-19','06:45:00',1.09),('7643','2013-06-19','06:50:00',1.22),('7643','2013-06-19','06:55:00',1.41),('7643','2013-06-19','07:00:00',1.65),('7643','2013-06-19','07:05:00',1.92),('7643','2013-06-19','07:10:00',2.21),('7643','2013-06-19','07:15:00',2.45),('7643','2013-06-19','07:20:00',2.66),('7643','2013-06-19','07:25:00',2.9),('7643','2013-06-19','07:30:00',3.12),('7643','2013-06-19','07:35:00',3.11),('7643','2013-06-19','07:40:00',3.46),('7643','2013-06-19','07:45:00',3.79),('7643','2013-06-19','07:50:00',4.29),('7643','2013-06-19','07:55:00',4.68),('7643','2013-06-19','08:00:00',5.07),('7643','2013-06-19','08:05:00',5.39),('7643','2013-06-19','08:10:00',5.75),('7643','2013-06-19','08:15:00',6.01),('7643','2013-06-19','08:20:00',6.34),('7643','2013-06-19','08:25:00',6.61),('7643','2013-06-19','08:30:00',6.99),('7643','2013-06-19','08:35:00',7.33),('7643','2013-06-19','08:40:00',7.62),('7643','2013-06-19','08:45:00',7.9),('7643','2013-06-19','08:50:00',8.13),('7643','2013-06-19','08:55:00',8.4),('7643','2013-06-19','09:00:00',8.71),('7643','2013-06-19','09:05:00',9.06),('7643','2013-06-19','09:10:00',9.3),('7643','2013-06-19','09:15:00',9.51),('7643','2013-06-19','09:20:00',9.81),('7643','2013-06-19','09:25:00',9.99),('7643','2013-06-19','09:30:00',10.26),('7643','2013-06-19','09:35:00',10.43),('7643','2013-06-19','09:40:00',10.73),('7643','2013-06-19','09:45:00',10.99),('7643','2013-06-19','09:50:00',11.2),('7643','2013-06-19','09:55:00',11.39),('7643','2013-06-19','10:00:00',11.52),('7643','2013-06-19','10:05:00',11.75),('7643','2013-06-19','10:10:00',11.94),('7643','2013-06-19','10:15:00',12),('7643','2013-06-19','10:20:00',12.2),('7643','2013-06-19','10:25:00',12.5),('7643','2013-06-19','10:30:00',12.64),('7643','2013-06-19','10:35:00',12.79),('7643','2013-06-19','10:40:00',12.89),('7643','2013-06-19','10:45:00',12.92),('7643','2013-06-19','10:50:00',13.06),('7643','2013-06-19','10:55:00',13.23),('7643','2013-06-19','11:00:00',13.41),('7643','2013-06-19','11:05:00',13.5),('7643','2013-06-19','11:10:00',13.55),('7643','2013-06-19','11:15:00',13.42),('7643','2013-06-19','11:20:00',13.32),('7643','2013-06-19','11:25:00',13.57),('7643','2013-06-19','11:30:00',13.83),('7643','2013-06-19','11:35:00',14.11),('7643','2013-06-19','11:40:00',14.22),('7643','2013-06-19','11:45:00',14.28),('7643','2013-06-19','11:50:00',14),('7643','2013-06-19','11:55:00',13.99),('7643','2013-06-19','12:00:00',14.26),('7643','2013-06-19','12:05:00',14.31),('7643','2013-06-19','12:10:00',14.02),('7643','2013-06-19','12:15:00',14.11),('7643','2013-06-19','12:20:00',14.21),('7643','2013-06-19','12:25:00',14.82),('7643','2013-06-19','12:30:00',14.93),('7643','2013-06-19','12:35:00',15.3),('7643','2013-06-19','12:40:00',13.12),('7643','2013-06-19','12:45:00',15.1),('7643','2013-06-19','12:50:00',13.84),('7643','2013-06-19','12:55:00',7.86),('7643','2013-06-19','13:00:00',15.39),('7643','2013-06-19','13:05:00',15.77),('7643','2013-06-19','13:10:00',14.97),('7643','2013-06-19','13:15:00',14.96),('7643','2013-06-19','13:20:00',14.84),('7643','2013-06-19','13:25:00',12.45),('7643','2013-06-19','13:30:00',14.07),('7643','2013-06-19','13:35:00',15.21),('7643','2013-06-19','13:40:00',15.21),('7643','2013-06-19','13:45:00',15.2),('7643','2013-06-19','13:50:00',15.31),('7643','2013-06-19','13:55:00',15.11),('7643','2013-06-19','14:00:00',15.43),('7643','2013-06-19','14:05:00',15.6),('7643','2013-06-19','14:10:00',15.25),('7643','2013-06-19','14:15:00',15.39),('7643','2013-06-19','14:20:00',15.48),('7643','2013-06-19','14:25:00',15.29),('7643','2013-06-19','14:30:00',15.19),('7643','2013-06-19','14:35:00',15.31),('7643','2013-06-19','14:40:00',15.39),('7643','2013-06-19','14:45:00',15.22),('7643','2013-06-19','14:50:00',15.17),('7643','2013-06-19','14:55:00',15.1),('7643','2013-06-19','15:00:00',14.94),('7643','2013-06-19','15:05:00',14.76),('7643','2013-06-19','15:10:00',14.62),('7643','2013-06-19','15:15:00',14.44),('7643','2013-06-19','15:20:00',14.24),('7643','2013-06-19','15:25:00',14.01),('7643','2013-06-19','15:30:00',13.91),('7643','2013-06-19','15:35:00',13.7),('7643','2013-06-19','15:40:00',13.57),('7643','2013-06-19','15:45:00',13.34),('7643','2013-06-19','15:50:00',13.08),('7643','2013-06-19','15:55:00',12.94),('7643','2013-06-19','16:00:00',12.76),('7643','2013-06-19','16:05:00',12.53),('7643','2013-06-19','16:10:00',12.32),('7643','2013-06-19','16:15:00',12.18),('7643','2013-06-19','16:20:00',11.94),('7643','2013-06-19','16:25:00',11.6),('7643','2013-06-19','16:30:00',11.35),('7643','2013-06-19','16:35:00',11.22),('7643','2013-06-19','16:40:00',10.89),('7643','2013-06-19','16:45:00',10.61),('7643','2013-06-19','16:50:00',10.28),('7643','2013-06-19','16:55:00',9.99),('7643','2013-06-19','17:00:00',9.74),('7643','2013-06-19','17:05:00',9.42),('7643','2013-06-19','17:10:00',9.17),('7643','2013-06-19','17:15:00',8.82),('7643','2013-06-19','17:20:00',8.49),('7643','2013-06-19','17:25:00',8.17),('7643','2013-06-19','17:30:00',7.85),('7643','2013-06-19','17:35:00',7.58),('7643','2013-06-19','17:40:00',7.35),('7643','2013-06-19','17:45:00',7.11),('7643','2013-06-19','17:50:00',6.84),('7643','2013-06-19','17:55:00',6.46),('7643','2013-06-19','18:00:00',6.11),('7643','2013-06-19','18:05:00',5.83),('7643','2013-06-19','18:10:00',5.56),('7643','2013-06-19','18:15:00',5.24),('7643','2013-06-19','18:20:00',4.94),('7643','2013-06-19','18:25:00',4.61),('7643','2013-06-19','18:30:00',4.29),('7643','2013-06-19','18:35:00',3.94),('7643','2013-06-19','18:40:00',3.57),('7643','2013-06-19','18:45:00',3.17),('7643','2013-06-19','18:50:00',2.81),('7643','2013-06-19','18:55:00',2.54),('7643','2013-06-19','19:00:00',2.23),('7643','2013-06-19','19:05:00',1.97),('7643','2013-06-19','19:10:00',1.76),('7643','2013-06-19','19:15:00',1.53),('7643','2013-06-19','19:20:00',1.26),('7643','2013-06-19','19:25:00',1.12),('7643','2013-06-18','06:45:00',1.11),('7643','2013-06-18','06:50:00',1.28),('7643','2013-06-18','06:55:00',1.48),('7643','2013-06-18','07:00:00',1.7),('7643','2013-06-18','07:05:00',1.95),('7643','2013-06-18','07:10:00',2.22),('7643','2013-06-18','07:15:00',2.47),('7643','2013-06-18','07:20:00',2.74),('7643','2013-06-18','07:25:00',3),('7643','2013-06-18','07:30:00',3.29),('7643','2013-06-18','07:35:00',3.56),('7643','2013-06-18','07:40:00',3.84),('7643','2013-06-18','07:45:00',4.1),('7643','2013-06-18','07:50:00',4.37),('7643','2013-06-18','07:55:00',4.7),('7643','2013-06-18','08:00:00',5),('7643','2013-06-18','08:05:00',5.3),('7643','2013-06-18','08:10:00',5.62),('7643','2013-06-18','08:15:00',5.82),('7643','2013-06-18','08:20:00',6.17),('7643','2013-06-18','08:25:00',6.44),('7643','2013-06-18','08:30:00',6.78),('7643','2013-06-18','08:35:00',7.11),('7643','2013-06-18','08:40:00',7.39),('7643','2013-06-18','08:45:00',7.66),('7643','2013-06-18','08:50:00',7.95),('7643','2013-06-18','08:55:00',8.28),('7643','2013-06-18','09:00:00',8.57),('7643','2013-06-18','09:05:00',8.87),('7643','2013-06-18','09:10:00',9.16),('7643','2013-06-18','09:15:00',9.46),('7643','2013-06-18','09:20:00',9.72),('7643','2013-06-18','09:25:00',9.96),('7643','2013-06-18','09:30:00',10.13),('7643','2013-06-18','09:35:00',10.32),('7643','2013-06-18','09:40:00',10.5),('7643','2013-06-18','09:45:00',10.69),('7643','2013-06-18','09:50:00',10.87),('7643','2013-06-18','09:55:00',11.1),('7643','2013-06-18','10:00:00',11.31),('7643','2013-06-18','10:05:00',11.51),('7643','2013-06-18','10:10:00',11.64),('7643','2013-06-18','10:15:00',11.79),('7643','2013-06-18','10:20:00',11.81),('7643','2013-06-18','10:25:00',11.89),('7643','2013-06-18','10:30:00',12.17),('7643','2013-06-18','10:35:00',12.27),('7643','2013-06-18','10:40:00',12.46),('7643','2013-06-18','10:45:00',12.56),('7643','2013-06-18','10:50:00',12.74),('7643','2013-06-18','10:55:00',12.94),('7643','2013-06-18','11:00:00',13.09),('7643','2013-06-18','11:05:00',13.02),('7643','2013-06-18','11:10:00',13.21),('7643','2013-06-18','11:15:00',13.28),('7643','2013-06-18','11:20:00',13.37),('7643','2013-06-18','11:25:00',13.58),('7643','2013-06-18','11:30:00',13.58),('7643','2013-06-18','11:35:00',13.74),('7643','2013-06-18','11:40:00',13.49),('7643','2013-06-18','11:45:00',13.74),('7643','2013-06-18','11:50:00',13.89),('7643','2013-06-18','11:55:00',13.99),('7643','2013-06-18','12:00:00',14.3),('7643','2013-06-18','12:05:00',14.05),('7643','2013-06-18','12:10:00',14.45),('7643','2013-06-18','12:15:00',14.1),('7643','2013-06-18','12:20:00',13.96),('7643','2013-06-18','12:25:00',14.33),('7643','2013-06-18','12:30:00',14.5),('7643','2013-06-18','12:35:00',14.83),('7643','2013-06-18','12:40:00',15.16),('7643','2013-06-18','12:45:00',15.1),('7643','2013-06-18','12:50:00',14.96),('7643','2013-06-18','12:55:00',15.11),('7643','2013-06-18','13:00:00',15.05),('7643','2013-06-18','13:05:00',14.94),('7643','2013-06-18','13:10:00',14.92),('7643','2013-06-18','13:15:00',14.89),('7643','2013-06-18','13:20:00',14.87),('7643','2013-06-18','13:25:00',15.05),('7643','2013-06-18','13:30:00',15.32),('7643','2013-06-18','13:35:00',15.23),('7643','2013-06-18','13:40:00',15.29),('7643','2013-06-18','13:45:00',15.17),('7643','2013-06-18','13:50:00',15.19),('7643','2013-06-18','13:55:00',15.34),('7643','2013-06-18','14:00:00',15.27),('7643','2013-06-18','14:05:00',15.26),('7643','2013-06-18','14:10:00',15.14),('7643','2013-06-18','14:15:00',15.06),('7643','2013-06-18','14:20:00',15.02),('7643','2013-06-18','14:25:00',14.9),('7643','2013-06-18','14:30:00',14.77),('7643','2013-06-18','14:35:00',14.59),('7643','2013-06-18','14:40:00',14.45),('7643','2013-06-18','14:45:00',14.34),('7643','2013-06-18','14:50:00',14.24),('7643','2013-06-18','14:55:00',14.13),('7643','2013-06-18','15:00:00',14.1),('7643','2013-06-18','15:05:00',14),('7643','2013-06-18','15:10:00',13.8),('7643','2013-06-18','15:15:00',13.69),('7643','2013-06-18','15:20:00',13.54),('7643','2013-06-18','15:25:00',13.36),('7643','2013-06-18','15:30:00',13.24),('7643','2013-06-18','15:35:00',13.04),('7643','2013-06-18','15:40:00',12.82),('7643','2013-06-18','15:45:00',12.61),('7643','2013-06-18','15:50:00',12.45),('7643','2013-06-18','15:55:00',12.19),('7643','2013-06-18','16:00:00',12.01),('7643','2013-06-18','16:05:00',11.79),('7643','2013-06-18','16:10:00',11.58),('7643','2013-06-18','16:15:00',11.33),('7643','2013-06-18','16:20:00',11.08),('7643','2013-06-18','16:25:00',10.89),('7643','2013-06-18','16:30:00',10.67),('7643','2013-06-18','16:35:00',10.54),('7643','2013-06-18','16:40:00',10.21),('7643','2013-06-18','16:45:00',10.04),('7643','2013-06-18','16:50:00',9.79),('7643','2013-06-18','16:55:00',9.6),('7643','2013-06-18','17:00:00',9.33),('7643','2013-06-18','17:05:00',8.97),('7643','2013-06-18','17:10:00',8.67),('7643','2013-06-18','17:15:00',8.42),('7643','2013-06-18','17:20:00',8.25),('7643','2013-06-18','17:25:00',7.98),('7643','2013-06-18','17:30:00',7.63),('7643','2013-06-18','17:35:00',7.43),('7643','2013-06-18','17:40:00',7.21),('7643','2013-06-18','17:45:00',6.88),('7643','2013-06-18','17:50:00',6.58),('7643','2013-06-18','17:55:00',6.26),('7643','2013-06-18','18:00:00',5.85),('7643','2013-06-18','18:05:00',5.53),('7643','2013-06-18','18:10:00',5.25),('7643','2013-06-18','18:15:00',4.92),('7643','2013-06-18','18:20:00',4.63),('7643','2013-06-18','18:25:00',4.32),('7643','2013-06-18','18:30:00',3.99),('7643','2013-06-18','18:35:00',3.6),('7643','2013-06-18','18:40:00',3.08),('7643','2013-06-18','18:45:00',2.78),('7643','2013-06-18','18:50:00',2.51),('7643','2013-06-18','18:55:00',2.21),('7643','2013-06-18','19:00:00',1.97),('7643','2013-06-18','19:05:00',1.88),('7643','2013-06-18','19:10:00',1.7),('7643','2013-06-18','19:15:00',1.44),('7643','2013-06-18','19:20:00',1.19),('7643','2013-06-18','19:25:00',1.03),('7643','2013-06-17','06:45:00',1.1),('7643','2013-06-17','06:50:00',1.25),('7643','2013-06-17','06:55:00',1.41),('7643','2013-06-17','07:00:00',1.63),('7643','2013-06-17','07:05:00',1.9),('7643','2013-06-17','07:10:00',2.17),('7643','2013-06-17','07:15:00',2.4),('7643','2013-06-17','07:20:00',2.64),('7643','2013-06-17','07:25:00',2.9),('7643','2013-06-17','07:30:00',3.24),('7643','2013-06-17','07:35:00',3.54),('7643','2013-06-17','07:40:00',3.81),('7643','2013-06-17','07:45:00',4.14),('7643','2013-06-17','07:50:00',4.41),('7643','2013-06-17','07:55:00',4.69),('7643','2013-06-17','08:00:00',4.94),('7643','2013-06-17','08:05:00',5.21),('7643','2013-06-17','08:10:00',5.53),('7643','2013-06-17','08:15:00',5.8),('7643','2013-06-17','08:20:00',6.15),('7643','2013-06-17','08:25:00',6.42),('7643','2013-06-17','08:30:00',6.72),('7643','2013-06-17','08:35:00',7),('7643','2013-06-17','08:40:00',7.31),('7643','2013-06-17','08:45:00',7.56),('7643','2013-06-17','08:50:00',7.8),('7643','2013-06-17','08:55:00',8.09),('7643','2013-06-17','09:00:00',8.37),('7643','2013-06-17','09:05:00',8.62),('7643','2013-06-17','09:10:00',8.89),('7643','2013-06-17','09:15:00',9.2),('7643','2013-06-17','09:20:00',9.46),('7643','2013-06-17','09:25:00',9.72),('7643','2013-06-17','09:30:00',9.87),('7643','2013-06-17','09:35:00',10.13),('7643','2013-06-17','09:40:00',10.33),('7643','2013-06-17','09:45:00',10.55),('7643','2013-06-17','09:50:00',10.85),('7643','2013-06-17','09:55:00',11.06),('7643','2013-06-17','10:00:00',11.22),('7643','2013-06-17','10:05:00',11.31),('7643','2013-06-17','10:10:00',11.46),('7643','2013-06-17','10:15:00',11.72),('7643','2013-06-17','10:20:00',11.99),('7643','2013-06-17','10:25:00',12.19),('7643','2013-06-17','10:30:00',12.4),('7643','2013-06-17','10:35:00',12.5),('7643','2013-06-17','10:40:00',12.45),('7643','2013-06-17','10:45:00',12.74),('7643','2013-06-17','10:50:00',12.79),('7643','2013-06-17','10:55:00',12.71),('7643','2013-06-17','11:00:00',13.03),('7643','2013-06-17','11:05:00',13.23),('7643','2013-06-17','11:10:00',13.42),('7643','2013-06-17','11:15:00',13.55),('7643','2013-06-17','11:20:00',13.56),('7643','2013-06-17','11:25:00',13.68),('7643','2013-06-17','11:30:00',13.65),('7643','2013-06-17','11:35:00',13.64),('7643','2013-06-17','11:40:00',13.82),('7643','2013-06-17','11:45:00',13.79),('7643','2013-06-17','11:50:00',13.84),('7643','2013-06-17','11:55:00',13.5),('7643','2013-06-17','12:00:00',13.75),('7643','2013-06-17','12:05:00',13.97),('7643','2013-06-17','12:10:00',13.74),('7643','2013-06-17','12:15:00',13.65),('7643','2013-06-17','12:20:00',13.72),('7643','2013-06-17','12:25:00',13),('7643','2013-06-17','12:30:00',13.75),('7643','2013-06-17','12:35:00',10.63),('7643','2013-06-17','12:40:00',13.54),('7643','2013-06-17','12:45:00',6.54),('7643','2013-06-17','12:50:00',14.18),('7643','2013-06-17','12:55:00',14.96),('7643','2013-06-17','13:00:00',12.67),('7643','2013-06-17','13:05:00',15.08),('7643','2013-06-17','13:10:00',15.37),('7643','2013-06-17','13:15:00',14.32),('7643','2013-06-17','13:20:00',13.45),('7643','2013-06-17','13:25:00',11.02),('7643','2013-06-17','13:30:00',9.69),('7643','2013-06-17','13:35:00',14.23),('7643','2013-06-17','13:40:00',14.47),('7643','2013-06-17','13:45:00',15.14),('7643','2013-06-17','13:50:00',15.15),('7643','2013-06-17','13:55:00',15.62),('7643','2013-06-17','14:00:00',15.55),('7643','2013-06-17','14:05:00',15.44),('7643','2013-06-17','14:10:00',15.22),('7643','2013-06-17','14:15:00',15),('7643','2013-06-17','14:20:00',14.9),('7643','2013-06-17','14:25:00',14.89),('7643','2013-06-17','14:30:00',14.74),('7643','2013-06-17','14:35:00',14.81),('7643','2013-06-17','14:40:00',14.82),('7643','2013-06-17','14:45:00',14.71),('7643','2013-06-17','14:50:00',14.44),('7643','2013-06-17','14:55:00',14.36),('7643','2013-06-17','15:00:00',14.31),('7643','2013-06-17','15:05:00',14.19),('7643','2013-06-17','15:10:00',14.05),('7643','2013-06-17','15:15:00',13.82),('7643','2013-06-17','15:20:00',13.67),('7643','2013-06-17','15:25:00',13.67),('7643','2013-06-17','15:30:00',13.47),('7643','2013-06-17','15:35:00',13.32),('7643','2013-06-17','15:40:00',13.29),('7643','2013-06-17','15:45:00',13.14),('7643','2013-06-17','15:50:00',12.96),('7643','2013-06-17','15:55:00',12.74),('7643','2013-06-17','16:00:00',12.77),('7643','2013-06-17','16:05:00',12.7),('7643','2013-06-17','16:10:00',12.4),('7643','2013-06-17','16:15:00',12.19),('7643','2013-06-17','16:20:00',12.05),('7643','2013-06-17','16:25:00',11.55),('7643','2013-06-17','16:30:00',11.25),('7643','2013-06-17','16:35:00',10.52),('7643','2013-06-17','16:40:00',10.62),('7643','2013-06-17','16:45:00',10.06),('7643','2013-06-17','16:50:00',9.98),('7643','2013-06-17','16:55:00',9.69),('7643','2013-06-17','17:00:00',9.44),('7643','2013-06-17','17:05:00',9.1),('7643','2013-06-17','17:10:00',8.82),('7643','2013-06-17','17:15:00',8.55),('7643','2013-06-17','17:20:00',8.26),('7643','2013-06-17','17:25:00',8.02),('7643','2013-06-17','17:30:00',7.63),('7643','2013-06-17','17:35:00',7.37),('7643','2013-06-17','17:40:00',7.16),('7643','2013-06-17','17:45:00',6.87),('7643','2013-06-17','17:50:00',6.55),('7643','2013-06-17','17:55:00',6.26),('7643','2013-06-17','18:00:00',5.84),('7643','2013-06-17','18:05:00',5.6),('7643','2013-06-17','18:10:00',5.38),('7643','2013-06-17','18:15:00',5.11),('7643','2013-06-17','18:20:00',4.88),('7643','2013-06-17','18:25:00',4.54),('7643','2013-06-17','18:30:00',4.24),('7643','2013-06-17','18:35:00',3.93),('7643','2013-06-17','18:40:00',3.58),('7643','2013-06-17','18:45:00',3.21),('7643','2013-06-17','18:50:00',2.82),('7643','2013-06-17','18:55:00',2.44),('7643','2013-06-17','19:00:00',2.18),('7643','2013-06-17','19:05:00',2.06),('7643','2013-06-17','19:10:00',1.88),('7643','2013-06-17','19:15:00',1.63),('7643','2013-06-17','19:20:00',1.41),('7643','2013-06-17','19:25:00',1.25),('7643','2013-06-17','19:30:00',1.1),('7643','2013-06-16','06:45:00',1.13),('7643','2013-06-16','06:50:00',1.3),('7643','2013-06-16','06:55:00',1.54),('7643','2013-06-16','07:00:00',1.75),('7643','2013-06-16','07:05:00',2.03),('7643','2013-06-16','07:10:00',2.3),('7643','2013-06-16','07:15:00',2.58),('7643','2013-06-16','07:20:00',2.87),('7643','2013-06-16','07:25:00',3.16),('7643','2013-06-16','07:30:00',3.46),('7643','2013-06-16','07:35:00',3.76),('7643','2013-06-16','07:40:00',4.1),('7643','2013-06-16','07:45:00',4.41),('7643','2013-06-16','07:50:00',4.71),('7643','2013-06-16','07:55:00',5.01),('7643','2013-06-16','08:00:00',5.33),('7643','2013-06-16','08:05:00',5.61),('7643','2013-06-16','08:10:00',5.92),('7643','2013-06-16','08:15:00',6.14),('7643','2013-06-16','08:20:00',6.54),('7643','2013-06-16','08:25:00',6.83),('7643','2013-06-16','08:30:00',7.13),('7643','2013-06-16','08:35:00',7.48),('7643','2013-06-16','08:40:00',7.75),('7643','2013-06-16','08:45:00',8.04),('7643','2013-06-16','08:50:00',8.31),('7643','2013-06-16','08:55:00',8.61),('7643','2013-06-16','09:00:00',8.92),('7643','2013-06-16','09:05:00',9.28),('7643','2013-06-16','09:10:00',9.57),('7643','2013-06-16','09:15:00',9.86),('7643','2013-06-16','09:20:00',10.09),('7643','2013-06-16','09:25:00',10.3),('7643','2013-06-16','09:30:00',10.52),('7643','2013-06-16','09:35:00',10.71),('7643','2013-06-16','09:40:00',10.94),('7643','2013-06-16','09:45:00',11.19),('7643','2013-06-16','09:50:00',11.33),('7643','2013-06-16','09:55:00',11.53),('7643','2013-06-16','10:00:00',11.67),('7643','2013-06-16','10:05:00',11.83),('7643','2013-06-16','10:10:00',11.94),('7643','2013-06-16','10:15:00',12.17),('7643','2013-06-16','10:20:00',12.38),('7643','2013-06-16','10:25:00',12.46),('7643','2013-06-16','10:30:00',12.58),('7643','2013-06-16','10:35:00',12.82),('7643','2013-06-16','10:40:00',12.98),('7643','2013-06-16','10:45:00',13.14),('7643','2013-06-16','10:50:00',13.25),('7643','2013-06-16','10:55:00',13.3),('7643','2013-06-16','11:00:00',13.53),('7643','2013-06-16','11:05:00',13.61),('7643','2013-06-16','11:10:00',13.64),('7643','2013-06-16','11:15:00',13.77),('7643','2013-06-16','11:20:00',13.9),('7643','2013-06-16','11:25:00',14.02),('7643','2013-06-16','11:30:00',13.93),('7643','2013-06-16','11:35:00',14.2),('7643','2013-06-16','11:40:00',14.04),('7643','2013-06-16','11:45:00',14.14),('7643','2013-06-16','11:50:00',14.39),('7643','2013-06-16','11:55:00',14.43),('7643','2013-06-16','12:00:00',14.38),('7643','2013-06-16','12:05:00',14.44),('7643','2013-06-16','12:10:00',14.68),('7643','2013-06-16','12:15:00',14.71),('7643','2013-06-16','12:20:00',14.79),('7643','2013-06-16','12:25:00',14.74),('7643','2013-06-16','12:30:00',14.73),('7643','2013-06-16','12:35:00',14.63),('7643','2013-06-16','12:40:00',14.8),('7643','2013-06-16','12:45:00',14.61),('7643','2013-06-16','12:50:00',14.73),('7643','2013-06-16','12:55:00',14.88),('7643','2013-06-16','13:00:00',15.03),('7643','2013-06-16','13:05:00',15.24),('7643','2013-06-16','13:10:00',15.26),('7643','2013-06-16','13:15:00',15.29),('7643','2013-06-16','13:20:00',15.11),('7643','2013-06-16','13:25:00',15.02),('7643','2013-06-16','13:30:00',15.15),('7643','2013-06-16','13:35:00',15.1),('7643','2013-06-16','13:40:00',15.21),('7643','2013-06-16','13:45:00',15.27),('7643','2013-06-16','13:50:00',15.07),('7643','2013-06-16','13:55:00',15.08),('7643','2013-06-16','14:00:00',15.09),('7643','2013-06-16','14:05:00',15.09),('7643','2013-06-16','14:10:00',14.98),('7643','2013-06-16','14:15:00',14.9),('7643','2013-06-16','14:20:00',14.78),('7643','2013-06-16','14:25:00',14.81),('7643','2013-06-16','14:30:00',14.67),('7643','2013-06-16','14:35:00',14.67),('7643','2013-06-16','14:40:00',14.57),('7643','2013-06-16','14:45:00',14.5),('7643','2013-06-16','14:50:00',14.36),('7643','2013-06-16','14:55:00',14.23),('7643','2013-06-16','15:00:00',14.11),('7643','2013-06-16','15:05:00',13.99),('7643','2013-06-16','15:10:00',13.85),('7643','2013-06-16','15:15:00',13.66),('7643','2013-06-16','15:20:00',13.55),('7643','2013-06-16','15:25:00',13.44),('7643','2013-06-16','15:30:00',13.26),('7643','2013-06-16','15:35:00',13.19),('7643','2013-06-16','15:40:00',13),('7643','2013-06-16','15:45:00',12.77),('7643','2013-06-16','15:50:00',12.65),('7643','2013-06-16','15:55:00',12.47),('7643','2013-06-16','16:00:00',12.29),('7643','2013-06-16','16:05:00',12.16),('7643','2013-06-16','16:10:00',11.91),('7643','2013-06-16','16:15:00',11.75),('7643','2013-06-16','16:20:00',11.5),('7643','2013-06-16','16:25:00',11.27),('7643','2013-06-16','16:30:00',11.05),('7643','2013-06-16','16:35:00',10.78),('7643','2013-06-16','16:40:00',10.52),('7643','2013-06-16','16:45:00',10.27),('7643','2013-06-16','16:50:00',10.04),('7643','2013-06-16','16:55:00',9.85),('7643','2013-06-16','17:00:00',9.58),('7643','2013-06-16','17:05:00',9.27),('7643','2013-06-16','17:10:00',8.95),('7643','2013-06-16','17:15:00',8.66),('7643','2013-06-16','17:20:00',8.43),('7643','2013-06-16','17:25:00',8.17),('7643','2013-06-16','17:30:00',7.83),('7643','2013-06-16','17:35:00',7.59),('7643','2013-06-16','17:40:00',7.4),('7643','2013-06-16','17:45:00',7.09),('7643','2013-06-16','17:50:00',6.8),('7643','2013-06-16','17:55:00',6.47),('7643','2013-06-16','18:00:00',6.09),('7643','2013-06-16','18:05:00',5.88),('7643','2013-06-16','18:10:00',5.61),('7643','2013-06-16','18:15:00',5.3),('7643','2013-06-16','18:20:00',4.99),('7643','2013-06-16','18:25:00',4.48),('7643','2013-06-16','18:30:00',4.41),('7643','2013-06-16','18:35:00',3.86),('7643','2013-06-16','18:40:00',3.83),('7643','2013-06-16','18:45:00',3.58),('7643','2013-06-16','18:50:00',3.26),('7643','2013-06-16','18:55:00',2.93),('7643','2013-06-16','19:00:00',2.64),('7643','2013-06-16','19:05:00',2.46),('7643','2013-06-16','19:10:00',2.22),('7643','2013-06-16','19:15:00',1.93),('7643','2013-06-16','19:20:00',1.67),('7643','2013-06-16','19:25:00',1.47),('7643','2013-06-16','19:30:00',1.3),('7643','2013-06-16','19:35:00',1.11),('7643','2013-06-15','06:45:00',1.16),('7643','2013-06-15','06:50:00',1.35),('7643','2013-06-15','06:55:00',1.6),('7643','2013-06-15','07:00:00',1.81),('7643','2013-06-15','07:05:00',2.09),('7643','2013-06-15','07:10:00',2.38),('7643','2013-06-15','07:15:00',2.65),('7643','2013-06-15','07:20:00',2.96),('7643','2013-06-15','07:25:00',3.25),('7643','2013-06-15','07:30:00',3.57),('7643','2013-06-15','07:35:00',3.88),('7643','2013-06-15','07:40:00',4.22),('7643','2013-06-15','07:45:00',4.53),('7643','2013-06-15','07:50:00',4.79),('7643','2013-06-15','07:55:00',5.1),('7643','2013-06-15','08:00:00',5.4),('7643','2013-06-15','08:05:00',5.72),('7643','2013-06-15','08:10:00',6.03),('7643','2013-06-15','08:15:00',6.22),('7643','2013-06-15','08:20:00',6.59),('7643','2013-06-15','08:25:00',6.94),('7643','2013-06-15','08:30:00',7.28),('7643','2013-06-15','08:35:00',7.59),('7643','2013-06-15','08:40:00',7.97),('7643','2013-06-15','08:45:00',8.26),('7643','2013-06-15','08:50:00',8.42),('7643','2013-06-15','08:55:00',8.72),('7643','2013-06-15','09:00:00',9.1),('7643','2013-06-15','09:05:00',9.46),('7643','2013-06-15','09:10:00',9.73),('7643','2013-06-15','09:15:00',10.1),('7643','2013-06-15','09:20:00',10.35),('7643','2013-06-15','09:25:00',10.55),('7643','2013-06-15','09:30:00',10.69),('7643','2013-06-15','09:35:00',10.79),('7643','2013-06-15','09:40:00',11.07),('7643','2013-06-15','09:45:00',11.25),('7643','2013-06-15','09:50:00',11.43),('7643','2013-06-15','09:55:00',11.65),('7643','2013-06-15','10:00:00',11.83),('7643','2013-06-15','10:05:00',12.02),('7643','2013-06-15','10:10:00',12.3),('7643','2013-06-15','10:15:00',12.26),('7643','2013-06-15','10:20:00',12.45),('7643','2013-06-15','10:25:00',12.68),('7643','2013-06-15','10:30:00',12.94),('7643','2013-06-15','10:35:00',13.07),('7643','2013-06-15','10:40:00',13.19),('7643','2013-06-15','10:45:00',13.3),('7643','2013-06-15','10:50:00',13.47),('7643','2013-06-15','10:55:00',13.7),('7643','2013-06-15','11:00:00',13.86),('7643','2013-06-15','11:05:00',13.77),('7643','2013-06-15','11:10:00',13.96),('7643','2013-06-15','11:15:00',14.15),('7643','2013-06-15','11:20:00',14.34),('7643','2013-06-15','11:25:00',14.48),('7643','2013-06-15','11:30:00',14.52),('7643','2013-06-15','11:35:00',14.68),('7643','2013-06-15','11:40:00',14.78),('7643','2013-06-15','11:45:00',14.82),('7643','2013-06-15','11:50:00',14.9),('7643','2013-06-15','11:55:00',14.93),('7643','2013-06-15','12:00:00',15.11),('7643','2013-06-15','12:05:00',15.24),('7643','2013-06-15','12:10:00',15.36),('7643','2013-06-15','12:15:00',15.5),('7643','2013-06-15','12:20:00',15.64),('7643','2013-06-15','12:25:00',15.62),('7643','2013-06-15','12:30:00',15.56),('7643','2013-06-15','12:35:00',15.59),('7643','2013-06-15','12:40:00',15.58),('7643','2013-06-15','12:45:00',15.55),('7643','2013-06-15','12:50:00',15.44),('7643','2013-06-15','12:55:00',15.49),('7643','2013-06-15','13:00:00',15.6),('7643','2013-06-15','13:05:00',15.73),('7643','2013-06-15','13:10:00',15.74),('7643','2013-06-15','13:15:00',15.95),('7643','2013-06-15','13:20:00',15.92),('7643','2013-06-15','13:25:00',15.91),('7643','2013-06-15','13:30:00',15.82),('7643','2013-06-15','13:35:00',16),('7643','2013-06-15','13:40:00',15.97),('7643','2013-06-15','13:45:00',15.85),('7643','2013-06-15','13:50:00',15.72),('7643','2013-06-15','13:55:00',15.82),('7643','2013-06-15','14:00:00',15.77),('7643','2013-06-15','14:05:00',15.66),('7643','2013-06-15','14:10:00',15.66),('7643','2013-06-15','14:15:00',15.61),('7643','2013-06-15','14:20:00',15.57),('7643','2013-06-15','14:25:00',15.41),('7643','2013-06-15','14:30:00',15.37),('7643','2013-06-15','14:35:00',15.21),('7643','2013-06-15','14:40:00',15.14),('7643','2013-06-15','14:45:00',14.95),('7643','2013-06-15','14:50:00',14.94),('7643','2013-06-15','14:55:00',14.81),('7643','2013-06-15','15:00:00',14.67),('7643','2013-06-15','15:05:00',14.53),('7643','2013-06-15','15:10:00',14.38),('7643','2013-06-15','15:15:00',14.24),('7643','2013-06-15','15:20:00',14.14),('7643','2013-06-15','15:25:00',14.05),('7643','2013-06-15','15:30:00',13.82),('7643','2013-06-15','15:35:00',13.65),('7643','2013-06-15','15:40:00',13.48),('7643','2013-06-15','15:45:00',13.34),('7643','2013-06-15','15:50:00',13.13),('7643','2013-06-15','15:55:00',12.96),('7643','2013-06-15','16:00:00',12.72),('7643','2013-06-15','16:05:00',12.54),('7643','2013-06-15','16:10:00',12.33),('7643','2013-06-15','16:15:00',12.09),('7643','2013-06-15','16:20:00',11.82),('7643','2013-06-15','16:25:00',11.51),('7643','2013-06-15','16:30:00',11.28),('7643','2013-06-15','16:35:00',11.05),('7643','2013-06-15','16:40:00',10.75),('7643','2013-06-15','16:45:00',10.42),('7643','2013-06-15','16:50:00',10.19),('7643','2013-06-15','16:55:00',9.97),('7643','2013-06-15','17:00:00',9.69),('7643','2013-06-15','17:05:00',9.39),('7643','2013-06-15','17:10:00',9.05),('7643','2013-06-15','17:15:00',8.67),('7643','2013-06-15','17:20:00',8.39),('7643','2013-06-15','17:25:00',8.1),('7643','2013-06-15','17:30:00',7.83),('7643','2013-06-15','17:35:00',7.55),('7643','2013-06-15','17:40:00',7.26),('7643','2013-06-15','17:45:00',6.89),('7643','2013-06-15','17:50:00',6.56),('7643','2013-06-15','17:55:00',6.19),('7643','2013-06-15','18:00:00',5.89),('7643','2013-06-15','18:05:00',5.66),('7643','2013-06-15','18:10:00',5.39),('7643','2013-06-15','18:15:00',5.07),('7643','2013-06-15','18:20:00',4.73),('7643','2013-06-15','18:25:00',4.46),('7643','2013-06-15','18:30:00',4.16),('7643','2013-06-15','18:35:00',3.85),('7643','2013-06-15','18:40:00',3.53),('7643','2013-06-15','18:45:00',3.15),('7643','2013-06-15','18:50:00',2.83),('7643','2013-06-15','18:55:00',2.56),('7643','2013-06-15','19:00:00',2.25),('7643','2013-06-15','19:05:00',2.03),('7643','2013-06-15','19:10:00',1.8),('7643','2013-06-15','19:15:00',1.53),('7643','2013-06-15','19:20:00',1.27),('7643','2013-06-15','19:25:00',1.12),('7643','2013-06-14','06:40:00',1.04),('7643','2013-06-14','06:45:00',1.2),('7643','2013-06-14','06:50:00',1.37),('7643','2013-06-14','06:55:00',1.54),('7643','2013-06-14','07:00:00',1.77),('7643','2013-06-14','07:05:00',2.05),('7643','2013-06-14','07:10:00',2.35),('7643','2013-06-14','07:15:00',2.59),('7643','2013-06-14','07:20:00',2.86),('7643','2013-06-14','07:25:00',3.09),('7643','2013-06-14','07:30:00',3.42),('7643','2013-06-14','07:35:00',3.71),('7643','2013-06-14','07:40:00',4),('7643','2013-06-14','07:45:00',4.34),('7643','2013-06-14','07:50:00',4.64),('7643','2013-06-14','07:55:00',4.94),('7643','2013-06-14','08:00:00',5.22),('7643','2013-06-14','08:05:00',5.54),('7643','2013-06-14','08:10:00',5.89),('7643','2013-06-14','08:15:00',6.14),('7643','2013-06-14','08:20:00',6.48),('7643','2013-06-14','08:25:00',6.63),('7643','2013-06-14','08:30:00',6.76),('7643','2013-06-14','08:35:00',7.35),('7643','2013-06-14','08:40:00',7.31),('7643','2013-06-14','08:45:00',3.47),('7643','2013-06-14','08:50:00',7.21),('7643','2013-06-14','08:55:00',8.81),('7643','2013-06-14','09:00:00',7.59),('7643','2013-06-14','09:05:00',9.1),('7643','2013-06-14','09:10:00',9.71),('7643','2013-06-14','09:15:00',9.83),('7643','2013-06-14','09:20:00',10.03),('7643','2013-06-14','09:25:00',10.28),('7643','2013-06-14','09:30:00',10.77),('7643','2013-06-14','09:35:00',10.52),('7643','2013-06-14','09:40:00',8.1),('7643','2013-06-14','09:45:00',10.96),('7643','2013-06-14','09:50:00',11.11),('7643','2013-06-14','09:55:00',11.78),('7643','2013-06-14','10:00:00',12.36),('7643','2013-06-14','10:05:00',12.1),('7643','2013-06-14','10:10:00',12.31),('7643','2013-06-14','10:15:00',6.58),('7643','2013-06-14','10:20:00',7.68),('7643','2013-06-14','10:25:00',4.64),('7643','2013-06-14','10:30:00',10.5),('7643','2013-06-14','10:35:00',14.18),('7643','2013-06-14','10:40:00',13.46),('7643','2013-06-14','10:45:00',13.12),('7643','2013-06-14','10:50:00',11.71),('7643','2013-06-14','10:55:00',11.34),('7643','2013-06-14','11:00:00',11.1),('7643','2013-06-14','11:05:00',7.72),('7643','2013-06-14','11:10:00',14.18),('7643','2013-06-14','11:15:00',15.88),('7643','2013-06-14','11:20:00',12.85),('7643','2013-06-14','11:25:00',7.82),('7643','2013-06-14','11:30:00',7.23),('7643','2013-06-14','11:35:00',11.09),('7643','2013-06-14','11:40:00',15.8),('7643','2013-06-14','11:45:00',16.61),('7643','2013-06-14','11:50:00',14.69),('7643','2013-06-14','11:55:00',16.28),('7643','2013-06-14','12:00:00',15.88),('7643','2013-06-14','12:05:00',16.02),('7643','2013-06-14','12:10:00',16.3),('7643','2013-06-14','12:15:00',16.45),('7643','2013-06-14','12:20:00',16.19),('7643','2013-06-14','12:25:00',15.72),('7643','2013-06-14','12:30:00',15.94),('7643','2013-06-14','12:35:00',16.09),('7643','2013-06-14','12:40:00',16.02),('7643','2013-06-14','12:45:00',16.1),('7643','2013-06-14','12:50:00',16.07),('7643','2013-06-14','12:55:00',16.17),('7643','2013-06-14','13:00:00',16.15),('7643','2013-06-14','13:05:00',16.15),('7643','2013-06-14','13:10:00',16.08),('7643','2013-06-14','13:15:00',16.02),('7643','2013-06-14','13:20:00',15.87),('7643','2013-06-14','13:25:00',16),('7643','2013-06-14','13:30:00',15.86),('7643','2013-06-14','13:35:00',15.71),('7643','2013-06-14','13:40:00',15.89),('7643','2013-06-14','13:45:00',15.8),('7643','2013-06-14','13:50:00',15.75),('7643','2013-06-14','13:55:00',15.61),('7643','2013-06-14','14:00:00',15.69),('7643','2013-06-14','14:05:00',15.62),('7643','2013-06-14','14:10:00',15.61),('7643','2013-06-14','14:15:00',15.45),('7643','2013-06-14','14:20:00',15.36),('7643','2013-06-14','14:25:00',15.37),('7643','2013-06-14','14:30:00',15.31),('7643','2013-06-14','14:35:00',15.22),('7643','2013-06-14','14:40:00',15.2),('7643','2013-06-14','14:45:00',14.93),('7643','2013-06-14','14:50:00',14.9),('7643','2013-06-14','14:55:00',14.76),('7643','2013-06-14','15:00:00',14.37),('7643','2013-06-14','15:05:00',14.37),('7643','2013-06-14','15:10:00',14.31),('7643','2013-06-14','15:15:00',14.2),('7643','2013-06-14','15:20:00',14.27),('7643','2013-06-14','15:25:00',14.1),('7643','2013-06-14','15:30:00',13.98),('7643','2013-06-14','15:35:00',13.77),('7643','2013-06-14','15:40:00',13.57),('7643','2013-06-14','15:45:00',13.35),('7643','2013-06-14','15:50:00',13.09),('7643','2013-06-14','15:55:00',12.95),('7643','2013-06-14','16:00:00',12.77),('7643','2013-06-14','16:05:00',12.47),('7643','2013-06-14','16:10:00',12.21),('7643','2013-06-14','16:15:00',12.01),('7643','2013-06-14','16:20:00',11.71),('7643','2013-06-14','16:25:00',11.43),('7643','2013-06-14','16:30:00',11.24),('7643','2013-06-14','16:35:00',10.96),('7643','2013-06-14','16:40:00',10.75),('7643','2013-06-14','16:45:00',10.45),('7643','2013-06-14','16:50:00',10.2),('7643','2013-06-14','16:55:00',9.93),('7643','2013-06-14','17:00:00',9.69),('7643','2013-06-14','17:05:00',9.32),('7643','2013-06-14','17:10:00',9.04),('7643','2013-06-14','17:15:00',8.63),('7643','2013-06-14','17:20:00',8.39),('7643','2013-06-14','17:25:00',8.05),('7643','2013-06-14','17:30:00',7.65),('7643','2013-06-14','17:35:00',7.48),('7643','2013-06-14','17:40:00',7.27),('7643','2013-06-14','17:45:00',6.86),('7643','2013-06-14','17:50:00',6.51),('7643','2013-06-14','17:55:00',6.16),('7643','2013-06-14','18:00:00',5.78),('7643','2013-06-14','18:05:00',5.54),('7643','2013-06-14','18:10:00',5.28),('7643','2013-06-14','18:15:00',5.01),('7643','2013-06-14','18:20:00',4.69),('7643','2013-06-14','18:25:00',4.37),('7643','2013-06-14','18:30:00',4.05),('7643','2013-06-14','18:35:00',3.79),('7643','2013-06-14','18:40:00',3.45),('7643','2013-06-14','18:45:00',3.07),('7643','2013-06-14','18:50:00',2.71),('7643','2013-06-14','18:55:00',2.37),('7643','2013-06-14','19:00:00',2.14),('7643','2013-06-14','19:05:00',2.03),('7643','2013-06-14','19:10:00',1.78),('7643','2013-06-14','19:15:00',1.54),('7643','2013-06-14','19:20:00',1.3),('7643','2013-06-14','19:25:00',1.16),('7643','2013-06-14','19:30:00',1.01),('7643','2013-06-13','06:45:00',1.18),('7643','2013-06-13','06:50:00',1.39),('7643','2013-06-13','06:55:00',1.68),('7643','2013-06-13','07:00:00',1.93),('7643','2013-06-13','07:05:00',2.24),('7643','2013-06-13','07:10:00',2.55),('7643','2013-06-13','07:15:00',2.87),('7643','2013-06-13','07:20:00',3.19),('7643','2013-06-13','07:25:00',3.52),('7643','2013-06-13','07:30:00',3.84),('7643','2013-06-13','07:35:00',4.18),('7643','2013-06-13','07:40:00',4.58),('7643','2013-06-13','07:45:00',4.88),('7643','2013-06-13','07:50:00',5.18),('7643','2013-06-13','07:55:00',5.55),('7643','2013-06-13','08:00:00',5.85),('7643','2013-06-13','08:05:00',6.13),('7643','2013-06-13','08:10:00',6.44),('7643','2013-06-13','08:15:00',6.68),('7643','2013-06-13','08:20:00',7.02),('7643','2013-06-13','08:25:00',7.33),('7643','2013-06-13','08:30:00',7.71),('7643','2013-06-13','08:35:00',8),('7643','2013-06-13','08:40:00',8.32),('7643','2013-06-13','08:45:00',8.66),('7643','2013-06-13','08:50:00',8.96),('7643','2013-06-13','08:55:00',9.26),('7643','2013-06-13','09:00:00',9.57),('7643','2013-06-13','09:05:00',9.92),('7643','2013-06-13','09:10:00',10.21),('7643','2013-06-13','09:15:00',10.49),('7643','2013-06-13','09:20:00',10.69),('7643','2013-06-13','09:25:00',10.9),('7643','2013-06-13','09:30:00',11.03),('7643','2013-06-13','09:35:00',11.36),('7643','2013-06-13','09:40:00',11.63),('7643','2013-06-13','09:45:00',11.87),('7643','2013-06-13','09:50:00',12.11),('7643','2013-06-13','09:55:00',12.3),('7643','2013-06-13','10:00:00',12.47),('7643','2013-06-13','10:05:00',12.6),('7643','2013-06-13','10:10:00',12.62),('7643','2013-06-13','10:15:00',12.81),('7643','2013-06-13','10:20:00',13.07),('7643','2013-06-13','10:25:00',13.15),('7643','2013-06-13','10:30:00',13.35),('7643','2013-06-13','10:35:00',13.78),('7643','2013-06-13','10:40:00',13.95),('7643','2013-06-13','10:45:00',13.99),('7643','2013-06-13','10:50:00',13.96),('7643','2013-06-13','10:55:00',14.01),('7643','2013-06-13','11:00:00',14.03),('7643','2013-06-13','11:05:00',14.15),('7643','2013-06-13','11:10:00',14.41),('7643','2013-06-13','11:15:00',14.58),('7643','2013-06-13','11:20:00',14.59),('7643','2013-06-13','11:25:00',14.46),('7643','2013-06-13','11:30:00',15.23),('7643','2013-06-13','11:35:00',15.32),('7643','2013-06-13','11:40:00',15.18),('7643','2013-06-13','11:45:00',15.23),('7643','2013-06-13','11:50:00',15.41),('7643','2013-06-13','11:55:00',15.31),('7643','2013-06-13','12:00:00',15.38),('7643','2013-06-13','12:05:00',15.44),('7643','2013-06-13','12:10:00',15.49),('7643','2013-06-13','12:15:00',15.51),('7643','2013-06-13','12:20:00',15.64),('7643','2013-06-13','12:25:00',15.63),('7643','2013-06-13','12:30:00',15.52),('7643','2013-06-13','12:35:00',15.84),('7643','2013-06-13','12:40:00',15.92),('7643','2013-06-13','12:45:00',15.97),('7643','2013-06-13','12:50:00',15.88),('7643','2013-06-13','12:55:00',15.75),('7643','2013-06-13','13:00:00',15.64),('7643','2013-06-13','13:05:00',15.75),('7643','2013-06-13','13:10:00',15.82),('7643','2013-06-13','13:15:00',16.34),('7643','2013-06-13','13:20:00',16.38),('7643','2013-06-13','13:25:00',16.34),('7643','2013-06-13','13:30:00',16.11),('7643','2013-06-13','13:35:00',16.19),('7643','2013-06-13','13:40:00',15.82),('7643','2013-06-13','13:45:00',15.97),('7643','2013-06-13','13:50:00',16.2),('7643','2013-06-13','13:55:00',16.21),('7643','2013-06-13','14:00:00',16),('7643','2013-06-13','14:05:00',15.97),('7643','2013-06-13','14:10:00',16.08),('7643','2013-06-13','14:15:00',15.74),('7643','2013-06-13','14:20:00',15.6),('7643','2013-06-13','14:25:00',15.5),('7643','2013-06-13','14:30:00',15.58),('7643','2013-06-13','14:35:00',15.55),('7643','2013-06-13','14:40:00',15.5),('7643','2013-06-13','14:45:00',15.29),('7643','2013-06-13','14:50:00',15.05),('7643','2013-06-13','14:55:00',15.11),('7643','2013-06-13','15:00:00',14.99),('7643','2013-06-13','15:05:00',14.9),('7643','2013-06-13','15:10:00',14.68),('7643','2013-06-13','15:15:00',14.53),('7643','2013-06-13','15:20:00',14.4),('7643','2013-06-13','15:25:00',14.22),('7643','2013-06-13','15:30:00',14.03),('7643','2013-06-13','15:35:00',13.91),('7643','2013-06-13','15:40:00',13.79),('7643','2013-06-13','15:45:00',13.61),('7643','2013-06-13','15:50:00',13.47),('7643','2013-06-13','15:55:00',13.28),('7643','2013-06-13','16:00:00',13.04),('7643','2013-06-13','16:05:00',12.8),('7643','2013-06-13','16:10:00',12.58),('7643','2013-06-13','16:15:00',12.27),('7643','2013-06-13','16:20:00',11.99),('7643','2013-06-13','16:25:00',11.66),('7643','2013-06-13','16:30:00',11.42),('7643','2013-06-13','16:35:00',11.18),('7643','2013-06-13','16:40:00',10.76),('7643','2013-06-13','16:45:00',10.59),('7643','2013-06-13','16:50:00',10.34),('7643','2013-06-13','16:55:00',10.1),('7643','2013-06-13','17:00:00',9.83),('7643','2013-06-13','17:05:00',9.15),('7643','2013-06-13','17:10:00',8.99),('7643','2013-06-13','17:15:00',8.86),('7643','2013-06-13','17:20:00',8.51),('7643','2013-06-13','17:25:00',8.16),('7643','2013-06-13','17:30:00',7.69),('7643','2013-06-13','17:35:00',7.57),('7643','2013-06-13','17:40:00',7.45),('7643','2013-06-13','17:45:00',7.16),('7643','2013-06-13','17:50:00',6.85),('7643','2013-06-13','17:55:00',6.46),('7643','2013-06-13','18:00:00',6.08),('7643','2013-06-13','18:05:00',5.91),('7643','2013-06-13','18:10:00',5.57),('7643','2013-06-13','18:15:00',5.3),('7643','2013-06-13','18:20:00',4.97),('7643','2013-06-13','18:25:00',4.65),('7643','2013-06-13','18:30:00',4.34),('7643','2013-06-13','18:35:00',4.01),('7643','2013-06-13','18:40:00',3.67),('7643','2013-06-13','18:45:00',3.29),('7643','2013-06-13','18:50:00',2.93),('7643','2013-06-13','18:55:00',2.63),('7643','2013-06-13','19:00:00',2.33),('7643','2013-06-13','19:05:00',2.1),('7643','2013-06-13','19:10:00',1.84),('7643','2013-06-13','19:15:00',1.55),('7643','2013-06-13','19:20:00',1.29),('7643','2013-06-13','19:25:00',1.13),('7643','2013-06-12','06:45:00',1.19),('7643','2013-06-12','06:50:00',1.42),('7643','2013-06-12','06:55:00',1.71),('7643','2013-06-12','07:00:00',1.95),('7643','2013-06-12','07:05:00',2.27),('7643','2013-06-12','07:10:00',2.58),('7643','2013-06-12','07:15:00',2.91),('7643','2013-06-12','07:20:00',3.23),('7643','2013-06-12','07:25:00',3.56),('7643','2013-06-12','07:30:00',3.9),('7643','2013-06-12','07:35:00',4.26),('7643','2013-06-12','07:40:00',4.64),('7643','2013-06-12','07:45:00',4.95),('7643','2013-06-12','07:50:00',5.26),('7643','2013-06-12','07:55:00',5.59),('7643','2013-06-12','08:00:00',5.91),('7643','2013-06-12','08:05:00',6.23),('7643','2013-06-12','08:10:00',6.53),('7643','2013-06-12','08:15:00',6.71),('7643','2013-06-12','08:20:00',6.98),('7643','2013-06-12','08:25:00',7.29),('7643','2013-06-12','08:30:00',7.74),('7643','2013-06-12','08:35:00',8.1),('7643','2013-06-12','08:40:00',8.38),('7643','2013-06-12','08:45:00',8.74),('7643','2013-06-12','08:50:00',9.01),('7643','2013-06-12','08:55:00',9.34),('7643','2013-06-12','09:00:00',9.67),('7643','2013-06-12','09:05:00',10),('7643','2013-06-12','09:10:00',10.28),('7643','2013-06-12','09:15:00',10.68),('7643','2013-06-12','09:20:00',10.96),('7643','2013-06-12','09:25:00',11.29),('7643','2013-06-12','09:30:00',11.58),('7643','2013-06-12','09:35:00',11.79),('7643','2013-06-12','09:40:00',12),('7643','2013-06-12','09:45:00',12.22),('7643','2013-06-12','09:50:00',12.38),('7643','2013-06-12','09:55:00',12.66),('7643','2013-06-12','10:00:00',12.87),('7643','2013-06-12','10:05:00',13.05),('7643','2013-06-12','10:10:00',13.24),('7643','2013-06-12','10:15:00',13.43),('7643','2013-06-12','10:20:00',13.57),('7643','2013-06-12','10:25:00',13.75),('7643','2013-06-12','10:30:00',14.02),('7643','2013-06-12','10:35:00',14.18),('7643','2013-06-12','10:40:00',14.28),('7643','2013-06-12','10:45:00',14.54),('7643','2013-06-12','10:50:00',14.7),('7643','2013-06-12','10:55:00',14.83),('7643','2013-06-12','11:00:00',14.92),('7643','2013-06-12','11:05:00',15.15),('7643','2013-06-12','11:10:00',15.31),('7643','2013-06-12','11:15:00',15.4),('7643','2013-06-12','11:20:00',15.51),('7643','2013-06-12','11:25:00',15.63),('7643','2013-06-12','11:30:00',15.66),('7643','2013-06-12','11:35:00',15.85),('7643','2013-06-12','11:40:00',15.98),('7643','2013-06-12','11:45:00',16.21),('7643','2013-06-12','11:50:00',16.22),('7643','2013-06-12','11:55:00',16.23),('7643','2013-06-12','12:00:00',16.29),('7643','2013-06-12','12:05:00',16.5),('7643','2013-06-12','12:10:00',16.51),('7643','2013-06-12','12:15:00',16.56),('7643','2013-06-12','12:20:00',16.59),('7643','2013-06-12','12:25:00',16.74),('7643','2013-06-12','12:30:00',16.74),('7643','2013-06-12','12:35:00',16.71),('7643','2013-06-12','12:40:00',16.74),('7643','2013-06-12','12:45:00',16.79),('7643','2013-06-12','12:50:00',16.84),('7643','2013-06-12','12:55:00',16.73),('7643','2013-06-12','13:00:00',16.75),('7643','2013-06-12','13:05:00',16.8),('7643','2013-06-12','13:10:00',16.72),('7643','2013-06-12','13:15:00',16.63),('7643','2013-06-12','13:20:00',16.46),('7643','2013-06-12','13:25:00',16.63),('7643','2013-06-12','13:30:00',16.5),('7643','2013-06-12','13:35:00',16.48),('7643','2013-06-12','13:40:00',16.49),('7643','2013-06-12','13:45:00',16.47),('7643','2013-06-12','13:50:00',16.44),('7643','2013-06-12','13:55:00',16.45),('7643','2013-06-12','14:00:00',16.49),('7643','2013-06-12','14:05:00',16.37),('7643','2013-06-12','14:10:00',16.18),('7643','2013-06-12','14:15:00',16.08),('7643','2013-06-12','14:20:00',16.08),('7643','2013-06-12','14:25:00',14.88),('7643','2013-06-12','14:30:00',15.1),('7643','2013-06-12','14:35:00',10.91),('7643','2013-06-12','14:40:00',15.4),('7643','2013-06-12','14:45:00',15.82),('7643','2013-06-12','14:50:00',15.41),('7643','2013-06-12','14:55:00',15.33),('7643','2013-06-12','15:00:00',15.26),('7643','2013-06-12','15:05:00',15.07),('7643','2013-06-12','15:10:00',14.85),('7643','2013-06-12','15:15:00',14.63),('7643','2013-06-12','15:20:00',14.41),('7643','2013-06-12','15:25:00',14.34),('7643','2013-06-12','15:30:00',14.21),('7643','2013-06-12','15:35:00',14.03),('7643','2013-06-12','15:40:00',13.74),('7643','2013-06-12','15:45:00',13.59),('7643','2013-06-12','15:50:00',13.42),('7643','2013-06-12','15:55:00',13.23),('7643','2013-06-12','16:00:00',13.04),('7643','2013-06-12','16:05:00',12.82),('7643','2013-06-12','16:10:00',12.49),('7643','2013-06-12','16:15:00',12.21),('7643','2013-06-12','16:20:00',11.88),('7643','2013-06-12','16:25:00',11.61),('7643','2013-06-12','16:30:00',11.43),('7643','2013-06-12','16:35:00',11.16),('7643','2013-06-12','16:40:00',10.84),('7643','2013-06-12','16:45:00',10.55),('7643','2013-06-12','16:50:00',10.15),('7643','2013-06-12','16:55:00',9.94),('7643','2013-06-12','17:00:00',9.71),('7643','2013-06-12','17:05:00',9.32),('7643','2013-06-12','17:10:00',9.03),('7643','2013-06-12','17:15:00',8.71),('7643','2013-06-12','17:20:00',8.44),('7643','2013-06-12','17:25:00',8.23),('7643','2013-06-12','17:30:00',7.87),('7643','2013-06-12','17:35:00',7.6),('7643','2013-06-12','17:40:00',7.43),('7643','2013-06-12','17:45:00',7.13),('7643','2013-06-12','17:50:00',6.84),('7643','2013-06-12','17:55:00',6.42),('7643','2013-06-12','18:00:00',6.03),('7643','2013-06-12','18:05:00',5.71),('7643','2013-06-12','18:10:00',5.39),('7643','2013-06-12','18:15:00',5.15),('7643','2013-06-12','18:20:00',4.89),('7643','2013-06-12','18:25:00',4.59),('7643','2013-06-12','18:30:00',4.27),('7643','2013-06-12','18:35:00',3.93),('7643','2013-06-12','18:40:00',3.54),('7643','2013-06-12','18:45:00',3.14),('7643','2013-06-12','18:50:00',2.83),('7643','2013-06-12','18:55:00',2.55),('7643','2013-06-12','19:00:00',2.23),('7643','2013-06-12','19:05:00',1.99),('7643','2013-06-12','19:10:00',1.77),('7643','2013-06-12','19:15:00',1.5),('7643','2013-06-12','19:20:00',1.27),('7643','2013-06-12','19:25:00',1.1),('7643','2013-06-11','06:45:00',1.18),('7643','2013-06-11','06:50:00',1.41),('7643','2013-06-11','06:55:00',1.7),('7643','2013-06-11','07:00:00',1.95),('7643','2013-06-11','07:05:00',2.27),('7643','2013-06-11','07:10:00',2.59),('7643','2013-06-11','07:15:00',2.91),('7643','2013-06-11','07:20:00',3.25),('7643','2013-06-11','07:25:00',3.58),('7643','2013-06-11','07:30:00',3.92),('7643','2013-06-11','07:35:00',4.25),('7643','2013-06-11','07:40:00',4.62),('7643','2013-06-11','07:45:00',4.97),('7643','2013-06-11','07:50:00',5.33),('7643','2013-06-11','07:55:00',5.69),('7643','2013-06-11','08:00:00',5.97),('7643','2013-06-11','08:05:00',6.28),('7643','2013-06-11','08:10:00',6.58),('7643','2013-06-11','08:15:00',6.88),('7643','2013-06-11','08:20:00',7.28),('7643','2013-06-11','08:25:00',7.64),('7643','2013-06-11','08:30:00',8),('7643','2013-06-11','08:35:00',8.28),('7643','2013-06-11','08:40:00',8.6),('7643','2013-06-11','08:45:00',8.99),('7643','2013-06-11','08:50:00',9.34),('7643','2013-06-11','08:55:00',9.64),('7643','2013-06-11','09:00:00',9.96),('7643','2013-06-11','09:05:00',10.33),('7643','2013-06-11','09:10:00',10.68),('7643','2013-06-11','09:15:00',10.95),('7643','2013-06-11','09:20:00',11.21),('7643','2013-06-11','09:25:00',11.45),('7643','2013-06-11','09:30:00',11.71),('7643','2013-06-11','09:35:00',11.92),('7643','2013-06-11','09:40:00',12.19),('7643','2013-06-11','09:45:00',12.41),('7643','2013-06-11','09:50:00',12.67),('7643','2013-06-11','09:55:00',12.93),('7643','2013-06-11','10:00:00',13.05),('7643','2013-06-11','10:05:00',13.18),('7643','2013-06-11','10:10:00',13.36),('7643','2013-06-11','10:15:00',13.49),('7643','2013-06-11','10:20:00',13.7),('7643','2013-06-11','10:25:00',13.93),('7643','2013-06-11','10:30:00',14.15),('7643','2013-06-11','10:35:00',14.21),('7643','2013-06-11','10:40:00',14.31),('7643','2013-06-11','10:45:00',14.54),('7643','2013-06-11','10:50:00',14.78),('7643','2013-06-11','10:55:00',14.98),('7643','2013-06-11','11:00:00',15.28),('7643','2013-06-11','11:05:00',15.34),('7643','2013-06-11','11:10:00',15.49),('7643','2013-06-11','11:15:00',15.64),('7643','2013-06-11','11:20:00',15.69),('7643','2013-06-11','11:25:00',15.73),('7643','2013-06-11','11:30:00',15.85),('7643','2013-06-11','11:35:00',15.92),('7643','2013-06-11','11:40:00',15.99),('7643','2013-06-11','11:45:00',16.08),('7643','2013-06-11','11:50:00',16.07),('7643','2013-06-11','11:55:00',16.47),('7643','2013-06-11','12:00:00',16.41),('7643','2013-06-11','12:05:00',16.58),('7643','2013-06-11','12:10:00',16.53),('7643','2013-06-11','12:15:00',16.65),('7643','2013-06-11','12:20:00',16.79),('7643','2013-06-11','12:25:00',17.48),('7643','2013-06-11','12:30:00',14.15),('7643','2013-06-11','12:35:00',17.81),('7643','2013-06-11','12:40:00',7.99),('7643','2013-06-11','12:45:00',10.25),('7643','2013-06-11','12:50:00',18.1),('7643','2013-06-11','12:55:00',12.62),('7643','2013-06-11','13:00:00',14.97),('7643','2013-06-11','13:05:00',11.95),('7643','2013-06-11','13:10:00',17.44),('7643','2013-06-11','13:15:00',16.99),('7643','2013-06-11','13:20:00',16.65),('7643','2013-06-11','13:25:00',16.47),('7643','2013-06-11','13:30:00',16.57),('7643','2013-06-11','13:35:00',16.7),('7643','2013-06-11','13:40:00',16.76),('7643','2013-06-11','13:45:00',16.88),('7643','2013-06-11','13:50:00',16.81),('7643','2013-06-11','13:55:00',17.08),('7643','2013-06-11','14:00:00',17.02),('7643','2013-06-11','14:05:00',11.77),('7643','2013-06-11','14:10:00',12.59),('7643','2013-06-11','14:15:00',17.87),('7643','2013-06-11','14:20:00',9.8),('7643','2013-06-11','14:25:00',6.16),('7643','2013-06-11','14:30:00',17.21),('7643','2013-06-11','14:35:00',17.03),('7643','2013-06-11','14:40:00',16.84),('7643','2013-06-11','14:45:00',16.53),('7643','2013-06-11','14:50:00',16.47),('7643','2013-06-11','14:55:00',16.78),('7643','2013-06-11','15:00:00',16.56),('7643','2013-06-11','15:05:00',15.81),('7643','2013-06-11','15:10:00',15.85),('7643','2013-06-11','15:15:00',12.98),('7643','2013-06-11','15:20:00',15.64),('7643','2013-06-11','15:25:00',14.83),('7643','2013-06-11','15:30:00',14.75),('7643','2013-06-11','15:35:00',14.65),('7643','2013-06-11','15:40:00',14.42),('7643','2013-06-11','15:45:00',14.35),('7643','2013-06-11','15:50:00',13.92),('7643','2013-06-11','15:55:00',13.87),('7643','2013-06-11','16:00:00',13.41),('7643','2013-06-11','16:05:00',12.98),('7643','2013-06-11','16:10:00',13.04),('7643','2013-06-11','16:15:00',12.71),('7643','2013-06-11','16:20:00',12.28),('7643','2013-06-11','16:25:00',12.21),('7643','2013-06-11','16:30:00',11.98),('7643','2013-06-11','16:35:00',11.58),('7643','2013-06-11','16:40:00',11.43),('7643','2013-06-11','16:45:00',10.67),('7643','2013-06-11','16:50:00',10.73),('7643','2013-06-11','16:55:00',10.38),('7643','2013-06-11','17:00:00',9.93),('7643','2013-06-11','17:05:00',9.79),('7643','2013-06-11','17:10:00',9.53),('7643','2013-06-11','17:15:00',9.15),('7643','2013-06-11','17:20:00',8.72),('7643','2013-06-11','17:25:00',8.44),('7643','2013-06-11','17:30:00',8.17),('7643','2013-06-11','17:35:00',7.95),('7643','2013-06-11','17:40:00',7.79),('7643','2013-06-11','17:45:00',7.37),('7643','2013-06-11','17:50:00',5.21),('7643','2013-06-11','17:55:00',2.28),('7643','2013-06-11','18:00:00',2.74),('7643','2013-06-11','18:05:00',6.17),('7643','2013-06-11','18:10:00',5.69),('7643','2013-06-11','18:15:00',5.43),('7643','2013-06-11','18:20:00',5.1),('7643','2013-06-11','18:25:00',4.35),('7643','2013-06-11','18:30:00',4.32),('7643','2013-06-11','18:35:00',4),('7643','2013-06-11','18:40:00',3.63),('7643','2013-06-11','18:45:00',3.17),('7643','2013-06-11','18:50:00',2.8),('7643','2013-06-11','18:55:00',2.53),('7643','2013-06-11','19:00:00',2.25),('7643','2013-06-11','19:05:00',1.99),('7643','2013-06-11','19:10:00',1.11),('7643','2013-06-11','19:15:00',1.27),('7643','2013-06-11','19:20:00',1.3),('7643','2013-06-11','19:25:00',1.08),('7643','2013-06-10','06:45:00',1.14),('7643','2013-06-10','06:50:00',1.36),('7643','2013-06-10','06:55:00',1.55),('7643','2013-06-10','07:00:00',1.76),('7643','2013-06-10','07:05:00',1.84),('7643','2013-06-10','07:10:00',2.01),('7643','2013-06-10','07:15:00',2.31),('7643','2013-06-10','07:20:00',2.82),('7643','2013-06-10','07:25:00',4.19),('7643','2013-06-10','07:30:00',3.97),('7643','2013-06-10','07:35:00',4.21),('7643','2013-06-10','07:40:00',3.97),('7643','2013-06-10','07:45:00',3),('7643','2013-06-10','07:50:00',5.53),('7643','2013-06-10','07:55:00',4.59),('7643','2013-06-10','08:00:00',4.95),('7643','2013-06-10','08:05:00',6.87),('7643','2013-06-10','08:10:00',7.37),('7643','2013-06-10','08:15:00',6.17),('7643','2013-06-10','08:20:00',2.69),('7643','2013-06-10','08:25:00',3.62),('7643','2013-06-10','08:30:00',3.84),('7643','2013-06-10','08:35:00',1.93),('7643','2013-06-10','08:40:00',7.52),('7643','2013-06-10','08:45:00',9.71),('7643','2013-06-10','08:50:00',7.37),('7643','2013-06-10','08:55:00',9.9),('7643','2013-06-10','09:00:00',4.84),('7643','2013-06-10','09:05:00',2.59),('7643','2013-06-10','09:10:00',7.59),('7643','2013-06-10','09:15:00',11.61),('7643','2013-06-10','09:20:00',11.77),('7643','2013-06-10','09:25:00',12.78),('7643','2013-06-10','09:30:00',8.81),('7643','2013-06-10','09:35:00',8.64),('7643','2013-06-10','09:40:00',2.89),('7643','2013-06-10','09:45:00',7.35),('7643','2013-06-10','09:50:00',12.51),('7643','2013-06-10','09:55:00',13.7),('7643','2013-06-10','10:00:00',13.84),('7643','2013-06-10','10:05:00',13.6),('7643','2013-06-10','10:10:00',13.38),('7643','2013-06-10','10:15:00',14.02),('7643','2013-06-10','10:20:00',14.32),('7643','2013-06-10','10:25:00',14.48),('7643','2013-06-10','10:30:00',14.41),('7643','2013-06-10','10:35:00',14.56),('7643','2013-06-10','10:40:00',13.6),('7643','2013-06-10','10:45:00',9.58),('7643','2013-06-10','10:50:00',14.19),('7643','2013-06-10','10:55:00',3.57),('7643','2013-06-10','11:00:00',9.51),('7643','2013-06-10','11:05:00',16.63),('7643','2013-06-10','11:10:00',7.05),('7643','2013-06-10','11:15:00',9.43),('7643','2013-06-10','11:20:00',16.17),('7643','2013-06-10','11:25:00',16.35),('7643','2013-06-10','11:30:00',16.39),('7643','2013-06-10','11:35:00',16.21),('7643','2013-06-10','11:40:00',16.26),('7643','2013-06-10','11:45:00',16.5),('7643','2013-06-10','11:50:00',16.68),('7643','2013-06-10','11:55:00',16.7),('7643','2013-06-10','12:00:00',16.87),('7643','2013-06-10','12:05:00',17.44),('7643','2013-06-10','12:10:00',16.67),('7643','2013-06-10','12:15:00',16.97),('7643','2013-06-10','12:20:00',17.09),('7643','2013-06-10','12:25:00',17.02),('7643','2013-06-10','12:30:00',17.12),('7643','2013-06-10','12:35:00',17.13),('7643','2013-06-10','12:40:00',17.16),('7643','2013-06-10','12:45:00',17.18),('7643','2013-06-10','12:50:00',17.39),('7643','2013-06-10','12:55:00',17.42),('7643','2013-06-10','13:00:00',17.4),('7643','2013-06-10','13:05:00',17.5),('7643','2013-06-10','13:10:00',17.49),('7643','2013-06-10','13:15:00',17.41),('7643','2013-06-10','13:20:00',17.46),('7643','2013-06-10','13:25:00',17.35),('7643','2013-06-10','13:30:00',17.42),('7643','2013-06-10','13:35:00',17.49),('7643','2013-06-10','13:40:00',17.62),('7643','2013-06-10','13:45:00',17.52),('7643','2013-06-10','13:50:00',17.76),('7643','2013-06-10','13:55:00',16.7),('7643','2013-06-10','14:00:00',17.36),('7643','2013-06-10','14:05:00',17.3),('7643','2013-06-10','14:10:00',17.08),('7643','2013-06-10','14:15:00',16.86),('7643','2013-06-10','14:20:00',16.76),('7643','2013-06-10','14:25:00',16.6),('7643','2013-06-10','14:30:00',16.56),('7643','2013-06-10','14:35:00',16.44),('7643','2013-06-10','14:40:00',16.27),('7643','2013-06-10','14:45:00',16.15),('7643','2013-06-10','14:50:00',15.96),('7643','2013-06-10','14:55:00',15.88),('7643','2013-06-10','15:00:00',15.72),('7643','2013-06-10','15:05:00',15.6),('7643','2013-06-10','15:10:00',15.43),('7643','2013-06-10','15:15:00',15.25),('7643','2013-06-10','15:20:00',15.14),('7643','2013-06-10','15:25:00',14.89),('7643','2013-06-10','15:30:00',14.76),('7643','2013-06-10','15:35:00',14.78),('7643','2013-06-10','15:40:00',14.7),('7643','2013-06-10','15:45:00',14.79),('7643','2013-06-10','15:50:00',14.16),('7643','2013-06-10','15:55:00',13.97),('7643','2013-06-10','16:00:00',13.85),('7643','2013-06-10','16:05:00',13.6),('7643','2013-06-10','16:10:00',13.31),('7643','2013-06-10','16:15:00',12.97),('7643','2013-06-10','16:20:00',12.69),('7643','2013-06-10','16:25:00',12.45),('7643','2013-06-10','16:30:00',12.25),('7643','2013-06-10','16:35:00',12),('7643','2013-06-10','16:40:00',11.99),('7643','2013-06-10','16:45:00',12.54),('7643','2013-06-10','16:50:00',12.68),('7643','2013-06-10','16:55:00',12.23),('7643','2013-06-10','17:00:00',11.01),('7643','2013-06-10','17:05:00',7.72),('7643','2013-06-10','17:10:00',3.68),('7643','2013-06-10','17:15:00',2.52),('7643','2013-06-10','17:20:00',2.04),('7643','2013-06-10','17:25:00',1.56),('7643','2013-06-10','17:30:00',1.25),('7643','2013-06-10','19:10:00',1.29),('7643','2013-06-10','19:15:00',1.87),('7643','2013-06-10','19:20:00',1.82),('7643','2013-06-10','19:25:00',1.63),('7643','2013-06-10','19:30:00',2.05),('7643','2013-06-10','19:35:00',1.69),('7643','2014-04-02','07:45:00',1.12),('7643','2014-04-02','07:50:00',1.27),('7643','2014-04-02','07:55:00',1.42),('7643','2014-04-02','08:00:00',1.61),('7643','2014-04-02','08:05:00',1.81),('7643','2014-04-02','08:10:00',1.99),('7643','2014-04-02','08:15:00',2.1),('7643','2014-04-02','08:20:00',2.28),('7643','2014-04-02','08:25:00',2.37),('7643','2014-04-02','08:30:00',2.57),('7643','2014-04-02','08:35:00',2.75),('7643','2014-04-02','08:40:00',3.03),('7643','2014-04-02','08:45:00',3.56),('7643','2014-04-02','08:50:00',3.68),('7643','2014-04-02','08:55:00',4.26),('7643','2014-04-02','09:00:00',4.74),('7643','2014-04-02','09:05:00',5.17),('7643','2014-04-02','09:10:00',5),('7643','2014-04-02','09:15:00',4.59),('7643','2014-04-02','09:20:00',4.6),('7643','2014-04-02','09:25:00',4.92),('7643','2014-04-02','09:30:00',5.76),('7643','2014-04-02','09:35:00',7.05),('7643','2014-04-02','09:40:00',7.54),('7643','2014-04-02','09:45:00',7.42),('7643','2014-04-02','09:50:00',7.09),('7643','2014-04-02','09:55:00',7.37),('7643','2014-04-02','10:00:00',8.8),('7643','2014-04-02','10:05:00',10.42),('7643','2014-04-02','10:10:00',11.18),('7643','2014-04-02','10:15:00',12.49),('7643','2014-04-02','10:20:00',12.9),('7643','2014-04-02','10:25:00',11.01),('7643','2014-04-02','10:30:00',10.46),('7643','2014-04-02','10:35:00',11.3),('7643','2014-04-02','10:40:00',9.08),('7643','2014-04-02','10:45:00',9.5),('7643','2014-04-02','10:50:00',7.86),('7643','2014-04-02','10:55:00',8.39),('7643','2014-04-02','11:00:00',7.9),('7643','2014-04-02','11:05:00',6.48),('7643','2014-04-02','11:10:00',6.12),('7643','2014-04-02','11:15:00',5.71),('7643','2014-04-02','11:20:00',5.43),('7643','2014-04-02','11:25:00',5.05),('7643','2014-04-02','11:30:00',5.02),('7643','2014-04-02','11:35:00',5.36),('7643','2014-04-02','11:40:00',5.91),('7643','2014-04-02','11:45:00',6.84),('7643','2014-04-02','11:50:00',8.44),('7643','2014-04-02','11:55:00',9.46),('7643','2014-04-02','12:00:00',8.88),('7643','2014-04-02','12:05:00',8.86),('7643','2014-04-02','12:10:00',8.57),('7643','2014-04-02','12:15:00',8.35),('7643','2014-04-02','12:20:00',9.35),('7643','2014-04-02','12:25:00',11.21),('7643','2014-04-02','12:30:00',15.65),('7643','2014-04-02','12:35:00',14.58),('7643','2014-04-02','12:40:00',16.72),('7643','2014-04-02','12:45:00',9.2),('7643','2014-04-02','12:50:00',10.56),('7643','2014-04-02','12:55:00',10.33),('7643','2014-04-02','13:00:00',10.28),('7643','2014-04-02','13:05:00',13.95),('7643','2014-04-02','13:10:00',9.25),('7643','2014-04-02','13:15:00',18.27),('7643','2014-04-02','13:20:00',7.88),('7643','2014-04-02','13:25:00',11.15),('7643','2014-04-02','13:30:00',11.24),('7643','2014-04-02','13:35:00',17.41),('7643','2014-04-02','13:40:00',15.86),('7643','2014-04-02','13:45:00',8.92),('7643','2014-04-02','13:50:00',7.88),('7643','2014-04-02','13:55:00',10.37),('7643','2014-04-02','14:00:00',14.74),('7643','2014-04-02','14:05:00',13.77),('7643','2014-04-02','14:10:00',10.46),('7643','2014-04-02','14:15:00',14.16),('7643','2014-04-02','14:20:00',14.84),('7643','2014-04-02','14:25:00',15.08),('7643','2014-04-02','14:30:00',15.05),('7643','2014-04-02','14:35:00',15.58),('7643','2014-04-02','14:40:00',15.07),('7643','2014-04-02','14:45:00',14.74),('7643','2014-04-02','14:50:00',14.35),('7643','2014-04-02','14:55:00',14.09),('7643','2014-04-02','15:00:00',13.93),('7643','2014-04-02','15:05:00',13.69),('7643','2014-04-02','15:10:00',13.61),('7643','2014-04-02','15:15:00',13.53),('7643','2014-04-02','15:20:00',13.5),('7643','2014-04-02','15:25:00',13.4),('7643','2014-04-02','15:30:00',13.18),('7643','2014-04-02','15:35:00',13),('7643','2014-04-02','15:40:00',12.78),('7643','2014-04-02','15:45:00',12.74),('7643','2014-04-02','15:50:00',12.52),('7643','2014-04-02','15:55:00',12.45),('7643','2014-04-02','16:00:00',12.29),('7643','2014-04-02','16:05:00',12.02),('7643','2014-04-02','16:10:00',11.92),('7643','2014-04-02','16:15:00',11.47),('7643','2014-04-02','16:20:00',11.31),('7643','2014-04-02','16:25:00',10.95),('7643','2014-04-02','16:30:00',10.62),('7643','2014-04-02','16:35:00',10.34),('7643','2014-04-02','16:40:00',10.08),('7643','2014-04-02','16:45:00',9.56),('7643','2014-04-02','16:50:00',7.29),('7643','2014-04-02','16:55:00',5.86),('7643','2014-04-02','17:00:00',4.31),('7643','2014-04-02','17:05:00',3.97),('7643','2014-04-02','17:10:00',3.47),('7643','2014-04-02','17:15:00',3.24),('7643','2014-04-02','17:20:00',3.31),('7643','2014-04-02','17:25:00',3.52),('7643','2014-04-02','17:30:00',3.49),('7643','2014-04-02','17:35:00',2.09),('7643','2014-04-02','17:40:00',1.83),('7643','2014-04-02','17:45:00',3.85),('7643','2014-04-02','17:50:00',5.29),('7643','2014-04-02','17:55:00',4.64),('7643','2014-04-02','18:00:00',4.18),('7643','2014-04-02','18:05:00',3.75),('7643','2014-04-02','18:10:00',3.35),('7643','2014-04-02','18:15:00',2.95),('7643','2014-04-02','18:20:00',2.53),('7643','2014-04-02','18:25:00',1.92),('7643','2014-04-02','18:30:00',1.21),('7643','2014-04-02','18:35:00',1.2),('7643','2014-04-02','18:40:00',1.15),('7643','2014-04-02','18:45:00',1.09),('7643','2013-06-09','07:05:00',1.79),('7643','2013-06-09','07:10:00',2.61),('7643','2013-06-09','07:15:00',1.61),('7643','2013-06-09','07:20:00',2.43),('7643','2013-06-09','07:25:00',2.46),('7643','2013-06-09','07:30:00',4.21),('7643','2013-06-09','07:35:00',5.93),('7643','2013-06-09','07:40:00',4.27),('7643','2013-06-09','07:45:00',2.87),('7643','2013-06-09','07:50:00',2.81),('7643','2013-06-09','07:55:00',2.72),('7643','2013-06-09','08:00:00',4.26),('7643','2013-06-09','08:05:00',5.53),('7643','2013-06-09','08:10:00',7.34),('7643','2013-06-09','08:15:00',6.99),('7643','2013-06-09','08:20:00',7.85),('7643','2013-06-09','08:25:00',4.82),('7643','2013-06-09','08:30:00',5.2),('7643','2013-06-09','08:35:00',4.4),('7643','2013-06-09','08:40:00',3.6),('7643','2013-06-09','08:45:00',3.41),('7643','2013-06-09','08:50:00',4.37),('7643','2013-06-09','08:55:00',3.86),('7643','2013-06-09','09:00:00',4.74),('7643','2013-06-09','09:05:00',4.44),('7643','2013-06-09','09:10:00',6.84),('7643','2013-06-09','09:15:00',3.77),('7643','2013-06-09','09:20:00',7.39),('7643','2013-06-09','09:25:00',6.28),('7643','2013-06-09','09:30:00',5.61),('7643','2013-06-09','09:35:00',13.4),('7643','2013-06-09','09:40:00',8.42),('7643','2013-06-09','09:45:00',12.92),('7643','2013-06-09','09:50:00',8.45),('7643','2013-06-09','09:55:00',7.04),('7643','2013-06-09','10:00:00',9.22),('7643','2013-06-09','10:05:00',11.26),('7643','2013-06-09','10:10:00',11.63),('7643','2013-06-09','10:15:00',13.77),('7643','2013-06-09','10:20:00',11.7),('7643','2013-06-09','10:25:00',11.84),('7643','2013-06-09','10:30:00',6.96),('7643','2013-06-09','10:35:00',6.94),('7643','2013-06-09','10:40:00',5.78),('7643','2013-06-09','10:45:00',5.05),('7643','2013-06-09','10:50:00',6.48),('7643','2013-06-09','10:55:00',11.05),('7643','2013-06-09','11:00:00',9.92),('7643','2013-06-09','11:05:00',6.73),('7643','2013-06-09','11:10:00',9.29),('7643','2013-06-09','11:15:00',14.01),('7643','2013-06-09','11:20:00',12.29),('7643','2013-06-09','11:25:00',15.96),('7643','2013-06-09','11:30:00',15.4),('7643','2013-06-09','11:35:00',16.76),('7643','2013-06-09','11:40:00',12.89),('7643','2013-06-09','11:45:00',14.2),('7643','2013-06-09','11:50:00',6.94),('7643','2013-06-09','11:55:00',10.61),('7643','2013-06-09','12:00:00',18.25),('7643','2013-06-09','12:05:00',10.62),('7643','2013-06-09','12:10:00',17.11),('7643','2013-06-09','12:15:00',16.41),('7643','2013-06-09','12:20:00',17.94),('7643','2013-06-09','12:25:00',16.36),('7643','2013-06-09','12:30:00',15.28),('7643','2013-06-09','12:35:00',11.68),('7643','2013-06-09','12:40:00',10.65),('7643','2013-06-09','12:45:00',13.36),('7643','2013-06-09','12:50:00',11.3),('7643','2013-06-09','12:55:00',6.8),('7643','2013-06-09','13:00:00',8.54),('7643','2013-06-09','13:05:00',18.66),('7643','2013-06-09','13:10:00',13.49),('7643','2013-06-09','13:15:00',13.29),('7643','2013-06-09','13:20:00',11.56),('7643','2013-06-09','13:25:00',14.27),('7643','2013-06-09','13:30:00',15.02),('7643','2013-06-09','13:35:00',19.16),('7643','2013-06-09','13:40:00',13.77),('7643','2013-06-09','13:45:00',15.91),('7643','2013-06-09','13:50:00',9.88),('7643','2013-06-09','13:55:00',11.29),('7643','2013-06-09','14:00:00',17.9),('7643','2013-06-09','14:05:00',16.86),('7643','2013-06-09','14:10:00',17.33),('7643','2013-06-09','14:15:00',17.69),('7643','2013-06-09','14:20:00',17.17),('7643','2013-06-09','14:25:00',17.02),('7643','2013-06-09','14:30:00',16.6),('7643','2013-06-09','14:35:00',16.55),('7643','2013-06-09','14:40:00',14.55),('7643','2013-06-09','14:45:00',16.66),('7643','2013-06-09','14:50:00',16.17),('7643','2013-06-09','14:55:00',16.06),('7643','2013-06-09','15:00:00',15.92),('7643','2013-06-09','15:05:00',15.71),('7643','2013-06-09','15:10:00',15.55),('7643','2013-06-09','15:15:00',15.32),('7643','2013-06-09','15:20:00',15.33),('7643','2013-06-09','15:25:00',15.13),('7643','2013-06-09','15:30:00',14.98),('7643','2013-06-09','15:35:00',14.86),('7643','2013-06-09','15:40:00',14.66),('7643','2013-06-09','15:45:00',14.42),('7643','2013-06-09','15:50:00',14.2),('7643','2013-06-09','15:55:00',14.07),('7643','2013-06-09','16:00:00',13.78),('7643','2013-06-09','16:05:00',13.61),('7643','2013-06-09','16:10:00',13.41),('7643','2013-06-09','16:15:00',13.09),('7643','2013-06-09','16:20:00',12.75),('7643','2013-06-09','16:25:00',12.44),('7643','2013-06-09','16:30:00',12.1),('7643','2013-06-09','16:35:00',12.07),('7643','2013-06-09','16:40:00',11.76),('7643','2013-06-09','16:45:00',11.41),('7643','2013-06-09','16:50:00',11.12),('7643','2013-06-09','16:55:00',10.89),('7643','2013-06-09','17:00:00',10.63),('7643','2013-06-09','17:05:00',10.4),('7643','2013-06-09','17:10:00',9.98),('7643','2013-06-09','17:15:00',9.54),('7643','2013-06-09','17:20:00',9.16),('7643','2013-06-09','17:25:00',8.87),('7643','2013-06-09','17:30:00',8.48),('7643','2013-06-09','17:35:00',8.16),('7643','2013-06-09','17:40:00',7.97),('7643','2013-06-09','17:45:00',7.66),('7643','2013-06-09','17:50:00',7.29),('7643','2013-06-09','17:55:00',6.96),('7643','2013-06-09','18:00:00',6.55),('7643','2013-06-09','18:05:00',6.14),('7643','2013-06-09','18:10:00',5.9),('7643','2013-06-09','18:15:00',5.57),('7643','2013-06-09','18:20:00',5.25),('7643','2013-06-09','18:25:00',4.9),('7643','2013-06-09','18:30:00',4.55),('7643','2013-06-09','18:35:00',4.24),('7643','2013-06-09','18:40:00',3.81),('7643','2013-06-09','18:45:00',3.35),('7643','2013-06-09','18:50:00',2.98),('7643','2013-06-09','18:55:00',2.7),('7643','2013-06-09','19:00:00',2.34),('7643','2013-06-09','19:05:00',2.04),('7643','2013-06-09','19:10:00',1.83),('7643','2013-06-09','19:15:00',1.5),('7643','2013-06-09','19:20:00',1.26),('7643','2013-06-09','19:25:00',1.08),('7643','2013-06-08','06:30:00',1.03),('7643','2013-06-08','07:05:00',1.11),('7643','2013-06-08','07:10:00',2.16),('7643','2013-06-08','07:15:00',1.93),('7643','2013-06-08','07:20:00',1.33),('7643','2013-06-08','07:25:00',2.68),('7643','2013-06-08','07:30:00',2.9),('7643','2013-06-08','07:35:00',5.15),('7643','2013-06-08','07:40:00',4.72),('7643','2013-06-08','07:45:00',2.35),('7643','2013-06-08','07:50:00',3.38),('7643','2013-06-08','07:55:00',5.4),('7643','2013-06-08','08:00:00',5.99),('7643','2013-06-08','08:05:00',6.02),('7643','2013-06-08','08:10:00',6.83),('7643','2013-06-08','08:15:00',7.2),('7643','2013-06-08','08:20:00',6.87),('7643','2013-06-08','08:25:00',6.9),('7643','2013-06-08','08:30:00',7.31),('7643','2013-06-08','08:35:00',7.79),('7643','2013-06-08','08:40:00',7.98),('7643','2013-06-08','08:45:00',8.47),('7643','2013-06-08','08:50:00',8.8),('7643','2013-06-08','08:55:00',9.18),('7643','2013-06-08','09:00:00',9.4),('7643','2013-06-08','09:05:00',9.69),('7643','2013-06-08','09:10:00',9.91),('7643','2013-06-08','09:15:00',10.23),('7643','2013-06-08','09:20:00',10.58),('7643','2013-06-08','09:25:00',10.64),('7643','2013-06-08','09:30:00',11.05),('7643','2013-06-08','09:35:00',11.07),('7643','2013-06-08','09:40:00',11.35),('7643','2013-06-08','09:45:00',11.78),('7643','2013-06-08','09:50:00',11.96),('7643','2013-06-08','09:55:00',12.19),('7643','2013-06-08','10:00:00',12.35),('7643','2013-06-08','10:05:00',12.55),('7643','2013-06-08','10:10:00',12.69),('7643','2013-06-08','10:15:00',12.88),('7643','2013-06-08','10:20:00',12.95),('7643','2013-06-08','10:25:00',13.19),('7643','2013-06-08','10:30:00',13.53),('7643','2013-06-08','10:35:00',13.57),('7643','2013-06-08','10:40:00',13.68),('7643','2013-06-08','10:45:00',13.8),('7643','2013-06-08','10:50:00',14),('7643','2013-06-08','10:55:00',14.2),('7643','2013-06-08','11:00:00',14.23),('7643','2013-06-08','11:05:00',14.21),('7643','2013-06-08','11:10:00',14.28),('7643','2013-06-08','11:15:00',14.8),('7643','2013-06-08','11:20:00',14.78),('7643','2013-06-08','11:25:00',14.84),('7643','2013-06-08','11:30:00',14.88),('7643','2013-06-08','11:35:00',14.84),('7643','2013-06-08','11:40:00',15.02),('7643','2013-06-08','11:45:00',15.32),('7643','2013-06-08','11:50:00',15.41),('7643','2013-06-08','11:55:00',15.31),('7643','2013-06-08','12:00:00',15.27),('7643','2013-06-08','12:05:00',15.6),('7643','2013-06-08','12:10:00',15.56),('7643','2013-06-08','12:15:00',15.53),('7643','2013-06-08','12:20:00',15.66),('7643','2013-06-08','12:25:00',15.66),('7643','2013-06-08','12:30:00',15.78),('7643','2013-06-08','12:35:00',15.74),('7643','2013-06-08','12:40:00',16.01),('7643','2013-06-08','12:45:00',15.37),('7643','2013-06-08','12:50:00',16.03),('7643','2013-06-08','12:55:00',13.35),('7643','2013-06-08','13:00:00',13.49),('7643','2013-06-08','13:05:00',12.78),('7643','2013-06-08','13:10:00',16.9),('7643','2013-06-08','13:15:00',16.27),('7643','2013-06-08','13:20:00',12.33),('7643','2013-06-08','13:25:00',13.7),('7643','2013-06-08','13:30:00',16.34),('7643','2013-06-08','13:35:00',16.84),('7643','2013-06-08','13:40:00',17.25),('7643','2013-06-08','13:45:00',17.32),('7643','2013-06-08','13:50:00',17.91),('7643','2013-06-08','13:55:00',16.71),('7643','2013-06-08','14:00:00',12.92),('7643','2013-06-08','14:05:00',17.25),('7643','2013-06-08','14:10:00',17.39),('7643','2013-06-08','14:15:00',11.42),('7643','2013-06-08','14:20:00',7.78),('7643','2013-06-08','14:25:00',4.47),('7643','2013-06-08','14:30:00',5.79),('7643','2013-06-08','14:35:00',14.76),('7643','2013-06-08','14:40:00',13.22),('7643','2013-06-08','14:45:00',14.52),('7643','2013-06-08','14:50:00',15.68),('7643','2013-06-08','14:55:00',15.74),('7643','2013-06-08','15:00:00',15.35),('7643','2013-06-08','15:05:00',14.66),('7643','2013-06-08','15:10:00',14.83),('7643','2013-06-08','15:15:00',14.36),('7643','2013-06-08','15:20:00',14.33),('7643','2013-06-08','15:25:00',14.41),('7643','2013-06-08','15:30:00',13.12),('7643','2013-06-08','15:35:00',13.79),('7643','2013-06-08','15:40:00',11.04),('7643','2013-06-08','15:45:00',11.54),('7643','2013-06-08','15:50:00',12.61),('7643','2013-06-08','15:55:00',13.5),('7643','2013-06-08','16:00:00',9.8),('7643','2013-06-08','16:05:00',12.59),('7643','2013-06-08','16:10:00',11.27),('7643','2013-06-08','16:15:00',7.31),('7643','2013-06-08','16:20:00',5.56),('7643','2013-06-08','16:25:00',8.01),('7643','2013-06-08','16:30:00',5.18),('7643','2013-06-08','16:35:00',3.65),('7643','2013-06-08','16:40:00',3.47),('7643','2013-06-08','16:45:00',3.44),('7643','2013-06-08','16:50:00',3.37),('7643','2013-06-08','16:55:00',3.14),('7643','2013-06-08','17:00:00',3.29),('7643','2013-06-08','17:05:00',3.8),('7643','2013-06-08','17:10:00',3.63),('7643','2013-06-08','17:15:00',2.97),('7643','2013-06-08','17:20:00',3.28),('7643','2013-06-08','17:25:00',2.52),('7643','2013-06-08','17:30:00',2.08),('7643','2013-06-08','17:35:00',2.38),('7643','2013-06-08','17:40:00',2.8),('7643','2013-06-08','17:45:00',2.52),('7643','2013-06-08','17:50:00',1.86),('7643','2013-06-08','17:55:00',2.04),('7643','2013-06-08','18:00:00',3.54),('7643','2013-06-08','18:05:00',3.12),('7643','2013-06-08','18:10:00',4.31),('7643','2013-06-08','18:15:00',4.31),('7643','2013-06-08','18:20:00',3.78),('7643','2013-06-08','18:25:00',1.8),('7643','2013-06-08','18:30:00',3.57),('7643','2013-06-08','18:35:00',2.05),('7643','2013-06-08','18:40:00',1.62),('7643','2013-06-08','18:45:00',2.05),('7643','2013-06-08','18:50:00',2.39),('7643','2013-06-08','18:55:00',1.82),('7643','2013-06-08','19:00:00',1.19),('7643','2013-06-07','06:45:00',1.17),('7643','2013-06-07','06:50:00',1.4),('7643','2013-06-07','06:55:00',1.67),('7643','2013-06-07','07:00:00',1.91),('7643','2013-06-07','07:05:00',2.24),('7643','2013-06-07','07:10:00',2.55),('7643','2013-06-07','07:15:00',2.82),('7643','2013-06-07','07:20:00',3.12),('7643','2013-06-07','07:25:00',3.4),('7643','2013-06-07','07:30:00',3.77),('7643','2013-06-07','07:35:00',4.07),('7643','2013-06-07','07:40:00',4.42),('7643','2013-06-07','07:45:00',4.76),('7643','2013-06-07','07:50:00',5.06),('7643','2013-06-07','07:55:00',5.38),('7643','2013-06-07','08:00:00',5.64),('7643','2013-06-07','08:05:00',5.96),('7643','2013-06-07','08:10:00',6.28),('7643','2013-06-07','08:15:00',6.53),('7643','2013-06-07','08:20:00',6.82),('7643','2013-06-07','08:25:00',7.15),('7643','2013-06-07','08:30:00',7.56),('7643','2013-06-07','08:35:00',7.88),('7643','2013-06-07','08:40:00',8.13),('7643','2013-06-07','08:45:00',8.51),('7643','2013-06-07','08:50:00',8.85),('7643','2013-06-07','08:55:00',9.17),('7643','2013-06-07','09:00:00',9.47),('7643','2013-06-07','09:05:00',9.82),('7643','2013-06-07','09:10:00',10.13),('7643','2013-06-07','09:15:00',10.33),('7643','2013-06-07','09:20:00',10.46),('7643','2013-06-07','09:25:00',10.81),('7643','2013-06-07','09:30:00',11.04),('7643','2013-06-07','09:35:00',11.17),('7643','2013-06-07','09:40:00',11.52),('7643','2013-06-07','09:45:00',11.56),('7643','2013-06-07','09:50:00',11.56),('7643','2013-06-07','09:55:00',12.13),('7643','2013-06-07','10:00:00',12.15),('7643','2013-06-07','10:05:00',8.23),('7643','2013-06-07','10:10:00',5.03),('7643','2013-06-07','10:15:00',13.27),('7643','2013-06-07','10:20:00',13.45),('7643','2013-06-07','10:25:00',13.67),('7643','2013-06-07','10:30:00',13.7),('7643','2013-06-07','10:35:00',13.84),('7643','2013-06-07','10:40:00',14.03),('7643','2013-06-07','10:45:00',14.56),('7643','2013-06-07','10:50:00',14.79),('7643','2013-06-07','10:55:00',15.41),('7643','2013-06-07','11:00:00',5.7),('7643','2013-06-07','11:05:00',8.75),('7643','2013-06-07','11:10:00',6.61),('7643','2013-06-07','11:15:00',14.99),('7643','2013-06-07','11:20:00',16.82),('7643','2013-06-07','11:25:00',16.77),('7643','2013-06-07','11:30:00',15.82),('7643','2013-06-07','11:35:00',12.69),('7643','2013-06-07','11:40:00',16.59),('7643','2013-06-07','11:45:00',16.29),('7643','2013-06-07','11:50:00',16.47),('7643','2013-06-07','11:55:00',16.89),('7643','2013-06-07','12:00:00',9.86),('7643','2013-06-07','12:05:00',11.96),('7643','2013-06-07','12:10:00',4.08),('7643','2013-06-07','12:15:00',8.02),('7643','2013-06-07','12:20:00',16.89),('7643','2013-06-07','12:25:00',4.18),('7643','2013-06-07','12:30:00',16.1),('7643','2013-06-07','12:35:00',12.98),('7643','2013-06-07','12:40:00',17.03),('7643','2013-06-07','12:45:00',14.47),('7643','2013-06-07','12:50:00',9.58),('7643','2013-06-07','12:55:00',17.69),('7643','2013-06-07','13:00:00',17.44),('7643','2013-06-07','13:05:00',13.8),('7643','2013-06-07','13:10:00',8.38),('7643','2013-06-07','13:15:00',15.99),('7643','2013-06-07','13:20:00',16.81),('7643','2013-06-07','13:25:00',17.45),('7643','2013-06-07','13:30:00',17.45),('7643','2013-06-07','13:35:00',17.2),('7643','2013-06-07','13:40:00',16.94),('7643','2013-06-07','13:45:00',16.98),('7643','2013-06-07','13:50:00',16.93),('7643','2013-06-07','13:55:00',16.77),('7643','2013-06-07','14:00:00',16.57),('7643','2013-06-07','14:05:00',16.53),('7643','2013-06-07','14:10:00',16.45),('7643','2013-06-07','14:15:00',16.51),('7643','2013-06-07','14:20:00',16.4),('7643','2013-06-07','14:25:00',16.27),('7643','2013-06-07','14:30:00',16.22),('7643','2013-06-07','14:35:00',16.07),('7643','2013-06-07','14:40:00',16.09),('7643','2013-06-07','14:45:00',15.99),('7643','2013-06-07','14:50:00',15.98),('7643','2013-06-07','14:55:00',15.87),('7643','2013-06-07','15:00:00',15.67),('7643','2013-06-07','15:05:00',15.09),('7643','2013-06-07','15:10:00',14.08),('7643','2013-06-07','15:15:00',14.39),('7643','2013-06-07','15:20:00',15.19),('7643','2013-06-07','15:25:00',14.26),('7643','2013-06-07','15:30:00',14.13),('7643','2013-06-07','15:35:00',14.63),('7643','2013-06-07','15:40:00',14.36),('7643','2013-06-07','15:45:00',14.81),('7643','2013-06-07','15:50:00',13.55),('7643','2013-06-07','15:55:00',13.69),('7643','2013-06-07','16:00:00',13.65),('7643','2013-06-07','16:05:00',13.53),('7643','2013-06-07','16:10:00',13.39),('7643','2013-06-07','16:15:00',13.2),('7643','2013-06-07','16:20:00',13.06),('7643','2013-06-07','16:25:00',12.41),('7643','2013-06-07','16:30:00',11.86),('7643','2013-06-07','16:35:00',11.47),('7643','2013-06-07','16:40:00',11.25),('7643','2013-06-07','16:45:00',10.96),('7643','2013-06-07','16:50:00',9.49),('7643','2013-06-07','16:55:00',9.1),('7643','2013-06-07','17:00:00',10.25),('7643','2013-06-07','17:05:00',9.08),('7643','2013-06-07','17:10:00',10.41),('7643','2013-06-07','17:15:00',10.17),('7643','2013-06-07','17:20:00',9.51),('7643','2013-06-07','17:25:00',8.99),('7643','2013-06-07','17:30:00',6.74),('7643','2013-06-07','17:35:00',4.65),('7643','2013-06-07','17:40:00',7.12),('7643','2013-06-07','17:45:00',8.06),('7643','2013-06-07','17:50:00',7),('7643','2013-06-07','17:55:00',7.22),('7643','2013-06-07','18:00:00',5.75),('7643','2013-06-07','18:05:00',5.2),('7643','2013-06-07','18:10:00',4.18),('7643','2013-06-07','18:15:00',4.21),('7643','2013-06-07','18:20:00',4.41),('7643','2013-06-07','18:25:00',3.71),('7643','2013-06-07','18:30:00',2.59),('7643','2013-06-07','18:35:00',2.27),('7643','2013-06-07','18:40:00',1.69),('7643','2013-06-07','18:45:00',1.42),('7643','2013-06-07','18:50:00',1.31),('7643','2013-06-07','18:55:00',1.34),('7643','2013-06-07','19:00:00',1.42),('7643','2013-06-07','19:05:00',1.47),('7643','2013-06-07','19:10:00',1.5),('7643','2013-06-07','19:15:00',1.52),('7643','2013-06-07','19:20:00',1.48),('7643','2013-06-07','19:25:00',1.4),('7643','2013-06-07','19:30:00',1.36),('7643','2013-06-07','19:35:00',1.24),('7643','2013-06-07','19:40:00',1.01),('7643','2013-06-06','06:45:00',1.21),('7643','2013-06-06','06:50:00',1.44),('7643','2013-06-06','06:55:00',1.72),('7643','2013-06-06','07:00:00',1.97),('7643','2013-06-06','07:05:00',2.31),('7643','2013-06-06','07:10:00',2.61),('7643','2013-06-06','07:15:00',2.96),('7643','2013-06-06','07:20:00',3.31),('7643','2013-06-06','07:25:00',3.61),('7643','2013-06-06','07:30:00',3.97),('7643','2013-06-06','07:35:00',4.33),('7643','2013-06-06','07:40:00',4.72),('7643','2013-06-06','07:45:00',5.08),('7643','2013-06-06','07:50:00',5.41),('7643','2013-06-06','07:55:00',5.75),('7643','2013-06-06','08:00:00',6.02),('7643','2013-06-06','08:05:00',6.34),('7643','2013-06-06','08:10:00',6.69),('7643','2013-06-06','08:15:00',6.95),('7643','2013-06-06','08:20:00',7.28),('7643','2013-06-06','08:25:00',7.67),('7643','2013-06-06','08:30:00',8.1),('7643','2013-06-06','08:35:00',8.43),('7643','2013-06-06','08:40:00',8.75),('7643','2013-06-06','08:45:00',9.19),('7643','2013-06-06','08:50:00',9.51),('7643','2013-06-06','08:55:00',9.84),('7643','2013-06-06','09:00:00',10.12),('7643','2013-06-06','09:05:00',10.43),('7643','2013-06-06','09:10:00',10.76),('7643','2013-06-06','09:15:00',11.12),('7643','2013-06-06','09:20:00',11.36),('7643','2013-06-06','09:25:00',11.62),('7643','2013-06-06','09:30:00',11.92),('7643','2013-06-06','09:35:00',12.21),('7643','2013-06-06','09:40:00',12.45),('7643','2013-06-06','09:45:00',12.72),('7643','2013-06-06','09:50:00',12.96),('7643','2013-06-06','09:55:00',13.17),('7643','2013-06-06','10:00:00',13.36),('7643','2013-06-06','10:05:00',13.59),('7643','2013-06-06','10:10:00',13.77),('7643','2013-06-06','10:15:00',14),('7643','2013-06-06','10:20:00',14.15),('7643','2013-06-06','10:25:00',14.28),('7643','2013-06-06','10:30:00',14.53),('7643','2013-06-06','10:35:00',14.69),('7643','2013-06-06','10:40:00',14.85),('7643','2013-06-06','10:45:00',15),('7643','2013-06-06','10:50:00',15.09),('7643','2013-06-06','10:55:00',15.22),('7643','2013-06-06','11:00:00',15.39),('7643','2013-06-06','11:05:00',15.56),('7643','2013-06-06','11:10:00',15.69),('7643','2013-06-06','11:15:00',15.7),('7643','2013-06-06','11:20:00',15.82),('7643','2013-06-06','11:25:00',15.94),('7643','2013-06-06','11:30:00',16.14),('7643','2013-06-06','11:35:00',16.32),('7643','2013-06-06','11:40:00',16.42),('7643','2013-06-06','11:45:00',16.41),('7643','2013-06-06','11:50:00',16.54),('7643','2013-06-06','11:55:00',16.58),('7643','2013-06-06','12:00:00',16.67),('7643','2013-06-06','12:05:00',16.72),('7643','2013-06-06','12:10:00',16.73),('7643','2013-06-06','12:15:00',16.84),('7643','2013-06-06','12:20:00',16.93),('7643','2013-06-06','12:25:00',16.83),('7643','2013-06-06','12:30:00',16.84),('7643','2013-06-06','12:35:00',16.76),('7643','2013-06-06','12:40:00',16.89),('7643','2013-06-06','12:45:00',17.03),('7643','2013-06-06','12:50:00',16.89),('7643','2013-06-06','12:55:00',16.99),('7643','2013-06-06','13:00:00',17.12),('7643','2013-06-06','13:05:00',16.99),('7643','2013-06-06','13:10:00',16.89),('7643','2013-06-06','13:15:00',16.86),('7643','2013-06-06','13:20:00',16.74),('7643','2013-06-06','13:25:00',16.78),('7643','2013-06-06','13:30:00',16.74),('7643','2013-06-06','13:35:00',16.69),('7643','2013-06-06','13:40:00',16.69),('7643','2013-06-06','13:45:00',16.6),('7643','2013-06-06','13:50:00',16.47),('7643','2013-06-06','13:55:00',16.34),('7643','2013-06-06','14:00:00',16.19),('7643','2013-06-06','14:05:00',16.06),('7643','2013-06-06','14:10:00',15.96),('7643','2013-06-06','14:15:00',15.99),('7643','2013-06-06','14:20:00',15.79),('7643','2013-06-06','14:25:00',15.58),('7643','2013-06-06','14:30:00',15.43),('7643','2013-06-06','14:35:00',15.38),('7643','2013-06-06','14:40:00',15.44),('7643','2013-06-06','14:45:00',15.38),('7643','2013-06-06','14:50:00',15.39),('7643','2013-06-06','14:55:00',15.28),('7643','2013-06-06','15:00:00',15.17),('7643','2013-06-06','15:05:00',15.14),('7643','2013-06-06','15:10:00',15.13),('7643','2013-06-06','15:15:00',14.81),('7643','2013-06-06','15:20:00',14.61),('7643','2013-06-06','15:25:00',14.73),('7643','2013-06-06','15:30:00',14.64),('7643','2013-06-06','15:35:00',14.36),('7643','2013-06-06','15:40:00',14.09),('7643','2013-06-06','15:45:00',13.83),('7643','2013-06-06','15:50:00',13.61),('7643','2013-06-06','15:55:00',13.55),('7643','2013-06-06','16:00:00',13.38),('7643','2013-06-06','16:05:00',12.95),('7643','2013-06-06','16:10:00',12.48),('7643','2013-06-06','16:15:00',12.01),('7643','2013-06-06','16:20:00',11.72),('7643','2013-06-06','16:25:00',11.81),('7643','2013-06-06','16:30:00',11.83),('7643','2013-06-06','16:35:00',11.57),('7643','2013-06-06','16:40:00',11.27),('7643','2013-06-06','16:45:00',11.01),('7643','2013-06-06','16:50:00',10.77),('7643','2013-06-06','16:55:00',10.53),('7643','2013-06-06','17:00:00',10.2),('7643','2013-06-06','17:05:00',9.83),('7643','2013-06-06','17:10:00',9.47),('7643','2013-06-06','17:15:00',9.01),('7643','2013-06-06','17:20:00',8.48),('7643','2013-06-06','17:25:00',8.33),('7643','2013-06-06','17:30:00',7.99),('7643','2013-06-06','17:35:00',7.83),('7643','2013-06-06','17:40:00',7.6),('7643','2013-06-06','17:45:00',7.45),('7643','2013-06-06','17:50:00',7.2),('7643','2013-06-06','17:55:00',6.7),('7643','2013-06-06','18:00:00',6.21),('7643','2013-06-06','18:05:00',6),('7643','2013-06-06','18:10:00',5.72),('7643','2013-06-06','18:15:00',5.3),('7643','2013-06-06','18:20:00',4.89),('7643','2013-06-06','18:25:00',4.42),('7643','2013-06-06','18:30:00',4.15),('7643','2013-06-06','18:35:00',3.84),('7643','2013-06-06','18:40:00',3.47),('7643','2013-06-06','18:45:00',3.04),('7643','2013-06-06','18:50:00',2.7),('7643','2013-06-06','18:55:00',2.47),('7643','2013-06-06','19:00:00',2.2),('7643','2013-06-06','19:05:00',1.89),('7643','2013-06-06','19:15:00',1.16),('7643','2013-06-05','06:50:00',1.19),('7643','2013-06-05','06:55:00',2.29),('7643','2013-06-05','07:00:00',3.07),('7643','2013-06-05','07:05:00',3.53),('7643','2013-06-05','07:10:00',3.33),('7643','2013-06-05','07:15:00',3.85),('7643','2013-06-05','07:20:00',2.54),('7643','2013-06-05','07:25:00',2.7),('7643','2013-06-05','07:30:00',2.4),('7643','2013-06-05','07:35:00',2.22),('7643','2013-06-05','07:40:00',2.57),('7643','2013-06-05','07:45:00',2.74),('7643','2013-06-05','07:50:00',4.09),('7643','2013-06-05','07:55:00',5.99),('7643','2013-06-05','08:00:00',6.49),('7643','2013-06-05','08:05:00',4.69),('7643','2013-06-05','08:10:00',6.46),('7643','2013-06-05','08:15:00',5.62),('7643','2013-06-05','08:20:00',6.08),('7643','2013-06-05','08:25:00',7.69),('7643','2013-06-05','08:30:00',7.98),('7643','2013-06-05','08:35:00',8.19),('7643','2013-06-05','08:40:00',8.38),('7643','2013-06-05','08:45:00',8.72),('7643','2013-06-05','08:50:00',5.94),('7643','2013-06-05','09:00:00',3.79),('7643','2013-06-05','09:05:00',10.03),('7643','2013-06-05','09:10:00',10.44),('7643','2013-06-05','09:15:00',10.74),('7643','2013-06-05','09:20:00',10.97),('7643','2013-06-05','09:25:00',11.34),('7643','2013-06-05','09:30:00',11.42),('7643','2013-06-05','09:35:00',11.71),('7643','2013-06-05','09:40:00',11.88),('7643','2013-06-05','09:45:00',11.9),('7643','2013-06-05','09:50:00',12.43),('7643','2013-06-05','09:55:00',12.71),('7643','2013-06-05','10:00:00',12.93),('7643','2013-06-05','10:05:00',12.92),('7643','2013-06-05','10:10:00',13.09),('7643','2013-06-05','10:15:00',13.47),('7643','2013-06-05','10:20:00',13.61),('7643','2013-06-05','10:25:00',13.87),('7643','2013-06-05','10:30:00',14.07),('7643','2013-06-05','10:35:00',14.09),('7643','2013-06-05','10:40:00',14.39),('7643','2013-06-05','10:45:00',14.51),('7643','2013-06-05','10:50:00',14.69),('7643','2013-06-05','10:55:00',14.82),('7643','2013-06-05','11:00:00',14.97),('7643','2013-06-05','11:05:00',14.85),('7643','2013-06-05','11:10:00',15.25),('7643','2013-06-05','11:15:00',15.29),('7643','2013-06-05','11:20:00',15.41),('7643','2013-06-05','11:25:00',15.44),('7643','2013-06-05','11:30:00',15.76),('7643','2013-06-05','11:35:00',15.83),('7643','2013-06-05','11:40:00',15.88),('7643','2013-06-05','11:45:00',16.06),('7643','2013-06-05','11:50:00',15.93),('7643','2013-06-05','11:55:00',15.68),('7643','2013-06-05','12:00:00',15.99),('7643','2013-06-05','12:05:00',7.7),('7643','2013-06-05','12:10:00',15.18),('7643','2013-06-05','12:15:00',16.4),('7643','2013-06-05','12:20:00',16.4),('7643','2013-06-05','12:25:00',16.64),('7643','2013-06-05','12:30:00',16.25),('7643','2013-06-05','12:35:00',16.48),('7643','2013-06-05','12:40:00',16.51),('7643','2013-06-05','12:45:00',15.95),('7643','2013-06-05','12:50:00',16.43),('7643','2013-06-05','12:55:00',16.86),('7643','2013-06-05','13:00:00',16.88),('7643','2013-06-05','13:05:00',16.64),('7643','2013-06-05','13:10:00',16.72),('7643','2013-06-05','13:15:00',16.82),('7643','2013-06-05','13:20:00',16.96),('7643','2013-06-05','13:25:00',16.83),('7643','2013-06-05','13:30:00',16.56),('7643','2013-06-05','13:35:00',16.73),('7643','2013-06-05','13:40:00',16.31),('7643','2013-06-05','13:45:00',5.9),('7643','2013-06-05','13:50:00',12.67),('7643','2013-06-05','13:55:00',17.15),('7643','2013-06-05','14:00:00',17.02),('7643','2013-06-05','14:05:00',16.96),('7643','2013-06-05','14:10:00',16.74),('7643','2013-06-05','14:15:00',16.87),('7643','2013-06-05','14:20:00',16.79),('7643','2013-06-05','14:25:00',9.61),('7643','2013-06-05','14:30:00',15.21),('7643','2013-06-05','14:35:00',11.1),('7643','2013-06-05','14:40:00',7.4),('7643','2013-06-05','14:45:00',12.65),('7643','2013-06-05','14:50:00',16.6),('7643','2013-06-05','14:55:00',16.53),('7643','2013-06-05','15:00:00',16.41),('7643','2013-06-05','15:05:00',16.41),('7643','2013-06-05','15:10:00',13.8),('7643','2013-06-05','15:15:00',15.62),('7643','2013-06-05','15:20:00',15.39),('7643','2013-06-05','15:25:00',8.76),('7643','2013-06-05','15:30:00',14.44),('7643','2013-06-05','15:35:00',14.01),('7643','2013-06-05','15:40:00',14.27),('7643','2013-06-05','15:45:00',14.46),('7643','2013-06-05','15:50:00',11.72),('7643','2013-06-05','15:55:00',13.12),('7643','2013-06-05','16:00:00',10.97),('7643','2013-06-05','16:05:00',13.42),('7643','2013-06-05','16:10:00',12.39),('7643','2013-06-05','16:15:00',12.03),('7643','2013-06-05','16:20:00',11.6),('7643','2013-06-05','16:25:00',11.77),('7643','2013-06-05','16:30:00',11.77),('7643','2013-06-05','16:35:00',11.54),('7643','2013-06-05','16:40:00',11.31),('7643','2013-06-05','16:45:00',10.55),('7643','2013-06-05','16:50:00',10.45),('7643','2013-06-05','16:55:00',9.96),('7643','2013-06-05','17:00:00',9.66),('7643','2013-06-05','17:05:00',9.3),('7643','2013-06-05','17:10:00',9.13),('7643','2013-06-05','17:15:00',8.79),('7643','2013-06-05','17:20:00',8.28),('7643','2013-06-05','17:25:00',8.13),('7643','2013-06-05','17:30:00',7.9),('7643','2013-06-05','17:35:00',7.56),('7643','2013-06-05','17:40:00',7.24),('7643','2013-06-05','17:45:00',6.94),('7643','2013-06-05','17:50:00',6.56),('7643','2013-06-05','17:55:00',6.17),('7643','2013-06-05','18:00:00',5.87),('7643','2013-06-05','18:05:00',5.48),('7643','2013-06-05','18:10:00',5.23),('7643','2013-06-05','18:15:00',4.93),('7643','2013-06-05','18:20:00',4.6),('7643','2013-06-05','18:25:00',4.28),('7643','2013-06-05','18:30:00',4.01),('7643','2013-06-05','18:35:00',3.77),('7643','2013-06-05','18:40:00',3.47),('7643','2013-06-05','18:45:00',3.04),('7643','2013-06-05','18:50:00',2.68),('7643','2013-06-05','18:55:00',2.47),('7643','2013-06-05','19:00:00',2.14),('7643','2013-06-05','19:05:00',1.84),('7643','2013-06-05','19:10:00',1.72),('7643','2013-06-05','19:15:00',1.47),('7643','2013-06-05','19:20:00',1.32),('7643','2013-06-05','19:25:00',1.16),('7643','2013-06-05','19:30:00',1.02),('7643','2013-06-04','06:30:00',1.06),('7643','2013-06-04','06:35:00',1.37),('7643','2013-06-04','06:40:00',1.63),('7643','2013-06-04','06:45:00',1.72),('7643','2013-06-04','06:50:00',1.85),('7643','2013-06-04','06:55:00',2.26),('7643','2013-06-04','07:00:00',2.23),('7643','2013-06-04','07:05:00',2.33),('7643','2013-06-04','07:10:00',1.64),('7643','2013-06-04','07:15:00',2.02),('7643','2013-06-04','07:20:00',2.83),('7643','2013-06-04','07:25:00',2.46),('7643','2013-06-04','07:30:00',1.96),('7643','2013-06-04','07:35:00',2.78),('7643','2013-06-04','07:40:00',2.32),('7643','2013-06-04','07:45:00',2.67),('7643','2013-06-04','07:50:00',4.92),('7643','2013-06-04','07:55:00',6.23),('7643','2013-06-04','08:00:00',6.56),('7643','2013-06-04','08:05:00',6.18),('7643','2013-06-04','08:10:00',5.58),('7643','2013-06-04','08:15:00',6.57),('7643','2013-06-04','08:20:00',6.97),('7643','2013-06-04','08:25:00',7.52),('7643','2013-06-04','08:30:00',7.91),('7643','2013-06-04','08:35:00',8.19),('7643','2013-06-04','08:40:00',8.47),('7643','2013-06-04','08:45:00',8.88),('7643','2013-06-04','08:50:00',9.24),('7643','2013-06-04','08:55:00',9.63),('7643','2013-06-04','09:00:00',9.92),('7643','2013-06-04','09:05:00',10.14),('7643','2013-06-04','09:10:00',10.86),('7643','2013-06-04','09:15:00',10.96),('7643','2013-06-04','09:20:00',12.08),('7643','2013-06-04','09:25:00',12.34),('7643','2013-06-04','09:30:00',12.9),('7643','2013-06-04','09:35:00',13.74),('7643','2013-06-04','09:40:00',14.31),('7643','2013-06-04','09:45:00',10.82),('7643','2013-06-04','09:50:00',9.64),('7643','2013-06-04','09:55:00',6.64),('7643','2013-06-04','10:00:00',12.74),('7643','2013-06-04','10:05:00',15.36),('7643','2013-06-04','10:10:00',15.14),('7643','2013-06-04','10:15:00',15.45),('7643','2013-06-04','10:20:00',6.96),('7643','2013-06-04','10:25:00',4.77),('7643','2013-06-04','10:30:00',4.71),('7643','2013-06-04','10:35:00',4.57),('7643','2013-06-04','10:40:00',8.39),('7643','2013-06-04','10:45:00',10.99),('7643','2013-06-04','10:50:00',6.84),('7643','2013-06-04','10:55:00',12.66),('7643','2013-06-04','11:00:00',15.18),('7643','2013-06-04','11:05:00',6.41),('7643','2013-06-04','11:10:00',6.5),('7643','2013-06-04','11:15:00',7.86),('7643','2013-06-04','11:20:00',4.9),('7643','2013-06-04','11:25:00',3.98),('7643','2013-06-04','11:30:00',3.96),('7643','2013-06-04','11:35:00',4.4),('7643','2013-06-04','11:40:00',5.07),('7643','2013-06-04','11:45:00',14.17),('7643','2013-06-04','11:50:00',9.16),('7643','2013-06-04','11:55:00',15.66),('7643','2013-06-04','12:00:00',18.59),('7643','2013-06-04','12:05:00',18.13),('7643','2013-06-04','12:10:00',18.09),('7643','2013-06-04','12:15:00',18.35),('7643','2013-06-04','12:20:00',18.53),('7643','2013-06-04','12:25:00',17.87),('7643','2013-06-04','12:30:00',8.85),('7643','2013-06-04','12:35:00',13.55),('7643','2013-06-04','12:40:00',15.09),('7643','2013-06-04','12:45:00',18.42),('7643','2013-06-04','12:50:00',8.07),('7643','2013-06-04','12:55:00',9.61),('7643','2013-06-04','13:00:00',14.85),('7643','2013-06-04','13:05:00',19.49),('7643','2013-06-04','13:10:00',10.87),('7643','2013-06-04','13:15:00',11.63),('7643','2013-06-04','13:20:00',9.67),('7643','2013-06-04','13:25:00',15.8),('7643','2013-06-04','13:30:00',19.88),('7643','2013-06-04','13:35:00',19.1),('7643','2013-06-04','13:40:00',18.58),('7643','2013-06-04','13:45:00',18.4),('7643','2013-06-04','13:50:00',17.8),('7643','2013-06-04','13:55:00',17.72),('7643','2013-06-04','14:00:00',17.29),('7643','2013-06-04','14:05:00',16.22),('7643','2013-06-04','14:10:00',17.09),('7643','2013-06-04','14:15:00',16.94),('7643','2013-06-04','14:20:00',16.99),('7643','2013-06-04','14:25:00',16.77),('7643','2013-06-04','14:30:00',16.67),('7643','2013-06-04','14:35:00',16.54),('7643','2013-06-04','14:40:00',16.45),('7643','2013-06-04','14:45:00',16.37),('7643','2013-06-04','14:50:00',16.38),('7643','2013-06-04','14:55:00',16.23),('7643','2013-06-04','15:00:00',15.82),('7643','2013-06-04','15:05:00',15.6),('7643','2013-06-04','15:10:00',15.45),('7643','2013-06-04','15:15:00',15.49),('7643','2013-06-04','15:20:00',15.3),('7643','2013-06-04','15:25:00',15.28),('7643','2013-06-04','15:30:00',15.26),('7643','2013-06-04','15:35:00',15.42),('7643','2013-06-04','15:40:00',15.11),('7643','2013-06-04','15:45:00',14.66),('7643','2013-06-04','15:50:00',14.26),('7643','2013-06-04','15:55:00',14.05),('7643','2013-06-04','16:00:00',13.9),('7643','2013-06-04','16:05:00',13.65),('7643','2013-06-04','16:10:00',13.27),('7643','2013-06-04','16:15:00',13.06),('7643','2013-06-04','16:20:00',12.87),('7643','2013-06-04','16:25:00',12.43),('7643','2013-06-04','16:30:00',12.29),('7643','2013-06-04','16:35:00',11.97),('7643','2013-06-04','16:40:00',11.66),('7643','2013-06-04','16:45:00',11.34),('7643','2013-06-04','16:50:00',11.03),('7643','2013-06-04','16:55:00',10.77),('7643','2013-06-04','17:00:00',10.47),('7643','2013-06-04','17:05:00',8.39),('7643','2013-06-04','17:10:00',8.73),('7643','2013-06-04','17:15:00',6.01),('7643','2013-06-04','17:20:00',6.53),('7643','2013-06-04','17:25:00',6.75),('7643','2013-06-04','17:30:00',7.68),('7643','2013-06-04','17:35:00',7.13),('7643','2013-06-04','17:40:00',6.63),('7643','2013-06-04','17:45:00',7.3),('7643','2013-06-04','17:50:00',6.95),('7643','2013-06-04','17:55:00',6.44),('7643','2013-06-04','18:00:00',5.84),('7643','2013-06-04','18:05:00',5.74),('7643','2013-06-04','18:10:00',4.12),('7643','2013-06-04','18:15:00',3.88),('7643','2013-06-04','18:20:00',3.19),('7643','2013-06-04','18:25:00',2.46),('7643','2013-06-04','18:30:00',4.37),('7643','2013-06-04','18:35:00',4.43),('7643','2013-06-04','18:40:00',3.61),('7643','2013-06-04','18:45:00',2.18),('7643','2013-06-04','18:50:00',1.96),('7643','2013-06-04','18:55:00',1.96),('7643','2013-06-04','19:00:00',2.06),('7643','2013-06-04','19:05:00',2.06),('7643','2013-06-04','19:10:00',1.86),('7643','2013-06-04','19:15:00',1.43),('7643','2013-06-03','06:55:00',1.06),('7643','2013-06-03','07:00:00',1.35),('7643','2013-06-03','07:05:00',2.54),('7643','2013-06-03','07:10:00',2.75),('7643','2013-06-03','07:15:00',3.05),('7643','2013-06-03','07:20:00',3.3),('7643','2013-06-03','07:25:00',3.53),('7643','2013-06-03','07:30:00',3.93),('7643','2013-06-03','07:35:00',4.32),('7643','2013-06-03','07:40:00',4.85),('7643','2013-06-03','07:45:00',5.62),('7643','2013-06-03','07:50:00',6.19),('7643','2013-06-03','07:55:00',6.66),('7643','2013-06-03','08:00:00',7.37),('7643','2013-06-03','08:05:00',8.02),('7643','2013-06-03','08:10:00',8.31),('7643','2013-06-03','08:15:00',8.5),('7643','2013-06-03','08:20:00',8.6),('7643','2013-06-03','08:25:00',8.83),('7643','2013-06-03','08:30:00',8.12),('7643','2013-06-03','08:35:00',9.97),('7643','2013-06-03','08:40:00',7.58),('7643','2013-06-03','08:45:00',7.72),('7643','2013-06-03','08:50:00',5.31),('7643','2013-06-03','08:55:00',5.05),('7643','2013-06-03','09:00:00',6.2),('7643','2013-06-03','09:05:00',6.67),('7643','2013-06-03','09:10:00',9.38),('7643','2013-06-03','09:15:00',12.03),('7643','2013-06-03','09:20:00',13.22),('7643','2013-06-03','09:25:00',12.5),('7643','2013-06-03','09:30:00',10.98),('7643','2013-06-03','09:35:00',9.76),('7643','2013-06-03','09:40:00',6.36),('7643','2013-06-03','09:45:00',6.78),('7643','2013-06-03','09:50:00',6.8),('7643','2013-06-03','09:55:00',6.91),('7643','2013-06-03','10:00:00',9.56),('7643','2013-06-03','10:05:00',9.65),('7643','2013-06-03','10:10:00',10.86),('7643','2013-06-03','10:15:00',8.98),('7643','2013-06-03','10:20:00',6.94),('7643','2013-06-03','10:25:00',6.81),('7643','2013-06-03','10:30:00',6.38),('7643','2013-06-03','10:35:00',6.47),('7643','2013-06-03','10:40:00',6.94),('7643','2013-06-03','10:45:00',7.97),('7643','2013-06-03','10:50:00',10.5),('7643','2013-06-03','10:55:00',13.1),('7643','2013-06-03','11:00:00',8.82),('7643','2013-06-03','11:05:00',9.03),('7643','2013-06-03','11:10:00',14.91),('7643','2013-06-03','11:15:00',12.17),('7643','2013-06-03','11:20:00',8.85),('7643','2013-06-03','11:25:00',10.37),('7643','2013-06-03','11:30:00',13.47),('7643','2013-06-03','11:35:00',12.26),('7643','2013-06-03','11:40:00',11.77),('7643','2013-06-03','11:45:00',14.97),('7643','2013-06-03','11:50:00',18.03),('7643','2013-06-03','11:55:00',12.18),('7643','2013-06-03','12:00:00',15.38),('7643','2013-06-03','12:05:00',16.05),('7643','2013-06-03','12:10:00',10.1),('7643','2013-06-03','12:15:00',11.16),('7643','2013-06-03','12:20:00',9.08),('7643','2013-06-03','12:25:00',7.82),('7643','2013-06-03','12:30:00',10.15),('7643','2013-06-03','12:35:00',15.14),('7643','2013-06-03','12:40:00',9.31),('7643','2013-06-03','12:45:00',12.16),('7643','2013-06-03','12:50:00',12.04),('7643','2013-06-03','12:55:00',7.86),('7643','2013-06-03','13:00:00',10.06),('7643','2013-06-03','13:05:00',6.13),('7643','2013-06-03','13:10:00',5.1),('7643','2013-06-03','13:15:00',5.22),('7643','2013-06-03','13:20:00',4.1),('7643','2013-06-03','13:25:00',4.51),('7643','2013-06-03','13:30:00',6.05),('7643','2013-06-03','13:35:00',8.51),('7643','2013-06-03','13:40:00',12.61),('7643','2013-06-03','13:45:00',16.15),('7643','2013-06-03','13:50:00',19.78),('7643','2013-06-03','13:55:00',18.32),('7643','2013-06-03','14:00:00',6.42),('7643','2013-06-03','14:05:00',14.38),('7643','2013-06-03','14:10:00',13.5),('7643','2013-06-03','14:15:00',15.04),('7643','2013-06-03','14:20:00',13.35),('7643','2013-06-03','14:25:00',10.18),('7643','2013-06-03','14:30:00',5.1),('7643','2013-06-03','14:35:00',5.68),('7643','2013-06-03','14:40:00',10.61),('7643','2013-06-03','14:45:00',4.82),('7643','2013-06-03','14:50:00',3.98),('7643','2013-06-03','14:55:00',13.01),('7643','2013-06-03','15:00:00',19.82),('7643','2013-06-03','15:05:00',19.12),('7643','2013-06-03','15:10:00',7.82),('7643','2013-06-03','15:15:00',4.49),('7643','2013-06-03','15:20:00',3.83),('7643','2013-06-03','15:25:00',3),('7643','2013-06-03','15:30:00',1.75),('7643','2013-06-03','17:10:00',1.08),('7643','2013-06-03','17:15:00',2.86),('7643','2013-06-03','17:20:00',3),('7643','2013-06-03','17:25:00',2.51),('7643','2013-06-03','17:30:00',1.83),('7643','2013-06-03','17:35:00',1.92),('7643','2013-06-03','17:40:00',3.81),('7643','2013-06-03','17:45:00',2.2),('7643','2013-06-03','17:50:00',2.27),('7643','2013-06-03','17:55:00',2.51),('7643','2013-06-03','18:00:00',2.74),('7643','2013-06-03','18:05:00',3.25),('7643','2013-06-03','18:10:00',3.48),('7643','2013-06-03','18:15:00',3.12),('7643','2013-06-03','18:20:00',2.78),('7643','2013-06-03','18:25:00',2.61),('7643','2013-06-03','18:30:00',2.15),('7643','2013-06-03','18:35:00',1.91),('7643','2013-06-03','18:40:00',2.29),('7643','2013-06-03','18:45:00',2.84),('7643','2013-06-03','18:50:00',2.65),('7643','2013-06-03','18:55:00',2.19),('7643','2013-06-03','19:00:00',1.95),('7643','2013-06-03','19:05:00',1.85),('7643','2013-06-03','19:10:00',1.65),('7643','2013-06-03','19:15:00',1.29),('7643','2013-06-03','19:20:00',1.22),('7643','2013-06-03','19:25:00',1.13),('7643','2013-06-03','19:30:00',1.02),('7643','2013-06-02','06:45:00',1.11),('7643','2013-06-02','06:50:00',1.27),('7643','2013-06-02','06:55:00',1.8),('7643','2013-06-02','07:00:00',2.09),('7643','2013-06-02','07:05:00',2.37),('7643','2013-06-02','07:10:00',1.97),('7643','2013-06-02','07:15:00',2.5),('7643','2013-06-02','07:20:00',2),('7643','2013-06-02','07:25:00',2.83),('7643','2013-06-02','07:30:00',1.71),('7643','2013-06-02','07:35:00',1.65),('7643','2013-06-02','07:40:00',4.23),('7643','2013-06-02','07:45:00',4.55),('7643','2013-06-02','07:50:00',5.3),('7643','2013-06-02','07:55:00',5.77),('7643','2013-06-02','08:00:00',6.09),('7643','2013-06-02','08:05:00',6.31),('7643','2013-06-02','08:10:00',6.6),('7643','2013-06-02','08:15:00',6.95),('7643','2013-06-02','08:20:00',7.25),('7643','2013-06-02','08:25:00',7.64),('7643','2013-06-02','08:30:00',7.92),('7643','2013-06-02','08:35:00',8.31),('7643','2013-06-02','08:40:00',8.58),('7643','2013-06-02','08:45:00',9.06),('7643','2013-06-02','08:50:00',9.28),('7643','2013-06-02','08:55:00',9.58),('7643','2013-06-02','09:00:00',9.82),('7643','2013-06-02','09:05:00',9.08),('7643','2013-06-02','09:10:00',10.16),('7643','2013-06-02','09:15:00',11.53),('7643','2013-06-02','09:20:00',12.41),('7643','2013-06-02','09:25:00',9.13),('7643','2013-06-02','09:30:00',8.33),('7643','2013-06-02','09:35:00',6.83),('7643','2013-06-02','09:40:00',10.41),('7643','2013-06-02','09:45:00',9.66),('7643','2013-06-02','09:50:00',13.32),('7643','2013-06-02','09:55:00',11.04),('7643','2013-06-02','10:00:00',15.35),('7643','2013-06-02','10:05:00',14.84),('7643','2013-06-02','10:10:00',11.09),('7643','2013-06-02','10:15:00',7.5),('7643','2013-06-02','10:20:00',7.52),('7643','2013-06-02','10:25:00',4.48),('7643','2013-06-02','10:30:00',4.39),('7643','2013-06-02','10:35:00',4.84),('7643','2013-06-02','10:40:00',6.09),('7643','2013-06-02','10:45:00',6.39),('7643','2013-06-02','10:50:00',6.57),('7643','2013-06-02','10:55:00',7),('7643','2013-06-02','11:00:00',9.69),('7643','2013-06-02','11:05:00',6.07),('7643','2013-06-02','11:10:00',5.08),('7643','2013-06-02','11:15:00',5.11),('7643','2013-06-02','11:20:00',6.5),('7643','2013-06-02','11:25:00',6.63),('7643','2013-06-02','11:30:00',6.08),('7643','2013-06-02','11:35:00',5.95),('7643','2013-06-02','11:40:00',10.83),('7643','2013-06-02','11:45:00',10.35),('7643','2013-06-02','11:50:00',5.81),('7643','2013-06-02','11:55:00',6.77),('7643','2013-06-02','12:00:00',8.26),('7643','2013-06-02','12:05:00',7.79),('7643','2013-06-02','12:10:00',7.28),('7643','2013-06-02','12:15:00',6.08),('7643','2013-06-02','12:20:00',5.54),('7643','2013-06-02','12:25:00',5.5),('7643','2013-06-02','12:30:00',8.19),('7643','2013-06-02','12:35:00',19.93),('7643','2013-06-02','12:40:00',13.71),('7643','2013-06-02','12:45:00',8.99),('7643','2013-06-02','12:50:00',8.35),('7643','2013-06-02','12:55:00',11.93),('7643','2013-06-02','13:00:00',7.72),('7643','2013-06-02','13:05:00',7.36),('7643','2013-06-02','13:10:00',8.11),('7643','2013-06-02','13:15:00',18.56),('7643','2013-06-02','13:20:00',19.29),('7643','2013-06-02','13:25:00',16.57),('7643','2013-06-02','13:30:00',15),('7643','2013-06-02','13:35:00',18.24),('7643','2013-06-02','13:40:00',15.59),('7643','2013-06-02','13:45:00',10.11),('7643','2013-06-02','13:50:00',14.2),('7643','2013-06-02','13:55:00',11.3),('7643','2013-06-02','14:00:00',16.48),('7643','2013-06-02','14:05:00',11.14),('7643','2013-06-02','14:10:00',9.57),('7643','2013-06-02','14:15:00',9.39),('7643','2013-06-02','14:20:00',8.48),('7643','2013-06-02','14:25:00',16.16),('7643','2013-06-02','14:30:00',18.42),('7643','2013-06-02','14:35:00',16.04),('7643','2013-06-02','14:40:00',12.82),('7643','2013-06-02','14:45:00',11.29),('7643','2013-06-02','14:50:00',9.46),('7643','2013-06-02','14:55:00',17.01),('7643','2013-06-02','15:00:00',17.66),('7643','2013-06-02','15:05:00',10.62),('7643','2013-06-02','15:10:00',16.53),('7643','2013-06-02','15:15:00',15.73),('7643','2013-06-02','15:20:00',11.79),('7643','2013-06-02','15:25:00',15.55),('7643','2013-06-02','15:30:00',15.2),('7643','2013-06-02','15:35:00',14.95),('7643','2013-06-02','15:40:00',14.74),('7643','2013-06-02','15:45:00',14.38),('7643','2013-06-02','15:50:00',14.32),('7643','2013-06-02','15:55:00',14.16),('7643','2013-06-02','16:00:00',13.92),('7643','2013-06-02','16:05:00',13.75),('7643','2013-06-02','16:10:00',13.6),('7643','2013-06-02','16:15:00',13.19),('7643','2013-06-02','16:20:00',12.48),('7643','2013-06-02','16:25:00',12.75),('7643','2013-06-02','16:30:00',12.96),('7643','2013-06-02','16:35:00',12.09),('7643','2013-06-02','16:40:00',12.16),('7643','2013-06-02','16:45:00',10.66),('7643','2013-06-02','16:50:00',8.08),('7643','2013-06-02','16:55:00',6.98),('7643','2013-06-02','17:00:00',8.25),('7643','2013-06-02','17:05:00',10.04),('7643','2013-06-02','17:10:00',8.92),('7643','2013-06-02','17:15:00',9.53),('7643','2013-06-02','17:20:00',8.54),('7643','2013-06-02','17:25:00',5.43),('7643','2013-06-02','17:30:00',3.13),('7643','2013-06-02','17:35:00',2.38),('7643','2013-06-02','17:40:00',2.38),('7643','2013-06-02','17:45:00',2.18),('7643','2013-06-02','17:50:00',2.64),('7643','2013-06-02','17:55:00',2.6),('7643','2013-06-02','18:00:00',2.19),('7643','2013-06-02','18:05:00',2),('7643','2013-06-02','18:10:00',1.81),('7643','2013-06-02','18:15:00',1.53),('7643','2013-06-02','18:20:00',1.08),('7643','2013-06-02','18:25:00',1.02),('7643','2013-06-02','18:30:00',1.23),('7643','2013-06-02','18:35:00',1.48),('7643','2013-06-02','18:40:00',1.55),('7643','2013-06-02','18:45:00',1.6),('7643','2013-06-02','18:50:00',1.57),('7643','2013-06-02','18:55:00',1.12),('7643','2013-06-01','06:40:00',1.19),('7643','2013-06-01','06:45:00',1.63),('7643','2013-06-01','06:50:00',2.45),('7643','2013-06-01','06:55:00',3.31),('7643','2013-06-01','07:00:00',3.5),('7643','2013-06-01','07:05:00',2.3),('7643','2013-06-01','07:10:00',1.72),('7643','2013-06-01','07:15:00',1.68),('7643','2013-06-01','07:20:00',1.56),('7643','2013-06-01','07:25:00',1.03),('7643','2013-06-01','07:40:00',1.15),('7643','2013-06-01','07:45:00',1.29),('7643','2013-06-01','07:50:00',1.02),('7643','2013-06-01','08:00:00',1.2),('7643','2013-06-01','08:15:00',1.18),('7643','2013-06-01','08:20:00',1.87),('7643','2013-06-01','08:25:00',2.88),('7643','2013-06-01','08:30:00',3.14),('7643','2013-06-01','08:35:00',3.38),('7643','2013-06-01','08:40:00',3.37),('7643','2013-06-01','08:45:00',3.62),('7643','2013-06-01','08:50:00',4.06),('7643','2013-06-01','08:55:00',3.6),('7643','2013-06-01','09:00:00',3.53),('7643','2013-06-01','09:05:00',3.78),('7643','2013-06-01','09:10:00',4.28),('7643','2013-06-01','09:15:00',4.5),('7643','2013-06-01','09:20:00',8.43),('7643','2013-06-01','09:25:00',13.32),('7643','2013-06-01','09:30:00',12.85),('7643','2013-06-01','09:35:00',12.71),('7643','2013-06-01','09:40:00',12.63),('7643','2013-06-01','09:45:00',12.72),('7643','2013-06-01','09:50:00',13.01),('7643','2013-06-01','09:55:00',13.14),('7643','2013-06-01','10:00:00',13.36),('7643','2013-06-01','10:05:00',13.31),('7643','2013-06-01','10:10:00',13.76),('7643','2013-06-01','10:15:00',13.99),('7643','2013-06-01','10:20:00',14.14),('7643','2013-06-01','10:25:00',14.24),('7643','2013-06-01','10:30:00',15.14),('7643','2013-06-01','10:35:00',16.15),('7643','2013-06-01','10:40:00',16.31),('7643','2013-06-01','10:45:00',15.5),('7643','2013-06-01','10:50:00',9.11),('7643','2013-06-01','10:55:00',11.87),('7643','2013-06-01','11:00:00',16.46),('7643','2013-06-01','11:05:00',14.03),('7643','2013-06-01','11:10:00',17.61),('7643','2013-06-01','11:15:00',12.67),('7643','2013-06-01','11:20:00',16.23),('7643','2013-06-01','11:25:00',15.8),('7643','2013-06-01','11:30:00',11.47),('7643','2013-06-01','11:35:00',6.21),('7643','2013-06-01','11:40:00',6.97),('7643','2013-06-01','11:45:00',5.35),('7643','2013-06-01','11:50:00',8.26),('7643','2013-06-01','11:55:00',10.01),('7643','2013-06-01','12:00:00',15.05),('7643','2013-06-01','12:05:00',8.34),('7643','2013-06-01','12:10:00',8.13),('7643','2013-06-01','12:15:00',17.29),('7643','2013-06-01','12:20:00',7.38),('7643','2013-06-01','12:25:00',6.37),('7643','2013-06-01','12:30:00',10.03),('7643','2013-06-01','12:35:00',8.6),('7643','2013-06-01','12:40:00',15.81),('7643','2013-06-01','12:45:00',19.01),('7643','2013-06-01','12:50:00',6.81),('7643','2013-06-01','12:55:00',16.76),('7643','2013-06-01','13:00:00',7.97),('7643','2013-06-01','13:05:00',5.59),('7643','2013-06-01','13:10:00',8.65),('7643','2013-06-01','13:15:00',19.43),('7643','2013-06-01','13:20:00',18.31),('7643','2013-06-01','13:25:00',17.81),('7643','2013-06-01','13:30:00',17.48),('7643','2013-06-01','13:35:00',17.55),('7643','2013-06-01','13:40:00',17.38),('7643','2013-06-01','13:45:00',17.26),('7643','2013-06-01','13:50:00',17.24),('7643','2013-06-01','13:55:00',17.15),('7643','2013-06-01','14:00:00',16.98),('7643','2013-06-01','14:05:00',16.92),('7643','2013-06-01','14:10:00',16.36),('7643','2013-06-01','14:15:00',16.81),('7643','2013-06-01','14:20:00',16.95),('7643','2013-06-01','14:25:00',16.89),('7643','2013-06-01','14:30:00',16.69),('7643','2013-06-01','14:35:00',16.47),('7643','2013-06-01','14:40:00',16.32),('7643','2013-06-01','14:45:00',16.18),('7643','2013-06-01','14:50:00',16.12),('7643','2013-06-01','14:55:00',15.96),('7643','2013-06-01','15:00:00',15.94),('7643','2013-06-01','15:05:00',15.73),('7643','2013-06-01','15:10:00',15.43),('7643','2013-06-01','15:15:00',15.49),('7643','2013-06-01','15:20:00',15.43),('7643','2013-06-01','15:25:00',14.62),('7643','2013-06-01','15:30:00',13.97),('7643','2013-06-01','15:35:00',11.72),('7643','2013-06-01','15:40:00',15.47),('7643','2013-06-01','15:45:00',14.66),('7643','2013-06-01','15:50:00',14.42),('7643','2013-06-01','15:55:00',11.06),('7643','2013-06-01','16:00:00',14.46),('7643','2013-06-01','16:05:00',13.53),('7643','2013-06-01','16:10:00',11.82),('7643','2013-06-01','16:15:00',8.41),('7643','2013-06-01','16:20:00',12.46),('7643','2013-06-01','16:25:00',12.63),('7643','2013-06-01','16:30:00',12.26),('7643','2013-06-01','16:35:00',11.76),('7643','2013-06-01','16:40:00',11.78),('7643','2013-06-01','16:45:00',11.27),('7643','2013-06-01','16:50:00',11.63),('7643','2013-06-01','16:55:00',11.1),('7643','2013-06-01','17:00:00',10.73),('7643','2013-06-01','17:05:00',10.33),('7643','2013-06-01','17:10:00',9.7),('7643','2013-06-01','17:15:00',9.38),('7643','2013-06-01','17:20:00',8.82),('7643','2013-06-01','17:25:00',8.78),('7643','2013-06-01','17:30:00',4.41),('7643','2013-06-01','17:35:00',7.84),('7643','2013-06-01','17:40:00',5.09),('7643','2013-06-01','17:45:00',6.01),('7643','2013-06-01','17:50:00',5.34),('7643','2013-06-01','17:55:00',3.8),('7643','2013-06-01','18:00:00',5.93),('7643','2013-06-01','18:05:00',2.67),('7643','2013-06-01','18:10:00',3.13),('7643','2013-06-01','18:15:00',2.65),('7643','2013-06-01','18:20:00',2.51),('7643','2013-06-01','18:25:00',2.41),('7643','2013-06-01','18:30:00',2.61),('7643','2013-06-01','18:35:00',2.39),('7643','2013-06-01','18:40:00',2.09),('7643','2013-06-01','18:45:00',2.09),('7643','2013-06-01','18:50:00',2.09),('7643','2013-06-01','18:55:00',1.53),('7643','2013-06-01','19:00:00',1.49),('7643','2013-06-01','19:05:00',1.22),('7643','2013-06-01','19:10:00',1.1),('7643','2013-06-01','19:15:00',1.11),('7643','2013-06-01','19:20:00',1.37),('7643','2013-06-01','19:25:00',1.05),('7643','2013-05-31','06:40:00',1.03),('7643','2013-05-31','06:45:00',1.22),('7643','2013-05-31','06:50:00',1.46),('7643','2013-05-31','06:55:00',1.74),('7643','2013-05-31','07:00:00',1.97),('7643','2013-05-31','07:05:00',2.31),('7643','2013-05-31','07:10:00',2.54),('7643','2013-05-31','07:15:00',2.87),('7643','2013-05-31','07:20:00',3.28),('7643','2013-05-31','07:25:00',3.62),('7643','2013-05-31','07:30:00',4.05),('7643','2013-05-31','07:35:00',4.43),('7643','2013-05-31','07:40:00',4.91),('7643','2013-05-31','07:45:00',5.86),('7643','2013-05-31','07:50:00',4.1),('7643','2013-05-31','07:55:00',4.39),('7643','2013-05-31','08:00:00',2.62),('7643','2013-05-31','08:05:00',2.25),('7643','2013-05-31','08:10:00',2.88),('7643','2013-05-31','08:15:00',6.3),('7643','2013-05-31','08:20:00',6.09),('7643','2013-05-31','08:25:00',3.42),('7643','2013-05-31','08:30:00',4.6),('7643','2013-05-31','08:35:00',5.25),('7643','2013-05-31','08:40:00',3.19),('7643','2013-05-31','08:45:00',2.16),('7643','2013-05-31','08:50:00',2.47),('7643','2013-05-31','08:55:00',2.54),('7643','2013-05-31','09:00:00',2.75),('7643','2013-05-31','09:05:00',2.11),('7643','2013-05-31','09:10:00',1.51),('7643','2013-05-31','09:15:00',1.69),('7643','2013-05-31','09:20:00',1.64),('7643','2013-05-31','09:25:00',1.78),('7643','2013-05-31','09:30:00',1.85),('7643','2013-05-31','09:35:00',1.71),('7643','2013-05-31','09:40:00',2.18),('7643','2013-05-31','09:45:00',3.18),('7643','2013-05-31','09:50:00',3.68),('7643','2013-05-31','09:55:00',2.77),('7643','2013-05-31','10:00:00',2.6),('7643','2013-05-31','10:05:00',2.9),('7643','2013-05-31','10:10:00',2.77),('7643','2013-05-31','10:15:00',2.36),('7643','2013-05-31','10:20:00',1.97),('7643','2013-05-31','10:25:00',1.35),('7643','2013-05-31','10:30:00',2.3),('7643','2013-05-31','10:35:00',4.16),('7643','2013-05-31','10:40:00',4.15),('7643','2013-05-31','10:45:00',2.75),('7643','2013-05-31','10:50:00',5.21),('7643','2013-05-31','10:55:00',9.28),('7643','2013-05-31','11:00:00',2.45),('7643','2013-05-31','11:05:00',1.58),('7643','2013-05-31','11:10:00',1.2),('7643','2013-05-31','11:15:00',1.52),('7643','2013-05-31','11:20:00',1.27),('7643','2013-05-31','11:25:00',1.53),('7643','2013-05-31','11:30:00',2.03),('7643','2013-05-31','11:35:00',1.87),('7643','2013-05-31','11:40:00',1.78),('7643','2013-05-31','11:45:00',2.62),('7643','2013-05-31','11:50:00',5.44),('7643','2013-05-31','11:55:00',6.87),('7643','2013-05-31','12:00:00',12.42),('7643','2013-05-31','12:05:00',12.7),('7643','2013-05-31','12:10:00',13.28),('7643','2013-05-31','12:15:00',6.2),('7643','2013-05-31','12:20:00',4.59),('7643','2013-05-31','12:25:00',4.69),('7643','2013-05-31','12:30:00',4.49),('7643','2013-05-31','12:35:00',3.49),('7643','2013-05-31','12:40:00',4.11),('7643','2013-05-31','12:45:00',6.5),('7643','2013-05-31','12:50:00',6.89),('7643','2013-05-31','12:55:00',6.97),('7643','2013-05-31','13:00:00',8.79),('7643','2013-05-31','13:05:00',9.25),('7643','2013-05-31','13:10:00',9.56),('7643','2013-05-31','13:15:00',10.38),('7643','2013-05-31','13:20:00',8.9),('7643','2013-05-31','13:25:00',6.79),('7643','2013-05-31','13:30:00',5.89),('7643','2013-05-31','13:35:00',4.67),('7643','2013-05-31','13:40:00',4.25),('7643','2013-05-31','13:45:00',4.92),('7643','2013-05-31','13:50:00',5.28),('7643','2013-05-31','13:55:00',5.94),('7643','2013-05-31','14:00:00',7.63),('7643','2013-05-31','14:05:00',9.43),('7643','2013-05-31','14:10:00',9.18),('7643','2013-05-31','14:15:00',9.74),('7643','2013-05-31','14:20:00',9.46),('7643','2013-05-31','14:25:00',6.13),('7643','2013-05-31','14:30:00',5.04),('7643','2013-05-31','14:35:00',5.18),('7643','2013-05-31','14:40:00',5.01),('7643','2013-05-31','14:45:00',4.91),('7643','2013-05-31','14:50:00',4.4),('7643','2013-05-31','14:55:00',3.38),('7643','2013-05-31','15:00:00',3.25),('7643','2013-05-31','15:05:00',3.23),('7643','2013-05-31','15:10:00',2.44),('7643','2013-05-31','15:15:00',2.31),('7643','2013-05-31','15:20:00',1.96),('7643','2013-05-31','15:25:00',1.47),('7643','2013-05-31','15:40:00',1.21),('7643','2013-05-31','15:45:00',1.75),('7643','2013-05-31','15:50:00',1.72),('7643','2013-05-31','15:55:00',1.69),('7643','2013-05-31','16:00:00',1.84),('7643','2013-05-31','16:05:00',2.17),('7643','2013-05-31','16:10:00',2.08),('7643','2013-05-31','16:15:00',2.32),('7643','2013-05-31','16:20:00',2.66),('7643','2013-05-31','16:25:00',2.08),('7643','2013-05-31','16:30:00',2.36),('7643','2013-05-31','16:35:00',2.66),('7643','2013-05-31','16:40:00',3.07),('7643','2013-05-31','16:45:00',2.65),('7643','2013-05-31','16:50:00',2.58),('7643','2013-05-31','16:55:00',2.57),('7643','2013-05-31','17:00:00',1.46),('7643','2013-05-31','18:25:00',1.69),('7643','2013-05-31','18:30:00',3.25),('7643','2013-05-31','18:35:00',3.94),('7643','2013-05-31','18:40:00',2.9),('7643','2013-05-31','18:45:00',2.17),('7643','2013-05-31','18:50:00',1.99),('7643','2013-05-31','18:55:00',2.27),('7643','2013-05-31','19:00:00',3.8),('7643','2013-05-31','19:05:00',3.4),('7643','2013-05-31','19:10:00',1.95),('7643','2014-04-01','07:35:00',1.15),('7643','2014-04-01','07:40:00',1.65),('7643','2014-04-01','07:45:00',1.66),('7643','2014-04-01','07:50:00',1.44),('7643','2014-04-01','07:55:00',2.02),('7643','2014-04-01','08:00:00',3.58),('7643','2014-04-01','08:05:00',3.91),('7643','2014-04-01','08:10:00',3.12),('7643','2014-04-01','08:15:00',2.59),('7643','2014-04-01','08:20:00',4.36),('7643','2014-04-01','08:25:00',2.97),('7643','2014-04-01','08:30:00',1.7),('7643','2014-04-01','08:35:00',2.35),('7643','2014-04-01','08:40:00',2.8),('7643','2014-04-01','08:45:00',3.03),('7643','2014-04-01','08:50:00',3.67),('7643','2014-04-01','08:55:00',8),('7643','2014-04-01','09:00:00',4.43),('7643','2014-04-01','09:05:00',4.43),('7643','2014-04-01','09:10:00',3.74),('7643','2014-04-01','09:15:00',3.99),('7643','2014-04-01','09:20:00',3.68),('7643','2014-04-01','09:25:00',3.26),('7643','2014-04-01','09:30:00',2.63),('7643','2014-04-01','09:35:00',3.15),('7643','2014-04-01','09:40:00',3.54),('7643','2014-04-01','09:45:00',2.87),('7643','2014-04-01','09:50:00',2.4),('7643','2014-04-01','09:55:00',2.82),('7643','2014-04-01','10:00:00',7.94),('7643','2014-04-01','10:05:00',8.81),('7643','2014-04-01','10:10:00',9.86),('7643','2014-04-01','10:15:00',9.98),('7643','2014-04-01','10:20:00',13.42),('7643','2014-04-01','10:25:00',13.38),('7643','2014-04-01','10:30:00',13.51),('7643','2014-04-01','10:35:00',4.05),('7643','2014-04-01','10:40:00',3.23),('7643','2014-04-01','10:45:00',3.22),('7643','2014-04-01','10:50:00',3.64),('7643','2014-04-01','10:55:00',13.4),('7643','2014-04-01','11:00:00',14.99),('7643','2014-04-01','11:05:00',12.48),('7643','2014-04-01','11:10:00',10.08),('7643','2014-04-01','11:15:00',5.1),('7643','2014-04-01','11:20:00',14.79),('7643','2014-04-01','11:25:00',16.14),('7643','2014-04-01','11:30:00',16.79),('7643','2014-04-01','11:35:00',15.31),('7643','2014-04-01','11:40:00',6.29),('7643','2014-04-01','11:45:00',4.47),('7643','2014-04-01','11:50:00',8.22),('7643','2014-04-01','11:55:00',10.25),('7643','2014-04-01','12:00:00',8.59),('7643','2014-04-01','12:05:00',18.75),('7643','2014-04-01','12:10:00',5.48),('7643','2014-04-01','12:15:00',4.59),('7643','2014-04-01','12:20:00',10.46),('7643','2014-04-01','12:25:00',10.28),('7643','2014-04-01','12:30:00',4.37),('7643','2014-04-01','12:35:00',15.19),('7643','2014-04-01','12:40:00',15.63),('7643','2014-04-01','12:45:00',18.08),('7643','2014-04-01','12:50:00',15.12),('7643','2014-04-01','12:55:00',10.32),('7643','2014-04-01','13:00:00',9.03),('7643','2014-04-01','13:05:00',8.47),('7643','2014-04-01','13:10:00',16.84),('7643','2014-04-01','13:15:00',18.43),('7643','2014-04-01','13:20:00',15.91),('7643','2014-04-01','13:25:00',17.63),('7643','2014-04-01','13:30:00',16.01),('7643','2014-04-01','13:35:00',17.39),('7643','2014-04-01','13:40:00',17.79),('7643','2014-04-01','13:45:00',17),('7643','2014-04-01','13:50:00',16.54),('7643','2014-04-01','13:55:00',16.51),('7643','2014-04-01','14:00:00',16.48),('7643','2014-04-01','14:05:00',16.07),('7643','2014-04-01','14:10:00',13.91),('7643','2014-04-01','14:15:00',16.26),('7643','2014-04-01','14:20:00',16),('7643','2014-04-01','14:25:00',15.86),('7643','2014-04-01','14:30:00',15.9),('7643','2014-04-01','14:35:00',15.65),('7643','2014-04-01','14:40:00',13.52),('7643','2014-04-01','14:45:00',15.67),('7643','2014-04-01','14:50:00',15.05),('7643','2014-04-01','14:55:00',13.95),('7643','2014-04-01','15:00:00',14.38),('7643','2014-04-01','15:05:00',13.23),('7643','2014-04-01','15:10:00',13.49),('7643','2014-04-01','15:15:00',13.62),('7643','2014-04-01','15:20:00',13.68),('7643','2014-04-01','15:25:00',13.47),('7643','2014-04-01','15:30:00',12.72),('7643','2014-04-01','15:35:00',12.33),('7643','2014-04-01','15:40:00',12.73),('7643','2014-04-01','15:45:00',13.02),('7643','2014-04-01','15:50:00',12.89),('7643','2014-04-01','15:55:00',11.32),('7643','2014-04-01','16:00:00',11.71),('7643','2014-04-01','16:05:00',11.69),('7643','2014-04-01','16:10:00',11.47),('7643','2014-04-01','16:15:00',11.1),('7643','2014-04-01','16:20:00',10.71),('7643','2014-04-01','16:25:00',10.53),('7643','2014-04-01','16:30:00',10.47),('7643','2014-04-01','16:35:00',10.13),('7643','2014-04-01','16:40:00',9.8),('7643','2014-04-01','16:45:00',9.46),('7643','2014-04-01','16:50:00',8.66),('7643','2014-04-01','16:55:00',8.52),('7643','2014-04-01','17:00:00',8.75),('7643','2014-04-01','17:05:00',7.85),('7643','2014-04-01','17:10:00',7.48),('7643','2014-04-01','17:15:00',6.66),('7643','2014-04-01','17:20:00',6.62),('7643','2014-04-01','17:25:00',6.3),('7643','2014-04-01','17:30:00',5.67),('7643','2014-04-01','17:35:00',5.49),('7643','2014-04-01','17:40:00',4.17),('7643','2014-04-01','17:45:00',4.05),('7643','2014-04-01','17:50:00',4.94),('7643','2014-04-01','17:55:00',4.24),('7643','2014-04-01','18:00:00',3.88),('7643','2014-04-01','18:05:00',2.53),('7643','2014-04-01','18:10:00',2.18),('7643','2014-04-01','18:15:00',2.06),('7643','2014-04-01','18:20:00',2.18),('7643','2014-04-01','18:25:00',1.93),('7643','2014-04-01','18:30:00',1.49),('7643','2014-04-01','18:35:00',1.13),('7643','2013-05-30','06:40:00',1.09),('7643','2013-05-30','06:45:00',1.26),('7643','2013-05-30','06:50:00',1.53),('7643','2013-05-30','06:55:00',1.8),('7643','2013-05-30','07:00:00',2.06),('7643','2013-05-30','07:05:00',2.38),('7643','2013-05-30','07:10:00',2.61),('7643','2013-05-30','07:15:00',2.91),('7643','2013-05-30','07:20:00',3.31),('7643','2013-05-30','07:25:00',3.69),('7643','2013-05-30','07:30:00',4.09),('7643','2013-05-30','07:35:00',4.39),('7643','2013-05-30','07:40:00',4.89),('7643','2013-05-30','07:45:00',5.24),('7643','2013-05-30','07:50:00',5.6),('7643','2013-05-30','07:55:00',6.05),('7643','2013-05-30','08:00:00',6.49),('7643','2013-05-30','08:05:00',6.72),('7643','2013-05-30','08:10:00',7.04),('7643','2013-05-30','08:15:00',7.28),('7643','2013-05-30','08:20:00',7.62),('7643','2013-05-30','08:25:00',8.05),('7643','2013-05-30','08:30:00',8.59),('7643','2013-05-30','08:35:00',8.92),('7643','2013-05-30','08:40:00',9.01),('7643','2013-05-30','08:45:00',3.65),('7643','2013-05-30','08:50:00',11.41),('7643','2013-05-30','08:55:00',6.1),('7643','2013-05-30','09:00:00',3.61),('7643','2013-05-30','09:05:00',2.94),('7643','2013-05-30','09:10:00',4.11),('7643','2013-05-30','09:15:00',3.33),('7643','2013-05-30','09:20:00',2.95),('7643','2013-05-30','09:25:00',3.42),('7643','2013-05-30','09:30:00',8.63),('7643','2013-05-30','09:35:00',14.98),('7643','2013-05-30','09:40:00',8.2),('7643','2013-05-30','09:45:00',12.7),('7643','2013-05-30','09:50:00',14.4),('7643','2013-05-30','09:55:00',14.59),('7643','2013-05-30','10:00:00',15.14),('7643','2013-05-30','10:05:00',10.48),('7643','2013-05-30','10:10:00',7.81),('7643','2013-05-30','10:15:00',13.07),('7643','2013-05-30','10:20:00',12.38),('7643','2013-05-30','10:25:00',5.58),('7643','2013-05-30','10:30:00',9.05),('7643','2013-05-30','10:35:00',10.82),('7643','2013-05-30','10:40:00',14.01),('7643','2013-05-30','10:45:00',15.53),('7643','2013-05-30','10:50:00',11.8),('7643','2013-05-30','10:55:00',16.28),('7643','2013-05-30','11:00:00',6.08),('7643','2013-05-30','11:05:00',5.91),('7643','2013-05-30','11:10:00',19.86),('7643','2013-05-30','11:15:00',17.11),('7643','2013-05-30','11:20:00',5.4),('7643','2013-05-30','11:25:00',7.19),('7643','2013-05-30','11:30:00',12.36),('7643','2013-05-30','11:35:00',9.89),('7643','2013-05-30','11:40:00',4.39),('7643','2013-05-30','11:45:00',12.26),('7643','2013-05-30','11:50:00',16.35),('7643','2013-05-30','11:55:00',9.93),('7643','2013-05-30','12:00:00',8.74),('7643','2013-05-30','12:05:00',17),('7643','2013-05-30','12:10:00',16.34),('7643','2013-05-30','12:15:00',6.19),('7643','2013-05-30','12:20:00',5.66),('7643','2013-05-30','12:25:00',13.31),('7643','2013-05-30','12:30:00',6.46),('7643','2013-05-30','12:35:00',5.76),('7643','2013-05-30','12:40:00',13.52),('7643','2013-05-30','12:45:00',9.72),('7643','2013-05-30','12:50:00',3.19),('7643','2013-05-30','12:55:00',4.75),('7643','2013-05-30','13:00:00',13),('7643','2013-05-30','13:05:00',8.55),('7643','2013-05-30','13:10:00',2.66),('7643','2013-05-30','13:15:00',2.34),('7643','2013-05-30','13:20:00',3.81),('7643','2013-05-30','13:25:00',6.42),('7643','2013-05-30','13:30:00',14.77),('7643','2013-05-30','13:35:00',19.07),('7643','2013-05-30','13:40:00',7.87),('7643','2013-05-30','13:45:00',4.85),('7643','2013-05-30','13:50:00',2.59),('7643','2013-05-30','13:55:00',3.29),('7643','2013-05-30','14:00:00',7.22),('7643','2013-05-30','14:05:00',3.07),('7643','2013-05-30','14:10:00',2.41),('7643','2013-05-30','14:15:00',1.39),('7643','2013-05-30','14:20:00',2.39),('7643','2013-05-30','14:25:00',2.83),('7643','2013-05-30','14:30:00',1.19),('7643','2013-05-30','14:45:00',2.17),('7643','2013-05-30','14:50:00',2.98),('7643','2013-05-30','14:55:00',2.42),('7643','2013-05-30','15:00:00',2.9),('7643','2013-05-30','15:05:00',5.57),('7643','2013-05-30','15:10:00',6.35),('7643','2013-05-30','15:15:00',9.06),('7643','2013-05-30','15:20:00',18.54),('7643','2013-05-30','15:25:00',13.52),('7643','2013-05-30','15:30:00',11),('7643','2013-05-30','15:35:00',8.01),('7643','2013-05-30','15:40:00',6.77),('7643','2013-05-30','15:45:00',6),('7643','2013-05-30','15:50:00',8.6),('7643','2013-05-30','15:55:00',8.2),('7643','2013-05-30','16:00:00',6.08),('7643','2013-05-30','16:05:00',5),('7643','2013-05-30','16:10:00',3.92),('7643','2013-05-30','16:15:00',3.46),('7643','2013-05-30','16:20:00',3.91),('7643','2013-05-30','16:25:00',5.09),('7643','2013-05-30','16:30:00',4.84),('7643','2013-05-30','16:35:00',4.07),('7643','2013-05-30','16:40:00',4.52),('7643','2013-05-30','16:45:00',4.67),('7643','2013-05-30','16:50:00',3.26),('7643','2013-05-30','16:55:00',2.45),('7643','2013-05-30','17:00:00',2.27),('7643','2013-05-30','17:05:00',2.29),('7643','2013-05-30','17:10:00',2.18),('7643','2013-05-30','17:15:00',2.29),('7643','2013-05-30','17:20:00',2.6),('7643','2013-05-30','17:25:00',2.84),('7643','2013-05-30','17:30:00',2.8),('7643','2013-05-30','17:35:00',2.34),('7643','2013-05-30','17:40:00',2.01),('7643','2013-05-30','17:45:00',2.15),('7643','2013-05-30','17:50:00',2),('7643','2013-05-30','17:55:00',1.73),('7643','2013-05-30','18:00:00',1.62),('7643','2013-05-30','18:05:00',1.88),('7643','2013-05-30','18:10:00',1.9),('7643','2013-05-30','18:15:00',1.72),('7643','2013-05-30','18:20:00',1.36),('7643','2013-05-30','18:25:00',1.02),('7643','2013-05-30','18:30:00',1.48),('7643','2013-05-30','18:35:00',1.91),('7643','2013-05-30','19:00:00',1.62),('7643','2013-05-30','19:05:00',1.63),('7643','2013-05-30','19:10:00',1.7),('7643','2013-05-30','19:15:00',1.11),('7643','2013-05-30','19:25:00',1.45),('7643','2013-05-30','19:30:00',1.46),('7643','2013-05-30','19:35:00',1.16),('7643','2013-05-30','19:40:00',1.16),('7643','2013-05-30','19:45:00',1.08),('7643','2013-05-29','07:30:00',1.22),('7643','2013-05-29','07:35:00',1.65),('7643','2013-05-29','07:40:00',2.28),('7643','2013-05-29','07:45:00',2.9),('7643','2013-05-29','07:50:00',4.02),('7643','2013-05-29','07:55:00',3.33),('7643','2013-05-29','08:00:00',2.54),('7643','2013-05-29','08:05:00',1.78),('7643','2013-05-29','08:10:00',2.24),('7643','2013-05-29','08:15:00',2.65),('7643','2013-05-29','08:20:00',3.13),('7643','2013-05-29','08:25:00',6.05),('7643','2013-05-29','08:30:00',4.25),('7643','2013-05-29','08:35:00',3.03),('7643','2013-05-29','08:40:00',9.69),('7643','2013-05-29','08:45:00',9.76),('7643','2013-05-29','08:50:00',9.99),('7643','2013-05-29','08:55:00',10.24),('7643','2013-05-29','09:00:00',10.46),('7643','2013-05-29','09:05:00',10.61),('7643','2013-05-29','09:10:00',11.1),('7643','2013-05-29','09:15:00',11.56),('7643','2013-05-29','09:20:00',11.86),('7643','2013-05-29','09:25:00',11.92),('7643','2013-05-29','09:30:00',12.38),('7643','2013-05-29','09:35:00',12.25),('7643','2013-05-29','09:40:00',13.2),('7643','2013-05-29','09:45:00',13.36),('7643','2013-05-29','09:50:00',12.48),('7643','2013-05-29','09:55:00',8.83),('7643','2013-05-29','10:00:00',6.01),('7643','2013-05-29','10:05:00',4.9),('7643','2013-05-29','10:10:00',9.24),('7643','2013-05-29','10:15:00',8.01),('7643','2013-05-29','10:20:00',16.89),('7643','2013-05-29','10:25:00',4.95),('7643','2013-05-29','10:30:00',5.83),('7643','2013-05-29','10:35:00',6.43),('7643','2013-05-29','10:40:00',12.66),('7643','2013-05-29','10:45:00',11.71),('7643','2013-05-29','10:50:00',16.2),('7643','2013-05-29','10:55:00',13.26),('7643','2013-05-29','11:00:00',18.03),('7643','2013-05-29','11:05:00',19.06),('7643','2013-05-29','11:10:00',7.99),('7643','2013-05-29','11:15:00',7.48),('7643','2013-05-29','11:20:00',14.55),('7643','2013-05-29','11:25:00',7.94),('7643','2013-05-29','11:30:00',15.07),('7643','2013-05-29','11:35:00',18.31),('7643','2013-05-29','11:40:00',19.23),('7643','2013-05-29','11:45:00',14.94),('7643','2013-05-29','11:50:00',15.18),('7643','2013-05-29','11:55:00',6.02),('7643','2013-05-29','12:00:00',16.26),('7643','2013-05-29','12:05:00',19.04),('7643','2013-05-29','12:10:00',9.23),('7643','2013-05-29','12:15:00',15.89),('7643','2013-05-29','12:20:00',13.22),('7643','2013-05-29','12:25:00',16.22),('7643','2013-05-29','12:30:00',15.06),('7643','2013-05-29','12:35:00',11.69),('7643','2013-05-29','12:40:00',17.99),('7643','2013-05-29','12:45:00',9.39),('7643','2013-05-29','12:50:00',18.77),('7643','2013-05-29','12:55:00',18.29),('7643','2013-05-29','13:00:00',14.98),('7643','2013-05-29','13:05:00',14.99),('7643','2013-05-29','13:10:00',8.46),('7643','2013-05-29','13:15:00',10.84),('7643','2013-05-29','13:20:00',6.83),('7643','2013-05-29','13:25:00',7.7),('7643','2013-05-29','13:30:00',8.94),('7643','2013-05-29','13:35:00',6.44),('7643','2013-05-29','13:40:00',17.72),('7643','2013-05-29','13:45:00',14.68),('7643','2013-05-29','13:50:00',6.02),('7643','2013-05-29','13:55:00',8.19),('7643','2013-05-29','14:00:00',11.79),('7643','2013-05-29','14:05:00',19.5),('7643','2013-05-29','14:10:00',16.76),('7643','2013-05-29','14:15:00',19.19),('7643','2013-05-29','14:20:00',12.27),('7643','2013-05-29','14:25:00',16.31),('7643','2013-05-29','14:30:00',16.8),('7643','2013-05-29','14:35:00',17.63),('7643','2013-05-29','14:40:00',18.16),('7643','2013-05-29','14:45:00',18.15),('7643','2013-05-29','14:50:00',18.14),('7643','2013-05-29','14:55:00',17.55),('7643','2013-05-29','15:00:00',16.57),('7643','2013-05-29','15:05:00',16.2),('7643','2013-05-29','15:10:00',5.86),('7643','2013-05-29','15:15:00',15.6),('7643','2013-05-29','15:20:00',17.45),('7643','2013-05-29','15:25:00',16.98),('7643','2013-05-29','15:30:00',14.86),('7643','2013-05-29','15:35:00',13.66),('7643','2013-05-29','15:40:00',17.84),('7643','2013-05-29','15:45:00',16.99),('7643','2013-05-29','15:50:00',8.49),('7643','2013-05-29','15:55:00',11.83),('7643','2013-05-29','16:00:00',17.83),('7643','2013-05-29','16:05:00',15.61),('7643','2013-05-29','16:10:00',15.44),('7643','2013-05-29','16:15:00',14.45),('7643','2013-05-29','16:20:00',13.28),('7643','2013-05-29','16:25:00',9.67),('7643','2013-05-29','16:30:00',10.38),('7643','2013-05-29','16:35:00',8.3),('7643','2013-05-29','16:40:00',5.51),('7643','2013-05-29','16:45:00',9.81),('7643','2013-05-29','16:50:00',10.24),('7643','2013-05-29','16:55:00',9.85),('7643','2013-05-29','17:00:00',7.29),('7643','2013-05-29','17:05:00',7.28),('7643','2013-05-29','17:10:00',3.11),('7643','2013-05-29','17:15:00',4.14),('7643','2013-05-29','17:20:00',4.91),('7643','2013-05-29','17:25:00',4.35),('7643','2013-05-29','17:30:00',4.44),('7643','2013-05-29','17:35:00',2.52),('7643','2013-05-29','17:40:00',1.99),('7643','2013-05-29','17:45:00',1.73),('7643','2013-05-29','17:50:00',1.26),('7643','2013-05-29','17:55:00',1.97),('7643','2013-05-29','18:00:00',3.28),('7643','2013-05-29','18:05:00',3.58),('7643','2013-05-29','18:10:00',3.55),('7643','2013-05-29','18:15:00',2.85),('7643','2013-05-29','18:20:00',2.43),('7643','2013-05-29','18:25:00',2.7),('7643','2013-05-29','18:30:00',3.07),('7643','2013-05-29','18:35:00',4.5),('7643','2013-05-29','18:40:00',4.58),('7643','2013-05-29','18:45:00',4.79),('7643','2013-05-29','18:50:00',4.87),('7643','2013-05-29','18:55:00',2.43),('7643','2013-05-29','19:00:00',2.15),('7643','2013-05-29','19:05:00',1.96),('7643','2013-05-29','19:40:00',1),('7643','2013-05-28','06:40:00',1.01),('7643','2013-05-28','06:45:00',1.17),('7643','2013-05-28','06:50:00',1.35),('7643','2013-05-28','06:55:00',1.56),('7643','2013-05-28','07:00:00',1.87),('7643','2013-05-28','07:05:00',2.19),('7643','2013-05-28','07:10:00',2.48),('7643','2013-05-28','07:15:00',2.89),('7643','2013-05-28','07:20:00',3.22),('7643','2013-05-28','07:25:00',3.56),('7643','2013-05-28','07:30:00',3.91),('7643','2013-05-28','07:35:00',4.34),('7643','2013-05-28','07:40:00',4.68),('7643','2013-05-28','07:45:00',5.03),('7643','2013-05-28','07:50:00',5.34),('7643','2013-05-28','07:55:00',5.7),('7643','2013-05-28','08:00:00',6.07),('7643','2013-05-28','08:05:00',6.38),('7643','2013-05-28','08:10:00',6.74),('7643','2013-05-28','08:15:00',7.02),('7643','2013-05-28','08:20:00',7.4),('7643','2013-05-28','08:25:00',7.76),('7643','2013-05-28','08:30:00',8.12),('7643','2013-05-28','08:35:00',8.51),('7643','2013-05-28','08:40:00',8.86),('7643','2013-05-28','08:45:00',9.22),('7643','2013-05-28','08:50:00',9.59),('7643','2013-05-28','08:55:00',9.9),('7643','2013-05-28','09:00:00',10.24),('7643','2013-05-28','09:05:00',10.53),('7643','2013-05-28','09:10:00',10.87),('7643','2013-05-28','09:15:00',11.19),('7643','2013-05-28','09:20:00',11.42),('7643','2013-05-28','09:25:00',11.68),('7643','2013-05-28','09:30:00',11.89),('7643','2013-05-28','09:35:00',12.18),('7643','2013-05-28','09:40:00',12.56),('7643','2013-05-28','09:45:00',12.81),('7643','2013-05-28','09:50:00',13.03),('7643','2013-05-28','09:55:00',13.3),('7643','2013-05-28','10:00:00',13.47),('7643','2013-05-28','10:05:00',13.74),('7643','2013-05-28','10:10:00',13.96),('7643','2013-05-28','10:15:00',14.17),('7643','2013-05-28','10:20:00',14.43),('7643','2013-05-28','10:25:00',14.62),('7643','2013-05-28','10:30:00',14.86),('7643','2013-05-28','10:35:00',15.07),('7643','2013-05-28','10:40:00',15.33),('7643','2013-05-28','10:45:00',15.44),('7643','2013-05-28','10:50:00',15.76),('7643','2013-05-28','10:55:00',15.95),('7643','2013-05-28','11:00:00',15.95),('7643','2013-05-28','11:05:00',16.11),('7643','2013-05-28','11:10:00',16.53),('7643','2013-05-28','11:15:00',11.82),('7643','2013-05-28','11:20:00',17.58),('7643','2013-05-28','11:25:00',18.31),('7643','2013-05-28','11:30:00',13.42),('7643','2013-05-28','11:35:00',16.47),('7643','2013-05-28','11:40:00',16.56),('7643','2013-05-28','11:45:00',15.51),('7643','2013-05-28','11:50:00',11.4),('7643','2013-05-28','11:55:00',16.17),('7643','2013-05-28','12:00:00',15.2),('7643','2013-05-28','12:05:00',11.64),('7643','2013-05-28','12:10:00',16.83),('7643','2013-05-28','12:15:00',15.15),('7643','2013-05-28','12:20:00',14.36),('7643','2013-05-28','12:25:00',18.55),('7643','2013-05-28','12:30:00',18.1),('7643','2013-05-28','12:35:00',18.13),('7643','2013-05-28','12:40:00',18.05),('7643','2013-05-28','12:45:00',16.18),('7643','2013-05-28','12:50:00',17.11),('7643','2013-05-28','12:55:00',17.72),('7643','2013-05-28','13:00:00',18.23),('7643','2013-05-28','13:05:00',17.59),('7643','2013-05-28','13:10:00',17.47),('7643','2013-05-28','13:15:00',17.57),('7643','2013-05-28','13:20:00',14.27),('7643','2013-05-28','13:25:00',18.64),('7643','2013-05-28','13:30:00',19.07),('7643','2013-05-28','13:35:00',17.38),('7643','2013-05-28','13:40:00',19.18),('7643','2013-05-28','13:45:00',16.96),('7643','2013-05-28','13:50:00',15.31),('7643','2013-05-28','13:55:00',15.35),('7643','2013-05-28','14:00:00',17.99),('7643','2013-05-28','14:05:00',17.67),('7643','2013-05-28','14:10:00',17.19),('7643','2013-05-28','14:15:00',17.77),('7643','2013-05-28','14:20:00',17.65),('7643','2013-05-28','14:25:00',17.19),('7643','2013-05-28','14:30:00',17.7),('7643','2013-05-28','14:35:00',9.88),('7643','2013-05-28','14:40:00',16.96),('7643','2013-05-28','14:45:00',17.79),('7643','2013-05-28','14:50:00',16.88),('7643','2013-05-28','14:55:00',15.41),('7643','2013-05-28','15:00:00',15.2),('7643','2013-05-28','15:05:00',18.07),('7643','2013-05-28','15:10:00',13.96),('7643','2013-05-28','15:15:00',8.87),('7643','2013-05-28','15:20:00',12.83),('7643','2013-05-28','15:25:00',11.76),('7643','2013-05-28','15:30:00',10.99),('7643','2013-05-28','15:35:00',10.92),('7643','2013-05-28','15:40:00',9.83),('7643','2013-05-28','15:45:00',11.97),('7643','2013-05-28','15:50:00',12.02),('7643','2013-05-28','15:55:00',11.34),('7643','2013-05-28','16:00:00',10.03),('7643','2013-05-28','16:05:00',10.45),('7643','2013-05-28','16:10:00',8.54),('7643','2013-05-28','16:15:00',7.91),('7643','2013-05-28','16:20:00',7.9),('7643','2013-05-28','16:25:00',7.54),('7643','2013-05-28','16:30:00',7.04),('7643','2013-05-28','16:35:00',6.83),('7643','2013-05-28','16:40:00',7.72),('7643','2013-05-28','16:45:00',7.29),('7643','2013-05-28','16:50:00',5.55),('7643','2013-05-28','16:55:00',5.53),('7643','2013-05-28','17:00:00',5.26),('7643','2013-05-28','17:05:00',2.55),('7643','2013-05-28','17:10:00',1.5),('7643','2013-05-28','17:15:00',1.46),('7643','2013-05-28','17:20:00',1.66),('7643','2013-05-28','17:25:00',2.23),('7643','2013-05-28','17:30:00',2.62),('7643','2013-05-28','17:35:00',3.89),('7643','2013-05-28','17:40:00',5.6),('7643','2013-05-28','17:45:00',4.15),('7643','2013-05-28','17:50:00',3.1),('7643','2013-05-28','17:55:00',2.48),('7643','2013-05-28','18:00:00',2.85),('7643','2013-05-28','18:05:00',3.52),('7643','2013-05-28','18:10:00',3.56),('7643','2013-05-28','18:15:00',7.04),('7643','2013-05-28','18:20:00',5.97),('7643','2013-05-28','18:25:00',1.84),('7643','2013-05-28','18:30:00',1.5),('7643','2013-05-28','18:35:00',1.64),('7643','2013-05-28','18:40:00',1.42),('7643','2013-05-28','18:50:00',1.58),('7643','2013-05-28','18:55:00',1.8),('7643','2013-05-28','19:00:00',1.45),('7643','2013-05-28','19:05:00',2),('7643','2013-05-28','19:10:00',2.07),('7643','2013-05-28','19:15:00',2.25),('7643','2013-05-28','19:20:00',1.82),('7643','2013-05-28','19:25:00',1.54),('7643','2013-05-28','19:30:00',1.3),('7643','2013-05-28','19:35:00',1.02),('7643','2013-05-28','19:40:00',1.01),('7643','2013-05-27','06:35:00',1.28),('7643','2013-05-27','06:40:00',1.74),('7643','2013-05-27','06:45:00',2.07),('7643','2013-05-27','06:50:00',2.22),('7643','2013-05-27','06:55:00',2),('7643','2013-05-27','07:00:00',1.61),('7643','2013-05-27','07:05:00',1.73),('7643','2013-05-27','07:10:00',2.48),('7643','2013-05-27','07:15:00',3.39),('7643','2013-05-27','07:20:00',4.04),('7643','2013-05-27','07:25:00',4.3),('7643','2013-05-27','07:30:00',3.41),('7643','2013-05-27','07:35:00',3.27),('7643','2013-05-27','07:40:00',4.07),('7643','2013-05-27','07:45:00',4.44),('7643','2013-05-27','07:50:00',4.3),('7643','2013-05-27','07:55:00',4.52),('7643','2013-05-27','08:00:00',4.62),('7643','2013-05-27','08:05:00',4.94),('7643','2013-05-27','08:10:00',5.67),('7643','2013-05-27','08:15:00',6.5),('7643','2013-05-27','08:20:00',7.07),('7643','2013-05-27','08:25:00',6.46),('7643','2013-05-27','08:30:00',6.97),('7643','2013-05-27','08:35:00',6.46),('7643','2013-05-27','08:40:00',5.73),('7643','2013-05-27','08:45:00',5.3),('7643','2013-05-27','08:50:00',6.04),('7643','2013-05-27','08:55:00',5.94),('7643','2013-05-27','09:00:00',6.57),('7643','2013-05-27','09:05:00',6.92),('7643','2013-05-27','09:10:00',6.35),('7643','2013-05-27','09:15:00',5.98),('7643','2013-05-27','09:20:00',7.07),('7643','2013-05-27','09:25:00',8.37),('7643','2013-05-27','09:30:00',8.96),('7643','2013-05-27','09:35:00',9.11),('7643','2013-05-27','09:40:00',8.74),('7643','2013-05-27','09:45:00',7.95),('7643','2013-05-27','09:50:00',8.1),('7643','2013-05-27','09:55:00',8.96),('7643','2013-05-27','10:00:00',8.24),('7643','2013-05-27','10:05:00',8.83),('7643','2013-05-27','10:10:00',9.79),('7643','2013-05-27','10:15:00',10.17),('7643','2013-05-27','10:20:00',10.76),('7643','2013-05-27','10:25:00',10.43),('7643','2013-05-27','10:30:00',11.75),('7643','2013-05-27','10:35:00',11.86),('7643','2013-05-27','10:40:00',10.47),('7643','2013-05-27','10:45:00',10.11),('7643','2013-05-27','10:50:00',11.02),('7643','2013-05-27','10:55:00',9.18),('7643','2013-05-27','11:00:00',9.24),('7643','2013-05-27','11:05:00',9.22),('7643','2013-05-27','11:10:00',10.11),('7643','2013-05-27','11:15:00',7.76),('7643','2013-05-27','11:20:00',8.93),('7643','2013-05-27','11:25:00',7.15),('7643','2013-05-27','11:30:00',14.44),('7643','2013-05-27','11:35:00',11.15),('7643','2013-05-27','11:40:00',15.57),('7643','2013-05-27','11:45:00',13.3),('7643','2013-05-27','11:50:00',4.42),('7643','2013-05-27','11:55:00',6.05),('7643','2013-05-27','12:00:00',5.89),('7643','2013-05-27','12:05:00',7.01),('7643','2013-05-27','12:10:00',12.06),('7643','2013-05-27','12:15:00',10.62),('7643','2013-05-27','12:20:00',8.99),('7643','2013-05-27','12:25:00',9.32),('7643','2013-05-27','12:30:00',10.43),('7643','2013-05-27','12:35:00',9.95),('7643','2013-05-27','12:40:00',10.15),('7643','2013-05-27','12:45:00',11.63),('7643','2013-05-27','12:50:00',10.28),('7643','2013-05-27','12:55:00',10.31),('7643','2013-05-27','13:00:00',10.67),('7643','2013-05-27','13:05:00',11.26),('7643','2013-05-27','13:10:00',11.67),('7643','2013-05-27','13:15:00',11.37),('7643','2013-05-27','13:20:00',12.77),('7643','2013-05-27','13:25:00',7.15),('7643','2013-05-27','13:30:00',8.27),('7643','2013-05-27','13:35:00',6.91),('7643','2013-05-27','13:40:00',7.54),('7643','2013-05-27','13:45:00',7.55),('7643','2013-05-27','13:50:00',11.82),('7643','2013-05-27','13:55:00',10.64),('7643','2013-05-27','14:00:00',10.01),('7643','2013-05-27','14:05:00',10.56),('7643','2013-05-27','14:10:00',15.28),('7643','2013-05-27','14:15:00',15.07),('7643','2013-05-27','14:20:00',10.04),('7643','2013-05-27','14:25:00',10.98),('7643','2013-05-27','14:30:00',13.12),('7643','2013-05-27','14:35:00',12.19),('7643','2013-05-27','14:40:00',13.2),('7643','2013-05-27','14:45:00',14.7),('7643','2013-05-27','14:50:00',10.52),('7643','2013-05-27','14:55:00',9.25),('7643','2013-05-27','15:00:00',9.09),('7643','2013-05-27','15:05:00',14.71),('7643','2013-05-27','15:10:00',6.3),('7643','2013-05-27','15:15:00',10.97),('7643','2013-05-27','15:20:00',12.44),('7643','2013-05-27','15:25:00',7.86),('7643','2013-05-27','15:30:00',5.74),('7643','2013-05-27','15:35:00',5.95),('7643','2013-05-27','15:40:00',11.05),('7643','2013-05-27','15:45:00',14.54),('7643','2013-05-27','15:50:00',11.96),('7643','2013-05-27','15:55:00',8.9),('7643','2013-05-27','16:00:00',6.45),('7643','2013-05-27','16:05:00',5.22),('7643','2013-05-27','16:10:00',5.51),('7643','2013-05-27','16:15:00',5.65),('7643','2013-05-27','16:20:00',8.66),('7643','2013-05-27','16:25:00',8.98),('7643','2013-05-27','16:30:00',10.04),('7643','2013-05-27','16:35:00',11.72),('7643','2013-05-27','16:40:00',10.91),('7643','2013-05-27','16:45:00',10.45),('7643','2013-05-27','16:50:00',10.16),('7643','2013-05-27','16:55:00',9.83),('7643','2013-05-27','17:00:00',9.73),('7643','2013-05-27','17:05:00',9.44),('7643','2013-05-27','17:10:00',9),('7643','2013-05-27','17:15:00',8.79),('7643','2013-05-27','17:20:00',8.4),('7643','2013-05-27','17:25:00',7.95),('7643','2013-05-27','17:30:00',7.65),('7643','2013-05-27','17:35:00',7.35),('7643','2013-05-27','17:40:00',5.53),('7643','2013-05-27','17:45:00',6.64),('7643','2013-05-27','17:50:00',6.35),('7643','2013-05-27','17:55:00',5.99),('7643','2013-05-27','18:00:00',6),('7643','2013-05-27','18:05:00',5.5),('7643','2013-05-27','18:10:00',5.24),('7643','2013-05-27','18:15:00',2.15),('7643','2013-05-27','18:20:00',1.37),('7643','2013-05-27','18:25:00',1.47),('7643','2013-05-27','18:30:00',2.28),('7643','2013-05-27','18:35:00',3.61),('7643','2013-05-27','18:40:00',3.25),('7643','2013-05-27','18:45:00',2.86),('7643','2013-05-27','18:50:00',2.5),('7643','2013-05-27','18:55:00',2.2),('7643','2013-05-27','19:00:00',2.02),('7643','2013-05-27','19:05:00',1.79),('7643','2013-05-27','19:10:00',1.55),('7643','2013-05-27','19:15:00',1.33),('7643','2013-05-27','19:20:00',1.16),('7643','2013-05-26','06:40:00',1.12),('7643','2013-05-26','06:45:00',1.48),('7643','2013-05-26','06:50:00',1.79),('7643','2013-05-26','06:55:00',1.78),('7643','2013-05-26','07:00:00',1.74),('7643','2013-05-26','07:05:00',2.5),('7643','2013-05-26','07:10:00',2.19),('7643','2013-05-26','07:15:00',1.69),('7643','2013-05-26','07:20:00',1.44),('7643','2013-05-26','07:25:00',3.89),('7643','2013-05-26','07:30:00',4.03),('7643','2013-05-26','07:35:00',4.57),('7643','2013-05-26','07:40:00',4.89),('7643','2013-05-26','07:45:00',4.74),('7643','2013-05-26','07:50:00',5.58),('7643','2013-05-26','07:55:00',3.95),('7643','2013-05-26','08:00:00',4.61),('7643','2013-05-26','08:05:00',6.79),('7643','2013-05-26','08:10:00',7.1),('7643','2013-05-26','08:15:00',5.25),('7643','2013-05-26','08:20:00',6.65),('7643','2013-05-26','08:25:00',6.65),('7643','2013-05-26','08:30:00',8.52),('7643','2013-05-26','08:35:00',8.78),('7643','2013-05-26','08:40:00',9.24),('7643','2013-05-26','08:45:00',9.98),('7643','2013-05-26','08:50:00',9.87),('7643','2013-05-26','08:55:00',9.36),('7643','2013-05-26','09:00:00',11.57),('7643','2013-05-26','09:05:00',11.46),('7643','2013-05-26','09:10:00',9.26),('7643','2013-05-26','09:15:00',9.69),('7643','2013-05-26','09:20:00',11.03),('7643','2013-05-26','09:25:00',5.45),('7643','2013-05-26','09:30:00',10.21),('7643','2013-05-26','09:35:00',13.09),('7643','2013-05-26','09:40:00',13.16),('7643','2013-05-26','09:45:00',13.4),('7643','2013-05-26','09:50:00',13.58),('7643','2013-05-26','09:55:00',12.48),('7643','2013-05-26','10:00:00',9.47),('7643','2013-05-26','10:05:00',14.87),('7643','2013-05-26','10:10:00',14.9),('7643','2013-05-26','10:15:00',15.23),('7643','2013-05-26','10:20:00',13.71),('7643','2013-05-26','10:25:00',6.69),('7643','2013-05-26','10:30:00',15.19),('7643','2013-05-26','10:35:00',7.38),('7643','2013-05-26','10:40:00',14.24),('7643','2013-05-26','10:45:00',11.61),('7643','2013-05-26','10:50:00',11.48),('7643','2013-05-26','10:55:00',6.15),('7643','2013-05-26','11:00:00',11.57),('7643','2013-05-26','11:05:00',17.2),('7643','2013-05-26','11:10:00',15.5),('7643','2013-05-26','11:15:00',11.38),('7643','2013-05-26','11:20:00',10.14),('7643','2013-05-26','11:25:00',19.74),('7643','2013-05-26','11:30:00',8.59),('7643','2013-05-26','11:35:00',10.05),('7643','2013-05-26','11:40:00',13.93),('7643','2013-05-26','11:45:00',14.12),('7643','2013-05-26','11:50:00',7.65),('7643','2013-05-26','11:55:00',9.63),('7643','2013-05-26','12:00:00',17.18),('7643','2013-05-26','12:05:00',9.69),('7643','2013-05-26','12:10:00',15.22),('7643','2013-05-26','12:15:00',17.56),('7643','2013-05-26','12:20:00',19.91),('7643','2013-05-26','12:25:00',18.46),('7643','2013-05-26','12:30:00',17.44),('7643','2013-05-26','12:35:00',14.58),('7643','2013-05-26','12:40:00',19.35),('7643','2013-05-26','12:45:00',15.61),('7643','2013-05-26','12:50:00',15.22),('7643','2013-05-26','12:55:00',18.13),('7643','2013-05-26','13:00:00',12.23),('7643','2013-05-26','13:05:00',5),('7643','2013-05-26','13:10:00',16.59),('7643','2013-05-26','13:15:00',9.38),('7643','2013-05-26','13:20:00',15.06),('7643','2013-05-26','13:25:00',18.65),('7643','2013-05-26','13:30:00',18.58),('7643','2013-05-26','13:35:00',16.44),('7643','2013-05-26','13:40:00',18.88),('7643','2013-05-26','13:45:00',18.39),('7643','2013-05-26','13:50:00',13.81),('7643','2013-05-26','13:55:00',15.6),('7643','2013-05-26','14:00:00',17.9),('7643','2013-05-26','14:05:00',17.85),('7643','2013-05-26','14:10:00',16.91),('7643','2013-05-26','14:15:00',15.47),('7643','2013-05-26','14:20:00',9.46),('7643','2013-05-26','14:25:00',17.48),('7643','2013-05-26','14:30:00',17.29),('7643','2013-05-26','14:35:00',17.11),('7643','2013-05-26','14:40:00',8.44),('7643','2013-05-26','14:45:00',18.9),('7643','2013-05-26','14:50:00',17.57),('7643','2013-05-26','14:55:00',14.72),('7643','2013-05-26','15:00:00',11.34),('7643','2013-05-26','15:05:00',10.02),('7643','2013-05-26','15:10:00',16.81),('7643','2013-05-26','15:15:00',11.57),('7643','2013-05-26','15:20:00',14.2),('7643','2013-05-26','15:25:00',13),('7643','2013-05-26','15:30:00',14.21),('7643','2013-05-26','15:35:00',16.19),('7643','2013-05-26','15:40:00',13.21),('7643','2013-05-26','15:45:00',11.88),('7643','2013-05-26','15:50:00',15.07),('7643','2013-05-26','15:55:00',9.78),('7643','2013-05-26','16:00:00',11.87),('7643','2013-05-26','16:05:00',8.49),('7643','2013-05-26','16:10:00',10.15),('7643','2013-05-26','16:15:00',8.92),('7643','2013-05-26','16:20:00',14.65),('7643','2013-05-26','16:25:00',14.04),('7643','2013-05-26','16:30:00',12.74),('7643','2013-05-26','16:35:00',11.22),('7643','2013-05-26','16:40:00',5.37),('7643','2013-05-26','16:45:00',4.66),('7643','2013-05-26','16:50:00',4.79),('7643','2013-05-26','16:55:00',5.15),('7643','2013-05-26','17:00:00',5.42),('7643','2013-05-26','17:05:00',5.54),('7643','2013-05-26','17:10:00',7.11),('7643','2013-05-26','17:15:00',5.61),('7643','2013-05-26','17:20:00',4.81),('7643','2013-05-26','17:25:00',4.38),('7643','2013-05-26','17:30:00',4.27),('7643','2013-05-26','17:35:00',3.98),('7643','2013-05-26','17:40:00',3.68),('7643','2013-05-26','17:45:00',3.45),('7643','2013-05-26','17:50:00',3.3),('7643','2013-05-26','17:55:00',3.36),('7643','2013-05-26','18:00:00',3.34),('7643','2013-05-26','18:05:00',3.01),('7643','2013-05-26','18:10:00',3.09),('7643','2013-05-26','18:15:00',3.46),('7643','2013-05-26','18:20:00',4.37),('7643','2013-05-26','18:25:00',6.43),('7643','2013-05-26','18:30:00',5.19),('7643','2013-05-26','18:35:00',3.68),('7643','2013-05-26','18:40:00',2.4),('7643','2013-05-26','18:45:00',3.16),('7643','2013-05-26','18:50:00',2.42),('7643','2013-05-26','18:55:00',3.14),('7643','2013-05-26','19:00:00',3.3),('7643','2013-05-26','19:05:00',3.11),('7643','2013-05-26','19:10:00',2.65),('7643','2013-05-26','19:15:00',2.01),('7643','2013-05-26','19:20:00',1.79),('7643','2013-05-26','19:25:00',1.77),('7643','2013-05-26','19:30:00',1.74),('7643','2013-05-26','19:35:00',1.63),('7643','2013-05-26','19:40:00',1.15),('7643','2013-05-25','06:50:00',1.05),('7643','2013-05-25','06:55:00',1.24),('7643','2013-05-25','07:20:00',3.4),('7643','2013-05-25','07:25:00',2.85),('7643','2013-05-25','07:35:00',4.22),('7643','2013-05-25','07:40:00',4.93),('7643','2013-05-25','07:45:00',5.65),('7643','2013-05-25','07:50:00',7.75),('7643','2013-05-25','07:55:00',3.09),('7643','2013-05-25','08:00:00',2.04),('7643','2013-05-25','08:05:00',7.2),('7643','2013-05-25','08:10:00',7.12),('7643','2013-05-25','08:15:00',2.44),('7643','2013-05-25','08:20:00',3.13),('7643','2013-05-25','08:25:00',3.68),('7643','2013-05-25','08:30:00',9.31),('7643','2013-05-25','08:35:00',6.68),('7643','2013-05-25','08:40:00',8),('7643','2013-05-25','08:45:00',11.06),('7643','2013-05-25','08:50:00',12.25),('7643','2013-05-25','08:55:00',3.71),('7643','2013-05-25','09:00:00',6.09),('7643','2013-05-25','09:05:00',2.98),('7643','2013-05-25','09:10:00',9.47),('7643','2013-05-25','09:15:00',5.13),('7643','2013-05-25','09:20:00',3.07),('7643','2013-05-25','09:25:00',5.46),('7643','2013-05-25','09:30:00',2.99),('7643','2013-05-25','09:35:00',3.81),('7643','2013-05-25','09:40:00',3.61),('7643','2013-05-25','09:45:00',8.91),('7643','2013-05-25','09:50:00',3.01),('7643','2013-05-25','09:55:00',3.77),('7643','2013-05-25','10:00:00',5.39),('7643','2013-05-25','10:05:00',11.04),('7643','2013-05-25','10:10:00',16.2),('7643','2013-05-25','10:15:00',10.28),('7643','2013-05-25','10:20:00',11.84),('7643','2013-05-25','10:25:00',11.31),('7643','2013-05-25','10:30:00',14.46),('7643','2013-05-25','10:35:00',15.9),('7643','2013-05-25','10:40:00',16.1),('7643','2013-05-25','10:45:00',16.28),('7643','2013-05-25','10:50:00',16.74),('7643','2013-05-25','10:55:00',15.01),('7643','2013-05-25','11:00:00',16.47),('7643','2013-05-25','11:05:00',17.05),('7643','2013-05-25','11:10:00',17.22),('7643','2013-05-25','11:15:00',17.23),('7643','2013-05-25','11:20:00',16.17),('7643','2013-05-25','11:25:00',17.64),('7643','2013-05-25','11:30:00',17.06),('7643','2013-05-25','11:35:00',17.76),('7643','2013-05-25','11:40:00',17.3),('7643','2013-05-25','11:45:00',16.55),('7643','2013-05-25','11:50:00',18.41),('7643','2013-05-25','11:55:00',18.07),('7643','2013-05-25','12:00:00',17.12),('7643','2013-05-25','12:05:00',17.96),('7643','2013-05-25','12:10:00',13.87),('7643','2013-05-25','12:15:00',13.69),('7643','2013-05-25','12:20:00',12.2),('7643','2013-05-25','12:25:00',17.82),('7643','2013-05-25','12:30:00',19.13),('7643','2013-05-25','12:35:00',18.99),('7643','2013-05-25','12:40:00',18.05),('7643','2013-05-25','12:45:00',19.19),('7643','2013-05-25','12:50:00',18.46),('7643','2013-05-25','12:55:00',18.26),('7643','2013-05-25','13:00:00',16.99),('7643','2013-05-25','13:05:00',16.94),('7643','2013-05-25','13:10:00',18.99),('7643','2013-05-25','13:15:00',19.21),('7643','2013-05-25','13:20:00',19.09),('7643','2013-05-25','13:25:00',18.77),('7643','2013-05-25','13:30:00',18.12),('7643','2013-05-25','13:35:00',18.98),('7643','2013-05-25','13:40:00',18.64),('7643','2013-05-25','13:45:00',18.61),('7643','2013-05-25','13:50:00',18.51),('7643','2013-05-25','13:55:00',18.27),('7643','2013-05-25','14:00:00',18.39),('7643','2013-05-25','14:05:00',17.82),('7643','2013-05-25','14:10:00',18),('7643','2013-05-25','14:15:00',18.06),('7643','2013-05-25','14:20:00',17.92),('7643','2013-05-25','14:25:00',17.74),('7643','2013-05-25','14:30:00',17.68),('7643','2013-05-25','14:35:00',17.59),('7643','2013-05-25','14:40:00',17.55),('7643','2013-05-25','14:45:00',17.33),('7643','2013-05-25','14:50:00',17.21),('7643','2013-05-25','14:55:00',16.96),('7643','2013-05-25','15:00:00',16.78),('7643','2013-05-25','15:05:00',16.69),('7643','2013-05-25','15:10:00',16.51),('7643','2013-05-25','15:15:00',16.41),('7643','2013-05-25','15:20:00',16.16),('7643','2013-05-25','15:25:00',15.96),('7643','2013-05-25','15:30:00',15.76),('7643','2013-05-25','15:35:00',15.56),('7643','2013-05-25','15:40:00',15.41),('7643','2013-05-25','15:45:00',15.12),('7643','2013-05-25','15:50:00',14.89),('7643','2013-05-25','15:55:00',14.62),('7643','2013-05-25','16:00:00',14.45),('7643','2013-05-25','16:05:00',14.15),('7643','2013-05-25','16:10:00',13.97),('7643','2013-05-25','16:15:00',13.69),('7643','2013-05-25','16:20:00',13.41),('7643','2013-05-25','16:25:00',13.17),('7643','2013-05-25','16:30:00',12.84),('7643','2013-05-25','16:35:00',12.43),('7643','2013-05-25','16:40:00',12.06),('7643','2013-05-25','16:45:00',11.91),('7643','2013-05-25','16:50:00',11.55),('7643','2013-05-25','16:55:00',11.22),('7643','2013-05-25','17:00:00',10.9),('7643','2013-05-25','17:05:00',10.64),('7643','2013-05-25','17:10:00',10.08),('7643','2013-05-25','17:15:00',9.68),('7643','2013-05-25','17:20:00',9.37),('7643','2013-05-25','17:25:00',8.99),('7643','2013-05-25','17:30:00',8.69),('7643','2013-05-25','17:35:00',8.25),('7643','2013-05-25','17:40:00',8.02),('7643','2013-05-25','17:45:00',7.67),('7643','2013-05-25','17:50:00',7.29),('7643','2013-05-25','17:55:00',6.89),('7643','2013-05-25','18:00:00',6.54),('7643','2013-05-25','18:05:00',6.18),('7643','2013-05-25','18:10:00',5.82),('7643','2013-05-25','18:15:00',5.48),('7643','2013-05-25','18:20:00',5.12),('7643','2013-05-25','18:25:00',4.74),('7643','2013-05-25','18:30:00',4.38),('7643','2013-05-25','18:35:00',3.98),('7643','2013-05-25','18:40:00',3.51),('7643','2013-05-25','18:45:00',3.05),('7643','2013-05-25','18:50:00',2.6),('7643','2013-05-25','18:55:00',2.22),('7643','2013-05-25','19:00:00',2.11),('7643','2013-05-25','19:05:00',1.86),('7643','2013-05-25','19:10:00',1.53),('7643','2013-05-25','19:15:00',1.26),('7643','2013-05-25','19:20:00',1.05),('7643','2013-05-24','18:40:00',1.82),('7643','2013-05-24','18:45:00',1.24),('7643','2013-05-24','19:00:00',1.01),('7643','2013-05-24','19:10:00',1.19),('7643','2013-05-23','09:25:00',6.48),('7643','2013-05-23','09:30:00',6.85),('7643','2013-05-23','09:35:00',3),('7643','2013-05-23','09:40:00',5.64),('7643','2013-05-23','09:45:00',4.76),('7643','2013-05-23','09:50:00',5.2),('7643','2013-05-23','09:55:00',10.71),('7643','2013-05-23','10:00:00',7.33),('7643','2013-05-23','10:05:00',3.07),('7643','2013-05-23','10:10:00',2.68),('7643','2013-05-23','10:15:00',1.91),('7643','2013-05-23','10:20:00',3.78),('7643','2013-05-23','10:25:00',9.37),('7643','2013-05-23','10:30:00',16.56),('7643','2013-05-23','10:35:00',15.24),('7643','2013-05-23','10:40:00',14.45),('7643','2013-05-23','10:45:00',14.91),('7643','2013-05-23','10:50:00',9.88),('7643','2013-05-23','10:55:00',15.08),('7643','2013-05-23','11:00:00',10.76),('7643','2013-05-23','11:05:00',12.87),('7643','2013-05-23','11:10:00',17.31),('7643','2013-05-23','11:15:00',15.1),('7643','2013-05-23','11:20:00',15.96),('7643','2013-05-23','11:25:00',15.22),('7643','2013-05-23','11:30:00',10.94),('7643','2013-05-23','11:35:00',4.75),('7643','2013-05-23','11:40:00',3.54),('7643','2013-05-23','11:45:00',8.94),('7643','2013-05-23','11:50:00',18.11),('7643','2013-05-23','11:55:00',15.37),('7643','2013-05-23','12:00:00',7.38),('7643','2013-05-23','12:05:00',11.05),('7643','2013-05-23','12:10:00',12.72),('7643','2013-05-23','12:15:00',8),('7643','2013-05-23','12:20:00',8.09),('7643','2013-05-23','12:25:00',15.82),('7643','2013-05-23','12:30:00',16.07),('7643','2013-05-23','12:35:00',8.15),('7643','2013-05-23','12:40:00',10.31),('7643','2013-05-23','12:45:00',13.97),('7643','2013-05-23','12:50:00',11.67),('7643','2013-05-23','12:55:00',8.98),('7643','2013-05-23','13:00:00',8.72),('7643','2013-05-23','13:05:00',7.91),('7643','2013-05-23','13:10:00',10.22),('7643','2013-05-23','13:15:00',11.1),('7643','2013-05-23','13:20:00',12.71),('7643','2013-05-23','13:25:00',10.44),('7643','2013-05-23','13:30:00',8.83),('7643','2013-05-23','13:35:00',14.05),('7643','2013-05-23','13:40:00',11.09),('7643','2013-05-23','13:45:00',5.26),('7643','2013-05-23','13:50:00',5),('7643','2013-05-23','13:55:00',14.3),('7643','2013-05-23','14:00:00',11.43),('7643','2013-05-23','14:05:00',8.41),('7643','2013-05-23','14:10:00',4.35),('7643','2013-05-23','14:15:00',13.36),('7643','2013-05-23','14:20:00',10.67),('7643','2013-05-23','14:25:00',14.7),('7643','2013-05-23','14:30:00',11.21),('7643','2013-05-23','14:35:00',11.16),('7643','2013-05-23','14:40:00',9.36),('7643','2013-05-23','14:45:00',8.49),('7643','2013-05-23','14:50:00',5.08),('7643','2013-05-23','14:55:00',6.34),('7643','2013-05-23','15:00:00',2.56),('7643','2013-05-21','06:45:00',1.24),('7643','2013-05-21','06:50:00',1.06),('7643','2013-05-21','06:55:00',1.18),('7643','2013-05-21','07:00:00',1.26),('7643','2013-05-21','07:05:00',1.37),('7643','2013-05-21','07:10:00',1.5),('7643','2013-05-21','07:15:00',1.56),('7643','2013-05-21','07:20:00',1.97),('7643','2013-05-21','07:25:00',2.34),('7643','2013-05-21','07:30:00',2.23),('7643','2013-05-21','07:35:00',2.13),('7643','2013-05-21','07:40:00',2.48),('7643','2013-05-21','07:45:00',2.75),('7643','2013-05-21','07:50:00',3.56),('7643','2013-05-21','07:55:00',4.02),('7643','2013-05-21','08:00:00',4.97),('7643','2013-05-21','08:05:00',5.72),('7643','2013-05-21','08:10:00',4.52),('7643','2013-05-21','08:15:00',7.83),('7643','2013-05-21','08:20:00',7.65),('7643','2013-05-21','08:25:00',7.32),('7643','2013-05-21','08:30:00',8.1),('7643','2013-05-21','08:35:00',9.69),('7643','2013-05-21','08:40:00',5.28),('7643','2013-05-21','08:45:00',7.05),('7643','2013-05-21','08:50:00',4.78),('7643','2013-05-21','08:55:00',1.43),('7643','2013-05-21','09:00:00',1.22),('7643','2013-05-21','09:05:00',1.66),('7643','2013-05-21','09:10:00',2.45),('7643','2013-05-21','09:15:00',3.28),('7643','2013-05-21','09:20:00',3.13),('7643','2013-05-21','09:25:00',4.05),('7643','2013-05-21','09:30:00',10.86),('7643','2013-05-21','09:35:00',11.49),('7643','2013-05-21','09:40:00',11.42),('7643','2013-05-21','09:45:00',11.55),('7643','2013-05-21','09:50:00',11.74),('7643','2013-05-21','09:55:00',11.94),('7643','2013-05-21','10:00:00',12.22),('7643','2013-05-21','10:05:00',12.46),('7643','2013-05-21','10:10:00',12.65),('7643','2013-05-21','10:15:00',12.86),('7643','2013-05-21','10:20:00',12.75),('7643','2013-05-21','10:25:00',13.68),('7643','2013-05-21','10:30:00',13.62),('7643','2013-05-21','10:35:00',13.8),('7643','2013-05-21','10:40:00',14.24),('7643','2013-05-21','10:45:00',14.25),('7643','2013-05-21','10:50:00',14.15),('7643','2013-05-21','10:55:00',14.33),('7643','2013-05-21','11:00:00',14.69),('7643','2013-05-21','11:05:00',15.21),('7643','2013-05-21','11:10:00',13.69),('7643','2013-05-21','11:15:00',14.57),('7643','2013-05-21','11:20:00',15.4),('7643','2013-05-21','11:25:00',15.45),('7643','2013-05-21','11:30:00',13.81),('7643','2013-05-21','11:35:00',12.23),('7643','2013-05-21','11:40:00',14.24),('7643','2013-05-21','11:45:00',15.5),('7643','2013-05-21','11:50:00',9.89),('7643','2013-05-21','11:55:00',8.71),('7643','2013-05-21','12:00:00',11.57),('7643','2013-05-21','12:05:00',8.85),('7643','2013-05-21','12:10:00',8.45),('7643','2013-05-21','12:15:00',12.46),('7643','2013-05-21','12:20:00',17.27),('7643','2013-05-21','12:25:00',11.53),('7643','2013-05-21','12:30:00',8.53),('7643','2013-05-21','12:35:00',9.35),('7643','2013-05-21','12:40:00',5.94),('7643','2013-05-21','12:45:00',2.49),('7643','2013-05-21','12:50:00',1.38),('7643','2013-05-21','12:55:00',1.94),('7643','2013-05-21','13:00:00',5.34),('7643','2013-05-21','13:05:00',17.22),('7643','2013-05-21','13:10:00',8.75),('7643','2013-05-21','13:15:00',9.05),('7643','2013-05-21','13:20:00',8.57),('7643','2013-05-21','13:25:00',4.44),('7643','2013-05-21','13:30:00',7.38),('7643','2013-05-21','13:35:00',12.78),('7643','2013-05-21','13:40:00',12.05),('7643','2013-05-21','13:45:00',10.02),('7643','2013-05-21','13:50:00',9.22),('7643','2013-05-21','13:55:00',9.38),('7643','2013-05-21','14:00:00',10.29),('7643','2013-05-21','14:05:00',14.51),('7643','2013-05-21','14:10:00',15.03),('7643','2013-05-21','14:15:00',16.52),('7643','2013-05-21','14:20:00',16.07),('7643','2013-05-21','14:25:00',15.86),('7643','2013-05-21','14:30:00',15.73),('7643','2013-05-21','14:35:00',15.59),('7643','2013-05-21','14:40:00',15.41),('7643','2013-05-21','14:45:00',15.26),('7643','2013-05-21','14:50:00',15.09),('7643','2013-05-21','14:55:00',15),('7643','2013-05-21','15:00:00',14.79),('7643','2013-05-21','15:05:00',14.62),('7643','2013-05-21','15:10:00',14.47),('7643','2013-05-21','15:15:00',14.23),('7643','2013-05-21','15:20:00',13.48),('7643','2013-05-21','15:25:00',8.89),('7643','2013-05-21','15:30:00',6.25),('7643','2014-03-31','12:35:00',13.63),('7643','2014-03-31','12:40:00',16.61),('7643','2014-03-31','12:45:00',16.74),('7643','2014-03-31','12:50:00',14.96),('7643','2014-03-31','12:55:00',17.03),('7643','2014-03-31','13:00:00',16.87),('7643','2014-03-31','13:05:00',17.05),('7643','2014-03-31','13:10:00',15.45),('7643','2014-03-31','13:15:00',16.38),('7643','2014-03-31','13:20:00',15.82),('7643','2014-03-31','13:25:00',16.8),('7643','2014-03-31','13:30:00',16.79),('7643','2014-03-31','13:35:00',16.93),('7643','2014-03-31','13:40:00',15.81),('7643','2014-03-31','13:45:00',17.09),('7643','2014-03-31','13:50:00',16.76),('7643','2014-03-31','13:55:00',16.7),('7643','2014-03-31','14:00:00',16.49),('7643','2014-03-31','14:05:00',16.46),('7643','2014-03-31','14:10:00',16.31),('7643','2014-03-31','14:15:00',9.67),('7643','2014-03-31','14:20:00',14.9),('7643','2014-03-31','14:25:00',15.83),('7643','2014-03-31','14:30:00',13.78),('7643','2014-03-31','14:35:00',16.55),('7643','2014-03-31','14:40:00',12.56),('7643','2014-03-31','14:45:00',16.8),('7643','2014-03-31','14:50:00',16.5),('7643','2014-03-31','14:55:00',10.71),('7643','2014-03-31','15:00:00',16.11),('7643','2014-03-31','15:05:00',11.59),('7643','2014-03-31','15:10:00',11.09),('7643','2014-03-31','15:15:00',12.08),('7643','2014-03-31','15:20:00',15.07),('7643','2014-03-31','15:25:00',11.78),('7643','2014-03-31','15:30:00',11.76),('7643','2014-03-31','15:35:00',12.4),('7643','2014-03-31','15:40:00',12.38),('7643','2014-03-31','15:45:00',10.16),('7643','2014-03-31','15:50:00',14.39),('7643','2014-03-31','15:55:00',12.77),('7643','2014-03-31','16:00:00',10.66),('7643','2014-03-31','16:05:00',12.96),('7643','2014-03-31','16:10:00',12.57),('7643','2014-03-31','16:15:00',11.39),('7643','2014-03-31','16:20:00',6.73),('7643','2014-03-31','16:25:00',10.42),('7643','2014-03-31','16:30:00',10.04),('7643','2014-03-31','16:35:00',11.07),('7643','2014-03-31','16:40:00',10.89),('7643','2014-03-31','16:45:00',7.76),('7643','2014-03-31','16:50:00',5.48),('7643','2014-03-31','16:55:00',9.28),('7643','2014-03-31','17:00:00',7.05),('7643','2014-03-31','17:05:00',8.62),('7643','2014-03-31','17:10:00',7.42),('7643','2014-03-31','17:15:00',7.83),('7643','2014-03-31','17:20:00',6.86),('7643','2014-03-31','17:25:00',7.02),('7643','2014-03-31','17:30:00',6.59),('7643','2014-03-31','17:35:00',6.11),('7643','2014-03-31','17:40:00',5.74),('7643','2014-03-31','17:45:00',5.37),('7643','2014-03-31','17:50:00',4.97),('7643','2014-03-31','17:55:00',4.42),('7643','2014-03-31','18:00:00',4.03),('7643','2014-03-31','18:05:00',3.7),('7643','2014-03-31','18:10:00',3.23),('7643','2014-03-31','18:15:00',2.85),('7643','2014-03-31','18:20:00',2.29),('7643','2014-03-31','18:25:00',2.09),('7643','2014-03-31','18:30:00',1.1),('7643','2013-05-20','06:40:00',1.06),('7643','2013-05-20','06:45:00',1.24),('7643','2013-05-20','06:50:00',1.42),('7643','2013-05-20','06:55:00',1.63),('7643','2013-05-20','07:00:00',1.85),('7643','2013-05-20','07:05:00',2.13),('7643','2013-05-20','07:10:00',2.41),('7643','2013-05-20','07:15:00',2.01),('7643','2013-05-20','07:20:00',2.99),('7643','2013-05-20','07:25:00',3.36),('7643','2013-05-20','07:30:00',3.92),('7643','2013-05-20','07:35:00',4.87),('7643','2013-05-20','07:40:00',5.58),('7643','2013-05-20','07:45:00',4.87),('7643','2013-05-20','07:50:00',3.88),('7643','2013-05-20','07:55:00',3.64),('7643','2013-05-20','08:00:00',4.61),('7643','2013-05-20','08:05:00',3.62),('7643','2013-05-20','08:10:00',4.89),('7643','2013-05-20','08:15:00',7.07),('7643','2013-05-20','08:20:00',5.89),('7643','2013-05-20','08:25:00',7.28),('7643','2013-05-20','08:30:00',5.23),('7643','2013-05-20','08:35:00',4.7),('7643','2013-05-20','08:40:00',5.61),('7643','2013-05-20','08:45:00',4.74),('7643','2013-05-20','08:50:00',5.12),('7643','2013-05-20','08:55:00',6.97),('7643','2013-05-20','09:00:00',5.99),('7643','2013-05-20','09:05:00',5.14),('7643','2013-05-20','09:10:00',5.62),('7643','2013-05-20','09:15:00',6.24),('7643','2013-05-20','09:20:00',8.73),('7643','2013-05-20','09:25:00',9.53),('7643','2013-05-20','09:30:00',7.49),('7643','2013-05-20','09:35:00',8.06),('7643','2013-05-20','09:40:00',7.56),('7643','2013-05-20','09:45:00',6.38),('7643','2013-05-20','09:50:00',6.05),('7643','2013-05-20','09:55:00',6.97),('7643','2013-05-20','10:00:00',7.51),('7643','2013-05-20','10:05:00',8.45),('7643','2013-05-20','10:10:00',9.06),('7643','2013-05-20','10:15:00',8.42),('7643','2013-05-20','10:20:00',8.03),('7643','2013-05-20','10:25:00',7.13),('7643','2013-05-20','10:30:00',6.69),('7643','2013-05-20','10:35:00',7.11),('7643','2013-05-20','10:40:00',8.16),('7643','2013-05-20','10:45:00',11.68),('7643','2013-05-20','10:50:00',7.86),('7643','2013-05-20','10:55:00',6.03),('7643','2013-05-20','11:00:00',7.51),('7643','2013-05-20','11:05:00',7.89),('7643','2013-05-20','11:10:00',11.91),('7643','2013-05-20','11:15:00',14.93),('7643','2013-05-20','11:20:00',11.56),('7643','2013-05-20','11:25:00',14.67),('7643','2013-05-20','11:30:00',10.27),('7643','2013-05-20','11:35:00',11.9),('7643','2013-05-20','11:40:00',11.45),('7643','2013-05-20','11:45:00',13),('7643','2013-05-20','11:50:00',9.3),('7643','2013-05-20','11:55:00',14.53),('7643','2013-05-20','12:00:00',13.56),('7643','2013-05-20','12:05:00',13.28),('7643','2013-05-20','12:10:00',10.76),('7643','2013-05-20','12:15:00',13.11),('7643','2013-05-20','12:20:00',8.94),('7643','2013-05-20','12:25:00',12.74),('7643','2013-05-20','12:30:00',14.71),('7643','2013-05-20','12:35:00',10.07),('7643','2013-05-20','12:40:00',15.21),('7643','2013-05-20','12:45:00',15.41),('7643','2013-05-20','12:50:00',9.23),('7643','2013-05-20','12:55:00',15.83),('7643','2013-05-20','13:00:00',15.31),('7643','2013-05-20','13:05:00',15.76),('7643','2013-05-20','13:10:00',10.37),('7643','2013-05-20','13:15:00',15.6),('7643','2013-05-20','13:20:00',12.86),('7643','2013-05-20','13:25:00',12.27),('7643','2013-05-20','13:30:00',11.87),('7643','2013-05-20','13:35:00',5.52),('7643','2013-05-20','13:40:00',3.29),('7643','2013-05-20','13:45:00',2.24),('7643','2013-05-20','13:50:00',1.5),('7643','2013-05-20','13:55:00',1.43),('7643','2013-05-20','14:00:00',2.42),('7643','2013-05-20','14:05:00',4.09),('7643','2013-05-20','14:10:00',6.43),('7643','2013-05-20','14:15:00',7.41),('7643','2013-05-20','14:20:00',6.67),('7643','2013-05-20','14:25:00',10.21),('7643','2013-05-20','14:30:00',8.4),('7643','2013-05-20','14:35:00',7.33),('7643','2013-05-20','14:40:00',7.19),('7643','2013-05-20','14:45:00',5.83),('7643','2013-05-20','14:50:00',3.81),('7643','2013-05-20','14:55:00',2.91),('7643','2013-05-20','15:00:00',1.72),('7643','2013-05-20','15:05:00',2.07),('7643','2013-05-20','15:10:00',2.38),('7643','2013-05-20','15:15:00',3.97),('7643','2013-05-20','15:20:00',5.53),('7643','2013-05-20','15:25:00',5.82),('7643','2013-05-20','15:30:00',8.05),('7643','2013-05-20','15:35:00',6.12),('7643','2013-05-20','15:40:00',4.82),('7643','2013-05-20','15:45:00',5.01),('7643','2013-05-20','15:50:00',4.54),('7643','2013-05-20','15:55:00',4.55),('7643','2013-05-20','16:00:00',4.56),('7643','2013-05-20','16:05:00',4.45),('7643','2013-05-20','16:10:00',4.79),('7643','2013-05-20','16:15:00',4.26),('7643','2013-05-20','16:20:00',3.5),('7643','2013-05-20','16:25:00',4.78),('7643','2013-05-20','16:30:00',6.19),('7643','2013-05-20','16:35:00',6.81),('7643','2013-05-20','16:40:00',7.65),('7643','2013-05-20','16:45:00',6.54),('7643','2013-05-20','16:50:00',4.1),('7643','2013-05-20','16:55:00',2.19),('7643','2013-05-20','17:00:00',2.51),('7643','2013-05-20','17:05:00',2.75),('7643','2013-05-20','17:10:00',2.28),('7643','2013-05-20','17:15:00',1.51),('7643','2013-05-19','06:45:00',1.04),('7643','2013-05-19','06:50:00',1.38),('7643','2013-05-19','06:55:00',1.76),('7643','2013-05-19','07:00:00',2.12),('7643','2013-05-19','07:05:00',2.3),('7643','2013-05-19','07:10:00',2.58),('7643','2013-05-19','07:15:00',2.83),('7643','2013-05-19','07:20:00',3.09),('7643','2013-05-19','07:25:00',3.07),('7643','2013-05-19','07:30:00',3.67),('7643','2013-05-19','07:35:00',4.12),('7643','2013-05-19','07:40:00',4.41),('7643','2013-05-19','07:45:00',4.74),('7643','2013-05-19','07:50:00',5.04),('7643','2013-05-19','07:55:00',5.39),('7643','2013-05-19','08:00:00',6.08),('7643','2013-05-19','08:05:00',4.53),('7643','2013-05-19','08:10:00',4.58),('7643','2013-05-19','08:15:00',4.7),('7643','2013-05-19','08:20:00',3.67),('7643','2013-05-19','08:25:00',4.26),('7643','2013-05-19','08:30:00',3.82),('7643','2013-05-19','08:35:00',2.47),('7643','2013-05-19','08:40:00',2.52),('7643','2013-05-19','08:45:00',6.32),('7643','2013-05-19','08:50:00',7.95),('7643','2013-05-19','08:55:00',11.32),('7643','2013-05-19','09:00:00',11.54),('7643','2013-05-19','09:05:00',12.15),('7643','2013-05-19','09:10:00',12.61),('7643','2013-05-19','09:15:00',8.87),('7643','2013-05-19','09:20:00',9.85),('7643','2013-05-19','09:25:00',4.29),('7643','2013-05-19','09:30:00',2.92),('7643','2013-05-19','09:35:00',8.12),('7643','2013-05-19','09:40:00',2.72),('7643','2013-05-19','09:45:00',2.28),('7643','2013-05-19','09:50:00',5.97),('7643','2013-05-19','09:55:00',2.86),('7643','2013-05-19','10:00:00',3.28),('7643','2013-05-19','10:05:00',5.23),('7643','2013-05-19','10:10:00',8.96),('7643','2013-05-19','10:15:00',3.67),('7643','2013-05-19','10:20:00',2.96),('7643','2013-05-19','10:25:00',4.17),('7643','2013-05-19','10:30:00',6.4),('7643','2013-05-19','10:35:00',6),('7643','2013-05-19','10:40:00',7.1),('7643','2013-05-19','10:45:00',4.33),('7643','2013-05-19','10:50:00',13.2),('7643','2013-05-19','10:55:00',12.26),('7643','2013-05-19','11:00:00',10.47),('7643','2013-05-19','11:05:00',13.6),('7643','2013-05-19','11:10:00',18.64),('7643','2013-05-19','11:15:00',18.1),('7643','2013-05-19','11:20:00',15.03),('7643','2013-05-19','11:25:00',12.13),('7643','2013-05-19','11:30:00',7.18),('7643','2013-05-19','11:35:00',12.85),('7643','2013-05-19','11:40:00',4.53),('7643','2013-05-19','11:45:00',6.48),('7643','2013-05-19','11:50:00',3.56),('7643','2013-05-19','11:55:00',13.09),('7643','2013-05-19','12:00:00',10.04),('7643','2013-05-19','12:05:00',10.3),('7643','2013-05-19','12:10:00',16.38),('7643','2013-05-19','12:15:00',6.42),('7643','2013-05-19','12:20:00',11.48),('7643','2013-05-19','12:25:00',12.33),('7643','2013-05-19','12:30:00',12.91),('7643','2013-05-19','12:35:00',5.78),('7643','2013-05-19','12:40:00',18.75),('7643','2013-05-19','12:45:00',18.99),('7643','2013-05-19','12:50:00',6.13),('7643','2013-05-19','12:55:00',7.49),('7643','2013-05-19','13:00:00',10.06),('7643','2013-05-19','13:05:00',12.84),('7643','2013-05-19','13:10:00',7.59),('7643','2013-05-19','13:15:00',4.86),('7643','2013-05-19','13:20:00',10.09),('7643','2013-05-19','13:25:00',13.33),('7643','2013-05-19','13:30:00',14.05),('7643','2013-05-19','13:35:00',12.37),('7643','2013-05-19','13:40:00',11.52),('7643','2013-05-19','13:45:00',7.92),('7643','2013-05-19','13:50:00',19.23),('7643','2013-05-19','13:55:00',16.09),('7643','2013-05-19','14:00:00',17.55),('7643','2013-05-19','14:05:00',7.11),('7643','2013-05-19','14:10:00',6.83),('7643','2013-05-19','14:15:00',19.16),('7643','2013-05-19','14:20:00',9.37),('7643','2013-05-19','14:25:00',9.24),('7643','2013-05-19','14:30:00',13.83),('7643','2013-05-19','14:35:00',5.56),('7643','2013-05-19','14:40:00',7.92),('7643','2013-05-19','14:45:00',7.69),('7643','2013-05-19','14:50:00',15.67),('7643','2013-05-19','14:55:00',8.05),('7643','2013-05-19','15:00:00',13.71),('7643','2013-05-19','15:05:00',6.48),('7643','2013-05-19','15:10:00',16.32),('7643','2013-05-19','15:15:00',10.14),('7643','2013-05-19','15:20:00',12.99),('7643','2013-05-19','15:25:00',10.37),('7643','2013-05-19','15:30:00',5.69),('7643','2013-05-19','15:35:00',16.31),('7643','2013-05-19','15:40:00',9.57),('7643','2013-05-19','15:45:00',5.2),('7643','2013-05-19','15:50:00',10.92),('7643','2013-05-19','15:55:00',6.34),('7643','2013-05-19','16:00:00',9.44),('7643','2013-05-19','16:05:00',9.76),('7643','2013-05-19','16:10:00',8.47),('7643','2013-05-19','16:15:00',10.21),('7643','2013-05-19','16:20:00',13.83),('7643','2013-05-19','16:25:00',13.31),('7643','2013-05-19','16:30:00',12.66),('7643','2013-05-19','16:35:00',11.96),('7643','2013-05-19','16:40:00',11.91),('7643','2013-05-19','16:45:00',11.02),('7643','2013-05-19','16:50:00',10.7),('7643','2013-05-19','16:55:00',10.29),('7643','2013-05-19','17:00:00',10.06),('7643','2013-05-19','17:05:00',10.2),('7643','2013-05-19','17:10:00',6.64),('7643','2013-05-19','17:15:00',5.11),('7643','2013-05-19','17:20:00',6.78),('7643','2013-05-19','17:25:00',8.75),('7643','2013-05-19','17:30:00',9.56),('7643','2013-05-19','17:35:00',7.82),('7643','2013-05-19','17:40:00',7.06),('7643','2013-05-19','17:45:00',6.69),('7643','2013-05-19','17:50:00',6.44),('7643','2013-05-19','17:55:00',6.13),('7643','2013-05-19','18:00:00',5.67),('7643','2013-05-19','18:05:00',6.24),('7643','2013-05-19','18:10:00',4.83),('7643','2013-05-19','18:15:00',5.55),('7643','2013-05-19','18:20:00',4.71),('7643','2013-05-19','18:25:00',4.15),('7643','2013-05-19','18:30:00',3.74),('7643','2013-05-19','18:35:00',3.39),('7643','2013-05-19','18:40:00',2.83),('7643','2013-05-19','18:45:00',2.63),('7643','2013-05-19','18:50:00',2.2),('7643','2013-05-19','18:55:00',1.94),('7643','2013-05-19','19:00:00',1.78),('7643','2013-05-19','19:05:00',1.59),('7643','2013-05-19','19:10:00',1.31),('7643','2013-05-19','19:15:00',1.1),('7643','2013-05-18','06:50:00',1.01),('7643','2013-05-18','06:55:00',1.23),('7643','2013-05-18','07:00:00',1.46),('7643','2013-05-18','07:05:00',1.54),('7643','2013-05-18','07:10:00',1.44),('7643','2013-05-18','07:15:00',1.37),('7643','2013-05-18','07:20:00',1.32),('7643','2013-05-18','07:25:00',1.17),('7643','2013-05-18','07:55:00',1.16),('7643','2013-05-18','08:05:00',1.8),('7643','2013-05-18','08:10:00',2.11),('7643','2013-05-18','08:15:00',2.59),('7643','2013-05-18','08:20:00',2.49),('7643','2013-05-18','08:25:00',2.24),('7643','2013-05-18','08:30:00',3.3),('7643','2013-05-18','08:40:00',3.28),('7643','2013-05-18','08:45:00',3.72),('7643','2013-05-18','08:50:00',4.34),('7643','2013-05-18','08:55:00',6.75),('7643','2013-05-18','09:00:00',5.45),('7643','2013-05-18','09:05:00',4.24),('7643','2013-05-18','09:10:00',4.71),('7643','2013-05-18','09:15:00',5.18),('7643','2013-05-18','09:20:00',4.06),('7643','2013-05-18','09:25:00',2.1),('7643','2013-05-18','09:30:00',2.38),('7643','2013-05-18','09:35:00',2.88),('7643','2013-05-18','09:40:00',3.76),('7643','2013-05-18','09:45:00',4.68),('7643','2013-05-18','09:50:00',3.31),('7643','2013-05-18','09:55:00',3.58),('7643','2013-05-18','10:00:00',5.84),('7643','2013-05-18','10:05:00',6.2),('7643','2013-05-18','10:10:00',7.96),('7643','2013-05-18','10:15:00',12.64),('7643','2013-05-18','10:20:00',9.19),('7643','2013-05-18','10:25:00',12),('7643','2013-05-18','10:30:00',12.79),('7643','2013-05-18','10:35:00',6.9),('7643','2013-05-18','10:40:00',11.74),('7643','2013-05-18','10:45:00',10.65),('7643','2013-05-18','10:50:00',6.53),('7643','2013-05-18','10:55:00',7.23),('7643','2013-05-18','11:00:00',7.82),('7643','2013-05-18','11:05:00',13.94),('7643','2013-05-18','11:10:00',9.77),('7643','2013-05-18','11:15:00',14.23),('7643','2013-05-18','11:20:00',17.07),('7643','2013-05-18','11:25:00',17.21),('7643','2013-05-18','11:30:00',17.13),('7643','2013-05-18','11:35:00',17.19),('7643','2013-05-18','11:40:00',17.75),('7643','2013-05-18','11:45:00',17.77),('7643','2013-05-18','11:50:00',17.62),('7643','2013-05-18','11:55:00',17.96),('7643','2013-05-18','12:00:00',17.95),('7643','2013-05-18','12:05:00',17.82),('7643','2013-05-18','12:10:00',17.9),('7643','2013-05-18','12:15:00',17.98),('7643','2013-05-18','12:20:00',18.81),('7643','2013-05-18','12:25:00',18.27),('7643','2013-05-18','12:30:00',15.51),('7643','2013-05-18','12:35:00',18.56),('7643','2013-05-18','12:40:00',18.67),('7643','2013-05-18','12:45:00',17.78),('7643','2013-05-18','12:50:00',12.91),('7643','2013-05-18','12:55:00',10.2),('7643','2013-05-18','13:00:00',14.58),('7643','2013-05-18','13:05:00',14.1),('7643','2013-05-18','13:10:00',14.16),('7643','2013-05-18','13:15:00',13.59),('7643','2013-05-18','13:20:00',17.05),('7643','2013-05-18','13:25:00',16.23),('7643','2013-05-18','13:30:00',17.92),('7643','2013-05-18','13:35:00',17.58),('7643','2013-05-18','13:40:00',17.56),('7643','2013-05-18','13:45:00',17.59),('7643','2013-05-18','13:50:00',17.52),('7643','2013-05-18','13:55:00',17.42),('7643','2013-05-18','14:00:00',17.38),('7643','2013-05-18','14:05:00',17.31),('7643','2013-05-18','14:10:00',17.29),('7643','2013-05-18','14:15:00',17.23),('7643','2013-05-18','14:20:00',17.12),('7643','2013-05-18','14:25:00',17.05),('7643','2013-05-18','14:30:00',16.84),('7643','2013-05-18','14:35:00',16.67),('7643','2013-05-18','14:40:00',16.51),('7643','2013-05-18','14:45:00',16.48),('7643','2013-05-18','14:50:00',16.39),('7643','2013-05-18','14:55:00',16.26),('7643','2013-05-18','15:00:00',16.14),('7643','2013-05-18','15:05:00',15.97),('7643','2013-05-18','15:10:00',15.73),('7643','2013-05-18','15:15:00',15.61),('7643','2013-05-18','15:20:00',15.36),('7643','2013-05-18','15:25:00',15.29),('7643','2013-05-18','15:30:00',15.12),('7643','2013-05-18','15:35:00',14.86),('7643','2013-05-18','15:40:00',14.49),('7643','2013-05-18','15:45:00',14.28),('7643','2013-05-18','15:50:00',14.26),('7643','2013-05-18','15:55:00',13.96),('7643','2013-05-18','16:00:00',13.71),('7643','2013-05-18','16:05:00',13.51),('7643','2013-05-18','16:10:00',13.26),('7643','2013-05-18','16:15:00',13.01),('7643','2013-05-18','16:20:00',12.65),('7643','2013-05-18','16:25:00',12.44),('7643','2013-05-18','16:30:00',12.09),('7643','2013-05-18','16:35:00',11.87),('7643','2013-05-18','16:40:00',11.56),('7643','2013-05-18','16:45:00',11.27),('7643','2013-05-18','16:50:00',10.97),('7643','2013-05-18','16:55:00',10.65),('7643','2013-05-18','17:00:00',10.43),('7643','2013-05-18','17:05:00',10.06),('7643','2013-05-18','17:10:00',9.7),('7643','2013-05-18','17:15:00',9.29),('7643','2013-05-18','17:20:00',9),('7643','2013-05-18','17:25:00',8.58),('7643','2013-05-18','17:30:00',8.16),('7643','2013-05-18','17:35:00',7.88),('7643','2013-05-18','17:40:00',7.4),('7643','2013-05-18','17:45:00',6.98),('7643','2013-05-18','17:50:00',6.84),('7643','2013-05-18','17:55:00',6.48),('7643','2013-05-18','18:00:00',6.1),('7643','2013-05-18','18:05:00',5.78),('7643','2013-05-18','18:10:00',5.4),('7643','2013-05-18','18:15:00',5.03),('7643','2013-05-18','18:20:00',4.68),('7643','2013-05-18','18:25:00',4.36),('7643','2013-05-18','18:30:00',3.98),('7643','2013-05-18','18:35:00',3.65),('7643','2013-05-18','18:40:00',3.22),('7643','2013-05-18','18:45:00',2.75),('7643','2013-05-18','18:50:00',2.47),('7643','2013-05-18','18:55:00',2.14),('7643','2013-05-18','19:00:00',1.79),('7643','2013-05-18','19:05:00',1.6),('7643','2013-05-18','19:10:00',1.27),('7643','2013-05-18','19:15:00',1.04),('7643','2013-05-17','06:45:00',1.08),('7643','2013-05-17','06:50:00',1.27),('7643','2013-05-17','06:55:00',1.48),('7643','2013-05-17','07:00:00',1.75),('7643','2013-05-17','07:05:00',2.02),('7643','2013-05-17','07:10:00',2.32),('7643','2013-05-17','07:15:00',2.64),('7643','2013-05-17','07:20:00',2.94),('7643','2013-05-17','07:25:00',3.27),('7643','2013-05-17','07:30:00',3.65),('7643','2013-05-17','07:35:00',4.03),('7643','2013-05-17','07:40:00',4.53),('7643','2013-05-17','07:45:00',4.73),('7643','2013-05-17','07:50:00',4.7),('7643','2013-05-17','07:55:00',7.06),('7643','2013-05-17','08:00:00',7.68),('7643','2013-05-17','08:05:00',7.27),('7643','2013-05-17','08:10:00',3.75),('7643','2013-05-17','08:15:00',3.63),('7643','2013-05-17','08:20:00',4.64),('7643','2013-05-17','08:25:00',9.63),('7643','2013-05-17','08:30:00',8.72),('7643','2013-05-17','08:35:00',6.92),('7643','2013-05-17','08:40:00',8.74),('7643','2013-05-17','08:45:00',8.78),('7643','2013-05-17','08:50:00',9.09),('7643','2013-05-17','08:55:00',9.4),('7643','2013-05-17','09:00:00',9.73),('7643','2013-05-17','09:05:00',9.92),('7643','2013-05-17','09:10:00',10.37),('7643','2013-05-17','09:15:00',10.65),('7643','2013-05-17','09:20:00',10.89),('7643','2013-05-17','09:25:00',11.08),('7643','2013-05-17','09:30:00',11.36),('7643','2013-05-17','09:35:00',11.6),('7643','2013-05-17','09:40:00',11.81),('7643','2013-05-17','09:45:00',12.03),('7643','2013-05-17','09:50:00',12.2),('7643','2013-05-17','09:55:00',12.49),('7643','2013-05-17','10:00:00',12.65),('7643','2013-05-17','10:05:00',12.82),('7643','2013-05-17','10:10:00',13.08),('7643','2013-05-17','10:15:00',13.35),('7643','2013-05-17','10:20:00',13.47),('7643','2013-05-17','10:25:00',13.6),('7643','2013-05-17','10:30:00',13.86),('7643','2013-05-17','10:35:00',13.88),('7643','2013-05-17','10:40:00',14.11),('7643','2013-05-17','10:45:00',14.38),('7643','2013-05-17','10:50:00',14.49),('7643','2013-05-17','10:55:00',14.85),('7643','2013-05-17','11:00:00',15.56),('7643','2013-05-17','11:05:00',15.25),('7643','2013-05-17','11:10:00',12.54),('7643','2013-05-17','11:15:00',15.84),('7643','2013-05-17','11:20:00',16.12),('7643','2013-05-17','11:25:00',15.22),('7643','2013-05-17','11:30:00',15.78),('7643','2013-05-17','11:35:00',15.17),('7643','2013-05-17','11:40:00',15.52),('7643','2013-05-17','11:45:00',15.48),('7643','2013-05-17','11:50:00',15.34),('7643','2013-05-17','11:55:00',15.81),('7643','2013-05-17','12:00:00',16.54),('7643','2013-05-17','12:05:00',15.65),('7643','2013-05-17','12:10:00',15.65),('7643','2013-05-17','12:15:00',15.74),('7643','2013-05-17','12:20:00',15.85),('7643','2013-05-17','12:25:00',15.94),('7643','2013-05-17','12:30:00',12.32),('7643','2013-05-17','12:35:00',16.28),('7643','2013-05-17','12:40:00',16.08),('7643','2013-05-17','12:45:00',15.31),('7643','2013-05-17','12:50:00',16.06),('7643','2013-05-17','12:55:00',15.96),('7643','2013-05-17','13:00:00',15.78),('7643','2013-05-17','13:05:00',15.77),('7643','2013-05-17','13:10:00',15.93),('7643','2013-05-17','13:15:00',15.94),('7643','2013-05-17','13:20:00',15.91),('7643','2013-05-17','13:25:00',16.03),('7643','2013-05-17','13:30:00',16.15),('7643','2013-05-17','13:35:00',15.07),('7643','2013-05-17','13:40:00',16.36),('7643','2013-05-17','13:45:00',17.01),('7643','2013-05-17','13:50:00',13.46),('7643','2013-05-17','13:55:00',12.99),('7643','2013-05-17','14:00:00',13.95),('7643','2013-05-17','14:05:00',13.26),('7643','2013-05-17','14:10:00',17.07),('7643','2013-05-17','14:15:00',16.46),('7643','2013-05-17','14:20:00',15.98),('7643','2013-05-17','14:25:00',15.63),('7643','2013-05-17','14:30:00',15.82),('7643','2013-05-17','14:35:00',14.4),('7643','2013-05-17','14:40:00',16.17),('7643','2013-05-17','14:45:00',15.42),('7643','2013-05-17','14:50:00',12.83),('7643','2013-05-17','14:55:00',13.36),('7643','2013-05-17','15:00:00',13.86),('7643','2013-05-17','15:05:00',13.92),('7643','2013-05-17','15:10:00',13.6),('7643','2013-05-17','15:15:00',13.32),('7643','2013-05-17','15:20:00',12.99),('7643','2013-05-17','15:25:00',12.78),('7643','2013-05-17','15:30:00',12.67),('7643','2013-05-17','15:35:00',12.53),('7643','2013-05-17','15:40:00',12.3),('7643','2013-05-17','15:45:00',11.99),('7643','2013-05-17','15:50:00',11.86),('7643','2013-05-17','15:55:00',11.61),('7643','2013-05-17','16:00:00',11.48),('7643','2013-05-17','16:05:00',11.31),('7643','2013-05-17','16:10:00',10.97),('7643','2013-05-17','16:15:00',10.69),('7643','2013-05-17','16:20:00',10.49),('7643','2013-05-17','16:25:00',10.26),('7643','2013-05-17','16:30:00',9.98),('7643','2013-05-17','16:35:00',9.73),('7643','2013-05-17','16:40:00',9.44),('7643','2013-05-17','16:45:00',9.19),('7643','2013-05-17','16:50:00',8.84),('7643','2013-05-17','16:55:00',8.61),('7643','2013-05-17','17:00:00',8.32),('7643','2013-05-17','17:05:00',8.01),('7643','2013-05-17','17:10:00',7.78),('7643','2013-05-17','17:15:00',7.48),('7643','2013-05-17','17:20:00',7.2),('7643','2013-05-17','17:25:00',6.89),('7643','2013-05-17','17:30:00',6.54),('7643','2013-05-17','17:35:00',6.2),('7643','2013-05-17','17:40:00',5.9),('7643','2013-05-17','17:45:00',5.65),('7643','2013-05-17','17:50:00',5.43),('7643','2013-05-17','17:55:00',5.17),('7643','2013-05-17','18:00:00',4.83),('7643','2013-05-17','18:05:00',4.51),('7643','2013-05-17','18:10:00',4.27),('7643','2013-05-17','18:15:00',3.97),('7643','2013-05-17','18:20:00',3.68),('7643','2013-05-17','18:25:00',3.39),('7643','2013-05-17','18:30:00',3.15),('7643','2013-05-17','18:35:00',2.9),('7643','2013-05-17','18:40:00',2.64),('7643','2013-05-17','18:45:00',2.38),('7643','2013-05-17','18:50:00',2.13),('7643','2013-05-17','18:55:00',1.91),('7643','2013-05-17','19:00:00',1.72),('7643','2013-05-17','19:05:00',1.55),('7643','2013-05-17','19:10:00',1.38),('7643','2013-05-17','19:15:00',1.21),('7643','2013-05-17','19:20:00',1.05),('7643','2013-05-16','07:00:00',1.07),('7643','2013-05-16','07:05:00',2.37),('7643','2013-05-16','07:10:00',2.7),('7643','2013-05-16','07:15:00',2.24),('7643','2013-05-16','07:20:00',3.03),('7643','2013-05-16','07:25:00',3.06),('7643','2013-05-16','07:30:00',2.38),('7643','2013-05-16','07:35:00',1.79),('7643','2013-05-16','07:40:00',4.08),('7643','2013-05-16','07:45:00',3.73),('7643','2013-05-16','07:50:00',3.42),('7643','2013-05-16','07:55:00',3.64),('7643','2013-05-16','08:00:00',4.86),('7643','2013-05-16','08:05:00',3.26),('7643','2013-05-16','08:10:00',3.04),('7643','2013-05-16','08:15:00',5.84),('7643','2013-05-16','08:20:00',7.9),('7643','2013-05-16','08:25:00',5.5),('7643','2013-05-16','08:30:00',3.6),('7643','2013-05-16','08:35:00',2.31),('7643','2013-05-16','08:40:00',1.27),('7643','2013-05-16','09:00:00',1.49),('7643','2013-05-16','09:05:00',2.32),('7643','2013-05-16','09:10:00',2.67),('7643','2013-05-16','09:15:00',2.32),('7643','2013-05-16','09:20:00',2.96),('7643','2013-05-16','09:25:00',4.32),('7643','2013-05-16','09:30:00',1.56),('7643','2013-05-16','09:35:00',1.31),('7643','2013-05-16','10:05:00',1.38),('7643','2013-05-16','10:10:00',1.71),('7643','2013-05-16','10:15:00',2.47),('7643','2013-05-16','10:20:00',3.23),('7643','2013-05-16','10:25:00',4.72),('7643','2013-05-16','10:30:00',5.94),('7643','2013-05-16','10:35:00',5),('7643','2013-05-16','10:40:00',5.64),('7643','2013-05-16','10:45:00',5.97),('7643','2013-05-16','10:50:00',10.06),('7643','2013-05-16','10:55:00',11.51),('7643','2013-05-16','11:00:00',8.49),('7643','2013-05-16','11:05:00',8.23),('7643','2013-05-16','11:10:00',5.46),('7643','2013-05-16','11:15:00',7.01),('7643','2013-05-16','11:20:00',7.65),('7643','2013-05-16','11:25:00',6.33),('7643','2013-05-16','11:30:00',8.72),('7643','2013-05-16','11:35:00',12.8),('7643','2013-05-16','11:40:00',6.5),('7643','2013-05-16','11:45:00',6.08),('7643','2013-05-16','11:50:00',7.54),('7643','2013-05-16','11:55:00',8.23),('7643','2013-05-16','12:00:00',6.63),('7643','2013-05-16','12:05:00',10.97),('7643','2013-05-16','12:10:00',12.06),('7643','2013-05-16','12:15:00',11.83),('7643','2013-05-16','12:20:00',9.34),('7643','2013-05-16','12:25:00',14.3),('7643','2013-05-16','12:30:00',10.32),('7643','2013-05-16','12:35:00',11.67),('7643','2013-05-16','12:40:00',18.51),('7643','2013-05-16','12:45:00',14.74),('7643','2013-05-16','12:50:00',18.14),('7643','2013-05-16','12:55:00',17.19),('7643','2013-05-16','13:00:00',14.53),('7643','2013-05-16','13:05:00',16.09),('7643','2013-05-16','13:10:00',12.84),('7643','2013-05-16','13:15:00',17.67),('7643','2013-05-16','13:20:00',17.48),('7643','2013-05-16','13:25:00',16.43),('7643','2013-05-16','13:30:00',11.5),('7643','2013-05-16','13:35:00',15.36),('7643','2013-05-16','13:40:00',15.36),('7643','2013-05-16','13:45:00',17.72),('7643','2013-05-16','13:50:00',17.12),('7643','2013-05-16','13:55:00',15.36),('7643','2013-05-16','14:00:00',15.92),('7643','2013-05-16','14:05:00',11.96),('7643','2013-05-16','14:10:00',14.35),('7643','2013-05-16','14:15:00',16.81),('7643','2013-05-16','14:20:00',17.72),('7643','2013-05-16','14:25:00',14.47),('7643','2013-05-16','14:30:00',14.66),('7643','2013-05-16','14:35:00',14.29),('7643','2013-05-16','14:40:00',10.58),('7643','2013-05-16','14:45:00',16.16),('7643','2013-05-16','14:50:00',10.43),('7643','2013-05-16','14:55:00',14.03),('7643','2013-05-16','15:00:00',11.45),('7643','2013-05-16','15:05:00',12.85),('7643','2013-05-16','15:10:00',7.91),('7643','2013-05-16','15:15:00',12.31),('7643','2013-05-16','15:20:00',9.55),('7643','2013-05-16','15:25:00',12.67),('7643','2013-05-16','15:30:00',10.77),('7643','2013-05-16','15:35:00',14.51),('7643','2013-05-16','15:40:00',15.52),('7643','2013-05-16','15:45:00',6.37),('7643','2013-05-16','15:50:00',9.09),('7643','2013-05-16','15:55:00',12.78),('7643','2013-05-16','16:00:00',6.68),('7643','2013-05-16','16:05:00',5.68),('7643','2013-05-16','16:10:00',8.15),('7643','2013-05-16','16:15:00',12.35),('7643','2013-05-16','16:20:00',12.67),('7643','2013-05-16','16:25:00',12.45),('7643','2013-05-16','16:30:00',11.38),('7643','2013-05-16','16:35:00',12.83),('7643','2013-05-16','16:40:00',13.22),('7643','2013-05-16','16:45:00',11.83),('7643','2013-05-16','16:50:00',10.86),('7643','2013-05-16','16:55:00',10.16),('7643','2013-05-16','17:00:00',9.89),('7643','2013-05-16','17:05:00',9.59),('7643','2013-05-16','17:10:00',9.31),('7643','2013-05-16','17:15:00',8.9),('7643','2013-05-16','17:20:00',8.55),('7643','2013-05-16','17:25:00',8.25),('7643','2013-05-16','17:30:00',7.82),('7643','2013-05-16','17:35:00',7.46),('7643','2013-05-16','17:40:00',7.23),('7643','2013-05-16','17:45:00',6.88),('7643','2013-05-16','17:50:00',6.55),('7643','2013-05-16','17:55:00',6.26),('7643','2013-05-16','18:00:00',5.95),('7643','2013-05-16','18:05:00',5.53),('7643','2013-05-16','18:10:00',5.16),('7643','2013-05-16','18:15:00',4.76),('7643','2013-05-16','18:20:00',4.46),('7643','2013-05-16','18:25:00',4.16),('7643','2013-05-16','18:30:00',3.79),('7643','2013-05-16','18:35:00',3.46),('7643','2013-05-16','18:40:00',3.03),('7643','2013-05-16','18:45:00',2.62),('7643','2013-05-16','18:50:00',2.3),('7643','2013-05-16','18:55:00',2.1),('7643','2013-05-16','19:00:00',1.17),('7643','2013-05-16','19:05:00',1.39),('7643','2013-05-15','09:10:00',1.69),('7643','2013-05-15','09:15:00',3.3),('7643','2013-05-15','09:20:00',4.19),('7643','2013-05-15','09:25:00',6.11),('7643','2013-05-15','09:30:00',5.98),('7643','2013-05-15','09:35:00',7.22),('7643','2013-05-15','09:40:00',8.24),('7643','2013-05-15','09:45:00',9.77),('7643','2013-05-15','09:50:00',4.67),('7643','2013-05-15','09:55:00',4.84),('7643','2013-05-15','10:00:00',5.95),('7643','2013-05-15','10:05:00',4.92),('7643','2013-05-15','10:10:00',4.57),('7643','2013-05-15','10:15:00',5.99),('7643','2013-05-15','10:20:00',8.16),('7643','2013-05-15','10:25:00',10.1),('7643','2013-05-15','10:30:00',7.58),('7643','2013-05-15','10:35:00',5.37),('7643','2013-05-15','10:40:00',5.28),('7643','2013-05-15','10:45:00',4.83),('7643','2013-05-15','10:50:00',5.76),('7643','2013-05-15','10:55:00',7.65),('7643','2013-05-15','11:00:00',15.76),('7643','2013-05-15','11:05:00',13),('7643','2013-05-15','11:10:00',11.12),('7643','2013-05-15','11:15:00',6.08),('7643','2013-05-15','11:20:00',3.98),('7643','2013-05-15','11:25:00',4.62),('7643','2013-05-15','11:30:00',5.61),('7643','2013-05-15','11:35:00',8.71),('7643','2013-05-15','11:40:00',15.34),('7643','2013-05-15','11:45:00',13.43),('7643','2013-05-15','11:50:00',11.46),('7643','2013-05-15','11:55:00',8.03),('7643','2013-05-15','12:00:00',6.58),('7643','2013-05-15','12:05:00',6.24),('7643','2013-05-15','12:10:00',6.6),('7643','2013-05-15','12:15:00',10.68),('7643','2013-05-15','12:20:00',7.28),('7643','2013-05-15','12:25:00',8.67),('7643','2013-05-15','12:30:00',12.12),('7643','2013-05-15','12:35:00',13.81),('7643','2013-05-15','12:40:00',12.08),('7643','2013-05-15','12:45:00',12.5),('7643','2013-05-15','12:50:00',10.55),('7643','2013-05-15','12:55:00',17.31),('7643','2013-05-15','13:00:00',15.09),('7643','2013-05-15','13:05:00',14.52),('7643','2013-05-15','13:10:00',15.83),('7643','2013-05-15','13:15:00',14.61),('7643','2013-05-15','13:20:00',16.27),('7643','2013-05-15','13:25:00',15.81),('7643','2013-05-15','13:30:00',15.54),('7643','2013-05-15','13:35:00',15.47),('7643','2013-05-15','13:40:00',15.27),('7643','2013-05-15','13:45:00',15.21),('7643','2013-05-15','13:50:00',15.09),('7643','2013-05-15','13:55:00',15.21),('7643','2013-05-15','14:00:00',15.11),('7643','2013-05-15','14:05:00',14.98),('7643','2013-05-15','14:10:00',14.78),('7643','2013-05-15','14:15:00',14.66),('7643','2013-05-15','14:20:00',14.72),('7643','2013-05-15','14:25:00',14.26),('7643','2013-05-15','14:30:00',14.2),('7643','2013-05-15','14:35:00',13.93),('7643','2013-05-15','14:40:00',13.89),('7643','2013-05-15','14:45:00',13.78),('7643','2013-05-15','14:50:00',13.14),('7643','2013-05-15','14:55:00',11.8),('7643','2013-05-15','15:00:00',13.29),('7643','2013-05-15','15:05:00',13.34),('7643','2013-05-15','15:10:00',13.38),('7643','2013-05-15','15:15:00',11.8),('7643','2013-05-15','15:20:00',12.68),('7643','2013-05-15','15:25:00',12.68),('7643','2013-05-15','15:30:00',12.31),('7643','2013-05-15','15:35:00',11.9),('7643','2013-05-15','15:40:00',12.19),('7643','2013-05-15','15:45:00',11.74),('7643','2013-05-15','15:50:00',11.66),('7643','2013-05-15','15:55:00',11.64),('7643','2013-05-15','16:00:00',11.48),('7643','2013-05-15','16:05:00',10.91),('7643','2013-05-15','16:10:00',10.92),('7643','2013-05-15','16:15:00',10.11),('7643','2013-05-15','16:20:00',10.67),('7643','2013-05-15','16:25:00',10.2),('7643','2013-05-15','16:30:00',10.12),('7643','2013-05-15','16:35:00',9.53),('7643','2013-05-15','16:40:00',5.91),('7643','2013-05-15','16:45:00',5.36),('7643','2013-05-15','16:50:00',7.88),('7643','2013-05-15','16:55:00',5.41),('7643','2013-05-15','17:00:00',5.28),('7643','2013-05-15','17:05:00',3.23),('7643','2013-05-15','17:10:00',3.05),('7643','2013-05-15','17:15:00',4.36),('7643','2013-05-15','17:20:00',5.25),('7643','2013-05-15','17:25:00',5.12),('7643','2013-05-15','17:30:00',6.67),('7643','2013-05-15','17:35:00',6.82),('7643','2013-05-15','17:40:00',5.31),('7643','2013-05-15','17:45:00',3.68),('7643','2013-05-15','17:50:00',2.29),('7643','2013-05-15','17:55:00',1.49),('7643','2013-05-15','18:00:00',1.35),('7643','2013-05-15','18:05:00',1.53),('7643','2013-05-15','18:10:00',1.58),('7643','2013-05-15','18:15:00',1.63),('7643','2013-05-15','18:20:00',1.84),('7643','2013-05-15','18:25:00',2.03),('7643','2013-05-15','18:30:00',2.35),('7643','2013-05-15','18:35:00',2.64),('7643','2013-05-15','18:40:00',2.65),('7643','2013-05-15','18:45:00',2.99),('7643','2013-05-15','18:50:00',3.25),('7643','2013-05-15','18:55:00',3.3),('7643','2013-05-15','19:00:00',3.5),('7643','2013-05-15','19:05:00',3.38),('7643','2013-05-15','19:10:00',2.79),('7643','2013-05-15','19:15:00',2.34),('7643','2013-05-15','19:20:00',2),('7643','2013-05-15','19:25:00',1.56),('7643','2013-05-15','19:30:00',1.18),('7643','2013-05-14','06:55:00',1.37),('7643','2013-05-14','07:00:00',1.52),('7643','2013-05-14','07:05:00',1.49),('7643','2013-05-14','07:10:00',2.22),('7643','2013-05-14','07:15:00',2.56),('7643','2013-05-14','07:20:00',2.89),('7643','2013-05-14','07:25:00',3.31),('7643','2013-05-14','07:30:00',3.75),('7643','2013-05-14','07:35:00',4.1),('7643','2013-05-14','07:40:00',4.47),('7643','2013-05-14','07:45:00',5.09),('7643','2013-05-14','07:50:00',5.28),('7643','2013-05-14','07:55:00',5.01),('7643','2013-05-14','08:00:00',5.33),('7643','2013-05-14','08:05:00',5.19),('7643','2013-05-14','08:10:00',6.08),('7643','2013-05-14','08:15:00',6.58),('7643','2013-05-14','08:20:00',6.68),('7643','2013-05-14','08:25:00',7),('7643','2013-05-14','08:30:00',7.25),('7643','2013-05-14','08:35:00',7.83),('7643','2013-05-14','08:40:00',8.27),('7643','2013-05-14','08:45:00',8.62),('7643','2013-05-14','08:50:00',8.95),('7643','2013-05-14','08:55:00',9.22),('7643','2013-05-14','09:00:00',8.9),('7643','2013-05-14','09:05:00',9.61),('7643','2013-05-14','09:10:00',9.57),('7643','2013-05-14','09:15:00',9.86),('7643','2013-05-14','09:20:00',9.86),('7643','2013-05-14','09:25:00',8.08),('7643','2013-05-14','09:30:00',10.92),('7643','2013-05-14','09:35:00',11.12),('7643','2013-05-14','09:40:00',11.12),('7643','2013-05-14','09:45:00',11.45),('7643','2013-05-14','09:50:00',11.77),('7643','2013-05-14','09:55:00',11.88),('7643','2013-05-14','10:00:00',12.23),('7643','2013-05-14','10:05:00',12.55),('7643','2013-05-14','10:10:00',12.85),('7643','2013-05-14','10:15:00',12.6),('7643','2013-05-14','10:20:00',13.23),('7643','2013-05-14','10:25:00',13.49),('7643','2013-05-14','10:30:00',12.98),('7643','2013-05-14','10:35:00',13.49),('7643','2013-05-14','10:40:00',14.02),('7643','2013-05-14','10:45:00',14.13),('7643','2013-05-14','10:50:00',14.11),('7643','2013-05-14','10:55:00',13.58),('7643','2013-05-14','11:00:00',13.89),('7643','2013-05-14','11:05:00',14.56),('7643','2013-05-14','11:10:00',14.68),('7643','2013-05-14','11:15:00',15.06),('7643','2013-05-14','11:20:00',14.22),('7643','2013-05-14','11:25:00',14.76),('7643','2013-05-14','11:30:00',15.7),('7643','2013-05-14','11:35:00',14.47),('7643','2013-05-14','11:40:00',12.16),('7643','2013-05-14','11:45:00',11.44),('7643','2013-05-14','11:50:00',10.23),('7643','2013-05-14','11:55:00',7.36),('7643','2013-05-14','12:00:00',7.77),('7643','2013-05-14','12:05:00',13.58),('7643','2013-05-14','12:10:00',17.68),('7643','2013-05-14','12:15:00',16.14),('7643','2013-05-14','12:20:00',10.57),('7643','2013-05-14','12:25:00',13.11),('7643','2013-05-14','12:30:00',10.88),('7643','2013-05-14','12:35:00',10.9),('7643','2013-05-14','12:40:00',17.74),('7643','2013-05-14','12:45:00',9.35),('7643','2013-05-14','12:50:00',9.31),('7643','2013-05-14','12:55:00',10.81),('7643','2013-05-14','13:00:00',10.78),('7643','2013-05-14','13:05:00',12.43),('7643','2013-05-14','13:10:00',11.37),('7643','2013-05-14','13:15:00',8.8),('7643','2013-05-14','13:20:00',10.56),('7643','2013-05-14','13:25:00',10.15),('7643','2013-05-14','13:30:00',11.17),('7643','2013-05-14','13:35:00',9.26),('7643','2013-05-14','13:40:00',9.97),('7643','2013-05-14','13:45:00',9.58),('7643','2013-05-14','13:50:00',8.08),('7643','2013-05-14','13:55:00',7.72),('7643','2013-05-14','14:00:00',6.65),('7643','2013-05-14','14:05:00',5.82),('7643','2013-05-14','14:10:00',6.06),('7643','2013-05-14','14:15:00',6.09),('7643','2013-05-14','14:20:00',6.28),('7643','2013-05-14','14:25:00',6.08),('7643','2013-05-14','14:30:00',5.39),('7643','2013-05-14','14:35:00',5.29),('7643','2013-05-14','14:40:00',5.72),('7643','2013-05-14','14:45:00',5.45),('7643','2013-05-14','14:50:00',5.49),('7643','2013-05-14','14:55:00',5.54),('7643','2013-05-14','15:00:00',5.38),('7643','2013-05-14','15:05:00',4.19),('7643','2013-05-14','15:10:00',3.26),('7643','2013-05-14','15:15:00',3.12),('7643','2013-05-14','15:20:00',2.95),('7643','2013-05-14','15:25:00',2.66),('7643','2013-05-14','15:30:00',2.84),('7643','2013-05-14','15:35:00',2.8),('7643','2013-05-14','15:40:00',3.04),('7643','2013-05-14','15:45:00',4),('7643','2013-05-14','15:50:00',5.52),('7643','2013-05-14','15:55:00',7.12),('7643','2013-05-14','16:00:00',7.06),('7643','2013-05-14','16:05:00',6.59),('7643','2013-05-14','16:10:00',5.89),('7643','2013-05-14','16:15:00',5.16),('7643','2013-05-14','16:20:00',5.69),('7643','2013-05-14','16:25:00',5.85),('7643','2013-05-14','16:30:00',5.32),('7643','2013-05-14','16:35:00',4.87),('7643','2013-05-14','16:40:00',4.49),('7643','2013-05-14','16:45:00',4.33),('7643','2013-05-14','16:50:00',4.36),('7643','2013-05-14','16:55:00',5.02),('7643','2013-05-14','17:00:00',5.95),('7643','2013-05-14','17:05:00',7.16),('7643','2013-05-14','17:10:00',6.8),('7643','2013-05-14','17:15:00',9.84),('7643','2013-05-14','17:20:00',6.85),('7643','2013-05-14','17:25:00',3.28),('7643','2013-05-14','17:30:00',3.43),('7643','2013-05-14','17:35:00',3.1),('7643','2013-05-14','17:40:00',2.84),('7643','2013-05-14','17:45:00',3),('7643','2013-05-14','17:50:00',3.1),('7643','2013-05-14','17:55:00',3.03),('7643','2013-05-14','18:00:00',2.76),('7643','2013-05-14','18:05:00',2.23),('7643','2013-05-14','18:10:00',1.63),('7643','2013-05-14','18:15:00',1.48),('7643','2013-05-14','18:20:00',1.63),('7643','2013-05-14','18:25:00',1.81),('7643','2013-05-14','18:30:00',1.62),('7643','2013-05-14','18:45:00',1.15),('7643','2013-05-14','18:50:00',1.07),('7643','2013-05-14','18:55:00',1),('7643','2013-05-14','19:10:00',1.22),('7643','2013-05-14','19:15:00',1.01),('7643','2013-05-13','06:50:00',1.13),('7643','2013-05-13','06:55:00',1.37),('7643','2013-05-13','07:00:00',1.65),('7643','2013-05-13','07:05:00',1.96),('7643','2013-05-13','07:10:00',2.29),('7643','2013-05-13','07:15:00',2.61),('7643','2013-05-13','07:20:00',2.92),('7643','2013-05-13','07:25:00',3.31),('7643','2013-05-13','07:30:00',3.66),('7643','2013-05-13','07:35:00',3.99),('7643','2013-05-13','07:40:00',4.34),('7643','2013-05-13','07:45:00',4.7),('7643','2013-05-13','07:50:00',5.12),('7643','2013-05-13','07:55:00',5.5),('7643','2013-05-13','08:00:00',5.89),('7643','2013-05-13','08:05:00',6.24),('7643','2013-05-13','08:10:00',6.61),('7643','2013-05-13','08:15:00',7.02),('7643','2013-05-13','08:20:00',7.25),('7643','2013-05-13','08:25:00',7.64),('7643','2013-05-13','08:30:00',8.08),('7643','2013-05-13','08:35:00',8.45),('7643','2013-05-13','08:40:00',8.79),('7643','2013-05-13','08:45:00',9.07),('7643','2013-05-13','08:50:00',9.37),('7643','2013-05-13','08:55:00',9.64),('7643','2013-05-13','09:00:00',9.93),('7643','2013-05-13','09:05:00',10.18),('7643','2013-05-13','09:10:00',10.49),('7643','2013-05-13','09:15:00',10.78),('7643','2013-05-13','09:20:00',11.08),('7643','2013-05-13','09:25:00',11.32),('7643','2013-05-13','09:30:00',11.56),('7643','2013-05-13','09:35:00',11.83),('7643','2013-05-13','09:40:00',12.07),('7643','2013-05-13','09:45:00',12.28),('7643','2013-05-13','09:50:00',12.52),('7643','2013-05-13','09:55:00',12.82),('7643','2013-05-13','10:00:00',13.06),('7643','2013-05-13','10:05:00',13.29),('7643','2013-05-13','10:10:00',13.51),('7643','2013-05-13','10:15:00',13.59),('7643','2013-05-13','10:20:00',13.9),('7643','2013-05-13','10:25:00',14.07),('7643','2013-05-13','10:30:00',14.17),('7643','2013-05-13','10:35:00',14.31),('7643','2013-05-13','10:40:00',14.45),('7643','2013-05-13','10:45:00',14.57),('7643','2013-05-13','10:50:00',14.75),('7643','2013-05-13','10:55:00',14.99),('7643','2013-05-13','11:00:00',15.12),('7643','2013-05-13','11:05:00',15.17),('7643','2013-05-13','11:10:00',15.38),('7643','2013-05-13','11:15:00',15.43),('7643','2013-05-13','11:20:00',15.45),('7643','2013-05-13','11:25:00',15.47),('7643','2013-05-13','11:30:00',15.63),('7643','2013-05-13','11:35:00',15.74),('7643','2013-05-13','11:40:00',15.74),('7643','2013-05-13','11:45:00',15.96),('7643','2013-05-13','11:50:00',16.14),('7643','2013-05-13','11:55:00',16.17),('7643','2013-05-13','12:00:00',16.15),('7643','2013-05-13','12:05:00',16.18),('7643','2013-05-13','12:10:00',16.22),('7643','2013-05-13','12:15:00',16.26),('7643','2013-05-13','12:20:00',16.44),('7643','2013-05-13','12:25:00',16.52),('7643','2013-05-13','12:30:00',16.71),('7643','2013-05-13','12:35:00',16.74),('7643','2013-05-13','12:40:00',16.66),('7643','2013-05-13','12:45:00',16.6),('7643','2013-05-13','12:50:00',16.72),('7643','2013-05-13','12:55:00',16.8),('7643','2013-05-13','13:00:00',16.72),('7643','2013-05-13','13:05:00',16.63),('7643','2013-05-13','13:10:00',16.73),('7643','2013-05-13','13:15:00',16.8),('7643','2013-05-13','13:20:00',16.65),('7643','2013-05-13','13:25:00',16.52),('7643','2013-05-13','13:30:00',16.37),('7643','2013-05-13','13:35:00',16.24),('7643','2013-05-13','13:40:00',16.2),('7643','2013-05-13','13:45:00',16.22),('7643','2013-05-13','13:50:00',16.12),('7643','2013-05-13','13:55:00',16.03),('7643','2013-05-13','14:00:00',16.01),('7643','2013-05-13','14:05:00',16.05),('7643','2013-05-13','14:10:00',15.95),('7643','2013-05-13','14:15:00',15.86),('7643','2013-05-13','14:20:00',15.63),('7643','2013-05-13','14:25:00',15.49),('7643','2013-05-13','14:30:00',15.4),('7643','2013-05-13','14:35:00',15.31),('7643','2013-05-13','14:40:00',15.33),('7643','2013-05-13','14:45:00',15.31),('7643','2013-05-13','14:50:00',15.32),('7643','2013-05-13','14:55:00',15.35),('7643','2013-05-13','15:00:00',15.36),('7643','2013-05-13','15:05:00',15.33),('7643','2013-05-13','15:10:00',15.15),('7643','2013-05-13','15:15:00',14.94),('7643','2013-05-13','15:20:00',14.75),('7643','2013-05-13','15:25:00',14.6),('7643','2013-05-13','15:30:00',14.46),('7643','2013-05-13','15:35:00',14.21),('7643','2013-05-13','15:40:00',14.05),('7643','2013-05-13','15:45:00',13.83),('7643','2013-05-13','15:50:00',13.58),('7643','2013-05-13','15:55:00',13.29),('7643','2013-05-13','16:00:00',13.05),('7643','2013-05-13','16:05:00',12.85),('7643','2013-05-13','16:10:00',12.63),('7643','2013-05-13','16:15:00',12.35),('7643','2013-05-13','16:20:00',12.09),('7643','2013-05-13','16:25:00',11.82),('7643','2013-05-13','16:30:00',11.56),('7643','2013-05-13','16:35:00',11.27),('7643','2013-05-13','16:40:00',10.98),('7643','2013-05-13','16:45:00',10.7),('7643','2013-05-13','16:50:00',10.43),('7643','2013-05-13','16:55:00',10.11),('7643','2013-05-13','17:00:00',9.73),('7643','2013-05-13','17:05:00',9.36),('7643','2013-05-13','17:10:00',9.03),('7643','2013-05-13','17:15:00',8.64),('7643','2013-05-13','17:20:00',8.3),('7643','2013-05-13','17:25:00',7.97),('7643','2013-05-13','17:30:00',7.6),('7643','2013-05-13','17:35:00',7.24),('7643','2013-05-13','17:40:00',6.87),('7643','2013-05-13','17:45:00',6.42),('7643','2013-05-13','17:50:00',6.2),('7643','2013-05-13','17:55:00',5.82),('7643','2013-05-13','18:00:00',5.52),('7643','2013-05-13','18:05:00',5.15),('7643','2013-05-13','18:10:00',4.7),('7643','2013-05-13','18:15:00',4.26),('7643','2013-05-13','18:20:00',4.08),('7643','2013-05-13','18:25:00',3.81),('7643','2013-05-13','18:30:00',3.5),('7643','2013-05-13','18:35:00',3.21),('7643','2013-05-13','18:40:00',2.83),('7643','2013-05-13','18:45:00',2.42),('7643','2013-05-13','18:50:00',2.12),('7643','2013-05-13','18:55:00',1.85),('7643','2013-05-13','19:00:00',1.46),('7643','2013-05-13','19:05:00',1.37),('7643','2013-05-13','19:10:00',1.1),('7643','2013-05-12','06:50:00',1.15),('7643','2013-05-12','06:55:00',1.4),('7643','2013-05-12','07:00:00',1.74),('7643','2013-05-12','07:05:00',1.94),('7643','2013-05-12','07:10:00',2.17),('7643','2013-05-12','07:15:00',2.5),('7643','2013-05-12','07:20:00',2.04),('7643','2013-05-12','07:25:00',2.24),('7643','2013-05-12','07:30:00',3.18),('7643','2013-05-12','07:35:00',3.47),('7643','2013-05-12','07:40:00',3.84),('7643','2013-05-12','07:45:00',4.24),('7643','2013-05-12','07:50:00',4.54),('7643','2013-05-12','07:55:00',3.91),('7643','2013-05-12','08:00:00',4.93),('7643','2013-05-12','08:05:00',5.56),('7643','2013-05-12','08:10:00',6),('7643','2013-05-12','08:15:00',6.37),('7643','2013-05-12','08:20:00',6.71),('7643','2013-05-12','08:25:00',6.85),('7643','2013-05-12','08:30:00',7.24),('7643','2013-05-12','08:35:00',7.55),('7643','2013-05-12','08:40:00',8.06),('7643','2013-05-12','08:45:00',8.31),('7643','2013-05-12','08:50:00',8.62),('7643','2013-05-12','08:55:00',8.91),('7643','2013-05-12','09:00:00',9.16),('7643','2013-05-12','09:05:00',9.49),('7643','2013-05-12','09:10:00',9.88),('7643','2013-05-12','09:15:00',10.15),('7643','2013-05-12','09:20:00',10.54),('7643','2013-05-12','09:25:00',10.76),('7643','2013-05-12','09:30:00',11.03),('7643','2013-05-12','09:35:00',11.28),('7643','2013-05-12','09:40:00',11.61),('7643','2013-05-12','09:45:00',11.83),('7643','2013-05-12','09:50:00',12.32),('7643','2013-05-12','09:55:00',12.86),('7643','2013-05-12','10:00:00',13.15),('7643','2013-05-12','10:05:00',13.2),('7643','2013-05-12','10:10:00',13.33),('7643','2013-05-12','10:15:00',14.07),('7643','2013-05-12','10:20:00',14.43),('7643','2013-05-12','10:25:00',7.9),('7643','2013-05-12','10:30:00',13.36),('7643','2013-05-12','10:35:00',10.5),('7643','2013-05-12','10:40:00',3.63),('7643','2013-05-12','10:45:00',9.75),('7643','2013-05-12','10:50:00',15.38),('7643','2013-05-12','10:55:00',7.48),('7643','2013-05-12','11:00:00',9.61),('7643','2013-05-12','11:05:00',9.08),('7643','2013-05-12','11:10:00',6.69),('7643','2013-05-12','11:15:00',9.6),('7643','2013-05-12','11:20:00',5.93),('7643','2013-05-12','11:25:00',7.63),('7643','2013-05-12','11:30:00',6.64),('7643','2013-05-12','11:35:00',11.02),('7643','2013-05-12','11:40:00',8.02),('7643','2013-05-12','11:45:00',10.91),('7643','2013-05-12','11:50:00',7.41),('7643','2013-05-12','11:55:00',6.42),('7643','2013-05-12','12:00:00',6.23),('7643','2013-05-12','12:05:00',6.04),('7643','2013-05-12','12:10:00',10.48),('7643','2013-05-12','12:15:00',11.15),('7643','2013-05-12','12:20:00',5.94),('7643','2013-05-12','12:25:00',5.37),('7643','2013-05-12','12:30:00',9.2),('7643','2013-05-12','12:35:00',16.25),('7643','2013-05-12','12:40:00',13.01),('7643','2013-05-12','12:45:00',10.24),('7643','2013-05-12','12:50:00',13.49),('7643','2013-05-12','12:55:00',13.71),('7643','2013-05-12','13:00:00',18.52),('7643','2013-05-12','13:05:00',12.73),('7643','2013-05-12','13:10:00',15.41),('7643','2013-05-12','13:15:00',17.58),('7643','2013-05-12','13:20:00',12.91),('7643','2013-05-12','13:25:00',18.05),('7643','2013-05-12','13:30:00',18.34),('7643','2013-05-12','13:35:00',14.65),('7643','2013-05-12','13:40:00',13.4),('7643','2013-05-12','13:45:00',5.64),('7643','2013-05-12','13:50:00',5.81),('7643','2013-05-12','13:55:00',4.27),('7643','2013-05-12','14:00:00',4.23),('7643','2013-05-12','14:05:00',4.96),('7643','2013-05-12','14:10:00',19.18),('7643','2013-05-12','14:15:00',18.11),('7643','2013-05-12','14:20:00',16.93),('7643','2013-05-12','14:25:00',13.35),('7643','2013-05-12','14:30:00',3.03),('7643','2013-05-12','14:35:00',11.99),('7643','2013-05-12','14:40:00',17.43),('7643','2013-05-12','14:45:00',15.56),('7643','2013-05-12','14:50:00',4.05),('7643','2013-05-12','14:55:00',10.64),('7643','2013-05-12','15:00:00',15.97),('7643','2013-05-12','15:05:00',13.35),('7643','2013-05-12','15:10:00',5.35),('7643','2013-05-12','15:15:00',3.41),('7643','2013-05-12','15:20:00',3.97),('7643','2013-05-12','15:25:00',3.31),('7643','2013-05-12','15:30:00',2.91),('7643','2013-05-12','15:35:00',2.48),('7643','2013-05-12','15:40:00',2.74),('7643','2013-05-12','15:45:00',2.71),('7643','2013-05-12','15:50:00',2.61),('7643','2013-05-12','15:55:00',2.46),('7643','2013-05-12','16:00:00',3.94),('7643','2013-05-12','16:05:00',4.33),('7643','2013-05-12','16:10:00',7.38),('7643','2013-05-12','16:15:00',4.98),('7643','2013-05-12','16:20:00',5.29),('7643','2013-05-12','16:25:00',5.16),('7643','2013-05-12','16:30:00',8.62),('7643','2013-05-12','16:35:00',4.71),('7643','2013-05-12','16:40:00',6.78),('7643','2013-05-12','16:45:00',8.41),('7643','2013-05-12','16:50:00',12.58),('7643','2013-05-12','16:55:00',11.86),('7643','2013-05-12','17:00:00',10.84),('7643','2013-05-12','17:05:00',10.06),('7643','2013-05-12','17:10:00',7.57),('7643','2013-05-12','17:15:00',10.79),('7643','2013-05-12','17:20:00',11.33),('7643','2013-05-12','17:25:00',10.21),('7643','2013-05-12','17:30:00',9.39),('7643','2013-05-12','17:35:00',8.7),('7643','2013-05-12','17:40:00',7.98),('7643','2013-05-12','17:45:00',7.72),('7643','2013-05-12','17:50:00',6.32),('7643','2013-05-12','17:55:00',3.51),('7643','2013-05-12','18:00:00',2.74),('7643','2013-05-12','18:05:00',2.42),('7643','2013-05-12','18:10:00',2.35),('7643','2013-05-12','18:15:00',3.13),('7643','2013-05-12','18:20:00',1.84),('7643','2013-05-12','18:25:00',1.5),('7643','2013-05-12','18:30:00',1.52),('7643','2013-05-12','18:35:00',1.29),('7643','2013-05-12','18:40:00',1.42),('7643','2013-05-12','18:45:00',1.25),('7643','2013-05-12','18:50:00',1.14),('7643','2013-05-12','18:55:00',1.22),('7643','2013-05-12','19:00:00',1.36),('7643','2013-05-11','07:10:00',1.26),('7643','2013-05-11','07:15:00',1.5),('7643','2013-05-11','07:20:00',1.68),('7643','2013-05-11','07:25:00',1.59),('7643','2013-05-11','07:30:00',1.54),('7643','2013-05-11','07:35:00',1.79),('7643','2013-05-11','07:40:00',1.76),('7643','2013-05-11','07:45:00',2),('7643','2013-05-11','07:50:00',2.12),('7643','2013-05-11','07:55:00',2.49),('7643','2013-05-11','08:00:00',2.9),('7643','2013-05-11','08:05:00',4.78),('7643','2013-05-11','08:10:00',6.73),('7643','2013-05-11','08:15:00',6.42),('7643','2013-05-11','08:20:00',4.87),('7643','2013-05-11','08:25:00',4.39),('7643','2013-05-11','08:30:00',3.52),('7643','2013-05-11','08:35:00',3.08),('7643','2013-05-11','08:40:00',3.26),('7643','2013-05-11','08:45:00',3.91),('7643','2013-05-11','08:50:00',5.4),('7643','2013-05-11','08:55:00',3.86),('7643','2013-05-11','09:00:00',4.86),('7643','2013-05-11','09:05:00',7.03),('7643','2013-05-11','09:10:00',4.44),('7643','2013-05-11','09:15:00',9.4),('7643','2013-05-11','09:20:00',8.84),('7643','2013-05-11','09:25:00',9.81),('7643','2013-05-11','09:30:00',11.98),('7643','2013-05-11','09:35:00',5.41),('7643','2013-05-11','09:40:00',6.03),('7643','2013-05-11','09:45:00',15.25),('7643','2013-05-11','09:50:00',14.17),('7643','2013-05-11','09:55:00',12.18),('7643','2013-05-11','10:00:00',10.05),('7643','2013-05-11','10:05:00',4.98),('7643','2013-05-11','10:10:00',9.82),('7643','2013-05-11','10:15:00',3.43),('7643','2013-05-11','10:20:00',3.36),('7643','2013-05-11','10:25:00',3.84),('7643','2013-05-11','10:30:00',5.58),('7643','2013-05-11','10:35:00',4.04),('7643','2013-05-11','10:40:00',3.36),('7643','2013-05-11','10:45:00',3.42),('7643','2013-05-11','10:50:00',7.27),('7643','2013-05-11','10:55:00',14.16),('7643','2013-05-11','11:00:00',3.53),('7643','2013-05-11','11:05:00',3.48),('7643','2013-05-11','11:10:00',7.03),('7643','2013-05-11','11:15:00',16.92),('7643','2013-05-11','11:20:00',5.75),('7643','2013-05-11','11:25:00',6.67),('7643','2013-05-11','11:30:00',17.43),('7643','2013-05-11','11:35:00',15.55),('7643','2013-05-11','11:40:00',12.7),('7643','2013-05-11','11:45:00',16.05),('7643','2013-05-11','11:50:00',17.05),('7643','2013-05-11','11:55:00',5.97),('7643','2013-05-11','12:00:00',13.24),('7643','2013-05-11','12:05:00',16.69),('7643','2013-05-11','12:10:00',17.73),('7643','2013-05-11','12:15:00',7.16),('7643','2013-05-11','12:20:00',4.18),('7643','2013-05-11','12:25:00',3.73),('7643','2013-05-11','12:30:00',3.67),('7643','2013-05-11','12:35:00',5.49),('7643','2013-05-11','12:40:00',8.64),('7643','2013-05-11','12:45:00',15.96),('7643','2013-05-11','12:50:00',16.96),('7643','2013-05-11','12:55:00',7.84),('7643','2013-05-11','13:00:00',5.24),('7643','2013-05-11','13:05:00',5.9),('7643','2013-05-11','13:10:00',9.77),('7643','2013-05-11','13:15:00',8.77),('7643','2013-05-11','13:20:00',6.7),('7643','2013-05-11','13:25:00',10.53),('7643','2013-05-11','13:30:00',18.56),('7643','2013-05-11','13:35:00',15.46),('7643','2013-05-11','13:40:00',14.66),('7643','2013-05-11','13:45:00',18.23),('7643','2013-05-11','13:50:00',11.62),('7643','2013-05-11','13:55:00',13.63),('7643','2013-05-11','14:00:00',9.84),('7643','2013-05-11','14:05:00',15.39),('7643','2013-05-11','14:10:00',12.73),('7643','2013-05-11','14:15:00',14.73),('7643','2013-05-11','14:20:00',18.24),('7643','2013-05-11','14:25:00',17.74),('7643','2013-05-11','14:30:00',17.29),('7643','2013-05-11','14:35:00',12.63),('7643','2013-05-11','14:40:00',15.17),('7643','2013-05-11','14:45:00',16.65),('7643','2013-05-11','14:50:00',15.96),('7643','2013-05-11','14:55:00',16.37),('7643','2013-05-11','15:00:00',16.35),('7643','2013-05-11','15:05:00',14.16),('7643','2013-05-11','15:10:00',15.65),('7643','2013-05-11','15:15:00',15.89),('7643','2013-05-11','15:20:00',11.24),('7643','2013-05-11','15:25:00',14.06),('7643','2013-05-11','15:30:00',12.12),('7643','2013-05-11','15:35:00',14.34),('7643','2013-05-11','15:40:00',14.04),('7643','2013-05-11','15:45:00',13.23),('7643','2013-05-11','15:50:00',13.45),('7643','2013-05-11','15:55:00',13.18),('7643','2013-05-11','16:00:00',12.86),('7643','2013-05-11','16:05:00',12.7),('7643','2013-05-11','16:10:00',12.42),('7643','2013-05-11','16:15:00',12.18),('7643','2013-05-11','16:20:00',11.91),('7643','2013-05-11','16:25:00',11.56),('7643','2013-05-11','16:30:00',11.44),('7643','2013-05-11','16:35:00',11.26),('7643','2013-05-11','16:40:00',11.36),('7643','2013-05-11','16:45:00',11.29),('7643','2013-05-11','16:50:00',11.71),('7643','2013-05-11','16:55:00',12.74),('7643','2013-05-11','17:00:00',12.66),('7643','2013-05-11','17:05:00',11.93),('7643','2013-05-11','17:10:00',11.95),('7643','2013-05-11','17:15:00',8.48),('7643','2013-05-11','17:20:00',10.51),('7643','2013-05-11','17:25:00',9.22),('7643','2013-05-11','17:30:00',7.23),('7643','2013-05-11','17:35:00',6.15),('7643','2013-05-11','17:40:00',7.97),('7643','2013-05-11','17:45:00',3.79),('7643','2013-05-11','17:50:00',4.29),('7643','2013-05-11','17:55:00',3.43),('7643','2013-05-11','18:00:00',4.28),('7643','2013-05-11','18:05:00',6.38),('7643','2013-05-11','18:10:00',5.73),('7643','2013-05-11','18:15:00',5.86),('7643','2013-05-11','18:20:00',3.88),('7643','2013-05-11','18:25:00',4.91),('7643','2013-05-11','18:30:00',3.68),('7643','2013-05-11','18:35:00',3.89),('7643','2013-05-11','18:40:00',3.71),('7643','2013-05-11','18:45:00',2.56),('7643','2013-05-11','18:50:00',2.28),('7643','2013-05-11','18:55:00',2.38),('7643','2013-05-11','19:00:00',2.59),('7643','2013-05-11','19:05:00',2.23),('7643','2013-05-11','19:10:00',1.98),('7643','2013-05-11','19:15:00',2.18),('7643','2013-05-11','19:20:00',2.1),('7643','2013-05-11','19:25:00',1.54),('7643','2013-05-11','19:30:00',1.43),('7643','2014-03-30','07:35:00',1.23),('7643','2014-03-30','07:40:00',1.5),('7643','2014-03-30','07:45:00',1.8),('7643','2014-03-30','07:50:00',2.1),('7643','2014-03-30','07:55:00',2.44),('7643','2014-03-30','08:00:00',2.81),('7643','2014-03-30','08:05:00',3.16),('7643','2014-03-30','08:10:00',3.55),('7643','2014-03-30','08:15:00',3.93),('7643','2014-03-30','08:20:00',4.33),('7643','2014-03-30','08:25:00',4.73),('7643','2014-03-30','08:30:00',5.11),('7643','2014-03-30','08:35:00',5.48),('7643','2014-03-30','08:40:00',5.86),('7643','2014-03-30','08:45:00',6.23),('7643','2014-03-30','08:50:00',6.57),('7643','2014-03-30','08:55:00',7.05),('7643','2014-03-30','09:00:00',7.45),('7643','2014-03-30','09:05:00',7.77),('7643','2014-03-30','09:10:00',8.13),('7643','2014-03-30','09:15:00',8.51),('7643','2014-03-30','09:20:00',8.83),('7643','2014-03-30','09:25:00',9.22),('7643','2014-03-30','09:30:00',9.51),('7643','2014-03-30','09:35:00',9.79),('7643','2014-03-30','09:40:00',10.05),('7643','2014-03-30','09:45:00',10.29),('7643','2014-03-30','09:50:00',10.57),('7643','2014-03-30','09:55:00',10.84),('7643','2014-03-30','10:00:00',11.05),('7643','2014-03-30','10:05:00',11.36),('7643','2014-03-30','10:10:00',11.65),('7643','2014-03-30','10:15:00',11.86),('7643','2014-03-30','10:20:00',12.03),('7643','2014-03-30','10:25:00',12.23),('7643','2014-03-30','10:30:00',12.32),('7643','2014-03-30','10:35:00',12.58),('7643','2014-03-30','10:40:00',12.82),('7643','2014-03-30','10:45:00',13.01),('7643','2014-03-30','10:50:00',13.3),('7643','2014-03-30','10:55:00',13.48),('7643','2014-03-30','11:00:00',13.66),('7643','2014-03-30','11:05:00',13.83),('7643','2014-03-30','11:10:00',13.91),('7643','2014-03-30','11:15:00',14.15),('7643','2014-03-30','11:20:00',14.28),('7643','2014-03-30','11:25:00',14.39),('7643','2014-03-30','11:30:00',14.46),('7643','2014-03-30','11:35:00',14.55),('7643','2014-03-30','11:40:00',14.7),('7643','2014-03-30','11:45:00',14.64),('7643','2014-03-30','11:50:00',14.83),('7643','2014-03-30','11:55:00',15.08),('7643','2014-03-30','12:00:00',15.27),('7643','2014-03-30','12:05:00',15.23),('7643','2014-03-30','12:10:00',15.28),('7643','2014-03-30','12:15:00',15.38),('7643','2014-03-30','12:20:00',15.56),('7643','2014-03-30','12:25:00',15.6),('7643','2014-03-30','12:30:00',15.63),('7643','2014-03-30','12:35:00',15.73),('7643','2014-03-30','12:40:00',15.8),('7643','2014-03-30','12:45:00',15.8),('7643','2014-03-30','12:50:00',15.75),('7643','2014-03-30','12:55:00',15.64),('7643','2014-03-30','13:00:00',15.72),('7643','2014-03-30','13:05:00',15.88),('7643','2014-03-30','13:10:00',15.87),('7643','2014-03-30','13:15:00',15.82),('7643','2014-03-30','13:20:00',15.82),('7643','2014-03-30','13:25:00',15.81),('7643','2014-03-30','13:30:00',15.91),('7643','2014-03-30','13:35:00',15.89),('7643','2014-03-30','13:40:00',15.79),('7643','2014-03-30','13:45:00',15.86),('7643','2014-03-30','13:50:00',15.76),('7643','2014-03-30','13:55:00',15.73),('7643','2014-03-30','14:00:00',15.58),('7643','2014-03-30','14:05:00',15.51),('7643','2014-03-30','14:10:00',15.47),('7643','2014-03-30','14:15:00',15.45),('7643','2014-03-30','14:20:00',15.37),('7643','2014-03-30','14:25:00',15.32),('7643','2014-03-30','14:30:00',15.25),('7643','2014-03-30','14:35:00',15.16),('7643','2014-03-30','14:40:00',15.09),('7643','2014-03-30','14:45:00',15.03),('7643','2014-03-30','14:50:00',14.91),('7643','2014-03-30','14:55:00',14.58),('7643','2014-03-30','15:00:00',14.55),('7643','2014-03-30','15:05:00',14.37),('7643','2014-03-30','15:10:00',14.29),('7643','2014-03-30','15:15:00',14.16),('7643','2014-03-30','15:20:00',13.89),('7643','2014-03-30','15:25:00',13.68),('7643','2014-03-30','15:30:00',13.44),('7643','2014-03-30','15:35:00',13.14),('7643','2014-03-30','15:40:00',12.95),('7643','2014-03-30','15:45:00',12.68),('7643','2014-03-30','15:50:00',12.42),('7643','2014-03-30','15:55:00',12.16),('7643','2014-03-30','16:00:00',11.94),('7643','2014-03-30','16:05:00',11.64),('7643','2014-03-30','16:10:00',11.32),('7643','2014-03-30','16:15:00',11.02),('7643','2014-03-30','16:20:00',10.77),('7643','2014-03-30','16:25:00',10.47),('7643','2014-03-30','16:30:00',10.19),('7643','2014-03-30','16:35:00',9.88),('7643','2014-03-30','16:40:00',9.54),('7643','2014-03-30','16:45:00',9.31),('7643','2014-03-30','16:50:00',8.96),('7643','2014-03-30','16:55:00',8.63),('7643','2014-03-30','17:00:00',8.24),('7643','2014-03-30','17:05:00',7.92),('7643','2014-03-30','17:10:00',7.63),('7643','2014-03-30','17:15:00',7.24),('7643','2014-03-30','17:20:00',6.85),('7643','2014-03-30','17:25:00',6.45),('7643','2014-03-30','17:30:00',6.09),('7643','2014-03-30','17:35:00',5.75),('7643','2014-03-30','17:40:00',5.36),('7643','2014-03-30','17:45:00',5.06),('7643','2014-03-30','17:50:00',4.66),('7643','2014-03-30','17:55:00',4.26),('7643','2014-03-30','18:00:00',3.88),('7643','2014-03-30','18:05:00',3.48),('7643','2014-03-30','18:10:00',3.07),('7643','2014-03-30','18:15:00',2.77),('7643','2014-03-30','18:20:00',2.42),('7643','2014-03-30','18:25:00',2.11),('7643','2014-03-30','18:30:00',1.78),('7643','2014-03-30','18:35:00',1.57),('7643','2014-03-30','18:40:00',1.44),('7643','2014-03-30','18:45:00',1.2),('7643','2013-05-10','07:10:00',1.61),('7643','2013-05-10','07:15:00',2.17),('7643','2013-05-10','07:20:00',2.61),('7643','2013-05-10','07:25:00',2.83),('7643','2013-05-10','07:30:00',3.09),('7643','2013-05-10','07:35:00',3.13),('7643','2013-05-10','07:40:00',3.29),('7643','2013-05-10','07:45:00',4.23),('7643','2013-05-10','07:50:00',4.88),('7643','2013-05-10','07:55:00',5.49),('7643','2013-05-10','08:00:00',5.5),('7643','2013-05-10','08:05:00',4.36),('7643','2013-05-10','08:10:00',2.73),('7643','2013-05-10','08:15:00',6.15),('7643','2013-05-10','08:20:00',5.1),('7643','2013-05-10','08:25:00',3.43),('7643','2013-05-10','08:30:00',3.4),('7643','2013-05-10','08:35:00',5.06),('7643','2013-05-10','08:40:00',2.57),('7643','2013-05-10','08:45:00',1.54),('7643','2013-05-10','08:50:00',1.93),('7643','2013-05-10','08:55:00',2.41),('7643','2013-05-10','09:00:00',2.54),('7643','2013-05-10','09:05:00',3.62),('7643','2013-05-10','09:10:00',3.51),('7643','2013-05-10','09:15:00',4.07),('7643','2013-05-10','09:20:00',6.95),('7643','2013-05-10','09:25:00',5.65),('7643','2013-05-10','09:30:00',9.2),('7643','2013-05-10','09:35:00',13.93),('7643','2013-05-10','09:40:00',8.68),('7643','2013-05-10','09:45:00',8.66),('7643','2013-05-10','09:50:00',4.92),('7643','2013-05-10','09:55:00',4.65),('7643','2013-05-10','10:00:00',5.56),('7643','2013-05-10','10:05:00',5.07),('7643','2013-05-10','10:10:00',3.79),('7643','2013-05-10','10:15:00',2.98),('7643','2013-05-10','10:20:00',3.8),('7643','2013-05-10','10:25:00',3.48),('7643','2013-05-10','10:30:00',4.42),('7643','2013-05-10','10:35:00',4.71),('7643','2013-05-10','10:40:00',3.66),('7643','2013-05-10','10:45:00',3.08),('7643','2013-05-10','10:50:00',4.2),('7643','2013-05-10','10:55:00',13.94),('7643','2013-05-10','11:00:00',8.07),('7643','2013-05-10','11:05:00',9.46),('7643','2013-05-10','11:10:00',4.56),('7643','2013-05-10','11:15:00',3.33),('7643','2013-05-10','11:20:00',2.84),('7643','2013-05-10','11:25:00',3.31),('7643','2013-05-10','11:30:00',5.17),('7643','2013-05-10','11:35:00',12.58),('7643','2013-05-10','11:40:00',7.97),('7643','2013-05-10','11:45:00',17.64),('7643','2013-05-10','11:50:00',9.87),('7643','2013-05-10','11:55:00',3.94),('7643','2013-05-10','12:00:00',4.9),('7643','2013-05-10','12:05:00',7.19),('7643','2013-05-10','12:10:00',5.42),('7643','2013-05-10','12:15:00',5.33),('7643','2013-05-10','12:20:00',7.31),('7643','2013-05-10','12:25:00',17.78),('7643','2013-05-10','12:30:00',12.65),('7643','2013-05-10','12:35:00',6.46),('7643','2013-05-10','12:40:00',7.81),('7643','2013-05-10','12:45:00',8.01),('7643','2013-05-10','12:50:00',8.46),('7643','2013-05-10','12:55:00',6.32),('7643','2013-05-10','13:00:00',6.06),('7643','2013-05-10','13:05:00',8.37),('7643','2013-05-10','13:10:00',4.58),('7643','2013-05-10','13:15:00',2.8),('7643','2013-05-10','13:20:00',3.38),('7643','2013-05-10','13:25:00',4.27),('7643','2013-05-10','13:30:00',4.26),('7643','2013-05-10','13:35:00',3.77),('7643','2013-05-10','13:40:00',2.96),('7643','2013-05-10','13:45:00',1.9),('7643','2013-05-10','13:50:00',2.45),('7643','2013-05-10','13:55:00',2.87),('7643','2013-05-10','14:00:00',6.51),('7643','2013-05-10','14:05:00',10.56),('7643','2013-05-10','14:10:00',12.03),('7643','2013-05-10','14:15:00',13.6),('7643','2013-05-10','14:20:00',18.32),('7643','2013-05-10','14:25:00',16.3),('7643','2013-05-10','14:30:00',12.11),('7643','2013-05-10','14:35:00',13.75),('7643','2013-05-10','14:40:00',17.45),('7643','2013-05-10','14:45:00',15.52),('7643','2013-05-10','14:50:00',17.12),('7643','2013-05-10','14:55:00',16.55),('7643','2013-05-10','15:00:00',16.02),('7643','2013-05-10','15:05:00',15.59),('7643','2013-05-10','15:10:00',14.38),('7643','2013-05-10','15:15:00',15.43),('7643','2013-05-10','15:20:00',12.79),('7643','2013-05-10','15:25:00',15.07),('7643','2013-05-10','15:30:00',14.41),('7643','2013-05-10','15:35:00',14.64),('7643','2013-05-10','15:40:00',13.48),('7643','2013-05-10','15:45:00',13.77),('7643','2013-05-10','15:50:00',14.71),('7643','2013-05-10','15:55:00',13.32),('7643','2013-05-10','16:00:00',9.96),('7643','2013-05-10','16:05:00',12.06),('7643','2013-05-10','16:10:00',9.83),('7643','2013-05-10','16:15:00',12.33),('7643','2013-05-10','16:20:00',10.63),('7643','2013-05-10','16:25:00',12.5),('7643','2013-05-10','16:30:00',12.1),('7643','2013-05-10','16:35:00',11.8),('7643','2013-05-10','16:40:00',11.05),('7643','2013-05-10','16:45:00',10.94),('7643','2013-05-10','16:50:00',10.13),('7643','2013-05-10','16:55:00',9.05),('7643','2013-05-10','17:00:00',9.19),('7643','2013-05-10','17:05:00',9.64),('7643','2013-05-10','17:10:00',8.27),('7643','2013-05-10','17:15:00',6.32),('7643','2013-05-10','17:20:00',8.95),('7643','2013-05-10','17:25:00',5.22),('7643','2013-05-10','17:30:00',7.01),('7643','2013-05-10','17:35:00',5.4),('7643','2013-05-10','17:40:00',7.26),('7643','2013-05-10','17:45:00',7.36),('7643','2013-05-10','17:50:00',5.04),('7643','2013-05-10','17:55:00',5.85),('7643','2013-05-10','18:00:00',2.95),('7643','2013-05-10','18:05:00',4.66),('7643','2013-05-10','18:10:00',6.56),('7643','2013-05-10','18:15:00',4.72),('7643','2013-05-10','18:20:00',2.9),('7643','2013-05-10','18:25:00',4.47),('7643','2013-05-10','18:30:00',3.91),('7643','2013-05-10','18:35:00',2.82),('7643','2013-05-10','18:40:00',2.47),('7643','2013-05-10','18:45:00',2.62),('7643','2013-05-10','18:50:00',1.9),('7643','2013-05-10','18:55:00',2.45),('7643','2013-05-10','19:00:00',1.85),('7643','2013-05-10','19:05:00',1.01),('7643','2013-05-10','19:10:00',1.04),('7643','2013-05-09','06:45:00',1.02),('7643','2013-05-09','06:50:00',1.08),('7643','2013-05-09','06:55:00',1.48),('7643','2013-05-09','07:00:00',2.01),('7643','2013-05-09','07:05:00',2.09),('7643','2013-05-09','07:10:00',2.31),('7643','2013-05-09','07:15:00',2.61),('7643','2013-05-09','07:20:00',2.08),('7643','2013-05-09','07:25:00',2.06),('7643','2013-05-09','07:30:00',3.34),('7643','2013-05-09','07:35:00',2.92),('7643','2013-05-09','07:40:00',3.52),('7643','2013-05-09','07:45:00',3.44),('7643','2013-05-09','07:50:00',2.89),('7643','2013-05-09','07:55:00',3.45),('7643','2013-05-09','08:00:00',6.12),('7643','2013-05-09','08:05:00',6.97),('7643','2013-05-09','08:10:00',7),('7643','2013-05-09','08:15:00',8.32),('7643','2013-05-09','08:20:00',7.67),('7643','2013-05-09','08:25:00',7.58),('7643','2013-05-09','08:30:00',7.03),('7643','2013-05-09','08:35:00',7.92),('7643','2013-05-09','08:40:00',4.12),('7643','2013-05-09','08:45:00',2.39),('7643','2013-05-09','08:50:00',2.37),('7643','2013-05-09','08:55:00',2.24),('7643','2013-05-09','09:00:00',5.1),('7643','2013-05-09','09:05:00',8.34),('7643','2013-05-09','09:10:00',10.21),('7643','2013-05-09','09:15:00',10.58),('7643','2013-05-09','09:20:00',10.18),('7643','2013-05-09','09:25:00',9.81),('7643','2013-05-09','09:30:00',9.06),('7643','2013-05-09','09:35:00',11.03),('7643','2013-05-09','09:40:00',10.67),('7643','2013-05-09','09:45:00',11.2),('7643','2013-05-09','09:50:00',11.7),('7643','2013-05-09','09:55:00',10.49),('7643','2013-05-09','10:00:00',9.41),('7643','2013-05-09','10:05:00',13.88),('7643','2013-05-09','10:10:00',8.23),('7643','2013-05-09','10:15:00',9.3),('7643','2013-05-09','10:20:00',8.54),('7643','2013-05-09','10:25:00',4.47),('7643','2013-05-09','10:30:00',4.37),('7643','2013-05-09','10:35:00',8.19),('7643','2013-05-09','10:40:00',14.92),('7643','2013-05-09','10:45:00',15.19),('7643','2013-05-09','10:50:00',15.4),('7643','2013-05-09','10:55:00',14.41),('7643','2013-05-09','11:00:00',15.29),('7643','2013-05-09','11:05:00',15.17),('7643','2013-05-09','11:10:00',15.2),('7643','2013-05-09','11:15:00',14.59),('7643','2013-05-09','11:20:00',16.61),('7643','2013-05-09','11:25:00',14.52),('7643','2013-05-09','11:30:00',13.52),('7643','2013-05-09','11:35:00',14.89),('7643','2013-05-09','11:40:00',9.86),('7643','2013-05-09','11:45:00',9.33),('7643','2013-05-09','11:50:00',11.86),('7643','2013-05-09','11:55:00',14.67),('7643','2013-05-09','12:00:00',16.07),('7643','2013-05-09','12:05:00',12.93),('7643','2013-05-09','12:10:00',11.15),('7643','2013-05-09','12:15:00',10.45),('7643','2013-05-09','12:20:00',11.54),('7643','2013-05-09','12:25:00',9.41),('7643','2013-05-09','12:30:00',7.97),('7643','2013-05-09','12:35:00',8.95),('7643','2013-05-09','12:40:00',13.49),('7643','2013-05-09','12:45:00',16.66),('7643','2013-05-09','12:50:00',13.26),('7643','2013-05-09','12:55:00',12.36),('7643','2013-05-09','13:00:00',16.55),('7643','2013-05-09','13:05:00',13.92),('7643','2013-05-09','13:10:00',16.34),('7643','2013-05-09','13:15:00',17.64),('7643','2013-05-09','13:20:00',12.57),('7643','2013-05-09','13:25:00',10.74),('7643','2013-05-09','13:30:00',12.27),('7643','2013-05-09','13:35:00',16.82),('7643','2013-05-09','13:40:00',14.96),('7643','2013-05-09','13:45:00',14.27),('7643','2013-05-09','13:50:00',9.33),('7643','2013-05-09','13:55:00',8.05),('7643','2013-05-09','14:00:00',7.3),('7643','2013-05-09','14:05:00',7.48),('7643','2013-05-09','14:10:00',8.84),('7643','2013-05-09','14:15:00',10.3),('7643','2013-05-09','14:20:00',9.82),('7643','2013-05-09','14:25:00',9.7),('7643','2013-05-09','14:30:00',9.96),('7643','2013-05-09','14:35:00',11.41),('7643','2013-05-09','14:40:00',10.63),('7643','2013-05-09','14:45:00',8.07),('7643','2013-05-09','14:50:00',5.65),('7643','2013-05-09','14:55:00',4.75),('7643','2013-05-09','15:00:00',4.47),('7643','2013-05-09','15:05:00',4.73),('7643','2013-05-09','15:10:00',6.26),('7643','2013-05-09','15:15:00',10.48),('7643','2013-05-09','15:20:00',11.33),('7643','2013-05-09','15:25:00',7.64),('7643','2013-05-09','15:30:00',6.98),('7643','2013-05-09','15:35:00',7.31),('7643','2013-05-09','15:40:00',7.69),('7643','2013-05-09','15:45:00',7.41),('7643','2013-05-09','15:50:00',6.68),('7643','2013-05-09','15:55:00',6.32),('7643','2013-05-09','16:00:00',6.06),('7643','2013-05-09','16:05:00',5.88),('7643','2013-05-09','16:10:00',5.73),('7643','2013-05-09','16:15:00',5.38),('7643','2013-05-09','16:20:00',4.82),('7643','2013-05-09','16:25:00',4.74),('7643','2013-05-09','16:30:00',4.99),('7643','2013-05-09','16:35:00',5.31),('7643','2013-05-09','16:40:00',5.08),('7643','2013-05-09','16:45:00',5.01),('7643','2013-05-09','16:50:00',5.07),('7643','2013-05-09','16:55:00',4.32),('7643','2013-05-09','17:00:00',3.41),('7643','2013-05-09','17:05:00',3.27),('7643','2013-05-09','17:10:00',4.17),('7643','2013-05-09','17:15:00',5.08),('7643','2013-05-09','17:20:00',7.98),('7643','2013-05-09','17:25:00',7.3),('7643','2013-05-09','17:30:00',6.69),('7643','2013-05-09','17:35:00',7.88),('7643','2013-05-09','17:40:00',5.18),('7643','2013-05-09','17:45:00',4.94),('7643','2013-05-09','17:50:00',4.23),('7643','2013-05-09','17:55:00',3.61),('7643','2013-05-09','18:00:00',3.37),('7643','2013-05-09','18:05:00',3.29),('7643','2013-05-09','18:10:00',2.98),('7643','2013-05-09','18:15:00',2.56),('7643','2013-05-09','18:20:00',2.61),('7643','2013-05-09','18:25:00',2.43),('7643','2013-05-09','18:30:00',1.9),('7643','2013-05-09','18:35:00',1.5),('7643','2013-05-09','18:40:00',1.27),('7643','2013-05-09','18:45:00',1.16),('7643','2013-05-09','18:50:00',1.1),('7643','2013-05-08','06:55:00',1.37),('7643','2013-05-08','07:00:00',1.79),('7643','2013-05-08','07:05:00',2.24),('7643','2013-05-08','07:10:00',2.43),('7643','2013-05-08','07:15:00',2.37),('7643','2013-05-08','07:20:00',2.59),('7643','2013-05-08','07:25:00',2.87),('7643','2013-05-08','07:30:00',3.22),('7643','2013-05-08','07:35:00',3.55),('7643','2013-05-08','07:40:00',3.92),('7643','2013-05-08','07:45:00',4.3),('7643','2013-05-08','07:50:00',4.64),('7643','2013-05-08','07:55:00',5),('7643','2013-05-08','08:00:00',5.33),('7643','2013-05-08','08:05:00',5.69),('7643','2013-05-08','08:10:00',6.01),('7643','2013-05-08','08:15:00',6.24),('7643','2013-05-08','08:20:00',6.64),('7643','2013-05-08','08:25:00',6.94),('7643','2013-05-08','08:30:00',7.23),('7643','2013-05-08','08:35:00',7.56),('7643','2013-05-08','08:40:00',7.91),('7643','2013-05-08','08:45:00',8.22),('7643','2013-05-08','08:50:00',8.53),('7643','2013-05-08','08:55:00',8.81),('7643','2013-05-08','09:00:00',9.14),('7643','2013-05-08','09:05:00',9.4),('7643','2013-05-08','09:10:00',9.59),('7643','2013-05-08','09:15:00',10.01),('7643','2013-05-08','09:20:00',10.33),('7643','2013-05-08','09:25:00',10.6),('7643','2013-05-08','09:30:00',10.96),('7643','2013-05-08','09:35:00',11.19),('7643','2013-05-08','09:40:00',11.48),('7643','2013-05-08','09:45:00',11.79),('7643','2013-05-08','09:50:00',12.01),('7643','2013-05-08','09:55:00',12.25),('7643','2013-05-08','10:00:00',12.47),('7643','2013-05-08','10:05:00',12.69),('7643','2013-05-08','10:10:00',12.84),('7643','2013-05-08','10:15:00',13.13),('7643','2013-05-08','10:20:00',13.25),('7643','2013-05-08','10:25:00',13.48),('7643','2013-05-08','10:30:00',13.68),('7643','2013-05-08','10:35:00',13.75),('7643','2013-05-08','10:40:00',13.98),('7643','2013-05-08','10:45:00',14.09),('7643','2013-05-08','10:50:00',14.18),('7643','2013-05-08','10:55:00',14.45),('7643','2013-05-08','11:00:00',14.59),('7643','2013-05-08','11:05:00',14.72),('7643','2013-05-08','11:10:00',14.94),('7643','2013-05-08','11:15:00',15.05),('7643','2013-05-08','11:20:00',15.08),('7643','2013-05-08','11:25:00',15.18),('7643','2013-05-08','11:30:00',15.16),('7643','2013-05-08','11:35:00',15.21),('7643','2013-05-08','11:40:00',15.4),('7643','2013-05-08','11:45:00',15.59),('7643','2013-05-08','11:50:00',15.57),('7643','2013-05-08','11:55:00',15.6),('7643','2013-05-08','12:00:00',15.71),('7643','2013-05-08','12:05:00',15.94),('7643','2013-05-08','12:10:00',15.96),('7643','2013-05-08','12:15:00',16.1),('7643','2013-05-08','12:20:00',16),('7643','2013-05-08','12:25:00',13.03),('7643','2013-05-08','12:30:00',14.79),('7643','2013-05-08','12:35:00',16.21),('7643','2013-05-08','12:40:00',12.43),('7643','2013-05-08','12:45:00',9.75),('7643','2013-05-08','12:50:00',12.02),('7643','2013-05-08','12:55:00',16.85),('7643','2013-05-08','13:00:00',16.48),('7643','2013-05-08','13:05:00',16.16),('7643','2013-05-08','13:10:00',16.2),('7643','2013-05-08','13:15:00',16.11),('7643','2013-05-08','13:20:00',16.11),('7643','2013-05-08','13:25:00',15.93),('7643','2013-05-08','13:30:00',16.14),('7643','2013-05-08','13:35:00',16.22),('7643','2013-05-08','13:40:00',16.27),('7643','2013-05-08','13:45:00',16.42),('7643','2013-05-08','13:50:00',16.19),('7643','2013-05-08','13:55:00',16.05),('7643','2013-05-08','14:00:00',15.61),('7643','2013-05-08','14:05:00',15.13),('7643','2013-05-08','14:10:00',15.15),('7643','2013-05-08','14:15:00',13.74),('7643','2013-05-08','14:20:00',15.93),('7643','2013-05-08','14:25:00',16.06),('7643','2013-05-08','14:30:00',15.35),('7643','2013-05-08','14:35:00',15.28),('7643','2013-05-08','14:40:00',15.27),('7643','2013-05-08','14:45:00',15.2),('7643','2013-05-08','14:50:00',15.01),('7643','2013-05-08','14:55:00',15.1),('7643','2013-05-08','15:00:00',14.93),('7643','2013-05-08','15:05:00',14.56),('7643','2013-05-08','15:10:00',14.4),('7643','2013-05-08','15:15:00',14.26),('7643','2013-05-08','15:20:00',14.05),('7643','2013-05-08','15:25:00',13.76),('7643','2013-05-08','15:30:00',13.74),('7643','2013-05-08','15:35:00',13.53),('7643','2013-05-08','15:40:00',13.36),('7643','2013-05-08','15:45:00',13.15),('7643','2013-05-08','15:50:00',12.99),('7643','2013-05-08','15:55:00',12.73),('7643','2013-05-08','16:00:00',12.4),('7643','2013-05-08','16:05:00',12.27),('7643','2013-05-08','16:10:00',11.97),('7643','2013-05-08','16:15:00',11.69),('7643','2013-05-08','16:20:00',11.52),('7643','2013-05-08','16:25:00',11.21),('7643','2013-05-08','16:30:00',10.97),('7643','2013-05-08','16:35:00',10.71),('7643','2013-05-08','16:40:00',10.32),('7643','2013-05-08','16:45:00',9.89),('7643','2013-05-08','16:50:00',9.61),('7643','2013-05-08','16:55:00',9.35),('7643','2013-05-08','17:00:00',9.1),('7643','2013-05-08','17:05:00',8.82),('7643','2013-05-08','17:10:00',8.48),('7643','2013-05-08','17:15:00',8.09),('7643','2013-05-08','17:20:00',7.72),('7643','2013-05-08','17:25:00',7.38),('7643','2013-05-08','17:30:00',7.1),('7643','2013-05-08','17:35:00',6.69),('7643','2013-05-08','17:40:00',6.35),('7643','2013-05-08','17:45:00',6.09),('7643','2013-05-08','17:50:00',5.71),('7643','2013-05-08','17:55:00',5.3),('7643','2013-05-08','18:00:00',5.07),('7643','2013-05-08','18:05:00',4.72),('7643','2013-05-08','18:10:00',4.34),('7643','2013-05-08','18:15:00',4.05),('7643','2013-05-08','18:20:00',3.76),('7643','2013-05-08','18:25:00',3.42),('7643','2013-05-08','18:30:00',3.12),('7643','2013-05-08','18:35:00',2.84),('7643','2013-05-08','18:40:00',2.49),('7643','2013-05-08','18:45:00',2.15),('7643','2013-05-08','18:50:00',1.83),('7643','2013-05-08','18:55:00',1.58),('7643','2013-05-08','19:00:00',1.38),('7643','2013-05-08','19:05:00',1.17),('7643','2013-05-08','19:10:00',1.02),('7643','2013-05-07','07:20:00',1.01),('7643','2013-05-07','07:25:00',1.57),('7643','2013-05-07','07:30:00',2.27),('7643','2013-05-07','07:40:00',1.04),('7643','2013-05-07','07:45:00',1.16),('7643','2013-05-07','07:50:00',1.44),('7643','2013-05-07','07:55:00',2.49),('7643','2013-05-07','08:00:00',1.83),('7643','2013-05-07','08:05:00',5.05),('7643','2013-05-07','08:10:00',6.78),('7643','2013-05-07','08:15:00',6.97),('7643','2013-05-07','08:20:00',7.17),('7643','2013-05-07','08:25:00',6.96),('7643','2013-05-07','08:30:00',7.61),('7643','2013-05-07','08:35:00',7.82),('7643','2013-05-07','08:40:00',8.21),('7643','2013-05-07','08:45:00',8.94),('7643','2013-05-07','08:50:00',10.14),('7643','2013-05-07','08:55:00',10.5),('7643','2013-05-07','09:00:00',9.92),('7643','2013-05-07','09:05:00',11.2),('7643','2013-05-07','09:10:00',10.47),('7643','2013-05-07','09:15:00',6.45),('7643','2013-05-07','09:20:00',4.12),('7643','2013-05-07','09:25:00',2.26),('7643','2013-05-07','09:30:00',2.34),('7643','2013-05-07','09:35:00',2.89),('7643','2013-05-07','09:40:00',3.96),('7643','2013-05-07','09:45:00',4.91),('7643','2013-05-07','09:50:00',4.56),('7643','2013-05-07','09:55:00',3.95),('7643','2013-05-07','10:00:00',9.9),('7643','2013-05-07','10:05:00',14.57),('7643','2013-05-07','10:10:00',8.48),('7643','2013-05-07','10:15:00',6.5),('7643','2013-05-07','10:20:00',8.4),('7643','2013-05-07','10:25:00',9.98),('7643','2013-05-07','10:30:00',4.95),('7643','2013-05-07','10:35:00',3.48),('7643','2013-05-07','10:40:00',3.39),('7643','2013-05-07','10:45:00',3.35),('7643','2013-05-07','10:50:00',3.17),('7643','2013-05-07','10:55:00',4.01),('7643','2013-05-07','11:00:00',6.55),('7643','2013-05-07','11:05:00',8.35),('7643','2013-05-07','11:10:00',15.03),('7643','2013-05-07','11:15:00',15.62),('7643','2013-05-07','11:20:00',15.82),('7643','2013-05-07','11:25:00',15.89),('7643','2013-05-07','11:30:00',16.4),('7643','2013-05-07','11:35:00',16.86),('7643','2013-05-07','11:40:00',17.02),('7643','2013-05-07','11:45:00',15.66),('7643','2013-05-07','11:50:00',6.91),('7643','2013-05-07','11:55:00',6),('7643','2013-05-07','12:00:00',14.97),('7643','2013-05-07','12:05:00',6.02),('7643','2013-05-07','12:10:00',2.51),('7643','2013-05-07','12:15:00',2.71),('7643','2013-05-07','12:20:00',3.42),('7643','2013-05-07','12:25:00',5.84),('7643','2013-05-07','12:30:00',9.68),('7643','2013-05-07','12:35:00',4.36),('7643','2013-05-07','12:40:00',4.72),('7643','2013-05-07','12:45:00',4.84),('7643','2013-05-07','12:50:00',11.85),('7643','2013-05-07','12:55:00',11.33),('7643','2013-05-07','13:00:00',12.02),('7643','2013-05-07','13:05:00',14.43),('7643','2013-05-07','13:10:00',17.23),('7643','2013-05-07','13:15:00',14.88),('7643','2013-05-07','13:20:00',4.15),('7643','2013-05-07','13:25:00',5.03),('7643','2013-05-07','13:30:00',3.58),('7643','2013-05-07','13:35:00',3.36),('7643','2013-05-07','13:40:00',3.7),('7643','2013-05-07','13:45:00',14.52),('7643','2013-05-07','13:50:00',17.38),('7643','2013-05-07','13:55:00',15.85),('7643','2013-05-07','14:00:00',14.23),('7643','2013-05-07','14:05:00',8.56),('7643','2013-05-07','14:10:00',6.9),('7643','2013-05-07','14:15:00',5.81),('7643','2013-05-07','14:20:00',15.08),('7643','2013-05-07','14:25:00',6.32),('7643','2013-05-07','14:30:00',16.96),('7643','2013-05-07','14:35:00',12.82),('7643','2013-05-07','14:40:00',6.36),('7643','2013-05-07','14:45:00',12.78),('7643','2013-05-07','14:50:00',16.91),('7643','2013-05-07','14:55:00',15.91),('7643','2013-05-07','15:00:00',14.95),('7643','2013-05-07','15:05:00',15.05),('7643','2013-05-07','15:10:00',14.14),('7643','2013-05-07','15:15:00',13.45),('7643','2013-05-07','15:20:00',14.52),('7643','2013-05-07','15:25:00',14.35),('7643','2013-05-07','15:30:00',14.06),('7643','2013-05-07','15:35:00',13.66),('7643','2013-05-07','15:40:00',13.27),('7643','2013-05-07','15:45:00',13.11),('7643','2013-05-07','15:50:00',12.91),('7643','2013-05-07','15:55:00',12.75),('7643','2013-05-07','16:00:00',12.6),('7643','2013-05-07','16:05:00',12.38),('7643','2013-05-07','16:10:00',12.18),('7643','2013-05-07','16:15:00',11.85),('7643','2013-05-07','16:20:00',11.54),('7643','2013-05-07','16:25:00',11.3),('7643','2013-05-07','16:30:00',11.38),('7643','2013-05-07','16:35:00',10.62),('7643','2013-05-07','16:40:00',10.43),('7643','2013-05-07','16:45:00',11.04),('7643','2013-05-07','16:50:00',10.62),('7643','2013-05-07','16:55:00',10.67),('7643','2013-05-07','17:00:00',8.89),('7643','2013-05-07','17:05:00',10.81),('7643','2013-05-07','17:10:00',10.46),('7643','2013-05-07','17:15:00',9.71),('7643','2013-05-07','17:20:00',8.67),('7643','2013-05-07','17:25:00',6.4),('7643','2013-05-07','17:30:00',8.6),('7643','2013-05-07','17:35:00',8.16),('7643','2013-05-07','17:40:00',7.79),('7643','2013-05-07','17:45:00',7.95),('7643','2013-05-07','17:50:00',7.96),('7643','2013-05-07','17:55:00',6.66),('7643','2013-05-07','18:00:00',3.19),('7643','2013-05-07','18:05:00',2.92),('7643','2013-05-07','18:10:00',3.3),('7643','2013-05-07','18:15:00',5.2),('7643','2013-05-07','18:20:00',5.06),('7643','2013-05-07','18:25:00',4.59),('7643','2013-05-07','18:30:00',3.96),('7643','2013-05-07','18:35:00',3.55),('7643','2013-05-07','18:40:00',2.21),('7643','2013-05-07','18:45:00',1.2),('7643','2013-05-07','19:00:00',1.44),('7643','2013-05-07','19:05:00',1.27),('7643','2013-05-06','06:55:00',1.12),('7643','2013-05-06','07:00:00',1.35),('7643','2013-05-06','07:05:00',1.62),('7643','2013-05-06','07:10:00',1.94),('7643','2013-05-06','07:15:00',2.24),('7643','2013-05-06','07:20:00',2.55),('7643','2013-05-06','07:25:00',2.9),('7643','2013-05-06','07:30:00',3.24),('7643','2013-05-06','07:35:00',3.62),('7643','2013-05-06','07:40:00',3.97),('7643','2013-05-06','07:45:00',4.33),('7643','2013-05-06','07:50:00',4.68),('7643','2013-05-06','07:55:00',5.02),('7643','2013-05-06','08:00:00',5.45),('7643','2013-05-06','08:05:00',5.76),('7643','2013-05-06','08:10:00',6.16),('7643','2013-05-06','08:15:00',6.5),('7643','2013-05-06','08:20:00',6.79),('7643','2013-05-06','08:25:00',7.06),('7643','2013-05-06','08:30:00',7.35),('7643','2013-05-06','08:35:00',7.8),('7643','2013-05-06','08:40:00',8.17),('7643','2013-05-06','08:45:00',8.46),('7643','2013-05-06','08:50:00',9.11),('7643','2013-05-06','08:55:00',9.7),('7643','2013-05-06','09:00:00',9.93),('7643','2013-05-06','09:05:00',10.17),('7643','2013-05-06','09:10:00',9.29),('7643','2013-05-06','09:15:00',6.27),('7643','2013-05-06','09:20:00',5.4),('7643','2013-05-06','09:25:00',2.81),('7643','2013-05-06','09:30:00',4.4),('7643','2013-05-06','09:35:00',11.41),('7643','2013-05-06','09:40:00',4.94),('7643','2013-05-06','09:45:00',4.67),('7643','2013-05-06','09:50:00',5.67),('7643','2013-05-06','09:55:00',6.82),('7643','2013-05-06','10:00:00',4.82),('7643','2013-05-06','10:05:00',4.97),('7643','2013-05-06','10:10:00',3.36),('7643','2013-05-06','10:15:00',2.63),('7643','2013-05-06','10:20:00',2.26),('7643','2013-05-06','10:25:00',2.17),('7643','2013-05-06','10:30:00',2.07),('7643','2013-05-06','10:35:00',1.85),('7643','2013-05-06','10:40:00',1.91),('7643','2013-05-06','10:45:00',1.75),('7643','2013-05-06','10:50:00',1.98),('7643','2013-05-06','10:55:00',2.55),('7643','2013-05-06','11:00:00',3.32),('7643','2013-05-06','11:05:00',3.88),('7643','2013-05-06','11:10:00',4.32),('7643','2013-05-06','11:15:00',5.02),('7643','2013-05-06','11:20:00',7.35),('7643','2013-05-06','11:25:00',11.96),('7643','2013-05-06','11:30:00',3.24),('7643','2013-05-06','11:35:00',2.19),('7643','2013-05-06','11:40:00',1.59),('7643','2013-05-06','11:45:00',1.65),('7643','2013-05-06','11:50:00',1.8),('7643','2013-05-06','11:55:00',2.11),('7643','2013-05-06','12:00:00',2.36),('7643','2013-05-06','12:05:00',2.69),('7643','2013-05-06','12:10:00',6.84),('7643','2013-05-06','12:15:00',3.71),('7643','2013-05-06','12:20:00',3.68),('7643','2013-05-06','12:25:00',4.85),('7643','2013-05-06','12:30:00',6.86),('7643','2013-05-06','12:35:00',3.66),('7643','2013-05-06','12:40:00',3.35),('7643','2013-05-06','12:45:00',2.46),('7643','2013-05-06','12:50:00',1.91),('7643','2013-05-06','12:55:00',1.96),('7643','2013-05-06','13:00:00',1.57),('7643','2013-05-06','13:05:00',2.28),('7643','2013-05-06','13:10:00',2.87),('7643','2013-05-06','13:15:00',4.35),('7643','2013-05-06','13:20:00',7.81),('7643','2013-05-06','13:25:00',12.61),('7643','2013-05-06','13:30:00',18.45),('7643','2013-05-06','13:35:00',13.52),('7643','2013-05-06','13:40:00',15.14),('7643','2013-05-06','13:45:00',15.55),('7643','2013-05-06','13:50:00',18.28),('7643','2013-05-06','13:55:00',17.23),('7643','2013-05-06','14:00:00',17.45),('7643','2013-05-06','14:05:00',17.22),('7643','2013-05-06','14:10:00',17.22),('7643','2013-05-06','14:15:00',16.17),('7643','2013-05-06','14:20:00',17.19),('7643','2013-05-06','14:25:00',17.31),('7643','2013-05-06','14:30:00',15.68),('7643','2013-05-06','14:35:00',16.77),('7643','2013-05-06','14:40:00',14.11),('7643','2013-05-06','14:45:00',17.35),('7643','2013-05-06','14:50:00',16.04),('7643','2013-05-06','14:55:00',11.05),('7643','2013-05-06','15:00:00',17.89),('7643','2013-05-06','15:05:00',15.29),('7643','2013-05-06','15:10:00',13.77),('7643','2013-05-06','15:15:00',13.85),('7643','2013-05-06','15:20:00',14.26),('7643','2013-05-06','15:25:00',10.56),('7643','2013-05-06','15:30:00',12.97),('7643','2013-05-06','15:35:00',12.94),('7643','2013-05-06','15:40:00',6.35),('7643','2013-05-06','15:45:00',6.08),('7643','2013-05-06','15:50:00',4.85),('7643','2013-05-06','15:55:00',7.15),('7643','2013-05-06','16:00:00',10.91),('7643','2013-05-06','16:05:00',10.41),('7643','2013-05-06','16:10:00',4.55),('7643','2013-05-06','16:15:00',8.46),('7643','2013-05-06','16:20:00',15.86),('7643','2013-05-06','16:25:00',14.75),('7643','2013-05-06','16:30:00',14.17),('7643','2013-05-06','16:35:00',13.97),('7643','2013-05-06','16:40:00',13.93),('7643','2013-05-06','16:45:00',10.35),('7643','2013-05-06','16:50:00',12.11),('7643','2013-05-06','16:55:00',10.74),('7643','2013-05-06','17:00:00',10.13),('7643','2013-05-06','17:05:00',10.44),('7643','2013-05-06','17:10:00',6.47),('7643','2013-05-06','17:15:00',4.48),('7643','2013-05-06','17:20:00',4.26),('7643','2013-05-06','17:25:00',4.39),('7643','2013-05-06','17:30:00',3.75),('7643','2013-05-06','17:35:00',3.8),('7643','2013-05-06','17:40:00',3.4),('7643','2013-05-06','17:45:00',3.14),('7643','2013-05-06','17:50:00',2.71),('7643','2013-05-06','17:55:00',2.11),('7643','2013-05-06','18:00:00',1.75),('7643','2013-05-06','18:05:00',1.58),('7643','2013-05-06','18:10:00',1.4),('7643','2013-05-06','18:15:00',1.31),('7643','2013-05-06','18:20:00',1.41),('7643','2013-05-06','18:25:00',1.54),('7643','2013-05-06','18:30:00',1.53),('7643','2013-05-06','18:35:00',1.65),('7643','2013-05-06','18:40:00',2.13),('7643','2013-05-06','18:45:00',2.7),('7643','2013-05-06','18:50:00',2.14),('7643','2013-05-06','18:55:00',1.35),('7643','2013-05-05','07:55:00',1.02),('7643','2013-05-05','08:00:00',1.4),('7643','2013-05-05','08:05:00',1.64),('7643','2013-05-05','08:10:00',1.92),('7643','2013-05-05','08:15:00',2.23),('7643','2013-05-05','08:20:00',2.54),('7643','2013-05-05','08:25:00',4.13),('7643','2013-05-05','08:30:00',5),('7643','2013-05-05','08:35:00',3.91),('7643','2013-05-05','08:40:00',3.28),('7643','2013-05-05','08:45:00',2.64),('7643','2013-05-05','08:50:00',3.87),('7643','2013-05-05','08:55:00',7.08),('7643','2013-05-05','09:00:00',7.65),('7643','2013-05-05','09:05:00',5.03),('7643','2013-05-05','09:10:00',5.8),('7643','2013-05-05','09:15:00',4.4),('7643','2013-05-05','09:20:00',4.35),('7643','2013-05-05','09:25:00',3.79),('7643','2013-05-05','09:30:00',3.47),('7643','2013-05-05','09:35:00',2.48),('7643','2013-05-05','09:40:00',1.49),('7643','2013-05-05','09:50:00',2.09),('7643','2013-05-05','09:55:00',3.9),('7643','2013-05-05','10:00:00',6.71),('7643','2013-05-05','10:05:00',4.84),('7643','2013-05-05','10:10:00',4.3),('7643','2013-05-05','10:15:00',5.74),('7643','2013-05-05','10:20:00',6.74),('7643','2013-05-05','10:25:00',6.06),('7643','2013-05-05','10:30:00',7.17),('7643','2013-05-05','10:35:00',6.35),('7643','2013-05-05','10:40:00',6.43),('7643','2013-05-05','10:45:00',12.28),('7643','2013-05-05','10:50:00',8.6),('7643','2013-05-05','10:55:00',7.45),('7643','2013-05-05','11:00:00',7.73),('7643','2013-05-05','11:05:00',7.58),('7643','2013-05-05','11:10:00',7.33),('7643','2013-05-05','11:15:00',6.67),('7643','2013-05-05','11:20:00',7.63),('7643','2013-05-05','11:25:00',8.46),('7643','2013-05-05','11:30:00',8.2),('7643','2013-05-05','11:35:00',6.18),('7643','2013-05-05','11:40:00',14.47),('7643','2013-05-05','11:45:00',13.98),('7643','2013-05-05','11:50:00',9.43),('7643','2013-05-05','11:55:00',5.29),('7643','2013-05-05','12:00:00',9.47),('7643','2013-05-05','12:05:00',6.79),('7643','2013-05-05','12:10:00',11.66),('7643','2013-05-05','12:15:00',8.59),('7643','2013-05-05','12:20:00',8.67),('7643','2013-05-05','12:25:00',11.59),('7643','2013-05-05','12:30:00',11.91),('7643','2013-05-05','12:35:00',16.21),('7643','2013-05-05','12:40:00',12.22),('7643','2013-05-05','12:45:00',9.21),('7643','2013-05-05','12:50:00',10.06),('7643','2013-05-05','12:55:00',13.34),('7643','2013-05-05','13:00:00',9.21),('7643','2013-05-05','13:05:00',8.7),('7643','2013-05-05','13:10:00',17.09),('7643','2013-05-05','13:15:00',15.29),('7643','2013-05-05','13:20:00',17.98),('7643','2013-05-05','13:25:00',14.71),('7643','2013-05-05','13:30:00',10.76),('7643','2013-05-05','13:35:00',10.82),('7643','2013-05-05','13:40:00',16.77),('7643','2013-05-05','13:45:00',10.74),('7643','2013-05-05','13:50:00',14.5),('7643','2013-05-05','13:55:00',17.4),('7643','2013-05-05','14:00:00',18.15),('7643','2013-05-05','14:05:00',12.91),('7643','2013-05-05','14:10:00',7.37),('7643','2013-05-05','14:15:00',10.56),('7643','2013-05-05','14:20:00',16.38),('7643','2013-05-05','14:25:00',15.6),('7643','2013-05-05','14:30:00',13.33),('7643','2013-05-05','14:35:00',18.08),('7643','2013-05-05','14:40:00',12.84),('7643','2013-05-05','14:45:00',11.94),('7643','2013-05-05','14:50:00',12.43),('7643','2013-05-05','14:55:00',13.45),('7643','2013-05-05','15:00:00',8.93),('7643','2013-05-05','15:05:00',12.04),('7643','2013-05-05','15:10:00',10.05),('7643','2013-05-05','15:15:00',7.74),('7643','2013-05-05','15:20:00',10.81),('7643','2013-05-05','15:25:00',4.94),('7643','2013-05-05','15:30:00',14.13),('7643','2013-05-05','15:35:00',9.01),('7643','2013-05-05','15:40:00',11.77),('7643','2013-05-05','15:45:00',5.63),('7643','2013-05-05','15:50:00',5.57),('7643','2013-05-05','15:55:00',9.25),('7643','2013-05-05','16:00:00',5.09),('7643','2013-05-05','16:05:00',6.38),('7643','2013-05-05','16:10:00',4.77),('7643','2013-05-05','16:15:00',4.5),('7643','2013-05-05','16:20:00',7.55),('7643','2013-05-05','16:25:00',8.94),('7643','2013-05-05','16:30:00',9.96),('7643','2013-05-05','16:35:00',7.46),('7643','2013-05-05','16:40:00',13.49),('7643','2013-05-05','16:45:00',8.01),('7643','2013-05-05','16:50:00',8.24),('7643','2013-05-05','16:55:00',7.66),('7643','2013-05-05','17:00:00',5.87),('7643','2013-05-05','17:05:00',2.28),('7643','2013-05-05','17:10:00',2),('7643','2013-05-05','17:15:00',6.54),('7643','2013-05-05','17:20:00',3.92),('7643','2013-05-05','17:25:00',2.53),('7643','2013-05-05','17:30:00',2.47),('7643','2013-05-05','17:35:00',6.6),('7643','2013-05-05','17:40:00',4.62),('7643','2013-05-05','17:45:00',3.66),('7643','2013-05-05','17:50:00',3.86),('7643','2013-05-05','17:55:00',2.53),('7643','2013-05-05','18:00:00',3.5),('7643','2013-05-05','18:05:00',5.56),('7643','2013-05-05','18:10:00',3.48),('7643','2013-05-05','18:15:00',1.81),('7643','2013-05-05','18:20:00',4.02),('7643','2013-05-05','18:25:00',3.86),('7643','2013-05-05','18:30:00',3.54),('7643','2013-05-05','18:35:00',2.1),('7643','2013-05-05','18:40:00',1.18),('7643','2013-05-05','18:45:00',1.19),('7643','2013-05-05','18:50:00',1.03),('7643','2013-05-04','07:10:00',1.49),('7643','2013-05-04','07:15:00',2.17),('7643','2013-05-04','07:20:00',2.37),('7643','2013-05-04','07:25:00',2.19),('7643','2013-05-04','07:30:00',2.16),('7643','2013-05-04','07:35:00',2.1),('7643','2013-05-04','07:40:00',2.7),('7643','2013-05-04','07:45:00',3.87),('7643','2013-05-04','07:50:00',4.08),('7643','2013-05-04','07:55:00',4.19),('7643','2013-05-04','08:00:00',4.62),('7643','2013-05-04','08:05:00',5.14),('7643','2013-05-04','08:10:00',5.53),('7643','2013-05-04','08:15:00',5.88),('7643','2013-05-04','08:20:00',6.73),('7643','2013-05-04','08:25:00',8.17),('7643','2013-05-04','08:30:00',8.04),('7643','2013-05-04','08:35:00',7.75),('7643','2013-05-04','08:40:00',7.93),('7643','2013-05-04','08:45:00',6.19),('7643','2013-05-04','08:50:00',5.12),('7643','2013-05-04','08:55:00',4.66),('7643','2013-05-04','09:00:00',5),('7643','2013-05-04','09:05:00',5.35),('7643','2013-05-04','09:10:00',6.35),('7643','2013-05-04','09:15:00',8.13),('7643','2013-05-04','09:20:00',6.6),('7643','2013-05-04','09:25:00',7.48),('7643','2013-05-04','09:30:00',6.42),('7643','2013-05-04','09:35:00',6.37),('7643','2013-05-04','09:40:00',8.84),('7643','2013-05-04','09:45:00',9.3),('7643','2013-05-04','09:50:00',8.72),('7643','2013-05-04','09:55:00',12.63),('7643','2013-05-04','10:00:00',8.33),('7643','2013-05-04','10:05:00',8.16),('7643','2013-05-04','10:10:00',8.03),('7643','2013-05-04','10:15:00',7.52),('7643','2013-05-04','10:20:00',10.81),('7643','2013-05-04','10:25:00',8.69),('7643','2013-05-04','10:30:00',9.74),('7643','2013-05-04','10:35:00',9.19),('7643','2013-05-04','10:40:00',9.61),('7643','2013-05-04','10:45:00',9.44),('7643','2013-05-04','10:50:00',7.7),('7643','2013-05-04','10:55:00',6.3),('7643','2013-05-04','11:00:00',5.78),('7643','2013-05-04','11:05:00',7.49),('7643','2013-05-04','11:10:00',6.61),('7643','2013-05-04','11:15:00',6.49),('7643','2013-05-04','11:20:00',9.09),('7643','2013-05-04','11:25:00',12.86),('7643','2013-05-04','11:30:00',10.71),('7643','2013-05-04','11:35:00',13.95),('7643','2013-05-04','11:40:00',12.55),('7643','2013-05-04','11:45:00',11.35),('7643','2013-05-04','11:50:00',9.84),('7643','2013-05-04','11:55:00',10.78),('7643','2013-05-04','12:00:00',8.91),('7643','2013-05-04','12:05:00',9.72),('7643','2013-05-04','12:10:00',9.05),('7643','2013-05-04','12:15:00',10.51),('7643','2013-05-04','12:20:00',10.96),('7643','2013-05-04','12:25:00',14.42),('7643','2013-05-04','12:30:00',14.08),('7643','2013-05-04','12:35:00',16.43),('7643','2013-05-04','12:40:00',13.91),('7643','2013-05-04','12:45:00',14.31),('7643','2013-05-04','12:50:00',12.84),('7643','2013-05-04','12:55:00',13.14),('7643','2013-05-04','13:00:00',13.95),('7643','2013-05-04','13:05:00',15.13),('7643','2013-05-04','13:10:00',13.3),('7643','2013-05-04','13:15:00',16.47),('7643','2013-05-04','13:20:00',12.57),('7643','2013-05-04','13:25:00',8.59),('7643','2013-05-04','13:30:00',7.39),('7643','2013-05-04','13:35:00',14.33),('7643','2013-05-04','13:40:00',16.65),('7643','2013-05-04','13:45:00',16.03),('7643','2013-05-04','13:50:00',16.09),('7643','2013-05-04','13:55:00',16.06),('7643','2013-05-04','14:00:00',16.41),('7643','2013-05-04','14:05:00',16.67),('7643','2013-05-04','14:10:00',12.53),('7643','2013-05-04','14:15:00',12.24),('7643','2013-05-04','14:20:00',14.6),('7643','2013-05-04','14:25:00',14.64),('7643','2013-05-04','14:30:00',14.24),('7643','2013-05-04','14:35:00',14.03),('7643','2013-05-04','14:40:00',13.9),('7643','2013-05-04','14:45:00',13.81),('7643','2013-05-04','14:50:00',13.64),('7643','2013-05-04','14:55:00',13.5),('7643','2013-05-04','15:00:00',13.46),('7643','2013-05-04','15:05:00',13.28),('7643','2013-05-04','15:10:00',13.13),('7643','2013-05-04','15:15:00',13.05),('7643','2013-05-04','15:20:00',12.82),('7643','2013-05-04','15:25:00',12.76),('7643','2013-05-04','15:30:00',12.63),('7643','2013-05-04','15:35:00',12.41),('7643','2013-05-04','15:40:00',12.18),('7643','2013-05-04','15:45:00',11.98),('7643','2013-05-04','15:50:00',11.78),('7643','2013-05-04','15:55:00',11.59),('7643','2013-05-04','16:00:00',11.41),('7643','2013-05-04','16:05:00',11.19),('7643','2013-05-04','16:10:00',10.98),('7643','2013-05-04','16:15:00',10.77),('7643','2013-05-04','16:20:00',10.53),('7643','2013-05-04','16:25:00',10.27),('7643','2013-05-04','16:30:00',10.01),('7643','2013-05-04','16:35:00',9.73),('7643','2013-05-04','16:40:00',9.46),('7643','2013-05-04','16:45:00',9.21),('7643','2013-05-04','16:50:00',8.93),('7643','2013-05-04','16:55:00',8.61),('7643','2013-05-04','17:00:00',8.31),('7643','2013-05-04','17:05:00',8.02),('7643','2013-05-04','17:10:00',7.73),('7643','2013-05-04','17:15:00',7.47),('7643','2013-05-04','17:20:00',7.13),('7643','2013-05-04','17:25:00',6.75),('7643','2013-05-04','17:30:00',6.4),('7643','2013-05-04','17:35:00',6.08),('7643','2013-05-04','17:40:00',5.73),('7643','2013-05-04','17:45:00',5.45),('7643','2013-05-04','17:50:00',5.09),('7643','2013-05-04','17:55:00',4.7),('7643','2013-05-04','18:00:00',4.42),('7643','2013-05-04','18:05:00',4.14),('7643','2013-05-04','18:10:00',3.84),('7643','2013-05-04','18:15:00',3.56),('7643','2013-05-04','18:20:00',3.25),('7643','2013-05-04','18:25:00',2.89),('7643','2013-05-04','18:30:00',2.74),('7643','2013-05-04','18:35:00',2.54),('7643','2013-05-04','18:40:00',2.29),('7643','2013-05-04','18:45:00',2.02),('7643','2013-05-04','18:50:00',1.75),('7643','2013-05-04','18:55:00',1.52),('7643','2013-05-04','19:00:00',1.35),('7643','2013-05-04','19:05:00',1.19),('7643','2013-05-04','19:10:00',1.02),('7643','2013-05-03','07:00:00',1.03),('7643','2013-05-03','07:05:00',1.12),('7643','2013-05-03','07:10:00',1.36),('7643','2013-05-03','07:15:00',1.05),('7643','2013-05-03','07:30:00',1.21),('7643','2013-05-03','07:35:00',2.33),('7643','2013-05-03','07:40:00',3.29),('7643','2013-05-03','07:45:00',3.4),('7643','2013-05-03','07:50:00',3.8),('7643','2013-05-03','07:55:00',4.38),('7643','2013-05-03','08:00:00',4.79),('7643','2013-05-03','08:05:00',5.09),('7643','2013-05-03','08:10:00',5.39),('7643','2013-05-03','08:15:00',5.67),('7643','2013-05-03','08:20:00',5.95),('7643','2013-05-03','08:25:00',6.14),('7643','2013-05-03','08:30:00',6.35),('7643','2013-05-03','08:35:00',6.57),('7643','2013-05-03','08:40:00',6.9),('7643','2013-05-03','08:45:00',7.21),('7643','2013-05-03','08:50:00',7.46),('7643','2013-05-03','08:55:00',7.83),('7643','2013-05-03','09:00:00',8.06),('7643','2013-05-03','09:05:00',8.33),('7643','2013-05-03','09:10:00',8.71),('7643','2013-05-03','09:15:00',8.94),('7643','2013-05-03','09:20:00',9.41),('7643','2013-05-03','09:25:00',9.51),('7643','2013-05-03','09:30:00',9.61),('7643','2013-05-03','09:35:00',10.03),('7643','2013-05-03','09:40:00',10.38),('7643','2013-05-03','09:45:00',10.77),('7643','2013-05-03','09:50:00',10.99),('7643','2013-05-03','09:55:00',11.19),('7643','2013-05-03','10:00:00',11.5),('7643','2013-05-03','10:05:00',11.65),('7643','2013-05-03','10:10:00',11.93),('7643','2013-05-03','10:15:00',12.23),('7643','2013-05-03','10:20:00',12.38),('7643','2013-05-03','10:25:00',12.59),('7643','2013-05-03','10:30:00',12.73),('7643','2013-05-03','10:35:00',12.88),('7643','2013-05-03','10:40:00',12.83),('7643','2013-05-03','10:45:00',12.86),('7643','2013-05-03','10:50:00',12.74),('7643','2013-05-03','10:55:00',12.61),('7643','2013-05-03','11:00:00',12.69),('7643','2013-05-03','11:05:00',12.75),('7643','2013-05-03','11:10:00',12.19),('7643','2013-05-03','11:15:00',11.81),('7643','2013-05-03','11:20:00',12.75),('7643','2013-05-03','11:25:00',12.97),('7643','2013-05-03','11:30:00',12.53),('7643','2013-05-03','11:35:00',12.79),('7643','2013-05-03','11:40:00',12.38),('7643','2013-05-03','11:45:00',12.87),('7643','2013-05-03','11:50:00',12.72),('7643','2013-05-03','11:55:00',12.85),('7643','2013-05-03','12:00:00',12.52),('7643','2013-05-03','12:05:00',13.13),('7643','2013-05-03','12:10:00',13.32),('7643','2013-05-03','12:15:00',13.61),('7643','2013-05-03','12:20:00',13.93),('7643','2013-05-03','12:25:00',14.15),('7643','2013-05-03','12:30:00',14.21),('7643','2013-05-03','12:35:00',14.4),('7643','2013-05-03','12:40:00',14.25),('7643','2013-05-03','12:45:00',14.45),('7643','2013-05-03','12:50:00',13.96),('7643','2013-05-03','12:55:00',13.55),('7643','2013-05-03','13:00:00',13.29),('7643','2013-05-03','13:05:00',12.04),('7643','2013-05-03','13:10:00',13.46),('7643','2013-05-03','13:15:00',15.06),('7643','2013-05-03','13:20:00',15.31),('7643','2013-05-03','13:25:00',14.2),('7643','2013-05-03','13:30:00',14.43),('7643','2013-05-03','13:35:00',13.89),('7643','2013-05-03','13:40:00',13.87),('7643','2013-05-03','13:45:00',13.82),('7643','2013-05-03','13:50:00',12.23),('7643','2013-05-03','13:55:00',13.09),('7643','2013-05-03','14:00:00',13.09),('7643','2013-05-03','14:05:00',13.62),('7643','2013-05-03','14:10:00',13),('7643','2013-05-03','14:15:00',13.33),('7643','2013-05-03','14:20:00',13.38),('7643','2013-05-03','14:25:00',12.47),('7643','2013-05-03','14:30:00',12.97),('7643','2013-05-03','14:35:00',12.21),('7643','2013-05-03','14:40:00',12.69),('7643','2013-05-03','14:45:00',12.48),('7643','2013-05-03','14:50:00',11.92),('7643','2013-05-03','14:55:00',12.32),('7643','2013-05-03','15:00:00',12.48),('7643','2013-05-03','15:05:00',12.69),('7643','2013-05-03','15:10:00',11.9),('7643','2013-05-03','15:15:00',12.19),('7643','2013-05-03','15:20:00',12.39),('7643','2013-05-03','15:25:00',12.47),('7643','2013-05-03','15:30:00',12.33),('7643','2013-05-03','15:35:00',11.66),('7643','2013-05-03','15:40:00',11.73),('7643','2013-05-03','15:45:00',11.73),('7643','2013-05-03','15:50:00',11.58),('7643','2013-05-03','15:55:00',11.34),('7643','2013-05-03','16:00:00',11.04),('7643','2013-05-03','16:05:00',10.85),('7643','2013-05-03','16:10:00',10.63),('7643','2013-05-03','16:15:00',10.31),('7643','2013-05-03','16:20:00',10.08),('7643','2013-05-03','16:25:00',9.85),('7643','2013-05-03','16:30:00',9.65),('7643','2013-05-03','16:35:00',9.4),('7643','2013-05-03','16:40:00',9.09),('7643','2013-05-03','16:45:00',8.78),('7643','2013-05-03','16:50:00',8.51),('7643','2013-05-03','16:55:00',8.24),('7643','2013-05-03','17:00:00',8),('7643','2013-05-03','17:05:00',7.46),('7643','2013-05-03','17:10:00',5.94),('7643','2013-05-03','17:15:00',6.85),('7643','2013-05-03','17:20:00',6.9),('7643','2013-05-03','17:25:00',6.58),('7643','2013-05-03','17:30:00',6.04),('7643','2013-05-03','17:35:00',5.62),('7643','2013-05-03','17:40:00',5.22),('7643','2013-05-03','17:45:00',5.13),('7643','2013-05-03','17:50:00',4.98),('7643','2013-05-03','17:55:00',4.68),('7643','2013-05-03','18:00:00',4.47),('7643','2013-05-03','18:05:00',4.21),('7643','2013-05-03','18:10:00',3.64),('7643','2013-05-03','18:15:00',2.78),('7643','2013-05-03','18:20:00',2.37),('7643','2013-05-03','18:25:00',2.08),('7643','2013-05-03','18:30:00',1.68),('7643','2013-05-03','18:35:00',1.39),('7643','2013-05-03','18:40:00',1.28),('7643','2013-05-03','18:45:00',1.09),('7643','2013-05-02','07:15:00',1.36),('7643','2013-05-02','07:20:00',1.45),('7643','2013-05-02','07:25:00',1.76),('7643','2013-05-02','07:30:00',1.73),('7643','2013-05-02','07:35:00',1.69),('7643','2013-05-02','07:40:00',1.79),('7643','2013-05-02','07:45:00',2.04),('7643','2013-05-02','07:50:00',2.35),('7643','2013-05-02','07:55:00',2.73),('7643','2013-05-02','08:00:00',3.46),('7643','2013-05-02','08:05:00',4.89),('7643','2013-05-02','08:10:00',6),('7643','2013-05-02','08:15:00',6.71),('7643','2013-05-02','08:20:00',6.55),('7643','2013-05-02','08:25:00',6.88),('7643','2013-05-02','08:30:00',7.05),('7643','2013-05-02','08:35:00',7.17),('7643','2013-05-02','08:40:00',7.5),('7643','2013-05-02','08:45:00',7.78),('7643','2013-05-02','08:50:00',7.69),('7643','2013-05-02','08:55:00',7.74),('7643','2013-05-02','09:00:00',8.38),('7643','2013-05-02','09:05:00',8.88),('7643','2013-05-02','09:10:00',8.93),('7643','2013-05-02','09:15:00',9.3),('7643','2013-05-02','09:20:00',9.49),('7643','2013-05-02','09:25:00',9.71),('7643','2013-05-02','09:30:00',10.08),('7643','2013-05-02','09:35:00',10.44),('7643','2013-05-02','09:40:00',10.71),('7643','2013-05-02','09:45:00',10.92),('7643','2013-05-02','09:50:00',11.11),('7643','2013-05-02','09:55:00',11.38),('7643','2013-05-02','10:00:00',11.62),('7643','2013-05-02','10:05:00',11.88),('7643','2013-05-02','10:10:00',12.06),('7643','2013-05-02','10:15:00',12.21),('7643','2013-05-02','10:20:00',12.36),('7643','2013-05-02','10:25:00',12.5),('7643','2013-05-02','10:30:00',12.8),('7643','2013-05-02','10:35:00',13.01),('7643','2013-05-02','10:40:00',13.16),('7643','2013-05-02','10:45:00',13.2),('7643','2013-05-02','10:50:00',13.24),('7643','2013-05-02','10:55:00',13.37),('7643','2013-05-02','11:00:00',13.56),('7643','2013-05-02','11:05:00',13.71),('7643','2013-05-02','11:10:00',13.85),('7643','2013-05-02','11:15:00',13.86),('7643','2013-05-02','11:20:00',14.05),('7643','2013-05-02','11:25:00',14.28),('7643','2013-05-02','11:30:00',14.41),('7643','2013-05-02','11:35:00',14.47),('7643','2013-05-02','11:40:00',14.64),('7643','2013-05-02','11:45:00',14.73),('7643','2013-05-02','11:50:00',14.81),('7643','2013-05-02','11:55:00',14.85),('7643','2013-05-02','12:00:00',14.83),('7643','2013-05-02','12:05:00',14.84),('7643','2013-05-02','12:10:00',15.04),('7643','2013-05-02','12:15:00',15.09),('7643','2013-05-02','12:20:00',15.11),('7643','2013-05-02','12:25:00',15.15),('7643','2013-05-02','12:30:00',15.15),('7643','2013-05-02','12:35:00',15.15),('7643','2013-05-02','12:40:00',15.17),('7643','2013-05-02','12:45:00',15.22),('7643','2013-05-02','12:50:00',15.37),('7643','2013-05-02','12:55:00',15.35),('7643','2013-05-02','13:00:00',15.2),('7643','2013-05-02','13:05:00',15.19),('7643','2013-05-02','13:10:00',15.2),('7643','2013-05-02','13:15:00',15.13),('7643','2013-05-02','13:20:00',15.13),('7643','2013-05-02','13:25:00',15.27),('7643','2013-05-02','13:30:00',15.07),('7643','2013-05-02','13:35:00',14.86),('7643','2013-05-02','13:40:00',14.45),('7643','2013-05-02','13:45:00',14.42),('7643','2013-05-02','13:50:00',14.28),('7643','2013-05-02','13:55:00',14.41),('7643','2013-05-02','14:00:00',14.37),('7643','2013-05-02','14:05:00',13.68),('7643','2013-05-02','14:10:00',13.95),('7643','2013-05-02','14:15:00',13.48),('7643','2013-05-02','14:20:00',13.95),('7643','2013-05-02','14:25:00',13.91),('7643','2013-05-02','14:30:00',13.59),('7643','2013-05-02','14:35:00',14),('7643','2013-05-02','14:40:00',13.69),('7643','2013-05-02','14:45:00',13.61),('7643','2013-05-02','14:50:00',13.54),('7643','2013-05-02','14:55:00',13.52),('7643','2013-05-02','15:00:00',13.45),('7643','2013-05-02','15:05:00',13.27),('7643','2013-05-02','15:10:00',13.28),('7643','2013-05-02','15:15:00',13.08),('7643','2013-05-02','15:20:00',13.01),('7643','2013-05-02','15:25:00',12.87),('7643','2013-05-02','15:30:00',12.63),('7643','2013-05-02','15:35:00',12.5),('7643','2013-05-02','15:40:00',12.3),('7643','2013-05-02','15:45:00',12.21),('7643','2013-05-02','15:50:00',11.77),('7643','2013-05-02','15:55:00',11.6),('7643','2013-05-02','16:00:00',11.5),('7643','2013-05-02','16:05:00',11.34),('7643','2013-05-02','16:10:00',11.03),('7643','2013-05-02','16:15:00',10.78),('7643','2013-05-02','16:20:00',10.28),('7643','2013-05-02','16:25:00',10.03),('7643','2013-05-02','16:30:00',10.06),('7643','2013-05-02','16:35:00',9.85),('7643','2013-05-02','16:40:00',9.5),('7643','2013-05-02','16:45:00',9.13),('7643','2013-05-02','16:50:00',8.86),('7643','2013-05-02','16:55:00',8.61),('7643','2013-05-02','17:00:00',8.33),('7643','2013-05-02','17:05:00',7.98),('7643','2013-05-02','17:10:00',7.64),('7643','2013-05-02','17:15:00',7.31),('7643','2013-05-02','17:20:00',6.89),('7643','2013-05-02','17:25:00',6.47),('7643','2013-05-02','17:30:00',6.13),('7643','2013-05-02','17:35:00',5.79),('7643','2013-05-02','17:40:00',5.29),('7643','2013-05-02','17:45:00',4.92),('7643','2013-05-02','17:50:00',4.71),('7643','2013-05-02','17:55:00',4.44),('7643','2013-05-02','18:00:00',4.22),('7643','2013-05-02','18:05:00',3.93),('7643','2013-05-02','18:10:00',3.68),('7643','2013-05-02','18:15:00',3.4),('7643','2013-05-02','18:20:00',3.11),('7643','2013-05-02','18:25:00',2.86),('7643','2013-05-02','18:30:00',2.56),('7643','2013-05-02','18:35:00',2.31),('7643','2013-05-02','18:40:00',2.09),('7643','2013-05-02','18:45:00',1.85),('7643','2013-05-02','18:50:00',1.61),('7643','2013-05-02','18:55:00',1.38),('7643','2013-05-02','19:00:00',1.19),('7643','2013-05-02','19:05:00',1.01),('7643','2013-05-01','08:30:00',1.29),('7643','2013-05-01','08:35:00',2.02),('7643','2013-05-01','08:40:00',2.94),('7643','2013-05-01','08:45:00',2.77),('7643','2013-05-01','08:50:00',2.87),('7643','2013-05-01','08:55:00',4.44),('7643','2013-05-01','09:00:00',7.2),('7643','2013-05-01','09:05:00',6.12),('7643','2013-05-01','09:10:00',3.3),('7643','2013-05-01','09:15:00',3.03),('7643','2013-05-01','09:20:00',3.56),('7643','2013-05-01','09:25:00',5.56),('7643','2013-05-01','09:30:00',6.12),('7643','2013-05-01','09:35:00',8.14),('7643','2013-05-01','09:40:00',5.27),('7643','2013-05-01','09:45:00',9.24),('7643','2013-05-01','09:50:00',4.64),('7643','2013-05-01','09:55:00',3.5),('7643','2013-05-01','10:00:00',3.84),('7643','2013-05-01','10:05:00',5.65),('7643','2013-05-01','10:10:00',5.27),('7643','2013-05-01','10:15:00',5.47),('7643','2013-05-01','10:20:00',5.61),('7643','2013-05-01','10:25:00',7.9),('7643','2013-05-01','10:30:00',12.41),('7643','2013-05-01','10:35:00',9.61),('7643','2013-05-01','10:40:00',13.92),('7643','2013-05-01','10:45:00',9.74),('7643','2013-05-01','10:50:00',12.27),('7643','2013-05-01','10:55:00',14.39),('7643','2013-05-01','11:00:00',14.91),('7643','2013-05-01','11:05:00',14.58),('7643','2013-05-01','11:10:00',10.73),('7643','2013-05-01','11:15:00',11.22),('7643','2013-05-01','11:20:00',10.81),('7643','2013-05-01','11:25:00',14.74),('7643','2013-05-01','11:30:00',14.68),('7643','2013-05-01','11:35:00',14.44),('7643','2013-05-01','11:40:00',14.29),('7643','2013-05-01','11:45:00',14.32),('7643','2013-05-01','11:50:00',14.36),('7643','2013-05-01','11:55:00',14.39),('7643','2013-05-01','12:00:00',14.33),('7643','2013-05-01','12:05:00',14.34),('7643','2013-05-01','12:10:00',14.34),('7643','2013-05-01','12:15:00',14.44),('7643','2013-05-01','12:20:00',14.42),('7643','2013-05-01','12:25:00',14.58),('7643','2013-05-01','12:30:00',14.95),('7643','2013-05-01','12:35:00',15.12),('7643','2013-05-01','12:40:00',15.28),('7643','2013-05-01','12:45:00',15.27),('7643','2013-05-01','12:50:00',15.39),('7643','2013-05-01','12:55:00',15.39),('7643','2013-05-01','13:00:00',15.47),('7643','2013-05-01','13:05:00',15.51),('7643','2013-05-01','13:10:00',15.66),('7643','2013-05-01','13:15:00',15.66),('7643','2013-05-01','13:20:00',15.71),('7643','2013-05-01','13:25:00',15.7),('7643','2013-05-01','13:30:00',15.64),('7643','2013-05-01','13:35:00',15.61),('7643','2013-05-01','13:40:00',15.69),('7643','2013-05-01','13:45:00',15.6),('7643','2013-05-01','13:50:00',15.44),('7643','2013-05-01','13:55:00',15.38),('7643','2013-05-01','14:00:00',15.22),('7643','2013-05-01','14:05:00',15.03),('7643','2013-05-01','14:10:00',14.96),('7643','2013-05-01','14:15:00',14.91),('7643','2013-05-01','14:20:00',14.67),('7643','2013-05-01','14:25:00',14.54),('7643','2013-05-01','14:30:00',14.41),('7643','2013-05-01','14:35:00',14.33),('7643','2013-05-01','14:40:00',14.22),('7643','2013-05-01','14:45:00',14.12),('7643','2013-05-01','14:50:00',14.02),('7643','2013-05-01','14:55:00',13.88),('7643','2013-05-01','15:00:00',13.71),('7643','2013-05-01','15:05:00',13.46),('7643','2013-05-01','15:10:00',13.36),('7643','2013-05-01','15:15:00',13.2),('7643','2013-05-01','15:20:00',13.03),('7643','2013-05-01','15:25:00',12.81),('7643','2013-05-01','15:30:00',12.34),('7643','2013-05-01','15:35:00',12.14),('7643','2013-05-01','15:40:00',11.92),('7643','2013-05-01','15:45:00',11.86),('7643','2013-05-01','15:50:00',11.65),('7643','2013-05-01','15:55:00',11.38),('7643','2013-05-01','16:00:00',11.14),('7643','2013-05-01','16:05:00',11.11),('7643','2013-05-01','16:10:00',10.89),('7643','2013-05-01','16:15:00',10.62),('7643','2013-05-01','16:20:00',10.34),('7643','2013-05-01','16:25:00',10.17),('7643','2013-05-01','16:30:00',9.89),('7643','2013-05-01','16:35:00',9.59),('7643','2013-05-01','16:40:00',9.31),('7643','2013-05-01','16:45:00',9.02),('7643','2013-05-01','16:50:00',8.84),('7643','2013-05-01','16:55:00',8.56),('7643','2013-05-01','17:00:00',8.25),('7643','2013-05-01','17:05:00',7.97),('7643','2013-05-01','17:10:00',7.69),('7643','2013-05-01','17:15:00',7.4),('7643','2013-05-01','17:20:00',7.12),('7643','2013-05-01','17:25:00',6.79),('7643','2013-05-01','17:30:00',6.43),('7643','2013-05-01','17:35:00',6.09),('7643','2013-05-01','17:40:00',5.74),('7643','2013-05-01','17:45:00',5.39),('7643','2013-05-01','17:50:00',5.08),('7643','2013-05-01','17:55:00',4.73),('7643','2013-05-01','18:00:00',4.38),('7643','2013-05-01','18:05:00',4.11),('7643','2013-05-01','18:10:00',3.85),('7643','2013-05-01','18:15:00',3.54),('7643','2013-05-01','18:20:00',3.24),('7643','2013-05-01','18:25:00',2.95),('7643','2013-05-01','18:30:00',2.68),('7643','2013-05-01','18:35:00',2.42),('7643','2013-05-01','18:40:00',2.16),('7643','2013-05-01','18:45:00',1.9),('7643','2013-05-01','18:50:00',1.61),('7643','2013-05-01','18:55:00',1.37),('7643','2013-05-01','19:00:00',1.17),('7643','2013-05-01','19:05:00',1),('7643','2013-04-30','07:00:00',1.07),('7643','2013-04-30','07:05:00',1.27),('7643','2013-04-30','07:10:00',1.46),('7643','2013-04-30','07:15:00',1.64),('7643','2013-04-30','07:20:00',1.82),('7643','2013-04-30','07:25:00',1.98),('7643','2013-04-30','07:30:00',2.4),('7643','2013-04-30','07:35:00',2.63),('7643','2013-04-30','07:40:00',2.89),('7643','2013-04-30','07:45:00',3.23),('7643','2013-04-30','07:50:00',3.56),('7643','2013-04-30','07:55:00',3.86),('7643','2013-04-30','08:00:00',4.17),('7643','2013-04-30','08:05:00',4.4),('7643','2013-04-30','08:10:00',4.61),('7643','2013-04-30','08:15:00',4.95),('7643','2013-04-30','08:20:00',5.32),('7643','2013-04-30','08:25:00',5.66),('7643','2013-04-30','08:30:00',6.09),('7643','2013-04-30','08:35:00',6.38),('7643','2013-04-30','08:40:00',6.69),('7643','2013-04-30','08:45:00',6.94),('7643','2013-04-30','08:50:00',7.38),('7643','2013-04-30','08:55:00',7.73),('7643','2013-04-30','09:00:00',8.07),('7643','2013-04-30','09:05:00',8.38),('7643','2013-04-30','09:10:00',8.58),('7643','2013-04-30','09:15:00',8.81),('7643','2013-04-30','09:20:00',8.99),('7643','2013-04-30','09:25:00',9.18),('7643','2013-04-30','09:30:00',9.34),('7643','2013-04-30','09:35:00',9.51),('7643','2013-04-30','09:40:00',9.8),('7643','2013-04-30','09:45:00',10.07),('7643','2013-04-30','09:50:00',10.29),('7643','2013-04-30','09:55:00',10.52),('7643','2013-04-30','10:00:00',10.71),('7643','2013-04-30','10:05:00',10.82),('7643','2013-04-30','10:10:00',11.18),('7643','2013-04-30','10:15:00',11.44),('7643','2013-04-30','10:20:00',11.67),('7643','2013-04-30','10:25:00',11.84),('7643','2013-04-30','10:30:00',12.03),('7643','2013-04-30','10:35:00',12.14),('7643','2013-04-30','10:40:00',12.67),('7643','2013-04-30','10:45:00',13.28),('7643','2013-04-30','10:50:00',13.41),('7643','2013-04-30','10:55:00',13.47),('7643','2013-04-30','11:00:00',13.62),('7643','2013-04-30','11:05:00',13.74),('7643','2013-04-30','11:10:00',13.88),('7643','2013-04-30','11:15:00',13),('7643','2013-04-30','11:20:00',12.38),('7643','2013-04-30','11:25:00',12.04),('7643','2013-04-30','11:30:00',11.78),('7643','2013-04-30','11:35:00',12.61),('7643','2013-04-30','11:40:00',11.16),('7643','2013-04-30','11:45:00',10.91),('7643','2013-04-30','11:50:00',12.83),('7643','2013-04-30','11:55:00',14.94),('7643','2013-04-30','12:00:00',14.67),('7643','2013-04-30','12:05:00',14.41),('7643','2013-04-30','12:10:00',14.39),('7643','2013-04-30','12:15:00',14.44),('7643','2013-04-30','12:20:00',14.59),('7643','2013-04-30','12:25:00',14.77),('7643','2013-04-30','12:30:00',14.85),('7643','2013-04-30','12:35:00',15.04),('7643','2013-04-30','12:40:00',15.35),('7643','2013-04-30','12:45:00',13.13),('7643','2013-04-30','12:50:00',12.51),('7643','2013-04-30','12:55:00',5.52),('7643','2013-04-30','13:00:00',7.31),('7643','2013-04-30','13:05:00',6.86),('7643','2013-04-30','13:10:00',10.02),('7643','2013-04-30','13:15:00',16.99),('7643','2013-04-30','13:20:00',17.02),('7643','2013-04-30','13:25:00',14.23),('7643','2013-04-30','13:30:00',10.68),('7643','2013-04-30','13:35:00',12.32),('7643','2013-04-30','13:40:00',16.53),('7643','2013-04-30','13:45:00',16.46),('7643','2013-04-30','13:50:00',15.62),('7643','2013-04-30','13:55:00',15.17),('7643','2013-04-30','14:00:00',14.9),('7643','2013-04-30','14:05:00',14.49),('7643','2013-04-30','14:10:00',14.31),('7643','2013-04-30','14:15:00',12.26),('7643','2013-04-30','14:20:00',15.05),('7643','2013-04-30','14:25:00',15.08),('7643','2013-04-30','14:30:00',15.14),('7643','2013-04-30','14:35:00',14.58),('7643','2013-04-30','14:40:00',12.91),('7643','2013-04-30','14:45:00',13.82),('7643','2013-04-30','14:50:00',11.31),('7643','2013-04-30','14:55:00',10.63),('7643','2013-04-30','15:00:00',11.93),('7643','2013-04-30','15:05:00',12.57),('7643','2013-04-30','15:10:00',12.99),('7643','2013-04-30','15:15:00',12.54),('7643','2013-04-30','15:20:00',12.04),('7643','2013-04-30','15:25:00',12.63),('7643','2013-04-30','15:30:00',10.32),('7643','2013-04-30','15:35:00',8.92),('7643','2013-04-30','15:40:00',8.81),('7643','2013-04-30','15:45:00',8.7),('7643','2013-04-30','15:50:00',6.4),('7643','2013-04-30','15:55:00',6.21),('7643','2013-04-30','16:00:00',7.64),('7643','2013-04-30','16:05:00',7.31),('7643','2013-04-30','16:10:00',6.53),('7643','2013-04-30','16:15:00',5.91),('7643','2013-04-30','16:20:00',5.05),('7643','2013-04-30','16:25:00',4.01),('7643','2013-04-30','16:30:00',3.75),('7643','2013-04-30','16:35:00',3.99),('7643','2013-04-30','16:40:00',4.3),('7643','2013-04-30','16:45:00',4),('7643','2013-04-30','16:50:00',3.48),('7643','2013-04-30','16:55:00',3.19),('7643','2013-04-30','17:00:00',3.24),('7643','2013-04-30','17:05:00',3.29),('7643','2013-04-30','17:10:00',3.35),('7643','2013-04-30','17:15:00',3.34),('7643','2013-04-30','17:20:00',3),('7643','2013-04-30','17:25:00',2.54),('7643','2013-04-30','17:30:00',2.16),('7643','2013-04-30','17:35:00',1.99),('7643','2013-04-30','17:40:00',1.82),('7643','2013-04-30','17:45:00',1.64),('7643','2013-04-30','17:50:00',1.42),('7643','2013-04-30','17:55:00',1.27),('7643','2013-04-30','18:00:00',1.16),('7643','2013-04-30','18:05:00',1.21),('7643','2013-04-30','18:10:00',1.34),('7643','2013-04-30','18:15:00',1.41),('7643','2013-04-30','18:20:00',1.38),('7643','2013-04-30','18:25:00',1.1),('7643','2013-04-29','07:30:00',1.07),('7643','2013-04-29','07:35:00',1.32),('7643','2013-04-29','07:40:00',1.39),('7643','2013-04-29','07:45:00',1.43),('7643','2013-04-29','07:50:00',1.52),('7643','2013-04-29','07:55:00',1.57),('7643','2013-04-29','08:00:00',1.52),('7643','2013-04-29','08:05:00',1.09),('7643','2013-04-29','08:10:00',1.18),('7643','2013-04-29','08:15:00',1.68),('7643','2013-04-29','08:20:00',2.07),('7643','2013-04-29','08:25:00',2.15),('7643','2013-04-29','08:30:00',2.78),('7643','2013-04-29','08:35:00',3.21),('7643','2013-04-29','08:40:00',3.06),('7643','2013-04-29','08:45:00',3.22),('7643','2013-04-29','08:50:00',4.21),('7643','2013-04-29','08:55:00',5.84),('7643','2013-04-29','09:00:00',6.45),('7643','2013-04-29','09:05:00',5.71),('7643','2013-04-29','09:10:00',8.66),('7643','2013-04-29','09:15:00',9.77),('7643','2013-04-29','09:20:00',9.85),('7643','2013-04-29','09:25:00',10.47),('7643','2013-04-29','09:30:00',10.25),('7643','2013-04-29','09:35:00',8.29),('7643','2013-04-29','09:40:00',5.89),('7643','2013-04-29','09:45:00',7.45),('7643','2013-04-29','09:50:00',9.75),('7643','2013-04-29','09:55:00',10.76),('7643','2013-04-29','10:00:00',12.55),('7643','2013-04-29','10:05:00',12.01),('7643','2013-04-29','10:10:00',10.56),('7643','2013-04-29','10:15:00',9.34),('7643','2013-04-29','10:20:00',8.49),('7643','2013-04-29','10:25:00',8.75),('7643','2013-04-29','10:30:00',7.75),('7643','2013-04-29','10:35:00',7.08),('7643','2013-04-29','10:40:00',5.99),('7643','2013-04-29','10:45:00',4.79),('7643','2013-04-29','10:50:00',5.26),('7643','2013-04-29','10:55:00',5.52),('7643','2013-04-29','11:00:00',5.68),('7643','2013-04-29','11:05:00',6.44),('7643','2013-04-29','11:10:00',6.53),('7643','2013-04-29','11:15:00',6.98),('7643','2013-04-29','11:20:00',7.88),('7643','2013-04-29','11:25:00',7.24),('7643','2013-04-29','11:30:00',7.04),('7643','2013-04-29','11:35:00',7.5),('7643','2013-04-29','11:40:00',7.22),('7643','2013-04-29','11:45:00',6.28),('7643','2013-04-29','11:50:00',6.51),('7643','2013-04-29','11:55:00',6.63),('7643','2013-04-29','12:00:00',6.54),('7643','2013-04-29','12:05:00',6.6),('7643','2013-04-29','12:10:00',6.42),('7643','2013-04-29','12:15:00',5.95),('7643','2013-04-29','12:20:00',5.24),('7643','2013-04-29','12:25:00',4.81),('7643','2013-04-29','12:30:00',4.92),('7643','2013-04-29','12:35:00',9.39),('7643','2013-04-29','12:40:00',16.34),('7643','2013-04-29','12:45:00',17.3),('7643','2013-04-29','12:50:00',16.61),('7643','2013-04-29','12:55:00',14.26),('7643','2013-04-29','13:00:00',15.55),('7643','2013-04-29','13:05:00',15.3),('7643','2013-04-29','13:10:00',15.55),('7643','2013-04-29','13:15:00',15.41),('7643','2013-04-29','13:20:00',15.22),('7643','2013-04-29','13:25:00',15.15),('7643','2013-04-29','13:30:00',15.09),('7643','2013-04-29','13:35:00',15.02),('7643','2013-04-29','13:40:00',14.87),('7643','2013-04-29','13:45:00',14.82),('7643','2013-04-29','13:50:00',14.76),('7643','2013-04-29','13:55:00',14.63),('7643','2013-04-29','14:00:00',14.53),('7643','2013-04-29','14:05:00',14.43),('7643','2013-04-29','14:10:00',14.33),('7643','2013-04-29','14:15:00',14.23),('7643','2013-04-29','14:20:00',14.21),('7643','2013-04-29','14:25:00',14.08),('7643','2013-04-29','14:30:00',14),('7643','2013-04-29','14:35:00',13.85),('7643','2013-04-29','14:40:00',13.64),('7643','2013-04-29','14:45:00',13.39),('7643','2013-04-29','14:50:00',13.18),('7643','2013-04-29','14:55:00',12.95),('7643','2013-04-29','15:00:00',12.8),('7643','2013-04-29','15:05:00',12.6),('7643','2013-04-29','15:10:00',12.41),('7643','2013-04-29','15:15:00',12.17),('7643','2013-04-29','15:20:00',11.99),('7643','2013-04-29','15:25:00',11.77),('7643','2013-04-29','15:30:00',11.62),('7643','2013-04-29','15:35:00',11.57),('7643','2013-04-29','15:40:00',11.34),('7643','2013-04-29','15:45:00',11.1),('7643','2013-04-29','15:50:00',10.89),('7643','2013-04-29','15:55:00',10.64),('7643','2013-04-29','16:00:00',10.41),('7643','2013-04-29','16:05:00',10.21),('7643','2013-04-29','16:10:00',10.01),('7643','2013-04-29','16:15:00',9.81),('7643','2013-04-29','16:20:00',9.55),('7643','2013-04-29','16:25:00',9.32),('7643','2013-04-29','16:30:00',9.16),('7643','2013-04-29','16:35:00',8.61),('7643','2013-04-29','16:40:00',7.36),('7643','2013-04-29','16:45:00',7.22),('7643','2013-04-29','16:50:00',7.01),('7643','2013-04-29','16:55:00',7.65),('7643','2013-04-29','17:00:00',7.14),('7643','2013-04-29','17:05:00',7.05),('7643','2013-04-29','17:10:00',6.01),('7643','2013-04-29','17:15:00',3.09),('7643','2013-04-29','17:20:00',4.77),('7643','2013-04-29','17:25:00',5.73),('7643','2013-04-29','17:30:00',5.51),('7643','2013-04-29','17:35:00',5.31),('7643','2013-04-29','17:40:00',4.99),('7643','2013-04-29','17:45:00',4.68),('7643','2013-04-29','17:50:00',4.36),('7643','2013-04-29','17:55:00',4.01),('7643','2013-04-29','18:00:00',3.74),('7643','2013-04-29','18:05:00',3.5),('7643','2013-04-29','18:10:00',3.26),('7643','2013-04-29','18:15:00',2.98),('7643','2013-04-29','18:20:00',2.72),('7643','2013-04-29','18:25:00',2.48),('7643','2013-04-29','18:30:00',2.25),('7643','2013-04-29','18:35:00',2.06),('7643','2013-04-29','18:40:00',1.85),('7643','2013-04-29','18:45:00',1.66),('7643','2013-04-29','18:50:00',1.48),('7643','2013-04-29','18:55:00',1.28),('7643','2013-04-29','19:00:00',1.1),('7643','2013-04-28','07:05:00',1.07),('7643','2013-04-28','07:10:00',1.55),('7643','2013-04-28','07:15:00',2.08),('7643','2013-04-28','07:20:00',2.57),('7643','2013-04-28','07:25:00',3),('7643','2013-04-28','07:30:00',3.15),('7643','2013-04-28','07:35:00',3.06),('7643','2013-04-28','07:40:00',2.82),('7643','2013-04-28','07:45:00',3.15),('7643','2013-04-28','07:50:00',3.35),('7643','2013-04-28','07:55:00',3.9),('7643','2013-04-28','08:00:00',4.58),('7643','2013-04-28','08:05:00',4.97),('7643','2013-04-28','08:10:00',4.8),('7643','2013-04-28','08:15:00',4.91),('7643','2013-04-28','08:20:00',5.27),('7643','2013-04-28','08:25:00',5.91),('7643','2013-04-28','08:30:00',6.73),('7643','2013-04-28','08:35:00',7.58),('7643','2013-04-28','08:40:00',7.67),('7643','2013-04-28','08:45:00',7.47),('7643','2013-04-28','08:50:00',8.02),('7643','2013-04-28','08:55:00',8.02),('7643','2013-04-28','09:00:00',6.21),('7643','2013-04-28','09:05:00',8.61),('7643','2013-04-28','09:10:00',9.47),('7643','2013-04-28','09:15:00',9.98),('7643','2013-04-28','09:20:00',9.36),('7643','2013-04-28','09:25:00',9.24),('7643','2013-04-28','09:30:00',9.1),('7643','2013-04-28','09:35:00',9.78),('7643','2013-04-28','09:40:00',9.96),('7643','2013-04-28','09:45:00',10.31),('7643','2013-04-28','09:50:00',10.92),('7643','2013-04-28','09:55:00',10.17),('7643','2013-04-28','10:00:00',10.62),('7643','2013-04-28','10:05:00',10.36),('7643','2013-04-28','10:10:00',10.38),('7643','2013-04-28','10:15:00',8.81),('7643','2013-04-28','10:20:00',8.61),('7643','2013-04-28','10:25:00',10.33),('7643','2013-04-28','10:30:00',10.38),('7643','2013-04-28','10:35:00',12.26),('7643','2013-04-28','10:40:00',12.39),('7643','2013-04-28','10:45:00',12.65),('7643','2013-04-28','10:50:00',12.04),('7643','2013-04-28','10:55:00',11.2),('7643','2013-04-28','11:00:00',12.66),('7643','2013-04-28','11:05:00',12.13),('7643','2013-04-28','11:10:00',12.04),('7643','2013-04-28','11:15:00',11.11),('7643','2013-04-28','11:20:00',12.86),('7643','2013-04-28','11:25:00',13.24),('7643','2013-04-28','11:30:00',13.99),('7643','2013-04-28','11:35:00',13.17),('7643','2013-04-28','11:40:00',13.34),('7643','2013-04-28','11:45:00',13.14),('7643','2013-04-28','11:50:00',14.47),('7643','2013-04-28','11:55:00',14.3),('7643','2013-04-28','12:00:00',14.92),('7643','2013-04-28','12:05:00',14.75),('7643','2013-04-28','12:10:00',14.26),('7643','2013-04-28','12:15:00',14.32),('7643','2013-04-28','12:20:00',14.48),('7643','2013-04-28','12:25:00',14.24),('7643','2013-04-28','12:30:00',14.63),('7643','2013-04-28','12:35:00',14.97),('7643','2013-04-28','12:40:00',15.21),('7643','2013-04-28','12:45:00',15.2),('7643','2013-04-28','12:50:00',15.03),('7643','2013-04-28','12:55:00',14.67),('7643','2013-04-28','13:00:00',14.99),('7643','2013-04-28','13:05:00',14.75),('7643','2013-04-28','13:10:00',14.55),('7643','2013-04-28','13:15:00',13.71),('7643','2013-04-28','13:20:00',14.66),('7643','2013-04-28','13:25:00',15.45),('7643','2013-04-28','13:30:00',15.09),('7643','2013-04-28','13:35:00',14.95),('7643','2013-04-28','13:40:00',14.8),('7643','2013-04-28','13:45:00',14.81),('7643','2013-04-28','13:50:00',14.45),('7643','2013-04-28','13:55:00',15.37),('7643','2013-04-28','14:00:00',14.39),('7643','2013-04-28','14:05:00',14.48),('7643','2013-04-28','14:10:00',14.53),('7643','2013-04-28','14:15:00',14.89),('7643','2013-04-28','14:20:00',14.79),('7643','2013-04-28','14:25:00',14.38),('7643','2013-04-28','14:30:00',13.73),('7643','2013-04-28','14:35:00',13.35),('7643','2013-04-28','14:40:00',12.69),('7643','2013-04-28','14:45:00',13.76),('7643','2013-04-28','14:50:00',13.22),('7643','2013-04-28','14:55:00',13.66),('7643','2013-04-28','15:00:00',13.16),('7643','2013-04-28','15:05:00',13.97),('7643','2013-04-28','15:10:00',12.98),('7643','2013-04-28','15:15:00',11.97),('7643','2013-04-28','15:20:00',12.66),('7643','2013-04-28','15:25:00',13.2),('7643','2013-04-28','15:30:00',12.83),('7643','2013-04-28','15:35:00',11.35),('7643','2013-04-28','15:40:00',10.24),('7643','2013-04-28','15:45:00',9.84),('7643','2013-04-28','15:50:00',10.17),('7643','2013-04-28','15:55:00',10.84),('7643','2013-04-28','16:00:00',10.57),('7643','2013-04-28','16:05:00',11.37),('7643','2013-04-28','16:10:00',10.51),('7643','2013-04-28','16:15:00',12.51),('7643','2013-04-28','16:20:00',11.96),('7643','2013-04-28','16:25:00',9.16),('7643','2013-04-28','16:30:00',9.63),('7643','2013-04-28','16:35:00',9.71),('7643','2013-04-28','16:40:00',10.19),('7643','2013-04-28','16:45:00',9.99),('7643','2013-04-28','16:50:00',10.22),('7643','2013-04-28','16:55:00',10.62),('7643','2013-04-28','17:00:00',9.68),('7643','2013-04-28','17:05:00',8.33),('7643','2013-04-28','17:10:00',8.59),('7643','2013-04-28','17:15:00',7.51),('7643','2013-04-28','17:20:00',6.26),('7643','2013-04-28','17:25:00',5.87),('7643','2013-04-28','17:30:00',5.64),('7643','2013-04-28','17:35:00',4.84),('7643','2013-04-28','17:40:00',4.01),('7643','2013-04-28','17:45:00',3.94),('7643','2013-04-28','17:50:00',4.7),('7643','2013-04-28','17:55:00',5.21),('7643','2013-04-28','18:00:00',5.03),('7643','2013-04-28','18:05:00',5.51),('7643','2013-04-28','18:10:00',4.92),('7643','2013-04-28','18:15:00',4.64),('7643','2013-04-28','18:20:00',3.85),('7643','2013-04-28','18:25:00',3.68),('7643','2013-04-28','18:30:00',3.34),('7643','2013-04-28','18:35:00',2.48),('7643','2013-04-28','18:40:00',2.11),('7643','2013-04-28','18:45:00',1.59),('7643','2013-04-28','18:50:00',1.06),('7643','2013-04-27','07:00:00',1.05),('7643','2013-04-27','07:05:00',1.26),('7643','2013-04-27','07:10:00',1.49),('7643','2013-04-27','07:15:00',1.74),('7643','2013-04-27','07:20:00',2),('7643','2013-04-27','07:25:00',2.25),('7643','2013-04-27','07:30:00',2.58),('7643','2013-04-27','07:35:00',2.92),('7643','2013-04-27','07:40:00',3.29),('7643','2013-04-27','07:45:00',3.69),('7643','2013-04-27','07:50:00',4.04),('7643','2013-04-27','07:55:00',4.35),('7643','2013-04-27','08:00:00',4.64),('7643','2013-04-27','08:05:00',5.12),('7643','2013-04-27','08:10:00',5.55),('7643','2013-04-27','08:15:00',5.85),('7643','2013-04-27','08:20:00',4.61),('7643','2013-04-27','08:40:00',4.2),('7643','2013-04-27','08:45:00',7.59),('7643','2013-04-27','09:40:00',10.86),('7643','2013-04-27','09:45:00',11.11),('7643','2013-04-27','09:50:00',11.37),('7643','2013-04-27','09:55:00',11.64),('7643','2013-04-27','10:00:00',11.89),('7643','2013-04-27','10:05:00',12.02),('7643','2013-04-27','10:10:00',12.14),('7643','2013-04-27','10:15:00',12.07),('7643','2013-04-27','10:20:00',12.54),('7643','2013-04-27','10:25:00',12.99),('7643','2013-04-27','10:30:00',12.88),('7643','2013-04-27','10:35:00',13.22),('7643','2013-04-27','10:40:00',12.06),('7643','2013-04-27','10:45:00',13.68),('7643','2013-04-27','10:50:00',13.66),('7643','2013-04-27','10:55:00',13.75),('7643','2013-04-27','11:00:00',13.86),('7643','2013-04-27','11:05:00',13.99),('7643','2013-04-27','11:10:00',14.34),('7643','2013-04-27','11:15:00',14.43),('7643','2013-04-27','11:20:00',14.29),('7643','2013-04-27','11:25:00',14.61),('7643','2013-04-27','11:30:00',14.69),('7643','2013-04-27','11:35:00',14.31),('7643','2013-04-27','11:40:00',14.58),('7643','2013-04-27','11:45:00',13.87),('7643','2013-04-27','11:50:00',14.15),('7643','2013-04-27','11:55:00',14.62),('7643','2013-04-27','12:00:00',13.09),('7643','2013-04-27','12:05:00',12.96),('7643','2013-04-27','12:10:00',14.48),('7643','2013-04-27','12:15:00',14.82),('7643','2013-04-27','12:20:00',14.62),('7643','2013-04-27','12:25:00',13.2),('7643','2013-04-27','12:30:00',12.29),('7643','2013-04-27','12:35:00',10.78),('7643','2013-04-27','12:40:00',11.44),('7643','2013-04-27','12:45:00',15.14),('7643','2013-04-27','12:50:00',15.37),('7643','2013-04-27','12:55:00',14.28),('7643','2013-04-27','13:00:00',14.63),('7643','2013-04-27','13:05:00',15.98),('7643','2013-04-27','13:10:00',15.36),('7643','2013-04-27','13:15:00',13.95),('7643','2013-04-27','13:20:00',14.57),('7643','2013-04-27','13:25:00',14.06),('7643','2013-04-27','13:30:00',15.32),('7643','2013-04-27','13:35:00',15.33),('7643','2013-04-27','13:40:00',16.34),('7643','2013-04-27','13:45:00',15.23),('7643','2013-04-27','13:50:00',12.23),('7643','2013-04-27','13:55:00',14.49),('7643','2013-04-27','14:00:00',15.72),('7643','2013-04-27','14:05:00',15.24),('7643','2013-04-27','14:10:00',14.5),('7643','2013-04-27','14:15:00',14.72),('7643','2013-04-27','14:20:00',14.66),('7643','2013-04-27','14:25:00',14.61),('7643','2013-04-27','14:30:00',14.45),('7643','2013-04-27','14:35:00',14.39),('7643','2013-04-27','14:40:00',14.15),('7643','2013-04-27','14:45:00',13.98),('7643','2013-04-27','14:50:00',13.87),('7643','2013-04-27','14:55:00',13.75),('7643','2013-04-27','15:00:00',13.67),('7643','2013-04-27','15:05:00',13.54),('7643','2013-04-27','15:10:00',13.4),('7643','2013-04-27','15:15:00',13.18),('7643','2013-04-27','15:20:00',12.94),('7643','2013-04-27','15:25:00',12.74),('7643','2013-04-27','15:30:00',12.59),('7643','2013-04-27','15:35:00',12.45),('7643','2013-04-27','15:40:00',12.36),('7643','2013-04-27','15:45:00',12.13),('7643','2013-04-27','15:50:00',11.91),('7643','2013-04-27','15:55:00',11.64),('7643','2013-04-27','16:00:00',11.42),('7643','2013-04-27','16:05:00',11.21),('7643','2013-04-27','16:10:00',10.96),('7643','2013-04-27','16:15:00',10.69),('7643','2013-04-27','16:20:00',10.43),('7643','2013-04-27','16:25:00',10.2),('7643','2013-04-27','16:30:00',9.98),('7643','2013-04-27','16:35:00',9.73),('7643','2013-04-27','16:40:00',9.43),('7643','2013-04-27','16:45:00',9.18),('7643','2013-04-27','16:50:00',8.93),('7643','2013-04-27','16:55:00',8.55),('7643','2013-04-27','17:00:00',8.3),('7643','2013-04-27','17:05:00',7.66),('7643','2013-04-27','17:10:00',7.32),('7643','2013-04-27','17:15:00',7.57),('7643','2013-04-27','17:20:00',7.15),('7643','2013-04-27','17:25:00',6.95),('7643','2013-04-27','17:30:00',5.94),('7643','2013-04-27','17:35:00',5.78),('7643','2013-04-27','17:40:00',5.39),('7643','2013-04-27','17:45:00',5.42),('7643','2013-04-27','17:50:00',5.17),('7643','2013-04-27','17:55:00',4.47),('7643','2013-04-27','18:00:00',4.33),('7643','2013-04-27','18:05:00',4.1),('7643','2013-04-27','18:10:00',2.83),('7643','2013-04-27','18:15:00',2.76),('7643','2013-04-27','18:20:00',3.27),('7643','2013-04-27','18:25:00',3.15),('7643','2013-04-27','18:30:00',2.54),('7643','2013-04-27','18:35:00',2.3),('7643','2013-04-27','18:40:00',2.12),('7643','2013-04-27','18:45:00',1.71),('7643','2013-04-27','18:50:00',1.64),('7643','2013-04-27','18:55:00',1.54),('7643','2013-04-27','19:00:00',1.46),('7643','2013-04-27','19:05:00',1.34),('7643','2013-04-27','19:10:00',1.22),('7643','2013-04-27','19:15:00',1.06),('7643','2013-04-26','07:30:00',1.12),('7643','2013-04-26','07:35:00',1.63),('7643','2013-04-26','07:40:00',1.67),('7643','2013-04-26','07:45:00',1.46),('7643','2013-04-26','07:50:00',1.42),('7643','2013-04-26','09:55:00',1.46),('7643','2013-04-26','10:00:00',1.33),('7643','2013-04-26','10:05:00',1.27),('7643','2013-04-26','10:10:00',1.09),('7643','2013-04-26','10:15:00',1.09),('7643','2013-04-26','10:20:00',1.13),('7643','2013-04-26','10:25:00',1.21),('7643','2013-04-26','10:40:00',1.12),('7643','2013-04-26','10:45:00',1.2),('7643','2013-04-26','10:50:00',1.09),('7643','2013-04-26','10:55:00',1.03),('7643','2013-04-26','11:00:00',1.09),('7643','2013-04-26','11:15:00',1.11),('7643','2013-04-26','11:20:00',1.03),('7643','2013-04-26','11:25:00',1.03),('7643','2013-04-26','11:30:00',1.15),('7643','2013-04-26','11:35:00',1.33),('7643','2013-04-26','11:40:00',1.57),('7643','2013-04-26','11:45:00',1.87),('7643','2013-04-26','11:50:00',2.16),('7643','2013-04-26','12:00:00',2.46),('7643','2013-04-26','12:05:00',2.41),('7643','2013-04-26','12:10:00',2.25),('7643','2013-04-26','12:15:00',2.11),('7643','2013-04-26','12:20:00',1.93),('7643','2013-04-26','12:25:00',1.91),('7643','2013-04-26','12:30:00',2.09),('7643','2013-04-26','12:35:00',2.32),('7643','2013-04-26','12:40:00',2.91),('7643','2013-04-26','12:45:00',3.15),('7643','2013-04-26','12:50:00',3.61),('7643','2013-04-26','12:55:00',4.78),('7643','2013-04-26','13:00:00',5.13),('7643','2013-04-26','13:05:00',3.9),('7643','2013-04-26','13:10:00',3.97),('7643','2013-04-26','13:15:00',5.07),('7643','2013-04-26','13:20:00',5.13),('7643','2013-04-26','13:25:00',3.99),('7643','2013-04-26','13:30:00',4.42),('7643','2013-04-26','13:35:00',5.38),('7643','2013-04-26','13:40:00',7.07),('7643','2013-04-26','13:45:00',4.28),('7643','2013-04-26','13:50:00',4),('7643','2013-04-26','13:55:00',3.04),('7643','2013-04-26','14:00:00',2.45),('7643','2013-04-26','14:05:00',2.86),('7643','2013-04-26','14:10:00',2.11),('7643','2013-04-26','14:15:00',2.03),('7643','2013-04-26','14:20:00',2.41),('7643','2013-04-26','14:25:00',5.18),('7643','2013-04-26','14:30:00',8.13),('7643','2013-04-26','14:35:00',6.52),('7643','2013-04-26','14:40:00',4.83),('7643','2013-04-26','14:45:00',4.56),('7643','2013-04-26','14:50:00',2.82),('7643','2013-04-26','14:55:00',3.59),('7643','2013-04-26','15:00:00',4.68),('7643','2013-04-26','15:05:00',7.88),('7643','2013-04-26','15:10:00',5.47),('7643','2013-04-26','15:15:00',4.61),('7643','2013-04-26','15:20:00',2.55),('7643','2013-04-26','15:25:00',2.29),('7643','2013-04-26','15:30:00',1.19),('7643','2013-04-26','15:35:00',1.31),('7643','2013-04-26','15:40:00',1.77),('7643','2013-04-26','15:45:00',1.5),('7643','2013-04-26','15:50:00',2.57),('7643','2013-04-26','16:30:00',2.23),('7643','2013-04-26','16:35:00',2.53),('7643','2013-04-26','16:40:00',3.46),('7643','2013-04-26','16:45:00',4.66),('7643','2013-04-26','16:55:00',9.26),('7643','2013-04-26','17:00:00',10),('7643','2013-04-26','17:05:00',5.36),('7643','2013-04-26','17:10:00',2.76),('7643','2013-04-26','17:15:00',1.96),('7643','2013-04-26','17:20:00',3.73),('7643','2013-04-26','17:25:00',2.45),('7643','2013-04-26','17:30:00',1.95),('7643','2013-04-26','17:35:00',2.67),('7643','2013-04-26','17:40:00',4.96),('7643','2013-04-26','17:50:00',2.1),('7643','2013-04-26','17:55:00',2.04),('7643','2013-04-26','18:00:00',2.11),('7643','2013-04-26','18:05:00',2.33),('7643','2013-04-26','18:10:00',1.94),('7643','2013-04-26','18:15:00',2.14),('7643','2013-04-26','18:20:00',1.81),('7643','2013-04-26','18:25:00',1.33),('7643','2013-04-26','18:30:00',1.12),('7643','2013-04-26','18:55:00',1.08),('7643','2013-04-25','06:50:00',1.11),('7643','2013-04-25','06:55:00',1.43),('7643','2013-04-25','07:00:00',1.7),('7643','2013-04-25','07:05:00',1.92),('7643','2013-04-25','07:10:00',2.11),('7643','2013-04-25','07:15:00',2.28),('7643','2013-04-25','07:20:00',2.32),('7643','2013-04-25','07:25:00',2.35),('7643','2013-04-25','07:30:00',2.34),('7643','2013-04-25','07:35:00',2.11),('7643','2013-04-25','07:40:00',2.06),('7643','2013-04-25','07:45:00',2.11),('7643','2013-04-25','07:50:00',2.45),('7643','2013-04-25','07:55:00',2.79),('7643','2013-04-25','08:00:00',3.08),('7643','2013-04-25','08:05:00',3.63),('7643','2013-04-25','08:10:00',4.72),('7643','2013-04-25','08:15:00',5.19),('7643','2013-04-25','08:20:00',5.41),('7643','2013-04-25','08:25:00',5.64),('7643','2013-04-25','08:30:00',5.86),('7643','2013-04-25','08:35:00',6.38),('7643','2013-04-25','08:40:00',6.65),('7643','2013-04-25','08:45:00',7.05),('7643','2013-04-25','08:50:00',7.11),('7643','2013-04-25','08:55:00',5.43),('7643','2013-04-25','09:00:00',6.45),('7643','2013-04-25','09:05:00',8.25),('7643','2013-04-25','09:10:00',6.98),('7643','2013-04-25','09:15:00',4.38),('7643','2013-04-25','09:20:00',4.38),('7643','2013-04-25','09:25:00',5.13),('7643','2013-04-25','09:30:00',6.01),('7643','2013-04-25','09:35:00',7.11),('7643','2013-04-25','09:40:00',7.9),('7643','2013-04-25','09:45:00',10.44),('7643','2013-04-25','09:50:00',9.75),('7643','2013-04-25','09:55:00',6.8),('7643','2013-04-25','10:00:00',7.58),('7643','2013-04-25','10:05:00',9.94),('7643','2013-04-25','10:10:00',11.74),('7643','2013-04-25','10:15:00',12.14),('7643','2013-04-25','10:20:00',11.74),('7643','2013-04-25','10:25:00',9.83),('7643','2013-04-25','10:30:00',13.15),('7643','2013-04-25','10:35:00',13.52),('7643','2013-04-25','10:40:00',13.13),('7643','2013-04-25','10:45:00',10.72),('7643','2013-04-25','10:50:00',8.85),('7643','2013-04-25','10:55:00',8.93),('7643','2013-04-25','11:00:00',11.89),('7643','2013-04-25','11:05:00',13.38),('7643','2013-04-25','11:10:00',12.13),('7643','2013-04-25','11:15:00',13.8),('7643','2013-04-25','11:20:00',10.27),('7643','2013-04-25','11:25:00',11.98),('7643','2013-04-25','11:30:00',12.02),('7643','2013-04-25','11:35:00',13.4),('7643','2013-04-25','11:40:00',12.48),('7643','2013-04-25','11:45:00',12.51),('7643','2013-04-25','11:50:00',9.82),('7643','2013-04-25','11:55:00',9.88),('7643','2013-04-25','12:00:00',11.03),('7643','2013-04-25','12:05:00',9.54),('7643','2013-04-25','12:10:00',8.74),('7643','2013-04-25','12:15:00',10.39),('7643','2013-04-25','12:20:00',9.55),('7643','2013-04-25','12:25:00',7.47),('7643','2013-04-25','12:30:00',6.74),('7643','2013-04-25','12:35:00',8.62),('7643','2013-04-25','12:40:00',13.08),('7643','2013-04-25','12:45:00',13.13),('7643','2013-04-25','12:50:00',7.9),('7643','2013-04-25','12:55:00',7.27),('7643','2013-04-25','13:00:00',5.27),('7643','2013-04-25','13:05:00',5.08),('7643','2013-04-25','13:10:00',6.15),('7643','2013-04-25','13:15:00',8.49),('7643','2013-04-25','13:20:00',6.24),('7643','2013-04-25','13:25:00',7.83),('7643','2013-04-25','13:30:00',9.9),('7643','2013-04-25','13:35:00',8.68),('7643','2013-04-25','13:40:00',10.08),('7643','2013-04-25','13:45:00',9.01),('7643','2013-04-25','13:50:00',9.56),('7643','2013-04-25','13:55:00',9.65),('7643','2013-04-25','14:00:00',10.32),('7643','2013-04-25','14:05:00',13.25),('7643','2013-04-25','14:10:00',13.77),('7643','2013-04-25','14:15:00',11.99),('7643','2013-04-25','14:20:00',13.56),('7643','2013-04-25','14:25:00',13.07),('7643','2013-04-25','14:30:00',15.11),('7643','2013-04-25','14:35:00',11.32),('7643','2013-04-25','14:40:00',6.36),('7643','2013-04-25','14:45:00',7.08),('7643','2013-04-25','14:50:00',14.99),('7643','2013-04-25','14:55:00',15.52),('7643','2013-04-25','15:00:00',14.22),('7643','2013-04-25','15:05:00',9.88),('7643','2013-04-25','15:10:00',5.05),('7643','2013-04-25','15:15:00',5.96),('7643','2013-04-25','15:20:00',5.43),('7643','2013-04-25','15:25:00',6.02),('7643','2013-04-25','15:30:00',8.52),('7643','2013-04-25','15:35:00',7),('7643','2013-04-25','15:40:00',7.13),('7643','2013-04-25','15:45:00',7.27),('7643','2013-04-25','15:50:00',6.83),('7643','2013-04-25','15:55:00',4.16),('7643','2013-04-25','16:00:00',2.13),('7643','2013-04-25','16:05:00',1.64),('7643','2013-04-25','16:10:00',1.32),('7643','2013-04-25','16:15:00',1.09),('7643','2013-04-25','16:20:00',1.28),('7643','2013-04-25','16:25:00',1.54),('7643','2013-04-25','16:30:00',1.77),('7643','2013-04-25','16:35:00',2.15),('7643','2013-04-25','16:40:00',2.06),('7643','2013-04-25','16:45:00',1.43),('7643','2013-04-25','17:00:00',1.02),('7643','2013-04-25','17:05:00',1.08),('7643','2013-04-24','07:10:00',1.08),('7643','2013-04-24','07:15:00',1.25),('7643','2013-04-24','07:20:00',1.4),('7643','2013-04-24','07:25:00',1.54),('7643','2013-04-24','07:30:00',1.7),('7643','2013-04-24','07:35:00',2.16),('7643','2013-04-24','07:40:00',2.32),('7643','2013-04-24','07:45:00',2.81),('7643','2013-04-24','07:50:00',2.72),('7643','2013-04-24','07:55:00',2.61),('7643','2013-04-24','08:00:00',2.98),('7643','2013-04-24','08:05:00',4.01),('7643','2013-04-24','08:10:00',4.2),('7643','2013-04-24','08:15:00',5.32),('7643','2013-04-24','08:20:00',4.51),('7643','2013-04-24','08:25:00',3.68),('7643','2013-04-24','08:30:00',3.86),('7643','2013-04-24','08:35:00',3.96),('7643','2013-04-24','08:40:00',4.11),('7643','2013-04-24','08:45:00',5.17),('7643','2013-04-24','08:50:00',8.23),('7643','2013-04-24','08:55:00',9.38),('7643','2013-04-24','09:00:00',7.86),('7643','2013-04-24','09:05:00',5.72),('7643','2013-04-24','09:10:00',5.3),('7643','2013-04-24','09:15:00',4.83),('7643','2013-04-24','09:20:00',5.07),('7643','2013-04-24','09:25:00',6.12),('7643','2013-04-24','09:30:00',5.39),('7643','2013-04-24','09:35:00',6.01),('7643','2013-04-24','09:40:00',8.25),('7643','2013-04-24','09:45:00',10.3),('7643','2013-04-24','09:50:00',12.04),('7643','2013-04-24','09:55:00',12.11),('7643','2013-04-24','10:00:00',12.27),('7643','2013-04-24','10:05:00',11.66),('7643','2013-04-24','10:10:00',10.82),('7643','2013-04-24','10:15:00',10.52),('7643','2013-04-24','10:20:00',12.48),('7643','2013-04-24','10:25:00',12.74),('7643','2013-04-24','10:30:00',13.32),('7643','2013-04-24','10:35:00',13.53),('7643','2013-04-24','10:40:00',13.53),('7643','2013-04-24','10:45:00',12.67),('7643','2013-04-24','10:50:00',12.88),('7643','2013-04-24','10:55:00',13.86),('7643','2013-04-24','11:00:00',14.37),('7643','2013-04-24','11:05:00',14.41),('7643','2013-04-24','11:10:00',14.6),('7643','2013-04-24','11:15:00',14.67),('7643','2013-04-24','11:20:00',14.77),('7643','2013-04-24','11:25:00',14.98),('7643','2013-04-24','11:30:00',15.16),('7643','2013-04-24','11:35:00',14.96),('7643','2013-04-24','11:40:00',15.27),('7643','2013-04-24','11:45:00',15.49),('7643','2013-04-24','11:50:00',15.64),('7643','2013-04-24','11:55:00',15.42),('7643','2013-04-24','12:00:00',15.24),('7643','2013-04-24','12:05:00',15.26),('7643','2013-04-24','12:10:00',15.55),('7643','2013-04-24','12:15:00',15.72),('7643','2013-04-24','12:20:00',15.76),('7643','2013-04-24','12:25:00',15.71),('7643','2013-04-24','12:30:00',15.84),('7643','2013-04-24','12:35:00',15.95),('7643','2013-04-24','12:40:00',15.89),('7643','2013-04-24','12:45:00',15.88),('7643','2013-04-24','12:50:00',15.76),('7643','2013-04-24','12:55:00',15.9),('7643','2013-04-24','13:00:00',16.08),('7643','2013-04-24','13:05:00',16.28),('7643','2013-04-24','13:10:00',16.14),('7643','2013-04-24','13:15:00',14.48),('7643','2013-04-24','13:20:00',13.55),('7643','2013-04-24','13:25:00',12.96),('7643','2013-04-24','13:30:00',10.67),('7643','2013-04-24','13:35:00',10.42),('7643','2013-04-24','13:40:00',9),('7643','2013-04-24','13:45:00',8.3),('7643','2013-04-24','13:50:00',7.78),('7643','2013-04-24','13:55:00',8.35),('7643','2013-04-24','14:00:00',8.46),('7643','2013-04-24','14:05:00',7.95),('7643','2013-04-24','14:10:00',8.59),('7643','2013-04-24','14:15:00',9.01),('7643','2013-04-24','14:20:00',9.25),('7643','2013-04-24','14:25:00',9.29),('7643','2013-04-24','14:30:00',10.85),('7643','2013-04-24','14:35:00',12.99),('7643','2013-04-24','14:40:00',13.37),('7643','2013-04-24','14:45:00',13.41),('7643','2013-04-24','14:50:00',12.19),('7643','2013-04-24','14:55:00',12.28),('7643','2013-04-24','15:00:00',12.2),('7643','2013-04-24','15:05:00',10.88),('7643','2013-04-24','15:10:00',11.02),('7643','2013-04-24','15:15:00',12.25),('7643','2013-04-24','15:20:00',12.91),('7643','2013-04-24','15:25:00',13.52),('7643','2013-04-24','15:30:00',13.24),('7643','2013-04-24','15:35:00',12.31),('7643','2013-04-24','15:40:00',11.76),('7643','2013-04-24','15:45:00',10.73),('7643','2013-04-24','15:50:00',10.1),('7643','2013-04-24','15:55:00',9.84),('7643','2013-04-24','16:00:00',9.91),('7643','2013-04-24','16:05:00',7.99),('7643','2013-04-24','16:10:00',8.67),('7643','2013-04-24','16:15:00',8.1),('7643','2013-04-24','16:20:00',8.3),('7643','2013-04-24','16:25:00',7.3),('7643','2013-04-24','16:30:00',7.1),('7643','2013-04-24','16:35:00',8.85),('7643','2013-04-24','16:40:00',7.93),('7643','2013-04-24','16:45:00',7.21),('7643','2013-04-24','16:50:00',6.5),('7643','2013-04-24','16:55:00',7.28),('7643','2013-04-24','17:00:00',6.57),('7643','2013-04-24','17:05:00',8.51),('7643','2013-04-24','17:10:00',8.96),('7643','2013-04-24','17:15:00',8.23),('7643','2013-04-24','17:20:00',7.88),('7643','2013-04-24','17:25:00',6.72),('7643','2013-04-24','17:30:00',5.07),('7643','2013-04-24','17:35:00',4.94),('7643','2013-04-24','17:40:00',5.14),('7643','2013-04-24','17:45:00',4.19),('7643','2013-04-24','17:50:00',3.56),('7643','2013-04-24','17:55:00',3.08),('7643','2013-04-24','18:00:00',3),('7643','2013-04-24','18:05:00',2.8),('7643','2013-04-24','18:10:00',2.6),('7643','2013-04-24','18:15:00',2.36),('7643','2013-04-24','18:20:00',2.14),('7643','2013-04-24','18:25:00',1.93),('7643','2013-04-24','18:30:00',1.75),('7643','2013-04-24','18:35:00',1.6),('7643','2013-04-24','18:40:00',1.47),('7643','2013-04-24','18:45:00',1.36),('7643','2013-04-24','18:50:00',1.24),('7643','2013-04-24','18:55:00',1.1),('7643','2013-04-23','07:15:00',1.08),('7643','2013-04-23','07:20:00',1.29),('7643','2013-04-23','07:25:00',1.44),('7643','2013-04-23','07:30:00',1.67),('7643','2013-04-23','07:35:00',2.15),('7643','2013-04-23','07:40:00',2.69),('7643','2013-04-23','07:45:00',3.17),('7643','2013-04-23','07:50:00',3.64),('7643','2013-04-23','07:55:00',4.04),('7643','2013-04-23','08:00:00',4.24),('7643','2013-04-23','08:05:00',4.47),('7643','2013-04-23','08:10:00',5.13),('7643','2013-04-23','08:15:00',5.87),('7643','2013-04-23','08:20:00',6.14),('7643','2013-04-23','08:25:00',6.64),('7643','2013-04-23','08:30:00',6.65),('7643','2013-04-23','08:35:00',6.42),('7643','2013-04-23','08:40:00',6.64),('7643','2013-04-23','08:45:00',6.87),('7643','2013-04-23','08:50:00',7.29),('7643','2013-04-23','08:55:00',7.52),('7643','2013-04-23','09:00:00',8.56),('7643','2013-04-23','09:05:00',8.88),('7643','2013-04-23','09:10:00',8.82),('7643','2013-04-23','09:15:00',9.01),('7643','2013-04-23','09:20:00',7.9),('7643','2013-04-23','09:25:00',9.73),('7643','2013-04-23','09:30:00',11.54),('7643','2013-04-23','09:35:00',11.22),('7643','2013-04-23','09:40:00',10.21),('7643','2013-04-23','09:45:00',9.74),('7643','2013-04-23','09:50:00',10.51),('7643','2013-04-23','09:55:00',11.99),('7643','2013-04-23','10:00:00',12.58),('7643','2013-04-23','10:05:00',12.91),('7643','2013-04-23','10:10:00',13.03),('7643','2013-04-23','10:15:00',13.13),('7643','2013-04-23','10:20:00',12.78),('7643','2013-04-23','10:25:00',12.56),('7643','2013-04-23','10:30:00',12.47),('7643','2013-04-23','10:35:00',12.52),('7643','2013-04-23','10:40:00',13.93),('7643','2013-04-23','10:45:00',14.11),('7643','2013-04-23','10:50:00',14.34),('7643','2013-04-23','10:55:00',14.82),('7643','2013-04-23','11:00:00',14.86),('7643','2013-04-23','11:05:00',14.41),('7643','2013-04-23','11:10:00',15.48),('7643','2013-04-23','11:15:00',15.74),('7643','2013-04-23','11:20:00',16.12),('7643','2013-04-23','11:25:00',16.44),('7643','2013-04-23','11:30:00',15.96),('7643','2013-04-23','11:35:00',12.9),('7643','2013-04-23','11:40:00',10.51),('7643','2013-04-23','11:45:00',10.98),('7643','2013-04-23','11:50:00',8.21),('7643','2013-04-23','11:55:00',12.03),('7643','2013-04-23','12:00:00',13.64),('7643','2013-04-23','12:05:00',8.89),('7643','2013-04-23','12:10:00',10.63),('7643','2013-04-23','12:15:00',15.65),('7643','2013-04-23','12:20:00',18),('7643','2013-04-23','12:25:00',15.56),('7643','2013-04-23','12:30:00',15.06),('7643','2013-04-23','12:35:00',15.68),('7643','2013-04-23','12:40:00',14.83),('7643','2013-04-23','12:45:00',14.87),('7643','2013-04-23','12:50:00',15.92),('7643','2013-04-23','12:55:00',15.52),('7643','2013-04-23','13:00:00',15.38),('7643','2013-04-23','13:05:00',13.41),('7643','2013-04-23','13:10:00',17.05),('7643','2013-04-23','13:15:00',16.13),('7643','2013-04-23','13:20:00',15.13),('7643','2013-04-23','13:25:00',15.59),('7643','2013-04-23','13:30:00',14.59),('7643','2013-04-23','13:35:00',15.73),('7643','2013-04-23','13:40:00',16.58),('7643','2013-04-23','13:45:00',15.06),('7643','2013-04-23','13:50:00',10.3),('7643','2013-04-23','13:55:00',16.26),('7643','2013-04-23','14:00:00',16.39),('7643','2013-04-23','14:05:00',11.34),('7643','2013-04-23','14:10:00',11.03),('7643','2013-04-23','14:15:00',16.1),('7643','2013-04-23','14:20:00',14.6),('7643','2013-04-23','14:25:00',15.07),('7643','2013-04-23','14:30:00',14.14),('7643','2013-04-23','14:35:00',12.71),('7643','2013-04-23','14:40:00',12.15),('7643','2013-04-23','14:45:00',11.74),('7643','2013-04-23','14:50:00',10.58),('7643','2013-04-23','14:55:00',9.13),('7643','2013-04-23','15:00:00',9.96),('7643','2013-04-23','15:05:00',9.02),('7643','2013-04-23','15:10:00',8.52),('7643','2013-04-23','15:15:00',8.98),('7643','2013-04-23','15:20:00',9.5),('7643','2013-04-23','15:25:00',8.07),('7643','2013-04-23','15:30:00',6.7),('7643','2013-04-23','15:35:00',6.55),('7643','2013-04-23','15:40:00',6.38),('7643','2013-04-23','15:45:00',6.44),('7643','2013-04-23','15:50:00',6.56),('7643','2013-04-23','15:55:00',8.09),('7643','2013-04-23','16:00:00',10.54),('7643','2013-04-23','16:05:00',10.65),('7643','2013-04-23','16:10:00',10.68),('7643','2013-04-23','16:15:00',9.52),('7643','2013-04-23','16:20:00',12.36),('7643','2013-04-23','16:25:00',9.56),('7643','2013-04-23','16:30:00',8.46),('7643','2013-04-23','16:35:00',6.96),('7643','2013-04-23','16:40:00',9.48),('7643','2013-04-23','16:45:00',9.9),('7643','2013-04-23','16:50:00',8.7),('7643','2013-04-23','16:55:00',10.26),('7643','2013-04-23','17:00:00',10.5),('7643','2013-04-23','17:05:00',9.74),('7643','2013-04-23','17:10:00',9.2),('7643','2013-04-23','17:15:00',7.12),('7643','2013-04-23','17:20:00',6.36),('7643','2013-04-23','17:25:00',6.04),('7643','2013-04-23','17:30:00',3.62),('7643','2013-04-23','17:35:00',3.14),('7643','2013-04-23','17:40:00',2.53),('7643','2013-04-23','17:45:00',3.27),('7643','2013-04-23','17:50:00',3.84),('7643','2013-04-23','17:55:00',5.04),('7643','2013-04-23','18:00:00',4.08),('7643','2013-04-23','18:05:00',3.97),('7643','2013-04-23','18:10:00',3.42),('7643','2013-04-23','18:15:00',2.33),('7643','2013-04-23','18:20:00',3.3),('7643','2013-04-23','18:25:00',3.01),('7643','2013-04-23','18:30:00',2.12),('7643','2013-04-23','18:35:00',1.5),('7643','2013-04-23','18:40:00',1.52),('7643','2013-04-23','18:45:00',1.31),('7643','2013-04-23','18:50:00',1.24),('7643','2013-04-23','18:55:00',1.09),('7643','2013-04-22','07:05:00',1.05),('7643','2013-04-22','07:10:00',1.31),('7643','2013-04-22','07:15:00',1.57),('7643','2013-04-22','07:20:00',1.89),('7643','2013-04-22','07:25:00',2.2),('7643','2013-04-22','07:30:00',2.5),('7643','2013-04-22','07:35:00',2.87),('7643','2013-04-22','07:40:00',3.25),('7643','2013-04-22','07:45:00',3.61),('7643','2013-04-22','07:50:00',4.02),('7643','2013-04-22','07:55:00',4.43),('7643','2013-04-22','08:00:00',4.88),('7643','2013-04-22','08:05:00',5.26),('7643','2013-04-22','08:10:00',5.65),('7643','2013-04-22','08:15:00',6.1),('7643','2013-04-22','08:20:00',6.5),('7643','2013-04-22','08:25:00',6.85),('7643','2013-04-22','08:30:00',7.23),('7643','2013-04-22','08:35:00',7.64),('7643','2013-04-22','08:40:00',7.97),('7643','2013-04-22','08:45:00',8.3),('7643','2013-04-22','08:50:00',8.63),('7643','2013-04-22','08:55:00',8.96),('7643','2013-04-22','09:00:00',9.3),('7643','2013-04-22','09:05:00',9.66),('7643','2013-04-22','09:10:00',10),('7643','2013-04-22','09:15:00',10.4),('7643','2013-04-22','09:20:00',10.7),('7643','2013-04-22','09:25:00',10.96),('7643','2013-04-22','09:30:00',11.22),('7643','2013-04-22','09:35:00',11.53),('7643','2013-04-22','09:40:00',10.67),('7643','2013-04-22','09:45:00',10.63),('7643','2013-04-22','09:50:00',12.51),('7643','2013-04-22','09:55:00',12.69),('7643','2013-04-22','10:00:00',12.8),('7643','2013-04-22','10:05:00',12.87),('7643','2013-04-22','10:10:00',13.11),('7643','2013-04-22','10:15:00',13.34),('7643','2013-04-22','10:20:00',13.6),('7643','2013-04-22','10:25:00',13.78),('7643','2013-04-22','10:30:00',13.93),('7643','2013-04-22','10:35:00',14.18),('7643','2013-04-22','10:40:00',14.43),('7643','2013-04-22','10:45:00',14.34),('7643','2013-04-22','10:50:00',14.44),('7643','2013-04-22','10:55:00',14.67),('7643','2013-04-22','11:00:00',14.74),('7643','2013-04-22','11:05:00',14.89),('7643','2013-04-22','11:10:00',15.09),('7643','2013-04-22','11:15:00',15.22),('7643','2013-04-22','11:20:00',15.28),('7643','2013-04-22','11:25:00',15.48),('7643','2013-04-22','11:30:00',15.61),('7643','2013-04-22','11:35:00',15.69),('7643','2013-04-22','11:40:00',15.69),('7643','2013-04-22','11:45:00',15.76),('7643','2013-04-22','11:50:00',15.87),('7643','2013-04-22','11:55:00',15.88),('7643','2013-04-22','12:00:00',15.88),('7643','2013-04-22','12:05:00',15.73),('7643','2013-04-22','12:10:00',15.99),('7643','2013-04-22','12:15:00',15.98),('7643','2013-04-22','12:20:00',16.01),('7643','2013-04-22','12:25:00',16.05),('7643','2013-04-22','12:30:00',10.73),('7643','2013-04-22','12:35:00',17.53),('7643','2013-04-22','12:40:00',13.08),('7643','2013-04-22','12:45:00',6.01),('7643','2013-04-22','12:50:00',12.25),('7643','2013-04-22','12:55:00',8.36),('7643','2013-04-22','13:00:00',11.51),('7643','2013-04-22','13:05:00',7.39),('7643','2013-04-22','13:10:00',5.77),('7643','2013-04-22','13:15:00',17.31),('7643','2013-04-22','13:20:00',17.73),('7643','2013-04-22','13:25:00',17.5),('7643','2013-04-22','13:30:00',16.95),('7643','2013-04-22','13:35:00',17.12),('7643','2013-04-22','13:40:00',16.85),('7643','2013-04-22','13:45:00',11.85),('7643','2013-04-22','13:50:00',15.14),('7643','2013-04-22','13:55:00',14.48),('7643','2013-04-22','14:00:00',6.71),('7643','2013-04-22','14:05:00',17.8),('7643','2013-04-22','14:10:00',10.8),('7643','2013-04-22','14:15:00',15.38),('7643','2013-04-22','14:20:00',14.97),('7643','2013-04-22','14:25:00',13.97),('7643','2013-04-22','14:30:00',15.89),('7643','2013-04-22','14:35:00',15.97),('7643','2013-04-22','14:40:00',15.8),('7643','2013-04-22','14:45:00',12.74),('7643','2013-04-22','14:50:00',7.99),('7643','2013-04-22','14:55:00',8.95),('7643','2013-04-22','15:00:00',8.5),('7643','2013-04-22','15:05:00',9.44),('7643','2013-04-22','15:10:00',11.3),('7643','2013-04-22','15:15:00',11.35),('7643','2013-04-22','15:20:00',10.36),('7643','2013-04-22','15:25:00',9.52),('7643','2013-04-22','15:30:00',9.22),('7643','2013-04-22','15:35:00',9.08),('7643','2013-04-22','15:40:00',8.56),('7643','2013-04-22','15:45:00',8.62),('7643','2013-04-22','15:50:00',7.03),('7643','2013-04-22','15:55:00',6.15),('7643','2013-04-22','16:00:00',6.81),('7643','2013-04-22','16:05:00',6.62),('7643','2013-04-22','16:10:00',6.37),('7643','2013-04-22','16:15:00',5.94),('7643','2013-04-22','16:20:00',4.6),('7643','2013-04-22','16:25:00',4.57),('7643','2013-04-22','16:30:00',4.18),('7643','2013-04-22','16:35:00',4.22),('7643','2013-04-22','16:40:00',4.45),('7643','2013-04-22','16:45:00',4.33),('7643','2013-04-22','16:50:00',3.81),('7643','2013-04-22','16:55:00',4.14),('7643','2013-04-22','17:00:00',3.9),('7643','2013-04-22','17:05:00',4.13),('7643','2013-04-22','17:10:00',5.72),('7643','2013-04-22','17:15:00',8.73),('7643','2013-04-22','17:20:00',5.48),('7643','2013-04-22','17:25:00',7.28),('7643','2013-04-22','17:30:00',5.64),('7643','2013-04-22','17:35:00',5.17),('7643','2013-04-22','17:40:00',5),('7643','2013-04-22','17:45:00',4.32),('7643','2013-04-22','17:50:00',4.08),('7643','2013-04-22','17:55:00',2.38),('7643','2013-04-22','18:00:00',2.79),('7643','2013-04-22','18:05:00',2.34),('7643','2013-04-22','18:10:00',1.93),('7643','2013-04-22','18:15:00',1.87),('7643','2013-04-22','18:20:00',1.62),('7643','2013-04-22','18:25:00',1.72),('7643','2013-04-22','18:30:00',1.73),('7643','2013-04-22','18:35:00',1.74),('7643','2013-04-22','18:40:00',1.72),('7643','2013-04-22','18:45:00',1.27),('7643','2013-04-22','18:50:00',1.15),('7643','2013-04-22','18:55:00',1.14),('7643','2013-04-21','08:40:00',1.54),('7643','2013-04-21','08:45:00',2.07),('7643','2013-04-21','08:50:00',1.37),('7643','2013-04-21','08:55:00',1.26),('7643','2013-04-21','09:00:00',2.35),('7643','2013-04-21','09:05:00',2.42),('7643','2013-04-21','09:10:00',2.64),('7643','2013-04-21','09:15:00',2.46),('7643','2013-04-21','09:20:00',2.48),('7643','2013-04-21','09:25:00',2.88),('7643','2013-04-21','09:30:00',4.06),('7643','2013-04-21','09:35:00',3.7),('7643','2013-04-21','09:40:00',2.84),('7643','2013-04-21','09:45:00',2.07),('7643','2013-04-21','10:30:00',1.95),('7643','2013-04-21','10:35:00',8.49),('7643','2013-04-21','10:40:00',14.88),('7643','2013-04-21','10:45:00',18.73),('7643','2013-04-21','10:50:00',8.42),('7643','2013-04-21','10:55:00',8.5),('7643','2013-04-21','11:00:00',7.7),('7643','2013-04-21','11:05:00',7.31),('7643','2013-04-21','11:10:00',8.84),('7643','2013-04-21','11:15:00',5.4),('7643','2013-04-21','11:20:00',5.56),('7643','2013-04-21','11:25:00',7.29),('7643','2013-04-21','11:30:00',11.53),('7643','2013-04-21','11:35:00',14.22),('7643','2013-04-21','11:40:00',13.36),('7643','2013-04-21','11:45:00',7.67),('7643','2013-04-21','11:50:00',6.7),('7643','2013-04-21','11:55:00',15.3),('7643','2013-04-21','12:00:00',14.46),('7643','2013-04-21','12:05:00',10.99),('7643','2013-04-21','12:10:00',18.33),('7643','2013-04-21','12:15:00',13.47),('7643','2013-04-21','12:20:00',13.78),('7643','2013-04-21','12:25:00',8.94),('7643','2013-04-21','12:30:00',10),('7643','2013-04-21','12:35:00',12.07),('7643','2013-04-21','12:40:00',17.58),('7643','2013-04-21','12:45:00',17.52),('7643','2013-04-21','12:50:00',18),('7643','2013-04-21','12:55:00',18.03),('7643','2013-04-21','13:00:00',17.91),('7643','2013-04-21','13:05:00',13.77),('7643','2013-04-21','13:10:00',17.06),('7643','2013-04-21','13:15:00',16.53),('7643','2013-04-21','13:20:00',14.47),('7643','2013-04-21','13:25:00',7.53),('7643','2013-04-21','13:30:00',10.17),('7643','2013-04-21','13:35:00',8.73),('7643','2013-04-21','13:40:00',9.91),('7643','2013-04-21','13:45:00',14.27),('7643','2013-04-21','13:50:00',4.26),('7643','2013-04-21','13:55:00',6.26),('7643','2013-04-21','14:00:00',4.52),('7643','2013-04-21','14:05:00',5.28),('7643','2013-04-21','14:10:00',4.68),('7643','2013-04-21','14:15:00',4.43),('7643','2013-04-21','14:20:00',19.79),('7643','2013-04-21','14:25:00',14.43),('7643','2013-04-21','14:30:00',18.91),('7643','2013-04-21','14:35:00',12.44),('7643','2013-04-21','14:40:00',18.03),('7643','2013-04-21','14:45:00',17.42),('7643','2013-04-21','14:50:00',17.57),('7643','2013-04-21','14:55:00',15.58),('7643','2013-04-21','15:00:00',15.77),('7643','2013-04-21','15:05:00',16.31),('7643','2013-04-21','15:10:00',5.61),('7643','2013-04-21','15:15:00',3.19),('7643','2013-04-21','15:20:00',4.18),('7643','2013-04-21','15:25:00',8.73),('7643','2013-04-21','15:30:00',7.49),('7643','2013-04-21','15:35:00',3.75),('7643','2013-04-21','15:40:00',8.53),('7643','2013-04-21','15:45:00',13.17),('7643','2013-04-21','15:50:00',9.24),('7643','2013-04-21','15:55:00',4.5),('7643','2013-04-21','16:00:00',3.03),('7643','2013-04-21','16:05:00',2.8),('7643','2013-04-21','16:10:00',2.74),('7643','2013-04-21','16:15:00',2.87),('7643','2013-04-21','16:20:00',2.55),('7643','2013-04-21','16:25:00',1.52),('7643','2013-04-21','16:30:00',2.01),('7643','2013-04-21','16:35:00',2.57),('7643','2013-04-21','16:40:00',4.38),('7643','2013-04-21','16:45:00',5.03),('7643','2013-04-21','16:50:00',3.04),('7643','2013-04-21','16:55:00',1.81),('7643','2013-04-21','17:00:00',1.74),('7643','2013-04-21','17:05:00',1.97),('7643','2013-04-21','17:10:00',1.82),('7643','2013-04-21','17:15:00',1.1),('7643','2013-04-21','17:20:00',1.3),('7643','2013-04-21','17:25:00',2.12),('7643','2013-04-21','17:30:00',3.16),('7643','2013-04-21','17:35:00',3.48),('7643','2013-04-21','17:40:00',2.55),('7643','2013-04-21','17:45:00',1.67),('7643','2013-04-21','17:50:00',1.39),('7643','2013-04-21','17:55:00',1.09),('7643','2013-04-21','18:00:00',1.13),('7643','2013-04-21','18:05:00',1.63),('7643','2013-04-21','18:10:00',2.27),('7643','2013-04-21','18:15:00',1.84),('7643','2013-04-21','18:20:00',2.74),('7643','2013-04-21','18:25:00',2.46),('7643','2013-04-21','18:30:00',1.57),('7643','2013-04-21','18:35:00',1.48),('7643','2013-04-21','18:40:00',1.27),('7643','2013-04-21','18:45:00',1.33),('7643','2013-04-21','18:50:00',1.96),('7643','2013-04-21','18:55:00',1.67),('7643','2013-04-21','19:00:00',1.46),('7643','2013-04-21','19:05:00',1.1),('7643','2014-03-28','06:40:00',1.22),('7643','2014-03-28','06:45:00',1.54),('7643','2014-03-28','06:50:00',1.84),('7643','2014-03-28','06:55:00',2.12),('7643','2014-03-28','07:00:00',2.48),('7643','2014-03-28','07:05:00',2.9),('7643','2014-03-28','07:10:00',3.32),('7643','2014-03-28','07:15:00',3.75),('7643','2014-03-28','07:20:00',4.1),('7643','2014-03-28','07:25:00',4.42),('7643','2014-03-28','07:30:00',4.81),('7643','2014-03-28','07:35:00',5.19),('7643','2014-03-28','07:40:00',5.67),('7643','2014-03-28','07:45:00',6.03),('7643','2014-03-28','07:50:00',6.48),('7643','2014-03-28','07:55:00',6.81),('7643','2014-03-28','08:00:00',7.18),('7643','2014-03-28','08:05:00',7.59),('7643','2014-03-28','08:10:00',7.97),('7643','2014-03-28','08:15:00',8.28),('7643','2014-03-28','08:20:00',8.61),('7643','2014-03-28','08:25:00',8.94),('7643','2014-03-28','08:30:00',9.19),('7643','2014-03-28','08:35:00',9.49),('7643','2014-03-28','08:40:00',9.76),('7643','2014-03-28','08:45:00',10.04),('7643','2014-03-28','08:50:00',10.32),('7643','2014-03-28','08:55:00',10.46),('7643','2014-03-28','09:00:00',10.72),('7643','2014-03-28','09:05:00',11.09),('7643','2014-03-28','09:10:00',11.42),('7643','2014-03-28','09:15:00',11.68),('7643','2014-03-28','09:20:00',11.92),('7643','2014-03-28','09:25:00',12.18),('7643','2014-03-28','09:30:00',12.36),('7643','2014-03-28','09:35:00',12.7),('7643','2014-03-28','09:40:00',12.99),('7643','2014-03-28','09:45:00',13.1),('7643','2014-03-28','09:50:00',13.41),('7643','2014-03-28','09:55:00',13.64),('7643','2014-03-28','10:00:00',13.8),('7643','2014-03-28','10:05:00',14.04),('7643','2014-03-28','10:10:00',14.29),('7643','2014-03-28','10:15:00',14.54),('7643','2014-03-28','10:20:00',14.64),('7643','2014-03-28','10:25:00',14.8),('7643','2014-03-28','10:30:00',14.82),('7643','2014-03-28','10:35:00',14.86),('7643','2014-03-28','10:40:00',15),('7643','2014-03-28','10:45:00',15.13),('7643','2014-03-28','10:50:00',15.45),('7643','2014-03-28','10:55:00',15.63),('7643','2014-03-28','11:00:00',15.59),('7643','2014-03-28','11:05:00',15.72),('7643','2014-03-28','11:10:00',15.76),('7643','2014-03-28','11:15:00',16.02),('7643','2014-03-28','11:20:00',16.03),('7643','2014-03-28','11:25:00',16.03),('7643','2014-03-28','11:30:00',15.94),('7643','2014-03-28','11:35:00',16.04),('7643','2014-03-28','11:40:00',15.64),('7643','2014-03-28','11:45:00',16.29),('7643','2014-03-28','11:50:00',16.22),('7643','2014-03-28','11:55:00',16.1),('7643','2014-03-28','12:00:00',16.22),('7643','2014-03-28','12:05:00',16.25),('7643','2014-03-28','12:10:00',16.15),('7643','2014-03-28','12:15:00',16.15),('7643','2014-03-28','12:20:00',16.24),('7643','2014-03-28','12:25:00',16.23),('7643','2014-03-28','12:30:00',16.33),('7643','2014-03-28','12:35:00',16.29),('7643','2014-03-28','12:40:00',16.08),('7643','2014-03-28','12:45:00',16.19),('7643','2014-03-28','12:50:00',16.05),('7643','2014-03-28','12:55:00',15.98),('7643','2014-03-28','13:00:00',15.92),('7643','2014-03-28','13:05:00',15.82),('7643','2014-03-28','13:10:00',15.67),('7643','2014-03-28','13:15:00',15.46),('7643','2014-03-28','13:20:00',15.43),('7643','2014-03-28','13:25:00',15.13),('7643','2014-03-28','13:30:00',15.01),('7643','2014-03-28','13:35:00',14.74),('7643','2014-03-28','13:40:00',14.59),('7643','2014-03-28','13:45:00',14.37),('7643','2014-03-28','13:50:00',14.29),('7643','2014-03-28','13:55:00',14.17),('7643','2014-03-28','14:00:00',14.01),('7643','2014-03-28','14:05:00',13.84),('7643','2014-03-28','14:10:00',13.84),('7643','2014-03-28','14:15:00',13.46),('7643','2014-03-28','14:20:00',11.94),('7643','2014-03-28','14:25:00',13.28),('7643','2014-03-28','14:30:00',12.74),('7643','2014-03-28','14:35:00',12.07),('7643','2014-03-28','14:40:00',12.01),('7643','2014-03-28','14:45:00',11.97),('7643','2014-03-28','14:50:00',11.81),('7643','2014-03-28','14:55:00',11.96),('7643','2014-03-28','15:00:00',11.69),('7643','2014-03-28','15:05:00',11.3),('7643','2014-03-28','15:10:00',10.7),('7643','2014-03-28','15:15:00',10.78),('7643','2014-03-28','15:20:00',10.59),('7643','2014-03-28','15:25:00',10.22),('7643','2014-03-28','15:30:00',9.6),('7643','2014-03-28','15:35:00',9.17),('7643','2014-03-28','15:40:00',9.04),('7643','2014-03-28','15:45:00',8.84),('7643','2014-03-28','15:50:00',8.5),('7643','2014-03-28','15:55:00',8.26),('7643','2014-03-28','16:00:00',7.95),('7643','2014-03-28','16:05:00',7.58),('7643','2014-03-28','16:10:00',7.19),('7643','2014-03-28','16:15:00',6.91),('7643','2014-03-28','16:20:00',6.24),('7643','2014-03-28','16:25:00',6.07),('7643','2014-03-28','16:30:00',5.75),('7643','2014-03-28','16:35:00',5.22),('7643','2014-03-28','16:40:00',4.59),('7643','2014-03-28','16:45:00',3.54),('7643','2014-03-28','16:50:00',3.84),('7643','2014-03-28','16:55:00',3.96),('7643','2014-03-28','17:00:00',3.63),('7643','2014-03-28','17:05:00',3.24),('7643','2014-03-28','17:10:00',2.93),('7643','2014-03-28','17:15:00',2.6),('7643','2014-03-28','17:20:00',2.23),('7643','2014-03-28','17:25:00',1.91),('7643','2014-03-28','17:30:00',1.59),('7643','2014-03-28','17:35:00',1.29),('7643','2013-04-20','07:30:00',1.01),('7643','2013-04-20','07:35:00',1.27),('7643','2013-04-20','07:40:00',1.33),('7643','2013-04-20','07:45:00',1.47),('7643','2013-04-20','07:50:00',1.71),('7643','2013-04-20','07:55:00',2.52),('7643','2013-04-20','08:00:00',2.79),('7643','2013-04-20','08:05:00',3.26),('7643','2013-04-20','08:10:00',3.74),('7643','2013-04-20','08:15:00',4.4),('7643','2013-04-20','08:20:00',3.46),('7643','2013-04-20','08:25:00',3.96),('7643','2013-04-20','08:30:00',3.44),('7643','2013-04-20','08:35:00',4.28),('7643','2013-04-20','08:40:00',4.86),('7643','2013-04-20','08:45:00',4.98),('7643','2013-04-20','08:50:00',4.69),('7643','2013-04-20','08:55:00',6.86),('7643','2013-04-20','09:00:00',5.31),('7643','2013-04-20','09:05:00',5.92),('7643','2013-04-20','09:10:00',9.17),('7643','2013-04-20','09:15:00',8.88),('7643','2013-04-20','09:20:00',5.25),('7643','2013-04-20','09:25:00',6.13),('7643','2013-04-20','09:30:00',10.79),('7643','2013-04-20','09:35:00',11.1),('7643','2013-04-20','09:40:00',10.78),('7643','2013-04-20','09:45:00',11.93),('7643','2013-04-20','09:50:00',13.21),('7643','2013-04-20','09:55:00',10.59),('7643','2013-04-20','10:00:00',9.99),('7643','2013-04-20','10:05:00',8.83),('7643','2013-04-20','10:10:00',7.57),('7643','2013-04-20','10:15:00',6.59),('7643','2013-04-20','10:20:00',11.02),('7643','2013-04-20','10:25:00',10.62),('7643','2013-04-20','10:30:00',11.54),('7643','2013-04-20','10:35:00',8.38),('7643','2013-04-20','10:40:00',11.5),('7643','2013-04-20','10:45:00',9.89),('7643','2013-04-20','10:50:00',12.87),('7643','2013-04-20','10:55:00',12.07),('7643','2013-04-20','11:35:00',10.62),('7643','2013-04-20','11:40:00',13.8),('7643','2013-04-20','11:45:00',14.6),('7643','2013-04-20','11:50:00',12.68),('7643','2013-04-20','11:55:00',11.27),('7643','2013-04-20','12:00:00',9.2),('7643','2013-04-20','12:05:00',8.64),('7643','2013-04-20','12:10:00',8.41),('7643','2013-04-20','12:15:00',7.91),('7643','2013-04-20','12:20:00',7.28),('7643','2013-04-20','12:25:00',7),('7643','2013-04-20','12:30:00',7.73),('7643','2013-04-20','12:35:00',7.78),('7643','2013-04-20','12:40:00',8.11),('7643','2013-04-20','12:45:00',7.92),('7643','2013-04-20','12:50:00',7.31),('7643','2013-04-20','12:55:00',7.25),('7643','2013-04-20','13:00:00',8.33),('7643','2013-04-20','13:05:00',9.95),('7643','2013-04-20','13:10:00',9.69),('7643','2013-04-20','13:15:00',9.1),('7643','2013-04-20','13:20:00',8.44),('7643','2013-04-20','13:25:00',8.1),('7643','2013-04-20','13:30:00',13.22),('7643','2013-04-20','13:35:00',13.22),('7643','2013-04-20','13:40:00',10.91),('7643','2013-04-20','13:45:00',10.87),('7643','2013-04-20','13:50:00',8.77),('7643','2013-04-20','13:55:00',15.21),('7643','2013-04-20','14:00:00',16.55),('7643','2013-04-20','14:05:00',16.05),('7643','2013-04-20','14:10:00',16),('7643','2013-04-20','14:15:00',14.11),('7643','2013-04-20','14:20:00',18.04),('7643','2013-04-20','14:25:00',14.41),('7643','2013-04-20','14:30:00',14.17),('7643','2013-04-20','14:35:00',15.22),('7643','2013-04-20','14:40:00',16.71),('7643','2013-04-20','14:45:00',12.69),('7643','2013-04-20','14:50:00',8.02),('7643','2013-04-20','14:55:00',7.08),('7643','2013-04-20','15:00:00',11.64),('7643','2013-04-20','15:05:00',16),('7643','2013-04-20','15:10:00',15.25),('7643','2013-04-20','15:15:00',11.88),('7643','2013-04-20','15:20:00',7.71),('7643','2013-04-20','15:25:00',6.9),('7643','2013-04-20','15:30:00',5.99),('7643','2013-04-20','15:35:00',5.04),('7643','2013-04-20','15:40:00',5.21),('7643','2013-04-20','15:45:00',4.32),('7643','2013-04-20','15:50:00',3.74),('7643','2013-04-20','15:55:00',3.4),('7643','2013-04-20','16:00:00',3.02),('7643','2013-04-20','16:05:00',2.66),('7643','2013-04-20','16:10:00',2.55),('7643','2013-04-20','16:15:00',2.63),('7643','2013-04-20','16:20:00',2.14),('7643','2013-04-20','16:25:00',1.65),('7643','2013-04-20','16:30:00',1.68),('7643','2013-04-20','16:35:00',2.13),('7643','2013-04-20','16:40:00',2.05),('7643','2013-04-20','16:45:00',1.64),('7643','2013-04-20','16:50:00',1.83),('7643','2013-04-20','16:55:00',2.59),('7643','2013-04-20','17:00:00',3.18),('7643','2013-04-20','17:05:00',3.17),('7643','2013-04-20','17:10:00',2.65),('7643','2013-04-20','17:15:00',2.62),('7643','2013-04-20','17:20:00',2.29),('7643','2013-04-20','17:25:00',2.05),('7643','2013-04-20','17:30:00',1.79),('7643','2013-04-20','17:35:00',1.7),('7643','2013-04-20','17:40:00',1.77),('7643','2013-04-20','17:45:00',1.97),('7643','2013-04-20','17:50:00',1.65),('7643','2013-04-20','17:55:00',1.8),('7643','2013-04-20','18:00:00',1.59),('7643','2013-04-20','18:05:00',1.31),('7643','2013-04-20','18:10:00',1.11),('7643','2013-04-20','18:15:00',1.25),('7643','2013-04-20','18:20:00',1.15),('7643','2013-04-19','07:10:00',1.18),('7643','2013-04-19','07:15:00',1.44),('7643','2013-04-19','07:20:00',1.45),('7643','2013-04-19','07:25:00',1.94),('7643','2013-04-19','07:30:00',2.43),('7643','2013-04-19','07:35:00',3.12),('7643','2013-04-19','07:40:00',3.39),('7643','2013-04-19','07:45:00',2.73),('7643','2013-04-19','07:50:00',2.77),('7643','2013-04-19','07:55:00',3.55),('7643','2013-04-19','08:00:00',3.98),('7643','2013-04-19','08:05:00',4.37),('7643','2013-04-19','08:10:00',4.84),('7643','2013-04-19','08:15:00',4.48),('7643','2013-04-19','08:20:00',4.29),('7643','2013-04-19','08:25:00',4.71),('7643','2013-04-19','08:30:00',5.26),('7643','2013-04-19','08:35:00',5.83),('7643','2013-04-19','08:40:00',6.53),('7643','2013-04-19','08:45:00',6.65),('7643','2013-04-19','08:50:00',6.63),('7643','2013-04-19','08:55:00',6.39),('7643','2013-04-19','09:00:00',8.02),('7643','2013-04-19','09:05:00',8.28),('7643','2013-04-19','09:10:00',7.68),('7643','2013-04-19','09:15:00',6.55),('7643','2013-04-19','09:20:00',9.15),('7643','2013-04-19','09:25:00',8.81),('7643','2013-04-19','09:30:00',7.37),('7643','2013-04-19','09:35:00',4.3),('7643','2013-04-19','09:40:00',4.05),('7643','2013-04-19','09:45:00',4.22),('7643','2013-04-19','09:50:00',3.92),('7643','2013-04-19','09:55:00',2.97),('7643','2013-04-19','10:00:00',2.17),('7643','2013-04-19','10:05:00',1.87),('7643','2013-04-19','10:10:00',1.76),('7643','2013-04-19','10:15:00',1.77),('7643','2013-04-19','10:20:00',1.83),('7643','2013-04-19','10:25:00',1.89),('7643','2013-04-19','10:30:00',2.24),('7643','2013-04-19','10:35:00',2.91),('7643','2013-04-19','10:40:00',4.98),('7643','2013-04-19','10:45:00',11.68),('7643','2013-04-19','10:50:00',7.71),('7643','2013-04-19','10:55:00',7.7),('7643','2013-04-19','11:00:00',7.43),('7643','2013-04-19','11:05:00',7.47),('7643','2013-04-19','11:10:00',13.59),('7643','2013-04-19','11:15:00',16.43),('7643','2013-04-19','11:20:00',7.51),('7643','2013-04-19','11:25:00',14.21),('7643','2013-04-19','11:30:00',16.19),('7643','2013-04-19','11:35:00',8.79),('7643','2013-04-19','11:40:00',6.43),('7643','2013-04-19','11:45:00',8.53),('7643','2013-04-19','11:50:00',8.6),('7643','2013-04-19','11:55:00',16.65),('7643','2013-04-19','12:00:00',15.19),('7643','2013-04-19','12:05:00',12.16),('7643','2013-04-19','12:10:00',15.85),('7643','2013-04-19','12:15:00',6.48),('7643','2013-04-19','12:20:00',16.15),('7643','2013-04-19','12:25:00',14.64),('7643','2013-04-19','12:30:00',16.87),('7643','2013-04-19','12:35:00',12.91),('7643','2013-04-19','12:40:00',16.94),('7643','2013-04-19','12:45:00',16.7),('7643','2013-04-19','12:50:00',16.94),('7643','2013-04-19','12:55:00',7.77),('7643','2013-04-19','13:00:00',12.78),('7643','2013-04-19','13:05:00',17),('7643','2013-04-19','13:10:00',16.64),('7643','2013-04-19','13:15:00',9.55),('7643','2013-04-19','13:20:00',14.16),('7643','2013-04-19','13:25:00',16.34),('7643','2013-04-19','13:30:00',13.99),('7643','2013-04-19','13:35:00',12.27),('7643','2013-04-19','13:40:00',15.34),('7643','2013-04-19','13:45:00',10.84),('7643','2013-04-19','13:50:00',11.33),('7643','2013-04-19','13:55:00',15.39),('7643','2013-04-19','14:00:00',8.93),('7643','2013-04-19','14:05:00',15.71),('7643','2013-04-19','14:10:00',15.14),('7643','2013-04-19','14:15:00',15.23),('7643','2013-04-19','14:20:00',14.98),('7643','2013-04-19','14:25:00',14.74),('7643','2013-04-19','14:30:00',14.57),('7643','2013-04-19','14:35:00',14.49),('7643','2013-04-19','14:40:00',14.35),('7643','2013-04-19','14:45:00',14.36),('7643','2013-04-19','14:50:00',14.45),('7643','2013-04-19','14:55:00',14.44),('7643','2013-04-19','15:00:00',14.27),('7643','2013-04-19','15:05:00',13.82),('7643','2013-04-19','15:10:00',7.01),('7643','2013-04-19','15:15:00',10.92),('7643','2013-04-19','15:20:00',9.48),('7643','2013-04-19','15:25:00',12.18),('7643','2013-04-19','15:30:00',7.03),('7643','2013-04-19','15:35:00',3.17),('7643','2013-04-19','15:40:00',2.8),('7643','2013-04-19','15:45:00',2.82),('7643','2013-04-19','15:50:00',2.7),('7643','2013-04-19','15:55:00',2.56),('7643','2013-04-19','16:00:00',2.8),('7643','2013-04-19','16:05:00',3.57),('7643','2013-04-19','16:10:00',5.21),('7643','2013-04-19','16:15:00',7.27),('7643','2013-04-19','16:20:00',7.39),('7643','2013-04-19','16:25:00',9.92),('7643','2013-04-19','16:30:00',10.8),('7643','2013-04-19','16:35:00',9.08),('7643','2013-04-19','16:40:00',10.91),('7643','2013-04-19','16:45:00',10.64),('7643','2013-04-19','16:50:00',9.7),('7643','2013-04-19','16:55:00',9.13),('7643','2013-04-19','17:00:00',8.52),('7643','2013-04-19','17:05:00',8.14),('7643','2013-04-19','17:10:00',7.93),('7643','2013-04-19','17:15:00',7.15),('7643','2013-04-19','17:20:00',6.72),('7643','2013-04-19','17:25:00',6.23),('7643','2013-04-19','17:30:00',7.02),('7643','2013-04-19','17:35:00',7.04),('7643','2013-04-19','17:40:00',6.43),('7643','2013-04-19','17:45:00',2.93),('7643','2013-04-19','17:50:00',3.32),('7643','2013-04-19','17:55:00',5.66),('7643','2013-04-19','18:00:00',4.68),('7643','2013-04-19','18:05:00',3.96),('7643','2013-04-19','18:10:00',4.51),('7643','2013-04-19','18:15:00',3.67),('7643','2013-04-19','18:20:00',2.51),('7643','2013-04-19','18:25:00',1.59),('7643','2013-04-19','18:30:00',1.48),('7643','2013-04-19','18:35:00',1.31),('7643','2013-04-19','18:40:00',1.69),('7643','2013-04-19','18:45:00',1.1),('7643','2013-04-18','07:30:00',1.12),('7643','2013-04-18','07:35:00',1.5),('7643','2013-04-18','07:40:00',2.27),('7643','2013-04-18','07:45:00',2.75),('7643','2013-04-18','07:50:00',1.73),('7643','2013-04-18','07:55:00',1.94),('7643','2013-04-18','08:00:00',3.03),('7643','2013-04-18','08:05:00',4.3),('7643','2013-04-18','08:10:00',2.97),('7643','2013-04-18','08:15:00',2.86),('7643','2013-04-18','08:20:00',5.12),('7643','2013-04-18','08:25:00',5.24),('7643','2013-04-18','08:30:00',5.5),('7643','2013-04-18','08:35:00',5.64),('7643','2013-04-18','08:40:00',6.42),('7643','2013-04-18','08:45:00',6.74),('7643','2013-04-18','08:50:00',7.08),('7643','2013-04-18','08:55:00',7.49),('7643','2013-04-18','09:00:00',7.73),('7643','2013-04-18','09:05:00',7.92),('7643','2013-04-18','09:10:00',8.14),('7643','2013-04-18','09:15:00',8.41),('7643','2013-04-18','09:20:00',8.72),('7643','2013-04-18','09:25:00',8.97),('7643','2013-04-18','09:30:00',9.19),('7643','2013-04-18','09:35:00',9.44),('7643','2013-04-18','09:40:00',9.85),('7643','2013-04-18','09:45:00',9.98),('7643','2013-04-18','09:50:00',10.13),('7643','2013-04-18','09:55:00',10.28),('7643','2013-04-18','10:00:00',10.61),('7643','2013-04-18','10:05:00',10.62),('7643','2013-04-18','10:10:00',10.73),('7643','2013-04-18','10:15:00',11.38),('7643','2013-04-18','10:20:00',9.68),('7643','2013-04-18','10:25:00',11.06),('7643','2013-04-18','10:30:00',10.46),('7643','2013-04-18','10:35:00',9.66),('7643','2013-04-18','10:40:00',12.26),('7643','2013-04-18','10:45:00',12.45),('7643','2013-04-18','10:50:00',12.55),('7643','2013-04-18','10:55:00',12.7),('7643','2013-04-18','11:00:00',12.76),('7643','2013-04-18','11:05:00',12.85),('7643','2013-04-18','11:10:00',12.92),('7643','2013-04-18','11:15:00',13),('7643','2013-04-18','11:20:00',13.09),('7643','2013-04-18','11:25:00',13.29),('7643','2013-04-18','11:30:00',13.46),('7643','2013-04-18','11:35:00',13.61),('7643','2013-04-18','11:40:00',13.85),('7643','2013-04-18','11:45:00',13.65),('7643','2013-04-18','11:50:00',14.07),('7643','2013-04-18','11:55:00',14.24),('7643','2013-04-18','12:00:00',14.35),('7643','2013-04-18','12:05:00',14.32),('7643','2013-04-18','12:10:00',14.36),('7643','2013-04-18','12:15:00',14.2),('7643','2013-04-18','12:20:00',14.41),('7643','2013-04-18','12:25:00',14.39),('7643','2013-04-18','12:30:00',14.35),('7643','2013-04-18','12:35:00',14.69),('7643','2013-04-18','12:40:00',14.77),('7643','2013-04-18','12:45:00',14.81),('7643','2013-04-18','12:50:00',14.62),('7643','2013-04-18','12:55:00',14.4),('7643','2013-04-18','13:00:00',14.85),('7643','2013-04-18','13:05:00',14.55),('7643','2013-04-18','13:10:00',14.83),('7643','2013-04-18','13:15:00',14.9),('7643','2013-04-18','13:20:00',14.82),('7643','2013-04-18','13:25:00',14.71),('7643','2013-04-18','13:30:00',14.96),('7643','2013-04-18','13:35:00',14.55),('7643','2013-04-18','13:40:00',14.42),('7643','2013-04-18','13:45:00',14.62),('7643','2013-04-18','13:50:00',14.34),('7643','2013-04-18','13:55:00',14.27),('7643','2013-04-18','14:00:00',14.34),('7643','2013-04-18','14:05:00',13.98),('7643','2013-04-18','14:10:00',14.15),('7643','2013-04-18','14:15:00',13.95),('7643','2013-04-18','14:20:00',13.9),('7643','2013-04-18','14:25:00',13.83),('7643','2013-04-18','14:30:00',13.72),('7643','2013-04-18','14:35:00',13.42),('7643','2013-04-18','14:40:00',13.38),('7643','2013-04-18','14:45:00',13.28),('7643','2013-04-18','14:50:00',13.17),('7643','2013-04-18','14:55:00',13.02),('7643','2013-04-18','15:00:00',12.78),('7643','2013-04-18','15:05:00',12.55),('7643','2013-04-18','15:10:00',12.45),('7643','2013-04-18','15:15:00',12.48),('7643','2013-04-18','15:20:00',12.14),('7643','2013-04-18','15:25:00',12.12),('7643','2013-04-18','15:30:00',11.87),('7643','2013-04-18','15:35:00',11.82),('7643','2013-04-18','15:40:00',11.61),('7643','2013-04-18','15:45:00',11.37),('7643','2013-04-18','15:50:00',11.18),('7643','2013-04-18','15:55:00',11.04),('7643','2013-04-18','16:00:00',10.77),('7643','2013-04-18','16:05:00',10.56),('7643','2013-04-18','16:10:00',10.2),('7643','2013-04-18','16:15:00',9.92),('7643','2013-04-18','16:20:00',9.7),('7643','2013-04-18','16:25:00',9.51),('7643','2013-04-18','16:30:00',9.17),('7643','2013-04-18','16:35:00',8.85),('7643','2013-04-18','16:40:00',8.62),('7643','2013-04-18','16:45:00',8.37),('7643','2013-04-18','16:50:00',8.05),('7643','2013-04-18','16:55:00',7.72),('7643','2013-04-18','17:00:00',7.41),('7643','2013-04-18','17:05:00',7.11),('7643','2013-04-18','17:10:00',6.72),('7643','2013-04-18','17:15:00',6.44),('7643','2013-04-18','17:20:00',6.13),('7643','2013-04-18','17:25:00',5.82),('7643','2013-04-18','17:30:00',5.55),('7643','2013-04-18','17:35:00',5.22),('7643','2013-04-18','17:40:00',4.9),('7643','2013-04-18','17:45:00',4.56),('7643','2013-04-18','17:50:00',4.15),('7643','2013-04-18','17:55:00',3.85),('7643','2013-04-18','18:00:00',3.6),('7643','2013-04-18','18:05:00',3.32),('7643','2013-04-18','18:10:00',3.02),('7643','2013-04-18','18:15:00',2.73),('7643','2013-04-18','18:20:00',2.5),('7643','2013-04-18','18:25:00',2.33),('7643','2013-04-18','18:30:00',2.06),('7643','2013-04-18','18:35:00',1.83),('7643','2013-04-18','18:40:00',1.66),('7643','2013-04-18','18:45:00',1.45),('7643','2013-04-18','18:50:00',1.23),('7643','2013-04-18','18:55:00',1.02),('7643','2013-04-17','06:55:00',1),('7643','2013-04-17','07:00:00',1.2),('7643','2013-04-17','07:05:00',1.42),('7643','2013-04-17','07:10:00',1.61),('7643','2013-04-17','07:15:00',1.28),('7643','2013-04-17','07:20:00',1.22),('7643','2013-04-17','07:25:00',1.31),('7643','2013-04-17','07:30:00',1.46),('7643','2013-04-17','07:35:00',1.57),('7643','2013-04-17','07:40:00',1.89),('7643','2013-04-17','07:45:00',1.96),('7643','2013-04-17','07:50:00',2.18),('7643','2013-04-17','07:55:00',2.2),('7643','2013-04-17','08:00:00',2.56),('7643','2013-04-17','08:05:00',3.21),('7643','2013-04-17','08:10:00',3.91),('7643','2013-04-17','08:15:00',4.4),('7643','2013-04-17','08:20:00',4.49),('7643','2013-04-17','08:25:00',4.5),('7643','2013-04-17','08:30:00',5.01),('7643','2013-04-17','08:35:00',5.3),('7643','2013-04-17','08:40:00',5.07),('7643','2013-04-17','08:45:00',5.29),('7643','2013-04-17','08:50:00',5.9),('7643','2013-04-17','08:55:00',6.87),('7643','2013-04-17','09:00:00',6.38),('7643','2013-04-17','09:05:00',7.42),('7643','2013-04-17','09:10:00',7.56),('7643','2013-04-17','09:15:00',7.55),('7643','2013-04-17','09:20:00',8.47),('7643','2013-04-17','09:25:00',8.72),('7643','2013-04-17','09:30:00',9.07),('7643','2013-04-17','09:35:00',9.38),('7643','2013-04-17','09:40:00',10.78),('7643','2013-04-17','09:45:00',9.71),('7643','2013-04-17','09:50:00',8.38),('7643','2013-04-17','09:55:00',8.65),('7643','2013-04-17','10:00:00',10.27),('7643','2013-04-17','10:05:00',11.34),('7643','2013-04-17','10:10:00',11.54),('7643','2013-04-17','10:15:00',12.16),('7643','2013-04-17','10:20:00',12.24),('7643','2013-04-17','10:25:00',12.18),('7643','2013-04-17','10:30:00',12.44),('7643','2013-04-17','10:35:00',12.53),('7643','2013-04-17','10:40:00',12.74),('7643','2013-04-17','10:45:00',12.89),('7643','2013-04-17','10:50:00',13.08),('7643','2013-04-17','10:55:00',13.28),('7643','2013-04-17','11:00:00',13.44),('7643','2013-04-17','11:05:00',13.62),('7643','2013-04-17','11:10:00',13.74),('7643','2013-04-17','11:15:00',13.89),('7643','2013-04-17','11:20:00',14.06),('7643','2013-04-17','11:25:00',14.17),('7643','2013-04-17','11:30:00',14.23),('7643','2013-04-17','11:35:00',14.3),('7643','2013-04-17','11:40:00',14.24),('7643','2013-04-17','11:45:00',14.41),('7643','2013-04-17','11:50:00',14.34),('7643','2013-04-17','11:55:00',14.69),('7643','2013-04-17','12:00:00',14.57),('7643','2013-04-17','12:05:00',15),('7643','2013-04-17','12:10:00',15.1),('7643','2013-04-17','12:15:00',15.12),('7643','2013-04-17','12:20:00',15.3),('7643','2013-04-17','12:25:00',15.34),('7643','2013-04-17','12:30:00',15.38),('7643','2013-04-17','12:35:00',15.46),('7643','2013-04-17','12:40:00',15.38),('7643','2013-04-17','12:45:00',15.5),('7643','2013-04-17','12:50:00',15.49),('7643','2013-04-17','12:55:00',15.43),('7643','2013-04-17','13:00:00',15.51),('7643','2013-04-17','13:05:00',15.51),('7643','2013-04-17','13:10:00',15.42),('7643','2013-04-17','13:15:00',15.43),('7643','2013-04-17','13:20:00',15.46),('7643','2013-04-17','13:25:00',15.47),('7643','2013-04-17','13:30:00',15.48),('7643','2013-04-17','13:35:00',15.42),('7643','2013-04-17','13:40:00',15.37),('7643','2013-04-17','13:45:00',15.35),('7643','2013-04-17','13:50:00',15.35),('7643','2013-04-17','13:55:00',15.31),('7643','2013-04-17','14:00:00',15.17),('7643','2013-04-17','14:05:00',15.09),('7643','2013-04-17','14:10:00',15),('7643','2013-04-17','14:15:00',14.94),('7643','2013-04-17','14:20:00',14.86),('7643','2013-04-17','14:25:00',14.74),('7643','2013-04-17','14:30:00',14.71),('7643','2013-04-17','14:35:00',14.67),('7643','2013-04-17','14:40:00',14.48),('7643','2013-04-17','14:45:00',14.21),('7643','2013-04-17','14:50:00',14),('7643','2013-04-17','14:55:00',13.93),('7643','2013-04-17','15:00:00',13.75),('7643','2013-04-17','15:05:00',13.59),('7643','2013-04-17','15:10:00',13.43),('7643','2013-04-17','15:15:00',13.25),('7643','2013-04-17','15:20:00',13.09),('7643','2013-04-17','15:25:00',12.78),('7643','2013-04-17','15:30:00',12.55),('7643','2013-04-17','15:35:00',12.39),('7643','2013-04-17','15:40:00',12.2),('7643','2013-04-17','15:45:00',11.99),('7643','2013-04-17','15:50:00',11.78),('7643','2013-04-17','15:55:00',11.58),('7643','2013-04-17','16:00:00',11.25),('7643','2013-04-17','16:05:00',11.06),('7643','2013-04-17','16:10:00',10.84),('7643','2013-04-17','16:15:00',10.6),('7643','2013-04-17','16:20:00',10.29),('7643','2013-04-17','16:25:00',9.9),('7643','2013-04-17','16:30:00',9.58),('7643','2013-04-17','16:35:00',9.33),('7643','2013-04-17','16:40:00',8.98),('7643','2013-04-17','16:45:00',8.81),('7643','2013-04-17','16:50:00',8.56),('7643','2013-04-17','16:55:00',8.28),('7643','2013-04-17','17:00:00',7.87),('7643','2013-04-17','17:05:00',7.47),('7643','2013-04-17','17:10:00',7.2),('7643','2013-04-17','17:15:00',6.94),('7643','2013-04-17','17:20:00',6.6),('7643','2013-04-17','17:25:00',6.29),('7643','2013-04-17','17:30:00',5.99),('7643','2013-04-17','17:35:00',5.67),('7643','2013-04-17','17:40:00',5.32),('7643','2013-04-17','17:45:00',5.01),('7643','2013-04-17','17:50:00',4.66),('7643','2013-04-17','17:55:00',4.33),('7643','2013-04-17','18:00:00',3.96),('7643','2013-04-17','18:05:00',3.63),('7643','2013-04-17','18:10:00',3.26),('7643','2013-04-17','18:15:00',2.89),('7643','2013-04-17','18:20:00',2.65),('7643','2013-04-17','18:25:00',2.33),('7643','2013-04-17','18:30:00',2.01),('7643','2013-04-17','18:35:00',1.77),('7643','2013-04-17','18:40:00',1.54),('7643','2013-04-17','18:45:00',1.29),('7643','2013-04-17','18:50:00',1.08),('7643','2013-04-16','07:15:00',1.24),('7643','2013-04-16','07:20:00',1.52),('7643','2013-04-16','07:25:00',1.77),('7643','2013-04-16','07:30:00',2.05),('7643','2013-04-16','07:35:00',2.37),('7643','2013-04-16','07:40:00',2.65),('7643','2013-04-16','07:45:00',2.95),('7643','2013-04-16','07:50:00',3.25),('7643','2013-04-16','07:55:00',3.61),('7643','2013-04-16','08:00:00',3.94),('7643','2013-04-16','08:05:00',4.25),('7643','2013-04-16','08:10:00',4.6),('7643','2013-04-16','08:15:00',4.94),('7643','2013-04-16','08:20:00',5.3),('7643','2013-04-16','08:25:00',5.64),('7643','2013-04-16','08:30:00',5.97),('7643','2013-04-16','08:35:00',6.28),('7643','2013-04-16','08:40:00',6.59),('7643','2013-04-16','08:45:00',6.93),('7643','2013-04-16','08:50:00',7.23),('7643','2013-04-16','08:55:00',7.53),('7643','2013-04-16','09:00:00',7.89),('7643','2013-04-16','09:05:00',8.19),('7643','2013-04-16','09:10:00',8.5),('7643','2013-04-16','09:15:00',8.84),('7643','2013-04-16','09:20:00',9.12),('7643','2013-04-16','09:25:00',9.43),('7643','2013-04-16','09:30:00',9.69),('7643','2013-04-16','09:35:00',9.93),('7643','2013-04-16','09:40:00',10.24),('7643','2013-04-16','09:45:00',10.56),('7643','2013-04-16','09:50:00',10.8),('7643','2013-04-16','09:55:00',11.03),('7643','2013-04-16','10:00:00',11.26),('7643','2013-04-16','10:05:00',11.5),('7643','2013-04-16','10:10:00',11.71),('7643','2013-04-16','10:15:00',11.95),('7643','2013-04-16','10:20:00',12.09),('7643','2013-04-16','10:25:00',12.31),('7643','2013-04-16','10:30:00',12.55),('7643','2013-04-16','10:35:00',12.67),('7643','2013-04-16','10:40:00',12.88),('7643','2013-04-16','10:45:00',13.11),('7643','2013-04-16','10:50:00',13.3),('7643','2013-04-16','10:55:00',13.39),('7643','2013-04-16','11:00:00',13.59),('7643','2013-04-16','11:05:00',13.75),('7643','2013-04-16','11:10:00',13.91),('7643','2013-04-16','11:15:00',14.14),('7643','2013-04-16','11:20:00',14.21),('7643','2013-04-16','11:25:00',14.29),('7643','2013-04-16','11:30:00',14.41),('7643','2013-04-16','11:35:00',14.44),('7643','2013-04-16','11:40:00',14.51),('7643','2013-04-16','11:45:00',14.61),('7643','2013-04-16','11:50:00',14.74),('7643','2013-04-16','11:55:00',14.96),('7643','2013-04-16','12:00:00',15.04),('7643','2013-04-16','12:05:00',15.03),('7643','2013-04-16','12:10:00',15.07),('7643','2013-04-16','12:15:00',15.23),('7643','2013-04-16','12:20:00',15.35),('7643','2013-04-16','12:25:00',15.31),('7643','2013-04-16','12:30:00',15.46),('7643','2013-04-16','12:35:00',15.5),('7643','2013-04-16','12:40:00',15.53),('7643','2013-04-16','12:45:00',15.53),('7643','2013-04-16','12:50:00',15.48),('7643','2013-04-16','12:55:00',15.52),('7643','2013-04-16','13:00:00',15.54),('7643','2013-04-16','13:05:00',15.55),('7643','2013-04-16','13:10:00',15.44),('7643','2013-04-16','13:15:00',15.61),('7643','2013-04-16','13:20:00',15.65),('7643','2013-04-16','13:25:00',15.72),('7643','2013-04-16','13:30:00',15.6),('7643','2013-04-16','13:35:00',15.24),('7643','2013-04-16','13:40:00',15.71),('7643','2013-04-16','13:45:00',14.55),('7643','2013-04-16','13:50:00',14.5),('7643','2013-04-16','13:55:00',15.68),('7643','2013-04-16','14:00:00',15.15),('7643','2013-04-16','14:05:00',16.36),('7643','2013-04-16','14:10:00',15.95),('7643','2013-04-16','14:15:00',14.41),('7643','2013-04-16','14:20:00',13.83),('7643','2013-04-16','14:25:00',14),('7643','2013-04-16','14:30:00',13.42),('7643','2013-04-16','14:35:00',15.68),('7643','2013-04-16','14:40:00',15.19),('7643','2013-04-16','14:45:00',12.79),('7643','2013-04-16','14:50:00',14.68),('7643','2013-04-16','14:55:00',15.26),('7643','2013-04-16','15:00:00',15.11),('7643','2013-04-16','15:05:00',15.34),('7643','2013-04-16','15:10:00',15.91),('7643','2013-04-16','15:15:00',14.76),('7643','2013-04-16','15:20:00',7.85),('7643','2013-04-16','15:25:00',7.95),('7643','2013-04-16','15:30:00',12.33),('7643','2013-04-16','15:35:00',13.3),('7643','2013-04-16','15:40:00',13.28),('7643','2013-04-16','15:45:00',13.24),('7643','2013-04-16','15:50:00',13.19),('7643','2013-04-16','15:55:00',13.28),('7643','2013-04-16','16:00:00',12.93),('7643','2013-04-16','16:05:00',9.19),('7643','2013-04-16','16:10:00',11.84),('7643','2013-04-16','16:15:00',11.43),('7643','2013-04-16','16:20:00',10.93),('7643','2013-04-16','16:25:00',10.52),('7643','2013-04-16','16:30:00',10.27),('7643','2013-04-16','16:35:00',10.22),('7643','2013-04-16','16:40:00',9.5),('7643','2013-04-16','16:45:00',9.69),('7643','2013-04-16','16:50:00',9),('7643','2013-04-16','16:55:00',8.49),('7643','2013-04-16','17:00:00',8.08),('7643','2013-04-16','17:05:00',7.7),('7643','2013-04-16','17:10:00',7.37),('7643','2013-04-16','17:15:00',7.06),('7643','2013-04-16','17:20:00',6.71),('7643','2013-04-16','17:25:00',6.37),('7643','2013-04-16','17:30:00',6.02),('7643','2013-04-16','17:35:00',5.69),('7643','2013-04-16','17:40:00',5.38),('7643','2013-04-16','17:45:00',5.06),('7643','2013-04-16','17:50:00',4.7),('7643','2013-04-16','17:55:00',4.35),('7643','2013-04-16','18:00:00',3.97),('7643','2013-04-16','18:05:00',3.64),('7643','2013-04-16','18:10:00',3.33),('7643','2013-04-16','18:15:00',2.99),('7643','2013-04-16','18:20:00',2.65),('7643','2013-04-16','18:25:00',2.41),('7643','2013-04-16','18:30:00',2.11),('7643','2013-04-16','18:35:00',1.81),('7643','2013-04-16','18:40:00',1.61),('7643','2013-04-16','18:45:00',1.4),('7643','2013-04-16','18:50:00',1.15),('7643','2013-04-15','07:20:00',1.12),('7643','2013-04-15','07:35:00',1.25),('7643','2013-04-15','07:40:00',2.18),('7643','2013-04-15','07:45:00',2.49),('7643','2013-04-15','07:50:00',2.82),('7643','2013-04-15','07:55:00',3.13),('7643','2013-04-15','08:00:00',3.16),('7643','2013-04-15','08:05:00',3.82),('7643','2013-04-15','08:10:00',4.19),('7643','2013-04-15','08:15:00',3.29),('7643','2013-04-15','08:20:00',2.52),('7643','2013-04-15','08:25:00',2.98),('7643','2013-04-15','08:30:00',3.17),('7643','2013-04-15','08:35:00',3.04),('7643','2013-04-15','08:40:00',3.13),('7643','2013-04-15','08:45:00',3.33),('7643','2013-04-15','08:50:00',3.7),('7643','2013-04-15','08:55:00',3.85),('7643','2013-04-15','09:00:00',4.16),('7643','2013-04-15','09:05:00',3.62),('7643','2013-04-15','09:10:00',4.53),('7643','2013-04-15','09:15:00',4.7),('7643','2013-04-15','09:20:00',4.63),('7643','2013-04-15','09:25:00',6.04),('7643','2013-04-15','09:30:00',6.2),('7643','2013-04-15','09:35:00',5.91),('7643','2013-04-15','09:40:00',5),('7643','2013-04-15','09:45:00',5.22),('7643','2013-04-15','09:50:00',5.05),('7643','2013-04-15','09:55:00',4.87),('7643','2013-04-15','10:00:00',4.67),('7643','2013-04-15','10:05:00',4.63),('7643','2013-04-15','10:10:00',4.86),('7643','2013-04-15','10:15:00',5.21),('7643','2013-04-15','10:20:00',5.47),('7643','2013-04-15','10:25:00',5.61),('7643','2013-04-15','10:30:00',5.68),('7643','2013-04-15','10:35:00',5.77),('7643','2013-04-15','10:40:00',5.63),('7643','2013-04-15','10:45:00',5.36),('7643','2013-04-15','10:50:00',5.41),('7643','2013-04-15','10:55:00',5.79),('7643','2013-04-15','11:00:00',6.3),('7643','2013-04-15','11:05:00',6.51),('7643','2013-04-15','11:10:00',6.51),('7643','2013-04-15','11:15:00',6.75),('7643','2013-04-15','11:20:00',6.9),('7643','2013-04-15','11:25:00',6.76),('7643','2013-04-15','11:30:00',6.69),('7643','2013-04-15','11:35:00',6.53),('7643','2013-04-15','11:40:00',7.15),('7643','2013-04-15','11:45:00',8.58),('7643','2013-04-15','11:50:00',9.18),('7643','2013-04-15','11:55:00',9.56),('7643','2013-04-15','12:00:00',9.7),('7643','2013-04-15','12:05:00',10.91),('7643','2013-04-15','12:10:00',11.68),('7643','2013-04-15','12:15:00',16.23),('7643','2013-04-15','12:20:00',11.67),('7643','2013-04-15','12:25:00',10.79),('7643','2013-04-15','12:30:00',13.38),('7643','2013-04-15','12:35:00',15.7),('7643','2013-04-15','12:40:00',16),('7643','2013-04-15','12:45:00',15.57),('7643','2013-04-15','12:50:00',12.3),('7643','2013-04-15','12:55:00',14.99),('7643','2013-04-15','13:00:00',15.66),('7643','2013-04-15','13:05:00',14.96),('7643','2013-04-15','13:10:00',15.06),('7643','2013-04-15','13:15:00',15.06),('7643','2013-04-15','13:20:00',15.26),('7643','2013-04-15','13:25:00',15.28),('7643','2013-04-15','13:30:00',15.12),('7643','2013-04-15','13:35:00',15.1),('7643','2013-04-15','13:40:00',14.97),('7643','2013-04-15','13:45:00',14.71),('7643','2013-04-15','13:50:00',14.67),('7643','2013-04-15','13:55:00',14.35),('7643','2013-04-15','14:00:00',14.48),('7643','2013-04-15','14:05:00',14.68),('7643','2013-04-15','14:10:00',14.7),('7643','2013-04-15','14:15:00',14.76),('7643','2013-04-15','14:20:00',14.4),('7643','2013-04-15','14:45:00',13.99),('7643','2013-04-15','14:50:00',13.46),('7643','2013-04-15','14:55:00',13.1),('7643','2013-04-15','15:00:00',13.5),('7643','2013-04-15','15:05:00',13.32),('7643','2013-04-15','15:10:00',13.27),('7643','2013-04-15','15:15:00',13.09),('7643','2013-04-15','15:20:00',12.95),('7643','2013-04-15','15:25:00',12.3),('7643','2013-04-15','15:30:00',12.05),('7643','2013-04-15','15:35:00',12.06),('7643','2013-04-15','15:40:00',12.05),('7643','2013-04-15','15:45:00',11.83),('7643','2013-04-15','15:50:00',11.71),('7643','2013-04-15','15:55:00',11.36),('7643','2013-04-15','16:00:00',10.79),('7643','2013-04-15','16:05:00',10.85),('7643','2013-04-15','16:10:00',10.62),('7643','2013-04-15','16:15:00',9.95),('7643','2013-04-15','16:20:00',10.14),('7643','2013-04-15','16:25:00',9.89),('7643','2013-04-15','16:30:00',9.67),('7643','2013-04-15','16:35:00',9.52),('7643','2013-04-15','16:40:00',9.91),('7643','2013-04-15','16:45:00',9.93),('7643','2013-04-15','16:50:00',8.88),('7643','2013-04-15','16:55:00',7.91),('7643','2013-04-15','17:00:00',7.92),('7643','2013-04-15','17:05:00',8.04),('7643','2013-04-15','17:10:00',8.16),('7643','2013-04-15','17:15:00',7.85),('7643','2013-04-15','17:20:00',7.55),('7643','2013-04-15','17:25:00',7.4),('7643','2013-04-15','17:30:00',6.36),('7643','2013-04-15','17:35:00',6.91),('7643','2013-04-15','17:40:00',6.64),('7643','2013-04-15','17:45:00',6),('7643','2013-04-15','17:50:00',5.38),('7643','2013-04-15','17:55:00',4.5),('7643','2013-04-15','18:00:00',2.78),('7643','2013-04-15','18:05:00',2.6),('7643','2013-04-15','18:10:00',2.29),('7643','2013-04-15','18:15:00',2.7),('7643','2013-04-15','18:20:00',2.21),('7643','2013-04-15','18:25:00',1.94),('7643','2013-04-15','18:30:00',1.86),('7643','2013-04-15','18:35:00',1.67),('7643','2013-04-15','18:40:00',1.52),('7643','2013-04-15','18:45:00',1.36),('7643','2013-04-15','18:50:00',1.15),('7643','2013-04-14','07:15:00',1.15),('7643','2013-04-14','07:20:00',1.42),('7643','2013-04-14','07:25:00',1.71),('7643','2013-04-14','07:30:00',2),('7643','2013-04-14','07:35:00',2.31),('7643','2013-04-14','07:40:00',2.6),('7643','2013-04-14','07:45:00',2.89),('7643','2013-04-14','07:50:00',3.21),('7643','2013-04-14','07:55:00',3.55),('7643','2013-04-14','08:00:00',3.9),('7643','2013-04-14','08:05:00',4.26),('7643','2013-04-14','08:10:00',4.6),('7643','2013-04-14','08:15:00',4.91),('7643','2013-04-14','08:20:00',5.24),('7643','2013-04-14','08:25:00',5.58),('7643','2013-04-14','08:30:00',5.95),('7643','2013-04-14','08:35:00',6.27),('7643','2013-04-14','08:40:00',6.59),('7643','2013-04-14','08:45:00',6.86),('7643','2013-04-14','08:50:00',7.22),('7643','2013-04-14','08:55:00',7.52),('7643','2013-04-14','09:00:00',7.87),('7643','2013-04-14','09:05:00',8.21),('7643','2013-04-14','09:10:00',8.53),('7643','2013-04-14','09:15:00',8.81),('7643','2013-04-14','09:20:00',9.1),('7643','2013-04-14','09:25:00',9.39),('7643','2013-04-14','09:30:00',9.71),('7643','2013-04-14','09:35:00',9.96),('7643','2013-04-14','09:40:00',10.19),('7643','2013-04-14','09:45:00',10.37),('7643','2013-04-14','09:50:00',10.69),('7643','2013-04-14','09:55:00',10.96),('7643','2013-04-14','10:00:00',11.19),('7643','2013-04-14','10:05:00',11.44),('7643','2013-04-14','10:10:00',11.7),('7643','2013-04-14','10:15:00',11.91),('7643','2013-04-14','10:20:00',12.11),('7643','2013-04-14','10:25:00',12.34),('7643','2013-04-14','10:30:00',12.5),('7643','2013-04-14','10:35:00',12.68),('7643','2013-04-14','10:40:00',12.84),('7643','2013-04-14','10:45:00',13.05),('7643','2013-04-14','10:50:00',13.21),('7643','2013-04-14','10:55:00',13.4),('7643','2013-04-14','11:00:00',13.6),('7643','2013-04-14','11:05:00',13.69),('7643','2013-04-14','11:10:00',13.89),('7643','2013-04-14','11:15:00',13.99),('7643','2013-04-14','11:20:00',14.12),('7643','2013-04-14','11:25:00',14.16),('7643','2013-04-14','11:30:00',14.37),('7643','2013-04-14','11:35:00',14.4),('7643','2013-04-14','11:40:00',14.48),('7643','2013-04-14','11:45:00',14.65),('7643','2013-04-14','11:50:00',14.8),('7643','2013-04-14','11:55:00',14.94),('7643','2013-04-14','12:00:00',14.95),('7643','2013-04-14','12:05:00',15.04),('7643','2013-04-14','12:10:00',15.11),('7643','2013-04-14','12:15:00',15.17),('7643','2013-04-14','12:20:00',15.19),('7643','2013-04-14','12:25:00',15.26),('7643','2013-04-14','12:30:00',15.26),('7643','2013-04-14','12:35:00',15.43),('7643','2013-04-14','12:40:00',15.41),('7643','2013-04-14','12:45:00',15.38),('7643','2013-04-14','12:50:00',15.41),('7643','2013-04-14','12:55:00',15.21),('7643','2013-04-14','13:00:00',15.25),('7643','2013-04-14','13:05:00',15.23),('7643','2013-04-14','13:10:00',15.3),('7643','2013-04-14','13:15:00',15.44),('7643','2013-04-14','13:20:00',15.45),('7643','2013-04-14','13:25:00',15.38),('7643','2013-04-14','13:30:00',15.31),('7643','2013-04-14','13:35:00',15.19),('7643','2013-04-14','13:40:00',15.2),('7643','2013-04-14','13:45:00',15.05),('7643','2013-04-14','13:50:00',15.09),('7643','2013-04-14','13:55:00',15.12),('7643','2013-04-14','14:00:00',15.25),('7643','2013-04-14','14:05:00',15.14),('7643','2013-04-14','14:10:00',15.16),('7643','2013-04-14','14:15:00',15.15),('7643','2013-04-14','14:20:00',15.14),('7643','2013-04-14','14:25:00',14.99),('7643','2013-04-14','14:30:00',14.83),('7643','2013-04-14','14:35:00',14.76),('7643','2013-04-14','14:40:00',14.63),('7643','2013-04-14','14:45:00',14.54),('7643','2013-04-14','14:50:00',14.35),('7643','2013-04-14','14:55:00',14.18),('7643','2013-04-14','15:00:00',14.01),('7643','2013-04-14','15:05:00',13.8),('7643','2013-04-14','15:10:00',13.66),('7643','2013-04-14','15:15:00',13.46),('7643','2013-04-14','15:20:00',13.24),('7643','2013-04-14','15:25:00',13.09),('7643','2013-04-14','15:30:00',12.89),('7643','2013-04-14','15:35:00',12.71),('7643','2013-04-14','15:40:00',12.48),('7643','2013-04-14','15:45:00',12.28),('7643','2013-04-14','15:50:00',12.02),('7643','2013-04-14','15:55:00',11.8),('7643','2013-04-14','16:00:00',11.52),('7643','2013-04-14','16:05:00',11.24),('7643','2013-04-14','16:10:00',10.98),('7643','2013-04-14','16:15:00',10.66),('7643','2013-04-14','16:20:00',10.34),('7643','2013-04-14','16:25:00',10.06),('7643','2013-04-14','16:30:00',9.77),('7643','2013-04-14','16:35:00',9.48),('7643','2013-04-14','16:40:00',9.22),('7643','2013-04-14','16:45:00',8.92),('7643','2013-04-14','16:50:00',8.58),('7643','2013-04-14','16:55:00',8.24),('7643','2013-04-14','17:00:00',7.94),('7643','2013-04-14','17:05:00',7.65),('7643','2013-04-14','17:10:00',7.32),('7643','2013-04-14','17:15:00',6.99),('7643','2013-04-14','17:20:00',6.66),('7643','2013-04-14','17:25:00',6.37),('7643','2013-04-14','17:30:00',6.02),('7643','2013-04-14','17:35:00',5.7),('7643','2013-04-14','17:40:00',5.36),('7643','2013-04-14','17:45:00',5.04),('7643','2013-04-14','17:50:00',4.72),('7643','2013-04-14','17:55:00',4.36),('7643','2013-04-14','18:00:00',4.01),('7643','2013-04-14','18:05:00',3.6),('7643','2013-04-14','18:10:00',3.26),('7643','2013-04-14','18:15:00',2.98),('7643','2013-04-14','18:20:00',2.62),('7643','2013-04-14','18:25:00',2.35),('7643','2013-04-14','18:30:00',2.08),('7643','2013-04-14','18:35:00',1.77),('7643','2013-04-14','18:40:00',1.51),('7643','2013-04-14','18:45:00',1.35),('7643','2013-04-14','18:50:00',1.11),('7643','2013-04-13','07:20:00',1.23),('7643','2013-04-13','07:25:00',1.5),('7643','2013-04-13','09:15:00',6.4),('7643','2013-04-13','09:20:00',8.51),('7643','2013-04-13','09:25:00',8.9),('7643','2013-04-13','09:30:00',9.2),('7643','2013-04-13','09:35:00',9.43),('7643','2013-04-13','09:40:00',9.73),('7643','2013-04-13','09:45:00',10.04),('7643','2013-04-13','09:50:00',10.32),('7643','2013-04-13','09:55:00',10.55),('7643','2013-04-13','10:00:00',10.8),('7643','2013-04-13','10:05:00',11.08),('7643','2013-04-13','10:10:00',11.28),('7643','2013-04-13','10:15:00',11.57),('7643','2013-04-13','10:20:00',11.76),('7643','2013-04-13','10:25:00',11.94),('7643','2013-04-13','10:30:00',12.13),('7643','2013-04-13','10:35:00',12.34),('7643','2013-04-13','10:40:00',12.58),('7643','2013-04-13','10:45:00',12.73),('7643','2013-04-13','10:50:00',12.95),('7643','2013-04-13','10:55:00',13.18),('7643','2013-04-13','11:00:00',13.38),('7643','2013-04-13','11:05:00',13.48),('7643','2013-04-13','11:10:00',13.63),('7643','2013-04-13','11:15:00',13.82),('7643','2013-04-13','11:20:00',13.9),('7643','2013-04-13','11:25:00',13.91),('7643','2013-04-13','11:30:00',14.11),('7643','2013-04-13','11:35:00',14.21),('7643','2013-04-13','11:40:00',14.43),('7643','2013-04-13','11:45:00',14.5),('7643','2013-04-13','11:50:00',14.56),('7643','2013-04-13','11:55:00',14.62),('7643','2013-04-13','12:00:00',14.73),('7643','2013-04-13','12:05:00',14.87),('7643','2013-04-13','12:10:00',14.96),('7643','2013-04-13','12:15:00',15.09),('7643','2013-04-13','12:20:00',15.13),('7643','2013-04-13','12:25:00',15.11),('7643','2013-04-13','12:30:00',15.03),('7643','2013-04-13','12:35:00',15.27),('7643','2013-04-13','12:40:00',14.72),('7643','2013-04-13','13:00:00',14.12),('7643','2013-04-13','13:05:00',8.86),('7643','2013-04-13','13:10:00',6.83),('7643','2013-04-13','13:15:00',15.74),('7643','2013-04-13','13:20:00',16.21),('7643','2013-04-13','13:25:00',15.65),('7643','2013-04-13','13:30:00',15.46),('7643','2013-04-13','13:35:00',15.4),('7643','2013-04-13','13:40:00',15.18),('7643','2013-04-13','13:45:00',15.14),('7643','2013-04-13','13:50:00',14.94),('7643','2013-04-13','13:55:00',14.77),('7643','2013-04-13','14:00:00',14.58),('7643','2013-04-13','14:05:00',14.77),('7643','2013-04-13','14:10:00',14.68),('7643','2013-04-13','14:15:00',14.79),('7643','2013-04-13','14:20:00',14.68),('7643','2013-04-13','14:25:00',14.45),('7643','2013-04-13','14:30:00',14.45),('7643','2013-04-13','14:35:00',14.63),('7643','2013-04-13','14:40:00',14.71),('7643','2013-04-13','14:45:00',14.91),('7643','2013-04-13','14:50:00',14.92),('7643','2013-04-13','14:55:00',14.36),('7643','2013-04-13','15:00:00',13.91),('7643','2013-04-13','15:05:00',13.87),('7643','2013-04-13','15:10:00',10.73),('7643','2013-04-13','15:15:00',5.01),('7643','2013-04-13','15:20:00',11.63),('7643','2013-04-13','15:25:00',11.39),('7643','2013-04-13','15:30:00',11.32),('7643','2013-04-13','15:35:00',13.04),('7643','2013-04-13','15:40:00',12.83),('7643','2013-04-13','15:45:00',12.71),('7643','2013-04-13','15:50:00',12.3),('7643','2013-04-13','15:55:00',8.29),('7643','2013-04-13','16:00:00',11.12),('7643','2013-04-13','16:05:00',10.69),('7643','2013-04-13','16:10:00',10.74),('7643','2013-04-13','16:15:00',10.16),('7643','2013-04-13','16:20:00',9.83),('7643','2013-04-13','16:25:00',9.84),('7643','2013-04-13','16:30:00',9.57),('7643','2013-04-13','16:35:00',9.15),('7643','2013-04-13','16:40:00',8.87),('7643','2013-04-13','16:45:00',8.6),('7643','2013-04-13','16:50:00',8.32),('7643','2013-04-13','16:55:00',8.03),('7643','2013-04-13','17:00:00',7.68),('7643','2013-04-13','17:05:00',7.31),('7643','2013-04-13','17:10:00',7.13),('7643','2013-04-13','17:15:00',6.71),('7643','2013-04-13','17:20:00',6.35),('7643','2013-04-13','17:25:00',6.01),('7643','2013-04-13','17:30:00',5.74),('7643','2013-04-13','17:35:00',5.47),('7643','2013-04-13','17:40:00',5.15),('7643','2013-04-13','17:45:00',4.87),('7643','2013-04-13','17:50:00',4.54),('7643','2013-04-13','17:55:00',4.14),('7643','2013-04-13','18:00:00',3.8),('7643','2013-04-13','18:05:00',3.5),('7643','2013-04-13','18:10:00',3.15),('7643','2013-04-13','18:15:00',2.81),('7643','2013-04-13','18:20:00',2.52),('7643','2013-04-13','18:25:00',2.29),('7643','2013-04-13','18:30:00',2),('7643','2013-04-13','18:35:00',1.73),('7643','2013-04-13','18:40:00',1.52),('7643','2013-04-13','18:45:00',1.3),('7643','2013-04-13','18:50:00',1.07),('7643','2013-04-12','07:25:00',1.03),('7643','2013-04-12','07:30:00',1.49),('7643','2013-04-12','07:35:00',1.95),('7643','2013-04-12','07:40:00',2.24),('7643','2013-04-12','07:45:00',2.57),('7643','2013-04-12','07:50:00',2.87),('7643','2013-04-12','07:55:00',3.21),('7643','2013-04-12','08:00:00',3.59),('7643','2013-04-12','08:05:00',3.74),('7643','2013-04-12','08:10:00',4.16),('7643','2013-04-12','08:15:00',3.69),('7643','2013-04-12','08:20:00',2.86),('7643','2013-04-12','08:25:00',2.2),('7643','2013-04-12','08:30:00',2.12),('7643','2013-04-12','08:35:00',2.03),('7643','2013-04-12','08:40:00',2.11),('7643','2013-04-12','08:45:00',2.73),('7643','2013-04-12','08:50:00',3.63),('7643','2013-04-12','08:55:00',4.05),('7643','2013-04-12','09:00:00',4.08),('7643','2013-04-12','09:05:00',4.84),('7643','2013-04-12','09:10:00',5.98),('7643','2013-04-12','09:15:00',4.14),('7643','2013-04-12','09:20:00',5.33),('7643','2013-04-12','09:25:00',9.71),('7643','2013-04-12','09:30:00',9.15),('7643','2013-04-12','09:35:00',9.34),('7643','2013-04-12','09:40:00',8.51),('7643','2013-04-12','09:45:00',10.14),('7643','2013-04-12','09:50:00',10.31),('7643','2013-04-12','09:55:00',10.66),('7643','2013-04-12','10:00:00',10.87),('7643','2013-04-12','10:05:00',11.24),('7643','2013-04-12','10:10:00',12.14),('7643','2013-04-12','10:15:00',10.05),('7643','2013-04-12','10:20:00',7.09),('7643','2013-04-12','10:25:00',9.07),('7643','2013-04-12','10:30:00',12.16),('7643','2013-04-12','10:35:00',6.68),('7643','2013-04-12','10:40:00',13.82),('7643','2013-04-12','10:45:00',8.84),('7643','2013-04-12','10:50:00',7.77),('7643','2013-04-12','10:55:00',7.81),('7643','2013-04-12','11:00:00',5.63),('7643','2013-04-12','11:05:00',7.27),('7643','2013-04-12','11:10:00',14.9),('7643','2013-04-12','11:15:00',8.07),('7643','2013-04-12','11:20:00',16.16),('7643','2013-04-12','11:25:00',10.61),('7643','2013-04-12','11:30:00',10.2),('7643','2013-04-12','11:35:00',15.99),('7643','2013-04-12','11:40:00',15.64),('7643','2013-04-12','11:45:00',15.64),('7643','2013-04-12','11:50:00',16.58),('7643','2013-04-12','11:55:00',16.03),('7643','2013-04-12','12:00:00',16.06),('7643','2013-04-12','12:05:00',9.27),('7643','2013-04-12','12:10:00',15.87),('7643','2013-04-12','12:15:00',14.3),('7643','2013-04-12','12:20:00',12.47),('7643','2013-04-12','12:25:00',7.09),('7643','2013-04-12','12:30:00',16.87),('7643','2013-04-12','12:35:00',16.33),('7643','2013-04-12','12:40:00',16.38),('7643','2013-04-12','12:45:00',16.01),('7643','2013-04-12','12:50:00',15.52),('7643','2013-04-12','12:55:00',15.83),('7643','2013-04-12','13:00:00',15.66),('7643','2013-04-12','13:05:00',15.91),('7643','2013-04-12','13:10:00',12.84),('7643','2013-04-12','13:15:00',15.23),('7643','2013-04-12','13:20:00',16.16),('7643','2013-04-12','13:25:00',13.9),('7643','2013-04-12','13:30:00',12.46),('7643','2013-04-12','13:35:00',6.47),('7643','2013-04-12','13:40:00',8.95),('7643','2013-04-12','13:45:00',8.29),('7643','2013-04-12','13:50:00',6.78),('7643','2013-04-12','13:55:00',6),('7643','2013-04-12','14:00:00',5.76),('7643','2013-04-12','14:05:00',10.08),('7643','2013-04-12','14:10:00',6.99),('7643','2013-04-12','14:15:00',6.93),('7643','2013-04-12','14:20:00',11.46),('7643','2013-04-12','14:25:00',7.58),('7643','2013-04-12','14:30:00',14.06),('7643','2013-04-12','14:35:00',14.24),('7643','2013-04-12','14:40:00',13.74),('7643','2013-04-12','14:45:00',13.84),('7643','2013-04-12','14:50:00',13.22),('7643','2013-04-12','14:55:00',13.35),('7643','2013-04-12','15:00:00',12.15),('7643','2013-04-12','15:05:00',11.24),('7643','2013-04-12','15:10:00',11.59),('7643','2013-04-12','15:15:00',10.54),('7643','2013-04-12','15:20:00',10.59),('7643','2013-04-12','15:25:00',9.82),('7643','2013-04-12','15:30:00',10),('7643','2013-04-12','15:35:00',9.69),('7643','2013-04-12','15:40:00',10.06),('7643','2013-04-12','15:45:00',10.19),('7643','2013-04-12','15:50:00',9.77),('7643','2013-04-12','15:55:00',9.98),('7643','2013-04-12','16:00:00',9.71),('7643','2013-04-12','16:05:00',9.23),('7643','2013-04-12','16:10:00',8.64),('7643','2013-04-12','16:15:00',8.94),('7643','2013-04-12','16:20:00',8.56),('7643','2013-04-12','16:25:00',7.92),('7643','2013-04-12','16:30:00',7.52),('7643','2013-04-12','16:35:00',7.09),('7643','2013-04-12','16:40:00',6.73),('7643','2013-04-12','16:45:00',6.34),('7643','2013-04-12','16:50:00',6.53),('7643','2013-04-12','16:55:00',5.41),('7643','2013-04-12','17:00:00',4.58),('7643','2013-04-12','17:05:00',4.3),('7643','2013-04-12','17:10:00',6.02),('7643','2013-04-12','17:15:00',7.06),('7643','2013-04-12','17:20:00',5.86),('7643','2013-04-12','17:25:00',6.56),('7643','2013-04-12','17:30:00',5.73),('7643','2013-04-12','17:35:00',5.71),('7643','2013-04-12','17:40:00',5.43),('7643','2013-04-12','17:45:00',4.86),('7643','2013-04-12','17:50:00',4.24),('7643','2013-04-12','17:55:00',4.53),('7643','2013-04-12','18:00:00',3.48),('7643','2013-04-12','18:05:00',3.39),('7643','2013-04-12','18:10:00',3.04),('7643','2013-04-12','18:15:00',2.97),('7643','2013-04-12','18:20:00',2.72),('7643','2013-04-12','18:25:00',2.52),('7643','2013-04-12','18:30:00',2.28),('7643','2013-04-12','18:35:00',1.93),('7643','2013-04-12','18:40:00',1.64),('7643','2013-04-12','18:45:00',1.38),('7643','2013-04-12','18:50:00',1.14),('7643','2013-04-11','07:40:00',1.26),('7643','2013-04-11','07:45:00',1.73),('7643','2013-04-11','07:50:00',2.85),('7643','2013-04-11','07:55:00',3.4),('7643','2013-04-11','08:00:00',3.71),('7643','2013-04-11','08:05:00',4.53),('7643','2013-04-11','08:10:00',4.44),('7643','2013-04-11','08:15:00',3.45),('7643','2013-04-11','08:20:00',4.25),('7643','2013-04-11','08:25:00',3.25),('7643','2013-04-11','08:30:00',3.26),('7643','2013-04-11','08:35:00',4.65),('7643','2013-04-11','08:40:00',3.98),('7643','2013-04-11','08:45:00',4.46),('7643','2013-04-11','08:50:00',5.1),('7643','2013-04-11','08:55:00',7.11),('7643','2013-04-11','09:00:00',7.84),('7643','2013-04-11','09:05:00',7.25),('7643','2013-04-11','09:10:00',5.96),('7643','2013-04-11','09:15:00',6.83),('7643','2013-04-11','09:20:00',6.57),('7643','2013-04-11','09:25:00',4.71),('7643','2013-04-11','09:30:00',5.37),('7643','2013-04-11','09:35:00',4.37),('7643','2013-04-11','09:40:00',4.62),('7643','2013-04-11','09:45:00',5.51),('7643','2013-04-11','09:50:00',4.11),('7643','2013-04-11','09:55:00',3.29),('7643','2013-04-11','10:00:00',2.94),('7643','2013-04-11','10:05:00',3.16),('7643','2013-04-11','10:10:00',3.11),('7643','2013-04-11','10:15:00',3.79),('7643','2013-04-11','10:20:00',6.85),('7643','2013-04-11','10:25:00',4.39),('7643','2013-04-11','10:30:00',3.6),('7643','2013-04-11','10:35:00',4.34),('7643','2013-04-11','10:40:00',5.8),('7643','2013-04-11','10:45:00',12.64),('7643','2013-04-11','10:50:00',15.3),('7643','2013-04-11','10:55:00',17),('7643','2013-04-11','11:00:00',11.56),('7643','2013-04-11','11:05:00',12),('7643','2013-04-11','11:10:00',6.75),('7643','2013-04-11','11:15:00',14.76),('7643','2013-04-11','11:20:00',14.03),('7643','2013-04-11','11:25:00',13.75),('7643','2013-04-11','11:30:00',12.5),('7643','2013-04-11','11:35:00',15.95),('7643','2013-04-11','11:40:00',16.72),('7643','2013-04-11','11:45:00',12.56),('7643','2013-04-11','11:50:00',15.21),('7643','2013-04-11','11:55:00',15.91),('7643','2013-04-11','12:00:00',15.83),('7643','2013-04-11','12:05:00',15.2),('7643','2013-04-11','12:10:00',14.92),('7643','2013-04-11','12:15:00',15.57),('7643','2013-04-11','12:20:00',16),('7643','2013-04-11','12:25:00',16.09),('7643','2013-04-11','12:30:00',15.92),('7643','2013-04-11','12:35:00',15.83),('7643','2013-04-11','12:40:00',15.23),('7643','2013-04-11','12:45:00',15.52),('7643','2013-04-11','12:50:00',15.68),('7643','2013-04-11','12:55:00',15.74),('7643','2013-04-11','13:00:00',15.87),('7643','2013-04-11','13:05:00',15.91),('7643','2013-04-11','13:10:00',15.94),('7643','2013-04-11','13:15:00',15.91),('7643','2013-04-11','13:20:00',15.95),('7643','2013-04-11','13:25:00',15.95),('7643','2013-04-11','13:30:00',15.78),('7643','2013-04-11','13:35:00',15.97),('7643','2013-04-11','13:40:00',15.83),('7643','2013-04-11','13:45:00',15.83),('7643','2013-04-11','13:50:00',15.72),('7643','2013-04-11','13:55:00',15.65),('7643','2013-04-11','14:00:00',15.52),('7643','2013-04-11','14:05:00',15.44),('7643','2013-04-11','14:10:00',15.36),('7643','2013-04-11','14:15:00',15.23),('7643','2013-04-11','14:20:00',15.12),('7643','2013-04-11','14:25:00',14.91),('7643','2013-04-11','14:30:00',14.71),('7643','2013-04-11','14:35:00',14.59),('7643','2013-04-11','14:40:00',14.48),('7643','2013-04-11','14:45:00',14.3),('7643','2013-04-11','14:50:00',14.16),('7643','2013-04-11','14:55:00',13.99),('7643','2013-04-11','15:00:00',13.87),('7643','2013-04-11','15:05:00',13.69),('7643','2013-04-11','15:10:00',13.45),('7643','2013-04-11','15:15:00',13.35),('7643','2013-04-11','15:20:00',13.07),('7643','2013-04-11','15:25:00',12.9),('7643','2013-04-11','15:30:00',12.67),('7643','2013-04-11','15:35:00',12.46),('7643','2013-04-11','15:40:00',12.2),('7643','2013-04-11','15:45:00',11.98),('7643','2013-04-11','15:50:00',11.79),('7643','2013-04-11','15:55:00',11.51),('7643','2013-04-11','16:00:00',11.29),('7643','2013-04-11','16:05:00',11.1),('7643','2013-04-11','16:10:00',10.91),('7643','2013-04-11','16:15:00',9.62),('7643','2013-04-11','16:20:00',10.39),('7643','2013-04-11','16:25:00',10.13),('7643','2013-04-11','16:30:00',6.4),('7643','2013-04-11','16:35:00',4.15),('7643','2013-04-11','16:40:00',6.1),('7643','2013-04-11','16:45:00',9.26),('7643','2013-04-11','16:50:00',8.53),('7643','2013-04-11','16:55:00',8.2),('7643','2013-04-11','17:00:00',7.88),('7643','2013-04-11','17:05:00',7.58),('7643','2013-04-11','17:10:00',7.24),('7643','2013-04-11','17:15:00',6.86),('7643','2013-04-11','17:20:00',6.55),('7643','2013-04-11','17:25:00',6.2),('7643','2013-04-11','17:30:00',5.92),('7643','2013-04-11','17:35:00',5.62),('7643','2013-04-11','17:40:00',5.3),('7643','2013-04-11','17:45:00',4.95),('7643','2013-04-11','17:50:00',4.58),('7643','2013-04-11','17:55:00',4.21),('7643','2013-04-11','18:00:00',3.85),('7643','2013-04-11','18:05:00',3.49),('7643','2013-04-11','18:10:00',3.04),('7643','2013-04-11','18:15:00',2.72),('7643','2013-04-11','18:20:00',2.43),('7643','2013-04-11','18:25:00',2.19),('7643','2013-04-11','18:30:00',1.45),('7643','2013-04-11','18:35:00',1.54),('7643','2013-04-11','18:40:00',1.35),('7643','2013-04-11','18:50:00',1.05),('7643','2014-03-27','06:45:00',1.16),('7643','2014-03-27','06:50:00',1.54),('7643','2014-03-27','06:55:00',1.78),('7643','2014-03-27','07:00:00',2.28),('7643','2014-03-27','07:05:00',3.08),('7643','2014-03-27','07:10:00',3.67),('7643','2014-03-27','07:15:00',4.03),('7643','2014-03-27','07:20:00',4.3),('7643','2014-03-27','07:25:00',4.51),('7643','2014-03-27','07:30:00',4.44),('7643','2014-03-27','07:35:00',5.47),('7643','2014-03-27','07:40:00',5.64),('7643','2014-03-27','07:45:00',6.32),('7643','2014-03-27','07:50:00',6.77),('7643','2014-03-27','07:55:00',7.08),('7643','2014-03-27','08:00:00',7.39),('7643','2014-03-27','08:05:00',7.79),('7643','2014-03-27','08:10:00',8.2),('7643','2014-03-27','08:15:00',8.65),('7643','2014-03-27','08:20:00',9.02),('7643','2014-03-27','08:25:00',9.29),('7643','2014-03-27','08:30:00',9.6),('7643','2014-03-27','08:35:00',9.91),('7643','2014-03-27','08:40:00',10.26),('7643','2014-03-27','08:45:00',10.55),('7643','2014-03-27','08:50:00',10.85),('7643','2014-03-27','08:55:00',11.24),('7643','2014-03-27','09:00:00',11.35),('7643','2014-03-27','09:05:00',11.87),('7643','2014-03-27','09:10:00',12.61),('7643','2014-03-27','09:15:00',12.69),('7643','2014-03-27','09:20:00',11.11),('7643','2014-03-27','09:25:00',13.26),('7643','2014-03-27','09:30:00',14.07),('7643','2014-03-27','09:35:00',13.4),('7643','2014-03-27','09:40:00',8.67),('7643','2014-03-27','09:45:00',6.4),('7643','2014-03-27','09:50:00',9.13),('7643','2014-03-27','09:55:00',13.48),('7643','2014-03-27','10:00:00',15.06),('7643','2014-03-27','10:05:00',14.9),('7643','2014-03-27','10:10:00',13.28),('7643','2014-03-27','10:15:00',11.06),('7643','2014-03-27','10:20:00',10.55),('7643','2014-03-27','10:25:00',13.69),('7643','2014-03-27','10:30:00',15.12),('7643','2014-03-27','10:35:00',13.62),('7643','2014-03-27','10:40:00',14.03),('7643','2014-03-27','10:45:00',11.25),('7643','2014-03-27','10:50:00',15.2),('7643','2014-03-27','10:55:00',16.09),('7643','2014-03-27','11:00:00',16.21),('7643','2014-03-27','11:05:00',16),('7643','2014-03-27','11:10:00',9.69),('7643','2014-03-27','11:15:00',13.08),('7643','2014-03-27','11:20:00',13.82),('7643','2014-03-27','11:25:00',8.78),('7643','2014-03-27','11:30:00',10.07),('7643','2014-03-27','11:35:00',14.5),('7643','2014-03-27','11:40:00',9.92),('7643','2014-03-27','11:45:00',4.9),('7643','2014-03-27','11:50:00',4.99),('7643','2014-03-27','11:55:00',4.77),('7643','2014-03-27','12:00:00',5.39),('7643','2014-03-27','12:05:00',5.66),('7643','2014-03-27','12:10:00',18.7),('7643','2014-03-27','12:15:00',18.64),('7643','2014-03-27','12:20:00',18.7),('7643','2014-03-27','12:25:00',8.3),('7643','2014-03-27','12:30:00',4.02),('7643','2014-03-27','12:35:00',12.17),('7643','2014-03-27','12:40:00',14.78),('7643','2014-03-27','12:45:00',16.76),('7643','2014-03-27','12:50:00',17.03),('7643','2014-03-27','12:55:00',17.61),('7643','2014-03-27','13:00:00',18.12),('7643','2014-03-27','13:05:00',10.09),('7643','2014-03-27','13:10:00',6.06),('7643','2014-03-27','13:15:00',6.1),('7643','2014-03-27','13:20:00',14.83),('7643','2014-03-27','13:25:00',11.28),('7643','2014-03-27','13:30:00',7.5),('7643','2014-03-27','13:35:00',16.9),('7643','2014-03-27','13:40:00',16.38),('7643','2014-03-27','13:45:00',15.97),('7643','2014-03-27','13:50:00',15.57),('7643','2014-03-27','13:55:00',14.73),('7643','2014-03-27','14:00:00',15.11),('7643','2014-03-27','14:05:00',14.88),('7643','2014-03-27','14:10:00',14.19),('7643','2014-03-27','14:15:00',14.45),('7643','2014-03-27','14:20:00',14.3),('7643','2014-03-27','14:25:00',14.01),('7643','2014-03-27','14:30:00',13.83),('7643','2014-03-27','14:35:00',13.62),('7643','2014-03-27','14:40:00',13.43),('7643','2014-03-27','14:45:00',13.22),('7643','2014-03-27','14:50:00',13.04),('7643','2014-03-27','14:55:00',12.74),('7643','2014-03-27','15:00:00',12.63),('7643','2014-03-27','15:05:00',12.33),('7643','2014-03-27','15:10:00',11.97),('7643','2014-03-27','15:15:00',11.65),('7643','2014-03-27','15:20:00',11.39),('7643','2014-03-27','15:25:00',11),('7643','2014-03-27','15:30:00',10.73),('7643','2014-03-27','15:35:00',10.42),('7643','2014-03-27','15:40:00',10.13),('7643','2014-03-27','15:45:00',10.06),('7643','2014-03-27','15:50:00',9.87),('7643','2014-03-27','15:55:00',9.47),('7643','2014-03-27','16:00:00',9.74),('7643','2014-03-27','16:05:00',9.84),('7643','2014-03-27','16:10:00',9.52),('7643','2014-03-27','16:15:00',9.26),('7643','2014-03-27','16:20:00',8.08),('7643','2014-03-27','16:25:00',7.01),('7643','2014-03-27','16:30:00',6.13),('7643','2014-03-27','16:35:00',4.23),('7643','2014-03-27','16:40:00',4.74),('7643','2014-03-27','16:45:00',4.67),('7643','2014-03-27','16:50:00',4.92),('7643','2014-03-27','16:55:00',1.17),('7643','2014-03-27','17:00:00',1.99),('7643','2014-03-27','17:05:00',3.39),('7643','2014-03-27','17:10:00',3.17),('7643','2014-03-27','17:15:00',3.15),('7643','2014-03-27','17:20:00',3.39),('7643','2014-03-27','17:25:00',2.18),('7643','2014-03-27','17:30:00',1.21),('7643','2014-03-27','17:35:00',1.39),('7643','2014-03-27','17:40:00',1.33),('7643','2014-03-27','17:45:00',1.46),('7643','2014-03-27','17:50:00',1.11),('7643','2013-04-09','07:15:00',1.18),('7643','2013-04-09','07:20:00',1.44),('7643','2013-04-09','07:25:00',1.59),('7643','2013-04-09','07:30:00',1.54),('7643','2013-04-09','07:35:00',1.57),('7643','2013-04-09','07:40:00',1.37),('7643','2013-04-09','07:55:00',1.03),('7643','2013-04-09','08:00:00',1.44),('7643','2013-04-09','08:05:00',1.68),('7643','2013-04-09','08:10:00',1.75),('7643','2013-04-09','08:15:00',1.4),('7643','2013-04-09','08:20:00',1.1),('7643','2013-04-09','08:35:00',1.41),('7643','2013-04-09','08:40:00',1.5),('7643','2013-04-09','08:45:00',1.08),('7643','2013-04-09','08:50:00',1.45),('7643','2013-04-09','08:55:00',6.1),('7643','2013-04-09','09:00:00',7.33),('7643','2013-04-09','09:05:00',8.07),('7643','2013-04-09','09:10:00',8.6),('7643','2013-04-09','09:15:00',8.38),('7643','2013-04-09','09:20:00',8.75),('7643','2013-04-09','09:25:00',9.08),('7643','2013-04-09','09:30:00',9.49),('7643','2013-04-09','09:35:00',9.85),('7643','2013-04-09','09:40:00',10.09),('7643','2013-04-09','09:45:00',10.49),('7643','2013-04-09','09:50:00',10.81),('7643','2013-04-09','09:55:00',11.21),('7643','2013-04-09','10:00:00',11.43),('7643','2013-04-09','10:05:00',11.81),('7643','2013-04-09','10:10:00',12.32),('7643','2013-04-09','10:15:00',13.17),('7643','2013-04-09','10:20:00',13.15),('7643','2013-04-09','10:25:00',13.34),('7643','2013-04-09','10:30:00',13.42),('7643','2013-04-09','10:35:00',13.5),('7643','2013-04-09','10:40:00',13.63),('7643','2013-04-09','10:45:00',13.96),('7643','2013-04-09','10:50:00',13.23),('7643','2013-04-09','10:55:00',12.96),('7643','2013-04-09','11:00:00',13.29),('7643','2013-04-09','11:05:00',13.08),('7643','2013-04-09','11:10:00',12.12),('7643','2013-04-09','11:15:00',12.06),('7643','2013-04-09','11:20:00',14.21),('7643','2013-04-09','11:25:00',14.72),('7643','2013-04-09','11:30:00',14.92),('7643','2013-04-09','11:35:00',15.03),('7643','2013-04-09','11:40:00',14.11),('7643','2013-04-09','11:45:00',15.32),('7643','2013-04-09','11:50:00',15.39),('7643','2013-04-09','11:55:00',15.51),('7643','2013-04-09','12:00:00',15.58),('7643','2013-04-09','12:05:00',15.69),('7643','2013-04-09','12:10:00',15.8),('7643','2013-04-09','12:15:00',15.89),('7643','2013-04-09','12:20:00',16.05),('7643','2013-04-09','12:25:00',16.26),('7643','2013-04-09','12:30:00',16.43),('7643','2013-04-09','12:35:00',16.39),('7643','2013-04-09','12:40:00',16.3),('7643','2013-04-09','12:45:00',16.4),('7643','2013-04-09','12:50:00',16.54),('7643','2013-04-09','12:55:00',16.71),('7643','2013-04-09','13:00:00',17.17),('7643','2013-04-09','13:05:00',16.97),('7643','2013-04-09','13:10:00',14.14),('7643','2013-04-09','13:15:00',9.7),('7643','2013-04-09','13:20:00',9.43),('7643','2013-04-09','13:25:00',6.87),('7643','2013-04-09','13:30:00',10.99),('7643','2013-04-09','13:35:00',10.56),('7643','2013-04-09','13:40:00',13.39),('7643','2013-04-09','13:45:00',11.89),('7643','2013-04-09','13:50:00',17.34),('7643','2013-04-09','13:55:00',6.31),('7643','2013-04-09','14:00:00',15.38),('7643','2013-04-09','14:05:00',13.31),('7643','2013-04-09','14:10:00',15.47),('7643','2013-04-09','14:15:00',16.07),('7643','2013-04-09','14:20:00',16.23),('7643','2013-04-09','14:25:00',16.03),('7643','2013-04-09','14:30:00',15.68),('7643','2013-04-09','14:35:00',14.57),('7643','2013-04-09','14:40:00',15.42),('7643','2013-04-09','14:45:00',8.35),('7643','2013-04-09','14:50:00',12.85),('7643','2013-04-09','14:55:00',15.48),('7643','2013-04-09','15:00:00',9.94),('7643','2013-04-09','15:05:00',9.82),('7643','2013-04-09','15:10:00',10.5),('7643','2013-04-09','15:15:00',11.91),('7643','2013-04-09','15:20:00',10.35),('7643','2013-04-09','15:25:00',11.46),('7643','2013-04-09','15:30:00',12.96),('7643','2013-04-09','15:35:00',11.7),('7643','2013-04-09','15:40:00',12.9),('7643','2013-04-09','15:45:00',12.75),('7643','2013-04-09','15:50:00',12.59),('7643','2013-04-09','15:55:00',12.83),('7643','2013-04-09','16:00:00',12.25),('7643','2013-04-09','16:05:00',11.8),('7643','2013-04-09','16:10:00',12.11),('7643','2013-04-09','16:15:00',9.49),('7643','2013-04-09','16:20:00',11.31),('7643','2013-04-09','16:25:00',10.16),('7643','2013-04-09','16:30:00',10.38),('7643','2013-04-09','16:35:00',7.02),('7643','2013-04-09','16:40:00',9.88),('7643','2013-04-09','16:45:00',8.73),('7643','2013-04-09','16:50:00',7.98),('7643','2013-04-09','16:55:00',6.65),('7643','2013-04-09','17:00:00',7.86),('7643','2013-04-09','17:05:00',8.04),('7643','2013-04-09','17:10:00',3.58),('7643','2013-04-09','17:15:00',6.42),('7643','2013-04-09','17:20:00',7.38),('7643','2013-04-09','17:25:00',5.03),('7643','2013-04-09','17:30:00',6.17),('7643','2013-04-09','17:35:00',4.29),('7643','2013-04-09','17:40:00',6.08),('7643','2013-04-09','17:45:00',5.16),('7643','2013-04-09','17:50:00',5.29),('7643','2013-04-09','17:55:00',4.47),('7643','2013-04-09','18:00:00',4.27),('7643','2013-04-09','18:05:00',3.08),('7643','2013-04-09','18:10:00',2.62),('7643','2013-04-09','18:15:00',2.9),('7643','2013-04-09','18:20:00',2.22),('7643','2013-04-09','18:25:00',1.28),('7643','2013-04-08','07:25:00',1.18),('7643','2013-04-08','07:30:00',1.51),('7643','2013-04-08','07:35:00',1.98),('7643','2013-04-08','07:40:00',2.53),('7643','2013-04-08','07:45:00',2.03),('7643','2013-04-08','07:50:00',2.6),('7643','2013-04-08','07:55:00',3.44),('7643','2013-04-08','08:00:00',2.97),('7643','2013-04-08','08:05:00',3.14),('7643','2013-04-08','08:10:00',2.91),('7643','2013-04-08','08:15:00',2.68),('7643','2013-04-08','08:20:00',4.32),('7643','2013-04-08','08:25:00',2.88),('7643','2013-04-08','08:30:00',4.27),('7643','2013-04-08','08:35:00',3.59),('7643','2013-04-08','08:40:00',1.89),('7643','2013-04-08','08:45:00',2.02),('7643','2013-04-08','08:50:00',2.57),('7643','2013-04-08','08:55:00',2.36),('7643','2013-04-08','09:00:00',2.82),('7643','2013-04-08','09:05:00',3.67),('7643','2013-04-08','09:10:00',3.72),('7643','2013-04-08','09:15:00',4.1),('7643','2013-04-08','09:20:00',3.79),('7643','2013-04-08','09:25:00',4.05),('7643','2013-04-08','09:30:00',4.97),('7643','2013-04-08','09:35:00',4.27),('7643','2013-04-08','09:40:00',2.69),('7643','2013-04-08','09:45:00',5.39),('7643','2013-04-08','09:50:00',7.57),('7643','2013-04-08','09:55:00',11.92),('7643','2013-04-08','10:00:00',11.79),('7643','2013-04-08','10:05:00',6.51),('7643','2013-04-08','10:10:00',7.26),('7643','2013-04-08','10:15:00',7.91),('7643','2013-04-08','10:20:00',7.06),('7643','2013-04-08','10:25:00',4.79),('7643','2013-04-08','10:30:00',2.63),('7643','2013-04-08','10:35:00',12.82),('7643','2013-04-08','10:40:00',12.47),('7643','2013-04-08','10:45:00',13.68),('7643','2013-04-08','10:50:00',15.56),('7643','2013-04-08','10:55:00',12.68),('7643','2013-04-08','11:00:00',15.71),('7643','2013-04-08','11:05:00',11.45),('7643','2013-04-08','11:10:00',14.92),('7643','2013-04-08','11:15:00',8.98),('7643','2013-04-08','11:20:00',3.25),('7643','2013-04-08','11:25:00',9.13),('7643','2013-04-08','11:30:00',13.98),('7643','2013-04-08','11:35:00',15.15),('7643','2013-04-08','11:40:00',9.37),('7643','2013-04-08','11:45:00',12.04),('7643','2013-04-08','11:50:00',13.06),('7643','2013-04-08','11:55:00',12.38),('7643','2013-04-08','12:00:00',17.41),('7643','2013-04-08','12:05:00',17.02),('7643','2013-04-08','12:10:00',17.06),('7643','2013-04-08','12:15:00',16.94),('7643','2013-04-08','12:20:00',17.33),('7643','2013-04-08','12:25:00',16.47),('7643','2013-04-08','12:30:00',16.75),('7643','2013-04-08','12:35:00',17.33),('7643','2013-04-08','12:40:00',17),('7643','2013-04-08','12:45:00',17.57),('7643','2013-04-08','12:50:00',17.24),('7643','2013-04-08','12:55:00',16.99),('7643','2013-04-08','13:00:00',15.53),('7643','2013-04-08','13:05:00',17.55),('7643','2013-04-08','13:10:00',17.82),('7643','2013-04-08','13:15:00',9.56),('7643','2013-04-08','13:20:00',10.51),('7643','2013-04-08','13:25:00',10.87),('7643','2013-04-08','13:30:00',9.89),('7643','2013-04-08','13:35:00',4.52),('7643','2013-04-08','13:40:00',15.74),('7643','2013-04-08','13:45:00',16.68),('7643','2013-04-08','13:50:00',12.22),('7643','2013-04-08','13:55:00',16.29),('7643','2013-04-08','14:00:00',15.36),('7643','2013-04-08','14:05:00',15.69),('7643','2013-04-08','14:10:00',8.26),('7643','2013-04-08','14:15:00',11.66),('7643','2013-04-08','14:20:00',10.84),('7643','2013-04-08','14:25:00',13.61),('7643','2013-04-08','14:30:00',11.18),('7643','2013-04-08','14:35:00',13.94),('7643','2013-04-08','14:40:00',11.58),('7643','2013-04-08','14:45:00',13.56),('7643','2013-04-08','14:50:00',13.02),('7643','2013-04-08','14:55:00',11.48),('7643','2013-04-08','15:00:00',15.59),('7643','2013-04-08','15:05:00',12.42),('7643','2013-04-08','15:10:00',14.71),('7643','2013-04-08','15:15:00',13.89),('7643','2013-04-08','15:20:00',12.04),('7643','2013-04-08','15:25:00',14.76),('7643','2013-04-08','15:30:00',14.16),('7643','2013-04-08','15:35:00',14.23),('7643','2013-04-08','15:40:00',10.15),('7643','2013-04-08','15:45:00',13.93),('7643','2013-04-08','15:50:00',13.64),('7643','2013-04-08','15:55:00',10.67),('7643','2013-04-08','16:00:00',9.76),('7643','2013-04-08','16:05:00',6.57),('7643','2013-04-08','16:10:00',9.32),('7643','2013-04-08','16:15:00',3.29),('7643','2013-04-08','16:20:00',2.6),('7643','2013-04-08','16:25:00',3.95),('7643','2013-04-08','16:30:00',3.6),('7643','2013-04-08','16:35:00',3.63),('7643','2013-04-08','16:40:00',3.66),('7643','2013-04-08','16:45:00',4.47),('7643','2013-04-08','16:50:00',11.38),('7643','2013-04-08','16:55:00',7.42),('7643','2013-04-08','17:00:00',4.85),('7643','2013-04-08','17:05:00',2.77),('7643','2013-04-08','17:10:00',2.19),('7643','2013-04-08','17:15:00',3.48),('7643','2013-04-08','17:20:00',5.52),('7643','2013-04-08','17:25:00',3.83),('7643','2013-04-08','17:30:00',3.01),('7643','2013-04-08','17:35:00',2.39),('7643','2013-04-08','17:40:00',3.42),('7643','2013-04-08','17:45:00',3.3),('7643','2013-04-08','17:50:00',2.29),('7643','2013-04-08','17:55:00',1.98),('7643','2013-04-08','18:00:00',2.15),('7643','2013-04-08','18:05:00',2.18),('7643','2013-04-08','18:10:00',2.02),('7643','2013-04-08','18:15:00',2.66),('7643','2013-04-08','18:20:00',3.03),('7643','2013-04-08','18:25:00',1.37),('7643','2013-04-08','18:30:00',1.21),('7643','2013-04-08','18:35:00',1.17),('7643','2013-04-08','18:40:00',1.06),('7643','2013-04-07','07:30:00',1.42),('7643','2013-04-07','07:35:00',1.37),('7643','2013-04-07','07:40:00',1.55),('7643','2013-04-07','07:45:00',1.57),('7643','2013-04-07','07:50:00',1.59),('7643','2013-04-07','07:55:00',1.92),('7643','2013-04-07','08:00:00',2.06),('7643','2013-04-07','08:05:00',2.08),('7643','2013-04-07','08:10:00',3.21),('7643','2013-04-07','08:15:00',2.84),('7643','2013-04-07','08:20:00',2.72),('7643','2013-04-07','08:25:00',2.97),('7643','2013-04-07','08:30:00',2.86),('7643','2013-04-07','08:35:00',3.07),('7643','2013-04-07','08:40:00',6.01),('7643','2013-04-07','08:45:00',3.92),('7643','2013-04-07','08:50:00',5.36),('7643','2013-04-07','08:55:00',7),('7643','2013-04-07','09:00:00',5.17),('7643','2013-04-07','09:05:00',6.18),('7643','2013-04-07','09:10:00',9.66),('7643','2013-04-07','09:15:00',7.3),('7643','2013-04-07','09:20:00',6.97),('7643','2013-04-07','09:25:00',9.38),('7643','2013-04-07','09:30:00',9.9),('7643','2013-04-07','09:35:00',10.34),('7643','2013-04-07','09:40:00',10.36),('7643','2013-04-07','09:45:00',10.69),('7643','2013-04-07','09:50:00',6.69),('7643','2013-04-07','09:55:00',6.86),('7643','2013-04-07','10:00:00',11.31),('7643','2013-04-07','10:05:00',12.22),('7643','2013-04-07','10:10:00',11.47),('7643','2013-04-07','10:15:00',11.83),('7643','2013-04-07','10:20:00',11.66),('7643','2013-04-07','10:25:00',11.9),('7643','2013-04-07','10:30:00',12.24),('7643','2013-04-07','10:35:00',11.6),('7643','2013-04-07','10:40:00',13.05),('7643','2013-04-07','10:45:00',13.71),('7643','2013-04-07','10:50:00',13.63),('7643','2013-04-07','10:55:00',13.06),('7643','2013-04-07','11:00:00',13.76),('7643','2013-04-07','11:05:00',12.1),('7643','2013-04-07','11:10:00',11.46),('7643','2013-04-07','11:15:00',10.37),('7643','2013-04-07','11:20:00',8.91),('7643','2013-04-07','11:25:00',7.56),('7643','2013-04-07','11:30:00',8.5),('7643','2013-04-07','11:35:00',11.18),('7643','2013-04-07','11:40:00',12.43),('7643','2013-04-07','11:45:00',10.74),('7643','2013-04-07','11:50:00',9.96),('7643','2013-04-07','11:55:00',8.6),('7643','2013-04-07','12:00:00',8.16),('7643','2013-04-07','12:05:00',7.71),('7643','2013-04-07','12:10:00',8.21),('7643','2013-04-07','12:15:00',9.74),('7643','2013-04-07','12:20:00',9.99),('7643','2013-04-07','12:25:00',9.91),('7643','2013-04-07','12:30:00',11.29),('7643','2013-04-07','12:35:00',8.17),('7643','2013-04-07','12:40:00',9.46),('7643','2013-04-07','12:45:00',11.88),('7643','2013-04-07','12:50:00',9.18),('7643','2013-04-07','12:55:00',6.09),('7643','2013-04-07','13:00:00',5.73),('7643','2013-04-07','13:05:00',7.19),('7643','2013-04-07','13:10:00',9.74),('7643','2013-04-07','13:15:00',13.04),('7643','2013-04-07','13:20:00',13.65),('7643','2013-04-07','13:25:00',11.12),('7643','2013-04-07','13:30:00',10.86),('7643','2013-04-07','13:35:00',11.36),('7643','2013-04-07','13:40:00',10.94),('7643','2013-04-07','13:45:00',12.21),('7643','2013-04-07','13:50:00',9.85),('7643','2013-04-07','13:55:00',14.34),('7643','2013-04-07','14:00:00',14.22),('7643','2013-04-07','14:05:00',13.07),('7643','2013-04-07','14:10:00',12.7),('7643','2013-04-07','14:15:00',14.25),('7643','2013-04-07','14:20:00',12.97),('7643','2013-04-07','14:25:00',14.97),('7643','2013-04-07','14:30:00',14.53),('7643','2013-04-07','14:35:00',13.46),('7643','2013-04-07','14:40:00',13.59),('7643','2013-04-07','14:45:00',14.57),('7643','2013-04-07','14:50:00',13.62),('7643','2013-04-07','14:55:00',14.51),('7643','2013-04-07','15:00:00',11.53),('7643','2013-04-07','15:05:00',11.09),('7643','2013-04-07','15:10:00',10.76),('7643','2013-04-07','15:15:00',11.47),('7643','2013-04-07','15:20:00',11.16),('7643','2013-04-07','15:25:00',13.09),('7643','2013-04-07','15:30:00',13.53),('7643','2013-04-07','15:35:00',12.83),('7643','2013-04-07','15:40:00',12.4),('7643','2013-04-07','15:45:00',12.16),('7643','2013-04-07','15:50:00',11.96),('7643','2013-04-07','15:55:00',11.65),('7643','2013-04-07','16:00:00',11.39),('7643','2013-04-07','16:05:00',10.79),('7643','2013-04-07','16:10:00',10.08),('7643','2013-04-07','16:15:00',10.7),('7643','2013-04-07','16:20:00',10.7),('7643','2013-04-07','16:25:00',10.17),('7643','2013-04-07','16:30:00',9.86),('7643','2013-04-07','16:35:00',9.57),('7643','2013-04-07','16:40:00',9.33),('7643','2013-04-07','16:45:00',9.03),('7643','2013-04-07','16:50:00',8.74),('7643','2013-04-07','16:55:00',8.39),('7643','2013-04-07','17:00:00',8.12),('7643','2013-04-07','17:05:00',7.82),('7643','2013-04-07','17:10:00',7.28),('7643','2013-04-07','17:15:00',6.93),('7643','2013-04-07','17:20:00',6.51),('7643','2013-04-07','17:25:00',6.66),('7643','2013-04-07','17:30:00',6.17),('7643','2013-04-07','17:35:00',5.71),('7643','2013-04-07','17:40:00',5.15),('7643','2013-04-07','17:45:00',4.71),('7643','2013-04-07','17:50:00',3.83),('7643','2013-04-07','17:55:00',3.33),('7643','2013-04-07','18:00:00',3.51),('7643','2013-04-07','18:05:00',2.4),('7643','2013-04-07','18:10:00',1.8),('7643','2013-04-07','18:15:00',2.58),('7643','2013-04-07','18:20:00',3.74),('7643','2013-04-07','18:25:00',3.33),('7643','2013-04-07','18:30:00',2.08),('7643','2013-04-07','18:35:00',1.04),('7643','2013-04-06','07:50:00',1.14),('7643','2013-04-06','07:55:00',1.3),('7643','2013-04-06','08:00:00',1.5),('7643','2013-04-06','08:05:00',1.76),('7643','2013-04-06','08:10:00',2.11),('7643','2013-04-06','08:15:00',2.49),('7643','2013-04-06','08:20:00',3.03),('7643','2013-04-06','08:25:00',3.53),('7643','2013-04-06','08:30:00',4),('7643','2013-04-06','08:35:00',4.43),('7643','2013-04-06','08:40:00',4.74),('7643','2013-04-06','08:45:00',4.82),('7643','2013-04-06','08:50:00',4.92),('7643','2013-04-06','08:55:00',5.07),('7643','2013-04-06','09:00:00',4.92),('7643','2013-04-06','09:05:00',5.2),('7643','2013-04-06','09:10:00',5.61),('7643','2013-04-06','09:15:00',5.63),('7643','2013-04-06','09:20:00',5.96),('7643','2013-04-06','09:25:00',5.77),('7643','2013-04-06','09:30:00',5.53),('7643','2013-04-06','09:35:00',5.31),('7643','2013-04-06','09:40:00',5.32),('7643','2013-04-06','09:45:00',6.86),('7643','2013-04-06','09:50:00',7.7),('7643','2013-04-06','09:55:00',8.49),('7643','2013-04-06','10:00:00',9.91),('7643','2013-04-06','10:05:00',10.26),('7643','2013-04-06','10:10:00',10.18),('7643','2013-04-06','10:15:00',10.5),('7643','2013-04-06','10:20:00',10.6),('7643','2013-04-06','10:25:00',10.44),('7643','2013-04-06','10:30:00',9.11),('7643','2013-04-06','10:35:00',10.34),('7643','2013-04-06','10:40:00',10.28),('7643','2013-04-06','10:45:00',10.04),('7643','2013-04-06','10:50:00',9.54),('7643','2013-04-06','10:55:00',8.46),('7643','2013-04-06','11:00:00',7.72),('7643','2013-04-06','11:05:00',6.91),('7643','2013-04-06','11:10:00',8.35),('7643','2013-04-06','11:15:00',11.5),('7643','2013-04-06','11:20:00',13.19),('7643','2013-04-06','11:25:00',14.3),('7643','2013-04-06','11:30:00',13.4),('7643','2013-04-06','11:35:00',12.73),('7643','2013-04-06','11:40:00',11.01),('7643','2013-04-06','11:45:00',9.13),('7643','2013-04-06','11:50:00',8.67),('7643','2013-04-06','11:55:00',8.94),('7643','2013-04-06','12:00:00',9.38),('7643','2013-04-06','12:05:00',9.1),('7643','2013-04-06','12:10:00',9.97),('7643','2013-04-06','12:15:00',9.56),('7643','2013-04-06','12:20:00',10.77),('7643','2013-04-06','12:25:00',11.55),('7643','2013-04-06','12:30:00',9.99),('7643','2013-04-06','12:35:00',10.96),('7643','2013-04-06','12:40:00',10.2),('7643','2013-04-06','12:45:00',8.92),('7643','2013-04-06','12:50:00',9.98),('7643','2013-04-06','12:55:00',10.22),('7643','2013-04-06','13:00:00',12.44),('7643','2013-04-06','13:05:00',13.26),('7643','2013-04-06','13:10:00',12.38),('7643','2013-04-06','13:15:00',11.38),('7643','2013-04-06','13:20:00',10.86),('7643','2013-04-06','13:25:00',12.51),('7643','2013-04-06','13:30:00',11.96),('7643','2013-04-06','13:35:00',11.37),('7643','2013-04-06','13:40:00',12.77),('7643','2013-04-06','13:45:00',12.42),('7643','2013-04-06','13:50:00',11.6),('7643','2013-04-06','13:55:00',11.8),('7643','2013-04-06','14:00:00',12.48),('7643','2013-04-06','14:05:00',11.35),('7643','2013-04-06','14:10:00',9.67),('7643','2013-04-06','14:15:00',9.06),('7643','2013-04-06','14:20:00',8.6),('7643','2013-04-06','14:25:00',7.96),('7643','2013-04-06','14:30:00',8.97),('7643','2013-04-06','14:35:00',9.31),('7643','2013-04-06','14:40:00',8.77),('7643','2013-04-06','14:45:00',7.92),('7643','2013-04-06','14:50:00',8.33),('7643','2013-04-06','14:55:00',8.67),('7643','2013-04-06','15:00:00',7.39),('7643','2013-04-06','15:05:00',10.54),('7643','2013-04-06','15:10:00',10.95),('7643','2013-04-06','15:15:00',11.06),('7643','2013-04-06','15:20:00',10.29),('7643','2013-04-06','15:25:00',10.25),('7643','2013-04-06','15:30:00',11.47),('7643','2013-04-06','15:35:00',10.24),('7643','2013-04-06','15:40:00',10.8),('7643','2013-04-06','15:45:00',10.14),('7643','2013-04-06','15:50:00',9.57),('7643','2013-04-06','15:55:00',9.45),('7643','2013-04-06','16:00:00',8.98),('7643','2013-04-06','16:05:00',7.87),('7643','2013-04-06','16:10:00',6.7),('7643','2013-04-06','16:15:00',5.93),('7643','2013-04-06','16:20:00',5.57),('7643','2013-04-06','16:25:00',4.96),('7643','2013-04-06','16:30:00',4.96),('7643','2013-04-06','16:35:00',6.1),('7643','2013-04-06','16:40:00',6.3),('7643','2013-04-06','16:45:00',7.45),('7643','2013-04-06','16:50:00',8.29),('7643','2013-04-06','16:55:00',8.26),('7643','2013-04-06','17:00:00',7.65),('7643','2013-04-06','17:05:00',6.26),('7643','2013-04-06','17:10:00',4.26),('7643','2013-04-06','17:15:00',3.25),('7643','2013-04-06','17:20:00',5.02),('7643','2013-04-06','17:25:00',7.06),('7643','2013-04-06','17:30:00',6.44),('7643','2013-04-06','17:35:00',6.09),('7643','2013-04-06','17:40:00',6.01),('7643','2013-04-06','17:45:00',5.67),('7643','2013-04-06','17:50:00',5.21),('7643','2013-04-06','17:55:00',4.47),('7643','2013-04-06','18:00:00',3.19),('7643','2013-04-06','18:05:00',2.37),('7643','2013-04-06','18:10:00',2.29),('7643','2013-04-06','18:15:00',1.77),('7643','2013-04-06','18:20:00',1.55),('7643','2013-04-06','18:25:00',1.41),('7643','2013-04-06','18:30:00',1.29),('7643','2013-04-06','18:35:00',1.19),('7643','2013-04-06','18:40:00',1.09),('7643','2013-04-05','07:25:00',1.02),('7643','2013-04-05','07:30:00',1.3),('7643','2013-04-05','07:35:00',1.61),('7643','2013-04-05','07:40:00',1.92),('7643','2013-04-05','07:45:00',2.26),('7643','2013-04-05','07:50:00',2.62),('7643','2013-04-05','07:55:00',2.96),('7643','2013-04-05','08:00:00',3.32),('7643','2013-04-05','08:05:00',3.67),('7643','2013-04-05','08:10:00',4.08),('7643','2013-04-05','08:15:00',4.44),('7643','2013-04-05','08:20:00',4.79),('7643','2013-04-05','08:25:00',5.09),('7643','2013-04-05','08:30:00',5.43),('7643','2013-04-05','08:35:00',5.74),('7643','2013-04-05','08:40:00',6.03),('7643','2013-04-05','08:45:00',6.27),('7643','2013-04-05','08:50:00',6.55),('7643','2013-04-05','08:55:00',6.83),('7643','2013-04-05','09:00:00',7.19),('7643','2013-04-05','09:05:00',7.55),('7643','2013-04-05','09:10:00',7.89),('7643','2013-04-05','09:15:00',8.18),('7643','2013-04-05','09:20:00',8.5),('7643','2013-04-05','09:25:00',8.76),('7643','2013-04-05','09:30:00',9.12),('7643','2013-04-05','09:35:00',9.23),('7643','2013-04-05','09:40:00',9.61),('7643','2013-04-05','09:45:00',9.74),('7643','2013-04-05','09:50:00',10.05),('7643','2013-04-05','09:55:00',10.46),('7643','2013-04-05','10:00:00',10.67),('7643','2013-04-05','10:05:00',10.99),('7643','2013-04-05','10:10:00',11.18),('7643','2013-04-05','10:15:00',11.4),('7643','2013-04-05','10:20:00',11.69),('7643','2013-04-05','10:25:00',11.79),('7643','2013-04-05','10:30:00',12.04),('7643','2013-04-05','10:35:00',12.25),('7643','2013-04-05','10:40:00',12.46),('7643','2013-04-05','10:45:00',12.7),('7643','2013-04-05','10:50:00',12.86),('7643','2013-04-05','10:55:00',13.05),('7643','2013-04-05','11:00:00',13.29),('7643','2013-04-05','11:05:00',13.46),('7643','2013-04-05','11:10:00',13.68),('7643','2013-04-05','11:15:00',13.78),('7643','2013-04-05','11:20:00',13.95),('7643','2013-04-05','11:25:00',14.17),('7643','2013-04-05','11:30:00',14.1),('7643','2013-04-05','11:35:00',14.17),('7643','2013-04-05','11:40:00',14.38),('7643','2013-04-05','11:45:00',14.44),('7643','2013-04-05','11:50:00',14.46),('7643','2013-04-05','11:55:00',14.75),('7643','2013-04-05','12:00:00',14.71),('7643','2013-04-05','12:05:00',14.71),('7643','2013-04-05','12:10:00',14.82),('7643','2013-04-05','12:15:00',14.87),('7643','2013-04-05','12:20:00',14.97),('7643','2013-04-05','12:25:00',12.29),('7643','2013-04-05','12:30:00',14.3),('7643','2013-04-05','12:35:00',15.44),('7643','2013-04-05','12:40:00',15.42),('7643','2013-04-05','12:45:00',15.6),('7643','2013-04-05','12:50:00',15.74),('7643','2013-04-05','12:55:00',15.77),('7643','2013-04-05','13:00:00',15.66),('7643','2013-04-05','13:05:00',15.6),('7643','2013-04-05','13:10:00',9.64),('7643','2013-04-05','13:15:00',7.39),('7643','2013-04-05','13:20:00',4.13),('7643','2013-04-05','13:25:00',3.74),('7643','2013-04-05','13:30:00',13.52),('7643','2013-04-05','13:35:00',13.01),('7643','2013-04-05','13:40:00',16.98),('7643','2013-04-05','13:45:00',8.42),('7643','2013-04-05','13:50:00',14.97),('7643','2013-04-05','13:55:00',16.69),('7643','2013-04-05','14:00:00',15.97),('7643','2013-04-05','14:05:00',15.58),('7643','2013-04-05','14:10:00',16.64),('7643','2013-04-05','14:15:00',11.16),('7643','2013-04-05','14:20:00',4.33),('7643','2013-04-05','14:25:00',4.99),('7643','2013-04-05','14:30:00',11.6),('7643','2013-04-05','14:35:00',9),('7643','2013-04-05','14:40:00',7.87),('7643','2013-04-05','14:45:00',15.29),('7643','2013-04-05','14:50:00',14.53),('7643','2013-04-05','14:55:00',14.76),('7643','2013-04-05','15:00:00',14.05),('7643','2013-04-05','15:05:00',13.79),('7643','2013-04-05','15:10:00',13.19),('7643','2013-04-05','15:15:00',12.91),('7643','2013-04-05','15:20:00',12.8),('7643','2013-04-05','15:25:00',12.67),('7643','2013-04-05','15:30:00',12.04),('7643','2013-04-05','15:35:00',11.68),('7643','2013-04-05','15:40:00',11.75),('7643','2013-04-05','15:45:00',10.93),('7643','2013-04-05','15:50:00',9.86),('7643','2013-04-05','15:55:00',10.95),('7643','2013-04-05','16:00:00',10.38),('7643','2013-04-05','16:05:00',10.72),('7643','2013-04-05','16:10:00',10.95),('7643','2013-04-05','16:15:00',9.3),('7643','2013-04-05','16:20:00',8.41),('7643','2013-04-05','16:25:00',7.26),('7643','2013-04-05','16:30:00',8.83),('7643','2013-04-05','16:35:00',7.92),('7643','2013-04-05','16:40:00',6.51),('7643','2013-04-05','16:45:00',8.46),('7643','2013-04-05','16:50:00',7.95),('7643','2013-04-05','16:55:00',6.92),('7643','2013-04-05','17:00:00',6.74),('7643','2013-04-05','17:05:00',6.12),('7643','2013-04-05','17:10:00',5.33),('7643','2013-04-05','17:15:00',4.25),('7643','2013-04-05','17:20:00',3.33),('7643','2013-04-05','17:25:00',3.58),('7643','2013-04-05','17:30:00',3.43),('7643','2013-04-05','17:35:00',2.87),('7643','2013-04-05','17:40:00',2.76),('7643','2013-04-05','17:45:00',2.63),('7643','2013-04-05','17:50:00',2.59),('7643','2013-04-05','17:55:00',2.36),('7643','2013-04-05','18:00:00',2.09),('7643','2013-04-05','18:05:00',1.87),('7643','2013-04-05','18:10:00',1.68),('7643','2013-04-05','18:15:00',1.52),('7643','2013-04-05','18:20:00',1.38),('7643','2013-04-05','18:25:00',1.24),('7643','2013-04-05','18:30:00',1.13),('7643','2013-04-05','18:35:00',1.01),('7643','2013-04-04','08:00:00',1.74),('7643','2013-04-04','08:05:00',2.89),('7643','2013-04-04','08:10:00',3.33),('7643','2013-04-04','08:15:00',5.14),('7643','2013-04-04','08:20:00',5.28),('7643','2013-04-04','08:25:00',3.53),('7643','2013-04-04','08:30:00',2.09),('7643','2013-04-04','08:35:00',1.39),('7643','2013-04-04','08:40:00',2.64),('7643','2013-04-04','08:45:00',3.17),('7643','2013-04-04','08:50:00',2.24),('7643','2013-04-04','08:55:00',7.53),('7643','2013-04-04','09:00:00',4.32),('7643','2013-04-04','09:05:00',9.39),('7643','2013-04-04','09:10:00',6.56),('7643','2013-04-04','09:15:00',9.13),('7643','2013-04-04','09:20:00',7.93),('7643','2013-04-04','09:25:00',3.67),('7643','2013-04-04','09:30:00',3.18),('7643','2013-04-04','09:35:00',3.53),('7643','2013-04-04','09:40:00',5.59),('7643','2013-04-04','09:45:00',7.6),('7643','2013-04-04','09:50:00',4.5),('7643','2013-04-04','09:55:00',3.83),('7643','2013-04-04','10:00:00',5.5),('7643','2013-04-04','10:05:00',3.31),('7643','2013-04-04','10:10:00',10.79),('7643','2013-04-04','10:15:00',10.16),('7643','2013-04-04','10:20:00',4.15),('7643','2013-04-04','10:25:00',7.55),('7643','2013-04-04','10:30:00',7.71),('7643','2013-04-04','10:35:00',5.08),('7643','2013-04-04','10:40:00',11.06),('7643','2013-04-04','10:45:00',6.49),('7643','2013-04-04','10:50:00',9.85),('7643','2013-04-04','10:55:00',6.68),('7643','2013-04-04','11:00:00',5.78),('7643','2013-04-04','11:05:00',11.62),('7643','2013-04-04','11:10:00',12.8),('7643','2013-04-04','11:15:00',13.75),('7643','2013-04-04','11:20:00',12.79),('7643','2013-04-04','11:25:00',14.67),('7643','2013-04-04','11:30:00',15.77),('7643','2013-04-04','11:35:00',12.18),('7643','2013-04-04','11:40:00',13.41),('7643','2013-04-04','11:45:00',16),('7643','2013-04-04','11:50:00',16.11),('7643','2013-04-04','11:55:00',15.94),('7643','2013-04-04','12:00:00',16.43),('7643','2013-04-04','12:05:00',10.3),('7643','2013-04-04','12:10:00',8.29),('7643','2013-04-04','12:15:00',10.27),('7643','2013-04-04','12:20:00',5.47),('7643','2013-04-04','12:25:00',8.51),('7643','2013-04-04','12:30:00',4.78),('7643','2013-04-04','12:35:00',5.44),('7643','2013-04-04','12:40:00',5.99),('7643','2013-04-04','12:45:00',9.55),('7643','2013-04-04','12:50:00',17.99),('7643','2013-04-04','12:55:00',16.35),('7643','2013-04-04','13:00:00',10.38),('7643','2013-04-04','13:05:00',14.46),('7643','2013-04-04','13:10:00',11.74),('7643','2013-04-04','13:15:00',15.68),('7643','2013-04-04','13:20:00',13.33),('7643','2013-04-04','13:25:00',15.48),('7643','2013-04-04','13:30:00',12.66),('7643','2013-04-04','13:35:00',16.46),('7643','2013-04-04','13:40:00',13.93),('7643','2013-04-04','13:45:00',11.2),('7643','2013-04-04','13:50:00',17.23),('7643','2013-04-04','13:55:00',15.19),('7643','2013-04-04','14:00:00',13.24),('7643','2013-04-04','14:05:00',17.57),('7643','2013-04-04','14:10:00',17.17),('7643','2013-04-04','14:15:00',12.26),('7643','2013-04-04','14:20:00',13.72),('7643','2013-04-04','14:25:00',13.64),('7643','2013-04-04','14:30:00',16.37),('7643','2013-04-04','14:35:00',13.98),('7643','2013-04-04','14:40:00',13.89),('7643','2013-04-04','14:45:00',14.4),('7643','2013-04-04','14:50:00',8.98),('7643','2013-04-04','14:55:00',17.48),('7643','2013-04-04','15:00:00',15.41),('7643','2013-04-04','15:05:00',16.61),('7643','2013-04-04','15:10:00',12.22),('7643','2013-04-04','15:15:00',6.14),('7643','2013-04-04','15:20:00',6.24),('7643','2013-04-04','15:25:00',9.38),('7643','2013-04-04','15:30:00',7.9),('7643','2013-04-04','15:35:00',5.57),('7643','2013-04-04','15:40:00',4.58),('7643','2013-04-04','15:45:00',5.58),('7643','2013-04-04','15:50:00',8.29),('7643','2013-04-04','15:55:00',6.3),('7643','2013-04-04','16:00:00',6.58),('7643','2013-04-04','16:05:00',6.05),('7643','2013-04-04','16:10:00',6.13),('7643','2013-04-04','16:15:00',8.12),('7643','2013-04-04','16:20:00',8.85),('7643','2013-04-04','16:25:00',7.29),('7643','2013-04-04','16:30:00',6),('7643','2013-04-04','16:35:00',9.6),('7643','2013-04-04','16:40:00',5.56),('7643','2013-04-04','16:45:00',6.16),('7643','2013-04-04','16:50:00',10.61),('7643','2013-04-04','16:55:00',6.42),('7643','2013-04-04','17:00:00',5.18),('7643','2013-04-04','17:05:00',3.87),('7643','2013-04-04','17:10:00',7.57),('7643','2013-04-04','17:15:00',9.3),('7643','2013-04-04','17:20:00',8.07),('7643','2013-04-04','17:25:00',7.38),('7643','2013-04-04','17:30:00',6.78),('7643','2013-04-04','17:35:00',3.48),('7643','2013-04-04','17:40:00',5.41),('7643','2013-04-04','17:45:00',1.91),('7643','2013-04-04','17:50:00',2.38),('7643','2013-04-04','17:55:00',5.46),('7643','2013-04-04','18:00:00',3.64),('7643','2013-04-04','18:05:00',1.54),('7643','2013-04-04','18:10:00',1.2),('7643','2013-04-04','18:15:00',1.9),('7643','2013-04-04','18:20:00',2.95),('7643','2013-04-04','18:25:00',2.36),('7643','2013-04-04','18:30:00',1.68),('7643','2013-04-04','18:35:00',1.38),('7643','2013-04-04','18:40:00',1.38),('7643','2013-04-04','18:45:00',1.13),('7643','2013-04-03','07:40:00',1.07),('7643','2013-04-03','07:45:00',1.11),('7643','2013-04-03','07:50:00',1.35),('7643','2013-04-03','07:55:00',1.79),('7643','2013-04-03','08:00:00',2.03),('7643','2013-04-03','08:05:00',2.45),('7643','2013-04-03','08:10:00',2.08),('7643','2013-04-03','08:15:00',2.18),('7643','2013-04-03','08:20:00',2.31),('7643','2013-04-03','08:25:00',2.41),('7643','2013-04-03','08:30:00',2.52),('7643','2013-04-03','08:35:00',3.36),('7643','2013-04-03','08:40:00',3.15),('7643','2013-04-03','08:45:00',3.03),('7643','2013-04-03','08:50:00',3.05),('7643','2013-04-03','08:55:00',5.25),('7643','2013-04-03','09:00:00',7.85),('7643','2013-04-03','09:05:00',5.78),('7643','2013-04-03','09:10:00',5.22),('7643','2013-04-03','09:15:00',5.13),('7643','2013-04-03','09:20:00',4.92),('7643','2013-04-03','09:25:00',3.77),('7643','2013-04-03','09:30:00',5.63),('7643','2013-04-03','09:35:00',9.98),('7643','2013-04-03','09:40:00',9.55),('7643','2013-04-03','09:45:00',8.32),('7643','2013-04-03','09:50:00',4.36),('7643','2013-04-03','09:55:00',4.65),('7643','2013-04-03','10:00:00',7.08),('7643','2013-04-03','10:05:00',9.51),('7643','2013-04-03','10:10:00',8.22),('7643','2013-04-03','10:15:00',5.87),('7643','2013-04-03','10:20:00',7.03),('7643','2013-04-03','10:25:00',14.11),('7643','2013-04-03','10:30:00',12.22),('7643','2013-04-03','10:35:00',7.2),('7643','2013-04-03','10:40:00',15.04),('7643','2013-04-03','10:45:00',8.3),('7643','2013-04-03','10:50:00',8.2),('7643','2013-04-03','10:55:00',14.84),('7643','2013-04-03','11:00:00',9.67),('7643','2013-04-03','11:05:00',4.78),('7643','2013-04-03','11:10:00',3.97),('7643','2013-04-03','11:15:00',5.27),('7643','2013-04-03','11:20:00',5.26),('7643','2013-04-03','11:25:00',3.93),('7643','2013-04-03','11:30:00',4.37),('7643','2013-04-03','11:35:00',6.48),('7643','2013-04-03','11:40:00',11.12),('7643','2013-04-03','11:45:00',13.55),('7643','2013-04-03','11:50:00',15.45),('7643','2013-04-03','11:55:00',15.89),('7643','2013-04-03','12:00:00',15.87),('7643','2013-04-03','12:05:00',15.21),('7643','2013-04-03','12:10:00',15.42),('7643','2013-04-03','12:15:00',14.87),('7643','2013-04-03','12:20:00',12.03),('7643','2013-04-03','12:25:00',11.58),('7643','2013-04-03','12:30:00',11.81),('7643','2013-04-03','12:35:00',14.9),('7643','2013-04-03','12:40:00',11.42),('7643','2013-04-03','12:45:00',16.3),('7643','2013-04-03','12:50:00',16.07),('7643','2013-04-03','12:55:00',14.97),('7643','2013-04-03','13:00:00',14.75),('7643','2013-04-03','13:05:00',14.59),('7643','2013-04-03','13:10:00',15.44),('7643','2013-04-03','13:15:00',15.95),('7643','2013-04-03','13:20:00',15.41),('7643','2013-04-03','13:25:00',15.87),('7643','2013-04-03','13:30:00',15.57),('7643','2013-04-03','13:35:00',13.93),('7643','2013-04-03','13:40:00',11.76),('7643','2013-04-03','13:45:00',12.67),('7643','2013-04-03','13:50:00',12.62),('7643','2013-04-03','13:55:00',9.4),('7643','2013-04-03','14:00:00',10.07),('7643','2013-04-03','14:05:00',13.46),('7643','2013-04-03','14:10:00',15),('7643','2013-04-03','14:15:00',15.02),('7643','2013-04-03','14:20:00',14.75),('7643','2013-04-03','14:25:00',13.53),('7643','2013-04-03','14:30:00',14.34),('7643','2013-04-03','14:35:00',14.34),('7643','2013-04-03','14:40:00',14.38),('7643','2013-04-03','14:45:00',14.15),('7643','2013-04-03','14:50:00',13.95),('7643','2013-04-03','14:55:00',13.82),('7643','2013-04-03','15:00:00',13.67),('7643','2013-04-03','15:05:00',13.28),('7643','2013-04-03','15:10:00',12.49),('7643','2013-04-03','15:15:00',12.56),('7643','2013-04-03','15:20:00',12.63),('7643','2013-04-03','15:25:00',12.96),('7643','2013-04-03','15:30:00',12.61),('7643','2013-04-03','15:35:00',12.32),('7643','2013-04-03','15:40:00',12),('7643','2013-04-03','15:45:00',11.75),('7643','2013-04-03','15:50:00',11.25),('7643','2013-04-03','15:55:00',11.19),('7643','2013-04-03','16:00:00',10.92),('7643','2013-04-03','16:05:00',10.59),('7643','2013-04-03','16:10:00',10.02),('7643','2013-04-03','16:15:00',9.35),('7643','2013-04-03','16:20:00',8.79),('7643','2013-04-03','16:25:00',7.95),('7643','2013-04-03','16:30:00',7.45),('7643','2013-04-03','16:35:00',6.98),('7643','2013-04-03','16:40:00',7.21),('7643','2013-04-03','16:45:00',6.99),('7643','2013-04-03','16:50:00',5.83),('7643','2013-04-03','16:55:00',6.88),('7643','2013-04-03','17:00:00',6.35),('7643','2013-04-03','17:05:00',6.68),('7643','2013-04-03','17:10:00',5.81),('7643','2013-04-03','17:15:00',5.31),('7643','2013-04-03','17:20:00',3.93),('7643','2013-04-03','17:25:00',3.88),('7643','2013-04-03','17:30:00',2.88),('7643','2013-04-03','17:35:00',2.52),('7643','2013-04-03','17:40:00',2.99),('7643','2013-04-03','17:45:00',2.84),('7643','2013-04-03','17:50:00',3.42),('7643','2013-04-03','17:55:00',4.05),('7643','2013-04-03','18:00:00',3.17),('7643','2013-04-03','18:05:00',2.72),('7643','2013-04-03','18:10:00',1.37),('7643','2013-04-03','18:15:00',1.39),('7643','2013-04-03','18:20:00',1.22),('7643','2013-04-03','18:25:00',1.04),('7643','2013-04-02','07:41:00',1.69),('7643','2013-04-02','07:45:00',1.99),('7643','2013-04-02','07:50:00',2.36),('7643','2013-04-02','07:55:00',2.7),('7643','2013-04-02','08:00:00',3.09),('7643','2013-04-02','08:05:00',3.5),('7643','2013-04-02','08:10:00',3.88),('7643','2013-04-02','08:15:00',4.46),('7643','2013-04-02','08:20:00',4.96),('7643','2013-04-02','08:25:00',5.04),('7643','2013-04-02','08:30:00',5.94),('7643','2013-04-02','08:35:00',4.85),('7643','2013-04-02','08:40:00',3.56),('7643','2013-04-02','08:45:00',5.38),('7643','2013-04-02','08:50:00',5.42),('7643','2013-04-02','08:55:00',8.08),('7643','2013-04-02','09:00:00',8.24),('7643','2013-04-02','09:05:00',8.72),('7643','2013-04-02','09:10:00',9.17),('7643','2013-04-02','09:15:00',9.88),('7643','2013-04-02','09:20:00',5.41),('7643','2013-04-02','09:25:00',8.77),('7643','2013-04-02','09:30:00',6.71),('7643','2013-04-02','09:35:00',9.75),('7643','2013-04-02','09:40:00',9.51),('7643','2013-04-02','09:45:00',11.81),('7643','2013-04-02','09:50:00',8.69),('7643','2013-04-02','09:55:00',12.04),('7643','2013-04-02','10:00:00',9.39),('7643','2013-04-02','10:05:00',4.79),('7643','2013-04-02','10:10:00',4.36),('7643','2013-04-02','10:15:00',5.08),('7643','2013-04-02','10:20:00',9.78),('7643','2013-04-02','10:25:00',15.81),('7643','2013-04-02','10:30:00',13.68),('7643','2013-04-02','10:35:00',10.9),('7643','2013-04-02','10:40:00',7.14),('7643','2013-04-02','10:45:00',4.62),('7643','2013-04-02','10:50:00',8.55),('7643','2013-04-02','10:55:00',4.74),('7643','2013-04-02','11:00:00',12.09),('7643','2013-04-02','11:05:00',11.77),('7643','2013-04-02','11:10:00',12.05),('7643','2013-04-02','11:15:00',11.55),('7643','2013-04-02','11:20:00',12.7),('7643','2013-04-02','11:25:00',7.42),('7643','2013-04-02','11:30:00',6.7),('7643','2013-04-02','11:35:00',8.79),('7643','2013-04-02','11:40:00',8.92),('7643','2013-04-02','11:45:00',5.72),('7643','2013-04-02','11:50:00',12.9),('7643','2013-04-02','11:55:00',12.78),('7643','2013-04-02','12:00:00',10.6),('7643','2013-04-02','12:05:00',18.27),('7643','2013-04-02','12:10:00',13.25),('7643','2013-04-02','12:15:00',8.92),('7643','2013-04-02','12:20:00',13.2),('7643','2013-04-02','12:25:00',16.68),('7643','2013-04-02','12:30:00',18.62),('7643','2013-04-02','12:35:00',16.14),('7643','2013-04-02','12:40:00',17.84),('7643','2013-04-02','12:45:00',18.32),('7643','2013-04-02','12:50:00',18.72),('7643','2013-04-02','12:55:00',15.99),('7643','2013-04-02','13:00:00',15.26),('7643','2013-04-02','13:05:00',13.66),('7643','2013-04-02','13:10:00',12.51),('7643','2013-04-02','13:15:00',18.65),('7643','2013-04-02','13:20:00',14.13),('7643','2013-04-02','13:25:00',14.09),('7643','2013-04-02','13:30:00',11.73),('7643','2013-04-02','13:35:00',14.96),('7643','2013-04-02','13:40:00',15.07),('7643','2013-04-02','13:45:00',11.3),('7643','2013-04-02','13:50:00',16.34),('7643','2013-04-02','13:55:00',10.15),('7643','2013-04-02','14:00:00',14.98),('7643','2013-04-02','14:05:00',18.81),('7643','2013-04-02','14:10:00',18.22),('7643','2013-04-02','14:15:00',15.38),('7643','2013-04-02','14:20:00',10.84),('7643','2013-04-02','14:25:00',11.72),('7643','2013-04-02','14:30:00',13.5),('7643','2013-04-02','14:35:00',16.73),('7643','2013-04-02','14:40:00',11.24),('7643','2013-04-02','14:45:00',7.27),('7643','2013-04-02','14:50:00',14),('7643','2013-04-02','14:55:00',12.83),('7643','2013-04-02','15:00:00',13.33),('7643','2013-04-02','15:05:00',12.98),('7643','2013-04-02','15:10:00',14.54),('7643','2013-04-02','15:15:00',18.22),('7643','2013-04-02','15:20:00',12.74),('7643','2013-04-02','15:25:00',12.65),('7643','2013-04-02','15:30:00',8.39),('7643','2013-04-02','15:35:00',10.31),('7643','2013-04-02','15:40:00',13.53),('7643','2013-04-02','15:45:00',12.33),('7643','2013-04-02','15:50:00',14.67),('7643','2013-04-02','15:55:00',14.05),('7643','2013-04-02','16:00:00',13.62),('7643','2013-04-02','16:05:00',13.14),('7643','2013-04-02','16:10:00',12.74),('7643','2013-04-02','16:15:00',11.72),('7643','2013-04-02','16:20:00',11.99),('7643','2013-04-02','16:25:00',11.33),('7643','2013-04-02','16:30:00',11.4),('7643','2013-04-02','16:35:00',11),('7643','2013-04-02','16:40:00',10.45),('7643','2013-04-02','16:45:00',10.11),('7643','2013-04-02','16:50:00',9.81),('7643','2013-04-02','16:55:00',9.49),('7643','2013-04-02','17:00:00',9.09),('7643','2013-04-02','17:05:00',8.74),('7643','2013-04-02','17:10:00',8.37),('7643','2013-04-02','17:15:00',7.99),('7643','2013-04-02','17:20:00',7.59),('7643','2013-04-02','17:25:00',7.11),('7643','2013-04-02','17:30:00',6.86),('7643','2013-04-02','17:35:00',6.41),('7643','2013-04-02','17:40:00',6.02),('7643','2013-04-02','17:45:00',5.6),('7643','2013-04-02','17:50:00',5.19),('7643','2013-04-02','17:55:00',4.82),('7643','2013-04-02','18:00:00',4.39),('7643','2013-04-02','18:05:00',3.95),('7643','2013-04-02','18:10:00',3.51),('7643','2013-04-02','18:15:00',3.11),('7643','2013-04-02','18:20:00',2.7),('7643','2013-04-02','18:25:00',2.31),('7643','2013-04-02','18:30:00',2),('7643','2013-04-02','18:35:00',1.66),('7643','2013-04-02','18:40:00',1.39),('7643','2013-04-02','18:45:00',1.12),('7643','2013-04-01','08:25:00',1.06),('7643','2013-04-01','08:30:00',2.03),('7643','2013-04-01','08:35:00',2.41),('7643','2013-04-01','08:40:00',6.64),('7643','2013-04-01','08:45:00',7.14),('7643','2013-04-01','08:50:00',5.13),('7643','2013-04-01','08:55:00',4.73),('7643','2013-04-01','09:00:00',7.73),('7643','2013-04-01','09:05:00',8.15),('7643','2013-04-01','09:10:00',8.78),('7643','2013-04-01','09:15:00',9.1),('7643','2013-04-01','09:20:00',5.85),('7643','2013-04-01','09:25:00',5.19),('7643','2013-04-01','09:30:00',11.1),('7643','2013-04-01','09:35:00',9.04),('7643','2013-04-01','09:40:00',10.01),('7643','2013-04-01','09:45:00',11.91),('7643','2013-04-01','09:50:00',5.46),('7643','2013-04-01','09:55:00',6.23),('7643','2013-04-01','10:00:00',5.5),('7643','2013-04-01','10:05:00',11.19),('7643','2013-04-01','10:10:00',6.24),('7643','2013-04-01','10:15:00',7.6),('7643','2013-04-01','10:20:00',8.78),('7643','2013-04-01','10:25:00',6.11),('7643','2013-04-01','10:30:00',2.52),('7643','2013-04-01','10:35:00',5.56),('7643','2013-04-01','10:40:00',5.75),('7643','2013-04-01','10:45:00',12.07),('7643','2013-04-01','10:50:00',15.26),('7643','2013-04-01','10:55:00',8.48),('7643','2013-04-01','11:00:00',3.53),('7643','2013-04-01','11:05:00',10.42),('7643','2013-04-01','11:10:00',10.43),('7643','2013-04-01','11:15:00',4.86),('7643','2013-04-01','11:20:00',3.53),('7643','2013-04-01','11:25:00',3.77),('7643','2013-04-01','11:30:00',4.09),('7643','2013-04-01','11:35:00',5),('7643','2013-04-01','11:40:00',2.61),('7643','2013-04-01','11:45:00',6.18),('7643','2013-04-01','11:50:00',7.91),('7643','2013-04-01','11:55:00',5.44),('7643','2013-04-01','12:00:00',4.14),('7643','2013-04-01','12:05:00',9.2),('7643','2013-04-01','12:10:00',12.38),('7643','2013-04-01','12:15:00',9.08),('7643','2013-04-01','12:20:00',1.84),('7643','2013-04-01','12:30:00',3.23),('7643','2013-04-01','12:35:00',6.19),('7643','2013-04-01','12:40:00',9.88),('7643','2013-04-01','12:45:00',9.22),('7643','2013-04-01','12:50:00',8),('7643','2013-04-01','12:55:00',8.24),('7643','2013-04-01','13:00:00',7.91),('7643','2013-04-01','13:05:00',9.93),('7643','2013-04-01','13:10:00',12.76),('7643','2013-04-01','13:15:00',8.41),('7643','2013-04-01','13:20:00',7.05),('7643','2013-04-01','13:25:00',13.26),('7643','2013-04-01','13:30:00',9.91),('7643','2013-04-01','13:35:00',6.99),('7643','2013-04-01','13:40:00',8.85),('7643','2013-04-01','13:45:00',9.24),('7643','2013-04-01','13:50:00',7.46),('7643','2013-04-01','13:55:00',6.92),('7643','2013-04-01','14:00:00',9.42),('7643','2013-04-01','14:05:00',9.36),('7643','2013-04-01','14:10:00',14.27),('7643','2013-04-01','14:15:00',9.32),('7643','2013-04-01','14:20:00',16.2),('7643','2013-04-01','14:25:00',17.96),('7643','2013-04-01','14:30:00',13.52),('7643','2013-04-01','14:35:00',7.07),('7643','2013-04-01','14:40:00',8.92),('7643','2013-04-01','14:45:00',8.36),('7643','2013-04-01','14:50:00',7.39),('7643','2013-04-01','14:55:00',6.09),('7643','2013-04-01','15:00:00',6.01),('7643','2013-04-01','15:05:00',2.82),('7643','2013-04-01','15:10:00',1.77),('7643','2013-04-01','15:15:00',2.09),('7643','2013-04-01','15:20:00',3.33),('7643','2013-04-01','15:25:00',2.03),('7643','2013-04-01','15:30:00',1.99),('7643','2013-04-01','15:35:00',2.55),('7643','2013-04-01','15:40:00',3.18),('7643','2013-04-01','15:45:00',4.3),('7643','2013-04-01','15:50:00',1.94),('7643','2013-04-01','15:55:00',1.95),('7643','2013-04-01','16:00:00',3.52),('7643','2013-04-01','16:05:00',4.26),('7643','2013-04-01','16:10:00',3.21),('7643','2013-04-01','16:15:00',3.79),('7643','2013-04-01','16:20:00',3.97),('7643','2013-04-01','16:25:00',3.3),('7643','2013-04-01','16:30:00',3.36),('7643','2013-04-01','16:35:00',3.73),('7643','2013-04-01','16:40:00',3.26),('7643','2013-04-01','16:45:00',3.13),('7643','2013-04-01','16:50:00',2.17),('7643','2013-04-01','16:55:00',2.54),('7643','2013-04-01','17:00:00',2.75),('7643','2013-04-01','17:05:00',2.6),('7643','2013-04-01','17:15:00',1.12),('7643','2013-04-01','17:20:00',1.38),('7643','2013-04-01','17:35:00',2.04),('7643','2013-04-01','17:40:00',4.22),('7643','2013-04-01','17:45:00',4.03),('7643','2013-04-01','17:50:00',1.14),('7643','2013-04-01','18:00:00',1.57),('7643','2013-04-01','18:05:00',1.5),('7643','2014-05-01','07:00:00',1.18),('7643','2014-05-01','07:05:00',1.54),('7643','2014-05-01','07:10:00',2.32),('7643','2014-05-01','07:15:00',2.54),('7643','2014-05-01','07:20:00',1.53),('7643','2014-05-01','07:25:00',2.1),('7643','2014-05-01','07:30:00',3.49),('7643','2014-05-01','07:35:00',3.42),('7643','2014-05-01','07:40:00',3.82),('7643','2014-05-01','07:45:00',4.25),('7643','2014-05-01','07:50:00',3.79),('7643','2014-05-01','07:55:00',1.58),('7643','2014-05-01','08:00:00',3.31),('7643','2014-05-01','08:05:00',4.27),('7643','2014-05-01','08:10:00',3.65),('7643','2014-05-01','08:15:00',6.58),('7643','2014-05-01','08:20:00',6.53),('7643','2014-05-01','08:25:00',6.48),('7643','2014-05-01','08:30:00',4.35),('7643','2014-05-01','08:35:00',1.95),('7643','2014-05-01','08:40:00',2.32),('7643','2014-05-01','08:45:00',3.95),('7643','2014-05-01','08:50:00',5.76),('7643','2014-05-01','08:55:00',2.76),('7643','2014-05-01','09:00:00',1.88),('7643','2014-05-01','09:05:00',1.98),('7643','2014-05-01','09:10:00',2.47),('7643','2014-05-01','09:15:00',3.78),('7643','2014-05-01','09:20:00',4.85),('7643','2014-05-01','09:25:00',5.42),('7643','2014-05-01','09:30:00',5.88),('7643','2014-05-01','09:35:00',5.68),('7643','2014-05-01','09:40:00',4.95),('7643','2014-05-01','09:45:00',5.47),('7643','2014-05-01','09:50:00',5.43),('7643','2014-05-01','09:55:00',5.45),('7643','2014-05-01','10:00:00',6.33),('7643','2014-05-01','10:05:00',6.49),('7643','2014-05-01','10:10:00',7.66),('7643','2014-05-01','10:15:00',7.04),('7643','2014-05-01','10:20:00',6.21),('7643','2014-05-01','10:25:00',4.45),('7643','2014-05-01','10:30:00',3.43),('7643','2014-05-01','10:35:00',3.25),('7643','2014-05-01','10:40:00',3.44),('7643','2014-05-01','10:45:00',4.27),('7643','2014-05-01','10:50:00',3.91),('7643','2014-05-01','10:55:00',3.29),('7643','2014-05-01','11:00:00',2.07),('7643','2014-05-01','11:05:00',1.48),('7643','2014-05-01','11:10:00',1.32),('7643','2014-05-01','11:15:00',1.42),('7643','2014-05-01','11:20:00',1.8),('7643','2014-05-01','11:25:00',1.97),('7643','2014-05-01','11:30:00',1.91),('7643','2014-05-01','11:35:00',1.68),('7643','2014-05-01','11:40:00',1.29),('7643','2014-05-01','12:20:00',1.97),('7643','2014-05-01','12:25:00',2.87),('7643','2014-05-01','12:30:00',3.71),('7643','2014-05-01','12:35:00',4.2),('7643','2014-05-01','12:40:00',3.71),('7643','2014-05-01','12:45:00',4.13),('7643','2014-05-01','12:50:00',6.43),('7643','2014-05-01','12:55:00',6.36),('7643','2014-05-01','13:00:00',6.16),('7643','2014-05-01','13:05:00',7.57),('7643','2014-05-01','13:10:00',7.99),('7643','2014-05-01','13:15:00',8.25),('7643','2014-05-01','13:20:00',13.3),('7643','2014-05-01','13:25:00',10.05),('7643','2014-05-01','13:30:00',11.82),('7643','2014-05-01','13:35:00',7.67),('7643','2014-05-01','13:40:00',9.31),('7643','2014-05-01','13:45:00',8.31),('7643','2014-05-01','13:50:00',5.21),('7643','2014-05-01','13:55:00',5.55),('7643','2014-05-01','14:00:00',5.46),('7643','2014-05-01','14:05:00',7.39),('7643','2014-05-01','14:10:00',5.33),('7643','2014-05-01','14:15:00',2.43),('7643','2014-05-01','14:20:00',2.01),('7643','2014-05-01','14:25:00',3.03),('7643','2014-05-01','14:30:00',5.81),('7643','2014-05-01','14:35:00',8.48),('7643','2014-05-01','14:40:00',10.11),('7643','2014-05-01','14:45:00',7.97),('7643','2014-05-01','14:50:00',5.78),('7643','2014-05-01','14:55:00',7.19),('7643','2014-05-01','15:00:00',13.65),('7643','2014-05-01','15:05:00',8.17),('7643','2014-05-01','15:10:00',10.56),('7643','2014-05-01','15:15:00',14.74),('7643','2014-05-01','15:20:00',5.97),('7643','2014-05-01','15:25:00',4.67),('7643','2014-05-01','15:30:00',4.77),('7643','2014-05-01','15:35:00',10.54),('7643','2014-05-01','15:40:00',16.51),('7643','2014-05-01','15:45:00',5.74),('7643','2014-05-01','15:50:00',2.98),('7643','2014-05-01','15:55:00',3.1),('7643','2014-05-01','16:00:00',4.35),('7643','2014-05-01','16:05:00',6.67),('7643','2014-05-01','16:10:00',4.56),('7643','2014-05-01','16:15:00',3.15),('7643','2014-05-01','16:20:00',10.47),('7643','2014-05-01','16:25:00',2.5),('7643','2014-05-01','16:30:00',1.12),('7643','2014-05-01','16:35:00',1.14),('7643','2014-05-01','16:45:00',1.04),('7643','2014-05-01','16:50:00',1.68),('7643','2014-05-01','16:55:00',1.93),('7643','2014-05-01','17:00:00',1.97),('7643','2014-05-01','17:05:00',2.98),('7643','2014-05-01','17:10:00',2.53),('7643','2014-05-01','17:15:00',3.53),('7643','2014-05-01','17:20:00',4.11),('7643','2014-05-01','17:25:00',4.84),('7643','2014-05-01','17:30:00',3.67),('7643','2014-05-01','17:35:00',2.74),('7643','2014-05-01','17:40:00',2.31),('7643','2014-05-01','17:45:00',1.87),('7643','2014-05-01','17:50:00',1.5),('7643','2014-05-01','17:55:00',1.42),('7643','2014-05-01','18:00:00',1.42),('7643','2014-05-01','18:05:00',1.52),('7643','2014-05-01','18:10:00',1.4),('7643','2014-05-01','18:15:00',1),('7643','2014-03-26','07:25:00',1.25),('7643','2014-03-26','07:30:00',1.57),('7643','2014-03-26','07:35:00',1.73),('7643','2014-03-26','07:40:00',2.13),('7643','2014-03-26','07:45:00',2.64),('7643','2014-03-26','07:50:00',2.94),('7643','2014-03-26','07:55:00',4.24),('7643','2014-03-26','08:00:00',5.07),('7643','2014-03-26','08:05:00',5.12),('7643','2014-03-26','08:10:00',2.34),('7643','2014-03-26','08:20:00',1.04),('7643','2014-03-26','08:45:00',1.29),('7643','2014-03-26','08:50:00',1.57),('7643','2014-03-26','08:55:00',1.35),('7643','2014-03-26','09:00:00',1.33),('7643','2014-03-26','09:05:00',1.59),('7643','2014-03-26','09:10:00',2.48),('7643','2014-03-26','09:15:00',3.11),('7643','2014-03-26','09:20:00',3.01),('7643','2014-03-26','09:25:00',2.86),('7643','2014-03-26','09:30:00',2.36),('7643','2014-03-26','09:35:00',1.67),('7643','2014-03-26','09:40:00',1.55),('7643','2014-03-26','09:45:00',1.67),('7643','2014-03-26','09:50:00',2.07),('7643','2014-03-26','09:55:00',3),('7643','2014-03-26','10:00:00',3.38),('7643','2014-03-26','10:05:00',3.63),('7643','2014-03-26','10:10:00',4.92),('7643','2014-03-26','10:15:00',3.85),('7643','2014-03-26','10:20:00',5.63),('7643','2014-03-26','10:25:00',6.86),('7643','2014-03-26','10:30:00',8),('7643','2014-03-26','10:35:00',7.56),('7643','2014-03-26','10:40:00',9.96),('7643','2014-03-26','10:45:00',4.98),('7643','2014-03-26','10:50:00',2.85),('7643','2014-03-26','10:55:00',2.78),('7643','2014-03-26','11:00:00',3.35),('7643','2014-03-26','11:05:00',2.42),('7643','2014-03-26','11:10:00',10.62),('7643','2014-03-26','11:15:00',16.98),('7643','2014-03-26','11:20:00',10.33),('7643','2014-03-26','11:25:00',3.03),('7643','2014-03-26','11:30:00',2.94),('7643','2014-03-26','11:35:00',1.28),('7643','2014-03-26','11:45:00',1.56),('7643','2014-03-26','11:50:00',3.29),('7643','2014-03-26','11:55:00',5.39),('7643','2014-03-26','12:00:00',5.49),('7643','2014-03-26','12:05:00',3.7),('7643','2014-03-26','12:10:00',6.19),('7643','2014-03-26','12:15:00',4.49),('7643','2014-03-26','12:20:00',3.98),('7643','2014-03-26','12:25:00',1.98),('7643','2014-03-26','12:45:00',1.59),('7643','2014-03-26','12:50:00',2.48),('7643','2014-03-26','12:55:00',3.22),('7643','2014-03-26','13:00:00',3.4),('7643','2014-03-26','13:05:00',3.77),('7643','2014-03-26','13:10:00',5.55),('7643','2014-03-26','13:15:00',7.69),('7643','2014-03-26','13:20:00',8.51),('7643','2014-03-26','13:25:00',9.24),('7643','2014-03-26','13:30:00',7.94),('7643','2014-03-26','13:35:00',7.43),('7643','2014-03-26','13:40:00',7.05),('7643','2014-03-26','13:45:00',6.63),('7643','2014-03-26','13:50:00',8.37),('7643','2014-03-26','13:55:00',10.79),('7643','2014-03-26','14:00:00',9.6),('7643','2014-03-26','14:05:00',4.46),('7643','2014-03-26','14:10:00',3.57),('7643','2014-03-26','14:15:00',8.67),('7643','2014-03-26','14:20:00',13.42),('7643','2014-03-26','14:25:00',14.25),('7643','2014-03-26','14:30:00',11.89),('7643','2014-03-26','14:35:00',9.8),('7643','2014-03-26','14:40:00',6.59),('7643','2014-03-26','14:45:00',6.39),('7643','2014-03-26','14:50:00',9),('7643','2014-03-26','14:55:00',9.49),('7643','2014-03-26','15:00:00',7.17),('7643','2014-03-26','15:05:00',6.19),('7643','2014-03-26','15:10:00',2.11),('7643','2014-03-26','15:15:00',1.57),('7643','2014-03-26','15:20:00',4.24),('7643','2014-03-26','15:25:00',8.49),('7643','2014-03-26','15:30:00',9.27),('7643','2014-03-26','15:35:00',4.82),('7643','2014-03-26','15:40:00',3.28),('7643','2014-03-26','15:45:00',2.44),('7643','2014-03-26','15:50:00',3.9),('7643','2014-03-26','15:55:00',3.6),('7643','2014-03-26','16:00:00',2.97),('7643','2014-03-26','16:05:00',3.57),('7643','2014-03-26','16:10:00',4.78),('7643','2014-03-26','16:15:00',4.65),('7643','2014-03-26','16:20:00',3.38),('7643','2014-03-26','16:25:00',3.88),('7643','2014-03-26','16:30:00',4.18),('7643','2014-03-26','16:35:00',3.23),('7643','2014-03-26','16:40:00',3.81),('7643','2014-03-26','16:45:00',3.85),('7643','2014-03-26','16:50:00',2.17),('7643','2014-03-26','16:55:00',2.67),('7643','2014-03-26','17:00:00',2.77),('7643','2014-03-26','17:05:00',2.69),('7643','2014-03-26','17:10:00',2.07),('7643','2014-03-26','17:15:00',2.13),('7643','2014-03-26','17:20:00',1.69),('7643','2013-03-31','07:41:00',1.03),('7643','2013-03-31','07:45:00',1.24),('7643','2013-03-31','07:50:00',1.32),('7643','2013-03-31','07:55:00',1.33),('7643','2013-03-31','08:00:00',2.15),('7643','2013-03-31','08:05:00',1.69),('7643','2013-03-31','08:10:00',1.25),('7643','2013-03-31','08:15:00',1.55),('7643','2013-03-31','08:20:00',2.92),('7643','2013-03-31','08:25:00',5.1),('7643','2013-03-31','08:30:00',4.58),('7643','2013-03-31','08:35:00',6.11),('7643','2013-03-31','08:40:00',7.41),('7643','2013-03-31','08:45:00',4.93),('7643','2013-03-31','08:50:00',7.53),('7643','2013-03-31','08:55:00',7.96),('7643','2013-03-31','09:00:00',7.77),('7643','2013-03-31','09:05:00',8.16),('7643','2013-03-31','09:10:00',8.8),('7643','2013-03-31','09:15:00',9.14),('7643','2013-03-31','09:20:00',8.78),('7643','2013-03-31','09:25:00',9.53),('7643','2013-03-31','09:30:00',9.22),('7643','2013-03-31','09:35:00',6.76),('7643','2013-03-31','09:40:00',9.56),('7643','2013-03-31','09:45:00',11.31),('7643','2013-03-31','09:50:00',11.07),('7643','2013-03-31','09:55:00',10.45),('7643','2013-03-31','10:00:00',11.72),('7643','2013-03-31','10:05:00',12.07),('7643','2013-03-31','10:10:00',11.16),('7643','2013-03-31','10:15:00',11.23),('7643','2013-03-31','10:20:00',12.84),('7643','2013-03-31','10:25:00',10.45),('7643','2013-03-31','10:30:00',10.13),('7643','2013-03-31','10:35:00',4.8),('7643','2013-03-31','10:40:00',10.41),('7643','2013-03-31','10:45:00',13.79),('7643','2013-03-31','10:50:00',3.46),('7643','2013-03-31','10:55:00',3.65),('7643','2013-03-31','11:00:00',4.2),('7643','2013-03-31','11:05:00',5.53),('7643','2013-03-31','11:10:00',9.41),('7643','2013-03-31','11:15:00',10.22),('7643','2013-03-31','11:20:00',14.43),('7643','2013-03-31','11:25:00',11.01),('7643','2013-03-31','11:30:00',8.86),('7643','2013-03-31','11:35:00',7.54),('7643','2013-03-31','11:40:00',12.67),('7643','2013-03-31','11:45:00',12.6),('7643','2013-03-31','11:50:00',9.73),('7643','2013-03-31','11:55:00',8.7),('7643','2013-03-31','12:00:00',11.62),('7643','2013-03-31','12:05:00',7.63),('7643','2013-03-31','12:10:00',9.24),('7643','2013-03-31','12:15:00',7.63),('7643','2013-03-31','12:20:00',6.83),('7643','2013-03-31','12:25:00',7.23),('7643','2013-03-31','12:30:00',9.78),('7643','2013-03-31','12:35:00',9.28),('7643','2013-03-31','12:40:00',8.93),('7643','2013-03-31','12:45:00',10.3),('7643','2013-03-31','12:50:00',10.96),('7643','2013-03-31','12:55:00',11.85),('7643','2013-03-31','13:00:00',11.19),('7643','2013-03-31','13:05:00',12.37),('7643','2013-03-31','13:10:00',10.81),('7643','2013-03-31','13:15:00',11.7),('7643','2013-03-31','13:20:00',11.36),('7643','2013-03-31','13:25:00',10.29),('7643','2013-03-31','13:30:00',11.24),('7643','2013-03-31','13:35:00',10.29),('7643','2013-03-31','13:40:00',13.67),('7643','2013-03-31','13:45:00',14.74),('7643','2013-03-31','13:50:00',16.31),('7643','2013-03-31','13:55:00',15.49),('7643','2013-03-31','14:00:00',9.24),('7643','2013-03-31','14:05:00',6.89),('7643','2013-03-31','14:10:00',8.82),('7643','2013-03-31','14:15:00',9.99),('7643','2013-03-31','14:20:00',10.57),('7643','2013-03-31','14:25:00',16.64),('7643','2013-03-31','14:30:00',9.93),('7643','2013-03-31','14:35:00',8.32),('7643','2013-03-31','14:40:00',7.41),('7643','2013-03-31','14:45:00',7.16),('7643','2013-03-31','14:50:00',7.83),('7643','2013-03-31','14:55:00',8.47),('7643','2013-03-31','15:00:00',7.51),('7643','2013-03-31','15:05:00',7.53),('7643','2013-03-31','15:10:00',7.69),('7643','2013-03-31','15:15:00',8.28),('7643','2013-03-31','15:20:00',8.59),('7643','2013-03-31','15:25:00',8.53),('7643','2013-03-31','15:30:00',7.73),('7643','2013-03-31','15:35:00',9.96),('7643','2013-03-31','15:40:00',9.35),('7643','2013-03-31','15:45:00',9.62),('7643','2013-03-31','15:50:00',10.8),('7643','2013-03-31','15:55:00',8.07),('7643','2013-03-31','16:00:00',7.35),('7643','2013-03-31','16:05:00',5.92),('7643','2013-03-31','16:10:00',4.95),('7643','2013-03-31','16:15:00',4.05),('7643','2013-03-31','16:20:00',3.78),('7643','2013-03-31','16:25:00',3.47),('7643','2013-03-31','16:30:00',2.94),('7643','2013-03-31','16:35:00',3.04),('7643','2013-03-31','16:40:00',2.82),('7643','2013-03-31','16:45:00',2.37),('7643','2013-03-31','16:50:00',1.47),('7643','2013-03-31','16:55:00',1.04),('7643','2013-03-30','08:00:00',1.07),('7643','2013-03-30','08:05:00',1.2),('7643','2013-03-30','08:10:00',1.02),('7643','2013-03-30','08:15:00',1.73),('7643','2013-03-30','08:20:00',3.33),('7643','2013-03-30','08:25:00',2.39),('7643','2013-03-30','08:30:00',3.49),('7643','2013-03-30','08:35:00',4.58),('7643','2013-03-30','08:40:00',3.84),('7643','2013-03-30','08:45:00',4.51),('7643','2013-03-30','08:50:00',4.03),('7643','2013-03-30','08:55:00',3.94),('7643','2013-03-30','09:00:00',4.85),('7643','2013-03-30','09:05:00',4.31),('7643','2013-03-30','09:10:00',4.26),('7643','2013-03-30','09:15:00',4.36),('7643','2013-03-30','09:20:00',8.86),('7643','2013-03-30','09:25:00',11.28),('7643','2013-03-30','09:30:00',7.98),('7643','2013-03-30','09:35:00',7.11),('7643','2013-03-30','09:40:00',4.09),('7643','2013-03-30','09:45:00',9.68),('7643','2013-03-30','09:50:00',5.18),('7643','2013-03-30','09:55:00',7.26),('7643','2013-03-30','10:00:00',8.74),('7643','2013-03-30','10:05:00',3.06),('7643','2013-03-30','10:10:00',1.89),('7643','2013-03-30','10:15:00',3.27),('7643','2013-03-30','10:20:00',7.31),('7643','2013-03-30','10:25:00',9.39),('7643','2013-03-30','10:30:00',11.96),('7643','2013-03-30','10:35:00',11.9),('7643','2013-03-30','10:40:00',2.72),('7643','2013-03-30','10:45:00',4.03),('7643','2013-03-30','10:50:00',7.18),('7643','2013-03-30','10:55:00',4.22),('7643','2013-03-30','11:00:00',2.65),('7643','2013-03-30','11:05:00',2.59),('7643','2013-03-30','11:10:00',5.42),('7643','2013-03-30','11:15:00',5.23),('7643','2013-03-30','11:20:00',4.34),('7643','2013-03-30','11:25:00',4.99),('7643','2013-03-30','11:30:00',3.53),('7643','2013-03-30','11:35:00',4.94),('7643','2013-03-30','11:40:00',6.23),('7643','2013-03-30','11:45:00',4.71),('7643','2013-03-30','11:50:00',5.48),('7643','2013-03-30','11:55:00',6.4),('7643','2013-03-30','12:00:00',5.74),('7643','2013-03-30','12:05:00',5.3),('7643','2013-03-30','12:10:00',5.21),('7643','2013-03-30','12:15:00',5.24),('7643','2013-03-30','12:20:00',4.94),('7643','2013-03-30','12:25:00',5.68),('7643','2013-03-30','12:30:00',6.67),('7643','2013-03-30','12:35:00',10.42),('7643','2013-03-30','12:40:00',8.19),('7643','2013-03-30','12:45:00',5.43),('7643','2013-03-30','12:50:00',5.98),('7643','2013-03-30','12:55:00',7.5),('7643','2013-03-30','13:00:00',9.28),('7643','2013-03-30','13:05:00',9.67),('7643','2013-03-30','13:10:00',10.17),('7643','2013-03-30','13:15:00',8.16),('7643','2013-03-30','13:20:00',15.03),('7643','2013-03-30','13:25:00',12.01),('7643','2013-03-30','13:30:00',3.01),('7643','2013-03-30','13:35:00',3.14),('7643','2013-03-30','13:40:00',5.41),('7643','2013-03-30','13:45:00',7.31),('7643','2013-03-30','13:50:00',8.74),('7643','2013-03-30','13:55:00',10.03),('7643','2013-03-30','14:00:00',6.59),('7643','2013-03-30','14:05:00',11.04),('7643','2013-03-30','14:10:00',7.89),('7643','2013-03-30','14:15:00',13.99),('7643','2013-03-30','14:20:00',6.04),('7643','2013-03-30','14:25:00',6.69),('7643','2013-03-30','14:30:00',16.77),('7643','2013-03-30','14:35:00',16.88),('7643','2013-03-30','14:40:00',16.91),('7643','2013-03-30','14:45:00',13.21),('7643','2013-03-30','14:50:00',13.77),('7643','2013-03-30','14:55:00',11.31),('7643','2013-03-30','15:00:00',10.04),('7643','2013-03-30','15:05:00',7.29),('7643','2013-03-30','15:10:00',11.83),('7643','2013-03-30','15:15:00',11.4),('7643','2013-03-30','15:20:00',16.65),('7643','2013-03-30','15:25:00',10.75),('7643','2013-03-30','15:30:00',9.87),('7643','2013-03-30','15:35:00',12.63),('7643','2013-03-30','15:40:00',16.16),('7643','2013-03-30','15:45:00',10.49),('7643','2013-03-30','15:50:00',3.79),('7643','2013-03-30','15:55:00',3.02),('7643','2013-03-30','16:00:00',12.53),('7643','2013-03-30','16:05:00',5.16),('7643','2013-03-30','16:10:00',5.52),('7643','2013-03-30','16:15:00',6.92),('7643','2013-03-30','16:20:00',6.61),('7643','2013-03-30','16:25:00',4.89),('7643','2013-03-30','16:30:00',3.99),('7643','2013-03-30','16:35:00',4.14),('7643','2013-03-30','16:40:00',4.96),('7643','2013-03-30','16:45:00',3.82),('7643','2013-03-30','16:50:00',3.41),('7643','2013-03-30','16:55:00',2.98),('7643','2013-03-30','17:00:00',4.3),('7643','2013-03-30','17:05:00',7.8),('7643','2013-03-30','17:10:00',6.88),('7643','2013-03-30','17:15:00',4.19),('7643','2013-03-30','17:20:00',4.15),('7643','2013-03-30','17:25:00',4.61),('7643','2013-03-30','17:30:00',4.81),('7643','2013-03-30','17:35:00',4.68),('7643','2013-03-30','17:40:00',3.03),('7643','2013-03-30','17:45:00',3.14),('7643','2013-03-30','17:50:00',3.42),('7643','2013-03-30','17:55:00',5.68),('7643','2013-03-30','18:00:00',3.5),('7643','2013-03-30','18:10:00',1.57),('7643','2013-03-30','18:15:00',4.46),('7643','2013-03-30','18:20:00',2.89),('7643','2013-03-30','18:25:00',1.09),('7643','2013-03-30','18:30:00',1.44),('7643','2013-03-30','18:35:00',1.19),('7643','2013-03-30','18:50:00',1.05),('7643','2013-03-29','06:50:00',1.08),('7643','2013-03-29','06:55:00',1.24),('7643','2013-03-29','07:00:00',1.33),('7643','2013-03-29','07:05:00',1.68),('7643','2013-03-29','07:10:00',1.57),('7643','2013-03-29','07:15:00',1.12),('7643','2013-03-29','07:20:00',1.57),('7643','2013-03-29','07:25:00',1.97),('7643','2013-03-29','07:30:00',2.07),('7643','2013-03-29','07:35:00',1.84),('7643','2013-03-29','07:40:00',1.31),('7643','2013-03-29','07:45:00',1.51),('7643','2013-03-29','07:50:00',2.49),('7643','2013-03-29','07:55:00',3.49),('7643','2013-03-29','08:00:00',2.68),('7643','2013-03-29','08:05:00',2.29),('7643','2013-03-29','08:10:00',2.38),('7643','2013-03-29','08:15:00',3.13),('7643','2013-03-29','08:20:00',3.14),('7643','2013-03-29','08:25:00',3.26),('7643','2013-03-29','08:30:00',3.35),('7643','2013-03-29','08:35:00',4.13),('7643','2013-03-29','08:40:00',4.11),('7643','2013-03-29','08:45:00',3.37),('7643','2013-03-29','08:50:00',3.46),('7643','2013-03-29','08:55:00',2.98),('7643','2013-03-29','09:00:00',2.94),('7643','2013-03-29','09:05:00',7.11),('7643','2013-03-29','09:10:00',6.27),('7643','2013-03-29','09:15:00',7.79),('7643','2013-03-29','09:20:00',15.39),('7643','2013-03-29','09:25:00',9.99),('7643','2013-03-29','09:30:00',4.87),('7643','2013-03-29','09:35:00',5.76),('7643','2013-03-29','09:40:00',5.2),('7643','2013-03-29','09:45:00',4.88),('7643','2013-03-29','09:50:00',3.87),('7643','2013-03-29','09:55:00',4.66),('7643','2013-03-29','10:00:00',6.32),('7643','2013-03-29','10:05:00',6.47),('7643','2013-03-29','10:10:00',7),('7643','2013-03-29','10:15:00',6.39),('7643','2013-03-29','10:20:00',5.4),('7643','2013-03-29','10:25:00',5.24),('7643','2013-03-29','10:30:00',6.08),('7643','2013-03-29','10:35:00',7.38),('7643','2013-03-29','10:40:00',9.68),('7643','2013-03-29','10:45:00',11.78),('7643','2013-03-29','10:50:00',12.6),('7643','2013-03-29','10:55:00',8.48),('7643','2013-03-29','11:00:00',11.46),('7643','2013-03-29','11:05:00',14.04),('7643','2013-03-29','11:10:00',17.65),('7643','2013-03-29','11:15:00',10.3),('7643','2013-03-29','11:20:00',18.82),('7643','2013-03-29','11:25:00',18.02),('7643','2013-03-29','11:30:00',9.68),('7643','2013-03-29','11:35:00',11.78),('7643','2013-03-29','11:40:00',8.59),('7643','2013-03-29','11:45:00',13.43),('7643','2013-03-29','11:50:00',15.04),('7643','2013-03-29','11:55:00',13.74),('7643','2013-03-29','12:00:00',17.21),('7643','2013-03-29','12:05:00',9.77),('7643','2013-03-29','12:10:00',7.43),('7643','2013-03-29','12:15:00',7.48),('7643','2013-03-29','12:20:00',7.22),('7643','2013-03-29','12:25:00',4.17),('7643','2013-03-29','12:30:00',4.51),('7643','2013-03-29','12:35:00',3.71),('7643','2013-03-29','12:40:00',2.2),('7643','2013-03-29','12:45:00',3.41),('7643','2013-03-29','12:50:00',3.29),('7643','2013-03-29','12:55:00',1.34),('7643','2013-03-29','13:00:00',1.06),('7643','2013-03-29','13:05:00',2.29),('7643','2013-03-29','13:10:00',3.8),('7643','2013-03-29','13:15:00',10.57),('7643','2013-03-29','13:20:00',8.81),('7643','2013-03-29','13:25:00',5.25),('7643','2013-03-29','13:30:00',2.93),('7643','2013-03-29','13:35:00',2.4),('7643','2013-03-29','13:40:00',2.49),('7643','2013-03-29','13:45:00',4.4),('7643','2013-03-29','13:50:00',10.26),('7643','2013-03-29','13:55:00',12.95),('7643','2013-03-29','14:00:00',7.58),('7643','2013-03-29','14:05:00',8.42),('7643','2013-03-29','14:10:00',4.21),('7643','2013-03-29','14:15:00',6.1),('7643','2013-03-29','14:20:00',6.93),('7643','2013-03-29','14:25:00',5.3),('7643','2013-03-29','14:30:00',5.65),('7643','2013-03-29','14:35:00',5.97),('7643','2013-03-29','14:40:00',4.22),('7643','2013-03-29','14:45:00',4.44),('7643','2013-03-29','14:50:00',5.93),('7643','2013-03-29','14:55:00',3.73),('7643','2013-03-29','15:00:00',3.08),('7643','2013-03-29','15:05:00',2.47),('7643','2013-03-29','15:10:00',2.33),('7643','2013-03-29','15:15:00',2.63),('7643','2013-03-29','15:20:00',3.57),('7643','2013-03-29','15:25:00',3.43),('7643','2013-03-29','15:30:00',2.65),('7643','2013-03-29','15:35:00',2.33),('7643','2013-03-29','15:40:00',3.05),('7643','2013-03-29','15:45:00',2.72),('7643','2013-03-29','15:50:00',2.72),('7643','2013-03-29','15:55:00',2.29),('7643','2013-03-29','16:00:00',1.46),('7643','2013-03-29','16:05:00',1.31),('7643','2013-03-29','16:15:00',1.01),('7643','2013-03-29','16:20:00',1.46),('7643','2013-03-29','16:25:00',1.34),('7643','2013-03-29','16:30:00',1.2),('7643','2013-03-29','16:45:00',1.03),('7643','2013-03-29','16:50:00',1.55),('7643','2013-03-29','16:55:00',1.12),('7643','2013-03-28','06:35:00',1.17),('7643','2013-03-28','06:45:00',1.28),('7643','2013-03-28','06:50:00',2.04),('7643','2013-03-28','06:55:00',1.93),('7643','2013-03-28','07:00:00',2.52),('7643','2013-03-28','07:05:00',2.82),('7643','2013-03-28','07:10:00',3.24),('7643','2013-03-28','07:15:00',3.55),('7643','2013-03-28','07:20:00',3.95),('7643','2013-03-28','07:25:00',4.5),('7643','2013-03-28','07:30:00',4.91),('7643','2013-03-28','07:35:00',4.62),('7643','2013-03-28','07:40:00',5.66),('7643','2013-03-28','07:45:00',6),('7643','2013-03-28','07:50:00',6.54),('7643','2013-03-28','07:55:00',4.15),('7643','2013-03-28','08:00:00',5.53),('7643','2013-03-28','08:05:00',6.77),('7643','2013-03-28','08:10:00',8.33),('7643','2013-03-28','08:16:00',8.23),('7643','2013-03-28','08:20:00',8.59),('7643','2013-03-28','08:25:00',8.92),('7643','2013-03-28','08:30:00',9.21),('7643','2013-03-28','08:35:00',9.53),('7643','2013-03-28','08:40:00',9.68),('7643','2013-03-28','08:45:00',9.44),('7643','2013-03-28','08:50:00',9.63),('7643','2013-03-28','08:55:00',9.4),('7643','2013-03-28','09:00:00',9.38),('7643','2013-03-28','09:05:00',10.4),('7643','2013-03-28','09:10:00',10.81),('7643','2013-03-28','09:15:00',11.9),('7643','2013-03-28','09:20:00',12.57),('7643','2013-03-28','09:25:00',11.75),('7643','2013-03-28','09:30:00',13.18),('7643','2013-03-28','09:35:00',13.17),('7643','2013-03-28','09:40:00',13.14),('7643','2013-03-28','09:45:00',12.05),('7643','2013-03-28','09:50:00',12.39),('7643','2013-03-28','09:55:00',13.06),('7643','2013-03-28','10:00:00',13.29),('7643','2013-03-28','10:05:00',12.36),('7643','2013-03-28','10:10:00',10.78),('7643','2013-03-28','10:15:00',13.36),('7643','2013-03-28','10:20:00',12.37),('7643','2013-03-28','10:25:00',11.79),('7643','2013-03-28','10:30:00',12.02),('7643','2013-03-28','10:35:00',12.97),('7643','2013-03-28','10:40:00',11.04),('7643','2013-03-28','10:45:00',11.6),('7643','2013-03-28','10:50:00',13.88),('7643','2013-03-28','10:55:00',14.04),('7643','2013-03-28','11:00:00',15.83),('7643','2013-03-28','11:05:00',15.34),('7643','2013-03-28','11:10:00',16.9),('7643','2013-03-28','11:15:00',17),('7643','2013-03-28','11:20:00',9.63),('7643','2013-03-28','11:25:00',13.56),('7643','2013-03-28','11:30:00',15),('7643','2013-03-28','11:35:00',14.2),('7643','2013-03-28','11:40:00',16.52),('7643','2013-03-28','11:45:00',16.55),('7643','2013-03-28','11:50:00',16.58),('7643','2013-03-28','11:55:00',16.61),('7643','2013-03-28','12:00:00',16.6),('7643','2013-03-28','12:05:00',16.96),('7643','2013-03-28','12:10:00',16.85),('7643','2013-03-28','12:15:00',15.53),('7643','2013-03-28','12:20:00',16.53),('7643','2013-03-28','12:25:00',16.16),('7643','2013-03-28','12:30:00',15.02),('7643','2013-03-28','12:35:00',15.84),('7643','2013-03-28','12:40:00',16.12),('7643','2013-03-28','12:45:00',12.97),('7643','2013-03-28','12:50:00',12.57),('7643','2013-03-28','12:55:00',14.2),('7643','2013-03-28','13:00:00',11.01),('7643','2013-03-28','13:05:00',10.65),('7643','2013-03-28','13:10:00',15.43),('7643','2013-03-28','13:15:00',13.22),('7643','2013-03-28','13:20:00',13.42),('7643','2013-03-28','13:25:00',16),('7643','2013-03-28','13:30:00',14.62),('7643','2013-03-28','13:35:00',12.9),('7643','2013-03-28','13:40:00',12.84),('7643','2013-03-28','13:45:00',13.15),('7643','2013-03-28','13:50:00',12.7),('7643','2013-03-28','13:55:00',13.21),('7643','2013-03-28','14:00:00',13.16),('7643','2013-03-28','14:05:00',11.19),('7643','2013-03-28','14:10:00',8.57),('7643','2013-03-28','14:15:00',9.2),('7643','2013-03-28','14:20:00',9.32),('7643','2013-03-28','14:25:00',9.55),('7643','2013-03-28','14:30:00',8.06),('7643','2013-03-28','14:35:00',7.97),('7643','2013-03-28','14:40:00',7.53),('7643','2013-03-28','14:45:00',7.01),('7643','2013-03-28','14:50:00',6.68),('7643','2013-03-28','14:55:00',6.5),('7643','2013-03-28','15:00:00',5.76),('7643','2013-03-28','15:05:00',5.81),('7643','2013-03-28','15:10:00',5.53),('7643','2013-03-28','15:15:00',5.38),('7643','2013-03-28','15:20:00',5.1),('7643','2013-03-28','15:25:00',4.58),('7643','2013-03-28','15:30:00',4.22),('7643','2013-03-28','15:35:00',4.05),('7643','2013-03-28','15:40:00',3.87),('7643','2013-03-28','15:45:00',3.74),('7643','2013-03-28','15:50:00',3.98),('7643','2013-03-28','15:55:00',4.65),('7643','2013-03-28','16:00:00',6.17),('7643','2013-03-28','16:05:00',5.72),('7643','2013-03-28','16:10:00',4.27),('7643','2013-03-28','16:15:00',3.66),('7643','2013-03-28','16:20:00',3.34),('7643','2013-03-28','16:25:00',3.62),('7643','2013-03-28','16:30:00',4.11),('7643','2013-03-28','16:35:00',3.95),('7643','2013-03-28','16:40:00',7.41),('7643','2013-03-28','16:45:00',6.1),('7643','2013-03-28','16:50:00',4.49),('7643','2013-03-28','16:55:00',3.51),('7643','2013-03-28','17:00:00',3.97),('7643','2013-03-28','17:05:00',3.09),('7643','2013-03-28','17:10:00',2),('7643','2013-03-28','17:15:00',1.99),('7643','2013-03-28','17:20:00',3.03),('7643','2013-03-28','17:25:00',3.01),('7643','2013-03-28','17:30:00',2.61),('7643','2013-03-28','17:35:00',2.04),('7643','2013-03-28','17:40:00',1.32),('7643','2013-03-27','07:25:00',1.17),('7643','2013-03-27','07:30:00',1.95),('7643','2013-03-27','07:35:00',1.82),('7643','2013-03-27','07:40:00',2.11),('7643','2013-03-27','07:45:00',2.04),('7643','2013-03-27','07:50:00',1.32),('7643','2013-03-27','08:25:00',1),('7643','2013-03-27','08:30:00',1.01),('7643','2013-03-27','08:35:00',1.31),('7643','2013-03-27','08:40:00',1.85),('7643','2013-03-27','08:45:00',1.98),('7643','2013-03-27','08:50:00',2.19),('7643','2013-03-27','08:55:00',2.67),('7643','2013-03-27','09:00:00',2.79),('7643','2013-03-27','09:05:00',3.97),('7643','2013-03-27','09:10:00',7.95),('7643','2013-03-27','09:15:00',12.38),('7643','2013-03-27','09:20:00',5.88),('7643','2013-03-27','09:25:00',5.7),('7643','2013-03-27','09:30:00',4),('7643','2013-03-27','09:35:00',3.52),('7643','2013-03-27','09:40:00',3.07),('7643','2013-03-27','09:45:00',3.61),('7643','2013-03-27','09:50:00',3.66),('7643','2013-03-27','09:55:00',4.04),('7643','2013-03-27','10:00:00',4.34),('7643','2013-03-27','10:05:00',3.21),('7643','2013-03-27','10:10:00',2.31),('7643','2013-03-27','10:15:00',2.35),('7643','2013-03-27','10:20:00',1.94),('7643','2013-03-27','10:25:00',2.08),('7643','2013-03-27','10:30:00',2.19),('7643','2013-03-27','10:35:00',2.05),('7643','2013-03-27','10:40:00',1.99),('7643','2013-03-27','10:45:00',1.82),('7643','2013-03-27','10:50:00',1.91),('7643','2013-03-27','10:55:00',3.08),('7643','2013-03-27','11:00:00',4.2),('7643','2013-03-27','11:05:00',2.89),('7643','2013-03-27','11:10:00',2.06),('7643','2013-03-27','11:15:00',1.82),('7643','2013-03-27','11:20:00',2.09),('7643','2013-03-27','11:25:00',2.68),('7643','2013-03-27','11:30:00',3.62),('7643','2013-03-27','11:35:00',5.75),('7643','2013-03-27','11:40:00',7.09),('7643','2013-03-27','11:45:00',4.9),('7643','2013-03-27','11:50:00',5.4),('7643','2013-03-27','11:55:00',8.67),('7643','2013-03-27','12:00:00',6.57),('7643','2013-03-27','12:05:00',4.71),('7643','2013-03-27','12:10:00',4.49),('7643','2013-03-27','12:15:00',5.04),('7643','2013-03-27','12:20:00',4.87),('7643','2013-03-27','12:25:00',4.23),('7643','2013-03-27','12:30:00',3.8),('7643','2013-03-27','12:35:00',3.44),('7643','2013-03-27','12:40:00',4.64),('7643','2013-03-27','12:45:00',6.26),('7643','2013-03-27','12:50:00',12.11),('7643','2013-03-27','12:55:00',13.53),('7643','2013-03-27','13:00:00',12.44),('7643','2013-03-27','13:05:00',12.05),('7643','2013-03-27','13:10:00',15.46),('7643','2013-03-27','13:15:00',13.43),('7643','2013-03-27','13:20:00',11.69),('7643','2013-03-27','13:25:00',14.87),('7643','2013-03-27','13:30:00',11.51),('7643','2013-03-27','13:35:00',9.84),('7643','2013-03-27','13:40:00',8.97),('7643','2013-03-27','13:45:00',8.35),('7643','2013-03-27','13:50:00',10.37),('7643','2013-03-27','13:55:00',7.08),('7643','2013-03-27','14:00:00',6.8),('7643','2013-03-27','14:05:00',9),('7643','2013-03-27','14:10:00',6.2),('7643','2013-03-27','14:15:00',5.97),('7643','2013-03-27','14:20:00',5.76),('7643','2013-03-27','14:25:00',6.5),('7643','2013-03-27','14:30:00',7.29),('7643','2013-03-27','14:35:00',6.43),('7643','2013-03-27','14:40:00',4.94),('7643','2013-03-27','14:45:00',4.81),('7643','2013-03-27','14:50:00',4.06),('7643','2013-03-27','14:55:00',3.45),('7643','2013-03-27','15:00:00',4.39),('7643','2013-03-27','15:05:00',5.09),('7643','2013-03-27','15:10:00',7.87),('7643','2013-03-27','15:15:00',7.3),('7643','2013-03-27','15:20:00',9.03),('7643','2013-03-27','15:25:00',6.62),('7643','2013-03-27','15:30:00',5.58),('7643','2013-03-27','15:35:00',9.47),('7643','2013-03-27','15:40:00',6.68),('7643','2013-03-27','15:45:00',7.08),('7643','2013-03-27','15:50:00',4.94),('7643','2013-03-27','15:55:00',9.56),('7643','2013-03-27','16:00:00',5.03),('7643','2013-03-27','16:05:00',3.28),('7643','2013-03-27','16:10:00',7.78),('7643','2013-03-27','16:15:00',2.55),('7643','2013-03-27','16:20:00',1.82),('7643','2013-03-27','16:25:00',2.5),('7643','2013-03-27','16:30:00',3.35),('7643','2013-03-27','16:35:00',6.02),('7643','2013-03-27','16:40:00',3.54),('7643','2013-03-27','16:45:00',4.17),('7643','2013-03-27','16:50:00',2.27),('7643','2013-03-27','16:55:00',2.52),('7643','2013-03-27','17:00:00',5.32),('7643','2013-03-27','17:05:00',4.54),('7643','2013-03-27','17:10:00',3.61),('7643','2013-03-27','17:15:00',3.05),('7643','2013-03-27','17:20:00',2.45),('7643','2013-03-27','17:25:00',1.9),('7643','2013-03-27','17:30:00',1.28),('7643','2013-03-26','06:35:00',1.02),('7643','2013-03-26','06:40:00',1.23),('7643','2013-03-26','06:45:00',1.47),('7643','2013-03-26','06:50:00',1.77),('7643','2013-03-26','06:55:00',2.02),('7643','2013-03-26','07:00:00',2.31),('7643','2013-03-26','07:05:00',2.6),('7643','2013-03-26','07:10:00',2.99),('7643','2013-03-26','07:15:00',3.39),('7643','2013-03-26','07:20:00',3.76),('7643','2013-03-26','07:25:00',4.19),('7643','2013-03-26','07:30:00',4.59),('7643','2013-03-26','07:35:00',4.74),('7643','2013-03-26','07:40:00',5),('7643','2013-03-26','07:45:00',3.33),('7643','2013-03-26','07:50:00',2.4),('7643','2013-03-26','07:55:00',4.53),('7643','2013-03-26','08:00:00',5.07),('7643','2013-03-26','08:05:00',5.8),('7643','2013-03-26','08:10:00',5.17),('7643','2013-03-26','08:15:00',5.61),('7643','2013-03-26','08:20:00',5.03),('7643','2013-03-26','08:25:00',5.81),('7643','2013-03-26','08:30:00',8.31),('7643','2013-03-26','08:35:00',6.48),('7643','2013-03-26','08:40:00',5.09),('7643','2013-03-26','08:45:00',4.44),('7643','2013-03-26','08:50:00',5.06),('7643','2013-03-26','08:55:00',7.06),('7643','2013-03-26','09:00:00',5.12),('7643','2013-03-26','09:05:00',4.56),('7643','2013-03-26','09:10:00',3.6),('7643','2013-03-26','09:15:00',7.15),('7643','2013-03-26','09:20:00',8.83),('7643','2013-03-26','09:25:00',5.9),('7643','2013-03-26','09:30:00',4.21),('7643','2013-03-26','09:35:00',3.58),('7643','2013-03-26','09:40:00',3.91),('7643','2013-03-26','09:45:00',7.35),('7643','2013-03-26','09:50:00',9.68),('7643','2013-03-26','09:55:00',5.88),('7643','2013-03-26','10:00:00',7.17),('7643','2013-03-26','10:05:00',4.33),('7643','2013-03-26','10:10:00',6.11),('7643','2013-03-26','10:15:00',6.95),('7643','2013-03-26','10:20:00',6.16),('7643','2013-03-26','10:25:00',7.2),('7643','2013-03-26','10:30:00',8.67),('7643','2013-03-26','10:35:00',5.92),('7643','2013-03-26','10:40:00',7.07),('7643','2013-03-26','10:45:00',8.08),('7643','2013-03-26','10:50:00',7.19),('7643','2013-03-26','10:55:00',7.36),('7643','2013-03-26','11:00:00',5.79),('7643','2013-03-26','11:05:00',6.12),('7643','2013-03-26','11:10:00',6.63),('7643','2013-03-26','11:15:00',6.91),('7643','2013-03-26','11:20:00',7.15),('7643','2013-03-26','11:25:00',6.72),('7643','2013-03-26','11:30:00',7.53),('7643','2013-03-26','11:35:00',7.09),('7643','2013-03-26','11:40:00',6.78),('7643','2013-03-26','11:45:00',6.74),('7643','2013-03-26','11:50:00',6.47),('7643','2013-03-26','11:55:00',9.9),('7643','2013-03-26','12:00:00',11.98),('7643','2013-03-26','12:05:00',11.59),('7643','2013-03-26','12:10:00',10.35),('7643','2013-03-26','12:15:00',7.13),('7643','2013-03-26','12:20:00',7.89),('7643','2013-03-26','12:25:00',6.39),('7643','2013-03-26','12:30:00',13.28),('7643','2013-03-26','12:35:00',18.18),('7643','2013-03-26','12:40:00',18.3),('7643','2013-03-26','12:45:00',17.3),('7643','2013-03-26','12:50:00',12.49),('7643','2013-03-26','12:55:00',9.81),('7643','2013-03-26','13:00:00',5.72),('7643','2013-03-26','13:05:00',9.62),('7643','2013-03-26','13:10:00',11.6),('7643','2013-03-26','13:15:00',7.07),('7643','2013-03-26','13:20:00',5.45),('7643','2013-03-26','13:25:00',5.27),('7643','2013-03-26','13:30:00',9.32),('7643','2013-03-26','13:35:00',9.23),('7643','2013-03-26','13:40:00',7.26),('7643','2013-03-26','13:45:00',9.11),('7643','2013-03-26','13:50:00',10.64),('7643','2013-03-26','13:55:00',9.47),('7643','2013-03-26','14:00:00',7.37),('7643','2013-03-26','14:05:00',5.86),('7643','2013-03-26','14:10:00',6.18),('7643','2013-03-26','14:15:00',6.98),('7643','2013-03-26','14:20:00',8.18),('7643','2013-03-26','14:25:00',7.1),('7643','2013-03-26','14:30:00',5.67),('7643','2013-03-26','14:35:00',6.15),('7643','2013-03-26','14:40:00',9.27),('7643','2013-03-26','14:45:00',9.14),('7643','2013-03-26','14:50:00',6.03),('7643','2013-03-26','14:55:00',4.95),('7643','2013-03-26','15:00:00',3.98),('7643','2013-03-26','15:05:00',4.71),('7643','2013-03-26','15:10:00',5.64),('7643','2013-03-26','15:15:00',3.98),('7643','2013-03-26','15:20:00',3.86),('7643','2013-03-26','15:25:00',3.87),('7643','2013-03-26','15:30:00',2.85),('7643','2013-03-26','15:35:00',2.54),('7643','2013-03-26','15:40:00',1.95),('7643','2013-03-26','15:45:00',1.25),('7643','2013-03-26','15:50:00',1.77),('7643','2013-03-26','15:55:00',2.12),('7643','2013-03-26','16:00:00',2.21),('7643','2013-03-26','16:05:00',2.39),('7643','2013-03-26','16:10:00',2.76),('7643','2013-03-26','16:15:00',2.8),('7643','2013-03-26','16:20:00',2.66),('7643','2013-03-26','16:25:00',2.84),('7643','2013-03-26','16:30:00',2.89),('7643','2013-03-26','16:35:00',2.91),('7643','2013-03-26','16:40:00',3.45),('7643','2013-03-26','16:45:00',4.37),('7643','2013-03-26','16:50:00',3.71),('7643','2013-03-26','16:55:00',4.44),('7643','2013-03-26','17:00:00',4.37),('7643','2013-03-26','17:05:00',5.18),('7643','2013-03-26','17:10:00',4.51),('7643','2013-03-26','17:15:00',2.8),('7643','2013-03-25','06:50:00',1.05),('7643','2013-03-25','06:55:00',1.24),('7643','2013-03-25','07:00:00',1.32),('7643','2013-03-25','07:05:00',1.49),('7643','2013-03-25','07:10:00',1.78),('7643','2013-03-25','07:15:00',2.03),('7643','2013-03-25','07:20:00',2.07),('7643','2013-03-25','07:30:00',1.01),('7643','2013-03-25','07:35:00',2.04),('7643','2013-03-25','07:40:00',2.63),('7643','2013-03-25','07:45:00',4.03),('7643','2013-03-25','07:50:00',7.18),('7643','2013-03-25','07:55:00',7.22),('7643','2013-03-25','08:00:00',2.46),('7643','2013-03-25','08:05:00',2.04),('7643','2013-03-25','08:10:00',2.51),('7643','2013-03-25','08:15:00',2.43),('7643','2013-03-25','08:20:00',2.24),('7643','2013-03-25','08:25:00',2.36),('7643','2013-03-25','08:30:00',3.19),('7643','2013-03-25','08:35:00',5.08),('7643','2013-03-25','08:40:00',5.73),('7643','2013-03-25','08:45:00',3.37),('7643','2013-03-25','08:50:00',2.12),('7643','2013-03-25','08:55:00',2.06),('7643','2013-03-25','09:00:00',1.92),('7643','2013-03-25','09:05:00',2.46),('7643','2013-03-25','09:10:00',3.8),('7643','2013-03-25','09:15:00',6.11),('7643','2013-03-25','09:20:00',4.08),('7643','2013-03-25','09:25:00',2.24),('7643','2013-03-25','09:30:00',1.76),('7643','2013-03-25','09:35:00',1.69),('7643','2013-03-25','09:40:00',1.87),('7643','2013-03-25','09:45:00',1.69),('7643','2013-03-25','09:50:00',2.7),('7643','2013-03-25','09:55:00',7.99),('7643','2013-03-25','10:00:00',4.97),('7643','2013-03-25','10:05:00',2.34),('7643','2013-03-25','10:10:00',2.84),('7643','2013-03-25','10:15:00',2.06),('7643','2013-03-25','10:20:00',1.92),('7643','2013-03-25','10:25:00',2.7),('7643','2013-03-25','10:30:00',1.24),('7643','2013-03-25','10:35:00',1.72),('7643','2013-03-25','10:40:00',2.07),('7643','2013-03-25','10:45:00',2.14),('7643','2013-03-25','10:50:00',3.4),('7643','2013-03-25','10:55:00',3.13),('7643','2013-03-25','11:00:00',3.83),('7643','2013-03-25','11:05:00',4.01),('7643','2013-03-25','11:10:00',9.06),('7643','2013-03-25','11:15:00',8.86),('7643','2013-03-25','11:20:00',7.8),('7643','2013-03-25','11:25:00',4.17),('7643','2013-03-25','11:30:00',3.05),('7643','2013-03-25','11:35:00',1.73),('7643','2013-03-25','11:40:00',1.43),('7643','2013-03-25','11:45:00',3.46),('7643','2013-03-25','11:50:00',8.54),('7643','2013-03-25','11:55:00',4.26),('7643','2013-03-25','12:00:00',3.8),('7643','2013-03-25','12:05:00',4.41),('7643','2013-03-25','12:10:00',4.71),('7643','2013-03-25','12:15:00',5.22),('7643','2013-03-25','12:20:00',5.5),('7643','2013-03-25','12:25:00',7.75),('7643','2013-03-25','12:30:00',7.02),('7643','2013-03-25','12:35:00',10.68),('7643','2013-03-25','12:40:00',8.44),('7643','2013-03-25','12:45:00',10.45),('7643','2013-03-25','12:50:00',7.41),('7643','2013-03-25','12:55:00',3.95),('7643','2013-03-25','13:00:00',6.35),('7643','2013-03-25','13:05:00',9.15),('7643','2013-03-25','13:10:00',9.04),('7643','2013-03-25','13:15:00',7.15),('7643','2013-03-25','13:20:00',5.02),('7643','2013-03-25','13:25:00',7.89),('7643','2013-03-25','13:30:00',6.82),('7643','2013-03-25','13:35:00',6.55),('7643','2013-03-25','13:40:00',7.91),('7643','2013-03-25','13:45:00',7.17),('7643','2013-03-25','13:50:00',6.27),('7643','2013-03-25','13:55:00',5.95),('7643','2013-03-25','14:00:00',5.72),('7643','2013-03-25','14:05:00',5.4),('7643','2013-03-25','14:10:00',5.47),('7643','2013-03-25','14:15:00',5.07),('7643','2013-03-25','14:20:00',4.46),('7643','2013-03-25','14:25:00',3.85),('7643','2013-03-25','14:30:00',3.26),('7643','2013-03-25','14:35:00',2.98),('7643','2013-03-25','14:40:00',3.18),('7643','2013-03-25','14:45:00',3.29),('7643','2013-03-25','14:50:00',2.98),('7643','2013-03-25','14:55:00',2.96),('7643','2013-03-25','15:00:00',2.92),('7643','2013-03-25','15:05:00',3.05),('7643','2013-03-25','15:10:00',2.99),('7643','2013-03-25','15:15:00',2.64),('7643','2013-03-25','15:20:00',2.88),('7643','2013-03-25','15:25:00',2.86),('7643','2013-03-25','15:30:00',3.11),('7643','2013-03-25','15:35:00',3.39),('7643','2013-03-25','15:40:00',3.02),('7643','2013-03-25','15:45:00',2.04),('7643','2013-03-25','15:50:00',2.03),('7643','2013-03-25','15:55:00',1.11),('7643','2013-03-25','16:15:00',1.13),('7643','2013-03-25','16:20:00',1.02),('7643','2013-03-24','08:10:00',2.01),('7643','2013-03-24','08:15:00',3.19),('7643','2013-03-24','08:20:00',6.55),('7643','2013-03-24','08:25:00',6.97),('7643','2013-03-24','08:30:00',6.11),('7643','2013-03-24','08:35:00',2.03),('7643','2013-03-24','08:40:00',2.42),('7643','2013-03-24','08:45:00',4.04),('7643','2013-03-24','08:50:00',3.34),('7643','2013-03-24','08:55:00',4.12),('7643','2013-03-24','09:00:00',4.17),('7643','2013-03-24','09:05:00',3.93),('7643','2013-03-24','09:10:00',3.97),('7643','2013-03-24','09:15:00',3.95),('7643','2013-03-24','09:20:00',9.25),('7643','2013-03-24','09:25:00',11.78),('7643','2013-03-24','09:30:00',5.1),('7643','2013-03-24','09:35:00',3.44),('7643','2013-03-24','09:40:00',2.45),('7643','2013-03-24','09:45:00',2.86),('7643','2013-03-24','09:50:00',13.15),('7643','2013-03-24','09:55:00',14.51),('7643','2013-03-24','10:00:00',14.97),('7643','2013-03-24','10:05:00',5.56),('7643','2013-03-24','10:10:00',3.27),('7643','2013-03-24','10:15:00',3.86),('7643','2013-03-24','10:20:00',6.06),('7643','2013-03-24','10:25:00',9.67),('7643','2013-03-24','10:30:00',8.8),('7643','2013-03-24','10:35:00',6.65),('7643','2013-03-24','10:40:00',7.16),('7643','2013-03-24','10:45:00',10.12),('7643','2013-03-24','10:50:00',9.9),('7643','2013-03-24','10:55:00',9.2),('7643','2013-03-24','11:00:00',8.7),('7643','2013-03-24','11:05:00',6.96),('7643','2013-03-24','11:10:00',8.27),('7643','2013-03-24','11:15:00',11.12),('7643','2013-03-24','11:20:00',16.58),('7643','2013-03-24','11:25:00',12),('7643','2013-03-24','11:30:00',9.44),('7643','2013-03-24','11:35:00',12.06),('7643','2013-03-24','11:40:00',6.1),('7643','2013-03-24','11:45:00',6.31),('7643','2013-03-24','11:50:00',8.16),('7643','2013-03-24','11:55:00',13.86),('7643','2013-03-24','12:00:00',14.83),('7643','2013-03-24','12:05:00',12.44),('7643','2013-03-24','12:10:00',19.6),('7643','2013-03-24','12:15:00',13.89),('7643','2013-03-24','12:20:00',9.72),('7643','2013-03-24','12:25:00',13.72),('7643','2013-03-24','12:30:00',16.28),('7643','2013-03-24','12:35:00',12.4),('7643','2013-03-24','12:40:00',9.9),('7643','2013-03-24','12:45:00',9.67),('7643','2013-03-24','12:50:00',11.74),('7643','2013-03-24','12:55:00',9.35),('7643','2013-03-24','13:00:00',9.19),('7643','2013-03-24','13:05:00',19.07),('7643','2013-03-24','13:10:00',15.23),('7643','2013-03-24','13:15:00',13.05),('7643','2013-03-24','13:20:00',13.83),('7643','2013-03-24','13:25:00',9.58),('7643','2013-03-24','13:30:00',12.03),('7643','2013-03-24','13:35:00',4.42),('7643','2013-03-24','13:40:00',4.44),('7643','2013-03-24','13:45:00',6.61),('7643','2013-03-24','13:50:00',8.29),('7643','2013-03-24','13:55:00',6.53),('7643','2013-03-24','14:00:00',3.98),('7643','2013-03-24','14:05:00',3.95),('7643','2013-03-24','14:10:00',8.9),('7643','2013-03-24','14:15:00',6.17),('7643','2013-03-24','14:20:00',9.46),('7643','2013-03-24','14:25:00',19.14),('7643','2013-03-24','14:30:00',11.01),('7643','2013-03-24','14:35:00',9.89),('7643','2013-03-24','14:40:00',6.58),('7643','2013-03-24','14:45:00',6.98),('7643','2013-03-24','14:50:00',6.13),('7643','2013-03-24','14:55:00',8.47),('7643','2013-03-24','15:00:00',7.96),('7643','2013-03-24','15:05:00',8.91),('7643','2013-03-24','15:10:00',12.26),('7643','2013-03-24','15:15:00',9.21),('7643','2013-03-24','15:20:00',6.93),('7643','2013-03-24','15:25:00',10.61),('7643','2013-03-24','15:30:00',9.11),('7643','2013-03-24','15:35:00',7.4),('7643','2013-03-24','15:40:00',12.25),('7643','2013-03-24','15:45:00',9.83),('7643','2013-03-24','15:50:00',7.03),('7643','2013-03-24','15:55:00',5.39),('7643','2013-03-24','16:00:00',10.59),('7643','2013-03-24','16:05:00',4.72),('7643','2013-03-24','16:10:00',3.55),('7643','2013-03-24','16:15:00',4.77),('7643','2013-03-24','16:20:00',2.92),('7643','2013-03-24','16:25:00',2.11),('7643','2013-03-24','16:30:00',4.15),('7643','2013-03-24','16:35:00',7.71),('7643','2013-03-24','16:40:00',6.3),('7643','2013-03-24','16:45:00',4.62),('7643','2013-03-24','16:50:00',2.79),('7643','2013-03-24','16:55:00',1.92),('7643','2013-03-24','17:00:00',1.43),('7643','2013-03-24','17:05:00',1.24),('7643','2013-03-24','17:10:00',1.23),('7643','2013-03-24','17:15:00',1.31),('7643','2013-03-24','17:20:00',1.17),('7643','2013-03-24','17:25:00',1.04),('7643','2013-03-23','06:50:00',1.11),('7643','2013-03-23','06:55:00',1.55),('7643','2013-03-23','07:00:00',1.62),('7643','2013-03-23','07:05:00',1.98),('7643','2013-03-23','07:10:00',2.34),('7643','2013-03-23','07:15:00',2.34),('7643','2013-03-23','07:20:00',3.14),('7643','2013-03-23','07:25:00',3.2),('7643','2013-03-23','07:30:00',3.17),('7643','2013-03-23','07:35:00',3.55),('7643','2013-03-23','07:40:00',3.76),('7643','2013-03-23','07:45:00',4.19),('7643','2013-03-23','07:50:00',4.83),('7643','2013-03-23','07:55:00',5.62),('7643','2013-03-23','08:00:00',6.55),('7643','2013-03-23','08:05:00',6.95),('7643','2013-03-23','08:10:00',7.12),('7643','2013-03-23','08:15:00',7.6),('7643','2013-03-23','08:20:00',7.95),('7643','2013-03-23','08:25:00',8.28),('7643','2013-03-23','08:30:00',8.55),('7643','2013-03-23','08:35:00',8.8),('7643','2013-03-23','08:40:00',9.04),('7643','2013-03-23','08:45:00',9.32),('7643','2013-03-23','08:50:00',9.44),('7643','2013-03-23','08:55:00',9.7),('7643','2013-03-23','09:00:00',9.95),('7643','2013-03-23','09:05:00',10.33),('7643','2013-03-23','09:10:00',10.56),('7643','2013-03-23','09:15:00',10.79),('7643','2013-03-23','09:20:00',10.99),('7643','2013-03-23','09:25:00',11.23),('7643','2013-03-23','09:30:00',11.45),('7643','2013-03-23','09:35:00',11.59),('7643','2013-03-23','09:40:00',11.79),('7643','2013-03-23','09:45:00',12.08),('7643','2013-03-23','09:50:00',12.28),('7643','2013-03-23','09:55:00',12.49),('7643','2013-03-23','10:00:00',12.45),('7643','2013-03-23','10:05:00',12.89),('7643','2013-03-23','10:10:00',13.12),('7643','2013-03-23','10:15:00',13.26),('7643','2013-03-23','10:20:00',13.4),('7643','2013-03-23','10:25:00',13.59),('7643','2013-03-23','10:30:00',13.8),('7643','2013-03-23','10:35:00',13.82),('7643','2013-03-23','10:40:00',13.83),('7643','2013-03-23','10:45:00',13.89),('7643','2013-03-23','10:50:00',13.94),('7643','2013-03-23','10:55:00',14.07),('7643','2013-03-23','11:00:00',14.15),('7643','2013-03-23','11:05:00',14.3),('7643','2013-03-23','11:10:00',14.39),('7643','2013-03-23','11:15:00',14.43),('7643','2013-03-23','11:20:00',14.44),('7643','2013-03-23','11:25:00',14.5),('7643','2013-03-23','11:30:00',14.57),('7643','2013-03-23','11:35:00',14.59),('7643','2013-03-23','11:40:00',14.65),('7643','2013-03-23','11:45:00',14.68),('7643','2013-03-23','11:50:00',14.69),('7643','2013-03-23','11:55:00',14.73),('7643','2013-03-23','12:00:00',14.86),('7643','2013-03-23','12:05:00',14.9),('7643','2013-03-23','12:10:00',15.17),('7643','2013-03-23','12:15:00',15.27),('7643','2013-03-23','12:20:00',15.55),('7643','2013-03-23','12:25:00',15.72),('7643','2013-03-23','12:30:00',15.68),('7643','2013-03-23','12:35:00',15.67),('7643','2013-03-23','12:40:00',15.47),('7643','2013-03-23','12:45:00',15.53),('7643','2013-03-23','12:50:00',15.53),('7643','2013-03-23','12:55:00',15.4),('7643','2013-03-23','13:00:00',15.3),('7643','2013-03-23','13:05:00',15.37),('7643','2013-03-23','13:10:00',15.27),('7643','2013-03-23','13:15:00',15.17),('7643','2013-03-23','13:20:00',15.11),('7643','2013-03-23','13:25:00',14.88),('7643','2013-03-23','13:30:00',14.75),('7643','2013-03-23','13:35:00',14.64),('7643','2013-03-23','13:40:00',14.55),('7643','2013-03-23','13:45:00',14.38),('7643','2013-03-23','13:50:00',14.23),('7643','2013-03-23','13:55:00',14.09),('7643','2013-03-23','14:00:00',13.88),('7643','2013-03-23','14:05:00',13.63),('7643','2013-03-23','14:10:00',13.34),('7643','2013-03-23','14:15:00',13.22),('7643','2013-03-23','14:20:00',13.01),('7643','2013-03-23','14:25:00',12.74),('7643','2013-03-23','14:30:00',12.34),('7643','2013-03-23','14:35:00',11.91),('7643','2013-03-23','14:40:00',11.79),('7643','2013-03-23','14:45:00',11.62),('7643','2013-03-23','14:50:00',11.07),('7643','2013-03-23','14:55:00',10.96),('7643','2013-03-23','15:00:00',10.67),('7643','2013-03-23','15:05:00',10.44),('7643','2013-03-23','15:10:00',9.9),('7643','2013-03-23','15:15:00',10.63),('7643','2013-03-23','15:20:00',10.16),('7643','2013-03-23','15:25:00',9.57),('7643','2013-03-23','15:30:00',8.6),('7643','2013-03-23','15:35:00',8.6),('7643','2013-03-23','15:40:00',8.53),('7643','2013-03-23','15:45:00',6.91),('7643','2013-03-23','15:50:00',5.24),('7643','2013-03-23','15:55:00',4.79),('7643','2013-03-23','16:00:00',4.62),('7643','2013-03-23','16:05:00',5.4),('7643','2013-03-23','16:10:00',3.88),('7643','2013-03-23','16:15:00',5.23),('7643','2013-03-23','16:20:00',4.1),('7643','2013-03-23','16:25:00',3.94),('7643','2013-03-23','16:30:00',4.33),('7643','2013-03-23','16:35:00',3.89),('7643','2013-03-23','16:40:00',3.06),('7643','2013-03-23','16:45:00',2.95),('7643','2013-03-23','16:50:00',2.39),('7643','2013-03-23','16:55:00',1.85),('7643','2013-03-23','17:00:00',1.82),('7643','2013-03-23','17:05:00',1.55),('7643','2013-03-23','17:10:00',1.4),('7643','2013-03-23','17:15:00',1.04),('7643','2013-03-22','06:45:00',1.16),('7643','2013-03-22','06:50:00',1.5),('7643','2013-03-22','06:55:00',1.79),('7643','2013-03-22','07:00:00',2.13),('7643','2013-03-22','07:05:00',2.43),('7643','2013-03-22','07:10:00',2.87),('7643','2013-03-22','07:15:00',3.26),('7643','2013-03-22','07:20:00',3.51),('7643','2013-03-22','07:25:00',3.67),('7643','2013-03-22','07:30:00',3.9),('7643','2013-03-22','07:35:00',4.09),('7643','2013-03-22','07:40:00',4.67),('7643','2013-03-22','07:45:00',4.73),('7643','2013-03-22','07:50:00',5.19),('7643','2013-03-22','07:55:00',5.89),('7643','2013-03-22','08:00:00',6.5),('7643','2013-03-22','08:05:00',7.1),('7643','2013-03-22','08:10:00',7.39),('7643','2013-03-22','08:15:00',7.73),('7643','2013-03-22','08:20:00',8.01),('7643','2013-03-22','08:25:00',8.29),('7643','2013-03-22','08:30:00',8.4),('7643','2013-03-22','08:35:00',8.75),('7643','2013-03-22','08:40:00',9.15),('7643','2013-03-22','08:45:00',9.47),('7643','2013-03-22','08:50:00',9.64),('7643','2013-03-22','08:55:00',10.18),('7643','2013-03-22','09:00:00',10.47),('7643','2013-03-22','09:05:00',10.88),('7643','2013-03-22','09:10:00',10.92),('7643','2013-03-22','09:15:00',11.19),('7643','2013-03-22','09:20:00',11.47),('7643','2013-03-22','09:25:00',11.75),('7643','2013-03-22','09:30:00',12.05),('7643','2013-03-22','09:35:00',12.2),('7643','2013-03-22','09:40:00',11.63),('7643','2013-03-22','09:45:00',12.45),('7643','2013-03-22','09:50:00',12.41),('7643','2013-03-22','09:55:00',12.53),('7643','2013-03-22','10:00:00',12.71),('7643','2013-03-22','10:05:00',13.26),('7643','2013-03-22','10:10:00',13.53),('7643','2013-03-22','10:15:00',13.46),('7643','2013-03-22','10:20:00',13.21),('7643','2013-03-22','10:25:00',13.47),('7643','2013-03-22','10:30:00',14.02),('7643','2013-03-22','10:35:00',14.43),('7643','2013-03-22','10:40:00',14.23),('7643','2013-03-22','10:45:00',14.08),('7643','2013-03-22','10:50:00',14.05),('7643','2013-03-22','10:55:00',13.65),('7643','2013-03-22','11:00:00',13.35),('7643','2013-03-22','11:05:00',13.12),('7643','2013-03-22','11:10:00',11.01),('7643','2013-03-22','11:15:00',12.2),('7643','2013-03-22','11:20:00',13.52),('7643','2013-03-22','11:25:00',14.1),('7643','2013-03-22','11:30:00',14),('7643','2013-03-22','11:35:00',14.77),('7643','2013-03-22','11:40:00',14.91),('7643','2013-03-22','11:45:00',14.69),('7643','2013-03-22','11:50:00',14.4),('7643','2013-03-22','11:55:00',14.96),('7643','2013-03-22','12:00:00',15.02),('7643','2013-03-22','12:05:00',14.97),('7643','2013-03-22','12:10:00',15.03),('7643','2013-03-22','12:15:00',15.19),('7643','2013-03-22','12:20:00',15.4),('7643','2013-03-22','12:25:00',15.08),('7643','2013-03-22','12:30:00',15.45),('7643','2013-03-22','12:35:00',15.46),('7643','2013-03-22','12:40:00',14.89),('7643','2013-03-22','12:45:00',14.93),('7643','2013-03-22','12:50:00',15.28),('7643','2013-03-22','12:55:00',15.05),('7643','2013-03-22','13:00:00',11.98),('7643','2013-03-22','13:05:00',15.19),('7643','2013-03-22','13:10:00',14.9),('7643','2013-03-22','13:15:00',14.36),('7643','2013-03-22','13:20:00',14.42),('7643','2013-03-22','13:25:00',14.5),('7643','2013-03-22','13:30:00',13.73),('7643','2013-03-22','13:35:00',12.47),('7643','2013-03-22','13:40:00',13.75),('7643','2013-03-22','13:45:00',13.84),('7643','2013-03-22','13:50:00',13.86),('7643','2013-03-22','13:55:00',13.65),('7643','2013-03-22','14:00:00',13.42),('7643','2013-03-22','14:05:00',13.59),('7643','2013-03-22','14:10:00',13.07),('7643','2013-03-22','14:15:00',12.71),('7643','2013-03-22','14:20:00',13.06),('7643','2013-03-22','14:25:00',12.79),('7643','2013-03-22','14:30:00',12.83),('7643','2013-03-22','14:35:00',12.39),('7643','2013-03-22','14:40:00',12.01),('7643','2013-03-22','14:45:00',11.29),('7643','2013-03-22','14:50:00',11.15),('7643','2013-03-22','14:55:00',11.28),('7643','2013-03-22','15:00:00',10.8),('7643','2013-03-22','15:05:00',9.97),('7643','2013-03-22','15:10:00',10.5),('7643','2013-03-22','15:15:00',9.79),('7643','2013-03-22','15:20:00',9.77),('7643','2013-03-22','15:25:00',9.71),('7643','2013-03-22','15:30:00',8.87),('7643','2013-03-22','15:35:00',8.78),('7643','2013-03-22','15:40:00',8.26),('7643','2013-03-22','15:45:00',7.67),('7643','2013-03-22','15:50:00',7.23),('7643','2013-03-22','15:55:00',7.06),('7643','2013-03-22','16:00:00',6.6),('7643','2013-03-22','16:05:00',5.81),('7643','2013-03-22','16:10:00',7.39),('7643','2013-03-22','16:15:00',6.56),('7643','2013-03-22','16:20:00',5.67),('7643','2013-03-22','16:25:00',5.76),('7643','2013-03-22','16:30:00',4.31),('7643','2013-03-22','16:35:00',4.61),('7643','2013-03-22','16:40:00',4.06),('7643','2013-03-22','16:45:00',4.04),('7643','2013-03-22','16:50:00',3.34),('7643','2013-03-22','16:55:00',3.32),('7643','2013-03-22','17:00:00',3.79),('7643','2013-03-22','17:05:00',3.85),('7643','2013-03-22','17:10:00',3.24),('7643','2013-03-22','17:15:00',2.56),('7643','2013-03-22','17:20:00',2.18),('7643','2013-03-22','17:25:00',1.9),('7643','2013-03-22','17:30:00',1.54),('7643','2013-03-22','17:35:00',1.07),('7643','2014-03-25','06:40:00',1.17),('7643','2014-03-25','06:45:00',1.4),('7643','2014-03-25','06:50:00',1.42),('7643','2014-03-25','06:55:00',1.98),('7643','2014-03-25','07:00:00',2.39),('7643','2014-03-25','07:05:00',2.02),('7643','2014-03-25','07:10:00',3.13),('7643','2014-03-25','07:15:00',3.52),('7643','2014-03-25','07:20:00',3.85),('7643','2014-03-25','07:25:00',4.29),('7643','2014-03-25','07:30:00',4.75),('7643','2014-03-25','07:35:00',5.21),('7643','2014-03-25','07:40:00',5.61),('7643','2014-03-25','07:45:00',6.08),('7643','2014-03-25','07:50:00',6.42),('7643','2014-03-25','07:55:00',6.84),('7643','2014-03-25','08:00:00',7.27),('7643','2014-03-25','08:05:00',7.68),('7643','2014-03-25','08:10:00',8.19),('7643','2014-03-25','08:15:00',9.03),('7643','2014-03-25','08:20:00',8.29),('7643','2014-03-25','08:25:00',4.79),('7643','2014-03-25','08:30:00',4.25),('7643','2014-03-25','08:35:00',3.51),('7643','2014-03-25','08:40:00',4.11),('7643','2014-03-25','08:45:00',4.59),('7643','2014-03-25','08:50:00',5.51),('7643','2014-03-25','08:55:00',5.02),('7643','2014-03-25','09:00:00',5.5),('7643','2014-03-25','09:05:00',5.14),('7643','2014-03-25','09:10:00',6.21),('7643','2014-03-25','09:15:00',5.24),('7643','2014-03-25','09:20:00',4.66),('7643','2014-03-25','09:25:00',6.85),('7643','2014-03-25','09:30:00',13.67),('7643','2014-03-25','09:35:00',13.31),('7643','2014-03-25','09:40:00',13.39),('7643','2014-03-25','09:45:00',13.52),('7643','2014-03-25','09:50:00',13.8),('7643','2014-03-25','09:55:00',13.51),('7643','2014-03-25','10:00:00',8.69),('7643','2014-03-25','10:05:00',14.44),('7643','2014-03-25','10:10:00',15.8),('7643','2014-03-25','10:15:00',15.84),('7643','2014-03-25','10:20:00',16.27),('7643','2014-03-25','10:25:00',14.68),('7643','2014-03-25','10:30:00',14.57),('7643','2014-03-25','10:35:00',12.66),('7643','2014-03-25','10:40:00',4.52),('7643','2014-03-25','10:45:00',13.38),('7643','2014-03-25','10:50:00',13.22),('7643','2014-03-25','10:55:00',12.28),('7643','2014-03-25','11:00:00',15.12),('7643','2014-03-25','11:05:00',13.7),('7643','2014-03-25','11:10:00',18.31),('7643','2014-03-25','11:15:00',18.4),('7643','2014-03-25','11:20:00',9.55),('7643','2014-03-25','11:25:00',4.83),('7643','2014-03-25','11:30:00',6.25),('7643','2014-03-25','11:35:00',7.15),('7643','2014-03-25','11:40:00',7.09),('7643','2014-03-25','11:45:00',10.18),('7643','2014-03-25','11:50:00',11.84),('7643','2014-03-25','11:55:00',17.55),('7643','2014-03-25','12:00:00',19.04),('7643','2014-03-25','12:05:00',15.85),('7643','2014-03-25','12:10:00',11.31),('7643','2014-03-25','12:15:00',6.01),('7643','2014-03-25','12:20:00',7.08),('7643','2014-03-25','12:25:00',6.84),('7643','2014-03-25','12:30:00',6.78),('7643','2014-03-25','12:35:00',6.49),('7643','2014-03-25','12:40:00',7.35),('7643','2014-03-25','12:45:00',8.21),('7643','2014-03-25','12:50:00',5.81),('7643','2014-03-25','12:55:00',4.94),('7643','2014-03-25','13:00:00',4.68),('7643','2014-03-25','13:05:00',4.64),('7643','2014-03-25','13:10:00',3.69),('7643','2014-03-25','13:15:00',2.67),('7643','2014-03-25','13:20:00',4.59),('7643','2014-03-25','13:25:00',17.55),('7643','2014-03-25','13:30:00',14.88),('7643','2014-03-25','13:35:00',11.43),('7643','2014-03-25','13:40:00',8.33),('7643','2014-03-25','13:45:00',3.16),('7643','2014-03-25','13:50:00',2.96),('7643','2014-03-25','13:55:00',8.91),('7643','2014-03-25','14:00:00',11),('7643','2014-03-25','14:05:00',17.7),('7643','2014-03-25','14:10:00',13.24),('7643','2014-03-25','14:15:00',5.01),('7643','2014-03-25','14:20:00',3.86),('7643','2014-03-25','14:25:00',3.09),('7643','2014-03-25','14:30:00',2.71),('7643','2014-03-25','14:35:00',2.38),('7643','2014-03-25','14:40:00',2.59),('7643','2014-03-25','14:45:00',8.13),('7643','2014-03-25','14:50:00',12.74),('7643','2014-03-25','14:55:00',13.77),('7643','2014-03-25','15:00:00',11.41),('7643','2014-03-25','15:05:00',12.34),('7643','2014-03-25','15:10:00',12.88),('7643','2014-03-25','15:15:00',12.74),('7643','2014-03-25','15:20:00',11.62),('7643','2014-03-25','15:25:00',12.68),('7643','2014-03-25','15:30:00',12.63),('7643','2014-03-25','15:35:00',12.04),('7643','2014-03-25','15:40:00',9.11),('7643','2014-03-25','15:45:00',9.26),('7643','2014-03-25','15:50:00',7.6),('7643','2014-03-25','15:55:00',7.35),('7643','2014-03-25','16:00:00',4.79),('7643','2014-03-25','16:05:00',4.26),('7643','2014-03-25','16:10:00',4.29),('7643','2014-03-25','16:15:00',4.25),('7643','2014-03-25','16:20:00',3.85),('7643','2014-03-25','16:25:00',2.81),('7643','2014-03-25','16:30:00',2.27),('7643','2014-03-25','16:35:00',2.28),('7643','2014-03-25','16:40:00',1.76),('7643','2014-03-25','16:45:00',1.68),('7643','2014-03-25','16:50:00',1.75),('7643','2014-03-25','16:55:00',1.56),('7643','2014-03-25','17:00:00',1.24),('7643','2014-03-25','17:05:00',1.07),('7643','2013-03-21','06:45:00',1.01),('7643','2013-03-21','06:50:00',1.29),('7643','2013-03-21','06:55:00',1.59),('7643','2013-03-21','07:00:00',1.93),('7643','2013-03-21','07:05:00',2.24),('7643','2013-03-21','07:10:00',2.55),('7643','2013-03-21','07:15:00',2.93),('7643','2013-03-21','07:20:00',3.34),('7643','2013-03-21','07:25:00',3.72),('7643','2013-03-21','07:30:00',4.13),('7643','2013-03-21','07:35:00',4.56),('7643','2013-03-21','07:40:00',5),('7643','2013-03-21','07:45:00',5.38),('7643','2013-03-21','07:50:00',5.72),('7643','2013-03-21','07:55:00',6.07),('7643','2013-03-21','08:00:00',6.44),('7643','2013-03-21','08:05:00',6.83),('7643','2013-03-21','08:10:00',7.24),('7643','2013-03-21','08:15:00',7.59),('7643','2013-03-21','08:20:00',7.95),('7643','2013-03-21','08:25:00',8.25),('7643','2013-03-21','08:30:00',8.59),('7643','2013-03-21','08:35:00',8.87),('7643','2013-03-21','08:40:00',9.11),('7643','2013-03-21','08:45:00',9.41),('7643','2013-03-21','08:50:00',9.71),('7643','2013-03-21','08:55:00',9.98),('7643','2013-03-21','09:00:00',10.17),('7643','2013-03-21','09:05:00',10.41),('7643','2013-03-21','09:10:00',10.72),('7643','2013-03-21','09:15:00',11.09),('7643','2013-03-21','09:20:00',11.12),('7643','2013-03-21','09:25:00',11.44),('7643','2013-03-21','09:30:00',11.63),('7643','2013-03-21','09:35:00',11.88),('7643','2013-03-21','09:40:00',12.1),('7643','2013-03-21','09:45:00',12.29),('7643','2013-03-21','09:50:00',12.58),('7643','2013-03-21','09:55:00',12.61),('7643','2013-03-21','10:00:00',12.95),('7643','2013-03-21','10:05:00',13.19),('7643','2013-03-21','10:10:00',13.41),('7643','2013-03-21','10:15:00',13.5),('7643','2013-03-21','10:20:00',13.51),('7643','2013-03-21','10:25:00',13.93),('7643','2013-03-21','10:30:00',14.31),('7643','2013-03-21','10:35:00',14.49),('7643','2013-03-21','10:40:00',14.52),('7643','2013-03-21','10:45:00',14.63),('7643','2013-03-21','10:50:00',14.13),('7643','2013-03-21','10:55:00',14.83),('7643','2013-03-21','11:00:00',14.94),('7643','2013-03-21','11:05:00',14.92),('7643','2013-03-21','11:10:00',15.14),('7643','2013-03-21','11:15:00',15.38),('7643','2013-03-21','11:20:00',15.33),('7643','2013-03-21','11:25:00',15.47),('7643','2013-03-21','11:30:00',15.6),('7643','2013-03-21','11:35:00',15.65),('7643','2013-03-21','11:40:00',15.58),('7643','2013-03-21','11:45:00',15.93),('7643','2013-03-21','11:50:00',15.91),('7643','2013-03-21','11:55:00',15.94),('7643','2013-03-21','12:00:00',15.98),('7643','2013-03-21','12:05:00',16.04),('7643','2013-03-21','12:10:00',16.04),('7643','2013-03-21','12:15:00',16.02),('7643','2013-03-21','12:20:00',16),('7643','2013-03-21','12:25:00',16.13),('7643','2013-03-21','12:30:00',16.02),('7643','2013-03-21','12:35:00',16.02),('7643','2013-03-21','12:40:00',16.01),('7643','2013-03-21','12:45:00',15.82),('7643','2013-03-21','12:50:00',15.53),('7643','2013-03-21','12:55:00',14.98),('7643','2013-03-21','13:00:00',15.95),('7643','2013-03-21','13:05:00',15.36),('7643','2013-03-21','13:10:00',15.73),('7643','2013-03-21','13:15:00',15.65),('7643','2013-03-21','13:20:00',15.47),('7643','2013-03-21','13:25:00',14.6),('7643','2013-03-21','13:30:00',14.38),('7643','2013-03-21','13:35:00',14.88),('7643','2013-03-21','13:40:00',12.79),('7643','2013-03-21','13:45:00',12.94),('7643','2013-03-21','13:50:00',14.96),('7643','2013-03-21','13:55:00',14.63),('7643','2013-03-21','14:00:00',14.22),('7643','2013-03-21','14:05:00',14.03),('7643','2013-03-21','14:10:00',13.89),('7643','2013-03-21','14:15:00',13.6),('7643','2013-03-21','14:20:00',13.46),('7643','2013-03-21','14:25:00',13.25),('7643','2013-03-21','14:30:00',13.08),('7643','2013-03-21','14:35:00',12.78),('7643','2013-03-21','14:40:00',12.43),('7643','2013-03-21','14:45:00',12.29),('7643','2013-03-21','14:50:00',12.17),('7643','2013-03-21','14:55:00',11.92),('7643','2013-03-21','15:00:00',11.68),('7643','2013-03-21','15:05:00',11.34),('7643','2013-03-21','15:10:00',10.09),('7643','2013-03-21','15:15:00',8.39),('7643','2013-03-21','15:20:00',8.15),('7643','2013-03-21','15:25:00',8.5),('7643','2013-03-21','15:30:00',7.98),('7643','2013-03-21','15:35:00',8.86),('7643','2013-03-21','15:40:00',8.43),('7643','2013-03-21','15:45:00',7.49),('7643','2013-03-21','15:50:00',7.96),('7643','2013-03-21','15:55:00',7.17),('7643','2013-03-21','16:00:00',5.17),('7643','2013-03-21','16:05:00',5.24),('7643','2013-03-21','16:10:00',5.97),('7643','2013-03-21','16:15:00',7.08),('7643','2013-03-21','16:20:00',5.72),('7643','2013-03-21','16:25:00',5.76),('7643','2013-03-21','16:30:00',6.14),('7643','2013-03-21','16:35:00',6.11),('7643','2013-03-21','16:40:00',5.86),('7643','2013-03-21','16:45:00',5.45),('7643','2013-03-21','16:50:00',5.14),('7643','2013-03-21','16:55:00',4.68),('7643','2013-03-21','17:00:00',4.07),('7643','2013-03-21','17:05:00',3.62),('7643','2013-03-21','17:10:00',3.17),('7643','2013-03-21','17:15:00',2.83),('7643','2013-03-21','17:20:00',2.53),('7643','2013-03-21','17:25:00',1.69),('7643','2013-03-21','17:30:00',1.56),('7643','2013-03-21','17:35:00',1.28),('7643','2013-03-21','17:40:00',1.03),('7643','2013-03-20','07:05:00',1.01),('7643','2013-03-20','07:10:00',1.06),('7643','2013-03-20','07:15:00',1.69),('7643','2013-03-20','07:20:00',1.16),('7643','2013-03-20','07:25:00',1.99),('7643','2013-03-20','07:30:00',2.41),('7643','2013-03-20','07:35:00',3.15),('7643','2013-03-20','07:40:00',5.08),('7643','2013-03-20','07:45:00',5.66),('7643','2013-03-20','07:50:00',6.12),('7643','2013-03-20','07:55:00',3.4),('7643','2013-03-20','08:00:00',1.88),('7643','2013-03-20','08:05:00',1.7),('7643','2013-03-20','08:10:00',4.32),('7643','2013-03-20','08:15:00',7.31),('7643','2013-03-20','08:20:00',8.51),('7643','2013-03-20','08:25:00',8.98),('7643','2013-03-20','08:30:00',8.74),('7643','2013-03-20','08:35:00',9.22),('7643','2013-03-20','08:40:00',10.07),('7643','2013-03-20','08:45:00',10.07),('7643','2013-03-20','08:50:00',10.17),('7643','2013-03-20','08:55:00',10.14),('7643','2013-03-20','09:00:00',10.82),('7643','2013-03-20','09:05:00',11.52),('7643','2013-03-20','09:10:00',13),('7643','2013-03-20','09:15:00',12.52),('7643','2013-03-20','09:20:00',10.56),('7643','2013-03-20','09:25:00',11.52),('7643','2013-03-20','09:30:00',10.81),('7643','2013-03-20','09:35:00',12.86),('7643','2013-03-20','09:40:00',12.4),('7643','2013-03-20','09:45:00',13.17),('7643','2013-03-20','09:50:00',13.48),('7643','2013-03-20','09:55:00',13.69),('7643','2013-03-20','10:00:00',13.9),('7643','2013-03-20','10:05:00',13.97),('7643','2013-03-20','10:10:00',14.12),('7643','2013-03-20','10:15:00',14.25),('7643','2013-03-20','10:20:00',14.36),('7643','2013-03-20','10:25:00',14.44),('7643','2013-03-20','10:30:00',14.6),('7643','2013-03-20','10:35:00',14.79),('7643','2013-03-20','10:40:00',14.93),('7643','2013-03-20','10:45:00',14.89),('7643','2013-03-20','10:50:00',14.9),('7643','2013-03-20','10:55:00',9.21),('7643','2013-03-20','11:00:00',14.4),('7643','2013-03-20','11:05:00',15.63),('7643','2013-03-20','11:10:00',15.72),('7643','2013-03-20','11:15:00',15.93),('7643','2013-03-20','11:20:00',16.03),('7643','2013-03-20','11:25:00',16.3),('7643','2013-03-20','11:30:00',16.31),('7643','2013-03-20','11:35:00',16.37),('7643','2013-03-20','11:40:00',16.35),('7643','2013-03-20','11:45:00',16.45),('7643','2013-03-20','11:50:00',16.49),('7643','2013-03-20','11:55:00',16.59),('7643','2013-03-20','12:00:00',16.66),('7643','2013-03-20','12:05:00',16.7),('7643','2013-03-20','12:10:00',16.7),('7643','2013-03-20','12:15:00',16.66),('7643','2013-03-20','12:20:00',16.62),('7643','2013-03-20','12:25:00',16.73),('7643','2013-03-20','12:30:00',16.68),('7643','2013-03-20','12:35:00',16.49),('7643','2013-03-20','12:40:00',16.42),('7643','2013-03-20','12:45:00',16.26),('7643','2013-03-20','12:50:00',16.25),('7643','2013-03-20','12:55:00',16.22),('7643','2013-03-20','13:00:00',16.11),('7643','2013-03-20','13:05:00',15.98),('7643','2013-03-20','13:10:00',15.91),('7643','2013-03-20','13:15:00',15.8),('7643','2013-03-20','13:20:00',15.68),('7643','2013-03-20','13:25:00',15.58),('7643','2013-03-20','13:30:00',15.46),('7643','2013-03-20','13:35:00',15.3),('7643','2013-03-20','13:40:00',15.16),('7643','2013-03-20','13:45:00',14.96),('7643','2013-03-20','13:50:00',14.83),('7643','2013-03-20','13:55:00',14.58),('7643','2013-03-20','14:00:00',14.4),('7643','2013-03-20','14:05:00',14.06),('7643','2013-03-20','14:10:00',13.96),('7643','2013-03-20','14:15:00',13.77),('7643','2013-03-20','14:20:00',13.53),('7643','2013-03-20','14:25:00',13.3),('7643','2013-03-20','14:30:00',13.01),('7643','2013-03-20','14:35:00',12.78),('7643','2013-03-20','14:40:00',12.64),('7643','2013-03-20','14:45:00',12.43),('7643','2013-03-20','14:50:00',12.23),('7643','2013-03-20','14:55:00',12),('7643','2013-03-20','15:00:00',11.71),('7643','2013-03-20','15:05:00',11.43),('7643','2013-03-20','15:10:00',11.16),('7643','2013-03-20','15:15:00',10.83),('7643','2013-03-20','15:20:00',10.53),('7643','2013-03-20','15:25:00',10.25),('7643','2013-03-20','15:30:00',9.97),('7643','2013-03-20','15:35:00',9.63),('7643','2013-03-20','15:40:00',9.26),('7643','2013-03-20','15:45:00',8.93),('7643','2013-03-20','15:50:00',8.62),('7643','2013-03-20','15:55:00',8.26),('7643','2013-03-20','16:00:00',7.91),('7643','2013-03-20','16:05:00',7.58),('7643','2013-03-20','16:10:00',7.21),('7643','2013-03-20','16:15:00',6.85),('7643','2013-03-20','16:20:00',6.5),('7643','2013-03-20','16:25:00',6.09),('7643','2013-03-20','16:30:00',5.68),('7643','2013-03-20','16:35:00',5.28),('7643','2013-03-20','16:40:00',4.84),('7643','2013-03-20','16:45:00',4.55),('7643','2013-03-20','16:50:00',4.19),('7643','2013-03-20','16:55:00',3.79),('7643','2013-03-20','17:00:00',3.41),('7643','2013-03-20','17:05:00',3.06),('7643','2013-03-20','17:10:00',2.76),('7643','2013-03-20','17:15:00',2.37),('7643','2013-03-20','17:20:00',2.04),('7643','2013-03-20','17:25:00',1.7),('7643','2013-03-20','17:30:00',1.39),('7643','2013-03-20','17:35:00',1.12),('7643','2013-03-19','06:50:00',1.14),('7643','2013-03-19','06:55:00',1.44),('7643','2013-03-19','07:00:00',1.75),('7643','2013-03-19','07:05:00',2.08),('7643','2013-03-19','07:10:00',2.44),('7643','2013-03-19','07:15:00',2.84),('7643','2013-03-19','07:20:00',3.23),('7643','2013-03-19','07:25:00',3.65),('7643','2013-03-19','07:30:00',4.12),('7643','2013-03-19','07:35:00',4.63),('7643','2013-03-19','07:40:00',4.51),('7643','2013-03-19','07:45:00',4.93),('7643','2013-03-19','07:50:00',5.02),('7643','2013-03-19','07:55:00',6.12),('7643','2013-03-19','08:00:00',5.27),('7643','2013-03-19','08:05:00',5.06),('7643','2013-03-19','08:10:00',6.82),('7643','2013-03-19','08:15:00',7.2),('7643','2013-03-19','08:20:00',7.49),('7643','2013-03-19','08:25:00',7.92),('7643','2013-03-19','08:30:00',8.38),('7643','2013-03-19','08:35:00',8.5),('7643','2013-03-19','08:40:00',8.37),('7643','2013-03-19','08:45:00',8.82),('7643','2013-03-19','08:50:00',9.25),('7643','2013-03-19','08:55:00',9.11),('7643','2013-03-19','09:00:00',9.9),('7643','2013-03-19','09:05:00',12.1),('7643','2013-03-19','09:10:00',11.16),('7643','2013-03-19','09:15:00',10.18),('7643','2013-03-19','09:20:00',11.05),('7643','2013-03-19','09:25:00',11.77),('7643','2013-03-19','09:30:00',11.74),('7643','2013-03-19','09:35:00',11.38),('7643','2013-03-19','09:40:00',12.05),('7643','2013-03-19','09:45:00',12.37),('7643','2013-03-19','09:50:00',12.55),('7643','2013-03-19','09:55:00',12.56),('7643','2013-03-19','10:00:00',13.02),('7643','2013-03-19','10:05:00',13.01),('7643','2013-03-19','10:10:00',11.21),('7643','2013-03-19','10:15:00',10.38),('7643','2013-03-19','10:20:00',10.88),('7643','2013-03-19','10:25:00',9.6),('7643','2013-03-19','10:30:00',11.31),('7643','2013-03-19','10:35:00',15.25),('7643','2013-03-19','10:40:00',11.74),('7643','2013-03-19','10:45:00',9.21),('7643','2013-03-19','10:50:00',11.74),('7643','2013-03-19','10:55:00',11.01),('7643','2013-03-19','11:00:00',11.28),('7643','2013-03-19','11:05:00',12.3),('7643','2013-03-19','11:10:00',9.99),('7643','2013-03-19','11:15:00',9.6),('7643','2013-03-19','11:20:00',10.37),('7643','2013-03-19','11:25:00',9.94),('7643','2013-03-19','11:30:00',9.25),('7643','2013-03-19','11:35:00',10.25),('7643','2013-03-19','11:40:00',8.33),('7643','2013-03-19','11:45:00',7.84),('7643','2013-03-19','11:50:00',7.41),('7643','2013-03-19','11:55:00',8.37),('7643','2013-03-19','12:00:00',8.05),('7643','2013-03-19','12:05:00',9.12),('7643','2013-03-19','12:10:00',7.23),('7643','2013-03-19','12:15:00',6.29),('7643','2013-03-19','12:20:00',5.76),('7643','2013-03-19','12:25:00',4.78),('7643','2013-03-19','12:30:00',3.87),('7643','2013-03-19','12:35:00',4.98),('7643','2013-03-19','12:40:00',3.5),('7643','2013-03-19','12:45:00',3.8),('7643','2013-03-19','12:50:00',5.47),('7643','2013-03-19','12:55:00',6.35),('7643','2013-03-19','13:00:00',6.92),('7643','2013-03-19','13:05:00',5.41),('7643','2013-03-19','13:10:00',5.45),('7643','2013-03-19','13:15:00',4.35),('7643','2013-03-19','13:20:00',4.69),('7643','2013-03-19','13:25:00',4.94),('7643','2013-03-19','13:30:00',5.37),('7643','2013-03-19','13:35:00',5.08),('7643','2013-03-19','13:40:00',6.42),('7643','2013-03-19','13:45:00',7.54),('7643','2013-03-19','13:50:00',6.28),('7643','2013-03-19','13:55:00',5.86),('7643','2013-03-19','14:00:00',5.81),('7643','2013-03-19','14:05:00',4.97),('7643','2013-03-19','14:10:00',4.7),('7643','2013-03-19','14:15:00',6.2),('7643','2013-03-19','14:20:00',7.87),('7643','2013-03-19','14:25:00',7.05),('7643','2013-03-19','14:30:00',6.03),('7643','2013-03-19','14:35:00',5.01),('7643','2013-03-19','14:40:00',3.98),('7643','2013-03-19','14:45:00',3.89),('7643','2013-03-19','14:50:00',3.14),('7643','2013-03-19','14:55:00',2.58),('7643','2013-03-19','15:00:00',2.84),('7643','2013-03-19','15:05:00',2.49),('7643','2013-03-19','15:10:00',2.24),('7643','2013-03-19','15:15:00',1.93),('7643','2013-03-19','15:20:00',1.68),('7643','2013-03-19','15:25:00',1.69),('7643','2013-03-19','15:30:00',2.09),('7643','2013-03-19','15:35:00',1.89),('7643','2013-03-19','15:40:00',1.26),('7643','2013-03-18','06:55:00',1.05),('7643','2013-03-18','07:00:00',1.52),('7643','2013-03-18','07:05:00',3.02),('7643','2013-03-18','07:10:00',3.41),('7643','2013-03-18','07:15:00',3.59),('7643','2013-03-18','07:20:00',3.08),('7643','2013-03-18','07:25:00',3.4),('7643','2013-03-18','07:30:00',3.75),('7643','2013-03-18','07:35:00',4.1),('7643','2013-03-18','07:40:00',4.46),('7643','2013-03-18','07:45:00',4.85),('7643','2013-03-18','07:50:00',5.27),('7643','2013-03-18','07:55:00',5.34),('7643','2013-03-18','08:00:00',3.58),('7643','2013-03-18','08:05:00',5.06),('7643','2013-03-18','08:10:00',6.51),('7643','2013-03-18','08:15:00',7.11),('7643','2013-03-18','08:20:00',7.36),('7643','2013-03-18','08:25:00',7.69),('7643','2013-03-18','08:30:00',8.15),('7643','2013-03-18','08:35:00',8.31),('7643','2013-03-18','08:40:00',8.85),('7643','2013-03-18','08:45:00',7.99),('7643','2013-03-18','08:50:00',9.53),('7643','2013-03-18','08:55:00',9.1),('7643','2013-03-18','09:00:00',10.12),('7643','2013-03-18','09:05:00',10.48),('7643','2013-03-18','09:10:00',10.67),('7643','2013-03-18','09:15:00',11.14),('7643','2013-03-18','09:20:00',10.14),('7643','2013-03-18','09:25:00',9.19),('7643','2013-03-18','09:30:00',11.52),('7643','2013-03-18','09:35:00',11.08),('7643','2013-03-18','09:40:00',12.59),('7643','2013-03-18','09:45:00',13.12),('7643','2013-03-18','09:50:00',10.83),('7643','2013-03-18','09:55:00',12.15),('7643','2013-03-18','10:00:00',10.57),('7643','2013-03-18','10:05:00',12.14),('7643','2013-03-18','10:10:00',13.42),('7643','2013-03-18','10:15:00',14),('7643','2013-03-18','10:20:00',14.29),('7643','2013-03-18','10:25:00',13.05),('7643','2013-03-18','10:30:00',14.61),('7643','2013-03-18','10:35:00',14.74),('7643','2013-03-18','10:40:00',14.76),('7643','2013-03-18','10:45:00',15.01),('7643','2013-03-18','10:50:00',15.09),('7643','2013-03-18','10:55:00',15.54),('7643','2013-03-18','11:00:00',15.8),('7643','2013-03-18','11:05:00',15.58),('7643','2013-03-18','11:10:00',15.21),('7643','2013-03-18','11:15:00',15.95),('7643','2013-03-18','11:20:00',16.07),('7643','2013-03-18','11:25:00',15.95),('7643','2013-03-18','11:30:00',16.02),('7643','2013-03-18','11:35:00',10.07),('7643','2013-03-18','11:40:00',14.6),('7643','2013-03-18','11:45:00',14.87),('7643','2013-03-18','11:50:00',16.55),('7643','2013-03-18','11:55:00',16.63),('7643','2013-03-18','12:00:00',16.4),('7643','2013-03-18','12:05:00',16.24),('7643','2013-03-18','12:10:00',16.24),('7643','2013-03-18','12:15:00',15.39),('7643','2013-03-18','12:20:00',16.31),('7643','2013-03-18','12:25:00',16.15),('7643','2013-03-18','12:30:00',15.74),('7643','2013-03-18','12:35:00',16.09),('7643','2013-03-18','12:40:00',16.05),('7643','2013-03-18','12:45:00',15.83),('7643','2013-03-18','12:50:00',16.1),('7643','2013-03-18','12:55:00',16.02),('7643','2013-03-18','13:00:00',15.9),('7643','2013-03-18','13:05:00',15.73),('7643','2013-03-18','13:10:00',15.52),('7643','2013-03-18','13:15:00',15.37),('7643','2013-03-18','13:20:00',15.35),('7643','2013-03-18','13:25:00',15.23),('7643','2013-03-18','13:30:00',15.12),('7643','2013-03-18','13:35:00',15.01),('7643','2013-03-18','13:40:00',14.61),('7643','2013-03-18','13:45:00',14.62),('7643','2013-03-18','13:50:00',14.55),('7643','2013-03-18','13:55:00',14.36),('7643','2013-03-18','14:00:00',14.25),('7643','2013-03-18','14:05:00',14.01),('7643','2013-03-18','14:10:00',13.77),('7643','2013-03-18','14:15:00',13.58),('7643','2013-03-18','14:20:00',13.43),('7643','2013-03-18','14:25:00',13.23),('7643','2013-03-18','14:30:00',13),('7643','2013-03-18','14:35:00',12.67),('7643','2013-03-18','14:40:00',12.55),('7643','2013-03-18','14:45:00',12.25),('7643','2013-03-18','14:50:00',12.03),('7643','2013-03-18','14:55:00',11.81),('7643','2013-03-18','15:00:00',11.55),('7643','2013-03-18','15:05:00',11.22),('7643','2013-03-18','15:10:00',10.93),('7643','2013-03-18','15:15:00',10.62),('7643','2013-03-18','15:20:00',10.38),('7643','2013-03-18','15:25:00',10.04),('7643','2013-03-18','15:30:00',9.77),('7643','2013-03-18','15:35:00',9.47),('7643','2013-03-18','15:40:00',9.11),('7643','2013-03-18','15:45:00',8.78),('7643','2013-03-18','15:50:00',8.51),('7643','2013-03-18','15:55:00',8.12),('7643','2013-03-18','16:00:00',7.8),('7643','2013-03-18','16:05:00',7.44),('7643','2013-03-18','16:10:00',7.04),('7643','2013-03-18','16:15:00',6.66),('7643','2013-03-18','16:20:00',6.29),('7643','2013-03-18','16:25:00',5.95),('7643','2013-03-18','16:30:00',5.64),('7643','2013-03-18','16:35:00',5.31),('7643','2013-03-18','16:40:00',4.93),('7643','2013-03-18','16:45:00',3.98),('7643','2013-03-18','16:50:00',3.1),('7643','2013-03-18','16:55:00',3.3),('7643','2013-03-18','17:00:00',2.7),('7643','2013-03-18','17:05:00',2.44),('7643','2013-03-18','17:10:00',2.32),('7643','2013-03-18','17:15:00',2.72),('7643','2013-03-18','17:20:00',2.34),('7643','2013-03-18','17:25:00',1.88),('7643','2013-03-18','17:30:00',1.4),('7643','2013-03-18','17:35:00',1.23),('7643','2013-03-17','07:00:00',1.04),('7643','2013-03-17','07:05:00',1.16),('7643','2013-03-17','07:10:00',1.15),('7643','2013-03-17','07:15:00',1.23),('7643','2013-03-17','07:20:00',1.4),('7643','2013-03-17','07:25:00',1.24),('7643','2013-03-17','07:50:00',1.25),('7643','2013-03-17','07:55:00',1.56),('7643','2013-03-17','08:00:00',1.58),('7643','2013-03-17','08:05:00',1.56),('7643','2013-03-17','08:10:00',1.44),('7643','2013-03-17','08:15:00',1.58),('7643','2013-03-17','08:20:00',1.97),('7643','2013-03-17','08:25:00',2.37),('7643','2013-03-17','08:30:00',2.77),('7643','2013-03-17','08:35:00',2.53),('7643','2013-03-17','08:40:00',2.41),('7643','2013-03-17','08:45:00',3.42),('7643','2013-03-17','08:50:00',2.94),('7643','2013-03-17','08:55:00',2.55),('7643','2013-03-17','09:00:00',1.76),('7643','2013-03-17','09:05:00',1.3),('7643','2013-03-17','09:10:00',1.12),('7643','2013-03-17','09:15:00',1.22),('7643','2013-03-17','09:20:00',1.57),('7643','2013-03-17','09:25:00',1.65),('7643','2013-03-17','09:30:00',1.88),('7643','2013-03-17','09:35:00',2.07),('7643','2013-03-17','09:40:00',2.32),('7643','2013-03-17','09:45:00',2.51),('7643','2013-03-17','09:50:00',2.59),('7643','2013-03-17','09:55:00',3.55),('7643','2013-03-17','10:00:00',4.58),('7643','2013-03-17','10:05:00',5.83),('7643','2013-03-17','10:10:00',5.67),('7643','2013-03-17','10:15:00',4.86),('7643','2013-03-17','10:20:00',6.17),('7643','2013-03-17','10:25:00',8.22),('7643','2013-03-17','10:30:00',7.59),('7643','2013-03-17','10:35:00',5.89),('7643','2013-03-17','10:40:00',5.31),('7643','2013-03-17','10:45:00',5.43),('7643','2013-03-17','10:50:00',5.29),('7643','2013-03-17','10:55:00',4.39),('7643','2013-03-17','11:00:00',4.71),('7643','2013-03-17','11:05:00',5.17),('7643','2013-03-17','11:10:00',5.99),('7643','2013-03-17','11:15:00',6.52),('7643','2013-03-17','11:20:00',6.76),('7643','2013-03-17','11:25:00',7.25),('7643','2013-03-17','11:30:00',8.71),('7643','2013-03-17','11:35:00',7.43),('7643','2013-03-17','11:40:00',6.95),('7643','2013-03-17','11:45:00',5.79),('7643','2013-03-17','11:50:00',4.71),('7643','2013-03-17','11:55:00',5.59),('7643','2013-03-17','12:00:00',5.93),('7643','2013-03-17','12:05:00',10.17),('7643','2013-03-17','12:10:00',9.39),('7643','2013-03-17','12:15:00',10.97),('7643','2013-03-17','12:20:00',10.09),('7643','2013-03-17','12:25:00',7.35),('7643','2013-03-17','12:30:00',13.69),('7643','2013-03-17','12:35:00',14.68),('7643','2013-03-17','12:40:00',12.18),('7643','2013-03-17','12:45:00',10.1),('7643','2013-03-17','12:50:00',14.34),('7643','2013-03-17','12:55:00',15.77),('7643','2013-03-17','13:00:00',13.35),('7643','2013-03-17','13:05:00',6.92),('7643','2013-03-17','13:10:00',4.52),('7643','2013-03-17','13:15:00',3.38),('7643','2013-03-17','13:20:00',3.81),('7643','2013-03-17','13:25:00',7.19),('7643','2013-03-17','13:30:00',5.29),('7643','2013-03-17','13:35:00',4.45),('7643','2013-03-17','13:40:00',7.53),('7643','2013-03-17','13:45:00',6.8),('7643','2013-03-17','13:50:00',6.27),('7643','2013-03-17','13:55:00',5.95),('7643','2013-03-17','14:00:00',6.42),('7643','2013-03-17','14:05:00',10.45),('7643','2013-03-17','14:10:00',9.47),('7643','2013-03-17','14:15:00',4.82),('7643','2013-03-17','14:20:00',4.74),('7643','2013-03-17','14:25:00',6.95),('7643','2013-03-17','14:30:00',3.16),('7643','2013-03-17','14:35:00',4.14),('7643','2013-03-17','14:40:00',4.65),('7643','2013-03-17','14:45:00',4.45),('7643','2013-03-17','14:50:00',2.51),('7643','2013-03-17','14:55:00',3.45),('7643','2013-03-17','15:00:00',4.01),('7643','2013-03-17','15:05:00',3.36),('7643','2013-03-17','15:10:00',2.46),('7643','2013-03-17','15:15:00',3.22),('7643','2013-03-17','15:20:00',2.52),('7643','2013-03-17','15:25:00',2.23),('7643','2013-03-17','15:30:00',2.09),('7643','2013-03-17','15:35:00',1.94),('7643','2013-03-17','15:40:00',1.53),('7643','2013-03-17','15:45:00',1.64),('7643','2013-03-17','15:50:00',1.41),('7643','2013-03-17','15:55:00',1.19),('7643','2013-03-17','16:00:00',1.22),('7643','2013-03-17','16:05:00',1.11),('7643','2013-03-16','06:45:00',1.13),('7643','2013-03-16','07:00:00',1.04),('7643','2013-03-16','07:05:00',1.4),('7643','2013-03-16','07:10:00',1.66),('7643','2013-03-16','07:15:00',1.61),('7643','2013-03-16','07:20:00',1.26),('7643','2013-03-16','07:25:00',1.32),('7643','2013-03-16','07:30:00',1.55),('7643','2013-03-16','07:35:00',1.55),('7643','2013-03-16','07:40:00',1.73),('7643','2013-03-16','07:45:00',1.89),('7643','2013-03-16','07:50:00',2.27),('7643','2013-03-16','07:55:00',2.42),('7643','2013-03-16','08:00:00',2.67),('7643','2013-03-16','08:05:00',2.99),('7643','2013-03-16','08:10:00',3.56),('7643','2013-03-16','08:15:00',4.04),('7643','2013-03-16','08:20:00',4.65),('7643','2013-03-16','08:25:00',6),('7643','2013-03-16','08:30:00',5.24),('7643','2013-03-16','08:35:00',4.57),('7643','2013-03-16','08:40:00',4.68),('7643','2013-03-16','08:45:00',5.64),('7643','2013-03-16','08:50:00',5.51),('7643','2013-03-16','08:55:00',5.19),('7643','2013-03-16','09:00:00',5.08),('7643','2013-03-16','09:05:00',5.81),('7643','2013-03-16','09:10:00',6.63),('7643','2013-03-16','09:15:00',7.38),('7643','2013-03-16','09:20:00',5.98),('7643','2013-03-16','09:25:00',4.95),('7643','2013-03-16','09:30:00',5.39),('7643','2013-03-16','09:35:00',6.14),('7643','2013-03-16','09:40:00',5.9),('7643','2013-03-16','09:45:00',6),('7643','2013-03-16','09:50:00',6.73),('7643','2013-03-16','09:55:00',7.36),('7643','2013-03-16','10:00:00',8.15),('7643','2013-03-16','10:05:00',6.7),('7643','2013-03-16','10:10:00',6.5),('7643','2013-03-16','10:15:00',7.13),('7643','2013-03-16','10:20:00',7.27),('7643','2013-03-16','10:25:00',7.6),('7643','2013-03-16','10:30:00',7.37),('7643','2013-03-16','10:35:00',7.05),('7643','2013-03-16','10:40:00',6.64),('7643','2013-03-16','10:45:00',7.01),('7643','2013-03-16','10:50:00',6.91),('7643','2013-03-16','10:55:00',6.33),('7643','2013-03-16','11:00:00',6.35),('7643','2013-03-16','11:05:00',5.4),('7643','2013-03-16','11:10:00',5.12),('7643','2013-03-16','11:15:00',5.41),('7643','2013-03-16','11:20:00',6.19),('7643','2013-03-16','11:25:00',6.52),('7643','2013-03-16','11:30:00',5.9),('7643','2013-03-16','11:35:00',5.75),('7643','2013-03-16','11:40:00',5.37),('7643','2013-03-16','11:45:00',5.06),('7643','2013-03-16','11:50:00',4.64),('7643','2013-03-16','11:55:00',4.15),('7643','2013-03-16','12:00:00',4.11),('7643','2013-03-16','12:05:00',4.25),('7643','2013-03-16','12:10:00',5.39),('7643','2013-03-16','12:15:00',7.24),('7643','2013-03-16','12:20:00',8.94),('7643','2013-03-16','12:25:00',13.13),('7643','2013-03-16','12:30:00',13.46),('7643','2013-03-16','12:35:00',9.89),('7643','2013-03-16','12:40:00',10.74),('7643','2013-03-16','12:45:00',9.41),('7643','2013-03-16','12:50:00',8.39),('7643','2013-03-16','12:55:00',6.64),('7643','2013-03-16','13:00:00',7.92),('7643','2013-03-16','13:05:00',8.85),('7643','2013-03-16','13:10:00',9.78),('7643','2013-03-16','13:15:00',9.97),('7643','2013-03-16','13:20:00',8.13),('7643','2013-03-16','13:25:00',6.92),('7643','2013-03-16','13:30:00',10.42),('7643','2013-03-16','13:35:00',11.8),('7643','2013-03-16','13:40:00',7.79),('7643','2013-03-16','13:45:00',7.09),('7643','2013-03-16','13:50:00',5.48),('7643','2013-03-16','13:55:00',8.41),('7643','2013-03-16','14:00:00',8.41),('7643','2013-03-16','14:05:00',8.14),('7643','2013-03-16','14:10:00',9.7),('7643','2013-03-16','14:15:00',10.6),('7643','2013-03-16','14:20:00',10.34),('7643','2013-03-16','14:25:00',9.21),('7643','2013-03-16','14:30:00',9.03),('7643','2013-03-16','14:35:00',7.3),('7643','2013-03-16','14:40:00',5.65),('7643','2013-03-16','14:45:00',5.01),('7643','2013-03-16','14:50:00',4.33),('7643','2013-03-16','14:55:00',4.46),('7643','2013-03-16','15:00:00',5.88),('7643','2013-03-16','15:05:00',6.51),('7643','2013-03-16','15:10:00',8.4),('7643','2013-03-16','15:15:00',7.79),('7643','2013-03-16','15:20:00',8.92),('7643','2013-03-16','15:25:00',6.62),('7643','2013-03-16','15:30:00',4.95),('7643','2013-03-16','15:35:00',5.11),('7643','2013-03-16','15:40:00',5.41),('7643','2013-03-16','15:45:00',5.17),('7643','2013-03-16','15:50:00',3.42),('7643','2013-03-16','15:55:00',3.13),('7643','2013-03-16','16:00:00',2.24),('7643','2013-03-16','16:05:00',1.23),('7643','2013-03-16','16:10:00',1.1),('7643','2013-03-16','16:15:00',1.53),('7643','2013-03-16','16:20:00',2.1),('7643','2013-03-16','16:30:00',1.27),('7643','2013-03-16','16:35:00',1.58),('7643','2013-03-16','16:40:00',2.81),('7643','2013-03-16','16:45:00',4.47),('7643','2013-03-16','16:50:00',1.57),('7643','2013-03-16','16:55:00',1.26),('7643','2013-03-16','17:00:00',1.43),('7643','2013-03-16','17:05:00',1.25),('7643','2013-03-16','17:10:00',1.21),('7643','2013-03-16','17:15:00',1.08),('7643','2013-03-15','07:25:00',1.12),('7643','2013-03-15','07:30:00',1.49),('7643','2013-03-15','07:35:00',1.73),('7643','2013-03-15','07:40:00',1.93),('7643','2013-03-15','07:45:00',2.38),('7643','2013-03-15','07:50:00',3.7),('7643','2013-03-15','07:55:00',3.34),('7643','2013-03-15','08:00:00',3.92),('7643','2013-03-15','08:05:00',3.95),('7643','2013-03-15','08:10:00',4.99),('7643','2013-03-15','08:15:00',8.55),('7643','2013-03-15','08:20:00',9.37),('7643','2013-03-15','08:25:00',9.01),('7643','2013-03-15','08:30:00',8.81),('7643','2013-03-15','08:35:00',9.23),('7643','2013-03-15','08:40:00',9.73),('7643','2013-03-15','08:45:00',9.67),('7643','2013-03-15','08:50:00',10.46),('7643','2013-03-15','08:55:00',11),('7643','2013-03-15','09:00:00',10.83),('7643','2013-03-15','09:05:00',11.03),('7643','2013-03-15','09:10:00',9.55),('7643','2013-03-15','09:15:00',12.02),('7643','2013-03-15','09:20:00',11.98),('7643','2013-03-15','09:25:00',8.07),('7643','2013-03-15','09:30:00',11.56),('7643','2013-03-15','09:35:00',12.85),('7643','2013-03-15','09:40:00',12.68),('7643','2013-03-15','09:45:00',10.8),('7643','2013-03-15','09:50:00',13.98),('7643','2013-03-15','09:55:00',14.05),('7643','2013-03-15','10:00:00',10.83),('7643','2013-03-15','10:05:00',8.61),('7643','2013-03-15','10:10:00',12.07),('7643','2013-03-15','10:15:00',9.39),('7643','2013-03-15','10:20:00',7.98),('7643','2013-03-15','10:25:00',12.28),('7643','2013-03-15','10:30:00',9.12),('7643','2013-03-15','10:35:00',12.97),('7643','2013-03-15','10:40:00',15.36),('7643','2013-03-15','10:45:00',15.77),('7643','2013-03-15','10:50:00',15.78),('7643','2013-03-15','10:55:00',15.8),('7643','2013-03-15','11:00:00',15.86),('7643','2013-03-15','11:05:00',15.81),('7643','2013-03-15','11:10:00',16.02),('7643','2013-03-15','11:15:00',16.22),('7643','2013-03-15','11:20:00',16.16),('7643','2013-03-15','11:25:00',16.22),('7643','2013-03-15','11:30:00',16.28),('7643','2013-03-15','11:35:00',16.36),('7643','2013-03-15','11:40:00',16.37),('7643','2013-03-15','11:45:00',16.31),('7643','2013-03-15','11:50:00',16.39),('7643','2013-03-15','11:55:00',16.47),('7643','2013-03-15','12:00:00',16.45),('7643','2013-03-15','12:05:00',16.31),('7643','2013-03-15','12:10:00',16.41),('7643','2013-03-15','12:15:00',16.4),('7643','2013-03-15','12:20:00',16.37),('7643','2013-03-15','12:25:00',16.29),('7643','2013-03-15','12:30:00',16.29),('7643','2013-03-15','12:35:00',16.05),('7643','2013-03-15','12:40:00',16.15),('7643','2013-03-15','12:45:00',16.15),('7643','2013-03-15','12:50:00',16.1),('7643','2013-03-15','12:55:00',15.88),('7643','2013-03-15','13:00:00',15.81),('7643','2013-03-15','13:05:00',15.62),('7643','2013-03-15','13:10:00',15.44),('7643','2013-03-15','13:15:00',15.42),('7643','2013-03-15','13:20:00',14.58),('7643','2013-03-15','13:25:00',8.18),('7643','2013-03-15','13:30:00',3.01),('7643','2013-03-15','13:35:00',7.6),('7643','2013-03-15','13:40:00',16.05),('7643','2013-03-15','13:45:00',15.37),('7643','2013-03-15','13:50:00',12.02),('7643','2013-03-15','13:55:00',3.29),('7643','2013-03-15','14:00:00',13.71),('7643','2013-03-15','14:05:00',15.46),('7643','2013-03-15','14:10:00',13.25),('7643','2013-03-15','14:15:00',10.6),('7643','2013-03-15','14:20:00',11.26),('7643','2013-03-15','14:25:00',3.64),('7643','2013-03-15','14:30:00',4.3),('7643','2013-03-15','14:35:00',11.32),('7643','2013-03-15','14:40:00',9.77),('7643','2013-03-15','14:45:00',9.77),('7643','2013-03-15','14:50:00',3.12),('7643','2013-03-15','14:55:00',2.61),('7643','2013-03-15','15:00:00',2.43),('7643','2013-03-15','15:05:00',2.31),('7643','2013-03-15','15:10:00',2.14),('7643','2013-03-15','15:15:00',2.05),('7643','2013-03-15','15:20:00',2.08),('7643','2013-03-15','15:25:00',2.3),('7643','2013-03-15','15:30:00',2.11),('7643','2013-03-15','15:35:00',2.44),('7643','2013-03-15','15:40:00',2.83),('7643','2013-03-15','15:45:00',3.73),('7643','2013-03-15','15:50:00',2.36),('7643','2013-03-15','15:55:00',1.66),('7643','2013-03-15','16:00:00',2.52),('7643','2013-03-15','16:05:00',5.12),('7643','2013-03-15','16:10:00',5.12),('7643','2013-03-15','16:15:00',6.15),('7643','2013-03-15','16:20:00',5.26),('7643','2013-03-15','16:25:00',2.2),('7643','2013-03-15','16:30:00',2.32),('7643','2013-03-15','16:35:00',2.22),('7643','2013-03-15','16:40:00',1.97),('7643','2013-03-15','16:45:00',1.71),('7643','2013-03-15','16:50:00',1.7),('7643','2013-03-15','16:55:00',3.2),('7643','2013-03-15','17:00:00',3.53),('7643','2013-03-15','17:05:00',3.28),('7643','2013-03-15','17:10:00',2.85),('7643','2013-03-15','17:15:00',2.59),('7643','2013-03-15','17:20:00',2.35),('7643','2013-03-15','17:25:00',2.01),('7643','2013-03-15','17:30:00',1.67),('7643','2013-03-15','17:35:00',1.43),('7643','2013-03-15','17:40:00',1.19),('7643','2013-03-14','09:30:00',1.05),('7643','2013-03-14','09:35:00',1.18),('7643','2013-03-14','09:40:00',1.24),('7643','2013-03-14','09:45:00',1.37),('7643','2013-03-14','09:50:00',1.7),('7643','2013-03-14','09:55:00',1.86),('7643','2013-03-14','10:00:00',2.17),('7643','2013-03-14','10:05:00',2.08),('7643','2013-03-14','10:10:00',2.23),('7643','2013-03-14','10:15:00',2.51),('7643','2013-03-14','10:20:00',2.26),('7643','2013-03-14','10:25:00',2.47),('7643','2013-03-14','10:30:00',3.25),('7643','2013-03-14','10:35:00',3.68),('7643','2013-03-14','10:40:00',4.28),('7643','2013-03-14','10:45:00',5.16),('7643','2013-03-14','10:50:00',5.04),('7643','2013-03-14','10:55:00',5.53),('7643','2013-03-14','11:00:00',5.43),('7643','2013-03-14','11:05:00',4.9),('7643','2013-03-14','11:10:00',4.64),('7643','2013-03-14','11:15:00',4.06),('7643','2013-03-14','11:20:00',4.88),('7643','2013-03-14','11:25:00',5.82),('7643','2013-03-14','11:30:00',6.47),('7643','2013-03-14','11:35:00',7.75),('7643','2013-03-14','11:40:00',9.38),('7643','2013-03-14','11:45:00',9.44),('7643','2013-03-14','11:50:00',7.56),('7643','2013-03-14','11:55:00',7.81),('7643','2013-03-14','12:00:00',7.08),('7643','2013-03-14','12:05:00',6.91),('7643','2013-03-14','12:10:00',7.1),('7643','2013-03-14','12:15:00',6.33),('7643','2013-03-14','12:20:00',6.42),('7643','2013-03-14','12:25:00',6.48),('7643','2013-03-14','12:30:00',6.75),('7643','2013-03-14','12:35:00',7.7),('7643','2013-03-14','12:40:00',6.95),('7643','2013-03-14','12:45:00',6.13),('7643','2013-03-14','12:50:00',5.75),('7643','2013-03-14','12:55:00',5.33),('7643','2013-03-14','13:00:00',4.88),('7643','2013-03-14','13:05:00',4.58),('7643','2013-03-14','13:10:00',4.62),('7643','2013-03-14','13:15:00',4.98),('7643','2013-03-14','13:20:00',5.33),('7643','2013-03-14','13:25:00',5.81),('7643','2013-03-14','13:30:00',5.77),('7643','2013-03-14','13:35:00',5.32),('7643','2013-03-14','13:40:00',5.57),('7643','2013-03-14','13:45:00',6.07),('7643','2013-03-14','13:50:00',5.08),('7643','2013-03-14','13:55:00',4.37),('7643','2013-03-14','14:00:00',3.89),('7643','2013-03-14','14:05:00',3.49),('7643','2013-03-14','14:10:00',2.94),('7643','2013-03-14','14:15:00',2.53),('7643','2013-03-14','14:20:00',2.24),('7643','2013-03-14','14:25:00',1.95),('7643','2013-03-14','14:30:00',1.81),('7643','2013-03-14','14:35:00',1.8),('7643','2013-03-14','14:40:00',1.99),('7643','2013-03-14','14:45:00',2.51),('7643','2013-03-14','14:50:00',3.49),('7643','2013-03-14','14:55:00',4.18),('7643','2013-03-14','15:00:00',4.5),('7643','2013-03-14','15:05:00',4.41),('7643','2013-03-14','15:10:00',4.34),('7643','2013-03-14','15:15:00',4.7),('7643','2013-03-14','15:20:00',4.76),('7643','2013-03-14','15:25:00',5.15),('7643','2013-03-14','15:30:00',4.76),('7643','2013-03-14','15:35:00',4.01),('7643','2013-03-14','15:40:00',3.3),('7643','2013-03-14','15:45:00',3.32),('7643','2013-03-14','15:50:00',3.26),('7643','2013-03-14','15:55:00',3.07),('7643','2013-03-14','16:00:00',3.56),('7643','2013-03-14','16:05:00',2.97),('7643','2013-03-14','16:10:00',2.57),('7643','2013-03-14','16:15:00',2.65),('7643','2013-03-14','16:20:00',2.3),('7643','2013-03-14','16:25:00',1.58),('7643','2013-03-14','16:30:00',1.47),('7643','2013-03-14','16:35:00',1.3),('7643','2013-03-14','16:40:00',1.1),('7643','2013-03-14','17:00:00',1.04),('7643','2013-03-14','17:05:00',1.19),('7643','2013-03-14','17:10:00',1.35),('7643','2013-03-14','17:15:00',2.5),('7643','2013-03-14','17:20:00',2.37),('7643','2013-03-14','17:25:00',1.81),('7643','2013-03-14','17:30:00',1.41),('7643','2013-03-13','07:15:00',1.03),('7643','2013-03-13','07:20:00',1.12),('7643','2013-03-13','08:10:00',1.22),('7643','2013-03-13','08:15:00',1.93),('7643','2013-03-13','08:20:00',2.75),('7643','2013-03-13','08:25:00',3.01),('7643','2013-03-13','08:30:00',2.58),('7643','2013-03-13','08:35:00',1.66),('7643','2013-03-13','08:40:00',1.36),('7643','2013-03-13','09:20:00',1.1),('7643','2013-03-13','09:25:00',1.33),('7643','2013-03-13','09:30:00',1.33),('7643','2013-03-13','09:35:00',1.06),('7643','2013-03-13','09:40:00',1.1),('7643','2013-03-13','09:45:00',1.21),('7643','2013-03-13','09:50:00',1.16),('7643','2013-03-13','10:15:00',1.51),('7643','2013-03-13','10:20:00',2.26),('7643','2013-03-13','10:25:00',2.33),('7643','2013-03-13','10:30:00',2.37),('7643','2013-03-13','10:35:00',2.44),('7643','2013-03-13','10:40:00',2.23),('7643','2013-03-13','10:45:00',1.77),('7643','2013-03-13','10:50:00',1.44),('7643','2013-03-13','10:55:00',1.24),('7643','2013-03-13','11:00:00',1.26),('7643','2013-03-13','11:05:00',1.29),('7643','2013-03-13','11:10:00',1.35),('7643','2013-03-13','11:15:00',1.34),('7643','2013-03-13','11:20:00',1.35),('7643','2013-03-13','11:25:00',2.13),('7643','2013-03-13','11:30:00',2.73),('7643','2013-03-13','11:35:00',3.18),('7643','2013-03-13','11:40:00',3.18),('7643','2013-03-13','11:45:00',3.3),('7643','2013-03-13','11:50:00',3.15),('7643','2013-03-13','11:55:00',2.87),('7643','2013-03-13','12:00:00',2.59),('7643','2013-03-13','12:05:00',2.32),('7643','2013-03-13','12:10:00',2.15),('7643','2013-03-13','12:15:00',2.17),('7643','2013-03-13','12:20:00',2.27),('7643','2013-03-13','12:25:00',2.4),('7643','2013-03-13','12:30:00',2.54),('7643','2013-03-13','12:35:00',2.52),('7643','2013-03-13','12:40:00',2.37),('7643','2013-03-13','12:45:00',2.68),('7643','2013-03-13','12:50:00',3.09),('7643','2013-03-13','12:55:00',3.71),('7643','2013-03-13','13:00:00',3.44),('7643','2013-03-13','13:05:00',3.5),('7643','2013-03-13','13:10:00',3.75),('7643','2013-03-13','13:15:00',3.97),('7643','2013-03-13','13:20:00',4.39),('7643','2013-03-13','13:25:00',4.31),('7643','2013-03-13','13:30:00',4.29),('7643','2013-03-13','13:35:00',4.41),('7643','2013-03-13','13:40:00',4.12),('7643','2013-03-13','13:45:00',5.2),('7643','2013-03-13','13:50:00',6.44),('7643','2013-03-13','13:55:00',8.32),('7643','2013-03-13','14:00:00',7.09),('7643','2013-03-13','14:05:00',7.16),('7643','2013-03-13','14:10:00',5.9),('7643','2013-03-13','14:15:00',4.67),('7643','2013-03-13','14:20:00',4.17),('7643','2013-03-13','14:25:00',4.13),('7643','2013-03-13','14:30:00',4.01),('7643','2013-03-13','14:35:00',3.25),('7643','2013-03-13','14:40:00',2.44),('7643','2013-03-13','14:45:00',2.06),('7643','2013-03-13','14:50:00',2.08),('7643','2013-03-13','14:55:00',2.23),('7643','2013-03-13','15:00:00',2.37),('7643','2013-03-13','15:05:00',3.28),('7643','2013-03-13','15:10:00',4.87),('7643','2013-03-13','15:15:00',5.07),('7643','2013-03-13','15:20:00',4.67),('7643','2013-03-13','15:25:00',4.79),('7643','2013-03-13','15:30:00',4.69),('7643','2013-03-13','15:35:00',3.89),('7643','2013-03-13','15:40:00',2.91),('7643','2013-03-13','15:45:00',2.43),('7643','2013-03-13','15:50:00',1.78),('7643','2013-03-13','15:55:00',1.05),('7643','2013-03-13','16:25:00',1.48),('7643','2013-03-13','16:30:00',1.98),('7643','2013-03-13','16:35:00',1.63),('7643','2013-03-13','16:40:00',1.31),('7643','2013-03-12','07:05:00',1.82),('7643','2013-03-12','07:10:00',2.09),('7643','2013-03-12','07:15:00',2.06),('7643','2013-03-12','07:20:00',2.5),('7643','2013-03-12','07:25:00',2.09),('7643','2013-03-12','07:30:00',1.39),('7643','2013-03-12','07:35:00',2.49),('7643','2013-03-12','07:40:00',2.33),('7643','2013-03-12','07:45:00',1.99),('7643','2013-03-12','07:50:00',1.37),('7643','2013-03-12','07:55:00',1.46),('7643','2013-03-12','08:00:00',1.51),('7643','2013-03-12','08:05:00',1.92),('7643','2013-03-12','08:10:00',2.16),('7643','2013-03-12','08:15:00',1.27),('7643','2013-03-12','08:20:00',1.35),('7643','2013-03-12','08:25:00',2.47),('7643','2013-03-12','08:30:00',1.63),('7643','2013-03-12','08:35:00',1.73),('7643','2013-03-12','08:40:00',2.54),('7643','2013-03-12','08:45:00',3.14),('7643','2013-03-12','08:50:00',4.5),('7643','2013-03-12','08:55:00',4.48),('7643','2013-03-12','09:00:00',3.03),('7643','2013-03-12','09:05:00',3),('7643','2013-03-12','09:10:00',4.86),('7643','2013-03-12','09:15:00',4.2),('7643','2013-03-12','09:20:00',4.22),('7643','2013-03-12','09:25:00',3.38),('7643','2013-03-12','09:30:00',3.11),('7643','2013-03-12','09:35:00',2.58),('7643','2013-03-12','09:40:00',2.73),('7643','2013-03-12','09:45:00',3.84),('7643','2013-03-12','09:50:00',2.66),('7643','2013-03-12','09:55:00',1.48),('7643','2013-03-12','10:00:00',2.5),('7643','2013-03-12','10:05:00',3.75),('7643','2013-03-12','10:10:00',5.18),('7643','2013-03-12','10:15:00',10.21),('7643','2013-03-12','10:20:00',7.3),('7643','2013-03-12','10:25:00',8.93),('7643','2013-03-12','10:30:00',15.27),('7643','2013-03-12','10:35:00',15.1),('7643','2013-03-12','10:40:00',9.37),('7643','2013-03-12','10:45:00',4.95),('7643','2013-03-12','10:50:00',4.83),('7643','2013-03-12','10:55:00',4.71),('7643','2013-03-12','11:00:00',4.56),('7643','2013-03-12','11:05:00',2.99),('7643','2013-03-12','11:10:00',3.56),('7643','2013-03-12','11:15:00',3.66),('7643','2013-03-12','11:20:00',3.27),('7643','2013-03-12','11:25:00',3.16),('7643','2013-03-12','11:30:00',4.88),('7643','2013-03-12','11:35:00',4.7),('7643','2013-03-12','11:40:00',4.47),('7643','2013-03-12','11:45:00',4.82),('7643','2013-03-12','11:50:00',4.46),('7643','2013-03-12','11:55:00',3.52),('7643','2013-03-12','12:00:00',2.28),('7643','2013-03-12','12:05:00',1.69),('7643','2013-03-12','12:10:00',1.46),('7643','2013-03-12','12:15:00',1.58),('7643','2013-03-12','12:20:00',1.63),('7643','2013-03-12','12:25:00',1.87),('7643','2013-03-12','12:30:00',2.54),('7643','2013-03-12','12:35:00',2.86),('7643','2013-03-12','12:40:00',3.12),('7643','2013-03-12','12:45:00',4.06),('7643','2013-03-12','12:50:00',5.02),('7643','2013-03-12','12:55:00',4.48),('7643','2013-03-12','13:00:00',4.36),('7643','2013-03-12','13:05:00',4.18),('7643','2013-03-12','13:10:00',3.78),('7643','2013-03-12','13:15:00',3.31),('7643','2013-03-12','13:20:00',2.79),('7643','2013-03-12','13:25:00',2.51),('7643','2013-03-12','13:30:00',2.85),('7643','2013-03-12','13:35:00',3.71),('7643','2013-03-12','13:40:00',3.22),('7643','2013-03-12','13:45:00',2.86),('7643','2013-03-12','13:50:00',2.69),('7643','2013-03-12','13:55:00',2.51),('7643','2013-03-12','14:00:00',2.14),('7643','2013-03-12','14:05:00',2.11),('7643','2013-03-12','14:10:00',1.9),('7643','2013-03-12','14:15:00',1.58),('7643','2013-03-12','14:20:00',1.47),('7643','2013-03-12','14:25:00',2.16),('7643','2013-03-12','14:30:00',2.39),('7643','2013-03-12','14:35:00',2.22),('7643','2013-03-12','14:40:00',2.17),('7643','2013-03-12','14:45:00',2.69),('7643','2013-03-12','14:50:00',2.98),('7643','2013-03-12','14:55:00',2.49),('7643','2013-03-12','15:00:00',2.64),('7643','2013-03-12','15:05:00',3.04),('7643','2013-03-12','15:10:00',3.12),('7643','2013-03-12','15:15:00',2.25),('7643','2013-03-12','15:20:00',1.32),('7643','2013-03-12','15:25:00',1.33),('7643','2013-03-12','15:30:00',1.09),('7643','2014-03-24','06:35:00',1.23),('7643','2014-03-24','06:40:00',1.53),('7643','2014-03-24','06:45:00',1.84),('7643','2014-03-24','06:50:00',2.02),('7643','2014-03-24','06:55:00',2.36),('7643','2014-03-24','07:00:00',2.21),('7643','2014-03-24','07:05:00',2.38),('7643','2014-03-24','07:10:00',3.54),('7643','2014-03-24','07:15:00',4.38),('7643','2014-03-24','07:20:00',5.13),('7643','2014-03-24','07:25:00',5.58),('7643','2014-03-24','07:30:00',6.02),('7643','2014-03-24','07:35:00',4.73),('7643','2014-03-24','07:40:00',4.37),('7643','2014-03-24','07:45:00',4.79),('7643','2014-03-24','07:50:00',5.13),('7643','2014-03-24','07:55:00',5.17),('7643','2014-03-24','08:00:00',4.88),('7643','2014-03-24','08:05:00',5.02),('7643','2014-03-24','08:10:00',5.4),('7643','2014-03-24','08:15:00',5.72),('7643','2014-03-24','08:20:00',5.18),('7643','2014-03-24','08:25:00',4.63),('7643','2014-03-24','08:30:00',4.12),('7643','2014-03-24','08:35:00',4.18),('7643','2014-03-24','08:40:00',5.03),('7643','2014-03-24','08:45:00',7.11),('7643','2014-03-24','08:50:00',7.6),('7643','2014-03-24','08:55:00',8.05),('7643','2014-03-24','09:00:00',7.25),('7643','2014-03-24','09:05:00',7.02),('7643','2014-03-24','09:10:00',7.13),('7643','2014-03-24','09:15:00',9.33),('7643','2014-03-24','09:20:00',10.14),('7643','2014-03-24','09:25:00',8.81),('7643','2014-03-24','09:30:00',7.79),('7643','2014-03-24','09:35:00',7.19),('7643','2014-03-24','09:40:00',7.35),('7643','2014-03-24','09:45:00',6.82),('7643','2014-03-24','09:50:00',7.03),('7643','2014-03-24','09:55:00',8.08),('7643','2014-03-24','10:00:00',9.42),('7643','2014-03-24','10:05:00',10),('7643','2014-03-24','10:10:00',10.67),('7643','2014-03-24','10:15:00',11.63),('7643','2014-03-24','10:20:00',11.6),('7643','2014-03-24','10:25:00',11.21),('7643','2014-03-24','10:30:00',12.05),('7643','2014-03-24','10:35:00',10.05),('7643','2014-03-24','10:40:00',8.27),('7643','2014-03-24','10:45:00',7.52),('7643','2014-03-24','10:50:00',7.33),('7643','2014-03-24','10:55:00',7.32),('7643','2014-03-24','11:00:00',7.83),('7643','2014-03-24','11:05:00',8.91),('7643','2014-03-24','11:10:00',10),('7643','2014-03-24','11:15:00',11.59),('7643','2014-03-24','11:20:00',12.32),('7643','2014-03-24','11:25:00',11.21),('7643','2014-03-24','11:30:00',8.47),('7643','2014-03-24','11:35:00',12.16),('7643','2014-03-24','11:40:00',9.01),('7643','2014-03-24','11:45:00',9.42),('7643','2014-03-24','11:50:00',7.58),('7643','2014-03-24','11:55:00',6.65),('7643','2014-03-24','12:00:00',4.81),('7643','2014-03-24','12:05:00',3.14),('7643','2014-03-24','12:10:00',3.16),('7643','2014-03-24','12:15:00',3.67),('7643','2014-03-24','12:20:00',4.94),('7643','2014-03-24','12:25:00',5.21),('7643','2014-03-24','12:30:00',3.7),('7643','2014-03-24','12:35:00',2.65),('7643','2014-03-24','12:40:00',2.44),('7643','2014-03-24','12:45:00',1.9),('7643','2014-03-24','12:50:00',1.12),('7643','2014-03-24','13:05:00',1.03),('7643','2014-03-24','13:10:00',1.32),('7643','2014-03-24','13:15:00',1.47),('7643','2014-03-24','13:20:00',1.55),('7643','2014-03-24','13:25:00',1.75),('7643','2014-03-24','13:30:00',2.74),('7643','2014-03-24','13:35:00',3.7),('7643','2014-03-24','13:40:00',3.52),('7643','2014-03-24','13:45:00',3.09),('7643','2014-03-24','13:50:00',3.04),('7643','2014-03-24','13:55:00',2.9),('7643','2014-03-24','14:00:00',2.52),('7643','2014-03-24','14:05:00',2.82),('7643','2014-03-24','14:10:00',3.36),('7643','2014-03-24','14:15:00',3.53),('7643','2014-03-24','14:20:00',2.59),('7643','2014-03-24','14:25:00',1.98),('7643','2014-03-24','14:30:00',2.03),('7643','2014-03-24','14:35:00',2.39),('7643','2014-03-24','14:40:00',2.19),('7643','2014-03-24','14:45:00',2.26),('7643','2014-03-24','14:50:00',1.77),('7643','2014-03-24','14:55:00',1.73),('7643','2014-03-24','15:00:00',1.82),('7643','2014-03-24','15:05:00',1.34),('7643','2014-03-24','15:10:00',1.34),('7643','2014-03-24','15:15:00',2.22),('7643','2014-03-24','15:20:00',2.12),('7643','2014-03-24','15:25:00',1.78),('7643','2014-03-24','15:30:00',1.49),('7643','2014-03-24','15:35:00',1.5),('7643','2014-03-24','15:40:00',1.29),('7643','2014-03-24','15:45:00',1.32),('7643','2014-03-24','15:50:00',1.1),('7643','2014-03-24','15:55:00',1.25),('7643','2014-03-24','16:00:00',1.06),('7643','2013-03-11','08:15:00',1.26),('7643','2013-03-11','08:20:00',7.02),('7643','2013-03-11','08:25:00',7.4),('7643','2013-03-11','08:30:00',7.71),('7643','2013-03-11','08:35:00',7.36),('7643','2013-03-11','08:40:00',7.38),('7643','2013-03-11','08:45:00',9.77),('7643','2013-03-11','08:50:00',6.88),('7643','2013-03-11','08:55:00',2.74),('7643','2013-03-11','09:00:00',5.29),('7643','2013-03-11','09:05:00',10.24),('7643','2013-03-11','09:10:00',10.43),('7643','2013-03-11','09:15:00',10.65),('7643','2013-03-11','09:20:00',10.88),('7643','2013-03-11','09:25:00',11.19),('7643','2013-03-11','09:30:00',11.58),('7643','2013-03-11','09:35:00',11.74),('7643','2013-03-11','09:40:00',11.53),('7643','2013-03-11','09:45:00',10.11),('7643','2013-03-11','09:50:00',5.04),('7643','2013-03-11','09:55:00',11.76),('7643','2013-03-11','10:00:00',9.82),('7643','2013-03-11','10:05:00',10.83),('7643','2013-03-11','10:10:00',13.87),('7643','2013-03-11','10:15:00',14.57),('7643','2013-03-11','10:20:00',6.58),('7643','2013-03-11','10:25:00',10.97),('7643','2013-03-11','10:30:00',5.17),('7643','2013-03-11','10:35:00',9.58),('7643','2013-03-11','10:40:00',10.46),('7643','2013-03-11','10:45:00',7.2),('7643','2013-03-11','10:50:00',10.71),('7643','2013-03-11','10:55:00',14.59),('7643','2013-03-11','11:00:00',16.28),('7643','2013-03-11','11:05:00',17.1),('7643','2013-03-11','11:10:00',11.6),('7643','2013-03-11','11:15:00',13.49),('7643','2013-03-11','11:20:00',14.93),('7643','2013-03-11','11:25:00',7.19),('7643','2013-03-11','11:30:00',5.59),('7643','2013-03-11','11:35:00',7.03),('7643','2013-03-11','11:40:00',8.29),('7643','2013-03-11','11:45:00',8.75),('7643','2013-03-11','11:50:00',9.68),('7643','2013-03-11','11:55:00',12.18),('7643','2013-03-11','12:00:00',3.48),('7643','2013-03-11','12:05:00',2.45),('7643','2013-03-11','12:10:00',12.97),('7643','2013-03-11','12:15:00',9.61),('7643','2013-03-11','12:20:00',9.29),('7643','2013-03-11','12:25:00',7.32),('7643','2013-03-11','12:30:00',13.39),('7643','2013-03-11','12:35:00',9.85),('7643','2013-03-11','12:40:00',16.6),('7643','2013-03-11','12:45:00',5.72),('7643','2013-03-11','12:50:00',7.56),('7643','2013-03-11','12:55:00',12.97),('7643','2013-03-11','13:00:00',12.96),('7643','2013-03-11','13:05:00',17.28),('7643','2013-03-11','13:10:00',10.21),('7643','2013-03-11','13:15:00',5.2),('7643','2013-03-11','13:20:00',10.87),('7643','2013-03-11','13:25:00',8.67),('7643','2013-03-11','13:30:00',5.15),('7643','2013-03-11','13:35:00',6.39),('7643','2013-03-11','13:40:00',4.53),('7643','2013-03-11','13:45:00',3.16),('7643','2013-03-11','13:50:00',3.6),('7643','2013-03-11','13:55:00',5.74),('7643','2013-03-11','14:00:00',6.88),('7643','2013-03-11','14:05:00',14.26),('7643','2013-03-11','14:10:00',8.31),('7643','2013-03-11','14:15:00',4.03),('7643','2013-03-11','14:20:00',3.99),('7643','2013-03-11','14:25:00',1.78),('7643','2013-03-11','14:30:00',2.02),('7643','2013-03-11','14:35:00',2.93),('7643','2013-03-11','14:40:00',1.33),('7643','2013-03-11','15:00:00',2.45),('7643','2013-03-11','15:05:00',1.59),('7643','2013-03-11','15:10:00',2.61),('7643','2013-03-11','15:15:00',2.17),('7643','2013-03-11','15:20:00',2.82),('7643','2013-03-11','15:25:00',2.92),('7643','2013-03-11','15:30:00',2.24),('7643','2013-03-11','15:35:00',1.84),('7643','2013-03-11','15:40:00',1.17),('7643','2013-03-11','15:50:00',1.4),('7643','2013-03-10','07:05:00',1.15),('7643','2013-03-10','07:10:00',1.51),('7643','2013-03-10','07:15:00',1.92),('7643','2013-03-10','07:20:00',2.25),('7643','2013-03-10','07:25:00',2.75),('7643','2013-03-10','07:30:00',3.09),('7643','2013-03-10','07:35:00',2.69),('7643','2013-03-10','07:40:00',3.14),('7643','2013-03-10','07:45:00',2.86),('7643','2013-03-10','07:50:00',1.79),('7643','2013-03-10','07:55:00',1.29),('7643','2013-03-10','08:00:00',2.18),('7643','2013-03-10','08:05:00',1.69),('7643','2013-03-10','08:10:00',6.07),('7643','2013-03-10','08:15:00',6.48),('7643','2013-03-10','08:20:00',6.84),('7643','2013-03-10','08:25:00',7.25),('7643','2013-03-10','08:30:00',7.57),('7643','2013-03-10','08:35:00',7.98),('7643','2013-03-10','08:40:00',8.23),('7643','2013-03-10','08:45:00',8.56),('7643','2013-03-10','08:50:00',8.92),('7643','2013-03-10','08:55:00',9.19),('7643','2013-03-10','09:00:00',9.44),('7643','2013-03-10','09:05:00',9.81),('7643','2013-03-10','09:10:00',10.01),('7643','2013-03-10','09:15:00',10.51),('7643','2013-03-10','09:20:00',9.58),('7643','2013-03-10','09:25:00',6.33),('7643','2013-03-10','09:30:00',4.96),('7643','2013-03-10','09:35:00',12.67),('7643','2013-03-10','09:40:00',12.76),('7643','2013-03-10','09:45:00',9.28),('7643','2013-03-10','09:50:00',6.08),('7643','2013-03-10','09:55:00',3.37),('7643','2013-03-10','10:00:00',3.02),('7643','2013-03-10','10:05:00',3.41),('7643','2013-03-10','10:10:00',4.03),('7643','2013-03-10','10:15:00',4.06),('7643','2013-03-10','10:20:00',4.62),('7643','2013-03-10','10:25:00',5.4),('7643','2013-03-10','10:30:00',4.98),('7643','2013-03-10','10:35:00',6.61),('7643','2013-03-10','10:40:00',10.06),('7643','2013-03-10','10:45:00',10.95),('7643','2013-03-10','10:50:00',13.05),('7643','2013-03-10','10:55:00',7.47),('7643','2013-03-10','11:00:00',5.86),('7643','2013-03-10','11:05:00',5.07),('7643','2013-03-10','11:10:00',5.92),('7643','2013-03-10','11:15:00',5.8),('7643','2013-03-10','11:20:00',4.98),('7643','2013-03-10','11:25:00',4.78),('7643','2013-03-10','11:30:00',7.19),('7643','2013-03-10','11:35:00',15.95),('7643','2013-03-10','11:40:00',9.66),('7643','2013-03-10','11:45:00',14.46),('7643','2013-03-10','11:50:00',8.47),('7643','2013-03-10','11:55:00',7.44),('7643','2013-03-10','12:00:00',6.64),('7643','2013-03-10','12:05:00',6.16),('7643','2013-03-10','12:10:00',5.33),('7643','2013-03-10','12:15:00',2.56),('7643','2013-03-10','12:20:00',3.06),('7643','2013-03-10','12:25:00',3.5),('7643','2013-03-10','12:30:00',3.7),('7643','2013-03-10','12:35:00',4.56),('7643','2013-03-10','12:40:00',4.65),('7643','2013-03-10','12:45:00',4.92),('7643','2013-03-10','12:50:00',11.18),('7643','2013-03-10','12:55:00',14.68),('7643','2013-03-10','13:00:00',8.65),('7643','2013-03-10','13:05:00',8.24),('7643','2013-03-10','13:10:00',15.88),('7643','2013-03-10','13:15:00',12.65),('7643','2013-03-10','13:20:00',12.12),('7643','2013-03-10','13:25:00',12.92),('7643','2013-03-10','13:30:00',13.79),('7643','2013-03-10','13:35:00',13.38),('7643','2013-03-10','13:40:00',8.38),('7643','2013-03-10','13:45:00',10.26),('7643','2013-03-10','13:50:00',14.58),('7643','2013-03-10','13:55:00',7.81),('7643','2013-03-10','14:00:00',3.88),('7643','2013-03-10','14:05:00',3.44),('7643','2013-03-10','14:10:00',3.01),('7643','2013-03-10','14:15:00',2.12),('7643','2013-03-10','14:20:00',1.93),('7643','2013-03-10','14:25:00',5.18),('7643','2013-03-10','14:30:00',4.44),('7643','2013-03-10','14:35:00',3.73),('7643','2013-03-10','14:40:00',4.5),('7643','2013-03-10','14:45:00',4.34),('7643','2013-03-10','14:50:00',2.29),('7643','2013-03-10','14:55:00',2.22),('7643','2013-03-10','15:00:00',2.06),('7643','2013-03-10','15:05:00',2.07),('7643','2013-03-10','15:10:00',1.96),('7643','2013-03-10','15:15:00',2.08),('7643','2013-03-10','15:20:00',2.22),('7643','2013-03-10','15:25:00',2.27),('7643','2013-03-10','15:30:00',2.85),('7643','2013-03-10','15:35:00',3.42),('7643','2013-03-10','15:40:00',4.01),('7643','2013-03-10','15:45:00',9.55),('7643','2013-03-10','15:50:00',9.01),('7643','2013-03-10','15:55:00',8.97),('7643','2013-03-10','16:00:00',7.48),('7643','2013-03-10','16:05:00',4.91),('7643','2013-03-10','16:10:00',5.89),('7643','2013-03-10','16:15:00',4.93),('7643','2013-03-10','16:20:00',6.16),('7643','2013-03-10','16:25:00',5.66),('7643','2013-03-10','16:30:00',5.66),('7643','2013-03-10','16:35:00',4.41),('7643','2013-03-10','16:40:00',3.03),('7643','2013-03-10','16:45:00',5.14),('7643','2013-03-10','16:50:00',4.03),('7643','2013-03-10','16:55:00',1.35),('7643','2013-03-10','17:05:00',1.72),('7643','2013-03-10','17:10:00',1.59),('7643','2013-03-10','17:15:00',1.71),('7643','2013-03-10','17:20:00',1.84),('7643','2013-03-10','17:25:00',1.58),('7643','2013-03-10','17:30:00',1.04),('7643','2013-03-09','07:05:00',1.2),('7643','2013-03-09','07:10:00',1.51),('7643','2013-03-09','07:15:00',1.64),('7643','2013-03-09','07:20:00',1.41),('7643','2013-03-09','07:25:00',1.34),('7643','2013-03-09','07:30:00',1.83),('7643','2013-03-09','07:35:00',3.02),('7643','2013-03-09','07:40:00',3.11),('7643','2013-03-09','07:45:00',3.63),('7643','2013-03-09','07:50:00',4.39),('7643','2013-03-09','07:55:00',4.95),('7643','2013-03-09','08:00:00',5.3),('7643','2013-03-09','08:05:00',5.75),('7643','2013-03-09','08:10:00',6.27),('7643','2013-03-09','08:15:00',6.38),('7643','2013-03-09','08:20:00',6.87),('7643','2013-03-09','08:25:00',7.23),('7643','2013-03-09','08:30:00',7.51),('7643','2013-03-09','08:35:00',7.86),('7643','2013-03-09','08:40:00',8.21),('7643','2013-03-09','08:45:00',8.5),('7643','2013-03-09','08:50:00',8.8),('7643','2013-03-09','08:55:00',9.15),('7643','2013-03-09','09:00:00',9.45),('7643','2013-03-09','09:05:00',9.74),('7643','2013-03-09','09:10:00',9.97),('7643','2013-03-09','09:15:00',10.3),('7643','2013-03-09','09:20:00',10.48),('7643','2013-03-09','09:25:00',10.75),('7643','2013-03-09','09:30:00',11.04),('7643','2013-03-09','09:35:00',11.35),('7643','2013-03-09','09:40:00',11.95),('7643','2013-03-09','09:45:00',12.63),('7643','2013-03-09','09:50:00',11.94),('7643','2013-03-09','09:55:00',13.9),('7643','2013-03-09','10:00:00',12.24),('7643','2013-03-09','10:05:00',6.43),('7643','2013-03-09','10:10:00',8.09),('7643','2013-03-09','10:15:00',7.37),('7643','2013-03-09','10:20:00',12.25),('7643','2013-03-09','10:25:00',4.94),('7643','2013-03-09','10:30:00',11.9),('7643','2013-03-09','10:35:00',12.74),('7643','2013-03-09','10:40:00',13.46),('7643','2013-03-09','10:45:00',9.98),('7643','2013-03-09','10:50:00',10.43),('7643','2013-03-09','10:55:00',10.83),('7643','2013-03-09','11:00:00',10.15),('7643','2013-03-09','11:05:00',10.76),('7643','2013-03-09','11:10:00',14.64),('7643','2013-03-09','11:15:00',5.58),('7643','2013-03-09','11:20:00',12.74),('7643','2013-03-09','11:25:00',16.77),('7643','2013-03-09','11:30:00',6.88),('7643','2013-03-09','11:35:00',12.3),('7643','2013-03-09','11:40:00',6.46),('7643','2013-03-09','11:45:00',6.4),('7643','2013-03-09','11:50:00',16.86),('7643','2013-03-09','11:55:00',15.87),('7643','2013-03-09','12:00:00',15.73),('7643','2013-03-09','12:05:00',15.37),('7643','2013-03-09','12:10:00',11.38),('7643','2013-03-09','12:15:00',13.39),('7643','2013-03-09','12:20:00',10.63),('7643','2013-03-09','12:25:00',12.76),('7643','2013-03-09','12:30:00',4.93),('7643','2013-03-09','12:35:00',5.15),('7643','2013-03-09','12:40:00',15.29),('7643','2013-03-09','12:45:00',16.93),('7643','2013-03-09','12:50:00',10.34),('7643','2013-03-09','12:55:00',15.99),('7643','2013-03-09','13:00:00',15.1),('7643','2013-03-09','13:05:00',13.8),('7643','2013-03-09','13:10:00',14.24),('7643','2013-03-09','13:15:00',14.74),('7643','2013-03-09','13:20:00',14.71),('7643','2013-03-09','13:25:00',13.49),('7643','2013-03-09','13:30:00',12.81),('7643','2013-03-09','13:35:00',14.14),('7643','2013-03-09','13:40:00',8),('7643','2013-03-09','13:45:00',9.26),('7643','2013-03-09','13:50:00',7.04),('7643','2013-03-09','13:55:00',6.69),('7643','2013-03-09','14:00:00',5.82),('7643','2013-03-09','14:05:00',7.3),('7643','2013-03-09','14:10:00',8.38),('7643','2013-03-09','14:15:00',9.75),('7643','2013-03-09','14:20:00',9.58),('7643','2013-03-09','14:25:00',7.24),('7643','2013-03-09','14:30:00',9.13),('7643','2013-03-09','14:35:00',13.51),('7643','2013-03-09','14:40:00',10.42),('7643','2013-03-09','14:45:00',6.1),('7643','2013-03-09','14:50:00',6.82),('7643','2013-03-09','14:55:00',6.28),('7643','2013-03-09','15:00:00',4.79),('7643','2013-03-09','15:05:00',5.29),('7643','2013-03-09','15:10:00',5.24),('7643','2013-03-09','15:15:00',3.37),('7643','2013-03-09','15:20:00',3.41),('7643','2013-03-09','15:25:00',2.17),('7643','2013-03-09','15:30:00',1.97),('7643','2013-03-09','15:35:00',2.1),('7643','2013-03-09','15:40:00',2.21),('7643','2013-03-09','15:45:00',2.15),('7643','2013-03-09','15:50:00',3.38),('7643','2013-03-09','15:55:00',2.73),('7643','2013-03-09','16:00:00',1.91),('7643','2013-03-09','16:05:00',1.48),('7643','2013-03-09','16:10:00',1.19),('7643','2013-03-08','07:35:00',1.16),('7643','2013-03-08','07:40:00',1.86),('7643','2013-03-08','07:45:00',1.73),('7643','2013-03-08','07:50:00',2.12),('7643','2013-03-08','07:55:00',2.74),('7643','2013-03-08','08:00:00',4.63),('7643','2013-03-08','08:05:00',6.38),('7643','2013-03-08','08:10:00',6.09),('7643','2013-03-08','08:15:00',6.29),('7643','2013-03-08','08:20:00',5.88),('7643','2013-03-08','08:25:00',7.02),('7643','2013-03-08','08:30:00',7.35),('7643','2013-03-08','08:35:00',7.18),('7643','2013-03-08','08:40:00',7.44),('7643','2013-03-08','08:45:00',3.73),('7643','2013-03-08','08:50:00',3.47),('7643','2013-03-08','08:55:00',3.89),('7643','2013-03-08','09:00:00',6.18),('7643','2013-03-08','09:05:00',2.71),('7643','2013-03-08','09:10:00',2.61),('7643','2013-03-08','09:15:00',3.7),('7643','2013-03-08','09:20:00',2.98),('7643','2013-03-08','09:25:00',4.74),('7643','2013-03-08','09:30:00',6.79),('7643','2013-03-08','09:35:00',6.07),('7643','2013-03-08','09:40:00',13.37),('7643','2013-03-08','09:45:00',11.08),('7643','2013-03-08','09:50:00',8.95),('7643','2013-03-08','09:55:00',14.19),('7643','2013-03-08','10:00:00',6.05),('7643','2013-03-08','10:05:00',4.68),('7643','2013-03-08','10:10:00',5.44),('7643','2013-03-08','10:15:00',4.29),('7643','2013-03-08','10:20:00',8.14),('7643','2013-03-08','10:25:00',4.71),('7643','2013-03-08','10:30:00',4.98),('7643','2013-03-08','10:35:00',4.36),('7643','2013-03-08','10:40:00',8.54),('7643','2013-03-08','10:45:00',5.92),('7643','2013-03-08','10:50:00',12.15),('7643','2013-03-08','10:55:00',7.99),('7643','2013-03-08','11:00:00',9.9),('7643','2013-03-08','11:05:00',8.69),('7643','2013-03-08','11:10:00',11.88),('7643','2013-03-08','11:15:00',16.12),('7643','2013-03-08','11:20:00',15.39),('7643','2013-03-08','11:25:00',10.13),('7643','2013-03-08','11:30:00',8.21),('7643','2013-03-08','11:35:00',16.14),('7643','2013-03-08','11:40:00',10.09),('7643','2013-03-08','11:45:00',8.02),('7643','2013-03-08','11:50:00',15.98),('7643','2013-03-08','11:55:00',14.78),('7643','2013-03-08','12:00:00',11.66),('7643','2013-03-08','12:05:00',10.06),('7643','2013-03-08','12:10:00',8.75),('7643','2013-03-08','12:15:00',5.08),('7643','2013-03-08','12:20:00',6.13),('7643','2013-03-08','12:25:00',6.73),('7643','2013-03-08','12:30:00',5.25),('7643','2013-03-08','12:35:00',7.81),('7643','2013-03-08','12:40:00',5.42),('7643','2013-03-08','12:45:00',9.66),('7643','2013-03-08','12:50:00',8.01),('7643','2013-03-08','12:55:00',13.34),('7643','2013-03-08','13:00:00',15.26),('7643','2013-03-08','13:05:00',13.58),('7643','2013-03-08','13:10:00',12.9),('7643','2013-03-08','13:15:00',17.04),('7643','2013-03-08','13:20:00',14.67),('7643','2013-03-08','13:25:00',7.66),('7643','2013-03-08','13:30:00',15.02),('7643','2013-03-08','13:35:00',5.76),('7643','2013-03-08','13:40:00',5.26),('7643','2013-03-08','13:45:00',9.09),('7643','2013-03-08','13:50:00',8.62),('7643','2013-03-08','13:55:00',4.19),('7643','2013-03-08','14:00:00',4.96),('7643','2013-03-08','14:05:00',14.99),('7643','2013-03-08','14:10:00',14.43),('7643','2013-03-08','14:15:00',13.23),('7643','2013-03-08','14:20:00',12.68),('7643','2013-03-08','14:25:00',12.4),('7643','2013-03-08','14:30:00',12.28),('7643','2013-03-08','14:35:00',11.97),('7643','2013-03-08','14:40:00',11.73),('7643','2013-03-08','14:45:00',11.48),('7643','2013-03-08','14:50:00',11.22),('7643','2013-03-08','14:55:00',11.02),('7643','2013-03-08','15:00:00',10.78),('7643','2013-03-08','15:05:00',10.54),('7643','2013-03-08','15:10:00',10.28),('7643','2013-03-08','15:15:00',9.96),('7643','2013-03-08','15:20:00',9.65),('7643','2013-03-08','15:25:00',9.29),('7643','2013-03-08','15:30:00',9.03),('7643','2013-03-08','15:35:00',8.56),('7643','2013-03-08','15:40:00',8.52),('7643','2013-03-08','15:45:00',8.18),('7643','2013-03-08','15:50:00',7.74),('7643','2013-03-08','15:55:00',6.95),('7643','2013-03-08','16:00:00',6.42),('7643','2013-03-08','16:05:00',6.6),('7643','2013-03-08','16:10:00',5.5),('7643','2013-03-08','16:15:00',6.1),('7643','2013-03-08','16:20:00',5.09),('7643','2013-03-08','16:25:00',5.68),('7643','2013-03-08','16:30:00',4.96),('7643','2013-03-08','16:35:00',4.02),('7643','2013-03-08','16:40:00',3.57),('7643','2013-03-08','16:45:00',2.65),('7643','2013-03-08','16:50:00',2.41),('7643','2013-03-08','16:55:00',1.29),('7643','2013-03-08','17:00:00',1.14),('7643','2013-03-08','17:05:00',1.03),('7643','2013-03-07','07:50:00',1.31),('7643','2013-03-07','07:55:00',1.09),('7643','2013-03-07','08:05:00',1.46),('7643','2013-03-07','08:10:00',4.05),('7643','2013-03-07','08:15:00',3.76),('7643','2013-03-07','08:20:00',2.12),('7643','2013-03-07','08:25:00',2.64),('7643','2013-03-07','08:30:00',5.31),('7643','2013-03-07','08:35:00',6.06),('7643','2013-03-07','08:40:00',3.13),('7643','2013-03-07','08:45:00',2.54),('7643','2013-03-07','08:50:00',4.47),('7643','2013-03-07','08:55:00',4.01),('7643','2013-03-07','09:00:00',2.48),('7643','2013-03-07','09:05:00',2.07),('7643','2013-03-07','09:10:00',2.57),('7643','2013-03-07','09:15:00',3.55),('7643','2013-03-07','09:20:00',2.94),('7643','2013-03-07','09:25:00',2.82),('7643','2013-03-07','09:30:00',5.94),('7643','2013-03-07','09:35:00',6.54),('7643','2013-03-07','09:40:00',4.72),('7643','2013-03-07','09:45:00',9.77),('7643','2013-03-07','09:50:00',10.56),('7643','2013-03-07','09:55:00',6.97),('7643','2013-03-07','10:00:00',3.73),('7643','2013-03-07','10:05:00',3.98),('7643','2013-03-07','10:10:00',4.86),('7643','2013-03-07','10:15:00',5.3),('7643','2013-03-07','10:20:00',6.01),('7643','2013-03-07','10:25:00',5.35),('7643','2013-03-07','10:30:00',7.44),('7643','2013-03-07','10:35:00',12.21),('7643','2013-03-07','10:40:00',8.09),('7643','2013-03-07','10:45:00',4.27),('7643','2013-03-07','10:50:00',5.17),('7643','2013-03-07','10:55:00',4.43),('7643','2013-03-07','11:00:00',4.14),('7643','2013-03-07','11:05:00',3.01),('7643','2013-03-07','11:10:00',1.97),('7643','2013-03-07','11:15:00',1.66),('7643','2013-03-07','11:20:00',1.79),('7643','2013-03-07','11:25:00',1.95),('7643','2013-03-07','11:30:00',2.81),('7643','2013-03-07','11:35:00',7.31),('7643','2013-03-07','11:40:00',9.41),('7643','2013-03-07','11:45:00',7.68),('7643','2013-03-07','11:50:00',6.66),('7643','2013-03-07','11:55:00',6.94),('7643','2013-03-07','12:00:00',7.19),('7643','2013-03-07','12:05:00',4.19),('7643','2013-03-07','12:10:00',3.21),('7643','2013-03-07','12:15:00',3.37),('7643','2013-03-07','12:20:00',5.39),('7643','2013-03-07','12:25:00',4.38),('7643','2013-03-07','12:30:00',3.99),('7643','2013-03-07','12:35:00',5.74),('7643','2013-03-07','12:40:00',8.79),('7643','2013-03-07','12:45:00',9.52),('7643','2013-03-07','12:50:00',9.69),('7643','2013-03-07','12:55:00',7.67),('7643','2013-03-07','13:00:00',8.47),('7643','2013-03-07','13:05:00',9.49),('7643','2013-03-07','13:10:00',5.6),('7643','2013-03-07','13:15:00',4.55),('7643','2013-03-07','13:20:00',4.37),('7643','2013-03-07','13:25:00',5.63),('7643','2013-03-07','13:30:00',6.94),('7643','2013-03-07','13:35:00',4.98),('7643','2013-03-07','13:40:00',4.57),('7643','2013-03-07','13:45:00',2.6),('7643','2013-03-07','13:50:00',2.26),('7643','2013-03-07','13:55:00',3.45),('7643','2013-03-07','14:00:00',2.01),('7643','2013-03-07','15:55:00',1.04),('7643','2013-03-07','16:00:00',1.21),('7643','2013-03-07','16:05:00',1.24),('7643','2013-03-07','16:10:00',1.17),('7643','2013-03-07','16:35:00',1.08),('7643','2013-03-07','16:40:00',1.38),('7643','2013-03-07','16:45:00',1.16),('7643','2013-03-07','16:50:00',1.72),('7643','2013-03-07','16:55:00',2.29),('7643','2013-03-07','17:00:00',2.02),('7643','2013-03-07','17:05:00',1.91),('7643','2013-03-07','17:10:00',4.04),('7643','2013-03-07','17:15:00',4.35),('7643','2013-03-07','17:20:00',2.09),('7643','2013-03-07','17:25:00',1.37),('7643','2013-03-06','08:15:00',1.13),('7643','2013-03-06','08:20:00',1.43),('7643','2013-03-06','08:25:00',1.4),('7643','2013-03-06','08:30:00',1.35),('7643','2013-03-06','08:35:00',2.21),('7643','2013-03-06','08:40:00',3.23),('7643','2013-03-06','08:45:00',3.12),('7643','2013-03-06','08:50:00',3.78),('7643','2013-03-06','08:55:00',3.02),('7643','2013-03-06','09:00:00',2.97),('7643','2013-03-06','09:05:00',3.08),('7643','2013-03-06','09:10:00',2.39),('7643','2013-03-06','09:15:00',2.77),('7643','2013-03-06','09:20:00',3.7),('7643','2013-03-06','09:25:00',1.84),('7643','2013-03-06','09:30:00',1.74),('7643','2013-03-06','09:45:00',1.26),('7643','2013-03-06','09:50:00',1.43),('7643','2013-03-06','09:55:00',1.99),('7643','2013-03-06','10:00:00',1.7),('7643','2013-03-06','10:05:00',1.03),('7643','2013-03-06','10:10:00',1.34),('7643','2013-03-06','10:15:00',1.29),('7643','2013-03-06','10:20:00',1),('7643','2013-03-06','10:25:00',2.1),('7643','2013-03-06','10:30:00',3.4),('7643','2013-03-06','10:35:00',1.94),('7643','2013-03-06','10:40:00',1.74),('7643','2013-03-06','10:45:00',1.76),('7643','2013-03-06','10:50:00',3.64),('7643','2013-03-06','10:55:00',4.42),('7643','2013-03-06','11:00:00',3.9),('7643','2013-03-06','11:05:00',5.48),('7643','2013-03-06','11:10:00',4.07),('7643','2013-03-06','11:15:00',2.41),('7643','2013-03-06','11:20:00',1.87),('7643','2013-03-06','11:25:00',2.81),('7643','2013-03-06','11:30:00',5.42),('7643','2013-03-06','11:35:00',6.65),('7643','2013-03-06','11:40:00',5.86),('7643','2013-03-06','11:45:00',6.15),('7643','2013-03-06','11:50:00',6.42),('7643','2013-03-06','11:55:00',5.12),('7643','2013-03-06','12:00:00',4.03),('7643','2013-03-06','12:05:00',3.83),('7643','2013-03-06','12:10:00',2.01),('7643','2013-03-06','12:20:00',1.5),('7643','2013-03-06','12:25:00',3.2),('7643','2013-03-06','12:30:00',3.68),('7643','2013-03-06','12:35:00',3.5),('7643','2013-03-06','12:40:00',5.66),('7643','2013-03-06','12:45:00',7.77),('7643','2013-03-06','12:50:00',6.32),('7643','2013-03-06','12:55:00',5.67),('7643','2013-03-06','13:00:00',6.14),('7643','2013-03-06','13:05:00',5.51),('7643','2013-03-06','13:10:00',4.56),('7643','2013-03-06','13:15:00',5.95),('7643','2013-03-06','13:20:00',7.59),('7643','2013-03-06','13:25:00',6.7),('7643','2013-03-06','13:30:00',5.91),('7643','2013-03-06','13:35:00',4.97),('7643','2013-03-06','13:40:00',2.86),('7643','2013-03-06','13:45:00',2.26),('7643','2013-03-06','13:50:00',2.34),('7643','2013-03-06','13:55:00',2.72),('7643','2013-03-06','14:00:00',2.26),('7643','2013-03-06','14:05:00',3.34),('7643','2013-03-06','14:10:00',3.45),('7643','2013-03-06','14:15:00',2.56),('7643','2013-03-06','14:20:00',2.59),('7643','2013-03-06','14:25:00',2.58),('7643','2013-03-06','14:30:00',2.45),('7643','2013-03-06','14:35:00',1.52),('7643','2013-03-06','14:40:00',1.38),('7643','2013-03-06','14:45:00',2.39),('7643','2013-03-06','14:50:00',2.36),('7643','2013-03-06','14:55:00',2),('7643','2013-03-06','15:20:00',2.12),('7643','2013-03-06','15:25:00',2.5),('7643','2013-03-06','15:30:00',1.89),('7643','2013-03-06','15:35:00',2.03),('7643','2013-03-06','15:40:00',2.57),('7643','2013-03-06','15:45:00',2.12),('7643','2013-03-06','15:50:00',1.61),('7643','2013-03-06','15:55:00',1.81),('7643','2013-03-06','16:00:00',1.62),('7643','2013-03-06','16:05:00',2.62),('7643','2013-03-06','16:10:00',2.57),('7643','2013-03-06','16:15:00',2.31),('7643','2013-03-06','16:20:00',2.2),('7643','2013-03-06','16:25:00',1.98),('7643','2013-03-06','16:30:00',1.74),('7643','2013-03-06','16:35:00',2.21),('7643','2013-03-06','16:40:00',4.16),('7643','2013-03-06','16:45:00',2.5),('7643','2013-03-06','16:50:00',1.5),('7643','2013-03-05','07:45:00',1.03),('7643','2013-03-05','07:50:00',1.08),('7643','2013-03-05','08:20:00',1.51),('7643','2013-03-05','08:25:00',1.93),('7643','2013-03-05','08:30:00',1.86),('7643','2013-03-05','08:35:00',1.88),('7643','2013-03-05','08:40:00',1.2),('7643','2013-03-05','09:00:00',1.05),('7643','2013-03-05','09:05:00',1.71),('7643','2013-03-05','09:10:00',2.06),('7643','2013-03-05','09:15:00',1.48),('7643','2013-03-05','09:20:00',1.71),('7643','2013-03-05','09:25:00',2.06),('7643','2013-03-05','09:30:00',1.56),('7643','2013-03-05','09:35:00',1.05),('7643','2013-03-05','09:40:00',1.12),('7643','2013-03-05','09:45:00',1.49),('7643','2013-03-05','09:50:00',1.69),('7643','2013-03-05','09:55:00',1.62),('7643','2013-03-05','10:00:00',1.13),('7643','2013-03-05','10:05:00',1.16),('7643','2013-03-05','10:10:00',1.07),('7643','2013-03-05','10:50:00',1.1),('7643','2013-03-05','11:40:00',1),('7643','2013-03-05','11:45:00',1.15),('7643','2013-03-05','11:50:00',1.34),('7643','2013-03-05','11:55:00',1.43),('7643','2013-03-05','12:00:00',1.33),('7643','2013-03-05','15:20:00',1.13),('7643','2013-03-05','15:35:00',1.17),('7643','2013-03-05','15:40:00',1.66),('7643','2013-03-05','15:45:00',1.35),('7643','2013-03-05','15:50:00',1.48),('7643','2013-03-05','15:55:00',1.75),('7643','2013-03-05','16:00:00',2.04),('7643','2013-03-05','16:05:00',2.06),('7643','2013-03-05','16:10:00',1.73),('7643','2013-03-05','16:15:00',1.53),('7643','2013-03-05','16:20:00',1.4),('7643','2013-03-05','16:25:00',1.27),('7643','2013-03-05','16:30:00',1.19),('7643','2013-03-05','16:35:00',1.22),('7643','2013-03-04','07:05:00',1.1),('7643','2013-03-04','07:10:00',1.12),('7643','2013-03-04','07:30:00',1.3),('7643','2013-03-04','07:35:00',1.95),('7643','2013-03-04','07:40:00',1.84),('7643','2013-03-04','07:45:00',1.94),('7643','2013-03-04','07:50:00',1.89),('7643','2013-03-04','07:55:00',1.9),('7643','2013-03-04','08:00:00',2.16),('7643','2013-03-04','08:05:00',2.93),('7643','2013-03-04','08:10:00',3.58),('7643','2013-03-04','08:15:00',5.11),('7643','2013-03-04','08:20:00',3.93),('7643','2013-03-04','08:25:00',5.27),('7643','2013-03-04','08:30:00',7.97),('7643','2013-03-04','08:35:00',6.68),('7643','2013-03-04','08:40:00',7.03),('7643','2013-03-04','08:45:00',5.74),('7643','2013-03-04','08:50:00',6.34),('7643','2013-03-04','08:55:00',5.86),('7643','2013-03-04','09:00:00',6.41),('7643','2013-03-04','09:05:00',6.53),('7643','2013-03-04','09:10:00',6.09),('7643','2013-03-04','09:15:00',5.73),('7643','2013-03-04','09:20:00',5.68),('7643','2013-03-04','09:25:00',5.58),('7643','2013-03-04','09:30:00',5.9),('7643','2013-03-04','09:35:00',6.39),('7643','2013-03-04','09:40:00',6.79),('7643','2013-03-04','09:45:00',6.87),('7643','2013-03-04','09:50:00',6.96),('7643','2013-03-04','09:55:00',6.56),('7643','2013-03-04','10:00:00',6.25),('7643','2013-03-04','10:05:00',6.95),('7643','2013-03-04','10:10:00',7.24),('7643','2013-03-04','10:15:00',7.51),('7643','2013-03-04','10:20:00',8.23),('7643','2013-03-04','10:25:00',7.67),('7643','2013-03-04','10:30:00',7.33),('7643','2013-03-04','10:35:00',8.88),('7643','2013-03-04','10:40:00',9.13),('7643','2013-03-04','10:45:00',9.49),('7643','2013-03-04','10:50:00',10.14),('7643','2013-03-04','10:55:00',10.39),('7643','2013-03-04','11:00:00',9.64),('7643','2013-03-04','11:05:00',10.34),('7643','2013-03-04','11:10:00',10.81),('7643','2013-03-04','11:15:00',10.61),('7643','2013-03-04','11:20:00',10.32),('7643','2013-03-04','11:25:00',9.88),('7643','2013-03-04','11:30:00',10),('7643','2013-03-04','11:35:00',10.98),('7643','2013-03-04','11:40:00',12.16),('7643','2013-03-04','11:45:00',11.75),('7643','2013-03-04','11:50:00',11.77),('7643','2013-03-04','11:55:00',12.03),('7643','2013-03-04','12:00:00',12.46),('7643','2013-03-04','12:05:00',12.8),('7643','2013-03-04','12:10:00',13.23),('7643','2013-03-04','12:15:00',10.71),('7643','2013-03-04','12:20:00',12.11),('7643','2013-03-04','12:25:00',12.13),('7643','2013-03-04','12:30:00',10.31),('7643','2013-03-04','12:35:00',10.37),('7643','2013-03-04','12:40:00',9.43),('7643','2013-03-04','12:45:00',10.27),('7643','2013-03-04','12:50:00',8.84),('7643','2013-03-04','12:55:00',7.98),('7643','2013-03-04','13:00:00',6.52),('7643','2013-03-04','13:05:00',6.2),('7643','2013-03-04','13:10:00',6.59),('7643','2013-03-04','13:15:00',7.05),('7643','2013-03-04','13:20:00',6.81),('7643','2013-03-04','13:25:00',6.07),('7643','2013-03-04','13:30:00',5.56),('7643','2013-03-04','13:35:00',5.24),('7643','2013-03-04','13:40:00',4.97),('7643','2013-03-04','13:45:00',4.51),('7643','2013-03-04','13:50:00',4.09),('7643','2013-03-04','13:55:00',3.83),('7643','2013-03-04','14:00:00',3.78),('7643','2013-03-04','14:05:00',3.88),('7643','2013-03-04','14:10:00',4.05),('7643','2013-03-04','14:15:00',3.8),('7643','2013-03-04','14:20:00',3.55),('7643','2013-03-04','14:25:00',3.59),('7643','2013-03-04','14:30:00',3.49),('7643','2013-03-04','14:35:00',3.53),('7643','2013-03-04','14:40:00',3.66),('7643','2013-03-04','14:45:00',3.76),('7643','2013-03-04','14:50:00',3.67),('7643','2013-03-04','14:55:00',3.31),('7643','2013-03-04','15:00:00',2.97),('7643','2013-03-04','15:05:00',2.76),('7643','2013-03-04','15:10:00',2.3),('7643','2013-03-04','15:15:00',1.94),('7643','2013-03-04','15:20:00',2.19),('7643','2013-03-04','15:25:00',2.58),('7643','2013-03-04','15:30:00',3.08),('7643','2013-03-04','15:35:00',3.22),('7643','2013-03-04','15:40:00',3.35),('7643','2013-03-04','15:45:00',4.21),('7643','2013-03-04','15:50:00',4.27),('7643','2013-03-04','15:55:00',3.54),('7643','2013-03-04','16:00:00',3.12),('7643','2013-03-04','16:05:00',2.7),('7643','2013-03-04','16:10:00',2.16),('7643','2013-03-04','16:15:00',1.93),('7643','2013-03-04','16:20:00',1.59),('7643','2013-03-04','16:25:00',1.27),('7643','2013-03-04','16:30:00',1.21),('7643','2013-03-04','16:35:00',1.15),('7643','2013-03-03','07:15:00',1.2),('7643','2013-03-03','07:20:00',1.48),('7643','2013-03-03','07:25:00',1.79),('7643','2013-03-03','07:30:00',2.12),('7643','2013-03-03','07:35:00',2.49),('7643','2013-03-03','07:40:00',2.88),('7643','2013-03-03','07:45:00',3.26),('7643','2013-03-03','07:50:00',3.63),('7643','2013-03-03','07:55:00',4.03),('7643','2013-03-03','08:00:00',4.42),('7643','2013-03-03','08:05:00',4.82),('7643','2013-03-03','08:10:00',5.22),('7643','2013-03-03','08:15:00',5.6),('7643','2013-03-03','08:20:00',5.93),('7643','2013-03-03','08:25:00',6.31),('7643','2013-03-03','08:30:00',6.68),('7643','2013-03-03','08:35:00',7.02),('7643','2013-03-03','08:40:00',7.39),('7643','2013-03-03','08:45:00',7.75),('7643','2013-03-03','08:50:00',8.06),('7643','2013-03-03','08:55:00',8.37),('7643','2013-03-03','09:00:00',8.65),('7643','2013-03-03','09:05:00',8.97),('7643','2013-03-03','09:10:00',9.27),('7643','2013-03-03','09:15:00',9.52),('7643','2013-03-03','09:20:00',9.8),('7643','2013-03-03','09:25:00',10.1),('7643','2013-03-03','09:30:00',10.39),('7643','2013-03-03','09:35:00',10.62),('7643','2013-03-03','09:40:00',10.91),('7643','2013-03-03','09:45:00',11.11),('7643','2013-03-03','09:50:00',11.36),('7643','2013-03-03','09:55:00',11.6),('7643','2013-03-03','10:00:00',11.84),('7643','2013-03-03','10:05:00',12.03),('7643','2013-03-03','10:10:00',12.2),('7643','2013-03-03','10:17:00',12.36),('7643','2013-03-03','10:20:00',12.53),('7643','2013-03-03','10:25:00',12.78),('7643','2013-03-03','10:30:00',12.95),('7643','2013-03-03','10:35:00',13.12),('7643','2013-03-03','10:40:00',13.22),('7643','2013-03-03','10:45:00',13.32),('7643','2013-03-03','10:50:00',13.53),('7643','2013-03-03','10:55:00',13.72),('7643','2013-03-03','11:00:00',13.65),('7643','2013-03-03','11:05:00',13.7),('7643','2013-03-03','11:10:00',13.71),('7643','2013-03-03','11:15:00',13.85),('7643','2013-03-03','11:20:00',13.84),('7643','2013-03-03','11:25:00',14.05),('7643','2013-03-03','11:30:00',14.13),('7643','2013-03-03','11:35:00',14.22),('7643','2013-03-03','11:40:00',14.24),('7643','2013-03-03','11:45:00',14.28),('7643','2013-03-03','11:50:00',14.11),('7643','2013-03-03','11:55:00',14.42),('7643','2013-03-03','12:00:00',14.33),('7643','2013-03-03','12:05:00',14.16),('7643','2013-03-03','12:10:00',14.19),('7643','2013-03-03','12:15:00',14.4),('7643','2013-03-03','12:20:00',14.46),('7643','2013-03-03','12:25:00',14.42),('7643','2013-03-03','12:30:00',14.34),('7643','2013-03-03','12:35:00',14.38),('7643','2013-03-03','12:40:00',14.35),('7643','2013-03-03','12:45:00',14.18),('7643','2013-03-03','12:50:00',14.18),('7643','2013-03-03','12:55:00',14.12),('7643','2013-03-03','13:00:00',13.55),('7643','2013-03-03','13:05:00',13.56),('7643','2013-03-03','13:10:00',13.49),('7643','2013-03-03','13:15:00',13.52),('7643','2013-03-03','13:20:00',13.47),('7643','2013-03-03','13:25:00',12.17),('7643','2013-03-03','13:30:00',13.16),('7643','2013-03-03','13:35:00',13.73),('7643','2013-03-03','13:40:00',12.89),('7643','2013-03-03','13:45:00',11.91),('7643','2013-03-03','13:50:00',12.87),('7643','2013-03-03','13:55:00',12.57),('7643','2013-03-03','14:00:00',12.43),('7643','2013-03-03','14:05:00',12.21),('7643','2013-03-03','14:10:00',11.79),('7643','2013-03-03','14:15:00',11.64),('7643','2013-03-03','14:20:00',10.82),('7643','2013-03-03','14:25:00',7.93),('7643','2013-03-03','14:30:00',9.7),('7643','2013-03-03','14:35:00',10.69),('7643','2013-03-03','14:40:00',10.69),('7643','2013-03-03','14:45:00',10.34),('7643','2013-03-03','14:50:00',10.01),('7643','2013-03-03','14:55:00',10.08),('7643','2013-03-03','15:00:00',9.69),('7643','2013-03-03','15:05:00',9.26),('7643','2013-03-03','15:10:00',9.19),('7643','2013-03-03','15:15:00',8.76),('7643','2013-03-03','15:20:00',8.49),('7643','2013-03-03','15:25:00',8.05),('7643','2013-03-03','15:30:00',7.89),('7643','2013-03-03','15:35:00',7.65),('7643','2013-03-03','15:40:00',7.45),('7643','2013-03-03','15:45:00',7.09),('7643','2013-03-03','15:50:00',6.64),('7643','2013-03-03','15:55:00',6.3),('7643','2013-03-03','16:00:00',6.11),('7643','2013-03-03','16:05:00',5.81),('7643','2013-03-03','16:10:00',5.39),('7643','2013-03-03','16:15:00',5.06),('7643','2013-03-03','16:20:00',4.8),('7643','2013-03-03','16:25:00',4.61),('7643','2013-03-03','16:30:00',4.32),('7643','2013-03-03','16:35:00',3.98),('7643','2013-03-03','16:40:00',3.6),('7643','2013-03-03','16:45:00',3.24),('7643','2013-03-03','16:50:00',2.9),('7643','2013-03-03','16:55:00',2.55),('7643','2013-03-03','17:00:00',2.22),('7643','2013-03-03','17:05:00',1.88),('7643','2013-03-03','17:10:00',1.62),('7643','2013-03-03','17:15:00',1.35),('7643','2013-03-03','17:20:00',1.1),('7643','2013-03-02','07:15:00',1.3),('7643','2013-03-02','07:20:00',1.64),('7643','2013-03-02','07:25:00',1.98),('7643','2013-03-02','07:30:00',2.37),('7643','2013-03-02','07:35:00',2.74),('7643','2013-03-02','07:40:00',3.14),('7643','2013-03-02','07:45:00',3.54),('7643','2013-03-02','07:50:00',3.9),('7643','2013-03-02','07:55:00',4.3),('7643','2013-03-02','08:00:00',4.69),('7643','2013-03-02','08:05:00',5.08),('7643','2013-03-02','08:10:00',5.47),('7643','2013-03-02','08:15:00',5.87),('7643','2013-03-02','08:20:00',6.26),('7643','2013-03-02','08:25:00',6.66),('7643','2013-03-02','08:30:00',7.03),('7643','2013-03-02','08:35:00',7.4),('7643','2013-03-02','08:40:00',7.76),('7643','2013-03-02','08:45:00',8.1),('7643','2013-03-02','08:50:00',8.43),('7643','2013-03-02','08:55:00',8.76),('7643','2013-03-02','09:00:00',9.05),('7643','2013-03-02','09:05:00',9.34),('7643','2013-03-02','09:10:00',9.62),('7643','2013-03-02','09:15:00',9.88),('7643','2013-03-02','09:20:00',10.19),('7643','2013-03-02','09:25:00',10.46),('7643','2013-03-02','09:30:00',10.76),('7643','2013-03-02','09:35:00',11.02),('7643','2013-03-02','09:40:00',11.28),('7643','2013-03-02','09:45:00',11.62),('7643','2013-03-02','09:50:00',11.98),('7643','2013-03-02','09:55:00',12.26),('7643','2013-03-02','10:00:00',12.5),('7643','2013-03-02','10:05:00',12.74),('7643','2013-03-02','10:10:00',12.93),('7643','2013-03-02','10:15:00',13.06),('7643','2013-03-02','10:20:00',13.3),('7643','2013-03-02','10:25:00',13.56),('7643','2013-03-02','10:30:00',13.67),('7643','2013-03-02','10:35:00',13.8),('7643','2013-03-02','10:40:00',13.96),('7643','2013-03-02','10:45:00',14.07),('7643','2013-03-02','10:50:00',14.14),('7643','2013-03-02','10:55:00',14.21),('7643','2013-03-02','11:00:00',14.26),('7643','2013-03-02','11:05:00',14.32),('7643','2013-03-02','11:10:00',14.34),('7643','2013-03-02','11:15:00',14.47),('7643','2013-03-02','11:20:00',14.56),('7643','2013-03-02','11:25:00',14.56),('7643','2013-03-02','11:30:00',14.6),('7643','2013-03-02','11:35:00',14.62),('7643','2013-03-02','11:40:00',14.77),('7643','2013-03-02','11:45:00',14.8),('7643','2013-03-02','11:50:00',14.95),('7643','2013-03-02','11:55:00',14.82),('7643','2013-03-02','12:00:00',14.82),('7643','2013-03-02','12:05:00',14.8),('7643','2013-03-02','12:10:00',14.81),('7643','2013-03-02','12:15:00',14.74),('7643','2013-03-02','12:20:00',14.76),('7643','2013-03-02','12:25:00',14.68),('7643','2013-03-02','12:30:00',14.7),('7643','2013-03-02','12:35:00',14.7),('7643','2013-03-02','12:40:00',14.73),('7643','2013-03-02','12:45:00',14.67),('7643','2013-03-02','12:50:00',14.62),('7643','2013-03-02','12:55:00',14.55),('7643','2013-03-02','13:00:00',14.45),('7643','2013-03-02','13:05:00',14.37),('7643','2013-03-02','13:10:00',14.31),('7643','2013-03-02','13:15:00',14.16),('7643','2013-03-02','13:20:00',14.06),('7643','2013-03-02','13:25:00',14.07),('7643','2013-03-02','13:30:00',13.98),('7643','2013-03-02','13:35:00',13.8),('7643','2013-03-02','13:40:00',13.7),('7643','2013-03-02','13:45:00',13.55),('7643','2013-03-02','13:50:00',13.28),('7643','2013-03-02','13:55:00',13.18),('7643','2013-03-02','14:00:00',13),('7643','2013-03-02','14:05:00',12.76),('7643','2013-03-02','14:10:00',12.67),('7643','2013-03-02','14:15:00',12.53),('7643','2013-03-02','14:20:00',12.37),('7643','2013-03-02','14:25:00',12.08),('7643','2013-03-02','14:30:00',11.87),('7643','2013-03-02','14:35:00',11.65),('7643','2013-03-02','14:40:00',11.47),('7643','2013-03-02','14:45:00',11.21),('7643','2013-03-02','14:50:00',10.99),('7643','2013-03-02','14:55:00',10.69),('7643','2013-03-02','15:00:00',10.4),('7643','2013-03-02','15:05:00',10.12),('7643','2013-03-02','15:10:00',9.82),('7643','2013-03-02','15:15:00',9.61),('7643','2013-03-02','15:20:00',9.34),('7643','2013-03-02','15:25:00',9.06),('7643','2013-03-02','15:30:00',8.78),('7643','2013-03-02','15:35:00',8.47),('7643','2013-03-02','15:40:00',8.09),('7643','2013-03-02','15:45:00',7.78),('7643','2013-03-02','15:50:00',7.43),('7643','2013-03-02','15:55:00',7.1),('7643','2013-03-02','16:00:00',6.76),('7643','2013-03-02','16:05:00',6.39),('7643','2013-03-02','16:10:00',6.06),('7643','2013-03-02','16:15:00',5.67),('7643','2013-03-02','16:20:00',5.3),('7643','2013-03-02','16:25:00',4.95),('7643','2013-03-02','16:30:00',4.59),('7643','2013-03-02','16:35:00',4.19),('7643','2013-03-02','16:40:00',3.83),('7643','2013-03-02','16:45:00',3.45),('7643','2013-03-02','16:50:00',3.07),('7643','2013-03-02','16:55:00',2.71),('7643','2013-03-02','17:00:00',2.34),('7643','2013-03-02','17:05:00',2.01),('7643','2013-03-02','17:10:00',1.68),('7643','2013-03-02','17:15:00',1.37),('7643','2013-03-02','17:20:00',1.08),('7643','2014-03-23','07:05:00',1.67),('7643','2014-03-23','07:10:00',1.59),('7643','2014-03-23','07:30:00',1.56),('7643','2014-03-23','07:35:00',2.47),('7643','2014-03-23','07:40:00',1.85),('7643','2014-03-23','07:45:00',4.68),('7643','2014-03-23','07:50:00',3.28),('7643','2014-03-23','07:55:00',2.98),('7643','2014-03-23','08:00:00',1.47),('7643','2014-03-23','08:10:00',1.92),('7643','2014-03-23','08:15:00',1.17),('7643','2014-03-23','08:20:00',1.71),('7643','2014-03-23','08:25:00',1.26),('7643','2014-03-23','08:30:00',2.05),('7643','2014-03-23','08:35:00',3.19),('7643','2014-03-23','08:40:00',3.41),('7643','2014-03-23','08:45:00',2.83),('7643','2014-03-23','08:50:00',2.95),('7643','2014-03-23','08:55:00',6.33),('7643','2014-03-23','09:00:00',7.16),('7643','2014-03-23','09:05:00',5.93),('7643','2014-03-23','09:10:00',2.63),('7643','2014-03-23','09:15:00',3.6),('7643','2014-03-23','09:20:00',8.14),('7643','2014-03-23','09:25:00',3.29),('7643','2014-03-23','09:30:00',5.9),('7643','2014-03-23','09:35:00',3.48),('7643','2014-03-23','09:40:00',6.03),('7643','2014-03-23','09:45:00',4.51),('7643','2014-03-23','09:50:00',3.99),('7643','2014-03-23','09:55:00',2.52),('7643','2014-03-23','10:00:00',7.83),('7643','2014-03-23','10:05:00',9.26),('7643','2014-03-23','10:10:00',14.22),('7643','2014-03-23','10:15:00',10.91),('7643','2014-03-23','10:20:00',3.65),('7643','2014-03-23','10:25:00',2.96),('7643','2014-03-23','10:30:00',2.83),('7643','2014-03-23','10:35:00',5.5),('7643','2014-03-23','10:40:00',4.59),('7643','2014-03-23','10:45:00',6.67),('7643','2014-03-23','10:50:00',18.59),('7643','2014-03-23','10:55:00',15.16),('7643','2014-03-23','11:00:00',6.33),('7643','2014-03-23','11:05:00',10.32),('7643','2014-03-23','11:10:00',11.17),('7643','2014-03-23','11:15:00',11.3),('7643','2014-03-23','11:20:00',8.78),('7643','2014-03-23','11:25:00',10.31),('7643','2014-03-23','11:30:00',12.9),('7643','2014-03-23','11:35:00',7.26),('7643','2014-03-23','11:40:00',3.11),('7643','2014-03-23','11:45:00',2.39),('7643','2014-03-23','11:50:00',2.22),('7643','2014-03-23','11:55:00',2.88),('7643','2014-03-23','12:00:00',2.66),('7643','2014-03-23','12:05:00',1.44),('7643','2014-03-23','12:15:00',1.62),('7643','2014-03-23','12:20:00',2.3),('7643','2014-03-23','12:25:00',2.62),('7643','2014-03-23','12:30:00',4.04),('7643','2014-03-23','12:35:00',6.99),('7643','2014-03-23','12:40:00',7.55),('7643','2014-03-23','12:45:00',6.89),('7643','2014-03-23','12:50:00',5.76),('7643','2014-03-23','12:55:00',5.32),('7643','2014-03-23','13:00:00',5.43),('7643','2014-03-23','13:05:00',5.39),('7643','2014-03-23','13:10:00',4.81),('7643','2014-03-23','13:15:00',3.76),('7643','2014-03-23','13:20:00',3.63),('7643','2014-03-23','13:25:00',4.44),('7643','2014-03-23','13:30:00',5.3),('7643','2014-03-23','13:35:00',4.81),('7643','2014-03-23','13:40:00',2.61),('7643','2014-03-23','13:45:00',3.08),('7643','2014-03-23','13:50:00',5.1),('7643','2014-03-23','13:55:00',5),('7643','2014-03-23','14:00:00',4.65),('7643','2014-03-23','14:05:00',4),('7643','2014-03-23','14:10:00',4.72),('7643','2014-03-23','14:15:00',6.2),('7643','2014-03-23','14:20:00',8.14),('7643','2014-03-23','14:25:00',7.98),('7643','2014-03-23','14:30:00',7.09),('7643','2014-03-23','14:35:00',8.92),('7643','2014-03-23','14:40:00',11.21),('7643','2014-03-23','14:45:00',13.06),('7643','2014-03-23','14:50:00',13.61),('7643','2014-03-23','14:55:00',11.97),('7643','2014-03-23','15:00:00',10.87),('7643','2014-03-23','15:05:00',9.59),('7643','2014-03-23','15:10:00',8.51),('7643','2014-03-23','15:15:00',5.72),('7643','2014-03-23','15:20:00',6.55),('7643','2014-03-23','15:25:00',5.73),('7643','2014-03-23','15:30:00',6.52),('7643','2014-03-23','15:35:00',5.52),('7643','2014-03-23','15:40:00',4.91),('7643','2014-03-23','15:45:00',4.15),('7643','2014-03-23','15:50:00',4.89),('7643','2014-03-23','15:55:00',5.93),('7643','2014-03-23','16:00:00',10.94),('7643','2014-03-23','16:05:00',5.19),('7643','2014-03-23','16:10:00',4.4),('7643','2014-03-23','16:15:00',3.52),('7643','2014-03-23','16:20:00',2.25),('7643','2014-03-23','17:30:00',1.25),('7643','2014-03-23','17:35:00',1.34),('7643','2014-03-23','17:40:00',1.26),('7643','2014-03-23','17:45:00',1.11),('7643','2013-03-01','07:40:00',1.01),('7643','2013-03-01','07:45:00',1.01),('7643','2013-03-01','07:50:00',1.12),('7643','2013-03-01','07:55:00',1.22),('7643','2013-03-01','08:00:00',1.42),('7643','2013-03-01','08:05:00',1.44),('7643','2013-03-01','08:10:00',1.21),('7643','2013-03-01','08:15:00',1.02),('7643','2013-03-01','08:20:00',1.04),('7643','2013-03-01','08:25:00',1.13),('7643','2013-03-01','08:30:00',1.38),('7643','2013-03-01','08:35:00',1.52),('7643','2013-03-01','08:40:00',1.54),('7643','2013-03-01','08:45:00',1.79),('7643','2013-03-01','08:50:00',1.92),('7643','2013-03-01','08:55:00',1.97),('7643','2013-03-01','09:00:00',2.07),('7643','2013-03-01','09:05:00',1.73),('7643','2013-03-01','09:10:00',1.32),('7643','2013-03-01','09:15:00',1.21),('7643','2013-03-01','09:20:00',1.52),('7643','2013-03-01','09:25:00',1.5),('7643','2013-03-01','09:30:00',1.52),('7643','2013-03-01','09:35:00',1.7),('7643','2013-03-01','09:40:00',2.2),('7643','2013-03-01','09:45:00',2.44),('7643','2013-03-01','09:50:00',2.57),('7643','2013-03-01','09:55:00',2.22),('7643','2013-03-01','10:00:00',2.23),('7643','2013-03-01','10:05:00',2.24),('7643','2013-03-01','10:10:00',2.03),('7643','2013-03-01','10:15:00',2.2),('7643','2013-03-01','10:20:00',2.58),('7643','2013-03-01','10:25:00',2.58),('7643','2013-03-01','10:30:00',2.72),('7643','2013-03-01','10:35:00',3.11),('7643','2013-03-01','10:40:00',3.43),('7643','2013-03-01','10:45:00',3.41),('7643','2013-03-01','10:50:00',3.79),('7643','2013-03-01','10:55:00',4),('7643','2013-03-01','11:00:00',4.19),('7643','2013-03-01','11:05:00',4.1),('7643','2013-03-01','11:10:00',4.56),('7643','2013-03-01','11:15:00',5.14),('7643','2013-03-01','11:20:00',4.59),('7643','2013-03-01','11:25:00',3.98),('7643','2013-03-01','11:30:00',3.71),('7643','2013-03-01','11:35:00',3.9),('7643','2013-03-01','11:40:00',4.35),('7643','2013-03-01','11:45:00',3.94),('7643','2013-03-01','11:50:00',3.97),('7643','2013-03-01','11:55:00',3.69),('7643','2013-03-01','12:00:00',3.68),('7643','2013-03-01','12:05:00',4.3),('7643','2013-03-01','12:10:00',4.4),('7643','2013-03-01','12:15:00',4.51),('7643','2013-03-01','12:20:00',4.12),('7643','2013-03-01','12:25:00',4.43),('7643','2013-03-01','12:30:00',4.61),('7643','2013-03-01','12:35:00',5.19),('7643','2013-03-01','12:40:00',5.36),('7643','2013-03-01','12:45:00',4.94),('7643','2013-03-01','12:50:00',4.77),('7643','2013-03-01','12:55:00',5.59),('7643','2013-03-01','13:00:00',5.46),('7643','2013-03-01','13:05:00',4.89),('7643','2013-03-01','13:10:00',4.1),('7643','2013-03-01','13:15:00',3.52),('7643','2013-03-01','13:20:00',3.33),('7643','2013-03-01','13:25:00',3.24),('7643','2013-03-01','13:30:00',3.47),('7643','2013-03-01','13:35:00',3.47),('7643','2013-03-01','13:40:00',3.76),('7643','2013-03-01','13:45:00',4.16),('7643','2013-03-01','13:50:00',4.02),('7643','2013-03-01','13:55:00',4.3),('7643','2013-03-01','14:00:00',4.98),('7643','2013-03-01','14:05:00',4.97),('7643','2013-03-01','14:10:00',4.22),('7643','2013-03-01','14:15:00',3.72),('7643','2013-03-01','14:20:00',3.55),('7643','2013-03-01','14:25:00',3.04),('7643','2013-03-01','14:30:00',2.06),('7643','2013-03-01','14:35:00',1.59),('7643','2013-03-01','14:40:00',1.63),('7643','2013-03-01','14:45:00',1.72),('7643','2013-03-01','14:50:00',2.36),('7643','2013-03-01','14:55:00',2.6),('7643','2013-03-01','15:00:00',2.67),('7643','2013-03-01','15:05:00',3),('7643','2013-03-01','15:10:00',2.89),('7643','2013-03-01','15:15:00',2.91),('7643','2013-03-01','15:20:00',2.77),('7643','2013-03-01','15:25:00',2.66),('7643','2013-03-01','15:30:00',3.01),('7643','2013-03-01','15:35:00',2.95),('7643','2013-03-01','15:40:00',2.89),('7643','2013-03-01','15:45:00',3.14),('7643','2013-03-01','15:50:00',2.68),('7643','2013-03-01','15:55:00',2.56),('7643','2013-03-01','16:00:00',2.33),('7643','2013-03-01','16:05:00',2.07),('7643','2013-03-01','16:10:00',1.76),('7643','2013-03-01','16:15:00',1.89),('7643','2013-03-01','16:20:00',1.69),('7643','2013-03-01','16:25:00',1.54),('7643','2013-03-01','16:30:00',1.5),('7643','2013-03-01','16:35:00',1.17),('7643','2013-03-01','16:40:00',1.28),('7643','2013-03-01','17:05:00',1.01),('7643','2013-03-01','17:10:00',1.05),('7643','2013-02-28','07:15:00',1.11),('7643','2013-02-28','07:20:00',1.19),('7643','2013-02-28','07:25:00',1.29),('7643','2013-02-28','07:30:00',1.37),('7643','2013-02-28','07:35:00',1.55),('7643','2013-02-28','07:40:00',1.87),('7643','2013-02-28','07:45:00',2.21),('7643','2013-02-28','07:50:00',2.6),('7643','2013-02-28','07:55:00',3.52),('7643','2013-02-28','08:00:00',3.96),('7643','2013-02-28','08:05:00',4.14),('7643','2013-02-28','08:10:00',4.1),('7643','2013-02-28','08:15:00',4.37),('7643','2013-02-28','08:20:00',4.67),('7643','2013-02-28','08:25:00',4.67),('7643','2013-02-28','08:30:00',5.02),('7643','2013-02-28','08:35:00',5.41),('7643','2013-02-28','08:40:00',5.84),('7643','2013-02-28','08:45:00',6.17),('7643','2013-02-28','08:50:00',6.4),('7643','2013-02-28','08:55:00',6.95),('7643','2013-02-28','09:00:00',7.37),('7643','2013-02-28','09:05:00',8.05),('7643','2013-02-28','09:10:00',8.03),('7643','2013-02-28','09:15:00',8.11),('7643','2013-02-28','09:20:00',8.37),('7643','2013-02-28','09:25:00',8.09),('7643','2013-02-28','09:30:00',8.95),('7643','2013-02-28','09:35:00',8.8),('7643','2013-02-28','09:40:00',9.54),('7643','2013-02-28','09:45:00',10.07),('7643','2013-02-28','09:50:00',9.97),('7643','2013-02-28','09:55:00',9.98),('7643','2013-02-28','10:00:00',10.3),('7643','2013-02-28','10:05:00',10.38),('7643','2013-02-28','10:10:00',10.07),('7643','2013-02-28','10:15:00',8.56),('7643','2013-02-28','10:20:00',8.53),('7643','2013-02-28','10:25:00',9.04),('7643','2013-02-28','10:30:00',10.12),('7643','2013-02-28','10:35:00',10.55),('7643','2013-02-28','10:40:00',9.61),('7643','2013-02-28','10:45:00',8.98),('7643','2013-02-28','10:50:00',8.35),('7643','2013-02-28','10:55:00',7.82),('7643','2013-02-28','11:00:00',6.82),('7643','2013-02-28','11:05:00',5.92),('7643','2013-02-28','11:10:00',5.73),('7643','2013-02-28','11:15:00',6.47),('7643','2013-02-28','11:20:00',6.8),('7643','2013-02-28','11:25:00',6.77),('7643','2013-02-28','11:30:00',6.94),('7643','2013-02-28','11:35:00',6.98),('7643','2013-02-28','11:40:00',6.56),('7643','2013-02-28','11:45:00',6.25),('7643','2013-02-28','11:50:00',6.2),('7643','2013-02-28','11:55:00',5.91),('7643','2013-02-28','12:00:00',5.64),('7643','2013-02-28','12:05:00',5.37),('7643','2013-02-28','12:10:00',4.98),('7643','2013-02-28','12:15:00',4.51),('7643','2013-02-28','12:20:00',4.23),('7643','2013-02-28','12:25:00',4.19),('7643','2013-02-28','12:30:00',4.32),('7643','2013-02-28','12:35:00',4.29),('7643','2013-02-28','12:40:00',4.14),('7643','2013-02-28','12:45:00',4.14),('7643','2013-02-28','12:50:00',4.23),('7643','2013-02-28','12:55:00',4.48),('7643','2013-02-28','13:00:00',4.76),('7643','2013-02-28','13:05:00',4.82),('7643','2013-02-28','13:10:00',5),('7643','2013-02-28','13:15:00',5.36),('7643','2013-02-28','13:20:00',5.8),('7643','2013-02-28','13:25:00',6.35),('7643','2013-02-28','13:30:00',6.2),('7643','2013-02-28','13:35:00',5.76),('7643','2013-02-28','13:40:00',5.47),('7643','2013-02-28','13:45:00',5.42),('7643','2013-02-28','13:50:00',5.38),('7643','2013-02-28','13:55:00',5.16),('7643','2013-02-28','14:00:00',4.98),('7643','2013-02-28','14:05:00',4.76),('7643','2013-02-28','14:10:00',4.47),('7643','2013-02-28','14:15:00',4.22),('7643','2013-02-28','14:20:00',4.07),('7643','2013-02-28','14:25:00',4.09),('7643','2013-02-28','14:30:00',4.2),('7643','2013-02-28','14:35:00',4.22),('7643','2013-02-28','14:40:00',4.02),('7643','2013-02-28','14:45:00',3.75),('7643','2013-02-28','14:50:00',3.55),('7643','2013-02-28','14:55:00',3.51),('7643','2013-02-28','15:00:00',3.52),('7643','2013-02-28','15:05:00',3.39),('7643','2013-02-28','15:10:00',3.09),('7643','2013-02-28','15:15:00',2.84),('7643','2013-02-28','15:20:00',2.67),('7643','2013-02-28','15:25:00',2.37),('7643','2013-02-28','15:30:00',2.13),('7643','2013-02-28','15:35:00',2.16),('7643','2013-02-28','15:40:00',2.38),('7643','2013-02-28','15:45:00',2.36),('7643','2013-02-28','15:50:00',2.22),('7643','2013-02-28','15:55:00',2.16),('7643','2013-02-28','16:00:00',2.18),('7643','2013-02-28','16:05:00',2.17),('7643','2013-02-28','16:10:00',2.06),('7643','2013-02-28','16:15:00',1.87),('7643','2013-02-28','16:20:00',1.58),('7643','2013-02-28','16:25:00',1.35),('7643','2013-02-28','16:30:00',1.25),('7643','2013-02-28','16:35:00',1.17),('7643','2013-02-28','16:40:00',1.08),('7643','2013-02-27','07:20:00',1.04),('7643','2013-02-27','07:25:00',1.31),('7643','2013-02-27','07:30:00',1.6),('7643','2013-02-27','07:35:00',1.92),('7643','2013-02-27','07:40:00',2.24),('7643','2013-02-27','07:45:00',2.58),('7643','2013-02-27','07:50:00',2.95),('7643','2013-02-27','07:55:00',3.31),('7643','2013-02-27','08:00:00',3.63),('7643','2013-02-27','08:05:00',4),('7643','2013-02-27','08:10:00',4.34),('7643','2013-02-27','08:15:00',4.7),('7643','2013-02-27','08:20:00',5.06),('7643','2013-02-27','08:25:00',5.39),('7643','2013-02-27','08:30:00',5.73),('7643','2013-02-27','08:35:00',6.07),('7643','2013-02-27','08:40:00',6.51),('7643','2013-02-27','08:45:00',6.92),('7643','2013-02-27','08:50:00',7.32),('7643','2013-02-27','08:55:00',7.71),('7643','2013-02-27','09:00:00',8.06),('7643','2013-02-27','09:05:00',8.32),('7643','2013-02-27','09:10:00',8.52),('7643','2013-02-27','09:15:00',8.78),('7643','2013-02-27','09:20:00',9.18),('7643','2013-02-27','09:25:00',9.43),('7643','2013-02-27','09:30:00',9.77),('7643','2013-02-27','09:35:00',10.05),('7643','2013-02-27','09:40:00',10.3),('7643','2013-02-27','09:45:00',10.55),('7643','2013-02-27','09:50:00',9.99),('7643','2013-02-27','09:55:00',10.85),('7643','2013-02-27','10:00:00',11.09),('7643','2013-02-27','10:05:00',11.22),('7643','2013-02-27','10:10:00',11.38),('7643','2013-02-27','10:15:00',11.56),('7643','2013-02-27','10:20:00',11.81),('7643','2013-02-27','10:25:00',11.77),('7643','2013-02-27','10:30:00',11.92),('7643','2013-02-27','10:35:00',12.3),('7643','2013-02-27','10:40:00',12.55),('7643','2013-02-27','10:45:00',12.74),('7643','2013-02-27','10:50:00',12.79),('7643','2013-02-27','10:55:00',12.89),('7643','2013-02-27','11:00:00',13.01),('7643','2013-02-27','11:05:00',13.35),('7643','2013-02-27','11:10:00',13.16),('7643','2013-02-27','11:15:00',13.32),('7643','2013-02-27','11:20:00',13.68),('7643','2013-02-27','11:25:00',13.85),('7643','2013-02-27','11:30:00',13.87),('7643','2013-02-27','11:35:00',13.69),('7643','2013-02-27','11:40:00',13.66),('7643','2013-02-27','11:45:00',13.83),('7643','2013-02-27','11:50:00',13.69),('7643','2013-02-27','11:55:00',13.12),('7643','2013-02-27','12:00:00',12.97),('7643','2013-02-27','12:05:00',13.5),('7643','2013-02-27','12:10:00',13.96),('7643','2013-02-27','12:15:00',14.01),('7643','2013-02-27','12:20:00',13.9),('7643','2013-02-27','12:25:00',13.63),('7643','2013-02-27','12:30:00',12.95),('7643','2013-02-27','12:35:00',13.32),('7643','2013-02-27','12:40:00',13.68),('7643','2013-02-27','12:45:00',13.68),('7643','2013-02-27','12:50:00',13.64),('7643','2013-02-27','12:55:00',13.76),('7643','2013-02-27','13:00:00',13.15),('7643','2013-02-27','13:05:00',13.48),('7643','2013-02-27','13:10:00',13.47),('7643','2013-02-27','13:15:00',13.59),('7643','2013-02-27','13:20:00',13.67),('7643','2013-02-27','13:25:00',13.52),('7643','2013-02-27','13:30:00',12.88),('7643','2013-02-27','13:35:00',13.17),('7643','2013-02-27','13:40:00',12.99),('7643','2013-02-27','13:45:00',13.16),('7643','2013-02-27','13:50:00',13.23),('7643','2013-02-27','13:55:00',13.66),('7643','2013-02-27','14:00:00',13.7),('7643','2013-02-27','14:05:00',13.2),('7643','2013-02-27','14:10:00',13.08),('7643','2013-02-27','14:15:00',12.57),('7643','2013-02-27','14:20:00',11.58),('7643','2013-02-27','14:25:00',11.13),('7643','2013-02-27','14:30:00',10.69),('7643','2013-02-27','14:35:00',10.12),('7643','2013-02-27','14:40:00',10.49),('7643','2013-02-27','14:45:00',10.33),('7643','2013-02-27','14:50:00',9.92),('7643','2013-02-27','14:55:00',9.65),('7643','2013-02-27','15:00:00',9.5),('7643','2013-02-27','15:05:00',8.99),('7643','2013-02-27','15:10:00',8.72),('7643','2013-02-27','15:15:00',8.57),('7643','2013-02-27','15:20:00',8.42),('7643','2013-02-27','15:25:00',7.83),('7643','2013-02-27','15:30:00',7.23),('7643','2013-02-27','15:35:00',6.94),('7643','2013-02-27','15:40:00',6.68),('7643','2013-02-27','15:45:00',6.48),('7643','2013-02-27','15:50:00',6.28),('7643','2013-02-27','15:55:00',5.96),('7643','2013-02-27','16:00:00',5.65),('7643','2013-02-27','16:05:00',5.26),('7643','2013-02-27','16:10:00',4.93),('7643','2013-02-27','16:15:00',4.63),('7643','2013-02-27','16:20:00',4.24),('7643','2013-02-27','16:25:00',3.96),('7643','2013-02-27','16:30:00',3.59),('7643','2013-02-27','16:35:00',3.44),('7643','2013-02-27','16:40:00',3.15),('7643','2013-02-27','16:45:00',2.86),('7643','2013-02-27','16:50:00',2.58),('7643','2013-02-27','16:55:00',2.28),('7643','2013-02-27','17:00:00',1.96),('7643','2013-02-27','17:05:00',1.63),('7643','2013-02-27','17:10:00',1.31),('7643','2013-02-27','17:15:00',1.05),('7643','2013-02-26','07:25:00',1.25),('7643','2013-02-26','07:30:00',1.52),('7643','2013-02-26','07:35:00',1.79),('7643','2013-02-26','07:40:00',2.09),('7643','2013-02-26','07:45:00',2.42),('7643','2013-02-26','07:50:00',2.74),('7643','2013-02-26','07:55:00',3.11),('7643','2013-02-26','08:00:00',3.51),('7643','2013-02-26','08:05:00',3.84),('7643','2013-02-26','08:10:00',4.17),('7643','2013-02-26','08:15:00',4.53),('7643','2013-02-26','08:20:00',4.93),('7643','2013-02-26','08:25:00',5.33),('7643','2013-02-26','08:30:00',5.7),('7643','2013-02-26','08:35:00',6.08),('7643','2013-02-26','08:40:00',6.32),('7643','2013-02-26','08:45:00',6.66),('7643','2013-02-26','08:50:00',7.03),('7643','2013-02-26','08:55:00',7.34),('7643','2013-02-26','09:00:00',7.68),('7643','2013-02-26','09:05:00',8.12),('7643','2013-02-26','09:10:00',8.39),('7643','2013-02-26','09:15:00',8.62),('7643','2013-02-26','09:20:00',8.92),('7643','2013-02-26','09:25:00',9.25),('7643','2013-02-26','09:30:00',9.48),('7643','2013-02-26','09:35:00',9.76),('7643','2013-02-26','09:40:00',10.01),('7643','2013-02-26','09:45:00',10.29),('7643','2013-02-26','09:50:00',10.49),('7643','2013-02-26','09:55:00',10.7),('7643','2013-02-26','10:00:00',10.94),('7643','2013-02-26','10:05:00',11.14),('7643','2013-02-26','10:10:00',11.32),('7643','2013-02-26','10:15:00',11.57),('7643','2013-02-26','10:20:00',11.8),('7643','2013-02-26','10:25:00',11.9),('7643','2013-02-26','10:30:00',12.03),('7643','2013-02-26','10:35:00',12.4),('7643','2013-02-26','10:40:00',12.32),('7643','2013-02-26','10:45:00',12.53),('7643','2013-02-26','10:50:00',12.61),('7643','2013-02-26','10:55:00',12.89),('7643','2013-02-26','11:00:00',12.94),('7643','2013-02-26','11:05:00',12.94),('7643','2013-02-26','11:10:00',12.84),('7643','2013-02-26','11:15:00',13.06),('7643','2013-02-26','11:20:00',12.68),('7643','2013-02-26','11:25:00',13.61),('7643','2013-02-26','11:30:00',13.91),('7643','2013-02-26','11:35:00',11.65),('7643','2013-02-26','11:40:00',10.32),('7643','2013-02-26','11:45:00',6.51),('7643','2013-02-26','11:50:00',5.95),('7643','2013-02-26','11:55:00',9.16),('7643','2013-02-26','12:00:00',4.68),('7643','2013-02-26','12:05:00',15.17),('7643','2013-02-26','12:10:00',14.5),('7643','2013-02-26','12:15:00',6.94),('7643','2013-02-26','12:20:00',15.07),('7643','2013-02-26','12:25:00',15.22),('7643','2013-02-26','12:30:00',14.23),('7643','2013-02-26','12:35:00',14.18),('7643','2013-02-26','12:40:00',14.49),('7643','2013-02-26','12:45:00',14.01),('7643','2013-02-26','12:50:00',14.12),('7643','2013-02-26','12:55:00',13.72),('7643','2013-02-26','13:00:00',13.9),('7643','2013-02-26','13:05:00',14.05),('7643','2013-02-26','13:10:00',13.94),('7643','2013-02-26','13:15:00',13.29),('7643','2013-02-26','13:20:00',9.73),('7643','2013-02-26','13:25:00',10.14),('7643','2013-02-26','13:30:00',10.78),('7643','2013-02-26','13:35:00',13.82),('7643','2013-02-26','13:40:00',13.87),('7643','2013-02-26','13:45:00',13.51),('7643','2013-02-26','13:50:00',12.86),('7643','2013-02-26','13:55:00',10.09),('7643','2013-02-26','14:00:00',8.91),('7643','2013-02-26','14:05:00',8.94),('7643','2013-02-26','14:10:00',10.48),('7643','2013-02-26','14:15:00',10.09),('7643','2013-02-26','14:20:00',9.3),('7643','2013-02-26','14:25:00',8.81),('7643','2013-02-26','14:30:00',10.87),('7643','2013-02-26','14:35:00',11.07),('7643','2013-02-26','14:40:00',10.72),('7643','2013-02-26','14:45:00',10.88),('7643','2013-02-26','14:50:00',10.33),('7643','2013-02-26','14:55:00',9.36),('7643','2013-02-26','15:00:00',9.91),('7643','2013-02-26','15:05:00',9.72),('7643','2013-02-26','15:10:00',9.28),('7643','2013-02-26','15:15:00',8.94),('7643','2013-02-26','15:20:00',8.38),('7643','2013-02-26','15:25:00',8.33),('7643','2013-02-26','15:30:00',8.19),('7643','2013-02-26','15:35:00',7.79),('7643','2013-02-26','15:40:00',7.38),('7643','2013-02-26','15:45:00',7.05),('7643','2013-02-26','15:50:00',6.82),('7643','2013-02-26','15:55:00',6.51),('7643','2013-02-26','16:00:00',6.18),('7643','2013-02-26','16:05:00',5.81),('7643','2013-02-26','16:10:00',5.44),('7643','2013-02-26','16:15:00',5.04),('7643','2013-02-26','16:20:00',4.74),('7643','2013-02-26','16:25:00',4.42),('7643','2013-02-26','16:30:00',3.96),('7643','2013-02-26','16:35:00',3.6),('7643','2013-02-26','16:40:00',3.26),('7643','2013-02-26','16:45:00',2.91),('7643','2013-02-26','16:50:00',2.6),('7643','2013-02-26','16:55:00',2.27),('7643','2013-02-26','17:00:00',1.92),('7643','2013-02-26','17:05:00',1.65),('7643','2013-02-26','17:10:00',1.38),('7643','2013-02-26','17:15:00',1.16),('7643','2013-02-25','08:15:00',1.13),('7643','2013-02-25','08:20:00',1.26),('7643','2013-02-25','08:25:00',1.3),('7643','2013-02-25','08:30:00',1.36),('7643','2013-02-25','08:35:00',1.52),('7643','2013-02-25','08:40:00',1.72),('7643','2013-02-25','08:45:00',1.92),('7643','2013-02-25','08:50:00',2.23),('7643','2013-02-25','08:55:00',2.6),('7643','2013-02-25','09:00:00',2.87),('7643','2013-02-25','09:05:00',3.06),('7643','2013-02-25','09:10:00',3.35),('7643','2013-02-25','09:15:00',3.58),('7643','2013-02-25','09:20:00',3.9),('7643','2013-02-25','09:25:00',4.3),('7643','2013-02-25','09:30:00',5.3),('7643','2013-02-25','09:35:00',6.63),('7643','2013-02-25','09:40:00',7.2),('7643','2013-02-25','09:45:00',7.15),('7643','2013-02-25','09:50:00',7.56),('7643','2013-02-25','09:55:00',8.17),('7643','2013-02-25','10:00:00',7.75),('7643','2013-02-25','10:05:00',7.72),('7643','2013-02-25','10:10:00',9.01),('7643','2013-02-25','10:15:00',10.58),('7643','2013-02-25','10:20:00',12.52),('7643','2013-02-25','10:25:00',13.55),('7643','2013-02-25','10:30:00',13.31),('7643','2013-02-25','10:35:00',12.07),('7643','2013-02-25','10:40:00',6.41),('7643','2013-02-25','10:45:00',5.6),('7643','2013-02-25','10:50:00',6.52),('7643','2013-02-25','10:55:00',6.75),('7643','2013-02-25','11:00:00',8.37),('7643','2013-02-25','11:05:00',7.64),('7643','2013-02-25','11:10:00',7.03),('7643','2013-02-25','11:15:00',6.68),('7643','2013-02-25','11:20:00',6.63),('7643','2013-02-25','11:25:00',6.1),('7643','2013-02-25','11:30:00',5.79),('7643','2013-02-25','11:35:00',5.62),('7643','2013-02-25','11:40:00',5.97),('7643','2013-02-25','11:45:00',6.07),('7643','2013-02-25','11:51:00',6.63),('7643','2013-02-25','11:55:00',6.65),('7643','2013-02-25','12:00:00',6.25),('7643','2013-02-25','12:05:00',5.97),('7643','2013-02-25','12:10:00',6.17),('7643','2013-02-25','12:15:00',5.54),('7643','2013-02-25','12:20:00',5.47),('7643','2013-02-25','12:25:00',4.99),('7643','2013-02-25','12:30:00',4.91),('7643','2013-02-25','12:35:00',4.53),('7643','2013-02-25','12:40:00',4.19),('7643','2013-02-25','12:45:00',3.74),('7643','2013-02-25','12:50:00',3.43),('7643','2013-02-25','12:55:00',3.72),('7643','2013-02-25','13:00:00',3.69),('7643','2013-02-25','13:05:00',3.25),('7643','2013-02-25','13:10:00',2.98),('7643','2013-02-25','13:15:00',3.29),('7643','2013-02-25','13:20:00',3.56),('7643','2013-02-25','13:25:00',3.69),('7643','2013-02-25','13:30:00',3.82),('7643','2013-02-25','13:35:00',3.84),('7643','2013-02-25','13:40:00',3.79),('7643','2013-02-25','13:45:00',3.35),('7643','2013-02-25','13:50:00',3.22),('7643','2013-02-25','13:55:00',3.18),('7643','2013-02-25','14:00:00',2.84),('7643','2013-02-25','14:05:00',2.59),('7643','2013-02-25','14:10:00',2.7),('7643','2013-02-25','14:15:00',3.07),('7643','2013-02-25','14:20:00',1.65),('7643','2013-02-25','14:25:00',1.19),('7643','2013-02-25','15:55:00',1.14),('7643','2013-02-25','16:00:00',1.22),('7643','2013-02-25','16:05:00',1.23),('7643','2013-02-25','16:10:00',1.24),('7643','2013-02-25','16:15:00',1.27),('7643','2013-02-25','16:20:00',1.28),('7643','2013-02-25','16:25:00',1.26),('7643','2013-02-25','16:30:00',1.22),('7643','2013-02-25','16:35:00',1.11),('7643','2013-02-25','16:40:00',1.04),('7643','2013-02-25','16:45:00',1.04),('7643','2013-02-24','08:30:00',1.35),('7643','2013-02-24','08:35:00',2.44),('7643','2013-02-24','08:40:00',4.18),('7643','2013-02-24','08:45:00',4.07),('7643','2013-02-24','08:50:00',4.45),('7643','2013-02-24','08:55:00',3.41),('7643','2013-02-24','09:00:00',5.22),('7643','2013-02-24','09:05:00',3.03),('7643','2013-02-24','09:10:00',3.28),('7643','2013-02-24','09:15:00',3.34),('7643','2013-02-24','09:20:00',3.73),('7643','2013-02-24','09:25:00',5.14),('7643','2013-02-24','09:30:00',5.54),('7643','2013-02-24','09:35:00',5.53),('7643','2013-02-24','09:40:00',4.08),('7643','2013-02-24','09:45:00',2.92),('7643','2013-02-24','09:50:00',2.51),('7643','2013-02-24','09:55:00',1.44),('7643','2013-02-24','10:20:00',1.11),('7643','2013-02-24','10:25:00',1.74),('7643','2013-02-24','10:30:00',1.72),('7643','2013-02-24','10:35:00',1.83),('7643','2013-02-24','10:40:00',3.06),('7643','2013-02-24','10:45:00',6.58),('7643','2013-02-24','10:50:00',11.73),('7643','2013-02-24','10:55:00',17.51),('7643','2013-02-24','11:00:00',17.29),('7643','2013-02-24','11:05:00',9.97),('7643','2013-02-24','11:10:00',7.95),('7643','2013-02-24','11:15:00',6.6),('7643','2013-02-24','11:20:00',4.26),('7643','2013-02-24','11:25:00',3.97),('7643','2013-02-24','11:30:00',5.25),('7643','2013-02-24','11:35:00',4.58),('7643','2013-02-24','11:40:00',5.08),('7643','2013-02-24','11:45:00',6.69),('7643','2013-02-24','11:50:00',11.03),('7643','2013-02-24','11:55:00',17.69),('7643','2013-02-24','12:00:00',8.71),('7643','2013-02-24','12:05:00',8.35),('7643','2013-02-24','12:10:00',7.6),('7643','2013-02-24','12:15:00',10.92),('7643','2013-02-24','12:20:00',17.14),('7643','2013-02-24','12:25:00',16.58),('7643','2013-02-24','12:30:00',14.46),('7643','2013-02-24','12:35:00',14.9),('7643','2013-02-24','12:40:00',15.68),('7643','2013-02-24','12:45:00',15.02),('7643','2013-02-24','12:50:00',14.46),('7643','2013-02-24','12:55:00',14.25),('7643','2013-02-24','13:00:00',14.7),('7643','2013-02-24','13:05:00',9.46),('7643','2013-02-24','13:10:00',9.65),('7643','2013-02-24','13:15:00',12.05),('7643','2013-02-24','13:20:00',9.06),('7643','2013-02-24','13:25:00',6.56),('7643','2013-02-24','13:30:00',5.93),('7643','2013-02-24','13:35:00',4.33),('7643','2013-02-24','13:40:00',3.74),('7643','2013-02-24','13:45:00',3.4),('7643','2013-02-24','13:50:00',3.54),('7643','2013-02-24','13:55:00',2.97),('7643','2013-02-24','14:00:00',2.44),('7643','2013-02-24','14:05:00',1.74),('7643','2013-02-24','14:10:00',1.49),('7643','2013-02-24','14:15:00',1.44),('7643','2013-02-24','14:20:00',1.43),('7643','2013-02-24','14:25:00',1.46),('7643','2013-02-24','14:30:00',2.16),('7643','2013-02-24','14:35:00',2.98),('7643','2013-02-24','14:40:00',3.32),('7643','2013-02-24','14:45:00',3.02),('7643','2013-02-24','14:50:00',2.96),('7643','2013-02-24','14:55:00',2.91),('7643','2013-02-24','15:00:00',2.86),('7643','2013-02-24','15:05:00',2.91),('7643','2013-02-24','15:10:00',2.74),('7643','2013-02-24','15:15:00',2.61),('7643','2013-02-24','15:20:00',2.37),('7643','2013-02-24','15:25:00',1.81),('7643','2013-02-24','15:30:00',1.19),('7643','2013-02-24','15:45:00',1.39),('7643','2013-02-24','15:50:00',1.96),('7643','2013-02-24','15:55:00',2.33),('7643','2013-02-24','16:00:00',2.38),('7643','2013-02-24','16:05:00',2.19),('7643','2013-02-24','16:10:00',1.93),('7643','2013-02-24','16:15:00',1.41),('7643','2013-02-24','16:20:00',1.09),('7643','2013-02-24','16:25:00',1.48),('7643','2013-02-24','16:30:00',2.15),('7643','2013-02-24','16:35:00',2.66),('7643','2013-02-24','16:40:00',2.39),('7643','2013-02-24','16:45:00',2.23),('7643','2013-02-24','16:50:00',2.08),('7643','2013-02-24','16:55:00',2.91),('7643','2013-02-24','17:00:00',2.47),('7643','2013-02-24','17:05:00',1.94),('7643','2013-02-24','17:10:00',1.56),('7643','2013-02-24','17:15:00',1.22),('7643','2013-02-23','07:50:00',1.31),('7643','2013-02-23','07:55:00',1.85),('7643','2013-02-23','08:00:00',2.85),('7643','2013-02-23','08:05:00',3.3),('7643','2013-02-23','08:10:00',1.39),('7643','2013-02-23','08:16:00',1.78),('7643','2013-02-23','08:20:00',2.07),('7643','2013-02-23','08:25:00',2.33),('7643','2013-02-23','08:30:00',1.96),('7643','2013-02-23','08:35:00',1.79),('7643','2013-02-23','08:40:00',1.32),('7643','2013-02-23','08:45:00',2.4),('7643','2013-02-23','08:50:00',2.59),('7643','2013-02-23','08:55:00',2.92),('7643','2013-02-23','09:00:00',2.13),('7643','2013-02-23','09:05:00',1.69),('7643','2013-02-23','09:10:00',1.4),('7643','2013-02-23','09:25:00',1.36),('7643','2013-02-23','09:30:00',1.26),('7643','2013-02-23','09:35:00',1.03),('7643','2013-02-23','09:45:00',1.48),('7643','2013-02-23','09:50:00',1.36),('7643','2013-02-23','09:55:00',1.42),('7643','2013-02-23','10:00:00',1.96),('7643','2013-02-23','10:05:00',1.6),('7643','2013-02-23','10:10:00',1.6),('7643','2013-02-23','10:15:00',1.48),('7643','2013-02-23','10:20:00',1.43),('7643','2013-02-23','10:25:00',1.96),('7643','2013-02-23','10:30:00',2.11),('7643','2013-02-23','10:35:00',2.43),('7643','2013-02-23','10:40:00',3.01),('7643','2013-02-23','10:45:00',3.46),('7643','2013-02-23','10:50:00',4.91),('7643','2013-02-23','10:55:00',4.55),('7643','2013-02-23','11:00:00',3.49),('7643','2013-02-23','11:05:00',3.45),('7643','2013-02-23','11:10:00',3.1),('7643','2013-02-23','11:15:00',3.19),('7643','2013-02-23','11:20:00',3.21),('7643','2013-02-23','11:25:00',3.26),('7643','2013-02-23','11:30:00',3.66),('7643','2013-02-23','11:35:00',2.86),('7643','2013-02-23','11:40:00',3.15),('7643','2013-02-23','11:45:00',3.38),('7643','2013-02-23','11:50:00',3.45),('7643','2013-02-23','11:55:00',3.39),('7643','2013-02-23','12:00:00',2.99),('7643','2013-02-23','12:05:00',2.94),('7643','2013-02-23','12:10:00',2.5),('7643','2013-02-23','12:15:00',1.93),('7643','2013-02-23','12:20:00',1.86),('7643','2013-02-23','12:25:00',1.5),('7643','2013-02-23','12:30:00',2.17),('7643','2013-02-23','12:35:00',3.53),('7643','2013-02-23','12:40:00',4.2),('7643','2013-02-23','12:45:00',4.92),('7643','2013-02-23','12:50:00',4.65),('7643','2013-02-23','12:55:00',3.91),('7643','2013-02-23','13:00:00',4.24),('7643','2013-02-23','13:05:00',6.36),('7643','2013-02-23','13:10:00',6.15),('7643','2013-02-23','13:15:00',5.42),('7643','2013-02-23','13:20:00',5.66),('7643','2013-02-23','13:25:00',4.27),('7643','2013-02-23','13:30:00',3.46),('7643','2013-02-23','13:35:00',4.57),('7643','2013-02-23','13:40:00',5.8),('7643','2013-02-23','13:45:00',5.88),('7643','2013-02-23','13:50:00',4.27),('7643','2013-02-23','13:55:00',3.56),('7643','2013-02-23','14:00:00',4.01),('7643','2013-02-23','14:05:00',6.87),('7643','2013-02-23','14:10:00',6.67),('7643','2013-02-23','14:15:00',4.14),('7643','2013-02-23','14:20:00',3.94),('7643','2013-02-23','14:25:00',3.36),('7643','2013-02-23','14:30:00',4.27),('7643','2013-02-23','14:35:00',4.59),('7643','2013-02-23','14:40:00',3.03),('7643','2013-02-23','14:45:00',3.23),('7643','2013-02-23','14:50:00',2.58),('7643','2013-02-23','14:55:00',2.33),('7643','2013-02-23','15:00:00',2.34),('7643','2013-02-23','15:05:00',3.28),('7643','2013-02-23','15:10:00',8.62),('7643','2013-02-23','15:15:00',6.43),('7643','2013-02-23','15:20:00',3.57),('7643','2013-02-23','15:25:00',7.11),('7643','2013-02-23','15:30:00',4.92),('7643','2013-02-23','15:35:00',7.25),('7643','2013-02-23','15:40:00',6.03),('7643','2013-02-23','15:45:00',5.24),('7643','2013-02-23','15:50:00',5.21),('7643','2013-02-23','15:55:00',4.63),('7643','2013-02-23','16:00:00',7.51),('7643','2013-02-23','16:05:00',4.83),('7643','2013-02-23','16:10:00',2.11),('7643','2013-02-23','16:15:00',1.8),('7643','2013-02-23','16:20:00',2.59),('7643','2013-02-23','16:25:00',2.17),('7643','2013-02-23','16:30:00',1.46),('7643','2013-02-23','16:35:00',1.53),('7643','2013-02-23','16:40:00',3.42),('7643','2013-02-23','16:45:00',3.33),('7643','2013-02-23','16:50:00',1.39),('7643','2013-02-23','16:55:00',1.16),('7643','2013-02-22','07:25:00',1.08),('7643','2013-02-22','07:30:00',1.48),('7643','2013-02-22','07:35:00',1.82),('7643','2013-02-22','07:40:00',2.13),('7643','2013-02-22','07:45:00',2.56),('7643','2013-02-22','07:50:00',3.04),('7643','2013-02-22','07:55:00',3.54),('7643','2013-02-22','08:00:00',3.97),('7643','2013-02-22','08:05:00',4.49),('7643','2013-02-22','08:10:00',5.58),('7643','2013-02-22','08:15:00',6.84),('7643','2013-02-22','08:20:00',4.28),('7643','2013-02-22','08:25:00',2.57),('7643','2013-02-22','08:30:00',2.41),('7643','2013-02-22','08:35:00',2.2),('7643','2013-02-22','08:40:00',1.98),('7643','2013-02-22','08:45:00',2.29),('7643','2013-02-22','08:50:00',3.2),('7643','2013-02-22','08:55:00',4.02),('7643','2013-02-22','09:00:00',4.79),('7643','2013-02-22','09:05:00',5.36),('7643','2013-02-22','09:10:00',3.74),('7643','2013-02-22','09:15:00',2.96),('7643','2013-02-22','09:20:00',2.11),('7643','2013-02-22','09:25:00',1.48),('7643','2013-02-22','09:30:00',2.35),('7643','2013-02-22','09:35:00',2.74),('7643','2013-02-22','09:40:00',3.8),('7643','2013-02-22','09:45:00',5.24),('7643','2013-02-22','09:50:00',5.26),('7643','2013-02-22','09:55:00',5.11),('7643','2013-02-22','10:00:00',4.12),('7643','2013-02-22','10:05:00',3.88),('7643','2013-02-22','10:10:00',3.35),('7643','2013-02-22','10:15:00',2.57),('7643','2013-02-22','10:20:00',2.72),('7643','2013-02-22','10:25:00',3.91),('7643','2013-02-22','10:30:00',3.36),('7643','2013-02-22','10:35:00',3.32),('7643','2013-02-22','10:40:00',3.04),('7643','2013-02-22','10:45:00',3.12),('7643','2013-02-22','10:50:00',3.04),('7643','2013-02-22','10:55:00',2.36),('7643','2013-02-22','11:00:00',1.89),('7643','2013-02-22','11:05:00',2.22),('7643','2013-02-22','11:10:00',2.01),('7643','2013-02-22','11:15:00',1.9),('7643','2013-02-22','11:20:00',2.57),('7643','2013-02-22','11:25:00',2.18),('7643','2013-02-22','11:30:00',2.27),('7643','2013-02-22','11:35:00',3.23),('7643','2013-02-22','11:40:00',3.35),('7643','2013-02-22','11:45:00',3.07),('7643','2013-02-22','11:50:00',2.45),('7643','2013-02-22','11:55:00',2.2),('7643','2013-02-22','12:00:00',1.98),('7643','2013-02-22','12:05:00',2.73),('7643','2013-02-22','12:10:00',2.71),('7643','2013-02-22','12:15:00',2.39),('7643','2013-02-22','12:20:00',2.54),('7643','2013-02-22','12:25:00',2.18),('7643','2013-02-22','12:30:00',2.38),('7643','2013-02-22','12:35:00',1.5),('7643','2013-02-22','12:40:00',1.62),('7643','2013-02-22','12:45:00',1.68),('7643','2013-02-22','12:50:00',1.82),('7643','2013-02-22','12:55:00',1.86),('7643','2013-02-22','13:00:00',1.49),('7643','2013-02-22','13:05:00',1.62),('7643','2013-02-22','13:10:00',2.08),('7643','2013-02-22','13:15:00',2.15),('7643','2013-02-22','13:20:00',1.87),('7643','2013-02-22','13:25:00',2.03),('7643','2013-02-22','13:30:00',1.22),('7643','2013-02-22','13:35:00',1.2),('7643','2013-02-22','13:40:00',1.42),('7643','2013-02-22','13:45:00',1.37),('7643','2013-02-22','13:50:00',2.03),('7643','2013-02-22','13:55:00',3.64),('7643','2013-02-22','14:00:00',3.93),('7643','2013-02-22','14:05:00',6.76),('7643','2013-02-22','14:10:00',5.9),('7643','2013-02-22','14:15:00',1.93),('7643','2013-02-22','14:20:00',1.42),('7643','2013-02-22','14:25:00',1.57),('7643','2013-02-22','14:30:00',1.3),('7643','2013-02-22','14:40:00',1.06),('7643','2013-02-22','14:45:00',2.9),('7643','2013-02-22','14:50:00',2.91),('7643','2013-02-22','14:55:00',1.89),('7643','2013-02-22','15:00:00',1.74),('7643','2013-02-22','15:05:00',2.1),('7643','2013-02-22','15:10:00',2.44),('7643','2013-02-22','15:15:00',1.1),('7643','2013-02-22','15:20:00',1.31),('7643','2013-02-22','15:25:00',1.6),('7643','2013-02-22','15:45:00',1.43),('7643','2013-02-22','15:50:00',1.03),('7643','2013-02-21','08:20:00',1.18),('7643','2013-02-21','08:55:00',1.1),('7643','2013-02-21','09:00:00',1.32),('7643','2013-02-21','09:05:00',1.23),('7643','2013-02-21','09:10:00',1.18),('7643','2013-02-21','09:15:00',1.16),('7643','2013-02-21','09:20:00',1.17),('7643','2013-02-21','09:25:00',1.22),('7643','2013-02-21','09:30:00',1.57),('7643','2013-02-21','09:35:00',3.14),('7643','2013-02-21','09:40:00',3.56),('7643','2013-02-21','09:45:00',2.36),('7643','2013-02-21','09:50:00',2.48),('7643','2013-02-21','09:55:00',2.09),('7643','2013-02-21','10:00:00',1.78),('7643','2013-02-21','10:05:00',1.98),('7643','2013-02-21','10:10:00',1.7),('7643','2013-02-21','10:15:00',2.6),('7643','2013-02-21','10:20:00',2.42),('7643','2013-02-21','10:25:00',1.15),('7643','2013-02-21','11:05:00',1.43),('7643','2013-02-21','11:10:00',1.45),('7643','2013-02-21','11:15:00',1.04),('7643','2013-02-21','11:20:00',1.34),('7643','2013-02-21','11:25:00',1.47),('7643','2013-02-21','11:30:00',1.95),('7643','2013-02-21','11:35:00',2.2),('7643','2013-02-21','11:40:00',2.11),('7643','2013-02-21','11:45:00',1.74),('7643','2013-02-21','11:50:00',1.66),('7643','2013-02-21','11:55:00',2),('7643','2013-02-21','12:00:00',2.08),('7643','2013-02-21','12:05:00',1.82),('7643','2013-02-21','12:10:00',1.65),('7643','2013-02-21','12:15:00',1.82),('7643','2013-02-21','12:20:00',1.51),('7643','2013-02-21','12:25:00',1.31),('7643','2013-02-21','12:40:00',1.13),('7643','2013-02-21','12:45:00',2.05),('7643','2013-02-21','12:50:00',2.62),('7643','2013-02-21','12:55:00',2.99),('7643','2013-02-21','13:00:00',2.55),('7643','2013-02-21','13:05:00',1.31),('7643','2013-02-21','13:40:00',1.74),('7643','2013-02-21','13:45:00',1.53),('7643','2013-02-21','13:55:00',1.68),('7643','2013-02-21','14:00:00',1.66),('7643','2013-02-21','14:05:00',1.69),('7643','2013-02-21','14:10:00',2.29),('7643','2013-02-21','14:15:00',2.78),('7643','2013-02-21','14:20:00',3.2),('7643','2013-02-21','14:25:00',2.04),('7643','2013-02-21','14:30:00',3.47),('7643','2013-02-21','14:35:00',4.56),('7643','2013-02-21','14:40:00',4.83),('7643','2013-02-21','14:45:00',4.05),('7643','2013-02-21','14:50:00',3.02),('7643','2013-02-21','14:55:00',5.22),('7643','2013-02-21','15:00:00',2.96),('7643','2013-02-21','15:05:00',1.29),('7643','2013-02-21','15:45:00',1.89),('7643','2013-02-21','15:50:00',2.94),('7643','2013-02-21','15:55:00',2.07),('7643','2013-02-21','16:00:00',1.46),('7643','2013-02-21','16:05:00',1.13),('7643','2013-02-21','16:10:00',2.02),('7643','2013-02-21','16:15:00',1.78),('7643','2013-02-21','16:20:00',4.44),('7643','2013-02-21','16:25:00',5.12),('7643','2013-02-21','16:30:00',4.44),('7643','2013-02-21','16:35:00',2.15),('7643','2013-02-21','16:40:00',1.32),('7643','2013-02-20','08:40:00',1.01),('7643','2013-02-20','08:50:00',1.01),('7643','2013-02-20','08:55:00',1.04),('7643','2013-02-20','09:00:00',1.17),('7643','2013-02-20','09:05:00',1.13),('7643','2013-02-20','09:10:00',1.23),('7643','2013-02-20','09:15:00',1.3),('7643','2013-02-20','09:20:00',1.52),('7643','2013-02-20','09:25:00',1.72),('7643','2013-02-20','09:30:00',1.9),('7643','2013-02-20','09:35:00',1.9),('7643','2013-02-20','09:40:00',2.13),('7643','2013-02-20','09:45:00',2.75),('7643','2013-02-20','09:50:00',3.03),('7643','2013-02-20','09:55:00',3.06),('7643','2013-02-20','10:00:00',2.91),('7643','2013-02-20','10:05:00',2.85),('7643','2013-02-20','10:10:00',2.91),('7643','2013-02-20','10:15:00',2.81),('7643','2013-02-20','10:20:00',2.8),('7643','2013-02-20','10:25:00',2.77),('7643','2013-02-20','10:30:00',2.79),('7643','2013-02-20','10:35:00',2.89),('7643','2013-02-20','10:40:00',2.99),('7643','2013-02-20','10:45:00',2.88),('7643','2013-02-20','10:50:00',2.83),('7643','2013-02-20','10:55:00',2.91),('7643','2013-02-20','11:00:00',2.61),('7643','2013-02-20','11:05:00',2.4),('7643','2013-02-20','11:10:00',2.31),('7643','2013-02-20','11:15:00',2.44),('7643','2013-02-20','11:20:00',2.88),('7643','2013-02-20','11:25:00',3.23),('7643','2013-02-20','11:30:00',3.47),('7643','2013-02-20','11:35:00',3.65),('7643','2013-02-20','11:40:00',3.62),('7643','2013-02-20','11:45:00',3.8),('7643','2013-02-20','11:50:00',4.19),('7643','2013-02-20','11:55:00',4.36),('7643','2013-02-20','12:00:00',4.33),('7643','2013-02-20','12:05:00',4.29),('7643','2013-02-20','12:10:00',4.49),('7643','2013-02-20','12:15:00',4.77),('7643','2013-02-20','12:20:00',5.16),('7643','2013-02-20','12:25:00',5.07),('7643','2013-02-20','12:30:00',4.75),('7643','2013-02-20','12:35:00',4.49),('7643','2013-02-20','12:40:00',4.32),('7643','2013-02-20','12:45:00',4.35),('7643','2013-02-20','12:50:00',4.43),('7643','2013-02-20','12:55:00',4.79),('7643','2013-02-20','13:00:00',4.91),('7643','2013-02-20','13:05:00',4.56),('7643','2013-02-20','13:10:00',4.27),('7643','2013-02-20','13:15:00',4.31),('7643','2013-02-20','13:20:00',4.44),('7643','2013-02-20','13:25:00',4.56),('7643','2013-02-20','13:30:00',4.65),('7643','2013-02-20','13:35:00',4.7),('7643','2013-02-20','13:40:00',4.56),('7643','2013-02-20','13:45:00',4.35),('7643','2013-02-20','13:50:00',4.43),('7643','2013-02-20','13:55:00',4.48),('7643','2013-02-20','14:00:00',4.51),('7643','2013-02-20','14:05:00',4.33),('7643','2013-02-20','14:10:00',4.03),('7643','2013-02-20','14:15:00',3.59),('7643','2013-02-20','14:20:00',3.17),('7643','2013-02-20','14:25:00',2.89),('7643','2013-02-20','14:30:00',2.96),('7643','2013-02-20','14:35:00',3.01),('7643','2013-02-20','14:40:00',2.91),('7643','2013-02-20','14:45:00',2.81),('7643','2013-02-20','14:50:00',2.71),('7643','2013-02-20','14:55:00',2.42),('7643','2013-02-20','15:00:00',2.11),('7643','2013-02-20','15:05:00',1.96),('7643','2013-02-20','15:10:00',1.97),('7643','2013-02-20','15:15:00',1.94),('7643','2013-02-20','15:20:00',1.91),('7643','2013-02-20','15:25:00',1.9),('7643','2013-02-20','15:30:00',1.93),('7643','2013-02-20','15:35:00',1.88),('7643','2013-02-20','15:40:00',1.95),('7643','2013-02-20','15:45:00',2.14),('7643','2013-02-20','15:50:00',2.46),('7643','2013-02-20','15:55:00',2.82),('7643','2013-02-20','16:00:00',3.27),('7643','2013-02-20','16:05:00',3.58),('7643','2013-02-20','16:10:00',3.12),('7643','2013-02-20','16:15:00',3.27),('7643','2013-02-20','16:20:00',4.78),('7643','2013-02-20','16:25:00',5.83),('7643','2013-02-20','16:30:00',5.35),('7643','2013-02-20','16:35:00',4.57),('7643','2013-02-20','16:40:00',3.63),('7643','2013-02-20','16:45:00',2.95),('7643','2013-02-20','16:50:00',2.45),('7643','2013-02-20','16:55:00',2.05),('7643','2013-02-20','17:00:00',1.69),('7643','2013-02-20','17:05:00',1.37),('7643','2013-02-20','17:10:00',1.03),('7643','2014-03-22','06:50:00',1.13),('7643','2014-03-22','06:55:00',1.19),('7643','2014-03-22','07:05:00',1.26),('7643','2014-03-22','07:10:00',1.54),('7643','2014-03-22','07:15:00',1.24),('7643','2014-03-22','07:20:00',1.24),('7643','2014-03-22','07:45:00',1.01),('7643','2014-03-22','07:55:00',1.26),('7643','2014-03-22','08:00:00',1.94),('7643','2014-03-22','08:05:00',2.46),('7643','2014-03-22','08:10:00',2.69),('7643','2014-03-22','08:15:00',2.75),('7643','2014-03-22','08:20:00',3.02),('7643','2014-03-22','08:25:00',3.4),('7643','2014-03-22','08:30:00',3.89),('7643','2014-03-22','08:35:00',4.4),('7643','2014-03-22','08:40:00',3.1),('7643','2014-03-22','08:45:00',3.35),('7643','2014-03-22','08:50:00',4.66),('7643','2014-03-22','08:55:00',6.24),('7643','2014-03-22','09:00:00',3.88),('7643','2014-03-22','09:05:00',6.56),('7643','2014-03-22','09:10:00',10.61),('7643','2014-03-22','09:15:00',10.48),('7643','2014-03-22','09:20:00',7.2),('7643','2014-03-22','09:25:00',4.14),('7643','2014-03-22','09:30:00',5.43),('7643','2014-03-22','09:35:00',5.45),('7643','2014-03-22','09:40:00',4.88),('7643','2014-03-22','09:45:00',3.69),('7643','2014-03-22','09:50:00',3.24),('7643','2014-03-22','09:55:00',2.87),('7643','2014-03-22','10:00:00',2.68),('7643','2014-03-22','10:05:00',2.59),('7643','2014-03-22','10:10:00',3.15),('7643','2014-03-22','10:15:00',2.48),('7643','2014-03-22','10:20:00',2.91),('7643','2014-03-22','10:25:00',4.49),('7643','2014-03-22','10:30:00',3.89),('7643','2014-03-22','10:35:00',3.07),('7643','2014-03-22','10:40:00',4.57),('7643','2014-03-22','10:45:00',4.2),('7643','2014-03-22','10:50:00',4.42),('7643','2014-03-22','10:55:00',6.52),('7643','2014-03-22','11:00:00',5.1),('7643','2014-03-22','11:05:00',4.01),('7643','2014-03-22','11:10:00',5.34),('7643','2014-03-22','11:15:00',3.31),('7643','2014-03-22','11:20:00',2.85),('7643','2014-03-22','11:25:00',3.93),('7643','2014-03-22','11:30:00',3.2),('7643','2014-03-22','11:35:00',4.86),('7643','2014-03-22','11:40:00',10.14),('7643','2014-03-22','11:45:00',3.69),('7643','2014-03-22','11:50:00',1.95),('7643','2014-03-22','11:55:00',3.47),('7643','2014-03-22','12:00:00',3.52),('7643','2014-03-22','12:05:00',2),('7643','2014-03-22','12:15:00',1.21),('7643','2014-03-22','12:20:00',1.07),('7643','2014-03-22','12:25:00',1.36),('7643','2014-03-22','12:30:00',2.06),('7643','2014-03-22','12:35:00',2.56),('7643','2014-03-22','12:40:00',2.11),('7643','2014-03-22','12:45:00',1.38),('7643','2014-03-22','13:05:00',1.83),('7643','2014-03-22','13:10:00',1.87),('7643','2014-03-22','13:15:00',1.84),('7643','2014-03-22','13:35:00',1.53),('7643','2014-03-22','13:40:00',3.02),('7643','2014-03-22','13:45:00',8.28),('7643','2014-03-22','13:50:00',6.8),('7643','2014-03-22','13:55:00',4.04),('7643','2014-03-22','14:00:00',3.68),('7643','2014-03-22','14:05:00',2.57),('7643','2014-03-22','14:10:00',1.58),('7643','2014-03-22','14:15:00',1.94),('7643','2014-03-22','14:20:00',1.23),('7643','2014-03-22','14:25:00',1.31),('7643','2014-03-22','14:30:00',1.47),('7643','2014-03-22','14:35:00',1.33),('7643','2014-03-22','14:45:00',1.14),('7643','2014-03-22','14:50:00',4.03),('7643','2014-03-22','14:55:00',3.74),('7643','2014-03-22','15:00:00',2.17),('7643','2014-03-22','15:05:00',3.54),('7643','2014-03-22','15:10:00',5.16),('7643','2014-03-22','15:15:00',7.61),('7643','2014-03-22','15:20:00',6.18),('7643','2014-03-22','15:25:00',6.72),('7643','2014-03-22','15:30:00',3.4),('7643','2014-03-22','15:35:00',3.96),('7643','2014-03-22','15:40:00',3.45),('7643','2014-03-22','15:45:00',2.82),('7643','2014-03-22','15:50:00',1.06),('7643','2014-03-22','17:35:00',1.26),('7643','2014-03-22','17:40:00',1.27),('7643','2013-02-19','07:50:00',1.26),('7643','2013-02-19','07:55:00',1.83),('7643','2013-02-19','08:00:00',1.73),('7643','2013-02-19','08:05:00',1.68),('7643','2013-02-19','08:10:00',1.84),('7643','2013-02-19','08:15:00',3.73),('7643','2013-02-19','08:20:00',4.79),('7643','2013-02-19','08:25:00',5.13),('7643','2013-02-19','08:30:00',5.53),('7643','2013-02-19','08:35:00',5.95),('7643','2013-02-19','08:40:00',6.33),('7643','2013-02-19','08:45:00',6.72),('7643','2013-02-19','08:50:00',7.1),('7643','2013-02-19','08:55:00',7.44),('7643','2013-02-19','09:00:00',7.92),('7643','2013-02-19','09:05:00',4.48),('7643','2013-02-19','09:10:00',5.51),('7643','2013-02-19','09:15:00',5.57),('7643','2013-02-19','09:20:00',4.57),('7643','2013-02-19','09:25:00',5.8),('7643','2013-02-19','09:30:00',8.12),('7643','2013-02-19','09:35:00',5.3),('7643','2013-02-19','09:40:00',4.48),('7643','2013-02-19','09:45:00',5.87),('7643','2013-02-19','09:50:00',6.34),('7643','2013-02-19','09:55:00',5.65),('7643','2013-02-19','10:00:00',3.69),('7643','2013-02-19','10:05:00',6.14),('7643','2013-02-19','10:10:00',4.22),('7643','2013-02-19','10:15:00',5.64),('7643','2013-02-19','10:20:00',3.08),('7643','2013-02-19','10:25:00',2.97),('7643','2013-02-19','10:30:00',2.81),('7643','2013-02-19','10:35:00',2.64),('7643','2013-02-19','10:40:00',3.32),('7643','2013-02-19','10:45:00',4.85),('7643','2013-02-19','10:50:00',14.06),('7643','2013-02-19','10:55:00',9.83),('7643','2013-02-19','11:00:00',2.91),('7643','2013-02-19','11:05:00',11.23),('7643','2013-02-19','11:10:00',11.7),('7643','2013-02-19','11:15:00',13.31),('7643','2013-02-19','11:20:00',4.56),('7643','2013-02-19','11:25:00',14.65),('7643','2013-02-19','11:30:00',15.51),('7643','2013-02-19','11:35:00',16.82),('7643','2013-02-19','11:40:00',16.97),('7643','2013-02-19','11:45:00',14.13),('7643','2013-02-19','11:50:00',15.29),('7643','2013-02-19','11:55:00',11.82),('7643','2013-02-19','12:00:00',15.75),('7643','2013-02-19','12:05:00',16.55),('7643','2013-02-19','12:10:00',14.62),('7643','2013-02-19','12:15:00',5.14),('7643','2013-02-19','12:20:00',6.04),('7643','2013-02-19','12:25:00',13.72),('7643','2013-02-19','12:30:00',16.89),('7643','2013-02-19','12:35:00',14.11),('7643','2013-02-19','12:40:00',7.94),('7643','2013-02-19','12:45:00',4.31),('7643','2013-02-19','12:50:00',4.29),('7643','2013-02-19','12:55:00',5.21),('7643','2013-02-19','13:00:00',14.29),('7643','2013-02-19','13:05:00',15.94),('7643','2013-02-19','13:10:00',15.52),('7643','2013-02-19','13:15:00',8.16),('7643','2013-02-19','13:20:00',4.42),('7643','2013-02-19','13:25:00',7.73),('7643','2013-02-19','13:30:00',13.29),('7643','2013-02-19','13:35:00',9.56),('7643','2013-02-19','13:40:00',6.48),('7643','2013-02-19','13:45:00',5.37),('7643','2013-02-19','13:50:00',5.84),('7643','2013-02-19','13:55:00',4.51),('7643','2013-02-19','14:00:00',7.84),('7643','2013-02-19','14:05:00',3.9),('7643','2013-02-19','14:10:00',3.83),('7643','2013-02-19','14:15:00',3.52),('7643','2013-02-19','14:20:00',2.89),('7643','2013-02-19','14:25:00',2.39),('7643','2013-02-19','14:30:00',3.02),('7643','2013-02-19','14:35:00',3.58),('7643','2013-02-19','14:40:00',3.87),('7643','2013-02-19','14:45:00',3.58),('7643','2013-02-19','14:50:00',3.37),('7643','2013-02-19','14:55:00',3.42),('7643','2013-02-19','15:00:00',3.27),('7643','2013-02-19','15:05:00',3.72),('7643','2013-02-19','15:10:00',3.83),('7643','2013-02-19','15:15:00',5.86),('7643','2013-02-19','15:20:00',7.93),('7643','2013-02-19','15:25:00',8.27),('7643','2013-02-19','15:30:00',4.32),('7643','2013-02-19','15:35:00',2.87),('7643','2013-02-19','15:40:00',2.4),('7643','2013-02-19','15:45:00',2.58),('7643','2013-02-19','15:50:00',2.91),('7643','2013-02-19','15:55:00',3.6),('7643','2013-02-19','16:00:00',5.72),('7643','2013-02-19','16:05:00',7.18),('7643','2013-02-19','16:10:00',6.65),('7643','2013-02-19','16:15:00',6.08),('7643','2013-02-19','16:20:00',5.41),('7643','2013-02-19','16:25:00',4.59),('7643','2013-02-19','16:30:00',4.29),('7643','2013-02-19','16:35:00',3.26),('7643','2013-02-19','16:40:00',2.27),('7643','2013-02-19','16:45:00',2.2),('7643','2013-02-19','16:50:00',1.87),('7643','2013-02-19','16:55:00',1.71),('7643','2013-02-19','17:00:00',1.59),('7643','2013-02-19','17:05:00',1.44),('7643','2013-02-19','17:10:00',1.09),('7643','2013-02-18','07:30:00',1.11),('7643','2013-02-18','07:35:00',1.4),('7643','2013-02-18','07:40:00',1.68),('7643','2013-02-18','07:45:00',2.02),('7643','2013-02-18','07:50:00',2.38),('7643','2013-02-18','07:55:00',2.73),('7643','2013-02-18','08:00:00',3.12),('7643','2013-02-18','08:05:00',3.49),('7643','2013-02-18','08:10:00',3.86),('7643','2013-02-18','08:15:00',4.26),('7643','2013-02-18','08:20:00',4.65),('7643','2013-02-18','08:25:00',5.05),('7643','2013-02-18','08:30:00',5.44),('7643','2013-02-18','08:35:00',5.83),('7643','2013-02-18','08:40:00',6.15),('7643','2013-02-18','08:45:00',6.5),('7643','2013-02-18','08:50:00',6.88),('7643','2013-02-18','08:55:00',7.19),('7643','2013-02-18','09:00:00',7.49),('7643','2013-02-18','09:05:00',7.8),('7643','2013-02-18','09:10:00',8.11),('7643','2013-02-18','09:15:00',8.4),('7643','2013-02-18','09:20:00',8.74),('7643','2013-02-18','09:25:00',9.01),('7643','2013-02-18','09:30:00',9.26),('7643','2013-02-18','09:35:00',9.51),('7643','2013-02-18','09:40:00',9.73),('7643','2013-02-18','09:45:00',9.99),('7643','2013-02-18','09:50:00',10.22),('7643','2013-02-18','09:55:00',10.51),('7643','2013-02-18','10:00:00',10.66),('7643','2013-02-18','10:05:00',10.92),('7643','2013-02-18','10:10:00',11.2),('7643','2013-02-18','10:15:00',11.38),('7643','2013-02-18','10:20:00',11.64),('7643','2013-02-18','10:25:00',11.84),('7643','2013-02-18','10:30:00',11.98),('7643','2013-02-18','10:35:00',12.14),('7643','2013-02-18','10:40:00',12.38),('7643','2013-02-18','10:45:00',12.44),('7643','2013-02-18','10:50:00',12.52),('7643','2013-02-18','10:55:00',12.59),('7643','2013-02-18','11:00:00',12.81),('7643','2013-02-18','11:05:00',13),('7643','2013-02-18','11:10:00',13.16),('7643','2013-02-18','11:15:00',13.18),('7643','2013-02-18','11:20:00',13.24),('7643','2013-02-18','11:25:00',13.42),('7643','2013-02-18','11:30:00',13.44),('7643','2013-02-18','11:35:00',13.53),('7643','2013-02-18','11:40:00',13.64),('7643','2013-02-18','11:45:00',13.6),('7643','2013-02-18','11:50:00',13.67),('7643','2013-02-18','11:55:00',13.82),('7643','2013-02-18','12:00:00',13.9),('7643','2013-02-18','12:05:00',13.88),('7643','2013-02-18','12:10:00',13.82),('7643','2013-02-18','12:15:00',13.7),('7643','2013-02-18','12:20:00',13.59),('7643','2013-02-18','12:25:00',13.31),('7643','2013-02-18','12:30:00',13.4),('7643','2013-02-18','12:35:00',13.42),('7643','2013-02-18','12:40:00',13.47),('7643','2013-02-18','12:45:00',13.45),('7643','2013-02-18','12:50:00',13.47),('7643','2013-02-18','12:55:00',13.48),('7643','2013-02-18','13:00:00',13.49),('7643','2013-02-18','13:05:00',13.31),('7643','2013-02-18','13:10:00',13.27),('7643','2013-02-18','13:15:00',13.16),('7643','2013-02-18','13:20:00',12.99),('7643','2013-02-18','13:25:00',12.93),('7643','2013-02-18','13:30:00',12.95),('7643','2013-02-18','13:35:00',12.78),('7643','2013-02-18','13:40:00',12.73),('7643','2013-02-18','13:45:00',12.6),('7643','2013-02-18','13:50:00',12.38),('7643','2013-02-18','13:55:00',12.36),('7643','2013-02-18','14:00:00',12),('7643','2013-02-18','14:05:00',11.67),('7643','2013-02-18','14:10:00',11.48),('7643','2013-02-18','14:15:00',11.31),('7643','2013-02-18','14:20:00',10.77),('7643','2013-02-18','14:25:00',5.96),('7643','2013-02-18','14:30:00',3.83),('7643','2013-02-18','14:35:00',10.23),('7643','2013-02-18','14:40:00',10.24),('7643','2013-02-18','14:45:00',9.79),('7643','2013-02-18','14:50:00',9.77),('7643','2013-02-18','14:55:00',9.37),('7643','2013-02-18','15:00:00',9.17),('7643','2013-02-18','15:05:00',8.95),('7643','2013-02-18','15:10:00',8.78),('7643','2013-02-18','15:15:00',8.57),('7643','2013-02-18','15:20:00',8.07),('7643','2013-02-18','15:25:00',7.75),('7643','2013-02-18','15:30:00',7.32),('7643','2013-02-18','15:35:00',7.03),('7643','2013-02-18','15:40:00',6.83),('7643','2013-02-18','15:45:00',6.58),('7643','2013-02-18','15:50:00',6.19),('7643','2013-02-18','15:55:00',5.84),('7643','2013-02-18','16:00:00',5.56),('7643','2013-02-18','16:05:00',5.2),('7643','2013-02-18','16:10:00',4.86),('7643','2013-02-18','16:15:00',4.52),('7643','2013-02-18','16:20:00',4.14),('7643','2013-02-18','16:25:00',3.77),('7643','2013-02-18','16:30:00',3.44),('7643','2013-02-18','16:35:00',3.15),('7643','2013-02-18','16:40:00',2.75),('7643','2013-02-18','16:45:00',2.37),('7643','2013-02-18','16:50:00',2.09),('7643','2013-02-18','16:55:00',1.77),('7643','2013-02-18','17:00:00',1.48),('7643','2013-02-18','17:05:00',1.23),('7643','2013-02-17','07:50:00',1.36),('7643','2013-02-17','07:55:00',2.36),('7643','2013-02-17','08:00:00',2.87),('7643','2013-02-17','08:05:00',3.21),('7643','2013-02-17','08:10:00',3.61),('7643','2013-02-17','08:15:00',3.95),('7643','2013-02-17','08:20:00',4.29),('7643','2013-02-17','08:25:00',4.63),('7643','2013-02-17','08:30:00',5.07),('7643','2013-02-17','08:35:00',5.48),('7643','2013-02-17','08:40:00',5.77),('7643','2013-02-17','08:45:00',6.1),('7643','2013-02-17','08:50:00',6.38),('7643','2013-02-17','08:55:00',6.71),('7643','2013-02-17','09:00:00',7.04),('7643','2013-02-17','09:05:00',7.37),('7643','2013-02-17','09:10:00',7.72),('7643','2013-02-17','09:15:00',8.09),('7643','2013-02-17','09:20:00',8.52),('7643','2013-02-17','09:25:00',9.37),('7643','2013-02-17','09:30:00',8.71),('7643','2013-02-17','09:35:00',4.65),('7643','2013-02-17','09:40:00',3.71),('7643','2013-02-17','09:45:00',2.86),('7643','2013-02-17','09:50:00',7.3),('7643','2013-02-17','09:55:00',2.9),('7643','2013-02-17','10:00:00',3.25),('7643','2013-02-17','10:05:00',4.22),('7643','2013-02-17','10:10:00',3.25),('7643','2013-02-17','10:15:00',2.01),('7643','2013-02-17','10:20:00',2.06),('7643','2013-02-17','10:25:00',2.04),('7643','2013-02-17','10:30:00',2.38),('7643','2013-02-17','10:35:00',2.8),('7643','2013-02-17','10:40:00',3.24),('7643','2013-02-17','10:45:00',3.12),('7643','2013-02-17','10:50:00',2.71),('7643','2013-02-17','10:55:00',3.78),('7643','2013-02-17','11:00:00',4.85),('7643','2013-02-17','11:05:00',4.8),('7643','2013-02-17','11:10:00',5.02),('7643','2013-02-17','11:15:00',4.48),('7643','2013-02-17','11:20:00',5.15),('7643','2013-02-17','11:25:00',5.93),('7643','2013-02-17','11:30:00',5.17),('7643','2013-02-17','11:35:00',5.29),('7643','2013-02-17','11:40:00',5.18),('7643','2013-02-17','11:45:00',4.91),('7643','2013-02-17','11:50:00',5.29),('7643','2013-02-17','11:55:00',6.2),('7643','2013-02-17','12:00:00',6.87),('7643','2013-02-17','12:05:00',6),('7643','2013-02-17','12:10:00',5.51),('7643','2013-02-17','12:15:00',5.35),('7643','2013-02-17','12:20:00',5.16),('7643','2013-02-17','12:25:00',5.35),('7643','2013-02-17','12:30:00',4.98),('7643','2013-02-17','12:35:00',4.65),('7643','2013-02-17','12:40:00',4.95),('7643','2013-02-17','12:45:00',5.93),('7643','2013-02-17','12:50:00',5.92),('7643','2013-02-17','12:55:00',5.45),('7643','2013-02-17','13:00:00',5.37),('7643','2013-02-17','13:05:00',5.46),('7643','2013-02-17','13:10:00',5.36),('7643','2013-02-17','13:15:00',6.48),('7643','2013-02-17','13:20:00',5.43),('7643','2013-02-17','13:25:00',6.02),('7643','2013-02-17','13:30:00',6.06),('7643','2013-02-17','13:35:00',5.26),('7643','2013-02-17','13:40:00',4.97),('7643','2013-02-17','13:45:00',4.38),('7643','2013-02-17','13:50:00',4.63),('7643','2013-02-17','13:55:00',5.81),('7643','2013-02-17','14:00:00',5.53),('7643','2013-02-17','14:05:00',4.93),('7643','2013-02-17','14:10:00',4.67),('7643','2013-02-17','14:15:00',3.91),('7643','2013-02-17','14:20:00',4.41),('7643','2013-02-17','14:25:00',2.94),('7643','2013-02-17','14:30:00',2.19),('7643','2013-02-17','14:35:00',2.05),('7643','2013-02-17','14:40:00',1.89),('7643','2013-02-17','14:45:00',1.73),('7643','2013-02-17','14:50:00',1.37),('7643','2013-02-17','14:55:00',1.19),('7643','2013-02-17','15:00:00',1.47),('7643','2013-02-17','15:05:00',2.07),('7643','2013-02-17','15:10:00',2.1),('7643','2013-02-17','15:15:00',1.74),('7643','2013-02-17','15:20:00',1.62),('7643','2013-02-17','15:25:00',1.6),('7643','2013-02-17','15:30:00',1.79),('7643','2013-02-17','15:35:00',2.47),('7643','2013-02-17','15:40:00',2.36),('7643','2013-02-17','15:45:00',1.94),('7643','2013-02-17','15:50:00',1.7),('7643','2013-02-17','15:55:00',1.56),('7643','2013-02-16','07:35:00',1.16),('7643','2013-02-16','07:40:00',1.4),('7643','2013-02-16','07:45:00',1.61),('7643','2013-02-16','07:50:00',1.93),('7643','2013-02-16','07:55:00',2.28),('7643','2013-02-16','08:00:00',2.67),('7643','2013-02-16','08:05:00',3.04),('7643','2013-02-16','08:10:00',3.41),('7643','2013-02-16','08:15:00',3.83),('7643','2013-02-16','08:20:00',4.24),('7643','2013-02-16','08:25:00',4.58),('7643','2013-02-16','08:30:00',5.14),('7643','2013-02-16','08:35:00',5.72),('7643','2013-02-16','08:40:00',6.23),('7643','2013-02-16','08:45:00',6.25),('7643','2013-02-16','08:50:00',5.43),('7643','2013-02-16','08:55:00',6.38),('7643','2013-02-16','09:00:00',6.95),('7643','2013-02-16','09:05:00',6.8),('7643','2013-02-16','09:10:00',7.47),('7643','2013-02-16','09:15:00',7.88),('7643','2013-02-16','09:20:00',8.24),('7643','2013-02-16','09:25:00',8.46),('7643','2013-02-16','09:30:00',8.65),('7643','2013-02-16','09:35:00',8.78),('7643','2013-02-16','09:40:00',9.07),('7643','2013-02-16','09:45:00',9.41),('7643','2013-02-16','09:50:00',9.72),('7643','2013-02-16','09:55:00',10.01),('7643','2013-02-16','10:00:00',10.28),('7643','2013-02-16','10:05:00',10.45),('7643','2013-02-16','10:10:00',10.65),('7643','2013-02-16','10:15:00',10.84),('7643','2013-02-16','10:20:00',11.02),('7643','2013-02-16','10:25:00',11.15),('7643','2013-02-16','10:30:00',11.38),('7643','2013-02-16','10:35:00',11.58),('7643','2013-02-16','10:40:00',11.75),('7643','2013-02-16','10:45:00',11.8),('7643','2013-02-16','10:50:00',11.96),('7643','2013-02-16','10:55:00',12.15),('7643','2013-02-16','11:00:00',12.49),('7643','2013-02-16','11:05:00',12.5),('7643','2013-02-16','11:10:00',12.38),('7643','2013-02-16','11:15:00',12.47),('7643','2013-02-16','11:20:00',12.55),('7643','2013-02-16','11:25:00',12.63),('7643','2013-02-16','11:30:00',12.82),('7643','2013-02-16','11:35:00',12.96),('7643','2013-02-16','11:40:00',13.12),('7643','2013-02-16','11:45:00',13.11),('7643','2013-02-16','11:50:00',13.18),('7643','2013-02-16','11:55:00',13.22),('7643','2013-02-16','12:00:00',13.26),('7643','2013-02-16','12:05:00',13.34),('7643','2013-02-16','12:10:00',13.37),('7643','2013-02-16','12:15:00',13.38),('7643','2013-02-16','12:20:00',13.26),('7643','2013-02-16','12:25:00',13.19),('7643','2013-02-16','12:30:00',13.04),('7643','2013-02-16','12:35:00',13.02),('7643','2013-02-16','12:40:00',12.99),('7643','2013-02-16','12:45:00',12.96),('7643','2013-02-16','12:50:00',13.08),('7643','2013-02-16','12:55:00',12.93),('7643','2013-02-16','13:00:00',12.73),('7643','2013-02-16','13:05:00',12.63),('7643','2013-02-16','13:10:00',12.45),('7643','2013-02-16','13:15:00',12.28),('7643','2013-02-16','13:20:00',8.4),('7643','2013-02-16','13:25:00',2.83),('7643','2013-02-16','13:30:00',4.43),('7643','2013-02-16','13:35:00',11.94),('7643','2013-02-16','13:40:00',12.01),('7643','2013-02-16','13:45:00',11.21),('7643','2013-02-16','13:50:00',10.61),('7643','2013-02-16','13:55:00',10.18),('7643','2013-02-16','14:00:00',2.21),('7643','2013-02-16','14:05:00',2.06),('7643','2013-02-16','14:10:00',5.99),('7643','2013-02-16','14:15:00',6.39),('7643','2013-02-16','14:20:00',2.97),('7643','2013-02-16','14:25:00',2.38),('7643','2013-02-16','14:30:00',4.26),('7643','2013-02-16','14:35:00',3.13),('7643','2013-02-16','14:40:00',2.96),('7643','2013-02-16','14:45:00',2.01),('7643','2013-02-16','14:50:00',2.99),('7643','2013-02-16','14:55:00',2.4),('7643','2013-02-16','15:00:00',4.04),('7643','2013-02-16','15:05:00',8.77),('7643','2013-02-16','15:10:00',6.98),('7643','2013-02-16','15:15:00',9.8),('7643','2013-02-16','15:20:00',8.94),('7643','2013-02-16','15:25:00',7.5),('7643','2013-02-16','15:30:00',6.27),('7643','2013-02-16','15:35:00',8.01),('7643','2013-02-16','15:40:00',7.95),('7643','2013-02-16','15:45:00',7.43),('7643','2013-02-16','15:50:00',6.92),('7643','2013-02-16','15:55:00',6.6),('7643','2013-02-16','16:00:00',5.97),('7643','2013-02-16','16:05:00',5.55),('7643','2013-02-16','16:10:00',2.72),('7643','2013-02-16','16:15:00',1.87),('7643','2013-02-16','16:20:00',3.94),('7643','2013-02-16','16:25:00',4.41),('7643','2013-02-16','16:30:00',4.66),('7643','2013-02-16','16:35:00',3.36),('7643','2013-02-16','16:40:00',2.16),('7643','2013-02-16','16:45:00',1.57),('7643','2013-02-15','07:40:00',1.26),('7643','2013-02-15','07:55:00',2.14),('7643','2013-02-15','08:00:00',2.73),('7643','2013-02-15','08:05:00',3.1),('7643','2013-02-15','08:10:00',3.41),('7643','2013-02-15','08:15:00',3.75),('7643','2013-02-15','08:20:00',4.06),('7643','2013-02-15','08:25:00',4.47),('7643','2013-02-15','08:30:00',4.85),('7643','2013-02-15','08:35:00',5.28),('7643','2013-02-15','08:40:00',5.65),('7643','2013-02-15','08:45:00',6),('7643','2013-02-15','08:50:00',3.37),('7643','2013-02-15','08:55:00',1.54),('7643','2013-02-15','09:00:00',2.12),('7643','2013-02-15','09:05:00',2.24),('7643','2013-02-15','09:10:00',2.69),('7643','2013-02-15','09:15:00',7.52),('7643','2013-02-15','09:20:00',8.53),('7643','2013-02-15','09:25:00',8.84),('7643','2013-02-15','09:30:00',8.04),('7643','2013-02-15','09:35:00',9.02),('7643','2013-02-15','09:40:00',9.44),('7643','2013-02-15','09:45:00',9.66),('7643','2013-02-15','09:50:00',10.02),('7643','2013-02-15','09:55:00',10.17),('7643','2013-02-15','10:00:00',10.34),('7643','2013-02-15','10:05:00',10.44),('7643','2013-02-15','10:10:00',10.84),('7643','2013-02-15','10:15:00',11.06),('7643','2013-02-15','10:20:00',11.27),('7643','2013-02-15','10:25:00',11.41),('7643','2013-02-15','10:30:00',11.64),('7643','2013-02-15','10:35:00',12.07),('7643','2013-02-15','10:40:00',11.25),('7643','2013-02-15','10:45:00',12.77),('7643','2013-02-15','10:50:00',12.62),('7643','2013-02-15','10:55:00',11.04),('7643','2013-02-15','11:00:00',12.92),('7643','2013-02-15','11:05:00',11.85),('7643','2013-02-15','11:10:00',9.56),('7643','2013-02-15','11:15:00',12.8),('7643','2013-02-15','11:20:00',11.14),('7643','2013-02-15','11:25:00',12.52),('7643','2013-02-15','11:30:00',13.31),('7643','2013-02-15','11:35:00',13.39),('7643','2013-02-15','11:40:00',13.44),('7643','2013-02-15','11:45:00',13.52),('7643','2013-02-15','11:50:00',13.72),('7643','2013-02-15','11:55:00',13.74),('7643','2013-02-15','12:00:00',13.72),('7643','2013-02-15','12:05:00',13.63),('7643','2013-02-15','12:10:00',13.52),('7643','2013-02-15','12:15:00',13.69),('7643','2013-02-15','12:20:00',13.67),('7643','2013-02-15','12:25:00',13.69),('7643','2013-02-15','12:30:00',13.66),('7643','2013-02-15','12:35:00',13.66),('7643','2013-02-15','12:40:00',13.62),('7643','2013-02-15','12:45:00',13.65),('7643','2013-02-15','12:50:00',13.71),('7643','2013-02-15','12:55:00',13.45),('7643','2013-02-15','13:00:00',13.5),('7643','2013-02-15','13:05:00',13.41),('7643','2013-02-15','13:10:00',13.28),('7643','2013-02-15','13:15:00',13.25),('7643','2013-02-15','13:20:00',13.17),('7643','2013-02-15','13:25:00',12.91),('7643','2013-02-15','13:30:00',12.93),('7643','2013-02-15','13:35:00',12.67),('7643','2013-02-15','13:40:00',12.76),('7643','2013-02-15','13:45:00',12.85),('7643','2013-02-15','13:50:00',12.72),('7643','2013-02-15','13:55:00',12.32),('7643','2013-02-15','14:00:00',12.17),('7643','2013-02-15','14:05:00',11.97),('7643','2013-02-15','14:10:00',11.82),('7643','2013-02-15','14:15:00',11.08),('7643','2013-02-15','14:20:00',3.33),('7643','2013-02-15','14:25:00',3.56),('7643','2013-02-15','14:30:00',3.96),('7643','2013-02-15','14:35:00',3.73),('7643','2013-02-15','14:40:00',3.85),('7643','2013-02-15','14:45:00',4.06),('7643','2013-02-15','14:50:00',4.01),('7643','2013-02-15','14:55:00',3.38),('7643','2013-02-15','15:00:00',3.24),('7643','2013-02-15','15:05:00',3.29),('7643','2013-02-15','15:10:00',3.28),('7643','2013-02-15','15:15:00',3.64),('7643','2013-02-15','15:20:00',4.49),('7643','2013-02-15','15:25:00',4.1),('7643','2013-02-15','15:30:00',6.53),('7643','2013-02-15','15:35:00',5.72),('7643','2013-02-15','15:40:00',8.05),('7643','2013-02-15','15:45:00',8.65),('7643','2013-02-15','15:50:00',8.15),('7643','2013-02-15','15:55:00',4.44),('7643','2013-02-15','16:00:00',5.14),('7643','2013-02-15','16:05:00',6.21),('7643','2013-02-15','16:10:00',5.3),('7643','2013-02-15','16:15:00',2.69),('7643','2013-02-15','16:20:00',2.33),('7643','2013-02-15','16:25:00',3.18),('7643','2013-02-15','16:30:00',2.2),('7643','2013-02-15','16:35:00',1.62),('7643','2013-02-15','16:40:00',1.31),('7643','2013-02-15','16:45:00',1.04),('7643','2013-02-14','07:35:00',1.21),('7643','2013-02-14','07:40:00',1.54),('7643','2013-02-14','07:45:00',1.83),('7643','2013-02-14','07:50:00',2.16),('7643','2013-02-14','07:55:00',2.8),('7643','2013-02-14','08:00:00',3.07),('7643','2013-02-14','08:05:00',2.85),('7643','2013-02-14','08:10:00',2.84),('7643','2013-02-14','08:15:00',3.23),('7643','2013-02-14','08:20:00',2.46),('7643','2013-02-14','08:25:00',2.07),('7643','2013-02-14','08:30:00',1.83),('7643','2013-02-14','08:35:00',1.58),('7643','2013-02-14','08:40:00',1.58),('7643','2013-02-14','08:45:00',1.65),('7643','2013-02-14','08:50:00',1.98),('7643','2013-02-14','08:55:00',2.63),('7643','2013-02-14','09:00:00',2.39),('7643','2013-02-14','09:05:00',2.83),('7643','2013-02-14','09:10:00',2.54),('7643','2013-02-14','09:15:00',3.07),('7643','2013-02-14','09:20:00',3.66),('7643','2013-02-14','09:25:00',4.77),('7643','2013-02-14','09:30:00',4.28),('7643','2013-02-14','09:35:00',3.84),('7643','2013-02-14','09:40:00',4.04),('7643','2013-02-14','09:45:00',3.77),('7643','2013-02-14','09:50:00',3.88),('7643','2013-02-14','09:55:00',4.87),('7643','2013-02-14','10:00:00',6.65),('7643','2013-02-14','10:05:00',7.51),('7643','2013-02-14','10:10:00',5.19),('7643','2013-02-14','10:15:00',4.63),('7643','2013-02-14','10:20:00',6.17),('7643','2013-02-14','10:25:00',9.13),('7643','2013-02-14','10:30:00',7.49),('7643','2013-02-14','10:35:00',11.03),('7643','2013-02-14','10:40:00',10.92),('7643','2013-02-14','10:45:00',11.2),('7643','2013-02-14','10:50:00',11.47),('7643','2013-02-14','10:55:00',7.24),('7643','2013-02-14','11:00:00',7.05),('7643','2013-02-14','11:05:00',7.42),('7643','2013-02-14','11:10:00',7.82),('7643','2013-02-14','11:15:00',10.5),('7643','2013-02-14','11:20:00',13.28),('7643','2013-02-14','11:25:00',13.18),('7643','2013-02-14','11:30:00',13),('7643','2013-02-14','11:35:00',10.6),('7643','2013-02-14','11:40:00',8.11),('7643','2013-02-14','11:45:00',7.79),('7643','2013-02-14','11:50:00',14.55),('7643','2013-02-14','11:55:00',13.41),('7643','2013-02-14','12:00:00',11.02),('7643','2013-02-14','12:05:00',11.48),('7643','2013-02-14','12:10:00',11.04),('7643','2013-02-14','12:15:00',11.16),('7643','2013-02-14','12:20:00',14.97),('7643','2013-02-14','12:25:00',13.53),('7643','2013-02-14','12:30:00',13.73),('7643','2013-02-14','12:35:00',13.75),('7643','2013-02-14','12:40:00',13.53),('7643','2013-02-14','12:45:00',13.43),('7643','2013-02-14','12:50:00',13.27),('7643','2013-02-14','12:55:00',11.33),('7643','2013-02-14','13:00:00',13.44),('7643','2013-02-14','13:05:00',13.34),('7643','2013-02-14','13:10:00',13.18),('7643','2013-02-14','13:15:00',13.37),('7643','2013-02-14','13:20:00',12.74),('7643','2013-02-14','13:25:00',12.62),('7643','2013-02-14','13:30:00',9.38),('7643','2013-02-14','13:35:00',9.24),('7643','2013-02-14','13:40:00',12.39),('7643','2013-02-14','13:45:00',9.88),('7643','2013-02-14','13:50:00',10.16),('7643','2013-02-14','13:55:00',11.61),('7643','2013-02-14','14:00:00',8.1),('7643','2013-02-14','14:05:00',12.15),('7643','2013-02-14','14:10:00',14.18),('7643','2013-02-14','14:15:00',9.04),('7643','2013-02-14','14:20:00',10.18),('7643','2013-02-14','14:25:00',7.34),('7643','2013-02-14','14:30:00',7.09),('7643','2013-02-14','14:35:00',10.26),('7643','2013-02-14','14:40:00',10.88),('7643','2013-02-14','14:45:00',9.39),('7643','2013-02-14','14:50:00',5.66),('7643','2013-02-14','14:55:00',4.52),('7643','2013-02-14','15:00:00',6.6),('7643','2013-02-14','15:05:00',5.08),('7643','2013-02-14','15:10:00',4.89),('7643','2013-02-14','15:15:00',6.26),('7643','2013-02-14','15:20:00',5),('7643','2013-02-14','15:25:00',5.48),('7643','2013-02-14','15:30:00',6.25),('7643','2013-02-14','15:35:00',5.1),('7643','2013-02-14','15:40:00',5.01),('7643','2013-02-14','15:45:00',4.65),('7643','2013-02-14','15:50:00',3.24),('7643','2013-02-14','15:55:00',3.01),('7643','2013-02-14','16:00:00',2.69),('7643','2013-02-14','16:05:00',2.56),('7643','2013-02-14','16:10:00',2.34),('7643','2013-02-14','16:15:00',2.08),('7643','2013-02-14','16:20:00',1.75),('7643','2013-02-14','16:25:00',1.48),('7643','2013-02-14','16:30:00',1.35),('7643','2013-02-14','16:35:00',1.34),('7643','2013-02-14','16:40:00',1.44),('7643','2013-02-14','16:45:00',1.9),('7643','2013-02-14','16:50:00',1.6),('7643','2013-02-14','16:55:00',1.13),('7643','2013-02-13','07:35:00',1.21),('7643','2013-02-13','07:40:00',1.49),('7643','2013-02-13','07:45:00',1.81),('7643','2013-02-13','07:50:00',2.18),('7643','2013-02-13','07:55:00',2.55),('7643','2013-02-13','08:00:00',2.94),('7643','2013-02-13','08:05:00',3.33),('7643','2013-02-13','08:10:00',3.69),('7643','2013-02-13','08:15:00',4.03),('7643','2013-02-13','08:20:00',4.39),('7643','2013-02-13','08:25:00',4.8),('7643','2013-02-13','08:30:00',5.16),('7643','2013-02-13','08:35:00',5.6),('7643','2013-02-13','08:40:00',5.95),('7643','2013-02-13','08:45:00',6.31),('7643','2013-02-13','08:50:00',6.66),('7643','2013-02-13','08:55:00',7),('7643','2013-02-13','09:00:00',7.34),('7643','2013-02-13','09:05:00',7.68),('7643','2013-02-13','09:10:00',7.99),('7643','2013-02-13','09:15:00',8.35),('7643','2013-02-13','09:20:00',8.66),('7643','2013-02-13','09:25:00',8.97),('7643','2013-02-13','09:30:00',9.26),('7643','2013-02-13','09:35:00',9.54),('7643','2013-02-13','09:40:00',9.84),('7643','2013-02-13','09:45:00',10.09),('7643','2013-02-13','09:50:00',10.36),('7643','2013-02-13','09:55:00',10.6),('7643','2013-02-13','10:00:00',10.86),('7643','2013-02-13','10:05:00',11.12),('7643','2013-02-13','10:10:00',11.36),('7643','2013-02-13','10:15:00',11.58),('7643','2013-02-13','10:20:00',11.76),('7643','2013-02-13','10:25:00',11.94),('7643','2013-02-13','10:30:00',12.12),('7643','2013-02-13','10:35:00',12.29),('7643','2013-02-13','10:40:00',12.46),('7643','2013-02-13','10:45:00',12.64),('7643','2013-02-13','10:50:00',12.82),('7643','2013-02-13','10:55:00',12.93),('7643','2013-02-13','11:00:00',13.07),('7643','2013-02-13','11:05:00',13.19),('7643','2013-02-13','11:10:00',13.31),('7643','2013-02-13','11:15:00',13.38),('7643','2013-02-13','11:20:00',13.47),('7643','2013-02-13','11:25:00',13.57),('7643','2013-02-13','11:30:00',13.66),('7643','2013-02-13','11:35:00',13.73),('7643','2013-02-13','11:40:00',13.76),('7643','2013-02-13','11:45:00',13.77),('7643','2013-02-13','11:50:00',13.88),('7643','2013-02-13','11:55:00',13.93),('7643','2013-02-13','12:00:00',13.97),('7643','2013-02-13','12:05:00',13.98),('7643','2013-02-13','12:10:00',13.95),('7643','2013-02-13','12:15:00',14.01),('7643','2013-02-13','12:20:00',13.97),('7643','2013-02-13','12:25:00',13.92),('7643','2013-02-13','12:30:00',13.84),('7643','2013-02-13','12:35:00',13.84),('7643','2013-02-13','12:40:00',13.84),('7643','2013-02-13','12:45:00',13.75),('7643','2013-02-13','12:50:00',13.65),('7643','2013-02-13','12:55:00',13.63),('7643','2013-02-13','13:00:00',13.52),('7643','2013-02-13','13:05:00',13.39),('7643','2013-02-13','13:10:00',13.43),('7643','2013-02-13','13:15:00',13.41),('7643','2013-02-13','13:20:00',13.25),('7643','2013-02-13','13:25:00',13.11),('7643','2013-02-13','13:30:00',12.98),('7643','2013-02-13','13:35:00',12.84),('7643','2013-02-13','13:40:00',12.72),('7643','2013-02-13','13:45:00',12.54),('7643','2013-02-13','13:50:00',12.38),('7643','2013-02-13','13:55:00',12.21),('7643','2013-02-13','14:00:00',12.01),('7643','2013-02-13','14:05:00',11.87),('7643','2013-02-13','14:10:00',11.63),('7643','2013-02-13','14:15:00',11.44),('7643','2013-02-13','14:20:00',11.26),('7643','2013-02-13','14:25:00',10.98),('7643','2013-02-13','14:30:00',10.76),('7643','2013-02-13','14:35:00',10.48),('7643','2013-02-13','14:40:00',10.28),('7643','2013-02-13','14:45:00',10.04),('7643','2013-02-13','14:50:00',9.75),('7643','2013-02-13','14:55:00',9.47),('7643','2013-02-13','15:00:00',9.22),('7643','2013-02-13','15:05:00',8.91),('7643','2013-02-13','15:10:00',8.58),('7643','2013-02-13','15:15:00',8.37),('7643','2013-02-13','15:20:00',7.99),('7643','2013-02-13','15:25:00',7.66),('7643','2013-02-13','15:30:00',7.4),('7643','2013-02-13','15:35:00',7.03),('7643','2013-02-13','15:40:00',6.67),('7643','2013-02-13','15:45:00',6.38),('7643','2013-02-13','15:50:00',6.05),('7643','2013-02-13','15:55:00',5.68),('7643','2013-02-13','16:00:00',5.31),('7643','2013-02-13','16:05:00',4.96),('7643','2013-02-13','16:10:00',4.57),('7643','2013-02-13','16:15:00',4.21),('7643','2013-02-13','16:20:00',3.84),('7643','2013-02-13','16:25:00',3.48),('7643','2013-02-13','16:30:00',3.11),('7643','2013-02-13','16:35:00',2.75),('7643','2013-02-13','16:40:00',2.4),('7643','2013-02-13','16:45:00',2.07),('7643','2013-02-13','16:50:00',1.74),('7643','2013-02-13','16:55:00',1.43),('7643','2013-02-13','17:00:00',1.14),('7643','2013-02-12','08:15:00',1.19),('7643','2013-02-12','08:20:00',1.38),('7643','2013-02-12','08:25:00',1.56),('7643','2013-02-12','08:30:00',1.76),('7643','2013-02-12','08:35:00',1.97),('7643','2013-02-12','08:40:00',2.21),('7643','2013-02-12','08:45:00',2.5),('7643','2013-02-12','08:50:00',2.82),('7643','2013-02-12','08:55:00',3.4),('7643','2013-02-12','09:00:00',4.06),('7643','2013-02-12','09:05:00',4.75),('7643','2013-02-12','09:10:00',5.12),('7643','2013-02-12','09:15:00',5.19),('7643','2013-02-12','09:20:00',5.13),('7643','2013-02-12','09:25:00',5.31),('7643','2013-02-12','09:30:00',6.47),('7643','2013-02-12','09:35:00',7.82),('7643','2013-02-12','09:40:00',8.8),('7643','2013-02-12','09:45:00',9.37),('7643','2013-02-12','09:50:00',9.75),('7643','2013-02-12','09:55:00',9.63),('7643','2013-02-12','10:00:00',9.18),('7643','2013-02-12','10:05:00',10.1),('7643','2013-02-12','10:10:00',10.48),('7643','2013-02-12','10:15:00',11.2),('7643','2013-02-12','10:20:00',11.46),('7643','2013-02-12','10:25:00',11.93),('7643','2013-02-12','10:30:00',12.35),('7643','2013-02-12','10:35:00',12.41),('7643','2013-02-12','10:40:00',12.43),('7643','2013-02-12','10:45:00',13.07),('7643','2013-02-12','10:50:00',13.3),('7643','2013-02-12','10:55:00',13.36),('7643','2013-02-12','11:00:00',13.5),('7643','2013-02-12','11:05:00',12.87),('7643','2013-02-12','11:10:00',12.96),('7643','2013-02-12','11:15:00',13.46),('7643','2013-02-12','11:20:00',12.82),('7643','2013-02-12','11:25:00',11.62),('7643','2013-02-12','11:30:00',9.82),('7643','2013-02-12','11:35:00',7.38),('7643','2013-02-12','11:40:00',7.31),('7643','2013-02-12','11:45:00',8),('7643','2013-02-12','11:50:00',10.13),('7643','2013-02-12','11:55:00',6.48),('7643','2013-02-12','12:00:00',4.14),('7643','2013-02-12','12:05:00',5.26),('7643','2013-02-12','12:10:00',10.71),('7643','2013-02-12','12:15:00',6.79),('7643','2013-02-12','12:20:00',9.02),('7643','2013-02-12','12:25:00',4.76),('7643','2013-02-12','12:30:00',3.9),('7643','2013-02-12','12:35:00',4.9),('7643','2013-02-12','12:40:00',4.22),('7643','2013-02-12','12:45:00',7.97),('7643','2013-02-12','12:50:00',10.52),('7643','2013-02-12','12:55:00',11.07),('7643','2013-02-12','13:00:00',9.32),('7643','2013-02-12','13:05:00',11.3),('7643','2013-02-12','13:10:00',9.75),('7643','2013-02-12','13:15:00',5.49),('7643','2013-02-12','13:20:00',13.55),('7643','2013-02-12','13:25:00',13.1),('7643','2013-02-12','13:30:00',13.89),('7643','2013-02-12','13:35:00',13.26),('7643','2013-02-12','13:40:00',11.72),('7643','2013-02-12','13:45:00',10.34),('7643','2013-02-12','13:50:00',10.5),('7643','2013-02-12','13:55:00',10.45),('7643','2013-02-12','14:00:00',11.75),('7643','2013-02-12','14:05:00',12.54),('7643','2013-02-12','14:10:00',11.47),('7643','2013-02-12','14:15:00',10.99),('7643','2013-02-12','14:20:00',10.21),('7643','2013-02-12','14:25:00',9.84),('7643','2013-02-12','14:30:00',10.59),('7643','2013-02-12','14:35:00',10.82),('7643','2013-02-12','14:40:00',10.39),('7643','2013-02-12','14:45:00',9.73),('7643','2013-02-12','14:50:00',9.89),('7643','2013-02-12','14:55:00',9.56),('7643','2013-02-12','15:00:00',9.28),('7643','2013-02-12','15:05:00',8.97),('7643','2013-02-12','15:10:00',8.6),('7643','2013-02-12','15:15:00',8.26),('7643','2013-02-12','15:20:00',8.03),('7643','2013-02-12','15:25:00',7.74),('7643','2013-02-12','15:30:00',7.46),('7643','2013-02-12','15:35:00',7.18),('7643','2013-02-12','15:40:00',6.81),('7643','2013-02-12','15:45:00',6.44),('7643','2013-02-12','15:50:00',6.1),('7643','2013-02-12','15:55:00',5.7),('7643','2013-02-12','16:00:00',5.32),('7643','2013-02-12','16:05:00',5.09),('7643','2013-02-12','16:10:00',4.72),('7643','2013-02-12','16:15:00',4.45),('7643','2013-02-12','16:20:00',3.99),('7643','2013-02-12','16:25:00',3.51),('7643','2013-02-12','16:30:00',3.14),('7643','2013-02-12','16:35:00',2.86),('7643','2013-02-12','16:40:00',2.53),('7643','2013-02-12','16:45:00',2.17),('7643','2013-02-12','16:50:00',1.66),('7643','2013-02-12','16:55:00',1.43),('7643','2013-02-11','11:25:00',1.1),('7643','2013-02-11','11:30:00',1.14),('7643','2013-02-11','11:35:00',1.34),('7643','2013-02-11','11:40:00',1.61),('7643','2013-02-11','11:45:00',1.76),('7643','2013-02-11','11:50:00',1.81),('7643','2013-02-11','11:55:00',1.7),('7643','2013-02-11','12:00:00',1.42),('7643','2013-02-11','12:05:00',1.58),('7643','2013-02-11','12:10:00',2.05),('7643','2013-02-11','12:15:00',2.1),('7643','2013-02-11','12:20:00',2.08),('7643','2013-02-11','12:25:00',2.08),('7643','2013-02-11','12:30:00',2.09),('7643','2013-02-11','12:35:00',1.88),('7643','2013-02-11','12:40:00',1.77),('7643','2013-02-11','12:45:00',1.61),('7643','2013-02-11','12:50:00',1.68),('7643','2013-02-11','12:55:00',1.52),('7643','2013-02-11','13:00:00',1.39),('7643','2013-02-11','13:05:00',1.45),('7643','2013-02-11','13:10:00',1.26),('7643','2013-02-11','13:15:00',1.33),('7643','2013-02-11','13:20:00',1.46),('7643','2013-02-11','13:25:00',1.47),('7643','2013-02-11','13:30:00',1.71),('7643','2013-02-11','13:35:00',1.74),('7643','2013-02-11','13:40:00',1.64),('7643','2013-02-11','13:45:00',1.61),('7643','2013-02-11','13:50:00',1.43),('7643','2013-02-11','13:55:00',1.23),('7643','2013-02-11','14:00:00',1.16),('7643','2013-02-11','14:05:00',1.12),('7643','2013-02-11','14:10:00',1.14),('7643','2013-02-11','14:15:00',1.08),('7643','2013-02-11','14:20:00',1.02),('7643','2013-02-11','14:25:00',1.18),('7643','2013-02-11','14:30:00',1.26),('7643','2013-02-11','14:35:00',1.11),('7643','2013-02-11','14:40:00',1.07),('7643','2013-02-11','14:45:00',1.07),('7643','2013-02-11','14:50:00',1.06),('7643','2013-02-11','14:55:00',1.1),('7643','2013-02-11','15:00:00',1.18),('7643','2013-02-11','15:05:00',1.18),('7643','2013-02-11','15:10:00',1.06),('7643','2013-02-11','15:15:00',1.04),('7643','2013-02-11','15:20:00',1.01),('7643','2013-02-10','08:20:00',1.26),('7643','2013-02-10','08:35:00',1.15),('7643','2013-02-10','08:40:00',1.16),('7643','2013-02-10','08:45:00',1.2),('7643','2013-02-10','08:50:00',1.16),('7643','2013-02-10','08:55:00',1.34),('7643','2013-02-10','09:00:00',1.76),('7643','2013-02-10','09:05:00',1.9),('7643','2013-02-10','09:10:00',1.77),('7643','2013-02-10','09:15:00',2.01),('7643','2013-02-10','09:20:00',1.94),('7643','2013-02-10','09:25:00',1.95),('7643','2013-02-10','09:30:00',2.55),('7643','2013-02-10','09:35:00',2.39),('7643','2013-02-10','09:40:00',2.08),('7643','2013-02-10','09:45:00',1.75),('7643','2013-02-10','09:50:00',1.68),('7643','2013-02-10','09:55:00',1.84),('7643','2013-02-10','10:00:00',2.03),('7643','2013-02-10','10:05:00',2.05),('7643','2013-02-10','10:10:00',2.27),('7643','2013-02-10','10:15:00',2.81),('7643','2013-02-10','10:20:00',3.51),('7643','2013-02-10','10:25:00',3.7),('7643','2013-02-10','10:30:00',4.03),('7643','2013-02-10','10:35:00',4.66),('7643','2013-02-10','10:40:00',4.03),('7643','2013-02-10','10:45:00',3.08),('7643','2013-02-10','10:50:00',2.7),('7643','2013-02-10','10:55:00',2.66),('7643','2013-02-10','11:00:00',4.06),('7643','2013-02-10','11:05:00',5.11),('7643','2013-02-10','11:10:00',5.27),('7643','2013-02-10','11:15:00',5.34),('7643','2013-02-10','11:20:00',4.29),('7643','2013-02-10','11:25:00',2.99),('7643','2013-02-10','11:30:00',1.54),('7643','2013-02-10','11:35:00',2.13),('7643','2013-02-10','11:40:00',2.54),('7643','2013-02-10','11:45:00',3.57),('7643','2013-02-10','11:50:00',2.49),('7643','2013-02-10','11:55:00',2.15),('7643','2013-02-10','12:00:00',1.46),('7643','2013-02-10','12:05:00',1.25),('7643','2013-02-10','12:10:00',1.41),('7643','2013-02-10','12:15:00',1.42),('7643','2013-02-10','12:20:00',1.3),('7643','2013-02-10','12:25:00',1.55),('7643','2013-02-10','12:30:00',1.16),('7643','2013-02-10','12:35:00',1.86),('7643','2013-02-10','12:40:00',2.66),('7643','2013-02-10','12:45:00',4.54),('7643','2013-02-10','12:50:00',2.47),('7643','2013-02-10','12:55:00',2.08),('7643','2013-02-10','13:00:00',1.54),('7643','2013-02-10','13:05:00',1.42),('7643','2013-02-10','13:15:00',1.07),('7643','2013-02-10','13:50:00',1.5),('7643','2013-02-10','13:55:00',3.01),('7643','2013-02-10','14:00:00',3.52),('7643','2013-02-10','14:05:00',3.79),('7643','2013-02-10','14:10:00',4.12),('7643','2013-02-10','14:15:00',3.45),('7643','2013-02-10','14:20:00',3.64),('7643','2013-02-10','14:25:00',5.46),('7643','2013-02-10','14:30:00',7.29),('7643','2013-02-10','14:35:00',3.93),('7643','2013-02-10','14:40:00',5.65),('7643','2013-02-10','14:45:00',4.8),('7643','2013-02-10','14:50:00',3.15),('7643','2013-02-10','14:55:00',2.73),('7643','2013-02-10','15:00:00',2.02),('7643','2013-02-10','15:05:00',3.11),('7643','2013-02-10','15:10:00',4.19),('7643','2013-02-10','15:15:00',2.44),('7643','2013-02-10','15:20:00',2.48),('7643','2013-02-10','15:25:00',2.53),('7643','2013-02-10','15:30:00',2.28),('7643','2013-02-10','15:35:00',2.47),('7643','2013-02-10','15:40:00',2.63),('7643','2013-02-10','15:45:00',2.78),('7643','2013-02-10','15:50:00',2.45),('7643','2013-02-10','15:55:00',1.65),('7643','2013-02-10','16:20:00',1.06),('7643','2013-02-10','16:35:00',1.05),('7643','2014-03-21','07:00:00',1.04),('7643','2014-03-21','07:05:00',1.04),('7643','2014-03-21','07:10:00',1.1),('7643','2014-03-21','07:15:00',1.31),('7643','2014-03-21','07:20:00',1.35),('7643','2014-03-21','07:25:00',1.66),('7643','2014-03-21','07:30:00',2.09),('7643','2014-03-21','07:35:00',3.32),('7643','2014-03-21','07:40:00',5.35),('7643','2014-03-21','07:45:00',5.03),('7643','2014-03-21','07:50:00',4.53),('7643','2014-03-21','07:55:00',2.58),('7643','2014-03-21','08:00:00',1.95),('7643','2014-03-21','08:05:00',2.34),('7643','2014-03-21','08:10:00',4.12),('7643','2014-03-21','08:15:00',5.87),('7643','2014-03-21','08:20:00',7.04),('7643','2014-03-21','08:25:00',6.93),('7643','2014-03-21','08:30:00',7.64),('7643','2014-03-21','08:35:00',3.57),('7643','2014-03-21','08:40:00',6.52),('7643','2014-03-21','08:45:00',9.59),('7643','2014-03-21','08:50:00',7.06),('7643','2014-03-21','08:55:00',7.47),('7643','2014-03-21','09:00:00',9.25),('7643','2014-03-21','09:05:00',4.77),('7643','2014-03-21','09:10:00',5.57),('7643','2014-03-21','09:15:00',4.84),('7643','2014-03-21','09:20:00',5.15),('7643','2014-03-21','09:25:00',6.01),('7643','2014-03-21','09:30:00',8.12),('7643','2014-03-21','09:35:00',6.21),('7643','2014-03-21','09:40:00',8.34),('7643','2014-03-21','09:45:00',12.21),('7643','2014-03-21','09:50:00',12.29),('7643','2014-03-21','09:55:00',12.71),('7643','2014-03-21','10:00:00',13.08),('7643','2014-03-21','10:05:00',13.2),('7643','2014-03-21','10:10:00',13.94),('7643','2014-03-21','10:15:00',8.55),('7643','2014-03-21','10:20:00',4.81),('7643','2014-03-21','10:25:00',4.2),('7643','2014-03-21','10:30:00',4.56),('7643','2014-03-21','10:35:00',6.44),('7643','2014-03-21','10:40:00',8.89),('7643','2014-03-21','10:45:00',12.2),('7643','2014-03-21','10:50:00',11.7),('7643','2014-03-21','10:55:00',6.52),('7643','2014-03-21','11:00:00',4.63),('7643','2014-03-21','11:05:00',6.1),('7643','2014-03-21','11:10:00',4.41),('7643','2014-03-21','11:15:00',5.93),('7643','2014-03-21','11:20:00',7.98),('7643','2014-03-21','11:25:00',16.47),('7643','2014-03-21','11:30:00',9.34),('7643','2014-03-21','11:35:00',6.24),('7643','2014-03-21','11:40:00',10.23),('7643','2014-03-21','11:45:00',8.75),('7643','2014-03-21','11:50:00',8.46),('7643','2014-03-21','11:55:00',12.72),('7643','2014-03-21','12:00:00',13.1),('7643','2014-03-21','12:05:00',6.9),('7643','2014-03-21','12:10:00',7.36),('7643','2014-03-21','12:15:00',13.43),('7643','2014-03-21','12:20:00',18.27),('7643','2014-03-21','12:25:00',9.74),('7643','2014-03-21','12:30:00',7.14),('7643','2014-03-21','12:35:00',11.3),('7643','2014-03-21','12:40:00',11.9),('7643','2014-03-21','12:45:00',11.4),('7643','2014-03-21','12:50:00',15.36),('7643','2014-03-21','12:55:00',10.26),('7643','2014-03-21','13:00:00',11.19),('7643','2014-03-21','13:05:00',9.73),('7643','2014-03-21','13:10:00',12.77),('7643','2014-03-21','13:15:00',14.21),('7643','2014-03-21','13:20:00',13.27),('7643','2014-03-21','13:25:00',10.57),('7643','2014-03-21','13:30:00',13.05),('7643','2014-03-21','13:35:00',14.94),('7643','2014-03-21','13:40:00',13.52),('7643','2014-03-21','13:45:00',12.68),('7643','2014-03-21','13:50:00',9.68),('7643','2014-03-21','13:55:00',7.64),('7643','2014-03-21','14:00:00',14.75),('7643','2014-03-21','14:05:00',11),('7643','2014-03-21','14:10:00',14.01),('7643','2014-03-21','14:15:00',13.51),('7643','2014-03-21','14:20:00',13.35),('7643','2014-03-21','14:25:00',12.8),('7643','2014-03-21','14:30:00',12.46),('7643','2014-03-21','14:35:00',12.28),('7643','2014-03-21','14:40:00',12),('7643','2014-03-21','14:45:00',11.83),('7643','2014-03-21','14:50:00',11.67),('7643','2014-03-21','14:55:00',11.37),('7643','2014-03-21','15:00:00',11.1),('7643','2014-03-21','15:05:00',10.98),('7643','2014-03-21','15:10:00',10.49),('7643','2014-03-21','15:15:00',9.99),('7643','2014-03-21','15:20:00',10.06),('7643','2014-03-21','15:25:00',8.5),('7643','2014-03-21','15:30:00',5.56),('7643','2014-03-21','15:35:00',6.79),('7643','2014-03-21','15:40:00',6.6),('7643','2014-03-21','15:45:00',6.8),('7643','2014-03-21','15:50:00',10.2),('7643','2014-03-21','15:55:00',10.07),('7643','2014-03-21','16:00:00',7.74),('7643','2014-03-21','16:05:00',7.79),('7643','2014-03-21','16:10:00',7.32),('7643','2014-03-21','16:15:00',5.39),('7643','2014-03-21','16:20:00',5.11),('7643','2014-03-21','16:25:00',3.35),('7643','2014-03-21','16:30:00',2.89),('7643','2014-03-21','16:35:00',1.97),('7643','2014-03-21','16:40:00',2.06),('7643','2014-03-21','16:45:00',1.55),('7643','2014-03-21','16:50:00',1.66),('7643','2014-03-21','16:55:00',2.17),('7643','2014-03-21','17:00:00',2.48),('7643','2014-03-21','17:05:00',2.14),('7643','2014-03-21','17:10:00',1.46),('7643','2014-03-21','17:25:00',1.39),('7643','2014-03-21','17:30:00',1.42),('7643','2014-03-21','17:35:00',1.16),('7643','2013-02-09','08:55:00',1.21),('7643','2013-02-09','09:00:00',1.56),('7643','2013-02-09','09:05:00',2.04),('7643','2013-02-09','09:10:00',2.21),('7643','2013-02-09','09:15:00',2.52),('7643','2013-02-09','09:20:00',2.18),('7643','2013-02-09','09:25:00',1.69),('7643','2013-02-09','09:30:00',1.94),('7643','2013-02-09','09:35:00',2.22),('7643','2013-02-09','09:40:00',3.58),('7643','2013-02-09','09:45:00',2.69),('7643','2013-02-09','09:50:00',6.63),('7643','2013-02-09','09:55:00',6.32),('7643','2013-02-09','10:00:00',8),('7643','2013-02-09','10:05:00',10.96),('7643','2013-02-09','10:10:00',10.46),('7643','2013-02-09','10:15:00',11.22),('7643','2013-02-09','10:20:00',11.39),('7643','2013-02-09','10:25:00',11.65),('7643','2013-02-09','10:30:00',11.9),('7643','2013-02-09','10:35:00',12.09),('7643','2013-02-09','10:40:00',12.19),('7643','2013-02-09','10:45:00',12.36),('7643','2013-02-09','10:50:00',12.5),('7643','2013-02-09','10:55:00',12.62),('7643','2013-02-09','11:00:00',12.75),('7643','2013-02-09','11:05:00',12.77),('7643','2013-02-09','11:10:00',12.92),('7643','2013-02-09','11:15:00',13.08),('7643','2013-02-09','11:20:00',13.16),('7643','2013-02-09','11:25:00',13.24),('7643','2013-02-09','11:30:00',13.34),('7643','2013-02-09','11:35:00',13.39),('7643','2013-02-09','11:40:00',13.52),('7643','2013-02-09','11:45:00',13.58),('7643','2013-02-09','11:50:00',13.57),('7643','2013-02-09','11:55:00',13.75),('7643','2013-02-09','12:00:00',13.83),('7643','2013-02-09','12:05:00',13.75),('7643','2013-02-09','12:10:00',13.75),('7643','2013-02-09','12:15:00',13.89),('7643','2013-02-09','12:20:00',13.86),('7643','2013-02-09','12:25:00',13.85),('7643','2013-02-09','12:30:00',13.83),('7643','2013-02-09','12:35:00',13.73),('7643','2013-02-09','12:40:00',13.62),('7643','2013-02-09','12:45:00',13.58),('7643','2013-02-09','12:50:00',13.51),('7643','2013-02-09','12:55:00',13.48),('7643','2013-02-09','13:00:00',13.33),('7643','2013-02-09','13:05:00',13.03),('7643','2013-02-09','13:10:00',12.91),('7643','2013-02-09','13:15:00',12.94),('7643','2013-02-09','13:20:00',12.77),('7643','2013-02-09','13:25:00',12.69),('7643','2013-02-09','13:30:00',12.63),('7643','2013-02-09','13:35:00',12.34),('7643','2013-02-09','13:40:00',12.12),('7643','2013-02-09','13:45:00',11.94),('7643','2013-02-09','13:50:00',11.86),('7643','2013-02-09','13:55:00',11.72),('7643','2013-02-09','14:00:00',11.39),('7643','2013-02-09','14:05:00',11.14),('7643','2013-02-09','14:10:00',10.96),('7643','2013-02-09','14:15:00',10.74),('7643','2013-02-09','14:20:00',10.61),('7643','2013-02-09','14:25:00',10.29),('7643','2013-02-09','14:30:00',10.14),('7643','2013-02-09','14:35:00',9.99),('7643','2013-02-09','14:40:00',8.29),('7643','2013-02-09','14:45:00',9.59),('7643','2013-02-09','14:50:00',9.37),('7643','2013-02-09','14:55:00',8.96),('7643','2013-02-09','15:00:00',5.03),('7643','2013-02-09','15:05:00',5.76),('7643','2013-02-09','15:10:00',5.86),('7643','2013-02-09','15:15:00',6.3),('7643','2013-02-09','15:20:00',3.63),('7643','2013-02-09','15:25:00',7.45),('7643','2013-02-09','15:30:00',6.69),('7643','2013-02-09','15:35:00',6.33),('7643','2013-02-09','15:40:00',3.43),('7643','2013-02-09','15:45:00',2.51),('7643','2013-02-09','15:50:00',1.7),('7643','2013-02-09','15:55:00',1.21),('7643','2013-02-09','16:00:00',1.22),('7643','2013-02-09','16:05:00',1.41),('7643','2013-02-09','16:10:00',1.36),('7643','2013-02-09','16:15:00',1.32),('7643','2013-02-09','16:20:00',1.89),('7643','2013-02-09','16:25:00',3.24),('7643','2013-02-09','16:30:00',3.14),('7643','2013-02-09','16:35:00',3.53),('7643','2013-02-09','16:40:00',2.65),('7643','2013-02-08','08:50:00',1.18),('7643','2013-02-08','08:55:00',1.27),('7643','2013-02-08','09:00:00',1.38),('7643','2013-02-08','09:05:00',1.66),('7643','2013-02-08','09:10:00',2.08),('7643','2013-02-08','09:15:00',2.27),('7643','2013-02-08','09:20:00',2.37),('7643','2013-02-08','09:25:00',2.74),('7643','2013-02-08','09:30:00',3.28),('7643','2013-02-08','09:35:00',3.52),('7643','2013-02-08','09:40:00',3.01),('7643','2013-02-08','09:45:00',2.66),('7643','2013-02-08','09:50:00',2.71),('7643','2013-02-08','09:55:00',2.65),('7643','2013-02-08','10:00:00',2.41),('7643','2013-02-08','10:05:00',2.26),('7643','2013-02-08','10:10:00',2.07),('7643','2013-02-08','10:15:00',1.94),('7643','2013-02-08','10:20:00',1.88),('7643','2013-02-08','10:25:00',1.91),('7643','2013-02-08','10:30:00',2.02),('7643','2013-02-08','10:35:00',2.18),('7643','2013-02-08','10:40:00',2.47),('7643','2013-02-08','10:45:00',3.06),('7643','2013-02-08','10:50:00',3.27),('7643','2013-02-08','10:55:00',3.5),('7643','2013-02-08','11:00:00',3.74),('7643','2013-02-08','11:05:00',3.87),('7643','2013-02-08','11:10:00',4),('7643','2013-02-08','11:15:00',4.2),('7643','2013-02-08','11:20:00',4.33),('7643','2013-02-08','11:25:00',4.41),('7643','2013-02-08','11:30:00',4.5),('7643','2013-02-08','11:35:00',4.36),('7643','2013-02-08','11:40:00',4.26),('7643','2013-02-08','11:45:00',4.35),('7643','2013-02-08','11:50:00',4.33),('7643','2013-02-08','11:55:00',4.19),('7643','2013-02-08','12:00:00',4.25),('7643','2013-02-08','12:05:00',4.22),('7643','2013-02-08','12:10:00',4.17),('7643','2013-02-08','12:15:00',4.21),('7643','2013-02-08','12:20:00',4.29),('7643','2013-02-08','12:25:00',4.31),('7643','2013-02-08','12:30:00',4.38),('7643','2013-02-08','12:35:00',4.64),('7643','2013-02-08','12:40:00',4.75),('7643','2013-02-08','12:45:00',4.76),('7643','2013-02-08','12:50:00',4.83),('7643','2013-02-08','12:55:00',4.77),('7643','2013-02-08','13:00:00',5.07),('7643','2013-02-08','13:05:00',5.84),('7643','2013-02-08','13:10:00',6.48),('7643','2013-02-08','13:15:00',7.13),('7643','2013-02-08','13:20:00',7.96),('7643','2013-02-08','13:25:00',8.51),('7643','2013-02-08','13:30:00',9.93),('7643','2013-02-08','13:35:00',9.95),('7643','2013-02-08','13:40:00',10.55),('7643','2013-02-08','13:45:00',11.17),('7643','2013-02-08','13:50:00',12.15),('7643','2013-02-08','13:55:00',11.47),('7643','2013-02-08','14:00:00',12.2),('7643','2013-02-08','14:05:00',10.75),('7643','2013-02-08','14:10:00',9.62),('7643','2013-02-08','14:15:00',10.23),('7643','2013-02-08','14:20:00',13.15),('7643','2013-02-08','14:25:00',13.25),('7643','2013-02-08','14:30:00',12.05),('7643','2013-02-08','14:35:00',10.93),('7643','2013-02-08','14:40:00',9.91),('7643','2013-02-08','14:45:00',9.25),('7643','2013-02-08','14:50:00',8.88),('7643','2013-02-08','14:55:00',9),('7643','2013-02-08','15:00:00',8.61),('7643','2013-02-08','15:05:00',8.22),('7643','2013-02-08','15:10:00',7.9),('7643','2013-02-08','15:15:00',7.64),('7643','2013-02-08','15:20:00',7.18),('7643','2013-02-08','15:25:00',6.71),('7643','2013-02-08','15:30:00',6.2),('7643','2013-02-08','15:35:00',6.26),('7643','2013-02-08','15:40:00',5.35),('7643','2013-02-08','15:45:00',3.73),('7643','2013-02-08','15:50:00',5.29),('7643','2013-02-08','15:55:00',5.08),('7643','2013-02-08','16:00:00',1.92),('7643','2013-02-08','16:05:00',1.43),('7643','2013-02-08','16:10:00',1.1),('7643','2013-02-08','16:15:00',1.08),('7643','2013-02-08','16:20:00',1.88),('7643','2013-02-08','16:25:00',2.73),('7643','2013-02-08','16:30:00',2.62),('7643','2013-02-08','16:35:00',2.36),('7643','2013-02-08','16:40:00',2.26),('7643','2013-02-08','16:45:00',1.8),('7643','2013-02-08','16:50:00',1.46),('7643','2013-02-08','16:55:00',1.59),('7643','2013-02-08','17:00:00',1.52),('7643','2013-02-08','17:05:00',1.2),('7643','2013-02-07','08:30:00',1.12),('7643','2013-02-07','08:35:00',1.37),('7643','2013-02-07','08:40:00',1.6),('7643','2013-02-07','08:45:00',1.77),('7643','2013-02-07','08:50:00',1.92),('7643','2013-02-07','08:55:00',2.21),('7643','2013-02-07','09:00:00',2.17),('7643','2013-02-07','09:05:00',2.04),('7643','2013-02-07','09:10:00',1.87),('7643','2013-02-07','09:15:00',2.01),('7643','2013-02-07','09:20:00',2.31),('7643','2013-02-07','09:25:00',2.63),('7643','2013-02-07','09:30:00',3.16),('7643','2013-02-07','09:35:00',6.61),('7643','2013-02-07','09:40:00',11.77),('7643','2013-02-07','09:45:00',9.38),('7643','2013-02-07','09:50:00',11.8),('7643','2013-02-07','09:55:00',11.62),('7643','2013-02-07','10:00:00',12.04),('7643','2013-02-07','10:05:00',12.86),('7643','2013-02-07','10:10:00',12.96),('7643','2013-02-07','10:15:00',12.81),('7643','2013-02-07','10:20:00',9.26),('7643','2013-02-07','10:25:00',10.74),('7643','2013-02-07','10:30:00',12.91),('7643','2013-02-07','10:35:00',5.27),('7643','2013-02-07','10:40:00',7.94),('7643','2013-02-07','10:45:00',12.18),('7643','2013-02-07','10:50:00',14.07),('7643','2013-02-07','10:55:00',13.74),('7643','2013-02-07','11:00:00',13.37),('7643','2013-02-07','11:05:00',13.17),('7643','2013-02-07','11:10:00',13.22),('7643','2013-02-07','11:15:00',13.23),('7643','2013-02-07','11:20:00',13.3),('7643','2013-02-07','11:25:00',13.33),('7643','2013-02-07','11:30:00',13.35),('7643','2013-02-07','11:35:00',13.38),('7643','2013-02-07','11:40:00',13.49),('7643','2013-02-07','11:45:00',13.47),('7643','2013-02-07','11:50:00',13.51),('7643','2013-02-07','11:55:00',13.51),('7643','2013-02-07','12:00:00',13.55),('7643','2013-02-07','12:05:00',13.61),('7643','2013-02-07','12:10:00',13.64),('7643','2013-02-07','12:15:00',13.64),('7643','2013-02-07','12:20:00',13.62),('7643','2013-02-07','12:25:00',13.65),('7643','2013-02-07','12:30:00',13.61),('7643','2013-02-07','12:35:00',13.63),('7643','2013-02-07','12:40:00',14),('7643','2013-02-07','12:45:00',14.76),('7643','2013-02-07','12:50:00',10.56),('7643','2013-02-07','12:55:00',7.79),('7643','2013-02-07','13:00:00',7.74),('7643','2013-02-07','13:05:00',6.96),('7643','2013-02-07','13:10:00',7.69),('7643','2013-02-07','13:15:00',7.34),('7643','2013-02-07','13:20:00',7.43),('7643','2013-02-07','13:25:00',7.24),('7643','2013-02-07','13:30:00',7.12),('7643','2013-02-07','13:35:00',9.39),('7643','2013-02-07','13:40:00',7.67),('7643','2013-02-07','13:45:00',6.03),('7643','2013-02-07','13:50:00',6.24),('7643','2013-02-07','13:55:00',6.28),('7643','2013-02-07','14:00:00',5.79),('7643','2013-02-07','14:05:00',5.77),('7643','2013-02-07','14:10:00',5.19),('7643','2013-02-07','14:15:00',4.69),('7643','2013-02-07','14:20:00',4.68),('7643','2013-02-07','14:25:00',5.05),('7643','2013-02-07','14:30:00',6.57),('7643','2013-02-07','14:35:00',7.62),('7643','2013-02-07','14:40:00',13.08),('7643','2013-02-07','14:45:00',12.43),('7643','2013-02-07','14:50:00',7.79),('7643','2013-02-07','14:55:00',8.75),('7643','2013-02-07','15:00:00',8.98),('7643','2013-02-07','15:05:00',11.76),('7643','2013-02-07','15:10:00',11.41),('7643','2013-02-07','15:15:00',10.23),('7643','2013-02-07','15:20:00',8.08),('7643','2013-02-07','15:25:00',8.21),('7643','2013-02-07','15:30:00',7.44),('7643','2013-02-07','15:35:00',6.99),('7643','2013-02-07','15:40:00',6.59),('7643','2013-02-07','15:45:00',6.25),('7643','2013-02-07','15:50:00',5.89),('7643','2013-02-07','15:55:00',5.45),('7643','2013-02-07','16:00:00',5.06),('7643','2013-02-07','16:05:00',4.63),('7643','2013-02-07','16:10:00',4.3),('7643','2013-02-07','16:15:00',3.46),('7643','2013-02-07','16:20:00',1.57),('7643','2013-02-07','16:30:00',1.06),('7643','2013-02-07','16:35:00',1.19),('7643','2013-02-07','16:40:00',1.03),('7643','2013-02-06','08:00:00',1.08),('7643','2013-02-06','09:10:00',1),('7643','2013-02-06','09:15:00',1.99),('7643','2013-02-06','09:20:00',2.31),('7643','2013-02-06','09:25:00',1.95),('7643','2013-02-06','09:30:00',1.93),('7643','2013-02-06','09:35:00',1.91),('7643','2013-02-06','09:40:00',1.97),('7643','2013-02-06','09:45:00',2.13),('7643','2013-02-06','09:50:00',2.3),('7643','2013-02-06','09:55:00',1.62),('7643','2013-02-06','10:00:00',1.25),('7643','2013-02-06','10:05:00',1.04),('7643','2013-02-06','10:20:00',1.46),('7643','2013-02-06','10:25:00',2.62),('7643','2013-02-06','10:30:00',2.49),('7643','2013-02-06','10:35:00',3.32),('7643','2013-02-06','10:40:00',4.19),('7643','2013-02-06','10:45:00',5.76),('7643','2013-02-06','10:50:00',2.8),('7643','2013-02-06','10:55:00',4.98),('7643','2013-02-06','11:00:00',5.33),('7643','2013-02-06','11:05:00',5.05),('7643','2013-02-06','11:10:00',3.4),('7643','2013-02-06','11:15:00',2.11),('7643','2013-02-06','11:20:00',1.51),('7643','2013-02-06','11:25:00',1.64),('7643','2013-02-06','11:30:00',2.08),('7643','2013-02-06','11:35:00',1.91),('7643','2013-02-06','12:20:00',2.6),('7643','2013-02-06','12:25:00',11.47),('7643','2013-02-06','12:30:00',8.33),('7643','2013-02-06','12:35:00',3.81),('7643','2013-02-06','12:40:00',2.24),('7643','2013-02-06','12:45:00',2.54),('7643','2013-02-06','12:50:00',2.74),('7643','2013-02-06','12:55:00',2.13),('7643','2013-02-06','13:00:00',1.78),('7643','2013-02-06','13:05:00',2.07),('7643','2013-02-06','13:10:00',2.63),('7643','2013-02-06','13:15:00',4.71),('7643','2013-02-06','13:20:00',5.14),('7643','2013-02-06','13:25:00',5.63),('7643','2013-02-06','13:30:00',4.17),('7643','2013-02-06','13:35:00',2.93),('7643','2013-02-06','13:40:00',3.3),('7643','2013-02-06','13:45:00',3.34),('7643','2013-02-06','13:50:00',3.42),('7643','2013-02-06','13:55:00',3.98),('7643','2013-02-06','14:00:00',4.93),('7643','2013-02-06','14:05:00',7.21),('7643','2013-02-06','14:10:00',11.66),('7643','2013-02-06','14:15:00',10.39),('7643','2013-02-06','14:20:00',7.65),('7643','2013-02-06','14:25:00',4.13),('7643','2013-02-06','14:30:00',3.3),('7643','2013-02-06','14:35:00',4.8),('7643','2013-02-06','14:40:00',5.54),('7643','2013-02-06','14:45:00',7.2),('7643','2013-02-06','14:50:00',5.98),('7643','2013-02-06','14:55:00',4.23),('7643','2013-02-06','15:00:00',7.47),('7643','2013-02-06','15:05:00',8.89),('7643','2013-02-06','15:10:00',10.01),('7643','2013-02-06','15:15:00',9),('7643','2013-02-06','15:20:00',5.76),('7643','2013-02-06','15:25:00',6.59),('7643','2013-02-06','15:30:00',4.98),('7643','2013-02-06','15:35:00',3.85),('7643','2013-02-06','15:40:00',2.73),('7643','2013-02-06','15:45:00',1.89),('7643','2013-02-06','15:50:00',2.04),('7643','2013-02-06','15:55:00',2),('7643','2013-02-06','16:00:00',1.55),('7643','2013-02-06','16:05:00',1.49),('7643','2013-02-06','16:10:00',1.1),('7643','2013-02-05','07:50:00',1.45),('7643','2013-02-05','07:55:00',1.63),('7643','2013-02-05','08:00:00',1.37),('7643','2013-02-05','08:05:00',1.3),('7643','2013-02-05','08:10:00',1.55),('7643','2013-02-05','08:15:00',1.6),('7643','2013-02-05','08:20:00',1.83),('7643','2013-02-05','08:25:00',1.9),('7643','2013-02-05','08:30:00',2.08),('7643','2013-02-05','08:35:00',2.64),('7643','2013-02-05','08:40:00',3.17),('7643','2013-02-05','08:45:00',4.1),('7643','2013-02-05','08:50:00',5.32),('7643','2013-02-05','08:55:00',4.02),('7643','2013-02-05','09:00:00',4.49),('7643','2013-02-05','09:05:00',4.84),('7643','2013-02-05','09:10:00',6.19),('7643','2013-02-05','09:15:00',3.88),('7643','2013-02-05','09:20:00',3.94),('7643','2013-02-05','09:25:00',4.38),('7643','2013-02-05','09:30:00',6.14),('7643','2013-02-05','09:35:00',4.46),('7643','2013-02-05','09:40:00',6.52),('7643','2013-02-05','09:45:00',4.77),('7643','2013-02-05','09:50:00',4.99),('7643','2013-02-05','09:55:00',6.38),('7643','2013-02-05','10:00:00',5.21),('7643','2013-02-05','10:05:00',7.19),('7643','2013-02-05','10:10:00',6.02),('7643','2013-02-05','10:15:00',5.27),('7643','2013-02-05','10:20:00',4.85),('7643','2013-02-05','10:25:00',6.57),('7643','2013-02-05','10:30:00',5.79),('7643','2013-02-05','10:35:00',7.58),('7643','2013-02-05','10:40:00',5.82),('7643','2013-02-05','10:45:00',4.24),('7643','2013-02-05','10:50:00',7.71),('7643','2013-02-05','10:55:00',8.75),('7643','2013-02-05','11:00:00',6.83),('7643','2013-02-05','11:05:00',5.29),('7643','2013-02-05','11:10:00',6.24),('7643','2013-02-05','11:15:00',5.42),('7643','2013-02-05','11:20:00',7.88),('7643','2013-02-05','11:25:00',11.97),('7643','2013-02-05','11:30:00',6.85),('7643','2013-02-05','11:35:00',5.72),('7643','2013-02-05','11:40:00',6.2),('7643','2013-02-05','11:45:00',6.29),('7643','2013-02-05','11:50:00',6.42),('7643','2013-02-05','11:55:00',5.82),('7643','2013-02-05','12:00:00',5.16),('7643','2013-02-05','12:05:00',4.34),('7643','2013-02-05','12:10:00',3.29),('7643','2013-02-05','12:15:00',3.97),('7643','2013-02-05','12:20:00',3.91),('7643','2013-02-05','12:25:00',3.83),('7643','2013-02-05','12:30:00',3.23),('7643','2013-02-05','12:35:00',2.81),('7643','2013-02-05','12:40:00',2.42),('7643','2013-02-05','12:45:00',2.35),('7643','2013-02-05','12:50:00',2.36),('7643','2013-02-05','12:55:00',2.35),('7643','2013-02-05','13:00:00',2.18),('7643','2013-02-05','13:05:00',2.09),('7643','2013-02-05','13:10:00',2.44),('7643','2013-02-05','13:15:00',2.93),('7643','2013-02-05','13:20:00',3.26),('7643','2013-02-05','13:25:00',3.61),('7643','2013-02-05','13:30:00',4.33),('7643','2013-02-05','13:35:00',4.65),('7643','2013-02-05','13:40:00',4.15),('7643','2013-02-05','13:45:00',3.63),('7643','2013-02-05','13:50:00',6.01),('7643','2013-02-05','13:55:00',5.04),('7643','2013-02-05','14:00:00',5.77),('7643','2013-02-05','14:05:00',4.81),('7643','2013-02-05','14:10:00',2.86),('7643','2013-02-05','14:15:00',1.53),('7643','2013-02-05','14:25:00',1.42),('7643','2013-02-05','14:30:00',5.89),('7643','2013-02-05','14:35:00',8.68),('7643','2013-02-05','14:40:00',5.94),('7643','2013-02-05','14:45:00',2.3),('7643','2013-02-05','15:05:00',1.08),('7643','2013-02-05','15:10:00',1.29),('7643','2013-02-05','15:15:00',1.96),('7643','2013-02-05','15:20:00',2.25),('7643','2013-02-05','15:25:00',3.22),('7643','2013-02-05','15:30:00',2.14),('7643','2013-02-05','15:35:00',1.12),('7643','2013-02-05','15:40:00',1.33),('7643','2013-02-05','15:45:00',2.19),('7643','2013-02-05','15:50:00',2.9),('7643','2013-02-05','15:55:00',1.51),('7643','2013-02-05','16:00:00',1.47),('7643','2013-02-05','16:05:00',1.49),('7643','2013-02-05','16:10:00',1.51),('7643','2013-02-05','16:15:00',1.5),('7643','2013-02-05','16:20:00',1.27),('7643','2013-02-04','07:45:00',1.08),('7643','2013-02-04','07:50:00',1.27),('7643','2013-02-04','07:55:00',1.51),('7643','2013-02-04','08:00:00',1.87),('7643','2013-02-04','08:05:00',2.18),('7643','2013-02-04','08:10:00',2.48),('7643','2013-02-04','08:15:00',2.82),('7643','2013-02-04','08:20:00',3.14),('7643','2013-02-04','08:25:00',3.51),('7643','2013-02-04','08:30:00',3.97),('7643','2013-02-04','08:35:00',4.51),('7643','2013-02-04','08:40:00',4.83),('7643','2013-02-04','08:45:00',5.15),('7643','2013-02-04','08:50:00',5.45),('7643','2013-02-04','08:55:00',5.8),('7643','2013-02-04','09:00:00',6.08),('7643','2013-02-04','09:05:00',6.31),('7643','2013-02-04','09:10:00',6.7),('7643','2013-02-04','09:15:00',7.06),('7643','2013-02-04','09:20:00',7.42),('7643','2013-02-04','09:25:00',7.75),('7643','2013-02-04','09:30:00',8),('7643','2013-02-04','09:35:00',8.34),('7643','2013-02-04','09:40:00',8.61),('7643','2013-02-04','09:45:00',8.8),('7643','2013-02-04','09:50:00',9.14),('7643','2013-02-04','09:55:00',9.3),('7643','2013-02-04','10:00:00',9.47),('7643','2013-02-04','10:05:00',9.7),('7643','2013-02-04','10:10:00',9.15),('7643','2013-02-04','10:15:00',9.32),('7643','2013-02-04','10:20:00',10.26),('7643','2013-02-04','10:25:00',10.56),('7643','2013-02-04','10:30:00',10.71),('7643','2013-02-04','10:35:00',10.85),('7643','2013-02-04','10:40:00',10.94),('7643','2013-02-04','10:45:00',10.9),('7643','2013-02-04','10:50:00',11.09),('7643','2013-02-04','10:55:00',11.16),('7643','2013-02-04','11:00:00',11.28),('7643','2013-02-04','11:05:00',11.35),('7643','2013-02-04','11:10:00',11.55),('7643','2013-02-04','11:15:00',11.6),('7643','2013-02-04','11:20:00',11.63),('7643','2013-02-04','11:25:00',11.72),('7643','2013-02-04','11:30:00',11.96),('7643','2013-02-04','11:35:00',11.14),('7643','2013-02-04','11:40:00',9.96),('7643','2013-02-04','11:45:00',8.41),('7643','2013-02-04','11:50:00',6.73),('7643','2013-02-04','11:55:00',5.42),('7643','2013-02-04','12:00:00',4.5),('7643','2013-02-04','12:05:00',4.67),('7643','2013-02-04','12:10:00',6.78),('7643','2013-02-04','12:15:00',6.5),('7643','2013-02-04','12:20:00',4.67),('7643','2013-02-04','12:25:00',4.42),('7643','2013-02-04','12:30:00',4.24),('7643','2013-02-04','12:35:00',5.02),('7643','2013-02-04','12:40:00',7.47),('7643','2013-02-04','12:45:00',7.23),('7643','2013-02-04','12:50:00',9.73),('7643','2013-02-04','12:55:00',3.71),('7643','2013-02-04','13:00:00',2.5),('7643','2013-02-04','13:05:00',2.91),('7643','2013-02-04','13:10:00',3.71),('7643','2013-02-04','13:15:00',4.8),('7643','2013-02-04','13:20:00',4.73),('7643','2013-02-04','13:25:00',4.4),('7643','2013-02-04','13:30:00',4.74),('7643','2013-02-04','13:35:00',3.49),('7643','2013-02-04','13:40:00',3.34),('7643','2013-02-04','13:45:00',4.54),('7643','2013-02-04','13:50:00',4.9),('7643','2013-02-04','13:55:00',4.19),('7643','2013-02-04','14:00:00',3.99),('7643','2013-02-04','14:05:00',4.28),('7643','2013-02-04','14:10:00',3.58),('7643','2013-02-04','14:15:00',3.69),('7643','2013-02-04','14:20:00',4.07),('7643','2013-02-04','14:25:00',5.86),('7643','2013-02-04','14:30:00',7.03),('7643','2013-02-04','14:35:00',4.97),('7643','2013-02-04','14:40:00',8.52),('7643','2013-02-04','14:45:00',6.91),('7643','2013-02-04','14:50:00',3.62),('7643','2013-02-04','14:55:00',3.24),('7643','2013-02-04','15:00:00',2.87),('7643','2013-02-04','15:05:00',3.98),('7643','2013-02-04','15:10:00',3.15),('7643','2013-02-04','15:15:00',2.4),('7643','2013-02-04','15:20:00',1.53),('7643','2013-02-04','15:25:00',1.07),('7643','2013-02-04','15:30:00',1.13),('7643','2013-02-03','07:45:00',1.13),('7643','2013-02-03','07:50:00',1.42),('7643','2013-02-03','07:55:00',1.76),('7643','2013-02-03','08:00:00',2.11),('7643','2013-02-03','08:05:00',2.51),('7643','2013-02-03','08:10:00',2.88),('7643','2013-02-03','08:15:00',3.26),('7643','2013-02-03','08:20:00',3.64),('7643','2013-02-03','08:25:00',4.03),('7643','2013-02-03','08:30:00',4.44),('7643','2013-02-03','08:35:00',4.84),('7643','2013-02-03','08:40:00',5.13),('7643','2013-02-03','08:45:00',5.47),('7643','2013-02-03','08:50:00',5.86),('7643','2013-02-03','08:55:00',5.39),('7643','2013-02-03','09:00:00',6.64),('7643','2013-02-03','09:05:00',7.11),('7643','2013-02-03','09:10:00',7.58),('7643','2013-02-03','09:15:00',7.83),('7643','2013-02-03','09:20:00',7.82),('7643','2013-02-03','09:25:00',7.69),('7643','2013-02-03','09:30:00',8.45),('7643','2013-02-03','09:35:00',8.47),('7643','2013-02-03','09:40:00',8.69),('7643','2013-02-03','09:45:00',7.96),('7643','2013-02-03','09:50:00',9.12),('7643','2013-02-03','09:55:00',10.07),('7643','2013-02-03','10:00:00',10.31),('7643','2013-02-03','10:05:00',10.53),('7643','2013-02-03','10:10:00',10.91),('7643','2013-02-03','10:15:00',11.28),('7643','2013-02-03','10:20:00',10.8),('7643','2013-02-03','10:25:00',11.21),('7643','2013-02-03','10:30:00',10.83),('7643','2013-02-03','10:35:00',10.17),('7643','2013-02-03','10:40:00',10.77),('7643','2013-02-03','10:45:00',11.8),('7643','2013-02-03','10:50:00',11.99),('7643','2013-02-03','10:55:00',11.97),('7643','2013-02-03','11:00:00',12.1),('7643','2013-02-03','11:05:00',12.34),('7643','2013-02-03','11:10:00',12.45),('7643','2013-02-03','11:15:00',12.52),('7643','2013-02-03','11:20:00',12.55),('7643','2013-02-03','11:25:00',12.67),('7643','2013-02-03','11:30:00',12.71),('7643','2013-02-03','11:35:00',12.79),('7643','2013-02-03','11:40:00',12.79),('7643','2013-02-03','11:45:00',12.86),('7643','2013-02-03','11:50:00',12.92),('7643','2013-02-03','11:55:00',12.94),('7643','2013-02-03','12:00:00',12.92),('7643','2013-02-03','12:05:00',12.98),('7643','2013-02-03','12:10:00',13.11),('7643','2013-02-03','12:15:00',13.06),('7643','2013-02-03','12:20:00',13),('7643','2013-02-03','12:25:00',12.95),('7643','2013-02-03','12:30:00',12.91),('7643','2013-02-03','12:35:00',12.83),('7643','2013-02-03','12:40:00',12.83),('7643','2013-02-03','12:45:00',12.83),('7643','2013-02-03','12:50:00',12.7),('7643','2013-02-03','12:55:00',12.59),('7643','2013-02-03','13:00:00',12.55),('7643','2013-02-03','13:05:00',12.58),('7643','2013-02-03','13:10:00',12.51),('7643','2013-02-03','13:15:00',12.43),('7643','2013-02-03','13:20:00',12.28),('7643','2013-02-03','13:25:00',12.16),('7643','2013-02-03','13:30:00',12.03),('7643','2013-02-03','13:35:00',11.88),('7643','2013-02-03','13:40:00',11.71),('7643','2013-02-03','13:45:00',11.61),('7643','2013-02-03','13:50:00',11.5),('7643','2013-02-03','13:55:00',11.44),('7643','2013-02-03','14:00:00',11.23),('7643','2013-02-03','14:05:00',11.07),('7643','2013-02-03','14:10:00',10.89),('7643','2013-02-03','14:15:00',10.67),('7643','2013-02-03','14:20:00',10.48),('7643','2013-02-03','14:25:00',10.26),('7643','2013-02-03','14:30:00',10.05),('7643','2013-02-03','14:35:00',9.76),('7643','2013-02-03','14:40:00',9.51),('7643','2013-02-03','14:45:00',9.31),('7643','2013-02-03','14:50:00',9.05),('7643','2013-02-03','14:55:00',8.73),('7643','2013-02-03','15:00:00',8.48),('7643','2013-02-03','15:05:00',8.19),('7643','2013-02-03','15:10:00',7.89),('7643','2013-02-03','15:15:00',7.57),('7643','2013-02-03','15:20:00',7.25),('7643','2013-02-03','15:25:00',6.98),('7643','2013-02-03','15:30:00',6.65),('7643','2013-02-03','15:35:00',6.31),('7643','2013-02-03','15:40:00',5.97),('7643','2013-02-03','15:45:00',5.64),('7643','2013-02-03','15:50:00',5.29),('7643','2013-02-03','15:55:00',4.94),('7643','2013-02-03','16:00:00',4.59),('7643','2013-02-03','16:05:00',4.27),('7643','2013-02-03','16:10:00',3.92),('7643','2013-02-03','16:15:00',3.53),('7643','2013-02-03','16:20:00',3.17),('7643','2013-02-03','16:25:00',2.8),('7643','2013-02-03','16:30:00',2.43),('7643','2013-02-03','16:35:00',2.05),('7643','2013-02-03','16:40:00',1.73),('7643','2013-02-03','16:45:00',1.42),('7643','2013-02-03','16:50:00',1.15),('7643','2013-02-02','08:05:00',1.98),('7643','2013-02-02','08:40:00',2.22),('7643','2013-02-02','08:45:00',2.45),('7643','2013-02-02','08:50:00',2.32),('7643','2013-02-02','08:55:00',1.63),('7643','2013-02-02','09:00:00',2.38),('7643','2013-02-02','09:05:00',2.34),('7643','2013-02-02','09:10:00',2.09),('7643','2013-02-02','09:15:00',2.86),('7643','2013-02-02','09:20:00',3.65),('7643','2013-02-02','09:25:00',4.53),('7643','2013-02-02','09:30:00',3.59),('7643','2013-02-02','09:35:00',3.11),('7643','2013-02-02','09:40:00',5.74),('7643','2013-02-02','09:45:00',7.84),('7643','2013-02-02','09:50:00',7.78),('7643','2013-02-02','09:55:00',6.36),('7643','2013-02-02','10:00:00',8.87),('7643','2013-02-02','10:05:00',3.9),('7643','2013-02-02','10:10:00',2.14),('7643','2013-02-02','10:15:00',1.95),('7643','2013-02-02','10:20:00',4.2),('7643','2013-02-02','10:25:00',2.31),('7643','2013-02-02','10:30:00',2.32),('7643','2013-02-02','10:35:00',1.6),('7643','2013-02-02','10:40:00',2.32),('7643','2013-02-02','11:10:00',1.32),('7643','2013-02-02','11:15:00',2.56),('7643','2013-02-02','11:20:00',4.86),('7643','2013-02-02','11:25:00',2.65),('7643','2013-02-02','11:30:00',1.15),('7643','2013-02-02','11:35:00',1.79),('7643','2013-02-02','11:40:00',1.63),('7643','2013-02-02','11:45:00',2.67),('7643','2013-02-02','11:50:00',3.46),('7643','2013-02-02','11:55:00',4.04),('7643','2013-02-02','12:00:00',4.24),('7643','2013-02-02','12:05:00',4.24),('7643','2013-02-02','12:10:00',3.98),('7643','2013-02-02','12:15:00',3.11),('7643','2013-02-02','12:20:00',2.53),('7643','2013-02-02','12:25:00',1.76),('7643','2013-02-02','12:30:00',1.46),('7643','2013-02-02','12:40:00',1.35),('7643','2013-02-02','12:50:00',1.68),('7643','2013-02-02','12:55:00',1.53),('7643','2013-02-02','13:45:00',1.43),('7643','2013-02-02','13:50:00',1.92),('7643','2013-02-02','13:55:00',1.74),('7643','2013-02-02','14:00:00',1.5),('7643','2013-02-02','14:35:00',1.01),('7643','2013-02-02','14:50:00',1.45),('7643','2013-02-02','14:55:00',1.9),('7643','2013-02-02','15:00:00',1.63),('7643','2013-02-02','15:05:00',1.26),('7643','2013-02-01','08:00:00',1.06),('7643','2013-02-01','08:05:00',1.05),('7643','2013-02-01','08:10:00',1.25),('7643','2013-02-01','08:15:00',1.37),('7643','2013-02-01','08:20:00',1.28),('7643','2013-02-01','08:25:00',1.11),('7643','2013-02-01','09:35:00',1.11),('7643','2013-02-01','09:40:00',1.29),('7643','2013-02-01','09:45:00',1.66),('7643','2013-02-01','09:50:00',1.53),('7643','2013-02-01','09:55:00',1.87),('7643','2013-02-01','10:00:00',1.86),('7643','2013-02-01','10:05:00',1.96),('7643','2013-02-01','10:10:00',2.41),('7643','2013-02-01','10:15:00',3.62),('7643','2013-02-01','10:20:00',4.09),('7643','2013-02-01','10:25:00',3.82),('7643','2013-02-01','10:30:00',4.37),('7643','2013-02-01','10:35:00',4.99),('7643','2013-02-01','10:40:00',5.48),('7643','2013-02-01','10:45:00',5.88),('7643','2013-02-01','10:50:00',5.17),('7643','2013-02-01','10:55:00',6.85),('7643','2013-02-01','11:00:00',7.93),('7643','2013-02-01','11:05:00',7.14),('7643','2013-02-01','11:10:00',7.56),('7643','2013-02-01','11:15:00',7.77),('7643','2013-02-01','11:20:00',7.54),('7643','2013-02-01','11:25:00',8.89),('7643','2013-02-01','11:30:00',8.21),('7643','2013-02-01','11:35:00',6.8),('7643','2013-02-01','11:40:00',6.71),('7643','2013-02-01','11:45:00',4.38),('7643','2013-02-01','11:50:00',4.04),('7643','2013-02-01','11:55:00',4.37),('7643','2013-02-01','12:00:00',3.27),('7643','2013-02-01','12:05:00',2.27),('7643','2013-02-01','12:10:00',1.89),('7643','2013-02-01','12:15:00',1.66),('7643','2013-02-01','12:20:00',1.51),('7643','2013-02-01','12:25:00',1.69),('7643','2013-02-01','12:30:00',1.17),('7643','2013-02-01','12:35:00',1.6),('7643','2013-02-01','12:40:00',1.68),('7643','2013-02-01','12:45:00',1.67),('7643','2013-02-01','12:50:00',2.75),('7643','2013-02-01','12:55:00',9.02),('7643','2013-02-01','13:00:00',5.89),('7643','2013-02-01','13:05:00',3.66),('7643','2013-02-01','13:10:00',6.15),('7643','2013-02-01','13:15:00',8.39),('7643','2013-02-01','13:20:00',7.14),('7643','2013-02-01','13:25:00',6.24),('7643','2013-02-01','13:30:00',4.86),('7643','2013-02-01','13:35:00',8.32),('7643','2013-02-01','13:40:00',10.21),('7643','2013-02-01','13:45:00',8.16),('7643','2013-02-01','13:50:00',7.61),('7643','2013-02-01','13:55:00',4.47),('7643','2013-02-01','14:00:00',2.26),('7643','2013-02-01','14:05:00',1.73),('7643','2013-02-01','14:10:00',1.46),('7643','2013-02-01','14:15:00',1.06),('7643','2013-02-01','14:20:00',1.1),('7643','2013-02-01','14:25:00',1.45),('7643','2013-02-01','14:30:00',1.57),('7643','2013-02-01','14:40:00',1.42),('7643','2013-01-31','08:15:00',1.19),('7643','2013-01-31','08:20:00',3.06),('7643','2013-01-31','08:25:00',3.45),('7643','2013-01-31','08:30:00',2.86),('7643','2013-01-31','08:35:00',3.69),('7643','2013-01-31','08:40:00',3.88),('7643','2013-01-31','08:45:00',4.32),('7643','2013-01-31','08:50:00',1.61),('7643','2013-01-31','08:55:00',3.76),('7643','2013-01-31','09:00:00',5.1),('7643','2013-01-31','09:05:00',6.34),('7643','2013-01-31','09:10:00',7.01),('7643','2013-01-31','09:15:00',2.22),('7643','2013-01-31','09:20:00',2.99),('7643','2013-01-31','09:25:00',6.39),('7643','2013-01-31','09:30:00',2.68),('7643','2013-01-31','09:35:00',4.52),('7643','2013-01-31','09:40:00',5.61),('7643','2013-01-31','09:45:00',3.72),('7643','2013-01-31','09:50:00',3.49),('7643','2013-01-31','09:55:00',3.56),('7643','2013-01-31','10:00:00',5.37),('7643','2013-01-31','10:05:00',3.18),('7643','2013-01-31','10:10:00',3.86),('7643','2013-01-31','10:15:00',4.21),('7643','2013-01-31','10:20:00',7.39),('7643','2013-01-31','10:25:00',7.11),('7643','2013-01-31','10:30:00',10.11),('7643','2013-01-31','10:35:00',6.21),('7643','2013-01-31','10:40:00',3.44),('7643','2013-01-31','10:45:00',4.96),('7643','2013-01-31','10:50:00',11.47),('7643','2013-01-31','10:55:00',6.24),('7643','2013-01-31','11:00:00',11.7),('7643','2013-01-31','11:05:00',8.37),('7643','2013-01-31','11:10:00',12.44),('7643','2013-01-31','11:15:00',12.14),('7643','2013-01-31','11:20:00',13.7),('7643','2013-01-31','11:25:00',9.33),('7643','2013-01-31','11:30:00',6.35),('7643','2013-01-31','11:35:00',10.06),('7643','2013-01-31','11:40:00',14.89),('7643','2013-01-31','11:45:00',10.34),('7643','2013-01-31','11:50:00',6.97),('7643','2013-01-31','11:55:00',4.86),('7643','2013-01-31','12:00:00',5.46),('7643','2013-01-31','12:05:00',7.26),('7643','2013-01-31','12:10:00',9.16),('7643','2013-01-31','12:15:00',10.03),('7643','2013-01-31','12:20:00',14.23),('7643','2013-01-31','12:25:00',11.82),('7643','2013-01-31','12:30:00',4.18),('7643','2013-01-31','12:35:00',7.64),('7643','2013-01-31','12:40:00',8.71),('7643','2013-01-31','12:45:00',7.47),('7643','2013-01-31','12:50:00',10.86),('7643','2013-01-31','12:55:00',9.45),('7643','2013-01-31','13:00:00',13.11),('7643','2013-01-31','13:05:00',12.63),('7643','2013-01-31','13:10:00',10.74),('7643','2013-01-31','13:15:00',11.62),('7643','2013-01-31','13:20:00',10.65),('7643','2013-01-31','13:25:00',7.69),('7643','2013-01-31','13:30:00',10.82),('7643','2013-01-31','13:35:00',7.5),('7643','2013-01-31','13:40:00',6.9),('7643','2013-01-31','13:45:00',9.56),('7643','2013-01-31','13:50:00',8.93),('7643','2013-01-31','13:55:00',4.3),('7643','2013-01-31','14:00:00',3.47),('7643','2013-01-31','14:05:00',3.27),('7643','2013-01-31','14:10:00',4.71),('7643','2013-01-31','14:15:00',9.7),('7643','2013-01-31','14:20:00',11.11),('7643','2013-01-31','14:25:00',9.59),('7643','2013-01-31','14:30:00',9.45),('7643','2013-01-31','14:35:00',9.27),('7643','2013-01-31','14:40:00',7.78),('7643','2013-01-31','14:45:00',4.14),('7643','2013-01-31','14:50:00',3.94),('7643','2013-01-31','14:55:00',6.24),('7643','2013-01-31','15:00:00',6.2),('7643','2013-01-31','15:05:00',8.86),('7643','2013-01-31','15:10:00',5.1),('7643','2013-01-31','15:15:00',6.86),('7643','2013-01-31','15:20:00',6.83),('7643','2013-01-31','15:25:00',5.19),('7643','2013-01-31','15:30:00',2.83),('7643','2013-01-31','15:35:00',4.97),('7643','2013-01-31','15:40:00',4.38),('7643','2013-01-31','15:45:00',3.89),('7643','2013-01-31','15:50:00',3.19),('7643','2013-01-31','15:55:00',4.73),('7643','2013-01-31','16:00:00',2.29),('7643','2013-01-31','16:05:00',1.6),('7643','2013-01-31','16:10:00',1.33),('7643','2014-03-20','06:50:00',1.3),('7643','2014-03-20','06:55:00',1.46),('7643','2014-03-20','07:00:00',1.68),('7643','2014-03-20','07:05:00',1.57),('7643','2014-03-20','07:10:00',1.77),('7643','2014-03-20','07:15:00',2.07),('7643','2014-03-20','07:20:00',2.74),('7643','2014-03-20','07:25:00',2.94),('7643','2014-03-20','07:30:00',2.86),('7643','2014-03-20','07:35:00',3.58),('7643','2014-03-20','07:40:00',4.04),('7643','2014-03-20','07:45:00',4.55),('7643','2014-03-20','07:50:00',5.09),('7643','2014-03-20','07:55:00',5.51),('7643','2014-03-20','08:00:00',5.82),('7643','2014-03-20','08:05:00',6.03),('7643','2014-03-20','08:10:00',6.49),('7643','2014-03-20','08:15:00',6.88),('7643','2014-03-20','08:20:00',7.2),('7643','2014-03-20','08:25:00',7.62),('7643','2014-03-20','08:30:00',8.07),('7643','2014-03-20','08:35:00',8.43),('7643','2014-03-20','08:40:00',8.58),('7643','2014-03-20','08:45:00',8.86),('7643','2014-03-20','08:50:00',9.23),('7643','2014-03-20','08:55:00',9.66),('7643','2014-03-20','09:00:00',10.01),('7643','2014-03-20','09:05:00',10.07),('7643','2014-03-20','09:10:00',10.5),('7643','2014-03-20','09:15:00',10.78),('7643','2014-03-20','09:20:00',11.15),('7643','2014-03-20','09:25:00',10.69),('7643','2014-03-20','09:30:00',11.44),('7643','2014-03-20','09:35:00',11.63),('7643','2014-03-20','09:40:00',11.83),('7643','2014-03-20','09:45:00',12.02),('7643','2014-03-20','09:50:00',12.1),('7643','2014-03-20','09:55:00',12.34),('7643','2014-03-20','10:00:00',12.43),('7643','2014-03-20','10:05:00',12.59),('7643','2014-03-20','10:10:00',12.77),('7643','2014-03-20','10:15:00',13.02),('7643','2014-03-20','10:20:00',13),('7643','2014-03-20','10:25:00',13.4),('7643','2014-03-20','10:30:00',13.51),('7643','2014-03-20','10:35:00',13.82),('7643','2014-03-20','10:40:00',13.86),('7643','2014-03-20','10:45:00',13.74),('7643','2014-03-20','10:50:00',13.73),('7643','2014-03-20','10:55:00',14.04),('7643','2014-03-20','11:00:00',14.15),('7643','2014-03-20','11:05:00',13.88),('7643','2014-03-20','11:10:00',13.88),('7643','2014-03-20','11:15:00',13.78),('7643','2014-03-20','11:20:00',13.73),('7643','2014-03-20','11:25:00',12.58),('7643','2014-03-20','11:30:00',11.17),('7643','2014-03-20','11:35:00',10.42),('7643','2014-03-20','11:40:00',5.87),('7643','2014-03-20','11:45:00',11.16),('7643','2014-03-20','11:50:00',15.5),('7643','2014-03-20','11:55:00',14.94),('7643','2014-03-20','12:00:00',11.15),('7643','2014-03-20','12:05:00',14.9),('7643','2014-03-20','12:10:00',15.62),('7643','2014-03-20','12:15:00',15.96),('7643','2014-03-20','12:20:00',15.55),('7643','2014-03-20','12:25:00',15.1),('7643','2014-03-20','12:30:00',14.86),('7643','2014-03-20','12:35:00',14.99),('7643','2014-03-20','12:40:00',15.21),('7643','2014-03-20','12:45:00',15.09),('7643','2014-03-20','12:50:00',15.02),('7643','2014-03-20','12:55:00',14.86),('7643','2014-03-20','13:00:00',14.8),('7643','2014-03-20','13:05:00',14.8),('7643','2014-03-20','13:10:00',14.68),('7643','2014-03-20','13:15:00',14.67),('7643','2014-03-20','13:20:00',14.55),('7643','2014-03-20','13:25:00',14.45),('7643','2014-03-20','13:30:00',14.34),('7643','2014-03-20','13:35:00',14.2),('7643','2014-03-20','13:40:00',14.24),('7643','2014-03-20','13:45:00',14.11),('7643','2014-03-20','13:50:00',14.03),('7643','2014-03-20','13:55:00',13.81),('7643','2014-03-20','14:00:00',13.71),('7643','2014-03-20','14:05:00',13.61),('7643','2014-03-20','14:10:00',13.43),('7643','2014-03-20','14:15:00',13.29),('7643','2014-03-20','14:20:00',13.14),('7643','2014-03-20','14:25:00',12.92),('7643','2014-03-20','14:30:00',12.26),('7643','2014-03-20','14:35:00',11.73),('7643','2014-03-20','14:40:00',11.88),('7643','2014-03-20','14:45:00',11.44),('7643','2014-03-20','14:50:00',9.51),('7643','2014-03-20','14:55:00',4.94),('7643','2014-03-20','15:00:00',2.85),('7643','2014-03-20','15:05:00',6.92),('7643','2014-03-20','15:10:00',12.14),('7643','2014-03-20','15:15:00',12.56),('7643','2014-03-20','15:20:00',11.65),('7643','2014-03-20','15:25:00',11.55),('7643','2014-03-20','15:30:00',11.69),('7643','2014-03-20','15:35:00',10.92),('7643','2014-03-20','15:40:00',10.89),('7643','2014-03-20','15:45:00',10.57),('7643','2014-03-20','15:50:00',10.22),('7643','2014-03-20','15:55:00',9.39),('7643','2014-03-20','16:00:00',9.12),('7643','2014-03-20','16:05:00',8.34),('7643','2014-03-20','16:10:00',7.91),('7643','2014-03-20','16:15:00',7.16),('7643','2014-03-20','16:20:00',6.55),('7643','2014-03-20','16:25:00',6.03),('7643','2014-03-20','16:30:00',5.56),('7643','2014-03-20','16:35:00',5.23),('7643','2014-03-20','16:40:00',4.83),('7643','2014-03-20','16:45:00',4.46),('7643','2014-03-20','16:50:00',4.06),('7643','2014-03-20','16:55:00',3.69),('7643','2014-03-20','17:00:00',3.08),('7643','2014-03-20','17:05:00',2.82),('7643','2014-03-20','17:10:00',2.42),('7643','2014-03-20','17:15:00',2.01),('7643','2014-03-20','17:20:00',1.71),('7643','2014-03-20','17:25:00',1.43),('7643','2014-03-20','17:30:00',1.2),('7643','2013-01-30','08:45:00',1.31),('7643','2013-01-30','08:50:00',1.81),('7643','2013-01-30','08:55:00',1.74),('7643','2013-01-30','09:00:00',2.15),('7643','2013-01-30','09:05:00',2.95),('7643','2013-01-30','09:10:00',3.48),('7643','2013-01-30','09:15:00',2.16),('7643','2013-01-30','09:20:00',3.01),('7643','2013-01-30','09:25:00',5.17),('7643','2013-01-30','09:30:00',8.41),('7643','2013-01-30','09:35:00',7.52),('7643','2013-01-30','09:40:00',7.89),('7643','2013-01-30','09:45:00',8.06),('7643','2013-01-30','09:50:00',8.16),('7643','2013-01-30','09:55:00',8.76),('7643','2013-01-30','10:00:00',8.81),('7643','2013-01-30','10:05:00',8.91),('7643','2013-01-30','10:10:00',8.88),('7643','2013-01-30','10:15:00',9.11),('7643','2013-01-30','10:20:00',9.56),('7643','2013-01-30','10:25:00',10.1),('7643','2013-01-30','10:30:00',10.41),('7643','2013-01-30','10:35:00',10.71),('7643','2013-01-30','10:40:00',10.32),('7643','2013-01-30','10:45:00',7.68),('7643','2013-01-30','10:50:00',11.19),('7643','2013-01-30','10:55:00',11.7),('7643','2013-01-30','11:00:00',11.77),('7643','2013-01-30','11:05:00',10.28),('7643','2013-01-30','11:10:00',12.07),('7643','2013-01-30','11:15:00',11.99),('7643','2013-01-30','11:20:00',12.45),('7643','2013-01-30','11:25:00',12.39),('7643','2013-01-30','11:30:00',11.8),('7643','2013-01-30','11:35:00',11.33),('7643','2013-01-30','11:40:00',11.71),('7643','2013-01-30','11:45:00',11.8),('7643','2013-01-30','11:50:00',11.72),('7643','2013-01-30','11:55:00',11.65),('7643','2013-01-30','12:00:00',11.68),('7643','2013-01-30','12:05:00',11.76),('7643','2013-01-30','12:10:00',11.84),('7643','2013-01-30','12:15:00',11.78),('7643','2013-01-30','12:20:00',11.84),('7643','2013-01-30','12:25:00',11.52),('7643','2013-01-30','12:30:00',11.69),('7643','2013-01-30','12:35:00',11.7),('7643','2013-01-30','12:40:00',11.59),('7643','2013-01-30','12:45:00',11.59),('7643','2013-01-30','12:50:00',11.51),('7643','2013-01-30','12:55:00',11.46),('7643','2013-01-30','13:00:00',11.38),('7643','2013-01-30','13:05:00',11.36),('7643','2013-01-30','13:10:00',10.92),('7643','2013-01-30','13:15:00',11),('7643','2013-01-30','13:20:00',10.86),('7643','2013-01-30','13:25:00',10.69),('7643','2013-01-30','13:30:00',10.68),('7643','2013-01-30','13:35:00',10.35),('7643','2013-01-30','13:40:00',10.24),('7643','2013-01-30','13:45:00',10.28),('7643','2013-01-30','13:50:00',10.82),('7643','2013-01-30','13:55:00',10.42),('7643','2013-01-30','14:00:00',10.18),('7643','2013-01-30','14:05:00',9.7),('7643','2013-01-30','14:10:00',9.28),('7643','2013-01-30','14:15:00',9.07),('7643','2013-01-30','14:20:00',8.98),('7643','2013-01-30','14:25:00',8.8),('7643','2013-01-30','14:30:00',8.58),('7643','2013-01-30','14:35:00',8.39),('7643','2013-01-30','14:40:00',8.07),('7643','2013-01-30','14:45:00',7.88),('7643','2013-01-30','14:50:00',7.68),('7643','2013-01-30','14:55:00',7.17),('7643','2013-01-30','15:00:00',7.02),('7643','2013-01-30','15:05:00',6.89),('7643','2013-01-30','15:10:00',6.62),('7643','2013-01-30','15:15:00',6.51),('7643','2013-01-30','15:20:00',6.29),('7643','2013-01-30','15:25:00',5.87),('7643','2013-01-30','15:30:00',5.61),('7643','2013-01-30','15:35:00',5.53),('7643','2013-01-30','15:40:00',5.17),('7643','2013-01-30','15:45:00',4.69),('7643','2013-01-30','15:50:00',4.31),('7643','2013-01-30','15:55:00',4.02),('7643','2013-01-30','16:00:00',3.41),('7643','2013-01-30','16:05:00',2.76),('7643','2013-01-30','16:10:00',3.05),('7643','2013-01-30','16:15:00',2.71),('7643','2013-01-30','16:20:00',2.39),('7643','2013-01-30','16:25:00',2.04),('7643','2013-01-30','16:30:00',2.02),('7643','2013-01-30','16:35:00',1.71),('7643','2013-01-30','16:40:00',1.4),('7643','2013-01-30','16:45:00',1.15),('7643','2013-01-29','08:30:00',1.29),('7643','2013-01-29','08:35:00',1.59),('7643','2013-01-29','08:40:00',1.56),('7643','2013-01-29','08:45:00',1.3),('7643','2013-01-29','08:50:00',1.3),('7643','2013-01-29','08:55:00',1.66),('7643','2013-01-29','09:00:00',1.51),('7643','2013-01-29','09:05:00',1.54),('7643','2013-01-29','09:10:00',2.06),('7643','2013-01-29','09:15:00',2.76),('7643','2013-01-29','09:20:00',1.65),('7643','2013-01-29','09:25:00',2.25),('7643','2013-01-29','09:30:00',2.81),('7643','2013-01-29','09:35:00',3.14),('7643','2013-01-29','09:40:00',2.86),('7643','2013-01-29','09:45:00',2.29),('7643','2013-01-29','09:50:00',1.58),('7643','2013-01-29','09:55:00',1.73),('7643','2013-01-29','10:00:00',3.31),('7643','2013-01-29','10:05:00',3.25),('7643','2013-01-29','10:10:00',6.02),('7643','2013-01-29','10:15:00',4.41),('7643','2013-01-29','10:20:00',6.04),('7643','2013-01-29','10:25:00',6.72),('7643','2013-01-29','10:30:00',6.35),('7643','2013-01-29','10:35:00',5.42),('7643','2013-01-29','10:40:00',5.43),('7643','2013-01-29','10:45:00',5.68),('7643','2013-01-29','10:50:00',10.98),('7643','2013-01-29','10:55:00',7.2),('7643','2013-01-29','11:00:00',9.96),('7643','2013-01-29','11:05:00',10.58),('7643','2013-01-29','11:10:00',10.54),('7643','2013-01-29','11:15:00',10.94),('7643','2013-01-29','11:20:00',11.04),('7643','2013-01-29','11:25:00',11.19),('7643','2013-01-29','11:30:00',11.2),('7643','2013-01-29','11:35:00',11.38),('7643','2013-01-29','11:40:00',10.62),('7643','2013-01-29','11:45:00',10.43),('7643','2013-01-29','11:50:00',9.93),('7643','2013-01-29','11:55:00',9.48),('7643','2013-01-29','12:00:00',8),('7643','2013-01-29','12:05:00',9.59),('7643','2013-01-29','12:10:00',9.36),('7643','2013-01-29','12:15:00',12.65),('7643','2013-01-29','12:20:00',5.49),('7643','2013-01-29','12:25:00',3.67),('7643','2013-01-29','12:30:00',2.99),('7643','2013-01-29','12:35:00',3.89),('7643','2013-01-29','12:40:00',5.6),('7643','2013-01-29','12:45:00',4.25),('7643','2013-01-29','12:50:00',13.65),('7643','2013-01-29','12:55:00',13.38),('7643','2013-01-29','13:00:00',12.67),('7643','2013-01-29','13:05:00',13.09),('7643','2013-01-29','13:10:00',10.22),('7643','2013-01-29','13:15:00',12.43),('7643','2013-01-29','13:20:00',12.47),('7643','2013-01-29','13:25:00',12.12),('7643','2013-01-29','13:30:00',11.4),('7643','2013-01-29','13:35:00',7.13),('7643','2013-01-29','13:40:00',9.97),('7643','2013-01-29','13:45:00',12.22),('7643','2013-01-29','13:50:00',11.04),('7643','2013-01-29','13:55:00',9.68),('7643','2013-01-29','14:00:00',11.14),('7643','2013-01-29','14:05:00',9.87),('7643','2013-01-29','14:10:00',8.57),('7643','2013-01-29','14:15:00',3.86),('7643','2013-01-29','14:20:00',4.13),('7643','2013-01-29','14:25:00',7.86),('7643','2013-01-29','14:30:00',8.24),('7643','2013-01-29','14:35:00',8.34),('7643','2013-01-29','14:40:00',8.92),('7643','2013-01-29','14:45:00',7.01),('7643','2013-01-29','14:50:00',3.72),('7643','2013-01-29','14:55:00',3.63),('7643','2013-01-29','15:00:00',5.87),('7643','2013-01-29','15:05:00',5.56),('7643','2013-01-29','15:10:00',3.41),('7643','2013-01-29','15:15:00',2.95),('7643','2013-01-29','15:20:00',2.61),('7643','2013-01-29','15:25:00',2.27),('7643','2013-01-29','15:30:00',2.22),('7643','2013-01-29','15:35:00',1.98),('7643','2013-01-29','15:40:00',1.51),('7643','2013-01-29','15:45:00',1.32),('7643','2013-01-29','15:50:00',1.33),('7643','2013-01-29','15:55:00',1.37),('7643','2013-01-29','16:00:00',1.31),('7643','2013-01-29','16:05:00',1.06),('7643','2013-01-29','16:10:00',1.3),('7643','2013-01-29','16:15:00',1.7),('7643','2013-01-29','16:20:00',1.77),('7643','2013-01-29','16:25:00',1.53),('7643','2013-01-29','16:30:00',1.68),('7643','2013-01-29','16:35:00',1.38),('7643','2013-01-29','16:40:00',1.18),('7643','2013-01-29','16:45:00',1.3),('7643','2013-01-29','16:50:00',1.06),('7643','2013-01-28','08:00:00',1.52),('7643','2013-01-28','08:05:00',1.85),('7643','2013-01-28','08:10:00',2.17),('7643','2013-01-28','08:15:00',2.51),('7643','2013-01-28','08:20:00',2.8),('7643','2013-01-28','08:25:00',3.14),('7643','2013-01-28','08:30:00',3.5),('7643','2013-01-28','08:35:00',3.59),('7643','2013-01-28','08:40:00',4.22),('7643','2013-01-28','08:45:00',4.56),('7643','2013-01-28','08:50:00',4.88),('7643','2013-01-28','08:55:00',5.21),('7643','2013-01-28','09:00:00',5.56),('7643','2013-01-28','09:05:00',5.92),('7643','2013-01-28','09:10:00',6.2),('7643','2013-01-28','09:15:00',6.48),('7643','2013-01-28','09:20:00',6.76),('7643','2013-01-28','09:25:00',7.02),('7643','2013-01-28','09:30:00',7.34),('7643','2013-01-28','09:35:00',7.53),('7643','2013-01-28','09:40:00',7.89),('7643','2013-01-28','09:45:00',8.21),('7643','2013-01-28','09:50:00',8.48),('7643','2013-01-28','09:55:00',8.67),('7643','2013-01-28','10:00:00',8.9),('7643','2013-01-28','10:05:00',9.21),('7643','2013-01-28','10:10:00',9.53),('7643','2013-01-28','10:15:00',9.79),('7643','2013-01-28','10:20:00',10.02),('7643','2013-01-28','10:25:00',10.25),('7643','2013-01-28','10:30:00',10.41),('7643','2013-01-28','10:35:00',10.55),('7643','2013-01-28','10:40:00',10.76),('7643','2013-01-28','10:45:00',10.95),('7643','2013-01-28','10:50:00',11.09),('7643','2013-01-28','10:55:00',11.14),('7643','2013-01-28','11:00:00',11.18),('7643','2013-01-28','11:05:00',11.24),('7643','2013-01-28','11:10:00',11.28),('7643','2013-01-28','11:15:00',11.49),('7643','2013-01-28','11:20:00',11.56),('7643','2013-01-28','11:25:00',11.52),('7643','2013-01-28','11:30:00',11.42),('7643','2013-01-28','11:35:00',11.89),('7643','2013-01-28','11:40:00',12.1),('7643','2013-01-28','11:45:00',12.05),('7643','2013-01-28','11:50:00',12.07),('7643','2013-01-28','11:55:00',12.04),('7643','2013-01-28','12:00:00',11.94),('7643','2013-01-28','12:05:00',12.01),('7643','2013-01-28','12:10:00',12.22),('7643','2013-01-28','12:15:00',12),('7643','2013-01-28','12:20:00',12),('7643','2013-01-28','12:25:00',12.14),('7643','2013-01-28','12:30:00',11.99),('7643','2013-01-28','12:35:00',11.8),('7643','2013-01-28','12:40:00',11.83),('7643','2013-01-28','12:45:00',11.7),('7643','2013-01-28','12:50:00',11.62),('7643','2013-01-28','12:55:00',11.77),('7643','2013-01-28','13:00:00',11.58),('7643','2013-01-28','13:05:00',11.4),('7643','2013-01-28','13:10:00',11.34),('7643','2013-01-28','13:15:00',11.26),('7643','2013-01-28','13:20:00',11),('7643','2013-01-28','13:25:00',11.12),('7643','2013-01-28','13:30:00',11),('7643','2013-01-28','13:35:00',10.87),('7643','2013-01-28','13:40:00',10.68),('7643','2013-01-28','13:45:00',10.63),('7643','2013-01-28','13:50:00',10.36),('7643','2013-01-28','13:55:00',10.13),('7643','2013-01-28','14:00:00',9.97),('7643','2013-01-28','14:05:00',9.67),('7643','2013-01-28','14:10:00',9.26),('7643','2013-01-28','14:15:00',9.39),('7643','2013-01-28','14:20:00',9.44),('7643','2013-01-28','14:25:00',9.23),('7643','2013-01-28','14:30:00',8.97),('7643','2013-01-28','14:35:00',8.67),('7643','2013-01-28','14:40:00',8.43),('7643','2013-01-28','14:45:00',8.25),('7643','2013-01-28','14:50:00',7.99),('7643','2013-01-28','14:55:00',7.72),('7643','2013-01-28','15:00:00',7.33),('7643','2013-01-28','15:05:00',7.08),('7643','2013-01-28','15:10:00',6.76),('7643','2013-01-28','15:15:00',6.49),('7643','2013-01-28','15:20:00',6.16),('7643','2013-01-28','15:25:00',5.79),('7643','2013-01-28','15:30:00',5.48),('7643','2013-01-28','15:35:00',5.22),('7643','2013-01-28','15:40:00',4.99),('7643','2013-01-28','15:45:00',4.67),('7643','2013-01-28','15:50:00',4.32),('7643','2013-01-28','15:55:00',4.08),('7643','2013-01-28','16:00:00',3.85),('7643','2013-01-28','16:05:00',3.54),('7643','2013-01-28','16:10:00',3.3),('7643','2013-01-28','16:15:00',2.98),('7643','2013-01-28','16:20:00',2.69),('7643','2013-01-28','16:25:00',2.35),('7643','2013-01-28','16:30:00',2.05),('7643','2013-01-28','16:35:00',1.74),('7643','2013-01-28','16:40:00',1.41),('7643','2013-01-28','16:45:00',1.14),('7643','2013-01-27','08:15:00',1.07),('7643','2013-01-27','08:20:00',1.31),('7643','2013-01-27','08:25:00',1.62),('7643','2013-01-27','08:30:00',1.87),('7643','2013-01-27','08:35:00',1.95),('7643','2013-01-27','08:40:00',1.95),('7643','2013-01-27','08:45:00',1.63),('7643','2013-01-27','08:50:00',1.43),('7643','2013-01-27','08:55:00',1.31),('7643','2013-01-27','09:00:00',1.09),('7643','2013-01-27','09:20:00',1.15),('7643','2013-01-27','09:25:00',1.21),('7643','2013-01-27','09:30:00',1.38),('7643','2013-01-27','09:35:00',1.47),('7643','2013-01-27','09:40:00',1.5),('7643','2013-01-27','09:45:00',1.66),('7643','2013-01-27','09:50:00',1.76),('7643','2013-01-27','09:55:00',1.64),('7643','2013-01-27','10:00:00',1.51),('7643','2013-01-27','10:05:00',1.68),('7643','2013-01-27','10:10:00',1.95),('7643','2013-01-27','10:15:00',1.92),('7643','2013-01-27','10:20:00',1.95),('7643','2013-01-27','10:25:00',1.87),('7643','2013-01-27','10:30:00',1.6),('7643','2013-01-27','10:35:00',1.48),('7643','2013-01-27','10:40:00',1.49),('7643','2013-01-27','10:45:00',1.72),('7643','2013-01-27','10:50:00',2.07),('7643','2013-01-27','10:55:00',2.34),('7643','2013-01-27','11:00:00',2.74),('7643','2013-01-27','11:05:00',3.11),('7643','2013-01-27','11:10:00',3.24),('7643','2013-01-27','11:15:00',2.75),('7643','2013-01-27','11:20:00',2.71),('7643','2013-01-27','11:25:00',2.58),('7643','2013-01-27','11:30:00',2.39),('7643','2013-01-27','11:35:00',2.23),('7643','2013-01-27','11:40:00',2.12),('7643','2013-01-27','11:45:00',2.11),('7643','2013-01-27','11:50:00',2.06),('7643','2013-01-27','11:55:00',1.93),('7643','2013-01-27','12:00:00',1.64),('7643','2013-01-27','12:05:00',1.53),('7643','2013-01-27','12:10:00',1.55),('7643','2013-01-27','12:15:00',1.65),('7643','2013-01-27','12:20:00',1.86),('7643','2013-01-27','12:25:00',2.01),('7643','2013-01-27','12:30:00',2.18),('7643','2013-01-27','12:35:00',2.5),('7643','2013-01-27','12:40:00',3.06),('7643','2013-01-27','12:45:00',3.93),('7643','2013-01-27','12:50:00',4.73),('7643','2013-01-27','12:55:00',4.48),('7643','2013-01-27','13:00:00',4.15),('7643','2013-01-27','13:05:00',3.99),('7643','2013-01-27','13:10:00',3.64),('7643','2013-01-27','13:15:00',3.46),('7643','2013-01-27','13:20:00',3.54),('7643','2013-01-27','13:25:00',3.62),('7643','2013-01-27','13:30:00',3.5),('7643','2013-01-27','13:35:00',3.16),('7643','2013-01-27','13:40:00',2.78),('7643','2013-01-27','13:45:00',2.56),('7643','2013-01-27','13:50:00',2.38),('7643','2013-01-27','13:55:00',2.34),('7643','2013-01-27','14:00:00',2.5),('7643','2013-01-27','14:05:00',2.6),('7643','2013-01-27','14:10:00',2.51),('7643','2013-01-27','14:15:00',2.31),('7643','2013-01-27','14:20:00',2.1),('7643','2013-01-27','14:25:00',1.84),('7643','2013-01-27','14:30:00',1.71),('7643','2013-01-27','14:35:00',1.6),('7643','2013-01-27','14:40:00',1.69),('7643','2013-01-27','14:45:00',1.88),('7643','2013-01-27','14:50:00',1.77),('7643','2013-01-27','14:55:00',1.6),('7643','2013-01-27','15:00:00',1.27),('7643','2013-01-27','15:05:00',1.04),('7643','2013-01-26','08:00:00',1.38),('7643','2013-01-26','08:05:00',1.69),('7643','2013-01-26','08:10:00',2.02),('7643','2013-01-26','08:15:00',2.35),('7643','2013-01-26','08:20:00',2.67),('7643','2013-01-26','08:25:00',3.1),('7643','2013-01-26','08:30:00',3.75),('7643','2013-01-26','08:35:00',4.35),('7643','2013-01-26','08:40:00',4.79),('7643','2013-01-26','08:45:00',4.89),('7643','2013-01-26','08:50:00',4.68),('7643','2013-01-26','08:55:00',5.14),('7643','2013-01-26','09:00:00',5.46),('7643','2013-01-26','09:05:00',5.73),('7643','2013-01-26','09:10:00',5.97),('7643','2013-01-26','09:15:00',6.24),('7643','2013-01-26','09:20:00',6.59),('7643','2013-01-26','09:25:00',6.91),('7643','2013-01-26','09:30:00',7.17),('7643','2013-01-26','09:35:00',7.46),('7643','2013-01-26','09:40:00',7.75),('7643','2013-01-26','09:45:00',8.01),('7643','2013-01-26','09:50:00',8.24),('7643','2013-01-26','09:55:00',8.54),('7643','2013-01-26','10:00:00',8.77),('7643','2013-01-26','10:05:00',9.02),('7643','2013-01-26','10:10:00',9.19),('7643','2013-01-26','10:15:00',9.43),('7643','2013-01-26','10:20:00',9.56),('7643','2013-01-26','10:25:00',9.8),('7643','2013-01-26','10:30:00',9.99),('7643','2013-01-26','10:35:00',10.18),('7643','2013-01-26','10:40:00',10.27),('7643','2013-01-26','10:45:00',10.45),('7643','2013-01-26','10:50:00',10.64),('7643','2013-01-26','10:55:00',10.73),('7643','2013-01-26','11:00:00',10.91),('7643','2013-01-26','11:05:00',11.01),('7643','2013-01-26','11:10:00',11.1),('7643','2013-01-26','11:15:00',11.25),('7643','2013-01-26','11:20:00',11.29),('7643','2013-01-26','11:25:00',11.36),('7643','2013-01-26','11:30:00',11.37),('7643','2013-01-26','11:35:00',11.46),('7643','2013-01-26','11:40:00',11.56),('7643','2013-01-26','11:45:00',11.66),('7643','2013-01-26','11:50:00',11.73),('7643','2013-01-26','11:55:00',11.72),('7643','2013-01-26','12:00:00',11.75),('7643','2013-01-26','12:05:00',11.79),('7643','2013-01-26','12:10:00',11.72),('7643','2013-01-26','12:15:00',11.77),('7643','2013-01-26','12:20:00',11.94),('7643','2013-01-26','12:25:00',11.77),('7643','2013-01-26','12:30:00',11.77),('7643','2013-01-26','12:35:00',11.62),('7643','2013-01-26','12:40:00',11.71),('7643','2013-01-26','12:45:00',11.65),('7643','2013-01-26','12:50:00',11.79),('7643','2013-01-26','12:55:00',11.66),('7643','2013-01-26','13:00:00',11.65),('7643','2013-01-26','13:05:00',11.62),('7643','2013-01-26','13:10:00',11.54),('7643','2013-01-26','13:15:00',11.38),('7643','2013-01-26','13:20:00',11.04),('7643','2013-01-26','13:25:00',10.92),('7643','2013-01-26','13:30:00',10.55),('7643','2013-01-26','13:35:00',10.47),('7643','2013-01-26','13:40:00',10.35),('7643','2013-01-26','13:45:00',10.17),('7643','2013-01-26','13:50:00',9.95),('7643','2013-01-26','13:55:00',9.94),('7643','2013-01-26','14:00:00',9.74),('7643','2013-01-26','14:05:00',9.5),('7643','2013-01-26','14:10:00',9.25),('7643','2013-01-26','14:15:00',8.93),('7643','2013-01-26','14:20:00',8.91),('7643','2013-01-26','14:25:00',8.63),('7643','2013-01-26','14:30:00',8.34),('7643','2013-01-26','14:35:00',8.06),('7643','2013-01-26','14:40:00',7.82),('7643','2013-01-26','14:45:00',7.63),('7643','2013-01-26','14:50:00',7.63),('7643','2013-01-26','14:55:00',7.39),('7643','2013-01-26','15:00:00',7.12),('7643','2013-01-26','15:05:00',6.79),('7643','2013-01-26','15:10:00',6.39),('7643','2013-01-26','15:15:00',6.08),('7643','2013-01-26','15:20:00',5.79),('7643','2013-01-26','15:25:00',5.47),('7643','2013-01-26','15:30:00',5.18),('7643','2013-01-26','15:35:00',4.87),('7643','2013-01-26','15:40:00',4.55),('7643','2013-01-26','15:45:00',4.23),('7643','2013-01-26','15:50:00',4.05),('7643','2013-01-26','15:55:00',3.77),('7643','2013-01-26','16:00:00',3.48),('7643','2013-01-26','16:05:00',3.27),('7643','2013-01-26','16:10:00',2.85),('7643','2013-01-26','16:15:00',2.44),('7643','2013-01-26','16:20:00',2.08),('7643','2013-01-26','16:25:00',1.81),('7643','2013-01-26','16:30:00',1.53),('7643','2013-01-26','16:35:00',1.31),('7643','2013-01-26','16:40:00',1.08),('7643','2013-01-25','08:15:00',1.02),('7643','2013-01-25','08:20:00',1.14),('7643','2013-01-25','08:30:00',1),('7643','2013-01-25','08:35:00',1.2),('7643','2013-01-25','08:40:00',1.17),('7643','2013-01-25','08:45:00',1.59),('7643','2013-01-25','08:50:00',2.11),('7643','2013-01-25','08:55:00',3.11),('7643','2013-01-25','09:00:00',5.37),('7643','2013-01-25','09:05:00',4.09),('7643','2013-01-25','09:10:00',4.43),('7643','2013-01-25','09:15:00',3.93),('7643','2013-01-25','09:20:00',4.15),('7643','2013-01-25','09:25:00',3.64),('7643','2013-01-25','09:30:00',2.91),('7643','2013-01-25','09:35:00',3.56),('7643','2013-01-25','09:40:00',3.19),('7643','2013-01-25','09:45:00',2.62),('7643','2013-01-25','09:50:00',3.93),('7643','2013-01-25','09:55:00',6.22),('7643','2013-01-25','10:00:00',3.73),('7643','2013-01-25','10:05:00',3.74),('7643','2013-01-25','10:10:00',3.27),('7643','2013-01-25','10:15:00',3.66),('7643','2013-01-25','10:20:00',4.75),('7643','2013-01-25','10:25:00',4.89),('7643','2013-01-25','10:30:00',3.04),('7643','2013-01-25','10:35:00',2.91),('7643','2013-01-25','10:40:00',3.4),('7643','2013-01-25','10:45:00',3.48),('7643','2013-01-25','10:50:00',4.21),('7643','2013-01-25','10:55:00',4.45),('7643','2013-01-25','11:00:00',3.32),('7643','2013-01-25','11:05:00',3.88),('7643','2013-01-25','11:10:00',3.6),('7643','2013-01-25','11:15:00',3.39),('7643','2013-01-25','11:20:00',3.22),('7643','2013-01-25','11:25:00',3.61),('7643','2013-01-25','11:30:00',3.63),('7643','2013-01-25','11:35:00',3.51),('7643','2013-01-25','11:40:00',3.52),('7643','2013-01-25','11:45:00',3.21),('7643','2013-01-25','11:50:00',3.29),('7643','2013-01-25','11:55:00',3.35),('7643','2013-01-25','12:00:00',2.89),('7643','2013-01-25','12:05:00',2.78),('7643','2013-01-25','12:10:00',2.74),('7643','2013-01-25','12:15:00',2.78),('7643','2013-01-25','12:20:00',2.83),('7643','2013-01-25','12:25:00',3.64),('7643','2013-01-25','12:30:00',3.46),('7643','2013-01-25','12:35:00',3.38),('7643','2013-01-25','12:40:00',3.19),('7643','2013-01-25','12:45:00',3.06),('7643','2013-01-25','12:50:00',3.28),('7643','2013-01-25','12:55:00',2.43),('7643','2013-01-25','13:00:00',1.86),('7643','2013-01-25','13:05:00',2.36),('7643','2013-01-25','13:10:00',2.31),('7643','2013-01-25','13:15:00',1.76),('7643','2013-01-25','13:20:00',1.6),('7643','2013-01-25','13:25:00',1.7),('7643','2013-01-25','13:30:00',1.86),('7643','2013-01-25','13:35:00',2.42),('7643','2013-01-25','13:40:00',2.58),('7643','2013-01-25','13:45:00',2.44),('7643','2013-01-25','13:50:00',2.21),('7643','2013-01-25','13:55:00',2.17),('7643','2013-01-25','14:00:00',1.91),('7643','2013-01-25','14:05:00',1.77),('7643','2013-01-25','14:10:00',1.81),('7643','2013-01-25','14:15:00',1.71),('7643','2013-01-25','14:20:00',1.91),('7643','2013-01-25','14:25:00',2.08),('7643','2013-01-25','14:30:00',2.13),('7643','2013-01-25','14:35:00',1.81),('7643','2013-01-25','14:40:00',1.47),('7643','2013-01-25','14:45:00',1.28),('7643','2013-01-25','14:50:00',1.18),('7643','2013-01-25','14:55:00',1.2),('7643','2013-01-25','15:00:00',1.07),('7643','2013-01-25','15:30:00',1.01),('7643','2013-01-24','08:15:00',1.1),('7643','2013-01-24','08:20:00',2.15),('7643','2013-01-24','08:25:00',3.18),('7643','2013-01-24','08:30:00',3.48),('7643','2013-01-24','08:35:00',4.16),('7643','2013-01-24','08:40:00',4.59),('7643','2013-01-24','08:45:00',4.96),('7643','2013-01-24','08:50:00',4.98),('7643','2013-01-24','08:55:00',5.19),('7643','2013-01-24','09:00:00',6.11),('7643','2013-01-24','09:05:00',5.09),('7643','2013-01-24','09:10:00',5.51),('7643','2013-01-24','09:15:00',6.6),('7643','2013-01-24','09:20:00',7.24),('7643','2013-01-24','09:25:00',7.69),('7643','2013-01-24','09:30:00',8.14),('7643','2013-01-24','09:35:00',7.71),('7643','2013-01-24','09:40:00',7.65),('7643','2013-01-24','09:45:00',7.75),('7643','2013-01-24','09:50:00',9.6),('7643','2013-01-24','09:55:00',9.74),('7643','2013-01-24','10:00:00',9.95),('7643','2013-01-24','10:05:00',9.98),('7643','2013-01-24','10:10:00',10.22),('7643','2013-01-24','10:15:00',10.24),('7643','2013-01-24','10:20:00',10.33),('7643','2013-01-24','10:25:00',10.5),('7643','2013-01-24','10:30:00',9.59),('7643','2013-01-24','10:35:00',6.58),('7643','2013-01-24','10:40:00',7.24),('7643','2013-01-24','10:45:00',11.4),('7643','2013-01-24','10:50:00',7.63),('7643','2013-01-24','10:55:00',12.24),('7643','2013-01-24','11:00:00',6.88),('7643','2013-01-24','11:05:00',8.09),('7643','2013-01-24','11:10:00',10.55),('7643','2013-01-24','11:15:00',11.95),('7643','2013-01-24','11:20:00',11.85),('7643','2013-01-24','11:25:00',11.82),('7643','2013-01-24','11:30:00',11.87),('7643','2013-01-24','11:35:00',12.07),('7643','2013-01-24','11:40:00',12.02),('7643','2013-01-24','11:45:00',12.13),('7643','2013-01-24','11:50:00',12.25),('7643','2013-01-24','11:55:00',12.25),('7643','2013-01-24','12:00:00',12.14),('7643','2013-01-24','12:05:00',12.14),('7643','2013-01-24','12:10:00',12.35),('7643','2013-01-24','12:15:00',12.42),('7643','2013-01-24','12:20:00',12.46),('7643','2013-01-24','12:25:00',12.5),('7643','2013-01-24','12:30:00',12.3),('7643','2013-01-24','12:35:00',10.59),('7643','2013-01-24','12:40:00',11.09),('7643','2013-01-24','12:45:00',11.87),('7643','2013-01-24','12:50:00',11.98),('7643','2013-01-24','12:55:00',11.61),('7643','2013-01-24','13:00:00',11.65),('7643','2013-01-24','13:05:00',11.54),('7643','2013-01-24','13:10:00',11.42),('7643','2013-01-24','13:15:00',11.41),('7643','2013-01-24','13:20:00',11.45),('7643','2013-01-24','13:25:00',11.59),('7643','2013-01-24','13:30:00',11.74),('7643','2013-01-24','13:35:00',11.47),('7643','2013-01-24','13:40:00',11.29),('7643','2013-01-24','13:45:00',11.04),('7643','2013-01-24','13:50:00',10.71),('7643','2013-01-24','13:55:00',10.43),('7643','2013-01-24','14:00:00',10.1),('7643','2013-01-24','14:05:00',9.71),('7643','2013-01-24','14:10:00',8.89),('7643','2013-01-24','14:15:00',8.61),('7643','2013-01-24','14:20:00',7.93),('7643','2013-01-24','14:25:00',8.05),('7643','2013-01-24','14:30:00',7.45),('7643','2013-01-24','14:35:00',7.07),('7643','2013-01-24','14:40:00',6.83),('7643','2013-01-24','14:45:00',6.65),('7643','2013-01-24','14:50:00',6.69),('7643','2013-01-24','14:55:00',6.42),('7643','2013-01-24','15:00:00',5.87),('7643','2013-01-24','15:05:00',5.52),('7643','2013-01-24','15:10:00',5.53),('7643','2013-01-24','15:15:00',5.32),('7643','2013-01-24','15:20:00',5.19),('7643','2013-01-24','15:25:00',5.17),('7643','2013-01-24','15:30:00',5.15),('7643','2013-01-24','15:35:00',5.32),('7643','2013-01-24','15:40:00',4.89),('7643','2013-01-24','15:45:00',4.36),('7643','2013-01-24','15:50:00',4.77),('7643','2013-01-24','15:55:00',4.28),('7643','2013-01-24','16:00:00',2.99),('7643','2013-01-24','16:05:00',1.98),('7643','2013-01-24','16:10:00',1.87),('7643','2013-01-24','16:15:00',2.17),('7643','2013-01-24','16:20:00',2.05),('7643','2013-01-24','16:25:00',1.66),('7643','2013-01-24','16:30:00',1.48),('7643','2013-01-24','16:35:00',1.16),('7643','2013-01-23','08:40:00',1.2),('7643','2013-01-23','08:45:00',1.63),('7643','2013-01-23','08:50:00',2.22),('7643','2013-01-23','08:55:00',2.67),('7643','2013-01-23','09:00:00',3.16),('7643','2013-01-23','09:05:00',2.11),('7643','2013-01-23','09:10:00',2.08),('7643','2013-01-23','09:15:00',2.35),('7643','2013-01-23','09:20:00',3.03),('7643','2013-01-23','09:25:00',3.31),('7643','2013-01-23','09:30:00',3.32),('7643','2013-01-23','09:35:00',2.83),('7643','2013-01-23','09:40:00',3.49),('7643','2013-01-23','09:45:00',5.99),('7643','2013-01-23','09:50:00',4.21),('7643','2013-01-23','09:55:00',8.42),('7643','2013-01-23','10:00:00',8.93),('7643','2013-01-23','10:05:00',9.34),('7643','2013-01-23','10:10:00',10.12),('7643','2013-01-23','10:15:00',9.63),('7643','2013-01-23','10:20:00',10.35),('7643','2013-01-23','10:25:00',10.42),('7643','2013-01-23','10:30:00',10.63),('7643','2013-01-23','10:35:00',10.64),('7643','2013-01-23','10:40:00',10.84),('7643','2013-01-23','10:45:00',10.98),('7643','2013-01-23','10:50:00',10.65),('7643','2013-01-23','10:55:00',8.91),('7643','2013-01-23','11:00:00',5.61),('7643','2013-01-23','11:05:00',4.12),('7643','2013-01-23','11:10:00',2.35),('7643','2013-01-23','11:15:00',1.71),('7643','2013-01-23','11:20:00',1.78),('7643','2013-01-23','11:25:00',1.77),('7643','2013-01-23','11:30:00',1.75),('7643','2013-01-23','11:35:00',1.89),('7643','2013-01-23','11:40:00',1.9),('7643','2013-01-23','11:45:00',1.82),('7643','2013-01-23','11:50:00',1.74),('7643','2013-01-23','11:55:00',1.64),('7643','2013-01-23','12:00:00',1.54),('7643','2013-01-23','12:05:00',1.5),('7643','2013-01-23','12:10:00',1.46),('7643','2013-01-23','12:15:00',1.41),('7643','2013-01-23','12:20:00',1.46),('7643','2013-01-23','12:25:00',1.59),('7643','2013-01-23','12:30:00',1.79),('7643','2013-01-23','12:35:00',2.12),('7643','2013-01-23','12:40:00',2.6),('7643','2013-01-23','12:45:00',3.09),('7643','2013-01-23','12:50:00',3.39),('7643','2013-01-23','12:55:00',3.54),('7643','2013-01-23','13:00:00',3.55),('7643','2013-01-23','13:05:00',3.45),('7643','2013-01-23','13:10:00',3.17),('7643','2013-01-23','13:15:00',3.02),('7643','2013-01-23','13:20:00',3.02),('7643','2013-01-23','13:25:00',3.13),('7643','2013-01-23','13:30:00',3.26),('7643','2013-01-23','13:35:00',3.22),('7643','2013-01-23','13:40:00',3.22),('7643','2013-01-23','13:45:00',3.31),('7643','2013-01-23','13:50:00',3.4),('7643','2013-01-23','13:55:00',3.58),('7643','2013-01-23','14:00:00',4.62),('7643','2013-01-23','14:05:00',4.53),('7643','2013-01-23','14:10:00',4.33),('7643','2013-01-23','14:15:00',5.12),('7643','2013-01-23','14:20:00',7.43),('7643','2013-01-23','14:25:00',12.68),('7643','2013-01-23','14:30:00',11.1),('7643','2013-01-23','14:35:00',7.94),('7643','2013-01-23','14:40:00',5.28),('7643','2013-01-23','14:45:00',7.54),('7643','2013-01-23','14:50:00',7.94),('7643','2013-01-23','14:55:00',8.15),('7643','2013-01-23','15:00:00',4.82),('7643','2013-01-23','15:05:00',4.37),('7643','2013-01-23','15:10:00',2.84),('7643','2013-01-23','15:15:00',2.73),('7643','2013-01-23','15:20:00',5.15),('7643','2013-01-23','15:25:00',5.42),('7643','2013-01-23','15:30:00',5.49),('7643','2013-01-23','15:35:00',4.61),('7643','2013-01-23','15:40:00',2.57),('7643','2013-01-23','15:45:00',4.36),('7643','2013-01-23','15:50:00',4.49),('7643','2013-01-23','15:55:00',4.01),('7643','2013-01-23','16:00:00',3.62),('7643','2013-01-23','16:05:00',2.91),('7643','2013-01-23','16:10:00',2.37),('7643','2013-01-23','16:15:00',2.49),('7643','2013-01-23','16:20:00',2.17),('7643','2013-01-23','16:25:00',1.38),('7643','2013-01-22','09:35:00',1.72),('7643','2013-01-22','09:40:00',1.46),('7643','2013-01-22','09:45:00',2.25),('7643','2013-01-22','09:50:00',2.78),('7643','2013-01-22','09:55:00',7.05),('7643','2013-01-22','10:00:00',3.37),('7643','2013-01-22','10:05:00',2.63),('7643','2013-01-22','10:10:00',1.94),('7643','2013-01-22','10:15:00',2.99),('7643','2013-01-22','10:20:00',2.99),('7643','2013-01-22','10:25:00',4.61),('7643','2013-01-22','10:30:00',9.26),('7643','2013-01-22','10:35:00',10.08),('7643','2013-01-22','10:40:00',5.05),('7643','2013-01-22','10:45:00',7.05),('7643','2013-01-22','10:50:00',9.16),('7643','2013-01-22','10:55:00',6.93),('7643','2013-01-22','11:00:00',2.76),('7643','2013-01-22','11:05:00',1.75),('7643','2013-01-22','11:10:00',2.09),('7643','2013-01-22','11:15:00',1.69),('7643','2013-01-22','11:20:00',1.05),('7643','2013-01-22','12:45:00',1.11),('7643','2013-01-22','13:20:00',1.16),('7643','2013-01-22','13:35:00',1.16),('7643','2013-01-22','13:40:00',1.14),('7643','2013-01-21','08:00:00',1.25),('7643','2013-01-21','08:05:00',2.4),('7643','2013-01-21','08:10:00',2.38),('7643','2013-01-21','08:15:00',1.64),('7643','2013-01-21','08:20:00',2.19),('7643','2013-01-21','08:25:00',2.23),('7643','2013-01-21','08:30:00',1.49),('7643','2013-01-21','08:35:00',2.89),('7643','2013-01-21','08:40:00',1.89),('7643','2013-01-21','08:45:00',4),('7643','2013-01-21','08:50:00',4.42),('7643','2013-01-21','08:55:00',2.52),('7643','2013-01-21','09:00:00',3.83),('7643','2013-01-21','09:05:00',5.87),('7643','2013-01-21','09:10:00',2.05),('7643','2013-01-21','09:15:00',2.15),('7643','2013-01-21','09:20:00',1.37),('7643','2013-01-21','09:25:00',2.96),('7643','2013-01-21','09:30:00',7.04),('7643','2013-01-21','09:35:00',8.13),('7643','2013-01-21','09:40:00',6.5),('7643','2013-01-21','09:45:00',9.92),('7643','2013-01-21','09:50:00',6.38),('7643','2013-01-21','09:55:00',7.32),('7643','2013-01-21','10:00:00',5.43),('7643','2013-01-21','10:05:00',9.45),('7643','2013-01-21','10:10:00',9.86),('7643','2013-01-21','10:15:00',8.71),('7643','2013-01-21','10:20:00',9.99),('7643','2013-01-21','10:25:00',10.15),('7643','2013-01-21','10:30:00',10.61),('7643','2013-01-21','10:35:00',11.08),('7643','2013-01-21','10:40:00',11.53),('7643','2013-01-21','10:45:00',10.39),('7643','2013-01-21','10:50:00',9.12),('7643','2013-01-21','10:55:00',5.64),('7643','2013-01-21','11:00:00',4),('7643','2013-01-21','11:05:00',2.58),('7643','2013-01-21','11:10:00',4.39),('7643','2013-01-21','11:15:00',6.93),('7643','2013-01-21','11:20:00',7.05),('7643','2013-01-21','11:25:00',4.56),('7643','2013-01-21','11:30:00',3.08),('7643','2013-01-21','11:35:00',2.71),('7643','2013-01-21','11:40:00',2.1),('7643','2013-01-21','11:45:00',5.38),('7643','2013-01-21','11:50:00',8.9),('7643','2013-01-21','11:55:00',4.07),('7643','2013-01-21','12:00:00',3.07),('7643','2013-01-21','12:05:00',3.73),('7643','2013-01-21','12:10:00',10.18),('7643','2013-01-21','12:15:00',11.05),('7643','2013-01-21','12:20:00',6.2),('7643','2013-01-21','12:25:00',9.49),('7643','2013-01-21','12:30:00',4.56),('7643','2013-01-21','12:35:00',3.87),('7643','2013-01-21','12:40:00',13.18),('7643','2013-01-21','12:45:00',3.73),('7643','2013-01-21','12:50:00',3.93),('7643','2013-01-21','12:55:00',4.61),('7643','2013-01-21','13:00:00',8.69),('7643','2013-01-21','13:05:00',13.26),('7643','2013-01-21','13:10:00',9.45),('7643','2013-01-21','13:15:00',3.61),('7643','2013-01-21','13:20:00',11.62),('7643','2013-01-21','13:25:00',2.9),('7643','2013-01-21','13:30:00',4.1),('7643','2013-01-21','13:35:00',2.08),('7643','2013-01-21','13:40:00',3.39),('7643','2013-01-21','13:45:00',3.8),('7643','2013-01-21','13:50:00',4.79),('7643','2013-01-21','13:55:00',2.16),('7643','2013-01-21','14:00:00',2.44),('7643','2013-01-21','14:05:00',2.72),('7643','2013-01-21','14:10:00',4.68),('7643','2013-01-21','14:15:00',4.66),('7643','2013-01-21','14:20:00',3.86),('7643','2013-01-21','14:25:00',7.52),('7643','2013-01-21','14:30:00',2.73),('7643','2013-01-21','14:35:00',6.28),('7643','2013-01-21','14:40:00',5.26),('7643','2013-01-21','14:45:00',7.07),('7643','2013-01-21','14:50:00',5.32),('7643','2013-01-21','14:55:00',2.02),('7643','2013-01-21','15:00:00',2.1),('7643','2013-01-21','15:05:00',2.83),('7643','2013-01-21','15:10:00',1.54),('7643','2013-01-21','15:15:00',1.66),('7643','2013-01-21','15:20:00',1.62),('7643','2013-01-21','15:25:00',1.36),('7643','2013-01-21','15:30:00',1.76),('7643','2013-01-21','15:35:00',1.4),('7643','2013-01-21','15:40:00',1.7),('7643','2013-01-21','15:45:00',1.18),('7643','2013-01-21','15:50:00',1.2),('7643','2014-03-19','06:50:00',1.33),('7643','2014-03-19','06:55:00',1.52),('7643','2014-03-19','07:00:00',1.8),('7643','2014-03-19','07:05:00',2.13),('7643','2014-03-19','07:10:00',2.52),('7643','2014-03-19','07:15:00',2.95),('7643','2014-03-19','07:20:00',3.29),('7643','2014-03-19','07:25:00',3.62),('7643','2014-03-19','07:30:00',3.64),('7643','2014-03-19','07:35:00',4.32),('7643','2014-03-19','07:40:00',4.81),('7643','2014-03-19','07:45:00',5.2),('7643','2014-03-19','07:50:00',5.49),('7643','2014-03-19','07:55:00',5.84),('7643','2014-03-19','08:00:00',6.25),('7643','2014-03-19','08:05:00',6.61),('7643','2014-03-19','08:10:00',6.83),('7643','2014-03-19','08:15:00',7.02),('7643','2014-03-19','08:20:00',7.19),('7643','2014-03-19','08:25:00',7.49),('7643','2014-03-19','08:30:00',7.91),('7643','2014-03-19','08:35:00',8.36),('7643','2014-03-19','08:40:00',8.82),('7643','2014-03-19','08:45:00',9.21),('7643','2014-03-19','08:50:00',9.48),('7643','2014-03-19','08:55:00',9.65),('7643','2014-03-19','09:00:00',9.84),('7643','2014-03-19','09:05:00',10.13),('7643','2014-03-19','09:10:00',10.63),('7643','2014-03-19','09:15:00',10.78),('7643','2014-03-19','09:20:00',11.1),('7643','2014-03-19','09:25:00',11.21),('7643','2014-03-19','09:30:00',11.29),('7643','2014-03-19','09:35:00',11.8),('7643','2014-03-19','09:40:00',11.71),('7643','2014-03-19','09:45:00',11.92),('7643','2014-03-19','09:50:00',11.89),('7643','2014-03-19','09:55:00',12.1),('7643','2014-03-19','10:00:00',12.6),('7643','2014-03-19','10:05:00',13.09),('7643','2014-03-19','10:10:00',13.25),('7643','2014-03-19','10:15:00',13.1),('7643','2014-03-19','10:20:00',13.24),('7643','2014-03-19','10:25:00',13.46),('7643','2014-03-19','10:30:00',13.54),('7643','2014-03-19','10:35:00',13.29),('7643','2014-03-19','10:40:00',12.94),('7643','2014-03-19','10:45:00',12.9),('7643','2014-03-19','10:50:00',13.87),('7643','2014-03-19','10:55:00',14.49),('7643','2014-03-19','11:00:00',14.69),('7643','2014-03-19','11:05:00',14.6),('7643','2014-03-19','11:10:00',14.43),('7643','2014-03-19','11:15:00',13.75),('7643','2014-03-19','11:20:00',14.38),('7643','2014-03-19','11:25:00',14.46),('7643','2014-03-19','11:30:00',14.86),('7643','2014-03-19','11:35:00',15.25),('7643','2014-03-19','11:40:00',14.99),('7643','2014-03-19','11:45:00',15.17),('7643','2014-03-19','11:50:00',15.01),('7643','2014-03-19','11:55:00',14.03),('7643','2014-03-19','12:00:00',13.38),('7643','2014-03-19','12:05:00',14.61),('7643','2014-03-19','12:10:00',14.95),('7643','2014-03-19','12:15:00',15.03),('7643','2014-03-19','12:20:00',14.53),('7643','2014-03-19','12:25:00',13.89),('7643','2014-03-19','12:30:00',14.57),('7643','2014-03-19','12:35:00',14.85),('7643','2014-03-19','12:40:00',14.85),('7643','2014-03-19','12:45:00',15.28),('7643','2014-03-19','12:50:00',15.2),('7643','2014-03-19','12:55:00',14.82),('7643','2014-03-19','13:00:00',14.77),('7643','2014-03-19','13:05:00',14.64),('7643','2014-03-19','13:10:00',14.33),('7643','2014-03-19','13:15:00',14.4),('7643','2014-03-19','13:20:00',14.51),('7643','2014-03-19','13:25:00',14.14),('7643','2014-03-19','13:30:00',14.33),('7643','2014-03-19','13:35:00',13.91),('7643','2014-03-19','13:40:00',12.89),('7643','2014-03-19','13:45:00',12.59),('7643','2014-03-19','13:50:00',12.16),('7643','2014-03-19','13:55:00',11.42),('7643','2014-03-19','14:00:00',11.55),('7643','2014-03-19','14:05:00',12.61),('7643','2014-03-19','14:10:00',12.17),('7643','2014-03-19','14:15:00',11.6),('7643','2014-03-19','14:20:00',11.58),('7643','2014-03-19','14:25:00',11.58),('7643','2014-03-19','14:30:00',9.87),('7643','2014-03-19','14:35:00',9.12),('7643','2014-03-19','14:40:00',10.26),('7643','2014-03-19','14:45:00',10),('7643','2014-03-19','14:50:00',9.58),('7643','2014-03-19','14:55:00',9.13),('7643','2014-03-19','15:00:00',8.3),('7643','2014-03-19','15:05:00',8.26),('7643','2014-03-19','15:10:00',8.27),('7643','2014-03-19','15:15:00',7.84),('7643','2014-03-19','15:20:00',8.36),('7643','2014-03-19','15:25:00',7.74),('7643','2014-03-19','15:30:00',7.27),('7643','2014-03-19','15:35:00',7.11),('7643','2014-03-19','15:40:00',6.4),('7643','2014-03-19','15:45:00',6.35),('7643','2014-03-19','15:50:00',5.73),('7643','2014-03-19','15:55:00',5.11),('7643','2014-03-19','16:00:00',4.26),('7643','2014-03-19','16:05:00',3.92),('7643','2014-03-19','16:10:00',4.12),('7643','2014-03-19','16:15:00',3.98),('7643','2014-03-19','16:20:00',4.22),('7643','2014-03-19','16:25:00',4.27),('7643','2014-03-19','16:30:00',3.84),('7643','2014-03-19','16:35:00',3.52),('7643','2014-03-19','16:40:00',3.26),('7643','2014-03-19','16:45:00',2.42),('7643','2014-03-19','16:50:00',2.04),('7643','2014-03-19','16:55:00',1.78),('7643','2014-03-19','17:00:00',1.69),('7643','2014-03-19','17:05:00',1.78),('7643','2014-03-19','17:10:00',1.66),('7643','2014-03-19','17:15:00',1.45),('7643','2014-03-19','17:20:00',1.24),('7643','2014-03-19','17:25:00',1.08),('7643','2013-01-20','09:55:00',1),('7643','2013-01-20','10:00:00',1.26),('7643','2013-01-20','10:05:00',1.65),('7643','2013-01-20','10:10:00',2.08),('7643','2013-01-20','10:15:00',2.42),('7643','2013-01-20','10:20:00',2.13),('7643','2013-01-20','10:25:00',2.1),('7643','2013-01-20','10:30:00',2.11),('7643','2013-01-20','10:35:00',1.65),('7643','2013-01-20','10:40:00',1.77),('7643','2013-01-20','10:45:00',1.8),('7643','2013-01-20','10:50:00',1.76),('7643','2013-01-20','10:55:00',1.98),('7643','2013-01-20','11:00:00',3.16),('7643','2013-01-20','11:05:00',2.88),('7643','2013-01-20','11:10:00',3.96),('7643','2013-01-20','11:15:00',4.57),('7643','2013-01-20','11:20:00',3.59),('7643','2013-01-20','11:25:00',3.56),('7643','2013-01-20','11:30:00',2.48),('7643','2013-01-20','11:35:00',1.63),('7643','2013-01-20','11:40:00',2.86),('7643','2013-01-20','11:45:00',3.24),('7643','2013-01-20','11:50:00',4.26),('7643','2013-01-20','11:55:00',13.15),('7643','2013-01-20','12:00:00',11.62),('7643','2013-01-20','12:05:00',11.23),('7643','2013-01-20','12:10:00',11.01),('7643','2013-01-20','12:15:00',10.54),('7643','2013-01-20','12:20:00',4.42),('7643','2013-01-20','12:25:00',6.39),('7643','2013-01-20','12:30:00',2.62),('7643','2013-01-20','12:35:00',2.71),('7643','2013-01-20','12:40:00',4.09),('7643','2013-01-20','12:45:00',2.55),('7643','2013-01-20','12:50:00',4.41),('7643','2013-01-20','12:55:00',3.23),('7643','2013-01-20','13:00:00',3.27),('7643','2013-01-20','13:05:00',7.49),('7643','2013-01-20','13:10:00',5.33),('7643','2013-01-20','13:15:00',3.48),('7643','2013-01-20','13:20:00',3.41),('7643','2013-01-20','13:25:00',3.03),('7643','2013-01-20','13:30:00',11.85),('7643','2013-01-20','13:35:00',12.42),('7643','2013-01-20','13:40:00',10.78),('7643','2013-01-20','13:45:00',4.04),('7643','2013-01-20','13:50:00',8.09),('7643','2013-01-20','13:55:00',12.49),('7643','2013-01-20','14:00:00',8.97),('7643','2013-01-20','14:05:00',9.83),('7643','2013-01-20','14:10:00',8.74),('7643','2013-01-20','14:15:00',6.14),('7643','2013-01-20','14:20:00',7.3),('7643','2013-01-20','14:25:00',7.94),('7643','2013-01-20','14:30:00',5.12),('7643','2013-01-20','14:35:00',3.2),('7643','2013-01-20','14:40:00',2.17),('7643','2013-01-20','14:45:00',1.63),('7643','2013-01-20','14:50:00',1.94),('7643','2013-01-20','14:55:00',1.42),('7643','2013-01-20','15:00:00',1.31),('7643','2013-01-20','15:05:00',1.64),('7643','2013-01-20','15:10:00',1.23),('7643','2013-01-20','15:35:00',1.54),('7643','2013-01-20','15:40:00',1.49),('7643','2013-01-20','15:45:00',1.75),('7643','2013-01-20','15:50:00',1.68),('7643','2013-01-20','15:55:00',1.05),('7643','2013-01-19','08:20:00',1.34),('7643','2013-01-19','08:25:00',1.71),('7643','2013-01-19','08:30:00',2.25),('7643','2013-01-19','08:35:00',2.55),('7643','2013-01-19','08:40:00',2.47),('7643','2013-01-19','08:45:00',1.89),('7643','2013-01-19','08:50:00',1.42),('7643','2013-01-19','08:55:00',1.31),('7643','2013-01-19','09:00:00',1.67),('7643','2013-01-19','09:05:00',2.01),('7643','2013-01-19','09:10:00',1.75),('7643','2013-01-19','09:15:00',1.38),('7643','2013-01-19','09:20:00',1.28),('7643','2013-01-19','09:25:00',1.43),('7643','2013-01-19','09:30:00',1.56),('7643','2013-01-19','09:35:00',1.16),('7643','2013-01-19','09:40:00',1.07),('7643','2013-01-19','09:45:00',1.36),('7643','2013-01-19','09:50:00',1.29),('7643','2013-01-19','09:55:00',1.6),('7643','2013-01-19','10:00:00',2.07),('7643','2013-01-19','10:05:00',2.13),('7643','2013-01-19','10:10:00',1.54),('7643','2013-01-19','10:15:00',1.18),('7643','2013-01-19','10:20:00',1.78),('7643','2013-01-19','10:25:00',2.28),('7643','2013-01-19','10:30:00',2.7),('7643','2013-01-19','10:35:00',2.18),('7643','2013-01-19','10:40:00',2.64),('7643','2013-01-19','10:45:00',3.04),('7643','2013-01-19','10:50:00',3.66),('7643','2013-01-19','10:55:00',4.13),('7643','2013-01-19','11:00:00',4.5),('7643','2013-01-19','11:05:00',4.46),('7643','2013-01-19','11:10:00',4.79),('7643','2013-01-19','11:15:00',6.49),('7643','2013-01-19','11:20:00',5.13),('7643','2013-01-19','11:25:00',7.11),('7643','2013-01-19','11:30:00',9.21),('7643','2013-01-19','11:35:00',6.86),('7643','2013-01-19','11:40:00',4.01),('7643','2013-01-19','11:45:00',3.79),('7643','2013-01-19','11:50:00',2.67),('7643','2013-01-19','11:55:00',2.01),('7643','2013-01-19','12:00:00',2.25),('7643','2013-01-19','12:05:00',2.13),('7643','2013-01-19','12:10:00',2.45),('7643','2013-01-19','12:15:00',2.98),('7643','2013-01-19','12:20:00',3.39),('7643','2013-01-19','12:25:00',3.57),('7643','2013-01-19','12:30:00',3.34),('7643','2013-01-19','12:35:00',3.09),('7643','2013-01-19','12:40:00',2.88),('7643','2013-01-19','12:45:00',2.81),('7643','2013-01-19','12:50:00',2.72),('7643','2013-01-19','12:55:00',2.68),('7643','2013-01-19','13:00:00',2.57),('7643','2013-01-19','13:05:00',2.44),('7643','2013-01-19','13:10:00',2.47),('7643','2013-01-19','13:15:00',2.72),('7643','2013-01-19','13:20:00',2.76),('7643','2013-01-19','13:25:00',2.84),('7643','2013-01-19','13:30:00',2.58),('7643','2013-01-19','13:35:00',2.86),('7643','2013-01-19','13:40:00',3.38),('7643','2013-01-19','13:45:00',3.25),('7643','2013-01-19','13:50:00',3.15),('7643','2013-01-19','13:55:00',2.79),('7643','2013-01-19','14:00:00',2.42),('7643','2013-01-19','14:05:00',2.11),('7643','2013-01-19','14:10:00',1.86),('7643','2013-01-19','14:15:00',2.1),('7643','2013-01-19','14:20:00',2.59),('7643','2013-01-19','14:25:00',2.24),('7643','2013-01-19','14:30:00',1.69),('7643','2013-01-19','14:35:00',1.42),('7643','2013-01-19','14:40:00',1.38),('7643','2013-01-19','14:45:00',1.41),('7643','2013-01-19','14:50:00',1.38),('7643','2013-01-19','14:55:00',1.11),('7643','2013-01-19','15:00:00',1.06),('7643','2013-01-18','08:25:00',1.04),('7643','2013-01-18','08:30:00',1.11),('7643','2013-01-18','08:35:00',1.22),('7643','2013-01-18','08:40:00',1.42),('7643','2013-01-18','08:45:00',1.69),('7643','2013-01-18','08:50:00',1.9),('7643','2013-01-18','08:55:00',2.05),('7643','2013-01-18','09:00:00',2.26),('7643','2013-01-18','09:05:00',2.5),('7643','2013-01-18','09:10:00',3.4),('7643','2013-01-18','09:15:00',5.35),('7643','2013-01-18','09:20:00',4.91),('7643','2013-01-18','09:25:00',3.97),('7643','2013-01-18','09:30:00',2.72),('7643','2013-01-18','09:35:00',2.45),('7643','2013-01-18','09:40:00',2.17),('7643','2013-01-18','09:45:00',2.9),('7643','2013-01-18','09:50:00',4.03),('7643','2013-01-18','09:55:00',5.83),('7643','2013-01-18','10:00:00',5.14),('7643','2013-01-18','10:05:00',4.03),('7643','2013-01-18','10:10:00',2.75),('7643','2013-01-18','10:15:00',1.9),('7643','2013-01-18','10:20:00',1.63),('7643','2013-01-18','10:25:00',2.18),('7643','2013-01-18','10:30:00',2.05),('7643','2013-01-18','10:35:00',3.38),('7643','2013-01-18','10:40:00',4.31),('7643','2013-01-18','10:45:00',4.93),('7643','2013-01-18','10:50:00',5.4),('7643','2013-01-18','10:55:00',2.66),('7643','2013-01-18','11:00:00',2.8),('7643','2013-01-18','11:05:00',3.06),('7643','2013-01-18','11:10:00',3.26),('7643','2013-01-18','11:15:00',3.47),('7643','2013-01-18','11:20:00',4.21),('7643','2013-01-18','11:25:00',4.34),('7643','2013-01-18','11:30:00',3.55),('7643','2013-01-18','11:35:00',2.4),('7643','2013-01-18','11:40:00',2.19),('7643','2013-01-18','11:45:00',2.46),('7643','2013-01-18','11:50:00',2.69),('7643','2013-01-18','11:55:00',2.49),('7643','2013-01-18','12:00:00',2.12),('7643','2013-01-18','12:05:00',2.11),('7643','2013-01-18','12:10:00',2.33),('7643','2013-01-18','12:15:00',2.5),('7643','2013-01-18','12:20:00',2.29),('7643','2013-01-18','12:25:00',1.86),('7643','2013-01-18','12:30:00',1.5),('7643','2013-01-18','12:35:00',1.29),('7643','2013-01-18','14:25:00',1.02),('7643','2013-01-18','14:30:00',1.84),('7643','2013-01-18','14:35:00',2.3),('7643','2013-01-18','14:40:00',1.5),('7643','2013-01-18','15:15:00',1.22),('7643','2013-01-17','08:35:00',1.2),('7643','2013-01-17','08:40:00',1.55),('7643','2013-01-17','08:45:00',2.15),('7643','2013-01-17','08:50:00',2.37),('7643','2013-01-17','08:57:00',2.47),('7643','2013-01-17','09:00:00',1.83),('7643','2013-01-17','09:05:00',1.52),('7643','2013-01-17','09:10:00',1.08),('7643','2013-01-17','09:20:00',1.24),('7643','2013-01-17','09:25:00',1.31),('7643','2013-01-17','09:35:00',1.65),('7643','2013-01-17','09:40:00',1.65),('7643','2013-01-17','09:45:00',1.39),('7643','2013-01-17','09:50:00',1.64),('7643','2013-01-17','09:55:00',2.08),('7643','2013-01-17','10:00:00',2.16),('7643','2013-01-17','10:05:00',2.22),('7643','2013-01-17','10:10:00',3),('7643','2013-01-17','10:15:00',9.11),('7643','2013-01-17','10:20:00',8.95),('7643','2013-01-17','10:25:00',6.56),('7643','2013-01-17','10:30:00',5.2),('7643','2013-01-17','10:35:00',4.05),('7643','2013-01-17','10:40:00',3.21),('7643','2013-01-17','10:45:00',2.91),('7643','2013-01-17','10:50:00',2.98),('7643','2013-01-17','10:55:00',3.01),('7643','2013-01-17','11:00:00',3.18),('7643','2013-01-17','11:05:00',3.34),('7643','2013-01-17','11:10:00',3.4),('7643','2013-01-17','11:15:00',3.26),('7643','2013-01-17','11:20:00',2.88),('7643','2013-01-17','11:25:00',2.94),('7643','2013-01-17','11:30:00',3.74),('7643','2013-01-17','11:35:00',4.52),('7643','2013-01-17','11:40:00',4.4),('7643','2013-01-17','11:45:00',3.66),('7643','2013-01-17','11:50:00',2.99),('7643','2013-01-17','11:55:00',3.04),('7643','2013-01-17','12:00:00',3.34),('7643','2013-01-17','12:05:00',3.32),('7643','2013-01-17','12:10:00',3.77),('7643','2013-01-17','12:15:00',3.83),('7643','2013-01-17','12:20:00',3.73),('7643','2013-01-17','12:25:00',3.88),('7643','2013-01-17','12:30:00',3.91),('7643','2013-01-17','12:35:00',4.68),('7643','2013-01-17','12:40:00',5.39),('7643','2013-01-17','12:45:00',5.6),('7643','2013-01-17','12:50:00',7.87),('7643','2013-01-17','12:55:00',7.49),('7643','2013-01-17','13:00:00',9.55),('7643','2013-01-17','13:05:00',8.96),('7643','2013-01-17','13:10:00',8.35),('7643','2013-01-17','13:15:00',8.96),('7643','2013-01-17','13:20:00',7.21),('7643','2013-01-17','13:25:00',5.84),('7643','2013-01-17','13:30:00',5.44),('7643','2013-01-17','13:35:00',5.36),('7643','2013-01-17','13:40:00',6.3),('7643','2013-01-17','13:45:00',7.99),('7643','2013-01-17','13:50:00',10.86),('7643','2013-01-17','13:55:00',11.29),('7643','2013-01-17','14:00:00',11.74),('7643','2013-01-17','14:05:00',10.07),('7643','2013-01-17','14:10:00',10.84),('7643','2013-01-17','14:15:00',6.93),('7643','2013-01-17','14:20:00',7.1),('7643','2013-01-17','14:25:00',5.61),('7643','2013-01-17','14:30:00',4.36),('7643','2013-01-17','14:35:00',3.69),('7643','2013-01-17','14:40:00',3.36),('7643','2013-01-17','14:45:00',3.97),('7643','2013-01-17','14:50:00',4.12),('7643','2013-01-17','14:55:00',3.4),('7643','2013-01-17','15:00:00',2.88),('7643','2013-01-17','15:05:00',3.08),('7643','2013-01-17','15:10:00',2.97),('7643','2013-01-17','15:15:00',3.3),('7643','2013-01-17','15:20:00',3.61),('7643','2013-01-17','15:25:00',4.17),('7643','2013-01-17','15:30:00',3.52),('7643','2013-01-17','15:35:00',2.56),('7643','2013-01-17','15:40:00',1.8),('7643','2013-01-17','15:45:00',2.87),('7643','2013-01-17','15:50:00',3.16),('7643','2013-01-17','15:55:00',3.25),('7643','2013-01-17','16:00:00',2.9),('7643','2013-01-17','16:05:00',2.72),('7643','2013-01-17','16:10:00',2.58),('7643','2013-01-17','16:15:00',2.43),('7643','2013-01-17','16:20:00',2.03),('7643','2013-01-17','16:25:00',1.72),('7643','2013-01-17','16:30:00',1.35),('7643','2013-01-17','16:35:00',1.03),('7643','2013-01-16','08:50:00',1.16),('7643','2013-01-16','08:55:00',1.32),('7643','2013-01-16','09:00:00',1.32),('7643','2013-01-16','09:05:00',1.77),('7643','2013-01-16','09:10:00',2.53),('7643','2013-01-16','09:15:00',2.73),('7643','2013-01-16','09:20:00',2.65),('7643','2013-01-16','09:25:00',2.39),('7643','2013-01-16','09:30:00',2.65),('7643','2013-01-16','09:35:00',2.97),('7643','2013-01-16','09:40:00',3.22),('7643','2013-01-16','09:45:00',4.01),('7643','2013-01-16','09:50:00',4.95),('7643','2013-01-16','09:55:00',4.63),('7643','2013-01-16','10:00:00',3.32),('7643','2013-01-16','10:05:00',3.48),('7643','2013-01-16','10:10:00',4.21),('7643','2013-01-16','10:15:00',4.95),('7643','2013-01-16','10:20:00',5.01),('7643','2013-01-16','10:25:00',6.34),('7643','2013-01-16','10:30:00',6.7),('7643','2013-01-16','10:35:00',6.2),('7643','2013-01-16','10:40:00',5.81),('7643','2013-01-16','10:45:00',6.32),('7643','2013-01-16','10:50:00',5.98),('7643','2013-01-16','10:55:00',7.18),('7643','2013-01-16','11:00:00',6.43),('7643','2013-01-16','11:05:00',6.16),('7643','2013-01-16','11:10:00',7.35),('7643','2013-01-16','11:15:00',7.34),('7643','2013-01-16','11:20:00',6.97),('7643','2013-01-16','11:25:00',6.05),('7643','2013-01-16','11:30:00',5.34),('7643','2013-01-16','11:35:00',5.98),('7643','2013-01-16','11:40:00',6.21),('7643','2013-01-16','11:45:00',5.39),('7643','2013-01-16','11:50:00',5.95),('7643','2013-01-16','11:55:00',6.41),('7643','2013-01-16','12:00:00',7.06),('7643','2013-01-16','12:05:00',7.15),('7643','2013-01-16','12:10:00',7.41),('7643','2013-01-16','12:15:00',8.36),('7643','2013-01-16','12:20:00',7.44),('7643','2013-01-16','12:25:00',6.03),('7643','2013-01-16','12:30:00',4.84),('7643','2013-01-16','12:35:00',5.83),('7643','2013-01-16','12:40:00',5.98),('7643','2013-01-16','12:45:00',4.53),('7643','2013-01-16','12:50:00',3.19),('7643','2013-01-16','12:55:00',3.11),('7643','2013-01-16','13:00:00',6.71),('7643','2013-01-16','13:05:00',5.57),('7643','2013-01-16','13:10:00',4.25),('7643','2013-01-16','13:15:00',5.6),('7643','2013-01-16','13:20:00',6.02),('7643','2013-01-16','13:25:00',5.5),('7643','2013-01-16','13:30:00',4.79),('7643','2013-01-16','13:35:00',5.87),('7643','2013-01-16','13:40:00',7.92),('7643','2013-01-16','13:45:00',6.91),('7643','2013-01-16','13:50:00',5.37),('7643','2013-01-16','13:55:00',3.49),('7643','2013-01-16','14:00:00',3.62),('7643','2013-01-16','14:05:00',3.88),('7643','2013-01-16','14:10:00',3.53),('7643','2013-01-16','14:15:00',2.13),('7643','2013-01-16','14:20:00',2.36),('7643','2013-01-16','14:25:00',3.18),('7643','2013-01-16','14:30:00',4.26),('7643','2013-01-16','14:35:00',5.57),('7643','2013-01-16','14:40:00',3.5),('7643','2013-01-16','14:45:00',1.31),('7643','2013-01-16','14:50:00',1.3),('7643','2013-01-16','14:55:00',2.65),('7643','2013-01-16','15:00:00',2.9),('7643','2013-01-16','15:05:00',1.94),('7643','2013-01-16','15:10:00',1.11),('7643','2013-01-16','15:15:00',1.15),('7643','2013-01-16','15:20:00',1.42),('7643','2013-01-16','15:25:00',1.5),('7643','2013-01-16','15:30:00',1.33),('7643','2013-01-16','15:35:00',1.24),('7643','2013-01-16','15:40:00',1.23),('7643','2013-01-16','15:45:00',1.37),('7643','2013-01-16','15:50:00',1.1),('7643','2013-01-15','08:40:00',1.92),('7643','2013-01-15','08:45:00',1.73),('7643','2013-01-15','09:00:00',1.18),('7643','2013-01-15','09:10:00',1.68),('7643','2013-01-15','09:15:00',4.3),('7643','2013-01-15','09:20:00',4.01),('7643','2013-01-15','09:25:00',6.13),('7643','2013-01-15','09:30:00',6.86),('7643','2013-01-15','09:35:00',7.23),('7643','2013-01-15','09:40:00',7.62),('7643','2013-01-15','09:45:00',5.08),('7643','2013-01-15','09:50:00',2.77),('7643','2013-01-15','09:55:00',3.53),('7643','2013-01-15','10:00:00',3.89),('7643','2013-01-15','10:05:00',2.37),('7643','2013-01-15','10:10:00',1.93),('7643','2013-01-15','10:20:00',1.3),('7643','2013-01-15','10:25:00',2.03),('7643','2013-01-15','10:30:00',2.75),('7643','2013-01-15','10:35:00',6.75),('7643','2013-01-15','10:40:00',7.79),('7643','2013-01-15','10:45:00',9.15),('7643','2013-01-15','10:50:00',2.55),('7643','2013-01-15','10:55:00',7.26),('7643','2013-01-15','11:00:00',3.03),('7643','2013-01-15','11:05:00',2.7),('7643','2013-01-15','11:10:00',1.66),('7643','2013-01-15','11:20:00',1.12),('7643','2013-01-15','11:25:00',6.17),('7643','2013-01-15','11:30:00',1.62),('7643','2013-01-15','12:00:00',5.43),('7643','2013-01-15','12:05:00',4.67),('7643','2013-01-15','12:10:00',5.49),('7643','2013-01-15','12:15:00',12.8),('7643','2013-01-15','12:20:00',12.64),('7643','2013-01-15','12:25:00',5.38),('7643','2013-01-15','12:30:00',1.73),('7643','2013-01-15','13:00:00',2.42),('7643','2013-01-15','13:05:00',8.07),('7643','2013-01-15','13:10:00',14.55),('7643','2013-01-15','13:15:00',15),('7643','2013-01-15','13:20:00',11.01),('7643','2013-01-15','13:25:00',7.25),('7643','2013-01-15','13:30:00',2.64),('7643','2013-01-15','13:35:00',1.15),('7643','2013-01-15','13:50:00',1.81),('7643','2013-01-15','13:55:00',9.93),('7643','2013-01-15','14:00:00',6.09),('7643','2013-01-15','14:05:00',5.46),('7643','2013-01-15','14:10:00',2.89),('7643','2013-01-15','15:00:00',1.44),('7643','2013-01-15','15:05:00',3.11),('7643','2013-01-15','15:10:00',3.04),('7643','2013-01-15','15:15:00',2.67),('7643','2013-01-15','15:20:00',1.24),('7643','2013-01-15','15:25:00',1.11),('7643','2013-01-15','15:30:00',1.05),('7643','2013-01-15','15:45:00',1.01),('7643','2013-01-15','15:50:00',1.12),('7643','2013-01-15','15:55:00',1.24),('7643','2013-01-15','16:00:00',1.11),('7643','2013-01-15','16:05:00',2.52),('7643','2013-01-15','16:10:00',2.17),('7643','2013-01-15','16:15:00',1.8),('7643','2013-01-15','16:20:00',1.04),('7643','2013-01-14','08:05:00',1.12),('7643','2013-01-14','08:10:00',1.02),('7643','2013-01-14','08:15:00',1.67),('7643','2013-01-14','08:20:00',1.32),('7643','2013-01-14','08:25:00',1.52),('7643','2013-01-14','08:30:00',1.7),('7643','2013-01-14','08:35:00',1.82),('7643','2013-01-14','08:40:00',1.72),('7643','2013-01-14','08:45:00',1.76),('7643','2013-01-14','08:50:00',1.67),('7643','2013-01-14','08:55:00',2.39),('7643','2013-01-14','09:00:00',2.35),('7643','2013-01-14','09:05:00',1.67),('7643','2013-01-14','09:10:00',1.79),('7643','2013-01-14','09:15:00',2.12),('7643','2013-01-14','09:20:00',1.47),('7643','2013-01-14','09:40:00',1.29),('7643','2013-01-14','09:45:00',1.93),('7643','2013-01-14','09:50:00',2.45),('7643','2013-01-14','09:55:00',3.61),('7643','2013-01-14','10:00:00',3.73),('7643','2013-01-14','10:05:00',2.87),('7643','2013-01-14','10:10:00',3.64),('7643','2013-01-14','10:15:00',3.29),('7643','2013-01-14','10:20:00',3.74),('7643','2013-01-14','10:25:00',3.81),('7643','2013-01-14','10:30:00',2.81),('7643','2013-01-14','10:35:00',3.13),('7643','2013-01-14','10:40:00',3.58),('7643','2013-01-14','10:45:00',4.22),('7643','2013-01-14','10:50:00',5.31),('7643','2013-01-14','10:55:00',5.73),('7643','2013-01-14','11:00:00',5.16),('7643','2013-01-14','11:05:00',5.7),('7643','2013-01-14','11:10:00',5.93),('7643','2013-01-14','11:15:00',5.63),('7643','2013-01-14','11:20:00',5.98),('7643','2013-01-14','11:25:00',5.83),('7643','2013-01-14','11:30:00',5.53),('7643','2013-01-14','11:35:00',5),('7643','2013-01-14','11:40:00',4.62),('7643','2013-01-14','11:45:00',3.94),('7643','2013-01-14','11:50:00',3.66),('7643','2013-01-14','11:55:00',4.03),('7643','2013-01-14','12:00:00',3.85),('7643','2013-01-14','12:05:00',3.68),('7643','2013-01-14','12:10:00',3.57),('7643','2013-01-14','12:15:00',4.23),('7643','2013-01-14','12:20:00',4.87),('7643','2013-01-14','12:25:00',4.7),('7643','2013-01-14','12:30:00',4.29),('7643','2013-01-14','12:35:00',4.24),('7643','2013-01-14','12:40:00',4.77),('7643','2013-01-14','12:45:00',4.97),('7643','2013-01-14','12:50:00',4.6),('7643','2013-01-14','12:55:00',4.12),('7643','2013-01-14','13:00:00',3.41),('7643','2013-01-14','13:05:00',3.58),('7643','2013-01-14','13:10:00',3.55),('7643','2013-01-14','13:15:00',3.68),('7643','2013-01-14','13:20:00',3.7),('7643','2013-01-14','13:25:00',3.6),('7643','2013-01-14','13:30:00',4.01),('7643','2013-01-14','13:35:00',4.09),('7643','2013-01-14','13:40:00',4.61),('7643','2013-01-14','13:45:00',4.31),('7643','2013-01-14','13:50:00',4.27),('7643','2013-01-14','13:55:00',4.91),('7643','2013-01-14','14:00:00',9.12),('7643','2013-01-14','14:05:00',10.69),('7643','2013-01-14','14:10:00',9.96),('7643','2013-01-14','14:15:00',10.62),('7643','2013-01-14','14:20:00',10.98),('7643','2013-01-14','14:25:00',10.46),('7643','2013-01-14','14:30:00',8.26),('7643','2013-01-14','14:35:00',7.14),('7643','2013-01-14','14:40:00',7.77),('7643','2013-01-14','14:45:00',7.48),('7643','2013-01-14','14:50:00',6.3),('7643','2013-01-14','14:55:00',4.74),('7643','2013-01-14','15:00:00',6.82),('7643','2013-01-14','15:05:00',6.89),('7643','2013-01-14','15:10:00',5.92),('7643','2013-01-14','15:15:00',3.11),('7643','2013-01-14','15:20:00',2.61),('7643','2013-01-14','15:25:00',3.5),('7643','2013-01-14','15:30:00',3.13),('7643','2013-01-14','15:35:00',3.01),('7643','2013-01-14','15:40:00',2.73),('7643','2013-01-14','15:45:00',2.6),('7643','2013-01-14','15:50:00',2.62),('7643','2013-01-14','15:55:00',2.56),('7643','2013-01-14','16:00:00',2.96),('7643','2013-01-14','16:05:00',3.34),('7643','2013-01-14','16:10:00',3.06),('7643','2013-01-14','16:15:00',2.67),('7643','2013-01-14','16:20:00',2.26),('7643','2013-01-14','16:25:00',1.88),('7643','2013-01-14','16:30:00',1.55),('7643','2013-01-14','16:35:00',1.16),('7643','2013-01-13','09:30:00',1.08),('7643','2013-01-13','09:35:00',1.3),('7643','2013-01-13','09:40:00',1.49),('7643','2013-01-13','09:45:00',2),('7643','2013-01-13','09:50:00',2.21),('7643','2013-01-13','09:55:00',1.84),('7643','2013-01-13','10:00:00',1.12),('7643','2013-01-13','10:05:00',1.02),('7643','2013-01-13','10:10:00',1.03),('7643','2013-01-13','10:20:00',1.03),('7643','2013-01-13','10:25:00',2.02),('7643','2013-01-13','10:30:00',1.42),('7643','2013-01-13','10:35:00',1.31),('7643','2013-01-13','10:45:00',1.48),('7643','2013-01-13','10:50:00',1.22),('7643','2013-01-13','10:55:00',1.73),('7643','2013-01-13','11:00:00',1.56),('7643','2013-01-13','11:05:00',1.76),('7643','2013-01-13','11:10:00',1.67),('7643','2013-01-13','11:15:00',1.81),('7643','2013-01-13','11:20:00',2.65),('7643','2013-01-13','11:25:00',2.68),('7643','2013-01-13','11:30:00',1.97),('7643','2013-01-13','11:35:00',2),('7643','2013-01-13','11:40:00',1.91),('7643','2013-01-13','11:45:00',1.64),('7643','2013-01-13','11:50:00',2.29),('7643','2013-01-13','11:55:00',1.81),('7643','2013-01-13','12:00:00',1.46),('7643','2013-01-13','12:05:00',1.29),('7643','2013-01-13','12:10:00',1.27),('7643','2013-01-13','12:15:00',1.68),('7643','2013-01-13','12:20:00',2.3),('7643','2013-01-13','12:25:00',3.16),('7643','2013-01-13','12:30:00',3.26),('7643','2013-01-13','12:35:00',2.93),('7643','2013-01-13','12:40:00',3.33),('7643','2013-01-13','12:45:00',3.66),('7643','2013-01-13','12:50:00',4.55),('7643','2013-01-13','12:55:00',4.27),('7643','2013-01-13','13:00:00',4.44),('7643','2013-01-13','13:05:00',4.25),('7643','2013-01-13','13:10:00',3.95),('7643','2013-01-13','13:15:00',3.32),('7643','2013-01-13','13:20:00',2.32),('7643','2013-01-13','13:25:00',1.36),('7643','2013-01-13','13:30:00',1.75),('7643','2013-01-13','13:35:00',2.54),('7643','2013-01-13','13:40:00',2.19),('7643','2013-01-13','13:45:00',1.16),('7643','2013-01-13','14:15:00',1.55),('7643','2013-01-13','14:20:00',1.3),('7643','2013-01-13','15:10:00',1.5),('7643','2013-01-13','15:15:00',5.02),('7643','2013-01-13','15:20:00',3.28),('7643','2013-01-13','15:25:00',3.31),('7643','2013-01-13','15:30:00',2.17),('7643','2013-01-13','15:35:00',1.35),('7643','2013-01-13','15:40:00',1.15),('7643','2013-01-13','15:45:00',1.12),('7643','2013-01-13','15:50:00',1.86),('7643','2013-01-13','15:55:00',1.41),('7643','2013-01-12','09:10:00',2.44),('7643','2013-01-12','09:15:00',6.45),('7643','2013-01-12','09:20:00',6.7),('7643','2013-01-12','09:25:00',6.71),('7643','2013-01-12','09:30:00',7.11),('7643','2013-01-12','09:35:00',7.36),('7643','2013-01-12','09:40:00',4.58),('7643','2013-01-12','09:45:00',2.8),('7643','2013-01-12','09:50:00',5.57),('7643','2013-01-12','09:55:00',7.07),('7643','2013-01-12','10:00:00',7.2),('7643','2013-01-12','10:05:00',7.59),('7643','2013-01-12','10:10:00',4.78),('7643','2013-01-12','10:15:00',3.04),('7643','2013-01-12','10:20:00',4.33),('7643','2013-01-12','10:25:00',6.32),('7643','2013-01-12','10:30:00',7.76),('7643','2013-01-12','10:35:00',3.65),('7643','2013-01-12','10:40:00',1.83),('7643','2013-01-12','10:45:00',1.44),('7643','2013-01-12','11:55:00',1.27),('7643','2013-01-12','12:00:00',1.37),('7643','2013-01-12','12:05:00',1.46),('7643','2013-01-12','12:10:00',1.45),('7643','2013-01-12','12:15:00',1.84),('7643','2013-01-12','12:20:00',1.95),('7643','2013-01-12','12:25:00',1.5),('7643','2013-01-12','12:30:00',1.6),('7643','2013-01-12','12:35:00',1.41),('7643','2013-01-12','12:40:00',1.64),('7643','2013-01-12','12:45:00',1.51),('7643','2013-01-12','13:40:00',1.01),('7643','2013-01-12','14:50:00',1.02),('7643','2013-01-11','08:05:00',1.19),('7643','2013-01-11','08:10:00',1.46),('7643','2013-01-11','08:15:00',1.72),('7643','2013-01-11','08:20:00',2.02),('7643','2013-01-11','08:25:00',2.33),('7643','2013-01-11','08:30:00',2.65),('7643','2013-01-11','08:35:00',2.96),('7643','2013-01-11','08:40:00',3.31),('7643','2013-01-11','08:45:00',3.6),('7643','2013-01-11','08:50:00',3.89),('7643','2013-01-11','08:55:00',4.21),('7643','2013-01-11','09:00:00',4.59),('7643','2013-01-11','09:05:00',4.91),('7643','2013-01-11','09:10:00',5.15),('7643','2013-01-11','09:15:00',5.4),('7643','2013-01-11','09:20:00',5.65),('7643','2013-01-11','09:25:00',5.98),('7643','2013-01-11','09:30:00',6.21),('7643','2013-01-11','09:35:00',6.38),('7643','2013-01-11','09:40:00',6.63),('7643','2013-01-11','09:45:00',6.84),('7643','2013-01-11','09:50:00',7.1),('7643','2013-01-11','09:55:00',7.33),('7643','2013-01-11','10:00:00',7.57),('7643','2013-01-11','10:05:00',7.95),('7643','2013-01-11','10:10:00',8.14),('7643','2013-01-11','10:15:00',8.35),('7643','2013-01-11','10:20:00',8.48),('7643','2013-01-11','10:25:00',8.68),('7643','2013-01-11','10:30:00',8.86),('7643','2013-01-11','10:35:00',9),('7643','2013-01-11','10:40:00',9.16),('7643','2013-01-11','10:45:00',9.38),('7643','2013-01-11','10:50:00',9.52),('7643','2013-01-11','10:55:00',9.62),('7643','2013-01-11','11:00:00',9.69),('7643','2013-01-11','11:05:00',9.55),('7643','2013-01-11','11:10:00',9.71),('7643','2013-01-11','11:15:00',9.8),('7643','2013-01-11','11:20:00',9.97),('7643','2013-01-11','11:25:00',9.96),('7643','2013-01-11','11:30:00',9.95),('7643','2013-01-11','11:35:00',10.06),('7643','2013-01-11','11:40:00',10.14),('7643','2013-01-11','11:45:00',10.24),('7643','2013-01-11','11:50:00',10.34),('7643','2013-01-11','11:55:00',10.33),('7643','2013-01-11','12:00:00',10.22),('7643','2013-01-11','12:05:00',10.15),('7643','2013-01-11','12:10:00',10.08),('7643','2013-01-11','12:15:00',10.2),('7643','2013-01-11','12:20:00',10.06),('7643','2013-01-11','12:25:00',9.95),('7643','2013-01-11','12:30:00',10.12),('7643','2013-01-11','12:35:00',7.9),('7643','2013-01-11','12:40:00',6.68),('7643','2013-01-11','12:45:00',1.96),('7643','2013-01-11','12:50:00',8.17),('7643','2013-01-11','12:55:00',5.66),('7643','2013-01-11','13:00:00',10.11),('7643','2013-01-11','13:05:00',9.69),('7643','2013-01-11','13:10:00',7.87),('7643','2013-01-11','13:15:00',8.06),('7643','2013-01-11','13:20:00',4.39),('7643','2013-01-11','13:25:00',8.53),('7643','2013-01-11','13:30:00',7.77),('7643','2013-01-11','13:35:00',9.12),('7643','2013-01-11','13:40:00',3),('7643','2013-01-11','13:45:00',6.63),('7643','2013-01-11','13:50:00',9.08),('7643','2013-01-11','13:55:00',9.56),('7643','2013-01-11','14:00:00',4.81),('7643','2013-01-11','14:05:00',8.04),('7643','2013-01-11','14:10:00',8.91),('7643','2013-01-11','14:15:00',8.12),('7643','2013-01-11','14:20:00',7.61),('7643','2013-01-11','14:25:00',7.44),('7643','2013-01-11','14:30:00',6.96),('7643','2013-01-11','14:35:00',6.72),('7643','2013-01-11','14:40:00',6.45),('7643','2013-01-11','14:45:00',6.13),('7643','2013-01-11','14:50:00',5.99),('7643','2013-01-11','14:55:00',5.81),('7643','2013-01-11','15:00:00',5.49),('7643','2013-01-11','15:05:00',5.07),('7643','2013-01-11','15:10:00',4.57),('7643','2013-01-11','15:15:00',3.6),('7643','2013-01-11','15:20:00',3.94),('7643','2013-01-11','15:25:00',3.92),('7643','2013-01-11','15:30:00',2.01),('7643','2013-01-11','15:35:00',3.37),('7643','2013-01-11','15:40:00',2.86),('7643','2013-01-11','15:45:00',2.79),('7643','2013-01-11','15:50:00',2.64),('7643','2013-01-11','15:55:00',2.42),('7643','2013-01-11','16:00:00',2.15),('7643','2013-01-11','16:05:00',1.91),('7643','2013-01-11','16:10:00',1.64),('7643','2013-01-11','16:15:00',1.33),('7643','2013-01-11','16:20:00',1.07),('7643','2014-03-18','06:50:00',1),('7643','2014-03-18','06:55:00',1.18),('7643','2014-03-18','07:00:00',1.47),('7643','2014-03-18','07:05:00',1.57),('7643','2014-03-18','07:10:00',1.42),('7643','2014-03-18','07:15:00',1.52),('7643','2014-03-18','07:20:00',2.22),('7643','2014-03-18','07:25:00',2.27),('7643','2014-03-18','07:30:00',1.89),('7643','2014-03-18','07:35:00',1.14),('7643','2014-03-18','07:40:00',1.05),('7643','2014-03-18','07:45:00',1.08),('7643','2014-03-18','07:50:00',1.44),('7643','2014-03-18','07:55:00',1.61),('7643','2014-03-18','08:00:00',1.58),('7643','2014-03-18','08:05:00',1.63),('7643','2014-03-18','08:10:00',1.69),('7643','2014-03-18','08:15:00',1.62),('7643','2014-03-18','08:20:00',1.7),('7643','2014-03-18','08:25:00',1.95),('7643','2014-03-18','08:30:00',2.17),('7643','2014-03-18','08:35:00',2.47),('7643','2014-03-18','08:40:00',2.91),('7643','2014-03-18','08:45:00',3.07),('7643','2014-03-18','08:50:00',3.32),('7643','2014-03-18','08:55:00',3.77),('7643','2014-03-18','09:00:00',4.19),('7643','2014-03-18','09:05:00',4.71),('7643','2014-03-18','09:10:00',5.5),('7643','2014-03-18','09:15:00',5.77),('7643','2014-03-18','09:20:00',6.56),('7643','2014-03-18','09:25:00',8.65),('7643','2014-03-18','09:30:00',6.76),('7643','2014-03-18','09:35:00',10.58),('7643','2014-03-18','09:40:00',9.66),('7643','2014-03-18','09:45:00',12.82),('7643','2014-03-18','09:50:00',14.78),('7643','2014-03-18','09:55:00',9.66),('7643','2014-03-18','10:00:00',6.12),('7643','2014-03-18','10:05:00',4.62),('7643','2014-03-18','10:10:00',3.82),('7643','2014-03-18','10:15:00',3.25),('7643','2014-03-18','10:20:00',3.59),('7643','2014-03-18','10:25:00',3.7),('7643','2014-03-18','10:30:00',4.5),('7643','2014-03-18','10:35:00',6.4),('7643','2014-03-18','10:40:00',12.34),('7643','2014-03-18','10:45:00',12.96),('7643','2014-03-18','10:50:00',10.38),('7643','2014-03-18','10:55:00',5.21),('7643','2014-03-18','11:00:00',4.62),('7643','2014-03-18','11:05:00',10.19),('7643','2014-03-18','11:10:00',15.24),('7643','2014-03-18','11:15:00',7.81),('7643','2014-03-18','11:20:00',7.36),('7643','2014-03-18','11:25:00',8.41),('7643','2014-03-18','11:30:00',8.45),('7643','2014-03-18','11:35:00',11.39),('7643','2014-03-18','11:40:00',8.31),('7643','2014-03-18','11:45:00',8.36),('7643','2014-03-18','11:50:00',6.97),('7643','2014-03-18','11:55:00',6.53),('7643','2014-03-18','12:00:00',10.66),('7643','2014-03-18','12:05:00',10.93),('7643','2014-03-18','12:10:00',16.62),('7643','2014-03-18','12:15:00',16.79),('7643','2014-03-18','12:20:00',13.64),('7643','2014-03-18','12:25:00',15.91),('7643','2014-03-18','12:30:00',16.37),('7643','2014-03-18','12:35:00',15.82),('7643','2014-03-18','12:40:00',15.71),('7643','2014-03-18','12:45:00',15.37),('7643','2014-03-18','12:50:00',13.09),('7643','2014-03-18','12:55:00',9.25),('7643','2014-03-18','13:00:00',15.27),('7643','2014-03-18','13:05:00',14.34),('7643','2014-03-18','13:10:00',15.01),('7643','2014-03-18','13:15:00',14.95),('7643','2014-03-18','13:20:00',7.47),('7643','2014-03-18','13:25:00',10.08),('7643','2014-03-18','13:30:00',14.6),('7643','2014-03-18','13:35:00',14.61),('7643','2014-03-18','13:40:00',14.38),('7643','2014-03-18','13:45:00',14.38),('7643','2014-03-18','13:50:00',13.91),('7643','2014-03-18','13:55:00',13.57),('7643','2014-03-18','14:00:00',13.46),('7643','2014-03-18','14:05:00',13.27),('7643','2014-03-18','14:10:00',13.27),('7643','2014-03-18','14:15:00',12.89),('7643','2014-03-18','14:20:00',12.74),('7643','2014-03-18','14:25:00',12.65),('7643','2014-03-18','14:30:00',12.2),('7643','2014-03-18','14:35:00',12.24),('7643','2014-03-18','14:40:00',12.09),('7643','2014-03-18','14:45:00',11.86),('7643','2014-03-18','14:50:00',11.48),('7643','2014-03-18','14:55:00',11.22),('7643','2014-03-18','15:00:00',11.01),('7643','2014-03-18','15:05:00',10.63),('7643','2014-03-18','15:10:00',10.38),('7643','2014-03-18','15:15:00',10.3),('7643','2014-03-18','15:20:00',9.91),('7643','2014-03-18','15:25:00',9.76),('7643','2014-03-18','15:30:00',9.35),('7643','2014-03-18','15:35:00',8.86),('7643','2014-03-18','15:40:00',8.77),('7643','2014-03-18','15:45:00',8.53),('7643','2014-03-18','15:50:00',8.11),('7643','2014-03-18','15:55:00',7.95),('7643','2014-03-18','16:00:00',7.48),('7643','2014-03-18','16:05:00',7.18),('7643','2014-03-18','16:10:00',6.92),('7643','2014-03-18','16:15:00',6.54),('7643','2014-03-18','16:20:00',6.13),('7643','2014-03-18','16:25:00',5.51),('7643','2014-03-18','16:30:00',5.18),('7643','2014-03-18','16:35:00',4.65),('7643','2014-03-18','16:40:00',4.29),('7643','2014-03-18','16:45:00',4.07),('7643','2014-03-18','16:50:00',3.4),('7643','2014-03-18','16:55:00',3.11),('7643','2014-03-18','17:00:00',2.43),('7643','2014-03-18','17:05:00',2.02),('7643','2014-03-18','17:10:00',1.79),('7643','2014-03-18','17:15:00',1.86),('7643','2014-03-18','17:20:00',1.67);
INSERT INTO `solarlogmod` VALUES ('7643','2014-03-18','17:25:00',1.5),('7643','2014-03-18','17:30:00',1.15),('7643','2013-01-10','09:00:00',1.38),('7643','2013-01-10','09:05:00',1.41),('7643','2013-01-10','09:10:00',1.57),('7643','2013-01-10','09:15:00',1.54),('7643','2013-01-10','09:20:00',1.78),('7643','2013-01-10','09:25:00',1.72),('7643','2013-01-10','09:30:00',1.81),('7643','2013-01-10','09:35:00',2),('7643','2013-01-10','09:40:00',2.06),('7643','2013-01-10','09:45:00',2.86),('7643','2013-01-10','09:50:00',3.71),('7643','2013-01-10','09:55:00',2.77),('7643','2013-01-10','10:00:00',4.54),('7643','2013-01-10','10:05:00',4.55),('7643','2013-01-10','10:10:00',5.28),('7643','2013-01-10','10:15:00',5.49),('7643','2013-01-10','10:20:00',4.98),('7643','2013-01-10','10:25:00',8.61),('7643','2013-01-10','10:30:00',8.71),('7643','2013-01-10','10:35:00',8.84),('7643','2013-01-10','10:40:00',8.99),('7643','2013-01-10','10:45:00',9.1),('7643','2013-01-10','10:50:00',9.27),('7643','2013-01-10','10:55:00',9.38),('7643','2013-01-10','11:00:00',9.5),('7643','2013-01-10','11:05:00',9.52),('7643','2013-01-10','11:10:00',9.46),('7643','2013-01-10','11:15:00',9.48),('7643','2013-01-10','11:20:00',9.29),('7643','2013-01-10','11:25:00',6.86),('7643','2013-01-10','11:30:00',3.65),('7643','2013-01-10','11:35:00',6.4),('7643','2013-01-10','11:40:00',3.81),('7643','2013-01-10','11:45:00',5.63),('7643','2013-01-10','11:50:00',5.63),('7643','2013-01-10','11:55:00',4.32),('7643','2013-01-10','12:00:00',3.5),('7643','2013-01-10','12:05:00',2.71),('7643','2013-01-10','12:10:00',2.07),('7643','2013-01-10','12:15:00',2.56),('7643','2013-01-10','12:20:00',2.87),('7643','2013-01-10','12:25:00',2.1),('7643','2013-01-10','12:30:00',1.34),('7643','2013-01-10','12:40:00',1.17),('7643','2013-01-10','12:45:00',1.67),('7643','2013-01-10','12:50:00',2.91),('7643','2013-01-10','12:55:00',8.54),('7643','2013-01-10','13:00:00',4.99),('7643','2013-01-10','13:05:00',4.37),('7643','2013-01-10','13:10:00',7.1),('7643','2013-01-10','13:15:00',5.01),('7643','2013-01-10','13:20:00',3.3),('7643','2013-01-10','13:25:00',2.3),('7643','2013-01-10','13:30:00',4.26),('7643','2013-01-10','13:35:00',9.89),('7643','2013-01-10','13:40:00',8.66),('7643','2013-01-10','13:45:00',4.81),('7643','2013-01-10','13:50:00',2.55),('7643','2013-01-10','13:55:00',1.58),('7643','2013-01-10','14:00:00',1.55),('7643','2013-01-10','14:05:00',1.32),('7643','2013-01-10','14:20:00',4.47),('7643','2013-01-10','14:25:00',4.75),('7643','2013-01-10','14:30:00',3.14),('7643','2013-01-10','14:35:00',2.91),('7643','2013-01-10','14:40:00',2.55),('7643','2013-01-10','14:45:00',4.48),('7643','2013-01-10','14:50:00',6.53),('7643','2013-01-10','14:55:00',3.39),('7643','2013-01-10','15:00:00',5.71),('7643','2013-01-10','15:05:00',5.79),('7643','2013-01-10','15:10:00',2.67),('7643','2013-01-10','15:20:00',1.23),('7643','2013-01-10','15:40:00',1.48),('7643','2013-01-10','15:45:00',2.03),('7643','2013-01-10','15:50:00',1.31),('7643','2013-01-09','09:55:00',1.43),('7643','2013-01-09','10:00:00',1.89),('7643','2013-01-09','10:05:00',2.02),('7643','2013-01-09','10:10:00',1.85),('7643','2013-01-09','10:15:00',1.47),('7643','2013-01-09','10:20:00',1.59),('7643','2013-01-09','10:25:00',1.99),('7643','2013-01-09','10:30:00',1.83),('7643','2013-01-09','10:35:00',1.56),('7643','2013-01-09','10:40:00',1.17),('7643','2013-01-09','11:05:00',1.15),('7643','2013-01-09','11:15:00',1.1),('7643','2013-01-09','11:20:00',2.38),('7643','2013-01-09','11:25:00',2.97),('7643','2013-01-09','11:30:00',3.67),('7643','2013-01-09','11:35:00',2.9),('7643','2013-01-09','11:40:00',1.84),('7643','2013-01-09','11:45:00',2.02),('7643','2013-01-09','11:50:00',3.12),('7643','2013-01-09','11:55:00',4.56),('7643','2013-01-09','12:00:00',4.73),('7643','2013-01-09','12:05:00',4.61),('7643','2013-01-09','12:10:00',4.15),('7643','2013-01-09','12:15:00',3.25),('7643','2013-01-09','12:20:00',2.16),('7643','2013-01-09','12:25:00',1.76),('7643','2013-01-09','12:30:00',1.7),('7643','2013-01-09','12:35:00',1.67),('7643','2013-01-09','12:40:00',1.74),('7643','2013-01-09','12:45:00',1.9),('7643','2013-01-09','12:50:00',1.74),('7643','2013-01-09','12:55:00',1.48),('7643','2013-01-09','13:00:00',1.11),('7643','2013-01-09','13:05:00',1.08),('7643','2013-01-09','13:10:00',1.49),('7643','2013-01-09','13:15:00',2.04),('7643','2013-01-09','13:20:00',1.93),('7643','2013-01-09','13:25:00',1.56),('7643','2013-01-09','13:30:00',1.72),('7643','2013-01-09','13:35:00',1.8),('7643','2013-01-09','13:40:00',1.95),('7643','2013-01-09','13:45:00',2.21),('7643','2013-01-09','13:50:00',2.12),('7643','2013-01-09','13:55:00',2.27),('7643','2013-01-09','14:00:00',2.51),('7643','2013-01-09','14:05:00',2.01),('7643','2013-01-09','14:10:00',1.53),('7643','2013-01-09','14:15:00',1.13),('7643','2013-01-09','14:30:00',1.47),('7643','2013-01-09','14:35:00',1.72),('7643','2013-01-09','15:10:00',1.12),('7643','2013-01-08','09:10:00',1.04),('7643','2013-01-08','09:15:00',1.13),('7643','2013-01-08','09:20:00',1.18),('7643','2013-01-08','09:25:00',1.3),('7643','2013-01-08','09:30:00',1.57),('7643','2013-01-08','09:35:00',2.83),('7643','2013-01-08','09:40:00',3.8),('7643','2013-01-08','09:45:00',2.45),('7643','2013-01-08','09:50:00',2.26),('7643','2013-01-08','09:55:00',2.13),('7643','2013-01-08','10:00:00',2.1),('7643','2013-01-08','10:05:00',2.2),('7643','2013-01-08','10:10:00',2.3),('7643','2013-01-08','10:15:00',2.54),('7643','2013-01-08','10:20:00',2.87),('7643','2013-01-08','10:25:00',2.76),('7643','2013-01-08','10:30:00',3.28),('7643','2013-01-08','10:35:00',3.34),('7643','2013-01-08','10:40:00',3.46),('7643','2013-01-08','10:45:00',4.67),('7643','2013-01-08','10:50:00',4.04),('7643','2013-01-08','10:55:00',6.7),('7643','2013-01-08','11:00:00',3.7),('7643','2013-01-08','11:05:00',4.25),('7643','2013-01-08','11:10:00',4.66),('7643','2013-01-08','11:15:00',10.73),('7643','2013-01-08','11:20:00',7.71),('7643','2013-01-08','11:25:00',4.5),('7643','2013-01-08','11:30:00',5.23),('7643','2013-01-08','11:35:00',5.16),('7643','2013-01-08','11:40:00',4.45),('7643','2013-01-08','11:45:00',4.07),('7643','2013-01-08','11:50:00',5.22),('7643','2013-01-08','11:55:00',6.27),('7643','2013-01-08','12:00:00',5.18),('7643','2013-01-08','12:05:00',4.66),('7643','2013-01-08','12:10:00',4.23),('7643','2013-01-08','12:15:00',4.12),('7643','2013-01-08','12:20:00',4.1),('7643','2013-01-08','12:25:00',3.83),('7643','2013-01-08','12:30:00',3.53),('7643','2013-01-08','12:35:00',3.82),('7643','2013-01-08','12:40:00',3.67),('7643','2013-01-08','12:45:00',3.51),('7643','2013-01-08','12:50:00',3.65),('7643','2013-01-08','12:55:00',4.18),('7643','2013-01-08','13:00:00',5.23),('7643','2013-01-08','13:05:00',6.71),('7643','2013-01-08','13:10:00',7.44),('7643','2013-01-08','13:15:00',4.5),('7643','2013-01-08','13:20:00',4.2),('7643','2013-01-08','13:25:00',3.57),('7643','2013-01-08','13:30:00',3.2),('7643','2013-01-08','13:35:00',3.13),('7643','2013-01-08','13:40:00',3.18),('7643','2013-01-08','13:45:00',3.19),('7643','2013-01-08','13:50:00',2.79),('7643','2013-01-08','13:55:00',2.64),('7643','2013-01-08','14:00:00',2.75),('7643','2013-01-08','14:05:00',2.55),('7643','2013-01-08','14:10:00',2.41),('7643','2013-01-08','14:15:00',2.21),('7643','2013-01-08','14:20:00',1.99),('7643','2013-01-08','14:25:00',1.82),('7643','2013-01-08','14:30:00',1.66),('7643','2013-01-08','14:35:00',1.72),('7643','2013-01-08','14:40:00',1.71),('7643','2013-01-08','14:45:00',1.4),('7643','2013-01-08','14:50:00',1.22),('7643','2013-01-08','14:55:00',1.16),('7643','2013-01-08','15:00:00',1.11),('7643','2013-01-08','15:05:00',1.06),('7643','2013-01-08','15:45:00',1.3),('7643','2013-01-08','15:50:00',1.26),('7643','2013-01-07','08:20:00',1.01),('7643','2013-01-07','08:25:00',1.79),('7643','2013-01-07','08:30:00',2.79),('7643','2013-01-07','08:35:00',4.27),('7643','2013-01-07','08:40:00',4.55),('7643','2013-01-07','08:45:00',4.91),('7643','2013-01-07','08:50:00',5.24),('7643','2013-01-07','08:55:00',5.79),('7643','2013-01-07','09:00:00',6.14),('7643','2013-01-07','09:05:00',6.06),('7643','2013-01-07','09:10:00',3.86),('7643','2013-01-07','09:15:00',4.92),('7643','2013-01-07','09:20:00',6.07),('7643','2013-01-07','09:25:00',6.41),('7643','2013-01-07','09:30:00',5.82),('7643','2013-01-07','09:35:00',4.55),('7643','2013-01-07','09:40:00',7),('7643','2013-01-07','09:45:00',7.97),('7643','2013-01-07','09:50:00',8.39),('7643','2013-01-07','09:55:00',8.24),('7643','2013-01-07','10:00:00',7.62),('7643','2013-01-07','10:05:00',7.37),('7643','2013-01-07','10:10:00',7.48),('7643','2013-01-07','10:15:00',7.81),('7643','2013-01-07','10:20:00',7.26),('7643','2013-01-07','10:25:00',7.96),('7643','2013-01-07','10:30:00',7.91),('7643','2013-01-07','10:35:00',8.6),('7643','2013-01-07','10:40:00',9.21),('7643','2013-01-07','10:45:00',9.11),('7643','2013-01-07','10:50:00',9.3),('7643','2013-01-07','10:55:00',9.44),('7643','2013-01-07','11:00:00',9.28),('7643','2013-01-07','11:05:00',9.66),('7643','2013-01-07','11:10:00',9.74),('7643','2013-01-07','11:15:00',9.77),('7643','2013-01-07','11:20:00',9.83),('7643','2013-01-07','11:25:00',9.93),('7643','2013-01-07','11:30:00',10.05),('7643','2013-01-07','11:35:00',10.08),('7643','2013-01-07','11:40:00',9.84),('7643','2013-01-07','11:45:00',11.77),('7643','2013-01-07','11:50:00',9.34),('7643','2013-01-07','11:55:00',6.87),('7643','2013-01-07','12:00:00',6.06),('7643','2013-01-07','12:05:00',5.78),('7643','2013-01-07','12:10:00',6.08),('7643','2013-01-07','12:15:00',5.61),('7643','2013-01-07','12:20:00',4.95),('7643','2013-01-07','12:25:00',4.84),('7643','2013-01-07','12:30:00',4.67),('7643','2013-01-07','12:35:00',4.56),('7643','2013-01-07','12:40:00',5.73),('7643','2013-01-07','12:45:00',7.16),('7643','2013-01-07','12:50:00',9.16),('7643','2013-01-07','12:55:00',7.41),('7643','2013-01-07','13:00:00',3.31),('7643','2013-01-07','13:05:00',3.06),('7643','2013-01-07','13:10:00',3.16),('7643','2013-01-07','13:15:00',3.58),('7643','2013-01-07','13:20:00',4.98),('7643','2013-01-07','13:25:00',3.64),('7643','2013-01-07','13:30:00',3.09),('7643','2013-01-07','13:35:00',2.97),('7643','2013-01-07','13:40:00',3.53),('7643','2013-01-07','13:45:00',3.8),('7643','2013-01-07','13:50:00',5.18),('7643','2013-01-07','13:55:00',6.39),('7643','2013-01-07','14:00:00',5.06),('7643','2013-01-07','14:05:00',5.03),('7643','2013-01-07','14:10:00',3.1),('7643','2013-01-07','14:15:00',2.98),('7643','2013-01-07','14:20:00',2.78),('7643','2013-01-07','14:25:00',3),('7643','2013-01-07','14:30:00',3.52),('7643','2013-01-07','14:35:00',3.24),('7643','2013-01-07','14:40:00',3.75),('7643','2013-01-07','14:45:00',2.76),('7643','2013-01-07','14:50:00',2.18),('7643','2013-01-07','14:55:00',2.16),('7643','2013-01-07','15:00:00',1.92),('7643','2013-01-07','15:05:00',2.22),('7643','2013-01-07','15:10:00',2.83),('7643','2013-01-07','15:15:00',3.38),('7643','2013-01-07','15:20:00',3.07),('7643','2013-01-07','15:25:00',2.08),('7643','2013-01-07','15:30:00',2.04),('7643','2013-01-07','15:35:00',2.35),('7643','2013-01-07','15:40:00',2.33),('7643','2013-01-07','15:45:00',1.99),('7643','2013-01-07','15:50:00',1.39),('7643','2013-01-07','15:55:00',1.02),('7643','2013-01-06','08:10:00',1.23),('7643','2013-01-06','08:15:00',1.5),('7643','2013-01-06','08:20:00',1.77),('7643','2013-01-06','08:25:00',2.04),('7643','2013-01-06','08:30:00',2.35),('7643','2013-01-06','08:35:00',2.64),('7643','2013-01-06','08:40:00',2.97),('7643','2013-01-06','08:45:00',3.28),('7643','2013-01-06','08:50:00',3.63),('7643','2013-01-06','08:55:00',4.02),('7643','2013-01-06','09:00:00',4.17),('7643','2013-01-06','09:05:00',3.81),('7643','2013-01-06','09:10:00',3.95),('7643','2013-01-06','09:15:00',3.21),('7643','2013-01-06','09:20:00',5.01),('7643','2013-01-06','09:25:00',5.68),('7643','2013-01-06','09:30:00',5.89),('7643','2013-01-06','09:35:00',6.24),('7643','2013-01-06','09:40:00',6.49),('7643','2013-01-06','09:45:00',6.82),('7643','2013-01-06','09:50:00',7.1),('7643','2013-01-06','09:55:00',7.28),('7643','2013-01-06','10:00:00',7.45),('7643','2013-01-06','10:05:00',7.89),('7643','2013-01-06','10:10:00',8.18),('7643','2013-01-06','10:15:00',8.36),('7643','2013-01-06','10:20:00',8.4),('7643','2013-01-06','10:25:00',8.46),('7643','2013-01-06','10:30:00',8.77),('7643','2013-01-06','10:35:00',8.89),('7643','2013-01-06','10:40:00',9.04),('7643','2013-01-06','10:45:00',9.05),('7643','2013-01-06','10:50:00',9.09),('7643','2013-01-06','10:55:00',9.1),('7643','2013-01-06','11:00:00',9.06),('7643','2013-01-06','11:05:00',9.17),('7643','2013-01-06','11:10:00',9.38),('7643','2013-01-06','11:15:00',9.63),('7643','2013-01-06','11:20:00',9.69),('7643','2013-01-06','11:25:00',9.86),('7643','2013-01-06','11:30:00',9.94),('7643','2013-01-06','11:35:00',9.92),('7643','2013-01-06','11:40:00',9.94),('7643','2013-01-06','11:45:00',10.03),('7643','2013-01-06','11:50:00',10.05),('7643','2013-01-06','11:55:00',10),('7643','2013-01-06','12:00:00',10.08),('7643','2013-01-06','12:05:00',10.22),('7643','2013-01-06','12:10:00',10.2),('7643','2013-01-06','12:15:00',10.13),('7643','2013-01-06','12:20:00',10.13),('7643','2013-01-06','12:25:00',10.14),('7643','2013-01-06','12:30:00',10.11),('7643','2013-01-06','12:35:00',10.02),('7643','2013-01-06','12:40:00',9.91),('7643','2013-01-06','12:45:00',9.84),('7643','2013-01-06','12:50:00',9.85),('7643','2013-01-06','12:55:00',9.73),('7643','2013-01-06','13:00:00',9.63),('7643','2013-01-06','13:05:00',9.53),('7643','2013-01-06','13:10:00',9.38),('7643','2013-01-06','13:15:00',9.19),('7643','2013-01-06','13:20:00',9.06),('7643','2013-01-06','13:25:00',9.01),('7643','2013-01-06','13:30:00',8.95),('7643','2013-01-06','13:35:00',8.8),('7643','2013-01-06','13:40:00',8.61),('7643','2013-01-06','13:45:00',8.46),('7643','2013-01-06','13:50:00',8.26),('7643','2013-01-06','13:55:00',8.12),('7643','2013-01-06','14:00:00',7.99),('7643','2013-01-06','14:05:00',7.79),('7643','2013-01-06','14:10:00',7.63),('7643','2013-01-06','14:15:00',7.41),('7643','2013-01-06','14:20:00',7.33),('7643','2013-01-06','14:25:00',7.07),('7643','2013-01-06','14:30:00',6.74),('7643','2013-01-06','14:35:00',6.59),('7643','2013-01-06','14:40:00',6.38),('7643','2013-01-06','14:45:00',6.01),('7643','2013-01-06','14:50:00',5.84),('7643','2013-01-06','14:55:00',5.55),('7643','2013-01-06','15:00:00',5.17),('7643','2013-01-06','15:05:00',5.02),('7643','2013-01-06','15:10:00',4.62),('7643','2013-01-06','15:15:00',4.45),('7643','2013-01-06','15:20:00',4.41),('7643','2013-01-06','15:25:00',4.22),('7643','2013-01-06','15:30:00',3.98),('7643','2013-01-06','15:35:00',3.71),('7643','2013-01-06','15:40:00',3.39),('7643','2013-01-06','15:45:00',3.07),('7643','2013-01-06','15:50:00',2.76),('7643','2013-01-06','15:55:00',2.44),('7643','2013-01-06','16:00:00',2.14),('7643','2013-01-06','16:05:00',1.84),('7643','2013-01-06','16:10:00',1.55),('7643','2013-01-06','16:15:00',1.28),('7643','2013-01-06','16:20:00',1.01),('7643','2013-01-05','08:05:00',1.24),('7643','2013-01-05','08:10:00',1.52),('7643','2013-01-05','08:15:00',1.79),('7643','2013-01-05','08:20:00',2.07),('7643','2013-01-05','08:25:00',2.37),('7643','2013-01-05','08:30:00',2.69),('7643','2013-01-05','08:35:00',3),('7643','2013-01-05','08:40:00',3.31),('7643','2013-01-05','08:45:00',3.64),('7643','2013-01-05','08:50:00',3.96),('7643','2013-01-05','08:55:00',4.28),('7643','2013-01-05','09:00:00',4.6),('7643','2013-01-05','09:05:00',4.9),('7643','2013-01-05','09:10:00',5.17),('7643','2013-01-05','09:15:00',5.46),('7643','2013-01-05','09:20:00',5.73),('7643','2013-01-05','09:25:00',5.98),('7643','2013-01-05','09:30:00',6.25),('7643','2013-01-05','09:35:00',6.48),('7643','2013-01-05','09:40:00',6.75),('7643','2013-01-05','09:45:00',6.95),('7643','2013-01-05','09:50:00',7.23),('7643','2013-01-05','09:55:00',7.47),('7643','2013-01-05','10:00:00',7.77),('7643','2013-01-05','10:05:00',7.98),('7643','2013-01-05','10:10:00',8.19),('7643','2013-01-05','10:15:00',8.37),('7643','2013-01-05','10:20:00',8.47),('7643','2013-01-05','10:25:00',8.71),('7643','2013-01-05','10:30:00',8.82),('7643','2013-01-05','10:35:00',8.98),('7643','2013-01-05','10:40:00',9.19),('7643','2013-01-05','10:45:00',9.33),('7643','2013-01-05','10:50:00',9.39),('7643','2013-01-05','10:55:00',9.57),('7643','2013-01-05','11:00:00',9.64),('7643','2013-01-05','11:05:00',9.69),('7643','2013-01-05','11:10:00',9.78),('7643','2013-01-05','11:15:00',9.84),('7643','2013-01-05','11:20:00',9.93),('7643','2013-01-05','11:25:00',9.98),('7643','2013-01-05','11:30:00',10.04),('7643','2013-01-05','11:35:00',10.09),('7643','2013-01-05','11:40:00',10.09),('7643','2013-01-05','11:45:00',10.1),('7643','2013-01-05','11:50:00',10.16),('7643','2013-01-05','11:55:00',10.22),('7643','2013-01-05','12:00:00',10.24),('7643','2013-01-05','12:05:00',10.25),('7643','2013-01-05','12:10:00',10.22),('7643','2013-01-05','12:15:00',10.1),('7643','2013-01-05','12:20:00',10.01),('7643','2013-01-05','12:25:00',9.91),('7643','2013-01-05','12:30:00',9.87),('7643','2013-01-05','12:35:00',9.75),('7643','2013-01-05','12:40:00',9.58),('7643','2013-01-05','12:45:00',9.74),('7643','2013-01-05','12:50:00',9.82),('7643','2013-01-05','12:55:00',9.85),('7643','2013-01-05','13:00:00',9.75),('7643','2013-01-05','13:05:00',9.69),('7643','2013-01-05','13:10:00',9.61),('7643','2013-01-05','13:15:00',9.52),('7643','2013-01-05','13:20:00',9.39),('7643','2013-01-05','13:25:00',9.28),('7643','2013-01-05','13:30:00',9.25),('7643','2013-01-05','13:35:00',9.11),('7643','2013-01-05','13:40:00',8.96),('7643','2013-01-05','13:45:00',8.83),('7643','2013-01-05','13:50:00',8.57),('7643','2013-01-05','13:55:00',8.33),('7643','2013-01-05','14:00:00',8.29),('7643','2013-01-05','14:05:00',8.29),('7643','2013-01-05','14:10:00',7.5),('7643','2013-01-05','14:15:00',6.43),('7643','2013-01-05','14:20:00',6.71),('7643','2013-01-05','14:25:00',6.63),('7643','2013-01-05','14:30:00',6.8),('7643','2013-01-05','14:35:00',6.52),('7643','2013-01-05','14:40:00',6.23),('7643','2013-01-05','14:45:00',5.96),('7643','2013-01-05','14:50:00',5.7),('7643','2013-01-05','14:55:00',5.4),('7643','2013-01-05','15:00:00',5.1),('7643','2013-01-05','15:05:00',4.76),('7643','2013-01-05','15:10:00',4.43),('7643','2013-01-05','15:15:00',4.31),('7643','2013-01-05','15:20:00',4.04),('7643','2013-01-05','15:25:00',3.76),('7643','2013-01-05','15:30:00',3.48),('7643','2013-01-05','15:35:00',3.18),('7643','2013-01-05','15:40:00',2.87),('7643','2013-01-05','15:45:00',2.63),('7643','2013-01-05','15:50:00',2.38),('7643','2013-01-05','15:55:00',2.12),('7643','2013-01-05','16:00:00',1.9),('7643','2013-01-05','16:05:00',1.61),('7643','2013-01-05','16:10:00',1.36),('7643','2013-01-05','16:15:00',1.09),('7643','2013-01-04','08:35:00',1.52),('7643','2013-01-04','08:40:00',1.78),('7643','2013-01-04','08:45:00',2.22),('7643','2013-01-04','08:50:00',1.99),('7643','2013-01-04','08:55:00',1.93),('7643','2013-01-04','09:00:00',2.02),('7643','2013-01-04','09:05:00',2.29),('7643','2013-01-04','09:10:00',2.4),('7643','2013-01-04','09:15:00',2.33),('7643','2013-01-04','09:20:00',2.22),('7643','2013-01-04','09:25:00',2.42),('7643','2013-01-04','09:30:00',2.41),('7643','2013-01-04','09:35:00',2.67),('7643','2013-01-04','09:40:00',2.75),('7643','2013-01-04','09:45:00',2.7),('7643','2013-01-04','09:50:00',2.64),('7643','2013-01-04','09:55:00',2.78),('7643','2013-01-04','10:00:00',3.1),('7643','2013-01-04','10:05:00',3.7),('7643','2013-01-04','10:10:00',4.26),('7643','2013-01-04','10:15:00',4.54),('7643','2013-01-04','10:20:00',4.17),('7643','2013-01-04','10:25:00',3.52),('7643','2013-01-04','10:30:00',3.64),('7643','2013-01-04','10:35:00',4.16),('7643','2013-01-04','10:40:00',4.49),('7643','2013-01-04','10:45:00',4.37),('7643','2013-01-04','10:50:00',5.09),('7643','2013-01-04','10:55:00',8.43),('7643','2013-01-04','11:00:00',7.27),('7643','2013-01-04','11:05:00',8.12),('7643','2013-01-04','11:10:00',8.28),('7643','2013-01-04','11:15:00',6.74),('7643','2013-01-04','11:20:00',8.96),('7643','2013-01-04','11:25:00',9.47),('7643','2013-01-04','11:30:00',9.6),('7643','2013-01-04','11:35:00',8.95),('7643','2013-01-04','11:40:00',8.08),('7643','2013-01-04','11:45:00',8.21),('7643','2013-01-04','11:50:00',7.11),('7643','2013-01-04','11:55:00',6.44),('7643','2013-01-04','12:00:00',5.93),('7643','2013-01-04','12:05:00',5.82),('7643','2013-01-04','12:10:00',5.68),('7643','2013-01-04','12:15:00',5.86),('7643','2013-01-04','12:20:00',5.25),('7643','2013-01-04','12:25:00',4.45),('7643','2013-01-04','12:30:00',4.58),('7643','2013-01-04','12:35:00',6.29),('7643','2013-01-04','12:40:00',7.65),('7643','2013-01-04','12:45:00',8.89),('7643','2013-01-04','12:50:00',5.56),('7643','2013-01-04','12:55:00',4.6),('7643','2013-01-04','13:00:00',4.9),('7643','2013-01-04','13:05:00',4.48),('7643','2013-01-04','13:10:00',4.34),('7643','2013-01-04','13:15:00',4),('7643','2013-01-04','13:20:00',4.01),('7643','2013-01-04','13:25:00',3.94),('7643','2013-01-04','13:30:00',6.98),('7643','2013-01-04','13:35:00',6.32),('7643','2013-01-04','13:40:00',4.4),('7643','2013-01-04','13:45:00',3.57),('7643','2013-01-04','13:50:00',3.91),('7643','2013-01-04','13:55:00',4.41),('7643','2013-01-04','14:00:00',4.16),('7643','2013-01-04','14:05:00',6.17),('7643','2013-01-04','14:10:00',5.81),('7643','2013-01-04','14:15:00',4.43),('7643','2013-01-04','14:20:00',4.07),('7643','2013-01-04','14:25:00',2.76),('7643','2013-01-04','14:30:00',4.48),('7643','2013-01-04','14:35:00',4.43),('7643','2013-01-04','14:40:00',4.86),('7643','2013-01-04','14:45:00',5.01),('7643','2013-01-04','14:50:00',3.47),('7643','2013-01-04','14:55:00',2.41),('7643','2013-01-04','15:00:00',4.15),('7643','2013-01-04','15:05:00',3.54),('7643','2013-01-04','15:10:00',1.52),('7643','2013-01-04','15:15:00',1.27),('7643','2013-01-04','15:40:00',1.77),('7643','2013-01-04','15:45:00',1.56),('7643','2013-01-04','15:50:00',1.26),('7643','2013-01-04','15:55:00',1.14),('7643','2013-01-03','08:10:00',1.35),('7643','2013-01-03','08:15:00',1.62),('7643','2013-01-03','08:20:00',1.82),('7643','2013-01-03','08:25:00',1.6),('7643','2013-01-03','08:30:00',1.26),('7643','2013-01-03','08:35:00',2.15),('7643','2013-01-03','08:40:00',2.61),('7643','2013-01-03','08:45:00',3.73),('7643','2013-01-03','08:50:00',4.06),('7643','2013-01-03','08:55:00',4.01),('7643','2013-01-03','09:00:00',4.17),('7643','2013-01-03','09:05:00',4.51),('7643','2013-01-03','09:10:00',4.9),('7643','2013-01-03','09:15:00',3.86),('7643','2013-01-03','09:20:00',5.02),('7643','2013-01-03','09:25:00',4.7),('7643','2013-01-03','09:30:00',4.64),('7643','2013-01-03','09:35:00',4.38),('7643','2013-01-03','09:40:00',4.56),('7643','2013-01-03','09:45:00',4.78),('7643','2013-01-03','09:50:00',5.12),('7643','2013-01-03','09:55:00',6.56),('7643','2013-01-03','10:00:00',8.1),('7643','2013-01-03','10:05:00',8.33),('7643','2013-01-03','10:10:00',7.1),('7643','2013-01-03','10:15:00',8.38),('7643','2013-01-03','10:20:00',7.21),('7643','2013-01-03','10:25:00',8.34),('7643','2013-01-03','10:30:00',8.96),('7643','2013-01-03','10:35:00',9.11),('7643','2013-01-03','10:40:00',9.34),('7643','2013-01-03','10:45:00',9.86),('7643','2013-01-03','10:50:00',10.41),('7643','2013-01-03','10:55:00',10.78),('7643','2013-01-03','11:00:00',9.42),('7643','2013-01-03','11:05:00',5.85),('7643','2013-01-03','11:10:00',3.54),('7643','2013-01-03','11:15:00',3.71),('7643','2013-01-03','11:20:00',4.57),('7643','2013-01-03','11:25:00',3.56),('7643','2013-01-03','11:30:00',3.51),('7643','2013-01-03','11:35:00',5.34),('7643','2013-01-03','11:40:00',4.2),('7643','2013-01-03','11:45:00',6.24),('7643','2013-01-03','11:50:00',9.82),('7643','2013-01-03','11:55:00',11.5),('7643','2013-01-03','12:00:00',11.79),('7643','2013-01-03','12:05:00',10.16),('7643','2013-01-03','12:10:00',8.07),('7643','2013-01-03','12:15:00',5.37),('7643','2013-01-03','12:20:00',4.37),('7643','2013-01-03','12:25:00',5),('7643','2013-01-03','12:30:00',7.23),('7643','2013-01-03','12:35:00',6.78),('7643','2013-01-03','12:40:00',9.79),('7643','2013-01-03','12:45:00',10.29),('7643','2013-01-03','12:50:00',10.38),('7643','2013-01-03','12:55:00',10.29),('7643','2013-01-03','13:00:00',9.84),('7643','2013-01-03','13:05:00',9.47),('7643','2013-01-03','13:10:00',9.3),('7643','2013-01-03','13:15:00',8.06),('7643','2013-01-03','13:20:00',8.99),('7643','2013-01-03','13:25:00',8.67),('7643','2013-01-03','13:30:00',8.41),('7643','2013-01-03','13:35:00',8.4),('7643','2013-01-03','13:40:00',8.1),('7643','2013-01-03','13:45:00',8.05),('7643','2013-01-03','13:50:00',7.9),('7643','2013-01-03','13:55:00',7.75),('7643','2013-01-03','14:00:00',7.57),('7643','2013-01-03','14:05:00',7.42),('7643','2013-01-03','14:10:00',7.17),('7643','2013-01-03','14:15:00',6.97),('7643','2013-01-03','14:20:00',6.76),('7643','2013-01-03','14:25:00',6.59),('7643','2013-01-03','14:30:00',6.43),('7643','2013-01-03','14:35:00',6.25),('7643','2013-01-03','14:40:00',5.97),('7643','2013-01-03','14:45:00',5.61),('7643','2013-01-03','14:50:00',5.19),('7643','2013-01-03','14:55:00',5.04),('7643','2013-01-03','15:00:00',4.86),('7643','2013-01-03','15:05:00',4.43),('7643','2013-01-03','15:10:00',3.88),('7643','2013-01-03','15:15:00',3.93),('7643','2013-01-03','15:20:00',3.69),('7643','2013-01-03','15:25:00',3.49),('7643','2013-01-03','15:30:00',3.21),('7643','2013-01-03','15:35:00',2.98),('7643','2013-01-03','15:40:00',2.8),('7643','2013-01-03','15:45:00',2.57),('7643','2013-01-03','15:50:00',1.39),('7643','2013-01-03','16:00:00',1.21),('7643','2013-01-03','16:10:00',1.1),('7643','2013-01-02','08:05:00',1.03),('7643','2013-01-02','08:10:00',1.31),('7643','2013-01-02','08:15:00',1.62),('7643','2013-01-02','08:20:00',1.93),('7643','2013-01-02','08:25:00',2.1),('7643','2013-01-02','08:30:00',2.5),('7643','2013-01-02','08:35:00',2.75),('7643','2013-01-02','08:40:00',3.22),('7643','2013-01-02','08:45:00',3.52),('7643','2013-01-02','08:50:00',3.77),('7643','2013-01-02','08:55:00',4.08),('7643','2013-01-02','09:00:00',4.48),('7643','2013-01-02','09:05:00',4.83),('7643','2013-01-02','09:10:00',5.16),('7643','2013-01-02','09:15:00',5.49),('7643','2013-01-02','09:20:00',5.78),('7643','2013-01-02','09:25:00',6.06),('7643','2013-01-02','09:30:00',6.32),('7643','2013-01-02','09:35:00',6.59),('7643','2013-01-02','09:40:00',7.08),('7643','2013-01-02','09:45:00',7.64),('7643','2013-01-02','09:50:00',8.29),('7643','2013-01-02','09:55:00',8.87),('7643','2013-01-02','10:00:00',9.34),('7643','2013-01-02','10:05:00',9.13),('7643','2013-01-02','10:10:00',8.86),('7643','2013-01-02','10:15:00',9.36),('7643','2013-01-02','10:20:00',8.8),('7643','2013-01-02','10:25:00',9.69),('7643','2013-01-02','10:30:00',7.82),('7643','2013-01-02','10:35:00',7.53),('7643','2013-01-02','10:40:00',6.76),('7643','2013-01-02','10:45:00',6.33),('7643','2013-01-02','10:50:00',6.53),('7643','2013-01-02','10:55:00',5.92),('7643','2013-01-02','11:00:00',6.43),('7643','2013-01-02','11:05:00',6.22),('7643','2013-01-02','11:10:00',6.18),('7643','2013-01-02','11:15:00',5.64),('7643','2013-01-02','11:20:00',5.04),('7643','2013-01-02','11:25:00',4.73),('7643','2013-01-02','11:30:00',4.66),('7643','2013-01-02','11:35:00',5.6),('7643','2013-01-02','11:40:00',10.5),('7643','2013-01-02','11:45:00',10.78),('7643','2013-01-02','11:50:00',10.6),('7643','2013-01-02','11:55:00',10.45),('7643','2013-01-02','12:00:00',10.34),('7643','2013-01-02','12:05:00',10.28),('7643','2013-01-02','12:10:00',10.26),('7643','2013-01-02','12:15:00',10.23),('7643','2013-01-02','12:20:00',10.27),('7643','2013-01-02','12:25:00',10.24),('7643','2013-01-02','12:30:00',10.18),('7643','2013-01-02','12:35:00',10.15),('7643','2013-01-02','12:40:00',10.05),('7643','2013-01-02','12:45:00',9.97),('7643','2013-01-02','12:50:00',9.92),('7643','2013-01-02','12:55:00',9.82),('7643','2013-01-02','13:00:00',9.75),('7643','2013-01-02','13:05:00',9.65),('7643','2013-01-02','13:10:00',9.56),('7643','2013-01-02','13:15:00',9.39),('7643','2013-01-02','13:20:00',9.3),('7643','2013-01-02','13:25:00',9.19),('7643','2013-01-02','13:30:00',8.99),('7643','2013-01-02','13:35:00',8.89),('7643','2013-01-02','13:40:00',8.75),('7643','2013-01-02','13:45:00',8.57),('7643','2013-01-02','13:50:00',8.4),('7643','2013-01-02','13:55:00',8.24),('7643','2013-01-02','14:00:00',8.06),('7643','2013-01-02','14:05:00',7.87),('7643','2013-01-02','14:10:00',7.7),('7643','2013-01-02','14:15:00',7.53),('7643','2013-01-02','14:20:00',7.29),('7643','2013-01-02','14:25:00',7.06),('7643','2013-01-02','14:30:00',6.87),('7643','2013-01-02','14:35:00',6.63),('7643','2013-01-02','14:40:00',6.38),('7643','2013-01-02','14:45:00',6.14),('7643','2013-01-02','14:50:00',5.9),('7643','2013-01-02','14:55:00',5.63),('7643','2013-01-02','15:00:00',5.37),('7643','2013-01-02','15:05:00',5.01),('7643','2013-01-02','15:10:00',4.68),('7643','2013-01-02','15:15:00',4.37),('7643','2013-01-02','15:20:00',3.86),('7643','2013-01-02','15:25:00',3.75),('7643','2013-01-02','15:30:00',3.6),('7643','2013-01-02','15:35:00',3.31),('7643','2013-01-02','15:40:00',2.91),('7643','2013-01-02','15:45:00',2.78),('7643','2013-01-02','15:50:00',2.49),('7643','2013-01-02','15:55:00',2.2),('7643','2013-01-02','16:00:00',1.85),('7643','2013-01-02','16:05:00',1.59),('7643','2013-01-02','16:10:00',1.3),('7643','2013-01-01','09:30:00',1.26),('7643','2013-01-01','09:35:00',1.84),('7643','2013-01-01','09:40:00',2.17),('7643','2013-01-01','09:45:00',2.41),('7643','2013-01-01','09:50:00',2.16),('7643','2013-01-01','09:55:00',2.1),('7643','2013-01-01','10:00:00',2.35),('7643','2013-01-01','10:05:00',2.23),('7643','2013-01-01','10:10:00',1.88),('7643','2013-01-01','10:15:00',1.69),('7643','2013-01-01','10:20:00',1.51),('7643','2013-01-01','10:25:00',1.25),('7643','2013-01-01','10:40:00',1.04),('7643','2013-01-01','10:45:00',1.16),('7643','2013-01-01','10:50:00',1.37),('7643','2013-01-01','10:55:00',1.15),('7643','2013-01-01','11:00:00',1.12),('7643','2013-01-01','11:05:00',1.53),('7643','2013-01-01','11:10:00',2.01),('7643','2013-01-01','11:15:00',1.15),('7643','2013-01-01','12:30:00',1.36),('7643','2013-01-01','13:20:00',1),('7643','2013-01-01','13:25:00',1.05),('7643','2013-01-01','13:30:00',1.34),('7643','2013-01-01','13:35:00',1.04),('7643','2013-01-01','13:40:00',2.92),('7643','2013-01-01','13:45:00',3.23),('7643','2013-01-01','13:50:00',3.28),('7643','2013-01-01','13:55:00',2.68),('7643','2013-01-01','14:00:00',2.38),('7643','2013-01-01','14:05:00',1.56),('7643','2014-03-17','07:10:00',1.15),('7643','2014-03-17','07:15:00',1.55),('7643','2014-03-17','07:20:00',1.41),('7643','2014-03-17','07:25:00',1.56),('7643','2014-03-17','07:30:00',1.66),('7643','2014-03-17','07:35:00',1.83),('7643','2014-03-17','07:40:00',2.14),('7643','2014-03-17','07:45:00',2.61),('7643','2014-03-17','07:50:00',5.33),('7643','2014-03-17','07:55:00',5.82),('7643','2014-03-17','08:00:00',4),('7643','2014-03-17','08:05:00',3.14),('7643','2014-03-17','08:10:00',3.33),('7643','2014-03-17','08:15:00',3.78),('7643','2014-03-17','08:20:00',4.92),('7643','2014-03-17','08:25:00',3.73),('7643','2014-03-17','08:30:00',3.57),('7643','2014-03-17','08:35:00',3),('7643','2014-03-17','08:40:00',3.23),('7643','2014-03-17','08:45:00',3.32),('7643','2014-03-17','08:50:00',6.95),('7643','2014-03-17','08:55:00',9.78),('7643','2014-03-17','09:00:00',9.5),('7643','2014-03-17','09:05:00',5.22),('7643','2014-03-17','09:10:00',5.52),('7643','2014-03-17','09:15:00',10.16),('7643','2014-03-17','09:20:00',12.13),('7643','2014-03-17','09:25:00',9.82),('7643','2014-03-17','09:30:00',4.94),('7643','2014-03-17','09:35:00',5.04),('7643','2014-03-17','09:40:00',5.32),('7643','2014-03-17','09:45:00',6.06),('7643','2014-03-17','09:50:00',7.15),('7643','2014-03-17','09:55:00',9.08),('7643','2014-03-17','10:00:00',6.29),('7643','2014-03-17','10:05:00',11.6),('7643','2014-03-17','10:10:00',12.34),('7643','2014-03-17','10:15:00',10.46),('7643','2014-03-17','10:20:00',15.33),('7643','2014-03-17','10:25:00',16.82),('7643','2014-03-17','10:30:00',10.91),('7643','2014-03-17','10:35:00',16.4),('7643','2014-03-17','10:40:00',13.08),('7643','2014-03-17','10:45:00',12.99),('7643','2014-03-17','10:50:00',17.17),('7643','2014-03-17','10:55:00',10.92),('7643','2014-03-17','11:00:00',11.19),('7643','2014-03-17','11:05:00',11.21),('7643','2014-03-17','11:10:00',8.56),('7643','2014-03-17','11:15:00',6.04),('7643','2014-03-17','11:20:00',8.22),('7643','2014-03-17','11:25:00',15.7),('7643','2014-03-17','11:30:00',12.97),('7643','2014-03-17','11:35:00',9.64),('7643','2014-03-17','11:40:00',10.57),('7643','2014-03-17','11:45:00',6.96),('7643','2014-03-17','11:50:00',8.45),('7643','2014-03-17','11:55:00',7.9),('7643','2014-03-17','12:00:00',6.71),('7643','2014-03-17','12:05:00',6.79),('7643','2014-03-17','12:10:00',7.37),('7643','2014-03-17','12:15:00',10.72),('7643','2014-03-17','12:20:00',11.37),('7643','2014-03-17','12:25:00',10.85),('7643','2014-03-17','12:30:00',7.32),('7643','2014-03-17','12:35:00',15.77),('7643','2014-03-17','12:40:00',9.4),('7643','2014-03-17','12:45:00',8.63),('7643','2014-03-17','12:50:00',6.18),('7643','2014-03-17','12:55:00',8.53),('7643','2014-03-17','13:00:00',16.06),('7643','2014-03-17','13:05:00',16.28),('7643','2014-03-17','13:10:00',15.54),('7643','2014-03-17','13:15:00',15.48),('7643','2014-03-17','13:20:00',15.15),('7643','2014-03-17','13:25:00',14.29),('7643','2014-03-17','13:30:00',12.22),('7643','2014-03-17','13:35:00',14.44),('7643','2014-03-17','13:40:00',14.31),('7643','2014-03-17','13:45:00',14.28),('7643','2014-03-17','13:50:00',13.83),('7643','2014-03-17','13:55:00',13.88),('7643','2014-03-17','14:00:00',13.68),('7643','2014-03-17','14:05:00',13.31),('7643','2014-03-17','14:10:00',13.48),('7643','2014-03-17','14:15:00',13.21),('7643','2014-03-17','14:20:00',13.13),('7643','2014-03-17','14:25:00',12.94),('7643','2014-03-17','14:30:00',12.74),('7643','2014-03-17','14:35:00',12.44),('7643','2014-03-17','14:40:00',12.24),('7643','2014-03-17','14:45:00',11.94),('7643','2014-03-17','14:50:00',11.8),('7643','2014-03-17','14:55:00',11.62),('7643','2014-03-17','15:00:00',11.27),('7643','2014-03-17','15:05:00',10.97),('7643','2014-03-17','15:10:00',10.65),('7643','2014-03-17','15:15:00',10.4),('7643','2014-03-17','15:20:00',10.18),('7643','2014-03-17','15:25:00',9.88),('7643','2014-03-17','15:30:00',9.53),('7643','2014-03-17','15:35:00',9.15),('7643','2014-03-17','15:40:00',8.85),('7643','2014-03-17','15:45:00',8.43),('7643','2014-03-17','15:50:00',8.15),('7643','2014-03-17','15:55:00',7.82),('7643','2014-03-17','16:00:00',7.59),('7643','2014-03-17','16:05:00',7.34),('7643','2014-03-17','16:10:00',6.88),('7643','2014-03-17','16:15:00',6.5),('7643','2014-03-17','16:20:00',6.07),('7643','2014-03-17','16:25:00',5.73),('7643','2014-03-17','16:30:00',5.48),('7643','2014-03-17','16:35:00',5.07),('7643','2014-03-17','16:40:00',4.6),('7643','2014-03-17','16:45:00',4.22),('7643','2014-03-17','16:50:00',3.79),('7643','2014-03-17','16:55:00',3.42),('7643','2014-03-17','17:00:00',3.12),('7643','2014-03-17','17:05:00',2.75),('7643','2014-03-17','17:10:00',2.41),('7643','2014-03-17','17:15:00',2.06),('7643','2014-03-17','17:20:00',1.74),('7643','2014-03-17','17:25:00',1.45),('7643','2014-03-17','17:30:00',1.19),('7643','2012-12-31','08:05:00',1.1),('7643','2012-12-31','08:10:00',1.32),('7643','2012-12-31','08:15:00',1.53),('7643','2012-12-31','08:20:00',1.76),('7643','2012-12-31','08:25:00',2.03),('7643','2012-12-31','08:30:00',2.32),('7643','2012-12-31','08:35:00',2.62),('7643','2012-12-31','08:40:00',2.94),('7643','2012-12-31','08:45:00',3.28),('7643','2012-12-31','08:50:00',3.69),('7643','2012-12-31','08:55:00',3.95),('7643','2012-12-31','09:00:00',4.26),('7643','2012-12-31','09:05:00',4.6),('7643','2012-12-31','09:10:00',4.87),('7643','2012-12-31','09:15:00',5.15),('7643','2012-12-31','09:20:00',5.44),('7643','2012-12-31','09:25:00',5.72),('7643','2012-12-31','09:30:00',5.98),('7643','2012-12-31','09:35:00',6.21),('7643','2012-12-31','09:40:00',6.44),('7643','2012-12-31','09:45:00',6.69),('7643','2012-12-31','09:50:00',6.92),('7643','2012-12-31','09:55:00',7.08),('7643','2012-12-31','10:00:00',7.23),('7643','2012-12-31','10:05:00',7.52),('7643','2012-12-31','10:10:00',7.75),('7643','2012-12-31','10:15:00',7.9),('7643','2012-12-31','10:20:00',8.04),('7643','2012-12-31','10:25:00',8.28),('7643','2012-12-31','10:30:00',8.49),('7643','2012-12-31','10:35:00',8.54),('7643','2012-12-31','10:40:00',8.84),('7643','2012-12-31','10:45:00',9.36),('7643','2012-12-31','10:50:00',9.92),('7643','2012-12-31','10:55:00',5.47),('7643','2012-12-31','11:00:00',3.36),('7643','2012-12-31','11:05:00',9.21),('7643','2012-12-31','11:10:00',10.18),('7643','2012-12-31','11:15:00',8.36),('7643','2012-12-31','11:20:00',6.79),('7643','2012-12-31','11:25:00',9.3),('7643','2012-12-31','11:30:00',11.19),('7643','2012-12-31','11:35:00',5.54),('7643','2012-12-31','11:40:00',6.3),('7643','2012-12-31','11:45:00',8.43),('7643','2012-12-31','11:50:00',9.17),('7643','2012-12-31','11:55:00',6.71),('7643','2012-12-31','12:00:00',5.69),('7643','2012-12-31','12:05:00',4.5),('7643','2012-12-31','12:10:00',4.95),('7643','2012-12-31','12:15:00',5.04),('7643','2012-12-31','12:20:00',4.65),('7643','2012-12-31','12:25:00',4.49),('7643','2012-12-31','12:30:00',4.03),('7643','2012-12-31','12:35:00',4),('7643','2012-12-31','12:40:00',4.49),('7643','2012-12-31','12:45:00',5.02),('7643','2012-12-31','12:50:00',5.18),('7643','2012-12-31','12:55:00',4.63),('7643','2012-12-31','13:00:00',3.68),('7643','2012-12-31','13:05:00',4.13),('7643','2012-12-31','13:10:00',3.24),('7643','2012-12-31','13:15:00',2.8),('7643','2012-12-31','13:20:00',3.13),('7643','2012-12-31','13:25:00',2.73),('7643','2012-12-31','13:30:00',2.34),('7643','2012-12-31','13:35:00',1.78),('7643','2012-12-31','13:40:00',1.39),('7643','2012-12-31','13:45:00',1.31),('7643','2012-12-31','13:50:00',1.04),('7643','2012-12-30','08:00:00',1.25),('7643','2012-12-30','08:05:00',1.42),('7643','2012-12-30','08:10:00',1.73),('7643','2012-12-30','08:15:00',1.97),('7643','2012-12-30','08:20:00',2.21),('7643','2012-12-30','08:25:00',2.59),('7643','2012-12-30','08:30:00',2.95),('7643','2012-12-30','08:35:00',3.02),('7643','2012-12-30','08:40:00',1.82),('7643','2012-12-30','08:45:00',1.95),('7643','2012-12-30','08:50:00',2.22),('7643','2012-12-30','08:55:00',2.6),('7643','2012-12-30','09:00:00',3.25),('7643','2012-12-30','09:05:00',3.64),('7643','2012-12-30','09:10:00',3.67),('7643','2012-12-30','09:15:00',4.98),('7643','2012-12-30','09:20:00',5.47),('7643','2012-12-30','09:25:00',6.38),('7643','2012-12-30','09:30:00',6.69),('7643','2012-12-30','09:35:00',2.53),('7643','2012-12-30','09:40:00',2.52),('7643','2012-12-30','09:45:00',1.53),('7643','2012-12-30','09:50:00',1.78),('7643','2012-12-30','09:55:00',2.39),('7643','2012-12-30','10:00:00',5.33),('7643','2012-12-30','10:05:00',3.15),('7643','2012-12-30','10:10:00',5.49),('7643','2012-12-30','10:15:00',8.01),('7643','2012-12-30','10:20:00',9.07),('7643','2012-12-30','10:25:00',9.09),('7643','2012-12-30','10:30:00',9.17),('7643','2012-12-30','10:35:00',9.29),('7643','2012-12-30','10:40:00',9.4),('7643','2012-12-30','10:45:00',9.3),('7643','2012-12-30','10:50:00',9.15),('7643','2012-12-30','10:55:00',9.52),('7643','2012-12-30','11:00:00',9.65),('7643','2012-12-30','11:05:00',9.62),('7643','2012-12-30','11:10:00',9.34),('7643','2012-12-30','11:15:00',9.54),('7643','2012-12-30','11:20:00',9.95),('7643','2012-12-30','11:25:00',10.05),('7643','2012-12-30','11:30:00',10.17),('7643','2012-12-30','11:35:00',10.16),('7643','2012-12-30','11:40:00',10.36),('7643','2012-12-30','11:45:00',10.36),('7643','2012-12-30','11:50:00',10.31),('7643','2012-12-30','11:55:00',10.35),('7643','2012-12-30','12:00:00',10.47),('7643','2012-12-30','12:05:00',10.47),('7643','2012-12-30','12:10:00',10.45),('7643','2012-12-30','12:15:00',10.57),('7643','2012-12-30','12:20:00',10.56),('7643','2012-12-30','12:25:00',10.51),('7643','2012-12-30','12:30:00',10.4),('7643','2012-12-30','12:35:00',10.33),('7643','2012-12-30','12:40:00',10.29),('7643','2012-12-30','12:45:00',10.21),('7643','2012-12-30','12:50:00',10.12),('7643','2012-12-30','12:55:00',10.04),('7643','2012-12-30','13:00:00',9.93),('7643','2012-12-30','13:05:00',9.83),('7643','2012-12-30','13:10:00',9.75),('7643','2012-12-30','13:15:00',9.57),('7643','2012-12-30','13:20:00',9.47),('7643','2012-12-30','13:25:00',9.38),('7643','2012-12-30','13:30:00',9.26),('7643','2012-12-30','13:35:00',9.03),('7643','2012-12-30','13:40:00',8.81),('7643','2012-12-30','13:45:00',8.69),('7643','2012-12-30','13:50:00',8.49),('7643','2012-12-30','13:55:00',8.31),('7643','2012-12-30','14:00:00',8.04),('7643','2012-12-30','14:05:00',7.8),('7643','2012-12-30','14:10:00',7.65),('7643','2012-12-30','14:15:00',7.47),('7643','2012-12-30','14:20:00',7.24),('7643','2012-12-30','14:25:00',6.98),('7643','2012-12-30','14:30:00',6.74),('7643','2012-12-30','14:35:00',6.56),('7643','2012-12-30','14:40:00',6.33),('7643','2012-12-30','14:45:00',6.03),('7643','2012-12-30','14:50:00',5.73),('7643','2012-12-30','14:55:00',5.47),('7643','2012-12-30','15:00:00',5.18),('7643','2012-12-30','15:05:00',4.89),('7643','2012-12-30','15:10:00',4.54),('7643','2012-12-30','15:15:00',4.21),('7643','2012-12-30','15:20:00',3.94),('7643','2012-12-30','15:25:00',3.69),('7643','2012-12-30','15:30:00',3.45),('7643','2012-12-30','15:35:00',3.15),('7643','2012-12-30','15:40:00',2.9),('7643','2012-12-30','15:45:00',2.6),('7643','2012-12-30','15:50:00',2.25),('7643','2012-12-30','15:55:00',1.92),('7643','2012-12-30','16:00:00',1.65),('7643','2012-12-30','16:05:00',1.38),('7643','2012-12-30','16:10:00',1.13),('7643','2012-12-29','08:00:00',1),('7643','2012-12-29','08:05:00',1.27),('7643','2012-12-29','08:10:00',1.54),('7643','2012-12-29','08:15:00',1.8),('7643','2012-12-29','08:20:00',2.08),('7643','2012-12-29','08:25:00',2.38),('7643','2012-12-29','08:30:00',2.72),('7643','2012-12-29','08:35:00',3.01),('7643','2012-12-29','08:40:00',3.33),('7643','2012-12-29','08:45:00',3.67),('7643','2012-12-29','08:50:00',3.96),('7643','2012-12-29','08:55:00',4.27),('7643','2012-12-29','09:00:00',4.57),('7643','2012-12-29','09:05:00',4.88),('7643','2012-12-29','09:10:00',5.15),('7643','2012-12-29','09:15:00',5.48),('7643','2012-12-29','09:20:00',5.73),('7643','2012-12-29','09:25:00',5.99),('7643','2012-12-29','09:30:00',6.26),('7643','2012-12-29','09:35:00',6.51),('7643','2012-12-29','09:40:00',6.74),('7643','2012-12-29','09:45:00',7),('7643','2012-12-29','09:50:00',7.18),('7643','2012-12-29','09:55:00',7.39),('7643','2012-12-29','10:00:00',7.67),('7643','2012-12-29','10:05:00',7.94),('7643','2012-12-29','10:10:00',8.19),('7643','2012-12-29','10:15:00',8.33),('7643','2012-12-29','10:20:00',8.53),('7643','2012-12-29','10:25:00',8.68),('7643','2012-12-29','10:30:00',8.84),('7643','2012-12-29','10:35:00',8.99),('7643','2012-12-29','10:40:00',9.13),('7643','2012-12-29','10:45:00',9.3),('7643','2012-12-29','10:50:00',9.39),('7643','2012-12-29','10:55:00',9.49),('7643','2012-12-29','11:00:00',9.62),('7643','2012-12-29','11:05:00',9.71),('7643','2012-12-29','11:10:00',9.78),('7643','2012-12-29','11:15:00',9.86),('7643','2012-12-29','11:20:00',9.91),('7643','2012-12-29','11:25:00',9.94),('7643','2012-12-29','11:30:00',10.01),('7643','2012-12-29','11:35:00',10.13),('7643','2012-12-29','11:40:00',10.13),('7643','2012-12-29','11:45:00',10.17),('7643','2012-12-29','11:50:00',10.14),('7643','2012-12-29','11:55:00',10.18),('7643','2012-12-29','12:00:00',10.14),('7643','2012-12-29','12:05:00',10.15),('7643','2012-12-29','12:10:00',10.18),('7643','2012-12-29','12:15:00',10.11),('7643','2012-12-29','12:20:00',10.16),('7643','2012-12-29','12:25:00',10.16),('7643','2012-12-29','12:30:00',10),('7643','2012-12-29','12:35:00',9.96),('7643','2012-12-29','12:40:00',9.84),('7643','2012-12-29','12:45:00',9.75),('7643','2012-12-29','12:50:00',9.64),('7643','2012-12-29','12:55:00',9.55),('7643','2012-12-29','13:00:00',9.63),('7643','2012-12-29','13:05:00',9.65),('7643','2012-12-29','13:10:00',9.55),('7643','2012-12-29','13:15:00',9.48),('7643','2012-12-29','13:20:00',9.35),('7643','2012-12-29','13:25:00',9.24),('7643','2012-12-29','13:30:00',9.12),('7643','2012-12-29','13:35:00',8.97),('7643','2012-12-29','13:40:00',8.86),('7643','2012-12-29','13:45:00',8.74),('7643','2012-12-29','13:50:00',8.54),('7643','2012-12-29','13:55:00',8.34),('7643','2012-12-29','14:00:00',8.18),('7643','2012-12-29','14:05:00',7.97),('7643','2012-12-29','14:10:00',7.72),('7643','2012-12-29','14:15:00',7.52),('7643','2012-12-29','14:20:00',7.31),('7643','2012-12-29','14:25:00',7.06),('7643','2012-12-29','14:30:00',6.77),('7643','2012-12-29','14:35:00',6.57),('7643','2012-12-29','14:40:00',6.27),('7643','2012-12-29','14:45:00',6.01),('7643','2012-12-29','14:50:00',5.75),('7643','2012-12-29','14:55:00',5.46),('7643','2012-12-29','15:00:00',5.16),('7643','2012-12-29','15:05:00',4.84),('7643','2012-12-29','15:10:00',4.58),('7643','2012-12-29','15:15:00',4.28),('7643','2012-12-29','15:20:00',3.98),('7643','2012-12-29','15:25:00',3.71),('7643','2012-12-29','15:30:00',3.42),('7643','2012-12-29','15:35:00',3.14),('7643','2012-12-29','15:40:00',2.82),('7643','2012-12-29','15:45:00',2.53),('7643','2012-12-29','15:50:00',2.25),('7643','2012-12-29','15:55:00',1.99),('7643','2012-12-29','16:00:00',1.7),('7643','2012-12-29','16:05:00',1.41),('7643','2012-12-29','16:10:00',1.15),('7643','2012-12-28','08:10:00',1.51),('7643','2012-12-28','08:15:00',1.83),('7643','2012-12-28','08:20:00',2.14),('7643','2012-12-28','08:25:00',2.51),('7643','2012-12-28','08:30:00',2.83),('7643','2012-12-28','08:35:00',3.19),('7643','2012-12-28','08:40:00',3.63),('7643','2012-12-28','08:45:00',3.98),('7643','2012-12-28','08:50:00',4.3),('7643','2012-12-28','08:55:00',4.53),('7643','2012-12-28','09:00:00',4.73),('7643','2012-12-28','09:05:00',5.02),('7643','2012-12-28','09:10:00',5.34),('7643','2012-12-28','09:15:00',5.62),('7643','2012-12-28','09:20:00',5.88),('7643','2012-12-28','09:25:00',6.11),('7643','2012-12-28','09:30:00',6.36),('7643','2012-12-28','09:35:00',6.63),('7643','2012-12-28','09:40:00',6.89),('7643','2012-12-28','09:45:00',7.18),('7643','2012-12-28','09:50:00',7.47),('7643','2012-12-28','09:55:00',7.7),('7643','2012-12-28','10:00:00',7.94),('7643','2012-12-28','10:05:00',8.17),('7643','2012-12-28','10:10:00',8.38),('7643','2012-12-28','10:15:00',8.6),('7643','2012-12-28','10:20:00',8.76),('7643','2012-12-28','10:25:00',8.95),('7643','2012-12-28','10:30:00',9.1),('7643','2012-12-28','10:35:00',9.22),('7643','2012-12-28','10:40:00',9.41),('7643','2012-12-28','10:45:00',9.56),('7643','2012-12-28','10:50:00',9.73),('7643','2012-12-28','10:55:00',9.84),('7643','2012-12-28','11:00:00',9.89),('7643','2012-12-28','11:05:00',9.98),('7643','2012-12-28','11:10:00',10.06),('7643','2012-12-28','11:15:00',10.18),('7643','2012-12-28','11:20:00',10.28),('7643','2012-12-28','11:25:00',10.32),('7643','2012-12-28','11:30:00',10.35),('7643','2012-12-28','11:35:00',10.41),('7643','2012-12-28','11:40:00',10.39),('7643','2012-12-28','11:45:00',10.47),('7643','2012-12-28','11:50:00',10.52),('7643','2012-12-28','11:55:00',10.5),('7643','2012-12-28','12:00:00',10.52),('7643','2012-12-28','12:05:00',10.59),('7643','2012-12-28','12:10:00',10.63),('7643','2012-12-28','12:15:00',10.52),('7643','2012-12-28','12:20:00',10.41),('7643','2012-12-28','12:25:00',10.34),('7643','2012-12-28','12:30:00',10.37),('7643','2012-12-28','12:35:00',10.41),('7643','2012-12-28','12:40:00',10.35),('7643','2012-12-28','12:45:00',10.1),('7643','2012-12-28','12:50:00',10.02),('7643','2012-12-28','12:55:00',10.02),('7643','2012-12-28','13:00:00',10),('7643','2012-12-28','13:05:00',9.96),('7643','2012-12-28','13:10:00',9.86),('7643','2012-12-28','13:15:00',9.76),('7643','2012-12-28','13:20:00',9.64),('7643','2012-12-28','13:25:00',9.46),('7643','2012-12-28','13:30:00',9.29),('7643','2012-12-28','13:35:00',9.15),('7643','2012-12-28','13:40:00',9.01),('7643','2012-12-28','13:45:00',8.88),('7643','2012-12-28','13:50:00',8.72),('7643','2012-12-28','13:55:00',8.53),('7643','2012-12-28','14:00:00',8.32),('7643','2012-12-28','14:05:00',8.07),('7643','2012-12-28','14:10:00',7.88),('7643','2012-12-28','14:15:00',7.72),('7643','2012-12-28','14:20:00',7.5),('7643','2012-12-28','14:25:00',7.24),('7643','2012-12-28','14:30:00',6.96),('7643','2012-12-28','14:35:00',6.7),('7643','2012-12-28','14:40:00',6.47),('7643','2012-12-28','14:45:00',6.23),('7643','2012-12-28','14:50:00',5.97),('7643','2012-12-28','14:55:00',5.68),('7643','2012-12-28','15:00:00',5.41),('7643','2012-12-28','15:05:00',5.12),('7643','2012-12-28','15:10:00',4.81),('7643','2012-12-28','15:15:00',4.51),('7643','2012-12-28','15:20:00',4.19),('7643','2012-12-28','15:25:00',3.88),('7643','2012-12-28','15:30:00',3.56),('7643','2012-12-28','15:35:00',3.24),('7643','2012-12-28','15:40:00',2.91),('7643','2012-12-28','15:45:00',2.61),('7643','2012-12-28','15:50:00',2.3),('7643','2012-12-28','15:55:00',2),('7643','2012-12-28','16:00:00',1.71),('7643','2012-12-28','16:05:00',1.44),('7643','2012-12-28','16:10:00',1.16),('7643','2012-12-27','08:40:00',2.68),('7643','2012-12-27','08:45:00',3.17),('7643','2012-12-27','08:50:00',3.47),('7643','2012-12-27','08:55:00',3.81),('7643','2012-12-27','09:00:00',4.11),('7643','2012-12-27','09:05:00',4.49),('7643','2012-12-27','09:10:00',4.81),('7643','2012-12-27','09:15:00',5.21),('7643','2012-12-27','09:20:00',5.42),('7643','2012-12-27','09:25:00',5.59),('7643','2012-12-27','09:30:00',5.82),('7643','2012-12-27','09:35:00',6.07),('7643','2012-12-27','09:40:00',6.28),('7643','2012-12-27','09:45:00',6.45),('7643','2012-12-27','09:50:00',6.61),('7643','2012-12-27','09:55:00',6.82),('7643','2012-12-27','10:00:00',7.14),('7643','2012-12-27','10:05:00',7.3),('7643','2012-12-27','10:10:00',7.62),('7643','2012-12-27','10:15:00',7.94),('7643','2012-12-27','10:20:00',8.14),('7643','2012-12-27','10:25:00',8.3),('7643','2012-12-27','10:30:00',8.54),('7643','2012-12-27','10:35:00',8.77),('7643','2012-12-27','10:40:00',8.79),('7643','2012-12-27','10:45:00',8.94),('7643','2012-12-27','10:50:00',9.01),('7643','2012-12-27','10:55:00',9.12),('7643','2012-12-27','11:00:00',9.28),('7643','2012-12-27','11:05:00',9.4),('7643','2012-12-27','11:10:00',9.69),('7643','2012-12-27','11:15:00',9.69),('7643','2012-12-27','11:20:00',9.76),('7643','2012-12-27','11:25:00',9.82),('7643','2012-12-27','11:30:00',9.41),('7643','2012-12-27','11:35:00',10.03),('7643','2012-12-27','11:40:00',10.05),('7643','2012-12-27','11:45:00',10.1),('7643','2012-12-27','11:50:00',10.22),('7643','2012-12-27','11:55:00',8.75),('7643','2012-12-27','12:00:00',9.08),('7643','2012-12-27','12:05:00',7.53),('7643','2012-12-27','12:10:00',9.22),('7643','2012-12-27','12:15:00',9.95),('7643','2012-12-27','12:20:00',9.6),('7643','2012-12-27','12:25:00',9.24),('7643','2012-12-27','12:30:00',9.85),('7643','2012-12-27','12:35:00',9.75),('7643','2012-12-27','12:40:00',9.09),('7643','2012-12-27','12:45:00',6.85),('7643','2012-12-27','12:50:00',9.78),('7643','2012-12-27','12:55:00',9.59),('7643','2012-12-27','13:00:00',9.5),('7643','2012-12-27','13:05:00',9.29),('7643','2012-12-27','13:10:00',9.17),('7643','2012-12-27','13:15:00',9.01),('7643','2012-12-27','13:20:00',8.9),('7643','2012-12-27','13:25:00',8.77),('7643','2012-12-27','13:30:00',8.64),('7643','2012-12-27','13:35:00',8.44),('7643','2012-12-27','13:40:00',8.3),('7643','2012-12-27','13:45:00',8.15),('7643','2012-12-27','13:50:00',8.06),('7643','2012-12-27','13:55:00',7.79),('7643','2012-12-27','14:00:00',7.56),('7643','2012-12-27','14:05:00',7.19),('7643','2012-12-27','14:10:00',6.1),('7643','2012-12-27','14:15:00',6.58),('7643','2012-12-27','14:20:00',6.42),('7643','2012-12-27','14:25:00',6.47),('7643','2012-12-27','14:30:00',6.11),('7643','2012-12-27','14:35:00',5.61),('7643','2012-12-27','14:40:00',2.71),('7643','2012-12-27','14:45:00',4.42),('7643','2012-12-27','14:50:00',5.24),('7643','2012-12-27','14:55:00',4.99),('7643','2012-12-27','15:00:00',4.75),('7643','2012-12-27','15:05:00',4.51),('7643','2012-12-27','15:10:00',4.22),('7643','2012-12-27','15:15:00',3.93),('7643','2012-12-27','15:20:00',3.63),('7643','2012-12-27','15:25:00',3.34),('7643','2012-12-27','15:30:00',3.09),('7643','2012-12-27','15:35:00',2.79),('7643','2012-12-27','15:40:00',2.5),('7643','2012-12-27','15:45:00',2.18),('7643','2012-12-27','15:50:00',1.88),('7643','2012-12-27','15:55:00',1.63),('7643','2012-12-27','16:00:00',1.42),('7643','2012-12-27','16:05:00',1.19),('7643','2012-12-26','08:45:00',1.03),('7643','2012-12-26','08:50:00',1.22),('7643','2012-12-26','08:55:00',1.67),('7643','2012-12-26','09:00:00',1.77),('7643','2012-12-26','09:05:00',1.31),('7643','2012-12-26','09:10:00',1.5),('7643','2012-12-26','09:15:00',2.15),('7643','2012-12-26','09:20:00',3.28),('7643','2012-12-26','09:25:00',4.15),('7643','2012-12-26','09:30:00',5.4),('7643','2012-12-26','09:35:00',6.41),('7643','2012-12-26','09:40:00',6.31),('7643','2012-12-26','09:45:00',6.55),('7643','2012-12-26','09:50:00',6.96),('7643','2012-12-26','09:55:00',7.14),('7643','2012-12-26','10:00:00',6.65),('7643','2012-12-26','10:05:00',5.34),('7643','2012-12-26','10:10:00',6.52),('7643','2012-12-26','10:15:00',8.18),('7643','2012-12-26','10:20:00',7.53),('7643','2012-12-26','10:25:00',7.59),('7643','2012-12-26','10:30:00',7.72),('7643','2012-12-26','10:35:00',7.85),('7643','2012-12-26','10:40:00',8.21),('7643','2012-12-26','10:45:00',8.58),('7643','2012-12-26','10:50:00',8.19),('7643','2012-12-26','10:55:00',8.34),('7643','2012-12-26','11:00:00',8.82),('7643','2012-12-26','11:05:00',9.19),('7643','2012-12-26','11:10:00',9.1),('7643','2012-12-26','11:15:00',7.37),('7643','2012-12-26','11:20:00',3.64),('7643','2012-12-26','11:25:00',2.83),('7643','2012-12-26','11:50:00',2.38),('7643','2012-12-26','11:55:00',9.56),('7643','2012-12-26','12:00:00',9.72),('7643','2012-12-26','12:05:00',9.63),('7643','2012-12-26','12:10:00',10.1),('7643','2012-12-26','12:15:00',9.16),('7643','2012-12-26','12:20:00',5.54),('7643','2012-12-26','12:25:00',9.29),('7643','2012-12-26','12:30:00',9.27),('7643','2012-12-26','12:35:00',9.82),('7643','2012-12-26','12:40:00',9.55),('7643','2012-12-26','12:45:00',10.69),('7643','2012-12-26','12:50:00',10.45),('7643','2012-12-26','12:55:00',8.93),('7643','2012-12-26','13:00:00',9.51),('7643','2012-12-26','13:05:00',10.07),('7643','2012-12-26','13:10:00',9.67),('7643','2012-12-26','13:15:00',10.05),('7643','2012-12-26','13:20:00',9.95),('7643','2012-12-26','13:25:00',9.71),('7643','2012-12-26','13:30:00',9.39),('7643','2012-12-26','13:35:00',4.12),('7643','2012-12-26','13:40:00',2.03),('7643','2012-12-26','13:45:00',2),('7643','2012-12-26','13:50:00',1.21),('7643','2012-12-26','13:55:00',1.86),('7643','2012-12-26','14:00:00',4.2),('7643','2012-12-26','14:05:00',6.18),('7643','2012-12-26','14:10:00',8.22),('7643','2012-12-26','14:15:00',7.7),('7643','2012-12-26','14:20:00',6.92),('7643','2012-12-26','14:25:00',6.61),('7643','2012-12-26','14:30:00',6.43),('7643','2012-12-26','14:35:00',6.19),('7643','2012-12-26','14:40:00',5.88),('7643','2012-12-26','14:45:00',5.11),('7643','2012-12-26','14:50:00',1.7),('7643','2012-12-26','14:55:00',4.67),('7643','2012-12-26','15:00:00',5.28),('7643','2012-12-26','15:05:00',4.56),('7643','2012-12-26','15:10:00',1.67),('7643','2012-12-26','15:15:00',1.31),('7643','2012-12-26','15:20:00',1.11),('7643','2012-12-26','15:25:00',1.61),('7643','2012-12-26','15:30:00',2.73),('7643','2012-12-26','15:35:00',2.21),('7643','2012-12-26','15:40:00',2.63),('7643','2012-12-26','15:45:00',2.26),('7643','2012-12-26','15:50:00',1.66),('7643','2012-12-26','15:55:00',1.54),('7643','2012-12-26','16:00:00',1.1),('7643','2012-12-25','08:30:00',1.01),('7643','2012-12-25','08:35:00',1.08),('7643','2012-12-25','08:40:00',1.31),('7643','2012-12-25','08:55:00',1.21),('7643','2012-12-25','09:00:00',1.79),('7643','2012-12-25','09:05:00',1.17),('7643','2012-12-25','09:10:00',2.56),('7643','2012-12-25','09:15:00',3.99),('7643','2012-12-25','09:20:00',5.43),('7643','2012-12-25','09:25:00',5.68),('7643','2012-12-25','09:30:00',5.89),('7643','2012-12-25','09:35:00',6.09),('7643','2012-12-25','09:40:00',6.39),('7643','2012-12-25','09:45:00',6.64),('7643','2012-12-25','09:50:00',6.86),('7643','2012-12-25','09:55:00',7.1),('7643','2012-12-25','10:00:00',7.31),('7643','2012-12-25','10:05:00',7.52),('7643','2012-12-25','10:10:00',7.71),('7643','2012-12-25','10:15:00',7.8),('7643','2012-12-25','10:20:00',7.94),('7643','2012-12-25','10:25:00',7.95),('7643','2012-12-25','10:30:00',8.12),('7643','2012-12-25','10:35:00',8.27),('7643','2012-12-25','10:40:00',8.44),('7643','2012-12-25','10:45:00',8.49),('7643','2012-12-25','10:50:00',8.61),('7643','2012-12-25','10:55:00',8.76),('7643','2012-12-25','11:00:00',8.85),('7643','2012-12-25','11:05:00',8.94),('7643','2012-12-25','11:10:00',9),('7643','2012-12-25','11:15:00',9.07),('7643','2012-12-25','11:20:00',9.11),('7643','2012-12-25','11:25:00',9.15),('7643','2012-12-25','11:30:00',9.2),('7643','2012-12-25','11:35:00',9.24),('7643','2012-12-25','11:40:00',9.35),('7643','2012-12-25','11:45:00',9.47),('7643','2012-12-25','11:50:00',9.62),('7643','2012-12-25','11:55:00',9.76),('7643','2012-12-25','12:00:00',9.9),('7643','2012-12-25','12:05:00',9.89),('7643','2012-12-25','12:10:00',9.85),('7643','2012-12-25','12:15:00',9.9),('7643','2012-12-25','12:20:00',9.92),('7643','2012-12-25','12:25:00',9.94),('7643','2012-12-25','12:30:00',9.84),('7643','2012-12-25','12:35:00',9.85),('7643','2012-12-25','12:40:00',8.54),('7643','2012-12-25','12:45:00',9.72),('7643','2012-12-25','12:50:00',9.35),('7643','2012-12-25','12:55:00',9.55),('7643','2012-12-25','13:00:00',9.63),('7643','2012-12-25','13:05:00',9.5),('7643','2012-12-25','13:10:00',9.52),('7643','2012-12-25','13:15:00',9.31),('7643','2012-12-25','13:20:00',9.57),('7643','2012-12-25','13:25:00',9.64),('7643','2012-12-25','13:30:00',10.21),('7643','2012-12-25','13:35:00',10.12),('7643','2012-12-25','13:40:00',10.02),('7643','2012-12-25','13:45:00',10.13),('7643','2012-12-25','13:50:00',9.13),('7643','2012-12-25','13:55:00',9.66),('7643','2012-12-25','14:00:00',9.44),('7643','2012-12-25','14:05:00',8.59),('7643','2012-12-25','14:10:00',2.93),('7643','2012-12-25','14:15:00',3.34),('7643','2012-12-25','14:20:00',1.44),('7643','2012-12-25','14:25:00',1.51),('7643','2012-12-25','14:30:00',1.21),('7643','2012-12-25','14:40:00',1.02),('7643','2012-12-24','09:00:00',1.13),('7643','2012-12-24','09:05:00',1.13),('7643','2012-12-24','09:10:00',1.13),('7643','2012-12-24','09:15:00',1.21),('7643','2012-12-24','09:20:00',1.46),('7643','2012-12-24','09:25:00',1.31),('7643','2012-12-24','09:30:00',1.36),('7643','2012-12-24','09:35:00',1.49),('7643','2012-12-24','09:40:00',1.52),('7643','2012-12-24','09:45:00',1.48),('7643','2012-12-24','09:50:00',1.55),('7643','2012-12-24','09:55:00',1.65),('7643','2012-12-24','10:00:00',1.94),('7643','2012-12-24','10:05:00',2.27),('7643','2012-12-24','10:10:00',2.53),('7643','2012-12-24','10:15:00',2.64),('7643','2012-12-24','10:20:00',2.77),('7643','2012-12-24','10:25:00',2.96),('7643','2012-12-24','10:30:00',2.81),('7643','2012-12-24','10:35:00',2.77),('7643','2012-12-24','10:40:00',2.71),('7643','2012-12-24','10:45:00',2.66),('7643','2012-12-24','10:50:00',2.64),('7643','2012-12-24','10:55:00',2.75),('7643','2012-12-24','11:00:00',2.76),('7643','2012-12-24','11:05:00',2.95),('7643','2012-12-24','11:10:00',2.98),('7643','2012-12-24','11:15:00',2.98),('7643','2012-12-24','11:20:00',3.22),('7643','2012-12-24','11:25:00',3.44),('7643','2012-12-24','11:30:00',3.26),('7643','2012-12-24','11:35:00',3.16),('7643','2012-12-24','11:40:00',2.92),('7643','2012-12-24','11:45:00',3.03),('7643','2012-12-24','11:50:00',3.27),('7643','2012-12-24','11:55:00',3.52),('7643','2012-12-24','12:00:00',3.47),('7643','2012-12-24','12:05:00',3.18),('7643','2012-12-24','12:10:00',3.16),('7643','2012-12-24','12:15:00',3.07),('7643','2012-12-24','12:20:00',3.06),('7643','2012-12-24','12:25:00',3.15),('7643','2012-12-24','12:30:00',2.89),('7643','2012-12-24','12:35:00',2.75),('7643','2012-12-24','12:40:00',2.72),('7643','2012-12-24','12:45:00',2.73),('7643','2012-12-24','12:50:00',2.82),('7643','2012-12-24','12:55:00',3.11),('7643','2012-12-24','13:00:00',2.95),('7643','2012-12-24','13:05:00',3.16),('7643','2012-12-24','13:10:00',3.22),('7643','2012-12-24','13:15:00',3.32),('7643','2012-12-24','13:20:00',3.2),('7643','2012-12-24','13:25:00',2.81),('7643','2012-12-24','13:30:00',2.49),('7643','2012-12-24','13:35:00',2.24),('7643','2012-12-24','13:40:00',2.42),('7643','2012-12-24','13:45:00',2.13),('7643','2012-12-24','13:50:00',2.02),('7643','2012-12-24','13:55:00',1.57),('7643','2012-12-24','14:00:00',1.92),('7643','2012-12-24','14:05:00',1.93),('7643','2012-12-24','14:10:00',1.65),('7643','2012-12-24','14:15:00',1.57),('7643','2012-12-24','14:20:00',1.44),('7643','2012-12-24','14:25:00',1.4),('7643','2012-12-24','14:30:00',1.75),('7643','2012-12-24','14:35:00',2),('7643','2012-12-24','14:40:00',3.56),('7643','2012-12-24','14:45:00',4.2),('7643','2012-12-24','14:50:00',3.76),('7643','2012-12-24','14:55:00',3.72),('7643','2012-12-24','15:00:00',3.59),('7643','2012-12-24','15:05:00',2.66),('7643','2012-12-24','15:10:00',3.04),('7643','2012-12-24','15:15:00',2.96),('7643','2012-12-24','15:20:00',2.58),('7643','2012-12-24','15:25:00',2.26),('7643','2012-12-24','15:30:00',1.92),('7643','2012-12-24','15:35:00',1.93),('7643','2012-12-24','15:40:00',1.93),('7643','2012-12-24','15:45:00',1.54),('7643','2012-12-24','15:50:00',1.26),('7643','2012-12-23','09:25:00',1.07),('7643','2012-12-23','09:30:00',1.04),('7643','2012-12-23','09:35:00',1.03),('7643','2012-12-23','09:40:00',1.09),('7643','2012-12-23','09:45:00',1.15),('7643','2012-12-23','09:50:00',1.15),('7643','2012-12-23','09:55:00',1.25),('7643','2012-12-23','10:00:00',1.35),('7643','2012-12-23','10:05:00',1.47),('7643','2012-12-23','10:10:00',1.48),('7643','2012-12-23','10:15:00',1.47),('7643','2012-12-23','10:20:00',1.37),('7643','2012-12-23','10:25:00',1.38),('7643','2012-12-23','10:30:00',1.46),('7643','2012-12-23','10:35:00',1.58),('7643','2012-12-23','10:40:00',1.47),('7643','2012-12-23','10:45:00',1.65),('7643','2012-12-23','10:50:00',1.7),('7643','2012-12-23','10:55:00',1.72),('7643','2012-12-23','11:00:00',1.68),('7643','2012-12-23','11:05:00',1.8),('7643','2012-12-23','11:10:00',1.95),('7643','2012-12-23','11:15:00',2.01),('7643','2012-12-23','11:20:00',2.18),('7643','2012-12-23','11:25:00',2.1),('7643','2012-12-23','11:30:00',2.29),('7643','2012-12-23','11:35:00',2.36),('7643','2012-12-23','11:40:00',2.32),('7643','2012-12-23','11:45:00',2.28),('7643','2012-12-23','11:50:00',2.17),('7643','2012-12-23','11:55:00',2.19),('7643','2012-12-23','12:00:00',2.44),('7643','2012-12-23','12:05:00',2.79),('7643','2012-12-23','12:10:00',3.04),('7643','2012-12-23','12:15:00',2.88),('7643','2012-12-23','12:20:00',2.76),('7643','2012-12-23','12:25:00',2.77),('7643','2012-12-23','12:30:00',2.72),('7643','2012-12-23','12:35:00',2.71),('7643','2012-12-23','12:40:00',2.71),('7643','2012-12-23','12:45:00',2.53),('7643','2012-12-23','12:50:00',2.34),('7643','2012-12-23','12:55:00',2.27),('7643','2012-12-23','13:00:00',2.22),('7643','2012-12-23','13:05:00',2.01),('7643','2012-12-23','13:10:00',1.98),('7643','2012-12-23','13:15:00',1.85),('7643','2012-12-23','13:20:00',1.64),('7643','2012-12-23','13:25:00',1.73),('7643','2012-12-23','13:30:00',1.36),('7643','2012-12-23','13:35:00',1.26),('7643','2012-12-23','13:40:00',1.36),('7643','2012-12-23','13:45:00',1.45),('7643','2012-12-23','13:50:00',1.4),('7643','2012-12-23','13:55:00',1.39),('7643','2012-12-23','14:00:00',1.41),('7643','2012-12-23','14:05:00',1.36),('7643','2012-12-23','14:10:00',1.36),('7643','2012-12-23','14:15:00',1.35),('7643','2012-12-23','14:20:00',1.35),('7643','2012-12-23','14:25:00',1.24),('7643','2012-12-23','14:30:00',1.14),('7643','2012-12-23','14:35:00',1.08),('7643','2012-12-23','14:40:00',1.03),('7643','2012-12-22','08:00:00',1.05),('7643','2012-12-22','08:05:00',1.32),('7643','2012-12-22','08:10:00',1.56),('7643','2012-12-22','08:15:00',1.82),('7643','2012-12-22','08:20:00',2.1),('7643','2012-12-22','08:25:00',2.36),('7643','2012-12-22','08:30:00',2.7),('7643','2012-12-22','08:35:00',2.96),('7643','2012-12-22','08:40:00',3.28),('7643','2012-12-22','08:45:00',3.63),('7643','2012-12-22','08:50:00',3.98),('7643','2012-12-22','08:55:00',4.35),('7643','2012-12-22','09:00:00',4.69),('7643','2012-12-22','09:05:00',5.03),('7643','2012-12-22','09:10:00',5.26),('7643','2012-12-22','09:15:00',5.36),('7643','2012-12-22','09:20:00',5.62),('7643','2012-12-22','09:25:00',6.01),('7643','2012-12-22','09:30:00',6.14),('7643','2012-12-22','09:35:00',6.46),('7643','2012-12-22','09:40:00',6.69),('7643','2012-12-22','09:45:00',6.93),('7643','2012-12-22','09:50:00',7.13),('7643','2012-12-22','09:55:00',7.28),('7643','2012-12-22','10:00:00',7.44),('7643','2012-12-22','10:05:00',7.73),('7643','2012-12-22','10:10:00',7.81),('7643','2012-12-22','10:15:00',7.94),('7643','2012-12-22','10:20:00',8.14),('7643','2012-12-22','10:25:00',8.11),('7643','2012-12-22','10:30:00',8.21),('7643','2012-12-22','10:35:00',8.45),('7643','2012-12-22','10:40:00',8.62),('7643','2012-12-22','10:45:00',8.88),('7643','2012-12-22','10:50:00',8.95),('7643','2012-12-22','10:55:00',8.53),('7643','2012-12-22','11:00:00',9.12),('7643','2012-12-22','11:05:00',9.25),('7643','2012-12-22','11:10:00',9.27),('7643','2012-12-22','11:15:00',9.37),('7643','2012-12-22','11:20:00',9.59),('7643','2012-12-22','11:25:00',8.74),('7643','2012-12-22','11:30:00',9.32),('7643','2012-12-22','11:35:00',9.89),('7643','2012-12-22','11:40:00',9.86),('7643','2012-12-22','11:45:00',9.69),('7643','2012-12-22','11:50:00',9.96),('7643','2012-12-22','11:55:00',9.35),('7643','2012-12-22','12:00:00',8.72),('7643','2012-12-22','12:05:00',8.85),('7643','2012-12-22','12:10:00',8.85),('7643','2012-12-22','12:15:00',7.14),('7643','2012-12-22','12:20:00',6.59),('7643','2012-12-22','12:25:00',4.59),('7643','2012-12-22','12:30:00',4.32),('7643','2012-12-22','12:35:00',3.82),('7643','2012-12-22','12:40:00',4.92),('7643','2012-12-22','12:45:00',4.46),('7643','2012-12-22','12:50:00',6.16),('7643','2012-12-22','12:55:00',8.12),('7643','2012-12-22','13:00:00',9.15),('7643','2012-12-22','13:05:00',8.08),('7643','2012-12-22','13:10:00',9.15),('7643','2012-12-22','13:15:00',6.37),('7643','2012-12-22','13:20:00',5.41),('7643','2012-12-22','13:25:00',5.61),('7643','2012-12-22','13:30:00',4.5),('7643','2012-12-22','13:35:00',3.71),('7643','2012-12-22','13:40:00',6.42),('7643','2012-12-22','13:45:00',6.28),('7643','2012-12-22','13:50:00',5.82),('7643','2012-12-22','13:55:00',5.08),('7643','2012-12-22','14:00:00',7.06),('7643','2012-12-22','14:05:00',6.65),('7643','2012-12-22','14:10:00',6.15),('7643','2012-12-22','14:15:00',6.43),('7643','2012-12-22','14:20:00',5.12),('7643','2012-12-22','14:25:00',4.06),('7643','2012-12-22','14:30:00',3.98),('7643','2012-12-22','14:35:00',4.95),('7643','2012-12-22','14:40:00',5.33),('7643','2012-12-22','14:45:00',5.5),('7643','2012-12-22','14:50:00',4.03),('7643','2012-12-22','14:55:00',2.86),('7643','2012-12-22','15:00:00',2.36),('7643','2012-12-22','15:05:00',2.31),('7643','2012-12-22','15:10:00',2.76),('7643','2012-12-22','15:15:00',1.74),('7643','2012-12-22','15:20:00',1.35),('7643','2012-12-22','15:25:00',1.01),('7643','2012-12-22','15:30:00',1.15),('7643','2012-12-22','15:35:00',1.12),('7643','2012-12-22','15:45:00',1.31),('7643','2012-12-22','15:50:00',1.36),('7643','2012-12-22','16:05:00',1.15),('7643','2014-04-30','07:40:00',2.73),('7643','2014-04-30','07:45:00',3.44),('7643','2014-04-30','07:50:00',4.56),('7643','2014-04-30','07:55:00',5.1),('7643','2014-04-30','08:00:00',5.65),('7643','2014-04-30','08:05:00',5.99),('7643','2014-04-30','08:10:00',6.05),('7643','2014-04-30','08:15:00',6.64),('7643','2014-04-30','08:20:00',6.99),('7643','2014-04-30','08:25:00',7.35),('7643','2014-04-30','08:30:00',7.67),('7643','2014-04-30','08:35:00',8.06),('7643','2014-04-30','08:40:00',8.36),('7643','2014-04-30','08:45:00',8.74),('7643','2014-04-30','08:50:00',9.16),('7643','2014-04-30','08:55:00',10.59),('7643','2014-04-30','09:00:00',6.97),('7643','2014-04-30','09:05:00',7.14),('7643','2014-04-30','09:10:00',5.7),('7643','2014-04-30','09:15:00',8.03),('7643','2014-04-30','09:20:00',5.14),('7643','2014-04-30','09:25:00',11.21),('7643','2014-04-30','09:30:00',12.39),('7643','2014-04-30','09:35:00',12.75),('7643','2014-04-30','09:40:00',11.9),('7643','2014-04-30','09:45:00',9.82),('7643','2014-04-30','09:50:00',6.49),('7643','2014-04-30','09:55:00',8.46),('7643','2014-04-30','10:00:00',7.89),('7643','2014-04-30','10:05:00',6.3),('7643','2014-04-30','10:10:00',14.86),('7643','2014-04-30','10:15:00',8.72),('7643','2014-04-30','10:20:00',9.04),('7643','2014-04-30','10:25:00',11.06),('7643','2014-04-30','10:30:00',10.18),('7643','2014-04-30','10:35:00',9.81),('7643','2014-04-30','10:40:00',11.24),('7643','2014-04-30','10:45:00',13.62),('7643','2014-04-30','10:50:00',16.53),('7643','2014-04-30','10:55:00',16.1),('7643','2014-04-30','11:00:00',16.39),('7643','2014-04-30','11:05:00',8.43),('7643','2014-04-30','11:10:00',10.96),('7643','2014-04-30','11:15:00',9.16),('7643','2014-04-30','11:20:00',18.08),('7643','2014-04-30','11:25:00',7.95),('7643','2014-04-30','11:30:00',11.64),('7643','2014-04-30','11:35:00',18.4),('7643','2014-04-30','11:40:00',18.16),('7643','2014-04-30','11:45:00',10.75),('7643','2014-04-30','11:50:00',12.55),('7643','2014-04-30','11:55:00',18.62),('7643','2014-04-30','12:00:00',17.31),('7643','2014-04-30','12:05:00',12.13),('7643','2014-04-30','12:10:00',17.63),('7643','2014-04-30','12:15:00',16.66),('7643','2014-04-30','12:20:00',17.25),('7643','2014-04-30','12:25:00',6.85),('7643','2014-04-30','12:30:00',13.35),('7643','2014-04-30','12:35:00',18.74),('7643','2014-04-30','12:40:00',18.24),('7643','2014-04-30','12:45:00',18.21),('7643','2014-04-30','12:50:00',9.67),('7643','2014-04-30','12:55:00',12.81),('7643','2014-04-30','13:00:00',18.87),('7643','2014-04-30','13:05:00',18.07),('7643','2014-04-30','13:10:00',18.11),('7643','2014-04-30','13:15:00',17),('7643','2014-04-30','13:20:00',17.66),('7643','2014-04-30','13:25:00',12.88),('7643','2014-04-30','13:30:00',7.52),('7643','2014-04-30','13:35:00',19.33),('7643','2014-04-30','13:40:00',18.39),('7643','2014-04-30','13:45:00',18.5),('7643','2014-04-30','13:50:00',18.89),('7643','2014-04-30','13:55:00',18.47),('7643','2014-04-30','14:00:00',14.19),('7643','2014-04-30','14:05:00',18.39),('7643','2014-04-30','14:10:00',18.34),('7643','2014-04-30','14:15:00',17.83),('7643','2014-04-30','14:20:00',17.46),('7643','2014-04-30','14:25:00',17.92),('7643','2014-04-30','14:30:00',16.95),('7643','2014-04-30','14:35:00',16.61),('7643','2014-04-30','14:40:00',16.56),('7643','2014-04-30','14:45:00',18.02),('7643','2014-04-30','14:50:00',17.64),('7643','2014-04-30','14:55:00',17.13),('7643','2014-04-30','15:00:00',17.67),('7643','2014-04-30','15:05:00',16.72),('7643','2014-04-30','15:10:00',9.64),('7643','2014-04-30','15:15:00',14.63),('7643','2014-04-30','15:20:00',15.82),('7643','2014-04-30','15:25:00',15.64),('7643','2014-04-30','15:30:00',15.15),('7643','2014-04-30','15:35:00',14.92),('7643','2014-04-30','15:40:00',14.6),('7643','2014-04-30','15:45:00',13.98),('7643','2014-04-30','15:50:00',14.29),('7643','2014-04-30','15:55:00',13.78),('7643','2014-04-30','16:00:00',13.59),('7643','2014-04-30','16:05:00',13.55),('7643','2014-04-30','16:10:00',12.96),('7643','2014-04-30','16:15:00',12.77),('7643','2014-04-30','16:20:00',12.18),('7643','2014-04-30','16:25:00',11.03),('7643','2014-04-30','16:30:00',11.56),('7643','2014-04-30','16:35:00',11.62),('7643','2014-04-30','16:40:00',10.99),('7643','2014-04-30','16:45:00',9.23),('7643','2014-04-30','16:50:00',8.63),('7643','2014-04-30','16:55:00',9.05),('7643','2014-04-30','17:00:00',9.47),('7643','2014-04-30','17:05:00',8.97),('7643','2014-04-30','17:10:00',9.65),('7643','2014-04-30','17:15:00',9.03),('7643','2014-04-30','17:20:00',8.64),('7643','2014-04-30','17:25:00',8.16),('7643','2014-04-30','17:30:00',7.72),('7643','2014-04-30','17:35:00',7.39),('7643','2014-04-30','17:40:00',6.99),('7643','2014-04-30','17:45:00',6.63),('7643','2014-04-30','17:50:00',6.23),('7643','2014-04-30','17:55:00',6.09),('7643','2014-04-30','18:00:00',5.72),('7643','2014-04-30','18:05:00',5.36),('7643','2014-04-30','18:10:00',4.74),('7643','2014-04-30','18:15:00',4.24),('7643','2014-04-30','18:20:00',3.89),('7643','2014-04-30','18:25:00',3.68),('7643','2014-04-30','18:30:00',3.35),('7643','2014-04-30','18:35:00',2.95),('7643','2014-04-30','18:40:00',2.53),('7643','2014-04-30','18:45:00',2.18),('7643','2014-04-30','18:50:00',1.77),('7643','2014-04-30','18:55:00',1.53),('7643','2014-04-30','19:00:00',1.23),('7643','2014-04-30','19:05:00',1.01),('7643','2014-03-16','08:05:00',1.03),('7643','2014-03-16','08:10:00',1.16),('7643','2014-03-16','08:15:00',1.6),('7643','2014-03-16','08:20:00',1.78),('7643','2014-03-16','08:25:00',1.95),('7643','2014-03-16','08:30:00',2.24),('7643','2014-03-16','08:35:00',2.35),('7643','2014-03-16','08:40:00',2.62),('7643','2014-03-16','08:45:00',2.72),('7643','2014-03-16','08:50:00',2.81),('7643','2014-03-16','08:55:00',3.17),('7643','2014-03-16','09:00:00',3.22),('7643','2014-03-16','09:05:00',3.5),('7643','2014-03-16','09:10:00',3.8),('7643','2014-03-16','09:15:00',4.51),('7643','2014-03-16','09:20:00',5.01),('7643','2014-03-16','09:25:00',5.96),('7643','2014-03-16','09:30:00',7.4),('7643','2014-03-16','09:35:00',6.96),('7643','2014-03-16','09:40:00',5.19),('7643','2014-03-16','09:45:00',4.97),('7643','2014-03-16','09:50:00',6.78),('7643','2014-03-16','09:55:00',7.25),('7643','2014-03-16','10:00:00',7.62),('7643','2014-03-16','10:05:00',6.22),('7643','2014-03-16','10:10:00',7.46),('7643','2014-03-16','10:15:00',6.54),('7643','2014-03-16','10:20:00',8.49),('7643','2014-03-16','10:25:00',6.25),('7643','2014-03-16','10:30:00',5.33),('7643','2014-03-16','10:35:00',5.56),('7643','2014-03-16','10:40:00',5.29),('7643','2014-03-16','10:45:00',6.59),('7643','2014-03-16','10:50:00',5.62),('7643','2014-03-16','10:55:00',5.85),('7643','2014-03-16','11:00:00',5.7),('7643','2014-03-16','11:05:00',5.38),('7643','2014-03-16','11:10:00',7.21),('7643','2014-03-16','11:15:00',6.34),('7643','2014-03-16','11:20:00',4.91),('7643','2014-03-16','11:25:00',5.08),('7643','2014-03-16','11:30:00',6.25),('7643','2014-03-16','11:35:00',5.12),('7643','2014-03-16','11:40:00',4.66),('7643','2014-03-16','11:45:00',4.43),('7643','2014-03-16','11:50:00',8.46),('7643','2014-03-16','11:55:00',6.89),('7643','2014-03-16','12:00:00',7.85),('7643','2014-03-16','12:05:00',6.95),('7643','2014-03-16','12:10:00',6.75),('7643','2014-03-16','12:15:00',6.51),('7643','2014-03-16','12:20:00',7.28),('7643','2014-03-16','12:25:00',16.03),('7643','2014-03-16','12:30:00',8.68),('7643','2014-03-16','12:35:00',14.37),('7643','2014-03-16','12:40:00',8.27),('7643','2014-03-16','12:45:00',6.45),('7643','2014-03-16','12:50:00',10.39),('7643','2014-03-16','12:55:00',14.6),('7643','2014-03-16','13:00:00',16),('7643','2014-03-16','13:05:00',13.39),('7643','2014-03-16','13:10:00',12.54),('7643','2014-03-16','13:15:00',14.84),('7643','2014-03-16','13:20:00',14.91),('7643','2014-03-16','13:25:00',14.46),('7643','2014-03-16','13:30:00',7.52),('7643','2014-03-16','13:35:00',12.89),('7643','2014-03-16','13:40:00',14.86),('7643','2014-03-16','13:45:00',14.94),('7643','2014-03-16','13:50:00',13.61),('7643','2014-03-16','13:55:00',13.79),('7643','2014-03-16','14:00:00',12.91),('7643','2014-03-16','14:05:00',12.27),('7643','2014-03-16','14:10:00',7.79),('7643','2014-03-16','14:15:00',4.56),('7643','2014-03-16','14:20:00',7.75),('7643','2014-03-16','14:25:00',6.07),('7643','2014-03-16','14:30:00',12.38),('7643','2014-03-16','14:35:00',9.5),('7643','2014-03-16','14:40:00',10.02),('7643','2014-03-16','14:45:00',11.73),('7643','2014-03-16','14:50:00',12.06),('7643','2014-03-16','14:55:00',11.57),('7643','2014-03-16','15:00:00',11.03),('7643','2014-03-16','15:05:00',10.57),('7643','2014-03-16','15:10:00',10.5),('7643','2014-03-16','15:15:00',10.36),('7643','2014-03-16','15:20:00',4.66),('7643','2014-03-16','15:25:00',9.13),('7643','2014-03-16','15:30:00',9.26),('7643','2014-03-16','15:35:00',7.93),('7643','2014-03-16','15:40:00',8.33),('7643','2014-03-16','15:45:00',7.94),('7643','2014-03-16','15:50:00',7.14),('7643','2014-03-16','15:55:00',7.4),('7643','2014-03-16','16:00:00',7.07),('7643','2014-03-16','16:05:00',6.73),('7643','2014-03-16','16:10:00',6),('7643','2014-03-16','16:15:00',3.69),('7643','2014-03-16','16:20:00',5.97),('7643','2014-03-16','16:25:00',5.9),('7643','2014-03-16','16:30:00',5.32),('7643','2014-03-16','16:35:00',4.76),('7643','2014-03-16','16:40:00',4.34),('7643','2014-03-16','16:45:00',3.69),('7643','2014-03-16','16:50:00',3.47),('7643','2014-03-16','16:55:00',1.8),('7643','2014-03-16','17:00:00',1.89),('7643','2014-03-16','17:05:00',2.21),('7643','2014-03-16','17:10:00',1.89),('7643','2014-03-16','17:15:00',1.51),('7643','2014-03-16','17:20:00',1.34),('7643','2012-12-21','09:15:00',1.14),('7643','2012-12-21','09:20:00',1.55),('7643','2012-12-21','09:25:00',2.08),('7643','2012-12-21','09:30:00',2.62),('7643','2012-12-21','09:35:00',3.33),('7643','2012-12-21','09:40:00',2.82),('7643','2012-12-21','09:45:00',2.32),('7643','2012-12-21','09:50:00',2.41),('7643','2012-12-21','09:55:00',2.71),('7643','2012-12-21','10:00:00',2.69),('7643','2012-12-21','10:05:00',2.78),('7643','2012-12-21','10:10:00',2.97),('7643','2012-12-21','10:15:00',3.07),('7643','2012-12-21','10:20:00',3.57),('7643','2012-12-21','10:25:00',8.21),('7643','2012-12-21','10:30:00',9.12),('7643','2012-12-21','10:35:00',10.88),('7643','2012-12-21','10:40:00',10.59),('7643','2012-12-21','10:45:00',10.4),('7643','2012-12-21','10:50:00',10.31),('7643','2012-12-21','10:55:00',10.43),('7643','2012-12-21','11:00:00',4.25),('7643','2012-12-21','11:05:00',1.98),('7643','2012-12-21','11:10:00',1.77),('7643','2012-12-21','11:15:00',1.7),('7643','2012-12-21','11:20:00',2.31),('7643','2012-12-21','11:25:00',1.91),('7643','2012-12-21','11:30:00',2.51),('7643','2012-12-21','11:35:00',3.15),('7643','2012-12-21','11:40:00',4.32),('7643','2012-12-21','11:45:00',6.36),('7643','2012-12-21','11:50:00',10.25),('7643','2012-12-21','11:55:00',5.77),('7643','2012-12-21','12:00:00',9.17),('7643','2012-12-21','12:05:00',6.92),('7643','2012-12-21','12:10:00',3.16),('7643','2012-12-21','12:15:00',3.49),('7643','2012-12-21','12:20:00',2.48),('7643','2012-12-21','12:25:00',2.47),('7643','2012-12-21','12:30:00',2.55),('7643','2012-12-21','12:35:00',2.73),('7643','2012-12-21','12:40:00',3.16),('7643','2012-12-21','12:45:00',8.07),('7643','2012-12-21','12:50:00',9.54),('7643','2012-12-21','12:55:00',8.89),('7643','2012-12-21','13:00:00',9.96),('7643','2012-12-21','13:05:00',11.26),('7643','2012-12-21','13:10:00',11.43),('7643','2012-12-21','13:15:00',11.58),('7643','2012-12-21','13:20:00',11.76),('7643','2012-12-21','13:25:00',11.55),('7643','2012-12-21','13:30:00',10.69),('7643','2012-12-21','13:35:00',10.39),('7643','2012-12-21','13:40:00',9.59),('7643','2012-12-21','13:45:00',3.33),('7643','2012-12-21','13:50:00',2.97),('7643','2012-12-21','13:55:00',3.75),('7643','2012-12-21','14:00:00',3.47),('7643','2012-12-21','14:05:00',4.66),('7643','2012-12-21','14:10:00',4.68),('7643','2012-12-21','14:15:00',5.58),('7643','2012-12-21','14:20:00',7),('7643','2012-12-21','14:25:00',1.89),('7643','2012-12-21','14:30:00',1.49),('7643','2012-12-21','14:35:00',1.26),('7643','2012-12-21','14:40:00',1.17),('7643','2012-12-21','14:45:00',1.37),('7643','2012-12-21','14:50:00',1.79),('7643','2012-12-21','14:55:00',2.18),('7643','2012-12-21','15:00:00',3.01),('7643','2012-12-21','15:05:00',1.75),('7643','2012-12-21','15:10:00',1.49),('7643','2012-12-21','15:15:00',1.33),('7643','2012-12-21','15:20:00',1.09),('7643','2012-12-21','15:35:00',1.19),('7643','2012-12-21','15:40:00',1.27),('7643','2012-12-21','15:45:00',1.58),('7643','2012-12-21','15:50:00',1.14),('7643','2012-12-21','15:55:00',1.65),('7643','2012-12-21','16:00:00',1.21),('7643','2012-12-21','16:05:00',1.15),('7643','2014-03-15','07:00:00',1.16),('7643','2014-03-15','07:05:00',1.42),('7643','2014-03-15','07:10:00',1.67),('7643','2014-03-15','07:15:00',1.98),('7643','2014-03-15','07:20:00',2.26),('7643','2014-03-15','07:25:00',2.51),('7643','2014-03-15','07:30:00',2.74),('7643','2014-03-15','07:35:00',3.02),('7643','2014-03-15','07:40:00',3.12),('7643','2014-03-15','07:45:00',3.44),('7643','2014-03-15','07:50:00',3.8),('7643','2014-03-15','07:55:00',4.37),('7643','2014-03-15','08:00:00',4.87),('7643','2014-03-15','08:05:00',5.21),('7643','2014-03-15','08:10:00',5.35),('7643','2014-03-15','08:15:00',5.58),('7643','2014-03-15','08:20:00',6.02),('7643','2014-03-15','08:25:00',6.37),('7643','2014-03-15','08:30:00',6.77),('7643','2014-03-15','08:35:00',7.07),('7643','2014-03-15','08:40:00',7.29),('7643','2014-03-15','08:45:00',7.7),('7643','2014-03-15','08:50:00',8.07),('7643','2014-03-15','08:55:00',8.16),('7643','2014-03-15','09:00:00',8.11),('7643','2014-03-15','09:05:00',8.43),('7643','2014-03-15','09:10:00',8.99),('7643','2014-03-15','09:15:00',9.64),('7643','2014-03-15','09:20:00',9.86),('7643','2014-03-15','09:25:00',9.81),('7643','2014-03-15','09:30:00',10.02),('7643','2014-03-15','09:35:00',10.09),('7643','2014-03-15','09:40:00',10.08),('7643','2014-03-15','09:45:00',10.71),('7643','2014-03-15','09:50:00',11.6),('7643','2014-03-15','09:55:00',11.33),('7643','2014-03-15','10:00:00',11.63),('7643','2014-03-15','10:05:00',11.44),('7643','2014-03-15','10:10:00',11.75),('7643','2014-03-15','10:15:00',12.22),('7643','2014-03-15','10:20:00',12.26),('7643','2014-03-15','10:25:00',12.22),('7643','2014-03-15','10:30:00',12.7),('7643','2014-03-15','10:45:00',13.28),('7643','2014-03-15','10:50:00',13.31),('7643','2014-03-15','13:55:00',12.86),('7643','2014-03-15','14:00:00',12.83),('7643','2014-03-15','14:05:00',12.33),('7643','2014-03-15','14:10:00',12.29),('7643','2014-03-15','14:15:00',11.85),('7643','2014-03-15','14:20:00',11.95),('7643','2014-03-15','14:25:00',11.71),('7643','2014-03-15','14:30:00',11.66),('7643','2014-03-15','14:35:00',11.35),('7643','2014-03-15','14:40:00',11.13),('7643','2014-03-15','14:45:00',10.76),('7643','2014-03-15','14:50:00',10.16),('7643','2014-03-15','14:55:00',10.06),('7643','2014-03-15','15:00:00',10.66),('7643','2014-03-15','15:05:00',10.03),('7643','2014-03-15','15:10:00',9.27),('7643','2014-03-15','15:15:00',8.65),('7643','2014-03-15','15:20:00',7.38),('7643','2014-03-15','15:25:00',8.15),('7643','2014-03-15','15:30:00',7.73),('7643','2014-03-15','15:35:00',7.03),('7643','2014-03-15','15:40:00',5.48),('7643','2014-03-15','15:45:00',5.55),('7643','2014-03-15','15:50:00',6.3),('7643','2014-03-15','15:55:00',5.85),('7643','2014-03-15','16:00:00',5.05),('7643','2014-03-15','16:05:00',5.86),('7643','2014-03-15','16:10:00',6.16),('7643','2014-03-15','16:15:00',6.05),('7643','2014-03-15','16:20:00',5.26),('7643','2014-03-15','16:25:00',5.43),('7643','2014-03-15','16:30:00',5.34),('7643','2014-03-15','16:35:00',4.79),('7643','2014-03-15','16:40:00',4.14),('7643','2014-03-15','16:45:00',3.69),('7643','2014-03-15','16:50:00',3.33),('7643','2014-03-15','16:55:00',2.75),('7643','2014-03-15','17:00:00',2.14),('7643','2014-03-15','17:05:00',2.02),('7643','2014-03-15','17:10:00',1.78),('7643','2014-03-15','17:15:00',1.33),('7643','2014-03-15','17:20:00',1.12),('7643','2014-03-15','17:25:00',1.03),('7643','2014-03-14','07:05:00',1.19),('7643','2014-03-14','07:10:00',1.42),('7643','2014-03-14','07:15:00',1.67),('7643','2014-03-14','07:20:00',1.92),('7643','2014-03-14','07:25:00',2.19),('7643','2014-03-14','07:30:00',2.49),('7643','2014-03-14','07:35:00',2.78),('7643','2014-03-14','07:40:00',3.07),('7643','2014-03-14','07:45:00',3.38),('7643','2014-03-14','07:50:00',3.72),('7643','2014-03-14','07:55:00',4.06),('7643','2014-03-14','08:00:00',4.45),('7643','2014-03-14','08:05:00',4.79),('7643','2014-03-14','08:10:00',5.11),('7643','2014-03-14','08:15:00',5.5),('7643','2014-03-14','08:20:00',5.83),('7643','2014-03-14','08:25:00',6.16),('7643','2014-03-14','08:30:00',6.49),('7643','2014-03-14','08:35:00',6.86),('7643','2014-03-14','08:40:00',7.18),('7643','2014-03-14','08:45:00',7.47),('7643','2014-03-14','08:50:00',7.78),('7643','2014-03-14','08:55:00',8.07),('7643','2014-03-14','09:00:00',8.4),('7643','2014-03-14','09:05:00',8.65),('7643','2014-03-14','09:10:00',9.02),('7643','2014-03-14','09:15:00',9.34),('7643','2014-03-14','09:20:00',9.62),('7643','2014-03-14','09:25:00',9.79),('7643','2014-03-14','09:30:00',10.04),('7643','2014-03-14','09:35:00',10.32),('7643','2014-03-14','09:40:00',10.52),('7643','2014-03-14','09:45:00',10.59),('7643','2014-03-14','09:50:00',10.78),('7643','2014-03-14','09:55:00',10.95),('7643','2014-03-14','10:00:00',11.17),('7643','2014-03-14','10:05:00',11.2),('7643','2014-03-14','10:10:00',11.45),('7643','2014-03-14','10:15:00',11.66),('7643','2014-03-14','10:20:00',11.68),('7643','2014-03-14','10:25:00',11.93),('7643','2014-03-14','10:30:00',12.26),('7643','2014-03-14','10:35:00',12.4),('7643','2014-03-14','10:40:00',12.59),('7643','2014-03-14','10:45:00',12.46),('7643','2014-03-14','10:50:00',13),('7643','2014-03-14','10:55:00',12.8),('7643','2014-03-14','11:00:00',12.74),('7643','2014-03-14','11:05:00',13.03),('7643','2014-03-14','11:10:00',13.27),('7643','2014-03-14','11:15:00',13.22),('7643','2014-03-14','11:20:00',13.64),('7643','2014-03-14','11:25:00',13.79),('7643','2014-03-14','11:30:00',14.1),('7643','2014-03-14','11:35:00',13.86),('7643','2014-03-14','11:40:00',13.91),('7643','2014-03-14','11:45:00',14.07),('7643','2014-03-14','11:50:00',14.15),('7643','2014-03-14','11:55:00',13.8),('7643','2014-03-14','12:00:00',13.97),('7643','2014-03-14','12:05:00',13.94),('7643','2014-03-14','12:10:00',13.96),('7643','2014-03-14','12:15:00',14.22),('7643','2014-03-14','12:20:00',14.19),('7643','2014-03-14','12:25:00',14.27),('7643','2014-03-14','12:30:00',14.45),('7643','2014-03-14','12:35:00',14.54),('7643','2014-03-14','12:40:00',14.46),('7643','2014-03-14','12:45:00',14.32),('7643','2014-03-14','12:50:00',14.3),('7643','2014-03-14','12:55:00',14.42),('7643','2014-03-14','13:00:00',14.27),('7643','2014-03-14','13:05:00',14.27),('7643','2014-03-14','13:10:00',14.31),('7643','2014-03-14','13:15:00',14.18),('7643','2014-03-14','13:20:00',14.12),('7643','2014-03-14','13:25:00',13.92),('7643','2014-03-14','13:30:00',13.89),('7643','2014-03-14','13:35:00',13.92),('7643','2014-03-14','13:40:00',13.73),('7643','2014-03-14','13:45:00',13.61),('7643','2014-03-14','13:50:00',13.25),('7643','2014-03-14','13:55:00',13.34),('7643','2014-03-14','14:00:00',13.27),('7643','2014-03-14','14:05:00',13.16),('7643','2014-03-14','14:10:00',12.98),('7643','2014-03-14','14:15:00',12.77),('7643','2014-03-14','14:20:00',12.58),('7643','2014-03-14','14:25:00',12.37),('7643','2014-03-14','14:30:00',12.16),('7643','2014-03-14','14:35:00',11.92),('7643','2014-03-14','14:40:00',11.65),('7643','2014-03-14','14:45:00',11.34),('7643','2014-03-14','14:50:00',11.01),('7643','2014-03-14','14:55:00',10.84),('7643','2014-03-14','15:00:00',10.65),('7643','2014-03-14','15:05:00',10.4),('7643','2014-03-14','15:10:00',10.09),('7643','2014-03-14','15:15:00',9.76),('7643','2014-03-14','15:20:00',9.43),('7643','2014-03-14','15:25:00',9.17),('7643','2014-03-14','15:30:00',8.78),('7643','2014-03-14','15:35:00',8.48),('7643','2014-03-14','15:40:00',8.13),('7643','2014-03-14','15:45:00',7.86),('7643','2014-03-14','15:50:00',7.51),('7643','2014-03-14','15:55:00',7.15),('7643','2014-03-14','16:00:00',6.78),('7643','2014-03-14','16:05:00',6.18),('7643','2014-03-14','16:10:00',5.99),('7643','2014-03-14','16:15:00',5.55),('7643','2014-03-14','16:20:00',5.3),('7643','2014-03-14','16:25:00',4.81),('7643','2014-03-14','16:30:00',4.54),('7643','2014-03-14','16:35:00',4.03),('7643','2014-03-14','16:40:00',3.61),('7643','2014-03-14','16:45:00',3.43),('7643','2014-03-14','16:50:00',3.04),('7643','2014-03-14','16:55:00',2.77),('7643','2014-03-14','17:00:00',2.49),('7643','2014-03-14','17:05:00',2.18),('7643','2014-03-14','17:10:00',1.92),('7643','2014-03-14','17:15:00',1.66),('7643','2014-03-14','17:20:00',1.42),('7643','2014-03-14','17:25:00',1.19),('7643','2014-03-13','07:10:00',1.07),('7643','2014-03-13','07:15:00',1.19),('7643','2014-03-13','07:20:00',1.33),('7643','2014-03-13','07:25:00',1.49),('7643','2014-03-13','07:30:00',1.7),('7643','2014-03-13','07:35:00',1.93),('7643','2014-03-13','07:40:00',2.15),('7643','2014-03-13','07:45:00',2.38),('7643','2014-03-13','07:50:00',2.6),('7643','2014-03-13','07:55:00',2.82),('7643','2014-03-13','08:00:00',3.01),('7643','2014-03-13','08:05:00',3.24),('7643','2014-03-13','08:10:00',3.58),('7643','2014-03-13','08:15:00',4.11),('7643','2014-03-13','08:20:00',4.54),('7643','2014-03-13','08:25:00',4.8),('7643','2014-03-13','08:30:00',5.18),('7643','2014-03-13','08:35:00',5.19),('7643','2014-03-13','08:40:00',4.89),('7643','2014-03-13','08:45:00',4.18),('7643','2014-03-13','08:50:00',4.05),('7643','2014-03-13','08:55:00',4.25),('7643','2014-03-13','09:00:00',4.61),('7643','2014-03-13','09:05:00',5.27),('7643','2014-03-13','09:10:00',5.84),('7643','2014-03-13','09:15:00',5.87),('7643','2014-03-13','09:20:00',5.84),('7643','2014-03-13','09:25:00',6.29),('7643','2014-03-13','09:30:00',6.28),('7643','2014-03-13','09:35:00',7.65),('7643','2014-03-13','09:40:00',9.59),('7643','2014-03-13','09:45:00',11.15),('7643','2014-03-13','09:50:00',12.96),('7643','2014-03-13','09:55:00',13.38),('7643','2014-03-13','10:00:00',14.17),('7643','2014-03-13','10:05:00',13.87),('7643','2014-03-13','10:10:00',13.61),('7643','2014-03-13','10:15:00',13.18),('7643','2014-03-13','10:20:00',12.86),('7643','2014-03-13','10:25:00',12.46),('7643','2014-03-13','10:30:00',12.45),('7643','2014-03-13','10:35:00',13.15),('7643','2014-03-13','10:40:00',13.34),('7643','2014-03-13','10:45:00',11.7),('7643','2014-03-13','10:50:00',7.4),('7643','2014-03-13','10:55:00',10.85),('7643','2014-03-13','11:00:00',13.11),('7643','2014-03-13','11:05:00',13.82),('7643','2014-03-13','11:10:00',14.94),('7643','2014-03-13','11:15:00',14.91),('7643','2014-03-13','11:20:00',14.51),('7643','2014-03-13','11:25:00',14.24),('7643','2014-03-13','11:30:00',14.38),('7643','2014-03-13','11:35:00',14.48),('7643','2014-03-13','11:40:00',14.33),('7643','2014-03-13','11:45:00',14.93),('7643','2014-03-13','11:50:00',15.09),('7643','2014-03-13','11:55:00',15.09),('7643','2014-03-13','12:00:00',15.13),('7643','2014-03-13','12:05:00',15.07),('7643','2014-03-13','12:10:00',14.27),('7643','2014-03-13','12:15:00',13.11),('7643','2014-03-13','12:20:00',10.54),('7643','2014-03-13','12:25:00',9.39),('7643','2014-03-13','12:30:00',8.69),('7643','2014-03-13','12:35:00',7.53),('7643','2014-03-13','12:40:00',9.3),('7643','2014-03-13','12:45:00',10.31),('7643','2014-03-13','12:50:00',12.45),('7643','2014-03-13','12:55:00',12.17),('7643','2014-03-13','13:00:00',8.49),('7643','2014-03-13','13:05:00',7.86),('7643','2014-03-13','13:10:00',9.33),('7643','2014-03-13','13:15:00',10.86),('7643','2014-03-13','13:20:00',11.02),('7643','2014-03-13','13:25:00',10.36),('7643','2014-03-13','13:30:00',9.45),('7643','2014-03-13','13:35:00',8.42),('7643','2014-03-13','13:40:00',7.97),('7643','2014-03-13','13:45:00',8.21),('7643','2014-03-13','13:50:00',7.9),('7643','2014-03-13','13:55:00',8.2),('7643','2014-03-13','14:00:00',9.55),('7643','2014-03-13','14:05:00',10.65),('7643','2014-03-13','14:10:00',10.34),('7643','2014-03-13','14:15:00',10.74),('7643','2014-03-13','14:20:00',11.39),('7643','2014-03-13','14:25:00',11.01),('7643','2014-03-13','14:30:00',10.08),('7643','2014-03-13','14:35:00',9.35),('7643','2014-03-13','14:40:00',7.66),('7643','2014-03-13','14:45:00',6.19),('7643','2014-03-13','14:50:00',5.51),('7643','2014-03-13','14:55:00',5.11),('7643','2014-03-13','15:00:00',4.72),('7643','2014-03-13','15:05:00',4.69),('7643','2014-03-13','15:10:00',4.52),('7643','2014-03-13','15:15:00',4.58),('7643','2014-03-13','15:20:00',4.97),('7643','2014-03-13','15:25:00',5.26),('7643','2014-03-13','15:30:00',5.85),('7643','2014-03-13','15:35:00',6.11),('7643','2014-03-13','15:40:00',5.47),('7643','2014-03-13','15:45:00',4.76),('7643','2014-03-13','15:50:00',4.32),('7643','2014-03-13','15:55:00',4.42),('7643','2014-03-13','16:00:00',4.1),('7643','2014-03-13','16:05:00',3.96),('7643','2014-03-13','16:10:00',3.51),('7643','2014-03-13','16:15:00',2.9),('7643','2014-03-13','16:20:00',2.57),('7643','2014-03-13','16:25:00',2.37),('7643','2014-03-13','16:30:00',2.27),('7643','2014-03-13','16:35:00',2.11),('7643','2014-03-13','16:40:00',1.98),('7643','2014-03-13','16:45:00',1.87),('7643','2014-03-13','16:50:00',1.77),('7643','2014-03-13','16:55:00',1.73),('7643','2014-03-13','17:00:00',1.66),('7643','2014-03-13','17:05:00',1.48),('7643','2014-03-13','17:10:00',1.34),('7643','2014-03-13','17:15:00',1.16),('7643','2014-03-12','07:00:00',1.06),('7643','2014-03-12','07:05:00',1.32),('7643','2014-03-12','07:10:00',1.61),('7643','2014-03-12','07:15:00',1.93),('7643','2014-03-12','07:20:00',2.27),('7643','2014-03-12','07:25:00',2.62),('7643','2014-03-12','07:30:00',2.96),('7643','2014-03-12','07:35:00',3.3),('7643','2014-03-12','07:40:00',3.65),('7643','2014-03-12','07:45:00',4.02),('7643','2014-03-12','07:50:00',4.4),('7643','2014-03-12','07:55:00',4.79),('7643','2014-03-12','08:00:00',5.16),('7643','2014-03-12','08:05:00',5.52),('7643','2014-03-12','08:10:00',5.89),('7643','2014-03-12','08:15:00',6.24),('7643','2014-03-12','08:20:00',6.57),('7643','2014-03-12','08:25:00',6.92),('7643','2014-03-12','08:30:00',7.19),('7643','2014-03-12','08:35:00',7.53),('7643','2014-03-12','08:40:00',7.87),('7643','2014-03-12','08:45:00',8.16),('7643','2014-03-12','08:50:00',8.45),('7643','2014-03-12','08:55:00',8.75),('7643','2014-03-12','09:00:00',9.08),('7643','2014-03-12','09:05:00',9.35),('7643','2014-03-12','09:10:00',9.63),('7643','2014-03-12','09:15:00',9.87),('7643','2014-03-12','09:20:00',10.11),('7643','2014-03-12','09:25:00',10.35),('7643','2014-03-12','09:30:00',10.6),('7643','2014-03-12','09:35:00',10.84),('7643','2014-03-12','09:40:00',11.11),('7643','2014-03-12','09:45:00',11.35),('7643','2014-03-12','09:50:00',11.54),('7643','2014-03-12','09:55:00',11.79),('7643','2014-03-12','10:00:00',12.01),('7643','2014-03-12','10:05:00',12.17),('7643','2014-03-12','10:10:00',12.34),('7643','2014-03-12','10:15:00',12.55),('7643','2014-03-12','10:20:00',12.65),('7643','2014-03-12','10:25:00',12.73),('7643','2014-03-12','10:30:00',12.93),('7643','2014-03-12','10:35:00',13.05),('7643','2014-03-12','10:40:00',13.12),('7643','2014-03-12','10:45:00',13.25),('7643','2014-03-12','10:50:00',13.31),('7643','2014-03-12','10:55:00',13.46),('7643','2014-03-12','11:00:00',13.51),('7643','2014-03-12','11:05:00',13.57),('7643','2014-03-12','11:10:00',13.71),('7643','2014-03-12','11:15:00',13.73),('7643','2014-03-12','11:20:00',13.88),('7643','2014-03-12','11:25:00',13.88),('7643','2014-03-12','11:30:00',13.88),('7643','2014-03-12','11:35:00',13.96),('7643','2014-03-12','11:40:00',13.97),('7643','2014-03-12','11:45:00',14.1),('7643','2014-03-12','11:50:00',14.14),('7643','2014-03-12','11:55:00',14.24),('7643','2014-03-12','12:00:00',14.3),('7643','2014-03-12','12:05:00',14.1),('7643','2014-03-12','12:10:00',13.96),('7643','2014-03-12','12:15:00',13.96),('7643','2014-03-12','12:20:00',13.96),('7643','2014-03-12','12:25:00',14.06),('7643','2014-03-12','12:30:00',14.08),('7643','2014-03-12','12:35:00',14.08),('7643','2014-03-12','12:40:00',13.98),('7643','2014-03-12','12:45:00',13.86),('7643','2014-03-12','12:50:00',13.78),('7643','2014-03-12','12:55:00',13.75),('7643','2014-03-12','13:00:00',13.61),('7643','2014-03-12','13:05:00',13.44),('7643','2014-03-12','13:10:00',13.22),('7643','2014-03-12','13:15:00',13.09),('7643','2014-03-12','13:20:00',13.16),('7643','2014-03-12','13:25:00',13.22),('7643','2014-03-12','13:30:00',13.19),('7643','2014-03-12','13:35:00',13.04),('7643','2014-03-12','13:40:00',12.9),('7643','2014-03-12','13:45:00',12.74),('7643','2014-03-12','13:50:00',12.54),('7643','2014-03-12','13:55:00',12.34),('7643','2014-03-12','14:00:00',12.22),('7643','2014-03-12','14:05:00',12.03),('7643','2014-03-12','14:10:00',11.91),('7643','2014-03-12','14:15:00',11.74),('7643','2014-03-12','14:20:00',11.6),('7643','2014-03-12','14:25:00',11.37),('7643','2014-03-12','14:30:00',11.15),('7643','2014-03-12','14:35:00',10.96),('7643','2014-03-12','14:40:00',10.73),('7643','2014-03-12','14:45:00',10.42),('7643','2014-03-12','14:50:00',10.25),('7643','2014-03-12','14:55:00',10),('7643','2014-03-12','15:00:00',9.73),('7643','2014-03-12','15:05:00',9.49),('7643','2014-03-12','15:10:00',9.24),('7643','2014-03-12','15:15:00',8.95),('7643','2014-03-12','15:20:00',8.72),('7643','2014-03-12','15:25:00',8.43),('7643','2014-03-12','15:30:00',8.16),('7643','2014-03-12','15:35:00',7.75),('7643','2014-03-12','15:40:00',7.18),('7643','2014-03-12','15:45:00',6.88),('7643','2014-03-12','15:50:00',6.61),('7643','2014-03-12','15:55:00',6.32),('7643','2014-03-12','16:00:00',6),('7643','2014-03-12','16:05:00',5.84),('7643','2014-03-12','16:10:00',5.49),('7643','2014-03-12','16:15:00',5.15),('7643','2014-03-12','16:20:00',4.86),('7643','2014-03-12','16:25:00',4.63),('7643','2014-03-12','16:30:00',4.36),('7643','2014-03-12','16:35:00',4.08),('7643','2014-03-12','16:40:00',3.77),('7643','2014-03-12','16:45:00',3.4),('7643','2014-03-12','16:50:00',3.1),('7643','2014-03-12','16:55:00',2.8),('7643','2014-03-12','17:00:00',2.44),('7643','2014-03-12','17:05:00',2.03),('7643','2014-03-12','17:10:00',1.57),('7643','2014-03-12','17:15:00',1.31),('7643','2014-03-12','17:20:00',1.06),('7643','2014-03-11','07:05:00',1.2),('7643','2014-03-11','07:10:00',1.48),('7643','2014-03-11','07:15:00',1.8),('7643','2014-03-11','07:20:00',2.11),('7643','2014-03-11','07:25:00',2.47),('7643','2014-03-11','07:30:00',2.82),('7643','2014-03-11','07:35:00',3.18),('7643','2014-03-11','07:40:00',3.54),('7643','2014-03-11','07:45:00',3.91),('7643','2014-03-11','07:50:00',4.26),('7643','2014-03-11','07:55:00',4.61),('7643','2014-03-11','08:00:00',4.97),('7643','2014-03-11','08:05:00',5.34),('7643','2014-03-11','08:10:00',5.71),('7643','2014-03-11','08:15:00',6.06),('7643','2014-03-11','08:20:00',6.39),('7643','2014-03-11','08:25:00',6.75),('7643','2014-03-11','08:30:00',7.07),('7643','2014-03-11','08:35:00',7.41),('7643','2014-03-11','08:40:00',7.76),('7643','2014-03-11','08:45:00',8.07),('7643','2014-03-11','08:50:00',8.38),('7643','2014-03-11','08:55:00',8.68),('7643','2014-03-11','09:00:00',8.97),('7643','2014-03-11','09:05:00',9.24),('7643','2014-03-11','09:10:00',9.54),('7643','2014-03-11','09:15:00',9.82),('7643','2014-03-11','09:20:00',10.11),('7643','2014-03-11','09:25:00',10.34),('7643','2014-03-11','09:30:00',10.57),('7643','2014-03-11','09:35:00',10.79),('7643','2014-03-11','09:40:00',11.02),('7643','2014-03-11','09:45:00',11.31),('7643','2014-03-11','09:50:00',11.48),('7643','2014-03-11','09:55:00',11.7),('7643','2014-03-11','10:00:00',11.98),('7643','2014-03-11','10:05:00',12.12),('7643','2014-03-11','10:10:00',12.33),('7643','2014-03-11','10:15:00',12.53),('7643','2014-03-11','10:20:00',12.66),('7643','2014-03-11','10:25:00',12.8),('7643','2014-03-11','10:30:00',12.98),('7643','2014-03-11','10:35:00',13.2),('7643','2014-03-11','10:40:00',13.38),('7643','2014-03-11','10:45:00',13.57),('7643','2014-03-11','10:50:00',13.69),('7643','2014-03-11','10:55:00',13.79),('7643','2014-03-11','11:00:00',13.93),('7643','2014-03-11','11:05:00',14.15),('7643','2014-03-11','11:10:00',14.28),('7643','2014-03-11','11:15:00',14.35),('7643','2014-03-11','11:20:00',14.48),('7643','2014-03-11','11:25:00',14.54),('7643','2014-03-11','11:30:00',14.6),('7643','2014-03-11','11:35:00',14.68),('7643','2014-03-11','11:40:00',14.73),('7643','2014-03-11','11:45:00',14.73),('7643','2014-03-11','11:50:00',14.75),('7643','2014-03-11','11:55:00',14.78),('7643','2014-03-11','12:00:00',14.74),('7643','2014-03-11','12:05:00',14.73),('7643','2014-03-11','12:10:00',14.7),('7643','2014-03-11','12:15:00',14.63),('7643','2014-03-11','12:20:00',14.59),('7643','2014-03-11','12:25:00',14.63),('7643','2014-03-11','12:30:00',14.57),('7643','2014-03-11','12:35:00',14.54),('7643','2014-03-11','12:40:00',14.37),('7643','2014-03-11','12:45:00',14.39),('7643','2014-03-11','12:50:00',14.29),('7643','2014-03-11','12:55:00',14.17),('7643','2014-03-11','13:00:00',14.15),('7643','2014-03-11','13:05:00',13.96),('7643','2014-03-11','13:10:00',13.87),('7643','2014-03-11','13:15:00',13.86),('7643','2014-03-11','13:20:00',13.72),('7643','2014-03-11','13:25:00',13.65),('7643','2014-03-11','13:30:00',13.44),('7643','2014-03-11','13:35:00',13.35),('7643','2014-03-11','13:40:00',13.22),('7643','2014-03-11','13:45:00',13.02),('7643','2014-03-11','13:50:00',13),('7643','2014-03-11','13:55:00',12.79),('7643','2014-03-11','14:00:00',12.64),('7643','2014-03-11','14:05:00',12.64),('7643','2014-03-11','14:10:00',12.3),('7643','2014-03-11','14:15:00',12.17),('7643','2014-03-11','14:20:00',11.97),('7643','2014-03-11','14:25:00',11.71),('7643','2014-03-11','14:30:00',11.55),('7643','2014-03-11','14:35:00',11.12),('7643','2014-03-11','14:40:00',10.82),('7643','2014-03-11','14:45:00',10.51),('7643','2014-03-11','14:50:00',10.34),('7643','2014-03-11','14:55:00',9.85),('7643','2014-03-11','15:00:00',9.52),('7643','2014-03-11','15:05:00',9.42),('7643','2014-03-11','15:10:00',9.18),('7643','2014-03-11','15:15:00',8.9),('7643','2014-03-11','15:20:00',8.7),('7643','2014-03-11','15:25:00',8.38),('7643','2014-03-11','15:30:00',7.94),('7643','2014-03-11','15:35:00',7.66),('7643','2014-03-11','15:40:00',7.47),('7643','2014-03-11','15:45:00',7.19),('7643','2014-03-11','15:50:00',6.95),('7643','2014-03-11','15:55:00',6.68),('7643','2014-03-11','16:00:00',6.45),('7643','2014-03-11','16:05:00',6),('7643','2014-03-11','16:10:00',5.65),('7643','2014-03-11','16:15:00',5.35),('7643','2014-03-11','16:20:00',5.03),('7643','2014-03-11','16:25:00',4.63),('7643','2014-03-11','16:30:00',4.28),('7643','2014-03-11','16:35:00',4),('7643','2014-03-11','16:40:00',3.68),('7643','2014-03-11','16:45:00',3.32),('7643','2014-03-11','16:50:00',2.96),('7643','2014-03-11','16:55:00',2.63),('7643','2014-03-11','17:00:00',2.32),('7643','2014-03-11','17:05:00',1.99),('7643','2014-03-11','17:10:00',1.72),('7643','2014-03-11','17:15:00',1.47),('7643','2014-03-11','17:20:00',1.22),('7643','2014-03-10','07:25:00',1.25),('7643','2014-03-10','07:30:00',1.34),('7643','2014-03-10','07:35:00',1.43),('7643','2014-03-10','07:40:00',1.71),('7643','2014-03-10','07:45:00',1.97),('7643','2014-03-10','07:50:00',1.94),('7643','2014-03-10','07:55:00',2.02),('7643','2014-03-10','08:00:00',2.08),('7643','2014-03-10','08:05:00',1.67),('7643','2014-03-10','08:10:00',1.35),('7643','2014-03-10','08:15:00',1.5),('7643','2014-03-10','08:20:00',1.67),('7643','2014-03-10','08:25:00',1.55),('7643','2014-03-10','08:30:00',1.6),('7643','2014-03-10','08:35:00',1.37),('7643','2014-03-10','08:40:00',1.12),('7643','2014-03-10','08:45:00',1.26),('7643','2014-03-10','08:50:00',1.51),('7643','2014-03-10','08:55:00',1.62),('7643','2014-03-10','09:00:00',1.61),('7643','2014-03-10','09:05:00',1.54),('7643','2014-03-10','09:10:00',1.54),('7643','2014-03-10','09:15:00',1.48),('7643','2014-03-10','09:20:00',1.4),('7643','2014-03-10','09:25:00',1.33),('7643','2014-03-10','09:30:00',1.33),('7643','2014-03-10','09:35:00',1.3),('7643','2014-03-10','09:40:00',1.26),('7643','2014-03-10','09:45:00',1.2),('7643','2014-03-10','09:50:00',1.26),('7643','2014-03-10','09:55:00',1.37),('7643','2014-03-10','10:00:00',1.44),('7643','2014-03-10','10:05:00',1.71),('7643','2014-03-10','10:10:00',2.03),('7643','2014-03-10','10:15:00',2.52),('7643','2014-03-10','10:20:00',3.08),('7643','2014-03-10','10:25:00',3.14),('7643','2014-03-10','10:30:00',3.23),('7643','2014-03-10','10:35:00',3.31),('7643','2014-03-10','10:40:00',3.25),('7643','2014-03-10','10:45:00',3.02),('7643','2014-03-10','10:50:00',2.68),('7643','2014-03-10','10:55:00',2.84),('7643','2014-03-10','11:00:00',3.29),('7643','2014-03-10','11:05:00',3.39),('7643','2014-03-10','11:10:00',3.44),('7643','2014-03-10','11:15:00',3.54),('7643','2014-03-10','11:20:00',3.21),('7643','2014-03-10','11:25:00',3.24),('7643','2014-03-10','11:30:00',3.25),('7643','2014-03-10','11:35:00',3.6),('7643','2014-03-10','11:40:00',3.81),('7643','2014-03-10','11:45:00',3.82),('7643','2014-03-10','11:50:00',3.27),('7643','2014-03-10','11:55:00',3.55),('7643','2014-03-10','12:00:00',3.74),('7643','2014-03-10','12:05:00',3.79),('7643','2014-03-10','12:10:00',4),('7643','2014-03-10','12:15:00',4.44),('7643','2014-03-10','12:20:00',4.78),('7643','2014-03-10','12:25:00',4.34),('7643','2014-03-10','12:30:00',4.13),('7643','2014-03-10','12:35:00',4.37),('7643','2014-03-10','12:40:00',4.72),('7643','2014-03-10','12:45:00',4.53),('7643','2014-03-10','12:50:00',4.46),('7643','2014-03-10','12:55:00',4.18),('7643','2014-03-10','13:00:00',3.77),('7643','2014-03-10','13:05:00',4.41),('7643','2014-03-10','13:10:00',4.61),('7643','2014-03-10','13:15:00',4.51),('7643','2014-03-10','13:20:00',4.55),('7643','2014-03-10','13:25:00',3.88),('7643','2014-03-10','13:30:00',3.81),('7643','2014-03-10','13:35:00',3.6),('7643','2014-03-10','13:40:00',3.73),('7643','2014-03-10','13:45:00',4.83),('7643','2014-03-10','13:50:00',5.81),('7643','2014-03-10','13:55:00',6.89),('7643','2014-03-10','14:00:00',6.94),('7643','2014-03-10','14:05:00',7.32),('7643','2014-03-10','14:10:00',8.97),('7643','2014-03-10','14:15:00',9.61),('7643','2014-03-10','14:20:00',7.56),('7643','2014-03-10','14:25:00',6.9),('7643','2014-03-10','14:30:00',4.76),('7643','2014-03-10','14:35:00',4.91),('7643','2014-03-10','14:40:00',4.84),('7643','2014-03-10','14:45:00',4.98),('7643','2014-03-10','14:50:00',4.61),('7643','2014-03-10','14:55:00',4.72),('7643','2014-03-10','15:00:00',5.56),('7643','2014-03-10','15:05:00',6.22),('7643','2014-03-10','15:10:00',6.54),('7643','2014-03-10','15:15:00',5.41),('7643','2014-03-10','15:20:00',5.07),('7643','2014-03-10','15:25:00',4.56),('7643','2014-03-10','15:30:00',4.39),('7643','2014-03-10','15:35:00',3.94),('7643','2014-03-10','15:40:00',3.93),('7643','2014-03-10','15:45:00',3.71),('7643','2014-03-10','15:50:00',3.73),('7643','2014-03-10','15:55:00',3.13),('7643','2014-03-10','16:00:00',2.83),('7643','2014-03-10','16:05:00',2.82),('7643','2014-03-10','16:10:00',2.89),('7643','2014-03-10','16:15:00',2.75),('7643','2014-03-10','16:20:00',2.71),('7643','2014-03-10','16:25:00',2.38),('7643','2014-03-10','16:30:00',2.16),('7643','2014-03-10','16:35:00',1.9),('7643','2014-03-10','16:40:00',1.72),('7643','2014-03-10','16:45:00',1.49),('7643','2014-03-10','16:50:00',1.27),('7643','2014-03-10','16:55:00',1.04),('7643','2014-03-09','07:55:00',1.01),('7643','2014-03-09','08:00:00',1.26),('7643','2014-03-09','08:05:00',1.58),('7643','2014-03-09','08:10:00',1.83),('7643','2014-03-09','08:15:00',2.02),('7643','2014-03-09','08:20:00',2.17),('7643','2014-03-09','08:25:00',2.37),('7643','2014-03-09','08:30:00',2.6),('7643','2014-03-09','08:35:00',3.02),('7643','2014-03-09','08:40:00',3.26),('7643','2014-03-09','08:45:00',3.21),('7643','2014-03-09','08:50:00',3.33),('7643','2014-03-09','08:55:00',3.33),('7643','2014-03-09','09:00:00',3.44),('7643','2014-03-09','09:05:00',3.77),('7643','2014-03-09','09:10:00',3.86),('7643','2014-03-09','09:15:00',3.48),('7643','2014-03-09','09:20:00',3.4),('7643','2014-03-09','09:25:00',3.46),('7643','2014-03-09','09:30:00',3.66),('7643','2014-03-09','09:35:00',3.5),('7643','2014-03-09','09:40:00',3.57),('7643','2014-03-09','09:45:00',3.28),('7643','2014-03-09','09:50:00',2.88),('7643','2014-03-09','09:55:00',2.76),('7643','2014-03-09','10:00:00',2.47),('7643','2014-03-09','10:05:00',2.66),('7643','2014-03-09','10:10:00',3.41),('7643','2014-03-09','10:15:00',4),('7643','2014-03-09','10:20:00',3.35),('7643','2014-03-09','10:25:00',3.23),('7643','2014-03-09','10:30:00',3.96),('7643','2014-03-09','10:35:00',4.49),('7643','2014-03-09','10:40:00',3.13),('7643','2014-03-09','10:45:00',1.98),('7643','2014-03-09','10:50:00',1.32),('7643','2014-03-09','10:55:00',1.29),('7643','2014-03-09','11:00:00',1.45),('7643','2014-03-09','11:05:00',1.95),('7643','2014-03-09','11:10:00',2.58),('7643','2014-03-09','11:15:00',3.15),('7643','2014-03-09','11:20:00',3.52),('7643','2014-03-09','11:25:00',3.24),('7643','2014-03-09','11:30:00',2.8),('7643','2014-03-09','11:35:00',1.84),('7643','2014-03-09','11:40:00',1.33),('7643','2014-03-09','11:45:00',1.27),('7643','2014-03-09','11:50:00',1.34),('7643','2014-03-09','11:55:00',1.28),('7643','2014-03-09','12:00:00',1.34),('7643','2014-03-09','12:05:00',1.62),('7643','2014-03-09','12:10:00',1.75),('7643','2014-03-09','12:15:00',1.87),('7643','2014-03-09','12:20:00',2.03),('7643','2014-03-09','12:25:00',2.18),('7643','2014-03-09','12:30:00',2.47),('7643','2014-03-09','12:35:00',2.83),('7643','2014-03-09','12:40:00',3.2),('7643','2014-03-09','12:45:00',3.68),('7643','2014-03-09','12:50:00',4.08),('7643','2014-03-09','12:55:00',4.37),('7643','2014-03-09','13:00:00',4.61),('7643','2014-03-09','13:05:00',4.76),('7643','2014-03-09','13:10:00',5.51),('7643','2014-03-09','13:15:00',6.43),('7643','2014-03-09','13:20:00',5.84),('7643','2014-03-09','13:25:00',5.24),('7643','2014-03-09','13:30:00',4.43),('7643','2014-03-09','13:35:00',3.7),('7643','2014-03-09','13:40:00',3.31),('7643','2014-03-09','13:45:00',3.08),('7643','2014-03-09','13:50:00',4.44),('7643','2014-03-09','13:55:00',3.71),('7643','2014-03-09','14:00:00',3.78),('7643','2014-03-09','14:05:00',5.53),('7643','2014-03-09','14:10:00',6.47),('7643','2014-03-09','14:15:00',9.5),('7643','2014-03-09','14:20:00',6.1),('7643','2014-03-09','14:25:00',5.74),('7643','2014-03-09','14:30:00',4.86),('7643','2014-03-09','14:35:00',8.89),('7643','2014-03-09','14:40:00',10.47),('7643','2014-03-09','14:45:00',7.8),('7643','2014-03-09','14:50:00',8.05),('7643','2014-03-09','14:55:00',5.6),('7643','2014-03-09','15:00:00',5.82),('7643','2014-03-09','15:05:00',4.19),('7643','2014-03-09','15:10:00',3.55),('7643','2014-03-09','15:15:00',4.24),('7643','2014-03-09','15:20:00',8.3),('7643','2014-03-09','15:25:00',7.79),('7643','2014-03-09','15:30:00',4.95),('7643','2014-03-09','15:35:00',4.22),('7643','2014-03-09','15:40:00',4.31),('7643','2014-03-09','15:45:00',3.64),('7643','2014-03-09','15:50:00',3.3),('7643','2014-03-09','15:55:00',3.19),('7643','2014-03-09','16:00:00',3.5),('7643','2014-03-09','16:05:00',3.66),('7643','2014-03-09','16:10:00',2.93),('7643','2014-03-09','16:15:00',2.66),('7643','2014-03-09','16:20:00',2.78),('7643','2014-03-09','16:25:00',3.33),('7643','2014-03-09','16:30:00',3.56),('7643','2014-03-09','16:35:00',2.31),('7643','2014-03-09','16:40:00',1.85),('7643','2014-03-09','16:45:00',1.44),('7643','2014-03-09','16:50:00',1.85),('7643','2014-03-09','16:55:00',2.83),('7643','2014-03-09','17:00:00',2.23),('7643','2014-03-09','17:05:00',1.43),('7643','2014-03-08','07:35:00',1.73),('7643','2014-03-08','07:40:00',2.51),('7643','2014-03-08','07:45:00',2.5),('7643','2014-03-08','07:50:00',3.86),('7643','2014-03-08','07:55:00',4.24),('7643','2014-03-08','08:00:00',4.63),('7643','2014-03-08','08:05:00',4.98),('7643','2014-03-08','08:10:00',5.37),('7643','2014-03-08','08:15:00',5.6),('7643','2014-03-08','08:20:00',4.28),('7643','2014-03-08','08:25:00',3.44),('7643','2014-03-08','08:30:00',4.25),('7643','2014-03-08','08:35:00',4.48),('7643','2014-03-08','08:40:00',4.79),('7643','2014-03-08','08:45:00',2.65),('7643','2014-03-08','08:50:00',4.55),('7643','2014-03-08','08:55:00',5.87),('7643','2014-03-08','09:00:00',7.16),('7643','2014-03-08','09:05:00',5.38),('7643','2014-03-08','09:10:00',2.04),('7643','2014-03-08','09:15:00',5.06),('7643','2014-03-08','09:20:00',10.13),('7643','2014-03-08','09:25:00',10.66),('7643','2014-03-08','09:30:00',7.89),('7643','2014-03-08','09:35:00',9.23),('7643','2014-03-08','09:40:00',11.92),('7643','2014-03-08','09:45:00',12.11),('7643','2014-03-08','09:50:00',12.25),('7643','2014-03-08','09:55:00',12.22),('7643','2014-03-08','10:00:00',12.33),('7643','2014-03-08','10:05:00',12.52),('7643','2014-03-08','10:10:00',12.83),('7643','2014-03-08','10:15:00',12.9),('7643','2014-03-08','10:20:00',12.89),('7643','2014-03-08','10:25:00',12.16),('7643','2014-03-08','10:30:00',13.45),('7643','2014-03-08','10:35:00',13.55),('7643','2014-03-08','10:40:00',13.73),('7643','2014-03-08','10:45:00',13.83),('7643','2014-03-08','10:50:00',14),('7643','2014-03-08','10:55:00',14.65),('7643','2014-03-08','11:00:00',14.04),('7643','2014-03-08','11:05:00',14.31),('7643','2014-03-08','11:10:00',16.07),('7643','2014-03-08','11:15:00',16.87),('7643','2014-03-08','11:20:00',14.6),('7643','2014-03-08','11:25:00',9.67),('7643','2014-03-08','11:30:00',7.36),('7643','2014-03-08','11:35:00',15.33),('7643','2014-03-08','11:40:00',7.71),('7643','2014-03-08','11:45:00',8.57),('7643','2014-03-08','11:50:00',12.37),('7643','2014-03-08','11:55:00',14.95),('7643','2014-03-08','12:00:00',14.09),('7643','2014-03-08','12:05:00',17.49),('7643','2014-03-08','12:10:00',17.26),('7643','2014-03-08','12:15:00',16.92),('7643','2014-03-08','12:20:00',16.69),('7643','2014-03-08','12:25:00',16.43),('7643','2014-03-08','12:30:00',16.53),('7643','2014-03-08','12:35:00',16.87),('7643','2014-03-08','12:40:00',16.21),('7643','2014-03-08','12:45:00',15.97),('7643','2014-03-08','12:50:00',16.14),('7643','2014-03-08','12:55:00',16.19),('7643','2014-03-08','13:00:00',16.43),('7643','2014-03-08','13:05:00',16.37),('7643','2014-03-08','13:10:00',16.14),('7643','2014-03-08','13:15:00',14.96),('7643','2014-03-08','13:20:00',14.81),('7643','2014-03-08','13:25:00',14.88),('7643','2014-03-08','13:30:00',14.71),('7643','2014-03-08','13:35:00',11.63),('7643','2014-03-08','13:40:00',2.89),('7643','2014-03-08','13:45:00',3.02),('7643','2014-03-08','13:50:00',4.55),('7643','2014-03-08','13:55:00',10.99),('7643','2014-03-08','14:00:00',14.21),('7643','2014-03-08','14:05:00',13.51),('7643','2014-03-08','14:10:00',13.25),('7643','2014-03-08','14:15:00',11.58),('7643','2014-03-08','14:20:00',11.83),('7643','2014-03-08','14:25:00',7.71),('7643','2014-03-08','14:30:00',3.79),('7643','2014-03-08','14:35:00',5.39),('7643','2014-03-08','14:40:00',9.39),('7643','2014-03-08','14:45:00',12.09),('7643','2014-03-08','14:50:00',11.51),('7643','2014-03-08','14:55:00',11.09),('7643','2014-03-08','15:00:00',10.7),('7643','2014-03-08','15:05:00',7.25),('7643','2014-03-08','15:10:00',9.72),('7643','2014-03-08','15:15:00',9.72),('7643','2014-03-08','15:20:00',9.42),('7643','2014-03-08','15:25:00',9.33),('7643','2014-03-08','15:30:00',9.19),('7643','2014-03-08','15:35:00',8.62),('7643','2014-03-08','15:40:00',8.2),('7643','2014-03-08','15:45:00',5.58),('7643','2014-03-08','15:50:00',4.3),('7643','2014-03-08','15:55:00',7.09),('7643','2014-03-08','16:00:00',6.95),('7643','2014-03-08','16:05:00',6.27),('7643','2014-03-08','16:10:00',4.76),('7643','2014-03-08','16:15:00',2.87),('7643','2014-03-08','16:20:00',3.73),('7643','2014-03-08','16:25:00',4.5),('7643','2014-03-08','16:30:00',4.44),('7643','2014-03-08','16:35:00',4.24),('7643','2014-03-08','16:40:00',4.03),('7643','2014-03-08','16:45:00',3.43),('7643','2014-03-08','16:50:00',3.03),('7643','2014-03-08','16:55:00',2.67),('7643','2014-03-08','17:00:00',2.24),('7643','2014-03-08','17:05:00',1.77),('7643','2014-03-08','17:10:00',1.64),('7643','2014-03-08','17:15:00',1.38),('7643','2014-03-08','17:20:00',1.12),('7643','2014-03-07','07:10:00',1.17),('7643','2014-03-07','07:15:00',1.47),('7643','2014-03-07','07:20:00',1.8),('7643','2014-03-07','07:25:00',2.14),('7643','2014-03-07','07:30:00',2.47),('7643','2014-03-07','07:35:00',2.83),('7643','2014-03-07','07:40:00',3.17),('7643','2014-03-07','07:45:00',3.51),('7643','2014-03-07','07:50:00',3.87),('7643','2014-03-07','07:55:00',4.21),('7643','2014-03-07','08:00:00',4.6),('7643','2014-03-07','08:05:00',4.92),('7643','2014-03-07','08:10:00',5.29),('7643','2014-03-07','08:15:00',5.65),('7643','2014-03-07','08:20:00',6.03),('7643','2014-03-07','08:25:00',6.39),('7643','2014-03-07','08:30:00',6.72),('7643','2014-03-07','08:35:00',7.05),('7643','2014-03-07','08:40:00',7.39),('7643','2014-03-07','08:45:00',7.71),('7643','2014-03-07','08:50:00',8.07),('7643','2014-03-07','08:55:00',8.39),('7643','2014-03-07','09:00:00',8.68),('7643','2014-03-07','09:05:00',8.96),('7643','2014-03-07','09:10:00',9.28),('7643','2014-03-07','09:15:00',9.58),('7643','2014-03-07','09:20:00',9.87),('7643','2014-03-07','09:25:00',10.13),('7643','2014-03-07','09:30:00',10.36),('7643','2014-03-07','09:35:00',10.59),('7643','2014-03-07','09:40:00',10.83),('7643','2014-03-07','09:45:00',11.09),('7643','2014-03-07','09:50:00',11.37),('7643','2014-03-07','09:55:00',11.57),('7643','2014-03-07','10:00:00',11.73),('7643','2014-03-07','10:05:00',11.92),('7643','2014-03-07','10:10:00',12.14),('7643','2014-03-07','10:15:00',12.42),('7643','2014-03-07','10:20:00',12.6),('7643','2014-03-07','10:25:00',12.82),('7643','2014-03-07','10:30:00',13.05),('7643','2014-03-07','10:35:00',13.25),('7643','2014-03-07','10:40:00',13.4),('7643','2014-03-07','10:45:00',13.55),('7643','2014-03-07','10:50:00',13.65),('7643','2014-03-07','10:55:00',13.73),('7643','2014-03-07','11:00:00',13.81),('7643','2014-03-07','11:05:00',13.86),('7643','2014-03-07','11:10:00',14.05),('7643','2014-03-07','11:15:00',14.28),('7643','2014-03-07','11:20:00',14.5),('7643','2014-03-07','11:25:00',14.92),('7643','2014-03-07','11:30:00',15.71),('7643','2014-03-07','11:35:00',12.97),('7643','2014-03-07','11:40:00',9.82),('7643','2014-03-07','11:45:00',5.2),('7643','2014-03-07','11:50:00',6.07),('7643','2014-03-07','11:55:00',13.97),('7643','2014-03-07','12:00:00',4.74),('7643','2014-03-07','12:05:00',3.77),('7643','2014-03-07','12:10:00',3.82),('7643','2014-03-07','12:15:00',4.2),('7643','2014-03-07','12:20:00',4.95),('7643','2014-03-07','12:25:00',5.43),('7643','2014-03-07','12:30:00',6.4),('7643','2014-03-07','12:35:00',13.18),('7643','2014-03-07','12:40:00',7.94),('7643','2014-03-07','12:45:00',8.42),('7643','2014-03-07','12:50:00',11.83),('7643','2014-03-07','12:55:00',13.22),('7643','2014-03-07','13:00:00',6.45),('7643','2014-03-07','13:05:00',5.79),('7643','2014-03-07','13:10:00',4.95),('7643','2014-03-07','13:15:00',3.89),('7643','2014-03-07','13:20:00',3.43),('7643','2014-03-07','13:25:00',4.13),('7643','2014-03-07','13:30:00',8.33),('7643','2014-03-07','13:35:00',6.62),('7643','2014-03-07','13:40:00',10.71),('7643','2014-03-07','13:45:00',9.44),('7643','2014-03-07','13:50:00',6.46),('7643','2014-03-07','13:55:00',4.67),('7643','2014-03-07','14:00:00',3.74),('7643','2014-03-07','14:05:00',3.6),('7643','2014-03-07','14:10:00',3.28),('7643','2014-03-07','14:15:00',2.73),('7643','2014-03-07','14:20:00',2.66),('7643','2014-03-07','14:25:00',2.58),('7643','2014-03-07','14:30:00',2.89),('7643','2014-03-07','14:35:00',3.43),('7643','2014-03-07','14:40:00',3.73),('7643','2014-03-07','14:45:00',3.43),('7643','2014-03-07','14:50:00',3.53),('7643','2014-03-07','14:55:00',3.64),('7643','2014-03-07','15:00:00',3.1),('7643','2014-03-07','15:05:00',2.86),('7643','2014-03-07','15:10:00',3.11),('7643','2014-03-07','15:15:00',4.32),('7643','2014-03-07','15:20:00',6.67),('7643','2014-03-07','15:25:00',7.09),('7643','2014-03-07','15:30:00',5.35),('7643','2014-03-07','15:35:00',2.48),('7643','2014-03-07','15:40:00',2.33),('7643','2014-03-07','15:45:00',2.42),('7643','2014-03-07','15:50:00',2.94),('7643','2014-03-07','15:55:00',3.25),('7643','2014-03-07','16:00:00',4.62),('7643','2014-03-07','16:05:00',4.29),('7643','2014-03-07','16:10:00',2.34),('7643','2014-03-07','16:15:00',2.5),('7643','2014-03-07','16:20:00',2.64),('7643','2014-03-07','16:25:00',2.53),('7643','2014-03-07','16:30:00',4.71),('7643','2014-03-07','16:35:00',4.56),('7643','2014-03-07','16:40:00',3.85),('7643','2014-03-07','16:45:00',3.5),('7643','2014-03-07','16:50:00',3.17),('7643','2014-03-07','16:55:00',2.76),('7643','2014-03-07','17:00:00',2.43),('7643','2014-03-07','17:05:00',2.08),('7643','2014-03-07','17:10:00',1.77),('7643','2014-03-07','17:15:00',1.51),('7643','2014-03-07','17:20:00',1.2),('7643','2014-04-29','07:00:00',1.15),('7643','2014-04-29','07:05:00',1.35),('7643','2014-04-29','07:10:00',1.6),('7643','2014-04-29','07:15:00',1.92),('7643','2014-04-29','07:20:00',2.17),('7643','2014-04-29','07:25:00',2.47),('7643','2014-04-29','07:30:00',2.86),('7643','2014-04-29','07:35:00',3.19),('7643','2014-04-29','07:40:00',3.56),('7643','2014-04-29','07:45:00',3.98),('7643','2014-04-29','07:50:00',4.38),('7643','2014-04-29','07:55:00',4.74),('7643','2014-04-29','08:00:00',5.16),('7643','2014-04-29','08:05:00',5.52),('7643','2014-04-29','08:10:00',6.07),('7643','2014-04-29','08:15:00',6.36),('7643','2014-04-29','08:20:00',6.73),('7643','2014-04-29','08:25:00',7.04),('7643','2014-04-29','08:30:00',7.4),('7643','2014-04-29','08:35:00',7.76),('7643','2014-04-29','08:40:00',8.01),('7643','2014-04-29','08:45:00',8.11),('7643','2014-04-29','08:50:00',8.74),('7643','2014-04-29','08:55:00',9.32),('7643','2014-04-29','09:00:00',9.58),('7643','2014-04-29','09:05:00',9.96),('7643','2014-04-29','09:10:00',10.77),('7643','2014-04-29','09:15:00',12.32),('7643','2014-04-29','09:20:00',7.06),('7643','2014-04-29','09:25:00',6.24),('7643','2014-04-29','09:30:00',4.42),('7643','2014-04-29','09:35:00',5.88),('7643','2014-04-29','09:40:00',12.83),('7643','2014-04-29','09:45:00',12.65),('7643','2014-04-29','09:50:00',8.91),('7643','2014-04-29','09:55:00',10.6),('7643','2014-04-29','10:00:00',14.11),('7643','2014-04-29','10:05:00',15.59),('7643','2014-04-29','10:10:00',5.18),('7643','2014-04-29','10:15:00',12.09),('7643','2014-04-29','10:20:00',7.97),('7643','2014-04-29','10:25:00',7.41),('7643','2014-04-29','10:30:00',7.51),('7643','2014-04-29','10:35:00',8.39),('7643','2014-04-29','10:40:00',8.4),('7643','2014-04-29','10:45:00',7.05),('7643','2014-04-29','10:50:00',6.23),('7643','2014-04-29','10:55:00',16.08),('7643','2014-04-29','11:00:00',15.86),('7643','2014-04-29','11:05:00',11.96),('7643','2014-04-29','11:10:00',12.24),('7643','2014-04-29','11:15:00',9.35),('7643','2014-04-29','11:20:00',6.46),('7643','2014-04-29','11:25:00',7.97),('7643','2014-04-29','11:30:00',9.59),('7643','2014-04-29','11:35:00',8.01),('7643','2014-04-29','11:40:00',12.36),('7643','2014-04-29','11:45:00',6.84),('7643','2014-04-29','11:50:00',11.51),('7643','2014-04-29','11:55:00',10.58),('7643','2014-04-29','12:00:00',15.08),('7643','2014-04-29','12:05:00',6.31),('7643','2014-04-29','12:10:00',5.98),('7643','2014-04-29','12:15:00',7.54),('7643','2014-04-29','12:20:00',8.17),('7643','2014-04-29','12:25:00',6.57),('7643','2014-04-29','12:30:00',9.07),('7643','2014-04-29','12:35:00',6.29),('7643','2014-04-29','12:40:00',7.1),('7643','2014-04-29','12:45:00',6.05),('7643','2014-04-29','12:50:00',6.89),('7643','2014-04-29','12:55:00',15.53),('7643','2014-04-29','13:00:00',17.85),('7643','2014-04-29','13:05:00',12.46),('7643','2014-04-29','13:10:00',13.88),('7643','2014-04-29','13:15:00',9.08),('7643','2014-04-29','13:20:00',9.01),('7643','2014-04-29','13:25:00',9.32),('7643','2014-04-29','13:30:00',9.24),('7643','2014-04-29','13:35:00',8.4),('7643','2014-04-29','13:40:00',11.59),('7643','2014-04-29','13:45:00',13.21),('7643','2014-04-29','13:50:00',9.6),('7643','2014-04-29','13:55:00',15.95),('7643','2014-04-29','14:00:00',8.98),('7643','2014-04-29','14:05:00',8.99),('7643','2014-04-29','14:10:00',6.33),('7643','2014-04-29','14:15:00',6.99),('7643','2014-04-29','14:20:00',11.91),('7643','2014-04-29','14:25:00',13.66),('7643','2014-04-29','14:30:00',18.57),('7643','2014-04-29','14:35:00',16.88),('7643','2014-04-29','14:40:00',9.42),('7643','2014-04-29','14:45:00',6.1),('7643','2014-04-29','14:50:00',6.26),('7643','2014-04-29','14:55:00',7.05),('7643','2014-04-29','15:00:00',6.02),('7643','2014-04-29','15:05:00',5.77),('7643','2014-04-29','15:10:00',5.47),('7643','2014-04-29','15:15:00',5.16),('7643','2014-04-29','15:20:00',4.45),('7643','2014-04-29','15:25:00',4.64),('7643','2014-04-29','15:30:00',6.77),('7643','2014-04-29','15:35:00',10.69),('7643','2014-04-29','15:40:00',13.08),('7643','2014-04-29','15:45:00',14.65),('7643','2014-04-29','15:50:00',17.29),('7643','2014-04-29','15:55:00',9.26),('7643','2014-04-29','16:00:00',6.28),('7643','2014-04-29','16:05:00',8.55),('7643','2014-04-29','16:10:00',6.99),('7643','2014-04-29','16:15:00',10.5),('7643','2014-04-29','16:20:00',9.15),('7643','2014-04-29','16:25:00',7.17),('7643','2014-04-29','16:30:00',14.03),('7643','2014-04-29','16:35:00',5.1),('7643','2014-04-29','16:40:00',12.18),('7643','2014-04-29','16:45:00',7.16),('7643','2014-04-29','16:50:00',6.58),('7643','2014-04-29','16:55:00',8.2),('7643','2014-04-29','17:00:00',7.93),('7643','2014-04-29','17:05:00',10.54),('7643','2014-04-29','17:10:00',7.19),('7643','2014-04-29','17:15:00',8.49),('7643','2014-04-29','17:20:00',4.31),('7643','2014-04-29','17:25:00',2.42),('7643','2014-04-29','17:30:00',3.23),('7643','2014-04-29','17:35:00',5.14),('7643','2014-04-29','17:40:00',5.06),('7643','2014-04-29','17:45:00',3.09),('7643','2014-04-29','17:50:00',3.04),('7643','2014-04-29','17:55:00',2.65),('7643','2014-04-29','18:00:00',2.4),('7643','2014-04-29','18:05:00',1.76),('7643','2014-04-29','18:10:00',2.04),('7643','2014-04-29','18:15:00',1.38),('7643','2014-04-29','18:25:00',1.38),('7643','2014-04-29','18:30:00',1.63),('7643','2014-04-29','18:35:00',2.03),('7643','2014-04-29','18:40:00',1.94),('7643','2014-04-29','18:45:00',2.11),('7643','2014-04-29','18:50:00',1.96),('7643','2014-04-29','18:55:00',1.39),('7643','2014-04-29','19:00:00',1.16),('7643','2014-04-29','19:05:00',1.29),('7643','2014-04-29','19:10:00',1.32),('7643','2014-03-06','07:45:00',1.38),('7643','2014-03-06','07:50:00',1.41),('7643','2014-03-06','08:15:00',1),('7643','2014-03-06','08:45:00',1.28),('7643','2014-03-06','08:50:00',1.33),('7643','2014-03-06','08:55:00',1.45),('7643','2014-03-06','09:00:00',1.48),('7643','2014-03-06','09:05:00',1.15),('7643','2014-03-06','09:10:00',1.01),('7643','2014-03-06','09:15:00',1.02),('7643','2014-03-06','09:20:00',1.42),('7643','2014-03-06','09:25:00',1.78),('7643','2014-03-06','09:30:00',2.03),('7643','2014-03-06','09:35:00',2.51),('7643','2014-03-06','09:40:00',2.06),('7643','2014-03-06','09:45:00',1.47),('7643','2014-03-06','09:50:00',1.82),('7643','2014-03-06','09:55:00',2.36),('7643','2014-03-06','10:00:00',2.04),('7643','2014-03-06','10:05:00',2.19),('7643','2014-03-06','10:10:00',2.26),('7643','2014-03-06','10:15:00',2.23),('7643','2014-03-06','10:20:00',2.38),('7643','2014-03-06','10:25:00',1.96),('7643','2014-03-06','10:30:00',2.45),('7643','2014-03-06','10:35:00',2.89),('7643','2014-03-06','10:40:00',2.44),('7643','2014-03-06','10:45:00',2.24),('7643','2014-03-06','10:50:00',2.31),('7643','2014-03-06','10:55:00',2.5),('7643','2014-03-06','11:00:00',2.88),('7643','2014-03-06','11:05:00',2.45),('7643','2014-03-06','11:10:00',2.13),('7643','2014-03-06','11:15:00',2.3),('7643','2014-03-06','11:20:00',2.87),('7643','2014-03-06','11:25:00',2.88),('7643','2014-03-06','11:30:00',3.54),('7643','2014-03-06','11:35:00',3.19),('7643','2014-03-06','11:40:00',3.13),('7643','2014-03-06','11:45:00',8.58),('7643','2014-03-06','11:50:00',14.04),('7643','2014-03-06','11:55:00',16.04),('7643','2014-03-06','12:00:00',17.8),('7643','2014-03-06','12:05:00',16.8),('7643','2014-03-06','12:10:00',16.75),('7643','2014-03-06','12:15:00',16.03),('7643','2014-03-06','12:20:00',16.31),('7643','2014-03-06','12:25:00',16.17),('7643','2014-03-06','12:30:00',16.45),('7643','2014-03-06','12:35:00',15.8),('7643','2014-03-06','12:40:00',11.3),('7643','2014-03-06','12:45:00',12.62),('7643','2014-03-06','12:50:00',6.9),('7643','2014-03-06','12:55:00',2.94),('7643','2014-03-06','13:00:00',6.86),('7643','2014-03-06','13:05:00',12.61),('7643','2014-03-06','13:10:00',4.85),('7643','2014-03-06','13:15:00',4.95),('7643','2014-03-06','13:20:00',10.31),('7643','2014-03-06','13:25:00',13.25),('7643','2014-03-06','13:30:00',10.16),('7643','2014-03-06','13:35:00',11.18),('7643','2014-03-06','13:40:00',12.06),('7643','2014-03-06','13:45:00',9.11),('7643','2014-03-06','13:50:00',5.06),('7643','2014-03-06','13:55:00',4.15),('7643','2014-03-06','14:00:00',4.02),('7643','2014-03-06','14:05:00',3.91),('7643','2014-03-06','14:10:00',3.92),('7643','2014-03-06','14:15:00',3.82),('7643','2014-03-06','14:20:00',3.61),('7643','2014-03-06','14:25:00',3.55),('7643','2014-03-06','14:30:00',3.73),('7643','2014-03-06','14:35:00',3.94),('7643','2014-03-06','14:40:00',4.08),('7643','2014-03-06','14:45:00',3.91),('7643','2014-03-06','14:50:00',5.1),('7643','2014-03-06','14:55:00',7.89),('7643','2014-03-06','15:00:00',10.02),('7643','2014-03-06','15:05:00',11.62),('7643','2014-03-06','15:10:00',11.65),('7643','2014-03-06','15:15:00',11.9),('7643','2014-03-06','15:20:00',12.25),('7643','2014-03-06','15:25:00',11.74),('7643','2014-03-06','15:30:00',11.2),('7643','2014-03-06','15:35:00',10.44),('7643','2014-03-06','15:40:00',8.74),('7643','2014-03-06','15:45:00',4.08),('7643','2014-03-06','15:50:00',2.68),('7643','2014-03-06','15:55:00',2.65),('7643','2014-03-06','16:00:00',6.38),('7643','2014-03-06','16:05:00',6.99),('7643','2014-03-06','16:10:00',6.84),('7643','2014-03-06','16:15:00',6.83),('7643','2014-03-06','16:20:00',6.19),('7643','2014-03-06','16:25:00',5.78),('7643','2014-03-06','16:30:00',5.21),('7643','2014-03-06','16:35:00',4.86),('7643','2014-03-06','16:40:00',4.89),('7643','2014-03-06','16:45:00',4.53),('7643','2014-03-06','16:50:00',4.22),('7643','2014-03-06','16:55:00',3.96),('7643','2014-03-06','17:00:00',3.69),('7643','2014-03-06','17:05:00',3.29),('7643','2014-03-06','17:10:00',2.83),('7643','2014-03-06','17:15:00',2.38),('7643','2014-03-06','17:20:00',1.99),('7643','2014-03-06','17:25:00',1.27),('7643','2014-03-05','07:20:00',1.04),('7643','2014-03-05','07:25:00',1.23),('7643','2014-03-05','07:30:00',1.1),('7643','2014-03-05','07:40:00',1.11),('7643','2014-03-05','07:45:00',1.32),('7643','2014-03-05','07:50:00',1.54),('7643','2014-03-05','07:55:00',2.54),('7643','2014-03-05','08:00:00',3.73),('7643','2014-03-05','08:05:00',4.27),('7643','2014-03-05','08:10:00',6.48),('7643','2014-03-05','08:15:00',6.76),('7643','2014-03-05','08:20:00',5.81),('7643','2014-03-05','08:25:00',4.73),('7643','2014-03-05','08:30:00',2.41),('7643','2014-03-05','08:35:00',3.26),('7643','2014-03-05','08:40:00',3.57),('7643','2014-03-05','08:45:00',3.27),('7643','2014-03-05','08:50:00',3.83),('7643','2014-03-05','08:55:00',3.35),('7643','2014-03-05','09:00:00',3.36),('7643','2014-03-05','09:05:00',3.08),('7643','2014-03-05','09:10:00',3),('7643','2014-03-05','09:15:00',3.65),('7643','2014-03-05','09:20:00',3.92),('7643','2014-03-05','09:25:00',3.48),('7643','2014-03-05','09:30:00',4),('7643','2014-03-05','09:35:00',4.74),('7643','2014-03-05','09:40:00',5.84),('7643','2014-03-05','09:45:00',6.68),('7643','2014-03-05','09:50:00',7.03),('7643','2014-03-05','09:55:00',7.19),('7643','2014-03-05','10:00:00',6.81),('7643','2014-03-05','10:05:00',8.76),('7643','2014-03-05','10:10:00',11.41),('7643','2014-03-05','10:15:00',13.08),('7643','2014-03-05','10:20:00',11.07),('7643','2014-03-05','10:25:00',8.66),('7643','2014-03-05','10:30:00',5.52),('7643','2014-03-05','10:35:00',6.1),('7643','2014-03-05','10:40:00',7.37),('7643','2014-03-05','10:45:00',8.26),('7643','2014-03-05','10:50:00',4.81),('7643','2014-03-05','10:55:00',6.65),('7643','2014-03-05','11:00:00',7.25),('7643','2014-03-05','11:05:00',8.85),('7643','2014-03-05','11:10:00',6.15),('7643','2014-03-05','11:15:00',11.25),('7643','2014-03-05','11:20:00',5.28),('7643','2014-03-05','11:25:00',5.85),('7643','2014-03-05','11:30:00',6.95),('7643','2014-03-05','11:35:00',4.92),('7643','2014-03-05','11:40:00',7.13),('7643','2014-03-05','11:45:00',13.31),('7643','2014-03-05','11:50:00',13.76),('7643','2014-03-05','11:55:00',16.19),('7643','2014-03-05','12:00:00',6.07),('7643','2014-03-05','12:05:00',12.52),('7643','2014-03-05','12:10:00',17.57),('7643','2014-03-05','12:15:00',12.31),('7643','2014-03-05','12:20:00',7.94),('7643','2014-03-05','12:25:00',17.45),('7643','2014-03-05','12:30:00',17.3),('7643','2014-03-05','12:35:00',8.64),('7643','2014-03-05','12:40:00',5.58),('7643','2014-03-05','12:45:00',4.09),('7643','2014-03-05','12:50:00',3.72),('7643','2014-03-05','12:55:00',4.41),('7643','2014-03-05','13:00:00',4.7),('7643','2014-03-05','13:05:00',4.86),('7643','2014-03-05','13:10:00',4.54),('7643','2014-03-05','13:15:00',5.89),('7643','2014-03-05','13:20:00',4.54),('7643','2014-03-05','13:25:00',4.07),('7643','2014-03-05','13:30:00',4.41),('7643','2014-03-05','13:35:00',4.37),('7643','2014-03-05','13:40:00',4.61),('7643','2014-03-05','13:45:00',3.84),('7643','2014-03-05','13:50:00',3.47),('7643','2014-03-05','13:55:00',3.24),('7643','2014-03-05','14:00:00',3.32),('7643','2014-03-05','14:05:00',3.78),('7643','2014-03-05','14:10:00',3.79),('7643','2014-03-05','14:15:00',3.71),('7643','2014-03-05','14:20:00',4.33),('7643','2014-03-05','14:25:00',4.28),('7643','2014-03-05','14:30:00',4.34),('7643','2014-03-05','14:35:00',4.58),('7643','2014-03-05','14:40:00',3.93),('7643','2014-03-05','14:45:00',3.02),('7643','2014-03-05','14:50:00',3.46),('7643','2014-03-05','14:55:00',3.19),('7643','2014-03-05','15:00:00',3.27),('7643','2014-03-05','15:05:00',3.86),('7643','2014-03-05','15:10:00',3.97),('7643','2014-03-05','15:15:00',3.08),('7643','2014-03-05','15:20:00',2.07),('7643','2014-03-05','15:25:00',2.02),('7643','2014-03-05','15:30:00',2.19),('7643','2014-03-05','15:35:00',2.27),('7643','2014-03-05','15:40:00',1.93),('7643','2014-03-05','15:45:00',1.5),('7643','2014-03-05','15:50:00',1.5),('7643','2014-03-05','15:55:00',1.93),('7643','2014-03-05','16:00:00',2.42),('7643','2014-03-05','16:05:00',2.44),('7643','2014-03-05','16:10:00',2.31),('7643','2014-03-05','16:15:00',2.39),('7643','2014-03-05','16:20:00',2.96),('7643','2014-03-05','16:25:00',4.74),('7643','2014-03-05','16:30:00',2.25),('7643','2014-03-05','16:35:00',1.88),('7643','2014-03-05','16:40:00',1.55),('7643','2014-03-05','16:45:00',1.85),('7643','2014-03-05','16:50:00',3.17),('7643','2014-03-05','16:55:00',3.14),('7643','2014-03-05','17:00:00',2.25),('7643','2014-03-05','17:05:00',1.48),('7643','2014-03-05','17:10:00',1.98),('7643','2014-03-05','17:15:00',1.93),('7643','2014-03-05','17:20:00',1.4),('7643','2014-03-05','17:25:00',1.05),('7643','2014-03-04','07:05:00',1.25),('7643','2014-03-04','07:10:00',1.65),('7643','2014-03-04','07:15:00',1.92),('7643','2014-03-04','07:20:00',2.17),('7643','2014-03-04','07:25:00',2.51),('7643','2014-03-04','07:30:00',3.14),('7643','2014-03-04','07:35:00',3.55),('7643','2014-03-04','07:40:00',4.05),('7643','2014-03-04','07:45:00',4.47),('7643','2014-03-04','07:50:00',4.84),('7643','2014-03-04','07:55:00',5.16),('7643','2014-03-04','08:00:00',5.38),('7643','2014-03-04','08:05:00',5.56),('7643','2014-03-04','08:10:00',5.47),('7643','2014-03-04','08:15:00',5.8),('7643','2014-03-04','08:20:00',3.56),('7643','2014-03-04','08:25:00',2.31),('7643','2014-03-04','08:30:00',6.81),('7643','2014-03-04','08:35:00',7.72),('7643','2014-03-04','08:40:00',9),('7643','2014-03-04','08:45:00',8.77),('7643','2014-03-04','08:50:00',3.14),('7643','2014-03-04','08:55:00',3.55),('7643','2014-03-04','09:00:00',10.14),('7643','2014-03-04','09:05:00',5.63),('7643','2014-03-04','09:10:00',2.84),('7643','2014-03-04','09:15:00',6.48),('7643','2014-03-04','09:20:00',10.31),('7643','2014-03-04','09:25:00',10.39),('7643','2014-03-04','09:30:00',10.53),('7643','2014-03-04','09:35:00',10.86),('7643','2014-03-04','09:40:00',11.04),('7643','2014-03-04','09:45:00',11.27),('7643','2014-03-04','09:50:00',11.43),('7643','2014-03-04','09:55:00',11.65),('7643','2014-03-04','10:00:00',11.88),('7643','2014-03-04','10:05:00',12.08),('7643','2014-03-04','10:10:00',12.42),('7643','2014-03-04','10:15:00',12.54),('7643','2014-03-04','10:20:00',12.65),('7643','2014-03-04','10:25:00',12.82),('7643','2014-03-04','10:30:00',12.95),('7643','2014-03-04','10:35:00',13.09),('7643','2014-03-04','10:40:00',13.2),('7643','2014-03-04','10:45:00',13.35),('7643','2014-03-04','10:50:00',13.49),('7643','2014-03-04','10:55:00',13.62),('7643','2014-03-04','11:00:00',13.81),('7643','2014-03-04','11:05:00',14.09),('7643','2014-03-04','11:10:00',14.2),('7643','2014-03-04','11:15:00',14.22),('7643','2014-03-04','11:20:00',14.3),('7643','2014-03-04','11:25:00',14.42),('7643','2014-03-04','11:30:00',14.69),('7643','2014-03-04','11:35:00',14.8),('7643','2014-03-04','11:40:00',15.49),('7643','2014-03-04','11:45:00',15.05),('7643','2014-03-04','11:50:00',14.86),('7643','2014-03-04','11:55:00',12.31),('7643','2014-03-04','12:00:00',12.99),('7643','2014-03-04','12:05:00',12.36),('7643','2014-03-04','12:10:00',5.48),('7643','2014-03-04','12:15:00',5.71),('7643','2014-03-04','12:20:00',2.79),('7643','2014-03-04','12:25:00',3.28),('7643','2014-03-04','12:30:00',3.88),('7643','2014-03-04','12:35:00',6.86),('7643','2014-03-04','12:40:00',5.16),('7643','2014-03-04','12:45:00',4.68),('7643','2014-03-04','12:50:00',6.97),('7643','2014-03-04','12:55:00',5.29),('7643','2014-03-04','13:00:00',6.63),('7643','2014-03-04','13:05:00',8.84),('7643','2014-03-04','13:10:00',11.92),('7643','2014-03-04','13:15:00',12.08),('7643','2014-03-04','13:20:00',6.8),('7643','2014-03-04','13:25:00',4.68),('7643','2014-03-04','13:30:00',4.51),('7643','2014-03-04','13:35:00',4.95),('7643','2014-03-04','13:40:00',5.81),('7643','2014-03-04','13:45:00',5.52),('7643','2014-03-04','13:50:00',4.53),('7643','2014-03-04','13:55:00',4.02),('7643','2014-03-04','14:00:00',3.69),('7643','2014-03-04','14:05:00',3.64),('7643','2014-03-04','14:10:00',3.8),('7643','2014-03-04','14:15:00',4.36),('7643','2014-03-04','14:20:00',4.57),('7643','2014-03-04','14:25:00',4.95),('7643','2014-03-04','14:30:00',5.32),('7643','2014-03-04','14:35:00',4.63),('7643','2014-03-04','14:40:00',5.12),('7643','2014-03-04','14:45:00',5.8),('7643','2014-03-04','14:50:00',8.83),('7643','2014-03-04','14:55:00',5.27),('7643','2014-03-04','15:00:00',3.58),('7643','2014-03-04','15:05:00',3.12),('7643','2014-03-04','15:10:00',3.17),('7643','2014-03-04','15:15:00',3.07),('7643','2014-03-04','15:20:00',2.75),('7643','2014-03-04','15:25:00',2.78),('7643','2014-03-04','15:30:00',3.61),('7643','2014-03-04','15:35:00',4.51),('7643','2014-03-04','15:40:00',7.92),('7643','2014-03-04','15:45:00',6.58),('7643','2014-03-04','15:50:00',5.31),('7643','2014-03-04','15:55:00',8.75),('7643','2014-03-04','16:00:00',10.41),('7643','2014-03-04','16:05:00',9.43),('7643','2014-03-04','16:10:00',7.97),('7643','2014-03-04','16:15:00',5.52),('7643','2014-03-04','16:20:00',2),('7643','2014-03-04','16:25:00',1.33),('7643','2014-03-04','16:30:00',1.14),('7643','2014-03-03','08:45:00',1.23),('7643','2014-03-03','08:50:00',2.16),('7643','2014-03-03','09:00:00',1.72),('7643','2014-03-03','09:05:00',4.11),('7643','2014-03-03','09:10:00',3.6),('7643','2014-03-03','09:15:00',6.86),('7643','2014-03-03','09:20:00',9.41),('7643','2014-03-03','09:25:00',4.16),('7643','2014-03-03','09:30:00',3.77),('7643','2014-03-03','09:35:00',3.84),('7643','2014-03-03','09:40:00',7.25),('7643','2014-03-03','09:45:00',7.47),('7643','2014-03-03','09:50:00',2.56),('7643','2014-03-03','09:55:00',7.73),('7643','2014-03-03','10:00:00',5.8),('7643','2014-03-03','10:05:00',4.14),('7643','2014-03-03','10:10:00',2.05),('7643','2014-03-03','10:15:00',1.94),('7643','2014-03-03','10:20:00',3.17),('7643','2014-03-03','10:25:00',14.45),('7643','2014-03-03','10:30:00',10.33),('7643','2014-03-03','10:35:00',12.28),('7643','2014-03-03','10:40:00',15.44),('7643','2014-03-03','10:45:00',15.11),('7643','2014-03-03','10:50:00',3.79),('7643','2014-03-03','10:55:00',9.95),('7643','2014-03-03','11:00:00',8.29),('7643','2014-03-03','11:05:00',6.23),('7643','2014-03-03','11:10:00',10.24),('7643','2014-03-03','11:15:00',17.38),('7643','2014-03-03','11:20:00',13.16),('7643','2014-03-03','11:25:00',4.51),('7643','2014-03-03','11:30:00',3.32),('7643','2014-03-03','11:35:00',2.37),('7643','2014-03-03','11:40:00',3.19),('7643','2014-03-03','11:45:00',8.69),('7643','2014-03-03','11:50:00',17.91),('7643','2014-03-03','11:55:00',15.74),('7643','2014-03-03','12:00:00',15.25),('7643','2014-03-03','12:05:00',14.98),('7643','2014-03-03','12:10:00',14.84),('7643','2014-03-03','12:15:00',14.69),('7643','2014-03-03','12:20:00',14.69),('7643','2014-03-03','12:25:00',14.74),('7643','2014-03-03','12:30:00',14.57),('7643','2014-03-03','12:35:00',14.52),('7643','2014-03-03','12:40:00',14.64),('7643','2014-03-03','12:45:00',13.56),('7643','2014-03-03','12:50:00',11.65),('7643','2014-03-03','12:55:00',12.13),('7643','2014-03-03','13:00:00',13),('7643','2014-03-03','13:05:00',13.88),('7643','2014-03-03','13:10:00',15.46),('7643','2014-03-03','13:15:00',12.96),('7643','2014-03-03','13:20:00',4.79),('7643','2014-03-03','13:25:00',3.63),('7643','2014-03-03','13:30:00',3.91),('7643','2014-03-03','13:35:00',3.11),('7643','2014-03-03','13:40:00',2),('7643','2014-03-03','13:45:00',2.83),('7643','2014-03-03','13:50:00',4.29),('7643','2014-03-03','13:55:00',4.13),('7643','2014-03-03','14:00:00',2.61),('7643','2014-03-03','14:05:00',5.37),('7643','2014-03-03','14:10:00',9.96),('7643','2014-03-03','14:15:00',10.24),('7643','2014-03-03','14:20:00',8.03),('7643','2014-03-03','14:25:00',13.31),('7643','2014-03-03','14:30:00',12.4),('7643','2014-03-03','14:35:00',11.78),('7643','2014-03-03','14:40:00',11.49),('7643','2014-03-03','14:45:00',11.41),('7643','2014-03-03','14:50:00',10.85),('7643','2014-03-03','14:55:00',5.09),('7643','2014-03-03','15:00:00',6.43),('7643','2014-03-03','15:05:00',10.31),('7643','2014-03-03','15:10:00',10.05),('7643','2014-03-03','15:15:00',9.55),('7643','2014-03-03','15:20:00',5.65),('7643','2014-03-03','15:25:00',9.32),('7643','2014-03-03','15:30:00',5.61),('7643','2014-03-03','15:35:00',9.87),('7643','2014-03-03','15:40:00',8.93),('7643','2014-03-03','15:45:00',6.32),('7643','2014-03-03','15:50:00',6.97),('7643','2014-03-03','15:55:00',2.75),('7643','2014-03-03','16:00:00',2.6),('7643','2014-03-03','16:05:00',3.51),('7643','2014-03-03','16:10:00',3.68),('7643','2014-03-03','16:15:00',3.04),('7643','2014-03-03','16:20:00',3.75),('7643','2014-03-03','16:25:00',4.71),('7643','2014-03-03','16:30:00',3.5),('7643','2014-03-03','16:35:00',3.34),('7643','2014-03-03','16:40:00',3.45),('7643','2014-03-03','16:45:00',3.66),('7643','2014-03-03','16:50:00',3.35),('7643','2014-03-03','16:55:00',2.59),('7643','2014-03-03','17:00:00',1.96),('7643','2014-03-03','17:05:00',1.67),('7643','2014-03-03','17:10:00',1.2),('7643','2014-03-02','07:15:00',1.17),('7643','2014-03-02','07:20:00',1.52),('7643','2014-03-02','07:25:00',1.88),('7643','2014-03-02','07:30:00',2.28),('7643','2014-03-02','07:35:00',2.61),('7643','2014-03-02','07:40:00',2.95),('7643','2014-03-02','07:45:00',3.3),('7643','2014-03-02','07:50:00',3.64),('7643','2014-03-02','07:55:00',3.22),('7643','2014-03-02','08:00:00',3.47),('7643','2014-03-02','08:05:00',3.52),('7643','2014-03-02','08:10:00',4.95),('7643','2014-03-02','08:15:00',5.54),('7643','2014-03-02','08:20:00',5.89),('7643','2014-03-02','08:25:00',6.16),('7643','2014-03-02','08:30:00',6.56),('7643','2014-03-02','08:35:00',6.84),('7643','2014-03-02','08:40:00',7.32),('7643','2014-03-02','08:45:00',7.6),('7643','2014-03-02','08:50:00',7.5),('7643','2014-03-02','08:55:00',8.43),('7643','2014-03-02','09:00:00',8.74),('7643','2014-03-02','09:05:00',8.79),('7643','2014-03-02','09:10:00',8.48),('7643','2014-03-02','09:15:00',8.47),('7643','2014-03-02','09:20:00',9.36),('7643','2014-03-02','09:25:00',9.9),('7643','2014-03-02','09:30:00',9.61),('7643','2014-03-02','09:35:00',8.94),('7643','2014-03-02','09:40:00',8.06),('7643','2014-03-02','09:45:00',8.42),('7643','2014-03-02','09:50:00',8.45),('7643','2014-03-02','09:55:00',9.97),('7643','2014-03-02','10:00:00',10.92),('7643','2014-03-02','10:05:00',11.61),('7643','2014-03-02','10:10:00',11.66),('7643','2014-03-02','10:15:00',11.84),('7643','2014-03-02','10:20:00',12.02),('7643','2014-03-02','10:25:00',12.18),('7643','2014-03-02','10:30:00',12.43),('7643','2014-03-02','10:35:00',12.6),('7643','2014-03-02','10:40:00',12.7),('7643','2014-03-02','10:45:00',12.71),('7643','2014-03-02','10:50:00',12.97),('7643','2014-03-02','10:55:00',13.1),('7643','2014-03-02','11:00:00',13.19),('7643','2014-03-02','11:05:00',13.22),('7643','2014-03-02','11:10:00',13.29),('7643','2014-03-02','11:15:00',13.4),('7643','2014-03-02','11:20:00',13.5),('7643','2014-03-02','11:25:00',13.65),('7643','2014-03-02','11:30:00',13.9),('7643','2014-03-02','11:35:00',9.46),('7643','2014-03-02','11:40:00',8.09),('7643','2014-03-02','11:45:00',14.01),('7643','2014-03-02','11:50:00',14.54),('7643','2014-03-02','11:55:00',14.55),('7643','2014-03-02','12:00:00',14.42),('7643','2014-03-02','12:05:00',14.5),('7643','2014-03-02','12:10:00',14.59),('7643','2014-03-02','12:15:00',14.56),('7643','2014-03-02','12:20:00',14.57),('7643','2014-03-02','12:25:00',14.58),('7643','2014-03-02','12:30:00',14.5),('7643','2014-03-02','12:35:00',14.44),('7643','2014-03-02','12:40:00',14.42),('7643','2014-03-02','12:45:00',14.34),('7643','2014-03-02','12:50:00',14.25),('7643','2014-03-02','12:55:00',14.16),('7643','2014-03-02','13:00:00',14.1),('7643','2014-03-02','13:05:00',13.96),('7643','2014-03-02','13:10:00',13.9),('7643','2014-03-02','13:15:00',13.79),('7643','2014-03-02','13:20:00',13.76),('7643','2014-03-02','13:25:00',13.67),('7643','2014-03-02','13:30:00',13.63),('7643','2014-03-02','13:35:00',13.52),('7643','2014-03-02','13:40:00',13.33),('7643','2014-03-02','13:45:00',13.22),('7643','2014-03-02','13:50:00',13.12),('7643','2014-03-02','13:55:00',12.87),('7643','2014-03-02','14:00:00',12.79),('7643','2014-03-02','14:05:00',12.63),('7643','2014-03-02','14:10:00',12.63),('7643','2014-03-02','14:15:00',12.61),('7643','2014-03-02','14:20:00',12.31),('7643','2014-03-02','14:25:00',11.55),('7643','2014-03-02','14:30:00',11.88),('7643','2014-03-02','14:35:00',11.73),('7643','2014-03-02','14:40:00',11.33),('7643','2014-03-02','14:45:00',11.05),('7643','2014-03-02','14:50:00',10.72),('7643','2014-03-02','14:55:00',10.49),('7643','2014-03-02','15:00:00',10.17),('7643','2014-03-02','15:05:00',9.9),('7643','2014-03-02','15:10:00',9.68),('7643','2014-03-02','15:15:00',9.25),('7643','2014-03-02','15:20:00',9.15),('7643','2014-03-02','15:25:00',8.91),('7643','2014-03-02','15:30:00',8.54),('7643','2014-03-02','15:35:00',8.2),('7643','2014-03-02','15:40:00',7.89),('7643','2014-03-02','15:45:00',7.55),('7643','2014-03-02','15:50:00',7.14),('7643','2014-03-02','15:55:00',6.78),('7643','2014-03-02','16:00:00',6.47),('7643','2014-03-02','16:05:00',6.13),('7643','2014-03-02','16:10:00',5.81),('7643','2014-03-02','16:15:00',5.49),('7643','2014-03-02','16:20:00',5.14),('7643','2014-03-02','16:25:00',4.73),('7643','2014-03-02','16:30:00',4.37),('7643','2014-03-02','16:35:00',3.97),('7643','2014-03-02','16:40:00',3.68),('7643','2014-03-02','16:45:00',3.44),('7643','2014-03-02','16:50:00',1.81),('7643','2014-03-02','16:55:00',2.69),('7643','2014-03-02','17:00:00',2.83),('7643','2014-03-02','17:05:00',2.32),('7643','2014-03-02','17:10:00',1.37),('7643','2014-03-02','17:15:00',1.1),('7643','2014-03-01','07:20:00',1.74),('7643','2014-03-01','07:25:00',1.43),('7643','2014-03-01','07:30:00',1.15),('7643','2014-03-01','07:35:00',1.06),('7643','2014-03-01','07:40:00',1.01),('7643','2014-03-01','07:45:00',2.12),('7643','2014-03-01','07:50:00',1.94),('7643','2014-03-01','07:55:00',1.76),('7643','2014-03-01','08:00:00',3.1),('7643','2014-03-01','08:05:00',4.55),('7643','2014-03-01','08:10:00',6.37),('7643','2014-03-01','08:15:00',6.91),('7643','2014-03-01','08:20:00',7.03),('7643','2014-03-01','08:25:00',6.4),('7643','2014-03-01','08:30:00',6.5),('7643','2014-03-01','08:35:00',6.81),('7643','2014-03-01','08:40:00',7.23),('7643','2014-03-01','08:45:00',7.64),('7643','2014-03-01','08:50:00',8.01),('7643','2014-03-01','08:55:00',8.3),('7643','2014-03-01','09:00:00',8.61),('7643','2014-03-01','09:05:00',8.99),('7643','2014-03-01','09:10:00',9.48),('7643','2014-03-01','09:15:00',9.83),('7643','2014-03-01','09:20:00',7.7),('7643','2014-03-01','09:25:00',10.07),('7643','2014-03-01','09:30:00',11.09),('7643','2014-03-01','09:35:00',11.1),('7643','2014-03-01','09:40:00',10.65),('7643','2014-03-01','09:45:00',5.54),('7643','2014-03-01','09:50:00',2.5),('7643','2014-03-01','09:55:00',3.26),('7643','2014-03-01','10:00:00',8.18),('7643','2014-03-01','10:05:00',5.74),('7643','2014-03-01','10:10:00',5.57),('7643','2014-03-01','10:15:00',4.24),('7643','2014-03-01','10:20:00',4.37),('7643','2014-03-01','10:25:00',4.67),('7643','2014-03-01','10:30:00',5.4),('7643','2014-03-01','10:35:00',5.62),('7643','2014-03-01','10:40:00',7.73),('7643','2014-03-01','10:45:00',4.42),('7643','2014-03-01','10:50:00',4.3),('7643','2014-03-01','10:55:00',4.38),('7643','2014-03-01','11:00:00',8.74),('7643','2014-03-01','11:05:00',11.42),('7643','2014-03-01','11:10:00',5.8),('7643','2014-03-01','11:15:00',4.58),('7643','2014-03-01','11:20:00',5.53),('7643','2014-03-01','11:25:00',7.16),('7643','2014-03-01','11:30:00',7.38),('7643','2014-03-01','11:35:00',11.51),('7643','2014-03-01','11:40:00',11.38),('7643','2014-03-01','11:45:00',14.54),('7643','2014-03-01','11:50:00',17.9),('7643','2014-03-01','11:55:00',15.91),('7643','2014-03-01','12:00:00',9.8),('7643','2014-03-01','12:05:00',6.64),('7643','2014-03-01','12:10:00',7.39),('7643','2014-03-01','12:15:00',12.63),('7643','2014-03-01','12:20:00',9.33),('7643','2014-03-01','12:25:00',6.87),('7643','2014-03-01','12:30:00',5.35),('7643','2014-03-01','12:35:00',4.23),('7643','2014-03-01','12:40:00',3.68),('7643','2014-03-01','12:45:00',3.66),('7643','2014-03-01','12:50:00',4.09),('7643','2014-03-01','12:55:00',4.76),('7643','2014-03-01','13:00:00',5.32),('7643','2014-03-01','13:05:00',5.45),('7643','2014-03-01','13:10:00',5.4),('7643','2014-03-01','13:15:00',5.27),('7643','2014-03-01','13:20:00',4.98),('7643','2014-03-01','13:25:00',4.39),('7643','2014-03-01','13:30:00',3.92),('7643','2014-03-01','13:35:00',3.3),('7643','2014-03-01','13:40:00',3.02),('7643','2014-03-01','13:45:00',2.86),('7643','2014-03-01','13:50:00',3.06),('7643','2014-03-01','13:55:00',3.59),('7643','2014-03-01','14:00:00',4.62),('7643','2014-03-01','14:05:00',5),('7643','2014-03-01','14:10:00',4.78),('7643','2014-03-01','14:15:00',4.56),('7643','2014-03-01','14:20:00',4.29),('7643','2014-03-01','14:25:00',4.37),('7643','2014-03-01','14:30:00',4.6),('7643','2014-03-01','14:35:00',4.56),('7643','2014-03-01','14:40:00',4.66),('7643','2014-03-01','14:45:00',4.77),('7643','2014-03-01','14:50:00',4.69),('7643','2014-03-01','14:55:00',4.59),('7643','2014-03-01','15:00:00',4.73),('7643','2014-03-01','15:05:00',5.23),('7643','2014-03-01','15:10:00',5.15),('7643','2014-03-01','15:15:00',5.1),('7643','2014-03-01','15:20:00',5.3),('7643','2014-03-01','15:25:00',5.39),('7643','2014-03-01','15:30:00',4.99),('7643','2014-03-01','15:35:00',5.39),('7643','2014-03-01','15:40:00',4.8),('7643','2014-03-01','15:45:00',4.18),('7643','2014-03-01','15:50:00',3.92),('7643','2014-03-01','15:55:00',3.39),('7643','2014-03-01','16:00:00',3.03),('7643','2014-03-01','16:05:00',2.76),('7643','2014-03-01','16:10:00',2.39),('7643','2014-03-01','16:15:00',2.1),('7643','2014-03-01','16:20:00',1.97),('7643','2014-03-01','16:25:00',1.81),('7643','2014-03-01','16:30:00',1.63),('7643','2014-03-01','16:35:00',1.54),('7643','2014-03-01','16:40:00',1.48),('7643','2014-03-01','16:45:00',1.46),('7643','2014-03-01','16:50:00',1.45),('7643','2014-03-01','16:55:00',1.47),('7643','2014-03-01','17:00:00',1.41),('7643','2014-02-28','09:50:00',1.61),('7643','2014-02-28','09:55:00',1.66),('7643','2014-02-28','10:00:00',1.25),('7643','2014-02-28','10:05:00',1.46),('7643','2014-02-28','10:10:00',1.36),('7643','2014-02-28','10:15:00',1.34),('7643','2014-02-28','10:20:00',1.37),('7643','2014-02-28','10:25:00',1.37),('7643','2014-02-28','10:30:00',1.18),('7643','2014-02-28','11:50:00',1.04),('7643','2014-02-28','11:55:00',1.45),('7643','2014-02-28','12:00:00',1.64),('7643','2014-02-28','12:05:00',1.55),('7643','2014-02-28','12:10:00',1.49),('7643','2014-02-28','12:15:00',1.56),('7643','2014-02-28','12:20:00',1.64),('7643','2014-02-28','12:25:00',1.65),('7643','2014-02-28','12:30:00',1.79),('7643','2014-02-28','12:35:00',1.58),('7643','2014-02-28','12:40:00',1.85),('7643','2014-02-28','12:45:00',1.64),('7643','2014-02-28','13:05:00',1.63),('7643','2014-02-28','13:10:00',1.68),('7643','2014-02-28','13:15:00',1.29),('7643','2014-02-28','13:20:00',1.38),('7643','2014-02-28','13:25:00',1.18),('7643','2014-02-28','13:30:00',1.11),('7643','2014-02-28','13:35:00',1.15),('7643','2014-02-28','14:20:00',1.37),('7643','2014-02-28','14:25:00',1.36),('7643','2014-02-28','14:30:00',1.09),('7643','2014-02-28','14:35:00',1.4),('7643','2014-02-28','14:40:00',1.91),('7643','2014-02-28','14:45:00',2.35),('7643','2014-02-28','14:50:00',2.41),('7643','2014-02-28','14:55:00',2.17),('7643','2014-02-28','15:00:00',1.95),('7643','2014-02-28','16:10:00',1.12),('7643','2014-02-28','16:15:00',1.35),('7643','2014-02-28','16:20:00',1.45),('7643','2014-02-28','16:25:00',1.04),('7643','2014-02-28','17:00:00',1.17),('7643','2014-02-28','17:05:00',1.1),('7643','2014-02-27','07:40:00',1.8),('7643','2014-02-27','07:45:00',2.81),('7643','2014-02-27','07:50:00',3.24),('7643','2014-02-27','07:55:00',3.85),('7643','2014-02-27','08:00:00',4.88),('7643','2014-02-27','08:05:00',4.09),('7643','2014-02-27','08:10:00',4.06),('7643','2014-02-27','08:15:00',3.54),('7643','2014-02-27','08:20:00',7.11),('7643','2014-02-27','08:25:00',6.12),('7643','2014-02-27','08:30:00',2.24),('7643','2014-02-27','08:35:00',8.21),('7643','2014-02-27','08:40:00',4.2),('7643','2014-02-27','08:55:00',1.17),('7643','2014-02-27','09:00:00',1.31),('7643','2014-02-27','09:05:00',1.3),('7643','2014-02-27','09:10:00',2.63),('7643','2014-02-27','09:15:00',4.37),('7643','2014-02-27','09:20:00',4.76),('7643','2014-02-27','09:25:00',4.86),('7643','2014-02-27','09:30:00',6.97),('7643','2014-02-27','09:35:00',4.44),('7643','2014-02-27','09:40:00',7.49),('7643','2014-02-27','09:45:00',11.44),('7643','2014-02-27','09:50:00',12.94),('7643','2014-02-27','09:55:00',11.57),('7643','2014-02-27','10:00:00',5.06),('7643','2014-02-27','10:05:00',4.39),('7643','2014-02-27','10:10:00',6.64),('7643','2014-02-27','10:15:00',4.76),('7643','2014-02-27','10:20:00',5.9),('7643','2014-02-27','10:25:00',13.73),('7643','2014-02-27','10:30:00',14.13),('7643','2014-02-27','10:35:00',11.7),('7643','2014-02-27','10:40:00',5.12),('7643','2014-02-27','10:45:00',2.97),('7643','2014-02-27','10:50:00',1.71),('7643','2014-02-27','10:55:00',1.51),('7643','2014-02-27','11:00:00',1.93),('7643','2014-02-27','11:05:00',2.51),('7643','2014-02-27','11:10:00',2.29),('7643','2014-02-27','11:15:00',2.97),('7643','2014-02-27','11:20:00',4.35),('7643','2014-02-27','11:25:00',4.41),('7643','2014-02-27','11:30:00',3.66),('7643','2014-02-27','11:35:00',2.68),('7643','2014-02-27','11:40:00',2.3),('7643','2014-02-27','11:45:00',3.06),('7643','2014-02-27','11:50:00',3.99),('7643','2014-02-27','11:55:00',4.17),('7643','2014-02-27','12:00:00',5.17),('7643','2014-02-27','12:05:00',7.42),('7643','2014-02-27','12:10:00',8.57),('7643','2014-02-27','12:15:00',5),('7643','2014-02-27','12:20:00',3.92),('7643','2014-02-27','12:25:00',4.73),('7643','2014-02-27','12:30:00',7.34),('7643','2014-02-27','12:35:00',11.03),('7643','2014-02-27','12:40:00',11.02),('7643','2014-02-27','12:45:00',4.3),('7643','2014-02-27','12:50:00',8.22),('7643','2014-02-27','12:55:00',6.08),('7643','2014-02-27','13:00:00',9.3),('7643','2014-02-27','13:05:00',7.12),('7643','2014-02-27','13:10:00',6.04),('7643','2014-02-27','13:15:00',4.03),('7643','2014-02-27','13:20:00',2.06),('7643','2014-02-27','13:40:00',1.05),('7643','2014-02-27','13:45:00',3.18),('7643','2014-02-27','13:50:00',12.39),('7643','2014-02-27','13:55:00',14.96),('7643','2014-02-27','14:00:00',7.4),('7643','2014-02-27','14:05:00',3.97),('7643','2014-02-27','14:10:00',3.27),('7643','2014-02-27','14:15:00',6.36),('7643','2014-02-27','14:20:00',6.75),('7643','2014-02-27','14:25:00',8.84),('7643','2014-02-27','14:30:00',6.56),('7643','2014-02-27','14:35:00',5.29),('7643','2014-02-27','14:40:00',4.7),('7643','2014-02-27','14:45:00',4.65),('7643','2014-02-27','14:50:00',4.99),('7643','2014-02-27','14:55:00',5.54),('7643','2014-02-27','15:00:00',8.17),('7643','2014-02-27','15:05:00',4.24),('7643','2014-02-27','15:10:00',2.13),('7643','2014-02-27','15:15:00',1.37),('7643','2014-02-27','15:20:00',1.91),('7643','2014-02-27','15:25:00',6.93),('7643','2014-02-27','15:30:00',7.68),('7643','2014-02-27','15:35:00',8.87),('7643','2014-02-27','15:40:00',7.25),('7643','2014-02-27','15:45:00',2.48),('7643','2014-02-27','15:50:00',1.49),('7643','2014-02-27','16:10:00',3.29),('7643','2014-02-27','16:15:00',7.01),('7643','2014-02-27','16:20:00',6.11),('7643','2014-02-27','16:25:00',3.23),('7643','2014-02-27','16:30:00',2.09),('7643','2014-02-27','16:35:00',3.47),('7643','2014-02-27','16:40:00',4.41),('7643','2014-02-27','16:45:00',5.33),('7643','2014-02-27','16:50:00',4.57),('7643','2014-02-27','16:55:00',1.69),('7643','2014-02-26','09:35:00',1.13),('7643','2014-02-26','09:40:00',1.19),('7643','2014-02-26','09:45:00',1.38),('7643','2014-02-26','09:50:00',1.5),('7643','2014-02-26','09:55:00',1.55),('7643','2014-02-26','10:00:00',1.7),('7643','2014-02-26','10:05:00',1.64),('7643','2014-02-26','10:10:00',1.72),('7643','2014-02-26','10:15:00',1.67),('7643','2014-02-26','10:20:00',1.72),('7643','2014-02-26','10:25:00',1.9),('7643','2014-02-26','10:30:00',2.76),('7643','2014-02-26','10:35:00',3.44),('7643','2014-02-26','10:40:00',3.91),('7643','2014-02-26','10:45:00',4.35),('7643','2014-02-26','10:50:00',4.61),('7643','2014-02-26','10:55:00',4.94),('7643','2014-02-26','11:00:00',5.52),('7643','2014-02-26','11:05:00',6.34),('7643','2014-02-26','11:10:00',5.91),('7643','2014-02-26','11:15:00',5.75),('7643','2014-02-26','11:20:00',5.37),('7643','2014-02-26','11:25:00',5.8),('7643','2014-02-26','11:30:00',7.24),('7643','2014-02-26','11:35:00',6.87),('7643','2014-02-26','11:40:00',5.56),('7643','2014-02-26','11:45:00',4.81),('7643','2014-02-26','11:50:00',4.58),('7643','2014-02-26','11:55:00',4.61),('7643','2014-02-26','12:00:00',4.48),('7643','2014-02-26','12:05:00',4.51),('7643','2014-02-26','12:10:00',3.78),('7643','2014-02-26','12:15:00',4.17),('7643','2014-02-26','12:20:00',4.59),('7643','2014-02-26','12:25:00',4.72),('7643','2014-02-26','12:30:00',4.37),('7643','2014-02-26','12:35:00',4.24),('7643','2014-02-26','12:40:00',4.13),('7643','2014-02-26','12:45:00',4.06),('7643','2014-02-26','12:50:00',3.95),('7643','2014-02-26','12:55:00',4.04),('7643','2014-02-26','13:00:00',4.26),('7643','2014-02-26','13:05:00',3.93),('7643','2014-02-26','13:10:00',4.1),('7643','2014-02-26','13:15:00',4.61),('7643','2014-02-26','13:20:00',4.61),('7643','2014-02-26','13:25:00',4.89),('7643','2014-02-26','13:30:00',5.46),('7643','2014-02-26','13:35:00',6.04),('7643','2014-02-26','13:40:00',6.12),('7643','2014-02-26','13:45:00',6.15),('7643','2014-02-26','13:50:00',6.54),('7643','2014-02-26','13:55:00',7.15),('7643','2014-02-26','14:00:00',7.18),('7643','2014-02-26','14:05:00',6.4),('7643','2014-02-26','14:10:00',5.5),('7643','2014-02-26','14:15:00',5.09),('7643','2014-02-26','14:20:00',5.18),('7643','2014-02-26','14:25:00',5.3),('7643','2014-02-26','14:30:00',5.79),('7643','2014-02-26','14:35:00',5.63),('7643','2014-02-26','14:40:00',4.95),('7643','2014-02-26','14:45:00',4.9),('7643','2014-02-26','14:50:00',4.53),('7643','2014-02-26','14:55:00',4.2),('7643','2014-02-26','15:00:00',4.29),('7643','2014-02-26','15:05:00',3.91),('7643','2014-02-26','15:10:00',4.21),('7643','2014-02-26','15:15:00',5.02),('7643','2014-02-26','15:20:00',5.49),('7643','2014-02-26','15:25:00',4.85),('7643','2014-02-26','15:30:00',4.78),('7643','2014-02-26','15:35:00',4.96),('7643','2014-02-26','15:40:00',4.37),('7643','2014-02-26','15:45:00',3.2),('7643','2014-02-26','15:50:00',2.81),('7643','2014-02-26','15:55:00',2.3),('7643','2014-02-26','16:00:00',2.35),('7643','2014-02-26','16:05:00',2.34),('7643','2014-02-26','16:10:00',2.1),('7643','2014-02-26','16:15:00',1.58),('7643','2014-02-26','16:20:00',1.38),('7643','2014-02-26','16:25:00',1.63),('7643','2014-02-26','16:30:00',1.9),('7643','2014-02-26','16:35:00',2.6),('7643','2014-02-26','16:40:00',4.21),('7643','2014-02-26','16:45:00',3.15),('7643','2014-02-26','16:50:00',4.01),('7643','2014-02-26','16:55:00',3.91),('7643','2014-02-26','17:00:00',3.32),('7643','2014-02-26','17:05:00',2.54),('7643','2014-02-26','17:10:00',1.83),('7643','2014-02-26','17:15:00',1.01),('7643','2014-02-25','07:25:00',1.19),('7643','2014-02-25','07:30:00',1.53),('7643','2014-02-25','07:35:00',1.77),('7643','2014-02-25','07:40:00',1.98),('7643','2014-02-25','07:45:00',2.19),('7643','2014-02-25','07:50:00',2.44),('7643','2014-02-25','07:55:00',2.99),('7643','2014-02-25','08:00:00',3.61),('7643','2014-02-25','08:05:00',3.92),('7643','2014-02-25','08:10:00',4.45),('7643','2014-02-25','08:15:00',4.88),('7643','2014-02-25','08:20:00',5.22),('7643','2014-02-25','08:25:00',5.55),('7643','2014-02-25','08:30:00',5.77),('7643','2014-02-25','08:35:00',6.31),('7643','2014-02-25','08:40:00',6.73),('7643','2014-02-25','08:45:00',7.52),('7643','2014-02-25','08:50:00',7.67),('7643','2014-02-25','08:55:00',7.69),('7643','2014-02-25','09:00:00',7.78),('7643','2014-02-25','09:05:00',7.85),('7643','2014-02-25','09:10:00',7.73),('7643','2014-02-25','09:15:00',8.56),('7643','2014-02-25','09:20:00',8.86),('7643','2014-02-25','09:25:00',9.28),('7643','2014-02-25','09:30:00',8.82),('7643','2014-02-25','09:35:00',9.03),('7643','2014-02-25','09:40:00',6.06),('7643','2014-02-25','09:45:00',9.9),('7643','2014-02-25','09:50:00',8),('7643','2014-02-25','09:55:00',5.1),('7643','2014-02-25','10:00:00',4.95),('7643','2014-02-25','10:05:00',4.05),('7643','2014-02-25','10:10:00',3.06),('7643','2014-02-25','10:15:00',3.02),('7643','2014-02-25','10:20:00',3.66),('7643','2014-02-25','10:25:00',3.8),('7643','2014-02-25','10:30:00',3.79),('7643','2014-02-25','10:35:00',3.38),('7643','2014-02-25','10:40:00',2.8),('7643','2014-02-25','10:45:00',2.35),('7643','2014-02-25','10:50:00',2.17),('7643','2014-02-25','10:55:00',2.69),('7643','2014-02-25','11:00:00',3.29),('7643','2014-02-25','11:05:00',3.68),('7643','2014-02-25','11:10:00',3.72),('7643','2014-02-25','11:15:00',3.6),('7643','2014-02-25','11:20:00',2.61),('7643','2014-02-25','11:25:00',2.04),('7643','2014-02-25','11:30:00',2.18),('7643','2014-02-25','11:35:00',2.53),('7643','2014-02-25','11:40:00',2.37),('7643','2014-02-25','11:45:00',2.37),('7643','2014-02-25','11:50:00',2.96),('7643','2014-02-25','11:55:00',3.15),('7643','2014-02-25','12:00:00',4.28),('7643','2014-02-25','12:05:00',7.43),('7643','2014-02-25','12:10:00',9.28),('7643','2014-02-25','12:15:00',4.79),('7643','2014-02-25','12:20:00',3.96),('7643','2014-02-25','12:25:00',4.52),('7643','2014-02-25','12:30:00',7.43),('7643','2014-02-25','12:35:00',6.64),('7643','2014-02-25','12:40:00',7.33),('7643','2014-02-25','12:45:00',7.69),('7643','2014-02-25','12:50:00',10.84),('7643','2014-02-25','12:55:00',5.92),('7643','2014-02-25','13:00:00',8.71),('7643','2014-02-25','13:05:00',11.92),('7643','2014-02-25','13:10:00',10.91),('7643','2014-02-25','13:15:00',11.19),('7643','2014-02-25','13:20:00',11.99),('7643','2014-02-25','13:25:00',11.59),('7643','2014-02-25','13:30:00',14.32),('7643','2014-02-25','13:35:00',13.31),('7643','2014-02-25','13:40:00',13.11),('7643','2014-02-25','13:45:00',11.22),('7643','2014-02-25','13:50:00',10.52),('7643','2014-02-25','13:55:00',6.22),('7643','2014-02-25','14:00:00',13.52),('7643','2014-02-25','14:05:00',10.85),('7643','2014-02-25','14:10:00',6.19),('7643','2014-02-25','14:15:00',10.31),('7643','2014-02-25','14:20:00',11.66),('7643','2014-02-25','14:25:00',12.84),('7643','2014-02-25','14:30:00',7.57),('7643','2014-02-25','14:35:00',7.26),('7643','2014-02-25','14:40:00',11.82),('7643','2014-02-25','14:45:00',11.41),('7643','2014-02-25','14:50:00',3.02),('7643','2014-02-25','14:55:00',10.63),('7643','2014-02-25','15:00:00',10.37),('7643','2014-02-25','15:05:00',5.4),('7643','2014-02-25','15:10:00',9.42),('7643','2014-02-25','15:15:00',8.14),('7643','2014-02-25','15:20:00',6.83),('7643','2014-02-25','15:25:00',4.66),('7643','2014-02-25','15:30:00',4.56),('7643','2014-02-25','15:35:00',6.09),('7643','2014-02-25','15:40:00',5.78),('7643','2014-02-25','15:45:00',4.72),('7643','2014-02-25','15:50:00',4.4),('7643','2014-02-25','15:55:00',5.55),('7643','2014-02-25','16:00:00',6.44),('7643','2014-02-25','16:05:00',5.97),('7643','2014-02-25','16:10:00',4.04),('7643','2014-02-25','16:15:00',2.77),('7643','2014-02-25','16:20:00',3.15),('7643','2014-02-25','16:25:00',2.27),('7643','2014-02-25','16:30:00',1.76),('7643','2014-02-25','16:35:00',1.57),('7643','2014-02-25','16:40:00',1.28),('7643','2014-04-28','09:00:00',1.01),('7643','2014-04-28','09:05:00',1.3),('7643','2014-04-28','09:10:00',1.47),('7643','2014-04-28','09:15:00',1.79),('7643','2014-04-28','09:20:00',1.68),('7643','2014-04-28','09:25:00',1.35),('7643','2014-04-28','09:30:00',1.37),('7643','2014-04-28','09:35:00',1.55),('7643','2014-04-28','09:40:00',1.96),('7643','2014-04-28','09:45:00',2.71),('7643','2014-04-28','09:50:00',3.66),('7643','2014-04-28','09:55:00',4.15),('7643','2014-04-28','10:00:00',4.19),('7643','2014-04-28','10:05:00',6.75),('7643','2014-04-28','10:10:00',14.81),('7643','2014-04-28','10:15:00',11.75),('7643','2014-04-28','10:20:00',11.95),('7643','2014-04-28','10:25:00',13.33),('7643','2014-04-28','10:30:00',15.37),('7643','2014-04-28','10:35:00',15.59),('7643','2014-04-28','10:40:00',15.66),('7643','2014-04-28','10:45:00',15.66),('7643','2014-04-28','10:50:00',15.95),('7643','2014-04-28','10:55:00',15.48),('7643','2014-04-28','11:00:00',15.6),('7643','2014-04-28','11:05:00',15.6),('7643','2014-04-28','11:10:00',15.9),('7643','2014-04-28','11:15:00',15.76),('7643','2014-04-28','11:20:00',14.79),('7643','2014-04-28','11:25:00',13.44),('7643','2014-04-28','11:30:00',13.87),('7643','2014-04-28','11:35:00',11.76),('7643','2014-04-28','11:40:00',17.83),('7643','2014-04-28','11:45:00',11.2),('7643','2014-04-28','11:50:00',5.18),('7643','2014-04-28','11:55:00',4.48),('7643','2014-04-28','12:00:00',5.05),('7643','2014-04-28','12:05:00',7.06),('7643','2014-04-28','12:10:00',9.98),('7643','2014-04-28','12:15:00',15.54),('7643','2014-04-28','12:20:00',7.77),('7643','2014-04-28','12:25:00',11.81),('7643','2014-04-28','12:30:00',11.2),('7643','2014-04-28','12:35:00',14.56),('7643','2014-04-28','12:40:00',19),('7643','2014-04-28','12:45:00',8.72),('7643','2014-04-28','12:50:00',17.21),('7643','2014-04-28','12:55:00',14.37),('7643','2014-04-28','13:00:00',8.34),('7643','2014-04-28','13:05:00',6.83),('7643','2014-04-28','13:10:00',7.04),('7643','2014-04-28','13:15:00',10.89),('7643','2014-04-28','13:20:00',9.71),('7643','2014-04-28','13:25:00',10.49),('7643','2014-04-28','13:30:00',16.09),('7643','2014-04-28','13:35:00',6.59),('7643','2014-04-28','13:40:00',5.77),('7643','2014-04-28','13:45:00',5.89),('7643','2014-04-28','13:50:00',9.25),('7643','2014-04-28','13:55:00',7.02),('7643','2014-04-28','14:00:00',2.72),('7643','2014-04-28','14:05:00',1.68),('7643','2014-04-28','14:10:00',1.39),('7643','2014-04-28','14:15:00',1.46),('7643','2014-04-28','14:20:00',1.83),('7643','2014-04-28','14:25:00',2.34),('7643','2014-04-28','14:30:00',2.4),('7643','2014-04-28','14:35:00',2.62),('7643','2014-04-28','14:40:00',2.87),('7643','2014-04-28','14:45:00',2.49),('7643','2014-04-28','14:50:00',1.96),('7643','2014-04-28','14:55:00',1.98),('7643','2014-04-28','15:00:00',2.89),('7643','2014-04-28','15:05:00',4.53),('7643','2014-04-28','15:10:00',3.25),('7643','2014-04-28','15:15:00',2.01),('7643','2014-04-28','15:20:00',1.53),('7643','2014-04-28','15:25:00',1.97),('7643','2014-04-28','15:30:00',2.32),('7643','2014-04-28','15:35:00',2.22),('7643','2014-04-28','15:40:00',1.48),('7643','2014-04-28','15:45:00',1.28),('7643','2014-04-28','15:50:00',1.36),('7643','2014-04-28','15:55:00',1.59),('7643','2014-04-28','16:00:00',1.73),('7643','2014-04-28','16:05:00',2.14),('7643','2014-04-28','16:10:00',2.53),('7643','2014-04-28','16:15:00',3.23),('7643','2014-04-28','16:20:00',3.78),('7643','2014-04-28','16:25:00',4.35),('7643','2014-04-28','16:30:00',3.87),('7643','2014-04-28','16:35:00',3.19),('7643','2014-04-28','16:40:00',2.55),('7643','2014-04-28','16:45:00',2.3),('7643','2014-04-28','16:50:00',2.5),('7643','2014-04-28','16:55:00',2.9),('7643','2014-04-28','17:00:00',3.44),('7643','2014-04-28','17:05:00',4.49),('7643','2014-04-28','17:10:00',4.55),('7643','2014-04-28','17:15:00',3.51),('7643','2014-04-28','17:20:00',3.25),('7643','2014-04-28','17:25:00',5.67),('7643','2014-04-28','17:30:00',6.29),('7643','2014-04-28','17:35:00',6.26),('7643','2014-04-28','17:40:00',5.92),('7643','2014-04-28','17:45:00',7.19),('7643','2014-04-28','17:50:00',4.29),('7643','2014-04-28','17:55:00',1.83),('7643','2014-04-28','18:00:00',2.38),('7643','2014-04-28','18:05:00',2.84),('7643','2014-04-28','18:10:00',2.12),('7643','2014-04-28','18:15:00',1.16),('7643','2014-04-28','18:30:00',1.47),('7643','2014-04-28','18:35:00',1.45),('7643','2014-04-28','18:40:00',1.2),('7643','2014-04-28','19:00:00',1.17),('7643','2014-02-24','07:25:00',1.18),('7643','2014-02-24','07:30:00',1.45),('7643','2014-02-24','07:35:00',1.74),('7643','2014-02-24','07:40:00',2.06),('7643','2014-02-24','07:45:00',2.39),('7643','2014-02-24','07:50:00',2.75),('7643','2014-02-24','07:55:00',3.1),('7643','2014-02-24','08:00:00',3.45),('7643','2014-02-24','08:05:00',3.79),('7643','2014-02-24','08:10:00',4.14),('7643','2014-02-24','08:15:00',4.51),('7643','2014-02-24','08:20:00',4.88),('7643','2014-02-24','08:25:00',5.24),('7643','2014-02-24','08:30:00',5.61),('7643','2014-02-24','08:35:00',5.93),('7643','2014-02-24','08:40:00',6.25),('7643','2014-02-24','08:45:00',6.63),('7643','2014-02-24','08:50:00',6.94),('7643','2014-02-24','08:55:00',7.26),('7643','2014-02-24','09:00:00',7.58),('7643','2014-02-24','09:05:00',7.89),('7643','2014-02-24','09:10:00',8.12),('7643','2014-02-24','09:15:00',8.41),('7643','2014-02-24','09:20:00',8.67),('7643','2014-02-24','09:25:00',8.86),('7643','2014-02-24','09:30:00',9.16),('7643','2014-02-24','09:35:00',9.36),('7643','2014-02-24','09:40:00',9.6),('7643','2014-02-24','09:45:00',9.8),('7643','2014-02-24','09:50:00',10.03),('7643','2014-02-24','09:55:00',10.23),('7643','2014-02-24','10:00:00',10.38),('7643','2014-02-24','10:05:00',10.6),('7643','2014-02-24','10:10:00',10.82),('7643','2014-02-24','10:15:00',11.01),('7643','2014-02-24','10:20:00',11.21),('7643','2014-02-24','10:25:00',11.36),('7643','2014-02-24','10:30:00',11.41),('7643','2014-02-24','10:35:00',11.46),('7643','2014-02-24','10:40:00',11.63),('7643','2014-02-24','10:45:00',11.76),('7643','2014-02-24','10:50:00',11.8),('7643','2014-02-24','10:55:00',11.99),('7643','2014-02-24','11:00:00',12.11),('7643','2014-02-24','11:05:00',12.2),('7643','2014-02-24','11:10:00',12.36),('7643','2014-02-24','11:15:00',12.4),('7643','2014-02-24','11:20:00',12.63),('7643','2014-02-24','11:25:00',12.64),('7643','2014-02-24','11:30:00',12.64),('7643','2014-02-24','11:35:00',12.77),('7643','2014-02-24','11:40:00',12.74),('7643','2014-02-24','11:45:00',12.79),('7643','2014-02-24','11:50:00',12.8),('7643','2014-02-24','11:55:00',12.79),('7643','2014-02-24','12:00:00',12.59),('7643','2014-02-24','12:05:00',13.06),('7643','2014-02-24','12:10:00',13.12),('7643','2014-02-24','12:15:00',13.14),('7643','2014-02-24','12:20:00',13.03),('7643','2014-02-24','12:25:00',12.94),('7643','2014-02-24','12:30:00',12.98),('7643','2014-02-24','12:35:00',12.96),('7643','2014-02-24','12:40:00',12.97),('7643','2014-02-24','12:45:00',12.9),('7643','2014-02-24','12:50:00',12.97),('7643','2014-02-24','12:55:00',13.1),('7643','2014-02-24','13:00:00',12.72),('7643','2014-02-24','13:05:00',12.94),('7643','2014-02-24','13:10:00',12.78),('7643','2014-02-24','13:15:00',7.46),('7643','2014-02-24','13:20:00',3.41),('7643','2014-02-24','13:25:00',3.13),('7643','2014-02-24','13:30:00',3.18),('7643','2014-02-24','13:35:00',4.65),('7643','2014-02-24','13:40:00',5.07),('7643','2014-02-24','13:45:00',3.92),('7643','2014-02-24','13:50:00',3.66),('7643','2014-02-24','13:55:00',4.42),('7643','2014-02-24','14:00:00',4.76),('7643','2014-02-24','14:05:00',4.12),('7643','2014-02-24','14:10:00',3.61),('7643','2014-02-24','14:15:00',3.99),('7643','2014-02-24','14:20:00',4.11),('7643','2014-02-24','14:25:00',4.57),('7643','2014-02-24','14:30:00',5.11),('7643','2014-02-24','14:35:00',8.49),('7643','2014-02-24','14:40:00',10.58),('7643','2014-02-24','14:45:00',10.42),('7643','2014-02-24','14:50:00',10.14),('7643','2014-02-24','14:55:00',6.07),('7643','2014-02-24','15:00:00',9.09),('7643','2014-02-24','15:05:00',8.83),('7643','2014-02-24','15:10:00',8.82),('7643','2014-02-24','15:15:00',8.34),('7643','2014-02-24','15:20:00',8.03),('7643','2014-02-24','15:25:00',6.96),('7643','2014-02-24','15:30:00',6.09),('7643','2014-02-24','15:35:00',5.56),('7643','2014-02-24','15:40:00',6.17),('7643','2014-02-24','15:45:00',4.43),('7643','2014-02-24','15:50:00',3.3),('7643','2014-02-24','15:55:00',3.69),('7643','2014-02-24','16:00:00',3.31),('7643','2014-02-24','16:05:00',3.65),('7643','2014-02-24','16:10:00',3.46),('7643','2014-02-24','16:15:00',3.69),('7643','2014-02-24','16:20:00',3.91),('7643','2014-02-24','16:25:00',3.18),('7643','2014-02-24','16:30:00',1.72),('7643','2014-02-24','16:35:00',1.25),('7643','2014-02-24','16:40:00',1.12),('7643','2014-02-23','07:20:00',1.05),('7643','2014-02-23','07:25:00',1.34),('7643','2014-02-23','07:30:00',1.65),('7643','2014-02-23','07:35:00',1.92),('7643','2014-02-23','07:40:00',2.15),('7643','2014-02-23','07:45:00',1.35),('7643','2014-02-23','07:50:00',2.27),('7643','2014-02-23','07:55:00',3.23),('7643','2014-02-23','08:00:00',3.79),('7643','2014-02-23','08:05:00',4.52),('7643','2014-02-23','08:10:00',5.16),('7643','2014-02-23','08:15:00',5.65),('7643','2014-02-23','08:20:00',6.07),('7643','2014-02-23','08:25:00',6.54),('7643','2014-02-23','08:30:00',7.01),('7643','2014-02-23','08:35:00',7.44),('7643','2014-02-23','08:40:00',6.59),('7643','2014-02-23','08:45:00',7.99),('7643','2014-02-23','08:50:00',7.54),('7643','2014-02-23','08:55:00',7.46),('7643','2014-02-23','09:00:00',7.55),('7643','2014-02-23','09:05:00',7.79),('7643','2014-02-23','09:10:00',8.09),('7643','2014-02-23','09:15:00',8.4),('7643','2014-02-23','09:20:00',8.64),('7643','2014-02-23','09:25:00',8.86),('7643','2014-02-23','09:30:00',9.21),('7643','2014-02-23','09:35:00',9.4),('7643','2014-02-23','09:40:00',9.62),('7643','2014-02-23','09:45:00',9.89),('7643','2014-02-23','09:50:00',10.13),('7643','2014-02-23','09:55:00',10.33),('7643','2014-02-23','10:00:00',10.54),('7643','2014-02-23','10:05:00',10.76),('7643','2014-02-23','10:10:00',10.99),('7643','2014-02-23','10:15:00',11.22),('7643','2014-02-23','10:20:00',11.39),('7643','2014-02-23','10:25:00',11.57),('7643','2014-02-23','10:30:00',11.74),('7643','2014-02-23','10:35:00',11.9),('7643','2014-02-23','10:40:00',12.03),('7643','2014-02-23','10:45:00',12.27),('7643','2014-02-23','10:50:00',12.43),('7643','2014-02-23','10:55:00',12.52),('7643','2014-02-23','11:00:00',12.62),('7643','2014-02-23','11:05:00',12.79),('7643','2014-02-23','11:10:00',12.95),('7643','2014-02-23','11:15:00',12.96),('7643','2014-02-23','11:20:00',12.95),('7643','2014-02-23','11:25:00',13.23),('7643','2014-02-23','11:30:00',14.58),('7643','2014-02-23','11:35:00',10.22),('7643','2014-02-23','11:40:00',13.7),('7643','2014-02-23','11:45:00',15),('7643','2014-02-23','11:50:00',12.33),('7643','2014-02-23','11:55:00',8.91),('7643','2014-02-23','12:00:00',13.31),('7643','2014-02-23','12:05:00',10.75),('7643','2014-02-23','12:10:00',12.08),('7643','2014-02-23','12:15:00',13.08),('7643','2014-02-23','12:20:00',8.44),('7643','2014-02-23','12:25:00',14.26),('7643','2014-02-23','12:30:00',12.87),('7643','2014-02-23','12:35:00',7.07),('7643','2014-02-23','12:40:00',12.15),('7643','2014-02-23','12:45:00',11.72),('7643','2014-02-23','12:50:00',14.32),('7643','2014-02-23','12:55:00',14),('7643','2014-02-23','13:00:00',14.04),('7643','2014-02-23','13:05:00',13.22),('7643','2014-02-23','13:10:00',14.77),('7643','2014-02-23','13:15:00',16.58),('7643','2014-02-23','13:20:00',8.19),('7643','2014-02-23','13:25:00',3.97),('7643','2014-02-23','13:30:00',3.51),('7643','2014-02-23','13:35:00',3.22),('7643','2014-02-23','13:40:00',3.03),('7643','2014-02-23','13:45:00',2.82),('7643','2014-02-23','13:50:00',2.68),('7643','2014-02-23','13:55:00',2.84),('7643','2014-02-23','14:00:00',3.08),('7643','2014-02-23','14:05:00',3.22),('7643','2014-02-23','14:10:00',3.42),('7643','2014-02-23','14:15:00',3.45),('7643','2014-02-23','14:20:00',3.41),('7643','2014-02-23','14:25:00',3.52),('7643','2014-02-23','14:30:00',3.73),('7643','2014-02-23','14:35:00',3.68),('7643','2014-02-23','14:40:00',3.68),('7643','2014-02-23','14:45:00',4),('7643','2014-02-23','14:50:00',3.72),('7643','2014-02-23','14:55:00',3.06),('7643','2014-02-23','15:00:00',2.9),('7643','2014-02-23','15:05:00',3.08),('7643','2014-02-23','15:10:00',3.38),('7643','2014-02-23','15:15:00',3.54),('7643','2014-02-23','15:20:00',4.14),('7643','2014-02-23','15:25:00',5.31),('7643','2014-02-23','15:30:00',5.96),('7643','2014-02-23','15:35:00',8.44),('7643','2014-02-23','15:40:00',9.37),('7643','2014-02-23','15:45:00',8.85),('7643','2014-02-23','15:50:00',8.39),('7643','2014-02-23','15:55:00',7.21),('7643','2014-02-23','16:00:00',7.54),('7643','2014-02-23','16:05:00',7.57),('7643','2014-02-23','16:10:00',6.99),('7643','2014-02-23','16:15:00',6.33),('7643','2014-02-23','16:20:00',5.25),('7643','2014-02-23','16:25:00',4.14),('7643','2014-02-23','16:30:00',2.09),('7643','2014-02-23','16:35:00',1.51),('7643','2014-02-23','16:45:00',2.26),('7643','2014-02-23','16:50:00',2.28),('7643','2014-02-23','16:55:00',2.04),('7643','2014-02-23','17:00:00',1.75),('7643','2014-02-23','17:05:00',1.45),('7643','2014-02-23','17:10:00',1.18),('7643','2014-02-23','17:15:00',1.01),('7643','2014-02-22','07:30:00',1.31),('7643','2014-02-22','07:35:00',1.5),('7643','2014-02-22','07:40:00',1.84),('7643','2014-02-22','07:45:00',2.27),('7643','2014-02-22','07:50:00',2.63),('7643','2014-02-22','07:55:00',2.97),('7643','2014-02-22','08:00:00',3.3),('7643','2014-02-22','08:05:00',3.66),('7643','2014-02-22','08:10:00',4.01),('7643','2014-02-22','08:15:00',4.38),('7643','2014-02-22','08:20:00',4.74),('7643','2014-02-22','08:25:00',5.07),('7643','2014-02-22','08:30:00',5.41),('7643','2014-02-22','08:35:00',5.75),('7643','2014-02-22','08:40:00',6.09),('7643','2014-02-22','08:45:00',6.42),('7643','2014-02-22','08:50:00',6.74),('7643','2014-02-22','08:55:00',7.04),('7643','2014-02-22','09:00:00',7.38),('7643','2014-02-22','09:05:00',7.74),('7643','2014-02-22','09:10:00',8.09),('7643','2014-02-22','09:15:00',8.43),('7643','2014-02-22','09:20:00',8.73),('7643','2014-02-22','09:25:00',8.63),('7643','2014-02-22','09:30:00',8.05),('7643','2014-02-22','09:35:00',9.36),('7643','2014-02-22','09:40:00',9.62),('7643','2014-02-22','09:45:00',9.78),('7643','2014-02-22','09:50:00',10.02),('7643','2014-02-22','09:55:00',10.14),('7643','2014-02-22','10:00:00',10.24),('7643','2014-02-22','10:05:00',10.49),('7643','2014-02-22','10:10:00',10.68),('7643','2014-02-22','10:15:00',10.81),('7643','2014-02-22','10:20:00',11.13),('7643','2014-02-22','10:25:00',11.35),('7643','2014-02-22','10:30:00',11.57),('7643','2014-02-22','10:35:00',11.8),('7643','2014-02-22','10:40:00',11.91),('7643','2014-02-22','10:45:00',12.09),('7643','2014-02-22','10:50:00',11.99),('7643','2014-02-22','10:55:00',12.06),('7643','2014-02-22','11:00:00',12.35),('7643','2014-02-22','11:05:00',12.54),('7643','2014-02-22','11:10:00',12.76),('7643','2014-02-22','11:15:00',12.76),('7643','2014-02-22','11:20:00',12.86),('7643','2014-02-22','11:25:00',11.26),('7643','2014-02-22','11:30:00',12.29),('7643','2014-02-22','11:35:00',13.52),('7643','2014-02-22','11:40:00',13.6),('7643','2014-02-22','11:45:00',13.26),('7643','2014-02-22','11:50:00',8.4),('7643','2014-02-22','11:55:00',13.69),('7643','2014-02-22','12:00:00',8.57),('7643','2014-02-22','12:05:00',12.78),('7643','2014-02-22','12:10:00',14.75),('7643','2014-02-22','12:15:00',14.61),('7643','2014-02-22','12:20:00',13.61),('7643','2014-02-22','12:25:00',8.85),('7643','2014-02-22','12:30:00',9.45),('7643','2014-02-22','12:35:00',14.96),('7643','2014-02-22','12:40:00',8.78),('7643','2014-02-22','12:45:00',9.03),('7643','2014-02-22','12:50:00',6.98),('7643','2014-02-22','12:55:00',7.51),('7643','2014-02-22','13:00:00',8.57),('7643','2014-02-22','13:05:00',13.15),('7643','2014-02-22','13:10:00',13.38),('7643','2014-02-22','13:15:00',13.16),('7643','2014-02-22','13:20:00',13.02),('7643','2014-02-22','13:25:00',13.04),('7643','2014-02-22','13:30:00',12.77),('7643','2014-02-22','13:35:00',8),('7643','2014-02-22','13:40:00',9.79),('7643','2014-02-22','13:45:00',10.83),('7643','2014-02-22','13:50:00',9.79),('7643','2014-02-22','13:55:00',2.75),('7643','2014-02-22','14:00:00',10.16),('7643','2014-02-22','14:05:00',10.44),('7643','2014-02-22','14:10:00',12.09),('7643','2014-02-22','14:15:00',9.95),('7643','2014-02-22','14:20:00',6.34),('7643','2014-02-22','14:25:00',8.75),('7643','2014-02-22','14:30:00',11.53),('7643','2014-02-22','14:35:00',9.09),('7643','2014-02-22','14:40:00',4.52),('7643','2014-02-22','14:45:00',4.36),('7643','2014-02-22','14:50:00',4.28),('7643','2014-02-22','14:55:00',2.5),('7643','2014-02-22','15:00:00',2.2),('7643','2014-02-22','15:05:00',1.73),('7643','2014-02-22','15:10:00',1.28),('7643','2014-02-22','15:15:00',1.01),('7643','2014-02-21','08:30:00',1.39),('7643','2014-02-21','08:35:00',1.55),('7643','2014-02-21','08:40:00',2.3),('7643','2014-02-21','08:45:00',1.84),('7643','2014-02-21','08:50:00',1.68),('7643','2014-02-21','08:55:00',1.06),('7643','2014-02-21','09:00:00',1.83),('7643','2014-02-21','09:05:00',3.12),('7643','2014-02-21','09:10:00',4.68),('7643','2014-02-21','09:15:00',2.04),('7643','2014-02-21','09:20:00',2.22),('7643','2014-02-21','09:25:00',2.93),('7643','2014-02-21','09:30:00',2.73),('7643','2014-02-21','09:35:00',2.94),('7643','2014-02-21','09:40:00',3.07),('7643','2014-02-21','09:45:00',3.01),('7643','2014-02-21','09:50:00',3.46),('7643','2014-02-21','09:55:00',3.58),('7643','2014-02-21','10:00:00',5.64),('7643','2014-02-21','10:05:00',8.91),('7643','2014-02-21','10:10:00',7.97),('7643','2014-02-21','10:15:00',8.87),('7643','2014-02-21','10:20:00',4.83),('7643','2014-02-21','10:25:00',7.74),('7643','2014-02-21','10:30:00',9.86),('7643','2014-02-21','10:35:00',6.36),('7643','2014-02-21','10:40:00',5.86),('7643','2014-02-21','10:45:00',10.93),('7643','2014-02-21','10:50:00',13.93),('7643','2014-02-21','10:55:00',4.58),('7643','2014-02-21','11:00:00',2.91),('7643','2014-02-21','11:05:00',2.13),('7643','2014-02-21','11:10:00',2.99),('7643','2014-02-21','11:15:00',2.76),('7643','2014-02-21','11:20:00',1.9),('7643','2014-02-21','11:25:00',1.48),('7643','2014-02-21','11:30:00',1.33),('7643','2014-02-21','11:45:00',1.1),('7643','2014-02-21','11:50:00',1.95),('7643','2014-02-21','11:55:00',2.71),('7643','2014-02-21','12:00:00',3.69),('7643','2014-02-21','12:05:00',4.17),('7643','2014-02-21','12:10:00',5.09),('7643','2014-02-21','12:15:00',8.03),('7643','2014-02-21','12:20:00',6.81),('7643','2014-02-21','12:25:00',6.81),('7643','2014-02-21','12:30:00',3.98),('7643','2014-02-21','12:35:00',4.01),('7643','2014-02-21','12:40:00',4.63),('7643','2014-02-21','12:45:00',13.67),('7643','2014-02-21','12:50:00',11.37),('7643','2014-02-21','12:55:00',5.57),('7643','2014-02-21','13:00:00',5.22),('7643','2014-02-21','13:05:00',6.39),('7643','2014-02-21','13:10:00',15.88),('7643','2014-02-21','13:15:00',9.92),('7643','2014-02-21','13:20:00',5.53),('7643','2014-02-21','13:25:00',3.96),('7643','2014-02-21','13:30:00',4.12),('7643','2014-02-21','13:35:00',5.52),('7643','2014-02-21','13:40:00',6.62),('7643','2014-02-21','13:45:00',5.63),('7643','2014-02-21','13:50:00',4.84),('7643','2014-02-21','13:55:00',13.31),('7643','2014-02-21','14:00:00',13.06),('7643','2014-02-21','14:05:00',8.72),('7643','2014-02-21','14:10:00',7.47),('7643','2014-02-21','14:15:00',7.15),('7643','2014-02-21','14:20:00',11.5),('7643','2014-02-21','14:25:00',8.88),('7643','2014-02-21','14:30:00',9.68),('7643','2014-02-21','14:35:00',3.32),('7643','2014-02-21','14:40:00',9.3),('7643','2014-02-21','14:45:00',11.07),('7643','2014-02-21','14:50:00',10.74),('7643','2014-02-21','14:55:00',2.98),('7643','2014-02-21','15:00:00',5.63),('7643','2014-02-21','15:05:00',8.03),('7643','2014-02-21','15:10:00',5.15),('7643','2014-02-21','15:15:00',3.98),('7643','2014-02-21','15:20:00',6.12),('7643','2014-02-21','15:25:00',3.44),('7643','2014-02-21','15:30:00',7.69),('7643','2014-02-21','15:35:00',6.26),('7643','2014-02-21','15:40:00',1.64),('7643','2014-02-21','15:45:00',6.65),('7643','2014-02-21','15:50:00',6.5),('7643','2014-02-21','15:55:00',5.48),('7643','2014-02-21','16:00:00',5.96),('7643','2014-02-21','16:05:00',4.04),('7643','2014-02-21','16:10:00',3.92),('7643','2014-02-21','16:15:00',4.72),('7643','2014-02-21','16:20:00',4.29),('7643','2014-02-21','16:25:00',3.91),('7643','2014-02-21','16:30:00',3.49),('7643','2014-02-21','16:35:00',3.22),('7643','2014-02-21','16:40:00',2.82),('7643','2014-02-21','16:45:00',2.63),('7643','2014-02-21','16:50:00',2.28),('7643','2014-02-21','16:55:00',1.66),('7643','2014-02-21','17:00:00',1.53),('7643','2014-02-21','17:05:00',1.28),('7643','2014-02-20','08:05:00',1.02),('7643','2014-02-20','08:10:00',1.22),('7643','2014-02-20','08:15:00',1.42),('7643','2014-02-20','08:20:00',1.62),('7643','2014-02-20','08:25:00',1.8),('7643','2014-02-20','08:30:00',1.97),('7643','2014-02-20','08:35:00',2.11),('7643','2014-02-20','08:40:00',2.3),('7643','2014-02-20','08:45:00',2.5),('7643','2014-02-20','08:50:00',2.59),('7643','2014-02-20','08:55:00',2.71),('7643','2014-02-20','09:00:00',2.62),('7643','2014-02-20','09:05:00',2.6),('7643','2014-02-20','09:10:00',2.67),('7643','2014-02-20','09:15:00',2.7),('7643','2014-02-20','09:20:00',3.01),('7643','2014-02-20','09:25:00',3.19),('7643','2014-02-20','09:30:00',3.27),('7643','2014-02-20','09:35:00',3.46),('7643','2014-02-20','09:40:00',3.63),('7643','2014-02-20','09:45:00',3.92),('7643','2014-02-20','09:50:00',4.48),('7643','2014-02-20','09:55:00',4.35),('7643','2014-02-20','10:00:00',4.41),('7643','2014-02-20','10:05:00',5.21),('7643','2014-02-20','10:10:00',5.11),('7643','2014-02-20','10:15:00',5.71),('7643','2014-02-20','10:20:00',7.61),('7643','2014-02-20','10:25:00',9.32),('7643','2014-02-20','10:30:00',10.93),('7643','2014-02-20','10:35:00',8.03),('7643','2014-02-20','10:40:00',7.1),('7643','2014-02-20','10:45:00',6.7),('7643','2014-02-20','10:50:00',5.74),('7643','2014-02-20','10:55:00',8.25),('7643','2014-02-20','11:00:00',6.9),('7643','2014-02-20','11:05:00',5.41),('7643','2014-02-20','11:10:00',5.49),('7643','2014-02-20','11:15:00',6.19),('7643','2014-02-20','11:20:00',6.25),('7643','2014-02-20','11:25:00',8.48),('7643','2014-02-20','11:30:00',14.32),('7643','2014-02-20','11:35:00',9.02),('7643','2014-02-20','11:40:00',10.02),('7643','2014-02-20','11:45:00',9.2),('7643','2014-02-20','11:50:00',6.46),('7643','2014-02-20','11:55:00',11.67),('7643','2014-02-20','12:00:00',15.75),('7643','2014-02-20','12:05:00',15.53),('7643','2014-02-20','12:10:00',11.96),('7643','2014-02-20','12:15:00',5.58),('7643','2014-02-20','12:20:00',5.48),('7643','2014-02-20','12:25:00',5.58),('7643','2014-02-20','12:30:00',5.33),('7643','2014-02-20','12:35:00',4.34),('7643','2014-02-20','12:40:00',3.79),('7643','2014-02-20','12:45:00',3.09),('7643','2014-02-20','12:50:00',2.97),('7643','2014-02-20','12:55:00',2.66),('7643','2014-02-20','13:00:00',1.83),('7643','2014-02-20','13:05:00',1.04),('7643','2014-02-20','13:35:00',1.14),('7643','2014-02-20','13:40:00',1.43),('7643','2014-02-20','13:45:00',1.66),('7643','2014-02-20','13:50:00',1.82),('7643','2014-02-20','13:55:00',1.84),('7643','2014-02-20','14:00:00',1.75),('7643','2014-02-20','14:05:00',1.78),('7643','2014-02-20','14:10:00',1.97),('7643','2014-02-20','14:15:00',2.2),('7643','2014-02-20','14:20:00',2.42),('7643','2014-02-20','14:25:00',2.47),('7643','2014-02-20','14:30:00',2.51),('7643','2014-02-20','14:35:00',2.4),('7643','2014-02-20','14:40:00',2.65),('7643','2014-02-20','14:45:00',3.02),('7643','2014-02-20','14:50:00',2.99),('7643','2014-02-20','14:55:00',3.18),('7643','2014-02-20','15:00:00',3.43),('7643','2014-02-20','15:05:00',6.33),('7643','2014-02-20','15:10:00',2.9),('7643','2014-02-20','15:15:00',2.21),('7643','2014-02-20','15:20:00',2.83),('7643','2014-02-20','15:25:00',4.19),('7643','2014-02-20','15:30:00',6.83),('7643','2014-02-20','15:35:00',6.94),('7643','2014-02-20','15:40:00',6.53),('7643','2014-02-20','15:45:00',6.34),('7643','2014-02-20','15:50:00',5.93),('7643','2014-02-20','15:55:00',5.39),('7643','2014-02-20','16:00:00',5.2),('7643','2014-02-20','16:05:00',4.85),('7643','2014-02-20','16:10:00',4.48),('7643','2014-02-20','16:15:00',4.13),('7643','2014-02-20','16:20:00',3.82),('7643','2014-02-20','16:25:00',3.47),('7643','2014-02-20','16:30:00',3.14),('7643','2014-02-20','16:35:00',2.82),('7643','2014-02-20','16:40:00',2.51),('7643','2014-02-20','16:45:00',2.19),('7643','2014-02-20','16:50:00',1.95),('7643','2014-02-20','16:55:00',1.72),('7643','2014-02-20','17:00:00',1.48),('7643','2014-02-20','17:05:00',1.23),('7643','2014-02-20','17:10:00',1.02),('7643','2014-02-19','08:10:00',1.11),('7643','2014-02-19','08:15:00',1.29),('7643','2014-02-19','08:20:00',1.36),('7643','2014-02-19','08:40:00',1.07),('7643','2014-02-19','08:50:00',1.04),('7643','2014-02-19','08:55:00',1.19),('7643','2014-02-19','09:00:00',1.29),('7643','2014-02-19','09:05:00',1.26),('7643','2014-02-19','09:10:00',1.42),('7643','2014-02-19','09:35:00',1.21),('7643','2014-02-19','09:40:00',1.16),('7643','2014-02-19','10:00:00',1.07),('7643','2014-02-19','10:05:00',1.59),('7643','2014-02-19','10:10:00',1.87),('7643','2014-02-19','10:15:00',1.32),('7643','2014-02-19','10:25:00',1.22),('7643','2014-02-19','10:30:00',1.39),('7643','2014-02-19','10:35:00',1.21),('7643','2014-02-19','10:40:00',1.25),('7643','2014-02-19','10:45:00',1.98),('7643','2014-02-19','10:50:00',2.03),('7643','2014-02-19','10:55:00',2.43),('7643','2014-02-19','11:00:00',1.6),('7643','2014-02-19','11:05:00',1.02),('7643','2014-02-19','11:15:00',1.75),('7643','2014-02-19','11:20:00',2.99),('7643','2014-02-19','11:25:00',3.57),('7643','2014-02-19','11:30:00',3.51),('7643','2014-02-19','11:35:00',2.95),('7643','2014-02-19','11:40:00',2.02),('7643','2014-02-19','11:45:00',2.23),('7643','2014-02-19','11:50:00',2.26),('7643','2014-02-19','11:55:00',2.75),('7643','2014-02-19','12:00:00',3.38),('7643','2014-02-19','12:05:00',2.34),('7643','2014-02-19','12:10:00',2.14),('7643','2014-02-19','12:15:00',1.98),('7643','2014-02-19','12:20:00',2.46),('7643','2014-02-19','12:25:00',3.15),('7643','2014-02-19','12:30:00',3.55),('7643','2014-02-19','12:35:00',3.41),('7643','2014-02-19','12:40:00',3.51),('7643','2014-02-19','12:45:00',3.05),('7643','2014-02-19','12:50:00',3.12),('7643','2014-02-19','12:55:00',4.08),('7643','2014-02-19','13:00:00',4.79),('7643','2014-02-19','13:05:00',2.81),('7643','2014-02-19','13:10:00',2.36),('7643','2014-02-19','13:15:00',4.36),('7643','2014-02-19','13:20:00',3.87),('7643','2014-02-19','13:25:00',2.99),('7643','2014-02-19','13:30:00',4.12),('7643','2014-02-19','13:35:00',3.75),('7643','2014-02-19','13:40:00',2.3),('7643','2014-02-19','13:45:00',1.87),('7643','2014-02-19','13:50:00',1.91),('7643','2014-02-19','13:55:00',2.18),('7643','2014-02-19','14:00:00',3.23),('7643','2014-02-19','14:05:00',2.17),('7643','2014-02-19','14:10:00',1.61),('7643','2014-02-19','14:15:00',2.2),('7643','2014-02-19','14:20:00',1.91),('7643','2014-02-19','14:25:00',1.84),('7643','2014-02-19','14:30:00',1.79),('7643','2014-02-19','14:35:00',1.52),('7643','2014-02-19','14:40:00',1.2),('7643','2014-02-19','14:45:00',1.24),('7643','2014-02-19','14:50:00',1.74),('7643','2014-02-19','15:25:00',1.06),('7643','2014-02-18','08:20:00',1.06),('7643','2014-02-18','08:25:00',1.33),('7643','2014-02-18','08:30:00',1.75),('7643','2014-02-18','08:35:00',2.22),('7643','2014-02-18','08:40:00',2.39),('7643','2014-02-18','08:45:00',2.62),('7643','2014-02-18','08:50:00',2.39),('7643','2014-02-18','08:55:00',2.34),('7643','2014-02-18','09:00:00',2.52),('7643','2014-02-18','09:05:00',2.53),('7643','2014-02-18','09:10:00',2.43),('7643','2014-02-18','09:15:00',2.75),('7643','2014-02-18','09:20:00',3.17),('7643','2014-02-18','09:25:00',3.65),('7643','2014-02-18','09:30:00',3.78),('7643','2014-02-18','09:35:00',4.41),('7643','2014-02-18','09:40:00',4.69),('7643','2014-02-18','09:45:00',5.6),('7643','2014-02-18','09:50:00',5.25),('7643','2014-02-18','09:55:00',4.82),('7643','2014-02-18','10:00:00',4.65),('7643','2014-02-18','10:05:00',4.64),('7643','2014-02-18','10:10:00',4.99),('7643','2014-02-18','10:15:00',5.22),('7643','2014-02-18','10:20:00',4.68),('7643','2014-02-18','10:25:00',4.82),('7643','2014-02-18','10:30:00',5.27),('7643','2014-02-18','10:35:00',5.52),('7643','2014-02-18','10:40:00',6.46),('7643','2014-02-18','10:45:00',7.2),('7643','2014-02-18','10:50:00',6.45),('7643','2014-02-18','10:55:00',5.69),('7643','2014-02-18','11:00:00',5.18),('7643','2014-02-18','11:05:00',5.59),('7643','2014-02-18','11:10:00',6.54),('7643','2014-02-18','11:15:00',6.26),('7643','2014-02-18','11:20:00',6.75),('7643','2014-02-18','11:25:00',6.45),('7643','2014-02-18','11:30:00',6.24),('7643','2014-02-18','11:35:00',5.95),('7643','2014-02-18','11:40:00',5.39),('7643','2014-02-18','11:45:00',5.41),('7643','2014-02-18','11:50:00',5.04),('7643','2014-02-18','11:55:00',4.29),('7643','2014-02-18','12:00:00',4.81),('7643','2014-02-18','12:05:00',5.5),('7643','2014-02-18','12:10:00',5.34),('7643','2014-02-18','12:15:00',5.16),('7643','2014-02-18','12:20:00',4.38),('7643','2014-02-18','12:25:00',5.07),('7643','2014-02-18','12:30:00',6.11),('7643','2014-02-18','12:35:00',4.9),('7643','2014-02-18','12:40:00',4.8),('7643','2014-02-18','12:45:00',4.77),('7643','2014-02-18','12:50:00',3.68),('7643','2014-02-18','12:55:00',2.99),('7643','2014-02-18','13:00:00',3.57),('7643','2014-02-18','13:05:00',4.11),('7643','2014-02-18','13:10:00',3.87),('7643','2014-02-18','13:15:00',4.2),('7643','2014-02-18','13:20:00',4.64),('7643','2014-02-18','13:25:00',4.93),('7643','2014-02-18','13:30:00',4.91),('7643','2014-02-18','13:35:00',6.06),('7643','2014-02-18','13:40:00',5.69),('7643','2014-02-18','13:45:00',6.27),('7643','2014-02-18','13:50:00',7.25),('7643','2014-02-18','13:55:00',6.86),('7643','2014-02-18','14:00:00',6.14),('7643','2014-02-18','14:05:00',7.01),('7643','2014-02-18','14:10:00',5.75),('7643','2014-02-18','14:15:00',5.15),('7643','2014-02-18','14:20:00',7.83),('7643','2014-02-18','14:25:00',6.22),('7643','2014-02-18','14:30:00',5.62),('7643','2014-02-18','14:35:00',6.18),('7643','2014-02-18','14:40:00',5.04),('7643','2014-02-18','14:45:00',4.94),('7643','2014-02-18','14:50:00',6.13),('7643','2014-02-18','14:55:00',5.68),('7643','2014-02-18','15:00:00',4.58),('7643','2014-02-18','15:05:00',4.52),('7643','2014-02-18','15:10:00',4.16),('7643','2014-02-18','15:15:00',5),('7643','2014-02-18','15:20:00',3.82),('7643','2014-02-18','15:25:00',4.32),('7643','2014-02-18','15:30:00',3.67),('7643','2014-02-18','15:35:00',3.28),('7643','2014-02-18','15:40:00',3.4),('7643','2014-02-18','15:45:00',3.43),('7643','2014-02-18','15:50:00',4.27),('7643','2014-02-18','15:55:00',3.54),('7643','2014-02-18','16:00:00',3.11),('7643','2014-02-18','16:05:00',2.88),('7643','2014-02-18','16:10:00',2.62),('7643','2014-02-18','16:15:00',2.57),('7643','2014-02-18','16:20:00',1.99),('7643','2014-02-18','16:25:00',1.54),('7643','2014-02-18','16:30:00',1.53),('7643','2014-02-18','16:35:00',1.32),('7643','2014-02-18','16:45:00',1.3),('7643','2014-02-18','16:50:00',1.03),('7643','2014-02-17','07:40:00',1.55),('7643','2014-02-17','07:45:00',1.86),('7643','2014-02-17','07:50:00',2.21),('7643','2014-02-17','07:55:00',2.55),('7643','2014-02-17','08:00:00',2.89),('7643','2014-02-17','08:05:00',3.24),('7643','2014-02-17','08:10:00',3.59),('7643','2014-02-17','08:15:00',3.92),('7643','2014-02-17','08:20:00',4.27),('7643','2014-02-17','08:25:00',4.61),('7643','2014-02-17','08:30:00',4.95),('7643','2014-02-17','08:35:00',5.28),('7643','2014-02-17','08:40:00',5.59),('7643','2014-02-17','08:45:00',5.91),('7643','2014-02-17','08:50:00',5.98),('7643','2014-02-17','08:55:00',6.5),('7643','2014-02-17','09:00:00',6.75),('7643','2014-02-17','09:05:00',7.04),('7643','2014-02-17','09:10:00',7.33),('7643','2014-02-17','09:15:00',7.62),('7643','2014-02-17','09:20:00',7.9),('7643','2014-02-17','09:25:00',8.11),('7643','2014-02-17','09:30:00',8.42),('7643','2014-02-17','09:35:00',8.63),('7643','2014-02-17','09:40:00',8.84),('7643','2014-02-17','09:45:00',9.05),('7643','2014-02-17','09:50:00',9.28),('7643','2014-02-17','09:55:00',9.54),('7643','2014-02-17','10:00:00',9.78),('7643','2014-02-17','10:05:00',9.95),('7643','2014-02-17','10:10:00',10.15),('7643','2014-02-17','10:15:00',10.29),('7643','2014-02-17','10:20:00',10.46),('7643','2014-02-17','10:25:00',10.57),('7643','2014-02-17','10:30:00',10.77),('7643','2014-02-17','10:35:00',10.93),('7643','2014-02-17','10:40:00',11.05),('7643','2014-02-17','10:45:00',11.18),('7643','2014-02-17','10:50:00',11.29),('7643','2014-02-17','10:55:00',11.51),('7643','2014-02-17','11:00:00',11.53),('7643','2014-02-17','11:05:00',9.83),('7643','2014-02-17','11:10:00',9.51),('7643','2014-02-17','11:15:00',9.11),('7643','2014-02-17','11:20:00',10.63),('7643','2014-02-17','11:25:00',11.89),('7643','2014-02-17','11:30:00',10.93),('7643','2014-02-17','11:35:00',9.9),('7643','2014-02-17','11:40:00',8.06),('7643','2014-02-17','11:45:00',8.3),('7643','2014-02-17','11:50:00',7.03),('7643','2014-02-17','11:55:00',5.75),('7643','2014-02-17','12:00:00',5.5),('7643','2014-02-17','12:05:00',5.55),('7643','2014-02-17','12:10:00',6.46),('7643','2014-02-17','12:15:00',6.94),('7643','2014-02-17','12:20:00',6.72),('7643','2014-02-17','12:25:00',7.9),('7643','2014-02-17','12:30:00',8.94),('7643','2014-02-17','12:35:00',6.64),('7643','2014-02-17','12:40:00',5.98),('7643','2014-02-17','12:45:00',5.74),('7643','2014-02-17','12:50:00',6.16),('7643','2014-02-17','12:55:00',6.75),('7643','2014-02-17','13:00:00',5.12),('7643','2014-02-17','13:05:00',4.82),('7643','2014-02-17','13:10:00',5.26),('7643','2014-02-17','13:15:00',7.06),('7643','2014-02-17','13:20:00',7.52),('7643','2014-02-17','13:25:00',8.92),('7643','2014-02-17','13:30:00',6.38),('7643','2014-02-17','13:35:00',5.32),('7643','2014-02-17','13:40:00',6.93),('7643','2014-02-17','13:45:00',8.19),('7643','2014-02-17','13:50:00',6.19),('7643','2014-02-17','13:55:00',6.22),('7643','2014-02-17','14:00:00',7.22),('7643','2014-02-17','14:05:00',10.23),('7643','2014-02-17','14:10:00',5.9),('7643','2014-02-17','14:15:00',4.58),('7643','2014-02-17','14:20:00',4.08),('7643','2014-02-17','14:25:00',4.21),('7643','2014-02-17','14:30:00',5.35),('7643','2014-02-17','14:35:00',5.07),('7643','2014-02-17','14:40:00',4.17),('7643','2014-02-17','14:45:00',3.86),('7643','2014-02-17','14:50:00',3.62),('7643','2014-02-17','14:55:00',3.44),('7643','2014-02-17','15:00:00',3.21),('7643','2014-02-17','15:05:00',3.06),('7643','2014-02-17','15:10:00',3.02),('7643','2014-02-17','15:15:00',2.82),('7643','2014-02-17','15:20:00',2.5),('7643','2014-02-17','15:25:00',2.62),('7643','2014-02-17','15:30:00',2.96),('7643','2014-02-17','15:35:00',3.79),('7643','2014-02-17','15:40:00',4.85),('7643','2014-02-17','15:45:00',5.09),('7643','2014-02-17','15:50:00',4.01),('7643','2014-02-17','15:55:00',3.64),('7643','2014-02-17','16:00:00',3.67),('7643','2014-02-17','16:05:00',4.14),('7643','2014-02-17','16:10:00',3.46),('7643','2014-02-17','16:15:00',2.4),('7643','2014-02-17','16:20:00',2.04),('7643','2014-02-17','16:25:00',1.6),('7643','2014-02-17','16:30:00',2.11),('7643','2014-02-17','16:35:00',2.38),('7643','2014-02-17','16:40:00',2.02),('7643','2014-02-17','16:45:00',1.48),('7643','2014-02-17','16:50:00',1.59),('7643','2014-02-17','16:55:00',1.57),('7643','2014-02-17','17:00:00',1.49),('7643','2014-02-16','07:35:00',1.18),('7643','2014-02-16','07:40:00',1.41),('7643','2014-02-16','07:45:00',1.67),('7643','2014-02-16','07:50:00',1.93),('7643','2014-02-16','07:55:00',2.23),('7643','2014-02-16','08:00:00',2.52),('7643','2014-02-16','08:05:00',2.8),('7643','2014-02-16','08:10:00',3.11),('7643','2014-02-16','08:15:00',3.41),('7643','2014-02-16','08:20:00',3.72),('7643','2014-02-16','08:25:00',4.08),('7643','2014-02-16','08:30:00',4.38),('7643','2014-02-16','08:35:00',4.64),('7643','2014-02-16','08:40:00',4.94),('7643','2014-02-16','08:45:00',5.3),('7643','2014-02-16','08:50:00',5.52),('7643','2014-02-16','08:55:00',5.79),('7643','2014-02-16','09:00:00',6.05),('7643','2014-02-16','09:05:00',6.27),('7643','2014-02-16','09:10:00',6.66),('7643','2014-02-16','09:15:00',7),('7643','2014-02-16','09:20:00',7.29),('7643','2014-02-16','09:25:00',7.57),('7643','2014-02-16','09:30:00',7.88),('7643','2014-02-16','09:35:00',8.09),('7643','2014-02-16','09:40:00',8.29),('7643','2014-02-16','09:45:00',8.49),('7643','2014-02-16','09:50:00',8.63),('7643','2014-02-16','09:55:00',8.82),('7643','2014-02-16','10:00:00',9.09),('7643','2014-02-16','10:05:00',9.31),('7643','2014-02-16','10:10:00',9.47),('7643','2014-02-16','10:15:00',9.62),('7643','2014-02-16','10:20:00',9.66),('7643','2014-02-16','10:25:00',9.75),('7643','2014-02-16','10:30:00',9.9),('7643','2014-02-16','10:35:00',9.94),('7643','2014-02-16','10:40:00',9.99),('7643','2014-02-16','10:45:00',10.07),('7643','2014-02-16','10:50:00',10.13),('7643','2014-02-16','10:55:00',10.35),('7643','2014-02-16','11:00:00',10.44),('7643','2014-02-16','11:05:00',10.5),('7643','2014-02-16','11:10:00',10.62),('7643','2014-02-16','11:15:00',10.77),('7643','2014-02-16','11:20:00',11.03),('7643','2014-02-16','11:25:00',11.25),('7643','2014-02-16','11:30:00',11.48),('7643','2014-02-16','11:35:00',11.69),('7643','2014-02-16','11:40:00',11.84),('7643','2014-02-16','11:45:00',11.84),('7643','2014-02-16','11:50:00',11.85),('7643','2014-02-16','11:55:00',11.87),('7643','2014-02-16','12:00:00',11.95),('7643','2014-02-16','12:05:00',11.97),('7643','2014-02-16','12:10:00',11.92),('7643','2014-02-16','12:15:00',11.87),('7643','2014-02-16','12:20:00',11.87),('7643','2014-02-16','12:25:00',11.9),('7643','2014-02-16','12:30:00',11.81),('7643','2014-02-16','12:35:00',11.77),('7643','2014-02-16','12:40:00',11.74),('7643','2014-02-16','12:45:00',11.68),('7643','2014-02-16','12:50:00',11.61),('7643','2014-02-16','12:55:00',11.52),('7643','2014-02-16','13:00:00',11.49),('7643','2014-02-16','13:05:00',11.34),('7643','2014-02-16','13:10:00',11.3),('7643','2014-02-16','13:15:00',11.19),('7643','2014-02-16','13:20:00',11.07),('7643','2014-02-16','13:25:00',11.01),('7643','2014-02-16','13:30:00',10.98),('7643','2014-02-16','13:35:00',10.9),('7643','2014-02-16','13:40:00',10.8),('7643','2014-02-16','13:45:00',10.5),('7643','2014-02-16','13:50:00',10.55),('7643','2014-02-16','13:55:00',10.37),('7643','2014-02-16','14:00:00',10.15),('7643','2014-02-16','14:05:00',10.06),('7643','2014-02-16','14:10:00',9.56),('7643','2014-02-16','14:15:00',9.27),('7643','2014-02-16','14:20:00',9.58),('7643','2014-02-16','14:25:00',9.18),('7643','2014-02-16','14:30:00',8.89),('7643','2014-02-16','14:35:00',8.62),('7643','2014-02-16','14:40:00',7.9),('7643','2014-02-16','14:45:00',8.6),('7643','2014-02-16','14:50:00',8.01),('7643','2014-02-16','14:55:00',8.02),('7643','2014-02-16','15:00:00',7.5),('7643','2014-02-16','15:05:00',7.35),('7643','2014-02-16','15:10:00',7.17),('7643','2014-02-16','15:15:00',7.19),('7643','2014-02-16','15:20:00',7),('7643','2014-02-16','15:25:00',6.46),('7643','2014-02-16','15:30:00',6.32),('7643','2014-02-16','15:35:00',5.98),('7643','2014-02-16','15:40:00',5.51),('7643','2014-02-16','15:45:00',5.45),('7643','2014-02-16','15:50:00',5.12),('7643','2014-02-16','15:55:00',4.81),('7643','2014-02-16','16:00:00',4.41),('7643','2014-02-16','16:05:00',4.18),('7643','2014-02-16','16:10:00',3.88),('7643','2014-02-16','16:15:00',3.52),('7643','2014-02-16','16:20:00',3.22),('7643','2014-02-16','16:25:00',2.96),('7643','2014-02-16','16:30:00',2.62),('7643','2014-02-16','16:35:00',2.26),('7643','2014-02-16','16:40:00',2.02),('7643','2014-02-16','16:45:00',1.74),('7643','2014-02-16','16:50:00',1.5),('7643','2014-02-16','16:55:00',1.21),('7643','2014-02-15','07:35:00',1.15),('7643','2014-02-15','07:40:00',1.44),('7643','2014-02-15','07:45:00',1.72),('7643','2014-02-15','07:50:00',2.05),('7643','2014-02-15','07:55:00',2.38),('7643','2014-02-15','08:00:00',2.74),('7643','2014-02-15','08:05:00',3.09),('7643','2014-02-15','08:10:00',3.44),('7643','2014-02-15','08:15:00',3.78),('7643','2014-02-15','08:20:00',4.15),('7643','2014-02-15','08:25:00',4.54),('7643','2014-02-15','08:30:00',4.94),('7643','2014-02-15','08:35:00',5.31),('7643','2014-02-15','08:40:00',5.38),('7643','2014-02-15','08:45:00',6.08),('7643','2014-02-15','08:50:00',5.72),('7643','2014-02-15','08:55:00',6.54),('7643','2014-02-15','09:00:00',7.04),('7643','2014-02-15','09:05:00',7.33),('7643','2014-02-15','09:10:00',7.12),('7643','2014-02-15','09:15:00',5.87),('7643','2014-02-15','09:20:00',7.56),('7643','2014-02-15','09:25:00',7.67),('7643','2014-02-15','09:30:00',7.99),('7643','2014-02-15','09:35:00',6.69),('7643','2014-02-15','09:40:00',8.54),('7643','2014-02-15','09:45:00',9),('7643','2014-02-15','09:50:00',9.41),('7643','2014-02-15','09:55:00',9.1),('7643','2014-02-15','10:00:00',8.97),('7643','2014-02-15','10:05:00',9.96),('7643','2014-02-15','10:10:00',10.2),('7643','2014-02-15','10:15:00',10.37),('7643','2014-02-15','10:20:00',10.61),('7643','2014-02-15','10:25:00',10.85),('7643','2014-02-15','10:30:00',10.98),('7643','2014-02-15','10:35:00',11.36),('7643','2014-02-15','10:40:00',11.68),('7643','2014-02-15','10:45:00',11.55),('7643','2014-02-15','10:50:00',10.26),('7643','2014-02-15','10:55:00',9.8),('7643','2014-02-15','11:00:00',11.65),('7643','2014-02-15','11:05:00',11.96),('7643','2014-02-15','11:10:00',11.39),('7643','2014-02-15','11:15:00',11.7),('7643','2014-02-15','11:20:00',11.35),('7643','2014-02-15','11:25:00',11.27),('7643','2014-02-15','11:30:00',11.57),('7643','2014-02-15','11:35:00',12.16),('7643','2014-02-15','11:40:00',12.13),('7643','2014-02-15','11:45:00',10.9),('7643','2014-02-15','11:50:00',12.26),('7643','2014-02-15','11:55:00',10.38),('7643','2014-02-15','12:00:00',12.41),('7643','2014-02-15','12:05:00',12.27),('7643','2014-02-15','12:10:00',12.36),('7643','2014-02-15','12:15:00',12.25),('7643','2014-02-15','12:20:00',12.22),('7643','2014-02-15','12:25:00',12.08),('7643','2014-02-15','12:30:00',12.27),('7643','2014-02-15','12:35:00',12.18),('7643','2014-02-15','12:40:00',12.1),('7643','2014-02-15','12:45:00',11.99),('7643','2014-02-15','12:50:00',11.99),('7643','2014-02-15','12:55:00',12.04),('7643','2014-02-15','13:00:00',11.91),('7643','2014-02-15','13:05:00',11.79),('7643','2014-02-15','13:10:00',11.43),('7643','2014-02-15','13:15:00',11.54),('7643','2014-02-15','13:20:00',11.75),('7643','2014-02-15','13:25:00',11.49),('7643','2014-02-15','13:30:00',11.34),('7643','2014-02-15','13:35:00',11.2),('7643','2014-02-15','13:40:00',11.08),('7643','2014-02-15','13:45:00',11.13),('7643','2014-02-15','13:50:00',10.92),('7643','2014-02-15','13:55:00',10.89),('7643','2014-02-15','14:00:00',10.9),('7643','2014-02-15','14:05:00',10.79),('7643','2014-02-15','14:10:00',10.59),('7643','2014-02-15','14:15:00',10.37),('7643','2014-02-15','14:20:00',10.28),('7643','2014-02-15','14:25:00',10.19),('7643','2014-02-15','14:30:00',9.96),('7643','2014-02-15','14:35:00',9.73),('7643','2014-02-15','14:40:00',9.34),('7643','2014-02-15','14:45:00',9.25),('7643','2014-02-15','14:50:00',8.99),('7643','2014-02-15','14:55:00',8.83),('7643','2014-02-15','15:00:00',8.49),('7643','2014-02-15','15:05:00',8.34),('7643','2014-02-15','15:10:00',7.95),('7643','2014-02-15','15:15:00',7.71),('7643','2014-02-15','15:20:00',7.37),('7643','2014-02-15','15:25:00',7),('7643','2014-02-15','15:30:00',6.78),('7643','2014-02-15','15:35:00',5.95),('7643','2014-02-15','15:40:00',5.37),('7643','2014-02-15','15:45:00',6.05),('7643','2014-02-15','15:50:00',4.91),('7643','2014-02-15','15:55:00',1.88),('7643','2014-02-15','16:00:00',1.36),('7643','2014-02-15','16:05:00',1.52),('7643','2014-02-15','16:10:00',2.46),('7643','2014-02-15','16:15:00',3.56),('7643','2014-02-15','16:20:00',3.88),('7643','2014-02-15','16:25:00',4.39),('7643','2014-02-15','16:30:00',4.31),('7643','2014-02-15','16:35:00',3.46),('7643','2014-02-15','16:40:00',2.46),('7643','2014-02-15','16:45:00',1.78),('7643','2014-02-15','16:50:00',1.17),('7643','2014-02-15','17:00:00',1.01),('7643','2014-02-15','17:05:00',1.05),('7643','2014-04-27','07:10:00',1),('7643','2014-04-27','07:15:00',1.36),('7643','2014-04-27','07:20:00',1.97),('7643','2014-04-27','07:25:00',1.76),('7643','2014-04-27','07:30:00',1.68),('7643','2014-04-27','07:35:00',1.84),('7643','2014-04-27','07:40:00',2),('7643','2014-04-27','07:45:00',2.23),('7643','2014-04-27','07:50:00',2.33),('7643','2014-04-27','07:55:00',2.61),('7643','2014-04-27','08:00:00',3.01),('7643','2014-04-27','08:05:00',2.3),('7643','2014-04-27','08:10:00',1.48),('7643','2014-04-27','08:15:00',5.97),('7643','2014-04-27','08:20:00',6.42),('7643','2014-04-27','08:25:00',6.38),('7643','2014-04-27','08:30:00',5.26),('7643','2014-04-27','08:35:00',4.74),('7643','2014-04-27','08:40:00',4.46),('7643','2014-04-27','08:45:00',4.44),('7643','2014-04-27','08:50:00',5.65),('7643','2014-04-27','08:55:00',5.53),('7643','2014-04-27','09:00:00',4.16),('7643','2014-04-27','09:05:00',3.71),('7643','2014-04-27','09:10:00',10.41),('7643','2014-04-27','09:15:00',11.45),('7643','2014-04-27','09:20:00',11.23),('7643','2014-04-27','09:25:00',12.98),('7643','2014-04-27','09:30:00',6.5),('7643','2014-04-27','09:35:00',8.69),('7643','2014-04-27','09:40:00',8.06),('7643','2014-04-27','09:45:00',6.46),('7643','2014-04-27','09:50:00',8.88),('7643','2014-04-27','09:55:00',5.45),('7643','2014-04-27','10:00:00',7.96),('7643','2014-04-27','10:05:00',9.34),('7643','2014-04-27','10:10:00',9),('7643','2014-04-27','10:15:00',8.58),('7643','2014-04-27','10:20:00',7.04),('7643','2014-04-27','10:25:00',5.7),('7643','2014-04-27','10:30:00',2.47),('7643','2014-04-27','10:35:00',1.68),('7643','2014-04-27','10:40:00',3.16),('7643','2014-04-27','10:45:00',5.68),('7643','2014-04-27','10:50:00',7.87),('7643','2014-04-27','10:55:00',7.65),('7643','2014-04-27','11:00:00',7.3),('7643','2014-04-27','11:05:00',8.92),('7643','2014-04-27','11:10:00',10.28),('7643','2014-04-27','11:15:00',10.09),('7643','2014-04-27','11:20:00',8.93),('7643','2014-04-27','11:25:00',7.3),('7643','2014-04-27','11:30:00',7.87),('7643','2014-04-27','11:35:00',7.41),('7643','2014-04-27','11:40:00',5.97),('7643','2014-04-27','11:45:00',6.06),('7643','2014-04-27','11:50:00',7.04),('7643','2014-04-27','11:55:00',7.71),('7643','2014-04-27','12:00:00',6.84),('7643','2014-04-27','12:05:00',5.22),('7643','2014-04-27','12:10:00',7.09),('7643','2014-04-27','12:15:00',10.81),('7643','2014-04-27','12:20:00',11.63),('7643','2014-04-27','12:25:00',10.84),('7643','2014-04-27','12:30:00',10.49),('7643','2014-04-27','12:35:00',9.71),('7643','2014-04-27','12:40:00',8.7),('7643','2014-04-27','12:45:00',7.45),('7643','2014-04-27','12:50:00',9.02),('7643','2014-04-27','12:55:00',8.45),('7643','2014-04-27','13:00:00',8.76),('7643','2014-04-27','13:05:00',9.99),('7643','2014-04-27','13:10:00',14.89),('7643','2014-04-27','13:15:00',9.12),('7643','2014-04-27','13:20:00',8.67),('7643','2014-04-27','13:25:00',9.67),('7643','2014-04-27','13:30:00',18.35),('7643','2014-04-27','13:35:00',13.64),('7643','2014-04-27','13:40:00',14.39),('7643','2014-04-27','13:45:00',10.74),('7643','2014-04-27','13:50:00',15.74),('7643','2014-04-27','13:55:00',11.48),('7643','2014-04-27','14:00:00',6.6),('7643','2014-04-27','14:05:00',10.86),('7643','2014-04-27','14:10:00',12.87),('7643','2014-04-27','14:15:00',12.12),('7643','2014-04-27','14:20:00',16.77),('7643','2014-04-27','14:25:00',9.98),('7643','2014-04-27','14:30:00',11.68),('7643','2014-04-27','14:35:00',14.48),('7643','2014-04-27','14:40:00',14.96),('7643','2014-04-27','14:45:00',11.39),('7643','2014-04-27','14:50:00',10.34),('7643','2014-04-27','14:55:00',14.88),('7643','2014-04-27','15:00:00',15.78),('7643','2014-04-27','15:05:00',14.19),('7643','2014-04-27','15:10:00',8.3),('7643','2014-04-27','15:15:00',7.12),('7643','2014-04-27','15:20:00',5.35),('7643','2014-04-27','15:25:00',7.08),('7643','2014-04-27','15:30:00',7.35),('7643','2014-04-27','15:35:00',12.48),('7643','2014-04-27','15:40:00',12.28),('7643','2014-04-27','15:45:00',12.72),('7643','2014-04-27','15:50:00',8.56),('7643','2014-04-27','15:55:00',4.12),('7643','2014-04-27','16:00:00',9.33),('7643','2014-04-27','16:05:00',12.55),('7643','2014-04-27','16:10:00',15.4),('7643','2014-04-27','16:15:00',12.55),('7643','2014-04-27','16:20:00',5.67),('7643','2014-04-27','16:25:00',6.26),('7643','2014-04-27','16:30:00',12.26),('7643','2014-04-27','16:35:00',12.05),('7643','2014-04-27','16:40:00',3.16),('7643','2014-04-27','16:45:00',2.55),('7643','2014-04-27','16:50:00',2.37),('7643','2014-04-27','16:55:00',4.45),('7643','2014-04-27','17:00:00',3.81),('7643','2014-04-27','17:05:00',1.93),('7643','2014-04-27','17:10:00',1.23),('7643','2014-04-27','17:15:00',1.31),('7643','2014-04-27','17:20:00',2.34),('7643','2014-04-27','17:25:00',3.49),('7643','2014-04-27','17:30:00',3.46),('7643','2014-04-27','17:35:00',4.04),('7643','2014-04-27','17:40:00',5.63),('7643','2014-04-27','17:45:00',3.65),('7643','2014-04-27','17:50:00',2.75),('7643','2014-04-27','17:55:00',2.68),('7643','2014-04-27','18:00:00',2.25),('7643','2014-04-27','18:05:00',1.71),('7643','2014-04-27','18:10:00',1.81),('7643','2014-04-27','18:15:00',1.91),('7643','2014-04-27','18:20:00',1.76),('7643','2014-04-27','18:25:00',1.9),('7643','2014-04-27','18:30:00',1.89),('7643','2014-04-27','18:35:00',1.78),('7643','2014-04-27','18:40:00',1.72),('7643','2014-04-27','18:45:00',1.09),('7643','2014-02-14','07:40:00',1.22),('7643','2014-02-14','07:45:00',1.54),('7643','2014-02-14','07:50:00',1.83),('7643','2014-02-14','07:55:00',2.18),('7643','2014-02-14','08:00:00',2.53),('7643','2014-02-14','08:05:00',2.87),('7643','2014-02-14','08:10:00',3.21),('7643','2014-02-14','08:15:00',3.52),('7643','2014-02-14','08:20:00',3.86),('7643','2014-02-14','08:25:00',4.17),('7643','2014-02-14','08:30:00',4.45),('7643','2014-02-14','08:35:00',4.78),('7643','2014-02-14','08:40:00',5.13),('7643','2014-02-14','08:45:00',5.36),('7643','2014-02-14','08:50:00',5.63),('7643','2014-02-14','08:55:00',5.78),('7643','2014-02-14','09:00:00',6.35),('7643','2014-02-14','09:05:00',6.64),('7643','2014-02-14','09:10:00',6.88),('7643','2014-02-14','09:15:00',7.18),('7643','2014-02-14','09:20:00',7.52),('7643','2014-02-14','09:25:00',7.81),('7643','2014-02-14','09:30:00',8.05),('7643','2014-02-14','09:35:00',8.34),('7643','2014-02-14','09:40:00',8.58),('7643','2014-02-14','09:45:00',8.76),('7643','2014-02-14','09:50:00',8.95),('7643','2014-02-14','09:55:00',9.21),('7643','2014-02-14','10:00:00',9.45),('7643','2014-02-14','10:05:00',9.62),('7643','2014-02-14','10:10:00',9.8),('7643','2014-02-14','10:15:00',9.98),('7643','2014-02-14','10:20:00',10.18),('7643','2014-02-14','10:25:00',10.28),('7643','2014-02-14','10:30:00',10.36),('7643','2014-02-14','10:35:00',10.49),('7643','2014-02-14','10:40:00',10.61),('7643','2014-02-14','10:45:00',10.73),('7643','2014-02-14','10:50:00',10.92),('7643','2014-02-14','10:55:00',10.94),('7643','2014-02-14','11:00:00',11.47),('7643','2014-02-14','11:05:00',11.53),('7643','2014-02-14','11:10:00',10.46),('7643','2014-02-14','11:15:00',12.38),('7643','2014-02-14','11:20:00',11.27),('7643','2014-02-14','11:25:00',4.73),('7643','2014-02-14','11:30:00',7.41),('7643','2014-02-14','11:35:00',8.43),('7643','2014-02-14','11:40:00',13.98),('7643','2014-02-14','11:45:00',11.89),('7643','2014-02-14','11:50:00',9.6),('7643','2014-02-14','11:55:00',11.25),('7643','2014-02-14','12:00:00',10.18),('7643','2014-02-14','12:05:00',9.56),('7643','2014-02-14','12:10:00',13.58),('7643','2014-02-14','12:15:00',14.49),('7643','2014-02-14','12:20:00',13.65),('7643','2014-02-14','12:25:00',12.98),('7643','2014-02-14','12:30:00',12.75),('7643','2014-02-14','12:35:00',9.68),('7643','2014-02-14','12:40:00',14.23),('7643','2014-02-14','12:45:00',14.44),('7643','2014-02-14','12:50:00',13.45),('7643','2014-02-14','12:55:00',6.52),('7643','2014-02-14','13:00:00',13.49),('7643','2014-02-14','13:05:00',12.95),('7643','2014-02-14','13:10:00',12.79),('7643','2014-02-14','13:15:00',12.61),('7643','2014-02-14','13:20:00',12.26),('7643','2014-02-14','13:25:00',11.92),('7643','2014-02-14','13:30:00',11.47),('7643','2014-02-14','13:35:00',11.51),('7643','2014-02-14','13:40:00',11.35),('7643','2014-02-14','13:45:00',11.12),('7643','2014-02-14','13:50:00',11.01),('7643','2014-02-14','13:55:00',10.8),('7643','2014-02-14','14:00:00',10.74),('7643','2014-02-14','14:05:00',10.51),('7643','2014-02-14','14:10:00',10.24),('7643','2014-02-14','14:15:00',10.18),('7643','2014-02-14','14:20:00',9.98),('7643','2014-02-14','14:25:00',9.72),('7643','2014-02-14','14:30:00',9.54),('7643','2014-02-14','14:35:00',9.38),('7643','2014-02-14','14:40:00',9.09),('7643','2014-02-14','14:45:00',8.86),('7643','2014-02-14','14:50:00',8.68),('7643','2014-02-14','14:55:00',8.43),('7643','2014-02-14','15:00:00',7.98),('7643','2014-02-14','15:05:00',7.7),('7643','2014-02-14','15:10:00',7.47),('7643','2014-02-14','15:15:00',7.35),('7643','2014-02-14','15:20:00',7.15),('7643','2014-02-14','15:25:00',6.83),('7643','2014-02-14','15:30:00',6.55),('7643','2014-02-14','15:35:00',6.35),('7643','2014-02-14','15:40:00',6.08),('7643','2014-02-14','15:45:00',5.8),('7643','2014-02-14','15:50:00',5.45),('7643','2014-02-14','15:55:00',5.13),('7643','2014-02-14','16:00:00',4.83),('7643','2014-02-14','16:05:00',4.52),('7643','2014-02-14','16:10:00',4.18),('7643','2014-02-14','16:15:00',3.85),('7643','2014-02-14','16:20:00',3.49),('7643','2014-02-14','16:25:00',3.15),('7643','2014-02-14','16:30:00',2.85),('7643','2014-02-14','16:35:00',2.54),('7643','2014-02-14','16:40:00',2.2),('7643','2014-02-14','16:45:00',1.89),('7643','2014-02-14','16:50:00',1.62),('7643','2014-02-14','16:55:00',1.35),('7643','2014-02-14','17:00:00',1.08),('7643','2014-02-13','08:40:00',3.33),('7643','2014-02-13','08:45:00',3.94),('7643','2014-02-13','08:50:00',5.63),('7643','2014-02-13','08:55:00',6.01),('7643','2014-02-13','09:00:00',6.3),('7643','2014-02-13','09:05:00',6.7),('7643','2014-02-13','09:10:00',6.21),('7643','2014-02-13','09:15:00',4.81),('7643','2014-02-13','09:20:00',5.41),('7643','2014-02-13','09:25:00',5.52),('7643','2014-02-13','09:30:00',7.06),('7643','2014-02-13','09:35:00',8.57),('7643','2014-02-13','09:40:00',4.99),('7643','2014-02-13','09:45:00',5.46),('7643','2014-02-13','09:50:00',9.45),('7643','2014-02-13','09:55:00',9.96),('7643','2014-02-13','10:00:00',9.01),('7643','2014-02-13','10:05:00',10),('7643','2014-02-13','10:10:00',10.62),('7643','2014-02-13','10:15:00',8.26),('7643','2014-02-13','10:20:00',10.45),('7643','2014-02-13','10:25:00',11.47),('7643','2014-02-13','10:30:00',11.14),('7643','2014-02-13','10:35:00',10.98),('7643','2014-02-13','10:40:00',11.3),('7643','2014-02-13','10:45:00',11.53),('7643','2014-02-13','10:50:00',11.76),('7643','2014-02-13','10:55:00',11.84),('7643','2014-02-13','11:00:00',11.69),('7643','2014-02-13','11:05:00',12.06),('7643','2014-02-13','11:10:00',12.14),('7643','2014-02-13','11:15:00',12.17),('7643','2014-02-13','11:20:00',12.37),('7643','2014-02-13','11:25:00',12.45),('7643','2014-02-13','11:30:00',12.52),('7643','2014-02-13','11:35:00',12.73),('7643','2014-02-13','11:40:00',12.65),('7643','2014-02-13','11:45:00',12.78),('7643','2014-02-13','11:50:00',11.35),('7643','2014-02-13','11:55:00',12.7),('7643','2014-02-13','12:00:00',12.86),('7643','2014-02-13','12:05:00',10.11),('7643','2014-02-13','12:10:00',12.92),('7643','2014-02-13','12:15:00',12.79),('7643','2014-02-13','12:20:00',12.66),('7643','2014-02-13','12:25:00',12.72),('7643','2014-02-13','12:30:00',12.71),('7643','2014-02-13','12:35:00',12.65),('7643','2014-02-13','12:40:00',12.58),('7643','2014-02-13','12:45:00',12.55),('7643','2014-02-13','12:50:00',12.51),('7643','2014-02-13','12:55:00',12.4),('7643','2014-02-13','13:00:00',12.42),('7643','2014-02-13','13:05:00',12.3),('7643','2014-02-13','13:10:00',12.27),('7643','2014-02-13','13:15:00',12.16),('7643','2014-02-13','13:20:00',12.03),('7643','2014-02-13','13:25:00',11.93),('7643','2014-02-13','13:30:00',11.75),('7643','2014-02-13','13:35:00',11.65),('7643','2014-02-13','13:40:00',11.52),('7643','2014-02-13','13:45:00',11.35),('7643','2014-02-13','13:50:00',11.31),('7643','2014-02-13','13:55:00',11.18),('7643','2014-02-13','14:00:00',11.02),('7643','2014-02-13','14:05:00',10.82),('7643','2014-02-13','14:10:00',10.6),('7643','2014-02-13','14:15:00',10.3),('7643','2014-02-13','14:20:00',10.13),('7643','2014-02-13','14:25:00',9.98),('7643','2014-02-13','14:30:00',9.77),('7643','2014-02-13','14:35:00',9.58),('7643','2014-02-13','14:40:00',9.35),('7643','2014-02-13','14:45:00',9.02),('7643','2014-02-13','14:50:00',8.78),('7643','2014-02-13','14:55:00',8.53),('7643','2014-02-13','15:00:00',8.26),('7643','2014-02-13','15:05:00',8.01),('7643','2014-02-13','15:10:00',7.76),('7643','2014-02-13','15:15:00',7.49),('7643','2014-02-13','15:20:00',7.22),('7643','2014-02-13','15:25:00',6.94),('7643','2014-02-13','15:30:00',6.64),('7643','2014-02-13','15:35:00',6.32),('7643','2014-02-13','15:40:00',6.01),('7643','2014-02-13','15:45:00',5.69),('7643','2014-02-13','15:50:00',5.36),('7643','2014-02-13','15:55:00',5.01),('7643','2014-02-13','16:00:00',4.72),('7643','2014-02-13','16:05:00',4.44),('7643','2014-02-13','16:10:00',4.02),('7643','2014-02-13','16:15:00',3.66),('7643','2014-02-13','16:20:00',3.42),('7643','2014-02-13','16:25:00',3.05),('7643','2014-02-13','16:30:00',2.71),('7643','2014-02-13','16:35:00',2.38),('7643','2014-02-13','16:40:00',2.12),('7643','2014-02-13','16:45:00',1.85),('7643','2014-02-13','16:50:00',1.51),('7643','2014-02-13','16:55:00',1.23),('7643','2014-02-12','07:40:00',1.13),('7643','2014-02-12','07:45:00',1.41),('7643','2014-02-12','07:50:00',1.7),('7643','2014-02-12','07:55:00',2.08),('7643','2014-02-12','08:00:00',2.42),('7643','2014-02-12','08:05:00',2.78),('7643','2014-02-12','08:10:00',3.2),('7643','2014-02-12','08:15:00',3.69),('7643','2014-02-12','08:20:00',4.18),('7643','2014-02-12','08:25:00',4.25),('7643','2014-02-12','08:30:00',4.57),('7643','2014-02-12','08:35:00',4.81),('7643','2014-02-12','08:40:00',5.06),('7643','2014-02-12','08:45:00',5.5),('7643','2014-02-12','08:50:00',5.88),('7643','2014-02-12','08:55:00',6.2),('7643','2014-02-12','09:00:00',6.58),('7643','2014-02-12','09:05:00',6.9),('7643','2014-02-12','09:10:00',7.25),('7643','2014-02-12','09:15:00',7.41),('7643','2014-02-12','09:20:00',7.73),('7643','2014-02-12','09:25:00',7.95),('7643','2014-02-12','09:30:00',8.21),('7643','2014-02-12','09:35:00',8.5),('7643','2014-02-12','09:40:00',8.71),('7643','2014-02-12','09:45:00',8.83),('7643','2014-02-12','09:50:00',9.06),('7643','2014-02-12','09:55:00',9.3),('7643','2014-02-12','10:00:00',9.58),('7643','2014-02-12','10:05:00',9.77),('7643','2014-02-12','10:10:00',9.99),('7643','2014-02-12','10:15:00',10.13),('7643','2014-02-12','10:20:00',10.26),('7643','2014-02-12','10:25:00',10.33),('7643','2014-02-12','10:30:00',10.6),('7643','2014-02-12','10:35:00',10.71),('7643','2014-02-12','10:40:00',10.7),('7643','2014-02-12','10:45:00',10.88),('7643','2014-02-12','10:50:00',11.07),('7643','2014-02-12','10:55:00',11.17),('7643','2014-02-12','11:00:00',11.36),('7643','2014-02-12','11:05:00',11.39),('7643','2014-02-12','11:10:00',11.72),('7643','2014-02-12','11:15:00',11.79),('7643','2014-02-12','11:20:00',10.81),('7643','2014-02-12','11:25:00',11.32),('7643','2014-02-12','11:30:00',11.1),('7643','2014-02-12','11:35:00',11.86),('7643','2014-02-12','11:40:00',8.24),('7643','2014-02-12','11:45:00',13.2),('7643','2014-02-12','11:50:00',8.43),('7643','2014-02-12','11:55:00',13.66),('7643','2014-02-12','12:00:00',9.17),('7643','2014-02-12','12:05:00',7.03),('7643','2014-02-12','12:10:00',12.56),('7643','2014-02-12','12:15:00',11.82),('7643','2014-02-12','12:20:00',9.74),('7643','2014-02-12','12:25:00',10.44),('7643','2014-02-12','12:30:00',15.07),('7643','2014-02-12','12:35:00',14.53),('7643','2014-02-12','12:40:00',11.92),('7643','2014-02-12','12:45:00',2.98),('7643','2014-02-12','12:50:00',6.06),('7643','2014-02-12','12:55:00',5.19),('7643','2014-02-12','13:00:00',7.1),('7643','2014-02-12','13:05:00',13.16),('7643','2014-02-12','13:10:00',12.76),('7643','2014-02-12','13:15:00',12.36),('7643','2014-02-12','13:20:00',12.34),('7643','2014-02-12','13:25:00',12.12),('7643','2014-02-12','13:30:00',12.1),('7643','2014-02-12','13:35:00',11.91),('7643','2014-02-12','13:40:00',11.71),('7643','2014-02-12','13:45:00',11.63),('7643','2014-02-12','13:50:00',11.46),('7643','2014-02-12','13:55:00',11.37),('7643','2014-02-12','14:00:00',11.13),('7643','2014-02-12','14:05:00',10.95),('7643','2014-02-12','14:10:00',10.79),('7643','2014-02-12','14:15:00',10.55),('7643','2014-02-12','14:20:00',10.28),('7643','2014-02-12','14:25:00',10.14),('7643','2014-02-12','14:30:00',9.9),('7643','2014-02-12','14:35:00',9.8),('7643','2014-02-12','14:40:00',7),('7643','2014-02-12','14:45:00',8.67),('7643','2014-02-12','14:50:00',5.31),('7643','2014-02-12','14:55:00',9.38),('7643','2014-02-12','15:00:00',9.44),('7643','2014-02-12','15:05:00',6.96),('7643','2014-02-12','15:10:00',8.44),('7643','2014-02-12','15:15:00',6.93),('7643','2014-02-12','15:20:00',7.78),('7643','2014-02-12','15:25:00',7.46),('7643','2014-02-12','15:30:00',3.99),('7643','2014-02-12','15:35:00',7.09),('7643','2014-02-12','15:40:00',6.68),('7643','2014-02-12','15:45:00',6.26),('7643','2014-02-12','15:50:00',4.31),('7643','2014-02-12','15:55:00',4.28),('7643','2014-02-12','16:00:00',2.15),('7643','2014-02-12','16:05:00',4.21),('7643','2014-02-12','16:10:00',4.66),('7643','2014-02-12','16:15:00',2.85),('7643','2014-02-12','16:20:00',1.12),('7643','2014-02-12','16:25:00',1.35),('7643','2014-02-12','16:30:00',1.34),('7643','2014-02-12','16:35:00',1.39),('7643','2014-02-12','16:55:00',1.28),('7643','2014-02-11','08:15:00',1.5),('7643','2014-02-11','08:20:00',3.25),('7643','2014-02-11','08:40:00',1.22),('7643','2014-02-11','08:45:00',5),('7643','2014-02-11','08:50:00',5.76),('7643','2014-02-11','08:55:00',6.09),('7643','2014-02-11','09:00:00',1.91),('7643','2014-02-11','09:05:00',2.27),('7643','2014-02-11','09:10:00',3.77),('7643','2014-02-11','09:15:00',7.06),('7643','2014-02-11','09:20:00',6.6),('7643','2014-02-11','09:25:00',7.46),('7643','2014-02-11','09:30:00',3.68),('7643','2014-02-11','09:35:00',2.45),('7643','2014-02-11','09:40:00',5.51),('7643','2014-02-11','09:45:00',9.48),('7643','2014-02-11','09:50:00',8.9),('7643','2014-02-11','09:55:00',5.15),('7643','2014-02-11','10:00:00',3.76),('7643','2014-02-11','10:05:00',5.69),('7643','2014-02-11','10:10:00',5.3),('7643','2014-02-11','10:15:00',4.19),('7643','2014-02-11','10:20:00',3.91),('7643','2014-02-11','10:25:00',4.19),('7643','2014-02-11','10:30:00',5.59),('7643','2014-02-11','10:35:00',7.88),('7643','2014-02-11','10:40:00',5.15),('7643','2014-02-11','10:45:00',7.27),('7643','2014-02-11','10:50:00',5.64),('7643','2014-02-11','10:55:00',5.49),('7643','2014-02-11','11:00:00',5.84),('7643','2014-02-11','11:05:00',11.28),('7643','2014-02-11','11:10:00',6.33),('7643','2014-02-11','11:15:00',5.76),('7643','2014-02-11','11:20:00',6.86),('7643','2014-02-11','11:25:00',6.05),('7643','2014-02-11','11:30:00',7.24),('7643','2014-02-11','11:35:00',6.89),('7643','2014-02-11','11:40:00',4.78),('7643','2014-02-11','11:45:00',3.58),('7643','2014-02-11','11:50:00',3.44),('7643','2014-02-11','11:55:00',2.9),('7643','2014-02-11','12:00:00',2.76),('7643','2014-02-11','12:05:00',3.73),('7643','2014-02-11','12:10:00',4.48),('7643','2014-02-11','12:15:00',4.77),('7643','2014-02-11','12:20:00',4.73),('7643','2014-02-11','12:25:00',4.97),('7643','2014-02-11','12:30:00',5.3),('7643','2014-02-11','12:35:00',5.05),('7643','2014-02-11','12:40:00',4.91),('7643','2014-02-11','12:45:00',5.47),('7643','2014-02-11','12:50:00',6.55),('7643','2014-02-11','12:55:00',6.59),('7643','2014-02-11','13:00:00',6.67),('7643','2014-02-11','13:05:00',5.55),('7643','2014-02-11','13:10:00',5.66),('7643','2014-02-11','13:15:00',5.28),('7643','2014-02-11','13:20:00',4.91),('7643','2014-02-11','13:25:00',6.01),('7643','2014-02-11','13:30:00',8.06),('7643','2014-02-11','13:35:00',12.62),('7643','2014-02-11','13:40:00',11.15),('7643','2014-02-11','13:45:00',9.72),('7643','2014-02-11','13:50:00',10.8),('7643','2014-02-11','13:55:00',9.57),('7643','2014-02-11','14:00:00',11.72),('7643','2014-02-11','14:05:00',11.82),('7643','2014-02-11','14:10:00',11.57),('7643','2014-02-11','14:15:00',10.93),('7643','2014-02-11','14:20:00',8.86),('7643','2014-02-11','14:25:00',10.43),('7643','2014-02-11','14:30:00',7.42),('7643','2014-02-11','14:35:00',10.16),('7643','2014-02-11','14:40:00',6.52),('7643','2014-02-11','14:45:00',9.22),('7643','2014-02-11','14:50:00',10.19),('7643','2014-02-11','14:55:00',9.31),('7643','2014-02-11','15:00:00',5.72),('7643','2014-02-11','15:05:00',4.06),('7643','2014-02-11','15:10:00',5.04),('7643','2014-02-11','15:15:00',4.09),('7643','2014-02-11','15:20:00',5.75),('7643','2014-02-11','15:25:00',4.66),('7643','2014-02-11','15:30:00',3.38),('7643','2014-02-11','15:35:00',7.8),('7643','2014-02-11','15:40:00',6.98),('7643','2014-02-11','15:45:00',5.44),('7643','2014-02-11','15:50:00',5.34),('7643','2014-02-11','15:55:00',2.4),('7643','2014-02-11','16:00:00',2.36),('7643','2014-02-11','16:05:00',1.88),('7643','2014-02-11','16:10:00',1.4),('7643','2014-02-11','16:15:00',1.31),('7643','2014-02-11','16:20:00',1.06),('7643','2014-02-10','08:25:00',1.12),('7643','2014-02-10','08:30:00',1.23),('7643','2014-02-10','08:35:00',1.36),('7643','2014-02-10','08:40:00',1.49),('7643','2014-02-10','08:45:00',1.52),('7643','2014-02-10','08:50:00',1.58),('7643','2014-02-10','08:55:00',1.78),('7643','2014-02-10','09:00:00',2.2),('7643','2014-02-10','09:05:00',2.44),('7643','2014-02-10','09:10:00',2.34),('7643','2014-02-10','09:15:00',2.9),('7643','2014-02-10','09:20:00',4.33),('7643','2014-02-10','09:25:00',4.82),('7643','2014-02-10','09:30:00',4.75),('7643','2014-02-10','09:35:00',4.75),('7643','2014-02-10','09:40:00',4.65),('7643','2014-02-10','09:45:00',4.46),('7643','2014-02-10','09:50:00',4.96),('7643','2014-02-10','09:55:00',5.17),('7643','2014-02-10','10:00:00',4.38),('7643','2014-02-10','10:05:00',4.82),('7643','2014-02-10','10:10:00',5.42),('7643','2014-02-10','10:15:00',6.37),('7643','2014-02-10','10:20:00',7.22),('7643','2014-02-10','10:25:00',7.57),('7643','2014-02-10','10:30:00',8.19),('7643','2014-02-10','10:35:00',9.43),('7643','2014-02-10','10:40:00',9.71),('7643','2014-02-10','10:45:00',8.74),('7643','2014-02-10','10:50:00',8.87),('7643','2014-02-10','10:55:00',7.66),('7643','2014-02-10','11:00:00',8.42),('7643','2014-02-10','11:05:00',7.73),('7643','2014-02-10','11:10:00',9.52),('7643','2014-02-10','11:15:00',9.31),('7643','2014-02-10','11:20:00',8.99),('7643','2014-02-10','11:25:00',8.92),('7643','2014-02-10','11:30:00',9.6),('7643','2014-02-10','11:35:00',7.24),('7643','2014-02-10','11:40:00',5.58),('7643','2014-02-10','11:45:00',6.42),('7643','2014-02-10','11:50:00',7.79),('7643','2014-02-10','11:55:00',5.77),('7643','2014-02-10','12:00:00',4.81),('7643','2014-02-10','12:05:00',5.66),('7643','2014-02-10','12:10:00',6.7),('7643','2014-02-10','12:15:00',5.78),('7643','2014-02-10','12:20:00',6.66),('7643','2014-02-10','12:25:00',8.78),('7643','2014-02-10','12:30:00',8.4),('7643','2014-02-10','12:35:00',7.13),('7643','2014-02-10','12:40:00',5.45),('7643','2014-02-10','12:45:00',6.38),('7643','2014-02-10','12:50:00',5.07),('7643','2014-02-10','12:55:00',6.38),('7643','2014-02-10','13:00:00',6.77),('7643','2014-02-10','13:05:00',8.38),('7643','2014-02-10','13:10:00',10.16),('7643','2014-02-10','13:15:00',9.79),('7643','2014-02-10','13:20:00',11.7),('7643','2014-02-10','13:25:00',10.75),('7643','2014-02-10','13:30:00',9.53),('7643','2014-02-10','13:35:00',9.09),('7643','2014-02-10','13:40:00',10.74),('7643','2014-02-10','13:45:00',8.23),('7643','2014-02-10','13:50:00',6.32),('7643','2014-02-10','13:55:00',5.09),('7643','2014-02-10','14:00:00',7.15),('7643','2014-02-10','14:05:00',7.43),('7643','2014-02-10','14:10:00',6.5),('7643','2014-02-10','14:15:00',7.21),('7643','2014-02-10','14:20:00',5.03),('7643','2014-02-10','14:25:00',4.56),('7643','2014-02-10','14:30:00',5.66),('7643','2014-02-10','14:35:00',5.18),('7643','2014-02-10','14:40:00',4.05),('7643','2014-02-10','14:45:00',3.85),('7643','2014-02-10','14:50:00',3.2),('7643','2014-02-10','14:55:00',3.33),('7643','2014-02-10','15:00:00',3.22),('7643','2014-02-10','15:05:00',3.3),('7643','2014-02-10','15:10:00',3.55),('7643','2014-02-10','15:15:00',4.45),('7643','2014-02-10','15:20:00',5.63),('7643','2014-02-10','15:25:00',3.86),('7643','2014-02-10','15:30:00',3.18),('7643','2014-02-10','15:35:00',3.28),('7643','2014-02-10','15:40:00',3.04),('7643','2014-02-10','15:45:00',2.49),('7643','2014-02-10','15:50:00',2.24),('7643','2014-02-10','15:55:00',2.27),('7643','2014-02-10','16:00:00',2.65),('7643','2014-02-10','16:05:00',3.42),('7643','2014-02-10','16:10:00',2.99),('7643','2014-02-10','16:15:00',2.85),('7643','2014-02-10','16:20:00',2.89),('7643','2014-02-10','16:25:00',3.11),('7643','2014-02-10','16:30:00',2.93),('7643','2014-02-10','16:35:00',2.54),('7643','2014-02-10','16:40:00',2.23),('7643','2014-02-10','16:45:00',1.76),('7643','2014-02-10','16:50:00',1.3),('7643','2014-02-09','09:20:00',1.21),('7643','2014-02-09','09:25:00',1.82),('7643','2014-02-09','09:30:00',1.2),('7643','2014-02-09','09:50:00',1.03),('7643','2014-02-09','09:55:00',1.3),('7643','2014-02-09','10:00:00',1.42),('7643','2014-02-09','10:05:00',1.72),('7643','2014-02-09','10:10:00',1.84),('7643','2014-02-09','10:15:00',1.48),('7643','2014-02-09','10:20:00',1.77),('7643','2014-02-09','10:25:00',2.04),('7643','2014-02-09','10:30:00',2.03),('7643','2014-02-09','10:35:00',1.89),('7643','2014-02-09','10:40:00',1.27),('7643','2014-02-09','10:45:00',1.03),('7643','2014-02-09','10:50:00',1.34),('7643','2014-02-09','10:55:00',1.7),('7643','2014-02-09','11:00:00',1.61),('7643','2014-02-09','11:05:00',1.59),('7643','2014-02-09','11:10:00',1.46),('7643','2014-02-09','11:15:00',1.44),('7643','2014-02-09','11:20:00',1.38),('7643','2014-02-09','11:25:00',1.31),('7643','2014-02-09','11:30:00',1.24),('7643','2014-02-09','11:35:00',1.26),('7643','2014-02-09','11:40:00',1.56),('7643','2014-02-09','11:45:00',1.75),('7643','2014-02-09','11:50:00',1.72),('7643','2014-02-09','11:55:00',1.56),('7643','2014-02-09','12:00:00',1.78),('7643','2014-02-09','12:05:00',1.17),('7643','2014-02-09','12:10:00',1.67),('7643','2014-02-09','12:15:00',1.27),('7643','2014-02-09','12:20:00',1.63),('7643','2014-02-09','12:25:00',3.13),('7643','2014-02-09','12:30:00',2.55),('7643','2014-02-09','12:35:00',1.86),('7643','2014-02-09','12:40:00',1.79),('7643','2014-02-09','12:45:00',1.6),('7643','2014-02-09','12:50:00',2.25),('7643','2014-02-09','12:55:00',3.35),('7643','2014-02-09','13:00:00',4.47),('7643','2014-02-09','13:05:00',3.77),('7643','2014-02-09','13:10:00',2.83),('7643','2014-02-09','13:15:00',2.78),('7643','2014-02-09','13:20:00',2.59),('7643','2014-02-09','13:25:00',2.42),('7643','2014-02-09','13:30:00',2.78),('7643','2014-02-09','13:35:00',3.1),('7643','2014-02-09','13:40:00',3.08),('7643','2014-02-09','13:45:00',3.07),('7643','2014-02-09','13:50:00',2.92),('7643','2014-02-09','13:55:00',3.45),('7643','2014-02-09','14:00:00',3.59),('7643','2014-02-09','14:05:00',3.11),('7643','2014-02-09','14:10:00',2.98),('7643','2014-02-09','14:15:00',3.08),('7643','2014-02-09','14:20:00',3.14),('7643','2014-02-09','14:25:00',3.33),('7643','2014-02-09','14:30:00',3.67),('7643','2014-02-09','14:35:00',3.93),('7643','2014-02-09','14:40:00',4.06),('7643','2014-02-09','14:45:00',3.57),('7643','2014-02-09','14:50:00',2.95),('7643','2014-02-09','14:55:00',2.63),('7643','2014-02-09','15:00:00',2.58),('7643','2014-02-09','15:05:00',2.8),('7643','2014-02-09','15:10:00',2.67),('7643','2014-02-09','15:15:00',2.64),('7643','2014-02-09','15:20:00',2.7),('7643','2014-02-09','15:25:00',2.86),('7643','2014-02-09','15:30:00',2.63),('7643','2014-02-09','15:35:00',2.13),('7643','2014-02-09','15:40:00',1.71),('7643','2014-02-09','15:45:00',1.54),('7643','2014-02-09','15:50:00',1.59),('7643','2014-02-09','15:55:00',1.49),('7643','2014-02-09','16:00:00',1.18),('7643','2014-02-08','10:10:00',1.11),('7643','2014-02-08','10:45:00',1.75),('7643','2014-02-08','10:50:00',1.3),('7643','2014-02-08','10:55:00',1.28),('7643','2014-02-08','11:00:00',2.61),('7643','2014-02-08','11:05:00',2.55),('7643','2014-02-08','11:10:00',2.08),('7643','2014-02-08','11:15:00',2.08),('7643','2014-02-08','11:20:00',2.14),('7643','2014-02-08','11:25:00',3.39),('7643','2014-02-08','11:30:00',4.11),('7643','2014-02-08','11:35:00',4.93),('7643','2014-02-08','11:40:00',3.01),('7643','2014-02-08','11:45:00',1.25),('7643','2014-02-08','11:50:00',1.5),('7643','2014-02-08','11:55:00',1.77),('7643','2014-02-08','12:00:00',1.31),('7643','2014-02-08','12:05:00',1.47),('7643','2014-02-08','12:10:00',1.51),('7643','2014-02-08','12:15:00',2.81),('7643','2014-02-08','12:20:00',2.18),('7643','2014-02-08','12:25:00',5.25),('7643','2014-02-08','12:30:00',5.66),('7643','2014-02-08','12:35:00',4.08),('7643','2014-02-08','12:40:00',2.67),('7643','2014-02-08','12:45:00',7.46),('7643','2014-02-08','12:50:00',2.81),('7643','2014-02-08','12:55:00',5.8),('7643','2014-02-08','13:00:00',9.94),('7643','2014-02-08','13:05:00',10.64),('7643','2014-02-08','13:10:00',9.02),('7643','2014-02-08','13:15:00',5.69),('7643','2014-02-08','13:20:00',2.64),('7643','2014-02-08','13:25:00',3.93),('7643','2014-02-08','13:30:00',2.98),('7643','2014-02-08','13:35:00',2.82),('7643','2014-02-08','13:40:00',6.1),('7643','2014-02-08','13:45:00',11.14),('7643','2014-02-08','13:50:00',5.88),('7643','2014-02-08','13:55:00',9.29),('7643','2014-02-08','14:00:00',6.81),('7643','2014-02-08','14:05:00',9.92),('7643','2014-02-08','14:10:00',9.99),('7643','2014-02-08','14:15:00',4.95),('7643','2014-02-08','14:20:00',4.33),('7643','2014-02-08','14:25:00',5.92),('7643','2014-02-08','14:30:00',8.26),('7643','2014-02-08','14:35:00',7.1),('7643','2014-02-08','14:40:00',5.2),('7643','2014-02-08','14:45:00',3.29),('7643','2014-02-08','14:50:00',7.24),('7643','2014-02-08','14:55:00',3.59),('7643','2014-02-08','15:00:00',3.71),('7643','2014-02-08','15:05:00',1.98),('7643','2014-02-08','15:10:00',3.57),('7643','2014-02-08','15:15:00',6.05),('7643','2014-02-08','15:20:00',6.68),('7643','2014-02-08','15:25:00',6.39),('7643','2014-02-08','15:30:00',4.27),('7643','2014-02-08','15:35:00',3.83),('7643','2014-02-08','15:40:00',4.53),('7643','2014-02-08','15:45:00',4.54),('7643','2014-02-08','15:50:00',4.81),('7643','2014-02-08','15:55:00',4.43),('7643','2014-02-08','16:00:00',3.4),('7643','2014-02-08','16:05:00',3.45),('7643','2014-02-08','16:10:00',3.4),('7643','2014-02-08','16:15:00',3.06),('7643','2014-02-08','16:20:00',2.55),('7643','2014-02-08','16:25:00',2.05),('7643','2014-02-08','16:30:00',1.29),('7643','2014-02-08','16:35:00',1.26),('7643','2014-02-08','16:40:00',1.6),('7643','2014-02-08','16:45:00',1.36),('7643','2014-02-08','16:50:00',1.09),('7643','2014-02-07','09:35:00',1.36),('7643','2014-02-07','09:40:00',1.86),('7643','2014-02-07','09:45:00',2.88),('7643','2014-02-07','09:50:00',6.52),('7643','2014-02-07','09:55:00',4.98),('7643','2014-02-07','10:00:00',2.99),('7643','2014-02-07','10:05:00',3.01),('7643','2014-02-07','10:10:00',2.9),('7643','2014-02-07','10:15:00',5.9),('7643','2014-02-07','10:20:00',6.19),('7643','2014-02-07','10:25:00',4.48),('7643','2014-02-07','10:30:00',7.44),('7643','2014-02-07','10:35:00',10.84),('7643','2014-02-07','10:40:00',5.84),('7643','2014-02-07','10:45:00',5.57),('7643','2014-02-07','10:50:00',6.65),('7643','2014-02-07','10:55:00',11.61),('7643','2014-02-07','11:00:00',6.14),('7643','2014-02-07','11:05:00',11.82),('7643','2014-02-07','11:10:00',7.04),('7643','2014-02-07','11:15:00',6.38),('7643','2014-02-07','11:20:00',6.91),('7643','2014-02-07','11:25:00',2.84),('7643','2014-02-07','11:30:00',4.58),('7643','2014-02-07','11:35:00',14.58),('7643','2014-02-07','11:40:00',10.38),('7643','2014-02-07','11:45:00',2.52),('7643','2014-02-07','11:50:00',3.04),('7643','2014-02-07','11:55:00',14.64),('7643','2014-02-07','12:00:00',8.06),('7643','2014-02-07','12:05:00',4.5),('7643','2014-02-07','12:10:00',7.87),('7643','2014-02-07','12:15:00',14.48),('7643','2014-02-07','12:20:00',5.37),('7643','2014-02-07','12:25:00',5.63),('7643','2014-02-07','12:30:00',14.01),('7643','2014-02-07','12:35:00',7.12),('7643','2014-02-07','12:40:00',9.52),('7643','2014-02-07','12:45:00',11.03),('7643','2014-02-07','12:50:00',12.08),('7643','2014-02-07','12:55:00',10.9),('7643','2014-02-07','13:00:00',6.33),('7643','2014-02-07','13:05:00',5.33),('7643','2014-02-07','13:10:00',5.45),('7643','2014-02-07','13:15:00',14.82),('7643','2014-02-07','13:20:00',14.6),('7643','2014-02-07','13:25:00',12.32),('7643','2014-02-07','13:30:00',11.78),('7643','2014-02-07','13:35:00',7.59),('7643','2014-02-07','13:40:00',11.06),('7643','2014-02-07','13:45:00',12.5),('7643','2014-02-07','13:50:00',11.45),('7643','2014-02-07','13:55:00',11.21),('7643','2014-02-07','14:00:00',10.95),('7643','2014-02-07','14:05:00',11.17),('7643','2014-02-07','14:10:00',6.87),('7643','2014-02-07','14:15:00',5.03),('7643','2014-02-07','14:20:00',7.51),('7643','2014-02-07','14:25:00',6.32),('7643','2014-02-07','14:30:00',11.31),('7643','2014-02-07','14:35:00',7.75),('7643','2014-02-07','14:40:00',9.76),('7643','2014-02-07','14:45:00',4.18),('7643','2014-02-07','14:50:00',8.79),('7643','2014-02-07','14:55:00',7.2),('7643','2014-02-07','15:00:00',4.73),('7643','2014-02-07','15:05:00',2.85),('7643','2014-02-07','15:10:00',4.22),('7643','2014-02-07','15:15:00',5.22),('7643','2014-02-07','15:20:00',8.18),('7643','2014-02-07','15:25:00',2.75),('7643','2014-02-07','15:30:00',1.2),('7643','2014-02-07','15:35:00',1.79),('7643','2014-02-07','15:40:00',6.51),('7643','2014-02-07','15:45:00',6.44),('7643','2014-02-07','15:50:00',5.46),('7643','2014-02-07','15:55:00',4.71),('7643','2014-02-07','16:00:00',2.68),('7643','2014-02-07','16:05:00',3.48),('7643','2014-02-07','16:10:00',3.71),('7643','2014-02-07','16:15:00',3.17),('7643','2014-02-07','16:20:00',1.53),('7643','2014-02-07','16:25:00',1.44),('7643','2014-02-07','16:40:00',1.04),('7643','2014-02-06','08:00:00',1.23),('7643','2014-02-06','08:05:00',1.58),('7643','2014-02-06','08:10:00',1.76),('7643','2014-02-06','08:15:00',1.42),('7643','2014-02-06','08:20:00',1.75),('7643','2014-02-06','08:25:00',3.6),('7643','2014-02-06','08:30:00',3.63),('7643','2014-02-06','08:35:00',3.89),('7643','2014-02-06','08:40:00',4.59),('7643','2014-02-06','08:45:00',4.97),('7643','2014-02-06','08:50:00',5.27),('7643','2014-02-06','08:55:00',5.61),('7643','2014-02-06','09:00:00',5.9),('7643','2014-02-06','09:05:00',6.21),('7643','2014-02-06','09:10:00',6.5),('7643','2014-02-06','09:15:00',6.82),('7643','2014-02-06','09:20:00',7.06),('7643','2014-02-06','09:25:00',7.3),('7643','2014-02-06','09:30:00',7.59),('7643','2014-02-06','09:35:00',7.8),('7643','2014-02-06','09:40:00',8.04),('7643','2014-02-06','09:45:00',8.24),('7643','2014-02-06','09:50:00',8.51),('7643','2014-02-06','09:55:00',8.67),('7643','2014-02-06','10:00:00',8.89),('7643','2014-02-06','10:05:00',9.07),('7643','2014-02-06','10:10:00',9.3),('7643','2014-02-06','10:15:00',9.67),('7643','2014-02-06','10:20:00',9.79),('7643','2014-02-06','10:25:00',10.01),('7643','2014-02-06','10:30:00',9.6),('7643','2014-02-06','10:35:00',9.19),('7643','2014-02-06','10:40:00',10.93),('7643','2014-02-06','10:45:00',11.35),('7643','2014-02-06','10:50:00',11.44),('7643','2014-02-06','10:55:00',8.58),('7643','2014-02-06','11:00:00',11.83),('7643','2014-02-06','11:05:00',10.41),('7643','2014-02-06','11:10:00',10.65),('7643','2014-02-06','11:15:00',12.27),('7643','2014-02-06','11:20:00',13.04),('7643','2014-02-06','11:25:00',12.48),('7643','2014-02-06','11:30:00',12.39),('7643','2014-02-06','11:35:00',10.79),('7643','2014-02-06','11:40:00',12.66),('7643','2014-02-06','11:45:00',12.92),('7643','2014-02-06','11:50:00',13.19),('7643','2014-02-06','11:55:00',13.92),('7643','2014-02-06','12:00:00',14.22),('7643','2014-02-06','12:05:00',11.23),('7643','2014-02-06','12:10:00',11.75),('7643','2014-02-06','12:15:00',7.18),('7643','2014-02-06','12:20:00',6.85),('7643','2014-02-06','12:25:00',14.42),('7643','2014-02-06','12:30:00',10.83),('7643','2014-02-06','12:35:00',3.48),('7643','2014-02-06','12:40:00',7.13),('7643','2014-02-06','12:45:00',4.7),('7643','2014-02-06','12:50:00',9.15),('7643','2014-02-06','12:55:00',8.74),('7643','2014-02-06','13:00:00',9.14),('7643','2014-02-06','13:05:00',12.14),('7643','2014-02-06','13:10:00',13.45),('7643','2014-02-06','13:15:00',9.11),('7643','2014-02-06','13:20:00',6.4),('7643','2014-02-06','13:25:00',4.9),('7643','2014-02-06','13:30:00',9.41),('7643','2014-02-06','13:35:00',8.44),('7643','2014-02-06','13:40:00',4.67),('7643','2014-02-06','13:45:00',11.37),('7643','2014-02-06','13:50:00',8.45),('7643','2014-02-06','13:55:00',7.45),('7643','2014-02-06','14:00:00',9.98),('7643','2014-02-06','14:05:00',11.49),('7643','2014-02-06','14:10:00',10.74),('7643','2014-02-06','14:15:00',10.04),('7643','2014-02-06','14:20:00',4.16),('7643','2014-02-06','14:25:00',3),('7643','2014-02-06','14:30:00',4.48),('7643','2014-02-06','14:35:00',4.22),('7643','2014-02-06','14:40:00',8.7),('7643','2014-02-06','14:45:00',8.31),('7643','2014-02-06','14:50:00',8.71),('7643','2014-02-06','14:55:00',8.31),('7643','2014-02-06','15:00:00',7.91),('7643','2014-02-06','15:05:00',7.78),('7643','2014-02-06','15:10:00',7.46),('7643','2014-02-06','15:15:00',7.01),('7643','2014-02-06','15:20:00',6.4),('7643','2014-02-06','15:25:00',6.55),('7643','2014-02-06','15:30:00',6.24),('7643','2014-02-06','15:35:00',5.9),('7643','2014-02-06','15:40:00',5.61),('7643','2014-02-06','15:45:00',5.26),('7643','2014-02-06','15:50:00',4.95),('7643','2014-02-06','15:55:00',4.67),('7643','2014-02-06','16:00:00',4.32),('7643','2014-02-06','16:05:00',4.02),('7643','2014-02-06','16:10:00',3.71),('7643','2014-02-06','16:15:00',3.35),('7643','2014-02-06','16:20:00',3),('7643','2014-02-06','16:25:00',2.7),('7643','2014-02-06','16:30:00',2.37),('7643','2014-02-06','16:35:00',2.05),('7643','2014-02-06','16:40:00',1.7),('7643','2014-02-06','16:45:00',1.45),('7643','2014-02-06','16:50:00',1.17),('7643','2014-02-05','08:05:00',1.49),('7643','2014-02-05','08:10:00',1.38),('7643','2014-02-05','08:15:00',2.18),('7643','2014-02-05','08:20:00',2.76),('7643','2014-02-05','08:25:00',2.75),('7643','2014-02-05','08:30:00',2.74),('7643','2014-02-05','08:35:00',2.16),('7643','2014-02-05','08:40:00',4.3),('7643','2014-02-05','08:45:00',4.87),('7643','2014-02-05','08:50:00',5.37),('7643','2014-02-05','08:55:00',6.19),('7643','2014-02-05','09:00:00',7.35),('7643','2014-02-05','09:05:00',8.23),('7643','2014-02-05','09:10:00',6.47),('7643','2014-02-05','09:15:00',6.29),('7643','2014-02-05','09:20:00',2.65),('7643','2014-02-05','09:25:00',2.12),('7643','2014-02-05','09:30:00',6.95),('7643','2014-02-05','09:35:00',8.21),('7643','2014-02-05','09:40:00',8.38),('7643','2014-02-05','09:45:00',8.53),('7643','2014-02-05','09:50:00',8.76),('7643','2014-02-05','09:55:00',8.9),('7643','2014-02-05','10:00:00',9.06),('7643','2014-02-05','10:05:00',9.3),('7643','2014-02-05','10:10:00',9.53),('7643','2014-02-05','10:15:00',9.75),('7643','2014-02-05','10:20:00',9.92),('7643','2014-02-05','10:25:00',9.71),('7643','2014-02-05','10:30:00',10.4),('7643','2014-02-05','10:35:00',8.85),('7643','2014-02-05','10:40:00',8.45),('7643','2014-02-05','10:45:00',9.64),('7643','2014-02-05','10:50:00',5.51),('7643','2014-02-05','10:55:00',6.13),('7643','2014-02-05','11:00:00',7.13),('7643','2014-02-05','11:05:00',6.76),('7643','2014-02-05','11:10:00',4.8),('7643','2014-02-05','11:15:00',5.24),('7643','2014-02-05','11:20:00',9.04),('7643','2014-02-05','11:25:00',11.77),('7643','2014-02-05','11:30:00',12.55),('7643','2014-02-05','11:35:00',12.19),('7643','2014-02-05','11:40:00',12.07),('7643','2014-02-05','11:45:00',12.1),('7643','2014-02-05','11:50:00',12.25),('7643','2014-02-05','11:55:00',12.23),('7643','2014-02-05','12:00:00',12.37),('7643','2014-02-05','12:05:00',12.7),('7643','2014-02-05','12:10:00',12.74),('7643','2014-02-05','12:15:00',12.22),('7643','2014-02-05','12:20:00',12.39),('7643','2014-02-05','12:25:00',12.31),('7643','2014-02-05','12:30:00',12.11),('7643','2014-02-05','12:35:00',9.46),('7643','2014-02-05','12:40:00',12.37),('7643','2014-02-05','12:45:00',12.47),('7643','2014-02-05','12:50:00',12.08),('7643','2014-02-05','12:55:00',12.03),('7643','2014-02-05','13:00:00',12.03),('7643','2014-02-05','13:05:00',9.1),('7643','2014-02-05','13:10:00',12.38),('7643','2014-02-05','13:15:00',12.35),('7643','2014-02-05','13:20:00',11.94),('7643','2014-02-05','13:25:00',8.83),('7643','2014-02-05','13:30:00',7.51),('7643','2014-02-05','13:35:00',10.46),('7643','2014-02-05','13:40:00',11.6),('7643','2014-02-05','13:45:00',11.29),('7643','2014-02-05','13:50:00',11.16),('7643','2014-02-05','13:55:00',10.85),('7643','2014-02-05','14:00:00',8.45),('7643','2014-02-05','14:05:00',10.05),('7643','2014-02-05','14:10:00',3.97),('7643','2014-02-05','14:15:00',9.39),('7643','2014-02-05','14:20:00',6.45),('7643','2014-02-05','14:25:00',9.41),('7643','2014-02-05','14:30:00',4.69),('7643','2014-02-05','14:35:00',6.72),('7643','2014-02-05','14:40:00',9.31),('7643','2014-02-05','14:45:00',8.52),('7643','2014-02-05','14:50:00',6.95),('7643','2014-02-05','14:55:00',8.5),('7643','2014-02-05','15:00:00',8.03),('7643','2014-02-05','15:05:00',7.66),('7643','2014-02-05','15:10:00',7.4),('7643','2014-02-05','15:15:00',7.3),('7643','2014-02-05','15:20:00',7.27),('7643','2014-02-05','15:25:00',6.52),('7643','2014-02-05','15:30:00',6.07),('7643','2014-02-05','15:35:00',5.77),('7643','2014-02-05','15:40:00',5.44),('7643','2014-02-05','15:45:00',5.14),('7643','2014-02-05','15:50:00',4.8),('7643','2014-02-05','15:55:00',4.47),('7643','2014-02-05','16:00:00',4.09),('7643','2014-02-05','16:05:00',3.8),('7643','2014-02-05','16:10:00',3.51),('7643','2014-02-05','16:15:00',3.19),('7643','2014-02-05','16:20:00',2.84),('7643','2014-02-05','16:25:00',2.56),('7643','2014-02-05','16:30:00',2.26),('7643','2014-02-05','16:35:00',1.95),('7643','2014-02-05','16:40:00',1.66),('7643','2014-02-05','16:45:00',1.38),('7643','2014-02-05','16:50:00',1.13),('7643','2014-04-26','08:25:00',1.15),('7643','2014-04-26','08:30:00',1.24),('7643','2014-04-26','08:35:00',1.36),('7643','2014-04-26','08:40:00',1.42),('7643','2014-04-26','08:45:00',1.72),('7643','2014-04-26','08:50:00',2.61),('7643','2014-04-26','08:55:00',3.52),('7643','2014-04-26','09:00:00',3.03),('7643','2014-04-26','09:05:00',1.38),('7643','2014-04-26','09:10:00',1.28),('7643','2014-04-26','09:15:00',2.42),('7643','2014-04-26','09:20:00',3.2),('7643','2014-04-26','09:25:00',3.06),('7643','2014-04-26','09:30:00',2.4),('7643','2014-04-26','09:35:00',1.93),('7643','2014-04-26','09:40:00',2.49),('7643','2014-04-26','09:45:00',3.43),('7643','2014-04-26','09:50:00',2.94),('7643','2014-04-26','09:55:00',2.86),('7643','2014-04-26','10:00:00',4.06),('7643','2014-04-26','10:05:00',3.94),('7643','2014-04-26','10:10:00',4.18),('7643','2014-04-26','10:15:00',3.46),('7643','2014-04-26','10:20:00',3.11),('7643','2014-04-26','10:25:00',2.61),('7643','2014-04-26','10:30:00',1.87),('7643','2014-04-26','10:35:00',1.66),('7643','2014-04-26','10:40:00',1.84),('7643','2014-04-26','10:45:00',1.44),('7643','2014-04-26','10:50:00',1.87),('7643','2014-04-26','10:55:00',3),('7643','2014-04-26','11:00:00',4.43),('7643','2014-04-26','11:05:00',5.25),('7643','2014-04-26','11:10:00',6.59),('7643','2014-04-26','11:15:00',6.5),('7643','2014-04-26','11:20:00',4.77),('7643','2014-04-26','11:25:00',3.33),('7643','2014-04-26','11:30:00',4.13),('7643','2014-04-26','11:35:00',6.81),('7643','2014-04-26','11:40:00',7.19),('7643','2014-04-26','11:45:00',12.65),('7643','2014-04-26','11:50:00',10.15),('7643','2014-04-26','11:55:00',9.9),('7643','2014-04-26','12:00:00',10.07),('7643','2014-04-26','12:05:00',10.85),('7643','2014-04-26','12:10:00',12.79),('7643','2014-04-26','12:15:00',11.94),('7643','2014-04-26','12:20:00',10.83),('7643','2014-04-26','12:25:00',11.36),('7643','2014-04-26','12:30:00',10.08),('7643','2014-04-26','12:35:00',10.35),('7643','2014-04-26','12:40:00',9.17),('7643','2014-04-26','12:45:00',10.48),('7643','2014-04-26','12:50:00',8),('7643','2014-04-26','12:55:00',6.47),('7643','2014-04-26','13:00:00',8.15),('7643','2014-04-26','13:05:00',8.2),('7643','2014-04-26','13:10:00',6.67),('7643','2014-04-26','13:15:00',6.91),('7643','2014-04-26','13:20:00',9.7),('7643','2014-04-26','13:25:00',8.93),('7643','2014-04-26','13:30:00',8.01),('7643','2014-04-26','13:35:00',6.89),('7643','2014-04-26','13:40:00',6.57),('7643','2014-04-26','13:45:00',6.25),('7643','2014-04-26','13:50:00',6.11),('7643','2014-04-26','13:55:00',5.52),('7643','2014-04-26','14:00:00',7.43),('7643','2014-04-26','14:05:00',8.72),('7643','2014-04-26','14:10:00',6.49),('7643','2014-04-26','14:15:00',6.1),('7643','2014-04-26','14:20:00',7.01),('7643','2014-04-26','14:25:00',8.69),('7643','2014-04-26','14:30:00',9.16),('7643','2014-04-26','14:35:00',8.89),('7643','2014-04-26','14:40:00',8.93),('7643','2014-04-26','14:45:00',7.75),('7643','2014-04-26','14:50:00',7.36),('7643','2014-04-26','14:55:00',7.98),('7643','2014-04-26','15:00:00',8.48),('7643','2014-04-26','15:05:00',12.33),('7643','2014-04-26','15:10:00',16.98),('7643','2014-04-26','15:15:00',11.94),('7643','2014-04-26','15:20:00',7.6),('7643','2014-04-26','15:25:00',4.61),('7643','2014-04-26','15:30:00',3.61),('7643','2014-04-26','15:35:00',3.91),('7643','2014-04-26','15:40:00',3.96),('7643','2014-04-26','15:45:00',3.47),('7643','2014-04-26','15:50:00',3.41),('7643','2014-04-26','15:55:00',2.2),('7643','2014-04-26','16:20:00',1.03),('7643','2014-04-26','16:25:00',1.45),('7643','2014-04-26','16:30:00',1.42),('7643','2014-04-26','16:35:00',1.94),('7643','2014-04-26','16:40:00',1.32),('7643','2014-04-26','17:15:00',1.13),('7643','2014-04-26','17:45:00',1.05),('7643','2014-04-26','17:55:00',1.16),('7643','2014-04-26','18:00:00',1.18),('7643','2014-02-04','09:20:00',1.03),('7643','2014-02-04','09:55:00',1.32),('7643','2014-02-04','10:00:00',1.4),('7643','2014-02-04','10:05:00',1.54),('7643','2014-02-04','10:10:00',3.05),('7643','2014-02-04','10:15:00',6.04),('7643','2014-02-04','10:20:00',10.86),('7643','2014-02-04','10:25:00',10.29),('7643','2014-02-04','10:30:00',3.4),('7643','2014-02-04','10:35:00',4.54),('7643','2014-02-04','10:40:00',3.04),('7643','2014-02-04','10:45:00',1.59),('7643','2014-02-04','10:50:00',3.16),('7643','2014-02-04','10:55:00',3.18),('7643','2014-02-04','11:00:00',2.35),('7643','2014-02-04','11:05:00',1.7),('7643','2014-02-04','11:10:00',4.17),('7643','2014-02-04','11:15:00',9.61),('7643','2014-02-04','11:20:00',12.63),('7643','2014-02-04','11:25:00',8.13),('7643','2014-02-04','11:30:00',4.39),('7643','2014-02-04','11:35:00',2.23),('7643','2014-02-04','11:40:00',1.24),('7643','2014-02-04','11:50:00',1.27),('7643','2014-02-04','11:55:00',1.16),('7643','2014-02-04','12:00:00',1.05),('7643','2014-02-04','12:35:00',1.26),('7643','2014-02-04','12:50:00',1.74),('7643','2014-02-04','12:55:00',4.23),('7643','2014-02-04','13:00:00',3.44),('7643','2014-02-04','13:05:00',3.47),('7643','2014-02-04','13:10:00',4.25),('7643','2014-02-04','13:15:00',3.67),('7643','2014-02-04','13:20:00',4.35),('7643','2014-02-04','13:25:00',6.61),('7643','2014-02-04','13:30:00',6.33),('7643','2014-02-04','13:35:00',7.59),('7643','2014-02-04','13:40:00',7.55),('7643','2014-02-04','13:45:00',7.56),('7643','2014-02-04','13:50:00',6.39),('7643','2014-02-04','13:55:00',4.44),('7643','2014-02-04','14:00:00',3.34),('7643','2014-02-04','14:05:00',2.28),('7643','2014-02-04','14:10:00',1.74),('7643','2014-02-04','14:15:00',1.97),('7643','2014-02-04','14:20:00',1.61),('7643','2014-02-04','14:25:00',1.31),('7643','2014-02-04','14:30:00',5.72),('7643','2014-02-04','14:35:00',6.4),('7643','2014-02-04','14:40:00',2.7),('7643','2014-02-04','14:45:00',1.88),('7643','2014-02-04','14:50:00',1.96),('7643','2014-02-04','14:55:00',1.67),('7643','2014-02-04','15:00:00',1.94),('7643','2014-02-04','15:05:00',1.91),('7643','2014-02-04','15:10:00',1.78),('7643','2014-02-04','15:15:00',1.28),('7643','2014-02-04','15:25:00',1.1),('7643','2014-02-04','15:30:00',1.88),('7643','2014-02-04','15:35:00',1.26),('7643','2014-02-03','08:20:00',1.16),('7643','2014-02-03','08:25:00',1.32),('7643','2014-02-03','08:30:00',1.62),('7643','2014-02-03','08:35:00',1.91),('7643','2014-02-03','08:40:00',1.97),('7643','2014-02-03','08:45:00',2.07),('7643','2014-02-03','08:50:00',2.13),('7643','2014-02-03','08:55:00',2.33),('7643','2014-02-03','09:00:00',2.52),('7643','2014-02-03','09:05:00',2.72),('7643','2014-02-03','09:10:00',3),('7643','2014-02-03','09:15:00',3.68),('7643','2014-02-03','09:20:00',5.88),('7643','2014-02-03','09:25:00',8.27),('7643','2014-02-03','09:30:00',8.24),('7643','2014-02-03','09:35:00',8.09),('7643','2014-02-03','09:40:00',8.8),('7643','2014-02-03','09:45:00',8.4),('7643','2014-02-03','09:50:00',6.4),('7643','2014-02-03','09:55:00',8.39),('7643','2014-02-03','10:00:00',9.58),('7643','2014-02-03','10:05:00',9.05),('7643','2014-02-03','10:10:00',4.9),('7643','2014-02-03','10:15:00',7.78),('7643','2014-02-03','10:20:00',5.28),('7643','2014-02-03','10:25:00',3.44),('7643','2014-02-03','10:30:00',2.37),('7643','2014-02-03','10:35:00',3.49),('7643','2014-02-03','10:40:00',5.03),('7643','2014-02-03','10:45:00',6.65),('7643','2014-02-03','10:50:00',9.65),('7643','2014-02-03','10:55:00',10.25),('7643','2014-02-03','11:00:00',6.03),('7643','2014-02-03','11:05:00',4.03),('7643','2014-02-03','11:10:00',3.89),('7643','2014-02-03','11:15:00',3.4),('7643','2014-02-03','11:20:00',3.09),('7643','2014-02-03','11:25:00',3.31),('7643','2014-02-03','11:30:00',3.45),('7643','2014-02-03','11:35:00',2.46),('7643','2014-02-03','11:40:00',4.33),('7643','2014-02-03','11:45:00',2.42),('7643','2014-02-03','11:50:00',5.88),('7643','2014-02-03','11:55:00',13.15),('7643','2014-02-03','12:00:00',12.72),('7643','2014-02-03','12:05:00',4.91),('7643','2014-02-03','12:10:00',5.98),('7643','2014-02-03','12:15:00',5.98),('7643','2014-02-03','12:20:00',5.41),('7643','2014-02-03','12:25:00',5.18),('7643','2014-02-03','12:30:00',4.42),('7643','2014-02-03','12:35:00',3.21),('7643','2014-02-03','12:40:00',2.96),('7643','2014-02-03','12:45:00',4.04),('7643','2014-02-03','12:50:00',4.36),('7643','2014-02-03','12:55:00',3.45),('7643','2014-02-03','13:00:00',4.32),('7643','2014-02-03','13:05:00',4.59),('7643','2014-02-03','13:10:00',3.55),('7643','2014-02-03','13:15:00',4.21),('7643','2014-02-03','13:20:00',4.85),('7643','2014-02-03','13:25:00',3.98),('7643','2014-02-03','13:30:00',3.02),('7643','2014-02-03','13:35:00',2.87),('7643','2014-02-03','13:40:00',2.84),('7643','2014-02-03','13:45:00',2.99),('7643','2014-02-03','13:50:00',3.68),('7643','2014-02-03','13:55:00',3.32),('7643','2014-02-03','14:00:00',2.45),('7643','2014-02-03','14:05:00',2.12),('7643','2014-02-03','14:10:00',2.74),('7643','2014-02-03','14:15:00',3.12),('7643','2014-02-03','14:20:00',3.05),('7643','2014-02-03','14:25:00',2.16),('7643','2014-02-03','14:30:00',1.07),('7643','2014-02-03','15:00:00',1.14),('7643','2014-02-03','15:05:00',1.54),('7643','2014-02-03','15:10:00',1.83),('7643','2014-02-03','15:15:00',1.65),('7643','2014-02-03','15:20:00',1.18),('7643','2014-02-03','15:25:00',1.02),('7643','2014-02-02','08:20:00',1.01),('7643','2014-02-02','08:25:00',1.19),('7643','2014-02-02','08:30:00',1.18),('7643','2014-02-02','08:35:00',1.11),('7643','2014-02-02','08:40:00',1.24),('7643','2014-02-02','08:45:00',1.55),('7643','2014-02-02','08:50:00',1.57),('7643','2014-02-02','08:55:00',1.52),('7643','2014-02-02','09:00:00',1.77),('7643','2014-02-02','09:05:00',1.83),('7643','2014-02-02','09:10:00',1.68),('7643','2014-02-02','09:15:00',1.76),('7643','2014-02-02','09:20:00',1.93),('7643','2014-02-02','09:25:00',2.11),('7643','2014-02-02','09:30:00',2.18),('7643','2014-02-02','09:35:00',2.33),('7643','2014-02-02','09:40:00',2.61),('7643','2014-02-02','09:45:00',2.96),('7643','2014-02-02','09:50:00',3.39),('7643','2014-02-02','09:55:00',2.99),('7643','2014-02-02','10:00:00',2.71),('7643','2014-02-02','10:05:00',2.78),('7643','2014-02-02','10:10:00',3.31),('7643','2014-02-02','10:15:00',3.89),('7643','2014-02-02','10:20:00',3.82),('7643','2014-02-02','10:25:00',3.81),('7643','2014-02-02','10:30:00',3.96),('7643','2014-02-02','10:35:00',3.97),('7643','2014-02-02','10:40:00',4.15),('7643','2014-02-02','10:45:00',4.15),('7643','2014-02-02','10:50:00',4.13),('7643','2014-02-02','10:55:00',4.05),('7643','2014-02-02','11:00:00',3.81),('7643','2014-02-02','11:05:00',3.59),('7643','2014-02-02','11:10:00',3.66),('7643','2014-02-02','11:15:00',3.77),('7643','2014-02-02','11:20:00',3.99),('7643','2014-02-02','11:25:00',4.27),('7643','2014-02-02','11:30:00',4.67),('7643','2014-02-02','11:35:00',4.73),('7643','2014-02-02','11:40:00',4.6),('7643','2014-02-02','11:45:00',4.57),('7643','2014-02-02','11:50:00',4.46),('7643','2014-02-02','11:55:00',3.83),('7643','2014-02-02','12:00:00',3.28),('7643','2014-02-02','12:05:00',3.36),('7643','2014-02-02','12:10:00',3.45),('7643','2014-02-02','12:15:00',3.65),('7643','2014-02-02','12:20:00',3.41),('7643','2014-02-02','12:25:00',2.97),('7643','2014-02-02','12:30:00',2.42),('7643','2014-02-02','12:35:00',2.14),('7643','2014-02-02','12:40:00',2.3),('7643','2014-02-02','12:45:00',1.64),('7643','2014-02-02','12:50:00',1.58),('7643','2014-02-02','12:55:00',2.33),('7643','2014-02-02','13:00:00',2.44),('7643','2014-02-02','13:05:00',2.33),('7643','2014-02-02','13:10:00',2.52),('7643','2014-02-02','13:15:00',2.77),('7643','2014-02-02','13:20:00',2.85),('7643','2014-02-02','13:25:00',3.07),('7643','2014-02-02','13:30:00',3.21),('7643','2014-02-02','13:35:00',3.05),('7643','2014-02-02','13:40:00',2.79),('7643','2014-02-02','13:45:00',2.69),('7643','2014-02-02','13:50:00',2.84),('7643','2014-02-02','13:55:00',2.88),('7643','2014-02-02','14:00:00',3.08),('7643','2014-02-02','14:05:00',3.24),('7643','2014-02-02','14:10:00',3.29),('7643','2014-02-02','14:15:00',3.14),('7643','2014-02-02','14:20:00',2.87),('7643','2014-02-02','14:25:00',3.22),('7643','2014-02-02','14:30:00',3.42),('7643','2014-02-02','14:35:00',3.44),('7643','2014-02-02','14:40:00',3.41),('7643','2014-02-02','14:45:00',3.23),('7643','2014-02-02','14:50:00',2.93),('7643','2014-02-02','14:55:00',2.41),('7643','2014-02-02','15:00:00',1.68),('7643','2014-02-02','15:05:00',1.39),('7643','2014-02-02','15:10:00',1.51),('7643','2014-02-02','15:15:00',1.64),('7643','2014-02-02','15:20:00',1.82),('7643','2014-02-02','15:25:00',1.88),('7643','2014-02-02','15:30:00',1.62),('7643','2014-02-02','15:35:00',1.35),('7643','2014-02-02','15:40:00',1.13),('7643','2014-02-01','09:40:00',1.09),('7643','2014-02-01','09:45:00',1.28),('7643','2014-02-01','09:50:00',1.31),('7643','2014-02-01','09:55:00',1.44),('7643','2014-02-01','10:00:00',1.59),('7643','2014-02-01','10:05:00',1.56),('7643','2014-02-01','10:10:00',1.52),('7643','2014-02-01','10:15:00',1.28),('7643','2014-02-01','10:20:00',1.16),('7643','2014-02-01','10:25:00',1.15),('7643','2014-02-01','10:30:00',1.08),('7643','2014-02-01','10:35:00',1.14),('7643','2014-02-01','10:40:00',1.3),('7643','2014-02-01','10:45:00',1.25),('7643','2014-02-01','10:50:00',1.05),('7643','2014-02-01','11:05:00',1.06),('7643','2014-02-01','11:10:00',1.29),('7643','2014-02-01','11:15:00',1.68),('7643','2014-02-01','11:20:00',1.96),('7643','2014-02-01','11:25:00',2.32),('7643','2014-02-01','11:30:00',2.51),('7643','2014-02-01','11:35:00',2.35),('7643','2014-02-01','11:40:00',2.43),('7643','2014-02-01','11:45:00',2.66),('7643','2014-02-01','11:50:00',2.89),('7643','2014-02-01','11:55:00',3.26),('7643','2014-02-01','12:00:00',3.6),('7643','2014-02-01','12:05:00',3.68),('7643','2014-02-01','12:10:00',3.51),('7643','2014-02-01','12:15:00',3.07),('7643','2014-02-01','12:20:00',2.63),('7643','2014-02-01','12:25:00',2.36),('7643','2014-02-01','12:30:00',2.38),('7643','2014-02-01','12:35:00',2.31),('7643','2014-02-01','12:40:00',2.09),('7643','2014-02-01','12:45:00',1.82),('7643','2014-02-01','12:50:00',1.6),('7643','2014-02-01','12:55:00',1.59),('7643','2014-02-01','13:00:00',1.66),('7643','2014-02-01','13:05:00',1.74),('7643','2014-02-01','13:10:00',1.83),('7643','2014-02-01','13:15:00',2.15),('7643','2014-02-01','13:20:00',2.43),('7643','2014-02-01','13:25:00',2.34),('7643','2014-02-01','13:30:00',1.94),('7643','2014-02-01','13:35:00',1.49),('7643','2014-02-01','13:40:00',1.46),('7643','2014-02-01','13:45:00',1.5),('7643','2014-02-01','13:50:00',1.74),('7643','2014-02-01','13:55:00',1.89),('7643','2014-02-01','14:00:00',1.86),('7643','2014-02-01','14:05:00',1.91),('7643','2014-02-01','14:10:00',1.74),('7643','2014-02-01','14:15:00',1.66),('7643','2014-02-01','14:20:00',1.96),('7643','2014-02-01','14:25:00',1.94),('7643','2014-02-01','14:30:00',1.77),('7643','2014-02-01','14:35:00',1.69),('7643','2014-02-01','14:40:00',1.59),('7643','2014-02-01','14:45:00',1.55),('7643','2014-02-01','14:50:00',1.64),('7643','2014-02-01','14:55:00',1.78),('7643','2014-02-01','15:00:00',1.92),('7643','2014-02-01','15:05:00',1.99),('7643','2014-02-01','15:10:00',1.98),('7643','2014-02-01','15:15:00',1.84),('7643','2014-02-01','15:20:00',1.72),('7643','2014-02-01','15:25:00',1.51),('7643','2014-02-01','15:30:00',1.21),('7643','2014-02-01','15:35:00',1.02),('7643','2014-01-31','08:45:00',1.93),('7643','2014-01-31','08:50:00',2.21),('7643','2014-01-31','08:55:00',1.86),('7643','2014-01-31','09:00:00',1.72),('7643','2014-01-31','09:05:00',1.85),('7643','2014-01-31','09:10:00',1.9),('7643','2014-01-31','09:15:00',2.2),('7643','2014-01-31','09:20:00',2.17),('7643','2014-01-31','09:25:00',2.25),('7643','2014-01-31','09:30:00',1.83),('7643','2014-01-31','09:35:00',1.49),('7643','2014-01-31','09:40:00',1.46),('7643','2014-01-31','09:45:00',1.71),('7643','2014-01-31','09:50:00',1.81),('7643','2014-01-31','09:55:00',1.89),('7643','2014-01-31','10:00:00',1.6),('7643','2014-01-31','10:05:00',1.58),('7643','2014-01-31','10:10:00',1.78),('7643','2014-01-31','10:15:00',2.33),('7643','2014-01-31','10:20:00',2.67),('7643','2014-01-31','10:25:00',2.41),('7643','2014-01-31','10:30:00',2.3),('7643','2014-01-31','10:35:00',2.28),('7643','2014-01-31','10:40:00',2.43),('7643','2014-01-31','10:45:00',2.66),('7643','2014-01-31','10:50:00',2.83),('7643','2014-01-31','10:55:00',3.23),('7643','2014-01-31','11:00:00',4.36),('7643','2014-01-31','11:05:00',4.16),('7643','2014-01-31','11:10:00',3.09),('7643','2014-01-31','11:15:00',4.11),('7643','2014-01-31','11:20:00',6.81),('7643','2014-01-31','11:25:00',4.84),('7643','2014-01-31','11:30:00',8.5),('7643','2014-01-31','11:35:00',6.54),('7643','2014-01-31','11:40:00',3.84),('7643','2014-01-31','11:45:00',2.58),('7643','2014-01-31','11:50:00',3.19),('7643','2014-01-31','11:55:00',7.5),('7643','2014-01-31','12:00:00',5.64),('7643','2014-01-31','12:05:00',5.75),('7643','2014-01-31','12:10:00',7.89),('7643','2014-01-31','12:15:00',5.06),('7643','2014-01-31','12:20:00',8.48),('7643','2014-01-31','12:25:00',4.75),('7643','2014-01-31','12:30:00',2.66),('7643','2014-01-31','12:35:00',3.89),('7643','2014-01-31','12:40:00',6.72),('7643','2014-01-31','12:45:00',8.47),('7643','2014-01-31','12:50:00',7.21),('7643','2014-01-31','12:55:00',4.65),('7643','2014-01-31','13:00:00',5.33),('7643','2014-01-31','13:05:00',3.79),('7643','2014-01-31','13:10:00',2.75),('7643','2014-01-31','13:15:00',2.27),('7643','2014-01-31','13:20:00',2.14),('7643','2014-01-31','13:25:00',2.32),('7643','2014-01-31','13:30:00',2.45),('7643','2014-01-31','13:35:00',2.38),('7643','2014-01-31','13:40:00',2.17),('7643','2014-01-31','13:45:00',2.23),('7643','2014-01-31','13:50:00',2.16),('7643','2014-01-31','13:55:00',1.57),('7643','2014-01-31','14:00:00',1.27),('7643','2014-01-31','14:05:00',1.28),('7643','2014-01-31','14:10:00',1.48),('7643','2014-01-31','14:15:00',1.22),('7643','2014-01-31','14:55:00',1.13),('7643','2014-01-31','15:00:00',1.14),('7643','2014-01-31','15:05:00',1.34),('7643','2014-01-31','15:10:00',1.28),('7643','2014-01-31','15:15:00',1.14),('7643','2014-01-30','10:10:00',1.03),('7643','2014-01-30','10:15:00',2.03),('7643','2014-01-30','10:20:00',2.28),('7643','2014-01-30','10:25:00',2.39),('7643','2014-01-30','10:30:00',3.02),('7643','2014-01-30','10:35:00',2.44),('7643','2014-01-30','10:40:00',1.12),('7643','2014-01-30','10:55:00',1.16),('7643','2014-01-30','11:00:00',1.54),('7643','2014-01-30','11:05:00',1.84),('7643','2014-01-30','11:10:00',1.87),('7643','2014-01-30','11:15:00',1.6),('7643','2014-01-30','11:20:00',1.72),('7643','2014-01-30','11:25:00',1.65),('7643','2014-01-30','11:30:00',1.81),('7643','2014-01-30','11:35:00',2.21),('7643','2014-01-30','11:40:00',2.49),('7643','2014-01-30','11:45:00',2.65),('7643','2014-01-30','11:50:00',2.77),('7643','2014-01-30','11:55:00',2.42),('7643','2014-01-30','12:00:00',2.02),('7643','2014-01-30','12:05:00',1.98),('7643','2014-01-30','12:10:00',2.28),('7643','2014-01-30','12:15:00',2.55),('7643','2014-01-30','12:20:00',2.46),('7643','2014-01-30','12:25:00',2.59),('7643','2014-01-30','12:30:00',2.66),('7643','2014-01-30','12:35:00',2.97),('7643','2014-01-30','12:40:00',2.35),('7643','2014-01-30','12:45:00',1.77),('7643','2014-01-30','12:50:00',1.62),('7643','2014-01-30','12:55:00',1.52),('7643','2014-01-30','13:00:00',1.6),('7643','2014-01-30','13:05:00',1.47),('7643','2014-01-30','13:10:00',1.25),('7643','2014-01-30','13:15:00',1.1),('7643','2014-01-30','13:20:00',1.27),('7643','2014-01-30','13:25:00',1.53),('7643','2014-01-30','13:30:00',1.58),('7643','2014-01-30','13:35:00',1.41),('7643','2014-01-30','13:40:00',1.99),('7643','2014-01-30','13:45:00',2.7),('7643','2014-01-30','13:50:00',3.31),('7643','2014-01-30','13:55:00',2.66),('7643','2014-01-30','14:00:00',1.92),('7643','2014-01-30','14:05:00',2.01),('7643','2014-01-30','14:10:00',2.18),('7643','2014-01-30','14:15:00',2.51),('7643','2014-01-30','14:20:00',2.35),('7643','2014-01-30','14:25:00',1.59),('7643','2014-01-30','14:30:00',1.15),('7643','2014-01-30','14:35:00',1.47),('7643','2014-01-30','14:40:00',2.06),('7643','2014-01-30','14:45:00',2.77),('7643','2014-01-30','14:50:00',1.52),('7643','2014-01-29','08:30:00',1.07),('7643','2014-01-29','08:35:00',1.21),('7643','2014-01-29','08:40:00',1.37),('7643','2014-01-29','08:45:00',1.54),('7643','2014-01-29','08:50:00',1.8),('7643','2014-01-29','08:55:00',2.03),('7643','2014-01-29','09:00:00',2.22),('7643','2014-01-29','09:05:00',2.39),('7643','2014-01-29','09:10:00',2.57),('7643','2014-01-29','09:15:00',2.92),('7643','2014-01-29','09:20:00',3.23),('7643','2014-01-29','09:25:00',3.39),('7643','2014-01-29','09:30:00',3.17),('7643','2014-01-29','09:35:00',3.15),('7643','2014-01-29','09:40:00',3.86),('7643','2014-01-29','09:45:00',3.25),('7643','2014-01-29','09:50:00',5.11),('7643','2014-01-29','09:55:00',8.09),('7643','2014-01-29','10:00:00',7.41),('7643','2014-01-29','10:05:00',5.92),('7643','2014-01-29','10:10:00',7.14),('7643','2014-01-29','10:15:00',8.98),('7643','2014-01-29','10:20:00',7.73),('7643','2014-01-29','10:25:00',9.2),('7643','2014-01-29','10:30:00',9.63),('7643','2014-01-29','10:35:00',9.69),('7643','2014-01-29','10:40:00',9.57),('7643','2014-01-29','10:45:00',8.82),('7643','2014-01-29','10:50:00',10.8),('7643','2014-01-29','10:55:00',12.66),('7643','2014-01-29','11:00:00',12.2),('7643','2014-01-29','11:05:00',11.59),('7643','2014-01-29','11:10:00',11.29),('7643','2014-01-29','11:15:00',11.09),('7643','2014-01-29','11:20:00',7.65),('7643','2014-01-29','11:25:00',9.56),('7643','2014-01-29','11:30:00',9.2),('7643','2014-01-29','11:35:00',8.61),('7643','2014-01-29','11:40:00',5),('7643','2014-01-29','11:45:00',9.72),('7643','2014-01-29','11:50:00',7.54),('7643','2014-01-29','11:55:00',12.16),('7643','2014-01-29','12:00:00',6.41),('7643','2014-01-29','12:05:00',10.81),('7643','2014-01-29','12:10:00',8.64),('7643','2014-01-29','12:15:00',7.9),('7643','2014-01-29','12:20:00',11.78),('7643','2014-01-29','12:25:00',10.17),('7643','2014-01-29','12:30:00',9.04),('7643','2014-01-29','12:35:00',9.72),('7643','2014-01-29','12:40:00',7.68),('7643','2014-01-29','12:45:00',11.8),('7643','2014-01-29','12:50:00',11.27),('7643','2014-01-29','12:55:00',10.53),('7643','2014-01-29','13:00:00',7.53),('7643','2014-01-29','13:05:00',12.34),('7643','2014-01-29','13:10:00',8.89),('7643','2014-01-29','13:15:00',10.02),('7643','2014-01-29','13:20:00',8.2),('7643','2014-01-29','13:25:00',10.99),('7643','2014-01-29','13:30:00',9.19),('7643','2014-01-29','13:35:00',8.29),('7643','2014-01-29','13:40:00',9.63),('7643','2014-01-29','13:45:00',11.01),('7643','2014-01-29','13:50:00',10.07),('7643','2014-01-29','13:55:00',9.25),('7643','2014-01-29','14:00:00',8.81),('7643','2014-01-29','14:05:00',8.6),('7643','2014-01-29','14:10:00',8.44),('7643','2014-01-29','14:15:00',7.17),('7643','2014-01-29','14:20:00',6.44),('7643','2014-01-29','14:25:00',6.87),('7643','2014-01-29','14:30:00',7.36),('7643','2014-01-29','14:35:00',7.2),('7643','2014-01-29','14:40:00',8.08),('7643','2014-01-29','14:45:00',7.61),('7643','2014-01-29','14:50:00',7.93),('7643','2014-01-29','14:55:00',7.54),('7643','2014-01-29','15:00:00',7.3),('7643','2014-01-29','15:05:00',7.14),('7643','2014-01-29','15:10:00',6.78),('7643','2014-01-29','15:15:00',6.28),('7643','2014-01-29','15:20:00',6.42),('7643','2014-01-29','15:25:00',6.42),('7643','2014-01-29','15:30:00',5.8),('7643','2014-01-29','15:35:00',5.72),('7643','2014-01-29','15:40:00',5.21),('7643','2014-01-29','15:45:00',3.21),('7643','2014-01-29','15:50:00',2.49),('7643','2014-01-29','15:55:00',1.11),('7643','2014-01-28','08:25:00',1.02),('7643','2014-01-28','08:30:00',1.38),('7643','2014-01-28','08:35:00',1.55),('7643','2014-01-28','08:40:00',1.58),('7643','2014-01-28','08:45:00',1.32),('7643','2014-01-28','08:50:00',1.19),('7643','2014-01-28','08:55:00',1.39),('7643','2014-01-28','09:00:00',1.71),('7643','2014-01-28','09:05:00',2.07),('7643','2014-01-28','09:10:00',2.65),('7643','2014-01-28','09:15:00',3.6),('7643','2014-01-28','09:20:00',5.64),('7643','2014-01-28','09:25:00',3.73),('7643','2014-01-28','09:30:00',5.04),('7643','2014-01-28','09:35:00',7.99),('7643','2014-01-28','09:40:00',6.75),('7643','2014-01-28','09:45:00',7.38),('7643','2014-01-28','09:50:00',6.54),('7643','2014-01-28','09:55:00',6.68),('7643','2014-01-28','10:00:00',5.2),('7643','2014-01-28','10:05:00',5.05),('7643','2014-01-28','10:10:00',5.98),('7643','2014-01-28','10:15:00',6.9),('7643','2014-01-28','10:20:00',4.95),('7643','2014-01-28','10:25:00',10),('7643','2014-01-28','10:30:00',10.91),('7643','2014-01-28','10:35:00',8.73),('7643','2014-01-28','10:40:00',7.86),('7643','2014-01-28','10:45:00',7.75),('7643','2014-01-28','10:50:00',7.4),('7643','2014-01-28','10:55:00',6.75),('7643','2014-01-28','11:00:00',6.93),('7643','2014-01-28','11:05:00',7.93),('7643','2014-01-28','11:10:00',7.04),('7643','2014-01-28','11:15:00',7.06),('7643','2014-01-28','11:20:00',7.39),('7643','2014-01-28','11:25:00',7.16),('7643','2014-01-28','11:30:00',10.42),('7643','2014-01-28','11:35:00',10.12),('7643','2014-01-28','11:40:00',7.5),('7643','2014-01-28','11:45:00',4.61),('7643','2014-01-28','11:50:00',3.86),('7643','2014-01-28','11:55:00',1.82),('7643','2014-01-28','12:05:00',1.19),('7643','2014-01-28','12:40:00',1.11),('7643','2014-01-28','12:45:00',3.53),('7643','2014-01-28','12:50:00',9.99),('7643','2014-01-28','12:55:00',12.08),('7643','2014-01-28','13:00:00',9.02),('7643','2014-01-28','13:05:00',3.41),('7643','2014-01-28','13:10:00',1.81),('7643','2014-01-28','13:15:00',1.04),('7643','2014-01-28','13:20:00',1.22),('7643','2014-01-28','13:25:00',1.93),('7643','2014-01-28','13:30:00',3.23),('7643','2014-01-28','13:35:00',6.21),('7643','2014-01-28','13:40:00',8.21),('7643','2014-01-28','13:45:00',3.6),('7643','2014-01-28','13:50:00',7.84),('7643','2014-01-28','13:55:00',8.17),('7643','2014-01-28','14:00:00',3.66),('7643','2014-01-28','14:05:00',2.35),('7643','2014-01-28','14:10:00',2.01),('7643','2014-01-28','14:15:00',1.53),('7643','2014-01-28','14:20:00',1.91),('7643','2014-01-28','14:25:00',2.01),('7643','2014-01-28','14:30:00',3.15),('7643','2014-01-28','14:35:00',2.85),('7643','2014-01-28','14:40:00',3.49),('7643','2014-01-28','14:45:00',2.59),('7643','2014-01-28','14:50:00',1.42),('7643','2014-01-28','14:55:00',1.28),('7643','2014-01-28','15:00:00',1.7),('7643','2014-01-28','15:05:00',2.51),('7643','2014-01-28','15:10:00',4.56),('7643','2014-01-28','15:15:00',5.7),('7643','2014-01-28','15:20:00',3.95),('7643','2014-01-28','15:25:00',2.01),('7643','2014-01-28','15:30:00',1.37),('7643','2014-01-27','08:30:00',1.05),('7643','2014-01-27','08:35:00',1.33),('7643','2014-01-27','08:45:00',1.12),('7643','2014-01-27','08:50:00',1.49),('7643','2014-01-27','08:55:00',1.5),('7643','2014-01-27','09:00:00',2.36),('7643','2014-01-27','09:05:00',3.63),('7643','2014-01-27','09:10:00',4.76),('7643','2014-01-27','09:15:00',4.74),('7643','2014-01-27','09:20:00',5.16),('7643','2014-01-27','09:25:00',5.44),('7643','2014-01-27','09:30:00',5.3),('7643','2014-01-27','09:35:00',6.05),('7643','2014-01-27','09:40:00',5.37),('7643','2014-01-27','09:45:00',6.15),('7643','2014-01-27','09:50:00',7.38),('7643','2014-01-27','09:55:00',8.04),('7643','2014-01-27','10:00:00',8.59),('7643','2014-01-27','10:05:00',8.3),('7643','2014-01-27','10:10:00',8.23),('7643','2014-01-27','10:15:00',8.5),('7643','2014-01-27','10:20:00',9.03),('7643','2014-01-27','10:25:00',9.54),('7643','2014-01-27','10:30:00',9.46),('7643','2014-01-27','10:35:00',9.83),('7643','2014-01-27','10:40:00',10.09),('7643','2014-01-27','10:45:00',8.86),('7643','2014-01-27','10:50:00',9.63),('7643','2014-01-27','10:55:00',10.07),('7643','2014-01-27','11:00:00',7.92),('7643','2014-01-27','11:05:00',10.57),('7643','2014-01-27','11:10:00',5.71),('7643','2014-01-27','11:15:00',7.44),('7643','2014-01-27','11:20:00',3.33),('7643','2014-01-27','11:25:00',3.41),('7643','2014-01-27','11:30:00',9.62),('7643','2014-01-27','11:35:00',8.3),('7643','2014-01-27','11:40:00',12.15),('7643','2014-01-27','11:45:00',9.67),('7643','2014-01-27','11:50:00',4.77),('7643','2014-01-27','11:55:00',2.24),('7643','2014-01-27','12:00:00',5.97),('7643','2014-01-27','12:05:00',12.53),('7643','2014-01-27','12:10:00',9.87),('7643','2014-01-27','12:15:00',10.21),('7643','2014-01-27','12:20:00',5.62),('7643','2014-01-27','12:25:00',4.5),('7643','2014-01-27','12:30:00',4.3),('7643','2014-01-27','12:35:00',5.54),('7643','2014-01-27','12:40:00',6.88),('7643','2014-01-27','12:45:00',6.59),('7643','2014-01-27','12:50:00',11.74),('7643','2014-01-27','12:55:00',11.52),('7643','2014-01-27','13:00:00',11.54),('7643','2014-01-27','13:05:00',13.3),('7643','2014-01-27','13:10:00',8.89),('7643','2014-01-27','13:15:00',10.01),('7643','2014-01-27','13:20:00',10.15),('7643','2014-01-27','13:25:00',10.95),('7643','2014-01-27','13:30:00',10.99),('7643','2014-01-27','13:35:00',11.97),('7643','2014-01-27','13:40:00',11.49),('7643','2014-01-27','13:45:00',11.07),('7643','2014-01-27','13:50:00',10.71),('7643','2014-01-27','13:55:00',10.49),('7643','2014-01-27','14:00:00',10.31),('7643','2014-01-27','14:05:00',10.02),('7643','2014-01-27','14:10:00',9.84),('7643','2014-01-27','14:15:00',9.65),('7643','2014-01-27','14:20:00',9.41),('7643','2014-01-27','14:25:00',9.54),('7643','2014-01-27','14:30:00',9.55),('7643','2014-01-27','14:35:00',8.66),('7643','2014-01-27','14:40:00',8.08),('7643','2014-01-27','14:45:00',8.34),('7643','2014-01-27','14:50:00',7.91),('7643','2014-01-27','14:55:00',7.66),('7643','2014-01-27','15:00:00',7.38),('7643','2014-01-27','15:05:00',7.11),('7643','2014-01-27','15:10:00',6.77),('7643','2014-01-27','15:15:00',6.46),('7643','2014-01-27','15:20:00',6.18),('7643','2014-01-27','15:25:00',5.83),('7643','2014-01-27','15:30:00',5.51),('7643','2014-01-27','15:35:00',5.15),('7643','2014-01-27','15:40:00',4.81),('7643','2014-01-27','15:45:00',4.5),('7643','2014-01-27','15:50:00',4.19),('7643','2014-01-27','15:55:00',3.85),('7643','2014-01-27','16:00:00',3.53),('7643','2014-01-27','16:05:00',3.2),('7643','2014-01-27','16:10:00',2.78),('7643','2014-01-27','16:15:00',2.53),('7643','2014-01-27','16:20:00',2.22),('7643','2014-01-27','16:25:00',1.91),('7643','2014-01-27','16:30:00',1.19),('7643','2014-01-26','08:10:00',1.09),('7643','2014-01-26','08:15:00',1.17),('7643','2014-01-26','08:20:00',1.33),('7643','2014-01-26','08:25:00',1.51),('7643','2014-01-26','08:30:00',1.82),('7643','2014-01-26','08:35:00',1.78),('7643','2014-01-26','08:40:00',1.68),('7643','2014-01-26','08:45:00',1.64),('7643','2014-01-26','08:50:00',1.57),('7643','2014-01-26','08:55:00',1.66),('7643','2014-01-26','09:00:00',1.73),('7643','2014-01-26','09:05:00',1.48),('7643','2014-01-26','09:10:00',1.33),('7643','2014-01-26','09:25:00',1.4),('7643','2014-01-26','09:30:00',1.45),('7643','2014-01-26','09:35:00',1.61),('7643','2014-01-26','09:40:00',2.33),('7643','2014-01-26','09:45:00',2.49),('7643','2014-01-26','09:50:00',2.71),('7643','2014-01-26','09:55:00',2.8),('7643','2014-01-26','10:00:00',2.85),('7643','2014-01-26','10:05:00',2.93),('7643','2014-01-26','10:10:00',2.77),('7643','2014-01-26','10:15:00',2.85),('7643','2014-01-26','10:20:00',2.8),('7643','2014-01-26','10:25:00',3.34),('7643','2014-01-26','10:30:00',3.33),('7643','2014-01-26','10:35:00',3.31),('7643','2014-01-26','10:40:00',2.98),('7643','2014-01-26','10:45:00',3.31),('7643','2014-01-26','10:50:00',3.29),('7643','2014-01-26','10:55:00',3.01),('7643','2014-01-26','11:00:00',3.29),('7643','2014-01-26','11:05:00',3.63),('7643','2014-01-26','11:10:00',3.13),('7643','2014-01-26','11:15:00',3.03),('7643','2014-01-26','11:20:00',3.79),('7643','2014-01-26','11:25:00',3.81),('7643','2014-01-26','11:30:00',3.25),('7643','2014-01-26','11:35:00',2.69),('7643','2014-01-26','11:40:00',2.89),('7643','2014-01-26','11:45:00',2.08),('7643','2014-01-26','11:50:00',2.08),('7643','2014-01-26','11:55:00',1.98),('7643','2014-01-26','12:00:00',2.29),('7643','2014-01-26','12:05:00',2.69),('7643','2014-01-26','12:10:00',2.49),('7643','2014-01-26','12:15:00',2.08),('7643','2014-01-26','12:20:00',1.77),('7643','2014-01-26','12:25:00',1.59),('7643','2014-01-26','12:30:00',1.79),('7643','2014-01-26','12:35:00',1.87),('7643','2014-01-26','12:40:00',1.71),('7643','2014-01-26','12:45:00',2.27),('7643','2014-01-26','12:50:00',3.06),('7643','2014-01-26','12:55:00',2.97),('7643','2014-01-26','13:00:00',2.67),('7643','2014-01-26','13:05:00',2.72),('7643','2014-01-26','13:10:00',2.79),('7643','2014-01-26','13:15:00',2.38),('7643','2014-01-26','13:20:00',2.26),('7643','2014-01-26','13:25:00',2.41),('7643','2014-01-26','13:30:00',2.82),('7643','2014-01-26','13:35:00',2.35),('7643','2014-01-26','13:40:00',1.62),('7643','2014-01-26','13:45:00',1.06),('7643','2014-01-26','14:40:00',1.08),('7643','2014-01-26','14:45:00',1.07),('7643','2014-01-26','15:00:00',1.05),('7643','2014-01-26','15:05:00',1.06),('8348','2014-05-05','06:45:00',1.2),('8348','2014-05-05','06:50:00',1.41),('8348','2014-05-05','06:55:00',1.52),('8348','2014-05-05','07:00:00',1.62),('8348','2014-05-05','07:05:00',1.74),('8348','2014-05-05','07:10:00',1.87),('8348','2014-05-05','07:15:00',1.97),('8348','2014-05-05','07:20:00',2.08),('8348','2014-05-05','07:25:00',2.24),('8348','2014-05-05','07:30:00',2.4),('8348','2014-05-05','07:35:00',2.71),('8348','2014-05-05','07:40:00',3.08),('8348','2014-05-05','07:45:00',3.26),('8348','2014-05-05','07:50:00',3.44),('8348','2014-05-05','07:55:00',3.62),('8348','2014-05-05','08:00:00',3.77),('8348','2014-05-05','08:05:00',3.87),('8348','2014-05-05','08:10:00',4.06),('8348','2014-05-05','08:15:00',4.19),('8348','2014-05-05','08:20:00',4.35),('8348','2014-05-05','08:25:00',4.49),('8348','2014-05-05','08:30:00',4.69),('8348','2014-05-05','08:35:00',4.81),('8348','2014-05-05','08:40:00',4.91),('8348','2014-05-05','08:45:00',5.06),('8348','2014-05-05','08:50:00',5.17),('8348','2014-05-05','08:55:00',5.3),('8348','2014-05-05','09:00:00',5.43),('8348','2014-05-05','09:05:00',5.57),('8348','2014-05-05','09:10:00',5.68),('8348','2014-05-05','09:15:00',5.76),('8348','2014-05-05','09:20:00',5.81),('8348','2014-05-05','09:25:00',5.93),('8348','2014-05-05','09:30:00',6.02),('8348','2014-05-05','09:35:00',6.16),('8348','2014-05-05','09:40:00',6.22),('8348','2014-05-05','09:45:00',6.29),('8348','2014-05-05','09:50:00',6.4),('8348','2014-05-05','09:55:00',6.42),('8348','2014-05-05','10:00:00',6.56),('8348','2014-05-05','10:05:00',6.58),('8348','2014-05-05','10:10:00',6.68),('8348','2014-05-05','10:15:00',6.84),('8348','2014-05-05','10:20:00',6.85),('8348','2014-05-05','10:25:00',6.68),('8348','2014-05-05','10:30:00',6.94),('8348','2014-05-05','10:35:00',6.94),('8348','2014-05-05','10:40:00',7),('8348','2014-05-05','10:45:00',7.15),('8348','2014-05-05','10:50:00',7.17),('8348','2014-05-05','10:55:00',6.52),('8348','2014-05-05','11:00:00',7.48),('8348','2014-05-05','11:05:00',6.07),('8348','2014-05-05','11:10:00',2.84),('8348','2014-05-05','11:15:00',4.66),('8348','2014-05-05','11:20:00',3.78),('8348','2014-05-05','11:25:00',5.71),('8348','2014-05-05','11:30:00',7.78),('8348','2014-05-05','11:35:00',3.95),('8348','2014-05-05','11:40:00',2.6),('8348','2014-05-05','11:45:00',5.48),('8348','2014-05-05','11:50:00',8.33),('8348','2014-05-05','11:55:00',3.27),('8348','2014-05-05','12:00:00',4.97),('8348','2014-05-05','12:05:00',6.02),('8348','2014-05-05','12:10:00',8.07),('8348','2014-05-05','12:15:00',7.9),('8348','2014-05-05','12:20:00',7.78),('8348','2014-05-05','12:25:00',7.6),('8348','2014-05-05','12:30:00',7.59),('8348','2014-05-05','12:35:00',7.63),('8348','2014-05-05','12:40:00',7.67),('8348','2014-05-05','12:45:00',7.66),('8348','2014-05-05','12:50:00',7.65),('8348','2014-05-05','12:55:00',7.65),('8348','2014-05-05','13:00:00',7.6),('8348','2014-05-05','13:05:00',7.79),('8348','2014-05-05','13:10:00',8.09),('8348','2014-05-05','13:15:00',8.32),('8348','2014-05-05','13:20:00',8.54),('8348','2014-05-05','13:25:00',7.47),('8348','2014-05-05','13:30:00',4.87),('8348','2014-05-05','13:35:00',4.12),('8348','2014-05-05','13:40:00',2.92),('8348','2014-05-05','13:45:00',2.51),('8348','2014-05-05','13:50:00',2.61),('8348','2014-05-05','13:55:00',2.93),('8348','2014-05-05','14:00:00',4.14),('8348','2014-05-05','14:05:00',4.16),('8348','2014-05-05','14:10:00',2.82),('8348','2014-05-05','14:15:00',2.57),('8348','2014-05-05','14:20:00',2.46),('8348','2014-05-05','14:25:00',4.15),('8348','2014-05-05','14:30:00',7.69),('8348','2014-05-05','14:35:00',3.4),('8348','2014-05-05','14:40:00',2.65),('8348','2014-05-05','14:45:00',5.73),('8348','2014-05-05','14:50:00',2.26),('8348','2014-05-05','14:55:00',3.36),('8348','2014-05-05','15:00:00',3.6),('8348','2014-05-05','15:05:00',5.33),('8348','2014-05-05','15:10:00',2.5),('8348','2014-05-05','15:15:00',2.47),('8348','2014-05-05','15:20:00',2.52),('8348','2014-05-05','15:25:00',2.01),('8348','2014-05-05','15:30:00',3.73),('8348','2014-05-05','15:35:00',4.38),('8348','2014-05-05','15:40:00',2.55),('8348','2014-05-05','15:45:00',5.69),('8348','2014-05-05','15:50:00',5.78),('8348','2014-05-05','15:55:00',5.48),('8348','2014-05-05','16:00:00',5.08),('8348','2014-05-05','16:05:00',4.8),('8348','2014-05-05','16:10:00',4.89),('8348','2014-05-05','16:15:00',4.74),('8348','2014-05-05','16:20:00',4.63),('8348','2014-05-05','16:25:00',4.36),('8348','2014-05-05','16:30:00',4.13),('8348','2014-05-05','16:35:00',3.99),('8348','2014-05-05','16:40:00',3.84),('8348','2014-05-05','16:45:00',3.65),('8348','2014-05-05','16:50:00',3.49),('8348','2014-05-05','16:55:00',3.36),('8348','2014-05-05','17:00:00',3.15),('8348','2014-05-05','17:05:00',3),('8348','2014-05-05','17:10:00',2.87),('8348','2014-05-05','17:15:00',2.67),('8348','2014-05-05','17:20:00',2.5),('8348','2014-05-05','17:25:00',2.34),('8348','2014-05-05','17:30:00',2.18),('8348','2014-05-05','17:35:00',2.04),('8348','2014-05-05','17:40:00',1.88),('8348','2014-05-05','17:45:00',1.72),('8348','2014-05-05','17:50:00',1.56),('8348','2014-05-05','17:55:00',1.39),('8348','2014-05-05','18:00:00',1.23),('8348','2014-05-05','18:05:00',1.08),('8348','2014-04-26','07:00:00',1.02),('8348','2014-04-26','07:05:00',1.09),('8348','2014-04-26','07:10:00',1.18),('8348','2014-04-26','07:15:00',1.22),('8348','2014-04-26','07:20:00',1.27),('8348','2014-04-26','07:25:00',1.31),('8348','2014-04-26','07:30:00',1.17),('8348','2014-04-26','07:35:00',1.26),('8348','2014-04-26','07:40:00',1.4),('8348','2014-04-26','07:45:00',1.52),('8348','2014-04-26','07:50:00',1.63),('8348','2014-04-26','07:55:00',1.58),('8348','2014-04-26','08:00:00',1.63),('8348','2014-04-26','08:05:00',1.83),('8348','2014-04-26','08:10:00',1.58),('8348','2014-04-26','08:15:00',1.38),('8348','2014-04-26','08:20:00',1.41),('8348','2014-04-26','08:25:00',1.42),('8348','2014-04-26','08:30:00',1.42),('8348','2014-04-26','08:35:00',1.57),('8348','2014-04-26','08:40:00',1.64),('8348','2014-04-26','08:45:00',1.44),('8348','2014-04-26','08:50:00',1.73),('8348','2014-04-26','08:55:00',2.49),('8348','2014-04-26','09:00:00',2.58),('8348','2014-04-26','09:05:00',2.35),('8348','2014-04-26','09:10:00',2.3),('8348','2014-04-26','09:15:00',2.33),('8348','2014-04-26','09:20:00',2.72),('8348','2014-04-26','09:25:00',2.8),('8348','2014-04-26','09:30:00',3.56),('8348','2014-04-26','09:35:00',3.7),('8348','2014-04-26','09:40:00',3.15),('8348','2014-04-26','09:45:00',3.4),('8348','2014-04-26','09:50:00',4.1),('8348','2014-04-26','09:55:00',5.74),('8348','2014-04-26','10:00:00',6.15),('8348','2014-04-26','10:05:00',5.77),('8348','2014-04-26','10:10:00',5.58),('8348','2014-04-26','10:15:00',5.49),('8348','2014-04-26','10:20:00',4.57),('8348','2014-04-26','10:25:00',5.17),('8348','2014-04-26','10:30:00',5.16),('8348','2014-04-26','10:35:00',5.13),('8348','2014-04-26','10:40:00',4.87),('8348','2014-04-26','10:45:00',5.34),('8348','2014-04-26','10:50:00',5.42),('8348','2014-04-26','10:55:00',4.95),('8348','2014-04-26','11:00:00',5.24),('8348','2014-04-26','11:05:00',5.21),('8348','2014-04-26','11:10:00',5.53),('8348','2014-04-26','11:15:00',5.08),('8348','2014-04-26','11:20:00',4.69),('8348','2014-04-26','11:25:00',3.69),('8348','2014-04-26','11:30:00',4.13),('8348','2014-04-26','11:35:00',5.81),('8348','2014-04-26','11:40:00',6.18),('8348','2014-04-26','11:45:00',5.45),('8348','2014-04-26','11:50:00',7.16),('8348','2014-04-26','11:55:00',7.4),('8348','2014-04-26','12:00:00',6.94),('8348','2014-04-26','12:05:00',5.01),('8348','2014-04-26','12:10:00',5.94),('8348','2014-04-26','12:15:00',7.65),('8348','2014-04-26','12:20:00',7.95),('8348','2014-04-26','12:25:00',4.81),('8348','2014-04-26','12:30:00',3.03),('8348','2014-04-26','12:35:00',3.92),('8348','2014-04-26','12:40:00',8.01),('8348','2014-04-26','12:45:00',7.44),('8348','2014-04-26','12:50:00',7.49),('8348','2014-04-26','12:55:00',7.83),('8348','2014-04-26','13:00:00',4.81),('8348','2014-04-26','13:05:00',1.41),('8348','2014-04-26','13:10:00',4.82),('8348','2014-04-26','13:15:00',2.03),('8348','2014-04-26','13:20:00',1.14),('8348','2014-04-26','13:25:00',1.75),('8348','2014-04-26','13:30:00',1.78),('8348','2014-04-26','13:35:00',2.82),('8348','2014-04-26','13:40:00',3.73),('8348','2014-04-26','13:45:00',1.42),('8348','2014-04-26','16:40:00',1.2),('8348','2014-04-26','16:45:00',1.54),('8348','2014-04-26','16:50:00',1.61),('8348','2014-04-26','16:55:00',1.47),('8348','2014-04-26','17:30:00',1.09),('8348','2014-04-26','17:35:00',1.34),('8348','2014-04-26','17:40:00',1.76),('8348','2014-04-26','17:45:00',1.99),('8348','2014-04-26','17:50:00',1.47),('8348','2014-04-25','06:45:00',1.04),('8348','2014-04-25','06:50:00',1.25),('8348','2014-04-25','06:55:00',1.58),('8348','2014-04-25','07:00:00',1.72),('8348','2014-04-25','07:05:00',1.69),('8348','2014-04-25','07:10:00',1.75),('8348','2014-04-25','07:15:00',1.7),('8348','2014-04-25','07:20:00',1.83),('8348','2014-04-25','07:25:00',1.94),('8348','2014-04-25','07:30:00',2.03),('8348','2014-04-25','07:35:00',2.15),('8348','2014-04-25','07:40:00',2.27),('8348','2014-04-25','07:45:00',2.44),('8348','2014-04-25','07:50:00',2.79),('8348','2014-04-25','07:55:00',3.12),('8348','2014-04-25','08:00:00',3.5),('8348','2014-04-25','08:05:00',2.83),('8348','2014-04-25','08:10:00',2.73),('8348','2014-04-25','08:15:00',2.25),('8348','2014-04-25','08:20:00',1.61),('8348','2014-04-25','08:25:00',2.05),('8348','2014-04-25','08:30:00',2.06),('8348','2014-04-25','08:35:00',2.09),('8348','2014-04-25','08:40:00',1.64),('8348','2014-04-25','08:45:00',1.66),('8348','2014-04-25','08:50:00',1.64),('8348','2014-04-25','08:55:00',1.78),('8348','2014-04-25','09:00:00',2.15),('8348','2014-04-25','09:05:00',2.08),('8348','2014-04-25','09:10:00',2.12),('8348','2014-04-25','09:15:00',2.16),('8348','2014-04-25','09:20:00',2.33),('8348','2014-04-25','09:25:00',2.51),('8348','2014-04-25','09:30:00',3.58),('8348','2014-04-25','09:35:00',5.16),('8348','2014-04-25','09:40:00',4.93),('8348','2014-04-25','09:45:00',5.62),('8348','2014-04-25','09:50:00',4.58),('8348','2014-04-25','09:55:00',4.13),('8348','2014-04-25','10:00:00',4.73),('8348','2014-04-25','10:05:00',2.53),('8348','2014-04-25','10:10:00',2.23),('8348','2014-04-25','10:15:00',5.66),('8348','2014-04-25','10:20:00',6.67),('8348','2014-04-25','10:25:00',6.66),('8348','2014-04-25','10:30:00',4.79),('8348','2014-04-25','10:35:00',4.79),('8348','2014-04-25','10:40:00',6.46),('8348','2014-04-25','10:45:00',3.82),('8348','2014-04-25','10:50:00',2.67),('8348','2014-04-25','10:55:00',3.37),('8348','2014-04-25','11:00:00',3.72),('8348','2014-04-25','11:05:00',5.4),('8348','2014-04-25','11:10:00',5.61),('8348','2014-04-25','11:15:00',6.27),('8348','2014-04-25','11:20:00',4.33),('8348','2014-04-25','11:25:00',2.28),('8348','2014-04-25','11:30:00',6.2),('8348','2014-04-25','11:35:00',7.78),('8348','2014-04-25','11:40:00',6.53),('8348','2014-04-25','11:45:00',7.87),('8348','2014-04-25','11:50:00',2.49),('8348','2014-04-25','11:55:00',2.54),('8348','2014-04-25','12:00:00',5.93),('8348','2014-04-25','12:05:00',2.47),('8348','2014-04-25','12:10:00',5.68),('8348','2014-04-25','12:15:00',2.12),('8348','2014-04-25','12:20:00',2),('8348','2014-04-25','12:25:00',2.34),('8348','2014-04-25','12:30:00',2.63),('8348','2014-04-25','12:35:00',1.98),('8348','2014-04-25','12:40:00',4.97),('8348','2014-04-25','12:45:00',2.44),('8348','2014-04-25','12:50:00',2.31),('8348','2014-04-25','12:55:00',4.3),('8348','2014-04-25','13:00:00',2.54),('8348','2014-04-25','13:05:00',2.7),('8348','2014-04-25','13:10:00',2.27),('8348','2014-04-25','13:15:00',3.3),('8348','2014-04-25','13:20:00',5.9),('8348','2014-04-25','13:25:00',4.6),('8348','2014-04-25','13:30:00',6.82),('8348','2014-04-25','13:35:00',5.89),('8348','2014-04-25','13:40:00',7.12),('8348','2014-04-25','13:45:00',7.03),('8348','2014-04-25','13:50:00',7),('8348','2014-04-25','13:55:00',6.87),('8348','2014-04-25','14:00:00',6.82),('8348','2014-04-25','14:05:00',6.73),('8348','2014-04-25','14:10:00',6.66),('8348','2014-04-25','14:15:00',6.67),('8348','2014-04-25','14:20:00',6.38),('8348','2014-04-25','14:25:00',6.39),('8348','2014-04-25','14:30:00',6.17),('8348','2014-04-25','14:35:00',6.26),('8348','2014-04-25','14:40:00',6.27),('8348','2014-04-25','14:45:00',6.06),('8348','2014-04-25','14:50:00',5.97),('8348','2014-04-25','14:55:00',5.9),('8348','2014-04-25','15:00:00',5.85),('8348','2014-04-25','15:05:00',5.63),('8348','2014-04-25','15:10:00',5.53),('8348','2014-04-25','15:15:00',5.27),('8348','2014-04-25','15:20:00',4.85),('8348','2014-04-25','15:25:00',5.01),('8348','2014-04-25','15:30:00',5.19),('8348','2014-04-25','15:35:00',5.15),('8348','2014-04-25','15:40:00',5.2),('8348','2014-04-25','15:45:00',5.02),('8348','2014-04-25','15:50:00',4.65),('8348','2014-04-25','15:55:00',3.98),('8348','2014-04-25','16:00:00',3.78),('8348','2014-04-25','16:05:00',4.2),('8348','2014-04-25','16:10:00',3.71),('8348','2014-04-25','16:15:00',3.7),('8348','2014-04-25','16:20:00',2.73),('8348','2014-04-25','16:25:00',2.02),('8348','2014-04-25','16:30:00',1.97),('8348','2014-04-25','16:35:00',2.06),('8348','2014-04-25','16:40:00',2.06),('8348','2014-04-25','16:45:00',1.74),('8348','2014-04-25','16:50:00',1.56),('8348','2014-04-25','16:55:00',1.46),('8348','2014-04-25','17:00:00',1.39),('8348','2014-04-25','17:05:00',1.4),('8348','2014-04-25','17:10:00',1.42),('8348','2014-04-25','17:15:00',1.18),('8348','2014-04-25','17:20:00',1.17),('8348','2014-04-25','17:25:00',1.2),('8348','2014-04-25','17:30:00',1.13),('8348','2014-04-25','17:35:00',1.08),('8348','2014-04-25','17:40:00',1),('8348','2014-04-25','18:10:00',1.05),('8348','2014-04-24','06:45:00',1.01),('8348','2014-04-24','06:50:00',1.1),('8348','2014-04-24','06:55:00',1.19),('8348','2014-04-24','07:00:00',1.45),('8348','2014-04-24','07:05:00',1.5),('8348','2014-04-24','07:10:00',1.58),('8348','2014-04-24','07:15:00',1.67),('8348','2014-04-24','07:20:00',1.77),('8348','2014-04-24','07:25:00',1.88),('8348','2014-04-24','07:30:00',1.96),('8348','2014-04-24','07:35:00',2.1),('8348','2014-04-24','07:40:00',2.25),('8348','2014-04-24','07:45:00',2.39),('8348','2014-04-24','07:50:00',2.73),('8348','2014-04-24','07:55:00',3),('8348','2014-04-24','08:00:00',3.15),('8348','2014-04-24','08:05:00',3.26),('8348','2014-04-24','08:10:00',3.45),('8348','2014-04-24','08:15:00',3.6),('8348','2014-04-24','08:20:00',3.72),('8348','2014-04-24','08:25:00',3.87),('8348','2014-04-24','08:30:00',3.99),('8348','2014-04-24','08:35:00',4.1),('8348','2014-04-24','08:40:00',4.26),('8348','2014-04-24','08:45:00',4.37),('8348','2014-04-24','08:50:00',4.49),('8348','2014-04-24','08:55:00',4.58),('8348','2014-04-24','09:00:00',4.7),('8348','2014-04-24','09:05:00',4.84),('8348','2014-04-24','09:10:00',4.96),('8348','2014-04-24','09:15:00',5.04),('8348','2014-04-24','09:20:00',5.08),('8348','2014-04-24','09:25:00',5.17),('8348','2014-04-24','09:30:00',5.29),('8348','2014-04-24','09:35:00',5.36),('8348','2014-04-24','09:40:00',5.46),('8348','2014-04-24','09:45:00',5.55),('8348','2014-04-24','09:50:00',5.63),('8348','2014-04-24','09:55:00',5.8),('8348','2014-04-24','10:00:00',5.87),('8348','2014-04-24','10:05:00',5.86),('8348','2014-04-24','10:10:00',5.97),('8348','2014-04-24','10:15:00',6.03),('8348','2014-04-24','10:20:00',6.09),('8348','2014-04-24','10:25:00',6.18),('8348','2014-04-24','10:30:00',6.25),('8348','2014-04-24','10:35:00',6.25),('8348','2014-04-24','10:40:00',5.73),('8348','2014-04-24','10:45:00',5.73),('8348','2014-04-24','10:50:00',6.49),('8348','2014-04-24','10:55:00',6.47),('8348','2014-04-24','11:00:00',6.54),('8348','2014-04-24','11:05:00',6.67),('8348','2014-04-24','11:10:00',6.76),('8348','2014-04-24','11:15:00',6.8),('8348','2014-04-24','11:20:00',6.78),('8348','2014-04-24','11:25:00',6.82),('8348','2014-04-24','11:30:00',6.9),('8348','2014-04-24','11:35:00',7.04),('8348','2014-04-24','11:40:00',6.57),('8348','2014-04-24','11:45:00',6.84),('8348','2014-04-24','11:50:00',7.03),('8348','2014-04-24','11:55:00',6.98),('8348','2014-04-24','12:00:00',7.11),('8348','2014-04-24','12:05:00',7.1),('8348','2014-04-24','12:10:00',7.2),('8348','2014-04-24','12:15:00',7.4),('8348','2014-04-24','12:20:00',7.32),('8348','2014-04-24','12:25:00',7.24),('8348','2014-04-24','12:30:00',7.36),('8348','2014-04-24','12:35:00',3.66),('8348','2014-04-24','12:40:00',3.16),('8348','2014-04-24','12:45:00',4.55),('8348','2014-04-24','12:50:00',8.36),('8348','2014-04-24','12:55:00',7.44),('8348','2014-04-24','13:00:00',3.77),('8348','2014-04-24','13:05:00',7.53),('8348','2014-04-24','13:10:00',8.23),('8348','2014-04-24','13:15:00',5.45),('8348','2014-04-24','13:20:00',6.57),('8348','2014-04-24','13:25:00',6.7),('8348','2014-04-24','13:30:00',7.16),('8348','2014-04-24','13:35:00',7.55),('8348','2014-04-24','13:40:00',5.85),('8348','2014-04-24','13:45:00',4.46),('8348','2014-04-24','13:50:00',3.55),('8348','2014-04-24','13:55:00',8.13),('8348','2014-04-24','14:00:00',8.2),('8348','2014-04-24','14:05:00',8.08),('8348','2014-04-24','14:10:00',8.09),('8348','2014-04-24','14:15:00',7.76),('8348','2014-04-24','14:20:00',4.58),('8348','2014-04-24','14:25:00',3.97),('8348','2014-04-24','14:30:00',4.97),('8348','2014-04-24','14:35:00',4.64),('8348','2014-04-24','14:40:00',4.09),('8348','2014-04-24','14:45:00',3.86),('8348','2014-04-24','14:50:00',4.24),('8348','2014-04-24','14:55:00',4.81),('8348','2014-04-24','15:00:00',7.41),('8348','2014-04-24','15:05:00',6.74),('8348','2014-04-24','15:10:00',5.49),('8348','2014-04-24','15:15:00',6.17),('8348','2014-04-24','15:20:00',5.65),('8348','2014-04-24','15:25:00',5.99),('8348','2014-04-24','15:30:00',5.29),('8348','2014-04-24','15:35:00',3.4),('8348','2014-04-24','15:40:00',3.8),('8348','2014-04-24','15:45:00',3.29),('8348','2014-04-24','15:50:00',2.79),('8348','2014-04-24','15:55:00',2.69),('8348','2014-04-24','16:00:00',2.6),('8348','2014-04-24','16:05:00',2.36),('8348','2014-04-24','16:10:00',2.24),('8348','2014-04-24','16:15:00',2),('8348','2014-04-24','16:20:00',1.98),('8348','2014-04-24','16:25:00',1.95),('8348','2014-04-24','16:30:00',1.89),('8348','2014-04-24','16:35:00',1.76),('8348','2014-04-24','16:40:00',1.5),('8348','2014-04-24','16:45:00',1.02),('8348','2014-04-23','09:40:00',1.06),('8348','2014-04-23','09:45:00',1.08),('8348','2014-04-23','10:15:00',1.05),('8348','2014-04-23','10:20:00',1.01),('8348','2014-04-23','10:35:00',1.07),('8348','2014-04-23','10:40:00',1.14),('8348','2014-04-23','10:45:00',1.23),('8348','2014-04-23','10:50:00',1.01),('8348','2014-04-23','11:50:00',1.01),('8348','2014-04-23','11:55:00',1.09),('8348','2014-04-23','12:00:00',1.2),('8348','2014-04-23','12:05:00',1.41),('8348','2014-04-23','12:10:00',1.74),('8348','2014-04-23','12:15:00',2.01),('8348','2014-04-23','12:20:00',2.15),('8348','2014-04-23','12:25:00',2.28),('8348','2014-04-23','12:30:00',2.47),('8348','2014-04-23','12:35:00',2.58),('8348','2014-04-23','12:40:00',2.76),('8348','2014-04-23','12:45:00',2.86),('8348','2014-04-23','12:50:00',2.86),('8348','2014-04-23','12:55:00',2.86),('8348','2014-04-23','13:00:00',2.69),('8348','2014-04-23','13:05:00',2.7),('8348','2014-04-23','13:10:00',2.6),('8348','2014-04-23','13:15:00',2.23),('8348','2014-04-23','13:20:00',1.93),('8348','2014-04-23','13:25:00',1.75),('8348','2014-04-23','13:30:00',1.65),('8348','2014-04-23','13:35:00',1.57),('8348','2014-04-23','13:40:00',1.62),('8348','2014-04-23','13:45:00',1.87),('8348','2014-04-23','13:50:00',2.27),('8348','2014-04-23','13:55:00',2.63),('8348','2014-04-23','14:00:00',2.96),('8348','2014-04-23','14:05:00',3.06),('8348','2014-04-23','14:10:00',3.01),('8348','2014-04-23','14:15:00',3.02),('8348','2014-04-23','14:20:00',2.58),('8348','2014-04-23','14:25:00',2.42),('8348','2014-04-23','14:30:00',2.38),('8348','2014-04-23','14:35:00',2.26),('8348','2014-04-23','14:40:00',2.23),('8348','2014-04-23','14:45:00',2.6),('8348','2014-04-23','14:50:00',1.88),('8348','2014-04-23','14:55:00',1.74),('8348','2014-04-23','15:00:00',1.48),('8348','2014-04-23','15:05:00',1.41),('8348','2014-04-23','15:10:00',1.24),('8348','2014-04-23','15:15:00',1.08),('8348','2014-04-22','06:45:00',1.06),('8348','2014-04-22','06:50:00',1.16),('8348','2014-04-22','06:55:00',1.25),('8348','2014-04-22','07:00:00',1.34),('8348','2014-04-22','07:05:00',1.51),('8348','2014-04-22','07:10:00',1.65),('8348','2014-04-22','07:15:00',1.75),('8348','2014-04-22','07:20:00',1.85),('8348','2014-04-22','07:25:00',1.96),('8348','2014-04-22','07:30:00',2.1),('8348','2014-04-22','07:35:00',2.2),('8348','2014-04-22','07:40:00',2.37),('8348','2014-04-22','07:45:00',2.52),('8348','2014-04-22','07:50:00',2.72),('8348','2014-04-22','07:55:00',2.98),('8348','2014-04-22','08:00:00',3.1),('8348','2014-04-22','08:05:00',3.39),('8348','2014-04-22','08:10:00',3.09),('8348','2014-04-22','08:15:00',2.94),('8348','2014-04-22','08:20:00',3.69),('8348','2014-04-22','08:25:00',4.09),('8348','2014-04-22','08:30:00',3.1),('8348','2014-04-22','08:35:00',4.18),('8348','2014-04-22','08:40:00',4.33),('8348','2014-04-22','08:45:00',4.76),('8348','2014-04-22','08:50:00',3.91),('8348','2014-04-22','08:55:00',2.48),('8348','2014-04-22','09:00:00',2.35),('8348','2014-04-22','09:05:00',2.53),('8348','2014-04-22','09:10:00',3.32),('8348','2014-04-22','09:15:00',3.35),('8348','2014-04-22','09:20:00',5.01),('8348','2014-04-22','09:25:00',3.77),('8348','2014-04-22','09:30:00',5.68),('8348','2014-04-22','09:35:00',5.94),('8348','2014-04-22','09:40:00',5.53),('8348','2014-04-22','09:45:00',6.17),('8348','2014-04-22','09:50:00',6.56),('8348','2014-04-22','09:55:00',5),('8348','2014-04-22','10:00:00',3.44),('8348','2014-04-22','10:05:00',3.87),('8348','2014-04-22','10:10:00',2.94),('8348','2014-04-22','10:15:00',2.51),('8348','2014-04-22','10:20:00',2.19),('8348','2014-04-22','10:25:00',2.14),('8348','2014-04-22','10:30:00',1.92),('8348','2014-04-22','10:35:00',2.02),('8348','2014-04-22','10:40:00',1.87),('8348','2014-04-22','10:45:00',1.6),('8348','2014-04-22','10:50:00',1.66),('8348','2014-04-22','10:55:00',1.59),('8348','2014-04-22','11:00:00',1.75),('8348','2014-04-22','11:05:00',2.14),('8348','2014-04-22','11:10:00',2.16),('8348','2014-04-22','11:15:00',2.17),('8348','2014-04-22','11:20:00',2.26),('8348','2014-04-22','11:25:00',2.41),('8348','2014-04-22','11:30:00',2.79),('8348','2014-04-22','11:35:00',2.41),('8348','2014-04-22','11:40:00',1.83),('8348','2014-04-22','11:45:00',1.54),('8348','2014-04-22','11:50:00',1.33),('8348','2014-04-22','11:55:00',1.28),('8348','2014-04-22','12:00:00',1.29),('8348','2014-04-22','12:05:00',1.42),('8348','2014-04-22','12:10:00',1.68),('8348','2014-04-22','12:15:00',2.54),('8348','2014-04-22','12:20:00',3.91),('8348','2014-04-22','12:25:00',4.48),('8348','2014-04-22','12:30:00',4.95),('8348','2014-04-22','12:35:00',4.62),('8348','2014-04-22','12:40:00',5.62),('8348','2014-04-22','12:45:00',5.71),('8348','2014-04-22','12:50:00',4.79),('8348','2014-04-22','12:55:00',2.76),('8348','2014-04-22','13:00:00',2.43),('8348','2014-04-22','13:05:00',3.09),('8348','2014-04-22','13:10:00',6.36),('8348','2014-04-22','13:15:00',5.83),('8348','2014-04-22','13:20:00',6.73),('8348','2014-04-22','13:25:00',4.73),('8348','2014-04-22','13:30:00',3.58),('8348','2014-04-22','13:35:00',4.19),('8348','2014-04-22','13:40:00',5.88),('8348','2014-04-22','13:45:00',7.07),('8348','2014-04-22','13:50:00',6.22),('8348','2014-04-22','13:55:00',5.07),('8348','2014-04-22','14:00:00',2.39),('8348','2014-04-22','14:05:00',2.27),('8348','2014-04-22','14:10:00',2.13),('8348','2014-04-22','14:15:00',2.11),('8348','2014-04-22','14:20:00',2.35),('8348','2014-04-22','14:25:00',2.56),('8348','2014-04-22','14:30:00',3.17),('8348','2014-04-22','14:35:00',4.46),('8348','2014-04-22','14:40:00',3.93),('8348','2014-04-22','14:45:00',3.49),('8348','2014-04-22','14:50:00',4.02),('8348','2014-04-22','14:55:00',3.3),('8348','2014-04-22','15:00:00',3.96),('8348','2014-04-22','15:05:00',2.72),('8348','2014-04-22','15:10:00',2.61),('8348','2014-04-22','15:15:00',2.46),('8348','2014-04-22','15:20:00',2.9),('8348','2014-04-22','15:25:00',2.79),('8348','2014-04-22','15:30:00',2.34),('8348','2014-04-22','15:35:00',2.64),('8348','2014-04-22','15:40:00',3.38),('8348','2014-04-22','15:45:00',3.04),('8348','2014-04-22','15:50:00',2.35),('8348','2014-04-22','15:55:00',2.06),('8348','2014-04-22','16:00:00',2.3),('8348','2014-04-22','16:05:00',2.66),('8348','2014-04-22','16:10:00',2.04),('8348','2014-04-22','16:15:00',1.82),('8348','2014-04-22','16:20:00',1.38),('8348','2014-04-22','16:25:00',1.17),('8348','2014-04-22','16:30:00',1.12),('8348','2014-04-22','16:35:00',1.26),('8348','2014-04-22','16:40:00',1.28),('8348','2014-04-22','16:45:00',1.11),('8348','2014-04-22','16:50:00',1.02),('8348','2014-04-21','07:25:00',1.08),('8348','2014-04-21','07:30:00',1.49),('8348','2014-04-21','07:35:00',1.49),('8348','2014-04-21','07:40:00',1.64),('8348','2014-04-21','07:45:00',1.6),('8348','2014-04-21','07:50:00',1.54),('8348','2014-04-21','07:55:00',1.52),('8348','2014-04-21','08:00:00',1.73),('8348','2014-04-21','08:05:00',1.73),('8348','2014-04-21','08:10:00',1.72),('8348','2014-04-21','08:15:00',1.76),('8348','2014-04-21','08:20:00',2.75),('8348','2014-04-21','08:25:00',2.52),('8348','2014-04-21','08:35:00',1),('8348','2014-04-21','08:40:00',1.52),('8348','2014-04-21','08:45:00',1.67),('8348','2014-04-21','08:50:00',1.72),('8348','2014-04-21','08:55:00',1.8),('8348','2014-04-21','09:00:00',2.31),('8348','2014-04-21','09:05:00',5.28),('8348','2014-04-21','09:10:00',5.04),('8348','2014-04-21','09:15:00',5.51),('8348','2014-04-21','09:20:00',5.27),('8348','2014-04-21','09:25:00',5.31),('8348','2014-04-21','09:30:00',5.31),('8348','2014-04-21','09:35:00',5.37),('8348','2014-04-21','09:40:00',5.42),('8348','2014-04-21','09:45:00',5.5),('8348','2014-04-21','09:50:00',5.57),('8348','2014-04-21','09:55:00',5.66),('8348','2014-04-21','10:00:00',5.73),('8348','2014-04-21','10:05:00',5.8),('8348','2014-04-21','10:10:00',5.87),('8348','2014-04-21','10:15:00',5.93),('8348','2014-04-21','10:20:00',5.99),('8348','2014-04-21','10:25:00',6.1),('8348','2014-04-21','10:30:00',6.15),('8348','2014-04-21','10:35:00',6.22),('8348','2014-04-21','10:40:00',6.34),('8348','2014-04-21','10:45:00',6.37),('8348','2014-04-21','10:50:00',6.4),('8348','2014-04-21','10:55:00',6.52),('8348','2014-04-21','11:00:00',6.59),('8348','2014-04-21','11:05:00',6.67),('8348','2014-04-21','11:10:00',6.68),('8348','2014-04-21','11:15:00',6.73),('8348','2014-04-21','11:20:00',6.82),('8348','2014-04-21','11:25:00',6.91),('8348','2014-04-21','11:30:00',6.95),('8348','2014-04-21','11:35:00',6.93),('8348','2014-04-21','11:40:00',6.99),('8348','2014-04-21','11:45:00',7.02),('8348','2014-04-21','11:50:00',7.09),('8348','2014-04-21','11:55:00',7.11),('8348','2014-04-21','12:00:00',7.11),('8348','2014-04-21','12:05:00',7.19),('8348','2014-04-21','12:10:00',7.17),('8348','2014-04-21','12:15:00',7.17),('8348','2014-04-21','12:20:00',7.21),('8348','2014-04-21','12:25:00',7.2),('8348','2014-04-21','12:30:00',7.18),('8348','2014-04-21','12:35:00',7.15),('8348','2014-04-21','12:40:00',7.21),('8348','2014-04-21','12:45:00',7.34),('8348','2014-04-21','12:50:00',7.37),('8348','2014-04-21','12:55:00',7.39),('8348','2014-04-21','13:00:00',7.36),('8348','2014-04-21','13:05:00',7.36),('8348','2014-04-21','13:10:00',7.36),('8348','2014-04-21','13:15:00',7.3),('8348','2014-04-21','13:20:00',7.22),('8348','2014-04-21','13:25:00',7.22),('8348','2014-04-21','13:30:00',7.18),('8348','2014-04-21','13:35:00',7.12),('8348','2014-04-21','13:40:00',7.11),('8348','2014-04-21','13:45:00',7.05),('8348','2014-04-21','13:50:00',6.99),('8348','2014-04-21','13:55:00',6.93),('8348','2014-04-21','14:00:00',6.87),('8348','2014-04-21','14:05:00',6.86),('8348','2014-04-21','14:10:00',6.78),('8348','2014-04-21','14:15:00',6.67),('8348','2014-04-21','14:20:00',6.64),('8348','2014-04-21','14:25:00',6.57),('8348','2014-04-21','14:30:00',6.46),('8348','2014-04-21','14:35:00',6.38),('8348','2014-04-21','14:40:00',6.29),('8348','2014-04-21','14:45:00',6.18),('8348','2014-04-21','14:50:00',6.13),('8348','2014-04-21','14:55:00',6.06),('8348','2014-04-21','15:00:00',5.99),('8348','2014-04-21','15:05:00',5.94),('8348','2014-04-21','15:10:00',5.83),('8348','2014-04-21','15:15:00',5.12),('8348','2014-04-21','15:20:00',5.68),('8348','2014-04-21','15:25:00',5.19),('8348','2014-04-21','15:30:00',4.88),('8348','2014-04-21','15:35:00',5.33),('8348','2014-04-21','15:40:00',5.19),('8348','2014-04-21','15:45:00',5.08),('8348','2014-04-21','15:50:00',4.95),('8348','2014-04-21','15:55:00',4.8),('8348','2014-04-21','16:00:00',4.65),('8348','2014-04-21','16:05:00',4.54),('8348','2014-04-21','16:10:00',4.42),('8348','2014-04-21','16:15:00',4.26),('8348','2014-04-21','16:20:00',4.11),('8348','2014-04-21','16:25:00',4),('8348','2014-04-21','16:30:00',3.89),('8348','2014-04-21','16:35:00',3.74),('8348','2014-04-21','16:40:00',3.43),('8348','2014-04-21','16:45:00',3.4),('8348','2014-04-21','16:50:00',3.22),('8348','2014-04-21','16:55:00',3.09),('8348','2014-04-21','17:00:00',2.9),('8348','2014-04-21','17:05:00',2.72),('8348','2014-04-21','17:10:00',2.55),('8348','2014-04-21','17:15:00',2.39),('8348','2014-04-21','17:20:00',2.23),('8348','2014-04-21','17:25:00',2.07),('8348','2014-04-21','17:30:00',1.89),('8348','2014-04-21','17:35:00',1.71),('8348','2014-04-21','17:40:00',1.55),('8348','2014-04-21','17:45:00',1.4),('8348','2014-04-21','17:50:00',1.28),('8348','2014-04-21','17:55:00',1.17),('8348','2014-04-21','18:00:00',1.09),('8348','2014-04-21','18:05:00',1.02),('8348','2014-04-20','06:45:00',1.05),('8348','2014-04-20','06:50:00',1.26),('8348','2014-04-20','06:55:00',1.42),('8348','2014-04-20','07:00:00',1.3),('8348','2014-04-20','07:05:00',1.37),('8348','2014-04-20','07:10:00',1.58),('8348','2014-04-20','07:15:00',1.77),('8348','2014-04-20','07:20:00',2.24),('8348','2014-04-20','07:25:00',3.08),('8348','2014-04-20','07:30:00',3.11),('8348','2014-04-20','07:35:00',2.95),('8348','2014-04-20','07:40:00',1.51),('8348','2014-04-20','07:45:00',2.49),('8348','2014-04-20','07:50:00',2.44),('8348','2014-04-20','07:55:00',2.12),('8348','2014-04-20','08:00:00',2.6),('8348','2014-04-20','08:05:00',1.89),('8348','2014-04-20','08:10:00',3.6),('8348','2014-04-20','08:15:00',4.03),('8348','2014-04-20','08:20:00',4.05),('8348','2014-04-20','08:25:00',4.74),('8348','2014-04-20','08:30:00',5.22),('8348','2014-04-20','08:35:00',5.25),('8348','2014-04-20','08:40:00',3.42),('8348','2014-04-20','08:45:00',2.41),('8348','2014-04-20','08:50:00',2.66),('8348','2014-04-20','08:55:00',3.19),('8348','2014-04-20','09:00:00',3.85),('8348','2014-04-20','09:05:00',4.83),('8348','2014-04-20','09:10:00',4.42),('8348','2014-04-20','09:15:00',4.9),('8348','2014-04-20','09:20:00',5.08),('8348','2014-04-20','09:25:00',4.65),('8348','2014-04-20','09:30:00',4.39),('8348','2014-04-20','09:35:00',4.66),('8348','2014-04-20','09:40:00',4.52),('8348','2014-04-20','09:45:00',4.62),('8348','2014-04-20','09:50:00',5.11),('8348','2014-04-20','09:55:00',4.98),('8348','2014-04-20','10:00:00',5.81),('8348','2014-04-20','10:05:00',5.87),('8348','2014-04-20','10:10:00',5.92),('8348','2014-04-20','10:15:00',6),('8348','2014-04-20','10:20:00',2.39),('8348','2014-04-20','10:25:00',7.38),('8348','2014-04-20','10:30:00',7.21),('8348','2014-04-20','10:35:00',6.69),('8348','2014-04-20','10:40:00',5.99),('8348','2014-04-20','10:45:00',3.51),('8348','2014-04-20','10:50:00',4.2),('8348','2014-04-20','10:55:00',2.39),('8348','2014-04-20','11:00:00',7.83),('8348','2014-04-20','11:05:00',7.52),('8348','2014-04-20','11:10:00',5.74),('8348','2014-04-20','11:15:00',3.87),('8348','2014-04-20','11:20:00',3.81),('8348','2014-04-20','11:25:00',6.28),('8348','2014-04-20','11:30:00',7.6),('8348','2014-04-20','11:35:00',7.38),('8348','2014-04-20','11:40:00',7.37),('8348','2014-04-20','11:45:00',7.45),('8348','2014-04-20','11:50:00',7.5),('8348','2014-04-20','11:55:00',7.51),('8348','2014-04-20','12:00:00',7.56),('8348','2014-04-20','12:05:00',7.61),('8348','2014-04-20','12:10:00',7.5),('8348','2014-04-20','12:15:00',7.83),('8348','2014-04-20','12:20:00',7.47),('8348','2014-04-20','12:25:00',7.45),('8348','2014-04-20','12:30:00',7.52),('8348','2014-04-20','12:35:00',7.55),('8348','2014-04-20','12:40:00',7.59),('8348','2014-04-20','12:45:00',7.55),('8348','2014-04-20','12:50:00',7.54),('8348','2014-04-20','12:55:00',7.48),('8348','2014-04-20','13:00:00',7.42),('8348','2014-04-20','13:05:00',7.42),('8348','2014-04-20','13:10:00',7.49),('8348','2014-04-20','13:15:00',7.82),('8348','2014-04-20','13:20:00',6.01),('8348','2014-04-20','13:25:00',5.6),('8348','2014-04-20','13:30:00',5.43),('8348','2014-04-20','13:35:00',4.48),('8348','2014-04-20','13:40:00',4.41),('8348','2014-04-20','13:45:00',4.82),('8348','2014-04-20','13:50:00',4.63),('8348','2014-04-20','13:55:00',5.18),('8348','2014-04-20','14:00:00',6.98),('8348','2014-04-20','14:05:00',6.35),('8348','2014-04-20','14:10:00',6.74),('8348','2014-04-20','14:15:00',6.86),('8348','2014-04-20','14:20:00',6.61),('8348','2014-04-20','14:25:00',6.67),('8348','2014-04-20','14:30:00',6.56),('8348','2014-04-20','14:35:00',6.46),('8348','2014-04-20','14:40:00',6.56),('8348','2014-04-20','14:45:00',5.51),('8348','2014-04-20','14:50:00',4.61),('8348','2014-04-20','14:55:00',6.38),('8348','2014-04-20','15:00:00',6.14),('8348','2014-04-20','15:05:00',6.02),('8348','2014-04-20','15:10:00',5.97),('8348','2014-04-20','15:15:00',5.91),('8348','2014-04-20','15:20:00',5.84),('8348','2014-04-20','15:25:00',4.89),('8348','2014-04-20','15:30:00',5.57),('8348','2014-04-20','15:35:00',5.38),('8348','2014-04-20','15:40:00',5.42),('8348','2014-04-20','15:45:00',4.73),('8348','2014-04-20','15:50:00',5.04),('8348','2014-04-20','15:55:00',5.12),('8348','2014-04-20','16:00:00',4.84),('8348','2014-04-20','16:05:00',4.64),('8348','2014-04-20','16:10:00',4.44),('8348','2014-04-20','16:15:00',4.26),('8348','2014-04-20','16:20:00',4.14),('8348','2014-04-20','16:25:00',3.98),('8348','2014-04-20','16:30:00',3.84),('8348','2014-04-20','16:35:00',3.68),('8348','2014-04-20','16:40:00',3.52),('8348','2014-04-20','16:45:00',3.31),('8348','2014-04-20','16:50:00',3.13),('8348','2014-04-20','16:55:00',3.03),('8348','2014-04-20','17:00:00',2.86),('8348','2014-04-20','17:05:00',2.71),('8348','2014-04-20','17:10:00',2.54),('8348','2014-04-20','17:15:00',2.26),('8348','2014-04-20','17:20:00',1.62),('8348','2014-04-20','17:25:00',1.22),('8348','2014-04-20','17:30:00',1.79),('8348','2014-04-20','17:35:00',1.83),('8348','2014-04-20','17:40:00',1.58),('8348','2013-11-21','09:40:00',1.11),('8348','2013-11-21','09:45:00',1.43),('8348','2013-11-21','09:50:00',1.15),('8348','2013-11-21','09:55:00',1.34),('8348','2013-11-21','10:00:00',1.05),('8348','2013-11-21','10:05:00',1.53),('8348','2013-11-21','10:10:00',1.67),('8348','2013-11-21','10:15:00',1.87),('8348','2013-11-21','10:20:00',1.74),('8348','2013-11-21','10:25:00',1.15),('8348','2013-11-21','10:30:00',1.86),('8348','2013-11-21','10:35:00',1.92),('8348','2013-11-21','10:40:00',2.11),('8348','2013-11-21','10:45:00',1.46),('8348','2013-11-21','11:15:00',1.12),('8348','2013-11-21','11:20:00',1.27),('8348','2013-11-21','11:25:00',1.72),('8348','2013-11-21','11:30:00',2.24),('8348','2013-11-21','11:35:00',1.49),('8348','2013-11-21','11:40:00',1.92),('8348','2013-11-21','11:45:00',2.06),('8348','2013-11-21','11:50:00',2.25),('8348','2013-11-21','11:55:00',2.32),('8348','2013-11-21','12:00:00',1.31),('8348','2013-11-21','12:05:00',2.17),('8348','2013-11-21','12:10:00',2.32),('8348','2013-11-21','12:15:00',2.32),('8348','2013-11-21','12:20:00',2.36),('8348','2013-11-21','12:25:00',2.43),('8348','2013-11-21','12:30:00',2.6),('8348','2013-11-21','12:35:00',2.67),('8348','2013-11-21','12:40:00',2.71),('8348','2013-11-21','12:45:00',2.63),('8348','2013-11-21','12:50:00',2.62),('8348','2013-11-21','12:55:00',2.75),('8348','2013-11-21','13:00:00',2.61),('8348','2013-11-21','13:05:00',2.26),('8348','2013-11-21','13:10:00',1.45),('8348','2013-11-21','13:15:00',2.54),('8348','2013-11-21','13:20:00',2.41),('8348','2013-11-21','13:25:00',1.85),('8348','2013-11-21','13:40:00',1.26),('8348','2013-11-21','13:45:00',2.17),('8348','2013-11-21','13:50:00',1.24),('8348','2013-11-21','13:55:00',2.19),('8348','2013-11-21','14:00:00',1.98),('8348','2013-11-21','14:25:00',1.31),('8348','2013-11-21','14:40:00',1.44),('8348','2013-11-21','14:45:00',1.37),('8348','2013-11-21','14:50:00',1.32),('8348','2013-11-21','15:00:00',1.09),('8348','2013-11-21','15:05:00',1.11),('8348','2013-11-21','15:10:00',1.04),('8348','2013-11-20','09:15:00',1.14),('8348','2013-11-20','09:20:00',1.22),('8348','2013-11-20','09:25:00',1.33),('8348','2013-11-20','09:30:00',1.4),('8348','2013-11-20','10:00:00',1.47),('8348','2013-11-20','10:15:00',1.49),('8348','2013-11-20','11:25:00',1.14),('8348','2013-11-20','11:30:00',1.07),('8348','2013-11-20','11:35:00',1.06),('8348','2013-11-20','11:40:00',1.16),('8348','2013-11-20','11:45:00',3.19),('8348','2013-11-20','11:50:00',2.59),('8348','2013-11-20','11:55:00',1.33),('8348','2013-11-20','12:20:00',2),('8348','2013-11-20','12:25:00',1.38),('8348','2013-11-20','12:45:00',1.02),('8348','2013-11-20','12:50:00',1.17),('8348','2013-11-20','12:55:00',1.72),('8348','2013-11-20','13:00:00',1.66),('8348','2013-11-20','13:05:00',1.43),('8348','2013-11-20','13:20:00',1.21),('8348','2013-11-20','13:25:00',1.06),('8348','2013-11-20','13:40:00',1.2),('8348','2013-11-20','13:45:00',1.37),('8348','2013-11-20','13:50:00',1.62),('8348','2013-11-20','13:55:00',1),('8348','2013-11-20','14:20:00',1.06),('8348','2013-11-20','14:25:00',1.1),('8348','2013-11-20','14:45:00',1.21),('8348','2013-11-20','15:05:00',1.3),('8348','2013-11-20','15:10:00',1.22),('8348','2013-11-20','15:15:00',1.01),('8348','2013-11-19','09:40:00',1.49),('8348','2013-11-19','09:45:00',1.45),('8348','2013-11-19','10:05:00',1.05),('8348','2013-11-19','10:50:00',1.26),('8348','2013-11-19','11:20:00',2.34),('8348','2013-11-19','11:25:00',1.77),('8348','2013-11-19','11:30:00',1.54),('8348','2013-11-19','11:35:00',2.19),('8348','2013-11-19','11:40:00',1.87),('8348','2013-11-19','11:45:00',2.15),('8348','2013-11-19','11:50:00',2.12),('8348','2013-11-19','11:55:00',2.05),('8348','2013-11-19','12:00:00',1.67),('8348','2013-11-19','12:05:00',2.17),('8348','2013-11-19','12:10:00',2.05),('8348','2013-11-19','12:15:00',2.12),('8348','2013-11-19','12:20:00',1.25),('8348','2013-11-19','12:30:00',1.19),('8348','2013-11-19','12:45:00',1.92),('8348','2013-11-19','12:50:00',1.92),('8348','2013-11-19','12:55:00',2.58),('8348','2013-11-19','13:00:00',1.1),('8348','2013-11-19','13:05:00',1.03),('8348','2013-11-19','13:15:00',1.81),('8348','2013-11-19','13:20:00',1.97),('8348','2013-11-19','15:25:00',1.12),('8348','2013-11-19','15:30:00',1.45),('8348','2013-11-19','15:35:00',1.05),('8348','2013-11-18','09:20:00',1.16),('8348','2013-11-18','09:25:00',1.23),('8348','2013-11-18','09:30:00',1.14),('8348','2013-11-18','09:35:00',1.5),('8348','2013-11-18','09:40:00',1.18),('8348','2013-11-18','09:45:00',1.08),('8348','2013-11-18','10:00:00',1.02),('8348','2013-11-18','10:05:00',1.16),('8348','2013-11-18','10:10:00',1.34),('8348','2013-11-18','10:15:00',1.43),('8348','2013-11-18','10:20:00',1.22),('8348','2013-11-18','10:25:00',1.12),('8348','2013-11-18','10:30:00',1.06),('8348','2013-11-18','10:35:00',1.04),('8348','2013-11-18','10:40:00',1.09),('8348','2013-11-18','10:45:00',1.13),('8348','2013-11-18','10:50:00',1.07),('8348','2013-11-18','11:35:00',1.01),('8348','2013-11-18','11:40:00',1.04),('8348','2013-11-18','11:45:00',1.07),('8348','2013-11-18','11:50:00',1.12),('8348','2013-11-18','11:55:00',1.19),('8348','2013-11-18','12:00:00',1.25),('8348','2013-11-18','12:05:00',1.31),('8348','2013-11-18','12:10:00',1.29),('8348','2013-11-18','12:15:00',1.34),('8348','2013-11-18','12:20:00',1.41),('8348','2013-11-18','12:25:00',1.47),('8348','2013-11-18','12:30:00',1.32),('8348','2013-11-18','12:35:00',1.17),('8348','2013-11-18','12:40:00',1),('8348','2013-11-18','13:40:00',1.04),('8348','2014-04-19','06:30:00',1.03),('8348','2014-04-19','06:35:00',1.19),('8348','2014-04-19','06:40:00',1.37),('8348','2014-04-19','06:45:00',1.04),('8348','2014-04-19','06:50:00',1.37),('8348','2014-04-19','06:55:00',2.54),('8348','2014-04-19','07:00:00',2.07),('8348','2014-04-19','07:05:00',1.79),('8348','2014-04-19','07:10:00',2.24),('8348','2014-04-19','07:15:00',1.85),('8348','2014-04-19','07:20:00',2.07),('8348','2014-04-19','07:25:00',2.49),('8348','2014-04-19','07:30:00',3.05),('8348','2014-04-19','07:35:00',3.27),('8348','2014-04-19','07:40:00',2.99),('8348','2014-04-19','07:45:00',3.02),('8348','2014-04-19','07:50:00',2.51),('8348','2014-04-19','07:55:00',1.69),('8348','2014-04-19','08:00:00',1.06),('8348','2014-04-19','08:10:00',1.15),('8348','2014-04-19','08:15:00',1.49),('8348','2014-04-19','08:20:00',1.88),('8348','2014-04-19','08:25:00',2.54),('8348','2014-04-19','08:30:00',3.68),('8348','2014-04-19','08:35:00',3.53),('8348','2014-04-19','08:40:00',2.14),('8348','2014-04-19','08:45:00',1.59),('8348','2014-04-19','08:50:00',1.35),('8348','2014-04-19','08:55:00',1.26),('8348','2014-04-19','09:00:00',1.32),('8348','2014-04-19','09:05:00',1.07),('8348','2014-04-19','09:15:00',1.16),('8348','2014-04-19','09:20:00',1.41),('8348','2014-04-19','09:25:00',1.37),('8348','2014-04-19','09:30:00',1.39),('8348','2014-04-19','09:35:00',1.68),('8348','2014-04-19','09:40:00',2.22),('8348','2014-04-19','09:45:00',2.13),('8348','2014-04-19','09:50:00',2.27),('8348','2014-04-19','09:55:00',2.9),('8348','2014-04-19','10:00:00',2.9),('8348','2014-04-19','10:05:00',2.29),('8348','2014-04-19','10:10:00',2.28),('8348','2014-04-19','10:15:00',3.35),('8348','2014-04-19','10:20:00',5.88),('8348','2014-04-19','10:25:00',5.01),('8348','2014-04-19','10:30:00',4.44),('8348','2014-04-19','10:35:00',4.7),('8348','2014-04-19','10:40:00',4.85),('8348','2014-04-19','10:45:00',3.72),('8348','2014-04-19','10:50:00',3),('8348','2014-04-19','10:55:00',1.9),('8348','2014-04-19','11:00:00',1.54),('8348','2014-04-19','11:05:00',1.24),('8348','2014-04-19','12:05:00',1.19),('8348','2014-04-19','12:10:00',1.18),('8348','2014-04-19','12:15:00',2.65),('8348','2014-04-19','12:20:00',2.56),('8348','2014-04-19','12:25:00',1.36),('8348','2014-04-19','12:35:00',1.52),('8348','2014-04-19','12:40:00',1.46),('8348','2014-04-19','12:45:00',1.07),('8348','2014-04-19','12:50:00',1.48),('8348','2014-04-19','12:55:00',1.7),('8348','2014-04-19','13:25:00',1.15),('8348','2014-04-19','13:30:00',2.53),('8348','2014-04-19','13:35:00',2.64),('8348','2014-04-19','13:40:00',3.21),('8348','2014-04-19','13:45:00',3.31),('8348','2014-04-19','13:50:00',2.08),('8348','2014-04-19','13:55:00',1.82),('8348','2014-04-19','14:00:00',2.51),('8348','2014-04-19','14:05:00',2.34),('8348','2014-04-19','14:10:00',1.11),('8348','2014-04-19','14:20:00',1.18),('8348','2014-04-19','14:25:00',1.96),('8348','2014-04-19','14:30:00',1.95),('8348','2014-04-19','14:35:00',1.13),('8348','2014-04-19','14:45:00',2.02),('8348','2014-04-19','14:50:00',5.35),('8348','2014-04-19','14:55:00',5.38),('8348','2014-04-19','15:00:00',4.05),('8348','2014-04-19','15:05:00',3.98),('8348','2014-04-19','15:10:00',3.45),('8348','2014-04-19','15:15:00',3.1),('8348','2014-04-19','15:20:00',3.47),('8348','2014-04-19','15:25:00',3.55),('8348','2014-04-19','15:30:00',5.73),('8348','2014-04-19','15:35:00',2.96),('8348','2014-04-19','15:40:00',2.07),('8348','2014-04-19','15:45:00',1.84),('8348','2014-04-19','15:50:00',1.37),('8348','2014-04-19','16:00:00',1.1),('8348','2014-04-19','16:05:00',1.69),('8348','2014-04-19','16:10:00',1.75),('8348','2014-04-19','16:15:00',2.02),('8348','2014-04-19','16:20:00',3.54),('8348','2014-04-19','16:25:00',2.48),('8348','2014-04-19','16:30:00',2.27),('8348','2014-04-19','16:35:00',1.75),('8348','2014-04-19','16:40:00',1.11),('8348','2013-11-17','08:45:00',1.04),('8348','2013-11-17','08:50:00',1.19),('8348','2013-11-17','08:55:00',1.27),('8348','2013-11-17','09:00:00',1.18),('8348','2013-11-17','09:05:00',1.09),('8348','2013-11-17','09:10:00',1.12),('8348','2013-11-17','09:15:00',1.18),('8348','2013-11-17','09:20:00',1.28),('8348','2013-11-17','09:25:00',1.34),('8348','2013-11-17','09:30:00',1.4),('8348','2013-11-17','09:35:00',1.38),('8348','2013-11-17','09:40:00',1.43),('8348','2013-11-17','09:45:00',1.47),('8348','2013-11-17','09:50:00',1.5),('8348','2013-11-17','09:55:00',1.56),('8348','2013-11-17','10:00:00',1.61),('8348','2013-11-17','10:05:00',1.65),('8348','2013-11-17','10:10:00',1.69),('8348','2013-11-17','10:15:00',1.73),('8348','2013-11-17','10:20:00',1.77),('8348','2013-11-17','10:25:00',1.8),('8348','2013-11-17','10:30:00',1.83),('8348','2013-11-17','10:35:00',1.86),('8348','2013-11-17','10:40:00',1.9),('8348','2013-11-17','10:45:00',1.92),('8348','2013-11-17','10:50:00',1.95),('8348','2013-11-17','10:55:00',1.97),('8348','2013-11-17','11:00:00',1.99),('8348','2013-11-17','11:05:00',2.02),('8348','2013-11-17','11:10:00',2.04),('8348','2013-11-17','11:15:00',2.06),('8348','2013-11-17','11:20:00',2.08),('8348','2013-11-17','11:25:00',2.09),('8348','2013-11-17','11:30:00',2.1),('8348','2013-11-17','11:35:00',2.1),('8348','2013-11-17','11:40:00',2.1),('8348','2013-11-17','11:45:00',2.13),('8348','2013-11-17','11:50:00',2.14),('8348','2013-11-17','11:55:00',2.14),('8348','2013-11-17','12:00:00',2.13),('8348','2013-11-17','12:05:00',2.13),('8348','2013-11-17','12:10:00',2.13),('8348','2013-11-17','12:15:00',2.11),('8348','2013-11-17','12:20:00',2.11),('8348','2013-11-17','12:25:00',2.11),('8348','2013-11-17','12:30:00',2.1),('8348','2013-11-17','12:35:00',2.1),('8348','2013-11-17','12:40:00',2.1),('8348','2013-11-17','12:45:00',2.09),('8348','2013-11-17','12:50:00',2.09),('8348','2013-11-17','12:55:00',2.07),('8348','2013-11-17','13:00:00',2.05),('8348','2013-11-17','13:05:00',2.02),('8348','2013-11-17','13:10:00',1.99),('8348','2013-11-17','13:15:00',1.97),('8348','2013-11-17','13:20:00',1.94),('8348','2013-11-17','13:25:00',1.95),('8348','2013-11-17','13:30:00',1.95),('8348','2013-11-17','13:35:00',1.66),('8348','2013-11-17','13:40:00',1.35),('8348','2013-11-17','14:00:00',1.52),('8348','2013-11-17','14:05:00',1.35),('8348','2013-11-17','14:10:00',1.62),('8348','2013-11-17','14:15:00',1.57),('8348','2013-11-17','14:20:00',1.51),('8348','2013-11-17','14:25:00',1.47),('8348','2013-11-17','14:30:00',1.37),('8348','2013-11-17','14:35:00',1.34),('8348','2013-11-17','14:40:00',1.26),('8348','2013-11-17','14:45:00',1.26),('8348','2013-11-15','09:15:00',1.07),('8348','2013-11-15','09:30:00',1.03),('8348','2013-11-15','09:35:00',1.13),('8348','2013-11-15','10:15:00',1.13),('8348','2013-11-15','10:20:00',1.13),('8348','2013-11-15','10:55:00',1.3),('8348','2013-11-15','11:00:00',1.19),('8348','2013-11-15','11:05:00',1.09),('8348','2013-11-15','11:10:00',1.05),('8348','2013-11-15','11:15:00',1.13),('8348','2013-11-15','11:20:00',1.45),('8348','2013-11-15','11:25:00',1.77),('8348','2013-11-15','11:30:00',1.5),('8348','2013-11-15','11:35:00',1.52),('8348','2013-11-15','11:40:00',1.8),('8348','2013-11-15','11:45:00',1.34),('8348','2013-11-15','11:50:00',1.16),('8348','2013-11-15','11:55:00',1.06),('8348','2013-11-15','12:00:00',1.06),('8348','2013-11-15','12:05:00',1.2),('8348','2013-11-15','12:15:00',1.06),('8348','2013-11-15','12:20:00',1.16),('8348','2013-11-15','12:25:00',1.55),('8348','2013-11-15','12:30:00',1.23),('8348','2013-11-15','12:35:00',1.06),('8348','2013-11-15','12:50:00',1.06),('8348','2013-11-15','12:55:00',1.27),('8348','2013-11-15','13:00:00',1.36),('8348','2013-11-15','13:05:00',1.16),('8348','2013-11-15','13:10:00',1.05),('8348','2013-11-15','13:35:00',1.05),('8348','2013-11-15','13:40:00',1.09),('8348','2013-11-15','13:45:00',1.47),('8348','2013-11-15','13:50:00',1.73),('8348','2013-11-15','13:55:00',1.1),('8348','2013-11-14','09:00:00',1.03),('8348','2013-11-14','09:20:00',1.31),('8348','2013-11-14','09:25:00',1.34),('8348','2013-11-14','09:30:00',1.37),('8348','2013-11-14','09:35:00',1.42),('8348','2013-11-14','09:40:00',1.47),('8348','2013-11-14','09:45:00',1.51),('8348','2013-11-14','09:50:00',1.33),('8348','2013-11-14','09:55:00',1.02),('8348','2013-11-14','10:05:00',1.13),('8348','2013-11-14','10:10:00',1.39),('8348','2013-11-14','10:15:00',1.78),('8348','2013-11-14','10:20:00',1.84),('8348','2013-11-14','10:25:00',1.83),('8348','2013-11-14','10:30:00',1.86),('8348','2013-11-14','10:35:00',1.88),('8348','2013-11-14','10:40:00',1.91),('8348','2013-11-14','10:45:00',1.91),('8348','2013-11-14','10:50:00',1.96),('8348','2013-11-14','10:55:00',1.95),('8348','2013-11-14','11:00:00',2),('8348','2013-11-14','11:05:00',2.11),('8348','2013-11-14','11:10:00',2.16),('8348','2013-11-14','11:15:00',2.21),('8348','2013-11-14','11:20:00',2.26),('8348','2013-11-14','11:25:00',2.3),('8348','2013-11-14','11:30:00',2.27),('8348','2013-11-14','11:35:00',2.09),('8348','2013-11-14','11:40:00',2),('8348','2013-11-14','11:45:00',1.58),('8348','2013-11-14','11:50:00',1.67),('8348','2013-11-14','11:55:00',1.36),('8348','2013-11-14','12:00:00',2.41),('8348','2013-11-14','12:05:00',1.29),('8348','2013-11-14','12:10:00',1.23),('8348','2013-11-14','12:15:00',1.27),('8348','2013-11-14','12:20:00',1.15),('8348','2013-11-14','12:35:00',1),('8348','2013-11-14','12:45:00',1),('8348','2013-11-14','12:50:00',1.04),('8348','2013-11-14','12:55:00',1.02),('8348','2013-11-14','13:00:00',1),('8348','2013-11-14','13:55:00',1.04),('8348','2013-11-13','10:20:00',1.71),('8348','2013-11-13','10:25:00',2.72),('8348','2013-11-13','10:30:00',2.35),('8348','2013-11-13','10:35:00',2.82),('8348','2013-11-13','10:40:00',2.65),('8348','2013-11-13','10:45:00',2.4),('8348','2013-11-13','10:50:00',2.81),('8348','2013-11-13','10:55:00',2.43),('8348','2013-11-13','11:00:00',1.61),('8348','2013-11-13','11:50:00',1.09),('8348','2013-11-13','11:55:00',1.01),('8348','2013-11-13','13:05:00',1.22),('8348','2013-11-13','13:10:00',1.14),('8348','2013-11-13','13:15:00',1.1),('8348','2013-11-13','13:55:00',1.43),('8348','2013-11-13','14:00:00',1.64),('8348','2013-11-13','14:05:00',1.58),('8348','2013-11-13','14:10:00',1.47),('8348','2013-11-13','14:15:00',1.51),('8348','2013-11-13','14:20:00',1.39),('8348','2013-11-13','14:25:00',1.45),('8348','2013-11-13','14:30:00',1.38),('8348','2013-11-13','14:35:00',1.02),('8348','2013-11-12','11:25:00',1.18),('8348','2013-11-12','11:40:00',2.23),('8348','2013-11-12','11:45:00',1.31),('8348','2013-11-12','11:50:00',1.49),('8348','2013-11-12','12:00:00',2.28),('8348','2013-11-12','12:05:00',1.21),('8348','2013-11-12','12:30:00',3.02),('8348','2013-11-12','12:35:00',2.74),('8348','2013-11-12','12:40:00',1.77),('8348','2013-11-12','12:45:00',1.69),('8348','2013-11-12','12:50:00',1.56),('8348','2013-11-12','12:55:00',1.98),('8348','2013-11-12','13:00:00',1.78),('8348','2013-11-12','13:05:00',1.89),('8348','2013-11-12','13:10:00',2.71),('8348','2013-11-12','13:15:00',3.25),('8348','2013-11-12','13:20:00',2.49),('8348','2013-11-12','13:25:00',2.69),('8348','2013-11-12','13:30:00',1.68),('8348','2013-11-12','13:35:00',1.75),('8348','2013-11-12','13:40:00',2.5),('8348','2013-11-12','13:45:00',1.55),('8348','2013-11-12','13:50:00',1.08),('8348','2013-11-12','13:55:00',1.19),('8348','2013-11-12','14:00:00',1.21),('8348','2013-11-12','14:05:00',1.12),('8348','2013-11-12','14:10:00',2.12),('8348','2013-11-12','14:15:00',2.4),('8348','2013-11-12','14:20:00',2.22),('8348','2013-11-12','14:25:00',1.07),('8348','2013-11-12','14:30:00',1.67),('8348','2013-11-12','14:35:00',1.11),('8348','2013-11-12','14:40:00',1.66),('8348','2013-11-12','14:45:00',1.53),('8348','2013-11-12','14:50:00',1.23),('8348','2013-11-12','15:20:00',1.06),('8348','2013-11-11','09:50:00',1.09),('8348','2013-11-11','09:55:00',1.16),('8348','2013-11-11','10:05:00',1.07),('8348','2013-11-11','10:10:00',1.09),('8348','2013-11-11','10:15:00',1.36),('8348','2013-11-11','10:20:00',1.78),('8348','2013-11-11','10:25:00',1.33),('8348','2013-11-11','11:05:00',1.18),('8348','2013-11-11','11:10:00',2.65),('8348','2013-11-11','11:15:00',2.07),('8348','2013-11-11','11:20:00',1.57),('8348','2013-11-11','11:25:00',2.34),('8348','2013-11-11','11:30:00',2.54),('8348','2013-11-11','11:35:00',2.35),('8348','2013-11-11','11:40:00',3.32),('8348','2013-11-11','11:45:00',2.58),('8348','2013-11-11','11:50:00',3.01),('8348','2013-11-11','11:55:00',2.84),('8348','2013-11-11','12:00:00',2.64),('8348','2013-11-11','12:05:00',2.54),('8348','2013-11-11','12:10:00',2.48),('8348','2013-11-11','12:15:00',2.48),('8348','2013-11-11','12:20:00',2.55),('8348','2013-11-11','12:25:00',2.5),('8348','2013-11-11','12:30:00',1.55),('8348','2013-11-11','12:35:00',1.09),('8348','2013-11-11','12:40:00',1.65),('8348','2013-11-11','12:45:00',1.62),('8348','2013-11-11','13:00:00',1.03),('8348','2013-11-11','13:10:00',2.23),('8348','2013-11-11','13:15:00',1.71),('8348','2013-11-11','13:35:00',1.06),('8348','2013-11-11','13:40:00',1.67),('8348','2013-11-11','13:45:00',1.17),('8348','2013-11-11','14:00:00',1.11),('8348','2013-11-11','14:05:00',1.49),('8348','2013-11-11','14:15:00',1.07),('8348','2013-11-11','14:20:00',1.56),('8348','2013-11-11','14:25:00',2.01),('8348','2013-11-11','14:30:00',1.79),('8348','2013-11-11','14:35:00',1.7),('8348','2013-11-11','14:40:00',1.55),('8348','2013-11-10','08:40:00',1.03),('8348','2013-11-10','08:50:00',1.2),('8348','2013-11-10','08:55:00',1.34),('8348','2013-11-10','09:00:00',1.12),('8348','2013-11-10','09:15:00',1.15),('8348','2013-11-10','09:20:00',1.41),('8348','2013-11-10','09:25:00',1.52),('8348','2013-11-10','09:30:00',1.34),('8348','2013-11-10','09:35:00',1.33),('8348','2013-11-10','09:40:00',1.44),('8348','2013-11-10','09:45:00',1.61),('8348','2013-11-10','09:50:00',1.69),('8348','2013-11-10','09:55:00',1.74),('8348','2013-11-10','10:00:00',1.79),('8348','2013-11-10','10:05:00',1.97),('8348','2013-11-10','10:10:00',2.05),('8348','2013-11-10','10:15:00',2.1),('8348','2013-11-10','10:20:00',1.99),('8348','2013-11-10','10:25:00',2.25),('8348','2013-11-10','10:30:00',2.37),('8348','2013-11-10','10:35:00',2.04),('8348','2013-11-10','10:40:00',2.22),('8348','2013-11-10','10:45:00',1.64),('8348','2013-11-10','10:50:00',2.38),('8348','2013-11-10','10:55:00',2.26),('8348','2013-11-10','11:00:00',2.12),('8348','2013-11-10','11:05:00',1.57),('8348','2013-11-10','11:10:00',1.04),('8348','2013-11-10','11:25:00',1.1),('8348','2013-11-10','11:35:00',1.02),('8348','2013-11-10','11:40:00',1.35),('8348','2013-11-10','11:45:00',1.64),('8348','2013-11-10','11:50:00',1.04),('8348','2013-11-10','11:55:00',1.34),('8348','2013-11-10','12:05:00',1.38),('8348','2013-11-10','12:10:00',1.92),('8348','2013-11-10','12:15:00',2.43),('8348','2013-11-10','12:20:00',2.48),('8348','2013-11-10','12:25:00',2.35),('8348','2013-11-10','12:30:00',1.51),('8348','2013-11-10','12:35:00',2.06),('8348','2013-11-10','12:40:00',2.57),('8348','2013-11-10','12:45:00',2.79),('8348','2013-11-10','12:50:00',2.73),('8348','2013-11-10','12:55:00',1.19),('8348','2013-11-10','13:00:00',1.06),('8348','2013-11-10','13:50:00',2.15),('8348','2013-11-10','13:55:00',1.68),('8348','2013-11-09','09:40:00',1.79),('8348','2013-11-09','09:45:00',1.31),('8348','2013-11-09','09:50:00',2.14),('8348','2013-11-09','09:55:00',2.08),('8348','2013-11-09','10:00:00',1.96),('8348','2013-11-09','10:05:00',1.8),('8348','2013-11-09','10:10:00',1.36),('8348','2013-11-09','10:15:00',1.76),('8348','2013-11-09','10:20:00',1.73),('8348','2013-11-09','10:25:00',1.67),('8348','2013-11-09','10:35:00',1.2),('8348','2013-11-09','10:40:00',1.16),('8348','2013-11-09','10:45:00',1.18),('8348','2013-11-09','10:50:00',1.3),('8348','2013-11-09','10:55:00',1.89),('8348','2013-11-09','11:00:00',1.72),('8348','2013-11-09','11:05:00',2.69),('8348','2013-11-09','11:10:00',2.5),('8348','2013-11-09','11:15:00',2.99),('8348','2013-11-09','11:20:00',1.74),('8348','2013-11-09','11:25:00',1.48),('8348','2013-11-09','11:30:00',1.37),('8348','2013-11-09','11:35:00',1.74),('8348','2013-11-09','11:40:00',2.23),('8348','2013-11-09','11:45:00',1.62),('8348','2013-11-09','11:50:00',2.34),('8348','2013-11-09','11:55:00',2.18),('8348','2013-11-09','12:00:00',2.46),('8348','2013-11-09','12:05:00',3.04),('8348','2013-11-09','12:10:00',1.57),('8348','2013-11-09','12:15:00',1.56),('8348','2013-11-09','12:20:00',1.01),('8348','2013-11-09','12:25:00',1.42),('8348','2013-11-09','12:30:00',2.21),('8348','2013-11-09','12:35:00',2.41),('8348','2013-11-09','12:40:00',2.35),('8348','2013-11-09','12:45:00',1.72),('8348','2013-11-09','12:50:00',2.02),('8348','2013-11-09','12:55:00',1.55),('8348','2013-11-09','13:00:00',2.78),('8348','2013-11-09','13:05:00',2.07),('8348','2013-11-09','13:10:00',2.65),('8348','2013-11-09','13:15:00',2.57),('8348','2013-11-09','13:20:00',1.3),('8348','2013-11-09','13:25:00',2.2),('8348','2013-11-09','13:30:00',2.31),('8348','2013-11-09','13:35:00',2.25),('8348','2013-11-09','13:40:00',2.11),('8348','2013-11-09','13:45:00',2.07),('8348','2013-11-09','13:50:00',2.1),('8348','2013-11-09','13:55:00',2.05),('8348','2013-11-09','14:00:00',1.99),('8348','2013-11-09','14:05:00',1.8),('8348','2013-11-09','14:10:00',1.17),('8348','2013-11-09','14:15:00',1.25),('8348','2013-11-09','14:20:00',1.87),('8348','2013-11-09','14:25:00',1.49),('8348','2013-11-09','14:35:00',1.03),('8348','2013-11-09','14:40:00',1.17),('8348','2013-11-09','14:50:00',1.36),('8348','2013-11-08','09:20:00',1.52),('8348','2013-11-08','09:25:00',1.69),('8348','2013-11-08','09:30:00',1.87),('8348','2013-11-08','09:35:00',1.75),('8348','2013-11-08','09:45:00',1.09),('8348','2013-11-08','09:50:00',1.42),('8348','2013-11-08','10:05:00',1.39),('8348','2013-11-08','10:10:00',1.12),('8348','2013-11-08','10:40:00',1.43),('8348','2013-11-08','10:45:00',1.26),('8348','2013-11-08','10:50:00',1.82),('8348','2013-11-08','11:20:00',1.65),('8348','2013-11-08','11:25:00',2.04),('8348','2013-11-08','11:30:00',2.8),('8348','2013-11-08','11:35:00',2.32),('8348','2013-11-08','11:40:00',2.67),('8348','2013-11-08','11:45:00',2.53),('8348','2013-11-08','11:50:00',2.66),('8348','2013-11-08','11:55:00',2.4),('8348','2013-11-08','12:00:00',2.36),('8348','2013-11-08','12:05:00',2.36),('8348','2013-11-08','12:10:00',2.33),('8348','2013-11-08','12:15:00',1.12),('8348','2013-11-08','12:20:00',2.01),('8348','2013-11-08','12:35:00',1.13),('8348','2013-11-08','12:40:00',2.07),('8348','2013-11-08','12:45:00',2.06),('8348','2013-11-08','12:50:00',2.52),('8348','2013-11-08','12:55:00',2.61),('8348','2013-11-08','13:00:00',2.51),('8348','2013-11-08','13:05:00',2.44),('8348','2013-11-08','13:10:00',2.57),('8348','2013-11-08','13:15:00',1.79),('8348','2013-11-08','13:20:00',1.21),('8348','2013-11-08','13:25:00',2.25),('8348','2013-11-08','13:30:00',1.74),('8348','2013-11-08','13:35:00',2.25),('8348','2013-11-08','13:40:00',2.17),('8348','2013-11-08','13:45:00',2.08),('8348','2013-11-08','13:50:00',2.06),('8348','2013-11-08','13:55:00',2.06),('8348','2013-11-08','14:00:00',2),('8348','2013-11-08','14:05:00',1.91),('8348','2013-11-08','14:10:00',1.87),('8348','2013-11-08','14:25:00',1.21),('8348','2013-11-08','14:30:00',1.37),('8348','2013-11-08','14:35:00',1.75),('8348','2013-11-08','14:40:00',1.49),('8348','2013-11-08','14:45:00',1.51),('8348','2013-11-08','14:50:00',1.06),('8348','2013-11-08','15:05:00',1.28),('8348','2013-11-08','15:10:00',1.21),('8348','2014-04-18','07:00:00',1.17),('8348','2014-04-18','07:05:00',2.12),('8348','2014-04-18','07:10:00',2.13),('8348','2014-04-18','07:15:00',1.01),('8348','2014-04-18','07:35:00',1.51),('8348','2014-04-18','07:40:00',2.25),('8348','2014-04-18','07:45:00',2.3),('8348','2014-04-18','07:50:00',1.9),('8348','2014-04-18','07:55:00',1.79),('8348','2014-04-18','08:00:00',2.04),('8348','2014-04-18','08:05:00',3.77),('8348','2014-04-18','08:10:00',4.95),('8348','2014-04-18','08:15:00',4.46),('8348','2014-04-18','08:20:00',4.16),('8348','2014-04-18','08:25:00',2.77),('8348','2014-04-18','08:30:00',4.84),('8348','2014-04-18','08:35:00',2.8),('8348','2014-04-18','08:40:00',1.82),('8348','2014-04-18','08:45:00',3.12),('8348','2014-04-18','08:50:00',4.81),('8348','2014-04-18','08:55:00',5.19),('8348','2014-04-18','09:00:00',4.34),('8348','2014-04-18','09:05:00',2.89),('8348','2014-04-18','09:10:00',2.61),('8348','2014-04-18','09:15:00',2.79),('8348','2014-04-18','09:20:00',2.65),('8348','2014-04-18','09:25:00',2.75),('8348','2014-04-18','09:30:00',2.32),('8348','2014-04-18','09:35:00',2.14),('8348','2014-04-18','09:40:00',2.52),('8348','2014-04-18','09:45:00',4.2),('8348','2014-04-18','09:50:00',5.22),('8348','2014-04-18','09:55:00',5.19),('8348','2014-04-18','10:00:00',3.37),('8348','2014-04-18','10:05:00',3.01),('8348','2014-04-18','10:10:00',3.51),('8348','2014-04-18','10:15:00',5.16),('8348','2014-04-18','10:20:00',3.3),('8348','2014-04-18','10:25:00',2.53),('8348','2014-04-18','10:30:00',3.01),('8348','2014-04-18','10:35:00',2.94),('8348','2014-04-18','10:40:00',3.09),('8348','2014-04-18','10:45:00',3),('8348','2014-04-18','10:50:00',3.62),('8348','2014-04-18','10:55:00',3.27),('8348','2014-04-18','11:00:00',3.35),('8348','2014-04-18','11:05:00',6.03),('8348','2014-04-18','11:10:00',6),('8348','2014-04-18','11:15:00',6.07),('8348','2014-04-18','11:20:00',6.77),('8348','2014-04-18','11:25:00',4.85),('8348','2014-04-18','11:30:00',7.71),('8348','2014-04-18','11:35:00',7.47),('8348','2014-04-18','11:40:00',7.52),('8348','2014-04-18','11:45:00',6.48),('8348','2014-04-18','11:50:00',6.4),('8348','2014-04-18','11:55:00',4.95),('8348','2014-04-18','12:00:00',7.62),('8348','2014-04-18','12:05:00',5.02),('8348','2014-04-18','12:10:00',4.73),('8348','2014-04-18','12:15:00',4.48),('8348','2014-04-18','12:20:00',4.22),('8348','2014-04-18','12:25:00',3.08),('8348','2014-04-18','12:30:00',2.52),('8348','2014-04-18','12:35:00',2.54),('8348','2014-04-18','12:40:00',2.42),('8348','2014-04-18','12:45:00',2.1),('8348','2014-04-18','12:50:00',2.59),('8348','2014-04-18','12:55:00',4.33),('8348','2014-04-18','13:00:00',3.72),('8348','2014-04-18','13:05:00',3.09),('8348','2014-04-18','13:10:00',2.73),('8348','2014-04-18','13:15:00',2.44),('8348','2014-04-18','13:20:00',2.88),('8348','2014-04-18','13:25:00',3.66),('8348','2014-04-18','13:30:00',4.11),('8348','2014-04-18','13:35:00',4.72),('8348','2014-04-18','13:40:00',4.22),('8348','2014-04-18','13:45:00',4.97),('8348','2014-04-18','13:50:00',5.92),('8348','2014-04-18','13:55:00',4.79),('8348','2014-04-18','14:00:00',8),('8348','2014-04-18','14:05:00',4.72),('8348','2014-04-18','14:10:00',3.42),('8348','2014-04-18','14:15:00',4.06),('8348','2014-04-18','14:20:00',3.48),('8348','2014-04-18','14:25:00',4.16),('8348','2014-04-18','14:30:00',6.21),('8348','2014-04-18','14:35:00',6.07),('8348','2014-04-18','14:40:00',5.73),('8348','2014-04-18','14:45:00',4.23),('8348','2014-04-18','14:50:00',4.92),('8348','2014-04-18','14:55:00',5.21),('8348','2014-04-18','15:00:00',4.38),('8348','2014-04-18','15:05:00',3.46),('8348','2014-04-18','15:10:00',2.71),('8348','2014-04-18','15:15:00',2.35),('8348','2014-04-18','15:20:00',2.51),('8348','2014-04-18','15:25:00',3.93),('8348','2014-04-18','15:30:00',4.23),('8348','2014-04-18','15:35:00',4.66),('8348','2014-04-18','15:40:00',5.92),('8348','2014-04-18','15:45:00',5.4),('8348','2014-04-18','15:50:00',5.4),('8348','2014-04-18','15:55:00',4.6),('8348','2014-04-18','16:00:00',5.03),('8348','2014-04-18','16:05:00',5.36),('8348','2014-04-18','16:10:00',4.77),('8348','2014-04-18','16:15:00',3.92),('8348','2014-04-18','16:20:00',4.15),('8348','2014-04-18','16:25:00',4.15),('8348','2014-04-18','16:30:00',3.87),('8348','2014-04-18','16:35:00',3.69),('8348','2014-04-18','16:40:00',3.53),('8348','2014-04-18','16:45:00',3.35),('8348','2014-04-18','16:50:00',3.26),('8348','2014-04-18','16:55:00',3.12),('8348','2014-04-18','17:00:00',2.99),('8348','2014-04-18','17:05:00',2.7),('8348','2014-04-18','17:10:00',2.51),('8348','2014-04-18','17:15:00',2.31),('8348','2014-04-18','17:20:00',2.14),('8348','2014-04-18','17:25:00',1.89),('8348','2014-04-18','17:30:00',1.42),('8348','2014-04-18','17:35:00',1.59),('8348','2014-04-18','17:40:00',1.42),('8348','2014-04-18','17:45:00',1.36),('8348','2014-04-18','17:50:00',1.17),('8348','2014-04-18','17:55:00',1.03),('8348','2013-11-07','08:55:00',1.06),('8348','2013-11-07','09:00:00',1.12),('8348','2013-11-07','09:05:00',1.18),('8348','2013-11-07','09:10:00',1.25),('8348','2013-11-07','09:15:00',1.32),('8348','2013-11-07','09:20:00',1.38),('8348','2013-11-07','09:25:00',1.43),('8348','2013-11-07','09:30:00',1.49),('8348','2013-11-07','09:35:00',1.53),('8348','2013-11-07','09:40:00',1.57),('8348','2013-11-07','09:45:00',1.62),('8348','2013-11-07','09:50:00',1.67),('8348','2013-11-07','09:55:00',1.7),('8348','2013-11-07','10:00:00',1.73),('8348','2013-11-07','10:05:00',1.77),('8348','2013-11-07','10:10:00',1.8),('8348','2013-11-07','10:15:00',1.83),('8348','2013-11-07','10:20:00',1.86),('8348','2013-11-07','10:25:00',1.89),('8348','2013-11-07','10:30:00',1.92),('8348','2013-11-07','10:35:00',1.95),('8348','2013-11-07','10:40:00',1.97),('8348','2013-11-07','10:45:00',1.99),('8348','2013-11-07','10:50:00',2.01),('8348','2013-11-07','10:55:00',2.01),('8348','2013-11-07','11:00:00',2.03),('8348','2013-11-07','11:05:00',2.06),('8348','2013-11-07','11:10:00',2.07),('8348','2013-11-07','11:15:00',2.09),('8348','2013-11-07','11:20:00',2.09),('8348','2013-11-07','11:25:00',2.09),('8348','2013-11-07','11:30:00',2.11),('8348','2013-11-07','11:35:00',2.13),('8348','2013-11-07','11:40:00',2.12),('8348','2013-11-07','11:45:00',2.16),('8348','2013-11-07','11:50:00',2.17),('8348','2013-11-07','11:55:00',2.14),('8348','2013-11-07','12:00:00',2.15),('8348','2013-11-07','12:05:00',2.12),('8348','2013-11-07','12:10:00',2.12),('8348','2013-11-07','12:15:00',2.14),('8348','2013-11-07','12:20:00',2.15),('8348','2013-11-07','12:25:00',2.14),('8348','2013-11-07','12:30:00',2.15),('8348','2013-11-07','12:35:00',2.18),('8348','2013-11-07','12:40:00',2.13),('8348','2013-11-07','12:45:00',2.13),('8348','2013-11-07','12:50:00',2.12),('8348','2013-11-07','12:55:00',2.18),('8348','2013-11-07','13:00:00',2.19),('8348','2013-11-07','13:05:00',1.27),('8348','2013-11-07','13:10:00',1.26),('8348','2013-11-07','13:15:00',1.45),('8348','2013-11-07','13:30:00',1.88),('8348','2013-11-07','13:35:00',2.27),('8348','2013-11-07','13:40:00',2.23),('8348','2013-11-07','13:45:00',1.13),('8348','2013-11-07','13:50:00',2.23),('8348','2013-11-07','13:55:00',1.47),('8348','2013-11-07','14:00:00',1.38),('8348','2013-11-07','14:05:00',1.12),('8348','2013-11-07','14:10:00',1.11),('8348','2013-11-07','14:15:00',1.28),('8348','2013-11-07','14:25:00',1.67),('8348','2013-11-07','14:30:00',1.52),('8348','2013-11-07','14:35:00',1.4),('8348','2013-11-07','14:40:00',1.59),('8348','2013-11-07','14:45:00',1.49),('8348','2013-11-07','14:50:00',1.44),('8348','2013-11-07','14:55:00',1.39),('8348','2013-11-07','15:00:00',1.32),('8348','2013-11-07','15:05:00',1.27),('8348','2013-11-07','15:10:00',1.19),('8348','2013-11-07','15:15:00',1.13),('8348','2013-11-07','15:20:00',1.05),('8348','2013-11-06','08:50:00',1.08),('8348','2013-11-06','08:55:00',1.08),('8348','2013-11-06','09:15:00',1.13),('8348','2013-11-06','09:20:00',1.27),('8348','2013-11-06','09:25:00',1.46),('8348','2013-11-06','09:30:00',1.54),('8348','2013-11-06','09:35:00',1.6),('8348','2013-11-06','09:40:00',1.64),('8348','2013-11-06','09:45:00',1.69),('8348','2013-11-06','09:50:00',1.73),('8348','2013-11-06','09:55:00',1.78),('8348','2013-11-06','10:00:00',1.82),('8348','2013-11-06','10:05:00',1.86),('8348','2013-11-06','10:10:00',1.9),('8348','2013-11-06','10:15:00',1.94),('8348','2013-11-06','10:20:00',1.99),('8348','2013-11-06','10:25:00',2.02),('8348','2013-11-06','10:30:00',2.05),('8348','2013-11-06','10:35:00',2.08),('8348','2013-11-06','10:40:00',2.09),('8348','2013-11-06','10:45:00',2.11),('8348','2013-11-06','10:50:00',2.14),('8348','2013-11-06','10:55:00',2.18),('8348','2013-11-06','11:00:00',2.2),('8348','2013-11-06','11:05:00',2.21),('8348','2013-11-06','11:10:00',2.23),('8348','2013-11-06','11:15:00',2.25),('8348','2013-11-06','11:20:00',2.26),('8348','2013-11-06','11:25:00',2.29),('8348','2013-11-06','11:30:00',2.29),('8348','2013-11-06','11:35:00',2.3),('8348','2013-11-06','11:40:00',2.31),('8348','2013-11-06','11:45:00',2.32),('8348','2013-11-06','11:50:00',2.32),('8348','2013-11-06','11:55:00',2.33),('8348','2013-11-06','12:00:00',2.35),('8348','2013-11-06','12:05:00',2.35),('8348','2013-11-06','12:10:00',2.33),('8348','2013-11-06','12:15:00',2.33),('8348','2013-11-06','12:20:00',2.33),('8348','2013-11-06','12:25:00',2.33),('8348','2013-11-06','12:30:00',2.33),('8348','2013-11-06','12:35:00',2.31),('8348','2013-11-06','12:40:00',2.31),('8348','2013-11-06','12:45:00',2.31),('8348','2013-11-06','12:50:00',2.29),('8348','2013-11-06','12:55:00',2.28),('8348','2013-11-06','13:00:00',2.27),('8348','2013-11-06','13:05:00',2.24),('8348','2013-11-06','13:10:00',2.22),('8348','2013-11-06','13:15:00',2.2),('8348','2013-11-06','13:20:00',2.18),('8348','2013-11-06','13:25:00',2.15),('8348','2013-11-06','13:30:00',2.12),('8348','2013-11-06','13:35:00',2.09),('8348','2013-11-06','13:40:00',2.05),('8348','2013-11-06','13:45:00',2.01),('8348','2013-11-06','13:50:00',2),('8348','2013-11-06','13:55:00',1.96),('8348','2013-11-06','14:00:00',1.92),('8348','2013-11-06','14:05:00',1.88),('8348','2013-11-06','14:10:00',1.86),('8348','2013-11-06','14:15:00',1.82),('8348','2013-11-06','14:20:00',1.78),('8348','2013-11-06','14:25:00',1.73),('8348','2013-11-06','14:30:00',1.68),('8348','2013-11-06','14:35:00',1.64),('8348','2013-11-06','14:40:00',1.59),('8348','2013-11-06','14:45:00',1.52),('8348','2013-11-06','14:50:00',1.46),('8348','2013-11-06','14:55:00',1.4),('8348','2013-11-06','15:00:00',1.34),('8348','2013-11-06','15:05:00',1.29),('8348','2013-11-06','15:10:00',1.23),('8348','2013-11-06','15:15:00',1.18),('8348','2013-11-06','15:20:00',1.11),('8348','2013-11-06','15:25:00',1.04),('8348','2013-11-05','08:30:00',1.01),('8348','2013-11-05','08:35:00',1.15),('8348','2013-11-05','08:40:00',1.18),('8348','2013-11-05','10:20:00',1.32),('8348','2013-11-05','10:25:00',1.79),('8348','2013-11-05','10:30:00',1.41),('8348','2013-11-05','10:35:00',1.97),('8348','2013-11-05','10:40:00',1.58),('8348','2013-11-05','10:45:00',1.56),('8348','2013-11-05','10:50:00',1.32),('8348','2013-11-05','10:55:00',1.14),('8348','2013-11-05','11:40:00',1.31),('8348','2013-11-05','11:45:00',1.29),('8348','2013-11-05','11:50:00',1.2),('8348','2013-11-05','11:55:00',1.05),('8348','2013-11-05','12:10:00',1.33),('8348','2013-11-05','12:15:00',1.31),('8348','2013-11-05','12:20:00',1.66),('8348','2013-11-05','12:25:00',1.43),('8348','2013-11-05','12:30:00',1.16),('8348','2013-11-05','13:30:00',1.02),('8348','2013-11-05','13:35:00',2.06),('8348','2013-11-05','13:40:00',2.24),('8348','2013-11-05','13:45:00',2.02),('8348','2013-11-05','13:50:00',1.22),('8348','2013-11-05','13:55:00',1.39),('8348','2013-11-05','14:00:00',1.29),('8348','2013-11-05','14:05:00',2.5),('8348','2013-11-05','14:10:00',2.41),('8348','2013-11-05','14:15:00',1.36),('8348','2013-11-05','14:30:00',1.55),('8348','2013-11-05','14:35:00',1.53),('8348','2013-11-04','09:10:00',1.4),('8348','2013-11-04','09:15:00',1.69),('8348','2013-11-04','09:20:00',1.76),('8348','2013-11-04','09:25:00',2.09),('8348','2013-11-04','09:30:00',1.1),('8348','2013-11-04','10:00:00',1.22),('8348','2013-11-04','10:05:00',1.99),('8348','2013-11-04','10:10:00',2.02),('8348','2013-11-04','10:15:00',2.1),('8348','2013-11-04','10:20:00',2.15),('8348','2013-11-04','10:25:00',2.42),('8348','2013-11-04','10:30:00',2.6),('8348','2013-11-04','10:35:00',1.97),('8348','2013-11-04','10:40:00',2.63),('8348','2013-11-04','10:45:00',1.95),('8348','2013-11-04','10:50:00',1.81),('8348','2013-11-04','10:55:00',2.24),('8348','2013-11-04','11:00:00',1.9),('8348','2013-11-04','11:05:00',2.77),('8348','2013-11-04','11:10:00',1.05),('8348','2013-11-04','11:15:00',1.74),('8348','2013-11-04','11:20:00',1.05),('8348','2013-11-04','11:30:00',2.07),('8348','2013-11-04','11:35:00',2.24),('8348','2013-11-04','11:40:00',1.78),('8348','2013-11-04','11:45:00',2.34),('8348','2013-11-04','11:50:00',3.23),('8348','2013-11-04','11:55:00',2.86),('8348','2013-11-04','12:00:00',2.82),('8348','2013-11-04','12:05:00',2.64),('8348','2013-11-04','12:10:00',2.58),('8348','2013-11-04','12:15:00',2.54),('8348','2013-11-04','12:20:00',2.27),('8348','2013-11-04','12:25:00',2.52),('8348','2013-11-04','12:30:00',2.5),('8348','2013-11-04','12:35:00',2.52),('8348','2013-11-04','12:40:00',2.5),('8348','2013-11-04','12:45:00',2.48),('8348','2013-11-04','12:50:00',2.44),('8348','2013-11-04','12:55:00',2.4),('8348','2013-11-04','13:00:00',2.4),('8348','2013-11-04','13:05:00',2.4),('8348','2013-11-04','13:10:00',2.37),('8348','2013-11-04','13:15:00',2.31),('8348','2013-11-04','13:20:00',1.99),('8348','2013-11-04','13:25:00',2.36),('8348','2013-11-04','13:30:00',2.3),('8348','2013-11-04','13:35:00',2.24),('8348','2013-11-04','13:40:00',1.91),('8348','2013-11-04','13:45:00',2.31),('8348','2013-11-04','13:50:00',2.23),('8348','2013-11-04','13:55:00',1.76),('8348','2013-11-04','14:00:00',1),('8348','2013-11-04','14:05:00',1.75),('8348','2013-11-04','14:10:00',2.14),('8348','2013-11-04','14:15:00',1.85),('8348','2013-11-04','14:20:00',1.89),('8348','2013-11-04','14:25:00',1.15),('8348','2013-11-04','14:35:00',2.04),('8348','2013-11-04','14:40:00',1.75),('8348','2013-11-04','14:45:00',1.74),('8348','2013-11-04','14:50:00',1.67),('8348','2013-11-04','14:55:00',1.45),('8348','2013-11-04','15:00:00',1.51),('8348','2013-11-04','15:10:00',1.11),('8348','2013-11-04','15:15:00',1.21),('8348','2013-11-04','15:20:00',1.15),('8348','2013-11-04','15:25:00',1.14),('8348','2013-11-04','15:35:00',1.05),('8348','2013-11-03','08:55:00',1.01),('8348','2013-11-03','09:40:00',1.95),('8348','2013-11-03','09:45:00',1.23),('8348','2013-11-03','10:10:00',1.33),('8348','2013-11-03','10:20:00',2.06),('8348','2013-11-03','10:25:00',1.71),('8348','2013-11-03','10:30:00',2.1),('8348','2013-11-03','10:35:00',1.49),('8348','2013-11-03','11:20:00',1.52),('8348','2013-11-03','11:25:00',1.58),('8348','2013-11-03','11:30:00',1.68),('8348','2013-11-03','11:35:00',2.31),('8348','2013-11-03','11:40:00',2.67),('8348','2013-11-03','11:45:00',2.79),('8348','2013-11-03','11:50:00',2.8),('8348','2013-11-03','11:55:00',1.9),('8348','2013-11-03','12:00:00',1.86),('8348','2013-11-03','12:05:00',2.46),('8348','2013-11-03','12:10:00',2),('8348','2013-11-03','12:15:00',1.41),('8348','2013-11-03','12:25:00',1.29),('8348','2013-11-03','12:30:00',1.08),('8348','2013-11-03','12:40:00',1.24),('8348','2013-11-03','12:45:00',1.01),('8348','2013-11-03','12:50:00',1),('8348','2013-11-03','13:40:00',1.13),('8348','2013-11-03','13:45:00',1.54),('8348','2013-11-03','13:55:00',1.19),('8348','2013-11-03','14:00:00',1.02),('8348','2013-11-03','14:05:00',1.69),('8348','2013-11-03','14:10:00',1.91),('8348','2013-11-03','14:15:00',2.1),('8348','2013-11-03','14:20:00',1.67),('8348','2013-11-03','14:25:00',1.7),('8348','2013-11-03','14:30:00',1.08),('8348','2013-11-03','14:35:00',1.4),('8348','2013-11-03','14:40:00',1.77),('8348','2013-11-03','14:45:00',1.5),('8348','2013-11-03','14:50:00',1.15),('8348','2013-11-03','15:05:00',1.01),('8348','2013-11-02','08:50:00',1.01),('8348','2013-11-02','08:55:00',1.07),('8348','2013-11-02','09:00:00',1.16),('8348','2013-11-02','09:05:00',1.3),('8348','2013-11-02','09:10:00',1.4),('8348','2013-11-02','09:20:00',1.35),('8348','2013-11-02','09:25:00',1.53),('8348','2013-11-02','09:30:00',1.53),('8348','2013-11-02','09:35:00',1.54),('8348','2013-11-02','09:40:00',1.55),('8348','2013-11-02','09:45:00',1.46),('8348','2013-11-02','09:50:00',1.9),('8348','2013-11-02','09:55:00',1.85),('8348','2013-11-02','10:00:00',2.09),('8348','2013-11-02','10:05:00',1.8),('8348','2013-11-02','10:10:00',1.07),('8348','2013-11-02','11:00:00',1.05),('8348','2013-11-02','11:05:00',1.25),('8348','2013-11-02','11:10:00',1.14),('8348','2013-11-02','11:55:00',1.59),('8348','2013-11-02','12:00:00',2.9),('8348','2013-11-02','12:05:00',2.81),('8348','2013-11-02','12:10:00',2.67),('8348','2013-11-02','12:15:00',2.55),('8348','2013-11-02','12:20:00',2.92),('8348','2013-11-02','12:25:00',2.69),('8348','2013-11-02','12:30:00',3.18),('8348','2013-11-02','12:35:00',2.92),('8348','2013-11-02','12:40:00',2.53),('8348','2013-11-02','12:45:00',1.77),('8348','2013-11-02','12:50:00',2.5),('8348','2013-11-02','12:55:00',2.57),('8348','2013-11-02','13:00:00',1.88),('8348','2013-11-02','13:05:00',2.47),('8348','2013-11-02','13:10:00',3.01),('8348','2013-11-02','13:15:00',1.3),('8348','2013-11-02','13:35:00',1.98),('8348','2013-11-02','13:40:00',2.75),('8348','2013-11-02','13:45:00',2.53),('8348','2013-11-02','13:50:00',2.84),('8348','2013-11-02','13:55:00',2.69),('8348','2013-11-02','14:00:00',2.45),('8348','2013-11-02','14:05:00',2.14),('8348','2013-11-02','14:10:00',1.98),('8348','2013-11-02','14:15:00',1.89),('8348','2013-11-02','14:20:00',1.84),('8348','2013-11-02','14:25:00',1.78),('8348','2013-11-02','14:30:00',1.74),('8348','2013-11-02','14:35:00',1.67),('8348','2013-11-02','14:40:00',1.62),('8348','2013-11-02','14:45:00',1.55),('8348','2013-11-02','14:50:00',1.54),('8348','2013-11-02','14:55:00',1.2),('8348','2013-11-02','15:00:00',1.25),('8348','2013-11-01','09:00:00',1.08),('8348','2013-11-01','09:05:00',1.22),('8348','2013-11-01','09:10:00',1.31),('8348','2013-11-01','09:15:00',1.36),('8348','2013-11-01','09:20:00',1.41),('8348','2013-11-01','09:25:00',1.47),('8348','2013-11-01','09:30:00',1.51),('8348','2013-11-01','09:35:00',1.56),('8348','2013-11-01','09:40:00',1.62),('8348','2013-11-01','09:45:00',1.67),('8348','2013-11-01','09:50:00',1.73),('8348','2013-11-01','09:55:00',1.77),('8348','2013-11-01','10:00:00',1.82),('8348','2013-11-01','10:05:00',1.86),('8348','2013-11-01','10:10:00',1.9),('8348','2013-11-01','10:15:00',1.93),('8348','2013-11-01','10:20:00',1.97),('8348','2013-11-01','10:25:00',2.01),('8348','2013-11-01','10:30:00',1.98),('8348','2013-11-01','10:35:00',2.01),('8348','2013-11-01','10:40:00',2.07),('8348','2013-11-01','10:45:00',2.04),('8348','2013-11-01','10:50:00',2.06),('8348','2013-11-01','10:55:00',2.05),('8348','2013-11-01','11:00:00',2.14),('8348','2013-11-01','11:05:00',1.94),('8348','2013-11-01','11:10:00',1.77),('8348','2013-11-01','11:15:00',1.83),('8348','2013-11-01','11:20:00',2.25),('8348','2013-11-01','11:25:00',2.37),('8348','2013-11-01','11:30:00',2.38),('8348','2013-11-01','11:35:00',2.26),('8348','2013-11-01','11:40:00',2.05),('8348','2013-11-01','11:45:00',2.18),('8348','2013-11-01','11:50:00',2.43),('8348','2013-11-01','11:55:00',2.47),('8348','2013-11-01','12:00:00',2.43),('8348','2013-11-01','12:05:00',2.33),('8348','2013-11-01','12:10:00',2.22),('8348','2013-11-01','12:15:00',2.11),('8348','2013-11-01','12:20:00',2.1),('8348','2013-11-01','12:25:00',2.13),('8348','2013-11-01','12:30:00',1.94),('8348','2013-11-01','12:35:00',1.05),('8348','2013-11-01','13:20:00',1.13),('8348','2013-11-01','13:35:00',1.09),('8348','2013-11-01','13:40:00',1.11),('8348','2013-10-31','08:40:00',1.07),('8348','2013-10-31','08:45:00',1.09),('8348','2013-10-31','08:50:00',1.16),('8348','2013-10-31','08:55:00',1.13),('8348','2013-10-31','09:00:00',1.13),('8348','2013-10-31','09:05:00',1.07),('8348','2013-10-31','09:20:00',1.2),('8348','2013-10-31','09:30:00',1.08),('8348','2013-10-31','09:35:00',1.38),('8348','2013-10-31','09:40:00',1.33),('8348','2013-10-31','09:45:00',1.33),('8348','2013-10-31','09:50:00',1.35),('8348','2013-10-31','09:55:00',1.36),('8348','2013-10-31','10:00:00',1.42),('8348','2013-10-31','10:05:00',1.41),('8348','2013-10-31','10:10:00',1.27),('8348','2013-10-31','10:15:00',1.24),('8348','2013-10-31','10:20:00',1.19),('8348','2013-10-31','10:25:00',1.29),('8348','2013-10-31','10:30:00',1.3),('8348','2013-10-31','10:35:00',1.45),('8348','2013-10-31','10:40:00',1.54),('8348','2013-10-31','10:45:00',1.42),('8348','2013-10-31','10:50:00',1.42),('8348','2013-10-31','10:55:00',1.56),('8348','2013-10-31','11:00:00',1.9),('8348','2013-10-31','11:05:00',2.18),('8348','2013-10-31','11:10:00',2.03),('8348','2013-10-31','11:15:00',1.8),('8348','2013-10-31','11:20:00',2.18),('8348','2013-10-31','11:25:00',1.95),('8348','2013-10-31','11:30:00',2.09),('8348','2013-10-31','11:35:00',2.01),('8348','2013-10-31','11:40:00',2.18),('8348','2013-10-31','11:45:00',2.32),('8348','2013-10-31','11:50:00',2.29),('8348','2013-10-31','11:55:00',2.29),('8348','2013-10-31','12:00:00',2.26),('8348','2013-10-31','12:05:00',2.17),('8348','2013-10-31','12:10:00',2.28),('8348','2013-10-31','12:15:00',2.28),('8348','2013-10-31','12:20:00',2.23),('8348','2013-10-31','12:25:00',2.24),('8348','2013-10-31','12:30:00',2.18),('8348','2013-10-31','12:35:00',2.12),('8348','2013-10-31','12:40:00',2.2),('8348','2013-10-31','12:45:00',2.24),('8348','2013-10-31','12:50:00',2.32),('8348','2013-10-31','12:55:00',2.34),('8348','2013-10-31','13:00:00',2.29),('8348','2013-10-31','13:05:00',2.23),('8348','2013-10-31','13:10:00',2.17),('8348','2013-10-31','13:15:00',2.17),('8348','2013-10-31','13:20:00',2.16),('8348','2013-10-31','13:25:00',2.13),('8348','2013-10-31','13:30:00',2.1),('8348','2013-10-31','13:35:00',2.06),('8348','2013-10-31','13:40:00',1.95),('8348','2013-10-31','13:45:00',1.93),('8348','2013-10-31','13:50:00',1.52),('8348','2013-10-31','13:55:00',1.27),('8348','2013-10-31','14:00:00',1.83),('8348','2013-10-31','14:05:00',1.78),('8348','2013-10-31','14:10:00',1.69),('8348','2013-10-31','14:15:00',1.48),('8348','2013-10-31','14:20:00',1.01),('8348','2013-10-31','14:25:00',1.49),('8348','2013-10-31','14:30:00',1.15),('8348','2013-10-31','15:00:00',1.03),('8348','2013-10-30','08:45:00',1.01),('8348','2013-10-30','08:50:00',1.05),('8348','2013-10-30','08:55:00',1.02),('8348','2013-10-30','09:00:00',1.1),('8348','2013-10-30','09:05:00',1.2),('8348','2013-10-30','09:10:00',1.32),('8348','2013-10-30','09:15:00',1.38),('8348','2013-10-30','09:20:00',1.43),('8348','2013-10-30','09:25:00',1.47),('8348','2013-10-30','09:30:00',1.51),('8348','2013-10-30','09:35:00',1.55),('8348','2013-10-30','09:40:00',1.62),('8348','2013-10-30','09:45:00',1.66),('8348','2013-10-30','09:50:00',1.71),('8348','2013-10-30','09:55:00',1.66),('8348','2013-10-30','10:00:00',1.52),('8348','2013-10-30','10:05:00',1.56),('8348','2013-10-30','10:10:00',1.8),('8348','2013-10-30','10:15:00',2),('8348','2013-10-30','10:20:00',1.95),('8348','2013-10-30','10:25:00',1.88),('8348','2013-10-30','10:30:00',1.9),('8348','2013-10-30','10:35:00',1.9),('8348','2013-10-30','10:40:00',1.99),('8348','2013-10-30','10:45:00',2.17),('8348','2013-10-30','10:50:00',1.38),('8348','2013-10-30','10:55:00',1.03),('8348','2013-10-30','11:00:00',2.14),('8348','2013-10-30','11:05:00',1.98),('8348','2013-10-30','11:10:00',2.23),('8348','2013-10-30','11:15:00',2.28),('8348','2013-10-30','11:20:00',1.71),('8348','2013-10-30','11:25:00',1.1),('8348','2013-10-30','11:30:00',1),('8348','2013-10-30','11:45:00',1.07),('8348','2013-10-30','11:50:00',1.53),('8348','2013-10-30','12:10:00',1.01),('8348','2013-10-30','12:15:00',1.37),('8348','2013-10-30','12:20:00',1.96),('8348','2013-10-30','12:25:00',2.64),('8348','2013-10-30','12:30:00',1.51),('8348','2013-10-30','12:35:00',1.25),('8348','2013-10-30','12:40:00',1.13),('8348','2013-10-30','12:45:00',1.85),('8348','2013-10-30','12:50:00',1.72),('8348','2013-10-30','12:55:00',2.29),('8348','2013-10-30','13:00:00',1.1),('8348','2013-10-30','13:05:00',1.16),('8348','2013-10-30','13:10:00',1.35),('8348','2013-10-30','13:15:00',2),('8348','2013-10-30','13:20:00',2),('8348','2013-10-30','13:25:00',2.14),('8348','2013-10-30','13:30:00',1.42),('8348','2013-10-30','13:40:00',1.92),('8348','2013-10-30','13:45:00',2.03),('8348','2013-10-30','13:55:00',1.21),('8348','2013-10-30','14:00:00',1.97),('8348','2013-10-30','14:05:00',2.08),('8348','2013-10-30','14:10:00',2.05),('8348','2013-10-30','14:35:00',1.12),('8348','2013-10-30','14:40:00',1.6),('8348','2013-10-30','14:45:00',1.47),('8348','2013-10-30','15:15:00',1.11),('8348','2013-10-30','15:20:00',1.1),('8348','2013-10-29','08:45:00',1.07),('8348','2013-10-29','08:50:00',1.07),('8348','2013-10-29','08:55:00',1.13),('8348','2013-10-29','09:00:00',1.21),('8348','2013-10-29','09:05:00',1.28),('8348','2013-10-29','09:10:00',1.34),('8348','2013-10-29','09:15:00',1.41),('8348','2013-10-29','09:20:00',1.46),('8348','2013-10-29','09:25:00',1.53),('8348','2013-10-29','09:30:00',1.59),('8348','2013-10-29','09:35:00',1.62),('8348','2013-10-29','09:40:00',1.68),('8348','2013-10-29','09:45:00',1.7),('8348','2013-10-29','09:50:00',1.72),('8348','2013-10-29','09:55:00',1.68),('8348','2013-10-29','10:05:00',1.29),('8348','2013-10-29','10:10:00',1.04),('8348','2013-10-29','10:15:00',1.19),('8348','2013-10-29','10:25:00',1.56),('8348','2013-10-29','10:30:00',2.14),('8348','2013-10-29','10:35:00',2.37),('8348','2013-10-29','10:40:00',2.43),('8348','2013-10-29','10:45:00',2.49),('8348','2013-10-29','10:50:00',2.51),('8348','2013-10-29','10:55:00',2.5),('8348','2013-10-29','11:00:00',2.52),('8348','2013-10-29','11:05:00',2.36),('8348','2013-10-29','11:10:00',1.28),('8348','2013-10-29','11:20:00',1.09),('8348','2013-10-29','11:25:00',2.47),('8348','2013-10-29','11:30:00',2.45),('8348','2013-10-29','11:35:00',2.49),('8348','2013-10-29','11:40:00',2.45),('8348','2013-10-29','11:45:00',2.49),('8348','2013-10-29','11:50:00',2.5),('8348','2013-10-29','11:55:00',2.39),('8348','2013-10-29','12:00:00',2.34),('8348','2013-10-29','12:05:00',2.25),('8348','2013-10-29','12:10:00',2.32),('8348','2013-10-29','12:15:00',2.29),('8348','2013-10-29','12:20:00',2.27),('8348','2013-10-29','12:25:00',2.25),('8348','2013-10-29','12:30:00',2.25),('8348','2013-10-29','12:35:00',2.25),('8348','2013-10-29','12:40:00',2.3),('8348','2013-10-29','12:45:00',2.3),('8348','2013-10-29','12:50:00',2.23),('8348','2013-10-29','12:55:00',2.22),('8348','2013-10-29','13:00:00',2.13),('8348','2013-10-29','13:05:00',2.2),('8348','2013-10-29','13:10:00',2.14),('8348','2013-10-29','13:15:00',2.13),('8348','2013-10-29','13:20:00',2.15),('8348','2013-10-29','13:25:00',2.06),('8348','2013-10-29','13:30:00',2.11),('8348','2013-10-29','13:35:00',2.11),('8348','2013-10-29','13:40:00',2.05),('8348','2013-10-29','13:45:00',1.93),('8348','2013-10-29','13:50:00',1.94),('8348','2013-10-29','13:55:00',1.84),('8348','2013-10-29','14:00:00',1.71),('8348','2013-10-29','14:05:00',1.85),('8348','2013-10-29','14:10:00',1.81),('8348','2013-10-29','14:15:00',1.8),('8348','2013-10-29','14:20:00',1.77),('8348','2013-10-29','14:25:00',1.68),('8348','2013-10-29','14:30:00',1.62),('8348','2013-10-29','14:35:00',1.56),('8348','2013-10-29','14:40:00',1.51),('8348','2013-10-29','14:45:00',1.45),('8348','2013-10-29','14:50:00',1.41),('8348','2013-10-29','14:55:00',1.33),('8348','2013-10-29','15:00:00',1.27),('8348','2013-10-29','15:05:00',1.21),('8348','2013-10-29','15:10:00',1.16),('8348','2013-10-29','15:15:00',1.13),('8348','2013-10-29','15:20:00',1.06),('8348','2014-04-17','07:00:00',1.2),('8348','2014-04-17','07:05:00',1.32),('8348','2014-04-17','07:10:00',1.49),('8348','2014-04-17','07:15:00',1.71),('8348','2014-04-17','07:20:00',1.73),('8348','2014-04-17','07:25:00',1.87),('8348','2014-04-17','07:30:00',1.98),('8348','2014-04-17','07:35:00',2.1),('8348','2014-04-17','07:40:00',2.21),('8348','2014-04-17','07:45:00',2.36),('8348','2014-04-17','07:50:00',2.51),('8348','2014-04-17','07:55:00',2.32),('8348','2014-04-17','08:00:00',2.56),('8348','2014-04-17','08:05:00',3.15),('8348','2014-04-17','08:10:00',3.53),('8348','2014-04-17','08:15:00',3.52),('8348','2014-04-17','08:20:00',3.82),('8348','2014-04-17','08:25:00',4.1),('8348','2014-04-17','08:30:00',4.25),('8348','2014-04-17','08:35:00',4.44),('8348','2014-04-17','08:40:00',4.57),('8348','2014-04-17','08:45:00',4.71),('8348','2014-04-17','08:50:00',4.84),('8348','2014-04-17','08:55:00',5.01),('8348','2014-04-17','09:00:00',5.25),('8348','2014-04-17','09:05:00',5.75),('8348','2014-04-17','09:10:00',5.51),('8348','2014-04-17','09:15:00',4.36),('8348','2014-04-17','09:20:00',5.99),('8348','2014-04-17','09:25:00',6.33),('8348','2014-04-17','09:30:00',6.61),('8348','2014-04-17','09:35:00',7),('8348','2014-04-17','09:40:00',6.25),('8348','2014-04-17','09:45:00',5.58),('8348','2014-04-17','09:50:00',4.35),('8348','2014-04-17','09:55:00',4.02),('8348','2014-04-17','10:00:00',4.6),('8348','2014-04-17','10:05:00',5.12),('8348','2014-04-17','10:10:00',5.15),('8348','2014-04-17','10:15:00',4.37),('8348','2014-04-17','10:20:00',5.63),('8348','2014-04-17','10:25:00',6.45),('8348','2014-04-17','10:30:00',4.26),('8348','2014-04-17','10:35:00',4.21),('8348','2014-04-17','10:40:00',4.49),('8348','2014-04-17','10:45:00',6.52),('8348','2014-04-17','10:50:00',4.8),('8348','2014-04-17','10:55:00',3.76),('8348','2014-04-17','11:00:00',4.76),('8348','2014-04-17','11:05:00',5.12),('8348','2014-04-17','11:10:00',4.74),('8348','2014-04-17','11:15:00',4.1),('8348','2014-04-17','11:20:00',4.14),('8348','2014-04-17','11:25:00',4.48),('8348','2014-04-17','11:30:00',5.7),('8348','2014-04-17','11:35:00',6.42),('8348','2014-04-17','11:40:00',7.41),('8348','2014-04-17','11:45:00',7.09),('8348','2014-04-17','11:50:00',6.84),('8348','2014-04-17','11:55:00',7.6),('8348','2014-04-17','12:00:00',7.23),('8348','2014-04-17','12:05:00',3.92),('8348','2014-04-17','12:10:00',1.61),('8348','2014-04-17','12:15:00',1.65),('8348','2014-04-17','12:20:00',4.94),('8348','2014-04-17','12:25:00',8.19),('8348','2014-04-17','12:30:00',7.46),('8348','2014-04-17','12:35:00',2.26),('8348','2014-04-17','12:40:00',1.63),('8348','2014-04-17','12:45:00',1.72),('8348','2014-04-17','12:50:00',2.19),('8348','2014-04-17','12:55:00',2.72),('8348','2014-04-17','13:00:00',1.89),('8348','2014-04-17','13:05:00',2.1),('8348','2014-04-17','13:10:00',5.13),('8348','2014-04-17','13:15:00',5.26),('8348','2014-04-17','13:20:00',2.88),('8348','2014-04-17','13:25:00',3.58),('8348','2014-04-17','13:30:00',3.18),('8348','2014-04-17','13:35:00',4.12),('8348','2014-04-17','13:40:00',6.34),('8348','2014-04-17','13:45:00',2.28),('8348','2014-04-17','13:50:00',1.44),('8348','2014-04-17','13:55:00',1.3),('8348','2014-04-17','14:00:00',1.42),('8348','2014-04-17','14:05:00',1.55),('8348','2014-04-17','14:10:00',1.46),('8348','2014-04-17','14:15:00',1.47),('8348','2014-04-17','14:20:00',1.72),('8348','2014-04-17','14:25:00',2.29),('8348','2014-04-17','14:30:00',3.46),('8348','2014-04-17','14:35:00',4.21),('8348','2014-04-17','14:40:00',3.08),('8348','2014-04-17','14:45:00',2.29),('8348','2014-04-17','14:50:00',2.21),('8348','2014-04-17','14:55:00',2.51),('8348','2014-04-17','15:00:00',2.03),('8348','2014-04-17','15:05:00',1.65),('8348','2014-04-17','15:10:00',1.88),('8348','2014-04-17','15:15:00',1.89),('8348','2014-04-17','15:20:00',1.85),('8348','2014-04-17','15:25:00',2.1),('8348','2014-04-17','15:30:00',2.12),('8348','2014-04-17','15:35:00',1.95),('8348','2014-04-17','15:40:00',2.28),('8348','2014-04-17','15:45:00',2.87),('8348','2014-04-17','15:50:00',2.8),('8348','2014-04-17','15:55:00',2.15),('8348','2014-04-17','16:00:00',1.83),('8348','2014-04-17','16:05:00',1.54),('8348','2014-04-17','16:10:00',1.55),('8348','2014-04-17','16:15:00',1.78),('8348','2014-04-17','16:20:00',2),('8348','2014-04-17','16:25:00',1.72),('8348','2014-04-17','16:30:00',1.8),('8348','2014-04-17','16:35:00',1.89),('8348','2014-04-17','16:40:00',1.81),('8348','2014-04-17','16:45:00',1.61),('8348','2014-04-17','16:50:00',1.29),('8348','2014-04-17','16:55:00',1.23),('8348','2013-10-28','08:50:00',1.03),('8348','2013-10-28','08:55:00',1.13),('8348','2013-10-28','09:00:00',1.3),('8348','2013-10-28','09:05:00',1.52),('8348','2013-10-28','09:10:00',1.6),('8348','2013-10-28','09:15:00',1.2),('8348','2013-10-28','09:20:00',1.02),('8348','2013-10-28','09:25:00',1.75),('8348','2013-10-28','09:30:00',1.79),('8348','2013-10-28','09:35:00',1.04),('8348','2013-10-28','09:40:00',1.45),('8348','2013-10-28','09:45:00',1.81),('8348','2013-10-28','09:50:00',1.74),('8348','2013-10-28','10:50:00',2.25),('8348','2013-10-28','10:55:00',2.25),('8348','2013-10-28','11:00:00',2.29),('8348','2013-10-28','11:05:00',2.3),('8348','2013-10-28','11:10:00',2.33),('8348','2013-10-28','11:15:00',2.33),('8348','2013-10-28','11:20:00',2.35),('8348','2013-10-28','11:25:00',2.37),('8348','2013-10-28','11:30:00',2.37),('8348','2013-10-28','11:35:00',2.37),('8348','2013-10-28','11:40:00',2.37),('8348','2013-10-28','11:45:00',2.39),('8348','2013-10-28','11:50:00',2.4),('8348','2013-10-28','11:55:00',2.35),('8348','2013-10-28','12:00:00',2.09),('8348','2013-10-28','12:05:00',2.34),('8348','2013-10-28','12:10:00',2.21),('8348','2013-10-28','12:15:00',2.52),('8348','2013-10-28','12:20:00',2.6),('8348','2013-10-28','12:25:00',2.31),('8348','2013-10-28','12:30:00',2.59),('8348','2013-10-28','12:35:00',2.89),('8348','2013-10-28','12:40:00',2.6),('8348','2013-10-28','12:45:00',2.65),('8348','2013-10-28','12:50:00',2.66),('8348','2013-10-28','12:55:00',2.48),('8348','2013-10-28','13:00:00',2.4),('8348','2013-10-28','13:05:00',2.38),('8348','2013-10-28','13:10:00',2.38),('8348','2013-10-28','13:15:00',2.34),('8348','2013-10-28','13:20:00',2.29),('8348','2013-10-28','13:25:00',2.29),('8348','2013-10-28','13:30:00',2.25),('8348','2013-10-28','13:35:00',2.18),('8348','2013-10-28','13:40:00',2.14),('8348','2013-10-28','13:45:00',2.09),('8348','2013-10-28','13:50:00',2.16),('8348','2013-10-28','13:55:00',2.13),('8348','2013-10-28','14:00:00',2.17),('8348','2013-10-28','14:05:00',2.12),('8348','2013-10-28','14:10:00',2.11),('8348','2013-10-28','14:15:00',2.03),('8348','2013-10-28','14:20:00',1.88),('8348','2013-10-28','14:25:00',2.07),('8348','2013-10-28','14:30:00',1.63),('8348','2013-10-28','14:35:00',1.83),('8348','2013-10-28','14:40:00',1.19),('8348','2013-10-28','14:45:00',1.73),('8348','2013-10-28','14:50:00',1.57),('8348','2013-10-28','14:55:00',1.51),('8348','2013-10-28','15:00:00',1.46),('8348','2013-10-28','15:05:00',1.41),('8348','2013-10-28','15:10:00',1.34),('8348','2013-10-28','15:15:00',1.22),('8348','2013-10-28','15:45:00',1.05),('8348','2013-10-27','10:10:00',1),('8348','2013-10-27','10:15:00',1.06),('8348','2013-10-27','10:20:00',1.19),('8348','2013-10-27','10:25:00',1.12),('8348','2013-10-27','10:30:00',1.1),('8348','2013-10-27','10:35:00',1.13),('8348','2013-10-27','10:40:00',1.15),('8348','2013-10-27','10:45:00',1.32),('8348','2013-10-27','10:50:00',1.29),('8348','2013-10-27','10:55:00',1.13),('8348','2013-10-27','11:00:00',1.09),('8348','2013-10-27','11:35:00',1.34),('8348','2013-10-27','11:40:00',2.06),('8348','2013-10-27','11:45:00',2.67),('8348','2013-10-27','11:50:00',1.22),('8348','2013-10-27','11:55:00',1.01),('8348','2013-10-27','12:00:00',1.03),('8348','2013-10-27','12:05:00',1.14),('8348','2013-10-27','12:15:00',1.21),('8348','2013-10-27','12:20:00',2.2),('8348','2013-10-27','12:25:00',2.1),('8348','2013-10-27','12:30:00',2.24),('8348','2013-10-27','12:35:00',2.68),('8348','2013-10-27','12:40:00',1.45),('8348','2013-10-27','12:45:00',1.74),('8348','2013-10-27','12:50:00',1.88),('8348','2013-10-27','12:55:00',2.07),('8348','2013-10-27','13:00:00',1.11),('8348','2013-10-27','13:05:00',1.13),('8348','2013-10-27','13:10:00',1.93),('8348','2013-10-27','13:25:00',2.3),('8348','2013-10-27','13:30:00',2.19),('8348','2013-10-27','13:35:00',2.19),('8348','2013-10-27','13:40:00',1.24),('8348','2013-10-27','14:00:00',1.13),('8348','2013-10-27','14:15:00',1.32),('8348','2013-10-27','14:20:00',1.01),('8348','2013-10-27','14:25:00',1.16),('8348','2013-10-27','14:30:00',1.7),('8348','2013-10-27','14:35:00',1.22),('8348','2013-10-27','14:40:00',1.39),('8348','2013-10-27','14:45:00',1.06),('8348','2013-10-27','15:00:00',1.34),('8348','2013-10-27','15:05:00',1.03),('8348','2013-10-27','15:10:00',1.31),('8348','2013-10-27','15:15:00',1.25),('8348','2013-10-27','15:20:00',1.19),('8348','2013-10-27','15:25:00',1.11),('8348','2013-10-27','15:30:00',1),('8348','2013-10-26','09:45:00',1.03),('8348','2013-10-26','09:50:00',1.1),('8348','2013-10-26','09:55:00',1.19),('8348','2013-10-26','10:00:00',1.26),('8348','2013-10-26','10:05:00',1.34),('8348','2013-10-26','10:10:00',1.4),('8348','2013-10-26','10:15:00',1.45),('8348','2013-10-26','10:20:00',1.5),('8348','2013-10-26','10:25:00',1.55),('8348','2013-10-26','10:30:00',1.6),('8348','2013-10-26','10:35:00',1.65),('8348','2013-10-26','10:40:00',1.7),('8348','2013-10-26','10:45:00',1.75),('8348','2013-10-26','10:50:00',1.8),('8348','2013-10-26','10:55:00',1.84),('8348','2013-10-26','11:00:00',1.88),('8348','2013-10-26','11:05:00',1.93),('8348','2013-10-26','11:10:00',1.95),('8348','2013-10-26','11:15:00',1.97),('8348','2013-10-26','11:20:00',1.98),('8348','2013-10-26','11:25:00',2.03),('8348','2013-10-26','11:30:00',2.07),('8348','2013-10-26','11:35:00',2.08),('8348','2013-10-26','11:40:00',2.1),('8348','2013-10-26','11:45:00',2.16),('8348','2013-10-26','11:50:00',2.17),('8348','2013-10-26','11:55:00',2.15),('8348','2013-10-26','12:00:00',2.18),('8348','2013-10-26','12:05:00',2.25),('8348','2013-10-26','12:10:00',2.27),('8348','2013-10-26','12:15:00',2.26),('8348','2013-10-26','12:20:00',2.29),('8348','2013-10-26','12:25:00',2.3),('8348','2013-10-26','12:30:00',2.29),('8348','2013-10-26','12:35:00',2.25),('8348','2013-10-26','12:40:00',2.32),('8348','2013-10-26','12:45:00',2.31),('8348','2013-10-26','12:50:00',2.29),('8348','2013-10-26','12:55:00',2.33),('8348','2013-10-26','13:00:00',2.3),('8348','2013-10-26','13:05:00',2.31),('8348','2013-10-26','13:10:00',2.08),('8348','2013-10-26','13:15:00',2.19),('8348','2013-10-26','13:20:00',2.25),('8348','2013-10-26','13:25:00',1.75),('8348','2013-10-26','13:30:00',2.33),('8348','2013-10-26','13:35:00',2.45),('8348','2013-10-26','13:40:00',2.41),('8348','2013-10-26','13:45:00',2.2),('8348','2013-10-26','13:50:00',2.23),('8348','2013-10-26','13:55:00',2.2),('8348','2013-10-26','14:00:00',2.16),('8348','2013-10-26','14:05:00',1.92),('8348','2013-10-26','14:10:00',2.15),('8348','2013-10-26','14:15:00',1.96),('8348','2013-10-26','14:20:00',1.81),('8348','2013-10-26','14:25:00',1.01),('8348','2013-10-26','14:30:00',1.59),('8348','2013-10-26','14:35:00',2.12),('8348','2013-10-26','14:40:00',1.88),('8348','2013-10-26','14:45:00',1.96),('8348','2013-10-26','14:50:00',1.9),('8348','2013-10-26','14:55:00',1.83),('8348','2013-10-26','15:00:00',1.82),('8348','2013-10-26','15:05:00',1.78),('8348','2013-10-26','15:10:00',1.76),('8348','2013-10-26','15:15:00',1.65),('8348','2013-10-26','15:20:00',1.47),('8348','2013-10-26','15:25:00',1.51),('8348','2013-10-26','15:30:00',1.52),('8348','2013-10-26','15:35:00',1.68),('8348','2013-10-26','15:40:00',1.59),('8348','2013-10-26','15:45:00',1.56),('8348','2013-10-26','15:50:00',1.44),('8348','2013-10-26','15:55:00',1.26),('8348','2013-10-26','16:00:00',1.19),('8348','2013-10-26','16:05:00',1.16),('8348','2013-10-26','16:10:00',1.16),('8348','2013-10-26','16:15:00',1.07),('8348','2013-10-26','16:20:00',1.07),('8348','2013-10-25','09:40:00',1.02),('8348','2013-10-25','09:45:00',1.08),('8348','2013-10-25','09:50:00',1.14),('8348','2013-10-25','09:55:00',1.2),('8348','2013-10-25','10:00:00',1.29),('8348','2013-10-25','10:05:00',1.36),('8348','2013-10-25','10:10:00',1.42),('8348','2013-10-25','10:15:00',1.47),('8348','2013-10-25','10:20:00',1.53),('8348','2013-10-25','10:25:00',1.6),('8348','2013-10-25','10:30:00',1.65),('8348','2013-10-25','10:35:00',1.7),('8348','2013-10-25','10:40:00',1.73),('8348','2013-10-25','10:45:00',1.77),('8348','2013-10-25','10:50:00',1.82),('8348','2013-10-25','10:55:00',1.86),('8348','2013-10-25','11:00:00',1.89),('8348','2013-10-25','11:05:00',1.94),('8348','2013-10-25','11:10:00',1.96),('8348','2013-10-25','11:15:00',1.99),('8348','2013-10-25','11:20:00',2.02),('8348','2013-10-25','11:25:00',2.04),('8348','2013-10-25','11:30:00',2.11),('8348','2013-10-25','11:35:00',2.14),('8348','2013-10-25','11:40:00',2.17),('8348','2013-10-25','11:45:00',2.2),('8348','2013-10-25','11:50:00',2.24),('8348','2013-10-25','11:55:00',2.27),('8348','2013-10-25','12:00:00',2.29),('8348','2013-10-25','12:05:00',2.3),('8348','2013-10-25','12:10:00',2.34),('8348','2013-10-25','12:15:00',2.35),('8348','2013-10-25','12:20:00',2.38),('8348','2013-10-25','12:25:00',2.4),('8348','2013-10-25','12:30:00',2.41),('8348','2013-10-25','12:35:00',2.42),('8348','2013-10-25','12:40:00',2.41),('8348','2013-10-25','12:45:00',2.4),('8348','2013-10-25','12:50:00',2.41),('8348','2013-10-25','12:55:00',2.43),('8348','2013-10-25','13:00:00',2.44),('8348','2013-10-25','13:05:00',2.43),('8348','2013-10-25','13:10:00',2.42),('8348','2013-10-25','13:15:00',2.38),('8348','2013-10-25','13:20:00',2.36),('8348','2013-10-25','13:25:00',2.34),('8348','2013-10-25','13:30:00',2.37),('8348','2013-10-25','13:35:00',2.37),('8348','2013-10-25','13:40:00',2.35),('8348','2013-10-25','13:45:00',2.33),('8348','2013-10-25','13:50:00',2.3),('8348','2013-10-25','13:55:00',2.29),('8348','2013-10-25','14:00:00',2.3),('8348','2013-10-25','14:05:00',2.3),('8348','2013-10-25','14:10:00',2.29),('8348','2013-10-25','14:15:00',2.27),('8348','2013-10-25','14:20:00',2.24),('8348','2013-10-25','14:25:00',2.22),('8348','2013-10-25','14:30:00',2.23),('8348','2013-10-25','14:35:00',2.21),('8348','2013-10-25','14:40:00',2.16),('8348','2013-10-25','14:45:00',2.11),('8348','2013-10-25','14:50:00',2.09),('8348','2013-10-25','14:55:00',2.06),('8348','2013-10-25','15:00:00',2.01),('8348','2013-10-25','15:05:00',1.97),('8348','2013-10-25','15:10:00',1.91),('8348','2013-10-25','15:15:00',1.85),('8348','2013-10-25','15:20:00',1.82),('8348','2013-10-25','15:25:00',1.74),('8348','2013-10-25','15:30:00',1.67),('8348','2013-10-25','15:35:00',1.64),('8348','2013-10-25','15:40:00',1.63),('8348','2013-10-25','15:45:00',1.59),('8348','2013-10-25','15:50:00',1.52),('8348','2013-10-25','15:55:00',1.48),('8348','2013-10-25','16:00:00',1.43),('8348','2013-10-25','16:05:00',1.39),('8348','2013-10-25','16:10:00',1.32),('8348','2013-10-25','16:15:00',1.27),('8348','2013-10-25','16:20:00',1.22),('8348','2013-10-25','16:25:00',1.16),('8348','2013-10-25','16:30:00',1.1),('8348','2013-10-25','16:35:00',1.03),('8348','2013-10-24','09:15:00',1.07),('8348','2013-10-24','10:35:00',1.46),('8348','2013-10-24','10:40:00',1.03),('8348','2013-10-24','10:45:00',1.94),('8348','2013-10-24','10:50:00',1.52),('8348','2013-10-24','10:55:00',1.79),('8348','2013-10-24','11:00:00',2.25),('8348','2013-10-24','11:05:00',2.44),('8348','2013-10-24','11:10:00',2.33),('8348','2013-10-24','11:15:00',1.6),('8348','2013-10-24','11:20:00',1.36),('8348','2013-10-24','11:25:00',1.74),('8348','2013-10-24','11:30:00',1.29),('8348','2013-10-24','11:45:00',1.05),('8348','2013-10-24','11:50:00',1.66),('8348','2013-10-24','11:55:00',2.23),('8348','2013-10-24','12:00:00',1.46),('8348','2013-10-24','12:05:00',1.23),('8348','2013-10-24','12:10:00',1.17),('8348','2013-10-24','12:15:00',1.17),('8348','2013-10-24','12:20:00',1.23),('8348','2013-10-24','12:25:00',1.34),('8348','2013-10-24','12:30:00',1.39),('8348','2013-10-24','12:35:00',1.5),('8348','2013-10-24','12:40:00',1.68),('8348','2013-10-24','12:45:00',1.84),('8348','2013-10-24','12:50:00',1.71),('8348','2013-10-24','12:55:00',2.16),('8348','2013-10-24','13:00:00',2.53),('8348','2013-10-24','13:05:00',2.73),('8348','2013-10-24','13:10:00',2.38),('8348','2013-10-24','13:15:00',1.79),('8348','2013-10-24','13:20:00',2.19),('8348','2013-10-24','13:25:00',1.78),('8348','2013-10-24','13:30:00',1.17),('8348','2013-10-24','13:35:00',1.13),('8348','2013-10-24','13:40:00',1.14),('8348','2013-10-24','13:45:00',1.22),('8348','2013-10-24','13:50:00',1.4),('8348','2013-10-24','13:55:00',1.86),('8348','2013-10-24','14:00:00',2.06),('8348','2013-10-24','14:05:00',1.45),('8348','2013-10-24','14:10:00',1.24),('8348','2013-10-24','14:15:00',1.19),('8348','2013-10-24','14:20:00',1.26),('8348','2013-10-24','14:25:00',1.32),('8348','2013-10-24','14:30:00',1.37),('8348','2013-10-24','14:35:00',1.71),('8348','2013-10-24','14:40:00',1.81),('8348','2013-10-24','14:45:00',1.85),('8348','2013-10-24','14:50:00',1.8),('8348','2013-10-24','15:05:00',1.21),('8348','2013-10-24','15:10:00',2.13),('8348','2013-10-24','15:15:00',1.1),('8348','2013-10-24','15:20:00',1.1),('8348','2013-10-24','15:25:00',1.07),('8348','2013-10-24','15:30:00',1.09),('8348','2013-10-24','15:35:00',2.07),('8348','2013-10-24','15:40:00',1.98),('8348','2013-10-24','15:45:00',1.69),('8348','2013-10-24','15:50:00',1.16),('8348','2013-10-23','10:40:00',1.13),('8348','2013-10-23','10:45:00',1.12),('8348','2013-10-23','10:50:00',1.35),('8348','2013-10-23','10:55:00',1.32),('8348','2013-10-23','11:00:00',1.21),('8348','2013-10-23','11:05:00',1.61),('8348','2013-10-23','11:10:00',1.14),('8348','2013-10-23','11:15:00',1.69),('8348','2013-10-23','11:20:00',2.18),('8348','2013-10-23','11:25:00',2.08),('8348','2013-10-23','11:30:00',2.13),('8348','2013-10-23','11:35:00',2.12),('8348','2013-10-23','11:40:00',2.19),('8348','2013-10-23','11:45:00',2.2),('8348','2013-10-23','11:50:00',1.7),('8348','2013-10-23','11:55:00',2.19),('8348','2013-10-23','12:00:00',2.27),('8348','2013-10-23','12:05:00',2.25),('8348','2013-10-23','12:10:00',2.17),('8348','2013-10-23','12:15:00',2.06),('8348','2013-10-23','12:20:00',2.04),('8348','2013-10-23','12:25:00',2.34),('8348','2013-10-23','12:30:00',2.31),('8348','2013-10-23','12:35:00',2.28),('8348','2013-10-23','12:40:00',2.22),('8348','2013-10-23','12:45:00',2.05),('8348','2013-10-23','12:50:00',1.5),('8348','2013-10-23','12:55:00',1.67),('8348','2013-10-23','13:00:00',2.23),('8348','2013-10-23','13:05:00',2.17),('8348','2013-10-23','13:10:00',2.29),('8348','2013-10-23','13:15:00',2.23),('8348','2013-10-23','13:20:00',2.19),('8348','2013-10-23','13:25:00',2.3),('8348','2013-10-23','13:30:00',2.22),('8348','2013-10-23','13:35:00',2.2),('8348','2013-10-23','13:40:00',2.19),('8348','2013-10-23','13:45:00',2.08),('8348','2013-10-23','13:50:00',1.86),('8348','2013-10-23','13:55:00',1.84),('8348','2013-10-23','14:00:00',1.94),('8348','2013-10-23','14:05:00',1.71),('8348','2013-10-23','14:10:00',1.96),('8348','2013-10-23','14:15:00',2.18),('8348','2013-10-23','14:20:00',2.13),('8348','2013-10-23','14:25:00',1.93),('8348','2013-10-23','14:30:00',1.97),('8348','2013-10-23','14:35:00',1.9),('8348','2013-10-23','14:40:00',2.09),('8348','2013-10-23','14:45:00',1.97),('8348','2013-10-23','14:50:00',1.77),('8348','2013-10-23','14:55:00',1.57),('8348','2013-10-23','15:00:00',1.84),('8348','2013-10-23','15:05:00',1.97),('8348','2013-10-23','15:10:00',1.9),('8348','2013-10-23','15:15:00',1.91),('8348','2013-10-23','15:20:00',1.89),('8348','2013-10-23','15:25:00',1.85),('8348','2013-10-23','15:30:00',1.74),('8348','2013-10-23','15:35:00',1.63),('8348','2013-10-23','15:40:00',1.76),('8348','2013-10-23','15:45:00',1.72),('8348','2013-10-23','15:50:00',1.56),('8348','2013-10-23','15:55:00',1.17),('8348','2013-10-23','16:00:00',1.01),('8348','2013-10-22','09:40:00',1.04),('8348','2013-10-22','09:45:00',1.1),('8348','2013-10-22','09:50:00',1.19),('8348','2013-10-22','09:55:00',1.25),('8348','2013-10-22','10:00:00',1.33),('8348','2013-10-22','10:05:00',1.39),('8348','2013-10-22','10:10:00',1.44),('8348','2013-10-22','10:15:00',1.49),('8348','2013-10-22','10:20:00',1.55),('8348','2013-10-22','10:25:00',1.6),('8348','2013-10-22','10:30:00',1.65),('8348','2013-10-22','10:35:00',1.71),('8348','2013-10-22','10:40:00',1.75),('8348','2013-10-22','10:45:00',1.78),('8348','2013-10-22','10:50:00',1.81),('8348','2013-10-22','10:55:00',1.85),('8348','2013-10-22','11:00:00',1.89),('8348','2013-10-22','11:05:00',1.94),('8348','2013-10-22','11:10:00',1.97),('8348','2013-10-22','11:15:00',1.98),('8348','2013-10-22','11:20:00',2),('8348','2013-10-22','11:25:00',2.02),('8348','2013-10-22','11:30:00',2.05),('8348','2013-10-22','11:35:00',2.05),('8348','2013-10-22','11:40:00',2.08),('8348','2013-10-22','11:45:00',2.1),('8348','2013-10-22','11:50:00',2.13),('8348','2013-10-22','11:55:00',2.18),('8348','2013-10-22','12:00:00',2.21),('8348','2013-10-22','12:05:00',2.21),('8348','2013-10-22','12:10:00',2.22),('8348','2013-10-22','12:15:00',2.25),('8348','2013-10-22','12:20:00',2.26),('8348','2013-10-22','12:25:00',2.23),('8348','2013-10-22','12:30:00',2.28),('8348','2013-10-22','12:35:00',2.3),('8348','2013-10-22','12:40:00',2.29),('8348','2013-10-22','12:45:00',2.21),('8348','2013-10-22','12:50:00',2.3),('8348','2013-10-22','12:55:00',2.26),('8348','2013-10-22','13:00:00',2.2),('8348','2013-10-22','13:05:00',2.17),('8348','2013-10-22','13:10:00',2.33),('8348','2013-10-22','13:15:00',2.28),('8348','2013-10-22','13:20:00',2.35),('8348','2013-10-22','13:25:00',2.37),('8348','2013-10-22','13:30:00',2.36),('8348','2013-10-22','13:35:00',2.32),('8348','2013-10-22','13:40:00',2.3),('8348','2013-10-22','13:45:00',2.19),('8348','2013-10-22','13:50:00',2.17),('8348','2013-10-22','13:55:00',2.2),('8348','2013-10-22','14:00:00',2.14),('8348','2013-10-22','14:05:00',2.25),('8348','2013-10-22','14:10:00',2.27),('8348','2013-10-22','14:15:00',2.29),('8348','2013-10-22','14:20:00',2.34),('8348','2013-10-22','14:25:00',1.91),('8348','2013-10-22','14:30:00',1.87),('8348','2013-10-22','14:35:00',1.82),('8348','2013-10-22','14:40:00',1.71),('8348','2013-10-22','14:45:00',1.87),('8348','2013-10-22','14:50:00',2),('8348','2013-10-22','14:55:00',1.94),('8348','2013-10-22','15:00:00',1.92),('8348','2013-10-22','15:05:00',1.89),('8348','2013-10-22','15:10:00',1.85),('8348','2013-10-22','15:15:00',1.68),('8348','2013-10-22','15:20:00',1.75),('8348','2013-10-22','15:25:00',1.69),('8348','2013-10-22','15:30:00',1.72),('8348','2013-10-22','15:35:00',1.7),('8348','2013-10-22','15:40:00',1.68),('8348','2013-10-22','15:45:00',1.57),('8348','2013-10-22','15:50:00',1.54),('8348','2013-10-22','15:55:00',1.41),('8348','2013-10-22','16:00:00',1.35),('8348','2013-10-22','16:05:00',1.27),('8348','2013-10-22','16:10:00',1.3),('8348','2013-10-22','16:15:00',1.2),('8348','2013-10-22','16:20:00',1.13),('8348','2013-10-22','16:25:00',1.1),('8348','2013-10-22','16:30:00',1.05),('8348','2013-10-21','09:40:00',1.05),('8348','2013-10-21','09:45:00',1),('8348','2013-10-21','09:50:00',1.08),('8348','2013-10-21','09:55:00',1.25),('8348','2013-10-21','10:00:00',1.24),('8348','2013-10-21','10:05:00',1.46),('8348','2013-10-21','10:10:00',1.51),('8348','2013-10-21','10:15:00',1.58),('8348','2013-10-21','10:20:00',1.6),('8348','2013-10-21','10:25:00',1.7),('8348','2013-10-21','10:30:00',1.65),('8348','2013-10-21','10:35:00',1.71),('8348','2013-10-21','10:40:00',1.69),('8348','2013-10-21','10:45:00',1.74),('8348','2013-10-21','10:50:00',1.85),('8348','2013-10-21','10:55:00',1.83),('8348','2013-10-21','11:00:00',1.99),('8348','2013-10-21','11:05:00',1.73),('8348','2013-10-21','11:10:00',1.78),('8348','2013-10-21','11:15:00',2.12),('8348','2013-10-21','11:20:00',2.11),('8348','2013-10-21','11:25:00',2.12),('8348','2013-10-21','11:30:00',2.18),('8348','2013-10-21','11:35:00',2.18),('8348','2013-10-21','11:40:00',2.16),('8348','2013-10-21','11:45:00',2.26),('8348','2013-10-21','11:50:00',2.28),('8348','2013-10-21','11:55:00',2.29),('8348','2013-10-21','12:00:00',2.37),('8348','2013-10-21','12:05:00',2.4),('8348','2013-10-21','12:10:00',2.43),('8348','2013-10-21','12:15:00',2.43),('8348','2013-10-21','12:20:00',2.42),('8348','2013-10-21','12:25:00',2.41),('8348','2013-10-21','12:30:00',2.3),('8348','2013-10-21','12:35:00',2.4),('8348','2013-10-21','12:40:00',2.46),('8348','2013-10-21','12:45:00',2.46),('8348','2013-10-21','12:50:00',2.45),('8348','2013-10-21','12:55:00',2.45),('8348','2013-10-21','13:00:00',2.42),('8348','2013-10-21','13:05:00',2.4),('8348','2013-10-21','13:10:00',2.33),('8348','2013-10-21','13:15:00',2.39),('8348','2013-10-21','13:20:00',2.37),('8348','2013-10-21','13:25:00',2.41),('8348','2013-10-21','13:30:00',2.48),('8348','2013-10-21','13:35:00',2.45),('8348','2013-10-21','13:40:00',2.42),('8348','2013-10-21','13:45:00',2.39),('8348','2013-10-21','13:50:00',2.32),('8348','2013-10-21','13:55:00',2.31),('8348','2013-10-21','14:00:00',2.3),('8348','2013-10-21','14:05:00',2.36),('8348','2013-10-21','14:10:00',2.31),('8348','2013-10-21','14:15:00',2.28),('8348','2013-10-21','14:20:00',2.29),('8348','2013-10-21','14:25:00',2.24),('8348','2013-10-21','14:30:00',2.22),('8348','2013-10-21','14:35:00',2.21),('8348','2013-10-21','14:40:00',2.09),('8348','2013-10-21','14:45:00',2.04),('8348','2013-10-21','14:50:00',2),('8348','2013-10-21','14:55:00',2),('8348','2013-10-21','15:00:00',2.03),('8348','2013-10-21','15:05:00',1.96),('8348','2013-10-21','15:10:00',1.95),('8348','2013-10-21','15:15:00',1.92),('8348','2013-10-21','15:20:00',1.87),('8348','2013-10-21','15:25:00',1.83),('8348','2013-10-21','15:30:00',1.71),('8348','2013-10-21','15:35:00',1.69),('8348','2013-10-21','15:40:00',1.7),('8348','2013-10-21','15:45:00',1.63),('8348','2013-10-21','15:50:00',1.57),('8348','2013-10-21','15:55:00',1.52),('8348','2013-10-21','16:00:00',1.5),('8348','2013-10-21','16:05:00',1.43),('8348','2013-10-21','16:10:00',1.4),('8348','2013-10-21','16:15:00',1.32),('8348','2013-10-21','16:20:00',1.26),('8348','2013-10-21','16:25:00',1.19),('8348','2013-10-21','16:30:00',1.12),('8348','2013-10-21','16:35:00',1.06),('8348','2013-10-20','09:30:00',1.01),('8348','2013-10-20','09:35:00',1.07),('8348','2013-10-20','09:40:00',1.12),('8348','2013-10-20','09:45:00',1.19),('8348','2013-10-20','09:50:00',1.26),('8348','2013-10-20','09:55:00',1.35),('8348','2013-10-20','10:00:00',1.43),('8348','2013-10-20','10:05:00',1.49),('8348','2013-10-20','10:10:00',1.55),('8348','2013-10-20','10:15:00',1.6),('8348','2013-10-20','10:20:00',1.65),('8348','2013-10-20','10:25:00',1.7),('8348','2013-10-20','10:30:00',1.75),('8348','2013-10-20','10:35:00',1.81),('8348','2013-10-20','10:40:00',1.84),('8348','2013-10-20','10:45:00',1.88),('8348','2013-10-20','10:50:00',1.92),('8348','2013-10-20','10:55:00',1.97),('8348','2013-10-20','11:00:00',2.01),('8348','2013-10-20','11:05:00',2.07),('8348','2013-10-20','11:10:00',2.1),('8348','2013-10-20','11:15:00',2.11),('8348','2013-10-20','11:20:00',2.17),('8348','2013-10-20','11:25:00',2.19),('8348','2013-10-20','11:30:00',2.23),('8348','2013-10-20','11:35:00',2.27),('8348','2013-10-20','11:40:00',2.28),('8348','2013-10-20','11:45:00',2.31),('8348','2013-10-20','11:50:00',2.35),('8348','2013-10-20','11:55:00',2.4),('8348','2013-10-20','12:00:00',2.37),('8348','2013-10-20','12:05:00',2.42),('8348','2013-10-20','12:10:00',2.42),('8348','2013-10-20','12:15:00',2.55),('8348','2013-10-20','12:20:00',2.52),('8348','2013-10-20','12:30:00',2.69),('8348','2013-10-20','12:35:00',2.53),('8348','2013-10-20','12:40:00',1.53),('8348','2013-10-20','12:45:00',1.53),('8348','2013-10-20','12:50:00',1.97),('8348','2013-10-20','12:55:00',1.89),('8348','2013-10-20','13:00:00',1.63),('8348','2013-10-20','13:05:00',2.9),('8348','2013-10-20','13:10:00',2.61),('8348','2013-10-20','13:20:00',1.04),('8348','2013-10-20','13:25:00',1.62),('8348','2013-10-20','13:30:00',1.38),('8348','2013-10-20','13:35:00',2.02),('8348','2013-10-20','13:40:00',1.08),('8348','2013-10-20','13:45:00',1.68),('8348','2013-10-20','13:55:00',2.36),('8348','2013-10-20','14:10:00',1.07),('8348','2013-10-20','16:50:00',1.17),('8348','2013-10-20','16:55:00',1.23),('8348','2013-10-20','17:00:00',1.16),('8348','2013-10-20','17:05:00',1.05),('8348','2013-10-19','09:15:00',1.1),('8348','2013-10-19','09:20:00',1.12),('8348','2013-10-19','09:25:00',1.15),('8348','2013-10-19','09:30:00',1.18),('8348','2013-10-19','09:35:00',1.25),('8348','2013-10-19','09:40:00',1.32),('8348','2013-10-19','09:45:00',1.42),('8348','2013-10-19','09:50:00',1.51),('8348','2013-10-19','09:55:00',1.61),('8348','2013-10-19','10:00:00',1.61),('8348','2013-10-19','10:05:00',1.58),('8348','2013-10-19','10:10:00',1.7),('8348','2013-10-19','10:15:00',1.71),('8348','2013-10-19','10:20:00',1.88),('8348','2013-10-19','10:25:00',1.95),('8348','2013-10-19','10:30:00',2),('8348','2013-10-19','10:35:00',2.02),('8348','2013-10-19','10:40:00',2.04),('8348','2013-10-19','10:45:00',2.05),('8348','2013-10-19','10:50:00',2.11),('8348','2013-10-19','10:55:00',2.19),('8348','2013-10-19','11:00:00',2.18),('8348','2013-10-19','11:05:00',2.08),('8348','2013-10-19','11:10:00',1.06),('8348','2013-10-19','11:20:00',1.98),('8348','2013-10-19','11:25:00',2.6),('8348','2013-10-19','11:30:00',2.49),('8348','2013-10-19','11:35:00',2.51),('8348','2013-10-19','11:40:00',2.39),('8348','2013-10-19','11:45:00',2.54),('8348','2013-10-19','11:50:00',2.41),('8348','2013-10-19','11:55:00',2.5),('8348','2013-10-19','12:00:00',2.65),('8348','2013-10-19','12:05:00',2.66),('8348','2013-10-19','12:10:00',2.63),('8348','2013-10-19','12:15:00',2.66),('8348','2013-10-19','12:20:00',2.65),('8348','2013-10-19','12:25:00',2.44),('8348','2013-10-19','12:30:00',2.65),('8348','2013-10-19','12:35:00',2.73),('8348','2013-10-19','12:40:00',2.83),('8348','2013-10-19','12:45:00',2.89),('8348','2013-10-19','12:50:00',2.92),('8348','2013-10-19','12:55:00',3),('8348','2013-10-19','13:00:00',3.08),('8348','2013-10-19','13:05:00',2.3),('8348','2013-10-19','13:10:00',2.78),('8348','2013-10-19','13:15:00',2.63),('8348','2013-10-19','13:20:00',2.68),('8348','2013-10-19','13:25:00',3.01),('8348','2013-10-19','13:30:00',3.01),('8348','2013-10-19','13:35:00',2.24),('8348','2013-10-19','13:40:00',1.96),('8348','2013-10-19','13:45:00',2.2),('8348','2013-10-19','13:50:00',2.44),('8348','2013-10-19','13:55:00',3.09),('8348','2013-10-19','14:00:00',2.46),('8348','2013-10-19','14:05:00',1.99),('8348','2013-10-19','14:10:00',1.65),('8348','2013-10-19','14:15:00',2.03),('8348','2013-10-19','14:20:00',1.73),('8348','2013-10-19','14:25:00',1.57),('8348','2013-10-19','14:30:00',2.16),('8348','2013-10-19','14:35:00',2.78),('8348','2013-10-19','14:40:00',2.08),('8348','2013-10-19','14:45:00',1.8),('8348','2013-10-19','14:50:00',2.59),('8348','2013-10-19','14:55:00',2.48),('8348','2013-10-19','15:00:00',2.41),('8348','2013-10-19','15:05:00',2.34),('8348','2013-10-19','15:10:00',2.31),('8348','2013-10-19','15:15:00',2.25),('8348','2013-10-19','15:20:00',2.1),('8348','2013-10-19','15:25:00',2.04),('8348','2013-10-19','15:30:00',1.94),('8348','2013-10-19','15:35:00',1.96),('8348','2013-10-19','15:40:00',1.79),('8348','2013-10-19','15:45:00',1.52),('8348','2013-10-19','15:50:00',1.69),('8348','2013-10-19','15:55:00',1.83),('8348','2013-10-19','16:00:00',1.51),('8348','2013-10-19','16:05:00',1.61),('8348','2013-10-19','16:10:00',1.55),('8348','2013-10-19','16:15:00',1.67),('8348','2013-10-19','16:20:00',1.46),('8348','2013-10-19','16:25:00',1.13),('8348','2013-10-19','16:30:00',1.44),('8348','2013-10-19','16:35:00',1.45),('8348','2013-10-19','16:40:00',1.4),('8348','2013-10-19','16:45:00',1.26),('8348','2013-10-19','16:50:00',1.21),('8348','2014-05-04','06:45:00',1.24),('8348','2014-05-04','06:50:00',1.54),('8348','2014-05-04','06:55:00',1.64),('8348','2014-05-04','07:00:00',1.72),('8348','2014-05-04','07:05:00',1.9),('8348','2014-05-04','07:10:00',1.96),('8348','2014-05-04','07:15:00',2.13),('8348','2014-05-04','07:20:00',2.25),('8348','2014-05-04','07:25:00',2.42),('8348','2014-05-04','07:30:00',2.79),('8348','2014-05-04','07:35:00',2.93),('8348','2014-05-04','07:40:00',2.97),('8348','2014-05-04','07:45:00',1.88),('8348','2014-05-04','07:50:00',2.33),('8348','2014-05-04','07:55:00',2.13),('8348','2014-05-04','08:00:00',2.37),('8348','2014-05-04','08:05:00',3.69),('8348','2014-05-04','08:10:00',3.52),('8348','2014-05-04','08:15:00',3.85),('8348','2014-05-04','08:20:00',5.95),('8348','2014-05-04','08:25:00',5.32),('8348','2014-05-04','08:30:00',2.8),('8348','2014-05-04','08:35:00',2.12),('8348','2014-05-04','08:40:00',2.62),('8348','2014-05-04','08:45:00',3.88),('8348','2014-05-04','08:50:00',3.48),('8348','2014-05-04','08:55:00',4.07),('8348','2014-05-04','09:00:00',6.25),('8348','2014-05-04','09:05:00',5.13),('8348','2014-05-04','09:10:00',5.41),('8348','2014-05-04','09:15:00',4.29),('8348','2014-05-04','09:20:00',3.32),('8348','2014-05-04','09:25:00',3.33),('8348','2014-05-04','09:30:00',3.51),('8348','2014-05-04','09:35:00',3.68),('8348','2014-05-04','09:40:00',3.84),('8348','2014-05-04','09:45:00',5.09),('8348','2014-05-04','09:50:00',5.41),('8348','2014-05-04','09:55:00',4.39),('8348','2014-05-04','10:00:00',4),('8348','2014-05-04','10:05:00',5.29),('8348','2014-05-04','10:10:00',8.13),('8348','2014-05-04','10:15:00',5.55),('8348','2014-05-04','10:20:00',7.64),('8348','2014-05-04','10:25:00',7.18),('8348','2014-05-04','10:30:00',6.66),('8348','2014-05-04','10:35:00',5.97),('8348','2014-05-04','10:40:00',5.26),('8348','2014-05-04','10:45:00',6.91),('8348','2014-05-04','10:50:00',6.23),('8348','2014-05-04','10:55:00',6.59),('8348','2014-05-04','11:00:00',4.65),('8348','2014-05-04','11:05:00',4.39),('8348','2014-05-04','11:10:00',3.23),('8348','2014-05-04','11:15:00',2.89),('8348','2014-05-04','11:20:00',2.92),('8348','2014-05-04','11:25:00',3.38),('8348','2014-05-04','11:30:00',7.61),('8348','2014-05-04','11:35:00',7.86),('8348','2014-05-04','11:40:00',7.84),('8348','2014-05-04','11:45:00',7.46),('8348','2014-05-04','11:50:00',9.5),('8348','2014-05-04','11:55:00',8.74),('8348','2014-05-04','12:00:00',3.87),('8348','2014-05-04','12:05:00',3.58),('8348','2014-05-04','12:10:00',9.28),('8348','2014-05-04','12:15:00',4.47),('8348','2014-05-04','12:20:00',2.93),('8348','2014-05-04','12:25:00',2.92),('8348','2014-05-04','12:30:00',2.73),('8348','2014-05-04','12:35:00',2.98),('8348','2014-05-04','12:40:00',2.92),('8348','2014-05-04','12:45:00',2.58),('8348','2014-05-04','12:50:00',2.51),('8348','2014-05-04','12:55:00',2.62),('8348','2014-05-04','13:00:00',2.68),('8348','2014-05-04','13:05:00',2.71),('8348','2014-05-04','13:10:00',2.56),('8348','2014-05-04','13:15:00',2.24),('8348','2014-05-04','13:20:00',1.7),('8348','2014-05-04','13:25:00',1.25),('8348','2014-05-04','13:30:00',1.15),('8348','2014-05-04','13:35:00',1.23),('8348','2014-05-04','13:40:00',1.45),('8348','2014-05-04','13:45:00',1.7),('8348','2014-05-04','13:50:00',2.35),('8348','2014-05-04','13:55:00',3.39),('8348','2014-05-04','14:00:00',3.61),('8348','2014-05-04','14:05:00',4.55),('8348','2014-05-04','14:10:00',5.59),('8348','2014-05-04','14:15:00',4.16),('8348','2014-05-04','14:20:00',3.16),('8348','2014-05-04','14:25:00',2.55),('8348','2014-05-04','14:30:00',2.08),('8348','2014-05-04','14:35:00',1.54),('8348','2014-05-04','14:40:00',1.41),('8348','2014-05-04','14:45:00',1.72),('8348','2014-05-04','14:50:00',2.07),('8348','2014-05-04','14:55:00',2.08),('8348','2014-05-04','15:00:00',1.74),('8348','2014-05-04','15:05:00',1.86),('8348','2014-05-04','15:10:00',2.24),('8348','2014-05-04','15:15:00',2.13),('8348','2014-05-04','15:20:00',1.76),('8348','2014-05-04','15:25:00',1.34),('8348','2014-05-04','15:30:00',1.02),('8348','2014-05-04','16:20:00',1.2),('8348','2014-05-04','16:25:00',1.74),('8348','2014-05-04','16:30:00',1.81),('8348','2014-05-04','16:35:00',1.92),('8348','2014-05-04','16:40:00',1.85),('8348','2014-05-04','16:45:00',1.41),('8348','2014-05-04','16:50:00',1.12),('8348','2014-05-04','17:05:00',1.19),('8348','2014-04-16','06:55:00',1.05),('8348','2014-04-16','07:00:00',1.15),('8348','2014-04-16','07:05:00',1.24),('8348','2014-04-16','07:10:00',1.36),('8348','2014-04-16','07:15:00',1.64),('8348','2014-04-16','07:20:00',1.77),('8348','2014-04-16','07:25:00',1.85),('8348','2014-04-16','07:30:00',1.46),('8348','2014-04-16','07:35:00',1.24),('8348','2014-04-16','07:40:00',1.27),('8348','2014-04-16','07:45:00',2.09),('8348','2014-04-16','07:50:00',2.28),('8348','2014-04-16','07:55:00',2.61),('8348','2014-04-16','08:00:00',2.98),('8348','2014-04-16','08:05:00',3.33),('8348','2014-04-16','08:10:00',3.49),('8348','2014-04-16','08:15:00',3.65),('8348','2014-04-16','08:20:00',3.8),('8348','2014-04-16','08:25:00',4.07),('8348','2014-04-16','08:30:00',2.69),('8348','2014-04-16','08:35:00',1.52),('8348','2014-04-16','08:40:00',1.51),('8348','2014-04-16','08:45:00',1.58),('8348','2014-04-16','08:50:00',1.67),('8348','2014-04-16','08:55:00',5.39),('8348','2014-04-16','09:00:00',5.23),('8348','2014-04-16','09:05:00',5.3),('8348','2014-04-16','09:10:00',5.42),('8348','2014-04-16','09:15:00',5.56),('8348','2014-04-16','09:20:00',5.69),('8348','2014-04-16','09:25:00',5.8),('8348','2014-04-16','09:30:00',5.9),('8348','2014-04-16','09:35:00',6),('8348','2014-04-16','09:40:00',6.11),('8348','2014-04-16','09:45:00',6.24),('8348','2014-04-16','09:50:00',6.55),('8348','2014-04-16','09:55:00',5.98),('8348','2014-04-16','10:00:00',6.48),('8348','2014-04-16','10:05:00',3.59),('8348','2014-04-16','10:10:00',2.63),('8348','2014-04-16','10:15:00',3.7),('8348','2014-04-16','10:20:00',6.81),('8348','2014-04-16','10:25:00',4.91),('8348','2014-04-16','10:30:00',6.08),('8348','2014-04-16','10:35:00',4.68),('8348','2014-04-16','10:40:00',5.19),('8348','2014-04-16','10:45:00',6.87),('8348','2014-04-16','10:50:00',7.28),('8348','2014-04-16','10:55:00',8.13),('8348','2014-04-16','11:00:00',8.19),('8348','2014-04-16','11:05:00',5.06),('8348','2014-04-16','11:10:00',7.29),('8348','2014-04-16','11:15:00',8.01),('8348','2014-04-16','11:20:00',4.2),('8348','2014-04-16','11:25:00',2.36),('8348','2014-04-16','11:30:00',3.88),('8348','2014-04-16','11:35:00',7.97),('8348','2014-04-16','11:40:00',7.98),('8348','2014-04-16','11:45:00',8.12),('8348','2014-04-16','11:50:00',6.97),('8348','2014-04-16','11:55:00',2.02),('8348','2014-04-16','12:00:00',6.02),('8348','2014-04-16','12:05:00',2.9),('8348','2014-04-16','12:10:00',1.59),('8348','2014-04-16','12:15:00',1.67),('8348','2014-04-16','12:20:00',2.7),('8348','2014-04-16','12:25:00',2.17),('8348','2014-04-16','12:30:00',1.74),('8348','2014-04-16','12:35:00',3.2),('8348','2014-04-16','12:40:00',4.46),('8348','2014-04-16','12:45:00',9.28),('8348','2014-04-16','12:50:00',7.95),('8348','2014-04-16','12:55:00',5.5),('8348','2014-04-16','13:00:00',3.08),('8348','2014-04-16','13:05:00',7.16),('8348','2014-04-16','13:10:00',9.12),('8348','2014-04-16','13:15:00',8.81),('8348','2014-04-16','13:20:00',8.42),('8348','2014-04-16','13:25:00',7.81),('8348','2014-04-16','13:30:00',7.87),('8348','2014-04-16','13:35:00',7.6),('8348','2014-04-16','13:40:00',7.33),('8348','2014-04-16','13:45:00',7.19),('8348','2014-04-16','13:50:00',7.53),('8348','2014-04-16','13:55:00',2.28),('8348','2014-04-16','14:00:00',2.5),('8348','2014-04-16','14:05:00',6.79),('8348','2014-04-16','14:10:00',8.56),('8348','2014-04-16','14:15:00',4.48),('8348','2014-04-16','14:20:00',1.16),('8348','2014-04-16','14:25:00',2.37),('8348','2014-04-16','14:30:00',6.17),('8348','2014-04-16','14:35:00',7.52),('8348','2014-04-16','14:40:00',7.25),('8348','2014-04-16','14:45:00',7.04),('8348','2014-04-16','14:50:00',6.79),('8348','2014-04-16','14:55:00',6.63),('8348','2014-04-16','15:00:00',6.48),('8348','2014-04-16','15:05:00',6.35),('8348','2014-04-16','15:10:00',6.19),('8348','2014-04-16','15:15:00',6.1),('8348','2014-04-16','15:20:00',6.06),('8348','2014-04-16','15:25:00',5.9),('8348','2014-04-16','15:30:00',5.8),('8348','2014-04-16','15:35:00',5.68),('8348','2014-04-16','15:40:00',5.56),('8348','2014-04-16','15:45:00',5.45),('8348','2014-04-16','15:50:00',5.28),('8348','2014-04-16','15:55:00',5.1),('8348','2014-04-16','16:00:00',4.97),('8348','2014-04-16','16:05:00',4.81),('8348','2014-04-16','16:10:00',4.67),('8348','2014-04-16','16:15:00',4.57),('8348','2014-04-16','16:20:00',4.4),('8348','2014-04-16','16:25:00',4.2),('8348','2014-04-16','16:30:00',4.08),('8348','2014-04-16','16:35:00',3.94),('8348','2014-04-16','16:40:00',3.67),('8348','2014-04-16','16:45:00',3.57),('8348','2014-04-16','16:50:00',3.54),('8348','2014-04-16','16:55:00',3.52),('8348','2014-04-16','17:00:00',3.25),('8348','2014-04-16','17:05:00',2.81),('8348','2014-04-16','17:10:00',2.51),('8348','2014-04-16','17:15:00',2.38),('8348','2014-04-16','17:20:00',2.56),('8348','2014-04-16','17:25:00',2.25),('8348','2014-04-16','17:30:00',2.05),('8348','2014-04-16','17:35:00',1.88),('8348','2014-04-16','17:40:00',1.87),('8348','2014-04-16','17:45:00',1.87),('8348','2014-04-16','17:50:00',1.87),('8348','2014-04-16','17:55:00',1.44),('8348','2014-04-16','18:05:00',1.1),('8348','2013-10-18','09:20:00',1.02),('8348','2013-10-18','09:25:00',1.04),('8348','2013-10-18','09:30:00',1.15),('8348','2013-10-18','09:35:00',1.22),('8348','2013-10-18','09:40:00',1.27),('8348','2013-10-18','09:45:00',1.35),('8348','2013-10-18','09:50:00',1.44),('8348','2013-10-18','09:55:00',1.53),('8348','2013-10-18','10:00:00',1.58),('8348','2013-10-18','10:05:00',1.66),('8348','2013-10-18','10:10:00',1.7),('8348','2013-10-18','10:15:00',1.76),('8348','2013-10-18','10:20:00',1.79),('8348','2013-10-18','10:25:00',1.86),('8348','2013-10-18','10:30:00',1.92),('8348','2013-10-18','10:35:00',1.97),('8348','2013-10-18','10:40:00',2.01),('8348','2013-10-18','10:45:00',2.07),('8348','2013-10-18','10:50:00',2.11),('8348','2013-10-18','10:55:00',2.15),('8348','2013-10-18','11:00:00',2.17),('8348','2013-10-18','11:05:00',2.13),('8348','2013-10-18','11:10:00',2.14),('8348','2013-10-18','11:15:00',2.18),('8348','2013-10-18','11:20:00',2.34),('8348','2013-10-18','11:25:00',2.29),('8348','2013-10-18','11:30:00',2.37),('8348','2013-10-18','11:35:00',2.42),('8348','2013-10-18','11:40:00',2.49),('8348','2013-10-18','11:45:00',2.45),('8348','2013-10-18','11:50:00',2.44),('8348','2013-10-18','11:55:00',2.54),('8348','2013-10-18','12:00:00',2.46),('8348','2013-10-18','12:05:00',2.56),('8348','2013-10-18','12:10:00',2.58),('8348','2013-10-18','12:15:00',2.54),('8348','2013-10-18','12:20:00',2.53),('8348','2013-10-18','12:25:00',2.59),('8348','2013-10-18','12:30:00',2.62),('8348','2013-10-18','12:35:00',2.57),('8348','2013-10-18','12:40:00',2.6),('8348','2013-10-18','12:45:00',2.53),('8348','2013-10-18','12:50:00',2.55),('8348','2013-10-18','12:55:00',2.62),('8348','2013-10-18','13:00:00',2.6),('8348','2013-10-18','13:05:00',2.54),('8348','2013-10-18','13:10:00',2.46),('8348','2013-10-18','13:15:00',2.58),('8348','2013-10-18','13:20:00',2.62),('8348','2013-10-18','13:25:00',2.66),('8348','2013-10-18','13:30:00',2.65),('8348','2013-10-18','13:35:00',2.64),('8348','2013-10-18','13:40:00',2.66),('8348','2013-10-18','13:45:00',2.57),('8348','2013-10-18','13:50:00',2.57),('8348','2013-10-18','13:55:00',2.55),('8348','2013-10-18','14:00:00',2.38),('8348','2013-10-18','14:05:00',2.45),('8348','2013-10-18','14:10:00',2.41),('8348','2013-10-18','14:15:00',2.47),('8348','2013-10-18','14:20:00',2.45),('8348','2013-10-18','14:25:00',2.43),('8348','2013-10-18','14:30:00',2.4),('8348','2013-10-18','14:35:00',2.31),('8348','2013-10-18','14:40:00',2.32),('8348','2013-10-18','14:45:00',2.27),('8348','2013-10-18','14:50:00',2.21),('8348','2013-10-18','14:55:00',2.28),('8348','2013-10-18','15:00:00',1.96),('8348','2013-10-18','15:05:00',1.81),('8348','2013-10-18','15:10:00',1.98),('8348','2013-10-18','15:15:00',1.98),('8348','2013-10-18','15:20:00',2.07),('8348','2013-10-18','15:25:00',1.96),('8348','2013-10-18','15:30:00',1.9),('8348','2013-10-18','15:35:00',1.89),('8348','2013-10-18','15:40:00',1.83),('8348','2013-10-18','15:45:00',1.65),('8348','2013-10-18','15:50:00',1.65),('8348','2013-10-18','15:55:00',1.52),('8348','2013-10-18','16:00:00',1.6),('8348','2013-10-18','16:05:00',1.5),('8348','2013-10-18','16:10:00',1.44),('8348','2013-10-18','16:15:00',1.32),('8348','2013-10-18','16:20:00',1.25),('8348','2013-10-18','16:25:00',1.1),('8348','2013-10-18','16:30:00',1.01),('8348','2013-10-17','09:20:00',1.03),('8348','2013-10-17','09:25:00',1.07),('8348','2013-10-17','09:30:00',1.15),('8348','2013-10-17','09:35:00',1.21),('8348','2013-10-17','09:40:00',1.27),('8348','2013-10-17','09:45:00',1.35),('8348','2013-10-17','09:50:00',1.43),('8348','2013-10-17','09:55:00',1.53),('8348','2013-10-17','10:00:00',1.59),('8348','2013-10-17','10:05:00',1.64),('8348','2013-10-17','10:10:00',1.7),('8348','2013-10-17','10:15:00',1.76),('8348','2013-10-17','10:20:00',1.82),('8348','2013-10-17','10:25:00',1.88),('8348','2013-10-17','10:30:00',1.93),('8348','2013-10-17','10:35:00',2),('8348','2013-10-17','10:40:00',2.04),('8348','2013-10-17','10:45:00',2.1),('8348','2013-10-17','10:50:00',2.15),('8348','2013-10-17','10:55:00',2.19),('8348','2013-10-17','11:00:00',2.24),('8348','2013-10-17','11:05:00',2.28),('8348','2013-10-17','11:10:00',2.32),('8348','2013-10-17','11:15:00',2.35),('8348','2013-10-17','11:20:00',2.38),('8348','2013-10-17','11:25:00',2.42),('8348','2013-10-17','11:30:00',2.46),('8348','2013-10-17','11:35:00',2.5),('8348','2013-10-17','11:40:00',2.53),('8348','2013-10-17','11:45:00',2.54),('8348','2013-10-17','11:50:00',2.57),('8348','2013-10-17','11:55:00',2.59),('8348','2013-10-17','12:00:00',2.61),('8348','2013-10-17','12:05:00',2.62),('8348','2013-10-17','12:10:00',2.64),('8348','2013-10-17','12:15:00',2.67),('8348','2013-10-17','12:20:00',2.67),('8348','2013-10-17','12:25:00',2.68),('8348','2013-10-17','12:30:00',2.7),('8348','2013-10-17','12:35:00',2.73),('8348','2013-10-17','12:40:00',2.74),('8348','2013-10-17','12:45:00',2.76),('8348','2013-10-17','12:50:00',2.77),('8348','2013-10-17','12:55:00',2.76),('8348','2013-10-17','13:00:00',2.76),('8348','2013-10-17','13:05:00',2.76),('8348','2013-10-17','13:10:00',2.76),('8348','2013-10-17','13:15:00',2.77),('8348','2013-10-17','13:20:00',2.75),('8348','2013-10-17','13:25:00',2.75),('8348','2013-10-17','13:30:00',2.73),('8348','2013-10-17','13:35:00',2.73),('8348','2013-10-17','13:40:00',2.71),('8348','2013-10-17','13:45:00',2.7),('8348','2013-10-17','13:50:00',2.69),('8348','2013-10-17','13:55:00',2.69),('8348','2013-10-17','14:00:00',2.67),('8348','2013-10-17','14:05:00',2.65),('8348','2013-10-17','14:10:00',2.63),('8348','2013-10-17','14:15:00',2.62),('8348','2013-10-17','14:20:00',2.6),('8348','2013-10-17','14:25:00',2.56),('8348','2013-10-17','14:30:00',2.52),('8348','2013-10-17','14:35:00',2.51),('8348','2013-10-17','14:40:00',2.48),('8348','2013-10-17','14:45:00',2.45),('8348','2013-10-17','14:50:00',2.41),('8348','2013-10-17','14:55:00',2.37),('8348','2013-10-17','15:00:00',2.34),('8348','2013-10-17','15:05:00',2.3),('8348','2013-10-17','15:10:00',2.29),('8348','2013-10-17','15:15:00',2.24),('8348','2013-10-17','15:20:00',2.19),('8348','2013-10-17','15:25:00',2.15),('8348','2013-10-17','15:30:00',2.1),('8348','2013-10-17','15:35:00',2.05),('8348','2013-10-17','15:40:00',2),('8348','2013-10-17','15:45:00',1.94),('8348','2013-10-17','15:50:00',1.87),('8348','2013-10-17','15:55:00',1.83),('8348','2013-10-17','16:00:00',1.77),('8348','2013-10-17','16:05:00',1.71),('8348','2013-10-17','16:10:00',1.67),('8348','2013-10-17','16:15:00',1.61),('8348','2013-10-17','16:20:00',1.56),('8348','2013-10-17','16:25:00',1.5),('8348','2013-10-17','16:30:00',1.42),('8348','2013-10-17','16:35:00',1.35),('8348','2013-10-17','16:40:00',1.29),('8348','2013-10-17','16:45:00',1.21),('8348','2013-10-17','16:50:00',1.14),('8348','2013-10-17','16:55:00',1.07),('8348','2013-10-16','09:45:00',1.28),('8348','2013-10-16','09:50:00',1.12),('8348','2013-10-16','11:15:00',1.23),('8348','2013-10-16','11:55:00',1.06),('8348','2013-10-16','12:10:00',1.09),('8348','2013-10-16','12:15:00',2.99),('8348','2013-10-16','12:20:00',2.35),('8348','2013-10-16','12:35:00',1.1),('8348','2013-10-16','12:40:00',3.23),('8348','2013-10-16','12:45:00',2.75),('8348','2013-10-16','12:50:00',2.45),('8348','2013-10-16','12:55:00',2.32),('8348','2013-10-16','13:00:00',2.26),('8348','2013-10-16','13:05:00',2.93),('8348','2013-10-16','13:10:00',2.72),('8348','2013-10-16','13:15:00',2.23),('8348','2013-10-16','13:20:00',2.92),('8348','2013-10-16','13:25:00',3.1),('8348','2013-10-16','13:30:00',2.97),('8348','2013-10-16','13:35:00',2.82),('8348','2013-10-16','13:40:00',2.85),('8348','2013-10-16','13:45:00',2.8),('8348','2013-10-16','13:50:00',2.71),('8348','2013-10-16','13:55:00',2.98),('8348','2013-10-16','14:00:00',2.38),('8348','2013-10-16','14:05:00',2.06),('8348','2013-10-16','14:10:00',2.89),('8348','2013-10-16','14:15:00',2.78),('8348','2013-10-16','14:20:00',2.81),('8348','2013-10-16','14:25:00',2.34),('8348','2013-10-16','14:30:00',2.65),('8348','2013-10-16','14:35:00',1.45),('8348','2013-10-16','14:40:00',2.67),('8348','2013-10-16','14:45:00',2.68),('8348','2013-10-16','14:50:00',2.54),('8348','2013-10-16','14:55:00',1.74),('8348','2013-10-16','15:00:00',2.46),('8348','2013-10-16','15:05:00',2.44),('8348','2013-10-16','15:10:00',2.49),('8348','2013-10-16','15:15:00',2.33),('8348','2013-10-16','15:20:00',2.25),('8348','2013-10-16','15:25:00',1.64),('8348','2013-10-16','15:35:00',1.79),('8348','2013-10-16','15:40:00',2.15),('8348','2013-10-16','15:45:00',1.99),('8348','2013-10-16','15:50:00',1.92),('8348','2013-10-16','15:55:00',1.88),('8348','2013-10-16','16:00:00',1.82),('8348','2013-10-16','16:05:00',1.76),('8348','2013-10-16','16:10:00',1.48),('8348','2013-10-16','16:15:00',1.63),('8348','2013-10-16','16:20:00',1.55),('8348','2013-10-16','16:25:00',1.48),('8348','2013-10-16','16:30:00',1.39),('8348','2013-10-16','16:35:00',1.24),('8348','2013-10-16','16:40:00',1.3),('8348','2013-10-16','16:45:00',1.2),('8348','2013-10-16','16:50:00',1.14),('8348','2013-10-16','16:55:00',1.08),('8348','2013-10-15','09:30:00',1.06),('8348','2013-10-15','09:45:00',1.33),('8348','2013-10-15','09:50:00',1.54),('8348','2013-10-15','09:55:00',1.66),('8348','2013-10-15','10:00:00',1.66),('8348','2013-10-15','10:05:00',1.82),('8348','2013-10-15','10:10:00',1.45),('8348','2013-10-15','10:25:00',1.17),('8348','2013-10-15','10:30:00',1.55),('8348','2013-10-15','10:35:00',1.32),('8348','2013-10-15','10:40:00',1.62),('8348','2013-10-15','10:45:00',1.84),('8348','2013-10-15','10:50:00',1.74),('8348','2013-10-15','10:55:00',1.53),('8348','2013-10-15','11:00:00',1.53),('8348','2013-10-15','11:05:00',1.65),('8348','2013-10-15','11:10:00',2.15),('8348','2013-10-15','11:15:00',2.28),('8348','2013-10-15','11:20:00',2.34),('8348','2013-10-15','11:25:00',2.19),('8348','2013-10-15','11:30:00',2.3),('8348','2013-10-15','11:35:00',1.9),('8348','2013-10-15','11:40:00',1.56),('8348','2013-10-15','11:45:00',1.32),('8348','2013-10-15','11:50:00',1.27),('8348','2013-10-15','11:55:00',1.26),('8348','2013-10-15','12:00:00',1.32),('8348','2013-10-15','12:05:00',1.32),('8348','2013-10-15','12:10:00',1.34),('8348','2013-10-15','12:15:00',1.32),('8348','2013-10-15','12:20:00',1.37),('8348','2013-10-15','12:25:00',1.24),('8348','2013-10-15','12:30:00',1.15),('8348','2013-10-15','12:35:00',1.14),('8348','2013-10-15','12:40:00',1.11),('8348','2013-10-15','12:45:00',1.24),('8348','2013-10-15','12:50:00',1.17),('8348','2013-10-15','12:55:00',1.07),('8348','2013-10-15','13:00:00',1.06),('8348','2013-10-15','13:05:00',1.39),('8348','2013-10-15','13:10:00',1.58),('8348','2013-10-15','13:15:00',1.6),('8348','2013-10-15','13:20:00',2.26),('8348','2013-10-15','13:25:00',2.61),('8348','2013-10-15','13:30:00',1.66),('8348','2013-10-15','13:35:00',1.43),('8348','2013-10-15','13:40:00',1.39),('8348','2013-10-15','13:45:00',1.41),('8348','2013-10-15','13:50:00',1.31),('8348','2013-10-15','13:55:00',1.16),('8348','2013-10-15','14:00:00',1.06),('8348','2013-10-15','14:05:00',1.06),('8348','2013-10-15','14:10:00',1.17),('8348','2013-10-15','14:15:00',1.63),('8348','2013-10-15','14:20:00',1.79),('8348','2013-10-15','14:25:00',1.98),('8348','2013-10-15','14:30:00',1.83),('8348','2013-10-15','14:35:00',1.23),('8348','2013-10-15','14:40:00',1.78),('8348','2013-10-15','14:45:00',1.93),('8348','2013-10-15','14:50:00',2.1),('8348','2013-10-15','14:55:00',1.75),('8348','2013-10-15','15:00:00',1.18),('8348','2013-10-15','15:05:00',1.19),('8348','2013-10-15','15:10:00',1.23),('8348','2013-10-15','15:15:00',1.12),('8348','2013-10-15','15:20:00',1.02),('8348','2013-10-15','16:30:00',1.06),('8348','2013-10-15','16:35:00',1.08),('8348','2013-10-14','09:25:00',1.05),('8348','2013-10-14','09:30:00',1.18),('8348','2013-10-14','09:35:00',1.15),('8348','2013-10-14','09:40:00',1.03),('8348','2013-10-14','09:50:00',1.18),('8348','2013-10-14','09:55:00',1.39),('8348','2013-10-14','10:00:00',1.38),('8348','2013-10-14','10:05:00',1.52),('8348','2013-10-14','10:10:00',1.63),('8348','2013-10-14','10:15:00',1.74),('8348','2013-10-14','10:20:00',1.78),('8348','2013-10-14','10:25:00',1.82),('8348','2013-10-14','10:30:00',1.87),('8348','2013-10-14','10:35:00',1.9),('8348','2013-10-14','10:40:00',1.88),('8348','2013-10-14','10:45:00',1.94),('8348','2013-10-14','10:50:00',2.03),('8348','2013-10-14','10:55:00',2.07),('8348','2013-10-14','11:00:00',2.12),('8348','2013-10-14','11:05:00',2.13),('8348','2013-10-14','11:10:00',2.24),('8348','2013-10-14','11:15:00',2.23),('8348','2013-10-14','11:20:00',2.24),('8348','2013-10-14','11:25:00',2.32),('8348','2013-10-14','11:30:00',2.39),('8348','2013-10-14','11:35:00',2.35),('8348','2013-10-14','11:40:00',2.38),('8348','2013-10-14','11:45:00',2.35),('8348','2013-10-14','11:50:00',2.4),('8348','2013-10-14','11:55:00',2.41),('8348','2013-10-14','12:00:00',2.45),('8348','2013-10-14','12:05:00',2.46),('8348','2013-10-14','12:10:00',2.51),('8348','2013-10-14','12:15:00',2.48),('8348','2013-10-14','12:20:00',2.32),('8348','2013-10-14','12:25:00',2.46),('8348','2013-10-14','12:30:00',2.59),('8348','2013-10-14','12:35:00',2.58),('8348','2013-10-14','12:40:00',2.58),('8348','2013-10-14','12:45:00',2.59),('8348','2013-10-14','12:50:00',2.59),('8348','2013-10-14','12:55:00',2.59),('8348','2013-10-14','13:00:00',2.58),('8348','2013-10-14','13:05:00',2.59),('8348','2013-10-14','13:10:00',2.59),('8348','2013-10-14','13:15:00',2.59),('8348','2013-10-14','13:20:00',2.59),('8348','2013-10-14','13:25:00',2.58),('8348','2013-10-14','13:30:00',2.57),('8348','2013-10-14','13:35:00',2.56),('8348','2013-10-14','13:40:00',2.57),('8348','2013-10-14','13:45:00',2.56),('8348','2013-10-14','13:50:00',2.54),('8348','2013-10-14','13:55:00',2.52),('8348','2013-10-14','14:00:00',2.51),('8348','2013-10-14','14:05:00',2.5),('8348','2013-10-14','14:10:00',2.48),('8348','2013-10-14','14:15:00',2.47),('8348','2013-10-14','14:20:00',2.44),('8348','2013-10-14','14:25:00',2.41),('8348','2013-10-14','14:30:00',2.39),('8348','2013-10-14','14:35:00',2.36),('8348','2013-10-14','14:40:00',2.35),('8348','2013-10-14','14:45:00',2.32),('8348','2013-10-14','14:50:00',2.3),('8348','2013-10-14','14:55:00',2.25),('8348','2013-10-14','15:00:00',2.21),('8348','2013-10-14','15:05:00',2.17),('8348','2013-10-14','15:10:00',2.12),('8348','2013-10-14','15:15:00',2.08),('8348','2013-10-14','15:20:00',2.04),('8348','2013-10-14','15:25:00',1.98),('8348','2013-10-14','15:30:00',1.92),('8348','2013-10-14','15:35:00',1.86),('8348','2013-10-14','15:40:00',1.65),('8348','2013-10-14','15:45:00',1.43),('8348','2013-10-14','15:50:00',1.48),('8348','2013-10-14','15:55:00',1.08),('8348','2013-10-14','16:00:00',1.33),('8348','2013-10-14','16:05:00',1.08),('8348','2013-10-13','09:15:00',1.14),('8348','2013-10-13','09:20:00',1.22),('8348','2013-10-13','09:25:00',1.12),('8348','2013-10-13','09:35:00',1.08),('8348','2013-10-13','09:40:00',1.42),('8348','2013-10-13','09:45:00',1.89),('8348','2013-10-13','09:50:00',1.94),('8348','2013-10-13','09:55:00',2.02),('8348','2013-10-13','10:00:00',1.57),('8348','2013-10-13','10:05:00',1.21),('8348','2013-10-13','10:10:00',1.61),('8348','2013-10-13','10:15:00',1.77),('8348','2013-10-13','10:20:00',1.49),('8348','2013-10-13','10:25:00',1.64),('8348','2013-10-13','10:30:00',2.09),('8348','2013-10-13','10:35:00',2.42),('8348','2013-10-13','10:40:00',2.51),('8348','2013-10-13','10:45:00',2.57),('8348','2013-10-13','10:50:00',2.34),('8348','2013-10-13','10:55:00',1.81),('8348','2013-10-13','11:00:00',2.32),('8348','2013-10-13','11:05:00',2.26),('8348','2013-10-13','11:10:00',2.38),('8348','2013-10-13','11:15:00',2.49),('8348','2013-10-13','11:20:00',2.39),('8348','2013-10-13','11:25:00',2.34),('8348','2013-10-13','11:30:00',2.41),('8348','2013-10-13','11:35:00',2.4),('8348','2013-10-13','11:40:00',2.41),('8348','2013-10-13','11:45:00',2.42),('8348','2013-10-13','11:50:00',2.46),('8348','2013-10-13','11:55:00',2.47),('8348','2013-10-13','12:00:00',2.5),('8348','2013-10-13','12:05:00',2.51),('8348','2013-10-13','12:10:00',2.52),('8348','2013-10-13','12:15:00',2.55),('8348','2013-10-13','12:20:00',2.51),('8348','2013-10-13','12:25:00',2.48),('8348','2013-10-13','12:30:00',2.59),('8348','2013-10-13','12:35:00',2.62),('8348','2013-10-13','12:40:00',2.63),('8348','2013-10-13','12:45:00',2.61),('8348','2013-10-13','12:50:00',2.6),('8348','2013-10-13','12:55:00',2.6),('8348','2013-10-13','13:00:00',2.61),('8348','2013-10-13','13:05:00',2.61),('8348','2013-10-13','13:10:00',2.66),('8348','2013-10-13','13:15:00',2.68),('8348','2013-10-13','13:20:00',2.69),('8348','2013-10-13','13:25:00',2.43),('8348','2013-10-13','13:30:00',2.02),('8348','2013-10-13','13:35:00',2.39),('8348','2013-10-13','13:40:00',1.53),('8348','2013-10-13','13:45:00',1.79),('8348','2013-10-13','13:50:00',1.97),('8348','2013-10-13','13:55:00',2.05),('8348','2013-10-13','14:00:00',2.56),('8348','2013-10-13','14:05:00',2.63),('8348','2013-10-13','14:10:00',2.62),('8348','2013-10-13','14:15:00',2.48),('8348','2013-10-13','14:20:00',2.64),('8348','2013-10-13','14:25:00',2.62),('8348','2013-10-13','14:30:00',2.37),('8348','2013-10-13','14:35:00',1.93),('8348','2013-10-13','14:40:00',2.33),('8348','2013-10-13','14:45:00',1.91),('8348','2013-10-13','14:50:00',1.52),('8348','2013-10-13','14:55:00',1.82),('8348','2013-10-13','15:00:00',2.26),('8348','2013-10-13','15:05:00',2.06),('8348','2013-10-13','15:10:00',1.46),('8348','2013-10-13','15:15:00',1.6),('8348','2013-10-13','15:20:00',1.88),('8348','2013-10-13','15:25:00',1.97),('8348','2013-10-13','15:30:00',1.51),('8348','2013-10-13','15:35:00',1.38),('8348','2013-10-13','15:40:00',1.35),('8348','2013-10-13','15:45:00',1.26),('8348','2013-10-13','15:50:00',1.21),('8348','2013-10-13','15:55:00',1.15),('8348','2013-10-13','16:00:00',1.3),('8348','2013-10-13','16:05:00',1.58),('8348','2013-10-13','16:10:00',1.35),('8348','2013-10-13','16:15:00',1.16),('8348','2013-10-13','16:20:00',1.2),('8348','2013-10-13','16:25:00',1.62),('8348','2013-10-13','16:30:00',1.61),('8348','2013-10-13','16:35:00',1.43),('8348','2013-10-13','16:40:00',1.07),('8348','2013-10-12','11:25:00',1.08),('8348','2013-10-12','11:30:00',1.25),('8348','2013-10-12','11:35:00',1.69),('8348','2013-10-12','11:40:00',2.51),('8348','2013-10-12','11:45:00',1.37),('8348','2013-10-12','11:50:00',1.26),('8348','2013-10-12','11:55:00',1.08),('8348','2013-10-12','12:15:00',1),('8348','2013-10-12','12:20:00',1.67),('8348','2013-10-12','12:25:00',2.96),('8348','2013-10-12','12:30:00',2.2),('8348','2013-10-12','12:35:00',2.6),('8348','2013-10-12','12:40:00',2.69),('8348','2013-10-12','12:45:00',2.45),('8348','2013-10-12','12:50:00',2.45),('8348','2013-10-12','12:55:00',2.18),('8348','2013-10-12','13:00:00',1.71),('8348','2013-10-12','13:15:00',1.04),('8348','2013-10-12','13:20:00',1.23),('8348','2013-10-12','13:25:00',1.38),('8348','2013-10-12','13:30:00',2.95),('8348','2013-10-12','13:35:00',1.32),('8348','2013-10-12','16:00:00',1.03),('8348','2013-10-12','16:10:00',1.02),('8348','2013-10-12','16:15:00',1.67),('8348','2013-10-12','16:20:00',1.64),('8348','2013-10-11','09:45:00',1.48),('8348','2013-10-11','09:50:00',1.56),('8348','2013-10-11','09:55:00',1.63),('8348','2013-10-11','10:00:00',1.7),('8348','2013-10-11','10:05:00',1.77),('8348','2013-10-11','10:10:00',1.84),('8348','2013-10-11','10:15:00',1.69),('8348','2013-10-11','10:20:00',1.8),('8348','2013-10-11','10:25:00',1.86),('8348','2013-10-11','10:30:00',2.16),('8348','2013-10-11','10:35:00',2.36),('8348','2013-10-11','10:40:00',1.65),('8348','2013-10-11','11:05:00',2.21),('8348','2013-10-11','11:10:00',1.83),('8348','2013-10-11','11:35:00',1.04),('8348','2013-10-11','11:40:00',2.06),('8348','2013-10-11','11:45:00',1.55),('8348','2013-10-11','11:50:00',1.76),('8348','2013-10-11','11:55:00',1.68),('8348','2013-10-11','12:00:00',2.06),('8348','2013-10-11','12:05:00',2.94),('8348','2013-10-11','12:10:00',1.58),('8348','2013-10-11','12:15:00',1.11),('8348','2013-10-11','12:25:00',1.16),('8348','2013-10-11','12:30:00',1.56),('8348','2013-10-11','13:05:00',1.86),('8348','2013-10-11','13:10:00',1.47),('8348','2013-10-11','13:15:00',1.18),('8348','2013-10-11','13:20:00',1.77),('8348','2013-10-11','13:25:00',3.91),('8348','2013-10-11','13:30:00',1.49),('8348','2013-10-11','13:40:00',2.42),('8348','2013-10-11','13:45:00',3.07),('8348','2013-10-11','13:50:00',1.23),('8348','2013-10-11','15:35:00',1.03),('8348','2013-10-11','15:40:00',1.47),('8348','2013-10-11','15:45:00',1.03),('8348','2013-10-11','16:00:00',2.07),('8348','2013-10-11','16:05:00',1.03),('8348','2013-10-11','16:35:00',1.03),('8348','2013-10-11','17:00:00',1.03),('8348','2013-10-10','09:15:00',1.07),('8348','2013-10-10','09:20:00',1.11),('8348','2013-10-10','09:25:00',1.14),('8348','2013-10-10','09:30:00',1.22),('8348','2013-10-10','09:40:00',1.18),('8348','2013-10-10','09:45:00',1.25),('8348','2013-10-10','09:50:00',1.25),('8348','2013-10-10','09:55:00',1.47),('8348','2013-10-10','10:10:00',1.06),('8348','2013-10-10','10:15:00',1.9),('8348','2013-10-10','10:20:00',1.93),('8348','2013-10-10','10:25:00',1.72),('8348','2013-10-10','10:35:00',1.02),('8348','2013-10-10','10:40:00',1.42),('8348','2013-10-10','10:45:00',2.11),('8348','2013-10-10','10:50:00',2.25),('8348','2013-10-10','10:55:00',1.79),('8348','2013-10-10','11:05:00',1.33),('8348','2013-10-10','11:20:00',1.25),('8348','2013-10-10','11:25:00',2.72),('8348','2013-10-10','11:30:00',1.28),('8348','2013-10-10','11:35:00',2.12),('8348','2013-10-10','11:40:00',1.58),('8348','2013-10-10','11:50:00',1.89),('8348','2013-10-10','11:55:00',2.54),('8348','2013-10-10','12:00:00',2.96),('8348','2013-10-10','12:05:00',3.01),('8348','2013-10-10','12:10:00',1.48),('8348','2013-10-10','12:20:00',1.64),('8348','2013-10-10','12:25:00',3.4),('8348','2013-10-10','12:35:00',2.46),('8348','2013-10-10','12:40:00',3.32),('8348','2013-10-10','12:45:00',2.41),('8348','2013-10-10','12:50:00',1.08),('8348','2013-10-10','12:55:00',2.61),('8348','2013-10-10','13:00:00',3.55),('8348','2013-10-10','13:05:00',3.45),('8348','2013-10-10','13:10:00',3.27),('8348','2013-10-10','13:15:00',1.69),('8348','2013-10-10','13:20:00',1.35),('8348','2013-10-10','13:25:00',3),('8348','2013-10-10','13:30:00',3.26),('8348','2013-10-10','13:35:00',2.19),('8348','2013-10-10','13:40:00',1.43),('8348','2013-10-10','13:45:00',2.47),('8348','2013-10-10','13:50:00',3.44),('8348','2013-10-10','13:55:00',3.1),('8348','2013-10-10','14:00:00',3.02),('8348','2013-10-10','14:05:00',3.09),('8348','2013-10-10','14:10:00',2.33),('8348','2013-10-10','14:15:00',1.89),('8348','2013-10-10','14:20:00',2.65),('8348','2013-10-10','14:25:00',3.22),('8348','2013-10-10','14:30:00',3.25),('8348','2013-10-10','14:35:00',3.19),('8348','2013-10-10','14:40:00',3.03),('8348','2013-10-10','14:45:00',2.88),('8348','2013-10-10','14:50:00',2.78),('8348','2013-10-10','14:55:00',2.59),('8348','2013-10-10','15:00:00',2.59),('8348','2013-10-10','15:05:00',2.71),('8348','2013-10-10','15:10:00',2.7),('8348','2013-10-10','15:15:00',1.96),('8348','2013-10-10','15:20:00',1.84),('8348','2013-10-10','15:25:00',2.22),('8348','2013-10-10','15:30:00',2.24),('8348','2013-10-10','15:35:00',1.28),('8348','2013-10-10','15:40:00',1.93),('8348','2013-10-10','15:45:00',1.33),('8348','2013-10-10','15:50:00',1.15),('8348','2013-10-10','15:55:00',1.58),('8348','2013-10-10','16:00:00',1.16),('8348','2013-10-10','16:15:00',1.01),('8348','2013-10-10','16:20:00',1.22),('8348','2013-10-10','16:25:00',1.42),('8348','2013-10-10','16:30:00',1.23),('8348','2013-10-10','16:45:00',1.4),('8348','2013-10-10','16:50:00',1.22),('8348','2013-10-10','16:55:00',1.29),('8348','2013-10-10','17:00:00',1.14),('8348','2013-10-10','17:20:00',1.03),('8348','2013-10-09','09:10:00',1.02),('8348','2013-10-09','09:20:00',1.01),('8348','2013-10-09','09:25:00',1.19),('8348','2013-10-09','09:30:00',1.27),('8348','2013-10-09','09:35:00',1.37),('8348','2013-10-09','09:40:00',1.5),('8348','2013-10-09','09:45:00',1.6),('8348','2013-10-09','09:50:00',1.67),('8348','2013-10-09','09:55:00',1.76),('8348','2013-10-09','10:00:00',1.9),('8348','2013-10-09','10:05:00',1.99),('8348','2013-10-09','10:10:00',1.75),('8348','2013-10-09','10:15:00',1.14),('8348','2013-10-09','10:30:00',1.04),('8348','2013-10-09','10:35:00',1.1),('8348','2013-10-09','10:40:00',1.02),('8348','2013-10-09','10:45:00',1.15),('8348','2013-10-09','10:50:00',2.86),('8348','2013-10-09','10:55:00',2.56),('8348','2013-10-09','11:00:00',2.22),('8348','2013-10-09','11:05:00',3.12),('8348','2013-10-09','11:10:00',3.2),('8348','2013-10-09','11:15:00',3.13),('8348','2013-10-09','11:20:00',3),('8348','2013-10-09','11:25:00',2.53),('8348','2013-10-09','11:30:00',3.22),('8348','2013-10-09','11:35:00',3.36),('8348','2013-10-09','11:40:00',3.34),('8348','2013-10-09','11:45:00',3.01),('8348','2013-10-09','11:50:00',2.85),('8348','2013-10-09','11:55:00',2.93),('8348','2013-10-09','12:00:00',1.6),('8348','2013-10-09','12:05:00',1.78),('8348','2013-10-09','12:10:00',1.65),('8348','2013-10-09','12:15:00',3.76),('8348','2013-10-09','12:20:00',3.22),('8348','2013-10-09','12:25:00',2.31),('8348','2013-10-09','12:30:00',1.37),('8348','2013-10-09','12:35:00',1.7),('8348','2013-10-09','12:40:00',1.39),('8348','2013-10-09','13:15:00',1.1),('8348','2013-10-09','13:20:00',1.6),('8348','2013-10-09','13:25:00',2.89),('8348','2013-10-09','13:30:00',3.15),('8348','2013-10-09','13:35:00',2.68),('8348','2013-10-09','13:40:00',2.23),('8348','2013-10-09','13:45:00',2.28),('8348','2013-10-09','13:50:00',1.67),('8348','2013-10-09','13:55:00',2.62),('8348','2013-10-09','14:00:00',3.19),('8348','2013-10-09','14:05:00',1.86),('8348','2013-10-09','14:10:00',1.29),('8348','2013-10-09','14:55:00',2.37),('8348','2013-10-09','15:00:00',1.02),('8348','2013-10-09','15:05:00',3),('8348','2013-10-09','15:10:00',2.75),('8348','2013-10-09','15:15:00',2.72),('8348','2013-10-09','15:20:00',2.42),('8348','2013-10-09','15:25:00',2.63),('8348','2013-10-09','15:30:00',1.9),('8348','2013-10-09','15:35:00',1.62),('8348','2013-10-09','15:40:00',1.8),('8348','2013-10-09','15:45:00',1.2),('8348','2013-10-09','15:50:00',1.03),('8348','2013-10-09','16:15:00',1.15),('8348','2013-10-09','16:20:00',1.49),('8348','2013-10-09','16:25:00',1.7),('8348','2013-10-09','16:30:00',2.13),('8348','2013-10-09','16:35:00',1.56),('8348','2013-10-09','16:40:00',1.44),('8348','2013-10-09','17:35:00',1.21),('8348','2014-04-15','07:00:00',1.21),('8348','2014-04-15','07:55:00',1.24),('8348','2014-04-15','08:00:00',2.84),('8348','2014-04-15','08:05:00',2.91),('8348','2014-04-15','08:10:00',2.19),('8348','2014-04-15','08:15:00',3.43),('8348','2014-04-15','08:20:00',3.99),('8348','2014-04-15','08:25:00',4.44),('8348','2014-04-15','08:30:00',4.08),('8348','2014-04-15','08:35:00',1.86),('8348','2014-04-15','08:40:00',1.02),('8348','2014-04-15','08:45:00',2.06),('8348','2014-04-15','08:50:00',4.82),('8348','2014-04-15','08:55:00',1.61),('8348','2014-04-15','09:00:00',2.31),('8348','2014-04-15','09:05:00',2.71),('8348','2014-04-15','09:10:00',3.02),('8348','2014-04-15','09:15:00',3.5),('8348','2014-04-15','09:20:00',3.96),('8348','2014-04-15','09:25:00',2.91),('8348','2014-04-15','09:30:00',5.79),('8348','2014-04-15','09:35:00',3.92),('8348','2014-04-15','09:40:00',3.97),('8348','2014-04-15','09:45:00',4.54),('8348','2014-04-15','09:50:00',4.89),('8348','2014-04-15','09:55:00',3.12),('8348','2014-04-15','10:00:00',3.41),('8348','2014-04-15','10:05:00',5.56),('8348','2014-04-15','10:10:00',3.52),('8348','2014-04-15','10:15:00',2.53),('8348','2014-04-15','10:20:00',1.85),('8348','2014-04-15','10:25:00',2.9),('8348','2014-04-15','10:30:00',2.2),('8348','2014-04-15','10:35:00',1.82),('8348','2014-04-15','10:40:00',1.13),('8348','2014-04-15','10:45:00',1.72),('8348','2014-04-15','10:50:00',2.57),('8348','2014-04-15','10:55:00',1.91),('8348','2014-04-15','11:00:00',1.27),('8348','2014-04-15','11:05:00',1.44),('8348','2014-04-15','11:10:00',1.88),('8348','2014-04-15','11:15:00',3.02),('8348','2014-04-15','11:20:00',3.08),('8348','2014-04-15','11:25:00',1.62),('8348','2014-04-15','11:30:00',1.09),('8348','2014-04-15','11:35:00',1.31),('8348','2014-04-15','11:40:00',1.13),('8348','2014-04-15','12:05:00',1.64),('8348','2014-04-15','12:10:00',2.6),('8348','2014-04-15','12:15:00',3.73),('8348','2014-04-15','12:20:00',4.76),('8348','2014-04-15','12:25:00',3.35),('8348','2014-04-15','12:30:00',4.92),('8348','2014-04-15','12:35:00',5.05),('8348','2014-04-15','12:40:00',3.1),('8348','2014-04-15','12:45:00',1.53),('8348','2014-04-15','12:50:00',1.25),('8348','2014-04-15','12:55:00',1.71),('8348','2014-04-15','13:00:00',4.86),('8348','2014-04-15','13:05:00',3.14),('8348','2014-04-15','13:10:00',3.29),('8348','2014-04-15','13:15:00',6.86),('8348','2014-04-15','13:20:00',6.65),('8348','2014-04-15','13:25:00',5.98),('8348','2014-04-15','13:30:00',3.8),('8348','2014-04-15','13:35:00',3.02),('8348','2014-04-15','13:40:00',4.33),('8348','2014-04-15','13:45:00',4.13),('8348','2014-04-15','13:50:00',5.8),('8348','2014-04-15','13:55:00',3.29),('8348','2014-04-15','14:00:00',1.61),('8348','2014-04-15','14:05:00',2.14),('8348','2014-04-15','14:10:00',2.14),('8348','2014-04-15','14:15:00',4.8),('8348','2014-04-15','14:20:00',3.5),('8348','2014-04-15','14:25:00',4.09),('8348','2014-04-15','14:30:00',2.95),('8348','2014-04-15','14:35:00',2.76),('8348','2014-04-15','14:40:00',2.71),('8348','2014-04-15','14:45:00',2.55),('8348','2014-04-15','14:50:00',2.65),('8348','2014-04-15','14:55:00',2.63),('8348','2014-04-15','15:00:00',2.61),('8348','2014-04-15','15:05:00',2.74),('8348','2014-04-15','15:10:00',1.54),('8348','2014-04-15','15:15:00',1.17),('8348','2013-10-08','10:55:00',1.01),('8348','2013-10-08','11:00:00',1.51),('8348','2013-10-08','11:10:00',1.57),('8348','2013-10-08','11:15:00',2.62),('8348','2013-10-08','11:20:00',3.3),('8348','2013-10-08','11:25:00',1.84),('8348','2013-10-08','11:30:00',2.23),('8348','2013-10-08','11:35:00',1.62),('8348','2013-10-08','11:40:00',1.39),('8348','2013-10-08','11:45:00',1.26),('8348','2013-10-08','12:20:00',1),('8348','2013-10-08','12:25:00',1.32),('8348','2013-10-08','12:30:00',2.35),('8348','2013-10-08','12:35:00',1.85),('8348','2013-10-08','12:40:00',3.53),('8348','2013-10-08','12:45:00',3.5),('8348','2013-10-08','12:50:00',2.83),('8348','2013-10-08','12:55:00',2.9),('8348','2013-10-08','13:00:00',3.28),('8348','2013-10-08','13:05:00',2.57),('8348','2013-10-08','13:10:00',1.51),('8348','2013-10-08','13:15:00',2.89),('8348','2013-10-08','13:20:00',1.26),('8348','2013-10-08','13:25:00',2.37),('8348','2013-10-08','13:30:00',1.44),('8348','2013-10-08','13:35:00',1.25),('8348','2013-10-08','13:40:00',1.03),('8348','2013-10-08','14:05:00',1.17),('8348','2013-10-08','14:10:00',1.67),('8348','2013-10-08','14:15:00',1.91),('8348','2013-10-08','14:20:00',2.41),('8348','2013-10-08','14:25:00',2.54),('8348','2013-10-08','14:30:00',2.42),('8348','2013-10-08','14:35:00',1.19),('8348','2013-10-08','14:40:00',1.36),('8348','2013-10-08','14:45:00',2.6),('8348','2013-10-08','14:50:00',2.91),('8348','2013-10-08','14:55:00',2.74),('8348','2013-10-08','15:00:00',2.67),('8348','2013-10-08','15:05:00',2.64),('8348','2013-10-08','15:10:00',2.68),('8348','2013-10-08','15:15:00',2.64),('8348','2013-10-08','15:20:00',1.68),('8348','2013-10-08','15:25:00',3.08),('8348','2013-10-08','15:30:00',3.06),('8348','2013-10-08','15:35:00',2.69),('8348','2013-10-08','15:40:00',1.78),('8348','2013-10-08','15:45:00',1.35),('8348','2013-10-08','15:50:00',2.03),('8348','2013-10-08','15:55:00',1.34),('8348','2013-10-08','16:00:00',1.04),('8348','2013-10-07','09:05:00',1.11),('8348','2013-10-07','09:10:00',1.03),('8348','2013-10-07','09:15:00',1.08),('8348','2013-10-07','09:20:00',1.15),('8348','2013-10-07','09:25:00',1.21),('8348','2013-10-07','09:30:00',1.29),('8348','2013-10-07','09:35:00',1.35),('8348','2013-10-07','09:40:00',1.44),('8348','2013-10-07','09:45:00',1.53),('8348','2013-10-07','09:50:00',1.6),('8348','2013-10-07','09:55:00',1.65),('8348','2013-10-07','10:00:00',1.71),('8348','2013-10-07','10:05:00',1.77),('8348','2013-10-07','10:10:00',1.78),('8348','2013-10-07','10:15:00',1.89),('8348','2013-10-07','10:20:00',1.94),('8348','2013-10-07','10:25:00',1.87),('8348','2013-10-07','10:30:00',2.07),('8348','2013-10-07','10:35:00',2.24),('8348','2013-10-07','10:40:00',2.19),('8348','2013-10-07','10:45:00',2.21),('8348','2013-10-07','10:50:00',2.25),('8348','2013-10-07','10:55:00',2.04),('8348','2013-10-07','11:00:00',2.56),('8348','2013-10-07','11:05:00',2.46),('8348','2013-10-07','11:10:00',1.48),('8348','2013-10-07','11:15:00',2.44),('8348','2013-10-07','11:20:00',2.42),('8348','2013-10-07','11:25:00',2.46),('8348','2013-10-07','11:30:00',2.57),('8348','2013-10-07','11:35:00',2.59),('8348','2013-10-07','11:40:00',2.62),('8348','2013-10-07','11:45:00',2.45),('8348','2013-10-07','11:50:00',2.71),('8348','2013-10-07','11:55:00',2.73),('8348','2013-10-07','12:00:00',2.74),('8348','2013-10-07','12:05:00',2.82),('8348','2013-10-07','12:10:00',2.88),('8348','2013-10-07','12:15:00',2.36),('8348','2013-10-07','12:20:00',1.04),('8348','2013-10-07','12:25:00',3.23),('8348','2013-10-07','12:30:00',3.28),('8348','2013-10-07','12:35:00',3.06),('8348','2013-10-07','12:40:00',2.92),('8348','2013-10-07','12:45:00',3.12),('8348','2013-10-07','12:50:00',2.88),('8348','2013-10-07','12:55:00',2.5),('8348','2013-10-07','13:00:00',3.23),('8348','2013-10-07','13:05:00',3.02),('8348','2013-10-07','13:10:00',3.25),('8348','2013-10-07','13:15:00',3.18),('8348','2013-10-07','13:20:00',3.39),('8348','2013-10-07','13:25:00',1.78),('8348','2013-10-07','13:30:00',1.43),('8348','2013-10-07','13:35:00',1.48),('8348','2013-10-07','13:40:00',2.11),('8348','2013-10-07','13:45:00',1.64),('8348','2013-10-07','13:50:00',1.26),('8348','2013-10-07','13:55:00',3.65),('8348','2013-10-07','14:00:00',3.37),('8348','2013-10-07','14:05:00',2.75),('8348','2013-10-07','14:10:00',1.27),('8348','2013-10-07','14:20:00',1.31),('8348','2013-10-07','14:25:00',1.23),('8348','2013-10-07','14:30:00',1.68),('8348','2013-10-07','14:35:00',3.43),('8348','2013-10-07','14:40:00',3.1),('8348','2013-10-07','14:45:00',1.79),('8348','2013-10-07','14:50:00',2.72),('8348','2013-10-07','14:55:00',2.78),('8348','2013-10-07','15:00:00',2.96),('8348','2013-10-07','15:05:00',1.98),('8348','2013-10-07','15:10:00',2.82),('8348','2013-10-07','15:15:00',1.95),('8348','2013-10-07','15:20:00',1.86),('8348','2013-10-07','15:25:00',2.48),('8348','2013-10-07','15:30:00',1.28),('8348','2013-10-07','15:35:00',1.4),('8348','2013-10-07','15:40:00',1.52),('8348','2013-10-07','15:45:00',2.85),('8348','2013-10-07','15:50:00',2.63),('8348','2013-10-07','15:55:00',1.14),('8348','2013-10-07','16:00:00',1.16),('8348','2013-10-07','16:05:00',2.04),('8348','2013-10-07','16:10:00',2.22),('8348','2013-10-07','16:15:00',2.07),('8348','2013-10-07','16:20:00',1.53),('8348','2013-10-07','16:25:00',1.52),('8348','2013-10-07','16:30:00',1.27),('8348','2013-10-07','16:35:00',1.13),('8348','2013-10-07','16:40:00',1.69),('8348','2013-10-07','16:45:00',1.61),('8348','2013-10-07','16:50:00',1.51),('8348','2013-10-07','16:55:00',1.39),('8348','2013-10-07','17:00:00',1.01),('8348','2013-10-07','17:05:00',1.18),('8348','2013-10-07','17:10:00',1.1),('8348','2013-10-07','17:15:00',1.03),('8348','2013-10-06','09:35:00',1.2),('8348','2013-10-06','09:40:00',1.09),('8348','2013-10-06','09:50:00',1.63),('8348','2013-10-06','09:55:00',1.87),('8348','2013-10-06','10:00:00',2.18),('8348','2013-10-06','10:05:00',2.23),('8348','2013-10-06','10:10:00',2.18),('8348','2013-10-06','10:15:00',2.02),('8348','2013-10-06','10:20:00',2.07),('8348','2013-10-06','10:25:00',2.3),('8348','2013-10-06','10:30:00',2.28),('8348','2013-10-06','10:35:00',2.25),('8348','2013-10-06','10:40:00',1.94),('8348','2013-10-06','10:45:00',1.58),('8348','2013-10-06','10:50:00',1.75),('8348','2013-10-06','10:55:00',1.83),('8348','2013-10-06','11:00:00',1.94),('8348','2013-10-06','11:05:00',2.15),('8348','2013-10-06','11:10:00',2.25),('8348','2013-10-06','11:15:00',2.22),('8348','2013-10-06','11:20:00',2.26),('8348','2013-10-06','11:25:00',2.33),('8348','2013-10-06','11:30:00',2.28),('8348','2013-10-06','11:35:00',2.25),('8348','2013-10-06','11:40:00',2.34),('8348','2013-10-06','11:45:00',1.68),('8348','2013-10-06','11:50:00',1.72),('8348','2013-10-06','11:55:00',2.16),('8348','2013-10-06','12:00:00',2.1),('8348','2013-10-06','12:05:00',2.06),('8348','2013-10-06','12:10:00',2.29),('8348','2013-10-06','12:15:00',2.59),('8348','2013-10-06','12:20:00',2.61),('8348','2013-10-06','12:25:00',2.21),('8348','2013-10-06','12:30:00',2.07),('8348','2013-10-06','12:35:00',2.21),('8348','2013-10-06','12:40:00',2.13),('8348','2013-10-06','12:45:00',2.18),('8348','2013-10-06','12:50:00',2.34),('8348','2013-10-06','12:55:00',2.61),('8348','2013-10-06','13:00:00',2.03),('8348','2013-10-06','13:05:00',2.56),('8348','2013-10-06','13:10:00',2.6),('8348','2013-10-06','13:15:00',3.24),('8348','2013-10-06','13:20:00',1.51),('8348','2013-10-06','13:45:00',1.11),('8348','2013-10-06','13:50:00',3.19),('8348','2013-10-06','13:55:00',2.25),('8348','2013-10-06','14:00:00',2.11),('8348','2013-10-06','14:05:00',2.66),('8348','2013-10-06','14:10:00',2.04),('8348','2013-10-06','14:15:00',1.52),('8348','2013-10-06','14:20:00',1.53),('8348','2013-10-06','14:25:00',1.73),('8348','2013-10-06','14:30:00',2.02),('8348','2013-10-06','14:35:00',1.79),('8348','2013-10-06','14:40:00',1.41),('8348','2013-10-06','14:45:00',1.56),('8348','2013-10-06','14:50:00',1.72),('8348','2013-10-06','14:55:00',2.06),('8348','2013-10-06','15:00:00',1.9),('8348','2013-10-06','15:05:00',1.37),('8348','2013-10-06','15:10:00',1.1),('8348','2013-10-06','15:15:00',1.11),('8348','2013-10-05','16:05:00',1.12),('8348','2013-10-05','16:10:00',1.09),('8348','2013-10-05','16:20:00',1.03),('8348','2013-10-05','16:25:00',1.01),('8348','2013-10-04','09:50:00',1.13),('8348','2013-10-04','09:55:00',2.22),('8348','2013-10-04','10:00:00',1.61),('8348','2013-10-04','10:05:00',1.24),('8348','2013-10-04','10:10:00',1.29),('8348','2013-10-04','10:15:00',1.48),('8348','2013-10-04','10:20:00',1.23),('8348','2013-10-04','10:25:00',1.62),('8348','2013-10-04','10:30:00',2.11),('8348','2013-10-04','10:35:00',1.41),('8348','2013-10-04','10:40:00',2.04),('8348','2013-10-04','10:45:00',1.6),('8348','2013-10-04','10:50:00',1.62),('8348','2013-10-04','10:55:00',2.51),('8348','2013-10-04','11:00:00',1.73),('8348','2013-10-04','11:05:00',1.41),('8348','2013-10-04','11:10:00',1.46),('8348','2013-10-04','11:15:00',2.23),('8348','2013-10-04','11:20:00',2.46),('8348','2013-10-04','11:25:00',2.31),('8348','2013-10-04','11:30:00',2.83),('8348','2013-10-04','11:35:00',2.98),('8348','2013-10-04','11:40:00',2.88),('8348','2013-10-04','11:45:00',2.84),('8348','2013-10-04','11:50:00',2.83),('8348','2013-10-04','11:55:00',2.82),('8348','2013-10-04','12:00:00',2.86),('8348','2013-10-04','12:05:00',2.88),('8348','2013-10-04','12:10:00',2.89),('8348','2013-10-04','12:15:00',2.68),('8348','2013-10-04','12:20:00',2.84),('8348','2013-10-04','12:25:00',2.99),('8348','2013-10-04','12:30:00',3.01),('8348','2013-10-04','12:35:00',2.75),('8348','2013-10-04','12:40:00',2.93),('8348','2013-10-04','12:45:00',2.95),('8348','2013-10-04','12:50:00',2.86),('8348','2013-10-04','12:55:00',2.89),('8348','2013-10-04','13:00:00',2.9),('8348','2013-10-04','13:05:00',2.97),('8348','2013-10-04','13:10:00',3),('8348','2013-10-04','13:15:00',3.14),('8348','2013-10-04','13:20:00',3.05),('8348','2013-10-04','13:25:00',2.85),('8348','2013-10-04','13:30:00',3.07),('8348','2013-10-04','13:35:00',3.01),('8348','2013-10-04','13:40:00',2.91),('8348','2013-10-04','13:45:00',2.87),('8348','2013-10-04','13:50:00',2.85),('8348','2013-10-04','13:55:00',2.85),('8348','2013-10-04','14:00:00',2.87),('8348','2013-10-04','14:05:00',2.86),('8348','2013-10-04','14:10:00',2.59),('8348','2013-10-04','14:15:00',2.34),('8348','2013-10-04','14:20:00',2.65),('8348','2013-10-04','14:25:00',2.79),('8348','2013-10-04','14:30:00',2.44),('8348','2013-10-04','14:35:00',1.67),('8348','2013-10-04','14:40:00',1.45),('8348','2013-10-04','14:45:00',1.69),('8348','2013-10-04','14:50:00',2.2),('8348','2013-10-04','14:55:00',2.18),('8348','2013-10-04','15:00:00',1.91),('8348','2013-10-04','15:05:00',2.12),('8348','2013-10-04','15:10:00',1.81),('8348','2013-10-04','15:15:00',1.43),('8348','2013-10-04','15:20:00',1.31),('8348','2013-10-04','15:25:00',2.15),('8348','2013-10-04','15:30:00',2.2),('8348','2013-10-04','15:35:00',1.16),('8348','2013-10-04','16:05:00',1.01),('8348','2013-10-03','09:05:00',1.03),('8348','2013-10-03','09:10:00',1.1),('8348','2013-10-03','09:15:00',1.16),('8348','2013-10-03','09:20:00',1.26),('8348','2013-10-03','09:25:00',1.35),('8348','2013-10-03','09:30:00',1.42),('8348','2013-10-03','09:35:00',1.51),('8348','2013-10-03','09:40:00',1.61),('8348','2013-10-03','09:45:00',1.7),('8348','2013-10-03','09:50:00',1.76),('8348','2013-10-03','09:55:00',1.83),('8348','2013-10-03','10:00:00',1.9),('8348','2013-10-03','10:05:00',1.98),('8348','2013-10-03','10:10:00',2.04),('8348','2013-10-03','10:15:00',2.1),('8348','2013-10-03','10:20:00',2.17),('8348','2013-10-03','10:25:00',2.23),('8348','2013-10-03','10:30:00',2.29),('8348','2013-10-03','10:35:00',2.35),('8348','2013-10-03','10:40:00',2.39),('8348','2013-10-03','10:45:00',2.45),('8348','2013-10-03','10:50:00',2.49),('8348','2013-10-03','10:55:00',2.54),('8348','2013-10-03','11:00:00',2.59),('8348','2013-10-03','11:05:00',2.63),('8348','2013-10-03','11:10:00',2.67),('8348','2013-10-03','11:15:00',2.72),('8348','2013-10-03','11:20:00',2.76),('8348','2013-10-03','11:25:00',2.8),('8348','2013-10-03','11:30:00',2.83),('8348','2013-10-03','11:35:00',2.87),('8348','2013-10-03','11:40:00',2.92),('8348','2013-10-03','11:45:00',2.94),('8348','2013-10-03','11:50:00',2.98),('8348','2013-10-03','11:55:00',3.01),('8348','2013-10-03','12:00:00',3.03),('8348','2013-10-03','12:05:00',3.06),('8348','2013-10-03','12:10:00',3.06),('8348','2013-10-03','12:15:00',3.07),('8348','2013-10-03','12:20:00',3.09),('8348','2013-10-03','12:25:00',3.11),('8348','2013-10-03','12:30:00',3.12),('8348','2013-10-03','12:35:00',3.14),('8348','2013-10-03','12:40:00',3.16),('8348','2013-10-03','12:45:00',3.16),('8348','2013-10-03','12:50:00',3.17),('8348','2013-10-03','12:55:00',3.17),('8348','2013-10-03','13:00:00',3.15),('8348','2013-10-03','13:05:00',3.1),('8348','2013-10-03','13:10:00',3.14),('8348','2013-10-03','13:15:00',3.14),('8348','2013-10-03','13:20:00',3.15),('8348','2013-10-03','13:25:00',3.14),('8348','2013-10-03','13:30:00',3.16),('8348','2013-10-03','13:35:00',3.15),('8348','2013-10-03','13:40:00',3.13),('8348','2013-10-03','13:45:00',3.11),('8348','2013-10-03','13:50:00',3.09),('8348','2013-10-03','13:55:00',3.1),('8348','2013-10-03','14:00:00',3.1),('8348','2013-10-03','14:05:00',3.1),('8348','2013-10-03','14:10:00',3.08),('8348','2013-10-03','14:15:00',3.06),('8348','2013-10-03','14:20:00',3.03),('8348','2013-10-03','14:25:00',3),('8348','2013-10-03','14:30:00',2.98),('8348','2013-10-03','14:35:00',2.95),('8348','2013-10-03','14:40:00',2.91),('8348','2013-10-03','14:45:00',2.88),('8348','2013-10-03','14:50:00',2.86),('8348','2013-10-03','14:55:00',2.83),('8348','2013-10-03','15:00:00',2.77),('8348','2013-10-03','15:05:00',2.74),('8348','2013-10-03','15:10:00',2.7),('8348','2013-10-03','15:15:00',2.66),('8348','2013-10-03','15:20:00',2.61),('8348','2013-10-03','15:25:00',2.58),('8348','2013-10-03','15:30:00',2.53),('8348','2013-10-03','15:35:00',2.47),('8348','2013-10-03','15:40:00',2.41),('8348','2013-10-03','15:45:00',2.36),('8348','2013-10-03','15:50:00',2.31),('8348','2013-10-03','15:55:00',2.26),('8348','2013-10-03','16:00:00',2.2),('8348','2013-10-03','16:05:00',2.14),('8348','2013-10-03','16:10:00',2.08),('8348','2013-10-03','16:15:00',2.02),('8348','2013-10-03','16:20:00',1.95),('8348','2013-10-03','16:25:00',1.89),('8348','2013-10-03','16:30:00',1.82),('8348','2013-10-03','16:35:00',1.75),('8348','2013-10-03','16:40:00',1.68),('8348','2013-10-03','16:45:00',1.61),('8348','2013-10-03','16:50:00',1.53),('8348','2013-10-03','16:55:00',1.45),('8348','2013-10-03','17:00:00',1.38),('8348','2013-10-03','17:05:00',1.3),('8348','2013-10-03','17:10:00',1.23),('8348','2013-10-03','17:15:00',1.14),('8348','2013-10-03','17:20:00',1.06),('8348','2013-10-02','09:10:00',1.05),('8348','2013-10-02','09:15:00',1.15),('8348','2013-10-02','09:20:00',1.22),('8348','2013-10-02','09:25:00',1.3),('8348','2013-10-02','09:30:00',1.36),('8348','2013-10-02','09:35:00',1.45),('8348','2013-10-02','09:40:00',1.55),('8348','2013-10-02','09:45:00',1.62),('8348','2013-10-02','09:50:00',1.68),('8348','2013-10-02','09:55:00',1.75),('8348','2013-10-02','10:00:00',1.8),('8348','2013-10-02','10:05:00',1.86),('8348','2013-10-02','10:10:00',1.92),('8348','2013-10-02','10:15:00',1.97),('8348','2013-10-02','10:20:00',2.04),('8348','2013-10-02','10:25:00',2.1),('8348','2013-10-02','10:30:00',2.15),('8348','2013-10-02','10:35:00',2.21),('8348','2013-10-02','10:40:00',2.28),('8348','2013-10-02','10:45:00',2.34),('8348','2013-10-02','10:50:00',2.4),('8348','2013-10-02','10:55:00',2.45),('8348','2013-10-02','11:00:00',2.5),('8348','2013-10-02','11:05:00',2.55),('8348','2013-10-02','11:10:00',2.59),('8348','2013-10-02','11:15:00',2.63),('8348','2013-10-02','11:20:00',2.66),('8348','2013-10-02','11:25:00',2.69),('8348','2013-10-02','11:30:00',2.73),('8348','2013-10-02','11:35:00',2.75),('8348','2013-10-02','11:40:00',2.78),('8348','2013-10-02','11:45:00',2.82),('8348','2013-10-02','11:50:00',2.85),('8348','2013-10-02','11:55:00',2.88),('8348','2013-10-02','12:00:00',2.9),('8348','2013-10-02','12:05:00',2.91),('8348','2013-10-02','12:10:00',2.93),('8348','2013-10-02','12:15:00',2.95),('8348','2013-10-02','12:20:00',2.97),('8348','2013-10-02','12:25:00',2.97),('8348','2013-10-02','12:30:00',3),('8348','2013-10-02','12:35:00',3.02),('8348','2013-10-02','12:40:00',3.03),('8348','2013-10-02','12:45:00',3.04),('8348','2013-10-02','12:50:00',3.05),('8348','2013-10-02','12:55:00',3.07),('8348','2013-10-02','13:00:00',3.06),('8348','2013-10-02','13:05:00',3.08),('8348','2013-10-02','13:10:00',3.09),('8348','2013-10-02','13:15:00',3.07),('8348','2013-10-02','13:20:00',3.07),('8348','2013-10-02','13:25:00',3.07),('8348','2013-10-02','13:30:00',3.08),('8348','2013-10-02','13:35:00',3.06),('8348','2013-10-02','13:40:00',3.06),('8348','2013-10-02','13:45:00',3.05),('8348','2013-10-02','13:50:00',3.04),('8348','2013-10-02','13:55:00',3.03),('8348','2013-10-02','14:00:00',3.01),('8348','2013-10-02','14:05:00',3),('8348','2013-10-02','14:10:00',2.99),('8348','2013-10-02','14:15:00',2.97),('8348','2013-10-02','14:20:00',2.94),('8348','2013-10-02','14:25:00',2.92),('8348','2013-10-02','14:30:00',2.9),('8348','2013-10-02','14:35:00',2.87),('8348','2013-10-02','14:40:00',2.84),('8348','2013-10-02','14:45:00',2.81),('8348','2013-10-02','14:50:00',2.79),('8348','2013-10-02','14:55:00',2.77),('8348','2013-10-02','15:00:00',2.74),('8348','2013-10-02','15:05:00',2.69),('8348','2013-10-02','15:10:00',2.65),('8348','2013-10-02','15:15:00',2.61),('8348','2013-10-02','15:20:00',2.57),('8348','2013-10-02','15:25:00',2.51),('8348','2013-10-02','15:30:00',2.47),('8348','2013-10-02','15:35:00',2.42),('8348','2013-10-02','15:40:00',2.39),('8348','2013-10-02','15:45:00',2.34),('8348','2013-10-02','15:50:00',2.28),('8348','2013-10-02','15:55:00',2.22),('8348','2013-10-02','16:00:00',2.16),('8348','2013-10-02','16:05:00',2.11),('8348','2013-10-02','16:10:00',2.05),('8348','2013-10-02','16:15:00',1.99),('8348','2013-10-02','16:20:00',1.91),('8348','2013-10-02','16:25:00',1.85),('8348','2013-10-02','16:30:00',1.79),('8348','2013-10-02','16:35:00',1.73),('8348','2013-10-02','16:40:00',1.66),('8348','2013-10-02','16:45:00',1.58),('8348','2013-10-02','16:50:00',1.5),('8348','2013-10-02','16:55:00',1.43),('8348','2013-10-02','17:00:00',1.36),('8348','2013-10-02','17:05:00',1.28),('8348','2013-10-02','17:10:00',1.19),('8348','2013-10-02','17:15:00',1.11),('8348','2013-10-02','17:20:00',1.03),('8348','2013-10-01','09:05:00',1.02),('8348','2013-10-01','09:10:00',1.09),('8348','2013-10-01','09:15:00',1.16),('8348','2013-10-01','09:20:00',1.23),('8348','2013-10-01','09:25:00',1.3),('8348','2013-10-01','09:30:00',1.37),('8348','2013-10-01','09:35:00',1.45),('8348','2013-10-01','09:40:00',1.53),('8348','2013-10-01','09:45:00',1.6),('8348','2013-10-01','09:50:00',1.67),('8348','2013-10-01','09:55:00',1.72),('8348','2013-10-01','10:00:00',1.78),('8348','2013-10-01','10:05:00',1.82),('8348','2013-10-01','10:10:00',1.87),('8348','2013-10-01','10:15:00',1.96),('8348','2013-10-01','10:20:00',2.04),('8348','2013-10-01','10:25:00',2.08),('8348','2013-10-01','10:30:00',2.13),('8348','2013-10-01','10:35:00',2.19),('8348','2013-10-01','10:40:00',2.23),('8348','2013-10-01','10:45:00',2.27),('8348','2013-10-01','10:50:00',2.34),('8348','2013-10-01','10:55:00',2.38),('8348','2013-10-01','11:00:00',2.46),('8348','2013-10-01','11:05:00',2.66),('8348','2013-10-01','11:10:00',2.07),('8348','2013-10-01','11:15:00',1.06),('8348','2013-10-01','11:20:00',2.82),('8348','2013-10-01','11:25:00',2.57),('8348','2013-10-01','11:35:00',2.43),('8348','2013-10-01','11:40:00',2.97),('8348','2013-10-01','11:45:00',2.95),('8348','2013-10-01','11:50:00',2.59),('8348','2013-10-01','11:55:00',2.21),('8348','2013-10-01','12:00:00',3.03),('8348','2013-10-01','12:05:00',2.97),('8348','2013-10-01','12:10:00',3.01),('8348','2013-10-01','12:15:00',3.1),('8348','2013-10-01','12:20:00',3.14),('8348','2013-10-01','12:25:00',3.15),('8348','2013-10-01','12:30:00',2.95),('8348','2013-10-01','12:35:00',2.11),('8348','2013-10-01','12:40:00',1.93),('8348','2013-10-01','12:45:00',3.33),('8348','2013-10-01','12:50:00',3.17),('8348','2013-10-01','12:55:00',2.69),('8348','2013-10-01','13:00:00',3.21),('8348','2013-10-01','13:05:00',2.39),('8348','2013-10-01','13:15:00',1.86),('8348','2013-10-01','13:20:00',3.46),('8348','2013-10-01','13:25:00',3.57),('8348','2013-10-01','13:30:00',2.63),('8348','2013-10-01','13:35:00',3.44),('8348','2013-10-01','13:40:00',3.13),('8348','2013-10-01','13:45:00',3.18),('8348','2013-10-01','13:50:00',3.21),('8348','2013-10-01','13:55:00',3.06),('8348','2013-10-01','14:00:00',2.99),('8348','2013-10-01','14:05:00',2.99),('8348','2013-10-01','14:10:00',2.96),('8348','2013-10-01','14:15:00',2.91),('8348','2013-10-01','14:20:00',2.9),('8348','2013-10-01','14:25:00',2.91),('8348','2013-10-01','14:30:00',2.87),('8348','2013-10-01','14:35:00',2.84),('8348','2013-10-01','14:40:00',2.88),('8348','2013-10-01','14:45:00',2.93),('8348','2013-10-01','14:50:00',2.92),('8348','2013-10-01','14:55:00',2.84),('8348','2013-10-01','15:00:00',2.85),('8348','2013-10-01','15:05:00',2.74),('8348','2013-10-01','15:10:00',2.66),('8348','2013-10-01','15:15:00',2.62),('8348','2013-10-01','15:20:00',2.58),('8348','2013-10-01','15:25:00',2.55),('8348','2013-10-01','15:30:00',2.5),('8348','2013-10-01','15:35:00',2.46),('8348','2013-10-01','15:40:00',2.41),('8348','2013-10-01','15:45:00',2.35),('8348','2013-10-01','15:50:00',2.3),('8348','2013-10-01','15:55:00',2.24),('8348','2013-10-01','16:00:00',2.18),('8348','2013-10-01','16:05:00',2.13),('8348','2013-10-01','16:10:00',2.06),('8348','2013-10-01','16:15:00',2),('8348','2013-10-01','16:20:00',1.94),('8348','2013-10-01','16:25:00',1.88),('8348','2013-10-01','16:30:00',1.81),('8348','2013-10-01','16:35:00',1.74),('8348','2013-10-01','16:40:00',1.66),('8348','2013-10-01','16:45:00',1.59),('8348','2013-10-01','16:50:00',1.52),('8348','2013-10-01','16:55:00',1.46),('8348','2013-10-01','17:00:00',1.38),('8348','2013-10-01','17:05:00',1.3),('8348','2013-10-01','17:10:00',1.24),('8348','2013-10-01','17:15:00',1.14),('8348','2013-10-01','17:20:00',1.09),('8348','2013-10-01','17:25:00',1.01),('8348','2013-09-30','09:50:00',1.07),('8348','2013-09-30','10:25:00',1.08),('8348','2013-09-30','10:30:00',1.21),('8348','2013-09-30','10:35:00',1.33),('8348','2013-09-30','10:40:00',1.67),('8348','2013-09-30','10:45:00',2.45),('8348','2013-09-30','10:50:00',2.55),('8348','2013-09-30','10:55:00',2.38),('8348','2013-09-30','11:00:00',2.01),('8348','2013-09-30','11:05:00',2.19),('8348','2013-09-30','11:10:00',2.48),('8348','2013-09-30','11:15:00',2.17),('8348','2013-09-30','11:20:00',2.59),('8348','2013-09-30','11:25:00',1.56),('8348','2013-09-30','11:30:00',2.04),('8348','2013-09-30','11:40:00',3.28),('8348','2013-09-30','11:45:00',1.5),('8348','2013-09-30','11:50:00',1.35),('8348','2013-09-30','11:55:00',1.18),('8348','2013-09-30','12:00:00',1.51),('8348','2013-09-30','12:05:00',2.36),('8348','2013-09-30','12:10:00',2.34),('8348','2013-09-30','12:15:00',3.21),('8348','2013-09-30','12:20:00',3.34),('8348','2013-09-30','12:25:00',3.28),('8348','2013-09-30','12:30:00',3.14),('8348','2013-09-30','12:35:00',3.13),('8348','2013-09-30','12:40:00',3.03),('8348','2013-09-30','12:45:00',2.91),('8348','2013-09-30','12:50:00',3.2),('8348','2013-09-30','12:55:00',3.22),('8348','2013-09-30','13:00:00',2.98),('8348','2013-09-30','13:05:00',3.39),('8348','2013-09-30','13:10:00',3.16),('8348','2013-09-30','13:15:00',2.83),('8348','2013-09-30','13:20:00',3.71),('8348','2013-09-30','13:25:00',3.86),('8348','2013-09-30','13:30:00',3.56),('8348','2013-09-30','13:35:00',2.69),('8348','2013-09-30','13:40:00',2.56),('8348','2013-09-30','13:45:00',1.21),('8348','2013-09-30','13:50:00',3.19),('8348','2013-09-30','13:55:00',2.24),('8348','2013-09-30','14:00:00',1.26),('8348','2013-09-30','14:05:00',1.21),('8348','2013-09-30','14:10:00',1.19),('8348','2013-09-30','14:15:00',1.11),('8348','2013-09-30','14:25:00',1.06),('8348','2013-09-30','14:30:00',2.3),('8348','2013-09-30','14:35:00',2.46),('8348','2013-09-30','14:40:00',3.41),('8348','2013-09-30','14:45:00',2.66),('8348','2013-09-30','14:50:00',3.15),('8348','2013-09-30','14:55:00',1.64),('8348','2013-09-30','15:00:00',2.11),('8348','2013-09-30','15:05:00',2.56),('8348','2013-09-30','15:10:00',2.91),('8348','2013-09-30','15:15:00',1.38),('8348','2013-09-30','15:20:00',1.39),('8348','2013-09-30','15:25:00',2.98),('8348','2013-09-30','15:30:00',1.38),('8348','2013-09-30','15:35:00',2.68),('8348','2013-09-30','15:40:00',2.97),('8348','2013-09-30','15:45:00',1.57),('8348','2013-09-30','16:10:00',1.45),('8348','2013-09-30','16:15:00',1.76),('8348','2013-09-30','16:20:00',1.24),('8348','2013-09-30','16:45:00',1.18),('8348','2013-09-29','10:00:00',1.06),('8348','2013-09-29','10:05:00',1.38),('8348','2013-09-29','10:10:00',1.58),('8348','2013-09-29','10:15:00',1.98),('8348','2013-09-29','10:20:00',1.61),('8348','2013-09-29','10:25:00',1.54),('8348','2013-09-29','10:30:00',1.8),('8348','2013-09-29','10:35:00',1.95),('8348','2013-09-29','10:40:00',2.1),('8348','2013-09-29','10:45:00',2.08),('8348','2013-09-29','10:50:00',2.16),('8348','2013-09-29','10:55:00',2.15),('8348','2013-09-29','11:00:00',2.21),('8348','2013-09-29','11:05:00',2.15),('8348','2013-09-29','11:10:00',2.16),('8348','2013-09-29','11:15:00',2.34),('8348','2013-09-29','11:20:00',2.31),('8348','2013-09-29','11:25:00',2.19),('8348','2013-09-29','11:30:00',2.38),('8348','2013-09-29','11:35:00',2.35),('8348','2013-09-29','11:40:00',2.39),('8348','2013-09-29','11:45:00',2.43),('8348','2013-09-29','11:50:00',2.62),('8348','2013-09-29','11:55:00',2.64),('8348','2013-09-29','12:00:00',2.36),('8348','2013-09-29','12:05:00',2.42),('8348','2013-09-29','12:10:00',2.81),('8348','2013-09-29','12:15:00',3.03),('8348','2013-09-29','12:20:00',1.97),('8348','2013-09-29','12:25:00',1.61),('8348','2013-09-29','12:30:00',1.66),('8348','2013-09-29','12:35:00',1.62),('8348','2013-09-29','12:40:00',1.4),('8348','2013-09-29','12:45:00',1.23),('8348','2013-09-29','12:50:00',1.21),('8348','2013-09-29','12:55:00',1.07),('8348','2013-09-29','13:00:00',1.02),('8348','2013-09-29','13:25:00',1.22),('8348','2013-09-29','13:30:00',1.7),('8348','2013-09-29','13:35:00',1.65),('8348','2013-09-29','13:40:00',1.55),('8348','2013-09-29','13:45:00',1.4),('8348','2013-09-29','13:50:00',1.51),('8348','2013-09-29','13:55:00',1.75),('8348','2013-09-29','14:00:00',1.65),('8348','2013-09-29','14:05:00',2.05),('8348','2013-09-29','14:10:00',1.24),('8348','2013-09-29','14:15:00',1.48),('8348','2013-09-29','14:20:00',2.17),('8348','2013-09-29','14:25:00',1.24),('8348','2013-09-29','14:30:00',1.07),('8348','2013-09-29','15:00:00',1.1),('8348','2013-09-29','16:00:00',1.03),('8348','2013-09-29','16:30:00',1.03),('8348','2014-04-14','06:55:00',1.02),('8348','2014-04-14','07:00:00',1.11),('8348','2014-04-14','07:05:00',1.2),('8348','2014-04-14','07:10:00',1.3),('8348','2014-04-14','07:15:00',1.46),('8348','2014-04-14','07:20:00',1.67),('8348','2014-04-14','07:25:00',1.76),('8348','2014-04-14','07:30:00',1.89),('8348','2014-04-14','07:35:00',1.99),('8348','2014-04-14','07:40:00',2.11),('8348','2014-04-14','07:45:00',2.22),('8348','2014-04-14','07:50:00',2.34),('8348','2014-04-14','07:55:00',2.48),('8348','2014-04-14','08:00:00',2.69),('8348','2014-04-14','08:05:00',3.03),('8348','2014-04-14','08:10:00',3.27),('8348','2014-04-14','08:15:00',3.43),('8348','2014-04-14','08:20:00',3.59),('8348','2014-04-14','08:25:00',3.74),('8348','2014-04-14','08:30:00',3.86),('8348','2014-04-14','08:35:00',4.05),('8348','2014-04-14','08:40:00',4.21),('8348','2014-04-14','08:45:00',4.33),('8348','2014-04-14','08:50:00',4.47),('8348','2014-04-14','08:55:00',4.59),('8348','2014-04-14','09:00:00',4.72),('8348','2014-04-14','09:05:00',4.83),('8348','2014-04-14','09:10:00',4.96),('8348','2014-04-14','09:15:00',5.08),('8348','2014-04-14','09:20:00',5.21),('8348','2014-04-14','09:25:00',5.3),('8348','2014-04-14','09:30:00',5.4),('8348','2014-04-14','09:35:00',5.48),('8348','2014-04-14','09:40:00',5.62),('8348','2014-04-14','09:45:00',5.7),('8348','2014-04-14','09:50:00',5.8),('8348','2014-04-14','09:55:00',5.9),('8348','2014-04-14','10:00:00',5.97),('8348','2014-04-14','10:05:00',6.04),('8348','2014-04-14','10:10:00',6.1),('8348','2014-04-14','10:15:00',6.19),('8348','2014-04-14','10:20:00',6.23),('8348','2014-04-14','10:25:00',6.29),('8348','2014-04-14','10:30:00',6.44),('8348','2014-04-14','10:35:00',6.5),('8348','2014-04-14','10:40:00',6.55),('8348','2014-04-14','10:45:00',6.63),('8348','2014-04-14','10:50:00',6.7),('8348','2014-04-14','10:55:00',6.74),('8348','2014-04-14','11:00:00',6.78),('8348','2014-04-14','11:05:00',6.83),('8348','2014-04-14','11:10:00',6.86),('8348','2014-04-14','11:15:00',6.91),('8348','2014-04-14','11:20:00',6.95),('8348','2014-04-14','11:25:00',7.03),('8348','2014-04-14','11:30:00',7.04),('8348','2014-04-14','11:35:00',7.07),('8348','2014-04-14','11:40:00',7.11),('8348','2014-04-14','11:45:00',7.17),('8348','2014-04-14','11:50:00',7.14),('8348','2014-04-14','11:55:00',7.25),('8348','2014-04-14','12:00:00',7.3),('8348','2014-04-14','12:05:00',7.33),('8348','2014-04-14','12:10:00',7.21),('8348','2014-04-14','12:15:00',7.33),('8348','2014-04-14','12:20:00',7.37),('8348','2014-04-14','12:25:00',7.4),('8348','2014-04-14','12:30:00',7.41),('8348','2014-04-14','12:35:00',7.47),('8348','2014-04-14','12:40:00',7.49),('8348','2014-04-14','12:45:00',7.45),('8348','2014-04-14','12:50:00',7.38),('8348','2014-04-14','12:55:00',7.4),('8348','2014-04-14','13:00:00',7.42),('8348','2014-04-14','13:05:00',7.38),('8348','2014-04-14','13:10:00',7.39),('8348','2014-04-14','13:15:00',7.4),('8348','2014-04-14','13:20:00',7.39),('8348','2014-04-14','13:25:00',7.41),('8348','2014-04-14','13:30:00',7.35),('8348','2014-04-14','13:35:00',7.3),('8348','2014-04-14','13:40:00',7.27),('8348','2014-04-14','13:45:00',7.2),('8348','2014-04-14','13:50:00',7.15),('8348','2014-04-14','13:55:00',7.07),('8348','2014-04-14','14:00:00',7.03),('8348','2014-04-14','14:05:00',7),('8348','2014-04-14','14:10:00',6.97),('8348','2014-04-14','14:15:00',6.91),('8348','2014-04-14','14:20:00',6.84),('8348','2014-04-14','14:25:00',6.75),('8348','2014-04-14','14:30:00',6.69),('8348','2014-04-14','14:35:00',6.59),('8348','2014-04-14','14:40:00',6.53),('8348','2014-04-14','14:45:00',6.41),('8348','2014-04-14','14:50:00',6.28),('8348','2014-04-14','14:55:00',6.22),('8348','2014-04-14','15:00:00',6.11),('8348','2014-04-14','15:05:00',6),('8348','2014-04-14','15:10:00',5.91),('8348','2014-04-14','15:15:00',5.8),('8348','2014-04-14','15:20:00',5.69),('8348','2014-04-14','15:25:00',5.58),('8348','2014-04-14','15:30:00',5.46),('8348','2014-04-14','15:35:00',5.34),('8348','2014-04-14','15:40:00',5.2),('8348','2014-04-14','15:45:00',5.06),('8348','2014-04-14','15:50:00',4.95),('8348','2014-04-14','15:55:00',4.81),('8348','2014-04-14','16:00:00',4.66),('8348','2014-04-14','16:05:00',4.51),('8348','2014-04-14','16:10:00',4.35),('8348','2014-04-14','16:15:00',4.22),('8348','2014-04-14','16:20:00',4.07),('8348','2014-04-14','16:25:00',3.93),('8348','2014-04-14','16:30:00',3.74),('8348','2014-04-14','16:35:00',3.53),('8348','2014-04-14','16:40:00',3.37),('8348','2014-04-14','16:45:00',3.24),('8348','2014-04-14','16:50:00',3.05),('8348','2014-04-14','16:55:00',2.87),('8348','2014-04-14','17:00:00',2.72),('8348','2014-04-14','17:05:00',2.55),('8348','2014-04-14','17:10:00',2.39),('8348','2014-04-14','17:15:00',2.18),('8348','2014-04-14','17:20:00',2.04),('8348','2014-04-14','17:25:00',1.9),('8348','2014-04-14','17:30:00',1.73),('8348','2014-04-14','17:35:00',1.56),('8348','2014-04-14','17:40:00',1.41),('8348','2014-04-14','17:45:00',1.23),('8348','2014-04-14','17:50:00',1.05),('8348','2013-09-28','09:05:00',1),('8348','2013-09-28','09:10:00',1.08),('8348','2013-09-28','09:15:00',1.13),('8348','2013-09-28','09:20:00',1.15),('8348','2013-09-28','09:25:00',1.27),('8348','2013-09-28','09:30:00',1.37),('8348','2013-09-28','09:35:00',1.44),('8348','2013-09-28','09:40:00',1.53),('8348','2013-09-28','09:45:00',1.63),('8348','2013-09-28','09:50:00',1.73),('8348','2013-09-28','09:55:00',1.62),('8348','2013-09-28','10:00:00',1.65),('8348','2013-09-28','10:05:00',1.04),('8348','2013-09-28','10:15:00',1.15),('8348','2013-09-28','10:20:00',1.73),('8348','2013-09-28','10:25:00',1.03),('8348','2013-09-28','10:30:00',2.32),('8348','2013-09-28','10:35:00',1.44),('8348','2013-09-28','10:40:00',1.41),('8348','2013-09-28','10:45:00',2.38),('8348','2013-09-28','10:50:00',2.83),('8348','2013-09-28','10:55:00',1.95),('8348','2013-09-28','11:00:00',1.06),('8348','2013-09-28','11:15:00',2.33),('8348','2013-09-28','11:20:00',2.95),('8348','2013-09-28','11:25:00',3.05),('8348','2013-09-28','11:30:00',2.9),('8348','2013-09-28','11:35:00',1.83),('8348','2013-09-28','11:40:00',1.23),('8348','2013-09-28','11:50:00',1.27),('8348','2013-09-28','11:55:00',1.15),('8348','2013-09-28','12:00:00',2.31),('8348','2013-09-28','12:05:00',3.1),('8348','2013-09-28','12:10:00',2.85),('8348','2013-09-28','12:15:00',2.82),('8348','2013-09-28','12:20:00',2.99),('8348','2013-09-28','12:25:00',1.91),('8348','2013-09-28','12:30:00',2.67),('8348','2013-09-28','12:35:00',1.91),('8348','2013-09-28','12:40:00',2.5),('8348','2013-09-28','12:45:00',2.81),('8348','2013-09-28','12:50:00',1.16),('8348','2013-09-28','12:55:00',3.27),('8348','2013-09-28','13:00:00',3.39),('8348','2013-09-28','13:05:00',1.26),('8348','2013-09-28','13:10:00',1.03),('8348','2013-09-28','13:15:00',1.26),('8348','2013-09-28','13:20:00',1.51),('8348','2013-09-28','13:25:00',2.78),('8348','2013-09-28','13:30:00',2),('8348','2013-09-28','13:35:00',1.4),('8348','2013-09-28','13:40:00',1.37),('8348','2013-09-28','13:45:00',2.41),('8348','2013-09-28','13:50:00',1.31),('8348','2013-09-28','13:55:00',1.3),('8348','2013-09-28','14:00:00',1.23),('8348','2013-09-28','14:05:00',1.53),('8348','2013-09-28','14:10:00',1.92),('8348','2013-09-28','14:15:00',2.78),('8348','2013-09-28','14:20:00',3.45),('8348','2013-09-28','14:25:00',2.84),('8348','2013-09-28','14:30:00',3.14),('8348','2013-09-28','14:35:00',3.25),('8348','2013-09-28','14:40:00',3.2),('8348','2013-09-28','14:45:00',3.17),('8348','2013-09-28','14:50:00',1.56),('8348','2013-09-28','14:55:00',2.37),('8348','2013-09-28','15:00:00',3.09),('8348','2013-09-28','15:05:00',2.12),('8348','2013-09-28','15:10:00',2.73),('8348','2013-09-28','15:15:00',2.37),('8348','2013-09-28','15:20:00',2.61),('8348','2013-09-28','15:25:00',2.72),('8348','2013-09-28','15:30:00',2.65),('8348','2013-09-28','15:35:00',2.51),('8348','2013-09-28','15:40:00',2.47),('8348','2013-09-28','15:45:00',2.31),('8348','2013-09-28','15:50:00',2.01),('8348','2013-09-28','15:55:00',1.88),('8348','2013-09-28','16:00:00',2.21),('8348','2013-09-28','16:05:00',2.22),('8348','2013-09-28','16:10:00',2.23),('8348','2013-09-28','16:15:00',2),('8348','2013-09-28','16:25:00',1.7),('8348','2013-09-28','16:30:00',1.73),('8348','2013-09-28','16:35:00',1.71),('8348','2013-09-28','16:40:00',1.64),('8348','2013-09-28','16:45:00',1.57),('8348','2013-09-28','16:50:00',1.52),('8348','2013-09-28','16:55:00',1.45),('8348','2013-09-28','17:00:00',1.35),('8348','2013-09-28','17:05:00',1.29),('8348','2013-09-28','17:10:00',1.21),('8348','2013-09-28','17:15:00',1.13),('8348','2013-09-28','17:20:00',1.06),('8348','2013-09-27','08:55:00',1.11),('8348','2013-09-27','09:50:00',1.19),('8348','2013-09-27','09:55:00',1.37),('8348','2013-09-27','10:00:00',1.56),('8348','2013-09-27','10:05:00',2.02),('8348','2013-09-27','10:10:00',1.38),('8348','2013-09-27','10:15:00',1.3),('8348','2013-09-27','10:20:00',1.85),('8348','2013-09-27','10:25:00',1.53),('8348','2013-09-27','10:30:00',1.15),('8348','2013-09-27','10:45:00',1.6),('8348','2013-09-27','10:50:00',1.65),('8348','2013-09-27','10:55:00',2.29),('8348','2013-09-27','11:00:00',2.4),('8348','2013-09-27','11:05:00',2.33),('8348','2013-09-27','11:10:00',1.67),('8348','2013-09-27','11:15:00',2.42),('8348','2013-09-27','11:20:00',2.73),('8348','2013-09-27','11:25:00',2.38),('8348','2013-09-27','11:30:00',2.4),('8348','2013-09-27','11:45:00',1.31),('8348','2013-09-27','11:50:00',1.2),('8348','2013-09-27','11:55:00',1.82),('8348','2013-09-27','12:00:00',2.26),('8348','2013-09-27','12:05:00',1.56),('8348','2013-09-27','12:10:00',2.83),('8348','2013-09-27','12:15:00',1.12),('8348','2013-09-27','12:45:00',2.76),('8348','2013-09-27','12:50:00',2.71),('8348','2013-09-27','12:55:00',3.02),('8348','2013-09-27','13:00:00',2.98),('8348','2013-09-27','13:05:00',2.36),('8348','2013-09-27','13:10:00',2.45),('8348','2013-09-27','13:15:00',1.93),('8348','2013-09-27','13:20:00',2.66),('8348','2013-09-27','13:25:00',1.58),('8348','2013-09-27','13:40:00',2.25),('8348','2013-09-27','13:45:00',2.29),('8348','2013-09-27','13:50:00',1.54),('8348','2013-09-27','13:55:00',1.25),('8348','2013-09-27','14:00:00',1.58),('8348','2013-09-27','14:05:00',3.26),('8348','2013-09-27','14:10:00',2.77),('8348','2013-09-27','14:15:00',2.56),('8348','2013-09-27','14:20:00',3.13),('8348','2013-09-27','14:25:00',3.08),('8348','2013-09-27','14:30:00',2.89),('8348','2013-09-27','14:35:00',2.92),('8348','2013-09-27','14:40:00',2.94),('8348','2013-09-27','14:45:00',2.84),('8348','2013-09-27','14:50:00',2.72),('8348','2013-09-27','14:55:00',2.57),('8348','2013-09-27','15:00:00',2.42),('8348','2013-09-27','15:05:00',1.51),('8348','2013-09-27','15:10:00',2.4),('8348','2013-09-27','15:15:00',2.68),('8348','2013-09-27','15:20:00',1.28),('8348','2013-09-27','15:25:00',2.05),('8348','2013-09-27','15:30:00',2.65),('8348','2013-09-27','15:35:00',2.12),('8348','2013-09-27','15:40:00',2.2),('8348','2013-09-27','15:45:00',1.31),('8348','2013-09-27','15:50:00',2.19),('8348','2013-09-27','15:55:00',2.36),('8348','2013-09-27','16:00:00',1.42),('8348','2013-09-27','16:05:00',1.54),('8348','2013-09-27','16:15:00',1.61),('8348','2013-09-27','16:20:00',2.04),('8348','2013-09-27','16:25:00',1.74),('8348','2013-09-27','16:30:00',1.68),('8348','2013-09-27','16:35:00',1.78),('8348','2013-09-27','16:40:00',1.68),('8348','2013-09-27','16:45:00',1.66),('8348','2013-09-27','16:50:00',1.58),('8348','2013-09-27','16:55:00',1.26),('8348','2013-09-27','17:10:00',1.35),('8348','2013-09-27','17:15:00',1.34),('8348','2013-09-27','17:20:00',1.17),('8348','2013-09-27','17:25:00',1.07),('8348','2013-09-26','09:00:00',1.01),('8348','2013-09-26','09:05:00',1.08),('8348','2013-09-26','09:10:00',1.15),('8348','2013-09-26','09:15:00',1.24),('8348','2013-09-26','09:20:00',1.32),('8348','2013-09-26','09:25:00',1.37),('8348','2013-09-26','09:30:00',1.44),('8348','2013-09-26','09:35:00',1.53),('8348','2013-09-26','09:40:00',1.6),('8348','2013-09-26','09:45:00',1.67),('8348','2013-09-26','09:50:00',1.74),('8348','2013-09-26','09:55:00',1.79),('8348','2013-09-26','10:00:00',1.83),('8348','2013-09-26','10:05:00',1.88),('8348','2013-09-26','10:10:00',1.96),('8348','2013-09-26','10:15:00',1.98),('8348','2013-09-26','10:20:00',1.97),('8348','2013-09-26','10:25:00',2.04),('8348','2013-09-26','10:30:00',2.1),('8348','2013-09-26','10:35:00',2.2),('8348','2013-09-26','10:40:00',2.18),('8348','2013-09-26','10:45:00',2.24),('8348','2013-09-26','10:50:00',2.32),('8348','2013-09-26','10:55:00',2.4),('8348','2013-09-26','11:00:00',2.36),('8348','2013-09-26','11:05:00',2.36),('8348','2013-09-26','11:10:00',2.4),('8348','2013-09-26','11:15:00',2.48),('8348','2013-09-26','11:20:00',2.54),('8348','2013-09-26','11:25:00',2.49),('8348','2013-09-26','11:30:00',2.47),('8348','2013-09-26','11:35:00',1.45),('8348','2013-09-26','11:40:00',2.12),('8348','2013-09-26','11:45:00',2.73),('8348','2013-09-26','11:50:00',2.55),('8348','2013-09-26','11:55:00',1.79),('8348','2013-09-26','12:00:00',2.95),('8348','2013-09-26','12:05:00',2.18),('8348','2013-09-26','12:15:00',1.05),('8348','2013-09-26','12:20:00',1.28),('8348','2013-09-26','12:25:00',1.08),('8348','2013-09-26','12:30:00',1.29),('8348','2013-09-26','12:35:00',1.4),('8348','2013-09-26','12:40:00',1.42),('8348','2013-09-26','12:45:00',1.38),('8348','2013-09-26','12:50:00',1.34),('8348','2013-09-26','12:55:00',2.5),('8348','2013-09-26','13:00:00',3.05),('8348','2013-09-26','13:05:00',2.29),('8348','2013-09-26','13:10:00',1.47),('8348','2013-09-26','13:15:00',2.74),('8348','2013-09-26','13:20:00',3.47),('8348','2013-09-26','13:25:00',2.89),('8348','2013-09-26','13:30:00',1.94),('8348','2013-09-26','13:35:00',1.77),('8348','2013-09-26','13:40:00',2.01),('8348','2013-09-26','13:45:00',1.25),('8348','2013-09-26','13:50:00',1.69),('8348','2013-09-26','13:55:00',1.67),('8348','2013-09-26','14:00:00',2.53),('8348','2013-09-26','14:05:00',2.43),('8348','2013-09-26','14:10:00',3.09),('8348','2013-09-26','14:15:00',3.41),('8348','2013-09-26','14:20:00',2.09),('8348','2013-09-26','14:30:00',1.85),('8348','2013-09-26','14:35:00',1.84),('8348','2013-09-26','14:40:00',1.42),('8348','2013-09-26','14:45:00',3.39),('8348','2013-09-26','14:50:00',2.86),('8348','2013-09-26','14:55:00',1.25),('8348','2013-09-26','15:00:00',1),('8348','2013-09-26','15:05:00',1.34),('8348','2013-09-26','15:15:00',1.12),('8348','2013-09-26','15:20:00',1.91),('8348','2013-09-26','15:25:00',1.95),('8348','2013-09-26','15:35:00',1.96),('8348','2013-09-26','15:45:00',1.96),('8348','2013-09-26','15:50:00',2.54),('8348','2013-09-26','15:55:00',2.34),('8348','2013-09-26','16:00:00',2.26),('8348','2013-09-26','16:05:00',2.19),('8348','2013-09-26','16:10:00',2.13),('8348','2013-09-26','16:15:00',2.02),('8348','2013-09-26','16:20:00',2.01),('8348','2013-09-26','16:25:00',2.01),('8348','2013-09-26','16:30:00',1.89),('8348','2013-09-26','16:35:00',1.81),('8348','2013-09-26','16:40:00',1.73),('8348','2013-09-26','16:45:00',1.66),('8348','2013-09-26','16:50:00',1.58),('8348','2013-09-26','16:55:00',1.52),('8348','2013-09-26','17:00:00',1.42),('8348','2013-09-26','17:05:00',1.37),('8348','2013-09-26','17:10:00',1.35),('8348','2013-09-26','17:15:00',1.25),('8348','2013-09-26','17:25:00',1),('8348','2013-09-26','17:30:00',1.06),('8348','2013-09-25','09:05:00',1.09),('8348','2013-09-25','09:10:00',1.64),('8348','2013-09-25','09:15:00',1.18),('8348','2013-09-25','09:25:00',1.21),('8348','2013-09-25','09:30:00',1.43),('8348','2013-09-25','09:35:00',1.51),('8348','2013-09-25','09:40:00',1.57),('8348','2013-09-25','09:50:00',1.26),('8348','2013-09-25','09:55:00',1.55),('8348','2013-09-25','10:00:00',1.94),('8348','2013-09-25','10:05:00',1),('8348','2013-09-25','10:20:00',1.31),('8348','2013-09-25','10:25:00',1.77),('8348','2013-09-25','10:30:00',1.14),('8348','2013-09-25','10:35:00',1.06),('8348','2013-09-25','10:40:00',1.36),('8348','2013-09-25','10:45:00',2.66),('8348','2013-09-25','10:50:00',2.98),('8348','2013-09-25','10:55:00',2.75),('8348','2013-09-25','11:00:00',1.41),('8348','2013-09-25','11:10:00',1.38),('8348','2013-09-25','11:15:00',2.19),('8348','2013-09-25','11:20:00',2.7),('8348','2013-09-25','11:25:00',2.73),('8348','2013-09-25','11:30:00',2.62),('8348','2013-09-25','11:35:00',1.8),('8348','2013-09-25','11:40:00',2.44),('8348','2013-09-25','11:45:00',2.91),('8348','2013-09-25','11:50:00',2.5),('8348','2013-09-25','11:55:00',1.56),('8348','2013-09-25','12:15:00',3.24),('8348','2013-09-25','12:20:00',2.4),('8348','2013-09-25','12:25:00',1.7),('8348','2013-09-25','12:30:00',2.57),('8348','2013-09-25','12:35:00',3.15),('8348','2013-09-25','12:40:00',1.9),('8348','2013-09-25','12:50:00',1.05),('8348','2013-09-25','13:00:00',1.02),('8348','2013-09-25','13:05:00',2.49),('8348','2013-09-25','13:25:00',1.28),('8348','2013-09-25','13:30:00',1.06),('8348','2013-09-25','13:35:00',2.92),('8348','2013-09-25','13:40:00',3.7),('8348','2013-09-25','13:45:00',3.68),('8348','2013-09-25','13:50:00',3.61),('8348','2013-09-25','13:55:00',2.33),('8348','2013-09-25','14:10:00',1.13),('8348','2013-09-25','14:30:00',1.55),('8348','2013-09-25','14:35:00',1.6),('8348','2013-09-25','14:40:00',3.64),('8348','2013-09-25','14:45:00',1.55),('8348','2013-09-25','14:50:00',2.88),('8348','2013-09-25','14:55:00',2.7),('8348','2013-09-25','15:00:00',3.16),('8348','2013-09-25','15:05:00',3.16),('8348','2013-09-25','15:10:00',2.93),('8348','2013-09-25','15:15:00',2.87),('8348','2013-09-25','15:20:00',2.65),('8348','2013-09-25','15:25:00',2.7),('8348','2013-09-25','15:30:00',1.74),('8348','2013-09-25','15:35:00',2.88),('8348','2013-09-25','15:40:00',2.81),('8348','2013-09-25','15:45:00',2.53),('8348','2013-09-25','15:50:00',2.56),('8348','2013-09-25','15:55:00',2.52),('8348','2013-09-25','16:00:00',2.46),('8348','2013-09-25','16:05:00',2.38),('8348','2013-09-25','16:10:00',2.3),('8348','2013-09-25','16:15:00',2.22),('8348','2013-09-25','16:20:00',2.15),('8348','2013-09-25','16:30:00',2.08),('8348','2013-09-25','16:35:00',1.97),('8348','2013-09-25','16:40:00',1.86),('8348','2013-09-25','16:45:00',1.78),('8348','2013-09-25','16:50:00',1.71),('8348','2013-09-25','16:55:00',1.62),('8348','2013-09-25','17:00:00',1.57),('8348','2013-09-25','17:05:00',1.49),('8348','2013-09-25','17:10:00',1.41),('8348','2013-09-25','17:15:00',1.33),('8348','2013-09-25','17:20:00',1.25),('8348','2013-09-25','17:25:00',1.16),('8348','2013-09-25','17:30:00',1.11),('8348','2013-09-25','17:35:00',1.02),('8348','2013-09-24','08:55:00',1.01),('8348','2013-09-24','09:00:00',1.07),('8348','2013-09-24','09:05:00',1.12),('8348','2013-09-24','09:10:00',1.21),('8348','2013-09-24','09:15:00',1.29),('8348','2013-09-24','09:20:00',1.36),('8348','2013-09-24','09:25:00',1.44),('8348','2013-09-24','09:30:00',1.53),('8348','2013-09-24','09:35:00',1.61),('8348','2013-09-24','09:40:00',1.67),('8348','2013-09-24','09:45:00',1.72),('8348','2013-09-24','09:50:00',1.8),('8348','2013-09-24','09:55:00',1.86),('8348','2013-09-24','10:00:00',1.92),('8348','2013-09-24','10:05:00',1.97),('8348','2013-09-24','10:10:00',2.04),('8348','2013-09-24','10:15:00',2.1),('8348','2013-09-24','10:20:00',2.15),('8348','2013-09-24','10:25:00',2.21),('8348','2013-09-24','10:30:00',2.25),('8348','2013-09-24','10:35:00',2.3),('8348','2013-09-24','10:40:00',2.36),('8348','2013-09-24','10:45:00',2.4),('8348','2013-09-24','10:50:00',2.43),('8348','2013-09-24','10:55:00',2.47),('8348','2013-09-24','11:00:00',2.51),('8348','2013-09-24','11:05:00',2.54),('8348','2013-09-24','11:10:00',2.57),('8348','2013-09-24','11:15:00',2.59),('8348','2013-09-24','11:20:00',2.65),('8348','2013-09-24','11:25:00',2.7),('8348','2013-09-24','11:30:00',2.75),('8348','2013-09-24','11:35:00',2.76),('8348','2013-09-24','11:40:00',2.81),('8348','2013-09-24','11:45:00',2.82),('8348','2013-09-24','11:50:00',2.82),('8348','2013-09-24','11:55:00',2.85),('8348','2013-09-24','12:00:00',2.86),('8348','2013-09-24','12:05:00',2.9),('8348','2013-09-24','12:10:00',2.93),('8348','2013-09-24','12:15:00',2.92),('8348','2013-09-24','12:20:00',2.92),('8348','2013-09-24','12:25:00',2.93),('8348','2013-09-24','12:30:00',2.95),('8348','2013-09-24','12:35:00',3.03),('8348','2013-09-24','12:40:00',3.05),('8348','2013-09-24','12:45:00',3.04),('8348','2013-09-24','12:50:00',3.03),('8348','2013-09-24','12:55:00',3.06),('8348','2013-09-24','13:00:00',3.06),('8348','2013-09-24','13:05:00',3.08),('8348','2013-09-24','13:10:00',3.1),('8348','2013-09-24','13:15:00',3.08),('8348','2013-09-24','13:20:00',3.1),('8348','2013-09-24','13:25:00',3.1),('8348','2013-09-24','13:30:00',3.12),('8348','2013-09-24','13:35:00',3.1),('8348','2013-09-24','13:40:00',3.11),('8348','2013-09-24','13:45:00',3.11),('8348','2013-09-24','13:50:00',3.07),('8348','2013-09-24','13:55:00',3.05),('8348','2013-09-24','14:00:00',3.05),('8348','2013-09-24','14:05:00',3.05),('8348','2013-09-24','14:10:00',3.06),('8348','2013-09-24','14:15:00',3.03),('8348','2013-09-24','14:20:00',3.02),('8348','2013-09-24','14:25:00',3),('8348','2013-09-24','14:30:00',2.99),('8348','2013-09-24','14:35:00',2.96),('8348','2013-09-24','14:40:00',2.95),('8348','2013-09-24','14:45:00',2.92),('8348','2013-09-24','14:50:00',2.87),('8348','2013-09-24','14:55:00',2.84),('8348','2013-09-24','15:00:00',2.8),('8348','2013-09-24','15:05:00',2.81),('8348','2013-09-24','15:10:00',2.77),('8348','2013-09-24','15:15:00',2.73),('8348','2013-09-24','15:20:00',2.72),('8348','2013-09-24','15:25:00',2.71),('8348','2013-09-24','15:30:00',2.66),('8348','2013-09-24','15:35:00',2.61),('8348','2013-09-24','15:40:00',2.56),('8348','2013-09-24','15:45:00',2.53),('8348','2013-09-24','15:50:00',2.47),('8348','2013-09-24','15:55:00',2.41),('8348','2013-09-24','16:00:00',2.36),('8348','2013-09-24','16:05:00',2.31),('8348','2013-09-24','16:10:00',2.25),('8348','2013-09-24','16:15:00',2.21),('8348','2013-09-24','16:20:00',2.15),('8348','2013-09-24','16:25:00',2.08),('8348','2013-09-24','16:30:00',2.01),('8348','2013-09-24','16:35:00',1.94),('8348','2013-09-24','16:40:00',1.87),('8348','2013-09-24','16:45:00',1.81),('8348','2013-09-24','16:50:00',1.76),('8348','2013-09-24','16:55:00',1.69),('8348','2013-09-24','17:00:00',1.61),('8348','2013-09-24','17:05:00',1.54),('8348','2013-09-24','17:10:00',1.45),('8348','2013-09-24','17:15:00',1.38),('8348','2013-09-24','17:20:00',1.3),('8348','2013-09-24','17:25:00',1.22),('8348','2013-09-24','17:30:00',1.11),('8348','2013-09-24','17:35:00',1),('8348','2013-09-23','08:55:00',1.02),('8348','2013-09-23','09:00:00',1.08),('8348','2013-09-23','09:05:00',1.15),('8348','2013-09-23','09:10:00',1.24),('8348','2013-09-23','09:15:00',1.33),('8348','2013-09-23','09:20:00',1.4),('8348','2013-09-23','09:25:00',1.48),('8348','2013-09-23','09:30:00',1.57),('8348','2013-09-23','09:35:00',1.64),('8348','2013-09-23','09:40:00',1.71),('8348','2013-09-23','09:45:00',1.77),('8348','2013-09-23','09:50:00',1.84),('8348','2013-09-23','09:55:00',1.89),('8348','2013-09-23','10:00:00',1.95),('8348','2013-09-23','10:05:00',2.02),('8348','2013-09-23','10:10:00',2.07),('8348','2013-09-23','10:15:00',2.13),('8348','2013-09-23','10:20:00',2.18),('8348','2013-09-23','10:25:00',2.24),('8348','2013-09-23','10:30:00',2.29),('8348','2013-09-23','10:35:00',2.35),('8348','2013-09-23','10:40:00',2.4),('8348','2013-09-23','10:45:00',2.44),('8348','2013-09-23','10:50:00',2.5),('8348','2013-09-23','10:55:00',2.54),('8348','2013-09-23','11:00:00',2.57),('8348','2013-09-23','11:05:00',2.62),('8348','2013-09-23','11:10:00',2.68),('8348','2013-09-23','11:15:00',2.74),('8348','2013-09-23','11:20:00',2.78),('8348','2013-09-23','11:25:00',2.81),('8348','2013-09-23','11:30:00',2.85),('8348','2013-09-23','11:35:00',2.88),('8348','2013-09-23','11:40:00',2.92),('8348','2013-09-23','11:45:00',2.93),('8348','2013-09-23','11:50:00',2.96),('8348','2013-09-23','11:55:00',2.99),('8348','2013-09-23','12:00:00',3.03),('8348','2013-09-23','12:05:00',3.06),('8348','2013-09-23','12:10:00',3.1),('8348','2013-09-23','12:15:00',3.13),('8348','2013-09-23','12:20:00',3.13),('8348','2013-09-23','12:25:00',3.13),('8348','2013-09-23','12:30:00',3.12),('8348','2013-09-23','12:35:00',3.14),('8348','2013-09-23','12:40:00',3.14),('8348','2013-09-23','12:45:00',3.16),('8348','2013-09-23','12:50:00',3.15),('8348','2013-09-23','12:55:00',3.15),('8348','2013-09-23','13:00:00',3.17),('8348','2013-09-23','13:05:00',3.14),('8348','2013-09-23','13:10:00',3.14),('8348','2013-09-23','13:15:00',3.12),('8348','2013-09-23','13:20:00',3.12),('8348','2013-09-23','13:25:00',3.1),('8348','2013-09-23','13:30:00',3.13),('8348','2013-09-23','13:35:00',3.1),('8348','2013-09-23','13:40:00',3.11),('8348','2013-09-23','13:45:00',3.1),('8348','2013-09-23','13:50:00',3.09),('8348','2013-09-23','13:55:00',3.08),('8348','2013-09-23','14:00:00',3.05),('8348','2013-09-23','14:05:00',2.99),('8348','2013-09-23','14:10:00',3),('8348','2013-09-23','14:15:00',2.97),('8348','2013-09-23','14:20:00',3.01),('8348','2013-09-23','14:25:00',3),('8348','2013-09-23','14:30:00',3.02),('8348','2013-09-23','14:35:00',2.93),('8348','2013-09-23','14:40:00',2.9),('8348','2013-09-23','14:45:00',2.86),('8348','2013-09-23','14:50:00',2.68),('8348','2013-09-23','14:55:00',2.82),('8348','2013-09-23','15:00:00',2.86),('8348','2013-09-23','15:05:00',2.82),('8348','2013-09-23','15:10:00',1.68),('8348','2013-09-23','15:15:00',2.42),('8348','2013-09-23','15:20:00',2.29),('8348','2013-09-23','15:25:00',2.62),('8348','2013-09-23','15:30:00',2.61),('8348','2013-09-23','15:35:00',2.56),('8348','2013-09-23','15:40:00',2.52),('8348','2013-09-23','15:45:00',2.47),('8348','2013-09-23','15:50:00',2.39),('8348','2013-09-23','15:55:00',2.19),('8348','2013-09-23','16:00:00',2.24),('8348','2013-09-23','16:05:00',2.23),('8348','2013-09-23','16:10:00',2.17),('8348','2013-09-23','16:15:00',2.12),('8348','2013-09-23','16:20:00',2.01),('8348','2013-09-23','16:25:00',1.96),('8348','2013-09-23','16:30:00',1.74),('8348','2013-09-23','16:35:00',1.87),('8348','2013-09-23','16:40:00',1.8),('8348','2013-09-23','16:45:00',1.75),('8348','2013-09-23','16:50:00',1.68),('8348','2013-09-23','16:55:00',1.61),('8348','2013-09-23','17:00:00',1.55),('8348','2013-09-23','17:05:00',1.48),('8348','2013-09-23','17:10:00',1.41),('8348','2013-09-23','17:15:00',1.34),('8348','2013-09-23','17:20:00',1.27),('8348','2013-09-23','17:25:00',1.2),('8348','2013-09-23','17:30:00',1.13),('8348','2013-09-23','17:35:00',1.06),('8348','2013-09-22','08:55:00',1),('8348','2013-09-22','09:00:00',1.07),('8348','2013-09-22','09:05:00',1.14),('8348','2013-09-22','09:10:00',1.24),('8348','2013-09-22','09:15:00',1.33),('8348','2013-09-22','09:20:00',1.4),('8348','2013-09-22','09:25:00',1.48),('8348','2013-09-22','09:30:00',1.58),('8348','2013-09-22','09:35:00',1.65),('8348','2013-09-22','09:40:00',1.71),('8348','2013-09-22','09:45:00',1.78),('8348','2013-09-22','09:50:00',1.84),('8348','2013-09-22','09:55:00',1.91),('8348','2013-09-22','10:00:00',1.98),('8348','2013-09-22','10:05:00',2.05),('8348','2013-09-22','10:10:00',2.12),('8348','2013-09-22','10:15:00',2.18),('8348','2013-09-22','10:20:00',2.23),('8348','2013-09-22','10:25:00',2.29),('8348','2013-09-22','10:30:00',2.36),('8348','2013-09-22','10:35:00',2.41),('8348','2013-09-22','10:40:00',2.45),('8348','2013-09-22','10:45:00',2.5),('8348','2013-09-22','10:50:00',2.54),('8348','2013-09-22','10:55:00',2.58),('8348','2013-09-22','11:00:00',2.63),('8348','2013-09-22','11:05:00',2.66),('8348','2013-09-22','11:10:00',2.69),('8348','2013-09-22','11:15:00',2.73),('8348','2013-09-22','11:20:00',2.79),('8348','2013-09-22','11:25:00',2.83),('8348','2013-09-22','11:30:00',2.88),('8348','2013-09-22','11:35:00',2.94),('8348','2013-09-22','11:40:00',2.97),('8348','2013-09-22','11:45:00',2.99),('8348','2013-09-22','11:50:00',3.03),('8348','2013-09-22','11:55:00',3.06),('8348','2013-09-22','12:00:00',3.08),('8348','2013-09-22','12:05:00',3.1),('8348','2013-09-22','12:10:00',3.11),('8348','2013-09-22','12:15:00',3.13),('8348','2013-09-22','12:20:00',3.16),('8348','2013-09-22','12:25:00',3.19),('8348','2013-09-22','12:30:00',3.19),('8348','2013-09-22','12:35:00',3.2),('8348','2013-09-22','12:40:00',3.23),('8348','2013-09-22','12:45:00',3.23),('8348','2013-09-22','12:50:00',3.25),('8348','2013-09-22','12:55:00',3.28),('8348','2013-09-22','13:00:00',3.25),('8348','2013-09-22','13:05:00',3.25),('8348','2013-09-22','13:10:00',3.29),('8348','2013-09-22','13:15:00',3.27),('8348','2013-09-22','13:20:00',3.25),('8348','2013-09-22','13:25:00',3.21),('8348','2013-09-22','13:30:00',3.23),('8348','2013-09-22','13:35:00',3.21),('8348','2013-09-22','13:40:00',3.2),('8348','2013-09-22','13:45:00',3.23),('8348','2013-09-22','13:50:00',3.25),('8348','2013-09-22','13:55:00',2.84),('8348','2013-09-22','14:00:00',3.2),('8348','2013-09-22','14:05:00',3.24),('8348','2013-09-22','14:10:00',3.26),('8348','2013-09-22','14:15:00',3.32),('8348','2013-09-22','14:20:00',1.92),('8348','2013-09-22','14:25:00',3.15),('8348','2013-09-22','14:30:00',1.45),('8348','2013-09-22','14:35:00',3.23),('8348','2013-09-22','14:40:00',2.88),('8348','2013-09-22','14:45:00',2.95),('8348','2013-09-22','14:50:00',3.03),('8348','2013-09-22','14:55:00',3.02),('8348','2013-09-22','15:00:00',3.06),('8348','2013-09-22','15:05:00',3.13),('8348','2013-09-22','15:10:00',3.03),('8348','2013-09-22','15:15:00',2.95),('8348','2013-09-22','15:20:00',3.15),('8348','2013-09-22','15:25:00',1.34),('8348','2013-09-22','15:40:00',3.06),('8348','2013-09-22','15:45:00',2.71),('8348','2013-09-22','15:50:00',2.59),('8348','2013-09-22','15:55:00',2.6),('8348','2013-09-22','16:00:00',2.79),('8348','2013-09-22','16:05:00',2.45),('8348','2013-09-22','16:10:00',2.99),('8348','2013-09-22','16:15:00',2.67),('8348','2013-09-22','16:20:00',1.73),('8348','2013-09-22','16:25:00',1.35),('8348','2013-09-22','16:30:00',1.22),('8348','2013-09-22','16:45:00',1.86),('8348','2013-09-22','16:50:00',1.38),('8348','2013-09-22','16:55:00',1.59),('8348','2013-09-22','17:00:00',1.11),('8348','2013-09-22','17:05:00',1.86),('8348','2013-09-22','17:10:00',1.36),('8348','2013-09-21','08:55:00',1.03),('8348','2013-09-21','09:00:00',1.09),('8348','2013-09-21','09:05:00',1.16),('8348','2013-09-21','09:10:00',1.25),('8348','2013-09-21','09:15:00',1.32),('8348','2013-09-21','09:20:00',1.38),('8348','2013-09-21','09:25:00',1.46),('8348','2013-09-21','09:30:00',1.56),('8348','2013-09-21','09:35:00',1.63),('8348','2013-09-21','09:40:00',1.69),('8348','2013-09-21','09:45:00',1.76),('8348','2013-09-21','09:50:00',1.83),('8348','2013-09-21','09:55:00',1.88),('8348','2013-09-21','10:00:00',1.95),('8348','2013-09-21','10:05:00',2.01),('8348','2013-09-21','10:10:00',2.06),('8348','2013-09-21','10:15:00',2.11),('8348','2013-09-21','10:20:00',2.16),('8348','2013-09-21','10:25:00',2.22),('8348','2013-09-21','10:30:00',2.28),('8348','2013-09-21','10:35:00',2.32),('8348','2013-09-21','10:40:00',2.36),('8348','2013-09-21','10:45:00',2.41),('8348','2013-09-21','10:50:00',2.46),('8348','2013-09-21','10:55:00',2.51),('8348','2013-09-21','11:00:00',2.54),('8348','2013-09-21','11:05:00',2.59),('8348','2013-09-21','11:10:00',2.62),('8348','2013-09-21','11:15:00',2.66),('8348','2013-09-21','11:20:00',2.7),('8348','2013-09-21','11:25:00',2.75),('8348','2013-09-21','11:30:00',2.78),('8348','2013-09-21','11:35:00',2.81),('8348','2013-09-21','11:40:00',2.84),('8348','2013-09-21','11:45:00',2.88),('8348','2013-09-21','11:50:00',2.92),('8348','2013-09-21','11:55:00',2.87),('8348','2013-09-21','12:00:00',2.96),('8348','2013-09-21','12:05:00',3),('8348','2013-09-21','12:10:00',3.01),('8348','2013-09-21','12:15:00',3.04),('8348','2013-09-21','12:20:00',2.97),('8348','2013-09-21','12:25:00',2.77),('8348','2013-09-21','12:30:00',3.13),('8348','2013-09-21','12:35:00',3.05),('8348','2013-09-21','12:40:00',2.82),('8348','2013-09-21','12:45:00',2.98),('8348','2013-09-21','12:50:00',3.1),('8348','2013-09-21','12:55:00',3.13),('8348','2013-09-21','13:00:00',3.14),('8348','2013-09-21','13:05:00',3.02),('8348','2013-09-21','13:10:00',3.12),('8348','2013-09-21','13:15:00',3.21),('8348','2013-09-21','13:20:00',2.66),('8348','2013-09-21','13:25:00',3.01),('8348','2013-09-21','13:30:00',3.02),('8348','2013-09-21','13:35:00',3.06),('8348','2013-09-21','13:40:00',2.7),('8348','2013-09-21','13:45:00',2.69),('8348','2013-09-21','13:50:00',2.82),('8348','2013-09-21','13:55:00',2.84),('8348','2013-09-21','14:00:00',2.92),('8348','2013-09-21','14:05:00',3.03),('8348','2013-09-21','14:10:00',2.92),('8348','2013-09-21','14:15:00',3.04),('8348','2013-09-21','14:20:00',3.06),('8348','2013-09-21','14:25:00',3.03),('8348','2013-09-21','14:30:00',2.98),('8348','2013-09-21','14:35:00',2.96),('8348','2013-09-21','14:40:00',2.93),('8348','2013-09-21','14:45:00',2.88),('8348','2013-09-21','14:50:00',2.88),('8348','2013-09-21','14:55:00',2.84),('8348','2013-09-21','15:00:00',2.81),('8348','2013-09-21','15:05:00',2.78),('8348','2013-09-21','15:10:00',2.68),('8348','2013-09-21','15:15:00',2.68),('8348','2013-09-21','15:20:00',2.67),('8348','2013-09-21','15:25:00',2.62),('8348','2013-09-21','15:30:00',2.59),('8348','2013-09-21','15:35:00',2.56),('8348','2013-09-21','15:40:00',2.34),('8348','2013-09-21','15:45:00',1.94),('8348','2013-09-21','15:50:00',2.31),('8348','2013-09-21','15:55:00',2.4),('8348','2013-09-21','16:00:00',1.84),('8348','2013-09-21','16:05:00',1.18),('8348','2013-09-21','16:10:00',1.52),('8348','2013-09-21','16:15:00',1.32),('8348','2013-09-21','16:20:00',1.55),('8348','2013-09-21','16:30:00',1.16),('8348','2013-09-21','16:35:00',1.35),('8348','2013-09-21','17:05:00',1.01),('8348','2013-09-21','17:15:00',1.11),('8348','2013-09-21','17:35:00',1.01),('8348','2013-09-20','08:40:00',1.1),('8348','2013-09-20','08:45:00',1),('8348','2013-09-20','09:05:00',1.04),('8348','2013-09-20','09:20:00',1.27),('8348','2013-09-20','09:25:00',1.47),('8348','2013-09-20','09:30:00',1.05),('8348','2013-09-20','09:35:00',1.03),('8348','2013-09-20','09:40:00',1.04),('8348','2013-09-20','09:45:00',1.13),('8348','2013-09-20','09:50:00',1.13),('8348','2013-09-20','09:55:00',1.24),('8348','2013-09-20','10:00:00',1.34),('8348','2013-09-20','10:05:00',2.31),('8348','2013-09-20','10:10:00',1.6),('8348','2013-09-20','10:15:00',2.52),('8348','2013-09-20','10:20:00',2.11),('8348','2013-09-20','10:25:00',1.53),('8348','2013-09-20','10:30:00',1.59),('8348','2013-09-20','10:35:00',1.8),('8348','2013-09-20','10:40:00',1.84),('8348','2013-09-20','10:45:00',1.8),('8348','2013-09-20','10:50:00',2.21),('8348','2013-09-20','10:55:00',1.87),('8348','2013-09-20','11:00:00',1.8),('8348','2013-09-20','11:05:00',1.65),('8348','2013-09-20','11:10:00',1.95),('8348','2013-09-20','11:15:00',2.06),('8348','2013-09-20','11:20:00',1.99),('8348','2013-09-20','11:25:00',2.59),('8348','2013-09-20','11:30:00',1.94),('8348','2013-09-20','11:35:00',3.13),('8348','2013-09-20','11:40:00',1.75),('8348','2013-09-20','11:45:00',3.32),('8348','2013-09-20','11:50:00',3.22),('8348','2013-09-20','11:55:00',3.1),('8348','2013-09-20','12:00:00',3.04),('8348','2013-09-20','12:05:00',3.02),('8348','2013-09-20','12:10:00',3.05),('8348','2013-09-20','12:15:00',3.11),('8348','2013-09-20','12:20:00',3.19),('8348','2013-09-20','12:25:00',2.92),('8348','2013-09-20','12:30:00',3.17),('8348','2013-09-20','12:35:00',2.72),('8348','2013-09-20','12:40:00',2.83),('8348','2013-09-20','12:45:00',2.6),('8348','2013-09-20','12:50:00',3.1),('8348','2013-09-20','12:55:00',3.22),('8348','2013-09-20','13:00:00',2.19),('8348','2013-09-20','13:05:00',3.2),('8348','2013-09-20','13:10:00',3.16),('8348','2013-09-20','13:15:00',2.25),('8348','2013-09-20','13:20:00',2.83),('8348','2013-09-20','13:25:00',2.09),('8348','2013-09-20','13:30:00',3.18),('8348','2013-09-20','13:35:00',2.57),('8348','2013-09-20','13:40:00',2.79),('8348','2013-09-20','13:45:00',3.29),('8348','2013-09-20','13:50:00',3.16),('8348','2013-09-20','13:55:00',2.91),('8348','2013-09-20','14:00:00',3.16),('8348','2013-09-20','14:05:00',2.6),('8348','2013-09-20','14:10:00',3.19),('8348','2013-09-20','14:15:00',3.08),('8348','2013-09-20','14:25:00',2.81),('8348','2013-09-20','14:30:00',3.3),('8348','2013-09-20','14:35:00',3.2),('8348','2013-09-20','14:40:00',2.05),('8348','2013-09-20','14:45:00',2.93),('8348','2013-09-20','14:50:00',3.08),('8348','2013-09-20','14:55:00',3.06),('8348','2013-09-20','15:00:00',2.7),('8348','2013-09-20','15:05:00',2.16),('8348','2013-09-20','15:10:00',2.4),('8348','2013-09-20','15:15:00',1.69),('8348','2013-09-20','15:30:00',1.71),('8348','2013-09-20','15:35:00',2.24),('8348','2013-09-20','15:40:00',2.03),('8348','2013-09-20','15:45:00',2.53),('8348','2013-09-20','15:50:00',2.69),('8348','2013-09-20','15:55:00',2.76),('8348','2013-09-20','16:00:00',2.8),('8348','2013-09-20','16:05:00',2.18),('8348','2013-09-20','16:10:00',1.66),('8348','2013-09-20','16:15:00',1.7),('8348','2013-09-20','16:20:00',1.44),('8348','2013-09-20','16:25:00',1.47),('8348','2013-09-20','16:45:00',1.06),('8348','2013-09-20','16:50:00',1.2),('8348','2013-09-20','16:55:00',2.08),('8348','2013-09-20','17:00:00',2.06),('8348','2013-09-20','17:05:00',2.17),('8348','2013-09-20','17:10:00',2.16),('8348','2013-09-20','17:15:00',1.93),('8348','2013-09-20','17:20:00',1.87),('8348','2013-09-20','17:25:00',1.67),('8348','2013-09-20','17:30:00',1.42),('8348','2013-09-20','17:35:00',1.23),('8348','2013-09-20','17:40:00',1.16),('8348','2013-09-20','17:45:00',1.15),('8348','2013-09-20','17:50:00',1.04),('8348','2013-09-20','18:00:00',1.02),('8348','2013-09-19','08:50:00',1.02),('8348','2013-09-19','09:10:00',1.14),('8348','2013-09-19','09:15:00',1.44),('8348','2013-09-19','09:20:00',1.04),('8348','2013-09-19','10:05:00',1.74),('8348','2013-09-19','10:10:00',1.69),('8348','2013-09-19','10:15:00',1.45),('8348','2013-09-19','10:25:00',1.1),('8348','2013-09-19','10:35:00',2.39),('8348','2013-09-19','10:40:00',2.55),('8348','2013-09-19','10:45:00',1.66),('8348','2013-09-19','10:50:00',1.5),('8348','2013-09-19','10:55:00',2.27),('8348','2013-09-19','11:00:00',2.67),('8348','2013-09-19','11:05:00',2.34),('8348','2013-09-19','11:10:00',1.49),('8348','2013-09-19','11:15:00',1.57),('8348','2013-09-19','11:20:00',2.06),('8348','2013-09-19','11:25:00',1.88),('8348','2013-09-19','11:30:00',3.66),('8348','2013-09-19','11:35:00',3.07),('8348','2013-09-19','11:40:00',2.38),('8348','2013-09-19','11:45:00',2.69),('8348','2013-09-19','11:50:00',2.93),('8348','2013-09-19','11:55:00',2.89),('8348','2013-09-19','12:00:00',2.97),('8348','2013-09-19','12:05:00',1.9),('8348','2013-09-19','12:10:00',2.69),('8348','2013-09-19','12:15:00',1.61),('8348','2013-09-19','12:20:00',3.69),('8348','2013-09-19','12:25:00',3.79),('8348','2013-09-19','12:30:00',3.55),('8348','2013-09-19','12:35:00',3.34),('8348','2013-09-19','12:40:00',2.96),('8348','2013-09-19','12:45:00',1.93),('8348','2013-09-19','12:50:00',3.64),('8348','2013-09-19','12:55:00',3.58),('8348','2013-09-19','13:00:00',3.61),('8348','2013-09-19','13:05:00',3.64),('8348','2013-09-19','13:10:00',3.81),('8348','2013-09-19','13:15:00',3.52),('8348','2013-09-19','13:20:00',3.02),('8348','2013-09-19','13:25:00',2.01),('8348','2013-09-19','13:30:00',3.6),('8348','2013-09-19','13:35:00',3.63),('8348','2013-09-19','13:40:00',3.88),('8348','2013-09-19','13:45:00',3.23),('8348','2013-09-19','13:50:00',1.34),('8348','2013-09-19','13:55:00',1.05),('8348','2013-09-19','14:00:00',1.2),('8348','2013-09-19','14:05:00',3.26),('8348','2013-09-19','14:10:00',3.48),('8348','2013-09-19','14:15:00',3.36),('8348','2013-09-19','14:20:00',3.31),('8348','2013-09-19','14:25:00',3.12),('8348','2013-09-19','14:30:00',3.22),('8348','2013-09-19','14:35:00',3.19),('8348','2013-09-19','14:40:00',3.18),('8348','2013-09-19','14:45:00',2.93),('8348','2013-09-19','14:50:00',3),('8348','2013-09-19','14:55:00',3.2),('8348','2013-09-19','15:00:00',3.15),('8348','2013-09-19','15:05:00',2.66),('8348','2013-09-19','15:10:00',2.35),('8348','2013-09-19','15:15:00',3.14),('8348','2013-09-19','15:20:00',3),('8348','2013-09-19','15:25:00',2.45),('8348','2013-09-19','15:30:00',2.25),('8348','2013-09-19','15:35:00',1.52),('8348','2013-09-19','15:40:00',2.91),('8348','2013-09-19','15:45:00',2.74),('8348','2013-09-19','15:50:00',2.64),('8348','2013-09-19','15:55:00',2.43),('8348','2013-09-19','16:00:00',2.54),('8348','2013-09-19','16:05:00',2.42),('8348','2013-09-19','16:10:00',1.41),('8348','2013-09-19','16:15:00',2.23),('8348','2013-09-19','16:20:00',2.42),('8348','2013-09-19','16:25:00',2.25),('8348','2013-09-19','16:30:00',1.72),('8348','2013-09-19','16:35:00',1.33),('8348','2013-09-19','16:40:00',1.14),('8348','2013-09-19','16:45:00',1.22),('8348','2013-09-19','16:50:00',1.35),('8348','2013-09-19','16:55:00',1.74),('8348','2013-09-19','17:00:00',1.65),('8348','2013-09-19','17:05:00',1.68),('8348','2013-09-19','17:10:00',1.58),('8348','2013-09-19','17:15:00',1.5),('8348','2013-09-19','17:20:00',1.45),('8348','2013-09-19','17:25:00',1.32),('8348','2013-09-19','17:30:00',1.22),('8348','2014-04-13','07:30:00',1.17),('8348','2014-04-13','07:35:00',1.18),('8348','2014-04-13','07:40:00',1.24),('8348','2014-04-13','07:45:00',1.27),('8348','2014-04-13','07:50:00',1.19),('8348','2014-04-13','07:55:00',1.28),('8348','2014-04-13','08:00:00',1.64),('8348','2014-04-13','08:05:00',2.2),('8348','2014-04-13','08:10:00',2.53),('8348','2014-04-13','08:15:00',2.22),('8348','2014-04-13','08:20:00',2.49),('8348','2014-04-13','08:25:00',3.37),('8348','2014-04-13','08:30:00',3.12),('8348','2014-04-13','08:35:00',2.63),('8348','2014-04-13','08:40:00',3.74),('8348','2014-04-13','08:45:00',2.9),('8348','2014-04-13','08:50:00',2.48),('8348','2014-04-13','08:55:00',2.65),('8348','2014-04-13','09:00:00',4.88),('8348','2014-04-13','09:05:00',5.97),('8348','2014-04-13','09:10:00',4.06),('8348','2014-04-13','09:15:00',4.09),('8348','2014-04-13','09:20:00',5.45),('8348','2014-04-13','09:25:00',3.09),('8348','2014-04-13','09:30:00',5.57),('8348','2014-04-13','09:35:00',5.44),('8348','2014-04-13','09:40:00',5.34),('8348','2014-04-13','09:45:00',5.8),('8348','2014-04-13','09:50:00',5.87),('8348','2014-04-13','09:55:00',5.87),('8348','2014-04-13','10:00:00',5.99),('8348','2014-04-13','10:05:00',6.14),('8348','2014-04-13','10:10:00',5.9),('8348','2014-04-13','10:15:00',6.5),('8348','2014-04-13','10:20:00',7.56),('8348','2014-04-13','10:25:00',4.1),('8348','2014-04-13','10:30:00',3.44),('8348','2014-04-13','10:35:00',4.93),('8348','2014-04-13','10:40:00',6.88),('8348','2014-04-13','10:45:00',6.14),('8348','2014-04-13','10:50:00',6.34),('8348','2014-04-13','10:55:00',4.32),('8348','2014-04-13','11:00:00',4.25),('8348','2014-04-13','11:05:00',2.93),('8348','2014-04-13','11:10:00',2.6),('8348','2014-04-13','11:15:00',2.37),('8348','2014-04-13','11:20:00',2.08),('8348','2014-04-13','11:25:00',1.51),('8348','2014-04-13','11:30:00',1.07),('8348','2014-04-13','11:45:00',1.01),('8348','2014-04-13','11:50:00',1.15),('8348','2014-04-13','11:55:00',1.25),('8348','2014-04-13','12:00:00',1.39),('8348','2014-04-13','12:05:00',2.53),('8348','2014-04-13','12:10:00',3.61),('8348','2014-04-13','12:15:00',3.52),('8348','2014-04-13','12:20:00',4.64),('8348','2014-04-13','12:25:00',5.16),('8348','2014-04-13','12:30:00',7.9),('8348','2014-04-13','12:35:00',7.12),('8348','2014-04-13','12:40:00',6.54),('8348','2014-04-13','12:45:00',3.53),('8348','2014-04-13','12:50:00',5),('8348','2014-04-13','12:55:00',5.3),('8348','2014-04-13','13:00:00',7.31),('8348','2014-04-13','13:05:00',6.85),('8348','2014-04-13','13:10:00',7.18),('8348','2014-04-13','13:15:00',7.12),('8348','2014-04-13','13:20:00',3.62),('8348','2014-04-13','13:25:00',3.05),('8348','2014-04-13','13:30:00',3.04),('8348','2014-04-13','13:35:00',3.01),('8348','2014-04-13','13:40:00',2.57),('8348','2014-04-13','13:45:00',4.82),('8348','2014-04-13','13:50:00',7.49),('8348','2014-04-13','13:55:00',5.85),('8348','2014-04-13','14:00:00',5.68),('8348','2014-04-13','14:05:00',6.77),('8348','2014-04-13','14:10:00',7),('8348','2014-04-13','14:15:00',6.14),('8348','2014-04-13','14:20:00',6.08),('8348','2014-04-13','14:25:00',6.22),('8348','2014-04-13','14:30:00',5.92),('8348','2014-04-13','14:35:00',4.3),('8348','2014-04-13','14:40:00',2.71),('8348','2014-04-13','14:45:00',2.85),('8348','2014-04-13','14:50:00',3.43),('8348','2014-04-13','14:55:00',3.58),('8348','2014-04-13','15:00:00',6.39),('8348','2014-04-13','15:05:00',4.02),('8348','2014-04-13','15:10:00',2.33),('8348','2014-04-13','15:15:00',2.91),('8348','2014-04-13','15:20:00',2.67),('8348','2014-04-13','15:25:00',2.67),('8348','2014-04-13','15:30:00',2.4),('8348','2014-04-13','15:35:00',3.22),('8348','2014-04-13','15:40:00',5.02),('8348','2014-04-13','15:45:00',5.42),('8348','2014-04-13','15:50:00',3.65),('8348','2014-04-13','15:55:00',4.7),('8348','2014-04-13','16:00:00',4.41),('8348','2014-04-13','16:05:00',2.62),('8348','2014-04-13','16:10:00',1.85),('8348','2014-04-13','16:15:00',2.37),('8348','2014-04-13','16:20:00',3.27),('8348','2014-04-13','16:25:00',2.46),('8348','2014-04-13','16:30:00',1.51),('8348','2014-04-13','16:35:00',1.29),('8348','2014-04-13','16:40:00',1.23),('8348','2014-04-13','16:45:00',1.66),('8348','2014-04-13','16:50:00',2.07),('8348','2014-04-13','16:55:00',2.31),('8348','2014-04-13','17:00:00',1.77),('8348','2014-04-13','17:05:00',2.09),('8348','2014-04-13','17:10:00',1.01),('8348','2014-04-13','17:20:00',1.03),('8348','2013-09-18','08:55:00',1.14),('8348','2013-09-18','09:05:00',1.31),('8348','2013-09-18','09:15:00',1.17),('8348','2013-09-18','09:20:00',1.57),('8348','2013-09-18','09:25:00',1.68),('8348','2013-09-18','09:30:00',1.12),('8348','2013-09-18','09:35:00',1.35),('8348','2013-09-18','09:40:00',1.64),('8348','2013-09-18','09:55:00',1.8),('8348','2013-09-18','10:00:00',1.93),('8348','2013-09-18','10:05:00',2.24),('8348','2013-09-18','10:10:00',2.19),('8348','2013-09-18','10:15:00',2.1),('8348','2013-09-18','10:20:00',2.16),('8348','2013-09-18','10:25:00',2.22),('8348','2013-09-18','10:30:00',2.27),('8348','2013-09-18','10:35:00',2.31),('8348','2013-09-18','10:40:00',2.35),('8348','2013-09-18','10:45:00',2.38),('8348','2013-09-18','10:50:00',2.39),('8348','2013-09-18','10:55:00',1.44),('8348','2013-09-18','11:00:00',2.72),('8348','2013-09-18','11:05:00',2.28),('8348','2013-09-18','11:10:00',2.98),('8348','2013-09-18','11:15:00',2.88),('8348','2013-09-18','11:20:00',2.26),('8348','2013-09-18','11:25:00',3.17),('8348','2013-09-18','11:30:00',3.13),('8348','2013-09-18','11:35:00',2.84),('8348','2013-09-18','11:40:00',1.88),('8348','2013-09-18','11:45:00',2.27),('8348','2013-09-18','11:50:00',3.09),('8348','2013-09-18','11:55:00',3.15),('8348','2013-09-18','12:00:00',2.83),('8348','2013-09-18','12:05:00',2.73),('8348','2013-09-18','12:10:00',3.31),('8348','2013-09-18','12:15:00',3.37),('8348','2013-09-18','12:20:00',3.32),('8348','2013-09-18','12:25:00',2.49),('8348','2013-09-18','12:30:00',1.82),('8348','2013-09-18','12:35:00',2.84),('8348','2013-09-18','12:40:00',3.34),('8348','2013-09-18','12:45:00',2.41),('8348','2013-09-18','12:50:00',3.54),('8348','2013-09-18','12:55:00',3.52),('8348','2013-09-18','13:00:00',2.23),('8348','2013-09-18','13:05:00',2.75),('8348','2013-09-18','13:10:00',3.48),('8348','2013-09-18','13:15:00',3.37),('8348','2013-09-18','13:20:00',3.45),('8348','2013-09-18','13:25:00',3.48),('8348','2013-09-18','13:30:00',3.48),('8348','2013-09-18','13:35:00',3.43),('8348','2013-09-18','13:40:00',3.42),('8348','2013-09-18','13:45:00',3.31),('8348','2013-09-18','13:50:00',1.56),('8348','2013-09-18','13:55:00',3.21),('8348','2013-09-18','14:00:00',3.53),('8348','2013-09-18','14:05:00',3.4),('8348','2013-09-18','14:10:00',3.39),('8348','2013-09-18','14:15:00',3.06),('8348','2013-09-18','14:20:00',3.32),('8348','2013-09-18','14:25:00',3.29),('8348','2013-09-18','14:30:00',3.22),('8348','2013-09-18','14:35:00',3.2),('8348','2013-09-18','14:40:00',3.2),('8348','2013-09-18','14:45:00',3.13),('8348','2013-09-18','14:50:00',3.22),('8348','2013-09-18','14:55:00',2.92),('8348','2013-09-18','15:00:00',3.11),('8348','2013-09-18','15:05:00',3.08),('8348','2013-09-18','15:10:00',1.44),('8348','2013-09-18','15:15:00',2.04),('8348','2013-09-18','15:20:00',2.56),('8348','2013-09-18','15:25:00',3.07),('8348','2013-09-18','15:30:00',3),('8348','2013-09-18','15:35:00',2.95),('8348','2013-09-18','15:40:00',2.9),('8348','2013-09-18','15:45:00',2.27),('8348','2013-09-18','15:50:00',2.23),('8348','2013-09-18','15:55:00',2.3),('8348','2013-09-18','16:00:00',2.39),('8348','2013-09-18','16:05:00',2.42),('8348','2013-09-18','16:10:00',2.66),('8348','2013-09-18','16:15:00',2.52),('8348','2013-09-18','16:20:00',2.35),('8348','2013-09-18','16:25:00',2.06),('8348','2013-09-18','16:30:00',1.98),('8348','2013-09-18','16:35:00',1.9),('8348','2013-09-18','16:40:00',1.94),('8348','2013-09-18','16:45:00',1.88),('8348','2013-09-18','16:50:00',1.69),('8348','2013-09-18','16:55:00',1.68),('8348','2013-09-18','17:00:00',1.78),('8348','2013-09-18','17:05:00',1.55),('8348','2013-09-18','17:10:00',1.59),('8348','2013-09-18','17:15:00',1.54),('8348','2013-09-18','17:20:00',1.49),('8348','2013-09-18','17:25:00',1.28),('8348','2013-09-18','17:30:00',1.36),('8348','2013-09-18','17:35:00',1.23),('8348','2013-09-18','17:40:00',1.16),('8348','2013-09-18','17:45:00',1.07),('8348','2013-09-17','09:40:00',1.15),('8348','2013-09-17','09:45:00',1.79),('8348','2013-09-17','09:50:00',1.09),('8348','2013-09-17','09:55:00',1.33),('8348','2013-09-17','10:00:00',1.68),('8348','2013-09-17','10:05:00',1.37),('8348','2013-09-17','10:10:00',1.62),('8348','2013-09-17','10:25:00',1.79),('8348','2013-09-17','10:30:00',2.39),('8348','2013-09-17','10:35:00',1.43),('8348','2013-09-17','10:40:00',1.33),('8348','2013-09-17','10:45:00',2.17),('8348','2013-09-17','10:50:00',3.08),('8348','2013-09-17','10:55:00',2.34),('8348','2013-09-17','11:00:00',1.81),('8348','2013-09-17','11:05:00',1.38),('8348','2013-09-17','11:10:00',2.96),('8348','2013-09-17','11:15:00',2.37),('8348','2013-09-17','11:20:00',1.97),('8348','2013-09-17','11:25:00',1.58),('8348','2013-09-17','11:30:00',1.58),('8348','2013-09-17','11:35:00',2.8),('8348','2013-09-17','11:40:00',2.9),('8348','2013-09-17','11:45:00',2.9),('8348','2013-09-17','11:50:00',2.98),('8348','2013-09-17','11:55:00',2.81),('8348','2013-09-17','12:00:00',2.93),('8348','2013-09-17','12:05:00',3.12),('8348','2013-09-17','12:10:00',1.58),('8348','2013-09-17','12:15:00',2.04),('8348','2013-09-17','12:20:00',2.02),('8348','2013-09-17','12:25:00',3.42),('8348','2013-09-17','12:30:00',2.66),('8348','2013-09-17','12:35:00',1.82),('8348','2013-09-17','12:40:00',3.12),('8348','2013-09-17','12:45:00',2.86),('8348','2013-09-17','12:50:00',2.27),('8348','2013-09-17','12:55:00',2.38),('8348','2013-09-17','13:00:00',2.15),('8348','2013-09-17','13:05:00',1.32),('8348','2013-09-17','13:10:00',2.38),('8348','2013-09-17','13:15:00',2.69),('8348','2013-09-17','13:20:00',2.11),('8348','2013-09-17','13:25:00',1.82),('8348','2013-09-17','13:30:00',1.57),('8348','2013-09-17','13:35:00',1.65),('8348','2013-09-17','13:40:00',2.33),('8348','2013-09-17','13:45:00',1.62),('8348','2013-09-17','13:55:00',1.17),('8348','2013-09-17','14:00:00',1.63),('8348','2013-09-17','14:05:00',1),('8348','2013-09-17','14:15:00',1.24),('8348','2013-09-17','14:25:00',1.69),('8348','2013-09-17','14:35:00',1.05),('8348','2013-09-17','14:55:00',3.02),('8348','2013-09-17','15:00:00',3.15),('8348','2013-09-17','15:05:00',2.5),('8348','2013-09-17','15:10:00',2.43),('8348','2013-09-17','15:15:00',2.5),('8348','2013-09-17','15:20:00',2.67),('8348','2013-09-17','15:25:00',2.54),('8348','2013-09-17','15:30:00',2),('8348','2013-09-17','15:45:00',1.43),('8348','2013-09-17','15:50:00',1.75),('8348','2013-09-17','15:55:00',2.06),('8348','2013-09-17','16:00:00',1.29),('8348','2013-09-17','16:05:00',1.64),('8348','2013-09-17','16:10:00',1.64),('8348','2013-09-17','16:15:00',1.68),('8348','2013-09-17','16:40:00',1.16),('8348','2013-09-17','16:45:00',1.38),('8348','2013-09-17','16:50:00',1.19),('8348','2013-09-17','17:00:00',1.48),('8348','2013-09-17','17:05:00',1.62),('8348','2013-09-17','17:10:00',1.5),('8348','2013-09-17','17:15:00',1.56),('8348','2013-09-17','17:20:00',1.35),('8348','2013-09-17','17:25:00',1.34),('8348','2013-09-17','17:30:00',1.32),('8348','2013-09-16','09:05:00',1.39),('8348','2013-09-16','09:10:00',1.52),('8348','2013-09-16','09:15:00',1.38),('8348','2013-09-16','09:20:00',1.34),('8348','2013-09-16','09:25:00',1.16),('8348','2013-09-16','09:30:00',1.56),('8348','2013-09-16','09:35:00',1.64),('8348','2013-09-16','09:40:00',1.72),('8348','2013-09-16','09:45:00',1.82),('8348','2013-09-16','09:50:00',1.9),('8348','2013-09-16','09:55:00',2),('8348','2013-09-16','10:00:00',2.06),('8348','2013-09-16','10:05:00',2.16),('8348','2013-09-16','10:10:00',1.8),('8348','2013-09-16','10:15:00',1.22),('8348','2013-09-16','10:20:00',1.74),('8348','2013-09-16','10:25:00',1.9),('8348','2013-09-16','10:30:00',2.65),('8348','2013-09-16','10:35:00',2.82),('8348','2013-09-16','10:40:00',3.03),('8348','2013-09-16','10:45:00',3.13),('8348','2013-09-16','10:50:00',1.73),('8348','2013-09-16','11:05:00',1.9),('8348','2013-09-16','11:15:00',2.29),('8348','2013-09-16','11:25:00',1.22),('8348','2013-09-16','11:30:00',3.23),('8348','2013-09-16','11:35:00',3.19),('8348','2013-09-16','11:40:00',3.31),('8348','2013-09-16','11:45:00',2.25),('8348','2013-09-16','11:50:00',2.71),('8348','2013-09-16','11:55:00',3.29),('8348','2013-09-16','12:00:00',3.36),('8348','2013-09-16','12:05:00',3.64),('8348','2013-09-16','12:10:00',2.51),('8348','2013-09-16','12:15:00',3.59),('8348','2013-09-16','12:20:00',3.34),('8348','2013-09-16','12:25:00',3.33),('8348','2013-09-16','12:30:00',3.33),('8348','2013-09-16','12:35:00',3.4),('8348','2013-09-16','12:40:00',3.63),('8348','2013-09-16','12:45:00',2.94),('8348','2013-09-16','12:50:00',2.52),('8348','2013-09-16','12:55:00',2.09),('8348','2013-09-16','13:00:00',1.39),('8348','2013-09-16','13:05:00',2.68),('8348','2013-09-16','13:10:00',3.56),('8348','2013-09-16','13:15:00',3.42),('8348','2013-09-16','13:20:00',3.43),('8348','2013-09-16','13:25:00',3.39),('8348','2013-09-16','13:30:00',3.38),('8348','2013-09-16','13:35:00',3.45),('8348','2013-09-16','13:40:00',3.43),('8348','2013-09-16','13:45:00',3.39),('8348','2013-09-16','13:50:00',3.46),('8348','2013-09-16','13:55:00',3.54),('8348','2013-09-16','14:00:00',2.34),('8348','2013-09-16','14:05:00',3.42),('8348','2013-09-16','14:10:00',3.33),('8348','2013-09-16','14:15:00',3.27),('8348','2013-09-16','14:20:00',3.22),('8348','2013-09-16','14:25:00',3.23),('8348','2013-09-16','14:30:00',3.2),('8348','2013-09-16','14:35:00',3.17),('8348','2013-09-16','14:40:00',3.13),('8348','2013-09-16','14:45:00',3.12),('8348','2013-09-16','14:50:00',3.11),('8348','2013-09-16','14:55:00',3.1),('8348','2013-09-16','15:00:00',3.07),('8348','2013-09-16','15:05:00',3.06),('8348','2013-09-16','15:10:00',3.05),('8348','2013-09-16','15:15:00',3.02),('8348','2013-09-16','15:20:00',2.98),('8348','2013-09-16','15:25:00',2.93),('8348','2013-09-16','15:30:00',2.89),('8348','2013-09-16','15:35:00',2.84),('8348','2013-09-16','15:40:00',2.81),('8348','2013-09-16','15:45:00',2.76),('8348','2013-09-16','15:50:00',2.72),('8348','2013-09-16','15:55:00',2.67),('8348','2013-09-16','16:00:00',2.37),('8348','2013-09-16','16:05:00',1.41),('8348','2013-09-16','16:10:00',2.6),('8348','2013-09-16','16:15:00',2.47),('8348','2013-09-16','16:20:00',2.4),('8348','2013-09-16','16:25:00',2.34),('8348','2013-09-16','16:30:00',2.28),('8348','2013-09-16','16:35:00',2.2),('8348','2013-09-16','16:40:00',2.15),('8348','2013-09-16','16:45:00',2.09),('8348','2013-09-16','16:50:00',2.02),('8348','2013-09-16','16:55:00',1.94),('8348','2013-09-16','17:00:00',1.88),('8348','2013-09-16','17:05:00',1.8),('8348','2013-09-16','17:10:00',1.72),('8348','2013-09-16','17:15:00',1.63),('8348','2013-09-16','17:20:00',1.56),('8348','2013-09-16','17:25:00',1.49),('8348','2013-09-16','17:30:00',1.44),('8348','2013-09-16','17:35:00',1.35),('8348','2013-09-16','17:40:00',1.23),('8348','2013-09-16','17:45:00',1.15),('8348','2013-09-16','17:50:00',1.04),('8348','2013-09-15','08:45:00',1.04),('8348','2013-09-15','08:50:00',1.06),('8348','2013-09-15','08:55:00',1.05),('8348','2013-09-15','09:00:00',1.13),('8348','2013-09-15','09:05:00',1.13),('8348','2013-09-15','09:10:00',1.31),('8348','2013-09-15','09:15:00',1.48),('8348','2013-09-15','09:20:00',1.47),('8348','2013-09-15','09:25:00',1.58),('8348','2013-09-15','09:30:00',1.62),('8348','2013-09-15','09:35:00',1.74),('8348','2013-09-15','09:40:00',1.81),('8348','2013-09-15','09:45:00',1.83),('8348','2013-09-15','09:50:00',1.92),('8348','2013-09-15','09:55:00',1.98),('8348','2013-09-15','10:00:00',2.08),('8348','2013-09-15','10:05:00',2.14),('8348','2013-09-15','10:10:00',2.16),('8348','2013-09-15','10:15:00',2.1),('8348','2013-09-15','10:20:00',2.18),('8348','2013-09-15','10:25:00',2.28),('8348','2013-09-15','10:30:00',2.17),('8348','2013-09-15','10:35:00',1.66),('8348','2013-09-15','10:40:00',1.29),('8348','2013-09-15','10:50:00',1.33),('8348','2013-09-15','10:55:00',2.7),('8348','2013-09-15','11:00:00',2.84),('8348','2013-09-15','11:05:00',3.06),('8348','2013-09-15','11:10:00',2.78),('8348','2013-09-15','11:15:00',1.31),('8348','2013-09-15','11:20:00',1.09),('8348','2013-09-15','11:25:00',1.73),('8348','2013-09-15','11:30:00',2.08),('8348','2013-09-15','11:35:00',1.8),('8348','2013-09-15','11:40:00',1.24),('8348','2013-09-15','11:45:00',1.42),('8348','2013-09-15','11:50:00',3.53),('8348','2013-09-15','11:55:00',1.15),('8348','2013-09-15','12:00:00',1.05),('8348','2013-09-15','12:05:00',1.02),('8348','2013-09-15','12:10:00',1.01),('8348','2013-09-15','12:15:00',1.09),('8348','2013-09-15','12:20:00',1.33),('8348','2013-09-15','12:25:00',1.56),('8348','2013-09-15','12:30:00',1.48),('8348','2013-09-15','12:35:00',1.34),('8348','2013-09-15','12:40:00',1.23),('8348','2013-09-15','12:50:00',1.18),('8348','2013-09-15','12:55:00',1.24),('8348','2013-09-15','13:00:00',1.15),('8348','2013-09-15','13:35:00',1.12),('8348','2013-09-15','13:40:00',1.29),('8348','2013-09-15','13:45:00',2.44),('8348','2013-09-15','13:50:00',2.23),('8348','2013-09-15','13:55:00',1.1),('8348','2013-09-15','14:00:00',1.62),('8348','2013-09-15','14:05:00',1.53),('8348','2013-09-15','14:10:00',1.44),('8348','2013-09-15','14:15:00',1.37),('8348','2013-09-15','14:20:00',1.28),('8348','2013-09-15','14:25:00',1.25),('8348','2013-09-15','14:30:00',1.19),('8348','2013-09-15','14:40:00',1.05),('8348','2013-09-15','14:55:00',1),('8348','2013-09-15','15:00:00',1.02),('8348','2013-09-15','15:05:00',1.08),('8348','2013-09-15','15:10:00',1.23),('8348','2013-09-15','15:15:00',2.32),('8348','2013-09-15','15:20:00',1.86),('8348','2013-09-15','15:25:00',1.34),('8348','2013-09-14','08:50:00',1.03),('8348','2013-09-14','08:55:00',1.11),('8348','2013-09-14','09:00:00',1.18),('8348','2013-09-14','09:05:00',1.25),('8348','2013-09-14','09:10:00',1.35),('8348','2013-09-14','09:15:00',1.42),('8348','2013-09-14','09:20:00',1.5),('8348','2013-09-14','09:25:00',1.58),('8348','2013-09-14','09:30:00',1.66),('8348','2013-09-14','09:35:00',1.72),('8348','2013-09-14','09:40:00',1.78),('8348','2013-09-14','09:45:00',1.85),('8348','2013-09-14','09:50:00',1.87),('8348','2013-09-14','09:55:00',1.98),('8348','2013-09-14','10:00:00',2.03),('8348','2013-09-14','10:05:00',2.02),('8348','2013-09-14','10:10:00',1.98),('8348','2013-09-14','10:15:00',2.03),('8348','2013-09-14','10:20:00',2.19),('8348','2013-09-14','10:25:00',2.28),('8348','2013-09-14','10:30:00',2.33),('8348','2013-09-14','10:35:00',2.43),('8348','2013-09-14','10:40:00',2.58),('8348','2013-09-14','10:45:00',2.23),('8348','2013-09-14','10:50:00',2.9),('8348','2013-09-14','10:55:00',2.74),('8348','2013-09-14','11:00:00',1.72),('8348','2013-09-14','11:15:00',1.7),('8348','2013-09-14','11:25:00',2.3),('8348','2013-09-14','11:30:00',3.08),('8348','2013-09-14','11:35:00',3.24),('8348','2013-09-14','11:40:00',3.24),('8348','2013-09-14','11:45:00',3.24),('8348','2013-09-14','11:50:00',3.39),('8348','2013-09-14','11:55:00',1.37),('8348','2013-09-14','12:15:00',1.05),('8348','2013-09-14','12:30:00',1.32),('8348','2013-09-14','12:35:00',1.47),('8348','2013-09-14','12:40:00',1.95),('8348','2013-09-14','13:10:00',1.87),('8348','2013-09-14','13:15:00',3.8),('8348','2013-09-14','13:20:00',3.49),('8348','2013-09-14','13:25:00',3.27),('8348','2013-09-14','13:30:00',3.55),('8348','2013-09-14','13:35:00',2.57),('8348','2013-09-14','13:40:00',2.71),('8348','2013-09-14','13:45:00',2.88),('8348','2013-09-14','13:50:00',2.53),('8348','2013-09-14','13:55:00',3.36),('8348','2013-09-14','14:00:00',3.65),('8348','2013-09-14','14:05:00',3.43),('8348','2013-09-14','14:10:00',3.34),('8348','2013-09-14','14:15:00',3.35),('8348','2013-09-14','14:20:00',3.27),('8348','2013-09-14','14:25:00',3.25),('8348','2013-09-14','14:30:00',3.24),('8348','2013-09-14','14:35:00',3.23),('8348','2013-09-14','14:40:00',3.22),('8348','2013-09-14','14:45:00',3.17),('8348','2013-09-14','14:50:00',3.15),('8348','2013-09-14','14:55:00',3.13),('8348','2013-09-14','15:00:00',3.1),('8348','2013-09-14','15:05:00',3.02),('8348','2013-09-14','15:10:00',3.01),('8348','2013-09-14','15:15:00',2.97),('8348','2013-09-14','15:20:00',2.93),('8348','2013-09-14','15:25:00',2.93),('8348','2013-09-14','15:30:00',2.88),('8348','2013-09-14','15:35:00',2.82),('8348','2013-09-14','15:40:00',2.81),('8348','2013-09-14','15:45:00',2.76),('8348','2013-09-14','15:50:00',2.68),('8348','2013-09-14','15:55:00',2.65),('8348','2013-09-14','16:00:00',2.59),('8348','2013-09-14','16:05:00',2.55),('8348','2013-09-14','16:10:00',2.46),('8348','2013-09-14','16:15:00',2.41),('8348','2013-09-14','16:20:00',2.34),('8348','2013-09-14','16:25:00',2.31),('8348','2013-09-14','16:30:00',2.26),('8348','2013-09-14','16:35:00',2.21),('8348','2013-09-14','16:40:00',2.15),('8348','2013-09-14','16:45:00',2.06),('8348','2013-09-14','16:50:00',2.01),('8348','2013-09-14','16:55:00',1.94),('8348','2013-09-14','17:00:00',1.86),('8348','2013-09-14','17:05:00',1.79),('8348','2013-09-14','17:10:00',1.75),('8348','2013-09-14','17:15:00',1.68),('8348','2013-09-14','17:20:00',1.39),('8348','2013-09-14','17:25:00',1.49),('8348','2013-09-14','17:30:00',1.42),('8348','2013-09-14','17:35:00',1.33),('8348','2013-09-14','17:40:00',1.25),('8348','2013-09-14','17:45:00',1.19),('8348','2013-09-14','17:50:00',1.12),('8348','2013-09-13','09:30:00',1.03),('8348','2013-09-13','09:35:00',1.13),('8348','2013-09-13','09:40:00',1.22),('8348','2013-09-13','09:45:00',1.13),('8348','2013-09-13','09:50:00',1.27),('8348','2013-09-13','09:55:00',1.62),('8348','2013-09-13','10:00:00',2.06),('8348','2013-09-13','10:10:00',1.68),('8348','2013-09-13','10:15:00',2.86),('8348','2013-09-13','10:20:00',2.3),('8348','2013-09-13','10:25:00',1.18),('8348','2013-09-13','10:30:00',2.26),('8348','2013-09-13','10:35:00',2.59),('8348','2013-09-13','10:40:00',2.48),('8348','2013-09-13','10:45:00',2.55),('8348','2013-09-13','10:50:00',2.59),('8348','2013-09-13','10:55:00',2.63),('8348','2013-09-13','11:00:00',2.66),('8348','2013-09-13','11:05:00',2.71),('8348','2013-09-13','11:10:00',2.74),('8348','2013-09-13','11:15:00',2.77),('8348','2013-09-13','11:20:00',2.82),('8348','2013-09-13','11:25:00',2.85),('8348','2013-09-13','11:30:00',2.9),('8348','2013-09-13','11:35:00',2.93),('8348','2013-09-13','11:40:00',2.95),('8348','2013-09-13','11:45:00',2.97),('8348','2013-09-13','11:50:00',3.03),('8348','2013-09-13','11:55:00',3.04),('8348','2013-09-13','12:00:00',3.03),('8348','2013-09-13','12:05:00',3.05),('8348','2013-09-13','12:10:00',2.99),('8348','2013-09-13','12:15:00',3.13),('8348','2013-09-13','12:20:00',3.13),('8348','2013-09-13','12:25:00',2.95),('8348','2013-09-13','12:30:00',3.33),('8348','2013-09-13','12:35:00',3.29),('8348','2013-09-13','12:40:00',3.28),('8348','2013-09-13','12:45:00',3.29),('8348','2013-09-13','12:50:00',3.3),('8348','2013-09-13','12:55:00',3.29),('8348','2013-09-13','13:00:00',3.28),('8348','2013-09-13','13:05:00',3.26),('8348','2013-09-13','13:10:00',3.28),('8348','2013-09-13','13:15:00',3.27),('8348','2013-09-13','13:20:00',3.24),('8348','2013-09-13','13:25:00',3.2),('8348','2013-09-13','13:30:00',3.19),('8348','2013-09-13','13:35:00',3.2),('8348','2013-09-13','13:40:00',3.21),('8348','2013-09-13','13:45:00',3.19),('8348','2013-09-13','13:50:00',3.19),('8348','2013-09-13','13:55:00',3.24),('8348','2013-09-13','14:00:00',3.26),('8348','2013-09-13','14:05:00',3.22),('8348','2013-09-13','14:10:00',3.19),('8348','2013-09-13','14:15:00',3.21),('8348','2013-09-13','14:20:00',3.22),('8348','2013-09-13','14:25:00',2.82),('8348','2013-09-13','14:30:00',2.4),('8348','2013-09-13','14:35:00',3.16),('8348','2013-09-13','14:40:00',3.12),('8348','2013-09-13','14:45:00',2.82),('8348','2013-09-13','14:50:00',2.43),('8348','2013-09-13','14:55:00',2.87),('8348','2013-09-13','15:00:00',3.06),('8348','2013-09-13','15:05:00',3.04),('8348','2013-09-13','15:10:00',3.03),('8348','2013-09-13','15:15:00',3.02),('8348','2013-09-13','15:20:00',2.95),('8348','2013-09-13','15:25:00',2.92),('8348','2013-09-13','15:30:00',2.88),('8348','2013-09-13','15:35:00',2.82),('8348','2013-09-13','15:40:00',2.8),('8348','2013-09-13','15:45:00',2.78),('8348','2013-09-13','15:50:00',2.74),('8348','2013-09-13','15:55:00',2.69),('8348','2013-09-13','16:00:00',2.63),('8348','2013-09-13','16:05:00',2.59),('8348','2013-09-13','16:10:00',2.51),('8348','2013-09-13','16:15:00',2.49),('8348','2013-09-13','16:20:00',2.42),('8348','2013-09-13','16:25:00',2.36),('8348','2013-09-13','16:30:00',2.3),('8348','2013-09-13','16:35:00',2.24),('8348','2013-09-13','16:40:00',2.18),('8348','2013-09-13','16:45:00',2.1),('8348','2013-09-13','16:50:00',2.04),('8348','2013-09-13','16:55:00',1.95),('8348','2013-09-13','17:00:00',1.88),('8348','2013-09-13','17:05:00',1.8),('8348','2013-09-13','17:10:00',1.73),('8348','2013-09-13','17:15:00',1.66),('8348','2013-09-13','17:20:00',1.59),('8348','2013-09-13','17:25:00',1.51),('8348','2013-09-13','17:30:00',1.43),('8348','2013-09-13','17:35:00',1.34),('8348','2013-09-13','17:40:00',1.26),('8348','2013-09-13','17:45:00',1.19),('8348','2013-09-13','17:50:00',1.11),('8348','2013-09-13','17:55:00',1.03),('8348','2013-09-12','08:30:00',1.1),('8348','2013-09-12','08:35:00',1.04),('8348','2013-09-12','09:00:00',1.2),('8348','2013-09-12','09:05:00',1.2),('8348','2013-09-12','09:15:00',1.41),('8348','2013-09-12','09:20:00',1.54),('8348','2013-09-12','09:25:00',1.75),('8348','2013-09-12','09:30:00',1.91),('8348','2013-09-12','09:35:00',1.85),('8348','2013-09-12','09:40:00',1.56),('8348','2013-09-12','09:45:00',1.9),('8348','2013-09-12','09:50:00',1.5),('8348','2013-09-12','09:55:00',1.02),('8348','2013-09-12','10:05:00',1.26),('8348','2013-09-12','10:10:00',1.49),('8348','2013-09-12','10:15:00',1.45),('8348','2013-09-12','10:20:00',1.04),('8348','2013-09-12','10:25:00',1.13),('8348','2013-09-12','10:30:00',1.99),('8348','2013-09-12','10:35:00',1.55),('8348','2013-09-12','10:55:00',1.67),('8348','2013-09-12','11:00:00',2.18),('8348','2013-09-12','11:05:00',3.11),('8348','2013-09-12','11:10:00',2.48),('8348','2013-09-12','11:15:00',2.2),('8348','2013-09-12','11:40:00',1.18),('8348','2013-09-12','11:45:00',1.63),('8348','2013-09-12','11:50:00',1.46),('8348','2013-09-12','11:55:00',2.76),('8348','2013-09-12','12:00:00',2.67),('8348','2013-09-12','12:05:00',3.15),('8348','2013-09-12','12:10:00',2.72),('8348','2013-09-12','12:15:00',3.18),('8348','2013-09-12','12:20:00',1.26),('8348','2013-09-12','12:25:00',1.64),('8348','2013-09-12','12:30:00',1.42),('8348','2013-09-12','12:35:00',2.72),('8348','2013-09-12','12:40:00',3.15),('8348','2013-09-12','12:50:00',2.42),('8348','2013-09-12','12:55:00',1.68),('8348','2013-09-12','13:00:00',3.75),('8348','2013-09-12','13:05:00',2.25),('8348','2013-09-12','13:10:00',2),('8348','2013-09-12','13:15:00',3.51),('8348','2013-09-12','13:20:00',3.9),('8348','2013-09-12','13:25:00',3.93),('8348','2013-09-12','13:30:00',3.05),('8348','2013-09-12','13:35:00',2.45),('8348','2013-09-12','13:40:00',2.85),('8348','2013-09-12','13:45:00',3.12),('8348','2013-09-12','13:50:00',3.6),('8348','2013-09-12','13:55:00',3.48),('8348','2013-09-12','14:00:00',3.51),('8348','2013-09-12','14:05:00',2.9),('8348','2013-09-12','14:10:00',2.86),('8348','2013-09-12','14:15:00',3.46),('8348','2013-09-12','14:20:00',3.52),('8348','2013-09-12','14:25:00',3.4),('8348','2013-09-12','14:30:00',3.44),('8348','2013-09-12','14:35:00',2.32),('8348','2013-09-12','14:40:00',2.94),('8348','2013-09-12','14:45:00',3.28),('8348','2013-09-12','14:50:00',3.25),('8348','2013-09-12','14:55:00',3.22),('8348','2013-09-12','15:00:00',3.23),('8348','2013-09-12','15:05:00',2.76),('8348','2013-09-12','15:10:00',2.15),('8348','2013-09-12','15:15:00',2.91),('8348','2013-09-12','15:20:00',3.05),('8348','2013-09-12','15:25:00',2.68),('8348','2013-09-12','15:30:00',2.98),('8348','2013-09-12','15:35:00',2.91),('8348','2013-09-12','15:40:00',2.89),('8348','2013-09-12','15:45:00',2.87),('8348','2013-09-12','15:50:00',2.77),('8348','2013-09-12','15:55:00',2.74),('8348','2013-09-12','16:00:00',2.82),('8348','2013-09-12','16:05:00',1.59),('8348','2013-09-12','16:10:00',2.69),('8348','2013-09-12','16:15:00',2.18),('8348','2013-09-12','16:20:00',1.67),('8348','2013-09-12','16:25:00',1.47),('8348','2013-09-12','16:30:00',1.48),('8348','2013-09-12','16:40:00',1.99),('8348','2013-09-12','16:45:00',2.39),('8348','2013-09-12','16:50:00',1.09),('8348','2013-09-12','16:55:00',1.5),('8348','2013-09-12','17:00:00',1.33),('8348','2013-09-12','17:05:00',1.82),('8348','2013-09-12','17:10:00',1.65),('8348','2013-09-12','17:15:00',1.77),('8348','2013-09-12','17:20:00',1.37),('8348','2013-09-12','17:30:00',1.6),('8348','2013-09-12','17:35:00',1.49),('8348','2013-09-12','17:40:00',1.39),('8348','2013-09-12','17:45:00',1.31),('8348','2013-09-12','17:50:00',1.16),('8348','2013-09-12','17:55:00',1.09),('8348','2013-09-11','09:00:00',1.37),('8348','2013-09-11','09:05:00',1.52),('8348','2013-09-11','09:10:00',1.55),('8348','2013-09-11','09:15:00',1.59),('8348','2013-09-11','09:20:00',1.98),('8348','2013-09-11','09:25:00',1.41),('8348','2013-09-11','09:30:00',1.04),('8348','2013-09-11','09:35:00',1.31),('8348','2013-09-11','09:40:00',1.12),('8348','2013-09-11','10:05:00',1.78),('8348','2013-09-11','10:15:00',1.9),('8348','2013-09-11','10:20:00',2.36),('8348','2013-09-11','10:25:00',1.84),('8348','2013-09-11','10:30:00',2.39),('8348','2013-09-11','10:35:00',2.56),('8348','2013-09-11','10:40:00',1.67),('8348','2013-09-11','10:45:00',1.35),('8348','2013-09-11','10:50:00',2.56),('8348','2013-09-11','10:55:00',1.21),('8348','2013-09-11','11:00:00',1.24),('8348','2013-09-11','11:05:00',1.32),('8348','2013-09-11','11:10:00',2.62),('8348','2013-09-11','11:15:00',2.28),('8348','2013-09-11','11:20:00',2.6),('8348','2013-09-11','11:25:00',2.17),('8348','2013-09-11','11:35:00',1.94),('8348','2013-09-11','11:40:00',3.03),('8348','2013-09-11','11:45:00',3.24),('8348','2013-09-11','11:50:00',2.93),('8348','2013-09-11','11:55:00',2.67),('8348','2013-09-11','12:00:00',2.81),('8348','2013-09-11','12:05:00',3.07),('8348','2013-09-11','12:10:00',1.98),('8348','2013-09-11','12:15:00',1.58),('8348','2013-09-11','12:20:00',1.81),('8348','2013-09-11','12:25:00',2.74),('8348','2013-09-11','12:30:00',2.99),('8348','2013-09-11','12:35:00',2.24),('8348','2013-09-11','12:45:00',1.52),('8348','2013-09-11','12:50:00',3.56),('8348','2013-09-11','12:55:00',1.81),('8348','2013-09-11','13:00:00',2.74),('8348','2013-09-11','13:05:00',3.22),('8348','2013-09-11','13:10:00',3.47),('8348','2013-09-11','13:15:00',3.84),('8348','2013-09-11','13:20:00',3.51),('8348','2013-09-11','13:25:00',3.26),('8348','2013-09-11','13:30:00',3.02),('8348','2013-09-11','13:35:00',1.82),('8348','2013-09-11','13:40:00',2.6),('8348','2013-09-11','13:45:00',2.63),('8348','2013-09-11','13:50:00',3.25),('8348','2013-09-11','13:55:00',2.38),('8348','2013-09-11','14:00:00',2.92),('8348','2013-09-11','14:05:00',3.62),('8348','2013-09-11','14:10:00',3),('8348','2013-09-11','14:15:00',3.49),('8348','2013-09-11','14:20:00',2.35),('8348','2013-09-11','14:25:00',3.12),('8348','2013-09-11','14:30:00',2.69),('8348','2013-09-11','14:35:00',2.79),('8348','2013-09-11','14:40:00',1.57),('8348','2013-09-11','14:45:00',3.09),('8348','2013-09-11','14:50:00',3.61),('8348','2013-09-11','14:55:00',2.96),('8348','2013-09-11','15:00:00',2.23),('8348','2013-09-11','15:05:00',3.24),('8348','2013-09-11','15:10:00',2.15),('8348','2013-09-11','15:15:00',3.07),('8348','2013-09-11','15:20:00',2.8),('8348','2013-09-11','15:25:00',2.77),('8348','2013-09-11','15:30:00',3.19),('8348','2013-09-11','15:35:00',1.08),('8348','2013-09-11','15:40:00',1.92),('8348','2013-09-11','15:45:00',2.38),('8348','2013-09-11','15:50:00',3),('8348','2013-09-11','15:55:00',2.06),('8348','2013-09-11','16:00:00',2.24),('8348','2013-09-11','16:05:00',2.82),('8348','2013-09-11','16:10:00',2.54),('8348','2013-09-11','16:15:00',2.61),('8348','2013-09-11','16:20:00',2.54),('8348','2013-09-11','16:25:00',2.39),('8348','2013-09-11','16:30:00',1.18),('8348','2013-09-11','16:35:00',1.63),('8348','2013-09-11','16:40:00',1.26),('8348','2013-09-11','16:45:00',2.34),('8348','2013-09-11','16:50:00',2.08),('8348','2013-09-11','16:55:00',1.94),('8348','2013-09-11','17:00:00',1.94),('8348','2013-09-11','17:05:00',1.87),('8348','2013-09-11','17:10:00',1.81),('8348','2013-09-11','17:15:00',1.72),('8348','2013-09-11','17:20:00',1.65),('8348','2013-09-11','17:25:00',1.57),('8348','2013-09-11','17:30:00',1.49),('8348','2013-09-11','17:35:00',1.41),('8348','2013-09-11','17:40:00',1.36),('8348','2013-09-11','17:45:00',1.2),('8348','2013-09-11','18:00:00',1.07),('8348','2013-09-10','08:55:00',1.05),('8348','2013-09-10','09:00:00',1.21),('8348','2013-09-10','09:05:00',1.2),('8348','2013-09-10','09:10:00',1.65),('8348','2013-09-10','09:15:00',1.47),('8348','2013-09-10','09:20:00',1.27),('8348','2013-09-10','09:25:00',1.31),('8348','2013-09-10','09:30:00',2.01),('8348','2013-09-10','09:35:00',2.15),('8348','2013-09-10','09:40:00',1.35),('8348','2013-09-10','09:45:00',1.16),('8348','2013-09-10','09:50:00',1.07),('8348','2013-09-10','10:40:00',1.34),('8348','2013-09-10','10:45:00',1.83),('8348','2013-09-10','10:50:00',1.12),('8348','2013-09-10','10:55:00',1.16),('8348','2013-09-10','11:00:00',1.43),('8348','2013-09-10','11:05:00',1.27),('8348','2013-09-10','11:10:00',1.25),('8348','2013-09-10','11:15:00',1.07),('8348','2013-09-10','11:20:00',1.17),('8348','2013-09-10','11:25:00',1.32),('8348','2013-09-10','11:45:00',1.24),('8348','2013-09-10','11:50:00',1.19),('8348','2013-09-10','11:55:00',1.51),('8348','2013-09-10','12:00:00',1.31),('8348','2013-09-10','13:25:00',1.01),('8348','2013-09-10','13:40:00',1.6),('8348','2013-09-10','13:45:00',2.42),('8348','2013-09-10','13:50:00',1.63),('8348','2013-09-10','13:55:00',1.4),('8348','2013-09-10','14:00:00',1.03),('8348','2013-09-10','14:05:00',1.19),('8348','2013-09-10','14:10:00',1.21),('8348','2013-09-10','14:15:00',1.46),('8348','2013-09-10','14:20:00',1.45),('8348','2013-09-10','14:25:00',1.97),('8348','2013-09-10','14:30:00',1.73),('8348','2013-09-10','14:35:00',1.29),('8348','2013-09-10','14:40:00',1.56),('8348','2013-09-10','14:45:00',1.65),('8348','2013-09-10','14:50:00',1.95),('8348','2013-09-10','14:55:00',1.75),('8348','2013-09-10','15:00:00',2.2),('8348','2013-09-10','15:05:00',2.01),('8348','2013-09-10','15:10:00',1.55),('8348','2013-09-10','15:15:00',1.41),('8348','2013-09-10','15:20:00',1.83),('8348','2013-09-10','15:25:00',1.61),('8348','2013-09-10','15:30:00',1.88),('8348','2013-09-10','15:35:00',1.67),('8348','2013-09-10','15:40:00',1.08),('8348','2013-09-10','16:10:00',1.2),('8348','2013-09-10','16:15:00',1.33),('8348','2013-09-09','08:55:00',1.01),('8348','2013-09-09','09:00:00',1.06),('8348','2013-09-09','10:00:00',1.17),('8348','2013-09-09','10:05:00',1.5),('8348','2013-09-09','10:10:00',1.53),('8348','2013-09-09','10:15:00',1.39),('8348','2013-09-09','10:20:00',1.34),('8348','2013-09-09','10:25:00',1.22),('8348','2013-09-09','10:30:00',1.3),('8348','2013-09-09','10:35:00',1.3),('8348','2013-09-09','10:40:00',1.48),('8348','2013-09-09','10:45:00',1.68),('8348','2013-09-09','10:50:00',2.15),('8348','2013-09-09','10:55:00',2.08),('8348','2013-09-09','11:00:00',2.29),('8348','2013-09-09','11:05:00',1.74),('8348','2013-09-09','11:10:00',1.64),('8348','2013-09-09','11:15:00',1.86),('8348','2013-09-09','11:20:00',2.08),('8348','2013-09-09','11:25:00',2.17),('8348','2013-09-09','11:30:00',1.77),('8348','2013-09-09','11:35:00',1.8),('8348','2013-09-09','11:40:00',2.68),('8348','2013-09-09','11:45:00',2.46),('8348','2013-09-09','11:50:00',2.57),('8348','2013-09-09','11:55:00',2.63),('8348','2013-09-09','12:00:00',2.42),('8348','2013-09-09','12:05:00',2.68),('8348','2013-09-09','12:10:00',2.46),('8348','2013-09-09','12:15:00',2.14),('8348','2013-09-09','12:20:00',1.34),('8348','2013-09-09','12:25:00',1.02),('8348','2013-09-09','12:40:00',1.22),('8348','2013-09-09','12:45:00',1.34),('8348','2013-09-09','12:50:00',1.08),('8348','2013-09-09','12:55:00',1.25),('8348','2013-09-09','13:00:00',1.3),('8348','2013-09-09','13:05:00',2.13),('8348','2013-09-09','13:10:00',1.64),('8348','2013-09-09','13:15:00',2.63),('8348','2013-09-09','13:20:00',2.66),('8348','2013-09-09','13:25:00',2.44),('8348','2013-09-09','13:30:00',3.01),('8348','2013-09-09','13:35:00',3.35),('8348','2013-09-09','13:40:00',2.71),('8348','2013-09-09','13:45:00',3.31),('8348','2013-09-09','13:50:00',3.08),('8348','2013-09-09','13:55:00',3.3),('8348','2013-09-09','14:00:00',3.17),('8348','2013-09-09','14:05:00',3.06),('8348','2013-09-09','14:10:00',3.38),('8348','2013-09-09','14:15:00',2.39),('8348','2013-09-09','14:20:00',1.8),('8348','2013-09-09','14:25:00',1.49),('8348','2013-09-09','14:30:00',1.54),('8348','2013-09-09','14:35:00',3.42),('8348','2013-09-09','14:40:00',3.31),('8348','2013-09-09','14:45:00',2.29),('8348','2013-09-09','14:50:00',3),('8348','2013-09-09','14:55:00',2.57),('8348','2013-09-09','15:00:00',2.35),('8348','2013-09-09','15:05:00',2.25),('8348','2013-09-09','15:10:00',2.21),('8348','2013-09-09','15:15:00',1.16),('8348','2013-09-09','15:20:00',1.89),('8348','2013-09-09','15:25:00',1.1),('8348','2013-09-09','15:30:00',2.73),('8348','2013-09-09','15:35:00',1.97),('8348','2013-09-09','15:40:00',2.51),('8348','2013-09-09','15:45:00',1.11),('8348','2013-09-09','15:50:00',1.19),('8348','2013-09-09','15:55:00',1.23),('8348','2013-09-09','16:00:00',1.44),('8348','2013-09-09','16:05:00',1.25),('8348','2013-09-09','16:10:00',1.52),('8348','2013-09-09','16:15:00',2.06),('8348','2013-09-09','16:20:00',1.52),('8348','2013-09-09','16:25:00',1.02),('8348','2013-09-09','16:30:00',1.01),('8348','2013-09-09','16:35:00',1.12),('8348','2013-09-09','16:40:00',1.3),('8348','2013-09-09','16:45:00',1.62),('8348','2014-04-12','07:10:00',1.12),('8348','2014-04-12','07:15:00',1.15),('8348','2014-04-12','07:20:00',1.1),('8348','2014-04-12','07:25:00',1.26),('8348','2014-04-12','07:50:00',1.07),('8348','2014-04-12','07:55:00',1.07),('8348','2014-04-12','08:00:00',1.06),('8348','2014-04-12','08:05:00',1.28),('8348','2014-04-12','08:10:00',1.85),('8348','2014-04-12','08:15:00',2.51),('8348','2014-04-12','08:20:00',3.43),('8348','2014-04-12','08:25:00',4.13),('8348','2014-04-12','08:30:00',3.07),('8348','2014-04-12','08:35:00',2.88),('8348','2014-04-12','08:40:00',2.44),('8348','2014-04-12','08:45:00',2.42),('8348','2014-04-12','08:50:00',2.57),('8348','2014-04-12','08:55:00',2.63),('8348','2014-04-12','09:00:00',2.69),('8348','2014-04-12','09:05:00',2.61),('8348','2014-04-12','09:10:00',2.79),('8348','2014-04-12','09:15:00',3.01),('8348','2014-04-12','09:20:00',3.31),('8348','2014-04-12','09:25:00',3.45),('8348','2014-04-12','09:30:00',3.51),('8348','2014-04-12','09:35:00',3.99),('8348','2014-04-12','09:40:00',3.91),('8348','2014-04-12','09:45:00',4.56),('8348','2014-04-12','09:50:00',4.87),('8348','2014-04-12','09:55:00',4.92),('8348','2014-04-12','10:00:00',3.25),('8348','2014-04-12','10:05:00',4.74),('8348','2014-04-12','10:10:00',4.29),('8348','2014-04-12','10:15:00',6.82),('8348','2014-04-12','10:20:00',6.89),('8348','2014-04-12','10:25:00',6.01),('8348','2014-04-12','10:30:00',5.58),('8348','2014-04-12','10:35:00',6.36),('8348','2014-04-12','10:40:00',6.29),('8348','2014-04-12','10:45:00',6.43),('8348','2014-04-12','10:50:00',5.27),('8348','2014-04-12','10:55:00',6.53),('8348','2014-04-12','11:00:00',3.94),('8348','2014-04-12','11:05:00',2.92),('8348','2014-04-12','11:10:00',4.73),('8348','2014-04-12','11:15:00',3.74),('8348','2014-04-12','11:20:00',4.05),('8348','2014-04-12','11:25:00',5.56),('8348','2014-04-12','11:30:00',4.7),('8348','2014-04-12','11:35:00',4.7),('8348','2014-04-12','11:40:00',5.21),('8348','2014-04-12','11:45:00',5.11),('8348','2014-04-12','11:50:00',3.32),('8348','2014-04-12','11:55:00',4.51),('8348','2014-04-12','12:00:00',4.15),('8348','2014-04-12','12:05:00',6.01),('8348','2014-04-12','12:10:00',5.12),('8348','2014-04-12','12:15:00',6.89),('8348','2014-04-12','12:20:00',7.51),('8348','2014-04-12','12:25:00',7.62),('8348','2014-04-12','12:30:00',7.4),('8348','2014-04-12','12:35:00',2.8),('8348','2014-04-12','12:40:00',2.67),('8348','2014-04-12','12:45:00',7.57),('8348','2014-04-12','12:50:00',6.88),('8348','2014-04-12','12:55:00',2.91),('8348','2014-04-12','13:00:00',5.46),('8348','2014-04-12','13:05:00',7.52),('8348','2014-04-12','13:10:00',7.36),('8348','2014-04-12','13:15:00',6.6),('8348','2014-04-12','13:20:00',6.45),('8348','2014-04-12','13:25:00',4.65),('8348','2014-04-12','13:30:00',4.53),('8348','2014-04-12','13:35:00',2.42),('8348','2014-04-12','13:40:00',2.46),('8348','2014-04-12','13:45:00',4.16),('8348','2014-04-12','13:50:00',6.36),('8348','2014-04-12','13:55:00',4.51),('8348','2014-04-12','14:00:00',5.77),('8348','2014-04-12','14:05:00',6.22),('8348','2014-04-12','14:10:00',6.53),('8348','2014-04-12','14:15:00',6.48),('8348','2014-04-12','14:20:00',4.89),('8348','2014-04-12','14:25:00',4.84),('8348','2014-04-12','14:30:00',3.88),('8348','2014-04-12','14:35:00',4.62),('8348','2014-04-12','14:40:00',5.4),('8348','2014-04-12','14:45:00',5.74),('8348','2014-04-12','14:50:00',6.35),('8348','2014-04-12','14:55:00',6.18),('8348','2014-04-12','15:00:00',6.21),('8348','2014-04-12','15:05:00',6.11),('8348','2014-04-12','15:10:00',5.87),('8348','2014-04-12','15:15:00',5.9),('8348','2014-04-12','15:20:00',6.02),('8348','2014-04-12','15:25:00',5.45),('8348','2014-04-12','15:30:00',5.28),('8348','2014-04-12','15:35:00',4.85),('8348','2014-04-12','15:40:00',4.43),('8348','2014-04-12','15:45:00',4.73),('8348','2014-04-12','15:50:00',2.9),('8348','2014-04-12','15:55:00',4.42),('8348','2014-04-12','16:00:00',4.43),('8348','2014-04-12','16:05:00',4.23),('8348','2014-04-12','16:10:00',4.21),('8348','2014-04-12','16:15:00',3.94),('8348','2014-04-12','16:20:00',3.21),('8348','2014-04-12','16:25:00',3.6),('8348','2014-04-12','16:30:00',3.67),('8348','2014-04-12','16:35:00',2.94),('8348','2014-04-12','16:40:00',3.37),('8348','2014-04-12','16:45:00',3.66),('8348','2014-04-12','16:50:00',3.22),('8348','2014-04-12','16:55:00',3.01),('8348','2014-04-12','17:00:00',2.45),('8348','2014-04-12','17:05:00',1.52),('8348','2014-04-12','17:50:00',1.01),('8348','2013-09-08','09:15:00',1.28),('8348','2013-09-08','09:20:00',1.31),('8348','2013-09-08','09:25:00',1.43),('8348','2013-09-08','09:30:00',1.34),('8348','2013-09-08','09:35:00',1.25),('8348','2013-09-08','09:40:00',1.59),('8348','2013-09-08','09:45:00',1.72),('8348','2013-09-08','09:50:00',1.81),('8348','2013-09-08','09:55:00',1.8),('8348','2013-09-08','10:00:00',1.86),('8348','2013-09-08','10:05:00',1.9),('8348','2013-09-08','10:10:00',2.02),('8348','2013-09-08','10:15:00',2.09),('8348','2013-09-08','10:20:00',2.13),('8348','2013-09-08','10:25:00',2.16),('8348','2013-09-08','10:30:00',2.18),('8348','2013-09-08','10:35:00',2.21),('8348','2013-09-08','10:40:00',2.33),('8348','2013-09-08','10:45:00',2.39),('8348','2013-09-08','10:50:00',2.43),('8348','2013-09-08','10:55:00',2.44),('8348','2013-09-08','11:00:00',2.46),('8348','2013-09-08','11:05:00',2.4),('8348','2013-09-08','11:10:00',2.45),('8348','2013-09-08','11:15:00',2.52),('8348','2013-09-08','11:20:00',2.59),('8348','2013-09-08','11:25:00',2.6),('8348','2013-09-08','11:30:00',2.61),('8348','2013-09-08','11:35:00',2.6),('8348','2013-09-08','11:40:00',2.63),('8348','2013-09-08','11:45:00',2.67),('8348','2013-09-08','11:50:00',2.74),('8348','2013-09-08','11:55:00',2.74),('8348','2013-09-08','12:00:00',2.71),('8348','2013-09-08','12:05:00',2.72),('8348','2013-09-08','12:10:00',2.7),('8348','2013-09-08','12:15:00',2.88),('8348','2013-09-08','12:20:00',2.85),('8348','2013-09-08','12:25:00',2.87),('8348','2013-09-08','12:30:00',2.92),('8348','2013-09-08','12:35:00',2.86),('8348','2013-09-08','12:40:00',2.82),('8348','2013-09-08','12:45:00',2.94),('8348','2013-09-08','12:50:00',2.92),('8348','2013-09-08','12:55:00',2.96),('8348','2013-09-08','13:00:00',2.94),('8348','2013-09-08','13:05:00',3),('8348','2013-09-08','13:10:00',3),('8348','2013-09-08','13:15:00',2.95),('8348','2013-09-08','13:20:00',2.98),('8348','2013-09-08','13:25:00',2.75),('8348','2013-09-08','13:30:00',2.72),('8348','2013-09-08','13:35:00',2.7),('8348','2013-09-08','13:40:00',2.02),('8348','2013-09-08','13:45:00',1.84),('8348','2013-09-08','13:50:00',2.26),('8348','2013-09-08','13:55:00',2.34),('8348','2013-09-08','14:00:00',2.82),('8348','2013-09-08','14:05:00',2.89),('8348','2013-09-08','14:10:00',3.16),('8348','2013-09-08','14:15:00',2.81),('8348','2013-09-08','14:20:00',2.97),('8348','2013-09-08','14:25:00',3.36),('8348','2013-09-08','14:30:00',2.97),('8348','2013-09-08','14:35:00',3.17),('8348','2013-09-08','14:40:00',3.09),('8348','2013-09-08','14:45:00',3.08),('8348','2013-09-08','14:50:00',3.04),('8348','2013-09-08','14:55:00',2.99),('8348','2013-09-08','15:00:00',2.99),('8348','2013-09-08','15:05:00',2.45),('8348','2013-09-08','15:10:00',1.68),('8348','2013-09-08','15:15:00',2.29),('8348','2013-09-08','15:20:00',2.86),('8348','2013-09-08','15:25:00',2.9),('8348','2013-09-08','15:30:00',2.91),('8348','2013-09-08','15:35:00',2.8),('8348','2013-09-08','15:40:00',2.6),('8348','2013-09-08','15:45:00',2.67),('8348','2013-09-08','15:50:00',2.63),('8348','2013-09-08','15:55:00',2.13),('8348','2013-09-08','16:00:00',2.27),('8348','2013-09-08','16:05:00',2.24),('8348','2013-09-08','16:10:00',2.01),('8348','2013-09-08','16:15:00',2.35),('8348','2013-09-08','16:20:00',2.13),('8348','2013-09-08','16:25:00',2.05),('8348','2013-09-08','16:30:00',2.17),('8348','2013-09-08','16:35:00',2),('8348','2013-09-08','16:40:00',1.67),('8348','2013-09-08','16:45:00',1.17),('8348','2013-09-08','16:50:00',1.2),('8348','2013-09-08','16:55:00',1.08),('8348','2013-09-08','17:00:00',1.24),('8348','2013-09-08','17:05:00',1.91),('8348','2013-09-08','17:10:00',1.81),('8348','2013-09-08','17:15:00',1.66),('8348','2013-09-08','17:20:00',1.45),('8348','2013-09-08','17:25:00',1.44),('8348','2013-09-08','17:30:00',1.32),('8348','2013-09-08','17:45:00',1.07),('8348','2013-09-08','17:50:00',1.07),('8348','2013-09-07','08:50:00',1.01),('8348','2013-09-07','08:55:00',1.06),('8348','2013-09-07','09:00:00',1.16),('8348','2013-09-07','09:05:00',1.24),('8348','2013-09-07','09:10:00',1.31),('8348','2013-09-07','09:15:00',1.4),('8348','2013-09-07','09:20:00',1.47),('8348','2013-09-07','09:25:00',1.55),('8348','2013-09-07','09:30:00',1.61),('8348','2013-09-07','09:35:00',1.68),('8348','2013-09-07','09:40:00',1.73),('8348','2013-09-07','09:45:00',1.78),('8348','2013-09-07','09:50:00',1.84),('8348','2013-09-07','09:55:00',1.9),('8348','2013-09-07','10:00:00',1.95),('8348','2013-09-07','10:05:00',2.01),('8348','2013-09-07','10:10:00',2.06),('8348','2013-09-07','10:15:00',2.13),('8348','2013-09-07','10:20:00',2.17),('8348','2013-09-07','10:25:00',2.22),('8348','2013-09-07','10:30:00',2.25),('8348','2013-09-07','10:35:00',2.31),('8348','2013-09-07','10:40:00',2.35),('8348','2013-09-07','10:45:00',2.39),('8348','2013-09-07','10:50:00',2.43),('8348','2013-09-07','10:55:00',2.48),('8348','2013-09-07','11:00:00',2.52),('8348','2013-09-07','11:05:00',2.57),('8348','2013-09-07','11:10:00',2.61),('8348','2013-09-07','11:15:00',2.64),('8348','2013-09-07','11:20:00',2.67),('8348','2013-09-07','11:25:00',2.7),('8348','2013-09-07','11:30:00',2.74),('8348','2013-09-07','11:35:00',2.76),('8348','2013-09-07','11:40:00',2.81),('8348','2013-09-07','11:45:00',2.85),('8348','2013-09-07','11:50:00',2.87),('8348','2013-09-07','11:55:00',2.86),('8348','2013-09-07','12:00:00',2.87),('8348','2013-09-07','12:05:00',2.91),('8348','2013-09-07','12:10:00',2.91),('8348','2013-09-07','12:15:00',2.93),('8348','2013-09-07','12:20:00',2.96),('8348','2013-09-07','12:25:00',2.98),('8348','2013-09-07','12:30:00',3),('8348','2013-09-07','12:35:00',3.03),('8348','2013-09-07','12:40:00',3.03),('8348','2013-09-07','12:45:00',3.06),('8348','2013-09-07','12:50:00',3.07),('8348','2013-09-07','12:55:00',3.1),('8348','2013-09-07','13:00:00',3.1),('8348','2013-09-07','13:05:00',3.08),('8348','2013-09-07','13:10:00',3.1),('8348','2013-09-07','13:15:00',3.12),('8348','2013-09-07','13:20:00',3.1),('8348','2013-09-07','13:25:00',3),('8348','2013-09-07','13:30:00',3.13),('8348','2013-09-07','13:35:00',3.14),('8348','2013-09-07','13:40:00',3.08),('8348','2013-09-07','13:45:00',3.11),('8348','2013-09-07','13:50:00',3.13),('8348','2013-09-07','13:55:00',2.96),('8348','2013-09-07','14:00:00',3.16),('8348','2013-09-07','14:05:00',3.18),('8348','2013-09-07','14:10:00',3.21),('8348','2013-09-07','14:15:00',3.17),('8348','2013-09-07','14:20:00',3.1),('8348','2013-09-07','14:25:00',3.06),('8348','2013-09-07','14:30:00',3.09),('8348','2013-09-07','14:35:00',3.12),('8348','2013-09-07','14:40:00',3.1),('8348','2013-09-07','14:45:00',3.05),('8348','2013-09-07','14:50:00',3.03),('8348','2013-09-07','14:55:00',3.01),('8348','2013-09-07','15:00:00',3),('8348','2013-09-07','15:05:00',2.95),('8348','2013-09-07','15:10:00',2.91),('8348','2013-09-07','15:15:00',2.94),('8348','2013-09-07','15:20:00',2.89),('8348','2013-09-07','15:25:00',2.85),('8348','2013-09-07','15:30:00',2.82),('8348','2013-09-07','15:35:00',2.77),('8348','2013-09-07','15:40:00',2.7),('8348','2013-09-07','15:45:00',2.67),('8348','2013-09-07','15:50:00',2.62),('8348','2013-09-07','15:55:00',2.58),('8348','2013-09-07','16:00:00',2.54),('8348','2013-09-07','16:05:00',2.49),('8348','2013-09-07','16:10:00',2.44),('8348','2013-09-07','16:15:00',2.38),('8348','2013-09-07','16:20:00',2.32),('8348','2013-09-07','16:25:00',2.25),('8348','2013-09-07','16:30:00',2.2),('8348','2013-09-07','16:35:00',2.15),('8348','2013-09-07','16:40:00',2.08),('8348','2013-09-07','16:45:00',2.02),('8348','2013-09-07','16:50:00',1.95),('8348','2013-09-07','16:55:00',1.89),('8348','2013-09-07','17:00:00',1.83),('8348','2013-09-07','17:05:00',1.77),('8348','2013-09-07','17:10:00',1.7),('8348','2013-09-07','17:15:00',1.62),('8348','2013-09-07','17:20:00',1.55),('8348','2013-09-07','17:25:00',1.47),('8348','2013-09-07','17:30:00',1.38),('8348','2013-09-07','17:35:00',1.34),('8348','2013-09-07','17:40:00',1.26),('8348','2013-09-07','17:45:00',1.2),('8348','2013-09-07','17:50:00',1.13),('8348','2013-09-07','17:55:00',1.04),('8348','2013-09-06','08:45:00',1),('8348','2013-09-06','08:50:00',1.06),('8348','2013-09-06','08:55:00',1.13),('8348','2013-09-06','09:00:00',1.21),('8348','2013-09-06','09:05:00',1.3),('8348','2013-09-06','09:10:00',1.36),('8348','2013-09-06','09:15:00',1.45),('8348','2013-09-06','09:20:00',1.51),('8348','2013-09-06','09:25:00',1.57),('8348','2013-09-06','09:30:00',1.63),('8348','2013-09-06','09:35:00',1.7),('8348','2013-09-06','09:40:00',1.77),('8348','2013-09-06','09:45:00',1.83),('8348','2013-09-06','09:50:00',1.87),('8348','2013-09-06','09:55:00',1.93),('8348','2013-09-06','10:00:00',2),('8348','2013-09-06','10:05:00',2.07),('8348','2013-09-06','10:10:00',2.12),('8348','2013-09-06','10:15:00',2.16),('8348','2013-09-06','10:20:00',2.21),('8348','2013-09-06','10:25:00',2.27),('8348','2013-09-06','10:30:00',2.31),('8348','2013-09-06','10:35:00',2.38),('8348','2013-09-06','10:40:00',2.42),('8348','2013-09-06','10:45:00',2.44),('8348','2013-09-06','10:50:00',2.48),('8348','2013-09-06','10:55:00',2.52),('8348','2013-09-06','11:00:00',2.57),('8348','2013-09-06','11:05:00',2.63),('8348','2013-09-06','11:10:00',2.64),('8348','2013-09-06','11:15:00',2.68),('8348','2013-09-06','11:20:00',2.71),('8348','2013-09-06','11:25:00',2.74),('8348','2013-09-06','11:30:00',2.79),('8348','2013-09-06','11:35:00',2.81),('8348','2013-09-06','11:40:00',2.85),('8348','2013-09-06','11:45:00',2.88),('8348','2013-09-06','11:50:00',2.92),('8348','2013-09-06','11:55:00',2.92),('8348','2013-09-06','12:00:00',2.93),('8348','2013-09-06','12:05:00',2.95),('8348','2013-09-06','12:10:00',2.97),('8348','2013-09-06','12:15:00',3),('8348','2013-09-06','12:20:00',3.01),('8348','2013-09-06','12:25:00',3.01),('8348','2013-09-06','12:30:00',3.04),('8348','2013-09-06','12:35:00',3.07),('8348','2013-09-06','12:40:00',3.1),('8348','2013-09-06','12:45:00',3.09),('8348','2013-09-06','12:50:00',3.06),('8348','2013-09-06','12:55:00',3.08),('8348','2013-09-06','13:00:00',3.09),('8348','2013-09-06','13:05:00',3.1),('8348','2013-09-06','13:10:00',3.11),('8348','2013-09-06','13:15:00',3.11),('8348','2013-09-06','13:20:00',3.1),('8348','2013-09-06','13:25:00',3.1),('8348','2013-09-06','13:30:00',3.09),('8348','2013-09-06','13:35:00',3.08),('8348','2013-09-06','13:40:00',3.04),('8348','2013-09-06','13:45:00',3.05),('8348','2013-09-06','13:50:00',3.07),('8348','2013-09-06','13:55:00',3.07),('8348','2013-09-06','14:00:00',3.06),('8348','2013-09-06','14:05:00',3.02),('8348','2013-09-06','14:10:00',3.02),('8348','2013-09-06','14:15:00',3.01),('8348','2013-09-06','14:20:00',3),('8348','2013-09-06','14:25:00',2.97),('8348','2013-09-06','14:30:00',2.96),('8348','2013-09-06','14:35:00',2.86),('8348','2013-09-06','14:40:00',2.89),('8348','2013-09-06','14:45:00',2.93),('8348','2013-09-06','14:50:00',2.96),('8348','2013-09-06','14:55:00',2.97),('8348','2013-09-06','15:00:00',2.97),('8348','2013-09-06','15:05:00',2.91),('8348','2013-09-06','15:10:00',2.86),('8348','2013-09-06','15:15:00',2.88),('8348','2013-09-06','15:20:00',2.84),('8348','2013-09-06','15:25:00',2.81),('8348','2013-09-06','15:30:00',2.75),('8348','2013-09-06','15:35:00',2.72),('8348','2013-09-06','15:40:00',2.68),('8348','2013-09-06','15:45:00',2.67),('8348','2013-09-06','15:50:00',2.62),('8348','2013-09-06','15:55:00',2.59),('8348','2013-09-06','16:00:00',2.54),('8348','2013-09-06','16:05:00',2.47),('8348','2013-09-06','16:10:00',2.42),('8348','2013-09-06','16:15:00',2.37),('8348','2013-09-06','16:20:00',2.33),('8348','2013-09-06','16:25:00',2.29),('8348','2013-09-06','16:30:00',2.25),('8348','2013-09-06','16:35:00',2.18),('8348','2013-09-06','16:40:00',2.12),('8348','2013-09-06','16:45:00',2.06),('8348','2013-09-06','16:50:00',1.97),('8348','2013-09-06','16:55:00',1.9),('8348','2013-09-06','17:00:00',1.86),('8348','2013-09-06','17:05:00',1.77),('8348','2013-09-06','17:10:00',1.71),('8348','2013-09-06','17:15:00',1.67),('8348','2013-09-06','17:20:00',1.57),('8348','2013-09-06','17:25:00',1.48),('8348','2013-09-06','17:30:00',1.38),('8348','2013-09-06','17:35:00',1.32),('8348','2013-09-06','17:40:00',1.27),('8348','2013-09-06','17:45:00',1.18),('8348','2013-09-06','17:50:00',1.07),('8348','2013-09-06','17:55:00',1),('8348','2013-09-05','08:45:00',1.06),('8348','2013-09-05','08:50:00',1.13),('8348','2013-09-05','08:55:00',1.18),('8348','2013-09-05','09:00:00',1.29),('8348','2013-09-05','09:05:00',1.38),('8348','2013-09-05','09:10:00',1.45),('8348','2013-09-05','09:15:00',1.54),('8348','2013-09-05','09:20:00',1.62),('8348','2013-09-05','09:25:00',1.68),('8348','2013-09-05','09:30:00',1.75),('8348','2013-09-05','09:35:00',1.8),('8348','2013-09-05','09:40:00',1.86),('8348','2013-09-05','09:45:00',1.93),('8348','2013-09-05','09:50:00',2),('8348','2013-09-05','09:55:00',2.06),('8348','2013-09-05','10:00:00',2.11),('8348','2013-09-05','10:05:00',2.17),('8348','2013-09-05','10:10:00',2.22),('8348','2013-09-05','10:15:00',2.27),('8348','2013-09-05','10:20:00',2.32),('8348','2013-09-05','10:25:00',2.37),('8348','2013-09-05','10:30:00',2.41),('8348','2013-09-05','10:35:00',2.45),('8348','2013-09-05','10:40:00',2.51),('8348','2013-09-05','10:45:00',2.54),('8348','2013-09-05','10:50:00',2.59),('8348','2013-09-05','10:55:00',2.64),('8348','2013-09-05','11:00:00',2.69),('8348','2013-09-05','11:05:00',2.74),('8348','2013-09-05','11:10:00',2.76),('8348','2013-09-05','11:15:00',2.78),('8348','2013-09-05','11:20:00',2.82),('8348','2013-09-05','11:25:00',2.81),('8348','2013-09-05','11:30:00',2.86),('8348','2013-09-05','11:35:00',2.91),('8348','2013-09-05','11:40:00',2.88),('8348','2013-09-05','11:45:00',2.89),('8348','2013-09-05','11:50:00',2.96),('8348','2013-09-05','11:55:00',3.01),('8348','2013-09-05','12:00:00',3.03),('8348','2013-09-05','12:05:00',3.04),('8348','2013-09-05','12:10:00',3.05),('8348','2013-09-05','12:15:00',3.08),('8348','2013-09-05','12:20:00',3.09),('8348','2013-09-05','12:25:00',3.11),('8348','2013-09-05','12:30:00',3.15),('8348','2013-09-05','12:35:00',3.15),('8348','2013-09-05','12:40:00',3.14),('8348','2013-09-05','12:45:00',3.16),('8348','2013-09-05','12:50:00',3.2),('8348','2013-09-05','12:55:00',3.21),('8348','2013-09-05','13:00:00',3.19),('8348','2013-09-05','13:05:00',3.18),('8348','2013-09-05','13:10:00',3.2),('8348','2013-09-05','13:15:00',3.2),('8348','2013-09-05','13:20:00',3.2),('8348','2013-09-05','13:25:00',3.22),('8348','2013-09-05','13:30:00',3.27),('8348','2013-09-05','13:35:00',3.25),('8348','2013-09-05','13:40:00',3.2),('8348','2013-09-05','13:45:00',3.19),('8348','2013-09-05','13:50:00',3.16),('8348','2013-09-05','13:55:00',3.14),('8348','2013-09-05','14:00:00',3.17),('8348','2013-09-05','14:05:00',3.17),('8348','2013-09-05','14:10:00',3.18),('8348','2013-09-05','14:15:00',3.2),('8348','2013-09-05','14:20:00',3.16),('8348','2013-09-05','14:25:00',3.1),('8348','2013-09-05','14:30:00',3.1),('8348','2013-09-05','14:35:00',3.06),('8348','2013-09-05','14:40:00',3.03),('8348','2013-09-05','14:45:00',3.04),('8348','2013-09-05','14:50:00',3.03),('8348','2013-09-05','14:55:00',3.05),('8348','2013-09-05','15:00:00',3.06),('8348','2013-09-05','15:05:00',3.05),('8348','2013-09-05','15:10:00',3.01),('8348','2013-09-05','15:15:00',2.98),('8348','2013-09-05','15:20:00',2.96),('8348','2013-09-05','15:25:00',2.92),('8348','2013-09-05','15:30:00',2.87),('8348','2013-09-05','15:35:00',2.84),('8348','2013-09-05','15:40:00',2.79),('8348','2013-09-05','15:45:00',2.73),('8348','2013-09-05','15:50:00',2.69),('8348','2013-09-05','15:55:00',2.69),('8348','2013-09-05','16:00:00',2.65),('8348','2013-09-05','16:05:00',2.61),('8348','2013-09-05','16:10:00',2.57),('8348','2013-09-05','16:15:00',2.52),('8348','2013-09-05','16:20:00',2.46),('8348','2013-09-05','16:25:00',2.41),('8348','2013-09-05','16:30:00',2.37),('8348','2013-09-05','16:35:00',2.35),('8348','2013-09-05','16:40:00',2.31),('8348','2013-09-05','16:45:00',2.28),('8348','2013-09-05','16:50:00',1.99),('8348','2013-09-05','16:55:00',1.61),('8348','2013-09-05','17:00:00',1.24),('8348','2013-09-05','17:05:00',1.33),('8348','2013-09-05','17:10:00',1.38),('8348','2013-09-05','17:15:00',1.19),('8348','2013-09-05','17:20:00',1.35),('8348','2013-09-05','17:25:00',1.37),('8348','2013-09-05','17:30:00',1.33),('8348','2013-09-05','17:35:00',1.4),('8348','2013-09-05','17:40:00',1.54),('8348','2013-09-05','17:45:00',1.41),('8348','2013-09-05','17:50:00',1.28),('8348','2013-09-05','17:55:00',1.08),('8348','2013-09-04','08:45:00',1.06),('8348','2013-09-04','08:50:00',1.11),('8348','2013-09-04','08:55:00',1.2),('8348','2013-09-04','09:00:00',1.3),('8348','2013-09-04','09:05:00',1.38),('8348','2013-09-04','09:10:00',1.46),('8348','2013-09-04','09:15:00',1.57),('8348','2013-09-04','09:20:00',1.65),('8348','2013-09-04','09:25:00',1.73),('8348','2013-09-04','09:30:00',1.8),('8348','2013-09-04','09:35:00',1.87),('8348','2013-09-04','09:40:00',1.94),('8348','2013-09-04','09:45:00',2),('8348','2013-09-04','09:50:00',2.07),('8348','2013-09-04','09:55:00',2.13),('8348','2013-09-04','10:00:00',2.19),('8348','2013-09-04','10:05:00',2.25),('8348','2013-09-04','10:10:00',2.31),('8348','2013-09-04','10:15:00',2.36),('8348','2013-09-04','10:20:00',2.39),('8348','2013-09-04','10:25:00',2.44),('8348','2013-09-04','10:30:00',2.49),('8348','2013-09-04','10:35:00',2.55),('8348','2013-09-04','10:40:00',2.6),('8348','2013-09-04','10:45:00',2.65),('8348','2013-09-04','10:50:00',2.7),('8348','2013-09-04','10:55:00',2.75),('8348','2013-09-04','11:00:00',2.79),('8348','2013-09-04','11:05:00',2.84),('8348','2013-09-04','11:10:00',2.87),('8348','2013-09-04','11:15:00',2.9),('8348','2013-09-04','11:20:00',2.93),('8348','2013-09-04','11:25:00',2.96),('8348','2013-09-04','11:30:00',3),('8348','2013-09-04','11:35:00',3.03),('8348','2013-09-04','11:40:00',3.07),('8348','2013-09-04','11:45:00',3.09),('8348','2013-09-04','11:50:00',3.12),('8348','2013-09-04','11:55:00',3.16),('8348','2013-09-04','12:00:00',3.19),('8348','2013-09-04','12:05:00',3.2),('8348','2013-09-04','12:10:00',3.22),('8348','2013-09-04','12:15:00',3.22),('8348','2013-09-04','12:20:00',3.24),('8348','2013-09-04','12:25:00',3.28),('8348','2013-09-04','12:30:00',3.29),('8348','2013-09-04','12:35:00',3.32),('8348','2013-09-04','12:40:00',3.31),('8348','2013-09-04','12:45:00',3.32),('8348','2013-09-04','12:50:00',3.33),('8348','2013-09-04','12:55:00',3.33),('8348','2013-09-04','13:00:00',3.33),('8348','2013-09-04','13:05:00',3.33),('8348','2013-09-04','13:10:00',3.35),('8348','2013-09-04','13:15:00',3.35),('8348','2013-09-04','13:20:00',3.35),('8348','2013-09-04','13:25:00',3.36),('8348','2013-09-04','13:30:00',3.36),('8348','2013-09-04','13:35:00',3.37),('8348','2013-09-04','13:40:00',3.38),('8348','2013-09-04','13:45:00',3.35),('8348','2013-09-04','13:50:00',3.34),('8348','2013-09-04','13:55:00',3.33),('8348','2013-09-04','14:00:00',3.31),('8348','2013-09-04','14:05:00',3.32),('8348','2013-09-04','14:10:00',3.31),('8348','2013-09-04','14:15:00',3.3),('8348','2013-09-04','14:20:00',3.27),('8348','2013-09-04','14:25:00',3.27),('8348','2013-09-04','14:30:00',3.26),('8348','2013-09-04','14:35:00',3.23),('8348','2013-09-04','14:40:00',3.2),('8348','2013-09-04','14:45:00',3.18),('8348','2013-09-04','14:50:00',3.16),('8348','2013-09-04','14:55:00',3.13),('8348','2013-09-04','15:00:00',3.09),('8348','2013-09-04','15:05:00',3.06),('8348','2013-09-04','15:10:00',3.04),('8348','2013-09-04','15:15:00',3.02),('8348','2013-09-04','15:20:00',3),('8348','2013-09-04','15:25:00',2.95),('8348','2013-09-04','15:30:00',2.93),('8348','2013-09-04','15:35:00',2.89),('8348','2013-09-04','15:40:00',2.84),('8348','2013-09-04','15:45:00',2.79),('8348','2013-09-04','15:50:00',2.76),('8348','2013-09-04','15:55:00',2.7),('8348','2013-09-04','16:00:00',2.65),('8348','2013-09-04','16:05:00',2.6),('8348','2013-09-04','16:10:00',2.56),('8348','2013-09-04','16:15:00',2.51),('8348','2013-09-04','16:20:00',2.46),('8348','2013-09-04','16:25:00',2.39),('8348','2013-09-04','16:30:00',2.35),('8348','2013-09-04','16:35:00',2.31),('8348','2013-09-04','16:40:00',2.24),('8348','2013-09-04','16:45:00',2.18),('8348','2013-09-04','16:50:00',2.11),('8348','2013-09-04','16:55:00',2.06),('8348','2013-09-04','17:00:00',1.99),('8348','2013-09-04','17:05:00',1.92),('8348','2013-09-04','17:10:00',1.85),('8348','2013-09-04','17:15:00',1.79),('8348','2013-09-04','17:20:00',1.72),('8348','2013-09-04','17:25:00',1.65),('8348','2013-09-04','17:30:00',1.58),('8348','2013-09-04','17:35:00',1.5),('8348','2013-09-04','17:40:00',1.42),('8348','2013-09-04','17:45:00',1.34),('8348','2013-09-04','17:50:00',1.26),('8348','2013-09-04','17:55:00',1.18),('8348','2013-09-04','18:00:00',1.09),('8348','2013-09-04','18:05:00',1.01),('8348','2013-09-03','08:45:00',1),('8348','2013-09-03','08:50:00',1.07),('8348','2013-09-03','08:55:00',1.15),('8348','2013-09-03','09:00:00',1.23),('8348','2013-09-03','09:05:00',1.3),('8348','2013-09-03','09:10:00',1.37),('8348','2013-09-03','09:15:00',1.47),('8348','2013-09-03','09:20:00',1.55),('8348','2013-09-03','09:25:00',1.63),('8348','2013-09-03','09:30:00',1.7),('8348','2013-09-03','09:35:00',1.75),('8348','2013-09-03','09:40:00',1.82),('8348','2013-09-03','09:45:00',1.88),('8348','2013-09-03','09:50:00',1.94),('8348','2013-09-03','09:55:00',2),('8348','2013-09-03','10:00:00',2.05),('8348','2013-09-03','10:05:00',2.1),('8348','2013-09-03','10:10:00',2.16),('8348','2013-09-03','10:15:00',2.22),('8348','2013-09-03','10:20:00',2.29),('8348','2013-09-03','10:25:00',2.33),('8348','2013-09-03','10:30:00',2.39),('8348','2013-09-03','10:35:00',2.47),('8348','2013-09-03','10:40:00',2.55),('8348','2013-09-03','10:45:00',2.58),('8348','2013-09-03','10:50:00',2.61),('8348','2013-09-03','10:55:00',2.63),('8348','2013-09-03','11:00:00',2.65),('8348','2013-09-03','11:05:00',2.69),('8348','2013-09-03','11:10:00',2.74),('8348','2013-09-03','11:15:00',2.79),('8348','2013-09-03','11:20:00',2.82),('8348','2013-09-03','11:25:00',2.85),('8348','2013-09-03','11:30:00',2.88),('8348','2013-09-03','11:35:00',2.9),('8348','2013-09-03','11:40:00',2.92),('8348','2013-09-03','11:45:00',2.96),('8348','2013-09-03','11:50:00',2.99),('8348','2013-09-03','11:55:00',3.04),('8348','2013-09-03','12:00:00',3.06),('8348','2013-09-03','12:05:00',3.08),('8348','2013-09-03','12:10:00',3.11),('8348','2013-09-03','12:15:00',3.14),('8348','2013-09-03','12:20:00',3.17),('8348','2013-09-03','12:25:00',3.19),('8348','2013-09-03','12:30:00',3.21),('8348','2013-09-03','12:35:00',3.21),('8348','2013-09-03','12:40:00',3.24),('8348','2013-09-03','12:45:00',3.25),('8348','2013-09-03','12:50:00',3.25),('8348','2013-09-03','12:55:00',3.25),('8348','2013-09-03','13:00:00',3.26),('8348','2013-09-03','13:05:00',3.26),('8348','2013-09-03','13:10:00',3.28),('8348','2013-09-03','13:15:00',3.29),('8348','2013-09-03','13:20:00',3.26),('8348','2013-09-03','13:25:00',3.25),('8348','2013-09-03','13:30:00',3.26),('8348','2013-09-03','13:35:00',3.28),('8348','2013-09-03','13:40:00',3.25),('8348','2013-09-03','13:45:00',3.24),('8348','2013-09-03','13:50:00',3.26),('8348','2013-09-03','13:55:00',3.25),('8348','2013-09-03','14:00:00',3.18),('8348','2013-09-03','14:05:00',3.15),('8348','2013-09-03','14:10:00',3.17),('8348','2013-09-03','14:15:00',3.15),('8348','2013-09-03','14:20:00',3.14),('8348','2013-09-03','14:25:00',3.13),('8348','2013-09-03','14:30:00',3.14),('8348','2013-09-03','14:35:00',3.16),('8348','2013-09-03','14:40:00',3.13),('8348','2013-09-03','14:45:00',3.1),('8348','2013-09-03','14:50:00',3.12),('8348','2013-09-03','14:55:00',3.09),('8348','2013-09-03','15:00:00',3.04),('8348','2013-09-03','15:05:00',2.99),('8348','2013-09-03','15:10:00',2.96),('8348','2013-09-03','15:15:00',2.96),('8348','2013-09-03','15:20:00',2.93),('8348','2013-09-03','15:25:00',2.89),('8348','2013-09-03','15:30:00',2.85),('8348','2013-09-03','15:35:00',2.79),('8348','2013-09-03','15:40:00',2.73),('8348','2013-09-03','15:45:00',2.69),('8348','2013-09-03','15:50:00',2.69),('8348','2013-09-03','15:55:00',2.64),('8348','2013-09-03','16:00:00',2.62),('8348','2013-09-03','16:05:00',2.59),('8348','2013-09-03','16:10:00',2.53),('8348','2013-09-03','16:15:00',2.46),('8348','2013-09-03','16:20:00',2.41),('8348','2013-09-03','16:25:00',2.37),('8348','2013-09-03','16:30:00',2.32),('8348','2013-09-03','16:35:00',2.27),('8348','2013-09-03','16:40:00',2.21),('8348','2013-09-03','16:45:00',2.16),('8348','2013-09-03','16:50:00',2.1),('8348','2013-09-03','16:55:00',2.05),('8348','2013-09-03','17:00:00',1.98),('8348','2013-09-03','17:05:00',1.91),('8348','2013-09-03','17:10:00',1.85),('8348','2013-09-03','17:15:00',1.78),('8348','2013-09-03','17:20:00',1.73),('8348','2013-09-03','17:25:00',1.66),('8348','2013-09-03','17:30:00',1.6),('8348','2013-09-03','17:35:00',1.52),('8348','2013-09-03','17:40:00',1.44),('8348','2013-09-03','17:45:00',1.38),('8348','2013-09-03','17:50:00',1.3),('8348','2013-09-03','17:55:00',1.19),('8348','2013-09-03','18:00:00',1.02),('8348','2013-09-02','08:45:00',1.05),('8348','2013-09-02','08:50:00',1.12),('8348','2013-09-02','08:55:00',1.18),('8348','2013-09-02','09:00:00',1.28),('8348','2013-09-02','09:05:00',1.36),('8348','2013-09-02','09:10:00',1.43),('8348','2013-09-02','09:15:00',1.53),('8348','2013-09-02','09:20:00',1.6),('8348','2013-09-02','09:25:00',1.67),('8348','2013-09-02','09:30:00',1.74),('8348','2013-09-02','09:35:00',1.81),('8348','2013-09-02','09:40:00',1.87),('8348','2013-09-02','09:45:00',1.93),('8348','2013-09-02','09:50:00',1.99),('8348','2013-09-02','09:55:00',2.04),('8348','2013-09-02','10:00:00',2.09),('8348','2013-09-02','10:05:00',2.15),('8348','2013-09-02','10:10:00',2.22),('8348','2013-09-02','10:15:00',2.28),('8348','2013-09-02','10:20:00',2.33),('8348','2013-09-02','10:25:00',2.38),('8348','2013-09-02','10:30:00',2.43),('8348','2013-09-02','10:35:00',2.48),('8348','2013-09-02','10:40:00',2.53),('8348','2013-09-02','10:45:00',2.57),('8348','2013-09-02','10:50:00',2.6),('8348','2013-09-02','10:55:00',2.63),('8348','2013-09-02','11:00:00',2.68),('8348','2013-09-02','11:05:00',2.72),('8348','2013-09-02','11:10:00',2.75),('8348','2013-09-02','11:15:00',2.79),('8348','2013-09-02','11:20:00',2.83),('8348','2013-09-02','11:25:00',2.87),('8348','2013-09-02','11:30:00',2.88),('8348','2013-09-02','11:35:00',2.91),('8348','2013-09-02','11:40:00',2.93),('8348','2013-09-02','11:45:00',2.94),('8348','2013-09-02','11:50:00',2.97),('8348','2013-09-02','11:55:00',2.99),('8348','2013-09-02','12:00:00',3.02),('8348','2013-09-02','12:05:00',3.05),('8348','2013-09-02','12:10:00',3.09),('8348','2013-09-02','12:15:00',3.1),('8348','2013-09-02','12:20:00',3.12),('8348','2013-09-02','12:25:00',3.14),('8348','2013-09-02','12:30:00',3.11),('8348','2013-09-02','12:35:00',3.15),('8348','2013-09-02','12:40:00',3.14),('8348','2013-09-02','12:45:00',3.17),('8348','2013-09-02','12:50:00',3.19),('8348','2013-09-02','12:55:00',3.2),('8348','2013-09-02','13:00:00',3.23),('8348','2013-09-02','13:05:00',3.24),('8348','2013-09-02','13:10:00',3.24),('8348','2013-09-02','13:15:00',3.23),('8348','2013-09-02','13:20:00',3.2),('8348','2013-09-02','13:25:00',3.21),('8348','2013-09-02','13:30:00',3.17),('8348','2013-09-02','13:35:00',3.19),('8348','2013-09-02','13:40:00',3.18),('8348','2013-09-02','13:45:00',1.34),('8348','2013-09-02','13:50:00',2.17),('8348','2013-09-02','13:55:00',1.37),('8348','2013-09-02','14:00:00',3.2),('8348','2013-09-02','14:05:00',3.36),('8348','2013-09-02','14:10:00',3.28),('8348','2013-09-02','14:15:00',3.23),('8348','2013-09-02','14:20:00',3.22),('8348','2013-09-02','14:25:00',3.22),('8348','2013-09-02','14:30:00',3.14),('8348','2013-09-02','14:35:00',3.11),('8348','2013-09-02','14:40:00',3.14),('8348','2013-09-02','14:45:00',3.21),('8348','2013-09-02','14:50:00',1.91),('8348','2013-09-02','15:00:00',1.28),('8348','2013-09-02','15:05:00',3.12),('8348','2013-09-02','15:10:00',2.94),('8348','2013-09-02','15:15:00',2.39),('8348','2013-09-02','15:25:00',2.1),('8348','2013-09-02','15:30:00',2.8),('8348','2013-09-02','15:35:00',2.1),('8348','2013-09-02','15:40:00',2.42),('8348','2013-09-02','15:45:00',2.8),('8348','2013-09-02','15:50:00',2.85),('8348','2013-09-02','15:55:00',2.75),('8348','2013-09-02','16:00:00',2.7),('8348','2013-09-02','16:05:00',2.62),('8348','2013-09-02','16:10:00',2.59),('8348','2013-09-02','16:15:00',2.57),('8348','2013-09-02','16:20:00',2.53),('8348','2013-09-02','16:25:00',2.45),('8348','2013-09-02','16:30:00',2.38),('8348','2013-09-02','16:35:00',2.33),('8348','2013-09-02','16:40:00',2.24),('8348','2013-09-02','16:45:00',2.17),('8348','2013-09-02','16:50:00',2.1),('8348','2013-09-02','16:55:00',1.99),('8348','2013-09-02','17:00:00',1.92),('8348','2013-09-02','17:05:00',1.86),('8348','2013-09-02','17:10:00',1.79),('8348','2013-09-02','17:15:00',1.74),('8348','2013-09-02','17:20:00',1.67),('8348','2013-09-02','17:25:00',1.61),('8348','2013-09-02','17:30:00',1.53),('8348','2013-09-02','17:35:00',1.45),('8348','2013-09-02','17:40:00',1.38),('8348','2013-09-02','17:45:00',1.32),('8348','2013-09-02','17:50:00',1.24),('8348','2013-09-02','17:55:00',1.18),('8348','2013-09-02','18:00:00',1.11),('8348','2013-09-02','18:05:00',1.03),('8348','2013-09-01','08:40:00',1.01),('8348','2013-09-01','08:45:00',1.09),('8348','2013-09-01','08:50:00',1.13),('8348','2013-09-01','08:55:00',1.25),('8348','2013-09-01','09:00:00',1.32),('8348','2013-09-01','09:05:00',1.39),('8348','2013-09-01','09:10:00',1.49),('8348','2013-09-01','09:15:00',1.57),('8348','2013-09-01','09:20:00',1.64),('8348','2013-09-01','09:25:00',1.7),('8348','2013-09-01','09:30:00',1.78),('8348','2013-09-01','09:35:00',1.85),('8348','2013-09-01','09:40:00',1.91),('8348','2013-09-01','09:45:00',1.97),('8348','2013-09-01','09:50:00',2.03),('8348','2013-09-01','09:55:00',2.08),('8348','2013-09-01','10:00:00',2.14),('8348','2013-09-01','10:05:00',2.18),('8348','2013-09-01','10:10:00',2.25),('8348','2013-09-01','10:15:00',2.29),('8348','2013-09-01','10:20:00',2.33),('8348','2013-09-01','10:25:00',2.39),('8348','2013-09-01','10:30:00',2.43),('8348','2013-09-01','10:35:00',2.48),('8348','2013-09-01','10:40:00',2.52),('8348','2013-09-01','10:45:00',2.58),('8348','2013-09-01','10:50:00',2.61),('8348','2013-09-01','10:55:00',2.67),('8348','2013-09-01','11:00:00',2.72),('8348','2013-09-01','11:05:00',2.76),('8348','2013-09-01','11:10:00',2.79),('8348','2013-09-01','11:15:00',2.81),('8348','2013-09-01','11:20:00',2.82),('8348','2013-09-01','11:25:00',2.86),('8348','2013-09-01','11:30:00',2.88),('8348','2013-09-01','11:35:00',2.91),('8348','2013-09-01','11:40:00',2.98),('8348','2013-09-01','11:45:00',3.02),('8348','2013-09-01','11:50:00',3.02),('8348','2013-09-01','11:55:00',3.05),('8348','2013-09-01','12:00:00',3.07),('8348','2013-09-01','12:05:00',3.05),('8348','2013-09-01','12:10:00',3.09),('8348','2013-09-01','12:15:00',3.11),('8348','2013-09-01','12:20:00',3.15),('8348','2013-09-01','12:25:00',3.1),('8348','2013-09-01','12:30:00',3.19),('8348','2013-09-01','12:35:00',3.17),('8348','2013-09-01','12:40:00',3.19),('8348','2013-09-01','12:45:00',3.19),('8348','2013-09-01','12:50:00',3.21),('8348','2013-09-01','12:55:00',3.22),('8348','2013-09-01','13:00:00',3.29),('8348','2013-09-01','13:05:00',3.22),('8348','2013-09-01','13:10:00',3.23),('8348','2013-09-01','13:15:00',3.19),('8348','2013-09-01','13:20:00',3.28),('8348','2013-09-01','13:25:00',3.3),('8348','2013-09-01','13:30:00',3.37),('8348','2013-09-01','13:35:00',3.31),('8348','2013-09-01','13:40:00',3.33),('8348','2013-09-01','13:45:00',3.19),('8348','2013-09-01','13:50:00',2.75),('8348','2013-09-01','13:55:00',2.95),('8348','2013-09-01','14:00:00',2.6),('8348','2013-09-01','14:05:00',2.67),('8348','2013-09-01','14:10:00',2.97),('8348','2013-09-01','14:15:00',2.93),('8348','2013-09-01','14:20:00',2.7),('8348','2013-09-01','14:25:00',2.78),('8348','2013-09-01','14:35:00',2.79),('8348','2013-09-01','14:40:00',2.8),('8348','2013-09-01','14:45:00',2.86),('8348','2013-09-01','14:50:00',2.86),('8348','2013-09-01','14:55:00',2.73),('8348','2013-09-01','15:00:00',2.77),('8348','2013-09-01','15:05:00',2.71),('8348','2013-09-01','15:10:00',2.74),('8348','2013-09-01','15:15:00',2.72),('8348','2013-09-01','15:20:00',2.62),('8348','2013-09-01','15:25:00',2.3),('8348','2013-09-01','15:30:00',1.99),('8348','2013-09-01','15:35:00',2.14),('8348','2013-09-01','15:40:00',2.48),('8348','2013-09-01','15:45:00',2.29),('8348','2013-09-01','15:50:00',1.78),('8348','2013-09-01','15:55:00',1.87),('8348','2013-09-01','16:00:00',2.33),('8348','2013-09-01','16:05:00',2.48),('8348','2013-09-01','16:10:00',2.52),('8348','2013-09-01','16:15:00',2.44),('8348','2013-09-01','16:20:00',2.29),('8348','2013-09-01','16:25:00',2.34),('8348','2013-09-01','16:30:00',2.49),('8348','2013-09-01','16:35:00',2.38),('8348','2013-09-01','16:40:00',2.33),('8348','2013-09-01','16:45:00',2.12),('8348','2013-09-01','16:50:00',2.06),('8348','2013-09-01','16:55:00',1.87),('8348','2013-09-01','17:00:00',1.54),('8348','2013-09-01','17:05:00',1.59),('8348','2013-09-01','17:10:00',1.28),('8348','2013-09-01','17:15:00',1.37),('8348','2013-09-01','17:20:00',1.47),('8348','2013-09-01','17:25:00',1.42),('8348','2013-09-01','17:30:00',1.24),('8348','2013-09-01','17:35:00',1.27),('8348','2013-09-01','17:40:00',1.33),('8348','2013-09-01','17:45:00',1.11),('8348','2013-09-01','17:50:00',1.01),('8348','2013-09-01','18:10:00',1.03),('8348','2013-08-31','08:40:00',1.06),('8348','2013-08-31','08:45:00',1.15),('8348','2013-08-31','08:50:00',1.25),('8348','2013-08-31','08:55:00',1.45),('8348','2013-08-31','09:00:00',1.52),('8348','2013-08-31','09:05:00',1.4),('8348','2013-08-31','09:10:00',1.17),('8348','2013-08-31','09:15:00',1.46),('8348','2013-08-31','09:20:00',1.66),('8348','2013-08-31','09:25:00',1.82),('8348','2013-08-31','09:30:00',1.88),('8348','2013-08-31','09:35:00',1.98),('8348','2013-08-31','09:40:00',2.02),('8348','2013-08-31','09:45:00',1.9),('8348','2013-08-31','09:50:00',1.96),('8348','2013-08-31','09:55:00',2.12),('8348','2013-08-31','10:00:00',2.26),('8348','2013-08-31','10:05:00',2.25),('8348','2013-08-31','10:10:00',2.37),('8348','2013-08-31','10:15:00',2.38),('8348','2013-08-31','10:20:00',2.44),('8348','2013-08-31','10:25:00',2.48),('8348','2013-08-31','10:30:00',2.55),('8348','2013-08-31','10:35:00',2.61),('8348','2013-08-31','10:40:00',2.63),('8348','2013-08-31','10:45:00',2.69),('8348','2013-08-31','10:50:00',2.77),('8348','2013-08-31','10:55:00',2.81),('8348','2013-08-31','11:00:00',2.86),('8348','2013-08-31','11:05:00',2.9),('8348','2013-08-31','11:10:00',2.92),('8348','2013-08-31','11:15:00',2.97),('8348','2013-08-31','11:20:00',3),('8348','2013-08-31','11:25:00',3.03),('8348','2013-08-31','11:30:00',3.07),('8348','2013-08-31','11:35:00',3.11),('8348','2013-08-31','11:40:00',3.16),('8348','2013-08-31','11:45:00',3.18),('8348','2013-08-31','11:50:00',3.2),('8348','2013-08-31','11:55:00',3.23),('8348','2013-08-31','12:00:00',3.22),('8348','2013-08-31','12:05:00',3.07),('8348','2013-08-31','12:10:00',3.1),('8348','2013-08-31','12:15:00',3.22),('8348','2013-08-31','12:20:00',3.24),('8348','2013-08-31','12:25:00',3.26),('8348','2013-08-31','12:30:00',3.24),('8348','2013-08-31','12:35:00',3.3),('8348','2013-08-31','12:40:00',3.31),('8348','2013-08-31','12:45:00',3.28),('8348','2013-08-31','12:50:00',3.28),('8348','2013-08-31','12:55:00',3.32),('8348','2013-08-31','13:00:00',3.34),('8348','2013-08-31','13:05:00',3.35),('8348','2013-08-31','13:10:00',3.34),('8348','2013-08-31','13:15:00',3.35),('8348','2013-08-31','13:20:00',3.3),('8348','2013-08-31','13:25:00',3.3),('8348','2013-08-31','13:30:00',3.36),('8348','2013-08-31','13:35:00',3.33),('8348','2013-08-31','13:40:00',3.31),('8348','2013-08-31','13:45:00',3.28),('8348','2013-08-31','13:50:00',3.32),('8348','2013-08-31','13:55:00',3.28),('8348','2013-08-31','14:00:00',3.28),('8348','2013-08-31','14:05:00',3.26),('8348','2013-08-31','14:10:00',3.24),('8348','2013-08-31','14:15:00',3.24),('8348','2013-08-31','14:20:00',3.21),('8348','2013-08-31','14:25:00',3.17),('8348','2013-08-31','14:30:00',3.18),('8348','2013-08-31','14:35:00',3.04),('8348','2013-08-31','14:40:00',3.07),('8348','2013-08-31','14:45:00',3.06),('8348','2013-08-31','14:50:00',3.06),('8348','2013-08-31','14:55:00',2.98),('8348','2013-08-31','15:00:00',2.96),('8348','2013-08-31','15:05:00',2.98),('8348','2013-08-31','15:10:00',2.95),('8348','2013-08-31','15:15:00',2.92),('8348','2013-08-31','15:20:00',2.88),('8348','2013-08-31','15:25:00',2.84),('8348','2013-08-31','15:30:00',2.86),('8348','2013-08-31','15:35:00',2.76),('8348','2013-08-31','15:40:00',2.74),('8348','2013-08-31','15:45:00',2.71),('8348','2013-08-31','15:50:00',2.67),('8348','2013-08-31','15:55:00',2.63),('8348','2013-08-31','16:00:00',2.61),('8348','2013-08-31','16:05:00',2.58),('8348','2013-08-31','16:10:00',2.53),('8348','2013-08-31','16:15:00',2.48),('8348','2013-08-31','16:20:00',2.43),('8348','2013-08-31','16:25:00',2.37),('8348','2013-08-31','16:30:00',2.3),('8348','2013-08-31','16:35:00',2.3),('8348','2013-08-31','16:40:00',2.21),('8348','2013-08-31','16:45:00',2.11),('8348','2013-08-31','16:50:00',2.05),('8348','2013-08-31','16:55:00',2.02),('8348','2013-08-31','17:00:00',1.93),('8348','2013-08-31','17:05:00',1.94),('8348','2013-08-31','17:10:00',1.88),('8348','2013-08-31','17:15:00',1.78),('8348','2013-08-31','17:20:00',1.73),('8348','2013-08-31','17:25:00',1.67),('8348','2013-08-31','17:30:00',1.58),('8348','2013-08-31','17:35:00',1.46),('8348','2013-08-31','17:40:00',1.44),('8348','2013-08-31','17:45:00',1.32),('8348','2013-08-31','17:50:00',1.29),('8348','2013-08-31','17:55:00',1.14),('8348','2013-08-30','08:25:00',1.01),('8348','2013-08-30','08:30:00',1.06),('8348','2013-08-30','08:35:00',1.14),('8348','2013-08-30','08:40:00',1.18),('8348','2013-08-30','08:45:00',1.08),('8348','2013-08-30','08:50:00',1.01),('8348','2013-08-30','08:55:00',1.03),('8348','2013-08-30','09:00:00',1.19),('8348','2013-08-30','09:05:00',1.3),('8348','2013-08-30','09:10:00',1.17),('8348','2013-08-30','09:15:00',1.09),('8348','2013-08-30','09:25:00',1.05),('8348','2013-08-30','09:30:00',1.35),('8348','2013-08-30','09:35:00',1.46),('8348','2013-08-30','09:40:00',1.44),('8348','2013-08-30','09:45:00',1.47),('8348','2013-08-30','09:50:00',1.49),('8348','2013-08-30','09:55:00',1.57),('8348','2013-08-30','10:00:00',1.61),('8348','2013-08-30','10:05:00',1.6),('8348','2013-08-30','10:10:00',1.63),('8348','2013-08-30','10:15:00',1.74),('8348','2013-08-30','10:20:00',1.78),('8348','2013-08-30','10:25:00',1.67),('8348','2013-08-30','10:30:00',1.86),('8348','2013-08-30','10:35:00',1.79),('8348','2013-08-30','10:40:00',1.71),('8348','2013-08-30','10:45:00',1.66),('8348','2013-08-30','10:50:00',1.77),('8348','2013-08-30','10:55:00',1.69),('8348','2013-08-30','11:00:00',1.76),('8348','2013-08-30','11:05:00',1.87),('8348','2013-08-30','11:10:00',1.97),('8348','2013-08-30','11:15:00',1.98),('8348','2013-08-30','11:20:00',2),('8348','2013-08-30','11:25:00',2.06),('8348','2013-08-30','11:30:00',2.18),('8348','2013-08-30','11:35:00',2.06),('8348','2013-08-30','11:40:00',2.25),('8348','2013-08-30','11:45:00',2.2),('8348','2013-08-30','11:50:00',2.54),('8348','2013-08-30','11:55:00',2.22),('8348','2013-08-30','12:00:00',2.02),('8348','2013-08-30','12:05:00',1.76),('8348','2013-08-30','12:10:00',1.94),('8348','2013-08-30','12:15:00',2.1),('8348','2013-08-30','12:20:00',2.24),('8348','2013-08-30','12:25:00',2.55),('8348','2013-08-30','12:30:00',2.78),('8348','2013-08-30','12:35:00',2.65),('8348','2013-08-30','12:40:00',2.59),('8348','2013-08-30','12:45:00',2.68),('8348','2013-08-30','12:50:00',2.61),('8348','2013-08-30','12:55:00',2.45),('8348','2013-08-30','13:00:00',2.44),('8348','2013-08-30','13:05:00',2.41),('8348','2013-08-30','13:10:00',2.42),('8348','2013-08-30','13:15:00',2.47),('8348','2013-08-30','13:20:00',2.7),('8348','2013-08-30','13:25:00',3.16),('8348','2013-08-30','13:30:00',3.39),('8348','2013-08-30','13:35:00',3.13),('8348','2013-08-30','13:40:00',3.33),('8348','2013-08-30','13:45:00',3.02),('8348','2013-08-30','13:50:00',3.03),('8348','2013-08-30','13:55:00',3.28),('8348','2013-08-30','14:00:00',3.39),('8348','2013-08-30','14:05:00',3.26),('8348','2013-08-30','14:10:00',3.25),('8348','2013-08-30','14:15:00',3.23),('8348','2013-08-30','14:20:00',3.33),('8348','2013-08-30','14:25:00',3.29),('8348','2013-08-30','14:30:00',3.27),('8348','2013-08-30','14:35:00',3.3),('8348','2013-08-30','14:40:00',3.13),('8348','2013-08-30','14:45:00',2.62),('8348','2013-08-30','14:50:00',2.25),('8348','2013-08-30','14:55:00',2.51),('8348','2013-08-30','15:00:00',2.19),('8348','2013-08-30','15:05:00',2.01),('8348','2013-08-30','15:10:00',1.99),('8348','2013-08-30','15:15:00',2.54),('8348','2013-08-30','15:20:00',2.19),('8348','2013-08-30','15:25:00',2),('8348','2013-08-30','15:30:00',1.83),('8348','2013-08-30','15:35:00',1.58),('8348','2013-08-30','15:40:00',1.7),('8348','2013-08-30','15:45:00',2.01),('8348','2013-08-30','15:50:00',2.13),('8348','2013-08-30','15:55:00',2.06),('8348','2013-08-30','16:00:00',1.96),('8348','2013-08-30','16:05:00',1.73),('8348','2013-08-30','16:10:00',1.43),('8348','2013-08-30','16:15:00',1.33),('8348','2013-08-30','16:20:00',1.52),('8348','2013-08-30','16:25:00',1.5),('8348','2013-08-30','16:30:00',1.68),('8348','2013-08-30','16:35:00',1.42),('8348','2013-08-30','16:40:00',2.24),('8348','2013-08-30','16:45:00',2.07),('8348','2013-08-30','16:50:00',2.2),('8348','2013-08-30','16:55:00',1.39),('8348','2013-08-30','17:00:00',1.45),('8348','2013-08-30','17:05:00',1.21),('8348','2013-08-30','17:10:00',1.5),('8348','2013-08-30','17:15:00',1.34),('8348','2013-08-30','17:20:00',1.17),('8348','2013-08-30','17:25:00',1.24),('8348','2013-08-30','17:30:00',1.1),('8348','2013-08-30','17:35:00',1.44),('8348','2013-08-30','17:40:00',1.21),('8348','2013-08-30','17:45:00',1.39),('8348','2013-08-30','17:50:00',1.06),('8348','2013-08-30','17:55:00',1.4),('8348','2013-08-30','18:00:00',1.15),('8348','2014-04-11','06:50:00',1.09),('8348','2014-04-11','06:55:00',1.12),('8348','2014-04-11','07:30:00',1.49),('8348','2014-04-11','07:35:00',1.85),('8348','2014-04-11','07:40:00',2.35),('8348','2014-04-11','07:45:00',2.41),('8348','2014-04-11','07:50:00',2.42),('8348','2014-04-11','07:55:00',2.49),('8348','2014-04-11','08:00:00',2.54),('8348','2014-04-11','08:05:00',2.72),('8348','2014-04-11','08:10:00',3.05),('8348','2014-04-11','08:15:00',3.28),('8348','2014-04-11','08:20:00',3.43),('8348','2014-04-11','08:25:00',3.58),('8348','2014-04-11','08:30:00',3.75),('8348','2014-04-11','08:35:00',3.9),('8348','2014-04-11','08:40:00',4.05),('8348','2014-04-11','08:45:00',4.22),('8348','2014-04-11','08:50:00',4.31),('8348','2014-04-11','08:55:00',4.53),('8348','2014-04-11','09:00:00',4.66),('8348','2014-04-11','09:05:00',4.78),('8348','2014-04-11','09:10:00',4.98),('8348','2014-04-11','09:15:00',5.07),('8348','2014-04-11','09:20:00',5.19),('8348','2014-04-11','09:25:00',5.3),('8348','2014-04-11','09:30:00',5.41),('8348','2014-04-11','09:35:00',5.52),('8348','2014-04-11','09:40:00',5.6),('8348','2014-04-11','09:45:00',5.76),('8348','2014-04-11','09:50:00',5.88),('8348','2014-04-11','09:55:00',5.97),('8348','2014-04-11','10:00:00',6.12),('8348','2014-04-11','10:05:00',6.18),('8348','2014-04-11','10:10:00',6.23),('8348','2014-04-11','10:15:00',6.31),('8348','2014-04-11','10:20:00',6.49),('8348','2014-04-11','10:25:00',6.56),('8348','2014-04-11','10:30:00',6.62),('8348','2014-04-11','10:35:00',6.73),('8348','2014-04-11','10:40:00',6.62),('8348','2014-04-11','10:45:00',6.82),('8348','2014-04-11','10:50:00',6.03),('8348','2014-04-11','10:55:00',7.22),('8348','2014-04-11','11:00:00',7.36),('8348','2014-04-11','11:05:00',6.63),('8348','2014-04-11','11:10:00',7.62),('8348','2014-04-11','11:15:00',7.41),('8348','2014-04-11','11:20:00',5.88),('8348','2014-04-11','11:25:00',7.1),('8348','2014-04-11','11:30:00',7.67),('8348','2014-04-11','11:35:00',6.99),('8348','2014-04-11','11:40:00',7.52),('8348','2014-04-11','11:45:00',7.96),('8348','2014-04-11','11:50:00',7.75),('8348','2014-04-11','11:55:00',7.72),('8348','2014-04-11','12:00:00',5.59),('8348','2014-04-11','12:05:00',4.36),('8348','2014-04-11','12:10:00',4.05),('8348','2014-04-11','12:15:00',6.97),('8348','2014-04-11','12:20:00',6.68),('8348','2014-04-11','12:25:00',8.08),('8348','2014-04-11','12:30:00',4.5),('8348','2014-04-11','12:35:00',7.86),('8348','2014-04-11','12:40:00',7.19),('8348','2014-04-11','12:45:00',7.58),('8348','2014-04-11','12:50:00',5.17),('8348','2014-04-11','12:55:00',7.37),('8348','2014-04-11','13:00:00',4.9),('8348','2014-04-11','13:05:00',6.57),('8348','2014-04-11','13:10:00',7.01),('8348','2014-04-11','13:15:00',7.27),('8348','2014-04-11','13:20:00',5.99),('8348','2014-04-11','13:25:00',6.1),('8348','2014-04-11','13:30:00',7.13),('8348','2014-04-11','13:35:00',7.97),('8348','2014-04-11','13:40:00',4.94),('8348','2014-04-11','13:45:00',6.14),('8348','2014-04-11','13:50:00',7.97),('8348','2014-04-11','13:55:00',6.19),('8348','2014-04-11','14:00:00',8.32),('8348','2014-04-11','14:05:00',8.06),('8348','2014-04-11','14:10:00',7.27),('8348','2014-04-11','14:15:00',6.22),('8348','2014-04-11','14:20:00',7.07),('8348','2014-04-11','14:25:00',6.96),('8348','2014-04-11','14:30:00',6.6),('8348','2014-04-11','14:35:00',4.55),('8348','2014-04-11','14:40:00',6.4),('8348','2014-04-11','14:45:00',6.32),('8348','2014-04-11','14:50:00',6.32),('8348','2014-04-11','14:55:00',6.23),('8348','2014-04-11','15:00:00',6.07),('8348','2014-04-11','15:05:00',5.92),('8348','2014-04-11','15:10:00',5.82),('8348','2014-04-11','15:15:00',5.54),('8348','2014-04-11','15:20:00',5.5),('8348','2014-04-11','15:25:00',5.41),('8348','2014-04-11','15:30:00',5.32),('8348','2014-04-11','15:35:00',4.86),('8348','2014-04-11','15:40:00',4.95),('8348','2014-04-11','15:45:00',5.05),('8348','2014-04-11','15:50:00',2.44),('8348','2014-04-11','15:55:00',2.9),('8348','2014-04-11','16:00:00',4.91),('8348','2014-04-11','16:05:00',4.14),('8348','2014-04-11','16:10:00',4.27),('8348','2014-04-11','16:15:00',4.13),('8348','2014-04-11','16:20:00',3.86),('8348','2014-04-11','16:25:00',3.86),('8348','2014-04-11','16:30:00',3.89),('8348','2014-04-11','16:35:00',3.75),('8348','2014-04-11','16:40:00',3.6),('8348','2014-04-11','16:45:00',3.22),('8348','2014-04-11','16:50:00',2.97),('8348','2014-04-11','16:55:00',2.77),('8348','2014-04-11','17:00:00',2.56),('8348','2014-04-11','17:05:00',2.37),('8348','2014-04-11','17:10:00',2.23),('8348','2014-04-11','17:15:00',2.11),('8348','2014-04-11','17:20:00',1.99),('8348','2014-04-11','17:25:00',1.86),('8348','2014-04-11','17:30:00',1.96),('8348','2014-04-11','17:35:00',1.73),('8348','2014-04-11','17:40:00',1.51),('8348','2014-04-11','17:45:00',1.3),('8348','2014-04-11','17:50:00',1.19),('8348','2014-04-11','17:55:00',1.06),('8348','2013-08-29','08:25:00',1.08),('8348','2013-08-29','08:30:00',1.27),('8348','2013-08-29','08:35:00',1.3),('8348','2013-08-29','08:40:00',1.09),('8348','2013-08-29','08:50:00',1.06),('8348','2013-08-29','08:55:00',1.31),('8348','2013-08-29','09:00:00',1.31),('8348','2013-08-29','09:05:00',1.29),('8348','2013-08-29','09:10:00',1.27),('8348','2013-08-29','09:15:00',1.35),('8348','2013-08-29','09:20:00',1.36),('8348','2013-08-29','09:25:00',1.27),('8348','2013-08-29','09:30:00',1.31),('8348','2013-08-29','09:35:00',1.44),('8348','2013-08-29','09:40:00',1.49),('8348','2013-08-29','09:45:00',1.31),('8348','2013-08-29','09:50:00',1.27),('8348','2013-08-29','09:55:00',1.32),('8348','2013-08-29','10:00:00',1.39),('8348','2013-08-29','10:05:00',1.34),('8348','2013-08-29','10:10:00',1.32),('8348','2013-08-29','10:15:00',1.32),('8348','2013-08-29','10:20:00',1.35),('8348','2013-08-29','10:25:00',1.35),('8348','2013-08-29','10:30:00',1.38),('8348','2013-08-29','10:35:00',1.31),('8348','2013-08-29','10:40:00',1.2),('8348','2013-08-29','10:45:00',1.13),('8348','2013-08-29','10:50:00',1.13),('8348','2013-08-29','10:55:00',1.26),('8348','2013-08-29','11:00:00',1.34),('8348','2013-08-29','11:05:00',1.36),('8348','2013-08-29','11:10:00',1.93),('8348','2013-08-29','11:15:00',2.17),('8348','2013-08-29','11:20:00',2.01),('8348','2013-08-29','11:25:00',1.57),('8348','2013-08-29','11:30:00',1.32),('8348','2013-08-29','11:35:00',1.24),('8348','2013-08-29','11:40:00',1.41),('8348','2013-08-29','11:45:00',1.63),('8348','2013-08-29','11:50:00',1.69),('8348','2013-08-29','11:55:00',1.61),('8348','2013-08-29','12:00:00',1.58),('8348','2013-08-29','12:05:00',1.76),('8348','2013-08-29','12:10:00',2.14),('8348','2013-08-29','12:15:00',2.47),('8348','2013-08-29','12:20:00',2.27),('8348','2013-08-29','12:25:00',2.32),('8348','2013-08-29','12:30:00',2.26),('8348','2013-08-29','12:35:00',2.72),('8348','2013-08-29','12:40:00',3.75),('8348','2013-08-29','12:45:00',3.85),('8348','2013-08-29','12:50:00',2.38),('8348','2013-08-29','12:55:00',2.85),('8348','2013-08-29','13:00:00',2.36),('8348','2013-08-29','13:05:00',2.21),('8348','2013-08-29','13:10:00',2.17),('8348','2013-08-29','13:15:00',2.07),('8348','2013-08-29','13:20:00',2.07),('8348','2013-08-29','13:25:00',1.78),('8348','2013-08-29','13:30:00',1.64),('8348','2013-08-29','13:35:00',1.56),('8348','2013-08-29','13:40:00',1.5),('8348','2013-08-29','13:45:00',1.4),('8348','2013-08-29','13:50:00',1.37),('8348','2013-08-29','13:55:00',1.6),('8348','2013-08-29','14:00:00',2.11),('8348','2013-08-29','14:05:00',1.51),('8348','2013-08-29','14:10:00',1.35),('8348','2013-08-29','14:15:00',1.11),('8348','2013-08-29','14:50:00',1.11),('8348','2013-08-29','14:55:00',1.27),('8348','2013-08-29','15:00:00',1.4),('8348','2013-08-29','15:05:00',1.59),('8348','2013-08-29','15:10:00',1.25),('8348','2013-08-29','15:15:00',1.08),('8348','2013-08-29','15:20:00',1.21),('8348','2013-08-29','15:25:00',1.41),('8348','2013-08-29','15:30:00',2.25),('8348','2013-08-29','15:35:00',2.11),('8348','2013-08-29','15:40:00',2.01),('8348','2013-08-29','15:45:00',2.12),('8348','2013-08-29','15:50:00',2.7),('8348','2013-08-29','15:55:00',3.14),('8348','2013-08-29','16:00:00',2.86),('8348','2013-08-29','16:05:00',3.03),('8348','2013-08-29','16:10:00',2.96),('8348','2013-08-29','16:15:00',2.76),('8348','2013-08-29','16:20:00',2.64),('8348','2013-08-29','16:25:00',2.55),('8348','2013-08-29','16:30:00',2.42),('8348','2013-08-29','16:35:00',2.43),('8348','2013-08-29','16:40:00',2.37),('8348','2013-08-29','16:45:00',2.32),('8348','2013-08-29','16:50:00',2.24),('8348','2013-08-29','16:55:00',2.18),('8348','2013-08-29','17:00:00',2.13),('8348','2013-08-29','17:05:00',2.07),('8348','2013-08-29','17:10:00',2),('8348','2013-08-29','17:15:00',1.92),('8348','2013-08-29','17:20:00',1.85),('8348','2013-08-29','17:25:00',1.78),('8348','2013-08-29','17:30:00',1.71),('8348','2013-08-29','17:35:00',1.63),('8348','2013-08-29','17:40:00',1.56),('8348','2013-08-29','17:45:00',1.46),('8348','2013-08-29','17:50:00',1.39),('8348','2013-08-29','17:55:00',1.32),('8348','2013-08-29','18:00:00',1.24),('8348','2013-08-29','18:05:00',1.17),('8348','2013-08-29','18:10:00',1.09),('8348','2013-08-29','18:15:00',1.03),('8348','2013-08-28','08:35:00',1.08),('8348','2013-08-28','08:40:00',1.15),('8348','2013-08-28','08:45:00',1.18),('8348','2013-08-28','09:00:00',1.08),('8348','2013-08-28','09:15:00',1.31),('8348','2013-08-28','09:20:00',1.03),('8348','2013-08-28','09:30:00',1.06),('8348','2013-08-28','09:35:00',1.98),('8348','2013-08-28','09:40:00',1.97),('8348','2013-08-28','09:45:00',2.02),('8348','2013-08-28','09:50:00',2.1),('8348','2013-08-28','09:55:00',2.12),('8348','2013-08-28','10:00:00',2.16),('8348','2013-08-28','10:05:00',2.21),('8348','2013-08-28','10:10:00',2.3),('8348','2013-08-28','10:15:00',2.45),('8348','2013-08-28','10:20:00',2.3),('8348','2013-08-28','10:25:00',1.33),('8348','2013-08-28','10:30:00',2.02),('8348','2013-08-28','10:35:00',1.76),('8348','2013-08-28','10:40:00',1.75),('8348','2013-08-28','10:45:00',2.73),('8348','2013-08-28','10:50:00',2.57),('8348','2013-08-28','10:55:00',2.94),('8348','2013-08-28','11:00:00',2.02),('8348','2013-08-28','11:05:00',2.85),('8348','2013-08-28','11:10:00',1.59),('8348','2013-08-28','11:15:00',1.9),('8348','2013-08-28','11:20:00',2.64),('8348','2013-08-28','11:25:00',3.31),('8348','2013-08-28','11:30:00',3.37),('8348','2013-08-28','11:35:00',2.98),('8348','2013-08-28','11:40:00',3.47),('8348','2013-08-28','11:45:00',2.49),('8348','2013-08-28','11:50:00',2.6),('8348','2013-08-28','11:55:00',2.24),('8348','2013-08-28','12:00:00',2.84),('8348','2013-08-28','12:05:00',2.59),('8348','2013-08-28','12:10:00',3.51),('8348','2013-08-28','12:15:00',3.58),('8348','2013-08-28','12:20:00',3.5),('8348','2013-08-28','12:25:00',3.37),('8348','2013-08-28','12:30:00',3.5),('8348','2013-08-28','12:35:00',3.49),('8348','2013-08-28','12:40:00',3.53),('8348','2013-08-28','12:45:00',3.65),('8348','2013-08-28','12:50:00',3.61),('8348','2013-08-28','12:55:00',3.56),('8348','2013-08-28','13:00:00',3.63),('8348','2013-08-28','13:05:00',2.82),('8348','2013-08-28','13:10:00',3.44),('8348','2013-08-28','13:15:00',3.74),('8348','2013-08-28','13:20:00',3.64),('8348','2013-08-28','13:25:00',3.67),('8348','2013-08-28','13:30:00',3.66),('8348','2013-08-28','13:35:00',3.38),('8348','2013-08-28','13:40:00',3.69),('8348','2013-08-28','13:45:00',2.78),('8348','2013-08-28','13:50:00',3.73),('8348','2013-08-28','13:55:00',3.55),('8348','2013-08-28','14:00:00',3.67),('8348','2013-08-28','14:05:00',3.63),('8348','2013-08-28','14:10:00',3.61),('8348','2013-08-28','14:15:00',3.61),('8348','2013-08-28','14:20:00',3.57),('8348','2013-08-28','14:25:00',3.56),('8348','2013-08-28','14:30:00',3.41),('8348','2013-08-28','14:35:00',2.59),('8348','2013-08-28','14:40:00',3.63),('8348','2013-08-28','14:45:00',3.46),('8348','2013-08-28','14:50:00',3.44),('8348','2013-08-28','14:55:00',3.42),('8348','2013-08-28','15:00:00',3.36),('8348','2013-08-28','15:05:00',3.36),('8348','2013-08-28','15:10:00',3.42),('8348','2013-08-28','15:15:00',3.38),('8348','2013-08-28','15:20:00',3.36),('8348','2013-08-28','15:25:00',2.95),('8348','2013-08-28','15:30:00',2.3),('8348','2013-08-28','15:35:00',2.05),('8348','2013-08-28','15:40:00',1.88),('8348','2013-08-28','15:45:00',2.27),('8348','2013-08-28','15:50:00',2.73),('8348','2013-08-28','15:55:00',2.43),('8348','2013-08-28','16:00:00',2.92),('8348','2013-08-28','16:05:00',3.14),('8348','2013-08-28','16:10:00',3),('8348','2013-08-28','16:15:00',2.4),('8348','2013-08-28','16:20:00',2.32),('8348','2013-08-28','16:25:00',2.84),('8348','2013-08-28','16:30:00',2.73),('8348','2013-08-28','16:35:00',2.58),('8348','2013-08-28','16:40:00',2.63),('8348','2013-08-28','16:45:00',2.49),('8348','2013-08-28','16:50:00',2.38),('8348','2013-08-28','16:55:00',2.28),('8348','2013-08-28','17:00:00',2.27),('8348','2013-08-28','17:05:00',2.15),('8348','2013-08-28','17:10:00',1.18),('8348','2013-08-28','17:15:00',1.67),('8348','2013-08-28','17:20:00',1.67),('8348','2013-08-28','17:25:00',1.2),('8348','2013-08-28','17:30:00',1.18),('8348','2013-08-28','17:35:00',1.38),('8348','2013-08-28','17:40:00',1.48),('8348','2013-08-28','18:15:00',1.05),('8348','2013-08-27','08:25:00',1.11),('8348','2013-08-27','08:30:00',1.1),('8348','2013-08-27','09:15:00',1.02),('8348','2013-08-27','09:20:00',1.19),('8348','2013-08-27','09:25:00',1.54),('8348','2013-08-27','09:30:00',1.74),('8348','2013-08-27','09:35:00',1.03),('8348','2013-08-27','09:55:00',1.17),('8348','2013-08-27','10:00:00',1.5),('8348','2013-08-27','10:05:00',1.83),('8348','2013-08-27','10:10:00',2.21),('8348','2013-08-27','10:15:00',2.24),('8348','2013-08-27','10:20:00',2.38),('8348','2013-08-27','10:25:00',2.4),('8348','2013-08-27','10:30:00',2.42),('8348','2013-08-27','10:35:00',2.48),('8348','2013-08-27','10:40:00',2.52),('8348','2013-08-27','10:45:00',2.58),('8348','2013-08-27','10:50:00',2.6),('8348','2013-08-27','10:55:00',2.64),('8348','2013-08-27','11:00:00',2.7),('8348','2013-08-27','11:05:00',2.74),('8348','2013-08-27','11:10:00',2.71),('8348','2013-08-27','11:15:00',2.49),('8348','2013-08-27','11:20:00',2.77),('8348','2013-08-27','11:25:00',2.72),('8348','2013-08-27','11:30:00',2.77),('8348','2013-08-27','11:35:00',2.84),('8348','2013-08-27','11:40:00',2.74),('8348','2013-08-27','11:45:00',3.33),('8348','2013-08-27','11:50:00',3.09),('8348','2013-08-27','11:55:00',3.34),('8348','2013-08-27','12:00:00',3.45),('8348','2013-08-27','12:05:00',3.36),('8348','2013-08-27','12:10:00',2.65),('8348','2013-08-27','12:15:00',3.09),('8348','2013-08-27','12:20:00',3.32),('8348','2013-08-27','12:25:00',3.23),('8348','2013-08-27','12:30:00',2.95),('8348','2013-08-27','12:35:00',3.03),('8348','2013-08-27','12:40:00',3.58),('8348','2013-08-27','12:45:00',2.64),('8348','2013-08-27','12:50:00',1.99),('8348','2013-08-27','12:55:00',1.59),('8348','2013-08-27','13:00:00',1.22),('8348','2013-08-27','13:05:00',1.37),('8348','2013-08-27','13:10:00',1.82),('8348','2013-08-27','13:15:00',1.45),('8348','2013-08-27','13:20:00',1.86),('8348','2013-08-27','13:25:00',1.99),('8348','2013-08-27','13:30:00',2.39),('8348','2013-08-27','13:35:00',1.73),('8348','2013-08-27','13:40:00',1.72),('8348','2013-08-27','13:45:00',1.82),('8348','2013-08-27','13:50:00',3.43),('8348','2013-08-27','13:55:00',2.85),('8348','2013-08-27','14:00:00',2.58),('8348','2013-08-27','14:05:00',2.23),('8348','2013-08-27','14:10:00',2.45),('8348','2013-08-27','14:15:00',2.98),('8348','2013-08-27','14:20:00',1.98),('8348','2013-08-27','14:25:00',1.23),('8348','2013-08-27','14:30:00',1.13),('8348','2013-08-27','14:35:00',1.03),('8348','2013-08-27','14:40:00',1.14),('8348','2013-08-27','14:45:00',1.18),('8348','2013-08-27','15:55:00',1.26),('8348','2013-08-27','16:00:00',1.39),('8348','2013-08-27','16:05:00',1.41),('8348','2013-08-27','16:10:00',3.05),('8348','2013-08-27','16:15:00',3.04),('8348','2013-08-27','16:20:00',1.63),('8348','2013-08-27','16:25:00',1.61),('8348','2013-08-27','16:35:00',1.14),('8348','2013-08-27','16:40:00',1.17),('8348','2013-08-27','16:45:00',1.65),('8348','2013-08-27','16:50:00',2.61),('8348','2013-08-27','16:55:00',1.89),('8348','2013-08-27','17:05:00',1.02),('8348','2013-08-27','17:10:00',2.47),('8348','2013-08-27','17:15:00',1.22),('8348','2013-08-27','17:45:00',1.32),('8348','2013-08-27','17:50:00',1.52),('8348','2013-08-27','17:55:00',1.51),('8348','2013-08-27','18:00:00',1.31),('8348','2013-08-26','08:20:00',1.03),('8348','2013-08-26','08:30:00',1.03),('8348','2013-08-26','08:40:00',1.1),('8348','2013-08-26','08:45:00',1.12),('8348','2013-08-26','08:50:00',1.23),('8348','2013-08-26','08:55:00',1.29),('8348','2013-08-26','09:00:00',1.38),('8348','2013-08-26','09:05:00',1.45),('8348','2013-08-26','09:10:00',1.53),('8348','2013-08-26','09:15:00',1.61),('8348','2013-08-26','09:20:00',1.67),('8348','2013-08-26','09:25:00',1.73),('8348','2013-08-26','09:30:00',1.8),('8348','2013-08-26','09:35:00',1.85),('8348','2013-08-26','09:40:00',1.91),('8348','2013-08-26','09:45:00',1.97),('8348','2013-08-26','09:50:00',2.05),('8348','2013-08-26','09:55:00',2.09),('8348','2013-08-26','10:00:00',2.13),('8348','2013-08-26','10:05:00',2.21),('8348','2013-08-26','10:10:00',2.23),('8348','2013-08-26','10:15:00',2.29),('8348','2013-08-26','10:20:00',2.37),('8348','2013-08-26','10:25:00',2.42),('8348','2013-08-26','10:30:00',2.46),('8348','2013-08-26','10:35:00',2.5),('8348','2013-08-26','10:40:00',2.55),('8348','2013-08-26','10:45:00',2.6),('8348','2013-08-26','10:50:00',2.66),('8348','2013-08-26','10:55:00',2.7),('8348','2013-08-26','11:00:00',2.76),('8348','2013-08-26','11:05:00',2.77),('8348','2013-08-26','11:10:00',2.8),('8348','2013-08-26','11:15:00',2.87),('8348','2013-08-26','11:20:00',2.89),('8348','2013-08-26','11:25:00',2.91),('8348','2013-08-26','11:30:00',2.98),('8348','2013-08-26','11:35:00',3.03),('8348','2013-08-26','11:40:00',3.04),('8348','2013-08-26','11:45:00',3.04),('8348','2013-08-26','11:50:00',2.74),('8348','2013-08-26','11:55:00',3.08),('8348','2013-08-26','12:00:00',3.12),('8348','2013-08-26','12:05:00',3.18),('8348','2013-08-26','12:10:00',3.19),('8348','2013-08-26','12:15:00',3.19),('8348','2013-08-26','12:20:00',3.16),('8348','2013-08-26','12:25:00',3.15),('8348','2013-08-26','12:30:00',3.17),('8348','2013-08-26','12:35:00',3.23),('8348','2013-08-26','12:40:00',3.26),('8348','2013-08-26','12:45:00',3.3),('8348','2013-08-26','12:50:00',3.31),('8348','2013-08-26','12:55:00',3.32),('8348','2013-08-26','13:00:00',3.53),('8348','2013-08-26','13:05:00',3.9),('8348','2013-08-26','13:10:00',3.3),('8348','2013-08-26','13:15:00',3.26),('8348','2013-08-26','13:20:00',2.57),('8348','2013-08-26','13:25:00',2.55),('8348','2013-08-26','13:30:00',2.49),('8348','2013-08-26','13:35:00',3.26),('8348','2013-08-26','13:40:00',3.38),('8348','2013-08-26','13:45:00',3.42),('8348','2013-08-26','13:50:00',3.48),('8348','2013-08-26','13:55:00',2.59),('8348','2013-08-26','14:00:00',2.63),('8348','2013-08-26','14:05:00',3.42),('8348','2013-08-26','14:10:00',2.51),('8348','2013-08-26','14:15:00',3.46),('8348','2013-08-26','14:20:00',3.33),('8348','2013-08-26','14:25:00',3.28),('8348','2013-08-26','14:30:00',3.26),('8348','2013-08-26','14:35:00',3.15),('8348','2013-08-26','14:40:00',2.91),('8348','2013-08-26','14:45:00',2.21),('8348','2013-08-26','14:50:00',1.87),('8348','2013-08-26','14:55:00',1.73),('8348','2013-08-26','15:00:00',1.64),('8348','2013-08-26','15:05:00',1.26),('8348','2013-08-26','15:40:00',1.42),('8348','2013-08-26','15:45:00',1.53),('8348','2013-08-26','15:50:00',1.54),('8348','2013-08-26','15:55:00',1.43),('8348','2013-08-26','16:00:00',2.04),('8348','2013-08-26','16:05:00',3.08),('8348','2013-08-26','16:10:00',2.71),('8348','2013-08-26','16:15:00',2.52),('8348','2013-08-26','16:20:00',2.51),('8348','2013-08-26','16:25:00',2.42),('8348','2013-08-26','16:30:00',2.36),('8348','2013-08-26','16:35:00',2.32),('8348','2013-08-26','16:40:00',2.28),('8348','2013-08-26','16:45:00',2.23),('8348','2013-08-26','16:50:00',2.08),('8348','2013-08-26','16:55:00',2.06),('8348','2013-08-26','17:00:00',2.03),('8348','2013-08-26','17:05:00',1.86),('8348','2013-08-26','17:10:00',1.89),('8348','2013-08-26','17:15:00',1.82),('8348','2013-08-26','17:20:00',1.39),('8348','2013-08-26','17:30:00',1.36),('8348','2013-08-26','17:35:00',1.03),('8348','2013-08-26','17:40:00',1.06),('8348','2013-08-26','17:45:00',1.26),('8348','2013-08-26','17:50:00',1.44),('8348','2013-08-26','17:55:00',1.42),('8348','2013-08-26','18:00:00',1.26),('8348','2013-08-26','18:05:00',1.11),('8348','2013-08-26','18:10:00',1.01),('8348','2013-08-25','08:45:00',1.34),('8348','2013-08-25','09:20:00',1.74),('8348','2013-08-25','09:25:00',1.77),('8348','2013-08-25','09:30:00',1.51),('8348','2013-08-25','09:35:00',1.14),('8348','2013-08-25','09:40:00',2.27),('8348','2013-08-25','09:45:00',2.68),('8348','2013-08-25','09:50:00',2.42),('8348','2013-08-25','09:55:00',2.55),('8348','2013-08-25','10:00:00',1.85),('8348','2013-08-25','10:05:00',1.22),('8348','2013-08-25','15:15:00',1.11),('8348','2013-08-25','15:20:00',1.3),('8348','2013-08-25','15:25:00',1.41),('8348','2013-08-25','15:30:00',1.99),('8348','2013-08-25','15:35:00',2.96),('8348','2013-08-25','15:40:00',3.12),('8348','2013-08-25','15:45:00',3.26),('8348','2013-08-25','15:50:00',2.3),('8348','2013-08-25','15:55:00',2.08),('8348','2013-08-25','16:00:00',3.11),('8348','2013-08-25','16:05:00',2.87),('8348','2013-08-25','16:10:00',2.75),('8348','2013-08-25','16:15:00',2.66),('8348','2013-08-25','16:20:00',2.6),('8348','2013-08-25','16:25:00',2.58),('8348','2013-08-25','16:30:00',2.54),('8348','2013-08-25','16:35:00',2.43),('8348','2013-08-25','16:40:00',1.83),('8348','2013-08-25','16:45:00',1.34),('8348','2013-08-25','16:50:00',1.84),('8348','2013-08-25','16:55:00',2.46),('8348','2013-08-25','17:00:00',2.32),('8348','2013-08-25','17:05:00',2.19),('8348','2013-08-25','17:10:00',2.1),('8348','2013-08-25','17:15:00',1.92),('8348','2013-08-25','17:20:00',1.85),('8348','2013-08-25','17:25:00',1.78),('8348','2013-08-25','17:30:00',1.69),('8348','2013-08-25','17:35:00',1.43),('8348','2013-08-25','17:40:00',1.3),('8348','2013-08-25','17:45:00',1.53),('8348','2013-08-25','17:50:00',1.37),('8348','2013-08-25','17:55:00',1.17),('8348','2013-08-25','18:10:00',1.02),('8348','2013-08-25','18:15:00',1.06),('8348','2013-08-25','18:20:00',1),('8348','2013-08-24','08:40:00',1.05),('8348','2013-08-24','08:45:00',1.11),('8348','2013-08-24','08:50:00',1.23),('8348','2013-08-24','08:55:00',1.27),('8348','2013-08-24','09:00:00',1.4),('8348','2013-08-24','09:05:00',1.62),('8348','2013-08-24','09:10:00',1.2),('8348','2013-08-24','09:15:00',1.06),('8348','2013-08-24','09:20:00',1.22),('8348','2013-08-24','09:25:00',1.71),('8348','2013-08-24','09:30:00',1.67),('8348','2013-08-24','09:35:00',1.69),('8348','2013-08-24','09:40:00',1.04),('8348','2013-08-24','09:45:00',1.96),('8348','2013-08-24','09:50:00',1.83),('8348','2013-08-24','09:55:00',2.14),('8348','2013-08-24','10:00:00',2.23),('8348','2013-08-24','10:05:00',2.24),('8348','2013-08-24','10:10:00',2.31),('8348','2013-08-24','10:15:00',2.33),('8348','2013-08-24','10:20:00',2.4),('8348','2013-08-24','10:25:00',2.43),('8348','2013-08-24','10:30:00',2.49),('8348','2013-08-24','10:35:00',2.53),('8348','2013-08-24','10:40:00',2.58),('8348','2013-08-24','10:45:00',2.62),('8348','2013-08-24','10:50:00',1.82),('8348','2013-08-24','10:55:00',2.81),('8348','2013-08-24','11:00:00',2.77),('8348','2013-08-24','11:05:00',2.84),('8348','2013-08-24','11:10:00',2.88),('8348','2013-08-24','11:15:00',2.91),('8348','2013-08-24','11:20:00',2.96),('8348','2013-08-24','11:25:00',2.93),('8348','2013-08-24','11:30:00',2.99),('8348','2013-08-24','11:35:00',3.02),('8348','2013-08-24','11:40:00',3.05),('8348','2013-08-24','11:45:00',3.08),('8348','2013-08-24','11:50:00',3.13),('8348','2013-08-24','11:55:00',3.13),('8348','2013-08-24','12:00:00',3.15),('8348','2013-08-24','12:05:00',3.16),('8348','2013-08-24','12:10:00',3.2),('8348','2013-08-24','12:15:00',3.24),('8348','2013-08-24','12:20:00',3.26),('8348','2013-08-24','12:25:00',3.27),('8348','2013-08-24','12:30:00',3.27),('8348','2013-08-24','12:35:00',3.29),('8348','2013-08-24','12:40:00',3.3),('8348','2013-08-24','12:45:00',3.33),('8348','2013-08-24','12:50:00',3.32),('8348','2013-08-24','12:55:00',3.3),('8348','2013-08-24','13:00:00',3.27),('8348','2013-08-24','13:05:00',3.3),('8348','2013-08-24','13:10:00',3.37),('8348','2013-08-24','13:15:00',3.35),('8348','2013-08-24','13:20:00',3.37),('8348','2013-08-24','13:25:00',3.41),('8348','2013-08-24','13:30:00',3.44),('8348','2013-08-24','13:35:00',3.45),('8348','2013-08-24','13:40:00',3.42),('8348','2013-08-24','13:45:00',3.43),('8348','2013-08-24','13:50:00',3.43),('8348','2013-08-24','13:55:00',3.41),('8348','2013-08-24','14:00:00',3.38),('8348','2013-08-24','14:05:00',3.4),('8348','2013-08-24','14:10:00',3.39),('8348','2013-08-24','14:15:00',3.38),('8348','2013-08-24','14:20:00',3.37),('8348','2013-08-24','14:25:00',3.35),('8348','2013-08-24','14:30:00',3.36),('8348','2013-08-24','14:35:00',3.34),('8348','2013-08-24','14:40:00',3.3),('8348','2013-08-24','14:45:00',3.27),('8348','2013-08-24','14:50:00',3.24),('8348','2013-08-24','14:55:00',3.23),('8348','2013-08-24','15:00:00',3.2),('8348','2013-08-24','15:05:00',3.19),('8348','2013-08-24','15:10:00',3.14),('8348','2013-08-24','15:15:00',3.11),('8348','2013-08-24','15:20:00',3.06),('8348','2013-08-24','15:25:00',3.05),('8348','2013-08-24','15:30:00',3.02),('8348','2013-08-24','15:35:00',2.99),('8348','2013-08-24','15:40:00',2.93),('8348','2013-08-24','15:45:00',2.89),('8348','2013-08-24','15:50:00',2.86),('8348','2013-08-24','15:55:00',2.82),('8348','2013-08-24','16:00:00',2.78),('8348','2013-08-24','16:05:00',2.72),('8348','2013-08-24','16:10:00',2.68),('8348','2013-08-24','16:15:00',2.62),('8348','2013-08-24','16:20:00',2.59),('8348','2013-08-24','16:25:00',2.49),('8348','2013-08-24','16:30:00',2.46),('8348','2013-08-24','16:35:00',2.43),('8348','2013-08-24','16:40:00',2.36),('8348','2013-08-24','16:45:00',2.27),('8348','2013-08-24','16:50:00',2.25),('8348','2013-08-24','16:55:00',2.18),('8348','2013-08-24','17:00:00',2.1),('8348','2013-08-24','17:05:00',2.07),('8348','2013-08-24','17:10:00',2.01),('8348','2013-08-24','17:15:00',1.95),('8348','2013-08-24','17:20:00',1.88),('8348','2013-08-24','17:25:00',1.81),('8348','2013-08-24','17:30:00',1.75),('8348','2013-08-24','17:35:00',1.67),('8348','2013-08-24','17:40:00',1.59),('8348','2013-08-24','17:45:00',1.52),('8348','2013-08-24','17:50:00',1.45),('8348','2013-08-24','17:55:00',1.37),('8348','2013-08-24','18:00:00',1.3),('8348','2013-08-24','18:05:00',1.22),('8348','2013-08-24','18:10:00',1.14),('8348','2013-08-24','18:15:00',1.06),('8348','2013-08-23','08:45:00',1.08),('8348','2013-08-23','08:50:00',1.13),('8348','2013-08-23','08:55:00',1.2),('8348','2013-08-23','09:00:00',1.26),('8348','2013-08-23','09:05:00',1.35),('8348','2013-08-23','09:10:00',1.42),('8348','2013-08-23','09:15:00',1.48),('8348','2013-08-23','09:20:00',1.55),('8348','2013-08-23','09:25:00',1.61),('8348','2013-08-23','09:30:00',1.65),('8348','2013-08-23','09:35:00',1.71),('8348','2013-08-23','09:40:00',1.76),('8348','2013-08-23','09:45:00',1.82),('8348','2013-08-23','09:50:00',1.88),('8348','2013-08-23','09:55:00',1.92),('8348','2013-08-23','10:00:00',1.97),('8348','2013-08-23','10:05:00',2.02),('8348','2013-08-23','10:10:00',2.08),('8348','2013-08-23','10:15:00',2.13),('8348','2013-08-23','10:20:00',2.19),('8348','2013-08-23','10:25:00',2.21),('8348','2013-08-23','10:30:00',2.25),('8348','2013-08-23','10:35:00',2.31),('8348','2013-08-23','10:40:00',2.36),('8348','2013-08-23','10:45:00',2.4),('8348','2013-08-23','10:50:00',2.38),('8348','2013-08-23','10:55:00',2.5),('8348','2013-08-23','11:00:00',2.53),('8348','2013-08-23','11:05:00',2.56),('8348','2013-08-23','11:10:00',1.95),('8348','2013-08-23','11:15:00',1.18),('8348','2013-08-23','11:20:00',1.18),('8348','2013-08-23','11:25:00',1.72),('8348','2013-08-23','11:30:00',1.79),('8348','2013-08-23','11:35:00',2.76),('8348','2013-08-23','11:40:00',3.1),('8348','2013-08-23','11:45:00',2.95),('8348','2013-08-23','11:50:00',3),('8348','2013-08-23','11:55:00',1.27),('8348','2013-08-23','12:00:00',1.17),('8348','2013-08-23','12:05:00',1.17),('8348','2013-08-23','12:10:00',2.57),('8348','2013-08-23','12:15:00',1.99),('8348','2013-08-23','12:35:00',1.19),('8348','2013-08-23','12:40:00',1.41),('8348','2013-08-23','12:45:00',2.01),('8348','2013-08-23','12:50:00',1.17),('8348','2013-08-23','12:55:00',1.75),('8348','2013-08-23','13:00:00',1),('8348','2013-08-23','13:05:00',2.24),('8348','2013-08-23','13:10:00',1.49),('8348','2013-08-23','13:15:00',2.18),('8348','2013-08-23','13:20:00',1.9),('8348','2013-08-23','13:25:00',2.99),('8348','2013-08-23','13:30:00',3.21),('8348','2013-08-23','13:35:00',2.47),('8348','2013-08-23','13:40:00',3.13),('8348','2013-08-23','13:45:00',2.18),('8348','2013-08-23','13:50:00',1.86),('8348','2013-08-23','13:55:00',3.7),('8348','2013-08-23','14:00:00',3.52),('8348','2013-08-23','14:05:00',3.21),('8348','2013-08-23','14:10:00',3.4),('8348','2013-08-23','14:15:00',3.42),('8348','2013-08-23','14:20:00',3.22),('8348','2013-08-23','14:25:00',3.22),('8348','2013-08-23','14:30:00',3.37),('8348','2013-08-23','14:35:00',3.32),('8348','2013-08-23','14:40:00',3.31),('8348','2013-08-23','14:45:00',3.29),('8348','2013-08-23','14:50:00',3.19),('8348','2013-08-23','14:55:00',3.14),('8348','2013-08-23','15:00:00',3.07),('8348','2013-08-23','15:05:00',2.99),('8348','2013-08-23','15:10:00',3.11),('8348','2013-08-23','15:15:00',3.02),('8348','2013-08-23','15:20:00',3.03),('8348','2013-08-23','15:25:00',3.04),('8348','2013-08-23','15:30:00',3.11),('8348','2013-08-23','15:35:00',2.89),('8348','2013-08-23','15:40:00',2.89),('8348','2013-08-23','15:45:00',2.88),('8348','2013-08-23','15:50:00',2.66),('8348','2013-08-23','15:55:00',2.79),('8348','2013-08-23','16:00:00',2.67),('8348','2013-08-23','16:05:00',2.52),('8348','2013-08-23','16:10:00',2.31),('8348','2013-08-23','16:15:00',2.45),('8348','2013-08-23','16:20:00',2.7),('8348','2013-08-23','16:25:00',2.56),('8348','2013-08-23','16:30:00',2.49),('8348','2013-08-23','16:35:00',2.54),('8348','2013-08-23','16:40:00',2.48),('8348','2013-08-23','16:45:00',2.41),('8348','2013-08-23','16:50:00',2.33),('8348','2013-08-23','16:55:00',2.24),('8348','2013-08-23','17:00:00',2.15),('8348','2013-08-23','17:05:00',2.05),('8348','2013-08-23','17:10:00',1.98),('8348','2013-08-23','17:15:00',1.91),('8348','2013-08-23','17:20:00',1.82),('8348','2013-08-23','17:25:00',1.76),('8348','2013-08-23','17:30:00',1.68),('8348','2013-08-23','17:35:00',1.61),('8348','2013-08-23','17:40:00',1.52),('8348','2013-08-23','17:45:00',1.47),('8348','2013-08-23','17:50:00',1.39),('8348','2013-08-23','17:55:00',1.33),('8348','2013-08-23','18:00:00',1.24),('8348','2013-08-23','18:05:00',1.17),('8348','2013-08-23','18:10:00',1.03),('8348','2013-08-22','08:40:00',1.03),('8348','2013-08-22','08:45:00',1.12),('8348','2013-08-22','08:50:00',1.18),('8348','2013-08-22','08:55:00',1.3),('8348','2013-08-22','09:00:00',1.39),('8348','2013-08-22','09:05:00',1.53),('8348','2013-08-22','09:10:00',1.64),('8348','2013-08-22','09:15:00',1.72),('8348','2013-08-22','09:20:00',1.83),('8348','2013-08-22','09:25:00',1.87),('8348','2013-08-22','09:30:00',1.76),('8348','2013-08-22','09:35:00',1.09),('8348','2013-08-22','09:40:00',1.15),('8348','2013-08-22','09:45:00',1.74),('8348','2013-08-22','09:50:00',2.09),('8348','2013-08-22','09:55:00',1.72),('8348','2013-08-22','10:00:00',2.35),('8348','2013-08-22','10:05:00',2.35),('8348','2013-08-22','10:10:00',2.36),('8348','2013-08-22','10:15:00',2.36),('8348','2013-08-22','10:20:00',2.35),('8348','2013-08-22','10:25:00',2.4),('8348','2013-08-22','10:30:00',2.47),('8348','2013-08-22','10:35:00',2.49),('8348','2013-08-22','10:40:00',2.54),('8348','2013-08-22','10:45:00',2.57),('8348','2013-08-22','10:50:00',2.6),('8348','2013-08-22','10:55:00',2.66),('8348','2013-08-22','11:00:00',2.7),('8348','2013-08-22','11:05:00',2.72),('8348','2013-08-22','11:10:00',2.75),('8348','2013-08-22','11:15:00',2.76),('8348','2013-08-22','11:20:00',2.79),('8348','2013-08-22','11:25:00',2.83),('8348','2013-08-22','11:30:00',2.86),('8348','2013-08-22','11:35:00',2.9),('8348','2013-08-22','11:40:00',2.93),('8348','2013-08-22','11:45:00',2.95),('8348','2013-08-22','11:50:00',2.97),('8348','2013-08-22','11:55:00',3),('8348','2013-08-22','12:00:00',3.01),('8348','2013-08-22','12:05:00',3.05),('8348','2013-08-22','12:10:00',3.04),('8348','2013-08-22','12:15:00',3.06),('8348','2013-08-22','12:20:00',3.1),('8348','2013-08-22','12:25:00',3.1),('8348','2013-08-22','12:30:00',3.1),('8348','2013-08-22','12:35:00',3.12),('8348','2013-08-22','12:40:00',3.14),('8348','2013-08-22','12:45:00',3.14),('8348','2013-08-22','12:50:00',3.13),('8348','2013-08-22','12:55:00',3.14),('8348','2013-08-22','13:00:00',3.14),('8348','2013-08-22','13:05:00',3.12),('8348','2013-08-22','13:10:00',3.09),('8348','2013-08-22','13:15:00',3.1),('8348','2013-08-22','13:20:00',3.17),('8348','2013-08-22','13:25:00',3.17),('8348','2013-08-22','13:30:00',3.17),('8348','2013-08-22','13:35:00',3.15),('8348','2013-08-22','13:40:00',3.15),('8348','2013-08-22','13:45:00',3.16),('8348','2013-08-22','13:50:00',3.14),('8348','2013-08-22','13:55:00',3.15),('8348','2013-08-22','14:00:00',3.13),('8348','2013-08-22','14:05:00',3.12),('8348','2013-08-22','14:10:00',3.12),('8348','2013-08-22','14:15:00',3.15),('8348','2013-08-22','14:20:00',3.17),('8348','2013-08-22','14:25:00',3.16),('8348','2013-08-22','14:30:00',2.62),('8348','2013-08-22','14:35:00',2.84),('8348','2013-08-22','14:40:00',3.18),('8348','2013-08-22','14:45:00',3.05),('8348','2013-08-22','14:50:00',3.07),('8348','2013-08-22','14:55:00',3.09),('8348','2013-08-22','15:00:00',3.05),('8348','2013-08-22','15:05:00',3.06),('8348','2013-08-22','15:10:00',3.07),('8348','2013-08-22','15:15:00',2.96),('8348','2013-08-22','15:20:00',3.01),('8348','2013-08-22','15:25:00',2.97),('8348','2013-08-22','15:30:00',2.91),('8348','2013-08-22','15:35:00',2.85),('8348','2013-08-22','15:40:00',2.85),('8348','2013-08-22','15:45:00',2.83),('8348','2013-08-22','15:50:00',2.79),('8348','2013-08-22','15:55:00',2.74),('8348','2013-08-22','16:00:00',2.68),('8348','2013-08-22','16:05:00',2.59),('8348','2013-08-22','16:10:00',2.56),('8348','2013-08-22','16:15:00',2.55),('8348','2013-08-22','16:20:00',2.5),('8348','2013-08-22','16:25:00',2.45),('8348','2013-08-22','16:30:00',2.4),('8348','2013-08-22','16:35:00',2.33),('8348','2013-08-22','16:40:00',2.26),('8348','2013-08-22','16:45:00',2.19),('8348','2013-08-22','16:50:00',2.13),('8348','2013-08-22','16:55:00',2.09),('8348','2013-08-22','17:00:00',2.03),('8348','2013-08-22','17:05:00',1.95),('8348','2013-08-22','17:10:00',1.89),('8348','2013-08-22','17:15:00',1.8),('8348','2013-08-22','17:20:00',1.73),('8348','2013-08-22','17:25:00',1.68),('8348','2013-08-22','17:30:00',1.62),('8348','2013-08-22','17:35:00',1.55),('8348','2013-08-22','17:40:00',1.48),('8348','2013-08-22','17:45:00',1.39),('8348','2013-08-22','17:50:00',1.31),('8348','2013-08-22','17:55:00',1.26),('8348','2013-08-22','18:00:00',1.2),('8348','2013-08-22','18:05:00',1.14),('8348','2013-08-22','18:10:00',1.1),('8348','2013-08-22','18:15:00',1.1),('8348','2013-08-21','09:05:00',1.2),('8348','2013-08-21','09:10:00',1.19),('8348','2013-08-21','09:15:00',1.84),('8348','2013-08-21','09:20:00',2.05),('8348','2013-08-21','09:25:00',1.08),('8348','2013-08-21','09:45:00',1.03),('8348','2013-08-21','09:50:00',2.02),('8348','2013-08-21','09:55:00',2.92),('8348','2013-08-21','10:00:00',2.74),('8348','2013-08-21','10:05:00',2.28),('8348','2013-08-21','10:10:00',2.23),('8348','2013-08-21','10:15:00',2.16),('8348','2013-08-21','10:20:00',1.83),('8348','2013-08-21','10:25:00',1.5),('8348','2013-08-21','10:30:00',1.8),('8348','2013-08-21','10:35:00',2.64),('8348','2013-08-21','10:40:00',2.16),('8348','2013-08-21','10:45:00',1.55),('8348','2013-08-21','10:50:00',1.77),('8348','2013-08-21','10:55:00',1.43),('8348','2013-08-21','11:00:00',1.9),('8348','2013-08-21','11:05:00',1.6),('8348','2013-08-21','11:10:00',1.44),('8348','2013-08-21','11:15:00',1.76),('8348','2013-08-21','11:20:00',2.49),('8348','2013-08-21','11:25:00',2.08),('8348','2013-08-21','11:30:00',2.28),('8348','2013-08-21','11:35:00',3.35),('8348','2013-08-21','11:40:00',3.39),('8348','2013-08-21','11:45:00',3.32),('8348','2013-08-21','11:50:00',3.01),('8348','2013-08-21','11:55:00',3.07),('8348','2013-08-21','12:00:00',3.36),('8348','2013-08-21','12:05:00',3.35),('8348','2013-08-21','12:10:00',3.34),('8348','2013-08-21','12:15:00',3.37),('8348','2013-08-21','12:20:00',3.22),('8348','2013-08-21','12:25:00',2.32),('8348','2013-08-21','12:30:00',1.94),('8348','2013-08-21','12:35:00',1.78),('8348','2013-08-21','12:40:00',2.91),('8348','2013-08-21','12:45:00',3.25),('8348','2013-08-21','12:50:00',3.23),('8348','2013-08-21','12:55:00',3.11),('8348','2013-08-21','13:00:00',3.27),('8348','2013-08-21','13:05:00',3.3),('8348','2013-08-21','13:10:00',3.32),('8348','2013-08-21','13:15:00',3.39),('8348','2013-08-21','13:20:00',3.4),('8348','2013-08-21','13:25:00',3.41),('8348','2013-08-21','13:30:00',3.4),('8348','2013-08-21','13:35:00',3.38),('8348','2013-08-21','13:40:00',3.2),('8348','2013-08-21','13:45:00',3.26),('8348','2013-08-21','13:50:00',3.27),('8348','2013-08-21','13:55:00',3.18),('8348','2013-08-21','14:00:00',2.99),('8348','2013-08-21','14:05:00',3.31),('8348','2013-08-21','14:10:00',3.36),('8348','2013-08-21','14:15:00',3.22),('8348','2013-08-21','14:20:00',2.12),('8348','2013-08-21','14:25:00',2.02),('8348','2013-08-21','14:30:00',2.96),('8348','2013-08-21','14:35:00',3),('8348','2013-08-21','14:40:00',3.04),('8348','2013-08-21','14:45:00',3.01),('8348','2013-08-21','14:50:00',2.9),('8348','2013-08-21','14:55:00',2.92),('8348','2013-08-21','15:00:00',3.03),('8348','2013-08-21','15:05:00',2.99),('8348','2013-08-21','15:10:00',2.88),('8348','2013-08-21','15:15:00',2.83),('8348','2013-08-21','15:20:00',2.78),('8348','2013-08-21','15:25:00',2.76),('8348','2013-08-21','15:30:00',2.69),('8348','2013-08-21','15:35:00',2.58),('8348','2013-08-21','15:40:00',2.45),('8348','2013-08-21','15:45:00',2.52),('8348','2013-08-21','15:50:00',2.56),('8348','2013-08-21','15:55:00',2.44),('8348','2013-08-21','16:00:00',2.32),('8348','2013-08-21','16:05:00',2.26),('8348','2013-08-21','16:10:00',2.22),('8348','2013-08-21','16:15:00',2.28),('8348','2013-08-21','16:20:00',2.4),('8348','2013-08-21','16:25:00',2.34),('8348','2013-08-21','16:30:00',2.48),('8348','2013-08-21','16:35:00',2.41),('8348','2013-08-21','16:40:00',2.33),('8348','2013-08-21','16:45:00',2.28),('8348','2013-08-21','16:50:00',2.22),('8348','2013-08-21','16:55:00',2.18),('8348','2013-08-21','17:00:00',2.13),('8348','2013-08-21','17:05:00',2.09),('8348','2013-08-21','17:10:00',2.04),('8348','2013-08-21','17:15:00',1.99),('8348','2013-08-21','17:20:00',1.99),('8348','2013-08-21','17:25:00',1.91),('8348','2013-08-21','17:30:00',1.83),('8348','2013-08-21','17:35:00',1.78),('8348','2013-08-21','17:40:00',1.72),('8348','2013-08-21','17:45:00',1.67),('8348','2013-08-21','17:50:00',1.64),('8348','2013-08-21','17:55:00',1.56),('8348','2013-08-21','18:00:00',1.49),('8348','2013-08-21','18:05:00',1.41),('8348','2013-08-21','18:10:00',1.3),('8348','2013-08-21','18:15:00',1.23),('8348','2013-08-21','18:20:00',1.13),('8348','2013-08-21','18:25:00',1.03),('8348','2013-08-20','09:20:00',1.01),('8348','2013-08-20','09:25:00',1.54),('8348','2013-08-20','09:30:00',2.06),('8348','2013-08-20','09:35:00',2.18),('8348','2013-08-20','09:40:00',2.43),('8348','2013-08-20','09:45:00',2.03),('8348','2013-08-20','09:50:00',1.7),('8348','2013-08-20','09:55:00',2.41),('8348','2013-08-20','10:00:00',2.9),('8348','2013-08-20','10:05:00',1.69),('8348','2013-08-20','10:10:00',1.43),('8348','2013-08-20','10:15:00',1.95),('8348','2013-08-20','10:20:00',1.81),('8348','2013-08-20','10:40:00',1.03),('8348','2013-08-20','10:45:00',2.08),('8348','2013-08-20','10:50:00',2.75),('8348','2013-08-20','10:55:00',2.43),('8348','2013-08-20','11:10:00',1.29),('8348','2013-08-20','11:15:00',3.1),('8348','2013-08-20','11:20:00',3.3),('8348','2013-08-20','11:25:00',2.81),('8348','2013-08-20','11:30:00',2.07),('8348','2013-08-20','11:35:00',3.11),('8348','2013-08-20','11:40:00',3.36),('8348','2013-08-20','11:45:00',3.43),('8348','2013-08-20','11:50:00',3.82),('8348','2013-08-20','11:55:00',3.71),('8348','2013-08-20','12:00:00',1.59),('8348','2013-08-20','12:05:00',1.25),('8348','2013-08-20','12:10:00',1.1),('8348','2013-08-20','12:30:00',1.25),('8348','2013-08-20','12:35:00',1.48),('8348','2013-08-20','12:40:00',1.61),('8348','2013-08-20','12:45:00',1.62),('8348','2013-08-20','12:50:00',1.65),('8348','2013-08-20','12:55:00',1.69),('8348','2013-08-20','13:00:00',1.67),('8348','2013-08-20','13:05:00',1.51),('8348','2013-08-20','13:10:00',1.45),('8348','2013-08-20','13:15:00',1.47),('8348','2013-08-20','13:20:00',1.53),('8348','2013-08-20','13:25:00',1.6),('8348','2013-08-20','13:30:00',1.76),('8348','2013-08-20','13:35:00',2.36),('8348','2013-08-20','13:40:00',3.52),('8348','2013-08-20','13:45:00',3.04),('8348','2013-08-20','13:50:00',3.77),('8348','2013-08-20','13:55:00',3.62),('8348','2013-08-20','14:00:00',3.58),('8348','2013-08-20','14:05:00',3.46),('8348','2013-08-20','14:10:00',3.02),('8348','2013-08-20','14:15:00',3.51),('8348','2013-08-20','14:20:00',3.54),('8348','2013-08-20','14:25:00',3.03),('8348','2013-08-20','14:30:00',2.86),('8348','2013-08-20','14:35:00',2.88),('8348','2013-08-20','14:40:00',3.36),('8348','2013-08-20','14:45:00',3.36),('8348','2013-08-20','14:50:00',3.44),('8348','2013-08-20','14:55:00',3.33),('8348','2013-08-20','15:00:00',2.94),('8348','2013-08-20','15:05:00',3.56),('8348','2013-08-20','15:10:00',3.46),('8348','2013-08-20','15:15:00',3.47),('8348','2013-08-20','15:20:00',3.4),('8348','2013-08-20','15:25:00',3.37),('8348','2013-08-20','15:30:00',3.35),('8348','2013-08-20','15:35:00',3.33),('8348','2013-08-20','15:40:00',3.39),('8348','2013-08-20','15:45:00',3.51),('8348','2013-08-20','15:50:00',3.64),('8348','2013-08-20','15:55:00',3.65),('8348','2013-08-20','16:00:00',3.47),('8348','2013-08-20','16:05:00',3.41),('8348','2013-08-20','16:10:00',3.36),('8348','2013-08-20','16:15:00',3.35),('8348','2013-08-20','16:20:00',3.3),('8348','2013-08-20','16:25:00',3.2),('8348','2013-08-20','16:30:00',2.88),('8348','2013-08-20','16:35:00',2.91),('8348','2013-08-20','16:40:00',3.02),('8348','2013-08-20','16:45:00',2.89),('8348','2013-08-20','16:50:00',2.73),('8348','2013-08-20','16:55:00',2.55),('8348','2013-08-20','17:00:00',2.39),('8348','2013-08-20','17:05:00',2.29),('8348','2013-08-20','17:10:00',2.21),('8348','2013-08-20','17:15:00',2.07),('8348','2013-08-20','17:20:00',2.04),('8348','2013-08-20','17:25:00',1.96),('8348','2013-08-20','17:30:00',1.9),('8348','2013-08-20','17:35:00',1.83),('8348','2013-08-20','17:40:00',1.76),('8348','2013-08-20','17:45:00',1.71),('8348','2013-08-20','17:50:00',1.56),('8348','2013-08-20','17:55:00',1.44),('8348','2013-08-20','18:00:00',1.32),('8348','2013-08-20','18:05:00',1.31),('8348','2013-08-20','18:10:00',1.32),('8348','2013-08-20','18:15:00',1.31),('8348','2013-08-20','18:20:00',1.28),('8348','2013-08-20','18:25:00',1.23),('8348','2013-08-20','18:30:00',1.21),('8348','2013-08-20','18:35:00',1.11),('8348','2014-04-10','07:05:00',1.06),('8348','2014-04-10','07:10:00',1.14),('8348','2014-04-10','07:15:00',1.24),('8348','2014-04-10','07:20:00',1.37),('8348','2014-04-10','07:25:00',1.63),('8348','2014-04-10','07:30:00',1.73),('8348','2014-04-10','07:35:00',1.84),('8348','2014-04-10','07:40:00',1.98),('8348','2014-04-10','07:45:00',2.13),('8348','2014-04-10','07:50:00',2.24),('8348','2014-04-10','07:55:00',2.32),('8348','2014-04-10','08:00:00',2.46),('8348','2014-04-10','08:05:00',2.68),('8348','2014-04-10','08:10:00',3.12),('8348','2014-04-10','08:15:00',3.31),('8348','2014-04-10','08:20:00',3.4),('8348','2014-04-10','08:25:00',3.71),('8348','2014-04-10','08:30:00',3.91),('8348','2014-04-10','08:35:00',4.09),('8348','2014-04-10','08:40:00',4.2),('8348','2014-04-10','08:45:00',4.34),('8348','2014-04-10','08:50:00',4.5),('8348','2014-04-10','08:55:00',4.64),('8348','2014-04-10','09:00:00',4.75),('8348','2014-04-10','09:05:00',4.85),('8348','2014-04-10','09:10:00',5.03),('8348','2014-04-10','09:15:00',5.06),('8348','2014-04-10','09:20:00',5.21),('8348','2014-04-10','09:25:00',5.29),('8348','2014-04-10','09:30:00',5.38),('8348','2014-04-10','09:35:00',5.6),('8348','2014-04-10','09:40:00',5.71),('8348','2014-04-10','09:45:00',5.74),('8348','2014-04-10','09:50:00',5.66),('8348','2014-04-10','09:55:00',5.83),('8348','2014-04-10','10:00:00',5.9),('8348','2014-04-10','10:05:00',6.11),('8348','2014-04-10','10:10:00',6.01),('8348','2014-04-10','10:15:00',6.24),('8348','2014-04-10','10:20:00',6.43),('8348','2014-04-10','10:25:00',6.57),('8348','2014-04-10','10:30:00',6.62),('8348','2014-04-10','10:35:00',6.7),('8348','2014-04-10','10:40:00',6.49),('8348','2014-04-10','10:45:00',6.71),('8348','2014-04-10','10:50:00',6.53),('8348','2014-04-10','10:55:00',6.85),('8348','2014-04-10','11:00:00',6.73),('8348','2014-04-10','11:05:00',6.36),('8348','2014-04-10','11:10:00',6.68),('8348','2014-04-10','11:15:00',6.73),('8348','2014-04-10','11:20:00',6.85),('8348','2014-04-10','11:25:00',6.52),('8348','2014-04-10','11:30:00',6.69),('8348','2014-04-10','11:35:00',7.08),('8348','2014-04-10','11:40:00',6.83),('8348','2014-04-10','11:45:00',7.01),('8348','2014-04-10','11:50:00',6.93),('8348','2014-04-10','11:55:00',6.89),('8348','2014-04-10','12:00:00',6.76),('8348','2014-04-10','12:05:00',6.6),('8348','2014-04-10','12:10:00',6.76),('8348','2014-04-10','12:15:00',6.73),('8348','2014-04-10','12:20:00',6.56),('8348','2014-04-10','12:25:00',7.11),('8348','2014-04-10','12:30:00',7.04),('8348','2014-04-10','12:35:00',7.2),('8348','2014-04-10','12:40:00',6.88),('8348','2014-04-10','12:45:00',7.21),('8348','2014-04-10','12:50:00',7.18),('8348','2014-04-10','12:55:00',7.14),('8348','2014-04-10','13:00:00',7.14),('8348','2014-04-10','13:05:00',7.07),('8348','2014-04-10','13:10:00',7.09),('8348','2014-04-10','13:15:00',7.1),('8348','2014-04-10','13:20:00',7.09),('8348','2014-04-10','13:25:00',6.99),('8348','2014-04-10','13:30:00',6.92),('8348','2014-04-10','13:35:00',6.89),('8348','2014-04-10','13:40:00',6.79),('8348','2014-04-10','13:45:00',6.17),('8348','2014-04-10','13:50:00',6.84),('8348','2014-04-10','13:55:00',6.78),('8348','2014-04-10','14:00:00',6.83),('8348','2014-04-10','14:05:00',6.77),('8348','2014-04-10','14:10:00',6.59),('8348','2014-04-10','14:15:00',6.55),('8348','2014-04-10','14:20:00',6.47),('8348','2014-04-10','14:25:00',6.41),('8348','2014-04-10','14:30:00',5.85),('8348','2014-04-10','14:35:00',5.69),('8348','2014-04-10','14:40:00',5.81),('8348','2014-04-10','14:45:00',5.81),('8348','2014-04-10','14:50:00',5.9),('8348','2014-04-10','14:55:00',5.86),('8348','2014-04-10','15:00:00',5.66),('8348','2014-04-10','15:05:00',5.78),('8348','2014-04-10','15:10:00',5.85),('8348','2014-04-10','15:15:00',6),('8348','2014-04-10','15:20:00',5.71),('8348','2014-04-10','15:25:00',5.69),('8348','2014-04-10','15:30:00',5.62),('8348','2014-04-10','15:35:00',5.44),('8348','2014-04-10','15:40:00',5.41),('8348','2014-04-10','15:45:00',5.39),('8348','2014-04-10','15:50:00',5.06),('8348','2014-04-10','15:55:00',4.91),('8348','2014-04-10','16:00:00',4.75),('8348','2014-04-10','16:05:00',4.63),('8348','2014-04-10','16:10:00',4.41),('8348','2014-04-10','16:15:00',4.19),('8348','2014-04-10','16:20:00',4.11),('8348','2014-04-10','16:25:00',3.9),('8348','2014-04-10','16:30:00',3.66),('8348','2014-04-10','16:35:00',3.52),('8348','2014-04-10','16:40:00',3.35),('8348','2014-04-10','16:45:00',3.18),('8348','2014-04-10','16:50:00',3),('8348','2014-04-10','16:55:00',2.82),('8348','2014-04-10','17:00:00',2.65),('8348','2014-04-10','17:05:00',2.47),('8348','2014-04-10','17:10:00',2.3),('8348','2014-04-10','17:15:00',2.14),('8348','2014-04-10','17:20:00',1.98),('8348','2014-04-10','17:25:00',1.8),('8348','2014-04-10','17:30:00',1.63),('8348','2014-04-10','17:35:00',1.41),('8348','2014-04-10','17:40:00',1.27),('8348','2014-04-10','17:45:00',1.06),('8348','2013-08-19','08:35:00',1.02),('8348','2013-08-19','08:40:00',1.08),('8348','2013-08-19','08:45:00',1.17),('8348','2013-08-19','08:50:00',1.27),('8348','2013-08-19','08:55:00',1.33),('8348','2013-08-19','09:00:00',1.44),('8348','2013-08-19','09:05:00',1.52),('8348','2013-08-19','09:10:00',1.58),('8348','2013-08-19','09:15:00',1.63),('8348','2013-08-19','09:20:00',1.7),('8348','2013-08-19','09:25:00',1.78),('8348','2013-08-19','09:30:00',1.85),('8348','2013-08-19','09:35:00',1.87),('8348','2013-08-19','09:40:00',1.94),('8348','2013-08-19','09:45:00',2.01),('8348','2013-08-19','09:50:00',2.06),('8348','2013-08-19','09:55:00',2.13),('8348','2013-08-19','10:00:00',2.18),('8348','2013-08-19','10:05:00',2.23),('8348','2013-08-19','10:10:00',2.28),('8348','2013-08-19','10:15:00',2.32),('8348','2013-08-19','10:20:00',2.38),('8348','2013-08-19','10:25:00',2.44),('8348','2013-08-19','10:30:00',2.5),('8348','2013-08-19','10:35:00',2.53),('8348','2013-08-19','10:40:00',2.57),('8348','2013-08-19','10:45:00',2.61),('8348','2013-08-19','10:50:00',2.64),('8348','2013-08-19','10:55:00',2.68),('8348','2013-08-19','11:00:00',2.68),('8348','2013-08-19','11:05:00',2.74),('8348','2013-08-19','11:10:00',2.78),('8348','2013-08-19','11:15:00',2.81),('8348','2013-08-19','11:20:00',2.85),('8348','2013-08-19','11:25:00',2.88),('8348','2013-08-19','11:30:00',2.91),('8348','2013-08-19','11:35:00',2.94),('8348','2013-08-19','11:40:00',2.95),('8348','2013-08-19','11:45:00',2.97),('8348','2013-08-19','11:50:00',3.01),('8348','2013-08-19','11:55:00',3),('8348','2013-08-19','12:00:00',3),('8348','2013-08-19','12:05:00',3.1),('8348','2013-08-19','12:10:00',3.12),('8348','2013-08-19','12:15:00',3.19),('8348','2013-08-19','12:20:00',3.21),('8348','2013-08-19','12:25:00',3.2),('8348','2013-08-19','12:30:00',3.23),('8348','2013-08-19','12:35:00',3.23),('8348','2013-08-19','12:40:00',3.23),('8348','2013-08-19','12:45:00',3.26),('8348','2013-08-19','12:50:00',3.27),('8348','2013-08-19','12:55:00',3.32),('8348','2013-08-19','13:00:00',3.34),('8348','2013-08-19','13:05:00',3.38),('8348','2013-08-19','13:10:00',3.38),('8348','2013-08-19','13:15:00',3.38),('8348','2013-08-19','13:20:00',3.41),('8348','2013-08-19','13:25:00',3.39),('8348','2013-08-19','13:30:00',3.42),('8348','2013-08-19','13:35:00',3.46),('8348','2013-08-19','13:40:00',3.45),('8348','2013-08-19','13:45:00',3.45),('8348','2013-08-19','13:50:00',3.46),('8348','2013-08-19','13:55:00',3.44),('8348','2013-08-19','14:00:00',3.41),('8348','2013-08-19','14:05:00',3.4),('8348','2013-08-19','14:10:00',3.41),('8348','2013-08-19','14:15:00',3.39),('8348','2013-08-19','14:20:00',3.4),('8348','2013-08-19','14:25:00',3.39),('8348','2013-08-19','14:30:00',3.41),('8348','2013-08-19','14:35:00',3.4),('8348','2013-08-19','14:40:00',3.37),('8348','2013-08-19','14:45:00',3.36),('8348','2013-08-19','14:50:00',3.33),('8348','2013-08-19','14:55:00',3.32),('8348','2013-08-19','15:00:00',3.29),('8348','2013-08-19','15:05:00',3.26),('8348','2013-08-19','15:10:00',3.23),('8348','2013-08-19','15:15:00',3.19),('8348','2013-08-19','15:20:00',3.17),('8348','2013-08-19','15:25:00',3.15),('8348','2013-08-19','15:30:00',3.11),('8348','2013-08-19','15:35:00',3.1),('8348','2013-08-19','15:40:00',3.07),('8348','2013-08-19','15:45:00',3.03),('8348','2013-08-19','15:50:00',2.98),('8348','2013-08-19','15:55:00',2.95),('8348','2013-08-19','16:00:00',2.9),('8348','2013-08-19','16:05:00',2.81),('8348','2013-08-19','16:10:00',2.74),('8348','2013-08-19','16:15:00',2.63),('8348','2013-08-19','16:20:00',2.71),('8348','2013-08-19','16:25:00',2.65),('8348','2013-08-19','16:30:00',2.6),('8348','2013-08-19','16:35:00',2.54),('8348','2013-08-19','16:40:00',2.48),('8348','2013-08-19','16:45:00',2.44),('8348','2013-08-19','16:50:00',2.38),('8348','2013-08-19','16:55:00',2.34),('8348','2013-08-19','17:00:00',2.27),('8348','2013-08-19','17:05:00',2.2),('8348','2013-08-19','17:10:00',2.14),('8348','2013-08-19','17:15:00',2.07),('8348','2013-08-19','17:20:00',2.01),('8348','2013-08-19','17:25:00',1.94),('8348','2013-08-19','17:30:00',1.87),('8348','2013-08-19','17:35:00',1.8),('8348','2013-08-19','17:40:00',1.74),('8348','2013-08-19','17:45:00',1.67),('8348','2013-08-19','17:50:00',1.59),('8348','2013-08-19','17:55:00',1.52),('8348','2013-08-19','18:00:00',1.45),('8348','2013-08-19','18:05:00',1.37),('8348','2013-08-19','18:10:00',1.3),('8348','2013-08-19','18:15:00',1.22),('8348','2013-08-19','18:20:00',1.14),('8348','2013-08-19','18:25:00',1.06),('8348','2013-08-18','08:30:00',1.01),('8348','2013-08-18','08:35:00',1.07),('8348','2013-08-18','08:40:00',1.14),('8348','2013-08-18','08:45:00',1.22),('8348','2013-08-18','08:50:00',1.32),('8348','2013-08-18','08:55:00',1.39),('8348','2013-08-18','09:00:00',1.47),('8348','2013-08-18','09:05:00',1.56),('8348','2013-08-18','09:10:00',1.63),('8348','2013-08-18','09:15:00',1.7),('8348','2013-08-18','09:20:00',1.76),('8348','2013-08-18','09:25:00',1.83),('8348','2013-08-18','09:30:00',1.91),('8348','2013-08-18','09:35:00',1.96),('8348','2013-08-18','09:40:00',2.05),('8348','2013-08-18','09:45:00',1.96),('8348','2013-08-18','09:50:00',2.11),('8348','2013-08-18','09:55:00',1.61),('8348','2013-08-18','10:00:00',2.16),('8348','2013-08-18','10:05:00',1.8),('8348','2013-08-18','10:10:00',2.22),('8348','2013-08-18','10:15:00',2.39),('8348','2013-08-18','10:20:00',2.43),('8348','2013-08-18','10:25:00',2.47),('8348','2013-08-18','10:30:00',2.51),('8348','2013-08-18','10:35:00',2.54),('8348','2013-08-18','10:40:00',2.56),('8348','2013-08-18','10:45:00',2.62),('8348','2013-08-18','10:50:00',2.65),('8348','2013-08-18','10:55:00',2.59),('8348','2013-08-18','11:00:00',2.65),('8348','2013-08-18','11:05:00',2.77),('8348','2013-08-18','11:10:00',2.8),('8348','2013-08-18','11:15:00',2.83),('8348','2013-08-18','11:20:00',2.86),('8348','2013-08-18','11:25:00',2.86),('8348','2013-08-18','11:30:00',2.87),('8348','2013-08-18','11:35:00',2.9),('8348','2013-08-18','11:40:00',2.95),('8348','2013-08-18','11:45:00',3),('8348','2013-08-18','11:50:00',3),('8348','2013-08-18','11:55:00',3.02),('8348','2013-08-18','12:00:00',3.01),('8348','2013-08-18','12:05:00',2.98),('8348','2013-08-18','12:10:00',3.06),('8348','2013-08-18','12:15:00',3.26),('8348','2013-08-18','12:20:00',3.33),('8348','2013-08-18','12:25:00',2.9),('8348','2013-08-18','12:30:00',2.11),('8348','2013-08-18','12:45:00',2.69),('8348','2013-08-18','12:50:00',2.38),('8348','2013-08-18','12:55:00',1.28),('8348','2013-08-18','13:00:00',1.6),('8348','2013-08-18','13:05:00',3.59),('8348','2013-08-18','13:10:00',3.53),('8348','2013-08-18','13:15:00',3.31),('8348','2013-08-18','13:20:00',3.44),('8348','2013-08-18','13:25:00',3.38),('8348','2013-08-18','13:30:00',3.38),('8348','2013-08-18','13:35:00',3.36),('8348','2013-08-18','13:40:00',3.41),('8348','2013-08-18','13:45:00',2.98),('8348','2013-08-18','13:50:00',3.46),('8348','2013-08-18','13:55:00',3.39),('8348','2013-08-18','14:00:00',3.48),('8348','2013-08-18','14:05:00',3.43),('8348','2013-08-18','14:10:00',3.41),('8348','2013-08-18','14:15:00',3.39),('8348','2013-08-18','14:20:00',3.4),('8348','2013-08-18','14:25:00',3.37),('8348','2013-08-18','14:30:00',3.38),('8348','2013-08-18','14:35:00',3.37),('8348','2013-08-18','14:40:00',3.34),('8348','2013-08-18','14:45:00',3.32),('8348','2013-08-18','14:50:00',3.32),('8348','2013-08-18','14:55:00',3.3),('8348','2013-08-18','15:00:00',3.29),('8348','2013-08-18','15:05:00',3.25),('8348','2013-08-18','15:10:00',3.23),('8348','2013-08-18','15:15:00',3.2),('8348','2013-08-18','15:20:00',3.16),('8348','2013-08-18','15:25:00',3.13),('8348','2013-08-18','15:30:00',3.1),('8348','2013-08-18','15:35:00',3.07),('8348','2013-08-18','15:40:00',3.05),('8348','2013-08-18','15:45:00',3),('8348','2013-08-18','15:50:00',2.95),('8348','2013-08-18','15:55:00',2.91),('8348','2013-08-18','16:00:00',2.88),('8348','2013-08-18','16:05:00',2.84),('8348','2013-08-18','16:10:00',2.78),('8348','2013-08-18','16:15:00',2.75),('8348','2013-08-18','16:20:00',2.69),('8348','2013-08-18','16:25:00',2.64),('8348','2013-08-18','16:30:00',2.59),('8348','2013-08-18','16:35:00',2.56),('8348','2013-08-18','16:40:00',2.49),('8348','2013-08-18','16:45:00',2.43),('8348','2013-08-18','16:50:00',2.38),('8348','2013-08-18','16:55:00',2.32),('8348','2013-08-18','17:00:00',2.28),('8348','2013-08-18','17:05:00',2.22),('8348','2013-08-18','17:10:00',2.15),('8348','2013-08-18','17:15:00',2.09),('8348','2013-08-18','17:20:00',2.03),('8348','2013-08-18','17:25:00',1.97),('8348','2013-08-18','17:30:00',1.89),('8348','2013-08-18','17:35:00',1.82),('8348','2013-08-18','17:40:00',1.75),('8348','2013-08-18','17:45:00',1.67),('8348','2013-08-18','17:50:00',1.6),('8348','2013-08-18','17:55:00',1.52),('8348','2013-08-18','18:00:00',1.44),('8348','2013-08-18','18:05:00',1.38),('8348','2013-08-18','18:10:00',1.31),('8348','2013-08-18','18:15:00',1.23),('8348','2013-08-18','18:20:00',1.15),('8348','2013-08-18','18:25:00',1.07),('8348','2013-08-17','08:35:00',1.04),('8348','2013-08-17','08:40:00',1.13),('8348','2013-08-17','08:45:00',1.21),('8348','2013-08-17','08:50:00',1.31),('8348','2013-08-17','08:55:00',1.39),('8348','2013-08-17','09:00:00',1.48),('8348','2013-08-17','09:05:00',1.56),('8348','2013-08-17','09:10:00',1.62),('8348','2013-08-17','09:15:00',1.68),('8348','2013-08-17','09:20:00',1.74),('8348','2013-08-17','09:25:00',1.81),('8348','2013-08-17','09:30:00',1.88),('8348','2013-08-17','09:35:00',1.94),('8348','2013-08-17','09:40:00',2),('8348','2013-08-17','09:45:00',2.06),('8348','2013-08-17','09:50:00',2.11),('8348','2013-08-17','09:55:00',2.16),('8348','2013-08-17','10:00:00',2.22),('8348','2013-08-17','10:05:00',2.27),('8348','2013-08-17','10:10:00',2.32),('8348','2013-08-17','10:15:00',2.36),('8348','2013-08-17','10:20:00',2.42),('8348','2013-08-17','10:25:00',2.46),('8348','2013-08-17','10:30:00',2.51),('8348','2013-08-17','10:35:00',2.57),('8348','2013-08-17','10:40:00',2.61),('8348','2013-08-17','10:45:00',2.65),('8348','2013-08-17','10:50:00',2.69),('8348','2013-08-17','10:55:00',2.72),('8348','2013-08-17','11:00:00',2.75),('8348','2013-08-17','11:05:00',2.8),('8348','2013-08-17','11:10:00',2.83),('8348','2013-08-17','11:15:00',2.83),('8348','2013-08-17','11:20:00',2.87),('8348','2013-08-17','11:25:00',2.9),('8348','2013-08-17','11:30:00',2.94),('8348','2013-08-17','11:35:00',2.97),('8348','2013-08-17','11:40:00',3.03),('8348','2013-08-17','11:45:00',3.08),('8348','2013-08-17','11:50:00',3.13),('8348','2013-08-17','11:55:00',3.08),('8348','2013-08-17','12:00:00',3.09),('8348','2013-08-17','12:05:00',3.14),('8348','2013-08-17','12:10:00',3.15),('8348','2013-08-17','12:15:00',2.96),('8348','2013-08-17','12:20:00',1.98),('8348','2013-08-17','12:25:00',3.17),('8348','2013-08-17','12:30:00',3.29),('8348','2013-08-17','12:35:00',2.52),('8348','2013-08-17','12:40:00',1.57),('8348','2013-08-17','12:45:00',3.44),('8348','2013-08-17','12:50:00',3.43),('8348','2013-08-17','12:55:00',3.4),('8348','2013-08-17','13:00:00',3.48),('8348','2013-08-17','13:05:00',3.47),('8348','2013-08-17','13:10:00',3.41),('8348','2013-08-17','13:15:00',3.39),('8348','2013-08-17','13:20:00',3.47),('8348','2013-08-17','13:25:00',3.44),('8348','2013-08-17','13:30:00',3.53),('8348','2013-08-17','13:35:00',2.75),('8348','2013-08-17','13:45:00',2.17),('8348','2013-08-17','13:55:00',2.47),('8348','2013-08-17','14:00:00',3.68),('8348','2013-08-17','14:05:00',2.56),('8348','2013-08-17','14:10:00',3.52),('8348','2013-08-17','14:15:00',3.22),('8348','2013-08-17','14:20:00',3.41),('8348','2013-08-17','14:25:00',3.39),('8348','2013-08-17','14:30:00',3.37),('8348','2013-08-17','14:35:00',3.34),('8348','2013-08-17','14:40:00',3.31),('8348','2013-08-17','14:45:00',3.35),('8348','2013-08-17','14:50:00',3.32),('8348','2013-08-17','14:55:00',3.25),('8348','2013-08-17','15:00:00',3.28),('8348','2013-08-17','15:05:00',3.26),('8348','2013-08-17','15:10:00',3.22),('8348','2013-08-17','15:15:00',3.18),('8348','2013-08-17','15:20:00',3.19),('8348','2013-08-17','15:25:00',3.13),('8348','2013-08-17','15:30:00',3.11),('8348','2013-08-17','15:35:00',3.11),('8348','2013-08-17','15:40:00',3.07),('8348','2013-08-17','15:45:00',3.01),('8348','2013-08-17','15:50:00',2.97),('8348','2013-08-17','15:55:00',2.95),('8348','2013-08-17','16:00:00',2.92),('8348','2013-08-17','16:05:00',2.85),('8348','2013-08-17','16:10:00',2.82),('8348','2013-08-17','16:15:00',2.79),('8348','2013-08-17','16:20:00',2.74),('8348','2013-08-17','16:25:00',2.69),('8348','2013-08-17','16:30:00',2.67),('8348','2013-08-17','16:35:00',2.63),('8348','2013-08-17','16:40:00',2.55),('8348','2013-08-17','16:45:00',2.46),('8348','2013-08-17','16:50:00',2.39),('8348','2013-08-17','16:55:00',2.39),('8348','2013-08-17','17:00:00',2.33),('8348','2013-08-17','17:05:00',2.25),('8348','2013-08-17','17:10:00',2.13),('8348','2013-08-17','17:15:00',1.92),('8348','2013-08-17','17:20:00',1.99),('8348','2013-08-17','17:25:00',2.03),('8348','2013-08-17','17:30:00',2),('8348','2013-08-17','17:35:00',1.94),('8348','2013-08-17','17:40:00',1.86),('8348','2013-08-17','17:45:00',1.78),('8348','2013-08-17','17:50:00',1.68),('8348','2013-08-17','17:55:00',1.62),('8348','2013-08-17','18:00:00',1.54),('8348','2013-08-17','18:05:00',1.46),('8348','2013-08-17','18:10:00',1.37),('8348','2013-08-17','18:15:00',1.28),('8348','2013-08-17','18:20:00',1.21),('8348','2013-08-17','18:25:00',1.13),('8348','2013-08-17','18:30:00',1.05),('8348','2013-08-16','08:30:00',1.03),('8348','2013-08-16','08:35:00',1.07),('8348','2013-08-16','08:40:00',1.18),('8348','2013-08-16','08:45:00',1.26),('8348','2013-08-16','08:50:00',1.34),('8348','2013-08-16','08:55:00',1.43),('8348','2013-08-16','09:00:00',1.53),('8348','2013-08-16','09:05:00',1.6),('8348','2013-08-16','09:10:00',1.68),('8348','2013-08-16','09:15:00',1.75),('8348','2013-08-16','09:20:00',1.82),('8348','2013-08-16','09:25:00',1.89),('8348','2013-08-16','09:30:00',1.96),('8348','2013-08-16','09:35:00',2.03),('8348','2013-08-16','09:40:00',2.09),('8348','2013-08-16','09:45:00',2.15),('8348','2013-08-16','09:50:00',2.21),('8348','2013-08-16','09:55:00',2.27),('8348','2013-08-16','10:00:00',2.32),('8348','2013-08-16','10:05:00',2.37),('8348','2013-08-16','10:10:00',2.44),('8348','2013-08-16','10:15:00',2.49),('8348','2013-08-16','10:20:00',2.54),('8348','2013-08-16','10:25:00',2.59),('8348','2013-08-16','10:30:00',2.64),('8348','2013-08-16','10:35:00',2.69),('8348','2013-08-16','10:40:00',2.73),('8348','2013-08-16','10:45:00',2.77),('8348','2013-08-16','10:50:00',2.8),('8348','2013-08-16','10:55:00',2.84),('8348','2013-08-16','11:00:00',2.89),('8348','2013-08-16','11:05:00',2.92),('8348','2013-08-16','11:10:00',2.96),('8348','2013-08-16','11:15:00',2.98),('8348','2013-08-16','11:20:00',3.01),('8348','2013-08-16','11:25:00',3.03),('8348','2013-08-16','11:30:00',3.05),('8348','2013-08-16','11:35:00',3.09),('8348','2013-08-16','11:40:00',3.11),('8348','2013-08-16','11:45:00',3.12),('8348','2013-08-16','11:50:00',3.14),('8348','2013-08-16','11:55:00',3.15),('8348','2013-08-16','12:00:00',3.17),('8348','2013-08-16','12:05:00',3.2),('8348','2013-08-16','12:10:00',3.23),('8348','2013-08-16','12:15:00',3.23),('8348','2013-08-16','12:20:00',3.25),('8348','2013-08-16','12:25:00',3.26),('8348','2013-08-16','12:30:00',3.28),('8348','2013-08-16','12:35:00',3.28),('8348','2013-08-16','12:40:00',3.28),('8348','2013-08-16','12:45:00',3.29),('8348','2013-08-16','12:50:00',3.28),('8348','2013-08-16','12:55:00',3.29),('8348','2013-08-16','13:00:00',3.31),('8348','2013-08-16','13:05:00',3.3),('8348','2013-08-16','13:10:00',3.3),('8348','2013-08-16','13:15:00',3.29),('8348','2013-08-16','13:20:00',3.32),('8348','2013-08-16','13:25:00',3.32),('8348','2013-08-16','13:30:00',3.33),('8348','2013-08-16','13:35:00',3.33),('8348','2013-08-16','13:40:00',3.31),('8348','2013-08-16','13:45:00',3.31),('8348','2013-08-16','13:50:00',3.31),('8348','2013-08-16','13:55:00',3.3),('8348','2013-08-16','14:00:00',3.29),('8348','2013-08-16','14:05:00',3.28),('8348','2013-08-16','14:10:00',3.26),('8348','2013-08-16','14:15:00',3.26),('8348','2013-08-16','14:20:00',3.26),('8348','2013-08-16','14:25:00',3.24),('8348','2013-08-16','14:30:00',3.21),('8348','2013-08-16','14:35:00',3.18),('8348','2013-08-16','14:40:00',3.18),('8348','2013-08-16','14:45:00',3.19),('8348','2013-08-16','14:50:00',3.19),('8348','2013-08-16','14:55:00',3.15),('8348','2013-08-16','15:00:00',3.1),('8348','2013-08-16','15:05:00',3.11),('8348','2013-08-16','15:10:00',3.15),('8348','2013-08-16','15:15:00',3.12),('8348','2013-08-16','15:20:00',3.12),('8348','2013-08-16','15:25:00',3.13),('8348','2013-08-16','15:30:00',3.11),('8348','2013-08-16','15:35:00',3.08),('8348','2013-08-16','15:40:00',3.02),('8348','2013-08-16','15:45:00',3.01),('8348','2013-08-16','15:50:00',2.99),('8348','2013-08-16','15:55:00',2.95),('8348','2013-08-16','16:00:00',2.91),('8348','2013-08-16','16:05:00',2.88),('8348','2013-08-16','16:10:00',2.83),('8348','2013-08-16','16:15:00',2.77),('8348','2013-08-16','16:20:00',2.72),('8348','2013-08-16','16:25:00',2.68),('8348','2013-08-16','16:30:00',2.64),('8348','2013-08-16','16:35:00',2.6),('8348','2013-08-16','16:40:00',2.55),('8348','2013-08-16','16:45:00',2.49),('8348','2013-08-16','16:50:00',2.43),('8348','2013-08-16','16:55:00',2.37),('8348','2013-08-16','17:00:00',2.3),('8348','2013-08-16','17:05:00',2.24),('8348','2013-08-16','17:10:00',2.17),('8348','2013-08-16','17:15:00',2.1),('8348','2013-08-16','17:20:00',2.04),('8348','2013-08-16','17:25:00',1.97),('8348','2013-08-16','17:30:00',1.89),('8348','2013-08-16','17:35:00',1.83),('8348','2013-08-16','17:40:00',1.77),('8348','2013-08-16','17:45:00',1.69),('8348','2013-08-16','17:50:00',1.62),('8348','2013-08-16','17:55:00',1.54),('8348','2013-08-16','18:00:00',1.46),('8348','2013-08-16','18:05:00',1.39),('8348','2013-08-16','18:10:00',1.32),('8348','2013-08-16','18:15:00',1.25),('8348','2013-08-16','18:20:00',1.18),('8348','2013-08-16','18:25:00',1.1),('8348','2013-08-15','08:30:00',1.06),('8348','2013-08-15','08:35:00',1.1),('8348','2013-08-15','08:40:00',1.2),('8348','2013-08-15','08:45:00',1.3),('8348','2013-08-15','08:50:00',1.37),('8348','2013-08-15','08:55:00',1.47),('8348','2013-08-15','09:00:00',1.63),('8348','2013-08-15','09:05:00',1.56),('8348','2013-08-15','09:10:00',1.57),('8348','2013-08-15','09:15:00',1.5),('8348','2013-08-15','09:20:00',1.9),('8348','2013-08-15','09:25:00',1.85),('8348','2013-08-15','09:30:00',1.95),('8348','2013-08-15','09:35:00',2.02),('8348','2013-08-15','09:40:00',2.09),('8348','2013-08-15','09:45:00',2.16),('8348','2013-08-15','09:50:00',2.21),('8348','2013-08-15','09:55:00',2.27),('8348','2013-08-15','10:00:00',2.33),('8348','2013-08-15','10:05:00',2.39),('8348','2013-08-15','10:10:00',2.44),('8348','2013-08-15','10:15:00',2.49),('8348','2013-08-15','10:20:00',2.55),('8348','2013-08-15','10:25:00',2.61),('8348','2013-08-15','10:30:00',2.66),('8348','2013-08-15','10:35:00',2.69),('8348','2013-08-15','10:40:00',2.73),('8348','2013-08-15','10:45:00',2.79),('8348','2013-08-15','10:50:00',2.78),('8348','2013-08-15','10:55:00',2.58),('8348','2013-08-15','11:00:00',2.38),('8348','2013-08-15','11:05:00',2.57),('8348','2013-08-15','11:10:00',1.98),('8348','2013-08-15','11:15:00',1.95),('8348','2013-08-15','11:20:00',2.27),('8348','2013-08-15','11:25:00',2.7),('8348','2013-08-15','11:30:00',2.99),('8348','2013-08-15','11:35:00',3.24),('8348','2013-08-15','11:40:00',3.32),('8348','2013-08-15','11:45:00',3.4),('8348','2013-08-15','11:50:00',3.44),('8348','2013-08-15','11:55:00',3.46),('8348','2013-08-15','12:00:00',3.46),('8348','2013-08-15','12:05:00',3.43),('8348','2013-08-15','12:10:00',3.42),('8348','2013-08-15','12:15:00',3.4),('8348','2013-08-15','12:20:00',3.45),('8348','2013-08-15','12:25:00',3.44),('8348','2013-08-15','12:30:00',3.44),('8348','2013-08-15','12:35:00',3.46),('8348','2013-08-15','12:40:00',3.45),('8348','2013-08-15','12:45:00',3.45),('8348','2013-08-15','12:50:00',3.43),('8348','2013-08-15','12:55:00',3.35),('8348','2013-08-15','13:00:00',3.25),('8348','2013-08-15','13:05:00',3.33),('8348','2013-08-15','13:10:00',3.32),('8348','2013-08-15','13:15:00',3.28),('8348','2013-08-15','13:20:00',3.25),('8348','2013-08-15','13:25:00',3.33),('8348','2013-08-15','13:30:00',3.42),('8348','2013-08-15','13:35:00',3.47),('8348','2013-08-15','13:40:00',3.46),('8348','2013-08-15','13:45:00',3.43),('8348','2013-08-15','13:50:00',3.39),('8348','2013-08-15','13:55:00',3.33),('8348','2013-08-15','14:00:00',3.32),('8348','2013-08-15','14:05:00',3.34),('8348','2013-08-15','14:10:00',3.35),('8348','2013-08-15','14:15:00',3.37),('8348','2013-08-15','14:20:00',3.37),('8348','2013-08-15','14:25:00',3.33),('8348','2013-08-15','14:30:00',3.26),('8348','2013-08-15','14:35:00',3.28),('8348','2013-08-15','14:40:00',3.25),('8348','2013-08-15','14:45:00',3.24),('8348','2013-08-15','14:50:00',3.21),('8348','2013-08-15','14:55:00',3.15),('8348','2013-08-15','15:00:00',3.11),('8348','2013-08-15','15:05:00',3.1),('8348','2013-08-15','15:10:00',3.1),('8348','2013-08-15','15:15:00',3.09),('8348','2013-08-15','15:20:00',3.05),('8348','2013-08-15','15:25:00',3),('8348','2013-08-15','15:30:00',2.99),('8348','2013-08-15','15:35:00',2.96),('8348','2013-08-15','15:40:00',2.91),('8348','2013-08-15','15:45:00',2.86),('8348','2013-08-15','15:50:00',2.81),('8348','2013-08-15','15:55:00',2.78),('8348','2013-08-15','16:00:00',2.75),('8348','2013-08-15','16:05:00',2.7),('8348','2013-08-15','16:10:00',2.63),('8348','2013-08-15','16:15:00',2.6),('8348','2013-08-15','16:20:00',2.62),('8348','2013-08-15','16:25:00',2.54),('8348','2013-08-15','16:30:00',2.46),('8348','2013-08-15','16:35:00',2.35),('8348','2013-08-15','16:40:00',2.36),('8348','2013-08-15','16:45:00',2.32),('8348','2013-08-15','16:50:00',2.25),('8348','2013-08-15','16:55:00',2.18),('8348','2013-08-15','17:00:00',2.15),('8348','2013-08-15','17:05:00',2.11),('8348','2013-08-15','17:10:00',2.04),('8348','2013-08-15','17:15:00',2.02),('8348','2013-08-15','17:20:00',1.96),('8348','2013-08-15','17:25:00',1.84),('8348','2013-08-15','17:30:00',1.82),('8348','2013-08-15','17:35:00',1.74),('8348','2013-08-15','17:40:00',1.67),('8348','2013-08-15','17:45:00',1.6),('8348','2013-08-15','17:50:00',1.53),('8348','2013-08-15','17:55:00',1.47),('8348','2013-08-15','18:00:00',1.41),('8348','2013-08-15','18:05:00',1.33),('8348','2013-08-15','18:10:00',1.23),('8348','2013-08-15','18:15:00',1.17),('8348','2013-08-15','18:20:00',1.12),('8348','2013-08-15','18:25:00',1.04),('8348','2013-08-14','08:30:00',1.01),('8348','2013-08-14','08:35:00',1.08),('8348','2013-08-14','08:40:00',1.26),('8348','2013-08-14','08:45:00',1.27),('8348','2013-08-14','08:50:00',1.25),('8348','2013-08-14','08:55:00',1.35),('8348','2013-08-14','09:00:00',1.55),('8348','2013-08-14','09:05:00',1.64),('8348','2013-08-14','09:10:00',1.69),('8348','2013-08-14','09:15:00',1.79),('8348','2013-08-14','09:20:00',1.86),('8348','2013-08-14','09:25:00',1.82),('8348','2013-08-14','09:30:00',2),('8348','2013-08-14','09:35:00',2.16),('8348','2013-08-14','09:40:00',1.55),('8348','2013-08-14','09:45:00',1.5),('8348','2013-08-14','09:55:00',1.42),('8348','2013-08-14','10:00:00',2.46),('8348','2013-08-14','10:05:00',2.29),('8348','2013-08-14','10:10:00',2.33),('8348','2013-08-14','10:15:00',2.29),('8348','2013-08-14','10:20:00',2.31),('8348','2013-08-14','10:25:00',2.74),('8348','2013-08-14','10:30:00',2.9),('8348','2013-08-14','10:35:00',2.86),('8348','2013-08-14','10:40:00',1.5),('8348','2013-08-14','10:55:00',1.01),('8348','2013-08-14','11:00:00',1.8),('8348','2013-08-14','11:05:00',2.37),('8348','2013-08-14','11:10:00',2.9),('8348','2013-08-14','11:15:00',2.93),('8348','2013-08-14','11:20:00',2.79),('8348','2013-08-14','11:25:00',2.81),('8348','2013-08-14','11:30:00',3.4),('8348','2013-08-14','11:35:00',2.79),('8348','2013-08-14','11:40:00',2.62),('8348','2013-08-14','11:45:00',1.28),('8348','2013-08-14','11:50:00',1.93),('8348','2013-08-14','11:55:00',2.26),('8348','2013-08-14','12:00:00',2.29),('8348','2013-08-14','12:05:00',2.74),('8348','2013-08-14','12:10:00',1.4),('8348','2013-08-14','12:15:00',1.16),('8348','2013-08-14','12:20:00',1.03),('8348','2013-08-14','12:25:00',1.75),('8348','2013-08-14','12:30:00',2.51),('8348','2013-08-14','12:35:00',1.14),('8348','2013-08-14','12:40:00',1.16),('8348','2013-08-14','12:45:00',1.19),('8348','2013-08-14','12:50:00',1.64),('8348','2013-08-14','12:55:00',1.71),('8348','2013-08-14','13:00:00',1.75),('8348','2013-08-14','13:15:00',1.02),('8348','2013-08-14','13:25:00',1.58),('8348','2013-08-14','13:30:00',3.49),('8348','2013-08-14','13:35:00',1.64),('8348','2013-08-14','13:40:00',2.09),('8348','2013-08-14','13:45:00',3.86),('8348','2013-08-14','13:50:00',3.88),('8348','2013-08-14','13:55:00',1.82),('8348','2013-08-14','14:00:00',2.41),('8348','2013-08-14','14:05:00',4),('8348','2013-08-14','14:10:00',3.83),('8348','2013-08-14','14:15:00',3.68),('8348','2013-08-14','14:20:00',3.62),('8348','2013-08-14','14:25:00',2.23),('8348','2013-08-14','14:30:00',3.76),('8348','2013-08-14','14:35:00',3.65),('8348','2013-08-14','14:40:00',3.5),('8348','2013-08-14','14:45:00',3.43),('8348','2013-08-14','14:50:00',3.52),('8348','2013-08-14','14:55:00',3.2),('8348','2013-08-14','15:00:00',3.31),('8348','2013-08-14','15:05:00',3.32),('8348','2013-08-14','15:10:00',3.22),('8348','2013-08-14','15:15:00',3.35),('8348','2013-08-14','15:20:00',3.32),('8348','2013-08-14','15:25:00',3.25),('8348','2013-08-14','15:30:00',3.16),('8348','2013-08-14','15:35:00',3.09),('8348','2013-08-14','15:40:00',3.11),('8348','2013-08-14','15:45:00',3.05),('8348','2013-08-14','15:50:00',3.01),('8348','2013-08-14','15:55:00',2.97),('8348','2013-08-14','16:00:00',2.94),('8348','2013-08-14','16:05:00',2.91),('8348','2013-08-14','16:10:00',2.89),('8348','2013-08-14','16:15:00',2.86),('8348','2013-08-14','16:20:00',2.81),('8348','2013-08-14','16:25:00',2.76),('8348','2013-08-14','16:30:00',2.7),('8348','2013-08-14','16:35:00',2.66),('8348','2013-08-14','16:40:00',2.6),('8348','2013-08-14','16:45:00',2.55),('8348','2013-08-14','16:50:00',2.48),('8348','2013-08-14','16:55:00',2.43),('8348','2013-08-14','17:00:00',2.35),('8348','2013-08-14','17:05:00',2.28),('8348','2013-08-14','17:10:00',2.23),('8348','2013-08-14','17:15:00',2.15),('8348','2013-08-14','17:20:00',2.08),('8348','2013-08-14','17:25:00',2.02),('8348','2013-08-14','17:30:00',1.95),('8348','2013-08-14','17:35:00',1.89),('8348','2013-08-14','17:40:00',1.83),('8348','2013-08-14','17:45:00',1.75),('8348','2013-08-14','17:50:00',1.68),('8348','2013-08-14','17:55:00',1.6),('8348','2013-08-14','18:00:00',1.52),('8348','2013-08-14','18:05:00',1.45),('8348','2013-08-14','18:10:00',1.35),('8348','2013-08-14','18:15:00',1.27),('8348','2013-08-14','18:20:00',1.24),('8348','2013-08-14','18:25:00',1.24),('8348','2013-08-14','18:30:00',1.17),('8348','2013-08-14','18:35:00',1.03),('8348','2013-08-13','08:30:00',1.07),('8348','2013-08-13','08:35:00',1.12),('8348','2013-08-13','08:40:00',1.19),('8348','2013-08-13','08:45:00',1.3),('8348','2013-08-13','08:50:00',1.37),('8348','2013-08-13','08:55:00',1.47),('8348','2013-08-13','09:00:00',1.56),('8348','2013-08-13','09:05:00',1.62),('8348','2013-08-13','09:10:00',1.69),('8348','2013-08-13','09:15:00',1.74),('8348','2013-08-13','09:20:00',1.79),('8348','2013-08-13','09:25:00',1.86),('8348','2013-08-13','09:30:00',1.93),('8348','2013-08-13','09:35:00',2),('8348','2013-08-13','09:40:00',2.03),('8348','2013-08-13','09:45:00',2.1),('8348','2013-08-13','09:50:00',2.19),('8348','2013-08-13','09:55:00',2.27),('8348','2013-08-13','10:00:00',2.31),('8348','2013-08-13','10:05:00',2.38),('8348','2013-08-13','10:10:00',2.38),('8348','2013-08-13','10:15:00',2.44),('8348','2013-08-13','10:20:00',2.47),('8348','2013-08-13','10:25:00',2.55),('8348','2013-08-13','10:30:00',2.61),('8348','2013-08-13','10:35:00',2.63),('8348','2013-08-13','10:40:00',2.68),('8348','2013-08-13','10:45:00',2.71),('8348','2013-08-13','10:50:00',2.74),('8348','2013-08-13','10:55:00',2.78),('8348','2013-08-13','11:00:00',2.82),('8348','2013-08-13','11:05:00',2.86),('8348','2013-08-13','11:10:00',2.88),('8348','2013-08-13','11:15:00',2.89),('8348','2013-08-13','11:20:00',2.95),('8348','2013-08-13','11:25:00',2.97),('8348','2013-08-13','11:30:00',3),('8348','2013-08-13','11:35:00',3),('8348','2013-08-13','11:40:00',3.05),('8348','2013-08-13','11:45:00',3.09),('8348','2013-08-13','11:50:00',3.13),('8348','2013-08-13','11:55:00',3.21),('8348','2013-08-13','12:00:00',3.24),('8348','2013-08-13','12:05:00',3.19),('8348','2013-08-13','12:10:00',3.29),('8348','2013-08-13','12:15:00',3.08),('8348','2013-08-13','12:20:00',2.48),('8348','2013-08-13','12:25:00',3.46),('8348','2013-08-13','12:30:00',3.53),('8348','2013-08-13','12:35:00',3.51),('8348','2013-08-13','12:40:00',2.3),('8348','2013-08-13','12:45:00',3.45),('8348','2013-08-13','12:50:00',2.86),('8348','2013-08-13','12:55:00',1.1),('8348','2013-08-13','13:00:00',1.03),('8348','2013-08-13','13:05:00',1.19),('8348','2013-08-13','13:10:00',3.5),('8348','2013-08-13','13:15:00',3.04),('8348','2013-08-13','13:20:00',3.01),('8348','2013-08-13','13:25:00',3.81),('8348','2013-08-13','13:30:00',3.8),('8348','2013-08-13','13:35:00',3.75),('8348','2013-08-13','13:40:00',3.78),('8348','2013-08-13','13:45:00',1.67),('8348','2013-08-13','13:50:00',1.6),('8348','2013-08-13','13:55:00',2.67),('8348','2013-08-13','14:00:00',3.86),('8348','2013-08-13','14:05:00',3.75),('8348','2013-08-13','14:10:00',3.7),('8348','2013-08-13','14:15:00',3.69),('8348','2013-08-13','14:20:00',3.3),('8348','2013-08-13','14:25:00',3.65),('8348','2013-08-13','14:30:00',3.1),('8348','2013-08-13','14:35:00',3.79),('8348','2013-08-13','14:40:00',2.58),('8348','2013-08-13','14:45:00',3.48),('8348','2013-08-13','14:50:00',3.16),('8348','2013-08-13','14:55:00',3.46),('8348','2013-08-13','15:00:00',3.43),('8348','2013-08-13','15:05:00',3.5),('8348','2013-08-13','15:10:00',3.21),('8348','2013-08-13','15:15:00',3.31),('8348','2013-08-13','15:20:00',3.18),('8348','2013-08-13','15:25:00',3.25),('8348','2013-08-13','15:30:00',3.21),('8348','2013-08-13','15:35:00',3.21),('8348','2013-08-13','15:40:00',3.1),('8348','2013-08-13','15:45:00',3.09),('8348','2013-08-13','15:50:00',3.02),('8348','2013-08-13','15:55:00',2.98),('8348','2013-08-13','16:00:00',2.95),('8348','2013-08-13','16:05:00',2.9),('8348','2013-08-13','16:10:00',2.85),('8348','2013-08-13','16:15:00',2.82),('8348','2013-08-13','16:20:00',2.79),('8348','2013-08-13','16:25:00',2.74),('8348','2013-08-13','16:30:00',2.67),('8348','2013-08-13','16:35:00',2.63),('8348','2013-08-13','16:40:00',2.59),('8348','2013-08-13','16:45:00',2.52),('8348','2013-08-13','16:50:00',2.46),('8348','2013-08-13','16:55:00',2.4),('8348','2013-08-13','17:00:00',2.34),('8348','2013-08-13','17:05:00',2.3),('8348','2013-08-13','17:10:00',2.23),('8348','2013-08-13','17:15:00',2.15),('8348','2013-08-13','17:20:00',2.09),('8348','2013-08-13','17:25:00',2.02),('8348','2013-08-13','17:30:00',1.94),('8348','2013-08-13','17:35:00',1.88),('8348','2013-08-13','17:40:00',1.83),('8348','2013-08-13','17:45:00',1.74),('8348','2013-08-13','17:50:00',1.68),('8348','2013-08-13','17:55:00',1.6),('8348','2013-08-13','18:00:00',1.53),('8348','2013-08-13','18:05:00',1.45),('8348','2013-08-13','18:10:00',1.37),('8348','2013-08-13','18:15:00',1.29),('8348','2013-08-13','18:20:00',1.23),('8348','2013-08-13','18:25:00',1.15),('8348','2013-08-13','18:30:00',1.06),('8348','2013-08-12','08:30:00',1.05),('8348','2013-08-12','08:35:00',1.12),('8348','2013-08-12','08:40:00',1.18),('8348','2013-08-12','08:45:00',1.29),('8348','2013-08-12','08:50:00',1.37),('8348','2013-08-12','08:55:00',1.45),('8348','2013-08-12','09:00:00',1.52),('8348','2013-08-12','09:05:00',1.59),('8348','2013-08-12','09:10:00',1.66),('8348','2013-08-12','09:15:00',1.72),('8348','2013-08-12','09:20:00',1.79),('8348','2013-08-12','09:25:00',1.85),('8348','2013-08-12','09:30:00',1.91),('8348','2013-08-12','09:35:00',1.97),('8348','2013-08-12','09:40:00',2.03),('8348','2013-08-12','09:45:00',2.08),('8348','2013-08-12','09:50:00',2.14),('8348','2013-08-12','09:55:00',2.19),('8348','2013-08-12','10:00:00',2.25),('8348','2013-08-12','10:05:00',2.29),('8348','2013-08-12','10:10:00',2.34),('8348','2013-08-12','10:15:00',2.38),('8348','2013-08-12','10:20:00',2.44),('8348','2013-08-12','10:25:00',2.51),('8348','2013-08-12','10:30:00',2.55),('8348','2013-08-12','10:35:00',2.57),('8348','2013-08-12','10:40:00',2.61),('8348','2013-08-12','10:45:00',2.64),('8348','2013-08-12','10:50:00',2.69),('8348','2013-08-12','10:55:00',2.73),('8348','2013-08-12','11:00:00',2.75),('8348','2013-08-12','11:05:00',2.75),('8348','2013-08-12','11:10:00',2.8),('8348','2013-08-12','11:15:00',2.83),('8348','2013-08-12','11:20:00',2.85),('8348','2013-08-12','11:25:00',2.89),('8348','2013-08-12','11:30:00',2.95),('8348','2013-08-12','11:35:00',3),('8348','2013-08-12','11:40:00',3.06),('8348','2013-08-12','11:45:00',3.11),('8348','2013-08-12','11:50:00',3.15),('8348','2013-08-12','11:55:00',3.11),('8348','2013-08-12','12:00:00',3.13),('8348','2013-08-12','12:05:00',3.3),('8348','2013-08-12','12:10:00',3.29),('8348','2013-08-12','12:15:00',2.94),('8348','2013-08-12','12:20:00',1.04),('8348','2013-08-12','12:25:00',1.08),('8348','2013-08-12','12:30:00',1.04),('8348','2013-08-12','12:35:00',2.83),('8348','2013-08-12','12:40:00',2.29),('8348','2013-08-12','12:45:00',2.06),('8348','2013-08-12','12:50:00',1.2),('8348','2013-08-12','13:20:00',1.02),('8348','2013-08-12','13:25:00',1.93),('8348','2013-08-12','13:30:00',1.18),('8348','2013-08-12','13:35:00',1.14),('8348','2013-08-12','13:40:00',1.01),('8348','2013-08-12','13:45:00',1.03),('8348','2013-08-12','13:50:00',3.02),('8348','2013-08-12','13:55:00',3.9),('8348','2013-08-12','14:00:00',2.55),('8348','2013-08-12','14:05:00',2.18),('8348','2013-08-12','14:10:00',2.49),('8348','2013-08-12','14:15:00',1.02),('8348','2013-08-12','14:35:00',1.01),('8348','2013-08-12','14:40:00',1.1),('8348','2013-08-12','14:45:00',1.11),('8348','2013-08-12','14:50:00',3.07),('8348','2013-08-12','14:55:00',3.8),('8348','2013-08-12','15:00:00',2.62),('8348','2013-08-12','15:05:00',2.86),('8348','2013-08-12','15:10:00',1.98),('8348','2013-08-12','15:15:00',3.49),('8348','2013-08-12','15:20:00',3.31),('8348','2013-08-12','15:25:00',2.97),('8348','2013-08-12','15:30:00',3.21),('8348','2013-08-12','15:35:00',3.11),('8348','2013-08-12','15:40:00',3.12),('8348','2013-08-12','15:45:00',3.05),('8348','2013-08-12','15:50:00',3.04),('8348','2013-08-12','15:55:00',2.97),('8348','2013-08-12','16:00:00',2.91),('8348','2013-08-12','16:05:00',2.85),('8348','2013-08-12','16:10:00',2.8),('8348','2013-08-12','16:15:00',2.77),('8348','2013-08-12','16:20:00',2.73),('8348','2013-08-12','16:25:00',2.7),('8348','2013-08-12','16:30:00',2.66),('8348','2013-08-12','16:35:00',2.57),('8348','2013-08-12','16:40:00',2.47),('8348','2013-08-12','16:45:00',2.44),('8348','2013-08-12','16:50:00',2.43),('8348','2013-08-12','16:55:00',2.38),('8348','2013-08-12','17:00:00',2.33),('8348','2013-08-12','17:05:00',2.26),('8348','2013-08-12','17:10:00',2.18),('8348','2013-08-12','17:15:00',2.12),('8348','2013-08-12','17:20:00',2.05),('8348','2013-08-12','17:25:00',2),('8348','2013-08-12','17:30:00',1.93),('8348','2013-08-12','17:35:00',1.87),('8348','2013-08-12','17:40:00',1.78),('8348','2013-08-12','17:45:00',1.71),('8348','2013-08-12','17:50:00',1.65),('8348','2013-08-12','17:55:00',1.58),('8348','2013-08-12','18:00:00',1.52),('8348','2013-08-12','18:05:00',1.44),('8348','2013-08-12','18:10:00',1.37),('8348','2013-08-12','18:15:00',1.29),('8348','2013-08-12','18:20:00',1.22),('8348','2013-08-12','18:25:00',1.16),('8348','2013-08-12','18:30:00',1.08),('8348','2013-08-12','18:35:00',1),('8348','2013-08-11','08:25:00',1),('8348','2013-08-11','08:30:00',1.07),('8348','2013-08-11','08:35:00',1.15),('8348','2013-08-11','08:40:00',1.19),('8348','2013-08-11','08:45:00',1.32),('8348','2013-08-11','08:50:00',1.4),('8348','2013-08-11','08:55:00',1.49),('8348','2013-08-11','09:00:00',1.57),('8348','2013-08-11','09:05:00',1.63),('8348','2013-08-11','09:10:00',1.69),('8348','2013-08-11','09:15:00',1.77),('8348','2013-08-11','09:20:00',1.83),('8348','2013-08-11','09:25:00',1.89),('8348','2013-08-11','09:30:00',1.96),('8348','2013-08-11','09:35:00',2.01),('8348','2013-08-11','09:40:00',2.07),('8348','2013-08-11','09:45:00',2.13),('8348','2013-08-11','09:50:00',2.19),('8348','2013-08-11','09:55:00',2.24),('8348','2013-08-11','10:00:00',2.3),('8348','2013-08-11','10:05:00',2.36),('8348','2013-08-11','10:10:00',2.42),('8348','2013-08-11','10:15:00',2.47),('8348','2013-08-11','10:20:00',2.52),('8348','2013-08-11','10:25:00',2.57),('8348','2013-08-11','10:30:00',2.62),('8348','2013-08-11','10:35:00',2.65),('8348','2013-08-11','10:40:00',2.69),('8348','2013-08-11','10:45:00',2.73),('8348','2013-08-11','10:50:00',2.77),('8348','2013-08-11','10:55:00',2.81),('8348','2013-08-11','11:00:00',2.86),('8348','2013-08-11','11:05:00',2.92),('8348','2013-08-11','11:10:00',2.97),('8348','2013-08-11','11:15:00',2.97),('8348','2013-08-11','11:20:00',2.99),('8348','2013-08-11','11:25:00',3.04),('8348','2013-08-11','11:30:00',3.08),('8348','2013-08-11','11:35:00',3.1),('8348','2013-08-11','11:40:00',3.11),('8348','2013-08-11','11:45:00',3.13),('8348','2013-08-11','11:50:00',3.15),('8348','2013-08-11','11:55:00',3.18),('8348','2013-08-11','12:00:00',3.21),('8348','2013-08-11','12:05:00',3.22),('8348','2013-08-11','12:10:00',3.22),('8348','2013-08-11','12:15:00',3.25),('8348','2013-08-11','12:20:00',3.27),('8348','2013-08-11','12:25:00',3.29),('8348','2013-08-11','12:30:00',3.31),('8348','2013-08-11','12:35:00',3.34),('8348','2013-08-11','12:40:00',3.35),('8348','2013-08-11','12:45:00',3.35),('8348','2013-08-11','12:50:00',3.32),('8348','2013-08-11','12:55:00',3.35),('8348','2013-08-11','13:00:00',3.36),('8348','2013-08-11','13:05:00',3.39),('8348','2013-08-11','13:10:00',3.36),('8348','2013-08-11','13:15:00',3.32),('8348','2013-08-11','13:20:00',3.3),('8348','2013-08-11','13:25:00',3.37),('8348','2013-08-11','13:30:00',3.4),('8348','2013-08-11','13:35:00',3.39),('8348','2013-08-11','13:40:00',3.38),('8348','2013-08-11','13:45:00',3.37),('8348','2013-08-11','13:50:00',3.35),('8348','2013-08-11','13:55:00',3.33),('8348','2013-08-11','14:00:00',3.34),('8348','2013-08-11','14:05:00',3.33),('8348','2013-08-11','14:10:00',3.33),('8348','2013-08-11','14:15:00',3.32),('8348','2013-08-11','14:20:00',3.27),('8348','2013-08-11','14:25:00',3.26),('8348','2013-08-11','14:30:00',3.25),('8348','2013-08-11','14:35:00',3.21),('8348','2013-08-11','14:40:00',3.27),('8348','2013-08-11','14:45:00',3.25),('8348','2013-08-11','14:50:00',3.13),('8348','2013-08-11','14:55:00',3.03),('8348','2013-08-11','15:05:00',3.24),('8348','2013-08-11','15:10:00',3.22),('8348','2013-08-11','15:15:00',3.08),('8348','2013-08-11','15:20:00',3.03),('8348','2013-08-11','15:25:00',3.09),('8348','2013-08-11','15:30:00',2.54),('8348','2013-08-11','15:35:00',2.96),('8348','2013-08-11','15:40:00',2.94),('8348','2013-08-11','15:45:00',2.96),('8348','2013-08-11','15:50:00',2.99),('8348','2013-08-11','15:55:00',2.98),('8348','2013-08-11','16:00:00',2.94),('8348','2013-08-11','16:05:00',2.88),('8348','2013-08-11','16:10:00',2.82),('8348','2013-08-11','16:15:00',2.78),('8348','2013-08-11','16:20:00',2.74),('8348','2013-08-11','16:25:00',2.68),('8348','2013-08-11','16:30:00',2.62),('8348','2013-08-11','16:35:00',2.59),('8348','2013-08-11','16:40:00',2.54),('8348','2013-08-11','16:45:00',2.48),('8348','2013-08-11','16:50:00',2.43),('8348','2013-08-11','16:55:00',2.38),('8348','2013-08-11','17:00:00',2.32),('8348','2013-08-11','17:05:00',2.26),('8348','2013-08-11','17:10:00',2.2),('8348','2013-08-11','17:15:00',2.14),('8348','2013-08-11','17:20:00',2.08),('8348','2013-08-11','17:25:00',2.01),('8348','2013-08-11','17:30:00',1.95),('8348','2013-08-11','17:35:00',1.88),('8348','2013-08-11','17:40:00',1.81),('8348','2013-08-11','17:45:00',1.74),('8348','2013-08-11','17:50:00',1.67),('8348','2013-08-11','17:55:00',1.6),('8348','2013-08-11','18:00:00',1.52),('8348','2013-08-11','18:05:00',1.44),('8348','2013-08-11','18:10:00',1.34),('8348','2013-08-11','18:15:00',1.26),('8348','2013-08-11','18:20:00',1.21),('8348','2013-08-11','18:25:00',1.14),('8348','2013-08-11','18:30:00',1.07),('8348','2013-08-10','08:25:00',1.04),('8348','2013-08-10','08:30:00',1.11),('8348','2013-08-10','08:35:00',1.2),('8348','2013-08-10','08:40:00',1.24),('8348','2013-08-10','08:45:00',1.34),('8348','2013-08-10','08:50:00',1.43),('8348','2013-08-10','08:55:00',1.52),('8348','2013-08-10','09:00:00',1.58),('8348','2013-08-10','09:05:00',1.66),('8348','2013-08-10','09:10:00',1.73),('8348','2013-08-10','09:15:00',1.8),('8348','2013-08-10','09:20:00',1.86),('8348','2013-08-10','09:25:00',1.92),('8348','2013-08-10','09:30:00',1.98),('8348','2013-08-10','09:35:00',2.04),('8348','2013-08-10','09:40:00',2.09),('8348','2013-08-10','09:45:00',2.15),('8348','2013-08-10','09:50:00',2.21),('8348','2013-08-10','09:55:00',2.28),('8348','2013-08-10','10:00:00',2.32),('8348','2013-08-10','10:05:00',2.37),('8348','2013-08-10','10:10:00',2.18),('8348','2013-08-10','10:15:00',2.22),('8348','2013-08-10','10:20:00',2.5),('8348','2013-08-10','10:25:00',2.55),('8348','2013-08-10','10:30:00',2.62),('8348','2013-08-10','10:35:00',2.66),('8348','2013-08-10','10:40:00',2.71),('8348','2013-08-10','10:45:00',2.74),('8348','2013-08-10','10:50:00',2.79),('8348','2013-08-10','10:55:00',2.85),('8348','2013-08-10','11:00:00',2.94),('8348','2013-08-10','11:05:00',2.98),('8348','2013-08-10','11:10:00',2.94),('8348','2013-08-10','11:15:00',3.09),('8348','2013-08-10','11:20:00',2.42),('8348','2013-08-10','11:25:00',2.18),('8348','2013-08-10','11:30:00',2.63),('8348','2013-08-10','11:35:00',3),('8348','2013-08-10','11:40:00',3.18),('8348','2013-08-10','11:45:00',3.2),('8348','2013-08-10','11:50:00',3.21),('8348','2013-08-10','11:55:00',3.23),('8348','2013-08-10','12:00:00',3.24),('8348','2013-08-10','12:05:00',3.27),('8348','2013-08-10','12:10:00',3.28),('8348','2013-08-10','12:15:00',3.32),('8348','2013-08-10','12:20:00',3.32),('8348','2013-08-10','12:25:00',3.36),('8348','2013-08-10','12:30:00',3.36),('8348','2013-08-10','12:35:00',3.38),('8348','2013-08-10','12:40:00',3.42),('8348','2013-08-10','12:45:00',3.29),('8348','2013-08-10','12:50:00',3.55),('8348','2013-08-10','12:55:00',3.54),('8348','2013-08-10','13:00:00',3.52),('8348','2013-08-10','13:05:00',3.43),('8348','2013-08-10','13:10:00',3.52),('8348','2013-08-10','13:15:00',3.63),('8348','2013-08-10','13:20:00',3.74),('8348','2013-08-10','13:25:00',3.77),('8348','2013-08-10','13:30:00',3.43),('8348','2013-08-10','13:35:00',1.82),('8348','2013-08-10','13:45:00',1.1),('8348','2013-08-10','13:50:00',3.81),('8348','2013-08-10','13:55:00',3.69),('8348','2013-08-10','14:00:00',3.81),('8348','2013-08-10','14:05:00',3.93),('8348','2013-08-10','14:10:00',3.56),('8348','2013-08-10','14:15:00',3.33),('8348','2013-08-10','14:20:00',2.28),('8348','2013-08-10','14:25:00',1.15),('8348','2013-08-10','14:30:00',1.11),('8348','2013-08-10','15:10:00',1.01),('8348','2013-08-10','15:15:00',1.14),('8348','2013-08-10','15:20:00',1.11),('8348','2013-08-10','15:35:00',1.21),('8348','2013-08-10','15:40:00',1.15),('8348','2013-08-10','15:45:00',1.29),('8348','2013-08-10','15:50:00',1.59),('8348','2013-08-10','15:55:00',1.76),('8348','2013-08-10','16:00:00',2.41),('8348','2013-08-10','16:05:00',3.79),('8348','2013-08-10','16:10:00',2.23),('8348','2013-08-10','16:15:00',2.31),('8348','2013-08-10','16:20:00',3.19),('8348','2013-08-10','16:25:00',1.01),('8348','2013-08-10','16:30:00',1.47),('8348','2013-08-10','16:35:00',2.03),('8348','2013-08-10','16:40:00',2.65),('8348','2013-08-10','16:45:00',2.75),('8348','2013-08-10','16:50:00',2.62),('8348','2013-08-10','16:55:00',2.44),('8348','2013-08-10','17:00:00',2.21),('8348','2013-08-10','17:05:00',1.51),('8348','2013-08-10','17:10:00',1),('8348','2013-08-10','17:15:00',1.14),('8348','2013-08-10','17:20:00',1.24),('8348','2013-08-10','17:25:00',1.49),('8348','2013-08-10','17:55:00',1.02),('8348','2014-04-09','07:00:00',1.29),('8348','2014-04-09','07:05:00',1.59),('8348','2014-04-09','07:10:00',1.4),('8348','2014-04-09','07:15:00',1.27),('8348','2014-04-09','07:20:00',1.56),('8348','2014-04-09','07:25:00',1.26),('8348','2014-04-09','07:30:00',1.34),('8348','2014-04-09','07:50:00',1.01),('8348','2014-04-09','07:55:00',1.51),('8348','2014-04-09','08:00:00',1.49),('8348','2014-04-09','08:05:00',1.48),('8348','2014-04-09','08:10:00',1.45),('8348','2014-04-09','08:15:00',1.42),('8348','2014-04-09','08:20:00',1.47),('8348','2014-04-09','08:25:00',1.67),('8348','2014-04-09','08:30:00',1.73),('8348','2014-04-09','08:35:00',1.48),('8348','2014-04-09','08:40:00',1.35),('8348','2014-04-09','08:45:00',1.82),('8348','2014-04-09','08:50:00',3.17),('8348','2014-04-09','08:55:00',4.53),('8348','2014-04-09','09:00:00',4.52),('8348','2014-04-09','09:05:00',4.58),('8348','2014-04-09','09:10:00',4.81),('8348','2014-04-09','09:15:00',5.06),('8348','2014-04-09','09:20:00',5.28),('8348','2014-04-09','09:25:00',5.57),('8348','2014-04-09','09:30:00',6.18),('8348','2014-04-09','09:35:00',4.59),('8348','2014-04-09','09:40:00',3.02),('8348','2014-04-09','09:45:00',2.27),('8348','2014-04-09','09:50:00',3.76),('8348','2014-04-09','09:55:00',2.24),('8348','2014-04-09','10:00:00',5.85),('8348','2014-04-09','10:05:00',7.09),('8348','2014-04-09','10:10:00',7.28),('8348','2014-04-09','10:15:00',7.37),('8348','2014-04-09','10:20:00',3.52),('8348','2014-04-09','10:25:00',1.86),('8348','2014-04-09','10:30:00',1.69),('8348','2014-04-09','10:35:00',4.29),('8348','2014-04-09','10:40:00',7.71),('8348','2014-04-09','10:45:00',5.58),('8348','2014-04-09','10:50:00',4.53),('8348','2014-04-09','10:55:00',7.26),('8348','2014-04-09','11:00:00',7.46),('8348','2014-04-09','11:05:00',7.25),('8348','2014-04-09','11:10:00',3.49),('8348','2014-04-09','11:15:00',2.62),('8348','2014-04-09','11:20:00',2.19),('8348','2014-04-09','11:25:00',1.71),('8348','2014-04-09','11:30:00',1.49),('8348','2014-04-09','11:35:00',1.31),('8348','2014-04-09','11:40:00',1.2),('8348','2014-04-09','11:45:00',1.08),('8348','2014-04-09','11:50:00',1.16),('8348','2014-04-09','11:55:00',1.17),('8348','2014-04-09','12:05:00',1.01),('8348','2014-04-09','12:10:00',1.26),('8348','2014-04-09','12:15:00',1.86),('8348','2014-04-09','12:20:00',2.71),('8348','2014-04-09','12:25:00',2.81),('8348','2014-04-09','12:30:00',2.4),('8348','2014-04-09','12:35:00',2.41),('8348','2014-04-09','12:40:00',2.05),('8348','2014-04-09','12:45:00',1.74),('8348','2014-04-09','12:50:00',1.67),('8348','2014-04-09','12:55:00',1.55),('8348','2014-04-09','13:00:00',1.83),('8348','2014-04-09','13:05:00',3.75),('8348','2014-04-09','13:10:00',4.88),('8348','2014-04-09','13:15:00',4.11),('8348','2014-04-09','13:20:00',3.07),('8348','2014-04-09','13:25:00',3.07),('8348','2014-04-09','13:30:00',5.9),('8348','2014-04-09','13:35:00',5.3),('8348','2014-04-09','13:40:00',5.08),('8348','2014-04-09','13:45:00',4.52),('8348','2014-04-09','13:50:00',3.68),('8348','2014-04-09','13:55:00',4.72),('8348','2014-04-09','14:00:00',5.56),('8348','2014-04-09','14:05:00',8.07),('8348','2014-04-09','14:10:00',7),('8348','2014-04-09','14:15:00',7.63),('8348','2014-04-09','14:20:00',6.21),('8348','2014-04-09','14:25:00',5.04),('8348','2014-04-09','14:30:00',3.66),('8348','2014-04-09','14:35:00',3.05),('8348','2014-04-09','14:40:00',3.95),('8348','2014-04-09','14:45:00',3.57),('8348','2014-04-09','14:50:00',2.45),('8348','2014-04-09','14:55:00',2.16),('8348','2014-04-09','15:00:00',2.23),('8348','2014-04-09','15:05:00',3.81),('8348','2014-04-09','15:10:00',5.82),('8348','2014-04-09','15:15:00',5.64),('8348','2014-04-09','15:20:00',5.44),('8348','2014-04-09','15:25:00',5.25),('8348','2014-04-09','15:30:00',3.36),('8348','2014-04-09','15:35:00',3.71),('8348','2014-04-09','15:40:00',3.56),('8348','2014-04-09','15:45:00',4.23),('8348','2014-04-09','15:50:00',3.27),('8348','2014-04-09','15:55:00',2.9),('8348','2014-04-09','16:00:00',3.87),('8348','2014-04-09','16:05:00',5.19),('8348','2014-04-09','16:10:00',4.38),('8348','2014-04-09','16:15:00',3.95),('8348','2014-04-09','16:20:00',3.81),('8348','2014-04-09','16:25:00',3.74),('8348','2014-04-09','16:30:00',2.61),('8348','2014-04-09','16:35:00',1.29),('8348','2014-04-09','16:40:00',1.39),('8348','2014-04-09','16:45:00',2.38),('8348','2014-04-09','16:50:00',2.19),('8348','2014-04-09','16:55:00',2.19),('8348','2014-04-09','17:00:00',1.82),('8348','2014-04-09','17:05:00',1.22),('8348','2014-04-09','17:10:00',1.42),('8348','2014-04-09','17:15:00',1.08),('8348','2013-08-09','08:40:00',1.05),('8348','2013-08-09','08:45:00',1.27),('8348','2013-08-09','08:50:00',1.34),('8348','2013-08-09','08:55:00',1.43),('8348','2013-08-09','09:00:00',1.52),('8348','2013-08-09','09:05:00',1.58),('8348','2013-08-09','09:10:00',1.47),('8348','2013-08-09','09:15:00',1.74),('8348','2013-08-09','09:20:00',1.59),('8348','2013-08-09','09:25:00',1.54),('8348','2013-08-09','09:30:00',1.77),('8348','2013-08-09','09:35:00',1.77),('8348','2013-08-09','09:40:00',1.27),('8348','2013-08-09','09:45:00',1.74),('8348','2013-08-09','09:50:00',1.9),('8348','2013-08-09','09:55:00',1.07),('8348','2013-08-09','10:00:00',1.47),('8348','2013-08-09','10:05:00',1.45),('8348','2013-08-09','10:10:00',1.77),('8348','2013-08-09','10:15:00',2.26),('8348','2013-08-09','10:20:00',2.24),('8348','2013-08-09','10:25:00',2.33),('8348','2013-08-09','10:30:00',2.39),('8348','2013-08-09','10:35:00',2.43),('8348','2013-08-09','10:40:00',2.48),('8348','2013-08-09','10:45:00',2.48),('8348','2013-08-09','10:50:00',2.51),('8348','2013-08-09','10:55:00',2.61),('8348','2013-08-09','11:00:00',2.61),('8348','2013-08-09','11:05:00',2.67),('8348','2013-08-09','11:10:00',2.68),('8348','2013-08-09','11:15:00',2.73),('8348','2013-08-09','11:20:00',2.78),('8348','2013-08-09','11:25:00',2.78),('8348','2013-08-09','11:30:00',2.84),('8348','2013-08-09','11:35:00',2.84),('8348','2013-08-09','11:40:00',2.87),('8348','2013-08-09','11:45:00',2.88),('8348','2013-08-09','11:50:00',2.93),('8348','2013-08-09','11:55:00',2.95),('8348','2013-08-09','12:00:00',2.99),('8348','2013-08-09','12:05:00',3.02),('8348','2013-08-09','12:10:00',3.02),('8348','2013-08-09','12:15:00',3.09),('8348','2013-08-09','12:20:00',3.22),('8348','2013-08-09','12:25:00',2.68),('8348','2013-08-09','12:30:00',2.12),('8348','2013-08-09','12:35:00',2.47),('8348','2013-08-09','12:40:00',3.2),('8348','2013-08-09','12:45:00',2.37),('8348','2013-08-09','12:50:00',2.22),('8348','2013-08-09','12:55:00',2.6),('8348','2013-08-09','13:00:00',1.23),('8348','2013-08-09','13:20:00',1.31),('8348','2013-08-09','13:25:00',1.92),('8348','2013-08-09','13:30:00',1.74),('8348','2013-08-09','13:35:00',1.34),('8348','2013-08-09','13:40:00',1.35),('8348','2013-08-09','13:45:00',1.26),('8348','2013-08-09','13:50:00',1.35),('8348','2013-08-09','13:55:00',1.19),('8348','2013-08-09','14:00:00',1.13),('8348','2013-08-09','14:05:00',1.12),('8348','2013-08-09','14:10:00',1.36),('8348','2013-08-09','15:05:00',1.08),('8348','2013-08-09','15:10:00',2.51),('8348','2013-08-09','15:15:00',2.39),('8348','2013-08-09','15:20:00',1.38),('8348','2013-08-09','15:25:00',1.11),('8348','2013-08-09','15:30:00',1.08),('8348','2013-08-09','15:35:00',1.81),('8348','2013-08-09','15:40:00',1.51),('8348','2013-08-09','15:45:00',2.55),('8348','2013-08-09','15:50:00',1.94),('8348','2013-08-09','15:55:00',1.67),('8348','2013-08-09','16:00:00',1.09),('8348','2013-08-09','16:50:00',1.37),('8348','2013-08-09','16:55:00',2.37),('8348','2013-08-09','17:00:00',1.29),('8348','2013-08-09','17:05:00',1.79),('8348','2013-08-08','08:30:00',1.01),('8348','2013-08-08','08:35:00',1.08),('8348','2013-08-08','08:40:00',1.16),('8348','2013-08-08','08:45:00',1.21),('8348','2013-08-08','08:50:00',1.3),('8348','2013-08-08','08:55:00',1.39),('8348','2013-08-08','09:00:00',1.46),('8348','2013-08-08','09:05:00',1.52),('8348','2013-08-08','09:10:00',1.57),('8348','2013-08-08','09:15:00',1.64),('8348','2013-08-08','09:20:00',1.7),('8348','2013-08-08','09:25:00',1.77),('8348','2013-08-08','09:30:00',1.83),('8348','2013-08-08','09:35:00',1.89),('8348','2013-08-08','09:40:00',1.94),('8348','2013-08-08','09:45:00',2),('8348','2013-08-08','09:50:00',2.05),('8348','2013-08-08','09:55:00',2.1),('8348','2013-08-08','10:00:00',2.16),('8348','2013-08-08','10:05:00',2.19),('8348','2013-08-08','10:10:00',2.24),('8348','2013-08-08','10:15:00',2.31),('8348','2013-08-08','10:20:00',2.36),('8348','2013-08-08','10:25:00',2.38),('8348','2013-08-08','10:30:00',2.43),('8348','2013-08-08','10:35:00',2.48),('8348','2013-08-08','10:40:00',2.51),('8348','2013-08-08','10:45:00',2.55),('8348','2013-08-08','10:50:00',2.59),('8348','2013-08-08','10:55:00',2.62),('8348','2013-08-08','11:00:00',2.66),('8348','2013-08-08','11:05:00',2.7),('8348','2013-08-08','11:10:00',2.72),('8348','2013-08-08','11:15:00',2.75),('8348','2013-08-08','11:20:00',2.73),('8348','2013-08-08','11:25:00',2.75),('8348','2013-08-08','11:30:00',2.8),('8348','2013-08-08','11:35:00',2.84),('8348','2013-08-08','11:40:00',2.87),('8348','2013-08-08','11:45:00',2.89),('8348','2013-08-08','11:50:00',2.91),('8348','2013-08-08','11:55:00',2.97),('8348','2013-08-08','12:00:00',2.97),('8348','2013-08-08','12:05:00',2.97),('8348','2013-08-08','12:10:00',3.02),('8348','2013-08-08','12:15:00',3.05),('8348','2013-08-08','12:20:00',3.07),('8348','2013-08-08','12:25:00',3.08),('8348','2013-08-08','12:30:00',3.07),('8348','2013-08-08','12:35:00',3.16),('8348','2013-08-08','12:40:00',3.17),('8348','2013-08-08','12:45:00',3.2),('8348','2013-08-08','12:50:00',3.2),('8348','2013-08-08','12:55:00',3.24),('8348','2013-08-08','13:00:00',3.25),('8348','2013-08-08','13:05:00',3.28),('8348','2013-08-08','13:10:00',3.3),('8348','2013-08-08','13:15:00',3.31),('8348','2013-08-08','13:20:00',3.35),('8348','2013-08-08','13:25:00',3.33),('8348','2013-08-08','13:30:00',3.29),('8348','2013-08-08','13:35:00',3.3),('8348','2013-08-08','13:40:00',3.27),('8348','2013-08-08','13:45:00',3.29),('8348','2013-08-08','13:50:00',3.3),('8348','2013-08-08','13:55:00',3.25),('8348','2013-08-08','14:00:00',3.26),('8348','2013-08-08','14:05:00',3.25),('8348','2013-08-08','14:10:00',3.23),('8348','2013-08-08','14:15:00',3.22),('8348','2013-08-08','14:20:00',3.2),('8348','2013-08-08','14:25:00',3.2),('8348','2013-08-08','14:30:00',3.2),('8348','2013-08-08','14:35:00',3.19),('8348','2013-08-08','14:40:00',3.14),('8348','2013-08-08','14:45:00',3.15),('8348','2013-08-08','14:50:00',3.11),('8348','2013-08-08','14:55:00',3.07),('8348','2013-08-08','15:00:00',3.03),('8348','2013-08-08','15:05:00',3.02),('8348','2013-08-08','15:10:00',2.99),('8348','2013-08-08','15:15:00',2.99),('8348','2013-08-08','15:20:00',2.96),('8348','2013-08-08','15:25:00',2.94),('8348','2013-08-08','15:30:00',2.89),('8348','2013-08-08','15:35:00',2.87),('8348','2013-08-08','15:40:00',2.84),('8348','2013-08-08','15:45:00',2.83),('8348','2013-08-08','15:50:00',2.79),('8348','2013-08-08','15:55:00',2.77),('8348','2013-08-08','16:00:00',2.73),('8348','2013-08-08','16:05:00',2.71),('8348','2013-08-08','16:10:00',2.68),('8348','2013-08-08','16:15:00',2.65),('8348','2013-08-08','16:20:00',2.62),('8348','2013-08-08','16:25:00',2.59),('8348','2013-08-08','16:30:00',2.55),('8348','2013-08-08','16:35:00',2.5),('8348','2013-08-08','16:40:00',2.44),('8348','2013-08-08','16:45:00',2.38),('8348','2013-08-08','16:50:00',2.31),('8348','2013-08-08','16:55:00',2.26),('8348','2013-08-08','17:00:00',2.22),('8348','2013-08-08','17:05:00',2.14),('8348','2013-08-08','17:10:00',2.08),('8348','2013-08-08','17:15:00',2.03),('8348','2013-08-08','17:20:00',1.96),('8348','2013-08-08','17:25:00',1.89),('8348','2013-08-08','17:30:00',1.82),('8348','2013-08-08','17:35:00',1.75),('8348','2013-08-08','17:40:00',1.69),('8348','2013-08-08','17:45:00',1.63),('8348','2013-08-08','17:50:00',1.57),('8348','2013-08-08','17:55:00',1.5),('8348','2013-08-08','18:00:00',1.44),('8348','2013-08-08','18:05:00',1.38),('8348','2013-08-08','18:10:00',1.31),('8348','2013-08-08','18:15:00',1.23),('8348','2013-08-08','18:20:00',1.16),('8348','2013-08-08','18:25:00',1.09),('8348','2013-08-08','18:30:00',1.02),('8348','2013-08-07','08:30:00',1.04),('8348','2013-08-07','08:35:00',1.11),('8348','2013-08-07','08:40:00',1.21),('8348','2013-08-07','08:45:00',1.27),('8348','2013-08-07','08:50:00',1.36),('8348','2013-08-07','08:55:00',1.44),('8348','2013-08-07','09:00:00',1.49),('8348','2013-08-07','09:05:00',1.55),('8348','2013-08-07','09:10:00',1.61),('8348','2013-08-07','09:15:00',1.67),('8348','2013-08-07','09:20:00',1.73),('8348','2013-08-07','09:25:00',1.79),('8348','2013-08-07','09:30:00',1.85),('8348','2013-08-07','09:35:00',1.92),('8348','2013-08-07','09:40:00',1.98),('8348','2013-08-07','09:45:00',2.04),('8348','2013-08-07','09:50:00',2.08),('8348','2013-08-07','09:55:00',2.13),('8348','2013-08-07','10:00:00',2.18),('8348','2013-08-07','10:05:00',2.2),('8348','2013-08-07','10:10:00',2.29),('8348','2013-08-07','10:15:00',2.33),('8348','2013-08-07','10:20:00',2.37),('8348','2013-08-07','10:25:00',2.41),('8348','2013-08-07','10:30:00',2.45),('8348','2013-08-07','10:35:00',2.51),('8348','2013-08-07','10:40:00',2.56),('8348','2013-08-07','10:45:00',2.58),('8348','2013-08-07','10:50:00',2.61),('8348','2013-08-07','10:55:00',2.64),('8348','2013-08-07','11:00:00',2.67),('8348','2013-08-07','11:05:00',2.72),('8348','2013-08-07','11:10:00',2.77),('8348','2013-08-07','11:15:00',2.8),('8348','2013-08-07','11:20:00',2.83),('8348','2013-08-07','11:25:00',2.85),('8348','2013-08-07','11:30:00',2.85),('8348','2013-08-07','11:35:00',2.88),('8348','2013-08-07','11:40:00',2.89),('8348','2013-08-07','11:45:00',2.93),('8348','2013-08-07','11:50:00',2.94),('8348','2013-08-07','11:55:00',2.98),('8348','2013-08-07','12:00:00',3),('8348','2013-08-07','12:05:00',3.02),('8348','2013-08-07','12:10:00',3.06),('8348','2013-08-07','12:15:00',3.09),('8348','2013-08-07','12:20:00',3.04),('8348','2013-08-07','12:25:00',3.07),('8348','2013-08-07','12:30:00',3.11),('8348','2013-08-07','12:35:00',3.06),('8348','2013-08-07','12:40:00',3.01),('8348','2013-08-07','12:45:00',3.1),('8348','2013-08-07','12:50:00',3.08),('8348','2013-08-07','12:55:00',3.18),('8348','2013-08-07','13:00:00',3.17),('8348','2013-08-07','13:05:00',3.23),('8348','2013-08-07','13:10:00',3.18),('8348','2013-08-07','13:15:00',3.25),('8348','2013-08-07','13:20:00',3.19),('8348','2013-08-07','13:25:00',3.28),('8348','2013-08-07','13:30:00',3.26),('8348','2013-08-07','13:35:00',3.29),('8348','2013-08-07','13:40:00',3.35),('8348','2013-08-07','13:45:00',3.28),('8348','2013-08-07','13:50:00',3.26),('8348','2013-08-07','13:55:00',3.34),('8348','2013-08-07','14:00:00',3.28),('8348','2013-08-07','14:05:00',3.32),('8348','2013-08-07','14:10:00',3.25),('8348','2013-08-07','14:15:00',3.27),('8348','2013-08-07','14:20:00',3.19),('8348','2013-08-07','14:25:00',3.17),('8348','2013-08-07','14:30:00',3.14),('8348','2013-08-07','14:35:00',3.13),('8348','2013-08-07','14:40:00',3.18),('8348','2013-08-07','14:45:00',3.19),('8348','2013-08-07','14:50:00',3.19),('8348','2013-08-07','14:55:00',3.12),('8348','2013-08-07','15:00:00',3.12),('8348','2013-08-07','15:05:00',3.09),('8348','2013-08-07','15:10:00',3.07),('8348','2013-08-07','15:15:00',3.08),('8348','2013-08-07','15:20:00',3.04),('8348','2013-08-07','15:25:00',2.98),('8348','2013-08-07','15:30:00',2.96),('8348','2013-08-07','15:35:00',2.91),('8348','2013-08-07','15:40:00',2.88),('8348','2013-08-07','15:45:00',2.89),('8348','2013-08-07','15:50:00',2.84),('8348','2013-08-07','15:55:00',2.8),('8348','2013-08-07','16:00:00',2.75),('8348','2013-08-07','16:05:00',2.72),('8348','2013-08-07','16:10:00',2.68),('8348','2013-08-07','16:15:00',2.65),('8348','2013-08-07','16:20:00',2.62),('8348','2013-08-07','16:25:00',2.58),('8348','2013-08-07','16:30:00',2.54),('8348','2013-08-07','16:35:00',2.48),('8348','2013-08-07','16:40:00',2.44),('8348','2013-08-07','16:45:00',2.39),('8348','2013-08-07','16:50:00',2.37),('8348','2013-08-07','16:55:00',2.32),('8348','2013-08-07','17:00:00',2.26),('8348','2013-08-07','17:05:00',2.17),('8348','2013-08-07','17:10:00',2.13),('8348','2013-08-07','17:15:00',2.05),('8348','2013-08-07','17:20:00',2),('8348','2013-08-07','17:25:00',1.95),('8348','2013-08-07','17:30:00',1.88),('8348','2013-08-07','17:35:00',1.81),('8348','2013-08-07','17:40:00',1.73),('8348','2013-08-07','17:45:00',1.67),('8348','2013-08-07','17:50:00',1.61),('8348','2013-08-07','17:55:00',1.54),('8348','2013-08-07','18:00:00',1.48),('8348','2013-08-07','18:05:00',1.4),('8348','2013-08-07','18:10:00',1.3),('8348','2013-08-07','18:15:00',1.21),('8348','2013-08-07','18:20:00',1.16),('8348','2013-08-07','18:25:00',1.1),('8348','2013-08-07','18:30:00',1.05),('8348','2013-08-06','08:30:00',1.04),('8348','2013-08-06','08:35:00',1.09),('8348','2013-08-06','08:40:00',1.19),('8348','2013-08-06','08:45:00',1.26),('8348','2013-08-06','08:50:00',1.35),('8348','2013-08-06','08:55:00',1.41),('8348','2013-08-06','09:00:00',1.48),('8348','2013-08-06','09:05:00',1.55),('8348','2013-08-06','09:10:00',1.61),('8348','2013-08-06','09:15:00',1.67),('8348','2013-08-06','09:20:00',1.73),('8348','2013-08-06','09:25:00',1.79),('8348','2013-08-06','09:30:00',1.85),('8348','2013-08-06','09:35:00',1.92),('8348','2013-08-06','09:40:00',1.96),('8348','2013-08-06','09:45:00',2.01),('8348','2013-08-06','09:50:00',2.08),('8348','2013-08-06','09:55:00',2.13),('8348','2013-08-06','10:00:00',2.18),('8348','2013-08-06','10:05:00',2.22),('8348','2013-08-06','10:10:00',2.26),('8348','2013-08-06','10:15:00',2.31),('8348','2013-08-06','10:20:00',2.36),('8348','2013-08-06','10:25:00',2.41),('8348','2013-08-06','10:30:00',2.44),('8348','2013-08-06','10:35:00',2.47),('8348','2013-08-06','10:40:00',2.52),('8348','2013-08-06','10:45:00',2.54),('8348','2013-08-06','10:50:00',2.59),('8348','2013-08-06','10:55:00',2.63),('8348','2013-08-06','11:00:00',2.66),('8348','2013-08-06','11:05:00',2.71),('8348','2013-08-06','11:10:00',2.75),('8348','2013-08-06','11:15:00',2.78),('8348','2013-08-06','11:20:00',2.82),('8348','2013-08-06','11:25:00',2.83),('8348','2013-08-06','11:30:00',2.87),('8348','2013-08-06','11:35:00',2.91),('8348','2013-08-06','11:40:00',2.92),('8348','2013-08-06','11:45:00',2.92),('8348','2013-08-06','11:50:00',2.95),('8348','2013-08-06','11:55:00',2.98),('8348','2013-08-06','12:00:00',2.99),('8348','2013-08-06','12:05:00',2.99),('8348','2013-08-06','12:10:00',3.03),('8348','2013-08-06','12:15:00',3.02),('8348','2013-08-06','12:20:00',3.02),('8348','2013-08-06','12:25:00',3.05),('8348','2013-08-06','12:30:00',3.07),('8348','2013-08-06','12:35:00',3.08),('8348','2013-08-06','12:40:00',3.09),('8348','2013-08-06','12:45:00',3.12),('8348','2013-08-06','12:50:00',3.17),('8348','2013-08-06','12:55:00',3.16),('8348','2013-08-06','13:00:00',3.18),('8348','2013-08-06','13:05:00',3.2),('8348','2013-08-06','13:10:00',3.23),('8348','2013-08-06','13:15:00',3.26),('8348','2013-08-06','13:20:00',3.29),('8348','2013-08-06','13:25:00',3.26),('8348','2013-08-06','13:30:00',3.3),('8348','2013-08-06','13:35:00',3.33),('8348','2013-08-06','13:40:00',3.36),('8348','2013-08-06','13:45:00',3.4),('8348','2013-08-06','13:50:00',3.42),('8348','2013-08-06','13:55:00',3.42),('8348','2013-08-06','14:00:00',3.42),('8348','2013-08-06','14:05:00',3.44),('8348','2013-08-06','14:10:00',3.44),('8348','2013-08-06','14:15:00',3.42),('8348','2013-08-06','14:20:00',3.4),('8348','2013-08-06','14:25:00',3.4),('8348','2013-08-06','14:30:00',3.38),('8348','2013-08-06','14:35:00',3.34),('8348','2013-08-06','14:40:00',3.33),('8348','2013-08-06','14:45:00',3.31),('8348','2013-08-06','14:50:00',3.31),('8348','2013-08-06','14:55:00',3.3),('8348','2013-08-06','15:00:00',3.29),('8348','2013-08-06','15:05:00',3.26),('8348','2013-08-06','15:10:00',3.24),('8348','2013-08-06','15:15:00',3.22),('8348','2013-08-06','15:20:00',3.21),('8348','2013-08-06','15:25:00',3.18),('8348','2013-08-06','15:30:00',3.14),('8348','2013-08-06','15:35:00',3.12),('8348','2013-08-06','15:40:00',3.08),('8348','2013-08-06','15:45:00',3.04),('8348','2013-08-06','15:50:00',2.99),('8348','2013-08-06','15:55:00',2.95),('8348','2013-08-06','16:00:00',2.9),('8348','2013-08-06','16:05:00',2.86),('8348','2013-08-06','16:10:00',2.82),('8348','2013-08-06','16:15:00',2.78),('8348','2013-08-06','16:20:00',2.74),('8348','2013-08-06','16:25:00',2.68),('8348','2013-08-06','16:30:00',2.64),('8348','2013-08-06','16:35:00',2.59),('8348','2013-08-06','16:40:00',2.54),('8348','2013-08-06','16:45:00',2.48),('8348','2013-08-06','16:50:00',2.43),('8348','2013-08-06','16:55:00',2.37),('8348','2013-08-06','17:00:00',2.31),('8348','2013-08-06','17:05:00',2.28),('8348','2013-08-06','17:10:00',2.2),('8348','2013-08-06','17:15:00',2.13),('8348','2013-08-06','17:20:00',2.05),('8348','2013-08-06','17:25:00',1.98),('8348','2013-08-06','17:30:00',1.93),('8348','2013-08-06','17:35:00',1.87),('8348','2013-08-06','17:40:00',1.78),('8348','2013-08-06','17:45:00',1.72),('8348','2013-08-06','17:50:00',1.66),('8348','2013-08-06','17:55:00',1.59),('8348','2013-08-06','18:00:00',1.52),('8348','2013-08-06','18:05:00',1.45),('8348','2013-08-06','18:10:00',1.38),('8348','2013-08-06','18:15:00',1.31),('8348','2013-08-06','18:20:00',1.24),('8348','2013-08-06','18:25:00',1.16),('8348','2013-08-06','18:30:00',1.11),('8348','2013-08-06','18:35:00',1.04),('8348','2013-08-05','08:25:00',1.02),('8348','2013-08-05','08:30:00',1.08),('8348','2013-08-05','08:35:00',1.14),('8348','2013-08-05','08:40:00',1.23),('8348','2013-08-05','08:45:00',1.3),('8348','2013-08-05','08:50:00',1.39),('8348','2013-08-05','08:55:00',1.46),('8348','2013-08-05','09:00:00',1.52),('8348','2013-08-05','09:05:00',1.59),('8348','2013-08-05','09:10:00',1.64),('8348','2013-08-05','09:15:00',1.7),('8348','2013-08-05','09:20:00',1.76),('8348','2013-08-05','09:25:00',1.82),('8348','2013-08-05','09:30:00',1.87),('8348','2013-08-05','09:35:00',1.92),('8348','2013-08-05','09:40:00',1.98),('8348','2013-08-05','09:45:00',2.04),('8348','2013-08-05','09:50:00',2.09),('8348','2013-08-05','09:55:00',2.15),('8348','2013-08-05','10:00:00',2.21),('8348','2013-08-05','10:05:00',2.26),('8348','2013-08-05','10:10:00',2.31),('8348','2013-08-05','10:15:00',2.36),('8348','2013-08-05','10:20:00',2.42),('8348','2013-08-05','10:25:00',2.47),('8348','2013-08-05','10:30:00',2.49),('8348','2013-08-05','10:35:00',2.54),('8348','2013-08-05','10:40:00',2.59),('8348','2013-08-05','10:45:00',2.64),('8348','2013-08-05','10:50:00',2.7),('8348','2013-08-05','10:55:00',2.74),('8348','2013-08-05','11:00:00',2.78),('8348','2013-08-05','11:05:00',2.83),('8348','2013-08-05','11:10:00',2.84),('8348','2013-08-05','11:15:00',2.88),('8348','2013-08-05','11:20:00',2.92),('8348','2013-08-05','11:25:00',2.94),('8348','2013-08-05','11:30:00',2.98),('8348','2013-08-05','11:35:00',2.98),('8348','2013-08-05','11:40:00',3.01),('8348','2013-08-05','11:45:00',3.08),('8348','2013-08-05','11:50:00',3.08),('8348','2013-08-05','11:55:00',3.11),('8348','2013-08-05','12:00:00',3.13),('8348','2013-08-05','12:05:00',3.13),('8348','2013-08-05','12:10:00',3.15),('8348','2013-08-05','12:15:00',3.15),('8348','2013-08-05','12:20:00',3.16),('8348','2013-08-05','12:25:00',3.17),('8348','2013-08-05','12:30:00',3.2),('8348','2013-08-05','12:35:00',3.25),('8348','2013-08-05','12:40:00',3.25),('8348','2013-08-05','12:45:00',3.23),('8348','2013-08-05','12:50:00',3.25),('8348','2013-08-05','12:55:00',3.27),('8348','2013-08-05','13:00:00',3.25),('8348','2013-08-05','13:05:00',3.24),('8348','2013-08-05','13:10:00',3.25),('8348','2013-08-05','13:15:00',3.26),('8348','2013-08-05','13:20:00',3.25),('8348','2013-08-05','13:25:00',3.31),('8348','2013-08-05','13:30:00',3.3),('8348','2013-08-05','13:35:00',3.3),('8348','2013-08-05','13:40:00',3.32),('8348','2013-08-05','13:45:00',3.24),('8348','2013-08-05','13:50:00',3.28),('8348','2013-08-05','13:55:00',3.32),('8348','2013-08-05','14:00:00',3.28),('8348','2013-08-05','14:05:00',3.3),('8348','2013-08-05','14:10:00',3.32),('8348','2013-08-05','14:15:00',3.3),('8348','2013-08-05','14:20:00',3.27),('8348','2013-08-05','14:25:00',3.25),('8348','2013-08-05','14:30:00',3.25),('8348','2013-08-05','14:35:00',3.22),('8348','2013-08-05','14:40:00',3.23),('8348','2013-08-05','14:45:00',3.22),('8348','2013-08-05','14:50:00',3.21),('8348','2013-08-05','14:55:00',3.19),('8348','2013-08-05','15:00:00',3.18),('8348','2013-08-05','15:05:00',3.18),('8348','2013-08-05','15:10:00',3.16),('8348','2013-08-05','15:15:00',3.15),('8348','2013-08-05','15:20:00',3.13),('8348','2013-08-05','15:25:00',3.11),('8348','2013-08-05','15:30:00',3.09),('8348','2013-08-05','15:35:00',3.06),('8348','2013-08-05','15:40:00',3.02),('8348','2013-08-05','15:45:00',2.99),('8348','2013-08-05','15:50:00',2.93),('8348','2013-08-05','15:55:00',2.9),('8348','2013-08-05','16:00:00',2.89),('8348','2013-08-05','16:05:00',2.88),('8348','2013-08-05','16:10:00',2.82),('8348','2013-08-05','16:15:00',2.75),('8348','2013-08-05','16:20:00',2.7),('8348','2013-08-05','16:25:00',2.65),('8348','2013-08-05','16:30:00',2.61),('8348','2013-08-05','16:35:00',2.59),('8348','2013-08-05','16:40:00',2.53),('8348','2013-08-05','16:45:00',2.48),('8348','2013-08-05','16:50:00',2.41),('8348','2013-08-05','16:55:00',2.35),('8348','2013-08-05','17:00:00',2.29),('8348','2013-08-05','17:05:00',2.24),('8348','2013-08-05','17:10:00',2.18),('8348','2013-08-05','17:15:00',2.11),('8348','2013-08-05','17:20:00',2.05),('8348','2013-08-05','17:25:00',1.98),('8348','2013-08-05','17:30:00',1.92),('8348','2013-08-05','17:35:00',1.86),('8348','2013-08-05','17:40:00',1.81),('8348','2013-08-05','17:45:00',1.73),('8348','2013-08-05','17:50:00',1.66),('8348','2013-08-05','17:55:00',1.58),('8348','2013-08-05','18:00:00',1.5),('8348','2013-08-05','18:05:00',1.42),('8348','2013-08-05','18:10:00',1.35),('8348','2013-08-05','18:15:00',1.27),('8348','2013-08-05','18:20:00',1.2),('8348','2013-08-05','18:25:00',1.14),('8348','2013-08-05','18:30:00',1.07),('8348','2013-08-04','08:25:00',1.03),('8348','2013-08-04','08:30:00',1.15),('8348','2013-08-04','08:35:00',1.22),('8348','2013-08-04','08:40:00',1.3),('8348','2013-08-04','08:45:00',1.38),('8348','2013-08-04','08:50:00',1.47),('8348','2013-08-04','08:55:00',1.54),('8348','2013-08-04','09:00:00',1.61),('8348','2013-08-04','09:05:00',1.68),('8348','2013-08-04','09:10:00',1.74),('8348','2013-08-04','09:15:00',1.79),('8348','2013-08-04','09:20:00',1.85),('8348','2013-08-04','09:25:00',1.92),('8348','2013-08-04','09:30:00',1.99),('8348','2013-08-04','09:35:00',2.05),('8348','2013-08-04','09:40:00',2.1),('8348','2013-08-04','09:45:00',2.16),('8348','2013-08-04','09:50:00',2.21),('8348','2013-08-04','09:55:00',2.27),('8348','2013-08-04','10:00:00',2.32),('8348','2013-08-04','10:05:00',2.37),('8348','2013-08-04','10:10:00',2.42),('8348','2013-08-04','10:15:00',2.47),('8348','2013-08-04','10:20:00',2.52),('8348','2013-08-04','10:25:00',2.56),('8348','2013-08-04','10:30:00',2.6),('8348','2013-08-04','10:35:00',2.64),('8348','2013-08-04','10:40:00',2.69),('8348','2013-08-04','10:45:00',2.73),('8348','2013-08-04','10:50:00',2.76),('8348','2013-08-04','10:55:00',2.79),('8348','2013-08-04','11:00:00',2.82),('8348','2013-08-04','11:05:00',2.86),('8348','2013-08-04','11:10:00',2.88),('8348','2013-08-04','11:15:00',2.92),('8348','2013-08-04','11:20:00',2.96),('8348','2013-08-04','11:25:00',3.01),('8348','2013-08-04','11:30:00',3.05),('8348','2013-08-04','11:35:00',3.08),('8348','2013-08-04','11:40:00',3.09),('8348','2013-08-04','11:45:00',3.12),('8348','2013-08-04','11:50:00',3.17),('8348','2013-08-04','11:55:00',3.19),('8348','2013-08-04','12:00:00',3.22),('8348','2013-08-04','12:05:00',3.24),('8348','2013-08-04','12:10:00',3.22),('8348','2013-08-04','12:15:00',3.27),('8348','2013-08-04','12:20:00',3.25),('8348','2013-08-04','12:25:00',3.25),('8348','2013-08-04','12:30:00',3.26),('8348','2013-08-04','12:35:00',3.31),('8348','2013-08-04','12:40:00',3.33),('8348','2013-08-04','12:45:00',3.37),('8348','2013-08-04','12:50:00',3.39),('8348','2013-08-04','12:55:00',3.37),('8348','2013-08-04','13:00:00',3.36),('8348','2013-08-04','13:05:00',3.33),('8348','2013-08-04','13:10:00',3.32),('8348','2013-08-04','13:15:00',3.36),('8348','2013-08-04','13:20:00',3.33),('8348','2013-08-04','13:25:00',3.35),('8348','2013-08-04','13:30:00',3.36),('8348','2013-08-04','13:35:00',3.44),('8348','2013-08-04','13:40:00',3.51),('8348','2013-08-04','13:45:00',3.51),('8348','2013-08-04','13:50:00',3.51),('8348','2013-08-04','13:55:00',3.5),('8348','2013-08-04','14:00:00',3.53),('8348','2013-08-04','14:05:00',3.51),('8348','2013-08-04','14:10:00',3.51),('8348','2013-08-04','14:15:00',3.48),('8348','2013-08-04','14:20:00',3.46),('8348','2013-08-04','14:25:00',3.44),('8348','2013-08-04','14:30:00',3.43),('8348','2013-08-04','14:35:00',3.4),('8348','2013-08-04','14:40:00',3.4),('8348','2013-08-04','14:45:00',3.36),('8348','2013-08-04','14:50:00',3.34),('8348','2013-08-04','14:55:00',3.34),('8348','2013-08-04','15:00:00',3.31),('8348','2013-08-04','15:05:00',3.28),('8348','2013-08-04','15:10:00',3.28),('8348','2013-08-04','15:15:00',3.26),('8348','2013-08-04','15:20:00',3.23),('8348','2013-08-04','15:25:00',3.17),('8348','2013-08-04','15:30:00',3.13),('8348','2013-08-04','15:35:00',3.15),('8348','2013-08-04','15:40:00',3.08),('8348','2013-08-04','15:45:00',3.05),('8348','2013-08-04','15:50:00',3.02),('8348','2013-08-04','15:55:00',2.99),('8348','2013-08-04','16:00:00',2.94),('8348','2013-08-04','16:05:00',2.94),('8348','2013-08-04','16:10:00',2.89),('8348','2013-08-04','16:15:00',2.87),('8348','2013-08-04','16:20:00',2.84),('8348','2013-08-04','16:25:00',2.77),('8348','2013-08-04','16:30:00',2.71),('8348','2013-08-04','16:35:00',2.66),('8348','2013-08-04','16:40:00',2.62),('8348','2013-08-04','16:45:00',2.54),('8348','2013-08-04','16:50:00',2.48),('8348','2013-08-04','16:55:00',2.42),('8348','2013-08-04','17:00:00',2.37),('8348','2013-08-04','17:05:00',2.34),('8348','2013-08-04','17:10:00',2.28),('8348','2013-08-04','17:15:00',2.2),('8348','2013-08-04','17:20:00',2.14),('8348','2013-08-04','17:25:00',2.08),('8348','2013-08-04','17:30:00',2.01),('8348','2013-08-04','17:35:00',1.94),('8348','2013-08-04','17:40:00',1.87),('8348','2013-08-04','17:45:00',1.8),('8348','2013-08-04','17:50:00',1.74),('8348','2013-08-04','17:55:00',1.65),('8348','2013-08-04','18:00:00',1.58),('8348','2013-08-04','18:05:00',1.49),('8348','2013-08-04','18:10:00',1.41),('8348','2013-08-04','18:15:00',1.34),('8348','2013-08-04','18:20:00',1.28),('8348','2013-08-04','18:25:00',1.19),('8348','2013-08-04','18:30:00',1.12),('8348','2013-08-04','18:35:00',1.04),('8348','2013-08-03','08:25:00',1.03),('8348','2013-08-03','08:30:00',1.15),('8348','2013-08-03','08:35:00',1.21),('8348','2013-08-03','08:40:00',1.29),('8348','2013-08-03','08:45:00',1.38),('8348','2013-08-03','08:50:00',1.46),('8348','2013-08-03','08:55:00',1.53),('8348','2013-08-03','09:00:00',1.59),('8348','2013-08-03','09:05:00',1.66),('8348','2013-08-03','09:10:00',1.72),('8348','2013-08-03','09:15:00',1.79),('8348','2013-08-03','09:20:00',1.85),('8348','2013-08-03','09:25:00',1.92),('8348','2013-08-03','09:30:00',1.97),('8348','2013-08-03','09:35:00',2.03),('8348','2013-08-03','09:40:00',2.08),('8348','2013-08-03','09:45:00',2.14),('8348','2013-08-03','09:50:00',2.19),('8348','2013-08-03','09:55:00',2.25),('8348','2013-08-03','10:00:00',2.3),('8348','2013-08-03','10:05:00',2.36),('8348','2013-08-03','10:10:00',2.4),('8348','2013-08-03','10:15:00',2.47),('8348','2013-08-03','10:20:00',2.52),('8348','2013-08-03','10:25:00',2.56),('8348','2013-08-03','10:30:00',2.6),('8348','2013-08-03','10:35:00',2.64),('8348','2013-08-03','10:40:00',2.68),('8348','2013-08-03','10:45:00',2.72),('8348','2013-08-03','10:50:00',2.76),('8348','2013-08-03','10:55:00',2.79),('8348','2013-08-03','11:00:00',2.8),('8348','2013-08-03','11:05:00',2.85),('8348','2013-08-03','11:10:00',2.93),('8348','2013-08-03','11:15:00',2.94),('8348','2013-08-03','11:20:00',2.98),('8348','2013-08-03','11:25:00',2.98),('8348','2013-08-03','11:30:00',3.04),('8348','2013-08-03','11:35:00',3.04),('8348','2013-08-03','11:40:00',3.04),('8348','2013-08-03','11:45:00',3.11),('8348','2013-08-03','11:50:00',3.13),('8348','2013-08-03','11:55:00',3.14),('8348','2013-08-03','12:00:00',3.16),('8348','2013-08-03','12:05:00',3.16),('8348','2013-08-03','12:10:00',3.17),('8348','2013-08-03','12:15:00',3.14),('8348','2013-08-03','12:20:00',3.18),('8348','2013-08-03','12:25:00',3.19),('8348','2013-08-03','12:30:00',3.19),('8348','2013-08-03','12:35:00',3.21),('8348','2013-08-03','12:40:00',3.2),('8348','2013-08-03','12:45:00',3.23),('8348','2013-08-03','12:50:00',3.27),('8348','2013-08-03','12:55:00',3.28),('8348','2013-08-03','13:00:00',3.33),('8348','2013-08-03','13:05:00',3.33),('8348','2013-08-03','13:10:00',3.28),('8348','2013-08-03','13:15:00',3.26),('8348','2013-08-03','13:20:00',3.22),('8348','2013-08-03','13:25:00',3.25),('8348','2013-08-03','13:30:00',3.25),('8348','2013-08-03','13:35:00',3.26),('8348','2013-08-03','13:40:00',3.32),('8348','2013-08-03','13:45:00',3.35),('8348','2013-08-03','13:50:00',3.36),('8348','2013-08-03','13:55:00',3.35),('8348','2013-08-03','14:00:00',3.37),('8348','2013-08-03','14:05:00',3.34),('8348','2013-08-03','14:10:00',3.28),('8348','2013-08-03','14:15:00',3.19),('8348','2013-08-03','14:20:00',3.22),('8348','2013-08-03','14:25:00',3.24),('8348','2013-08-03','14:30:00',3.31),('8348','2013-08-03','14:35:00',3.4),('8348','2013-08-03','14:40:00',3.38),('8348','2013-08-03','14:45:00',3.37),('8348','2013-08-03','14:50:00',3.37),('8348','2013-08-03','14:55:00',3.38),('8348','2013-08-03','15:00:00',3.34),('8348','2013-08-03','15:05:00',3.3),('8348','2013-08-03','15:10:00',3.23),('8348','2013-08-03','15:15:00',3.2),('8348','2013-08-03','15:20:00',3.19),('8348','2013-08-03','15:25:00',3.19),('8348','2013-08-03','15:30:00',3.17),('8348','2013-08-03','15:35:00',3.14),('8348','2013-08-03','15:40:00',3.1),('8348','2013-08-03','15:45:00',3.08),('8348','2013-08-03','15:50:00',3.07),('8348','2013-08-03','15:55:00',3.01),('8348','2013-08-03','16:00:00',2.96),('8348','2013-08-03','16:05:00',2.91),('8348','2013-08-03','16:10:00',2.86),('8348','2013-08-03','16:15:00',2.79),('8348','2013-08-03','16:20:00',2.73),('8348','2013-08-03','16:25:00',2.68),('8348','2013-08-03','16:30:00',2.66),('8348','2013-08-03','16:35:00',2.63),('8348','2013-08-03','16:40:00',2.59),('8348','2013-08-03','16:45:00',2.54),('8348','2013-08-03','16:50:00',2.48),('8348','2013-08-03','16:55:00',2.45),('8348','2013-08-03','17:00:00',2.38),('8348','2013-08-03','17:05:00',2.32),('8348','2013-08-03','17:10:00',2.26),('8348','2013-08-03','17:15:00',2.19),('8348','2013-08-03','17:20:00',2.13),('8348','2013-08-03','17:25:00',2.07),('8348','2013-08-03','17:30:00',2.01),('8348','2013-08-03','17:35:00',1.96),('8348','2013-08-03','17:40:00',1.88),('8348','2013-08-03','17:45:00',1.81),('8348','2013-08-03','17:50:00',1.73),('8348','2013-08-03','17:55:00',1.66),('8348','2013-08-03','18:00:00',1.58),('8348','2013-08-03','18:05:00',1.52),('8348','2013-08-03','18:10:00',1.45),('8348','2013-08-03','18:15:00',1.37),('8348','2013-08-03','18:20:00',1.31),('8348','2013-08-03','18:25:00',1.24),('8348','2013-08-03','18:30:00',1.17),('8348','2013-08-03','18:35:00',1.1),('8348','2013-08-03','18:40:00',1.02),('8348','2013-08-02','08:20:00',1.02),('8348','2013-08-02','08:25:00',1.08),('8348','2013-08-02','08:30:00',1.2),('8348','2013-08-02','08:35:00',1.28),('8348','2013-08-02','08:40:00',1.36),('8348','2013-08-02','08:45:00',1.43),('8348','2013-08-02','08:50:00',1.53),('8348','2013-08-02','08:55:00',1.59),('8348','2013-08-02','09:00:00',1.66),('8348','2013-08-02','09:05:00',1.73),('8348','2013-08-02','09:10:00',1.79),('8348','2013-08-02','09:15:00',1.85),('8348','2013-08-02','09:20:00',1.92),('8348','2013-08-02','09:25:00',1.98),('8348','2013-08-02','09:30:00',2.04),('8348','2013-08-02','09:35:00',2.09),('8348','2013-08-02','09:40:00',2.15),('8348','2013-08-02','09:45:00',2.2),('8348','2013-08-02','09:50:00',2.25),('8348','2013-08-02','09:55:00',2.32),('8348','2013-08-02','10:00:00',2.36),('8348','2013-08-02','10:05:00',2.4),('8348','2013-08-02','10:10:00',2.46),('8348','2013-08-02','10:15:00',2.51),('8348','2013-08-02','10:20:00',2.56),('8348','2013-08-02','10:25:00',2.6),('8348','2013-08-02','10:30:00',2.64),('8348','2013-08-02','10:35:00',2.68),('8348','2013-08-02','10:40:00',2.72),('8348','2013-08-02','10:45:00',2.77),('8348','2013-08-02','10:50:00',2.81),('8348','2013-08-02','10:55:00',2.83),('8348','2013-08-02','11:00:00',2.87),('8348','2013-08-02','11:05:00',2.91),('8348','2013-08-02','11:10:00',2.93),('8348','2013-08-02','11:15:00',2.96),('8348','2013-08-02','11:20:00',2.99),('8348','2013-08-02','11:25:00',3.04),('8348','2013-08-02','11:30:00',3.06),('8348','2013-08-02','11:35:00',3.09),('8348','2013-08-02','11:40:00',3.11),('8348','2013-08-02','11:45:00',3.12),('8348','2013-08-02','11:50:00',3.15),('8348','2013-08-02','11:55:00',3.2),('8348','2013-08-02','12:00:00',3.23),('8348','2013-08-02','12:05:00',3.23),('8348','2013-08-02','12:10:00',3.26),('8348','2013-08-02','12:15:00',3.28),('8348','2013-08-02','12:20:00',3.29),('8348','2013-08-02','12:25:00',3.3),('8348','2013-08-02','12:30:00',3.29),('8348','2013-08-02','12:35:00',3.28),('8348','2013-08-02','12:40:00',3.28),('8348','2013-08-02','12:45:00',3.31),('8348','2013-08-02','12:50:00',3.34),('8348','2013-08-02','12:55:00',3.35),('8348','2013-08-02','13:00:00',3.4),('8348','2013-08-02','13:05:00',3.41),('8348','2013-08-02','13:10:00',3.43),('8348','2013-08-02','13:15:00',3.41),('8348','2013-08-02','13:20:00',3.39),('8348','2013-08-02','13:25:00',3.37),('8348','2013-08-02','13:30:00',3.39),('8348','2013-08-02','13:35:00',3.43),('8348','2013-08-02','13:40:00',3.45),('8348','2013-08-02','13:45:00',3.42),('8348','2013-08-02','13:50:00',3.43),('8348','2013-08-02','13:55:00',3.42),('8348','2013-08-02','14:00:00',3.39),('8348','2013-08-02','14:05:00',3.41),('8348','2013-08-02','14:10:00',3.35),('8348','2013-08-02','14:15:00',3.31),('8348','2013-08-02','14:20:00',3.29),('8348','2013-08-02','14:25:00',3.26),('8348','2013-08-02','14:30:00',3.28),('8348','2013-08-02','14:35:00',3.36),('8348','2013-08-02','14:40:00',3.4),('8348','2013-08-02','14:45:00',3.42),('8348','2013-08-02','14:50:00',3.41),('8348','2013-08-02','14:55:00',3.39),('8348','2013-08-02','15:00:00',3.38),('8348','2013-08-02','15:05:00',3.36),('8348','2013-08-02','15:10:00',3.31),('8348','2013-08-02','15:15:00',3.24),('8348','2013-08-02','15:20:00',3.27),('8348','2013-08-02','15:25:00',3.27),('8348','2013-08-02','15:30:00',3.24),('8348','2013-08-02','15:35:00',3.22),('8348','2013-08-02','15:40:00',3.17),('8348','2013-08-02','15:45:00',3.14),('8348','2013-08-02','15:50:00',3.12),('8348','2013-08-02','15:55:00',3.06),('8348','2013-08-02','16:00:00',3.04),('8348','2013-08-02','16:05:00',2.99),('8348','2013-08-02','16:10:00',2.93),('8348','2013-08-02','16:15:00',2.9),('8348','2013-08-02','16:20:00',2.86),('8348','2013-08-02','16:25:00',2.81),('8348','2013-08-02','16:30:00',2.77),('8348','2013-08-02','16:35:00',2.74),('8348','2013-08-02','16:40:00',2.68),('8348','2013-08-02','16:45:00',2.61),('8348','2013-08-02','16:50:00',2.57),('8348','2013-08-02','16:55:00',2.49),('8348','2013-08-02','17:00:00',2.42),('8348','2013-08-02','17:05:00',2.37),('8348','2013-08-02','17:10:00',2.31),('8348','2013-08-02','17:15:00',2.26),('8348','2013-08-02','17:20:00',2.2),('8348','2013-08-02','17:25:00',2.14),('8348','2013-08-02','17:30:00',2.06),('8348','2013-08-02','17:35:00',2),('8348','2013-08-02','17:40:00',1.95),('8348','2013-08-02','17:45:00',1.87),('8348','2013-08-02','17:50:00',1.79),('8348','2013-08-02','17:55:00',1.72),('8348','2013-08-02','18:00:00',1.65),('8348','2013-08-02','18:05:00',1.58),('8348','2013-08-02','18:10:00',1.51),('8348','2013-08-02','18:15:00',1.43),('8348','2013-08-02','18:20:00',1.36),('8348','2013-08-02','18:25:00',1.29),('8348','2013-08-02','18:30:00',1.21),('8348','2013-08-02','18:35:00',1.13),('8348','2013-08-02','18:40:00',1.05),('8348','2013-08-01','08:20:00',1.02),('8348','2013-08-01','08:25:00',1.1),('8348','2013-08-01','08:30:00',1.22),('8348','2013-08-01','08:35:00',1.31),('8348','2013-08-01','08:40:00',1.36),('8348','2013-08-01','08:45:00',1.47),('8348','2013-08-01','08:50:00',1.56),('8348','2013-08-01','08:55:00',1.63),('8348','2013-08-01','09:00:00',1.7),('8348','2013-08-01','09:05:00',1.76),('8348','2013-08-01','09:10:00',1.84),('8348','2013-08-01','09:15:00',1.91),('8348','2013-08-01','09:20:00',1.97),('8348','2013-08-01','09:25:00',2.04),('8348','2013-08-01','09:30:00',2.1),('8348','2013-08-01','09:35:00',2.16),('8348','2013-08-01','09:40:00',2.23),('8348','2013-08-01','09:45:00',2.29),('8348','2013-08-01','09:50:00',2.35),('8348','2013-08-01','09:55:00',2.4),('8348','2013-08-01','10:00:00',2.47),('8348','2013-08-01','10:05:00',2.53),('8348','2013-08-01','10:10:00',2.59),('8348','2013-08-01','10:15:00',2.65),('8348','2013-08-01','10:20:00',2.68),('8348','2013-08-01','10:25:00',2.74),('8348','2013-08-01','10:30:00',2.79),('8348','2013-08-01','10:35:00',2.83),('8348','2013-08-01','10:40:00',2.87),('8348','2013-08-01','10:45:00',2.91),('8348','2013-08-01','10:50:00',2.97),('8348','2013-08-01','10:55:00',3.01),('8348','2013-08-01','11:00:00',3.05),('8348','2013-08-01','11:05:00',3.11),('8348','2013-08-01','11:10:00',3.15),('8348','2013-08-01','11:15:00',3.19),('8348','2013-08-01','11:20:00',3.2),('8348','2013-08-01','11:25:00',3.24),('8348','2013-08-01','11:30:00',3.26),('8348','2013-08-01','11:35:00',3.3),('8348','2013-08-01','11:40:00',3.35),('8348','2013-08-01','11:45:00',3.37),('8348','2013-08-01','11:50:00',3.4),('8348','2013-08-01','11:55:00',3.42),('8348','2013-08-01','12:00:00',3.45),('8348','2013-08-01','12:05:00',3.47),('8348','2013-08-01','12:10:00',3.46),('8348','2013-08-01','12:15:00',3.5),('8348','2013-08-01','12:20:00',3.51),('8348','2013-08-01','12:25:00',3.53),('8348','2013-08-01','12:30:00',3.54),('8348','2013-08-01','12:35:00',3.57),('8348','2013-08-01','12:40:00',3.58),('8348','2013-08-01','12:45:00',3.58),('8348','2013-08-01','12:50:00',3.62),('8348','2013-08-01','12:55:00',3.61),('8348','2013-08-01','13:00:00',3.6),('8348','2013-08-01','13:05:00',3.59),('8348','2013-08-01','13:10:00',3.61),('8348','2013-08-01','13:15:00',3.48),('8348','2013-08-01','13:20:00',3.61),('8348','2013-08-01','13:25:00',3.65),('8348','2013-08-01','13:30:00',3.67),('8348','2013-08-01','13:35:00',2.96),('8348','2013-08-01','13:40:00',3.69),('8348','2013-08-01','13:45:00',3.66),('8348','2013-08-01','13:50:00',3.5),('8348','2013-08-01','13:55:00',3.62),('8348','2013-08-01','14:00:00',3.67),('8348','2013-08-01','14:05:00',3.6),('8348','2013-08-01','14:10:00',3.57),('8348','2013-08-01','14:15:00',3.52),('8348','2013-08-01','14:20:00',3.5),('8348','2013-08-01','14:25:00',3.5),('8348','2013-08-01','14:30:00',3.5),('8348','2013-08-01','14:35:00',3.06),('8348','2013-08-01','14:40:00',3.36),('8348','2013-08-01','14:45:00',3.5),('8348','2013-08-01','14:50:00',2.31),('8348','2013-08-01','14:55:00',3.46),('8348','2013-08-01','15:00:00',3.37),('8348','2013-08-01','15:05:00',3.39),('8348','2013-08-01','15:10:00',3.29),('8348','2013-08-01','15:15:00',3.26),('8348','2013-08-01','15:20:00',3.36),('8348','2013-08-01','15:25:00',3.32),('8348','2013-08-01','15:30:00',3.24),('8348','2013-08-01','15:35:00',3.24),('8348','2013-08-01','15:40:00',2.19),('8348','2013-08-01','15:45:00',3.17),('8348','2013-08-01','15:50:00',3.12),('8348','2013-08-01','15:55:00',3.11),('8348','2013-08-01','16:00:00',3.11),('8348','2013-08-01','16:05:00',3.07),('8348','2013-08-01','16:10:00',2.98),('8348','2013-08-01','16:15:00',2.92),('8348','2013-08-01','16:20:00',2.89),('8348','2013-08-01','16:25:00',2.83),('8348','2013-08-01','16:30:00',2.78),('8348','2013-08-01','16:35:00',2.73),('8348','2013-08-01','16:40:00',2.68),('8348','2013-08-01','16:45:00',2.62),('8348','2013-08-01','16:50:00',2.57),('8348','2013-08-01','16:55:00',2.52),('8348','2013-08-01','17:00:00',2.46),('8348','2013-08-01','17:05:00',2.4),('8348','2013-08-01','17:10:00',2.34),('8348','2013-08-01','17:15:00',2.28),('8348','2013-08-01','17:20:00',2.23),('8348','2013-08-01','17:25:00',2.16),('8348','2013-08-01','17:30:00',2.11),('8348','2013-08-01','17:35:00',2.05),('8348','2013-08-01','17:40:00',1.97),('8348','2013-08-01','17:45:00',1.9),('8348','2013-08-01','17:50:00',1.83),('8348','2013-08-01','17:55:00',1.78),('8348','2013-08-01','18:00:00',1.71),('8348','2013-08-01','18:05:00',1.63),('8348','2013-08-01','18:10:00',1.56),('8348','2013-08-01','18:15:00',1.49),('8348','2013-08-01','18:20:00',1.42),('8348','2013-08-01','18:25:00',1.34),('8348','2013-08-01','18:30:00',1.27),('8348','2013-08-01','18:35:00',1.19),('8348','2013-08-01','18:40:00',1.11),('8348','2013-08-01','18:45:00',1.04),('8348','2013-07-31','08:20:00',1.05),('8348','2013-07-31','08:25:00',1.15),('8348','2013-07-31','08:30:00',1.21),('8348','2013-07-31','08:35:00',1.34),('8348','2013-07-31','08:40:00',1.41),('8348','2013-07-31','08:45:00',1.52),('8348','2013-07-31','08:50:00',1.6),('8348','2013-07-31','08:55:00',1.67),('8348','2013-07-31','09:00:00',1.74),('8348','2013-07-31','09:05:00',1.8),('8348','2013-07-31','09:10:00',1.88),('8348','2013-07-31','09:15:00',1.94),('8348','2013-07-31','09:20:00',2),('8348','2013-07-31','09:25:00',2.06),('8348','2013-07-31','09:30:00',2.13),('8348','2013-07-31','09:35:00',2.2),('8348','2013-07-31','09:40:00',2.26),('8348','2013-07-31','09:45:00',2.31),('8348','2013-07-31','09:50:00',2.36),('8348','2013-07-31','09:55:00',2.41),('8348','2013-07-31','10:00:00',2.46),('8348','2013-07-31','10:05:00',2.52),('8348','2013-07-31','10:10:00',2.58),('8348','2013-07-31','10:15:00',2.66),('8348','2013-07-31','10:20:00',2.7),('8348','2013-07-31','10:25:00',2.72),('8348','2013-07-31','10:30:00',2.76),('8348','2013-07-31','10:35:00',2.83),('8348','2013-07-31','10:40:00',2.9),('8348','2013-07-31','10:45:00',2.96),('8348','2013-07-31','10:50:00',3),('8348','2013-07-31','10:55:00',3.05),('8348','2013-07-31','11:00:00',3.09),('8348','2013-07-31','11:05:00',3.13),('8348','2013-07-31','11:10:00',3.16),('8348','2013-07-31','11:15:00',3.19),('8348','2013-07-31','11:20:00',3.23),('8348','2013-07-31','11:25:00',3.27),('8348','2013-07-31','11:30:00',3.3),('8348','2013-07-31','11:35:00',3.32),('8348','2013-07-31','11:40:00',3.34),('8348','2013-07-31','11:45:00',3.38),('8348','2013-07-31','11:50:00',3.45),('8348','2013-07-31','11:55:00',3.48),('8348','2013-07-31','12:00:00',3.46),('8348','2013-07-31','12:05:00',3.45),('8348','2013-07-31','12:10:00',3.45),('8348','2013-07-31','12:15:00',3.51),('8348','2013-07-31','12:20:00',3.51),('8348','2013-07-31','12:25:00',3.6),('8348','2013-07-31','12:30:00',3.57),('8348','2013-07-31','12:35:00',3.56),('8348','2013-07-31','12:40:00',3.62),('8348','2013-07-31','12:45:00',2.98),('8348','2013-07-31','12:50:00',2.01),('8348','2013-07-31','12:55:00',3.41),('8348','2013-07-31','13:00:00',1.41),('8348','2013-07-31','13:05:00',3.33),('8348','2013-07-31','13:10:00',3.57),('8348','2013-07-31','13:15:00',3.69),('8348','2013-07-31','13:20:00',3.6),('8348','2013-07-31','13:25:00',3.18),('8348','2013-07-31','13:30:00',3.67),('8348','2013-07-31','13:35:00',3.66),('8348','2013-07-31','13:40:00',3.66),('8348','2013-07-31','13:45:00',3.73),('8348','2013-07-31','13:50:00',3.8),('8348','2013-07-31','13:55:00',1.75),('8348','2013-07-31','14:00:00',3.68),('8348','2013-07-31','14:05:00',3.72),('8348','2013-07-31','14:10:00',3.22),('8348','2013-07-31','14:15:00',3.16),('8348','2013-07-31','14:20:00',3.23),('8348','2013-07-31','14:25:00',3.17),('8348','2013-07-31','14:30:00',3.62),('8348','2013-07-31','14:35:00',3.53),('8348','2013-07-31','14:40:00',3.57),('8348','2013-07-31','14:45:00',3.51),('8348','2013-07-31','14:50:00',3.24),('8348','2013-07-31','14:55:00',2.21),('8348','2013-07-31','15:00:00',1.7),('8348','2013-07-31','15:05:00',3.64),('8348','2013-07-31','15:10:00',3.29),('8348','2013-07-31','15:15:00',2.51),('8348','2013-07-31','15:20:00',3.24),('8348','2013-07-31','15:25:00',3.09),('8348','2013-07-31','15:30:00',3.23),('8348','2013-07-31','15:35:00',3.34),('8348','2013-07-31','15:40:00',3.3),('8348','2013-07-31','15:45:00',3.19),('8348','2013-07-31','15:50:00',3.15),('8348','2013-07-31','15:55:00',3.09),('8348','2013-07-31','16:00:00',3.02),('8348','2013-07-31','16:05:00',3.03),('8348','2013-07-31','16:10:00',3.02),('8348','2013-07-31','16:15:00',2.95),('8348','2013-07-31','16:20:00',2.97),('8348','2013-07-31','16:25:00',2.97),('8348','2013-07-31','16:30:00',2.9),('8348','2013-07-31','16:35:00',2.71),('8348','2013-07-31','16:40:00',2.65),('8348','2013-07-31','16:45:00',2.59),('8348','2013-07-31','16:50:00',2.56),('8348','2013-07-31','16:55:00',2.5),('8348','2013-07-31','17:00:00',2.38),('8348','2013-07-31','17:05:00',2.15),('8348','2013-07-31','17:10:00',2.32),('8348','2013-07-31','17:15:00',1.86),('8348','2013-07-31','17:20:00',1.85),('8348','2013-07-31','17:25:00',2.18),('8348','2013-07-31','17:30:00',2.05),('8348','2013-07-31','17:35:00',1.97),('8348','2013-07-31','17:40:00',1.96),('8348','2013-07-31','17:45:00',1.86),('8348','2013-07-31','17:50:00',1.81),('8348','2013-07-31','17:55:00',1.74),('8348','2013-07-31','18:00:00',1.68),('8348','2013-07-31','18:05:00',1.61),('8348','2013-07-31','18:10:00',1.54),('8348','2013-07-31','18:15:00',1.49),('8348','2013-07-31','18:20:00',1.43),('8348','2013-07-31','18:25:00',1.37),('8348','2013-07-31','18:30:00',1.3),('8348','2013-07-31','18:35:00',1.23),('8348','2013-07-31','18:40:00',1.15),('8348','2013-07-31','18:45:00',1.07),('8348','2014-04-08','06:50:00',1.04),('8348','2014-04-08','07:00:00',1.05),('8348','2014-04-08','07:05:00',1.13),('8348','2014-04-08','07:10:00',1.33),('8348','2014-04-08','07:15:00',1.67),('8348','2014-04-08','07:20:00',1.84),('8348','2014-04-08','07:25:00',1.4),('8348','2014-04-08','07:30:00',1.76),('8348','2014-04-08','07:35:00',1.74),('8348','2014-04-08','07:40:00',1.56),('8348','2014-04-08','07:45:00',1.99),('8348','2014-04-08','07:50:00',2.06),('8348','2014-04-08','07:55:00',2.19),('8348','2014-04-08','08:00:00',2.35),('8348','2014-04-08','08:05:00',2.46),('8348','2014-04-08','08:10:00',2.67),('8348','2014-04-08','08:15:00',2.97),('8348','2014-04-08','08:20:00',3.17),('8348','2014-04-08','08:25:00',3.34),('8348','2014-04-08','08:30:00',3.48),('8348','2014-04-08','08:35:00',3.59),('8348','2014-04-08','08:40:00',3.68),('8348','2014-04-08','08:45:00',3.84),('8348','2014-04-08','08:50:00',3.95),('8348','2014-04-08','08:55:00',4.04),('8348','2014-04-08','09:00:00',4.13),('8348','2014-04-08','09:05:00',4.17),('8348','2014-04-08','09:10:00',4.34),('8348','2014-04-08','09:15:00',4.62),('8348','2014-04-08','09:20:00',4.7),('8348','2014-04-08','09:25:00',4.78),('8348','2014-04-08','09:30:00',4.94),('8348','2014-04-08','09:35:00',5.04),('8348','2014-04-08','09:40:00',5.04),('8348','2014-04-08','09:45:00',5.07),('8348','2014-04-08','09:50:00',5.24),('8348','2014-04-08','09:55:00',5.33),('8348','2014-04-08','10:00:00',5.25),('8348','2014-04-08','10:05:00',5.6),('8348','2014-04-08','10:10:00',5.72),('8348','2014-04-08','10:15:00',5.78),('8348','2014-04-08','10:20:00',5.99),('8348','2014-04-08','10:25:00',6.01),('8348','2014-04-08','10:30:00',5.83),('8348','2014-04-08','10:35:00',5.76),('8348','2014-04-08','10:40:00',6.1),('8348','2014-04-08','10:45:00',6.2),('8348','2014-04-08','10:50:00',6.1),('8348','2014-04-08','10:55:00',6.32),('8348','2014-04-08','11:00:00',6.4),('8348','2014-04-08','11:05:00',6.24),('8348','2014-04-08','11:10:00',6.18),('8348','2014-04-08','11:15:00',5.83),('8348','2014-04-08','11:20:00',5.98),('8348','2014-04-08','11:25:00',5.89),('8348','2014-04-08','11:30:00',7.03),('8348','2014-04-08','11:35:00',6.92),('8348','2014-04-08','11:40:00',5.79),('8348','2014-04-08','11:45:00',4.81),('8348','2014-04-08','11:50:00',6.02),('8348','2014-04-08','11:55:00',6.84),('8348','2014-04-08','12:00:00',6.46),('8348','2014-04-08','12:05:00',6.91),('8348','2014-04-08','12:10:00',6.97),('8348','2014-04-08','12:15:00',7.17),('8348','2014-04-08','12:20:00',7.08),('8348','2014-04-08','12:25:00',7.1),('8348','2014-04-08','12:30:00',7.16),('8348','2014-04-08','12:35:00',7.23),('8348','2014-04-08','12:40:00',7.21),('8348','2014-04-08','12:45:00',7.08),('8348','2014-04-08','12:50:00',7.17),('8348','2014-04-08','12:55:00',7.17),('8348','2014-04-08','13:00:00',7.09),('8348','2014-04-08','13:05:00',7.1),('8348','2014-04-08','13:10:00',7.18),('8348','2014-04-08','13:15:00',7.14),('8348','2014-04-08','13:20:00',6.66),('8348','2014-04-08','13:25:00',6.76),('8348','2014-04-08','13:30:00',7.06),('8348','2014-04-08','13:35:00',6.63),('8348','2014-04-08','13:40:00',6.27),('8348','2014-04-08','13:45:00',5.99),('8348','2014-04-08','13:50:00',6.69),('8348','2014-04-08','13:55:00',6.92),('8348','2014-04-08','14:00:00',6.75),('8348','2014-04-08','14:05:00',6.62),('8348','2014-04-08','14:10:00',6.65),('8348','2014-04-08','14:15:00',6.55),('8348','2014-04-08','14:20:00',6.39),('8348','2014-04-08','14:25:00',6.33),('8348','2014-04-08','14:30:00',5.74),('8348','2014-04-08','14:35:00',6.13),('8348','2014-04-08','14:40:00',6.1),('8348','2014-04-08','14:45:00',5.78),('8348','2014-04-08','14:50:00',5.93),('8348','2014-04-08','14:55:00',5.84),('8348','2014-04-08','15:00:00',5.59),('8348','2014-04-08','15:05:00',5.48),('8348','2014-04-08','15:10:00',5.28),('8348','2014-04-08','15:15:00',4.99),('8348','2014-04-08','15:20:00',4.56),('8348','2014-04-08','15:25:00',4.97),('8348','2014-04-08','15:30:00',5.19),('8348','2014-04-08','15:35:00',5.06),('8348','2014-04-08','15:40:00',4.74),('8348','2014-04-08','15:45:00',4.55),('8348','2014-04-08','15:50:00',4.65),('8348','2014-04-08','15:55:00',4.25),('8348','2014-04-08','16:00:00',4.02),('8348','2014-04-08','16:05:00',4.17),('8348','2014-04-08','16:10:00',3.94),('8348','2014-04-08','16:15:00',3.82),('8348','2014-04-08','16:20:00',3.68),('8348','2014-04-08','16:25:00',3.36),('8348','2014-04-08','16:30:00',3.11),('8348','2014-04-08','16:35:00',2.86),('8348','2014-04-08','16:40:00',2.84),('8348','2014-04-08','16:45:00',2.7),('8348','2014-04-08','16:50:00',2.59),('8348','2014-04-08','16:55:00',2.32),('8348','2014-04-08','17:00:00',2.32),('8348','2014-04-08','17:05:00',2.25),('8348','2014-04-08','17:10:00',2.04),('8348','2014-04-08','17:15:00',1.96),('8348','2014-04-08','17:20:00',1.73),('8348','2014-04-08','17:25:00',1.4),('8348','2014-04-08','17:30:00',1.14),('8348','2013-07-30','08:15:00',1.05),('8348','2013-07-30','08:20:00',1.21),('8348','2013-07-30','08:25:00',1.21),('8348','2013-07-30','08:30:00',1.25),('8348','2013-07-30','08:35:00',1.31),('8348','2013-07-30','08:40:00',1.39),('8348','2013-07-30','08:45:00',1.48),('8348','2013-07-30','08:50:00',1.56),('8348','2013-07-30','08:55:00',1.65),('8348','2013-07-30','09:00:00',1.72),('8348','2013-07-30','09:05:00',1.73),('8348','2013-07-30','09:10:00',1.87),('8348','2013-07-30','09:15:00',2),('8348','2013-07-30','09:20:00',2.11),('8348','2013-07-30','09:25:00',2.05),('8348','2013-07-30','09:30:00',1.47),('8348','2013-07-30','09:35:00',2.08),('8348','2013-07-30','09:40:00',1.78),('8348','2013-07-30','09:45:00',2.09),('8348','2013-07-30','09:50:00',2.43),('8348','2013-07-30','09:55:00',1.68),('8348','2013-07-30','10:00:00',1.98),('8348','2013-07-30','10:05:00',2.58),('8348','2013-07-30','10:10:00',2.69),('8348','2013-07-30','10:15:00',2.72),('8348','2013-07-30','10:20:00',2.8),('8348','2013-07-30','10:25:00',2.84),('8348','2013-07-30','10:30:00',2.86),('8348','2013-07-30','10:35:00',2.86),('8348','2013-07-30','10:40:00',2.85),('8348','2013-07-30','10:45:00',2.93),('8348','2013-07-30','10:50:00',2.88),('8348','2013-07-30','10:55:00',2.89),('8348','2013-07-30','11:00:00',2.98),('8348','2013-07-30','11:05:00',3.04),('8348','2013-07-30','11:10:00',2.46),('8348','2013-07-30','11:15:00',1.22),('8348','2013-07-30','11:20:00',2.5),('8348','2013-07-30','11:25:00',1.49),('8348','2013-07-30','11:30:00',1.74),('8348','2013-07-30','11:35:00',3.48),('8348','2013-07-30','11:40:00',3.39),('8348','2013-07-30','11:45:00',3.34),('8348','2013-07-30','11:50:00',3.43),('8348','2013-07-30','11:55:00',3.09),('8348','2013-07-30','12:00:00',3.28),('8348','2013-07-30','12:05:00',3.33),('8348','2013-07-30','12:10:00',3.26),('8348','2013-07-30','12:15:00',3.29),('8348','2013-07-30','12:20:00',3.41),('8348','2013-07-30','12:25:00',3.5),('8348','2013-07-30','12:30:00',3.53),('8348','2013-07-30','12:35:00',3.45),('8348','2013-07-30','12:40:00',1.08),('8348','2013-07-30','12:45:00',2.19),('8348','2013-07-30','12:50:00',3.81),('8348','2013-07-30','12:55:00',3.79),('8348','2013-07-30','13:00:00',2.8),('8348','2013-07-30','13:05:00',3.21),('8348','2013-07-30','13:10:00',3.04),('8348','2013-07-30','13:15:00',2.45),('8348','2013-07-30','13:20:00',3.8),('8348','2013-07-30','13:25:00',3.7),('8348','2013-07-30','13:30:00',3.96),('8348','2013-07-30','13:35:00',3.88),('8348','2013-07-30','13:40:00',3.87),('8348','2013-07-30','13:45:00',3.75),('8348','2013-07-30','13:50:00',3.86),('8348','2013-07-30','13:55:00',3.82),('8348','2013-07-30','14:00:00',3.74),('8348','2013-07-30','14:05:00',3.5),('8348','2013-07-30','14:10:00',3.81),('8348','2013-07-30','14:15:00',3.47),('8348','2013-07-30','14:20:00',3.65),('8348','2013-07-30','14:25:00',3.62),('8348','2013-07-30','14:30:00',3.56),('8348','2013-07-30','14:35:00',3.6),('8348','2013-07-30','14:40:00',3.58),('8348','2013-07-30','14:45:00',2.31),('8348','2013-07-30','14:50:00',3.57),('8348','2013-07-30','14:55:00',3.43),('8348','2013-07-30','15:00:00',3.47),('8348','2013-07-30','15:05:00',3.43),('8348','2013-07-30','15:10:00',3.29),('8348','2013-07-30','15:15:00',3.32),('8348','2013-07-30','15:20:00',3.31),('8348','2013-07-30','15:25:00',3.19),('8348','2013-07-30','15:30:00',3.25),('8348','2013-07-30','15:35:00',3.25),('8348','2013-07-30','15:40:00',3.2),('8348','2013-07-30','15:45:00',3.15),('8348','2013-07-30','15:50:00',3.11),('8348','2013-07-30','15:55:00',3.06),('8348','2013-07-30','16:00:00',3.05),('8348','2013-07-30','16:05:00',2.99),('8348','2013-07-30','16:10:00',2.92),('8348','2013-07-30','16:15:00',2.88),('8348','2013-07-30','16:20:00',2.85),('8348','2013-07-30','16:25:00',2.81),('8348','2013-07-30','16:30:00',2.73),('8348','2013-07-30','16:35:00',2.71),('8348','2013-07-30','16:40:00',2.68),('8348','2013-07-30','16:45:00',2.63),('8348','2013-07-30','16:50:00',2.56),('8348','2013-07-30','16:55:00',2.51),('8348','2013-07-30','17:00:00',2.47),('8348','2013-07-30','17:05:00',2.4),('8348','2013-07-30','17:10:00',2.33),('8348','2013-07-30','17:15:00',2.27),('8348','2013-07-30','17:20:00',2.22),('8348','2013-07-30','17:25:00',2.18),('8348','2013-07-30','17:30:00',2.09),('8348','2013-07-30','17:35:00',2.02),('8348','2013-07-30','17:40:00',1.96),('8348','2013-07-30','17:45:00',1.89),('8348','2013-07-30','17:50:00',1.8),('8348','2013-07-30','17:55:00',1.7),('8348','2013-07-30','18:00:00',1.64),('8348','2013-07-30','18:05:00',1.58),('8348','2013-07-30','18:10:00',1.51),('8348','2013-07-30','18:15:00',1.44),('8348','2013-07-30','18:20:00',1.37),('8348','2013-07-30','18:25:00',1.31),('8348','2013-07-30','18:30:00',1.22),('8348','2013-07-30','18:35:00',1.13),('8348','2013-07-30','18:40:00',1.05),('8348','2013-07-29','08:20:00',1.01),('8348','2013-07-29','08:25:00',1.06),('8348','2013-07-29','08:30:00',1.11),('8348','2013-07-29','08:35:00',1.16),('8348','2013-07-29','08:40:00',1.26),('8348','2013-07-29','08:45:00',1.36),('8348','2013-07-29','08:50:00',1.45),('8348','2013-07-29','08:55:00',1.5),('8348','2013-07-29','09:00:00',1.56),('8348','2013-07-29','09:05:00',1.63),('8348','2013-07-29','09:10:00',1.68),('8348','2013-07-29','09:15:00',1.74),('8348','2013-07-29','09:20:00',1.79),('8348','2013-07-29','09:25:00',1.86),('8348','2013-07-29','09:30:00',1.92),('8348','2013-07-29','09:35:00',1.96),('8348','2013-07-29','09:40:00',2.03),('8348','2013-07-29','09:45:00',2.12),('8348','2013-07-29','09:50:00',2.18),('8348','2013-07-29','09:55:00',2.22),('8348','2013-07-29','10:00:00',2.27),('8348','2013-07-29','10:05:00',2.33),('8348','2013-07-29','10:10:00',2.4),('8348','2013-07-29','10:15:00',2.43),('8348','2013-07-29','10:20:00',2.49),('8348','2013-07-29','10:25:00',2.57),('8348','2013-07-29','10:30:00',2.61),('8348','2013-07-29','10:35:00',2.63),('8348','2013-07-29','10:40:00',2.66),('8348','2013-07-29','10:45:00',2.74),('8348','2013-07-29','10:50:00',2.75),('8348','2013-07-29','10:55:00',2.8),('8348','2013-07-29','11:00:00',2.8),('8348','2013-07-29','11:05:00',2.87),('8348','2013-07-29','11:10:00',2.91),('8348','2013-07-29','11:15:00',2.91),('8348','2013-07-29','11:20:00',2.92),('8348','2013-07-29','11:25:00',2.99),('8348','2013-07-29','11:30:00',2.99),('8348','2013-07-29','11:35:00',2.97),('8348','2013-07-29','11:40:00',2.99),('8348','2013-07-29','11:45:00',3.02),('8348','2013-07-29','11:50:00',3.05),('8348','2013-07-29','11:55:00',3.08),('8348','2013-07-29','12:00:00',3.1),('8348','2013-07-29','12:05:00',3.14),('8348','2013-07-29','12:10:00',3.2),('8348','2013-07-29','12:15:00',3.23),('8348','2013-07-29','12:20:00',3.21),('8348','2013-07-29','12:25:00',3.22),('8348','2013-07-29','12:30:00',3.25),('8348','2013-07-29','12:35:00',3.29),('8348','2013-07-29','12:40:00',3.29),('8348','2013-07-29','12:45:00',3.27),('8348','2013-07-29','12:50:00',3.25),('8348','2013-07-29','12:55:00',3.25),('8348','2013-07-29','13:00:00',3.32),('8348','2013-07-29','13:05:00',3.37),('8348','2013-07-29','13:10:00',3.43),('8348','2013-07-29','13:15:00',3.45),('8348','2013-07-29','13:20:00',3.5),('8348','2013-07-29','13:25:00',3.53),('8348','2013-07-29','13:30:00',3.55),('8348','2013-07-29','13:35:00',3.54),('8348','2013-07-29','13:40:00',3.56),('8348','2013-07-29','13:45:00',3.57),('8348','2013-07-29','13:50:00',3.57),('8348','2013-07-29','13:55:00',3.57),('8348','2013-07-29','14:00:00',3.58),('8348','2013-07-29','14:05:00',3.57),('8348','2013-07-29','14:10:00',3.55),('8348','2013-07-29','14:15:00',3.53),('8348','2013-07-29','14:20:00',3.53),('8348','2013-07-29','14:25:00',3.49),('8348','2013-07-29','14:30:00',3.48),('8348','2013-07-29','14:35:00',3.47),('8348','2013-07-29','14:40:00',3.45),('8348','2013-07-29','14:45:00',3.43),('8348','2013-07-29','14:50:00',3.41),('8348','2013-07-29','14:55:00',3.39),('8348','2013-07-29','15:00:00',3.37),('8348','2013-07-29','15:05:00',3.34),('8348','2013-07-29','15:10:00',3.32),('8348','2013-07-29','15:15:00',3.29),('8348','2013-07-29','15:20:00',3.26),('8348','2013-07-29','15:25:00',3.23),('8348','2013-07-29','15:30:00',3.2),('8348','2013-07-29','15:35:00',3.21),('8348','2013-07-29','15:40:00',3.26),('8348','2013-07-29','15:45:00',3.27),('8348','2013-07-29','15:50:00',2.7),('8348','2013-07-29','15:55:00',1.83),('8348','2013-07-29','16:00:00',1.69),('8348','2013-07-29','16:05:00',2.74),('8348','2013-07-29','16:10:00',2.72),('8348','2013-07-29','16:15:00',2.57),('8348','2013-07-29','16:20:00',2.43),('8348','2013-07-29','16:25:00',2.34),('8348','2013-07-29','16:30:00',2.96),('8348','2013-07-29','16:35:00',2.61),('8348','2013-07-29','16:40:00',2.33),('8348','2013-07-29','16:45:00',2.82),('8348','2013-07-29','16:50:00',2.52),('8348','2013-07-29','16:55:00',1.61),('8348','2013-07-29','17:00:00',1.31),('8348','2013-07-29','17:05:00',1.93),('8348','2013-07-29','17:10:00',1.25),('8348','2013-07-29','17:15:00',1.18),('8348','2013-07-29','17:20:00',2.2),('8348','2013-07-29','17:25:00',2.04),('8348','2013-07-29','17:30:00',1.29),('8348','2013-07-29','17:40:00',1.12),('8348','2013-07-29','17:45:00',1.93),('8348','2013-07-29','17:50:00',1.79),('8348','2013-07-29','17:55:00',1.64),('8348','2013-07-29','18:00:00',1.16),('8348','2013-07-29','18:10:00',1.37),('8348','2013-07-29','18:15:00',1.15),('8348','2013-07-29','18:20:00',1.31),('8348','2013-07-29','18:25:00',1.27),('8348','2013-07-29','18:30:00',1.21),('8348','2013-07-29','18:35:00',1.08),('8348','2013-07-28','08:20:00',1),('8348','2013-07-28','08:25:00',1.04),('8348','2013-07-28','08:30:00',1.14),('8348','2013-07-28','08:35:00',1.24),('8348','2013-07-28','08:40:00',1.33),('8348','2013-07-28','08:45:00',1.41),('8348','2013-07-28','08:50:00',1.47),('8348','2013-07-28','08:55:00',1.54),('8348','2013-07-28','09:00:00',1.62),('8348','2013-07-28','09:05:00',1.68),('8348','2013-07-28','09:10:00',1.74),('8348','2013-07-28','09:15:00',1.8),('8348','2013-07-28','09:20:00',1.84),('8348','2013-07-28','09:25:00',1.91),('8348','2013-07-28','09:30:00',1.97),('8348','2013-07-28','09:35:00',2.03),('8348','2013-07-28','09:40:00',2.07),('8348','2013-07-28','09:45:00',2.13),('8348','2013-07-28','09:50:00',2.19),('8348','2013-07-28','09:55:00',2.23),('8348','2013-07-28','10:00:00',2.26),('8348','2013-07-28','10:05:00',2.29),('8348','2013-07-28','10:10:00',2.37),('8348','2013-07-28','10:15:00',2.44),('8348','2013-07-28','10:20:00',2.46),('8348','2013-07-28','10:25:00',2.52),('8348','2013-07-28','10:30:00',2.56),('8348','2013-07-28','10:35:00',2.6),('8348','2013-07-28','10:40:00',2.63),('8348','2013-07-28','10:45:00',2.68),('8348','2013-07-28','10:50:00',2.74),('8348','2013-07-28','10:55:00',2.8),('8348','2013-07-28','11:00:00',2.84),('8348','2013-07-28','11:05:00',2.87),('8348','2013-07-28','11:10:00',2.87),('8348','2013-07-28','11:15:00',2.89),('8348','2013-07-28','11:20:00',2.94),('8348','2013-07-28','11:25:00',2.97),('8348','2013-07-28','11:30:00',2.97),('8348','2013-07-28','11:35:00',2.94),('8348','2013-07-28','11:40:00',2.98),('8348','2013-07-28','11:45:00',3.06),('8348','2013-07-28','11:50:00',3.09),('8348','2013-07-28','11:55:00',3.11),('8348','2013-07-28','12:00:00',3.11),('8348','2013-07-28','12:05:00',3.12),('8348','2013-07-28','12:10:00',3.12),('8348','2013-07-28','12:15:00',3.07),('8348','2013-07-28','12:20:00',3.15),('8348','2013-07-28','12:25:00',3.13),('8348','2013-07-28','12:30:00',3.32),('8348','2013-07-28','12:35:00',3.26),('8348','2013-07-28','12:40:00',3.27),('8348','2013-07-28','12:45:00',3.22),('8348','2013-07-28','12:50:00',3.22),('8348','2013-07-28','12:55:00',3.25),('8348','2013-07-28','13:00:00',3.25),('8348','2013-07-28','13:05:00',3.33),('8348','2013-07-28','13:10:00',3.41),('8348','2013-07-28','13:15:00',3.38),('8348','2013-07-28','13:20:00',2.42),('8348','2013-07-28','13:25:00',3.39),('8348','2013-07-28','13:30:00',3.47),('8348','2013-07-28','13:35:00',3.47),('8348','2013-07-28','13:40:00',3.48),('8348','2013-07-28','13:45:00',3.51),('8348','2013-07-28','13:50:00',3.52),('8348','2013-07-28','13:55:00',3.49),('8348','2013-07-28','14:00:00',3.46),('8348','2013-07-28','14:05:00',3.47),('8348','2013-07-28','14:10:00',3.45),('8348','2013-07-28','14:15:00',3.46),('8348','2013-07-28','14:20:00',3.46),('8348','2013-07-28','14:25:00',3.45),('8348','2013-07-28','14:30:00',3.39),('8348','2013-07-28','14:35:00',3.39),('8348','2013-07-28','14:40:00',3.37),('8348','2013-07-28','14:45:00',3.37),('8348','2013-07-28','14:50:00',3.33),('8348','2013-07-28','14:55:00',3.33),('8348','2013-07-28','15:00:00',3.3),('8348','2013-07-28','15:05:00',3.24),('8348','2013-07-28','15:10:00',3.27),('8348','2013-07-28','15:15:00',3.23),('8348','2013-07-28','15:20:00',3.17),('8348','2013-07-28','15:25:00',3.16),('8348','2013-07-28','15:30:00',3.16),('8348','2013-07-28','15:35:00',3.1),('8348','2013-07-28','15:40:00',3.1),('8348','2013-07-28','15:45:00',3.04),('8348','2013-07-28','15:50:00',3.04),('8348','2013-07-28','15:55:00',3.01),('8348','2013-07-28','16:00:00',2.98),('8348','2013-07-28','16:05:00',2.99),('8348','2013-07-28','16:10:00',2.95),('8348','2013-07-28','16:15:00',2.91),('8348','2013-07-28','16:20:00',2.88),('8348','2013-07-28','16:25:00',2.83),('8348','2013-07-28','16:30:00',2.78),('8348','2013-07-28','16:35:00',2.73),('8348','2013-07-28','16:40:00',2.68),('8348','2013-07-28','16:45:00',2.64),('8348','2013-07-28','16:50:00',2.59),('8348','2013-07-28','16:55:00',2.52),('8348','2013-07-28','17:00:00',2.47),('8348','2013-07-28','17:05:00',2.42),('8348','2013-07-28','17:10:00',2.37),('8348','2013-07-28','17:15:00',2.31),('8348','2013-07-28','17:20:00',2.25),('8348','2013-07-28','17:25:00',2.19),('8348','2013-07-28','17:30:00',2.12),('8348','2013-07-28','17:35:00',2.06),('8348','2013-07-28','17:40:00',2),('8348','2013-07-28','17:45:00',1.93),('8348','2013-07-28','17:50:00',1.86),('8348','2013-07-28','17:55:00',1.78),('8348','2013-07-28','18:00:00',1.7),('8348','2013-07-28','18:05:00',1.63),('8348','2013-07-28','18:10:00',1.57),('8348','2013-07-28','18:15:00',1.49),('8348','2013-07-28','18:20:00',1.41),('8348','2013-07-28','18:25:00',1.35),('8348','2013-07-28','18:30:00',1.27),('8348','2013-07-28','18:35:00',1.18),('8348','2013-07-28','18:40:00',1.1),('8348','2013-07-28','18:45:00',1.02),('8348','2013-07-27','08:15:00',1),('8348','2013-07-27','08:20:00',1.05),('8348','2013-07-27','08:25:00',1.13),('8348','2013-07-27','08:30:00',1.21),('8348','2013-07-27','08:35:00',1.28),('8348','2013-07-27','08:40:00',1.37),('8348','2013-07-27','08:45:00',1.44),('8348','2013-07-27','08:50:00',1.5),('8348','2013-07-27','08:55:00',1.59),('8348','2013-07-27','09:00:00',1.66),('8348','2013-07-27','09:05:00',1.72),('8348','2013-07-27','09:10:00',1.8),('8348','2013-07-27','09:15:00',1.85),('8348','2013-07-27','09:20:00',1.91),('8348','2013-07-27','09:25:00',1.97),('8348','2013-07-27','09:30:00',2.01),('8348','2013-07-27','09:35:00',2.07),('8348','2013-07-27','09:40:00',2.13),('8348','2013-07-27','09:45:00',2.2),('8348','2013-07-27','09:50:00',2.26),('8348','2013-07-27','09:55:00',2.33),('8348','2013-07-27','10:00:00',2.38),('8348','2013-07-27','10:05:00',2.4),('8348','2013-07-27','10:10:00',2.45),('8348','2013-07-27','10:15:00',2.49),('8348','2013-07-27','10:20:00',2.55),('8348','2013-07-27','10:25:00',2.59),('8348','2013-07-27','10:30:00',2.63),('8348','2013-07-27','10:35:00',2.68),('8348','2013-07-27','10:40:00',2.71),('8348','2013-07-27','10:45:00',2.75),('8348','2013-07-27','10:50:00',2.79),('8348','2013-07-27','10:55:00',2.84),('8348','2013-07-27','11:00:00',2.89),('8348','2013-07-27','11:05:00',2.9),('8348','2013-07-27','11:10:00',2.95),('8348','2013-07-27','11:15:00',2.99),('8348','2013-07-27','11:20:00',3),('8348','2013-07-27','11:25:00',3.03),('8348','2013-07-27','11:30:00',3.05),('8348','2013-07-27','11:35:00',3.09),('8348','2013-07-27','11:40:00',3.13),('8348','2013-07-27','11:45:00',3.17),('8348','2013-07-27','11:50:00',3.17),('8348','2013-07-27','11:55:00',3.19),('8348','2013-07-27','12:00:00',3.18),('8348','2013-07-27','12:05:00',3.21),('8348','2013-07-27','12:10:00',3.21),('8348','2013-07-27','12:15:00',3.27),('8348','2013-07-27','12:20:00',3.26),('8348','2013-07-27','12:25:00',3.25),('8348','2013-07-27','12:30:00',3.28),('8348','2013-07-27','12:35:00',3.29),('8348','2013-07-27','12:40:00',3.4),('8348','2013-07-27','12:45:00',3.45),('8348','2013-07-27','12:50:00',3.41),('8348','2013-07-27','12:55:00',3.42),('8348','2013-07-27','13:00:00',3.53),('8348','2013-07-27','13:05:00',2.85),('8348','2013-07-27','13:10:00',2.8),('8348','2013-07-27','13:15:00',3.46),('8348','2013-07-27','13:20:00',3.49),('8348','2013-07-27','13:25:00',3.49),('8348','2013-07-27','13:30:00',3.44),('8348','2013-07-27','13:35:00',3.41),('8348','2013-07-27','13:40:00',3.45),('8348','2013-07-27','13:45:00',3.49),('8348','2013-07-27','13:50:00',3.54),('8348','2013-07-27','13:55:00',3.53),('8348','2013-07-27','14:00:00',3.48),('8348','2013-07-27','14:05:00',3.48),('8348','2013-07-27','14:10:00',3.48),('8348','2013-07-27','14:15:00',3.6),('8348','2013-07-27','14:20:00',3.46),('8348','2013-07-27','14:25:00',3.46),('8348','2013-07-27','14:30:00',3.46),('8348','2013-07-27','14:35:00',3.44),('8348','2013-07-27','14:40:00',3.45),('8348','2013-07-27','14:45:00',3.42),('8348','2013-07-27','14:50:00',3.44),('8348','2013-07-27','14:55:00',3.43),('8348','2013-07-27','15:00:00',3.36),('8348','2013-07-27','15:05:00',3.32),('8348','2013-07-27','15:10:00',3.31),('8348','2013-07-27','15:15:00',3.29),('8348','2013-07-27','15:20:00',3.23),('8348','2013-07-27','15:25:00',3.24),('8348','2013-07-27','15:30:00',3.22),('8348','2013-07-27','15:35:00',3.2),('8348','2013-07-27','15:40:00',3.16),('8348','2013-07-27','15:45:00',3.13),('8348','2013-07-27','15:50:00',3.09),('8348','2013-07-27','15:55:00',3.06),('8348','2013-07-27','16:00:00',3.03),('8348','2013-07-27','16:05:00',2.99),('8348','2013-07-27','16:10:00',2.94),('8348','2013-07-27','16:15:00',2.9),('8348','2013-07-27','16:20:00',2.86),('8348','2013-07-27','16:25:00',2.83),('8348','2013-07-27','16:30:00',2.78),('8348','2013-07-27','16:35:00',2.75),('8348','2013-07-27','16:40:00',2.7),('8348','2013-07-27','16:45:00',2.64),('8348','2013-07-27','16:50:00',2.59),('8348','2013-07-27','16:55:00',2.53),('8348','2013-07-27','17:00:00',2.46),('8348','2013-07-27','17:05:00',2.41),('8348','2013-07-27','17:10:00',2.36),('8348','2013-07-27','17:15:00',2.31),('8348','2013-07-27','17:20:00',2.22),('8348','2013-07-27','17:25:00',2.19),('8348','2013-07-27','17:30:00',2.09),('8348','2013-07-27','17:35:00',2.05),('8348','2013-07-27','17:40:00',1.96),('8348','2013-07-27','17:45:00',1.91),('8348','2013-07-27','17:50:00',1.85),('8348','2013-07-27','17:55:00',1.77),('8348','2013-07-27','18:00:00',1.72),('8348','2013-07-27','18:05:00',1.66),('8348','2013-07-27','18:10:00',1.6),('8348','2013-07-27','18:15:00',1.51),('8348','2013-07-27','18:20:00',1.42),('8348','2013-07-27','18:25:00',1.35),('8348','2013-07-27','18:30:00',1.3),('8348','2013-07-27','18:35:00',1.23),('8348','2013-07-27','18:40:00',1.15),('8348','2013-07-27','18:45:00',1.07),('8348','2014-04-07','07:10:00',1.2),('8348','2014-04-07','07:15:00',1.36),('8348','2014-04-07','07:20:00',1.61),('8348','2014-04-07','07:25:00',1.68),('8348','2014-04-07','07:30:00',1.89),('8348','2014-04-07','07:35:00',2.39),('8348','2014-04-07','07:40:00',2.48),('8348','2014-04-07','07:45:00',2.43),('8348','2014-04-07','07:50:00',2.27),('8348','2014-04-07','07:55:00',2.03),('8348','2014-04-07','08:00:00',1.98),('8348','2014-04-07','08:05:00',2.04),('8348','2014-04-07','08:10:00',2.3),('8348','2014-04-07','08:15:00',2.58),('8348','2014-04-07','08:20:00',2.22),('8348','2014-04-07','08:25:00',2.11),('8348','2014-04-07','08:30:00',2.1),('8348','2014-04-07','08:35:00',2),('8348','2014-04-07','08:40:00',2.07),('8348','2014-04-07','08:45:00',2.18),('8348','2014-04-07','08:50:00',2.28),('8348','2014-04-07','08:55:00',2.45),('8348','2014-04-07','09:00:00',2.41),('8348','2014-04-07','09:05:00',2.42),('8348','2014-04-07','09:10:00',2.48),('8348','2014-04-07','09:15:00',2.29),('8348','2014-04-07','09:20:00',2.29),('8348','2014-04-07','09:25:00',2.35),('8348','2014-04-07','09:30:00',2.41),('8348','2014-04-07','09:35:00',2.56),('8348','2014-04-07','09:40:00',2.63),('8348','2014-04-07','09:45:00',2.71),('8348','2014-04-07','09:50:00',2.84),('8348','2014-04-07','09:55:00',3.05),('8348','2014-04-07','10:00:00',3.22),('8348','2014-04-07','10:05:00',3.39),('8348','2014-04-07','10:10:00',3.77),('8348','2014-04-07','10:15:00',4.03),('8348','2014-04-07','10:20:00',4),('8348','2014-04-07','10:25:00',3.5),('8348','2014-04-07','10:30:00',3.55),('8348','2014-04-07','10:35:00',3.48),('8348','2014-04-07','10:40:00',3.35),('8348','2014-04-07','10:45:00',3.18),('8348','2014-04-07','10:50:00',3.06),('8348','2014-04-07','10:55:00',2.98),('8348','2014-04-07','11:00:00',3.39),('8348','2014-04-07','11:05:00',4.09),('8348','2014-04-07','11:10:00',4.53),('8348','2014-04-07','11:15:00',5.92),('8348','2014-04-07','11:20:00',6.93),('8348','2014-04-07','11:25:00',6.43),('8348','2014-04-07','11:30:00',4.06),('8348','2014-04-07','11:35:00',3.56),('8348','2014-04-07','11:40:00',4.78),('8348','2014-04-07','11:45:00',6.69),('8348','2014-04-07','11:50:00',6.79),('8348','2014-04-07','11:55:00',6.71),('8348','2014-04-07','12:00:00',6.72),('8348','2014-04-07','12:05:00',6.7),('8348','2014-04-07','12:10:00',6.67),('8348','2014-04-07','12:15:00',6.7),('8348','2014-04-07','12:20:00',6.72),('8348','2014-04-07','12:25:00',6.7),('8348','2014-04-07','12:30:00',6.67),('8348','2014-04-07','12:35:00',6.63),('8348','2014-04-07','12:40:00',6.63),('8348','2014-04-07','12:45:00',6.65),('8348','2014-04-07','12:50:00',6.66),('8348','2014-04-07','12:55:00',6.7),('8348','2014-04-07','13:00:00',6.65),('8348','2014-04-07','13:05:00',6.63),('8348','2014-04-07','13:10:00',6.64),('8348','2014-04-07','13:15:00',6.49),('8348','2014-04-07','13:20:00',6.58),('8348','2014-04-07','13:25:00',6.77),('8348','2014-04-07','13:30:00',6.7),('8348','2014-04-07','13:35:00',6.5),('8348','2014-04-07','13:40:00',6.48),('8348','2014-04-07','13:45:00',6.29),('8348','2014-04-07','13:50:00',6.5),('8348','2014-04-07','13:55:00',6.17),('8348','2014-04-07','14:00:00',5.56),('8348','2014-04-07','14:05:00',6.45),('8348','2014-04-07','14:10:00',6.22),('8348','2014-04-07','14:15:00',6.58),('8348','2014-04-07','14:20:00',6.79),('8348','2014-04-07','14:25:00',6.75),('8348','2014-04-07','14:30:00',6.24),('8348','2014-04-07','14:35:00',6.34),('8348','2014-04-07','14:40:00',6.25),('8348','2014-04-07','14:45:00',6.45),('8348','2014-04-07','14:50:00',6.73),('8348','2014-04-07','14:55:00',6.45),('8348','2014-04-07','15:00:00',4.28),('8348','2014-04-07','15:05:00',3.81),('8348','2014-04-07','15:10:00',5.81),('8348','2014-04-07','15:15:00',5.41),('8348','2014-04-07','15:20:00',5.02),('8348','2014-04-07','15:25:00',4.92),('8348','2014-04-07','15:30:00',4.69),('8348','2014-04-07','15:35:00',3.02),('8348','2014-04-07','15:40:00',2),('8348','2014-04-07','15:45:00',3.46),('8348','2014-04-07','15:50:00',4.69),('8348','2014-04-07','15:55:00',4.74),('8348','2014-04-07','16:00:00',4.92),('8348','2014-04-07','16:05:00',4.59),('8348','2014-04-07','16:10:00',3.32),('8348','2014-04-07','16:15:00',3.5),('8348','2014-04-07','16:20:00',1.98),('8348','2014-04-07','16:25:00',1.6),('8348','2014-04-07','16:30:00',1.34),('8348','2014-04-07','16:35:00',1.03),('8348','2014-04-07','16:45:00',1.71),('8348','2014-04-07','16:50:00',1.45),('8348','2014-04-07','16:55:00',2.34),('8348','2014-04-07','17:00:00',2.11),('8348','2014-04-07','17:05:00',1.99),('8348','2014-04-07','17:10:00',2),('8348','2014-04-07','17:15:00',1.91),('8348','2014-04-07','17:20:00',1.64),('8348','2014-04-07','17:25:00',1.49),('8348','2014-04-07','17:30:00',1.29),('8348','2014-04-07','17:35:00',1.08),('8348','2014-05-03','06:35:00',1.01),('8348','2014-05-03','06:40:00',1.1),('8348','2014-05-03','06:45:00',1.2),('8348','2014-05-03','06:50:00',1.42),('8348','2014-05-03','06:55:00',1.58),('8348','2014-05-03','07:00:00',1.77),('8348','2014-05-03','07:05:00',2.06),('8348','2014-05-03','07:10:00',2.5),('8348','2014-05-03','07:15:00',2.92),('8348','2014-05-03','07:20:00',1.93),('8348','2014-05-03','07:25:00',1.77),('8348','2014-05-03','07:30:00',2.43),('8348','2014-05-03','07:35:00',1.45),('8348','2014-05-03','07:40:00',1.42),('8348','2014-05-03','07:45:00',1.84),('8348','2014-05-03','07:50:00',3.79),('8348','2014-05-03','07:55:00',4.45),('8348','2014-05-03','08:00:00',5.09),('8348','2014-05-03','08:05:00',2.79),('8348','2014-05-03','08:10:00',2.11),('8348','2014-05-03','08:15:00',5.37),('8348','2014-05-03','08:20:00',3.89),('8348','2014-05-03','08:25:00',4.96),('8348','2014-05-03','08:30:00',3.38),('8348','2014-05-03','08:35:00',5.73),('8348','2014-05-03','08:40:00',4.72),('8348','2014-05-03','08:45:00',5.18),('8348','2014-05-03','08:50:00',3.14),('8348','2014-05-03','08:55:00',4.8),('8348','2014-05-03','09:00:00',5.92),('8348','2014-05-03','09:05:00',5.95),('8348','2014-05-03','09:10:00',6.2),('8348','2014-05-03','09:15:00',6.85),('8348','2014-05-03','09:20:00',6.18),('8348','2014-05-03','09:25:00',6.35),('8348','2014-05-03','09:30:00',3.81),('8348','2014-05-03','09:35:00',2.1),('8348','2014-05-03','09:40:00',1.85),('8348','2014-05-03','09:45:00',2.16),('8348','2014-05-03','09:50:00',1.96),('8348','2014-05-03','09:55:00',2.3),('8348','2014-05-03','10:00:00',2.08),('8348','2014-05-03','10:05:00',5.11),('8348','2014-05-03','10:10:00',5.91),('8348','2014-05-03','10:15:00',8.68),('8348','2014-05-03','10:20:00',6.99),('8348','2014-05-03','10:25:00',7.25),('8348','2014-05-03','10:30:00',8.11),('8348','2014-05-03','10:35:00',5.54),('8348','2014-05-03','10:40:00',5.01),('8348','2014-05-03','10:45:00',5.07),('8348','2014-05-03','10:50:00',4.23),('8348','2014-05-03','10:55:00',4.64),('8348','2014-05-03','11:00:00',3.67),('8348','2014-05-03','11:05:00',2.93),('8348','2014-05-03','11:10:00',2.61),('8348','2014-05-03','11:15:00',2.43),('8348','2014-05-03','11:20:00',2.24),('8348','2014-05-03','11:25:00',2.31),('8348','2014-05-03','11:30:00',2.94),('8348','2014-05-03','11:35:00',3.71),('8348','2014-05-03','11:40:00',3.55),('8348','2014-05-03','11:45:00',3.64),('8348','2014-05-03','11:50:00',3.37),('8348','2014-05-03','11:55:00',3.31),('8348','2014-05-03','12:00:00',3.58),('8348','2014-05-03','12:05:00',4.06),('8348','2014-05-03','12:10:00',6.05),('8348','2014-05-03','12:15:00',5.62),('8348','2014-05-03','12:20:00',3.96),('8348','2014-05-03','12:25:00',5.27),('8348','2014-05-03','12:30:00',5.98),('8348','2014-05-03','12:35:00',5.04),('8348','2014-05-03','12:40:00',3.75),('8348','2014-05-03','12:45:00',3.46),('8348','2014-05-03','12:50:00',3.41),('8348','2014-05-03','12:55:00',3.42),('8348','2014-05-03','13:00:00',3.35),('8348','2014-05-03','13:05:00',3.38),('8348','2014-05-03','13:10:00',3.64),('8348','2014-05-03','13:15:00',4.12),('8348','2014-05-03','13:20:00',4.79),('8348','2014-05-03','13:25:00',5.89),('8348','2014-05-03','13:30:00',5.27),('8348','2014-05-03','13:35:00',2.98),('8348','2014-05-03','13:40:00',2.32),('8348','2014-05-03','13:45:00',1.48),('8348','2014-05-03','13:50:00',1.04),('8348','2014-05-03','13:55:00',1.55),('8348','2014-05-03','14:00:00',1.93),('8348','2014-05-03','14:05:00',1.76),('8348','2014-05-03','14:10:00',1.46),('8348','2014-05-03','14:15:00',1.07),('8348','2014-05-03','15:25:00',1.02),('8348','2014-05-03','15:30:00',1.19),('8348','2014-05-03','15:35:00',1.34),('8348','2014-05-03','15:40:00',1.47),('8348','2014-05-03','15:45:00',1.59),('8348','2014-05-03','15:50:00',1.67),('8348','2014-05-03','15:55:00',1.71),('8348','2014-05-03','16:00:00',1.72),('8348','2014-05-03','16:05:00',1.73),('8348','2014-05-03','16:10:00',1.74),('8348','2014-05-03','16:15:00',1.73),('8348','2014-05-03','16:20:00',1.72),('8348','2014-05-03','16:25:00',1.73),('8348','2014-05-03','16:30:00',1.7),('8348','2014-05-03','16:35:00',1.64),('8348','2014-05-03','16:40:00',1.7),('8348','2014-05-03','16:45:00',1.86),('8348','2014-05-03','16:50:00',2.24),('8348','2014-05-03','16:55:00',2.23),('8348','2014-05-03','17:00:00',1.76),('8348','2014-05-03','17:05:00',1.51),('8348','2014-05-03','17:10:00',1.61),('8348','2014-05-03','17:15:00',1.39),('8348','2014-05-03','17:20:00',1.07),('8348','2014-05-03','17:25:00',1.3),('8348','2014-05-03','17:45:00',1.35),('8348','2014-05-03','17:50:00',1.12),('8348','2014-04-06','07:15:00',1.17),('8348','2014-04-06','07:20:00',1.25),('8348','2014-04-06','07:25:00',1.37),('8348','2014-04-06','07:30:00',1.58),('8348','2014-04-06','07:35:00',1.72),('8348','2014-04-06','07:40:00',1.84),('8348','2014-04-06','07:45:00',1.94),('8348','2014-04-06','07:50:00',1.49),('8348','2014-04-06','07:55:00',1.07),('8348','2014-04-06','08:05:00',1.57),('8348','2014-04-06','08:10:00',3.02),('8348','2014-04-06','08:15:00',3.24),('8348','2014-04-06','08:20:00',3.1),('8348','2014-04-06','08:25:00',2.83),('8348','2014-04-06','08:30:00',2.61),('8348','2014-04-06','08:35:00',3.58),('8348','2014-04-06','08:40:00',3.9),('8348','2014-04-06','08:45:00',4.91),('8348','2014-04-06','08:50:00',5.64),('8348','2014-04-06','08:55:00',5.7),('8348','2014-04-06','09:00:00',4.66),('8348','2014-04-06','09:05:00',4.92),('8348','2014-04-06','09:10:00',4.41),('8348','2014-04-06','09:15:00',5.32),('8348','2014-04-06','09:20:00',3.91),('8348','2014-04-06','09:25:00',2.23),('8348','2014-04-06','09:30:00',2.35),('8348','2014-04-06','09:35:00',2.59),('8348','2014-04-06','09:40:00',2.75),('8348','2014-04-06','09:45:00',4.07),('8348','2014-04-06','09:50:00',3.38),('8348','2014-04-06','09:55:00',2.66),('8348','2014-04-06','10:00:00',2.82),('8348','2014-04-06','10:05:00',3.96),('8348','2014-04-06','10:10:00',6.34),('8348','2014-04-06','10:15:00',5.83),('8348','2014-04-06','10:20:00',6.72),('8348','2014-04-06','10:25:00',6.61),('8348','2014-04-06','10:30:00',7.03),('8348','2014-04-06','10:35:00',7.38),('8348','2014-04-06','10:40:00',7.25),('8348','2014-04-06','10:45:00',7.16),('8348','2014-04-06','10:50:00',5.38),('8348','2014-04-06','10:55:00',7.05),('8348','2014-04-06','11:00:00',7.23),('8348','2014-04-06','11:05:00',6.81),('8348','2014-04-06','11:10:00',7.04),('8348','2014-04-06','11:15:00',7.13),('8348','2014-04-06','11:20:00',6.33),('8348','2014-04-06','11:25:00',3.66),('8348','2014-04-06','11:30:00',3.94),('8348','2014-04-06','11:35:00',3.01),('8348','2014-04-06','11:40:00',3.68),('8348','2014-04-06','11:45:00',1.99),('8348','2014-04-06','11:50:00',1.94),('8348','2014-04-06','11:55:00',6.2),('8348','2014-04-06','12:00:00',7.36),('8348','2014-04-06','12:05:00',6.5),('8348','2014-04-06','12:10:00',6.94),('8348','2014-04-06','12:15:00',8.12),('8348','2014-04-06','12:20:00',3.59),('8348','2014-04-06','12:25:00',1.9),('8348','2014-04-06','12:30:00',7.83),('8348','2014-04-06','12:35:00',5.91),('8348','2014-04-06','12:40:00',2.47),('8348','2014-04-06','12:45:00',8),('8348','2014-04-06','12:50:00',7.71),('8348','2014-04-06','12:55:00',7.59),('8348','2014-04-06','13:00:00',7.34),('8348','2014-04-06','13:05:00',7.22),('8348','2014-04-06','13:10:00',7.45),('8348','2014-04-06','13:15:00',6.88),('8348','2014-04-06','13:20:00',3.61),('8348','2014-04-06','13:25:00',3.3),('8348','2014-04-06','13:30:00',1.95),('8348','2014-04-06','13:35:00',2.24),('8348','2014-04-06','13:40:00',4.15),('8348','2014-04-06','13:45:00',8.63),('8348','2014-04-06','13:50:00',6.35),('8348','2014-04-06','13:55:00',4.93),('8348','2014-04-06','14:00:00',3.15),('8348','2014-04-06','14:05:00',2.34),('8348','2014-04-06','14:10:00',5.87),('8348','2014-04-06','14:15:00',5.33),('8348','2014-04-06','14:20:00',4.44),('8348','2014-04-06','14:25:00',2.26),('8348','2014-04-06','14:30:00',2.07),('8348','2014-04-06','14:35:00',1.15),('8348','2014-04-06','14:40:00',1.28),('8348','2014-04-06','14:45:00',1.73),('8348','2014-04-06','14:50:00',2.85),('8348','2014-04-06','14:55:00',6.6),('8348','2014-04-06','15:00:00',5.68),('8348','2014-04-06','15:05:00',2.78),('8348','2014-04-06','15:10:00',4.01),('8348','2014-04-06','15:15:00',1.93),('8348','2014-04-06','15:20:00',1.22),('8348','2014-04-06','15:25:00',1.69),('8348','2014-04-06','15:30:00',1.76),('8348','2014-04-06','15:35:00',2.52),('8348','2014-04-06','15:40:00',5.08),('8348','2014-04-06','15:45:00',5.84),('8348','2014-04-06','15:50:00',5.5),('8348','2014-04-06','15:55:00',4.71),('8348','2014-04-06','16:00:00',1.9),('8348','2014-04-06','16:05:00',1.44),('8348','2014-04-06','16:10:00',1.17),('8348','2014-04-06','16:15:00',1.07),('8348','2014-04-06','16:20:00',1.51),('8348','2014-04-06','16:25:00',3.99),('8348','2014-04-06','16:30:00',3.81),('8348','2014-04-06','16:35:00',2.32),('8348','2014-04-06','16:40:00',1.28),('8348','2014-04-06','16:45:00',2.5),('8348','2014-04-06','16:50:00',3.12),('8348','2014-04-06','16:55:00',2.85),('8348','2014-04-06','17:00:00',2.62),('8348','2014-04-06','17:05:00',2.41),('8348','2014-04-06','17:10:00',2.27),('8348','2014-04-06','17:15:00',2.21),('8348','2014-04-06','17:20:00',2.18),('8348','2014-04-06','17:25:00',1.95),('8348','2014-04-06','17:30:00',1.15),('8348','2014-04-06','17:35:00',1.2),('8348','2014-04-05','07:35:00',1.14),('8348','2014-04-05','07:40:00',1.14),('8348','2014-04-05','07:45:00',1.04),('8348','2014-04-05','08:00:00',1.02),('8348','2014-04-05','08:05:00',1.28),('8348','2014-04-05','08:10:00',1.39),('8348','2014-04-05','08:15:00',1.9),('8348','2014-04-05','08:20:00',2.6),('8348','2014-04-05','08:25:00',3.52),('8348','2014-04-05','08:30:00',5.51),('8348','2014-04-05','08:35:00',5.44),('8348','2014-04-05','08:40:00',5.6),('8348','2014-04-05','08:45:00',4.93),('8348','2014-04-05','08:50:00',2.65),('8348','2014-04-05','08:55:00',4.28),('8348','2014-04-05','09:00:00',3.57),('8348','2014-04-05','09:05:00',3.36),('8348','2014-04-05','09:10:00',3.8),('8348','2014-04-05','09:15:00',2.7),('8348','2014-04-05','09:20:00',3.92),('8348','2014-04-05','09:25:00',4.75),('8348','2014-04-05','09:30:00',4.06),('8348','2014-04-05','09:35:00',4.51),('8348','2014-04-05','09:40:00',4.37),('8348','2014-04-05','09:45:00',5.13),('8348','2014-04-05','09:50:00',4.18),('8348','2014-04-05','09:55:00',4.68),('8348','2014-04-05','10:00:00',5.28),('8348','2014-04-05','10:05:00',5.55),('8348','2014-04-05','10:10:00',6.34),('8348','2014-04-05','10:15:00',6.51),('8348','2014-04-05','10:20:00',6.83),('8348','2014-04-05','10:25:00',5.72),('8348','2014-04-05','10:30:00',4.1),('8348','2014-04-05','10:35:00',3.78),('8348','2014-04-05','10:40:00',5.21),('8348','2014-04-05','10:45:00',6.45),('8348','2014-04-05','10:50:00',6.88),('8348','2014-04-05','10:55:00',6.66),('8348','2014-04-05','11:00:00',6.42),('8348','2014-04-05','11:05:00',5.09),('8348','2014-04-05','11:10:00',5.12),('8348','2014-04-05','11:15:00',5.7),('8348','2014-04-05','11:20:00',5.26),('8348','2014-04-05','11:25:00',5.92),('8348','2014-04-05','11:30:00',4.51),('8348','2014-04-05','11:35:00',3.5),('8348','2014-04-05','11:40:00',5.51),('8348','2014-04-05','11:45:00',7.1),('8348','2014-04-05','11:50:00',7.71),('8348','2014-04-05','11:55:00',7.26),('8348','2014-04-05','12:00:00',5.7),('8348','2014-04-05','12:05:00',5.15),('8348','2014-04-05','12:10:00',5.58),('8348','2014-04-05','12:15:00',4.22),('8348','2014-04-05','12:20:00',7.05),('8348','2014-04-05','12:25:00',6.86),('8348','2014-04-05','12:30:00',6.27),('8348','2014-04-05','12:35:00',7.86),('8348','2014-04-05','12:40:00',7.78),('8348','2014-04-05','12:45:00',8.02),('8348','2014-04-05','12:50:00',8.03),('8348','2014-04-05','12:55:00',6.51),('8348','2014-04-05','13:00:00',5.75),('8348','2014-04-05','13:05:00',8.31),('8348','2014-04-05','13:10:00',4.77),('8348','2014-04-05','13:15:00',1.27),('8348','2014-04-05','13:20:00',1.52),('8348','2014-04-05','13:25:00',1.92),('8348','2014-04-05','13:30:00',2.31),('8348','2014-04-05','13:35:00',1.74),('8348','2014-04-05','13:40:00',1.45),('8348','2014-04-05','13:45:00',1.35),('8348','2014-04-05','13:50:00',3.67),('8348','2014-04-05','13:55:00',7.41),('8348','2014-04-05','14:00:00',7.31),('8348','2014-04-05','14:05:00',6.97),('8348','2014-04-05','14:10:00',3.36),('8348','2014-04-05','14:15:00',4.41),('8348','2014-04-05','14:20:00',7.73),('8348','2014-04-05','14:25:00',5.02),('8348','2014-04-05','14:30:00',2.68),('8348','2014-04-05','14:35:00',2.83),('8348','2014-04-05','14:40:00',3.95),('8348','2014-04-05','14:45:00',3.93),('8348','2014-04-05','14:50:00',3.99),('8348','2014-04-05','14:55:00',2.2),('8348','2014-04-05','15:00:00',2.31),('8348','2014-04-05','15:05:00',2.45),('8348','2014-04-05','15:10:00',2.31),('8348','2014-04-05','15:15:00',3.19),('8348','2014-04-05','15:20:00',6.67),('8348','2014-04-05','15:25:00',6.1),('8348','2014-04-05','15:30:00',4.19),('8348','2014-04-05','15:35:00',4.88),('8348','2014-04-05','15:40:00',2.82),('8348','2014-04-05','15:45:00',3.64),('8348','2014-04-05','15:50:00',3.12),('8348','2014-04-05','15:55:00',4.59),('8348','2014-04-05','16:00:00',3.32),('8348','2014-04-05','16:05:00',4.2),('8348','2014-04-05','16:10:00',3.58),('8348','2014-04-05','16:15:00',1.95),('8348','2014-04-05','16:20:00',2.6),('8348','2014-04-05','16:25:00',2.55),('8348','2014-04-05','16:30:00',2.5),('8348','2014-04-05','16:35:00',2.11),('8348','2014-04-05','16:40:00',1.91),('8348','2014-04-05','16:45:00',1.87),('8348','2014-04-05','16:50:00',2.3),('8348','2014-04-05','16:55:00',2.37),('8348','2014-04-05','17:00:00',2.31),('8348','2014-04-05','17:05:00',2.08),('8348','2014-04-05','17:10:00',2.07),('8348','2014-04-05','17:15:00',2.18),('8348','2014-04-05','17:20:00',2.04),('8348','2014-04-05','17:25:00',1.51),('8348','2014-04-04','07:40:00',1.26),('8348','2014-04-04','07:45:00',1.38),('8348','2014-04-04','07:50:00',1.55),('8348','2014-04-04','07:55:00',1.6),('8348','2014-04-04','08:00:00',1.6),('8348','2014-04-04','08:05:00',2.15),('8348','2014-04-04','08:10:00',2.85),('8348','2014-04-04','08:15:00',2.53),('8348','2014-04-04','08:20:00',1.79),('8348','2014-04-04','08:25:00',1.46),('8348','2014-04-04','08:30:00',1.42),('8348','2014-04-04','08:35:00',1.43),('8348','2014-04-04','08:40:00',1.37),('8348','2014-04-04','08:45:00',1.33),('8348','2014-04-04','08:50:00',1.21),('8348','2014-04-04','10:20:00',1.29),('8348','2014-04-04','11:45:00',1.13),('8348','2014-04-04','11:50:00',1.07),('8348','2014-04-04','11:55:00',1.16),('8348','2014-04-04','12:05:00',1.21),('8348','2014-04-04','12:10:00',2.17),('8348','2014-04-04','12:15:00',1.68),('8348','2014-04-04','12:20:00',3.57),('8348','2014-04-04','12:25:00',4.22),('8348','2014-04-04','12:30:00',3.67),('8348','2014-04-04','12:35:00',4.52),('8348','2014-04-04','12:40:00',7.66),('8348','2014-04-04','12:45:00',5.42),('8348','2014-04-04','12:50:00',6.93),('8348','2014-04-04','12:55:00',4.36),('8348','2014-04-04','13:00:00',4.74),('8348','2014-04-04','13:05:00',8.6),('8348','2014-04-04','13:10:00',7.45),('8348','2014-04-04','13:15:00',6.32),('8348','2014-04-04','13:20:00',5.56),('8348','2014-04-04','13:25:00',5.6),('8348','2014-04-04','13:30:00',2.39),('8348','2014-04-04','13:35:00',3.83),('8348','2014-04-04','13:40:00',3.07),('8348','2014-04-04','13:45:00',2.56),('8348','2014-04-04','13:50:00',5.13),('8348','2014-04-04','13:55:00',7.26),('8348','2014-04-04','14:00:00',7.38),('8348','2014-04-04','14:05:00',7.58),('8348','2014-04-04','14:10:00',5.58),('8348','2014-04-04','14:15:00',5.99),('8348','2014-04-04','14:20:00',4.29),('8348','2014-04-04','14:25:00',3.72),('8348','2014-04-04','14:30:00',2.71),('8348','2014-04-04','14:35:00',2.84),('8348','2014-04-04','14:40:00',4.22),('8348','2014-04-04','14:45:00',3.95),('8348','2014-04-04','14:50:00',3.17),('8348','2014-04-04','14:55:00',5.39),('8348','2014-04-04','15:00:00',6.42),('8348','2014-04-04','15:05:00',4.45),('8348','2014-04-04','15:10:00',6.95),('8348','2014-04-04','15:15:00',2.92),('8348','2014-04-04','15:20:00',2.21),('8348','2014-04-04','15:25:00',1.97),('8348','2014-04-04','15:30:00',3.79),('8348','2014-04-04','15:35:00',2.77),('8348','2014-04-04','15:40:00',2.89),('8348','2014-04-04','15:45:00',4.98),('8348','2014-04-04','15:50:00',5.32),('8348','2014-04-04','15:55:00',3.9),('8348','2014-04-04','16:00:00',3.84),('8348','2014-04-04','16:05:00',3.92),('8348','2014-04-04','16:10:00',4.26),('8348','2014-04-04','16:15:00',3.67),('8348','2014-04-04','16:20:00',4.21),('8348','2014-04-04','16:25:00',3.86),('8348','2014-04-04','16:30:00',4.38),('8348','2014-04-04','16:35:00',4.1),('8348','2014-04-04','16:40:00',2.46),('8348','2014-04-04','16:45:00',3.33),('8348','2014-04-04','16:50:00',3.22),('8348','2014-04-04','16:55:00',2.87),('8348','2014-04-04','17:00:00',2.61),('8348','2014-04-04','17:05:00',2.39),('8348','2014-04-04','17:10:00',2.15),('8348','2014-04-04','17:15:00',1.96),('8348','2014-04-04','17:20:00',1.77),('8348','2014-04-04','17:25:00',1.24),('8348','2014-04-04','17:30:00',1.51),('8348','2014-04-04','17:35:00',1.39),('8348','2014-04-04','17:40:00',1.01),('8348','2014-04-03','07:20:00',1.05),('8348','2014-04-03','07:25:00',1.12),('8348','2014-04-03','07:30:00',1.21),('8348','2014-04-03','07:35:00',1.28),('8348','2014-04-03','07:40:00',1.41),('8348','2014-04-03','07:45:00',1.6),('8348','2014-04-03','07:50:00',1.65),('8348','2014-04-03','07:55:00',1.86),('8348','2014-04-03','08:00:00',2.04),('8348','2014-04-03','08:05:00',2.23),('8348','2014-04-03','08:10:00',2.18),('8348','2014-04-03','08:15:00',2.03),('8348','2014-04-03','08:20:00',2.06),('8348','2014-04-03','08:25:00',2.2),('8348','2014-04-03','08:30:00',2.53),('8348','2014-04-03','08:35:00',2.99),('8348','2014-04-03','08:40:00',3.16),('8348','2014-04-03','08:45:00',3.09),('8348','2014-04-03','08:50:00',2.94),('8348','2014-04-03','08:55:00',3.05),('8348','2014-04-03','09:00:00',3.62),('8348','2014-04-03','09:05:00',4.17),('8348','2014-04-03','09:10:00',4.41),('8348','2014-04-03','09:15:00',5.06),('8348','2014-04-03','09:20:00',5.16),('8348','2014-04-03','09:25:00',4.8),('8348','2014-04-03','09:30:00',4.48),('8348','2014-04-03','09:35:00',4.85),('8348','2014-04-03','09:40:00',3.83),('8348','2014-04-03','09:45:00',4.19),('8348','2014-04-03','09:50:00',3.66),('8348','2014-04-03','09:55:00',3.81),('8348','2014-04-03','10:00:00',3.58),('8348','2014-04-03','10:05:00',3.02),('8348','2014-04-03','10:10:00',2.89),('8348','2014-04-03','10:15:00',2.7),('8348','2014-04-03','10:20:00',2.57),('8348','2014-04-03','10:25:00',2.39),('8348','2014-04-03','10:30:00',2.36),('8348','2014-04-03','10:35:00',2.52),('8348','2014-04-03','10:40:00',2.77),('8348','2014-04-03','10:45:00',3.12),('8348','2014-04-03','10:50:00',3.76),('8348','2014-04-03','10:55:00',4.2),('8348','2014-04-03','11:00:00',4.02),('8348','2014-04-03','11:05:00',4.06),('8348','2014-04-03','11:10:00',3.91),('8348','2014-04-03','11:15:00',3.85),('8348','2014-04-03','11:20:00',4.25),('8348','2014-04-03','11:25:00',5.18),('8348','2014-04-03','11:30:00',6.58),('8348','2014-04-03','11:35:00',6.3),('8348','2014-04-03','11:40:00',7.01),('8348','2014-04-03','11:45:00',4.19),('8348','2014-04-03','11:50:00',4.85),('8348','2014-04-03','11:55:00',4.86),('8348','2014-04-03','12:00:00',4.51),('8348','2014-04-03','12:05:00',5.73),('8348','2014-04-03','12:10:00',4.34),('8348','2014-04-03','12:15:00',7.62),('8348','2014-04-03','12:20:00',5),('8348','2014-04-03','12:25:00',4.81),('8348','2014-04-03','12:30:00',4.88),('8348','2014-04-03','12:35:00',7.74),('8348','2014-04-03','12:40:00',6.94),('8348','2014-04-03','12:45:00',3.75),('8348','2014-04-03','12:50:00',3.77),('8348','2014-04-03','12:55:00',4.36),('8348','2014-04-03','13:00:00',6.31),('8348','2014-04-03','13:05:00',6.23),('8348','2014-04-03','13:10:00',4.85),('8348','2014-04-03','13:15:00',6.1),('8348','2014-04-03','13:20:00',6.54),('8348','2014-04-03','13:25:00',6.77),('8348','2014-04-03','13:30:00',6.86),('8348','2014-04-03','13:35:00',7.04),('8348','2014-04-03','13:40:00',6.79),('8348','2014-04-03','13:45:00',6.59),('8348','2014-04-03','13:50:00',6.51),('8348','2014-04-03','13:55:00',6.41),('8348','2014-04-03','14:00:00',6.31),('8348','2014-04-03','14:05:00',6.27),('8348','2014-04-03','14:10:00',6.15),('8348','2014-04-03','14:15:00',6.11),('8348','2014-04-03','14:20:00',6.2),('8348','2014-04-03','14:25:00',6.19),('8348','2014-04-03','14:30:00',6.17),('8348','2014-04-03','14:35:00',6.09),('8348','2014-04-03','14:40:00',6.03),('8348','2014-04-03','14:45:00',5.97),('8348','2014-04-03','14:50:00',5.93),('8348','2014-04-03','14:55:00',5.89),('8348','2014-04-03','15:00:00',5.87),('8348','2014-04-03','15:05:00',5.66),('8348','2014-04-03','15:10:00',5.69),('8348','2014-04-03','15:15:00',5.49),('8348','2014-04-03','15:20:00',5.43),('8348','2014-04-03','15:25:00',5.25),('8348','2014-04-03','15:30:00',5.09),('8348','2014-04-03','15:35:00',4.99),('8348','2014-04-03','15:40:00',4.88),('8348','2014-04-03','15:45:00',4.48),('8348','2014-04-03','15:50:00',3.49),('8348','2014-04-03','15:55:00',2.96),('8348','2014-04-03','16:00:00',2.15),('8348','2014-04-03','16:05:00',1.94),('8348','2014-04-03','16:10:00',1.77),('8348','2014-04-03','16:15:00',1.7),('8348','2014-04-03','16:20:00',1.85),('8348','2014-04-03','16:25:00',2.02),('8348','2014-04-03','16:30:00',2.06),('8348','2014-04-03','16:35:00',1.35),('8348','2014-04-03','16:40:00',1.11),('8348','2014-04-03','16:45:00',1.97),('8348','2014-04-03','16:50:00',2.92),('8348','2014-04-03','16:55:00',2.61),('8348','2014-04-03','17:00:00',2.4),('8348','2014-04-03','17:05:00',2.2),('8348','2014-04-03','17:10:00',2.03),('8348','2014-04-03','17:15:00',1.86),('8348','2014-04-03','17:20:00',1.65),('8348','2014-04-03','17:25:00',1.28),('8348','2014-04-02','07:00:00',1.22),('8348','2014-04-02','07:05:00',1.13),('8348','2014-04-02','07:20:00',1.06),('8348','2014-04-02','07:35:00',1.23),('8348','2014-04-02','07:40:00',1.31),('8348','2014-04-02','07:45:00',1.34),('8348','2014-04-02','07:50:00',1.98),('8348','2014-04-02','07:55:00',2.56),('8348','2014-04-02','08:00:00',1.49),('8348','2014-04-02','08:05:00',1.14),('8348','2014-04-02','08:10:00',1.15),('8348','2014-04-02','08:15:00',1.35),('8348','2014-04-02','08:20:00',1.35),('8348','2014-04-02','08:25:00',1.16),('8348','2014-04-02','08:30:00',1.03),('8348','2014-04-02','08:35:00',1.33),('8348','2014-04-02','08:40:00',1.64),('8348','2014-04-02','08:45:00',1.36),('8348','2014-04-02','08:50:00',1.87),('8348','2014-04-02','08:55:00',4.88),('8348','2014-04-02','09:00:00',4.02),('8348','2014-04-02','09:05:00',4.93),('8348','2014-04-02','09:10:00',5.27),('8348','2014-04-02','09:15:00',5.78),('8348','2014-04-02','09:20:00',5.82),('8348','2014-04-02','09:25:00',5.66),('8348','2014-04-02','09:30:00',2.28),('8348','2014-04-02','09:35:00',1.9),('8348','2014-04-02','09:40:00',2.18),('8348','2014-04-02','09:45:00',2.42),('8348','2014-04-02','09:50:00',5.87),('8348','2014-04-02','09:55:00',5.96),('8348','2014-04-02','10:00:00',6.13),('8348','2014-04-02','10:05:00',4.86),('8348','2014-04-02','10:10:00',2),('8348','2014-04-02','10:15:00',5.37),('8348','2014-04-02','10:20:00',6.39),('8348','2014-04-02','10:25:00',7.13),('8348','2014-04-02','10:30:00',5.66),('8348','2014-04-02','10:35:00',3.89),('8348','2014-04-02','10:40:00',2.42),('8348','2014-04-02','10:45:00',4.76),('8348','2014-04-02','10:50:00',7.19),('8348','2014-04-02','10:55:00',7.23),('8348','2014-04-02','11:00:00',7.12),('8348','2014-04-02','11:05:00',3.59),('8348','2014-04-02','11:10:00',2.79),('8348','2014-04-02','11:15:00',6.67),('8348','2014-04-02','11:20:00',7.55),('8348','2014-04-02','11:25:00',7.19),('8348','2014-04-02','11:30:00',6.43),('8348','2014-04-02','11:35:00',7.71),('8348','2014-04-02','11:40:00',6.12),('8348','2014-04-02','11:45:00',5.51),('8348','2014-04-02','11:50:00',6.28),('8348','2014-04-02','11:55:00',4.54),('8348','2014-04-02','12:00:00',4.59),('8348','2014-04-02','12:05:00',4.98),('8348','2014-04-02','12:10:00',6.5),('8348','2014-04-02','12:15:00',5.73),('8348','2014-04-02','12:20:00',6.33),('8348','2014-04-02','12:25:00',6.21),('8348','2014-04-02','12:30:00',7.57),('8348','2014-04-02','12:35:00',7.62),('8348','2014-04-02','12:40:00',7.83),('8348','2014-04-02','12:45:00',7.5),('8348','2014-04-02','12:50:00',7.43),('8348','2014-04-02','12:55:00',7.62),('8348','2014-04-02','13:00:00',7.44),('8348','2014-04-02','13:05:00',7.29),('8348','2014-04-02','13:10:00',7.49),('8348','2014-04-02','13:15:00',7.23),('8348','2014-04-02','13:20:00',7.3),('8348','2014-04-02','13:25:00',7.29),('8348','2014-04-02','13:30:00',7.12),('8348','2014-04-02','13:35:00',7.05),('8348','2014-04-02','13:40:00',6.68),('8348','2014-04-02','13:45:00',7.1),('8348','2014-04-02','13:50:00',6.07),('8348','2014-04-02','13:55:00',6.39),('8348','2014-04-02','14:00:00',6.55),('8348','2014-04-02','14:05:00',6.63),('8348','2014-04-02','14:10:00',6.25),('8348','2014-04-02','14:15:00',6.28),('8348','2014-04-02','14:20:00',6.32),('8348','2014-04-02','14:25:00',6.19),('8348','2014-04-02','14:30:00',5.86),('8348','2014-04-02','14:35:00',5.67),('8348','2014-04-02','14:40:00',6),('8348','2014-04-02','14:45:00',6.04),('8348','2014-04-02','14:50:00',5.97),('8348','2014-04-02','14:55:00',5.18),('8348','2014-04-02','15:00:00',5.46),('8348','2014-04-02','15:05:00',5.48),('8348','2014-04-02','15:10:00',5.37),('8348','2014-04-02','15:15:00',5.32),('8348','2014-04-02','15:20:00',5.11),('8348','2014-04-02','15:25:00',5.09),('8348','2014-04-02','15:30:00',5.05),('8348','2014-04-02','15:35:00',4.85),('8348','2014-04-02','15:40:00',4.78),('8348','2014-04-02','15:45:00',4.59),('8348','2014-04-02','15:50:00',4.2),('8348','2014-04-02','15:55:00',4.2),('8348','2014-04-02','16:00:00',4.31),('8348','2014-04-02','16:05:00',3.92),('8348','2014-04-02','16:10:00',3.79),('8348','2014-04-02','16:15:00',3.37),('8348','2014-04-02','16:20:00',3.35),('8348','2014-04-02','16:25:00',3.23),('8348','2014-04-02','16:30:00',2.93),('8348','2014-04-02','16:35:00',2.87),('8348','2014-04-02','16:40:00',2.13),('8348','2014-04-02','16:45:00',2.25),('8348','2014-04-02','16:50:00',2.69),('8348','2014-04-02','16:55:00',2.31),('8348','2014-04-02','17:00:00',2.12),('8348','2014-04-02','17:05:00',1.39),('8348','2014-04-02','17:10:00',1.24),('8348','2014-04-02','17:15:00',1.2),('8348','2014-04-02','17:20:00',1.28),('8348','2014-04-02','17:25:00',1.16),('8348','2013-05-30','08:25:00',1.02),('8348','2013-05-30','08:40:00',2.01),('8348','2013-05-30','08:45:00',2.03),('8348','2013-05-30','08:50:00',2.09),('8348','2013-05-30','08:55:00',2.16),('8348','2013-05-30','09:00:00',2.23),('8348','2013-05-30','09:05:00',2.3),('8348','2013-05-30','09:10:00',2.35),('8348','2013-05-30','09:15:00',2.44),('8348','2013-05-30','09:20:00',2.44),('8348','2013-05-30','09:25:00',2.66),('8348','2013-05-30','09:30:00',2.77),('8348','2013-05-30','09:35:00',2.77),('8348','2013-05-30','09:40:00',2.96),('8348','2013-05-30','09:45:00',2.63),('8348','2013-05-30','09:50:00',3.21),('8348','2013-05-30','09:55:00',1.57),('8348','2013-05-30','10:05:00',1.76),('8348','2013-05-30','10:10:00',3.09),('8348','2013-05-30','10:15:00',1.4),('8348','2013-05-30','10:20:00',3.29),('8348','2013-05-30','10:30:00',1.06),('8348','2013-05-30','10:35:00',1.21),('8348','2013-05-30','10:40:00',2.05),('8348','2013-05-30','10:45:00',3.81),('8348','2013-05-30','10:50:00',3.94),('8348','2013-05-30','10:55:00',3.67),('8348','2013-05-30','11:00:00',4.28),('8348','2013-05-30','11:05:00',3.44),('8348','2013-05-30','11:10:00',1.29),('8348','2013-05-30','11:15:00',2.05),('8348','2013-05-30','11:20:00',3.85),('8348','2013-05-30','11:25:00',1.79),('8348','2013-05-30','11:30:00',3.75),('8348','2013-05-30','11:35:00',4),('8348','2013-05-30','11:40:00',3.85),('8348','2013-05-30','11:45:00',3.4),('8348','2013-05-30','11:50:00',4.18),('8348','2013-05-30','11:55:00',1.05),('8348','2013-05-30','12:00:00',4.04),('8348','2013-05-30','12:05:00',4.68),('8348','2013-05-30','12:10:00',2.61),('8348','2013-05-30','12:15:00',4.53),('8348','2013-05-30','12:20:00',3.89),('8348','2013-05-30','12:25:00',4.09),('8348','2013-05-30','12:30:00',2.31),('8348','2013-05-29','07:50:00',1.01),('8348','2013-05-29','07:55:00',1.07),('8348','2013-05-29','08:00:00',1.13),('8348','2013-05-29','08:05:00',1.23),('8348','2013-05-29','08:10:00',1.34),('8348','2013-05-29','08:15:00',1.43),('8348','2013-05-29','08:20:00',1.49),('8348','2013-05-29','08:25:00',1.61),('8348','2013-05-29','08:30:00',1.71),('8348','2013-05-29','08:35:00',1.79),('8348','2013-05-29','08:40:00',1.86),('8348','2013-05-29','08:45:00',1.93),('8348','2013-05-29','08:50:00',2.01),('8348','2013-05-29','08:55:00',2.1),('8348','2013-05-29','09:00:00',2.17),('8348','2013-05-29','09:05:00',2.23),('8348','2013-05-29','09:10:00',2.3),('8348','2013-05-29','09:15:00',2.37),('8348','2013-05-29','09:20:00',2.43),('8348','2013-05-29','09:25:00',2.49),('8348','2013-05-29','09:30:00',2.55),('8348','2013-05-29','09:35:00',2.63),('8348','2013-05-29','09:40:00',2.7),('8348','2013-05-29','09:45:00',2.78),('8348','2013-05-29','09:50:00',2.85),('8348','2013-05-29','09:55:00',2.9),('8348','2013-05-29','10:00:00',2.95),('8348','2013-05-29','10:05:00',3.01),('8348','2013-05-29','10:10:00',3.06),('8348','2013-05-29','10:15:00',3.12),('8348','2013-05-29','10:20:00',3.2),('8348','2013-05-29','10:25:00',3.24),('8348','2013-05-29','10:30:00',3.3),('8348','2013-05-29','10:35:00',3.37),('8348','2013-05-29','10:40:00',3.41),('8348','2013-05-29','10:45:00',3.47),('8348','2013-05-29','10:50:00',3.49),('8348','2013-05-29','10:55:00',3.57),('8348','2013-05-29','11:00:00',3.61),('8348','2013-05-29','11:05:00',3.63),('8348','2013-05-29','11:10:00',3.79),('8348','2013-05-29','11:15:00',2.53),('8348','2013-05-29','11:20:00',3.59),('8348','2013-05-29','11:25:00',2.89),('8348','2013-05-29','11:30:00',4.28),('8348','2013-05-29','11:35:00',3.96),('8348','2013-05-29','11:40:00',3.04),('8348','2013-05-29','11:45:00',3.43),('8348','2013-05-29','11:50:00',3.14),('8348','2013-05-29','11:55:00',4.27),('8348','2013-05-29','12:00:00',4.17),('8348','2013-05-29','12:05:00',2.79),('8348','2013-05-29','12:10:00',3.86),('8348','2013-05-29','12:15:00',4.06),('8348','2013-05-29','12:20:00',4.23),('8348','2013-05-29','12:25:00',4.18),('8348','2013-05-29','12:30:00',4.14),('8348','2013-05-29','12:35:00',4.14),('8348','2013-05-29','12:40:00',4.18),('8348','2013-05-29','12:45:00',4.21),('8348','2013-05-29','12:50:00',4),('8348','2013-05-29','12:55:00',4.17),('8348','2013-05-29','13:00:00',4.2),('8348','2013-05-29','13:05:00',4.35),('8348','2013-05-29','13:10:00',3.96),('8348','2013-05-29','13:15:00',4.21),('8348','2013-05-29','13:20:00',4.75),('8348','2013-05-29','13:25:00',4.69),('8348','2013-05-29','13:30:00',4.49),('8348','2013-05-29','13:35:00',3.49),('8348','2013-05-29','13:40:00',4.2),('8348','2013-05-29','13:45:00',4.09),('8348','2013-05-29','13:50:00',3.83),('8348','2013-05-29','13:55:00',3.65),('8348','2013-05-29','14:00:00',4.27),('8348','2013-05-29','14:05:00',4.11),('8348','2013-05-29','14:10:00',4.08),('8348','2013-05-29','14:15:00',4.2),('8348','2013-05-29','14:20:00',4.19),('8348','2013-05-29','14:25:00',3.41),('8348','2013-05-29','14:30:00',4.19),('8348','2013-05-29','14:35:00',3.61),('8348','2013-05-29','14:40:00',4.3),('8348','2013-05-29','14:45:00',4.23),('8348','2013-05-29','14:50:00',3.71),('8348','2013-05-29','14:55:00',3.9),('8348','2013-05-29','15:00:00',4.22),('8348','2013-05-29','15:05:00',4.19),('8348','2013-05-29','15:10:00',3.58),('8348','2013-05-29','15:15:00',2.8),('8348','2013-05-29','15:20:00',3.09),('8348','2013-05-29','15:25:00',2.57),('8348','2013-05-29','15:30:00',2.9),('8348','2013-05-29','15:35:00',3.09),('8348','2013-05-29','15:40:00',2.65),('8348','2013-05-29','15:45:00',2.87),('8348','2013-05-29','15:50:00',2.77),('8348','2013-05-29','15:55:00',2.79),('8348','2013-05-29','16:00:00',2.61),('8348','2013-05-29','16:05:00',2.59),('8348','2013-05-29','16:10:00',2.22),('8348','2013-05-29','16:15:00',2.12),('8348','2013-05-29','16:20:00',2.06),('8348','2013-05-29','16:25:00',2.2),('8348','2013-05-29','16:30:00',1.87),('8348','2013-05-29','16:35:00',1.86),('8348','2013-05-29','16:40:00',2.2),('8348','2013-05-29','16:45:00',1.9),('8348','2013-05-29','16:50:00',1.52),('8348','2013-05-29','16:55:00',1.4),('8348','2013-05-29','17:00:00',1.28),('8348','2013-05-29','17:35:00',1.11),('8348','2013-05-29','17:40:00',1.66),('8348','2013-05-29','17:45:00',1.08),('8348','2013-05-29','18:05:00',1.36),('8348','2013-05-29','18:10:00',1.4),('8348','2013-05-29','18:15:00',2.22),('8348','2013-05-29','18:20:00',1.45),('8348','2013-05-28','07:50:00',1.01),('8348','2013-05-28','08:00:00',1.04),('8348','2013-05-28','08:05:00',1.09),('8348','2013-05-28','08:10:00',1.21),('8348','2013-05-28','08:15:00',1.4),('8348','2013-05-28','08:20:00',1.5),('8348','2013-05-28','08:25:00',1.37),('8348','2013-05-28','08:30:00',1.58),('8348','2013-05-28','08:35:00',1.45),('8348','2013-05-28','08:40:00',1.32),('8348','2013-05-28','08:45:00',1.28),('8348','2013-05-28','08:50:00',1.52),('8348','2013-05-28','08:55:00',1.36),('8348','2013-05-28','09:00:00',1.43),('8348','2013-05-28','09:05:00',1.62),('8348','2013-05-28','09:10:00',1.49),('8348','2013-05-28','09:15:00',1.42),('8348','2013-05-28','09:20:00',1.62),('8348','2013-05-28','09:25:00',1.81),('8348','2013-05-28','09:30:00',1.95),('8348','2013-05-28','09:35:00',2.03),('8348','2013-05-28','09:40:00',1.96),('8348','2013-05-28','09:45:00',1.83),('8348','2013-05-28','09:50:00',1.89),('8348','2013-05-28','09:55:00',2.02),('8348','2013-05-28','10:00:00',1.89),('8348','2013-05-28','10:05:00',2),('8348','2013-05-28','10:10:00',2.24),('8348','2013-05-28','10:15:00',2.32),('8348','2013-05-28','10:20:00',2.44),('8348','2013-05-28','10:25:00',2.44),('8348','2013-05-28','10:30:00',2.6),('8348','2013-05-28','10:35:00',2.67),('8348','2013-05-28','10:40:00',2.49),('8348','2013-05-28','10:45:00',2.31),('8348','2013-05-28','10:50:00',2.47),('8348','2013-05-28','10:55:00',2.18),('8348','2013-05-28','11:00:00',2.21),('8348','2013-05-28','11:05:00',2.13),('8348','2013-05-28','11:10:00',2.24),('8348','2013-05-28','11:15:00',2.1),('8348','2013-05-28','11:20:00',2.04),('8348','2013-05-28','11:25:00',2),('8348','2013-05-28','11:30:00',3.7),('8348','2013-05-28','11:35:00',2.68),('8348','2013-05-28','11:40:00',3.44),('8348','2013-05-28','11:45:00',3.09),('8348','2013-05-28','11:50:00',1.05),('8348','2013-05-28','11:55:00',1.54),('8348','2013-05-28','12:00:00',1.39),('8348','2013-05-28','12:05:00',1.77),('8348','2013-05-28','12:10:00',2.35),('8348','2013-05-28','12:15:00',2.44),('8348','2013-05-28','12:20:00',2.14),('8348','2013-05-28','12:25:00',2.18),('8348','2013-05-28','12:30:00',2.44),('8348','2013-05-28','12:35:00',2.38),('8348','2013-05-28','12:40:00',2.41),('8348','2013-05-28','12:45:00',2.67),('8348','2013-05-28','12:50:00',2.41),('8348','2013-05-28','12:55:00',2.47),('8348','2013-05-28','13:00:00',2.52),('8348','2013-05-28','13:05:00',2.7),('8348','2013-05-28','13:10:00',2.84),('8348','2013-05-28','13:15:00',2.38),('8348','2013-05-28','13:20:00',2.95),('8348','2013-05-28','13:25:00',1.64),('8348','2013-05-28','13:30:00',1.97),('8348','2013-05-28','13:35:00',1.66),('8348','2013-05-28','13:40:00',1.86),('8348','2013-05-28','13:45:00',1.76),('8348','2013-05-28','13:50:00',2.4),('8348','2013-05-28','13:55:00',2.28),('8348','2013-05-28','14:00:00',2.4),('8348','2013-05-28','14:05:00',2.53),('8348','2013-05-28','14:10:00',3.55),('8348','2013-05-28','14:15:00',3.65),('8348','2013-05-28','14:20:00',2.28),('8348','2013-05-28','14:25:00',2.55),('8348','2013-05-28','14:30:00',3.06),('8348','2013-05-28','14:35:00',2.64),('8348','2013-05-28','14:40:00',2.9),('8348','2013-05-28','14:45:00',3.51),('8348','2013-05-28','14:50:00',2.81),('8348','2013-05-28','14:55:00',2.45),('8348','2013-05-28','15:00:00',2.27),('8348','2013-05-28','15:05:00',3.32),('8348','2013-05-28','15:10:00',1.6),('8348','2013-05-28','15:15:00',2.39),('8348','2013-05-28','15:20:00',2.92),('8348','2013-05-28','15:25:00',2.13),('8348','2013-05-28','15:30:00',1.39),('8348','2013-05-28','15:35:00',1.43),('8348','2013-05-28','15:40:00',2.21),('8348','2013-05-28','15:45:00',3.51),('8348','2013-05-28','15:50:00',2.95),('8348','2013-05-28','15:55:00',2.14),('8348','2013-05-28','16:00:00',1.56),('8348','2013-05-28','16:05:00',1.26),('8348','2013-05-28','16:10:00',1.37),('8348','2013-05-28','16:15:00',1.51),('8348','2013-05-28','16:20:00',2.31),('8348','2013-05-28','16:25:00',2.12),('8348','2013-05-28','16:30:00',2.44),('8348','2013-05-28','16:35:00',3.06),('8348','2013-05-28','16:40:00',2.82),('8348','2013-05-28','16:45:00',2.72),('8348','2013-05-28','16:50:00',2.65),('8348','2013-05-28','16:55:00',2.59),('8348','2013-05-28','17:00:00',2.54),('8348','2013-05-28','17:05:00',2.49),('8348','2013-05-28','17:10:00',2.4),('8348','2013-05-28','17:15:00',2.35),('8348','2013-05-28','17:20:00',2.3),('8348','2013-05-28','17:25:00',2.21),('8348','2013-05-28','17:30:00',2.12),('8348','2013-05-28','17:35:00',2.05),('8348','2013-05-28','17:40:00',1.98),('8348','2013-05-28','17:45:00',1.9),('8348','2013-05-28','17:50:00',1.85),('8348','2013-05-28','17:55:00',1.8),('8348','2013-05-28','18:00:00',1.78),('8348','2013-05-28','18:05:00',1.71),('8348','2013-05-28','18:35:00',1.25),('8348','2013-05-28','18:40:00',1.18),('8348','2013-05-28','18:45:00',1.09),('8348','2013-05-28','18:50:00',1.02),('8348','2013-05-27','07:45:00',1),('8348','2013-05-27','08:00:00',1.06),('8348','2013-05-27','08:05:00',1.35),('8348','2013-05-27','08:10:00',1.53),('8348','2013-05-27','08:15:00',1.47),('8348','2013-05-27','08:20:00',1.33),('8348','2013-05-27','08:25:00',1.62),('8348','2013-05-27','08:30:00',1.73),('8348','2013-05-27','08:35:00',1.83),('8348','2013-05-27','08:40:00',1.91),('8348','2013-05-27','08:45:00',2.17),('8348','2013-05-27','08:50:00',2.21),('8348','2013-05-27','08:55:00',1.59),('8348','2013-05-27','09:00:00',2.48),('8348','2013-05-27','09:05:00',2.65),('8348','2013-05-27','09:10:00',2.42),('8348','2013-05-27','09:15:00',2.4),('8348','2013-05-27','09:20:00',1.72),('8348','2013-05-27','09:25:00',2.9),('8348','2013-05-27','09:30:00',2.72),('8348','2013-05-27','09:35:00',2.75),('8348','2013-05-27','09:40:00',2.79),('8348','2013-05-27','09:45:00',2.88),('8348','2013-05-27','09:50:00',2.89),('8348','2013-05-27','09:55:00',2.96),('8348','2013-05-27','10:00:00',3.16),('8348','2013-05-27','10:05:00',3.16),('8348','2013-05-27','10:10:00',3.23),('8348','2013-05-27','10:15:00',3.07),('8348','2013-05-27','10:20:00',2.44),('8348','2013-05-27','10:25:00',2.03),('8348','2013-05-27','10:30:00',1.83),('8348','2013-05-27','10:40:00',2.48),('8348','2013-05-27','10:45:00',2.43),('8348','2013-05-27','10:50:00',2.25),('8348','2013-05-27','10:55:00',2.46),('8348','2013-05-27','11:00:00',3.42),('8348','2013-05-27','11:05:00',2),('8348','2013-05-27','11:10:00',1.78),('8348','2013-05-27','11:15:00',1.89),('8348','2013-05-27','11:20:00',2.72),('8348','2013-05-27','11:25:00',2.74),('8348','2013-05-27','11:30:00',3.16),('8348','2013-05-27','11:35:00',1.52),('8348','2013-05-27','11:40:00',3.87),('8348','2013-05-27','11:45:00',2.63),('8348','2013-05-27','11:50:00',1.5),('8348','2013-05-27','11:55:00',1.84),('8348','2013-05-27','12:00:00',4.59),('8348','2013-05-27','12:05:00',2.82),('8348','2013-05-27','12:10:00',3.16),('8348','2013-05-27','12:15:00',2.09),('8348','2013-05-27','12:20:00',4.19),('8348','2013-05-27','12:25:00',3.37),('8348','2013-05-27','12:30:00',3.99),('8348','2013-05-27','12:35:00',1.99),('8348','2013-05-27','12:40:00',4.42),('8348','2013-05-27','12:45:00',3.16),('8348','2013-05-27','12:50:00',3.69),('8348','2013-05-27','12:55:00',4.08),('8348','2013-05-27','13:00:00',3.24),('8348','2013-05-27','13:05:00',2.04),('8348','2013-05-27','13:10:00',4.47),('8348','2013-05-27','13:15:00',2.52),('8348','2013-05-27','13:20:00',3.84),('8348','2013-05-27','13:25:00',4.38),('8348','2013-05-27','13:30:00',4.38),('8348','2013-05-27','13:35:00',2.21),('8348','2013-05-27','13:40:00',4.66),('8348','2013-05-27','13:45:00',3.07),('8348','2013-05-27','13:50:00',1.74),('8348','2013-05-27','13:55:00',4.39),('8348','2013-05-27','14:00:00',4.15),('8348','2013-05-27','14:05:00',4.24),('8348','2013-05-27','14:10:00',3.82),('8348','2013-05-27','14:15:00',3.69),('8348','2013-05-27','14:20:00',2.53),('8348','2013-05-27','14:25:00',4.09),('8348','2013-05-27','14:30:00',3.21),('8348','2013-05-27','14:35:00',3.33),('8348','2013-05-27','14:40:00',2.15),('8348','2013-05-27','14:45:00',4.44),('8348','2013-05-27','14:50:00',3.93),('8348','2013-05-27','14:55:00',3.55),('8348','2013-05-27','15:00:00',2.65),('8348','2013-05-27','15:05:00',2.56),('8348','2013-05-27','15:10:00',4.07),('8348','2013-05-27','15:15:00',2.77),('8348','2013-05-27','15:20:00',3.34),('8348','2013-05-27','15:25:00',3.24),('8348','2013-05-27','15:30:00',3.5),('8348','2013-05-27','15:35:00',3.99),('8348','2013-05-27','15:40:00',3.29),('8348','2013-05-27','15:45:00',2.57),('8348','2013-05-27','15:50:00',3.51),('8348','2013-05-27','15:55:00',2.44),('8348','2013-05-27','16:00:00',3.05),('8348','2013-05-27','16:05:00',2.14),('8348','2013-05-27','16:10:00',2.52),('8348','2013-05-27','16:15:00',2.22),('8348','2013-05-27','16:20:00',3.65),('8348','2013-05-27','16:25:00',3.52),('8348','2013-05-27','16:30:00',3.24),('8348','2013-05-27','16:35:00',2.94),('8348','2013-05-27','16:40:00',1.38),('8348','2013-05-27','16:45:00',1.23),('8348','2013-05-27','16:50:00',1.22),('8348','2013-05-27','16:55:00',1.29),('8348','2013-05-27','17:00:00',1.37),('8348','2013-05-27','17:05:00',1.42),('8348','2013-05-27','17:10:00',1.82),('8348','2013-05-27','17:15:00',1.42),('8348','2013-05-27','17:20:00',1.21),('8348','2013-05-27','17:25:00',1.11),('8348','2013-05-27','17:30:00',1.08),('8348','2013-05-27','17:35:00',1),('8348','2013-05-27','18:20:00',1.36),('8348','2013-05-27','18:25:00',2.02),('8348','2013-05-27','18:30:00',1.58),('8348','2013-05-27','18:35:00',1.21),('8348','2013-05-27','18:45:00',1.2),('8348','2013-05-27','18:55:00',1.2),('8348','2013-05-27','19:00:00',1.28),('8348','2013-05-27','19:05:00',1.24),('8348','2013-05-27','19:10:00',1.11),('8348','2013-05-26','07:45:00',1.09),('8348','2013-05-26','07:50:00',1.69),('8348','2013-05-26','08:05:00',1.75),('8348','2013-05-26','08:10:00',1.51),('8348','2013-05-26','08:20:00',1.12),('8348','2013-05-26','08:25:00',1.43),('8348','2013-05-26','08:30:00',1.71),('8348','2013-05-26','08:35:00',1.82),('8348','2013-05-26','08:40:00',2.07),('8348','2013-05-26','08:45:00',2.08),('8348','2013-05-26','08:50:00',1.89),('8348','2013-05-26','08:55:00',1.01),('8348','2013-05-26','09:00:00',2.01),('8348','2013-05-26','09:10:00',1.92),('8348','2013-05-26','09:15:00',2),('8348','2013-05-26','09:25:00',1.37),('8348','2013-05-26','09:40:00',1.12),('8348','2013-05-26','09:45:00',1.84),('8348','2013-05-26','09:55:00',1.09),('8348','2013-05-26','10:05:00',2.85),('8348','2013-05-26','10:10:00',3.37),('8348','2013-05-26','10:15:00',2.29),('8348','2013-05-26','10:20:00',2.65),('8348','2013-05-26','10:25:00',2.86),('8348','2013-05-26','10:30:00',3.18),('8348','2013-05-26','10:35:00',2.82),('8348','2013-05-26','10:40:00',3.59),('8348','2013-05-26','10:45:00',3.61),('8348','2013-05-26','10:50:00',3.67),('8348','2013-05-26','10:55:00',3.71),('8348','2013-05-26','11:00:00',3.69),('8348','2013-05-26','11:05:00',3.79),('8348','2013-05-26','11:10:00',3.82),('8348','2013-05-26','11:15:00',3.86),('8348','2013-05-26','11:20:00',3.91),('8348','2013-05-26','11:25:00',3.94),('8348','2013-05-26','11:30:00',3.99),('8348','2013-05-26','11:35:00',3.69),('8348','2013-05-26','11:40:00',4.11),('8348','2013-05-26','11:45:00',4.14),('8348','2013-05-26','11:50:00',4.13),('8348','2013-05-26','11:55:00',4.05),('8348','2013-05-26','12:00:00',4.19),('8348','2013-05-26','12:05:00',4.22),('8348','2013-05-26','12:10:00',3.89),('8348','2013-05-26','12:15:00',3.32),('8348','2013-05-26','12:20:00',3.71),('8348','2013-05-26','12:25:00',3.78),('8348','2013-05-26','12:30:00',4.3),('8348','2013-05-26','12:35:00',4.37),('8348','2013-05-26','12:40:00',3.94),('8348','2013-05-26','12:45:00',3.3),('8348','2013-05-26','12:50:00',4.43),('8348','2013-05-26','12:55:00',4.41),('8348','2013-05-26','13:00:00',4.43),('8348','2013-05-26','13:05:00',4.1),('8348','2013-05-26','13:10:00',4.47),('8348','2013-05-26','13:15:00',4.12),('8348','2013-05-26','13:20:00',4.41),('8348','2013-05-26','13:25:00',4.4),('8348','2013-05-26','13:30:00',4.41),('8348','2013-05-26','13:35:00',4.39),('8348','2013-05-26','13:40:00',4.36),('8348','2013-05-26','13:45:00',4.39),('8348','2013-05-26','13:50:00',4.04),('8348','2013-05-26','13:55:00',4.31),('8348','2013-05-26','14:00:00',4.29),('8348','2013-05-26','14:05:00',4.28),('8348','2013-05-26','14:10:00',4.22),('8348','2013-05-26','14:15:00',4.21),('8348','2013-05-26','14:20:00',4.23),('8348','2013-05-26','14:25:00',4.21),('8348','2013-05-26','14:30:00',4.19),('8348','2013-05-26','14:35:00',4.15),('8348','2013-05-26','14:40:00',4.16),('8348','2013-05-26','14:45:00',4.13),('8348','2013-05-26','14:50:00',4.12),('8348','2013-05-26','14:55:00',4.09),('8348','2013-05-26','15:00:00',4.04),('8348','2013-05-26','15:05:00',4.02),('8348','2013-05-26','15:10:00',4),('8348','2013-05-26','15:15:00',3.98),('8348','2013-05-26','15:20:00',3.94),('8348','2013-05-26','15:25:00',3.9),('8348','2013-05-26','15:30:00',3.86),('8348','2013-05-26','15:35:00',3.82),('8348','2013-05-26','15:40:00',3.8),('8348','2013-05-26','15:45:00',3.75),('8348','2013-05-26','15:50:00',3.69),('8348','2013-05-26','15:55:00',3.65),('8348','2013-05-26','16:00:00',3.62),('8348','2013-05-26','16:05:00',3.57),('8348','2013-05-26','16:10:00',3.51),('8348','2013-05-26','16:15:00',3.46),('8348','2013-05-26','16:20:00',3.41),('8348','2013-05-26','16:25:00',3.36),('8348','2013-05-26','16:30:00',3.3),('8348','2013-05-26','16:35:00',3.22),('8348','2013-05-26','16:40:00',3.18),('8348','2013-05-26','16:45:00',3.12),('8348','2013-05-26','16:50:00',3.06),('8348','2013-05-26','16:55:00',2.99),('8348','2013-05-26','17:00:00',2.92),('8348','2013-05-26','17:05:00',2.87),('8348','2013-05-26','17:10:00',2.79),('8348','2013-05-26','17:15:00',2.73),('8348','2013-05-26','17:20:00',2.64),('8348','2013-05-26','17:25:00',2.57),('8348','2013-05-26','17:30:00',2.48),('8348','2013-05-26','17:35:00',2.4),('8348','2013-05-26','17:40:00',2.34),('8348','2013-05-26','17:45:00',2.26),('8348','2013-05-26','17:50:00',2.2),('8348','2013-05-26','17:55:00',2.11),('8348','2013-05-26','18:00:00',2.03),('8348','2013-05-26','18:05:00',1.95),('8348','2013-05-26','18:10:00',1.87),('8348','2013-05-26','18:15:00',1.79),('8348','2013-05-26','18:20:00',1.7),('8348','2013-05-26','18:25:00',1.62),('8348','2013-05-26','18:30:00',1.53),('8348','2013-05-26','18:35:00',1.44),('8348','2013-05-26','18:40:00',1.34),('8348','2013-05-26','18:45:00',1.26),('8348','2013-05-26','18:50:00',1.19),('8348','2013-05-26','18:55:00',1.11),('8348','2013-05-26','19:00:00',1.02),('8348','2013-05-25','07:35:00',1.27),('8348','2013-05-25','07:55:00',1.29),('8348','2013-05-25','08:00:00',1.66),('8348','2013-05-25','08:05:00',1.55),('8348','2013-05-25','08:10:00',1.31),('8348','2013-05-25','08:20:00',1.13),('8348','2013-05-25','08:25:00',2.04),('8348','2013-05-25','08:30:00',2.18),('8348','2013-05-25','08:35:00',1.2),('8348','2013-05-25','08:40:00',1.24),('8348','2013-05-25','08:45:00',1.22),('8348','2013-05-25','08:50:00',1.52),('8348','2013-05-25','08:55:00',2.18),('8348','2013-05-25','09:00:00',2.01),('8348','2013-05-25','09:05:00',2.4),('8348','2013-05-25','09:10:00',1.84),('8348','2013-05-25','09:15:00',2.98),('8348','2013-05-25','09:20:00',1.33),('8348','2013-05-25','09:25:00',1.44),('8348','2013-05-25','09:30:00',1.08),('8348','2013-05-25','09:35:00',2.13),('8348','2013-05-25','09:40:00',3.18),('8348','2013-05-25','09:45:00',2.57),('8348','2013-05-25','09:50:00',3.15),('8348','2013-05-25','09:55:00',1.98),('8348','2013-05-25','10:10:00',1.09),('8348','2013-05-25','10:15:00',1.26),('8348','2013-05-25','10:40:00',1.37),('8348','2013-05-25','10:45:00',1.27),('8348','2013-05-25','10:50:00',1.27),('8348','2013-05-25','11:05:00',1.8),('8348','2013-05-25','11:10:00',3.75),('8348','2013-05-25','11:15:00',3.4),('8348','2013-05-25','11:20:00',2.77),('8348','2013-05-25','11:35:00',1.91),('8348','2013-05-25','11:40:00',2.28),('8348','2013-05-25','11:45:00',2.35),('8348','2013-05-25','11:50:00',1.65),('8348','2013-05-25','11:55:00',1.81),('8348','2013-05-25','12:00:00',1.75),('8348','2013-05-25','12:05:00',1.33),('8348','2013-05-25','12:10:00',1.71),('8348','2013-05-25','12:15:00',1.19),('8348','2013-05-25','12:20:00',1.47),('8348','2013-05-25','12:25:00',1.99),('8348','2013-05-25','12:30:00',1.32),('8348','2013-05-25','12:35:00',1.6),('8348','2013-05-25','12:40:00',1.77),('8348','2013-05-25','12:45:00',1.71),('8348','2013-05-25','12:50:00',1.21),('8348','2013-05-25','12:55:00',1.77),('8348','2013-05-25','13:05:00',2.12),('8348','2013-05-25','13:10:00',1.35),('8348','2013-05-25','13:15:00',1.78),('8348','2013-05-25','13:20:00',2.44),('8348','2013-05-25','13:25:00',2.82),('8348','2013-05-25','13:30:00',1.79),('8348','2013-05-25','13:35:00',1.4),('8348','2013-05-25','13:40:00',1.99),('8348','2013-05-25','13:45:00',1.98),('8348','2013-05-25','13:50:00',2.18),('8348','2013-05-25','13:55:00',3.51),('8348','2013-05-25','14:00:00',3.89),('8348','2013-05-25','14:05:00',3.6),('8348','2013-05-25','14:10:00',4.41),('8348','2013-05-25','14:15:00',4.02),('8348','2013-05-25','14:20:00',3.16),('8348','2013-05-25','14:25:00',2.08),('8348','2013-05-25','14:30:00',1.99),('8348','2013-05-25','14:35:00',2.57),('8348','2013-05-25','14:40:00',1.37),('8348','2013-05-25','14:45:00',2.16),('8348','2013-05-25','14:50:00',2.26),('8348','2013-05-25','14:55:00',1.93),('8348','2013-05-25','15:00:00',3.64),('8348','2013-05-25','15:05:00',3.27),('8348','2013-05-25','15:10:00',1.97),('8348','2013-05-25','15:15:00',2.57),('8348','2013-05-25','15:20:00',1.89),('8348','2013-05-25','15:25:00',1.98),('8348','2013-05-25','15:30:00',3.48),('8348','2013-05-25','15:35:00',4.17),('8348','2013-05-25','15:40:00',4.14),('8348','2013-05-25','15:45:00',3.69),('8348','2013-05-25','15:50:00',3.87),('8348','2013-05-25','15:55:00',3.85),('8348','2013-05-25','16:00:00',2.75),('8348','2013-05-25','16:05:00',2.32),('8348','2013-05-25','16:10:00',1.61),('8348','2013-05-25','16:15:00',1.32),('8348','2013-05-25','16:20:00',1.95),('8348','2013-05-25','16:25:00',1.73),('8348','2013-05-25','16:30:00',3.07),('8348','2013-05-25','16:35:00',3.37),('8348','2013-05-25','16:40:00',3.42),('8348','2013-05-25','16:45:00',1.89),('8348','2013-05-25','16:50:00',1.51),('8348','2013-05-25','17:05:00',1.55),('8348','2013-05-25','17:10:00',3.02),('8348','2013-05-25','17:15:00',2.8),('8348','2013-05-25','17:20:00',2.02),('8348','2013-05-25','17:35:00',1.88),('8348','2013-05-25','17:40:00',1.66),('8348','2013-05-25','17:50:00',1.43),('8348','2013-05-25','18:00:00',1.11),('8348','2013-05-24','08:05:00',1.42),('8348','2013-05-24','08:10:00',1.54),('8348','2013-05-24','08:15:00',1.47),('8348','2013-05-24','08:25:00',1.24),('8348','2013-05-24','08:30:00',1.81),('8348','2013-05-24','08:35:00',1.38),('8348','2013-05-24','08:45:00',2.02),('8348','2013-05-24','08:50:00',2.06),('8348','2013-05-24','08:55:00',2.16),('8348','2013-05-24','09:00:00',2.31),('8348','2013-05-24','09:05:00',2.49),('8348','2013-05-24','09:20:00',1.89),('8348','2013-05-24','09:25:00',1.72),('8348','2013-05-24','09:30:00',2.03),('8348','2013-05-24','09:40:00',1.42),('8348','2013-05-24','09:50:00',1.21),('8348','2013-05-24','09:55:00',2.36),('8348','2013-05-24','10:00:00',2.23),('8348','2013-05-24','10:20:00',1),('8348','2013-05-24','10:25:00',2.41),('8348','2013-05-24','10:30:00',3.38),('8348','2013-05-24','10:35:00',3.55),('8348','2013-05-24','10:40:00',3.62),('8348','2013-05-24','10:45:00',3.34),('8348','2013-05-24','10:50:00',3.56),('8348','2013-05-24','10:55:00',4.07),('8348','2013-05-24','11:00:00',3.57),('8348','2013-05-24','11:05:00',3.48),('8348','2013-05-24','11:10:00',3.68),('8348','2013-05-24','11:15:00',2.98),('8348','2013-05-24','11:20:00',4.11),('8348','2013-05-24','11:25:00',4.12),('8348','2013-05-24','11:30:00',2.92),('8348','2013-05-24','11:35:00',1.5),('8348','2013-05-24','11:45:00',2.97),('8348','2013-05-24','11:50:00',4.69),('8348','2013-05-24','11:55:00',3.23),('8348','2013-05-24','12:00:00',2.23),('8348','2013-05-24','12:05:00',2.4),('8348','2013-05-24','12:10:00',4.24),('8348','2013-05-24','12:15:00',3.09),('8348','2013-05-24','12:20:00',2.09),('8348','2013-05-24','12:25:00',3.26),('8348','2013-05-24','12:30:00',4.31),('8348','2013-05-24','12:35:00',2.2),('8348','2013-05-24','12:40:00',2.56),('8348','2013-05-24','12:45:00',2.55),('8348','2013-05-24','12:50:00',3.03),('8348','2013-05-24','12:55:00',2.54),('8348','2013-05-24','13:00:00',2.51),('8348','2013-05-24','13:05:00',2.02),('8348','2013-05-24','13:10:00',2.32),('8348','2013-05-24','13:15:00',2.87),('8348','2013-05-24','13:20:00',3.09),('8348','2013-05-24','13:25:00',2.22),('8348','2013-05-24','13:30:00',1.77),('8348','2013-05-24','13:35:00',2.84),('8348','2013-05-24','13:40:00',2.12),('8348','2013-05-24','13:45:00',1.1),('8348','2013-05-24','13:50:00',1.1),('8348','2013-05-24','13:55:00',2.19),('8348','2013-05-24','14:00:00',2.03),('8348','2013-05-24','14:05:00',1.93),('8348','2013-05-24','14:10:00',1.43),('8348','2013-05-24','14:15:00',3.92),('8348','2013-05-24','14:20:00',3.17),('8348','2013-05-24','14:25:00',2.63),('8348','2013-05-24','14:30:00',2.6),('8348','2013-05-24','14:35:00',3.24),('8348','2013-05-24','14:40:00',3.11),('8348','2013-05-24','14:45:00',2.58),('8348','2013-05-24','14:50:00',1.41),('8348','2013-05-24','14:55:00',1.74),('8348','2013-05-24','15:00:00',2.38),('8348','2013-05-24','15:05:00',3.11),('8348','2013-05-24','15:10:00',2.37),('8348','2013-05-24','15:15:00',2.72),('8348','2013-05-24','15:20:00',4.54),('8348','2013-05-24','15:25:00',3.68),('8348','2013-05-24','15:30:00',4.22),('8348','2013-05-24','15:35:00',3.5),('8348','2013-05-24','15:40:00',3.25),('8348','2013-05-24','15:45:00',3.96),('8348','2013-05-24','15:50:00',4.71),('8348','2013-05-24','15:55:00',4.14),('8348','2013-05-24','16:00:00',2.37),('8348','2013-05-24','16:05:00',2.07),('8348','2013-05-24','16:10:00',2.21),('8348','2013-05-24','16:15:00',2.72),('8348','2013-05-24','16:20:00',2.28),('8348','2013-05-24','16:25:00',3.18),('8348','2013-05-24','16:30:00',2.97),('8348','2013-05-24','16:35:00',1.74),('8348','2013-05-24','16:50:00',1.49),('8348','2013-05-24','16:55:00',1.69),('8348','2013-05-24','17:00:00',1.34),('8348','2013-05-24','17:20:00',1.01),('8348','2013-05-24','17:25:00',1.05),('8348','2013-05-24','17:30:00',1.06),('8348','2013-05-24','17:35:00',1.05),('8348','2013-05-23','08:05:00',1.42),('8348','2013-05-23','08:10:00',1.23),('8348','2013-05-23','08:30:00',1.22),('8348','2013-05-23','08:35:00',1.48),('8348','2013-05-23','08:40:00',2.13),('8348','2013-05-23','08:45:00',2.06),('8348','2013-05-23','08:50:00',1.2),('8348','2013-05-23','09:00:00',2.55),('8348','2013-05-23','09:20:00',2.07),('8348','2013-05-23','09:25:00',2.79),('8348','2013-05-23','09:30:00',2.96),('8348','2013-05-23','09:35:00',1.74),('8348','2013-05-23','09:40:00',2.18),('8348','2013-05-23','09:45:00',1.72),('8348','2013-05-23','09:50:00',3),('8348','2013-05-23','09:55:00',1.5),('8348','2013-05-23','10:00:00',1.35),('8348','2013-05-23','10:05:00',3.49),('8348','2013-05-23','10:10:00',2.05),('8348','2013-05-23','10:15:00',3.57),('8348','2013-05-23','10:20:00',1.69),('8348','2013-05-23','10:25:00',3.46),('8348','2013-05-23','10:30:00',3.05),('8348','2013-05-23','10:35:00',3.55),('8348','2013-05-23','10:40:00',3.36),('8348','2013-05-23','10:45:00',3.78),('8348','2013-05-23','10:50:00',2.5),('8348','2013-05-23','10:55:00',3.25),('8348','2013-05-23','11:00:00',2.13),('8348','2013-05-23','11:05:00',3.41),('8348','2013-05-23','11:10:00',2.84),('8348','2013-05-23','11:15:00',2.26),('8348','2013-05-23','11:20:00',1.89),('8348','2013-05-23','11:25:00',2.65),('8348','2013-05-23','11:30:00',2.58),('8348','2013-05-23','11:35:00',3.51),('8348','2013-05-23','11:40:00',4.3),('8348','2013-05-23','11:45:00',2.9),('8348','2013-05-23','11:50:00',2.13),('8348','2013-05-23','11:55:00',3.95),('8348','2013-05-23','12:00:00',3.83),('8348','2013-05-23','12:05:00',4.28),('8348','2013-05-23','12:10:00',4.36),('8348','2013-05-23','12:15:00',3.69),('8348','2013-05-23','12:20:00',3.27),('8348','2013-05-23','12:25:00',2.8),('8348','2013-05-23','12:30:00',3.64),('8348','2013-05-23','12:35:00',1.75),('8348','2013-05-23','12:40:00',4.46),('8348','2013-05-23','12:45:00',3.35),('8348','2013-05-23','12:50:00',3.83),('8348','2013-05-23','12:55:00',3.45),('8348','2013-05-23','13:00:00',4.44),('8348','2013-05-23','13:05:00',3.49),('8348','2013-05-23','13:10:00',4.51),('8348','2013-05-23','13:15:00',3.98),('8348','2013-05-23','13:20:00',3.41),('8348','2013-05-23','13:25:00',4.73),('8348','2013-05-23','13:30:00',4.01),('8348','2013-05-23','13:35:00',2.4),('8348','2013-05-23','13:40:00',2.37),('8348','2013-05-23','13:45:00',2.76),('8348','2013-05-23','13:50:00',3.8),('8348','2013-05-23','13:55:00',3.66),('8348','2013-05-23','14:00:00',4.47),('8348','2013-05-23','14:05:00',3.96),('8348','2013-05-23','14:10:00',3.44),('8348','2013-05-23','14:15:00',3.6),('8348','2013-05-23','14:20:00',3.93),('8348','2013-05-23','14:25:00',2.27),('8348','2013-05-23','14:30:00',2.24),('8348','2013-05-23','14:35:00',4.71),('8348','2013-05-23','14:40:00',2.76),('8348','2013-05-23','14:45:00',2.33),('8348','2013-05-23','14:50:00',2.65),('8348','2013-05-23','14:55:00',3.92),('8348','2013-05-23','15:00:00',4.26),('8348','2013-05-23','15:05:00',3.3),('8348','2013-05-23','15:10:00',1.37),('8348','2013-05-23','15:15:00',1.63),('8348','2013-05-23','15:20:00',3.37),('8348','2013-05-23','15:25:00',1.79),('8348','2013-05-23','15:30:00',3.36),('8348','2013-05-23','15:35:00',3.55),('8348','2013-05-23','15:40:00',1.45),('8348','2013-05-23','15:45:00',3.14),('8348','2013-05-23','15:50:00',1.11),('8348','2013-05-23','15:55:00',1.78),('8348','2013-05-23','16:00:00',2.9),('8348','2013-05-23','16:05:00',4.03),('8348','2013-05-23','16:10:00',2.44),('8348','2013-05-23','16:15:00',2.22),('8348','2013-05-23','16:20:00',3.38),('8348','2013-05-23','16:25:00',2.17),('8348','2013-05-23','16:30:00',3.08),('8348','2013-05-23','16:35:00',1.45),('8348','2013-05-23','16:40:00',1.64),('8348','2013-05-23','16:45:00',2.39),('8348','2013-05-23','17:05:00',1.14),('8348','2013-05-23','17:10:00',2.85),('8348','2013-05-23','17:15:00',1.44),('8348','2013-05-23','17:25:00',1.01),('8348','2013-05-23','17:30:00',1.05),('8348','2013-05-23','17:35:00',1.61),('8348','2013-05-23','17:40:00',1.12),('8348','2013-05-23','17:50:00',1.2),('8348','2013-05-23','17:55:00',1.28),('8348','2013-05-23','18:00:00',1.91),('8348','2013-05-23','18:05:00',2.38),('8348','2013-05-23','18:45:00',1.24),('8348','2013-05-23','18:50:00',1.29),('8348','2013-05-22','08:05:00',1.18),('8348','2013-05-22','08:15:00',1.66),('8348','2013-05-22','08:20:00',1.59),('8348','2013-05-22','08:25:00',1.43),('8348','2013-05-22','08:30:00',1.9),('8348','2013-05-22','08:35:00',2.22),('8348','2013-05-22','08:40:00',1.37),('8348','2013-05-22','08:45:00',1.31),('8348','2013-05-22','09:25:00',1.03),('8348','2013-05-22','09:30:00',2.48),('8348','2013-05-22','09:35:00',2.51),('8348','2013-05-22','09:40:00',2.49),('8348','2013-05-22','09:45:00',2.51),('8348','2013-05-22','09:50:00',2.56),('8348','2013-05-22','09:55:00',2.61),('8348','2013-05-22','10:00:00',2.68),('8348','2013-05-22','10:05:00',2.74),('8348','2013-05-22','10:10:00',2.8),('8348','2013-05-22','10:15:00',2.86),('8348','2013-05-22','10:20:00',2.77),('8348','2013-05-22','10:25:00',2.91),('8348','2013-05-22','10:30:00',3.02),('8348','2013-05-22','10:35:00',3.05),('8348','2013-05-22','10:40:00',3.24),('8348','2013-05-22','10:45:00',3.22),('8348','2013-05-22','10:50:00',3.15),('8348','2013-05-22','10:55:00',3.18),('8348','2013-05-22','11:00:00',3.24),('8348','2013-05-22','11:05:00',3.33),('8348','2013-05-22','11:10:00',2.66),('8348','2013-05-22','11:15:00',3.25),('8348','2013-05-22','11:20:00',3.47),('8348','2013-05-22','11:25:00',3.62),('8348','2013-05-22','11:30:00',2.65),('8348','2013-05-22','11:35:00',3.07),('8348','2013-05-22','11:40:00',2.65),('8348','2013-05-22','11:45:00',3.68),('8348','2013-05-22','11:50:00',2.18),('8348','2013-05-22','11:55:00',1.79),('8348','2013-05-22','12:00:00',2.67),('8348','2013-05-22','12:05:00',2.16),('8348','2013-05-22','12:10:00',2.12),('8348','2013-05-22','12:15:00',2.76),('8348','2013-05-22','12:20:00',3.09),('8348','2013-05-22','12:25:00',2.92),('8348','2013-05-22','12:30:00',1.99),('8348','2013-05-22','12:35:00',2.09),('8348','2013-05-22','12:40:00',1.56),('8348','2013-05-22','13:05:00',3.67),('8348','2013-05-22','13:10:00',2.55),('8348','2013-05-22','13:15:00',2.48),('8348','2013-05-22','13:20:00',3.01),('8348','2013-05-22','13:25:00',1.02),('8348','2013-05-22','13:30:00',1.54),('8348','2013-05-22','13:35:00',3.49),('8348','2013-05-22','13:40:00',2.58),('8348','2013-05-22','13:45:00',2.6),('8348','2013-05-22','13:50:00',1.83),('8348','2013-05-22','13:55:00',1.76),('8348','2013-05-22','14:00:00',2.6),('8348','2013-05-22','14:05:00',3.2),('8348','2013-05-22','14:10:00',3.77),('8348','2013-05-22','14:15:00',3.93),('8348','2013-05-22','14:20:00',3.81),('8348','2013-05-22','14:25:00',3.75),('8348','2013-05-22','14:30:00',3.71),('8348','2013-05-22','14:35:00',3.7),('8348','2013-05-22','14:40:00',3.7),('8348','2013-05-22','14:45:00',3.67),('8348','2013-05-22','14:50:00',3.65),('8348','2013-05-22','14:55:00',3.61),('8348','2013-05-22','15:00:00',3.59),('8348','2013-05-22','15:05:00',3.54),('8348','2013-05-22','15:10:00',3.52),('8348','2013-05-22','15:15:00',3.5),('8348','2013-05-22','15:20:00',3.15),('8348','2013-05-22','15:25:00',2.1),('8348','2013-05-22','15:30:00',1.69),('8348','2013-05-22','15:35:00',2.05),('8348','2013-05-22','15:40:00',2.73),('8348','2013-05-22','15:45:00',2.64),('8348','2013-05-22','15:50:00',3.29),('8348','2013-05-22','15:55:00',3.07),('8348','2013-05-22','16:00:00',3.17),('8348','2013-05-22','16:05:00',3.08),('8348','2013-05-22','16:10:00',3.01),('8348','2013-05-22','16:15:00',2.99),('8348','2013-05-22','16:20:00',2.93),('8348','2013-05-22','16:25:00',2.88),('8348','2013-05-22','16:30:00',2.81),('8348','2013-05-22','16:35:00',2.74),('8348','2013-05-22','16:40:00',2.7),('8348','2013-05-22','16:45:00',2.15),('8348','2013-05-22','16:50:00',1.17),('8348','2013-05-22','17:15:00',1.12),('8348','2013-05-22','17:20:00',1.35),('8348','2013-05-22','17:25:00',1.68),('8348','2013-05-22','17:30:00',1.3),('8348','2013-05-22','17:35:00',1.55),('8348','2013-05-22','17:55:00',1.25),('8348','2013-05-22','18:00:00',1.69),('8348','2013-05-22','18:05:00',1.09),('8348','2014-04-01','07:15:00',1.05),('8348','2014-04-01','07:20:00',1.15),('8348','2014-04-01','07:25:00',1.25),('8348','2014-04-01','07:30:00',1.34),('8348','2014-04-01','07:35:00',1.47),('8348','2014-04-01','07:40:00',1.67),('8348','2014-04-01','07:45:00',1.78),('8348','2014-04-01','07:50:00',1.89),('8348','2014-04-01','07:55:00',2),('8348','2014-04-01','08:00:00',2.12),('8348','2014-04-01','08:05:00',2.26),('8348','2014-04-01','08:10:00',2.38),('8348','2014-04-01','08:15:00',2.5),('8348','2014-04-01','08:20:00',2.71),('8348','2014-04-01','08:25:00',3.1),('8348','2014-04-01','08:30:00',3.31),('8348','2014-04-01','08:35:00',3.45),('8348','2014-04-01','08:40:00',3.66),('8348','2014-04-01','08:45:00',3.86),('8348','2014-04-01','08:50:00',3.91),('8348','2014-04-01','08:55:00',4.19),('8348','2014-04-01','09:00:00',4.3),('8348','2014-04-01','09:05:00',4.25),('8348','2014-04-01','09:10:00',4.58),('8348','2014-04-01','09:15:00',4.77),('8348','2014-04-01','09:20:00',5.1),('8348','2014-04-01','09:25:00',4.76),('8348','2014-04-01','09:30:00',4.5),('8348','2014-04-01','09:35:00',4.53),('8348','2014-04-01','09:40:00',4.56),('8348','2014-04-01','09:45:00',3),('8348','2014-04-01','09:50:00',5.72),('8348','2014-04-01','09:55:00',5.66),('8348','2014-04-01','10:00:00',5.73),('8348','2014-04-01','10:05:00',5.82),('8348','2014-04-01','10:10:00',5.85),('8348','2014-04-01','10:15:00',5.92),('8348','2014-04-01','10:20:00',5.85),('8348','2014-04-01','10:25:00',6),('8348','2014-04-01','10:30:00',6.24),('8348','2014-04-01','10:35:00',6.39),('8348','2014-04-01','10:40:00',6.4),('8348','2014-04-01','10:45:00',6.61),('8348','2014-04-01','10:50:00',6.56),('8348','2014-04-01','10:55:00',6.62),('8348','2014-04-01','11:00:00',6.69),('8348','2014-04-01','11:05:00',6.75),('8348','2014-04-01','11:10:00',6.85),('8348','2014-04-01','11:15:00',6.91),('8348','2014-04-01','11:20:00',7.04),('8348','2014-04-01','11:25:00',7.14),('8348','2014-04-01','11:30:00',7.2),('8348','2014-04-01','11:35:00',7.22),('8348','2014-04-01','11:40:00',7.24),('8348','2014-04-01','11:45:00',7.26),('8348','2014-04-01','11:50:00',7.34),('8348','2014-04-01','11:55:00',7.28),('8348','2014-04-01','12:00:00',7.26),('8348','2014-04-01','12:05:00',7.39),('8348','2014-04-01','12:10:00',7.46),('8348','2014-04-01','12:15:00',7.19),('8348','2014-04-01','12:20:00',7.26),('8348','2014-04-01','12:25:00',7.33),('8348','2014-04-01','12:30:00',7.38),('8348','2014-04-01','12:35:00',7.41),('8348','2014-04-01','12:40:00',7.41),('8348','2014-04-01','12:45:00',6.95),('8348','2014-04-01','12:50:00',7.17),('8348','2014-04-01','12:55:00',7.43),('8348','2014-04-01','13:00:00',7.38),('8348','2014-04-01','13:05:00',7.39),('8348','2014-04-01','13:10:00',7.37),('8348','2014-04-01','13:15:00',7.37),('8348','2014-04-01','13:20:00',7.19),('8348','2014-04-01','13:25:00',7.28),('8348','2014-04-01','13:30:00',5.82),('8348','2014-04-01','13:35:00',7.01),('8348','2014-04-01','13:40:00',7.48),('8348','2014-04-01','13:45:00',7.71),('8348','2014-04-01','13:50:00',6.54),('8348','2014-04-01','13:55:00',6.99),('8348','2014-04-01','14:00:00',6.18),('8348','2014-04-01','14:05:00',7.06),('8348','2014-04-01','14:10:00',6.49),('8348','2014-04-01','14:15:00',5.8),('8348','2014-04-01','14:20:00',6.05),('8348','2014-04-01','14:25:00',6.37),('8348','2014-04-01','14:30:00',6.92),('8348','2014-04-01','14:35:00',4.88),('8348','2014-04-01','14:40:00',6.16),('8348','2014-04-01','14:45:00',6.15),('8348','2014-04-01','14:50:00',5.81),('8348','2014-04-01','14:55:00',4.35),('8348','2014-04-01','15:00:00',4.33),('8348','2014-04-01','15:05:00',5.69),('8348','2014-04-01','15:10:00',5.14),('8348','2014-04-01','15:15:00',4.16),('8348','2014-04-01','15:20:00',5.16),('8348','2014-04-01','15:25:00',3.73),('8348','2014-04-01','15:30:00',4.63),('8348','2014-04-01','15:35:00',4.63),('8348','2014-04-01','15:40:00',3.45),('8348','2014-04-01','15:45:00',4.12),('8348','2014-04-01','15:50:00',3.79),('8348','2014-04-01','15:55:00',3.62),('8348','2014-04-01','16:00:00',4.68),('8348','2014-04-01','16:05:00',4.13),('8348','2014-04-01','16:10:00',4.23),('8348','2014-04-01','16:15:00',3.71),('8348','2014-04-01','16:20:00',3.74),('8348','2014-04-01','16:25:00',3.36),('8348','2014-04-01','16:30:00',3.5),('8348','2014-04-01','16:35:00',3.25),('8348','2014-04-01','16:40:00',3.07),('8348','2014-04-01','16:45:00',2.69),('8348','2014-04-01','16:50:00',2.76),('8348','2014-04-01','16:55:00',2.56),('8348','2014-04-01','17:00:00',2.34),('8348','2014-04-01','17:05:00',2.15),('8348','2014-04-01','17:10:00',2),('8348','2014-04-01','17:15:00',1.81),('8348','2014-04-01','17:20:00',1.51),('8348','2014-04-01','17:25:00',1.26),('8348','2013-05-21','07:35:00',1.04),('8348','2013-05-21','07:40:00',1.2),('8348','2013-05-21','07:45:00',1.01),('8348','2013-05-21','08:10:00',1.27),('8348','2013-05-21','08:15:00',1.58),('8348','2013-05-21','08:20:00',1.39),('8348','2013-05-21','08:25:00',1.66),('8348','2013-05-21','08:30:00',1.19),('8348','2013-05-21','08:35:00',1.16),('8348','2013-05-21','08:40:00',1.33),('8348','2013-05-21','08:45:00',1.15),('8348','2013-05-21','08:50:00',1.27),('8348','2013-05-21','08:55:00',1.57),('8348','2013-05-21','09:00:00',1.36),('8348','2013-05-21','09:05:00',1.22),('8348','2013-05-21','09:10:00',1.34),('8348','2013-05-21','09:15:00',1.48),('8348','2013-05-21','09:20:00',1.96),('8348','2013-05-21','09:25:00',2.14),('8348','2013-05-21','09:30:00',1.74),('8348','2013-05-21','09:35:00',1.7),('8348','2013-05-21','09:40:00',1.86),('8348','2013-05-21','09:45:00',1.55),('8348','2013-05-21','09:50:00',1.55),('8348','2013-05-21','09:55:00',1.71),('8348','2013-05-21','10:00:00',1.89),('8348','2013-05-21','10:05:00',1.89),('8348','2013-05-21','10:10:00',2.1),('8348','2013-05-21','10:15:00',2.14),('8348','2013-05-21','10:20:00',1.84),('8348','2013-05-21','10:25:00',1.78),('8348','2013-05-21','10:30:00',1.68),('8348','2013-05-21','10:35:00',1.69),('8348','2013-05-21','10:40:00',1.86),('8348','2013-05-21','10:45:00',2.65),('8348','2013-05-21','10:50:00',1.9),('8348','2013-05-21','10:55:00',1.52),('8348','2013-05-21','11:00:00',1.74),('8348','2013-05-21','11:05:00',1.62),('8348','2013-05-21','11:10:00',2.45),('8348','2013-05-21','11:15:00',3.32),('8348','2013-05-21','11:20:00',2.95),('8348','2013-05-21','11:25:00',3.61),('8348','2013-05-21','11:30:00',2.78),('8348','2013-05-21','11:35:00',2.34),('8348','2013-05-21','11:40:00',2.3),('8348','2013-05-21','11:45:00',2.94),('8348','2013-05-21','11:50:00',2.55),('8348','2013-05-21','11:55:00',3.19),('8348','2013-05-21','12:00:00',2.72),('8348','2013-05-21','12:05:00',3.5),('8348','2013-05-21','12:10:00',2.59),('8348','2013-05-21','12:15:00',2.89),('8348','2013-05-21','12:20:00',2.11),('8348','2013-05-21','12:25:00',2.78),('8348','2013-05-21','12:30:00',3.81),('8348','2013-05-21','12:35:00',2.38),('8348','2013-05-21','12:40:00',3.8),('8348','2013-05-21','12:45:00',3.52),('8348','2013-05-21','12:50:00',2.48),('8348','2013-05-21','12:55:00',4.11),('8348','2013-05-21','13:00:00',3.48),('8348','2013-05-21','13:05:00',3.77),('8348','2013-05-21','13:10:00',2.3),('8348','2013-05-21','13:15:00',3.27),('8348','2013-05-21','13:20:00',2.7),('8348','2013-05-21','13:25:00',2.61),('8348','2013-05-21','13:30:00',2.65),('8348','2013-05-21','13:35:00',1.38),('8348','2013-05-21','14:05:00',1.01),('8348','2013-05-21','14:10:00',1.6),('8348','2013-05-21','14:15:00',1.92),('8348','2013-05-21','14:20:00',1.64),('8348','2013-05-21','14:25:00',2.39),('8348','2013-05-21','14:30:00',2.52),('8348','2013-05-21','14:35:00',1.86),('8348','2013-05-21','14:40:00',1.73),('8348','2013-05-21','14:45:00',1.52),('8348','2013-05-21','15:15:00',1.04),('8348','2013-05-21','15:20:00',1.44),('8348','2013-05-21','15:25:00',1.47),('8348','2013-05-21','15:30:00',2.27),('8348','2013-05-21','15:35:00',1.56),('8348','2013-05-21','15:40:00',1.26),('8348','2013-05-21','15:45:00',1.31),('8348','2013-05-21','15:50:00',1.17),('8348','2013-05-21','15:55:00',1.12),('8348','2013-05-21','16:00:00',1.08),('8348','2013-05-21','16:05:00',1.08),('8348','2013-05-21','16:10:00',1.23),('8348','2013-05-21','16:15:00',1.02),('8348','2013-05-21','16:25:00',1.15),('8348','2013-05-21','16:30:00',1.77),('8348','2013-05-21','16:35:00',2.02),('8348','2013-05-21','16:40:00',1.82),('8348','2013-05-21','16:45:00',1.8),('8348','2013-05-21','16:50:00',1.02),('8348','2013-05-17','08:00:00',1.03),('8348','2013-05-17','08:10:00',1.02),('8348','2013-05-17','08:15:00',1.45),('8348','2013-05-17','08:20:00',1.89),('8348','2013-05-17','08:25:00',1.45),('8348','2013-05-17','09:25:00',1.09),('8348','2013-05-17','10:25:00',1.22),('8348','2013-05-17','10:30:00',1.52),('8348','2013-05-17','10:35:00',1.17),('8348','2013-05-17','10:40:00',1.28),('8348','2013-05-17','10:45:00',1.43),('8348','2013-05-17','10:50:00',2.4),('8348','2013-05-17','10:55:00',2.61),('8348','2013-05-17','11:00:00',2.16),('8348','2013-05-17','11:05:00',1.82),('8348','2013-05-17','11:10:00',1.35),('8348','2013-05-17','11:15:00',2.03),('8348','2013-05-17','11:20:00',1.89),('8348','2013-05-17','11:25:00',1.62),('8348','2013-05-17','11:30:00',1.46),('8348','2013-05-17','11:35:00',2.07),('8348','2013-05-17','11:40:00',1.38),('8348','2013-05-17','11:45:00',2.67),('8348','2013-05-17','11:50:00',4.35),('8348','2013-05-17','11:55:00',3.26),('8348','2013-05-17','12:00:00',3.66),('8348','2013-05-17','12:05:00',2.82),('8348','2013-05-17','12:10:00',3.22),('8348','2013-05-17','12:15:00',1.98),('8348','2013-05-17','12:20:00',3.06),('8348','2013-05-17','12:25:00',3.37),('8348','2013-05-17','12:30:00',2.25),('8348','2013-05-17','12:35:00',2.66),('8348','2013-05-17','12:40:00',3.94),('8348','2013-05-17','12:45:00',4.44),('8348','2013-05-17','12:50:00',4.43),('8348','2013-05-17','12:55:00',3.97),('8348','2013-05-17','13:00:00',3.23),('8348','2013-05-17','13:05:00',3.46),('8348','2013-05-17','13:10:00',3.63),('8348','2013-05-17','13:15:00',4.16),('8348','2013-05-17','13:20:00',4.23),('8348','2013-05-17','13:25:00',4.17),('8348','2013-05-17','13:30:00',3.24),('8348','2013-05-17','13:35:00',4.22),('8348','2013-05-17','13:40:00',3.64),('8348','2013-05-17','13:45:00',3.61),('8348','2013-05-17','13:50:00',3.96),('8348','2013-05-17','13:55:00',4.48),('8348','2013-05-17','14:00:00',3.06),('8348','2013-05-17','14:05:00',3.1),('8348','2013-05-17','14:10:00',3.75),('8348','2013-05-17','14:15:00',3.91),('8348','2013-05-17','14:20:00',4.19),('8348','2013-05-17','14:25:00',3.67),('8348','2013-05-17','14:30:00',3.64),('8348','2013-05-17','14:35:00',3.74),('8348','2013-05-16','09:20:00',1.01),('8348','2013-05-16','09:25:00',1.39),('8348','2013-05-16','09:30:00',1.39),('8348','2013-05-16','09:35:00',1.6),('8348','2013-05-16','09:40:00',1.81),('8348','2013-05-16','09:45:00',2.17),('8348','2013-05-16','09:50:00',1.19),('8348','2013-05-16','09:55:00',1.09),('8348','2013-05-16','10:00:00',1.37),('8348','2013-05-16','10:05:00',1.18),('8348','2013-05-16','10:10:00',1.07),('8348','2013-05-16','10:15:00',1.38),('8348','2013-05-16','10:20:00',1.85),('8348','2013-05-16','10:25:00',1.64),('8348','2013-05-16','10:30:00',1.7),('8348','2013-05-16','10:35:00',1.25),('8348','2013-05-16','10:40:00',1.28),('8348','2013-05-16','10:45:00',1.18),('8348','2013-05-16','10:50:00',1.35),('8348','2013-05-16','10:55:00',1.48),('8348','2013-05-16','11:00:00',3.45),('8348','2013-05-16','11:05:00',3.04),('8348','2013-05-16','11:10:00',2.82),('8348','2013-05-16','11:15:00',2.34),('8348','2013-05-16','11:20:00',1.11),('8348','2013-05-16','11:25:00',1.2),('8348','2013-05-16','11:30:00',1.43),('8348','2013-05-16','11:35:00',2.38),('8348','2013-05-16','11:40:00',3.63),('8348','2013-05-16','11:45:00',3.22),('8348','2013-05-16','11:50:00',3.33),('8348','2013-05-16','11:55:00',2.43),('8348','2013-05-16','12:00:00',1.68),('8348','2013-05-16','12:05:00',1.47),('8348','2013-05-16','12:10:00',1.51),('8348','2013-05-16','12:15:00',2.25),('8348','2013-05-16','12:20:00',1.8),('8348','2013-05-16','12:25:00',1.92),('8348','2013-05-16','12:30:00',2.82),('8348','2013-05-16','12:35:00',2.97),('8348','2013-05-16','12:40:00',3.92),('8348','2013-05-16','12:45:00',2.97),('8348','2013-05-16','12:50:00',2.28),('8348','2013-05-16','12:55:00',3.5),('8348','2013-05-16','13:00:00',3.71),('8348','2013-05-16','13:05:00',3.64),('8348','2013-05-16','13:10:00',3.59),('8348','2013-05-16','13:15:00',3.26),('8348','2013-05-16','13:20:00',2.99),('8348','2013-05-16','13:25:00',3.66),('8348','2013-05-16','13:30:00',3.57),('8348','2013-05-16','13:35:00',3.55),('8348','2013-05-16','13:40:00',3.51),('8348','2013-05-16','13:45:00',3.5),('8348','2013-05-16','13:50:00',3.5),('8348','2013-05-16','13:55:00',3.53),('8348','2013-05-16','14:00:00',3.49),('8348','2013-05-16','14:05:00',3.49),('8348','2013-05-16','14:10:00',3.49),('8348','2013-05-16','14:15:00',3.44),('8348','2013-05-16','14:20:00',3.43),('8348','2013-05-16','14:25:00',3.38),('8348','2013-05-16','14:30:00',3.39),('8348','2013-05-16','14:35:00',3.33),('8348','2013-05-16','14:40:00',3.31),('8348','2013-05-16','14:45:00',3.32),('8348','2013-05-16','14:50:00',3.08),('8348','2013-05-16','14:55:00',2.83),('8348','2013-05-16','15:00:00',3.27),('8348','2013-05-16','15:05:00',3.23),('8348','2013-05-16','15:10:00',3.24),('8348','2013-05-16','15:15:00',2.96),('8348','2013-05-16','15:20:00',3.14),('8348','2013-05-16','15:25:00',3.12),('8348','2013-05-16','15:30:00',3.03),('8348','2013-05-16','15:35:00',2.94),('8348','2013-05-16','15:40:00',3.02),('8348','2013-05-16','15:45:00',2.92),('8348','2013-05-16','15:50:00',2.9),('8348','2013-05-16','15:55:00',2.86),('8348','2013-05-16','16:00:00',2.85),('8348','2013-05-16','16:05:00',2.68),('8348','2013-05-16','16:10:00',2.71),('8348','2013-05-16','16:15:00',2.52),('8348','2013-05-16','16:20:00',2.71),('8348','2013-05-16','16:25:00',2.56),('8348','2013-05-16','16:30:00',2.57),('8348','2013-05-16','16:35:00',2.5),('8348','2013-05-16','16:40:00',1.49),('8348','2013-05-16','16:45:00',1.3),('8348','2013-05-16','16:50:00',1.72),('8348','2013-05-16','16:55:00',1.57),('8348','2013-05-16','17:00:00',1.56),('8348','2013-05-16','17:15:00',1.23),('8348','2013-05-16','17:20:00',1.39),('8348','2013-05-16','17:25:00',1.42),('8348','2013-05-16','17:30:00',1.69),('8348','2013-05-16','17:35:00',1.7),('8348','2013-05-16','17:40:00',1.41),('8348','2013-05-16','19:00:00',1.01),('8348','2013-05-15','07:45:00',1.01),('8348','2013-05-15','07:50:00',1.03),('8348','2013-05-15','08:10:00',1.15),('8348','2013-05-15','08:15:00',1.27),('8348','2013-05-15','08:20:00',1.33),('8348','2013-05-15','08:25:00',1.41),('8348','2013-05-15','08:30:00',1.45),('8348','2013-05-15','08:35:00',1.6),('8348','2013-05-15','08:40:00',1.69),('8348','2013-05-15','08:45:00',1.77),('8348','2013-05-15','08:50:00',1.84),('8348','2013-05-15','08:55:00',1.93),('8348','2013-05-15','09:00:00',1.88),('8348','2013-05-15','09:05:00',2.02),('8348','2013-05-15','09:10:00',2.01),('8348','2013-05-15','09:15:00',2.09),('8348','2013-05-15','09:20:00',2.09),('8348','2013-05-15','09:25:00',2.17),('8348','2013-05-15','09:30:00',2.3),('8348','2013-05-15','09:35:00',2.35),('8348','2013-05-15','09:40:00',2.36),('8348','2013-05-15','09:45:00',2.46),('8348','2013-05-15','09:50:00',2.54),('8348','2013-05-15','09:55:00',2.58),('8348','2013-05-15','10:00:00',2.66),('8348','2013-05-15','10:05:00',2.69),('8348','2013-05-15','10:10:00',2.73),('8348','2013-05-15','10:15:00',2.73),('8348','2013-05-15','10:20:00',2.86),('8348','2013-05-15','10:25:00',2.93),('8348','2013-05-15','10:30:00',2.87),('8348','2013-05-15','10:35:00',2.97),('8348','2013-05-15','10:40:00',3.04),('8348','2013-05-15','10:45:00',3.1),('8348','2013-05-15','10:50:00',3.1),('8348','2013-05-15','10:55:00',3.01),('8348','2013-05-15','11:00:00',2.98),('8348','2013-05-15','11:05:00',3.15),('8348','2013-05-15','11:10:00',3.21),('8348','2013-05-15','11:15:00',3.26),('8348','2013-05-15','11:20:00',3.13),('8348','2013-05-15','11:25:00',3.28),('8348','2013-05-15','11:30:00',3.23),('8348','2013-05-15','11:35:00',3.08),('8348','2013-05-15','11:40:00',2.7),('8348','2013-05-15','11:45:00',2.55),('8348','2013-05-15','11:50:00',2.2),('8348','2013-05-15','11:55:00',1.66),('8348','2013-05-15','12:00:00',1.88),('8348','2013-05-15','12:05:00',2.7),('8348','2013-05-15','12:10:00',3.9),('8348','2013-05-15','12:15:00',4),('8348','2013-05-15','12:20:00',3),('8348','2013-05-15','12:25:00',3.44),('8348','2013-05-15','12:30:00',2.52),('8348','2013-05-15','12:35:00',2.81),('8348','2013-05-15','12:40:00',4.12),('8348','2013-05-15','12:45:00',2.27),('8348','2013-05-15','12:50:00',2.25),('8348','2013-05-15','12:55:00',2.46),('8348','2013-05-15','13:00:00',2.49),('8348','2013-05-15','13:05:00',3.19),('8348','2013-05-15','13:10:00',2.64),('8348','2013-05-15','13:15:00',2.29),('8348','2013-05-15','13:20:00',2.5),('8348','2013-05-15','13:25:00',2.49),('8348','2013-05-15','13:30:00',2.49),('8348','2013-05-15','13:35:00',2.2),('8348','2013-05-15','13:40:00',2.4),('8348','2013-05-15','13:45:00',2.31),('8348','2013-05-15','13:50:00',1.94),('8348','2013-05-15','13:55:00',1.96),('8348','2013-05-15','14:00:00',1.73),('8348','2013-05-15','14:05:00',1.54),('8348','2013-05-15','14:10:00',1.6),('8348','2013-05-15','14:15:00',1.58),('8348','2013-05-15','14:20:00',1.64),('8348','2013-05-15','14:25:00',1.55),('8348','2013-05-15','14:30:00',1.36),('8348','2013-05-15','14:35:00',1.33),('8348','2013-05-15','14:40:00',1.48),('8348','2013-05-15','14:45:00',1.35),('8348','2013-05-15','14:50:00',1.34),('8348','2013-05-15','14:55:00',1.34),('8348','2013-05-15','15:00:00',1.34),('8348','2013-05-15','15:05:00',1.04),('8348','2013-05-15','15:50:00',1.37),('8348','2013-05-15','15:55:00',1.81),('8348','2013-05-15','16:00:00',1.77),('8348','2013-05-15','16:05:00',1.67),('8348','2013-05-15','16:10:00',1.52),('8348','2013-05-15','16:15:00',1.36),('8348','2013-05-15','16:20:00',1.47),('8348','2013-05-15','16:25:00',1.5),('8348','2013-05-15','16:30:00',1.32),('8348','2013-05-15','16:35:00',1.23),('8348','2013-05-15','16:40:00',1.15),('8348','2013-05-15','16:45:00',1.09),('8348','2013-05-15','16:50:00',1.11),('8348','2013-05-15','16:55:00',1.29),('8348','2013-05-15','17:00:00',1.58),('8348','2013-05-15','17:05:00',1.87),('8348','2013-05-15','17:10:00',2.49),('8348','2013-05-15','17:15:00',2.76),('8348','2013-05-15','17:20:00',1.5),('8348','2013-05-14','07:55:00',1),('8348','2013-05-14','08:00:00',1.08),('8348','2013-05-14','08:05:00',1.13),('8348','2013-05-14','08:10:00',1.18),('8348','2013-05-14','08:15:00',1.32),('8348','2013-05-14','08:20:00',1.39),('8348','2013-05-14','08:25:00',1.51),('8348','2013-05-14','08:30:00',1.61),('8348','2013-05-14','08:35:00',1.7),('8348','2013-05-14','08:40:00',1.78),('8348','2013-05-14','08:45:00',1.85),('8348','2013-05-14','08:50:00',1.92),('8348','2013-05-14','08:55:00',1.99),('8348','2013-05-14','09:00:00',2.07),('8348','2013-05-14','09:05:00',2.14),('8348','2013-05-14','09:10:00',2.21),('8348','2013-05-14','09:15:00',2.27),('8348','2013-05-14','09:20:00',2.33),('8348','2013-05-14','09:25:00',2.39),('8348','2013-05-14','09:30:00',2.45),('8348','2013-05-14','09:35:00',2.51),('8348','2013-05-14','09:40:00',2.56),('8348','2013-05-14','09:45:00',2.61),('8348','2013-05-14','09:50:00',2.66),('8348','2013-05-14','09:55:00',2.74),('8348','2013-05-14','10:00:00',2.8),('8348','2013-05-14','10:05:00',2.86),('8348','2013-05-14','10:10:00',2.9),('8348','2013-05-14','10:15:00',2.97),('8348','2013-05-14','10:20:00',3),('8348','2013-05-14','10:25:00',3.01),('8348','2013-05-14','10:30:00',3.08),('8348','2013-05-14','10:35:00',3.12),('8348','2013-05-14','10:40:00',3.18),('8348','2013-05-14','10:45:00',3.22),('8348','2013-05-14','10:50:00',3.25),('8348','2013-05-14','10:55:00',3.28),('8348','2013-05-14','11:00:00',3.29),('8348','2013-05-14','11:05:00',3.34),('8348','2013-05-14','11:10:00',3.38),('8348','2013-05-14','11:15:00',3.4),('8348','2013-05-14','11:20:00',3.42),('8348','2013-05-14','11:25:00',3.43),('8348','2013-05-14','11:30:00',3.45),('8348','2013-05-14','11:35:00',3.47),('8348','2013-05-14','11:40:00',3.5),('8348','2013-05-14','11:45:00',3.51),('8348','2013-05-14','11:50:00',3.54),('8348','2013-05-14','11:55:00',3.56),('8348','2013-05-14','12:00:00',3.58),('8348','2013-05-14','12:05:00',3.58),('8348','2013-05-14','12:10:00',3.6),('8348','2013-05-14','12:15:00',3.66),('8348','2013-05-14','12:20:00',3.7),('8348','2013-05-14','12:25:00',3.7),('8348','2013-05-14','12:30:00',3.71),('8348','2013-05-14','12:35:00',3.74),('8348','2013-05-14','12:40:00',3.76),('8348','2013-05-14','12:45:00',3.74),('8348','2013-05-14','12:50:00',3.76),('8348','2013-05-14','12:55:00',3.78),('8348','2013-05-14','13:00:00',3.77),('8348','2013-05-14','13:05:00',3.74),('8348','2013-05-14','13:10:00',3.79),('8348','2013-05-14','13:15:00',3.76),('8348','2013-05-14','13:20:00',3.75),('8348','2013-05-14','13:25:00',3.74),('8348','2013-05-14','13:30:00',3.73),('8348','2013-05-14','13:35:00',3.73),('8348','2013-05-14','13:40:00',3.73),('8348','2013-05-14','13:45:00',3.75),('8348','2013-05-14','13:50:00',3.75),('8348','2013-05-14','13:55:00',3.72),('8348','2013-05-14','14:00:00',3.7),('8348','2013-05-14','14:05:00',3.68),('8348','2013-05-14','14:10:00',3.64),('8348','2013-05-14','14:15:00',3.63),('8348','2013-05-14','14:20:00',3.64),('8348','2013-05-14','14:25:00',3.62),('8348','2013-05-14','14:30:00',3.6),('8348','2013-05-14','14:35:00',3.63),('8348','2013-05-14','14:40:00',3.7),('8348','2013-05-14','14:45:00',3.75),('8348','2013-05-14','14:50:00',3.77),('8348','2013-05-14','14:55:00',3.78),('8348','2013-05-14','15:00:00',3.77),('8348','2013-05-14','15:05:00',3.76),('8348','2013-05-14','15:10:00',3.74),('8348','2013-05-14','15:15:00',3.7),('8348','2013-05-14','15:20:00',3.67),('8348','2013-05-14','15:25:00',3.62),('8348','2013-05-14','15:30:00',3.6),('8348','2013-05-14','15:35:00',3.55),('8348','2013-05-14','15:40:00',3.51),('8348','2013-05-14','15:45:00',3.47),('8348','2013-05-14','15:50:00',3.44),('8348','2013-05-14','15:55:00',3.38),('8348','2013-05-14','16:00:00',3.34),('8348','2013-05-14','16:05:00',3.28),('8348','2013-05-14','16:10:00',3.24),('8348','2013-05-14','16:15:00',3.19),('8348','2013-05-14','16:20:00',3.13),('8348','2013-05-14','16:25:00',3.09),('8348','2013-05-14','16:30:00',3.02),('8348','2013-05-14','16:35:00',2.97),('8348','2013-05-14','16:40:00',2.91),('8348','2013-05-14','16:45:00',2.85),('8348','2013-05-14','16:50:00',2.8),('8348','2013-05-14','16:55:00',2.73),('8348','2013-05-14','17:00:00',2.66),('8348','2013-05-14','17:05:00',2.59),('8348','2013-05-14','17:10:00',2.52),('8348','2013-05-14','17:15:00',2.45),('8348','2013-05-14','17:20:00',2.38),('8348','2013-05-14','17:25:00',2.31),('8348','2013-05-14','17:30:00',2.24),('8348','2013-05-14','17:35:00',2.16),('8348','2013-05-14','17:40:00',2.09),('8348','2013-05-14','17:45:00',2.01),('8348','2013-05-14','17:50:00',1.93),('8348','2013-05-14','17:55:00',1.85),('8348','2013-05-14','18:00:00',1.77),('8348','2013-05-14','18:05:00',1.69),('8348','2013-05-14','18:10:00',1.61),('8348','2013-05-14','18:15:00',1.53),('8348','2013-05-14','18:20:00',1.45),('8348','2013-05-14','18:25:00',1.36),('8348','2013-05-14','18:30:00',1.29),('8348','2013-05-14','18:35:00',1.21),('8348','2013-05-14','18:40:00',1.13),('8348','2013-05-14','18:45:00',1.04),('8348','2013-05-13','08:00:00',1.03),('8348','2013-05-13','08:05:00',1.09),('8348','2013-05-13','08:10:00',1.16),('8348','2013-05-13','08:15:00',1.26),('8348','2013-05-13','08:20:00',1.34),('8348','2013-05-13','08:25:00',1.42),('8348','2013-05-13','08:30:00',1.49),('8348','2013-05-13','08:35:00',1.59),('8348','2013-05-13','08:40:00',1.66),('8348','2013-05-13','08:45:00',1.73),('8348','2013-05-13','08:50:00',1.78),('8348','2013-05-13','08:55:00',1.87),('8348','2013-05-13','09:00:00',1.93),('8348','2013-05-13','09:05:00',2),('8348','2013-05-13','09:10:00',2.07),('8348','2013-05-13','09:15:00',2.12),('8348','2013-05-13','09:20:00',2.18),('8348','2013-05-13','09:25:00',2.24),('8348','2013-05-13','09:30:00',2.34),('8348','2013-05-13','09:35:00',2.39),('8348','2013-05-13','09:40:00',2.51),('8348','2013-05-13','09:45:00',2.55),('8348','2013-05-13','09:50:00',2.54),('8348','2013-05-13','09:55:00',2.01),('8348','2013-05-13','10:00:00',2.91),('8348','2013-05-13','10:05:00',2.92),('8348','2013-05-13','10:10:00',2.81),('8348','2013-05-13','10:15:00',2.87),('8348','2013-05-13','10:20:00',3.09),('8348','2013-05-13','10:25:00',2.89),('8348','2013-05-13','10:30:00',2.5),('8348','2013-05-13','10:40:00',1.18),('8348','2013-05-13','10:45:00',1.05),('8348','2013-05-13','10:50:00',3.19),('8348','2013-05-13','10:55:00',2.42),('8348','2013-05-13','11:00:00',2.69),('8348','2013-05-13','11:05:00',2.92),('8348','2013-05-13','11:10:00',2.64),('8348','2013-05-13','11:15:00',1.45),('8348','2013-05-13','11:20:00',1.36),('8348','2013-05-13','11:25:00',1.57),('8348','2013-05-13','11:30:00',1.53),('8348','2013-05-13','11:35:00',2.3),('8348','2013-05-13','11:40:00',3.04),('8348','2013-05-13','11:45:00',2.69),('8348','2013-05-13','11:50:00',1.87),('8348','2013-05-13','11:55:00',1.72),('8348','2013-05-13','12:00:00',1.66),('8348','2013-05-13','12:05:00',1.63),('8348','2013-05-13','12:10:00',3.68),('8348','2013-05-13','12:15:00',1.52),('8348','2013-05-13','12:20:00',1.08),('8348','2013-05-13','12:25:00',1.08),('8348','2013-05-13','12:30:00',2.02),('8348','2013-05-13','12:35:00',4.54),('8348','2013-05-13','12:40:00',4.22),('8348','2013-05-13','12:45:00',2.81),('8348','2013-05-13','12:50:00',2.93),('8348','2013-05-13','12:55:00',3.3),('8348','2013-05-13','13:00:00',3.82),('8348','2013-05-13','13:05:00',4.01),('8348','2013-05-13','13:10:00',3.56),('8348','2013-05-13','13:15:00',3.55),('8348','2013-05-13','13:20:00',4.21),('8348','2013-05-13','13:25:00',4.11),('8348','2013-05-13','13:30:00',3.98),('8348','2013-05-13','13:35:00',4.25),('8348','2013-05-13','13:40:00',3.83),('8348','2013-05-13','13:45:00',3.23),('8348','2013-05-13','13:50:00',1.21),('8348','2013-05-13','13:55:00',1.76),('8348','2013-05-13','14:00:00',1.11),('8348','2013-05-13','14:05:00',4.2),('8348','2013-05-13','14:10:00',4.33),('8348','2013-05-13','14:15:00',4.19),('8348','2013-05-13','14:20:00',3.79),('8348','2013-05-13','14:25:00',3.75),('8348','2013-05-13','14:30:00',3.76),('8348','2013-05-13','14:35:00',3.71),('8348','2013-05-13','14:40:00',3.91),('8348','2013-05-13','14:45:00',3.22),('8348','2013-05-13','14:50:00',3.99),('8348','2013-05-13','14:55:00',3.99),('8348','2013-05-13','15:00:00',2.12),('8348','2013-05-13','15:05:00',2.33),('8348','2013-05-13','15:10:00',1.24),('8348','2013-05-13','15:20:00',1.08),('8348','2013-05-13','15:40:00',1.49),('8348','2013-05-13','16:00:00',1.04),('8348','2013-05-13','16:05:00',1.8),('8348','2013-05-13','16:10:00',1.85),('8348','2013-05-13','16:15:00',1.17),('8348','2013-05-13','16:20:00',1.23),('8348','2013-05-13','16:25:00',1.27),('8348','2013-05-13','16:30:00',2.11),('8348','2013-05-13','16:35:00',1.27),('8348','2013-05-13','16:40:00',1.5),('8348','2013-05-13','16:45:00',2.23),('8348','2013-05-13','16:50:00',3.14),('8348','2013-05-13','16:55:00',2.98),('8348','2013-05-13','17:00:00',2.88),('8348','2013-05-13','17:05:00',2.71),('8348','2013-05-13','17:10:00',1.37),('8348','2013-05-13','17:15:00',2.84),('8348','2013-05-13','17:20:00',3.14),('8348','2013-05-13','17:25:00',2.97),('8348','2013-05-13','17:30:00',2.81),('8348','2013-05-13','17:35:00',2.63),('8348','2013-05-13','17:40:00',2.44),('8348','2013-05-13','17:45:00',2.37),('8348','2013-05-13','17:50:00',1.87),('8348','2013-05-13','17:55:00',1.64),('8348','2013-05-13','18:00:00',1.27),('8348','2013-05-13','18:10:00',1.34),('8348','2013-05-13','18:15:00',1.15),('8348','2013-05-12','08:15:00',1.22),('8348','2013-05-12','08:20:00',1.35),('8348','2013-05-12','08:25:00',1.66),('8348','2013-05-12','08:30:00',1.21),('8348','2013-05-12','08:40:00',1.35),('8348','2013-05-12','08:45:00',1.6),('8348','2013-05-12','08:50:00',1.25),('8348','2013-05-12','08:55:00',1.16),('8348','2013-05-12','09:00:00',1.1),('8348','2013-05-12','09:05:00',1.32),('8348','2013-05-12','09:15:00',1.22),('8348','2013-05-12','09:20:00',1.23),('8348','2013-05-12','09:25:00',1.1),('8348','2013-05-12','09:30:00',1.1),('8348','2013-05-12','09:35:00',1.15),('8348','2013-05-12','09:40:00',1.16),('8348','2013-05-12','09:45:00',2.41),('8348','2013-05-12','09:50:00',3.09),('8348','2013-05-12','09:55:00',2.61),('8348','2013-05-12','10:00:00',3.06),('8348','2013-05-12','10:05:00',2.63),('8348','2013-05-12','10:10:00',2.35),('8348','2013-05-12','10:25:00',2.49),('8348','2013-05-12','10:30:00',2.71),('8348','2013-05-12','10:35:00',1.06),('8348','2013-05-12','10:40:00',1.99),('8348','2013-05-12','10:45:00',1.78),('8348','2013-05-12','10:50:00',2.61),('8348','2013-05-12','10:55:00',3.41),('8348','2013-05-12','11:00:00',3.73),('8348','2013-05-12','11:05:00',3.66),('8348','2013-05-12','11:10:00',3.73),('8348','2013-05-12','11:15:00',3.75),('8348','2013-05-12','11:20:00',3.8),('8348','2013-05-12','11:25:00',3.9),('8348','2013-05-12','11:30:00',3.98),('8348','2013-05-12','11:35:00',3.43),('8348','2013-05-12','11:40:00',2.83),('8348','2013-05-12','11:45:00',2.88),('8348','2013-05-12','11:50:00',1.98),('8348','2013-05-12','11:55:00',1.44),('8348','2013-05-12','12:00:00',2.16),('8348','2013-05-12','12:05:00',4.08),('8348','2013-05-12','12:10:00',2.72),('8348','2013-05-12','12:15:00',1.2),('8348','2013-05-12','12:20:00',1.02),('8348','2013-05-12','12:25:00',1.07),('8348','2013-05-12','12:30:00',3.17),('8348','2013-05-12','12:35:00',3.57),('8348','2013-05-12','12:40:00',3.83),('8348','2013-05-12','12:45:00',3.9),('8348','2013-05-12','12:50:00',4.06),('8348','2013-05-12','12:55:00',3.98),('8348','2013-05-12','13:00:00',1.48),('8348','2013-05-12','13:05:00',1.41),('8348','2013-05-12','13:10:00',4.37),('8348','2013-05-12','13:15:00',2.08),('8348','2013-05-12','13:20:00',3.59),('8348','2013-05-12','13:25:00',3.28),('8348','2013-05-12','13:30:00',4.19),('8348','2013-05-12','13:35:00',3.93),('8348','2013-05-12','13:40:00',3.66),('8348','2013-05-12','13:45:00',4.48),('8348','2013-05-12','13:50:00',3.38),('8348','2013-05-12','13:55:00',2.62),('8348','2013-05-12','14:00:00',3.08),('8348','2013-05-12','14:05:00',3.34),('8348','2013-05-12','14:10:00',4.12),('8348','2013-05-12','14:15:00',4.35),('8348','2013-05-12','14:20:00',3.17),('8348','2013-05-12','14:25:00',3.69),('8348','2013-05-12','14:30:00',4.16),('8348','2013-05-12','14:35:00',4.15),('8348','2013-05-12','14:40:00',4.06),('8348','2013-05-12','14:45:00',3.82),('8348','2013-05-12','14:50:00',3.97),('8348','2013-05-12','14:55:00',3.89),('8348','2013-05-12','15:00:00',3.46),('8348','2013-05-12','15:05:00',3.97),('8348','2013-05-12','15:10:00',3.11),('8348','2013-05-12','15:15:00',3.54),('8348','2013-05-12','15:20:00',2.48),('8348','2013-05-12','15:25:00',3.81),('8348','2013-05-12','15:30:00',3.65),('8348','2013-05-12','15:35:00',3.58),('8348','2013-05-12','15:40:00',3.55),('8348','2013-05-12','15:45:00',3.49),('8348','2013-05-12','15:50:00',3.43),('8348','2013-05-12','15:55:00',3.34),('8348','2013-05-12','16:00:00',3.23),('8348','2013-05-12','16:05:00',3.14),('8348','2013-05-12','16:10:00',3.19),('8348','2013-05-12','16:15:00',3.16),('8348','2013-05-12','16:20:00',3.11),('8348','2013-05-12','16:25:00',3.04),('8348','2013-05-12','16:30:00',2.99),('8348','2013-05-12','16:35:00',2.99),('8348','2013-05-12','16:40:00',3.09),('8348','2013-05-12','16:45:00',3.25),('8348','2013-05-12','16:50:00',2.74),('8348','2013-05-12','16:55:00',3.28),('8348','2013-05-12','17:00:00',2.81),('8348','2013-05-12','17:05:00',2.85),('8348','2013-05-12','17:10:00',3.26),('8348','2013-05-12','17:15:00',3.1),('8348','2013-05-12','17:20:00',2.92),('8348','2013-05-12','17:25:00',2.38),('8348','2013-05-12','17:30:00',2.36),('8348','2013-05-12','17:35:00',2.32),('8348','2013-05-12','17:40:00',1.62),('8348','2013-05-12','17:45:00',1.59),('8348','2013-05-12','17:50:00',1.16),('8348','2013-05-12','18:00:00',1.72),('8348','2013-05-12','18:05:00',1.83),('8348','2013-05-12','18:10:00',2.03),('8348','2013-05-12','18:15:00',1.33),('8348','2013-05-12','18:20:00',1.02),('8348','2013-05-12','18:25:00',1.49),('8348','2013-05-12','18:30:00',1.35),('8348','2013-05-12','18:35:00',1.4),('8348','2014-03-31','07:15:00',1.07),('8348','2014-03-31','07:20:00',1.15),('8348','2014-03-31','07:25:00',1.24),('8348','2014-03-31','07:30:00',1.32),('8348','2014-03-31','07:35:00',1.41),('8348','2014-03-31','07:40:00',1.66),('8348','2014-03-31','07:45:00',1.78),('8348','2014-03-31','07:50:00',1.9),('8348','2014-03-31','07:55:00',2),('8348','2014-03-31','08:00:00',2.11),('8348','2014-03-31','08:05:00',2.24),('8348','2014-03-31','08:10:00',2.35),('8348','2014-03-31','08:15:00',2.47),('8348','2014-03-31','08:20:00',2.63),('8348','2014-03-31','08:25:00',3.01),('8348','2014-03-31','08:30:00',3.3),('8348','2014-03-31','08:35:00',3.45),('8348','2014-03-31','08:40:00',3.6),('8348','2014-03-31','08:45:00',3.75),('8348','2014-03-31','08:50:00',3.89),('8348','2014-03-31','08:55:00',4.05),('8348','2014-03-31','09:00:00',4.15),('8348','2014-03-31','09:05:00',4.28),('8348','2014-03-31','09:10:00',4.42),('8348','2014-03-31','09:15:00',4.5),('8348','2014-03-31','09:20:00',4.58),('8348','2014-03-31','09:25:00',4.69),('8348','2014-03-31','09:30:00',4.86),('8348','2014-03-31','09:35:00',4.91),('8348','2014-03-31','09:40:00',5.05),('8348','2014-03-31','09:45:00',5.16),('8348','2014-03-31','09:50:00',5.26),('8348','2014-03-31','09:55:00',5.36),('8348','2014-03-31','10:00:00',5.42),('8348','2014-03-31','10:05:00',5.48),('8348','2014-03-31','10:10:00',5.62),('8348','2014-03-31','10:15:00',5.69),('8348','2014-03-31','10:20:00',5.74),('8348','2014-03-31','10:25:00',5.85),('8348','2014-03-31','10:30:00',5.91),('8348','2014-03-31','10:35:00',5.96),('8348','2014-03-31','10:40:00',5.95),('8348','2014-03-31','10:45:00',6.05),('8348','2014-03-31','10:50:00',6.23),('8348','2014-03-31','10:55:00',6.36),('8348','2014-03-31','11:00:00',6.38),('8348','2014-03-31','11:05:00',6.34),('8348','2014-03-31','11:10:00',6.34),('8348','2014-03-31','11:15:00',6.44),('8348','2014-03-31','11:20:00',6.52),('8348','2014-03-31','11:25:00',6.57),('8348','2014-03-31','11:30:00',6.62),('8348','2014-03-31','11:35:00',6.67),('8348','2014-03-31','11:40:00',6.72),('8348','2014-03-31','11:45:00',6.61),('8348','2014-03-31','11:50:00',6.61),('8348','2014-03-31','11:55:00',6.65),('8348','2014-03-31','12:00:00',6.78),('8348','2014-03-31','12:05:00',6.83),('8348','2014-03-31','12:10:00',6.88),('8348','2014-03-31','12:15:00',6.87),('8348','2014-03-31','12:20:00',6.87),('8348','2014-03-31','12:25:00',6.85),('8348','2014-03-31','12:30:00',6.91),('8348','2014-03-31','12:35:00',6.96),('8348','2014-03-31','12:40:00',6.99),('8348','2014-03-31','12:45:00',7),('8348','2014-03-31','12:50:00',7.02),('8348','2014-03-31','12:55:00',6.98),('8348','2014-03-31','13:00:00',6.95),('8348','2014-03-31','13:05:00',6.94),('8348','2014-03-31','13:10:00',6.88),('8348','2014-03-31','13:15:00',6.9),('8348','2014-03-31','13:20:00',6.89),('8348','2014-03-31','13:25:00',6.87),('8348','2014-03-31','13:30:00',6.84),('8348','2014-03-31','13:35:00',6.8),('8348','2014-03-31','13:40:00',6.78),('8348','2014-03-31','13:45:00',6.77),('8348','2014-03-31','13:50:00',6.7),('8348','2014-03-31','13:55:00',6.67),('8348','2014-03-31','14:00:00',6.61),('8348','2014-03-31','14:05:00',6.53),('8348','2014-03-31','14:10:00',6.48),('8348','2014-03-31','14:15:00',6.45),('8348','2014-03-31','14:20:00',6.38),('8348','2014-03-31','14:25:00',6.3),('8348','2014-03-31','14:30:00',6.19),('8348','2014-03-31','14:35:00',6.09),('8348','2014-03-31','14:40:00',6.04),('8348','2014-03-31','14:45:00',5.98),('8348','2014-03-31','14:50:00',5.83),('8348','2014-03-31','14:55:00',5.73),('8348','2014-03-31','15:00:00',5.6),('8348','2014-03-31','15:05:00',5.48),('8348','2014-03-31','15:10:00',5.37),('8348','2014-03-31','15:15:00',5.27),('8348','2014-03-31','15:20:00',5.13),('8348','2014-03-31','15:25:00',5.01),('8348','2014-03-31','15:30:00',4.88),('8348','2014-03-31','15:35:00',4.78),('8348','2014-03-31','15:40:00',4.62),('8348','2014-03-31','15:45:00',4.49),('8348','2014-03-31','15:50:00',4.36),('8348','2014-03-31','15:55:00',4.23),('8348','2014-03-31','16:00:00',4.09),('8348','2014-03-31','16:05:00',3.95),('8348','2014-03-31','16:10:00',3.8),('8348','2014-03-31','16:15:00',3.64),('8348','2014-03-31','16:20:00',3.43),('8348','2014-03-31','16:25:00',3.28),('8348','2014-03-31','16:30:00',3.13),('8348','2014-03-31','16:35:00',3.01),('8348','2014-03-31','16:40:00',2.85),('8348','2014-03-31','16:45:00',2.71),('8348','2014-03-31','16:50:00',2.53),('8348','2014-03-31','16:55:00',2.35),('8348','2014-03-31','17:00:00',2.18),('8348','2014-03-31','17:05:00',2.02),('8348','2014-03-31','17:10:00',1.86),('8348','2014-03-31','17:15:00',1.74),('8348','2014-03-31','17:20:00',1.57),('8348','2014-03-31','17:25:00',1.39),('8348','2014-03-31','17:30:00',1.24),('8348','2014-03-31','17:35:00',1.16),('8348','2014-03-31','17:40:00',1.1),('8348','2013-05-11','07:50:00',1),('8348','2013-05-11','07:55:00',1.14),('8348','2013-05-11','08:00:00',1.08),('8348','2013-05-11','08:05:00',1.12),('8348','2013-05-11','08:15:00',1.26),('8348','2013-05-11','08:20:00',1.08),('8348','2013-05-11','09:05:00',1.19),('8348','2013-05-11','09:10:00',1.34),('8348','2013-05-11','09:15:00',1.23),('8348','2013-05-11','09:20:00',1.74),('8348','2013-05-11','09:25:00',1.36),('8348','2013-05-11','09:30:00',2.22),('8348','2013-05-11','09:35:00',2.06),('8348','2013-05-11','09:40:00',1.21),('8348','2013-05-11','09:45:00',1.79),('8348','2013-05-11','09:50:00',1.7),('8348','2013-05-11','09:55:00',2.79),('8348','2013-05-11','10:00:00',1.89),('8348','2013-05-11','10:05:00',1.2),('8348','2013-05-11','10:20:00',1.08),('8348','2013-05-11','10:25:00',1),('8348','2013-05-11','10:30:00',1.16),('8348','2013-05-11','10:35:00',1.13),('8348','2013-05-11','10:50:00',1.22),('8348','2013-05-11','10:55:00',2.74),('8348','2013-05-11','11:00:00',3.86),('8348','2013-05-11','11:05:00',1.75),('8348','2013-05-11','11:10:00',1.17),('8348','2013-05-11','11:30:00',1.61),('8348','2013-05-11','11:35:00',3.01),('8348','2013-05-11','11:40:00',1.77),('8348','2013-05-11','11:45:00',4.16),('8348','2013-05-11','11:50:00',1.82),('8348','2013-05-11','12:00:00',1.45),('8348','2013-05-11','12:05:00',1.82),('8348','2013-05-11','12:10:00',1.39),('8348','2013-05-11','12:15:00',1.31),('8348','2013-05-11','12:20:00',2.48),('8348','2013-05-11','12:25:00',4.49),('8348','2013-05-11','12:30:00',2.47),('8348','2013-05-11','12:35:00',2.03),('8348','2013-05-11','12:40:00',1.86),('8348','2013-05-11','12:45:00',1.59),('8348','2013-05-11','12:50:00',1.58),('8348','2013-05-11','12:55:00',1.45),('8348','2013-05-11','13:00:00',1.61),('8348','2013-05-11','13:05:00',1.34),('8348','2013-05-11','13:10:00',1.01),('8348','2013-05-11','13:30:00',1.01),('8348','2013-05-11','13:35:00',1.17),('8348','2013-05-11','14:00:00',2.35),('8348','2013-05-11','14:05:00',3.42),('8348','2013-05-11','14:10:00',2.37),('8348','2013-05-11','14:15:00',3.11),('8348','2013-05-11','14:20:00',3.73),('8348','2013-05-11','14:25:00',3.47),('8348','2013-05-11','14:30:00',1.89),('8348','2013-05-11','14:35:00',2.81),('8348','2013-05-11','14:40:00',2.65),('8348','2013-05-11','14:45:00',4.39),('8348','2013-05-11','14:50:00',4.26),('8348','2013-05-11','14:55:00',4.08),('8348','2013-05-11','15:00:00',3.66),('8348','2013-05-11','15:05:00',3.92),('8348','2013-05-11','15:10:00',4),('8348','2013-05-11','15:15:00',3.88),('8348','2013-05-11','15:20:00',3.84),('8348','2013-05-11','15:25:00',3.46),('8348','2013-05-11','15:30:00',3.75),('8348','2013-05-11','15:35:00',3.31),('8348','2013-05-11','15:40:00',3.71),('8348','2013-05-11','15:45:00',3.39),('8348','2013-05-11','15:50:00',3.22),('8348','2013-05-11','15:55:00',3.57),('8348','2013-05-11','16:00:00',3.54),('8348','2013-05-11','16:05:00',3.34),('8348','2013-05-11','16:10:00',3.47),('8348','2013-05-11','16:15:00',2.86),('8348','2013-05-11','16:20:00',3.34),('8348','2013-05-11','16:25:00',3.2),('8348','2013-05-11','16:30:00',2.87),('8348','2013-05-11','16:35:00',2.46),('8348','2013-05-11','16:40:00',3.02),('8348','2013-05-11','16:45:00',2.91),('8348','2013-05-11','16:50:00',2.32),('8348','2013-05-11','16:55:00',2.89),('8348','2013-05-11','17:00:00',2.82),('8348','2013-05-11','17:05:00',2.18),('8348','2013-05-11','17:10:00',2.62),('8348','2013-05-11','17:15:00',1.68),('8348','2013-05-11','17:20:00',2.48),('8348','2013-05-11','17:25:00',2.47),('8348','2013-05-11','17:30:00',1.9),('8348','2013-05-11','17:35:00',2.26),('8348','2013-05-11','17:40:00',1.93),('8348','2013-05-11','17:45:00',2.19),('8348','2013-05-11','17:50:00',1.27),('8348','2013-05-11','17:55:00',1.68),('8348','2013-05-11','18:05:00',1.58),('8348','2013-05-11','18:10:00',1.76),('8348','2013-05-11','18:15:00',1.19),('8348','2013-05-11','18:20:00',1.14),('8348','2013-05-11','18:25:00',1.34),('8348','2013-05-11','18:30:00',1.14),('8348','2013-05-11','18:35:00',1.11),('8348','2013-05-11','18:40:00',1.05),('8348','2013-05-11','18:55:00',1.06),('8348','2013-05-10','07:55:00',1.04),('8348','2013-05-10','08:00:00',1.31),('8348','2013-05-10','08:05:00',1.58),('8348','2013-05-10','08:10:00',1.67),('8348','2013-05-10','08:15:00',1.69),('8348','2013-05-10','08:20:00',1.55),('8348','2013-05-10','08:25:00',1.46),('8348','2013-05-10','08:30:00',1.51),('8348','2013-05-10','08:35:00',1.53),('8348','2013-05-10','09:00:00',1.32),('8348','2013-05-10','09:05:00',1.95),('8348','2013-05-10','09:10:00',2.14),('8348','2013-05-10','09:15:00',2.24),('8348','2013-05-10','09:20:00',2.12),('8348','2013-05-10','09:25:00',1.94),('8348','2013-05-10','09:30:00',1.99),('8348','2013-05-10','09:35:00',2.48),('8348','2013-05-10','09:40:00',2.1),('8348','2013-05-10','09:45:00',2.39),('8348','2013-05-10','09:50:00',1.96),('8348','2013-05-10','09:55:00',2.09),('8348','2013-05-10','10:00:00',1.24),('8348','2013-05-10','10:05:00',1.27),('8348','2013-05-10','10:10:00',1.1),('8348','2013-05-10','10:20:00',2.08),('8348','2013-05-10','10:25:00',2.08),('8348','2013-05-10','10:30:00',2.81),('8348','2013-05-10','10:35:00',3.09),('8348','2013-05-10','10:40:00',3.25),('8348','2013-05-10','10:45:00',3.41),('8348','2013-05-10','10:50:00',3.47),('8348','2013-05-10','10:55:00',3.46),('8348','2013-05-10','11:00:00',3.35),('8348','2013-05-10','11:05:00',3.41),('8348','2013-05-10','11:10:00',3.4),('8348','2013-05-10','11:15:00',3.28),('8348','2013-05-10','11:20:00',3.76),('8348','2013-05-10','11:25:00',3.07),('8348','2013-05-10','11:30:00',3.41),('8348','2013-05-10','11:35:00',2.91),('8348','2013-05-10','11:40:00',1.64),('8348','2013-05-10','11:45:00',3.41),('8348','2013-05-10','11:50:00',3.1),('8348','2013-05-10','11:55:00',4.14),('8348','2013-05-10','12:00:00',2.5),('8348','2013-05-10','12:05:00',1.85),('8348','2013-05-10','12:10:00',1.78),('8348','2013-05-10','12:15:00',2.2),('8348','2013-05-10','12:20:00',2.47),('8348','2013-05-10','12:25:00',2.04),('8348','2013-05-10','12:30:00',2.23),('8348','2013-05-10','12:35:00',2.08),('8348','2013-05-10','12:40:00',3.19),('8348','2013-05-10','12:45:00',4.15),('8348','2013-05-10','12:50:00',3.42),('8348','2013-05-10','12:55:00',2.43),('8348','2013-05-10','13:00:00',3.88),('8348','2013-05-10','13:05:00',3.55),('8348','2013-05-10','13:10:00',4.63),('8348','2013-05-10','13:15:00',4.26),('8348','2013-05-10','13:20:00',2.87),('8348','2013-05-10','13:25:00',2.77),('8348','2013-05-10','13:30:00',3.14),('8348','2013-05-10','13:35:00',3.66),('8348','2013-05-10','13:40:00',4.01),('8348','2013-05-10','13:45:00',3.56),('8348','2013-05-10','13:50:00',2.18),('8348','2013-05-10','13:55:00',1.99),('8348','2013-05-10','14:00:00',1.83),('8348','2013-05-10','14:05:00',1.94),('8348','2013-05-10','14:10:00',2.31),('8348','2013-05-10','14:15:00',2.44),('8348','2013-05-10','14:20:00',2.4),('8348','2013-05-10','14:25:00',2.39),('8348','2013-05-10','14:30:00',2.47),('8348','2013-05-10','14:35:00',3.05),('8348','2013-05-10','14:40:00',2.5),('8348','2013-05-10','14:45:00',1.81),('8348','2013-05-10','14:50:00',1.39),('8348','2013-05-10','14:55:00',1.22),('8348','2013-05-10','15:00:00',1.18),('8348','2013-05-10','15:05:00',1.35),('8348','2013-05-10','15:10:00',1.94),('8348','2013-05-10','15:15:00',3.3),('8348','2013-05-10','15:20:00',2.47),('8348','2013-05-10','15:25:00',1.88),('8348','2013-05-10','15:30:00',1.83),('8348','2013-05-10','15:35:00',1.87),('8348','2013-05-10','15:40:00',1.94),('8348','2013-05-10','15:45:00',1.83),('8348','2013-05-10','15:50:00',1.68),('8348','2013-05-10','15:55:00',1.58),('8348','2013-05-10','16:00:00',1.54),('8348','2013-05-10','16:05:00',1.51),('8348','2013-05-10','16:10:00',1.48),('8348','2013-05-10','16:15:00',1.35),('8348','2013-05-10','16:20:00',1.23),('8348','2013-05-10','16:25:00',1.26),('8348','2013-05-10','16:30:00',1.34),('8348','2013-05-10','16:35:00',1.42),('8348','2013-05-10','16:40:00',1.33),('8348','2013-05-10','16:45:00',1.38),('8348','2013-05-10','16:50:00',1.29),('8348','2013-05-10','16:55:00',1.07),('8348','2013-05-10','17:10:00',1.28),('8348','2013-05-10','17:15:00',1.61),('8348','2013-05-10','17:20:00',2.15),('8348','2013-05-10','17:25:00',1.91),('8348','2013-05-10','17:30:00',1.84),('8348','2013-05-10','17:35:00',2.31),('8348','2013-05-10','17:40:00',1.34),('8348','2013-05-10','17:45:00',1.27),('8348','2013-05-10','17:50:00',1.05),('8348','2013-05-09','08:00:00',1.01),('8348','2013-05-09','08:05:00',1.08),('8348','2013-05-09','08:10:00',1.15),('8348','2013-05-09','08:15:00',1.19),('8348','2013-05-09','08:20:00',1.32),('8348','2013-05-09','08:25:00',1.38),('8348','2013-05-09','08:30:00',1.49),('8348','2013-05-09','08:35:00',1.57),('8348','2013-05-09','08:40:00',1.67),('8348','2013-05-09','08:45:00',1.74),('8348','2013-05-09','08:50:00',1.8),('8348','2013-05-09','08:55:00',1.86),('8348','2013-05-09','09:00:00',1.93),('8348','2013-05-09','09:05:00',2.01),('8348','2013-05-09','09:10:00',2.08),('8348','2013-05-09','09:15:00',2.15),('8348','2013-05-09','09:20:00',2.21),('8348','2013-05-09','09:25:00',2.29),('8348','2013-05-09','09:30:00',2.36),('8348','2013-05-09','09:35:00',2.42),('8348','2013-05-09','09:40:00',2.47),('8348','2013-05-09','09:45:00',2.53),('8348','2013-05-09','09:50:00',2.6),('8348','2013-05-09','09:55:00',2.66),('8348','2013-05-09','10:00:00',2.72),('8348','2013-05-09','10:05:00',2.77),('8348','2013-05-09','10:10:00',2.82),('8348','2013-05-09','10:15:00',2.86),('8348','2013-05-09','10:20:00',2.89),('8348','2013-05-09','10:25:00',2.94),('8348','2013-05-09','10:30:00',2.99),('8348','2013-05-09','10:35:00',3.03),('8348','2013-05-09','10:40:00',3.07),('8348','2013-05-09','10:45:00',3.1),('8348','2013-05-09','10:50:00',3.15),('8348','2013-05-09','10:55:00',3.18),('8348','2013-05-09','11:00:00',3.21),('8348','2013-05-09','11:05:00',3.26),('8348','2013-05-09','11:10:00',3.3),('8348','2013-05-09','11:15:00',3.32),('8348','2013-05-09','11:20:00',3.35),('8348','2013-05-09','11:25:00',3.37),('8348','2013-05-09','11:30:00',3.38),('8348','2013-05-09','11:35:00',3.41),('8348','2013-05-09','11:40:00',3.48),('8348','2013-05-09','11:45:00',3.5),('8348','2013-05-09','11:50:00',3.5),('8348','2013-05-09','11:55:00',3.53),('8348','2013-05-09','12:00:00',3.52),('8348','2013-05-09','12:05:00',3.57),('8348','2013-05-09','12:10:00',3.6),('8348','2013-05-09','12:15:00',3.62),('8348','2013-05-09','12:20:00',3.63),('8348','2013-05-09','12:25:00',3.62),('8348','2013-05-09','12:30:00',3.66),('8348','2013-05-09','12:35:00',3.69),('8348','2013-05-09','12:40:00',3.7),('8348','2013-05-09','12:45:00',3.71),('8348','2013-05-09','12:50:00',3.75),('8348','2013-05-09','12:55:00',3.72),('8348','2013-05-09','13:00:00',3.69),('8348','2013-05-09','13:05:00',3.66),('8348','2013-05-09','13:10:00',3.7),('8348','2013-05-09','13:15:00',3.71),('8348','2013-05-09','13:20:00',3.74),('8348','2013-05-09','13:25:00',3.75),('8348','2013-05-09','13:30:00',3.78),('8348','2013-05-09','13:35:00',3.76),('8348','2013-05-09','13:40:00',3.78),('8348','2013-05-09','13:45:00',3.85),('8348','2013-05-09','13:50:00',3.84),('8348','2013-05-09','13:55:00',3.92),('8348','2013-05-09','14:00:00',2.73),('8348','2013-05-09','14:05:00',2.79),('8348','2013-05-09','14:10:00',3.44),('8348','2013-05-09','14:15:00',2.87),('8348','2013-05-09','14:20:00',1.82),('8348','2013-05-09','14:25:00',3.97),('8348','2013-05-09','14:30:00',3.84),('8348','2013-05-09','14:35:00',3.78),('8348','2013-05-09','14:40:00',3.75),('8348','2013-05-09','14:45:00',3.71),('8348','2013-05-09','14:50:00',3.71),('8348','2013-05-09','14:55:00',3.76),('8348','2013-05-09','15:00:00',3.75),('8348','2013-05-09','15:05:00',3.69),('8348','2013-05-09','15:10:00',3.63),('8348','2013-05-09','15:15:00',3.57),('8348','2013-05-09','15:20:00',3.52),('8348','2013-05-09','15:25:00',3.46),('8348','2013-05-09','15:30:00',3.47),('8348','2013-05-09','15:35:00',3.46),('8348','2013-05-09','15:40:00',3.43),('8348','2013-05-09','15:45:00',3.4),('8348','2013-05-09','15:50:00',3.36),('8348','2013-05-09','15:55:00',3.32),('8348','2013-05-09','16:00:00',3.27),('8348','2013-05-09','16:05:00',3.23),('8348','2013-05-09','16:10:00',3.18),('8348','2013-05-09','16:15:00',3.11),('8348','2013-05-09','16:20:00',3.04),('8348','2013-05-09','16:25:00',2.97),('8348','2013-05-09','16:30:00',2.93),('8348','2013-05-09','16:35:00',2.87),('8348','2013-05-09','16:40:00',2.81),('8348','2013-05-09','16:45:00',2.74),('8348','2013-05-09','16:50:00',2.65),('8348','2013-05-09','16:55:00',2.59),('8348','2013-05-09','17:00:00',2.53),('8348','2013-05-09','17:05:00',2.46),('8348','2013-05-09','17:10:00',2.41),('8348','2013-05-09','17:15:00',2.34),('8348','2013-05-09','17:20:00',2.29),('8348','2013-05-09','17:25:00',2.23),('8348','2013-05-09','17:30:00',2.14),('8348','2013-05-09','17:35:00',2.06),('8348','2013-05-09','17:40:00',1.98),('8348','2013-05-09','17:45:00',1.9),('8348','2013-05-09','17:50:00',1.82),('8348','2013-05-09','17:55:00',1.75),('8348','2013-05-09','18:00:00',1.67),('8348','2013-05-09','18:05:00',1.59),('8348','2013-05-09','18:10:00',1.5),('8348','2013-05-09','18:15:00',1.42),('8348','2013-05-09','18:20:00',1.34),('8348','2013-05-09','18:25:00',1.26),('8348','2013-05-09','18:30:00',1.18),('8348','2013-05-09','18:35:00',1.1),('8348','2013-05-09','18:40:00',1.02),('8348','2013-05-08','08:05:00',1.16),('8348','2013-05-08','08:10:00',1.21),('8348','2013-05-08','08:15:00',1.22),('8348','2013-05-08','08:20:00',1.29),('8348','2013-05-08','08:25:00',1.36),('8348','2013-05-08','08:30:00',1.44),('8348','2013-05-08','08:35:00',1.52),('8348','2013-05-08','08:40:00',1.49),('8348','2013-05-08','08:45:00',1.05),('8348','2013-05-08','08:50:00',1.1),('8348','2013-05-08','09:05:00',1.22),('8348','2013-05-08','09:10:00',1.35),('8348','2013-05-08','09:35:00',1.24),('8348','2013-05-08','09:40:00',3),('8348','2013-05-08','09:45:00',2.47),('8348','2013-05-08','09:50:00',1.73),('8348','2013-05-08','09:55:00',2.67),('8348','2013-05-08','10:05:00',2.02),('8348','2013-05-08','10:10:00',2.59),('8348','2013-05-08','10:15:00',1.48),('8348','2013-05-08','10:55:00',1.33),('8348','2013-05-08','11:00:00',2.19),('8348','2013-05-08','11:05:00',3.76),('8348','2013-05-08','11:10:00',3.48),('8348','2013-05-08','11:15:00',2.8),('8348','2013-05-08','11:20:00',3.44),('8348','2013-05-08','11:25:00',3.68),('8348','2013-05-08','11:30:00',3.79),('8348','2013-05-08','11:35:00',3.88),('8348','2013-05-08','11:40:00',3.09),('8348','2013-05-08','11:45:00',1.49),('8348','2013-05-08','11:50:00',1.55),('8348','2013-05-08','11:55:00',1.56),('8348','2013-05-08','12:00:00',3.58),('8348','2013-05-08','12:05:00',1.13),('8348','2013-05-08','12:15:00',1.05),('8348','2013-05-08','12:20:00',3.09),('8348','2013-05-08','12:25:00',2.64),('8348','2013-05-08','12:30:00',2.14),('8348','2013-05-08','12:35:00',1.05),('8348','2013-05-08','12:40:00',1.05),('8348','2013-05-08','12:45:00',1.26),('8348','2013-05-08','12:50:00',1.55),('8348','2013-05-08','12:55:00',3.02),('8348','2013-05-08','13:00:00',4.07),('8348','2013-05-08','13:05:00',2.82),('8348','2013-05-08','13:10:00',4.67),('8348','2013-05-08','13:15:00',2.29),('8348','2013-05-08','13:20:00',1.02),('8348','2013-05-08','13:25:00',1.94),('8348','2013-05-08','13:40:00',2.79),('8348','2013-05-08','13:45:00',4.52),('8348','2013-05-08','13:50:00',4.33),('8348','2013-05-08','13:55:00',4.26),('8348','2013-05-08','14:00:00',3.56),('8348','2013-05-08','14:05:00',3.93),('8348','2013-05-08','14:10:00',2.43),('8348','2013-05-08','14:15:00',1.42),('8348','2013-05-08','14:20:00',2.36),('8348','2013-05-08','14:25:00',1.4),('8348','2013-05-08','14:30:00',1.94),('8348','2013-05-08','14:35:00',3.08),('8348','2013-05-08','14:40:00',4.46),('8348','2013-05-08','14:45:00',4),('8348','2013-05-08','14:50:00',3.91),('8348','2013-05-08','14:55:00',3.56),('8348','2013-05-08','15:00:00',3.37),('8348','2013-05-08','15:05:00',3.63),('8348','2013-05-08','15:10:00',3.28),('8348','2013-05-08','15:15:00',3.71),('8348','2013-05-08','15:20:00',3.67),('8348','2013-05-08','15:25:00',3.67),('8348','2013-05-08','15:30:00',3.61),('8348','2013-05-08','15:35:00',3.49),('8348','2013-05-08','15:40:00',3.44),('8348','2013-05-08','15:45:00',3.42),('8348','2013-05-08','15:50:00',3.38),('8348','2013-05-08','15:55:00',3.35),('8348','2013-05-08','16:00:00',3.34),('8348','2013-05-08','16:05:00',3.26),('8348','2013-05-08','16:10:00',3.22),('8348','2013-05-08','16:15:00',3.17),('8348','2013-05-08','16:20:00',3.09),('8348','2013-05-08','16:25:00',3.06),('8348','2013-05-08','16:30:00',3.09),('8348','2013-05-08','16:35:00',2.89),('8348','2013-05-08','16:40:00',2.31),('8348','2013-05-08','16:45:00',2.31),('8348','2013-05-08','16:50:00',2.66),('8348','2013-05-08','16:55:00',2.71),('8348','2013-05-08','17:00:00',2.62),('8348','2013-05-08','17:05:00',2.76),('8348','2013-05-08','17:10:00',2.68),('8348','2013-05-08','17:15:00',2.53),('8348','2013-05-08','17:20:00',2.14),('8348','2013-05-08','17:25:00',2.23),('8348','2013-05-08','17:30:00',2.48),('8348','2013-05-08','17:35:00',2.42),('8348','2013-05-08','17:40:00',2.42),('8348','2013-05-08','17:45:00',2.43),('8348','2013-05-08','17:50:00',2.41),('8348','2013-05-08','17:55:00',2.21),('8348','2013-05-08','18:00:00',1.01),('8348','2013-05-08','18:10:00',1.14),('8348','2013-05-08','18:15:00',1.8),('8348','2013-05-08','18:20:00',1.71),('8348','2013-05-08','18:25:00',1.55),('8348','2013-05-08','18:30:00',1.24),('8348','2013-05-08','18:35:00',1.22),('8348','2013-05-07','08:05:00',1.05),('8348','2013-05-07','08:10:00',1.11),('8348','2013-05-07','08:15:00',1.18),('8348','2013-05-07','08:20:00',1.27),('8348','2013-05-07','08:25:00',1.35),('8348','2013-05-07','08:30:00',1.45),('8348','2013-05-07','08:35:00',1.51),('8348','2013-05-07','08:40:00',1.64),('8348','2013-05-07','08:45:00',1.74),('8348','2013-05-07','08:50:00',1.88),('8348','2013-05-07','08:55:00',2.06),('8348','2013-05-07','09:00:00',2.18),('8348','2013-05-07','09:35:00',1.01),('8348','2013-05-07','09:40:00',1.73),('8348','2013-05-07','09:45:00',1.92),('8348','2013-05-07','09:50:00',1.91),('8348','2013-05-07','10:55:00',1.06),('8348','2013-05-07','11:00:00',1.23),('8348','2013-05-07','11:05:00',1.3),('8348','2013-05-07','11:10:00',1.26),('8348','2013-05-07','11:15:00',1.22),('8348','2013-05-07','11:20:00',1.38),('8348','2013-05-07','11:25:00',1.55),('8348','2013-05-07','11:55:00',1.51),('8348','2013-05-07','12:00:00',4.38),('8348','2013-05-07','12:05:00',4.3),('8348','2013-05-07','12:10:00',4.32),('8348','2013-05-07','12:15:00',4.36),('8348','2013-05-07','12:20:00',4.33),('8348','2013-05-07','12:25:00',3.49),('8348','2013-05-07','12:30:00',1.19),('8348','2013-05-07','13:15:00',1.07),('8348','2013-05-07','13:20:00',1.06),('8348','2013-05-07','13:25:00',1.27),('8348','2013-05-07','13:30:00',2.3),('8348','2013-05-07','13:35:00',3.32),('8348','2013-05-07','13:40:00',4.15),('8348','2013-05-07','13:45:00',4.62),('8348','2013-05-07','13:50:00',4.26),('8348','2013-05-07','13:55:00',2.01),('8348','2013-05-07','14:00:00',4.33),('8348','2013-05-07','14:05:00',3.49),('8348','2013-05-07','14:10:00',3.74),('8348','2013-05-07','14:15:00',3.91),('8348','2013-05-07','14:20:00',2.32),('8348','2013-05-07','14:25:00',1.53),('8348','2013-05-07','14:30:00',2.81),('8348','2013-05-07','14:35:00',2.31),('8348','2013-05-07','14:40:00',4.14),('8348','2013-05-07','14:45:00',2.61),('8348','2013-05-07','14:50:00',3.62),('8348','2013-05-07','14:55:00',2.76),('8348','2013-05-07','15:00:00',3.76),('8348','2013-05-07','15:05:00',3.92),('8348','2013-05-07','15:10:00',3.3),('8348','2013-05-07','15:15:00',3.78),('8348','2013-05-07','15:20:00',3.59),('8348','2013-05-07','15:25:00',2.33),('8348','2013-05-07','15:30:00',2.22),('8348','2013-05-07','15:35:00',2.84),('8348','2013-05-07','15:40:00',2.83),('8348','2013-05-07','15:45:00',2.2),('8348','2013-05-07','15:50:00',1.92),('8348','2013-05-07','15:55:00',2.13),('8348','2013-05-07','16:00:00',3.45),('8348','2013-05-07','16:05:00',1.79),('8348','2013-05-07','16:10:00',1.24),('8348','2013-05-07','16:15:00',2.81),('8348','2013-05-07','16:20:00',4.05),('8348','2013-05-07','16:25:00',3.83),('8348','2013-05-07','16:30:00',3.64),('8348','2013-05-07','16:35:00',3.61),('8348','2013-05-07','16:40:00',3.64),('8348','2013-05-07','16:45:00',2.74),('8348','2013-05-07','16:50:00',2.95),('8348','2013-05-07','16:55:00',2.23),('8348','2013-05-07','17:00:00',2.76),('8348','2013-05-07','17:05:00',2.88),('8348','2013-05-07','17:10:00',1.59),('8348','2013-05-07','17:15:00',1.18),('8348','2013-05-07','17:20:00',1.16),('8348','2013-05-07','17:25:00',1.14),('8348','2013-05-06','08:25:00',1.03),('8348','2013-05-06','08:30:00',1.13),('8348','2013-05-06','08:35:00',1.04),('8348','2013-05-06','08:50:00',1.09),('8348','2013-05-06','08:55:00',1.77),('8348','2013-05-06','09:00:00',2.02),('8348','2013-05-06','09:05:00',1.41),('8348','2013-05-06','09:10:00',1.25),('8348','2013-05-06','09:15:00',1.24),('8348','2013-05-06','09:20:00',1.2),('8348','2013-05-06','09:25:00',1.12),('8348','2013-05-06','10:00:00',1.59),('8348','2013-05-06','10:05:00',1.09),('8348','2013-05-06','10:10:00',1.01),('8348','2013-05-06','10:15:00',1.29),('8348','2013-05-06','10:20:00',2.02),('8348','2013-05-06','10:25:00',1.73),('8348','2013-05-06','10:30:00',1.71),('8348','2013-05-06','10:35:00',1.73),('8348','2013-05-06','10:40:00',1.64),('8348','2013-05-06','10:45:00',2.31),('8348','2013-05-06','10:50:00',2.37),('8348','2013-05-06','10:55:00',1.79),('8348','2013-05-06','11:00:00',1.64),('8348','2013-05-06','11:05:00',1.85),('8348','2013-05-06','11:10:00',1.81),('8348','2013-05-06','11:15:00',1.6),('8348','2013-05-06','11:20:00',1.92),('8348','2013-05-06','11:25:00',2),('8348','2013-05-06','11:30:00',1.32),('8348','2013-05-06','11:35:00',1.57),('8348','2013-05-06','11:40:00',2.18),('8348','2013-05-06','11:45:00',3.66),('8348','2013-05-06','11:50:00',2.03),('8348','2013-05-06','11:55:00',1.69),('8348','2013-05-06','12:00:00',1.95),('8348','2013-05-06','12:05:00',1.89),('8348','2013-05-06','12:10:00',3.18),('8348','2013-05-06','12:15:00',2.28),('8348','2013-05-06','12:20:00',2.19),('8348','2013-05-06','12:25:00',2.74),('8348','2013-05-06','12:30:00',3.83),('8348','2013-05-06','12:35:00',4.28),('8348','2013-05-06','12:40:00',2.52),('8348','2013-05-06','12:45:00',1.97),('8348','2013-05-06','12:50:00',3.54),('8348','2013-05-06','12:55:00',2.85),('8348','2013-05-06','13:00:00',2.16),('8348','2013-05-06','13:05:00',3.4),('8348','2013-05-06','13:10:00',3.43),('8348','2013-05-06','13:15:00',3.7),('8348','2013-05-06','13:20:00',2.8),('8348','2013-05-06','13:25:00',2.75),('8348','2013-05-06','13:30:00',2.77),('8348','2013-05-06','13:35:00',3.04),('8348','2013-05-06','13:40:00',3.33),('8348','2013-05-06','13:45:00',4.37),('8348','2013-05-06','13:50:00',3.55),('8348','2013-05-06','13:55:00',4.43),('8348','2013-05-06','14:00:00',3.08),('8348','2013-05-06','14:05:00',3.95),('8348','2013-05-06','14:10:00',2.37),('8348','2013-05-06','14:15:00',3.17),('8348','2013-05-06','14:20:00',4.67),('8348','2013-05-06','14:25:00',2.25),('8348','2013-05-06','14:30:00',3.7),('8348','2013-05-06','14:35:00',3.82),('8348','2013-05-06','14:40:00',2.06),('8348','2013-05-06','14:45:00',2.84),('8348','2013-05-06','14:50:00',1.95),('8348','2013-05-06','14:55:00',3.91),('8348','2013-05-06','15:00:00',3.58),('8348','2013-05-06','15:05:00',3.15),('8348','2013-05-06','15:10:00',3.51),('8348','2013-05-06','15:15:00',1.92),('8348','2013-05-06','15:20:00',2),('8348','2013-05-06','15:25:00',2.97),('8348','2013-05-06','15:30:00',1.45),('8348','2013-05-06','15:35:00',1.88),('8348','2013-05-06','15:40:00',1.28),('8348','2013-05-06','15:45:00',1.75),('8348','2013-05-06','15:50:00',2),('8348','2013-05-06','15:55:00',1.4),('8348','2013-05-06','16:00:00',2.18),('8348','2013-05-06','16:05:00',1.41),('8348','2013-05-06','16:10:00',1.31),('8348','2013-05-06','16:15:00',1.77),('8348','2013-05-06','16:20:00',2.09),('8348','2013-05-06','16:25:00',1.68),('8348','2013-05-06','16:30:00',1.84),('8348','2013-05-06','16:35:00',1.86),('8348','2013-05-06','16:40:00',2.56),('8348','2013-05-06','16:45:00',2.79),('8348','2013-05-06','16:50:00',2.54),('8348','2013-05-06','16:55:00',2.86),('8348','2013-05-06','17:15:00',1.11),('8348','2013-05-06','17:35:00',1.42),('8348','2013-05-06','17:40:00',1.69),('8348','2013-05-06','17:50:00',1.21),('8348','2013-05-06','17:55:00',1.25),('8348','2013-05-06','18:00:00',1.67),('8348','2013-05-06','18:05:00',1.86),('8348','2013-05-06','18:15:00',1.26),('8348','2013-05-06','18:20:00',1.69),('8348','2013-05-06','18:25:00',1.47),('8348','2013-05-06','18:30:00',1.27),('8348','2013-05-05','08:10:00',1.05),('8348','2013-05-05','08:15:00',1.15),('8348','2013-05-05','08:20:00',1.35),('8348','2013-05-05','08:25:00',1.7),('8348','2013-05-05','08:30:00',1.83),('8348','2013-05-05','08:35:00',1.69),('8348','2013-05-05','08:40:00',1.75),('8348','2013-05-05','08:45:00',1.44),('8348','2013-05-05','08:50:00',1.16),('8348','2013-05-05','08:55:00',1.15),('8348','2013-05-05','09:00:00',1.21),('8348','2013-05-05','09:05:00',1.24),('8348','2013-05-05','09:10:00',1.24),('8348','2013-05-05','09:15:00',1.28),('8348','2013-05-05','09:20:00',1.1),('8348','2013-05-05','09:25:00',1.28),('8348','2013-05-05','09:30:00',1.61),('8348','2013-05-05','09:35:00',1.28),('8348','2013-05-05','09:40:00',2.04),('8348','2013-05-05','09:45:00',2.59),('8348','2013-05-05','09:50:00',2.75),('8348','2013-05-05','09:55:00',2.61),('8348','2013-05-05','10:00:00',2.59),('8348','2013-05-05','10:05:00',2.36),('8348','2013-05-05','10:10:00',1.91),('8348','2013-05-05','10:15:00',2.43),('8348','2013-05-05','10:20:00',3.07),('8348','2013-05-05','10:25:00',1.95),('8348','2013-05-05','10:30:00',2.21),('8348','2013-05-05','10:35:00',2.42),('8348','2013-05-05','10:40:00',2.22),('8348','2013-05-05','10:45:00',2.28),('8348','2013-05-05','10:50:00',1.53),('8348','2013-05-05','10:55:00',1.34),('8348','2013-05-05','11:00:00',1.31),('8348','2013-05-05','11:05:00',1.53),('8348','2013-05-05','11:10:00',1.4),('8348','2013-05-05','11:15:00',1.5),('8348','2013-05-05','11:20:00',2.31),('8348','2013-05-05','11:25:00',3.09),('8348','2013-05-05','11:30:00',2.27),('8348','2013-05-05','11:35:00',3.07),('8348','2013-05-05','11:40:00',2.37),('8348','2013-05-05','11:45:00',2.38),('8348','2013-05-05','11:50:00',2.5),('8348','2013-05-05','11:55:00',3.33),('8348','2013-05-05','12:00:00',2.84),('8348','2013-05-05','12:05:00',2.6),('8348','2013-05-05','12:10:00',2.4),('8348','2013-05-05','12:15:00',2.84),('8348','2013-05-05','12:20:00',2.86),('8348','2013-05-05','12:25:00',3.6),('8348','2013-05-05','12:30:00',2.36),('8348','2013-05-05','12:35:00',3.17),('8348','2013-05-05','12:40:00',3.73),('8348','2013-05-05','12:45:00',3.89),('8348','2013-05-05','12:50:00',3.77),('8348','2013-05-05','12:55:00',3.93),('8348','2013-05-05','13:00:00',3.95),('8348','2013-05-05','13:05:00',3.96),('8348','2013-05-05','13:10:00',4.1),('8348','2013-05-05','13:15:00',3.49),('8348','2013-05-05','13:20:00',2.99),('8348','2013-05-05','13:25:00',1.71),('8348','2013-05-05','13:30:00',1.56),('8348','2013-05-05','13:35:00',3.98),('8348','2013-05-05','13:40:00',4.11),('8348','2013-05-05','13:45:00',3.94),('8348','2013-05-05','13:50:00',4.02),('8348','2013-05-05','13:55:00',4.06),('8348','2013-05-05','14:00:00',4.09),('8348','2013-05-05','14:05:00',3.86),('8348','2013-05-05','14:10:00',2.98),('8348','2013-05-05','14:15:00',3.26),('8348','2013-05-05','14:20:00',3.72),('8348','2013-05-05','14:25:00',3.59),('8348','2013-05-05','14:30:00',3.52),('8348','2013-05-05','14:35:00',3.48),('8348','2013-05-05','14:40:00',3.46),('8348','2013-05-05','14:45:00',3.44),('8348','2013-05-05','14:50:00',3.41),('8348','2013-05-05','14:55:00',3.36),('8348','2013-05-05','15:00:00',3.35),('8348','2013-05-05','15:05:00',3.32),('8348','2013-05-05','15:10:00',3.31),('8348','2013-05-05','15:15:00',3.28),('8348','2013-05-05','15:20:00',3.21),('8348','2013-05-05','15:25:00',3.21),('8348','2013-05-05','15:30:00',3.19),('8348','2013-05-05','15:35:00',3.19),('8348','2013-05-05','15:40:00',3.16),('8348','2013-05-05','15:45:00',3.11),('8348','2013-05-05','15:50:00',3.07),('8348','2013-05-05','15:55:00',3.04),('8348','2013-05-05','16:00:00',2.99),('8348','2013-05-05','16:05:00',2.95),('8348','2013-05-05','16:10:00',2.9),('8348','2013-05-05','16:15:00',2.84),('8348','2013-05-05','16:20:00',2.79),('8348','2013-05-05','16:25:00',2.75),('8348','2013-05-05','16:30:00',2.71),('8348','2013-05-05','16:35:00',2.65),('8348','2013-05-05','16:40:00',2.6),('8348','2013-05-05','16:45:00',2.53),('8348','2013-05-05','16:50:00',2.47),('8348','2013-05-05','16:55:00',2.4),('8348','2013-05-05','17:00:00',2.34),('8348','2013-05-05','17:05:00',2.28),('8348','2013-05-05','17:10:00',2.21),('8348','2013-05-05','17:15:00',2.15),('8348','2013-05-05','17:20:00',2.08),('8348','2013-05-05','17:25:00',1.99),('8348','2013-05-05','17:30:00',1.92),('8348','2013-05-05','17:35:00',1.84),('8348','2013-05-05','17:40:00',1.78),('8348','2013-05-05','17:45:00',1.71),('8348','2013-05-05','17:50:00',1.63),('8348','2013-05-05','17:55:00',1.55),('8348','2013-05-05','18:00:00',1.46),('8348','2013-05-05','18:05:00',1.39),('8348','2013-05-05','18:10:00',1.31),('8348','2013-05-05','18:15:00',1.24),('8348','2013-05-05','18:20:00',1.17),('8348','2013-05-05','18:25:00',1.09),('8348','2013-05-05','18:30:00',1.01),('8348','2013-05-04','08:10:00',1.02),('8348','2013-05-04','08:15:00',1.08),('8348','2013-05-04','08:20:00',1.13),('8348','2013-05-04','08:25:00',1.18),('8348','2013-05-04','08:30:00',1.3),('8348','2013-05-04','08:35:00',1.35),('8348','2013-05-04','08:40:00',1.43),('8348','2013-05-04','08:45:00',1.53),('8348','2013-05-04','08:50:00',1.59),('8348','2013-05-04','08:55:00',1.66),('8348','2013-05-04','09:00:00',1.72),('8348','2013-05-04','09:05:00',1.8),('8348','2013-05-04','09:10:00',1.88),('8348','2013-05-04','09:15:00',1.91),('8348','2013-05-04','09:20:00',2),('8348','2013-05-04','09:25:00',2.04),('8348','2013-05-04','09:30:00',2.08),('8348','2013-05-04','09:35:00',2.16),('8348','2013-05-04','09:40:00',2.24),('8348','2013-05-04','09:45:00',2.3),('8348','2013-05-04','09:50:00',2.35),('8348','2013-05-04','09:55:00',2.41),('8348','2013-05-04','10:00:00',2.49),('8348','2013-05-04','10:05:00',2.52),('8348','2013-05-04','10:10:00',2.57),('8348','2013-05-04','10:15:00',2.63),('8348','2013-05-04','10:20:00',2.69),('8348','2013-05-04','10:25:00',2.74),('8348','2013-05-04','10:30:00',2.76),('8348','2013-05-04','10:35:00',2.8),('8348','2013-05-04','10:40:00',2.81),('8348','2013-05-04','10:45:00',2.82),('8348','2013-05-04','10:50:00',2.77),('8348','2013-05-04','10:55:00',2.81),('8348','2013-05-04','11:00:00',2.82),('8348','2013-05-04','11:05:00',2.83),('8348','2013-05-04','11:10:00',2.7),('8348','2013-05-04','11:15:00',2.65),('8348','2013-05-04','11:20:00',2.85),('8348','2013-05-04','11:25:00',2.9),('8348','2013-05-04','11:30:00',2.81),('8348','2013-05-04','11:35:00',2.9),('8348','2013-05-04','11:40:00',2.82),('8348','2013-05-04','11:45:00',2.89),('8348','2013-05-04','11:50:00',2.93),('8348','2013-05-04','11:55:00',2.93),('8348','2013-05-04','12:00:00',2.89),('8348','2013-05-04','12:05:00',3.02),('8348','2013-05-04','12:10:00',3.03),('8348','2013-05-04','12:15:00',3.12),('8348','2013-05-04','12:20:00',3.15),('8348','2013-05-04','12:25:00',3.22),('8348','2013-05-04','12:30:00',3.26),('8348','2013-05-04','12:35:00',3.28),('8348','2013-05-04','12:40:00',3.27),('8348','2013-05-04','12:45:00',3.32),('8348','2013-05-04','12:50:00',3.21),('8348','2013-05-04','12:55:00',3.2),('8348','2013-05-04','13:00:00',3.17),('8348','2013-05-04','13:05:00',2.84),('8348','2013-05-04','13:10:00',3.04),('8348','2013-05-04','13:15:00',3.44),('8348','2013-05-04','13:20:00',3.47),('8348','2013-05-04','13:25:00',3.34),('8348','2013-05-04','13:30:00',3.38),('8348','2013-05-04','13:35:00',3.2),('8348','2013-05-04','13:40:00',3.29),('8348','2013-05-04','13:45:00',3.3),('8348','2013-05-04','13:50:00',2.91),('8348','2013-05-04','13:55:00',3.01),('8348','2013-05-04','14:00:00',3.26),('8348','2013-05-04','14:05:00',3.19),('8348','2013-05-04','14:10:00',3.08),('8348','2013-05-04','14:15:00',3.13),('8348','2013-05-04','14:20:00',3.16),('8348','2013-05-04','14:25:00',2.92),('8348','2013-05-04','14:30:00',3.11),('8348','2013-05-04','14:35:00',2.89),('8348','2013-05-04','14:40:00',3.03),('8348','2013-05-04','14:45:00',2.97),('8348','2013-05-04','14:50:00',2.9),('8348','2013-05-04','14:55:00',3.02),('8348','2013-05-04','15:00:00',3.03),('8348','2013-05-04','15:05:00',3.12),('8348','2013-05-04','15:10:00',2.95),('8348','2013-05-04','15:15:00',3.04),('8348','2013-05-04','15:20:00',3.02),('8348','2013-05-04','15:25:00',3.03),('8348','2013-05-04','15:30:00',2.98),('8348','2013-05-04','15:35:00',2.89),('8348','2013-05-04','15:40:00',2.94),('8348','2013-05-04','15:45:00',2.97),('8348','2013-05-04','15:50:00',2.92),('8348','2013-05-04','15:55:00',2.88),('8348','2013-05-04','16:00:00',2.84),('8348','2013-05-04','16:05:00',2.77),('8348','2013-05-04','16:10:00',2.72),('8348','2013-05-04','16:15:00',2.69),('8348','2013-05-04','16:20:00',2.64),('8348','2013-05-04','16:25:00',2.58),('8348','2013-05-04','16:30:00',2.52),('8348','2013-05-04','16:35:00',2.47),('8348','2013-05-04','16:40:00',2.39),('8348','2013-05-04','16:45:00',2.34),('8348','2013-05-04','16:50:00',2.28),('8348','2013-05-04','16:55:00',2.24),('8348','2013-05-04','17:00:00',2.2),('8348','2013-05-04','17:05:00',2.12),('8348','2013-05-04','17:10:00',1.66),('8348','2013-05-04','17:15:00',1.9),('8348','2013-05-04','17:20:00',1.99),('8348','2013-05-04','17:25:00',1.92),('8348','2013-05-04','17:30:00',1.83),('8348','2013-05-04','17:35:00',1.7),('8348','2013-05-04','17:40:00',1.59),('8348','2013-05-04','17:45:00',1.56),('8348','2013-05-04','17:50:00',1.58),('8348','2013-05-04','17:55:00',1.51),('8348','2013-05-04','18:00:00',1.44),('8348','2013-05-04','18:05:00',1.37),('8348','2013-05-04','18:10:00',1.16),('8348','2013-05-03','08:05:00',1.02),('8348','2013-05-03','08:10:00',1.13),('8348','2013-05-03','08:15:00',1.3),('8348','2013-05-03','08:20:00',1.29),('8348','2013-05-03','08:25:00',1.37),('8348','2013-05-03','08:30:00',1.4),('8348','2013-05-03','08:35:00',1.44),('8348','2013-05-03','08:40:00',1.53),('8348','2013-05-03','08:45:00',1.64),('8348','2013-05-03','08:50:00',1.62),('8348','2013-05-03','08:55:00',1.65),('8348','2013-05-03','09:00:00',1.77),('8348','2013-05-03','09:05:00',1.87),('8348','2013-05-03','09:10:00',1.91),('8348','2013-05-03','09:15:00',1.97),('8348','2013-05-03','09:20:00',2.02),('8348','2013-05-03','09:25:00',2.1),('8348','2013-05-03','09:30:00',2.14),('8348','2013-05-03','09:35:00',2.22),('8348','2013-05-03','09:40:00',2.28),('8348','2013-05-03','09:45:00',2.35),('8348','2013-05-03','09:50:00',2.4),('8348','2013-05-03','09:55:00',2.46),('8348','2013-05-03','10:00:00',2.53),('8348','2013-05-03','10:05:00',2.57),('8348','2013-05-03','10:10:00',2.62),('8348','2013-05-03','10:15:00',2.66),('8348','2013-05-03','10:20:00',2.7),('8348','2013-05-03','10:25:00',2.74),('8348','2013-05-03','10:30:00',2.78),('8348','2013-05-03','10:35:00',2.85),('8348','2013-05-03','10:40:00',2.9),('8348','2013-05-03','10:45:00',2.93),('8348','2013-05-03','10:50:00',2.94),('8348','2013-05-03','10:55:00',2.99),('8348','2013-05-03','11:00:00',3.04),('8348','2013-05-03','11:05:00',3.08),('8348','2013-05-03','11:10:00',3.09),('8348','2013-05-03','11:15:00',3.11),('8348','2013-05-03','11:20:00',3.16),('8348','2013-05-03','11:25:00',3.2),('8348','2013-05-03','11:30:00',3.23),('8348','2013-05-03','11:35:00',3.28),('8348','2013-05-03','11:40:00',3.31),('8348','2013-05-03','11:45:00',3.3),('8348','2013-05-03','11:50:00',3.31),('8348','2013-05-03','11:55:00',3.34),('8348','2013-05-03','12:00:00',3.36),('8348','2013-05-03','12:05:00',3.36),('8348','2013-05-03','12:10:00',3.38),('8348','2013-05-03','12:15:00',3.4),('8348','2013-05-03','12:20:00',3.43),('8348','2013-05-03','12:25:00',3.45),('8348','2013-05-03','12:30:00',3.45),('8348','2013-05-03','12:35:00',3.45),('8348','2013-05-03','12:40:00',3.46),('8348','2013-05-03','12:45:00',3.42),('8348','2013-05-03','12:50:00',3.48),('8348','2013-05-03','12:55:00',3.52),('8348','2013-05-03','13:00:00',3.54),('8348','2013-05-03','13:05:00',3.52),('8348','2013-05-03','13:10:00',3.52),('8348','2013-05-03','13:15:00',3.52),('8348','2013-05-03','13:20:00',3.54),('8348','2013-05-03','13:25:00',3.56),('8348','2013-05-03','13:30:00',3.56),('8348','2013-05-03','13:35:00',3.47),('8348','2013-05-03','13:40:00',3.35),('8348','2013-05-03','13:45:00',3.4),('8348','2013-05-03','13:50:00',3.36),('8348','2013-05-03','13:55:00',3.37),('8348','2013-05-03','14:00:00',3.37),('8348','2013-05-03','14:05:00',3.2),('8348','2013-05-03','14:10:00',3.27),('8348','2013-05-03','14:15:00',3.25),('8348','2013-05-03','14:20:00',3.35),('8348','2013-05-03','14:25:00',3.3),('8348','2013-05-03','14:30:00',3.35),('8348','2013-05-03','14:35:00',3.4),('8348','2013-05-03','14:40:00',3.36),('8348','2013-05-03','14:45:00',3.37),('8348','2013-05-03','14:50:00',3.33),('8348','2013-05-03','14:55:00',3.34),('8348','2013-05-03','15:00:00',3.34),('8348','2013-05-03','15:05:00',3.33),('8348','2013-05-03','15:10:00',3.33),('8348','2013-05-03','15:15:00',3.31),('8348','2013-05-03','15:20:00',3.27),('8348','2013-05-03','15:25:00',3.26),('8348','2013-05-03','15:30:00',3.23),('8348','2013-05-03','15:35:00',3.19),('8348','2013-05-03','15:40:00',3.14),('8348','2013-05-03','15:45:00',3.1),('8348','2013-05-03','15:50:00',3.04),('8348','2013-05-03','15:55:00',2.99),('8348','2013-05-03','16:00:00',2.98),('8348','2013-05-03','16:05:00',2.96),('8348','2013-05-03','16:10:00',2.91),('8348','2013-05-03','16:15:00',2.81),('8348','2013-05-03','16:20:00',2.7),('8348','2013-05-03','16:25:00',2.67),('8348','2013-05-03','16:30:00',2.67),('8348','2013-05-03','16:35:00',2.6),('8348','2013-05-03','16:40:00',2.55),('8348','2013-05-03','16:45:00',2.49),('8348','2013-05-03','16:50:00',2.42),('8348','2013-05-03','16:55:00',2.34),('8348','2013-05-03','17:00:00',2.29),('8348','2013-05-03','17:05:00',2.22),('8348','2013-05-03','17:10:00',2.14),('8348','2013-05-03','17:15:00',2.07),('8348','2013-05-03','17:20:00',1.97),('8348','2013-05-03','17:25:00',1.87),('8348','2013-05-03','17:30:00',1.8),('8348','2013-05-03','17:35:00',1.72),('8348','2013-05-03','17:40:00',1.64),('8348','2013-05-03','17:45:00',1.55),('8348','2013-05-03','17:50:00',1.46),('8348','2013-05-03','17:55:00',1.4),('8348','2013-05-03','18:00:00',1.36),('8348','2013-05-03','18:05:00',1.31),('8348','2013-05-03','18:10:00',1.22),('8348','2013-05-03','18:15:00',1.15),('8348','2013-05-03','18:20:00',1.08),('8348','2013-05-03','18:25:00',1.01),('8348','2013-05-02','08:55:00',1.03),('8348','2013-05-02','09:00:00',1.52),('8348','2013-05-02','09:05:00',1.25),('8348','2013-05-02','09:25:00',1.55),('8348','2013-05-02','09:30:00',1.87),('8348','2013-05-02','09:35:00',1.75),('8348','2013-05-02','09:40:00',1.34),('8348','2013-05-02','09:45:00',2.24),('8348','2013-05-02','09:50:00',1.23),('8348','2013-05-02','10:05:00',1.31),('8348','2013-05-02','10:10:00',1.28),('8348','2013-05-02','10:15:00',1.3),('8348','2013-05-02','10:20:00',1.33),('8348','2013-05-02','10:25:00',1.54),('8348','2013-05-02','10:30:00',2.41),('8348','2013-05-02','10:35:00',2.29),('8348','2013-05-02','10:40:00',2.87),('8348','2013-05-02','10:45:00',2.84),('8348','2013-05-02','10:50:00',3.1),('8348','2013-05-02','10:55:00',3.32),('8348','2013-05-02','11:00:00',3.25),('8348','2013-05-02','11:05:00',3.02),('8348','2013-05-02','11:10:00',2.66),('8348','2013-05-02','11:15:00',2.51),('8348','2013-05-02','11:20:00',2.35),('8348','2013-05-02','11:25:00',3.24),('8348','2013-05-02','11:30:00',3.4),('8348','2013-05-02','11:35:00',3.28),('8348','2013-05-02','11:40:00',3.28),('8348','2013-05-02','11:45:00',3.29),('8348','2013-05-02','11:50:00',3.28),('8348','2013-05-02','11:55:00',3.29),('8348','2013-05-02','12:00:00',3.29),('8348','2013-05-02','12:05:00',3.29),('8348','2013-05-02','12:10:00',3.27),('8348','2013-05-02','12:15:00',3.33),('8348','2013-05-02','12:20:00',3.35),('8348','2013-05-02','12:25:00',3.38),('8348','2013-05-02','12:30:00',3.41),('8348','2013-05-02','12:35:00',3.48),('8348','2013-05-02','12:40:00',3.52),('8348','2013-05-02','12:45:00',3.54),('8348','2013-05-02','12:50:00',3.57),('8348','2013-05-02','12:55:00',3.6),('8348','2013-05-02','13:00:00',3.62),('8348','2013-05-02','13:05:00',3.66),('8348','2013-05-02','13:10:00',3.71),('8348','2013-05-02','13:15:00',3.75),('8348','2013-05-02','13:20:00',3.76),('8348','2013-05-02','13:25:00',3.77),('8348','2013-05-02','13:30:00',3.77),('8348','2013-05-02','13:35:00',3.76),('8348','2013-05-02','13:40:00',3.74),('8348','2013-05-02','13:45:00',3.7),('8348','2013-05-02','13:50:00',3.67),('8348','2013-05-02','13:55:00',3.67),('8348','2013-05-02','14:00:00',3.66),('8348','2013-05-02','14:05:00',3.61),('8348','2013-05-02','14:10:00',3.58),('8348','2013-05-02','14:15:00',3.57),('8348','2013-05-02','14:20:00',3.55),('8348','2013-05-02','14:25:00',3.53),('8348','2013-05-02','14:30:00',3.5),('8348','2013-05-02','14:35:00',3.47),('8348','2013-05-02','14:40:00',3.46),('8348','2013-05-02','14:45:00',3.46),('8348','2013-05-02','14:50:00',3.42),('8348','2013-05-02','14:55:00',3.38),('8348','2013-05-02','15:00:00',3.38),('8348','2013-05-02','15:05:00',3.35),('8348','2013-05-02','15:10:00',3.31),('8348','2013-05-02','15:15:00',3.25),('8348','2013-05-02','15:20:00',3.21),('8348','2013-05-02','15:25:00',3.17),('8348','2013-05-02','15:30:00',3.13),('8348','2013-05-02','15:35:00',3.13),('8348','2013-05-02','15:40:00',3.1),('8348','2013-05-02','15:45:00',3.06),('8348','2013-05-02','15:50:00',3.05),('8348','2013-05-02','15:55:00',3.01),('8348','2013-05-02','16:00:00',2.97),('8348','2013-05-02','16:05:00',2.93),('8348','2013-05-02','16:10:00',2.89),('8348','2013-05-02','16:15:00',2.84),('8348','2013-05-02','16:20:00',2.77),('8348','2013-05-02','16:25:00',2.73),('8348','2013-05-02','16:30:00',2.65),('8348','2013-05-02','16:35:00',2.59),('8348','2013-05-02','16:40:00',2.55),('8348','2013-05-02','16:45:00',2.48),('8348','2013-05-02','16:50:00',2.42),('8348','2013-05-02','16:55:00',2.36),('8348','2013-05-02','17:00:00',2.31),('8348','2013-05-02','17:05:00',2.25),('8348','2013-05-02','17:10:00',2.19),('8348','2013-05-02','17:15:00',2.13),('8348','2013-05-02','17:20:00',2.06),('8348','2013-05-02','17:25:00',2),('8348','2013-05-02','17:30:00',1.92),('8348','2013-05-02','17:35:00',1.84),('8348','2013-05-02','17:40:00',1.77),('8348','2013-05-02','17:45:00',1.7),('8348','2013-05-02','17:50:00',1.62),('8348','2013-05-02','17:55:00',1.54),('8348','2013-05-02','18:00:00',1.47),('8348','2013-05-02','18:05:00',1.4),('8348','2013-05-02','18:10:00',1.32),('8348','2013-05-02','18:15:00',1.24),('8348','2013-05-02','18:20:00',1.16),('8348','2013-05-02','18:25:00',1.08),('8348','2013-05-02','18:30:00',1.01),('8348','2014-03-30','07:05:00',1.05),('8348','2014-03-30','07:10:00',1.14),('8348','2014-03-30','07:15:00',1.27),('8348','2014-03-30','07:20:00',1.44),('8348','2014-03-30','07:25:00',1.59),('8348','2014-03-30','07:30:00',1.71),('8348','2014-03-30','07:35:00',1.79),('8348','2014-03-30','07:40:00',1.89),('8348','2014-03-30','07:45:00',1.92),('8348','2014-03-30','07:50:00',1.95),('8348','2014-03-30','07:55:00',2.05),('8348','2014-03-30','08:00:00',2.16),('8348','2014-03-30','08:05:00',2.13),('8348','2014-03-30','08:10:00',2.13),('8348','2014-03-30','08:15:00',2.12),('8348','2014-03-30','08:20:00',2.45),('8348','2014-03-30','08:25:00',2.67),('8348','2014-03-30','08:30:00',3.04),('8348','2014-03-30','08:35:00',3.24),('8348','2014-03-30','08:40:00',3.33),('8348','2014-03-30','08:45:00',3.51),('8348','2014-03-30','08:50:00',3.66),('8348','2014-03-30','08:55:00',3.66),('8348','2014-03-30','09:00:00',3.68),('8348','2014-03-30','09:05:00',4.13),('8348','2014-03-30','09:10:00',4.27),('8348','2014-03-30','09:15:00',4.33),('8348','2014-03-30','09:20:00',4.12),('8348','2014-03-30','09:25:00',4.54),('8348','2014-03-30','09:30:00',4.71),('8348','2014-03-30','09:35:00',4.84),('8348','2014-03-30','09:40:00',4.95),('8348','2014-03-30','09:45:00',4.98),('8348','2014-03-30','09:50:00',5.02),('8348','2014-03-30','09:55:00',5.06),('8348','2014-03-30','10:00:00',5.06),('8348','2014-03-30','10:05:00',5.13),('8348','2014-03-30','10:10:00',5.1),('8348','2014-03-30','10:15:00',4.97),('8348','2014-03-30','10:20:00',4.84),('8348','2014-03-30','10:25:00',5.06),('8348','2014-03-30','10:30:00',5.42),('8348','2014-03-30','10:35:00',5.6),('8348','2014-03-30','10:40:00',5.87),('8348','2014-03-30','10:45:00',6.01),('8348','2014-03-30','10:50:00',6.08),('8348','2014-03-30','10:55:00',6.29),('8348','2014-03-30','11:00:00',6.37),('8348','2014-03-30','11:05:00',6.62),('8348','2014-03-30','11:10:00',6.69),('8348','2014-03-30','11:15:00',6.9),('8348','2014-03-30','11:20:00',6.72),('8348','2014-03-30','11:25:00',6.72),('8348','2014-03-30','11:30:00',6.57),('8348','2014-03-30','11:35:00',6.28),('8348','2014-03-30','11:40:00',6.6),('8348','2014-03-30','11:45:00',6.51),('8348','2014-03-30','11:50:00',6.61),('8348','2014-03-30','11:55:00',6.7),('8348','2014-03-30','12:00:00',6.82),('8348','2014-03-30','12:05:00',6.99),('8348','2014-03-30','12:10:00',6.94),('8348','2014-03-30','12:15:00',6.84),('8348','2014-03-30','12:20:00',6.92),('8348','2014-03-30','12:25:00',6.96),('8348','2014-03-30','12:30:00',7.03),('8348','2014-03-30','12:35:00',6.99),('8348','2014-03-30','12:40:00',7.02),('8348','2014-03-30','12:45:00',7.17),('8348','2014-03-30','12:50:00',7.19),('8348','2014-03-30','12:55:00',7.02),('8348','2014-03-30','13:00:00',6.95),('8348','2014-03-30','13:05:00',7.01),('8348','2014-03-30','13:10:00',6.9),('8348','2014-03-30','13:15:00',6.7),('8348','2014-03-30','13:20:00',6.9),('8348','2014-03-30','13:25:00',7.08),('8348','2014-03-30','13:30:00',7.14),('8348','2014-03-30','13:35:00',6.48),('8348','2014-03-30','13:40:00',5.81),('8348','2014-03-30','13:45:00',5.76),('8348','2014-03-30','13:50:00',5.3),('8348','2014-03-30','13:55:00',3.67),('8348','2014-03-30','14:00:00',2.77),('8348','2014-03-30','14:05:00',3.27),('8348','2014-03-30','14:10:00',3.87),('8348','2014-03-30','14:15:00',3.33),('8348','2014-03-30','14:20:00',5.02),('8348','2014-03-30','14:25:00',5.51),('8348','2014-03-30','14:30:00',5.86),('8348','2014-03-30','14:35:00',5.89),('8348','2014-03-30','14:40:00',5.76),('8348','2014-03-30','14:45:00',5.91),('8348','2014-03-30','14:50:00',5.83),('8348','2014-03-30','14:55:00',5.57),('8348','2014-03-30','15:00:00',4.93),('8348','2014-03-30','15:05:00',4.56),('8348','2014-03-30','15:10:00',4.72),('8348','2014-03-30','15:15:00',4.75),('8348','2014-03-30','15:20:00',5.09),('8348','2014-03-30','15:25:00',5.21),('8348','2014-03-30','15:30:00',4.95),('8348','2014-03-30','15:35:00',5.12),('8348','2014-03-30','15:40:00',4.68),('8348','2014-03-30','15:45:00',4.45),('8348','2014-03-30','15:50:00',3.94),('8348','2014-03-30','15:55:00',3.58),('8348','2014-03-30','16:00:00',3.7),('8348','2014-03-30','16:05:00',4.07),('8348','2014-03-30','16:10:00',4.12),('8348','2014-03-30','16:15:00',4.06),('8348','2014-03-30','16:20:00',3.81),('8348','2014-03-30','16:25:00',3.43),('8348','2014-03-30','16:30:00',3.39),('8348','2014-03-30','16:35:00',3.28),('8348','2014-03-30','16:40:00',2.93),('8348','2014-03-30','16:45:00',2.93),('8348','2014-03-30','16:50:00',2.64),('8348','2014-03-30','16:55:00',2.04),('8348','2014-03-30','17:00:00',1.56),('8348','2014-03-30','17:05:00',1.67),('8348','2014-03-30','17:10:00',1.55),('8348','2014-03-30','17:15:00',1.57),('8348','2014-03-30','17:20:00',1.17),('8348','2013-05-01','08:20:00',1.07),('8348','2013-05-01','08:25:00',1.12),('8348','2013-05-01','08:30:00',1.19),('8348','2013-05-01','08:35:00',1.25),('8348','2013-05-01','08:40:00',1.33),('8348','2013-05-01','08:45:00',1.44),('8348','2013-05-01','08:50:00',1.53),('8348','2013-05-01','08:55:00',1.6),('8348','2013-05-01','09:00:00',1.68),('8348','2013-05-01','09:05:00',1.75),('8348','2013-05-01','09:10:00',1.81),('8348','2013-05-01','09:15:00',1.86),('8348','2013-05-01','09:20:00',1.9),('8348','2013-05-01','09:25:00',1.95),('8348','2013-05-01','09:30:00',1.98),('8348','2013-05-01','09:35:00',2.05),('8348','2013-05-01','09:40:00',2.11),('8348','2013-05-01','09:45:00',2.18),('8348','2013-05-01','09:50:00',2.23),('8348','2013-05-01','09:55:00',2.28),('8348','2013-05-01','10:00:00',2.32),('8348','2013-05-01','10:05:00',2.34),('8348','2013-05-01','10:10:00',2.43),('8348','2013-05-01','10:15:00',2.49),('8348','2013-05-01','10:20:00',2.54),('8348','2013-05-01','10:25:00',2.59),('8348','2013-05-01','10:30:00',2.65),('8348','2013-05-01','10:35:00',2.68),('8348','2013-05-01','10:40:00',2.85),('8348','2013-05-01','10:45:00',2.92),('8348','2013-05-01','10:50:00',2.96),('8348','2013-05-01','10:55:00',2.95),('8348','2013-05-01','11:00:00',3.01),('8348','2013-05-01','11:05:00',3.06),('8348','2013-05-01','11:10:00',3.09),('8348','2013-05-01','11:15:00',2.88),('8348','2013-05-01','11:20:00',2.95),('8348','2013-05-01','11:25:00',2.94),('8348','2013-05-01','11:30:00',2.86),('8348','2013-05-01','11:35:00',2.93),('8348','2013-05-01','11:40:00',2.3),('8348','2013-05-01','11:45:00',2.18),('8348','2013-05-01','11:50:00',2.79),('8348','2013-05-01','11:55:00',3.35),('8348','2013-05-01','12:00:00',3.32),('8348','2013-05-01','12:05:00',3.28),('8348','2013-05-01','12:10:00',3.29),('8348','2013-05-01','12:15:00',3.26),('8348','2013-05-01','12:20:00',3.28),('8348','2013-05-01','12:25:00',3.36),('8348','2013-05-01','12:30:00',3.39),('8348','2013-05-01','12:35:00',3.45),('8348','2013-05-01','12:40:00',3.58),('8348','2013-05-01','12:45:00',3.24),('8348','2013-05-01','12:50:00',2.49),('8348','2013-05-01','12:55:00',1.38),('8348','2013-05-01','13:00:00',1.38),('8348','2013-05-01','13:05:00',1.65),('8348','2013-05-01','13:10:00',1.94),('8348','2013-05-01','13:15:00',3.28),('8348','2013-05-01','13:20:00',4.15),('8348','2013-05-01','13:25:00',3.39),('8348','2013-05-01','13:30:00',2.77),('8348','2013-05-01','13:35:00',3.14),('8348','2013-05-01','13:40:00',3.82),('8348','2013-05-01','13:45:00',3.9),('8348','2013-05-01','13:50:00',3.69),('8348','2013-05-01','13:55:00',3.56),('8348','2013-05-01','14:00:00',3.47),('8348','2013-05-01','14:05:00',3.45),('8348','2013-05-01','14:10:00',3.48),('8348','2013-05-01','14:15:00',3.08),('8348','2013-05-01','14:20:00',3.66),('8348','2013-05-01','14:25:00',3.66),('8348','2013-05-01','14:30:00',3.69),('8348','2013-05-01','14:35:00',3.55),('8348','2013-05-01','14:40:00',3.21),('8348','2013-05-01','14:45:00',3.29),('8348','2013-05-01','14:50:00',2.96),('8348','2013-05-01','14:55:00',2.68),('8348','2013-05-01','15:00:00',2.75),('8348','2013-05-01','15:05:00',3.24),('8348','2013-05-01','15:10:00',3.27),('8348','2013-05-01','15:15:00',3.11),('8348','2013-05-01','15:20:00',3.02),('8348','2013-05-01','15:25:00',2.98),('8348','2013-05-01','15:30:00',2.5),('8348','2013-05-01','15:35:00',2.2),('8348','2013-05-01','15:40:00',2.2),('8348','2013-05-01','15:45:00',2.15),('8348','2013-05-01','15:50:00',1.63),('8348','2013-05-01','15:55:00',1.59),('8348','2013-05-01','16:00:00',1.9),('8348','2013-05-01','16:05:00',1.84),('8348','2013-05-01','16:10:00',1.67),('8348','2013-05-01','16:15:00',1.54),('8348','2013-05-01','16:20:00',1.37),('8348','2013-05-01','16:25:00',1.06),('8348','2013-05-01','16:35:00',1.02),('8348','2013-05-01','16:40:00',1.1),('8348','2013-05-01','16:45:00',1.03),('8348','2013-04-30','08:55:00',1.39),('8348','2013-04-30','09:00:00',1.48),('8348','2013-04-30','09:05:00',1.29),('8348','2013-04-30','09:10:00',1.77),('8348','2013-04-30','09:15:00',2.12),('8348','2013-04-30','09:20:00',2.17),('8348','2013-04-30','09:25:00',2.33),('8348','2013-04-30','09:30:00',2.26),('8348','2013-04-30','09:35:00',1.88),('8348','2013-04-30','09:40:00',1.33),('8348','2013-04-30','09:45:00',1.75),('8348','2013-04-30','09:50:00',2.16),('8348','2013-04-30','09:55:00',2.42),('8348','2013-04-30','10:00:00',2.76),('8348','2013-04-30','10:05:00',2.77),('8348','2013-04-30','10:10:00',2.24),('8348','2013-04-30','10:15:00',1.93),('8348','2013-04-30','10:20:00',1.82),('8348','2013-04-30','10:25:00',2.6),('8348','2013-04-30','10:30:00',1.92),('8348','2013-04-30','10:35:00',1.68),('8348','2013-04-30','10:40:00',1.52),('8348','2013-04-30','10:45:00',1.22),('8348','2013-04-30','10:50:00',1.31),('8348','2013-04-30','10:55:00',1.42),('8348','2013-04-30','11:00:00',1.47),('8348','2013-04-30','11:05:00',1.65),('8348','2013-04-30','11:10:00',1.67),('8348','2013-04-30','11:15:00',1.74),('8348','2013-04-30','11:20:00',2.02),('8348','2013-04-30','11:25:00',1.83),('8348','2013-04-30','11:30:00',1.83),('8348','2013-04-30','11:35:00',1.95),('8348','2013-04-30','11:40:00',1.83),('8348','2013-04-30','11:45:00',1.5),('8348','2013-04-30','11:50:00',1.51),('8348','2013-04-30','11:55:00',1.56),('8348','2013-04-30','12:00:00',1.59),('8348','2013-04-30','12:05:00',1.64),('8348','2013-04-30','12:10:00',1.58),('8348','2013-04-30','12:15:00',1.45),('8348','2013-04-30','12:20:00',1.33),('8348','2013-04-30','12:25:00',1.24),('8348','2013-04-30','12:30:00',1.26),('8348','2013-04-30','12:35:00',2.2),('8348','2013-04-30','12:40:00',3.8),('8348','2013-04-30','12:45:00',3.94),('8348','2013-04-30','12:50:00',3.75),('8348','2013-04-30','12:55:00',3.34),('8348','2013-04-30','13:00:00',3.59),('8348','2013-04-30','13:05:00',3.52),('8348','2013-04-30','13:10:00',3.53),('8348','2013-04-30','13:15:00',3.5),('8348','2013-04-30','13:20:00',3.47),('8348','2013-04-30','13:25:00',3.45),('8348','2013-04-30','13:30:00',3.47),('8348','2013-04-30','13:35:00',3.45),('8348','2013-04-30','13:40:00',3.43),('8348','2013-04-30','13:45:00',3.39),('8348','2013-04-30','13:50:00',3.36),('8348','2013-04-30','13:55:00',3.35),('8348','2013-04-30','14:00:00',3.32),('8348','2013-04-30','14:05:00',3.32),('8348','2013-04-30','14:10:00',3.3),('8348','2013-04-30','14:15:00',3.28),('8348','2013-04-30','14:20:00',3.25),('8348','2013-04-30','14:25:00',3.27),('8348','2013-04-30','14:30:00',3.25),('8348','2013-04-30','14:35:00',3.23),('8348','2013-04-30','14:40:00',3.21),('8348','2013-04-30','14:45:00',3.18),('8348','2013-04-30','14:50:00',3.14),('8348','2013-04-30','14:55:00',3.1),('8348','2013-04-30','15:00:00',3.07),('8348','2013-04-30','15:05:00',3.01),('8348','2013-04-30','15:10:00',2.97),('8348','2013-04-30','15:15:00',2.95),('8348','2013-04-30','15:20:00',2.94),('8348','2013-04-30','15:25:00',2.9),('8348','2013-04-30','15:30:00',2.92),('8348','2013-04-30','15:35:00',2.91),('8348','2013-04-30','15:40:00',2.87),('8348','2013-04-30','15:45:00',2.83),('8348','2013-04-30','15:50:00',2.78),('8348','2013-04-30','15:55:00',2.73),('8348','2013-04-30','16:00:00',2.69),('8348','2013-04-30','16:05:00',2.65),('8348','2013-04-30','16:10:00',2.59),('8348','2013-04-30','16:15:00',2.54),('8348','2013-04-30','16:20:00',2.49),('8348','2013-04-30','16:25:00',2.44),('8348','2013-04-30','16:30:00',2.39),('8348','2013-04-30','16:35:00',2.29),('8348','2013-04-30','16:40:00',1.91),('8348','2013-04-30','16:45:00',2.14),('8348','2013-04-30','16:50:00',1.72),('8348','2013-04-30','16:55:00',1.89),('8348','2013-04-30','17:00:00',1.96),('8348','2013-04-30','17:05:00',1.91),('8348','2013-04-30','17:10:00',1.66),('8348','2013-04-30','17:20:00',1.44),('8348','2013-04-30','17:25:00',1.62),('8348','2013-04-30','17:30:00',1.56),('8348','2013-04-30','17:35:00',1.52),('8348','2013-04-30','17:40:00',1.45),('8348','2013-04-30','17:45:00',1.38),('8348','2013-04-30','17:50:00',1.29),('8348','2013-04-30','17:55:00',1.21),('8348','2013-04-30','18:00:00',1.15),('8348','2013-04-30','18:05:00',1.07),('8348','2013-04-30','18:10:00',1.01),('8348','2013-04-29','08:05:00',1.01),('8348','2013-04-29','08:15:00',1.01),('8348','2013-04-29','08:20:00',1.1),('8348','2013-04-29','08:25:00',1.24),('8348','2013-04-29','08:30:00',1.4),('8348','2013-04-29','08:35:00',1.54),('8348','2013-04-29','08:40:00',1.59),('8348','2013-04-29','08:45:00',1.59),('8348','2013-04-29','08:50:00',1.71),('8348','2013-04-29','08:55:00',1.69),('8348','2013-04-29','09:00:00',1.38),('8348','2013-04-29','09:05:00',1.83),('8348','2013-04-29','09:10:00',2.02),('8348','2013-04-29','09:15:00',2.12),('8348','2013-04-29','09:20:00',2.01),('8348','2013-04-29','09:25:00',1.96),('8348','2013-04-29','09:30:00',1.98),('8348','2013-04-29','09:35:00',2.11),('8348','2013-04-29','09:40:00',2.13),('8348','2013-04-29','09:45:00',2.19),('8348','2013-04-29','09:50:00',2.34),('8348','2013-04-29','09:55:00',2.2),('8348','2013-04-29','10:00:00',2.29),('8348','2013-04-29','10:05:00',2.32),('8348','2013-04-29','10:10:00',2.28),('8348','2013-04-29','10:15:00',1.86),('8348','2013-04-29','10:20:00',1.93),('8348','2013-04-29','10:25:00',2.29),('8348','2013-04-29','10:30:00',2.41),('8348','2013-04-29','10:35:00',2.72),('8348','2013-04-29','10:40:00',2.73),('8348','2013-04-29','10:45:00',2.78),('8348','2013-04-29','10:50:00',2.69),('8348','2013-04-29','10:55:00',2.51),('8348','2013-04-29','11:00:00',2.84),('8348','2013-04-29','11:05:00',2.67),('8348','2013-04-29','11:10:00',2.61),('8348','2013-04-29','11:15:00',2.48),('8348','2013-04-29','11:20:00',2.94),('8348','2013-04-29','11:25:00',3),('8348','2013-04-29','11:30:00',3.13),('8348','2013-04-29','11:35:00',2.96),('8348','2013-04-29','11:40:00',3.07),('8348','2013-04-29','11:45:00',2.89),('8348','2013-04-29','11:50:00',3.29),('8348','2013-04-29','11:55:00',3.23),('8348','2013-04-29','12:00:00',3.32),('8348','2013-04-29','12:05:00',3.29),('8348','2013-04-29','12:10:00',3.21),('8348','2013-04-29','12:15:00',3.28),('8348','2013-04-29','12:20:00',3.29),('8348','2013-04-29','12:25:00',3.2),('8348','2013-04-29','12:30:00',3.3),('8348','2013-04-29','12:35:00',3.37),('8348','2013-04-29','12:40:00',3.43),('8348','2013-04-29','12:45:00',3.45),('8348','2013-04-29','12:50:00',3.41),('8348','2013-04-29','12:55:00',3.39),('8348','2013-04-29','13:00:00',3.49),('8348','2013-04-29','13:05:00',3.42),('8348','2013-04-29','13:10:00',3.35),('8348','2013-04-29','13:15:00',3),('8348','2013-04-29','13:20:00',3.42),('8348','2013-04-29','13:25:00',3.6),('8348','2013-04-29','13:30:00',3.51),('8348','2013-04-29','13:35:00',3.37),('8348','2013-04-29','13:40:00',3.5),('8348','2013-04-29','13:45:00',3.43),('8348','2013-04-29','13:50:00',3.29),('8348','2013-04-29','13:55:00',3.74),('8348','2013-04-29','14:00:00',3.45),('8348','2013-04-29','14:05:00',3.35),('8348','2013-04-29','14:10:00',3.47),('8348','2013-04-29','14:15:00',3.56),('8348','2013-04-29','14:20:00',3.59),('8348','2013-04-29','14:25:00',3.43),('8348','2013-04-29','14:30:00',3.28),('8348','2013-04-29','14:35:00',3.25),('8348','2013-04-29','14:40:00',3.07),('8348','2013-04-29','14:45:00',3.28),('8348','2013-04-29','14:50:00',3.27),('8348','2013-04-29','14:55:00',3.28),('8348','2013-04-29','15:00:00',3.19),('8348','2013-04-29','15:05:00',3.29),('8348','2013-04-29','15:10:00',2.92),('8348','2013-04-29','15:15:00',2.94),('8348','2013-04-29','15:20:00',3.11),('8348','2013-04-29','15:25:00',3.24),('8348','2013-04-29','15:30:00',3.15),('8348','2013-04-29','15:35:00',2.78),('8348','2013-04-29','15:40:00',2.55),('8348','2013-04-29','15:45:00',2.49),('8348','2013-04-29','15:50:00',2.57),('8348','2013-04-29','15:55:00',2.71),('8348','2013-04-29','16:00:00',2.66),('8348','2013-04-29','16:05:00',2.86),('8348','2013-04-29','16:10:00',2.74),('8348','2013-04-29','16:15:00',3.18),('8348','2013-04-29','16:20:00',3.02),('8348','2013-04-29','16:25:00',2.36),('8348','2013-04-29','16:30:00',2.46),('8348','2013-04-29','16:35:00',2.47),('8348','2013-04-29','16:40:00',2.64),('8348','2013-04-29','16:45:00',2.66),('8348','2013-04-29','16:50:00',2.69),('8348','2013-04-29','16:55:00',2.8),('8348','2013-04-29','17:00:00',2.59),('8348','2013-04-29','17:05:00',2.24),('8348','2013-04-29','17:10:00',2.32),('8348','2013-04-29','17:15:00',1.99),('8348','2013-04-29','17:20:00',1.61),('8348','2013-04-29','17:25:00',1.59),('8348','2013-04-29','17:30:00',1.51),('8348','2013-04-29','17:35:00',1.42),('8348','2013-04-29','17:40:00',1.2),('8348','2013-04-29','17:45:00',1.08),('8348','2013-04-29','17:50:00',1.37),('8348','2013-04-29','17:55:00',1.58),('8348','2013-04-29','18:00:00',1.55),('8348','2013-04-29','18:05:00',1.74),('8348','2013-04-29','18:10:00',1.58),('8348','2013-04-29','18:15:00',1.51),('8348','2013-04-29','18:20:00',1.28),('8348','2013-04-29','18:25:00',1.28),('8348','2013-04-29','18:30:00',1.18),('8348','2013-04-28','08:15:00',1.04),('8348','2013-04-28','08:20:00',1.13),('8348','2013-04-28','08:25:00',1.2),('8348','2013-04-28','08:30:00',1.26),('8348','2013-04-28','08:35:00',1.37),('8348','2013-04-28','08:40:00',1.42),('8348','2013-04-28','08:45:00',1.51),('8348','2013-04-28','08:50:00',1.62),('8348','2013-04-28','08:55:00',1.69),('8348','2013-04-28','09:00:00',1.76),('8348','2013-04-28','09:05:00',1.83),('8348','2013-04-28','09:10:00',1.9),('8348','2013-04-28','09:15:00',1.98),('8348','2013-04-28','09:20:00',2.04),('8348','2013-04-28','09:25:00',2.11),('8348','2013-04-28','09:30:00',2.17),('8348','2013-04-28','09:35:00',2.22),('8348','2013-04-28','09:40:00',2.29),('8348','2013-04-28','09:45:00',2.36),('8348','2013-04-28','09:50:00',2.42),('8348','2013-04-28','09:55:00',2.48),('8348','2013-04-28','10:00:00',2.52),('8348','2013-04-28','10:05:00',2.56),('8348','2013-04-28','10:10:00',2.63),('8348','2013-04-28','10:15:00',2.63),('8348','2013-04-28','10:20:00',2.71),('8348','2013-04-28','10:25:00',2.81),('8348','2013-04-28','10:30:00',2.76),('8348','2013-04-28','10:35:00',2.86),('8348','2013-04-28','10:40:00',2.66),('8348','2013-04-28','10:45:00',2.99),('8348','2013-04-28','10:50:00',3.01),('8348','2013-04-28','10:55:00',3.03),('8348','2013-04-28','11:00:00',3.06),('8348','2013-04-28','11:05:00',3.09),('8348','2013-04-28','11:10:00',3.13),('8348','2013-04-28','11:15:00',3.21),('8348','2013-04-28','11:20:00',3.22),('8348','2013-04-28','11:25:00',3.28),('8348','2013-04-28','11:30:00',3.28),('8348','2013-04-28','11:35:00',3.21),('8348','2013-04-28','11:40:00',3.25),('8348','2013-04-28','11:45:00',3.19),('8348','2013-04-28','11:50:00',3.18),('8348','2013-04-28','11:55:00',3.34),('8348','2013-04-28','12:00:00',2.95),('8348','2013-04-28','12:05:00',2.9),('8348','2013-04-28','12:10:00',3.19),('8348','2013-04-28','12:15:00',3.32),('8348','2013-04-28','12:20:00',3.29),('8348','2013-04-28','12:25:00',3),('8348','2013-04-28','12:30:00',2.86),('8348','2013-04-28','12:35:00',2.7),('8348','2013-04-28','12:40:00',2.68),('8348','2013-04-28','12:45:00',3.58),('8348','2013-04-28','12:50:00',3.5),('8348','2013-04-28','12:55:00',3.3),('8348','2013-04-28','13:00:00',3.37),('8348','2013-04-28','13:05:00',3.6),('8348','2013-04-28','13:10:00',3.55),('8348','2013-04-28','13:15:00',3.29),('8348','2013-04-28','13:20:00',3.39),('8348','2013-04-28','13:25:00',3.31),('8348','2013-04-28','13:30:00',3.56),('8348','2013-04-28','13:35:00',3.57),('8348','2013-04-28','13:40:00',3.7),('8348','2013-04-28','13:45:00',2.6),('8348','2013-04-28','13:50:00',1.55),('8348','2013-04-28','13:55:00',1.62),('8348','2013-04-28','14:00:00',2.77),('8348','2013-04-28','14:05:00',3.69),('8348','2013-04-28','14:10:00',3.52),('8348','2013-04-28','14:15:00',3.57),('8348','2013-04-28','14:20:00',3.05),('8348','2013-04-28','14:25:00',3.52),('8348','2013-04-28','14:30:00',3.44),('8348','2013-04-28','14:35:00',3.42),('8348','2013-04-28','14:40:00',3.39),('8348','2013-04-28','14:45:00',3.37),('8348','2013-04-28','14:50:00',3.33),('8348','2013-04-28','14:55:00',3.32),('8348','2013-04-28','15:00:00',3.28),('8348','2013-04-28','15:05:00',3.26),('8348','2013-04-28','15:10:00',3.26),('8348','2013-04-28','15:15:00',3.22),('8348','2013-04-28','15:20:00',3.19),('8348','2013-04-28','15:25:00',3.14),('8348','2013-04-28','15:30:00',3.11),('8348','2013-04-28','15:35:00',3.07),('8348','2013-04-28','15:40:00',3.03),('8348','2013-04-28','15:45:00',3),('8348','2013-04-28','15:50:00',2.96),('8348','2013-04-28','15:55:00',2.93),('8348','2013-04-28','16:00:00',2.88),('8348','2013-04-28','16:05:00',2.84),('8348','2013-04-28','16:10:00',2.81),('8348','2013-04-28','16:15:00',2.75),('8348','2013-04-28','16:20:00',2.69),('8348','2013-04-28','16:25:00',2.63),('8348','2013-04-28','16:30:00',2.59),('8348','2013-04-28','16:35:00',2.54),('8348','2013-04-28','16:40:00',2.48),('8348','2013-04-28','16:45:00',2.42),('8348','2013-04-28','16:50:00',2.38),('8348','2013-04-28','16:55:00',2.31),('8348','2013-04-28','17:00:00',2.25),('8348','2013-04-28','17:05:00',2.1),('8348','2013-04-28','17:10:00',2.01),('8348','2013-04-28','17:15:00',2.08),('8348','2013-04-28','17:20:00',1.99),('8348','2013-04-28','17:25:00',1.95),('8348','2013-04-28','17:30:00',1.67),('8348','2013-04-28','17:35:00',1.67),('8348','2013-04-28','17:40:00',1.57),('8348','2013-04-28','17:45:00',1.62),('8348','2013-04-28','17:50:00',1.54),('8348','2013-04-28','17:55:00',1.35),('8348','2013-04-28','18:00:00',1.34),('8348','2013-04-28','18:05:00',1.28),('8348','2013-04-28','18:20:00',1.11),('8348','2013-04-28','18:25:00',1.05),('8348','2013-04-27','12:55:00',1.22),('8348','2013-04-27','13:00:00',1.35),('8348','2013-04-27','13:05:00',1.03),('8348','2013-04-27','13:10:00',1.11),('8348','2013-04-27','13:15:00',1.4),('8348','2013-04-27','13:20:00',1.48),('8348','2013-04-27','13:25:00',1.09),('8348','2013-04-27','13:30:00',1.11),('8348','2013-04-27','13:35:00',1.37),('8348','2013-04-27','13:40:00',1.57),('8348','2013-04-27','13:45:00',1.05),('8348','2013-04-27','13:50:00',1.01),('8348','2013-04-27','14:25:00',1.09),('8348','2013-04-27','14:30:00',1.97),('8348','2013-04-27','14:35:00',1.9),('8348','2013-04-27','14:40:00',1.2),('8348','2013-04-27','14:45:00',1.11),('8348','2013-04-27','15:05:00',1.35),('8348','2013-04-27','15:10:00',1.15),('8348','2013-04-27','16:45:00',1.15),('8348','2013-04-27','16:50:00',2),('8348','2013-04-27','16:55:00',1.8),('8348','2013-04-27','17:00:00',2.32),('8348','2013-04-27','17:05:00',1.67),('8348','2013-04-27','17:40:00',1.02),('8348','2013-04-26','08:20:00',1.04),('8348','2013-04-26','08:25:00',1.1),('8348','2013-04-26','08:30:00',1.16),('8348','2013-04-26','08:35:00',1.25),('8348','2013-04-26','08:40:00',1.28),('8348','2013-04-26','08:45:00',1.37),('8348','2013-04-26','08:50:00',1.28),('8348','2013-04-26','08:55:00',1.18),('8348','2013-04-26','09:00:00',1.01),('8348','2013-04-26','09:05:00',1.46),('8348','2013-04-26','09:10:00',1.62),('8348','2013-04-26','09:15:00',1.03),('8348','2013-04-26','09:20:00',1.01),('8348','2013-04-26','09:25:00',1.24),('8348','2013-04-26','09:30:00',1.79),('8348','2013-04-26','09:35:00',1.54),('8348','2013-04-26','09:40:00',1.58),('8348','2013-04-26','09:45:00',2.18),('8348','2013-04-26','09:50:00',1.98),('8348','2013-04-26','09:55:00',1.49),('8348','2013-04-26','10:00:00',1.89),('8348','2013-04-26','10:05:00',2.31),('8348','2013-04-26','10:10:00',2.41),('8348','2013-04-26','10:15:00',2.65),('8348','2013-04-26','10:20:00',2.62),('8348','2013-04-26','10:25:00',2.45),('8348','2013-04-26','10:30:00',2.72),('8348','2013-04-26','10:35:00',2.87),('8348','2013-04-26','10:40:00',2.83),('8348','2013-04-26','10:45:00',2.74),('8348','2013-04-26','10:50:00',2.17),('8348','2013-04-26','10:55:00',1.58),('8348','2013-04-26','11:00:00',2.78),('8348','2013-04-26','11:05:00',2.83),('8348','2013-04-26','11:10:00',2.69),('8348','2013-04-26','11:15:00',2.83),('8348','2013-04-26','11:20:00',2.08),('8348','2013-04-26','11:25:00',2.49),('8348','2013-04-26','11:30:00',2.66),('8348','2013-04-26','11:35:00',2.96),('8348','2013-04-26','11:40:00',2.8),('8348','2013-04-26','11:45:00',2.58),('8348','2013-04-26','11:50:00',2.36),('8348','2013-04-26','11:55:00',2.2),('8348','2013-04-26','12:00:00',2.51),('8348','2013-04-26','12:05:00',2.44),('8348','2013-04-26','12:10:00',2.11),('8348','2013-04-26','12:15:00',2.39),('8348','2013-04-26','12:20:00',2.38),('8348','2013-04-26','12:25:00',1.67),('8348','2013-04-26','12:30:00',1.61),('8348','2013-04-26','12:35:00',2.07),('8348','2013-04-26','12:40:00',2.89),('8348','2013-04-26','12:45:00',2.96),('8348','2013-04-26','12:50:00',1.96),('8348','2013-04-26','12:55:00',1.8),('8348','2013-04-26','13:00:00',1.26),('8348','2013-04-26','13:05:00',1.2),('8348','2013-04-26','13:10:00',1.46),('8348','2013-04-26','13:15:00',2.29),('8348','2013-04-26','13:20:00',1.63),('8348','2013-04-26','13:25:00',1.9),('8348','2013-04-26','13:30:00',2.62),('8348','2013-04-26','13:35:00',2.16),('8348','2013-04-26','13:40:00',2.43),('8348','2013-04-26','13:45:00',1.96),('8348','2013-04-26','13:50:00',3.17),('8348','2013-04-26','13:55:00',2.32),('8348','2013-04-26','14:00:00',2.67),('8348','2013-04-26','14:05:00',3.51),('8348','2013-04-26','14:10:00',2.83),('8348','2013-04-26','14:15:00',2.91),('8348','2013-04-26','14:20:00',3.2),('8348','2013-04-26','14:25:00',3.62),('8348','2013-04-26','14:30:00',3.53),('8348','2013-04-26','14:35:00',2.48),('8348','2013-04-26','14:40:00',1.64),('8348','2013-04-26','14:45:00',1.41),('8348','2013-04-26','14:50:00',3.46),('8348','2013-04-26','14:55:00',3.7),('8348','2013-04-26','15:00:00',3.46),('8348','2013-04-26','15:05:00',2.4),('8348','2013-04-26','15:10:00',1.35),('8348','2013-04-26','15:15:00',2.01),('8348','2013-04-26','15:20:00',1.36),('8348','2013-04-26','15:25:00',1.44),('8348','2013-04-26','15:30:00',1.96),('8348','2013-04-26','15:35:00',1.74),('8348','2013-04-26','15:40:00',1.77),('8348','2013-04-26','15:45:00',2.22),('8348','2013-04-26','15:50:00',1.67),('8348','2013-04-26','15:55:00',1),('8348','2013-04-25','08:15:00',1.1),('8348','2013-04-25','08:45:00',1.15),('8348','2013-04-25','08:50:00',1.68),('8348','2013-04-25','08:55:00',1.93),('8348','2013-04-25','09:00:00',1.59),('8348','2013-04-25','09:05:00',1.19),('8348','2013-04-25','09:10:00',1.13),('8348','2013-04-25','09:15:00',1.05),('8348','2013-04-25','09:20:00',1.12),('8348','2013-04-25','09:25:00',1.25),('8348','2013-04-25','09:30:00',1.18),('8348','2013-04-25','09:35:00',1.34),('8348','2013-04-25','09:40:00',1.85),('8348','2013-04-25','09:45:00',2.23),('8348','2013-04-25','09:50:00',2.5),('8348','2013-04-25','09:55:00',2.54),('8348','2013-04-25','10:00:00',2.54),('8348','2013-04-25','10:05:00',2.37),('8348','2013-04-25','10:10:00',2.18),('8348','2013-04-25','10:15:00',2.36),('8348','2013-04-25','10:20:00',2.66),('8348','2013-04-25','10:25:00',2.76),('8348','2013-04-25','10:30:00',2.85),('8348','2013-04-25','10:35:00',2.88),('8348','2013-04-25','10:40:00',2.89),('8348','2013-04-25','10:45:00',2.79),('8348','2013-04-25','10:50:00',3),('8348','2013-04-25','10:55:00',3),('8348','2013-04-25','11:00:00',3.1),('8348','2013-04-25','11:05:00',3.14),('8348','2013-04-25','11:10:00',3.16),('8348','2013-04-25','11:15:00',3.18),('8348','2013-04-25','11:20:00',3.22),('8348','2013-04-25','11:25:00',3.25),('8348','2013-04-25','11:30:00',3.27),('8348','2013-04-25','11:35:00',3.32),('8348','2013-04-25','11:40:00',3.35),('8348','2013-04-25','11:45:00',3.4),('8348','2013-04-25','11:50:00',3.44),('8348','2013-04-25','11:55:00',3.41),('8348','2013-04-25','12:00:00',3.35),('8348','2013-04-25','12:05:00',3.36),('8348','2013-04-25','12:10:00',3.43),('8348','2013-04-25','12:15:00',3.46),('8348','2013-04-25','12:20:00',3.48),('8348','2013-04-25','12:25:00',3.47),('8348','2013-04-25','12:30:00',3.48),('8348','2013-04-25','12:35:00',3.49),('8348','2013-04-25','12:40:00',3.49),('8348','2013-04-25','12:45:00',3.5),('8348','2013-04-25','12:50:00',3.49),('8348','2013-04-25','12:55:00',3.53),('8348','2013-04-25','13:00:00',3.56),('8348','2013-04-25','13:05:00',3.64),('8348','2013-04-25','13:10:00',3.28),('8348','2013-04-25','13:15:00',3.52),('8348','2013-04-25','13:20:00',3.45),('8348','2013-04-25','13:25:00',3.33),('8348','2013-04-25','13:30:00',2.51),('8348','2013-04-25','13:35:00',2.35),('8348','2013-04-25','13:40:00',2.1),('8348','2013-04-25','13:45:00',1.97),('8348','2013-04-25','13:50:00',1.86),('8348','2013-04-25','13:55:00',1.98),('8348','2013-04-25','14:00:00',2.05),('8348','2013-04-25','14:05:00',1.93),('8348','2013-04-25','14:10:00',2.08),('8348','2013-04-25','14:15:00',2.26),('8348','2013-04-25','14:20:00',2.32),('8348','2013-04-25','14:25:00',2.41),('8348','2013-04-25','14:30:00',2.83),('8348','2013-04-25','14:35:00',3.25),('8348','2013-04-25','14:40:00',3.03),('8348','2013-04-25','14:45:00',3.08),('8348','2013-04-25','14:50:00',2.84),('8348','2013-04-25','14:55:00',2.97),('8348','2013-04-25','15:00:00',2.83),('8348','2013-04-25','15:05:00',2.6),('8348','2013-04-25','15:10:00',2.56),('8348','2013-04-25','15:15:00',2.93),('8348','2013-04-25','15:20:00',3.13),('8348','2013-04-25','15:25:00',3.16),('8348','2013-04-25','15:30:00',3.09),('8348','2013-04-25','15:35:00',2.95),('8348','2013-04-25','15:40:00',2.73),('8348','2013-04-25','15:45:00',2.65),('8348','2013-04-25','15:50:00',2.51),('8348','2013-04-25','15:55:00',2.42),('8348','2013-04-25','16:00:00',2.45),('8348','2013-04-25','16:05:00',2.11),('8348','2013-04-25','16:10:00',2.09),('8348','2013-04-25','16:15:00',2.06),('8348','2013-04-25','16:20:00',2.19),('8348','2013-04-25','16:25:00',1.95),('8348','2013-04-25','16:30:00',1.85),('8348','2013-04-25','16:35:00',2.3),('8348','2013-04-25','16:40:00',1.95),('8348','2013-04-25','16:45:00',2.08),('8348','2013-04-25','16:50:00',1.75),('8348','2013-04-25','16:55:00',1.77),('8348','2013-04-25','17:00:00',1.76),('8348','2013-04-25','17:05:00',2.06),('8348','2013-04-25','17:10:00',2.22),('8348','2013-04-25','17:15:00',2.07),('8348','2013-04-25','17:20:00',2.07),('8348','2013-04-25','17:25:00',1.72),('8348','2013-04-25','17:30:00',1.44),('8348','2013-04-25','17:35:00',1.33),('8348','2013-04-25','17:40:00',1.37),('8348','2013-04-25','17:45:00',1.18),('8348','2013-04-24','08:15:00',1.04),('8348','2013-04-24','08:20:00',1.09),('8348','2013-04-24','08:25:00',1.18),('8348','2013-04-24','08:30:00',1.2),('8348','2013-04-24','08:35:00',1.18),('8348','2013-04-24','08:40:00',1.22),('8348','2013-04-24','08:45:00',1.32),('8348','2013-04-24','08:50:00',1.38),('8348','2013-04-24','08:55:00',1.52),('8348','2013-04-24','09:00:00',1.69),('8348','2013-04-24','09:05:00',1.88),('8348','2013-04-24','09:10:00',2.01),('8348','2013-04-24','09:15:00',1.81),('8348','2013-04-24','09:20:00',1.61),('8348','2013-04-24','09:25:00',1.96),('8348','2013-04-24','09:30:00',2.18),('8348','2013-04-24','09:35:00',2.4),('8348','2013-04-24','09:40:00',2.26),('8348','2013-04-24','09:45:00',2.2),('8348','2013-04-24','09:50:00',2.34),('8348','2013-04-24','09:55:00',2.65),('8348','2013-04-24','10:00:00',2.67),('8348','2013-04-24','10:05:00',2.73),('8348','2013-04-24','10:10:00',2.77),('8348','2013-04-24','10:15:00',2.75),('8348','2013-04-24','10:20:00',2.74),('8348','2013-04-24','10:25:00',2.72),('8348','2013-04-24','10:30:00',2.69),('8348','2013-04-24','10:35:00',2.67),('8348','2013-04-24','10:40:00',2.98),('8348','2013-04-24','10:45:00',3.05),('8348','2013-04-24','10:50:00',3.09),('8348','2013-04-24','10:55:00',3.16),('8348','2013-04-24','11:00:00',3.19),('8348','2013-04-24','11:05:00',3.13),('8348','2013-04-24','11:10:00',3.36),('8348','2013-04-24','11:15:00',3.43),('8348','2013-04-24','11:20:00',3.51),('8348','2013-04-24','11:25:00',3.59),('8348','2013-04-24','11:30:00',3.35),('8348','2013-04-24','11:35:00',2.96),('8348','2013-04-24','11:40:00',2.4),('8348','2013-04-24','11:45:00',2.32),('8348','2013-04-24','11:50:00',1.77),('8348','2013-04-24','11:55:00',2.39),('8348','2013-04-24','12:00:00',2.98),('8348','2013-04-24','12:05:00',2.14),('8348','2013-04-24','12:10:00',2.56),('8348','2013-04-24','12:15:00',3.36),('8348','2013-04-24','12:20:00',4),('8348','2013-04-24','12:25:00',3.37),('8348','2013-04-24','12:30:00',3.37),('8348','2013-04-24','12:35:00',3.45),('8348','2013-04-24','12:40:00',3.21),('8348','2013-04-24','12:45:00',3.45),('8348','2013-04-24','12:50:00',3.65),('8348','2013-04-24','12:55:00',3.51),('8348','2013-04-24','13:00:00',3.37),('8348','2013-04-24','13:05:00',3.06),('8348','2013-04-24','13:10:00',3.92),('8348','2013-04-24','13:15:00',3.48),('8348','2013-04-24','13:20:00',3.41),('8348','2013-04-24','13:25:00',3.49),('8348','2013-04-24','13:30:00',3.22),('8348','2013-04-24','13:35:00',3.3),('8348','2013-04-24','13:40:00',3.93),('8348','2013-04-24','13:45:00',3.15),('8348','2013-04-24','13:50:00',2.47),('8348','2013-04-24','13:55:00',3.66),('8348','2013-04-24','14:00:00',3.52),('8348','2013-04-24','14:05:00',2.59),('8348','2013-04-24','14:10:00',2.62),('8348','2013-04-24','14:15:00',3.69),('8348','2013-04-24','14:20:00',3.33),('8348','2013-04-24','14:25:00',3.42),('8348','2013-04-24','14:30:00',3.23),('8348','2013-04-24','14:35:00',2.9),('8348','2013-04-24','14:40:00',2.72),('8348','2013-04-24','14:45:00',2.67),('8348','2013-04-24','14:50:00',2.35),('8348','2013-04-24','14:55:00',2.11),('8348','2013-04-24','15:00:00',2.35),('8348','2013-04-24','15:05:00',2.17),('8348','2013-04-24','15:10:00',2.02),('8348','2013-04-24','15:15:00',2.14),('8348','2013-04-24','15:20:00',2.28),('8348','2013-04-24','15:25:00',1.87),('8348','2013-04-24','15:30:00',1.64),('8348','2013-04-24','15:35:00',1.58),('8348','2013-04-24','15:40:00',1.57),('8348','2013-04-24','15:45:00',1.57),('8348','2013-04-24','15:50:00',1.61),('8348','2013-04-24','15:55:00',2.02),('8348','2013-04-24','16:00:00',2.47),('8348','2013-04-24','16:05:00',2.6),('8348','2013-04-24','16:10:00',2.56),('8348','2013-04-24','16:15:00',2.51),('8348','2013-04-24','16:20:00',3.29),('8348','2013-04-24','16:25:00',2.38),('8348','2013-04-24','16:30:00',2.01),('8348','2013-04-24','16:35:00',1.77),('8348','2013-04-24','16:40:00',2.44),('8348','2013-04-24','16:45:00',2.46),('8348','2013-04-24','16:50:00',2.25),('8348','2013-04-24','16:55:00',2.69),('8348','2013-04-24','17:00:00',2.67),('8348','2013-04-24','17:05:00',2.52),('8348','2013-04-24','17:10:00',2.44),('8348','2013-04-24','17:15:00',1.74),('8348','2013-04-24','17:20:00',1.75),('8348','2013-04-24','17:25:00',1.59),('8348','2013-04-24','17:50:00',1.13),('8348','2013-04-24','17:55:00',1.49),('8348','2013-04-24','18:00:00',1.13),('8348','2013-04-24','18:05:00',1.25),('8348','2013-04-23','08:15:00',1.04),('8348','2013-04-23','08:20:00',1.11),('8348','2013-04-23','08:25:00',1.19),('8348','2013-04-23','08:30:00',1.26),('8348','2013-04-23','08:35:00',1.33),('8348','2013-04-23','08:40:00',1.44),('8348','2013-04-23','08:45:00',1.53),('8348','2013-04-23','08:50:00',1.62),('8348','2013-04-23','08:55:00',1.73),('8348','2013-04-23','09:00:00',1.82),('8348','2013-04-23','09:05:00',1.89),('8348','2013-04-23','09:10:00',1.96),('8348','2013-04-23','09:15:00',2.05),('8348','2013-04-23','09:20:00',2.12),('8348','2013-04-23','09:25:00',2.2),('8348','2013-04-23','09:30:00',2.25),('8348','2013-04-23','09:35:00',2.32),('8348','2013-04-23','09:40:00',2.15),('8348','2013-04-23','09:45:00',2.16),('8348','2013-04-23','09:50:00',2.56),('8348','2013-04-23','09:55:00',2.63),('8348','2013-04-23','10:00:00',2.65),('8348','2013-04-23','10:05:00',2.69),('8348','2013-04-23','10:10:00',2.73),('8348','2013-04-23','10:15:00',2.78),('8348','2013-04-23','10:20:00',2.82),('8348','2013-04-23','10:25:00',2.89),('8348','2013-04-23','10:30:00',2.94),('8348','2013-04-23','10:35:00',2.98),('8348','2013-04-23','10:40:00',3.04),('8348','2013-04-23','10:45:00',3.01),('8348','2013-04-23','10:50:00',3.1),('8348','2013-04-23','10:55:00',3.15),('8348','2013-04-23','11:00:00',3.18),('8348','2013-04-23','11:05:00',3.2),('8348','2013-04-23','11:10:00',3.23),('8348','2013-04-23','11:15:00',3.27),('8348','2013-04-23','11:20:00',3.31),('8348','2013-04-23','11:25:00',3.36),('8348','2013-04-23','11:30:00',3.39),('8348','2013-04-23','11:35:00',3.42),('8348','2013-04-23','11:40:00',3.44),('8348','2013-04-23','11:45:00',3.46),('8348','2013-04-23','11:50:00',3.48),('8348','2013-04-23','11:55:00',3.48),('8348','2013-04-23','12:00:00',3.49),('8348','2013-04-23','12:05:00',3.49),('8348','2013-04-23','12:10:00',3.51),('8348','2013-04-23','12:15:00',3.5),('8348','2013-04-23','12:20:00',3.51),('8348','2013-04-23','12:25:00',3.58),('8348','2013-04-23','12:30:00',3.17),('8348','2013-04-23','12:35:00',3.8),('8348','2013-04-23','12:40:00',4.13),('8348','2013-04-23','12:45:00',3.86),('8348','2013-04-23','12:50:00',1.66),('8348','2013-04-23','12:55:00',4.24),('8348','2013-04-23','13:00:00',4.2),('8348','2013-04-23','13:05:00',3.59),('8348','2013-04-23','13:10:00',1.23),('8348','2013-04-23','13:15:00',2.17),('8348','2013-04-23','13:20:00',4.05),('8348','2013-04-23','13:25:00',3.91),('8348','2013-04-23','13:30:00',3.84),('8348','2013-04-23','13:35:00',3.96),('8348','2013-04-23','13:40:00',4),('8348','2013-04-23','13:45:00',2.85),('8348','2013-04-23','13:50:00',3.51),('8348','2013-04-23','13:55:00',3.94),('8348','2013-04-23','14:00:00',2.54),('8348','2013-04-23','14:05:00',4.09),('8348','2013-04-23','14:10:00',3.5),('8348','2013-04-23','14:15:00',3.51),('8348','2013-04-23','14:20:00',3.5),('8348','2013-04-23','14:25:00',3.22),('8348','2013-04-23','14:30:00',3.77),('8348','2013-04-23','14:35:00',3.6),('8348','2013-04-23','14:40:00',3.58),('8348','2013-04-23','14:45:00',3.13),('8348','2013-04-23','14:50:00',2),('8348','2013-04-23','14:55:00',2.07),('8348','2013-04-23','15:00:00',2.16),('8348','2013-04-23','15:05:00',2.29),('8348','2013-04-23','15:10:00',2.79),('8348','2013-04-23','15:15:00',2.77),('8348','2013-04-23','15:20:00',2.57),('8348','2013-04-23','15:25:00',2.33),('8348','2013-04-23','15:30:00',2.32),('8348','2013-04-23','15:35:00',2.29),('8348','2013-04-23','15:40:00',2.41),('8348','2013-04-23','15:45:00',2.41),('8348','2013-04-23','15:50:00',1.95),('8348','2013-04-23','15:55:00',1.57),('8348','2013-04-23','16:00:00',1.67),('8348','2013-04-23','16:05:00',2.01),('8348','2013-04-23','16:10:00',2.01),('8348','2013-04-23','16:15:00',2.09),('8348','2013-04-23','16:20:00',1.31),('8348','2013-04-23','16:25:00',1.32),('8348','2013-04-23','16:30:00',1.11),('8348','2013-04-23','16:35:00',1.05),('8348','2013-04-23','16:40:00',1),('8348','2013-04-23','16:45:00',1.15),('8348','2013-04-23','16:55:00',1.01),('8348','2013-04-23','17:00:00',1.06),('8348','2013-04-23','17:05:00',1.08),('8348','2013-04-23','17:10:00',1.66),('8348','2013-04-23','17:15:00',1.41),('8348','2013-04-23','17:25:00',1.5),('8348','2013-04-23','17:30:00',1.5),('8348','2013-04-23','17:35:00',1.2),('8348','2013-04-22','09:30:00',1.08),('8348','2013-04-22','10:35:00',1.91),('8348','2013-04-22','10:40:00',2.65),('8348','2013-04-22','10:45:00',4.24),('8348','2013-04-22','10:50:00',2.05),('8348','2013-04-22','10:55:00',2.1),('8348','2013-04-22','11:00:00',1.85),('8348','2013-04-22','11:05:00',1.61),('8348','2013-04-22','11:10:00',2.16),('8348','2013-04-22','11:15:00',1.32),('8348','2013-04-22','11:20:00',1.32),('8348','2013-04-22','11:25:00',1.66),('8348','2013-04-22','11:30:00',2.46),('8348','2013-04-22','11:35:00',3.51),('8348','2013-04-22','11:40:00',3.42),('8348','2013-04-22','11:45:00',2.07),('8348','2013-04-22','11:50:00',1.51),('8348','2013-04-22','11:55:00',2.76),('8348','2013-04-22','12:00:00',3.31),('8348','2013-04-22','12:05:00',3.79),('8348','2013-04-22','12:10:00',2.15),('8348','2013-04-22','12:15:00',2.34),('8348','2013-04-22','12:20:00',1.98),('8348','2013-04-22','12:25:00',2.19),('8348','2013-04-22','12:30:00',2.54),('8348','2013-04-22','12:35:00',1.67),('8348','2013-04-22','12:40:00',2.93),('8348','2013-04-22','12:45:00',2.97),('8348','2013-04-22','12:50:00',4.08),('8348','2013-04-22','12:55:00',4.04),('8348','2013-04-22','13:00:00',4.05),('8348','2013-04-22','13:05:00',3.39),('8348','2013-04-22','13:10:00',3),('8348','2013-04-22','13:15:00',4.14),('8348','2013-04-22','13:20:00',4.38),('8348','2013-04-22','13:25:00',2.62),('8348','2013-04-22','13:30:00',1.47),('8348','2013-04-22','13:35:00',1.85),('8348','2013-04-22','13:40:00',2.26),('8348','2013-04-22','13:45:00',1.68),('8348','2013-04-22','13:50:00',1.03),('8348','2013-04-22','13:55:00',2.05),('8348','2013-04-22','14:00:00',1.31),('8348','2013-04-22','14:05:00',1.76),('8348','2013-04-22','14:10:00',2.91),('8348','2013-04-22','14:15:00',3.71),('8348','2013-04-22','14:20:00',3.57),('8348','2013-04-22','14:25:00',2.63),('8348','2013-04-22','14:30:00',4.04),('8348','2013-04-22','14:35:00',2.47),('8348','2013-04-22','14:40:00',4.25),('8348','2013-04-22','14:45:00',3.89),('8348','2013-04-22','14:50:00',4.04),('8348','2013-04-22','14:55:00',3.94),('8348','2013-04-22','15:00:00',1.18),('8348','2013-04-22','15:05:00',1.4),('8348','2013-04-22','15:10:00',1.52),('8348','2013-04-22','15:15:00',1.07),('8348','2013-04-22','15:20:00',1.53),('8348','2013-04-22','15:25:00',4.03),('8348','2013-04-22','15:30:00',1.59),('8348','2013-04-22','15:35:00',1.59),('8348','2013-04-22','15:40:00',2.22),('8348','2013-04-22','15:45:00',3.54),('8348','2013-04-22','15:50:00',2.81),('8348','2013-04-22','15:55:00',1.47),('8348','2013-04-22','16:45:00',1.03),('8348','2014-03-29','07:20:00',1.09),('8348','2014-03-29','07:25:00',1.18),('8348','2014-03-29','07:30:00',1.29),('8348','2014-03-29','07:35:00',1.37),('8348','2014-03-29','07:40:00',1.53),('8348','2014-03-29','07:45:00',1.72),('8348','2014-03-29','07:50:00',1.83),('8348','2014-03-29','07:55:00',1.93),('8348','2014-03-29','08:00:00',2.06),('8348','2014-03-29','08:05:00',2.19),('8348','2014-03-29','08:10:00',2.31),('8348','2014-03-29','08:15:00',2.4),('8348','2014-03-29','08:20:00',2.52),('8348','2014-03-29','08:25:00',2.76),('8348','2014-03-29','08:30:00',3.01),('8348','2014-03-29','08:35:00',3.19),('8348','2014-03-29','08:40:00',3.34),('8348','2014-03-29','08:45:00',3.57),('8348','2014-03-29','08:50:00',3.75),('8348','2014-03-29','08:55:00',3.84),('8348','2014-03-29','09:00:00',3.96),('8348','2014-03-29','09:05:00',4.07),('8348','2014-03-29','09:10:00',4.21),('8348','2014-03-29','09:15:00',4.38),('8348','2014-03-29','09:20:00',4.54),('8348','2014-03-29','09:25:00',4.67),('8348','2014-03-29','09:30:00',4.78),('8348','2014-03-29','09:35:00',4.87),('8348','2014-03-29','09:40:00',5.01),('8348','2014-03-29','09:45:00',5.08),('8348','2014-03-29','09:50:00',5.21),('8348','2014-03-29','09:55:00',5.34),('8348','2014-03-29','10:00:00',5.46),('8348','2014-03-29','10:05:00',5.52),('8348','2014-03-29','10:10:00',5.66),('8348','2014-03-29','10:15:00',5.8),('8348','2014-03-29','10:20:00',5.86),('8348','2014-03-29','10:25:00',5.95),('8348','2014-03-29','10:30:00',6.01),('8348','2014-03-29','10:35:00',6.08),('8348','2014-03-29','10:40:00',6.14),('8348','2014-03-29','10:45:00',6.23),('8348','2014-03-29','10:50:00',6.29),('8348','2014-03-29','10:55:00',6.33),('8348','2014-03-29','11:00:00',6.37),('8348','2014-03-29','11:05:00',6.38),('8348','2014-03-29','11:10:00',6.43),('8348','2014-03-29','11:15:00',6.51),('8348','2014-03-29','11:20:00',6.55),('8348','2014-03-29','11:25:00',6.62),('8348','2014-03-29','11:30:00',6.67),('8348','2014-03-29','11:35:00',6.61),('8348','2014-03-29','11:40:00',6.43),('8348','2014-03-29','11:45:00',6.74),('8348','2014-03-29','11:50:00',6.78),('8348','2014-03-29','11:55:00',6.75),('8348','2014-03-29','12:00:00',6.77),('8348','2014-03-29','12:05:00',6.81),('8348','2014-03-29','12:10:00',6.82),('8348','2014-03-29','12:15:00',6.83),('8348','2014-03-29','12:20:00',6.96),('8348','2014-03-29','12:25:00',6.95),('8348','2014-03-29','12:30:00',6.9),('8348','2014-03-29','12:35:00',6.9),('8348','2014-03-29','12:40:00',6.89),('8348','2014-03-29','12:45:00',6.92),('8348','2014-03-29','12:50:00',6.91),('8348','2014-03-29','12:55:00',6.86),('8348','2014-03-29','13:00:00',6.79),('8348','2014-03-29','13:05:00',6.87),('8348','2014-03-29','13:10:00',6.78),('8348','2014-03-29','13:15:00',6.77),('8348','2014-03-29','13:20:00',6.73),('8348','2014-03-29','13:25:00',6.61),('8348','2014-03-29','13:30:00',6.62),('8348','2014-03-29','13:35:00',6.51),('8348','2014-03-29','13:40:00',6.47),('8348','2014-03-29','13:45:00',6.32),('8348','2014-03-29','13:50:00',6.23),('8348','2014-03-29','13:55:00',6.18),('8348','2014-03-29','14:00:00',6.17),('8348','2014-03-29','14:05:00',6.15),('8348','2014-03-29','14:10:00',6.09),('8348','2014-03-29','14:15:00',6.02),('8348','2014-03-29','14:20:00',5.95),('8348','2014-03-29','14:25:00',5.89),('8348','2014-03-29','14:30:00',5.78),('8348','2014-03-29','14:35:00',5.14),('8348','2014-03-29','14:40:00',4.08),('8348','2014-03-29','14:45:00',5.23),('8348','2014-03-29','14:50:00',5.59),('8348','2014-03-29','14:55:00',5.62),('8348','2014-03-29','15:00:00',5.52),('8348','2014-03-29','15:05:00',5.35),('8348','2014-03-29','15:10:00',5.2),('8348','2014-03-29','15:15:00',5.12),('8348','2014-03-29','15:20:00',5.02),('8348','2014-03-29','15:25:00',4.83),('8348','2014-03-29','15:30:00',4.63),('8348','2014-03-29','15:35:00',4.45),('8348','2014-03-29','15:40:00',4.42),('8348','2014-03-29','15:45:00',4.31),('8348','2014-03-29','15:50:00',4.15),('8348','2014-03-29','15:55:00',4.04),('8348','2014-03-29','16:00:00',3.92),('8348','2014-03-29','16:05:00',3.76),('8348','2014-03-29','16:10:00',3.55),('8348','2014-03-29','16:15:00',3.38),('8348','2014-03-29','16:20:00',3.07),('8348','2014-03-29','16:25:00',3.1),('8348','2014-03-29','16:30:00',2.96),('8348','2014-03-29','16:35:00',2.69),('8348','2014-03-29','16:40:00',2.33),('8348','2014-03-29','16:45:00',1.9),('8348','2014-03-29','16:50:00',2.1),('8348','2014-03-29','16:55:00',2.17),('8348','2014-03-29','17:00:00',2.05),('8348','2014-03-29','17:05:00',1.86),('8348','2014-03-29','17:10:00',1.72),('8348','2014-03-29','17:15:00',1.56),('8348','2014-03-29','17:20:00',1.38),('8348','2014-03-29','17:25:00',1.2),('8348','2014-03-29','17:30:00',1.04),('8348','2013-04-21','08:25:00',1.02),('8348','2013-04-21','08:30:00',1.1),('8348','2013-04-21','08:35:00',1.23),('8348','2013-04-21','08:40:00',1.19),('8348','2013-04-21','08:45:00',1.11),('8348','2013-04-21','08:50:00',1.24),('8348','2013-04-21','08:55:00',1.63),('8348','2013-04-21','09:00:00',1.51),('8348','2013-04-21','09:05:00',1.91),('8348','2013-04-21','09:10:00',1.64),('8348','2013-04-21','09:15:00',1.39),('8348','2013-04-21','09:20:00',1.35),('8348','2013-04-21','09:25:00',1.96),('8348','2013-04-21','09:30:00',2.33),('8348','2013-04-21','09:35:00',2.39),('8348','2013-04-21','09:40:00',2.48),('8348','2013-04-21','09:45:00',2.65),('8348','2013-04-21','09:50:00',2.95),('8348','2013-04-21','09:55:00',3.27),('8348','2013-04-21','10:00:00',2.68),('8348','2013-04-21','10:05:00',1.75),('8348','2013-04-21','10:10:00',1.73),('8348','2013-04-21','10:15:00',1.57),('8348','2013-04-21','10:20:00',3.21),('8348','2013-04-21','10:25:00',2.27),('8348','2013-04-21','10:30:00',2.14),('8348','2013-04-21','10:35:00',1.55),('8348','2013-04-21','10:40:00',1.85),('8348','2013-04-21','10:45:00',2.16),('8348','2013-04-21','10:50:00',2.28),('8348','2013-04-21','10:55:00',2.22),('8348','2013-04-21','11:00:00',3.1),('8348','2013-04-21','11:05:00',2.95),('8348','2013-04-21','11:10:00',3.49),('8348','2013-04-21','11:15:00',2.96),('8348','2013-04-21','11:20:00',2.56),('8348','2013-04-21','11:25:00',2.71),('8348','2013-04-21','11:30:00',2.46),('8348','2013-04-21','11:35:00',2.35),('8348','2013-04-21','11:40:00',2.49),('8348','2013-04-21','11:45:00',2.71),('8348','2013-04-21','11:50:00',2.99),('8348','2013-04-21','11:55:00',2.81),('8348','2013-04-21','12:00:00',2.21),('8348','2013-04-21','12:05:00',2.25),('8348','2013-04-21','12:10:00',2.16),('8348','2013-04-21','12:15:00',2.01),('8348','2013-04-21','12:20:00',1.83),('8348','2013-04-21','12:25:00',1.78),('8348','2013-04-21','12:30:00',1.91),('8348','2013-04-21','12:35:00',1.98),('8348','2013-04-21','12:40:00',2),('8348','2013-04-21','12:45:00',2.02),('8348','2013-04-21','12:50:00',1.91),('8348','2013-04-21','12:55:00',1.84),('8348','2013-04-21','13:00:00',2.08),('8348','2013-04-21','13:05:00',2.43),('8348','2013-04-21','13:10:00',2.44),('8348','2013-04-21','13:15:00',2.24),('8348','2013-04-21','13:20:00',2.11),('8348','2013-04-21','13:25:00',2.06),('8348','2013-04-21','13:30:00',3),('8348','2013-04-21','13:35:00',3.5),('8348','2013-04-21','13:40:00',2.59),('8348','2013-04-21','13:45:00',3),('8348','2013-04-21','13:50:00',2.96),('8348','2013-04-21','13:55:00',3.53),('8348','2013-04-21','14:00:00',3.64),('8348','2013-04-21','14:05:00',4.03),('8348','2013-04-21','14:10:00',3.81),('8348','2013-04-21','14:15:00',4.08),('8348','2013-04-21','14:20:00',4.27),('8348','2013-04-21','14:25:00',4.02),('8348','2013-04-21','14:30:00',3.64),('8348','2013-04-21','14:35:00',4.13),('8348','2013-04-21','14:40:00',4.29),('8348','2013-04-21','14:45:00',3.25),('8348','2013-04-21','14:50:00',2.01),('8348','2013-04-21','14:55:00',2.06),('8348','2013-04-21','15:00:00',1.84),('8348','2013-04-21','15:05:00',3.46),('8348','2013-04-21','15:10:00',3.76),('8348','2013-04-21','15:15:00',2.87),('8348','2013-04-21','15:20:00',1.67),('8348','2013-04-21','15:25:00',1.8),('8348','2013-04-21','15:30:00',1.6),('8348','2013-04-21','15:35:00',1.37),('8348','2013-04-21','15:40:00',1.44),('8348','2013-04-21','15:45:00',1.18),('8348','2013-04-20','08:30:00',1.11),('8348','2013-04-20','08:35:00',1.2),('8348','2013-04-20','08:40:00',1.33),('8348','2013-04-20','08:45:00',1.41),('8348','2013-04-20','08:50:00',1.45),('8348','2013-04-20','08:55:00',1.46),('8348','2013-04-20','09:00:00',1.71),('8348','2013-04-20','09:05:00',1.81),('8348','2013-04-20','09:10:00',1.73),('8348','2013-04-20','09:15:00',1.73),('8348','2013-04-20','09:20:00',2.13),('8348','2013-04-20','09:25:00',2.01),('8348','2013-04-20','09:30:00',1.9),('8348','2013-04-20','09:35:00',1.33),('8348','2013-04-20','09:50:00',1.02),('8348','2013-04-20','10:40:00',1.11),('8348','2013-04-20','10:45:00',2),('8348','2013-04-20','10:50:00',2.43),('8348','2013-04-20','10:55:00',2.3),('8348','2013-04-20','11:00:00',3.22),('8348','2013-04-20','11:05:00',3.25),('8348','2013-04-20','11:10:00',3.51),('8348','2013-04-20','11:15:00',3.62),('8348','2013-04-20','11:20:00',2.69),('8348','2013-04-20','11:25:00',2.73),('8348','2013-04-20','11:30:00',3.69),('8348','2013-04-20','11:35:00',2.14),('8348','2013-04-20','11:40:00',1.16),('8348','2013-04-20','11:45:00',1.91),('8348','2013-04-20','11:50:00',3.08),('8348','2013-04-20','11:55:00',3.98),('8348','2013-04-20','12:00:00',3.95),('8348','2013-04-20','12:05:00',3.87),('8348','2013-04-20','12:10:00',3.8),('8348','2013-04-20','12:15:00',3.82),('8348','2013-04-20','12:20:00',3.74),('8348','2013-04-20','12:25:00',3.78),('8348','2013-04-20','12:30:00',3.49),('8348','2013-04-20','12:35:00',1.29),('8348','2013-04-20','12:40:00',1.57),('8348','2013-04-20','12:45:00',4.08),('8348','2013-04-20','12:50:00',2.93),('8348','2013-04-20','12:55:00',2.34),('8348','2013-04-20','13:00:00',3.34),('8348','2013-04-20','13:05:00',2.64),('8348','2013-04-20','13:10:00',2.3),('8348','2013-04-20','13:15:00',3.9),('8348','2013-04-20','13:20:00',3.14),('8348','2013-04-20','13:25:00',3.07),('8348','2013-04-20','13:30:00',1.29),('8348','2013-04-20','13:35:00',1.92),('8348','2013-04-20','13:40:00',3.22),('8348','2013-04-20','13:45:00',2.02),('8348','2013-04-20','13:50:00',1.54),('8348','2013-04-20','13:55:00',2.12),('8348','2013-04-20','14:00:00',2.58),('8348','2013-04-20','14:05:00',3.02),('8348','2013-04-20','14:10:00',3.41),('8348','2013-04-20','14:15:00',3.84),('8348','2013-04-20','14:20:00',3.67),('8348','2013-04-20','14:25:00',3.62),('8348','2013-04-20','14:30:00',3.53),('8348','2013-04-20','14:35:00',3.47),('8348','2013-04-20','14:40:00',3.47),('8348','2013-04-20','14:45:00',3.5),('8348','2013-04-20','14:50:00',3.46),('8348','2013-04-20','14:55:00',3.47),('8348','2013-04-20','15:00:00',3.47),('8348','2013-04-20','15:05:00',3.44),('8348','2013-04-20','15:10:00',2.1),('8348','2013-04-20','15:15:00',2.17),('8348','2013-04-20','15:20:00',2.37),('8348','2013-04-20','15:25:00',3.07),('8348','2013-04-20','15:30:00',1.49),('8348','2013-04-20','16:05:00',1.01),('8348','2013-04-20','16:10:00',1.58),('8348','2013-04-20','16:15:00',2.36),('8348','2013-04-20','16:20:00',2),('8348','2013-04-20','16:25:00',2.52),('8348','2013-04-20','16:30:00',2.6),('8348','2013-04-20','16:35:00',2.62),('8348','2013-04-20','16:40:00',2.68),('8348','2013-04-20','16:45:00',2.84),('8348','2013-04-20','16:50:00',2.57),('8348','2013-04-20','16:55:00',2.46),('8348','2013-04-20','17:00:00',2.34),('8348','2013-04-20','17:05:00',2.28),('8348','2013-04-20','17:10:00',2.22),('8348','2013-04-20','17:15:00',1.95),('8348','2013-04-20','17:20:00',1.99),('8348','2013-04-20','17:25:00',2.01),('8348','2013-04-20','17:30:00',2.09),('8348','2013-04-20','17:35:00',2.07),('8348','2013-04-20','17:40:00',1.86),('8348','2013-04-20','17:50:00',1.01),('8348','2013-04-20','17:55:00',1.75),('8348','2013-04-20','18:00:00',1.27),('8348','2013-04-20','18:05:00',1.37),('8348','2013-04-20','18:10:00',1.48),('8348','2013-04-20','18:15:00',1.25),('8348','2013-04-19','08:35:00',1.16),('8348','2013-04-19','08:40:00',1.24),('8348','2013-04-19','08:45:00',1.32),('8348','2013-04-19','08:50:00',1.39),('8348','2013-04-19','08:55:00',1.48),('8348','2013-04-19','09:00:00',1.56),('8348','2013-04-19','09:05:00',1.62),('8348','2013-04-19','09:10:00',1.68),('8348','2013-04-19','09:15:00',1.73),('8348','2013-04-19','09:20:00',1.82),('8348','2013-04-19','09:25:00',1.88),('8348','2013-04-19','09:30:00',1.93),('8348','2013-04-19','09:35:00',2),('8348','2013-04-19','09:40:00',2.05),('8348','2013-04-19','09:45:00',2.1),('8348','2013-04-19','09:50:00',2.14),('8348','2013-04-19','09:55:00',2.22),('8348','2013-04-19','10:00:00',2.26),('8348','2013-04-19','10:05:00',2.31),('8348','2013-04-19','10:10:00',2.36),('8348','2013-04-19','10:15:00',2.46),('8348','2013-04-19','10:20:00',2.4),('8348','2013-04-19','10:25:00',2.58),('8348','2013-04-19','10:30:00',2.57),('8348','2013-04-19','10:35:00',2.13),('8348','2013-04-19','10:40:00',2.75),('8348','2013-04-19','10:45:00',2.7),('8348','2013-04-19','10:50:00',2.73),('8348','2013-04-19','10:55:00',2.75),('8348','2013-04-19','11:00:00',2.79),('8348','2013-04-19','11:05:00',2.83),('8348','2013-04-19','11:10:00',2.88),('8348','2013-04-19','11:15:00',2.89),('8348','2013-04-19','11:20:00',2.94),('8348','2013-04-19','11:25:00',2.99),('8348','2013-04-19','11:30:00',3),('8348','2013-04-19','11:35:00',2.98),('8348','2013-04-19','11:40:00',3.09),('8348','2013-04-19','11:45:00',3.17),('8348','2013-04-19','11:50:00',3.22),('8348','2013-04-19','11:55:00',3.22),('8348','2013-04-19','12:00:00',3.18),('8348','2013-04-19','12:05:00',3.24),('8348','2013-04-19','12:10:00',3.29),('8348','2013-04-19','12:15:00',3.27),('8348','2013-04-19','12:20:00',3.27),('8348','2013-04-19','12:25:00',3.3),('8348','2013-04-19','12:30:00',3.35),('8348','2013-04-19','12:35:00',3.34),('8348','2013-04-19','12:40:00',3.35),('8348','2013-04-19','12:45:00',3.36),('8348','2013-04-19','12:50:00',3.35),('8348','2013-04-19','12:55:00',3.39),('8348','2013-04-19','13:00:00',3.38),('8348','2013-04-19','13:05:00',3.43),('8348','2013-04-19','13:10:00',3.47),('8348','2013-04-19','13:15:00',3.48),('8348','2013-04-19','13:20:00',3.45),('8348','2013-04-19','13:25:00',3.53),('8348','2013-04-19','13:30:00',3.5),('8348','2013-04-19','13:35:00',3.44),('8348','2013-04-19','13:40:00',3.49),('8348','2013-04-19','13:45:00',3.45),('8348','2013-04-19','13:50:00',3.43),('8348','2013-04-19','13:55:00',3.44),('8348','2013-04-19','14:00:00',3.39),('8348','2013-04-19','14:05:00',3.41),('8348','2013-04-19','14:10:00',3.4),('8348','2013-04-19','14:15:00',3.37),('8348','2013-04-19','14:20:00',3.33),('8348','2013-04-19','14:25:00',3.35),('8348','2013-04-19','14:30:00',3.27),('8348','2013-04-19','14:35:00',3.26),('8348','2013-04-19','14:40:00',3.25),('8348','2013-04-19','14:45:00',3.22),('8348','2013-04-19','14:50:00',3.24),('8348','2013-04-19','14:55:00',3.21),('8348','2013-04-19','15:00:00',3.19),('8348','2013-04-19','15:05:00',3.15),('8348','2013-04-19','15:10:00',3.11),('8348','2013-04-19','15:15:00',3.08),('8348','2013-04-19','15:20:00',3.05),('8348','2013-04-19','15:25:00',3.05),('8348','2013-04-19','15:30:00',3.02),('8348','2013-04-19','15:35:00',2.97),('8348','2013-04-19','15:40:00',2.96),('8348','2013-04-19','15:45:00',2.92),('8348','2013-04-19','15:50:00',2.89),('8348','2013-04-19','15:55:00',2.85),('8348','2013-04-19','16:00:00',2.8),('8348','2013-04-19','16:05:00',2.75),('8348','2013-04-19','16:10:00',2.68),('8348','2013-04-19','16:15:00',2.63),('8348','2013-04-19','16:20:00',2.58),('8348','2013-04-19','16:25:00',2.53),('8348','2013-04-19','16:30:00',2.47),('8348','2013-04-19','16:35:00',2.39),('8348','2013-04-19','16:40:00',2.33),('8348','2013-04-19','16:45:00',2.28),('8348','2013-04-19','16:50:00',2.2),('8348','2013-04-19','16:55:00',2.11),('8348','2013-04-19','17:00:00',2.06),('8348','2013-04-19','17:05:00',1.98),('8348','2013-04-19','17:10:00',1.89),('8348','2013-04-19','17:15:00',1.82),('8348','2013-04-19','17:20:00',1.75),('8348','2013-04-19','17:25:00',1.68),('8348','2013-04-19','17:30:00',1.61),('8348','2013-04-19','17:35:00',1.54),('8348','2013-04-19','17:40:00',1.47),('8348','2013-04-19','17:45:00',1.39),('8348','2013-04-19','17:50:00',1.26),('8348','2013-04-19','17:55:00',1.2),('8348','2013-04-19','18:00:00',1.14),('8348','2013-04-19','18:05:00',1.08),('8348','2013-04-19','18:10:00',1.01),('8348','2013-04-18','08:30:00',1.01),('8348','2013-04-18','08:35:00',1.06),('8348','2013-04-18','08:40:00',1.03),('8348','2013-04-18','08:45:00',1.03),('8348','2013-04-18','08:50:00',1.15),('8348','2013-04-18','08:55:00',1.31),('8348','2013-04-18','09:00:00',1.4),('8348','2013-04-18','09:05:00',1.51),('8348','2013-04-18','09:10:00',1.56),('8348','2013-04-18','09:15:00',1.58),('8348','2013-04-18','09:20:00',1.62),('8348','2013-04-18','09:25:00',1.67),('8348','2013-04-18','09:30:00',1.81),('8348','2013-04-18','09:35:00',2.01),('8348','2013-04-18','09:40:00',2.21),('8348','2013-04-18','09:45:00',2.13),('8348','2013-04-18','09:50:00',1.83),('8348','2013-04-18','09:55:00',1.79),('8348','2013-04-18','10:00:00',2.1),('8348','2013-04-18','10:05:00',2.34),('8348','2013-04-18','10:10:00',2.47),('8348','2013-04-18','10:15:00',2.62),('8348','2013-04-18','10:20:00',2.66),('8348','2013-04-18','10:25:00',2.64),('8348','2013-04-18','10:30:00',2.68),('8348','2013-04-18','10:35:00',2.7),('8348','2013-04-18','10:40:00',2.77),('8348','2013-04-18','10:45:00',2.82),('8348','2013-04-18','10:50:00',2.85),('8348','2013-04-18','10:55:00',2.89),('8348','2013-04-18','11:00:00',2.93),('8348','2013-04-18','11:05:00',2.97),('8348','2013-04-18','11:10:00',3.02),('8348','2013-04-18','11:15:00',3.07),('8348','2013-04-18','11:20:00',3.11),('8348','2013-04-18','11:25:00',3.15),('8348','2013-04-18','11:30:00',3.17),('8348','2013-04-18','11:35:00',3.2),('8348','2013-04-18','11:40:00',3.22),('8348','2013-04-18','11:45:00',3.22),('8348','2013-04-18','11:50:00',3.32),('8348','2013-04-18','11:55:00',3.38),('8348','2013-04-18','12:00:00',3.34),('8348','2013-04-18','12:05:00',3.4),('8348','2013-04-18','12:10:00',3.46),('8348','2013-04-18','12:15:00',3.47),('8348','2013-04-18','12:20:00',3.54),('8348','2013-04-18','12:25:00',3.5),('8348','2013-04-18','12:30:00',3.54),('8348','2013-04-18','12:35:00',3.56),('8348','2013-04-18','12:40:00',3.54),('8348','2013-04-18','12:45:00',3.58),('8348','2013-04-18','12:50:00',3.59),('8348','2013-04-18','12:55:00',3.62),('8348','2013-04-18','13:00:00',3.64),('8348','2013-04-18','13:05:00',3.63),('8348','2013-04-18','13:10:00',3.61),('8348','2013-04-18','13:15:00',3.6),('8348','2013-04-18','13:20:00',3.59),('8348','2013-04-18','13:25:00',3.63),('8348','2013-04-18','13:30:00',3.63),('8348','2013-04-18','13:35:00',3.65),('8348','2013-04-18','13:40:00',3.63),('8348','2013-04-18','13:45:00',3.65),('8348','2013-04-18','13:50:00',3.67),('8348','2013-04-18','13:55:00',3.67),('8348','2013-04-18','14:00:00',3.66),('8348','2013-04-18','14:05:00',3.65),('8348','2013-04-18','14:10:00',3.63),('8348','2013-04-18','14:15:00',3.64),('8348','2013-04-18','14:20:00',3.62),('8348','2013-04-18','14:25:00',3.59),('8348','2013-04-18','14:30:00',3.58),('8348','2013-04-18','14:35:00',3.56),('8348','2013-04-18','14:40:00',3.53),('8348','2013-04-18','14:45:00',3.51),('8348','2013-04-18','14:50:00',3.48),('8348','2013-04-18','14:55:00',3.44),('8348','2013-04-18','15:00:00',3.41),('8348','2013-04-18','15:05:00',3.39),('8348','2013-04-18','15:10:00',3.34),('8348','2013-04-18','15:15:00',3.31),('8348','2013-04-18','15:20:00',3.26),('8348','2013-04-18','15:25:00',3.24),('8348','2013-04-18','15:30:00',3.19),('8348','2013-04-18','15:35:00',3.15),('8348','2013-04-18','15:40:00',3.1),('8348','2013-04-18','15:45:00',3.06),('8348','2013-04-18','15:50:00',3.04),('8348','2013-04-18','15:55:00',2.96),('8348','2013-04-18','16:00:00',2.91),('8348','2013-04-18','16:05:00',2.85),('8348','2013-04-18','16:10:00',2.81),('8348','2013-04-18','16:15:00',2.75),('8348','2013-04-18','16:20:00',2.66),('8348','2013-04-18','16:25:00',2.61),('8348','2013-04-18','16:30:00',2.56),('8348','2013-04-18','16:35:00',2.49),('8348','2013-04-18','16:40:00',2.44),('8348','2013-04-18','16:45:00',2.39),('8348','2013-04-18','16:50:00',2.34),('8348','2013-04-18','16:55:00',2.25),('8348','2013-04-18','17:00:00',2.17),('8348','2013-04-18','17:05:00',2.08),('8348','2013-04-18','17:10:00',2.03),('8348','2013-04-18','17:15:00',1.99),('8348','2013-04-18','17:20:00',1.9),('8348','2013-04-18','17:25:00',1.82),('8348','2013-04-18','17:30:00',1.75),('8348','2013-04-18','17:35:00',1.69),('8348','2013-04-18','17:40:00',1.6),('8348','2013-04-18','17:45:00',1.54),('8348','2013-04-18','17:50:00',1.47),('8348','2013-04-18','17:55:00',1.39),('8348','2013-04-18','18:00:00',1.3),('8348','2013-04-18','18:05:00',1.21),('8348','2013-04-18','18:10:00',1.12),('8348','2013-04-18','18:15:00',1.04),('8348','2013-04-17','08:30:00',1.03),('8348','2013-04-17','08:35:00',1.14),('8348','2013-04-17','08:40:00',1.2),('8348','2013-04-17','08:45:00',1.28),('8348','2013-04-17','08:50:00',1.37),('8348','2013-04-17','08:55:00',1.44),('8348','2013-04-17','09:00:00',1.52),('8348','2013-04-17','09:05:00',1.63),('8348','2013-04-17','09:10:00',1.7),('8348','2013-04-17','09:15:00',1.77),('8348','2013-04-17','09:20:00',1.84),('8348','2013-04-17','09:25:00',1.91),('8348','2013-04-17','09:30:00',1.98),('8348','2013-04-17','09:35:00',2.06),('8348','2013-04-17','09:40:00',2.12),('8348','2013-04-17','09:45:00',2.18),('8348','2013-04-17','09:50:00',2.25),('8348','2013-04-17','09:55:00',2.31),('8348','2013-04-17','10:00:00',2.36),('8348','2013-04-17','10:05:00',2.42),('8348','2013-04-17','10:10:00',2.48),('8348','2013-04-17','10:15:00',2.53),('8348','2013-04-17','10:20:00',2.59),('8348','2013-04-17','10:25:00',2.65),('8348','2013-04-17','10:30:00',2.7),('8348','2013-04-17','10:35:00',2.75),('8348','2013-04-17','10:40:00',2.79),('8348','2013-04-17','10:45:00',2.83),('8348','2013-04-17','10:50:00',2.89),('8348','2013-04-17','10:55:00',2.93),('8348','2013-04-17','11:00:00',2.97),('8348','2013-04-17','11:05:00',3.02),('8348','2013-04-17','11:10:00',3.06),('8348','2013-04-17','11:15:00',3.1),('8348','2013-04-17','11:20:00',3.13),('8348','2013-04-17','11:25:00',3.14),('8348','2013-04-17','11:30:00',3.17),('8348','2013-04-17','11:35:00',3.21),('8348','2013-04-17','11:40:00',3.23),('8348','2013-04-17','11:45:00',3.25),('8348','2013-04-17','11:50:00',3.3),('8348','2013-04-17','11:55:00',3.33),('8348','2013-04-17','12:00:00',3.34),('8348','2013-04-17','12:05:00',3.36),('8348','2013-04-17','12:10:00',3.38),('8348','2013-04-17','12:15:00',3.42),('8348','2013-04-17','12:20:00',3.42),('8348','2013-04-17','12:25:00',3.44),('8348','2013-04-17','12:30:00',3.49),('8348','2013-04-17','12:35:00',3.51),('8348','2013-04-17','12:40:00',3.51),('8348','2013-04-17','12:45:00',3.52),('8348','2013-04-17','12:50:00',3.52),('8348','2013-04-17','12:55:00',3.55),('8348','2013-04-17','13:00:00',3.54),('8348','2013-04-17','13:05:00',3.56),('8348','2013-04-17','13:10:00',3.56),('8348','2013-04-17','13:15:00',3.59),('8348','2013-04-17','13:20:00',3.58),('8348','2013-04-17','13:25:00',3.59),('8348','2013-04-17','13:30:00',3.6),('8348','2013-04-17','13:35:00',3.61),('8348','2013-04-17','13:40:00',3.68),('8348','2013-04-17','13:45:00',3.56),('8348','2013-04-17','13:50:00',3.52),('8348','2013-04-17','13:55:00',3.78),('8348','2013-04-17','14:00:00',3.59),('8348','2013-04-17','14:05:00',3.95),('8348','2013-04-17','14:10:00',3.92),('8348','2013-04-17','14:15:00',3.48),('8348','2013-04-17','14:20:00',3.45),('8348','2013-04-17','14:25:00',3.31),('8348','2013-04-17','14:30:00',3.59),('8348','2013-04-17','14:35:00',3.85),('8348','2013-04-17','14:40:00',3.59),('8348','2013-04-17','14:45:00',3.36),('8348','2013-04-17','14:50:00',3.75),('8348','2013-04-17','14:55:00',3.76),('8348','2013-04-17','15:00:00',3.72),('8348','2013-04-17','15:05:00',3.79),('8348','2013-04-17','15:10:00',3.92),('8348','2013-04-17','15:15:00',3.62),('8348','2013-04-17','15:20:00',2.1),('8348','2013-04-17','15:25:00',1.8),('8348','2013-04-17','15:30:00',3.12),('8348','2013-04-17','15:35:00',3.33),('8348','2013-04-17','15:40:00',3.37),('8348','2013-04-17','15:45:00',3.36),('8348','2013-04-17','15:50:00',3.34),('8348','2013-04-17','15:55:00',3.25),('8348','2013-04-17','16:00:00',3.11),('8348','2013-04-17','16:05:00',2.28),('8348','2013-04-17','16:10:00',3.05),('8348','2013-04-17','16:15:00',2.95),('8348','2013-04-17','16:20:00',2.85),('8348','2013-04-17','16:25:00',2.79),('8348','2013-04-17','16:30:00',2.73),('8348','2013-04-17','16:35:00',2.71),('8348','2013-04-17','16:40:00',2.36),('8348','2013-04-17','16:45:00',2.59),('8348','2013-04-17','16:50:00',2.44),('8348','2013-04-17','16:55:00',2.34),('8348','2013-04-17','17:00:00',2.26),('8348','2013-04-17','17:05:00',2.17),('8348','2013-04-17','17:10:00',2.09),('8348','2013-04-17','17:15:00',2.02),('8348','2013-04-17','17:20:00',1.94),('8348','2013-04-17','17:25:00',1.87),('8348','2013-04-17','17:30:00',1.78),('8348','2013-04-17','17:35:00',1.71),('8348','2013-04-17','17:40:00',1.63),('8348','2013-04-17','17:45:00',1.54),('8348','2013-04-17','17:50:00',1.47),('8348','2013-04-17','17:55:00',1.4),('8348','2013-04-17','18:00:00',1.32),('8348','2013-04-17','18:05:00',1.24),('8348','2013-04-17','18:10:00',1.16),('8348','2013-04-17','18:15:00',1.07),('8348','2013-04-16','09:10:00',1.2),('8348','2013-04-16','09:15:00',1.17),('8348','2013-04-16','09:25:00',1.22),('8348','2013-04-16','09:30:00',1.46),('8348','2013-04-16','09:35:00',1.35),('8348','2013-04-16','09:40:00',1.26),('8348','2013-04-16','09:45:00',1.31),('8348','2013-04-16','09:50:00',1.24),('8348','2013-04-16','09:55:00',1.2),('8348','2013-04-16','10:00:00',1.15),('8348','2013-04-16','10:05:00',1.15),('8348','2013-04-16','10:10:00',1.23),('8348','2013-04-16','10:15:00',1.31),('8348','2013-04-16','10:20:00',1.36),('8348','2013-04-16','10:25:00',1.4),('8348','2013-04-16','10:30:00',1.4),('8348','2013-04-16','10:35:00',1.43),('8348','2013-04-16','10:40:00',1.41),('8348','2013-04-16','10:45:00',1.35),('8348','2013-04-16','10:50:00',1.37),('8348','2013-04-16','10:55:00',1.46),('8348','2013-04-16','11:00:00',1.58),('8348','2013-04-16','11:05:00',1.63),('8348','2013-04-16','11:10:00',1.61),('8348','2013-04-16','11:15:00',1.66),('8348','2013-04-16','11:20:00',1.7),('8348','2013-04-16','11:25:00',1.67),('8348','2013-04-16','11:30:00',1.62),('8348','2013-04-16','11:35:00',1.57),('8348','2013-04-16','11:40:00',1.73),('8348','2013-04-16','11:45:00',1.98),('8348','2013-04-16','11:50:00',2.11),('8348','2013-04-16','11:55:00',2.18),('8348','2013-04-16','12:00:00',2.21),('8348','2013-04-16','12:05:00',2.48),('8348','2013-04-16','12:10:00',2.38),('8348','2013-04-16','12:15:00',2.52),('8348','2013-04-16','12:20:00',2.65),('8348','2013-04-16','12:25:00',2.56),('8348','2013-04-16','12:30:00',2.16),('8348','2013-04-16','12:35:00',3.63),('8348','2013-04-16','12:40:00',3.48),('8348','2013-04-16','12:45:00',2.99),('8348','2013-04-16','12:50:00',2.47),('8348','2013-04-16','12:55:00',3.42),('8348','2013-04-16','13:00:00',3.62),('8348','2013-04-16','13:05:00',3.46),('8348','2013-04-16','13:10:00',3.45),('8348','2013-04-16','13:15:00',3.49),('8348','2013-04-16','13:20:00',3.56),('8348','2013-04-16','13:25:00',3.58),('8348','2013-04-16','13:30:00',3.57),('8348','2013-04-16','13:35:00',3.53),('8348','2013-04-16','13:40:00',3.51),('8348','2013-04-16','13:45:00',3.44),('8348','2013-04-16','13:50:00',3.43),('8348','2013-04-16','13:55:00',3.35),('8348','2013-04-16','14:00:00',3.45),('8348','2013-04-16','14:05:00',3.52),('8348','2013-04-16','14:10:00',3.53),('8348','2013-04-16','14:15:00',3.57),('8348','2013-04-16','14:20:00',3.51),('8348','2013-04-16','14:25:00',3),('8348','2013-04-16','14:30:00',3.1),('8348','2013-04-16','14:35:00',2.74),('8348','2013-04-16','14:40:00',3.25),('8348','2013-04-16','14:45:00',3.4),('8348','2013-04-16','14:50:00',3.31),('8348','2013-04-16','14:55:00',3.25),('8348','2013-04-16','15:00:00',3.35),('8348','2013-04-16','15:05:00',3.32),('8348','2013-04-16','15:10:00',3.33),('8348','2013-04-16','15:15:00',3.26),('8348','2013-04-16','15:20:00',3.2),('8348','2013-04-16','15:25:00',3.1),('8348','2013-04-16','15:30:00',2.99),('8348','2013-04-16','15:35:00',3.07),('8348','2013-04-16','15:40:00',3.04),('8348','2013-04-16','15:45:00',3.01),('8348','2013-04-16','15:50:00',2.96),('8348','2013-04-16','15:55:00',2.93),('8348','2013-04-16','16:00:00',2.8),('8348','2013-04-16','16:05:00',2.8),('8348','2013-04-16','16:10:00',2.72),('8348','2013-04-16','16:15:00',2.65),('8348','2013-04-16','16:20:00',2.67),('8348','2013-04-16','16:25:00',2.61),('8348','2013-04-16','16:30:00',2.57),('8348','2013-04-16','16:35:00',2.54),('8348','2013-04-16','16:40:00',2.64),('8348','2013-04-16','16:45:00',2.69),('8348','2013-04-16','16:50:00',2.45),('8348','2013-04-16','16:55:00',2.09),('8348','2013-04-16','17:00:00',2.14),('8348','2013-04-16','17:05:00',2.21),('8348','2013-04-16','17:10:00',2.21),('8348','2013-04-16','17:15:00',2.15),('8348','2013-04-16','17:20:00',2.09),('8348','2013-04-16','17:25:00',2.08),('8348','2013-04-16','17:30:00',1.95),('8348','2013-04-16','17:35:00',1.96),('8348','2013-04-16','17:40:00',1.83),('8348','2013-04-16','17:45:00',1.7),('8348','2013-04-16','17:50:00',1.55),('8348','2013-04-16','17:55:00',1.37),('8348','2013-04-15','08:30:00',1.02),('8348','2013-04-15','08:35:00',1.1),('8348','2013-04-15','08:40:00',1.15),('8348','2013-04-15','08:45:00',1.24),('8348','2013-04-15','08:50:00',1.3),('8348','2013-04-15','08:55:00',1.42),('8348','2013-04-15','09:00:00',1.51),('8348','2013-04-15','09:05:00',1.61),('8348','2013-04-15','09:10:00',1.7),('8348','2013-04-15','09:15:00',1.76),('8348','2013-04-15','09:20:00',1.83),('8348','2013-04-15','09:25:00',1.91),('8348','2013-04-15','09:30:00',1.97),('8348','2013-04-15','09:35:00',2.04),('8348','2013-04-15','09:40:00',2.09),('8348','2013-04-15','09:45:00',2.16),('8348','2013-04-15','09:50:00',2.23),('8348','2013-04-15','09:55:00',2.28),('8348','2013-04-15','10:00:00',2.34),('8348','2013-04-15','10:05:00',2.4),('8348','2013-04-15','10:10:00',2.46),('8348','2013-04-15','10:15:00',2.53),('8348','2013-04-15','10:20:00',2.58),('8348','2013-04-15','10:25:00',2.62),('8348','2013-04-15','10:30:00',2.68),('8348','2013-04-15','10:35:00',2.73),('8348','2013-04-15','10:40:00',2.78),('8348','2013-04-15','10:45:00',2.82),('8348','2013-04-15','10:50:00',2.86),('8348','2013-04-15','10:55:00',2.9),('8348','2013-04-15','11:00:00',2.95),('8348','2013-04-15','11:05:00',3),('8348','2013-04-15','11:10:00',3.03),('8348','2013-04-15','11:15:00',3.07),('8348','2013-04-15','11:20:00',3.1),('8348','2013-04-15','11:25:00',3.13),('8348','2013-04-15','11:30:00',3.17),('8348','2013-04-15','11:35:00',3.19),('8348','2013-04-15','11:40:00',3.23),('8348','2013-04-15','11:45:00',3.25),('8348','2013-04-15','11:50:00',3.27),('8348','2013-04-15','11:55:00',3.29),('8348','2013-04-15','12:00:00',3.32),('8348','2013-04-15','12:05:00',3.34),('8348','2013-04-15','12:10:00',3.35),('8348','2013-04-15','12:15:00',3.38),('8348','2013-04-15','12:20:00',3.4),('8348','2013-04-15','12:25:00',3.41),('8348','2013-04-15','12:30:00',3.43),('8348','2013-04-15','12:35:00',3.46),('8348','2013-04-15','12:40:00',3.46),('8348','2013-04-15','12:45:00',3.45),('8348','2013-04-15','12:50:00',3.42),('8348','2013-04-15','12:55:00',3.46),('8348','2013-04-15','13:00:00',3.48),('8348','2013-04-15','13:05:00',3.51),('8348','2013-04-15','13:10:00',3.5),('8348','2013-04-15','13:15:00',3.5),('8348','2013-04-15','13:20:00',3.52),('8348','2013-04-15','13:25:00',3.53),('8348','2013-04-15','13:30:00',3.52),('8348','2013-04-15','13:35:00',3.52),('8348','2013-04-15','13:40:00',3.49),('8348','2013-04-15','13:45:00',3.48),('8348','2013-04-15','13:50:00',3.58),('8348','2013-04-15','13:55:00',3.63),('8348','2013-04-15','14:00:00',3.65),('8348','2013-04-15','14:05:00',3.66),('8348','2013-04-15','14:10:00',3.67),('8348','2013-04-15','14:15:00',3.67),('8348','2013-04-15','14:20:00',3.67),('8348','2013-04-15','14:25:00',3.64),('8348','2013-04-15','14:30:00',3.61),('8348','2013-04-15','14:35:00',3.59),('8348','2013-04-15','14:40:00',3.54),('8348','2013-04-15','14:45:00',3.53),('8348','2013-04-15','14:50:00',3.5),('8348','2013-04-15','14:55:00',3.48),('8348','2013-04-15','15:00:00',3.45),('8348','2013-04-15','15:05:00',3.42),('8348','2013-04-15','15:10:00',3.4),('8348','2013-04-15','15:15:00',3.36),('8348','2013-04-15','15:20:00',3.32),('8348','2013-04-15','15:25:00',3.27),('8348','2013-04-15','15:30:00',3.25),('8348','2013-04-15','15:35:00',3.21),('8348','2013-04-15','15:40:00',3.17),('8348','2013-04-15','15:45:00',3.12),('8348','2013-04-15','15:50:00',3.07),('8348','2013-04-15','15:55:00',3.03),('8348','2013-04-15','16:00:00',2.97),('8348','2013-04-15','16:05:00',2.91),('8348','2013-04-15','16:10:00',2.85),('8348','2013-04-15','16:15:00',2.8),('8348','2013-04-15','16:20:00',2.75),('8348','2013-04-15','16:25:00',2.69),('8348','2013-04-15','16:30:00',2.62),('8348','2013-04-15','16:35:00',2.56),('8348','2013-04-15','16:40:00',2.5),('8348','2013-04-15','16:45:00',2.43),('8348','2013-04-15','16:50:00',2.37),('8348','2013-04-15','16:55:00',2.3),('8348','2013-04-15','17:00:00',2.22),('8348','2013-04-15','17:05:00',2.15),('8348','2013-04-15','17:10:00',2.08),('8348','2013-04-15','17:15:00',2.01),('8348','2013-04-15','17:20:00',1.93),('8348','2013-04-15','17:25:00',1.86),('8348','2013-04-15','17:30:00',1.78),('8348','2013-04-15','17:35:00',1.7),('8348','2013-04-15','17:40:00',1.63),('8348','2013-04-15','17:45:00',1.55),('8348','2013-04-15','17:50:00',1.47),('8348','2013-04-15','17:55:00',1.4),('8348','2013-04-15','18:00:00',1.32),('8348','2013-04-15','18:05:00',1.24),('8348','2013-04-15','18:10:00',1.16),('8348','2013-04-15','18:15:00',1.08),('8348','2013-04-15','18:20:00',1),('8348','2013-04-14','08:30:00',1.02),('8348','2013-04-14','08:35:00',1.09),('8348','2013-04-14','08:40:00',1.13),('8348','2013-04-14','08:45:00',1.19),('8348','2013-04-14','08:50:00',1.28),('8348','2013-04-14','08:55:00',1.39),('8348','2013-04-14','09:00:00',1.47),('8348','2013-04-14','09:05:00',1.55),('8348','2013-04-14','09:10:00',1.64),('8348','2013-04-14','09:15:00',1.71),('8348','2013-04-14','09:20:00',1.78),('8348','2013-04-14','09:25:00',1.86),('8348','2013-04-14','09:30:00',1.92),('8348','2013-04-14','09:35:00',1.98),('8348','2013-04-14','09:40:00',2.06),('8348','2013-04-14','09:45:00',2.12),('8348','2013-04-14','09:50:00',2.18),('8348','2013-04-14','09:55:00',2.25),('8348','2013-04-14','10:00:00',2.3),('8348','2013-04-14','10:05:00',2.35),('8348','2013-04-14','10:10:00',2.41),('8348','2013-04-14','10:15:00',2.46),('8348','2013-04-14','10:20:00',2.51),('8348','2013-04-14','10:25:00',2.56),('8348','2013-04-14','10:30:00',2.6),('8348','2013-04-14','10:35:00',2.66),('8348','2013-04-14','10:40:00',2.7),('8348','2013-04-14','10:45:00',2.74),('8348','2013-04-14','10:50:00',2.79),('8348','2013-04-14','10:55:00',2.85),('8348','2013-04-14','11:00:00',2.89),('8348','2013-04-14','11:05:00',2.95),('8348','2013-04-14','11:10:00',2.97),('8348','2013-04-14','11:15:00',3.01),('8348','2013-04-14','11:20:00',3.05),('8348','2013-04-14','11:25:00',3.06),('8348','2013-04-14','11:30:00',3.09),('8348','2013-04-14','11:35:00',3.09),('8348','2013-04-14','11:40:00',3.18),('8348','2013-04-14','11:45:00',3.2),('8348','2013-04-14','11:50:00',3.22),('8348','2013-04-14','11:55:00',3.24),('8348','2013-04-14','12:00:00',3.25),('8348','2013-04-14','12:05:00',3.24),('8348','2013-04-14','12:10:00',3.28),('8348','2013-04-14','12:15:00',3.34),('8348','2013-04-14','12:20:00',3.35),('8348','2013-04-14','12:25:00',3.38),('8348','2013-04-14','12:30:00',3.38),('8348','2013-04-14','12:35:00',3.38),('8348','2013-04-14','12:40:00',3.39),('8348','2013-04-14','12:45:00',3.5),('8348','2013-04-14','12:50:00',3.53),('8348','2013-04-14','12:55:00',3.49),('8348','2013-04-14','13:00:00',3.21),('8348','2013-04-14','13:05:00',3.55),('8348','2013-04-14','13:10:00',3.54),('8348','2013-04-14','13:15:00',3.57),('8348','2013-04-14','13:20:00',3.61),('8348','2013-04-14','13:25:00',3.56),('8348','2013-04-14','13:30:00',3.54),('8348','2013-04-14','13:35:00',3.51),('8348','2013-04-14','13:40:00',3.5),('8348','2013-04-14','13:45:00',3.41),('8348','2013-04-14','13:50:00',3.46),('8348','2013-04-14','13:55:00',3.46),('8348','2013-04-14','14:00:00',3.45),('8348','2013-04-14','14:05:00',3.47),('8348','2013-04-14','14:10:00',3.46),('8348','2013-04-14','14:15:00',3.42),('8348','2013-04-14','14:20:00',3.38),('8348','2013-04-14','14:25:00',3.4),('8348','2013-04-14','14:30:00',3.41),('8348','2013-04-14','14:35:00',3.47),('8348','2013-04-14','14:40:00',3.49),('8348','2013-04-14','14:45:00',3.57),('8348','2013-04-14','14:50:00',3.52),('8348','2013-04-14','14:55:00',3.47),('8348','2013-04-14','15:00:00',3.39),('8348','2013-04-14','15:05:00',3.39),('8348','2013-04-14','15:10:00',3.43),('8348','2013-04-14','15:15:00',3.32),('8348','2013-04-14','15:20:00',3.23),('8348','2013-04-14','15:25:00',2.65),('8348','2013-04-14','15:30:00',2.95),('8348','2013-04-14','15:35:00',3.25),('8348','2013-04-14','15:40:00',3.26),('8348','2013-04-14','15:45:00',3.31),('8348','2013-04-14','15:50:00',3.17),('8348','2013-04-14','15:55:00',3.01),('8348','2013-04-14','16:00:00',2.62),('8348','2013-04-14','16:05:00',2.79),('8348','2013-04-14','16:10:00',2.82),('8348','2013-04-14','16:15:00',2.69),('8348','2013-04-14','16:20:00',2.62),('8348','2013-04-14','16:25:00',2.63),('8348','2013-04-14','16:30:00',2.56),('8348','2013-04-14','16:35:00',2.47),('8348','2013-04-14','16:40:00',2.4),('8348','2013-04-14','16:45:00',2.32),('8348','2013-04-14','16:50:00',2.27),('8348','2013-04-14','16:55:00',2.2),('8348','2013-04-14','17:00:00',2.11),('8348','2013-04-14','17:05:00',2.07),('8348','2013-04-14','17:10:00',2.01),('8348','2013-04-14','17:15:00',1.92),('8348','2013-04-14','17:20:00',1.85),('8348','2013-04-14','17:25:00',1.78),('8348','2013-04-14','17:30:00',1.71),('8348','2013-04-14','17:35:00',1.63),('8348','2013-04-14','17:40:00',1.55),('8348','2013-04-14','17:45:00',1.49),('8348','2013-04-14','17:50:00',1.41),('8348','2013-04-14','17:55:00',1.31),('8348','2013-04-14','18:00:00',1.23),('8348','2013-04-14','18:05:00',1.17),('8348','2013-04-14','18:10:00',1.09),('8348','2013-04-14','18:15:00',1.02),('8348','2013-04-13','08:55:00',1.19),('8348','2013-04-13','09:05:00',1.04),('8348','2013-04-13','09:10:00',1.01),('8348','2013-04-13','09:25:00',1.58),('8348','2013-04-13','09:30:00',1.94),('8348','2013-04-13','09:35:00',1.92),('8348','2013-04-13','09:40:00',1.83),('8348','2013-04-13','09:45:00',2.12),('8348','2013-04-13','09:50:00',2.16),('8348','2013-04-13','09:55:00',2.19),('8348','2013-04-13','10:00:00',2.29),('8348','2013-04-13','10:05:00',2.43),('8348','2013-04-13','10:10:00',2.56),('8348','2013-04-13','10:15:00',1.94),('8348','2013-04-13','10:20:00',2.08),('8348','2013-04-13','10:25:00',2.36),('8348','2013-04-13','10:30:00',2.87),('8348','2013-04-13','10:35:00',2.79),('8348','2013-04-13','10:40:00',2.95),('8348','2013-04-13','10:45:00',2.62),('8348','2013-04-13','10:50:00',2.45),('8348','2013-04-13','10:55:00',3.19),('8348','2013-04-13','11:00:00',1.76),('8348','2013-04-13','11:05:00',2.96),('8348','2013-04-13','11:10:00',2.08),('8348','2013-04-13','11:15:00',2.76),('8348','2013-04-13','11:20:00',2.64),('8348','2013-04-13','11:30:00',2.73),('8348','2013-04-13','11:35:00',3.53),('8348','2013-04-13','11:40:00',3.55),('8348','2013-04-13','11:45:00',3.67),('8348','2013-04-13','11:50:00',1.67),('8348','2013-04-13','11:55:00',3.72),('8348','2013-04-13','12:00:00',3.79),('8348','2013-04-13','12:05:00',3.69),('8348','2013-04-13','12:10:00',3.73),('8348','2013-04-13','12:15:00',3.63),('8348','2013-04-13','12:20:00',2.54),('8348','2013-04-13','12:25:00',3.51),('8348','2013-04-13','12:30:00',3.13),('8348','2013-04-13','12:35:00',3.76),('8348','2013-04-13','12:40:00',3.66),('8348','2013-04-13','12:45:00',3.65),('8348','2013-04-13','12:50:00',3.56),('8348','2013-04-13','12:55:00',3.57),('8348','2013-04-13','13:00:00',3.49),('8348','2013-04-13','13:05:00',3.68),('8348','2013-04-13','13:10:00',3.76),('8348','2013-04-13','13:15:00',3.67),('8348','2013-04-13','13:20:00',3.68),('8348','2013-04-13','13:25:00',3.72),('8348','2013-04-13','13:30:00',3.52),('8348','2013-04-13','13:35:00',3.09),('8348','2013-04-13','13:40:00',2.88),('8348','2013-04-13','13:45:00',3.12),('8348','2013-04-13','13:50:00',2.26),('8348','2013-04-13','13:55:00',1.86),('8348','2013-04-13','14:00:00',1.9),('8348','2013-04-13','14:05:00',2.14),('8348','2013-04-13','14:10:00',1.69),('8348','2013-04-13','14:15:00',2.39),('8348','2013-04-13','14:20:00',3.2),('8348','2013-04-13','14:25:00',3.31),('8348','2013-04-13','14:30:00',3.35),('8348','2013-04-13','14:35:00',3.41),('8348','2013-04-13','14:40:00',3.34),('8348','2013-04-13','14:45:00',3.37),('8348','2013-04-13','14:50:00',3.2),('8348','2013-04-13','14:55:00',3.28),('8348','2013-04-13','15:00:00',3.02),('8348','2013-04-13','15:05:00',2.76),('8348','2013-04-13','15:10:00',2.89),('8348','2013-04-13','15:15:00',2.47),('8348','2013-04-13','15:20:00',2.56),('8348','2013-04-13','15:25:00',2.45),('8348','2013-04-13','15:30:00',2.52),('8348','2013-04-13','15:35:00',2.45),('8348','2013-04-13','15:40:00',2.56),('8348','2013-04-13','15:45:00',2.61),('8348','2013-04-13','15:50:00',2.54),('8348','2013-04-13','15:55:00',2.52),('8348','2013-04-13','16:00:00',2.51),('8348','2013-04-13','16:05:00',2.36),('8348','2013-04-13','16:10:00',2.23),('8348','2013-04-13','16:15:00',2.3),('8348','2013-04-13','16:20:00',2.21),('8348','2013-04-13','16:25:00',2.05),('8348','2013-04-13','16:30:00',1.96),('8348','2013-04-13','16:35:00',1.82),('8348','2013-04-13','16:40:00',1.73),('8348','2013-04-13','16:45:00',1.66),('8348','2013-04-13','16:50:00',1.71),('8348','2013-04-13','16:55:00',1.4),('8348','2013-04-13','17:00:00',1.17),('8348','2013-04-13','17:05:00',1.15),('8348','2013-04-13','17:10:00',1.71),('8348','2013-04-13','17:15:00',1.91),('8348','2013-04-13','17:20:00',1.61),('8348','2013-04-13','17:25:00',1.85),('8348','2013-04-13','17:30:00',1.61),('8348','2013-04-13','17:35:00',1.64),('8348','2013-04-13','17:40:00',1.57),('8348','2013-04-13','17:45:00',1.42),('8348','2013-04-13','17:50:00',1.27),('8348','2013-04-13','17:55:00',1.38),('8348','2013-04-13','18:00:00',1.08),('8348','2013-04-13','18:05:00',1.07),('8348','2013-04-12','08:35:00',1.03),('8348','2013-04-12','08:55:00',1.4),('8348','2013-04-12','09:00:00',1.62),('8348','2013-04-12','09:05:00',1.3),('8348','2013-04-12','09:10:00',1.11),('8348','2013-04-12','09:15:00',1.72),('8348','2013-04-12','09:20:00',2.21),('8348','2013-04-12','09:25:00',1.98),('8348','2013-04-12','09:30:00',1.43),('8348','2013-04-12','09:35:00',1.16),('8348','2013-04-12','09:40:00',1.24),('8348','2013-04-12','09:45:00',1.68),('8348','2013-04-12','10:20:00',2.23),('8348','2013-04-12','10:25:00',2.5),('8348','2013-04-12','10:30:00',1.6),('8348','2013-04-12','10:35:00',2.5),('8348','2013-04-12','10:40:00',3.39),('8348','2013-04-12','10:45:00',3.44),('8348','2013-04-12','10:50:00',3.17),('8348','2013-04-12','10:55:00',1.32),('8348','2013-04-12','11:00:00',1.11),('8348','2013-04-12','11:05:00',1.6),('8348','2013-04-12','11:10:00',1.32),('8348','2013-04-12','11:15:00',3.49),('8348','2013-04-12','11:20:00',3.93),('8348','2013-04-12','11:25:00',3.76),('8348','2013-04-12','11:30:00',3.94),('8348','2013-04-12','11:35:00',3.34),('8348','2013-04-12','11:40:00',1.47),('8348','2013-04-12','11:45:00',1.99),('8348','2013-04-12','11:50:00',1.88),('8348','2013-04-12','11:55:00',3.04),('8348','2013-04-12','12:00:00',3.82),('8348','2013-04-12','12:05:00',3.65),('8348','2013-04-12','12:10:00',3.55),('8348','2013-04-12','12:15:00',3.62),('8348','2013-04-12','12:20:00',3.72),('8348','2013-04-12','12:25:00',3.73),('8348','2013-04-12','12:30:00',3.21),('8348','2013-04-12','12:35:00',3.65),('8348','2013-04-12','12:40:00',3.53),('8348','2013-04-12','12:45:00',3.56),('8348','2013-04-12','12:50:00',3.15),('8348','2013-04-12','12:55:00',2.64),('8348','2013-04-12','13:00:00',3.68),('8348','2013-04-12','13:05:00',3.73),('8348','2013-04-12','13:10:00',3.71),('8348','2013-04-12','13:15:00',3.73),('8348','2013-04-12','13:20:00',3.74),('8348','2013-04-12','13:25:00',3.72),('8348','2013-04-12','13:30:00',3.7),('8348','2013-04-12','13:35:00',3.72),('8348','2013-04-12','13:40:00',3.65),('8348','2013-04-12','13:45:00',3.68),('8348','2013-04-12','13:50:00',3.66),('8348','2013-04-12','13:55:00',3.67),('8348','2013-04-12','14:00:00',3.69),('8348','2013-04-12','14:05:00',3.68),('8348','2013-04-12','14:10:00',3.65),('8348','2013-04-12','14:15:00',3.62),('8348','2013-04-12','14:20:00',3.58),('8348','2013-04-12','14:25:00',3.56),('8348','2013-04-12','14:30:00',3.55),('8348','2013-04-12','14:35:00',3.53),('8348','2013-04-12','14:40:00',3.49),('8348','2013-04-12','14:45:00',3.47),('8348','2013-04-12','14:50:00',3.45),('8348','2013-04-12','14:55:00',3.41),('8348','2013-04-12','15:00:00',3.38),('8348','2013-04-12','15:05:00',3.34),('8348','2013-04-12','15:10:00',3.3),('8348','2013-04-12','15:15:00',3.24),('8348','2013-04-12','15:20:00',3.22),('8348','2013-04-12','15:25:00',3.19),('8348','2013-04-12','15:30:00',3.15),('8348','2013-04-12','15:35:00',3.1),('8348','2013-04-12','15:40:00',3.07),('8348','2013-04-12','15:45:00',3.06),('8348','2013-04-12','15:50:00',3.03),('8348','2013-04-12','15:55:00',2.97),('8348','2013-04-12','16:00:00',2.94),('8348','2013-04-12','16:05:00',2.89),('8348','2013-04-12','16:10:00',2.88),('8348','2013-04-12','16:15:00',2.51),('8348','2013-04-12','16:20:00',2.7),('8348','2013-04-12','16:25:00',2.68),('8348','2013-04-12','16:30:00',1.59),('8348','2013-04-12','16:35:00',1.29),('8348','2013-04-12','16:40:00',1.6),('8348','2013-04-12','16:45:00',2.5),('8348','2013-04-12','16:50:00',2.34),('8348','2013-04-12','16:55:00',2.28),('8348','2013-04-12','17:00:00',2.2),('8348','2013-04-12','17:05:00',2.12),('8348','2013-04-12','17:10:00',2.03),('8348','2013-04-12','17:15:00',1.96),('8348','2013-04-12','17:20:00',1.88),('8348','2013-04-12','17:25:00',1.81),('8348','2013-04-12','17:30:00',1.78),('8348','2013-04-12','17:35:00',1.68),('8348','2013-04-12','17:40:00',1.59),('8348','2013-04-12','17:45:00',1.47),('8348','2013-04-12','17:50:00',1.41),('8348','2013-04-12','17:55:00',1.34),('8348','2013-04-12','18:00:00',1.26),('8348','2013-04-12','18:05:00',1.18),('8348','2013-04-12','18:10:00',1.07),('8348','2014-03-28','07:15:00',1.02),('8348','2014-03-28','07:20:00',1.07),('8348','2014-03-28','07:25:00',1.11),('8348','2014-03-28','07:30:00',1.19),('8348','2014-03-28','07:35:00',1.31),('8348','2014-03-28','07:40:00',1.4),('8348','2014-03-28','07:45:00',1.72),('8348','2014-03-28','07:50:00',1.82),('8348','2014-03-28','07:55:00',1.91),('8348','2014-03-28','08:00:00',2),('8348','2014-03-28','08:05:00',2.14),('8348','2014-03-28','08:10:00',2.27),('8348','2014-03-28','08:15:00',2.41),('8348','2014-03-28','08:20:00',2.55),('8348','2014-03-28','08:25:00',2.7),('8348','2014-03-28','08:30:00',3.1),('8348','2014-03-28','08:35:00',3.32),('8348','2014-03-28','08:40:00',3.5),('8348','2014-03-28','08:45:00',3.65),('8348','2014-03-28','08:50:00',3.87),('8348','2014-03-28','08:55:00',4.05),('8348','2014-03-28','09:00:00',4.17),('8348','2014-03-28','09:05:00',4.51),('8348','2014-03-28','09:10:00',4.77),('8348','2014-03-28','09:15:00',4.71),('8348','2014-03-28','09:20:00',4.33),('8348','2014-03-28','09:25:00',5.29),('8348','2014-03-28','09:30:00',5.48),('8348','2014-03-28','09:35:00',4.7),('8348','2014-03-28','09:40:00',3.05),('8348','2014-03-28','09:45:00',2.7),('8348','2014-03-28','09:50:00',3.91),('8348','2014-03-28','09:55:00',5.63),('8348','2014-03-28','10:00:00',5.8),('8348','2014-03-28','10:05:00',5.84),('8348','2014-03-28','10:10:00',4.87),('8348','2014-03-28','10:15:00',4.33),('8348','2014-03-28','10:20:00',4.03),('8348','2014-03-28','10:25:00',5.93),('8348','2014-03-28','10:30:00',6.01),('8348','2014-03-28','10:35:00',5.86),('8348','2014-03-28','10:40:00',5.55),('8348','2014-03-28','10:45:00',4.39),('8348','2014-03-28','10:50:00',6.51),('8348','2014-03-28','10:55:00',6.53),('8348','2014-03-28','11:00:00',6.06),('8348','2014-03-28','11:05:00',5.62),('8348','2014-03-28','11:10:00',5.04),('8348','2014-03-28','11:15:00',4.71),('8348','2014-03-28','11:20:00',3.43),('8348','2014-03-28','11:25:00',4.21),('8348','2014-03-28','11:30:00',4.73),('8348','2014-03-28','11:35:00',2.84),('8348','2014-03-28','11:40:00',2.56),('8348','2014-03-28','11:45:00',5.87),('8348','2014-03-28','11:50:00',2.78),('8348','2014-03-28','11:55:00',2.19),('8348','2014-03-28','12:00:00',3.31),('8348','2014-03-28','12:05:00',7.66),('8348','2014-03-28','12:10:00',7.66),('8348','2014-03-28','12:15:00',8.05),('8348','2014-03-28','12:20:00',6.02),('8348','2014-03-28','12:25:00',2.19),('8348','2014-03-28','12:30:00',1.71),('8348','2014-03-28','12:35:00',7.03),('8348','2014-03-28','12:40:00',6.87),('8348','2014-03-28','12:45:00',7.41),('8348','2014-03-28','12:50:00',7.54),('8348','2014-03-28','12:55:00',8.1),('8348','2014-03-28','13:00:00',8.42),('8348','2014-03-28','13:05:00',2.69),('8348','2014-03-28','13:10:00',2.57),('8348','2014-03-28','13:15:00',4.32),('8348','2014-03-28','13:20:00',4.55),('8348','2014-03-28','13:25:00',2.59),('8348','2014-03-28','13:30:00',2.94),('8348','2014-03-28','13:35:00',5.6),('8348','2014-03-28','13:40:00',7.75),('8348','2014-03-28','13:45:00',7.21),('8348','2014-03-28','13:50:00',6.9),('8348','2014-03-28','13:55:00',6.71),('8348','2014-03-28','14:00:00',6.82),('8348','2014-03-28','14:05:00',6.73),('8348','2014-03-28','14:10:00',6.53),('8348','2014-03-28','14:15:00',6.55),('8348','2014-03-28','14:20:00',6.48),('8348','2014-03-28','14:25:00',6.41),('8348','2014-03-28','14:30:00',6.34),('8348','2014-03-28','14:35:00',6.27),('8348','2014-03-28','14:40:00',6.21),('8348','2014-03-28','14:45:00',6.12),('8348','2014-03-28','14:50:00',6.07),('8348','2014-03-28','14:55:00',5.97),('8348','2014-03-28','15:00:00',5.91),('8348','2014-03-28','15:05:00',5.79),('8348','2014-03-28','15:10:00',5.64),('8348','2014-03-28','15:15:00',5.51),('8348','2014-03-28','15:20:00',5.37),('8348','2014-03-28','15:25:00',5.25),('8348','2014-03-28','15:30:00',5.16),('8348','2014-03-28','15:35:00',5.06),('8348','2014-03-28','15:40:00',4.95),('8348','2014-03-28','15:45:00',4.97),('8348','2014-03-28','15:50:00',4.88),('8348','2014-03-28','15:55:00',4.79),('8348','2014-03-28','16:00:00',4.9),('8348','2014-03-28','16:05:00',5),('8348','2014-03-28','16:10:00',4.82),('8348','2014-03-28','16:15:00',4.57),('8348','2014-03-28','16:20:00',3.91),('8348','2014-03-28','16:25:00',3.56),('8348','2014-03-28','16:30:00',3.31),('8348','2014-03-28','16:35:00',2.06),('8348','2014-03-28','16:40:00',1.37),('8348','2014-03-28','16:45:00',2.27),('8348','2014-03-28','16:50:00',2.15),('8348','2014-03-28','17:00:00',1.6),('8348','2014-03-28','17:05:00',1.87),('8348','2014-03-28','17:10:00',1.94),('8348','2014-03-28','17:15:00',1.96),('8348','2014-03-28','17:20:00',1.96),('8348','2014-03-28','17:35:00',1.06),('8348','2014-03-28','17:40:00',1.02),('8348','2014-03-28','17:45:00',1.06),('8348','2013-04-11','08:35:00',1.05),('8348','2013-04-11','08:40:00',1.12),('8348','2013-04-11','08:45:00',1.19),('8348','2013-04-11','08:50:00',1.24),('8348','2013-04-11','08:55:00',1.35),('8348','2013-04-11','09:00:00',1.41),('8348','2013-04-11','09:05:00',1.5),('8348','2013-04-11','09:10:00',1.59),('8348','2013-04-11','09:15:00',1.68),('8348','2013-04-11','09:20:00',1.75),('8348','2013-04-11','09:25:00',1.8),('8348','2013-04-11','09:30:00',1.85),('8348','2013-04-11','09:35:00',1.93),('8348','2013-04-11','09:40:00',1.94),('8348','2013-04-11','09:45:00',2.15),('8348','2013-04-11','09:50:00',1.68),('8348','2013-04-11','09:55:00',1.38),('8348','2013-04-11','10:00:00',1.84),('8348','2013-04-11','10:05:00',2.28),('8348','2013-04-11','10:10:00',1.64),('8348','2013-04-11','10:15:00',2.51),('8348','2013-04-11','10:20:00',2.58),('8348','2013-04-11','10:25:00',2.77),('8348','2013-04-11','10:30:00',2.92),('8348','2013-04-11','10:35:00',2.78),('8348','2013-04-11','10:40:00',2.8),('8348','2013-04-11','10:45:00',1.94),('8348','2013-04-11','10:50:00',1.11),('8348','2013-04-11','11:05:00',3.13),('8348','2013-04-11','11:10:00',3.37),('8348','2013-04-11','11:15:00',3.23),('8348','2013-04-11','11:20:00',1.63),('8348','2013-04-11','11:25:00',3.05),('8348','2013-04-11','11:30:00',3.53),('8348','2013-04-11','11:35:00',1.62),('8348','2013-04-11','11:40:00',1.08),('8348','2013-04-11','11:45:00',1),('8348','2013-04-11','11:50:00',1.1),('8348','2013-04-11','11:55:00',3.68),('8348','2013-04-11','12:00:00',3.64),('8348','2013-04-11','12:05:00',3.85),('8348','2013-04-11','12:10:00',2.73),('8348','2013-04-11','12:15:00',1.68),('8348','2013-04-11','12:20:00',2.2),('8348','2013-04-11','12:25:00',3.9),('8348','2013-04-11','12:30:00',3.35),('8348','2013-04-11','12:35:00',1.39),('8348','2013-04-11','12:40:00',4.02),('8348','2013-04-11','12:45:00',3.89),('8348','2013-04-11','12:50:00',3.47),('8348','2013-04-11','12:55:00',3.03),('8348','2013-04-11','13:00:00',3.77),('8348','2013-04-11','13:05:00',3.05),('8348','2013-04-11','13:10:00',3.86),('8348','2013-04-11','13:15:00',3.69),('8348','2013-04-11','13:20:00',3.27),('8348','2013-04-11','13:25:00',3.83),('8348','2013-04-11','13:30:00',3.76),('8348','2013-04-11','13:35:00',3.49),('8348','2013-04-11','13:40:00',3.76),('8348','2013-04-11','13:45:00',3.68),('8348','2013-04-11','13:50:00',3.67),('8348','2013-04-11','13:55:00',3.75),('8348','2013-04-11','14:00:00',3.71),('8348','2013-04-11','14:05:00',3.75),('8348','2013-04-11','14:10:00',3.77),('8348','2013-04-11','14:15:00',3.74),('8348','2013-04-11','14:20:00',3.72),('8348','2013-04-11','14:25:00',3.64),('8348','2013-04-11','14:30:00',3.62),('8348','2013-04-11','14:35:00',3.38),('8348','2013-04-11','14:40:00',3.71),('8348','2013-04-11','14:45:00',3.62),('8348','2013-04-11','14:50:00',3.57),('8348','2013-04-11','14:55:00',3.55),('8348','2013-04-11','15:00:00',3.48),('8348','2013-04-11','15:05:00',3.41),('8348','2013-04-11','15:10:00',3.39),('8348','2013-04-11','15:15:00',3.37),('8348','2013-04-11','15:20:00',3.34),('8348','2013-04-11','15:25:00',3.3),('8348','2013-04-11','15:30:00',3.24),('8348','2013-04-11','15:35:00',3.21),('8348','2013-04-11','15:40:00',3.16),('8348','2013-04-11','15:45:00',3.11),('8348','2013-04-11','15:50:00',3.07),('8348','2013-04-11','15:55:00',3.03),('8348','2013-04-11','16:00:00',2.98),('8348','2013-04-11','16:05:00',2.93),('8348','2013-04-11','16:10:00',2.88),('8348','2013-04-11','16:15:00',2.82),('8348','2013-04-11','16:20:00',2.77),('8348','2013-04-11','16:25:00',2.71),('8348','2013-04-11','16:30:00',2.66),('8348','2013-04-11','16:35:00',2.59),('8348','2013-04-11','16:40:00',2.52),('8348','2013-04-11','16:45:00',2.47),('8348','2013-04-11','16:50:00',2.39),('8348','2013-04-11','16:55:00',2.34),('8348','2013-04-11','17:00:00',2.24),('8348','2013-04-11','17:05:00',2.17),('8348','2013-04-11','17:10:00',2.09),('8348','2013-04-11','17:15:00',2.03),('8348','2013-04-11','17:20:00',1.94),('8348','2013-04-11','17:25:00',1.86),('8348','2013-04-11','17:30:00',1.8),('8348','2013-04-11','17:35:00',1.73),('8348','2013-04-11','17:40:00',1.66),('8348','2013-04-11','17:45:00',1.57),('8348','2013-04-11','17:50:00',1.49),('8348','2013-04-11','17:55:00',1.39),('8348','2013-04-11','18:00:00',1.26),('8348','2013-04-11','18:05:00',1.17),('8348','2013-04-11','18:10:00',1.03),('8348','2013-04-11','18:15:00',1.05),('8348','2013-04-11','18:20:00',1.03),('8348','2013-04-10','08:55:00',1.28),('8348','2013-04-10','09:00:00',1.42),('8348','2013-04-10','09:05:00',1.54),('8348','2013-04-10','09:10:00',1.66),('8348','2013-04-10','09:15:00',1.75),('8348','2013-04-10','09:20:00',1.77),('8348','2013-04-10','09:25:00',1.77),('8348','2013-04-10','09:30:00',1.86),('8348','2013-04-10','09:35:00',1.99),('8348','2013-04-10','09:40:00',2.08),('8348','2013-04-10','09:45:00',2.11),('8348','2013-04-10','09:50:00',2.24),('8348','2013-04-10','09:55:00',2.33),('8348','2013-04-10','10:00:00',2.38),('8348','2013-04-10','10:05:00',2.52),('8348','2013-04-10','10:10:00',2.67),('8348','2013-04-10','10:15:00',2.74),('8348','2013-04-10','10:20:00',2.79),('8348','2013-04-10','10:25:00',2.83),('8348','2013-04-10','10:30:00',2.86),('8348','2013-04-10','10:35:00',2.9),('8348','2013-04-10','10:40:00',2.83),('8348','2013-04-10','10:45:00',3.04),('8348','2013-04-10','10:50:00',2.86),('8348','2013-04-10','10:55:00',2.87),('8348','2013-04-10','11:00:00',2.83),('8348','2013-04-10','11:05:00',2.92),('8348','2013-04-10','11:10:00',3.03),('8348','2013-04-10','11:15:00',3.02),('8348','2013-04-10','11:20:00',3.15),('8348','2013-04-10','11:25:00',3.29),('8348','2013-04-10','11:30:00',3.29),('8348','2013-04-10','11:35:00',3.36),('8348','2013-04-10','11:40:00',3.4),('8348','2013-04-10','11:45:00',3.4),('8348','2013-04-10','11:50:00',3.47),('8348','2013-04-10','11:55:00',3.52),('8348','2013-04-10','12:00:00',3.57),('8348','2013-04-10','12:05:00',3.64),('8348','2013-04-10','12:10:00',3.66),('8348','2013-04-10','12:15:00',3.73),('8348','2013-04-10','12:20:00',3.75),('8348','2013-04-10','12:25:00',3.79),('8348','2013-04-10','12:30:00',3.84),('8348','2013-04-10','12:35:00',3.73),('8348','2013-04-10','12:40:00',3.81),('8348','2013-04-10','12:45:00',3.8),('8348','2013-04-10','12:50:00',3.57),('8348','2013-04-10','12:55:00',3.27),('8348','2013-04-10','13:00:00',3.71),('8348','2013-04-10','13:05:00',2.11),('8348','2013-04-10','13:10:00',1.53),('8348','2013-04-10','13:15:00',2.19),('8348','2013-04-10','13:20:00',3.37),('8348','2013-04-10','13:25:00',3.96),('8348','2013-04-10','13:30:00',3.26),('8348','2013-04-10','13:35:00',4.3),('8348','2013-04-10','13:40:00',2.5),('8348','2013-04-10','13:45:00',2.43),('8348','2013-04-10','13:50:00',3.86),('8348','2013-04-10','13:55:00',3.66),('8348','2013-04-10','14:00:00',3.87),('8348','2013-04-10','14:05:00',3.83),('8348','2013-04-10','14:10:00',3.84),('8348','2013-04-10','14:15:00',3.77),('8348','2013-04-10','14:20:00',3.77),('8348','2013-04-10','14:25:00',3.82),('8348','2013-04-10','14:30:00',3.83),('8348','2013-04-10','14:35:00',3.75),('8348','2013-04-10','14:40:00',3.74),('8348','2013-04-10','14:45:00',3.8),('8348','2013-04-10','14:50:00',3.79),('8348','2013-04-10','14:55:00',3.67),('8348','2013-04-10','15:00:00',2.99),('8348','2013-04-10','15:05:00',3.74),('8348','2013-04-10','15:10:00',3.32),('8348','2013-04-10','15:15:00',3.45),('8348','2013-04-10','15:20:00',3.63),('8348','2013-04-10','15:25:00',3.4),('8348','2013-04-10','15:30:00',3.29),('8348','2013-04-10','15:35:00',3.26),('8348','2013-04-10','15:40:00',2.53),('8348','2013-04-10','15:45:00',3.2),('8348','2013-04-10','15:50:00',3.2),('8348','2013-04-10','15:55:00',2.92),('8348','2013-04-10','16:00:00',2.62),('8348','2013-04-10','16:05:00',3),('8348','2013-04-10','16:10:00',2.98),('8348','2013-04-10','16:15:00',2.24),('8348','2013-04-10','16:20:00',2.37),('8348','2013-04-10','16:25:00',2.85),('8348','2013-04-10','16:30:00',1.7),('8348','2013-04-10','16:35:00',1.62),('8348','2013-04-10','16:40:00',2.56),('8348','2013-04-10','16:45:00',2.42),('8348','2013-04-10','16:50:00',2.04),('8348','2013-04-10','16:55:00',2.09),('8348','2013-04-10','17:00:00',2.26),('8348','2013-04-10','17:05:00',1.48),('8348','2013-04-10','17:10:00',1.79),('8348','2013-04-10','17:15:00',2.24),('8348','2013-04-10','17:20:00',2.07),('8348','2013-04-10','17:25:00',1.95),('8348','2013-04-10','17:30:00',1.8),('8348','2013-04-10','17:35:00',1.73),('8348','2013-04-10','17:45:00',1.6),('8348','2013-04-10','17:55:00',1.36),('8348','2013-04-10','18:05:00',1.06),('8348','2013-04-10','18:10:00',1.01),('8348','2013-04-09','09:45:00',1.07),('8348','2013-04-09','09:50:00',2.25),('8348','2013-04-09','09:55:00',2.36),('8348','2013-04-09','10:00:00',1.46),('8348','2013-04-09','10:10:00',1.24),('8348','2013-04-09','10:15:00',2.14),('8348','2013-04-09','10:20:00',1.18),('8348','2013-04-09','10:30:00',1.1),('8348','2013-04-09','10:35:00',2.42),('8348','2013-04-09','10:40:00',2.16),('8348','2013-04-09','10:45:00',2.74),('8348','2013-04-09','10:50:00',3.52),('8348','2013-04-09','10:55:00',2.72),('8348','2013-04-09','11:00:00',3.15),('8348','2013-04-09','11:05:00',3.44),('8348','2013-04-09','11:10:00',3.25),('8348','2013-04-09','11:15:00',1.25),('8348','2013-04-09','11:20:00',1.37),('8348','2013-04-09','11:25:00',3.61),('8348','2013-04-09','11:30:00',3.55),('8348','2013-04-09','11:35:00',1.8),('8348','2013-04-09','11:45:00',3),('8348','2013-04-09','11:50:00',3.92),('8348','2013-04-09','11:55:00',2.97),('8348','2013-04-09','12:00:00',3.97),('8348','2013-04-09','12:05:00',3.9),('8348','2013-04-09','12:10:00',3.95),('8348','2013-04-09','12:15:00',3.97),('8348','2013-04-09','12:20:00',2.44),('8348','2013-04-09','12:25:00',3.78),('8348','2013-04-09','12:30:00',3.73),('8348','2013-04-09','12:35:00',3.55),('8348','2013-04-09','12:40:00',3.94),('8348','2013-04-09','12:45:00',3.57),('8348','2013-04-09','12:50:00',4.09),('8348','2013-04-09','12:55:00',3.97),('8348','2013-04-09','13:00:00',4),('8348','2013-04-09','13:05:00',4.23),('8348','2013-04-09','13:10:00',4.33),('8348','2013-04-09','13:15:00',3.89),('8348','2013-04-09','13:20:00',3.26),('8348','2013-04-09','13:25:00',4.07),('8348','2013-04-09','13:30:00',2.62),('8348','2013-04-09','13:35:00',1.81),('8348','2013-04-09','13:40:00',1.57),('8348','2013-04-09','13:45:00',1.44),('8348','2013-04-09','13:50:00',3.76),('8348','2013-04-09','13:55:00',3.84),('8348','2013-04-09','14:00:00',3.59),('8348','2013-04-09','14:05:00',2.81),('8348','2013-04-09','14:10:00',3.2),('8348','2013-04-09','14:15:00',3.6),('8348','2013-04-09','14:20:00',1.62),('8348','2013-04-09','14:25:00',3.25),('8348','2013-04-09','14:30:00',3.61),('8348','2013-04-09','14:35:00',3.44),('8348','2013-04-09','14:40:00',3.53),('8348','2013-04-09','14:45:00',3.28),('8348','2013-04-09','14:50:00',3.19),('8348','2013-04-09','14:55:00',2.79),('8348','2013-04-09','15:00:00',2.68),('8348','2013-04-09','15:05:00',3.53),('8348','2013-04-09','15:10:00',3.58),('8348','2013-04-09','15:15:00',2.84),('8348','2013-04-09','15:20:00',3.57),('8348','2013-04-09','15:25:00',3.57),('8348','2013-04-09','15:30:00',2.67),('8348','2013-04-09','15:35:00',3.13),('8348','2013-04-09','15:40:00',3.43),('8348','2013-04-09','15:45:00',2.99),('8348','2013-04-09','15:50:00',3.23),('8348','2013-04-09','15:55:00',2.71),('8348','2013-04-09','16:00:00',2.57),('8348','2013-04-09','16:05:00',2.6),('8348','2013-04-09','16:10:00',2.56),('8348','2013-04-09','16:15:00',2.72),('8348','2013-04-09','16:20:00',1.18),('8348','2013-04-09','16:35:00',1.26),('8348','2013-04-09','16:40:00',1.25),('8348','2013-04-09','16:50:00',2.37),('8348','2013-04-09','16:55:00',1.94),('8348','2013-04-09','17:30:00',1.11),('8348','2013-04-08','08:45:00',1),('8348','2013-04-08','08:50:00',1.09),('8348','2013-04-08','09:00:00',1.1),('8348','2013-04-08','09:05:00',1.1),('8348','2013-04-08','09:10:00',1.47),('8348','2013-04-08','09:15:00',1.89),('8348','2013-04-08','09:20:00',1.97),('8348','2013-04-08','09:25:00',1.91),('8348','2013-04-08','09:30:00',1.96),('8348','2013-04-08','09:35:00',2.13),('8348','2013-04-08','09:40:00',2.19),('8348','2013-04-08','09:45:00',2.26),('8348','2013-04-08','09:50:00',1.39),('8348','2013-04-08','09:55:00',1.42),('8348','2013-04-08','10:00:00',2.4),('8348','2013-04-08','10:05:00',2.55),('8348','2013-04-08','10:10:00',2.4),('8348','2013-04-08','10:15:00',2.55),('8348','2013-04-08','10:20:00',2.56),('8348','2013-04-08','10:25:00',2.58),('8348','2013-04-08','10:30:00',2.62),('8348','2013-04-08','10:35:00',2.51),('8348','2013-04-08','10:40:00',2.77),('8348','2013-04-08','10:45:00',2.95),('8348','2013-04-08','10:50:00',3),('8348','2013-04-08','10:55:00',2.87),('8348','2013-04-08','11:00:00',3.06),('8348','2013-04-08','11:05:00',2.66),('8348','2013-04-08','11:10:00',2.51),('8348','2013-04-08','11:15:00',2.4),('8348','2013-04-08','11:20:00',2.01),('8348','2013-04-08','11:25:00',1.76),('8348','2013-04-08','11:30:00',2),('8348','2013-04-08','11:35:00',2.57),('8348','2013-04-08','11:40:00',2.73),('8348','2013-04-08','11:45:00',2.48),('8348','2013-04-08','11:50:00',2.31),('8348','2013-04-08','11:55:00',2.06),('8348','2013-04-08','12:00:00',1.97),('8348','2013-04-08','12:05:00',1.89),('8348','2013-04-08','12:10:00',2.03),('8348','2013-04-08','12:15:00',2.38),('8348','2013-04-08','12:20:00',2.38),('8348','2013-04-08','12:25:00',2.4),('8348','2013-04-08','12:30:00',2.65),('8348','2013-04-08','12:35:00',2.53),('8348','2013-04-08','12:40:00',2.18),('8348','2013-04-08','12:45:00',2.96),('8348','2013-04-08','12:50:00',2.84),('8348','2013-04-08','12:55:00',2.6),('8348','2013-04-08','13:00:00',1.67),('8348','2013-04-08','13:05:00',2.33),('8348','2013-04-08','13:10:00',2.52),('8348','2013-04-08','13:15:00',2.63),('8348','2013-04-08','13:20:00',3.34),('8348','2013-04-08','13:25:00',2.87),('8348','2013-04-08','13:30:00',2.53),('8348','2013-04-08','13:35:00',2.38),('8348','2013-04-08','13:40:00',2.21),('8348','2013-04-08','13:45:00',2.8),('8348','2013-04-08','13:50:00',2.81),('8348','2013-04-08','13:55:00',3.54),('8348','2013-04-08','14:00:00',3.34),('8348','2013-04-08','14:05:00',2.91),('8348','2013-04-08','14:10:00',3.02),('8348','2013-04-08','14:15:00',3.45),('8348','2013-04-08','14:20:00',3.06),('8348','2013-04-08','14:25:00',3.61),('8348','2013-04-08','14:30:00',3.51),('8348','2013-04-08','14:35:00',3.29),('8348','2013-04-08','14:40:00',3.27),('8348','2013-04-08','14:45:00',3.32),('8348','2013-04-08','14:50:00',3.32),('8348','2013-04-08','14:55:00',3.45),('8348','2013-04-08','15:00:00',2.66),('8348','2013-04-08','15:05:00',2.67),('8348','2013-04-08','15:10:00',2.66),('8348','2013-04-08','15:15:00',2.75),('8348','2013-04-08','15:20:00',2.52),('8348','2013-04-08','15:25:00',3.26),('8348','2013-04-08','15:30:00',3.35),('8348','2013-04-08','15:35:00',3.22),('8348','2013-04-08','15:40:00',3.15),('8348','2013-04-08','15:45:00',3.09),('8348','2013-04-08','15:50:00',3.09),('8348','2013-04-08','15:55:00',3.01),('8348','2013-04-08','16:00:00',2.96),('8348','2013-04-08','16:05:00',2.81),('8348','2013-04-08','16:10:00',2.65),('8348','2013-04-08','16:15:00',2.79),('8348','2013-04-08','16:20:00',2.81),('8348','2013-04-08','16:25:00',2.69),('8348','2013-04-08','16:30:00',2.63),('8348','2013-04-08','16:35:00',2.55),('8348','2013-04-08','16:40:00',2.51),('8348','2013-04-08','16:45:00',2.46),('8348','2013-04-08','16:50:00',2.41),('8348','2013-04-08','16:55:00',2.33),('8348','2013-04-08','17:00:00',2.27),('8348','2013-04-08','17:05:00',2.21),('8348','2013-04-08','17:10:00',2.08),('8348','2013-04-08','17:15:00',2.02),('8348','2013-04-08','17:20:00',1.9),('8348','2013-04-08','17:25:00',1.95),('8348','2013-04-08','17:30:00',1.81),('8348','2013-04-08','17:35:00',1.7),('8348','2013-04-08','17:40:00',1.54),('8348','2013-04-08','17:45:00',1.47),('8348','2013-04-08','17:50:00',1.2),('8348','2013-04-08','17:55:00',1.04),('8348','2013-04-08','18:00:00',1.12),('8348','2013-04-08','18:20:00',1.28),('8348','2013-04-08','18:25:00',1.15),('8348','2013-04-07','09:05:00',1.03),('8348','2013-04-07','09:10:00',1.11),('8348','2013-04-07','09:15:00',1.16),('8348','2013-04-07','09:20:00',1.23),('8348','2013-04-07','09:25:00',1.25),('8348','2013-04-07','09:30:00',1.18),('8348','2013-04-07','09:35:00',1.13),('8348','2013-04-07','09:40:00',1.13),('8348','2013-04-07','09:45:00',1.32),('8348','2013-04-07','09:50:00',1.61),('8348','2013-04-07','09:55:00',1.73),('8348','2013-04-07','10:00:00',2.02),('8348','2013-04-07','10:05:00',2.17),('8348','2013-04-07','10:10:00',2.15),('8348','2013-04-07','10:15:00',2.23),('8348','2013-04-07','10:20:00',2.28),('8348','2013-04-07','10:25:00',2.37),('8348','2013-04-07','10:30:00',2.07),('8348','2013-04-07','10:35:00',2.18),('8348','2013-04-07','10:40:00',2.25),('8348','2013-04-07','10:45:00',2.19),('8348','2013-04-07','10:50:00',2.19),('8348','2013-04-07','10:55:00',1.97),('8348','2013-04-07','11:00:00',1.79),('8348','2013-04-07','11:05:00',1.6),('8348','2013-04-07','11:10:00',1.75),('8348','2013-04-07','11:15:00',2.34),('8348','2013-04-07','11:20:00',2.89),('8348','2013-04-07','11:25:00',3.16),('8348','2013-04-07','11:30:00',3.15),('8348','2013-04-07','11:35:00',2.96),('8348','2013-04-07','11:40:00',2.73),('8348','2013-04-07','11:45:00',2.21),('8348','2013-04-07','11:50:00',1.98),('8348','2013-04-07','11:55:00',2.11),('8348','2013-04-07','12:00:00',2.13),('8348','2013-04-07','12:05:00',2.15),('8348','2013-04-07','12:10:00',2.32),('8348','2013-04-07','12:15:00',2.29),('8348','2013-04-07','12:20:00',2.39),('8348','2013-04-07','12:25:00',2.69),('8348','2013-04-07','12:30:00',2.5),('8348','2013-04-07','12:35:00',2.52),('8348','2013-04-07','12:40:00',2.54),('8348','2013-04-07','12:45:00',2.16),('8348','2013-04-07','12:50:00',2.33),('8348','2013-04-07','12:55:00',2.32),('8348','2013-04-07','13:00:00',2.76),('8348','2013-04-07','13:05:00',3.1),('8348','2013-04-07','13:10:00',2.95),('8348','2013-04-07','13:15:00',2.68),('8348','2013-04-07','13:20:00',2.53),('8348','2013-04-07','13:25:00',2.85),('8348','2013-04-07','13:30:00',2.67),('8348','2013-04-07','13:35:00',2.66),('8348','2013-04-07','13:40:00',2.95),('8348','2013-04-07','13:45:00',2.94),('8348','2013-04-07','13:50:00',2.62),('8348','2013-04-07','13:55:00',2.49),('8348','2013-04-07','14:00:00',3.24),('8348','2013-04-07','14:05:00',3.03),('8348','2013-04-07','14:10:00',1.63),('8348','2013-04-07','14:15:00',2.32),('8348','2013-04-07','14:20:00',2.14),('8348','2013-04-07','14:25:00',1.81),('8348','2013-04-07','14:30:00',1.52),('8348','2013-04-07','14:35:00',1.96),('8348','2013-04-07','14:40:00',1.84),('8348','2013-04-07','14:45:00',1.91),('8348','2013-04-07','14:50:00',2.07),('8348','2013-04-07','14:55:00',1.98),('8348','2013-04-07','15:00:00',1.81),('8348','2013-04-07','15:05:00',2.59),('8348','2013-04-07','15:10:00',2.48),('8348','2013-04-07','15:15:00',2.63),('8348','2013-04-07','15:20:00',2.65),('8348','2013-04-07','15:25:00',2.75),('8348','2013-04-07','15:30:00',2.6),('8348','2013-04-07','15:35:00',2.66),('8348','2013-04-07','15:40:00',2.27),('8348','2013-04-07','15:45:00',2.41),('8348','2013-04-07','15:50:00',2.39),('8348','2013-04-07','15:55:00',1.88),('8348','2013-04-07','16:00:00',2.2),('8348','2013-04-07','16:05:00',1.92),('8348','2013-04-07','16:10:00',1.66),('8348','2013-04-07','16:15:00',1.45),('8348','2013-04-07','16:20:00',1.36),('8348','2013-04-07','16:25:00',1.27),('8348','2013-04-07','16:30:00',1.35),('8348','2013-04-07','16:35:00',1.69),('8348','2013-04-07','16:40:00',1.68);
INSERT INTO `solarlogmod` VALUES ('8348','2013-04-07','16:45:00',2.13),('8348','2013-04-07','16:50:00',2.21),('8348','2013-04-07','16:55:00',2.15),('8348','2013-04-07','17:00:00',2.01),('8348','2013-04-07','17:05:00',1.85),('8348','2013-04-07','17:10:00',1.19),('8348','2013-04-07','17:20:00',1.61),('8348','2013-04-07','17:25:00',1.95),('8348','2013-04-07','17:30:00',1.8),('8348','2013-04-07','17:35:00',1.73),('8348','2013-04-07','17:40:00',1.74),('8348','2013-04-07','17:45:00',1.65),('8348','2013-04-07','17:50:00',1.52),('8348','2013-04-07','17:55:00',1.26),('8348','2013-04-06','08:40:00',1.04),('8348','2013-04-06','08:45:00',1.11),('8348','2013-04-06','08:50:00',1.18),('8348','2013-04-06','08:55:00',1.23),('8348','2013-04-06','09:00:00',1.33),('8348','2013-04-06','09:05:00',1.42),('8348','2013-04-06','09:10:00',1.5),('8348','2013-04-06','09:15:00',1.58),('8348','2013-04-06','09:20:00',1.7),('8348','2013-04-06','09:25:00',1.79),('8348','2013-04-06','09:30:00',1.85),('8348','2013-04-06','09:35:00',1.88),('8348','2013-04-06','09:40:00',1.98),('8348','2013-04-06','09:45:00',2.04),('8348','2013-04-06','09:50:00',2.1),('8348','2013-04-06','09:55:00',2.16),('8348','2013-04-06','10:00:00',2.23),('8348','2013-04-06','10:05:00',2.29),('8348','2013-04-06','10:10:00',2.36),('8348','2013-04-06','10:15:00',1.73),('8348','2013-04-06','10:20:00',1.54),('8348','2013-04-06','10:25:00',2.46),('8348','2013-04-06','10:30:00',2.4),('8348','2013-04-06','10:35:00',2.52),('8348','2013-04-06','10:40:00',2.64),('8348','2013-04-06','10:45:00',2.73),('8348','2013-04-06','10:50:00',2.77),('8348','2013-04-06','10:55:00',2.81),('8348','2013-04-06','11:00:00',2.87),('8348','2013-04-06','11:05:00',2.92),('8348','2013-04-06','11:10:00',2.95),('8348','2013-04-06','11:15:00',2.99),('8348','2013-04-06','11:20:00',3.05),('8348','2013-04-06','11:25:00',3.13),('8348','2013-04-06','11:30:00',3.16),('8348','2013-04-06','11:35:00',3.18),('8348','2013-04-06','11:40:00',3.2),('8348','2013-04-06','11:45:00',3.23),('8348','2013-04-06','11:50:00',3.23),('8348','2013-04-06','11:55:00',3.23),('8348','2013-04-06','12:00:00',3.22),('8348','2013-04-06','12:05:00',3.28),('8348','2013-04-06','12:10:00',3.3),('8348','2013-04-06','12:15:00',3.33),('8348','2013-04-06','12:20:00',3.4),('8348','2013-04-06','12:25:00',3.47),('8348','2013-04-06','12:30:00',3.46),('8348','2013-04-06','12:35:00',3.51),('8348','2013-04-06','12:40:00',3.49),('8348','2013-04-06','12:45:00',3.51),('8348','2013-04-06','12:50:00',3.54),('8348','2013-04-06','12:55:00',3.49),('8348','2013-04-06','13:00:00',3.37),('8348','2013-04-06','13:05:00',3.33),('8348','2013-04-06','13:10:00',3.62),('8348','2013-04-06','13:15:00',4.04),('8348','2013-04-06','13:20:00',3.3),('8348','2013-04-06','13:25:00',1.95),('8348','2013-04-06','13:30:00',3.29),('8348','2013-04-06','13:35:00',4.09),('8348','2013-04-06','13:40:00',3.76),('8348','2013-04-06','13:45:00',2.7),('8348','2013-04-06','13:50:00',3.99),('8348','2013-04-06','13:55:00',2.4),('8348','2013-04-06','14:00:00',2.95),('8348','2013-04-06','14:05:00',1.93),('8348','2013-04-06','14:10:00',2.34),('8348','2013-04-06','14:15:00',3.95),('8348','2013-04-06','14:20:00',2.89),('8348','2013-04-06','14:30:00',3.01),('8348','2013-04-06','14:35:00',3.69),('8348','2013-04-06','14:40:00',3.01),('8348','2013-04-06','14:45:00',3.54),('8348','2013-04-06','14:50:00',3.37),('8348','2013-04-06','14:55:00',3.45),('8348','2013-04-06','15:00:00',3),('8348','2013-04-06','15:05:00',3.39),('8348','2013-04-06','15:10:00',3.24),('8348','2013-04-06','15:15:00',3.22),('8348','2013-04-06','15:20:00',3.2),('8348','2013-04-06','15:25:00',3.17),('8348','2013-04-06','15:30:00',3.03),('8348','2013-04-06','15:35:00',3),('8348','2013-04-06','15:40:00',3),('8348','2013-04-06','15:45:00',2.71),('8348','2013-04-06','15:50:00',2.77),('8348','2013-04-06','15:55:00',2.89),('8348','2013-04-06','16:00:00',2.68),('8348','2013-04-06','16:05:00',2.86),('8348','2013-04-06','16:10:00',2.75),('8348','2013-04-06','16:15:00',2.64),('8348','2013-04-06','16:20:00',2.13),('8348','2013-04-06','16:25:00',1.79),('8348','2013-04-06','16:30:00',2.21),('8348','2013-04-06','16:35:00',2.08),('8348','2013-04-06','16:40:00',1.72),('8348','2013-04-06','16:45:00',2.27),('8348','2013-04-06','16:50:00',2.2),('8348','2013-04-06','16:55:00',1.94),('8348','2013-04-06','17:00:00',1.99),('8348','2013-04-06','17:05:00',1.71),('8348','2013-04-06','17:10:00',1.46),('8348','2013-04-06','17:15:00',1.14),('8348','2013-04-05','08:20:00',1.01),('8348','2013-04-05','09:05:00',1.76),('8348','2013-04-05','09:15:00',1.78),('8348','2013-04-05','09:20:00',1.63),('8348','2013-04-05','09:25:00',1),('8348','2013-04-05','09:35:00',1.02),('8348','2013-04-05','09:40:00',1.99),('8348','2013-04-05','09:45:00',1.87),('8348','2013-04-05','09:50:00',1.08),('8348','2013-04-05','10:00:00',1.23),('8348','2013-04-05','10:10:00',2.03),('8348','2013-04-05','10:15:00',2.75),('8348','2013-04-05','10:20:00',1.22),('8348','2013-04-05','10:25:00',2.15),('8348','2013-04-05','10:30:00',2.25),('8348','2013-04-05','10:35:00',2.29),('8348','2013-04-05','10:40:00',3.13),('8348','2013-04-05','10:45:00',1.64),('8348','2013-04-05','10:50:00',1.43),('8348','2013-04-05','10:55:00',2.72),('8348','2013-04-05','11:00:00',2.56),('8348','2013-04-05','11:05:00',2.35),('8348','2013-04-05','11:10:00',2.98),('8348','2013-04-05','11:15:00',2.87),('8348','2013-04-05','11:20:00',2.77),('8348','2013-04-05','11:25:00',2.65),('8348','2013-04-05','11:30:00',2.88),('8348','2013-04-05','11:35:00',2.33),('8348','2013-04-05','11:40:00',3.6),('8348','2013-04-05','11:45:00',2.53),('8348','2013-04-05','11:50:00',3.46),('8348','2013-04-05','11:55:00',3.33),('8348','2013-04-05','12:00:00',3.63),('8348','2013-04-05','12:05:00',2.57),('8348','2013-04-05','12:10:00',1.93),('8348','2013-04-05','12:15:00',1.99),('8348','2013-04-05','12:20:00',1.4),('8348','2013-04-05','12:25:00',2.06),('8348','2013-04-05','12:30:00',1.18),('8348','2013-04-05','12:35:00',1.27),('8348','2013-04-05','12:40:00',1.71),('8348','2013-04-05','12:45:00',3.45),('8348','2013-04-05','12:50:00',4.04),('8348','2013-04-05','12:55:00',3.88),('8348','2013-04-05','13:00:00',2.86),('8348','2013-04-05','13:05:00',2.81),('8348','2013-04-05','13:10:00',2.49),('8348','2013-04-05','13:15:00',2.51),('8348','2013-04-05','13:20:00',2.59),('8348','2013-04-05','13:25:00',2.28),('8348','2013-04-05','13:30:00',2.45),('8348','2013-04-05','13:35:00',2.86),('8348','2013-04-05','13:40:00',3.23),('8348','2013-04-05','13:45:00',3.12),('8348','2013-04-05','13:50:00',4.17),('8348','2013-04-05','13:55:00',3.34),('8348','2013-04-05','14:00:00',2.66),('8348','2013-04-05','14:05:00',4.1),('8348','2013-04-05','14:10:00',3.59),('8348','2013-04-05','14:15:00',3.57),('8348','2013-04-05','14:20:00',3.59),('8348','2013-04-05','14:25:00',3.63),('8348','2013-04-05','14:30:00',3.57),('8348','2013-04-05','14:35:00',3.66),('8348','2013-04-05','14:40:00',3.84),('8348','2013-04-05','14:45:00',2.83),('8348','2013-04-05','14:50:00',2.57),('8348','2013-04-05','14:55:00',3.53),('8348','2013-04-05','15:00:00',3.07),('8348','2013-04-05','15:05:00',3.07),('8348','2013-04-05','15:10:00',1.95),('8348','2013-04-05','15:15:00',1.5),('8348','2013-04-05','15:20:00',1.57),('8348','2013-04-05','15:25:00',1.63),('8348','2013-04-05','15:30:00',1.43),('8348','2013-04-05','15:35:00',1.17),('8348','2013-04-05','15:40:00',1),('8348','2013-04-05','15:45:00',1.25),('8348','2013-04-05','15:50:00',1.56),('8348','2013-04-05','15:55:00',1.5),('8348','2013-04-05','16:00:00',1.59),('8348','2013-04-05','16:05:00',1.47),('8348','2013-04-05','16:10:00',1.47),('8348','2013-04-05','16:15:00',2.05),('8348','2013-04-05','16:20:00',1.73),('8348','2013-04-05','16:25:00',1.41),('8348','2013-04-05','16:30:00',1.49),('8348','2013-04-05','16:35:00',1.47),('8348','2013-04-05','16:40:00',1.41),('8348','2013-04-05','16:45:00',2.02),('8348','2013-04-05','16:50:00',2.79),('8348','2013-04-05','16:55:00',1.39),('8348','2013-04-05','17:00:00',1.51),('8348','2013-04-05','17:05:00',1),('8348','2013-04-05','17:10:00',2.38),('8348','2013-04-05','17:15:00',1.95),('8348','2013-04-05','17:20:00',1.6),('8348','2013-04-05','17:25:00',1.7),('8348','2013-04-05','17:30:00',2.16),('8348','2013-04-05','17:35:00',1.27),('8348','2013-04-05','17:40:00',1.37),('8348','2013-04-05','17:50:00',1.17),('8348','2013-04-05','17:55:00',1.75),('8348','2013-04-05','18:00:00',1.25),('8348','2013-04-04','08:55:00',1.14),('8348','2013-04-04','09:00:00',1.59),('8348','2013-04-04','09:05:00',1.18),('8348','2013-04-04','09:10:00',1.1),('8348','2013-04-04','09:15:00',1.12),('8348','2013-04-04','09:20:00',1.13),('8348','2013-04-04','09:30:00',1.32),('8348','2013-04-04','09:35:00',2.08),('8348','2013-04-04','09:40:00',1.97),('8348','2013-04-04','09:45:00',1.7),('8348','2013-04-04','09:55:00',1.11),('8348','2013-04-04','10:00:00',1.58),('8348','2013-04-04','10:05:00',2.06),('8348','2013-04-04','10:10:00',1.84),('8348','2013-04-04','10:15:00',1.4),('8348','2013-04-04','10:20:00',1.52),('8348','2013-04-04','10:25:00',2.81),('8348','2013-04-04','10:30:00',2.58),('8348','2013-04-04','10:35:00',1.73),('8348','2013-04-04','10:40:00',3.19),('8348','2013-04-04','10:45:00',1.81),('8348','2013-04-04','10:50:00',2.1),('8348','2013-04-04','10:55:00',3.1),('8348','2013-04-04','11:00:00',1.86),('8348','2013-04-04','11:05:00',1.07),('8348','2013-04-04','11:15:00',1.34),('8348','2013-04-04','11:20:00',1.23),('8348','2013-04-04','11:30:00',1.05),('8348','2013-04-04','11:35:00',1.5),('8348','2013-04-04','11:40:00',2.48),('8348','2013-04-04','11:45:00',2.93),('8348','2013-04-04','11:50:00',3.26),('8348','2013-04-04','11:55:00',3.53),('8348','2013-04-04','12:00:00',3.38),('8348','2013-04-04','12:05:00',3.41),('8348','2013-04-04','12:10:00',3.44),('8348','2013-04-04','12:15:00',3.35),('8348','2013-04-04','12:20:00',2.87),('8348','2013-04-04','12:25:00',2.05),('8348','2013-04-04','12:30:00',2.15),('8348','2013-04-04','12:35:00',1.64),('8348','2013-04-04','12:40:00',2.83),('8348','2013-04-04','12:45:00',2.47),('8348','2013-04-04','12:50:00',3.54),('8348','2013-04-04','12:55:00',3.31),('8348','2013-04-04','13:00:00',3.32),('8348','2013-04-04','13:05:00',3.35),('8348','2013-04-04','13:10:00',3.45),('8348','2013-04-04','13:15:00',3.54),('8348','2013-04-04','13:20:00',3.46),('8348','2013-04-04','13:25:00',3.6),('8348','2013-04-04','13:30:00',3.49),('8348','2013-04-04','13:35:00',3.2),('8348','2013-04-04','13:40:00',2.75),('8348','2013-04-04','13:45:00',2.86),('8348','2013-04-04','13:50:00',2.78),('8348','2013-04-04','13:55:00',2.2),('8348','2013-04-04','14:00:00',2.37),('8348','2013-04-04','14:05:00',3.08),('8348','2013-04-04','14:10:00',3.45),('8348','2013-04-04','14:15:00',3.4),('8348','2013-04-04','14:20:00',3.4),('8348','2013-04-04','14:25:00',3.34),('8348','2013-04-04','14:30:00',3.32),('8348','2013-04-04','14:35:00',3.29),('8348','2013-04-04','14:40:00',3.27),('8348','2013-04-04','14:45:00',3.23),('8348','2013-04-04','14:50:00',3.21),('8348','2013-04-04','14:55:00',3.22),('8348','2013-04-04','15:00:00',3.18),('8348','2013-04-04','15:05:00',3.06),('8348','2013-04-04','15:10:00',2.92),('8348','2013-04-04','15:15:00',2.88),('8348','2013-04-04','15:20:00',2.94),('8348','2013-04-04','15:25:00',2.97),('8348','2013-04-04','15:30:00',2.96),('8348','2013-04-04','15:35:00',2.9),('8348','2013-04-04','15:40:00',2.83),('8348','2013-04-04','15:45:00',2.79),('8348','2013-04-04','15:50:00',2.69),('8348','2013-04-04','15:55:00',2.67),('8348','2013-04-04','16:00:00',2.62),('8348','2013-04-04','16:05:00',2.54),('8348','2013-04-04','16:10:00',2.43),('8348','2013-04-04','16:15:00',2.33),('8348','2013-04-04','16:20:00',2.2),('8348','2013-04-04','16:25:00',2.17),('8348','2013-04-04','16:30:00',1.67),('8348','2013-04-04','16:35:00',1.8),('8348','2013-04-04','16:40:00',1.81),('8348','2013-04-04','16:45:00',1.64),('8348','2013-04-04','16:50:00',1.57),('8348','2013-04-04','16:55:00',1.81),('8348','2013-04-04','17:00:00',1.63),('8348','2013-04-04','17:05:00',1.61),('8348','2013-04-04','17:10:00',1.55),('8348','2013-04-04','17:15:00',1.34),('8348','2013-04-04','17:55:00',1.12),('8348','2013-04-03','08:50:00',1.09),('8348','2013-04-03','08:55:00',1.2),('8348','2013-04-03','09:00:00',1.35),('8348','2013-04-03','09:05:00',1.36),('8348','2013-04-03','09:10:00',1.61),('8348','2013-04-03','09:15:00',1.62),('8348','2013-04-03','09:20:00',1.09),('8348','2013-04-03','09:25:00',1.18),('8348','2013-04-03','09:30:00',2.11),('8348','2013-04-03','09:35:00',2.34),('8348','2013-04-03','09:40:00',2.01),('8348','2013-04-03','09:45:00',2.18),('8348','2013-04-03','09:50:00',2.35),('8348','2013-04-03','09:55:00',2.62),('8348','2013-04-03','10:00:00',2.14),('8348','2013-04-03','10:05:00',1.04),('8348','2013-04-03','10:10:00',1.06),('8348','2013-04-03','10:15:00',1.44),('8348','2013-04-03','10:20:00',2.69),('8348','2013-04-03','10:25:00',2.63),('8348','2013-04-03','10:30:00',2.3),('8348','2013-04-03','10:35:00',1.91),('8348','2013-04-03','10:40:00',1.48),('8348','2013-04-03','10:45:00',1.28),('8348','2013-04-03','10:50:00',1.93),('8348','2013-04-03','10:55:00',2.14),('8348','2013-04-03','11:00:00',2.91),('8348','2013-04-03','11:05:00',3.22),('8348','2013-04-03','11:10:00',1.8),('8348','2013-04-03','11:15:00',3.3),('8348','2013-04-03','11:20:00',3.65),('8348','2013-04-03','11:25:00',1.96),('8348','2013-04-03','11:30:00',1.5),('8348','2013-04-03','11:35:00',1.87),('8348','2013-04-03','11:40:00',1.43),('8348','2013-04-03','11:45:00',1.59),('8348','2013-04-03','11:50:00',3.43),('8348','2013-04-03','11:55:00',1.86),('8348','2013-04-03','12:00:00',3.28),('8348','2013-04-03','12:05:00',3.44),('8348','2013-04-03','12:10:00',2.34),('8348','2013-04-03','12:15:00',1.95),('8348','2013-04-03','12:20:00',3.69),('8348','2013-04-03','12:25:00',3.41),('8348','2013-04-03','12:30:00',2.77),('8348','2013-04-03','12:35:00',3.67),('8348','2013-04-03','12:40:00',4.06),('8348','2013-04-03','12:45:00',3.18),('8348','2013-04-03','12:50:00',4.03),('8348','2013-04-03','12:55:00',4.03),('8348','2013-04-03','13:00:00',3.33),('8348','2013-04-03','13:05:00',3.3),('8348','2013-04-03','13:10:00',2.61),('8348','2013-04-03','13:15:00',4.36),('8348','2013-04-03','13:20:00',2.86),('8348','2013-04-03','13:25:00',2.58),('8348','2013-04-03','13:30:00',2.51),('8348','2013-04-03','13:35:00',4.27),('8348','2013-04-03','13:40:00',3.45),('8348','2013-04-03','13:45:00',3.03),('8348','2013-04-03','13:50:00',3.28),('8348','2013-04-03','13:55:00',2.64),('8348','2013-04-03','14:00:00',4.52),('8348','2013-04-03','14:05:00',3.9),('8348','2013-04-03','14:10:00',3.07),('8348','2013-04-03','14:15:00',1.92),('8348','2013-04-03','14:20:00',1.8),('8348','2013-04-03','14:25:00',3.45),('8348','2013-04-03','14:30:00',3.73),('8348','2013-04-03','14:35:00',3.47),('8348','2013-04-03','14:40:00',3.21),('8348','2013-04-03','14:45:00',2.84),('8348','2013-04-03','14:50:00',1.79),('8348','2013-04-03','14:55:00',2.98),('8348','2013-04-03','15:00:00',3.43),('8348','2013-04-03','15:05:00',3.68),('8348','2013-04-03','15:10:00',3.3),('8348','2013-04-03','15:15:00',3.95),('8348','2013-04-03','15:20:00',3.74),('8348','2013-04-03','15:25:00',3.64),('8348','2013-04-03','15:30:00',2.75),('8348','2013-04-03','15:35:00',3.08),('8348','2013-04-03','15:40:00',3.46),('8348','2013-04-03','15:45:00',2.79),('8348','2013-04-03','15:50:00',3.2),('8348','2013-04-03','15:55:00',3.34),('8348','2013-04-03','16:00:00',3.26),('8348','2013-04-03','16:05:00',3.13),('8348','2013-04-03','16:10:00',3.1),('8348','2013-04-03','16:15:00',3),('8348','2013-04-03','16:20:00',2.93),('8348','2013-04-03','16:25:00',2.87),('8348','2013-04-03','16:30:00',2.71),('8348','2013-04-03','16:35:00',2.57),('8348','2013-04-03','16:40:00',2.67),('8348','2013-04-03','16:45:00',2.57),('8348','2013-04-03','16:50:00',2.51),('8348','2013-04-03','16:55:00',2.44),('8348','2013-04-03','17:00:00',2.36),('8348','2013-04-03','17:05:00',2.27),('8348','2013-04-03','17:10:00',2.2),('8348','2013-04-03','17:15:00',2.13),('8348','2013-04-03','17:20:00',1.93),('8348','2013-04-03','17:25:00',1.96),('8348','2013-04-03','17:30:00',1.87),('8348','2013-04-03','17:35:00',1.77),('8348','2013-04-03','17:40:00',1.69),('8348','2013-04-03','17:45:00',1.6),('8348','2013-04-03','17:50:00',1.52),('8348','2013-04-03','17:55:00',1.42),('8348','2013-04-03','18:00:00',1.32),('8348','2013-04-03','18:05:00',1.24),('8348','2013-04-03','18:10:00',1.13),('8348','2013-04-03','18:15:00',1.03),('8348','2013-04-02','08:40:00',1.21),('8348','2013-04-02','08:45:00',1.26),('8348','2013-04-02','08:50:00',1.14),('8348','2013-04-02','09:00:00',1.31),('8348','2013-04-02','09:05:00',1.34),('8348','2013-04-02','09:10:00',1.37),('8348','2013-04-02','09:15:00',1.1),('8348','2013-04-02','09:20:00',1.42),('8348','2013-04-02','09:25:00',1.1),('8348','2013-04-02','09:30:00',1.04),('8348','2013-04-02','09:35:00',2.07),('8348','2013-04-02','09:40:00',2.09),('8348','2013-04-02','09:45:00',1.84),('8348','2013-04-02','09:50:00',1.77),('8348','2013-04-02','09:55:00',1.65),('8348','2013-04-02','10:00:00',1.76),('8348','2013-04-02','10:05:00',1.1),('8348','2013-04-02','10:10:00',1.22),('8348','2013-04-02','10:15:00',1.3),('8348','2013-04-02','10:20:00',1.46),('8348','2013-04-02','10:25:00',1.43),('8348','2013-04-02','10:35:00',2.13),('8348','2013-04-02','10:40:00',1.79),('8348','2013-04-02','10:45:00',2.17),('8348','2013-04-02','10:50:00',3.29),('8348','2013-04-02','10:55:00',1.47),('8348','2013-04-02','11:05:00',2.64),('8348','2013-04-02','11:10:00',1.63),('8348','2013-04-02','11:15:00',1.04),('8348','2013-04-02','11:25:00',1.04),('8348','2013-04-02','11:30:00',1.1),('8348','2013-04-02','11:35:00',1.02),('8348','2013-04-02','11:45:00',2.25),('8348','2013-04-02','11:50:00',2.11),('8348','2013-04-02','11:55:00',1.13),('8348','2013-04-02','12:05:00',3.06),('8348','2013-04-02','12:10:00',1.68),('8348','2013-04-02','12:15:00',2.19),('8348','2013-04-02','12:35:00',1.58),('8348','2013-04-02','12:40:00',1.86),('8348','2013-04-02','12:45:00',2.1),('8348','2013-04-02','12:50:00',2),('8348','2013-04-02','12:55:00',2.03),('8348','2013-04-02','13:00:00',2.16),('8348','2013-04-02','13:05:00',2.35),('8348','2013-04-02','13:10:00',2.89),('8348','2013-04-02','13:15:00',2.41),('8348','2013-04-02','13:20:00',1.86),('8348','2013-04-02','13:25:00',2.95),('8348','2013-04-02','13:30:00',2.36),('8348','2013-04-02','13:35:00',1.77),('8348','2013-04-02','13:40:00',2.66),('8348','2013-04-02','13:45:00',2.43),('8348','2013-04-02','13:50:00',2.12),('8348','2013-04-02','13:55:00',1.61),('8348','2013-04-02','14:00:00',2.2),('8348','2013-04-02','14:05:00',1.75),('8348','2013-04-02','14:10:00',2.23),('8348','2013-04-02','14:15:00',2.08),('8348','2013-04-02','14:20:00',3.27),('8348','2013-04-02','14:25:00',3.4),('8348','2013-04-02','14:30:00',2.45),('8348','2013-04-02','14:35:00',1.71),('8348','2013-04-02','14:40:00',2.3),('8348','2013-04-02','14:45:00',2.47),('8348','2013-04-02','14:50:00',1.91),('8348','2013-04-02','14:55:00',1.61),('8348','2013-04-02','15:00:00',1.43),('8348','2013-04-02','15:45:00',1.1),('8348','2013-04-02','16:05:00',1.07),('8348','2014-05-02','06:15:00',1.06),('8348','2014-05-02','06:35:00',1.03),('8348','2014-05-02','06:40:00',1.15),('8348','2014-05-02','06:45:00',1.26),('8348','2014-05-02','06:50:00',1.47),('8348','2014-05-02','06:55:00',1.81),('8348','2014-05-02','07:00:00',2.16),('8348','2014-05-02','07:05:00',2.17),('8348','2014-05-02','07:10:00',1.54),('8348','2014-05-02','07:15:00',2.66),('8348','2014-05-02','07:20:00',3.64),('8348','2014-05-02','07:25:00',1.97),('8348','2014-05-02','07:30:00',1.31),('8348','2014-05-02','07:40:00',1.38),('8348','2014-05-02','07:45:00',2.12),('8348','2014-05-02','07:50:00',2.1),('8348','2014-05-02','07:55:00',1.24),('8348','2014-05-02','08:05:00',1.24),('8348','2014-05-02','08:10:00',1.6),('8348','2014-05-02','08:15:00',2.24),('8348','2014-05-02','08:20:00',2.63),('8348','2014-05-02','08:25:00',3.01),('8348','2014-05-02','08:30:00',3.65),('8348','2014-05-02','08:35:00',3.22),('8348','2014-05-02','08:40:00',2.94),('8348','2014-05-02','08:45:00',3.17),('8348','2014-05-02','08:50:00',2.95),('8348','2014-05-02','08:55:00',2.69),('8348','2014-05-02','09:00:00',3.52),('8348','2014-05-02','09:05:00',3.6),('8348','2014-05-02','09:10:00',3.42),('8348','2014-05-02','09:15:00',2.84),('8348','2014-05-02','09:20:00',2.78),('8348','2014-05-02','09:25:00',2.23),('8348','2014-05-02','09:30:00',1.71),('8348','2014-05-02','09:35:00',1.68),('8348','2014-05-02','09:40:00',1.83),('8348','2014-05-02','09:45:00',2.26),('8348','2014-05-02','09:50:00',2.19),('8348','2014-05-02','09:55:00',1.57),('8348','2014-05-02','11:25:00',1.62),('8348','2014-05-02','11:30:00',2.02),('8348','2014-05-02','11:35:00',2.27),('8348','2014-05-02','11:40:00',2.23),('8348','2014-05-02','11:45:00',2.68),('8348','2014-05-02','11:50:00',3.49),('8348','2014-05-02','11:55:00',2.82),('8348','2014-05-02','12:00:00',2.88),('8348','2014-05-02','12:05:00',3.11),('8348','2014-05-02','12:10:00',3.49),('8348','2014-05-02','12:15:00',4.19),('8348','2014-05-02','12:20:00',6.02),('8348','2014-05-02','12:25:00',6.02),('8348','2014-05-02','12:30:00',5.03),('8348','2014-05-02','12:35:00',5.82),('8348','2014-05-02','12:40:00',4.74),('8348','2014-05-02','12:45:00',3.92),('8348','2014-05-02','12:50:00',3.23),('8348','2014-05-02','12:55:00',2.63),('8348','2014-05-02','13:00:00',2.71),('8348','2014-05-02','13:05:00',3.34),('8348','2014-05-02','13:10:00',1.99),('8348','2014-05-02','13:25:00',1.22),('8348','2014-05-02','13:30:00',1.87),('8348','2014-05-02','13:35:00',2.49),('8348','2014-05-02','13:40:00',5.69),('8348','2014-05-02','13:45:00',3.2),('8348','2014-05-02','13:50:00',2.55),('8348','2014-05-02','13:55:00',3.46),('8348','2014-05-02','14:00:00',4.22),('8348','2014-05-02','14:05:00',3.63),('8348','2014-05-02','14:10:00',7.47),('8348','2014-05-02','14:15:00',6.53),('8348','2014-05-02','14:20:00',4.89),('8348','2014-05-02','14:25:00',4.25),('8348','2014-05-02','14:30:00',2.32),('8348','2014-05-02','14:35:00',4.08),('8348','2014-05-02','14:40:00',6.6),('8348','2014-05-02','14:45:00',2.26),('8348','2014-05-02','14:50:00',1.51),('8348','2014-05-02','14:55:00',1.58),('8348','2014-05-02','15:00:00',2.67),('8348','2014-05-02','15:05:00',3.61),('8348','2014-05-02','15:10:00',2.15),('8348','2014-05-02','15:15:00',1.77),('8348','2014-05-02','15:20:00',5.14),('8348','2014-05-02','15:25:00',1.26),('8348','2014-05-02','15:55:00',1.63),('8348','2014-05-02','16:05:00',1.24),('8348','2014-05-02','16:10:00',1.08),('8348','2014-05-02','16:15:00',1.56),('8348','2014-05-02','16:20:00',1.81),('8348','2014-05-02','16:25:00',2.23),('8348','2014-05-02','16:30:00',1.67),('8348','2014-05-02','16:35:00',1.36),('8348','2014-05-02','16:40:00',1.11),('8348','2014-03-27','07:45:00',1.27),('8348','2014-03-27','07:50:00',1.39),('8348','2014-03-27','07:55:00',1.9),('8348','2014-03-27','08:00:00',2.33),('8348','2014-03-27','08:05:00',2.56),('8348','2014-03-27','08:10:00',1.46),('8348','2014-03-27','09:10:00',1.35),('8348','2014-03-27','09:15:00',1.68),('8348','2014-03-27','09:20:00',1.59),('8348','2014-03-27','09:25:00',1.46),('8348','2014-03-27','09:30:00',1.3),('8348','2014-03-27','09:55:00',1.27),('8348','2014-03-27','10:00:00',1.55),('8348','2014-03-27','10:05:00',2.02),('8348','2014-03-27','10:10:00',2.39),('8348','2014-03-27','10:15:00',2.22),('8348','2014-03-27','10:20:00',3.04),('8348','2014-03-27','10:25:00',3.86),('8348','2014-03-27','10:30:00',3.76),('8348','2014-03-27','10:35:00',3.14),('8348','2014-03-27','10:40:00',3.5),('8348','2014-03-27','10:45:00',2.09),('8348','2014-03-27','10:50:00',1.44),('8348','2014-03-27','10:55:00',1.35),('8348','2014-03-27','11:00:00',1.31),('8348','2014-03-27','11:05:00',1.12),('8348','2014-03-27','11:10:00',4.54),('8348','2014-03-27','11:15:00',4.35),('8348','2014-03-27','11:20:00',2.52),('8348','2014-03-27','11:25:00',1.33),('8348','2014-03-27','11:50:00',1.95),('8348','2014-03-27','11:55:00',2.51),('8348','2014-03-27','12:00:00',2.16),('8348','2014-03-27','12:05:00',1.93),('8348','2014-03-27','12:10:00',2.24),('8348','2014-03-27','12:15:00',1.73),('8348','2014-03-27','12:20:00',1.78),('8348','2014-03-27','12:25:00',1.17),('8348','2014-03-27','12:55:00',1.34),('8348','2014-03-27','13:00:00',1.69),('8348','2014-03-27','13:05:00',2.01),('8348','2014-03-27','13:10:00',2.81),('8348','2014-03-27','13:15:00',3.97),('8348','2014-03-27','13:20:00',4.25),('8348','2014-03-27','13:25:00',4.47),('8348','2014-03-27','13:30:00',3.92),('8348','2014-03-27','13:35:00',3.43),('8348','2014-03-27','13:40:00',3.25),('8348','2014-03-27','13:45:00',2.93),('8348','2014-03-27','13:50:00',3.68),('8348','2014-03-27','13:55:00',4.92),('8348','2014-03-27','14:00:00',3.84),('8348','2014-03-27','14:05:00',2.15),('8348','2014-03-27','14:10:00',1.17),('8348','2014-03-27','14:15:00',4.34),('8348','2014-03-27','14:20:00',6.95),('8348','2014-03-27','14:25:00',6.55),('8348','2014-03-27','14:30:00',7.19),('8348','2014-03-27','14:35:00',3.85),('8348','2014-03-27','14:40:00',3.5),('8348','2014-03-27','14:45:00',3.16),('8348','2014-03-27','14:50:00',3.79),('8348','2014-03-27','14:55:00',3.12),('8348','2014-03-27','15:00:00',7.08),('8348','2014-03-27','15:05:00',2.69),('8348','2014-03-27','15:20:00',1.53),('8348','2014-03-27','15:25:00',4.56),('8348','2014-03-27','15:30:00',5.66),('8348','2014-03-27','15:35:00',4.4),('8348','2014-03-27','15:40:00',2.4),('8348','2014-03-27','15:45:00',1.09),('8348','2014-03-27','15:50:00',1.54),('8348','2014-03-27','15:55:00',1.62),('8348','2014-03-27','16:00:00',1.53),('8348','2014-03-27','16:05:00',1.78),('8348','2014-03-27','16:10:00',1.99),('8348','2014-03-27','16:15:00',1.89),('8348','2014-03-27','16:20:00',1.55),('8348','2014-03-27','16:25:00',1.87),('8348','2014-03-27','16:30:00',2.41),('8348','2014-03-27','16:35:00',1.65),('8348','2014-03-27','16:40:00',1.66),('8348','2014-03-27','16:45:00',1.66),('8348','2014-03-27','16:50:00',1.11),('8348','2014-03-27','16:55:00',1.77),('8348','2014-03-27','17:00:00',1.78),('8348','2014-03-27','17:05:00',1.54),('8348','2014-03-27','17:10:00',1.11),('8348','2013-04-01','08:40:00',1.12),('8348','2013-04-01','08:55:00',1.05),('8348','2013-04-01','09:00:00',1.3),('8348','2013-04-01','09:05:00',1.38),('8348','2013-04-01','09:10:00',1.52),('8348','2013-04-01','09:15:00',1.48),('8348','2013-04-01','09:20:00',1.1),('8348','2013-04-01','09:25:00',1.35),('8348','2013-04-01','09:30:00',1.83),('8348','2013-04-01','09:35:00',1.49),('8348','2013-04-01','09:40:00',1.43),('8348','2013-04-01','09:45:00',1.6),('8348','2013-04-01','09:50:00',2.2),('8348','2013-04-01','09:55:00',2.14),('8348','2013-04-01','10:00:00',2.33),('8348','2013-04-01','10:05:00',2.44),('8348','2013-04-01','10:10:00',1.82),('8348','2013-04-01','10:15:00',2.23),('8348','2013-04-01','10:20:00',1.64),('8348','2013-04-01','10:25:00',2.39),('8348','2013-04-01','10:30:00',1.81),('8348','2013-04-01','10:35:00',1.39),('8348','2013-04-01','10:40:00',1.35),('8348','2013-04-01','10:45:00',2.64),('8348','2013-04-01','10:50:00',2.12),('8348','2013-04-01','10:55:00',1.55),('8348','2013-04-01','11:00:00',1.22),('8348','2013-04-01','11:05:00',1.47),('8348','2013-04-01','11:10:00',2.07),('8348','2013-04-01','11:15:00',2.89),('8348','2013-04-01','11:20:00',2.55),('8348','2013-04-01','11:25:00',1.88),('8348','2013-04-01','11:30:00',1.35),('8348','2013-04-01','11:35:00',1.6),('8348','2013-04-01','11:40:00',2.34),('8348','2013-04-01','11:45:00',2.76),('8348','2013-04-01','11:50:00',2.25),('8348','2013-04-01','11:55:00',1.97),('8348','2013-04-01','12:00:00',2.57),('8348','2013-04-01','12:05:00',1.62),('8348','2013-04-01','12:10:00',2.08),('8348','2013-04-01','12:15:00',1.75),('8348','2013-04-01','12:20:00',1.47),('8348','2013-04-01','12:25:00',1.63),('8348','2013-04-01','12:30:00',2.29),('8348','2013-04-01','12:35:00',2.13),('8348','2013-04-01','12:40:00',2.16),('8348','2013-04-01','12:45:00',2.4),('8348','2013-04-01','12:50:00',2.55),('8348','2013-04-01','12:55:00',2.75),('8348','2013-04-01','13:00:00',2.68),('8348','2013-04-01','13:05:00',2.92),('8348','2013-04-01','13:10:00',2.68),('8348','2013-04-01','13:15:00',2.66),('8348','2013-04-01','13:20:00',2.56),('8348','2013-04-01','13:25:00',2.42),('8348','2013-04-01','13:30:00',2.75),('8348','2013-04-01','13:35:00',2.39),('8348','2013-04-01','13:40:00',2.98),('8348','2013-04-01','13:45:00',3.31),('8348','2013-04-01','13:50:00',3.64),('8348','2013-04-01','13:55:00',3.81),('8348','2013-04-01','14:00:00',2.13),('8348','2013-04-01','14:05:00',1.66),('8348','2013-04-01','14:10:00',2.12),('8348','2013-04-01','14:15:00',2.35),('8348','2013-04-01','14:20:00',2.43),('8348','2013-04-01','14:25:00',3.8),('8348','2013-04-01','14:30:00',2.6),('8348','2013-04-01','14:35:00',2.05),('8348','2013-04-01','14:40:00',1.8),('8348','2013-04-01','14:45:00',1.8),('8348','2013-04-01','14:50:00',1.94),('8348','2013-04-01','14:55:00',2.07),('8348','2013-04-01','15:00:00',1.84),('8348','2013-04-01','15:05:00',1.83),('8348','2013-04-01','15:10:00',1.87),('8348','2013-04-01','15:15:00',2.02),('8348','2013-04-01','15:20:00',2.07),('8348','2013-04-01','15:25:00',2.14),('8348','2013-04-01','15:30:00',1.86),('8348','2013-04-01','15:35:00',2.33),('8348','2013-04-01','15:40:00',2.17),('8348','2013-04-01','15:45:00',2.21),('8348','2013-04-01','15:50:00',2.58),('8348','2013-04-01','15:55:00',1.99),('8348','2013-04-01','16:00:00',1.8),('8348','2013-04-01','16:05:00',1.48),('8348','2013-04-01','16:10:00',1.24),('8348','2013-03-31','08:45:00',1.06),('8348','2013-03-31','08:55:00',1.05),('8348','2013-03-31','09:15:00',1.03),('8348','2013-03-31','09:20:00',2.02),('8348','2013-03-31','09:25:00',2.24),('8348','2013-03-31','09:30:00',1.91),('8348','2013-03-31','09:35:00',2),('8348','2013-03-31','09:40:00',1.31),('8348','2013-03-31','09:45:00',2.13),('8348','2013-03-31','09:50:00',1.35),('8348','2013-03-31','09:55:00',1.67),('8348','2013-03-31','10:00:00',1.91),('8348','2013-03-31','10:20:00',1.86),('8348','2013-03-31','10:25:00',2.4),('8348','2013-03-31','10:30:00',2.15),('8348','2013-03-31','10:35:00',2.38),('8348','2013-03-31','10:45:00',1.07),('8348','2013-03-31','10:50:00',1.9),('8348','2013-03-31','11:10:00',1.25),('8348','2013-03-31','11:15:00',1.14),('8348','2013-03-31','11:20:00',1),('8348','2013-03-31','11:25:00',1.52),('8348','2013-03-31','11:30:00',1.21),('8348','2013-03-31','11:35:00',1.47),('8348','2013-03-31','11:40:00',1.53),('8348','2013-03-31','11:45:00',1.41),('8348','2013-03-31','11:50:00',1.45),('8348','2013-03-31','11:55:00',1.53),('8348','2013-03-31','12:00:00',1.41),('8348','2013-03-31','12:05:00',1.29),('8348','2013-03-31','12:10:00',1.15),('8348','2013-03-31','12:15:00',1.21),('8348','2013-03-31','12:20:00',1.13),('8348','2013-03-31','12:25:00',1.34),('8348','2013-03-31','12:30:00',1.66),('8348','2013-03-31','12:35:00',2.54),('8348','2013-03-31','12:40:00',3.49),('8348','2013-03-31','12:45:00',1.72),('8348','2013-03-31','12:50:00',1.61),('8348','2013-03-31','12:55:00',1.82),('8348','2013-03-31','13:00:00',2.21),('8348','2013-03-31','13:05:00',1.66),('8348','2013-03-31','13:10:00',2.36),('8348','2013-03-31','13:15:00',3.04),('8348','2013-03-31','13:20:00',3.67),('8348','2013-03-31','13:25:00',2.58),('8348','2013-03-31','13:40:00',1.43),('8348','2013-03-31','13:45:00',1.7),('8348','2013-03-31','13:50:00',1.79),('8348','2013-03-31','13:55:00',1.34),('8348','2013-03-31','14:00:00',2.12),('8348','2013-03-31','14:05:00',2.99),('8348','2013-03-31','14:10:00',2.36),('8348','2013-03-31','14:15:00',2.46),('8348','2013-03-31','14:20:00',2.09),('8348','2013-03-31','14:25:00',1.69),('8348','2013-03-31','14:30:00',2.1),('8348','2013-03-31','14:35:00',3.87),('8348','2013-03-31','14:40:00',4.11),('8348','2013-03-31','14:45:00',3.59),('8348','2013-03-31','14:50:00',3.33),('8348','2013-03-31','14:55:00',2.67),('8348','2013-03-31','15:00:00',3.17),('8348','2013-03-31','15:05:00',2.11),('8348','2013-03-31','15:10:00',3.07),('8348','2013-03-31','15:15:00',2.9),('8348','2013-03-31','15:20:00',3.77),('8348','2013-03-31','15:25:00',3.13),('8348','2013-03-31','15:30:00',2.67),('8348','2013-03-31','15:35:00',2.64),('8348','2013-03-31','15:40:00',3.73),('8348','2013-03-31','15:45:00',2.35),('8348','2013-03-31','16:00:00',2.37),('8348','2013-03-31','16:05:00',1.13),('8348','2013-03-31','16:10:00',1.3),('8348','2013-03-31','16:15:00',2.3),('8348','2013-03-31','16:20:00',1.67),('8348','2013-03-31','16:25:00',1.24),('8348','2013-03-31','16:35:00',1.08),('8348','2013-03-31','16:40:00',1.12),('8348','2013-03-31','17:00:00',1.25),('8348','2013-03-31','17:05:00',1.7),('8348','2013-03-31','17:10:00',1.21),('8348','2013-03-31','17:20:00',1),('8348','2013-03-31','17:25:00',1.06),('8348','2013-03-31','17:30:00',1.19),('8348','2013-03-31','17:35:00',1.14),('8348','2013-03-31','17:50:00',1.19),('8348','2013-03-31','17:55:00',1.63),('8348','2013-03-31','18:15:00',1.4),('8348','2013-03-30','08:35:00',1.02),('8348','2013-03-30','09:05:00',1.51),('8348','2013-03-30','09:10:00',1.62),('8348','2013-03-30','09:15:00',1.58),('8348','2013-03-30','09:20:00',2.78),('8348','2013-03-30','09:25:00',1.86),('8348','2013-03-30','09:30:00',1.22),('8348','2013-03-30','09:35:00',1.42),('8348','2013-03-30','09:40:00',1.35),('8348','2013-03-30','09:45:00',1.17),('8348','2013-03-30','09:55:00',1.03),('8348','2013-03-30','10:00:00',1.58),('8348','2013-03-30','10:05:00',1.53),('8348','2013-03-30','10:10:00',1.71),('8348','2013-03-30','10:15:00',1.57),('8348','2013-03-30','10:20:00',1.37),('8348','2013-03-30','10:25:00',1.35),('8348','2013-03-30','10:30:00',1.54),('8348','2013-03-30','10:35:00',1.83),('8348','2013-03-30','10:40:00',2.19),('8348','2013-03-30','10:45:00',2.93),('8348','2013-03-30','10:50:00',2.76),('8348','2013-03-30','10:55:00',2.08),('8348','2013-03-30','11:00:00',3.31),('8348','2013-03-30','11:05:00',3.53),('8348','2013-03-30','11:10:00',4.22),('8348','2013-03-30','11:15:00',3.86),('8348','2013-03-30','11:20:00',4.44),('8348','2013-03-30','11:25:00',3.96),('8348','2013-03-30','11:30:00',2.08),('8348','2013-03-30','11:35:00',2.9),('8348','2013-03-30','11:40:00',2.36),('8348','2013-03-30','11:45:00',2.85),('8348','2013-03-30','11:50:00',3.44),('8348','2013-03-30','11:55:00',4.2),('8348','2013-03-30','12:00:00',3.92),('8348','2013-03-30','12:05:00',2.52),('8348','2013-03-30','12:10:00',1.93),('8348','2013-03-30','12:15:00',1.82),('8348','2013-03-30','12:20:00',1.75),('8348','2013-03-30','12:25:00',1.1),('8348','2013-03-30','13:10:00',1.54),('8348','2013-03-30','13:15:00',3.24),('8348','2013-03-30','13:20:00',2.45),('8348','2013-03-30','13:25:00',1.64),('8348','2013-03-30','13:30:00',1.06),('8348','2013-03-30','13:45:00',2.19),('8348','2013-03-30','13:50:00',4.08),('8348','2013-03-30','13:55:00',1.85),('8348','2013-03-30','14:00:00',2.08),('8348','2013-03-30','14:05:00',2.12),('8348','2013-03-30','14:10:00',1.07),('8348','2013-03-30','14:20:00',1.8),('8348','2013-03-30','14:25:00',1.25),('8348','2013-03-30','14:30:00',1.87),('8348','2013-03-30','14:35:00',2.14),('8348','2013-03-30','14:40:00',1.17),('8348','2013-03-30','14:50:00',1.34),('8348','2013-03-29','07:45:00',1.01),('8348','2013-03-29','08:00:00',1.06),('8348','2013-03-29','08:05:00',1.24),('8348','2013-03-29','08:10:00',1.41),('8348','2013-03-29','08:15:00',1.43),('8348','2013-03-29','08:20:00',1.5),('8348','2013-03-29','08:25:00',1.58),('8348','2013-03-29','08:30:00',1.69),('8348','2013-03-29','08:35:00',1.81),('8348','2013-03-29','08:40:00',1.88),('8348','2013-03-29','08:45:00',1.82),('8348','2013-03-29','08:50:00',1.86),('8348','2013-03-29','08:55:00',1.77),('8348','2013-03-29','09:00:00',1.95),('8348','2013-03-29','09:05:00',2.04),('8348','2013-03-29','09:10:00',2.14),('8348','2013-03-29','09:15:00',2.39),('8348','2013-03-29','09:20:00',2.53),('8348','2013-03-29','09:25:00',2.34),('8348','2013-03-29','09:30:00',2.82),('8348','2013-03-29','09:35:00',2.89),('8348','2013-03-29','09:40:00',2.94),('8348','2013-03-29','09:45:00',2.58),('8348','2013-03-29','09:50:00',2.79),('8348','2013-03-29','09:55:00',2.81),('8348','2013-03-29','10:00:00',2.82),('8348','2013-03-29','10:05:00',2.69),('8348','2013-03-29','10:10:00',2.3),('8348','2013-03-29','10:15:00',2.87),('8348','2013-03-29','10:20:00',2.68),('8348','2013-03-29','10:25:00',2.58),('8348','2013-03-29','10:30:00',2.79),('8348','2013-03-29','10:35:00',2.25),('8348','2013-03-29','10:40:00',3.18),('8348','2013-03-29','10:45:00',2.44),('8348','2013-03-29','10:50:00',2.08),('8348','2013-03-29','10:55:00',2.82),('8348','2013-03-29','11:00:00',2.89),('8348','2013-03-29','11:05:00',3.37),('8348','2013-03-29','11:10:00',3.77),('8348','2013-03-29','11:15:00',1.53),('8348','2013-03-29','11:20:00',3.27),('8348','2013-03-29','11:25:00',3.93),('8348','2013-03-29','11:30:00',3.74),('8348','2013-03-29','11:35:00',3.59),('8348','2013-03-29','11:40:00',3.64),('8348','2013-03-29','11:45:00',3.63),('8348','2013-03-29','11:50:00',3.68),('8348','2013-03-29','11:55:00',3.71),('8348','2013-03-29','12:00:00',3.72),('8348','2013-03-29','12:05:00',3.82),('8348','2013-03-29','12:10:00',3.75),('8348','2013-03-29','12:15:00',3.49),('8348','2013-03-29','12:20:00',3.78),('8348','2013-03-29','12:25:00',3.61),('8348','2013-03-29','12:30:00',3.48),('8348','2013-03-29','12:35:00',3.6),('8348','2013-03-29','12:40:00',3.71),('8348','2013-03-29','12:45:00',3.36),('8348','2013-03-29','12:50:00',3.84),('8348','2013-03-29','12:55:00',3.54),('8348','2013-03-29','13:00:00',3.65),('8348','2013-03-29','13:05:00',3.14),('8348','2013-03-29','13:10:00',3.51),('8348','2013-03-29','13:15:00',3.05),('8348','2013-03-29','13:20:00',3.09),('8348','2013-03-29','13:25:00',3.93),('8348','2013-03-29','13:30:00',3.34),('8348','2013-03-29','13:35:00',3.11),('8348','2013-03-29','13:40:00',3.07),('8348','2013-03-29','13:45:00',3.21),('8348','2013-03-29','13:50:00',3.05),('8348','2013-03-29','13:55:00',3.17),('8348','2013-03-29','14:00:00',3.3),('8348','2013-03-29','14:05:00',2.75),('8348','2013-03-29','14:10:00',2.28),('8348','2013-03-29','14:15:00',2.25),('8348','2013-03-29','14:20:00',2.26),('8348','2013-03-29','14:25:00',2.29),('8348','2013-03-29','14:30:00',1.95),('8348','2013-03-29','14:35:00',1.94),('8348','2013-03-29','14:40:00',1.87),('8348','2013-03-29','14:45:00',1.72),('8348','2013-03-29','14:50:00',1.66),('8348','2013-03-29','14:55:00',1.6),('8348','2013-03-29','15:00:00',1.45),('8348','2013-03-29','15:05:00',1.49),('8348','2013-03-29','15:10:00',1.39),('8348','2013-03-29','15:15:00',1.37),('8348','2013-03-29','15:20:00',1.28),('8348','2013-03-29','15:25:00',1.15),('8348','2013-03-29','15:30:00',1.06),('8348','2013-03-29','15:35:00',1.01),('8348','2013-03-29','15:50:00',1.03),('8348','2013-03-29','15:55:00',1.21),('8348','2013-03-29','16:00:00',1.49),('8348','2013-03-29','16:05:00',1.41),('8348','2013-03-29','16:10:00',1.06),('8348','2013-03-29','16:30:00',1.09),('8348','2013-03-29','16:35:00',1.06),('8348','2013-03-29','16:40:00',2),('8348','2013-03-29','16:45:00',1.62),('8348','2013-03-29','16:50:00',1.16),('8348','2013-03-29','17:00:00',1.19),('8348','2013-03-29','17:20:00',1),('8348','2013-03-29','17:25:00',1.01),('8348','2013-03-28','09:10:00',1.28),('8348','2013-03-28','09:15:00',2.46),('8348','2013-03-28','09:20:00',1.44),('8348','2013-03-28','09:25:00',1.37),('8348','2013-03-28','09:30:00',1.09),('8348','2013-03-28','09:50:00',1.05),('8348','2013-03-28','10:00:00',1.04),('8348','2013-03-28','11:40:00',1.47),('8348','2013-03-28','11:45:00',1.14),('8348','2013-03-28','11:55:00',1.93),('8348','2013-03-28','12:00:00',1.41),('8348','2013-03-28','12:15:00',1.07),('8348','2013-03-28','12:30:00',1.03),('8348','2013-03-28','12:40:00',1.26),('8348','2013-03-28','12:45:00',1.57),('8348','2013-03-28','12:50:00',2.86),('8348','2013-03-28','12:55:00',3.09),('8348','2013-03-28','13:00:00',3.26),('8348','2013-03-28','13:05:00',4.39),('8348','2013-03-28','13:10:00',3.15),('8348','2013-03-28','13:15:00',3.66),('8348','2013-03-28','13:20:00',2.93),('8348','2013-03-28','13:25:00',2.38),('8348','2013-03-28','13:30:00',2.66),('8348','2013-03-28','13:35:00',2.67),('8348','2013-03-28','13:40:00',2.73),('8348','2013-03-28','13:45:00',2.43),('8348','2013-03-28','13:50:00',2.88),('8348','2013-03-28','13:55:00',1.52),('8348','2013-03-28','14:00:00',1.72),('8348','2013-03-28','14:05:00',1.83),('8348','2013-03-28','14:10:00',1.29),('8348','2013-03-28','14:15:00',1.28),('8348','2013-03-28','14:20:00',1.56),('8348','2013-03-28','14:25:00',1.34),('8348','2013-03-28','14:30:00',2),('8348','2013-03-28','14:35:00',1.52),('8348','2013-03-28','14:40:00',1.01),('8348','2013-03-28','15:00:00',1.1),('8348','2013-03-28','15:05:00',1.22),('8348','2013-03-28','15:10:00',2.5),('8348','2013-03-28','15:15:00',1.97),('8348','2013-03-28','15:20:00',1.59),('8348','2013-03-28','15:25:00',1.06),('8348','2013-03-28','15:30:00',1.55),('8348','2013-03-28','15:35:00',2.06),('8348','2013-03-28','15:40:00',1.59),('8348','2013-03-28','15:45:00',2.15),('8348','2013-03-28','15:50:00',1.32),('8348','2013-03-28','15:55:00',2.74),('8348','2013-03-28','16:00:00',1.26),('8348','2013-03-28','16:10:00',1.84),('8348','2013-03-28','16:35:00',1.63),('8348','2013-03-28','16:40:00',1.06),('8348','2013-03-28','16:45:00',1.11),('8348','2013-03-28','17:00:00',1.5),('8348','2013-03-28','17:05:00',1.34),('8348','2013-03-28','17:10:00',1.13),('8348','2013-03-27','07:55:00',1.17),('8348','2013-03-27','08:00:00',1.2),('8348','2013-03-27','08:05:00',1.18),('8348','2013-03-27','08:10:00',1.11),('8348','2013-03-27','08:15:00',1.25),('8348','2013-03-27','08:20:00',1.09),('8348','2013-03-27','08:25:00',1.25),('8348','2013-03-27','08:30:00',1.5),('8348','2013-03-27','08:35:00',1.45),('8348','2013-03-27','08:40:00',1.15),('8348','2013-03-27','08:45:00',1.09),('8348','2013-03-27','08:50:00',1.5),('8348','2013-03-27','08:55:00',1.14),('8348','2013-03-27','09:00:00',1.24),('8348','2013-03-27','09:15:00',1.14),('8348','2013-03-27','09:20:00',1.22),('8348','2013-03-27','09:45:00',1.39),('8348','2013-03-27','09:50:00',1.67),('8348','2013-03-27','09:55:00',1.31),('8348','2013-03-27','10:00:00',1.19),('8348','2013-03-27','10:10:00',1.09),('8348','2013-03-27','10:15:00',1.61),('8348','2013-03-27','10:20:00',1.28),('8348','2013-03-27','10:25:00',1.6),('8348','2013-03-27','10:30:00',2.05),('8348','2013-03-27','10:35:00',1.83),('8348','2013-03-27','10:40:00',2.03),('8348','2013-03-27','10:45:00',1.92),('8348','2013-03-27','10:50:00',2.04),('8348','2013-03-27','10:55:00',1.88),('8348','2013-03-27','11:00:00',1.62),('8348','2013-03-27','11:05:00',1.41),('8348','2013-03-27','11:10:00',1.52),('8348','2013-03-27','11:15:00',1.6),('8348','2013-03-27','11:20:00',1.68),('8348','2013-03-27','11:25:00',1.58),('8348','2013-03-27','11:30:00',1.75),('8348','2013-03-27','11:35:00',1.69),('8348','2013-03-27','11:40:00',1.54),('8348','2013-03-27','11:45:00',1.58),('8348','2013-03-27','11:50:00',1.55),('8348','2013-03-27','11:55:00',2.32),('8348','2013-03-27','12:00:00',2.41),('8348','2013-03-27','12:05:00',2.28),('8348','2013-03-27','12:10:00',1.92),('8348','2013-03-27','12:15:00',1.55),('8348','2013-03-27','12:20:00',1.56),('8348','2013-03-27','12:25:00',1.54),('8348','2013-03-27','12:30:00',3.22),('8348','2013-03-27','12:35:00',4.13),('8348','2013-03-27','12:40:00',2.84),('8348','2013-03-27','12:45:00',3.61),('8348','2013-03-27','12:50:00',2.67),('8348','2013-03-27','12:55:00',1.68),('8348','2013-03-27','13:00:00',1.47),('8348','2013-03-27','13:05:00',1.46),('8348','2013-03-27','13:10:00',1.91),('8348','2013-03-27','13:15:00',1.53),('8348','2013-03-27','13:20:00',1.21),('8348','2013-03-27','13:25:00',1.23),('8348','2013-03-27','13:30:00',1.48),('8348','2013-03-27','13:35:00',1.95),('8348','2013-03-27','13:40:00',1.59),('8348','2013-03-27','13:45:00',1.81),('8348','2013-03-27','13:50:00',2.01),('8348','2013-03-27','13:55:00',1.95),('8348','2013-03-27','14:00:00',1.53),('8348','2013-03-27','14:05:00',1.4),('8348','2013-03-27','14:10:00',1.45),('8348','2013-03-27','14:15:00',1.65),('8348','2013-03-27','14:20:00',2.06),('8348','2013-03-27','14:25:00',1.62),('8348','2013-03-27','14:30:00',1.37),('8348','2013-03-27','14:35:00',1.64),('8348','2013-03-27','14:40:00',2.12),('8348','2013-03-27','14:45:00',2.04),('8348','2013-03-27','14:50:00',1.61),('8348','2013-03-27','14:55:00',1.16),('8348','2013-03-27','15:00:00',1.01),('8348','2013-03-27','15:05:00',1.33),('8348','2013-03-27','15:10:00',1.34),('8348','2013-03-27','15:25:00',1.03),('8348','2013-03-27','16:45:00',1.15),('8348','2013-03-27','16:55:00',1.16),('8348','2013-03-27','17:00:00',1.27),('8348','2013-03-27','17:05:00',1.49),('8348','2013-03-27','17:10:00',1.2),('8348','2013-03-26','07:50:00',1.31),('8348','2013-03-26','07:55:00',1.37),('8348','2013-03-26','08:35:00',1.26),('8348','2013-03-26','08:40:00',1.33),('8348','2013-03-26','09:15:00',1.39),('8348','2013-03-26','09:50:00',1.1),('8348','2013-03-26','09:55:00',2.42),('8348','2013-03-26','10:00:00',1.15),('8348','2013-03-26','11:00:00',1.08),('8348','2013-03-26','11:05:00',1.01),('8348','2013-03-26','11:10:00',2.19),('8348','2013-03-26','11:15:00',1.32),('8348','2013-03-26','11:20:00',1.42),('8348','2013-03-26','11:50:00',1.13),('8348','2013-03-26','12:00:00',1.33),('8348','2013-03-26','12:05:00',1.22),('8348','2013-03-26','12:10:00',1.25),('8348','2013-03-26','12:15:00',1.33),('8348','2013-03-26','12:20:00',1.47),('8348','2013-03-26','12:25:00',2.31),('8348','2013-03-26','12:30:00',1.94),('8348','2013-03-26','12:35:00',2.65),('8348','2013-03-26','12:40:00',1.46),('8348','2013-03-26','12:45:00',2.47),('8348','2013-03-26','12:50:00',1.72),('8348','2013-03-26','13:00:00',1.48),('8348','2013-03-26','13:05:00',2.19),('8348','2013-03-26','13:10:00',2.05),('8348','2013-03-26','13:15:00',1.7),('8348','2013-03-26','13:20:00',1.82),('8348','2013-03-26','13:25:00',2.05),('8348','2013-03-26','13:30:00',1.62),('8348','2013-03-26','13:35:00',1.92),('8348','2013-03-26','13:40:00',2.2),('8348','2013-03-26','13:45:00',1.92),('8348','2013-03-26','13:50:00',1.63),('8348','2013-03-26','13:55:00',1.44),('8348','2013-03-26','14:00:00',1.43),('8348','2013-03-26','14:05:00',1.4),('8348','2013-03-26','14:10:00',1.49),('8348','2013-03-26','14:15:00',1.37),('8348','2013-03-26','14:20:00',1.14),('8348','2013-03-26','14:25:00',1.06),('8348','2013-03-25','08:25:00',1.55),('8348','2013-03-25','08:30:00',1.19),('8348','2013-03-25','08:55:00',1.08),('8348','2013-03-25','09:00:00',1.02),('8348','2013-03-25','09:10:00',1.13),('8348','2013-03-25','09:15:00',1),('8348','2013-03-25','09:20:00',1.95),('8348','2013-03-25','09:25:00',2.25),('8348','2013-03-25','09:30:00',1.45),('8348','2013-03-25','09:50:00',3.6),('8348','2013-03-25','09:55:00',3.76),('8348','2013-03-25','10:00:00',1.42),('8348','2013-03-25','10:10:00',1.05),('8348','2013-03-25','10:20:00',1.29),('8348','2013-03-25','10:25:00',2.18),('8348','2013-03-25','10:30:00',2.15),('8348','2013-03-25','10:35:00',1.34),('8348','2013-03-25','10:40:00',1.5),('8348','2013-03-25','10:45:00',2.38),('8348','2013-03-25','10:50:00',2.04),('8348','2013-03-25','10:55:00',2.61),('8348','2013-03-25','11:00:00',2.16),('8348','2013-03-25','11:05:00',1.95),('8348','2013-03-25','11:10:00',1.7),('8348','2013-03-25','11:15:00',1.94),('8348','2013-03-25','11:20:00',3.25),('8348','2013-03-25','11:25:00',3.12),('8348','2013-03-25','11:30:00',4.11),('8348','2013-03-25','11:35:00',2.97),('8348','2013-03-25','11:40:00',1.18),('8348','2013-03-25','11:45:00',1.45),('8348','2013-03-25','11:50:00',1.71),('8348','2013-03-25','11:55:00',2.59),('8348','2013-03-25','12:00:00',3.64),('8348','2013-03-25','12:05:00',3.62),('8348','2013-03-25','12:10:00',3.75),('8348','2013-03-25','12:15:00',2.49),('8348','2013-03-25','12:20:00',2.49),('8348','2013-03-25','12:25:00',4.13),('8348','2013-03-25','12:30:00',3.17),('8348','2013-03-25','12:35:00',2.66),('8348','2013-03-25','12:40:00',2.24),('8348','2013-03-25','12:45:00',2.19),('8348','2013-03-25','12:50:00',2.63),('8348','2013-03-25','12:55:00',3.1),('8348','2013-03-25','13:00:00',2.61),('8348','2013-03-25','13:05:00',4.22),('8348','2013-03-25','13:10:00',4.21),('8348','2013-03-25','13:15:00',3.93),('8348','2013-03-25','13:20:00',3.95),('8348','2013-03-25','13:25:00',1.54),('8348','2013-03-25','13:30:00',1.99),('8348','2013-03-25','13:35:00',1.06),('8348','2013-03-25','13:40:00',1.1),('8348','2013-03-25','13:45:00',2.51),('8348','2013-03-25','13:50:00',1.73),('8348','2013-03-25','13:55:00',1.63),('8348','2013-03-25','14:05:00',1.04),('8348','2013-03-25','14:10:00',2.9),('8348','2013-03-25','14:15:00',2.45),('8348','2013-03-25','14:20:00',2.43),('8348','2013-03-25','14:25:00',3.59),('8348','2013-03-25','14:30:00',1.97),('8348','2013-03-25','14:35:00',1.68),('8348','2013-03-25','14:40:00',1.32),('8348','2013-03-25','14:45:00',2.34),('8348','2013-03-25','14:50:00',1.88),('8348','2013-03-25','14:55:00',2.73),('8348','2013-03-25','15:00:00',2.48),('8348','2013-03-25','15:05:00',2.45),('8348','2013-03-25','15:10:00',2.02),('8348','2013-03-25','15:15:00',2.26),('8348','2013-03-25','15:20:00',2.51),('8348','2013-03-25','15:25:00',2.78),('8348','2013-03-25','15:30:00',2.61),('8348','2013-03-25','15:35:00',1.96),('8348','2013-03-25','15:40:00',2.67),('8348','2013-03-25','15:45:00',1.42),('8348','2013-03-25','15:55:00',1.38),('8348','2013-03-25','16:00:00',1.83),('8348','2013-03-25','16:05:00',1.05),('8348','2013-03-25','16:10:00',1.42),('8348','2013-03-25','16:15:00',1.06),('8348','2013-03-25','16:30:00',1.43),('8348','2013-03-25','16:35:00',1.92),('8348','2013-03-25','16:40:00',2.05),('8348','2013-03-24','08:00:00',1.09),('8348','2013-03-24','08:05:00',1.19),('8348','2013-03-24','08:10:00',1.23),('8348','2013-03-24','08:15:00',1.31),('8348','2013-03-24','08:20:00',1.4),('8348','2013-03-24','08:25:00',1.49),('8348','2013-03-24','08:30:00',1.56),('8348','2013-03-24','08:35:00',1.63),('8348','2013-03-24','08:40:00',1.72),('8348','2013-03-24','08:45:00',1.78),('8348','2013-03-24','08:50:00',1.84),('8348','2013-03-24','08:55:00',1.9),('8348','2013-03-24','09:00:00',1.97),('8348','2013-03-24','09:05:00',2.04),('8348','2013-03-24','09:10:00',2.11),('8348','2013-03-24','09:15:00',2.17),('8348','2013-03-24','09:20:00',2.22),('8348','2013-03-24','09:25:00',2.27),('8348','2013-03-24','09:30:00',2.33),('8348','2013-03-24','09:35:00',2.39),('8348','2013-03-24','09:40:00',2.43),('8348','2013-03-24','09:45:00',2.48),('8348','2013-03-24','09:50:00',2.51),('8348','2013-03-24','09:55:00',2.59),('8348','2013-03-24','10:00:00',2.64),('8348','2013-03-24','10:05:00',2.69),('8348','2013-03-24','10:10:00',2.74),('8348','2013-03-24','10:15:00',2.79),('8348','2013-03-24','10:20:00',2.84),('8348','2013-03-24','10:25:00',2.87),('8348','2013-03-24','10:30:00',2.92),('8348','2013-03-24','10:35:00',2.95),('8348','2013-03-24','10:40:00',2.96),('8348','2013-03-24','10:45:00',2.98),('8348','2013-03-24','10:50:00',3),('8348','2013-03-24','10:55:00',3.04),('8348','2013-03-24','11:00:00',3.05),('8348','2013-03-24','11:05:00',3.08),('8348','2013-03-24','11:10:00',3.09),('8348','2013-03-24','11:15:00',3.11),('8348','2013-03-24','11:20:00',3.12),('8348','2013-03-24','11:25:00',3.15),('8348','2013-03-24','11:30:00',3.16),('8348','2013-03-24','11:35:00',3.21),('8348','2013-03-24','11:40:00',3.23),('8348','2013-03-24','11:45:00',3.23),('8348','2013-03-24','11:50:00',3.26),('8348','2013-03-24','11:55:00',3.27),('8348','2013-03-24','12:00:00',3.29),('8348','2013-03-24','12:05:00',3.33),('8348','2013-03-24','12:10:00',3.37),('8348','2013-03-24','12:15:00',3.4),('8348','2013-03-24','12:20:00',3.48),('8348','2013-03-24','12:25:00',3.53),('8348','2013-03-24','12:30:00',3.52),('8348','2013-03-24','12:35:00',3.55),('8348','2013-03-24','12:40:00',3.55),('8348','2013-03-24','12:45:00',3.56),('8348','2013-03-24','12:50:00',3.52),('8348','2013-03-24','12:55:00',3.52),('8348','2013-03-24','13:00:00',3.5),('8348','2013-03-24','13:05:00',3.51),('8348','2013-03-24','13:10:00',3.51),('8348','2013-03-24','13:15:00',3.51),('8348','2013-03-24','13:20:00',3.51),('8348','2013-03-24','13:25:00',3.44),('8348','2013-03-24','13:30:00',3.41),('8348','2013-03-24','13:35:00',3.4),('8348','2013-03-24','13:40:00',3.39),('8348','2013-03-24','13:45:00',3.37),('8348','2013-03-24','13:50:00',3.35),('8348','2013-03-24','13:55:00',3.31),('8348','2013-03-24','14:00:00',3.27),('8348','2013-03-24','14:05:00',3.23),('8348','2013-03-24','14:10:00',3.19),('8348','2013-03-24','14:15:00',3.16),('8348','2013-03-24','14:20:00',3.12),('8348','2013-03-24','14:25:00',3.08),('8348','2013-03-24','14:30:00',2.99),('8348','2013-03-24','14:35:00',2.89),('8348','2013-03-24','14:40:00',2.86),('8348','2013-03-24','14:45:00',2.83),('8348','2013-03-24','14:50:00',2.68),('8348','2013-03-24','14:55:00',2.7),('8348','2013-03-24','15:00:00',2.61),('8348','2013-03-24','15:05:00',2.56),('8348','2013-03-24','15:10:00',2.39),('8348','2013-03-24','15:15:00',2.63),('8348','2013-03-24','15:20:00',2.53),('8348','2013-03-24','15:25:00',2.38),('8348','2013-03-24','15:30:00',2.18),('8348','2013-03-24','15:35:00',2.11),('8348','2013-03-24','15:40:00',2.12),('8348','2013-03-24','15:45:00',1.7),('8348','2013-03-24','15:50:00',1.22),('8348','2013-03-24','15:55:00',1.17),('8348','2013-03-24','16:00:00',1.13),('8348','2013-03-24','16:05:00',1.38),('8348','2013-03-24','16:15:00',1.48),('8348','2013-03-24','16:20:00',1.22),('8348','2013-03-24','16:25:00',1.02),('8348','2013-03-24','16:30:00',1.15),('8348','2013-03-24','16:35:00',1.01),('8348','2013-03-23','08:00:00',1.07),('8348','2013-03-23','08:05:00',1.16),('8348','2013-03-23','08:10:00',1.21),('8348','2013-03-23','08:15:00',1.29),('8348','2013-03-23','08:20:00',1.36),('8348','2013-03-23','08:25:00',1.45),('8348','2013-03-23','08:30:00',1.49),('8348','2013-03-23','08:35:00',1.58),('8348','2013-03-23','08:40:00',1.69),('8348','2013-03-23','08:45:00',1.8),('8348','2013-03-23','08:50:00',1.88),('8348','2013-03-23','08:55:00',1.99),('8348','2013-03-23','09:00:00',2.05),('8348','2013-03-23','09:05:00',2.13),('8348','2013-03-23','09:10:00',2.16),('8348','2013-03-23','09:15:00',2.2),('8348','2013-03-23','09:20:00',2.27),('8348','2013-03-23','09:25:00',2.4),('8348','2013-03-23','09:30:00',2.44),('8348','2013-03-23','09:35:00',2.46),('8348','2013-03-23','09:40:00',2.42),('8348','2013-03-23','09:45:00',2.57),('8348','2013-03-23','09:50:00',2.6),('8348','2013-03-23','09:55:00',2.63),('8348','2013-03-23','10:00:00',2.65),('8348','2013-03-23','10:05:00',2.76),('8348','2013-03-23','10:10:00',2.76),('8348','2013-03-23','10:15:00',2.85),('8348','2013-03-23','10:20:00',2.83),('8348','2013-03-23','10:25:00',2.84),('8348','2013-03-23','10:30:00',2.97),('8348','2013-03-23','10:35:00',3.04),('8348','2013-03-23','10:40:00',3.03),('8348','2013-03-23','10:45:00',3.04),('8348','2013-03-23','10:50:00',3.05),('8348','2013-03-23','10:55:00',2.96),('8348','2013-03-23','11:00:00',2.88),('8348','2013-03-23','11:05:00',2.68),('8348','2013-03-23','11:10:00',2.3),('8348','2013-03-23','11:15:00',2.58),('8348','2013-03-23','11:20:00',3.05),('8348','2013-03-23','11:25:00',3.03),('8348','2013-03-23','11:30:00',3.06),('8348','2013-03-23','11:35:00',3.23),('8348','2013-03-23','11:40:00',3.22),('8348','2013-03-23','11:45:00',3.26),('8348','2013-03-23','11:50:00',3.12),('8348','2013-03-23','11:55:00',3.27),('8348','2013-03-23','12:00:00',3.32),('8348','2013-03-23','12:05:00',3.27),('8348','2013-03-23','12:10:00',3.28),('8348','2013-03-23','12:15:00',3.37),('8348','2013-03-23','12:20:00',3.42),('8348','2013-03-23','12:25:00',3.39),('8348','2013-03-23','12:30:00',3.43),('8348','2013-03-23','12:35:00',3.34),('8348','2013-03-23','12:40:00',3.29),('8348','2013-03-23','12:45:00',3.38),('8348','2013-03-23','12:50:00',3.44),('8348','2013-03-23','12:55:00',3.39),('8348','2013-03-23','13:00:00',2.62),('8348','2013-03-23','13:05:00',3.38),('8348','2013-03-23','13:10:00',3.43),('8348','2013-03-23','13:15:00',3.29),('8348','2013-03-23','13:20:00',3.35),('8348','2013-03-23','13:25:00',3.25),('8348','2013-03-23','13:30:00',3.06),('8348','2013-03-23','13:35:00',3.04),('8348','2013-03-23','13:40:00',3.3),('8348','2013-03-23','13:45:00',3.04),('8348','2013-03-23','13:50:00',3.32),('8348','2013-03-23','13:55:00',3.2),('8348','2013-03-23','14:00:00',3.18),('8348','2013-03-23','14:05:00',3.21),('8348','2013-03-23','14:10:00',3.11),('8348','2013-03-23','14:15:00',3.02),('8348','2013-03-23','14:20:00',3.14),('8348','2013-03-23','14:25:00',3.06),('8348','2013-03-23','14:30:00',3.05),('8348','2013-03-23','14:35:00',2.99),('8348','2013-03-23','14:40:00',2.91),('8348','2013-03-23','14:45:00',2.75),('8348','2013-03-23','14:50:00',2.69),('8348','2013-03-23','14:55:00',2.74),('8348','2013-03-23','15:00:00',2.64),('8348','2013-03-23','15:05:00',2.5),('8348','2013-03-23','15:10:00',2.59),('8348','2013-03-23','15:15:00',2.42),('8348','2013-03-23','15:20:00',2.48),('8348','2013-03-23','15:25:00',2.45),('8348','2013-03-23','15:30:00',2.21),('8348','2013-03-23','15:35:00',2.23),('8348','2013-03-23','15:40:00',2.07),('8348','2013-03-23','15:45:00',1.96),('8348','2013-03-23','15:50:00',1.86),('8348','2013-03-23','15:55:00',1.78),('8348','2013-03-23','16:00:00',1.69),('8348','2013-03-23','16:05:00',1.55),('8348','2013-03-23','16:10:00',1.96),('8348','2013-03-23','16:15:00',1.78),('8348','2013-03-23','16:20:00',1.5),('8348','2013-03-23','16:25:00',1.53),('8348','2013-03-23','16:30:00',1.2),('8348','2013-03-23','16:35:00',1.3),('8348','2013-03-23','16:40:00',1.12),('8348','2013-03-23','16:45:00',1.13),('8348','2013-03-23','17:00:00',1.12),('8348','2013-03-23','17:05:00',1.17),('8348','2013-03-23','17:10:00',1),('8348','2014-03-26','07:25:00',1.09),('8348','2014-03-26','07:30:00',1.19),('8348','2014-03-26','07:35:00',1.28),('8348','2014-03-26','07:40:00',1.37),('8348','2014-03-26','07:45:00',1.53),('8348','2014-03-26','07:50:00',1.75),('8348','2014-03-26','07:55:00',1.84),('8348','2014-03-26','08:00:00',1.96),('8348','2014-03-26','08:05:00',2.08),('8348','2014-03-26','08:10:00',2.28),('8348','2014-03-26','08:15:00',2.55),('8348','2014-03-26','08:20:00',3.25),('8348','2014-03-26','08:25:00',2.47),('8348','2014-03-26','08:30:00',1.92),('8348','2014-03-26','08:35:00',1.59),('8348','2014-03-26','08:40:00',1.8),('8348','2014-03-26','08:45:00',2),('8348','2014-03-26','08:50:00',2.33),('8348','2014-03-26','08:55:00',2.08),('8348','2014-03-26','09:00:00',2.32),('8348','2014-03-26','09:05:00',2.19),('8348','2014-03-26','09:10:00',2.54),('8348','2014-03-26','09:15:00',2.06),('8348','2014-03-26','09:20:00',1.66),('8348','2014-03-26','09:25:00',2.1),('8348','2014-03-26','09:30:00',5),('8348','2014-03-26','09:35:00',5.09),('8348','2014-03-26','09:40:00',5.16),('8348','2014-03-26','09:45:00',5.24),('8348','2014-03-26','09:50:00',5.31),('8348','2014-03-26','09:55:00',5.4),('8348','2014-03-26','10:00:00',5.75),('8348','2014-03-26','10:05:00',4.76),('8348','2014-03-26','10:10:00',5.73),('8348','2014-03-26','10:15:00',6.9),('8348','2014-03-26','10:20:00',6.23),('8348','2014-03-26','10:25:00',5.82),('8348','2014-03-26','10:30:00',5.73),('8348','2014-03-26','10:35:00',2.61),('8348','2014-03-26','10:40:00',1.62),('8348','2014-03-26','10:45:00',2.55),('8348','2014-03-26','10:50:00',3.53),('8348','2014-03-26','10:55:00',8.37),('8348','2014-03-26','11:00:00',6.43),('8348','2014-03-26','11:05:00',1.95),('8348','2014-03-26','11:10:00',2.8),('8348','2014-03-26','11:15:00',6.29),('8348','2014-03-26','11:20:00',5.01),('8348','2014-03-26','11:25:00',2.34),('8348','2014-03-26','11:30:00',3.02),('8348','2014-03-26','11:35:00',3.17),('8348','2014-03-26','11:40:00',3.91),('8348','2014-03-26','11:45:00',5.44),('8348','2014-03-26','11:50:00',7.97),('8348','2014-03-26','11:55:00',8.07),('8348','2014-03-26','12:00:00',7.49),('8348','2014-03-26','12:05:00',7.19),('8348','2014-03-26','12:10:00',7.78),('8348','2014-03-26','12:15:00',3.01),('8348','2014-03-26','12:20:00',3.31),('8348','2014-03-26','12:25:00',3.17),('8348','2014-03-26','12:30:00',3.07),('8348','2014-03-26','12:35:00',2.96),('8348','2014-03-26','12:40:00',3.74),('8348','2014-03-26','12:45:00',4.06),('8348','2014-03-26','12:50:00',3.04),('8348','2014-03-26','12:55:00',2.34),('8348','2014-03-26','13:00:00',2.33),('8348','2014-03-26','13:05:00',2.29),('8348','2014-03-26','13:10:00',2.19),('8348','2014-03-26','13:15:00',1.47),('8348','2014-03-26','13:20:00',2.94),('8348','2014-03-26','13:25:00',7.97),('8348','2014-03-26','13:30:00',4.36),('8348','2014-03-26','13:35:00',2.84),('8348','2014-03-26','13:40:00',2.34),('8348','2014-03-26','13:45:00',1.8),('8348','2014-03-26','13:50:00',1.74),('8348','2014-03-26','13:55:00',2.26),('8348','2014-03-26','14:00:00',3.08),('8348','2014-03-26','14:05:00',6.04),('8348','2014-03-26','14:10:00',7.41),('8348','2014-03-26','14:15:00',3.33),('8348','2014-03-26','14:20:00',1.68),('8348','2014-03-26','14:25:00',1.39),('8348','2014-03-26','14:30:00',1.27),('8348','2014-03-26','14:35:00',1.15),('8348','2014-03-26','14:40:00',1.21),('8348','2014-03-26','14:45:00',4.12),('8348','2014-03-26','14:50:00',5.86),('8348','2014-03-26','14:55:00',6.13),('8348','2014-03-26','15:00:00',5.77),('8348','2014-03-26','15:05:00',5.66),('8348','2014-03-26','15:10:00',5.8),('8348','2014-03-26','15:15:00',5.99),('8348','2014-03-26','15:20:00',5.57),('8348','2014-03-26','15:25:00',5.64),('8348','2014-03-26','15:30:00',5.79),('8348','2014-03-26','15:35:00',5.58),('8348','2014-03-26','15:40:00',4.57),('8348','2014-03-26','15:45:00',4.76),('8348','2014-03-26','15:50:00',4.14),('8348','2014-03-26','15:55:00',3.1),('8348','2014-03-26','16:00:00',2.5),('8348','2014-03-26','16:05:00',2.99),('8348','2014-03-26','16:10:00',2.9),('8348','2014-03-26','16:15:00',3.2),('8348','2014-03-26','16:20:00',1.98),('8348','2014-03-26','16:25:00',1.54),('8348','2014-03-26','16:30:00',1.21),('8348','2014-03-26','16:35:00',1.2),('8348','2013-03-22','08:00:00',1.04),('8348','2013-03-22','08:05:00',1.1),('8348','2013-03-22','08:10:00',1.17),('8348','2013-03-22','08:15:00',1.24),('8348','2013-03-22','08:20:00',1.32),('8348','2013-03-22','08:25:00',1.42),('8348','2013-03-22','08:30:00',1.51),('8348','2013-03-22','08:35:00',1.59),('8348','2013-03-22','08:40:00',1.68),('8348','2013-03-22','08:45:00',1.79),('8348','2013-03-22','08:50:00',1.87),('8348','2013-03-22','08:55:00',1.94),('8348','2013-03-22','09:00:00',1.99),('8348','2013-03-22','09:05:00',2.05),('8348','2013-03-22','09:10:00',2.13),('8348','2013-03-22','09:15:00',2.18),('8348','2013-03-22','09:20:00',2.25),('8348','2013-03-22','09:25:00',2.29),('8348','2013-03-22','09:30:00',2.36),('8348','2013-03-22','09:35:00',2.42),('8348','2013-03-22','09:40:00',2.47),('8348','2013-03-22','09:45:00',2.56),('8348','2013-03-22','09:50:00',2.59),('8348','2013-03-22','09:55:00',2.65),('8348','2013-03-22','10:00:00',2.7),('8348','2013-03-22','10:05:00',2.75),('8348','2013-03-22','10:10:00',2.8),('8348','2013-03-22','10:15:00',2.8),('8348','2013-03-22','10:20:00',2.86),('8348','2013-03-22','10:25:00',2.97),('8348','2013-03-22','10:30:00',3.03),('8348','2013-03-22','10:35:00',3.09),('8348','2013-03-22','10:40:00',3.13),('8348','2013-03-22','10:45:00',3.18),('8348','2013-03-22','10:50:00',3.23),('8348','2013-03-22','10:55:00',3.25),('8348','2013-03-22','11:00:00',3.26),('8348','2013-03-22','11:05:00',3.29),('8348','2013-03-22','11:10:00',3.34),('8348','2013-03-22','11:15:00',3.39),('8348','2013-03-22','11:20:00',3.4),('8348','2013-03-22','11:25:00',3.36),('8348','2013-03-22','11:30:00',3.45),('8348','2013-03-22','11:35:00',3.47),('8348','2013-03-22','11:40:00',3.51),('8348','2013-03-22','11:45:00',3.55),('8348','2013-03-22','11:50:00',3.54),('8348','2013-03-22','11:55:00',3.57),('8348','2013-03-22','12:00:00',3.57),('8348','2013-03-22','12:05:00',3.61),('8348','2013-03-22','12:10:00',3.6),('8348','2013-03-22','12:15:00',3.61),('8348','2013-03-22','12:20:00',3.61),('8348','2013-03-22','12:25:00',3.63),('8348','2013-03-22','12:30:00',3.66),('8348','2013-03-22','12:35:00',3.65),('8348','2013-03-22','12:40:00',3.67),('8348','2013-03-22','12:45:00',3.65),('8348','2013-03-22','12:50:00',3.59),('8348','2013-03-22','12:55:00',3.47),('8348','2013-03-22','13:00:00',3.67),('8348','2013-03-22','13:05:00',3.56),('8348','2013-03-22','13:10:00',3.68),('8348','2013-03-22','13:15:00',3.65),('8348','2013-03-22','13:20:00',3.61),('8348','2013-03-22','13:25:00',3.42),('8348','2013-03-22','13:30:00',3.39),('8348','2013-03-22','13:35:00',3.49),('8348','2013-03-22','13:40:00',2.98),('8348','2013-03-22','13:45:00',3.12),('8348','2013-03-22','13:50:00',3.54),('8348','2013-03-22','13:55:00',3.48),('8348','2013-03-22','14:00:00',3.41),('8348','2013-03-22','14:05:00',3.37),('8348','2013-03-22','14:10:00',3.34),('8348','2013-03-22','14:15:00',3.3),('8348','2013-03-22','14:20:00',3.27),('8348','2013-03-22','14:25:00',3.23),('8348','2013-03-22','14:30:00',3.19),('8348','2013-03-22','14:35:00',3.14),('8348','2013-03-22','14:40:00',3.08),('8348','2013-03-22','14:45:00',3.03),('8348','2013-03-22','14:50:00',2.99),('8348','2013-03-22','14:55:00',2.95),('8348','2013-03-22','15:00:00',2.92),('8348','2013-03-22','15:05:00',2.83),('8348','2013-03-22','15:10:00',2.52),('8348','2013-03-22','15:15:00',2.11),('8348','2013-03-22','15:20:00',2.08),('8348','2013-03-22','15:25:00',2.23),('8348','2013-03-22','15:30:00',2.05),('8348','2013-03-22','15:35:00',2.3),('8348','2013-03-22','15:40:00',2.2),('8348','2013-03-22','15:45:00',1.96),('8348','2013-03-22','15:50:00',2.13),('8348','2013-03-22','15:55:00',1.86),('8348','2013-03-22','16:00:00',1.36),('8348','2013-03-22','16:05:00',1.41),('8348','2013-03-22','16:10:00',1.65),('8348','2013-03-22','16:15:00',1.94),('8348','2013-03-22','16:20:00',1.53),('8348','2013-03-22','16:25:00',1.58),('8348','2013-03-22','16:30:00',1.72),('8348','2013-03-22','16:35:00',1.71),('8348','2013-03-22','16:40:00',1.67),('8348','2013-03-22','16:45:00',1.55),('8348','2013-03-22','16:50:00',1.44),('8348','2013-03-22','16:55:00',1.39),('8348','2013-03-22','17:00:00',1.27),('8348','2013-03-22','17:05:00',1.13),('8348','2013-03-22','17:10:00',1.03),('8348','2013-03-21','08:15:00',1.21),('8348','2013-03-21','08:20:00',1.35),('8348','2013-03-21','08:25:00',1.69),('8348','2013-03-21','08:30:00',1.51),('8348','2013-03-21','08:35:00',1.69),('8348','2013-03-21','08:40:00',1.73),('8348','2013-03-21','08:45:00',1.93),('8348','2013-03-21','08:50:00',1.81),('8348','2013-03-21','08:55:00',1.98),('8348','2013-03-21','09:00:00',2.13),('8348','2013-03-21','09:05:00',2.4),('8348','2013-03-21','09:10:00',2.68),('8348','2013-03-21','09:15:00',1.81),('8348','2013-03-21','09:20:00',2.03),('8348','2013-03-21','09:25:00',2.44),('8348','2013-03-21','09:30:00',2.56),('8348','2013-03-21','09:35:00',2.59),('8348','2013-03-21','09:40:00',2.54),('8348','2013-03-21','09:45:00',2.71),('8348','2013-03-21','09:50:00',2.78),('8348','2013-03-21','09:55:00',2.84),('8348','2013-03-21','10:00:00',2.91),('8348','2013-03-21','10:05:00',2.93),('8348','2013-03-21','10:10:00',2.99),('8348','2013-03-21','10:15:00',3.03),('8348','2013-03-21','10:20:00',3.08),('8348','2013-03-21','10:25:00',3.11),('8348','2013-03-21','10:30:00',3.17),('8348','2013-03-21','10:35:00',3.21),('8348','2013-03-21','10:40:00',3.24),('8348','2013-03-21','10:45:00',3.24),('8348','2013-03-21','10:50:00',3.26),('8348','2013-03-21','10:55:00',2.55),('8348','2013-03-21','11:00:00',3.39),('8348','2013-03-21','11:05:00',3.43),('8348','2013-03-21','11:10:00',3.47),('8348','2013-03-21','11:15:00',3.52),('8348','2013-03-21','11:20:00',3.54),('8348','2013-03-21','11:25:00',3.59),('8348','2013-03-21','11:30:00',3.63),('8348','2013-03-21','11:35:00',3.66),('8348','2013-03-21','11:40:00',3.66),('8348','2013-03-21','11:45:00',3.69),('8348','2013-03-21','11:50:00',3.72),('8348','2013-03-21','11:55:00',3.73),('8348','2013-03-21','12:00:00',3.74),('8348','2013-03-21','12:05:00',3.76),('8348','2013-03-21','12:10:00',3.77),('8348','2013-03-21','12:15:00',3.78),('8348','2013-03-21','12:20:00',3.78),('8348','2013-03-21','12:25:00',3.79),('8348','2013-03-21','12:30:00',3.81),('8348','2013-03-21','12:35:00',3.81),('8348','2013-03-21','12:40:00',3.8),('8348','2013-03-21','12:45:00',3.79),('8348','2013-03-21','12:50:00',3.78),('8348','2013-03-21','12:55:00',3.78),('8348','2013-03-21','13:00:00',3.77),('8348','2013-03-21','13:05:00',3.73),('8348','2013-03-21','13:10:00',3.7),('8348','2013-03-21','13:15:00',3.69),('8348','2013-03-21','13:20:00',3.68),('8348','2013-03-21','13:25:00',3.66),('8348','2013-03-21','13:30:00',3.66),('8348','2013-03-21','13:35:00',3.63),('8348','2013-03-21','13:40:00',3.61),('8348','2013-03-21','13:45:00',3.58),('8348','2013-03-21','13:50:00',3.54),('8348','2013-03-21','13:55:00',3.5),('8348','2013-03-21','14:00:00',3.47),('8348','2013-03-21','14:05:00',3.42),('8348','2013-03-21','14:10:00',3.38),('8348','2013-03-21','14:15:00',3.35),('8348','2013-03-21','14:20:00',3.31),('8348','2013-03-21','14:25:00',3.27),('8348','2013-03-21','14:30:00',3.2),('8348','2013-03-21','14:35:00',3.13),('8348','2013-03-21','14:40:00',3.1),('8348','2013-03-21','14:45:00',3.07),('8348','2013-03-21','14:50:00',3.04),('8348','2013-03-21','14:55:00',2.98),('8348','2013-03-21','15:00:00',2.92),('8348','2013-03-21','15:05:00',2.87),('8348','2013-03-21','15:10:00',2.81),('8348','2013-03-21','15:15:00',2.76),('8348','2013-03-21','15:20:00',2.69),('8348','2013-03-21','15:25:00',2.64),('8348','2013-03-21','15:30:00',2.57),('8348','2013-03-21','15:35:00',2.5),('8348','2013-03-21','15:40:00',2.43),('8348','2013-03-21','15:45:00',2.35),('8348','2013-03-21','15:50:00',2.28),('8348','2013-03-21','15:55:00',2.21),('8348','2013-03-21','16:00:00',2.14),('8348','2013-03-21','16:05:00',2.07),('8348','2013-03-21','16:10:00',1.98),('8348','2013-03-21','16:15:00',1.91),('8348','2013-03-21','16:20:00',1.83),('8348','2013-03-21','16:25:00',1.73),('8348','2013-03-21','16:30:00',1.63),('8348','2013-03-21','16:35:00',1.54),('8348','2013-03-21','16:40:00',1.44),('8348','2013-03-21','16:45:00',1.38),('8348','2013-03-21','16:50:00',1.29),('8348','2013-03-21','16:55:00',1.19),('8348','2013-03-21','17:00:00',1.1),('8348','2013-03-21','17:05:00',1.02),('8348','2013-03-20','07:55:00',1.08),('8348','2013-03-20','08:00:00',1.03),('8348','2013-03-20','08:05:00',1.07),('8348','2013-03-20','08:10:00',1.16),('8348','2013-03-20','08:15:00',1.22),('8348','2013-03-20','08:20:00',1.29),('8348','2013-03-20','08:25:00',1.4),('8348','2013-03-20','08:30:00',1.52),('8348','2013-03-20','08:35:00',1.62),('8348','2013-03-20','08:40:00',1.49),('8348','2013-03-20','08:45:00',1.68),('8348','2013-03-20','08:50:00',1.78),('8348','2013-03-20','08:55:00',1.77),('8348','2013-03-20','09:00:00',1.79),('8348','2013-03-20','09:05:00',2.4),('8348','2013-03-20','09:10:00',1.95),('8348','2013-03-20','09:15:00',2.17),('8348','2013-03-20','09:20:00',2.24),('8348','2013-03-20','09:25:00',2.09),('8348','2013-03-20','09:30:00',2.38),('8348','2013-03-20','09:35:00',2.29),('8348','2013-03-20','09:40:00',2.42),('8348','2013-03-20','09:45:00',2.49),('8348','2013-03-20','09:50:00',2.53),('8348','2013-03-20','09:55:00',2.54),('8348','2013-03-20','10:00:00',2.63),('8348','2013-03-20','10:05:00',2.66),('8348','2013-03-20','10:10:00',2.64),('8348','2013-03-20','10:15:00',2.07),('8348','2013-03-20','10:20:00',2.07),('8348','2013-03-20','10:25:00',1.96),('8348','2013-03-20','10:30:00',2.56),('8348','2013-03-20','10:35:00',3.16),('8348','2013-03-20','10:40:00',2.53),('8348','2013-03-20','10:45:00',2.11),('8348','2013-03-20','10:50:00',2.85),('8348','2013-03-20','10:55:00',2.47),('8348','2013-03-20','11:00:00',2.38),('8348','2013-03-20','11:05:00',2.88),('8348','2013-03-20','11:10:00',2.2),('8348','2013-03-20','11:15:00',2.12),('8348','2013-03-20','11:20:00',2.29),('8348','2013-03-20','11:25:00',2.26),('8348','2013-03-20','11:30:00',2.1),('8348','2013-03-20','11:35:00',2.33),('8348','2013-03-20','11:40:00',1.91),('8348','2013-03-20','11:45:00',1.82),('8348','2013-03-20','11:50:00',1.77),('8348','2013-03-20','11:55:00',1.96),('8348','2013-03-20','12:00:00',1.91),('8348','2013-03-20','12:05:00',2.13),('8348','2013-03-20','12:10:00',1.77),('8348','2013-03-20','12:15:00',1.52),('8348','2013-03-20','12:20:00',1.41),('8348','2013-03-20','12:25:00',1.19),('8348','2013-03-20','12:35:00',1.23),('8348','2013-03-20','12:50:00',1.32),('8348','2013-03-20','12:55:00',1.57),('8348','2013-03-20','13:00:00',1.69),('8348','2013-03-20','13:05:00',1.26),('8348','2013-03-20','13:10:00',1.29),('8348','2013-03-20','13:15:00',1.04),('8348','2013-03-20','13:20:00',1.13),('8348','2013-03-20','13:25:00',1.23),('8348','2013-03-20','13:30:00',1.34),('8348','2013-03-20','13:35:00',1.28),('8348','2013-03-20','13:40:00',1.59),('8348','2013-03-20','13:45:00',1.84),('8348','2013-03-20','13:50:00',1.56),('8348','2013-03-20','13:55:00',1.45),('8348','2013-03-20','14:00:00',1.45),('8348','2013-03-20','14:05:00',1.24),('8348','2013-03-20','14:10:00',1.16),('8348','2013-03-20','14:15:00',1.56),('8348','2013-03-20','14:20:00',1.93),('8348','2013-03-20','14:25:00',1.8),('8348','2013-03-20','14:30:00',1.56),('8348','2013-03-20','14:35:00',1.27),('8348','2013-03-20','14:40:00',1),('8348','2013-03-19','08:10:00',1.09),('8348','2013-03-19','08:15:00',1.19),('8348','2013-03-19','08:20:00',1.24),('8348','2013-03-19','08:25:00',1.32),('8348','2013-03-19','08:30:00',1.35),('8348','2013-03-19','08:35:00',1.48),('8348','2013-03-19','08:40:00',1.59),('8348','2013-03-19','08:45:00',1.72),('8348','2013-03-19','08:50:00',1.81),('8348','2013-03-19','08:55:00',1.85),('8348','2013-03-19','09:00:00',1.93),('8348','2013-03-19','09:05:00',1.85),('8348','2013-03-19','09:10:00',2.09),('8348','2013-03-19','09:15:00',1.71),('8348','2013-03-19','09:20:00',1.73),('8348','2013-03-19','09:25:00',2.24),('8348','2013-03-19','09:30:00',2.38),('8348','2013-03-19','09:35:00',2.44),('8348','2013-03-19','09:40:00',2.56),('8348','2013-03-19','09:45:00',2.48),('8348','2013-03-19','09:50:00',2.64),('8348','2013-03-19','09:55:00',2.27),('8348','2013-03-19','10:00:00',2.96),('8348','2013-03-19','10:05:00',2.25),('8348','2013-03-19','10:10:00',2.59),('8348','2013-03-19','10:15:00',2.92),('8348','2013-03-19','10:20:00',2.98),('8348','2013-03-19','10:25:00',3.08),('8348','2013-03-19','10:30:00',3.09),('8348','2013-03-19','10:35:00',3.13),('8348','2013-03-19','10:40:00',3.16),('8348','2013-03-19','10:45:00',3.22),('8348','2013-03-19','10:50:00',3.24),('8348','2013-03-19','10:55:00',3.35),('8348','2013-03-19','11:00:00',3.36),('8348','2013-03-19','11:05:00',3.38),('8348','2013-03-19','11:10:00',3.32),('8348','2013-03-19','11:15:00',3.45),('8348','2013-03-19','11:20:00',3.45),('8348','2013-03-19','11:25:00',3.47),('8348','2013-03-19','11:30:00',3.46),('8348','2013-03-19','11:35:00',2.17),('8348','2013-03-19','11:40:00',3.14),('8348','2013-03-19','11:45:00',3.27),('8348','2013-03-19','11:50:00',3.64),('8348','2013-03-19','11:55:00',3.69),('8348','2013-03-19','12:00:00',3.64),('8348','2013-03-19','12:05:00',3.61),('8348','2013-03-19','12:10:00',3.65),('8348','2013-03-19','12:15:00',3.45),('8348','2013-03-19','12:20:00',3.67),('8348','2013-03-19','12:25:00',3.61),('8348','2013-03-19','12:30:00',3.62),('8348','2013-03-19','12:35:00',3.63),('8348','2013-03-19','12:40:00',3.67),('8348','2013-03-19','12:45:00',3.69),('8348','2013-03-19','12:50:00',3.57),('8348','2013-03-19','12:55:00',3.59),('8348','2013-03-19','13:00:00',3.65),('8348','2013-03-19','13:05:00',3.63),('8348','2013-03-19','13:10:00',3.58),('8348','2013-03-19','13:15:00',3.59),('8348','2013-03-19','13:20:00',3.54),('8348','2013-03-19','13:25:00',3.52),('8348','2013-03-19','13:30:00',3.51),('8348','2013-03-19','13:35:00',3.46),('8348','2013-03-19','13:40:00',3.41),('8348','2013-03-19','13:45:00',3.43),('8348','2013-03-19','13:50:00',3.41),('8348','2013-03-19','13:55:00',3.37),('8348','2013-03-19','14:00:00',3.36),('8348','2013-03-19','14:05:00',3.32),('8348','2013-03-19','14:10:00',3.29),('8348','2013-03-19','14:15:00',3.25),('8348','2013-03-19','14:20:00',3.21),('8348','2013-03-19','14:25:00',3.17),('8348','2013-03-19','14:30:00',3.14),('8348','2013-03-19','14:35:00',3.08),('8348','2013-03-19','14:40:00',3.04),('8348','2013-03-19','14:45:00',2.99),('8348','2013-03-19','14:50:00',2.92),('8348','2013-03-19','14:55:00',2.86),('8348','2013-03-19','15:00:00',2.81),('8348','2013-03-19','15:05:00',2.77),('8348','2013-03-19','15:10:00',2.71),('8348','2013-03-19','15:15:00',2.63),('8348','2013-03-19','15:20:00',2.59),('8348','2013-03-19','15:25:00',2.53),('8348','2013-03-19','15:30:00',2.47),('8348','2013-03-19','15:35:00',2.42),('8348','2013-03-19','15:40:00',2.34),('8348','2013-03-19','15:45:00',2.27),('8348','2013-03-19','15:50:00',2.2),('8348','2013-03-19','15:55:00',2.13),('8348','2013-03-19','16:00:00',2.05),('8348','2013-03-19','16:05:00',1.96),('8348','2013-03-19','16:10:00',1.88),('8348','2013-03-19','16:15:00',1.81),('8348','2013-03-19','16:20:00',1.73),('8348','2013-03-19','16:25:00',1.67),('8348','2013-03-19','16:30:00',1.59),('8348','2013-03-19','16:35:00',1.49),('8348','2013-03-19','16:40:00',1.42),('8348','2013-03-19','16:45:00',1.15),('8348','2013-03-18','10:00:00',1.13),('8348','2013-03-18','10:05:00',1.34),('8348','2013-03-18','10:10:00',1.35),('8348','2013-03-18','10:15:00',1.19),('8348','2013-03-18','10:20:00',1.39),('8348','2013-03-18','10:25:00',1.66),('8348','2013-03-18','10:30:00',1.63),('8348','2013-03-18','10:35:00',1.38),('8348','2013-03-18','10:40:00',1.3),('8348','2013-03-18','10:45:00',1.37),('8348','2013-03-18','10:50:00',1.29),('8348','2013-03-18','10:55:00',1.07),('8348','2013-03-18','11:00:00',1.18),('8348','2013-03-18','11:05:00',1.31),('8348','2013-03-18','11:10:00',1.47),('8348','2013-03-18','11:15:00',1.61),('8348','2013-03-18','11:20:00',1.65),('8348','2013-03-18','11:25:00',1.71),('8348','2013-03-18','11:30:00',2.16),('8348','2013-03-18','11:35:00',1.81),('8348','2013-03-18','11:40:00',1.62),('8348','2013-03-18','11:45:00',1.39),('8348','2013-03-18','11:50:00',1.14),('8348','2013-03-18','11:55:00',1.36),('8348','2013-03-18','12:00:00',1.43),('8348','2013-03-18','12:05:00',2.4),('8348','2013-03-18','12:10:00',2.25),('8348','2013-03-18','12:15:00',2.72),('8348','2013-03-18','12:20:00',2.54),('8348','2013-03-18','12:25:00',1.82),('8348','2013-03-18','12:30:00',3.01),('8348','2013-03-18','12:35:00',3.39),('8348','2013-03-18','12:40:00',2.61),('8348','2013-03-18','12:45:00',2.4),('8348','2013-03-18','12:50:00',3.27),('8348','2013-03-18','12:55:00',3.49),('8348','2013-03-18','13:00:00',2.76),('8348','2013-03-18','13:05:00',1.4),('8348','2013-03-18','13:10:00',1.06),('8348','2013-03-18','13:20:00',1.01),('8348','2013-03-18','13:25:00',1.74),('8348','2013-03-18','13:30:00',1.26),('8348','2013-03-18','13:35:00',1.07),('8348','2013-03-18','13:40:00',1.85),('8348','2013-03-18','13:45:00',1.66),('8348','2013-03-18','13:50:00',1.56),('8348','2013-03-18','13:55:00',1.38),('8348','2013-03-18','14:00:00',1.52),('8348','2013-03-18','14:05:00',2.34),('8348','2013-03-18','14:10:00',2.16),('8348','2013-03-18','14:15:00',1.13),('8348','2013-03-18','14:20:00',1.07),('8348','2013-03-18','14:25:00',1.52),('8348','2013-03-18','14:35:00',1.03),('8348','2013-03-18','14:40:00',1.07),('8348','2013-03-17','08:20:00',1.06),('8348','2013-03-17','08:25:00',1.29),('8348','2013-03-17','08:30:00',1.15),('8348','2013-03-17','08:35:00',1.01),('8348','2013-03-17','08:40:00',1.04),('8348','2013-03-17','08:45:00',1.22),('8348','2013-03-17','08:50:00',1.21),('8348','2013-03-17','08:55:00',1.15),('8348','2013-03-17','09:00:00',1.13),('8348','2013-03-17','09:05:00',1.31),('8348','2013-03-17','09:10:00',1.5),('8348','2013-03-17','09:15:00',1.6),('8348','2013-03-17','09:20:00',1.38),('8348','2013-03-17','09:25:00',1.18),('8348','2013-03-17','09:30:00',1.29),('8348','2013-03-17','09:35:00',1.45),('8348','2013-03-17','09:40:00',1.37),('8348','2013-03-17','09:45:00',1.41),('8348','2013-03-17','09:50:00',1.58),('8348','2013-03-17','09:55:00',1.68),('8348','2013-03-17','10:00:00',1.85),('8348','2013-03-17','10:05:00',1.56),('8348','2013-03-17','10:10:00',1.54),('8348','2013-03-17','10:15:00',1.67),('8348','2013-03-17','10:20:00',1.69),('8348','2013-03-17','10:25:00',1.77),('8348','2013-03-17','10:30:00',1.73),('8348','2013-03-17','10:35:00',1.66),('8348','2013-03-17','10:40:00',1.58),('8348','2013-03-17','10:45:00',1.66),('8348','2013-03-17','10:50:00',1.57),('8348','2013-03-17','10:55:00',1.42),('8348','2013-03-17','11:00:00',1.45),('8348','2013-03-17','11:05:00',1.24),('8348','2013-03-17','11:10:00',1.21),('8348','2013-03-17','11:15:00',1.34),('8348','2013-03-17','11:20:00',1.55),('8348','2013-03-17','11:25:00',1.58),('8348','2013-03-17','11:30:00',1.41),('8348','2013-03-17','11:35:00',1.4),('8348','2013-03-17','11:40:00',1.33),('8348','2013-03-17','11:45:00',1.23),('8348','2013-03-17','11:50:00',1.14),('8348','2013-03-17','11:55:00',1.02),('8348','2013-03-17','12:10:00',1.29),('8348','2013-03-17','12:15:00',1.76),('8348','2013-03-17','12:20:00',2.12),('8348','2013-03-17','12:25:00',3.05),('8348','2013-03-17','12:30:00',3.28),('8348','2013-03-17','12:35:00',2.2),('8348','2013-03-17','12:40:00',2.38),('8348','2013-03-17','12:45:00',2.23),('8348','2013-03-17','12:50:00',1.97),('8348','2013-03-17','12:55:00',1.6),('8348','2013-03-17','13:00:00',1.86),('8348','2013-03-17','13:05:00',2.02),('8348','2013-03-17','13:10:00',2.23),('8348','2013-03-17','13:15:00',2.16),('8348','2013-03-17','13:20:00',1.82),('8348','2013-03-17','13:25:00',1.64),('8348','2013-03-17','13:30:00',2.5),('8348','2013-03-17','13:35:00',2.65),('8348','2013-03-17','13:40:00',1.84),('8348','2013-03-17','13:45:00',1.66),('8348','2013-03-17','13:50:00',1.31),('8348','2013-03-17','13:55:00',1.98),('8348','2013-03-17','14:00:00',1.92),('8348','2013-03-17','14:05:00',1.96),('8348','2013-03-17','14:10:00',2.31),('8348','2013-03-17','14:15:00',2.49),('8348','2013-03-17','14:20:00',2.49),('8348','2013-03-17','14:25:00',2.27),('8348','2013-03-17','14:30:00',2.1),('8348','2013-03-17','14:35:00',1.77),('8348','2013-03-17','14:40:00',1.35),('8348','2013-03-17','14:45:00',1.22),('8348','2013-03-17','14:50:00',1.05),('8348','2013-03-17','14:55:00',1.13),('8348','2013-03-17','15:00:00',1.46),('8348','2013-03-17','15:05:00',1.57),('8348','2013-03-17','15:10:00',2.03),('8348','2013-03-17','15:15:00',1.93),('8348','2013-03-17','15:20:00',2.26),('8348','2013-03-17','15:25:00',1.99),('8348','2013-03-17','15:30:00',1.24),('8348','2013-03-17','15:35:00',1.53),('8348','2013-03-17','15:40:00',1.49),('8348','2013-03-17','15:45:00',1.4),('8348','2013-03-17','16:45:00',1.13),('8348','2013-03-16','08:15:00',1.3),('8348','2013-03-16','08:20:00',1.46),('8348','2013-03-16','08:25:00',1.46),('8348','2013-03-16','08:30:00',1.46),('8348','2013-03-16','08:35:00',1.57),('8348','2013-03-16','08:40:00',1.67),('8348','2013-03-16','08:45:00',1.66),('8348','2013-03-16','08:50:00',1.88),('8348','2013-03-16','08:55:00',2.04),('8348','2013-03-16','09:00:00',2.03),('8348','2013-03-16','09:05:00',1.68),('8348','2013-03-16','09:10:00',2.06),('8348','2013-03-16','09:15:00',2.23),('8348','2013-03-16','09:20:00',2.27),('8348','2013-03-16','09:25:00',1.69),('8348','2013-03-16','09:30:00',2.45),('8348','2013-03-16','09:35:00',2.61),('8348','2013-03-16','09:40:00',2.45),('8348','2013-03-16','09:45:00',2.77),('8348','2013-03-16','09:50:00',2.73),('8348','2013-03-16','09:55:00',2.85),('8348','2013-03-16','10:00:00',2.41),('8348','2013-03-16','10:05:00',1.54),('8348','2013-03-16','10:10:00',2.17),('8348','2013-03-16','10:18:00',1.96),('8348','2013-03-16','10:20:00',1.48),('8348','2013-03-16','10:25:00',1.95),('8348','2013-03-16','10:30:00',1.72),('8348','2013-03-16','10:35:00',1.79),('8348','2013-03-16','10:40:00',2.6),('8348','2013-03-16','10:45:00',3.25),('8348','2013-03-16','10:50:00',3.25),('8348','2013-03-16','10:55:00',3.22),('8348','2013-03-16','11:00:00',3.31),('8348','2013-03-16','11:05:00',3.32),('8348','2013-03-16','11:10:00',3.35),('8348','2013-03-16','11:18:00',3.37),('8348','2013-03-16','11:20:00',3.41),('8348','2013-03-16','11:25:00',3.41),('8348','2013-03-16','11:30:00',3.44),('8348','2013-03-16','11:35:00',3.44),('8348','2013-03-16','11:40:00',3.48),('8348','2013-03-16','11:45:00',3.49),('8348','2013-03-16','11:50:00',3.51),('8348','2013-03-16','11:55:00',3.51),('8348','2013-03-16','12:00:00',3.52),('8348','2013-03-16','12:05:00',3.52),('8348','2013-03-16','12:10:00',3.51),('8348','2013-03-16','12:15:00',3.52),('8348','2013-03-16','12:20:00',3.52),('8348','2013-03-16','12:25:00',3.52),('8348','2013-03-16','12:30:00',3.53),('8348','2013-03-16','12:35:00',3.53),('8348','2013-03-16','12:40:00',3.52),('8348','2013-03-16','12:45:00',3.53),('8348','2013-03-16','12:50:00',3.52),('8348','2013-03-16','12:55:00',3.49),('8348','2013-03-16','13:00:00',3.46),('8348','2013-03-16','13:05:00',3.44),('8348','2013-03-16','13:10:00',3.43),('8348','2013-03-16','13:15:00',3.42),('8348','2013-03-16','13:20:00',3.11),('8348','2013-03-16','13:30:00',2.25),('8348','2013-03-16','13:35:00',3.41),('8348','2013-03-16','13:40:00',3.44),('8348','2013-03-16','13:45:00',3.45),('8348','2013-03-16','13:50:00',3.07),('8348','2013-03-16','13:55:00',2.99),('8348','2013-03-16','14:00:00',3.5),('8348','2013-03-16','14:05:00',3.37),('8348','2013-03-16','14:15:00',3.18),('8348','2013-03-16','14:20:00',1.52),('8348','2013-03-16','14:25:00',1.82),('8348','2013-03-16','14:30:00',3.36),('8348','2013-03-16','14:35:00',2.8),('8348','2013-03-16','14:40:00',1.12),('8348','2013-03-16','15:40:00',1.01),('8348','2013-03-16','16:00:00',1.85),('8348','2013-03-16','16:05:00',1.92),('8348','2013-03-16','16:10:00',1.92),('8348','2013-03-16','16:15:00',1.56),('8348','2013-03-16','16:55:00',1.17),('8348','2013-03-16','17:00:00',1.06),('8348','2013-03-16','17:05:00',1.05),('8348','2013-03-15','10:40:00',1.13),('8348','2013-03-15','10:45:00',1.3),('8348','2013-03-15','10:50:00',1.33),('8348','2013-03-15','10:55:00',1.42),('8348','2013-03-15','11:00:00',1.38),('8348','2013-03-15','11:05:00',1.21),('8348','2013-03-15','11:10:00',1.17),('8348','2013-03-15','11:20:00',1.14),('8348','2013-03-15','11:25:00',1.39),('8348','2013-03-15','11:30:00',1.56),('8348','2013-03-15','11:35:00',1.92),('8348','2013-03-15','11:40:00',2.27),('8348','2013-03-15','11:45:00',2.01),('8348','2013-03-15','11:50:00',1.86),('8348','2013-03-15','11:55:00',1.94),('8348','2013-03-15','12:00:00',1.74),('8348','2013-03-15','12:05:00',1.71),('8348','2013-03-15','12:10:00',1.86),('8348','2013-03-15','12:15:00',1.65),('8348','2013-03-15','12:20:00',1.61),('8348','2013-03-15','12:25:00',1.7),('8348','2013-03-15','12:30:00',1.74),('8348','2013-03-15','12:35:00',1.95),('8348','2013-03-15','12:40:00',1.67),('8348','2013-03-15','12:45:00',1.38),('8348','2013-03-15','12:50:00',1.3),('8348','2013-03-15','12:55:00',1.27),('8348','2013-03-15','13:00:00',1.2),('8348','2013-03-15','13:05:00',1.1),('8348','2013-03-15','13:10:00',1.17),('8348','2013-03-15','13:15:00',1.3),('8348','2013-03-15','13:20:00',1.4),('8348','2013-03-15','13:25:00',1.55),('8348','2013-03-15','13:30:00',1.47),('8348','2013-03-15','13:35:00',1.35),('8348','2013-03-15','13:40:00',1.39),('8348','2013-03-15','13:45:00',1.47),('8348','2013-03-15','13:50:00',1.2),('8348','2013-03-15','13:55:00',1.04),('8348','2013-03-15','14:55:00',1.08),('8348','2013-03-15','15:00:00',1.13),('8348','2013-03-15','15:05:00',1.07),('8348','2013-03-15','15:10:00',1.07),('8348','2013-03-15','15:15:00',1.16),('8348','2013-03-15','15:20:00',1.2),('8348','2013-03-15','15:25:00',1.29),('8348','2013-03-15','15:30:00',1.11),('8348','2013-03-14','13:05:00',1.01),('8348','2013-03-14','13:10:00',1.07),('8348','2013-03-14','13:15:00',1.04),('8348','2013-03-14','13:20:00',1.08),('8348','2013-03-14','13:25:00',1.09),('8348','2013-03-14','13:30:00',1.07),('8348','2013-03-14','13:35:00',1.1),('8348','2013-03-14','13:40:00',1.05),('8348','2013-03-14','13:45:00',1.34),('8348','2013-03-14','13:50:00',1.72),('8348','2013-03-14','13:55:00',1.89),('8348','2013-03-14','14:00:00',1.73),('8348','2013-03-14','14:05:00',1.83),('8348','2013-03-14','14:10:00',1.37),('8348','2013-03-14','14:15:00',1.18),('8348','2013-03-14','14:20:00',1.08),('8348','2013-03-14','14:25:00',1.07),('8348','2013-03-14','15:10:00',1.2),('8348','2013-03-14','15:15:00',1.18),('8348','2013-03-14','15:20:00',1.1),('8348','2013-03-14','15:25:00',1.15),('8348','2013-03-14','15:30:00',1.11),('8348','2013-03-13','08:50:00',1.01),('8348','2013-03-13','09:10:00',1.04),('8348','2013-03-13','10:10:00',1.13),('8348','2013-03-13','10:15:00',1.78),('8348','2013-03-13','10:20:00',1.4),('8348','2013-03-13','10:25:00',1.86),('8348','2013-03-13','10:30:00',3.07),('8348','2013-03-13','10:35:00',2.6),('8348','2013-03-13','10:40:00',2.44),('8348','2013-03-13','10:45:00',1.4),('8348','2013-03-13','10:50:00',1.12),('8348','2013-03-13','11:00:00',1.08),('8348','2013-03-13','11:10:00',1.13),('8348','2013-03-13','11:30:00',1.06),('8348','2013-03-13','11:35:00',1.11),('8348','2013-03-13','11:40:00',1.12),('8348','2013-03-13','11:45:00',1.27),('8348','2013-03-13','11:50:00',1.14),('8348','2013-03-13','12:45:00',1.03),('8348','2013-03-13','12:50:00',1.2),('8348','2013-03-13','12:55:00',1.08),('8348','2013-03-13','13:00:00',1.05),('8348','2013-03-13','13:05:00',1.03),('8348','2014-03-25','07:10:00',1.1),('8348','2014-03-25','07:15:00',1.36),('8348','2014-03-25','07:20:00',1.59),('8348','2014-03-25','07:25:00',1.8),('8348','2014-03-25','07:30:00',1.94),('8348','2014-03-25','07:35:00',1.67),('8348','2014-03-25','07:40:00',1.63),('8348','2014-03-25','07:45:00',1.82),('8348','2014-03-25','07:50:00',1.97),('8348','2014-03-25','07:55:00',2.03),('8348','2014-03-25','08:00:00',1.99),('8348','2014-03-25','08:05:00',2.07),('8348','2014-03-25','08:10:00',2.21),('8348','2014-03-25','08:15:00',2.3),('8348','2014-03-25','08:20:00',2.16),('8348','2014-03-25','08:25:00',2.01),('8348','2014-03-25','08:30:00',1.87),('8348','2014-03-25','08:35:00',1.92),('8348','2014-03-25','08:40:00',2.26),('8348','2014-03-25','08:45:00',3.03),('8348','2014-03-25','08:50:00',3.1),('8348','2014-03-25','08:55:00',3.24),('8348','2014-03-25','09:00:00',2.97),('8348','2014-03-25','09:05:00',2.94),('8348','2014-03-25','09:10:00',2.97),('8348','2014-03-25','09:15:00',3.83),('8348','2014-03-25','09:20:00',4.11),('8348','2014-03-25','09:25:00',3.68),('8348','2014-03-25','09:30:00',3.36),('8348','2014-03-25','09:35:00',3.14),('8348','2014-03-25','09:40:00',3.17),('8348','2014-03-25','09:45:00',3.01),('8348','2014-03-25','09:50:00',3.13),('8348','2014-03-25','09:55:00',3.45),('8348','2014-03-25','10:00:00',3.94),('8348','2014-03-25','10:05:00',4.18),('8348','2014-03-25','10:10:00',4.41),('8348','2014-03-25','10:15:00',4.44),('8348','2014-03-25','10:20:00',4.43),('8348','2014-03-25','10:25:00',4.63),('8348','2014-03-25','10:30:00',5.01),('8348','2014-03-25','10:35:00',4.23),('8348','2014-03-25','10:40:00',3.58),('8348','2014-03-25','10:45:00',3.35),('8348','2014-03-25','10:50:00',3.25),('8348','2014-03-25','10:55:00',3.28),('8348','2014-03-25','11:00:00',3.58),('8348','2014-03-25','11:05:00',4.02),('8348','2014-03-25','11:10:00',4.5),('8348','2014-03-25','11:15:00',5.07),('8348','2014-03-25','11:20:00',4.41),('8348','2014-03-25','11:25:00',5.01),('8348','2014-03-25','11:30:00',5.07),('8348','2014-03-25','11:35:00',4.11),('8348','2014-03-25','11:40:00',4.66),('8348','2014-03-25','11:45:00',3.54),('8348','2014-03-25','11:50:00',4.41),('8348','2014-03-25','11:55:00',3.22),('8348','2014-03-25','12:00:00',2.23),('8348','2014-03-25','12:05:00',1.43),('8348','2014-03-25','12:10:00',1.36),('8348','2014-03-25','12:15:00',1.57),('8348','2014-03-25','12:20:00',2.03),('8348','2014-03-25','12:25:00',2.32),('8348','2014-03-25','12:30:00',1.88),('8348','2014-03-25','12:35:00',1.5),('8348','2014-03-25','12:40:00',1.54),('8348','2014-03-25','12:45:00',1.52),('8348','2014-03-25','12:50:00',1.04),('8348','2014-03-25','13:30:00',1.16),('8348','2014-03-25','13:35:00',1.52),('8348','2014-03-25','13:40:00',1.52),('8348','2014-03-25','13:45:00',1.33),('8348','2014-03-25','13:50:00',1.34),('8348','2014-03-25','13:55:00',1.34),('8348','2014-03-25','14:00:00',1.26),('8348','2014-03-25','14:05:00',1.32),('8348','2014-03-25','14:10:00',1.45),('8348','2014-03-25','14:15:00',1.58),('8348','2014-03-25','14:20:00',1.21),('8348','2014-03-25','14:35:00',1.16),('8348','2014-03-25','14:40:00',1.17),('8348','2014-03-25','14:45:00',1.23),('8348','2014-03-25','14:50:00',1.06),('8348','2014-03-25','15:15:00',1.14),('8348','2014-03-25','15:20:00',1.17),('8348','2013-03-12','08:20:00',1.23),('8348','2013-03-12','08:25:00',1.22),('8348','2013-03-12','08:30:00',1.28),('8348','2013-03-12','08:35:00',1.22),('8348','2013-03-12','08:40:00',1.24),('8348','2013-03-12','08:45:00',1.69),('8348','2013-03-12','08:50:00',1.01),('8348','2013-03-12','09:00:00',1.27),('8348','2013-03-12','09:05:00',1.85),('8348','2013-03-12','09:10:00',1.91),('8348','2013-03-12','09:15:00',1.97),('8348','2013-03-12','09:20:00',2.03),('8348','2013-03-12','09:25:00',2.09),('8348','2013-03-12','09:30:00',2.11),('8348','2013-03-12','09:35:00',2.25),('8348','2013-03-12','09:40:00',2.38),('8348','2013-03-12','09:45:00',1.98),('8348','2013-03-12','09:50:00',2.42),('8348','2013-03-12','09:55:00',2.55),('8348','2013-03-12','10:00:00',2.71),('8348','2013-03-12','10:05:00',2.41),('8348','2013-03-12','10:10:00',2.1),('8348','2013-03-12','10:15:00',2.62),('8348','2013-03-12','10:20:00',2.66),('8348','2013-03-12','10:25:00',3.15),('8348','2013-03-12','10:30:00',2.63),('8348','2013-03-12','10:35:00',2.01),('8348','2013-03-12','10:40:00',2.98),('8348','2013-03-12','10:45:00',1.64),('8348','2013-03-12','10:50:00',3.16),('8348','2013-03-12','10:55:00',3.15),('8348','2013-03-12','11:00:00',3.07),('8348','2013-03-12','11:05:00',3.35),('8348','2013-03-12','11:10:00',3.04),('8348','2013-03-12','11:15:00',2.9),('8348','2013-03-12','11:20:00',3.82),('8348','2013-03-12','11:25:00',1.37),('8348','2013-03-12','11:30:00',1.55),('8348','2013-03-12','11:35:00',1.81),('8348','2013-03-12','11:40:00',1.98),('8348','2013-03-12','11:45:00',2.21),('8348','2013-03-12','11:50:00',2.53),('8348','2013-03-12','11:55:00',3.31),('8348','2013-03-12','12:05:00',1.36),('8348','2013-03-12','12:10:00',3.95),('8348','2013-03-12','12:15:00',2.49),('8348','2013-03-12','12:20:00',2.25),('8348','2013-03-12','12:25:00',3.9),('8348','2013-03-12','12:30:00',4.63),('8348','2013-03-12','12:35:00',2.51),('8348','2013-03-12','12:40:00',3.21),('8348','2013-03-12','12:45:00',1.05),('8348','2013-03-12','12:50:00',1.63),('8348','2013-03-12','12:55:00',2.35),('8348','2013-03-12','13:00:00',3.92),('8348','2013-03-12','13:05:00',1.91),('8348','2013-03-12','13:10:00',2.35),('8348','2013-03-12','13:15:00',2.17),('8348','2013-03-12','13:20:00',2.57),('8348','2013-03-12','13:25:00',1.8),('8348','2013-03-12','13:30:00',1.46),('8348','2013-03-12','13:35:00',2.17),('8348','2013-03-12','13:40:00',1.64),('8348','2013-03-12','13:45:00',1.23),('8348','2013-03-12','13:50:00',1.13),('8348','2013-03-12','13:55:00',2.11),('8348','2013-03-12','14:00:00',2.63),('8348','2013-03-12','14:05:00',2),('8348','2013-03-12','14:10:00',2.02),('8348','2013-03-12','15:15:00',1.02),('8348','2013-03-12','15:20:00',1.03),('8348','2013-03-11','08:20:00',1.04),('8348','2013-03-11','08:25:00',1.11),('8348','2013-03-11','08:30:00',1.18),('8348','2013-03-11','08:35:00',1.26),('8348','2013-03-11','08:40:00',1.34),('8348','2013-03-11','08:45:00',1.44),('8348','2013-03-11','08:50:00',1.54),('8348','2013-03-11','08:55:00',1.62),('8348','2013-03-11','09:00:00',1.72),('8348','2013-03-11','09:05:00',1.79),('8348','2013-03-11','09:10:00',1.86),('8348','2013-03-11','09:15:00',1.95),('8348','2013-03-11','09:20:00',1.72),('8348','2013-03-11','09:25:00',1.58),('8348','2013-03-11','09:35:00',2.33),('8348','2013-03-11','09:40:00',2.21),('8348','2013-03-11','09:45:00',2.02),('8348','2013-03-11','10:10:00',1.09),('8348','2013-03-11','10:15:00',1.11),('8348','2013-03-11','10:20:00',1.22),('8348','2013-03-11','10:25:00',1.34),('8348','2013-03-11','10:30:00',1.22),('8348','2013-03-11','10:35:00',1.4),('8348','2013-03-11','10:40:00',1.94),('8348','2013-03-11','10:45:00',2.04),('8348','2013-03-11','10:50:00',2.62),('8348','2013-03-11','10:55:00',1.65),('8348','2013-03-11','11:00:00',1.42),('8348','2013-03-11','11:05:00',1.16),('8348','2013-03-11','11:10:00',1.31),('8348','2013-03-11','11:15:00',1.4),('8348','2013-03-11','11:20:00',1.25),('8348','2013-03-11','11:25:00',1.13),('8348','2013-03-11','11:30:00',1.98),('8348','2013-03-11','11:35:00',1.76),('8348','2013-03-11','11:40:00',1.77),('8348','2013-03-11','11:45:00',2.36),('8348','2013-03-11','11:50:00',2.05),('8348','2013-03-11','11:55:00',1.83),('8348','2013-03-11','12:00:00',1.65),('8348','2013-03-11','12:05:00',1.61),('8348','2013-03-11','12:10:00',3),('8348','2013-03-11','12:35:00',1.44),('8348','2013-03-11','12:40:00',1.13),('8348','2013-03-11','12:45:00',1.21),('8348','2013-03-11','12:50:00',2.04),('8348','2013-03-11','12:55:00',3.14),('8348','2013-03-11','13:00:00',2.1),('8348','2013-03-11','13:05:00',1.72),('8348','2013-03-11','13:10:00',2.4),('8348','2013-03-11','13:15:00',3.33),('8348','2013-03-11','13:20:00',3.39),('8348','2013-03-11','13:25:00',3.43),('8348','2013-03-11','13:30:00',3.24),('8348','2013-03-11','13:35:00',3.6),('8348','2013-03-11','13:40:00',2.97),('8348','2013-03-11','13:45:00',2.27),('8348','2013-03-11','13:50:00',1.35),('8348','2013-03-11','13:55:00',1.96),('8348','2013-03-11','14:20:00',1.29),('8348','2013-03-11','14:25:00',1.55),('8348','2013-03-11','14:30:00',1.13),('8348','2013-03-11','14:40:00',1.47),('8348','2013-03-11','15:25:00',1.59),('8348','2013-03-11','15:30:00',2.47),('8348','2013-03-11','15:35:00',1.41),('8348','2013-03-11','15:40:00',1.5),('8348','2013-03-11','15:45:00',2.71),('8348','2013-03-11','15:50:00',2.27),('8348','2013-03-11','15:55:00',1.87),('8348','2013-03-11','16:00:00',1.84),('8348','2013-03-11','16:05:00',1.49),('8348','2013-03-11','16:10:00',1.75),('8348','2013-03-11','16:15:00',1.14),('8348','2013-03-11','16:20:00',1.29),('8348','2013-03-11','16:25:00',1.43),('8348','2013-03-11','16:30:00',1.43),('8348','2013-03-11','16:35:00',1.22),('8348','2013-03-11','16:40:00',1.07),('8348','2013-03-11','16:45:00',1.44),('8348','2013-03-10','08:20:00',1.07),('8348','2013-03-10','08:25:00',1.12),('8348','2013-03-10','08:30:00',1.2),('8348','2013-03-10','08:35:00',1.25),('8348','2013-03-10','08:40:00',1.32),('8348','2013-03-10','08:45:00',1.43),('8348','2013-03-10','08:50:00',1.51),('8348','2013-03-10','08:55:00',1.59),('8348','2013-03-10','09:00:00',1.68),('8348','2013-03-10','09:05:00',1.78),('8348','2013-03-10','09:10:00',1.85),('8348','2013-03-10','09:15:00',1.91),('8348','2013-03-10','09:20:00',1.97),('8348','2013-03-10','09:25:00',2.04),('8348','2013-03-10','09:30:00',2.13),('8348','2013-03-10','09:35:00',2.21),('8348','2013-03-10','09:40:00',2.14),('8348','2013-03-10','09:45:00',2.03),('8348','2013-03-10','09:50:00',1.85),('8348','2013-03-10','09:55:00',1.99),('8348','2013-03-10','10:00:00',1.76),('8348','2013-03-10','10:05:00',2.12),('8348','2013-03-10','10:10:00',2.7),('8348','2013-03-10','10:15:00',2.33),('8348','2013-03-10','10:20:00',1.96),('8348','2013-03-10','10:25:00',2.88),('8348','2013-03-10','10:30:00',2.38),('8348','2013-03-10','10:35:00',2.48),('8348','2013-03-10','10:40:00',2.76),('8348','2013-03-10','10:45:00',2.99),('8348','2013-03-10','10:50:00',2.36),('8348','2013-03-10','10:55:00',2),('8348','2013-03-10','11:00:00',2.17),('8348','2013-03-10','11:05:00',1.49),('8348','2013-03-10','11:10:00',2.12),('8348','2013-03-10','11:15:00',2.1),('8348','2013-03-10','11:20:00',1.05),('8348','2013-03-10','11:25:00',2.6),('8348','2013-03-10','11:30:00',1.84),('8348','2013-03-10','11:35:00',1.44),('8348','2013-03-10','11:40:00',1.18),('8348','2013-03-10','11:45:00',1.27),('8348','2013-03-10','11:50:00',2.16),('8348','2013-03-10','11:55:00',3.53),('8348','2013-03-10','12:00:00',3.31),('8348','2013-03-10','12:05:00',3.35),('8348','2013-03-10','12:10:00',3.45),('8348','2013-03-10','12:15:00',1.98),('8348','2013-03-10','12:20:00',2.6),('8348','2013-03-10','12:25:00',2.61),('8348','2013-03-10','12:30:00',2.68),('8348','2013-03-10','12:35:00',2.24),('8348','2013-03-10','12:40:00',2.76),('8348','2013-03-10','12:45:00',3.74),('8348','2013-03-10','12:50:00',3.48),('8348','2013-03-10','12:55:00',3.51),('8348','2013-03-10','13:00:00',3.4),('8348','2013-03-10','13:05:00',3.32),('8348','2013-03-10','13:10:00',3.18),('8348','2013-03-10','13:15:00',3.39),('8348','2013-03-10','13:20:00',3.51),('8348','2013-03-10','13:25:00',3.19),('8348','2013-03-10','13:30:00',3.07),('8348','2013-03-10','13:35:00',3.03),('8348','2013-03-10','13:40:00',2.01),('8348','2013-03-10','13:45:00',1.93),('8348','2013-03-10','13:50:00',1.7),('8348','2013-03-10','13:55:00',1.61),('8348','2013-03-10','14:00:00',1.37),('8348','2013-03-10','14:05:00',1.7),('8348','2013-03-10','14:10:00',2.07),('8348','2013-03-10','14:15:00',2.52),('8348','2013-03-10','14:20:00',2.5),('8348','2013-03-10','14:25:00',1.66),('8348','2013-03-10','14:30:00',2.02),('8348','2013-03-10','14:35:00',2.75),('8348','2013-03-10','14:40:00',2.02),('8348','2013-03-10','14:45:00',1.53),('8348','2013-03-10','14:50:00',1.5),('8348','2013-03-10','14:55:00',1.35),('8348','2013-03-10','15:00:00',1.04),('8348','2013-03-10','15:05:00',1.23),('8348','2013-03-10','15:10:00',1.19),('8348','2013-03-09','08:25:00',1.07),('8348','2013-03-09','08:30:00',1.15),('8348','2013-03-09','08:35:00',1.21),('8348','2013-03-09','08:40:00',1.31),('8348','2013-03-09','08:50:00',1.06),('8348','2013-03-09','08:55:00',1.48),('8348','2013-03-09','09:00:00',1.17),('8348','2013-03-09','09:05:00',1.18),('8348','2013-03-09','09:30:00',1.64),('8348','2013-03-09','09:35:00',1.71),('8348','2013-03-09','09:40:00',2.28),('8348','2013-03-09','09:45:00',2.87),('8348','2013-03-09','09:50:00',1.59),('8348','2013-03-09','09:55:00',2.35),('8348','2013-03-09','10:05:00',1.18),('8348','2013-03-09','10:10:00',1.17),('8348','2013-03-09','10:15:00',1.28),('8348','2013-03-09','10:20:00',1.23),('8348','2013-03-09','10:35:00',1.89),('8348','2013-03-09','10:40:00',2.09),('8348','2013-03-09','10:45:00',3.32),('8348','2013-03-09','10:50:00',3.3),('8348','2013-03-09','10:55:00',2.55),('8348','2013-03-09','11:00:00',3.33),('8348','2013-03-09','11:05:00',3.23),('8348','2013-03-09','11:10:00',2.88),('8348','2013-03-09','11:15:00',3.36),('8348','2013-03-09','11:20:00',3.44),('8348','2013-03-09','11:25:00',3.32),('8348','2013-03-09','11:30:00',3.34),('8348','2013-03-09','11:35:00',3.3),('8348','2013-03-09','11:40:00',3.33),('8348','2013-03-09','11:45:00',3.36),('8348','2013-03-09','11:50:00',3.31),('8348','2013-03-09','11:55:00',3.33),('8348','2013-03-09','12:00:00',3.09),('8348','2013-03-09','12:05:00',1.59),('8348','2013-03-09','12:10:00',1.71),('8348','2013-03-09','12:15:00',1.3),('8348','2013-03-09','12:20:00',1.33),('8348','2013-03-09','12:25:00',1.67),('8348','2013-03-09','12:30:00',1.33),('8348','2013-03-09','12:35:00',1.6),('8348','2013-03-09','12:40:00',1.47),('8348','2013-03-09','12:45:00',1.89),('8348','2013-03-09','12:50:00',1.68),('8348','2013-03-09','12:55:00',3),('8348','2013-03-09','13:00:00',3.44),('8348','2013-03-09','13:05:00',3.37),('8348','2013-03-09','13:10:00',3.35),('8348','2013-03-09','13:15:00',3.55),('8348','2013-03-09','13:20:00',2.94),('8348','2013-03-09','13:25:00',3.07),('8348','2013-03-09','13:30:00',3.51),('8348','2013-03-09','13:35:00',3.53),('8348','2013-03-09','13:40:00',3.4),('8348','2013-03-09','13:45:00',3.3),('8348','2013-03-09','13:50:00',3.3),('8348','2013-03-09','13:55:00',1.58),('8348','2013-03-09','14:05:00',1),('8348','2013-03-09','14:10:00',3.28),('8348','2013-03-09','14:15:00',2.39),('8348','2013-03-09','14:20:00',3.03),('8348','2013-03-09','14:25:00',2.95),('8348','2013-03-09','14:30:00',2.87),('8348','2013-03-09','14:35:00',2.8),('8348','2013-03-09','14:40:00',2.77),('8348','2013-03-09','14:45:00',2.73),('8348','2013-03-09','14:50:00',2.68),('8348','2013-03-09','14:55:00',2.64),('8348','2013-03-09','15:00:00',2.59),('8348','2013-03-09','15:05:00',2.53),('8348','2013-03-09','15:10:00',2.47),('8348','2013-03-09','15:15:00',2.42),('8348','2013-03-09','15:20:00',2.35),('8348','2013-03-09','15:25:00',2.28),('8348','2013-03-09','15:30:00',2.2),('8348','2013-03-09','15:35:00',2.13),('8348','2013-03-09','15:40:00',2.1),('8348','2013-03-09','15:45:00',2.05),('8348','2013-03-09','15:50:00',1.98),('8348','2013-03-09','15:55:00',1.81),('8348','2013-03-09','16:00:00',1.66),('8348','2013-03-09','16:05:00',1.69),('8348','2013-03-09','16:10:00',1.34),('8348','2013-03-09','16:15:00',1.55),('8348','2013-03-09','16:20:00',1.21),('8348','2013-03-09','16:25:00',1.5),('8348','2013-03-09','16:30:00',1.28),('8348','2013-03-09','16:35:00',1.11),('8348','2013-03-09','16:40:00',1.03),('8348','2013-03-08','08:30:00',1.33),('8348','2013-03-08','08:35:00',1.5),('8348','2013-03-08','09:30:00',1.39),('8348','2013-03-08','09:35:00',1.85),('8348','2013-03-08','09:40:00',1.1),('8348','2013-03-08','09:45:00',1.18),('8348','2013-03-08','09:50:00',1.68),('8348','2013-03-08','09:55:00',1.57),('8348','2013-03-08','10:05:00',1.16),('8348','2013-03-08','10:10:00',1.4),('8348','2013-03-08','10:15:00',1.83),('8348','2013-03-08','10:20:00',1.43),('8348','2013-03-08','10:25:00',1.27),('8348','2013-03-08','10:30:00',1.62),('8348','2013-03-08','10:35:00',1.89),('8348','2013-03-08','10:40:00',1.27),('8348','2013-03-08','10:50:00',1.17),('8348','2013-03-08','10:55:00',1.12),('8348','2013-03-08','11:00:00',1.1),('8348','2013-03-08','11:35:00',1.31),('8348','2013-03-08','11:40:00',1.72),('8348','2013-03-08','11:45:00',1.42),('8348','2013-03-08','11:50:00',1.27),('8348','2013-03-08','11:55:00',1.44),('8348','2013-03-08','12:00:00',2.07),('8348','2013-03-08','12:05:00',1.37),('8348','2013-03-08','12:10:00',1.09),('8348','2013-03-08','12:20:00',1.23),('8348','2013-03-08','12:25:00',1.04),('8348','2013-03-08','12:35:00',1.52),('8348','2013-03-08','12:40:00',1.77),('8348','2013-03-08','12:45:00',1.88),('8348','2013-03-08','12:50:00',2.16),('8348','2013-03-08','12:55:00',1.85),('8348','2013-03-08','13:00:00',1.89),('8348','2013-03-08','13:05:00',1.99),('8348','2013-03-08','13:10:00',1.34),('8348','2013-03-08','13:15:00',1.07),('8348','2013-03-08','13:20:00',1),('8348','2013-03-08','13:25:00',1.37),('8348','2013-03-08','13:30:00',1.87),('8348','2013-03-08','13:35:00',1.28),('8348','2013-03-08','13:40:00',1.16),('8348','2013-03-08','17:10:00',1.2),('8348','2013-03-07','10:55:00',1.13),('8348','2013-03-07','11:00:00',1.03),('8348','2013-03-07','11:05:00',1.41),('8348','2013-03-07','11:30:00',1.43),('8348','2013-03-07','11:35:00',2.1),('8348','2013-03-07','11:40:00',1.92),('8348','2013-03-07','11:45:00',2.14),('8348','2013-03-07','11:50:00',2.19),('8348','2013-03-07','11:55:00',1.51),('8348','2013-03-07','12:00:00',1.2),('8348','2013-03-07','12:40:00',1.2),('8348','2013-03-07','12:45:00',1.74),('8348','2013-03-07','12:50:00',1.64),('8348','2013-03-07','12:55:00',1.43),('8348','2013-03-07','13:00:00',1.57),('8348','2013-03-07','13:05:00',1.72),('8348','2013-03-07','13:10:00',1.52),('8348','2013-03-07','13:15:00',1.64),('8348','2013-03-07','13:20:00',1.98),('8348','2013-03-07','13:25:00',1.74),('8348','2013-03-07','13:30:00',1.45),('8348','2013-03-07','13:35:00',1.35),('8348','2013-03-05','08:25:00',1),('8348','2013-03-05','08:30:00',1.38),('8348','2013-03-05','08:35:00',1.3),('8348','2013-03-05','08:40:00',1.37),('8348','2013-03-05','08:45:00',1.19),('8348','2013-03-05','08:50:00',1.28),('8348','2013-03-05','08:55:00',1.27),('8348','2013-03-05','09:00:00',1.37),('8348','2013-03-05','09:05:00',1.39),('8348','2013-03-05','09:10:00',1.32),('8348','2013-03-05','09:15:00',1.29),('8348','2013-03-05','09:20:00',1.3),('8348','2013-03-05','09:25:00',1.29),('8348','2013-03-05','09:30:00',1.35),('8348','2013-03-05','09:35:00',1.47),('8348','2013-03-05','09:40:00',1.54),('8348','2013-03-05','09:45:00',1.56),('8348','2013-03-05','09:50:00',1.55),('8348','2013-03-05','09:55:00',1.47),('8348','2013-03-05','10:00:00',1.42),('8348','2013-03-05','10:05:00',1.54),('8348','2013-03-05','10:10:00',1.6),('8348','2013-03-05','10:15:00',1.63),('8348','2013-03-05','10:20:00',1.79),('8348','2013-03-05','10:25:00',1.66),('8348','2013-03-05','10:30:00',1.59),('8348','2013-03-05','10:35:00',1.84),('8348','2013-03-05','10:40:00',1.9),('8348','2013-03-05','10:45:00',2.01),('8348','2013-03-05','10:50:00',2.17),('8348','2013-03-05','10:55:00',2.2),('8348','2013-03-05','11:00:00',2.1),('8348','2013-03-05','11:05:00',2.22),('8348','2013-03-05','11:10:00',2.28),('8348','2013-03-05','11:15:00',2.24),('8348','2013-03-05','11:20:00',2.19),('8348','2013-03-05','11:25:00',2.14),('8348','2013-03-05','11:30:00',2.2),('8348','2013-03-05','11:35:00',2.41),('8348','2013-03-05','11:40:00',2.61),('8348','2013-03-05','11:45:00',2.52),('8348','2013-03-05','11:50:00',2.57),('8348','2013-03-05','11:55:00',2.6),('8348','2013-03-05','12:00:00',2.67),('8348','2013-03-05','12:05:00',2.77),('8348','2013-03-05','12:10:00',2.85),('8348','2013-03-05','12:15:00',2.32),('8348','2013-03-05','12:20:00',2.62),('8348','2013-03-05','12:25:00',2.67),('8348','2013-03-05','12:30:00',2.22),('8348','2013-03-05','12:35:00',2.3),('8348','2013-03-05','12:40:00',2.24),('8348','2013-03-05','12:45:00',2.3),('8348','2013-03-05','12:50:00',2.01),('8348','2013-03-05','12:55:00',1.83),('8348','2013-03-05','13:00:00',1.54),('8348','2013-03-05','13:05:00',1.48),('8348','2013-03-05','13:10:00',1.58),('8348','2013-03-05','13:15:00',1.69),('8348','2013-03-05','13:20:00',1.61),('8348','2013-03-05','13:25:00',1.46),('8348','2013-03-05','13:30:00',1.34),('8348','2013-03-05','13:35:00',1.26),('8348','2013-03-05','13:40:00',1.2),('8348','2013-03-05','13:45:00',1.09),('8348','2013-03-05','15:45:00',1.06),('8348','2013-03-05','15:50:00',1.04),('8348','2013-03-04','08:25:00',1),('8348','2013-03-04','08:30:00',1.06),('8348','2013-03-04','08:35:00',1.11),('8348','2013-03-04','08:40:00',1.16),('8348','2013-03-04','08:45:00',1.25),('8348','2013-03-04','08:50:00',1.34),('8348','2013-03-04','08:55:00',1.41),('8348','2013-03-04','09:00:00',1.47),('8348','2013-03-04','09:05:00',1.57),('8348','2013-03-04','09:10:00',1.66),('8348','2013-03-04','09:15:00',1.75),('8348','2013-03-04','09:20:00',1.82),('8348','2013-03-04','09:25:00',1.88),('8348','2013-03-04','09:30:00',1.94),('8348','2013-03-04','09:35:00',2.02),('8348','2013-03-04','09:40:00',2.08),('8348','2013-03-04','09:45:00',2.13),('8348','2013-03-04','09:50:00',2.19),('8348','2013-03-04','09:55:00',2.25),('8348','2013-03-04','10:00:00',2.3),('8348','2013-03-04','10:05:00',2.33),('8348','2013-03-04','10:10:00',2.4),('8348','2013-03-04','10:15:00',2.44),('8348','2013-03-04','10:20:00',2.47),('8348','2013-03-04','10:25:00',2.47),('8348','2013-03-04','10:30:00',2.54),('8348','2013-03-04','10:35:00',2.6),('8348','2013-03-04','10:40:00',2.64),('8348','2013-03-04','10:45:00',2.68),('8348','2013-03-04','10:50:00',2.7),('8348','2013-03-04','10:55:00',2.72),('8348','2013-03-04','11:00:00',2.78),('8348','2013-03-04','11:05:00',2.84),('8348','2013-03-04','11:10:00',2.86),('8348','2013-03-04','11:15:00',2.86),('8348','2013-03-04','11:20:00',2.88),('8348','2013-03-04','11:25:00',2.89),('8348','2013-03-04','11:30:00',2.96),('8348','2013-03-04','11:35:00',2.98),('8348','2013-03-04','11:40:00',2.99),('8348','2013-03-04','11:45:00',2.99),('8348','2013-03-04','11:50:00',2.95),('8348','2013-03-04','11:55:00',2.95),('8348','2013-03-04','12:00:00',2.97),('8348','2013-03-04','12:05:00',3),('8348','2013-03-04','12:10:00',3.06),('8348','2013-03-04','12:15:00',3.09),('8348','2013-03-04','12:20:00',3.1),('8348','2013-03-04','12:25:00',3.06),('8348','2013-03-04','12:30:00',3.07),('8348','2013-03-04','12:35:00',3.09),('8348','2013-03-04','12:40:00',3.09),('8348','2013-03-04','12:45:00',3.09),('8348','2013-03-04','12:50:00',3.07),('8348','2013-03-04','12:55:00',3.06),('8348','2013-03-04','13:00:00',3.04),('8348','2013-03-04','13:05:00',3),('8348','2013-03-04','13:10:00',3),('8348','2013-03-04','13:15:00',3.02),('8348','2013-03-04','13:20:00',3.01),('8348','2013-03-04','13:25:00',2.93),('8348','2013-03-04','13:30:00',1.97),('8348','2013-03-04','13:35:00',3.07),('8348','2013-03-04','13:40:00',2.81),('8348','2013-03-04','13:45:00',2.71),('8348','2013-03-04','13:50:00',2.81),('8348','2013-03-04','13:55:00',2.83),('8348','2013-03-04','14:00:00',2.84),('8348','2013-03-04','14:05:00',2.83),('8348','2013-03-04','14:10:00',2.72),('8348','2013-03-04','14:15:00',2.65),('8348','2013-03-04','14:20:00',2.63),('8348','2013-03-04','14:25:00',2.55),('8348','2013-03-04','14:30:00',2.5),('8348','2013-03-04','14:35:00',2.55),('8348','2013-03-04','14:40:00',2.47),('8348','2013-03-04','14:45:00',2.41),('8348','2013-03-04','14:50:00',2.34),('8348','2013-03-04','14:55:00',2.28),('8348','2013-03-04','15:00:00',2.25),('8348','2013-03-04','15:05:00',2.24),('8348','2013-03-04','15:10:00',2.15),('8348','2013-03-04','15:15:00',2.07),('8348','2013-03-04','15:20:00',2.04),('8348','2013-03-04','15:25:00',1.98),('8348','2013-03-04','15:30:00',1.94),('8348','2013-03-04','15:35:00',1.85),('8348','2013-03-04','15:40:00',1.82),('8348','2013-03-04','15:45:00',1.75),('8348','2013-03-04','15:50:00',1.68),('8348','2013-03-04','15:55:00',1.63),('8348','2013-03-04','16:00:00',1.56),('8348','2013-03-04','16:05:00',1.49),('8348','2013-03-04','16:10:00',1.41),('8348','2013-03-04','16:15:00',1.35),('8348','2013-03-04','16:20:00',1.28),('8348','2013-03-04','16:25:00',1.23),('8348','2013-03-04','16:30:00',1.15),('8348','2013-03-04','16:35:00',1.07),('8348','2013-03-03','08:30:00',1.03),('8348','2013-03-03','08:35:00',1.07),('8348','2013-03-03','08:40:00',1.17),('8348','2013-03-03','08:45:00',1.24),('8348','2013-03-03','08:50:00',1.32),('8348','2013-03-03','08:55:00',1.4),('8348','2013-03-03','09:00:00',1.48),('8348','2013-03-03','09:05:00',1.57),('8348','2013-03-03','09:10:00',1.66),('8348','2013-03-03','09:15:00',1.75),('8348','2013-03-03','09:20:00',1.83),('8348','2013-03-03','09:25:00',1.89),('8348','2013-03-03','09:30:00',1.96),('8348','2013-03-03','09:35:00',2.02),('8348','2013-03-03','09:40:00',2.08),('8348','2013-03-03','09:45:00',2.15),('8348','2013-03-03','09:50:00',2.22),('8348','2013-03-03','09:55:00',2.3),('8348','2013-03-03','10:00:00',2.37),('8348','2013-03-03','10:05:00',2.42),('8348','2013-03-03','10:10:00',2.48),('8348','2013-03-03','10:15:00',2.55),('8348','2013-03-03','10:20:00',2.6),('8348','2013-03-03','10:25:00',2.65),('8348','2013-03-03','10:30:00',2.69),('8348','2013-03-03','10:35:00',2.73),('8348','2013-03-03','10:40:00',2.77),('8348','2013-03-03','10:45:00',2.8),('8348','2013-03-03','10:50:00',2.83),('8348','2013-03-03','10:55:00',2.86),('8348','2013-03-03','11:00:00',2.89),('8348','2013-03-03','11:05:00',2.92),('8348','2013-03-03','11:10:00',2.94),('8348','2013-03-03','11:15:00',2.97),('8348','2013-03-03','11:20:00',2.99),('8348','2013-03-03','11:25:00',3.01),('8348','2013-03-03','11:30:00',3.03),('8348','2013-03-03','11:35:00',3.06),('8348','2013-03-03','11:40:00',3.07),('8348','2013-03-03','11:45:00',3.09),('8348','2013-03-03','11:50:00',3.1),('8348','2013-03-03','11:55:00',3.12),('8348','2013-03-03','12:00:00',3.12),('8348','2013-03-03','12:05:00',3.13),('8348','2013-03-03','12:10:00',3.13),('8348','2013-03-03','12:15:00',3.14),('8348','2013-03-03','12:20:00',3.14),('8348','2013-03-03','12:25:00',3.17),('8348','2013-03-03','12:30:00',3.17),('8348','2013-03-03','12:35:00',3.17),('8348','2013-03-03','12:40:00',3.18),('8348','2013-03-03','12:45:00',3.2),('8348','2013-03-03','12:50:00',3.19),('8348','2013-03-03','12:55:00',3.19),('8348','2013-03-03','13:00:00',3.17),('8348','2013-03-03','13:05:00',3.17),('8348','2013-03-03','13:10:00',3.16),('8348','2013-03-03','13:15:00',3.12),('8348','2013-03-03','13:20:00',3.12),('8348','2013-03-03','13:25:00',3.11),('8348','2013-03-03','13:30:00',3.09),('8348','2013-03-03','13:35:00',3.06),('8348','2013-03-03','13:40:00',3.04),('8348','2013-03-03','13:45:00',3),('8348','2013-03-03','13:50:00',2.99),('8348','2013-03-03','13:55:00',2.95),('8348','2013-03-03','14:00:00',2.93),('8348','2013-03-03','14:05:00',2.91),('8348','2013-03-03','14:10:00',2.89),('8348','2013-03-03','14:15:00',2.88),('8348','2013-03-03','14:20:00',2.83),('8348','2013-03-03','14:25:00',2.8),('8348','2013-03-03','14:30:00',2.74),('8348','2013-03-03','14:35:00',2.71),('8348','2013-03-03','14:40:00',2.67),('8348','2013-03-03','14:45:00',2.62),('8348','2013-03-03','14:50:00',2.58),('8348','2013-03-03','14:55:00',2.51),('8348','2013-03-03','15:00:00',2.47),('8348','2013-03-03','15:05:00',2.41),('8348','2013-03-03','15:10:00',2.35),('8348','2013-03-03','15:15:00',2.32),('8348','2013-03-03','15:20:00',2.27),('8348','2013-03-03','15:25:00',2.21),('8348','2013-03-03','15:30:00',2.16),('8348','2013-03-03','15:35:00',2.08),('8348','2013-03-03','15:40:00',2.01),('8348','2013-03-03','15:45:00',1.94),('8348','2013-03-03','15:50:00',1.87),('8348','2013-03-03','15:55:00',1.8),('8348','2013-03-03','16:00:00',1.71),('8348','2013-03-03','16:05:00',1.65),('8348','2013-03-03','16:10:00',1.57),('8348','2013-03-03','16:15:00',1.49),('8348','2013-03-03','16:20:00',1.41),('8348','2013-03-03','16:25:00',1.33),('8348','2013-03-03','16:30:00',1.25),('8348','2013-03-03','16:35:00',1.17),('8348','2013-03-03','16:40:00',1.09),('8348','2014-03-24','07:35:00',1.02),('8348','2014-03-24','07:45:00',2.02),('8348','2014-03-24','07:50:00',1.45),('8348','2014-03-24','07:55:00',1.47),('8348','2014-03-24','08:35:00',1.5),('8348','2014-03-24','08:40:00',1.59),('8348','2014-03-24','08:45:00',1.13),('8348','2014-03-24','08:50:00',1.35),('8348','2014-03-24','08:55:00',2.7),('8348','2014-03-24','09:00:00',2.97),('8348','2014-03-24','09:05:00',1.59),('8348','2014-03-24','09:10:00',1.12),('8348','2014-03-24','09:15:00',1.07),('8348','2014-03-24','09:20:00',2.59),('8348','2014-03-24','09:25:00',1.51),('8348','2014-03-24','09:30:00',2.28),('8348','2014-03-24','09:35:00',1.72),('8348','2014-03-24','09:40:00',2.77),('8348','2014-03-24','09:45:00',2.08),('8348','2014-03-24','09:50:00',1.92),('8348','2014-03-24','09:55:00',1.19),('8348','2014-03-24','10:00:00',3.77),('8348','2014-03-24','10:05:00',4.98),('8348','2014-03-24','10:10:00',5.56),('8348','2014-03-24','10:15:00',4.41),('8348','2014-03-24','10:20:00',1.65),('8348','2014-03-24','10:25:00',1.47),('8348','2014-03-24','10:30:00',1.38),('8348','2014-03-24','10:35:00',2.33),('8348','2014-03-24','10:40:00',1.94),('8348','2014-03-24','10:45:00',2.91),('8348','2014-03-24','10:50:00',7.79),('8348','2014-03-24','10:55:00',6.59),('8348','2014-03-24','11:00:00',3.21),('8348','2014-03-24','11:05:00',4.24),('8348','2014-03-24','11:10:00',4.88),('8348','2014-03-24','11:15:00',5.59),('8348','2014-03-24','11:20:00',5.33),('8348','2014-03-24','11:25:00',5.5),('8348','2014-03-24','11:30:00',7.05),('8348','2014-03-24','11:35:00',2.87),('8348','2014-03-24','11:40:00',1.44),('8348','2014-03-24','11:45:00',1.1),('8348','2014-03-24','11:50:00',1.13),('8348','2014-03-24','11:55:00',1.29),('8348','2014-03-24','12:00:00',1.14),('8348','2014-03-24','12:20:00',1.02),('8348','2014-03-24','12:25:00',1.23),('8348','2014-03-24','12:30:00',2.07),('8348','2014-03-24','12:35:00',3.52),('8348','2014-03-24','12:40:00',3.68),('8348','2014-03-24','12:45:00',3.18),('8348','2014-03-24','12:50:00',2.72),('8348','2014-03-24','12:55:00',2.62),('8348','2014-03-24','13:00:00',2.64),('8348','2014-03-24','13:05:00',2.62),('8348','2014-03-24','13:10:00',2.26),('8348','2014-03-24','13:15:00',1.98),('8348','2014-03-24','13:20:00',2.03),('8348','2014-03-24','13:25:00',2.32),('8348','2014-03-24','13:30:00',2.61),('8348','2014-03-24','13:35:00',2.17),('8348','2014-03-24','13:40:00',1.51),('8348','2014-03-24','13:45:00',2.13),('8348','2014-03-24','13:50:00',2.44),('8348','2014-03-24','13:55:00',2.42),('8348','2014-03-24','14:00:00',2.14),('8348','2014-03-24','14:05:00',1.97),('8348','2014-03-24','14:10:00',2.31),('8348','2014-03-24','14:15:00',2.95),('8348','2014-03-24','14:20:00',3.85),('8348','2014-03-24','14:25:00',3.67),('8348','2014-03-24','14:30:00',3.3),('8348','2014-03-24','14:35:00',4.03),('8348','2014-03-24','14:40:00',5.63),('8348','2014-03-24','14:45:00',6.18),('8348','2014-03-24','14:50:00',6.47),('8348','2014-03-24','14:55:00',5.62),('8348','2014-03-24','15:00:00',4.9),('8348','2014-03-24','15:05:00',4.4),('8348','2014-03-24','15:10:00',3.9),('8348','2014-03-24','15:15:00',2.62),('8348','2014-03-24','15:20:00',3.03),('8348','2014-03-24','15:25:00',2.63),('8348','2014-03-24','15:30:00',3.18),('8348','2014-03-24','15:35:00',2.71),('8348','2014-03-24','15:40:00',2.3),('8348','2014-03-24','15:45:00',2.36),('8348','2014-03-24','15:50:00',2.7),('8348','2014-03-24','15:55:00',2.88),('8348','2014-03-24','16:00:00',4.71),('8348','2014-03-24','16:05:00',2.36),('8348','2014-03-24','16:10:00',2.03),('8348','2014-03-24','16:15:00',1.43),('8348','2013-03-02','10:50:00',1.01),('8348','2013-03-02','10:55:00',1.05),('8348','2013-03-02','11:00:00',1.13),('8348','2013-03-02','11:05:00',1.2),('8348','2013-03-02','11:10:00',1.22),('8348','2013-03-02','11:15:00',1.42),('8348','2013-03-02','11:20:00',1.25),('8348','2013-03-02','11:25:00',1.11),('8348','2013-03-02','11:30:00',1.05),('8348','2013-03-02','11:35:00',1.07),('8348','2013-03-02','11:40:00',1.22),('8348','2013-03-02','11:45:00',1.1),('8348','2013-03-02','11:50:00',1.12),('8348','2013-03-02','11:55:00',1.04),('8348','2013-03-02','12:00:00',1.02),('8348','2013-03-02','12:05:00',1.16),('8348','2013-03-02','12:10:00',1.14),('8348','2013-03-02','12:15:00',1.17),('8348','2013-03-02','12:20:00',1.1),('8348','2013-03-02','12:25:00',1.15),('8348','2013-03-02','12:30:00',1.23),('8348','2013-03-02','12:35:00',1.34),('8348','2013-03-02','12:40:00',1.6),('8348','2013-03-02','12:45:00',1.45),('8348','2013-03-02','12:50:00',1.28),('8348','2013-03-02','12:55:00',1.4),('8348','2013-03-02','13:00:00',1.35),('8348','2013-03-02','13:05:00',1.15),('8348','2013-03-02','13:45:00',1.08),('8348','2013-03-02','13:50:00',1.04),('8348','2013-03-02','13:55:00',1.1),('8348','2013-03-02','14:00:00',1.21),('8348','2013-03-02','14:05:00',1.18),('8348','2013-03-02','14:10:00',1.01),('8348','2013-03-01','08:35:00',1.01),('8348','2013-03-01','08:40:00',1.08),('8348','2013-03-01','08:45:00',1.14),('8348','2013-03-01','08:50:00',1.2),('8348','2013-03-01','08:55:00',1.28),('8348','2013-03-01','09:00:00',1.35),('8348','2013-03-01','09:05:00',1.46),('8348','2013-03-01','09:10:00',1.47),('8348','2013-03-01','09:15:00',1.54),('8348','2013-03-01','09:20:00',1.58),('8348','2013-03-01','09:25:00',1.63),('8348','2013-03-01','09:30:00',1.79),('8348','2013-03-01','09:35:00',1.73),('8348','2013-03-01','09:40:00',1.83),('8348','2013-03-01','09:45:00',1.95),('8348','2013-03-01','09:50:00',1.98),('8348','2013-03-01','09:55:00',1.95),('8348','2013-03-01','10:00:00',2),('8348','2013-03-01','10:05:00',2),('8348','2013-03-01','10:10:00',2),('8348','2013-03-01','10:15:00',1.81),('8348','2013-03-01','10:20:00',1.73),('8348','2013-03-01','10:25:00',1.85),('8348','2013-03-01','10:30:00',2.07),('8348','2013-03-01','10:35:00',2.26),('8348','2013-03-01','10:40:00',2.03),('8348','2013-03-01','10:45:00',1.94),('8348','2013-03-01','10:50:00',1.86),('8348','2013-03-01','10:55:00',1.77),('8348','2013-03-01','11:00:00',1.58),('8348','2013-03-01','11:05:00',1.41),('8348','2013-03-01','11:10:00',1.37),('8348','2013-03-01','11:15:00',1.5),('8348','2013-03-01','11:20:00',1.58),('8348','2013-03-01','11:25:00',1.58),('8348','2013-03-01','11:30:00',1.59),('8348','2013-03-01','11:35:00',1.62),('8348','2013-03-01','11:40:00',1.55),('8348','2013-03-01','11:45:00',1.48),('8348','2013-03-01','11:50:00',1.46),('8348','2013-03-01','11:55:00',1.4),('8348','2013-03-01','12:00:00',1.34),('8348','2013-03-01','12:05:00',1.28),('8348','2013-03-01','12:10:00',1.19),('8348','2013-03-01','12:15:00',1.09),('8348','2013-03-01','12:20:00',1.03),('8348','2013-03-01','12:25:00',1.03),('8348','2013-03-01','12:30:00',1.07),('8348','2013-03-01','12:35:00',1.06),('8348','2013-03-01','12:40:00',1.02),('8348','2013-03-01','12:45:00',1.02),('8348','2013-03-01','12:50:00',1.05),('8348','2013-03-01','12:55:00',1.11),('8348','2013-03-01','13:00:00',1.17),('8348','2013-03-01','13:05:00',1.18),('8348','2013-03-01','13:10:00',1.22),('8348','2013-03-01','13:15:00',1.3),('8348','2013-03-01','13:20:00',1.41),('8348','2013-03-01','13:25:00',1.54),('8348','2013-03-01','13:30:00',1.49),('8348','2013-03-01','13:35:00',1.39),('8348','2013-03-01','13:40:00',1.32),('8348','2013-03-01','13:45:00',1.3),('8348','2013-03-01','13:50:00',1.29),('8348','2013-03-01','13:55:00',1.24),('8348','2013-03-01','14:00:00',1.21),('8348','2013-03-01','14:05:00',1.16),('8348','2013-03-01','14:10:00',1.09),('8348','2013-03-01','14:15:00',1.03),('8348','2013-03-01','14:30:00',1.03),('8348','2013-03-01','14:35:00',1.02),('8348','2013-02-28','08:35:00',1.01),('8348','2013-02-28','08:40:00',1.07),('8348','2013-02-28','08:45:00',1.13),('8348','2013-02-28','08:50:00',1.21),('8348','2013-02-28','08:55:00',1.29),('8348','2013-02-28','09:00:00',1.36),('8348','2013-02-28','09:05:00',1.41),('8348','2013-02-28','09:10:00',1.48),('8348','2013-02-28','09:15:00',1.57),('8348','2013-02-28','09:20:00',1.66),('8348','2013-02-28','09:25:00',1.71),('8348','2013-02-28','09:30:00',1.78),('8348','2013-02-28','09:35:00',1.85),('8348','2013-02-28','09:40:00',1.92),('8348','2013-02-28','09:45:00',1.99),('8348','2013-02-28','09:50:00',1.89),('8348','2013-02-28','09:55:00',2.06),('8348','2013-02-28','10:00:00',2.13),('8348','2013-02-28','10:05:00',2.19),('8348','2013-02-28','10:10:00',2.21),('8348','2013-02-28','10:15:00',2.26),('8348','2013-02-28','10:20:00',2.32),('8348','2013-02-28','10:25:00',2.35),('8348','2013-02-28','10:30:00',2.34),('8348','2013-02-28','10:35:00',2.41),('8348','2013-02-28','10:40:00',2.45),('8348','2013-02-28','10:45:00',2.49),('8348','2013-02-28','10:50:00',2.51),('8348','2013-02-28','10:55:00',2.52),('8348','2013-02-28','11:00:00',2.62),('8348','2013-02-28','11:05:00',2.67),('8348','2013-02-28','11:10:00',2.74),('8348','2013-02-28','11:15:00',2.77),('8348','2013-02-28','11:20:00',2.79),('8348','2013-02-28','11:25:00',2.86),('8348','2013-02-28','11:30:00',2.84),('8348','2013-02-28','11:35:00',2.86),('8348','2013-02-28','11:40:00',2.86),('8348','2013-02-28','11:45:00',2.85),('8348','2013-02-28','11:50:00',2.85),('8348','2013-02-28','11:55:00',2.87),('8348','2013-02-28','12:00:00',2.85),('8348','2013-02-28','12:05:00',2.8),('8348','2013-02-28','12:10:00',2.54),('8348','2013-02-28','12:15:00',2.93),('8348','2013-02-28','12:20:00',2.98),('8348','2013-02-28','12:25:00',2.9),('8348','2013-02-28','12:30:00',2.95),('8348','2013-02-28','12:35:00',3),('8348','2013-02-28','12:40:00',3.02),('8348','2013-02-28','12:45:00',2.96),('8348','2013-02-28','12:50:00',2.89),('8348','2013-02-28','12:55:00',2.94),('8348','2013-02-28','13:00:00',2.81),('8348','2013-02-28','13:05:00',2.96),('8348','2013-02-28','13:10:00',2.95),('8348','2013-02-28','13:15:00',2.92),('8348','2013-02-28','13:20:00',2.35),('8348','2013-02-28','13:25:00',1.17),('8348','2013-02-28','13:30:00',2.9),('8348','2013-02-28','13:35:00',2.92),('8348','2013-02-28','13:40:00',2.89),('8348','2013-02-28','13:45:00',2.83),('8348','2013-02-28','13:50:00',2.91),('8348','2013-02-28','13:55:00',2.99),('8348','2013-02-28','14:00:00',3.04),('8348','2013-02-28','14:05:00',2.96),('8348','2013-02-28','14:10:00',2.83),('8348','2013-02-28','14:15:00',2.7),('8348','2013-02-28','14:20:00',2.63),('8348','2013-02-28','14:25:00',2.55),('8348','2013-02-28','14:30:00',2.47),('8348','2013-02-28','14:35:00',2.34),('8348','2013-02-28','14:40:00',2.41),('8348','2013-02-28','14:45:00',2.38),('8348','2013-02-28','14:50:00',2.36),('8348','2013-02-28','14:55:00',2.29),('8348','2013-02-28','15:00:00',2.23),('8348','2013-02-28','15:05:00',2.13),('8348','2013-02-28','15:10:00',2.09),('8348','2013-02-28','15:15:00',2.03),('8348','2013-02-28','15:20:00',1.98),('8348','2013-02-28','15:25:00',1.84),('8348','2013-02-28','15:30:00',1.72),('8348','2013-02-28','15:35:00',1.69),('8348','2013-02-28','15:40:00',1.65),('8348','2013-02-28','15:45:00',1.63),('8348','2013-02-28','15:50:00',1.56),('8348','2013-02-28','15:55:00',1.49),('8348','2013-02-28','16:00:00',1.43),('8348','2013-02-28','16:05:00',1.33),('8348','2013-02-28','16:10:00',1.26),('8348','2013-02-28','16:15:00',1.19),('8348','2013-02-28','16:20:00',1.13),('8348','2013-02-28','16:25:00',1.05),('8348','2013-02-27','08:40:00',1.02),('8348','2013-02-27','08:45:00',1.08),('8348','2013-02-27','08:50:00',1.14),('8348','2013-02-27','08:55:00',1.21),('8348','2013-02-27','09:00:00',1.29),('8348','2013-02-27','09:05:00',1.36),('8348','2013-02-27','09:10:00',1.44),('8348','2013-02-27','09:15:00',1.52),('8348','2013-02-27','09:20:00',1.62),('8348','2013-02-27','09:25:00',1.68),('8348','2013-02-27','09:30:00',1.74),('8348','2013-02-27','09:35:00',1.8),('8348','2013-02-27','09:40:00',1.86),('8348','2013-02-27','09:45:00',1.92),('8348','2013-02-27','09:50:00',1.98),('8348','2013-02-27','09:55:00',2.04),('8348','2013-02-27','10:00:00',2.1),('8348','2013-02-27','10:05:00',2.15),('8348','2013-02-27','10:10:00',2.19),('8348','2013-02-27','10:15:00',2.27),('8348','2013-02-27','10:20:00',2.28),('8348','2013-02-27','10:25:00',2.31),('8348','2013-02-27','10:30:00',2.36),('8348','2013-02-27','10:35:00',2.4),('8348','2013-02-27','10:40:00',2.36),('8348','2013-02-27','10:45:00',2.52),('8348','2013-02-27','10:50:00',2.58),('8348','2013-02-27','10:55:00',2.57),('8348','2013-02-27','11:00:00',2.63),('8348','2013-02-27','11:05:00',2.67),('8348','2013-02-27','11:10:00',2.73),('8348','2013-02-27','11:15:00',2.76),('8348','2013-02-27','11:20:00',2.8),('8348','2013-02-27','11:25:00',2.06),('8348','2013-02-27','11:30:00',1.08),('8348','2013-02-27','11:35:00',1.04),('8348','2013-02-27','11:45:00',1.12),('8348','2013-02-27','11:50:00',2.99),('8348','2013-02-27','11:55:00',3.15),('8348','2013-02-27','12:00:00',3.04),('8348','2013-02-27','12:05:00',3.06),('8348','2013-02-27','12:10:00',3.12),('8348','2013-02-27','12:15:00',3.25),('8348','2013-02-27','12:20:00',3.13),('8348','2013-02-27','12:25:00',3.05),('8348','2013-02-27','12:30:00',3),('8348','2013-02-27','12:35:00',3.07),('8348','2013-02-27','12:40:00',3.06),('8348','2013-02-27','12:45:00',3.02),('8348','2013-02-27','12:50:00',3.02),('8348','2013-02-27','12:55:00',3.04),('8348','2013-02-27','13:00:00',3.04),('8348','2013-02-27','13:05:00',3.09),('8348','2013-02-27','13:10:00',2.62),('8348','2013-02-27','13:15:00',2.82),('8348','2013-02-27','13:20:00',2.73),('8348','2013-02-27','13:25:00',3.05),('8348','2013-02-27','13:30:00',3.03),('8348','2013-02-27','13:35:00',2.99),('8348','2013-02-27','13:40:00',2.97),('8348','2013-02-27','13:45:00',2.83),('8348','2013-02-27','13:50:00',2.59),('8348','2013-02-27','13:55:00',2.67),('8348','2013-02-27','14:00:00',2.25),('8348','2013-02-27','14:05:00',2.42),('8348','2013-02-27','14:10:00',1.46),('8348','2013-02-27','14:15:00',1.86),('8348','2013-02-27','14:20:00',2.53),('8348','2013-02-27','14:25:00',2.07),('8348','2013-02-27','14:30:00',2.6),('8348','2013-02-27','14:35:00',2.62),('8348','2013-02-27','14:40:00',2.53),('8348','2013-02-27','14:45:00',2.31),('8348','2013-02-27','14:50:00',1.83),('8348','2013-02-27','14:55:00',1.94),('8348','2013-02-27','15:00:00',2.34),('8348','2013-02-27','15:05:00',2.33),('8348','2013-02-27','15:10:00',2.09),('8348','2013-02-27','15:15:00',1.8),('8348','2013-02-27','15:20:00',1.82),('8348','2013-02-27','15:25:00',1.99),('8348','2013-02-27','15:30:00',1.92),('8348','2013-02-27','15:35:00',1.85),('8348','2013-02-27','15:40:00',1.77),('8348','2013-02-27','15:45:00',1.73),('8348','2013-02-27','15:50:00',1.67),('8348','2013-02-27','15:55:00',1.62),('8348','2013-02-27','16:00:00',1.54),('8348','2013-02-27','16:05:00',1.47),('8348','2013-02-27','16:10:00',1.4),('8348','2013-02-27','16:15:00',1.32),('8348','2013-02-27','16:20:00',1.24),('8348','2013-02-27','16:25:00',1.17),('8348','2013-02-27','16:30:00',1.07),('8348','2013-02-26','09:30:00',1.1),('8348','2013-02-26','09:35:00',1.36),('8348','2013-02-26','09:40:00',1.52),('8348','2013-02-26','09:45:00',1.54),('8348','2013-02-26','09:50:00',1.55),('8348','2013-02-26','09:55:00',1.69),('8348','2013-02-26','10:00:00',1.62),('8348','2013-02-26','10:05:00',1.57),('8348','2013-02-26','10:10:00',1.78),('8348','2013-02-26','10:15:00',2.03),('8348','2013-02-26','10:20:00',2.45),('8348','2013-02-26','10:25:00',2.72),('8348','2013-02-26','10:30:00',2.66),('8348','2013-02-26','10:35:00',1.95),('8348','2013-02-26','10:40:00',2.25),('8348','2013-02-26','10:45:00',1.3),('8348','2013-02-26','10:50:00',1.51),('8348','2013-02-26','10:55:00',1.61),('8348','2013-02-26','11:00:00',1.97),('8348','2013-02-26','11:05:00',1.7),('8348','2013-02-26','11:10:00',1.7),('8348','2013-02-26','11:15:00',1.54),('8348','2013-02-26','11:20:00',1.53),('8348','2013-02-26','11:25:00',1.43),('8348','2013-02-26','11:30:00',1.4),('8348','2013-02-26','11:35:00',1.33),('8348','2013-02-26','11:40:00',1.38),('8348','2013-02-26','11:45:00',1.35),('8348','2013-02-26','11:50:00',1.48),('8348','2013-02-26','11:55:00',1.53),('8348','2013-02-26','12:00:00',1.49),('8348','2013-02-26','12:05:00',1.47),('8348','2013-02-26','12:10:00',1.51),('8348','2013-02-26','12:15:00',1.34),('8348','2013-02-26','12:20:00',1.38),('8348','2013-02-26','12:25:00',1.27),('8348','2013-02-26','12:30:00',1.27),('8348','2013-02-26','12:35:00',1.16),('8348','2013-02-26','12:40:00',1.07),('8348','2013-02-25','09:25:00',1.22),('8348','2013-02-25','09:30:00',1.36),('8348','2013-02-25','09:35:00',1.35),('8348','2013-02-25','09:40:00',1.03),('8348','2013-02-25','10:45:00',1.48),('8348','2013-02-25','10:50:00',2.62),('8348','2013-02-25','10:55:00',3.69),('8348','2013-02-25','11:00:00',3.42),('8348','2013-02-25','11:05:00',1.79),('8348','2013-02-25','11:10:00',1.64),('8348','2013-02-25','11:15:00',1.47),('8348','2013-02-25','11:20:00',1.12),('8348','2013-02-25','11:25:00',1.05),('8348','2013-02-25','11:30:00',1.5),('8348','2013-02-25','11:35:00',1.25),('8348','2013-02-25','11:40:00',1.47),('8348','2013-02-25','11:45:00',1.58),('8348','2013-02-25','11:50:00',1.96),('8348','2013-02-25','11:55:00',3.92),('8348','2013-02-25','12:00:00',2.73),('8348','2013-02-25','12:05:00',2.13),('8348','2013-02-25','12:10:00',1.65),('8348','2013-02-25','12:15:00',1.74),('8348','2013-02-25','12:20:00',3.29),('8348','2013-02-25','12:25:00',3.63),('8348','2013-02-25','12:30:00',2.77),('8348','2013-02-25','12:35:00',2.1),('8348','2013-02-25','12:40:00',2.93),('8348','2013-02-25','12:45:00',3.33),('8348','2013-02-25','12:50:00',3.14),('8348','2013-02-25','12:55:00',3.14),('8348','2013-02-25','13:00:00',2.29),('8348','2013-02-25','13:05:00',2.21),('8348','2013-02-25','13:10:00',1.35),('8348','2013-02-25','13:15:00',2.23),('8348','2013-02-25','13:20:00',1.78),('8348','2013-02-25','13:25:00',1.31),('8348','2013-02-25','13:30:00',1.59),('8348','2013-02-25','13:35:00',1.61),('8348','2013-02-25','13:40:00',1.08),('8348','2013-02-24','10:50:00',1.25),('8348','2013-02-24','10:55:00',1.18),('8348','2013-02-24','12:40:00',1.08),('8348','2013-02-24','12:45:00',1.15),('8348','2013-02-24','13:00:00',1.06),('8348','2013-02-24','13:05:00',1.36),('8348','2013-02-24','13:10:00',1.33),('8348','2013-02-24','13:15:00',1.2),('8348','2013-02-24','13:20:00',1.39),('8348','2013-02-24','13:35:00',1.29),('8348','2013-02-24','13:40:00',1.04),('8348','2013-02-24','13:45:00',1.14),('8348','2013-02-24','13:50:00',1),('8348','2013-02-24','14:00:00',1.04),('8348','2013-02-24','14:05:00',1.75),('8348','2013-02-24','14:10:00',1.51),('8348','2013-02-24','14:15:00',1.06),('8348','2013-02-24','14:30:00',1.09),('8348','2013-02-24','14:35:00',1.12),('8348','2013-02-24','15:10:00',2.06),('8348','2013-02-24','15:15:00',1.05),('8348','2013-02-24','15:20:00',1.42),('8348','2013-02-24','15:25:00',1.48),('8348','2013-02-24','15:30:00',1.03),('8348','2013-02-24','15:35:00',1.49),('8348','2013-02-24','15:40:00',1.13),('8348','2013-02-24','15:45:00',1.45),('8348','2013-02-24','15:50:00',1.01),('8348','2013-02-24','15:55:00',1.51),('8348','2013-02-24','16:00:00',1.66),('8348','2013-02-24','16:05:00',1.06),('8348','2013-02-24','16:40:00',1.03),('8348','2013-02-23','08:15:00',1.11),('8348','2013-02-23','09:00:00',1.16),('8348','2013-02-23','09:05:00',1.12),('8348','2013-02-23','09:45:00',1.18),('8348','2013-02-23','09:50:00',1.24),('8348','2013-02-23','09:55:00',1.22),('8348','2013-02-23','14:05:00',1.5),('8348','2013-02-23','14:10:00',1.16),('8348','2013-02-22','14:35:00',1.34),('8348','2013-02-22','14:40:00',1.33),('8348','2013-02-22','14:55:00',1.21),('8348','2013-02-22','16:20:00',1.09),('8348','2013-02-22','16:25:00',1.25),('8348','2013-02-22','16:30:00',1.04),('8348','2013-02-21','11:50:00',1.06),('8348','2013-02-21','11:55:00',1.08),('8348','2013-02-21','12:00:00',1.05),('8348','2013-02-21','12:05:00',1.07),('8348','2013-02-21','12:10:00',1.1),('8348','2013-02-21','12:15:00',1.17),('8348','2013-02-21','12:20:00',1.24),('8348','2013-02-21','12:25:00',1.21),('8348','2013-02-21','12:30:00',1.14),('8348','2013-02-21','12:35:00',1.09),('8348','2013-02-21','12:40:00',1.06),('8348','2013-02-21','12:45:00',1.08),('8348','2013-02-21','12:50:00',1.08),('8348','2013-02-21','12:55:00',1.15),('8348','2013-02-21','13:00:00',1.15),('8348','2013-02-21','13:05:00',1.07),('8348','2013-02-21','13:10:00',1.03),('8348','2013-02-21','13:15:00',1.08),('8348','2013-02-21','13:20:00',1.13),('8348','2013-02-21','13:25:00',1.16),('8348','2013-02-21','13:30:00',1.16),('8348','2013-02-21','13:35:00',1.16),('8348','2013-02-21','13:40:00',1.11),('8348','2013-02-21','13:45:00',1.05),('8348','2013-02-21','13:50:00',1.07),('8348','2013-02-21','13:55:00',1.05),('8348','2013-02-21','14:00:00',1.07),('8348','2013-02-21','14:05:00',1.03),('8348','2013-02-21','16:20:00',1.3),('8348','2013-02-21','16:25:00',1.4),('8348','2013-02-21','16:30:00',1.29),('8348','2013-02-21','16:35:00',1.13),('8348','2014-03-23','08:05:00',1.18),('8348','2014-03-23','08:10:00',1.26),('8348','2014-03-23','08:15:00',1.25),('8348','2014-03-23','08:20:00',1.36),('8348','2014-03-23','08:25:00',1.53),('8348','2014-03-23','08:30:00',1.7),('8348','2014-03-23','08:35:00',1.84),('8348','2014-03-23','08:40:00',1.4),('8348','2014-03-23','08:45:00',1.48),('8348','2014-03-23','08:50:00',2),('8348','2014-03-23','08:55:00',2.49),('8348','2014-03-23','09:00:00',1.63),('8348','2014-03-23','09:05:00',2.68),('8348','2014-03-23','09:10:00',4.23),('8348','2014-03-23','09:15:00',4.14),('8348','2014-03-23','09:20:00',3.05),('8348','2014-03-23','09:25:00',1.87),('8348','2014-03-23','09:30:00',2.47),('8348','2014-03-23','09:35:00',2.55),('8348','2014-03-23','09:40:00',2.15),('8348','2014-03-23','09:45:00',1.72),('8348','2014-03-23','09:50:00',1.49),('8348','2014-03-23','09:55:00',1.39),('8348','2014-03-23','10:00:00',1.28),('8348','2014-03-23','10:05:00',1.23),('8348','2014-03-23','10:10:00',1.37),('8348','2014-03-23','10:15:00',1.05),('8348','2014-03-23','10:20:00',1.29),('8348','2014-03-23','10:25:00',2.08),('8348','2014-03-23','10:30:00',1.57),('8348','2014-03-23','10:35:00',1.2),('8348','2014-03-23','10:40:00',2.04),('8348','2014-03-23','10:45:00',1.83),('8348','2014-03-23','10:50:00',2.06),('8348','2014-03-23','10:55:00',2.91),('8348','2014-03-23','11:00:00',2.17),('8348','2014-03-23','11:05:00',1.8),('8348','2014-03-23','11:10:00',2.18),('8348','2014-03-23','11:15:00',1.37),('8348','2014-03-23','11:20:00',1.46),('8348','2014-03-23','11:25:00',1.9),('8348','2014-03-23','11:30:00',1.52),('8348','2014-03-23','11:35:00',2.84),('8348','2014-03-23','11:40:00',6.61),('8348','2014-03-23','11:45:00',1.78),('8348','2014-03-23','11:55:00',1.46),('8348','2014-03-23','12:00:00',1.63),('8348','2014-03-23','12:05:00',1.06),('8348','2014-03-23','12:25:00',1.02),('8348','2014-03-23','12:30:00',1.12),('8348','2014-03-23','12:35:00',1.21),('8348','2014-03-23','13:15:00',1.02),('8348','2014-03-23','13:40:00',1.86),('8348','2014-03-23','13:45:00',4.51),('8348','2014-03-23','13:50:00',2.87),('8348','2014-03-23','13:55:00',2.29),('8348','2014-03-23','14:00:00',1.82),('8348','2014-03-23','14:05:00',1.08),('8348','2014-03-23','14:15:00',1.06),('8348','2014-03-23','14:50:00',1.3),('8348','2014-03-23','14:55:00',1.61),('8348','2014-03-23','15:00:00',1.3),('8348','2014-03-23','15:05:00',1.82),('8348','2014-03-23','15:10:00',2.27),('8348','2014-03-23','15:15:00',3.43),('8348','2014-03-23','15:20:00',3.02),('8348','2014-03-23','15:25:00',3.41),('8348','2014-03-23','15:30:00',2.27),('8348','2014-03-23','15:35:00',1.6),('8348','2014-03-23','15:40:00',1.7),('8348','2013-02-20','08:45:00',1.04),('8348','2013-02-20','08:50:00',1.11),('8348','2013-02-20','08:55:00',1.17),('8348','2013-02-20','09:00:00',1.28),('8348','2013-02-20','09:10:00',1.03),('8348','2013-02-20','09:15:00',1.2),('8348','2013-02-20','09:20:00',1.44),('8348','2013-02-20','09:25:00',1.43),('8348','2013-02-20','09:30:00',1.47),('8348','2013-02-20','09:35:00',1.12),('8348','2013-02-20','09:40:00',1.05),('8348','2013-02-20','09:45:00',1.05),('8348','2013-02-20','09:50:00',1.31),('8348','2013-02-20','09:55:00',1.59),('8348','2013-02-20','10:00:00',1.14),('8348','2013-02-20','10:05:00',1.5),('8348','2013-02-20','10:10:00',1.74),('8348','2013-02-20','10:45:00',1.19),('8348','2013-02-20','10:50:00',3.2),('8348','2013-02-20','10:55:00',1.62),('8348','2013-02-20','11:05:00',1.46),('8348','2013-02-20','11:10:00',3.32),('8348','2013-02-20','11:15:00',3.02),('8348','2013-02-20','11:20:00',2.87),('8348','2013-02-20','11:25:00',1.54),('8348','2013-02-20','11:30:00',1.07),('8348','2013-02-20','11:35:00',2.45),('8348','2013-02-20','11:40:00',3.66),('8348','2013-02-20','11:45:00',3.17),('8348','2013-02-20','11:50:00',3.58),('8348','2013-02-20','11:55:00',2.66),('8348','2013-02-20','12:00:00',2.07),('8348','2013-02-20','12:10:00',1.79),('8348','2013-02-20','12:15:00',3.3),('8348','2013-02-20','12:20:00',1.55),('8348','2013-02-20','12:25:00',2.66),('8348','2013-02-20','12:30:00',3.83),('8348','2013-02-20','12:35:00',2.65),('8348','2013-02-20','12:50:00',1.04),('8348','2013-02-20','12:55:00',1.22),('8348','2013-02-20','13:00:00',2.88),('8348','2013-02-20','13:05:00',1.61),('8348','2013-02-20','13:10:00',2.86),('8348','2013-02-20','13:15:00',3.55),('8348','2013-02-20','13:20:00',2.63),('8348','2013-02-20','13:25:00',1.5),('8348','2013-02-20','13:30:00',1.73),('8348','2013-02-20','13:35:00',1.26),('8348','2013-02-20','13:40:00',1.37),('8348','2013-02-20','13:45:00',1.12),('8348','2013-02-20','13:50:00',1.05),('8348','2013-02-20','13:55:00',1.08),('8348','2013-02-20','14:00:00',1.02),('8348','2013-02-20','14:40:00',1.09),('8348','2013-02-20','14:45:00',1.11),('8348','2013-02-20','15:10:00',1.85),('8348','2013-02-20','15:15:00',2.41),('8348','2013-02-20','15:20:00',1.87),('8348','2013-02-20','15:25:00',2.3),('8348','2013-02-20','15:30:00',1.74),('8348','2013-02-20','15:35:00',1.16),('8348','2013-02-20','16:05:00',1.18),('8348','2013-02-20','16:10:00',1.62),('8348','2013-02-20','16:15:00',1.59),('8348','2013-02-20','16:20:00',1.46),('8348','2013-02-20','16:25:00',1.21),('8348','2013-02-20','16:30:00',1.01),('8348','2013-02-19','08:50:00',1.04),('8348','2013-02-19','08:55:00',1.1),('8348','2013-02-19','09:00:00',1.14),('8348','2013-02-19','09:05:00',1.23),('8348','2013-02-19','09:10:00',1.31),('8348','2013-02-19','09:15:00',1.37),('8348','2013-02-19','09:20:00',1.45),('8348','2013-02-19','09:25:00',1.54),('8348','2013-02-19','09:30:00',1.63),('8348','2013-02-19','09:35:00',1.7),('8348','2013-02-19','09:40:00',1.75),('8348','2013-02-19','09:45:00',1.82),('8348','2013-02-19','09:50:00',1.88),('8348','2013-02-19','09:55:00',1.94),('8348','2013-02-19','10:00:00',1.99),('8348','2013-02-19','10:05:00',2.03),('8348','2013-02-19','10:10:00',2.1),('8348','2013-02-19','10:15:00',2.16),('8348','2013-02-19','10:20:00',2.22),('8348','2013-02-19','10:25:00',2.23),('8348','2013-02-19','10:30:00',2.31),('8348','2013-02-19','10:35:00',2.35),('8348','2013-02-19','10:40:00',2.38),('8348','2013-02-19','10:45:00',2.42),('8348','2013-02-19','10:50:00',2.47),('8348','2013-02-19','10:55:00',2.51),('8348','2013-02-19','11:00:00',2.52),('8348','2013-02-19','11:05:00',2.56),('8348','2013-02-19','11:10:00',2.63),('8348','2013-02-19','11:15:00',2.64),('8348','2013-02-19','11:20:00',2.66),('8348','2013-02-19','11:25:00',2.68),('8348','2013-02-19','11:30:00',2.68),('8348','2013-02-19','11:35:00',2.72),('8348','2013-02-19','11:40:00',2.77),('8348','2013-02-19','11:45:00',2.76),('8348','2013-02-19','11:50:00',2.81),('8348','2013-02-19','11:55:00',2.82),('8348','2013-02-19','12:00:00',2.82),('8348','2013-02-19','12:05:00',2.82),('8348','2013-02-19','12:10:00',2.81),('8348','2013-02-19','12:15:00',2.81),('8348','2013-02-19','12:20:00',2.84),('8348','2013-02-19','12:25:00',2.86),('8348','2013-02-19','12:30:00',2.87),('8348','2013-02-19','12:35:00',2.82),('8348','2013-02-19','12:40:00',2.86),('8348','2013-02-19','12:45:00',2.86),('8348','2013-02-19','12:50:00',2.87),('8348','2013-02-19','12:55:00',2.87),('8348','2013-02-19','13:00:00',2.9),('8348','2013-02-19','13:05:00',2.9),('8348','2013-02-19','13:10:00',2.91),('8348','2013-02-19','13:15:00',2.94),('8348','2013-02-19','13:20:00',2.91),('8348','2013-02-19','13:25:00',2.86),('8348','2013-02-19','13:30:00',2.83),('8348','2013-02-19','13:35:00',2.79),('8348','2013-02-19','13:40:00',2.76),('8348','2013-02-19','13:45:00',2.72),('8348','2013-02-19','13:50:00',2.69),('8348','2013-02-19','13:55:00',2.68),('8348','2013-02-19','14:00:00',2.62),('8348','2013-02-19','14:05:00',2.57),('8348','2013-02-19','14:10:00',2.57),('8348','2013-02-19','14:15:00',2.5),('8348','2013-02-19','14:20:00',2.28),('8348','2013-02-19','14:25:00',2.38),('8348','2013-02-19','14:30:00',2.37),('8348','2013-02-19','14:35:00',2.34),('8348','2013-02-19','14:40:00',2.27),('8348','2013-02-19','14:45:00',2.26),('8348','2013-02-19','14:50:00',2.25),('8348','2013-02-19','14:55:00',2.19),('8348','2013-02-19','15:00:00',2.14),('8348','2013-02-19','15:05:00',2.08),('8348','2013-02-19','15:10:00',2.07),('8348','2013-02-19','15:15:00',1.97),('8348','2013-02-19','15:20:00',1.92),('8348','2013-02-19','15:25:00',1.86),('8348','2013-02-19','15:30:00',1.73),('8348','2013-02-19','15:35:00',1.67),('8348','2013-02-19','15:40:00',1.66),('8348','2013-02-19','15:45:00',1.58),('8348','2013-02-19','15:50:00',1.51),('8348','2013-02-19','15:55:00',1.47),('8348','2013-02-19','16:00:00',1.39),('8348','2013-02-19','16:05:00',1.32),('8348','2013-02-19','16:10:00',1.23),('8348','2013-02-19','16:15:00',1.16),('8348','2013-02-19','16:20:00',1.08),('8348','2013-02-18','08:55:00',1.04),('8348','2013-02-18','09:00:00',1.1),('8348','2013-02-18','09:05:00',1.17),('8348','2013-02-18','09:10:00',1.25),('8348','2013-02-18','09:15:00',1.37),('8348','2013-02-18','09:20:00',1.56),('8348','2013-02-18','09:25:00',1.75),('8348','2013-02-18','09:30:00',1.39),('8348','2013-02-18','09:35:00',1.09),('8348','2013-02-18','09:50:00',1.48),('8348','2013-02-18','11:00:00',1.06),('8348','2013-02-18','11:05:00',1.1),('8348','2013-02-18','11:10:00',1.23),('8348','2013-02-18','11:15:00',1.09),('8348','2013-02-18','11:20:00',1.33),('8348','2013-02-18','11:25:00',1.36),('8348','2013-02-18','11:30:00',1.28),('8348','2013-02-18','11:35:00',1.32),('8348','2013-02-18','11:40:00',1.3),('8348','2013-02-18','11:45:00',1.21),('8348','2013-02-18','11:50:00',1.28),('8348','2013-02-18','11:55:00',1.49),('8348','2013-02-18','12:00:00',1.57),('8348','2013-02-18','12:05:00',1.48),('8348','2013-02-18','12:10:00',1.33),('8348','2013-02-18','12:15:00',1.31),('8348','2013-02-18','12:20:00',1.27),('8348','2013-02-18','12:25:00',1.28),('8348','2013-02-18','12:30:00',1.19),('8348','2013-02-18','12:35:00',1.13),('8348','2013-02-18','12:40:00',1.18),('8348','2013-02-18','12:45:00',1.41),('8348','2013-02-18','12:50:00',1.42),('8348','2013-02-18','12:55:00',1.31),('8348','2013-02-18','13:00:00',1.34),('8348','2013-02-18','13:05:00',1.37),('8348','2013-02-18','13:10:00',1.34),('8348','2013-02-18','13:15:00',1.71),('8348','2013-02-18','13:20:00',1.36),('8348','2013-02-18','13:25:00',1.76),('8348','2013-02-18','13:30:00',1.43),('8348','2013-02-18','13:35:00',1.18),('8348','2013-02-18','13:40:00',1.14),('8348','2013-02-18','13:45:00',1.09),('8348','2013-02-18','13:50:00',1.1),('8348','2013-02-18','13:55:00',1.41),('8348','2013-02-18','14:00:00',1.39),('8348','2013-02-18','14:05:00',1.39),('8348','2013-02-18','14:10:00',1.16),('8348','2013-02-18','14:20:00',1.07),('8348','2013-02-17','08:55:00',1.01),('8348','2013-02-17','09:00:00',1.06),('8348','2013-02-17','09:05:00',1.1),('8348','2013-02-17','09:10:00',1.16),('8348','2013-02-17','09:15:00',1.29),('8348','2013-02-17','09:20:00',1.35),('8348','2013-02-17','09:25:00',1.43),('8348','2013-02-17','09:30:00',1.5),('8348','2013-02-17','09:35:00',1.57),('8348','2013-02-17','09:40:00',1.63),('8348','2013-02-17','09:45:00',1.69),('8348','2013-02-17','09:50:00',1.76),('8348','2013-02-17','09:55:00',1.83),('8348','2013-02-17','10:00:00',1.87),('8348','2013-02-17','10:05:00',1.93),('8348','2013-02-17','10:10:00',1.98),('8348','2013-02-17','10:15:00',2.03),('8348','2013-02-17','10:20:00',2.07),('8348','2013-02-17','10:25:00',2.13),('8348','2013-02-17','10:30:00',2.18),('8348','2013-02-17','10:35:00',2.24),('8348','2013-02-17','10:40:00',2.29),('8348','2013-02-17','10:45:00',2.31),('8348','2013-02-17','10:50:00',2.34),('8348','2013-02-17','10:55:00',2.37),('8348','2013-02-17','11:00:00',2.42),('8348','2013-02-17','11:05:00',2.46),('8348','2013-02-17','11:10:00',2.5),('8348','2013-02-17','11:15:00',2.51),('8348','2013-02-17','11:20:00',2.53),('8348','2013-02-17','11:25:00',2.59),('8348','2013-02-17','11:30:00',2.59),('8348','2013-02-17','11:35:00',2.6),('8348','2013-02-17','11:40:00',2.61),('8348','2013-02-17','11:45:00',2.67),('8348','2013-02-17','11:50:00',2.69),('8348','2013-02-17','11:55:00',2.71),('8348','2013-02-17','12:00:00',2.74),('8348','2013-02-17','12:05:00',2.75),('8348','2013-02-17','12:10:00',2.79),('8348','2013-02-17','12:15:00',2.78),('8348','2013-02-17','12:20:00',2.76),('8348','2013-02-17','12:25:00',2.77),('8348','2013-02-17','12:30:00',2.8),('8348','2013-02-17','12:35:00',2.79),('8348','2013-02-17','12:40:00',2.76),('8348','2013-02-17','12:45:00',2.71),('8348','2013-02-17','12:50:00',2.71),('8348','2013-02-17','12:55:00',2.75),('8348','2013-02-17','13:00:00',2.76),('8348','2013-02-17','13:05:00',2.76),('8348','2013-02-17','13:10:00',2.72),('8348','2013-02-17','13:15:00',2.71),('8348','2013-02-17','13:20:00',2.33),('8348','2013-02-17','13:30:00',2.69),('8348','2013-02-17','13:35:00',2.58),('8348','2013-02-17','13:40:00',2.55),('8348','2013-02-17','13:45:00',2.53),('8348','2013-02-17','13:50:00',2.18),('8348','2013-02-17','13:55:00',1.86),('8348','2013-02-17','14:05:00',1.18),('8348','2013-02-17','14:10:00',2.55),('8348','2013-02-17','14:15:00',1.9),('8348','2013-02-17','14:25:00',1.27),('8348','2013-02-17','14:30:00',2.17),('8348','2013-02-17','14:35:00',2.4),('8348','2013-02-17','14:40:00',2.07),('8348','2013-02-17','15:00:00',1.42),('8348','2013-02-17','15:05:00',1.49),('8348','2013-02-17','15:10:00',2.29),('8348','2013-02-17','15:15:00',2.22),('8348','2013-02-17','15:20:00',2.14),('8348','2013-02-17','15:25:00',2.03),('8348','2013-02-17','15:30:00',1.87),('8348','2013-02-17','15:35:00',1.82),('8348','2013-02-17','15:40:00',1.82),('8348','2013-02-17','15:45:00',1.7),('8348','2013-02-17','15:50:00',1.63),('8348','2013-02-17','15:55:00',1.55),('8348','2013-02-17','16:00:00',1.45),('8348','2013-02-17','16:05:00',1.34),('8348','2013-02-17','16:25:00',1.16),('8348','2013-02-17','16:30:00',1.14),('8348','2013-02-16','09:15:00',1.31),('8348','2013-02-16','09:20:00',1.42),('8348','2013-02-16','09:25:00',1.47),('8348','2013-02-16','09:30:00',1.54),('8348','2013-02-16','09:35:00',1.63),('8348','2013-02-16','09:40:00',1.68),('8348','2013-02-16','09:45:00',1.73),('8348','2013-02-16','09:50:00',1.81),('8348','2013-02-16','09:55:00',1.85),('8348','2013-02-16','10:00:00',1.88),('8348','2013-02-16','10:05:00',1.94),('8348','2013-02-16','10:10:00',2.03),('8348','2013-02-16','10:15:00',2.06),('8348','2013-02-16','10:20:00',2.13),('8348','2013-02-16','10:25:00',2.17),('8348','2013-02-16','10:30:00',2.2),('8348','2013-02-16','10:35:00',2.3),('8348','2013-02-16','10:40:00',2.33),('8348','2013-02-16','10:45:00',2.45),('8348','2013-02-16','10:50:00',2.47),('8348','2013-02-16','10:55:00',2.45),('8348','2013-02-16','11:00:00',2.51),('8348','2013-02-16','11:05:00',2.49),('8348','2013-02-16','11:10:00',2.52),('8348','2013-02-16','11:15:00',2.57),('8348','2013-02-16','11:20:00',2.59),('8348','2013-02-16','11:25:00',2.67),('8348','2013-02-16','11:30:00',2.67),('8348','2013-02-16','11:35:00',2.7),('8348','2013-02-16','11:40:00',2.73),('8348','2013-02-16','11:45:00',2.77),('8348','2013-02-16','11:50:00',2.8),('8348','2013-02-16','11:55:00',2.81),('8348','2013-02-16','12:00:00',2.81),('8348','2013-02-16','12:05:00',2.81),('8348','2013-02-16','12:10:00',2.82),('8348','2013-02-16','12:15:00',2.84),('8348','2013-02-16','12:20:00',2.84),('8348','2013-02-16','12:25:00',2.84),('8348','2013-02-16','12:30:00',2.85),('8348','2013-02-16','12:35:00',2.86),('8348','2013-02-16','12:40:00',2.87),('8348','2013-02-16','12:45:00',2.87),('8348','2013-02-16','12:50:00',2.91),('8348','2013-02-16','12:55:00',2.88),('8348','2013-02-16','13:00:00',2.88),('8348','2013-02-16','13:05:00',2.86),('8348','2013-02-16','13:10:00',2.83),('8348','2013-02-16','13:15:00',2.82),('8348','2013-02-16','13:20:00',2.8),('8348','2013-02-16','13:25:00',2.77),('8348','2013-02-16','13:30:00',2.75),('8348','2013-02-16','13:35:00',2.74),('8348','2013-02-16','13:40:00',2.74),('8348','2013-02-16','13:45:00',2.75),('8348','2013-02-16','13:50:00',2.73),('8348','2013-02-16','13:55:00',2.69),('8348','2013-02-16','14:00:00',2.63),('8348','2013-02-16','14:05:00',2.63),('8348','2013-02-16','14:10:00',2.6),('8348','2013-02-16','14:15:00',2.58),('8348','2013-02-16','14:20:00',2.62),('8348','2013-02-16','14:25:00',1.77),('8348','2013-02-16','15:20:00',1.05),('8348','2013-02-16','15:25:00',1.21),('8348','2013-02-16','15:30:00',2.12),('8348','2013-02-16','15:35:00',2.07),('8348','2013-02-16','15:40:00',1.97),('8348','2013-02-16','15:45:00',1.9),('8348','2013-02-16','15:50:00',1.95),('8348','2013-02-16','15:55:00',1.27),('8348','2013-02-16','16:00:00',1.12),('8348','2013-02-16','16:05:00',1.3),('8348','2013-02-15','09:20:00',1.17),('8348','2013-02-15','09:25:00',1.45),('8348','2013-02-15','09:30:00',1.06),('8348','2013-02-15','09:55:00',1.11),('8348','2013-02-15','10:00:00',1.42),('8348','2013-02-15','10:05:00',1.24),('8348','2013-02-15','10:10:00',1.03),('8348','2013-02-15','10:15:00',1),('8348','2013-02-15','10:20:00',1.35),('8348','2013-02-15','10:25:00',1.76),('8348','2013-02-15','10:30:00',1.5),('8348','2013-02-15','10:35:00',2.27),('8348','2013-02-15','10:40:00',2.2),('8348','2013-02-15','10:48:00',2.26),('8348','2013-02-15','10:50:00',1.42),('8348','2013-02-15','10:55:00',1.53),('8348','2013-02-15','11:00:00',1.46),('8348','2013-02-15','11:05:00',1.57),('8348','2013-02-15','11:10:00',1.64),('8348','2013-02-15','11:15:00',2.15),('8348','2013-02-15','11:20:00',2.71),('8348','2013-02-15','11:25:00',2.65),('8348','2013-02-15','11:30:00',2.65),('8348','2013-02-15','11:35:00',2.29),('8348','2013-02-15','11:40:00',1.53),('8348','2013-02-15','11:45:00',1.95),('8348','2013-02-15','11:50:00',3.08),('8348','2013-02-15','11:55:00',2.63),('8348','2013-02-15','12:00:00',2.34),('8348','2013-02-15','12:05:00',2.23),('8348','2013-02-15','12:10:00',2.29),('8348','2013-02-15','12:15:00',2.57),('8348','2013-02-15','12:20:00',3.16),('8348','2013-02-15','12:25:00',2.81),('8348','2013-02-15','12:30:00',2.91),('8348','2013-02-15','12:35:00',2.86),('8348','2013-02-15','12:40:00',2.87),('8348','2013-02-15','12:45:00',2.87),('8348','2013-02-15','12:50:00',2.87),('8348','2013-02-15','12:55:00',2.9),('8348','2013-02-15','13:00:00',2.88),('8348','2013-02-15','13:05:00',2.88),('8348','2013-02-15','13:10:00',2.8),('8348','2013-02-15','13:15:00',2.9),('8348','2013-02-15','13:20:00',2.66),('8348','2013-02-15','13:25:00',2.37),('8348','2013-02-15','13:30:00',1.68),('8348','2013-02-15','13:35:00',2.06),('8348','2013-02-15','13:40:00',2.84),('8348','2013-02-15','13:45:00',2.18),('8348','2013-02-15','13:50:00',2.2),('8348','2013-02-15','13:55:00',2.45),('8348','2013-02-15','14:00:00',1.83),('8348','2013-02-15','14:05:00',2.6),('8348','2013-02-15','14:10:00',3.05),('8348','2013-02-15','14:15:00',2.04),('8348','2013-02-15','14:20:00',2.1),('8348','2013-02-15','14:25:00',1.49),('8348','2013-02-15','14:30:00',1.42),('8348','2013-02-15','14:35:00',2.34),('8348','2013-02-15','14:40:00',2.45),('8348','2013-02-15','14:45:00',1.85),('8348','2013-02-15','14:50:00',1.15),('8348','2013-02-15','14:55:00',1.13),('8348','2013-02-15','15:00:00',1.66),('8348','2013-02-15','15:05:00',1.08),('8348','2013-02-15','15:10:00',1.3),('8348','2013-02-15','15:15:00',1.46),('8348','2013-02-15','15:20:00',1.21),('8348','2013-02-15','15:25:00',1.47),('8348','2013-02-15','15:30:00',1.62),('8348','2013-02-15','15:35:00',1.27),('8348','2013-02-15','15:40:00',1.14),('8348','2013-02-15','15:45:00',1.1),('8348','2013-02-14','09:00:00',1.07),('8348','2013-02-14','09:05:00',1.12),('8348','2013-02-14','09:10:00',1.2),('8348','2013-02-14','09:15:00',1.27),('8348','2013-02-14','09:20:00',1.35),('8348','2013-02-14','09:25:00',1.42),('8348','2013-02-14','09:30:00',1.51),('8348','2013-02-14','09:35:00',1.62),('8348','2013-02-14','09:40:00',1.69),('8348','2013-02-14','09:45:00',1.76),('8348','2013-02-14','09:50:00',1.82),('8348','2013-02-14','09:55:00',1.89),('8348','2013-02-14','10:00:00',1.95),('8348','2013-02-14','10:05:00',2.01),('8348','2013-02-14','10:10:00',2.07),('8348','2013-02-14','10:15:00',2.13),('8348','2013-02-14','10:20:00',2.18),('8348','2013-02-14','10:25:00',2.23),('8348','2013-02-14','10:30:00',2.28),('8348','2013-02-14','10:35:00',2.33),('8348','2013-02-14','10:40:00',2.38),('8348','2013-02-14','10:45:00',2.42),('8348','2013-02-14','10:50:00',2.47),('8348','2013-02-14','10:55:00',2.52),('8348','2013-02-14','11:00:00',2.55),('8348','2013-02-14','11:05:00',2.59),('8348','2013-02-14','11:10:00',2.63),('8348','2013-02-14','11:15:00',2.66),('8348','2013-02-14','11:20:00',2.69),('8348','2013-02-14','11:25:00',2.71),('8348','2013-02-14','11:30:00',2.73),('8348','2013-02-14','11:35:00',2.76),('8348','2013-02-14','11:40:00',2.76),('8348','2013-02-14','11:45:00',2.79),('8348','2013-02-14','11:50:00',2.81),('8348','2013-02-14','11:55:00',2.83),('8348','2013-02-14','12:00:00',2.86),('8348','2013-02-14','12:05:00',2.87),('8348','2013-02-14','12:10:00',2.87),('8348','2013-02-14','12:15:00',2.88),('8348','2013-02-14','12:20:00',2.88),('8348','2013-02-14','12:25:00',2.89),('8348','2013-02-14','12:30:00',2.89),('8348','2013-02-14','12:35:00',2.89),('8348','2013-02-14','12:40:00',2.9),('8348','2013-02-14','12:45:00',2.88),('8348','2013-02-14','12:50:00',2.87),('8348','2013-02-14','12:55:00',2.87),('8348','2013-02-14','13:00:00',2.87),('8348','2013-02-14','13:05:00',2.87),('8348','2013-02-14','13:10:00',2.87),('8348','2013-02-14','13:15:00',2.86),('8348','2013-02-14','13:20:00',2.84),('8348','2013-02-14','13:25:00',2.81),('8348','2013-02-14','13:30:00',2.79),('8348','2013-02-14','13:35:00',2.77),('8348','2013-02-14','13:40:00',2.76),('8348','2013-02-14','13:45:00',2.74),('8348','2013-02-14','13:50:00',2.7),('8348','2013-02-14','13:55:00',2.67),('8348','2013-02-14','14:00:00',2.64),('8348','2013-02-14','14:05:00',2.6),('8348','2013-02-14','14:10:00',2.57),('8348','2013-02-14','14:15:00',2.53),('8348','2013-02-14','14:20:00',2.49),('8348','2013-02-14','14:25:00',2.45),('8348','2013-02-14','14:30:00',2.39),('8348','2013-02-14','14:35:00',2.34),('8348','2013-02-14','14:40:00',2.3),('8348','2013-02-14','14:45:00',2.26),('8348','2013-02-14','14:50:00',2.21),('8348','2013-02-14','14:55:00',2.16),('8348','2013-02-14','15:00:00',2.1),('8348','2013-02-14','15:05:00',2.04),('8348','2013-02-14','15:10:00',1.99),('8348','2013-02-14','15:15:00',1.92),('8348','2013-02-14','15:20:00',1.86),('8348','2013-02-14','15:25:00',1.79),('8348','2013-02-14','15:30:00',1.74),('8348','2013-02-14','15:35:00',1.66),('8348','2013-02-14','15:40:00',1.58),('8348','2013-02-14','15:45:00',1.53),('8348','2013-02-14','15:50:00',1.46),('8348','2013-02-14','15:55:00',1.39),('8348','2013-02-14','16:00:00',1.31),('8348','2013-02-14','16:05:00',1.22),('8348','2013-02-14','16:10:00',1.14),('8348','2013-02-14','16:15:00',1.07),('8348','2013-02-13','09:10:00',1),('8348','2013-02-13','09:25:00',1.01),('8348','2013-02-13','09:30:00',1.02),('8348','2013-02-13','09:35:00',1.34),('8348','2013-02-13','09:40:00',1.53),('8348','2013-02-13','09:45:00',1.79),('8348','2013-02-13','09:50:00',1.8),('8348','2013-02-13','09:55:00',1.7),('8348','2013-02-13','10:00:00',1.76),('8348','2013-02-13','10:05:00',1.89),('8348','2013-02-13','10:10:00',2),('8348','2013-02-13','10:15:00',2.11),('8348','2013-02-13','10:20:00',2.18),('8348','2013-02-13','10:25:00',2.26),('8348','2013-02-13','10:30:00',2.4),('8348','2013-02-13','10:35:00',2.37),('8348','2013-02-13','10:40:00',2.39),('8348','2013-02-13','10:45:00',2.56),('8348','2013-02-13','10:50:00',2.61),('8348','2013-02-13','10:55:00',2.6),('8348','2013-02-13','11:00:00',2.55),('8348','2013-02-13','11:05:00',2.69),('8348','2013-02-13','11:10:00',2.44),('8348','2013-02-13','11:15:00',2.57),('8348','2013-02-13','11:20:00',2.59),('8348','2013-02-13','11:25:00',1.93),('8348','2013-02-13','11:30:00',2.52),('8348','2013-02-13','11:35:00',1.37),('8348','2013-02-13','11:40:00',1.31),('8348','2013-02-13','11:45:00',1.09),('8348','2013-02-13','11:50:00',1.02),('8348','2013-02-13','12:10:00',1.51),('8348','2013-02-13','12:15:00',1.77),('8348','2013-02-13','12:20:00',1.8),('8348','2013-02-13','12:25:00',2.07),('8348','2013-02-13','12:35:00',1.25),('8348','2013-02-13','12:45:00',1.65),('8348','2013-02-13','12:50:00',2.17),('8348','2013-02-13','12:55:00',2.11),('8348','2013-02-13','13:00:00',2.05),('8348','2013-02-13','13:05:00',1.89),('8348','2013-02-13','13:10:00',2.25),('8348','2013-02-13','13:15:00',2.12),('8348','2013-02-13','13:20:00',2.9),('8348','2013-02-13','13:25:00',2.94),('8348','2013-02-13','13:30:00',2.99),('8348','2013-02-13','13:35:00',3),('8348','2013-02-13','13:40:00',2.81),('8348','2013-02-13','13:45:00',2.64),('8348','2013-02-13','13:50:00',2.28),('8348','2013-02-13','13:55:00',2.3),('8348','2013-02-13','14:00:00',2.64),('8348','2013-02-13','14:05:00',2.8),('8348','2013-02-13','14:10:00',2.41),('8348','2013-02-13','14:15:00',2.37),('8348','2013-02-13','14:20:00',2.3),('8348','2013-02-13','14:25:00',2.12),('8348','2013-02-13','14:30:00',2.34),('8348','2013-02-13','14:35:00',2.43),('8348','2013-02-13','14:40:00',2.39),('8348','2013-02-13','14:45:00',2.22),('8348','2013-02-13','14:50:00',2.25),('8348','2013-02-13','14:55:00',2.19),('8348','2013-02-13','15:00:00',2.12),('8348','2013-02-13','15:05:00',2.06),('8348','2013-02-13','15:10:00',1.98),('8348','2013-02-13','15:15:00',1.91),('8348','2013-02-13','15:20:00',1.85),('8348','2013-02-13','15:25:00',1.83),('8348','2013-02-13','15:30:00',1.77),('8348','2013-02-13','15:35:00',1.71),('8348','2013-02-13','15:40:00',1.65),('8348','2013-02-13','15:45:00',1.58),('8348','2013-02-13','15:50:00',1.49),('8348','2013-02-13','15:55:00',1.43),('8348','2013-02-13','16:00:00',1.34),('8348','2013-02-13','16:05:00',1.25),('8348','2013-02-13','16:10:00',1.18),('8348','2013-02-13','16:15:00',1.11),('8348','2013-02-13','16:20:00',1.01),('8348','2013-02-11','10:35:00',1.14),('8348','2013-02-11','10:40:00',1.02),('8348','2013-02-11','11:10:00',1.17),('8348','2013-02-11','11:15:00',1.29),('8348','2013-02-11','11:20:00',1.02),('8348','2013-02-11','11:45:00',1.08),('8348','2013-02-11','12:45:00',1.14),('8348','2013-02-11','14:10:00',1.1),('8348','2013-02-11','14:25:00',1.36),('8348','2013-02-11','14:30:00',1.93),('8348','2013-02-11','14:35:00',1.01),('8348','2013-02-11','14:40:00',1.48),('8348','2013-02-11','14:45:00',1.22),('8348','2014-03-22','07:35:00',1.45),('8348','2014-03-22','07:40:00',1.94),('8348','2014-03-22','07:45:00',1.85),('8348','2014-03-22','07:50:00',1.74),('8348','2014-03-22','07:55:00',1.05),('8348','2014-03-22','08:10:00',1.65),('8348','2014-03-22','08:15:00',1.95),('8348','2014-03-22','08:20:00',2.27),('8348','2014-03-22','08:25:00',2.29),('8348','2014-03-22','08:30:00',2.39),('8348','2014-03-22','08:35:00',1.68),('8348','2014-03-22','08:40:00',3.42),('8348','2014-03-22','08:45:00',3.34),('8348','2014-03-22','08:50:00',2.76),('8348','2014-03-22','08:55:00',2.56),('8348','2014-03-22','09:00:00',3.29),('8348','2014-03-22','09:05:00',2.34),('8348','2014-03-22','09:10:00',2.47),('8348','2014-03-22','09:15:00',2.18),('8348','2014-03-22','09:20:00',2.36),('8348','2014-03-22','09:25:00',2.9),('8348','2014-03-22','09:30:00',4.17),('8348','2014-03-22','09:35:00',3),('8348','2014-03-22','09:40:00',4.01),('8348','2014-03-22','09:45:00',4.65),('8348','2014-03-22','09:50:00',4.76),('8348','2014-03-22','09:55:00',4.89),('8348','2014-03-22','10:00:00',5.12),('8348','2014-03-22','10:05:00',3.8),('8348','2014-03-22','10:10:00',4.34),('8348','2014-03-22','10:15:00',2.97),('8348','2014-03-22','10:20:00',2.02),('8348','2014-03-22','10:25:00',1.69),('8348','2014-03-22','10:30:00',1.74),('8348','2014-03-22','10:35:00',2.55),('8348','2014-03-22','10:40:00',3.53),('8348','2014-03-22','10:45:00',4.35),('8348','2014-03-22','10:50:00',5.06),('8348','2014-03-22','10:55:00',2.38),('8348','2014-03-22','11:00:00',2),('8348','2014-03-22','11:05:00',1.77),('8348','2014-03-22','11:10:00',2.31),('8348','2014-03-22','11:15:00',3.17),('8348','2014-03-22','11:20:00',6.37),('8348','2014-03-22','11:25:00',6.73),('8348','2014-03-22','11:30:00',5.86),('8348','2014-03-22','11:35:00',2.93),('8348','2014-03-22','11:40:00',5.44),('8348','2014-03-22','11:45:00',2.85),('8348','2014-03-22','11:50:00',3.79),('8348','2014-03-22','11:55:00',7.38),('8348','2014-03-22','12:00:00',4.85),('8348','2014-03-22','12:05:00',3.27),('8348','2014-03-22','12:10:00',2.29),('8348','2014-03-22','12:15:00',3.4),('8348','2014-03-22','12:20:00',6.66),('8348','2014-03-22','12:25:00',4.98),('8348','2014-03-22','12:30:00',3),('8348','2014-03-22','12:35:00',5.3),('8348','2014-03-22','12:40:00',6.4),('8348','2014-03-22','12:45:00',6.99),('8348','2014-03-22','12:50:00',4.1),('8348','2014-03-22','12:55:00',6.21),('8348','2014-03-22','13:00:00',2.58),('8348','2014-03-22','13:05:00',4.9),('8348','2014-03-22','13:10:00',7.36),('8348','2014-03-22','13:15:00',5.16),('8348','2014-03-22','13:20:00',6.28),('8348','2014-03-22','13:25:00',6.25),('8348','2014-03-22','13:30:00',3.89),('8348','2014-03-22','13:35:00',6.39),('8348','2014-03-22','13:40:00',5.96),('8348','2014-03-22','13:45:00',6.41),('8348','2014-03-22','13:50:00',6.09),('8348','2014-03-22','13:55:00',3.94),('8348','2014-03-22','14:00:00',5.52),('8348','2014-03-22','14:05:00',3.78),('8348','2014-03-22','14:10:00',6.18),('8348','2014-03-22','14:15:00',4.19),('8348','2014-03-22','14:20:00',5.08),('8348','2014-03-22','14:25:00',5.9),('8348','2014-03-22','14:30:00',5.73),('8348','2014-03-22','14:35:00',5.65),('8348','2014-03-22','14:40:00',5.53),('8348','2014-03-22','14:45:00',5.36),('8348','2014-03-22','14:50:00',5.31),('8348','2014-03-22','14:55:00',5.23),('8348','2014-03-22','15:00:00',5.08),('8348','2014-03-22','15:05:00',5.01),('8348','2014-03-22','15:10:00',4.77),('8348','2014-03-22','15:15:00',4.69),('8348','2014-03-22','15:20:00',4.7),('8348','2014-03-22','15:25:00',3.79),('8348','2014-03-22','15:30:00',2.54),('8348','2014-03-22','15:35:00',4.65),('8348','2014-03-22','15:40:00',5.32),('8348','2014-03-22','15:45:00',5.14),('8348','2014-03-22','15:50:00',5.07),('8348','2014-03-22','15:55:00',4.59),('8348','2014-03-22','16:00:00',4.23),('8348','2014-03-22','16:05:00',3.75),('8348','2014-03-22','16:10:00',3.43),('8348','2014-03-22','16:15:00',3.24),('8348','2014-03-22','16:20:00',3.19),('8348','2014-03-22','16:25:00',2.64),('8348','2014-03-22','16:30:00',1.48),('8348','2014-03-22','16:35:00',1.25),('8348','2014-03-22','16:45:00',1.16),('8348','2014-03-22','16:50:00',1.65),('8348','2014-03-22','16:55:00',1.5),('8348','2014-03-22','17:00:00',1.73),('8348','2014-03-22','17:05:00',1.22),('8348','2013-02-10','10:00:00',1.91),('8348','2013-02-10','10:05:00',1.98),('8348','2013-02-10','10:10:00',1.98),('8348','2013-02-10','10:15:00',2.07),('8348','2013-02-10','10:20:00',2.11),('8348','2013-02-10','10:25:00',2.16),('8348','2013-02-10','10:30:00',2.21),('8348','2013-02-10','10:35:00',2.26),('8348','2013-02-10','10:40:00',2.29),('8348','2013-02-10','10:45:00',2.33),('8348','2013-02-10','10:50:00',2.38),('8348','2013-02-10','10:55:00',2.42),('8348','2013-02-10','11:00:00',2.47),('8348','2013-02-10','11:05:00',2.49),('8348','2013-02-10','11:10:00',2.52),('8348','2013-02-10','11:15:00',2.55),('8348','2013-02-10','11:20:00',2.57),('8348','2013-02-10','11:25:00',2.6),('8348','2013-02-10','11:30:00',2.64),('8348','2013-02-10','11:35:00',2.66),('8348','2013-02-10','11:40:00',2.68),('8348','2013-02-10','11:45:00',2.7),('8348','2013-02-10','11:50:00',2.72),('8348','2013-02-10','11:55:00',2.75),('8348','2013-02-10','12:00:00',2.79),('8348','2013-02-10','12:05:00',2.8),('8348','2013-02-10','12:10:00',2.81),('8348','2013-02-10','12:15:00',2.85),('8348','2013-02-10','12:20:00',2.85),('8348','2013-02-10','12:25:00',2.86),('8348','2013-02-10','12:30:00',2.84),('8348','2013-02-10','12:35:00',2.85),('8348','2013-02-10','12:40:00',2.84),('8348','2013-02-10','12:45:00',2.84),('8348','2013-02-10','12:50:00',2.86),('8348','2013-02-10','12:55:00',2.86),('8348','2013-02-10','13:00:00',2.83),('8348','2013-02-10','13:05:00',2.79),('8348','2013-02-10','13:10:00',2.78),('8348','2013-02-10','13:15:00',2.75),('8348','2013-02-10','13:20:00',2.75),('8348','2013-02-10','13:25:00',2.75),('8348','2013-02-10','13:30:00',2.69),('8348','2013-02-10','13:35:00',2.63),('8348','2013-02-10','13:40:00',2.6),('8348','2013-02-10','13:45:00',2.58),('8348','2013-02-10','13:50:00',2.59),('8348','2013-02-10','13:55:00',2.55),('8348','2013-02-10','14:00:00',2.48),('8348','2013-02-10','14:05:00',2.46),('8348','2013-02-10','14:10:00',2.43),('8348','2013-02-10','14:15:00',2.4),('8348','2013-02-10','14:20:00',2.39),('8348','2013-02-10','14:25:00',2.32),('8348','2013-02-10','14:30:00',2.31),('8348','2013-02-10','14:35:00',1.81),('8348','2013-02-10','14:40:00',2.23),('8348','2013-02-10','14:45:00',2.13),('8348','2013-02-10','14:50:00',2.09),('8348','2013-02-10','14:55:00',1.23),('8348','2013-02-10','15:00:00',1.29),('8348','2013-02-10','15:05:00',1.45),('8348','2013-02-10','15:10:00',1.91),('8348','2013-02-10','15:15:00',1.27),('8348','2013-02-10','15:20:00',1.89),('8348','2013-02-10','15:25:00',1.98),('8348','2013-02-10','15:30:00',1.29),('8348','2013-02-10','15:35:00',1.47),('8348','2013-02-10','15:40:00',1.1),('8348','2013-02-09','11:05:00',1),('8348','2013-02-09','11:10:00',1.03),('8348','2013-02-09','11:15:00',1.07),('8348','2013-02-09','11:20:00',1.1),('8348','2013-02-09','11:25:00',1.11),('8348','2013-02-09','11:30:00',1.12),('8348','2013-02-09','11:35:00',1.09),('8348','2013-02-09','11:40:00',1.06),('8348','2013-02-09','11:45:00',1.07),('8348','2013-02-09','11:50:00',1.07),('8348','2013-02-09','11:55:00',1.04),('8348','2013-02-09','12:00:00',1.05),('8348','2013-02-09','12:05:00',1.05),('8348','2013-02-09','12:10:00',1.03),('8348','2013-02-09','12:15:00',1.02),('8348','2013-02-09','12:20:00',1.04),('8348','2013-02-09','12:25:00',1.05),('8348','2013-02-09','12:30:00',1.07),('8348','2013-02-09','12:35:00',1.13),('8348','2013-02-09','12:40:00',1.15),('8348','2013-02-09','12:45:00',1.15),('8348','2013-02-09','12:50:00',1.17),('8348','2013-02-09','12:55:00',1.16),('8348','2013-02-09','13:00:00',1.24),('8348','2013-02-09','13:05:00',1.4),('8348','2013-02-09','13:10:00',1.56),('8348','2013-02-09','13:15:00',1.69),('8348','2013-02-09','13:20:00',1.88),('8348','2013-02-09','13:25:00',1.98),('8348','2013-02-09','13:30:00',2.25),('8348','2013-02-09','13:35:00',2.33),('8348','2013-02-09','13:40:00',2.35),('8348','2013-02-09','13:45:00',2.55),('8348','2013-02-09','13:50:00',2.66),('8348','2013-02-09','13:55:00',2.75),('8348','2013-02-09','14:00:00',2.65),('8348','2013-02-09','14:05:00',2.38),('8348','2013-02-09','14:10:00',2.01),('8348','2013-02-09','14:15:00',2.51),('8348','2013-02-09','14:20:00',2.85),('8348','2013-02-09','14:25:00',2.9),('8348','2013-02-09','14:30:00',2.61),('8348','2013-02-09','14:35:00',2.41),('8348','2013-02-09','14:40:00',2.18),('8348','2013-02-09','14:45:00',2.11),('8348','2013-02-09','14:50:00',2.06),('8348','2013-02-09','14:55:00',2.04),('8348','2013-02-09','15:00:00',1.97),('8348','2013-02-09','15:05:00',1.91),('8348','2013-02-09','15:10:00',1.85),('8348','2013-02-09','15:15:00',1.74),('8348','2013-02-09','15:20:00',1.72),('8348','2013-02-09','15:25:00',1.52),('8348','2013-02-09','15:30:00',1.55),('8348','2013-02-09','15:35:00',1.48),('8348','2013-02-09','15:40:00',1.41),('8348','2013-02-09','15:45:00',1.3),('8348','2013-02-09','15:50:00',1.28),('8348','2013-02-08','09:35:00',1.86),('8348','2013-02-08','09:40:00',1.94),('8348','2013-02-08','09:45:00',1.47),('8348','2013-02-08','09:50:00',2.01),('8348','2013-02-08','09:55:00',2.06),('8348','2013-02-08','10:00:00',2.19),('8348','2013-02-08','10:05:00',2.34),('8348','2013-02-08','10:10:00',2.36),('8348','2013-02-08','10:15:00',2.46),('8348','2013-02-08','10:20:00',2.61),('8348','2013-02-08','10:25:00',2.43),('8348','2013-02-08','10:30:00',2.59),('8348','2013-02-08','10:35:00',1.21),('8348','2013-02-08','10:40:00',2.16),('8348','2013-02-08','10:45:00',2.47),('8348','2013-02-08','10:50:00',2.66),('8348','2013-02-08','10:55:00',2.62),('8348','2013-02-08','11:00:00',2.56),('8348','2013-02-08','11:05:00',2.54),('8348','2013-02-08','11:10:00',2.56),('8348','2013-02-08','11:15:00',2.56),('8348','2013-02-08','11:20:00',2.59),('8348','2013-02-08','11:25:00',2.61),('8348','2013-02-08','11:30:00',2.63),('8348','2013-02-08','11:35:00',2.64),('8348','2013-02-08','11:40:00',2.67),('8348','2013-02-08','11:45:00',2.69),('8348','2013-02-08','11:50:00',2.7),('8348','2013-02-08','11:55:00',2.71),('8348','2013-02-08','12:00:00',2.73),('8348','2013-02-08','12:05:00',2.74),('8348','2013-02-08','12:10:00',2.75),('8348','2013-02-08','12:15:00',2.76),('8348','2013-02-08','12:20:00',2.79),('8348','2013-02-08','12:25:00',2.82),('8348','2013-02-08','12:30:00',2.81),('8348','2013-02-08','12:35:00',2.82),('8348','2013-02-08','12:40:00',2.87),('8348','2013-02-08','12:45:00',3.18),('8348','2013-02-08','12:50:00',1.95),('8348','2013-02-08','12:55:00',1.89),('8348','2013-02-08','13:00:00',1.74),('8348','2013-02-08','13:05:00',1.52),('8348','2013-02-08','13:10:00',1.68),('8348','2013-02-08','13:15:00',1.62),('8348','2013-02-08','13:20:00',1.71),('8348','2013-02-08','13:25:00',1.58),('8348','2013-02-08','13:30:00',1.58),('8348','2013-02-08','13:35:00',2.3),('8348','2013-02-08','13:40:00',1.68),('8348','2013-02-08','13:45:00',1.32),('8348','2013-02-08','13:50:00',1.38),('8348','2013-02-08','13:55:00',1.41),('8348','2013-02-08','14:00:00',1.31),('8348','2013-02-08','14:05:00',1.29),('8348','2013-02-08','14:10:00',1.2),('8348','2013-02-08','14:15:00',1.11),('8348','2013-02-08','14:20:00',1.15),('8348','2013-02-08','14:25:00',1.44),('8348','2013-02-08','14:30:00',1.84),('8348','2013-02-08','14:35:00',2.12),('8348','2013-02-08','14:40:00',3.21),('8348','2013-02-08','14:45:00',2.62),('8348','2013-02-08','14:50:00',1.77),('8348','2013-02-08','14:55:00',2.28),('8348','2013-02-08','15:00:00',2.43),('8348','2013-02-08','15:05:00',2.68),('8348','2013-02-08','15:10:00',2.51),('8348','2013-02-08','15:15:00',1.95),('8348','2013-02-08','15:20:00',1.19),('8348','2013-02-08','15:25:00',1.81),('8348','2013-02-08','15:30:00',1.72),('8348','2013-02-08','15:35:00',1.62),('8348','2013-02-08','15:40:00',1.55),('8348','2013-02-08','15:45:00',1.49),('8348','2013-02-08','15:50:00',1.4),('8348','2013-02-08','15:55:00',1.31),('8348','2013-02-08','16:00:00',1.22),('8348','2013-02-08','16:05:00',1.14),('8348','2013-02-08','16:10:00',1.08),('8348','2013-02-07','10:40:00',1.16),('8348','2013-02-07','10:45:00',1.22),('8348','2013-02-07','10:55:00',1.22),('8348','2013-02-07','11:00:00',1.67),('8348','2013-02-07','12:25:00',2.16),('8348','2013-02-07','12:30:00',1.6),('8348','2013-02-07','13:15:00',1.77),('8348','2013-02-07','13:20:00',1.38),('8348','2013-02-07','13:25:00',1.19),('8348','2013-02-07','13:55:00',1.01),('8348','2013-02-07','14:00:00',1.23),('8348','2013-02-07','14:05:00',1.74),('8348','2013-02-07','14:10:00',2.71),('8348','2013-02-07','14:15:00',2.54),('8348','2013-02-07','14:20:00',2.38),('8348','2013-02-07','14:25:00',1.13),('8348','2013-02-07','14:30:00',1.05),('8348','2013-02-07','14:35:00',1.85),('8348','2013-02-07','14:40:00',1.5),('8348','2013-02-07','14:45:00',1.83),('8348','2013-02-07','14:50:00',1.17),('8348','2013-02-07','15:00:00',1.64),('8348','2013-02-07','15:05:00',2.22),('8348','2013-02-07','15:10:00',2.26),('8348','2013-02-07','15:15:00',1.36),('8348','2013-02-06','09:10:00',1.12),('8348','2013-02-06','09:30:00',1.23),('8348','2013-02-06','09:40:00',1.32),('8348','2013-02-06','09:45:00',1.08),('8348','2013-02-06','09:50:00',1.09),('8348','2013-02-06','09:55:00',1.32),('8348','2013-02-06','10:06:00',1.25),('8348','2013-02-06','10:10:00',1.07),('8348','2013-02-06','10:15:00',1.16),('8348','2013-02-06','10:20:00',1.04),('8348','2013-02-06','10:25:00',1.39),('8348','2013-02-06','10:30:00',1.23),('8348','2013-02-06','10:35:00',1.64),('8348','2013-02-06','10:40:00',1.14),('8348','2013-02-06','10:50:00',1.47),('8348','2013-02-06','10:55:00',1.85),('8348','2013-02-06','11:00:00',1.56),('8348','2013-02-06','11:05:00',1.25),('8348','2013-02-06','11:10:00',1.4),('8348','2013-02-06','11:15:00',1.3),('8348','2013-02-06','11:20:00',1.61),('8348','2013-02-06','11:25:00',2.37),('8348','2013-02-06','11:30:00',1.35),('8348','2013-02-06','11:35:00',1.29),('8348','2013-02-06','11:40:00',1.45),('8348','2013-02-06','11:45:00',1.47),('8348','2013-02-06','11:50:00',1.52),('8348','2013-02-06','11:55:00',1.43),('8348','2013-02-06','12:00:00',1.22),('8348','2013-02-06','12:15:00',1.04),('8348','2013-02-06','12:20:00',1),('8348','2013-02-06','13:30:00',1.16),('8348','2013-02-06','13:35:00',1.28),('8348','2013-02-06','13:40:00',1.02),('8348','2013-02-06','13:45:00',1.05),('8348','2013-02-06','13:50:00',1.65),('8348','2013-02-06','13:55:00',1.18),('8348','2013-02-06','14:00:00',1.27),('8348','2013-02-06','14:05:00',1.2),('8348','2013-02-06','14:30:00',1.49),('8348','2013-02-06','14:35:00',2.03),('8348','2013-02-06','14:40:00',1.19),('8348','2013-02-05','09:10:00',1.01),('8348','2013-02-05','09:15:00',1.04),('8348','2013-02-05','09:20:00',1.1),('8348','2013-02-05','09:25:00',1.19),('8348','2013-02-05','09:30:00',1.25),('8348','2013-02-05','09:35:00',1.32),('8348','2013-02-05','09:40:00',1.42),('8348','2013-02-05','09:45:00',1.52),('8348','2013-02-05','09:50:00',1.6),('8348','2013-02-05','09:55:00',1.66),('8348','2013-02-05','10:00:00',1.68),('8348','2013-02-05','10:05:00',1.72),('8348','2013-02-05','10:10:00',1.65),('8348','2013-02-05','10:15:00',1.67),('8348','2013-02-05','10:20:00',1.89),('8348','2013-02-05','10:25:00',1.94),('8348','2013-02-05','10:30:00',1.99),('8348','2013-02-05','10:35:00',2.02),('8348','2013-02-05','10:40:00',2.06),('8348','2013-02-05','10:45:00',2.08),('8348','2013-02-05','10:50:00',2.1),('8348','2013-02-05','10:55:00',2.14),('8348','2013-02-05','11:00:00',2.17),('8348','2013-02-05','11:05:00',2.18),('8348','2013-02-05','11:10:00',2.26),('8348','2013-02-05','11:15:00',2.26),('8348','2013-02-05','11:20:00',2.29),('8348','2013-02-05','11:25:00',2.33),('8348','2013-02-05','11:30:00',2.32),('8348','2013-02-05','11:35:00',2.2),('8348','2013-02-05','11:40:00',1.92),('8348','2013-02-05','11:45:00',2.02),('8348','2013-02-05','11:50:00',1.48),('8348','2013-02-05','11:55:00',1.26),('8348','2013-02-05','12:05:00',1.43),('8348','2013-02-05','12:10:00',1.31),('8348','2013-02-05','12:15:00',1.25),('8348','2013-02-05','12:20:00',1.1),('8348','2013-02-05','12:25:00',1.07),('8348','2013-02-05','12:30:00',1.04),('8348','2013-02-05','12:35:00',1.37),('8348','2013-02-05','12:40:00',1.73),('8348','2013-02-05','12:45:00',1.85),('8348','2013-02-05','12:50:00',1.74),('8348','2013-02-05','13:15:00',1.23),('8348','2013-02-05','13:20:00',1.25),('8348','2013-02-05','13:25:00',1.24),('8348','2013-02-05','13:30:00',1.18),('8348','2013-02-05','13:45:00',1.26),('8348','2013-02-05','13:50:00',1.28),('8348','2013-02-05','13:55:00',1.13),('8348','2013-02-05','14:00:00',1.16),('8348','2013-02-05','14:05:00',1.14),('8348','2013-02-05','14:15:00',1.05),('8348','2013-02-05','14:20:00',1.12),('8348','2013-02-05','14:25:00',1.58),('8348','2013-02-05','14:30:00',1.59),('8348','2013-02-05','14:35:00',1.36),('8348','2013-02-05','14:40:00',1.32),('8348','2013-02-04','09:05:00',1.01),('8348','2013-02-04','09:10:00',1.09),('8348','2013-02-04','09:15:00',1.14),('8348','2013-02-04','09:20:00',1.13),('8348','2013-02-04','09:25:00',1.2),('8348','2013-02-04','09:30:00',1.3),('8348','2013-02-04','09:35:00',1.33),('8348','2013-02-04','09:40:00',1.39),('8348','2013-02-04','09:45:00',1.28),('8348','2013-02-04','09:50:00',1.62),('8348','2013-02-04','09:55:00',1.74),('8348','2013-02-04','10:00:00',1.77),('8348','2013-02-04','10:05:00',1.86),('8348','2013-02-04','10:10:00',1.95),('8348','2013-02-04','10:15:00',2.03),('8348','2013-02-04','10:20:00',1.92),('8348','2013-02-04','10:25:00',2.03),('8348','2013-02-04','10:30:00',1.94),('8348','2013-02-04','10:35:00',1.85),('8348','2013-02-04','10:40:00',1.98),('8348','2013-02-04','10:45:00',2.18),('8348','2013-02-04','10:50:00',2.25),('8348','2013-02-04','10:55:00',2.26),('8348','2013-02-04','11:00:00',2.28),('8348','2013-02-04','11:05:00',2.35),('8348','2013-02-04','11:10:00',2.38),('8348','2013-02-04','11:15:00',2.41),('8348','2013-02-04','11:20:00',2.44),('8348','2013-02-04','11:25:00',2.46),('8348','2013-02-04','11:30:00',2.48),('8348','2013-02-04','11:35:00',2.51),('8348','2013-02-04','11:40:00',2.54),('8348','2013-02-04','11:45:00',2.56),('8348','2013-02-04','11:50:00',2.57),('8348','2013-02-04','11:55:00',2.58),('8348','2013-02-04','12:00:00',2.59),('8348','2013-02-04','12:05:00',2.62),('8348','2013-02-04','12:10:00',2.63),('8348','2013-02-04','12:15:00',2.63),('8348','2013-02-04','12:20:00',2.63),('8348','2013-02-04','12:25:00',2.63),('8348','2013-02-04','12:30:00',2.63),('8348','2013-02-04','12:35:00',2.63),('8348','2013-02-04','12:40:00',2.63),('8348','2013-02-04','12:45:00',2.64),('8348','2013-02-04','12:50:00',2.65),('8348','2013-02-04','12:55:00',2.65),('8348','2013-02-04','13:00:00',2.65),('8348','2013-02-04','13:05:00',2.64),('8348','2013-02-04','13:10:00',2.61),('8348','2013-02-04','13:15:00',2.61),('8348','2013-02-04','13:20:00',2.6),('8348','2013-02-04','13:25:00',2.59),('8348','2013-02-04','13:30:00',2.56),('8348','2013-02-04','13:35:00',2.54),('8348','2013-02-04','13:40:00',2.52),('8348','2013-02-04','13:45:00',2.49),('8348','2013-02-04','13:50:00',2.48),('8348','2013-02-04','13:55:00',2.45),('8348','2013-02-04','14:00:00',2.41),('8348','2013-02-04','14:05:00',2.38),('8348','2013-02-04','14:10:00',2.35),('8348','2013-02-04','14:15:00',2.31),('8348','2013-02-04','14:20:00',2.28),('8348','2013-02-04','14:25:00',2.24),('8348','2013-02-04','14:30:00',2.2),('8348','2013-02-04','14:35:00',2.15),('8348','2013-02-04','14:40:00',2.09),('8348','2013-02-04','14:45:00',2.05),('8348','2013-02-04','14:50:00',2.01),('8348','2013-02-04','14:55:00',1.95),('8348','2013-02-04','15:00:00',1.9),('8348','2013-02-04','15:05:00',1.85),('8348','2013-02-04','15:10:00',1.8),('8348','2013-02-04','15:15:00',1.74),('8348','2013-02-04','15:20:00',1.68),('8348','2013-02-04','15:25:00',1.61),('8348','2013-02-04','15:30:00',1.54),('8348','2013-02-04','15:35:00',1.48),('8348','2013-02-04','15:40:00',1.41),('8348','2013-02-04','15:45:00',1.34),('8348','2013-02-04','15:50:00',1.27),('8348','2013-02-04','15:55:00',1.2),('8348','2013-02-04','16:00:00',1.13),('8348','2013-02-04','16:05:00',1.06),('8348','2013-02-03','09:25:00',1.12),('8348','2013-02-03','09:40:00',1.08),('8348','2013-02-03','09:45:00',1.2),('8348','2013-02-03','09:50:00',1.34),('8348','2013-02-03','09:55:00',1.21),('8348','2013-02-03','10:00:00',1.51),('8348','2013-02-03','11:20:00',1.24),('8348','2013-02-03','11:55:00',1.3),('8348','2013-02-03','12:00:00',1.23),('8348','2013-02-03','12:05:00',1.18),('8348','2013-02-03','12:10:00',1.17),('8348','2013-02-02','10:30:00',1.03),('8348','2013-02-02','10:35:00',1.12),('8348','2013-02-02','10:40:00',1.23),('8348','2013-02-02','10:45:00',1.37),('8348','2013-02-02','10:50:00',1.09),('8348','2013-02-02','10:55:00',1.61),('8348','2013-02-02','11:00:00',1.64),('8348','2013-02-02','11:05:00',1.51),('8348','2013-02-02','11:10:00',1.61),('8348','2013-02-02','11:15:00',1.55),('8348','2013-02-02','11:20:00',1.57),('8348','2013-02-02','11:25:00',1.81),('8348','2013-02-02','11:30:00',1.68),('8348','2013-02-02','11:35:00',1.6),('8348','2013-02-02','11:40:00',1.53),('8348','2013-02-02','11:45:00',1.1),('8348','2013-02-02','11:55:00',1.04),('8348','2013-02-02','12:55:00',1.9),('8348','2013-02-02','13:00:00',1.68),('8348','2013-02-02','13:05:00',1.6),('8348','2013-02-02','13:10:00',1.87),('8348','2013-02-02','13:15:00',1.88),('8348','2013-02-02','13:20:00',1.68),('8348','2013-02-02','13:25:00',1.65),('8348','2013-02-02','13:30:00',1.26),('8348','2013-02-02','13:35:00',1.74),('8348','2013-02-02','13:40:00',2.2),('8348','2013-02-02','13:45:00',1.79),('8348','2013-02-02','13:50:00',1.71),('8348','2013-02-01','09:05:00',1.05),('8348','2013-02-01','09:10:00',1.13),('8348','2013-02-01','09:25:00',1.22),('8348','2013-02-01','09:30:00',1.29),('8348','2013-02-01','09:35:00',1.46),('8348','2013-02-01','09:40:00',1.67),('8348','2013-02-01','09:45:00',1.26),('8348','2013-02-01','09:50:00',1.02),('8348','2013-02-01','09:55:00',1.48),('8348','2013-02-01','10:00:00',1.16),('8348','2013-02-01','10:05:00',1.66),('8348','2013-02-01','10:15:00',1.14),('8348','2013-02-01','10:20:00',1.09),('8348','2013-02-01','10:50:00',2.22),('8348','2013-02-01','10:55:00',2.61),('8348','2013-02-01','11:00:00',2.47),('8348','2013-02-01','11:05:00',2.29),('8348','2013-02-01','11:10:00',1.67),('8348','2013-02-01','11:15:00',1.1),('8348','2013-02-01','11:20:00',1.71),('8348','2013-02-01','11:30:00',1.04),('8348','2013-02-01','11:35:00',1.64),('8348','2013-02-01','11:40:00',1.18),('8348','2013-02-01','11:45:00',1.57),('8348','2013-02-01','11:50:00',1.15),('8348','2013-02-01','12:00:00',1.1),('8348','2013-02-01','12:05:00',1.57),('8348','2013-02-01','12:10:00',1.43),('8348','2013-02-01','12:15:00',1.89),('8348','2013-02-01','12:20:00',2.83),('8348','2013-02-01','12:25:00',2.33),('8348','2013-02-01','12:30:00',2.11),('8348','2013-02-01','12:35:00',2.45),('8348','2013-02-01','12:40:00',2.84),('8348','2013-02-01','12:45:00',2.61),('8348','2013-02-01','12:50:00',2.81),('8348','2013-02-01','12:55:00',1.34),('8348','2013-02-01','13:00:00',1.7),('8348','2013-02-01','13:05:00',1.81),('8348','2013-02-01','13:10:00',2.69),('8348','2013-02-01','13:15:00',2.47),('8348','2013-02-01','13:20:00',2.57),('8348','2013-02-01','13:25:00',1.8),('8348','2013-02-01','13:30:00',2.21),('8348','2013-02-01','13:35:00',1.72),('8348','2013-02-01','13:40:00',2.1),('8348','2013-02-01','13:45:00',1.58),('8348','2013-02-01','13:50:00',1.06),('8348','2013-02-01','14:10:00',1.53),('8348','2013-02-01','14:15:00',2.35),('8348','2013-02-01','14:20:00',2.34),('8348','2013-02-01','14:25:00',2.1),('8348','2013-02-01','14:30:00',2.09),('8348','2013-02-01','14:35:00',2.06),('8348','2013-02-01','14:40:00',1.03),('8348','2013-02-01','15:10:00',1.4),('8348','2013-02-01','15:15:00',1.82),('8348','2013-02-01','15:20:00',1.7),('8348','2013-02-01','15:25:00',1.55),('8348','2013-02-01','15:50:00',1),('8348','2013-02-01','15:55:00',1.09),('8348','2014-03-21','07:35:00',1.1),('8348','2014-03-21','07:40:00',1.19),('8348','2014-03-21','07:45:00',1.32),('8348','2014-03-21','07:50:00',1.43),('8348','2014-03-21','07:55:00',1.59),('8348','2014-03-21','08:00:00',1.72),('8348','2014-03-21','08:05:00',1.79),('8348','2014-03-21','08:10:00',1.87),('8348','2014-03-21','08:15:00',1.98),('8348','2014-03-21','08:20:00',2.09),('8348','2014-03-21','08:25:00',2.23),('8348','2014-03-21','08:30:00',2.36),('8348','2014-03-21','08:35:00',2.48),('8348','2014-03-21','08:40:00',2.79),('8348','2014-03-21','08:45:00',3.01),('8348','2014-03-21','08:50:00',3.19),('8348','2014-03-21','08:55:00',3.35),('8348','2014-03-21','09:00:00',3.49),('8348','2014-03-21','09:05:00',3.61),('8348','2014-03-21','09:10:00',3.83),('8348','2014-03-21','09:15:00',3.92),('8348','2014-03-21','09:20:00',4.09),('8348','2014-03-21','09:25:00',3.99),('8348','2014-03-21','09:30:00',4.29),('8348','2014-03-21','09:35:00',4.31),('8348','2014-03-21','09:40:00',4.48),('8348','2014-03-21','09:45:00',4.58),('8348','2014-03-21','09:50:00',4.65),('8348','2014-03-21','09:55:00',4.72),('8348','2014-03-21','10:00:00',4.82),('8348','2014-03-21','10:05:00',4.87),('8348','2014-03-21','10:10:00',4.95),('8348','2014-03-21','10:15:00',5.06),('8348','2014-03-21','10:20:00',5.12),('8348','2014-03-21','10:25:00',5.27),('8348','2014-03-21','10:30:00',5.32),('8348','2014-03-21','10:35:00',5.39),('8348','2014-03-21','10:40:00',5.52),('8348','2014-03-21','10:45:00',5.47),('8348','2014-03-21','10:50:00',5.47),('8348','2014-03-21','10:55:00',5.54),('8348','2014-03-21','11:00:00',5.66),('8348','2014-03-21','11:05:00',5.67),('8348','2014-03-21','11:10:00',5.73),('8348','2014-03-21','11:15:00',5.74),('8348','2014-03-21','11:20:00',5.94),('8348','2014-03-21','11:25:00',6.12),('8348','2014-03-21','11:30:00',4.61),('8348','2014-03-21','11:35:00',3.51),('8348','2014-03-21','11:40:00',4.4),('8348','2014-03-21','11:45:00',5.19),('8348','2014-03-21','11:50:00',6.94),('8348','2014-03-21','11:55:00',6.94),('8348','2014-03-21','12:00:00',5.6),('8348','2014-03-21','12:05:00',4.02),('8348','2014-03-21','12:10:00',6.17),('8348','2014-03-21','12:15:00',6.51),('8348','2014-03-21','12:20:00',6.5),('8348','2014-03-21','12:25:00',6.56),('8348','2014-03-21','12:30:00',6.44),('8348','2014-03-21','12:35:00',6.45),('8348','2014-03-21','12:40:00',6.44),('8348','2014-03-21','12:45:00',6.5),('8348','2014-03-21','12:50:00',6.42),('8348','2014-03-21','12:55:00',6.36),('8348','2014-03-21','13:00:00',6.41),('8348','2014-03-21','13:05:00',6.48),('8348','2014-03-21','13:10:00',6.42),('8348','2014-03-21','13:15:00',6.46),('8348','2014-03-21','13:20:00',6.38),('8348','2014-03-21','13:25:00',6.34),('8348','2014-03-21','13:30:00',6.26),('8348','2014-03-21','13:35:00',6.31),('8348','2014-03-21','13:40:00',6.28),('8348','2014-03-21','13:45:00',6.22),('8348','2014-03-21','13:50:00',6.25),('8348','2014-03-21','13:55:00',6.18),('8348','2014-03-21','14:00:00',6.2),('8348','2014-03-21','14:05:00',6.17),('8348','2014-03-21','14:10:00',6.1),('8348','2014-03-21','14:15:00',6.02),('8348','2014-03-21','14:20:00',5.96),('8348','2014-03-21','14:25:00',5.88),('8348','2014-03-21','14:30:00',5.56),('8348','2014-03-21','14:35:00',5.47),('8348','2014-03-21','14:40:00',5.5),('8348','2014-03-21','14:45:00',5.41),('8348','2014-03-21','14:50:00',4.48),('8348','2014-03-21','14:55:00',2.39),('8348','2014-03-21','15:00:00',1.52),('8348','2014-03-21','15:05:00',3.03),('8348','2014-03-21','15:10:00',5.61),('8348','2014-03-21','15:15:00',5.79),('8348','2014-03-21','15:20:00',5.24),('8348','2014-03-21','15:25:00',5.31),('8348','2014-03-21','15:30:00',5.44),('8348','2014-03-21','15:35:00',4.99),('8348','2014-03-21','15:40:00',5.07),('8348','2014-03-21','15:45:00',4.93),('8348','2014-03-21','15:50:00',4.87),('8348','2014-03-21','15:55:00',4.76),('8348','2014-03-21','16:00:00',4.52),('8348','2014-03-21','16:05:00',4.15),('8348','2014-03-21','16:10:00',3.85),('8348','2014-03-21','16:15:00',3.61),('8348','2014-03-21','16:20:00',3.36),('8348','2014-03-21','16:25:00',3.08),('8348','2014-03-21','16:30:00',2.9),('8348','2014-03-21','16:35:00',2.7),('8348','2014-03-21','16:40:00',2.52),('8348','2014-03-21','16:45:00',2.38),('8348','2014-03-21','16:50:00',2.21),('8348','2014-03-21','16:55:00',2.04),('8348','2014-03-21','17:00:00',1.72),('8348','2014-03-21','17:05:00',1.61),('8348','2014-03-21','17:10:00',1.45),('8348','2014-03-21','17:15:00',1.23),('8348','2014-03-21','17:20:00',1.08),('8348','2013-01-31','09:25:00',1.01),('8348','2013-01-31','09:30:00',1.29),('8348','2013-01-31','09:35:00',1.24),('8348','2013-01-31','09:40:00',1.2),('8348','2013-01-31','09:45:00',1.36),('8348','2013-01-31','09:50:00',1.42),('8348','2013-01-31','09:55:00',1.54),('8348','2013-01-31','10:00:00',1.54),('8348','2013-01-31','10:05:00',1.59),('8348','2013-01-31','10:10:00',1.61),('8348','2013-01-31','10:15:00',1.66),('8348','2013-01-31','10:20:00',1.76),('8348','2013-01-31','10:25:00',1.76),('8348','2013-01-31','10:30:00',1.92),('8348','2013-01-31','10:35:00',2.06),('8348','2013-01-31','10:40:00',2.13),('8348','2013-01-31','10:45:00',2.22),('8348','2013-01-31','10:50:00',2.21),('8348','2013-01-31','10:55:00',1.54),('8348','2013-01-31','11:10:00',2.33),('8348','2013-01-31','11:15:00',2.65),('8348','2013-01-31','11:20:00',2.71),('8348','2013-01-31','11:25:00',2.46),('8348','2013-01-31','11:30:00',2.34),('8348','2013-01-31','11:35:00',2.35),('8348','2013-01-31','11:40:00',2.33),('8348','2013-01-31','11:45:00',2.34),('8348','2013-01-31','11:50:00',2.37),('8348','2013-01-31','11:55:00',2.37),('8348','2013-01-31','12:00:00',2.36),('8348','2013-01-31','12:05:00',2.43),('8348','2013-01-31','12:10:00',2.42),('8348','2013-01-31','12:15:00',2.29),('8348','2013-01-31','12:20:00',2.43),('8348','2013-01-31','12:25:00',2.42),('8348','2013-01-31','12:30:00',2.41),('8348','2013-01-31','12:35:00',2.42),('8348','2013-01-31','12:40:00',2.42),('8348','2013-01-31','12:45:00',2.4),('8348','2013-01-31','12:50:00',2.42),('8348','2013-01-31','12:55:00',2.42),('8348','2013-01-31','13:00:00',2.39),('8348','2013-01-31','13:05:00',2.4),('8348','2013-01-31','13:10:00',2.39),('8348','2013-01-31','13:15:00',2.32),('8348','2013-01-31','13:20:00',2.29),('8348','2013-01-31','13:25:00',2.3),('8348','2013-01-31','13:30:00',2.29),('8348','2013-01-31','13:35:00',2.24),('8348','2013-01-31','13:40:00',2.23),('8348','2013-01-31','13:45:00',2.21),('8348','2013-01-31','13:50:00',2.25),('8348','2013-01-31','13:55:00',2.22),('8348','2013-01-31','14:00:00',2.11),('8348','2013-01-31','14:05:00',2.07),('8348','2013-01-31','14:10:00',2.02),('8348','2013-01-31','14:15:00',2.03),('8348','2013-01-31','14:20:00',1.98),('8348','2013-01-31','14:25:00',1.97),('8348','2013-01-31','14:30:00',1.88),('8348','2013-01-31','14:35:00',1.84),('8348','2013-01-31','14:40:00',1.82),('8348','2013-01-31','14:45:00',1.76),('8348','2013-01-31','14:50:00',1.71),('8348','2013-01-31','14:55:00',1.61),('8348','2013-01-31','15:00:00',1.59),('8348','2013-01-31','15:05:00',1.58),('8348','2013-01-31','15:10:00',1.53),('8348','2013-01-31','15:15:00',1.51),('8348','2013-01-31','15:20:00',1.47),('8348','2013-01-31','15:25:00',1.36),('8348','2013-01-31','15:30:00',1.33),('8348','2013-01-31','15:35:00',1.31),('8348','2013-01-31','15:40:00',1.22),('8348','2013-01-31','15:45:00',1.12),('8348','2013-01-31','15:50:00',1.06),('8348','2013-01-30','10:05:00',1.05),('8348','2013-01-30','10:10:00',1.3),('8348','2013-01-30','10:15:00',1.05),('8348','2013-01-30','10:20:00',1.4),('8348','2013-01-30','10:25:00',1.51),('8348','2013-01-30','10:30:00',1.22),('8348','2013-01-30','10:35:00',1.17),('8348','2013-01-30','10:40:00',1.12),('8348','2013-01-30','10:45:00',1.63),('8348','2013-01-30','10:50:00',1.92),('8348','2013-01-30','10:55:00',1.94),('8348','2013-01-30','11:00:00',2.08),('8348','2013-01-30','11:05:00',2),('8348','2013-01-30','11:10:00',2.05),('8348','2013-01-30','11:15:00',2.07),('8348','2013-01-30','11:20:00',2.13),('8348','2013-01-30','11:25:00',2.21),('8348','2013-01-30','11:30:00',2.23),('8348','2013-01-30','11:35:00',2.15),('8348','2013-01-30','11:40:00',2.08),('8348','2013-01-30','11:45:00',2.49),('8348','2013-01-30','11:50:00',1.75),('8348','2013-01-30','11:55:00',1.87),('8348','2013-01-30','12:00:00',2.19),('8348','2013-01-30','12:05:00',1.65),('8348','2013-01-30','12:10:00',1.04),('8348','2013-01-30','12:15:00',1.7),('8348','2013-01-30','12:20:00',1.39),('8348','2013-01-30','12:40:00',1.04),('8348','2013-01-30','12:45:00',1.02),('8348','2013-01-30','12:50:00',2.43),('8348','2013-01-30','12:55:00',2.93),('8348','2013-01-30','13:00:00',2.75),('8348','2013-01-30','13:05:00',2.59),('8348','2013-01-30','13:10:00',2.68),('8348','2013-01-30','13:15:00',2.71),('8348','2013-01-30','13:20:00',2.65),('8348','2013-01-30','13:25:00',2.7),('8348','2013-01-30','13:30:00',2.59),('8348','2013-01-30','13:35:00',2.78),('8348','2013-01-30','13:40:00',2.19),('8348','2013-01-30','13:45:00',1.21),('8348','2013-01-30','13:50:00',2.59),('8348','2013-01-30','13:55:00',2.47),('8348','2013-01-30','14:00:00',2.23),('8348','2013-01-30','14:05:00',2.54),('8348','2013-01-30','14:10:00',2.48),('8348','2013-01-30','14:15:00',2.02),('8348','2013-01-30','14:20:00',1.67),('8348','2013-01-30','14:25:00',2.14),('8348','2013-01-30','14:30:00',2.07),('8348','2013-01-30','14:35:00',1.97),('8348','2013-01-30','14:40:00',1.43),('8348','2013-01-30','14:45:00',1.61),('8348','2013-01-29','09:25:00',1.05),('8348','2013-01-29','09:30:00',1.13),('8348','2013-01-29','09:35:00',1.19),('8348','2013-01-29','09:40:00',1.25),('8348','2013-01-29','09:45:00',1.35),('8348','2013-01-29','09:50:00',1.41),('8348','2013-01-29','09:55:00',1.48),('8348','2013-01-29','10:00:00',1.53),('8348','2013-01-29','10:05:00',1.6),('8348','2013-01-29','10:10:00',1.66),('8348','2013-01-29','10:15:00',1.72),('8348','2013-01-29','10:20:00',1.77),('8348','2013-01-29','10:25:00',1.83),('8348','2013-01-29','10:30:00',1.89),('8348','2013-01-29','10:35:00',1.93),('8348','2013-01-29','10:40:00',1.99),('8348','2013-01-29','10:45:00',2.02),('8348','2013-01-29','10:50:00',2.06),('8348','2013-01-29','10:55:00',2.09),('8348','2013-01-29','11:00:00',2.11),('8348','2013-01-29','11:05:00',2.14),('8348','2013-01-29','11:10:00',2.16),('8348','2013-01-29','11:15:00',2.21),('8348','2013-01-29','11:20:00',2.25),('8348','2013-01-29','11:25:00',2.23),('8348','2013-01-29','11:30:00',2.22),('8348','2013-01-29','11:35:00',2.34),('8348','2013-01-29','11:40:00',2.37),('8348','2013-01-29','11:45:00',2.38),('8348','2013-01-29','11:50:00',2.38),('8348','2013-01-29','11:55:00',2.39),('8348','2013-01-29','12:00:00',2.38),('8348','2013-01-29','12:05:00',2.39),('8348','2013-01-29','12:10:00',2.46),('8348','2013-01-29','12:15:00',2.43),('8348','2013-01-29','12:20:00',2.45),('8348','2013-01-29','12:25:00',2.46),('8348','2013-01-29','12:30:00',2.47),('8348','2013-01-29','12:35:00',2.42),('8348','2013-01-29','12:40:00',2.45),('8348','2013-01-29','12:45:00',2.39),('8348','2013-01-29','12:50:00',2.4),('8348','2013-01-29','12:55:00',2.45),('8348','2013-01-29','13:00:00',2.44),('8348','2013-01-29','13:05:00',2.42),('8348','2013-01-29','13:10:00',2.4),('8348','2013-01-29','13:15:00',2.37),('8348','2013-01-29','13:20:00',2.33),('8348','2013-01-29','13:25:00',2.37),('8348','2013-01-29','13:30:00',2.34),('8348','2013-01-29','13:35:00',2.3),('8348','2013-01-29','13:40:00',2.27),('8348','2013-01-29','13:45:00',2.27),('8348','2013-01-29','13:50:00',2.24),('8348','2013-01-29','13:55:00',2.21),('8348','2013-01-29','14:00:00',2.16),('8348','2013-01-29','14:05:00',2.09),('8348','2013-01-29','14:10:00',2.07),('8348','2013-01-29','14:15:00',1.76),('8348','2013-01-29','14:20:00',2.07),('8348','2013-01-29','14:25:00',2.02),('8348','2013-01-29','14:30:00',1.99),('8348','2013-01-29','14:35:00',1.93),('8348','2013-01-29','14:40:00',1.89),('8348','2013-01-29','14:45:00',1.85),('8348','2013-01-29','14:50:00',1.8),('8348','2013-01-29','14:55:00',1.74),('8348','2013-01-29','15:00:00',1.67),('8348','2013-01-29','15:05:00',1.63),('8348','2013-01-29','15:10:00',1.57),('8348','2013-01-29','15:15:00',1.51),('8348','2013-01-29','15:20:00',1.43),('8348','2013-01-29','15:25:00',1.36),('8348','2013-01-29','15:30:00',1.3),('8348','2013-01-29','15:35:00',1.23),('8348','2013-01-29','15:40:00',1.19),('8348','2013-01-29','15:45:00',1.13),('8348','2013-01-29','15:50:00',1.04),('8348','2013-01-29','15:55:00',1),('8348','2013-01-28','12:50:00',1.14),('8348','2013-01-28','12:55:00',1.08),('8348','2013-01-27','09:25:00',1.04),('8348','2013-01-27','09:30:00',1.11),('8348','2013-01-27','09:35:00',1.19),('8348','2013-01-27','09:40:00',1.25),('8348','2013-01-27','09:45:00',1.32),('8348','2013-01-27','09:50:00',1.38),('8348','2013-01-27','09:55:00',1.45),('8348','2013-01-27','10:00:00',1.5),('8348','2013-01-27','10:05:00',1.56),('8348','2013-01-27','10:10:00',1.6),('8348','2013-01-27','10:15:00',1.66),('8348','2013-01-27','10:20:00',1.7),('8348','2013-01-27','10:25:00',1.76),('8348','2013-01-27','10:30:00',1.8),('8348','2013-01-27','10:35:00',1.84),('8348','2013-01-27','10:40:00',1.88),('8348','2013-01-27','10:45:00',1.93),('8348','2013-01-27','10:50:00',1.97),('8348','2013-01-27','10:55:00',2.02),('8348','2013-01-27','11:00:00',2.05),('8348','2013-01-27','11:05:00',2.09),('8348','2013-01-27','11:10:00',2.12),('8348','2013-01-27','11:15:00',2.14),('8348','2013-01-27','11:20:00',2.18),('8348','2013-01-27','11:25:00',2.2),('8348','2013-01-27','11:30:00',2.22),('8348','2013-01-27','11:35:00',2.22),('8348','2013-01-27','11:40:00',2.26),('8348','2013-01-27','11:45:00',2.28),('8348','2013-01-27','11:50:00',2.29),('8348','2013-01-27','11:55:00',2.32),('8348','2013-01-27','12:00:00',2.33),('8348','2013-01-27','12:05:00',2.36),('8348','2013-01-27','12:10:00',2.38),('8348','2013-01-27','12:15:00',2.38),('8348','2013-01-27','12:20:00',2.38),('8348','2013-01-27','12:25:00',2.4),('8348','2013-01-27','12:30:00',2.39),('8348','2013-01-27','12:35:00',2.4),('8348','2013-01-27','12:40:00',2.4),('8348','2013-01-27','12:45:00',2.39),('8348','2013-01-27','12:50:00',2.37),('8348','2013-01-27','12:55:00',2.41),('8348','2013-01-27','13:00:00',2.41),('8348','2013-01-27','13:05:00',2.41),('8348','2013-01-27','13:10:00',2.39),('8348','2013-01-27','13:15:00',2.36),('8348','2013-01-27','13:20:00',2.32),('8348','2013-01-27','13:25:00',2.28),('8348','2013-01-27','13:30:00',2.24),('8348','2013-01-27','13:35:00',2.22),('8348','2013-01-27','13:40:00',2.16),('8348','2013-01-27','13:45:00',2.09),('8348','2013-01-27','13:50:00',2.09),('8348','2013-01-27','13:55:00',2.08),('8348','2013-01-27','14:00:00',2.06),('8348','2013-01-27','14:05:00',2.03),('8348','2013-01-27','14:10:00',2.02),('8348','2013-01-27','14:15:00',1.98),('8348','2013-01-27','14:20:00',1.92),('8348','2013-01-27','14:25:00',1.86),('8348','2013-01-27','14:30:00',1.81),('8348','2013-01-27','14:35:00',1.77),('8348','2013-01-27','14:40:00',1.73),('8348','2013-01-27','14:45:00',1.74),('8348','2013-01-27','14:50:00',1.7),('8348','2013-01-27','14:55:00',1.65),('8348','2013-01-27','15:00:00',1.59),('8348','2013-01-27','15:05:00',1.52),('8348','2013-01-27','15:10:00',1.43),('8348','2013-01-27','15:15:00',1.37),('8348','2013-01-27','15:20:00',1.32),('8348','2013-01-27','15:25:00',1.27),('8348','2013-01-27','15:30:00',1.22),('8348','2013-01-27','15:35:00',1.14),('8348','2013-01-27','15:40:00',1.09),('8348','2013-01-27','15:45:00',1.03),('8348','2013-01-26','10:20:00',1.11),('8348','2013-01-26','10:25:00',1.01),('8348','2013-01-25','09:20:00',1.06),('8348','2013-01-25','09:25:00',1.12),('8348','2013-01-25','09:30:00',1.23),('8348','2013-01-25','09:35:00',1.23),('8348','2013-01-25','09:40:00',1.16),('8348','2013-01-25','09:45:00',1.29),('8348','2013-01-25','09:50:00',1.6),('8348','2013-01-25','09:55:00',1.64),('8348','2013-01-25','10:00:00',1.66),('8348','2013-01-25','10:05:00',1.72),('8348','2013-01-25','10:10:00',1.76),('8348','2013-01-25','10:15:00',1.74),('8348','2013-01-25','10:20:00',1.77),('8348','2013-01-25','10:25:00',1.86),('8348','2013-01-25','10:30:00',1.84),('8348','2013-01-25','10:35:00',1.22),('8348','2013-01-25','10:40:00',2.09),('8348','2013-01-25','10:45:00',1.76),('8348','2013-01-25','10:50:00',1.44),('8348','2013-01-25','10:55:00',2.22),('8348','2013-01-25','11:00:00',1.28),('8348','2013-01-25','11:05:00',1.49),('8348','2013-01-25','11:10:00',2.18),('8348','2013-01-25','11:15:00',2.24),('8348','2013-01-25','11:20:00',2.25),('8348','2013-01-25','11:25:00',2.27),('8348','2013-01-25','11:30:00',2.3),('8348','2013-01-25','11:35:00',2.36),('8348','2013-01-25','11:40:00',2.36),('8348','2013-01-25','11:45:00',2.39),('8348','2013-01-25','11:50:00',2.43),('8348','2013-01-25','11:55:00',2.42),('8348','2013-01-25','12:00:00',2.41),('8348','2013-01-25','12:05:00',2.4),('8348','2013-01-25','12:10:00',2.44),('8348','2013-01-25','12:15:00',2.46),('8348','2013-01-25','12:20:00',2.48),('8348','2013-01-25','12:25:00',2.46),('8348','2013-01-25','12:30:00',2.44),('8348','2013-01-25','12:35:00',2.07),('8348','2013-01-25','12:40:00',2.26),('8348','2013-01-25','12:45:00',2.41),('8348','2013-01-25','12:50:00',2.37),('8348','2013-01-25','12:55:00',2.39),('8348','2013-01-25','13:00:00',2.38),('8348','2013-01-25','13:05:00',2.34),('8348','2013-01-25','13:10:00',2.33),('8348','2013-01-25','13:15:00',2.33),('8348','2013-01-25','13:20:00',2.36),('8348','2013-01-25','13:25:00',2.39),('8348','2013-01-25','13:30:00',2.46),('8348','2013-01-25','13:35:00',2.43),('8348','2013-01-25','13:40:00',2.39),('8348','2013-01-25','13:45:00',2.34),('8348','2013-01-25','13:50:00',2.26),('8348','2013-01-25','13:55:00',2.21),('8348','2013-01-25','14:00:00',2.15),('8348','2013-01-25','14:05:00',2.03),('8348','2013-01-25','14:10:00',1.94),('8348','2013-01-25','14:15:00',1.8),('8348','2013-01-25','14:20:00',1.73),('8348','2013-01-25','14:25:00',1.77),('8348','2013-01-25','14:30:00',1.69),('8348','2013-01-25','14:35:00',1.59),('8348','2013-01-25','14:40:00',1.58),('8348','2013-01-25','14:45:00',1.51),('8348','2013-01-25','14:50:00',1.48),('8348','2013-01-25','14:55:00',1.44),('8348','2013-01-25','15:00:00',1.32),('8348','2013-01-25','15:05:00',1.26),('8348','2013-01-25','15:10:00',1.23),('8348','2013-01-25','15:15:00',1.19),('8348','2013-01-25','15:20:00',1.19),('8348','2013-01-25','15:25:00',1.17),('8348','2013-01-25','15:30:00',1.18),('8348','2013-01-25','15:35:00',1.21),('8348','2013-01-25','15:40:00',1.17),('8348','2013-01-25','15:45:00',1.15),('8348','2013-01-25','15:50:00',1.14),('8348','2013-01-25','15:55:00',1.02),('8348','2013-01-24','09:45:00',1.09),('8348','2013-01-24','09:50:00',1.37),('8348','2013-01-24','09:55:00',1.5),('8348','2013-01-24','10:00:00',1.55),('8348','2013-01-24','10:05:00',1.57),('8348','2013-01-24','10:10:00',1.76),('8348','2013-01-24','10:15:00',1.76),('8348','2013-01-24','10:20:00',1.8),('8348','2013-01-24','10:25:00',1.85),('8348','2013-01-24','10:30:00',1.89),('8348','2013-01-24','10:35:00',1.92),('8348','2013-01-24','10:40:00',1.97),('8348','2013-01-24','10:45:00',2.02),('8348','2013-01-24','10:50:00',2.1),('8348','2013-01-24','10:55:00',1.88),('8348','2013-01-24','11:00:00',1.42),('8348','2013-01-24','14:00:00',1.06),('8348','2013-01-24','14:05:00',1.05),('8348','2013-01-24','14:10:00',1.02),('8348','2013-01-24','14:15:00',1.16),('8348','2013-01-24','14:20:00',1.74),('8348','2013-01-24','14:25:00',2.8),('8348','2013-01-24','14:30:00',2.43),('8348','2013-01-24','14:35:00',1.68),('8348','2013-01-24','14:40:00',1.28),('8348','2013-01-24','14:45:00',1.68),('8348','2013-01-24','14:50:00',1.79),('8348','2013-01-24','14:55:00',1.79),('8348','2013-01-24','15:00:00',1.28),('8348','2013-01-24','15:20:00',1.19),('8348','2013-01-24','15:25:00',1.18),('8348','2013-01-24','15:30:00',1.29),('8348','2013-01-24','15:35:00',1.06),('8348','2013-01-24','15:45:00',1.05),('8348','2013-01-24','15:50:00',1.04),('8348','2013-01-23','09:55:00',1.29),('8348','2013-01-23','10:30:00',2.03),('8348','2013-01-23','10:35:00',2.04),('8348','2013-01-23','10:40:00',1.28),('8348','2013-01-23','10:45:00',1.21),('8348','2013-01-23','10:50:00',1.72),('8348','2013-01-23','10:55:00',1.31),('8348','2013-01-22','09:00:00',1.1),('8348','2013-01-22','09:30:00',1.15),('8348','2013-01-22','09:35:00',1.38),('8348','2013-01-22','09:40:00',1.2),('8348','2013-01-22','09:45:00',1.85),('8348','2013-01-22','09:50:00',1.05),('8348','2013-01-22','09:55:00',1.25),('8348','2013-01-22','10:05:00',1.57),('8348','2013-01-22','10:10:00',1.86),('8348','2013-01-22','10:15:00',1.49),('8348','2013-01-22','10:20:00',1.78),('8348','2013-01-22','10:25:00',1.9),('8348','2013-01-22','10:30:00',1.98),('8348','2013-01-22','10:35:00',2.18),('8348','2013-01-22','10:40:00',2.48),('8348','2013-01-22','10:45:00',2.01),('8348','2013-01-22','10:50:00',1.65),('8348','2013-01-22','10:55:00',1.07),('8348','2013-01-22','11:15:00',1.4),('8348','2013-01-22','11:20:00',1.46),('8348','2013-01-22','11:45:00',1.44),('8348','2013-01-22','11:50:00',1.65),('8348','2013-01-22','12:10:00',2.4),('8348','2013-01-22','12:15:00',2.09),('8348','2013-01-22','12:20:00',1.42),('8348','2013-01-22','12:25:00',2.19),('8348','2013-01-22','12:35:00',1.14),('8348','2013-01-22','12:40:00',2.69),('8348','2013-01-22','12:50:00',1.15),('8348','2013-01-22','13:00:00',2.42),('8348','2013-01-22','13:05:00',2.13),('8348','2013-01-22','13:10:00',1.81),('8348','2013-01-22','13:15:00',1.27),('8348','2013-01-22','13:20:00',1.91),('8348','2013-01-22','13:40:00',1.15),('8348','2013-01-22','13:50:00',1.19),('8348','2013-01-22','14:10:00',1.25),('8348','2013-01-22','14:15:00',1.31),('8348','2013-01-22','14:20:00',1.01),('8348','2013-01-22','14:25:00',1.68),('8348','2013-01-22','14:35:00',1.19),('8348','2013-01-22','14:40:00',1.14),('8348','2013-01-22','14:45:00',1.45),('8348','2014-03-20','07:25:00',1.07),('8348','2014-03-20','07:30:00',1.09),('8348','2014-03-20','07:35:00',1.25),('8348','2014-03-20','07:40:00',1.37),('8348','2014-03-20','07:45:00',1.48),('8348','2014-03-20','07:50:00',1.56),('8348','2014-03-20','07:55:00',1.69),('8348','2014-03-20','08:00:00',1.86),('8348','2014-03-20','08:05:00',1.94),('8348','2014-03-20','08:10:00',2.02),('8348','2014-03-20','08:15:00',2.07),('8348','2014-03-20','08:20:00',2.14),('8348','2014-03-20','08:25:00',2.26),('8348','2014-03-20','08:30:00',2.38),('8348','2014-03-20','08:35:00',2.5),('8348','2014-03-20','08:40:00',2.78),('8348','2014-03-20','08:45:00',3.14),('8348','2014-03-20','08:50:00',3.26),('8348','2014-03-20','08:55:00',3.38),('8348','2014-03-20','09:00:00',3.45),('8348','2014-03-20','09:05:00',3.64),('8348','2014-03-20','09:10:00',3.83),('8348','2014-03-20','09:15:00',3.92),('8348','2014-03-20','09:20:00',4.06),('8348','2014-03-20','09:25:00',4.12),('8348','2014-03-20','09:30:00',4.24),('8348','2014-03-20','09:35:00',4.36),('8348','2014-03-20','09:40:00',4.44),('8348','2014-03-20','09:45:00',4.49),('8348','2014-03-20','09:50:00',4.49),('8348','2014-03-20','09:55:00',4.65),('8348','2014-03-20','10:00:00',4.86),('8348','2014-03-20','10:05:00',5.04),('8348','2014-03-20','10:10:00',5.11),('8348','2014-03-20','10:15:00',5.09),('8348','2014-03-20','10:20:00',5.12),('8348','2014-03-20','10:25:00',5.2),('8348','2014-03-20','10:30:00',5.3),('8348','2014-03-20','10:35:00',5.16),('8348','2014-03-20','10:40:00',5.1),('8348','2014-03-20','10:45:00',5.15),('8348','2014-03-20','10:50:00',5.55),('8348','2014-03-20','10:55:00',5.85),('8348','2014-03-20','11:00:00',5.89),('8348','2014-03-20','11:05:00',5.89),('8348','2014-03-20','11:10:00',5.85),('8348','2014-03-20','11:15:00',5.58),('8348','2014-03-20','11:20:00',5.81),('8348','2014-03-20','11:25:00',5.9),('8348','2014-03-20','11:30:00',6.04),('8348','2014-03-20','11:35:00',6.24),('8348','2014-03-20','11:40:00',6.15),('8348','2014-03-20','11:45:00',6.2),('8348','2014-03-20','11:50:00',6.12),('8348','2014-03-20','11:55:00',5.96),('8348','2014-03-20','12:00:00',5.5),('8348','2014-03-20','12:05:00',5.99),('8348','2014-03-20','12:10:00',6.33),('8348','2014-03-20','12:15:00',6.45),('8348','2014-03-20','12:20:00',6.25),('8348','2014-03-20','12:25:00',5.94),('8348','2014-03-20','12:30:00',6.18),('8348','2014-03-20','12:35:00',6.28),('8348','2014-03-20','12:40:00',6.25),('8348','2014-03-20','12:45:00',6.38),('8348','2014-03-20','12:50:00',6.35),('8348','2014-03-20','12:55:00',6.34),('8348','2014-03-20','13:00:00',6.33),('8348','2014-03-20','13:05:00',6.28),('8348','2014-03-20','13:10:00',6.1),('8348','2014-03-20','13:15:00',6.15),('8348','2014-03-20','13:20:00',6.17),('8348','2014-03-20','13:25:00',5.94),('8348','2014-03-20','13:30:00',6.05),('8348','2014-03-20','13:35:00',5.93),('8348','2014-03-20','13:40:00',5.69),('8348','2014-03-20','13:45:00',5.46),('8348','2014-03-20','13:50:00',5.25),('8348','2014-03-20','13:55:00',4.97),('8348','2014-03-20','14:00:00',5.02),('8348','2014-03-20','14:05:00',5.39),('8348','2014-03-20','14:10:00',5.26),('8348','2014-03-20','14:15:00',5.06),('8348','2014-03-20','14:20:00',4.97),('8348','2014-03-20','14:25:00',5.08),('8348','2014-03-20','14:30:00',4.36),('8348','2014-03-20','14:35:00',3.93),('8348','2014-03-20','14:40:00',4.53),('8348','2014-03-20','14:45:00',4.44),('8348','2014-03-20','14:50:00',4.13),('8348','2014-03-20','14:55:00',4.1),('8348','2014-03-20','15:00:00',3.77),('8348','2014-03-20','15:05:00',3.64),('8348','2014-03-20','15:10:00',3.83),('8348','2014-03-20','15:15:00',3.67),('8348','2014-03-20','15:20:00',3.91),('8348','2014-03-20','15:25:00',3.58),('8348','2014-03-20','15:30:00',3.48),('8348','2014-03-20','15:35:00',3.35),('8348','2014-03-20','15:40:00',3.05),('8348','2014-03-20','15:45:00',3.1),('8348','2014-03-20','15:50:00',2.74),('8348','2014-03-20','15:55:00',2.48),('8348','2014-03-20','16:00:00',2.16),('8348','2014-03-20','16:05:00',1.91),('8348','2014-03-20','16:10:00',1.93),('8348','2014-03-20','16:15:00',1.9),('8348','2014-03-20','16:20:00',1.97),('8348','2014-03-20','16:25:00',2.05),('8348','2014-03-20','16:30:00',1.92),('8348','2014-03-20','16:35:00',1.78),('8348','2014-03-20','16:40:00',1.65),('8348','2014-03-20','16:45:00',1.22),('8348','2013-01-21','11:15:00',1.07),('8348','2013-01-21','11:50:00',1.3),('8348','2013-01-21','11:55:00',2.63),('8348','2013-01-21','12:00:00',2.29),('8348','2013-01-21','12:05:00',2.29),('8348','2013-01-21','12:10:00',2.49),('8348','2013-01-21','12:15:00',1.51),('8348','2013-01-21','12:25:00',1.17),('8348','2013-01-21','12:50:00',1),('8348','2013-01-21','13:05:00',1.81),('8348','2013-01-21','13:10:00',1.34),('8348','2013-01-21','13:30:00',2.35),('8348','2013-01-21','13:35:00',2.67),('8348','2013-01-21','13:40:00',2.09),('8348','2013-01-21','13:50:00',1.39),('8348','2013-01-21','13:55:00',2.34),('8348','2013-01-21','14:00:00',2.41),('8348','2013-01-21','14:05:00',2.54),('8348','2013-01-21','14:10:00',2.08),('8348','2013-01-21','14:15:00',1.51),('8348','2013-01-21','14:20:00',2.05),('8348','2013-01-21','14:25:00',2.23),('8348','2013-01-21','14:30:00',1.12),('8348','2013-01-20','11:05:00',1.03),('8348','2013-01-20','11:10:00',1.09),('8348','2013-01-20','11:15:00',1.46),('8348','2013-01-20','11:20:00',1.17),('8348','2013-01-20','11:25:00',1.52),('8348','2013-01-20','11:30:00',1.98),('8348','2013-01-20','11:35:00',1.58),('8348','2013-01-19','09:55:00',1.25),('8348','2013-01-19','10:00:00',1.16),('8348','2013-01-19','10:45:00',1.15),('8348','2013-01-19','10:50:00',1.16),('8348','2013-01-19','11:20:00',1.03),('8348','2013-01-19','11:25:00',1.03),('8348','2013-01-18','10:15:00',1.85),('8348','2013-01-18','10:20:00',1.76),('8348','2013-01-18','10:25:00',1.25),('8348','2013-01-18','10:30:00',1.09),('8348','2013-01-18','11:35:00',1.08),('8348','2013-01-18','11:40:00',1.01),('8348','2013-01-18','12:35:00',1.14),('8348','2013-01-18','12:40:00',1.24),('8348','2013-01-18','12:45:00',1.34),('8348','2013-01-18','12:50:00',1.8),('8348','2013-01-18','12:55:00',1.82),('8348','2013-01-18','13:00:00',2.19),('8348','2013-01-18','13:05:00',1.97),('8348','2013-01-18','13:10:00',1.84),('8348','2013-01-18','13:15:00',2.13),('8348','2013-01-18','13:20:00',1.65),('8348','2013-01-18','13:25:00',1.38),('8348','2013-01-18','13:30:00',1.27),('8348','2013-01-18','13:35:00',1.25),('8348','2013-01-18','13:40:00',1.29),('8348','2013-01-18','13:45:00',2.63),('8348','2013-01-18','13:50:00',2.61),('8348','2013-01-18','13:55:00',2.39),('8348','2013-01-18','14:00:00',1.6),('8348','2013-01-18','14:05:00',1.92),('8348','2013-01-18','14:10:00',1.74),('8348','2013-01-18','14:15:00',1.87),('8348','2013-01-18','14:20:00',1.63),('8348','2013-01-18','14:25:00',1.32),('8348','2013-01-18','14:30:00',1.03),('8348','2013-01-17','09:50:00',1.05),('8348','2013-01-17','10:15:00',1.12),('8348','2013-01-17','10:20:00',1.07),('8348','2013-01-17','10:25:00',1.34),('8348','2013-01-17','10:30:00',1.39),('8348','2013-01-17','10:35:00',1.3),('8348','2013-01-17','10:40:00',1.28),('8348','2013-01-17','10:45:00',1.35),('8348','2013-01-17','10:50:00',1.28),('8348','2013-01-17','10:55:00',1.46),('8348','2013-01-17','11:00:00',1.32),('8348','2013-01-17','11:05:00',1.35),('8348','2013-01-17','11:10:00',1.56),('8348','2013-01-17','11:15:00',1.5),('8348','2013-01-17','11:20:00',1.42),('8348','2013-01-17','11:25:00',1.22),('8348','2013-01-17','11:30:00',1.09),('8348','2013-01-17','11:35:00',1.21),('8348','2013-01-17','11:40:00',1.31),('8348','2013-01-17','11:45:00',1.18),('8348','2013-01-17','11:50:00',1.27),('8348','2013-01-17','11:55:00',1.35),('8348','2013-01-17','12:00:00',1.5),('8348','2013-01-17','12:05:00',1.45),('8348','2013-01-17','12:10:00',1.47),('8348','2013-01-17','12:15:00',1.61),('8348','2013-01-17','12:20:00',1.55),('8348','2013-01-17','12:25:00',1.44),('8348','2013-01-17','12:30:00',1.21),('8348','2013-01-17','12:35:00',1.42),('8348','2013-01-17','12:40:00',1.58),('8348','2013-01-17','12:45:00',1.24),('8348','2013-01-17','13:00:00',1.31),('8348','2013-01-17','13:05:00',1.3),('8348','2013-01-17','13:15:00',1.27),('8348','2013-01-17','13:20:00',1.26),('8348','2013-01-17','13:25:00',1.1),('8348','2013-01-17','13:30:00',1.06),('8348','2013-01-17','13:35:00',1.48),('8348','2013-01-17','13:40:00',1.54),('8348','2013-01-17','13:45:00',1.95),('8348','2013-01-17','13:50:00',1.66),('8348','2013-01-17','14:00:00',1.32),('8348','2013-01-17','14:30:00',1.14),('8348','2013-01-17','14:35:00',1.55),('8348','2013-01-16','09:30:00',1.03),('8348','2013-01-16','09:35:00',1.13),('8348','2013-01-16','09:40:00',1.2),('8348','2013-01-16','10:35:00',1.33),('8348','2013-01-16','10:40:00',1.67),('8348','2013-01-16','10:45:00',1.58),('8348','2013-01-16','10:55:00',1.61),('8348','2013-01-16','11:25:00',1.29),('8348','2013-01-16','12:00:00',1.47),('8348','2013-01-16','12:05:00',1.17),('8348','2013-01-16','12:10:00',1.57),('8348','2013-01-16','12:15:00',2.92),('8348','2013-01-16','12:20:00',2.58),('8348','2013-01-16','13:05:00',1.67),('8348','2013-01-16','13:10:00',2.89),('8348','2013-01-16','13:15:00',3.22),('8348','2013-01-16','13:20:00',2.42),('8348','2013-01-16','13:25:00',1.38),('8348','2013-01-16','13:55:00',2.4),('8348','2013-01-16','14:00:00',1.51),('8348','2013-01-16','14:05:00',1.12),('8348','2013-01-15','10:50:00',1.12),('8348','2013-01-15','10:55:00',1.25),('8348','2013-01-15','11:00:00',1.25),('8348','2013-01-15','11:05:00',1.3),('8348','2013-01-15','11:10:00',1.34),('8348','2013-01-15','11:15:00',1.26),('8348','2013-01-15','11:20:00',1.29),('8348','2013-01-15','11:25:00',1.29),('8348','2013-01-15','11:30:00',1.23),('8348','2013-01-15','11:35:00',1.16),('8348','2013-01-15','11:40:00',1.04),('8348','2013-01-15','11:55:00',1.01),('8348','2013-01-15','12:20:00',1.12),('8348','2013-01-15','12:25:00',1.1),('8348','2013-01-15','12:30:00',1.06),('8348','2013-01-15','12:35:00',1.07),('8348','2013-01-15','12:40:00',1.18),('8348','2013-01-15','12:45:00',1.2),('8348','2013-01-15','12:50:00',1.24),('8348','2013-01-15','12:55:00',1.04),('8348','2013-01-15','13:30:00',1.01),('8348','2013-01-15','13:35:00',1.05),('8348','2013-01-15','13:40:00',1.19),('8348','2013-01-15','13:45:00',1.07),('8348','2013-01-15','13:50:00',1.03),('8348','2013-01-15','13:55:00',1.16),('8348','2013-01-15','14:00:00',1.91),('8348','2013-01-15','14:05:00',1.63),('8348','2013-01-15','14:10:00',1.72),('8348','2013-01-15','14:15:00',2.35),('8348','2013-01-15','14:20:00',2.22),('8348','2013-01-15','14:25:00',1.67),('8348','2013-01-15','14:30:00',1.9),('8348','2013-01-15','14:35:00',1.62),('8348','2013-01-15','14:40:00',1.11),('8348','2013-01-15','14:45:00',1.58),('8348','2013-01-15','14:50:00',1.51),('8348','2013-01-15','14:55:00',1.61),('8348','2013-01-15','15:00:00',1.5),('8348','2013-01-15','15:05:00',1.4),('8348','2013-01-15','15:10:00',1.35),('8348','2013-01-15','15:15:00',1.17),('8348','2013-01-15','15:20:00',1.02),('8348','2013-01-14','12:50:00',1.03),('8348','2013-01-14','12:55:00',1.02),('8348','2013-01-14','13:00:00',1.07),('8348','2013-01-14','13:05:00',1.04),('8348','2013-01-14','15:15:00',1.2),('8348','2013-01-13','09:15:00',1.13),('8348','2013-01-13','09:20:00',1.22),('8348','2013-01-13','09:25:00',1.18),('8348','2013-01-13','09:30:00',1.24),('8348','2013-01-13','09:35:00',1.28),('8348','2013-01-13','09:50:00',1.1),('8348','2013-01-13','09:55:00',1.23),('8348','2013-01-13','10:00:00',1.28),('8348','2013-01-13','10:05:00',1.44),('8348','2013-01-13','10:10:00',1.04),('8348','2013-01-13','10:20:00',1.15),('8348','2013-01-13','10:25:00',1.1),('8348','2013-01-13','10:30:00',1.57),('8348','2013-01-12','09:35:00',1.01),('8348','2013-01-12','09:40:00',1.07),('8348','2013-01-12','09:45:00',1.13),('8348','2013-01-12','09:50:00',1.18),('8348','2013-01-12','09:55:00',1.24),('8348','2013-01-12','10:00:00',1.28),('8348','2013-01-12','10:05:00',1.34),('8348','2013-01-12','10:10:00',1.39),('8348','2013-01-12','10:15:00',1.45),('8348','2013-01-12','10:20:00',1.47),('8348','2013-01-12','10:25:00',1.51),('8348','2013-01-12','10:30:00',1.55),('8348','2013-01-12','10:35:00',1.59),('8348','2013-01-12','10:40:00',1.64),('8348','2013-01-12','10:45:00',1.69),('8348','2013-01-12','10:50:00',1.71),('8348','2013-01-12','10:55:00',1.77),('8348','2013-01-12','11:00:00',1.81),('8348','2013-01-12','11:05:00',1.81),('8348','2013-01-12','11:10:00',1.84),('8348','2013-01-12','11:15:00',1.87),('8348','2013-01-12','11:20:00',1.9),('8348','2013-01-12','11:25:00',1.92),('8348','2013-01-12','11:30:00',1.92),('8348','2013-01-12','11:35:00',1.95),('8348','2013-01-12','11:40:00',1.97),('8348','2013-01-12','11:45:00',1.99),('8348','2013-01-12','11:50:00',2.01),('8348','2013-01-12','11:55:00',2.03),('8348','2013-01-12','12:00:00',2.03),('8348','2013-01-12','12:05:00',2.03),('8348','2013-01-12','12:10:00',2),('8348','2013-01-12','12:15:00',2.01),('8348','2013-01-12','12:20:00',2.02),('8348','2013-01-12','12:25:00',2.02),('8348','2013-01-12','12:30:00',1.99),('8348','2013-01-12','12:35:00',2.01),('8348','2013-01-12','12:40:00',1.71),('8348','2013-01-12','12:45:00',1.27),('8348','2013-01-12','12:50:00',1.96),('8348','2013-01-12','13:00:00',1.73),('8348','2013-01-12','13:05:00',2.03),('8348','2013-01-12','13:10:00',1.6),('8348','2013-01-12','13:15:00',1.16),('8348','2013-01-12','13:25:00',1.32),('8348','2013-01-12','13:30:00',1.6),('8348','2013-01-12','13:35:00',1.52),('8348','2013-01-12','13:50:00',1.45),('8348','2013-01-12','13:55:00',2.2),('8348','2013-01-12','14:00:00',1.49),('8348','2013-01-12','14:05:00',1.44),('8348','2013-01-12','14:10:00',2.03),('8348','2013-01-12','14:15:00',1.63),('8348','2013-01-12','14:20:00',1.59),('8348','2013-01-12','14:25:00',1.59),('8348','2013-01-12','14:30:00',1.55),('8348','2013-01-12','14:35:00',1.52),('8348','2013-01-12','14:40:00',1.47),('8348','2013-01-12','14:45:00',1.41),('8348','2013-01-12','14:50:00',1.35),('8348','2013-01-12','14:55:00',1.28),('8348','2013-01-12','15:00:00',1.22),('8348','2013-01-12','15:05:00',1.11),('8348','2013-01-12','15:15:00',1),('8348','2014-03-19','08:25:00',1.04),('8348','2014-03-19','08:30:00',1.14),('8348','2014-03-19','08:35:00',1.27),('8348','2014-03-19','08:40:00',1.44),('8348','2014-03-19','08:45:00',1.59),('8348','2014-03-19','08:50:00',1.68),('8348','2014-03-19','08:55:00',1.76),('8348','2014-03-19','09:00:00',1.82),('8348','2014-03-19','09:05:00',2.09),('8348','2014-03-19','09:10:00',2.39),('8348','2014-03-19','09:15:00',2.64),('8348','2014-03-19','09:20:00',2.84),('8348','2014-03-19','09:25:00',3.61),('8348','2014-03-19','09:30:00',5.51),('8348','2014-03-19','09:35:00',5.24),('8348','2014-03-19','09:40:00',5.21),('8348','2014-03-19','09:45:00',4.26),('8348','2014-03-19','09:50:00',4.31),('8348','2014-03-19','09:55:00',3.91),('8348','2014-03-19','10:00:00',2.52),('8348','2014-03-19','10:05:00',1.91),('8348','2014-03-19','10:10:00',1.67),('8348','2014-03-19','10:15:00',1.53),('8348','2014-03-19','10:20:00',1.7),('8348','2014-03-19','10:25:00',1.82),('8348','2014-03-19','10:30:00',2.2),('8348','2014-03-19','10:35:00',3.38),('8348','2014-03-19','10:40:00',3.95),('8348','2014-03-19','10:45:00',2.98),('8348','2014-03-19','10:50:00',3.57),('8348','2014-03-19','10:55:00',3.78),('8348','2014-03-19','11:00:00',5.53),('8348','2014-03-19','11:05:00',4.9),('8348','2014-03-19','11:10:00',3),('8348','2014-03-19','11:15:00',2.86),('8348','2014-03-19','11:20:00',2.93),('8348','2014-03-19','11:25:00',2.95),('8348','2014-03-19','11:30:00',3.02),('8348','2014-03-19','11:35:00',3.65),('8348','2014-03-19','11:40:00',2.94),('8348','2014-03-19','11:45:00',2.84),('8348','2014-03-19','11:50:00',4.46),('8348','2014-03-19','11:55:00',5.13),('8348','2014-03-19','12:00:00',7.22),('8348','2014-03-19','12:05:00',7.28),('8348','2014-03-19','12:10:00',7.15),('8348','2014-03-19','12:15:00',7.35),('8348','2014-03-19','12:20:00',7.24),('8348','2014-03-19','12:25:00',4.1),('8348','2014-03-19','12:30:00',3.44),('8348','2014-03-19','12:35:00',5.95),('8348','2014-03-19','12:40:00',6.91),('8348','2014-03-19','12:45:00',4.52),('8348','2014-03-19','12:50:00',4.14),('8348','2014-03-19','12:55:00',7.08),('8348','2014-03-19','13:00:00',6.6),('8348','2014-03-19','13:05:00',6.22),('8348','2014-03-19','13:10:00',6.53),('8348','2014-03-19','13:15:00',6.37),('8348','2014-03-19','13:20:00',4.79),('8348','2014-03-19','13:25:00',5.47),('8348','2014-03-19','13:30:00',6.28),('8348','2014-03-19','13:35:00',6.31),('8348','2014-03-19','13:40:00',6.2),('8348','2014-03-19','13:45:00',6.2),('8348','2014-03-19','13:50:00',5.99),('8348','2014-03-19','13:55:00',6.11),('8348','2014-03-19','14:00:00',6.1),('8348','2014-03-19','14:05:00',6.04),('8348','2014-03-19','14:10:00',5.8),('8348','2014-03-19','14:15:00',5.7),('8348','2014-03-19','14:20:00',5.7),('8348','2014-03-19','14:25:00',5.7),('8348','2014-03-19','14:30:00',5.5),('8348','2014-03-19','14:35:00',5.6),('8348','2014-03-19','14:40:00',5.46),('8348','2014-03-19','14:45:00',5.4),('8348','2014-03-19','14:50:00',5.33),('8348','2014-03-19','14:55:00',5.16),('8348','2014-03-19','15:00:00',5.04),('8348','2014-03-19','15:05:00',4.94),('8348','2014-03-19','15:10:00',4.87),('8348','2014-03-19','15:15:00',4.9),('8348','2014-03-19','15:20:00',4.69),('8348','2014-03-19','15:25:00',4.63),('8348','2014-03-19','15:30:00',4.48),('8348','2014-03-19','15:35:00',4.23),('8348','2014-03-19','15:40:00',4.24),('8348','2014-03-19','15:45:00',4.12),('8348','2014-03-19','15:50:00',3.96),('8348','2014-03-19','15:55:00',3.84),('8348','2014-03-19','16:00:00',3.66),('8348','2014-03-19','16:05:00',3.52),('8348','2014-03-19','16:10:00',3.42),('8348','2014-03-19','16:15:00',3.24),('8348','2014-03-19','16:20:00',3.05),('8348','2014-03-19','16:25:00',2.83),('8348','2014-03-19','16:30:00',2.7),('8348','2014-03-19','16:35:00',2.41),('8348','2014-03-19','16:40:00',2.26),('8348','2014-03-19','16:45:00',2.16),('8348','2014-03-19','16:50:00',1.82),('8348','2014-03-19','16:55:00',1.71),('8348','2014-03-19','17:00:00',1.34),('8348','2014-03-19','17:05:00',1.14),('8348','2014-03-19','17:10:00',1),('8348','2014-03-19','17:15:00',1.09),('8348','2013-01-11','10:05:00',1.25),('8348','2013-01-11','10:10:00',1.06),('8348','2013-01-11','10:15:00',1.55),('8348','2013-01-11','10:20:00',1.16),('8348','2013-01-11','10:25:00',1.58),('8348','2013-01-11','10:30:00',1.51),('8348','2013-01-11','10:35:00',1.57),('8348','2013-01-11','10:40:00',1.61),('8348','2013-01-11','10:45:00',1.66),('8348','2013-01-11','10:50:00',1.69),('8348','2013-01-11','10:55:00',1.73),('8348','2013-01-11','11:00:00',1.75),('8348','2013-01-11','11:05:00',1.78),('8348','2013-01-11','11:10:00',1.82),('8348','2013-01-11','11:15:00',1.83),('8348','2013-01-11','11:20:00',1.82),('8348','2013-01-11','11:25:00',1.23),('8348','2013-01-11','11:30:00',1.02),('8348','2013-01-11','11:35:00',1.2),('8348','2013-01-11','11:40:00',1.14),('8348','2013-01-11','11:45:00',1.25),('8348','2013-01-11','11:50:00',1.21),('8348','2013-01-11','11:55:00',1.09),('8348','2013-01-11','12:55:00',1.32),('8348','2013-01-11','13:00:00',1.17),('8348','2013-01-11','13:10:00',1.61),('8348','2013-01-11','13:35:00',1.98),('8348','2013-01-11','13:40:00',1.32),('8348','2013-01-11','13:45:00',1.82),('8348','2013-01-11','14:20:00',1.17),('8348','2013-01-11','14:25:00',1.02),('8348','2013-01-11','14:45:00',1.24),('8348','2013-01-11','14:50:00',1.47),('8348','2013-01-11','14:55:00',1.31),('8348','2013-01-11','15:00:00',1.4),('8348','2013-01-11','15:05:00',1.25),('8348','2013-01-10','11:55:00',1.05),('8348','2013-01-10','12:00:00',1.09),('8348','2013-01-10','12:05:00',1.06),('8348','2013-01-09','10:50:00',1.04),('8348','2013-01-09','10:55:00',1.1),('8348','2013-01-09','11:10:00',1.44),('8348','2013-01-09','11:15:00',1.71),('8348','2013-01-09','11:20:00',1.19),('8348','2013-01-09','11:25:00',1.04),('8348','2013-01-09','11:30:00',1.01),('8348','2013-01-09','11:35:00',1.08),('8348','2013-01-09','11:40:00',1.01),('8348','2013-01-09','11:50:00',1.05),('8348','2013-01-09','11:55:00',1.25),('8348','2013-01-09','12:00:00',1.01),('8348','2013-01-09','12:05:00',1.02),('8348','2013-01-09','12:10:00',1.02),('8348','2013-01-09','12:15:00',1.01),('8348','2013-01-09','12:20:00',1.02),('8348','2013-01-09','12:55:00',1.05),('8348','2013-01-09','13:00:00',1.07),('8348','2013-01-09','13:05:00',1.08),('8348','2013-01-09','13:10:00',1.16),('8348','2013-01-09','13:15:00',1.19),('8348','2013-01-08','09:25:00',1.03),('8348','2013-01-08','09:40:00',1.16),('8348','2013-01-08','09:45:00',1.37),('8348','2013-01-08','09:50:00',1.47),('8348','2013-01-08','09:55:00',1.47),('8348','2013-01-08','10:00:00',1.4),('8348','2013-01-08','10:05:00',1.3),('8348','2013-01-08','10:10:00',1.33),('8348','2013-01-08','10:15:00',1.33),('8348','2013-01-08','10:20:00',1.27),('8348','2013-01-08','10:25:00',1.4),('8348','2013-01-08','10:30:00',1.41),('8348','2013-01-08','10:35:00',1.52),('8348','2013-01-08','10:40:00',1.66),('8348','2013-01-08','10:45:00',1.63),('8348','2013-01-08','10:50:00',1.62),('8348','2013-01-08','10:55:00',1.68),('8348','2013-01-08','11:00:00',1.69),('8348','2013-01-08','11:05:00',1.77),('8348','2013-01-08','11:10:00',1.8),('8348','2013-01-08','11:15:00',1.83),('8348','2013-01-08','11:20:00',1.86),('8348','2013-01-08','11:25:00',1.88),('8348','2013-01-08','11:30:00',1.93),('8348','2013-01-08','11:35:00',1.95),('8348','2013-01-08','11:40:00',1.98),('8348','2013-01-08','11:45:00',2.37),('8348','2013-01-08','11:50:00',1.7),('8348','2013-01-08','11:55:00',1.44),('8348','2013-01-08','12:00:00',1.36),('8348','2013-01-08','12:05:00',1.3),('8348','2013-01-08','12:10:00',1.4),('8348','2013-01-08','12:15:00',1.29),('8348','2013-01-08','12:20:00',1.14),('8348','2013-01-08','12:25:00',1.1),('8348','2013-01-08','12:30:00',1.06),('8348','2013-01-08','12:35:00',1.03),('8348','2013-01-08','12:40:00',1.31),('8348','2013-01-08','12:45:00',1.59),('8348','2013-01-08','12:50:00',1.79),('8348','2013-01-08','12:55:00',1.23),('8348','2013-01-08','13:20:00',1.09),('8348','2013-01-08','13:45:00',1.31),('8348','2013-01-08','13:50:00',1.19),('8348','2013-01-08','13:55:00',1.28),('8348','2013-01-08','14:05:00',1.21),('8348','2013-01-07','09:35:00',1),('8348','2013-01-07','09:40:00',1.04),('8348','2013-01-07','09:45:00',1.1),('8348','2013-01-07','09:50:00',1.15),('8348','2013-01-07','09:55:00',1.22),('8348','2013-01-07','10:00:00',1.29),('8348','2013-01-07','10:05:00',1.36),('8348','2013-01-07','10:10:00',1.43),('8348','2013-01-07','10:15:00',1.49),('8348','2013-01-07','10:20:00',1.53),('8348','2013-01-07','10:25:00',1.55),('8348','2013-01-07','10:30:00',1.58),('8348','2013-01-07','10:35:00',1.61),('8348','2013-01-07','10:40:00',1.66),('8348','2013-01-07','10:45:00',1.7),('8348','2013-01-07','10:50:00',1.71),('8348','2013-01-07','10:55:00',1.72),('8348','2013-01-07','11:00:00',1.75),('8348','2013-01-07','11:05:00',1.77),('8348','2013-01-07','11:10:00',1.81),('8348','2013-01-07','11:15:00',1.83),('8348','2013-01-07','11:20:00',1.86),('8348','2013-01-07','11:25:00',1.88),('8348','2013-01-07','11:30:00',1.84),('8348','2013-01-07','11:35:00',1.91),('8348','2013-01-07','11:40:00',1.93),('8348','2013-01-07','11:45:00',1.93),('8348','2013-01-07','11:50:00',1.96),('8348','2013-01-07','11:55:00',1.96),('8348','2013-01-07','12:00:00',1.97),('8348','2013-01-07','12:05:00',1.99),('8348','2013-01-07','12:10:00',1.99),('8348','2013-01-07','12:15:00',2),('8348','2013-01-07','12:20:00',2),('8348','2013-01-07','12:25:00',2),('8348','2013-01-07','12:30:00',2.02),('8348','2013-01-07','12:35:00',2.02),('8348','2013-01-07','12:40:00',2),('8348','2013-01-07','12:45:00',2),('8348','2013-01-07','12:50:00',1.97),('8348','2013-01-07','12:55:00',1.95),('8348','2013-01-07','13:00:00',1.96),('8348','2013-01-07','13:05:00',1.95),('8348','2013-01-07','13:10:00',1.92),('8348','2013-01-07','13:15:00',1.9),('8348','2013-01-07','13:20:00',1.87),('8348','2013-01-07','13:25:00',1.88),('8348','2013-01-07','13:30:00',1.85),('8348','2013-01-07','13:35:00',1.81),('8348','2013-01-07','13:40:00',1.81),('8348','2013-01-07','13:45:00',1.77),('8348','2013-01-07','13:50:00',1.73),('8348','2013-01-07','13:55:00',1.7),('8348','2013-01-07','14:00:00',1.71),('8348','2013-01-07','14:05:00',1.67),('8348','2013-01-07','14:10:00',1.62),('8348','2013-01-07','14:15:00',1.59),('8348','2013-01-07','14:20:00',1.57),('8348','2013-01-07','14:25:00',1.53),('8348','2013-01-07','14:30:00',1.48),('8348','2013-01-07','14:35:00',1.43),('8348','2013-01-07','14:40:00',1.4),('8348','2013-01-07','14:45:00',1.34),('8348','2013-01-07','14:50:00',1.31),('8348','2013-01-07','14:55:00',1.23),('8348','2013-01-07','15:00:00',1.19),('8348','2013-01-07','15:05:00',1.13),('8348','2013-01-07','15:10:00',1.05),('8348','2013-01-06','09:35:00',1.01),('8348','2013-01-06','09:40:00',1.07),('8348','2013-01-06','09:45:00',1.12),('8348','2013-01-06','09:50:00',1.18),('8348','2013-01-06','09:55:00',1.21),('8348','2013-01-06','10:00:00',1.28),('8348','2013-01-06','10:05:00',1.32),('8348','2013-01-06','10:10:00',1.37),('8348','2013-01-06','10:15:00',1.41),('8348','2013-01-06','10:20:00',1.45),('8348','2013-01-06','10:25:00',1.5),('8348','2013-01-06','10:30:00',1.55),('8348','2013-01-06','10:35:00',1.6),('8348','2013-01-06','10:40:00',1.64),('8348','2013-01-06','10:45:00',1.67),('8348','2013-01-06','10:50:00',1.7),('8348','2013-01-06','10:55:00',1.73),('8348','2013-01-06','11:00:00',1.67),('8348','2013-01-06','11:05:00',1.79),('8348','2013-01-06','11:10:00',1.8),('8348','2013-01-06','11:15:00',1.83),('8348','2013-01-06','11:20:00',1.86),('8348','2013-01-06','11:25:00',1.89),('8348','2013-01-06','11:30:00',1.91),('8348','2013-01-06','11:35:00',1.93),('8348','2013-01-06','11:40:00',1.94),('8348','2013-01-06','11:45:00',1.95),('8348','2013-01-06','11:50:00',1.98),('8348','2013-01-06','11:55:00',1.99),('8348','2013-01-06','12:00:00',2),('8348','2013-01-06','12:05:00',2),('8348','2013-01-06','12:10:00',2),('8348','2013-01-06','12:15:00',2),('8348','2013-01-06','12:20:00',1.99),('8348','2013-01-06','12:25:00',1.98),('8348','2013-01-06','12:30:00',1.98),('8348','2013-01-06','12:35:00',1.95),('8348','2013-01-06','12:40:00',1.97),('8348','2013-01-06','12:45:00',2),('8348','2013-01-06','12:50:00',2.03),('8348','2013-01-06','12:55:00',2.04),('8348','2013-01-06','13:00:00',2.03),('8348','2013-01-06','13:05:00',2.01),('8348','2013-01-06','13:10:00',2),('8348','2013-01-06','13:15:00',1.98),('8348','2013-01-06','13:20:00',1.97),('8348','2013-01-06','13:25:00',1.95),('8348','2013-01-06','13:30:00',1.94),('8348','2013-01-06','13:35:00',1.92),('8348','2013-01-06','13:40:00',1.88),('8348','2013-01-06','13:45:00',1.87),('8348','2013-01-06','13:50:00',1.81),('8348','2013-01-06','13:55:00',1.77),('8348','2013-01-06','14:00:00',1.78),('8348','2013-01-06','14:05:00',1.77),('8348','2013-01-06','14:10:00',1.63),('8348','2013-01-06','14:15:00',1.64),('8348','2013-01-06','14:20:00',1.62),('8348','2013-01-06','14:25:00',1.48),('8348','2013-01-06','14:30:00',1.48),('8348','2013-01-06','14:35:00',1.41),('8348','2013-01-06','14:40:00',1.35),('8348','2013-01-06','14:45:00',1.31),('8348','2013-01-06','14:50:00',1.26),('8348','2013-01-06','14:55:00',1.2),('8348','2013-01-06','15:00:00',1.14),('8348','2013-01-06','15:05:00',1.07),('8348','2013-01-06','15:10:00',1.01),('8348','2013-01-05','10:50:00',1.04),('8348','2013-01-05','10:55:00',1.63),('8348','2013-01-05','11:00:00',1.38),('8348','2013-01-05','11:05:00',1.65),('8348','2013-01-05','11:10:00',1.54),('8348','2013-01-05','11:15:00',1.32),('8348','2013-01-05','11:20:00',1.75),('8348','2013-01-05','11:25:00',1.86),('8348','2013-01-05','11:30:00',1.88),('8348','2013-01-05','11:35:00',1.79),('8348','2013-01-05','11:40:00',1.69),('8348','2013-01-05','11:45:00',1.71),('8348','2013-01-05','11:50:00',1.52),('8348','2013-01-05','11:55:00',1.4),('8348','2013-01-05','12:00:00',1.3),('8348','2013-01-05','12:05:00',1.29),('8348','2013-01-05','12:10:00',1.29),('8348','2013-01-05','12:15:00',1.31),('8348','2013-01-05','12:20:00',1.19),('8348','2013-01-05','12:25:00',1.02),('8348','2013-01-05','12:30:00',1.01),('8348','2013-01-05','12:35:00',1.36),('8348','2013-01-05','12:40:00',1.71),('8348','2013-01-05','12:45:00',1.88),('8348','2013-01-05','12:50:00',1.24),('8348','2013-01-05','12:55:00',1.05),('8348','2013-01-05','13:00:00',1.1),('8348','2013-01-05','13:05:00',1.05),('8348','2013-01-05','13:10:00',1),('8348','2013-01-05','13:30:00',1.57),('8348','2013-01-05','13:35:00',1.3),('8348','2013-01-05','13:55:00',1.05),('8348','2013-01-05','14:05:00',1.46),('8348','2013-01-05','14:10:00',1.26),('8348','2013-01-05','14:15:00',1.07),('8348','2013-01-05','14:30:00',1.04),('8348','2013-01-05','14:40:00',1.05),('8348','2013-01-05','14:45:00',1.14),('8348','2013-01-05','15:00:00',1.07),('8348','2013-01-04','09:55:00',1.11),('8348','2013-01-04','10:00:00',1.42),('8348','2013-01-04','10:05:00',1.49),('8348','2013-01-04','10:10:00',1.31),('8348','2013-01-04','10:15:00',1.48),('8348','2013-01-04','10:20:00',1.29),('8348','2013-01-04','10:25:00',1.5),('8348','2013-01-04','10:30:00',1.61),('8348','2013-01-04','10:35:00',1.66),('8348','2013-01-04','10:40:00',1.73),('8348','2013-01-04','10:45:00',1.83),('8348','2013-01-04','10:50:00',1.96),('8348','2013-01-04','10:55:00',2.06),('8348','2013-01-04','11:00:00',1.84),('8348','2013-01-04','11:05:00',1.18),('8348','2013-01-04','11:45:00',1.12),('8348','2013-01-04','11:50:00',1.89),('8348','2013-01-04','11:55:00',2.33),('8348','2013-01-04','12:00:00',2.43),('8348','2013-01-04','12:05:00',2.03),('8348','2013-01-04','12:10:00',1.6),('8348','2013-01-04','12:15:00',1.09),('8348','2013-01-04','12:30:00',1.63),('8348','2013-01-04','12:35:00',1.4),('8348','2013-01-04','12:40:00',2.05),('8348','2013-01-04','12:45:00',2.07),('8348','2013-01-04','12:50:00',2.05),('8348','2013-01-04','12:55:00',2.06),('8348','2013-01-04','13:00:00',2.01),('8348','2013-01-04','13:05:00',1.91),('8348','2013-01-04','13:10:00',1.51),('8348','2013-01-04','13:15:00',1.75),('8348','2013-01-04','13:20:00',1.83),('8348','2013-01-04','13:25:00',1.78),('8348','2013-01-04','13:30:00',1.73),('8348','2013-01-04','13:35:00',1.74),('8348','2013-01-04','13:40:00',1.69),('8348','2013-01-04','13:45:00',1.71),('8348','2013-01-04','13:50:00',1.65),('8348','2013-01-04','13:55:00',1.61),('8348','2013-01-04','14:00:00',1.58),('8348','2013-01-04','14:05:00',1.57),('8348','2013-01-04','14:10:00',1.53),('8348','2013-01-04','14:15:00',1.47),('8348','2013-01-04','14:20:00',1.43),('8348','2013-01-04','14:25:00',1.36),('8348','2013-01-04','14:30:00',1.38),('8348','2013-01-04','14:35:00',1.35),('8348','2013-01-04','14:40:00',1.25),('8348','2013-01-04','14:45:00',1.21),('8348','2013-01-04','14:50:00',1.2),('8348','2013-01-04','14:55:00',1.15),('8348','2013-01-04','15:00:00',1.09),('8348','2013-01-03','09:35:00',1.05),('8348','2013-01-03','09:40:00',1.16),('8348','2013-01-03','09:45:00',1.29),('8348','2013-01-03','09:50:00',1.44),('8348','2013-01-03','09:55:00',1.55),('8348','2013-01-03','10:00:00',1.64),('8348','2013-01-03','10:05:00',1.72),('8348','2013-01-03','10:10:00',1.6),('8348','2013-01-03','10:15:00',1.96),('8348','2013-01-03','10:20:00',1.63),('8348','2013-01-03','10:25:00',1.7),('8348','2013-01-03','10:30:00',1.51),('8348','2013-01-03','10:35:00',1.55),('8348','2013-01-03','10:40:00',1.41),('8348','2013-01-03','10:45:00',1.31),('8348','2013-01-03','10:50:00',1.29),('8348','2013-01-03','10:55:00',1.23),('8348','2013-01-03','11:00:00',1.35),('8348','2013-01-03','11:05:00',1.26),('8348','2013-01-03','11:10:00',1.23),('8348','2013-01-03','11:15:00',1.16),('8348','2013-01-03','11:20:00',1.03),('8348','2013-01-03','11:35:00',1.09),('8348','2013-01-03','11:40:00',1.97),('8348','2013-01-03','11:45:00',2.05),('8348','2013-01-03','11:50:00',2.02),('8348','2013-01-03','11:55:00',2),('8348','2013-01-03','12:00:00',2),('8348','2013-01-03','12:05:00',2.01),('8348','2013-01-03','12:10:00',2.01),('8348','2013-01-03','12:15:00',2.01),('8348','2013-01-03','12:20:00',2.02),('8348','2013-01-03','12:25:00',2.02),('8348','2013-01-03','12:30:00',2.03),('8348','2013-01-03','12:35:00',2.03),('8348','2013-01-03','12:40:00',2.02),('8348','2013-01-03','12:45:00',2.02),('8348','2013-01-03','12:50:00',2),('8348','2013-01-03','12:55:00',2),('8348','2013-01-03','13:00:00',1.98),('8348','2013-01-03','13:05:00',1.96),('8348','2013-01-03','13:10:00',1.95),('8348','2013-01-03','13:15:00',1.93),('8348','2013-01-03','13:20:00',1.9),('8348','2013-01-03','13:25:00',1.89),('8348','2013-01-03','13:30:00',1.86),('8348','2013-01-03','13:35:00',1.84),('8348','2013-01-03','13:40:00',1.82),('8348','2013-01-03','13:45:00',1.79),('8348','2013-01-03','13:50:00',1.76),('8348','2013-01-03','13:55:00',1.73),('8348','2013-01-03','14:00:00',1.7),('8348','2013-01-03','14:05:00',1.67),('8348','2013-01-03','14:10:00',1.63),('8348','2013-01-03','14:15:00',1.61),('8348','2013-01-03','14:20:00',1.57),('8348','2013-01-03','14:25:00',1.52),('8348','2013-01-03','14:30:00',1.48),('8348','2013-01-03','14:35:00',1.43),('8348','2013-01-03','14:40:00',1.37),('8348','2013-01-03','14:45:00',1.33),('8348','2013-01-03','14:50:00',1.28),('8348','2013-01-03','14:55:00',1.23),('8348','2013-01-03','15:00:00',1.17),('8348','2013-01-03','15:05:00',1.11),('8348','2013-01-03','15:10:00',1.05),('8348','2014-03-18','07:45:00',1.04),('8348','2014-03-18','07:50:00',1.24),('8348','2014-03-18','07:55:00',1.73),('8348','2014-03-18','08:00:00',1.6),('8348','2014-03-18','08:05:00',1.35),('8348','2014-03-18','08:10:00',1.4),('8348','2014-03-18','08:15:00',1.42),('8348','2014-03-18','08:20:00',2.13),('8348','2014-03-18','08:25:00',1.95),('8348','2014-03-18','08:30:00',1.79),('8348','2014-03-18','08:35:00',1.63),('8348','2014-03-18','08:40:00',1.46),('8348','2014-03-18','08:45:00',1.4),('8348','2014-03-18','08:50:00',1.85),('8348','2014-03-18','08:55:00',4.02),('8348','2014-03-18','09:00:00',3.82),('8348','2014-03-18','09:05:00',3.38),('8348','2014-03-18','09:10:00',2.59),('8348','2014-03-18','09:15:00',3.26),('8348','2014-03-18','09:20:00',4.51),('8348','2014-03-18','09:25:00',3.88),('8348','2014-03-18','09:30:00',2.39),('8348','2014-03-18','09:35:00',2.93),('8348','2014-03-18','09:40:00',2.66),('8348','2014-03-18','09:45:00',2.36),('8348','2014-03-18','09:50:00',3.57),('8348','2014-03-18','09:55:00',3.71),('8348','2014-03-18','10:00:00',3.55),('8348','2014-03-18','10:05:00',5.33),('8348','2014-03-18','10:10:00',5.85),('8348','2014-03-18','10:15:00',5.96),('8348','2014-03-18','10:20:00',4.24),('8348','2014-03-18','10:25:00',3.05),('8348','2014-03-18','10:30:00',4.04),('8348','2014-03-18','10:35:00',5.56),('8348','2014-03-18','10:40:00',4.48),('8348','2014-03-18','10:45:00',4.75),('8348','2014-03-18','10:50:00',3.44),('8348','2014-03-18','10:55:00',6.23),('8348','2014-03-18','11:00:00',4.77),('8348','2014-03-18','11:05:00',4.17),('8348','2014-03-18','11:10:00',3.22),('8348','2014-03-18','11:15:00',2.3),('8348','2014-03-18','11:20:00',2.94),('8348','2014-03-18','11:25:00',3.42),('8348','2014-03-18','11:30:00',7.48),('8348','2014-03-18','11:35:00',7.57),('8348','2014-03-18','11:40:00',6.23),('8348','2014-03-18','11:45:00',4.31),('8348','2014-03-18','11:50:00',4.25),('8348','2014-03-18','11:55:00',2.82),('8348','2014-03-18','12:00:00',3.11),('8348','2014-03-18','12:05:00',3.28),('8348','2014-03-18','12:10:00',6.09),('8348','2014-03-18','12:15:00',6.47),('8348','2014-03-18','12:20:00',3.74),('8348','2014-03-18','12:25:00',2.81),('8348','2014-03-18','12:30:00',5.1),('8348','2014-03-18','12:35:00',5.92),('8348','2014-03-18','12:40:00',4.96),('8348','2014-03-18','12:45:00',5.62),('8348','2014-03-18','12:50:00',6.45),('8348','2014-03-18','12:55:00',5.97),('8348','2014-03-18','13:00:00',6.7),('8348','2014-03-18','13:05:00',6.68),('8348','2014-03-18','13:10:00',6.65),('8348','2014-03-18','13:15:00',6.57),('8348','2014-03-18','13:20:00',6.34),('8348','2014-03-18','13:25:00',5.78),('8348','2014-03-18','13:30:00',6.18),('8348','2014-03-18','13:35:00',6.38),('8348','2014-03-18','13:40:00',6.23),('8348','2014-03-18','13:45:00',6.22),('8348','2014-03-18','13:50:00',6.19),('8348','2014-03-18','13:55:00',6.2),('8348','2014-03-18','14:00:00',6.13),('8348','2014-03-18','14:05:00',6.09),('8348','2014-03-18','14:10:00',5.99),('8348','2014-03-18','14:15:00',5.91),('8348','2014-03-18','14:20:00',5.89),('8348','2014-03-18','14:25:00',5.8),('8348','2014-03-18','14:30:00',5.7),('8348','2014-03-18','14:35:00',5.63),('8348','2014-03-18','14:40:00',5.52),('8348','2014-03-18','14:45:00',5.42),('8348','2014-03-18','14:50:00',5.37),('8348','2014-03-18','14:55:00',5.25),('8348','2014-03-18','15:00:00',5.11),('8348','2014-03-18','15:05:00',5.06),('8348','2014-03-18','15:10:00',4.98),('8348','2014-03-18','15:15:00',4.86),('8348','2014-03-18','15:20:00',4.71),('8348','2014-03-18','15:25:00',4.61),('8348','2014-03-18','15:30:00',4.53),('8348','2014-03-18','15:35:00',4.37),('8348','2014-03-18','15:40:00',4.23),('8348','2014-03-18','15:45:00',4.08),('8348','2014-03-18','15:50:00',3.88),('8348','2014-03-18','15:55:00',3.8),('8348','2014-03-18','16:00:00',3.66),('8348','2014-03-18','16:05:00',3.42),('8348','2014-03-18','16:10:00',3.34),('8348','2014-03-18','16:15:00',3.24),('8348','2014-03-18','16:20:00',3.04),('8348','2014-03-18','16:25:00',2.89),('8348','2014-03-18','16:30:00',2.75),('8348','2014-03-18','16:35:00',2.55),('8348','2014-03-18','16:40:00',2.4),('8348','2014-03-18','16:45:00',2.16),('8348','2014-03-18','16:50:00',2.02),('8348','2014-03-18','16:55:00',1.84),('8348','2014-03-18','17:00:00',1.81),('8348','2014-03-18','17:05:00',1.59),('8348','2014-03-18','17:10:00',1.42),('8348','2014-03-18','17:15:00',1.22),('8348','2014-03-18','17:20:00',1.04),('8348','2013-01-01','09:40:00',1.02),('8348','2013-01-01','09:45:00',1.08),('8348','2013-01-01','09:50:00',1.14),('8348','2013-01-01','09:55:00',1.19),('8348','2013-01-01','10:00:00',1.23),('8348','2013-01-01','10:05:00',1.26),('8348','2013-01-01','10:10:00',1.3),('8348','2013-01-01','10:15:00',1.36),('8348','2013-01-01','10:20:00',1.39),('8348','2013-01-01','10:25:00',1.44),('8348','2013-01-01','10:30:00',1.49),('8348','2013-01-01','10:35:00',1.53),('8348','2013-01-01','10:40:00',1.63),('8348','2013-01-01','10:45:00',1.54),('8348','2013-01-01','10:50:00',1.57),('8348','2013-01-01','11:05:00',1.87),('8348','2013-01-01','11:10:00',1.81),('8348','2013-01-01','11:15:00',1.58),('8348','2013-01-01','11:20:00',1.32),('8348','2013-01-01','11:25:00',1.61),('8348','2013-01-01','11:30:00',1.83),('8348','2013-01-01','11:35:00',1.1),('8348','2013-01-01','11:40:00',1.39),('8348','2013-01-01','11:45:00',1.92),('8348','2013-01-01','11:50:00',1.77),('8348','2013-01-01','11:55:00',1.58),('8348','2013-01-01','12:00:00',1.06),('8348','2013-01-01','12:10:00',1.13),('8348','2013-01-01','12:15:00',1.03),('8348','2013-01-01','12:20:00',1.17),('8348','2013-01-01','12:25:00',1.04),('8348','2013-01-01','12:45:00',1.09),('8348','2013-01-01','12:50:00',1.01),('8348','2012-12-31','10:10:00',1.17),('8348','2012-12-31','10:15:00',1.54),('8348','2012-12-31','10:20:00',1.57),('8348','2012-12-31','10:25:00',1.59),('8348','2012-12-31','10:30:00',1.62),('8348','2012-12-31','10:35:00',1.65),('8348','2012-12-31','10:40:00',1.68),('8348','2012-12-31','10:45:00',1.67),('8348','2012-12-31','10:50:00',1.69),('8348','2012-12-31','10:55:00',1.75),('8348','2012-12-31','11:00:00',1.79),('8348','2012-12-31','11:05:00',1.78),('8348','2012-12-31','11:10:00',1.74),('8348','2012-12-31','11:15:00',1.82),('8348','2012-12-31','11:20:00',1.89),('8348','2012-12-31','11:25:00',1.91),('8348','2012-12-31','11:30:00',1.94),('8348','2012-12-31','11:35:00',1.97),('8348','2012-12-31','11:40:00',1.98),('8348','2012-12-31','11:45:00',2),('8348','2012-12-31','11:50:00',2.01),('8348','2012-12-31','11:55:00',2.02),('8348','2012-12-31','12:00:00',2.04),('8348','2012-12-31','12:05:00',2.07),('8348','2012-12-31','12:10:00',2.07),('8348','2012-12-31','12:15:00',2.08),('8348','2012-12-31','12:20:00',2.08),('8348','2012-12-31','12:25:00',2.08),('8348','2012-12-31','12:30:00',2.08),('8348','2012-12-31','12:35:00',2.07),('8348','2012-12-31','12:40:00',2.07),('8348','2012-12-31','12:45:00',2.07),('8348','2012-12-31','12:50:00',2.06),('8348','2012-12-31','12:55:00',2.04),('8348','2012-12-31','13:00:00',2.02),('8348','2012-12-31','13:05:00',2),('8348','2012-12-31','13:10:00',1.99),('8348','2012-12-31','13:15:00',1.97),('8348','2012-12-31','13:20:00',1.95),('8348','2012-12-31','13:25:00',1.92),('8348','2012-12-31','13:30:00',1.91),('8348','2012-12-31','13:35:00',1.88),('8348','2012-12-31','13:40:00',1.85),('8348','2012-12-31','13:45:00',1.82),('8348','2012-12-31','13:50:00',1.78),('8348','2012-12-31','13:55:00',1.74),('8348','2012-12-31','14:00:00',1.71),('8348','2012-12-31','14:05:00',1.69),('8348','2012-12-31','14:10:00',1.64),('8348','2012-12-31','14:15:00',1.6),('8348','2012-12-31','14:20:00',1.55),('8348','2012-12-31','14:25:00',1.51),('8348','2012-12-31','14:30:00',1.48),('8348','2012-12-31','14:35:00',1.43),('8348','2012-12-31','14:40:00',1.39),('8348','2012-12-31','14:45:00',1.34),('8348','2012-12-31','14:50:00',1.29),('8348','2012-12-31','14:55:00',1.23),('8348','2012-12-31','15:00:00',1.16),('8348','2012-12-31','15:05:00',1.11),('8348','2012-12-31','15:10:00',1.05),('8348','2012-12-30','09:35:00',1.02),('8348','2012-12-30','09:40:00',1.07),('8348','2012-12-30','09:45:00',1.11),('8348','2012-12-30','09:50:00',1.17),('8348','2012-12-30','09:55:00',1.22),('8348','2012-12-30','10:00:00',1.26),('8348','2012-12-30','10:05:00',1.31),('8348','2012-12-30','10:10:00',1.36),('8348','2012-12-30','10:15:00',1.41),('8348','2012-12-30','10:20:00',1.45),('8348','2012-12-30','10:25:00',1.49),('8348','2012-12-30','10:30:00',1.54),('8348','2012-12-30','10:35:00',1.58),('8348','2012-12-30','10:40:00',1.62),('8348','2012-12-30','10:45:00',1.66),('8348','2012-12-30','10:50:00',1.69),('8348','2012-12-30','10:55:00',1.73),('8348','2012-12-30','11:00:00',1.75),('8348','2012-12-30','11:05:00',1.79),('8348','2012-12-30','11:10:00',1.81),('8348','2012-12-30','11:15:00',1.84),('8348','2012-12-30','11:20:00',1.86),('8348','2012-12-30','11:25:00',1.88),('8348','2012-12-30','11:30:00',1.89),('8348','2012-12-30','11:35:00',1.92),('8348','2012-12-30','11:40:00',1.93),('8348','2012-12-30','11:45:00',1.96),('8348','2012-12-30','11:50:00',1.98),('8348','2012-12-30','11:55:00',1.99),('8348','2012-12-30','12:00:00',1.99),('8348','2012-12-30','12:05:00',2),('8348','2012-12-30','12:10:00',2.02),('8348','2012-12-30','12:15:00',2.03),('8348','2012-12-30','12:20:00',2.02),('8348','2012-12-30','12:25:00',2),('8348','2012-12-30','12:30:00',1.98),('8348','2012-12-30','12:35:00',1.98),('8348','2012-12-30','12:40:00',1.98),('8348','2012-12-30','12:45:00',1.97),('8348','2012-12-30','12:50:00',1.96),('8348','2012-12-30','12:55:00',1.97),('8348','2012-12-30','13:00:00',2),('8348','2012-12-30','13:05:00',1.99),('8348','2012-12-30','13:10:00',1.98),('8348','2012-12-30','13:15:00',1.97),('8348','2012-12-30','13:20:00',1.95),('8348','2012-12-30','13:25:00',1.94),('8348','2012-12-30','13:30:00',1.92),('8348','2012-12-30','13:35:00',1.89),('8348','2012-12-30','13:40:00',1.86),('8348','2012-12-30','13:45:00',1.83),('8348','2012-12-30','13:50:00',1.8),('8348','2012-12-30','13:55:00',1.77),('8348','2012-12-30','14:00:00',1.75),('8348','2012-12-30','14:05:00',1.7),('8348','2012-12-30','14:10:00',1.66),('8348','2012-12-30','14:15:00',1.63),('8348','2012-12-30','14:20:00',1.58),('8348','2012-12-30','14:25:00',1.54),('8348','2012-12-30','14:30:00',1.48),('8348','2012-12-30','14:35:00',1.44),('8348','2012-12-30','14:40:00',1.39),('8348','2012-12-30','14:45:00',1.33),('8348','2012-12-30','14:50:00',1.27),('8348','2012-12-30','14:55:00',1.22),('8348','2012-12-30','15:00:00',1.16),('8348','2012-12-30','15:05:00',1.09),('8348','2012-12-30','15:10:00',1.04),('8348','2012-12-29','09:40:00',1.05),('8348','2012-12-29','09:45:00',1.11),('8348','2012-12-29','09:50:00',1.17),('8348','2012-12-29','09:55:00',1.23),('8348','2012-12-29','10:00:00',1.28),('8348','2012-12-29','10:05:00',1.34),('8348','2012-12-29','10:10:00',1.38),('8348','2012-12-29','10:15:00',1.44),('8348','2012-12-29','10:20:00',1.48),('8348','2012-12-29','10:25:00',1.52),('8348','2012-12-29','10:30:00',1.56),('8348','2012-12-29','10:35:00',1.6),('8348','2012-12-29','10:40:00',1.64),('8348','2012-12-29','10:45:00',1.68),('8348','2012-12-29','10:50:00',1.73),('8348','2012-12-29','10:55:00',1.77),('8348','2012-12-29','11:00:00',1.79),('8348','2012-12-29','11:05:00',1.82),('8348','2012-12-29','11:10:00',1.84),('8348','2012-12-29','11:15:00',1.88),('8348','2012-12-29','11:20:00',1.91),('8348','2012-12-29','11:25:00',1.93),('8348','2012-12-29','11:30:00',1.94),('8348','2012-12-29','11:35:00',1.98),('8348','2012-12-29','11:40:00',1.97),('8348','2012-12-29','11:45:00',2),('8348','2012-12-29','11:50:00',2.01),('8348','2012-12-29','11:55:00',2.02),('8348','2012-12-29','12:00:00',2.05),('8348','2012-12-29','12:05:00',2.07),('8348','2012-12-29','12:10:00',2.09),('8348','2012-12-29','12:15:00',2.07),('8348','2012-12-29','12:20:00',2.05),('8348','2012-12-29','12:25:00',2.03),('8348','2012-12-29','12:30:00',2.04),('8348','2012-12-29','12:35:00',2.04),('8348','2012-12-29','12:40:00',2.06),('8348','2012-12-29','12:45:00',2.04),('8348','2012-12-29','12:50:00',2.02),('8348','2012-12-29','12:55:00',2.01),('8348','2012-12-29','13:00:00',2.03),('8348','2012-12-29','13:05:00',2.03),('8348','2012-12-29','13:10:00',2),('8348','2012-12-29','13:15:00',2),('8348','2012-12-29','13:20:00',1.98),('8348','2012-12-29','13:25:00',1.95),('8348','2012-12-29','13:30:00',1.92),('8348','2012-12-29','13:35:00',1.9),('8348','2012-12-29','13:40:00',1.88),('8348','2012-12-29','13:45:00',1.85),('8348','2012-12-29','13:50:00',1.82),('8348','2012-12-29','13:55:00',1.78),('8348','2012-12-29','14:00:00',1.75),('8348','2012-12-29','14:05:00',1.71),('8348','2012-12-29','14:10:00',1.67),('8348','2012-12-29','14:15:00',1.64),('8348','2012-12-29','14:20:00',1.6),('8348','2012-12-29','14:25:00',1.55),('8348','2012-12-29','14:30:00',1.5),('8348','2012-12-29','14:35:00',1.44),('8348','2012-12-29','14:40:00',1.4),('8348','2012-12-29','14:45:00',1.36),('8348','2012-12-29','14:50:00',1.31),('8348','2012-12-29','14:55:00',1.25),('8348','2012-12-29','15:00:00',1.19),('8348','2012-12-29','15:05:00',1.14),('8348','2012-12-29','15:10:00',1.08),('8348','2012-12-29','15:15:00',1.01),('8348','2012-12-28','09:45:00',1.05),('8348','2012-12-28','09:50:00',1.06),('8348','2012-12-28','09:55:00',1.12),('8348','2012-12-28','10:00:00',1.18),('8348','2012-12-28','10:05:00',1.24),('8348','2012-12-28','10:10:00',1.3),('8348','2012-12-28','10:15:00',1.35),('8348','2012-12-28','10:20:00',1.39),('8348','2012-12-28','10:25:00',1.44),('8348','2012-12-28','10:30:00',1.46),('8348','2012-12-28','10:35:00',1.53),('8348','2012-12-28','10:40:00',1.56),('8348','2012-12-28','10:45:00',1.59),('8348','2012-12-28','10:50:00',1.63),('8348','2012-12-28','10:55:00',1.68),('8348','2012-12-28','11:00:00',1.69),('8348','2012-12-28','11:05:00',1.75),('8348','2012-12-28','11:10:00',1.8),('8348','2012-12-28','11:15:00',1.81),('8348','2012-12-28','11:20:00',1.81),('8348','2012-12-28','11:25:00',1.86),('8348','2012-12-28','11:30:00',1.8),('8348','2012-12-28','11:35:00',1.92),('8348','2012-12-28','11:40:00',1.93),('8348','2012-12-28','11:45:00',1.89),('8348','2012-12-28','11:50:00',1.97),('8348','2012-12-28','11:55:00',1.97),('8348','2012-12-28','12:00:00',1.52),('8348','2012-12-28','12:05:00',1.83),('8348','2012-12-28','12:10:00',1.99),('8348','2012-12-28','12:15:00',1.99),('8348','2012-12-28','12:20:00',2.01),('8348','2012-12-28','12:25:00',1.98),('8348','2012-12-28','12:30:00',1.98),('8348','2012-12-28','12:35:00',1.97),('8348','2012-12-28','12:40:00',1.98),('8348','2012-12-28','12:45:00',1.97),('8348','2012-12-28','12:50:00',1.92),('8348','2012-12-28','12:55:00',1.77),('8348','2012-12-28','13:00:00',1.94),('8348','2012-12-28','13:05:00',1.92),('8348','2012-12-28','13:10:00',1.88),('8348','2012-12-28','13:15:00',1.86),('8348','2012-12-28','13:20:00',1.84),('8348','2012-12-28','13:25:00',1.83),('8348','2012-12-28','13:30:00',1.8),('8348','2012-12-28','13:35:00',1.77),('8348','2012-12-28','13:40:00',1.74),('8348','2012-12-28','13:45:00',1.7),('8348','2012-12-28','13:50:00',1.68),('8348','2012-12-28','13:55:00',1.6),('8348','2012-12-28','14:00:00',1.51),('8348','2012-12-28','14:05:00',1.48),('8348','2012-12-28','14:10:00',1.47),('8348','2012-12-28','14:15:00',1.45),('8348','2012-12-28','14:20:00',1.39),('8348','2012-12-28','14:25:00',1.35),('8348','2012-12-28','14:35:00',1.09),('8348','2012-12-28','14:40:00',1.19),('8348','2012-12-28','14:45:00',1.2),('8348','2012-12-28','14:50:00',1.15),('8348','2012-12-28','14:55:00',1.1),('8348','2012-12-28','15:00:00',1.07),('8348','2012-12-28','15:05:00',1.01),('8348','2012-12-27','09:35:00',1.13),('8348','2012-12-27','09:40:00',1.03),('8348','2012-12-27','09:45:00',1.19),('8348','2012-12-27','09:50:00',1.32),('8348','2012-12-27','10:15:00',1.23),('8348','2012-12-27','10:20:00',1.3),('8348','2012-12-27','10:25:00',1.37),('8348','2012-12-27','10:30:00',1.39),('8348','2012-12-27','10:35:00',1.45),('8348','2012-12-27','10:40:00',1.51),('8348','2012-12-27','10:45:00',1.56),('8348','2012-12-27','10:50:00',1.53),('8348','2012-12-27','10:55:00',1.6),('8348','2012-12-27','11:00:00',1.2),('8348','2012-12-27','11:05:00',1.61),('8348','2012-12-27','11:10:00',1.24),('8348','2012-12-27','11:50:00',1.7),('8348','2012-12-27','11:55:00',1.9),('8348','2012-12-27','12:00:00',1.99),('8348','2012-12-27','12:05:00',2.21),('8348','2012-12-27','12:10:00',2.26),('8348','2012-12-27','12:15:00',1.06),('8348','2012-12-27','12:20:00',1.62),('8348','2012-12-27','12:25:00',1.73),('8348','2012-12-27','12:30:00',1.93),('8348','2012-12-27','12:35:00',1.92),('8348','2012-12-27','12:40:00',2),('8348','2012-12-27','12:45:00',1.77),('8348','2012-12-27','12:50:00',1.68),('8348','2012-12-27','12:55:00',2.02),('8348','2012-12-27','13:00:00',1.98),('8348','2012-12-27','13:05:00',1.39),('8348','2012-12-27','13:10:00',1.26),('8348','2012-12-27','13:15:00',1.85),('8348','2012-12-27','13:20:00',1.14),('8348','2012-12-27','13:25:00',1.81),('8348','2012-12-27','13:30:00',1.75),('8348','2012-12-27','14:00:00',1.27),('8348','2012-12-27','14:05:00',1.46),('8348','2012-12-27','14:10:00',1.57),('8348','2012-12-27','14:15:00',1.55),('8348','2012-12-27','14:20:00',1.46),('8348','2012-12-27','14:25:00',1.42),('8348','2012-12-27','14:30:00',1.39),('8348','2012-12-27','14:35:00',1.36),('8348','2012-12-27','14:40:00',1.25),('8348','2012-12-27','15:00:00',1.15),('8348','2012-12-27','15:05:00',1.04),('8348','2012-12-26','09:40:00',1.02),('8348','2012-12-26','09:45:00',1.06),('8348','2012-12-26','09:50:00',1.11),('8348','2012-12-26','09:55:00',1.17),('8348','2012-12-26','10:00:00',1.22),('8348','2012-12-26','10:05:00',1.26),('8348','2012-12-26','10:10:00',1.3),('8348','2012-12-26','10:15:00',1.34),('8348','2012-12-26','10:20:00',1.37),('8348','2012-12-26','10:25:00',1.4),('8348','2012-12-26','10:30:00',1.44),('8348','2012-12-26','10:35:00',1.49),('8348','2012-12-26','10:40:00',1.52),('8348','2012-12-26','10:45:00',1.54),('8348','2012-12-26','10:50:00',1.57),('8348','2012-12-26','10:55:00',1.6),('8348','2012-12-26','11:00:00',1.63),('8348','2012-12-26','11:05:00',1.66),('8348','2012-12-26','11:10:00',1.68),('8348','2012-12-26','11:15:00',1.7),('8348','2012-12-26','11:20:00',1.74),('8348','2012-12-26','11:25:00',1.76),('8348','2012-12-26','11:30:00',1.77),('8348','2012-12-26','11:35:00',1.78),('8348','2012-12-26','11:40:00',1.82),('8348','2012-12-26','11:45:00',1.83),('8348','2012-12-26','11:50:00',1.88),('8348','2012-12-26','11:55:00',1.93),('8348','2012-12-26','12:00:00',1.97),('8348','2012-12-26','12:05:00',2.01),('8348','2012-12-26','12:10:00',2.01),('8348','2012-12-26','12:15:00',2.01),('8348','2012-12-26','12:20:00',2.02),('8348','2012-12-26','12:25:00',2.04),('8348','2012-12-26','12:30:00',2.03),('8348','2012-12-26','12:35:00',2.03),('8348','2012-12-26','12:40:00',2.05),('8348','2012-12-26','12:45:00',2.02),('8348','2012-12-26','12:50:00',1.97),('8348','2012-12-26','12:55:00',1.84),('8348','2012-12-26','13:00:00',2.05),('8348','2012-12-26','13:05:00',1.61),('8348','2012-12-26','13:10:00',2.07),('8348','2012-12-26','13:15:00',2.06),('8348','2012-12-26','13:20:00',2.16),('8348','2012-12-26','13:25:00',2.1),('8348','2012-12-26','13:30:00',2.36),('8348','2012-12-26','13:35:00',2.34),('8348','2012-12-26','13:40:00',2.29),('8348','2012-12-26','13:45:00',2.19),('8348','2012-12-26','13:50:00',1.95),('8348','2012-12-26','13:55:00',1.84),('8348','2012-12-26','14:00:00',1.65),('8348','2012-12-26','14:05:00',1.92),('8348','2012-12-26','14:10:00',1.09),('8348','2012-12-23','09:35:00',1.03),('8348','2012-12-23','09:40:00',1.08),('8348','2012-12-23','09:45:00',1.13),('8348','2012-12-23','09:50:00',1.18),('8348','2012-12-23','09:55:00',1.22),('8348','2012-12-23','10:00:00',1.26),('8348','2012-12-23','10:05:00',1.31),('8348','2012-12-23','10:10:00',1.35),('8348','2012-12-23','10:15:00',1.38),('8348','2012-12-23','10:20:00',1.42),('8348','2012-12-23','10:25:00',1.43),('8348','2012-12-23','10:30:00',1.44),('8348','2012-12-23','10:35:00',1.48),('8348','2012-12-23','10:40:00',1.55),('8348','2012-12-23','10:45:00',1.61),('8348','2012-12-23','10:50:00',1.62),('8348','2012-12-23','10:55:00',1.56),('8348','2012-12-23','11:00:00',1.68),('8348','2012-12-23','11:05:00',1.7),('8348','2012-12-23','11:10:00',1.72),('8348','2012-12-23','11:15:00',1.76),('8348','2012-12-23','11:20:00',1.82),('8348','2012-12-23','11:25:00',1.64),('8348','2012-12-23','11:30:00',1.77),('8348','2012-12-23','11:35:00',1.88),('8348','2012-12-23','11:40:00',1.89),('8348','2012-12-23','11:45:00',1.89),('8348','2012-12-23','11:50:00',1.94),('8348','2012-12-23','11:55:00',1.81),('8348','2012-12-23','12:00:00',1.7),('8348','2012-12-23','12:05:00',1.76),('8348','2012-12-23','12:10:00',1.77),('8348','2012-12-23','12:15:00',1.41),('8348','2012-12-23','12:20:00',1.04),('8348','2012-12-23','12:30:00',1.42),('8348','2012-12-23','12:35:00',1.12),('8348','2012-12-23','12:40:00',1.25),('8348','2012-12-23','12:50:00',1.31),('8348','2012-12-23','12:55:00',1.83),('8348','2012-12-23','13:00:00',1.89),('8348','2012-12-23','13:05:00',1.53),('8348','2012-12-23','13:10:00',1.68),('8348','2012-12-23','13:15:00',1.18),('8348','2012-12-23','13:20:00',1.03),('8348','2012-12-23','13:35:00',1.06),('8348','2012-12-23','13:40:00',1.31),('8348','2012-12-23','13:45:00',1.39),('8348','2012-12-23','13:50:00',1.22),('8348','2012-12-23','13:55:00',1.15),('8348','2012-12-23','14:00:00',1.67),('8348','2012-12-23','14:05:00',1.41),('8348','2012-12-23','14:10:00',1.33),('8348','2012-12-23','14:15:00',1.38),('8348','2012-12-23','14:20:00',1.08),('8348','2012-12-23','14:35:00',1.03),('8348','2012-12-23','14:40:00',1.18),('8348','2012-12-23','14:45:00',1.19),('8348','2014-05-01','06:40:00',1.14),('8348','2014-05-01','06:50:00',1.34),('8348','2014-05-01','06:55:00',1.58),('8348','2014-05-01','07:00:00',1.73),('8348','2014-05-01','07:05:00',1.79),('8348','2014-05-01','07:10:00',1.8),('8348','2014-05-01','07:15:00',1.95),('8348','2014-05-01','07:20:00',2.07),('8348','2014-05-01','07:25:00',2.2),('8348','2014-05-01','07:30:00',2.33),('8348','2014-05-01','07:35:00',2.47),('8348','2014-05-01','07:40:00',2.82),('8348','2014-05-01','07:45:00',3.19),('8348','2014-05-01','07:50:00',3.58),('8348','2014-05-01','07:55:00',4.2),('8348','2014-05-01','08:00:00',2.99),('8348','2014-05-01','08:05:00',1.83),('8348','2014-05-01','08:10:00',2.53),('8348','2014-05-01','08:15:00',2.88),('8348','2014-05-01','08:20:00',3.05),('8348','2014-05-01','08:25:00',4.51),('8348','2014-05-01','08:30:00',4.78),('8348','2014-05-01','08:35:00',4.93),('8348','2014-05-01','08:40:00',5.41),('8348','2014-05-01','08:45:00',2.98),('8348','2014-05-01','08:50:00',4.16),('8348','2014-05-01','08:55:00',3.06),('8348','2014-05-01','09:00:00',3.54),('8348','2014-05-01','09:05:00',4.21),('8348','2014-05-01','09:10:00',5.04),('8348','2014-05-01','09:15:00',4.04),('8348','2014-05-01','09:20:00',3.26),('8348','2014-05-01','09:25:00',4.91),('8348','2014-05-01','09:30:00',6.6),('8348','2014-05-01','09:35:00',5.39),('8348','2014-05-01','09:40:00',5.55),('8348','2014-05-01','09:45:00',6.63),('8348','2014-05-01','09:50:00',6.84),('8348','2014-05-01','09:55:00',7.6),('8348','2014-05-01','10:00:00',3.41),('8348','2014-05-01','10:05:00',5.05),('8348','2014-05-01','10:10:00',5.05),('8348','2014-05-01','10:15:00',6.76),('8348','2014-05-01','10:20:00',7.62),('8348','2014-05-01','10:25:00',7.62),('8348','2014-05-01','10:30:00',6.41),('8348','2014-05-01','10:35:00',7.72),('8348','2014-05-01','10:40:00',7.65),('8348','2014-05-01','10:45:00',7.13),('8348','2014-05-01','10:50:00',7.87),('8348','2014-05-01','10:55:00',6.44),('8348','2014-05-01','11:00:00',6.91),('8348','2014-05-01','11:05:00',5.52),('8348','2014-05-01','11:10:00',2.83),('8348','2014-05-01','11:15:00',4.48),('8348','2014-05-01','11:20:00',5.84),('8348','2014-05-01','11:25:00',6),('8348','2014-05-01','11:30:00',8.12),('8348','2014-05-01','11:35:00',8.11),('8348','2014-05-01','11:40:00',8.09),('8348','2014-05-01','11:45:00',5.21),('8348','2014-05-01','11:50:00',4.34),('8348','2014-05-01','11:55:00',8.62),('8348','2014-05-01','12:00:00',7.83),('8348','2014-05-01','12:05:00',8.25),('8348','2014-05-01','12:10:00',8.04),('8348','2014-05-01','12:15:00',6.01),('8348','2014-05-01','12:20:00',8.35),('8348','2014-05-01','12:25:00',4.8),('8348','2014-05-01','12:30:00',5.01),('8348','2014-05-01','12:35:00',7.86),('8348','2014-05-01','12:40:00',8.41),('8348','2014-05-01','12:45:00',8.51),('8348','2014-05-01','12:50:00',8.27),('8348','2014-05-01','12:55:00',6.61),('8348','2014-05-01','13:00:00',4.72),('8348','2014-05-01','13:05:00',6.91),('8348','2014-05-01','13:10:00',7.51),('8348','2014-05-01','13:15:00',8.03),('8348','2014-05-01','13:20:00',7.74),('8348','2014-05-01','13:25:00',7.86),('8348','2014-05-01','13:30:00',7.55),('8348','2014-05-01','13:35:00',6.87),('8348','2014-05-01','13:40:00',6.04),('8348','2014-05-01','13:45:00',7.38),('8348','2014-05-01','13:50:00',7.88),('8348','2014-05-01','13:55:00',5.76),('8348','2014-05-01','14:00:00',8.04),('8348','2014-05-01','14:05:00',7.97),('8348','2014-05-01','14:10:00',7.48),('8348','2014-05-01','14:15:00',7.49),('8348','2014-05-01','14:20:00',7.37),('8348','2014-05-01','14:25:00',7.19),('8348','2014-05-01','14:30:00',6.97),('8348','2014-05-01','14:35:00',6.9),('8348','2014-05-01','14:40:00',6.89),('8348','2014-05-01','14:45:00',6.78),('8348','2014-05-01','14:50:00',6.63),('8348','2014-05-01','14:55:00',6.37),('8348','2014-05-01','15:00:00',6.39),('8348','2014-05-01','15:05:00',6.45),('8348','2014-05-01','15:10:00',6.15),('8348','2014-05-01','15:15:00',6.15),('8348','2014-05-01','15:20:00',5.92),('8348','2014-05-01','15:25:00',5.4),('8348','2014-05-01','15:30:00',5.68),('8348','2014-05-01','15:35:00',5.66),('8348','2014-05-01','15:40:00',5.38),('8348','2014-05-01','15:45:00',4.56),('8348','2014-05-01','15:50:00',4.47),('8348','2014-05-01','15:55:00',4.54),('8348','2014-05-01','16:00:00',4.43),('8348','2014-05-01','16:05:00',4.65),('8348','2014-05-01','16:10:00',4.9),('8348','2014-05-01','16:15:00',4.63),('8348','2014-05-01','16:20:00',4.52),('8348','2014-05-01','16:25:00',4.35),('8348','2014-05-01','16:30:00',4.19),('8348','2014-05-01','16:35:00',4.06),('8348','2014-05-01','16:40:00',3.88),('8348','2014-05-01','16:45:00',3.74),('8348','2014-05-01','16:50:00',3.61),('8348','2014-05-01','16:55:00',3.46),('8348','2014-05-01','17:00:00',3.45),('8348','2014-05-01','17:05:00',3.15),('8348','2014-05-01','17:10:00',2.9),('8348','2014-05-01','17:15:00',2.7),('8348','2014-05-01','17:20:00',2.55),('8348','2014-05-01','17:25:00',2.23),('8348','2014-05-01','17:30:00',2.27),('8348','2014-05-01','17:35:00',1.63),('8348','2014-05-01','17:40:00',1.91),('8348','2014-05-01','17:45:00',1.76),('8348','2014-05-01','17:50:00',1.58),('8348','2014-05-01','17:55:00',1.41),('8348','2014-05-01','18:00:00',1.26),('8348','2014-05-01','18:05:00',1.06),('8348','2014-03-17','08:30:00',1.02),('8348','2014-03-17','08:35:00',1.08),('8348','2014-03-17','08:40:00',1.26),('8348','2014-03-17','08:45:00',1.38),('8348','2014-03-17','08:50:00',1.31),('8348','2014-03-17','08:55:00',1.44),('8348','2014-03-17','09:00:00',1.43),('8348','2014-03-17','09:05:00',1.52),('8348','2014-03-17','09:10:00',1.67),('8348','2014-03-17','09:15:00',1.85),('8348','2014-03-17','09:20:00',2.01),('8348','2014-03-17','09:25:00',2.45),('8348','2014-03-17','09:30:00',2.8),('8348','2014-03-17','09:35:00',2.61),('8348','2014-03-17','09:40:00',2.18),('8348','2014-03-17','09:45:00',2.24),('8348','2014-03-17','09:50:00',3.13),('8348','2014-03-17','09:55:00',3.05),('8348','2014-03-17','10:00:00',3.26),('8348','2014-03-17','10:05:00',3.04),('8348','2014-03-17','10:10:00',2.89),('8348','2014-03-17','10:15:00',3),('8348','2014-03-17','10:20:00',3.52),('8348','2014-03-17','10:25:00',3.21),('8348','2014-03-17','10:30:00',2.54),('8348','2014-03-17','10:35:00',2.49),('8348','2014-03-17','10:40:00',2.49),('8348','2014-03-17','10:45:00',3.19),('8348','2014-03-17','10:50:00',2.66),('8348','2014-03-17','10:55:00',2.44),('8348','2014-03-17','11:00:00',2.63),('8348','2014-03-17','11:05:00',2.53),('8348','2014-03-17','11:10:00',2.89),('8348','2014-03-17','11:15:00',3.54),('8348','2014-03-17','11:20:00',2.62),('8348','2014-03-17','11:25:00',2.66),('8348','2014-03-17','11:30:00',2.51),('8348','2014-03-17','11:35:00',2.37),('8348','2014-03-17','11:40:00',2.25),('8348','2014-03-17','11:45:00',2.54),('8348','2014-03-17','11:50:00',2.72),('8348','2014-03-17','11:55:00',2.95),('8348','2014-03-17','12:00:00',4.08),('8348','2014-03-17','12:05:00',3),('8348','2014-03-17','12:10:00',3.03),('8348','2014-03-17','12:15:00',2.92),('8348','2014-03-17','12:20:00',5.55),('8348','2014-03-17','12:25:00',3.4),('8348','2014-03-17','12:30:00',2.79),('8348','2014-03-17','12:35:00',4.74),('8348','2014-03-17','12:40:00',5.34),('8348','2014-03-17','12:45:00',7.09),('8348','2014-03-17','12:50:00',6.87),('8348','2014-03-17','12:55:00',6.82),('8348','2014-03-17','13:00:00',4.78),('8348','2014-03-17','13:05:00',2.67),('8348','2014-03-17','13:10:00',5.8),('8348','2014-03-17','13:15:00',6.64),('8348','2014-03-17','13:20:00',6.43),('8348','2014-03-17','13:25:00',6.28),('8348','2014-03-17','13:30:00',6.43),('8348','2014-03-17','13:35:00',6.42),('8348','2014-03-17','13:40:00',6.66),('8348','2014-03-17','13:45:00',4.14),('8348','2014-03-17','13:50:00',5.86),('8348','2014-03-17','13:55:00',5.25),('8348','2014-03-17','14:00:00',6.56),('8348','2014-03-17','14:05:00',5.79),('8348','2014-03-17','14:10:00',3.52),('8348','2014-03-17','14:15:00',4.25),('8348','2014-03-17','14:20:00',4.79),('8348','2014-03-17','14:25:00',3.89),('8348','2014-03-17','14:30:00',2.66),('8348','2014-03-17','14:35:00',3.17),('8348','2014-03-17','14:40:00',5.38),('8348','2014-03-17','14:45:00',3.52),('8348','2014-03-17','14:50:00',3.95),('8348','2014-03-17','14:55:00',4.73),('8348','2014-03-17','15:00:00',5.09),('8348','2014-03-17','15:05:00',3.77),('8348','2014-03-17','15:10:00',4.63),('8348','2014-03-17','15:15:00',4.78),('8348','2014-03-17','15:20:00',4.27),('8348','2014-03-17','15:25:00',4.35),('8348','2014-03-17','15:30:00',4.42),('8348','2014-03-17','15:35:00',4.22),('8348','2014-03-17','15:40:00',3.58),('8348','2014-03-17','15:45:00',3.88),('8348','2014-03-17','15:50:00',3.61),('8348','2014-03-17','15:55:00',3.49),('8348','2014-03-17','16:00:00',3.36),('8348','2014-03-17','16:05:00',3.24),('8348','2014-03-17','16:10:00',1.23),('8348','2014-03-17','16:15:00',2.33),('8348','2014-03-17','16:20:00',3.19),('8348','2014-03-17','16:25:00',3.17),('8348','2014-03-17','16:30:00',2.52),('8348','2014-03-17','16:35:00',2.66),('8348','2014-03-17','16:40:00',2.4),('8348','2014-03-17','16:45:00',1.99),('8348','2014-03-17','16:50:00',1.95),('8348','2014-03-17','16:55:00',1.53),('8348','2014-03-17','17:00:00',1.13),('8348','2014-03-17','17:05:00',1.24),('8348','2012-12-22','10:25:00',1.25),('8348','2012-12-22','10:30:00',1.79),('8348','2012-12-22','10:35:00',2.04),('8348','2012-12-22','10:40:00',1.98),('8348','2012-12-22','10:45:00',1.95),('8348','2012-12-22','10:50:00',1.88),('8348','2012-12-22','10:55:00',1.79),('8348','2012-12-22','11:35:00',1.03),('8348','2012-12-22','11:40:00',1.54),('8348','2012-12-22','11:45:00',1.64),('8348','2012-12-22','11:50:00',1.67),('8348','2012-12-22','11:55:00',1.18),('8348','2012-12-22','12:00:00',1.18),('8348','2012-12-22','12:45:00',1.85),('8348','2012-12-22','12:50:00',1.92),('8348','2012-12-22','12:55:00',1.74),('8348','2012-12-22','13:00:00',2.1),('8348','2012-12-22','13:05:00',1.8),('8348','2012-12-22','13:10:00',2.51),('8348','2012-12-22','13:15:00',2.56),('8348','2012-12-22','13:20:00',2.48),('8348','2012-12-22','13:25:00',2.4),('8348','2012-12-22','13:30:00',2.19),('8348','2012-12-22','13:35:00',2.27),('8348','2012-12-22','13:40:00',1.38),('8348','2012-12-22','14:00:00',1.07),('8348','2012-12-22','14:10:00',1.44),('8348','2012-12-22','14:15:00',1.08),('8348','2012-12-22','15:00:00',1.08),('8348','2014-03-16','07:35:00',1.02),('8348','2014-03-16','07:40:00',1.08),('8348','2014-03-16','07:45:00',1.17),('8348','2014-03-16','07:50:00',1.27),('8348','2014-03-16','07:55:00',1.47),('8348','2014-03-16','08:00:00',1.64),('8348','2014-03-16','08:05:00',1.78),('8348','2014-03-16','08:10:00',1.81),('8348','2014-03-16','08:15:00',1.86),('8348','2014-03-16','08:20:00',1.96),('8348','2014-03-16','08:25:00',2.07),('8348','2014-03-16','08:30:00',2.17),('8348','2014-03-16','08:35:00',2.24),('8348','2014-03-16','08:40:00',2.34),('8348','2014-03-16','08:45:00',2.54),('8348','2014-03-16','08:50:00',2.76),('8348','2014-03-16','08:55:00',2.83),('8348','2014-03-16','09:00:00',2.82),('8348','2014-03-16','09:05:00',2.94),('8348','2014-03-16','09:10:00',3.16),('8348','2014-03-16','09:15:00',3.53),('8348','2014-03-16','09:20:00',3.63),('8348','2014-03-16','09:25:00',3.64),('8348','2014-03-16','09:30:00',3.74),('8348','2014-03-16','09:35:00',3.77),('8348','2014-03-16','09:40:00',3.84),('8348','2014-03-16','09:45:00',4.14),('8348','2014-03-16','09:50:00',4.35),('8348','2014-03-16','09:55:00',4.31),('8348','2014-03-16','10:00:00',4.47),('8348','2014-03-16','10:05:00',4.49),('8348','2014-03-16','10:10:00',4.6),('8348','2014-03-16','10:15:00',4.76),('8348','2014-03-16','10:20:00',4.69),('8348','2014-03-16','10:25:00',4.81),('8348','2014-03-16','10:30:00',4.93),('8348','2014-03-16','10:35:00',5.01),('8348','2014-03-16','10:40:00',5.15),('8348','2014-03-16','10:45:00',5.26),('8348','2014-03-16','10:50:00',4.74),('8348','2014-03-16','10:55:00',5.11),('8348','2014-03-16','11:00:00',5.24),('8348','2014-03-16','11:05:00',5.42),('8348','2014-03-16','11:10:00',5.44),('8348','2014-03-16','11:15:00',5.58),('8348','2014-03-16','11:20:00',5.61),('8348','2014-03-16','11:25:00',5.76),('8348','2014-03-16','11:30:00',5.85),('8348','2014-03-16','11:35:00',5.85),('8348','2014-03-16','11:40:00',5.94),('8348','2014-03-16','11:45:00',5.88),('8348','2014-03-16','11:50:00',5.84),('8348','2014-03-16','11:55:00',5.86),('8348','2014-03-16','12:00:00',5.82),('8348','2014-03-16','12:05:00',5.96),('8348','2014-03-16','12:10:00',5.95),('8348','2014-03-16','12:15:00',5.76),('8348','2014-03-16','12:20:00',5.43),('8348','2014-03-16','12:25:00',5.61),('8348','2014-03-16','12:30:00',5.89),('8348','2014-03-16','12:35:00',5.95),('8348','2014-03-16','12:40:00',6.07),('8348','2014-03-16','12:45:00',6.02),('8348','2014-03-16','12:50:00',5.97),('8348','2014-03-16','12:55:00',5.82),('8348','2014-03-16','13:00:00',5.82),('8348','2014-03-16','13:05:00',5.98),('8348','2014-03-16','13:10:00',5.97),('8348','2014-03-16','13:15:00',6.02),('8348','2014-03-16','13:20:00',5.79),('8348','2014-03-16','13:25:00',5.83),('8348','2014-03-16','13:30:00',5.86),('8348','2014-03-16','13:35:00',5.79),('8348','2014-03-16','13:40:00',5.86),('8348','2014-03-16','13:45:00',5.73),('8348','2014-03-16','13:50:00',5.8),('8348','2014-03-16','13:55:00',5.82),('8348','2014-03-16','14:00:00',5.54),('8348','2014-03-16','14:05:00',5.59),('8348','2014-03-16','14:10:00',5.45),('8348','2014-03-16','14:15:00',5.35),('8348','2014-03-16','14:20:00',5.37),('8348','2014-03-16','14:25:00',5.31),('8348','2014-03-16','14:30:00',5.25),('8348','2014-03-16','14:35:00',5.18),('8348','2014-03-16','14:40:00',5.05),('8348','2014-03-16','14:45:00',4.91),('8348','2014-03-16','14:50:00',4.7),('8348','2014-03-16','14:55:00',4.64),('8348','2014-03-16','15:00:00',4.83),('8348','2014-03-16','15:05:00',4.6),('8348','2014-03-16','15:10:00',4.2),('8348','2014-03-16','15:15:00',4.06),('8348','2014-03-16','15:20:00',3.42),('8348','2014-03-16','15:25:00',3.88),('8348','2014-03-16','15:30:00',3.63),('8348','2014-03-16','15:35:00',3.32),('8348','2014-03-16','15:40:00',2.63),('8348','2014-03-16','15:45:00',2.58),('8348','2014-03-16','15:50:00',2.9),('8348','2014-03-16','15:55:00',2.69),('8348','2014-03-16','16:00:00',2.38),('8348','2014-03-16','16:05:00',2.82),('8348','2014-03-16','16:10:00',2.96),('8348','2014-03-16','16:15:00',2.91),('8348','2014-03-16','16:20:00',2.65),('8348','2014-03-16','16:25:00',2.64),('8348','2014-03-16','16:30:00',2.61),('8348','2014-03-16','16:35:00',2.4),('8348','2014-03-16','16:40:00',2.1),('8348','2014-03-16','16:45:00',1.84),('8348','2014-03-16','16:50:00',1.7),('8348','2014-03-16','16:55:00',1.42),('8348','2014-03-16','17:00:00',1.17),('8348','2014-03-16','17:05:00',1.13),('8348','2014-03-15','07:40:00',1.06),('8348','2014-03-15','07:45:00',1.15),('8348','2014-03-15','07:50:00',1.26),('8348','2014-03-15','07:55:00',1.37),('8348','2014-03-15','08:00:00',1.48),('8348','2014-03-15','08:05:00',1.61),('8348','2014-03-15','08:10:00',1.71),('8348','2014-03-15','08:15:00',1.82),('8348','2014-03-15','08:20:00',1.93),('8348','2014-03-15','08:25:00',2.02),('8348','2014-03-15','08:30:00',2.13),('8348','2014-03-15','08:35:00',2.22),('8348','2014-03-15','08:40:00',2.33),('8348','2014-03-15','08:45:00',2.46),('8348','2014-03-15','08:50:00',2.69),('8348','2014-03-15','08:55:00',2.84),('8348','2014-03-15','09:00:00',2.96),('8348','2014-03-15','09:05:00',3.08),('8348','2014-03-15','09:10:00',3.19),('8348','2014-03-15','09:15:00',3.4),('8348','2014-03-15','09:20:00',3.59),('8348','2014-03-15','09:25:00',3.71),('8348','2014-03-15','09:30:00',3.8),('8348','2014-03-15','09:35:00',3.89),('8348','2014-03-15','09:40:00',3.99),('8348','2014-03-15','09:45:00',4.08),('8348','2014-03-15','09:50:00',4.14),('8348','2014-03-15','09:55:00',4.22),('8348','2014-03-15','10:00:00',4.3),('8348','2014-03-15','10:05:00',4.4),('8348','2014-03-15','10:10:00',4.47),('8348','2014-03-15','10:15:00',4.6),('8348','2014-03-15','10:20:00',4.72),('8348','2014-03-15','10:25:00',4.77),('8348','2014-03-15','10:30:00',4.85),('8348','2014-03-15','10:35:00',4.88),('8348','2014-03-15','10:40:00',4.94),('8348','2014-03-15','10:45:00',5),('8348','2014-03-15','10:50:00',4.96),('8348','2014-03-15','10:55:00',5.04),('8348','2014-03-15','11:00:00',5.17),('8348','2014-03-15','11:05:00',5.18),('8348','2014-03-15','11:10:00',5.31),('8348','2014-03-15','11:15:00',5.53),('8348','2014-03-15','11:20:00',5.59),('8348','2014-03-15','11:25:00',5.72),('8348','2014-03-15','11:30:00',5.7),('8348','2014-03-15','11:35:00',5.83),('8348','2014-03-15','11:40:00',5.82),('8348','2014-03-15','11:45:00',5.85),('8348','2014-03-15','11:50:00',5.76),('8348','2014-03-15','11:55:00',5.93),('8348','2014-03-15','12:00:00',5.89),('8348','2014-03-15','12:05:00',5.88),('8348','2014-03-15','12:10:00',5.98),('8348','2014-03-15','12:15:00',6.08),('8348','2014-03-15','12:20:00',5.94),('8348','2014-03-15','12:25:00',6.03),('8348','2014-03-15','12:30:00',6.13),('8348','2014-03-15','12:35:00',6.35),('8348','2014-03-15','12:40:00',6.29),('8348','2014-03-15','12:45:00',6.22),('8348','2014-03-15','12:50:00',6.27),('8348','2014-03-15','12:55:00',6.14),('8348','2014-03-15','13:00:00',6.16),('8348','2014-03-15','13:05:00',6.18),('8348','2014-03-15','13:10:00',6.17),('8348','2014-03-15','13:15:00',6.16),('8348','2014-03-15','13:20:00',6.12),('8348','2014-03-15','13:25:00',6.12),('8348','2014-03-15','13:30:00',6.12),('8348','2014-03-15','13:35:00',6.09),('8348','2014-03-15','13:40:00',6.11),('8348','2014-03-15','13:45:00',6.03),('8348','2014-03-15','13:50:00',5.99),('8348','2014-03-15','13:55:00',5.96),('8348','2014-03-15','14:00:00',5.94),('8348','2014-03-15','14:05:00',5.92),('8348','2014-03-15','14:10:00',5.8),('8348','2014-03-15','14:15:00',5.72),('8348','2014-03-15','14:20:00',5.63),('8348','2014-03-15','14:25:00',5.56),('8348','2014-03-15','14:30:00',5.47),('8348','2014-03-15','14:35:00',5.36),('8348','2014-03-15','14:40:00',5.25),('8348','2014-03-15','14:45:00',5.16),('8348','2014-03-15','14:50:00',5.05),('8348','2014-03-15','14:55:00',5),('8348','2014-03-15','15:00:00',4.9),('8348','2014-03-15','15:05:00',4.78),('8348','2014-03-15','15:10:00',4.65),('8348','2014-03-15','15:15:00',4.52),('8348','2014-03-15','15:20:00',4.36),('8348','2014-03-15','15:25:00',4.24),('8348','2014-03-15','15:30:00',4.15),('8348','2014-03-15','15:35:00',3.99),('8348','2014-03-15','15:40:00',3.86),('8348','2014-03-15','15:45:00',3.75),('8348','2014-03-15','15:50:00',3.63),('8348','2014-03-15','15:55:00',3.47),('8348','2014-03-15','16:00:00',3.24),('8348','2014-03-15','16:05:00',3.02),('8348','2014-03-15','16:10:00',2.85),('8348','2014-03-15','16:15:00',2.64),('8348','2014-03-15','16:20:00',2.53),('8348','2014-03-15','16:25:00',2.37),('8348','2014-03-15','16:30:00',2.21),('8348','2014-03-15','16:35:00',2.09),('8348','2014-03-15','16:40:00',1.93),('8348','2014-03-15','16:45:00',1.79),('8348','2014-03-15','16:50:00',1.61),('8348','2014-03-15','16:55:00',1.48),('8348','2014-03-15','17:00:00',1.33),('8348','2014-03-15','17:05:00',1.2),('8348','2014-03-15','17:10:00',1.06),('8348','2014-03-14','07:45:00',1.07),('8348','2014-03-14','07:50:00',1.17),('8348','2014-03-14','07:55:00',1.27),('8348','2014-03-14','08:00:00',1.35),('8348','2014-03-14','08:05:00',1.43),('8348','2014-03-14','08:10:00',1.55),('8348','2014-03-14','08:15:00',1.7),('8348','2014-03-14','08:20:00',1.87),('8348','2014-03-14','08:25:00',1.95),('8348','2014-03-14','08:30:00',2.09),('8348','2014-03-14','08:35:00',2.08),('8348','2014-03-14','08:40:00',2.07),('8348','2014-03-14','08:45:00',1.86),('8348','2014-03-14','08:50:00',1.78),('8348','2014-03-14','08:55:00',1.83),('8348','2014-03-14','09:00:00',1.97),('8348','2014-03-14','09:05:00',2.22),('8348','2014-03-14','09:10:00',2.48),('8348','2014-03-14','09:15:00',2.59),('8348','2014-03-14','09:20:00',2.52),('8348','2014-03-14','09:25:00',2.62),('8348','2014-03-14','09:30:00',2.61),('8348','2014-03-14','09:35:00',2.98),('8348','2014-03-14','09:40:00',3.68),('8348','2014-03-14','09:45:00',4.2),('8348','2014-03-14','09:50:00',4.91),('8348','2014-03-14','09:55:00',5.26),('8348','2014-03-14','10:00:00',5.42),('8348','2014-03-14','10:05:00',5.47),('8348','2014-03-14','10:10:00',5.35),('8348','2014-03-14','10:15:00',5.25),('8348','2014-03-14','10:20:00',5.23),('8348','2014-03-14','10:25:00',4.98),('8348','2014-03-14','10:30:00',4.94),('8348','2014-03-14','10:35:00',5.07),('8348','2014-03-14','10:40:00',5.36),('8348','2014-03-14','10:45:00',4.84),('8348','2014-03-14','10:50:00',3.25),('8348','2014-03-14','10:55:00',3.94),('8348','2014-03-14','11:00:00',5.23),('8348','2014-03-14','11:05:00',5.42),('8348','2014-03-14','11:10:00',5.92),('8348','2014-03-14','11:15:00',6.15),('8348','2014-03-14','11:20:00',5.93),('8348','2014-03-14','11:25:00',5.85),('8348','2014-03-14','11:30:00',5.75),('8348','2014-03-14','11:35:00',5.9),('8348','2014-03-14','11:40:00',5.8),('8348','2014-03-14','11:45:00',5.86),('8348','2014-03-14','11:50:00',6.01),('8348','2014-03-14','11:55:00',6.07),('8348','2014-03-14','12:00:00',6.09),('8348','2014-03-14','12:05:00',5.98),('8348','2014-03-14','12:10:00',5.75),('8348','2014-03-14','12:15:00',5.65),('8348','2014-03-14','12:20:00',5.03),('8348','2014-03-14','12:25:00',4.06),('8348','2014-03-14','12:30:00',3.93),('8348','2014-03-14','12:35:00',3.16),('8348','2014-03-14','12:40:00',3.73),('8348','2014-03-14','12:45:00',3.92),('8348','2014-03-14','12:50:00',4.87),('8348','2014-03-14','12:55:00',5.08),('8348','2014-03-14','13:00:00',3.53),('8348','2014-03-14','13:05:00',3.12),('8348','2014-03-14','13:10:00',3.88),('8348','2014-03-14','13:15:00',4.31),('8348','2014-03-14','13:20:00',4.88),('8348','2014-03-14','13:25:00',4.52),('8348','2014-03-14','13:30:00',4.1),('8348','2014-03-14','13:35:00',3.67),('8348','2014-03-14','13:40:00',3.43),('8348','2014-03-14','13:45:00',3.6),('8348','2014-03-14','13:50:00',3.52),('8348','2014-03-14','13:55:00',3.47),('8348','2014-03-14','14:00:00',3.97),('8348','2014-03-14','14:05:00',4.45),('8348','2014-03-14','14:10:00',4.51),('8348','2014-03-14','14:15:00',4.85),('8348','2014-03-14','14:20:00',4.89),('8348','2014-03-14','14:25:00',4.95),('8348','2014-03-14','14:30:00',4.56),('8348','2014-03-14','14:35:00',4.31),('8348','2014-03-14','14:40:00',3.69),('8348','2014-03-14','14:45:00',2.96),('8348','2014-03-14','14:50:00',2.63),('8348','2014-03-14','14:55:00',2.44),('8348','2014-03-14','15:00:00',2.21),('8348','2014-03-14','15:05:00',2.18),('8348','2014-03-14','15:10:00',2.1),('8348','2014-03-14','15:15:00',2.07),('8348','2014-03-14','15:20:00',2.21),('8348','2014-03-14','15:25:00',2.47),('8348','2014-03-14','15:30:00',2.61),('8348','2014-03-14','15:35:00',2.92),('8348','2014-03-14','15:40:00',2.64),('8348','2014-03-14','15:45:00',2.36),('8348','2014-03-14','15:50:00',2.05),('8348','2014-03-14','15:55:00',2.07),('8348','2014-03-14','16:00:00',1.95),('8348','2014-03-14','16:05:00',1.92),('8348','2014-03-14','16:10:00',1.65),('8348','2014-03-14','16:15:00',1.4),('8348','2014-03-14','16:20:00',1.23),('8348','2014-03-14','16:25:00',1.14),('8348','2014-03-14','16:30:00',1.09),('8348','2014-03-14','16:35:00',1.02),('8348','2014-03-13','07:40:00',1.02),('8348','2014-03-13','07:45:00',1.12),('8348','2014-03-13','07:50:00',1.2),('8348','2014-03-13','07:55:00',1.3),('8348','2014-03-13','08:00:00',1.38),('8348','2014-03-13','08:05:00',1.49),('8348','2014-03-13','08:10:00',1.74),('8348','2014-03-13','08:15:00',1.85),('8348','2014-03-13','08:20:00',1.94),('8348','2014-03-13','08:25:00',2.02),('8348','2014-03-13','08:30:00',2.14),('8348','2014-03-13','08:35:00',2.26),('8348','2014-03-13','08:40:00',2.41),('8348','2014-03-13','08:45:00',2.5),('8348','2014-03-13','08:50:00',2.72),('8348','2014-03-13','08:55:00',3.08),('8348','2014-03-13','09:00:00',3.3),('8348','2014-03-13','09:05:00',3.44),('8348','2014-03-13','09:10:00',3.59),('8348','2014-03-13','09:15:00',3.71),('8348','2014-03-13','09:20:00',3.87),('8348','2014-03-13','09:25:00',4),('8348','2014-03-13','09:30:00',4.13),('8348','2014-03-13','09:35:00',4.25),('8348','2014-03-13','09:40:00',4.35),('8348','2014-03-13','09:45:00',4.49),('8348','2014-03-13','09:50:00',4.61),('8348','2014-03-13','09:55:00',4.72),('8348','2014-03-13','10:00:00',4.83),('8348','2014-03-13','10:05:00',4.94),('8348','2014-03-13','10:10:00',5.03),('8348','2014-03-13','10:15:00',5.12),('8348','2014-03-13','10:20:00',5.19),('8348','2014-03-13','10:25:00',5.26),('8348','2014-03-13','10:30:00',5.36),('8348','2014-03-13','10:35:00',5.44),('8348','2014-03-13','10:40:00',5.49),('8348','2014-03-13','10:45:00',5.55),('8348','2014-03-13','10:50:00',5.65),('8348','2014-03-13','10:55:00',5.7),('8348','2014-03-13','11:00:00',5.73),('8348','2014-03-13','11:05:00',5.8),('8348','2014-03-13','11:10:00',5.88),('8348','2014-03-13','11:15:00',5.92),('8348','2014-03-13','11:20:00',5.95),('8348','2014-03-13','11:25:00',5.99),('8348','2014-03-13','11:30:00',5.98),('8348','2014-03-13','11:35:00',6.02),('8348','2014-03-13','11:40:00',6.06),('8348','2014-03-13','11:45:00',6.1),('8348','2014-03-13','11:50:00',6.17),('8348','2014-03-13','11:55:00',6.23),('8348','2014-03-13','12:00:00',6.24),('8348','2014-03-13','12:05:00',6.22),('8348','2014-03-13','12:10:00',6.25),('8348','2014-03-13','12:15:00',6.27),('8348','2014-03-13','12:20:00',6.23),('8348','2014-03-13','12:25:00',6.18),('8348','2014-03-13','12:30:00',6.21),('8348','2014-03-13','12:35:00',6.21),('8348','2014-03-13','12:40:00',6.2),('8348','2014-03-13','12:45:00',6.14),('8348','2014-03-13','12:50:00',6.12),('8348','2014-03-13','12:55:00',6.09),('8348','2014-03-13','13:00:00',6.04),('8348','2014-03-13','13:05:00',6.06),('8348','2014-03-13','13:10:00',5.98),('8348','2014-03-13','13:15:00',6.1),('8348','2014-03-13','13:20:00',6.11),('8348','2014-03-13','13:25:00',6.14),('8348','2014-03-13','13:30:00',6.19),('8348','2014-03-13','13:35:00',6.16),('8348','2014-03-13','13:40:00',6.08),('8348','2014-03-13','13:45:00',6.04),('8348','2014-03-13','13:50:00',5.97),('8348','2014-03-13','13:55:00',5.9),('8348','2014-03-13','14:00:00',5.81),('8348','2014-03-13','14:05:00',5.73),('8348','2014-03-13','14:10:00',5.68),('8348','2014-03-13','14:15:00',5.66),('8348','2014-03-13','14:20:00',5.57),('8348','2014-03-13','14:25:00',5.48),('8348','2014-03-13','14:30:00',5.39),('8348','2014-03-13','14:35:00',5.32),('8348','2014-03-13','14:40:00',5.23),('8348','2014-03-13','14:45:00',5.12),('8348','2014-03-13','14:50:00',5.03),('8348','2014-03-13','14:55:00',4.91),('8348','2014-03-13','15:00:00',4.81),('8348','2014-03-13','15:05:00',4.69),('8348','2014-03-13','15:10:00',4.61),('8348','2014-03-13','15:15:00',4.51),('8348','2014-03-13','15:20:00',4.4),('8348','2014-03-13','15:25:00',4.28),('8348','2014-03-13','15:30:00',4.13),('8348','2014-03-13','15:35:00',3.99),('8348','2014-03-13','15:40:00',3.86),('8348','2014-03-13','15:45:00',3.75),('8348','2014-03-13','15:50:00',3.64),('8348','2014-03-13','15:55:00',3.49),('8348','2014-03-13','16:00:00',3.28),('8348','2014-03-13','16:05:00',3.11),('8348','2014-03-13','16:10:00',2.97),('8348','2014-03-13','16:15:00',2.81),('8348','2014-03-13','16:20:00',2.69),('8348','2014-03-13','16:25:00',2.54),('8348','2014-03-13','16:30:00',2.38),('8348','2014-03-13','16:35:00',2.24),('8348','2014-03-13','16:40:00',2.06),('8348','2014-03-13','16:45:00',1.91),('8348','2014-03-13','16:50:00',1.78),('8348','2014-03-13','16:55:00',1.64),('8348','2014-03-13','17:00:00',1.48),('8348','2014-03-13','17:05:00',1.33),('8348','2014-03-13','17:10:00',1.15),('8348','2014-03-13','17:15:00',1.01),('8348','2014-03-12','07:50:00',1.09),('8348','2014-03-12','07:55:00',1.18),('8348','2014-03-12','08:00:00',1.27),('8348','2014-03-12','08:05:00',1.37),('8348','2014-03-12','08:10:00',1.58),('8348','2014-03-12','08:15:00',1.73),('8348','2014-03-12','08:20:00',1.83),('8348','2014-03-12','08:25:00',1.93),('8348','2014-03-12','08:30:00',2.04),('8348','2014-03-12','08:35:00',2.19),('8348','2014-03-12','08:40:00',2.31),('8348','2014-03-12','08:45:00',2.42),('8348','2014-03-12','08:50:00',2.59),('8348','2014-03-12','08:55:00',2.91),('8348','2014-03-12','09:00:00',3.21),('8348','2014-03-12','09:05:00',3.37),('8348','2014-03-12','09:10:00',3.51),('8348','2014-03-12','09:15:00',3.65),('8348','2014-03-12','09:20:00',3.82),('8348','2014-03-12','09:25:00',3.98),('8348','2014-03-12','09:30:00',4.08),('8348','2014-03-12','09:35:00',4.21),('8348','2014-03-12','09:40:00',4.31),('8348','2014-03-12','09:45:00',4.42),('8348','2014-03-12','09:50:00',4.53),('8348','2014-03-12','09:55:00',4.65),('8348','2014-03-12','10:00:00',4.77),('8348','2014-03-12','10:05:00',4.88),('8348','2014-03-12','10:10:00',4.97),('8348','2014-03-12','10:15:00',5.07),('8348','2014-03-12','10:20:00',5.17),('8348','2014-03-12','10:25:00',5.24),('8348','2014-03-12','10:30:00',5.32),('8348','2014-03-12','10:35:00',5.43),('8348','2014-03-12','10:40:00',5.55),('8348','2014-03-12','10:45:00',5.64),('8348','2014-03-12','10:50:00',5.72),('8348','2014-03-12','10:55:00',5.8),('8348','2014-03-12','11:00:00',5.9),('8348','2014-03-12','11:05:00',5.96),('8348','2014-03-12','11:10:00',6.03),('8348','2014-03-12','11:15:00',6.09),('8348','2014-03-12','11:20:00',6.15),('8348','2014-03-12','11:25:00',6.19),('8348','2014-03-12','11:30:00',6.24),('8348','2014-03-12','11:35:00',6.26),('8348','2014-03-12','11:40:00',6.3),('8348','2014-03-12','11:45:00',6.31),('8348','2014-03-12','11:50:00',6.35),('8348','2014-03-12','11:55:00',6.37),('8348','2014-03-12','12:00:00',6.39),('8348','2014-03-12','12:05:00',6.38),('8348','2014-03-12','12:10:00',6.39),('8348','2014-03-12','12:15:00',6.39),('8348','2014-03-12','12:20:00',6.38),('8348','2014-03-12','12:25:00',6.37),('8348','2014-03-12','12:30:00',6.36),('8348','2014-03-12','12:35:00',6.35),('8348','2014-03-12','12:40:00',6.35),('8348','2014-03-12','12:45:00',6.39),('8348','2014-03-12','12:50:00',6.38),('8348','2014-03-12','12:55:00',6.33),('8348','2014-03-12','13:00:00',6.36),('8348','2014-03-12','13:05:00',6.28),('8348','2014-03-12','13:10:00',6.28),('8348','2014-03-12','13:15:00',6.25),('8348','2014-03-12','13:20:00',6.26),('8348','2014-03-12','13:25:00',6.18),('8348','2014-03-12','13:30:00',6.17),('8348','2014-03-12','13:35:00',6.05),('8348','2014-03-12','13:40:00',6.06),('8348','2014-03-12','13:45:00',6.02),('8348','2014-03-12','13:50:00',5.93),('8348','2014-03-12','13:55:00',5.88),('8348','2014-03-12','14:00:00',5.88),('8348','2014-03-12','14:05:00',5.85),('8348','2014-03-12','14:10:00',5.79),('8348','2014-03-12','14:15:00',5.69),('8348','2014-03-12','14:20:00',5.6),('8348','2014-03-12','14:25:00',5.51),('8348','2014-03-12','14:30:00',5.49),('8348','2014-03-12','14:35:00',5.25),('8348','2014-03-12','14:40:00',5.18),('8348','2014-03-12','14:45:00',4.99),('8348','2014-03-12','14:50:00',5.03),('8348','2014-03-12','14:55:00',4.79),('8348','2014-03-12','15:00:00',4.54),('8348','2014-03-12','15:05:00',4.59),('8348','2014-03-12','15:10:00',4.49),('8348','2014-03-12','15:15:00',4.3),('8348','2014-03-12','15:20:00',4.29),('8348','2014-03-12','15:25:00',4.1),('8348','2014-03-12','15:30:00',3.92),('8348','2014-03-12','15:35:00',3.87),('8348','2014-03-12','15:40:00',3.82),('8348','2014-03-12','15:45:00',3.72),('8348','2014-03-12','15:50:00',3.64),('8348','2014-03-12','15:55:00',3.49),('8348','2014-03-12','16:00:00',3.35),('8348','2014-03-12','16:05:00',3.2),('8348','2014-03-12','16:10:00',2.98),('8348','2014-03-12','16:15:00',2.86),('8348','2014-03-12','16:20:00',2.71),('8348','2014-03-12','16:25:00',2.52),('8348','2014-03-12','16:30:00',2.34),('8348','2014-03-12','16:35:00',2.26),('8348','2014-03-12','16:40:00',2.09),('8348','2014-03-12','16:45:00',1.91),('8348','2014-03-12','16:50:00',1.74),('8348','2014-03-12','16:55:00',1.57),('8348','2014-03-12','17:00:00',1.41),('8348','2014-03-12','17:05:00',1.24),('8348','2014-03-12','17:10:00',1.1),('8348','2014-03-11','07:55:00',1.04),('8348','2014-03-11','08:00:00',1.04),('8348','2014-03-11','10:10:00',1.04),('8348','2014-03-11','10:15:00',1.28),('8348','2014-03-11','10:20:00',1.6),('8348','2014-03-11','10:25:00',1.66),('8348','2014-03-11','10:30:00',1.71),('8348','2014-03-11','10:35:00',1.73),('8348','2014-03-11','10:40:00',1.68),('8348','2014-03-11','10:45:00',1.59),('8348','2014-03-11','10:50:00',1.47),('8348','2014-03-11','10:55:00',1.54),('8348','2014-03-11','11:00:00',1.77),('8348','2014-03-11','11:05:00',1.84),('8348','2014-03-11','11:10:00',1.86),('8348','2014-03-11','11:15:00',1.89),('8348','2014-03-11','11:20:00',1.67),('8348','2014-03-11','11:25:00',1.6),('8348','2014-03-11','11:30:00',1.52),('8348','2014-03-11','11:35:00',1.62),('8348','2014-03-11','11:40:00',1.77),('8348','2014-03-11','11:45:00',1.89),('8348','2014-03-11','11:50:00',1.67),('8348','2014-03-11','11:55:00',1.82),('8348','2014-03-11','12:00:00',1.91),('8348','2014-03-11','12:05:00',1.92),('8348','2014-03-11','12:10:00',1.97),('8348','2014-03-11','12:15:00',2.23),('8348','2014-03-11','12:20:00',2.37),('8348','2014-03-11','12:25:00',2.15),('8348','2014-03-11','12:30:00',2.09),('8348','2014-03-11','12:35:00',2.26),('8348','2014-03-11','12:40:00',2.49),('8348','2014-03-11','12:45:00',2.46),('8348','2014-03-11','12:50:00',2.35),('8348','2014-03-11','12:55:00',2.14),('8348','2014-03-11','13:00:00',2.07),('8348','2014-03-11','13:05:00',2.34),('8348','2014-03-11','13:10:00',2.35),('8348','2014-03-11','13:15:00',2.29),('8348','2014-03-11','13:20:00',2.4),('8348','2014-03-11','13:25:00',2.07),('8348','2014-03-11','13:30:00',1.98),('8348','2014-03-11','13:35:00',1.9),('8348','2014-03-11','13:40:00',1.98),('8348','2014-03-11','13:45:00',2.45),('8348','2014-03-11','13:50:00',2.84),('8348','2014-03-11','13:55:00',3.43),('8348','2014-03-11','14:00:00',3.46),('8348','2014-03-11','14:05:00',3.61),('8348','2014-03-11','14:10:00',4.25),('8348','2014-03-11','14:15:00',4.03),('8348','2014-03-11','14:20:00',3.76),('8348','2014-03-11','14:25:00',3.3),('8348','2014-03-11','14:30:00',2.57),('8348','2014-03-11','14:35:00',2.7),('8348','2014-03-11','14:40:00',2.63),('8348','2014-03-11','14:45:00',2.85),('8348','2014-03-11','14:50:00',2.54),('8348','2014-03-11','14:55:00',2.5),('8348','2014-03-11','15:00:00',2.86),('8348','2014-03-11','15:05:00',3.06),('8348','2014-03-11','15:10:00',3.24),('8348','2014-03-11','15:15:00',2.95),('8348','2014-03-11','15:20:00',3.03),('8348','2014-03-11','15:25:00',2.61),('8348','2014-03-11','15:30:00',2.38),('8348','2014-03-11','15:35:00',2.09),('8348','2014-03-11','15:40:00',2.02),('8348','2014-03-11','15:45:00',1.91),('8348','2014-03-11','15:50:00',1.87),('8348','2014-03-11','15:55:00',1.51),('8348','2014-03-11','16:00:00',1.38),('8348','2014-03-11','16:05:00',1.34),('8348','2014-03-11','16:10:00',1.39),('8348','2014-03-11','16:15:00',1.33),('8348','2014-03-11','16:20:00',1.32),('8348','2014-03-11','16:25:00',1.16),('8348','2014-03-11','16:30:00',1.07),('8348','2014-03-10','08:15:00',1),('8348','2014-03-10','08:20:00',1.08),('8348','2014-03-10','08:25:00',1.18),('8348','2014-03-10','08:30:00',1.28),('8348','2014-03-10','08:35:00',1.46),('8348','2014-03-10','08:40:00',1.58),('8348','2014-03-10','08:45:00',1.57),('8348','2014-03-10','08:50:00',1.63),('8348','2014-03-10','08:55:00',1.65),('8348','2014-03-10','09:00:00',1.69),('8348','2014-03-10','09:05:00',1.8),('8348','2014-03-10','09:10:00',1.85),('8348','2014-03-10','09:15:00',1.85),('8348','2014-03-10','09:20:00',1.78),('8348','2014-03-10','09:25:00',1.78),('8348','2014-03-10','09:30:00',1.84),('8348','2014-03-10','09:35:00',1.87),('8348','2014-03-10','09:40:00',1.92),('8348','2014-03-10','09:45:00',1.73),('8348','2014-03-10','09:50:00',1.49),('8348','2014-03-10','09:55:00',1.38),('8348','2014-03-10','10:00:00',1.25),('8348','2014-03-10','10:05:00',1.44),('8348','2014-03-10','10:10:00',1.81),('8348','2014-03-10','10:15:00',2.11),('8348','2014-03-10','10:20:00',1.68),('8348','2014-03-10','10:25:00',1.61),('8348','2014-03-10','10:30:00',1.97),('8348','2014-03-10','10:35:00',2.15),('8348','2014-03-10','10:40:00',1.46),('8348','2014-03-10','11:10:00',1.27),('8348','2014-03-10','11:15:00',1.61),('8348','2014-03-10','11:20:00',1.76),('8348','2014-03-10','11:25:00',1.64),('8348','2014-03-10','11:30:00',1.46),('8348','2014-03-10','12:20:00',1.04),('8348','2014-03-10','12:25:00',1.1),('8348','2014-03-10','12:30:00',1.23),('8348','2014-03-10','12:35:00',1.42),('8348','2014-03-10','12:40:00',1.59),('8348','2014-03-10','12:45:00',1.81),('8348','2014-03-10','12:50:00',1.99),('8348','2014-03-10','12:55:00',2.12),('8348','2014-03-10','13:00:00',2.22),('8348','2014-03-10','13:05:00',2.27),('8348','2014-03-10','13:10:00',2.42),('8348','2014-03-10','13:15:00',2.63),('8348','2014-03-10','13:20:00',2.61),('8348','2014-03-10','13:25:00',2.28),('8348','2014-03-10','13:30:00',1.91),('8348','2014-03-10','13:35:00',1.59),('8348','2014-03-10','13:40:00',1.44),('8348','2014-03-10','13:45:00',1.37),('8348','2014-03-10','13:50:00',2.05),('8348','2014-03-10','13:55:00',2.16),('8348','2014-03-10','14:00:00',2.12),('8348','2014-03-10','14:05:00',3.14),('8348','2014-03-10','14:10:00',4.11),('8348','2014-03-10','14:15:00',5.74),('8348','2014-03-10','14:20:00',4.05),('8348','2014-03-10','14:25:00',3.01),('8348','2014-03-10','14:30:00',2.32),('8348','2014-03-10','14:35:00',3.53),('8348','2014-03-10','14:40:00',4.75),('8348','2014-03-10','14:45:00',4.37),('8348','2014-03-10','14:50:00',4.52),('8348','2014-03-10','14:55:00',2.38),('8348','2014-03-10','15:00:00',2.88),('8348','2014-03-10','15:05:00',2.29),('8348','2014-03-10','15:10:00',1.81),('8348','2014-03-10','15:15:00',2.78),('8348','2014-03-10','15:20:00',3.58),('8348','2014-03-10','15:25:00',3.8),('8348','2014-03-10','15:30:00',3.56),('8348','2014-03-10','15:35:00',2.07),('8348','2014-03-10','15:40:00',1.77),('8348','2014-03-10','15:45:00',1.27),('8348','2014-03-10','15:50:00',1.57),('8348','2014-03-10','15:55:00',1.54),('8348','2014-03-10','16:00:00',1.53),('8348','2014-03-10','16:05:00',1.78),('8348','2014-03-10','16:10:00',1.52),('8348','2014-03-10','16:15:00',1.29),('8348','2014-03-10','16:20:00',1.39),('8348','2014-03-10','16:25:00',1.88),('8348','2014-03-10','16:30:00',2.24),('8348','2014-03-10','16:35:00',1.52),('8348','2014-03-10','16:40:00',1.02),('8348','2014-03-10','16:55:00',1.54),('8348','2014-03-10','17:00:00',1.28),('8348','2014-03-10','17:05:00',1.03),('8348','2014-03-09','07:50:00',1.04),('8348','2014-03-09','07:55:00',1.13),('8348','2014-03-09','08:00:00',1.23),('8348','2014-03-09','08:05:00',1.3),('8348','2014-03-09','08:10:00',1.4),('8348','2014-03-09','08:15:00',1.61),('8348','2014-03-09','08:20:00',1.69),('8348','2014-03-09','08:25:00',1.7),('8348','2014-03-09','08:30:00',1.6),('8348','2014-03-09','08:35:00',1.42),('8348','2014-03-09','08:40:00',1.54),('8348','2014-03-09','08:45:00',1.52),('8348','2014-03-09','08:50:00',1.25),('8348','2014-03-09','08:55:00',2.1),('8348','2014-03-09','09:00:00',2.69),('8348','2014-03-09','09:05:00',2.1),('8348','2014-03-09','09:10:00',1.25),('8348','2014-03-09','09:15:00',3.53),('8348','2014-03-09','09:20:00',3.72),('8348','2014-03-09','09:25:00',3.82),('8348','2014-03-09','09:30:00',4.29),('8348','2014-03-09','09:35:00',4.57),('8348','2014-03-09','09:40:00',4.73),('8348','2014-03-09','09:45:00',4.85),('8348','2014-03-09','09:50:00',4.89),('8348','2014-03-09','09:55:00',4.9),('8348','2014-03-09','10:00:00',4.95),('8348','2014-03-09','10:05:00',5.03),('8348','2014-03-09','10:10:00',5.2),('8348','2014-03-09','10:15:00',5.24),('8348','2014-03-09','10:20:00',5.24),('8348','2014-03-09','10:25:00',4.51),('8348','2014-03-09','10:30:00',5.49),('8348','2014-03-09','10:35:00',5.55),('8348','2014-03-09','10:40:00',5.63),('8348','2014-03-09','10:45:00',5.71),('8348','2014-03-09','10:50:00',5.86),('8348','2014-03-09','10:55:00',6.08),('8348','2014-03-09','11:00:00',6.5),('8348','2014-03-09','11:05:00',6.6),('8348','2014-03-09','11:10:00',6.79),('8348','2014-03-09','11:15:00',6.8),('8348','2014-03-09','11:20:00',4.16),('8348','2014-03-09','11:25:00',4.86),('8348','2014-03-09','11:30:00',2.6),('8348','2014-03-09','11:35:00',3.76),('8348','2014-03-09','11:40:00',3.6),('8348','2014-03-09','11:45:00',3.56),('8348','2014-03-09','11:50:00',5.39),('8348','2014-03-09','11:55:00',5.77),('8348','2014-03-09','12:00:00',7.37),('8348','2014-03-09','12:05:00',7.53),('8348','2014-03-09','12:10:00',7.44),('8348','2014-03-09','12:15:00',7.39),('8348','2014-03-09','12:20:00',7.32),('8348','2014-03-09','12:25:00',7.17),('8348','2014-03-09','12:30:00',7.24),('8348','2014-03-09','12:35:00',7.41),('8348','2014-03-09','12:40:00',7.01),('8348','2014-03-09','12:45:00',6.84),('8348','2014-03-09','12:50:00',6.95),('8348','2014-03-09','12:55:00',7.04),('8348','2014-03-09','13:00:00',7.18),('8348','2014-03-09','13:05:00',7.24),('8348','2014-03-09','13:10:00',7.25),('8348','2014-03-09','13:15:00',6.77),('8348','2014-03-09','13:20:00',6.62),('8348','2014-03-09','13:25:00',6.52),('8348','2014-03-09','13:30:00',5.84),('8348','2014-03-09','13:35:00',5.76),('8348','2014-03-09','13:40:00',1.61),('8348','2014-03-09','13:45:00',2.48),('8348','2014-03-09','13:50:00',5.74),('8348','2014-03-09','13:55:00',1.68),('8348','2014-03-09','14:00:00',5.56),('8348','2014-03-09','14:05:00',6.26),('8348','2014-03-09','14:10:00',6.11),('8348','2014-03-09','14:15:00',5.97),('8348','2014-03-09','14:20:00',3.77),('8348','2014-03-09','14:25:00',4.44),('8348','2014-03-09','14:30:00',1.67),('8348','2014-03-09','14:35:00',1.72),('8348','2014-03-09','14:40:00',1.79),('8348','2014-03-09','14:45:00',4.6),('8348','2014-03-09','14:50:00',3.25),('8348','2014-03-09','14:55:00',5.33),('8348','2014-03-09','15:00:00',5.16),('8348','2014-03-09','15:05:00',3.8),('8348','2014-03-09','15:10:00',4.93),('8348','2014-03-09','15:15:00',4.73),('8348','2014-03-09','15:20:00',4.67),('8348','2014-03-09','15:25:00',4.63),('8348','2014-03-09','15:30:00',4.52),('8348','2014-03-09','15:35:00',4.33),('8348','2014-03-09','15:40:00',4.07),('8348','2014-03-09','15:45:00',3.58),('8348','2014-03-09','15:50:00',1.17),('8348','2014-03-09','15:55:00',2.74),('8348','2014-03-09','16:00:00',3.51),('8348','2014-03-09','16:05:00',3.25),('8348','2014-03-09','16:10:00',2.58),('8348','2014-03-09','16:15:00',2.42),('8348','2014-03-09','16:20:00',2.23),('8348','2014-03-09','16:25:00',2.54),('8348','2014-03-09','16:30:00',2.41),('8348','2014-03-09','16:35:00',2.35),('8348','2014-03-09','16:40:00',2.3),('8348','2014-03-09','16:45:00',1.97),('8348','2014-03-09','16:50:00',1.77),('8348','2014-03-09','16:55:00',1.6),('8348','2014-03-09','17:00:00',1.39),('8348','2014-03-09','17:05:00',1.21),('8348','2014-03-09','17:10:00',1.07),('8348','2014-03-08','07:50:00',1.01),('8348','2014-03-08','07:55:00',1.09),('8348','2014-03-08','08:00:00',1.19),('8348','2014-03-08','08:05:00',1.28),('8348','2014-03-08','08:10:00',1.37),('8348','2014-03-08','08:15:00',1.53),('8348','2014-03-08','08:20:00',1.73),('8348','2014-03-08','08:25:00',1.84),('8348','2014-03-08','08:30:00',1.95),('8348','2014-03-08','08:35:00',2.05),('8348','2014-03-08','08:40:00',2.19),('8348','2014-03-08','08:45:00',2.32),('8348','2014-03-08','08:50:00',2.43),('8348','2014-03-08','08:55:00',2.56),('8348','2014-03-08','09:00:00',2.92),('8348','2014-03-08','09:05:00',3.2),('8348','2014-03-08','09:10:00',3.36),('8348','2014-03-08','09:15:00',3.47),('8348','2014-03-08','09:20:00',3.63),('8348','2014-03-08','09:25:00',3.81),('8348','2014-03-08','09:30:00',3.98),('8348','2014-03-08','09:35:00',4.09),('8348','2014-03-08','09:40:00',4.21),('8348','2014-03-08','09:45:00',4.33),('8348','2014-03-08','09:50:00',4.46),('8348','2014-03-08','09:55:00',4.58),('8348','2014-03-08','10:00:00',4.68),('8348','2014-03-08','10:05:00',4.78),('8348','2014-03-08','10:10:00',4.88),('8348','2014-03-08','10:15:00',4.98),('8348','2014-03-08','10:20:00',5.08),('8348','2014-03-08','10:25:00',5.18),('8348','2014-03-08','10:30:00',5.33),('8348','2014-03-08','10:35:00',5.42),('8348','2014-03-08','10:40:00',5.5),('8348','2014-03-08','10:45:00',5.57),('8348','2014-03-08','10:50:00',5.65),('8348','2014-03-08','10:55:00',5.71),('8348','2014-03-08','11:00:00',5.78),('8348','2014-03-08','11:05:00',5.84),('8348','2014-03-08','11:10:00',5.92),('8348','2014-03-08','11:15:00',6.01),('8348','2014-03-08','11:20:00',6.16),('8348','2014-03-08','11:25:00',6.34),('8348','2014-03-08','11:30:00',6.59),('8348','2014-03-08','11:35:00',5.43),('8348','2014-03-08','11:40:00',3.72),('8348','2014-03-08','11:45:00',2.3),('8348','2014-03-08','11:50:00',2.55),('8348','2014-03-08','11:55:00',5.26),('8348','2014-03-08','12:00:00',3.99),('8348','2014-03-08','12:05:00',1.91),('8348','2014-03-08','12:10:00',2.03),('8348','2014-03-08','12:15:00',2.14),('8348','2014-03-08','12:20:00',2.39),('8348','2014-03-08','12:25:00',2.63),('8348','2014-03-08','12:30:00',2.8),('8348','2014-03-08','12:35:00',6.05),('8348','2014-03-08','12:40:00',3.39),('8348','2014-03-08','12:45:00',3.81),('8348','2014-03-08','12:50:00',3.68),('8348','2014-03-08','12:55:00',5.05),('8348','2014-03-08','13:00:00',3.61),('8348','2014-03-08','13:05:00',3.02),('8348','2014-03-08','13:10:00',2.66),('8348','2014-03-08','13:15:00',2.12),('8348','2014-03-08','13:20:00',1.8),('8348','2014-03-08','13:25:00',1.82),('8348','2014-03-08','13:30:00',2.87),('8348','2014-03-08','13:35:00',2.97),('8348','2014-03-08','13:40:00',3.77),('8348','2014-03-08','13:45:00',4.66),('8348','2014-03-08','13:50:00',3.67),('8348','2014-03-08','13:55:00',2.55),('8348','2014-03-08','14:00:00',2.02),('8348','2014-03-08','14:05:00',1.86),('8348','2014-03-08','14:10:00',1.71),('8348','2014-03-08','14:15:00',1.42),('8348','2014-03-08','14:20:00',1.36),('8348','2014-03-08','14:25:00',1.32),('8348','2014-03-08','14:30:00',1.45),('8348','2014-03-08','14:35:00',1.72),('8348','2014-03-08','14:40:00',1.82),('8348','2014-03-08','14:45:00',1.71),('8348','2014-03-08','14:50:00',1.76),('8348','2014-03-08','14:55:00',1.88),('8348','2014-03-08','15:00:00',1.65),('8348','2014-03-08','15:05:00',1.47),('8348','2014-03-08','15:10:00',1.59),('8348','2014-03-08','15:15:00',2.09),('8348','2014-03-08','15:20:00',2.91),('8348','2014-03-08','15:25:00',2.9),('8348','2014-03-08','15:30:00',2.34),('8348','2014-03-08','15:35:00',1.28),('8348','2014-03-08','15:40:00',1.14),('8348','2014-03-08','15:45:00',1.19),('8348','2014-03-08','15:50:00',1.43),('8348','2014-03-08','15:55:00',1.57),('8348','2014-03-08','16:00:00',1.79),('8348','2014-03-08','16:05:00',2.19),('8348','2014-03-08','16:10:00',1.25),('8348','2014-03-08','16:15:00',1.2),('8348','2014-03-08','16:20:00',1.3),('8348','2014-03-08','16:25:00',1.22),('8348','2014-03-08','16:30:00',1.97),('8348','2014-03-08','16:35:00',2.56),('8348','2014-03-08','16:40:00',2.21),('8348','2014-03-08','16:45:00',2.04),('8348','2014-03-08','16:50:00',1.88),('8348','2014-03-08','16:55:00',1.65),('8348','2014-03-08','17:00:00',1.5),('8348','2014-03-08','17:05:00',1.35),('8348','2014-03-08','17:10:00',1.2),('8348','2014-03-08','17:15:00',1.07),('8348','2014-04-30','06:40:00',1.07),('8348','2014-04-30','06:45:00',1.16),('8348','2014-04-30','06:50:00',1.25),('8348','2014-04-30','06:55:00',1.47),('8348','2014-04-30','07:00:00',1.59),('8348','2014-04-30','07:05:00',1.64),('8348','2014-04-30','07:10:00',1.81),('8348','2014-04-30','07:15:00',1.93),('8348','2014-04-30','07:20:00',2.03),('8348','2014-04-30','07:25:00',2.12),('8348','2014-04-30','07:30:00',2.24),('8348','2014-04-30','07:35:00',2.41),('8348','2014-04-30','07:40:00',2.66),('8348','2014-04-30','07:45:00',2.97),('8348','2014-04-30','07:50:00',3.17),('8348','2014-04-30','07:55:00',3.47),('8348','2014-04-30','08:00:00',3.78),('8348','2014-04-30','08:05:00',4.09),('8348','2014-04-30','08:10:00',4.4),('8348','2014-04-30','08:15:00',2.85),('8348','2014-04-30','08:20:00',1.7),('8348','2014-04-30','08:25:00',2.37),('8348','2014-04-30','08:30:00',3.45),('8348','2014-04-30','08:35:00',4.24),('8348','2014-04-30','08:40:00',5.16),('8348','2014-04-30','08:45:00',5.08),('8348','2014-04-30','08:50:00',2.84),('8348','2014-04-30','08:55:00',4.72),('8348','2014-04-30','09:00:00',6.12),('8348','2014-04-30','09:05:00',5.68),('8348','2014-04-30','09:10:00',3.95),('8348','2014-04-30','09:15:00',6.31),('8348','2014-04-30','09:20:00',3.37),('8348','2014-04-30','09:25:00',2.86),('8348','2014-04-30','09:30:00',3.16),('8348','2014-04-30','09:35:00',4.18),('8348','2014-04-30','09:40:00',3.85),('8348','2014-04-30','09:45:00',3.07),('8348','2014-04-30','09:50:00',2.95),('8348','2014-04-30','09:55:00',6.9),('8348','2014-04-30','10:00:00',6.92),('8348','2014-04-30','10:05:00',7.09),('8348','2014-04-30','10:10:00',6.16),('8348','2014-04-30','10:15:00',4.77),('8348','2014-04-30','10:20:00',3.69),('8348','2014-04-30','10:25:00',4.92),('8348','2014-04-30','10:30:00',3.88),('8348','2014-04-30','10:35:00',4.54),('8348','2014-04-30','10:40:00',4.22),('8348','2014-04-30','10:45:00',5.26),('8348','2014-04-30','10:50:00',6.5),('8348','2014-04-30','10:55:00',4.75),('8348','2014-04-30','11:00:00',4.62),('8348','2014-04-30','11:05:00',2.68),('8348','2014-04-30','11:10:00',2.53),('8348','2014-04-30','11:15:00',3.55),('8348','2014-04-30','11:20:00',3.41),('8348','2014-04-30','11:25:00',2.59),('8348','2014-04-30','11:30:00',2.54),('8348','2014-04-30','11:35:00',2.65),('8348','2014-04-30','11:40:00',2.26),('8348','2014-04-30','11:45:00',2.73),('8348','2014-04-30','11:50:00',2.97),('8348','2014-04-30','11:55:00',8.51),('8348','2014-04-30','12:00:00',7.11),('8348','2014-04-30','12:05:00',7.86),('8348','2014-04-30','12:10:00',7.92),('8348','2014-04-30','12:15:00',3.62),('8348','2014-04-30','12:20:00',3.7),('8348','2014-04-30','12:25:00',5.01),('8348','2014-04-30','12:30:00',3.1),('8348','2014-04-30','12:35:00',3.98),('8348','2014-04-30','12:40:00',6.92),('8348','2014-04-30','12:45:00',6.2),('8348','2014-04-30','12:50:00',7.02),('8348','2014-04-30','12:55:00',7.78),('8348','2014-04-30','13:00:00',3.66),('8348','2014-04-30','13:05:00',3.35),('8348','2014-04-30','13:10:00',3.03),('8348','2014-04-30','13:15:00',3.6),('8348','2014-04-30','13:20:00',6.26),('8348','2014-04-30','13:25:00',6.56),('8348','2014-04-30','13:30:00',8.32),('8348','2014-04-30','13:35:00',7.76),('8348','2014-04-30','13:40:00',3.95),('8348','2014-04-30','13:45:00',2.59),('8348','2014-04-30','13:50:00',3.17),('8348','2014-04-30','13:55:00',3.44),('8348','2014-04-30','14:00:00',2.81),('8348','2014-04-30','14:05:00',2.8),('8348','2014-04-30','14:10:00',2.77),('8348','2014-04-30','14:15:00',2.42),('8348','2014-04-30','14:20:00',2.39),('8348','2014-04-30','14:25:00',2.76),('8348','2014-04-30','14:30:00',3.38),('8348','2014-04-30','14:35:00',5.68),('8348','2014-04-30','14:40:00',7.81),('8348','2014-04-30','14:45:00',7.33),('8348','2014-04-30','14:50:00',5.63),('8348','2014-04-30','14:55:00',4.44),('8348','2014-04-30','15:00:00',2.61),('8348','2014-04-30','15:05:00',3.66),('8348','2014-04-30','15:10:00',3.32),('8348','2014-04-30','15:15:00',3.8),('8348','2014-04-30','15:20:00',2.98),('8348','2014-04-30','15:25:00',3.36),('8348','2014-04-30','15:30:00',4.41),('8348','2014-04-30','15:35:00',2.51),('8348','2014-04-30','15:40:00',4.08),('8348','2014-04-30','15:45:00',5.4),('8348','2014-04-30','15:50:00',6.17),('8348','2014-04-30','15:55:00',4.67),('8348','2014-04-30','16:00:00',3.22),('8348','2014-04-30','16:05:00',4.38),('8348','2014-04-30','16:10:00',2.23),('8348','2014-04-30','16:15:00',1.63),('8348','2014-04-30','16:20:00',2.52),('8348','2014-04-30','16:25:00',1.44),('8348','2014-04-30','16:30:00',1.38),('8348','2014-04-30','16:35:00',1.87),('8348','2014-04-30','16:40:00',2.05),('8348','2014-04-30','16:45:00',1.47),('8348','2014-04-30','16:50:00',1.46),('8348','2014-04-30','16:55:00',1.38),('8348','2014-04-30','17:00:00',1.01),('8348','2014-04-30','17:35:00',1.07),('8348','2014-04-30','17:40:00',1.01),('8348','2014-04-30','17:45:00',1.07),('8348','2014-03-07','09:35:00',1.18),('8348','2014-03-07','09:40:00',1.08),('8348','2014-03-07','09:55:00',1.25),('8348','2014-03-07','10:00:00',1.2),('8348','2014-03-07','10:05:00',1.12),('8348','2014-03-07','10:10:00',1.15),('8348','2014-03-07','10:15:00',1.06),('8348','2014-03-07','10:20:00',1.28),('8348','2014-03-07','10:25:00',1.16),('8348','2014-03-07','10:30:00',1.3),('8348','2014-03-07','10:35:00',1.37),('8348','2014-03-07','10:40:00',1.23),('8348','2014-03-07','10:45:00',1.21),('8348','2014-03-07','10:50:00',1.33),('8348','2014-03-07','10:55:00',1.45),('8348','2014-03-07','11:00:00',1.64),('8348','2014-03-07','11:05:00',1.32),('8348','2014-03-07','11:10:00',1.09),('8348','2014-03-07','11:15:00',1.26),('8348','2014-03-07','11:20:00',1.65),('8348','2014-03-07','11:25:00',1.66),('8348','2014-03-07','11:30:00',1.75),('8348','2014-03-07','11:35:00',1.68),('8348','2014-03-07','11:40:00',1.54),('8348','2014-03-07','11:45:00',3.06),('8348','2014-03-07','11:50:00',4.39),('8348','2014-03-07','11:55:00',6.82),('8348','2014-03-07','12:00:00',7.84),('8348','2014-03-07','12:05:00',5.32),('8348','2014-03-07','12:10:00',7.28),('8348','2014-03-07','12:15:00',6.95),('8348','2014-03-07','12:20:00',7.02),('8348','2014-03-07','12:25:00',6.97),('8348','2014-03-07','12:30:00',6.97),('8348','2014-03-07','12:35:00',6.79),('8348','2014-03-07','12:40:00',4.54),('8348','2014-03-07','12:45:00',2.04),('8348','2014-03-07','12:50:00',2.56),('8348','2014-03-07','12:55:00',1.27),('8348','2014-03-07','13:00:00',2.02),('8348','2014-03-07','13:05:00',4.39),('8348','2014-03-07','13:10:00',1.88),('8348','2014-03-07','13:15:00',1.92),('8348','2014-03-07','13:20:00',3.81),('8348','2014-03-07','13:25:00',5.07),('8348','2014-03-07','13:30:00',4.41),('8348','2014-03-07','13:35:00',4.52),('8348','2014-03-07','13:40:00',4.65),('8348','2014-03-07','13:45:00',3.86),('8348','2014-03-07','13:50:00',2.71),('8348','2014-03-07','13:55:00',2.19),('8348','2014-03-07','14:00:00',2.08),('8348','2014-03-07','14:05:00',1.99),('8348','2014-03-07','14:10:00',2.02),('8348','2014-03-07','14:15:00',2.01),('8348','2014-03-07','14:20:00',1.97),('8348','2014-03-07','14:25:00',1.91),('8348','2014-03-07','14:30:00',2.03),('8348','2014-03-07','14:35:00',2.1),('8348','2014-03-07','14:40:00',2.21),('8348','2014-03-07','14:45:00',2.23),('8348','2014-03-07','14:50:00',2.82),('8348','2014-03-07','14:55:00',4.11),('8348','2014-03-07','15:00:00',4.98),('8348','2014-03-07','15:05:00',5.49),('8348','2014-03-07','15:10:00',5.6),('8348','2014-03-07','15:15:00',5.66),('8348','2014-03-07','15:20:00',5.76),('8348','2014-03-07','15:25:00',5.61),('8348','2014-03-07','15:30:00',5.49),('8348','2014-03-07','15:35:00',5.16),('8348','2014-03-07','15:40:00',4.77),('8348','2014-03-07','15:45:00',4.42),('8348','2014-03-07','15:50:00',3.16),('8348','2014-03-07','15:55:00',1.74),('8348','2014-03-07','16:00:00',3.34),('8348','2014-03-07','16:05:00',3.38),('8348','2014-03-07','16:10:00',3.33),('8348','2014-03-07','16:15:00',3.31),('8348','2014-03-07','16:20:00',3.02),('8348','2014-03-07','16:25:00',2.88),('8348','2014-03-07','16:30:00',2.68),('8348','2014-03-07','16:35:00',2.56),('8348','2014-03-07','16:40:00',2.6),('8348','2014-03-07','16:45:00',2.47),('8348','2014-03-07','16:50:00',2.3),('8348','2014-03-07','16:55:00',2.16),('8348','2014-03-07','17:00:00',2.02),('8348','2014-03-07','17:05:00',1.81),('8348','2014-03-07','17:10:00',1.6),('8348','2014-03-07','17:15:00',1.37),('8348','2014-03-07','17:20:00',1.15),('8348','2014-03-06','08:00:00',1.62),('8348','2014-03-06','08:05:00',1.53),('8348','2014-03-06','08:10:00',1.99),('8348','2014-03-06','08:15:00',2.41),('8348','2014-03-06','08:20:00',2.19),('8348','2014-03-06','08:25:00',1.96),('8348','2014-03-06','08:30:00',1.34),('8348','2014-03-06','08:35:00',1.15),('8348','2014-03-06','08:40:00',1.09),('8348','2014-03-06','08:45:00',1.41),('8348','2014-03-06','08:50:00',1.5),('8348','2014-03-06','08:55:00',1.49),('8348','2014-03-06','09:00:00',1.57),('8348','2014-03-06','09:05:00',1.43),('8348','2014-03-06','09:10:00',1.43),('8348','2014-03-06','09:15:00',1.69),('8348','2014-03-06','09:20:00',1.87),('8348','2014-03-06','09:25:00',1.63),('8348','2014-03-06','09:30:00',1.65),('8348','2014-03-06','09:35:00',1.92),('8348','2014-03-06','09:50:00',3.04),('8348','2014-03-06','09:55:00',3.24),('8348','2014-03-06','10:00:00',3.39),('8348','2014-03-06','10:05:00',3.8),('8348','2014-03-06','10:10:00',4.25),('8348','2014-03-06','10:15:00',4.79),('8348','2014-03-06','10:20:00',4.99),('8348','2014-03-06','10:25:00',3.54),('8348','2014-03-06','10:30:00',1.72),('8348','2014-03-06','10:35:00',2.57),('8348','2014-03-06','10:40:00',3.29),('8348','2014-03-06','10:45:00',2.01),('8348','2014-03-06','10:50:00',2.46),('8348','2014-03-06','10:55:00',2.62),('8348','2014-03-06','11:00:00',4.69),('8348','2014-03-06','11:05:00',5.74),('8348','2014-03-06','11:10:00',4.34),('8348','2014-03-06','11:15:00',4.43),('8348','2014-03-06','11:20:00',3.6),('8348','2014-03-06','11:25:00',3.5),('8348','2014-03-06','11:30:00',2.69),('8348','2014-03-06','11:35:00',2.28),('8348','2014-03-06','11:40:00',2.99),('8348','2014-03-06','11:45:00',6.69),('8348','2014-03-06','11:50:00',4.11),('8348','2014-03-06','11:55:00',5.19),('8348','2014-03-06','12:00:00',2.57),('8348','2014-03-06','12:05:00',5.08),('8348','2014-03-06','12:10:00',7.95),('8348','2014-03-06','12:15:00',6.46),('8348','2014-03-06','12:20:00',2.83),('8348','2014-03-06','12:25:00',5.66),('8348','2014-03-06','12:30:00',7.56),('8348','2014-03-06','12:35:00',3.19),('8348','2014-03-06','12:40:00',1.3),('8348','2014-03-06','12:55:00',2.26),('8348','2014-03-06','13:00:00',2.6),('8348','2014-03-06','13:05:00',2.46),('8348','2014-03-06','13:10:00',2.29),('8348','2014-03-06','13:15:00',2.59),('8348','2014-03-06','13:20:00',2),('8348','2014-03-06','13:25:00',1.84),('8348','2014-03-06','13:30:00',2),('8348','2014-03-06','13:35:00',1.95),('8348','2014-03-06','13:40:00',2.16),('8348','2014-03-06','13:45:00',1.89),('8348','2014-03-06','13:50:00',1.76),('8348','2014-03-06','13:55:00',1.61),('8348','2014-03-06','14:00:00',1.65),('8348','2014-03-06','14:05:00',1.96),('8348','2014-03-06','14:10:00',1.96),('8348','2014-03-06','14:15:00',1.87),('8348','2014-03-06','14:20:00',2.14),('8348','2014-03-06','14:25:00',1.98),('8348','2014-03-06','14:30:00',1.88),('8348','2014-03-06','14:35:00',3.59),('8348','2014-03-06','14:40:00',2.09),('8348','2014-03-06','14:45:00',1.41),('8348','2014-03-06','14:50:00',1.56),('8348','2014-03-06','14:55:00',1.55),('8348','2014-03-06','15:00:00',1.73),('8348','2014-03-06','15:05:00',2.23),('8348','2014-03-06','15:10:00',2.54),('8348','2014-03-06','15:15:00',1.49),('8348','2014-03-06','15:20:00',1.17),('8348','2014-03-06','15:25:00',1.13),('8348','2014-03-06','15:30:00',1.16),('8348','2014-03-06','15:35:00',1.22),('8348','2014-03-06','15:40:00',1.06),('8348','2014-03-06','16:00:00',1.19),('8348','2014-03-06','16:05:00',1.18),('8348','2014-03-06','16:10:00',1.08),('8348','2014-03-06','16:15:00',1.08),('8348','2014-03-06','16:20:00',1.2),('8348','2014-03-06','16:25:00',1.2),('8348','2014-03-06','16:30:00',1.77),('8348','2014-03-06','16:45:00',1.76),('8348','2014-03-06','16:50:00',1.94),('8348','2014-03-06','16:55:00',1.84),('8348','2014-03-06','17:00:00',1.48),('8348','2014-03-06','17:10:00',1.47),('8348','2014-03-06','17:15:00',1.21),('8348','2014-03-05','07:35:00',1.1),('8348','2014-03-05','07:40:00',1.22),('8348','2014-03-05','07:45:00',1.33),('8348','2014-03-05','07:50:00',1.43),('8348','2014-03-05','07:55:00',1.51),('8348','2014-03-05','08:00:00',1.53),('8348','2014-03-05','08:05:00',1.5),('8348','2014-03-05','08:10:00',1.6),('8348','2014-03-05','08:15:00',1.69),('8348','2014-03-05','08:20:00',1.02),('8348','2014-03-05','08:30:00',1.84),('8348','2014-03-05','08:35:00',2.83),('8348','2014-03-05','08:40:00',2.69),('8348','2014-03-05','08:45:00',2.73),('8348','2014-03-05','08:50:00',1.31),('8348','2014-03-05','08:55:00',1.1),('8348','2014-03-05','09:00:00',3.21),('8348','2014-03-05','09:05:00',2.06),('8348','2014-03-05','09:10:00',1.86),('8348','2014-03-05','09:15:00',3.49),('8348','2014-03-05','09:20:00',3.77),('8348','2014-03-05','09:25:00',3.83),('8348','2014-03-05','09:30:00',3.97),('8348','2014-03-05','09:35:00',3.79),('8348','2014-03-05','09:40:00',4.29),('8348','2014-03-05','09:45:00',4.4),('8348','2014-03-05','09:50:00',4.47),('8348','2014-03-05','09:55:00',4.58),('8348','2014-03-05','10:00:00',4.66),('8348','2014-03-05','10:05:00',4.76),('8348','2014-03-05','10:10:00',4.9),('8348','2014-03-05','10:15:00',4.98),('8348','2014-03-05','10:20:00',5.04),('8348','2014-03-05','10:25:00',5.14),('8348','2014-03-05','10:30:00',5.21),('8348','2014-03-05','10:35:00',5.3),('8348','2014-03-05','10:40:00',5.36),('8348','2014-03-05','10:45:00',5.43),('8348','2014-03-05','10:50:00',5.53),('8348','2014-03-05','10:55:00',5.6),('8348','2014-03-05','11:00:00',5.71),('8348','2014-03-05','11:05:00',5.85),('8348','2014-03-05','11:10:00',5.91),('8348','2014-03-05','11:15:00',6.03),('8348','2014-03-05','11:20:00',6.11),('8348','2014-03-05','11:25:00',6.17),('8348','2014-03-05','11:30:00',6.32),('8348','2014-03-05','11:35:00',6.73),('8348','2014-03-05','11:40:00',6.32),('8348','2014-03-05','11:45:00',6.53),('8348','2014-03-05','11:50:00',6.46),('8348','2014-03-05','11:55:00',5.61),('8348','2014-03-05','12:00:00',5.89),('8348','2014-03-05','12:05:00',4.75),('8348','2014-03-05','12:10:00',3.52),('8348','2014-03-05','12:15:00',1.62),('8348','2014-03-05','12:20:00',1.42),('8348','2014-03-05','12:25:00',1.44),('8348','2014-03-05','12:30:00',2.39),('8348','2014-03-05','12:35:00',2.71),('8348','2014-03-05','12:40:00',2.48),('8348','2014-03-05','12:45:00',1.95),('8348','2014-03-05','12:50:00',2.59),('8348','2014-03-05','12:55:00',3.01),('8348','2014-03-05','13:00:00',3.48),('8348','2014-03-05','13:05:00',4.85),('8348','2014-03-05','13:10:00',6.47),('8348','2014-03-05','13:15:00',3.98),('8348','2014-03-05','13:20:00',4.17),('8348','2014-03-05','13:25:00',3.73),('8348','2014-03-05','13:30:00',2.15),('8348','2014-03-05','13:35:00',2.36),('8348','2014-03-05','13:40:00',2.78),('8348','2014-03-05','13:45:00',2.58),('8348','2014-03-05','13:50:00',2.23),('8348','2014-03-05','13:55:00',2.07),('8348','2014-03-05','14:00:00',1.96),('8348','2014-03-05','14:05:00',2.02),('8348','2014-03-05','14:10:00',1.99),('8348','2014-03-05','14:15:00',2.17),('8348','2014-03-05','14:20:00',2.27),('8348','2014-03-05','14:25:00',2.51),('8348','2014-03-05','14:30:00',2.62),('8348','2014-03-05','14:35:00',2.2),('8348','2014-03-05','14:40:00',2.83),('8348','2014-03-05','14:45:00',3.53),('8348','2014-03-05','14:50:00',3.27),('8348','2014-03-05','14:55:00',2.43),('8348','2014-03-05','15:00:00',1.67),('8348','2014-03-05','15:05:00',1.41),('8348','2014-03-05','15:10:00',1.39),('8348','2014-03-05','15:15:00',1.36),('8348','2014-03-05','15:20:00',1.29),('8348','2014-03-05','15:25:00',1.42),('8348','2014-03-05','15:30:00',1.83),('8348','2014-03-05','15:35:00',2.13),('8348','2014-03-05','15:40:00',3.13),('8348','2014-03-05','15:45:00',3.86),('8348','2014-03-05','15:50:00',2.28),('8348','2014-03-05','15:55:00',3.93),('8348','2014-03-05','16:00:00',5.13),('8348','2014-03-05','16:05:00',4.55),('8348','2014-03-05','16:10:00',3.59),('8348','2014-03-05','16:15:00',2.29),('8348','2014-03-04','08:50:00',1.09),('8348','2014-03-04','09:00:00',1.09),('8348','2014-03-04','09:05:00',1.61),('8348','2014-03-04','09:10:00',2.66),('8348','2014-03-04','09:15:00',3.3),('8348','2014-03-04','09:20:00',3.77),('8348','2014-03-04','09:25:00',1.47),('8348','2014-03-04','09:30:00',1.72),('8348','2014-03-04','09:35:00',1.68),('8348','2014-03-04','09:40:00',1.82),('8348','2014-03-04','09:45:00',1.75),('8348','2014-03-04','09:50:00',1.24),('8348','2014-03-04','09:55:00',3.06),('8348','2014-03-04','10:00:00',2.53),('8348','2014-03-04','10:05:00',1.79),('8348','2014-03-04','10:10:00',1.2),('8348','2014-03-04','10:20:00',1.65),('8348','2014-03-04','10:25:00',4.69),('8348','2014-03-04','10:30:00',3.82),('8348','2014-03-04','10:35:00',5.82),('8348','2014-03-04','10:40:00',6.89),('8348','2014-03-04','10:45:00',6.66),('8348','2014-03-04','10:50:00',2.87),('8348','2014-03-04','10:55:00',5),('8348','2014-03-04','11:00:00',4.68),('8348','2014-03-04','11:05:00',4.56),('8348','2014-03-04','11:10:00',6.73),('8348','2014-03-04','11:15:00',7.97),('8348','2014-03-04','11:20:00',4.98),('8348','2014-03-04','11:25:00',1.52),('8348','2014-03-04','11:30:00',1.9),('8348','2014-03-04','11:35:00',1.39),('8348','2014-03-04','11:40:00',1.62),('8348','2014-03-04','11:45:00',3.4),('8348','2014-03-04','11:50:00',7.51),('8348','2014-03-04','11:55:00',6.94),('8348','2014-03-04','12:00:00',6.71),('8348','2014-03-04','12:05:00',6.58),('8348','2014-03-04','12:10:00',6.55),('8348','2014-03-04','12:15:00',6.54),('8348','2014-03-04','12:20:00',6.56),('8348','2014-03-04','12:25:00',6.6),('8348','2014-03-04','12:30:00',6.48),('8348','2014-03-04','12:35:00',6.44),('8348','2014-03-04','12:40:00',6.51),('8348','2014-03-04','12:45:00',4.34),('8348','2014-03-04','12:50:00',5.78),('8348','2014-03-04','12:55:00',4.73),('8348','2014-03-04','13:00:00',6.71),('8348','2014-03-04','13:05:00',4.53),('8348','2014-03-04','13:10:00',7.04),('8348','2014-03-04','13:15:00',4.44),('8348','2014-03-04','13:20:00',3.31),('8348','2014-03-04','13:25:00',1.85),('8348','2014-03-04','13:30:00',1.89),('8348','2014-03-04','13:35:00',1.41),('8348','2014-03-04','13:40:00',1.18),('8348','2014-03-04','13:45:00',2.1),('8348','2014-03-04','13:50:00',2.42),('8348','2014-03-04','13:55:00',2.25),('8348','2014-03-04','14:00:00',1.34),('8348','2014-03-04','14:05:00',3.46),('8348','2014-03-04','14:10:00',4.71),('8348','2014-03-04','14:15:00',6.38),('8348','2014-03-04','14:20:00',3.86),('8348','2014-03-04','14:25:00',6.47),('8348','2014-03-04','14:30:00',5.83),('8348','2014-03-04','14:35:00',5.57),('8348','2014-03-04','14:40:00',5.51),('8348','2014-03-04','14:45:00',5.21),('8348','2014-03-04','14:50:00',5.81),('8348','2014-03-04','14:55:00',4.18),('8348','2014-03-04','15:00:00',5.61),('8348','2014-03-04','15:05:00',5.14),('8348','2014-03-04','15:10:00',4.88),('8348','2014-03-04','15:15:00',4.67),('8348','2014-03-04','15:20:00',2.95),('8348','2014-03-04','15:25:00',3.71),('8348','2014-03-04','15:30:00',1.56),('8348','2014-03-04','15:35:00',5.09),('8348','2014-03-04','15:40:00',4.53),('8348','2014-03-04','15:45:00',4.3),('8348','2014-03-04','15:50:00',3),('8348','2014-03-04','15:55:00',1.25),('8348','2014-03-04','16:00:00',1.19),('8348','2014-03-04','16:05:00',1.73),('8348','2014-03-04','16:10:00',1.93),('8348','2014-03-04','16:15:00',1.46),('8348','2014-03-04','16:20:00',1.76),('8348','2014-03-04','16:25:00',2.57),('8348','2014-03-04','16:30:00',1.83),('8348','2014-03-04','16:35:00',1.76),('8348','2014-03-04','16:40:00',2.01),('8348','2014-03-04','16:45:00',2.13),('8348','2014-03-04','16:50:00',1.95),('8348','2014-03-04','16:55:00',1.6),('8348','2014-03-04','17:00:00',1.27),('8348','2014-03-03','08:30:00',1.04),('8348','2014-03-03','08:35:00',1.1),('8348','2014-03-03','08:40:00',1.18),('8348','2014-03-03','08:45:00',1.26),('8348','2014-03-03','08:50:00',1.27),('8348','2014-03-03','08:55:00',1.49),('8348','2014-03-03','09:00:00',1.53),('8348','2014-03-03','09:05:00',1.59),('8348','2014-03-03','09:10:00',1.49),('8348','2014-03-03','09:15:00',1.6),('8348','2014-03-03','09:20:00',1.78),('8348','2014-03-03','09:25:00',1.89),('8348','2014-03-03','09:30:00',1.91),('8348','2014-03-03','09:35:00',1.68),('8348','2014-03-03','09:40:00',1.61),('8348','2014-03-03','09:45:00',1.71),('8348','2014-03-03','09:50:00',1.73),('8348','2014-03-03','09:55:00',2),('8348','2014-03-03','10:00:00',2.22),('8348','2014-03-03','10:05:00',2.36),('8348','2014-03-03','10:10:00',2.39),('8348','2014-03-03','10:15:00',2.43),('8348','2014-03-03','10:20:00',2.47),('8348','2014-03-03','10:25:00',2.52),('8348','2014-03-03','10:30:00',2.56),('8348','2014-03-03','10:35:00',2.57),('8348','2014-03-03','10:40:00',2.6),('8348','2014-03-03','10:45:00',2.65),('8348','2014-03-03','10:50:00',2.72),('8348','2014-03-03','10:55:00',2.74),('8348','2014-03-03','11:00:00',2.76),('8348','2014-03-03','11:05:00',2.84),('8348','2014-03-03','11:10:00',2.85),('8348','2014-03-03','11:15:00',2.87),('8348','2014-03-03','11:20:00',2.94),('8348','2014-03-03','11:25:00',2.95),('8348','2014-03-03','11:30:00',3.01),('8348','2014-03-03','11:35:00',2.51),('8348','2014-03-03','11:40:00',3.14),('8348','2014-03-03','11:45:00',3.12),('8348','2014-03-03','11:50:00',3.2),('8348','2014-03-03','11:55:00',3.21),('8348','2014-03-03','12:00:00',3.24),('8348','2014-03-03','12:05:00',3.25),('8348','2014-03-03','12:10:00',3.25),('8348','2014-03-03','12:15:00',3.27),('8348','2014-03-03','12:20:00',3.29),('8348','2014-03-03','12:25:00',3.28),('8348','2014-03-03','12:30:00',3.29),('8348','2014-03-03','12:35:00',3.27),('8348','2014-03-03','12:40:00',3.26),('8348','2014-03-03','12:45:00',3.25),('8348','2014-03-03','12:50:00',3.24),('8348','2014-03-03','12:55:00',3.24),('8348','2014-03-03','13:00:00',3.24),('8348','2014-03-03','13:05:00',3.23),('8348','2014-03-03','13:10:00',3.22),('8348','2014-03-03','13:15:00',3.21),('8348','2014-03-03','13:20:00',3.2),('8348','2014-03-03','13:25:00',3.19),('8348','2014-03-03','13:30:00',3.19),('8348','2014-03-03','13:35:00',3.16),('8348','2014-03-03','13:40:00',3.12),('8348','2014-03-03','13:45:00',3.11),('8348','2014-03-03','13:50:00',3.09),('8348','2014-03-03','13:55:00',3.06),('8348','2014-03-03','14:00:00',3.05),('8348','2014-03-03','14:05:00',3.07),('8348','2014-03-03','14:10:00',3.08),('8348','2014-03-03','14:15:00',3.05),('8348','2014-03-03','14:20:00',2.95),('8348','2014-03-03','14:25:00',2.56),('8348','2014-03-03','14:30:00',2.88),('8348','2014-03-03','14:35:00',2.84),('8348','2014-03-03','14:40:00',2.79),('8348','2014-03-03','14:45:00',2.72),('8348','2014-03-03','14:50:00',2.65),('8348','2014-03-03','14:55:00',2.6),('8348','2014-03-03','15:00:00',2.54),('8348','2014-03-03','15:05:00',2.43),('8348','2014-03-03','15:10:00',2.44),('8348','2014-03-03','15:15:00',2.36),('8348','2014-03-03','15:20:00',2.32),('8348','2014-03-03','15:25:00',2.26),('8348','2014-03-03','15:30:00',2.19),('8348','2014-03-03','15:35:00',2.12),('8348','2014-03-03','15:40:00',2.04),('8348','2014-03-03','15:45:00',1.98),('8348','2014-03-03','15:50:00',1.9),('8348','2014-03-03','15:55:00',1.83),('8348','2014-03-03','16:00:00',1.74),('8348','2014-03-03','16:05:00',1.66),('8348','2014-03-03','16:10:00',1.58),('8348','2014-03-03','16:15:00',1.5),('8348','2014-03-03','16:20:00',1.43),('8348','2014-03-03','16:25:00',1.35),('8348','2014-03-03','16:30:00',1.26),('8348','2014-03-03','16:35:00',1.18),('8348','2014-03-03','16:40:00',1.08),('8348','2014-03-02','08:10:00',1.12),('8348','2014-03-02','08:15:00',1.04),('8348','2014-03-02','08:20:00',1.02),('8348','2014-03-02','08:30:00',1.02),('8348','2014-03-02','08:35:00',1.07),('8348','2014-03-02','08:40:00',1.15),('8348','2014-03-02','08:45:00',1.2),('8348','2014-03-02','08:50:00',1.32),('8348','2014-03-02','08:55:00',1.42),('8348','2014-03-02','09:00:00',1.49),('8348','2014-03-02','09:05:00',1.6),('8348','2014-03-02','09:10:00',1.74),('8348','2014-03-02','09:15:00',1.87),('8348','2014-03-02','09:20:00',1.41),('8348','2014-03-02','09:25:00',1.99),('8348','2014-03-02','09:30:00',2.19),('8348','2014-03-02','09:35:00',2.19),('8348','2014-03-02','09:40:00',2.1),('8348','2014-03-02','10:00:00',1.31),('8348','2014-03-02','10:05:00',1.38),('8348','2014-03-02','10:10:00',1.26),('8348','2014-03-02','10:15:00',1.14),('8348','2014-03-02','10:20:00',1.14),('8348','2014-03-02','10:25:00',1.29),('8348','2014-03-02','10:30:00',1.41),('8348','2014-03-02','10:35:00',2.12),('8348','2014-03-02','10:40:00',2.81),('8348','2014-03-02','10:50:00',1.26),('8348','2014-03-02','10:55:00',1.21),('8348','2014-03-02','11:00:00',2.14),('8348','2014-03-02','11:05:00',2.98),('8348','2014-03-02','11:10:00',1.54),('8348','2014-03-02','11:15:00',1.12),('8348','2014-03-02','11:20:00',1.48),('8348','2014-03-02','11:25:00',1.77),('8348','2014-03-02','11:30:00',1.85),('8348','2014-03-02','11:35:00',2.98),('8348','2014-03-02','11:40:00',2.35),('8348','2014-03-02','11:45:00',3.48),('8348','2014-03-02','11:50:00',3.89),('8348','2014-03-02','11:55:00',3.74),('8348','2014-03-02','12:00:00',2.67),('8348','2014-03-02','12:05:00',1.81),('8348','2014-03-02','12:10:00',1.4),('8348','2014-03-02','12:15:00',2.46),('8348','2014-03-02','12:20:00',2.03),('8348','2014-03-02','12:25:00',1.71),('8348','2014-03-02','12:30:00',1.34),('8348','2014-03-02','12:35:00',1.05),('8348','2014-03-02','12:55:00',1.11),('8348','2014-03-02','13:00:00',1.33),('8348','2014-03-02','13:05:00',1.43),('8348','2014-03-02','13:10:00',1.43),('8348','2014-03-02','13:15:00',1.33),('8348','2014-03-02','13:20:00',1.24),('8348','2014-03-02','13:25:00',1.15),('8348','2014-03-02','13:30:00',1.04),('8348','2014-03-02','14:00:00',1.1),('8348','2014-03-02','14:05:00',1.23),('8348','2014-03-02','14:10:00',1.2),('8348','2014-03-02','14:15:00',1.17),('8348','2014-03-02','14:20:00',1.09),('8348','2014-03-02','14:25:00',1.08),('8348','2014-03-02','14:30:00',1.12),('8348','2014-03-02','14:35:00',1.12),('8348','2014-03-02','14:40:00',1.11),('8348','2014-03-02','14:45:00',1.16),('8348','2014-03-02','14:50:00',1.17),('8348','2014-03-02','14:55:00',1.14),('8348','2014-03-02','15:00:00',1.2),('8348','2014-03-02','15:05:00',1.28),('8348','2014-03-02','15:10:00',1.33),('8348','2014-03-02','15:15:00',1.28),('8348','2014-03-02','15:20:00',1.25),('8348','2014-03-02','15:25:00',1.22),('8348','2014-03-02','15:30:00',1.29),('8348','2014-03-02','15:35:00',1.23),('8348','2014-03-02','15:40:00',1.32),('8348','2014-03-02','15:45:00',1.16),('8348','2014-03-02','15:50:00',1.04),('8348','2014-02-28','08:20:00',1.2),('8348','2014-02-28','08:35:00',1.23),('8348','2014-02-28','09:25:00',1.04),('8348','2014-02-28','09:30:00',1.48),('8348','2014-02-28','09:40:00',1.78),('8348','2014-02-28','09:45:00',2.25),('8348','2014-02-28','09:50:00',2.7),('8348','2014-02-28','09:55:00',1.96),('8348','2014-02-28','10:00:00',1.02),('8348','2014-02-28','10:10:00',1.33),('8348','2014-02-28','10:15:00',1.03),('8348','2014-02-28','10:20:00',1.6),('8348','2014-02-28','10:25:00',2.33),('8348','2014-02-28','10:30:00',2.9),('8348','2014-02-28','10:35:00',2.04),('8348','2014-02-28','10:40:00',1.08),('8348','2014-02-28','11:20:00',1.27),('8348','2014-02-28','11:25:00',1.3),('8348','2014-02-28','11:30:00',1.14),('8348','2014-02-28','11:55:00',1.02),('8348','2014-02-28','12:00:00',1.3),('8348','2014-02-28','12:05:00',1.98),('8348','2014-02-28','12:10:00',1.81),('8348','2014-02-28','12:25:00',1.8),('8348','2014-02-28','12:30:00',1.9),('8348','2014-02-28','12:35:00',3.25),('8348','2014-02-28','12:40:00',2.81),('8348','2014-02-28','12:45:00',1.15),('8348','2014-02-28','12:50:00',3.13),('8348','2014-02-28','12:55:00',1.86),('8348','2014-02-28','13:00:00',2.45),('8348','2014-02-28','13:05:00',1.55),('8348','2014-02-28','13:10:00',1.43),('8348','2014-02-28','13:15:00',1.03),('8348','2014-02-28','13:50:00',3.75),('8348','2014-02-28','13:55:00',2.56),('8348','2014-02-28','14:00:00',1.24),('8348','2014-02-28','14:20:00',1.25),('8348','2014-02-28','14:25:00',1.78),('8348','2014-02-28','14:30:00',1.65),('8348','2014-02-28','14:35:00',1.35),('8348','2014-02-28','14:40:00',1.21),('8348','2014-02-28','14:45:00',1.19),('8348','2014-02-28','14:50:00',1.27),('8348','2014-02-28','14:55:00',1.37),('8348','2014-02-28','15:00:00',1.98),('8348','2014-02-28','15:05:00',1.58),('8348','2014-02-28','15:25:00',2.27),('8348','2014-02-28','15:30:00',1.73),('8348','2014-02-28','15:35:00',1.8),('8348','2014-02-28','15:40:00',1.77),('8348','2014-02-28','16:15:00',1.86),('8348','2014-02-28','16:20:00',1.54),('8348','2014-02-28','16:35:00',1),('8348','2014-02-28','16:40:00',1.34),('8348','2014-02-28','16:45:00',1.47),('8348','2014-02-28','16:50:00',1.24),('8348','2014-02-27','10:40:00',1.08),('8348','2014-02-27','10:45:00',1.17),('8348','2014-02-27','10:50:00',1.2),('8348','2014-02-27','10:55:00',1.27),('8348','2014-02-27','11:00:00',1.43),('8348','2014-02-27','11:05:00',1.57),('8348','2014-02-27','11:10:00',1.45),('8348','2014-02-27','11:15:00',1.4),('8348','2014-02-27','11:20:00',1.3),('8348','2014-02-27','11:25:00',1.43),('8348','2014-02-27','11:30:00',1.75),('8348','2014-02-27','11:35:00',1.62),('8348','2014-02-27','11:40:00',1.36),('8348','2014-02-27','11:45:00',1.17),('8348','2014-02-27','11:50:00',1.13),('8348','2014-02-27','11:55:00',1.19),('8348','2014-02-27','12:00:00',1.17),('8348','2014-02-27','12:05:00',1.15),('8348','2014-02-27','12:10:00',1.09),('8348','2014-02-27','12:15:00',1.16),('8348','2014-02-27','12:20:00',1.2),('8348','2014-02-27','12:25:00',1.22),('8348','2014-02-27','12:30:00',1.15),('8348','2014-02-27','12:35:00',1.12),('8348','2014-02-27','12:40:00',1.1),('8348','2014-02-27','12:45:00',1.08),('8348','2014-02-27','12:50:00',1.06),('8348','2014-02-27','12:55:00',1.08),('8348','2014-02-27','13:00:00',1.14),('8348','2014-02-27','13:10:00',1.03),('8348','2014-02-27','13:15:00',1.15),('8348','2014-02-27','13:20:00',1.17),('8348','2014-02-27','13:25:00',1.25),('8348','2014-02-27','13:30:00',1.43),('8348','2014-02-27','13:35:00',1.53),('8348','2014-02-27','13:40:00',1.58),('8348','2014-02-27','13:45:00',1.57),('8348','2014-02-27','13:50:00',1.61),('8348','2014-02-27','13:55:00',1.82),('8348','2014-02-27','14:00:00',1.85),('8348','2014-02-27','14:05:00',1.57),('8348','2014-02-27','14:10:00',1.46),('8348','2014-02-27','14:15:00',1.33),('8348','2014-02-27','14:20:00',1.33),('8348','2014-02-27','14:25:00',1.31),('8348','2014-02-27','14:30:00',1.4),('8348','2014-02-27','14:35:00',1.32),('8348','2014-02-27','14:40:00',1.13),('8348','2014-02-27','14:45:00',1.19),('8348','2014-02-27','14:50:00',1.14),('8348','2014-02-27','14:55:00',1.03),('8348','2014-02-27','15:00:00',1.1),('8348','2014-02-27','15:05:00',1.09),('8348','2014-02-27','15:10:00',1.12),('8348','2014-02-27','15:15:00',1.28),('8348','2014-02-27','15:20:00',1.4),('8348','2014-02-27','15:25:00',1.25),('8348','2014-02-27','15:30:00',1.23),('8348','2014-02-27','15:35:00',1.19),('8348','2014-02-27','16:50:00',1.02),('8348','2014-02-27','16:55:00',1.08),('8348','2014-02-26','08:35:00',1.06),('8348','2014-02-26','08:40:00',1.15),('8348','2014-02-26','08:45:00',1.31),('8348','2014-02-26','08:50:00',1.2),('8348','2014-02-26','08:55:00',1.26),('8348','2014-02-26','09:00:00',1.36),('8348','2014-02-26','09:05:00',1.38),('8348','2014-02-26','09:10:00',1.47),('8348','2014-02-26','09:15:00',1.58),('8348','2014-02-26','09:20:00',1.71),('8348','2014-02-26','09:25:00',1.88),('8348','2014-02-26','09:30:00',1.74),('8348','2014-02-26','09:35:00',1.57),('8348','2014-02-26','09:40:00',1.47),('8348','2014-02-26','09:45:00',1.37),('8348','2014-02-26','09:50:00',1.25),('8348','2014-02-26','09:55:00',1.29),('8348','2014-02-26','10:00:00',1.12),('8348','2014-02-26','11:55:00',1.04),('8348','2014-02-26','12:00:00',1.11),('8348','2014-02-26','12:05:00',1.16),('8348','2014-02-26','12:10:00',1.21),('8348','2014-02-26','12:15:00',1.12),('8348','2014-02-26','12:20:00',1.08),('8348','2014-02-26','12:25:00',1.82),('8348','2014-02-26','12:30:00',1.82),('8348','2014-02-26','12:35:00',2.22),('8348','2014-02-26','12:40:00',2.86),('8348','2014-02-26','12:45:00',3.4),('8348','2014-02-26','12:50:00',3.33),('8348','2014-02-26','12:55:00',3.22),('8348','2014-02-26','13:00:00',2.77),('8348','2014-02-26','13:05:00',2.32),('8348','2014-02-26','13:10:00',2.73),('8348','2014-02-26','13:15:00',2.52),('8348','2014-02-26','13:20:00',1.97),('8348','2014-02-26','13:25:00',1.92),('8348','2014-02-26','13:30:00',1.93),('8348','2014-02-26','13:35:00',1.9),('8348','2014-02-26','13:40:00',1.94),('8348','2014-02-26','13:45:00',1.44),('8348','2014-02-26','13:50:00',1.28),('8348','2014-02-26','13:55:00',1.78),('8348','2014-02-26','14:00:00',3.03),('8348','2014-02-26','14:05:00',2.34),('8348','2014-02-26','14:10:00',1.04),('8348','2014-02-26','14:15:00',1.53),('8348','2014-02-26','14:20:00',2.72),('8348','2014-02-26','14:25:00',2.26),('8348','2014-02-26','14:30:00',1.06),('8348','2014-02-26','14:35:00',1.78),('8348','2014-02-26','14:40:00',2.81),('8348','2014-02-26','14:45:00',2.65),('8348','2014-02-26','14:50:00',2.74),('8348','2014-02-26','14:55:00',2.73),('8348','2014-02-26','15:00:00',2.51),('8348','2014-02-26','15:05:00',2.3),('8348','2014-02-26','15:10:00',2.41),('8348','2014-02-26','15:15:00',2.06),('8348','2014-02-26','15:20:00',1.38),('8348','2014-02-26','15:30:00',1.11),('8348','2014-02-26','15:35:00',1.62),('8348','2014-02-26','15:40:00',1.65),('8348','2014-02-26','15:45:00',1.31),('8348','2014-02-26','15:50:00',1.26),('8348','2014-02-26','15:55:00',1.44),('8348','2014-02-26','16:00:00',1.63),('8348','2014-02-26','16:05:00',1.4),('8348','2014-02-26','16:10:00',1.06),('8348','2014-04-29','08:40:00',1.04),('8348','2014-04-29','08:45:00',1.44),('8348','2014-04-29','08:50:00',1.86),('8348','2014-04-29','08:55:00',2.02),('8348','2014-04-29','09:00:00',2.04),('8348','2014-04-29','09:05:00',3.03),('8348','2014-04-29','09:10:00',5.57),('8348','2014-04-29','09:15:00',5.8),('8348','2014-04-29','09:20:00',5.12),('8348','2014-04-29','09:25:00',6.4),('8348','2014-04-29','09:30:00',6.47),('8348','2014-04-29','09:35:00',6.4),('8348','2014-04-29','09:40:00',6.49),('8348','2014-04-29','09:45:00',6.59),('8348','2014-04-29','09:50:00',6.66),('8348','2014-04-29','09:55:00',6.18),('8348','2014-04-29','10:00:00',6.63),('8348','2014-04-29','10:05:00',6.57),('8348','2014-04-29','10:10:00',6.99),('8348','2014-04-29','10:15:00',7.27),('8348','2014-04-29','10:20:00',6.9),('8348','2014-04-29','10:25:00',6.92),('8348','2014-04-29','10:30:00',5.37),('8348','2014-04-29','10:35:00',4.56),('8348','2014-04-29','10:40:00',5.64),('8348','2014-04-29','10:45:00',5.43),('8348','2014-04-29','10:50:00',2.03),('8348','2014-04-29','10:55:00',2.08),('8348','2014-04-29','11:00:00',2.67),('8348','2014-04-29','11:05:00',3.04),('8348','2014-04-29','11:10:00',3.06),('8348','2014-04-29','11:15:00',2.9),('8348','2014-04-29','11:20:00',5.04),('8348','2014-04-29','11:25:00',4.18),('8348','2014-04-29','11:30:00',3.21),('8348','2014-04-29','11:35:00',2.86),('8348','2014-04-29','11:40:00',3.96),('8348','2014-04-29','11:45:00',4.82),('8348','2014-04-29','11:50:00',4.26),('8348','2014-04-29','11:55:00',2.92),('8348','2014-04-29','12:00:00',4.55),('8348','2014-04-29','12:05:00',3.47),('8348','2014-04-29','12:10:00',3.6),('8348','2014-04-29','12:15:00',4.01),('8348','2014-04-29','12:20:00',5.71),('8348','2014-04-29','12:25:00',5.05),('8348','2014-04-29','12:30:00',5.31),('8348','2014-04-29','12:35:00',3.37),('8348','2014-04-29','12:40:00',3.05),('8348','2014-04-29','12:45:00',7),('8348','2014-04-29','12:50:00',2.78),('8348','2014-04-29','12:55:00',1.56),('8348','2014-04-29','13:35:00',1.02),('8348','2014-04-29','13:40:00',1.12),('8348','2014-04-29','14:00:00',1.29),('8348','2014-04-29','14:05:00',1.71),('8348','2014-04-29','14:10:00',1.37),('8348','2014-04-29','14:25:00',1.22),('8348','2014-04-29','14:30:00',1.38),('8348','2014-04-29','14:35:00',1.41),('8348','2014-04-29','15:05:00',1.14),('8348','2014-04-29','15:10:00',1.33),('8348','2014-04-29','15:15:00',1.62),('8348','2014-04-29','15:20:00',1.79),('8348','2014-04-29','15:25:00',1.87),('8348','2014-04-29','15:30:00',1.53),('8348','2014-04-29','15:35:00',1.32),('8348','2014-04-29','15:40:00',1.18),('8348','2014-04-29','15:45:00',1.17),('8348','2014-04-29','15:50:00',1.24),('8348','2014-04-29','15:55:00',1.47),('8348','2014-04-29','16:00:00',1.78),('8348','2014-04-29','16:05:00',2.22),('8348','2014-04-29','16:10:00',2.04),('8348','2014-04-29','16:15:00',1.62),('8348','2014-04-29','16:20:00',2.23),('8348','2014-04-29','16:25:00',2.77),('8348','2014-04-29','16:30:00',4.21),('8348','2014-04-29','16:35:00',3.28),('8348','2014-04-29','16:40:00',3.93),('8348','2014-04-29','16:45:00',3.25),('8348','2014-04-29','16:55:00',1),('8348','2014-04-29','17:00:00',1.18),('8348','2014-04-29','17:05:00',1.24),('8348','2014-02-25','08:40:00',1.02),('8348','2014-02-25','08:45:00',1.09),('8348','2014-02-25','08:50:00',1.13),('8348','2014-02-25','08:55:00',1.22),('8348','2014-02-25','09:00:00',1.3),('8348','2014-02-25','09:05:00',1.36),('8348','2014-02-25','09:10:00',1.42),('8348','2014-02-25','09:15:00',1.51),('8348','2014-02-25','09:20:00',1.61),('8348','2014-02-25','09:25:00',1.68),('8348','2014-02-25','09:30:00',1.74),('8348','2014-02-25','09:35:00',1.79),('8348','2014-02-25','09:40:00',1.84),('8348','2014-02-25','09:45:00',1.9),('8348','2014-02-25','09:50:00',1.97),('8348','2014-02-25','09:55:00',2.02),('8348','2014-02-25','10:00:00',2.09),('8348','2014-02-25','10:05:00',2.14),('8348','2014-02-25','10:10:00',2.19),('8348','2014-02-25','10:15:00',2.24),('8348','2014-02-25','10:20:00',2.28),('8348','2014-02-25','10:25:00',2.32),('8348','2014-02-25','10:30:00',2.36),('8348','2014-02-25','10:35:00',2.39),('8348','2014-02-25','10:40:00',2.42),('8348','2014-02-25','10:45:00',2.45),('8348','2014-02-25','10:50:00',2.52),('8348','2014-02-25','10:55:00',2.56),('8348','2014-02-25','11:00:00',2.57),('8348','2014-02-25','11:05:00',2.59),('8348','2014-02-25','11:10:00',2.6),('8348','2014-02-25','11:15:00',2.63),('8348','2014-02-25','11:20:00',2.68),('8348','2014-02-25','11:25:00',2.7),('8348','2014-02-25','11:30:00',2.69),('8348','2014-02-25','11:35:00',2.7),('8348','2014-02-25','11:40:00',2.72),('8348','2014-02-25','11:45:00',2.75),('8348','2014-02-25','11:50:00',2.76),('8348','2014-02-25','11:55:00',2.75),('8348','2014-02-25','12:00:00',2.79),('8348','2014-02-25','12:05:00',2.84),('8348','2014-02-25','12:10:00',2.86),('8348','2014-02-25','12:15:00',2.82),('8348','2014-02-25','12:20:00',2.85),('8348','2014-02-25','12:25:00',2.91),('8348','2014-02-25','12:30:00',2.88),('8348','2014-02-25','12:35:00',2.89),('8348','2014-02-25','12:40:00',2.89),('8348','2014-02-25','12:45:00',2.91),('8348','2014-02-25','12:50:00',2.92),('8348','2014-02-25','12:55:00',2.96),('8348','2014-02-25','13:00:00',2.91),('8348','2014-02-25','13:05:00',2.82),('8348','2014-02-25','13:10:00',2.73),('8348','2014-02-25','13:15:00',2.38),('8348','2014-02-25','13:20:00',1.59),('8348','2014-02-25','13:25:00',1.35),('8348','2014-02-25','13:40:00',1.19),('8348','2014-02-25','13:45:00',1.21),('8348','2014-02-25','13:55:00',1.05),('8348','2014-02-25','14:00:00',1.24),('8348','2014-02-25','14:05:00',1.07),('8348','2014-02-25','14:10:00',1),('8348','2014-02-25','14:15:00',1.07),('8348','2014-02-25','14:20:00',1.09),('8348','2014-02-25','14:25:00',1.91),('8348','2014-02-25','14:30:00',2.36),('8348','2014-02-25','14:35:00',2.26),('8348','2014-02-25','14:40:00',2.68),('8348','2014-02-25','14:45:00',2.69),('8348','2014-02-25','14:50:00',2.5),('8348','2014-02-25','14:55:00',2.27),('8348','2014-02-25','15:00:00',1.96),('8348','2014-02-25','15:05:00',2.22),('8348','2014-02-25','15:10:00',2.12),('8348','2014-02-25','15:15:00',2.1),('8348','2014-02-25','15:20:00',2),('8348','2014-02-25','15:25:00',1.73),('8348','2014-02-25','15:30:00',1.62),('8348','2014-02-25','15:35:00',1.5),('8348','2014-02-25','15:40:00',1.54),('8348','2014-02-25','15:45:00',1.02),('8348','2014-02-25','15:55:00',1.04),('8348','2014-02-25','16:15:00',1.04),('8348','2014-02-25','16:20:00',1.06),('8348','2014-02-24','08:30:00',1.01),('8348','2014-02-24','08:35:00',1.16),('8348','2014-02-24','08:45:00',1.16),('8348','2014-02-24','08:50:00',1.17),('8348','2014-02-24','08:55:00',1.21),('8348','2014-02-24','09:00:00',1.25),('8348','2014-02-24','09:05:00',1.32),('8348','2014-02-24','09:10:00',1.37),('8348','2014-02-24','09:15:00',1.46),('8348','2014-02-24','09:20:00',1.57),('8348','2014-02-24','09:25:00',1.65),('8348','2014-02-24','09:30:00',1.72),('8348','2014-02-24','09:35:00',1.78),('8348','2014-02-24','09:40:00',1.83),('8348','2014-02-24','09:45:00',1.89),('8348','2014-02-24','09:50:00',1.95),('8348','2014-02-24','09:55:00',2.01),('8348','2014-02-24','10:00:00',2.08),('8348','2014-02-24','10:05:00',2.13),('8348','2014-02-24','10:10:00',2.19),('8348','2014-02-24','10:15:00',2.24),('8348','2014-02-24','10:20:00',2.31),('8348','2014-02-24','10:25:00',2.36),('8348','2014-02-24','10:30:00',2.4),('8348','2014-02-24','10:35:00',2.45),('8348','2014-02-24','10:40:00',2.49),('8348','2014-02-24','10:45:00',2.53),('8348','2014-02-24','10:50:00',2.58),('8348','2014-02-24','10:55:00',2.61),('8348','2014-02-24','11:00:00',2.64),('8348','2014-02-24','11:05:00',2.67),('8348','2014-02-24','11:10:00',2.7),('8348','2014-02-24','11:15:00',2.69),('8348','2014-02-24','11:20:00',2.78),('8348','2014-02-24','11:25:00',2.89),('8348','2014-02-24','11:30:00',3.2),('8348','2014-02-24','11:35:00',2.1),('8348','2014-02-24','11:40:00',2.33),('8348','2014-02-24','11:45:00',2.21),('8348','2014-02-24','11:50:00',2.89),('8348','2014-02-24','11:55:00',2.39),('8348','2014-02-24','12:00:00',2.39),('8348','2014-02-24','12:05:00',3.09),('8348','2014-02-24','12:10:00',2.92),('8348','2014-02-24','12:15:00',2.87),('8348','2014-02-24','12:20:00',2.43),('8348','2014-02-24','12:25:00',2.35),('8348','2014-02-24','12:30:00',1.45),('8348','2014-02-24','12:35:00',3.02),('8348','2014-02-24','12:40:00',3.32),('8348','2014-02-24','12:45:00',3.23),('8348','2014-02-24','12:50:00',3.17),('8348','2014-02-24','12:55:00',3.18),('8348','2014-02-24','13:00:00',3),('8348','2014-02-24','13:05:00',2.61),('8348','2014-02-24','13:10:00',3.63),('8348','2014-02-24','13:15:00',1.51),('8348','2014-02-24','15:20:00',1.05),('8348','2014-02-24','15:25:00',1.14),('8348','2014-02-24','15:30:00',1.19),('8348','2014-02-24','15:35:00',1.91),('8348','2014-02-24','15:40:00',2.34),('8348','2014-02-24','15:45:00',2.23),('8348','2014-02-24','15:50:00',1.78),('8348','2014-02-24','15:55:00',1.74),('8348','2014-02-24','16:00:00',2.06),('8348','2014-02-24','16:05:00',1.94),('8348','2014-02-24','16:10:00',1.83),('8348','2014-02-24','16:15:00',1.67),('8348','2014-02-24','16:20:00',1.42),('8348','2014-02-24','16:25:00',1.19),('8348','2014-02-23','08:45:00',1.03),('8348','2014-02-23','08:50:00',1.09),('8348','2014-02-23','08:55:00',1.15),('8348','2014-02-23','09:00:00',1.22),('8348','2014-02-23','09:05:00',1.3),('8348','2014-02-23','09:10:00',1.37),('8348','2014-02-23','09:15:00',1.49),('8348','2014-02-23','09:20:00',1.58),('8348','2014-02-23','09:25:00',1.61),('8348','2014-02-23','09:30:00',1.53),('8348','2014-02-23','09:35:00',1.77),('8348','2014-02-23','09:40:00',1.84),('8348','2014-02-23','09:45:00',1.87),('8348','2014-02-23','09:50:00',1.91),('8348','2014-02-23','09:55:00',1.96),('8348','2014-02-23','10:00:00',2.02),('8348','2014-02-23','10:05:00',2.07),('8348','2014-02-23','10:10:00',2.1),('8348','2014-02-23','10:15:00',2.17),('8348','2014-02-23','10:20:00',2.22),('8348','2014-02-23','10:25:00',2.28),('8348','2014-02-23','10:30:00',2.34),('8348','2014-02-23','10:35:00',2.37),('8348','2014-02-23','10:40:00',2.42),('8348','2014-02-23','10:45:00',2.47),('8348','2014-02-23','10:50:00',2.52),('8348','2014-02-23','10:55:00',2.56),('8348','2014-02-23','11:00:00',2.61),('8348','2014-02-23','11:05:00',2.6),('8348','2014-02-23','11:10:00',2.69),('8348','2014-02-23','11:15:00',2.69),('8348','2014-02-23','11:20:00',2.76),('8348','2014-02-23','11:25:00',2.79),('8348','2014-02-23','11:30:00',2.32),('8348','2014-02-23','11:35:00',2.85),('8348','2014-02-23','11:40:00',2.8),('8348','2014-02-23','11:45:00',1.99),('8348','2014-02-23','11:50:00',1.97),('8348','2014-02-23','11:55:00',2.2),('8348','2014-02-23','12:00:00',3.11),('8348','2014-02-23','12:05:00',3.19),('8348','2014-02-23','12:10:00',3.26),('8348','2014-02-23','12:15:00',3.29),('8348','2014-02-23','12:20:00',2.33),('8348','2014-02-23','12:25:00',1.79),('8348','2014-02-23','12:30:00',2.43),('8348','2014-02-23','12:35:00',3.38),('8348','2014-02-23','12:40:00',1.78),('8348','2014-02-23','12:45:00',1.92),('8348','2014-02-23','12:50:00',1.55),('8348','2014-02-23','12:55:00',1.78),('8348','2014-02-23','13:00:00',2.1),('8348','2014-02-23','13:05:00',3.14),('8348','2014-02-23','13:10:00',3.09),('8348','2014-02-23','13:15:00',3.04),('8348','2014-02-23','13:20:00',3.03),('8348','2014-02-23','13:25:00',3.02),('8348','2014-02-23','13:30:00',2.98),('8348','2014-02-23','13:35:00',2.85),('8348','2014-02-23','13:40:00',2.67),('8348','2014-02-23','13:45:00',1.88),('8348','2014-02-23','14:00:00',2.19),('8348','2014-02-23','14:05:00',2.69),('8348','2014-02-23','14:10:00',3.04),('8348','2014-02-23','14:15:00',2.03),('8348','2014-02-23','14:20:00',1.98),('8348','2014-02-23','14:25:00',2.78),('8348','2014-02-23','14:30:00',2.85),('8348','2014-02-23','14:35:00',2.1),('8348','2014-02-23','14:40:00',1.1),('8348','2014-02-23','14:45:00',1.11),('8348','2014-02-23','14:50:00',1.08),('8348','2014-02-22','10:00:00',1.25),('8348','2014-02-22','10:05:00',1.59),('8348','2014-02-22','10:10:00',1.79),('8348','2014-02-22','10:15:00',1.74),('8348','2014-02-22','10:20:00',1.21),('8348','2014-02-22','10:25:00',1.76),('8348','2014-02-22','10:30:00',2.01),('8348','2014-02-22','10:35:00',1.52),('8348','2014-02-22','10:40:00',1.68),('8348','2014-02-22','10:45:00',3.03),('8348','2014-02-22','10:50:00',2.97),('8348','2014-02-22','10:55:00',1.03),('8348','2014-02-22','12:05:00',1.18),('8348','2014-02-22','12:10:00',1.48),('8348','2014-02-22','12:15:00',1.65),('8348','2014-02-22','12:20:00',1.48),('8348','2014-02-22','12:25:00',1.51),('8348','2014-02-22','12:35:00',1.09),('8348','2014-02-22','12:40:00',1.25),('8348','2014-02-22','12:45:00',2.98),('8348','2014-02-22','12:50:00',2.78),('8348','2014-02-22','12:55:00',1.35),('8348','2014-02-22','13:00:00',1.3),('8348','2014-02-22','13:05:00',2.01),('8348','2014-02-22','13:10:00',4.1),('8348','2014-02-22','13:15:00',2.28),('8348','2014-02-22','13:20:00',1.5),('8348','2014-02-22','13:30:00',1.18),('8348','2014-02-22','13:35:00',1.98),('8348','2014-02-22','13:40:00',1.86),('8348','2014-02-22','13:45:00',1.65),('8348','2014-02-22','13:50:00',1.86),('8348','2014-02-22','13:55:00',2.98),('8348','2014-02-22','14:00:00',3.16),('8348','2014-02-22','14:05:00',3.16),('8348','2014-02-22','14:10:00',2.96),('8348','2014-02-22','14:15:00',2.91),('8348','2014-02-22','14:20:00',2.81),('8348','2014-02-22','14:25:00',2.14),('8348','2014-02-22','14:30:00',2.79),('8348','2014-02-22','14:35:00',2.57),('8348','2014-02-22','14:40:00',2.39),('8348','2014-02-22','14:45:00',2.75),('8348','2014-02-22','14:50:00',2.28),('8348','2014-02-22','15:00:00',1.77),('8348','2014-02-22','15:05:00',2.21),('8348','2014-02-22','15:10:00',1.65),('8348','2014-02-22','15:15:00',1.98),('8348','2014-02-22','15:20:00',1.25),('8348','2014-02-22','15:25:00',2.03),('8348','2014-02-22','15:30:00',1.4),('8348','2014-02-22','15:45:00',1.63),('8348','2014-02-22','15:50:00',1.8),('8348','2014-02-22','16:00:00',1.35),('8348','2014-02-22','16:10:00',1.04),('8348','2014-02-22','16:15:00',1.3),('8348','2014-02-22','16:20:00',1.23),('8348','2014-02-22','16:25:00',1.13),('8348','2014-02-21','09:50:00',1.05),('8348','2014-02-21','09:55:00',1.03),('8348','2014-02-21','10:00:00',1.06),('8348','2014-02-21','10:05:00',1.26),('8348','2014-02-21','10:10:00',1.17),('8348','2014-02-21','10:15:00',1.29),('8348','2014-02-21','10:20:00',1.72),('8348','2014-02-21','10:25:00',1.97),('8348','2014-02-21','10:30:00',2.31),('8348','2014-02-21','10:35:00',1.69),('8348','2014-02-21','10:40:00',1.53),('8348','2014-02-21','10:45:00',1.47),('8348','2014-02-21','10:50:00',1.34),('8348','2014-02-21','10:55:00',1.88),('8348','2014-02-21','11:00:00',1.49),('8348','2014-02-21','11:05:00',1.32),('8348','2014-02-21','11:10:00',1.31),('8348','2014-02-21','11:15:00',1.46),('8348','2014-02-21','11:20:00',1.37),('8348','2014-02-21','11:25:00',1.44),('8348','2014-02-21','11:30:00',2.05),('8348','2014-02-21','11:35:00',1.6),('8348','2014-02-21','11:40:00',1.68),('8348','2014-02-21','11:45:00',1.4),('8348','2014-02-21','11:50:00',1.94),('8348','2014-02-21','11:55:00',1.88),('8348','2014-02-21','12:00:00',3.03),('8348','2014-02-21','12:05:00',3.53),('8348','2014-02-21','12:10:00',3.27),('8348','2014-02-21','12:15:00',2.78),('8348','2014-02-21','12:20:00',1.61),('8348','2014-02-21','12:25:00',1.42),('8348','2014-02-21','12:30:00',1.59),('8348','2014-02-21','12:35:00',1.27),('8348','2014-02-21','12:40:00',1.02),('8348','2014-02-21','15:25:00',1.16),('8348','2014-02-21','15:30:00',1.59),('8348','2014-02-21','15:35:00',1.79),('8348','2014-02-21','15:40:00',1.69),('8348','2014-02-21','15:45:00',1.63),('8348','2014-02-21','15:50:00',1.52),('8348','2014-02-21','15:55:00',1.44),('8348','2014-02-21','16:00:00',1.37),('8348','2014-02-21','16:05:00',1.29),('8348','2014-02-21','16:10:00',1.21),('8348','2014-02-21','16:15:00',1.13),('8348','2014-02-21','16:20:00',1.05),('8348','2014-02-20','11:25:00',1.09),('8348','2014-02-20','11:30:00',1.08),('8348','2014-02-20','12:40:00',1.05),('8348','2014-02-20','12:55:00',1.08),('8348','2014-02-20','13:00:00',1.32),('8348','2014-02-20','13:15:00',1.09),('8348','2014-02-20','13:30:00',1.09),('8348','2014-02-19','09:35:00',1.02),('8348','2014-02-19','09:40:00',1.1),('8348','2014-02-19','09:45:00',1.31),('8348','2014-02-19','09:50:00',1.23),('8348','2014-02-19','09:55:00',1.15),('8348','2014-02-19','10:00:00',1.12),('8348','2014-02-19','10:05:00',1.12),('8348','2014-02-19','10:10:00',1.21),('8348','2014-02-19','10:15:00',1.28),('8348','2014-02-19','10:20:00',1.17),('8348','2014-02-19','10:25:00',1.2),('8348','2014-02-19','10:30:00',1.27),('8348','2014-02-19','10:35:00',1.33),('8348','2014-02-19','10:40:00',1.52),('8348','2014-02-19','10:45:00',1.65),('8348','2014-02-19','10:50:00',1.57),('8348','2014-02-19','10:55:00',1.41),('8348','2014-02-19','11:00:00',1.28),('8348','2014-02-19','11:05:00',1.28),('8348','2014-02-19','11:10:00',1.42),('8348','2014-02-19','11:15:00',1.44),('8348','2014-02-19','11:20:00',1.56),('8348','2014-02-19','11:25:00',1.46),('8348','2014-02-19','11:30:00',1.33),('8348','2014-02-19','11:35:00',1.31),('8348','2014-02-19','11:40:00',1.28),('8348','2014-02-19','11:45:00',1.18),('8348','2014-02-19','11:50:00',1.24),('8348','2014-02-19','11:55:00',1.12),('8348','2014-02-19','12:00:00',1.19),('8348','2014-02-19','12:05:00',1.3),('8348','2014-02-19','12:10:00',1.28),('8348','2014-02-19','12:15:00',1.25),('8348','2014-02-19','12:20:00',1.08),('8348','2014-02-19','12:25:00',1.26),('8348','2014-02-19','12:30:00',1.42),('8348','2014-02-19','12:35:00',1.2),('8348','2014-02-19','12:40:00',1.1),('8348','2014-02-19','12:45:00',1.12),('8348','2014-02-19','13:05:00',1.04),('8348','2014-02-19','13:15:00',1.12),('8348','2014-02-19','13:20:00',1.11),('8348','2014-02-19','13:25:00',1.35),('8348','2014-02-19','13:30:00',1.36),('8348','2014-02-19','13:35:00',1.57),('8348','2014-02-19','13:40:00',1.46),('8348','2014-02-19','13:45:00',1.76),('8348','2014-02-19','13:50:00',1.9),('8348','2014-02-19','13:55:00',1.68),('8348','2014-02-19','14:00:00',1.57),('8348','2014-02-19','14:05:00',1.64),('8348','2014-02-19','14:10:00',1.31),('8348','2014-02-19','14:15:00',1.16),('8348','2014-02-19','14:20:00',1.86),('8348','2014-02-19','14:25:00',1.45),('8348','2014-02-19','14:30:00',1.41),('8348','2014-02-19','14:35:00',1.48),('8348','2014-02-19','14:40:00',1.25),('8348','2014-02-19','14:45:00',1.14),('8348','2014-02-19','14:50:00',1.53),('8348','2014-02-19','14:55:00',1.31),('8348','2014-02-19','15:05:00',1),('8348','2014-02-19','15:10:00',1.04),('8348','2014-02-19','15:15:00',1.16),('8348','2014-02-19','15:25:00',1.04),('8348','2014-02-19','15:50:00',1.06),('8348','2014-02-18','08:55:00',1.03),('8348','2014-02-18','09:00:00',1.09),('8348','2014-02-18','09:05:00',1.16),('8348','2014-02-18','09:10:00',1.22),('8348','2014-02-18','09:15:00',1.3),('8348','2014-02-18','09:20:00',1.37),('8348','2014-02-18','09:25:00',1.44),('8348','2014-02-18','09:30:00',1.54),('8348','2014-02-18','09:35:00',1.59),('8348','2014-02-18','09:40:00',1.65),('8348','2014-02-18','09:45:00',1.71),('8348','2014-02-18','09:50:00',1.77),('8348','2014-02-18','09:55:00',1.83),('8348','2014-02-18','10:00:00',1.89),('8348','2014-02-18','10:05:00',1.94),('8348','2014-02-18','10:10:00',1.98),('8348','2014-02-18','10:15:00',2.02),('8348','2014-02-18','10:20:00',2.06),('8348','2014-02-18','10:25:00',2.11),('8348','2014-02-18','10:30:00',2.15),('8348','2014-02-18','10:35:00',2.18),('8348','2014-02-18','10:40:00',2.23),('8348','2014-02-18','10:45:00',2.26),('8348','2014-02-18','10:50:00',2.3),('8348','2014-02-18','10:55:00',2.35),('8348','2014-02-18','11:00:00',2.4),('8348','2014-02-18','11:05:00',2.1),('8348','2014-02-18','11:10:00',2.03),('8348','2014-02-18','11:15:00',1.97),('8348','2014-02-18','11:20:00',2.17),('8348','2014-02-18','11:25:00',2.49),('8348','2014-02-18','11:30:00',2.28),('8348','2014-02-18','11:35:00',2.22),('8348','2014-02-18','11:40:00',1.75),('8348','2014-02-18','11:45:00',1.71),('8348','2014-02-18','11:50:00',1.52),('8348','2014-02-18','11:55:00',1.35),('8348','2014-02-18','12:00:00',1.33),('8348','2014-02-18','12:05:00',1.34),('8348','2014-02-18','12:10:00',1.51),('8348','2014-02-18','12:15:00',1.64),('8348','2014-02-18','12:20:00',1.64),('8348','2014-02-18','12:25:00',1.86),('8348','2014-02-18','12:30:00',2),('8348','2014-02-18','12:35:00',1.57),('8348','2014-02-18','12:40:00',1.42),('8348','2014-02-18','12:45:00',1.37),('8348','2014-02-18','12:50:00',1.46),('8348','2014-02-18','12:55:00',1.61),('8348','2014-02-18','13:00:00',1.27),('8348','2014-02-18','13:05:00',1.19),('8348','2014-02-18','13:10:00',1.25),('8348','2014-02-18','13:15:00',1.64),('8348','2014-02-18','13:20:00',1.82),('8348','2014-02-18','13:25:00',2.24),('8348','2014-02-18','13:30:00',1.65),('8348','2014-02-18','13:35:00',1.33),('8348','2014-02-18','13:40:00',1.67),('8348','2014-02-18','13:45:00',1.93),('8348','2014-02-18','13:50:00',1.52),('8348','2014-02-18','13:55:00',1.5),('8348','2014-02-18','14:00:00',1.65),('8348','2014-02-18','14:05:00',2.38),('8348','2014-02-18','14:10:00',1.48),('8348','2014-02-18','14:15:00',1.15),('8348','2014-02-18','14:20:00',1.02),('8348','2014-02-18','14:25:00',1.04),('8348','2014-02-18','14:30:00',1.29),('8348','2014-02-18','14:35:00',1.24),('8348','2014-02-18','14:40:00',1.06),('8348','2014-02-18','15:40:00',1.18),('8348','2014-02-18','15:45:00',1.26),('8348','2014-02-18','16:05:00',1.04),('8348','2014-02-17','09:00:00',1.01),('8348','2014-02-17','09:05:00',1.08),('8348','2014-02-17','09:10:00',1.14),('8348','2014-02-17','09:15:00',1.22),('8348','2014-02-17','09:20:00',1.28),('8348','2014-02-17','09:25:00',1.36),('8348','2014-02-17','09:30:00',1.46),('8348','2014-02-17','09:35:00',1.53),('8348','2014-02-17','09:40:00',1.57),('8348','2014-02-17','09:45:00',1.62),('8348','2014-02-17','09:50:00',1.65),('8348','2014-02-17','09:55:00',1.71),('8348','2014-02-17','10:00:00',1.77),('8348','2014-02-17','10:05:00',1.82),('8348','2014-02-17','10:10:00',1.86),('8348','2014-02-17','10:15:00',1.89),('8348','2014-02-17','10:20:00',1.92),('8348','2014-02-17','10:25:00',1.96),('8348','2014-02-17','10:30:00',2),('8348','2014-02-17','10:35:00',2.02),('8348','2014-02-17','10:40:00',2.03),('8348','2014-02-17','10:45:00',2.06),('8348','2014-02-17','10:50:00',2.09),('8348','2014-02-17','10:55:00',2.14),('8348','2014-02-17','11:00:00',2.14),('8348','2014-02-17','11:05:00',2.17),('8348','2014-02-17','11:10:00',2.2),('8348','2014-02-17','11:15:00',2.25),('8348','2014-02-17','11:20:00',2.27),('8348','2014-02-17','11:25:00',2.36),('8348','2014-02-17','11:30:00',2.43),('8348','2014-02-17','11:35:00',2.49),('8348','2014-02-17','11:40:00',2.53),('8348','2014-02-17','11:45:00',2.56),('8348','2014-02-17','11:50:00',2.58),('8348','2014-02-17','11:55:00',2.59),('8348','2014-02-17','12:00:00',2.6),('8348','2014-02-17','12:05:00',2.61),('8348','2014-02-17','12:10:00',2.62),('8348','2014-02-17','12:15:00',2.61),('8348','2014-02-17','12:20:00',2.61),('8348','2014-02-17','12:25:00',2.62),('8348','2014-02-17','12:30:00',2.64),('8348','2014-02-17','12:35:00',2.64),('8348','2014-02-17','12:40:00',2.63),('8348','2014-02-17','12:45:00',2.62),('8348','2014-02-17','12:50:00',2.61),('8348','2014-02-17','12:55:00',2.6),('8348','2014-02-17','13:00:00',2.6),('8348','2014-02-17','13:05:00',2.58),('8348','2014-02-17','13:10:00',2.57),('8348','2014-02-17','13:15:00',2.55),('8348','2014-02-17','13:20:00',2.54),('8348','2014-02-17','13:25:00',2.55),('8348','2014-02-17','13:30:00',2.54),('8348','2014-02-17','13:35:00',2.52),('8348','2014-02-17','13:40:00',2.51),('8348','2014-02-17','13:45:00',2.44),('8348','2014-02-17','13:50:00',2.45),('8348','2014-02-17','13:55:00',2.41),('8348','2014-02-17','14:00:00',2.36),('8348','2014-02-17','14:05:00',2.35),('8348','2014-02-17','14:10:00',2.27),('8348','2014-02-17','14:15:00',2.19),('8348','2014-02-17','14:20:00',2.28),('8348','2014-02-17','14:25:00',2.2),('8348','2014-02-17','14:30:00',2.12),('8348','2014-02-17','14:35:00',2.07),('8348','2014-02-17','14:40:00',1.96),('8348','2014-02-17','14:45:00',2.07),('8348','2014-02-17','14:50:00',1.99),('8348','2014-02-17','14:55:00',1.94),('8348','2014-02-17','15:00:00',1.82),('8348','2014-02-17','15:05:00',1.81),('8348','2014-02-17','15:10:00',1.76),('8348','2014-02-17','15:15:00',1.78),('8348','2014-02-17','15:20:00',1.75),('8348','2014-02-17','15:25:00',1.62),('8348','2014-02-17','15:30:00',1.6),('8348','2014-02-17','15:35:00',1.53),('8348','2014-02-17','15:40:00',1.42),('8348','2014-02-17','15:45:00',1.42),('8348','2014-02-17','15:50:00',1.34),('8348','2014-02-17','15:55:00',1.27),('8348','2014-02-17','16:00:00',1.17),('8348','2014-02-17','16:05:00',1.12),('8348','2014-02-17','16:10:00',1.04),('8348','2014-02-16','08:55:00',1.06),('8348','2014-02-16','09:00:00',1.13),('8348','2014-02-16','09:05:00',1.18),('8348','2014-02-16','09:10:00',1.18),('8348','2014-02-16','09:20:00',1.3),('8348','2014-02-16','09:25:00',1.34),('8348','2014-02-16','09:30:00',1.41),('8348','2014-02-16','09:35:00',1.27),('8348','2014-02-16','09:40:00',1.58),('8348','2014-02-16','09:45:00',1.71),('8348','2014-02-16','09:50:00',1.78),('8348','2014-02-16','09:55:00',1.75),('8348','2014-02-16','10:00:00',1.73),('8348','2014-02-16','10:05:00',1.93),('8348','2014-02-16','10:10:00',1.99),('8348','2014-02-16','10:15:00',2.04),('8348','2014-02-16','10:20:00',2.1),('8348','2014-02-16','10:25:00',2.14),('8348','2014-02-16','10:30:00',2.2),('8348','2014-02-16','10:35:00',2.29),('8348','2014-02-16','10:40:00',2.36),('8348','2014-02-16','10:45:00',2.36),('8348','2014-02-16','10:50:00',2.12),('8348','2014-02-16','10:55:00',2.06),('8348','2014-02-16','11:00:00',2.39),('8348','2014-02-16','11:05:00',2.46),('8348','2014-02-16','11:10:00',2.4),('8348','2014-02-16','11:15:00',2.47),('8348','2014-02-16','11:20:00',2.42),('8348','2014-02-16','11:25:00',2.33),('8348','2014-02-16','11:30:00',2.4),('8348','2014-02-16','11:35:00',2.55),('8348','2014-02-16','11:40:00',2.56),('8348','2014-02-16','11:45:00',2.3),('8348','2014-02-16','11:50:00',2.56),('8348','2014-02-16','11:55:00',2.3),('8348','2014-02-16','12:00:00',2.66),('8348','2014-02-16','12:05:00',2.64),('8348','2014-02-16','12:10:00',2.65),('8348','2014-02-16','12:15:00',2.65),('8348','2014-02-16','12:20:00',2.67),('8348','2014-02-16','12:25:00',2.57),('8348','2014-02-16','12:30:00',2.65),('8348','2014-02-16','12:35:00',2.66),('8348','2014-02-16','12:40:00',2.65),('8348','2014-02-16','12:45:00',2.64),('8348','2014-02-16','12:50:00',2.63),('8348','2014-02-16','12:55:00',2.64),('8348','2014-02-16','13:00:00',2.63),('8348','2014-02-16','13:05:00',2.68),('8348','2014-02-16','13:10:00',2.58),('8348','2014-02-16','13:15:00',2.63),('8348','2014-02-16','13:20:00',2.62),('8348','2014-02-16','13:25:00',2.59),('8348','2014-02-16','13:30:00',2.57),('8348','2014-02-16','13:35:00',2.56),('8348','2014-02-16','13:40:00',2.52),('8348','2014-02-16','13:45:00',2.58),('8348','2014-02-16','13:50:00',2.52),('8348','2014-02-16','13:55:00',2.56),('8348','2014-02-16','14:00:00',2.56),('8348','2014-02-16','14:05:00',2.55),('8348','2014-02-16','14:10:00',2.51),('8348','2014-02-16','14:15:00',2.47),('8348','2014-02-16','14:20:00',2.46),('8348','2014-02-16','14:25:00',2.44),('8348','2014-02-16','14:30:00',2.39),('8348','2014-02-16','14:35:00',2.33),('8348','2014-02-16','14:40:00',2.25),('8348','2014-02-16','14:45:00',2.23),('8348','2014-02-16','14:50:00',2.19),('8348','2014-02-16','14:55:00',2.1),('8348','2014-02-16','15:00:00',2.04),('8348','2014-02-16','15:05:00',2.04),('8348','2014-02-16','15:10:00',1.99),('8348','2014-02-16','15:15:00',1.92),('8348','2014-02-16','15:20:00',1.84),('8348','2014-02-16','15:25:00',1.77),('8348','2014-02-16','15:30:00',1.71),('8348','2014-02-16','15:35:00',1.54),('8348','2014-02-16','15:40:00',1.3),('8348','2014-02-16','15:45:00',1.53),('8348','2014-02-16','15:50:00',1.24),('8348','2014-02-16','16:20:00',1.08),('8348','2014-02-16','16:25:00',1.2),('8348','2014-02-16','16:30:00',1.17),('8348','2014-04-28','06:45:00',1.07),('8348','2014-04-28','06:50:00',1.08),('8348','2014-04-28','06:55:00',1.2),('8348','2014-04-28','07:00:00',1.32),('8348','2014-04-28','07:15:00',2.02),('8348','2014-04-28','07:20:00',2.33),('8348','2014-04-28','07:25:00',2.79),('8348','2014-04-28','07:30:00',2.04),('8348','2014-04-28','07:35:00',2.03),('8348','2014-04-28','07:40:00',2.16),('8348','2014-04-28','07:45:00',2.25),('8348','2014-04-28','07:50:00',1.98),('8348','2014-04-28','07:55:00',2.1),('8348','2014-04-28','08:00:00',1.71),('8348','2014-04-28','08:05:00',1.7),('8348','2014-04-28','08:10:00',2.16),('8348','2014-04-28','08:15:00',3.56),('8348','2014-04-28','08:20:00',1.94),('8348','2014-04-28','08:25:00',2.62),('8348','2014-04-28','08:30:00',5.22),('8348','2014-04-28','08:35:00',3.45),('8348','2014-04-28','08:40:00',3.09),('8348','2014-04-28','08:45:00',4.59),('8348','2014-04-28','08:50:00',4.67),('8348','2014-04-28','08:55:00',2.32),('8348','2014-04-28','09:00:00',3.12),('8348','2014-04-28','09:05:00',3.97),('8348','2014-04-28','09:10:00',4.05),('8348','2014-04-28','09:15:00',3.64),('8348','2014-04-28','09:20:00',3.07),('8348','2014-04-28','09:25:00',1.82),('8348','2014-04-28','09:35:00',1.08),('8348','2014-04-28','09:40:00',1.91),('8348','2014-04-28','09:45:00',2.91),('8348','2014-04-28','09:50:00',3.6),('8348','2014-04-28','09:55:00',3.18),('8348','2014-04-28','10:00:00',3.43),('8348','2014-04-28','10:05:00',4.41),('8348','2014-04-28','10:10:00',4.57),('8348','2014-04-28','10:15:00',4.55),('8348','2014-04-28','10:20:00',4.29),('8348','2014-04-28','10:25:00',3.14),('8348','2014-04-28','10:30:00',3.32),('8348','2014-04-28','10:35:00',2.95),('8348','2014-04-28','10:40:00',2.82),('8348','2014-04-28','10:45:00',3.12),('8348','2014-04-28','10:50:00',3.51),('8348','2014-04-28','10:55:00',3.54),('8348','2014-04-28','11:00:00',3.28),('8348','2014-04-28','11:05:00',2.71),('8348','2014-04-28','11:10:00',3.71),('8348','2014-04-28','11:15:00',5.33),('8348','2014-04-28','11:20:00',5.25),('8348','2014-04-28','11:25:00',5.09),('8348','2014-04-28','11:30:00',5.02),('8348','2014-04-28','11:35:00',4.44),('8348','2014-04-28','11:40:00',3.85),('8348','2014-04-28','11:45:00',3.54),('8348','2014-04-28','11:50:00',4.1),('8348','2014-04-28','11:55:00',4.18),('8348','2014-04-28','12:00:00',4.35),('8348','2014-04-28','12:05:00',5.94),('8348','2014-04-28','12:10:00',5.92),('8348','2014-04-28','12:15:00',4.15),('8348','2014-04-28','12:20:00',4.65),('8348','2014-04-28','12:25:00',5.62),('8348','2014-04-28','12:30:00',7.78),('8348','2014-04-28','12:35:00',6.9),('8348','2014-04-28','12:40:00',7.84),('8348','2014-04-28','12:45:00',7.16),('8348','2014-04-28','12:50:00',7.69),('8348','2014-04-28','12:55:00',5.7),('8348','2014-04-28','13:00:00',5.25),('8348','2014-04-28','13:05:00',7.1),('8348','2014-04-28','13:10:00',7.84),('8348','2014-04-28','13:15:00',4.84),('8348','2014-04-28','13:20:00',7.75),('8348','2014-04-28','13:25:00',6),('8348','2014-04-28','13:30:00',7.44),('8348','2014-04-28','13:35:00',6.01),('8348','2014-04-28','13:40:00',6.63),('8348','2014-04-28','13:45:00',5.27),('8348','2014-04-28','13:50:00',4.34),('8348','2014-04-28','13:55:00',6.89),('8348','2014-04-28','14:00:00',3.92),('8348','2014-04-28','14:05:00',6.02),('8348','2014-04-28','14:10:00',3.63),('8348','2014-04-28','14:15:00',5.48),('8348','2014-04-28','14:20:00',5.35),('8348','2014-04-28','14:25:00',2.73),('8348','2014-04-28','14:30:00',3.47),('8348','2014-04-28','14:35:00',4.75),('8348','2014-04-28','14:40:00',3.95),('8348','2014-04-28','14:45:00',4.1),('8348','2014-04-28','14:50:00',5.36),('8348','2014-04-28','14:55:00',2.94),('8348','2014-04-28','15:00:00',7.43),('8348','2014-04-28','15:05:00',7.31),('8348','2014-04-28','15:10:00',5.71),('8348','2014-04-28','15:15:00',3.01),('8348','2014-04-28','15:20:00',5.35),('8348','2014-04-28','15:25:00',4.05),('8348','2014-04-28','15:30:00',4.78),('8348','2014-04-28','15:35:00',4.39),('8348','2014-04-28','15:40:00',1.45),('8348','2014-04-28','15:45:00',1.25),('8348','2014-04-28','15:50:00',1.45),('8348','2014-04-28','15:55:00',5.48),('8348','2014-04-28','16:00:00',1.76),('8348','2014-04-28','16:05:00',1.09),('8348','2014-04-28','16:15:00',1.04),('8348','2014-04-28','16:20:00',2.18),('8348','2014-04-28','16:25:00',1.85),('8348','2014-04-28','16:30:00',1.57),('8348','2014-04-28','16:35:00',2.14),('8348','2014-04-28','16:40:00',2.73),('8348','2014-04-28','16:45:00',1.51),('8348','2014-04-28','16:50:00',1.32),('8348','2014-04-28','16:55:00',1.25),('8348','2014-04-28','17:10:00',1.16),('8348','2014-04-28','17:15:00',1.21),('8348','2014-04-28','17:25:00',1.03),('8348','2014-04-28','17:35:00',1.13),('8348','2014-02-15','09:00:00',1.01),('8348','2014-02-15','09:05:00',1.06),('8348','2014-02-15','09:10:00',1.13),('8348','2014-02-15','09:15:00',1.17),('8348','2014-02-15','09:20:00',1.24),('8348','2014-02-15','09:25:00',1.32),('8348','2014-02-15','09:30:00',1.41),('8348','2014-02-15','09:35:00',1.5),('8348','2014-02-15','09:40:00',1.57),('8348','2014-02-15','09:45:00',1.64),('8348','2014-02-15','09:50:00',1.69),('8348','2014-02-15','09:55:00',1.74),('8348','2014-02-15','10:00:00',1.79),('8348','2014-02-15','10:05:00',1.84),('8348','2014-02-15','10:10:00',1.89),('8348','2014-02-15','10:15:00',1.94),('8348','2014-02-15','10:20:00',1.99),('8348','2014-02-15','10:25:00',2.02),('8348','2014-02-15','10:30:00',2.04),('8348','2014-02-15','10:35:00',2.08),('8348','2014-02-15','10:40:00',2.11),('8348','2014-02-15','10:45:00',2.16),('8348','2014-02-15','10:50:00',2.16),('8348','2014-02-15','10:55:00',2.23),('8348','2014-02-15','11:00:00',2.17),('8348','2014-02-15','11:05:00',1.95),('8348','2014-02-15','11:10:00',2.42),('8348','2014-02-15','11:15:00',1.97),('8348','2014-02-15','11:20:00',1.76),('8348','2014-02-15','11:25:00',2.1),('8348','2014-02-15','11:30:00',2.67),('8348','2014-02-15','11:35:00',1.31),('8348','2014-02-15','11:40:00',1.82),('8348','2014-02-15','11:45:00',3.05),('8348','2014-02-15','11:50:00',2.78),('8348','2014-02-15','11:55:00',2.76),('8348','2014-02-15','12:00:00',1.08),('8348','2014-02-15','12:05:00',1.23),('8348','2014-02-15','12:10:00',1.09),('8348','2014-02-15','12:15:00',3.1),('8348','2014-02-15','12:20:00',2.99),('8348','2014-02-15','12:25:00',2.16),('8348','2014-02-15','12:30:00',1.41),('8348','2014-02-15','12:35:00',2.23),('8348','2014-02-15','12:40:00',1.8),('8348','2014-02-15','12:45:00',3.23),('8348','2014-02-15','12:50:00',3.26),('8348','2014-02-15','12:55:00',2.85),('8348','2014-02-15','13:00:00',3.16),('8348','2014-02-15','13:05:00',3.09),('8348','2014-02-15','13:10:00',3.16),('8348','2014-02-15','13:15:00',2.64),('8348','2014-02-15','13:20:00',2.83),('8348','2014-02-15','13:25:00',2.74),('8348','2014-02-15','13:30:00',2.73),('8348','2014-02-15','13:35:00',2.68),('8348','2014-02-15','13:40:00',2.62),('8348','2014-02-15','13:45:00',2.59),('8348','2014-02-15','13:50:00',2.62),('8348','2014-02-15','13:55:00',2.57),('8348','2014-02-15','14:00:00',2.5),('8348','2014-02-15','14:05:00',2.46),('8348','2014-02-15','14:10:00',2.44),('8348','2014-02-15','14:15:00',2.38),('8348','2014-02-15','14:20:00',2.35),('8348','2014-02-15','14:25:00',2.33),('8348','2014-02-15','14:30:00',2.23),('8348','2014-02-15','14:35:00',2.2),('8348','2014-02-15','14:40:00',2.18),('8348','2014-02-15','14:45:00',2.12),('8348','2014-02-15','14:50:00',2.02),('8348','2014-02-15','14:55:00',2),('8348','2014-02-15','15:00:00',1.99),('8348','2014-02-15','15:05:00',1.96),('8348','2014-02-15','15:10:00',1.91),('8348','2014-02-15','15:15:00',1.84),('8348','2014-02-15','15:20:00',1.79),('8348','2014-02-15','15:25:00',1.73),('8348','2014-02-15','15:30:00',1.68),('8348','2014-02-15','15:35:00',1.62),('8348','2014-02-15','15:40:00',1.55),('8348','2014-02-15','15:45:00',1.48),('8348','2014-02-15','15:50:00',1.41),('8348','2014-02-15','15:55:00',1.35),('8348','2014-02-15','16:00:00',1.28),('8348','2014-02-15','16:05:00',1.21),('8348','2014-02-15','16:10:00',1.14),('8348','2014-02-15','16:15:00',1.06),('8348','2014-04-27','07:30:00',1.04),('8348','2014-04-27','07:50:00',1.39),('8348','2014-04-27','07:55:00',1.78),('8348','2014-04-27','08:00:00',1.25),('8348','2014-04-27','08:10:00',1.16),('8348','2014-04-27','08:15:00',1.63),('8348','2014-04-27','08:20:00',1.81),('8348','2014-04-27','08:25:00',1.53),('8348','2014-04-27','08:30:00',1.26),('8348','2014-04-27','08:40:00',1.09),('8348','2014-04-27','08:45:00',1.32),('8348','2014-04-27','08:50:00',1.09),('8348','2014-04-27','08:55:00',1.33),('8348','2014-04-27','09:00:00',1.95),('8348','2014-04-27','09:05:00',2.1),('8348','2014-04-27','09:10:00',2.18),('8348','2014-04-27','09:15:00',2.03),('8348','2014-04-27','09:20:00',2.22),('8348','2014-04-27','09:25:00',2.04),('8348','2014-04-27','09:30:00',1.15),('8348','2014-04-27','09:55:00',1.22),('8348','2014-04-27','10:00:00',1.94),('8348','2014-04-27','10:05:00',2.22),('8348','2014-04-27','10:10:00',2.12),('8348','2014-04-27','10:15:00',2.02),('8348','2014-04-27','10:20:00',1.64),('8348','2014-04-27','10:25:00',1.15),('8348','2014-04-27','10:30:00',1.46),('8348','2014-04-27','10:35:00',2.4),('8348','2014-04-27','10:40:00',2.74),('8348','2014-04-27','10:45:00',6.07),('8348','2014-04-27','10:50:00',5.67),('8348','2014-04-27','10:55:00',4.57),('8348','2014-04-27','11:00:00',4.47),('8348','2014-04-27','11:05:00',4.94),('8348','2014-04-27','11:10:00',5.29),('8348','2014-04-27','11:15:00',5.5),('8348','2014-04-27','11:20:00',5.2),('8348','2014-04-27','11:25:00',5.15),('8348','2014-04-27','11:30:00',4.52),('8348','2014-04-27','11:35:00',4.83),('8348','2014-04-27','11:40:00',4.27),('8348','2014-04-27','11:45:00',4.58),('8348','2014-04-27','11:50:00',3.97),('8348','2014-04-27','11:55:00',3.2),('8348','2014-04-27','12:00:00',4.15),('8348','2014-04-27','12:05:00',3.99),('8348','2014-04-27','12:10:00',3.4),('8348','2014-04-27','12:15:00',3.48),('8348','2014-04-27','12:20:00',4.35),('8348','2014-04-27','12:25:00',4),('8348','2014-04-27','12:30:00',3.69),('8348','2014-04-27','12:35:00',3.31),('8348','2014-04-27','12:40:00',2.94),('8348','2014-04-27','12:45:00',3.05),('8348','2014-04-27','12:50:00',3.02),('8348','2014-04-27','12:55:00',2.89),('8348','2014-04-27','13:00:00',3.65),('8348','2014-04-27','13:05:00',4.13),('8348','2014-04-27','13:10:00',3.03),('8348','2014-04-27','13:15:00',2.65),('8348','2014-04-27','13:20:00',3.23),('8348','2014-04-27','13:25:00',3.97),('8348','2014-04-27','13:30:00',4.16),('8348','2014-04-27','13:35:00',4.11),('8348','2014-04-27','13:40:00',4.36),('8348','2014-04-27','13:45:00',3.74),('8348','2014-04-27','13:50:00',3.5),('8348','2014-04-27','13:55:00',3.73),('8348','2014-04-27','14:00:00',3.99),('8348','2014-04-27','14:05:00',5.78),('8348','2014-04-27','14:10:00',7.08),('8348','2014-04-27','14:15:00',5.67),('8348','2014-04-27','14:20:00',3.42),('8348','2014-04-27','14:25:00',2.09),('8348','2014-04-27','14:30:00',1.66),('8348','2014-04-27','14:35:00',1.89),('8348','2014-04-27','14:40:00',2.01),('8348','2014-04-27','14:45:00',1.65),('8348','2014-04-27','14:50:00',1.63),('8348','2014-04-27','14:55:00',1.18),('8537','2014-05-05','07:45:00',1.29),('8537','2014-05-05','07:50:00',1.39),('8537','2014-05-05','07:55:00',1.49),('8537','2014-05-05','08:00:00',1.61),('8537','2014-05-05','08:05:00',1.73),('8537','2014-05-05','08:10:00',1.84),('8537','2014-05-05','08:15:00',1.96),('8537','2014-05-05','08:20:00',2.09),('8537','2014-05-05','08:25:00',2.21),('8537','2014-05-05','08:30:00',2.33),('8537','2014-05-05','08:35:00',2.45),('8537','2014-05-05','08:40:00',2.56),('8537','2014-05-05','08:45:00',2.67),('8537','2014-05-05','08:50:00',2.76),('8537','2014-05-05','08:55:00',2.86),('8537','2014-05-05','09:00:00',2.94),('8537','2014-05-05','09:05:00',3.02),('8537','2014-05-05','09:10:00',3.13),('8537','2014-05-05','09:15:00',3.22),('8537','2014-05-05','09:20:00',3.3),('8537','2014-05-05','09:25:00',3.41),('8537','2014-05-05','09:30:00',3.5),('8537','2014-05-05','09:35:00',3.6),('8537','2014-05-05','09:40:00',3.71),('8537','2014-05-05','09:45:00',3.8),('8537','2014-05-05','09:50:00',3.9),('8537','2014-05-05','09:55:00',3.99),('8537','2014-05-05','10:00:00',3.98),('8537','2014-05-05','10:05:00',4.16),('8537','2014-05-05','10:10:00',4.23),('8537','2014-05-05','10:15:00',4.26),('8537','2014-05-05','10:20:00',4.28),('8537','2014-05-05','10:25:00',4.36),('8537','2014-05-05','10:30:00',4.43),('8537','2014-05-05','10:35:00',4.51),('8537','2014-05-05','10:40:00',4.51),('8537','2014-05-05','10:45:00',4.56),('8537','2014-05-05','10:50:00',4.64),('8537','2014-05-05','10:55:00',4.67),('8537','2014-05-05','11:00:00',4.74),('8537','2014-05-05','11:05:00',4.73),('8537','2014-05-05','11:10:00',4.8),('8537','2014-05-05','11:15:00',4.87),('8537','2014-05-05','11:20:00',4.89),('8537','2014-05-05','11:25:00',4.86),('8537','2014-05-05','11:30:00',4.9),('8537','2014-05-05','11:35:00',4.91),('8537','2014-05-05','11:40:00',5.01),('8537','2014-05-05','11:45:00',5.06),('8537','2014-05-05','11:50:00',5.12),('8537','2014-05-05','11:55:00',4.84),('8537','2014-05-05','12:00:00',3.46),('8537','2014-05-05','12:05:00',2.65),('8537','2014-05-05','12:10:00',2.54),('8537','2014-05-05','12:15:00',3.49),('8537','2014-05-05','12:20:00',2.23),('8537','2014-05-05','12:25:00',4.48),('8537','2014-05-05','12:30:00',3.96),('8537','2014-05-05','12:35:00',2.75),('8537','2014-05-05','12:40:00',2.57),('8537','2014-05-05','12:45:00',5.35),('8537','2014-05-05','12:50:00',4.07),('8537','2014-05-05','12:55:00',1.86),('8537','2014-05-05','13:00:00',3.5),('8537','2014-05-05','13:05:00',4.13),('8537','2014-05-05','13:10:00',5.65),('8537','2014-05-05','13:15:00',5.39),('8537','2014-05-05','13:20:00',5.24),('8537','2014-05-05','13:25:00',5.21),('8537','2014-05-05','13:30:00',5.28),('8537','2014-05-05','13:35:00',5.32),('8537','2014-05-05','13:40:00',5.23),('8537','2014-05-05','13:45:00',5.22),('8537','2014-05-05','13:50:00',5.25),('8537','2014-05-05','13:55:00',5.25),('8537','2014-05-05','14:00:00',5.27),('8537','2014-05-05','14:05:00',5.46),('8537','2014-05-05','14:10:00',5.5),('8537','2014-05-05','14:15:00',5.26),('8537','2014-05-05','14:20:00',5.83),('8537','2014-05-05','14:25:00',4.85),('8537','2014-05-05','14:30:00',3.98),('8537','2014-05-05','14:35:00',2.08),('8537','2014-05-05','14:40:00',2.13),('8537','2014-05-05','14:45:00',1.5),('8537','2014-05-05','14:50:00',1.5),('8537','2014-05-05','14:55:00',1.88),('8537','2014-05-05','15:00:00',1.84),('8537','2014-05-05','15:05:00',4.02),('8537','2014-05-05','15:10:00',2.22),('8537','2014-05-05','15:15:00',1.59),('8537','2014-05-05','15:20:00',1.84),('8537','2014-05-05','15:25:00',2.43),('8537','2014-05-05','15:30:00',4.86),('8537','2014-05-05','15:35:00',4.67),('8537','2014-05-05','15:40:00',4.39),('8537','2014-05-05','15:45:00',2.31),('8537','2014-05-05','15:50:00',1.64),('8537','2014-05-05','15:55:00',1.58),('8537','2014-05-05','16:00:00',1.35),('8537','2014-05-05','16:05:00',2.56),('8537','2014-05-05','16:10:00',1.52),('8537','2014-05-05','16:15:00',1.54),('8537','2014-05-05','16:20:00',1.54),('8537','2014-05-05','16:25:00',1.33),('8537','2014-05-05','16:30:00',1.1),('8537','2014-05-05','16:40:00',2.25),('8537','2014-05-05','16:45:00',3.06),('8537','2014-05-05','16:50:00',2.77),('8537','2014-05-05','16:55:00',2.33),('8537','2014-05-05','17:00:00',2.8),('8537','2014-05-05','17:05:00',2.61),('8537','2014-05-05','17:10:00',1.81),('8537','2014-05-05','17:15:00',2.04),('8537','2014-05-05','17:20:00',2.41),('8537','2014-05-05','17:25:00',2.25),('8537','2014-05-05','17:30:00',2.06),('8537','2014-05-05','17:35:00',1.94),('8537','2014-05-05','17:40:00',1.82),('8537','2014-05-05','17:45:00',1.69),('8537','2014-05-05','17:50:00',1.58),('8537','2014-05-05','17:55:00',1.5),('8537','2014-05-05','18:00:00',1.37),('8537','2014-05-05','18:05:00',1.25),('8537','2014-05-05','18:10:00',1.17),('8537','2014-05-05','18:15:00',1.07),('8537','2014-04-26','08:45:00',1.05),('8537','2014-04-26','08:50:00',1.09),('8537','2014-04-26','08:55:00',1.02),('8537','2014-04-26','09:00:00',1.06),('8537','2014-04-26','09:05:00',1.16),('8537','2014-04-26','09:35:00',1.08),('8537','2014-04-26','09:40:00',1.13),('8537','2014-04-26','09:50:00',1.26),('8537','2014-04-26','09:55:00',1.66),('8537','2014-04-26','10:00:00',1.7),('8537','2014-04-26','10:05:00',1.55),('8537','2014-04-26','10:10:00',1.51),('8537','2014-04-26','10:15:00',1.56),('8537','2014-04-26','10:20:00',1.71),('8537','2014-04-26','10:25:00',1.91),('8537','2014-04-26','10:30:00',2.21),('8537','2014-04-26','10:35:00',2.34),('8537','2014-04-26','10:40:00',2.64),('8537','2014-04-26','10:45:00',2.48),('8537','2014-04-26','10:50:00',3.24),('8537','2014-04-26','10:55:00',4.3),('8537','2014-04-26','11:00:00',4.37),('8537','2014-04-26','11:05:00',4.11),('8537','2014-04-26','11:10:00',3.37),('8537','2014-04-26','11:15:00',4.01),('8537','2014-04-26','11:20:00',3.75),('8537','2014-04-26','11:25:00',3.7),('8537','2014-04-26','11:30:00',3.81),('8537','2014-04-26','11:35:00',3.69),('8537','2014-04-26','11:40:00',3.5),('8537','2014-04-26','11:45:00',3.85),('8537','2014-04-26','11:50:00',3.77),('8537','2014-04-26','11:55:00',3.47),('8537','2014-04-26','12:00:00',3.8),('8537','2014-04-26','12:05:00',3.97),('8537','2014-04-26','12:10:00',3.72),('8537','2014-04-26','12:15:00',3.54),('8537','2014-04-26','12:20:00',3.49),('8537','2014-04-26','12:25:00',2.5),('8537','2014-04-26','12:30:00',3.35),('8537','2014-04-26','12:35:00',3.98),('8537','2014-04-26','12:40:00',4.32),('8537','2014-04-26','12:45:00',4.79),('8537','2014-04-26','12:50:00',4.93),('8537','2014-04-26','12:55:00',5.22),('8537','2014-04-26','13:00:00',4.88),('8537','2014-04-26','13:05:00',3.38),('8537','2014-04-26','13:10:00',3.63),('8537','2014-04-26','13:15:00',5.2),('8537','2014-04-26','13:20:00',5.38),('8537','2014-04-26','13:25:00',3.2),('8537','2014-04-26','13:30:00',1.68),('8537','2014-04-26','13:35:00',3.47),('8537','2014-04-26','13:40:00',3.49),('8537','2014-04-26','13:45:00',5.12),('8537','2014-04-26','13:50:00',5.16),('8537','2014-04-26','13:55:00',5.37),('8537','2014-04-26','14:00:00',4.05),('8537','2014-04-26','14:05:00',1.26),('8537','2014-04-26','14:10:00',3.85),('8537','2014-04-26','14:15:00',1.86),('8537','2014-04-26','14:25:00',1.01),('8537','2014-04-26','14:30:00',1.05),('8537','2014-04-26','14:35:00',2.12),('8537','2014-04-26','14:40:00',3.06),('8537','2014-04-26','14:45:00',1.29),('8537','2014-04-26','15:15:00',1.02),('8537','2014-04-26','17:45:00',1.05),('8537','2014-04-26','17:50:00',1.07),('8537','2014-04-25','07:55:00',1.41),('8537','2014-04-25','08:00:00',1.43),('8537','2014-04-25','08:05:00',1.43),('8537','2014-04-25','08:10:00',1.54),('8537','2014-04-25','08:15:00',1.6),('8537','2014-04-25','08:20:00',1.72),('8537','2014-04-25','08:25:00',1.82),('8537','2014-04-25','08:30:00',1.92),('8537','2014-04-25','08:35:00',1.98),('8537','2014-04-25','08:40:00',2.06),('8537','2014-04-25','08:45:00',2.11),('8537','2014-04-25','08:50:00',2.34),('8537','2014-04-25','08:55:00',2.57),('8537','2014-04-25','09:00:00',2.88),('8537','2014-04-25','09:05:00',2.91),('8537','2014-04-25','09:10:00',3.08),('8537','2014-04-25','09:15:00',3.07),('8537','2014-04-25','09:20:00',1.94),('8537','2014-04-25','09:25:00',2),('8537','2014-04-25','09:30:00',3.07),('8537','2014-04-25','09:35:00',1.61),('8537','2014-04-25','09:40:00',1.21),('8537','2014-04-25','09:45:00',1.25),('8537','2014-04-25','09:50:00',1.16),('8537','2014-04-25','09:55:00',1.33),('8537','2014-04-25','10:00:00',1.65),('8537','2014-04-25','10:05:00',1.43),('8537','2014-04-25','10:10:00',1.3),('8537','2014-04-25','10:15:00',1.38),('8537','2014-04-25','10:20:00',1.43),('8537','2014-04-25','10:25:00',1.5),('8537','2014-04-25','10:30:00',1.57),('8537','2014-04-25','10:35:00',3.15),('8537','2014-04-25','10:40:00',3.44),('8537','2014-04-25','10:45:00',3.05),('8537','2014-04-25','10:50:00',4.22),('8537','2014-04-25','10:55:00',4.15),('8537','2014-04-25','11:00:00',3.84),('8537','2014-04-25','11:05:00',2.14),('8537','2014-04-25','11:10:00',2.33),('8537','2014-04-25','11:15:00',3.26),('8537','2014-04-25','11:20:00',5),('8537','2014-04-25','11:25:00',4.51),('8537','2014-04-25','11:30:00',3.86),('8537','2014-04-25','11:35:00',5.06),('8537','2014-04-25','11:40:00',1.82),('8537','2014-04-25','11:45:00',1.82),('8537','2014-04-25','11:50:00',1.49),('8537','2014-04-25','11:55:00',1.71),('8537','2014-04-25','12:00:00',2.59),('8537','2014-04-25','12:05:00',2.57),('8537','2014-04-25','12:10:00',2.02),('8537','2014-04-25','12:15:00',2.7),('8537','2014-04-25','12:20:00',4.83),('8537','2014-04-25','12:25:00',4.68),('8537','2014-04-25','12:30:00',5.05),('8537','2014-04-25','12:35:00',5.22),('8537','2014-04-25','12:40:00',5.4),('8537','2014-04-25','12:45:00',5.48),('8537','2014-04-25','12:50:00',3.64),('8537','2014-04-25','12:55:00',1.75),('8537','2014-04-25','13:00:00',2.81),('8537','2014-04-25','13:05:00',3.83),('8537','2014-04-25','13:10:00',1.98),('8537','2014-04-25','13:15:00',4.33),('8537','2014-04-25','13:20:00',1.65),('8537','2014-04-25','13:25:00',2.27),('8537','2014-04-25','13:30:00',1.6),('8537','2014-04-25','13:35:00',1.32),('8537','2014-04-25','13:40:00',1.85),('8537','2014-04-25','13:45:00',1.87),('8537','2014-04-25','13:50:00',1.35),('8537','2014-04-25','13:55:00',1.98),('8537','2014-04-25','14:00:00',1.52),('8537','2014-04-25','14:05:00',1.77),('8537','2014-04-25','14:10:00',1.52),('8537','2014-04-25','14:15:00',1.44),('8537','2014-04-25','14:20:00',5.19),('8537','2014-04-25','14:25:00',5.49),('8537','2014-04-25','14:30:00',4.68),('8537','2014-04-25','14:35:00',3.99),('8537','2014-04-25','14:40:00',4.6),('8537','2014-04-25','14:45:00',4.62),('8537','2014-04-25','14:50:00',4.59),('8537','2014-04-25','14:55:00',4.58),('8537','2014-04-25','15:00:00',4.49),('8537','2014-04-25','15:05:00',4.39),('8537','2014-04-25','15:10:00',4.33),('8537','2014-04-25','15:15:00',4.29),('8537','2014-04-25','15:20:00',4.1),('8537','2014-04-25','15:25:00',4.02),('8537','2014-04-25','15:30:00',3.78),('8537','2014-04-25','15:35:00',4),('8537','2014-04-25','15:40:00',3.92),('8537','2014-04-25','15:45:00',3.74),('8537','2014-04-25','15:50:00',3.75),('8537','2014-04-25','15:55:00',3.71),('8537','2014-04-25','16:00:00',3.68),('8537','2014-04-25','16:05:00',3.5),('8537','2014-04-25','16:10:00',3.13),('8537','2014-04-25','16:15:00',2.92),('8537','2014-04-25','16:20:00',2.97),('8537','2014-04-25','16:25:00',2.99),('8537','2014-04-25','16:30:00',3.09),('8537','2014-04-25','16:35:00',3.05),('8537','2014-04-25','16:40:00',3.07),('8537','2014-04-25','16:45:00',2.9),('8537','2014-04-25','16:50:00',2.68),('8537','2014-04-25','16:55:00',2.28),('8537','2014-04-25','17:00:00',2.11),('8537','2014-04-25','17:05:00',2.28),('8537','2014-04-25','17:10:00',2),('8537','2014-04-25','17:15:00',2.04),('8537','2014-04-25','17:20:00',1.52),('8537','2014-04-25','17:25:00',1.1),('8537','2014-04-25','17:30:00',1.06),('8537','2014-04-25','17:35:00',1.08),('8537','2014-04-25','17:40:00',1.07),('8537','2014-04-24','07:45:00',1.03),('8537','2014-04-24','07:50:00',1.13),('8537','2014-04-24','07:55:00',1.24),('8537','2014-04-24','08:05:00',1.44),('8537','2014-04-24','08:10:00',1.55),('8537','2014-04-24','08:15:00',1.66),('8537','2014-04-24','08:20:00',1.79),('8537','2014-04-24','08:25:00',1.9),('8537','2014-04-24','08:30:00',2.01),('8537','2014-04-24','08:35:00',2.11),('8537','2014-04-24','08:40:00',2.22),('8537','2014-04-24','08:45:00',2.31),('8537','2014-04-24','08:50:00',2.41),('8537','2014-04-24','08:55:00',2.52),('8537','2014-04-24','09:00:00',2.62),('8537','2014-04-24','09:05:00',2.7),('8537','2014-04-24','09:10:00',2.8),('8537','2014-04-24','09:15:00',2.91),('8537','2014-04-24','09:20:00',2.97),('8537','2014-04-24','09:25:00',3.07),('8537','2014-04-24','09:30:00',3.15),('8537','2014-04-24','09:35:00',3.25),('8537','2014-04-24','09:40:00',3.35),('8537','2014-04-24','09:45:00',3.44),('8537','2014-04-24','09:50:00',3.49),('8537','2014-04-24','09:55:00',3.57),('8537','2014-04-24','10:00:00',3.65),('8537','2014-04-24','10:05:00',3.72),('8537','2014-04-24','10:10:00',3.76),('8537','2014-04-24','10:15:00',3.8),('8537','2014-04-24','10:20:00',3.85),('8537','2014-04-24','10:25:00',3.89),('8537','2014-04-24','10:30:00',3.97),('8537','2014-04-24','10:35:00',4.03),('8537','2014-04-24','10:40:00',4.13),('8537','2014-04-24','10:45:00',4.15),('8537','2014-04-24','10:50:00',4.26),('8537','2014-04-24','10:55:00',4.31),('8537','2014-04-24','11:00:00',4.34),('8537','2014-04-24','11:05:00',4.33),('8537','2014-04-24','11:10:00',4.35),('8537','2014-04-24','11:15:00',4.46),('8537','2014-04-24','11:20:00',4.49),('8537','2014-04-24','11:25:00',4.52),('8537','2014-04-24','11:30:00',4.54),('8537','2014-04-24','11:35:00',4.6),('8537','2014-04-24','11:40:00',4.64),('8537','2014-04-24','11:45:00',4.61),('8537','2014-04-24','11:50:00',4.65),('8537','2014-04-24','11:55:00',4.68),('8537','2014-04-24','12:00:00',4.6),('8537','2014-04-24','12:05:00',4.82),('8537','2014-04-24','12:10:00',4.94),('8537','2014-04-24','12:15:00',2.36),('8537','2014-04-24','12:20:00',3.71),('8537','2014-04-24','12:25:00',5.08),('8537','2014-04-24','12:30:00',5.05),('8537','2014-04-24','12:35:00',5.09),('8537','2014-04-24','12:40:00',5.15),('8537','2014-04-24','12:45:00',5.13),('8537','2014-04-24','12:50:00',5.17),('8537','2014-04-24','12:55:00',5.09),('8537','2014-04-24','13:00:00',4.99),('8537','2014-04-24','13:05:00',5),('8537','2014-04-24','13:10:00',4.98),('8537','2014-04-24','13:15:00',5.07),('8537','2014-04-24','13:20:00',5.25),('8537','2014-04-24','13:25:00',5.14),('8537','2014-04-24','13:30:00',5.14),('8537','2014-04-24','13:35:00',5.1),('8537','2014-04-24','13:40:00',1.54),('8537','2014-04-24','13:45:00',3.89),('8537','2014-04-24','13:50:00',5.59),('8537','2014-04-24','13:55:00',5.69),('8537','2014-04-24','14:00:00',3.32),('8537','2014-04-24','14:05:00',4.99),('8537','2014-04-24','14:10:00',4.9),('8537','2014-04-24','14:15:00',4.1),('8537','2014-04-24','14:20:00',3.93),('8537','2014-04-24','14:25:00',4.86),('8537','2014-04-24','14:30:00',5.24),('8537','2014-04-24','14:35:00',4.85),('8537','2014-04-24','14:40:00',3.64),('8537','2014-04-24','14:45:00',2.95),('8537','2014-04-24','14:50:00',1.85),('8537','2014-04-24','14:55:00',4.48),('8537','2014-04-24','15:00:00',5.37),('8537','2014-04-24','15:05:00',5.18),('8537','2014-04-24','15:10:00',4.9),('8537','2014-04-24','15:15:00',4.44),('8537','2014-04-24','15:20:00',2.9),('8537','2014-04-24','15:25:00',2.55),('8537','2014-04-24','15:30:00',3.18),('8537','2014-04-24','15:35:00',3.05),('8537','2014-04-24','15:40:00',2.56),('8537','2014-04-24','15:45:00',2.34),('8537','2014-04-24','15:50:00',2.61),('8537','2014-04-24','15:55:00',2.98),('8537','2014-04-24','16:00:00',4.25),('8537','2014-04-24','16:05:00',4.13),('8537','2014-04-24','16:10:00',3.44),('8537','2014-04-24','16:15:00',3.8),('8537','2014-04-24','16:20:00',3.4),('8537','2014-04-24','16:25:00',2.85),('8537','2014-04-24','16:30:00',3.25),('8537','2014-04-24','16:35:00',2.07),('8537','2014-04-24','16:40:00',2.26),('8537','2014-04-24','16:45:00',2.21),('8537','2014-04-24','16:50:00',1.64),('8537','2014-04-24','16:55:00',1.75),('8537','2014-04-24','17:00:00',1.59),('8537','2014-04-24','17:05:00',1.44),('8537','2014-04-24','17:10:00',1.35),('8537','2014-04-24','17:15:00',1.23),('8537','2014-04-24','17:20:00',1.24),('8537','2014-04-24','17:25:00',1.22),('8537','2014-04-24','17:30:00',1.19),('8537','2014-04-24','17:35:00',1.14),('8537','2014-04-24','17:40:00',1),('8537','2014-04-23','13:05:00',1.02),('8537','2014-04-23','13:10:00',1.26),('8537','2014-04-23','13:15:00',1.39),('8537','2014-04-23','13:20:00',1.47),('8537','2014-04-23','13:25:00',1.54),('8537','2014-04-23','13:30:00',1.65),('8537','2014-04-23','13:35:00',1.73),('8537','2014-04-23','13:40:00',1.82),('8537','2014-04-23','13:45:00',1.85),('8537','2014-04-23','13:50:00',1.82),('8537','2014-04-23','13:55:00',1.79),('8537','2014-04-23','14:00:00',1.68),('8537','2014-04-23','14:05:00',1.72),('8537','2014-04-23','14:10:00',1.6),('8537','2014-04-23','14:15:00',1.34),('8537','2014-04-23','14:20:00',1.19),('8537','2014-04-23','14:25:00',1.1),('8537','2014-04-23','14:30:00',1.05),('8537','2014-04-23','14:35:00',1.04),('8537','2014-04-23','14:40:00',1.14),('8537','2014-04-23','14:45:00',1.37),('8537','2014-04-23','14:50:00',1.66),('8537','2014-04-23','14:55:00',1.9),('8537','2014-04-23','15:00:00',2.06),('8537','2014-04-23','15:05:00',2.08),('8537','2014-04-23','15:10:00',2.09),('8537','2014-04-23','15:15:00',2.09),('8537','2014-04-23','15:20:00',1.73),('8537','2014-04-23','15:25:00',1.64),('8537','2014-04-23','15:30:00',1.59),('8537','2014-04-23','15:35:00',1.51),('8537','2014-04-23','15:40:00',1.48),('8537','2014-04-23','15:45:00',1.43),('8537','2014-04-23','15:50:00',1.22),('8537','2014-04-23','15:55:00',1.17),('8537','2014-04-23','16:00:00',1.02),('8537','2014-04-22','07:50:00',1.08),('8537','2014-04-22','07:55:00',1.18),('8537','2014-04-22','08:00:00',1.27),('8537','2014-04-22','08:05:00',1.38),('8537','2014-04-22','08:10:00',1.5),('8537','2014-04-22','08:15:00',1.6),('8537','2014-04-22','08:20:00',1.73),('8537','2014-04-22','08:25:00',1.83),('8537','2014-04-22','08:30:00',1.94),('8537','2014-04-22','08:35:00',2.06),('8537','2014-04-22','08:40:00',2.17),('8537','2014-04-22','08:45:00',2.25),('8537','2014-04-22','08:50:00',2.35),('8537','2014-04-22','08:55:00',2.39),('8537','2014-04-22','09:00:00',2.49),('8537','2014-04-22','09:05:00',2.77),('8537','2014-04-22','09:10:00',2.65),('8537','2014-04-22','09:15:00',2.63),('8537','2014-04-22','09:20:00',2.93),('8537','2014-04-22','09:25:00',3.1),('8537','2014-04-22','09:30:00',3.15),('8537','2014-04-22','09:35:00',3.31),('8537','2014-04-22','09:40:00',3.27),('8537','2014-04-22','09:45:00',3.49),('8537','2014-04-22','09:50:00',2.83),('8537','2014-04-22','09:55:00',1.73),('8537','2014-04-22','10:00:00',1.6),('8537','2014-04-22','10:05:00',1.69),('8537','2014-04-22','10:10:00',2.23),('8537','2014-04-22','10:15:00',2.43),('8537','2014-04-22','10:20:00',3.7),('8537','2014-04-22','10:25:00',2.61),('8537','2014-04-22','10:30:00',4.08),('8537','2014-04-22','10:35:00',4.25),('8537','2014-04-22','10:40:00',4.03),('8537','2014-04-22','10:45:00',4.35),('8537','2014-04-22','10:50:00',4.79),('8537','2014-04-22','10:55:00',3.57),('8537','2014-04-22','11:00:00',2.4),('8537','2014-04-22','11:05:00',2.95),('8537','2014-04-22','11:10:00',1.97),('8537','2014-04-22','11:15:00',1.63),('8537','2014-04-22','11:20:00',1.42),('8537','2014-04-22','11:25:00',1.45),('8537','2014-04-22','11:30:00',1.29),('8537','2014-04-22','11:35:00',1.36),('8537','2014-04-22','11:40:00',1.25),('8537','2014-04-22','11:45:00',1.06),('8537','2014-04-22','11:50:00',1.05),('8537','2014-04-22','12:00:00',1.09),('8537','2014-04-22','12:05:00',1.34),('8537','2014-04-22','12:10:00',1.39),('8537','2014-04-22','12:15:00',1.42),('8537','2014-04-22','12:20:00',1.49),('8537','2014-04-22','12:25:00',1.6),('8537','2014-04-22','12:30:00',1.86),('8537','2014-04-22','12:35:00',1.64),('8537','2014-04-22','12:40:00',1.22),('8537','2014-04-22','12:45:00',1.01),('8537','2014-04-22','13:10:00',1.04),('8537','2014-04-22','13:15:00',1.6),('8537','2014-04-22','13:20:00',2.71),('8537','2014-04-22','13:25:00',3.03),('8537','2014-04-22','13:30:00',3.38),('8537','2014-04-22','13:35:00',3.1),('8537','2014-04-22','13:40:00',3.82),('8537','2014-04-22','13:45:00',3.86),('8537','2014-04-22','13:50:00',3.35),('8537','2014-04-22','13:55:00',1.84),('8537','2014-04-22','14:00:00',1.6),('8537','2014-04-22','14:05:00',1.92),('8537','2014-04-22','14:10:00',4.15),('8537','2014-04-22','14:15:00',3.85),('8537','2014-04-22','14:20:00',4.22),('8537','2014-04-22','14:25:00',3.17),('8537','2014-04-22','14:30:00',2.42),('8537','2014-04-22','14:35:00',2.83),('8537','2014-04-22','14:40:00',3.7),('8537','2014-04-22','14:45:00',4.4),('8537','2014-04-22','14:50:00',4.28),('8537','2014-04-22','14:55:00',3.35),('8537','2014-04-22','15:00:00',1.55),('8537','2014-04-22','15:05:00',1.5),('8537','2014-04-22','15:10:00',1.36),('8537','2014-04-22','15:15:00',1.33),('8537','2014-04-22','15:20:00',1.47),('8537','2014-04-22','15:25:00',1.68),('8537','2014-04-22','15:30:00',2.05),('8537','2014-04-22','15:35:00',2.89),('8537','2014-04-22','15:40:00',2.56),('8537','2014-04-22','15:45:00',2.09),('8537','2014-04-22','15:50:00',2.46),('8537','2014-04-22','15:55:00',2.07),('8537','2014-04-22','16:00:00',2.34),('8537','2014-04-22','16:05:00',1.73),('8537','2014-04-22','16:10:00',1.63),('8537','2014-04-22','16:15:00',1.55),('8537','2014-04-22','16:20:00',1.85),('8537','2014-04-22','16:25:00',1.75),('8537','2014-04-22','16:30:00',1.47),('8537','2014-04-22','16:35:00',1.47),('8537','2014-04-22','16:40:00',1.87),('8537','2014-04-22','16:45:00',1.88),('8537','2014-04-22','16:50:00',1.51),('8537','2014-04-22','16:55:00',1.31),('8537','2014-04-22','17:00:00',1.41),('8537','2014-04-22','17:05:00',1.61),('8537','2014-04-22','17:10:00',1.29),('8537','2014-04-22','17:15:00',1.16),('8537','2014-04-21','08:40:00',1.01),('8537','2014-04-21','09:00:00',1.04),('8537','2014-04-21','09:05:00',1.04),('8537','2014-04-21','09:10:00',1.06),('8537','2014-04-21','09:15:00',1.14),('8537','2014-04-21','09:20:00',1.76),('8537','2014-04-21','09:25:00',1.39),('8537','2014-04-21','09:45:00',1.02),('8537','2014-04-21','09:50:00',1.1),('8537','2014-04-21','09:55:00',1.27),('8537','2014-04-21','10:00:00',1.72),('8537','2014-04-21','10:05:00',3.57),('8537','2014-04-21','10:10:00',3.88),('8537','2014-04-21','10:15:00',3.99),('8537','2014-04-21','10:20:00',3.9),('8537','2014-04-21','10:25:00',3.88),('8537','2014-04-21','10:30:00',3.97),('8537','2014-04-21','10:35:00',4.01),('8537','2014-04-21','10:40:00',4.06),('8537','2014-04-21','10:45:00',4.09),('8537','2014-04-21','10:50:00',4.12),('8537','2014-04-21','10:55:00',4.16),('8537','2014-04-21','11:00:00',4.21),('8537','2014-04-21','11:05:00',4.25),('8537','2014-04-21','11:10:00',4.31),('8537','2014-04-21','11:15:00',4.34),('8537','2014-04-21','11:20:00',4.38),('8537','2014-04-21','11:25:00',4.42),('8537','2014-04-21','11:30:00',4.5),('8537','2014-04-21','11:35:00',4.56),('8537','2014-04-21','11:40:00',4.59),('8537','2014-04-21','11:45:00',4.64),('8537','2014-04-21','11:50:00',4.66),('8537','2014-04-21','11:55:00',4.65),('8537','2014-04-21','12:00:00',4.7),('8537','2014-04-21','12:05:00',4.75),('8537','2014-04-21','12:10:00',4.77),('8537','2014-04-21','12:15:00',4.84),('8537','2014-04-21','12:20:00',4.88),('8537','2014-04-21','12:25:00',4.92),('8537','2014-04-21','12:30:00',4.93),('8537','2014-04-21','12:35:00',4.93),('8537','2014-04-21','12:40:00',4.93),('8537','2014-04-21','12:45:00',4.99),('8537','2014-04-21','12:50:00',4.99),('8537','2014-04-21','12:55:00',4.99),('8537','2014-04-21','13:00:00',4.95),('8537','2014-04-21','13:05:00',4.98),('8537','2014-04-21','13:10:00',5.01),('8537','2014-04-21','13:15:00',4.99),('8537','2014-04-21','13:20:00',4.96),('8537','2014-04-21','13:25:00',4.93),('8537','2014-04-21','13:30:00',4.88),('8537','2014-04-21','13:35:00',4.93),('8537','2014-04-21','13:40:00',4.93),('8537','2014-04-21','13:45:00',4.95),('8537','2014-04-21','13:50:00',4.95),('8537','2014-04-21','13:55:00',4.93),('8537','2014-04-21','14:00:00',4.91),('8537','2014-04-21','14:05:00',4.9),('8537','2014-04-21','14:10:00',4.88),('8537','2014-04-21','14:15:00',4.85),('8537','2014-04-21','14:20:00',4.83),('8537','2014-04-21','14:25:00',4.77),('8537','2014-04-21','14:30:00',4.73),('8537','2014-04-21','14:35:00',4.46),('8537','2014-04-21','14:40:00',4.05),('8537','2014-04-21','14:45:00',4.38),('8537','2014-04-21','14:50:00',4.51),('8537','2014-04-21','14:55:00',4.48),('8537','2014-04-21','15:00:00',4.42),('8537','2014-04-21','15:05:00',4.39),('8537','2014-04-21','15:10:00',4.31),('8537','2014-04-21','15:15:00',4.24),('8537','2014-04-21','15:20:00',4.21),('8537','2014-04-21','15:25:00',4.08),('8537','2014-04-21','15:30:00',4),('8537','2014-04-21','15:35:00',3.98),('8537','2014-04-21','15:40:00',3.9),('8537','2014-04-21','15:45:00',3.83),('8537','2014-04-21','15:50:00',3.77),('8537','2014-04-21','15:55:00',3.71),('8537','2014-04-21','16:00:00',3.66),('8537','2014-04-21','16:05:00',3.51),('8537','2014-04-21','16:10:00',3.09),('8537','2014-04-21','16:15:00',2.95),('8537','2014-04-21','16:20:00',3.33),('8537','2014-04-21','16:25:00',3.18),('8537','2014-04-21','16:30:00',3.07),('8537','2014-04-21','16:35:00',3.08),('8537','2014-04-21','16:40:00',2.99),('8537','2014-04-21','16:45:00',2.85),('8537','2014-04-21','16:50:00',2.78),('8537','2014-04-21','16:55:00',2.68),('8537','2014-04-21','17:00:00',2.57),('8537','2014-04-21','17:05:00',2.38),('8537','2014-04-21','17:10:00',2.34),('8537','2014-04-21','17:15:00',2.24),('8537','2014-04-21','17:20:00',2.15),('8537','2014-04-21','17:25:00',2.04),('8537','2014-04-21','17:30:00',1.94),('8537','2014-04-21','17:35:00',1.79),('8537','2014-04-21','17:40:00',1.62),('8537','2014-04-21','17:45:00',1.6),('8537','2014-04-21','17:50:00',1.51),('8537','2014-04-21','17:55:00',1.38),('8537','2014-04-21','18:00:00',1.27),('8537','2014-04-21','18:05:00',1.17),('8537','2014-04-21','18:10:00',1.06),('8537','2014-04-20','07:50:00',1.1),('8537','2014-04-20','07:55:00',1.27),('8537','2014-04-20','08:00:00',1.29),('8537','2014-04-20','08:05:00',1.34),('8537','2014-04-20','08:10:00',1.42),('8537','2014-04-20','08:15:00',1.61),('8537','2014-04-20','08:20:00',1.9),('8537','2014-04-20','08:25:00',2.53),('8537','2014-04-20','08:30:00',2.85),('8537','2014-04-20','08:35:00',2.79),('8537','2014-04-20','08:40:00',2.19),('8537','2014-04-20','08:45:00',2.07),('8537','2014-04-20','08:50:00',2.09),('8537','2014-04-20','08:55:00',1.14),('8537','2014-04-20','09:00:00',2.04),('8537','2014-04-20','09:10:00',1.81),('8537','2014-04-20','09:15:00',3.15),('8537','2014-04-20','09:20:00',3.18),('8537','2014-04-20','09:25:00',3.5),('8537','2014-04-20','09:30:00',4.02),('8537','2014-04-20','09:35:00',3.08),('8537','2014-04-20','09:40:00',2.4),('8537','2014-04-20','09:45:00',1.65),('8537','2014-04-20','09:50:00',1.84),('8537','2014-04-20','09:55:00',2.15),('8537','2014-04-20','10:00:00',2.74),('8537','2014-04-20','10:05:00',3.32),('8537','2014-04-20','10:10:00',3.08),('8537','2014-04-20','10:15:00',3.61),('8537','2014-04-20','10:20:00',3.72),('8537','2014-04-20','10:25:00',3.16),('8537','2014-04-20','10:30:00',2.99),('8537','2014-04-20','10:35:00',3.22),('8537','2014-04-20','10:40:00',3.13),('8537','2014-04-20','10:45:00',3.23),('8537','2014-04-20','10:50:00',3.48),('8537','2014-04-20','10:55:00',3.53),('8537','2014-04-20','11:00:00',4.1),('8537','2014-04-20','11:05:00',4.14),('8537','2014-04-20','11:10:00',3.95),('8537','2014-04-20','11:15:00',4.68),('8537','2014-04-20','11:20:00',3.75),('8537','2014-04-20','11:25:00',2.86),('8537','2014-04-20','11:30:00',4.99),('8537','2014-04-20','11:35:00',4.85),('8537','2014-04-20','11:40:00',3.77),('8537','2014-04-20','11:45:00',4.67),('8537','2014-04-20','11:50:00',3.8),('8537','2014-04-20','11:55:00',1.66),('8537','2014-04-20','12:00:00',3.8),('8537','2014-04-20','12:05:00',5.35),('8537','2014-04-20','12:10:00',3.54),('8537','2014-04-20','12:15:00',1.89),('8537','2014-04-20','12:20:00',2.72),('8537','2014-04-20','12:25:00',5.73),('8537','2014-04-20','12:30:00',5.32),('8537','2014-04-20','12:35:00',5.07),('8537','2014-04-20','12:40:00',5.1),('8537','2014-04-20','12:45:00',5.14),('8537','2014-04-20','12:50:00',5.2),('8537','2014-04-20','12:55:00',5.2),('8537','2014-04-20','13:00:00',5.26),('8537','2014-04-20','13:05:00',5.28),('8537','2014-04-20','13:10:00',5.29),('8537','2014-04-20','13:15:00',5.37),('8537','2014-04-20','13:20:00',5.11),('8537','2014-04-20','13:25:00',5.11),('8537','2014-04-20','13:30:00',5.13),('8537','2014-04-20','13:35:00',5.1),('8537','2014-04-20','13:40:00',5.11),('8537','2014-04-20','13:45:00',5.08),('8537','2014-04-20','13:50:00',5.05),('8537','2014-04-20','13:55:00',5.04),('8537','2014-04-20','14:00:00',5.01),('8537','2014-04-20','14:05:00',5.04),('8537','2014-04-20','14:10:00',5.01),('8537','2014-04-20','14:15:00',5.16),('8537','2014-04-20','14:20:00',4.09),('8537','2014-04-20','14:25:00',3.68),('8537','2014-04-20','14:30:00',3.58),('8537','2014-04-20','14:35:00',2.92),('8537','2014-04-20','14:40:00',2.87),('8537','2014-04-20','14:45:00',3.1),('8537','2014-04-20','14:50:00',3),('8537','2014-04-20','14:55:00',3.32),('8537','2014-04-20','15:00:00',3.73),('8537','2014-04-20','15:05:00',3.68),('8537','2014-04-20','15:10:00',4.37),('8537','2014-04-20','15:15:00',4.46),('8537','2014-04-20','15:20:00',4.24),('8537','2014-04-20','15:25:00',4.2),('8537','2014-04-20','15:30:00',3.87),('8537','2014-04-20','15:35:00',3.76),('8537','2014-04-20','15:40:00',4.13),('8537','2014-04-20','15:45:00',3.46),('8537','2014-04-20','15:50:00',2.77),('8537','2014-04-20','15:55:00',3.96),('8537','2014-04-20','16:00:00',3.8),('8537','2014-04-20','16:05:00',3.69),('8537','2014-04-20','16:10:00',3.61),('8537','2014-04-20','16:15:00',3.56),('8537','2014-04-20','16:20:00',3.55),('8537','2014-04-20','16:25:00',2.92),('8537','2014-04-20','16:30:00',3.5),('8537','2014-04-20','16:35:00',3.23),('8537','2014-04-20','16:40:00',3.27),('8537','2014-04-20','16:45:00',2.51),('8537','2014-04-20','16:50:00',2.93),('8537','2014-04-20','16:55:00',2.87),('8537','2014-04-20','17:00:00',2.73),('8537','2014-04-20','17:05:00',2.48),('8537','2014-04-20','17:10:00',2.39),('8537','2014-04-20','17:15:00',2.27),('8537','2014-04-20','17:20:00',2.17),('8537','2014-04-20','17:25:00',2.04),('8537','2014-04-20','17:30:00',1.94),('8537','2014-04-20','17:35:00',1.78),('8537','2014-04-20','17:40:00',1.7),('8537','2014-04-20','17:45:00',1.59),('8537','2014-04-20','17:50:00',1.48),('8537','2014-04-20','17:55:00',1.37),('8537','2014-04-20','18:00:00',1.27),('8537','2014-04-20','18:05:00',1.17),('8537','2014-04-20','18:10:00',1.06),('8537','2014-04-19','07:35:00',1.01),('8537','2014-04-19','07:40:00',1.19),('8537','2014-04-19','07:55:00',1.91),('8537','2014-04-19','08:00:00',1.74),('8537','2014-04-19','08:05:00',1.26),('8537','2014-04-19','08:10:00',1.71),('8537','2014-04-19','08:15:00',1.24),('8537','2014-04-19','08:20:00',1.32),('8537','2014-04-19','08:25:00',1.72),('8537','2014-04-19','08:30:00',2.26),('8537','2014-04-19','08:35:00',2.91),('8537','2014-04-19','08:40:00',2.42),('8537','2014-04-19','08:45:00',2.26),('8537','2014-04-19','08:50:00',1.77),('8537','2014-04-19','08:55:00',1.24),('8537','2014-04-19','09:20:00',1.17),('8537','2014-04-19','09:25:00',1.59),('8537','2014-04-19','09:30:00',2.44),('8537','2014-04-19','09:35:00',2.49),('8537','2014-04-19','09:40:00',1.46),('8537','2014-04-19','09:45:00',1.08),('8537','2014-04-19','10:35:00',1.04),('8537','2014-04-19','10:40:00',1.41),('8537','2014-04-19','10:45:00',1.35),('8537','2014-04-19','10:50:00',1.37),('8537','2014-04-19','10:55:00',1.74),('8537','2014-04-19','11:00:00',1.86),('8537','2014-04-19','11:05:00',1.5),('8537','2014-04-19','11:10:00',1.4),('8537','2014-04-19','11:15:00',2.06),('8537','2014-04-19','11:20:00',3.6),('8537','2014-04-19','11:25:00',3.09),('8537','2014-04-19','11:30:00',3.17),('8537','2014-04-19','11:35:00',2.81),('8537','2014-04-19','11:40:00',2.94),('8537','2014-04-19','11:45:00',2.51),('8537','2014-04-19','11:50:00',2.09),('8537','2014-04-19','11:55:00',1.26),('8537','2014-04-19','13:15:00',1.72),('8537','2014-04-19','13:20:00',1.42),('8537','2014-04-19','13:50:00',1.02),('8537','2014-04-19','14:30:00',1.54),('8537','2014-04-19','14:35:00',1.78),('8537','2014-04-19','14:40:00',2.1),('8537','2014-04-19','14:45:00',2.2),('8537','2014-04-19','14:50:00',1.51),('8537','2014-04-19','14:55:00',1.27),('8537','2014-04-19','15:00:00',1.64),('8537','2014-04-19','15:05:00',1.45),('8537','2014-04-19','15:25:00',1.27),('8537','2014-04-19','15:30:00',1.33),('8537','2014-04-19','15:45:00',1.08),('8537','2014-04-19','15:50:00',3.4),('8537','2014-04-19','15:55:00',3.49),('8537','2014-04-19','16:00:00',2.1),('8537','2014-04-19','16:05:00',1.9),('8537','2014-04-19','16:10:00',1.9),('8537','2014-04-19','16:15:00',1.93),('8537','2014-04-19','16:20:00',2.28),('8537','2014-04-19','16:25:00',2.22),('8537','2014-04-19','16:30:00',3.02),('8537','2014-04-19','16:35:00',1.85),('8537','2014-04-19','16:40:00',1.28),('8537','2014-04-19','16:45:00',1.1),('8537','2014-04-19','17:10:00',1.08),('8537','2014-04-19','17:15:00',1.06),('8537','2014-04-19','17:20:00',1.75),('8537','2014-04-19','17:25:00',1.47),('8537','2014-04-19','17:30:00',1.28),('8537','2014-04-19','17:35:00',1.04),('8537','2014-04-18','08:00:00',1.01),('8537','2014-04-18','08:05:00',1.91),('8537','2014-04-18','08:10:00',1.74),('8537','2014-04-18','08:35:00',1.17),('8537','2014-04-18','08:40:00',1.72),('8537','2014-04-18','08:45:00',1.73),('8537','2014-04-18','08:50:00',1.29),('8537','2014-04-18','08:55:00',1.18),('8537','2014-04-18','09:00:00',1.42),('8537','2014-04-18','09:05:00',2.98),('8537','2014-04-18','09:10:00',3.79),('8537','2014-04-18','09:15:00',3.49),('8537','2014-04-18','09:20:00',3.26),('8537','2014-04-18','09:25:00',2.26),('8537','2014-04-18','09:30:00',3.69),('8537','2014-04-18','09:35:00',2.14),('8537','2014-04-18','09:40:00',1.45),('8537','2014-04-18','09:45:00',2.08),('8537','2014-04-18','09:50:00',3.5),('8537','2014-04-18','09:55:00',3.37),('8537','2014-04-18','10:00:00',3.07),('8537','2014-04-18','10:05:00',2.05),('8537','2014-04-18','10:10:00',1.84),('8537','2014-04-18','10:15:00',2.12),('8537','2014-04-18','10:20:00',1.75),('8537','2014-04-18','10:25:00',1.81),('8537','2014-04-18','10:30:00',1.52),('8537','2014-04-18','10:35:00',1.37),('8537','2014-04-18','10:40:00',1.64),('8537','2014-04-18','10:45:00',3.12),('8537','2014-04-18','10:50:00',3.43),('8537','2014-04-18','10:55:00',3.58),('8537','2014-04-18','11:00:00',2.16),('8537','2014-04-18','11:05:00',1.92),('8537','2014-04-18','11:10:00',2.54),('8537','2014-04-18','11:15:00',3.44),('8537','2014-04-18','11:20:00',2.22),('8537','2014-04-18','11:25:00',1.61),('8537','2014-04-18','11:30:00',1.95),('8537','2014-04-18','11:35:00',1.89),('8537','2014-04-18','11:40:00',1.97),('8537','2014-04-18','11:45:00',1.85),('8537','2014-04-18','11:50:00',2.23),('8537','2014-04-18','11:55:00',2.06),('8537','2014-04-18','12:00:00',2.09),('8537','2014-04-18','12:05:00',3.55),('8537','2014-04-18','12:10:00',3.95),('8537','2014-04-18','12:15:00',3.96),('8537','2014-04-18','12:20:00',4.69),('8537','2014-04-18','12:25:00',3.72),('8537','2014-04-18','12:30:00',5.39),('8537','2014-04-18','12:35:00',5.05),('8537','2014-04-18','12:40:00',5.31),('8537','2014-04-18','12:45:00',4.3),('8537','2014-04-18','12:50:00',3.71),('8537','2014-04-18','12:55:00',2.46),('8537','2014-04-18','13:00:00',5.43),('8537','2014-04-18','13:05:00',3.67),('8537','2014-04-18','13:10:00',2.93),('8537','2014-04-18','13:15:00',2.85),('8537','2014-04-18','13:20:00',2.59),('8537','2014-04-18','13:25:00',1.93),('8537','2014-04-18','13:30:00',1.65),('8537','2014-04-18','13:35:00',1.64),('8537','2014-04-18','13:40:00',1.45),('8537','2014-04-18','13:45:00',1.27),('8537','2014-04-18','13:50:00',1.58),('8537','2014-04-18','13:55:00',2.51),('8537','2014-04-18','14:00:00',2.26),('8537','2014-04-18','14:05:00',1.92),('8537','2014-04-18','14:10:00',1.69),('8537','2014-04-18','14:15:00',1.51),('8537','2014-04-18','14:20:00',1.79),('8537','2014-04-18','14:25:00',2.34),('8537','2014-04-18','14:30:00',2.6),('8537','2014-04-18','14:35:00',2.98),('8537','2014-04-18','14:40:00',2.65),('8537','2014-04-18','14:45:00',3.26),('8537','2014-04-18','14:50:00',3.69),('8537','2014-04-18','14:55:00',2.52),('8537','2014-04-18','15:00:00',4.78),('8537','2014-04-18','15:05:00',2.9),('8537','2014-04-18','15:10:00',2.37),('8537','2014-04-18','15:15:00',2.6),('8537','2014-04-18','15:20:00',2.26),('8537','2014-04-18','15:25:00',2.48),('8537','2014-04-18','15:30:00',3.6),('8537','2014-04-18','15:35:00',4.48),('8537','2014-04-18','15:40:00',2.46),('8537','2014-04-18','15:45:00',2.71),('8537','2014-04-18','15:50:00',3.35),('8537','2014-04-18','15:55:00',2.87),('8537','2014-04-18','16:00:00',2.56),('8537','2014-04-18','16:05:00',2.02),('8537','2014-04-18','16:10:00',1.66),('8537','2014-04-18','16:15:00',1.44),('8537','2014-04-18','16:20:00',1.49),('8537','2014-04-18','16:25:00',2.12),('8537','2014-04-18','16:30:00',2.19),('8537','2014-04-18','16:35:00',2.48),('8537','2014-04-18','16:40:00',3.27),('8537','2014-04-18','16:45:00',3.07),('8537','2014-04-18','16:50:00',2.82),('8537','2014-04-18','16:55:00',2.16),('8537','2014-04-18','17:00:00',2.25),('8537','2014-04-18','17:05:00',2.87),('8537','2014-04-18','17:10:00',2.09),('8537','2014-04-18','17:15:00',2.3),('8537','2014-04-18','17:20:00',1.97),('8537','2014-04-18','17:25:00',2.14),('8537','2014-04-18','17:30:00',1.94),('8537','2014-04-18','17:35:00',1.77),('8537','2014-04-18','17:40:00',1.7),('8537','2014-04-18','17:45:00',1.58),('8537','2014-04-18','17:50:00',1.5),('8537','2014-04-18','17:55:00',1.39),('8537','2014-04-18','18:00:00',1.29),('8537','2014-04-18','18:05:00',1.16),('8537','2014-04-18','18:10:00',1.03),('8537','2014-04-17','08:00:00',1.33),('8537','2014-04-17','08:05:00',1.48),('8537','2014-04-17','08:10:00',1.61),('8537','2014-04-17','08:15:00',1.73),('8537','2014-04-17','08:20:00',1.77),('8537','2014-04-17','08:25:00',1.95),('8537','2014-04-17','08:30:00',2.07),('8537','2014-04-17','08:35:00',2.17),('8537','2014-04-17','08:40:00',2.29),('8537','2014-04-17','08:45:00',2.4),('8537','2014-04-17','08:50:00',2.51),('8537','2014-04-17','08:55:00',2.28),('8537','2014-04-17','09:00:00',2.26),('8537','2014-04-17','09:05:00',2.64),('8537','2014-04-17','09:10:00',2.91),('8537','2014-04-17','09:15:00',2.91),('8537','2014-04-17','09:20:00',3.19),('8537','2014-04-17','09:25:00',3.29),('8537','2014-04-17','09:30:00',3.39),('8537','2014-04-17','09:35:00',3.5),('8537','2014-04-17','09:40:00',3.6),('8537','2014-04-17','09:45:00',3.71),('8537','2014-04-17','09:50:00',3.79),('8537','2014-04-17','09:55:00',3.92),('8537','2014-04-17','10:00:00',4.07),('8537','2014-04-17','10:05:00',4.37),('8537','2014-04-17','10:10:00',4.12),('8537','2014-04-17','10:15:00',3.63),('8537','2014-04-17','10:20:00',4.32),('8537','2014-04-17','10:25:00',4.7),('8537','2014-04-17','10:30:00',4.99),('8537','2014-04-17','10:35:00',5.23),('8537','2014-04-17','10:40:00',4.93),('8537','2014-04-17','10:45:00',4.07),('8537','2014-04-17','10:50:00',3.07),('8537','2014-04-17','10:55:00',3.1),('8537','2014-04-17','11:00:00',3.08),('8537','2014-04-17','11:05:00',4.17),('8537','2014-04-17','11:10:00',3.97),('8537','2014-04-17','11:15:00',3.5),('8537','2014-04-17','11:20:00',4.05),('8537','2014-04-17','11:25:00',4.46),('8537','2014-04-17','11:30:00',2.98),('8537','2014-04-17','11:35:00',3.31),('8537','2014-04-17','11:40:00',3.17),('8537','2014-04-17','11:45:00',4.46),('8537','2014-04-17','11:50:00',3.15),('8537','2014-04-17','11:55:00',2.37),('8537','2014-04-17','12:00:00',2.78),('8537','2014-04-17','12:05:00',3.51),('8537','2014-04-17','12:10:00',3.27),('8537','2014-04-17','12:15:00',2.93),('8537','2014-04-17','12:20:00',2.77),('8537','2014-04-17','12:25:00',3),('8537','2014-04-17','12:30:00',3.83),('8537','2014-04-17','12:35:00',4.7),('8537','2014-04-17','12:40:00',5.41),('8537','2014-04-17','12:45:00',5.08),('8537','2014-04-17','12:50:00',5.32),('8537','2014-04-17','12:55:00',5.49),('8537','2014-04-17','13:00:00',5.48),('8537','2014-04-17','13:05:00',1.15),('8537','2014-04-17','13:15:00',1.52),('8537','2014-04-17','13:20:00',1.54),('8537','2014-04-17','13:25:00',6),('8537','2014-04-17','13:30:00',5.31),('8537','2014-04-17','13:35:00',1.27),('8537','2014-04-17','13:40:00',1.13),('8537','2014-04-17','13:45:00',1.1),('8537','2014-04-17','13:50:00',1.25),('8537','2014-04-17','13:55:00',1.39),('8537','2014-04-17','14:00:00',1.3),('8537','2014-04-17','14:05:00',1.36),('8537','2014-04-17','14:10:00',3.15),('8537','2014-04-17','14:15:00',2.01),('8537','2014-04-17','14:20:00',1.57),('8537','2014-04-17','14:25:00',2.21),('8537','2014-04-17','14:30:00',1.86),('8537','2014-04-17','14:35:00',2.17),('8537','2014-04-17','14:40:00',4.11),('8537','2014-04-17','14:45:00',1.66),('8537','2014-04-17','14:50:00',1.05),('8537','2014-04-17','15:05:00',1.11),('8537','2014-04-17','15:10:00',1.08),('8537','2014-04-17','15:20:00',1.03),('8537','2014-04-17','15:25:00',1.31),('8537','2014-04-17','15:30:00',1.99),('8537','2014-04-17','15:35:00',2.48),('8537','2014-04-17','15:40:00',1.97),('8537','2014-04-17','15:45:00',1.46),('8537','2014-04-17','15:50:00',1.37),('8537','2014-04-17','15:55:00',1.55),('8537','2014-04-17','16:00:00',1.36),('8537','2014-04-17','16:05:00',1.09),('8537','2014-04-17','16:10:00',1.22),('8537','2014-04-17','16:15:00',1.28),('8537','2014-04-17','16:20:00',1.24),('8537','2014-04-17','16:25:00',1.34),('8537','2014-04-17','16:30:00',1.41),('8537','2014-04-17','16:35:00',1.27),('8537','2014-04-17','16:40:00',1.43),('8537','2014-04-17','16:45:00',1.76),('8537','2014-04-17','16:50:00',1.78),('8537','2014-04-17','16:55:00',1.4),('8537','2014-04-17','17:00:00',1.17),('8537','2014-04-17','17:15:00',1.07),('8537','2014-04-17','17:20:00',1.21),('8537','2014-04-17','17:25:00',1.09),('8537','2014-04-17','17:30:00',1.12),('8537','2014-04-17','17:35:00',1.12),('8537','2014-04-17','17:40:00',1.09),('8537','2014-05-04','07:45:00',1.19),('8537','2014-05-04','07:50:00',1.45),('8537','2014-05-04','07:55:00',1.56),('8537','2014-05-04','08:00:00',1.67),('8537','2014-05-04','08:05:00',1.81),('8537','2014-05-04','08:10:00',1.91),('8537','2014-05-04','08:15:00',2.03),('8537','2014-05-04','08:20:00',2.17),('8537','2014-05-04','08:25:00',2.28),('8537','2014-05-04','08:30:00',2.51),('8537','2014-05-04','08:35:00',2.32),('8537','2014-05-04','08:40:00',2.11),('8537','2014-05-04','08:45:00',1.2),('8537','2014-05-04','08:50:00',2.46),('8537','2014-05-04','08:55:00',1.51),('8537','2014-05-04','09:00:00',1.67),('8537','2014-05-04','09:05:00',2.48),('8537','2014-05-04','09:10:00',2.67),('8537','2014-05-04','09:15:00',2.54),('8537','2014-05-04','09:20:00',4.38),('8537','2014-05-04','09:25:00',3.89),('8537','2014-05-04','09:30:00',1.66),('8537','2014-05-04','09:35:00',1.51),('8537','2014-05-04','09:40:00',2.05),('8537','2014-05-04','09:45:00',3.01),('8537','2014-05-04','09:50:00',2.72),('8537','2014-05-04','09:55:00',2.73),('8537','2014-05-04','10:00:00',4.57),('8537','2014-05-04','10:05:00',4.7),('8537','2014-05-04','10:10:00',4.12),('8537','2014-05-04','10:15:00',3.29),('8537','2014-05-04','10:20:00',2.33),('8537','2014-05-04','10:25:00',2.32),('8537','2014-05-04','10:30:00',2.41),('8537','2014-05-04','10:35:00',2.49),('8537','2014-05-04','10:40:00',2.64),('8537','2014-05-04','10:45:00',3.78),('8537','2014-05-04','10:50:00',4.05),('8537','2014-05-04','10:55:00',3.14),('8537','2014-05-04','11:00:00',3.29),('8537','2014-05-04','11:05:00',4.02),('8537','2014-05-04','11:10:00',5.79),('8537','2014-05-04','11:15:00',4.81),('8537','2014-05-04','11:20:00',5.46),('8537','2014-05-04','11:25:00',3.91),('8537','2014-05-04','11:30:00',4.55),('8537','2014-05-04','11:35:00',4.76),('8537','2014-05-04','11:40:00',3.57),('8537','2014-05-04','11:45:00',5.3),('8537','2014-05-04','11:50:00',3.44),('8537','2014-05-04','11:55:00',4.03),('8537','2014-05-04','12:00:00',4.01),('8537','2014-05-04','12:05:00',4.74),('8537','2014-05-04','12:10:00',3.69),('8537','2014-05-04','12:15:00',1.88),('8537','2014-05-04','12:20:00',2.05),('8537','2014-05-04','12:25:00',2.22),('8537','2014-05-04','12:30:00',5.84),('8537','2014-05-04','12:35:00',5.07),('8537','2014-05-04','12:40:00',3.66),('8537','2014-05-04','12:45:00',4.75),('8537','2014-05-04','12:50:00',4.34),('8537','2014-05-04','12:55:00',3.49),('8537','2014-05-04','13:00:00',2.58),('8537','2014-05-04','13:05:00',2.43),('8537','2014-05-04','13:10:00',2.7),('8537','2014-05-04','13:15:00',2.43),('8537','2014-05-04','13:20:00',2.1),('8537','2014-05-04','13:25:00',1.82),('8537','2014-05-04','13:30:00',1.88),('8537','2014-05-04','13:35:00',1.99),('8537','2014-05-04','13:40:00',1.9),('8537','2014-05-04','13:45:00',1.67),('8537','2014-05-04','13:50:00',1.59),('8537','2014-05-04','13:55:00',1.63),('8537','2014-05-04','14:00:00',1.61),('8537','2014-05-04','14:05:00',1.64),('8537','2014-05-04','14:10:00',1.65),('8537','2014-05-04','14:15:00',1.55),('8537','2014-05-04','14:20:00',1.25),('8537','2014-05-04','14:45:00',1.01),('8537','2014-05-04','14:50:00',1.33),('8537','2014-05-04','14:55:00',1.91),('8537','2014-05-04','15:00:00',2.19),('8537','2014-05-04','15:05:00',3.22),('8537','2014-05-04','15:10:00',3.95),('8537','2014-05-04','15:15:00',3.19),('8537','2014-05-04','15:20:00',1.9),('8537','2014-05-04','15:25:00',1.65),('8537','2014-05-04','15:30:00',1.26),('8537','2014-05-04','15:45:00',1.11),('8537','2014-05-04','15:50:00',1.41),('8537','2014-05-04','15:55:00',1.45),('8537','2014-05-04','16:00:00',1.19),('8537','2014-05-04','16:05:00',1.27),('8537','2014-05-04','16:10:00',1.56),('8537','2014-05-04','16:15:00',1.52),('8537','2014-05-04','16:20:00',1.28),('8537','2014-05-04','16:25:00',1.02),('8537','2014-05-04','17:25:00',1.13),('8537','2014-05-04','17:30:00',1.1),('8537','2014-05-04','17:35:00',1.09),('8537','2014-05-04','17:40:00',1.08),('8537','2014-04-16','07:50:00',1.08),('8537','2014-04-16','07:55:00',1.18),('8537','2014-04-16','08:00:00',1.3),('8537','2014-04-16','08:05:00',1.41),('8537','2014-04-16','08:10:00',1.58),('8537','2014-04-16','08:15:00',1.68),('8537','2014-04-16','08:20:00',1.82),('8537','2014-04-16','08:25:00',1.95),('8537','2014-04-16','08:30:00',1.44),('8537','2014-04-16','08:35:00',1.18),('8537','2014-04-16','08:40:00',1.48),('8537','2014-04-16','08:45:00',2.21),('8537','2014-04-16','08:50:00',2.5),('8537','2014-04-16','08:55:00',2.64),('8537','2014-04-16','09:00:00',2.75),('8537','2014-04-16','09:05:00',2.86),('8537','2014-04-16','09:10:00',2.97),('8537','2014-04-16','09:15:00',3.04),('8537','2014-04-16','09:20:00',3.15),('8537','2014-04-16','09:25:00',3.28),('8537','2014-04-16','09:30:00',2.31),('8537','2014-04-16','09:35:00',1.04),('8537','2014-04-16','09:45:00',1.15),('8537','2014-04-16','09:50:00',2.09),('8537','2014-04-16','09:55:00',4.17),('8537','2014-04-16','10:00:00',4.05),('8537','2014-04-16','10:05:00',4.11),('8537','2014-04-16','10:10:00',4.19),('8537','2014-04-16','10:15:00',4.3),('8537','2014-04-16','10:20:00',4.39),('8537','2014-04-16','10:25:00',4.47),('8537','2014-04-16','10:30:00',4.55),('8537','2014-04-16','10:35:00',4.62),('8537','2014-04-16','10:40:00',4.68),('8537','2014-04-16','10:45:00',4.76),('8537','2014-04-16','10:50:00',4.91),('8537','2014-04-16','10:55:00',4.58),('8537','2014-04-16','11:00:00',4.92),('8537','2014-04-16','11:05:00',3.65),('8537','2014-04-16','11:10:00',1.81),('8537','2014-04-16','11:15:00',2.69),('8537','2014-04-16','11:20:00',4.93),('8537','2014-04-16','11:25:00',3.38),('8537','2014-04-16','11:30:00',4.57),('8537','2014-04-16','11:35:00',3.33),('8537','2014-04-16','11:40:00',4.71),('8537','2014-04-16','11:45:00',5.05),('8537','2014-04-16','11:50:00',5.94),('8537','2014-04-16','11:55:00',5.76),('8537','2014-04-16','12:00:00',5.87),('8537','2014-04-16','12:05:00',2.94),('8537','2014-04-16','12:10:00',4.75),('8537','2014-04-16','12:15:00',4.71),('8537','2014-04-16','12:20:00',4.33),('8537','2014-04-16','12:25:00',1.77),('8537','2014-04-16','12:30:00',2.66),('8537','2014-04-16','12:35:00',5.3),('8537','2014-04-16','12:40:00',5.89),('8537','2014-04-16','12:45:00',5.77),('8537','2014-04-16','12:50:00',5.86),('8537','2014-04-16','12:55:00',2.97),('8537','2014-04-16','13:00:00',3.2),('8537','2014-04-16','13:05:00',1.44),('8537','2014-04-16','13:20:00',1.72),('8537','2014-04-16','13:25:00',1.3),('8537','2014-04-16','13:30:00',1.05),('8537','2014-04-16','13:35:00',1.81),('8537','2014-04-16','13:40:00',2.73),('8537','2014-04-16','13:45:00',5.72),('8537','2014-04-16','13:50:00',4.68),('8537','2014-04-16','13:55:00',3.43),('8537','2014-04-16','14:00:00',2.13),('8537','2014-04-16','14:05:00',3.79),('8537','2014-04-16','14:10:00',5.59),('8537','2014-04-16','14:15:00',5.99),('8537','2014-04-16','14:20:00',5.34),('8537','2014-04-16','14:25:00',4.48),('8537','2014-04-16','14:30:00',5.11),('8537','2014-04-16','14:35:00',5.03),('8537','2014-04-16','14:40:00',5.05),('8537','2014-04-16','14:45:00',4.72),('8537','2014-04-16','14:50:00',4.86),('8537','2014-04-16','14:55:00',1.72),('8537','2014-04-16','15:00:00',2.12),('8537','2014-04-16','15:05:00',3.32),('8537','2014-04-16','15:10:00',5.73),('8537','2014-04-16','15:15:00',3.49),('8537','2014-04-16','15:25:00',1.46),('8537','2014-04-16','15:30:00',3.94),('8537','2014-04-16','15:35:00',4.88),('8537','2014-04-16','15:40:00',4.72),('8537','2014-04-16','15:45:00',4.51),('8537','2014-04-16','15:50:00',4.41),('8537','2014-04-16','15:55:00',4.27),('8537','2014-04-16','16:00:00',4.11),('8537','2014-04-16','16:05:00',3.86),('8537','2014-04-16','16:10:00',3.34),('8537','2014-04-16','16:15:00',3.72),('8537','2014-04-16','16:20:00',3.73),('8537','2014-04-16','16:25:00',3.58),('8537','2014-04-16','16:30:00',3.5),('8537','2014-04-16','16:35:00',3.42),('8537','2014-04-16','16:40:00',3.21),('8537','2014-04-16','16:45:00',3.1),('8537','2014-04-16','16:50:00',3.06),('8537','2014-04-16','16:55:00',2.95),('8537','2014-04-16','17:00:00',2.82),('8537','2014-04-16','17:05:00',2.59),('8537','2014-04-16','17:10:00',2.55),('8537','2014-04-16','17:15:00',2.45),('8537','2014-04-16','17:20:00',2.33),('8537','2014-04-16','17:25:00',2.17),('8537','2014-04-16','17:30:00',2.06),('8537','2014-04-16','17:35:00',1.94),('8537','2014-04-16','17:40:00',1.82),('8537','2014-04-16','17:45:00',1.75),('8537','2014-04-16','17:50:00',1.73),('8537','2014-04-16','17:55:00',1.69),('8537','2014-04-16','18:00:00',1.52),('8537','2014-04-16','18:05:00',1.41),('8537','2014-04-16','18:10:00',1.26),('8537','2014-04-16','18:15:00',1.08),('8537','2014-04-16','18:20:00',1.01),('8537','2014-04-15','09:00:00',1.7),('8537','2014-04-15','09:05:00',1.98),('8537','2014-04-15','09:10:00',1.89),('8537','2014-04-15','09:15:00',2.49),('8537','2014-04-15','09:20:00',2.2),('8537','2014-04-15','09:25:00',3.09),('8537','2014-04-15','09:30:00',2.44),('8537','2014-04-15','09:35:00',1.08),('8537','2014-04-15','09:45:00',1.28),('8537','2014-04-15','09:50:00',3.41),('8537','2014-04-15','09:55:00',1.03),('8537','2014-04-15','10:00:00',1.65),('8537','2014-04-15','10:05:00',1.68),('8537','2014-04-15','10:10:00',1.99),('8537','2014-04-15','10:15:00',2.27),('8537','2014-04-15','10:20:00',1.8),('8537','2014-04-15','10:25:00',1.65),('8537','2014-04-15','10:30:00',3.7),('8537','2014-04-15','10:35:00',2.85),('8537','2014-04-15','10:40:00',2.32),('8537','2014-04-15','10:45:00',3.27),('8537','2014-04-15','10:50:00',2.93),('8537','2014-04-15','10:55:00',1.77),('8537','2014-04-15','11:00:00',2.01),('8537','2014-04-15','11:05:00',4.53),('8537','2014-04-15','11:10:00',3.22),('8537','2014-04-15','11:15:00',1.98),('8537','2014-04-15','11:20:00',1.36),('8537','2014-04-15','11:25:00',1.71),('8537','2014-04-15','11:30:00',1.29),('8537','2014-04-15','11:35:00',1.11),('8537','2014-04-15','11:45:00',1.26),('8537','2014-04-15','11:50:00',1.71),('8537','2014-04-15','11:55:00',1.23),('8537','2014-04-15','12:10:00',1.2),('8537','2014-04-15','12:15:00',1.75),('8537','2014-04-15','12:20:00',2.22),('8537','2014-04-15','12:25:00',1.05),('8537','2014-04-15','13:05:00',1.15),('8537','2014-04-15','13:10:00',1.92),('8537','2014-04-15','13:15:00',2.09),('8537','2014-04-15','13:20:00',3.41),('8537','2014-04-15','13:25:00',2.27),('8537','2014-04-15','13:30:00',3.07),('8537','2014-04-15','13:35:00',3.74),('8537','2014-04-15','13:40:00',3.31),('8537','2014-04-15','13:45:00',1.22),('8537','2014-04-15','13:50:00',1.09),('8537','2014-04-15','13:55:00',1.06),('8537','2014-04-15','14:00:00',2.37),('8537','2014-04-15','14:05:00',3.09),('8537','2014-04-15','14:10:00',3.16),('8537','2014-04-15','14:15:00',4.25),('8537','2014-04-15','14:20:00',2.84),('8537','2014-04-15','14:25:00',4.32),('8537','2014-04-15','14:30:00',3.3),('8537','2014-04-15','14:35:00',2.51),('8537','2014-04-15','14:40:00',1.74),('8537','2014-04-15','14:45:00',1.44),('8537','2014-04-15','14:50:00',1.42),('8537','2014-04-15','14:55:00',1.17),('8537','2014-04-15','15:10:00',1.14),('8537','2014-04-15','15:15:00',1.6),('8537','2014-04-15','15:20:00',2.04),('8537','2014-04-15','15:25:00',2.25),('8537','2014-04-15','15:30:00',1.71),('8537','2014-04-15','15:35:00',1.61),('8537','2014-04-15','15:40:00',1.68),('8537','2014-04-15','15:45:00',1.54),('8537','2014-04-15','15:50:00',1.54),('8537','2014-04-15','15:55:00',1.65),('8537','2014-04-15','16:00:00',1.72),('8537','2014-04-15','16:05:00',1.67),('8537','2014-04-15','16:10:00',1.01),('8537','2013-10-08','08:10:00',1.11),('8537','2013-10-08','08:15:00',1.42),('8537','2013-10-08','08:20:00',1.42),('8537','2013-10-08','10:00:00',1.31),('8537','2013-10-08','10:05:00',1.11),('8537','2013-10-08','10:10:00',1.12),('8537','2013-10-08','11:00:00',2.11),('8537','2013-10-08','11:05:00',1.57),('8537','2013-10-08','11:10:00',3.59),('8537','2013-10-08','11:15:00',4.87),('8537','2013-10-08','11:20:00',4.28),('8537','2013-10-08','11:25:00',2.21),('8537','2013-10-08','11:30:00',3.78),('8537','2013-10-08','11:35:00',2.68),('8537','2013-10-08','11:40:00',1.93),('8537','2013-10-08','11:45:00',1.78),('8537','2013-10-08','11:50:00',1.28),('8537','2013-10-08','11:55:00',1.04),('8537','2013-10-08','12:10:00',1.18),('8537','2013-10-08','12:15:00',1.18),('8537','2013-10-08','12:20:00',1.33),('8537','2013-10-08','12:25:00',1.76),('8537','2013-10-08','12:30:00',3.65),('8537','2013-10-08','12:35:00',2.46),('8537','2013-10-08','12:40:00',4.89),('8537','2013-10-08','12:45:00',4.75),('8537','2013-10-08','12:50:00',4.98),('8537','2013-10-08','12:55:00',4.91),('8537','2013-10-08','13:00:00',4.17),('8537','2013-10-08','13:05:00',4.18),('8537','2013-10-08','13:10:00',2.67),('8537','2013-10-08','13:15:00',4.47),('8537','2013-10-08','13:20:00',1.77),('8537','2013-10-08','13:25:00',4.1),('8537','2013-10-08','13:30:00',2.15),('8537','2013-10-08','13:35:00',1.41),('8537','2013-10-08','13:40:00',1.38),('8537','2013-10-08','13:45:00',1.01),('8537','2013-10-08','13:55:00',1.1),('8537','2013-10-08','14:05:00',1.79),('8537','2013-10-08','14:10:00',2.62),('8537','2013-10-08','14:15:00',2.9),('8537','2013-10-08','14:20:00',3.31),('8537','2013-10-08','14:25:00',3.41),('8537','2013-10-08','14:30:00',3.16),('8537','2013-10-08','14:35:00',1.36),('8537','2013-10-08','14:40:00',1.58),('8537','2013-10-08','14:45:00',3.65),('8537','2013-10-08','14:50:00',4),('8537','2013-10-08','14:55:00',3.78),('8537','2013-10-08','15:00:00',3.7),('8537','2013-10-08','15:05:00',3.67),('8537','2013-10-08','15:10:00',3.42),('8537','2013-10-08','15:15:00',3.6),('8537','2013-10-08','15:20:00',2.09),('8537','2013-10-08','15:25:00',3.88),('8537','2013-10-08','15:30:00',4.01),('8537','2013-10-08','15:35:00',3.46),('8537','2013-10-08','15:40:00',2.59),('8537','2013-10-08','15:45:00',1.98),('8537','2013-10-08','15:50:00',2.73),('8537','2013-10-08','15:55:00',1.8),('8537','2013-10-08','16:00:00',1.52),('8537','2013-10-08','16:05:00',1.94),('8537','2013-10-07','08:20:00',1.07),('8537','2013-10-07','08:25:00',1.18),('8537','2013-10-07','08:30:00',1.29),('8537','2013-10-07','08:35:00',1.6),('8537','2013-10-07','08:40:00',1.91),('8537','2013-10-07','08:45:00',1.05),('8537','2013-10-07','08:55:00',1.43),('8537','2013-10-07','09:00:00',1.98),('8537','2013-10-07','09:05:00',2.22),('8537','2013-10-07','09:10:00',2.18),('8537','2013-10-07','09:15:00',2.27),('8537','2013-10-07','09:20:00',2.35),('8537','2013-10-07','09:25:00',2.44),('8537','2013-10-07','09:30:00',2.55),('8537','2013-10-07','09:35:00',2.64),('8537','2013-10-07','09:40:00',2.73),('8537','2013-10-07','09:45:00',2.81),('8537','2013-10-07','09:50:00',2.91),('8537','2013-10-07','09:55:00',2.97),('8537','2013-10-07','10:00:00',3.05),('8537','2013-10-07','10:05:00',3.13),('8537','2013-10-07','10:10:00',3.13),('8537','2013-10-07','10:15:00',3.27),('8537','2013-10-07','10:20:00',3.34),('8537','2013-10-07','10:25:00',3.39),('8537','2013-10-07','10:30:00',3.52),('8537','2013-10-07','10:35:00',3.67),('8537','2013-10-07','10:40:00',3.67),('8537','2013-10-07','10:45:00',3.73),('8537','2013-10-07','10:50:00',3.81),('8537','2013-10-07','10:55:00',3.27),('8537','2013-10-07','11:00:00',3.39),('8537','2013-10-07','11:05:00',3.94),('8537','2013-10-07','11:10:00',2.84),('8537','2013-10-07','11:15:00',3.64),('8537','2013-10-07','11:20:00',3.74),('8537','2013-10-07','11:25:00',4.08),('8537','2013-10-07','11:30:00',4.1),('8537','2013-10-07','11:35:00',4.12),('8537','2013-10-07','11:40:00',4.17),('8537','2013-10-07','11:45:00',4.22),('8537','2013-10-07','11:50:00',4.21),('8537','2013-10-07','11:55:00',4.32),('8537','2013-10-07','12:00:00',4.3),('8537','2013-10-07','12:05:00',4.4),('8537','2013-10-07','12:10:00',4.24),('8537','2013-10-07','12:15:00',2.75),('8537','2013-10-07','12:20:00',3.85),('8537','2013-10-07','12:25:00',4.92),('8537','2013-10-07','12:30:00',4.69),('8537','2013-10-07','12:35:00',4.6),('8537','2013-10-07','12:40:00',4.61),('8537','2013-10-07','12:45:00',4.58),('8537','2013-10-07','12:50:00',4.57),('8537','2013-10-07','12:55:00',4.68),('8537','2013-10-07','13:00:00',3.97),('8537','2013-10-07','13:05:00',4.56),('8537','2013-10-07','13:10:00',4.57),('8537','2013-10-07','13:15:00',3.13),('8537','2013-10-07','13:20:00',4.94),('8537','2013-10-07','13:25:00',3.28),('8537','2013-10-07','13:30:00',3.15),('8537','2013-10-07','13:35:00',2.44),('8537','2013-10-07','13:40:00',2.12),('8537','2013-10-07','13:45:00',1.67),('8537','2013-10-07','13:50:00',2.71),('8537','2013-10-07','13:55:00',5.24),('8537','2013-10-07','14:00:00',4.97),('8537','2013-10-07','14:05:00',1.71),('8537','2013-10-07','14:10:00',2.36),('8537','2013-10-07','14:15:00',1.04),('8537','2013-10-07','14:20:00',1.73),('8537','2013-10-07','14:25:00',1.96),('8537','2013-10-07','14:30:00',1.81),('8537','2013-10-07','14:35:00',1.48),('8537','2013-10-07','14:40:00',2.81),('8537','2013-10-07','14:45:00',4.43),('8537','2013-10-07','14:50:00',4.35),('8537','2013-10-07','14:55:00',4.16),('8537','2013-10-07','15:00:00',2.85),('8537','2013-10-07','15:05:00',2.03),('8537','2013-10-07','15:10:00',2.36),('8537','2013-10-07','15:20:00',1.04),('8537','2013-10-07','15:25:00',2.04),('8537','2013-10-07','15:30:00',2.02),('8537','2013-10-07','15:35:00',1.71),('8537','2013-10-07','15:40:00',1.68),('8537','2013-10-07','15:45:00',1.85),('8537','2013-10-07','15:50:00',2.59),('8537','2013-10-07','15:55:00',2.39),('8537','2013-10-07','16:10:00',2.74),('8537','2013-10-07','16:15:00',2.69),('8537','2013-10-07','16:20:00',2.58),('8537','2013-10-07','16:25:00',2.24),('8537','2013-10-07','16:30:00',2.16),('8537','2013-10-07','16:35:00',2.12),('8537','2013-10-07','16:40:00',2.11),('8537','2013-10-07','16:45:00',1.97),('8537','2013-10-07','16:50:00',1.81),('8537','2013-10-07','16:55:00',1.64),('8537','2013-10-07','17:00:00',1.48),('8537','2013-10-07','17:05:00',1.34),('8537','2013-10-07','17:10:00',1.17),('8537','2013-10-07','17:15:00',1.09),('8537','2013-10-06','09:05:00',1.29),('8537','2013-10-06','09:10:00',1.13),('8537','2013-10-06','09:30:00',1.4),('8537','2013-10-06','09:35:00',1.88),('8537','2013-10-06','09:40:00',1.69),('8537','2013-10-06','09:45:00',1.37),('8537','2013-10-06','09:50:00',2.59),('8537','2013-10-06','09:55:00',3.05),('8537','2013-10-06','10:00:00',3.53),('8537','2013-10-06','10:05:00',3.6),('8537','2013-10-06','10:10:00',3.52),('8537','2013-10-06','10:15:00',3.26),('8537','2013-10-06','10:20:00',3.26),('8537','2013-10-06','10:25:00',3.69),('8537','2013-10-06','10:30:00',3.62),('8537','2013-10-06','10:35:00',3.49),('8537','2013-10-06','10:40:00',3.04),('8537','2013-10-06','10:45:00',2.49),('8537','2013-10-06','10:50:00',2.81),('8537','2013-10-06','10:55:00',3.01),('8537','2013-10-06','11:00:00',3.16),('8537','2013-10-06','11:05:00',3.46),('8537','2013-10-06','11:10:00',3.56),('8537','2013-10-06','11:15:00',3.4),('8537','2013-10-06','11:20:00',3.49),('8537','2013-10-06','11:25:00',3.69),('8537','2013-10-06','11:30:00',3.59),('8537','2013-10-06','11:35:00',3.53),('8537','2013-10-06','11:40:00',3.45),('8537','2013-10-06','11:45:00',2.84),('8537','2013-10-06','11:50:00',2.75),('8537','2013-10-06','11:55:00',3.2),('8537','2013-10-06','12:00:00',3.26),('8537','2013-10-06','12:05:00',3.36),('8537','2013-10-06','12:10:00',4.06),('8537','2013-10-06','12:15:00',3.98),('8537','2013-10-06','12:20:00',3.31),('8537','2013-10-06','12:25:00',3.45),('8537','2013-10-06','12:30:00',3.27),('8537','2013-10-06','12:35:00',3.42),('8537','2013-10-06','12:40:00',2.93),('8537','2013-10-06','12:45:00',3.19),('8537','2013-10-06','12:50:00',3.55),('8537','2013-10-06','12:55:00',4.03),('8537','2013-10-06','13:00:00',4.13),('8537','2013-10-06','13:05:00',3.98),('8537','2013-10-06','13:10:00',3.11),('8537','2013-10-06','13:15:00',2.96),('8537','2013-10-06','13:20:00',3.55),('8537','2013-10-06','13:25:00',1.29),('8537','2013-10-06','13:45:00',1.74),('8537','2013-10-06','13:50:00',4.75),('8537','2013-10-06','13:55:00',3.66),('8537','2013-10-06','14:00:00',2.17),('8537','2013-10-06','14:05:00',2.24),('8537','2013-10-06','14:10:00',3.29),('8537','2013-10-06','14:15:00',2.1),('8537','2013-10-06','14:20:00',2.02),('8537','2013-10-06','14:25:00',1.95),('8537','2013-10-06','14:30:00',2.48),('8537','2013-10-06','14:35:00',2.44),('8537','2013-10-06','14:40:00',1.93),('8537','2013-10-06','14:45:00',2.06),('8537','2013-10-06','14:50:00',2.1),('8537','2013-10-06','14:55:00',2.72),('8537','2013-10-06','15:00:00',2.37),('8537','2013-10-06','15:05:00',1.75),('8537','2013-10-06','15:10:00',1.42),('8537','2013-10-06','15:15:00',1.3),('8537','2013-10-06','15:20:00',1.14),('8537','2013-10-06','15:40:00',1.01),('8537','2013-10-06','15:45:00',1.01),('8537','2013-10-06','15:50:00',1.1),('8537','2013-10-06','15:55:00',1.34),('8537','2013-10-06','16:00:00',1.35),('8537','2013-10-06','17:15:00',1.04),('8537','2013-10-05','15:55:00',1.02),('8537','2013-10-05','16:00:00',1.14),('8537','2013-10-05','16:05:00',1.37),('8537','2013-10-05','16:10:00',1.37),('8537','2013-10-05','16:15:00',1.23),('8537','2013-10-05','16:20:00',1.26),('8537','2013-10-05','16:25:00',1.27),('8537','2013-10-05','16:30:00',1.1),('8537','2013-10-05','16:35:00',1.03),('8537','2013-10-05','16:40:00',1.08),('8537','2013-10-05','16:45:00',1.01),('8537','2013-10-04','09:25:00',1.17),('8537','2013-10-04','09:30:00',1.33),('8537','2013-10-04','09:35:00',1.33),('8537','2013-10-04','09:40:00',1.31),('8537','2013-10-04','09:45:00',1.35),('8537','2013-10-04','09:50:00',1.64),('8537','2013-10-04','09:55:00',3.38),('8537','2013-10-04','10:00:00',2.48),('8537','2013-10-04','10:05:00',1.82),('8537','2013-10-04','10:10:00',1.82),('8537','2013-10-04','10:15:00',2.24),('8537','2013-10-04','10:20:00',1.79),('8537','2013-10-04','10:25:00',2.28),('8537','2013-10-04','10:30:00',2.86),('8537','2013-10-04','10:35:00',2.29),('8537','2013-10-04','10:40:00',3.1),('8537','2013-10-04','10:45:00',2.44),('8537','2013-10-04','10:50:00',2.27),('8537','2013-10-04','10:55:00',3.42),('8537','2013-10-04','11:00:00',2.67),('8537','2013-10-04','11:05:00',2.1),('8537','2013-10-04','11:10:00',1.95),('8537','2013-10-04','11:15:00',3.61),('8537','2013-10-04','11:20:00',3.8),('8537','2013-10-04','11:25:00',3.59),('8537','2013-10-04','11:30:00',4.45),('8537','2013-10-04','11:35:00',4.54),('8537','2013-10-04','11:40:00',4.61),('8537','2013-10-04','11:45:00',4.5),('8537','2013-10-04','11:50:00',4.43),('8537','2013-10-04','11:55:00',4.44),('8537','2013-10-04','12:00:00',4.44),('8537','2013-10-04','12:05:00',4.51),('8537','2013-10-04','12:10:00',4.54),('8537','2013-10-04','12:15:00',4.28),('8537','2013-10-04','12:20:00',4.33),('8537','2013-10-04','12:25:00',4.6),('8537','2013-10-04','12:30:00',4.54),('8537','2013-10-04','12:35:00',4.13),('8537','2013-10-04','12:40:00',4.48),('8537','2013-10-04','12:45:00',4.53),('8537','2013-10-04','12:50:00',4.36),('8537','2013-10-04','12:55:00',4.39),('8537','2013-10-04','13:00:00',4.43),('8537','2013-10-04','13:05:00',4.48),('8537','2013-10-04','13:10:00',4.49),('8537','2013-10-04','13:15:00',4.71),('8537','2013-10-04','13:20:00',4.6),('8537','2013-10-04','13:25:00',4.35),('8537','2013-10-04','13:30:00',4.56),('8537','2013-10-04','13:35:00',3.99),('8537','2013-10-04','13:40:00',4.38),('8537','2013-10-04','13:45:00',4.25),('8537','2013-10-04','13:50:00',4.26),('8537','2013-10-04','13:55:00',4.27),('8537','2013-10-04','14:00:00',4.25),('8537','2013-10-04','14:05:00',4.21),('8537','2013-10-04','14:10:00',3.85),('8537','2013-10-04','14:15:00',3.47),('8537','2013-10-04','14:20:00',3.79),('8537','2013-10-04','14:25:00',4.03),('8537','2013-10-04','14:30:00',3.53),('8537','2013-10-04','14:35:00',2.5),('8537','2013-10-04','14:40:00',1.99),('8537','2013-10-04','14:45:00',2.25),('8537','2013-10-04','14:50:00',2.99),('8537','2013-10-04','14:55:00',3.06),('8537','2013-10-04','15:00:00',2.64),('8537','2013-10-04','15:05:00',2.98),('8537','2013-10-04','15:10:00',2.59),('8537','2013-10-04','15:15:00',2),('8537','2013-10-04','15:20:00',1.76),('8537','2013-10-04','15:25:00',2.66),('8537','2013-10-04','15:30:00',3.18),('8537','2013-10-04','15:35:00',1.7),('8537','2013-10-04','15:40:00',1.04),('8537','2013-10-04','16:00:00',1.14),('8537','2013-10-04','16:05:00',1.27),('8537','2013-10-04','16:10:00',1.2),('8537','2013-10-04','16:15:00',1.08),('8537','2013-10-03','08:15:00',1.08),('8537','2013-10-03','08:20:00',1.19),('8537','2013-10-03','08:25:00',1.31),('8537','2013-10-03','08:30:00',1.43),('8537','2013-10-03','08:35:00',1.55),('8537','2013-10-03','08:40:00',1.66),('8537','2013-10-03','08:45:00',1.79),('8537','2013-10-03','08:50:00',1.91),('8537','2013-10-03','08:55:00',2.03),('8537','2013-10-03','09:00:00',2.15),('8537','2013-10-03','09:05:00',2.25),('8537','2013-10-03','09:10:00',2.37),('8537','2013-10-03','09:15:00',2.47),('8537','2013-10-03','09:20:00',2.59),('8537','2013-10-03','09:25:00',2.7),('8537','2013-10-03','09:30:00',2.81),('8537','2013-10-03','09:35:00',2.91),('8537','2013-10-03','09:40:00',3.01),('8537','2013-10-03','09:45:00',3.11),('8537','2013-10-03','09:50:00',3.2),('8537','2013-10-03','09:55:00',3.3),('8537','2013-10-03','10:00:00',3.39),('8537','2013-10-03','10:05:00',3.48),('8537','2013-10-03','10:10:00',3.56),('8537','2013-10-03','10:15:00',3.63),('8537','2013-10-03','10:20:00',3.71),('8537','2013-10-03','10:25:00',3.8),('8537','2013-10-03','10:30:00',3.86),('8537','2013-10-03','10:35:00',3.95),('8537','2013-10-03','10:40:00',4.02),('8537','2013-10-03','10:45:00',4.07),('8537','2013-10-03','10:50:00',4.12),('8537','2013-10-03','10:55:00',4.18),('8537','2013-10-03','11:00:00',4.21),('8537','2013-10-03','11:05:00',4.28),('8537','2013-10-03','11:10:00',4.34),('8537','2013-10-03','11:15:00',4.36),('8537','2013-10-03','11:20:00',4.43),('8537','2013-10-03','11:25:00',4.47),('8537','2013-10-03','11:30:00',4.49),('8537','2013-10-03','11:35:00',4.56),('8537','2013-10-03','11:40:00',4.6),('8537','2013-10-03','11:45:00',4.62),('8537','2013-10-03','11:50:00',4.68),('8537','2013-10-03','11:55:00',4.7),('8537','2013-10-03','12:00:00',4.71),('8537','2013-10-03','12:05:00',4.74),('8537','2013-10-03','12:10:00',4.76),('8537','2013-10-03','12:15:00',4.73),('8537','2013-10-03','12:20:00',4.76),('8537','2013-10-03','12:25:00',4.77),('8537','2013-10-03','12:30:00',4.78),('8537','2013-10-03','12:35:00',4.79),('8537','2013-10-03','12:40:00',4.8),('8537','2013-10-03','12:45:00',4.81),('8537','2013-10-03','12:50:00',4.78),('8537','2013-10-03','12:55:00',4.78),('8537','2013-10-03','13:00:00',4.74),('8537','2013-10-03','13:05:00',4.68),('8537','2013-10-03','13:10:00',4.77),('8537','2013-10-03','13:15:00',4.74),('8537','2013-10-03','13:20:00',4.73),('8537','2013-10-03','13:25:00',4.71),('8537','2013-10-03','13:30:00',4.7),('8537','2013-10-03','13:35:00',4.65),('8537','2013-10-03','13:40:00',4.64),('8537','2013-10-03','13:45:00',4.61),('8537','2013-10-03','13:50:00',4.6),('8537','2013-10-03','13:55:00',4.62),('8537','2013-10-03','14:00:00',4.59),('8537','2013-10-03','14:05:00',4.55),('8537','2013-10-03','14:10:00',4.52),('8537','2013-10-03','14:15:00',4.45),('8537','2013-10-03','14:20:00',4.4),('8537','2013-10-03','14:25:00',4.35),('8537','2013-10-03','14:30:00',4.31),('8537','2013-10-03','14:35:00',4.22),('8537','2013-10-03','14:40:00',4.04),('8537','2013-10-03','14:45:00',3.78),('8537','2013-10-03','14:50:00',3.96),('8537','2013-10-03','14:55:00',4),('8537','2013-10-03','15:00:00',3.94),('8537','2013-10-03','15:05:00',3.86),('8537','2013-10-03','15:10:00',3.79),('8537','2013-10-03','15:15:00',3.72),('8537','2013-10-03','15:20:00',3.65),('8537','2013-10-03','15:25:00',3.55),('8537','2013-10-03','15:30:00',3.33),('8537','2013-10-03','15:35:00',3.31),('8537','2013-10-03','15:40:00',3.29),('8537','2013-10-03','15:45:00',3.2),('8537','2013-10-03','15:50:00',3.12),('8537','2013-10-03','15:55:00',3.04),('8537','2013-10-03','16:00:00',2.93),('8537','2013-10-03','16:05:00',2.8),('8537','2013-10-03','16:10:00',2.71),('8537','2013-10-03','16:15:00',2.6),('8537','2013-10-03','16:20:00',2.52),('8537','2013-10-03','16:25:00',2.35),('8537','2013-10-03','16:30:00',2.3),('8537','2013-10-03','16:35:00',2.14),('8537','2013-10-03','16:40:00',1.94),('8537','2013-10-03','16:45:00',1.79),('8537','2013-10-03','16:50:00',1.83),('8537','2013-10-03','16:55:00',1.69),('8537','2013-10-03','17:00:00',1.56),('8537','2013-10-03','17:05:00',1.45),('8537','2013-10-03','17:10:00',1.35),('8537','2013-10-03','17:15:00',1.17),('8537','2013-10-03','17:20:00',1.1),('8537','2013-10-02','08:15:00',1.08),('8537','2013-10-02','08:20:00',1.31),('8537','2013-10-02','08:25:00',1.29),('8537','2013-10-02','08:30:00',1.37),('8537','2013-10-02','08:35:00',1.44),('8537','2013-10-02','08:40:00',1.54),('8537','2013-10-02','08:45:00',1.67),('8537','2013-10-02','08:50:00',1.79),('8537','2013-10-02','08:55:00',1.9),('8537','2013-10-02','09:00:00',2.03),('8537','2013-10-02','09:05:00',2.13),('8537','2013-10-02','09:10:00',2.24),('8537','2013-10-02','09:15:00',2.36),('8537','2013-10-02','09:20:00',2.47),('8537','2013-10-02','09:25:00',2.57),('8537','2013-10-02','09:30:00',2.64),('8537','2013-10-02','09:35:00',2.77),('8537','2013-10-02','09:40:00',2.86),('8537','2013-10-02','09:45:00',2.93),('8537','2013-10-02','09:50:00',3.02),('8537','2013-10-02','09:55:00',3.09),('8537','2013-10-02','10:00:00',2.36),('8537','2013-10-02','10:05:00',3.23),('8537','2013-10-02','10:10:00',3.29),('8537','2013-10-02','10:15:00',3.39),('8537','2013-10-02','10:20:00',3.49),('8537','2013-10-02','10:25:00',3.57),('8537','2013-10-02','10:30:00',3.66),('8537','2013-10-02','10:35:00',3.73),('8537','2013-10-02','10:40:00',3.82),('8537','2013-10-02','10:45:00',3.9),('8537','2013-10-02','10:50:00',3.95),('8537','2013-10-02','10:55:00',4.02),('8537','2013-10-02','11:00:00',4.08),('8537','2013-10-02','11:05:00',4.14),('8537','2013-10-02','11:10:00',4.19),('8537','2013-10-02','11:15:00',4.24),('8537','2013-10-02','11:20:00',4.27),('8537','2013-10-02','11:25:00',4.31),('8537','2013-10-02','11:30:00',4.34),('8537','2013-10-02','11:35:00',4.35),('8537','2013-10-02','11:40:00',4.39),('8537','2013-10-02','11:45:00',4.41),('8537','2013-10-02','11:50:00',4.45),('8537','2013-10-02','11:55:00',4.49),('8537','2013-10-02','12:00:00',4.52),('8537','2013-10-02','12:05:00',4.55),('8537','2013-10-02','12:10:00',4.53),('8537','2013-10-02','12:15:00',4.58),('8537','2013-10-02','12:20:00',4.59),('8537','2013-10-02','12:25:00',4.58),('8537','2013-10-02','12:30:00',4.58),('8537','2013-10-02','12:35:00',4.61),('8537','2013-10-02','12:40:00',4.64),('8537','2013-10-02','12:45:00',4.64),('8537','2013-10-02','12:50:00',4.62),('8537','2013-10-02','12:55:00',4.62),('8537','2013-10-02','13:00:00',4.64),('8537','2013-10-02','13:05:00',4.63),('8537','2013-10-02','13:10:00',4.61),('8537','2013-10-02','13:15:00',4.6),('8537','2013-10-02','13:20:00',4.62),('8537','2013-10-02','13:25:00',4.61),('8537','2013-10-02','13:30:00',4.59),('8537','2013-10-02','13:35:00',4.57),('8537','2013-10-02','13:40:00',4.55),('8537','2013-10-02','13:45:00',4.52),('8537','2013-10-02','13:50:00',4.49),('8537','2013-10-02','13:55:00',4.47),('8537','2013-10-02','14:00:00',4.44),('8537','2013-10-02','14:05:00',4.41),('8537','2013-10-02','14:10:00',4.39),('8537','2013-10-02','14:15:00',4.34),('8537','2013-10-02','14:20:00',4.21),('8537','2013-10-02','14:25:00',4.24),('8537','2013-10-02','14:30:00',4.17),('8537','2013-10-02','14:35:00',4.1),('8537','2013-10-02','14:40:00',4.06),('8537','2013-10-02','14:45:00',4.01),('8537','2013-10-02','14:50:00',3.95),('8537','2013-10-02','14:55:00',3.91),('8537','2013-10-02','15:00:00',3.85),('8537','2013-10-02','15:05:00',3.78),('8537','2013-10-02','15:10:00',3.71),('8537','2013-10-02','15:15:00',3.65),('8537','2013-10-02','15:20:00',3.56),('8537','2013-10-02','15:25:00',3.42),('8537','2013-10-02','15:30:00',3.19),('8537','2013-10-02','15:35:00',3.17),('8537','2013-10-02','15:40:00',3.22),('8537','2013-10-02','15:45:00',3.15),('8537','2013-10-02','15:50:00',3.06),('8537','2013-10-02','15:55:00',2.96),('8537','2013-10-02','16:00:00',2.85),('8537','2013-10-02','16:05:00',2.7),('8537','2013-10-02','16:10:00',2.65),('8537','2013-10-02','16:15:00',2.56),('8537','2013-10-02','16:20:00',2.46),('8537','2013-10-02','16:25:00',2.31),('8537','2013-10-02','16:30:00',2.22),('8537','2013-10-02','16:35:00',2.12),('8537','2013-10-02','16:40:00',2.01),('8537','2013-10-02','16:45:00',1.9),('8537','2013-10-02','16:50:00',1.79),('8537','2013-10-02','16:55:00',1.64),('8537','2013-10-02','17:00:00',1.53),('8537','2013-10-02','17:05:00',1.42),('8537','2013-10-02','17:10:00',1.31),('8537','2013-10-02','17:15:00',1.17),('8537','2013-10-02','17:20:00',1.06),('8537','2013-10-01','08:25:00',1.31),('8537','2013-10-01','08:30:00',1.26),('8537','2013-10-01','08:35:00',1.02),('8537','2013-10-01','08:40:00',1.59),('8537','2013-10-01','08:45:00',1.72),('8537','2013-10-01','08:50:00',1.83),('8537','2013-10-01','08:55:00',1.94),('8537','2013-10-01','09:00:00',2.04),('8537','2013-10-01','09:05:00',2.14),('8537','2013-10-01','09:10:00',2.22),('8537','2013-10-01','09:15:00',2.32),('8537','2013-10-01','09:20:00',2.41),('8537','2013-10-01','09:25:00',2.51),('8537','2013-10-01','09:30:00',2.59),('8537','2013-10-01','09:35:00',2.67),('8537','2013-10-01','09:40:00',2.77),('8537','2013-10-01','09:45:00',2.86),('8537','2013-10-01','09:50:00',2.92),('8537','2013-10-01','09:55:00',3.02),('8537','2013-10-01','10:00:00',3.1),('8537','2013-10-01','10:05:00',3.18),('8537','2013-10-01','10:10:00',3.27),('8537','2013-10-01','10:15:00',3.32),('8537','2013-10-01','10:20:00',3.34),('8537','2013-10-01','10:25:00',3.51),('8537','2013-10-01','10:30:00',3.59),('8537','2013-10-01','10:35:00',3.64),('8537','2013-10-01','10:40:00',3.72),('8537','2013-10-01','10:45:00',3.8),('8537','2013-10-01','10:50:00',3.8),('8537','2013-10-01','10:55:00',3.88),('8537','2013-10-01','11:00:00',3.88),('8537','2013-10-01','11:05:00',4.12),('8537','2013-10-01','11:10:00',4.37),('8537','2013-10-01','11:15:00',1.59),('8537','2013-10-01','11:20:00',2.35),('8537','2013-10-01','11:25:00',4.13),('8537','2013-10-01','11:30:00',3.49),('8537','2013-10-01','11:35:00',1.39),('8537','2013-10-01','11:40:00',3.35),('8537','2013-10-01','11:45:00',4.5),('8537','2013-10-01','11:50:00',4.49),('8537','2013-10-01','11:55:00',4.51),('8537','2013-10-01','12:00:00',4.42),('8537','2013-10-01','12:05:00',4.32),('8537','2013-10-01','12:10:00',4.26),('8537','2013-10-01','12:15:00',4.47),('8537','2013-10-01','12:20:00',4.65),('8537','2013-10-01','12:25:00',4.64),('8537','2013-10-01','12:30:00',4.71),('8537','2013-10-01','12:35:00',4.61),('8537','2013-10-01','12:40:00',1.2),('8537','2013-10-01','12:45:00',4.66),('8537','2013-10-01','12:50:00',4.71),('8537','2013-10-01','12:55:00',4.68),('8537','2013-10-01','13:00:00',4.63),('8537','2013-10-01','13:05:00',4.24),('8537','2013-10-01','13:20:00',4.4),('8537','2013-10-01','13:25:00',4.99),('8537','2013-10-01','13:30:00',4.4),('8537','2013-10-01','13:35:00',4.76),('8537','2013-10-01','13:40:00',4),('8537','2013-10-01','13:45:00',4.71),('8537','2013-10-01','13:50:00',2.82),('8537','2013-10-01','13:55:00',4.49),('8537','2013-10-01','14:00:00',4.33),('8537','2013-10-01','14:05:00',4.25),('8537','2013-10-01','14:10:00',4.22),('8537','2013-10-01','14:15:00',4.14),('8537','2013-10-01','14:20:00',4.11),('8537','2013-10-01','14:25:00',4.06),('8537','2013-10-01','14:30:00',3.95),('8537','2013-10-01','14:35:00',3.85),('8537','2013-10-01','14:40:00',3.98),('8537','2013-10-01','14:45:00',3.95),('8537','2013-10-01','14:50:00',3.83),('8537','2013-10-01','14:55:00',3.86),('8537','2013-10-01','15:00:00',3.82),('8537','2013-10-01','15:05:00',3.69),('8537','2013-10-01','15:10:00',3.59),('8537','2013-10-01','15:15:00',3.5),('8537','2013-10-01','15:20:00',3.43),('8537','2013-10-01','15:25:00',3.39),('8537','2013-10-01','15:30:00',3.33),('8537','2013-10-01','15:35:00',3.2),('8537','2013-10-01','15:40:00',3.17),('8537','2013-10-01','15:45:00',3.08),('8537','2013-10-01','15:50:00',3),('8537','2013-10-01','15:55:00',2.92),('8537','2013-10-01','16:00:00',2.79),('8537','2013-10-01','16:05:00',2.73),('8537','2013-10-01','16:10:00',2.62),('8537','2013-10-01','16:15:00',2.55),('8537','2013-10-01','16:20:00',2.46),('8537','2013-10-01','16:25:00',2.33),('8537','2013-10-01','16:30:00',2.18),('8537','2013-10-01','16:35:00',2.02),('8537','2013-10-01','16:40:00',1.99),('8537','2013-10-01','16:45:00',1.89),('8537','2013-10-01','16:50:00',1.79),('8537','2013-10-01','16:55:00',1.66),('8537','2013-10-01','17:00:00',1.55),('8537','2013-10-01','17:05:00',1.43),('8537','2013-10-01','17:10:00',1.33),('8537','2013-10-01','17:15:00',1.18),('8537','2013-10-01','17:20:00',1.1),('8537','2013-10-01','17:25:00',1.01),('8537','2013-09-30','09:45:00',1.14),('8537','2013-09-30','09:50:00',1.5),('8537','2013-09-30','09:55:00',1.27),('8537','2013-09-30','10:00:00',1.19),('8537','2013-09-30','10:05:00',1.15),('8537','2013-09-30','10:10:00',1.25),('8537','2013-09-30','10:15:00',1.27),('8537','2013-09-30','10:20:00',1.28),('8537','2013-09-30','10:25:00',1.53),('8537','2013-09-30','10:30:00',1.75),('8537','2013-09-30','10:35:00',2.01),('8537','2013-09-30','10:40:00',2.63),('8537','2013-09-30','10:45:00',3.95),('8537','2013-09-30','10:50:00',4.08),('8537','2013-09-30','10:55:00',3.76),('8537','2013-09-30','11:00:00',2.77),('8537','2013-09-30','11:05:00',2.83),('8537','2013-09-30','11:10:00',3.21),('8537','2013-09-30','11:15:00',3.54),('8537','2013-09-30','11:20:00',3.89),('8537','2013-09-30','11:25:00',2.87),('8537','2013-09-30','11:30:00',2.07),('8537','2013-09-30','11:35:00',1.78),('8537','2013-09-30','11:40:00',3.7),('8537','2013-09-30','11:45:00',2.39),('8537','2013-09-30','11:50:00',2.1),('8537','2013-09-30','11:55:00',1.71),('8537','2013-09-30','12:00:00',1.76),('8537','2013-09-30','12:05:00',1.95),('8537','2013-09-30','12:10:00',2.11),('8537','2013-09-30','12:15:00',4.78),('8537','2013-09-30','12:20:00',4.79),('8537','2013-09-30','12:25:00',4.77),('8537','2013-09-30','12:30:00',4.54),('8537','2013-09-30','12:35:00',4.62),('8537','2013-09-30','12:40:00',4.52),('8537','2013-09-30','12:45:00',3.99),('8537','2013-09-30','12:50:00',4.84),('8537','2013-09-30','12:55:00',4.73),('8537','2013-09-30','13:00:00',4.78),('8537','2013-09-30','13:05:00',4.7),('8537','2013-09-30','13:10:00',4.89),('8537','2013-09-30','13:15:00',4.68),('8537','2013-09-30','13:20:00',5.02),('8537','2013-09-30','13:25:00',5.25),('8537','2013-09-30','13:30:00',5.16),('8537','2013-09-30','13:35:00',4.23),('8537','2013-09-30','13:40:00',4.55),('8537','2013-09-30','13:45:00',3.02),('8537','2013-09-30','13:50:00',3.81),('8537','2013-09-30','13:55:00',2.78),('8537','2013-09-30','14:00:00',2.21),('8537','2013-09-30','14:05:00',1.62),('8537','2013-09-30','14:10:00',1.54),('8537','2013-09-30','14:15:00',1.46),('8537','2013-09-30','14:20:00',1.24),('8537','2013-09-30','14:25:00',1.39),('8537','2013-09-30','14:30:00',2.98),('8537','2013-09-30','14:35:00',3.17),('8537','2013-09-30','14:40:00',4.57),('8537','2013-09-30','14:45:00',4.16),('8537','2013-09-30','14:50:00',3.23),('8537','2013-09-30','14:55:00',3.38),('8537','2013-09-30','15:00:00',2.13),('8537','2013-09-30','15:05:00',2.61),('8537','2013-09-30','15:10:00',4.36),('8537','2013-09-30','15:15:00',2.55),('8537','2013-09-30','15:20:00',1.35),('8537','2013-09-30','15:25:00',3.02),('8537','2013-09-30','15:30:00',2.53),('8537','2013-09-30','15:35:00',3.02),('8537','2013-09-30','15:40:00',3.78),('8537','2013-09-30','15:45:00',2.55),('8537','2013-09-30','16:10:00',1.08),('8537','2013-09-30','16:15:00',1.68),('8537','2013-09-30','16:20:00',2.13),('8537','2013-09-30','16:25:00',1.01),('8537','2013-09-30','16:40:00',1.07),('8537','2013-09-30','16:45:00',1.69),('8537','2013-09-29','08:45:00',1.13),('8537','2013-09-29','08:50:00',1.45),('8537','2013-09-29','08:55:00',1.28),('8537','2013-09-29','09:00:00',1.18),('8537','2013-09-29','09:05:00',1.04),('8537','2013-09-29','09:10:00',1.16),('8537','2013-09-29','09:15:00',1.53),('8537','2013-09-29','09:20:00',1.03),('8537','2013-09-29','09:25:00',1.05),('8537','2013-09-29','09:30:00',1.02),('8537','2013-09-29','09:45:00',1.11),('8537','2013-09-29','09:50:00',1.2),('8537','2013-09-29','09:55:00',1.24),('8537','2013-09-29','10:00:00',1.46),('8537','2013-09-29','10:05:00',2.03),('8537','2013-09-29','10:10:00',2.38),('8537','2013-09-29','10:15:00',3.02),('8537','2013-09-29','10:20:00',2.65),('8537','2013-09-29','10:25:00',2.47),('8537','2013-09-29','10:30:00',2.83),('8537','2013-09-29','10:35:00',3.01),('8537','2013-09-29','10:40:00',3.26),('8537','2013-09-29','10:45:00',3.36),('8537','2013-09-29','10:50:00',3.47),('8537','2013-09-29','10:55:00',3.43),('8537','2013-09-29','11:00:00',3.5),('8537','2013-09-29','11:05:00',3.36),('8537','2013-09-29','11:10:00',3.4),('8537','2013-09-29','11:15:00',3.67),('8537','2013-09-29','11:20:00',3.67),('8537','2013-09-29','11:25:00',3.37),('8537','2013-09-29','11:30:00',3.65),('8537','2013-09-29','11:35:00',3.62),('8537','2013-09-29','11:40:00',3.76),('8537','2013-09-29','11:45:00',3.86),('8537','2013-09-29','11:50:00',4.03),('8537','2013-09-29','11:55:00',3.99),('8537','2013-09-29','12:00:00',3.83),('8537','2013-09-29','12:05:00',4.02),('8537','2013-09-29','12:10:00',3.79),('8537','2013-09-29','12:15:00',4.51),('8537','2013-09-29','12:20:00',3.48),('8537','2013-09-29','12:25:00',2.24),('8537','2013-09-29','12:30:00',2.28),('8537','2013-09-29','12:35:00',2.23),('8537','2013-09-29','12:40:00',1.93),('8537','2013-09-29','12:45:00',1.71),('8537','2013-09-29','12:50:00',1.74),('8537','2013-09-29','12:55:00',1.49),('8537','2013-09-29','13:00:00',1.56),('8537','2013-09-29','13:05:00',1.26),('8537','2013-09-29','13:10:00',1.35),('8537','2013-09-29','13:15:00',1.03),('8537','2013-09-29','13:20:00',1.1),('8537','2013-09-29','13:25:00',1.6),('8537','2013-09-29','13:30:00',2.83),('8537','2013-09-29','13:35:00',1.95),('8537','2013-09-29','13:40:00',1.91),('8537','2013-09-29','13:45:00',1.77),('8537','2013-09-29','13:50:00',1.89),('8537','2013-09-29','13:55:00',2.79),('8537','2013-09-29','14:00:00',2.18),('8537','2013-09-29','14:05:00',2.99),('8537','2013-09-29','14:10:00',1.68),('8537','2013-09-29','14:15:00',1.96),('8537','2013-09-29','14:20:00',2.4),('8537','2013-09-29','14:25:00',1.72),('8537','2013-09-29','14:30:00',1.52),('8537','2013-09-29','14:35:00',1.46),('8537','2013-09-29','14:40:00',1.31),('8537','2013-09-29','14:50:00',1.11),('8537','2013-09-29','14:55:00',1.23),('8537','2013-09-29','15:00:00',1.56),('8537','2013-09-29','15:20:00',1.14),('8537','2013-09-29','15:25:00',1),('8537','2013-09-29','15:55:00',1.07),('8537','2013-09-29','16:00:00',1.35),('8537','2013-09-29','16:05:00',1.1),('8537','2013-09-29','16:30:00',1.3),('8537','2013-09-29','16:35:00',1.14),('8537','2014-04-14','07:55:00',1.09),('8537','2014-04-14','08:00:00',1.2),('8537','2014-04-14','08:05:00',1.32),('8537','2014-04-14','08:10:00',1.43),('8537','2014-04-14','08:15:00',1.55),('8537','2014-04-14','08:20:00',1.67),('8537','2014-04-14','08:25:00',1.79),('8537','2014-04-14','08:30:00',1.9),('8537','2014-04-14','08:35:00',2.02),('8537','2014-04-14','08:40:00',2.13),('8537','2014-04-14','08:45:00',2.25),('8537','2014-04-14','08:50:00',2.36),('8537','2014-04-14','08:55:00',2.46),('8537','2014-04-14','09:00:00',2.57),('8537','2014-04-14','09:05:00',2.66),('8537','2014-04-14','09:10:00',2.78),('8537','2014-04-14','09:15:00',2.87),('8537','2014-04-14','09:20:00',2.96),('8537','2014-04-14','09:25:00',2.99),('8537','2014-04-14','09:30:00',3.13),('8537','2014-04-14','09:35:00',3.22),('8537','2014-04-14','09:40:00',3.3),('8537','2014-04-14','09:45:00',3.4),('8537','2014-04-14','09:50:00',3.49),('8537','2014-04-14','09:55:00',3.6),('8537','2014-04-14','10:00:00',3.67),('8537','2014-04-14','10:05:00',3.78),('8537','2014-04-14','10:10:00',3.83),('8537','2014-04-14','10:15:00',3.93),('8537','2014-04-14','10:20:00',4.02),('8537','2014-04-14','10:25:00',4.09),('8537','2014-04-14','10:30:00',4.15),('8537','2014-04-14','10:35:00',4.22),('8537','2014-04-14','10:40:00',4.23),('8537','2014-04-14','10:45:00',4.34),('8537','2014-04-14','10:50:00',4.4),('8537','2014-04-14','10:55:00',4.45),('8537','2014-04-14','11:00:00',4.49),('8537','2014-04-14','11:05:00',4.54),('8537','2014-04-14','11:10:00',4.58),('8537','2014-04-14','11:15:00',4.63),('8537','2014-04-14','11:20:00',4.69),('8537','2014-04-14','11:25:00',4.72),('8537','2014-04-14','11:30:00',4.75),('8537','2014-04-14','11:35:00',4.81),('8537','2014-04-14','11:40:00',4.83),('8537','2014-04-14','11:45:00',4.86),('8537','2014-04-14','11:50:00',4.89),('8537','2014-04-14','11:55:00',4.88),('8537','2014-04-14','12:00:00',4.91),('8537','2014-04-14','12:05:00',4.93),('8537','2014-04-14','12:10:00',4.98),('8537','2014-04-14','12:15:00',4.99),('8537','2014-04-14','12:20:00',4.98),('8537','2014-04-14','12:25:00',4.93),('8537','2014-04-14','12:30:00',5.07),('8537','2014-04-14','12:35:00',5.03),('8537','2014-04-14','12:40:00',5.11),('8537','2014-04-14','12:45:00',5.13),('8537','2014-04-14','12:50:00',5.13),('8537','2014-04-14','12:55:00',5.11),('8537','2014-04-14','13:00:00',5.15),('8537','2014-04-14','13:05:00',5.13),('8537','2014-04-14','13:10:00',5.11),('8537','2014-04-14','13:15:00',5.06),('8537','2014-04-14','13:20:00',5.13),('8537','2014-04-14','13:25:00',5.09),('8537','2014-04-14','13:30:00',5.09),('8537','2014-04-14','13:35:00',5.14),('8537','2014-04-14','13:40:00',5.11),('8537','2014-04-14','13:45:00',5.08),('8537','2014-04-14','13:50:00',5.05),('8537','2014-04-14','13:55:00',5.04),('8537','2014-04-14','14:00:00',5.03),('8537','2014-04-14','14:05:00',5),('8537','2014-04-14','14:10:00',4.98),('8537','2014-04-14','14:15:00',4.96),('8537','2014-04-14','14:20:00',4.96),('8537','2014-04-14','14:25:00',4.95),('8537','2014-04-14','14:30:00',4.83),('8537','2014-04-14','14:35:00',4.48),('8537','2014-04-14','14:40:00',4.04),('8537','2014-04-14','14:45:00',4.53),('8537','2014-04-14','14:50:00',4.67),('8537','2014-04-14','14:55:00',4.62),('8537','2014-04-14','15:00:00',4.56),('8537','2014-04-14','15:05:00',4.51),('8537','2014-04-14','15:10:00',4.47),('8537','2014-04-14','15:15:00',4.41),('8537','2014-04-14','15:20:00',4.35),('8537','2014-04-14','15:25:00',4.08),('8537','2014-04-14','15:30:00',4.05),('8537','2014-04-14','15:35:00',4.1),('8537','2014-04-14','15:40:00',4.05),('8537','2014-04-14','15:45:00',3.98),('8537','2014-04-14','15:50:00',3.91),('8537','2014-04-14','15:55:00',3.86),('8537','2014-04-14','16:00:00',3.76),('8537','2014-04-14','16:05:00',3.57),('8537','2014-04-14','16:10:00',3.21),('8537','2014-04-14','16:15:00',3.46),('8537','2014-04-14','16:20:00',3.38),('8537','2014-04-14','16:25:00',3.31),('8537','2014-04-14','16:30:00',3.21),('8537','2014-04-14','16:35:00',3.13),('8537','2014-04-14','16:40:00',2.87),('8537','2014-04-14','16:45:00',2.7),('8537','2014-04-14','16:50:00',2.8),('8537','2014-04-14','16:55:00',2.71),('8537','2014-04-14','17:00:00',2.55),('8537','2014-04-14','17:05:00',2.4),('8537','2014-04-14','17:10:00',2.32),('8537','2014-04-14','17:15:00',2.19),('8537','2014-04-14','17:20:00',2.13),('8537','2014-04-14','17:25:00',2.02),('8537','2014-04-14','17:30:00',1.86),('8537','2014-04-14','17:35:00',1.74),('8537','2014-04-14','17:40:00',1.63),('8537','2014-04-14','17:45:00',1.53),('8537','2014-04-14','17:50:00',1.42),('8537','2014-04-14','17:55:00',1.3),('8537','2014-04-14','18:00:00',1.2),('8537','2014-04-14','18:05:00',1.09),('8537','2013-09-28','08:15:00',1.01),('8537','2013-09-28','08:20:00',1.16),('8537','2013-09-28','08:30:00',1.27),('8537','2013-09-28','08:35:00',1.35),('8537','2013-09-28','08:40:00',1.47),('8537','2013-09-28','08:45:00',1.56),('8537','2013-09-28','08:50:00',1.67),('8537','2013-09-28','08:55:00',1.74),('8537','2013-09-28','09:00:00',1.85),('8537','2013-09-28','09:05:00',1.95),('8537','2013-09-28','09:10:00',2.09),('8537','2013-09-28','09:15:00',2.19),('8537','2013-09-28','09:20:00',2.27),('8537','2013-09-28','09:25:00',2.39),('8537','2013-09-28','09:30:00',2.49),('8537','2013-09-28','09:35:00',2.57),('8537','2013-09-28','09:40:00',2.72),('8537','2013-09-28','09:45:00',2.53),('8537','2013-09-28','09:50:00',2.52),('8537','2013-09-28','09:55:00',2.61),('8537','2013-09-28','10:00:00',1.88),('8537','2013-09-28','10:05:00',2.77),('8537','2013-09-28','10:10:00',1.41),('8537','2013-09-28','10:15:00',1.09),('8537','2013-09-28','10:20:00',1.25),('8537','2013-09-28','10:25:00',1.82),('8537','2013-09-28','10:30:00',2.48),('8537','2013-09-28','10:35:00',2.67),('8537','2013-09-28','10:40:00',2.49),('8537','2013-09-28','10:45:00',3.27),('8537','2013-09-28','10:50:00',4.22),('8537','2013-09-28','10:55:00',4.3),('8537','2013-09-28','11:00:00',3.94),('8537','2013-09-28','11:05:00',1.5),('8537','2013-09-28','11:10:00',2.03),('8537','2013-09-28','11:15:00',3.9),('8537','2013-09-28','11:20:00',4.23),('8537','2013-09-28','11:25:00',4.14),('8537','2013-09-28','11:30:00',4.42),('8537','2013-09-28','11:35:00',3.66),('8537','2013-09-28','11:40:00',3.62),('8537','2013-09-28','11:45:00',1.11),('8537','2013-09-28','11:50:00',2.52),('8537','2013-09-28','11:55:00',1.6),('8537','2013-09-28','12:00:00',4.74),('8537','2013-09-28','12:05:00',4.66),('8537','2013-09-28','12:10:00',4.5),('8537','2013-09-28','12:15:00',2.98),('8537','2013-09-28','12:20:00',4.07),('8537','2013-09-28','12:25:00',3.02),('8537','2013-09-28','12:30:00',2.21),('8537','2013-09-28','12:35:00',2.8),('8537','2013-09-28','12:40:00',2.61),('8537','2013-09-28','12:45:00',1.76),('8537','2013-09-28','12:50:00',5.06),('8537','2013-09-28','12:55:00',4.49),('8537','2013-09-28','13:00:00',4.52),('8537','2013-09-28','13:05:00',3.67),('8537','2013-09-28','13:10:00',1.36),('8537','2013-09-28','13:15:00',1.59),('8537','2013-09-28','13:20:00',2.31),('8537','2013-09-28','13:25:00',3.81),('8537','2013-09-28','13:30:00',3.51),('8537','2013-09-28','13:35:00',1.87),('8537','2013-09-28','13:40:00',1.79),('8537','2013-09-28','13:45:00',2.4),('8537','2013-09-28','13:50:00',2.79),('8537','2013-09-28','13:55:00',1.74),('8537','2013-09-28','14:00:00',1.98),('8537','2013-09-28','14:05:00',2.16),('8537','2013-09-28','14:10:00',1.85),('8537','2013-09-28','14:15:00',2.31),('8537','2013-09-28','14:20:00',4.21),('8537','2013-09-28','14:25:00',4.62),('8537','2013-09-28','14:30:00',4.2),('8537','2013-09-28','14:35:00',4.35),('8537','2013-09-28','14:40:00',4.33),('8537','2013-09-28','14:45:00',4.27),('8537','2013-09-28','14:50:00',3.13),('8537','2013-09-28','14:55:00',3.22),('8537','2013-09-28','15:00:00',4.17),('8537','2013-09-28','15:05:00',2.67),('8537','2013-09-28','15:10:00',2.79),('8537','2013-09-28','15:15:00',3.39),('8537','2013-09-28','15:20:00',3.82),('8537','2013-09-28','15:25:00',3.8),('8537','2013-09-28','15:30:00',3.62),('8537','2013-09-28','15:35:00',3.35),('8537','2013-09-28','15:40:00',3.27),('8537','2013-09-28','15:45:00',2.47),('8537','2013-09-28','15:50:00',2.18),('8537','2013-09-28','15:55:00',2.67),('8537','2013-09-28','16:00:00',2.95),('8537','2013-09-28','16:05:00',3.01),('8537','2013-09-28','16:10:00',2.94),('8537','2013-09-28','16:15:00',2.76),('8537','2013-09-28','16:20:00',2.54),('8537','2013-09-28','16:25:00',2.19),('8537','2013-09-28','16:30:00',2.06),('8537','2013-09-28','16:35:00',2.05),('8537','2013-09-28','16:40:00',1.95),('8537','2013-09-28','16:45:00',1.82),('8537','2013-09-28','16:50:00',1.74),('8537','2013-09-28','16:55:00',1.63),('8537','2013-09-28','17:00:00',1.49),('8537','2013-09-28','17:05:00',1.41),('8537','2013-09-28','17:10:00',1.28),('8537','2013-09-28','17:15:00',1.19),('8537','2013-09-28','17:20:00',1.09),('8537','2013-09-28','17:25:00',1),('8537','2013-09-27','08:25:00',1.32),('8537','2013-09-27','08:30:00',1.28),('8537','2013-09-27','08:35:00',1.47),('8537','2013-09-27','08:40:00',1.57),('8537','2013-09-27','08:45:00',1.37),('8537','2013-09-27','08:50:00',1.54),('8537','2013-09-27','08:55:00',1.93),('8537','2013-09-27','09:00:00',1.78),('8537','2013-09-27','09:05:00',1.42),('8537','2013-09-27','09:10:00',1.2),('8537','2013-09-27','09:15:00',1.27),('8537','2013-09-27','09:25:00',1.15),('8537','2013-09-27','09:50:00',1.61),('8537','2013-09-27','09:55:00',2.82),('8537','2013-09-27','10:00:00',2.04),('8537','2013-09-27','10:05:00',2.62),('8537','2013-09-27','10:10:00',2.1),('8537','2013-09-27','10:15:00',2.16),('8537','2013-09-27','10:20:00',3.19),('8537','2013-09-27','10:25:00',2.37),('8537','2013-09-27','10:30:00',1.98),('8537','2013-09-27','10:35:00',1.9),('8537','2013-09-27','10:40:00',1.52),('8537','2013-09-27','10:45:00',1.78),('8537','2013-09-27','10:50:00',1.62),('8537','2013-09-27','10:55:00',3.28),('8537','2013-09-27','11:00:00',3.67),('8537','2013-09-27','11:05:00',3.43),('8537','2013-09-27','11:10:00',3.2),('8537','2013-09-27','11:15:00',3.49),('8537','2013-09-27','11:20:00',3.03),('8537','2013-09-27','11:25:00',2.62),('8537','2013-09-27','11:30:00',2.18),('8537','2013-09-27','11:35:00',1.23),('8537','2013-09-27','11:40:00',1.24),('8537','2013-09-27','11:45:00',2.78),('8537','2013-09-27','11:50:00',1.3),('8537','2013-09-27','11:55:00',1.38),('8537','2013-09-27','12:00:00',4.32),('8537','2013-09-27','12:05:00',2.44),('8537','2013-09-27','12:10:00',4.69),('8537','2013-09-27','12:15:00',3.36),('8537','2013-09-27','12:20:00',1.15),('8537','2013-09-27','12:25:00',1.24),('8537','2013-09-27','12:30:00',1.43),('8537','2013-09-27','12:35:00',1.23),('8537','2013-09-27','12:40:00',1.07),('8537','2013-09-27','12:45:00',1.53),('8537','2013-09-27','12:50:00',3.57),('8537','2013-09-27','12:55:00',4.36),('8537','2013-09-27','13:00:00',4.36),('8537','2013-09-27','13:05:00',4.35),('8537','2013-09-27','13:10:00',4.51),('8537','2013-09-27','13:15:00',3.36),('8537','2013-09-27','13:20:00',2.62),('8537','2013-09-27','13:25:00',2.55),('8537','2013-09-27','13:30:00',1.01),('8537','2013-09-27','13:35:00',1.06),('8537','2013-09-27','13:40:00',1.13),('8537','2013-09-27','13:45:00',1.66),('8537','2013-09-27','13:50:00',1.31),('8537','2013-09-27','13:55:00',1.57),('8537','2013-09-27','14:00:00',1.96),('8537','2013-09-27','14:05:00',3.96),('8537','2013-09-27','14:10:00',2.62),('8537','2013-09-27','14:15:00',4.2),('8537','2013-09-27','14:20:00',3.51),('8537','2013-09-27','14:25:00',4.21),('8537','2013-09-27','14:30:00',3.18),('8537','2013-09-27','14:35:00',4.05),('8537','2013-09-27','14:40:00',3.94),('8537','2013-09-27','14:45:00',3.9),('8537','2013-09-27','14:50:00',3.84),('8537','2013-09-27','14:55:00',3.74),('8537','2013-09-27','15:00:00',3.78),('8537','2013-09-27','15:05:00',2.62),('8537','2013-09-27','15:10:00',2.67),('8537','2013-09-27','15:15:00',3.53),('8537','2013-09-27','15:20:00',2.75),('8537','2013-09-27','15:25:00',3.39),('8537','2013-09-27','15:30:00',3.34),('8537','2013-09-27','15:35:00',3.21),('8537','2013-09-27','15:40:00',3.15),('8537','2013-09-27','15:45:00',2.6),('8537','2013-09-27','15:50:00',3.14),('8537','2013-09-27','15:55:00',2.95),('8537','2013-09-27','16:00:00',2.27),('8537','2013-09-27','16:05:00',2.22),('8537','2013-09-27','16:10:00',1.26),('8537','2013-09-27','16:15:00',1.9),('8537','2013-09-27','16:20:00',2.18),('8537','2013-09-27','16:25:00',2.21),('8537','2013-09-27','16:30:00',2.09),('8537','2013-09-27','16:35:00',2.09),('8537','2013-09-27','16:40:00',1.84),('8537','2013-09-27','16:45:00',1.93),('8537','2013-09-27','16:50:00',1.64),('8537','2013-09-27','16:55:00',1.06),('8537','2013-09-27','17:10:00',1.2),('8537','2013-09-27','17:15:00',1.4),('8537','2013-09-27','17:20:00',1.21),('8537','2013-09-27','17:25:00',1.1),('8537','2013-09-27','17:30:00',1.01),('8537','2013-09-26','08:15:00',1.06),('8537','2013-09-26','08:25:00',1.23),('8537','2013-09-26','08:30:00',1.21),('8537','2013-09-26','08:35:00',1.27),('8537','2013-09-26','08:40:00',1.55),('8537','2013-09-26','08:45:00',1.68),('8537','2013-09-26','08:50:00',1.82),('8537','2013-09-26','08:55:00',1.94),('8537','2013-09-26','09:00:00',2.04),('8537','2013-09-26','09:05:00',2.13),('8537','2013-09-26','09:10:00',2.24),('8537','2013-09-26','09:15:00',2.36),('8537','2013-09-26','09:20:00',2.47),('8537','2013-09-26','09:25:00',2.55),('8537','2013-09-26','09:30:00',2.63),('8537','2013-09-26','09:35:00',2.74),('8537','2013-09-26','09:40:00',2.81),('8537','2013-09-26','09:45:00',2.91),('8537','2013-09-26','09:50:00',3),('8537','2013-09-26','09:55:00',3.04),('8537','2013-09-26','10:00:00',3.13),('8537','2013-09-26','10:05:00',3.21),('8537','2013-09-26','10:10:00',3.3),('8537','2013-09-26','10:15:00',3.29),('8537','2013-09-26','10:20:00',3.35),('8537','2013-09-26','10:25:00',3.33),('8537','2013-09-26','10:30:00',3.49),('8537','2013-09-26','10:35:00',3.57),('8537','2013-09-26','10:40:00',3.58),('8537','2013-09-26','10:45:00',3.67),('8537','2013-09-26','10:50:00',3.68),('8537','2013-09-26','10:55:00',3.75),('8537','2013-09-26','11:00:00',3.64),('8537','2013-09-26','11:05:00',3.78),('8537','2013-09-26','11:10:00',3.88),('8537','2013-09-26','11:15:00',3.89),('8537','2013-09-26','11:20:00',3.99),('8537','2013-09-26','11:25:00',4.03),('8537','2013-09-26','11:30:00',4.05),('8537','2013-09-26','11:35:00',3.71),('8537','2013-09-26','11:40:00',3.35),('8537','2013-09-26','11:45:00',4.1),('8537','2013-09-26','11:50:00',4.17),('8537','2013-09-26','11:55:00',2.41),('8537','2013-09-26','12:00:00',4.02),('8537','2013-09-26','12:05:00',3.13),('8537','2013-09-26','12:10:00',1.87),('8537','2013-09-26','12:15:00',1.62),('8537','2013-09-26','12:20:00',2.03),('8537','2013-09-26','12:25:00',1.53),('8537','2013-09-26','12:30:00',1.59),('8537','2013-09-26','12:35:00',1.64),('8537','2013-09-26','12:40:00',1.79),('8537','2013-09-26','12:45:00',1.97),('8537','2013-09-26','12:50:00',1.88),('8537','2013-09-26','12:55:00',2.78),('8537','2013-09-26','13:00:00',3.76),('8537','2013-09-26','13:05:00',3.05),('8537','2013-09-26','13:10:00',2.14),('8537','2013-09-26','13:15:00',3.41),('8537','2013-09-26','13:20:00',4.89),('8537','2013-09-26','13:25:00',4.66),('8537','2013-09-26','13:30:00',2.21),('8537','2013-09-26','13:35:00',2.34),('8537','2013-09-26','13:40:00',2.01),('8537','2013-09-26','13:45:00',1.65),('8537','2013-09-26','13:50:00',1.95),('8537','2013-09-26','13:55:00',2.58),('8537','2013-09-26','14:00:00',2.95),('8537','2013-09-26','14:05:00',3.69),('8537','2013-09-26','14:10:00',4.26),('8537','2013-09-26','14:15:00',3.94),('8537','2013-09-26','14:20:00',3.37),('8537','2013-09-26','14:25:00',1.08),('8537','2013-09-26','14:30:00',1.22),('8537','2013-09-26','14:35:00',3.14),('8537','2013-09-26','14:40:00',2.04),('8537','2013-09-26','14:45:00',3.93),('8537','2013-09-26','14:50:00',4.55),('8537','2013-09-26','14:55:00',2.92),('8537','2013-09-26','15:00:00',1.6),('8537','2013-09-26','15:05:00',2.52),('8537','2013-09-26','15:10:00',1.71),('8537','2013-09-26','15:15:00',1.61),('8537','2013-09-26','15:20:00',2.15),('8537','2013-09-26','15:25:00',3.1),('8537','2013-09-26','15:35:00',2.33),('8537','2013-09-26','15:40:00',1.57),('8537','2013-09-26','15:45:00',1.93),('8537','2013-09-26','15:50:00',2.85),('8537','2013-09-26','15:55:00',3.04),('8537','2013-09-26','16:00:00',2.87),('8537','2013-09-26','16:05:00',2.74),('8537','2013-09-26','16:10:00',2.7),('8537','2013-09-26','16:15:00',2.48),('8537','2013-09-26','16:20:00',2.28),('8537','2013-09-26','16:25:00',2.15),('8537','2013-09-26','16:30:00',2.2),('8537','2013-09-26','16:35:00',2.09),('8537','2013-09-26','16:40:00',2.02),('8537','2013-09-26','16:45:00',1.91),('8537','2013-09-26','16:50:00',1.8),('8537','2013-09-26','16:55:00',1.7),('8537','2013-09-26','17:00:00',1.56),('8537','2013-09-26','17:05:00',1.52),('8537','2013-09-26','17:10:00',1.45),('8537','2013-09-26','17:15:00',1.32),('8537','2013-09-26','17:20:00',1.24),('8537','2013-09-26','17:25:00',1.05),('8537','2013-09-25','08:25:00',1.15),('8537','2013-09-25','08:30:00',1.26),('8537','2013-09-25','08:45:00',1.74),('8537','2013-09-25','08:50:00',1.51),('8537','2013-09-25','09:05:00',1.16),('8537','2013-09-25','09:10:00',1.69),('8537','2013-09-25','09:15:00',1.56),('8537','2013-09-25','09:20:00',1.12),('8537','2013-09-25','09:25:00',1.72),('8537','2013-09-25','09:30:00',1.95),('8537','2013-09-25','09:35:00',2.72),('8537','2013-09-25','09:40:00',2.56),('8537','2013-09-25','09:50:00',2.61),('8537','2013-09-25','09:55:00',1.44),('8537','2013-09-25','10:00:00',2.23),('8537','2013-09-25','10:05:00',1.41),('8537','2013-09-25','10:10:00',1.09),('8537','2013-09-25','10:20:00',1.47),('8537','2013-09-25','10:25:00',1.41),('8537','2013-09-25','10:30:00',1.86),('8537','2013-09-25','10:40:00',1.69),('8537','2013-09-25','10:45:00',2.54),('8537','2013-09-25','10:50:00',4.46),('8537','2013-09-25','10:55:00',4.42),('8537','2013-09-25','11:00:00',4.09),('8537','2013-09-25','11:05:00',1.66),('8537','2013-09-25','11:10:00',3.4),('8537','2013-09-25','11:15:00',1.71),('8537','2013-09-25','11:20:00',1.25),('8537','2013-09-25','11:25:00',4.33),('8537','2013-09-25','11:30:00',4.35),('8537','2013-09-25','11:35:00',4.16),('8537','2013-09-25','11:40:00',3.39),('8537','2013-09-25','11:45:00',4.46),('8537','2013-09-25','11:50:00',2.88),('8537','2013-09-25','11:55:00',2.02),('8537','2013-09-25','12:00:00',1.21),('8537','2013-09-25','12:10:00',1.25),('8537','2013-09-25','12:15:00',3.22),('8537','2013-09-25','12:20:00',4.35),('8537','2013-09-25','12:25:00',1.44),('8537','2013-09-25','12:30:00',3.06),('8537','2013-09-25','12:35:00',3.76),('8537','2013-09-25','12:40:00',4.29),('8537','2013-09-25','12:45:00',1.28),('8537','2013-09-25','12:50:00',1.21),('8537','2013-09-25','13:00:00',1.52),('8537','2013-09-25','13:05:00',1.18),('8537','2013-09-25','13:10:00',1.11),('8537','2013-09-25','13:15:00',1.11),('8537','2013-09-25','13:20:00',1.25),('8537','2013-09-25','13:25:00',1.31),('8537','2013-09-25','13:30:00',1.51),('8537','2013-09-25','13:35:00',5.03),('8537','2013-09-25','13:40:00',5.05),('8537','2013-09-25','13:45:00',5.07),('8537','2013-09-25','13:50:00',4.99),('8537','2013-09-25','13:55:00',4.02),('8537','2013-09-25','14:00:00',1.18),('8537','2013-09-25','14:05:00',1.12),('8537','2013-09-25','14:10:00',1.28),('8537','2013-09-25','14:15:00',1.14),('8537','2013-09-25','14:20:00',1.11),('8537','2013-09-25','14:25:00',1.32),('8537','2013-09-25','14:30:00',3.19),('8537','2013-09-25','14:35:00',4.07),('8537','2013-09-25','14:40:00',3.82),('8537','2013-09-25','14:45:00',3.05),('8537','2013-09-25','14:50:00',2.74),('8537','2013-09-25','14:55:00',2.92),('8537','2013-09-25','15:00:00',3.59),('8537','2013-09-25','15:05:00',3.97),('8537','2013-09-25','15:10:00',3.74),('8537','2013-09-25','15:15:00',3.71),('8537','2013-09-25','15:20:00',3.72),('8537','2013-09-25','15:25:00',3.3),('8537','2013-09-25','15:30:00',3.61),('8537','2013-09-25','15:35:00',3.16),('8537','2013-09-25','15:40:00',3.65),('8537','2013-09-25','15:45:00',3.19),('8537','2013-09-25','15:50:00',3.25),('8537','2013-09-25','15:55:00',3.14),('8537','2013-09-25','16:00:00',3.04),('8537','2013-09-25','16:05:00',2.95),('8537','2013-09-25','16:10:00',2.84),('8537','2013-09-25','16:15:00',2.75),('8537','2013-09-25','16:20:00',2.62),('8537','2013-09-25','16:25:00',1.16),('8537','2013-09-25','16:30:00',2.46),('8537','2013-09-25','16:35:00',2.27),('8537','2013-09-25','16:40:00',2.18),('8537','2013-09-25','16:45:00',2.08),('8537','2013-09-25','16:50:00',1.97),('8537','2013-09-25','16:55:00',1.83),('8537','2013-09-25','17:00:00',1.71),('8537','2013-09-25','17:05:00',1.62),('8537','2013-09-25','17:10:00',1.52),('8537','2013-09-25','17:15:00',1.41),('8537','2013-09-25','17:20:00',1.29),('8537','2013-09-25','17:25:00',1.17),('8537','2013-09-25','17:30:00',1.09),('8537','2013-09-24','08:10:00',1.03),('8537','2013-09-24','08:15:00',1.14),('8537','2013-09-24','08:20:00',1.27),('8537','2013-09-24','08:25:00',1.38),('8537','2013-09-24','08:30:00',1.49),('8537','2013-09-24','08:35:00',1.61),('8537','2013-09-24','08:40:00',1.73),('8537','2013-09-24','08:45:00',1.84),('8537','2013-09-24','08:50:00',1.93),('8537','2013-09-24','08:55:00',2.05),('8537','2013-09-24','09:00:00',2.15),('8537','2013-09-24','09:05:00',2.26),('8537','2013-09-24','09:10:00',2.37),('8537','2013-09-24','09:15:00',2.46),('8537','2013-09-24','09:20:00',2.56),('8537','2013-09-24','09:25:00',2.67),('8537','2013-09-24','09:30:00',2.78),('8537','2013-09-24','09:35:00',2.87),('8537','2013-09-24','09:40:00',2.96),('8537','2013-09-24','09:45:00',3.02),('8537','2013-09-24','09:50:00',3.09),('8537','2013-09-24','09:55:00',3.19),('8537','2013-09-24','10:00:00',3.24),('8537','2013-09-24','10:05:00',3.33),('8537','2013-09-24','10:10:00',3.43),('8537','2013-09-24','10:15:00',3.5),('8537','2013-09-24','10:20:00',3.58),('8537','2013-09-24','10:25:00',3.67),('8537','2013-09-24','10:30:00',3.73),('8537','2013-09-24','10:35:00',3.77),('8537','2013-09-24','10:40:00',3.85),('8537','2013-09-24','10:45:00',3.89),('8537','2013-09-24','10:50:00',3.95),('8537','2013-09-24','10:55:00',4.03),('8537','2013-09-24','11:00:00',4.06),('8537','2013-09-24','11:05:00',4.07),('8537','2013-09-24','11:10:00',4.1),('8537','2013-09-24','11:15:00',4.12),('8537','2013-09-24','11:20:00',4.15),('8537','2013-09-24','11:25:00',4.23),('8537','2013-09-24','11:30:00',4.25),('8537','2013-09-24','11:35:00',4.28),('8537','2013-09-24','11:40:00',4.32),('8537','2013-09-24','11:45:00',4.34),('8537','2013-09-24','11:50:00',4.34),('8537','2013-09-24','11:55:00',4.33),('8537','2013-09-24','12:00:00',4.38),('8537','2013-09-24','12:05:00',4.38),('8537','2013-09-24','12:10:00',4.4),('8537','2013-09-24','12:15:00',4.42),('8537','2013-09-24','12:20:00',4.44),('8537','2013-09-24','12:25:00',4.45),('8537','2013-09-24','12:30:00',4.47),('8537','2013-09-24','12:35:00',4.48),('8537','2013-09-24','12:40:00',4.51),('8537','2013-09-24','12:45:00',4.53),('8537','2013-09-24','12:50:00',4.51),('8537','2013-09-24','12:55:00',4.52),('8537','2013-09-24','13:00:00',4.51),('8537','2013-09-24','13:05:00',4.52),('8537','2013-09-24','13:10:00',4.48),('8537','2013-09-24','13:15:00',4.55),('8537','2013-09-24','13:20:00',4.53),('8537','2013-09-24','13:25:00',4.5),('8537','2013-09-24','13:30:00',4.43),('8537','2013-09-24','13:35:00',4.45),('8537','2013-09-24','13:40:00',4.46),('8537','2013-09-24','13:45:00',4.45),('8537','2013-09-24','13:50:00',4.38),('8537','2013-09-24','13:55:00',4.38),('8537','2013-09-24','14:00:00',4.35),('8537','2013-09-24','14:05:00',4.34),('8537','2013-09-24','14:10:00',4.29),('8537','2013-09-24','14:15:00',4.25),('8537','2013-09-24','14:20:00',4.09),('8537','2013-09-24','14:25:00',4.08),('8537','2013-09-24','14:30:00',4.1),('8537','2013-09-24','14:35:00',4.06),('8537','2013-09-24','14:40:00',4.03),('8537','2013-09-24','14:45:00',3.98),('8537','2013-09-24','14:50:00',3.88),('8537','2013-09-24','14:55:00',3.82),('8537','2013-09-24','15:00:00',3.76),('8537','2013-09-24','15:05:00',3.68),('8537','2013-09-24','15:10:00',3.58),('8537','2013-09-24','15:15:00',3.59),('8537','2013-09-24','15:20:00',3.55),('8537','2013-09-24','15:25:00',3.52),('8537','2013-09-24','15:30:00',3.47),('8537','2013-09-24','15:35:00',3.39),('8537','2013-09-24','15:40:00',3.3),('8537','2013-09-24','15:45:00',3.22),('8537','2013-09-24','15:50:00',3.15),('8537','2013-09-24','15:55:00',3.07),('8537','2013-09-24','16:00:00',2.99),('8537','2013-09-24','16:05:00',2.91),('8537','2013-09-24','16:10:00',2.79),('8537','2013-09-24','16:15:00',2.63),('8537','2013-09-24','16:20:00',2.28),('8537','2013-09-24','16:25:00',2.46),('8537','2013-09-24','16:30:00',2.44),('8537','2013-09-24','16:35:00',2.24),('8537','2013-09-24','16:40:00',2.14),('8537','2013-09-24','16:45:00',2.07),('8537','2013-09-24','16:50:00',2.01),('8537','2013-09-24','16:55:00',1.89),('8537','2013-09-24','17:00:00',1.78),('8537','2013-09-24','17:05:00',1.63),('8537','2013-09-24','17:10:00',1.56),('8537','2013-09-24','17:15:00',1.45),('8537','2013-09-24','17:20:00',1.34),('8537','2013-09-24','17:25:00',1.21),('8537','2013-09-24','17:30:00',1.09),('8537','2013-09-23','08:10:00',1.08),('8537','2013-09-23','08:15:00',1.19),('8537','2013-09-23','08:20:00',1.31),('8537','2013-09-23','08:25:00',1.44),('8537','2013-09-23','08:30:00',1.55),('8537','2013-09-23','08:35:00',1.67),('8537','2013-09-23','08:40:00',1.79),('8537','2013-09-23','08:45:00',1.91),('8537','2013-09-23','08:50:00',2.02),('8537','2013-09-23','08:55:00',2.13),('8537','2013-09-23','09:00:00',2.22),('8537','2013-09-23','09:05:00',2.34),('8537','2013-09-23','09:10:00',2.45),('8537','2013-09-23','09:15:00',2.55),('8537','2013-09-23','09:20:00',2.65),('8537','2013-09-23','09:25:00',2.74),('8537','2013-09-23','09:30:00',2.84),('8537','2013-09-23','09:35:00',2.92),('8537','2013-09-23','09:40:00',3.02),('8537','2013-09-23','09:45:00',3.1),('8537','2013-09-23','09:50:00',3.19),('8537','2013-09-23','09:55:00',3.27),('8537','2013-09-23','10:00:00',3.36),('8537','2013-09-23','10:05:00',3.45),('8537','2013-09-23','10:10:00',3.52),('8537','2013-09-23','10:15:00',3.58),('8537','2013-09-23','10:20:00',3.65),('8537','2013-09-23','10:25:00',3.71),('8537','2013-09-23','10:30:00',3.78),('8537','2013-09-23','10:35:00',3.85),('8537','2013-09-23','10:40:00',3.91),('8537','2013-09-23','10:45:00',3.96),('8537','2013-09-23','10:50:00',3.98),('8537','2013-09-23','10:55:00',4.08),('8537','2013-09-23','11:00:00',4.12),('8537','2013-09-23','11:05:00',4.2),('8537','2013-09-23','11:10:00',4.26),('8537','2013-09-23','11:15:00',4.33),('8537','2013-09-23','11:20:00',4.36),('8537','2013-09-23','11:25:00',4.39),('8537','2013-09-23','11:30:00',4.45),('8537','2013-09-23','11:35:00',4.48),('8537','2013-09-23','11:40:00',4.5),('8537','2013-09-23','11:45:00',4.52),('8537','2013-09-23','11:50:00',4.58),('8537','2013-09-23','11:55:00',4.6),('8537','2013-09-23','12:00:00',4.64),('8537','2013-09-23','12:05:00',4.69),('8537','2013-09-23','12:10:00',4.72),('8537','2013-09-23','12:15:00',4.73),('8537','2013-09-23','12:20:00',4.75),('8537','2013-09-23','12:25:00',4.73),('8537','2013-09-23','12:30:00',4.69),('8537','2013-09-23','12:35:00',4.65),('8537','2013-09-23','12:40:00',4.64),('8537','2013-09-23','12:45:00',4.68),('8537','2013-09-23','12:50:00',4.66),('8537','2013-09-23','12:55:00',4.69),('8537','2013-09-23','13:00:00',4.71),('8537','2013-09-23','13:05:00',4.65),('8537','2013-09-23','13:10:00',4.64),('8537','2013-09-23','13:15:00',4.62),('8537','2013-09-23','13:20:00',4.57),('8537','2013-09-23','13:25:00',4.6),('8537','2013-09-23','13:30:00',4.59),('8537','2013-09-23','13:35:00',4.58),('8537','2013-09-23','13:40:00',4.57),('8537','2013-09-23','13:45:00',4.57),('8537','2013-09-23','13:50:00',4.55),('8537','2013-09-23','13:55:00',4.46),('8537','2013-09-23','14:00:00',4.41),('8537','2013-09-23','14:05:00',4.33),('8537','2013-09-23','14:10:00',4.36),('8537','2013-09-23','14:15:00',4.39),('8537','2013-09-23','14:20:00',4.15),('8537','2013-09-23','14:25:00',4.16),('8537','2013-09-23','14:30:00',4.28),('8537','2013-09-23','14:35:00',4.19),('8537','2013-09-23','14:40:00',4.13),('8537','2013-09-23','14:45:00',4.08),('8537','2013-09-23','14:50:00',3.49),('8537','2013-09-23','14:55:00',4.01),('8537','2013-09-23','15:00:00',3.94),('8537','2013-09-23','15:05:00',3.75),('8537','2013-09-23','15:10:00',2.61),('8537','2013-09-23','15:15:00',3.75),('8537','2013-09-23','15:20:00',3.6),('8537','2013-09-23','15:25:00',3.52),('8537','2013-09-23','15:30:00',3.47),('8537','2013-09-23','15:35:00',3.41),('8537','2013-09-23','15:40:00',3.36),('8537','2013-09-23','15:45:00',3.2),('8537','2013-09-23','15:50:00',3.15),('8537','2013-09-23','15:55:00',3.05),('8537','2013-09-23','16:00:00',2.89),('8537','2013-09-23','16:05:00',2.9),('8537','2013-09-23','16:10:00',1.86),('8537','2013-09-23','16:15:00',2.72),('8537','2013-09-23','16:20:00',1.82),('8537','2013-09-23','16:25:00',2.33),('8537','2013-09-23','16:30:00',1.56),('8537','2013-09-23','16:35:00',2.14),('8537','2013-09-23','16:40:00',2.12),('8537','2013-09-23','16:45:00',2.05),('8537','2013-09-23','16:50:00',1.92),('8537','2013-09-23','16:55:00',1.8),('8537','2013-09-23','17:00:00',1.73),('8537','2013-09-23','17:05:00',1.59),('8537','2013-09-23','17:10:00',1.52),('8537','2013-09-23','17:15:00',1.42),('8537','2013-09-23','17:20:00',1.32),('8537','2013-09-23','17:25:00',1.19),('8537','2013-09-23','17:30:00',1.11),('8537','2013-09-23','17:35:00',1.02),('8537','2013-09-22','08:05:00',1.02),('8537','2013-09-22','08:10:00',1.16),('8537','2013-09-22','08:20:00',1.09),('8537','2013-09-22','08:25:00',1.44),('8537','2013-09-22','08:30:00',1.53),('8537','2013-09-22','08:35:00',1.63),('8537','2013-09-22','08:40:00',1.73),('8537','2013-09-22','08:45:00',1.85),('8537','2013-09-22','08:50:00',1.96),('8537','2013-09-22','08:55:00',2.09),('8537','2013-09-22','09:00:00',2.19),('8537','2013-09-22','09:05:00',2.3),('8537','2013-09-22','09:10:00',2.42),('8537','2013-09-22','09:15:00',2.54),('8537','2013-09-22','09:20:00',2.63),('8537','2013-09-22','09:25:00',2.73),('8537','2013-09-22','09:30:00',2.84),('8537','2013-09-22','09:35:00',2.93),('8537','2013-09-22','09:40:00',2.99),('8537','2013-09-22','09:45:00',3.09),('8537','2013-09-22','09:50:00',3.17),('8537','2013-09-22','09:55:00',3.27),('8537','2013-09-22','10:00:00',3.37),('8537','2013-09-22','10:05:00',3.48),('8537','2013-09-22','10:10:00',3.55),('8537','2013-09-22','10:15:00',3.62),('8537','2013-09-22','10:20:00',3.71),('8537','2013-09-22','10:25:00',3.77),('8537','2013-09-22','10:30:00',3.85),('8537','2013-09-22','10:35:00',3.93),('8537','2013-09-22','10:40:00',3.91),('8537','2013-09-22','10:45:00',4.02),('8537','2013-09-22','10:50:00',4.09),('8537','2013-09-22','10:55:00',4.13),('8537','2013-09-22','11:00:00',4.17),('8537','2013-09-22','11:05:00',4.21),('8537','2013-09-22','11:10:00',4.26),('8537','2013-09-22','11:15:00',4.31),('8537','2013-09-22','11:20:00',4.34),('8537','2013-09-22','11:25:00',4.37),('8537','2013-09-22','11:30:00',4.42),('8537','2013-09-22','11:35:00',4.5),('8537','2013-09-22','11:40:00',4.56),('8537','2013-09-22','11:45:00',4.61),('8537','2013-09-22','11:50:00',4.62),('8537','2013-09-22','11:55:00',4.66),('8537','2013-09-22','12:00:00',4.71),('8537','2013-09-22','12:05:00',4.73),('8537','2013-09-22','12:10:00',4.77),('8537','2013-09-22','12:15:00',4.78),('8537','2013-09-22','12:20:00',4.79),('8537','2013-09-22','12:25:00',4.8),('8537','2013-09-22','12:30:00',4.8),('8537','2013-09-22','12:35:00',4.8),('8537','2013-09-22','12:40:00',4.85),('8537','2013-09-22','12:45:00',4.82),('8537','2013-09-22','12:50:00',4.86),('8537','2013-09-22','12:55:00',4.91),('8537','2013-09-22','13:00:00',4.86),('8537','2013-09-22','13:05:00',4.83),('8537','2013-09-22','13:10:00',4.18),('8537','2013-09-22','13:15:00',4.88),('8537','2013-09-22','13:20:00',4.79),('8537','2013-09-22','13:25:00',4.77),('8537','2013-09-22','13:30:00',4.72),('8537','2013-09-22','13:35:00',4.71),('8537','2013-09-22','13:40:00',4.68),('8537','2013-09-22','13:45:00',4.69),('8537','2013-09-22','13:50:00',4.7),('8537','2013-09-22','13:55:00',4.1),('8537','2013-09-22','14:00:00',4.59),('8537','2013-09-22','14:05:00',4.62),('8537','2013-09-22','14:10:00',4.65),('8537','2013-09-22','14:15:00',4.42),('8537','2013-09-22','14:20:00',2.73),('8537','2013-09-22','14:25:00',4.57),('8537','2013-09-22','14:30:00',3.19),('8537','2013-09-22','14:35:00',4.43),('8537','2013-09-22','14:40:00',3.32),('8537','2013-09-22','14:45:00',3.72),('8537','2013-09-22','14:50:00',4.24),('8537','2013-09-22','14:55:00',4.18),('8537','2013-09-22','15:00:00',4.2),('8537','2013-09-22','15:05:00',4.21),('8537','2013-09-22','15:10:00',4.01),('8537','2013-09-22','15:15:00',4.23),('8537','2013-09-22','15:20:00',4.41),('8537','2013-09-22','15:25:00',2.2),('8537','2013-09-22','15:30:00',1.2),('8537','2013-09-22','15:35:00',1.2),('8537','2013-09-22','15:40:00',3.05),('8537','2013-09-22','15:45:00',3.56),('8537','2013-09-22','15:50:00',3.38),('8537','2013-09-22','15:55:00',3.34),('8537','2013-09-22','16:00:00',3.56),('8537','2013-09-22','16:05:00',3.36),('8537','2013-09-22','16:10:00',3.73),('8537','2013-09-22','16:15:00',3.49),('8537','2013-09-22','16:20:00',2.35),('8537','2013-09-22','16:25:00',1.78),('8537','2013-09-22','16:30:00',1.4),('8537','2013-09-22','16:35:00',1.14),('8537','2013-09-22','16:40:00',1.22),('8537','2013-09-22','16:45:00',2.05),('8537','2013-09-22','16:50:00',1.93),('8537','2013-09-22','16:55:00',1.51),('8537','2013-09-22','17:00:00',1.11),('8537','2013-09-22','17:05:00',1.54),('8537','2013-09-22','17:10:00',1.27),('8537','2013-09-22','17:15:00',1.07),('8537','2013-09-21','08:10:00',1.04),('8537','2013-09-21','08:15:00',1.16),('8537','2013-09-21','08:20:00',1.27),('8537','2013-09-21','08:25:00',1.38),('8537','2013-09-21','08:30:00',1.5),('8537','2013-09-21','08:35:00',1.61),('8537','2013-09-21','08:40:00',1.73),('8537','2013-09-21','08:45:00',1.83),('8537','2013-09-21','08:50:00',1.96),('8537','2013-09-21','08:55:00',2.07),('8537','2013-09-21','09:00:00',2.18),('8537','2013-09-21','09:05:00',2.27),('8537','2013-09-21','09:10:00',2.36),('8537','2013-09-21','09:15:00',2.46),('8537','2013-09-21','09:20:00',2.56),('8537','2013-09-21','09:25:00',2.66),('8537','2013-09-21','09:30:00',2.74),('8537','2013-09-21','09:35:00',2.84),('8537','2013-09-21','09:40:00',2.91),('8537','2013-09-21','09:45:00',3.02),('8537','2013-09-21','09:50:00',3.11),('8537','2013-09-21','09:55:00',3.18),('8537','2013-09-21','10:00:00',3.28),('8537','2013-09-21','10:05:00',3.38),('8537','2013-09-21','10:10:00',3.43),('8537','2013-09-21','10:15:00',3.49),('8537','2013-09-21','10:20:00',3.54),('8537','2013-09-21','10:25:00',3.65),('8537','2013-09-21','10:30:00',3.72),('8537','2013-09-21','10:35:00',3.77),('8537','2013-09-21','10:40:00',3.84),('8537','2013-09-21','10:45:00',3.91),('8537','2013-09-21','10:50:00',3.96),('8537','2013-09-21','10:55:00',4.02),('8537','2013-09-21','11:00:00',4.08),('8537','2013-09-21','11:05:00',4.12),('8537','2013-09-21','11:10:00',4.15),('8537','2013-09-21','11:15:00',4.21),('8537','2013-09-21','11:20:00',4.26),('8537','2013-09-21','11:25:00',4.32),('8537','2013-09-21','11:30:00',4.4),('8537','2013-09-21','11:35:00',4.35),('8537','2013-09-21','11:40:00',4.44),('8537','2013-09-21','11:45:00',4.49),('8537','2013-09-21','11:50:00',4.5),('8537','2013-09-21','11:55:00',4.44),('8537','2013-09-21','12:00:00',4.53),('8537','2013-09-21','12:05:00',4.59),('8537','2013-09-21','12:10:00',4.59),('8537','2013-09-21','12:15:00',4.59),('8537','2013-09-21','12:20:00',4.55),('8537','2013-09-21','12:25:00',4.16),('8537','2013-09-21','12:30:00',4.71),('8537','2013-09-21','12:35:00',4.61),('8537','2013-09-21','12:40:00',4.33),('8537','2013-09-21','12:45:00',4.56),('8537','2013-09-21','12:50:00',4.65),('8537','2013-09-21','12:55:00',4.71),('8537','2013-09-21','13:00:00',4.67),('8537','2013-09-21','13:05:00',4.54),('8537','2013-09-21','13:10:00',4.67),('8537','2013-09-21','13:15:00',4.77),('8537','2013-09-21','13:20:00',3.9),('8537','2013-09-21','13:25:00',4.48),('8537','2013-09-21','13:30:00',4.44),('8537','2013-09-21','13:35:00',4.53),('8537','2013-09-21','13:40:00',3.99),('8537','2013-09-21','13:45:00',3.96),('8537','2013-09-21','13:50:00',4.16),('8537','2013-09-21','13:55:00',4.14),('8537','2013-09-21','14:00:00',4.22),('8537','2013-09-21','14:05:00',4.43),('8537','2013-09-21','14:10:00',4.24),('8537','2013-09-21','14:15:00',4.43),('8537','2013-09-21','14:20:00',4.31),('8537','2013-09-21','14:25:00',4.3),('8537','2013-09-21','14:30:00',4.24),('8537','2013-09-21','14:35:00',4.18),('8537','2013-09-21','14:40:00',4.13),('8537','2013-09-21','14:45:00',4.06),('8537','2013-09-21','14:50:00',4.02),('8537','2013-09-21','14:55:00',3.99),('8537','2013-09-21','15:00:00',3.92),('8537','2013-09-21','15:05:00',3.81),('8537','2013-09-21','15:10:00',3.69),('8537','2013-09-21','15:15:00',3.64),('8537','2013-09-21','15:20:00',3.64),('8537','2013-09-21','15:25:00',3.56),('8537','2013-09-21','15:30:00',3.51),('8537','2013-09-21','15:35:00',3.45),('8537','2013-09-21','15:40:00',3.13),('8537','2013-09-21','15:45:00',2.35),('8537','2013-09-21','15:50:00',3.05),('8537','2013-09-21','15:55:00',3.12),('8537','2013-09-21','16:00:00',2.41),('8537','2013-09-21','16:05:00',1.57),('8537','2013-09-21','16:10:00',1.91),('8537','2013-09-21','16:15:00',1.6),('8537','2013-09-21','16:20:00',1.85),('8537','2013-09-21','16:30:00',1.33),('8537','2013-09-21','16:35:00',1.61),('8537','2013-09-21','16:40:00',1.14),('8537','2013-09-21','16:55:00',1.14),('8537','2013-09-21','17:15:00',1.18),('8537','2013-09-20','08:35:00',1.74),('8537','2013-09-20','08:40:00',1.9),('8537','2013-09-20','08:45:00',1.72),('8537','2013-09-20','08:50:00',1.21),('8537','2013-09-20','08:55:00',1.2),('8537','2013-09-20','09:00:00',1.33),('8537','2013-09-20','09:05:00',1.43),('8537','2013-09-20','09:10:00',1.32),('8537','2013-09-20','09:15:00',1.67),('8537','2013-09-20','09:20:00',1.78),('8537','2013-09-20','09:25:00',1.71),('8537','2013-09-20','09:30:00',1.48),('8537','2013-09-20','09:35:00',1.53),('8537','2013-09-20','09:40:00',1.51),('8537','2013-09-20','09:45:00',1.5),('8537','2013-09-20','09:50:00',1.56),('8537','2013-09-20','09:55:00',1.73),('8537','2013-09-20','10:00:00',1.92),('8537','2013-09-20','10:05:00',3.26),('8537','2013-09-20','10:10:00',2.66),('8537','2013-09-20','10:15:00',3.38),('8537','2013-09-20','10:20:00',4),('8537','2013-09-20','10:25:00',3.19),('8537','2013-09-20','10:30:00',2.8),('8537','2013-09-20','10:35:00',2.98),('8537','2013-09-20','10:40:00',4.51),('8537','2013-09-20','10:45:00',3.64),('8537','2013-09-20','10:50:00',3.91),('8537','2013-09-20','10:55:00',3.28),('8537','2013-09-20','11:00:00',2.33),('8537','2013-09-20','11:05:00',2.29),('8537','2013-09-20','11:10:00',2.46),('8537','2013-09-20','11:15:00',3.35),('8537','2013-09-20','11:20:00',2.78),('8537','2013-09-20','11:25:00',3.19),('8537','2013-09-20','11:30:00',2.67),('8537','2013-09-20','11:35:00',3.78),('8537','2013-09-20','11:40:00',3.14),('8537','2013-09-20','11:45:00',4.8),('8537','2013-09-20','11:50:00',4.82),('8537','2013-09-20','11:55:00',4.67),('8537','2013-09-20','12:00:00',4.57),('8537','2013-09-20','12:05:00',4.61),('8537','2013-09-20','12:10:00',4.67),('8537','2013-09-20','12:15:00',4.78),('8537','2013-09-20','12:20:00',4.87),('8537','2013-09-20','12:25:00',4.56),('8537','2013-09-20','12:30:00',4.38),('8537','2013-09-20','12:35:00',3.87),('8537','2013-09-20','12:40:00',4.34),('8537','2013-09-20','12:45:00',2.83),('8537','2013-09-20','12:50:00',3.92),('8537','2013-09-20','12:55:00',4.89),('8537','2013-09-20','13:00:00',4.09),('8537','2013-09-20','13:05:00',4.67),('8537','2013-09-20','13:10:00',4.73),('8537','2013-09-20','13:15:00',2.78),('8537','2013-09-20','13:20:00',3.79),('8537','2013-09-20','13:25:00',5.01),('8537','2013-09-20','13:30:00',4.83),('8537','2013-09-20','13:35:00',2.95),('8537','2013-09-20','13:40:00',4.42),('8537','2013-09-20','13:45:00',4.69),('8537','2013-09-20','13:50:00',4.49),('8537','2013-09-20','13:55:00',4.09),('8537','2013-09-20','14:00:00',4.57),('8537','2013-09-20','14:05:00',4.67),('8537','2013-09-20','14:10:00',1.38),('8537','2013-09-20','14:15:00',2.79),('8537','2013-09-20','14:20:00',1.65),('8537','2013-09-20','14:25:00',3.18),('8537','2013-09-20','14:30:00',4.72),('8537','2013-09-20','14:35:00',4.55),('8537','2013-09-20','14:40:00',4.35),('8537','2013-09-20','14:45:00',4.45),('8537','2013-09-20','14:50:00',4.43),('8537','2013-09-20','14:55:00',4.34),('8537','2013-09-20','15:00:00',3.27),('8537','2013-09-20','15:05:00',2.31),('8537','2013-09-20','15:10:00',3.78),('8537','2013-09-20','15:15:00',3.02),('8537','2013-09-20','15:20:00',3.1),('8537','2013-09-20','15:25:00',2.84),('8537','2013-09-20','15:30:00',2.44),('8537','2013-09-20','15:35:00',3.24),('8537','2013-09-20','15:40:00',2.49),('8537','2013-09-20','15:45:00',3.51),('8537','2013-09-20','15:50:00',3.41),('8537','2013-09-20','15:55:00',3.48),('8537','2013-09-20','16:00:00',2.24),('8537','2013-09-20','16:05:00',1.83),('8537','2013-09-20','16:10:00',1.97),('8537','2013-09-20','16:15:00',2.44),('8537','2013-09-20','16:20:00',1.4),('8537','2013-09-20','16:25:00',1.32),('8537','2013-09-20','16:35:00',1.01),('8537','2013-09-20','16:40:00',1.13),('8537','2013-09-20','16:45:00',1.54),('8537','2013-09-20','16:50:00',2.05),('8537','2013-09-20','16:55:00',2.35),('8537','2013-09-20','17:00:00',2.02),('8537','2013-09-20','17:05:00',2.37),('8537','2013-09-20','17:10:00',2.31),('8537','2013-09-20','17:15:00',2.17),('8537','2013-09-20','17:20:00',2.08),('8537','2013-09-20','17:25:00',1.72),('8537','2013-09-20','17:30:00',1.47),('8537','2013-09-20','17:35:00',1.26),('8537','2013-09-20','17:40:00',1.04),('8537','2013-09-20','17:45:00',1.02),('8537','2013-09-19','08:15:00',1.01),('8537','2013-09-19','08:20:00',1.28),('8537','2013-09-19','08:25:00',1.24),('8537','2013-09-19','08:30:00',1.54),('8537','2013-09-19','08:35:00',1.69),('8537','2013-09-19','08:40:00',1.38),('8537','2013-09-19','08:45:00',1.56),('8537','2013-09-19','08:50:00',1.37),('8537','2013-09-19','08:55:00',1.56),('8537','2013-09-19','09:00:00',1.68),('8537','2013-09-19','09:05:00',1.11),('8537','2013-09-19','09:10:00',1.82),('8537','2013-09-19','09:15:00',2.01),('8537','2013-09-19','09:20:00',1.55),('8537','2013-09-19','09:25:00',1.24),('8537','2013-09-19','09:35:00',1.06),('8537','2013-09-19','09:40:00',1.11),('8537','2013-09-19','10:05:00',2.48),('8537','2013-09-19','10:10:00',2.78),('8537','2013-09-19','10:15:00',2.61),('8537','2013-09-19','10:20:00',1.08),('8537','2013-09-19','10:25:00',1.35),('8537','2013-09-19','10:30:00',1.15),('8537','2013-09-19','10:35:00',4.1),('8537','2013-09-19','10:40:00',3.51),('8537','2013-09-19','10:45:00',3.44),('8537','2013-09-19','10:50:00',1.84),('8537','2013-09-19','10:55:00',3.11),('8537','2013-09-19','11:00:00',4.98),('8537','2013-09-19','11:05:00',4.26),('8537','2013-09-19','11:10:00',2.63),('8537','2013-09-19','11:15:00',2.01),('8537','2013-09-19','11:20:00',3.07),('8537','2013-09-19','11:25:00',2.33),('8537','2013-09-19','11:30:00',4.25),('8537','2013-09-19','11:35:00',3.57),('8537','2013-09-19','11:40:00',3.47),('8537','2013-09-19','11:45:00',4.3),('8537','2013-09-19','11:50:00',4.28),('8537','2013-09-19','11:55:00',4.3),('8537','2013-09-19','12:00:00',2.71),('8537','2013-09-19','12:05:00',2.09),('8537','2013-09-19','12:10:00',4.13),('8537','2013-09-19','12:15:00',3.84),('8537','2013-09-19','12:20:00',4.4),('8537','2013-09-19','12:25:00',5.06),('8537','2013-09-19','12:30:00',5.1),('8537','2013-09-19','12:35:00',4.77),('8537','2013-09-19','12:40:00',4.88),('8537','2013-09-19','12:45:00',3.53),('8537','2013-09-19','12:50:00',5.09),('8537','2013-09-19','12:55:00',4.97),('8537','2013-09-19','13:00:00',4.96),('8537','2013-09-19','13:05:00',4.96),('8537','2013-09-19','13:10:00',5.22),('8537','2013-09-19','13:15:00',5.21),('8537','2013-09-19','13:20:00',4.78),('8537','2013-09-19','13:25:00',3.11),('8537','2013-09-19','13:30:00',5),('8537','2013-09-19','13:35:00',4.95),('8537','2013-09-19','13:40:00',5.19),('8537','2013-09-19','13:45:00',5.09),('8537','2013-09-19','13:50:00',4.38),('8537','2013-09-19','13:55:00',2.02),('8537','2013-09-19','14:00:00',1.12),('8537','2013-09-19','14:05:00',3.94),('8537','2013-09-19','14:10:00',4.85),('8537','2013-09-19','14:15:00',4.64),('8537','2013-09-19','14:20:00',4.42),('8537','2013-09-19','14:25:00',4.33),('8537','2013-09-19','14:30:00',4.36),('8537','2013-09-19','14:35:00',4.29),('8537','2013-09-19','14:40:00',4.23),('8537','2013-09-19','14:45:00',4.16),('8537','2013-09-19','14:50:00',4.15),('8537','2013-09-19','14:55:00',4.15),('8537','2013-09-19','15:00:00',4.13),('8537','2013-09-19','15:05:00',3.77),('8537','2013-09-19','15:10:00',2.86),('8537','2013-09-19','15:15:00',3.64),('8537','2013-09-19','15:20:00',3.75),('8537','2013-09-19','15:25:00',3.35),('8537','2013-09-19','15:30:00',3.23),('8537','2013-09-19','15:35:00',2.23),('8537','2013-09-19','15:40:00',3.34),('8537','2013-09-19','15:45:00',3.58),('8537','2013-09-19','15:50:00',3.35),('8537','2013-09-19','15:55:00',3.04),('8537','2013-09-19','16:00:00',3.12),('8537','2013-09-19','16:05:00',3.07),('8537','2013-09-19','16:10:00',2.27),('8537','2013-09-19','16:15:00',2.81),('8537','2013-09-19','16:20:00',2.77),('8537','2013-09-19','16:25:00',2.74),('8537','2013-09-19','16:30:00',2.24),('8537','2013-09-19','16:35:00',2.03),('8537','2013-09-19','16:40:00',1.26),('8537','2013-09-19','16:45:00',1.16),('8537','2013-09-19','16:50:00',1.92),('8537','2013-09-19','16:55:00',2.2),('8537','2013-09-19','17:00:00',1.83),('8537','2013-09-19','17:05:00',1.75),('8537','2013-09-19','17:10:00',1.66),('8537','2013-09-19','17:15:00',1.57),('8537','2013-09-19','17:20:00',1.48),('8537','2013-09-19','17:25:00',1.26),('8537','2013-09-19','17:30:00',1.16),('8537','2013-09-19','17:35:00',1.01),('8537','2014-04-13','09:00:00',1.07),('8537','2014-04-13','09:05:00',1.41),('8537','2014-04-13','09:10:00',1.71),('8537','2014-04-13','09:15:00',1.51),('8537','2014-04-13','09:20:00',1.73),('8537','2014-04-13','09:25:00',2.35),('8537','2014-04-13','09:30:00',2.17),('8537','2014-04-13','09:35:00',1.72),('8537','2014-04-13','09:40:00',2.65),('8537','2014-04-13','09:45:00',2.25),('8537','2014-04-13','09:50:00',1.8),('8537','2014-04-13','09:55:00',1.86),('8537','2014-04-13','10:00:00',3.21),('8537','2014-04-13','10:05:00',4.48),('8537','2014-04-13','10:10:00',2.61),('8537','2014-04-13','10:15:00',2.97),('8537','2014-04-13','10:20:00',3.87),('8537','2014-04-13','10:25:00',2.19),('8537','2014-04-13','10:30:00',4.18),('8537','2014-04-13','10:35:00',4.21),('8537','2014-04-13','10:40:00',4.12),('8537','2014-04-13','10:45:00',4.38),('8537','2014-04-13','10:50:00',4.4),('8537','2014-04-13','10:55:00',4.4),('8537','2014-04-13','11:00:00',4.47),('8537','2014-04-13','11:05:00',4.51),('8537','2014-04-13','11:10:00',4.4),('8537','2014-04-13','11:15:00',3.68),('8537','2014-04-13','11:20:00',5.37),('8537','2014-04-13','11:25:00',3.81),('8537','2014-04-13','11:30:00',2.28),('8537','2014-04-13','11:35:00',3.08),('8537','2014-04-13','11:40:00',5.04),('8537','2014-04-13','11:45:00',4.61),('8537','2014-04-13','11:50:00',4.63),('8537','2014-04-13','11:55:00',3.53),('8537','2014-04-13','12:00:00',2.99),('8537','2014-04-13','12:05:00',2.02),('8537','2014-04-13','12:10:00',1.79),('8537','2014-04-13','12:15:00',1.65),('8537','2014-04-13','12:20:00',1.45),('8537','2014-04-13','12:25:00',1.07),('8537','2014-04-13','13:05:00',1.51),('8537','2014-04-13','13:10:00',2.31),('8537','2014-04-13','13:15:00',2.24),('8537','2014-04-13','13:20:00',2.79),('8537','2014-04-13','13:25:00',3.33),('8537','2014-04-13','13:30:00',4.94),('8537','2014-04-13','13:35:00',4.74),('8537','2014-04-13','13:40:00',4.74),('8537','2014-04-13','13:45:00',2.43),('8537','2014-04-13','13:50:00',3.57),('8537','2014-04-13','13:55:00',3.78),('8537','2014-04-13','14:00:00',4.77),('8537','2014-04-13','14:05:00',4.04),('8537','2014-04-13','14:10:00',4.46),('8537','2014-04-13','14:15:00',4.52),('8537','2014-04-13','14:20:00',2.17),('8537','2014-04-13','14:25:00',1.9),('8537','2014-04-13','14:30:00',1.9),('8537','2014-04-13','14:35:00',1.79),('8537','2014-04-13','14:40:00',1.49),('8537','2014-04-13','14:45:00',2.09),('8537','2014-04-13','14:50:00',3.98),('8537','2014-04-13','14:55:00',2.21),('8537','2014-04-13','15:00:00',3.69),('8537','2014-04-13','15:05:00',4.3),('8537','2014-04-13','15:10:00',4.44),('8537','2014-04-13','15:15:00',3.95),('8537','2014-04-13','15:20:00',3.88),('8537','2014-04-13','15:25:00',4.02),('8537','2014-04-13','15:30:00',3.88),('8537','2014-04-13','15:35:00',2.62),('8537','2014-04-13','15:40:00',1.5),('8537','2014-04-13','15:45:00',1.61),('8537','2014-04-13','15:50:00',2.15),('8537','2014-04-13','15:55:00',2.43),('8537','2014-04-13','16:00:00',4),('8537','2014-04-13','16:05:00',3.19),('8537','2014-04-13','16:10:00',1.62),('8537','2014-04-13','16:15:00',1.61),('8537','2014-04-13','16:20:00',1.67),('8537','2014-04-13','16:25:00',1.65),('8537','2014-04-13','16:30:00',1.45),('8537','2014-04-13','16:35:00',1.99),('8537','2014-04-13','16:40:00',2.68),('8537','2014-04-13','16:45:00',3.43),('8537','2014-04-13','16:50:00',2.17),('8537','2014-04-13','16:55:00',2.58),('8537','2014-04-13','17:00:00',2.56),('8537','2014-04-13','17:05:00',1.76),('8537','2014-04-13','17:10:00',1.1),('8537','2014-04-13','17:15:00',1.17),('8537','2014-04-13','17:20:00',1.45),('8537','2014-04-13','17:25:00',1.31),('8537','2014-04-13','17:50:00',1.08),('8537','2014-04-13','17:55:00',1.14),('8537','2014-04-13','18:00:00',1.08),('8537','2013-09-18','08:10:00',1.06),('8537','2013-09-18','08:15:00',1.08),('8537','2013-09-18','08:25:00',1.27),('8537','2013-09-18','08:30:00',1.06),('8537','2013-09-18','08:35:00',1.04),('8537','2013-09-18','08:45:00',1.94),('8537','2013-09-18','08:55:00',1.3),('8537','2013-09-18','09:00:00',1.2),('8537','2013-09-18','09:05:00',2.09),('8537','2013-09-18','09:10:00',1.06),('8537','2013-09-18','09:15:00',1.56),('8537','2013-09-18','09:20:00',2.84),('8537','2013-09-18','09:25:00',1.91),('8537','2013-09-18','09:30:00',1.55),('8537','2013-09-18','09:35:00',3.14),('8537','2013-09-18','09:40:00',2.32),('8537','2013-09-18','09:45:00',1.49),('8537','2013-09-18','09:50:00',1),('8537','2013-09-18','09:55:00',1.69),('8537','2013-09-18','10:00:00',3.39),('8537','2013-09-18','10:05:00',3.81),('8537','2013-09-18','10:10:00',3.71),('8537','2013-09-18','10:15:00',3.55),('8537','2013-09-18','10:20:00',3.54),('8537','2013-09-18','10:25:00',3.56),('8537','2013-09-18','10:30:00',3.6),('8537','2013-09-18','10:35:00',3.67),('8537','2013-09-18','10:40:00',3.75),('8537','2013-09-18','10:45:00',3.68),('8537','2013-09-18','10:50:00',3.46),('8537','2013-09-18','10:55:00',3.02),('8537','2013-09-18','11:00:00',3.83),('8537','2013-09-18','11:05:00',3.7),('8537','2013-09-18','11:10:00',3.93),('8537','2013-09-18','11:15:00',2.18),('8537','2013-09-18','11:25:00',3.65),('8537','2013-09-18','11:30:00',4.88),('8537','2013-09-18','11:35:00',4.76),('8537','2013-09-18','11:40:00',3.6),('8537','2013-09-18','11:45:00',3.24),('8537','2013-09-18','11:50:00',4.65),('8537','2013-09-18','11:55:00',4.61),('8537','2013-09-18','12:00:00',4.71),('8537','2013-09-18','12:05:00',4.15),('8537','2013-09-18','12:10:00',4.94),('8537','2013-09-18','12:15:00',4.92),('8537','2013-09-18','12:20:00',4.88),('8537','2013-09-18','12:25:00',4.58),('8537','2013-09-18','12:30:00',2.61),('8537','2013-09-18','12:35:00',4.58),('8537','2013-09-18','12:40:00',5.15),('8537','2013-09-18','12:45:00',2.1),('8537','2013-09-18','12:50:00',4.8),('8537','2013-09-18','12:55:00',4.54),('8537','2013-09-18','13:00:00',3.75),('8537','2013-09-18','13:05:00',2.99),('8537','2013-09-18','13:10:00',5.03),('8537','2013-09-18','13:15:00',4.95),('8537','2013-09-18','13:20:00',4.9),('8537','2013-09-18','13:25:00',4.84),('8537','2013-09-18','13:30:00',4.89),('8537','2013-09-18','13:35:00',4.8),('8537','2013-09-18','13:40:00',4.76),('8537','2013-09-18','13:45:00',4.75),('8537','2013-09-18','13:50:00',4.9),('8537','2013-09-18','13:55:00',4.14),('8537','2013-09-18','14:00:00',4.83),('8537','2013-09-18','14:05:00',3.7),('8537','2013-09-18','14:10:00',4.1),('8537','2013-09-18','14:15:00',4.58),('8537','2013-09-18','14:20:00',4.54),('8537','2013-09-18','14:25:00',4.44),('8537','2013-09-18','14:30:00',4.36),('8537','2013-09-18','14:35:00',4.34),('8537','2013-09-18','14:40:00',4.33),('8537','2013-09-18','14:45:00',4.22),('8537','2013-09-18','14:50:00',2.88),('8537','2013-09-18','14:55:00',3.59),('8537','2013-09-18','15:00:00',4.14),('8537','2013-09-18','15:05:00',3.99),('8537','2013-09-18','15:10:00',1.43),('8537','2013-09-18','15:15:00',2.42),('8537','2013-09-18','15:20:00',2.85),('8537','2013-09-18','15:25:00',3.97),('8537','2013-09-18','15:30:00',3.89),('8537','2013-09-18','15:35:00',3.57),('8537','2013-09-18','15:40:00',3.69),('8537','2013-09-18','15:45:00',3.42),('8537','2013-09-18','15:50:00',2.66),('8537','2013-09-18','15:55:00',2.13),('8537','2013-09-18','16:00:00',3.43),('8537','2013-09-18','16:05:00',3.4),('8537','2013-09-18','16:10:00',3.25),('8537','2013-09-18','16:15:00',3.04),('8537','2013-09-18','16:20:00',2.85),('8537','2013-09-18','16:25:00',2.5),('8537','2013-09-18','16:30:00',2.41),('8537','2013-09-18','16:35:00',2.25),('8537','2013-09-18','16:40:00',2.2),('8537','2013-09-18','16:45:00',2.18),('8537','2013-09-18','16:50:00',1.95),('8537','2013-09-18','16:55:00',1.87),('8537','2013-09-18','17:00:00',1.95),('8537','2013-09-18','17:05:00',1.7),('8537','2013-09-18','17:10:00',1.67),('8537','2013-09-18','17:15:00',1.6),('8537','2013-09-18','17:20:00',1.53),('8537','2013-09-18','17:25:00',1.18),('8537','2013-09-18','17:30:00',1.33),('8537','2013-09-18','17:35:00',1.2),('8537','2013-09-18','17:40:00',1.09),('8537','2013-09-17','09:20:00',1.47),('8537','2013-09-17','09:25:00',1.04),('8537','2013-09-17','09:30:00',1.31),('8537','2013-09-17','09:40:00',1.63),('8537','2013-09-17','09:45:00',2.78),('8537','2013-09-17','09:50:00',1.78),('8537','2013-09-17','09:55:00',1.73),('8537','2013-09-17','10:00:00',2.64),('8537','2013-09-17','10:05:00',1.85),('8537','2013-09-17','10:10:00',2.27),('8537','2013-09-17','10:20:00',1.15),('8537','2013-09-17','10:25:00',2.98),('8537','2013-09-17','10:30:00',4.06),('8537','2013-09-17','10:35:00',2.14),('8537','2013-09-17','10:40:00',2.4),('8537','2013-09-17','10:45:00',2.39),('8537','2013-09-17','10:50:00',4.51),('8537','2013-09-17','10:55:00',3.44),('8537','2013-09-17','11:00:00',2.72),('8537','2013-09-17','11:05:00',2.4),('8537','2013-09-17','11:10:00',4.06),('8537','2013-09-17','11:15:00',3.27),('8537','2013-09-17','11:20:00',2.88),('8537','2013-09-17','11:25:00',2.17),('8537','2013-09-17','11:30:00',2.21),('8537','2013-09-17','11:35:00',3.89),('8537','2013-09-17','11:40:00',4.1),('8537','2013-09-17','11:45:00',3.86),('8537','2013-09-17','11:50:00',3.71),('8537','2013-09-17','11:55:00',3.26),('8537','2013-09-17','12:00:00',4.48),('8537','2013-09-17','12:05:00',3.39),('8537','2013-09-17','12:10:00',2.23),('8537','2013-09-17','12:15:00',2.68),('8537','2013-09-17','12:20:00',2.42),('8537','2013-09-17','12:25:00',4.65),('8537','2013-09-17','12:30:00',3.8),('8537','2013-09-17','12:35:00',2.7),('8537','2013-09-17','12:40:00',3.98),('8537','2013-09-17','12:45:00',3.94),('8537','2013-09-17','12:50:00',3.6),('8537','2013-09-17','12:55:00',3.05),('8537','2013-09-17','13:00:00',2.8),('8537','2013-09-17','13:05:00',1.77),('8537','2013-09-17','13:10:00',3.1),('8537','2013-09-17','13:15:00',3.81),('8537','2013-09-17','13:20:00',2.82),('8537','2013-09-17','13:25:00',1.66),('8537','2013-09-17','13:30:00',2.1),('8537','2013-09-17','13:35:00',2.12),('8537','2013-09-17','13:40:00',2.79),('8537','2013-09-17','13:45:00',1.96),('8537','2013-09-17','13:50:00',1.11),('8537','2013-09-17','13:55:00',1.49),('8537','2013-09-17','14:00:00',2.27),('8537','2013-09-17','14:05:00',1.56),('8537','2013-09-17','14:10:00',1.14),('8537','2013-09-17','14:15:00',1.54),('8537','2013-09-17','14:20:00',1.12),('8537','2013-09-17','14:25:00',2.16),('8537','2013-09-17','14:30:00',1.29),('8537','2013-09-17','14:35:00',1.33),('8537','2013-09-17','14:40:00',1.04),('8537','2013-09-17','14:50:00',1.54),('8537','2013-09-17','14:55:00',3.1),('8537','2013-09-17','15:00:00',3.81),('8537','2013-09-17','15:05:00',3.07),('8537','2013-09-17','15:10:00',3.05),('8537','2013-09-17','15:15:00',3.09),('8537','2013-09-17','15:20:00',3.48),('8537','2013-09-17','15:25:00',3.26),('8537','2013-09-17','15:30:00',2.77),('8537','2013-09-17','15:35:00',1.33),('8537','2013-09-17','15:45:00',1.38),('8537','2013-09-17','15:50:00',2.11),('8537','2013-09-17','15:55:00',2.23),('8537','2013-09-17','16:00:00',1.48),('8537','2013-09-17','16:05:00',2.12),('8537','2013-09-17','16:10:00',1.84),('8537','2013-09-17','16:15:00',1.88),('8537','2013-09-17','16:20:00',1.23),('8537','2013-09-17','16:40:00',1.33),('8537','2013-09-17','16:45:00',1.53),('8537','2013-09-17','16:50:00',1.38),('8537','2013-09-17','16:55:00',1.08),('8537','2013-09-17','17:00:00',1.63),('8537','2013-09-17','17:05:00',1.78),('8537','2013-09-17','17:10:00',1.63),('8537','2013-09-17','17:15:00',1.65),('8537','2013-09-17','17:20:00',1.37),('8537','2013-09-17','17:25:00',1.28),('8537','2013-09-17','17:30:00',1.34),('8537','2013-09-16','08:10:00',1.17),('8537','2013-09-16','08:15:00',1.28),('8537','2013-09-16','08:20:00',1.34),('8537','2013-09-16','08:25:00',1.44),('8537','2013-09-16','08:30:00',1.54),('8537','2013-09-16','08:35:00',1.68),('8537','2013-09-16','08:40:00',1.88),('8537','2013-09-16','08:45:00',1.46),('8537','2013-09-16','08:50:00',1.83),('8537','2013-09-16','08:55:00',1.05),('8537','2013-09-16','09:05:00',1.74),('8537','2013-09-16','09:10:00',2.24),('8537','2013-09-16','09:15:00',2.71),('8537','2013-09-16','09:20:00',2.08),('8537','2013-09-16','09:25:00',2.55),('8537','2013-09-16','09:30:00',2.44),('8537','2013-09-16','09:35:00',2.56),('8537','2013-09-16','09:40:00',3.02),('8537','2013-09-16','09:45:00',3.08),('8537','2013-09-16','09:50:00',3.15),('8537','2013-09-16','09:55:00',3.32),('8537','2013-09-16','10:00:00',3.4),('8537','2013-09-16','10:05:00',3.48),('8537','2013-09-16','10:10:00',3.31),('8537','2013-09-16','10:15:00',1.17),('8537','2013-09-16','10:20:00',1.88),('8537','2013-09-16','10:25:00',2.22),('8537','2013-09-16','10:30:00',3.97),('8537','2013-09-16','10:35:00',4.21),('8537','2013-09-16','10:40:00',4.45),('8537','2013-09-16','10:45:00',4.68),('8537','2013-09-16','10:50:00',3.25),('8537','2013-09-16','11:05:00',3.01),('8537','2013-09-16','11:10:00',1.18),('8537','2013-09-16','11:15:00',1.01),('8537','2013-09-16','11:20:00',2.57),('8537','2013-09-16','11:25:00',2.66),('8537','2013-09-16','11:30:00',4.75),('8537','2013-09-16','11:35:00',4.64),('8537','2013-09-16','11:40:00',4.69),('8537','2013-09-16','11:45:00',4.13),('8537','2013-09-16','11:50:00',3.16),('8537','2013-09-16','11:55:00',4.83),('8537','2013-09-16','12:00:00',4.98),('8537','2013-09-16','12:05:00',5.06),('8537','2013-09-16','12:10:00',5.13),('8537','2013-09-16','12:15:00',4.3),('8537','2013-09-16','12:20:00',4.84),('8537','2013-09-16','12:25:00',4.81),('8537','2013-09-16','12:30:00',4.79),('8537','2013-09-16','12:35:00',4.86),('8537','2013-09-16','12:40:00',4.99),('8537','2013-09-16','12:45:00',5.08),('8537','2013-09-16','12:50:00',2.91),('8537','2013-09-16','12:55:00',2.91),('8537','2013-09-16','13:00:00',3.8),('8537','2013-09-16','13:05:00',4.41),('8537','2013-09-16','13:10:00',4.66),('8537','2013-09-16','13:15:00',4.86),('8537','2013-09-16','13:20:00',4.71),('8537','2013-09-16','13:25:00',4.84),('8537','2013-09-16','13:30:00',4.78),('8537','2013-09-16','13:35:00',4.77),('8537','2013-09-16','13:40:00',4.76),('8537','2013-09-16','13:45:00',4.73),('8537','2013-09-16','13:50:00',4.76),('8537','2013-09-16','13:55:00',4.87),('8537','2013-09-16','14:00:00',4.39),('8537','2013-09-16','14:05:00',3.77),('8537','2013-09-16','14:10:00',4.64),('8537','2013-09-16','14:15:00',4.54),('8537','2013-09-16','14:20:00',4.44),('8537','2013-09-16','14:25:00',4.4),('8537','2013-09-16','14:30:00',4.38),('8537','2013-09-16','14:35:00',4.3),('8537','2013-09-16','14:40:00',4.22),('8537','2013-09-16','14:45:00',4.21),('8537','2013-09-16','14:50:00',4.06),('8537','2013-09-16','14:55:00',4.15),('8537','2013-09-16','15:00:00',4.11),('8537','2013-09-16','15:05:00',4.08),('8537','2013-09-16','15:10:00',3.84),('8537','2013-09-16','15:15:00',3.37),('8537','2013-09-16','15:20:00',3.2),('8537','2013-09-16','15:25:00',3.75),('8537','2013-09-16','15:30:00',3.7),('8537','2013-09-16','15:35:00',3.63),('8537','2013-09-16','15:40:00',3.58),('8537','2013-09-16','15:45:00',3.51),('8537','2013-09-16','15:50:00',3.38),('8537','2013-09-16','15:55:00',3.3),('8537','2013-09-16','16:00:00',3.28),('8537','2013-09-16','16:05:00',2.36),('8537','2013-09-16','16:10:00',3.21),('8537','2013-09-16','16:15:00',3.01),('8537','2013-09-16','16:20:00',2.9),('8537','2013-09-16','16:25:00',2.78),('8537','2013-09-16','16:30:00',2.71),('8537','2013-09-16','16:35:00',2.58),('8537','2013-09-16','16:40:00',2.51),('8537','2013-09-16','16:45:00',2.34),('8537','2013-09-16','16:50:00',2.27),('8537','2013-09-16','16:55:00',2.17),('8537','2013-09-16','17:00:00',2.06),('8537','2013-09-16','17:05:00',1.93),('8537','2013-09-16','17:10:00',1.81),('8537','2013-09-16','17:15:00',1.69),('8537','2013-09-16','17:20:00',1.58),('8537','2013-09-16','17:25:00',1.48),('8537','2013-09-16','17:30:00',1.37),('8537','2013-09-16','17:35:00',1.15),('8537','2013-09-16','17:40:00',1.03),('8537','2013-09-16','17:45:00',1.03),('8537','2013-09-15','08:05:00',1.06),('8537','2013-09-15','08:10:00',1.17),('8537','2013-09-15','08:15:00',1.29),('8537','2013-09-15','08:20:00',1.4),('8537','2013-09-15','08:25:00',1.52),('8537','2013-09-15','08:30:00',1.63),('8537','2013-09-15','08:35:00',1.76),('8537','2013-09-15','08:40:00',1.9),('8537','2013-09-15','08:45:00',2.03),('8537','2013-09-15','08:50:00',2.06),('8537','2013-09-15','08:55:00',1.99),('8537','2013-09-15','09:00:00',2.17),('8537','2013-09-15','09:05:00',2.23),('8537','2013-09-15','09:10:00',2.42),('8537','2013-09-15','09:15:00',2.64),('8537','2013-09-15','09:20:00',2.58),('8537','2013-09-15','09:25:00',2.71),('8537','2013-09-15','09:30:00',2.75),('8537','2013-09-15','09:35:00',2.94),('8537','2013-09-15','09:40:00',3),('8537','2013-09-15','09:45:00',3.04),('8537','2013-09-15','09:50:00',3.16),('8537','2013-09-15','09:55:00',3.21),('8537','2013-09-15','10:00:00',3.34),('8537','2013-09-15','10:05:00',3.41),('8537','2013-09-15','10:10:00',3.43),('8537','2013-09-15','10:15:00',3.38),('8537','2013-09-15','10:20:00',3.49),('8537','2013-09-15','10:25:00',3.6),('8537','2013-09-15','10:30:00',3.43),('8537','2013-09-15','10:35:00',2.84),('8537','2013-09-15','10:40:00',1.98),('8537','2013-09-15','10:45:00',1.64),('8537','2013-09-15','10:50:00',1.2),('8537','2013-09-15','10:55:00',1.74),('8537','2013-09-15','11:00:00',3.62),('8537','2013-09-15','11:05:00',4.54),('8537','2013-09-15','11:10:00',3.35),('8537','2013-09-15','11:15:00',1.6),('8537','2013-09-15','11:20:00',1.25),('8537','2013-09-15','11:25:00',1.23),('8537','2013-09-15','11:30:00',1.43),('8537','2013-09-15','11:35:00',3.66),('8537','2013-09-15','11:40:00',1.87),('8537','2013-09-15','11:45:00',1.5),('8537','2013-09-15','11:50:00',3.08),('8537','2013-09-15','11:55:00',1.62),('8537','2013-09-15','12:00:00',1.48),('8537','2013-09-15','12:05:00',1.41),('8537','2013-09-15','12:10:00',1.32),('8537','2013-09-15','12:15:00',1.34),('8537','2013-09-15','12:20:00',1.61),('8537','2013-09-15','12:25:00',1.9),('8537','2013-09-15','12:30:00',1.93),('8537','2013-09-15','12:35:00',1.87),('8537','2013-09-15','12:40:00',1.83),('8537','2013-09-15','12:45:00',1.43),('8537','2013-09-15','12:50:00',1.53),('8537','2013-09-15','12:55:00',1.59),('8537','2013-09-15','13:00:00',1.48),('8537','2013-09-15','13:05:00',1.33),('8537','2013-09-15','13:25:00',1.08),('8537','2013-09-15','13:30:00',1.17),('8537','2013-09-15','13:35:00',1.44),('8537','2013-09-15','13:40:00',1.64),('8537','2013-09-15','13:45:00',2.35),('8537','2013-09-15','13:50:00',2.33),('8537','2013-09-15','13:55:00',1.51),('8537','2013-09-15','14:00:00',2.14),('8537','2013-09-15','14:05:00',1.98),('8537','2013-09-15','14:10:00',1.74),('8537','2013-09-15','14:15:00',1.58),('8537','2013-09-15','14:20:00',1.5),('8537','2013-09-15','14:25:00',1.49),('8537','2013-09-15','14:30:00',1.47),('8537','2013-09-15','14:35:00',1.26),('8537','2013-09-15','14:40:00',1.28),('8537','2013-09-15','14:45:00',1.11),('8537','2013-09-15','14:50:00',1.17),('8537','2013-09-15','14:55:00',1.24),('8537','2013-09-15','15:00:00',1.26),('8537','2013-09-15','15:05:00',1.35),('8537','2013-09-15','15:10:00',1.54),('8537','2013-09-15','15:15:00',3.02),('8537','2013-09-15','15:20:00',2.46),('8537','2013-09-15','15:25:00',1.77),('8537','2013-09-15','15:30:00',1.32),('8537','2013-09-15','15:35:00',1.26),('8537','2013-09-15','15:40:00',1.17),('8537','2013-09-15','15:45:00',1.13),('8537','2013-09-15','15:50:00',1.13),('8537','2013-09-15','15:55:00',1.13),('8537','2013-09-15','16:05:00',1.11),('8537','2013-09-14','08:05:00',1.01),('8537','2013-09-14','08:10:00',1.12),('8537','2013-09-14','08:15:00',1.23),('8537','2013-09-14','08:20:00',1.34),('8537','2013-09-14','08:25:00',1.45),('8537','2013-09-14','08:30:00',1.58),('8537','2013-09-14','08:35:00',1.7),('8537','2013-09-14','08:40:00',1.81),('8537','2013-09-14','08:45:00',1.92),('8537','2013-09-14','08:50:00',2.02),('8537','2013-09-14','08:55:00',2.14),('8537','2013-09-14','09:00:00',2.25),('8537','2013-09-14','09:05:00',2.35),('8537','2013-09-14','09:10:00',2.46),('8537','2013-09-14','09:15:00',2.56),('8537','2013-09-14','09:20:00',2.65),('8537','2013-09-14','09:25:00',2.72),('8537','2013-09-14','09:30:00',2.84),('8537','2013-09-14','09:35:00',2.91),('8537','2013-09-14','09:40:00',3),('8537','2013-09-14','09:45:00',3.1),('8537','2013-09-14','09:50:00',3.1),('8537','2013-09-14','09:55:00',3.2),('8537','2013-09-14','10:00:00',2.69),('8537','2013-09-14','10:05:00',3.19),('8537','2013-09-14','10:10:00',3.16),('8537','2013-09-14','10:15:00',3.27),('8537','2013-09-14','10:20:00',3.5),('8537','2013-09-14','10:25:00',3.67),('8537','2013-09-14','10:30:00',3.65),('8537','2013-09-14','10:35:00',3.78),('8537','2013-09-14','10:40:00',3.92),('8537','2013-09-14','10:45:00',4.26),('8537','2013-09-14','10:50:00',4.54),('8537','2013-09-14','10:55:00',4.57),('8537','2013-09-14','11:00:00',4.4),('8537','2013-09-14','11:05:00',2.01),('8537','2013-09-14','11:10:00',1.12),('8537','2013-09-14','11:15:00',1.12),('8537','2013-09-14','11:25:00',2.74),('8537','2013-09-14','11:30:00',4.55),('8537','2013-09-14','11:35:00',4.45),('8537','2013-09-14','11:40:00',3.98),('8537','2013-09-14','11:45:00',4.47),('8537','2013-09-14','11:50:00',3.96),('8537','2013-09-14','11:55:00',2.32),('8537','2013-09-14','12:00:00',2.1),('8537','2013-09-14','12:05:00',2.91),('8537','2013-09-14','12:10:00',1.75),('8537','2013-09-14','12:15:00',2.66),('8537','2013-09-14','12:20:00',1.18),('8537','2013-09-14','12:35:00',2.26),('8537','2013-09-14','12:40:00',3.99),('8537','2013-09-14','12:45:00',1.21),('8537','2013-09-14','12:50:00',1.05),('8537','2013-09-14','12:55:00',1.11),('8537','2013-09-14','13:00:00',1.11),('8537','2013-09-14','13:10:00',1.42),('8537','2013-09-14','13:15:00',4.4),('8537','2013-09-14','13:20:00',5.04),('8537','2013-09-14','13:25:00',4.77),('8537','2013-09-14','13:30:00',5.12),('8537','2013-09-14','13:35:00',2.72),('8537','2013-09-14','13:40:00',2.54),('8537','2013-09-14','13:45:00',3.37),('8537','2013-09-14','13:50:00',3.16),('8537','2013-09-14','13:55:00',5.49),('8537','2013-09-14','14:00:00',5.05),('8537','2013-09-14','14:05:00',4.7),('8537','2013-09-14','14:10:00',4.61),('8537','2013-09-14','14:15:00',4.58),('8537','2013-09-14','14:20:00',3.9),('8537','2013-09-14','14:25:00',4.27),('8537','2013-09-14','14:30:00',4.41),('8537','2013-09-14','14:35:00',4.37),('8537','2013-09-14','14:40:00',4.31),('8537','2013-09-14','14:45:00',4.16),('8537','2013-09-14','14:50:00',4.23),('8537','2013-09-14','14:55:00',4.18),('8537','2013-09-14','15:00:00',4.1),('8537','2013-09-14','15:05:00',4.02),('8537','2013-09-14','15:10:00',3.91),('8537','2013-09-14','15:15:00',3.83),('8537','2013-09-14','15:20:00',3.82),('8537','2013-09-14','15:25:00',3.79),('8537','2013-09-14','15:30:00',3.56),('8537','2013-09-14','15:35:00',3.65),('8537','2013-09-14','15:40:00',3.58),('8537','2013-09-14','15:45:00',3.49),('8537','2013-09-14','15:50:00',3.37),('8537','2013-09-14','15:55:00',3.29),('8537','2013-09-14','16:00:00',3.2),('8537','2013-09-14','16:05:00',3.12),('8537','2013-09-14','16:10:00',3.05),('8537','2013-09-14','16:15:00',2.96),('8537','2013-09-14','16:20:00',2.89),('8537','2013-09-14','16:25:00',2.66),('8537','2013-09-14','16:30:00',2.55),('8537','2013-09-14','16:35:00',2.6),('8537','2013-09-14','16:40:00',2.5),('8537','2013-09-14','16:45:00',2.33),('8537','2013-09-14','16:50:00',2.24),('8537','2013-09-14','16:55:00',2.17),('8537','2013-09-14','17:00:00',1.86),('8537','2013-09-14','17:05:00',1.96),('8537','2013-09-14','17:10:00',1.85),('8537','2013-09-14','17:15:00',1.73),('8537','2013-09-14','17:20:00',1.62),('8537','2013-09-14','17:25:00',1.5),('8537','2013-09-14','17:30:00',1.38),('8537','2013-09-14','17:35:00',1.17),('8537','2013-09-14','17:40:00',1.11),('8537','2013-09-14','17:45:00',1.1),('8537','2013-09-14','17:50:00',1),('8537','2013-09-13','08:30:00',1.08),('8537','2013-09-13','08:50:00',1.12),('8537','2013-09-13','08:55:00',1.25),('8537','2013-09-13','09:00:00',1.19),('8537','2013-09-13','09:05:00',1.14),('8537','2013-09-13','09:10:00',1.12),('8537','2013-09-13','09:15:00',1.17),('8537','2013-09-13','09:20:00',1.2),('8537','2013-09-13','09:25:00',1.32),('8537','2013-09-13','09:30:00',1.43),('8537','2013-09-13','09:35:00',1.56),('8537','2013-09-13','09:40:00',1.7),('8537','2013-09-13','09:45:00',1.61),('8537','2013-09-13','09:50:00',1.84),('8537','2013-09-13','09:55:00',3.29),('8537','2013-09-13','10:00:00',3.4),('8537','2013-09-13','10:05:00',1.52),('8537','2013-09-13','10:10:00',2.12),('8537','2013-09-13','10:15:00',4.27),('8537','2013-09-13','10:20:00',4.13),('8537','2013-09-13','10:25:00',2.35),('8537','2013-09-13','10:30:00',2.7),('8537','2013-09-13','10:35:00',4.06),('8537','2013-09-13','10:40:00',4.01),('8537','2013-09-13','10:45:00',3.99),('8537','2013-09-13','10:50:00',4.07),('8537','2013-09-13','10:55:00',4.12),('8537','2013-09-13','11:00:00',4.14),('8537','2013-09-13','11:05:00',4.22),('8537','2013-09-13','11:10:00',4.24),('8537','2013-09-13','11:15:00',4.29),('8537','2013-09-13','11:20:00',4.36),('8537','2013-09-13','11:25:00',4.35),('8537','2013-09-13','11:30:00',4.34),('8537','2013-09-13','11:35:00',4.47),('8537','2013-09-13','11:40:00',4.48),('8537','2013-09-13','11:45:00',4.48),('8537','2013-09-13','11:50:00',4.5),('8537','2013-09-13','11:55:00',4.56),('8537','2013-09-13','12:00:00',4.6),('8537','2013-09-13','12:05:00',4.68),('8537','2013-09-13','12:10:00',4.68),('8537','2013-09-13','12:15:00',4.69),('8537','2013-09-13','12:20:00',4.7),('8537','2013-09-13','12:25:00',4.79),('8537','2013-09-13','12:30:00',4.95),('8537','2013-09-13','12:35:00',4.85),('8537','2013-09-13','12:40:00',4.86),('8537','2013-09-13','12:45:00',4.85),('8537','2013-09-13','12:50:00',4.94),('8537','2013-09-13','12:55:00',4.87),('8537','2013-09-13','13:00:00',4.79),('8537','2013-09-13','13:05:00',4.76),('8537','2013-09-13','13:10:00',4.73),('8537','2013-09-13','13:15:00',4.74),('8537','2013-09-13','13:20:00',4.73),('8537','2013-09-13','13:25:00',4.74),('8537','2013-09-13','13:30:00',4.69),('8537','2013-09-13','13:35:00',4.65),('8537','2013-09-13','13:40:00',4.63),('8537','2013-09-13','13:45:00',4.6),('8537','2013-09-13','13:50:00',4.56),('8537','2013-09-13','13:55:00',4.55),('8537','2013-09-13','14:00:00',4.57),('8537','2013-09-13','14:05:00',4.53),('8537','2013-09-13','14:10:00',4.47),('8537','2013-09-13','14:15:00',4.46),('8537','2013-09-13','14:20:00',4.45),('8537','2013-09-13','14:25:00',4.2),('8537','2013-09-13','14:30:00',3.81),('8537','2013-09-13','14:35:00',4.29),('8537','2013-09-13','14:40:00',4.19),('8537','2013-09-13','14:45:00',4.18),('8537','2013-09-13','14:50:00',4.26),('8537','2013-09-13','14:55:00',4.15),('8537','2013-09-13','15:00:00',4.03),('8537','2013-09-13','15:05:00',4.04),('8537','2013-09-13','15:10:00',4),('8537','2013-09-13','15:15:00',3.72),('8537','2013-09-13','15:20:00',3.82),('8537','2013-09-13','15:25:00',3.79),('8537','2013-09-13','15:30:00',3.73),('8537','2013-09-13','15:35:00',3.68),('8537','2013-09-13','15:40:00',3.62),('8537','2013-09-13','15:45:00',3.56),('8537','2013-09-13','15:50:00',3.41),('8537','2013-09-13','15:55:00',3.35),('8537','2013-09-13','16:00:00',3.26),('8537','2013-09-13','16:05:00',3.19),('8537','2013-09-13','16:10:00',3.11),('8537','2013-09-13','16:15:00',3.03),('8537','2013-09-13','16:20:00',2.93),('8537','2013-09-13','16:25:00',2.79),('8537','2013-09-13','16:30:00',2.33),('8537','2013-09-13','16:35:00',2.62),('8537','2013-09-13','16:40:00',2.54),('8537','2013-09-13','16:45:00',2.36),('8537','2013-09-13','16:50:00',2.26),('8537','2013-09-13','16:55:00',2.18),('8537','2013-09-13','17:00:00',2.07),('8537','2013-09-13','17:05:00',1.96),('8537','2013-09-13','17:10:00',1.84),('8537','2013-09-13','17:15:00',1.7),('8537','2013-09-13','17:20:00',1.61),('8537','2013-09-13','17:25:00',1.51),('8537','2013-09-13','17:30:00',1.4),('8537','2013-09-13','17:35:00',1.27),('8537','2013-09-13','17:40:00',1.19),('8537','2013-09-13','17:45:00',1.1),('8537','2013-09-12','08:00:00',1.13),('8537','2013-09-12','08:15:00',1.46),('8537','2013-09-12','08:20:00',1.49),('8537','2013-09-12','08:25:00',1.74),('8537','2013-09-12','08:30:00',1.95),('8537','2013-09-12','08:35:00',1.89),('8537','2013-09-12','08:40:00',1.38),('8537','2013-09-12','08:55:00',2),('8537','2013-09-12','09:00:00',2.2),('8537','2013-09-12','09:05:00',2.15),('8537','2013-09-12','09:10:00',1.66),('8537','2013-09-12','09:15:00',2.45),('8537','2013-09-12','09:20:00',2.47),('8537','2013-09-12','09:25:00',2.71),('8537','2013-09-12','09:30:00',2.91),('8537','2013-09-12','09:35:00',2.65),('8537','2013-09-12','09:40:00',2.18),('8537','2013-09-12','09:45:00',2.67),('8537','2013-09-12','09:50:00',2.65),('8537','2013-09-12','09:55:00',1.79),('8537','2013-09-12','10:00:00',1.27),('8537','2013-09-12','10:05:00',1.62),('8537','2013-09-12','10:10:00',2.03),('8537','2013-09-12','10:15:00',2),('8537','2013-09-12','10:20:00',1.56),('8537','2013-09-12','10:25:00',1.09),('8537','2013-09-12','10:30:00',1.86),('8537','2013-09-12','10:35:00',2.06),('8537','2013-09-12','10:55:00',2.21),('8537','2013-09-12','11:00:00',2.7),('8537','2013-09-12','11:05:00',4),('8537','2013-09-12','11:10:00',2.87),('8537','2013-09-12','11:15:00',3.08),('8537','2013-09-12','11:20:00',1.46),('8537','2013-09-12','11:40:00',1.27),('8537','2013-09-12','11:45:00',2.82),('8537','2013-09-12','11:50:00',1.88),('8537','2013-09-12','11:55:00',3.48),('8537','2013-09-12','12:00:00',3.89),('8537','2013-09-12','12:05:00',4.54),('8537','2013-09-12','12:10:00',4.01),('8537','2013-09-12','12:15:00',3.7),('8537','2013-09-12','12:20:00',1.66),('8537','2013-09-12','12:25:00',2.29),('8537','2013-09-12','12:30:00',1.81),('8537','2013-09-12','12:35:00',3.45),('8537','2013-09-12','12:40:00',4.59),('8537','2013-09-12','12:45:00',1.33),('8537','2013-09-12','12:50:00',2.71),('8537','2013-09-12','12:55:00',2.29),('8537','2013-09-12','13:00:00',5.05),('8537','2013-09-12','13:05:00',2.77),('8537','2013-09-12','13:10:00',3.97),('8537','2013-09-12','13:15:00',4.64),('8537','2013-09-12','13:20:00',5.45),('8537','2013-09-12','13:25:00',5.54),('8537','2013-09-12','13:30:00',4.28),('8537','2013-09-12','13:35:00',3.6),('8537','2013-09-12','13:40:00',3.65),('8537','2013-09-12','13:45:00',4.08),('8537','2013-09-12','13:50:00',4.9),('8537','2013-09-12','13:55:00',4.81),('8537','2013-09-12','14:00:00',4.88),('8537','2013-09-12','14:05:00',4.55),('8537','2013-09-12','14:10:00',3.85),('8537','2013-09-12','14:15:00',4.79),('8537','2013-09-12','14:20:00',4.54),('8537','2013-09-12','14:25:00',4.66),('8537','2013-09-12','14:30:00',4.33),('8537','2013-09-12','14:35:00',3.32),('8537','2013-09-12','14:40:00',3.45),('8537','2013-09-12','14:45:00',4.48),('8537','2013-09-12','14:50:00',4.35),('8537','2013-09-12','14:55:00',4.27),('8537','2013-09-12','15:00:00',4.06),('8537','2013-09-12','15:05:00',3.53),('8537','2013-09-12','15:10:00',3),('8537','2013-09-12','15:15:00',4.01),('8537','2013-09-12','15:20:00',3.94),('8537','2013-09-12','15:25:00',3.5),('8537','2013-09-12','15:30:00',3.83),('8537','2013-09-12','15:35:00',3.72),('8537','2013-09-12','15:40:00',3.66),('8537','2013-09-12','15:45:00',3.66),('8537','2013-09-12','15:50:00',3.53),('8537','2013-09-12','15:55:00',3.4),('8537','2013-09-12','16:00:00',3.43),('8537','2013-09-12','16:05:00',2.48),('8537','2013-09-12','16:10:00',2.94),('8537','2013-09-12','16:15:00',2.32),('8537','2013-09-12','16:20:00',2.07),('8537','2013-09-12','16:25:00',2.12),('8537','2013-09-12','16:30:00',1.88),('8537','2013-09-12','16:35:00',1.19),('8537','2013-09-12','16:40:00',2.12),('8537','2013-09-12','16:45:00',2.77),('8537','2013-09-12','16:50:00',1.06),('8537','2013-09-12','16:55:00',1.4),('8537','2013-09-12','17:00:00',1.42),('8537','2013-09-12','17:05:00',1.57),('8537','2013-09-12','17:10:00',1.3),('8537','2013-09-12','17:15:00',1.93),('8537','2013-09-12','17:20:00',1.21),('8537','2013-09-12','17:30:00',1.28),('8537','2013-09-12','17:35:00',1.48),('8537','2013-09-12','17:40:00',1.31),('8537','2013-09-12','17:45:00',1.26),('8537','2013-09-12','17:50:00',1.07),('8537','2013-09-11','08:05:00',1.33),('8537','2013-09-11','08:10:00',1.26),('8537','2013-09-11','08:15:00',1.22),('8537','2013-09-11','08:30:00',1.01),('8537','2013-09-11','08:50:00',1.06),('8537','2013-09-11','08:55:00',1.16),('8537','2013-09-11','09:00:00',2.46),('8537','2013-09-11','09:05:00',2.35),('8537','2013-09-11','09:10:00',2.44),('8537','2013-09-11','09:15:00',2.68),('8537','2013-09-11','09:20:00',2.52),('8537','2013-09-11','09:25:00',2.46),('8537','2013-09-11','09:30:00',1.65),('8537','2013-09-11','09:35:00',2.38),('8537','2013-09-11','09:40:00',1.79),('8537','2013-09-11','09:50:00',1.02),('8537','2013-09-11','10:00:00',1.22),('8537','2013-09-11','10:05:00',2.91),('8537','2013-09-11','10:15:00',2.17),('8537','2013-09-11','10:20:00',3.58),('8537','2013-09-11','10:25:00',2.69),('8537','2013-09-11','10:30:00',4.05),('8537','2013-09-11','10:35:00',3.2),('8537','2013-09-11','10:40:00',3.86),('8537','2013-09-11','10:45:00',3.02),('8537','2013-09-11','10:50:00',3.67),('8537','2013-09-11','10:55:00',1.91),('8537','2013-09-11','11:00:00',1.67),('8537','2013-09-11','11:05:00',3.63),('8537','2013-09-11','11:10:00',4.26),('8537','2013-09-11','11:15:00',3.39),('8537','2013-09-11','11:20:00',4.71),('8537','2013-09-11','11:25:00',3.35),('8537','2013-09-11','11:35:00',3.48),('8537','2013-09-11','11:40:00',3.6),('8537','2013-09-11','11:45:00',4.75),('8537','2013-09-11','11:50:00',4.79),('8537','2013-09-11','11:55:00',3.8),('8537','2013-09-11','12:00:00',3.58),('8537','2013-09-11','12:05:00',4.29),('8537','2013-09-11','12:10:00',2.52),('8537','2013-09-11','12:15:00',2.54),('8537','2013-09-11','12:20:00',3.38),('8537','2013-09-11','12:25:00',2.46),('8537','2013-09-11','12:30:00',4.89),('8537','2013-09-11','12:35:00',3.15),('8537','2013-09-11','12:40:00',1.42),('8537','2013-09-11','12:45:00',3.66),('8537','2013-09-11','12:50:00',4.47),('8537','2013-09-11','12:55:00',1.21),('8537','2013-09-11','13:00:00',4.44),('8537','2013-09-11','13:05:00',3.74),('8537','2013-09-11','13:10:00',4.91),('8537','2013-09-11','13:15:00',5.13),('8537','2013-09-11','13:20:00',5.2),('8537','2013-09-11','13:25:00',4.37),('8537','2013-09-11','13:30:00',4.5),('8537','2013-09-11','13:35:00',2.4),('8537','2013-09-11','13:40:00',4.07),('8537','2013-09-11','13:45:00',3.14),('8537','2013-09-11','13:50:00',4.53),('8537','2013-09-11','13:55:00',2.95),('8537','2013-09-11','14:00:00',3.71),('8537','2013-09-11','14:05:00',4.89),('8537','2013-09-11','14:10:00',2.82),('8537','2013-09-11','14:15:00',4.39),('8537','2013-09-11','14:20:00',3.51),('8537','2013-09-11','14:25:00',4.47),('8537','2013-09-11','14:30:00',3.47),('8537','2013-09-11','14:35:00',3.72),('8537','2013-09-11','14:40:00',2.19),('8537','2013-09-11','14:45:00',3.95),('8537','2013-09-11','14:50:00',4.45),('8537','2013-09-11','14:55:00',2.88),('8537','2013-09-11','15:00:00',3.2),('8537','2013-09-11','15:05:00',4.15),('8537','2013-09-11','15:10:00',3.1),('8537','2013-09-11','15:15:00',4),('8537','2013-09-11','15:20:00',4.34),('8537','2013-09-11','15:25:00',2.58),('8537','2013-09-11','15:30:00',2.03),('8537','2013-09-11','15:35:00',1.14),('8537','2013-09-11','15:40:00',1.38),('8537','2013-09-11','15:45:00',3.03),('8537','2013-09-11','15:50:00',3.71),('8537','2013-09-11','15:55:00',3.19),('8537','2013-09-11','16:00:00',3.22),('8537','2013-09-11','16:05:00',2.99),('8537','2013-09-11','16:10:00',3.31),('8537','2013-09-11','16:15:00',3.21),('8537','2013-09-11','16:20:00',3.01),('8537','2013-09-11','16:25:00',2.06),('8537','2013-09-11','16:30:00',2.16),('8537','2013-09-11','16:35:00',1.59),('8537','2013-09-11','16:40:00',1.33),('8537','2013-09-11','16:45:00',2.67),('8537','2013-09-11','16:50:00',2.09),('8537','2013-09-11','16:55:00',1.69),('8537','2013-09-11','17:00:00',1.65),('8537','2013-09-11','17:05:00',2.07),('8537','2013-09-11','17:10:00',1.94),('8537','2013-09-11','17:15:00',1.79),('8537','2013-09-11','17:20:00',1.66),('8537','2013-09-11','17:25:00',1.56),('8537','2013-09-11','17:30:00',1.45),('8537','2013-09-11','17:35:00',1.36),('8537','2013-09-11','17:40:00',1.26),('8537','2013-09-11','17:45:00',1.01),('8537','2013-09-11','17:50:00',1.03),('8537','2013-09-10','08:15:00',1.04),('8537','2013-09-10','08:55:00',1.99),('8537','2013-09-10','09:00:00',2.17),('8537','2013-09-10','09:05:00',2.35),('8537','2013-09-10','09:10:00',2.8),('8537','2013-09-10','09:15:00',2.34),('8537','2013-09-10','09:20:00',1.86),('8537','2013-09-10','09:25:00',1.85),('8537','2013-09-10','09:30:00',3.05),('8537','2013-09-10','09:35:00',3.44),('8537','2013-09-10','09:40:00',1.92),('8537','2013-09-10','09:45:00',1.63),('8537','2013-09-10','09:50:00',1.47),('8537','2013-09-10','09:55:00',1.33),('8537','2013-09-10','10:20:00',1.07),('8537','2013-09-10','10:25:00',1.17),('8537','2013-09-10','10:30:00',1.19),('8537','2013-09-10','10:35:00',1.36),('8537','2013-09-10','10:40:00',1.77),('8537','2013-09-10','10:45:00',2.34),('8537','2013-09-10','10:50:00',1.5),('8537','2013-09-10','10:55:00',1.54),('8537','2013-09-10','11:00:00',1.83),('8537','2013-09-10','11:05:00',1.55),('8537','2013-09-10','11:10:00',1.65),('8537','2013-09-10','11:15:00',1.41),('8537','2013-09-10','11:20:00',1.54),('8537','2013-09-10','11:25:00',1.76),('8537','2013-09-10','11:30:00',1.3),('8537','2013-09-10','11:45:00',1.5),('8537','2013-09-10','11:50:00',1.5),('8537','2013-09-10','11:55:00',1.91),('8537','2013-09-10','12:00:00',1.56),('8537','2013-09-10','12:05:00',1.24),('8537','2013-09-10','12:10:00',1.17),('8537','2013-09-10','12:15:00',1.15),('8537','2013-09-10','12:20:00',1.21),('8537','2013-09-10','12:25:00',1.16),('8537','2013-09-10','12:30:00',1.03),('8537','2013-09-10','13:20:00',1.05),('8537','2013-09-10','13:25:00',1.24),('8537','2013-09-10','13:30:00',1.15),('8537','2013-09-10','13:35:00',1.23),('8537','2013-09-10','13:40:00',2.07),('8537','2013-09-10','13:45:00',3.3),('8537','2013-09-10','13:50:00',2.14),('8537','2013-09-10','13:55:00',1.83),('8537','2013-09-10','14:00:00',1.28),('8537','2013-09-10','14:05:00',1.52),('8537','2013-09-10','14:10:00',1.55),('8537','2013-09-10','14:15:00',1.88),('8537','2013-09-10','14:20:00',1.88),('8537','2013-09-10','14:25:00',2.57),('8537','2013-09-10','14:30:00',2.32),('8537','2013-09-10','14:35:00',1.74),('8537','2013-09-10','14:40:00',2.12),('8537','2013-09-10','14:45:00',2.18),('8537','2013-09-10','14:50:00',2.44),('8537','2013-09-10','14:55:00',2.21),('8537','2013-09-10','15:00:00',2.66),('8537','2013-09-10','15:05:00',2.68),('8537','2013-09-10','15:10:00',1.96),('8537','2013-09-10','15:15:00',1.87),('8537','2013-09-10','15:20:00',2.32),('8537','2013-09-10','15:25:00',2.06),('8537','2013-09-10','15:30:00',2.31),('8537','2013-09-10','15:35:00',2.08),('8537','2013-09-10','15:40:00',1.37),('8537','2013-09-10','15:45:00',1.21),('8537','2013-09-10','15:50:00',1.2),('8537','2013-09-10','15:55:00',1.18),('8537','2013-09-10','16:00:00',1.21),('8537','2013-09-10','16:05:00',1.35),('8537','2013-09-10','16:10:00',1.45),('8537','2013-09-10','16:15:00',1.66),('8537','2013-09-10','16:20:00',1.23),('8537','2013-09-10','16:25:00',1.13),('8537','2013-09-09','07:45:00',1.1),('8537','2013-09-09','07:50:00',1.16),('8537','2013-09-09','07:55:00',1.06),('8537','2013-09-09','08:45:00',1),('8537','2013-09-09','08:50:00',1.15),('8537','2013-09-09','08:55:00',1.37),('8537','2013-09-09','09:00:00',1.42),('8537','2013-09-09','09:05:00',1.27),('8537','2013-09-09','09:10:00',1.09),('8537','2013-09-09','09:35:00',1.28),('8537','2013-09-09','09:40:00',1.21),('8537','2013-09-09','10:00:00',1.6),('8537','2013-09-09','10:05:00',2.09),('8537','2013-09-09','10:10:00',2.09),('8537','2013-09-09','10:15:00',2.02),('8537','2013-09-09','10:20:00',1.64),('8537','2013-09-09','10:25:00',1.51),('8537','2013-09-09','10:30:00',1.81),('8537','2013-09-09','10:35:00',2.04),('8537','2013-09-09','10:40:00',2.04),('8537','2013-09-09','10:45:00',2.28),('8537','2013-09-09','10:50:00',3.02),('8537','2013-09-09','10:55:00',2.91),('8537','2013-09-09','11:00:00',3.09),('8537','2013-09-09','11:05:00',2.44),('8537','2013-09-09','11:10:00',2.12),('8537','2013-09-09','11:15:00',2.59),('8537','2013-09-09','11:20:00',2.98),('8537','2013-09-09','11:25:00',3.25),('8537','2013-09-09','11:30:00',2.58),('8537','2013-09-09','11:35:00',2.55),('8537','2013-09-09','11:40:00',3.84),('8537','2013-09-09','11:45:00',3.97),('8537','2013-09-09','11:50:00',3.83),('8537','2013-09-09','11:55:00',3.93),('8537','2013-09-09','12:00:00',3.17),('8537','2013-09-09','12:05:00',3.83),('8537','2013-09-09','12:10:00',2.95),('8537','2013-09-09','12:15:00',2.4),('8537','2013-09-09','12:20:00',2.18),('8537','2013-09-09','12:25:00',1.57),('8537','2013-09-09','12:30:00',1.34),('8537','2013-09-09','12:35:00',1.22),('8537','2013-09-09','12:40:00',1.62),('8537','2013-09-09','12:45:00',1.94),('8537','2013-09-09','12:50:00',1.49),('8537','2013-09-09','12:55:00',1.81),('8537','2013-09-09','13:00:00',1.87),('8537','2013-09-09','13:05:00',2.9),('8537','2013-09-09','13:10:00',3.25),('8537','2013-09-09','13:15:00',3.63),('8537','2013-09-09','13:20:00',2.35),('8537','2013-09-09','13:25:00',2.8),('8537','2013-09-09','13:30:00',3.32),('8537','2013-09-09','13:35:00',4.66),('8537','2013-09-09','13:40:00',3.88),('8537','2013-09-09','13:45:00',4.57),('8537','2013-09-09','13:50:00',4.71),('8537','2013-09-09','13:55:00',4.71),('8537','2013-09-09','14:00:00',4.33),('8537','2013-09-09','14:05:00',4.11),('8537','2013-09-09','14:10:00',4.07),('8537','2013-09-09','14:15:00',3.1),('8537','2013-09-09','14:20:00',2.4),('8537','2013-09-09','14:25:00',1.97),('8537','2013-09-09','14:30:00',2.11),('8537','2013-09-09','14:35:00',4.14),('8537','2013-09-09','14:40:00',3.73),('8537','2013-09-09','14:45:00',2.34),('8537','2013-09-09','14:50:00',3.07),('8537','2013-09-09','14:55:00',3.47),('8537','2013-09-09','15:00:00',3.01),('8537','2013-09-09','15:05:00',2.69),('8537','2013-09-09','15:10:00',3.35),('8537','2013-09-09','15:15:00',1.77),('8537','2013-09-09','15:20:00',2.36),('8537','2013-09-09','15:25:00',1.33),('8537','2013-09-09','15:30:00',3.35),('8537','2013-09-09','15:35:00',2.66),('8537','2013-09-09','15:40:00',2.39),('8537','2013-09-09','15:45:00',1.33),('8537','2013-09-09','15:50:00',1.38),('8537','2013-09-09','15:55:00',1.56),('8537','2013-09-09','16:00:00',1.77),('8537','2013-09-09','16:05:00',1.5),('8537','2013-09-09','16:10:00',1.84),('8537','2013-09-09','16:15:00',2.41),('8537','2013-09-09','16:20:00',2.04),('8537','2013-09-09','16:25:00',1.21),('8537','2013-09-09','16:30:00',1.22),('8537','2013-09-09','16:35:00',1.36),('8537','2013-09-09','16:40:00',1.51),('8537','2013-09-09','16:45:00',2.14),('8537','2013-09-09','17:00:00',1.08),('8537','2013-09-09','18:15:00',1.01),('8537','2014-04-12','08:15:00',1.04),('8537','2014-04-12','09:10:00',1.15),('8537','2014-04-12','09:15:00',1.58),('8537','2014-04-12','09:20:00',2.38),('8537','2014-04-12','09:25:00',2.8),('8537','2014-04-12','09:30:00',2.06),('8537','2014-04-12','09:35:00',1.71),('8537','2014-04-12','09:40:00',1.4),('8537','2014-04-12','09:45:00',1.34),('8537','2014-04-12','09:50:00',1.4),('8537','2014-04-12','09:55:00',1.39),('8537','2014-04-12','10:00:00',1.41),('8537','2014-04-12','10:05:00',1.46),('8537','2014-04-12','10:10:00',1.57),('8537','2014-04-12','10:15:00',1.75),('8537','2014-04-12','10:20:00',1.9),('8537','2014-04-12','10:25:00',2.21),('8537','2014-04-12','10:30:00',2.35),('8537','2014-04-12','10:35:00',2.83),('8537','2014-04-12','10:40:00',2.71),('8537','2014-04-12','10:45:00',2.91),('8537','2014-04-12','10:50:00',2.87),('8537','2014-04-12','10:55:00',2.13),('8537','2014-04-12','11:00:00',2.3),('8537','2014-04-12','11:05:00',3.48),('8537','2014-04-12','11:10:00',3.67),('8537','2014-04-12','11:15:00',4.96),('8537','2014-04-12','11:20:00',4.69),('8537','2014-04-12','11:25:00',4.3),('8537','2014-04-12','11:30:00',4.24),('8537','2014-04-12','11:35:00',4.64),('8537','2014-04-12','11:40:00',4.54),('8537','2014-04-12','11:45:00',4.65),('8537','2014-04-12','11:50:00',3.36),('8537','2014-04-12','11:55:00',2.47),('8537','2014-04-12','12:00:00',2.21),('8537','2014-04-12','12:05:00',2),('8537','2014-04-12','12:10:00',2.56),('8537','2014-04-12','12:15:00',2.01),('8537','2014-04-12','12:20:00',2.13),('8537','2014-04-12','12:25:00',3.75),('8537','2014-04-12','12:30:00',3.13),('8537','2014-04-12','12:35:00',2.94),('8537','2014-04-12','12:40:00',3.46),('8537','2014-04-12','12:45:00',3.58),('8537','2014-04-12','12:50:00',2.62),('8537','2014-04-12','12:55:00',2.21),('8537','2014-04-12','13:00:00',1.67),('8537','2014-04-12','13:05:00',2.03),('8537','2014-04-12','13:10:00',3.16),('8537','2014-04-12','13:15:00',4.28),('8537','2014-04-12','13:20:00',5.01),('8537','2014-04-12','13:25:00',5.07),('8537','2014-04-12','13:30:00',2.66),('8537','2014-04-12','13:35:00',3.23),('8537','2014-04-12','13:40:00',1.97),('8537','2014-04-12','13:45:00',1.92),('8537','2014-04-12','13:50:00',3.68),('8537','2014-04-12','13:55:00',1.73),('8537','2014-04-12','14:00:00',1.91),('8537','2014-04-12','14:05:00',4.09),('8537','2014-04-12','14:10:00',4.61),('8537','2014-04-12','14:15:00',4.51),('8537','2014-04-12','14:20:00',3.62),('8537','2014-04-12','14:25:00',4.64),('8537','2014-04-12','14:30:00',3.88),('8537','2014-04-12','14:35:00',2.75),('8537','2014-04-12','14:40:00',2.46),('8537','2014-04-12','14:45:00',3.11),('8537','2014-04-12','14:50:00',4.9),('8537','2014-04-12','14:55:00',4.18),('8537','2014-04-12','15:00:00',4.05),('8537','2014-04-12','15:05:00',4.13),('8537','2014-04-12','15:10:00',4.17),('8537','2014-04-12','15:15:00',4.18),('8537','2014-04-12','15:20:00',3.52),('8537','2014-04-12','15:25:00',3.11),('8537','2014-04-12','15:30:00',2.4),('8537','2014-04-12','15:35:00',2.92),('8537','2014-04-12','15:40:00',3.39),('8537','2014-04-12','15:45:00',3.55),('8537','2014-04-12','15:50:00',3.98),('8537','2014-04-12','15:55:00',3.86),('8537','2014-04-12','16:00:00',3.83),('8537','2014-04-12','16:05:00',3.64),('8537','2014-04-12','16:10:00',3.23),('8537','2014-04-12','16:15:00',3.46),('8537','2014-04-12','16:20:00',3.64),('8537','2014-04-12','16:25:00',3.28),('8537','2014-04-12','16:30:00',3.18),('8537','2014-04-12','16:35:00',2.93),('8537','2014-04-12','16:40:00',2.13),('8537','2014-04-12','16:45:00',2.21),('8537','2014-04-12','16:50:00',1.64),('8537','2014-04-12','16:55:00',2.26),('8537','2014-04-12','17:00:00',2.54),('8537','2014-04-12','17:05:00',2.18),('8537','2014-04-12','17:10:00',2.25),('8537','2014-04-12','17:15:00',2.13),('8537','2014-04-12','17:20:00',1.72),('8537','2014-04-12','17:25:00',1.79),('8537','2014-04-12','17:30:00',1.5),('8537','2014-04-12','17:35:00',1.27),('8537','2014-04-12','17:40:00',1.3),('8537','2014-04-12','17:45:00',1.65),('8537','2014-04-12','17:50:00',1.56),('8537','2014-04-12','17:55:00',1.32),('8537','2014-04-12','18:00:00',1.26),('8537','2013-09-08','08:50:00',1.04),('8537','2013-09-08','08:55:00',1),('8537','2013-09-08','09:00:00',1.36),('8537','2013-09-08','09:05:00',1.26),('8537','2013-09-08','09:10:00',1.24),('8537','2013-09-08','09:15:00',1.44),('8537','2013-09-08','09:20:00',1.44),('8537','2013-09-08','09:25:00',1.86),('8537','2013-09-08','09:30:00',2.44),('8537','2013-09-08','09:35:00',2.84),('8537','2013-09-08','09:40:00',2.83),('8537','2013-09-08','09:45:00',2.81),('8537','2013-09-08','09:50:00',2.87),('8537','2013-09-08','09:55:00',2.99),('8537','2013-09-08','10:00:00',3.1),('8537','2013-09-08','10:05:00',3.2),('8537','2013-09-08','10:10:00',3.23),('8537','2013-09-08','10:15:00',3.3),('8537','2013-09-08','10:20:00',3.16),('8537','2013-09-08','10:25:00',3.38),('8537','2013-09-08','10:30:00',3.45),('8537','2013-09-08','10:35:00',3.58),('8537','2013-09-08','10:40:00',3.63),('8537','2013-09-08','10:45:00',3.7),('8537','2013-09-08','10:50:00',3.73),('8537','2013-09-08','10:55:00',3.77),('8537','2013-09-08','11:00:00',3.83),('8537','2013-09-08','11:05:00',3.83),('8537','2013-09-08','11:10:00',3.85),('8537','2013-09-08','11:15:00',3.93),('8537','2013-09-08','11:20:00',4.01),('8537','2013-09-08','11:25:00',3.92),('8537','2013-09-08','11:30:00',4.01),('8537','2013-09-08','11:35:00',3.98),('8537','2013-09-08','11:40:00',4.07),('8537','2013-09-08','11:45:00',4.04),('8537','2013-09-08','11:50:00',4.05),('8537','2013-09-08','11:55:00',4.15),('8537','2013-09-08','12:00:00',4.04),('8537','2013-09-08','12:05:00',4.01),('8537','2013-09-08','12:10:00',4.04),('8537','2013-09-08','12:15:00',4.2),('8537','2013-09-08','12:20:00',4.26),('8537','2013-09-08','12:25:00',4.17),('8537','2013-09-08','12:30:00',4.25),('8537','2013-09-08','12:35:00',4.31),('8537','2013-09-08','12:40:00',4.14),('8537','2013-09-08','12:45:00',4.31),('8537','2013-09-08','12:50:00',4.26),('8537','2013-09-08','12:55:00',4.34),('8537','2013-09-08','13:00:00',4.33),('8537','2013-09-08','13:05:00',4.31),('8537','2013-09-08','13:10:00',4.3),('8537','2013-09-08','13:15:00',4.17),('8537','2013-09-08','13:20:00',4.18),('8537','2013-09-08','13:25:00',4.02),('8537','2013-09-08','13:30:00',3.83),('8537','2013-09-08','13:35:00',3.74),('8537','2013-09-08','13:40:00',2.91),('8537','2013-09-08','13:45:00',2.48),('8537','2013-09-08','13:50:00',3.12),('8537','2013-09-08','13:55:00',3.26),('8537','2013-09-08','14:00:00',3.88),('8537','2013-09-08','14:05:00',3.96),('8537','2013-09-08','14:10:00',4.29),('8537','2013-09-08','14:15:00',3.81),('8537','2013-09-08','14:20:00',4),('8537','2013-09-08','14:25:00',4.53),('8537','2013-09-08','14:30:00',3.83),('8537','2013-09-08','14:35:00',3.78),('8537','2013-09-08','14:40:00',4.04),('8537','2013-09-08','14:45:00',4.07),('8537','2013-09-08','14:50:00',4.03),('8537','2013-09-08','14:55:00',3.93),('8537','2013-09-08','15:00:00',3.93),('8537','2013-09-08','15:05:00',3.29),('8537','2013-09-08','15:10:00',2.16),('8537','2013-09-08','15:15:00',2.88),('8537','2013-09-08','15:20:00',3.56),('8537','2013-09-08','15:25:00',3.62),('8537','2013-09-08','15:30:00',3.71),('8537','2013-09-08','15:35:00',3.58),('8537','2013-09-08','15:40:00',3.34),('8537','2013-09-08','15:45:00',3.37),('8537','2013-09-08','15:50:00',3.38),('8537','2013-09-08','15:55:00',2.67),('8537','2013-09-08','16:00:00',2.68),('8537','2013-09-08','16:05:00',2.78),('8537','2013-09-08','16:10:00',2.59),('8537','2013-09-08','16:15:00',2.73),('8537','2013-09-08','16:20:00',2.62),('8537','2013-09-08','16:25:00',2.52),('8537','2013-09-08','16:30:00',2.45),('8537','2013-09-08','16:35:00',2.22),('8537','2013-09-08','16:40:00',2.05),('8537','2013-09-08','16:45:00',1.34),('8537','2013-09-08','16:50:00',1.38),('8537','2013-09-08','16:55:00',1.23),('8537','2013-09-08','17:00:00',1.38),('8537','2013-09-08','17:05:00',2.09),('8537','2013-09-08','17:10:00',1.99),('8537','2013-09-08','17:15:00',1.79),('8537','2013-09-08','17:20:00',1.53),('8537','2013-09-08','17:25:00',1.49),('8537','2013-09-08','17:30:00',1.36),('8537','2013-09-08','17:45:00',1.01),('8537','2013-09-08','17:50:00',1.01),('8537','2013-09-07','08:05:00',1.03),('8537','2013-09-07','08:10:00',1.14),('8537','2013-09-07','08:15:00',1.24),('8537','2013-09-07','08:20:00',1.34),('8537','2013-09-07','08:25:00',1.44),('8537','2013-09-07','08:30:00',1.55),('8537','2013-09-07','08:35:00',1.66),('8537','2013-09-07','08:40:00',1.76),('8537','2013-09-07','08:45:00',1.85),('8537','2013-09-07','08:50:00',1.95),('8537','2013-09-07','08:55:00',2.05),('8537','2013-09-07','09:00:00',2.12),('8537','2013-09-07','09:05:00',2.22),('8537','2013-09-07','09:10:00',2.35),('8537','2013-09-07','09:15:00',2.47),('8537','2013-09-07','09:20:00',2.54),('8537','2013-09-07','09:25:00',2.64),('8537','2013-09-07','09:30:00',2.73),('8537','2013-09-07','09:35:00',2.79),('8537','2013-09-07','09:40:00',2.87),('8537','2013-09-07','09:45:00',2.94),('8537','2013-09-07','09:50:00',3.03),('8537','2013-09-07','09:55:00',3.12),('8537','2013-09-07','10:00:00',3.19),('8537','2013-09-07','10:05:00',3.27),('8537','2013-09-07','10:10:00',3.33),('8537','2013-09-07','10:15:00',3.39),('8537','2013-09-07','10:20:00',3.45),('8537','2013-09-07','10:25:00',3.5),('8537','2013-09-07','10:30:00',3.55),('8537','2013-09-07','10:35:00',3.66),('8537','2013-09-07','10:40:00',3.69),('8537','2013-09-07','10:45:00',3.71),('8537','2013-09-07','10:50:00',3.78),('8537','2013-09-07','10:55:00',3.81),('8537','2013-09-07','11:00:00',3.85),('8537','2013-09-07','11:05:00',3.9),('8537','2013-09-07','11:10:00',3.96),('8537','2013-09-07','11:15:00',4.02),('8537','2013-09-07','11:20:00',4.09),('8537','2013-09-07','11:25:00',4.14),('8537','2013-09-07','11:30:00',4.19),('8537','2013-09-07','11:35:00',4.24),('8537','2013-09-07','11:40:00',4.25),('8537','2013-09-07','11:45:00',4.3),('8537','2013-09-07','11:50:00',4.33),('8537','2013-09-07','11:55:00',4.35),('8537','2013-09-07','12:00:00',4.33),('8537','2013-09-07','12:05:00',4.3),('8537','2013-09-07','12:10:00',4.42),('8537','2013-09-07','12:15:00',4.41),('8537','2013-09-07','12:20:00',4.43),('8537','2013-09-07','12:25:00',4.48),('8537','2013-09-07','12:30:00',4.48),('8537','2013-09-07','12:35:00',4.49),('8537','2013-09-07','12:40:00',4.45),('8537','2013-09-07','12:45:00',4.46),('8537','2013-09-07','12:50:00',4.47),('8537','2013-09-07','12:55:00',4.52),('8537','2013-09-07','13:00:00',4.49),('8537','2013-09-07','13:05:00',4.41),('8537','2013-09-07','13:10:00',4.4),('8537','2013-09-07','13:15:00',4.42),('8537','2013-09-07','13:20:00',4.48),('8537','2013-09-07','13:25:00',4.37),('8537','2013-09-07','13:30:00',4.47),('8537','2013-09-07','13:35:00',4.65),('8537','2013-09-07','13:40:00',4.58),('8537','2013-09-07','13:45:00',4.38),('8537','2013-09-07','13:50:00',4.46),('8537','2013-09-07','13:55:00',4.39),('8537','2013-09-07','14:00:00',3.17),('8537','2013-09-07','14:05:00',4.31),('8537','2013-09-07','14:10:00',4.43),('8537','2013-09-07','14:15:00',4.39),('8537','2013-09-07','14:20:00',4.28),('8537','2013-09-07','14:25:00',4.18),('8537','2013-09-07','14:30:00',3.92),('8537','2013-09-07','14:35:00',3.69),('8537','2013-09-07','14:40:00',4.01),('8537','2013-09-07','14:45:00',4.12),('8537','2013-09-07','14:50:00',4.06),('8537','2013-09-07','14:55:00',4.03),('8537','2013-09-07','15:00:00',4.01),('8537','2013-09-07','15:05:00',3.92),('8537','2013-09-07','15:10:00',3.81),('8537','2013-09-07','15:15:00',3.82),('8537','2013-09-07','15:20:00',3.54),('8537','2013-09-07','15:25:00',3.6),('8537','2013-09-07','15:30:00',3.61),('8537','2013-09-07','15:35:00',3.55),('8537','2013-09-07','15:40:00',3.44),('8537','2013-09-07','15:45:00',3.38),('8537','2013-09-07','15:50:00',3.33),('8537','2013-09-07','15:55:00',3.2),('8537','2013-09-07','16:00:00',2.88),('8537','2013-09-07','16:05:00',3.05),('8537','2013-09-07','16:10:00',2.98),('8537','2013-09-07','16:15:00',2.9),('8537','2013-09-07','16:20:00',2.81),('8537','2013-09-07','16:25:00',2.72),('8537','2013-09-07','16:30:00',2.56),('8537','2013-09-07','16:35:00',2.38),('8537','2013-09-07','16:40:00',2.45),('8537','2013-09-07','16:45:00',2.36),('8537','2013-09-07','16:50:00',2.22),('8537','2013-09-07','16:55:00',2.06),('8537','2013-09-07','17:00:00',2.03),('8537','2013-09-07','17:05:00',1.93),('8537','2013-09-07','17:10:00',1.83),('8537','2013-09-07','17:15:00',1.71),('8537','2013-09-07','17:20:00',1.6),('8537','2013-09-07','17:25:00',1.49),('8537','2013-09-07','17:30:00',1.39),('8537','2013-09-07','17:35:00',1.31),('8537','2013-09-07','17:40:00',1.22),('8537','2013-09-07','17:45:00',1.12),('8537','2013-09-07','17:50:00',1.03),('8537','2013-09-06','08:05:00',1.05),('8537','2013-09-06','08:10:00',1.15),('8537','2013-09-06','08:15:00',1.26),('8537','2013-09-06','08:20:00',1.37),('8537','2013-09-06','08:25:00',1.47),('8537','2013-09-06','08:30:00',1.57),('8537','2013-09-06','08:35:00',1.68),('8537','2013-09-06','08:40:00',1.8),('8537','2013-09-06','08:45:00',1.91),('8537','2013-09-06','08:50:00',1.99),('8537','2013-09-06','08:55:00',2.12),('8537','2013-09-06','09:00:00',2.21),('8537','2013-09-06','09:05:00',2.3),('8537','2013-09-06','09:10:00',2.4),('8537','2013-09-06','09:15:00',2.48),('8537','2013-09-06','09:20:00',2.57),('8537','2013-09-06','09:25:00',2.64),('8537','2013-09-06','09:30:00',2.72),('8537','2013-09-06','09:35:00',2.81),('8537','2013-09-06','09:40:00',2.89),('8537','2013-09-06','09:45:00',2.97),('8537','2013-09-06','09:50:00',3.06),('8537','2013-09-06','09:55:00',3.13),('8537','2013-09-06','10:00:00',3.23),('8537','2013-09-06','10:05:00',3.29),('8537','2013-09-06','10:10:00',3.35),('8537','2013-09-06','10:15:00',3.45),('8537','2013-09-06','10:20:00',3.5),('8537','2013-09-06','10:25:00',3.53),('8537','2013-09-06','10:30:00',3.63),('8537','2013-09-06','10:35:00',3.72),('8537','2013-09-06','10:40:00',3.77),('8537','2013-09-06','10:45:00',3.83),('8537','2013-09-06','10:50:00',3.84),('8537','2013-09-06','10:55:00',3.9),('8537','2013-09-06','11:00:00',3.98),('8537','2013-09-06','11:05:00',4.07),('8537','2013-09-06','11:10:00',4.06),('8537','2013-09-06','11:15:00',4.05),('8537','2013-09-06','11:20:00',4.11),('8537','2013-09-06','11:25:00',4.15),('8537','2013-09-06','11:30:00',4.17),('8537','2013-09-06','11:35:00',4.23),('8537','2013-09-06','11:40:00',4.25),('8537','2013-09-06','11:45:00',4.28),('8537','2013-09-06','11:50:00',4.29),('8537','2013-09-06','11:55:00',4.34),('8537','2013-09-06','12:00:00',4.36),('8537','2013-09-06','12:05:00',4.38),('8537','2013-09-06','12:10:00',4.42),('8537','2013-09-06','12:15:00',4.48),('8537','2013-09-06','12:20:00',4.5),('8537','2013-09-06','12:25:00',4.53),('8537','2013-09-06','12:30:00',4.57),('8537','2013-09-06','12:35:00',4.6),('8537','2013-09-06','12:40:00',4.53),('8537','2013-09-06','12:45:00',4.45),('8537','2013-09-06','12:50:00',4.44),('8537','2013-09-06','12:55:00',4.49),('8537','2013-09-06','13:00:00',4.59),('8537','2013-09-06','13:05:00',4.61),('8537','2013-09-06','13:10:00',4.57),('8537','2013-09-06','13:15:00',4.51),('8537','2013-09-06','13:20:00',4.51),('8537','2013-09-06','13:25:00',4.55),('8537','2013-09-06','13:30:00',4.46),('8537','2013-09-06','13:35:00',4.4),('8537','2013-09-06','13:40:00',4.38),('8537','2013-09-06','13:45:00',4.36),('8537','2013-09-06','13:50:00',4.34),('8537','2013-09-06','13:55:00',4.35),('8537','2013-09-06','14:00:00',4.28),('8537','2013-09-06','14:05:00',4.19),('8537','2013-09-06','14:10:00',4.21),('8537','2013-09-06','14:15:00',4.24),('8537','2013-09-06','14:20:00',4.21),('8537','2013-09-06','14:25:00',4.18),('8537','2013-09-06','14:30:00',3.96),('8537','2013-09-06','14:35:00',3.58),('8537','2013-09-06','14:40:00',3.89),('8537','2013-09-06','14:45:00',4.03),('8537','2013-09-06','14:50:00',4.07),('8537','2013-09-06','14:55:00',4.03),('8537','2013-09-06','15:00:00',3.93),('8537','2013-09-06','15:05:00',3.83),('8537','2013-09-06','15:10:00',3.82),('8537','2013-09-06','15:15:00',3.74),('8537','2013-09-06','15:20:00',3.53),('8537','2013-09-06','15:25:00',3.52),('8537','2013-09-06','15:30:00',3.51),('8537','2013-09-06','15:35:00',3.46),('8537','2013-09-06','15:40:00',3.4),('8537','2013-09-06','15:45:00',3.36),('8537','2013-09-06','15:50:00',3.29),('8537','2013-09-06','15:55:00',3.18),('8537','2013-09-06','16:00:00',2.86),('8537','2013-09-06','16:05:00',2.99),('8537','2013-09-06','16:10:00',2.9),('8537','2013-09-06','16:15:00',2.86),('8537','2013-09-06','16:20:00',2.8),('8537','2013-09-06','16:25:00',2.75),('8537','2013-09-06','16:30:00',2.67),('8537','2013-09-06','16:35:00',2.39),('8537','2013-09-06','16:40:00',2.47),('8537','2013-09-06','16:45:00',2.38),('8537','2013-09-06','16:50:00',2.26),('8537','2013-09-06','16:55:00',2.11),('8537','2013-09-06','17:00:00',2.05),('8537','2013-09-06','17:05:00',1.92),('8537','2013-09-06','17:10:00',1.86),('8537','2013-09-06','17:15:00',1.75),('8537','2013-09-06','17:20:00',1.64),('8537','2013-09-06','17:25:00',1.48),('8537','2013-09-06','17:30:00',1.39),('8537','2013-09-06','17:35:00',1.31),('8537','2013-09-06','17:40:00',1.23),('8537','2013-09-06','17:45:00',1.1),('8537','2013-09-05','08:00:00',1.05),('8537','2013-09-05','08:05:00',1.16),('8537','2013-09-05','08:10:00',1.27),('8537','2013-09-05','08:15:00',1.39),('8537','2013-09-05','08:20:00',1.51),('8537','2013-09-05','08:25:00',1.62),('8537','2013-09-05','08:30:00',1.73),('8537','2013-09-05','08:35:00',1.85),('8537','2013-09-05','08:40:00',1.96),('8537','2013-09-05','08:45:00',2.05),('8537','2013-09-05','08:50:00',2.17),('8537','2013-09-05','08:55:00',2.26),('8537','2013-09-05','09:00:00',2.35),('8537','2013-09-05','09:05:00',2.46),('8537','2013-09-05','09:10:00',2.56),('8537','2013-09-05','09:15:00',2.65),('8537','2013-09-05','09:20:00',2.75),('8537','2013-09-05','09:25:00',2.85),('8537','2013-09-05','09:30:00',2.93),('8537','2013-09-05','09:35:00',3.01),('8537','2013-09-05','09:40:00',3.08),('8537','2013-09-05','09:45:00',3.16),('8537','2013-09-05','09:50:00',3.25),('8537','2013-09-05','09:55:00',3.33),('8537','2013-09-05','10:00:00',3.4),('8537','2013-09-05','10:05:00',3.46),('8537','2013-09-05','10:10:00',3.54),('8537','2013-09-05','10:15:00',3.6),('8537','2013-09-05','10:20:00',3.64),('8537','2013-09-05','10:25:00',3.69),('8537','2013-09-05','10:30:00',3.75),('8537','2013-09-05','10:35:00',3.79),('8537','2013-09-05','10:40:00',3.84),('8537','2013-09-05','10:45:00',3.89),('8537','2013-09-05','10:50:00',3.94),('8537','2013-09-05','10:55:00',3.99),('8537','2013-09-05','11:00:00',4.03),('8537','2013-09-05','11:05:00',4.1),('8537','2013-09-05','11:10:00',4.17),('8537','2013-09-05','11:15:00',4.18),('8537','2013-09-05','11:20:00',4.24),('8537','2013-09-05','11:25:00',4.32),('8537','2013-09-05','11:30:00',4.26),('8537','2013-09-05','11:35:00',4.37),('8537','2013-09-05','11:40:00',4.31),('8537','2013-09-05','11:45:00',4.3),('8537','2013-09-05','11:50:00',4.46),('8537','2013-09-05','11:55:00',4.48),('8537','2013-09-05','12:00:00',4.49),('8537','2013-09-05','12:05:00',4.49),('8537','2013-09-05','12:10:00',4.55),('8537','2013-09-05','12:15:00',4.59),('8537','2013-09-05','12:20:00',4.63),('8537','2013-09-05','12:25:00',4.62),('8537','2013-09-05','12:30:00',4.61),('8537','2013-09-05','12:35:00',4.59),('8537','2013-09-05','12:40:00',4.58),('8537','2013-09-05','12:45:00',4.57),('8537','2013-09-05','12:50:00',4.59),('8537','2013-09-05','12:55:00',4.6),('8537','2013-09-05','13:00:00',4.6),('8537','2013-09-05','13:05:00',4.6),('8537','2013-09-05','13:10:00',4.57),('8537','2013-09-05','13:15:00',4.56),('8537','2013-09-05','13:20:00',4.58),('8537','2013-09-05','13:25:00',4.58),('8537','2013-09-05','13:30:00',4.57),('8537','2013-09-05','13:35:00',4.59),('8537','2013-09-05','13:40:00',4.61),('8537','2013-09-05','13:45:00',4.56),('8537','2013-09-05','13:50:00',4.5),('8537','2013-09-05','13:55:00',4.45),('8537','2013-09-05','14:00:00',4.44),('8537','2013-09-05','14:05:00',4.4),('8537','2013-09-05','14:10:00',4.42),('8537','2013-09-05','14:15:00',4.41),('8537','2013-09-05','14:20:00',4.35),('8537','2013-09-05','14:25:00',4.31),('8537','2013-09-05','14:30:00',4.17),('8537','2013-09-05','14:35:00',4),('8537','2013-09-05','14:40:00',4.11),('8537','2013-09-05','14:45:00',4.09),('8537','2013-09-05','14:50:00',3.98),('8537','2013-09-05','14:55:00',4.03),('8537','2013-09-05','15:00:00',4.03),('8537','2013-09-05','15:05:00',3.99),('8537','2013-09-05','15:10:00',3.93),('8537','2013-09-05','15:15:00',3.84),('8537','2013-09-05','15:20:00',3.71),('8537','2013-09-05','15:25:00',3.7),('8537','2013-09-05','15:30:00',3.62),('8537','2013-09-05','15:35:00',3.59),('8537','2013-09-05','15:40:00',3.52),('8537','2013-09-05','15:45:00',3.46),('8537','2013-09-05','15:50:00',3.39),('8537','2013-09-05','15:55:00',3.33),('8537','2013-09-05','16:00:00',3.02),('8537','2013-09-05','16:05:00',3.15),('8537','2013-09-05','16:10:00',3.12),('8537','2013-09-05','16:15:00',3.06),('8537','2013-09-05','16:20:00',2.99),('8537','2013-09-05','16:25:00',2.9),('8537','2013-09-05','16:30:00',2.82),('8537','2013-09-05','16:35:00',2.58),('8537','2013-09-05','16:40:00',2.7),('8537','2013-09-05','16:45:00',2.65),('8537','2013-09-05','16:50:00',2.29),('8537','2013-09-05','16:55:00',1.77),('8537','2013-09-05','17:00:00',1.4),('8537','2013-09-05','17:05:00',1.5),('8537','2013-09-05','17:10:00',1.51),('8537','2013-09-05','17:15:00',1.33),('8537','2013-09-05','17:20:00',1.48),('8537','2013-09-05','17:25:00',1.44),('8537','2013-09-05','17:30:00',1.43),('8537','2013-09-05','17:35:00',1.45),('8537','2013-09-05','17:40:00',1.54),('8537','2013-09-05','17:45:00',1.37),('8537','2013-09-05','17:50:00',1.2),('8537','2013-09-05','17:55:00',1.04),('8537','2013-09-04','08:00:00',1.03),('8537','2013-09-04','08:05:00',1.16),('8537','2013-09-04','08:10:00',1.27),('8537','2013-09-04','08:15:00',1.39),('8537','2013-09-04','08:20:00',1.5),('8537','2013-09-04','08:25:00',1.61),('8537','2013-09-04','08:30:00',1.72),('8537','2013-09-04','08:35:00',1.83),('8537','2013-09-04','08:40:00',1.94),('8537','2013-09-04','08:45:00',2.04),('8537','2013-09-04','08:50:00',2.16),('8537','2013-09-04','08:55:00',2.27),('8537','2013-09-04','09:00:00',2.37),('8537','2013-09-04','09:05:00',2.47),('8537','2013-09-04','09:10:00',2.59),('8537','2013-09-04','09:15:00',2.68),('8537','2013-09-04','09:20:00',2.8),('8537','2013-09-04','09:25:00',2.88),('8537','2013-09-04','09:30:00',2.99),('8537','2013-09-04','09:35:00',3.1),('8537','2013-09-04','09:40:00',3.19),('8537','2013-09-04','09:45:00',3.27),('8537','2013-09-04','09:50:00',3.34),('8537','2013-09-04','09:55:00',3.44),('8537','2013-09-04','10:00:00',3.54),('8537','2013-09-04','10:05:00',3.61),('8537','2013-09-04','10:10:00',3.68),('8537','2013-09-04','10:15:00',3.73),('8537','2013-09-04','10:20:00',3.8),('8537','2013-09-04','10:25:00',3.85),('8537','2013-09-04','10:30:00',3.91),('8537','2013-09-04','10:35:00',3.99),('8537','2013-09-04','10:40:00',4.03),('8537','2013-09-04','10:45:00',4.07),('8537','2013-09-04','10:50:00',4.13),('8537','2013-09-04','10:55:00',4.21),('8537','2013-09-04','11:00:00',4.26),('8537','2013-09-04','11:05:00',4.28),('8537','2013-09-04','11:10:00',4.37),('8537','2013-09-04','11:15:00',4.4),('8537','2013-09-04','11:20:00',4.44),('8537','2013-09-04','11:25:00',4.49),('8537','2013-09-04','11:30:00',4.51),('8537','2013-09-04','11:35:00',4.58),('8537','2013-09-04','11:40:00',4.61),('8537','2013-09-04','11:45:00',4.66),('8537','2013-09-04','11:50:00',4.7),('8537','2013-09-04','11:55:00',4.72),('8537','2013-09-04','12:00:00',4.75),('8537','2013-09-04','12:05:00',4.75),('8537','2013-09-04','12:10:00',4.77),('8537','2013-09-04','12:15:00',4.79),('8537','2013-09-04','12:20:00',4.8),('8537','2013-09-04','12:25:00',4.84),('8537','2013-09-04','12:30:00',4.86),('8537','2013-09-04','12:35:00',4.88),('8537','2013-09-04','12:40:00',4.89),('8537','2013-09-04','12:45:00',4.86),('8537','2013-09-04','12:50:00',4.84),('8537','2013-09-04','12:55:00',4.86),('8537','2013-09-04','13:00:00',4.86),('8537','2013-09-04','13:05:00',4.87),('8537','2013-09-04','13:10:00',4.86),('8537','2013-09-04','13:15:00',4.86),('8537','2013-09-04','13:20:00',4.86),('8537','2013-09-04','13:25:00',4.86),('8537','2013-09-04','13:30:00',4.84),('8537','2013-09-04','13:35:00',4.83),('8537','2013-09-04','13:40:00',4.8),('8537','2013-09-04','13:45:00',4.77),('8537','2013-09-04','13:50:00',4.76),('8537','2013-09-04','13:55:00',4.71),('8537','2013-09-04','14:00:00',4.68),('8537','2013-09-04','14:05:00',4.59),('8537','2013-09-04','14:10:00',4.66),('8537','2013-09-04','14:15:00',4.62),('8537','2013-09-04','14:20:00',4.54),('8537','2013-09-04','14:25:00',4.56),('8537','2013-09-04','14:30:00',4.4),('8537','2013-09-04','14:35:00',4.3),('8537','2013-09-04','14:40:00',4.4),('8537','2013-09-04','14:45:00',4.36),('8537','2013-09-04','14:50:00',4.31),('8537','2013-09-04','14:55:00',4.25),('8537','2013-09-04','15:00:00',4.21),('8537','2013-09-04','15:05:00',4.17),('8537','2013-09-04','15:10:00',4.11),('8537','2013-09-04','15:15:00',4.07),('8537','2013-09-04','15:20:00',3.96),('8537','2013-09-04','15:25:00',3.89),('8537','2013-09-04','15:30:00',3.82),('8537','2013-09-04','15:35:00',3.75),('8537','2013-09-04','15:40:00',3.69),('8537','2013-09-04','15:45:00',3.63),('8537','2013-09-04','15:50:00',3.54),('8537','2013-09-04','15:55:00',3.47),('8537','2013-09-04','16:00:00',3.18),('8537','2013-09-04','16:05:00',3.19),('8537','2013-09-04','16:10:00',3.18),('8537','2013-09-04','16:15:00',3.12),('8537','2013-09-04','16:20:00',3.03),('8537','2013-09-04','16:25:00',2.95),('8537','2013-09-04','16:30:00',2.89),('8537','2013-09-04','16:35:00',2.72),('8537','2013-09-04','16:40:00',2.66),('8537','2013-09-04','16:45:00',2.58),('8537','2013-09-04','16:50:00',2.48),('8537','2013-09-04','16:55:00',2.3),('8537','2013-09-04','17:00:00',2.2),('8537','2013-09-04','17:05:00',2.11),('8537','2013-09-04','17:10:00',2.03),('8537','2013-09-04','17:15:00',1.91),('8537','2013-09-04','17:20:00',1.81),('8537','2013-09-04','17:25:00',1.67),('8537','2013-09-04','17:30:00',1.58),('8537','2013-09-04','17:35:00',1.47),('8537','2013-09-04','17:40:00',1.37),('8537','2013-09-04','17:45:00',1.25),('8537','2013-09-04','17:50:00',1.16),('8537','2013-09-04','17:55:00',1.06),('8537','2013-09-03','08:05:00',1.05),('8537','2013-09-03','08:10:00',1.14),('8537','2013-09-03','08:15:00',1.25),('8537','2013-09-03','08:20:00',1.34),('8537','2013-09-03','08:25:00',1.44),('8537','2013-09-03','08:30:00',1.55),('8537','2013-09-03','08:35:00',1.65),('8537','2013-09-03','08:40:00',1.75),('8537','2013-09-03','08:45:00',1.86),('8537','2013-09-03','08:50:00',1.97),('8537','2013-09-03','08:55:00',2.09),('8537','2013-09-03','09:00:00',2.18),('8537','2013-09-03','09:05:00',2.28),('8537','2013-09-03','09:10:00',2.39),('8537','2013-09-03','09:15:00',2.47),('8537','2013-09-03','09:20:00',2.6),('8537','2013-09-03','09:25:00',2.7),('8537','2013-09-03','09:30:00',2.79),('8537','2013-09-03','09:35:00',2.87),('8537','2013-09-03','09:40:00',2.95),('8537','2013-09-03','09:45:00',3.03),('8537','2013-09-03','09:50:00',3.1),('8537','2013-09-03','09:55:00',3.17),('8537','2013-09-03','10:00:00',3.24),('8537','2013-09-03','10:05:00',3.31),('8537','2013-09-03','10:10:00',3.38),('8537','2013-09-03','10:15:00',3.48),('8537','2013-09-03','10:20:00',3.56),('8537','2013-09-03','10:25:00',3.63),('8537','2013-09-03','10:30:00',3.71),('8537','2013-09-03','10:35:00',3.82),('8537','2013-09-03','10:40:00',3.92),('8537','2013-09-03','10:45:00',3.98),('8537','2013-09-03','10:50:00',4.01),('8537','2013-09-03','10:55:00',4.04),('8537','2013-09-03','11:00:00',4.09),('8537','2013-09-03','11:05:00',4.08),('8537','2013-09-03','11:10:00',4.18),('8537','2013-09-03','11:15:00',4.22),('8537','2013-09-03','11:20:00',4.25),('8537','2013-09-03','11:25:00',4.32),('8537','2013-09-03','11:30:00',4.34),('8537','2013-09-03','11:35:00',4.37),('8537','2013-09-03','11:40:00',4.39),('8537','2013-09-03','11:45:00',4.43),('8537','2013-09-03','11:50:00',4.45),('8537','2013-09-03','11:55:00',4.51),('8537','2013-09-03','12:00:00',4.52),('8537','2013-09-03','12:05:00',4.56),('8537','2013-09-03','12:10:00',4.61),('8537','2013-09-03','12:15:00',4.64),('8537','2013-09-03','12:20:00',4.65),('8537','2013-09-03','12:25:00',4.71),('8537','2013-09-03','12:30:00',4.74),('8537','2013-09-03','12:35:00',4.74),('8537','2013-09-03','12:40:00',4.75),('8537','2013-09-03','12:45:00',4.78),('8537','2013-09-03','12:50:00',4.72),('8537','2013-09-03','12:55:00',4.73),('8537','2013-09-03','13:00:00',4.75),('8537','2013-09-03','13:05:00',4.79),('8537','2013-09-03','13:10:00',4.77),('8537','2013-09-03','13:15:00',4.75),('8537','2013-09-03','13:20:00',4.74),('8537','2013-09-03','13:25:00',4.67),('8537','2013-09-03','13:30:00',4.69),('8537','2013-09-03','13:35:00',4.7),('8537','2013-09-03','13:40:00',4.66),('8537','2013-09-03','13:45:00',4.7),('8537','2013-09-03','13:50:00',4.67),('8537','2013-09-03','13:55:00',4.63),('8537','2013-09-03','14:00:00',4.51),('8537','2013-09-03','14:05:00',4.41),('8537','2013-09-03','14:10:00',4.47),('8537','2013-09-03','14:15:00',4.48),('8537','2013-09-03','14:20:00',4.47),('8537','2013-09-03','14:25:00',4.44),('8537','2013-09-03','14:30:00',4.3),('8537','2013-09-03','14:35:00',4.16),('8537','2013-09-03','14:40:00',4.31),('8537','2013-09-03','14:45:00',4.29),('8537','2013-09-03','14:50:00',4.28),('8537','2013-09-03','14:55:00',4.23),('8537','2013-09-03','15:00:00',4.15),('8537','2013-09-03','15:05:00',4.02),('8537','2013-09-03','15:10:00',4.03),('8537','2013-09-03','15:15:00',4),('8537','2013-09-03','15:20:00',3.86),('8537','2013-09-03','15:25:00',3.81),('8537','2013-09-03','15:30:00',3.7),('8537','2013-09-03','15:35:00',3.63),('8537','2013-09-03','15:40:00',3.56),('8537','2013-09-03','15:45:00',3.52),('8537','2013-09-03','15:50:00',3.47),('8537','2013-09-03','15:55:00',3.42),('8537','2013-09-03','16:00:00',3.24),('8537','2013-09-03','16:05:00',3.08),('8537','2013-09-03','16:10:00',3.15),('8537','2013-09-03','16:15:00',3.08),('8537','2013-09-03','16:20:00',3.02),('8537','2013-09-03','16:25:00',2.93),('8537','2013-09-03','16:30:00',2.85),('8537','2013-09-03','16:35:00',2.72),('8537','2013-09-03','16:40:00',2.62),('8537','2013-09-03','16:45:00',2.54),('8537','2013-09-03','16:50:00',2.46),('8537','2013-09-03','16:55:00',2.35),('8537','2013-09-03','17:00:00',2.19),('8537','2013-09-03','17:05:00',2.12),('8537','2013-09-03','17:10:00',2.03),('8537','2013-09-03','17:15:00',1.92),('8537','2013-09-03','17:20:00',1.82),('8537','2013-09-03','17:25:00',1.69),('8537','2013-09-03','17:30:00',1.59),('8537','2013-09-03','17:35:00',1.49),('8537','2013-09-03','17:40:00',1.39),('8537','2013-09-03','17:45:00',1.28),('8537','2013-09-03','17:50:00',1.19),('8537','2013-09-03','17:55:00',1.1),('8537','2013-09-02','08:05:00',1.09),('8537','2013-09-02','08:10:00',1.19),('8537','2013-09-02','08:15:00',1.29),('8537','2013-09-02','08:20:00',1.4),('8537','2013-09-02','08:25:00',1.5),('8537','2013-09-02','08:30:00',1.6),('8537','2013-09-02','08:35:00',1.71),('8537','2013-09-02','08:40:00',1.82),('8537','2013-09-02','08:45:00',1.94),('8537','2013-09-02','08:50:00',2.04),('8537','2013-09-02','08:55:00',2.15),('8537','2013-09-02','09:00:00',2.25),('8537','2013-09-02','09:05:00',2.36),('8537','2013-09-02','09:10:00',2.45),('8537','2013-09-02','09:15:00',2.55),('8537','2013-09-02','09:20:00',2.65),('8537','2013-09-02','09:25:00',2.74),('8537','2013-09-02','09:30:00',2.83),('8537','2013-09-02','09:35:00',2.95),('8537','2013-09-02','09:40:00',3.02),('8537','2013-09-02','09:45:00',3.11),('8537','2013-09-02','09:50:00',3.2),('8537','2013-09-02','09:55:00',3.27),('8537','2013-09-02','10:00:00',3.35),('8537','2013-09-02','10:05:00',3.44),('8537','2013-09-02','10:10:00',3.52),('8537','2013-09-02','10:15:00',3.61),('8537','2013-09-02','10:20:00',3.66),('8537','2013-09-02','10:25:00',3.74),('8537','2013-09-02','10:30:00',3.8),('8537','2013-09-02','10:35:00',3.85),('8537','2013-09-02','10:40:00',3.89),('8537','2013-09-02','10:45:00',3.89),('8537','2013-09-02','10:50:00',3.98),('8537','2013-09-02','10:55:00',4.04),('8537','2013-09-02','11:00:00',4.07),('8537','2013-09-02','11:05:00',4.14),('8537','2013-09-02','11:10:00',4.15),('8537','2013-09-02','11:15:00',4.2),('8537','2013-09-02','11:20:00',4.26),('8537','2013-09-02','11:25:00',4.31),('8537','2013-09-02','11:30:00',4.33),('8537','2013-09-02','11:35:00',4.34),('8537','2013-09-02','11:40:00',4.38),('8537','2013-09-02','11:45:00',4.43),('8537','2013-09-02','11:50:00',4.44),('8537','2013-09-02','11:55:00',4.48),('8537','2013-09-02','12:00:00',4.47),('8537','2013-09-02','12:05:00',4.56),('8537','2013-09-02','12:10:00',4.64),('8537','2013-09-02','12:15:00',4.64),('8537','2013-09-02','12:20:00',4.62),('8537','2013-09-02','12:25:00',4.6),('8537','2013-09-02','12:30:00',4.53),('8537','2013-09-02','12:35:00',4.53),('8537','2013-09-02','12:40:00',4.63),('8537','2013-09-02','12:45:00',4.62),('8537','2013-09-02','12:50:00',4.6),('8537','2013-09-02','12:55:00',4.61),('8537','2013-09-02','13:00:00',4.64),('8537','2013-09-02','13:05:00',4.64),('8537','2013-09-02','13:10:00',4.63),('8537','2013-09-02','13:15:00',4.64),('8537','2013-09-02','13:20:00',4.63),('8537','2013-09-02','13:25:00',4.65),('8537','2013-09-02','13:30:00',4.59),('8537','2013-09-02','13:35:00',4.61),('8537','2013-09-02','13:40:00',4.61),('8537','2013-09-02','13:45:00',2.11),('8537','2013-09-02','13:55:00',2.51),('8537','2013-09-02','14:00:00',4.44),('8537','2013-09-02','14:05:00',4.61),('8537','2013-09-02','14:10:00',4.4),('8537','2013-09-02','14:15:00',4.58),('8537','2013-09-02','14:20:00',4.51),('8537','2013-09-02','14:25:00',4.48),('8537','2013-09-02','14:30:00',4.4),('8537','2013-09-02','14:35:00',4.23),('8537','2013-09-02','14:40:00',4.42),('8537','2013-09-02','14:45:00',4.4),('8537','2013-09-02','14:50:00',4.37),('8537','2013-09-02','14:55:00',2.42),('8537','2013-09-02','15:05:00',3.91),('8537','2013-09-02','15:10:00',4.07),('8537','2013-09-02','15:15:00',4.03),('8537','2013-09-02','15:20:00',2.33),('8537','2013-09-02','15:25:00',3.82),('8537','2013-09-02','15:30:00',2.03),('8537','2013-09-02','15:35:00',2.69),('8537','2013-09-02','15:40:00',3.62),('8537','2013-09-02','15:45:00',3.64),('8537','2013-09-02','15:50:00',3.56),('8537','2013-09-02','15:55:00',3.48),('8537','2013-09-02','16:00:00',3.31),('8537','2013-09-02','16:05:00',3.1),('8537','2013-09-02','16:10:00',3.13),('8537','2013-09-02','16:15:00',3.14),('8537','2013-09-02','16:20:00',3.09),('8537','2013-09-02','16:25:00',2.96),('8537','2013-09-02','16:30:00',2.87),('8537','2013-09-02','16:35:00',2.74),('8537','2013-09-02','16:40:00',2.37),('8537','2013-09-02','16:45:00',2.48),('8537','2013-09-02','16:50:00',2.36),('8537','2013-09-02','16:55:00',2.25),('8537','2013-09-02','17:00:00',2.06),('8537','2013-09-02','17:05:00',2.03),('8537','2013-09-02','17:10:00',1.93),('8537','2013-09-02','17:15:00',1.85),('8537','2013-09-02','17:20:00',1.73),('8537','2013-09-02','17:25:00',1.64),('8537','2013-09-02','17:30:00',1.51),('8537','2013-09-02','17:35:00',1.43),('8537','2013-09-02','17:40:00',1.33),('8537','2013-09-02','17:45:00',1.24),('8537','2013-09-02','17:50:00',1.13),('8537','2013-09-02','17:55:00',1.06),('8537','2013-09-01','08:00:00',1.06),('8537','2013-09-01','08:05:00',1.17),('8537','2013-09-01','08:10:00',1.28),('8537','2013-09-01','08:15:00',1.39),('8537','2013-09-01','08:20:00',1.49),('8537','2013-09-01','08:25:00',1.59),('8537','2013-09-01','08:30:00',1.59),('8537','2013-09-01','08:35:00',1.79),('8537','2013-09-01','08:40:00',1.92),('8537','2013-09-01','08:45:00',2.02),('8537','2013-09-01','08:50:00',2.12),('8537','2013-09-01','08:55:00',2.23),('8537','2013-09-01','09:00:00',2.31),('8537','2013-09-01','09:05:00',2.4),('8537','2013-09-01','09:10:00',2.51),('8537','2013-09-01','09:15:00',2.61),('8537','2013-09-01','09:20:00',2.71),('8537','2013-09-01','09:25:00',2.8),('8537','2013-09-01','09:30:00',2.9),('8537','2013-09-01','09:35:00',3),('8537','2013-09-01','09:40:00',3.08),('8537','2013-09-01','09:45:00',3.16),('8537','2013-09-01','09:50:00',3.26),('8537','2013-09-01','09:55:00',3.33),('8537','2013-09-01','10:00:00',3.41),('8537','2013-09-01','10:05:00',3.48),('8537','2013-09-01','10:10:00',3.56),('8537','2013-09-01','10:15:00',3.59),('8537','2013-09-01','10:20:00',3.65),('8537','2013-09-01','10:25:00',3.71),('8537','2013-09-01','10:30:00',3.79),('8537','2013-09-01','10:35:00',3.84),('8537','2013-09-01','10:40:00',3.9),('8537','2013-09-01','10:45:00',3.95),('8537','2013-09-01','10:50:00',3.96),('8537','2013-09-01','10:55:00',4.03),('8537','2013-09-01','11:00:00',4.14),('8537','2013-09-01','11:05:00',4.2),('8537','2013-09-01','11:10:00',4.22),('8537','2013-09-01','11:15:00',4.21),('8537','2013-09-01','11:20:00',4.24),('8537','2013-09-01','11:25:00',4.26),('8537','2013-09-01','11:30:00',4.25),('8537','2013-09-01','11:35:00',4.42),('8537','2013-09-01','11:40:00',4.52),('8537','2013-09-01','11:45:00',4.55),('8537','2013-09-01','11:50:00',4.55),('8537','2013-09-01','11:55:00',4.54),('8537','2013-09-01','12:00:00',4.56),('8537','2013-09-01','12:05:00',4.48),('8537','2013-09-01','12:10:00',4.61),('8537','2013-09-01','12:15:00',4.63),('8537','2013-09-01','12:20:00',4.65),('8537','2013-09-01','12:25:00',4.52),('8537','2013-09-01','12:30:00',4.64),('8537','2013-09-01','12:35:00',4.67),('8537','2013-09-01','12:40:00',4.69),('8537','2013-09-01','12:45:00',4.67),('8537','2013-09-01','12:50:00',4.69),('8537','2013-09-01','12:55:00',4.66),('8537','2013-09-01','13:00:00',4.76),('8537','2013-09-01','13:05:00',4.75),('8537','2013-09-01','13:10:00',4.73),('8537','2013-09-01','13:15:00',4.27),('8537','2013-09-01','13:20:00',4.8),('8537','2013-09-01','13:25:00',4.78),('8537','2013-09-01','13:30:00',4.79),('8537','2013-09-01','13:35:00',4.66),('8537','2013-09-01','13:40:00',4.66),('8537','2013-09-01','13:45:00',4.5),('8537','2013-09-01','13:50:00',4.05),('8537','2013-09-01','13:55:00',4.23),('8537','2013-09-01','14:00:00',3.72),('8537','2013-09-01','14:05:00',3.64),('8537','2013-09-01','14:10:00',4.24),('8537','2013-09-01','14:15:00',4.25),('8537','2013-09-01','14:20:00',3.9),('8537','2013-09-01','14:25:00',3.86),('8537','2013-09-01','14:30:00',3.98),('8537','2013-09-01','14:35:00',3.88),('8537','2013-09-01','14:40:00',3.89),('8537','2013-09-01','14:45:00',3.93),('8537','2013-09-01','14:50:00',3.94),('8537','2013-09-01','14:55:00',3.81),('8537','2013-09-01','15:00:00',3.78),('8537','2013-09-01','15:05:00',3.75),('8537','2013-09-01','15:10:00',3.7),('8537','2013-09-01','15:15:00',3.58),('8537','2013-09-01','15:20:00',3.4),('8537','2013-09-01','15:25:00',2.98),('8537','2013-09-01','15:30:00',2.5),('8537','2013-09-01','15:35:00',2.82),('8537','2013-09-01','15:40:00',3.21),('8537','2013-09-01','15:45:00',2.86),('8537','2013-09-01','15:50:00',2.18),('8537','2013-09-01','15:55:00',2.53),('8537','2013-09-01','16:00:00',3.01),('8537','2013-09-01','16:05:00',3.05),('8537','2013-09-01','16:10:00',3.18),('8537','2013-09-01','16:15:00',3.03),('8537','2013-09-01','16:20:00',2.78),('8537','2013-09-01','16:25:00',2.76),('8537','2013-09-01','16:30:00',3.02),('8537','2013-09-01','16:35:00',2.81),('8537','2013-09-01','16:40:00',2.63),('8537','2013-09-01','16:45:00',2.3),('8537','2013-09-01','16:50:00',2.41),('8537','2013-09-01','16:55:00',2.19),('8537','2013-09-01','17:00:00',1.74),('8537','2013-09-01','17:05:00',1.76),('8537','2013-09-01','17:10:00',1.53),('8537','2013-09-01','17:15:00',1.45),('8537','2013-09-01','17:20:00',1.58),('8537','2013-09-01','17:25:00',1.48),('8537','2013-09-01','17:30:00',1.34),('8537','2013-09-01','17:35:00',1.29),('8537','2013-09-01','17:40:00',1.34),('8537','2013-09-01','17:45:00',1.15),('8537','2013-09-01','17:50:00',1.04),('8537','2013-08-31','08:20:00',1.22),('8537','2013-08-31','08:25:00',1.44),('8537','2013-08-31','08:30:00',1.72),('8537','2013-08-31','08:35:00',1.82),('8537','2013-08-31','08:40:00',1.96),('8537','2013-08-31','08:45:00',2.11),('8537','2013-08-31','08:50:00',2.3),('8537','2013-08-31','08:55:00',2.49),('8537','2013-08-31','09:00:00',2.62),('8537','2013-08-31','09:05:00',2.4),('8537','2013-08-31','09:10:00',1.97),('8537','2013-08-31','09:15:00',2.4),('8537','2013-08-31','09:20:00',2.72),('8537','2013-08-31','09:25:00',2.98),('8537','2013-08-31','09:30:00',3.03),('8537','2013-08-31','09:35:00',3.16),('8537','2013-08-31','09:40:00',3.21),('8537','2013-08-31','09:45:00',3.05),('8537','2013-08-31','09:50:00',3.08),('8537','2013-08-31','09:55:00',3.32),('8537','2013-08-31','10:00:00',3.54),('8537','2013-08-31','10:05:00',3.56),('8537','2013-08-31','10:10:00',3.71),('8537','2013-08-31','10:15:00',3.72),('8537','2013-08-31','10:20:00',3.77),('8537','2013-08-31','10:25:00',3.83),('8537','2013-08-31','10:30:00',3.91),('8537','2013-08-31','10:35:00',4.01),('8537','2013-08-31','10:40:00',4.02),('8537','2013-08-31','10:45:00',4.11),('8537','2013-08-31','10:50:00',4.2),('8537','2013-08-31','10:55:00',4.24),('8537','2013-08-31','11:00:00',4.35),('8537','2013-08-31','11:05:00',4.39),('8537','2013-08-31','11:10:00',4.44),('8537','2013-08-31','11:15:00',4.48),('8537','2013-08-31','11:20:00',4.53),('8537','2013-08-31','11:25:00',4.57),('8537','2013-08-31','11:30:00',4.61),('8537','2013-08-31','11:35:00',4.67),('8537','2013-08-31','11:40:00',4.71),('8537','2013-08-31','11:45:00',4.74),('8537','2013-08-31','11:50:00',4.78),('8537','2013-08-31','11:55:00',4.8),('8537','2013-08-31','12:00:00',4.3),('8537','2013-08-31','12:05:00',3.31),('8537','2013-08-31','12:10:00',4.38),('8537','2013-08-31','12:15:00',4.62),('8537','2013-08-31','12:20:00',4.77),('8537','2013-08-31','12:25:00',4.78),('8537','2013-08-31','12:30:00',4.78),('8537','2013-08-31','12:35:00',4.79),('8537','2013-08-31','12:40:00',4.8),('8537','2013-08-31','12:45:00',4.81),('8537','2013-08-31','12:50:00',4.78),('8537','2013-08-31','12:55:00',4.83),('8537','2013-08-31','13:00:00',4.82),('8537','2013-08-31','13:05:00',4.85),('8537','2013-08-31','13:10:00',4.82),('8537','2013-08-31','13:15:00',4.8),('8537','2013-08-31','13:20:00',4.83),('8537','2013-08-31','13:25:00',4.8),('8537','2013-08-31','13:30:00',4.77),('8537','2013-08-31','13:35:00',4.76),('8537','2013-08-31','13:40:00',4.73),('8537','2013-08-31','13:45:00',4.71),('8537','2013-08-31','13:50:00',4.72),('8537','2013-08-31','13:55:00',4.66),('8537','2013-08-31','14:00:00',4.65),('8537','2013-08-31','14:05:00',4.63),('8537','2013-08-31','14:10:00',4.58),('8537','2013-08-31','14:15:00',4.55),('8537','2013-08-31','14:20:00',4.45),('8537','2013-08-31','14:25:00',4.42),('8537','2013-08-31','14:30:00',4.39),('8537','2013-08-31','14:35:00',3.91),('8537','2013-08-31','14:40:00',3.86),('8537','2013-08-31','14:45:00',4.18),('8537','2013-08-31','14:50:00',4.14),('8537','2013-08-31','14:55:00',4.02),('8537','2013-08-31','15:00:00',4.01),('8537','2013-08-31','15:05:00',4.03),('8537','2013-08-31','15:10:00',3.99),('8537','2013-08-31','15:15:00',3.92),('8537','2013-08-31','15:20:00',3.82),('8537','2013-08-31','15:25:00',3.61),('8537','2013-08-31','15:30:00',3.68),('8537','2013-08-31','15:35:00',3.56),('8537','2013-08-31','15:40:00',3.55),('8537','2013-08-31','15:45:00',3.52),('8537','2013-08-31','15:50:00',3.44),('8537','2013-08-31','15:55:00',3.36),('8537','2013-08-31','16:00:00',3.28),('8537','2013-08-31','16:05:00',3.17),('8537','2013-08-31','16:10:00',3.15),('8537','2013-08-31','16:15:00',3.08),('8537','2013-08-31','16:20:00',3.01),('8537','2013-08-31','16:25:00',2.91),('8537','2013-08-31','16:30:00',2.8),('8537','2013-08-31','16:35:00',2.8),('8537','2013-08-31','16:40:00',2.54),('8537','2013-08-31','16:45:00',2.5),('8537','2013-08-31','16:50:00',2.4),('8537','2013-08-31','16:55:00',2.33),('8537','2013-08-31','17:00:00',2.12),('8537','2013-08-31','17:05:00',2.12),('8537','2013-08-31','17:10:00',2.08),('8537','2013-08-31','17:15:00',1.95),('8537','2013-08-31','17:20:00',1.81),('8537','2013-08-31','17:25:00',1.71),('8537','2013-08-31','17:30:00',1.56),('8537','2013-08-31','17:35:00',1.43),('8537','2013-08-31','17:40:00',1.38),('8537','2013-08-31','17:45:00',1.25),('8537','2013-08-31','17:50:00',1.14),('8537','2013-08-31','17:55:00',1),('8537','2013-08-30','08:00:00',1.09),('8537','2013-08-30','08:05:00',1.33),('8537','2013-08-30','08:10:00',1.49),('8537','2013-08-30','08:15:00',1.44),('8537','2013-08-30','08:20:00',1.54),('8537','2013-08-30','08:25:00',1.6),('8537','2013-08-30','08:30:00',1.67),('8537','2013-08-30','08:35:00',1.76),('8537','2013-08-30','08:40:00',1.81),('8537','2013-08-30','08:45:00',1.63),('8537','2013-08-30','08:50:00',1.48),('8537','2013-08-30','08:55:00',1.48),('8537','2013-08-30','09:00:00',1.71),('8537','2013-08-30','09:05:00',1.88),('8537','2013-08-30','09:10:00',1.67),('8537','2013-08-30','09:15:00',1.56),('8537','2013-08-30','09:20:00',1.41),('8537','2013-08-30','09:25:00',1.5),('8537','2013-08-30','09:30:00',1.93),('8537','2013-08-30','09:35:00',2.16),('8537','2013-08-30','09:40:00',2.1),('8537','2013-08-30','09:45:00',2.15),('8537','2013-08-30','09:50:00',2.16),('8537','2013-08-30','09:55:00',2.26),('8537','2013-08-30','10:00:00',2.29),('8537','2013-08-30','10:05:00',2.27),('8537','2013-08-30','10:10:00',2.27),('8537','2013-08-30','10:15:00',2.42),('8537','2013-08-30','10:20:00',2.56),('8537','2013-08-30','10:25:00',2.35),('8537','2013-08-30','10:30:00',2.61),('8537','2013-08-30','10:35:00',2.5),('8537','2013-08-30','10:40:00',2.37),('8537','2013-08-30','10:45:00',2.3),('8537','2013-08-30','10:50:00',2.44),('8537','2013-08-30','10:55:00',2.33),('8537','2013-08-30','11:00:00',2.44),('8537','2013-08-30','11:05:00',2.59),('8537','2013-08-30','11:10:00',2.73),('8537','2013-08-30','11:15:00',2.76),('8537','2013-08-30','11:20:00',2.74),('8537','2013-08-30','11:25:00',2.87),('8537','2013-08-30','11:30:00',3.05),('8537','2013-08-30','11:35:00',2.9),('8537','2013-08-30','11:40:00',3.16),('8537','2013-08-30','11:45:00',3.09),('8537','2013-08-30','11:50:00',3.57),('8537','2013-08-30','11:55:00',3.14),('8537','2013-08-30','12:00:00',2.82),('8537','2013-08-30','12:05:00',2.4),('8537','2013-08-30','12:10:00',2.61),('8537','2013-08-30','12:15:00',2.87),('8537','2013-08-30','12:20:00',3.1),('8537','2013-08-30','12:25:00',3.53),('8537','2013-08-30','12:30:00',3.86),('8537','2013-08-30','12:35:00',3.72),('8537','2013-08-30','12:40:00',3.62),('8537','2013-08-30','12:45:00',3.74),('8537','2013-08-30','12:50:00',3.69),('8537','2013-08-30','12:55:00',3.43),('8537','2013-08-30','13:00:00',3.34),('8537','2013-08-30','13:05:00',3.25),('8537','2013-08-30','13:10:00',3.36),('8537','2013-08-30','13:15:00',3.22),('8537','2013-08-30','13:20:00',3.74),('8537','2013-08-30','13:25:00',4.43),('8537','2013-08-30','13:30:00',4.73),('8537','2013-08-30','13:35:00',4.41),('8537','2013-08-30','13:40:00',4.68),('8537','2013-08-30','13:45:00',4.21),('8537','2013-08-30','13:50:00',4.21),('8537','2013-08-30','13:55:00',4.6),('8537','2013-08-30','14:00:00',4.75),('8537','2013-08-30','14:05:00',4.58),('8537','2013-08-30','14:10:00',4.62),('8537','2013-08-30','14:15:00',4.54),('8537','2013-08-30','14:20:00',4.59),('8537','2013-08-30','14:25:00',4.51),('8537','2013-08-30','14:30:00',4.49),('8537','2013-08-30','14:35:00',4.33),('8537','2013-08-30','14:40:00',4.33),('8537','2013-08-30','14:45:00',3.57),('8537','2013-08-30','14:50:00',2.98),('8537','2013-08-30','14:55:00',3.41),('8537','2013-08-30','15:00:00',2.95),('8537','2013-08-30','15:05:00',2.7),('8537','2013-08-30','15:10:00',2.7),('8537','2013-08-30','15:15:00',3.31),('8537','2013-08-30','15:20:00',2.87),('8537','2013-08-30','15:25:00',2.56),('8537','2013-08-30','15:30:00',2.39),('8537','2013-08-30','15:35:00',1.99),('8537','2013-08-30','15:40:00',2.13),('8537','2013-08-30','15:45:00',2.49),('8537','2013-08-30','15:50:00',2.7),('8537','2013-08-30','15:55:00',2.67),('8537','2013-08-30','16:00:00',2.52),('8537','2013-08-30','16:05:00',2.2),('8537','2013-08-30','16:10:00',1.79),('8537','2013-08-30','16:15:00',1.64),('8537','2013-08-30','16:20:00',1.79),('8537','2013-08-30','16:25:00',1.82),('8537','2013-08-30','16:30:00',1.8),('8537','2013-08-30','16:35:00',1.66),('8537','2013-08-30','16:40:00',2.5),('8537','2013-08-30','16:45:00',2.43),('8537','2013-08-30','16:50:00',2.05),('8537','2013-08-30','16:55:00',1.53),('8537','2013-08-30','17:00:00',1.8),('8537','2013-08-30','17:05:00',1.44),('8537','2013-08-30','17:10:00',1.63),('8537','2013-08-30','17:15:00',1.5),('8537','2013-08-30','17:20:00',1.3),('8537','2013-08-30','17:25:00',1.26),('8537','2013-08-30','17:30:00',1.34),('8537','2013-08-30','17:35:00',1.31),('8537','2013-08-30','17:40:00',1.46),('8537','2013-08-30','17:45:00',1.43),('8537','2013-08-30','17:50:00',1.18),('8537','2013-08-30','17:55:00',1.32),('8537','2013-08-30','18:00:00',1.03),('8537','2014-04-11','07:50:00',1.02),('8537','2014-04-11','07:55:00',1.11),('8537','2014-04-11','08:30:00',1.27),('8537','2014-04-11','08:35:00',1.72),('8537','2014-04-11','08:40:00',2.14),('8537','2014-04-11','08:45:00',2.27),('8537','2014-04-11','08:50:00',2.34),('8537','2014-04-11','08:55:00',2.43),('8537','2014-04-11','09:00:00',2.49),('8537','2014-04-11','09:05:00',2.56),('8537','2014-04-11','09:10:00',2.61),('8537','2014-04-11','09:15:00',2.7),('8537','2014-04-11','09:20:00',2.84),('8537','2014-04-11','09:25:00',2.95),('8537','2014-04-11','09:30:00',3.03),('8537','2014-04-11','09:35:00',3.13),('8537','2014-04-11','09:40:00',3.2),('8537','2014-04-11','09:45:00',3.27),('8537','2014-04-11','09:50:00',3.36),('8537','2014-04-11','09:55:00',3.44),('8537','2014-04-11','10:00:00',3.54),('8537','2014-04-11','10:05:00',3.63),('8537','2014-04-11','10:10:00',3.78),('8537','2014-04-11','10:15:00',3.83),('8537','2014-04-11','10:20:00',3.9),('8537','2014-04-11','10:25:00',3.98),('8537','2014-04-11','10:30:00',4.04),('8537','2014-04-11','10:35:00',4.09),('8537','2014-04-11','10:40:00',4.13),('8537','2014-04-11','10:45:00',4.2),('8537','2014-04-11','10:50:00',4.31),('8537','2014-04-11','10:55:00',4.38),('8537','2014-04-11','11:00:00',4.45),('8537','2014-04-11','11:05:00',4.48),('8537','2014-04-11','11:10:00',4.51),('8537','2014-04-11','11:15:00',4.31),('8537','2014-04-11','11:20:00',4.66),('8537','2014-04-11','11:25:00',4.75),('8537','2014-04-11','11:30:00',4.75),('8537','2014-04-11','11:35:00',4.8),('8537','2014-04-11','11:40:00',4.7),('8537','2014-04-11','11:45:00',4.86),('8537','2014-04-11','11:50:00',4.86),('8537','2014-04-11','11:55:00',5),('8537','2014-04-11','12:00:00',5.18),('8537','2014-04-11','12:05:00',4.52),('8537','2014-04-11','12:10:00',5.29),('8537','2014-04-11','12:15:00',4.93),('8537','2014-04-11','12:20:00',5.06),('8537','2014-04-11','12:25:00',3.32),('8537','2014-04-11','12:30:00',5.21),('8537','2014-04-11','12:35:00',5.27),('8537','2014-04-11','12:40:00',5.41),('8537','2014-04-11','12:45:00',5.14),('8537','2014-04-11','12:50:00',4.96),('8537','2014-04-11','12:55:00',5.27),('8537','2014-04-11','13:00:00',4.93),('8537','2014-04-11','13:05:00',3.31),('8537','2014-04-11','13:10:00',3.63),('8537','2014-04-11','13:15:00',4.84),('8537','2014-04-11','13:20:00',2.9),('8537','2014-04-11','13:25:00',5.08),('8537','2014-04-11','13:30:00',3.79),('8537','2014-04-11','13:35:00',3.65),('8537','2014-04-11','13:40:00',3.8),('8537','2014-04-11','13:45:00',4.52),('8537','2014-04-11','13:50:00',4.37),('8537','2014-04-11','13:55:00',4.79),('8537','2014-04-11','14:00:00',4.43),('8537','2014-04-11','14:05:00',3.76),('8537','2014-04-11','14:10:00',3.8),('8537','2014-04-11','14:15:00',4),('8537','2014-04-11','14:20:00',3.29),('8537','2014-04-11','14:25:00',3.13),('8537','2014-04-11','14:30:00',5.16),('8537','2014-04-11','14:35:00',5.27),('8537','2014-04-11','14:40:00',4.69),('8537','2014-04-11','14:45:00',4.26),('8537','2014-04-11','14:50:00',4.68),('8537','2014-04-11','14:55:00',3.97),('8537','2014-04-11','15:00:00',3.91),('8537','2014-04-11','15:05:00',4.37),('8537','2014-04-11','15:10:00',4.18),('8537','2014-04-11','15:15:00',4.5),('8537','2014-04-11','15:20:00',3.72),('8537','2014-04-11','15:25:00',4.11),('8537','2014-04-11','15:30:00',4.19),('8537','2014-04-11','15:35:00',4.08),('8537','2014-04-11','15:40:00',4.03),('8537','2014-04-11','15:45:00',3.88),('8537','2014-04-11','15:50:00',3.84),('8537','2014-04-11','15:55:00',3.84),('8537','2014-04-11','16:00:00',3.69),('8537','2014-04-11','16:05:00',3.55),('8537','2014-04-11','16:10:00',3.49),('8537','2014-04-11','16:15:00',3.37),('8537','2014-04-11','16:20:00',3.27),('8537','2014-04-11','16:25:00',3.22),('8537','2014-04-11','16:30:00',3.15),('8537','2014-04-11','16:35:00',2.8),('8537','2014-04-11','16:40:00',2.53),('8537','2014-04-11','16:45:00',2.31),('8537','2014-04-11','16:50:00',2.19),('8537','2014-04-11','16:55:00',1.2),('8537','2014-04-11','17:00:00',1.92),('8537','2014-04-11','17:05:00',1.47),('8537','2014-04-11','17:10:00',1.71),('8537','2014-04-11','17:15:00',1.42),('8537','2014-04-11','17:20:00',1.58),('8537','2014-04-11','17:25:00',1.97),('8537','2014-04-11','17:30:00',1.91),('8537','2014-04-11','17:35:00',1.87),('8537','2014-04-11','17:40:00',1.77),('8537','2014-04-11','17:45:00',1.58),('8537','2014-04-11','17:50:00',1.41),('8537','2014-04-11','17:55:00',1.29),('8537','2014-04-11','18:00:00',1.17),('8537','2014-04-11','18:05:00',1.03),('8537','2013-08-29','07:55:00',1.02),('8537','2013-08-29','08:00:00',1.15),('8537','2013-08-29','08:05:00',1.25),('8537','2013-08-29','08:10:00',1.39),('8537','2013-08-29','08:15:00',1.54),('8537','2013-08-29','08:20:00',1.73),('8537','2013-08-29','08:25:00',1.96),('8537','2013-08-29','08:30:00',2.21),('8537','2013-08-29','08:35:00',2.15),('8537','2013-08-29','08:40:00',1.65),('8537','2013-08-29','08:45:00',1.27),('8537','2013-08-29','08:50:00',1.47),('8537','2013-08-29','08:55:00',1.95),('8537','2013-08-29','09:00:00',1.91),('8537','2013-08-29','09:05:00',1.86),('8537','2013-08-29','09:10:00',1.79),('8537','2013-08-29','09:15:00',1.96),('8537','2013-08-29','09:20:00',1.94),('8537','2013-08-29','09:25:00',1.77),('8537','2013-08-29','09:30:00',1.83),('8537','2013-08-29','09:35:00',2),('8537','2013-08-29','09:40:00',2.04),('8537','2013-08-29','09:45:00',1.78),('8537','2013-08-29','09:50:00',1.72),('8537','2013-08-29','09:55:00',1.79),('8537','2013-08-29','10:00:00',1.91),('8537','2013-08-29','10:05:00',1.81),('8537','2013-08-29','10:10:00',1.77),('8537','2013-08-29','10:15:00',1.76),('8537','2013-08-29','10:20:00',1.78),('8537','2013-08-29','10:25:00',1.77),('8537','2013-08-29','10:30:00',1.83),('8537','2013-08-29','10:35:00',1.72),('8537','2013-08-29','10:40:00',1.59),('8537','2013-08-29','10:45:00',1.47),('8537','2013-08-29','10:50:00',1.45),('8537','2013-08-29','10:55:00',1.6),('8537','2013-08-29','11:00:00',1.71),('8537','2013-08-29','11:05:00',1.72),('8537','2013-08-29','11:10:00',2.55),('8537','2013-08-29','11:15:00',3.12),('8537','2013-08-29','11:20:00',2.91),('8537','2013-08-29','11:25:00',2.15),('8537','2013-08-29','11:30:00',1.85),('8537','2013-08-29','11:35:00',1.62),('8537','2013-08-29','11:40:00',1.8),('8537','2013-08-29','11:45:00',2.12),('8537','2013-08-29','11:50:00',2.22),('8537','2013-08-29','11:55:00',2.13),('8537','2013-08-29','12:00:00',2.13),('8537','2013-08-29','12:05:00',2.47),('8537','2013-08-29','12:10:00',2.98),('8537','2013-08-29','12:15:00',3.64),('8537','2013-08-29','12:20:00',3.12),('8537','2013-08-29','12:25:00',3.18),('8537','2013-08-29','12:30:00',3.19),('8537','2013-08-29','12:35:00',3.78),('8537','2013-08-29','12:40:00',5.22),('8537','2013-08-29','12:45:00',5.27),('8537','2013-08-29','12:50:00',3.14),('8537','2013-08-29','12:55:00',4.36),('8537','2013-08-29','13:00:00',3.43),('8537','2013-08-29','13:05:00',2.99),('8537','2013-08-29','13:10:00',2.95),('8537','2013-08-29','13:15:00',2.83),('8537','2013-08-29','13:20:00',2.77),('8537','2013-08-29','13:25:00',2.4),('8537','2013-08-29','13:30:00',2.18),('8537','2013-08-29','13:35:00',2.03),('8537','2013-08-29','13:40:00',1.92),('8537','2013-08-29','13:45:00',1.8),('8537','2013-08-29','13:50:00',1.76),('8537','2013-08-29','13:55:00',2.02),('8537','2013-08-29','14:00:00',2.78),('8537','2013-08-29','14:05:00',2.01),('8537','2013-08-29','14:10:00',1.81),('8537','2013-08-29','14:15:00',1.54),('8537','2013-08-29','14:20:00',1.23),('8537','2013-08-29','14:25:00',1.09),('8537','2013-08-29','14:30:00',1.01),('8537','2013-08-29','14:35:00',1.01),('8537','2013-08-29','14:40:00',1.03),('8537','2013-08-29','14:45:00',1.13),('8537','2013-08-29','14:50:00',1.31),('8537','2013-08-29','14:55:00',1.55),('8537','2013-08-29','15:00:00',1.73),('8537','2013-08-29','15:05:00',1.91),('8537','2013-08-29','15:10:00',1.56),('8537','2013-08-29','15:15:00',1.36),('8537','2013-08-29','15:20:00',1.45),('8537','2013-08-29','15:25:00',1.66),('8537','2013-08-29','15:30:00',2.34),('8537','2013-08-29','15:35:00',2.45),('8537','2013-08-29','15:40:00',2.26),('8537','2013-08-29','15:45:00',2.74),('8537','2013-08-29','15:50:00',3.33),('8537','2013-08-29','15:55:00',3.54),('8537','2013-08-29','16:00:00',3.59),('8537','2013-08-29','16:05:00',3.76),('8537','2013-08-29','16:10:00',3.31),('8537','2013-08-29','16:15:00',3.34),('8537','2013-08-29','16:20:00',3.21),('8537','2013-08-29','16:25:00',3.06),('8537','2013-08-29','16:30:00',2.91),('8537','2013-08-29','16:35:00',2.89),('8537','2013-08-29','16:40:00',2.67),('8537','2013-08-29','16:45:00',2.64),('8537','2013-08-29','16:50:00',2.58),('8537','2013-08-29','16:55:00',2.49),('8537','2013-08-29','17:00:00',2.35),('8537','2013-08-29','17:05:00',2.18),('8537','2013-08-29','17:10:00',2.16),('8537','2013-08-29','17:15:00',2.06),('8537','2013-08-29','17:20:00',1.94),('8537','2013-08-29','17:25:00',1.83),('8537','2013-08-29','17:30:00',1.7),('8537','2013-08-29','17:35:00',1.6),('8537','2013-08-29','17:40:00',1.49),('8537','2013-08-29','17:45:00',1.37),('8537','2013-08-29','17:50:00',1.27),('8537','2013-08-29','17:55:00',1.17),('8537','2013-08-29','18:00:00',1.09),('8537','2013-08-28','07:55:00',1),('8537','2013-08-28','08:00:00',1.13),('8537','2013-08-28','08:05:00',1.21),('8537','2013-08-28','08:10:00',1.3),('8537','2013-08-28','08:15:00',1.41),('8537','2013-08-28','08:20:00',1.5),('8537','2013-08-28','08:25:00',1.59),('8537','2013-08-28','08:30:00',1.68),('8537','2013-08-28','08:35:00',1.91),('8537','2013-08-28','08:40:00',1.49),('8537','2013-08-28','08:45:00',1.5),('8537','2013-08-28','08:50:00',1.62),('8537','2013-08-28','08:55:00',1.07),('8537','2013-08-28','09:00:00',2.22),('8537','2013-08-28','09:05:00',1.72),('8537','2013-08-28','09:10:00',1.49),('8537','2013-08-28','09:15:00',1.93),('8537','2013-08-28','09:20:00',1.6),('8537','2013-08-28','09:30:00',1.22),('8537','2013-08-28','09:35:00',2.83),('8537','2013-08-28','09:40:00',3.02),('8537','2013-08-28','09:45:00',3.22),('8537','2013-08-28','09:50:00',3.3),('8537','2013-08-28','09:55:00',3.33),('8537','2013-08-28','10:00:00',3.37),('8537','2013-08-28','10:05:00',3.43),('8537','2013-08-28','10:10:00',3.6),('8537','2013-08-28','10:15:00',3.66),('8537','2013-08-28','10:20:00',4.01),('8537','2013-08-28','10:25:00',2.91),('8537','2013-08-28','10:30:00',2.71),('8537','2013-08-28','10:35:00',2.24),('8537','2013-08-28','10:40:00',2.27),('8537','2013-08-28','10:45:00',3.7),('8537','2013-08-28','10:50:00',4.19),('8537','2013-08-28','10:55:00',4.11),('8537','2013-08-28','11:00:00',2.64),('8537','2013-08-28','11:05:00',2.91),('8537','2013-08-28','11:10:00',3.97),('8537','2013-08-28','11:15:00',3.03),('8537','2013-08-28','11:20:00',4.73),('8537','2013-08-28','11:25:00',4.62),('8537','2013-08-28','11:30:00',4.68),('8537','2013-08-28','11:35:00',4.73),('8537','2013-08-28','11:40:00',4.91),('8537','2013-08-28','11:45:00',3.73),('8537','2013-08-28','11:50:00',2.91),('8537','2013-08-28','11:55:00',3.75),('8537','2013-08-28','12:00:00',1.97),('8537','2013-08-28','12:05:00',4.47),('8537','2013-08-28','12:10:00',4.93),('8537','2013-08-28','12:15:00',3.38),('8537','2013-08-28','12:20:00',4.96),('8537','2013-08-28','12:25:00',4.91),('8537','2013-08-28','12:30:00',4.88),('8537','2013-08-28','12:35:00',4.85),('8537','2013-08-28','12:40:00',4.88),('8537','2013-08-28','12:45:00',5.03),('8537','2013-08-28','12:50:00',4.98),('8537','2013-08-28','12:55:00',4.92),('8537','2013-08-28','13:00:00',5.02),('8537','2013-08-28','13:05:00',4.54),('8537','2013-08-28','13:10:00',5.12),('8537','2013-08-28','13:15:00',5.06),('8537','2013-08-28','13:20:00',4.95),('8537','2013-08-28','13:25:00',4.97),('8537','2013-08-28','13:30:00',4.97),('8537','2013-08-28','13:35:00',4.93),('8537','2013-08-28','13:40:00',4.88),('8537','2013-08-28','13:45:00',4.71),('8537','2013-08-28','13:50:00',4.6),('8537','2013-08-28','13:55:00',3.53),('8537','2013-08-28','14:00:00',4.84),('8537','2013-08-28','14:05:00',4.79),('8537','2013-08-28','14:10:00',4.85),('8537','2013-08-28','14:15:00',4.85),('8537','2013-08-28','14:20:00',4.75),('8537','2013-08-28','14:25:00',4.72),('8537','2013-08-28','14:30:00',3.8),('8537','2013-08-28','14:35:00',3.81),('8537','2013-08-28','14:40:00',4.63),('8537','2013-08-28','14:45:00',4.53),('8537','2013-08-28','14:50:00',4.48),('8537','2013-08-28','14:55:00',4.42),('8537','2013-08-28','15:00:00',4.37),('8537','2013-08-28','15:05:00',4.06),('8537','2013-08-28','15:10:00',4.39),('8537','2013-08-28','15:15:00',4.31),('8537','2013-08-28','15:20:00',4.26),('8537','2013-08-28','15:25:00',3.93),('8537','2013-08-28','15:30:00',2.3),('8537','2013-08-28','15:35:00',4.08),('8537','2013-08-28','15:40:00',2.46),('8537','2013-08-28','15:45:00',1.93),('8537','2013-08-28','15:50:00',1.88),('8537','2013-08-28','15:55:00',2.48),('8537','2013-08-28','16:00:00',3.95),('8537','2013-08-28','16:05:00',2.94),('8537','2013-08-28','16:10:00',3.58),('8537','2013-08-28','16:15:00',2.78),('8537','2013-08-28','16:20:00',1.56),('8537','2013-08-28','16:25:00',3.46),('8537','2013-08-28','16:30:00',3.18),('8537','2013-08-28','16:35:00',3.07),('8537','2013-08-28','16:40:00',2.92),('8537','2013-08-28','16:45:00',2.3),('8537','2013-08-28','16:50:00',2.55),('8537','2013-08-28','16:55:00',2.25),('8537','2013-08-28','17:00:00',2.52),('8537','2013-08-28','17:05:00',2.3),('8537','2013-08-28','17:10:00',1.64),('8537','2013-08-28','17:15:00',2.09),('8537','2013-08-28','17:20:00',1.13),('8537','2013-08-28','17:25:00',1.62),('8537','2013-08-28','17:30:00',1.07),('8537','2013-08-28','17:35:00',1.4),('8537','2013-08-28','17:40:00',1.25),('8537','2013-08-28','17:45:00',1.16),('8537','2013-08-27','08:20:00',1.34),('8537','2013-08-27','08:25:00',1.77),('8537','2013-08-27','08:30:00',1.79),('8537','2013-08-27','08:35:00',1.27),('8537','2013-08-27','08:40:00',1.18),('8537','2013-08-27','08:45:00',1.46),('8537','2013-08-27','08:50:00',1.08),('8537','2013-08-27','09:00:00',1.16),('8537','2013-08-27','09:05:00',1.24),('8537','2013-08-27','09:10:00',1.25),('8537','2013-08-27','09:15:00',1.6),('8537','2013-08-27','09:20:00',1.84),('8537','2013-08-27','09:25:00',2.43),('8537','2013-08-27','09:30:00',2.66),('8537','2013-08-27','09:35:00',1.6),('8537','2013-08-27','09:40:00',1.22),('8537','2013-08-27','09:45:00',1.26),('8537','2013-08-27','09:50:00',1.32),('8537','2013-08-27','09:55:00',1.72),('8537','2013-08-27','10:00:00',2.26),('8537','2013-08-27','10:05:00',2.77),('8537','2013-08-27','10:10:00',3.39),('8537','2013-08-27','10:15:00',3.48),('8537','2013-08-27','10:20:00',3.63),('8537','2013-08-27','10:25:00',3.66),('8537','2013-08-27','10:30:00',3.73),('8537','2013-08-27','10:35:00',3.78),('8537','2013-08-27','10:40:00',3.76),('8537','2013-08-27','10:45:00',3.89),('8537','2013-08-27','10:50:00',3.95),('8537','2013-08-27','10:55:00',3.97),('8537','2013-08-27','11:00:00',4.01),('8537','2013-08-27','11:05:00',4.14),('8537','2013-08-27','11:10:00',4.12),('8537','2013-08-27','11:15:00',4.21),('8537','2013-08-27','11:20:00',4.17),('8537','2013-08-27','11:25:00',4.17),('8537','2013-08-27','11:30:00',4.17),('8537','2013-08-27','11:35:00',4.28),('8537','2013-08-27','11:40:00',4.15),('8537','2013-08-27','11:45:00',5.06),('8537','2013-08-27','11:50:00',3.94),('8537','2013-08-27','11:55:00',4.55),('8537','2013-08-27','12:00:00',4.85),('8537','2013-08-27','12:05:00',4.51),('8537','2013-08-27','12:10:00',3.75),('8537','2013-08-27','12:15:00',4.16),('8537','2013-08-27','12:20:00',4.52),('8537','2013-08-27','12:25:00',4.45),('8537','2013-08-27','12:30:00',4.52),('8537','2013-08-27','12:35:00',5.04),('8537','2013-08-27','12:40:00',4.29),('8537','2013-08-27','12:45:00',3.67),('8537','2013-08-27','12:50:00',2.91),('8537','2013-08-27','12:55:00',2.66),('8537','2013-08-27','13:00:00',1.7),('8537','2013-08-27','13:05:00',2.06),('8537','2013-08-27','13:10:00',2.92),('8537','2013-08-27','13:15:00',2.41),('8537','2013-08-27','13:20:00',2.25),('8537','2013-08-27','13:25:00',2.26),('8537','2013-08-27','13:30:00',2.81),('8537','2013-08-27','13:35:00',2.24),('8537','2013-08-27','13:40:00',2.48),('8537','2013-08-27','13:45:00',3.19),('8537','2013-08-27','13:50:00',4.7),('8537','2013-08-27','13:55:00',3.78),('8537','2013-08-27','14:00:00',4.99),('8537','2013-08-27','14:05:00',2.98),('8537','2013-08-27','14:10:00',2.28),('8537','2013-08-27','14:15:00',3.7),('8537','2013-08-27','14:20:00',2.8),('8537','2013-08-27','14:25:00',1.59),('8537','2013-08-27','14:30:00',1.28),('8537','2013-08-27','14:35:00',1.31),('8537','2013-08-27','14:40:00',1.4),('8537','2013-08-27','14:45:00',1.48),('8537','2013-08-27','14:50:00',1.16),('8537','2013-08-27','15:55:00',1.26),('8537','2013-08-27','16:00:00',1.6),('8537','2013-08-27','16:05:00',1.66),('8537','2013-08-27','16:10:00',3.51),('8537','2013-08-27','16:15:00',3.07),('8537','2013-08-27','16:20:00',2.04),('8537','2013-08-27','16:25:00',1.95),('8537','2013-08-27','16:30:00',1.2),('8537','2013-08-27','16:35:00',1.32),('8537','2013-08-27','16:40:00',1.41),('8537','2013-08-27','16:45:00',1.12),('8537','2013-08-27','16:50:00',1.52),('8537','2013-08-27','16:55:00',1.17),('8537','2013-08-27','17:05:00',1.06),('8537','2013-08-27','17:10:00',2.62),('8537','2013-08-27','17:15:00',1.5),('8537','2013-08-27','17:20:00',1.03),('8537','2013-08-27','17:45:00',1.23),('8537','2013-08-27','17:50:00',1.27),('8537','2013-08-27','17:55:00',1.36),('8537','2013-08-27','18:00:00',1.07),('8537','2013-08-26','08:05:00',1.54),('8537','2013-08-26','08:10:00',1.53),('8537','2013-08-26','08:20:00',1.78),('8537','2013-08-26','08:25:00',1.55),('8537','2013-08-26','08:30:00',1.84),('8537','2013-08-26','08:35:00',1.4),('8537','2013-08-26','08:40:00',1.91),('8537','2013-08-26','08:45:00',2.03),('8537','2013-08-26','08:50:00',2.13),('8537','2013-08-26','08:55:00',2.24),('8537','2013-08-26','09:00:00',2.33),('8537','2013-08-26','09:05:00',2.41),('8537','2013-08-26','09:10:00',2.48),('8537','2013-08-26','09:15:00',2.6),('8537','2013-08-26','09:20:00',2.7),('8537','2013-08-26','09:25:00',2.78),('8537','2013-08-26','09:30:00',2.88),('8537','2013-08-26','09:35:00',2.93),('8537','2013-08-26','09:40:00',3.02),('8537','2013-08-26','09:45:00',3.1),('8537','2013-08-26','09:50:00',3.18),('8537','2013-08-26','09:55:00',3.22),('8537','2013-08-26','10:00:00',3.31),('8537','2013-08-26','10:05:00',3.4),('8537','2013-08-26','10:10:00',3.44),('8537','2013-08-26','10:15:00',3.52),('8537','2013-08-26','10:20:00',3.57),('8537','2013-08-26','10:25:00',3.68),('8537','2013-08-26','10:30:00',3.74),('8537','2013-08-26','10:35:00',3.76),('8537','2013-08-26','10:40:00',3.86),('8537','2013-08-26','10:45:00',3.94),('8537','2013-08-26','10:50:00',3.97),('8537','2013-08-26','10:55:00',4.03),('8537','2013-08-26','11:00:00',4.07),('8537','2013-08-26','11:05:00',4.09),('8537','2013-08-26','11:10:00',4.07),('8537','2013-08-26','11:15:00',4.16),('8537','2013-08-26','11:20:00',4.23),('8537','2013-08-26','11:25:00',4.25),('8537','2013-08-26','11:30:00',4.32),('8537','2013-08-26','11:35:00',4.39),('8537','2013-08-26','11:40:00',4.39),('8537','2013-08-26','11:45:00',4.39),('8537','2013-08-26','11:50:00',3.35),('8537','2013-08-26','11:55:00',4.48),('8537','2013-08-26','12:00:00',4.51),('8537','2013-08-26','12:05:00',4.59),('8537','2013-08-26','12:10:00',4.62),('8537','2013-08-26','12:15:00',4.61),('8537','2013-08-26','12:20:00',4.58),('8537','2013-08-26','12:25:00',4.55),('8537','2013-08-26','12:30:00',4.55),('8537','2013-08-26','12:35:00',4.56),('8537','2013-08-26','12:40:00',4.57),('8537','2013-08-26','12:45:00',4.61),('8537','2013-08-26','12:50:00',4.63),('8537','2013-08-26','12:55:00',4.63),('8537','2013-08-26','13:00:00',4.82),('8537','2013-08-26','13:05:00',5.28),('8537','2013-08-26','13:10:00',5.07),('8537','2013-08-26','13:15:00',3.22),('8537','2013-08-26','13:20:00',3.1),('8537','2013-08-26','13:25:00',3.19),('8537','2013-08-26','13:30:00',3.28),('8537','2013-08-26','13:35:00',4.49),('8537','2013-08-26','13:40:00',4.6),('8537','2013-08-26','13:45:00',4.65),('8537','2013-08-26','13:50:00',4.71),('8537','2013-08-26','13:55:00',3.74),('8537','2013-08-26','14:00:00',3.15),('8537','2013-08-26','14:05:00',4.2),('8537','2013-08-26','14:10:00',2.86),('8537','2013-08-26','14:15:00',4.53),('8537','2013-08-26','14:20:00',4.46),('8537','2013-08-26','14:25:00',4.39),('8537','2013-08-26','14:30:00',4.39),('8537','2013-08-26','14:35:00',4.05),('8537','2013-08-26','14:40:00',3.73),('8537','2013-08-26','14:45:00',2.91),('8537','2013-08-26','14:50:00',2.51),('8537','2013-08-26','14:55:00',2.31),('8537','2013-08-26','15:00:00',2.19),('8537','2013-08-26','15:05:00',1.62),('8537','2013-08-26','15:10:00',1.26),('8537','2013-08-26','15:15:00',1.1),('8537','2013-08-26','15:35:00',1.15),('8537','2013-08-26','15:40:00',1.78),('8537','2013-08-26','15:45:00',1.92),('8537','2013-08-26','15:50:00',1.82),('8537','2013-08-26','15:55:00',1.71),('8537','2013-08-26','16:00:00',2.64),('8537','2013-08-26','16:05:00',3.69),('8537','2013-08-26','16:10:00',3.09),('8537','2013-08-26','16:15:00',3.05),('8537','2013-08-26','16:20:00',2.98),('8537','2013-08-26','16:25:00',2.88),('8537','2013-08-26','16:30:00',2.81),('8537','2013-08-26','16:35:00',2.74),('8537','2013-08-26','16:40:00',2.66),('8537','2013-08-26','16:45:00',2.58),('8537','2013-08-26','16:50:00',2.39),('8537','2013-08-26','16:55:00',2.32),('8537','2013-08-26','17:00:00',2.28),('8537','2013-08-26','17:05:00',1.99),('8537','2013-08-26','17:10:00',2.02),('8537','2013-08-26','17:15:00',1.92),('8537','2013-08-26','17:20:00',1.44),('8537','2013-08-26','17:30:00',1.28),('8537','2013-08-26','17:35:00',1.05),('8537','2013-08-26','17:40:00',1.06),('8537','2013-08-26','17:45:00',1.17),('8537','2013-08-26','17:50:00',1.3),('8537','2013-08-26','17:55:00',1.27),('8537','2013-08-26','18:00:00',1.14),('8537','2013-08-26','18:05:00',1),('8537','2013-08-25','08:00:00',1.06),('8537','2013-08-25','08:05:00',1.2),('8537','2013-08-25','08:10:00',1.43),('8537','2013-08-25','08:15:00',1.43),('8537','2013-08-25','08:20:00',1.32),('8537','2013-08-25','08:25:00',1.41),('8537','2013-08-25','08:30:00',1.11),('8537','2013-08-25','08:35:00',1.03),('8537','2013-08-25','08:40:00',1.46),('8537','2013-08-25','08:45:00',1.75),('8537','2013-08-25','09:10:00',1),('8537','2013-08-25','09:15:00',1.24),('8537','2013-08-25','09:20:00',2.52),('8537','2013-08-25','09:25:00',2.49),('8537','2013-08-25','09:30:00',2.2),('8537','2013-08-25','09:35:00',2.25),('8537','2013-08-25','09:40:00',3.5),('8537','2013-08-25','09:45:00',3.72),('8537','2013-08-25','09:50:00',3.51),('8537','2013-08-25','09:55:00',3.82),('8537','2013-08-25','10:00:00',2.75),('8537','2013-08-25','10:05:00',1.97),('8537','2013-08-25','10:10:00',1.16),('8537','2013-08-25','15:05:00',1.02),('8537','2013-08-25','15:10:00',1.12),('8537','2013-08-25','15:15:00',1.32),('8537','2013-08-25','15:20:00',1.6),('8537','2013-08-25','15:25:00',1.77),('8537','2013-08-25','15:30:00',2.34),('8537','2013-08-25','15:35:00',3.04),('8537','2013-08-25','15:40:00',3.15),('8537','2013-08-25','15:45:00',4.15),('8537','2013-08-25','15:50:00',3.11),('8537','2013-08-25','15:55:00',2.66),('8537','2013-08-25','16:00:00',3.84),('8537','2013-08-25','16:05:00',3.61),('8537','2013-08-25','16:10:00',3.26),('8537','2013-08-25','16:15:00',3.3),('8537','2013-08-25','16:20:00',3.19),('8537','2013-08-25','16:25:00',3.15),('8537','2013-08-25','16:30:00',3.05),('8537','2013-08-25','16:35:00',2.93),('8537','2013-08-25','16:40:00',2.26),('8537','2013-08-25','16:45:00',1.45),('8537','2013-08-25','16:50:00',1.79),('8537','2013-08-25','16:55:00',1.49),('8537','2013-08-25','17:00:00',2.57),('8537','2013-08-25','17:05:00',2.4),('8537','2013-08-25','17:10:00',2.23),('8537','2013-08-25','17:15:00',2.08),('8537','2013-08-25','17:20:00',1.98),('8537','2013-08-25','17:25:00',1.86),('8537','2013-08-25','17:30:00',1.75),('8537','2013-08-25','17:35:00',1.48),('8537','2013-08-25','17:40:00',1.25),('8537','2013-08-25','17:45:00',1.45),('8537','2013-08-25','17:50:00',1.3),('8537','2013-08-25','17:55:00',1.11),('8537','2013-08-24','08:25:00',1.5),('8537','2013-08-24','08:30:00',1.51),('8537','2013-08-24','08:35:00',1.76),('8537','2013-08-24','08:40:00',1.87),('8537','2013-08-24','08:45:00',1.93),('8537','2013-08-24','08:50:00',1.6),('8537','2013-08-24','08:55:00',2.21),('8537','2013-08-24','09:00:00',2.31),('8537','2013-08-24','09:05:00',2.46),('8537','2013-08-24','09:10:00',2.69),('8537','2013-08-24','09:15:00',2.66),('8537','2013-08-24','09:20:00',2.73),('8537','2013-08-24','09:25:00',2.25),('8537','2013-08-24','09:30:00',2.26),('8537','2013-08-24','09:35:00',3.06),('8537','2013-08-24','09:40:00',2.99),('8537','2013-08-24','09:45:00',3.02),('8537','2013-08-24','09:50:00',2.7),('8537','2013-08-24','09:55:00',1.85),('8537','2013-08-24','10:00:00',2.27),('8537','2013-08-24','10:05:00',3.08),('8537','2013-08-24','10:10:00',3.51),('8537','2013-08-24','10:15:00',3.55),('8537','2013-08-24','10:20:00',3.61),('8537','2013-08-24','10:25:00',3.64),('8537','2013-08-24','10:30:00',3.7),('8537','2013-08-24','10:35:00',3.77),('8537','2013-08-24','10:40:00',3.84),('8537','2013-08-24','10:45:00',3.86),('8537','2013-08-24','10:50:00',3.82),('8537','2013-08-24','10:55:00',4.08),('8537','2013-08-24','11:00:00',4.08),('8537','2013-08-24','11:05:00',4.13),('8537','2013-08-24','11:10:00',4.24),('8537','2013-08-24','11:15:00',4.2),('8537','2013-08-24','11:20:00',4.19),('8537','2013-08-24','11:25:00',4.24),('8537','2013-08-24','11:30:00',4.27),('8537','2013-08-24','11:35:00',4.32),('8537','2013-08-24','11:40:00',4.35),('8537','2013-08-24','11:45:00',4.38),('8537','2013-08-24','11:50:00',4.43),('8537','2013-08-24','11:55:00',4.4),('8537','2013-08-24','12:00:00',4.47),('8537','2013-08-24','12:05:00',4.51),('8537','2013-08-24','12:10:00',4.54),('8537','2013-08-24','12:15:00',4.56),('8537','2013-08-24','12:20:00',4.58),('8537','2013-08-24','12:25:00',4.59),('8537','2013-08-24','12:30:00',4.59),('8537','2013-08-24','12:35:00',4.64),('8537','2013-08-24','12:40:00',4.64),('8537','2013-08-24','12:45:00',4.63),('8537','2013-08-24','12:50:00',4.64),('8537','2013-08-24','12:55:00',4.61),('8537','2013-08-24','13:00:00',4.57),('8537','2013-08-24','13:05:00',4.57),('8537','2013-08-24','13:10:00',4.6),('8537','2013-08-24','13:15:00',4.63),('8537','2013-08-24','13:20:00',4.68),('8537','2013-08-24','13:25:00',4.58),('8537','2013-08-24','13:30:00',4.67),('8537','2013-08-24','13:35:00',4.68),('8537','2013-08-24','13:40:00',4.65),('8537','2013-08-24','13:45:00',4.62),('8537','2013-08-24','13:50:00',4.61),('8537','2013-08-24','13:55:00',4.57),('8537','2013-08-24','14:00:00',4.55),('8537','2013-08-24','14:05:00',4.54),('8537','2013-08-24','14:10:00',4.53),('8537','2013-08-24','14:15:00',4.49),('8537','2013-08-24','14:20:00',4.49),('8537','2013-08-24','14:25:00',4.45),('8537','2013-08-24','14:30:00',4.43),('8537','2013-08-24','14:35:00',4.28),('8537','2013-08-24','14:40:00',4.02),('8537','2013-08-24','14:45:00',4.22),('8537','2013-08-24','14:50:00',4.15),('8537','2013-08-24','14:55:00',4.14),('8537','2013-08-24','15:00:00',4.11),('8537','2013-08-24','15:05:00',4.07),('8537','2013-08-24','15:10:00',3.99),('8537','2013-08-24','15:15:00',3.98),('8537','2013-08-24','15:20:00',3.93),('8537','2013-08-24','15:25:00',3.87),('8537','2013-08-24','15:30:00',3.77),('8537','2013-08-24','15:35:00',3.7),('8537','2013-08-24','15:40:00',3.63),('8537','2013-08-24','15:45:00',3.55),('8537','2013-08-24','15:50:00',3.52),('8537','2013-08-24','15:55:00',3.45),('8537','2013-08-24','16:00:00',3.39),('8537','2013-08-24','16:05:00',3.33),('8537','2013-08-24','16:10:00',3.21),('8537','2013-08-24','16:15:00',3.15),('8537','2013-08-24','16:20:00',3.08),('8537','2013-08-24','16:25:00',3),('8537','2013-08-24','16:30:00',2.89),('8537','2013-08-24','16:35:00',2.82),('8537','2013-08-24','16:40:00',2.73),('8537','2013-08-24','16:45:00',2.52),('8537','2013-08-24','16:50:00',2.04),('8537','2013-08-24','16:55:00',2.09),('8537','2013-08-24','17:00:00',2.36),('8537','2013-08-24','17:05:00',2.23),('8537','2013-08-24','17:10:00',2.11),('8537','2013-08-24','17:15:00',2.06),('8537','2013-08-24','17:20:00',1.97),('8537','2013-08-24','17:25:00',1.86),('8537','2013-08-24','17:30:00',1.75),('8537','2013-08-24','17:35:00',1.63),('8537','2013-08-24','17:40:00',1.53),('8537','2013-08-24','17:45:00',1.43),('8537','2013-08-24','17:50:00',1.34),('8537','2013-08-24','17:55:00',1.24),('8537','2013-08-24','18:00:00',1.14),('8537','2013-08-24','18:05:00',1.05),('8537','2013-08-23','08:05:00',1.04),('8537','2013-08-23','08:10:00',1.13),('8537','2013-08-23','08:15:00',1.23),('8537','2013-08-23','08:20:00',1.34),('8537','2013-08-23','08:25:00',1.44),('8537','2013-08-23','08:30:00',1.55),('8537','2013-08-23','08:35:00',1.62),('8537','2013-08-23','08:40:00',1.67),('8537','2013-08-23','08:45:00',1.82),('8537','2013-08-23','08:50:00',1.89),('8537','2013-08-23','08:55:00',1.96),('8537','2013-08-23','09:00:00',2.04),('8537','2013-08-23','09:05:00',2.14),('8537','2013-08-23','09:10:00',2.19),('8537','2013-08-23','09:15:00',2.35),('8537','2013-08-23','09:20:00',2.44),('8537','2013-08-23','09:25:00',2.52),('8537','2013-08-23','09:30:00',2.61),('8537','2013-08-23','09:35:00',2.66),('8537','2013-08-23','09:40:00',2.69),('8537','2013-08-23','09:45:00',2.79),('8537','2013-08-23','09:50:00',2.9),('8537','2013-08-23','09:55:00',2.98),('8537','2013-08-23','10:00:00',3.04),('8537','2013-08-23','10:05:00',3.11),('8537','2013-08-23','10:10:00',3.15),('8537','2013-08-23','10:15:00',3.24),('8537','2013-08-23','10:20:00',3.3),('8537','2013-08-23','10:25:00',3.37),('8537','2013-08-23','10:30:00',3.41),('8537','2013-08-23','10:35:00',3.43),('8537','2013-08-23','10:40:00',3.53),('8537','2013-08-23','10:45:00',3.47),('8537','2013-08-23','10:50:00',3.62),('8537','2013-08-23','10:55:00',3.56),('8537','2013-08-23','11:00:00',3.81),('8537','2013-08-23','11:05:00',3.94),('8537','2013-08-23','11:10:00',3.48),('8537','2013-08-23','11:15:00',3.21),('8537','2013-08-23','11:20:00',3.18),('8537','2013-08-23','11:25:00',4.05),('8537','2013-08-23','11:30:00',3.49),('8537','2013-08-23','11:35:00',4.01),('8537','2013-08-23','11:40:00',4.09),('8537','2013-08-23','11:45:00',4.31),('8537','2013-08-23','11:50:00',4.21),('8537','2013-08-23','11:55:00',4.21),('8537','2013-08-23','12:00:00',3.65),('8537','2013-08-23','12:05:00',2.42),('8537','2013-08-23','12:10:00',1.77),('8537','2013-08-23','12:15:00',4.21),('8537','2013-08-23','12:20:00',1.14),('8537','2013-08-23','12:25:00',1.09),('8537','2013-08-23','12:30:00',1.03),('8537','2013-08-23','12:35:00',1.4),('8537','2013-08-23','12:40:00',1.59),('8537','2013-08-23','12:45:00',1.23),('8537','2013-08-23','12:50:00',1.14),('8537','2013-08-23','12:55:00',1.05),('8537','2013-08-23','13:00:00',1.18),('8537','2013-08-23','13:05:00',1.55),('8537','2013-08-23','13:10:00',1.84),('8537','2013-08-23','13:15:00',3.35),('8537','2013-08-23','13:20:00',2.27),('8537','2013-08-23','13:25:00',4.69),('8537','2013-08-23','13:30:00',5.04),('8537','2013-08-23','13:35:00',4.76),('8537','2013-08-23','13:40:00',4.56),('8537','2013-08-23','13:45:00',4.6),('8537','2013-08-23','13:50:00',3.89),('8537','2013-08-23','13:55:00',4.37),('8537','2013-08-23','14:00:00',4.44),('8537','2013-08-23','14:05:00',4.77),('8537','2013-08-23','14:10:00',4.69),('8537','2013-08-23','14:15:00',4.64),('8537','2013-08-23','14:20:00',3.48),('8537','2013-08-23','14:25:00',3.53),('8537','2013-08-23','14:30:00',4.56),('8537','2013-08-23','14:35:00',4.23),('8537','2013-08-23','14:40:00',4.17),('8537','2013-08-23','14:45:00',4.25),('8537','2013-08-23','14:50:00',4.13),('8537','2013-08-23','14:55:00',4.03),('8537','2013-08-23','15:00:00',3.96),('8537','2013-08-23','15:05:00',3.71),('8537','2013-08-23','15:10:00',3.92),('8537','2013-08-23','15:15:00',3.85),('8537','2013-08-23','15:20:00',3.77),('8537','2013-08-23','15:25:00',3.81),('8537','2013-08-23','15:30:00',3.82),('8537','2013-08-23','15:35:00',3.47),('8537','2013-08-23','15:40:00',3.56),('8537','2013-08-23','15:45:00',3.56),('8537','2013-08-23','15:50:00',3.29),('8537','2013-08-23','15:55:00',3.45),('8537','2013-08-23','16:00:00',3.27),('8537','2013-08-23','16:05:00',3.08),('8537','2013-08-23','16:10:00',2.75),('8537','2013-08-23','16:15:00',2.84),('8537','2013-08-23','16:20:00',3.17),('8537','2013-08-23','16:25:00',3.05),('8537','2013-08-23','16:30:00',2.97),('8537','2013-08-23','16:35:00',2.93),('8537','2013-08-23','16:40:00',2.86),('8537','2013-08-23','16:45:00',2.71),('8537','2013-08-23','16:50:00',2.28),('8537','2013-08-23','16:55:00',1.83),('8537','2013-08-23','17:00:00',2.38),('8537','2013-08-23','17:05:00',2.23),('8537','2013-08-23','17:10:00',2.07),('8537','2013-08-23','17:15:00',2),('8537','2013-08-23','17:20:00',1.9),('8537','2013-08-23','17:25:00',1.82),('8537','2013-08-23','17:30:00',1.68),('8537','2013-08-23','17:35:00',1.59),('8537','2013-08-23','17:40:00',1.46),('8537','2013-08-23','17:45:00',1.39),('8537','2013-08-23','17:50:00',1.31),('8537','2013-08-23','17:55:00',1.22),('8537','2013-08-23','18:00:00',1.11),('8537','2013-08-23','18:05:00',1.02),('8537','2013-08-22','08:00:00',1.04),('8537','2013-08-22','08:05:00',1.11),('8537','2013-08-22','08:10:00',1.23),('8537','2013-08-22','08:15:00',1.3),('8537','2013-08-22','08:20:00',1.38),('8537','2013-08-22','08:25:00',1.49),('8537','2013-08-22','08:30:00',1.6),('8537','2013-08-22','08:35:00',1.71),('8537','2013-08-22','08:40:00',1.78),('8537','2013-08-22','08:45:00',1.92),('8537','2013-08-22','08:50:00',2.02),('8537','2013-08-22','08:55:00',2.14),('8537','2013-08-22','09:00:00',2.19),('8537','2013-08-22','09:05:00',2.42),('8537','2013-08-22','09:10:00',2.58),('8537','2013-08-22','09:15:00',2.72),('8537','2013-08-22','09:20:00',2.87),('8537','2013-08-22','09:25:00',2.87),('8537','2013-08-22','09:30:00',2.4),('8537','2013-08-22','09:35:00',1.58),('8537','2013-08-22','09:40:00',1.71),('8537','2013-08-22','09:45:00',2.26),('8537','2013-08-22','09:50:00',3.09),('8537','2013-08-22','09:55:00',2.48),('8537','2013-08-22','10:00:00',3.48),('8537','2013-08-22','10:05:00',3.53),('8537','2013-08-22','10:10:00',3.55),('8537','2013-08-22','10:15:00',3.55),('8537','2013-08-22','10:20:00',3.55),('8537','2013-08-22','10:25:00',3.62),('8537','2013-08-22','10:30:00',3.72),('8537','2013-08-22','10:35:00',3.73),('8537','2013-08-22','10:40:00',3.8),('8537','2013-08-22','10:45:00',3.84),('8537','2013-08-22','10:50:00',3.89),('8537','2013-08-22','10:55:00',3.93),('8537','2013-08-22','11:00:00',4),('8537','2013-08-22','11:05:00',4.01),('8537','2013-08-22','11:10:00',4.06),('8537','2013-08-22','11:15:00',4.12),('8537','2013-08-22','11:20:00',4.09),('8537','2013-08-22','11:25:00',4.11),('8537','2013-08-22','11:30:00',4.2),('8537','2013-08-22','11:35:00',4.24),('8537','2013-08-22','11:40:00',4.29),('8537','2013-08-22','11:45:00',4.28),('8537','2013-08-22','11:50:00',4.32),('8537','2013-08-22','11:55:00',4.37),('8537','2013-08-22','12:00:00',4.44),('8537','2013-08-22','12:05:00',4.46),('8537','2013-08-22','12:10:00',4.47),('8537','2013-08-22','12:15:00',4.49),('8537','2013-08-22','12:20:00',4.5),('8537','2013-08-22','12:25:00',4.5),('8537','2013-08-22','12:30:00',4.5),('8537','2013-08-22','12:35:00',4.51),('8537','2013-08-22','12:40:00',4.52),('8537','2013-08-22','12:45:00',4.54),('8537','2013-08-22','12:50:00',4.56),('8537','2013-08-22','12:55:00',4.59),('8537','2013-08-22','13:00:00',4.55),('8537','2013-08-22','13:05:00',4.35),('8537','2013-08-22','13:10:00',4.37),('8537','2013-08-22','13:15:00',4.34),('8537','2013-08-22','13:20:00',4.4),('8537','2013-08-22','13:25:00',4.4),('8537','2013-08-22','13:30:00',4.45),('8537','2013-08-22','13:35:00',4.41),('8537','2013-08-22','13:40:00',4.44),('8537','2013-08-22','13:45:00',4.46),('8537','2013-08-22','13:50:00',4.43),('8537','2013-08-22','13:55:00',4.42),('8537','2013-08-22','14:00:00',4.4),('8537','2013-08-22','14:05:00',4.39),('8537','2013-08-22','14:10:00',4.38),('8537','2013-08-22','14:15:00',4.36),('8537','2013-08-22','14:20:00',4.36),('8537','2013-08-22','14:25:00',4.3),('8537','2013-08-22','14:30:00',4.3),('8537','2013-08-22','14:35:00',4.11),('8537','2013-08-22','14:40:00',4.07),('8537','2013-08-22','14:45:00',4.13),('8537','2013-08-22','14:50:00',4.07),('8537','2013-08-22','14:55:00',4.05),('8537','2013-08-22','15:00:00',4.01),('8537','2013-08-22','15:05:00',3.96),('8537','2013-08-22','15:10:00',3.92),('8537','2013-08-22','15:15:00',3.85),('8537','2013-08-22','15:20:00',3.78),('8537','2013-08-22','15:25:00',3.72),('8537','2013-08-22','15:30:00',3.6),('8537','2013-08-22','15:35:00',3.31),('8537','2013-08-22','15:40:00',3.16),('8537','2013-08-22','15:45:00',3.47),('8537','2013-08-22','15:50:00',3.42),('8537','2013-08-22','15:55:00',3.34),('8537','2013-08-22','16:00:00',3.25),('8537','2013-08-22','16:05:00',3.14),('8537','2013-08-22','16:10:00',3),('8537','2013-08-22','16:15:00',3),('8537','2013-08-22','16:20:00',2.93),('8537','2013-08-22','16:25:00',2.86),('8537','2013-08-22','16:30:00',2.8),('8537','2013-08-22','16:35:00',2.7),('8537','2013-08-22','16:40:00',2.62),('8537','2013-08-22','16:45:00',2.49),('8537','2013-08-22','16:50:00',2.2),('8537','2013-08-22','16:55:00',1.94),('8537','2013-08-22','17:00:00',2.22),('8537','2013-08-22','17:05:00',2.13),('8537','2013-08-22','17:10:00',1.97),('8537','2013-08-22','17:15:00',1.89),('8537','2013-08-22','17:20:00',1.82),('8537','2013-08-22','17:25:00',1.72),('8537','2013-08-22','17:30:00',1.63),('8537','2013-08-22','17:35:00',1.55),('8537','2013-08-22','17:40:00',1.42),('8537','2013-08-22','17:45:00',1.34),('8537','2013-08-22','17:50:00',1.24),('8537','2013-08-22','17:55:00',1.18),('8537','2013-08-22','18:00:00',1.1),('8537','2013-08-22','18:05:00',1.02),('8537','2013-08-21','09:00:00',1.08),('8537','2013-08-21','09:05:00',1.66),('8537','2013-08-21','09:10:00',1.56),('8537','2013-08-21','09:15:00',2.89),('8537','2013-08-21','09:20:00',2.86),('8537','2013-08-21','09:25:00',1.49),('8537','2013-08-21','09:35:00',1.16),('8537','2013-08-21','09:40:00',1.32),('8537','2013-08-21','09:45:00',1.51),('8537','2013-08-21','09:50:00',3.52),('8537','2013-08-21','09:55:00',4.12),('8537','2013-08-21','10:00:00',3.94),('8537','2013-08-21','10:05:00',3.15),('8537','2013-08-21','10:10:00',2.86),('8537','2013-08-21','10:15:00',1.72),('8537','2013-08-21','10:20:00',2.33),('8537','2013-08-21','10:25:00',2.06),('8537','2013-08-21','10:30:00',2.77),('8537','2013-08-21','10:35:00',4.03),('8537','2013-08-21','10:40:00',3.24),('8537','2013-08-21','10:45:00',2.66),('8537','2013-08-21','10:50:00',2.55),('8537','2013-08-21','10:55:00',2.08),('8537','2013-08-21','11:00:00',2.67),('8537','2013-08-21','11:05:00',2.21),('8537','2013-08-21','11:10:00',2.07),('8537','2013-08-21','11:15:00',2.66),('8537','2013-08-21','11:20:00',4.03),('8537','2013-08-21','11:25:00',2.88),('8537','2013-08-21','11:30:00',3.28),('8537','2013-08-21','11:35:00',4.85),('8537','2013-08-21','11:40:00',4.83),('8537','2013-08-21','11:45:00',4.77),('8537','2013-08-21','11:50:00',3.89),('8537','2013-08-21','11:55:00',4.46),('8537','2013-08-21','12:00:00',4.83),('8537','2013-08-21','12:05:00',4.79),('8537','2013-08-21','12:10:00',4.81),('8537','2013-08-21','12:15:00',4.86),('8537','2013-08-21','12:20:00',4.37),('8537','2013-08-21','12:25:00',3.49),('8537','2013-08-21','12:30:00',3.64),('8537','2013-08-21','12:35:00',3.05),('8537','2013-08-21','12:40:00',4.12),('8537','2013-08-21','12:45:00',4.59),('8537','2013-08-21','12:50:00',4.48),('8537','2013-08-21','12:55:00',4.31),('8537','2013-08-21','13:00:00',4.54),('8537','2013-08-21','13:05:00',4.63),('8537','2013-08-21','13:10:00',4.66),('8537','2013-08-21','13:15:00',4.76),('8537','2013-08-21','13:20:00',4.73),('8537','2013-08-21','13:25:00',4.78),('8537','2013-08-21','13:30:00',4.77),('8537','2013-08-21','13:35:00',4.65),('8537','2013-08-21','13:40:00',4.45),('8537','2013-08-21','13:45:00',4.15),('8537','2013-08-21','13:50:00',4.5),('8537','2013-08-21','13:55:00',4.51),('8537','2013-08-21','14:00:00',4.26),('8537','2013-08-21','14:05:00',4.56),('8537','2013-08-21','14:10:00',4.55),('8537','2013-08-21','14:15:00',4.4),('8537','2013-08-21','14:20:00',3.54),('8537','2013-08-21','14:25:00',3.12),('8537','2013-08-21','14:30:00',4.06),('8537','2013-08-21','14:35:00',3.95),('8537','2013-08-21','14:40:00',4),('8537','2013-08-21','14:45:00',4.02),('8537','2013-08-21','14:50:00',3.81),('8537','2013-08-21','14:55:00',3.87),('8537','2013-08-21','15:00:00',3.97),('8537','2013-08-21','15:05:00',3.96),('8537','2013-08-21','15:10:00',3.81),('8537','2013-08-21','15:15:00',3.77),('8537','2013-08-21','15:20:00',3.67),('8537','2013-08-21','15:25:00',3.6),('8537','2013-08-21','15:30:00',3.44),('8537','2013-08-21','15:35:00',3.22),('8537','2013-08-21','15:40:00',3.16),('8537','2013-08-21','15:45:00',3.19),('8537','2013-08-21','15:50:00',3.26),('8537','2013-08-21','15:55:00',3.1),('8537','2013-08-21','16:00:00',2.88),('8537','2013-08-21','16:05:00',2.76),('8537','2013-08-21','16:10:00',2.7),('8537','2013-08-21','16:15:00',2.6),('8537','2013-08-21','16:20:00',2.48),('8537','2013-08-21','16:25:00',2.81),('8537','2013-08-21','16:30:00',2.94),('8537','2013-08-21','16:35:00',2.87),('8537','2013-08-21','16:40:00',2.76),('8537','2013-08-21','16:45:00',2.67),('8537','2013-08-21','16:50:00',2.46),('8537','2013-08-21','16:55:00',2.36),('8537','2013-08-21','17:00:00',2.41),('8537','2013-08-21','17:05:00',2.35),('8537','2013-08-21','17:10:00',2.19),('8537','2013-08-21','17:15:00',2.18),('8537','2013-08-21','17:20:00',2.14),('8537','2013-08-21','17:25:00',2.05),('8537','2013-08-21','17:30:00',1.92),('8537','2013-08-21','17:35:00',1.84),('8537','2013-08-21','17:40:00',1.73),('8537','2013-08-21','17:45:00',1.66),('8537','2013-08-21','17:50:00',1.61),('8537','2013-08-21','17:55:00',1.52),('8537','2013-08-21','18:00:00',1.42),('8537','2013-08-21','18:05:00',1.32),('8537','2013-08-21','18:10:00',1.21),('8537','2013-08-21','18:15:00',1.12),('8537','2013-08-20','07:55:00',1.18),('8537','2013-08-20','08:00:00',1.13),('8537','2013-08-20','08:50:00',1.13),('8537','2013-08-20','08:55:00',1.3),('8537','2013-08-20','09:00:00',1.22),('8537','2013-08-20','09:05:00',1.28),('8537','2013-08-20','09:10:00',1.3),('8537','2013-08-20','09:15:00',1.31),('8537','2013-08-20','09:20:00',1.3),('8537','2013-08-20','09:25:00',2.14),('8537','2013-08-20','09:30:00',2.75),('8537','2013-08-20','09:35:00',2.93),('8537','2013-08-20','09:40:00',2.94),('8537','2013-08-20','09:45:00',2.88),('8537','2013-08-20','09:50:00',2.81),('8537','2013-08-20','09:55:00',2.71),('8537','2013-08-20','10:00:00',2.79),('8537','2013-08-20','10:05:00',1.31),('8537','2013-08-20','10:10:00',2.55),('8537','2013-08-20','10:15:00',3.12),('8537','2013-08-20','10:20:00',4.12),('8537','2013-08-20','10:25:00',1.6),('8537','2013-08-20','10:30:00',1.16),('8537','2013-08-20','10:35:00',1.14),('8537','2013-08-20','10:40:00',1.17),('8537','2013-08-20','10:45:00',1.21),('8537','2013-08-20','10:50:00',2.6),('8537','2013-08-20','10:55:00',2.42),('8537','2013-08-20','11:00:00',1.07),('8537','2013-08-20','11:15:00',3.26),('8537','2013-08-20','11:20:00',4.66),('8537','2013-08-20','11:25:00',4.33),('8537','2013-08-20','11:30:00',1.28),('8537','2013-08-20','11:35:00',2.29),('8537','2013-08-20','11:40:00',4.71),('8537','2013-08-20','11:45:00',4.93),('8537','2013-08-20','11:50:00',5.21),('8537','2013-08-20','11:55:00',4.19),('8537','2013-08-20','12:00:00',1.89),('8537','2013-08-20','12:05:00',1.77),('8537','2013-08-20','12:10:00',1.88),('8537','2013-08-20','12:15:00',1.02),('8537','2013-08-20','12:20:00',1.07),('8537','2013-08-20','12:25:00',1.24),('8537','2013-08-20','12:30:00',1.5),('8537','2013-08-20','12:35:00',1.67),('8537','2013-08-20','12:40:00',1.99),('8537','2013-08-20','12:45:00',2),('8537','2013-08-20','12:50:00',2.08),('8537','2013-08-20','12:55:00',2.12),('8537','2013-08-20','13:00:00',2.05),('8537','2013-08-20','13:05:00',1.91),('8537','2013-08-20','13:10:00',1.85),('8537','2013-08-20','13:15:00',1.92),('8537','2013-08-20','13:20:00',1.99),('8537','2013-08-20','13:25:00',2.09),('8537','2013-08-20','13:30:00',2.25),('8537','2013-08-20','13:35:00',2.86),('8537','2013-08-20','13:40:00',4.64),('8537','2013-08-20','13:45:00',4.26),('8537','2013-08-20','13:50:00',4.81),('8537','2013-08-20','13:55:00',4.88),('8537','2013-08-20','14:00:00',4.78),('8537','2013-08-20','14:05:00',4.76),('8537','2013-08-20','14:10:00',4.73),('8537','2013-08-20','14:15:00',4.6),('8537','2013-08-20','14:20:00',4.61),('8537','2013-08-20','14:25:00',4.38),('8537','2013-08-20','14:30:00',3.82),('8537','2013-08-20','14:35:00',4.54),('8537','2013-08-20','14:40:00',4.77),('8537','2013-08-20','14:45:00',4.13),('8537','2013-08-20','14:50:00',4.57),('8537','2013-08-20','14:55:00',3.64),('8537','2013-08-20','15:00:00',4),('8537','2013-08-20','15:05:00',4.51),('8537','2013-08-20','15:10:00',4.45),('8537','2013-08-20','15:15:00',4.31),('8537','2013-08-20','15:20:00',4.31),('8537','2013-08-20','15:25:00',4.28),('8537','2013-08-20','15:30:00',4.18),('8537','2013-08-20','15:35:00',4.01),('8537','2013-08-20','15:40:00',4.2),('8537','2013-08-20','15:45:00',4.37),('8537','2013-08-20','15:50:00',4.1),('8537','2013-08-20','15:55:00',4.54),('8537','2013-08-20','16:00:00',4.19),('8537','2013-08-20','16:05:00',4.17),('8537','2013-08-20','16:10:00',4.09),('8537','2013-08-20','16:15:00',3.99),('8537','2013-08-20','16:20:00',3.9),('8537','2013-08-20','16:25:00',3.73),('8537','2013-08-20','16:30:00',3.39),('8537','2013-08-20','16:35:00',3.5),('8537','2013-08-20','16:40:00',3.57),('8537','2013-08-20','16:45:00',3.42),('8537','2013-08-20','16:50:00',3.02),('8537','2013-08-20','16:55:00',2.93),('8537','2013-08-20','17:00:00',2.71),('8537','2013-08-20','17:05:00',2.55),('8537','2013-08-20','17:10:00',2.31),('8537','2013-08-20','17:15:00',2.14),('8537','2013-08-20','17:20:00',2.15),('8537','2013-08-20','17:25:00',2.04),('8537','2013-08-20','17:30:00',1.94),('8537','2013-08-20','17:35:00',1.84),('8537','2013-08-20','17:40:00',1.68),('8537','2013-08-20','17:45:00',1.65),('8537','2013-08-20','17:50:00',1.49),('8537','2013-08-20','17:55:00',1.34),('8537','2013-08-20','18:00:00',1.16),('8537','2013-08-20','18:05:00',1.19),('8537','2013-08-20','18:10:00',1.19),('8537','2013-08-20','18:15:00',1.18),('8537','2013-08-20','18:20:00',1.11),('8537','2013-08-20','18:25:00',1.04),('8537','2014-04-10','07:55:00',1.04),('8537','2014-04-10','08:00:00',1.15),('8537','2014-04-10','08:05:00',1.29),('8537','2014-04-10','08:10:00',1.41),('8537','2014-04-10','08:15:00',1.54),('8537','2014-04-10','08:20:00',1.66),('8537','2014-04-10','08:25:00',1.79),('8537','2014-04-10','08:30:00',1.91),('8537','2014-04-10','08:35:00',2.04),('8537','2014-04-10','08:40:00',2.17),('8537','2014-04-10','08:45:00',2.29),('8537','2014-04-10','08:50:00',2.4),('8537','2014-04-10','08:55:00',2.5),('8537','2014-04-10','09:00:00',2.58),('8537','2014-04-10','09:05:00',2.72),('8537','2014-04-10','09:10:00',2.82),('8537','2014-04-10','09:15:00',2.86),('8537','2014-04-10','09:20:00',2.89),('8537','2014-04-10','09:25:00',3.11),('8537','2014-04-10','09:30:00',3.23),('8537','2014-04-10','09:35:00',3.31),('8537','2014-04-10','09:40:00',3.39),('8537','2014-04-10','09:45:00',3.49),('8537','2014-04-10','09:50:00',3.61),('8537','2014-04-10','09:55:00',3.69),('8537','2014-04-10','10:00:00',3.75),('8537','2014-04-10','10:05:00',3.8),('8537','2014-04-10','10:10:00',3.93),('8537','2014-04-10','10:15:00',3.93),('8537','2014-04-10','10:20:00',4.02),('8537','2014-04-10','10:25:00',4.08),('8537','2014-04-10','10:30:00',4.1),('8537','2014-04-10','10:35:00',4.3),('8537','2014-04-10','10:40:00',4.34),('8537','2014-04-10','10:45:00',4.37),('8537','2014-04-10','10:50:00',4.28),('8537','2014-04-10','10:55:00',4.4),('8537','2014-04-10','11:00:00',4.48),('8537','2014-04-10','11:05:00',4.61),('8537','2014-04-10','11:10:00',4.52),('8537','2014-04-10','11:15:00',4.7),('8537','2014-04-10','11:20:00',4.82),('8537','2014-04-10','11:25:00',4.89),('8537','2014-04-10','11:30:00',4.9),('8537','2014-04-10','11:35:00',4.98),('8537','2014-04-10','11:40:00',4.85),('8537','2014-04-10','11:45:00',4.96),('8537','2014-04-10','11:50:00',4.79),('8537','2014-04-10','11:55:00',5.03),('8537','2014-04-10','12:00:00',4.98),('8537','2014-04-10','12:05:00',4.66),('8537','2014-04-10','12:10:00',4.87),('8537','2014-04-10','12:15:00',4.97),('8537','2014-04-10','12:20:00',4.97),('8537','2014-04-10','12:25:00',4.82),('8537','2014-04-10','12:30:00',4.9),('8537','2014-04-10','12:35:00',5.13),('8537','2014-04-10','12:40:00',5.07),('8537','2014-04-10','12:45:00',5.13),('8537','2014-04-10','12:50:00',4.97),('8537','2014-04-10','12:55:00',4.86),('8537','2014-04-10','13:00:00',4.83),('8537','2014-04-10','13:05:00',4.69),('8537','2014-04-10','13:10:00',4.76),('8537','2014-04-10','13:15:00',4.81),('8537','2014-04-10','13:20:00',4.76),('8537','2014-04-10','13:25:00',5.1),('8537','2014-04-10','13:30:00',5),('8537','2014-04-10','13:35:00',5.08),('8537','2014-04-10','13:40:00',4.85),('8537','2014-04-10','13:45:00',5.13),('8537','2014-04-10','13:50:00',5.08),('8537','2014-04-10','13:55:00',5),('8537','2014-04-10','14:00:00',4.97),('8537','2014-04-10','14:05:00',4.93),('8537','2014-04-10','14:10:00',4.95),('8537','2014-04-10','14:15:00',4.92),('8537','2014-04-10','14:20:00',4.94),('8537','2014-04-10','14:25:00',4.92),('8537','2014-04-10','14:30:00',4.81),('8537','2014-04-10','14:35:00',4.7),('8537','2014-04-10','14:40:00',4.71),('8537','2014-04-10','14:45:00',4.31),('8537','2014-04-10','14:50:00',4.72),('8537','2014-04-10','14:55:00',4.6),('8537','2014-04-10','15:00:00',4.53),('8537','2014-04-10','15:05:00',4.49),('8537','2014-04-10','15:10:00',4.38),('8537','2014-04-10','15:15:00',4.35),('8537','2014-04-10','15:20:00',4.22),('8537','2014-04-10','15:25:00',3.92),('8537','2014-04-10','15:30:00',3.72),('8537','2014-04-10','15:35:00',3.76),('8537','2014-04-10','15:40:00',3.85),('8537','2014-04-10','15:45:00',3.78),('8537','2014-04-10','15:50:00',3.81),('8537','2014-04-10','15:55:00',3.73),('8537','2014-04-10','16:00:00',3.56),('8537','2014-04-10','16:05:00',3.51),('8537','2014-04-10','16:10:00',3.53),('8537','2014-04-10','16:15:00',3.6),('8537','2014-04-10','16:20:00',3.38),('8537','2014-04-10','16:25:00',3.41),('8537','2014-04-10','16:30:00',3.32),('8537','2014-04-10','16:35:00',3.23),('8537','2014-04-10','16:40:00',3.02),('8537','2014-04-10','16:45:00',2.61),('8537','2014-04-10','16:50:00',2.92),('8537','2014-04-10','16:55:00',2.8),('8537','2014-04-10','17:00:00',2.57),('8537','2014-04-10','17:05:00',2.43),('8537','2014-04-10','17:10:00',2.37),('8537','2014-04-10','17:15:00',2.24),('8537','2014-04-10','17:20:00',2.15),('8537','2014-04-10','17:25:00',2.02),('8537','2014-04-10','17:30:00',1.83),('8537','2014-04-10','17:35:00',1.74),('8537','2014-04-10','17:40:00',1.63),('8537','2014-04-10','17:45:00',1.52),('8537','2014-04-10','17:50:00',1.39),('8537','2014-04-10','17:55:00',1.29),('8537','2014-04-10','18:00:00',1.18),('8537','2014-04-10','18:05:00',1.07),('8537','2013-08-19','07:55:00',1.03),('8537','2013-08-19','08:00:00',1.13),('8537','2013-08-19','08:05:00',1.23),('8537','2013-08-19','08:10:00',1.31),('8537','2013-08-19','08:15:00',1.41),('8537','2013-08-19','08:20:00',1.51),('8537','2013-08-19','08:25:00',1.62),('8537','2013-08-19','08:30:00',1.7),('8537','2013-08-19','08:35:00',1.8),('8537','2013-08-19','08:40:00',1.89),('8537','2013-08-19','08:45:00',2.01),('8537','2013-08-19','08:50:00',2.11),('8537','2013-08-19','08:55:00',2.23),('8537','2013-08-19','09:00:00',2.34),('8537','2013-08-19','09:05:00',2.43),('8537','2013-08-19','09:10:00',2.53),('8537','2013-08-19','09:15:00',2.62),('8537','2013-08-19','09:20:00',2.72),('8537','2013-08-19','09:25:00',2.8),('8537','2013-08-19','09:30:00',2.86),('8537','2013-08-19','09:35:00',2.96),('8537','2013-08-19','09:40:00',3.04),('8537','2013-08-19','09:45:00',3.12),('8537','2013-08-19','09:50:00',3.18),('8537','2013-08-19','09:55:00',3.27),('8537','2013-08-19','10:00:00',3.36),('8537','2013-08-19','10:05:00',3.39),('8537','2013-08-19','10:10:00',3.47),('8537','2013-08-19','10:15:00',3.53),('8537','2013-08-19','10:20:00',3.6),('8537','2013-08-19','10:25:00',3.65),('8537','2013-08-19','10:30:00',3.72),('8537','2013-08-19','10:35:00',3.79),('8537','2013-08-19','10:40:00',3.87),('8537','2013-08-19','10:45:00',3.91),('8537','2013-08-19','10:50:00',3.96),('8537','2013-08-19','10:55:00',3.95),('8537','2013-08-19','11:00:00',4.07),('8537','2013-08-19','11:05:00',4.09),('8537','2013-08-19','11:10:00',4.08),('8537','2013-08-19','11:15:00',4.13),('8537','2013-08-19','11:20:00',4.17),('8537','2013-08-19','11:25:00',4.12),('8537','2013-08-19','11:30:00',4.24),('8537','2013-08-19','11:35:00',4.27),('8537','2013-08-19','11:40:00',4.29),('8537','2013-08-19','11:45:00',4.3),('8537','2013-08-19','11:50:00',4.29),('8537','2013-08-19','11:55:00',4.36),('8537','2013-08-19','12:00:00',4.33),('8537','2013-08-19','12:05:00',4.43),('8537','2013-08-19','12:10:00',4.44),('8537','2013-08-19','12:15:00',4.48),('8537','2013-08-19','12:20:00',4.53),('8537','2013-08-19','12:25:00',4.5),('8537','2013-08-19','12:30:00',4.52),('8537','2013-08-19','12:35:00',4.56),('8537','2013-08-19','12:40:00',4.53),('8537','2013-08-19','12:45:00',4.61),('8537','2013-08-19','12:50:00',4.63),('8537','2013-08-19','12:55:00',4.64),('8537','2013-08-19','13:00:00',4.63),('8537','2013-08-19','13:05:00',4.65),('8537','2013-08-19','13:10:00',4.67),('8537','2013-08-19','13:15:00',4.62),('8537','2013-08-19','13:20:00',4.66),('8537','2013-08-19','13:25:00',4.61),('8537','2013-08-19','13:30:00',4.62),('8537','2013-08-19','13:35:00',4.55),('8537','2013-08-19','13:40:00',4.63),('8537','2013-08-19','13:45:00',4.61),('8537','2013-08-19','13:50:00',4.61),('8537','2013-08-19','13:55:00',4.62),('8537','2013-08-19','14:00:00',4.58),('8537','2013-08-19','14:05:00',4.57),('8537','2013-08-19','14:10:00',4.56),('8537','2013-08-19','14:15:00',4.52),('8537','2013-08-19','14:20:00',4.51),('8537','2013-08-19','14:25:00',4.48),('8537','2013-08-19','14:30:00',4.46),('8537','2013-08-19','14:35:00',4.41),('8537','2013-08-19','14:40:00',4.21),('8537','2013-08-19','14:45:00',3.91),('8537','2013-08-19','14:50:00',3.73),('8537','2013-08-19','14:55:00',4.22),('8537','2013-08-19','15:00:00',4.19),('8537','2013-08-19','15:05:00',4.16),('8537','2013-08-19','15:10:00',4.12),('8537','2013-08-19','15:15:00',4.07),('8537','2013-08-19','15:20:00',4.02),('8537','2013-08-19','15:25:00',3.98),('8537','2013-08-19','15:30:00',3.85),('8537','2013-08-19','15:35:00',3.73),('8537','2013-08-19','15:40:00',3.78),('8537','2013-08-19','15:45:00',3.7),('8537','2013-08-19','15:50:00',3.64),('8537','2013-08-19','15:55:00',3.57),('8537','2013-08-19','16:00:00',3.5),('8537','2013-08-19','16:05:00',3.43),('8537','2013-08-19','16:10:00',3.36),('8537','2013-08-19','16:15:00',2.99),('8537','2013-08-19','16:20:00',2.86),('8537','2013-08-19','16:25:00',3.05),('8537','2013-08-19','16:30:00',3.01),('8537','2013-08-19','16:35:00',2.96),('8537','2013-08-19','16:40:00',2.89),('8537','2013-08-19','16:45:00',2.81),('8537','2013-08-19','16:50:00',2.68),('8537','2013-08-19','16:55:00',2.6),('8537','2013-08-19','17:00:00',2.51),('8537','2013-08-19','17:05:00',2.42),('8537','2013-08-19','17:10:00',2.25),('8537','2013-08-19','17:15:00',2.1),('8537','2013-08-19','17:20:00',2.09),('8537','2013-08-19','17:25:00',1.98),('8537','2013-08-19','17:30:00',1.87),('8537','2013-08-19','17:35:00',1.78),('8537','2013-08-19','17:40:00',1.65),('8537','2013-08-19','17:45:00',1.56),('8537','2013-08-19','17:50:00',1.47),('8537','2013-08-19','17:55:00',1.36),('8537','2013-08-19','18:00:00',1.27),('8537','2013-08-19','18:05:00',1.18),('8537','2013-08-19','18:10:00',1.08),('8537','2013-08-18','07:55:00',1.06),('8537','2013-08-18','08:00:00',1.16),('8537','2013-08-18','08:05:00',1.26),('8537','2013-08-18','08:10:00',1.37),('8537','2013-08-18','08:15:00',1.47),('8537','2013-08-18','08:20:00',1.58),('8537','2013-08-18','08:25:00',1.68),('8537','2013-08-18','08:30:00',1.79),('8537','2013-08-18','08:35:00',1.89),('8537','2013-08-18','08:40:00',2),('8537','2013-08-18','08:45:00',2.07),('8537','2013-08-18','08:50:00',2.18),('8537','2013-08-18','08:55:00',2.27),('8537','2013-08-18','09:00:00',2.36),('8537','2013-08-18','09:05:00',2.46),('8537','2013-08-18','09:10:00',2.57),('8537','2013-08-18','09:15:00',2.67),('8537','2013-08-18','09:20:00',2.76),('8537','2013-08-18','09:25:00',2.85),('8537','2013-08-18','09:30:00',2.95),('8537','2013-08-18','09:35:00',3.03),('8537','2013-08-18','09:40:00',3.15),('8537','2013-08-18','09:45:00',2.9),('8537','2013-08-18','09:50:00',3.11),('8537','2013-08-18','09:55:00',2.5),('8537','2013-08-18','10:00:00',3.39),('8537','2013-08-18','10:05:00',2.9),('8537','2013-08-18','10:10:00',3.16),('8537','2013-08-18','10:15:00',3.57),('8537','2013-08-18','10:20:00',3.61),('8537','2013-08-18','10:25:00',3.67),('8537','2013-08-18','10:30:00',3.7),('8537','2013-08-18','10:35:00',3.77),('8537','2013-08-18','10:40:00',3.84),('8537','2013-08-18','10:45:00',3.88),('8537','2013-08-18','10:50:00',3.92),('8537','2013-08-18','10:55:00',3.95),('8537','2013-08-18','11:00:00',3.93),('8537','2013-08-18','11:05:00',4.02),('8537','2013-08-18','11:10:00',4.1),('8537','2013-08-18','11:15:00',4.1),('8537','2013-08-18','11:20:00',4.13),('8537','2013-08-18','11:25:00',4.2),('8537','2013-08-18','11:30:00',4.23),('8537','2013-08-18','11:35:00',4.28),('8537','2013-08-18','11:40:00',4.31),('8537','2013-08-18','11:45:00',4.31),('8537','2013-08-18','11:50:00',4.38),('8537','2013-08-18','11:55:00',4.36),('8537','2013-08-18','12:00:00',4.36),('8537','2013-08-18','12:05:00',4.45),('8537','2013-08-18','12:10:00',4.43),('8537','2013-08-18','12:15:00',4.11),('8537','2013-08-18','12:20:00',4.54),('8537','2013-08-18','12:25:00',4.61),('8537','2013-08-18','12:30:00',4.59),('8537','2013-08-18','12:35:00',3.67),('8537','2013-08-18','12:40:00',1.32),('8537','2013-08-18','12:45:00',2.27),('8537','2013-08-18','12:50:00',1.89),('8537','2013-08-18','12:55:00',1.29),('8537','2013-08-18','13:00:00',1.68),('8537','2013-08-18','13:05:00',5.05),('8537','2013-08-18','13:10:00',4.9),('8537','2013-08-18','13:15:00',3.65),('8537','2013-08-18','13:20:00',4.04),('8537','2013-08-18','13:25:00',4.73),('8537','2013-08-18','13:30:00',4.73),('8537','2013-08-18','13:35:00',4.6),('8537','2013-08-18','13:40:00',4.71),('8537','2013-08-18','13:45:00',4.65),('8537','2013-08-18','13:50:00',4.65),('8537','2013-08-18','13:55:00',4.56),('8537','2013-08-18','14:00:00',4.66),('8537','2013-08-18','14:05:00',4.6),('8537','2013-08-18','14:10:00',4.51),('8537','2013-08-18','14:15:00',4.51),('8537','2013-08-18','14:20:00',4.47),('8537','2013-08-18','14:25:00',4.46),('8537','2013-08-18','14:30:00',4.46),('8537','2013-08-18','14:35:00',4.43),('8537','2013-08-18','14:40:00',4.26),('8537','2013-08-18','14:45:00',3.96),('8537','2013-08-18','14:50:00',4.1),('8537','2013-08-18','14:55:00',4.23),('8537','2013-08-18','15:00:00',4.18),('8537','2013-08-18','15:05:00',4.15),('8537','2013-08-18','15:10:00',4.08),('8537','2013-08-18','15:15:00',4.04),('8537','2013-08-18','15:20:00',3.99),('8537','2013-08-18','15:25:00',3.93),('8537','2013-08-18','15:30:00',3.83),('8537','2013-08-18','15:35:00',3.71),('8537','2013-08-18','15:40:00',3.73),('8537','2013-08-18','15:45:00',3.7),('8537','2013-08-18','15:50:00',3.64),('8537','2013-08-18','15:55:00',3.55),('8537','2013-08-18','16:00:00',3.5),('8537','2013-08-18','16:05:00',3.41),('8537','2013-08-18','16:10:00',3.35),('8537','2013-08-18','16:15:00',3.05),('8537','2013-08-18','16:20:00',2.94),('8537','2013-08-18','16:25:00',3.09),('8537','2013-08-18','16:30:00',3.02),('8537','2013-08-18','16:35:00',2.95),('8537','2013-08-18','16:40:00',2.88),('8537','2013-08-18','16:45:00',2.78),('8537','2013-08-18','16:50:00',2.66),('8537','2013-08-18','16:55:00',2.58),('8537','2013-08-18','17:00:00',2.51),('8537','2013-08-18','17:05:00',2.42),('8537','2013-08-18','17:10:00',2.28),('8537','2013-08-18','17:15:00',2.07),('8537','2013-08-18','17:20:00',2.1),('8537','2013-08-18','17:25:00',2.01),('8537','2013-08-18','17:30:00',1.91),('8537','2013-08-18','17:35:00',1.79),('8537','2013-08-18','17:40:00',1.67),('8537','2013-08-18','17:45:00',1.56),('8537','2013-08-18','17:50:00',1.46),('8537','2013-08-18','17:55:00',1.37),('8537','2013-08-18','18:00:00',1.27),('8537','2013-08-18','18:05:00',1.17),('8537','2013-08-18','18:10:00',1.09),('8537','2013-08-18','18:15:00',1),('8537','2013-08-17','07:55:00',1.04),('8537','2013-08-17','08:00:00',1.12),('8537','2013-08-17','08:05:00',1.23),('8537','2013-08-17','08:10:00',1.32),('8537','2013-08-17','08:15:00',1.42),('8537','2013-08-17','08:20:00',1.53),('8537','2013-08-17','08:25:00',1.63),('8537','2013-08-17','08:30:00',1.72),('8537','2013-08-17','08:35:00',1.84),('8537','2013-08-17','08:40:00',1.96),('8537','2013-08-17','08:45:00',2.06),('8537','2013-08-17','08:50:00',2.16),('8537','2013-08-17','08:55:00',2.27),('8537','2013-08-17','09:00:00',2.36),('8537','2013-08-17','09:05:00',2.46),('8537','2013-08-17','09:10:00',2.54),('8537','2013-08-17','09:15:00',2.62),('8537','2013-08-17','09:20:00',2.72),('8537','2013-08-17','09:25:00',2.82),('8537','2013-08-17','09:30:00',2.91),('8537','2013-08-17','09:35:00',2.98),('8537','2013-08-17','09:40:00',3.07),('8537','2013-08-17','09:45:00',3.14),('8537','2013-08-17','09:50:00',3.21),('8537','2013-08-17','09:55:00',3.29),('8537','2013-08-17','10:00:00',3.38),('8537','2013-08-17','10:05:00',3.46),('8537','2013-08-17','10:10:00',3.53),('8537','2013-08-17','10:15:00',3.58),('8537','2013-08-17','10:20:00',3.62),('8537','2013-08-17','10:25:00',3.68),('8537','2013-08-17','10:30:00',3.72),('8537','2013-08-17','10:35:00',3.79),('8537','2013-08-17','10:40:00',3.81),('8537','2013-08-17','10:45:00',3.84),('8537','2013-08-17','10:50:00',3.94),('8537','2013-08-17','10:55:00',4.01),('8537','2013-08-17','11:00:00',4.05),('8537','2013-08-17','11:05:00',4.1),('8537','2013-08-17','11:10:00',4.15),('8537','2013-08-17','11:15:00',4.2),('8537','2013-08-17','11:20:00',4.22),('8537','2013-08-17','11:25:00',4.24),('8537','2013-08-17','11:30:00',4.31),('8537','2013-08-17','11:35:00',4.31),('8537','2013-08-17','11:40:00',4.28),('8537','2013-08-17','11:45:00',4.34),('8537','2013-08-17','11:50:00',4.43),('8537','2013-08-17','11:55:00',4.39),('8537','2013-08-17','12:00:00',4.4),('8537','2013-08-17','12:05:00',4.52),('8537','2013-08-17','12:10:00',4.46),('8537','2013-08-17','12:15:00',4.47),('8537','2013-08-17','12:20:00',4.56),('8537','2013-08-17','12:25:00',4.55),('8537','2013-08-17','12:30:00',4.59),('8537','2013-08-17','12:35:00',4.57),('8537','2013-08-17','12:40:00',4.5),('8537','2013-08-17','12:45:00',4.65),('8537','2013-08-17','12:50:00',4.62),('8537','2013-08-17','12:55:00',4.59),('8537','2013-08-17','13:00:00',4.65),('8537','2013-08-17','13:05:00',4.64),('8537','2013-08-17','13:10:00',4.79),('8537','2013-08-17','13:15:00',4.75),('8537','2013-08-17','13:20:00',4.8),('8537','2013-08-17','13:25:00',4.78),('8537','2013-08-17','13:30:00',4.82),('8537','2013-08-17','13:35:00',4.87),('8537','2013-08-17','13:40:00',1.74),('8537','2013-08-17','13:45:00',2.3),('8537','2013-08-17','13:50:00',4.27),('8537','2013-08-17','13:55:00',1.19),('8537','2013-08-17','14:00:00',4.32),('8537','2013-08-17','14:05:00',4.74),('8537','2013-08-17','14:10:00',4.56),('8537','2013-08-17','14:15:00',4.05),('8537','2013-08-17','14:20:00',4.63),('8537','2013-08-17','14:25:00',4.6),('8537','2013-08-17','14:30:00',4.52),('8537','2013-08-17','14:35:00',4.39),('8537','2013-08-17','14:40:00',4.34),('8537','2013-08-17','14:45:00',4.02),('8537','2013-08-17','14:50:00',4.28),('8537','2013-08-17','14:55:00',4.19),('8537','2013-08-17','15:00:00',4.21),('8537','2013-08-17','15:05:00',4.12),('8537','2013-08-17','15:10:00',4.06),('8537','2013-08-17','15:15:00',3.99),('8537','2013-08-17','15:20:00',4.03),('8537','2013-08-17','15:25:00',3.94),('8537','2013-08-17','15:30:00',3.86),('8537','2013-08-17','15:35:00',3.83),('8537','2013-08-17','15:40:00',3.77),('8537','2013-08-17','15:45:00',3.69),('8537','2013-08-17','15:50:00',3.64),('8537','2013-08-17','15:55:00',3.58),('8537','2013-08-17','16:00:00',3.51),('8537','2013-08-17','16:05:00',3.43),('8537','2013-08-17','16:10:00',3.36),('8537','2013-08-17','16:15:00',3.14),('8537','2013-08-17','16:20:00',3.11),('8537','2013-08-17','16:25:00',3.14),('8537','2013-08-17','16:30:00',3.04),('8537','2013-08-17','16:35:00',3),('8537','2013-08-17','16:40:00',2.94),('8537','2013-08-17','16:45:00',2.83),('8537','2013-08-17','16:50:00',2.68),('8537','2013-08-17','16:55:00',2.65),('8537','2013-08-17','17:00:00',2.57),('8537','2013-08-17','17:05:00',2.43),('8537','2013-08-17','17:10:00',2.31),('8537','2013-08-17','17:15:00',1.97),('8537','2013-08-17','17:20:00',2.07),('8537','2013-08-17','17:25:00',2.07),('8537','2013-08-17','17:30:00',2.03),('8537','2013-08-17','17:35:00',1.92),('8537','2013-08-17','17:40:00',1.82),('8537','2013-08-17','17:45:00',1.67),('8537','2013-08-17','17:50:00',1.57),('8537','2013-08-17','17:55:00',1.48),('8537','2013-08-17','18:00:00',1.37),('8537','2013-08-17','18:05:00',1.25),('8537','2013-08-17','18:10:00',1.15),('8537','2013-08-17','18:15:00',1.06),('8537','2013-08-16','07:55:00',1.05),('8537','2013-08-16','08:00:00',1.16),('8537','2013-08-16','08:05:00',1.26),('8537','2013-08-16','08:10:00',1.36),('8537','2013-08-16','08:15:00',1.47),('8537','2013-08-16','08:20:00',1.58),('8537','2013-08-16','08:25:00',1.69),('8537','2013-08-16','08:30:00',1.8),('8537','2013-08-16','08:35:00',1.9),('8537','2013-08-16','08:40:00',2.01),('8537','2013-08-16','08:45:00',2.11),('8537','2013-08-16','08:50:00',2.22),('8537','2013-08-16','08:55:00',2.33),('8537','2013-08-16','09:00:00',2.43),('8537','2013-08-16','09:05:00',2.53),('8537','2013-08-16','09:10:00',2.62),('8537','2013-08-16','09:15:00',2.72),('8537','2013-08-16','09:20:00',2.83),('8537','2013-08-16','09:25:00',2.92),('8537','2013-08-16','09:30:00',3.02),('8537','2013-08-16','09:35:00',3.11),('8537','2013-08-16','09:40:00',3.2),('8537','2013-08-16','09:45:00',3.29),('8537','2013-08-16','09:50:00',3.37),('8537','2013-08-16','09:55:00',3.45),('8537','2013-08-16','10:00:00',3.51),('8537','2013-08-16','10:05:00',3.6),('8537','2013-08-16','10:10:00',3.65),('8537','2013-08-16','10:15:00',3.7),('8537','2013-08-16','10:20:00',3.78),('8537','2013-08-16','10:25:00',3.85),('8537','2013-08-16','10:30:00',3.87),('8537','2013-08-16','10:35:00',3.97),('8537','2013-08-16','10:40:00',4.02),('8537','2013-08-16','10:45:00',4.08),('8537','2013-08-16','10:50:00',4.13),('8537','2013-08-16','10:55:00',4.17),('8537','2013-08-16','11:00:00',4.22),('8537','2013-08-16','11:05:00',4.27),('8537','2013-08-16','11:10:00',4.32),('8537','2013-08-16','11:15:00',4.37),('8537','2013-08-16','11:20:00',4.39),('8537','2013-08-16','11:25:00',4.39),('8537','2013-08-16','11:30:00',4.42),('8537','2013-08-16','11:35:00',4.5),('8537','2013-08-16','11:40:00',4.51),('8537','2013-08-16','11:45:00',4.51),('8537','2013-08-16','11:50:00',4.52),('8537','2013-08-16','11:55:00',4.53),('8537','2013-08-16','12:00:00',4.59),('8537','2013-08-16','12:05:00',4.62),('8537','2013-08-16','12:10:00',4.68),('8537','2013-08-16','12:15:00',4.68),('8537','2013-08-16','12:20:00',4.7),('8537','2013-08-16','12:25:00',4.71),('8537','2013-08-16','12:30:00',4.72),('8537','2013-08-16','12:35:00',4.7),('8537','2013-08-16','12:40:00',4.71),('8537','2013-08-16','12:45:00',4.77),('8537','2013-08-16','12:50:00',4.8),('8537','2013-08-16','12:55:00',4.76),('8537','2013-08-16','13:00:00',4.76),('8537','2013-08-16','13:05:00',4.77),('8537','2013-08-16','13:10:00',4.77),('8537','2013-08-16','13:15:00',4.75),('8537','2013-08-16','13:20:00',4.73),('8537','2013-08-16','13:25:00',4.66),('8537','2013-08-16','13:30:00',4.58),('8537','2013-08-16','13:35:00',4.61),('8537','2013-08-16','13:40:00',4.61),('8537','2013-08-16','13:45:00',4.61),('8537','2013-08-16','13:50:00',4.64),('8537','2013-08-16','13:55:00',4.61),('8537','2013-08-16','14:00:00',4.58),('8537','2013-08-16','14:05:00',4.6),('8537','2013-08-16','14:10:00',4.55),('8537','2013-08-16','14:15:00',4.52),('8537','2013-08-16','14:20:00',4.46),('8537','2013-08-16','14:25:00',4.44),('8537','2013-08-16','14:30:00',4.4),('8537','2013-08-16','14:35:00',4.37),('8537','2013-08-16','14:40:00',4.23),('8537','2013-08-16','14:45:00',4.04),('8537','2013-08-16','14:50:00',4.19),('8537','2013-08-16','14:55:00',4.21),('8537','2013-08-16','15:00:00',4.14),('8537','2013-08-16','15:05:00',4.08),('8537','2013-08-16','15:10:00',4.05),('8537','2013-08-16','15:15:00',3.92),('8537','2013-08-16','15:20:00',3.98),('8537','2013-08-16','15:25:00',3.95),('8537','2013-08-16','15:30:00',3.88),('8537','2013-08-16','15:35:00',3.78),('8537','2013-08-16','15:40:00',3.72),('8537','2013-08-16','15:45:00',3.66),('8537','2013-08-16','15:50:00',3.62),('8537','2013-08-16','15:55:00',3.57),('8537','2013-08-16','16:00:00',3.5),('8537','2013-08-16','16:05:00',3.45),('8537','2013-08-16','16:10:00',3.38),('8537','2013-08-16','16:15:00',3.19),('8537','2013-08-16','16:20:00',3.18),('8537','2013-08-16','16:25:00',3.11),('8537','2013-08-16','16:30:00',3.04),('8537','2013-08-16','16:35:00',2.97),('8537','2013-08-16','16:40:00',2.91),('8537','2013-08-16','16:45:00',2.82),('8537','2013-08-16','16:50:00',2.7),('8537','2013-08-16','16:55:00',2.61),('8537','2013-08-16','17:00:00',2.52),('8537','2013-08-16','17:05:00',2.43),('8537','2013-08-16','17:10:00',2.33),('8537','2013-08-16','17:15:00',2.16),('8537','2013-08-16','17:20:00',2.09),('8537','2013-08-16','17:25:00',2),('8537','2013-08-16','17:30:00',1.91),('8537','2013-08-16','17:35:00',1.79),('8537','2013-08-16','17:40:00',1.7),('8537','2013-08-16','17:45:00',1.56),('8537','2013-08-16','17:50:00',1.48),('8537','2013-08-16','17:55:00',1.38),('8537','2013-08-16','18:00:00',1.28),('8537','2013-08-16','18:05:00',1.18),('8537','2013-08-16','18:10:00',1.1),('8537','2013-08-16','18:15:00',1.01),('8537','2013-08-15','08:00:00',1.15),('8537','2013-08-15','08:05:00',1.53),('8537','2013-08-15','08:10:00',1.53),('8537','2013-08-15','08:15:00',1.28),('8537','2013-08-15','08:20:00',1.65),('8537','2013-08-15','08:25:00',1.74),('8537','2013-08-15','08:30:00',1.83),('8537','2013-08-15','08:35:00',1.93),('8537','2013-08-15','08:40:00',2.04),('8537','2013-08-15','08:45:00',2.16),('8537','2013-08-15','08:50:00',2.27),('8537','2013-08-15','08:55:00',2.34),('8537','2013-08-15','09:00:00',2.45),('8537','2013-08-15','09:05:00',2.38),('8537','2013-08-15','09:10:00',1.54),('8537','2013-08-15','09:15:00',2.23),('8537','2013-08-15','09:20:00',2.99),('8537','2013-08-15','09:25:00',2.93),('8537','2013-08-15','09:30:00',2.96),('8537','2013-08-15','09:35:00',3.07),('8537','2013-08-15','09:40:00',3.17),('8537','2013-08-15','09:45:00',3.27),('8537','2013-08-15','09:50:00',3.36),('8537','2013-08-15','09:55:00',3.43),('8537','2013-08-15','10:00:00',3.52),('8537','2013-08-15','10:05:00',3.6),('8537','2013-08-15','10:10:00',3.67),('8537','2013-08-15','10:15:00',3.75),('8537','2013-08-15','10:20:00',3.82),('8537','2013-08-15','10:25:00',3.89),('8537','2013-08-15','10:30:00',3.97),('8537','2013-08-15','10:35:00',4.01),('8537','2013-08-15','10:40:00',4.06),('8537','2013-08-15','10:45:00',4.09),('8537','2013-08-15','10:50:00',4.04),('8537','2013-08-15','10:55:00',3.91),('8537','2013-08-15','11:00:00',4.24),('8537','2013-08-15','11:05:00',3.19),('8537','2013-08-15','11:10:00',3),('8537','2013-08-15','11:15:00',3.33),('8537','2013-08-15','11:20:00',3.73),('8537','2013-08-15','11:25:00',4.15),('8537','2013-08-15','11:30:00',4.37),('8537','2013-08-15','11:35:00',4.63),('8537','2013-08-15','11:40:00',4.77),('8537','2013-08-15','11:45:00',4.91),('8537','2013-08-15','11:50:00',4.94),('8537','2013-08-15','11:55:00',4.93),('8537','2013-08-15','12:00:00',4.97),('8537','2013-08-15','12:05:00',4.94),('8537','2013-08-15','12:10:00',4.9),('8537','2013-08-15','12:15:00',4.91),('8537','2013-08-15','12:20:00',4.9),('8537','2013-08-15','12:25:00',4.94),('8537','2013-08-15','12:30:00',4.8),('8537','2013-08-15','12:35:00',4.96),('8537','2013-08-15','12:40:00',4.91),('8537','2013-08-15','12:45:00',4.92),('8537','2013-08-15','12:50:00',4.91),('8537','2013-08-15','12:55:00',4.7),('8537','2013-08-15','13:00:00',4.62),('8537','2013-08-15','13:05:00',4.72),('8537','2013-08-15','13:10:00',4.64),('8537','2013-08-15','13:15:00',4.53),('8537','2013-08-15','13:20:00',4.6),('8537','2013-08-15','13:25:00',4.72),('8537','2013-08-15','13:30:00',4.82),('8537','2013-08-15','13:35:00',4.83),('8537','2013-08-15','13:40:00',4.76),('8537','2013-08-15','13:45:00',4.71),('8537','2013-08-15','13:50:00',4.69),('8537','2013-08-15','13:55:00',4.66),('8537','2013-08-15','14:00:00',4.72),('8537','2013-08-15','14:05:00',4.71),('8537','2013-08-15','14:10:00',4.69),('8537','2013-08-15','14:15:00',4.65),('8537','2013-08-15','14:20:00',4.62),('8537','2013-08-15','14:25:00',4.47),('8537','2013-08-15','14:30:00',4.39),('8537','2013-08-15','14:35:00',4.53),('8537','2013-08-15','14:40:00',4.41),('8537','2013-08-15','14:45:00',4.09),('8537','2013-08-15','14:50:00',4.28),('8537','2013-08-15','14:55:00',4.23),('8537','2013-08-15','15:00:00',4.18),('8537','2013-08-15','15:05:00',4.15),('8537','2013-08-15','15:10:00',4.11),('8537','2013-08-15','15:15:00',4.08),('8537','2013-08-15','15:20:00',3.99),('8537','2013-08-15','15:25:00',3.92),('8537','2013-08-15','15:30:00',3.87),('8537','2013-08-15','15:35:00',3.77),('8537','2013-08-15','15:40:00',3.72),('8537','2013-08-15','15:45:00',3.64),('8537','2013-08-15','15:50:00',3.57),('8537','2013-08-15','15:55:00',3.55),('8537','2013-08-15','16:00:00',3.48),('8537','2013-08-15','16:05:00',3.4),('8537','2013-08-15','16:10:00',3.27),('8537','2013-08-15','16:15:00',3.17),('8537','2013-08-15','16:20:00',3.17),('8537','2013-08-15','16:25:00',3.07),('8537','2013-08-15','16:30:00',2.91),('8537','2013-08-15','16:35:00',2.86),('8537','2013-08-15','16:40:00',2.82),('8537','2013-08-15','16:45:00',2.75),('8537','2013-08-15','16:50:00',2.63),('8537','2013-08-15','16:55:00',2.52),('8537','2013-08-15','17:00:00',2.46),('8537','2013-08-15','17:05:00',2.37),('8537','2013-08-15','17:10:00',2.26),('8537','2013-08-15','17:15:00',2.17),('8537','2013-08-15','17:20:00',2.09),('8537','2013-08-15','17:25:00',1.97),('8537','2013-08-15','17:30:00',1.91),('8537','2013-08-15','17:35:00',1.77),('8537','2013-08-15','17:40:00',1.69),('8537','2013-08-15','17:45:00',1.57),('8537','2013-08-15','17:50:00',1.49),('8537','2013-08-15','17:55:00',1.38),('8537','2013-08-15','18:00:00',1.29),('8537','2013-08-15','18:05:00',1.19),('8537','2013-08-15','18:10:00',1.08),('8537','2013-08-15','18:15:00',1.01),('8537','2013-08-14','07:55:00',1.06),('8537','2013-08-14','08:00:00',1.15),('8537','2013-08-14','08:05:00',1.24),('8537','2013-08-14','08:10:00',1.34),('8537','2013-08-14','08:15:00',1.45),('8537','2013-08-14','08:20:00',1.49),('8537','2013-08-14','08:25:00',1.55),('8537','2013-08-14','08:30:00',1.7),('8537','2013-08-14','08:35:00',1.82),('8537','2013-08-14','08:40:00',2),('8537','2013-08-14','08:45:00',2.1),('8537','2013-08-14','08:50:00',1.98),('8537','2013-08-14','08:55:00',2.19),('8537','2013-08-14','09:00:00',2.34),('8537','2013-08-14','09:05:00',2.41),('8537','2013-08-14','09:10:00',2.63),('8537','2013-08-14','09:15:00',2.72),('8537','2013-08-14','09:20:00',2.82),('8537','2013-08-14','09:25:00',2.71),('8537','2013-08-14','09:30:00',3.05),('8537','2013-08-14','09:35:00',3.17),('8537','2013-08-14','09:40:00',2.65),('8537','2013-08-14','09:45:00',1.12),('8537','2013-08-14','09:50:00',1.21),('8537','2013-08-14','09:55:00',1.79),('8537','2013-08-14','10:00:00',2.06),('8537','2013-08-14','10:05:00',3.5),('8537','2013-08-14','10:10:00',3.4),('8537','2013-08-14','10:15:00',3.36),('8537','2013-08-14','10:20:00',2.71),('8537','2013-08-14','10:25:00',1.59),('8537','2013-08-14','10:30:00',4.14),('8537','2013-08-14','10:35:00',4.07),('8537','2013-08-14','10:40:00',3.66),('8537','2013-08-14','10:45:00',3.04),('8537','2013-08-14','10:50:00',1.71),('8537','2013-08-14','10:55:00',1.6),('8537','2013-08-14','11:00:00',4.05),('8537','2013-08-14','11:05:00',4),('8537','2013-08-14','11:10:00',3.79),('8537','2013-08-14','11:15:00',4.06),('8537','2013-08-14','11:20:00',2.83),('8537','2013-08-14','11:25:00',3.38),('8537','2013-08-14','11:30:00',4.53),('8537','2013-08-14','11:35:00',4.49),('8537','2013-08-14','11:40:00',4.47),('8537','2013-08-14','11:45:00',3.83),('8537','2013-08-14','11:50:00',3.63),('8537','2013-08-14','11:55:00',3.22),('8537','2013-08-14','12:00:00',2),('8537','2013-08-14','12:05:00',3.46),('8537','2013-08-14','12:10:00',3.19),('8537','2013-08-14','12:15:00',2.37),('8537','2013-08-14','12:20:00',1.83),('8537','2013-08-14','12:25:00',2.02),('8537','2013-08-14','12:30:00',2.75),('8537','2013-08-14','12:35:00',1.54),('8537','2013-08-14','12:40:00',1.5),('8537','2013-08-14','12:45:00',1.69),('8537','2013-08-14','12:50:00',2.12),('8537','2013-08-14','12:55:00',2.73),('8537','2013-08-14','13:00:00',2.91),('8537','2013-08-14','13:05:00',1.23),('8537','2013-08-14','13:10:00',1.18),('8537','2013-08-14','13:15:00',1.1),('8537','2013-08-14','13:20:00',1.06),('8537','2013-08-14','13:25:00',2.01),('8537','2013-08-14','13:30:00',3.56),('8537','2013-08-14','13:35:00',3.29),('8537','2013-08-14','13:40:00',2.77),('8537','2013-08-14','13:45:00',5.12),('8537','2013-08-14','13:50:00',5.15),('8537','2013-08-14','13:55:00',3.05),('8537','2013-08-14','14:00:00',3.35),('8537','2013-08-14','14:05:00',4.37),('8537','2013-08-14','14:10:00',3.16),('8537','2013-08-14','14:15:00',4.26),('8537','2013-08-14','14:20:00',4.88),('8537','2013-08-14','14:25:00',4.76),('8537','2013-08-14','14:30:00',4.02),('8537','2013-08-14','14:35:00',4.04),('8537','2013-08-14','14:40:00',4.53),('8537','2013-08-14','14:45:00',4.31),('8537','2013-08-14','14:50:00',4.25),('8537','2013-08-14','14:55:00',4.33),('8537','2013-08-14','15:00:00',4.3),('8537','2013-08-14','15:05:00',4.16),('8537','2013-08-14','15:10:00',4.16),('8537','2013-08-14','15:15:00',4.19),('8537','2013-08-14','15:20:00',4.15),('8537','2013-08-14','15:25:00',4.06),('8537','2013-08-14','15:30:00',3.93),('8537','2013-08-14','15:35:00',3.71),('8537','2013-08-14','15:40:00',3.78),('8537','2013-08-14','15:45:00',3.7),('8537','2013-08-14','15:50:00',3.69),('8537','2013-08-14','15:55:00',3.61),('8537','2013-08-14','16:00:00',3.55),('8537','2013-08-14','16:05:00',3.48),('8537','2013-08-14','16:10:00',3.46),('8537','2013-08-14','16:15:00',3.35),('8537','2013-08-14','16:20:00',3.26),('8537','2013-08-14','16:25:00',3.19),('8537','2013-08-14','16:30:00',3.1),('8537','2013-08-14','16:35:00',3.06),('8537','2013-08-14','16:40:00',2.98),('8537','2013-08-14','16:45:00',2.89),('8537','2013-08-14','16:50:00',2.8),('8537','2013-08-14','16:55:00',2.69),('8537','2013-08-14','17:00:00',2.59),('8537','2013-08-14','17:05:00',2.48),('8537','2013-08-14','17:10:00',2.4),('8537','2013-08-14','17:15:00',2.21),('8537','2013-08-14','17:20:00',2.14),('8537','2013-08-14','17:25:00',2.07),('8537','2013-08-14','17:30:00',1.98),('8537','2013-08-14','17:35:00',1.86),('8537','2013-08-14','17:40:00',1.77),('8537','2013-08-14','17:45:00',1.63),('8537','2013-08-14','17:50:00',1.54),('8537','2013-08-14','17:55:00',1.46),('8537','2013-08-14','18:00:00',1.36),('8537','2013-08-14','18:05:00',1.25),('8537','2013-08-14','18:10:00',1.15),('8537','2013-08-14','18:15:00',1.07),('8537','2013-08-14','18:20:00',1.04),('8537','2013-08-13','07:55:00',1.08),('8537','2013-08-13','08:00:00',1.19),('8537','2013-08-13','08:05:00',1.27),('8537','2013-08-13','08:10:00',1.37),('8537','2013-08-13','08:15:00',1.45),('8537','2013-08-13','08:20:00',1.55),('8537','2013-08-13','08:25:00',1.68),('8537','2013-08-13','08:30:00',1.8),('8537','2013-08-13','08:35:00',1.91),('8537','2013-08-13','08:40:00',2),('8537','2013-08-13','08:45:00',2.09),('8537','2013-08-13','08:50:00',2.2),('8537','2013-08-13','08:55:00',2.3),('8537','2013-08-13','09:00:00',2.42),('8537','2013-08-13','09:05:00',2.51),('8537','2013-08-13','09:10:00',2.6),('8537','2013-08-13','09:15:00',2.65),('8537','2013-08-13','09:20:00',2.73),('8537','2013-08-13','09:25:00',2.8),('8537','2013-08-13','09:30:00',2.94),('8537','2013-08-13','09:35:00',3.04),('8537','2013-08-13','09:40:00',3.05),('8537','2013-08-13','09:45:00',3.11),('8537','2013-08-13','09:50:00',3.13),('8537','2013-08-13','09:55:00',2.22),('8537','2013-08-13','10:00:00',3.2),('8537','2013-08-13','10:05:00',3.44),('8537','2013-08-13','10:10:00',3.52),('8537','2013-08-13','10:15:00',3.65),('8537','2013-08-13','10:20:00',3.65),('8537','2013-08-13','10:25:00',3.61),('8537','2013-08-13','10:30:00',3.62),('8537','2013-08-13','10:35:00',3.88),('8537','2013-08-13','10:40:00',3.92),('8537','2013-08-13','10:45:00',3.93),('8537','2013-08-13','10:50:00',4.05),('8537','2013-08-13','10:55:00',4.06),('8537','2013-08-13','11:00:00',4.1),('8537','2013-08-13','11:05:00',4.12),('8537','2013-08-13','11:10:00',4.17),('8537','2013-08-13','11:15:00',4.2),('8537','2013-08-13','11:20:00',4.25),('8537','2013-08-13','11:25:00',4.27),('8537','2013-08-13','11:30:00',4.33),('8537','2013-08-13','11:35:00',4.35),('8537','2013-08-13','11:40:00',4.34),('8537','2013-08-13','11:45:00',4.38),('8537','2013-08-13','11:50:00',4.44),('8537','2013-08-13','11:55:00',4.53),('8537','2013-08-13','12:00:00',4.59),('8537','2013-08-13','12:05:00',4.64),('8537','2013-08-13','12:10:00',4.68),('8537','2013-08-13','12:15:00',4.73),('8537','2013-08-13','12:20:00',4.7),('8537','2013-08-13','12:25:00',4.88),('8537','2013-08-13','12:30:00',4.88),('8537','2013-08-13','12:35:00',4.91),('8537','2013-08-13','12:40:00',4.74),('8537','2013-08-13','12:45:00',2.3),('8537','2013-08-13','12:50:00',1.95),('8537','2013-08-13','12:55:00',5.16),('8537','2013-08-13','13:00:00',2.05),('8537','2013-08-13','13:05:00',1.5),('8537','2013-08-13','13:10:00',1.4),('8537','2013-08-13','13:15:00',1.87),('8537','2013-08-13','13:20:00',4.89),('8537','2013-08-13','13:25:00',5.21),('8537','2013-08-13','13:30:00',5.14),('8537','2013-08-13','13:35:00',5.04),('8537','2013-08-13','13:40:00',4.87),('8537','2013-08-13','13:45:00',4.82),('8537','2013-08-13','13:50:00',3.29),('8537','2013-08-13','13:55:00',3.73),('8537','2013-08-13','14:00:00',5.08),('8537','2013-08-13','14:05:00',4.27),('8537','2013-08-13','14:10:00',5.11),('8537','2013-08-13','14:15:00',5.07),('8537','2013-08-13','14:20:00',4.74),('8537','2013-08-13','14:25:00',3.14),('8537','2013-08-13','14:30:00',2.98),('8537','2013-08-13','14:35:00',5.14),('8537','2013-08-13','14:40:00',2.69),('8537','2013-08-13','14:45:00',2.8),('8537','2013-08-13','14:50:00',4.86),('8537','2013-08-13','14:55:00',4.75),('8537','2013-08-13','15:00:00',4.26),('8537','2013-08-13','15:05:00',2.83),('8537','2013-08-13','15:10:00',4.13),('8537','2013-08-13','15:15:00',3.29),('8537','2013-08-13','15:20:00',4.11),('8537','2013-08-13','15:25:00',4.12),('8537','2013-08-13','15:30:00',3.84),('8537','2013-08-13','15:35:00',3.93),('8537','2013-08-13','15:40:00',3.91),('8537','2013-08-13','15:45:00',3.78),('8537','2013-08-13','15:50:00',3.67),('8537','2013-08-13','15:55:00',3.61),('8537','2013-08-13','16:00:00',3.56),('8537','2013-08-13','16:05:00',3.48),('8537','2013-08-13','16:10:00',3.41),('8537','2013-08-13','16:15:00',3.29),('8537','2013-08-13','16:20:00',3.06),('8537','2013-08-13','16:25:00',2.9),('8537','2013-08-13','16:30:00',3.1),('8537','2013-08-13','16:35:00',3.03),('8537','2013-08-13','16:40:00',2.95),('8537','2013-08-13','16:45:00',2.88),('8537','2013-08-13','16:50:00',2.78),('8537','2013-08-13','16:55:00',2.65),('8537','2013-08-13','17:00:00',2.59),('8537','2013-08-13','17:05:00',2.51),('8537','2013-08-13','17:10:00',2.42),('8537','2013-08-13','17:15:00',2.28),('8537','2013-08-13','17:20:00',2.09),('8537','2013-08-13','17:25:00',2.08),('8537','2013-08-13','17:30:00',1.98),('8537','2013-08-13','17:35:00',1.87),('8537','2013-08-13','17:40:00',1.77),('8537','2013-08-13','17:45:00',1.65),('8537','2013-08-13','17:50:00',1.55),('8537','2013-08-13','17:55:00',1.45),('8537','2013-08-13','18:00:00',1.34),('8537','2013-08-13','18:05:00',1.25),('8537','2013-08-13','18:10:00',1.15),('8537','2013-08-13','18:15:00',1.06),('8537','2013-08-12','07:55:00',1.07),('8537','2013-08-12','08:00:00',1.17),('8537','2013-08-12','08:05:00',1.27),('8537','2013-08-12','08:10:00',1.36),('8537','2013-08-12','08:15:00',1.46),('8537','2013-08-12','08:20:00',1.57),('8537','2013-08-12','08:25:00',1.67),('8537','2013-08-12','08:30:00',1.77),('8537','2013-08-12','08:35:00',1.87),('8537','2013-08-12','08:40:00',1.97),('8537','2013-08-12','08:45:00',2.07),('8537','2013-08-12','08:50:00',2.16),('8537','2013-08-12','08:55:00',2.26),('8537','2013-08-12','09:00:00',2.37),('8537','2013-08-12','09:05:00',2.46),('8537','2013-08-12','09:10:00',2.55),('8537','2013-08-12','09:15:00',2.64),('8537','2013-08-12','09:20:00',2.74),('8537','2013-08-12','09:25:00',2.82),('8537','2013-08-12','09:30:00',2.9),('8537','2013-08-12','09:35:00',2.97),('8537','2013-08-12','09:40:00',3.04),('8537','2013-08-12','09:45:00',3.13),('8537','2013-08-12','09:50:00',3.21),('8537','2013-08-12','09:55:00',3.28),('8537','2013-08-12','10:00:00',3.34),('8537','2013-08-12','10:05:00',3.39),('8537','2013-08-12','10:10:00',3.45),('8537','2013-08-12','10:15:00',3.51),('8537','2013-08-12','10:20:00',3.56),('8537','2013-08-12','10:25:00',3.64),('8537','2013-08-12','10:30:00',3.71),('8537','2013-08-12','10:35:00',3.74),('8537','2013-08-12','10:40:00',3.72),('8537','2013-08-12','10:45:00',3.89),('8537','2013-08-12','10:50:00',3.94),('8537','2013-08-12','10:55:00',3.98),('8537','2013-08-12','11:00:00',4.01),('8537','2013-08-12','11:05:00',4.04),('8537','2013-08-12','11:10:00',4.09),('8537','2013-08-12','11:15:00',4.14),('8537','2013-08-12','11:20:00',4.11),('8537','2013-08-12','11:25:00',4.16),('8537','2013-08-12','11:30:00',4.24),('8537','2013-08-12','11:35:00',4.28),('8537','2013-08-12','11:40:00',4.35),('8537','2013-08-12','11:45:00',4.37),('8537','2013-08-12','11:50:00',4.41),('8537','2013-08-12','11:55:00',4.49),('8537','2013-08-12','12:00:00',4.66),('8537','2013-08-12','12:05:00',4.68),('8537','2013-08-12','12:10:00',4.66),('8537','2013-08-12','12:15:00',3.33),('8537','2013-08-12','12:20:00',3.21),('8537','2013-08-12','12:25:00',2.63),('8537','2013-08-12','12:30:00',1.14),('8537','2013-08-12','12:35:00',1.66),('8537','2013-08-12','12:40:00',2.27),('8537','2013-08-12','12:45:00',2.2),('8537','2013-08-12','12:50:00',2.57),('8537','2013-08-12','12:55:00',1.74),('8537','2013-08-12','13:00:00',1.32),('8537','2013-08-12','13:20:00',1.14),('8537','2013-08-12','13:25:00',1.76),('8537','2013-08-12','13:30:00',1.42),('8537','2013-08-12','13:35:00',1.42),('8537','2013-08-12','13:40:00',1.25),('8537','2013-08-12','13:45:00',1.32),('8537','2013-08-12','13:50:00',3.41),('8537','2013-08-12','13:55:00',4.51),('8537','2013-08-12','14:00:00',2.52),('8537','2013-08-12','14:05:00',1.17),('8537','2013-08-12','14:10:00',3.17),('8537','2013-08-12','14:15:00',2.17),('8537','2013-08-12','14:20:00',1.24),('8537','2013-08-12','14:35:00',1.24),('8537','2013-08-12','14:40:00',1.34),('8537','2013-08-12','14:45:00',1.49),('8537','2013-08-12','14:50:00',3.18),('8537','2013-08-12','14:55:00',4.92),('8537','2013-08-12','15:00:00',4.69),('8537','2013-08-12','15:05:00',4.52),('8537','2013-08-12','15:10:00',4.41),('8537','2013-08-12','15:15:00',3.47),('8537','2013-08-12','15:20:00',3.32),('8537','2013-08-12','15:25:00',4.17),('8537','2013-08-12','15:30:00',3.99),('8537','2013-08-12','15:35:00',3.77),('8537','2013-08-12','15:40:00',3.77),('8537','2013-08-12','15:45:00',3.69),('8537','2013-08-12','15:50:00',3.69),('8537','2013-08-12','15:55:00',3.63),('8537','2013-08-12','16:00:00',3.52),('8537','2013-08-12','16:05:00',3.49),('8537','2013-08-12','16:10:00',3.4),('8537','2013-08-12','16:15:00',3.32),('8537','2013-08-12','16:20:00',3.05),('8537','2013-08-12','16:25:00',2.67),('8537','2013-08-12','16:30:00',2.77),('8537','2013-08-12','16:35:00',2.96),('8537','2013-08-12','16:40:00',2.91),('8537','2013-08-12','16:45:00',2.81),('8537','2013-08-12','16:50:00',2.76),('8537','2013-08-12','16:55:00',2.57),('8537','2013-08-12','17:00:00',2.54),('8537','2013-08-12','17:05:00',2.46),('8537','2013-08-12','17:10:00',2.37),('8537','2013-08-12','17:15:00',2.24),('8537','2013-08-12','17:20:00',2.11),('8537','2013-08-12','17:25:00',2.02),('8537','2013-08-12','17:30:00',1.96),('8537','2013-08-12','17:35:00',1.86),('8537','2013-08-12','17:40:00',1.75),('8537','2013-08-12','17:45:00',1.63),('8537','2013-08-12','17:50:00',1.52),('8537','2013-08-12','17:55:00',1.44),('8537','2013-08-12','18:00:00',1.35),('8537','2013-08-12','18:05:00',1.27),('8537','2013-08-12','18:10:00',1.15),('8537','2013-08-12','18:15:00',1.07),('8537','2013-08-11','07:50:00',1.02),('8537','2013-08-11','07:55:00',1.12),('8537','2013-08-11','08:00:00',1.22),('8537','2013-08-11','08:05:00',1.33),('8537','2013-08-11','08:10:00',1.42),('8537','2013-08-11','08:15:00',1.52),('8537','2013-08-11','08:20:00',1.63),('8537','2013-08-11','08:25:00',1.7),('8537','2013-08-11','08:30:00',1.83),('8537','2013-08-11','08:35:00',1.92),('8537','2013-08-11','08:40:00',2.02),('8537','2013-08-11','08:45:00',2.14),('8537','2013-08-11','08:50:00',2.24),('8537','2013-08-11','08:55:00',2.34),('8537','2013-08-11','09:00:00',2.44),('8537','2013-08-11','09:05:00',2.53),('8537','2013-08-11','09:10:00',2.62),('8537','2013-08-11','09:15:00',2.71),('8537','2013-08-11','09:20:00',2.8),('8537','2013-08-11','09:25:00',2.89),('8537','2013-08-11','09:30:00',2.98),('8537','2013-08-11','09:35:00',3.06),('8537','2013-08-11','09:40:00',3.13),('8537','2013-08-11','09:45:00',3.24),('8537','2013-08-11','09:50:00',3.31),('8537','2013-08-11','09:55:00',3.4),('8537','2013-08-11','10:00:00',3.48),('8537','2013-08-11','10:05:00',3.56),('8537','2013-08-11','10:10:00',3.64),('8537','2013-08-11','10:15:00',3.74),('8537','2013-08-11','10:20:00',3.79),('8537','2013-08-11','10:25:00',3.84),('8537','2013-08-11','10:30:00',3.89),('8537','2013-08-11','10:35:00',3.93),('8537','2013-08-11','10:40:00',3.97),('8537','2013-08-11','10:45:00',4.02),('8537','2013-08-11','10:50:00',4.11),('8537','2013-08-11','10:55:00',4.13),('8537','2013-08-11','11:00:00',4.21),('8537','2013-08-11','11:05:00',4.28),('8537','2013-08-11','11:10:00',4.35),('8537','2013-08-11','11:15:00',4.32),('8537','2013-08-11','11:20:00',4.36),('8537','2013-08-11','11:25:00',4.44),('8537','2013-08-11','11:30:00',4.49),('8537','2013-08-11','11:35:00',4.5),('8537','2013-08-11','11:40:00',4.53),('8537','2013-08-11','11:45:00',4.53),('8537','2013-08-11','11:50:00',4.63),('8537','2013-08-11','11:55:00',4.64),('8537','2013-08-11','12:00:00',4.62),('8537','2013-08-11','12:05:00',4.65),('8537','2013-08-11','12:10:00',4.65),('8537','2013-08-11','12:15:00',4.66),('8537','2013-08-11','12:20:00',4.72),('8537','2013-08-11','12:25:00',4.76),('8537','2013-08-11','12:30:00',4.77),('8537','2013-08-11','12:35:00',4.75),('8537','2013-08-11','12:40:00',4.72),('8537','2013-08-11','12:45:00',4.74),('8537','2013-08-11','12:50:00',4.7),('8537','2013-08-11','12:55:00',4.75),('8537','2013-08-11','13:00:00',4.77),('8537','2013-08-11','13:05:00',4.7),('8537','2013-08-11','13:10:00',4.67),('8537','2013-08-11','13:15:00',4.76),('8537','2013-08-11','13:20:00',4.74),('8537','2013-08-11','13:25:00',4.79),('8537','2013-08-11','13:30:00',4.74),('8537','2013-08-11','13:35:00',4.7),('8537','2013-08-11','13:40:00',4.7),('8537','2013-08-11','13:45:00',4.68),('8537','2013-08-11','13:50:00',4.67),('8537','2013-08-11','13:55:00',4.68),('8537','2013-08-11','14:00:00',4.68),('8537','2013-08-11','14:05:00',4.64),('8537','2013-08-11','14:10:00',4.61),('8537','2013-08-11','14:15:00',4.51),('8537','2013-08-11','14:20:00',4.44),('8537','2013-08-11','14:25:00',4.48),('8537','2013-08-11','14:30:00',4.4),('8537','2013-08-11','14:35:00',4.38),('8537','2013-08-11','14:40:00',4.42),('8537','2013-08-11','14:45:00',4.33),('8537','2013-08-11','14:50:00',4.24),('8537','2013-08-11','14:55:00',4.16),('8537','2013-08-11','15:00:00',4.22),('8537','2013-08-11','15:05:00',4.2),('8537','2013-08-11','15:10:00',4.12),('8537','2013-08-11','15:15:00',4.04),('8537','2013-08-11','15:20:00',3.96),('8537','2013-08-11','15:25:00',3.99),('8537','2013-08-11','15:30:00',3.87),('8537','2013-08-11','15:35:00',3.64),('8537','2013-08-11','15:40:00',3.58),('8537','2013-08-11','15:45:00',3.61),('8537','2013-08-11','15:50:00',3.67),('8537','2013-08-11','15:55:00',3.6),('8537','2013-08-11','16:00:00',3.55),('8537','2013-08-11','16:05:00',3.49),('8537','2013-08-11','16:10:00',3.42),('8537','2013-08-11','16:15:00',3.33),('8537','2013-08-11','16:20:00',3.14),('8537','2013-08-11','16:25:00',2.9),('8537','2013-08-11','16:30:00',3.06),('8537','2013-08-11','16:35:00',2.99),('8537','2013-08-11','16:40:00',2.92),('8537','2013-08-11','16:45:00',2.83),('8537','2013-08-11','16:50:00',2.75),('8537','2013-08-11','16:55:00',2.62),('8537','2013-08-11','17:00:00',2.55),('8537','2013-08-11','17:05:00',2.46),('8537','2013-08-11','17:10:00',2.37),('8537','2013-08-11','17:15:00',2.25),('8537','2013-08-11','17:20:00',2.1),('8537','2013-08-11','17:25:00',2.05),('8537','2013-08-11','17:30:00',1.95),('8537','2013-08-11','17:35:00',1.88),('8537','2013-08-11','17:40:00',1.76),('8537','2013-08-11','17:45:00',1.66),('8537','2013-08-11','17:50:00',1.53),('8537','2013-08-11','17:55:00',1.45),('8537','2013-08-11','18:00:00',1.35),('8537','2013-08-11','18:05:00',1.26),('8537','2013-08-11','18:10:00',1.12),('8537','2013-08-11','18:15:00',1.02),('8537','2013-08-10','07:50:00',1.01),('8537','2013-08-10','07:55:00',1.11),('8537','2013-08-10','08:00:00',1.22),('8537','2013-08-10','08:05:00',1.33),('8537','2013-08-10','08:10:00',1.43),('8537','2013-08-10','08:15:00',1.55),('8537','2013-08-10','08:20:00',1.67),('8537','2013-08-10','08:25:00',1.78),('8537','2013-08-10','08:30:00',1.89),('8537','2013-08-10','08:35:00',1.99),('8537','2013-08-10','08:40:00',2.09),('8537','2013-08-10','08:45:00',2.18),('8537','2013-08-10','08:50:00',2.28),('8537','2013-08-10','08:55:00',2.38),('8537','2013-08-10','09:00:00',2.46),('8537','2013-08-10','09:05:00',2.56),('8537','2013-08-10','09:10:00',2.66),('8537','2013-08-10','09:15:00',2.77),('8537','2013-08-10','09:20:00',2.85),('8537','2013-08-10','09:25:00',2.94),('8537','2013-08-10','09:30:00',2.99),('8537','2013-08-10','09:35:00',3.11),('8537','2013-08-10','09:40:00',3.19),('8537','2013-08-10','09:45:00',3.29),('8537','2013-08-10','09:50:00',3.34),('8537','2013-08-10','09:55:00',3.41),('8537','2013-08-10','10:00:00',3.49),('8537','2013-08-10','10:05:00',3.55),('8537','2013-08-10','10:10:00',3.24),('8537','2013-08-10','10:15:00',3.12),('8537','2013-08-10','10:20:00',3.76),('8537','2013-08-10','10:25:00',3.83),('8537','2013-08-10','10:30:00',3.87),('8537','2013-08-10','10:35:00',3.89),('8537','2013-08-10','10:40:00',3.98),('8537','2013-08-10','10:45:00',4.03),('8537','2013-08-10','10:50:00',4.08),('8537','2013-08-10','10:55:00',4.18),('8537','2013-08-10','11:00:00',4.3),('8537','2013-08-10','11:05:00',4.32),('8537','2013-08-10','11:10:00',4.37),('8537','2013-08-10','11:15:00',3.63),('8537','2013-08-10','11:20:00',3.72),('8537','2013-08-10','11:25:00',3.06),('8537','2013-08-10','11:30:00',4.01),('8537','2013-08-10','11:35:00',4.55),('8537','2013-08-10','11:40:00',4.59),('8537','2013-08-10','11:45:00',4.6),('8537','2013-08-10','11:50:00',4.62),('8537','2013-08-10','11:55:00',4.63),('8537','2013-08-10','12:00:00',4.65),('8537','2013-08-10','12:05:00',4.67),('8537','2013-08-10','12:10:00',4.68),('8537','2013-08-10','12:15:00',4.73),('8537','2013-08-10','12:20:00',4.71),('8537','2013-08-10','12:25:00',4.79),('8537','2013-08-10','12:30:00',4.76),('8537','2013-08-10','12:35:00',4.79),('8537','2013-08-10','12:40:00',4.79),('8537','2013-08-10','12:45:00',4.88),('8537','2013-08-10','12:50:00',4.97),('8537','2013-08-10','12:55:00',4.94),('8537','2013-08-10','13:00:00',4.9),('8537','2013-08-10','13:05:00',4.87),('8537','2013-08-10','13:10:00',4.92),('8537','2013-08-10','13:15:00',5),('8537','2013-08-10','13:20:00',5.09),('8537','2013-08-10','13:25:00',5.14),('8537','2013-08-10','13:30:00',4.38),('8537','2013-08-10','13:35:00',3.9),('8537','2013-08-10','13:40:00',1.17),('8537','2013-08-10','13:45:00',1.35),('8537','2013-08-10','13:50:00',5.16),('8537','2013-08-10','13:55:00',4.95),('8537','2013-08-10','14:00:00',4.79),('8537','2013-08-10','14:05:00',3.38),('8537','2013-08-10','14:10:00',5.5),('8537','2013-08-10','14:15:00',5.07),('8537','2013-08-10','14:20:00',3.19),('8537','2013-08-10','14:25:00',1.52),('8537','2013-08-10','14:30:00',1.5),('8537','2013-08-10','14:35:00',1.33),('8537','2013-08-10','14:40:00',1.22),('8537','2013-08-10','14:45:00',1.15),('8537','2013-08-10','14:50:00',1.05),('8537','2013-08-10','14:55:00',1.01),('8537','2013-08-10','15:00:00',1.13),('8537','2013-08-10','15:05:00',1.23),('8537','2013-08-10','15:10:00',1.3),('8537','2013-08-10','15:15:00',1.48),('8537','2013-08-10','15:20:00',1.5),('8537','2013-08-10','15:25:00',1.34),('8537','2013-08-10','15:30:00',1.29),('8537','2013-08-10','15:35:00',1.6),('8537','2013-08-10','15:40:00',1.54),('8537','2013-08-10','15:45:00',1.65),('8537','2013-08-10','15:50:00',1.95),('8537','2013-08-10','15:55:00',2.22),('8537','2013-08-10','16:00:00',2.44),('8537','2013-08-10','16:05:00',4.76),('8537','2013-08-10','16:10:00',2.45),('8537','2013-08-10','16:15:00',2.51),('8537','2013-08-10','16:20:00',3.39),('8537','2013-08-10','16:25:00',1.44),('8537','2013-08-10','16:30:00',1.86),('8537','2013-08-10','16:35:00',3.45),('8537','2013-08-10','16:40:00',3.29),('8537','2013-08-10','16:45:00',3.22),('8537','2013-08-10','16:50:00',3.04),('8537','2013-08-10','16:55:00',2.77),('8537','2013-08-10','17:00:00',2.64),('8537','2013-08-10','17:05:00',1.64),('8537','2013-08-10','17:10:00',1.02),('8537','2013-08-10','17:15:00',1.19),('8537','2013-08-10','17:20:00',1.23),('8537','2013-08-10','17:25:00',1.45),('8537','2014-04-09','08:05:00',1.22),('8537','2014-04-09','08:10:00',1.14),('8537','2014-04-09','08:20:00',1.39),('8537','2014-04-09','09:00:00',1.02),('8537','2014-04-09','09:25:00',1.07),('8537','2014-04-09','09:30:00',1.15),('8537','2014-04-09','09:35:00',1.05),('8537','2014-04-09','09:40:00',1.06),('8537','2014-04-09','09:45:00',1.41),('8537','2014-04-09','09:50:00',2.26),('8537','2014-04-09','09:55:00',3.55),('8537','2014-04-09','10:00:00',3.49),('8537','2014-04-09','10:05:00',3.5),('8537','2014-04-09','10:10:00',3.66),('8537','2014-04-09','10:15:00',3.87),('8537','2014-04-09','10:20:00',3.89),('8537','2014-04-09','10:25:00',3.02),('8537','2014-04-09','10:30:00',3.18),('8537','2014-04-09','10:35:00',4.46),('8537','2014-04-09','10:40:00',1.76),('8537','2014-04-09','10:45:00',1.41),('8537','2014-04-09','10:50:00',1.69),('8537','2014-04-09','10:55:00',1.59),('8537','2014-04-09','11:00:00',4.31),('8537','2014-04-09','11:05:00',4.88),('8537','2014-04-09','11:10:00',4.88),('8537','2014-04-09','11:15:00',5.07),('8537','2014-04-09','11:20:00',4.46),('8537','2014-04-09','11:25:00',1.46),('8537','2014-04-09','11:30:00',1.26),('8537','2014-04-09','11:35:00',2.05),('8537','2014-04-09','11:40:00',5.11),('8537','2014-04-09','11:45:00',5.45),('8537','2014-04-09','11:50:00',4.48),('8537','2014-04-09','11:55:00',5.25),('8537','2014-04-09','12:00:00',5.45),('8537','2014-04-09','12:05:00',4.44),('8537','2014-04-09','12:10:00',2.46),('8537','2014-04-09','12:15:00',3.16),('8537','2014-04-09','12:20:00',1.64),('8537','2014-04-09','12:25:00',1.19),('8537','2014-04-09','13:15:00',1.01),('8537','2014-04-09','13:20:00',1.55),('8537','2014-04-09','13:25:00',1.82),('8537','2014-04-09','13:30:00',1.54),('8537','2014-04-09','13:35:00',1.46),('8537','2014-04-09','13:40:00',1.35),('8537','2014-04-09','13:45:00',1.2),('8537','2014-04-09','13:50:00',1.04),('8537','2014-04-09','14:00:00',1.08),('8537','2014-04-09','14:05:00',2.19),('8537','2014-04-09','14:10:00',2.29),('8537','2014-04-09','14:15:00',2.07),('8537','2014-04-09','14:20:00',2.26),('8537','2014-04-09','14:25:00',1.83),('8537','2014-04-09','14:30:00',3.17),('8537','2014-04-09','14:35:00',4.86),('8537','2014-04-09','14:40:00',2.38),('8537','2014-04-09','14:45:00',2.03),('8537','2014-04-09','14:50:00',2.35),('8537','2014-04-09','14:55:00',2.49),('8537','2014-04-09','15:00:00',2.79),('8537','2014-04-09','15:05:00',4.49),('8537','2014-04-09','15:10:00',3.92),('8537','2014-04-09','15:15:00',3.89),('8537','2014-04-09','15:20:00',4.31),('8537','2014-04-09','15:25:00',2.33),('8537','2014-04-09','15:30:00',3.79),('8537','2014-04-09','15:35:00',2.2),('8537','2014-04-09','15:40:00',2.4),('8537','2014-04-09','15:45:00',2.54),('8537','2014-04-09','15:50:00',2.07),('8537','2014-04-09','15:55:00',1.88),('8537','2014-04-09','16:00:00',1.44),('8537','2014-04-09','16:05:00',2.45),('8537','2014-04-09','16:10:00',3.31),('8537','2014-04-09','16:15:00',3.51),('8537','2014-04-09','16:20:00',3.5),('8537','2014-04-09','16:25:00',3.32),('8537','2014-04-09','16:30:00',3.4),('8537','2014-04-09','16:35:00',1.87),('8537','2014-04-09','16:40:00',1.61),('8537','2014-04-09','16:45:00',1.7),('8537','2014-04-09','16:50:00',2.09),('8537','2014-04-09','16:55:00',1.66),('8537','2014-04-09','17:00:00',1.99),('8537','2014-04-09','17:05:00',2.57),('8537','2014-04-09','17:10:00',2.07),('8537','2014-04-09','17:15:00',1.88),('8537','2014-04-09','17:20:00',2.07),('8537','2014-04-09','17:25:00',2.06),('8537','2014-04-09','17:30:00',1.39),('8537','2014-04-09','17:45:00',1.3),('8537','2014-04-09','17:50:00',1.29),('8537','2014-04-09','17:55:00',1.3),('8537','2014-04-09','18:00:00',1.13),('8537','2013-08-09','08:05:00',1.4),('8537','2013-08-09','08:10:00',1.12),('8537','2013-08-09','08:15:00',1.02),('8537','2013-08-09','08:30:00',1.06),('8537','2013-08-09','08:35:00',1.33),('8537','2013-08-09','08:40:00',1.69),('8537','2013-08-09','08:45:00',2.01),('8537','2013-08-09','08:50:00',2.06),('8537','2013-08-09','08:55:00',2.12),('8537','2013-08-09','09:00:00',2.16),('8537','2013-08-09','09:05:00',2.33),('8537','2013-08-09','09:10:00',2.61),('8537','2013-08-09','09:15:00',2.21),('8537','2013-08-09','09:20:00',2.42),('8537','2013-08-09','09:25:00',1.84),('8537','2013-08-09','09:30:00',2.91),('8537','2013-08-09','09:35:00',2.93),('8537','2013-08-09','09:40:00',2.07),('8537','2013-08-09','09:45:00',2.75),('8537','2013-08-09','09:50:00',3.01),('8537','2013-08-09','09:55:00',2),('8537','2013-08-09','10:00:00',2.32),('8537','2013-08-09','10:05:00',2.36),('8537','2013-08-09','10:10:00',2.58),('8537','2013-08-09','10:15:00',3.29),('8537','2013-08-09','10:20:00',3.3),('8537','2013-08-09','10:25:00',3.3),('8537','2013-08-09','10:30:00',2.8),('8537','2013-08-09','10:35:00',3.6),('8537','2013-08-09','10:40:00',3.77),('8537','2013-08-09','10:45:00',3.73),('8537','2013-08-09','10:50:00',3.73),('8537','2013-08-09','10:55:00',3.86),('8537','2013-08-09','11:00:00',3.92),('8537','2013-08-09','11:05:00',3.94),('8537','2013-08-09','11:10:00',4.01),('8537','2013-08-09','11:15:00',4.08),('8537','2013-08-09','11:20:00',4.08),('8537','2013-08-09','11:25:00',4.05),('8537','2013-08-09','11:30:00',4.12),('8537','2013-08-09','11:35:00',4.16),('8537','2013-08-09','11:40:00',4.17),('8537','2013-08-09','11:45:00',4.16),('8537','2013-08-09','11:50:00',4.27),('8537','2013-08-09','11:55:00',4.35),('8537','2013-08-09','12:00:00',4.36),('8537','2013-08-09','12:05:00',4.33),('8537','2013-08-09','12:10:00',4.34),('8537','2013-08-09','12:15:00',4.44),('8537','2013-08-09','12:20:00',4.58),('8537','2013-08-09','12:25:00',3.96),('8537','2013-08-09','12:30:00',3.31),('8537','2013-08-09','12:35:00',3.84),('8537','2013-08-09','12:40:00',4.41),('8537','2013-08-09','12:45:00',3.16),('8537','2013-08-09','12:50:00',3.28),('8537','2013-08-09','12:55:00',3.27),('8537','2013-08-09','13:00:00',1.58),('8537','2013-08-09','13:05:00',1.08),('8537','2013-08-09','13:10:00',1),('8537','2013-08-09','13:15:00',1.22),('8537','2013-08-09','13:20:00',1.67),('8537','2013-08-09','13:25:00',2.95),('8537','2013-08-09','13:30:00',2.34),('8537','2013-08-09','13:35:00',1.8),('8537','2013-08-09','13:40:00',1.78),('8537','2013-08-09','13:45:00',1.68),('8537','2013-08-09','13:50:00',1.75),('8537','2013-08-09','13:55:00',1.5),('8537','2013-08-09','14:00:00',1.41),('8537','2013-08-09','14:05:00',1.58),('8537','2013-08-09','14:10:00',1.64),('8537','2013-08-09','14:15:00',1.16),('8537','2013-08-09','14:20:00',1.08),('8537','2013-08-09','14:25:00',1.27),('8537','2013-08-09','14:30:00',1.25),('8537','2013-08-09','15:05:00',1.6),('8537','2013-08-09','15:10:00',3.07),('8537','2013-08-09','15:15:00',2.88),('8537','2013-08-09','15:20:00',1.75),('8537','2013-08-09','15:25:00',1.41),('8537','2013-08-09','15:30:00',1.35),('8537','2013-08-09','15:35:00',2.39),('8537','2013-08-09','15:40:00',1.84),('8537','2013-08-09','15:45:00',2.92),('8537','2013-08-09','15:50:00',2.36),('8537','2013-08-09','15:55:00',2.28),('8537','2013-08-09','16:00:00',1.34),('8537','2013-08-09','16:45:00',1),('8537','2013-08-09','16:50:00',1.61),('8537','2013-08-09','16:55:00',2.18),('8537','2013-08-09','17:00:00',1.65),('8537','2013-08-09','17:05:00',1.83),('8537','2013-08-09','17:10:00',1.11),('8537','2013-08-09','17:30:00',1.01),('8537','2013-08-09','17:35:00',1.03),('8537','2013-08-09','19:20:00',1.14),('8537','2013-08-09','19:25:00',1.07),('8537','2013-08-08','07:55:00',1.04),('8537','2013-08-08','08:00:00',1.13),('8537','2013-08-08','08:05:00',1.22),('8537','2013-08-08','08:10:00',1.32),('8537','2013-08-08','08:15:00',1.4),('8537','2013-08-08','08:20:00',1.48),('8537','2013-08-08','08:25:00',1.59),('8537','2013-08-08','08:30:00',1.68),('8537','2013-08-08','08:35:00',1.77),('8537','2013-08-08','08:40:00',1.85),('8537','2013-08-08','08:45:00',1.94),('8537','2013-08-08','08:50:00',1.99),('8537','2013-08-08','08:55:00',2.14),('8537','2013-08-08','09:00:00',2.24),('8537','2013-08-08','09:05:00',2.36),('8537','2013-08-08','09:10:00',2.45),('8537','2013-08-08','09:15:00',2.53),('8537','2013-08-08','09:20:00',2.62),('8537','2013-08-08','09:25:00',2.71),('8537','2013-08-08','09:30:00',2.8),('8537','2013-08-08','09:35:00',2.89),('8537','2013-08-08','09:40:00',2.97),('8537','2013-08-08','09:45:00',3.05),('8537','2013-08-08','09:50:00',3.13),('8537','2013-08-08','09:55:00',3.19),('8537','2013-08-08','10:00:00',3.25),('8537','2013-08-08','10:05:00',3.32),('8537','2013-08-08','10:10:00',3.36),('8537','2013-08-08','10:15:00',3.48),('8537','2013-08-08','10:20:00',3.51),('8537','2013-08-08','10:25:00',3.57),('8537','2013-08-08','10:30:00',3.63),('8537','2013-08-08','10:35:00',3.7),('8537','2013-08-08','10:40:00',3.75),('8537','2013-08-08','10:45:00',3.79),('8537','2013-08-08','10:50:00',3.82),('8537','2013-08-08','10:55:00',3.85),('8537','2013-08-08','11:00:00',3.88),('8537','2013-08-08','11:05:00',3.93),('8537','2013-08-08','11:10:00',3.99),('8537','2013-08-08','11:15:00',4.02),('8537','2013-08-08','11:20:00',4.03),('8537','2013-08-08','11:25:00',4.02),('8537','2013-08-08','11:30:00',4.05),('8537','2013-08-08','11:35:00',4.11),('8537','2013-08-08','11:40:00',4.16),('8537','2013-08-08','11:45:00',4.18),('8537','2013-08-08','11:50:00',4.2),('8537','2013-08-08','11:55:00',4.21),('8537','2013-08-08','12:00:00',4.26),('8537','2013-08-08','12:05:00',4.27),('8537','2013-08-08','12:10:00',4.26),('8537','2013-08-08','12:15:00',4.36),('8537','2013-08-08','12:20:00',4.32),('8537','2013-08-08','12:25:00',4.36),('8537','2013-08-08','12:30:00',4.32),('8537','2013-08-08','12:35:00',4.42),('8537','2013-08-08','12:40:00',4.47),('8537','2013-08-08','12:45:00',4.5),('8537','2013-08-08','12:50:00',4.52),('8537','2013-08-08','12:55:00',4.52),('8537','2013-08-08','13:00:00',4.5),('8537','2013-08-08','13:05:00',4.53),('8537','2013-08-08','13:10:00',4.54),('8537','2013-08-08','13:15:00',4.49),('8537','2013-08-08','13:20:00',4.49),('8537','2013-08-08','13:25:00',4.55),('8537','2013-08-08','13:30:00',4.53),('8537','2013-08-08','13:35:00',4.49),('8537','2013-08-08','13:40:00',4.45),('8537','2013-08-08','13:45:00',4.46),('8537','2013-08-08','13:50:00',4.47),('8537','2013-08-08','13:55:00',4.4),('8537','2013-08-08','14:00:00',4.4),('8537','2013-08-08','14:05:00',4.41),('8537','2013-08-08','14:10:00',4.36),('8537','2013-08-08','14:15:00',4.31),('8537','2013-08-08','14:20:00',4.28),('8537','2013-08-08','14:25:00',4.28),('8537','2013-08-08','14:30:00',4.29),('8537','2013-08-08','14:35:00',4.24),('8537','2013-08-08','14:40:00',4.16),('8537','2013-08-08','14:45:00',3.95),('8537','2013-08-08','14:50:00',3.67),('8537','2013-08-08','14:55:00',3.66),('8537','2013-08-08','15:00:00',4.02),('8537','2013-08-08','15:05:00',3.97),('8537','2013-08-08','15:10:00',3.91),('8537','2013-08-08','15:15:00',3.86),('8537','2013-08-08','15:20:00',3.81),('8537','2013-08-08','15:25:00',3.74),('8537','2013-08-08','15:30:00',3.68),('8537','2013-08-08','15:35:00',3.62),('8537','2013-08-08','15:40:00',3.5),('8537','2013-08-08','15:45:00',3.5),('8537','2013-08-08','15:50:00',3.44),('8537','2013-08-08','15:55:00',3.38),('8537','2013-08-08','16:00:00',3.34),('8537','2013-08-08','16:05:00',3.3),('8537','2013-08-08','16:10:00',3.25),('8537','2013-08-08','16:15:00',3.18),('8537','2013-08-08','16:20:00',3.1),('8537','2013-08-08','16:25:00',3.04),('8537','2013-08-08','16:30:00',2.98),('8537','2013-08-08','16:35:00',2.91),('8537','2013-08-08','16:40:00',2.82),('8537','2013-08-08','16:45:00',2.75),('8537','2013-08-08','16:50:00',2.65),('8537','2013-08-08','16:55:00',2.55),('8537','2013-08-08','17:00:00',2.45),('8537','2013-08-08','17:05:00',2.36),('8537','2013-08-08','17:10:00',2.28),('8537','2013-08-08','17:15:00',2.2),('8537','2013-08-08','17:20:00',2.03),('8537','2013-08-08','17:25:00',1.97),('8537','2013-08-08','17:30:00',1.89),('8537','2013-08-08','17:35:00',1.8),('8537','2013-08-08','17:40:00',1.68),('8537','2013-08-08','17:45:00',1.6),('8537','2013-08-08','17:50:00',1.49),('8537','2013-08-08','17:55:00',1.41),('8537','2013-08-08','18:00:00',1.33),('8537','2013-08-08','18:05:00',1.24),('8537','2013-08-08','18:10:00',1.15),('8537','2013-08-08','18:15:00',1.05),('8537','2013-08-07','07:55:00',1.09),('8537','2013-08-07','08:00:00',1.19),('8537','2013-08-07','08:05:00',1.27),('8537','2013-08-07','08:10:00',1.38),('8537','2013-08-07','08:15:00',1.48),('8537','2013-08-07','08:20:00',1.58),('8537','2013-08-07','08:25:00',1.68),('8537','2013-08-07','08:30:00',1.77),('8537','2013-08-07','08:35:00',1.86),('8537','2013-08-07','08:40:00',1.98),('8537','2013-08-07','08:45:00',2.07),('8537','2013-08-07','08:50:00',2.16),('8537','2013-08-07','08:55:00',2.26),('8537','2013-08-07','09:00:00',2.36),('8537','2013-08-07','09:05:00',2.43),('8537','2013-08-07','09:10:00',2.5),('8537','2013-08-07','09:15:00',2.58),('8537','2013-08-07','09:20:00',2.66),('8537','2013-08-07','09:25:00',2.77),('8537','2013-08-07','09:30:00',2.86),('8537','2013-08-07','09:35:00',2.95),('8537','2013-08-07','09:40:00',3.04),('8537','2013-08-07','09:45:00',3.1),('8537','2013-08-07','09:50:00',3.18),('8537','2013-08-07','09:55:00',3.21),('8537','2013-08-07','10:00:00',3.28),('8537','2013-08-07','10:05:00',3.38),('8537','2013-08-07','10:10:00',3.44),('8537','2013-08-07','10:15:00',3.5),('8537','2013-08-07','10:20:00',3.55),('8537','2013-08-07','10:25:00',3.63),('8537','2013-08-07','10:30:00',3.65),('8537','2013-08-07','10:35:00',3.69),('8537','2013-08-07','10:40:00',3.75),('8537','2013-08-07','10:45:00',3.8),('8537','2013-08-07','10:50:00',3.86),('8537','2013-08-07','10:55:00',3.92),('8537','2013-08-07','11:00:00',3.94),('8537','2013-08-07','11:05:00',3.93),('8537','2013-08-07','11:10:00',4.04),('8537','2013-08-07','11:15:00',4.08),('8537','2013-08-07','11:20:00',4.13),('8537','2013-08-07','11:25:00',4.15),('8537','2013-08-07','11:30:00',4.19),('8537','2013-08-07','11:35:00',4.23),('8537','2013-08-07','11:40:00',4.22),('8537','2013-08-07','11:45:00',4.25),('8537','2013-08-07','11:50:00',4.24),('8537','2013-08-07','11:55:00',4.29),('8537','2013-08-07','12:00:00',4.34),('8537','2013-08-07','12:05:00',4.38),('8537','2013-08-07','12:10:00',4.41),('8537','2013-08-07','12:15:00',4.47),('8537','2013-08-07','12:20:00',4.44),('8537','2013-08-07','12:25:00',4.41),('8537','2013-08-07','12:30:00',4.4),('8537','2013-08-07','12:35:00',4.42),('8537','2013-08-07','12:40:00',4.37),('8537','2013-08-07','12:45:00',4.29),('8537','2013-08-07','12:50:00',4.46),('8537','2013-08-07','12:55:00',4.44),('8537','2013-08-07','13:00:00',4.48),('8537','2013-08-07','13:05:00',4.47),('8537','2013-08-07','13:10:00',4.52),('8537','2013-08-07','13:15:00',4.49),('8537','2013-08-07','13:20:00',4.52),('8537','2013-08-07','13:25:00',4.43),('8537','2013-08-07','13:30:00',4.52),('8537','2013-08-07','13:35:00',4.43),('8537','2013-08-07','13:40:00',4.49),('8537','2013-08-07','13:45:00',4.53),('8537','2013-08-07','13:50:00',4.45),('8537','2013-08-07','13:55:00',4.52),('8537','2013-08-07','14:00:00',4.44),('8537','2013-08-07','14:05:00',4.42),('8537','2013-08-07','14:10:00',4.35),('8537','2013-08-07','14:15:00',4.32),('8537','2013-08-07','14:20:00',4.29),('8537','2013-08-07','14:25:00',4.23),('8537','2013-08-07','14:30:00',4.19),('8537','2013-08-07','14:35:00',4.13),('8537','2013-08-07','14:40:00',4.07),('8537','2013-08-07','14:45:00',4.01),('8537','2013-08-07','14:50:00',3.73),('8537','2013-08-07','14:55:00',3.87),('8537','2013-08-07','15:00:00',4.01),('8537','2013-08-07','15:05:00',3.97),('8537','2013-08-07','15:10:00',3.93),('8537','2013-08-07','15:15:00',3.92),('8537','2013-08-07','15:20:00',3.89),('8537','2013-08-07','15:25:00',3.8),('8537','2013-08-07','15:30:00',3.76),('8537','2013-08-07','15:35:00',3.7),('8537','2013-08-07','15:40:00',3.6),('8537','2013-08-07','15:45:00',3.57),('8537','2013-08-07','15:50:00',3.51),('8537','2013-08-07','15:55:00',3.48),('8537','2013-08-07','16:00:00',3.37),('8537','2013-08-07','16:05:00',3.33),('8537','2013-08-07','16:10:00',3.22),('8537','2013-08-07','16:15:00',3.19),('8537','2013-08-07','16:20:00',3.09),('8537','2013-08-07','16:25:00',3.02),('8537','2013-08-07','16:30:00',2.98),('8537','2013-08-07','16:35:00',2.9),('8537','2013-08-07','16:40:00',2.84),('8537','2013-08-07','16:45:00',2.76),('8537','2013-08-07','16:50:00',2.71),('8537','2013-08-07','16:55:00',2.64),('8537','2013-08-07','17:00:00',2.52),('8537','2013-08-07','17:05:00',2.43),('8537','2013-08-07','17:10:00',2.32),('8537','2013-08-07','17:15:00',2.25),('8537','2013-08-07','17:20:00',2.09),('8537','2013-08-07','17:25:00',1.99),('8537','2013-08-07','17:30:00',1.92),('8537','2013-08-07','17:35:00',1.83),('8537','2013-08-07','17:40:00',1.71),('8537','2013-08-07','17:45:00',1.63),('8537','2013-08-07','17:50:00',1.52),('8537','2013-08-07','17:55:00',1.44),('8537','2013-08-07','18:00:00',1.35),('8537','2013-08-07','18:05:00',1.26),('8537','2013-08-07','18:10:00',1.15),('8537','2013-08-07','18:15:00',1.05),('8537','2013-08-06','07:55:00',1.06),('8537','2013-08-06','08:00:00',1.15),('8537','2013-08-06','08:05:00',1.24),('8537','2013-08-06','08:10:00',1.35),('8537','2013-08-06','08:15:00',1.45),('8537','2013-08-06','08:20:00',1.55),('8537','2013-08-06','08:25:00',1.64),('8537','2013-08-06','08:30:00',1.74),('8537','2013-08-06','08:35:00',1.83),('8537','2013-08-06','08:40:00',1.94),('8537','2013-08-06','08:45:00',2.04),('8537','2013-08-06','08:50:00',2.14),('8537','2013-08-06','08:55:00',2.21),('8537','2013-08-06','09:00:00',2.3),('8537','2013-08-06','09:05:00',2.37),('8537','2013-08-06','09:10:00',2.47),('8537','2013-08-06','09:15:00',2.58),('8537','2013-08-06','09:20:00',2.67),('8537','2013-08-06','09:25:00',2.74),('8537','2013-08-06','09:30:00',2.82),('8537','2013-08-06','09:35:00',2.93),('8537','2013-08-06','09:40:00',3),('8537','2013-08-06','09:45:00',3.05),('8537','2013-08-06','09:50:00',3.12),('8537','2013-08-06','09:55:00',3.21),('8537','2013-08-06','10:00:00',3.27),('8537','2013-08-06','10:05:00',3.33),('8537','2013-08-06','10:10:00',3.4),('8537','2013-08-06','10:15:00',3.45),('8537','2013-08-06','10:20:00',3.49),('8537','2013-08-06','10:25:00',3.57),('8537','2013-08-06','10:30:00',3.63),('8537','2013-08-06','10:35:00',3.65),('8537','2013-08-06','10:40:00',3.69),('8537','2013-08-06','10:45:00',3.73),('8537','2013-08-06','10:50:00',3.77),('8537','2013-08-06','10:55:00',3.87),('8537','2013-08-06','11:00:00',3.95),('8537','2013-08-06','11:05:00',3.86),('8537','2013-08-06','11:10:00',4),('8537','2013-08-06','11:15:00',4.06),('8537','2013-08-06','11:20:00',4.09),('8537','2013-08-06','11:25:00',4.09),('8537','2013-08-06','11:30:00',4.17),('8537','2013-08-06','11:35:00',4.22),('8537','2013-08-06','11:40:00',4.22),('8537','2013-08-06','11:45:00',4.22),('8537','2013-08-06','11:50:00',4.22),('8537','2013-08-06','11:55:00',4.32),('8537','2013-08-06','12:00:00',4.33),('8537','2013-08-06','12:05:00',4.33),('8537','2013-08-06','12:10:00',4.31),('8537','2013-08-06','12:15:00',4.31),('8537','2013-08-06','12:20:00',4.34),('8537','2013-08-06','12:25:00',4.33),('8537','2013-08-06','12:30:00',4.34),('8537','2013-08-06','12:35:00',4.39),('8537','2013-08-06','12:40:00',4.34),('8537','2013-08-06','12:45:00',4.33),('8537','2013-08-06','12:50:00',4.39),('8537','2013-08-06','12:55:00',4.34),('8537','2013-08-06','13:00:00',4.43),('8537','2013-08-06','13:05:00',4.46),('8537','2013-08-06','13:10:00',4.52),('8537','2013-08-06','13:15:00',4.51),('8537','2013-08-06','13:20:00',4.49),('8537','2013-08-06','13:25:00',4.48),('8537','2013-08-06','13:30:00',4.53),('8537','2013-08-06','13:35:00',4.54),('8537','2013-08-06','13:40:00',4.58),('8537','2013-08-06','13:45:00',4.57),('8537','2013-08-06','13:50:00',4.56),('8537','2013-08-06','13:55:00',4.56),('8537','2013-08-06','14:00:00',4.57),('8537','2013-08-06','14:05:00',4.56),('8537','2013-08-06','14:10:00',4.54),('8537','2013-08-06','14:15:00',4.55),('8537','2013-08-06','14:20:00',4.52),('8537','2013-08-06','14:25:00',4.48),('8537','2013-08-06','14:30:00',4.45),('8537','2013-08-06','14:35:00',4.39),('8537','2013-08-06','14:40:00',4.31),('8537','2013-08-06','14:45:00',4.11),('8537','2013-08-06','14:50:00',3.8),('8537','2013-08-06','14:55:00',4.03),('8537','2013-08-06','15:00:00',4.2),('8537','2013-08-06','15:05:00',4.15),('8537','2013-08-06','15:10:00',4.14),('8537','2013-08-06','15:15:00',4.09),('8537','2013-08-06','15:20:00',4.04),('8537','2013-08-06','15:25:00',3.98),('8537','2013-08-06','15:30:00',3.93),('8537','2013-08-06','15:35:00',3.88),('8537','2013-08-06','15:40:00',3.75),('8537','2013-08-06','15:45:00',3.7),('8537','2013-08-06','15:50:00',3.65),('8537','2013-08-06','15:55:00',3.57),('8537','2013-08-06','16:00:00',3.53),('8537','2013-08-06','16:05:00',3.46),('8537','2013-08-06','16:10:00',3.4),('8537','2013-08-06','16:15:00',3.34),('8537','2013-08-06','16:20:00',3.24),('8537','2013-08-06','16:25:00',3.14),('8537','2013-08-06','16:30:00',3.07),('8537','2013-08-06','16:35:00',2.99),('8537','2013-08-06','16:40:00',2.94),('8537','2013-08-06','16:45:00',2.86),('8537','2013-08-06','16:50:00',2.77),('8537','2013-08-06','16:55:00',2.69),('8537','2013-08-06','17:00:00',2.57),('8537','2013-08-06','17:05:00',2.51),('8537','2013-08-06','17:10:00',2.4),('8537','2013-08-06','17:15:00',2.31),('8537','2013-08-06','17:20:00',2.15),('8537','2013-08-06','17:25:00',1.98),('8537','2013-08-06','17:30:00',2),('8537','2013-08-06','17:35:00',1.91),('8537','2013-08-06','17:40:00',1.78),('8537','2013-08-06','17:45:00',1.68),('8537','2013-08-06','17:50:00',1.57),('8537','2013-08-06','17:55:00',1.48),('8537','2013-08-06','18:00:00',1.39),('8537','2013-08-06','18:05:00',1.3),('8537','2013-08-06','18:10:00',1.21),('8537','2013-08-06','18:15:00',1.11),('8537','2013-08-06','18:20:00',1.02),('8537','2013-08-05','07:50:00',1.04),('8537','2013-08-05','07:55:00',1.14),('8537','2013-08-05','08:00:00',1.23),('8537','2013-08-05','08:05:00',1.33),('8537','2013-08-05','08:10:00',1.43),('8537','2013-08-05','08:15:00',1.52),('8537','2013-08-05','08:20:00',1.61),('8537','2013-08-05','08:25:00',1.71),('8537','2013-08-05','08:30:00',1.8),('8537','2013-08-05','08:35:00',1.9),('8537','2013-08-05','08:40:00',2),('8537','2013-08-05','08:45:00',2.1),('8537','2013-08-05','08:50:00',2.18),('8537','2013-08-05','08:55:00',2.28),('8537','2013-08-05','09:00:00',2.37),('8537','2013-08-05','09:05:00',2.45),('8537','2013-08-05','09:10:00',2.53),('8537','2013-08-05','09:15:00',2.61),('8537','2013-08-05','09:20:00',2.69),('8537','2013-08-05','09:25:00',2.77),('8537','2013-08-05','09:30:00',2.86),('8537','2013-08-05','09:35:00',2.94),('8537','2013-08-05','09:40:00',3.01),('8537','2013-08-05','09:45:00',3.07),('8537','2013-08-05','09:50:00',3.14),('8537','2013-08-05','09:55:00',3.23),('8537','2013-08-05','10:00:00',3.32),('8537','2013-08-05','10:05:00',3.37),('8537','2013-08-05','10:10:00',3.48),('8537','2013-08-05','10:15:00',3.55),('8537','2013-08-05','10:20:00',3.58),('8537','2013-08-05','10:25:00',3.63),('8537','2013-08-05','10:30:00',3.67),('8537','2013-08-05','10:35:00',3.74),('8537','2013-08-05','10:40:00',3.81),('8537','2013-08-05','10:45:00',3.85),('8537','2013-08-05','10:50:00',3.91),('8537','2013-08-05','10:55:00',3.96),('8537','2013-08-05','11:00:00',4.02),('8537','2013-08-05','11:05:00',4.08),('8537','2013-08-05','11:10:00',4.14),('8537','2013-08-05','11:15:00',4.13),('8537','2013-08-05','11:20:00',4.23),('8537','2013-08-05','11:25:00',4.25),('8537','2013-08-05','11:30:00',4.25),('8537','2013-08-05','11:35:00',4.32),('8537','2013-08-05','11:40:00',4.31),('8537','2013-08-05','11:45:00',4.34),('8537','2013-08-05','11:50:00',4.38),('8537','2013-08-05','11:55:00',4.41),('8537','2013-08-05','12:00:00',4.43),('8537','2013-08-05','12:05:00',4.42),('8537','2013-08-05','12:10:00',4.46),('8537','2013-08-05','12:15:00',4.5),('8537','2013-08-05','12:20:00',4.51),('8537','2013-08-05','12:25:00',4.56),('8537','2013-08-05','12:30:00',4.55),('8537','2013-08-05','12:35:00',4.53),('8537','2013-08-05','12:40:00',4.53),('8537','2013-08-05','12:45:00',4.53),('8537','2013-08-05','12:50:00',4.54),('8537','2013-08-05','12:55:00',4.52),('8537','2013-08-05','13:00:00',4.57),('8537','2013-08-05','13:05:00',4.51),('8537','2013-08-05','13:10:00',4.62),('8537','2013-08-05','13:15:00',4.61),('8537','2013-08-05','13:20:00',4.6),('8537','2013-08-05','13:25:00',4.56),('8537','2013-08-05','13:30:00',4.58),('8537','2013-08-05','13:35:00',4.55),('8537','2013-08-05','13:40:00',4.51),('8537','2013-08-05','13:45:00',4.46),('8537','2013-08-05','13:50:00',4.41),('8537','2013-08-05','13:55:00',4.44),('8537','2013-08-05','14:00:00',4.47),('8537','2013-08-05','14:05:00',4.44),('8537','2013-08-05','14:10:00',4.37),('8537','2013-08-05','14:15:00',4.32),('8537','2013-08-05','14:20:00',4.31),('8537','2013-08-05','14:25:00',4.3),('8537','2013-08-05','14:30:00',4.31),('8537','2013-08-05','14:35:00',4.28),('8537','2013-08-05','14:40:00',4.28),('8537','2013-08-05','14:45:00',4.11),('8537','2013-08-05','14:50:00',3.77),('8537','2013-08-05','14:55:00',4.09),('8537','2013-08-05','15:00:00',4.06),('8537','2013-08-05','15:05:00',4.07),('8537','2013-08-05','15:10:00',4.03),('8537','2013-08-05','15:15:00',4),('8537','2013-08-05','15:20:00',3.96),('8537','2013-08-05','15:25:00',3.92),('8537','2013-08-05','15:30:00',3.87),('8537','2013-08-05','15:35:00',3.82),('8537','2013-08-05','15:40:00',3.65),('8537','2013-08-05','15:45:00',3.65),('8537','2013-08-05','15:50:00',3.61),('8537','2013-08-05','15:55:00',3.53),('8537','2013-08-05','16:00:00',3.5),('8537','2013-08-05','16:05:00',3.46),('8537','2013-08-05','16:10:00',3.39),('8537','2013-08-05','16:15:00',3.32),('8537','2013-08-05','16:20:00',3.22),('8537','2013-08-05','16:25:00',3.11),('8537','2013-08-05','16:30:00',3.05),('8537','2013-08-05','16:35:00',2.99),('8537','2013-08-05','16:40:00',2.91),('8537','2013-08-05','16:45:00',2.84),('8537','2013-08-05','16:50:00',2.76),('8537','2013-08-05','16:55:00',2.67),('8537','2013-08-05','17:00:00',2.5),('8537','2013-08-05','17:05:00',2.11),('8537','2013-08-05','17:10:00',2.26),('8537','2013-08-05','17:15:00',2.28),('8537','2013-08-05','17:20:00',2.13),('8537','2013-08-05','17:25:00',2.01),('8537','2013-08-05','17:30:00',1.96),('8537','2013-08-05','17:35:00',1.88),('8537','2013-08-05','17:40:00',1.79),('8537','2013-08-05','17:45:00',1.68),('8537','2013-08-05','17:50:00',1.57),('8537','2013-08-05','17:55:00',1.46),('8537','2013-08-05','18:00:00',1.38),('8537','2013-08-05','18:05:00',1.27),('8537','2013-08-05','18:10:00',1.18),('8537','2013-08-05','18:15:00',1.08),('8537','2013-08-04','07:50:00',1.1),('8537','2013-08-04','07:55:00',1.2),('8537','2013-08-04','08:00:00',1.31),('8537','2013-08-04','08:05:00',1.41),('8537','2013-08-04','08:10:00',1.52),('8537','2013-08-04','08:15:00',1.62),('8537','2013-08-04','08:20:00',1.73),('8537','2013-08-04','08:25:00',1.83),('8537','2013-08-04','08:30:00',1.93),('8537','2013-08-04','08:35:00',2.03),('8537','2013-08-04','08:40:00',2.14),('8537','2013-08-04','08:45:00',2.22),('8537','2013-08-04','08:50:00',2.34),('8537','2013-08-04','08:55:00',2.44),('8537','2013-08-04','09:00:00',2.53),('8537','2013-08-04','09:05:00',2.61),('8537','2013-08-04','09:10:00',2.69),('8537','2013-08-04','09:15:00',2.76),('8537','2013-08-04','09:20:00',2.84),('8537','2013-08-04','09:25:00',2.93),('8537','2013-08-04','09:30:00',3),('8537','2013-08-04','09:35:00',3.09),('8537','2013-08-04','09:40:00',3.19),('8537','2013-08-04','09:45:00',3.26),('8537','2013-08-04','09:50:00',3.32),('8537','2013-08-04','09:55:00',3.4),('8537','2013-08-04','10:00:00',3.46),('8537','2013-08-04','10:05:00',3.54),('8537','2013-08-04','10:10:00',3.61),('8537','2013-08-04','10:15:00',3.65),('8537','2013-08-04','10:20:00',3.72),('8537','2013-08-04','10:25:00',3.81),('8537','2013-08-04','10:30:00',3.87),('8537','2013-08-04','10:35:00',3.87),('8537','2013-08-04','10:40:00',3.94),('8537','2013-08-04','10:45:00',4.02),('8537','2013-08-04','10:50:00',4.07),('8537','2013-08-04','10:55:00',4.1),('8537','2013-08-04','11:00:00',4.12),('8537','2013-08-04','11:05:00',4.14),('8537','2013-08-04','11:10:00',4.17),('8537','2013-08-04','11:15:00',4.21),('8537','2013-08-04','11:20:00',4.23),('8537','2013-08-04','11:25:00',4.31),('8537','2013-08-04','11:30:00',4.37),('8537','2013-08-04','11:35:00',4.45),('8537','2013-08-04','11:40:00',4.49),('8537','2013-08-04','11:45:00',4.5),('8537','2013-08-04','11:50:00',4.51),('8537','2013-08-04','11:55:00',4.59),('8537','2013-08-04','12:00:00',4.57),('8537','2013-08-04','12:05:00',4.57),('8537','2013-08-04','12:10:00',4.57),('8537','2013-08-04','12:15:00',4.58),('8537','2013-08-04','12:20:00',4.56),('8537','2013-08-04','12:25:00',4.56),('8537','2013-08-04','12:30:00',4.6),('8537','2013-08-04','12:35:00',4.61),('8537','2013-08-04','12:40:00',4.63),('8537','2013-08-04','12:45:00',4.66),('8537','2013-08-04','12:50:00',4.65),('8537','2013-08-04','12:55:00',4.63),('8537','2013-08-04','13:00:00',4.64),('8537','2013-08-04','13:05:00',4.63),('8537','2013-08-04','13:10:00',4.63),('8537','2013-08-04','13:15:00',4.67),('8537','2013-08-04','13:20:00',4.64),('8537','2013-08-04','13:25:00',4.61),('8537','2013-08-04','13:30:00',4.63),('8537','2013-08-04','13:35:00',4.64),('8537','2013-08-04','13:40:00',4.75),('8537','2013-08-04','13:45:00',4.72),('8537','2013-08-04','13:50:00',4.71),('8537','2013-08-04','13:55:00',4.68),('8537','2013-08-04','14:00:00',4.69),('8537','2013-08-04','14:05:00',4.67),('8537','2013-08-04','14:10:00',4.63),('8537','2013-08-04','14:15:00',4.62),('8537','2013-08-04','14:20:00',4.57),('8537','2013-08-04','14:25:00',4.55),('8537','2013-08-04','14:30:00',4.52),('8537','2013-08-04','14:35:00',4.49),('8537','2013-08-04','14:40:00',4.47),('8537','2013-08-04','14:45:00',4.39),('8537','2013-08-04','14:50:00',4.32),('8537','2013-08-04','14:55:00',4.32),('8537','2013-08-04','15:00:00',4.28),('8537','2013-08-04','15:05:00',4.24),('8537','2013-08-04','15:10:00',4.2),('8537','2013-08-04','15:15:00',4.18),('8537','2013-08-04','15:20:00',4.12),('8537','2013-08-04','15:25:00',4.05),('8537','2013-08-04','15:30:00',3.93),('8537','2013-08-04','15:35:00',3.98),('8537','2013-08-04','15:40:00',3.79),('8537','2013-08-04','15:45:00',3.71),('8537','2013-08-04','15:50:00',3.7),('8537','2013-08-04','15:55:00',3.66),('8537','2013-08-04','16:00:00',3.6),('8537','2013-08-04','16:05:00',3.55),('8537','2013-08-04','16:10:00',3.49),('8537','2013-08-04','16:15:00',3.44),('8537','2013-08-04','16:20:00',3.36),('8537','2013-08-04','16:25:00',3.25),('8537','2013-08-04','16:30:00',3.16),('8537','2013-08-04','16:35:00',3.08),('8537','2013-08-04','16:40:00',3.02),('8537','2013-08-04','16:45:00',2.94),('8537','2013-08-04','16:50:00',2.84),('8537','2013-08-04','16:55:00',2.76),('8537','2013-08-04','17:00:00',2.58),('8537','2013-08-04','17:05:00',2.22),('8537','2013-08-04','17:10:00',2.5),('8537','2013-08-04','17:15:00',2.39),('8537','2013-08-04','17:20:00',2.28),('8537','2013-08-04','17:25:00',2.14),('8537','2013-08-04','17:30:00',2.05),('8537','2013-08-04','17:35:00',1.97),('8537','2013-08-04','17:40:00',1.86),('8537','2013-08-04','17:45:00',1.75),('8537','2013-08-04','17:50:00',1.66),('8537','2013-08-04','17:55:00',1.54),('8537','2013-08-04','18:00:00',1.44),('8537','2013-08-04','18:05:00',1.34),('8537','2013-08-04','18:10:00',1.24),('8537','2013-08-04','18:15:00',1.14),('8537','2013-08-04','18:20:00',1.06),('8537','2013-08-03','07:50:00',1.05),('8537','2013-08-03','07:55:00',1.15),('8537','2013-08-03','08:00:00',1.25),('8537','2013-08-03','08:05:00',1.34),('8537','2013-08-03','08:10:00',1.44),('8537','2013-08-03','08:15:00',1.54),('8537','2013-08-03','08:20:00',1.65),('8537','2013-08-03','08:25:00',1.75),('8537','2013-08-03','08:30:00',1.85),('8537','2013-08-03','08:35:00',1.93),('8537','2013-08-03','08:40:00',2.03),('8537','2013-08-03','08:45:00',2.12),('8537','2013-08-03','08:50:00',2.21),('8537','2013-08-03','08:55:00',2.31),('8537','2013-08-03','09:00:00',2.4),('8537','2013-08-03','09:05:00',2.48),('8537','2013-08-03','09:10:00',2.56),('8537','2013-08-03','09:15:00',2.65),('8537','2013-08-03','09:20:00',2.74),('8537','2013-08-03','09:25:00',2.83),('8537','2013-08-03','09:30:00',2.6),('8537','2013-08-03','09:35:00',2.63),('8537','2013-08-03','09:40:00',2.69),('8537','2013-08-03','09:45:00',2.76),('8537','2013-08-03','09:50:00',2.73),('8537','2013-08-03','09:55:00',2.84),('8537','2013-08-03','10:00:00',2.99),('8537','2013-08-03','10:05:00',3),('8537','2013-08-03','10:10:00',3.25),('8537','2013-08-03','10:15:00',3.54),('8537','2013-08-03','10:20:00',3.5),('8537','2013-08-03','10:25:00',3.59),('8537','2013-08-03','10:30:00',3.68),('8537','2013-08-03','10:35:00',3.68),('8537','2013-08-03','10:40:00',3.82),('8537','2013-08-03','10:45:00',3.87),('8537','2013-08-03','10:50:00',4.04),('8537','2013-08-03','10:55:00',4.12),('8537','2013-08-03','11:00:00',4.15),('8537','2013-08-03','11:05:00',4.17),('8537','2013-08-03','11:10:00',4.18),('8537','2013-08-03','11:15:00',4.24),('8537','2013-08-03','11:20:00',4.3),('8537','2013-08-03','11:25:00',4.35),('8537','2013-08-03','11:30:00',4.4),('8537','2013-08-03','11:35:00',4.44),('8537','2013-08-03','11:40:00',4.42),('8537','2013-08-03','11:45:00',4.42),('8537','2013-08-03','11:50:00',4.5),('8537','2013-08-03','11:55:00',4.49),('8537','2013-08-03','12:00:00',4.5),('8537','2013-08-03','12:05:00',4.53),('8537','2013-08-03','12:10:00',4.55),('8537','2013-08-03','12:15:00',4.54),('8537','2013-08-03','12:20:00',4.56),('8537','2013-08-03','12:25:00',4.62),('8537','2013-08-03','12:30:00',4.62),('8537','2013-08-03','12:35:00',4.58),('8537','2013-08-03','12:40:00',4.6),('8537','2013-08-03','12:45:00',4.63),('8537','2013-08-03','12:50:00',4.68),('8537','2013-08-03','12:55:00',4.64),('8537','2013-08-03','13:00:00',4.64),('8537','2013-08-03','13:05:00',4.58),('8537','2013-08-03','13:10:00',4.61),('8537','2013-08-03','13:15:00',4.65),('8537','2013-08-03','13:20:00',4.53),('8537','2013-08-03','13:25:00',4.5),('8537','2013-08-03','13:30:00',4.52),('8537','2013-08-03','13:35:00',4.44),('8537','2013-08-03','13:40:00',4.51),('8537','2013-08-03','13:45:00',4.58),('8537','2013-08-03','13:50:00',4.53),('8537','2013-08-03','13:55:00',4.51),('8537','2013-08-03','14:00:00',4.53),('8537','2013-08-03','14:05:00',4.51),('8537','2013-08-03','14:10:00',4.41),('8537','2013-08-03','14:15:00',4.29),('8537','2013-08-03','14:20:00',4.32),('8537','2013-08-03','14:25:00',4.3),('8537','2013-08-03','14:30:00',4.33),('8537','2013-08-03','14:35:00',4.46),('8537','2013-08-03','14:40:00',4.37),('8537','2013-08-03','14:45:00',4.31),('8537','2013-08-03','14:50:00',4.3),('8537','2013-08-03','14:55:00',4.29),('8537','2013-08-03','15:00:00',4.25),('8537','2013-08-03','15:05:00',4.15),('8537','2013-08-03','15:10:00',4.11),('8537','2013-08-03','15:15:00',4.05),('8537','2013-08-03','15:20:00',4.03),('8537','2013-08-03','15:25:00',4.02),('8537','2013-08-03','15:30:00',3.99),('8537','2013-08-03','15:35:00',3.86),('8537','2013-08-03','15:40:00',3.8),('8537','2013-08-03','15:45:00',3.71),('8537','2013-08-03','15:50:00',3.74),('8537','2013-08-03','15:55:00',3.65),('8537','2013-08-03','16:00:00',3.56),('8537','2013-08-03','16:05:00',3.48),('8537','2013-08-03','16:10:00',3.41),('8537','2013-08-03','16:15:00',3.34),('8537','2013-08-03','16:20:00',3.25),('8537','2013-08-03','16:25:00',3.16),('8537','2013-08-03','16:30:00',3.11),('8537','2013-08-03','16:35:00',3.04),('8537','2013-08-03','16:40:00',2.97),('8537','2013-08-03','16:45:00',2.89),('8537','2013-08-03','16:50:00',2.84),('8537','2013-08-03','16:55:00',2.76),('8537','2013-08-03','17:00:00',2.59),('8537','2013-08-03','17:05:00',2.36),('8537','2013-08-03','17:10:00',2.46),('8537','2013-08-03','17:15:00',2.36),('8537','2013-08-03','17:20:00',2.24),('8537','2013-08-03','17:25:00',2.13),('8537','2013-08-03','17:30:00',2.05),('8537','2013-08-03','17:35:00',1.97),('8537','2013-08-03','17:40:00',1.88),('8537','2013-08-03','17:45:00',1.75),('8537','2013-08-03','17:50:00',1.66),('8537','2013-08-03','17:55:00',1.53),('8537','2013-08-03','18:00:00',1.45),('8537','2013-08-03','18:05:00',1.35),('8537','2013-08-03','18:10:00',1.26),('8537','2013-08-03','18:15:00',1.16),('8537','2013-08-03','18:20:00',1.07),('8537','2013-08-02','07:45:00',1.01),('8537','2013-08-02','07:50:00',1.11),('8537','2013-08-02','07:55:00',1.21),('8537','2013-08-02','08:00:00',1.32),('8537','2013-08-02','08:05:00',1.42),('8537','2013-08-02','08:10:00',1.52),('8537','2013-08-02','08:15:00',1.62),('8537','2013-08-02','08:20:00',1.73),('8537','2013-08-02','08:25:00',1.83),('8537','2013-08-02','08:30:00',1.93),('8537','2013-08-02','08:35:00',2.03),('8537','2013-08-02','08:40:00',2.12),('8537','2013-08-02','08:45:00',2.22),('8537','2013-08-02','08:50:00',2.31),('8537','2013-08-02','08:55:00',2.41),('8537','2013-08-02','09:00:00',2.5),('8537','2013-08-02','09:05:00',2.59),('8537','2013-08-02','09:10:00',2.68),('8537','2013-08-02','09:15:00',2.78),('8537','2013-08-02','09:20:00',2.85),('8537','2013-08-02','09:25:00',2.94),('8537','2013-08-02','09:30:00',2.97),('8537','2013-08-02','09:35:00',3.09),('8537','2013-08-02','09:40:00',3.17),('8537','2013-08-02','09:45:00',3.24),('8537','2013-08-02','09:50:00',3.3),('8537','2013-08-02','09:55:00',3.37),('8537','2013-08-02','10:00:00',3.43),('8537','2013-08-02','10:05:00',3.46),('8537','2013-08-02','10:10:00',3.53),('8537','2013-08-02','10:15:00',3.61),('8537','2013-08-02','10:20:00',3.69),('8537','2013-08-02','10:25:00',3.73),('8537','2013-08-02','10:30:00',3.8),('8537','2013-08-02','10:35:00',3.84),('8537','2013-08-02','10:40:00',3.9),('8537','2013-08-02','10:45:00',3.93),('8537','2013-08-02','10:50:00',3.98),('8537','2013-08-02','10:55:00',4.04),('8537','2013-08-02','11:00:00',4.12),('8537','2013-08-02','11:05:00',4.14),('8537','2013-08-02','11:10:00',4.14),('8537','2013-08-02','11:15:00',4.2),('8537','2013-08-02','11:20:00',4.29),('8537','2013-08-02','11:25:00',4.35),('8537','2013-08-02','11:30:00',4.35),('8537','2013-08-02','11:35:00',4.38),('8537','2013-08-02','11:40:00',4.38),('8537','2013-08-02','11:45:00',4.4),('8537','2013-08-02','11:50:00',4.45),('8537','2013-08-02','11:55:00',4.47),('8537','2013-08-02','12:00:00',4.58),('8537','2013-08-02','12:05:00',4.6),('8537','2013-08-02','12:10:00',4.55),('8537','2013-08-02','12:15:00',4.59),('8537','2013-08-02','12:20:00',4.58),('8537','2013-08-02','12:25:00',4.55),('8537','2013-08-02','12:30:00',4.52),('8537','2013-08-02','12:35:00',4.59),('8537','2013-08-02','12:40:00',4.56),('8537','2013-08-02','12:45:00',4.55),('8537','2013-08-02','12:50:00',4.55),('8537','2013-08-02','12:55:00',4.55),('8537','2013-08-02','13:00:00',4.58),('8537','2013-08-02','13:05:00',4.66),('8537','2013-08-02','13:10:00',4.71),('8537','2013-08-02','13:15:00',4.66),('8537','2013-08-02','13:20:00',4.6),('8537','2013-08-02','13:25:00',4.61),('8537','2013-08-02','13:30:00',4.65),('8537','2013-08-02','13:35:00',4.66),('8537','2013-08-02','13:40:00',4.65),('8537','2013-08-02','13:45:00',4.61),('8537','2013-08-02','13:50:00',4.61),('8537','2013-08-02','13:55:00',4.62),('8537','2013-08-02','14:00:00',4.6),('8537','2013-08-02','14:05:00',4.56),('8537','2013-08-02','14:10:00',4.5),('8537','2013-08-02','14:15:00',4.42),('8537','2013-08-02','14:20:00',4.35),('8537','2013-08-02','14:25:00',4.35),('8537','2013-08-02','14:30:00',4.37),('8537','2013-08-02','14:35:00',4.43),('8537','2013-08-02','14:40:00',4.43),('8537','2013-08-02','14:45:00',4.25),('8537','2013-08-02','14:50:00',4.25),('8537','2013-08-02','14:55:00',4.27),('8537','2013-08-02','15:00:00',4.22),('8537','2013-08-02','15:05:00',4.17),('8537','2013-08-02','15:10:00',4.11),('8537','2013-08-02','15:15:00',4.02),('8537','2013-08-02','15:20:00',4.03),('8537','2013-08-02','15:25:00',4.01),('8537','2013-08-02','15:30:00',3.97),('8537','2013-08-02','15:35:00',3.88),('8537','2013-08-02','15:40:00',3.79),('8537','2013-08-02','15:45:00',3.63),('8537','2013-08-02','15:50:00',3.66),('8537','2013-08-02','15:55:00',3.58),('8537','2013-08-02','16:00:00',3.55),('8537','2013-08-02','16:05:00',3.48),('8537','2013-08-02','16:10:00',3.42),('8537','2013-08-02','16:15:00',3.36),('8537','2013-08-02','16:20:00',3.26),('8537','2013-08-02','16:25:00',3.13),('8537','2013-08-02','16:30:00',3.09),('8537','2013-08-02','16:35:00',3.04),('8537','2013-08-02','16:40:00',2.96),('8537','2013-08-02','16:45:00',2.88),('8537','2013-08-02','16:50:00',2.81),('8537','2013-08-02','16:55:00',2.72),('8537','2013-08-02','17:00:00',2.58),('8537','2013-08-02','17:05:00',2.39),('8537','2013-08-02','17:10:00',2.42),('8537','2013-08-02','17:15:00',2.36),('8537','2013-08-02','17:20:00',2.27),('8537','2013-08-02','17:25:00',2.1),('8537','2013-08-02','17:30:00',2.03),('8537','2013-08-02','17:35:00',1.95),('8537','2013-08-02','17:40:00',1.87),('8537','2013-08-02','17:45:00',1.74),('8537','2013-08-02','17:50:00',1.63),('8537','2013-08-02','17:55:00',1.51),('8537','2013-08-02','18:00:00',1.44),('8537','2013-08-02','18:05:00',1.35),('8537','2013-08-02','18:10:00',1.26),('8537','2013-08-02','18:15:00',1.15),('8537','2013-08-02','18:20:00',1.06),('8537','2013-08-01','07:45:00',1.02),('8537','2013-08-01','07:50:00',1.12),('8537','2013-08-01','07:55:00',1.22),('8537','2013-08-01','08:00:00',1.32),('8537','2013-08-01','08:05:00',1.42),('8537','2013-08-01','08:10:00',1.52),('8537','2013-08-01','08:15:00',1.62),('8537','2013-08-01','08:20:00',1.74),('8537','2013-08-01','08:25:00',1.85),('8537','2013-08-01','08:30:00',1.96),('8537','2013-08-01','08:35:00',2.07),('8537','2013-08-01','08:40:00',2.17),('8537','2013-08-01','08:45:00',2.28),('8537','2013-08-01','08:50:00',2.38),('8537','2013-08-01','08:55:00',2.47),('8537','2013-08-01','09:00:00',2.55),('8537','2013-08-01','09:05:00',2.65),('8537','2013-08-01','09:10:00',2.75),('8537','2013-08-01','09:15:00',2.85),('8537','2013-08-01','09:20:00',2.95),('8537','2013-08-01','09:25:00',3.03),('8537','2013-08-01','09:30:00',3.12),('8537','2013-08-01','09:35:00',3.21),('8537','2013-08-01','09:40:00',3.29),('8537','2013-08-01','09:45:00',3.37),('8537','2013-08-01','09:50:00',3.45),('8537','2013-08-01','09:55:00',3.53),('8537','2013-08-01','10:00:00',3.61),('8537','2013-08-01','10:05:00',3.66),('8537','2013-08-01','10:10:00',3.74),('8537','2013-08-01','10:15:00',3.78),('8537','2013-08-01','10:20:00',3.85),('8537','2013-08-01','10:25:00',3.91),('8537','2013-08-01','10:30:00',3.99),('8537','2013-08-01','10:35:00',4.05),('8537','2013-08-01','10:40:00',4.11),('8537','2013-08-01','10:45:00',4.16),('8537','2013-08-01','10:50:00',4.22),('8537','2013-08-01','10:55:00',4.27),('8537','2013-08-01','11:00:00',4.32),('8537','2013-08-01','11:05:00',4.38),('8537','2013-08-01','11:10:00',4.43),('8537','2013-08-01','11:15:00',4.52),('8537','2013-08-01','11:20:00',4.55),('8537','2013-08-01','11:25:00',4.59),('8537','2013-08-01','11:30:00',4.61),('8537','2013-08-01','11:35:00',4.67),('8537','2013-08-01','11:40:00',4.71),('8537','2013-08-01','11:45:00',4.74),('8537','2013-08-01','11:50:00',4.77),('8537','2013-08-01','11:55:00',4.79),('8537','2013-08-01','12:00:00',4.79),('8537','2013-08-01','12:05:00',4.83),('8537','2013-08-01','12:10:00',4.84),('8537','2013-08-01','12:15:00',4.86),('8537','2013-08-01','12:20:00',4.88),('8537','2013-08-01','12:25:00',4.9),('8537','2013-08-01','12:30:00',4.92),('8537','2013-08-01','12:35:00',4.96),('8537','2013-08-01','12:40:00',4.96),('8537','2013-08-01','12:45:00',4.93),('8537','2013-08-01','12:50:00',4.97),('8537','2013-08-01','12:55:00',4.95),('8537','2013-08-01','13:00:00',4.96),('8537','2013-08-01','13:05:00',4.94),('8537','2013-08-01','13:10:00',4.96),('8537','2013-08-01','13:15:00',4.95),('8537','2013-08-01','13:20:00',4.98),('8537','2013-08-01','13:25:00',4.97),('8537','2013-08-01','13:30:00',4.94),('8537','2013-08-01','13:35:00',4.88),('8537','2013-08-01','13:40:00',4.94),('8537','2013-08-01','13:45:00',4.91),('8537','2013-08-01','13:50:00',4.91),('8537','2013-08-01','13:55:00',4.46),('8537','2013-08-01','14:00:00',4.24),('8537','2013-08-01','14:05:00',4.88),('8537','2013-08-01','14:10:00',4.62),('8537','2013-08-01','14:15:00',4.77),('8537','2013-08-01','14:20:00',4.45),('8537','2013-08-01','14:25:00',4.62),('8537','2013-08-01','14:30:00',4.63),('8537','2013-08-01','14:35:00',3.32),('8537','2013-08-01','14:40:00',4.16),('8537','2013-08-01','14:45:00',4.54),('8537','2013-08-01','14:50:00',3.69),('8537','2013-08-01','14:55:00',4.42),('8537','2013-08-01','15:00:00',4.29),('8537','2013-08-01','15:05:00',4.36),('8537','2013-08-01','15:10:00',4.11),('8537','2013-08-01','15:15:00',3.63),('8537','2013-08-01','15:20:00',3.87),('8537','2013-08-01','15:25:00',4.15),('8537','2013-08-01','15:30:00',4.14),('8537','2013-08-01','15:35:00',3.94),('8537','2013-08-01','15:40:00',3.36),('8537','2013-08-01','15:45:00',3.88),('8537','2013-08-01','15:50:00',3.84),('8537','2013-08-01','15:55:00',3.82),('8537','2013-08-01','16:00:00',3.78),('8537','2013-08-01','16:05:00',3.67),('8537','2013-08-01','16:10:00',3.6),('8537','2013-08-01','16:15:00',3.5),('8537','2013-08-01','16:20:00',3.45),('8537','2013-08-01','16:25:00',3.32),('8537','2013-08-01','16:30:00',3.23),('8537','2013-08-01','16:35:00',3.17),('8537','2013-08-01','16:40:00',3.1),('8537','2013-08-01','16:45:00',3.01),('8537','2013-08-01','16:50:00',2.92),('8537','2013-08-01','16:55:00',2.85),('8537','2013-08-01','17:00:00',2.72),('8537','2013-08-01','17:05:00',2.64),('8537','2013-08-01','17:10:00',2.53),('8537','2013-08-01','17:15:00',2.45),('8537','2013-08-01','17:20:00',2.35),('8537','2013-08-01','17:25:00',2.15),('8537','2013-08-01','17:30:00',2.12),('8537','2013-08-01','17:35:00',2.03),('8537','2013-08-01','17:40:00',1.93),('8537','2013-08-01','17:45:00',1.81),('8537','2013-08-01','17:50:00',1.72),('8537','2013-08-01','17:55:00',1.59),('8537','2013-08-01','18:00:00',1.51),('8537','2013-08-01','18:05:00',1.39),('8537','2013-08-01','18:10:00',1.31),('8537','2013-08-01','18:15:00',1.21),('8537','2013-08-01','18:20:00',1.12),('8537','2013-08-01','18:25:00',1.03),('8537','2013-07-31','07:45:00',1.06),('8537','2013-07-31','07:50:00',1.16),('8537','2013-07-31','07:55:00',1.26),('8537','2013-07-31','08:00:00',1.36),('8537','2013-07-31','08:05:00',1.46),('8537','2013-07-31','08:10:00',1.58),('8537','2013-07-31','08:15:00',1.68),('8537','2013-07-31','08:20:00',1.79),('8537','2013-07-31','08:25:00',1.9),('8537','2013-07-31','08:30:00',2),('8537','2013-07-31','08:35:00',2.1),('8537','2013-07-31','08:40:00',2.2),('8537','2013-07-31','08:45:00',2.31),('8537','2013-07-31','08:50:00',2.41),('8537','2013-07-31','08:55:00',2.5),('8537','2013-07-31','09:00:00',2.54),('8537','2013-07-31','09:05:00',2.7),('8537','2013-07-31','09:10:00',2.8),('8537','2013-07-31','09:15:00',2.87),('8537','2013-07-31','09:20:00',2.97),('8537','2013-07-31','09:25:00',3.05),('8537','2013-07-31','09:30:00',3.15),('8537','2013-07-31','09:35:00',3.23),('8537','2013-07-31','09:40:00',3.3),('8537','2013-07-31','09:45:00',3.4),('8537','2013-07-31','09:50:00',2.07),('8537','2013-07-31','09:55:00',3.53),('8537','2013-07-31','10:00:00',3.61),('8537','2013-07-31','10:05:00',3.69),('8537','2013-07-31','10:10:00',3.72),('8537','2013-07-31','10:15:00',3.82),('8537','2013-07-31','10:20:00',3.88),('8537','2013-07-31','10:25:00',3.95),('8537','2013-07-31','10:30:00',3.03),('8537','2013-07-31','10:35:00',2.42),('8537','2013-07-31','10:40:00',4.17),('8537','2013-07-31','10:45:00',4.22),('8537','2013-07-31','10:50:00',4.3),('8537','2013-07-31','10:55:00',4.33),('8537','2013-07-31','11:00:00',4.39),('8537','2013-07-31','11:05:00',4.42),('8537','2013-07-31','11:10:00',4.47),('8537','2013-07-31','11:15:00',4.52),('8537','2013-07-31','11:20:00',4.56),('8537','2013-07-31','11:25:00',4.61),('8537','2013-07-31','11:30:00',4.66),('8537','2013-07-31','11:35:00',4.67),('8537','2013-07-31','11:40:00',4.71),('8537','2013-07-31','11:45:00',4.78),('8537','2013-07-31','11:50:00',4.8),('8537','2013-07-31','11:55:00',4.83),('8537','2013-07-31','12:00:00',4.73),('8537','2013-07-31','12:05:00',4.85),('8537','2013-07-31','12:10:00',4.87),('8537','2013-07-31','12:15:00',4.92),('8537','2013-07-31','12:20:00',4.93),('8537','2013-07-31','12:25:00',4.99),('8537','2013-07-31','12:30:00',4.97),('8537','2013-07-31','12:35:00',4.94),('8537','2013-07-31','12:40:00',4.96),('8537','2013-07-31','12:45:00',4.29),('8537','2013-07-31','12:50:00',3.12),('8537','2013-07-31','12:55:00',5.08),('8537','2013-07-31','13:00:00',2.08),('8537','2013-07-31','13:05:00',5.01),('8537','2013-07-31','13:10:00',5.05),('8537','2013-07-31','13:15:00',5.03),('8537','2013-07-31','13:20:00',4.79),('8537','2013-07-31','13:25:00',4.32),('8537','2013-07-31','13:30:00',5.04),('8537','2013-07-31','13:35:00',4.82),('8537','2013-07-31','13:40:00',5.04),('8537','2013-07-31','13:45:00',5.02),('8537','2013-07-31','13:50:00',4.35),('8537','2013-07-31','13:55:00',2.65),('8537','2013-07-31','14:00:00',4.7),('8537','2013-07-31','14:05:00',5.07),('8537','2013-07-31','14:10:00',4.57),('8537','2013-07-31','14:15:00',4.96),('8537','2013-07-31','14:20:00',5.02),('8537','2013-07-31','14:25:00',4.91),('8537','2013-07-31','14:30:00',4.81),('8537','2013-07-31','14:35:00',4.71),('8537','2013-07-31','14:40:00',4.73),('8537','2013-07-31','14:45:00',4.63),('8537','2013-07-31','14:50:00',3.79),('8537','2013-07-31','14:55:00',1.87),('8537','2013-07-31','15:00:00',1.67),('8537','2013-07-31','15:05:00',4.68),('8537','2013-07-31','15:10:00',3.2),('8537','2013-07-31','15:15:00',3.03),('8537','2013-07-31','15:20:00',4.56),('8537','2013-07-31','15:25:00',4.27),('8537','2013-07-31','15:30:00',4.26),('8537','2013-07-31','15:35:00',3.6),('8537','2013-07-31','15:40:00',4.1),('8537','2013-07-31','15:45:00',3.8),('8537','2013-07-31','15:50:00',3.9),('8537','2013-07-31','15:55:00',3.79),('8537','2013-07-31','16:00:00',3.71),('8537','2013-07-31','16:05:00',3.67),('8537','2013-07-31','16:10:00',3.67),('8537','2013-07-31','16:15:00',3.58),('8537','2013-07-31','16:20:00',3.58),('8537','2013-07-31','16:25:00',3.33),('8537','2013-07-31','16:30:00',3.23),('8537','2013-07-31','16:35:00',1.69),('8537','2013-07-31','16:40:00',3.11),('8537','2013-07-31','16:45:00',2.98),('8537','2013-07-31','16:50:00',2.95),('8537','2013-07-31','16:55:00',2.84),('8537','2013-07-31','17:00:00',2.33),('8537','2013-07-31','17:05:00',2.5),('8537','2013-07-31','17:10:00',2.51),('8537','2013-07-31','17:15:00',2.45),('8537','2013-07-31','17:20:00',2.25),('8537','2013-07-31','17:25:00',2.17),('8537','2013-07-31','17:30:00',2.09),('8537','2013-07-31','17:35:00',1.97),('8537','2013-07-31','17:40:00',1.91),('8537','2013-07-31','17:45:00',1.78),('8537','2013-07-31','17:50:00',1.71),('8537','2013-07-31','17:55:00',1.58),('8537','2013-07-31','18:00:00',1.5),('8537','2013-07-31','18:05:00',1.41),('8537','2013-07-31','18:10:00',1.31),('8537','2013-07-31','18:15:00',1.24),('8537','2013-07-31','18:20:00',1.13),('8537','2013-07-31','18:25:00',1.05),('8537','2014-04-08','08:15:00',1.45),('8537','2014-04-08','08:20:00',1.55),('8537','2014-04-08','08:25:00',1.2),('8537','2014-04-08','08:30:00',1.61),('8537','2014-04-08','08:35:00',1.64),('8537','2014-04-08','08:40:00',1.57),('8537','2014-04-08','08:45:00',1.95),('8537','2014-04-08','08:50:00',2.01),('8537','2014-04-08','08:55:00',2.17),('8537','2014-04-08','09:00:00',2.28),('8537','2014-04-08','09:05:00',2.37),('8537','2014-04-08','09:10:00',2.46),('8537','2014-04-08','09:15:00',2.58),('8537','2014-04-08','09:20:00',2.69),('8537','2014-04-08','09:25:00',2.78),('8537','2014-04-08','09:30:00',2.89),('8537','2014-04-08','09:35:00',2.96),('8537','2014-04-08','09:40:00',2.99),('8537','2014-04-08','09:45:00',3.08),('8537','2014-04-08','09:50:00',3.18),('8537','2014-04-08','09:55:00',3.21),('8537','2014-04-08','10:00:00',3.28),('8537','2014-04-08','10:05:00',3.26),('8537','2014-04-08','10:10:00',3.34),('8537','2014-04-08','10:15:00',3.57),('8537','2014-04-08','10:20:00',3.66),('8537','2014-04-08','10:25:00',3.67),('8537','2014-04-08','10:30:00',3.77),('8537','2014-04-08','10:35:00',3.71),('8537','2014-04-08','10:40:00',3.84),('8537','2014-04-08','10:45:00',3.97),('8537','2014-04-08','10:50:00',4.06),('8537','2014-04-08','10:55:00',4.07),('8537','2014-04-08','11:00:00',4.11),('8537','2014-04-08','11:05:00',4.21),('8537','2014-04-08','11:10:00',4.21),('8537','2014-04-08','11:15:00',4.17),('8537','2014-04-08','11:20:00',4.31),('8537','2014-04-08','11:25:00',4.45),('8537','2014-04-08','11:30:00',4.42),('8537','2014-04-08','11:35:00',4.17),('8537','2014-04-08','11:40:00',4.34),('8537','2014-04-08','11:45:00',4.48),('8537','2014-04-08','11:50:00',4.34),('8537','2014-04-08','11:55:00',4.51),('8537','2014-04-08','12:00:00',4.56),('8537','2014-04-08','12:05:00',4.42),('8537','2014-04-08','12:10:00',4.38),('8537','2014-04-08','12:15:00',4.29),('8537','2014-04-08','12:20:00',4.27),('8537','2014-04-08','12:25:00',4.22),('8537','2014-04-08','12:30:00',5.02),('8537','2014-04-08','12:35:00',4.75),('8537','2014-04-08','12:40:00',4.12),('8537','2014-04-08','12:45:00',3.66),('8537','2014-04-08','12:50:00',4.26),('8537','2014-04-08','12:55:00',4.75),('8537','2014-04-08','13:00:00',4.54),('8537','2014-04-08','13:05:00',4.86),('8537','2014-04-08','13:10:00',4.89),('8537','2014-04-08','13:15:00',4.97),('8537','2014-04-08','13:20:00',4.9),('8537','2014-04-08','13:25:00',4.88),('8537','2014-04-08','13:30:00',4.94),('8537','2014-04-08','13:35:00',4.93),('8537','2014-04-08','13:40:00',4.9),('8537','2014-04-08','13:45:00',4.84),('8537','2014-04-08','13:50:00',4.86),('8537','2014-04-08','13:55:00',4.88),('8537','2014-04-08','14:00:00',4.82),('8537','2014-04-08','14:05:00',4.82),('8537','2014-04-08','14:10:00',4.78),('8537','2014-04-08','14:15:00',4.73),('8537','2014-04-08','14:20:00',4.52),('8537','2014-04-08','14:25:00',4.57),('8537','2014-04-08','14:30:00',4.61),('8537','2014-04-08','14:35:00',4.19),('8537','2014-04-08','14:40:00',4.06),('8537','2014-04-08','14:45:00',3.85),('8537','2014-04-08','14:50:00',4.37),('8537','2014-04-08','14:55:00',4.4),('8537','2014-04-08','15:00:00',4.4),('8537','2014-04-08','15:05:00',4.26),('8537','2014-04-08','15:10:00',4.28),('8537','2014-04-08','15:15:00',4.21),('8537','2014-04-08','15:20:00',4.06),('8537','2014-04-08','15:25:00',3.99),('8537','2014-04-08','15:30:00',3.84),('8537','2014-04-08','15:35:00',3.86),('8537','2014-04-08','15:40:00',3.82),('8537','2014-04-08','15:45:00',3.57),('8537','2014-04-08','15:50:00',3.65),('8537','2014-04-08','15:55:00',3.57),('8537','2014-04-08','16:00:00',3.42),('8537','2014-04-08','16:05:00',3.1),('8537','2014-04-08','16:10:00',3.05),('8537','2014-04-08','16:15:00',2.98),('8537','2014-04-08','16:20:00',2.71),('8537','2014-04-08','16:25:00',2.97),('8537','2014-04-08','16:30:00',3.05),('8537','2014-04-08','16:35:00',2.99),('8537','2014-04-08','16:40:00',2.7),('8537','2014-04-08','16:45:00',2.6),('8537','2014-04-08','16:50:00',2.64),('8537','2014-04-08','16:55:00',2.41),('8537','2014-04-08','17:00:00',2.14),('8537','2014-04-08','17:05:00',2.25),('8537','2014-04-08','17:10:00',2.11),('8537','2014-04-08','17:15:00',2.04),('8537','2014-04-08','17:20:00',1.91),('8537','2014-04-08','17:25:00',1.76),('8537','2014-04-08','17:30:00',1.59),('8537','2014-04-08','17:35:00',1.41),('8537','2014-04-08','17:40:00',1.4),('8537','2014-04-08','17:45:00',1.31),('8537','2014-04-08','17:50:00',1.22),('8537','2014-04-08','17:55:00',1.05),('8537','2014-04-08','18:00:00',1.04),('8537','2013-07-30','07:55:00',1.21),('8537','2013-07-30','08:00:00',1.35),('8537','2013-07-30','08:05:00',1.46),('8537','2013-07-30','08:10:00',1.54),('8537','2013-07-30','08:15:00',1.64),('8537','2013-07-30','08:20:00',1.86),('8537','2013-07-30','08:25:00',1.98),('8537','2013-07-30','08:30:00',2),('8537','2013-07-30','08:35:00',2.07),('8537','2013-07-30','08:40:00',2.17),('8537','2013-07-30','08:45:00',2.24),('8537','2013-07-30','08:50:00',2.36),('8537','2013-07-30','08:55:00',2.49),('8537','2013-07-30','09:00:00',2.61),('8537','2013-07-30','09:05:00',2.69),('8537','2013-07-30','09:10:00',2.79),('8537','2013-07-30','09:15:00',2.89),('8537','2013-07-30','09:20:00',3.08),('8537','2013-07-30','09:25:00',3.19),('8537','2013-07-30','09:30:00',3.26),('8537','2013-07-30','09:35:00',3.33),('8537','2013-07-30','09:40:00',3.48),('8537','2013-07-30','09:45:00',3.52),('8537','2013-07-30','09:50:00',3.55),('8537','2013-07-30','09:55:00',3.7),('8537','2013-07-30','10:00:00',3.65),('8537','2013-07-30','10:05:00',3.76),('8537','2013-07-30','10:10:00',3.84),('8537','2013-07-30','10:15:00',3.86),('8537','2013-07-30','10:20:00',3.6),('8537','2013-07-30','10:25:00',4.06),('8537','2013-07-30','10:30:00',4.07),('8537','2013-07-30','10:35:00',4.11),('8537','2013-07-30','10:40:00',4.11),('8537','2013-07-30','10:45:00',4.17),('8537','2013-07-30','10:50:00',4.15),('8537','2013-07-30','10:55:00',4.2),('8537','2013-07-30','11:00:00',4.06),('8537','2013-07-30','11:05:00',4.3),('8537','2013-07-30','11:10:00',4.5),('8537','2013-07-30','11:15:00',4.53),('8537','2013-07-30','11:20:00',3.68),('8537','2013-07-30','11:30:00',1.38),('8537','2013-07-30','11:35:00',3.96),('8537','2013-07-30','11:40:00',4.65),('8537','2013-07-30','11:45:00',4.68),('8537','2013-07-30','11:50:00',4.71),('8537','2013-07-30','11:55:00',4.64),('8537','2013-07-30','12:00:00',4.64),('8537','2013-07-30','12:05:00',4.7),('8537','2013-07-30','12:10:00',4.73),('8537','2013-07-30','12:15:00',4.67),('8537','2013-07-30','12:20:00',4.66),('8537','2013-07-30','12:25:00',4.67),('8537','2013-07-30','12:30:00',4.74),('8537','2013-07-30','12:35:00',4.77),('8537','2013-07-30','12:40:00',3.39),('8537','2013-07-30','12:45:00',2.68),('8537','2013-07-30','12:50:00',5.06),('8537','2013-07-30','12:55:00',5.12),('8537','2013-07-30','13:00:00',4.88),('8537','2013-07-30','13:05:00',3.68),('8537','2013-07-30','13:10:00',3.74),('8537','2013-07-30','13:15:00',5.04),('8537','2013-07-30','13:20:00',4.96),('8537','2013-07-30','13:25:00',4.47),('8537','2013-07-30','13:30:00',4.3),('8537','2013-07-30','13:35:00',4.92),('8537','2013-07-30','13:40:00',4.88),('8537','2013-07-30','13:45:00',4.79),('8537','2013-07-30','13:50:00',4.94),('8537','2013-07-30','13:55:00',4.97),('8537','2013-07-30','14:00:00',4.87),('8537','2013-07-30','14:05:00',4.89),('8537','2013-07-30','14:10:00',4.18),('8537','2013-07-30','14:15:00',4.69),('8537','2013-07-30','14:20:00',4.61),('8537','2013-07-30','14:25:00',4.66),('8537','2013-07-30','14:30:00',4.66),('8537','2013-07-30','14:35:00',4.56),('8537','2013-07-30','14:40:00',4.48),('8537','2013-07-30','14:45:00',4.37),('8537','2013-07-30','14:50:00',4.17),('8537','2013-07-30','14:55:00',4.33),('8537','2013-07-30','15:00:00',4.26),('8537','2013-07-30','15:05:00',4.17),('8537','2013-07-30','15:10:00',4.07),('8537','2013-07-30','15:15:00',4.07),('8537','2013-07-30','15:20:00',4),('8537','2013-07-30','15:25:00',3.85),('8537','2013-07-30','15:30:00',3.89),('8537','2013-07-30','15:35:00',3.88),('8537','2013-07-30','15:40:00',3.79),('8537','2013-07-30','15:45:00',3.55),('8537','2013-07-30','15:50:00',3.68),('8537','2013-07-30','15:55:00',3.6),('8537','2013-07-30','16:00:00',3.56),('8537','2013-07-30','16:05:00',3.48),('8537','2013-07-30','16:10:00',3.41),('8537','2013-07-30','16:15:00',3.36),('8537','2013-07-30','16:20:00',3.31),('8537','2013-07-30','16:25:00',3.18),('8537','2013-07-30','16:30:00',3.08),('8537','2013-07-30','16:35:00',3.03),('8537','2013-07-30','16:40:00',2.98),('8537','2013-07-30','16:45:00',2.88),('8537','2013-07-30','16:50:00',2.8),('8537','2013-07-30','16:55:00',2.7),('8537','2013-07-30','17:00:00',2.64),('8537','2013-07-30','17:05:00',2.27),('8537','2013-07-30','17:10:00',2.33),('8537','2013-07-30','17:15:00',2.35),('8537','2013-07-30','17:20:00',2.29),('8537','2013-07-30','17:25:00',2.16),('8537','2013-07-30','17:30:00',2.02),('8537','2013-07-30','17:35:00',1.97),('8537','2013-07-30','17:40:00',1.89),('8537','2013-07-30','17:45:00',1.77),('8537','2013-07-30','17:50:00',1.66),('8537','2013-07-30','17:55:00',1.52),('8537','2013-07-30','18:00:00',1.44),('8537','2013-07-30','18:05:00',1.36),('8537','2013-07-30','18:10:00',1.28),('8537','2013-07-30','18:15:00',1.19),('8537','2013-07-30','18:20:00',1.1),('8537','2013-07-30','18:25:00',1.02),('8537','2013-07-29','07:50:00',1.05),('8537','2013-07-29','07:55:00',1.14),('8537','2013-07-29','08:00:00',1.24),('8537','2013-07-29','08:05:00',1.33),('8537','2013-07-29','08:10:00',1.42),('8537','2013-07-29','08:15:00',1.5),('8537','2013-07-29','08:20:00',1.56),('8537','2013-07-29','08:25:00',1.66),('8537','2013-07-29','08:30:00',1.76),('8537','2013-07-29','08:35:00',1.84),('8537','2013-07-29','08:40:00',1.96),('8537','2013-07-29','08:45:00',2.04),('8537','2013-07-29','08:50:00',2.1),('8537','2013-07-29','08:55:00',2.19),('8537','2013-07-29','09:00:00',2.26),('8537','2013-07-29','09:05:00',2.38),('8537','2013-07-29','09:10:00',2.47),('8537','2013-07-29','09:15:00',2.56),('8537','2013-07-29','09:20:00',2.65),('8537','2013-07-29','09:25:00',2.72),('8537','2013-07-29','09:30:00',2.78),('8537','2013-07-29','09:35:00',2.87),('8537','2013-07-29','09:40:00',2.99),('8537','2013-07-29','09:45:00',3.08),('8537','2013-07-29','09:50:00',3.13),('8537','2013-07-29','09:55:00',3.2),('8537','2013-07-29','10:00:00',3.28),('8537','2013-07-29','10:05:00',3.37),('8537','2013-07-29','10:10:00',3.44),('8537','2013-07-29','10:15:00',3.48),('8537','2013-07-29','10:20:00',3.59),('8537','2013-07-29','10:25:00',3.64),('8537','2013-07-29','10:30:00',3.66),('8537','2013-07-29','10:35:00',3.71),('8537','2013-07-29','10:40:00',3.8),('8537','2013-07-29','10:45:00',3.76),('8537','2013-07-29','10:50:00',3.83),('8537','2013-07-29','10:55:00',3.89),('8537','2013-07-29','11:00:00',3.94),('8537','2013-07-29','11:05:00',3.93),('8537','2013-07-29','11:10:00',3.94),('8537','2013-07-29','11:15:00',4.05),('8537','2013-07-29','11:20:00',4.1),('8537','2013-07-29','11:25:00',4.14),('8537','2013-07-29','11:30:00',4.16),('8537','2013-07-29','11:35:00',4.17),('8537','2013-07-29','11:40:00',4.19),('8537','2013-07-29','11:45:00',4.19),('8537','2013-07-29','11:50:00',4.25),('8537','2013-07-29','11:55:00',4.28),('8537','2013-07-29','12:00:00',4.27),('8537','2013-07-29','12:05:00',4.3),('8537','2013-07-29','12:10:00',4.33),('8537','2013-07-29','12:15:00',4.41),('8537','2013-07-29','12:20:00',4.4),('8537','2013-07-29','12:25:00',4.39),('8537','2013-07-29','12:30:00',4.45),('8537','2013-07-29','12:35:00',4.48),('8537','2013-07-29','12:40:00',4.47),('8537','2013-07-29','12:45:00',4.48),('8537','2013-07-29','12:50:00',4.46),('8537','2013-07-29','12:55:00',4.4),('8537','2013-07-29','13:00:00',4.41),('8537','2013-07-29','13:05:00',4.53),('8537','2013-07-29','13:10:00',4.56),('8537','2013-07-29','13:15:00',4.58),('8537','2013-07-29','13:20:00',4.63),('8537','2013-07-29','13:25:00',4.64),('8537','2013-07-29','13:30:00',4.68),('8537','2013-07-29','13:35:00',4.67),('8537','2013-07-29','13:40:00',4.66),('8537','2013-07-29','13:45:00',4.62),('8537','2013-07-29','13:50:00',4.63),('8537','2013-07-29','13:55:00',4.61),('8537','2013-07-29','14:00:00',4.58),('8537','2013-07-29','14:05:00',4.59),('8537','2013-07-29','14:10:00',4.54),('8537','2013-07-29','14:15:00',4.5),('8537','2013-07-29','14:20:00',4.5),('8537','2013-07-29','14:25:00',4.43),('8537','2013-07-29','14:30:00',4.42),('8537','2013-07-29','14:35:00',4.38),('8537','2013-07-29','14:40:00',4.35),('8537','2013-07-29','14:45:00',4.26),('8537','2013-07-29','14:50:00',4.22),('8537','2013-07-29','14:55:00',4.2),('8537','2013-07-29','15:00:00',4.16),('8537','2013-07-29','15:05:00',4.14),('8537','2013-07-29','15:10:00',4.11),('8537','2013-07-29','15:15:00',4.07),('8537','2013-07-29','15:20:00',4),('8537','2013-07-29','15:25:00',3.96),('8537','2013-07-29','15:30:00',3.9),('8537','2013-07-29','15:35:00',3.87),('8537','2013-07-29','15:40:00',3.86),('8537','2013-07-29','15:45:00',3.72),('8537','2013-07-29','15:50:00',3.32),('8537','2013-07-29','15:55:00',2.18),('8537','2013-07-29','16:00:00',1.9),('8537','2013-07-29','16:05:00',3.05),('8537','2013-07-29','16:10:00',3.3),('8537','2013-07-29','16:15:00',2.74),('8537','2013-07-29','16:20:00',2.81),('8537','2013-07-29','16:25:00',2.51),('8537','2013-07-29','16:30:00',3.36),('8537','2013-07-29','16:35:00',2.97),('8537','2013-07-29','16:40:00',2.46),('8537','2013-07-29','16:45:00',3.11),('8537','2013-07-29','16:50:00',2.98),('8537','2013-07-29','16:55:00',1.89),('8537','2013-07-29','17:00:00',1.51),('8537','2013-07-29','17:05:00',1.69),('8537','2013-07-29','17:10:00',1.41),('8537','2013-07-29','17:15:00',1.01),('8537','2013-07-29','17:20:00',2.17),('8537','2013-07-29','17:25:00',2.08),('8537','2013-07-29','17:30:00',1.41),('8537','2013-07-29','17:40:00',1.07),('8537','2013-07-29','17:45:00',1.89),('8537','2013-07-29','17:50:00',1.67),('8537','2013-07-29','17:55:00',1.49),('8537','2013-07-29','18:00:00',1.15),('8537','2013-07-29','18:10:00',1.14),('8537','2013-07-29','18:20:00',1.1),('8537','2013-07-29','18:25:00',1.05),('8537','2013-07-28','07:50:00',1.03),('8537','2013-07-28','07:55:00',1.11),('8537','2013-07-28','08:00:00',1.23),('8537','2013-07-28','08:05:00',1.32),('8537','2013-07-28','08:10:00',1.42),('8537','2013-07-28','08:15:00',1.51),('8537','2013-07-28','08:20:00',1.61),('8537','2013-07-28','08:25:00',1.7),('8537','2013-07-28','08:30:00',1.82),('8537','2013-07-28','08:35:00',1.91),('8537','2013-07-28','08:40:00',2),('8537','2013-07-28','08:45:00',2.1),('8537','2013-07-28','08:50:00',2.18),('8537','2013-07-28','08:55:00',2.28),('8537','2013-07-28','09:00:00',2.38),('8537','2013-07-28','09:05:00',2.48),('8537','2013-07-28','09:10:00',2.55),('8537','2013-07-28','09:15:00',2.64),('8537','2013-07-28','09:20:00',2.69),('8537','2013-07-28','09:25:00',2.75),('8537','2013-07-28','09:30:00',2.87),('8537','2013-07-28','09:35:00',2.96),('8537','2013-07-28','09:40:00',3.03),('8537','2013-07-28','09:45:00',3.09),('8537','2013-07-28','09:50:00',3.18),('8537','2013-07-28','09:55:00',3.22),('8537','2013-07-28','10:00:00',3.3),('8537','2013-07-28','10:05:00',3.36),('8537','2013-07-28','10:10:00',3.43),('8537','2013-07-28','10:15:00',3.49),('8537','2013-07-28','10:20:00',3.57),('8537','2013-07-28','10:25:00',3.6),('8537','2013-07-28','10:30:00',3.65),('8537','2013-07-28','10:35:00',3.68),('8537','2013-07-28','10:40:00',3.76),('8537','2013-07-28','10:45:00',3.84),('8537','2013-07-28','10:50:00',3.85),('8537','2013-07-28','10:55:00',3.87),('8537','2013-07-28','11:00:00',3.96),('8537','2013-07-28','11:05:00',4.02),('8537','2013-07-28','11:10:00',4.05),('8537','2013-07-28','11:15:00',4.08),('8537','2013-07-28','11:20:00',4.15),('8537','2013-07-28','11:25:00',4.2),('8537','2013-07-28','11:30:00',4.19),('8537','2013-07-28','11:35:00',4.25),('8537','2013-07-28','11:40:00',4.27),('8537','2013-07-28','11:45:00',4.25),('8537','2013-07-28','11:50:00',4.27),('8537','2013-07-28','11:55:00',4.33),('8537','2013-07-28','12:00:00',4.32),('8537','2013-07-28','12:05:00',4.35),('8537','2013-07-28','12:10:00',4.36),('8537','2013-07-28','12:15:00',4.32),('8537','2013-07-28','12:20:00',4.37),('8537','2013-07-28','12:25:00',4.36),('8537','2013-07-28','12:30:00',4.41),('8537','2013-07-28','12:35:00',4.52),('8537','2013-07-28','12:40:00',4.57),('8537','2013-07-28','12:45:00',4.47),('8537','2013-07-28','12:50:00',4.43),('8537','2013-07-28','12:55:00',4.5),('8537','2013-07-28','13:00:00',4.51),('8537','2013-07-28','13:05:00',4.52),('8537','2013-07-28','13:10:00',3.79),('8537','2013-07-28','13:15:00',4.64),('8537','2013-07-28','13:20:00',4.7),('8537','2013-07-28','13:25:00',4.62),('8537','2013-07-28','13:30:00',4.62),('8537','2013-07-28','13:35:00',4.61),('8537','2013-07-28','13:40:00',4.63),('8537','2013-07-28','13:45:00',4.64),('8537','2013-07-28','13:50:00',4.68),('8537','2013-07-28','13:55:00',4.63),('8537','2013-07-28','14:00:00',4.57),('8537','2013-07-28','14:05:00',4.54),('8537','2013-07-28','14:10:00',4.51),('8537','2013-07-28','14:15:00',4.56),('8537','2013-07-28','14:20:00',4.53),('8537','2013-07-28','14:25:00',4.48),('8537','2013-07-28','14:30:00',4.4),('8537','2013-07-28','14:35:00',4.38),('8537','2013-07-28','14:40:00',4.39),('8537','2013-07-28','14:45:00',4.3),('8537','2013-07-28','14:50:00',4.03),('8537','2013-07-28','14:55:00',3.65),('8537','2013-07-28','15:00:00',3.86),('8537','2013-07-28','15:05:00',4.11),('8537','2013-07-28','15:10:00',4.1),('8537','2013-07-28','15:15:00',4),('8537','2013-07-28','15:20:00',3.95),('8537','2013-07-28','15:25:00',3.91),('8537','2013-07-28','15:30:00',3.9),('8537','2013-07-28','15:35:00',3.84),('8537','2013-07-28','15:40:00',3.79),('8537','2013-07-28','15:45:00',3.62),('8537','2013-07-28','15:50:00',3.67),('8537','2013-07-28','15:55:00',3.6),('8537','2013-07-28','16:00:00',3.55),('8537','2013-07-28','16:05:00',3.52),('8537','2013-07-28','16:10:00',3.46),('8537','2013-07-28','16:15:00',3.39),('8537','2013-07-28','16:20:00',3.34),('8537','2013-07-28','16:25:00',3.24),('8537','2013-07-28','16:30:00',3.16),('8537','2013-07-28','16:35:00',3.09),('8537','2013-07-28','16:40:00',2.99),('8537','2013-07-28','16:45:00',2.93),('8537','2013-07-28','16:50:00',2.85),('8537','2013-07-28','16:55:00',2.78),('8537','2013-07-28','17:00:00',2.68),('8537','2013-07-28','17:05:00',2.37),('8537','2013-07-28','17:10:00',1.97),('8537','2013-07-28','17:15:00',2.42),('8537','2013-07-28','17:20:00',2.33),('8537','2013-07-28','17:25:00',2.17),('8537','2013-07-28','17:30:00',2.06),('8537','2013-07-28','17:35:00',2),('8537','2013-07-28','17:40:00',1.91),('8537','2013-07-28','17:45:00',1.82),('8537','2013-07-28','17:50:00',1.71),('8537','2013-07-28','17:55:00',1.6),('8537','2013-07-28','18:00:00',1.48),('8537','2013-07-28','18:05:00',1.4),('8537','2013-07-28','18:10:00',1.32),('8537','2013-07-28','18:15:00',1.23),('8537','2013-07-28','18:20:00',1.13),('8537','2013-07-28','18:25:00',1.04),('8537','2013-07-27','07:50:00',1.07),('8537','2013-07-27','07:55:00',1.17),('8537','2013-07-27','08:00:00',1.27),('8537','2013-07-27','08:05:00',1.36),('8537','2013-07-27','08:10:00',1.46),('8537','2013-07-27','08:15:00',1.57),('8537','2013-07-27','08:20:00',1.65),('8537','2013-07-27','08:25:00',1.72),('8537','2013-07-27','08:30:00',1.85),('8537','2013-07-27','08:35:00',1.95),('8537','2013-07-27','08:40:00',2.04),('8537','2013-07-27','08:45:00',2.12),('8537','2013-07-27','08:50:00',2.21),('8537','2013-07-27','08:55:00',2.32),('8537','2013-07-27','09:00:00',2.41),('8537','2013-07-27','09:05:00',2.53),('8537','2013-07-27','09:10:00',2.61),('8537','2013-07-27','09:15:00',2.7),('8537','2013-07-27','09:20:00',2.79),('8537','2013-07-27','09:25:00',2.85),('8537','2013-07-27','09:30:00',2.94),('8537','2013-07-27','09:35:00',3.02),('8537','2013-07-27','09:40:00',3.05),('8537','2013-07-27','09:45:00',3.18),('8537','2013-07-27','09:50:00',3.26),('8537','2013-07-27','09:55:00',3.36),('8537','2013-07-27','10:00:00',3.41),('8537','2013-07-27','10:05:00',3.47),('8537','2013-07-27','10:10:00',3.53),('8537','2013-07-27','10:15:00',3.62),('8537','2013-07-27','10:20:00',3.68),('8537','2013-07-27','10:25:00',3.71),('8537','2013-07-27','10:30:00',3.75),('8537','2013-07-27','10:35:00',3.78),('8537','2013-07-27','10:40:00',3.87),('8537','2013-07-27','10:45:00',3.92),('8537','2013-07-27','10:50:00',3.98),('8537','2013-07-27','10:55:00',4.04),('8537','2013-07-27','11:00:00',4.07),('8537','2013-07-27','11:05:00',4.09),('8537','2013-07-27','11:10:00',4.06),('8537','2013-07-27','11:15:00',4.24),('8537','2013-07-27','11:20:00',4.31),('8537','2013-07-27','11:25:00',4.31),('8537','2013-07-27','11:30:00',4.38),('8537','2013-07-27','11:35:00',4.38),('8537','2013-07-27','11:40:00',4.44),('8537','2013-07-27','11:45:00',4.44),('8537','2013-07-27','11:50:00',4.44),('8537','2013-07-27','11:55:00',4.51),('8537','2013-07-27','12:00:00',4.51),('8537','2013-07-27','12:05:00',4.55),('8537','2013-07-27','12:10:00',4.6),('8537','2013-07-27','12:15:00',4.61),('8537','2013-07-27','12:20:00',4.59),('8537','2013-07-27','12:25:00',4.53),('8537','2013-07-27','12:30:00',4.5),('8537','2013-07-27','12:35:00',4.54),('8537','2013-07-27','12:40:00',4.42),('8537','2013-07-27','12:45:00',4.58),('8537','2013-07-27','12:50:00',4.56),('8537','2013-07-27','12:55:00',4.62),('8537','2013-07-27','13:00:00',4.77),('8537','2013-07-27','13:05:00',4.8),('8537','2013-07-27','13:10:00',4.74),('8537','2013-07-27','13:15:00',4.69),('8537','2013-07-27','13:20:00',4.71),('8537','2013-07-27','13:25:00',4.74),('8537','2013-07-27','13:30:00',4.65),('8537','2013-07-27','13:35:00',4.69),('8537','2013-07-27','13:40:00',4.5),('8537','2013-07-27','13:45:00',4.74),('8537','2013-07-27','13:50:00',4.71),('8537','2013-07-27','13:55:00',4.71),('8537','2013-07-27','14:00:00',4.37),('8537','2013-07-27','14:05:00',4.4),('8537','2013-07-27','14:10:00',4.53),('8537','2013-07-27','14:15:00',4.62),('8537','2013-07-27','14:20:00',4.51),('8537','2013-07-27','14:25:00',4.41),('8537','2013-07-27','14:30:00',4.41),('8537','2013-07-27','14:35:00',4.38),('8537','2013-07-27','14:40:00',4.41),('8537','2013-07-27','14:45:00',4.27),('8537','2013-07-27','14:50:00',4.15),('8537','2013-07-27','14:55:00',4.19),('8537','2013-07-27','15:00:00',4.12),('8537','2013-07-27','15:05:00',4.09),('8537','2013-07-27','15:10:00',4.09),('8537','2013-07-27','15:15:00',4.05),('8537','2013-07-27','15:20:00',4.01),('8537','2013-07-27','15:25:00',3.97),('8537','2013-07-27','15:30:00',3.9),('8537','2013-07-27','15:35:00',3.88),('8537','2013-07-27','15:40:00',3.8),('8537','2013-07-27','15:45:00',3.7),('8537','2013-07-27','15:50:00',3.68),('8537','2013-07-27','15:55:00',3.61),('8537','2013-07-27','16:00:00',3.55),('8537','2013-07-27','16:05:00',3.49),('8537','2013-07-27','16:10:00',3.43),('8537','2013-07-27','16:15:00',3.35),('8537','2013-07-27','16:20:00',3.3),('8537','2013-07-27','16:25:00',3.19),('8537','2013-07-27','16:30:00',3.14),('8537','2013-07-27','16:35:00',3.09),('8537','2013-07-27','16:40:00',3),('8537','2013-07-27','16:45:00',2.93),('8537','2013-07-27','16:50:00',2.84),('8537','2013-07-27','16:55:00',2.76),('8537','2013-07-27','17:00:00',2.65),('8537','2013-07-27','17:05:00',2.39),('8537','2013-07-27','17:10:00',1.92),('8537','2013-07-27','17:15:00',2.4),('8537','2013-07-27','17:20:00',2.34),('8537','2013-07-27','17:25:00',2.19),('8537','2013-07-27','17:30:00',2.08),('8537','2013-07-27','17:35:00',2),('8537','2013-07-27','17:40:00',1.91),('8537','2013-07-27','17:45:00',1.81),('8537','2013-07-27','17:50:00',1.71),('8537','2013-07-27','17:55:00',1.62),('8537','2013-07-27','18:00:00',1.5),('8537','2013-07-27','18:05:00',1.43),('8537','2013-07-27','18:10:00',1.34),('8537','2013-07-27','18:15:00',1.24),('8537','2013-07-27','18:20:00',1.14),('8537','2013-07-27','18:25:00',1.05),('8537','2013-07-26','07:50:00',1.08),('8537','2013-07-26','07:55:00',1.13),('8537','2013-07-26','08:00:00',1.2),('8537','2013-07-26','08:05:00',1.32),('8537','2013-07-26','08:10:00',1.43),('8537','2013-07-26','08:15:00',1.52),('8537','2013-07-26','08:20:00',1.59),('8537','2013-07-26','08:25:00',1.69),('8537','2013-07-26','08:30:00',1.8),('8537','2013-07-26','08:35:00',1.89),('8537','2013-07-26','08:40:00',1.97),('8537','2013-07-26','08:45:00',2.07),('8537','2013-07-26','08:50:00',2.13),('8537','2013-07-26','08:55:00',2.25),('8537','2013-07-26','09:00:00',2.37),('8537','2013-07-26','09:05:00',2.46),('8537','2013-07-26','09:10:00',2.53),('8537','2013-07-26','09:15:00',2.66),('8537','2013-07-26','09:20:00',2.73),('8537','2013-07-26','09:25:00',2.82),('8537','2013-07-26','09:30:00',2.9),('8537','2013-07-26','09:35:00',2.95),('8537','2013-07-26','09:40:00',3.03),('8537','2013-07-26','09:45:00',2.92),('8537','2013-07-26','09:50:00',3.17),('8537','2013-07-26','09:55:00',3.3),('8537','2013-07-26','10:00:00',3.35),('8537','2013-07-26','10:05:00',3.4),('8537','2013-07-26','10:10:00',3.45),('8537','2013-07-26','10:15:00',3.55),('8537','2013-07-26','10:20:00',3.62),('8537','2013-07-26','10:25:00',3.68),('8537','2013-07-26','10:30:00',3.73),('8537','2013-07-26','10:35:00',3.78),('8537','2013-07-26','10:40:00',3.78),('8537','2013-07-26','10:45:00',3.92),('8537','2013-07-26','10:50:00',3.96),('8537','2013-07-26','10:55:00',3.97),('8537','2013-07-26','11:00:00',3.93),('8537','2013-07-26','11:05:00',3.7),('8537','2013-07-26','11:10:00',2.6),('8537','2013-07-26','11:15:00',4.17),('8537','2013-07-26','11:20:00',4.17),('8537','2013-07-26','11:25:00',4.28),('8537','2013-07-26','11:30:00',3.86),('8537','2013-07-26','11:35:00',4.19),('8537','2013-07-26','11:40:00',4.12),('8537','2013-07-26','11:45:00',4.43),('8537','2013-07-26','11:50:00',4.4),('8537','2013-07-26','11:55:00',4.38),('8537','2013-07-26','12:00:00',4.24),('8537','2013-07-26','12:05:00',3.06),('8537','2013-07-26','12:10:00',3.15),('8537','2013-07-26','12:15:00',4.33),('8537','2013-07-26','12:20:00',4.03),('8537','2013-07-26','12:25:00',4.77),('8537','2013-07-26','12:30:00',4.7),('8537','2013-07-26','12:35:00',4.64),('8537','2013-07-26','12:40:00',4.53),('8537','2013-07-26','12:45:00',4.88),('8537','2013-07-26','12:50:00',3.55),('8537','2013-07-26','12:55:00',4),('8537','2013-07-26','13:00:00',1.6),('8537','2013-07-26','13:05:00',1.57),('8537','2013-07-26','13:10:00',1.5),('8537','2013-07-26','13:15:00',1.54),('8537','2013-07-26','13:20:00',4.02),('8537','2013-07-26','13:25:00',5.02),('8537','2013-07-26','13:30:00',4.88),('8537','2013-07-26','13:35:00',4.79),('8537','2013-07-26','13:40:00',4.61),('8537','2013-07-26','13:45:00',4.9),('8537','2013-07-26','13:50:00',4.42),('8537','2013-07-26','13:55:00',4.07),('8537','2013-07-26','14:00:00',4.82),('8537','2013-07-26','14:05:00',4.72),('8537','2013-07-26','14:10:00',4.43),('8537','2013-07-26','14:15:00',4.74),('8537','2013-07-26','14:20:00',4.63),('8537','2013-07-26','14:25:00',4.62),('8537','2013-07-26','14:30:00',4.53),('8537','2013-07-26','14:35:00',4.52),('8537','2013-07-26','14:40:00',4.51),('8537','2013-07-26','14:45:00',4.35),('8537','2013-07-26','14:50:00',4.17),('8537','2013-07-26','14:55:00',3.8),('8537','2013-07-26','15:00:00',4.26),('8537','2013-07-26','15:05:00',4.16),('8537','2013-07-26','15:10:00',4.12),('8537','2013-07-26','15:15:00',4.1),('8537','2013-07-26','15:20:00',3.99),('8537','2013-07-26','15:25:00',3.94),('8537','2013-07-26','15:30:00',3.9),('8537','2013-07-26','15:35:00',3.92),('8537','2013-07-26','15:40:00',3.84),('8537','2013-07-26','15:45:00',3.75),('8537','2013-07-26','15:50:00',3.72),('8537','2013-07-26','15:55:00',3.63),('8537','2013-07-26','16:00:00',3.58),('8537','2013-07-26','16:05:00',3.54),('8537','2013-07-26','16:10:00',3.45),('8537','2013-07-26','16:15:00',3.36),('8537','2013-07-26','16:20:00',3.34),('8537','2013-07-26','16:25:00',3.26),('8537','2013-07-26','16:30:00',3.16),('8537','2013-07-26','16:35:00',3.08),('8537','2013-07-26','16:40:00',3.01),('8537','2013-07-26','16:45:00',2.94),('8537','2013-07-26','16:50:00',2.87),('8537','2013-07-26','16:55:00',2.77),('8537','2013-07-26','17:00:00',2.69),('8537','2013-07-26','17:05:00',2.46),('8537','2013-07-26','17:10:00',2.04),('8537','2013-07-26','17:15:00',2.24),('8537','2013-07-26','17:20:00',2.29),('8537','2013-07-26','17:25:00',2.19),('8537','2013-07-26','17:30:00',2.01),('8537','2013-07-26','17:35:00',1.97),('8537','2013-07-26','17:40:00',1.89),('8537','2013-07-26','17:45:00',1.79),('8537','2013-07-26','17:50:00',1.59),('8537','2013-07-26','17:55:00',1.55),('8537','2013-07-26','18:00:00',1.41),('8537','2013-07-26','18:05:00',1.36),('8537','2013-07-26','18:10:00',1.28),('8537','2013-07-26','18:15:00',1.2),('8537','2013-07-26','18:20:00',1.08),('8537','2013-07-26','18:25:00',1.03),('8537','2013-07-25','07:50:00',1.08),('8537','2013-07-25','07:55:00',1.18),('8537','2013-07-25','08:00:00',1.27),('8537','2013-07-25','08:05:00',1.34),('8537','2013-07-25','08:10:00',1.43),('8537','2013-07-25','08:15:00',1.54),('8537','2013-07-25','08:20:00',1.61),('8537','2013-07-25','08:25:00',1.7),('8537','2013-07-25','08:30:00',1.79),('8537','2013-07-25','08:35:00',1.89),('8537','2013-07-25','08:40:00',1.98),('8537','2013-07-25','08:45:00',2.07),('8537','2013-07-25','08:50:00',2.15),('8537','2013-07-25','08:55:00',2.31),('8537','2013-07-25','09:00:00',2.38),('8537','2013-07-25','09:05:00',2.53),('8537','2013-07-25','09:10:00',2.66),('8537','2013-07-25','09:15:00',2.78),('8537','2013-07-25','09:20:00',2.85),('8537','2013-07-25','09:25:00',1.71),('8537','2013-07-25','09:30:00',2.05),('8537','2013-07-25','09:35:00',1.64),('8537','2013-07-25','09:40:00',2.91),('8537','2013-07-25','09:45:00',2.95),('8537','2013-07-25','09:50:00',2.34),('8537','2013-07-25','09:55:00',1.07),('8537','2013-07-25','10:00:00',1.15),('8537','2013-07-25','10:05:00',2.5),('8537','2013-07-25','10:10:00',3.43),('8537','2013-07-25','10:15:00',3.7),('8537','2013-07-25','10:20:00',3.81),('8537','2013-07-25','10:25:00',3.83),('8537','2013-07-25','10:30:00',3.75),('8537','2013-07-25','10:35:00',3.93),('8537','2013-07-25','10:40:00',2.58),('8537','2013-07-25','10:45:00',3.22),('8537','2013-07-25','10:50:00',3.57),('8537','2013-07-25','10:55:00',3.18),('8537','2013-07-25','11:00:00',1.36),('8537','2013-07-25','11:05:00',4.06),('8537','2013-07-25','11:10:00',4.32),('8537','2013-07-25','11:15:00',4.22),('8537','2013-07-25','11:20:00',3.99),('8537','2013-07-25','11:25:00',4.49),('8537','2013-07-25','11:30:00',4.42),('8537','2013-07-25','11:35:00',3.94),('8537','2013-07-25','11:40:00',4.04),('8537','2013-07-25','11:45:00',4.57),('8537','2013-07-25','11:50:00',3.93),('8537','2013-07-25','11:55:00',2.57),('8537','2013-07-25','12:00:00',4.06),('8537','2013-07-25','12:05:00',4.25),('8537','2013-07-25','12:10:00',2.39),('8537','2013-07-25','12:15:00',2.96),('8537','2013-07-25','12:20:00',3.03),('8537','2013-07-25','12:25:00',1.79),('8537','2013-07-25','12:30:00',2.15),('8537','2013-07-25','12:35:00',3.02),('8537','2013-07-25','12:40:00',1.64),('8537','2013-07-25','12:45:00',1.44),('8537','2013-07-25','12:50:00',2.06),('8537','2013-07-25','12:55:00',3.37),('8537','2013-07-25','13:00:00',5.15),('8537','2013-07-25','13:05:00',4.37),('8537','2013-07-25','13:10:00',3.76),('8537','2013-07-25','13:15:00',5.03),('8537','2013-07-25','13:20:00',4.95),('8537','2013-07-25','13:25:00',4.87),('8537','2013-07-25','13:30:00',4.9),('8537','2013-07-25','13:35:00',4.74),('8537','2013-07-25','13:40:00',4.82),('8537','2013-07-25','13:45:00',4.8),('8537','2013-07-25','13:50:00',4.78),('8537','2013-07-25','13:55:00',4.72),('8537','2013-07-25','14:00:00',4.77),('8537','2013-07-25','14:05:00',4.77),('8537','2013-07-25','14:10:00',4.78),('8537','2013-07-25','14:15:00',4.8),('8537','2013-07-25','14:20:00',4.77),('8537','2013-07-25','14:25:00',4.7),('8537','2013-07-25','14:30:00',4.68),('8537','2013-07-25','14:35:00',4.66),('8537','2013-07-25','14:40:00',4.54),('8537','2013-07-25','14:45:00',4.54),('8537','2013-07-25','14:50:00',4.24),('8537','2013-07-25','14:55:00',3.97),('8537','2013-07-25','15:00:00',4.38),('8537','2013-07-25','15:05:00',4.36),('8537','2013-07-25','15:10:00',4.31),('8537','2013-07-25','15:15:00',4.25),('8537','2013-07-25','15:20:00',4.23),('8537','2013-07-25','15:25:00',4.15),('8537','2013-07-25','15:30:00',4.1),('8537','2013-07-25','15:35:00',4.06),('8537','2013-07-25','15:40:00',4),('8537','2013-07-25','15:45:00',3.94),('8537','2013-07-25','15:50:00',3.86),('8537','2013-07-25','15:55:00',3.79),('8537','2013-07-25','16:00:00',3.73),('8537','2013-07-25','16:05:00',3.68),('8537','2013-07-25','16:10:00',3.62),('8537','2013-07-25','16:15:00',3.55),('8537','2013-07-25','16:20:00',3.49),('8537','2013-07-25','16:25:00',3.38),('8537','2013-07-25','16:30:00',3.24),('8537','2013-07-25','16:35:00',3.18),('8537','2013-07-25','16:40:00',3.14),('8537','2013-07-25','16:45:00',3.06),('8537','2013-07-25','16:50:00',2.97),('8537','2013-07-25','16:55:00',2.9),('8537','2013-07-25','17:00:00',2.82),('8537','2013-07-25','17:05:00',2.61),('8537','2013-07-25','17:10:00',2.09),('8537','2013-07-25','17:15:00',2.41),('8537','2013-07-25','17:20:00',2.42),('8537','2013-07-25','17:25:00',2.3),('8537','2013-07-25','17:30:00',2.18),('8537','2013-07-25','17:35:00',2.11),('8537','2013-07-25','17:40:00',2.01),('8537','2013-07-25','17:45:00',1.92),('8537','2013-07-25','17:50:00',1.72),('8537','2013-07-25','17:55:00',1.7),('8537','2013-07-25','18:00:00',1.58),('8537','2013-07-25','18:05:00',1.49),('8537','2013-07-25','18:10:00',1.39),('8537','2013-07-25','18:15:00',1.27),('8537','2013-07-25','18:20:00',1.18),('8537','2013-07-25','18:25:00',1.07),('8537','2013-07-25','18:30:00',1),('8537','2013-07-24','07:55:00',1.1),('8537','2013-07-24','08:00:00',1.07),('8537','2013-07-24','08:05:00',1.14),('8537','2013-07-24','08:10:00',1.04),('8537','2013-07-24','08:15:00',1.09),('8537','2013-07-24','08:20:00',1.48),('8537','2013-07-24','08:25:00',1.26),('8537','2013-07-24','08:30:00',1.3),('8537','2013-07-24','08:35:00',1.31),('8537','2013-07-24','08:40:00',1.21),('8537','2013-07-24','08:45:00',1.55),('8537','2013-07-24','08:50:00',1.91),('8537','2013-07-24','08:55:00',1.83),('8537','2013-07-24','09:00:00',1.6),('8537','2013-07-24','09:05:00',1.9),('8537','2013-07-24','09:10:00',2.85),('8537','2013-07-24','09:15:00',2.6),('8537','2013-07-24','09:20:00',2.18),('8537','2013-07-24','09:25:00',1.35),('8537','2013-07-24','09:30:00',1.97),('8537','2013-07-24','09:35:00',2.52),('8537','2013-07-24','09:40:00',2.85),('8537','2013-07-24','09:45:00',2.6),('8537','2013-07-24','09:50:00',1.74),('8537','2013-07-24','09:55:00',1.5),('8537','2013-07-24','10:00:00',1.17),('8537','2013-07-24','10:05:00',1.14),('8537','2013-07-24','10:10:00',1.15),('8537','2013-07-24','10:15:00',1.21),('8537','2013-07-24','10:20:00',1.69),('8537','2013-07-24','10:25:00',3.24),('8537','2013-07-24','10:30:00',3.64),('8537','2013-07-24','10:35:00',3.97),('8537','2013-07-24','10:40:00',4.28),('8537','2013-07-24','10:45:00',3.97),('8537','2013-07-24','10:50:00',2.26),('8537','2013-07-24','10:55:00',4.23),('8537','2013-07-24','11:00:00',3.5),('8537','2013-07-24','11:05:00',4.42),('8537','2013-07-24','11:10:00',3.91),('8537','2013-07-24','11:15:00',4.42),('8537','2013-07-24','11:20:00',4.34),('8537','2013-07-24','11:25:00',4.37),('8537','2013-07-24','11:30:00',4.46),('8537','2013-07-24','11:35:00',4.64),('8537','2013-07-24','11:40:00',4.53),('8537','2013-07-24','11:45:00',4.49),('8537','2013-07-24','11:50:00',4.46),('8537','2013-07-24','11:55:00',4.62),('8537','2013-07-24','12:00:00',4.78),('8537','2013-07-24','12:05:00',3.8),('8537','2013-07-24','12:10:00',1.76),('8537','2013-07-24','12:15:00',2.3),('8537','2013-07-24','12:20:00',5.19),('8537','2013-07-24','12:25:00',3.13),('8537','2013-07-24','12:30:00',1.79),('8537','2013-07-24','12:35:00',1.29),('8537','2013-07-24','12:40:00',1.47),('8537','2013-07-24','12:45:00',3.58),('8537','2013-07-24','12:50:00',1.56),('8537','2013-07-24','12:55:00',1.52),('8537','2013-07-24','13:00:00',3.05),('8537','2013-07-24','13:05:00',5.25),('8537','2013-07-24','13:10:00',4.97),('8537','2013-07-24','13:15:00',4.07),('8537','2013-07-24','13:20:00',4.12),('8537','2013-07-24','13:25:00',1.03),('8537','2013-07-24','13:30:00',2.11),('8537','2013-07-24','13:35:00',5.21),('8537','2013-07-24','13:40:00',1.49),('8537','2013-07-24','13:45:00',2.82),('8537','2013-07-24','13:50:00',3.62),('8537','2013-07-24','13:55:00',5.28),('8537','2013-07-24','14:00:00',3.61),('8537','2013-07-24','14:05:00',5.1),('8537','2013-07-24','14:10:00',4.55),('8537','2013-07-24','14:15:00',4.88),('8537','2013-07-24','14:20:00',3.76),('8537','2013-07-24','14:25:00',4.33),('8537','2013-07-24','14:30:00',4.79),('8537','2013-07-24','14:35:00',5.06),('8537','2013-07-24','14:40:00',4.76),('8537','2013-07-24','14:45:00',4.73),('8537','2013-07-24','14:50:00',4.54),('8537','2013-07-24','14:55:00',4.38),('8537','2013-07-24','15:00:00',4.44),('8537','2013-07-24','15:05:00',4.48),('8537','2013-07-24','15:10:00',4.38),('8537','2013-07-24','15:15:00',4.38),('8537','2013-07-24','15:20:00',4.31),('8537','2013-07-24','15:25:00',4.29),('8537','2013-07-24','15:30:00',4.06),('8537','2013-07-24','15:35:00',3.96),('8537','2013-07-24','15:40:00',4.02),('8537','2013-07-24','15:45:00',3.9),('8537','2013-07-24','15:50:00',3.76),('8537','2013-07-24','15:55:00',3.86),('8537','2013-07-24','16:00:00',3.75),('8537','2013-07-24','16:05:00',3.68),('8537','2013-07-24','16:10:00',3.54),('8537','2013-07-24','16:15:00',3.52),('8537','2013-07-24','16:20:00',3.61),('8537','2013-07-24','16:25:00',3.51),('8537','2013-07-24','16:30:00',3.4),('8537','2013-07-24','16:35:00',3.29),('8537','2013-07-24','16:40:00',3.27),('8537','2013-07-24','16:45:00',3.1),('8537','2013-07-24','16:50:00',3.05),('8537','2013-07-24','16:55:00',3.09),('8537','2013-07-24','17:00:00',3.05),('8537','2013-07-24','17:05:00',2.79),('8537','2013-07-24','17:10:00',1.84),('8537','2013-07-24','17:15:00',2.52),('8537','2013-07-24','17:20:00',2.53),('8537','2013-07-24','17:25:00',2.34),('8537','2013-07-24','17:30:00',2.24),('8537','2013-07-24','17:35:00',2.12),('8537','2013-07-24','17:40:00',1.99),('8537','2013-07-24','17:45:00',1.92),('8537','2013-07-24','17:50:00',1.71),('8537','2013-07-24','17:55:00',1.68),('8537','2013-07-24','18:00:00',1.55),('8537','2013-07-24','18:05:00',1.44),('8537','2013-07-24','18:10:00',1.36),('8537','2013-07-24','18:15:00',1.23),('8537','2013-07-24','18:20:00',1.11),('8537','2013-07-24','18:25:00',1.1),('8537','2013-07-24','18:30:00',1.04),('8537','2013-07-23','07:45:00',1.09),('8537','2013-07-23','07:50:00',1.13),('8537','2013-07-23','07:55:00',1.23),('8537','2013-07-23','08:00:00',1.39),('8537','2013-07-23','08:05:00',1.52),('8537','2013-07-23','08:10:00',1.62),('8537','2013-07-23','08:15:00',1.72),('8537','2013-07-23','08:20:00',1.81),('8537','2013-07-23','08:25:00',1.9),('8537','2013-07-23','08:30:00',2),('8537','2013-07-23','08:35:00',2.1),('8537','2013-07-23','08:40:00',2.2),('8537','2013-07-23','08:45:00',2.29),('8537','2013-07-23','08:50:00',2.39),('8537','2013-07-23','08:55:00',2.5),('8537','2013-07-23','09:00:00',2.58),('8537','2013-07-23','09:05:00',2.67),('8537','2013-07-23','09:10:00',2.75),('8537','2013-07-23','09:15:00',2.82),('8537','2013-07-23','09:20:00',2.87),('8537','2013-07-23','09:25:00',2.94),('8537','2013-07-23','09:30:00',3.03),('8537','2013-07-23','09:35:00',3.11),('8537','2013-07-23','09:40:00',3.19),('8537','2013-07-23','09:45:00',3.22),('8537','2013-07-23','09:50:00',3.28),('8537','2013-07-23','09:55:00',3.3),('8537','2013-07-23','10:00:00',3.39),('8537','2013-07-23','10:05:00',3.42),('8537','2013-07-23','10:10:00',3.54),('8537','2013-07-23','10:15:00',3.61),('8537','2013-07-23','10:20:00',3.68),('8537','2013-07-23','10:25:00',3.77),('8537','2013-07-23','10:30:00',3.88),('8537','2013-07-23','10:35:00',3.96),('8537','2013-07-23','10:40:00',4.02),('8537','2013-07-23','10:45:00',4.04),('8537','2013-07-23','10:50:00',4.07),('8537','2013-07-23','10:55:00',4.12),('8537','2013-07-23','11:00:00',4.18),('8537','2013-07-23','11:05:00',4.19),('8537','2013-07-23','11:10:00',4.22),('8537','2013-07-23','11:15:00',4.27),('8537','2013-07-23','11:20:00',4.32),('8537','2013-07-23','11:25:00',4.39),('8537','2013-07-23','11:30:00',4.47),('8537','2013-07-23','11:35:00',4.51),('8537','2013-07-23','11:40:00',4.48),('8537','2013-07-23','11:45:00',4.49),('8537','2013-07-23','11:50:00',4.47),('8537','2013-07-23','11:55:00',4.57),('8537','2013-07-23','12:00:00',4.61),('8537','2013-07-23','12:05:00',4.66),('8537','2013-07-23','12:10:00',4.7),('8537','2013-07-23','12:15:00',4.7),('8537','2013-07-23','12:20:00',4.7),('8537','2013-07-23','12:25:00',4.69),('8537','2013-07-23','12:30:00',4.71),('8537','2013-07-23','12:35:00',4.74),('8537','2013-07-23','12:40:00',4.64),('8537','2013-07-23','12:45:00',4.83),('8537','2013-07-23','12:50:00',2.35),('8537','2013-07-23','12:55:00',4.31),('8537','2013-07-23','13:00:00',2.43),('8537','2013-07-23','13:05:00',1.21),('8537','2013-07-23','13:10:00',2.18),('8537','2013-07-23','13:15:00',2.49),('8537','2013-07-23','13:25:00',1.1),('8537','2013-07-23','13:30:00',3.12),('8537','2013-07-23','13:35:00',5.15),('8537','2013-07-23','13:40:00',4.03),('8537','2013-07-23','13:45:00',1.43),('8537','2013-07-23','13:50:00',3.3),('8537','2013-07-23','13:55:00',3.03),('8537','2013-07-23','14:00:00',5),('8537','2013-07-23','14:05:00',2.94),('8537','2013-07-23','14:35:00',1.52),('8537','2013-07-23','14:40:00',3.46),('8537','2013-07-23','14:45:00',4.29),('8537','2013-07-23','14:50:00',3.84),('8537','2013-07-23','14:55:00',4.11),('8537','2013-07-23','15:00:00',4.65),('8537','2013-07-23','15:05:00',4.88),('8537','2013-07-23','15:10:00',3.9),('8537','2013-07-23','15:15:00',3.97),('8537','2013-07-23','15:20:00',4.26),('8537','2013-07-23','15:25:00',4.15),('8537','2013-07-23','15:30:00',4.04),('8537','2013-07-23','15:35:00',3.99),('8537','2013-07-23','15:40:00',3.95),('8537','2013-07-23','15:45:00',3.78),('8537','2013-07-23','15:50:00',3.82),('8537','2013-07-23','15:55:00',3.79),('8537','2013-07-23','16:00:00',3.71),('8537','2013-07-23','16:05:00',3.58),('8537','2013-07-23','16:10:00',3.51),('8537','2013-07-23','16:15:00',3.43),('8537','2013-07-23','16:20:00',3.43),('8537','2013-07-23','16:25:00',3.32),('8537','2013-07-23','16:30:00',3.26),('8537','2013-07-23','16:35:00',3.12),('8537','2013-07-23','16:40:00',3.08),('8537','2013-07-23','16:45:00',2.98),('8537','2013-07-23','16:50:00',2.92),('8537','2013-07-23','16:55:00',2.85),('8537','2013-07-23','17:00:00',2.76),('8537','2013-07-23','17:05:00',2.59),('8537','2013-07-23','17:10:00',2.47),('8537','2013-07-23','17:15:00',2.51),('8537','2013-07-23','17:20:00',2.43),('8537','2013-07-23','17:25:00',2.35),('8537','2013-07-23','17:30:00',2.19),('8537','2013-07-23','17:35:00',2.13),('8537','2013-07-23','17:40:00',2.04),('8537','2013-07-23','17:45:00',1.96),('8537','2013-07-23','17:50:00',1.78),('8537','2013-07-23','17:55:00',1.73),('8537','2013-07-23','18:00:00',1.62),('8537','2013-07-23','18:05:00',1.54),('8537','2013-07-23','18:10:00',1.45),('8537','2013-07-23','18:15:00',1.37),('8537','2013-07-23','18:20:00',1.27),('8537','2013-07-23','18:25:00',1.16),('8537','2013-07-23','18:30:00',1.07),('8537','2013-07-22','07:45:00',1.08),('8537','2013-07-22','07:50:00',1.17),('8537','2013-07-22','07:55:00',1.27),('8537','2013-07-22','08:00:00',1.37),('8537','2013-07-22','08:05:00',1.46),('8537','2013-07-22','08:10:00',1.56),('8537','2013-07-22','08:15:00',1.67),('8537','2013-07-22','08:20:00',1.77),('8537','2013-07-22','08:25:00',1.87),('8537','2013-07-22','08:30:00',1.97),('8537','2013-07-22','08:35:00',2.07),('8537','2013-07-22','08:40:00',2.18),('8537','2013-07-22','08:45:00',2.28),('8537','2013-07-22','08:50:00',2.37),('8537','2013-07-22','08:55:00',2.47),('8537','2013-07-22','09:00:00',2.56),('8537','2013-07-22','09:05:00',2.65),('8537','2013-07-22','09:10:00',2.74),('8537','2013-07-22','09:15:00',2.82),('8537','2013-07-22','09:20:00',2.91),('8537','2013-07-22','09:25:00',2.99),('8537','2013-07-22','09:30:00',3.06),('8537','2013-07-22','09:35:00',3.14),('8537','2013-07-22','09:40:00',3.19),('8537','2013-07-22','09:45:00',3.3),('8537','2013-07-22','09:50:00',3.32),('8537','2013-07-22','09:55:00',3.47),('8537','2013-07-22','10:00:00',3.53),('8537','2013-07-22','10:05:00',3.6),('8537','2013-07-22','10:10:00',3.66),('8537','2013-07-22','10:15:00',3.73),('8537','2013-07-22','10:20:00',3.8),('8537','2013-07-22','10:25:00',3.85),('8537','2013-07-22','10:30:00',3.93),('8537','2013-07-22','10:35:00',3.97),('8537','2013-07-22','10:40:00',4.03),('8537','2013-07-22','10:45:00',4.08),('8537','2013-07-22','10:50:00',4.13),('8537','2013-07-22','10:55:00',4.19),('8537','2013-07-22','11:00:00',4.21),('8537','2013-07-22','11:05:00',4.25),('8537','2013-07-22','11:10:00',4.3),('8537','2013-07-22','11:15:00',4.3),('8537','2013-07-22','11:20:00',4.3),('8537','2013-07-22','11:25:00',4.37),('8537','2013-07-22','11:30:00',4.42),('8537','2013-07-22','11:35:00',4.45),('8537','2013-07-22','11:40:00',4.49),('8537','2013-07-22','11:45:00',4.48),('8537','2013-07-22','11:50:00',4.51),('8537','2013-07-22','11:55:00',4.54),('8537','2013-07-22','12:00:00',4.54),('8537','2013-07-22','12:05:00',4.6),('8537','2013-07-22','12:10:00',4.64),('8537','2013-07-22','12:15:00',4.7),('8537','2013-07-22','12:20:00',4.69),('8537','2013-07-22','12:25:00',4.68),('8537','2013-07-22','12:30:00',4.82),('8537','2013-07-22','12:35:00',4.82),('8537','2013-07-22','12:40:00',4.78),('8537','2013-07-22','12:45:00',4.74),('8537','2013-07-22','12:50:00',4.66),('8537','2013-07-22','12:55:00',4.76),('8537','2013-07-22','13:00:00',4.81),('8537','2013-07-22','13:05:00',4.89),('8537','2013-07-22','13:10:00',4.83),('8537','2013-07-22','13:15:00',4.74),('8537','2013-07-22','13:20:00',4.78),('8537','2013-07-22','13:25:00',4.81),('8537','2013-07-22','13:30:00',4.77),('8537','2013-07-22','13:35:00',4.72),('8537','2013-07-22','13:40:00',4.84),('8537','2013-07-22','13:45:00',4.78),('8537','2013-07-22','13:50:00',4.79),('8537','2013-07-22','13:55:00',4.7),('8537','2013-07-22','14:00:00',4.63),('8537','2013-07-22','14:05:00',4.68),('8537','2013-07-22','14:10:00',4.63),('8537','2013-07-22','14:15:00',4.64),('8537','2013-07-22','14:20:00',4.6),('8537','2013-07-22','14:25:00',4.55),('8537','2013-07-22','14:30:00',4.59),('8537','2013-07-22','14:35:00',4.56),('8537','2013-07-22','14:40:00',4.55),('8537','2013-07-22','14:45:00',4.47),('8537','2013-07-22','14:50:00',4.22),('8537','2013-07-22','14:55:00',4.21),('8537','2013-07-22','15:00:00',3.42),('8537','2013-07-22','15:05:00',4.37),('8537','2013-07-22','15:10:00',4.31),('8537','2013-07-22','15:15:00',4.22),('8537','2013-07-22','15:20:00',4.15),('8537','2013-07-22','15:25:00',4.18),('8537','2013-07-22','15:30:00',1.25),('8537','2013-07-22','15:40:00',1.32),('8537','2013-07-22','15:45:00',3.97),('8537','2013-07-22','15:50:00',3.75),('8537','2013-07-22','15:55:00',4.04),('8537','2013-07-22','16:00:00',3.83),('8537','2013-07-22','16:05:00',2.79),('8537','2013-07-22','16:10:00',1.92),('8537','2013-07-22','16:15:00',3.01),('8537','2013-07-22','16:20:00',3.48),('8537','2013-07-22','16:25:00',3.66),('8537','2013-07-22','16:30:00',3.35),('8537','2013-07-22','16:35:00',2.94),('8537','2013-07-22','16:40:00',2.93),('8537','2013-07-22','16:45:00',2.98),('8537','2013-07-22','16:50:00',2.88),('8537','2013-07-22','16:55:00',2.83),('8537','2013-07-22','17:00:00',2.75),('8537','2013-07-22','17:05:00',2.64),('8537','2013-07-22','17:10:00',2.48),('8537','2013-07-22','17:15:00',2.5),('8537','2013-07-22','17:20:00',2.39),('8537','2013-07-22','17:25:00',2.21),('8537','2013-07-22','17:30:00',2.08),('8537','2013-07-22','17:35:00',2.03),('8537','2013-07-22','17:40:00',1.98),('8537','2013-07-22','17:45:00',1.76),('8537','2013-07-22','17:50:00',1.67),('8537','2013-07-22','17:55:00',1.64),('8537','2013-07-22','18:00:00',1.57),('8537','2013-07-22','18:05:00',1.47),('8537','2013-07-22','18:10:00',1.35),('8537','2013-07-22','18:15:00',1.23),('8537','2013-07-22','18:20:00',1.16),('8537','2013-07-22','18:25:00',1.07),('8537','2013-07-22','18:30:00',1.01),('8537','2013-07-21','07:45:00',1.08),('8537','2013-07-21','07:50:00',1.13),('8537','2013-07-21','07:55:00',1.18),('8537','2013-07-21','08:00:00',1.28),('8537','2013-07-21','08:05:00',1.35),('8537','2013-07-21','08:10:00',1.48),('8537','2013-07-21','08:15:00',1.57),('8537','2013-07-21','08:20:00',1.62),('8537','2013-07-21','08:25:00',1.77),('8537','2013-07-21','08:30:00',1.88),('8537','2013-07-21','08:35:00',1.97),('8537','2013-07-21','08:40:00',2.04),('8537','2013-07-21','08:45:00',2.13),('8537','2013-07-21','08:50:00',2.21),('8537','2013-07-21','08:55:00',2.33),('8537','2013-07-21','09:00:00',2.43),('8537','2013-07-21','09:05:00',2.52),('8537','2013-07-21','09:10:00',2.61),('8537','2013-07-21','09:15:00',2.71),('8537','2013-07-21','09:20:00',2.79),('8537','2013-07-21','09:25:00',2.86),('8537','2013-07-21','09:30:00',2.94),('8537','2013-07-21','09:35:00',2.99),('8537','2013-07-21','09:40:00',3.11),('8537','2013-07-21','09:45:00',3.18),('8537','2013-07-21','09:50:00',3.25),('8537','2013-07-21','09:55:00',3.32),('8537','2013-07-21','10:00:00',3.41),('8537','2013-07-21','10:05:00',3.47),('8537','2013-07-21','10:10:00',3.53),('8537','2013-07-21','10:15:00',3.58),('8537','2013-07-21','10:20:00',3.66),('8537','2013-07-21','10:25:00',3.71),('8537','2013-07-21','10:30:00',3.74),('8537','2013-07-21','10:35:00',3.79),('8537','2013-07-21','10:40:00',3.86),('8537','2013-07-21','10:45:00',3.97),('8537','2013-07-21','10:50:00',4),('8537','2013-07-21','10:55:00',4.1),('8537','2013-07-21','11:00:00',4.14),('8537','2013-07-21','11:05:00',4.14),('8537','2013-07-21','11:10:00',4.16),('8537','2013-07-21','11:15:00',4.2),('8537','2013-07-21','11:20:00',4.31),('8537','2013-07-21','11:25:00',4.32),('8537','2013-07-21','11:30:00',4.36),('8537','2013-07-21','11:35:00',4.42),('8537','2013-07-21','11:40:00',4.63),('8537','2013-07-21','11:45:00',4.54),('8537','2013-07-21','11:50:00',4.59),('8537','2013-07-21','11:55:00',4.59),('8537','2013-07-21','12:00:00',4.57),('8537','2013-07-21','12:05:00',4.66),('8537','2013-07-21','12:10:00',4.57),('8537','2013-07-21','12:15:00',4.86),('8537','2013-07-21','12:20:00',5.05),('8537','2013-07-21','12:25:00',5.06),('8537','2013-07-21','12:30:00',5.18),('8537','2013-07-21','12:35:00',5.46),('8537','2013-07-21','12:40:00',5.41),('8537','2013-07-21','12:45:00',4.85),('8537','2013-07-21','12:50:00',4.69),('8537','2013-07-21','12:55:00',5.6),('8537','2013-07-21','13:00:00',5.15),('8537','2013-07-21','13:05:00',5.41),('8537','2013-07-21','13:10:00',5.23),('8537','2013-07-21','13:15:00',4.45),('8537','2013-07-21','13:20:00',4.42),('8537','2013-07-21','13:25:00',5.23),('8537','2013-07-21','13:30:00',5.01),('8537','2013-07-21','13:35:00',4.67),('8537','2013-07-21','13:40:00',4.77),('8537','2013-07-21','13:45:00',1.96),('8537','2013-07-21','13:50:00',1.18),('8537','2013-07-21','14:05:00',1.06),('8537','2013-07-21','14:20:00',1.29),('8537','2013-07-21','14:25:00',1.41),('8537','2013-07-21','14:30:00',1.32),('8537','2013-07-21','14:35:00',1.46),('8537','2013-07-21','14:40:00',1.46),('8537','2013-07-21','14:45:00',2.79),('8537','2013-07-21','14:50:00',4.77),('8537','2013-07-21','14:55:00',1.89),('8537','2013-07-21','15:00:00',2.23),('8537','2013-07-21','15:05:00',1.8),('8537','2013-07-21','15:10:00',1.76),('8537','2013-07-21','15:15:00',3.04),('8537','2013-07-21','15:20:00',4.03),('8537','2013-07-21','15:25:00',1.88),('8537','2013-07-21','15:30:00',1.64),('8537','2013-07-21','15:35:00',1.86),('8537','2013-07-21','15:40:00',3.27),('8537','2013-07-21','15:45:00',2.79),('8537','2013-07-21','15:50:00',3.13),('8537','2013-07-21','15:55:00',2.21),('8537','2013-07-21','16:00:00',1.55),('8537','2013-07-21','16:05:00',1.24),('8537','2013-07-21','16:10:00',1.05),('8537','2013-07-21','16:40:00',1.02),('8537','2013-07-21','16:45:00',1.02),('8537','2013-07-21','16:50:00',1.06),('8537','2013-07-21','16:55:00',1.18),('8537','2013-07-21','17:00:00',1.31),('8537','2013-07-21','17:05:00',1.41),('8537','2013-07-21','17:10:00',1.39),('8537','2013-07-21','17:15:00',1.23),('8537','2013-07-21','17:20:00',1.13),('8537','2013-07-21','17:25:00',1.03),('8537','2014-04-07','08:20:00',1.22),('8537','2014-04-07','08:25:00',1.21),('8537','2014-04-07','08:30:00',1.33),('8537','2014-04-07','08:35:00',1.85),('8537','2014-04-07','08:40:00',1.96),('8537','2014-04-07','08:45:00',2.03),('8537','2014-04-07','08:50:00',1.71),('8537','2014-04-07','08:55:00',1.44),('8537','2014-04-07','09:00:00',1.38),('8537','2014-04-07','09:05:00',1.44),('8537','2014-04-07','09:10:00',1.62),('8537','2014-04-07','09:15:00',1.81),('8537','2014-04-07','09:20:00',1.63),('8537','2014-04-07','09:25:00',1.5),('8537','2014-04-07','09:30:00',1.49),('8537','2014-04-07','09:35:00',1.35),('8537','2014-04-07','09:40:00',1.38),('8537','2014-04-07','09:45:00',1.45),('8537','2014-04-07','09:50:00',1.52),('8537','2014-04-07','09:55:00',1.72),('8537','2014-04-07','10:00:00',1.63),('8537','2014-04-07','10:05:00',1.61),('8537','2014-04-07','10:10:00',1.72),('8537','2014-04-07','10:15:00',1.55),('8537','2014-04-07','10:20:00',1.53),('8537','2014-04-07','10:25:00',1.57),('8537','2014-04-07','10:30:00',1.62),('8537','2014-04-07','10:35:00',1.74),('8537','2014-04-07','10:40:00',1.78),('8537','2014-04-07','10:45:00',1.84),('8537','2014-04-07','10:50:00',1.89),('8537','2014-04-07','10:55:00',2.02),('8537','2014-04-07','11:00:00',2.14),('8537','2014-04-07','11:05:00',2.27),('8537','2014-04-07','11:10:00',2.59),('8537','2014-04-07','11:15:00',2.89),('8537','2014-04-07','11:20:00',2.59),('8537','2014-04-07','11:25:00',2.42),('8537','2014-04-07','11:30:00',2.46),('8537','2014-04-07','11:35:00',2.42),('8537','2014-04-07','11:40:00',2.31),('8537','2014-04-07','11:45:00',2.18),('8537','2014-04-07','11:50:00',2.11),('8537','2014-04-07','11:55:00',2.08),('8537','2014-04-07','12:00:00',2.31),('8537','2014-04-07','12:05:00',2.87),('8537','2014-04-07','12:10:00',3.24),('8537','2014-04-07','12:15:00',4.29),('8537','2014-04-07','12:20:00',5.12),('8537','2014-04-07','12:25:00',4.86),('8537','2014-04-07','12:30:00',3.14),('8537','2014-04-07','12:35:00',2.82),('8537','2014-04-07','12:40:00',3.46),('8537','2014-04-07','12:45:00',4.82),('8537','2014-04-07','12:50:00',4.88),('8537','2014-04-07','12:55:00',4.83),('8537','2014-04-07','13:00:00',4.89),('8537','2014-04-07','13:05:00',4.84),('8537','2014-04-07','13:10:00',4.8),('8537','2014-04-07','13:15:00',4.78),('8537','2014-04-07','13:20:00',4.81),('8537','2014-04-07','13:25:00',4.86),('8537','2014-04-07','13:30:00',4.8),('8537','2014-04-07','13:35:00',4.77),('8537','2014-04-07','13:40:00',4.72),('8537','2014-04-07','13:45:00',4.75),('8537','2014-04-07','13:50:00',4.74),('8537','2014-04-07','13:55:00',4.71),('8537','2014-04-07','14:00:00',4.7),('8537','2014-04-07','14:05:00',4.64),('8537','2014-04-07','14:10:00',4.58),('8537','2014-04-07','14:15:00',4.56),('8537','2014-04-07','14:20:00',4.57),('8537','2014-04-07','14:25:00',4.74),('8537','2014-04-07','14:30:00',4.67),('8537','2014-04-07','14:35:00',4.39),('8537','2014-04-07','14:40:00',4.08),('8537','2014-04-07','14:45:00',4.3),('8537','2014-04-07','14:50:00',4.37),('8537','2014-04-07','14:55:00',3.94),('8537','2014-04-07','15:00:00',3.56),('8537','2014-04-07','15:05:00',4.44),('8537','2014-04-07','15:10:00',3.97),('8537','2014-04-07','15:15:00',3.24),('8537','2014-04-07','15:20:00',4.58),('8537','2014-04-07','15:25:00',4.33),('8537','2014-04-07','15:30:00',4.03),('8537','2014-04-07','15:35:00',4.08),('8537','2014-04-07','15:40:00',3.97),('8537','2014-04-07','15:45:00',4.06),('8537','2014-04-07','15:50:00',4.24),('8537','2014-04-07','15:55:00',4.07),('8537','2014-04-07','16:00:00',2.5),('8537','2014-04-07','16:05:00',1.99),('8537','2014-04-07','16:10:00',3.6),('8537','2014-04-07','16:15:00',3.29),('8537','2014-04-07','16:20:00',3.05),('8537','2014-04-07','16:25:00',2.98),('8537','2014-04-07','16:30:00',2.84),('8537','2014-04-07','16:35:00',2.29),('8537','2014-04-07','16:40:00',1.25),('8537','2014-04-07','16:45:00',2.36),('8537','2014-04-07','16:50:00',2.16),('8537','2014-04-07','16:55:00',2.21),('8537','2014-04-07','17:00:00',2.61),('8537','2014-04-07','17:05:00',2.27),('8537','2014-04-07','17:10:00',1.38),('8537','2014-04-07','17:15:00',1.9),('8537','2013-07-20','07:40:00',1),('8537','2013-07-20','07:45:00',1.09),('8537','2013-07-20','07:50:00',1.16),('8537','2013-07-20','07:55:00',1.27),('8537','2013-07-20','08:00:00',1.36),('8537','2013-07-20','08:05:00',1.46),('8537','2013-07-20','08:10:00',1.55),('8537','2013-07-20','08:15:00',1.66),('8537','2013-07-20','08:20:00',1.76),('8537','2013-07-20','08:25:00',1.87),('8537','2013-07-20','08:30:00',1.96),('8537','2013-07-20','08:35:00',2.06),('8537','2013-07-20','08:40:00',2.17),('8537','2013-07-20','08:45:00',2.29),('8537','2013-07-20','08:50:00',2.37),('8537','2013-07-20','08:55:00',2.49),('8537','2013-07-20','09:00:00',2.6),('8537','2013-07-20','09:05:00',2.7),('8537','2013-07-20','09:10:00',2.85),('8537','2013-07-20','09:15:00',2.96),('8537','2013-07-20','09:20:00',3.02),('8537','2013-07-20','09:25:00',2.96),('8537','2013-07-20','09:30:00',2.98),('8537','2013-07-20','09:35:00',3),('8537','2013-07-20','09:40:00',3.01),('8537','2013-07-20','09:45:00',3.3),('8537','2013-07-20','09:50:00',3.25),('8537','2013-07-20','09:55:00',3.32),('8537','2013-07-20','10:00:00',3.48),('8537','2013-07-20','10:05:00',3.49),('8537','2013-07-20','10:10:00',3.61),('8537','2013-07-20','10:15:00',3.66),('8537','2013-07-20','10:20:00',3.76),('8537','2013-07-20','10:25:00',3.81),('8537','2013-07-20','10:30:00',3.87),('8537','2013-07-20','10:35:00',3.89),('8537','2013-07-20','10:40:00',3.97),('8537','2013-07-20','10:45:00',4.07),('8537','2013-07-20','10:50:00',4.08),('8537','2013-07-20','10:55:00',4.16),('8537','2013-07-20','11:00:00',4.2),('8537','2013-07-20','11:05:00',4.19),('8537','2013-07-20','11:10:00',4.23),('8537','2013-07-20','11:15:00',4.29),('8537','2013-07-20','11:20:00',4.33),('8537','2013-07-20','11:25:00',4.36),('8537','2013-07-20','11:30:00',4.39),('8537','2013-07-20','11:35:00',4.46),('8537','2013-07-20','11:40:00',4.48),('8537','2013-07-20','11:45:00',4.5),('8537','2013-07-20','11:50:00',4.59),('8537','2013-07-20','11:55:00',4.62),('8537','2013-07-20','12:00:00',4.68),('8537','2013-07-20','12:05:00',4.73),('8537','2013-07-20','12:10:00',4.79),('8537','2013-07-20','12:15:00',4.71),('8537','2013-07-20','12:20:00',3.95),('8537','2013-07-20','12:25:00',2.59),('8537','2013-07-20','12:30:00',4.8),('8537','2013-07-20','12:35:00',4.71),('8537','2013-07-20','12:40:00',4.82),('8537','2013-07-20','12:45:00',4.86),('8537','2013-07-20','12:50:00',4.87),('8537','2013-07-20','12:55:00',4.91),('8537','2013-07-20','13:00:00',5.04),('8537','2013-07-20','13:05:00',4.99),('8537','2013-07-20','13:10:00',4.88),('8537','2013-07-20','13:15:00',3.86),('8537','2013-07-20','13:20:00',1.31),('8537','2013-07-20','13:25:00',2.89),('8537','2013-07-20','13:30:00',5.19),('8537','2013-07-20','13:35:00',5.05),('8537','2013-07-20','13:40:00',5.11),('8537','2013-07-20','13:45:00',5.03),('8537','2013-07-20','13:50:00',2.44),('8537','2013-07-20','13:55:00',1.03),('8537','2013-07-20','14:00:00',2.61),('8537','2013-07-20','14:05:00',5.17),('8537','2013-07-20','14:10:00',3.59),('8537','2013-07-20','14:15:00',2.58),('8537','2013-07-20','14:20:00',3.92),('8537','2013-07-20','14:25:00',4.97),('8537','2013-07-20','14:30:00',4.8),('8537','2013-07-20','14:35:00',4.89),('8537','2013-07-20','14:40:00',4.74),('8537','2013-07-20','14:45:00',2.11),('8537','2013-07-20','14:50:00',3.42),('8537','2013-07-20','14:55:00',1.46),('8537','2013-07-20','15:00:00',2.77),('8537','2013-07-20','15:05:00',4.65),('8537','2013-07-20','15:10:00',4.5),('8537','2013-07-20','15:15:00',4.34),('8537','2013-07-20','15:20:00',4.22),('8537','2013-07-20','15:25:00',4.14),('8537','2013-07-20','15:30:00',4.1),('8537','2013-07-20','15:35:00',4.02),('8537','2013-07-20','15:40:00',3.86),('8537','2013-07-20','15:45:00',3.72),('8537','2013-07-20','15:50:00',3.63),('8537','2013-07-20','15:55:00',3.77),('8537','2013-07-20','16:00:00',3.69),('8537','2013-07-20','16:05:00',3.61),('8537','2013-07-20','16:10:00',3.56),('8537','2013-07-20','16:15:00',3.51),('8537','2013-07-20','16:20:00',3.46),('8537','2013-07-20','16:25:00',3.38),('8537','2013-07-20','16:30:00',3.19),('8537','2013-07-20','16:35:00',2.83),('8537','2013-07-20','16:40:00',3.09),('8537','2013-07-20','16:45:00',2.98),('8537','2013-07-20','16:50:00',2.91),('8537','2013-07-20','16:55:00',2.81),('8537','2013-07-20','17:00:00',2.73),('8537','2013-07-20','17:05:00',2.65),('8537','2013-07-20','17:10:00',2.54),('8537','2013-07-20','17:15:00',2.48),('8537','2013-07-20','17:20:00',2.39),('8537','2013-07-20','17:25:00',2.29),('8537','2013-07-20','17:30:00',2.13),('8537','2013-07-20','17:35:00',2.09),('8537','2013-07-20','17:40:00',2.01),('8537','2013-07-20','17:45:00',1.92),('8537','2013-07-20','17:50:00',1.76),('8537','2013-07-20','17:55:00',1.69),('8537','2013-07-20','18:00:00',1.58),('8537','2013-07-20','18:05:00',1.49),('8537','2013-07-20','18:10:00',1.4),('8537','2013-07-20','18:15:00',1.31),('8537','2013-07-20','18:20:00',1.22),('8537','2013-07-20','18:25:00',1.13),('8537','2013-07-20','18:30:00',1.04),('8537','2013-07-19','07:45:00',1.06),('8537','2013-07-19','07:50:00',1.15),('8537','2013-07-19','07:55:00',1.24),('8537','2013-07-19','08:00:00',1.33),('8537','2013-07-19','08:05:00',1.42),('8537','2013-07-19','08:10:00',1.51),('8537','2013-07-19','08:15:00',1.6),('8537','2013-07-19','08:20:00',1.69),('8537','2013-07-19','08:25:00',1.78),('8537','2013-07-19','08:30:00',1.87),('8537','2013-07-19','08:35:00',1.98),('8537','2013-07-19','08:40:00',2.09),('8537','2013-07-19','08:45:00',2.19),('8537','2013-07-19','08:50:00',2.29),('8537','2013-07-19','08:55:00',2.38),('8537','2013-07-19','09:00:00',2.44),('8537','2013-07-19','09:05:00',2.52),('8537','2013-07-19','09:10:00',2.62),('8537','2013-07-19','09:15:00',2.7),('8537','2013-07-19','09:20:00',2.79),('8537','2013-07-19','09:25:00',2.85),('8537','2013-07-19','09:30:00',2.91),('8537','2013-07-19','09:35:00',2.99),('8537','2013-07-19','09:40:00',3.08),('8537','2013-07-19','09:45:00',3.12),('8537','2013-07-19','09:50:00',3.19),('8537','2013-07-19','09:55:00',3.25),('8537','2013-07-19','10:00:00',3.36),('8537','2013-07-19','10:05:00',3.38),('8537','2013-07-19','10:10:00',3.44),('8537','2013-07-19','10:15:00',3.5),('8537','2013-07-19','10:20:00',3.53),('8537','2013-07-19','10:25:00',3.63),('8537','2013-07-19','10:30:00',3.65),('8537','2013-07-19','10:35:00',3.75),('8537','2013-07-19','10:40:00',3.73),('8537','2013-07-19','10:45:00',3.84),('8537','2013-07-19','10:50:00',3.84),('8537','2013-07-19','10:55:00',3.99),('8537','2013-07-19','11:00:00',4),('8537','2013-07-19','11:05:00',4.03),('8537','2013-07-19','11:10:00',4.03),('8537','2013-07-19','11:15:00',4.05),('8537','2013-07-19','11:20:00',4.15),('8537','2013-07-19','11:25:00',4.2),('8537','2013-07-19','11:30:00',4.18),('8537','2013-07-19','11:35:00',4.16),('8537','2013-07-19','11:40:00',4.22),('8537','2013-07-19','11:45:00',4.37),('8537','2013-07-19','11:50:00',4.3),('8537','2013-07-19','11:55:00',4.4),('8537','2013-07-19','12:00:00',3.31),('8537','2013-07-19','12:05:00',2.35),('8537','2013-07-19','12:10:00',4.52),('8537','2013-07-19','12:15:00',4.61),('8537','2013-07-19','12:20:00',4.62),('8537','2013-07-19','12:25:00',4.61),('8537','2013-07-19','12:30:00',4.58),('8537','2013-07-19','12:35:00',4.58),('8537','2013-07-19','12:40:00',4.36),('8537','2013-07-19','12:45:00',4.5),('8537','2013-07-19','12:50:00',4.65),('8537','2013-07-19','12:55:00',4.7),('8537','2013-07-19','13:00:00',3.65),('8537','2013-07-19','13:05:00',4.38),('8537','2013-07-19','13:10:00',4.9),('8537','2013-07-19','13:15:00',2.44),('8537','2013-07-19','13:20:00',1.8),('8537','2013-07-19','13:25:00',4.24),('8537','2013-07-19','13:30:00',5.12),('8537','2013-07-19','13:35:00',4.98),('8537','2013-07-19','13:40:00',4.91),('8537','2013-07-19','13:45:00',4.94),('8537','2013-07-19','13:50:00',4.94),('8537','2013-07-19','13:55:00',4.98),('8537','2013-07-19','14:00:00',5),('8537','2013-07-19','14:05:00',4.88),('8537','2013-07-19','14:10:00',3.46),('8537','2013-07-19','14:15:00',4.21),('8537','2013-07-19','14:20:00',4.8),('8537','2013-07-19','14:25:00',4.54),('8537','2013-07-19','14:30:00',4.9),('8537','2013-07-19','14:35:00',4.92),('8537','2013-07-19','14:40:00',4.35),('8537','2013-07-19','14:45:00',4.59),('8537','2013-07-19','14:50:00',4.32),('8537','2013-07-19','14:55:00',4.58),('8537','2013-07-19','15:00:00',4.48),('8537','2013-07-19','15:05:00',4.45),('8537','2013-07-19','15:10:00',4.45),('8537','2013-07-19','15:15:00',2.5),('8537','2013-07-19','15:20:00',3.67),('8537','2013-07-19','15:25:00',3.26),('8537','2013-07-19','15:30:00',4.39),('8537','2013-07-19','15:35:00',4.26),('8537','2013-07-19','15:40:00',4.19),('8537','2013-07-19','15:45:00',4.02),('8537','2013-07-19','15:50:00',3.87),('8537','2013-07-19','15:55:00',3.88),('8537','2013-07-19','16:00:00',3.82),('8537','2013-07-19','16:05:00',3.76),('8537','2013-07-19','16:10:00',3.74),('8537','2013-07-19','16:15:00',3.66),('8537','2013-07-19','16:20:00',3.6),('8537','2013-07-19','16:25:00',3.52),('8537','2013-07-19','16:30:00',3.38),('8537','2013-07-19','16:35:00',3.03),('8537','2013-07-19','16:40:00',3.28),('8537','2013-07-19','16:45:00',3.22),('8537','2013-07-19','16:50:00',3.16),('8537','2013-07-19','16:55:00',3.18),('8537','2013-07-19','17:00:00',2.44),('8537','2013-07-19','17:05:00',2.18),('8537','2013-07-19','17:10:00',2.77),('8537','2013-07-19','17:15:00',2.35),('8537','2013-07-19','17:20:00',2.04),('8537','2013-07-19','17:25:00',1.8),('8537','2013-07-19','17:30:00',1.99),('8537','2013-07-19','17:35:00',2.08),('8537','2013-07-19','17:40:00',1.76),('8537','2013-07-19','17:45:00',1.43),('8537','2013-07-19','17:50:00',1.08),('8537','2013-07-18','07:40:00',1.03),('8537','2013-07-18','07:45:00',1.13),('8537','2013-07-18','07:50:00',1.23),('8537','2013-07-18','07:55:00',1.33),('8537','2013-07-18','08:00:00',1.42),('8537','2013-07-18','08:05:00',1.52),('8537','2013-07-18','08:10:00',1.62),('8537','2013-07-18','08:15:00',1.72),('8537','2013-07-18','08:20:00',1.81),('8537','2013-07-18','08:25:00',1.91),('8537','2013-07-18','08:30:00',2.01),('8537','2013-07-18','08:35:00',2.1),('8537','2013-07-18','08:40:00',2.2),('8537','2013-07-18','08:45:00',2.26),('8537','2013-07-18','08:50:00',2.38),('8537','2013-07-18','08:55:00',2.48),('8537','2013-07-18','09:00:00',2.58),('8537','2013-07-18','09:05:00',2.66),('8537','2013-07-18','09:10:00',2.74),('8537','2013-07-18','09:15:00',2.81),('8537','2013-07-18','09:20:00',2.9),('8537','2013-07-18','09:25:00',2.98),('8537','2013-07-18','09:30:00',3.06),('8537','2013-07-18','09:35:00',3.15),('8537','2013-07-18','09:40:00',3.21),('8537','2013-07-18','09:45:00',3.28),('8537','2013-07-18','09:50:00',3.37),('8537','2013-07-18','09:55:00',3.44),('8537','2013-07-18','10:00:00',3.51),('8537','2013-07-18','10:05:00',3.58),('8537','2013-07-18','10:10:00',3.67),('8537','2013-07-18','10:15:00',3.68),('8537','2013-07-18','10:20:00',3.74),('8537','2013-07-18','10:25:00',3.77),('8537','2013-07-18','10:30:00',3.85),('8537','2013-07-18','10:35:00',3.93),('8537','2013-07-18','10:40:00',3.99),('8537','2013-07-18','10:45:00',4.02),('8537','2013-07-18','10:50:00',4.08),('8537','2013-07-18','10:55:00',4.12),('8537','2013-07-18','11:00:00',4.15),('8537','2013-07-18','11:05:00',4.16),('8537','2013-07-18','11:10:00',4.2),('8537','2013-07-18','11:15:00',4.27),('8537','2013-07-18','11:20:00',4.39),('8537','2013-07-18','11:25:00',4.42),('8537','2013-07-18','11:30:00',4.45),('8537','2013-07-18','11:35:00',4.46),('8537','2013-07-18','11:40:00',4.45),('8537','2013-07-18','11:45:00',4.48),('8537','2013-07-18','11:50:00',4.49),('8537','2013-07-18','11:55:00',4.59),('8537','2013-07-18','12:00:00',4.62),('8537','2013-07-18','12:05:00',4.55),('8537','2013-07-18','12:10:00',4.53),('8537','2013-07-18','12:15:00',4.53),('8537','2013-07-18','12:20:00',4.65),('8537','2013-07-18','12:25:00',3.97),('8537','2013-07-18','12:30:00',2.48),('8537','2013-07-18','12:35:00',4.79),('8537','2013-07-18','12:40:00',5.04),('8537','2013-07-18','12:45:00',3.23),('8537','2013-07-18','12:50:00',4.2),('8537','2013-07-18','12:55:00',3.87),('8537','2013-07-18','13:00:00',4.86),('8537','2013-07-18','13:05:00',4.86),('8537','2013-07-18','13:10:00',4.91),('8537','2013-07-18','13:15:00',4.79),('8537','2013-07-18','13:20:00',4.45),('8537','2013-07-18','13:25:00',4.58),('8537','2013-07-18','13:30:00',4.6),('8537','2013-07-18','13:35:00',4.5),('8537','2013-07-18','13:40:00',5),('8537','2013-07-18','13:45:00',4.98),('8537','2013-07-18','13:50:00',4.82),('8537','2013-07-18','13:55:00',4.73),('8537','2013-07-18','14:00:00',4.64),('8537','2013-07-18','14:05:00',4.68),('8537','2013-07-18','14:10:00',4.64),('8537','2013-07-18','14:15:00',4.67),('8537','2013-07-18','14:20:00',4.68),('8537','2013-07-18','14:25:00',4.63),('8537','2013-07-18','14:30:00',4.54),('8537','2013-07-18','14:35:00',4.61),('8537','2013-07-18','14:40:00',4.59),('8537','2013-07-18','14:45:00',4.5),('8537','2013-07-18','14:50:00',4.28),('8537','2013-07-18','14:55:00',4.3),('8537','2013-07-18','15:00:00',4.31),('8537','2013-07-18','15:05:00',4.3),('8537','2013-07-18','15:10:00',4.27),('8537','2013-07-18','15:15:00',4.16),('8537','2013-07-18','15:20:00',4.17),('8537','2013-07-18','15:25:00',4.13),('8537','2013-07-18','15:30:00',4.07),('8537','2013-07-18','15:35:00',4.03),('8537','2013-07-18','15:40:00',3.98),('8537','2013-07-18','15:45:00',3.75),('8537','2013-07-18','15:50:00',3.7),('8537','2013-07-18','15:55:00',3.76),('8537','2013-07-18','16:00:00',3.69),('8537','2013-07-18','16:05:00',3.6),('8537','2013-07-18','16:10:00',3.55),('8537','2013-07-18','16:15:00',3.45),('8537','2013-07-18','16:20:00',3.4),('8537','2013-07-18','16:25:00',3.32),('8537','2013-07-18','16:30:00',3.11),('8537','2013-07-18','16:35:00',2.88),('8537','2013-07-18','16:40:00',3.05),('8537','2013-07-18','16:45:00',2.98),('8537','2013-07-18','16:50:00',2.89),('8537','2013-07-18','16:55:00',2.82),('8537','2013-07-18','17:00:00',2.72),('8537','2013-07-18','17:05:00',2.63),('8537','2013-07-18','17:10:00',2.36),('8537','2013-07-18','17:15:00',1.93),('8537','2013-07-18','17:20:00',1.99),('8537','2013-07-18','17:25:00',2.26),('8537','2013-07-18','17:30:00',2.07),('8537','2013-07-18','17:35:00',1.97),('8537','2013-07-18','17:40:00',1.85),('8537','2013-07-18','17:45:00',1.73),('8537','2013-07-18','17:50:00',1.64),('8537','2013-07-18','17:55:00',1.61),('8537','2013-07-18','18:00:00',1.45),('8537','2013-07-18','18:05:00',1.38),('8537','2013-07-18','18:10:00',1.28),('8537','2013-07-18','18:15:00',1.23),('8537','2013-07-18','18:20:00',1.12),('8537','2013-07-18','18:25:00',1.04),('8537','2013-07-17','07:40:00',1.04),('8537','2013-07-17','07:45:00',1.14),('8537','2013-07-17','07:50:00',1.24),('8537','2013-07-17','07:55:00',1.31),('8537','2013-07-17','08:00:00',1.41),('8537','2013-07-17','08:05:00',1.53),('8537','2013-07-17','08:10:00',1.67),('8537','2013-07-17','08:15:00',1.75),('8537','2013-07-17','08:20:00',1.9),('8537','2013-07-17','08:25:00',1.99),('8537','2013-07-17','08:30:00',2.08),('8537','2013-07-17','08:35:00',2.2),('8537','2013-07-17','08:40:00',2.31),('8537','2013-07-17','08:45:00',2.41),('8537','2013-07-17','08:50:00',2.51),('8537','2013-07-17','08:55:00',2.6),('8537','2013-07-17','09:00:00',2.7),('8537','2013-07-17','09:05:00',2.8),('8537','2013-07-17','09:10:00',2.89),('8537','2013-07-17','09:15:00',2.99),('8537','2013-07-17','09:20:00',3.09),('8537','2013-07-17','09:25:00',3.19),('8537','2013-07-17','09:30:00',3.19),('8537','2013-07-17','09:35:00',3.3),('8537','2013-07-17','09:40:00',3.41),('8537','2013-07-17','09:45:00',3.49),('8537','2013-07-17','09:50:00',3.56),('8537','2013-07-17','09:55:00',3.62),('8537','2013-07-17','10:00:00',3.68),('8537','2013-07-17','10:05:00',3.74),('8537','2013-07-17','10:10:00',3.8),('8537','2013-07-17','10:15:00',3.87),('8537','2013-07-17','10:20:00',3.91),('8537','2013-07-17','10:25:00',3.97),('8537','2013-07-17','10:30:00',4.04),('8537','2013-07-17','10:35:00',4.11),('8537','2013-07-17','10:40:00',4.12),('8537','2013-07-17','10:45:00',4.23),('8537','2013-07-17','10:50:00',4.3),('8537','2013-07-17','10:55:00',4.3),('8537','2013-07-17','11:00:00',4.39),('8537','2013-07-17','11:05:00',4.46),('8537','2013-07-17','11:10:00',4.5),('8537','2013-07-17','11:15:00',4.5),('8537','2013-07-17','11:20:00',4.54),('8537','2013-07-17','11:25:00',4.56),('8537','2013-07-17','11:30:00',4.6),('8537','2013-07-17','11:35:00',4.67),('8537','2013-07-17','11:40:00',4.68),('8537','2013-07-17','11:45:00',4.73),('8537','2013-07-17','11:50:00',4.75),('8537','2013-07-17','11:55:00',4.82),('8537','2013-07-17','12:00:00',4.85),('8537','2013-07-17','12:05:00',4.86),('8537','2013-07-17','12:10:00',4.89),('8537','2013-07-17','12:15:00',4.85),('8537','2013-07-17','12:20:00',4.87),('8537','2013-07-17','12:25:00',4.94),('8537','2013-07-17','12:30:00',4.92),('8537','2013-07-17','12:35:00',4.88),('8537','2013-07-17','12:40:00',4.91),('8537','2013-07-17','12:45:00',4.91),('8537','2013-07-17','12:50:00',4.91),('8537','2013-07-17','12:55:00',4.95),('8537','2013-07-17','13:00:00',4.92),('8537','2013-07-17','13:05:00',4.91),('8537','2013-07-17','13:10:00',4.93),('8537','2013-07-17','13:15:00',4.89),('8537','2013-07-17','13:20:00',4.84),('8537','2013-07-17','13:25:00',4.84),('8537','2013-07-17','13:30:00',4.88),('8537','2013-07-17','13:35:00',4.83),('8537','2013-07-17','13:40:00',4.82),('8537','2013-07-17','13:45:00',4.83),('8537','2013-07-17','13:50:00',4.85),('8537','2013-07-17','13:55:00',4.88),('8537','2013-07-17','14:00:00',4.86),('8537','2013-07-17','14:05:00',4.83),('8537','2013-07-17','14:10:00',4.74),('8537','2013-07-17','14:15:00',4.75),('8537','2013-07-17','14:20:00',4.66),('8537','2013-07-17','14:25:00',4.59),('8537','2013-07-17','14:30:00',4.56),('8537','2013-07-17','14:35:00',4.61),('8537','2013-07-17','14:40:00',4.79),('8537','2013-07-17','14:45:00',4.68),('8537','2013-07-17','14:50:00',4.43),('8537','2013-07-17','14:55:00',4.34),('8537','2013-07-17','15:00:00',4.4),('8537','2013-07-17','15:05:00',4.27),('8537','2013-07-17','15:10:00',2.93),('8537','2013-07-17','15:15:00',4.34),('8537','2013-07-17','15:20:00',4.35),('8537','2013-07-17','15:25:00',4.26),('8537','2013-07-17','15:30:00',4.18),('8537','2013-07-17','15:35:00',4.16),('8537','2013-07-17','15:40:00',3.32),('8537','2013-07-17','15:45:00',3.96),('8537','2013-07-17','15:50:00',3.65),('8537','2013-07-17','15:55:00',3.92),('8537','2013-07-17','16:00:00',3.81),('8537','2013-07-17','16:05:00',3.76),('8537','2013-07-17','16:10:00',3.72),('8537','2013-07-17','16:15:00',3.61),('8537','2013-07-17','16:20:00',3.51),('8537','2013-07-17','16:25:00',3.42),('8537','2013-07-17','16:30:00',3.22),('8537','2013-07-17','16:35:00',2.98),('8537','2013-07-17','16:40:00',3.16),('8537','2013-07-17','16:45:00',3.13),('8537','2013-07-17','16:50:00',2.99),('8537','2013-07-17','16:55:00',2.85),('8537','2013-07-17','17:00:00',2.81),('8537','2013-07-17','17:05:00',2.8),('8537','2013-07-17','17:10:00',2.61),('8537','2013-07-17','17:15:00',2.1),('8537','2013-07-17','17:20:00',2.43),('8537','2013-07-17','17:25:00',2.3),('8537','2013-07-17','17:30:00',2.18),('8537','2013-07-17','17:35:00',2.06),('8537','2013-07-17','17:40:00',1.99),('8537','2013-07-17','17:45:00',1.91),('8537','2013-07-17','17:50:00',1.84),('8537','2013-07-17','17:55:00',1.71),('8537','2013-07-17','18:00:00',1.61),('8537','2013-07-17','18:05:00',1.5),('8537','2013-07-17','18:10:00',1.43),('8537','2013-07-17','18:15:00',1.34),('8537','2013-07-17','18:20:00',1.24),('8537','2013-07-17','18:25:00',1.14),('8537','2013-07-17','18:30:00',1.05),('8537','2013-07-16','07:40:00',1.07),('8537','2013-07-16','07:45:00',1.16),('8537','2013-07-16','07:50:00',1.25),('8537','2013-07-16','07:55:00',1.33),('8537','2013-07-16','08:00:00',1.4),('8537','2013-07-16','08:05:00',1.51),('8537','2013-07-16','08:10:00',1.61),('8537','2013-07-16','08:15:00',1.71),('8537','2013-07-16','08:20:00',1.81),('8537','2013-07-16','08:25:00',1.92),('8537','2013-07-16','08:30:00',2.02),('8537','2013-07-16','08:35:00',2.11),('8537','2013-07-16','08:40:00',2.18),('8537','2013-07-16','08:45:00',2.27),('8537','2013-07-16','08:50:00',2.36),('8537','2013-07-16','08:55:00',2.48),('8537','2013-07-16','09:00:00',2.57),('8537','2013-07-16','09:05:00',2.63),('8537','2013-07-16','09:10:00',2.73),('8537','2013-07-16','09:15:00',2.8),('8537','2013-07-16','09:20:00',2.88),('8537','2013-07-16','09:25:00',2.98),('8537','2013-07-16','09:30:00',3.06),('8537','2013-07-16','09:35:00',3.14),('8537','2013-07-16','09:40:00',3.23),('8537','2013-07-16','09:45:00',3.3),('8537','2013-07-16','09:50:00',3.42),('8537','2013-07-16','09:55:00',3.51),('8537','2013-07-16','10:00:00',3.59),('8537','2013-07-16','10:05:00',3.68),('8537','2013-07-16','10:10:00',3.75),('8537','2013-07-16','10:15:00',3.81),('8537','2013-07-16','10:20:00',3.85),('8537','2013-07-16','10:25:00',3.91),('8537','2013-07-16','10:30:00',3.99),('8537','2013-07-16','10:35:00',4.03),('8537','2013-07-16','10:40:00',4.08),('8537','2013-07-16','10:45:00',4.12),('8537','2013-07-16','10:50:00',4.19),('8537','2013-07-16','10:55:00',4.24),('8537','2013-07-16','11:00:00',4.29),('8537','2013-07-16','11:05:00',4.34),('8537','2013-07-16','11:10:00',4.4),('8537','2013-07-16','11:15:00',4.42),('8537','2013-07-16','11:20:00',4.45),('8537','2013-07-16','11:25:00',4.52),('8537','2013-07-16','11:30:00',4.55),('8537','2013-07-16','11:35:00',4.53),('8537','2013-07-16','11:40:00',4.57),('8537','2013-07-16','11:45:00',4.63),('8537','2013-07-16','11:50:00',4.71),('8537','2013-07-16','11:55:00',4.78),('8537','2013-07-16','12:00:00',4.8),('8537','2013-07-16','12:05:00',4.81),('8537','2013-07-16','12:10:00',4.85),('8537','2013-07-16','12:15:00',4.85),('8537','2013-07-16','12:20:00',4.85),('8537','2013-07-16','12:25:00',4.84),('8537','2013-07-16','12:30:00',4.82),('8537','2013-07-16','12:35:00',4.82),('8537','2013-07-16','12:40:00',4.78),('8537','2013-07-16','12:45:00',4.77),('8537','2013-07-16','12:50:00',4.74),('8537','2013-07-16','12:55:00',4.77),('8537','2013-07-16','13:00:00',4.79),('8537','2013-07-16','13:05:00',4.9),('8537','2013-07-16','13:10:00',4.9),('8537','2013-07-16','13:15:00',4.94),('8537','2013-07-16','13:20:00',4.85),('8537','2013-07-16','13:25:00',4.82),('8537','2013-07-16','13:30:00',4.89),('8537','2013-07-16','13:35:00',4.87),('8537','2013-07-16','13:40:00',4.87),('8537','2013-07-16','13:45:00',4.9),('8537','2013-07-16','13:50:00',4.99),('8537','2013-07-16','13:55:00',4.72),('8537','2013-07-16','14:00:00',4.85),('8537','2013-07-16','14:05:00',4.7),('8537','2013-07-16','14:10:00',4.79),('8537','2013-07-16','14:15:00',4.11),('8537','2013-07-16','14:20:00',1.65),('8537','2013-07-16','14:25:00',4.42),('8537','2013-07-16','14:30:00',4.79),('8537','2013-07-16','14:35:00',4.77),('8537','2013-07-16','14:40:00',4.74),('8537','2013-07-16','14:45:00',4.65),('8537','2013-07-16','14:50:00',4.6),('8537','2013-07-16','14:55:00',4.59),('8537','2013-07-16','15:00:00',4.5),('8537','2013-07-16','15:05:00',4.4),('8537','2013-07-16','15:10:00',4.31),('8537','2013-07-16','15:15:00',4.25),('8537','2013-07-16','15:20:00',4.24),('8537','2013-07-16','15:25:00',4.22),('8537','2013-07-16','15:30:00',4.25),('8537','2013-07-16','15:35:00',4.2),('8537','2013-07-16','15:40:00',3.94),('8537','2013-07-16','15:45:00',3.05),('8537','2013-07-16','15:50:00',3.84),('8537','2013-07-16','15:55:00',3.84),('8537','2013-07-16','16:00:00',2.82),('8537','2013-07-16','16:05:00',1.01),('8537','2013-07-16','16:10:00',3.68),('8537','2013-07-16','16:15:00',3.61),('8537','2013-07-16','16:20:00',2.06),('8537','2013-07-16','16:25:00',1.48),('8537','2013-07-16','16:30:00',1.23),('8537','2013-07-16','16:45:00',1.41),('8537','2013-07-16','16:50:00',1.28),('8537','2013-07-16','16:55:00',1.37),('8537','2013-07-16','17:00:00',2.95),('8537','2013-07-16','17:05:00',2.94),('8537','2013-07-16','17:10:00',2.97),('8537','2013-07-16','17:15:00',2.8),('8537','2013-07-16','17:20:00',2.1),('8537','2013-07-16','17:25:00',1.42),('8537','2013-07-16','17:30:00',1.54),('8537','2013-07-16','17:35:00',1.55),('8537','2013-07-16','17:40:00',1.98),('8537','2013-07-16','17:45:00',2.13),('8537','2013-07-16','17:50:00',1.96),('8537','2013-07-16','17:55:00',1.39),('8537','2013-07-16','18:00:00',1.08),('8537','2013-07-16','18:10:00',1.04),('8537','2013-07-16','18:15:00',1.13),('8537','2013-07-16','18:20:00',1.09),('8537','2013-07-16','18:25:00',1.16),('8537','2013-07-16','18:30:00',1.08),('8537','2013-07-15','07:40:00',1.08),('8537','2013-07-15','07:45:00',1.18),('8537','2013-07-15','07:50:00',1.28),('8537','2013-07-15','07:55:00',1.38),('8537','2013-07-15','08:00:00',1.46),('8537','2013-07-15','08:05:00',1.58),('8537','2013-07-15','08:10:00',1.68),('8537','2013-07-15','08:15:00',1.79),('8537','2013-07-15','08:20:00',1.9),('8537','2013-07-15','08:25:00',2),('8537','2013-07-15','08:30:00',2.1),('8537','2013-07-15','08:35:00',2.21),('8537','2013-07-15','08:40:00',2.31),('8537','2013-07-15','08:45:00',2.4),('8537','2013-07-15','08:50:00',2.49),('8537','2013-07-15','08:55:00',2.59),('8537','2013-07-15','09:00:00',2.68),('8537','2013-07-15','09:05:00',2.77),('8537','2013-07-15','09:10:00',2.86),('8537','2013-07-15','09:15:00',2.94),('8537','2013-07-15','09:20:00',3.04),('8537','2013-07-15','09:25:00',3.12),('8537','2013-07-15','09:30:00',3.2),('8537','2013-07-15','09:35:00',3.28),('8537','2013-07-15','09:40:00',3.35),('8537','2013-07-15','09:45:00',3.41),('8537','2013-07-15','09:50:00',3.48),('8537','2013-07-15','09:55:00',3.54),('8537','2013-07-15','10:00:00',3.61),('8537','2013-07-15','10:05:00',3.68),('8537','2013-07-15','10:10:00',3.76),('8537','2013-07-15','10:15:00',3.83),('8537','2013-07-15','10:20:00',3.86),('8537','2013-07-15','10:25:00',3.89),('8537','2013-07-15','10:30:00',3.96),('8537','2013-07-15','10:35:00',3.99),('8537','2013-07-15','10:40:00',4.07),('8537','2013-07-15','10:45:00',4.12),('8537','2013-07-15','10:50:00',4.19),('8537','2013-07-15','10:55:00',4.25),('8537','2013-07-15','11:00:00',4.22),('8537','2013-07-15','11:05:00',4.34),('8537','2013-07-15','11:10:00',4.35),('8537','2013-07-15','11:15:00',4.36),('8537','2013-07-15','11:20:00',4.42),('8537','2013-07-15','11:25:00',4.46),('8537','2013-07-15','11:30:00',4.47),('8537','2013-07-15','11:35:00',4.53),('8537','2013-07-15','11:40:00',4.56),('8537','2013-07-15','11:45:00',4.58),('8537','2013-07-15','11:50:00',4.62),('8537','2013-07-15','11:55:00',4.67),('8537','2013-07-15','12:00:00',4.76),('8537','2013-07-15','12:05:00',4.72),('8537','2013-07-15','12:10:00',4.68),('8537','2013-07-15','12:15:00',4.77),('8537','2013-07-15','12:20:00',4.85),('8537','2013-07-15','12:25:00',4.85),('8537','2013-07-15','12:30:00',4.84),('8537','2013-07-15','12:35:00',4.82),('8537','2013-07-15','12:40:00',4.83),('8537','2013-07-15','12:45:00',4.74),('8537','2013-07-15','12:50:00',4.75),('8537','2013-07-15','12:55:00',4.84),('8537','2013-07-15','13:00:00',4.9),('8537','2013-07-15','13:05:00',4.8),('8537','2013-07-15','13:10:00',4.99),('8537','2013-07-15','13:15:00',4.94),('8537','2013-07-15','13:20:00',4.89),('8537','2013-07-15','13:25:00',5.11),('8537','2013-07-15','13:30:00',5.23),('8537','2013-07-15','13:35:00',4.3),('8537','2013-07-15','13:40:00',1.38),('8537','2013-07-15','13:45:00',3.58),('8537','2013-07-15','13:50:00',5.14),('8537','2013-07-15','13:55:00',5.22),('8537','2013-07-15','14:00:00',5.18),('8537','2013-07-15','14:05:00',4.37),('8537','2013-07-15','14:10:00',1.21),('8537','2013-07-15','14:15:00',1.2),('8537','2013-07-15','14:20:00',3.6),('8537','2013-07-15','14:25:00',5.04),('8537','2013-07-15','14:30:00',4.66),('8537','2013-07-15','14:35:00',4.44),('8537','2013-07-15','14:40:00',4.73),('8537','2013-07-15','14:45:00',4.76),('8537','2013-07-15','14:50:00',4.64),('8537','2013-07-15','14:55:00',4.43),('8537','2013-07-15','15:00:00',4.01),('8537','2013-07-15','15:05:00',4.34),('8537','2013-07-15','15:10:00',4.43),('8537','2013-07-15','15:15:00',4.3),('8537','2013-07-15','15:20:00',3.39),('8537','2013-07-15','15:25:00',3.87),('8537','2013-07-15','15:30:00',4.07),('8537','2013-07-15','15:35:00',3.78),('8537','2013-07-15','15:40:00',4.23),('8537','2013-07-15','15:45:00',3.98),('8537','2013-07-15','15:50:00',3.85),('8537','2013-07-15','15:55:00',3.8),('8537','2013-07-15','16:00:00',3.71),('8537','2013-07-15','16:05:00',3.68),('8537','2013-07-15','16:10:00',3.61),('8537','2013-07-15','16:15:00',3.55),('8537','2013-07-15','16:20:00',3.38),('8537','2013-07-15','16:25:00',3.31),('8537','2013-07-15','16:30:00',3.15),('8537','2013-07-15','16:35:00',3.06),('8537','2013-07-15','16:40:00',3.08),('8537','2013-07-15','16:45:00',3.02),('8537','2013-07-15','16:50:00',2.93),('8537','2013-07-15','16:55:00',2.88),('8537','2013-07-15','17:00:00',2.79),('8537','2013-07-15','17:05:00',2.71),('8537','2013-07-15','17:10:00',2.49),('8537','2013-07-15','17:15:00',2.13),('8537','2013-07-15','17:20:00',2.41),('8537','2013-07-15','17:25:00',2.33),('8537','2013-07-15','17:30:00',2.19),('8537','2013-07-15','17:35:00',2.06),('8537','2013-07-15','17:40:00',1.99),('8537','2013-07-15','17:45:00',1.88),('8537','2013-07-15','17:50:00',1.78),('8537','2013-07-15','17:55:00',1.62),('8537','2013-07-15','18:00:00',1.57),('8537','2013-07-15','18:05:00',1.46),('8537','2013-07-15','18:10:00',1.4),('8537','2013-07-15','18:15:00',1.32),('8537','2013-07-15','18:20:00',1.22),('8537','2013-07-15','18:25:00',1.12),('8537','2013-07-15','18:30:00',1.04),('8537','2013-07-14','07:50:00',1.15),('8537','2013-07-14','07:55:00',1.47),('8537','2013-07-14','08:00:00',1.45),('8537','2013-07-14','08:05:00',2),('8537','2013-07-14','08:10:00',1.84),('8537','2013-07-14','08:15:00',1.89),('8537','2013-07-14','08:20:00',2.22),('8537','2013-07-14','08:25:00',1.75),('8537','2013-07-14','08:30:00',1.11),('8537','2013-07-14','08:35:00',1.36),('8537','2013-07-14','08:40:00',1.31),('8537','2013-07-14','08:45:00',1.13),('8537','2013-07-14','08:50:00',1.3),('8537','2013-07-14','08:55:00',1.34),('8537','2013-07-14','09:00:00',1.26),('8537','2013-07-14','09:05:00',1.55),('8537','2013-07-14','09:10:00',1.82),('8537','2013-07-14','09:15:00',1.89),('8537','2013-07-14','09:20:00',2.33),('8537','2013-07-14','09:25:00',2.39),('8537','2013-07-14','09:30:00',2.5),('8537','2013-07-14','09:35:00',2.2),('8537','2013-07-14','09:40:00',1.97),('8537','2013-07-14','09:45:00',1.98),('8537','2013-07-14','09:50:00',1.88),('8537','2013-07-14','09:55:00',2),('8537','2013-07-14','10:00:00',1.97),('8537','2013-07-14','10:05:00',2.1),('8537','2013-07-14','10:10:00',2.06),('8537','2013-07-14','10:15:00',2.22),('8537','2013-07-14','10:20:00',2.82),('8537','2013-07-14','10:25:00',3.15),('8537','2013-07-14','10:30:00',2.99),('8537','2013-07-14','10:35:00',4.31),('8537','2013-07-14','10:40:00',4.28),('8537','2013-07-14','10:45:00',3.53),('8537','2013-07-14','10:50:00',4.52),('8537','2013-07-14','10:55:00',4.03),('8537','2013-07-14','11:00:00',4.3),('8537','2013-07-14','11:05:00',4.17),('8537','2013-07-14','11:10:00',4.04),('8537','2013-07-14','11:15:00',2.61),('8537','2013-07-14','11:20:00',4.48),('8537','2013-07-14','11:25:00',3.04),('8537','2013-07-14','11:30:00',4.74),('8537','2013-07-14','11:35:00',4.78),('8537','2013-07-14','11:40:00',4.31),('8537','2013-07-14','11:45:00',4.87),('8537','2013-07-14','11:50:00',3.99),('8537','2013-07-14','11:55:00',2.63),('8537','2013-07-14','12:00:00',2.23),('8537','2013-07-14','12:05:00',3.78),('8537','2013-07-14','12:10:00',4.83),('8537','2013-07-14','12:15:00',3.22),('8537','2013-07-14','12:20:00',3.97),('8537','2013-07-14','12:25:00',4.55),('8537','2013-07-14','12:30:00',2.46),('8537','2013-07-14','12:35:00',5.04),('8537','2013-07-14','12:40:00',4.8),('8537','2013-07-14','12:45:00',5.06),('8537','2013-07-14','12:50:00',4.81),('8537','2013-07-14','12:55:00',2.14),('8537','2013-07-14','13:00:00',4.01),('8537','2013-07-14','13:05:00',5.41),('8537','2013-07-14','13:10:00',5.12),('8537','2013-07-14','13:15:00',5.04),('8537','2013-07-14','13:20:00',5.11),('8537','2013-07-14','13:25:00',5),('8537','2013-07-14','13:30:00',4.99),('8537','2013-07-14','13:35:00',4.96),('8537','2013-07-14','13:40:00',4.93),('8537','2013-07-14','13:45:00',4.95),('8537','2013-07-14','13:50:00',4.96),('8537','2013-07-14','13:55:00',4.91),('8537','2013-07-14','14:00:00',4.92),('8537','2013-07-14','14:05:00',4.94),('8537','2013-07-14','14:10:00',4.92),('8537','2013-07-14','14:15:00',4.9),('8537','2013-07-14','14:20:00',4.86),('8537','2013-07-14','14:25:00',4.82),('8537','2013-07-14','14:30:00',4.76),('8537','2013-07-14','14:35:00',4.7),('8537','2013-07-14','14:40:00',4.62),('8537','2013-07-14','14:45:00',4.52),('8537','2013-07-14','14:50:00',4.4),('8537','2013-07-14','14:55:00',4.16),('8537','2013-07-14','15:00:00',4.21),('8537','2013-07-14','15:05:00',4.4),('8537','2013-07-14','15:10:00',4.32),('8537','2013-07-14','15:15:00',4.29),('8537','2013-07-14','15:20:00',4.22),('8537','2013-07-14','15:25:00',4.14),('8537','2013-07-14','15:30:00',4.11),('8537','2013-07-14','15:35:00',4.07),('8537','2013-07-14','15:40:00',4.01),('8537','2013-07-14','15:45:00',3.89),('8537','2013-07-14','15:50:00',3.83),('8537','2013-07-14','15:55:00',3.82),('8537','2013-07-14','16:00:00',3.55),('8537','2013-07-14','16:05:00',3.69),('8537','2013-07-14','16:10:00',3.64),('8537','2013-07-14','16:15:00',3.59),('8537','2013-07-14','16:20:00',3.62),('8537','2013-07-14','16:25:00',3),('8537','2013-07-14','16:30:00',1.96),('8537','2013-07-14','16:35:00',2.58),('8537','2013-07-14','16:40:00',2.42),('8537','2013-07-14','16:45:00',3.22),('8537','2013-07-14','16:50:00',3.05),('8537','2013-07-14','16:55:00',2.79),('8537','2013-07-14','17:00:00',2.11),('8537','2013-07-14','17:05:00',2.41),('8537','2013-07-14','17:10:00',2.18),('8537','2013-07-14','17:15:00',2.22),('8537','2013-07-14','17:20:00',1.34),('8537','2013-07-14','17:25:00',2),('8537','2013-07-14','17:30:00',2.25),('8537','2013-07-14','17:35:00',2.36),('8537','2013-07-14','17:40:00',1.21),('8537','2013-07-14','17:45:00',1.04),('8537','2013-07-14','17:50:00',1.32),('8537','2013-07-14','17:55:00',1.35),('8537','2013-07-14','18:00:00',1.18),('8537','2013-07-14','18:10:00',1.02),('8537','2013-07-13','07:35:00',1.02),('8537','2013-07-13','07:40:00',1.06),('8537','2013-07-13','07:45:00',1.12),('8537','2013-07-13','07:50:00',1.2),('8537','2013-07-13','07:55:00',1.29),('8537','2013-07-13','08:00:00',1.35),('8537','2013-07-13','08:05:00',1.48),('8537','2013-07-13','08:10:00',1.58),('8537','2013-07-13','08:15:00',1.69),('8537','2013-07-13','08:20:00',1.78),('8537','2013-07-13','08:25:00',1.87),('8537','2013-07-13','08:30:00',1.98),('8537','2013-07-13','08:35:00',2.05),('8537','2013-07-13','08:40:00',2.11),('8537','2013-07-13','08:45:00',2.2),('8537','2013-07-13','08:50:00',2.37),('8537','2013-07-13','08:55:00',2.42),('8537','2013-07-13','09:00:00',2.55),('8537','2013-07-13','09:05:00',2.64),('8537','2013-07-13','09:10:00',2.74),('8537','2013-07-13','09:15:00',2.81),('8537','2013-07-13','09:20:00',2.86),('8537','2013-07-13','09:25:00',2.95),('8537','2013-07-13','09:30:00',2.98),('8537','2013-07-13','09:35:00',3.1),('8537','2013-07-13','09:40:00',3.16),('8537','2013-07-13','09:45:00',3.29),('8537','2013-07-13','09:50:00',3.37),('8537','2013-07-13','09:55:00',3.41),('8537','2013-07-13','10:00:00',3.48),('8537','2013-07-13','10:05:00',3.53),('8537','2013-07-13','10:10:00',3.62),('8537','2013-07-13','10:15:00',3.71),('8537','2013-07-13','10:20:00',3.79),('8537','2013-07-13','10:25:00',3.87),('8537','2013-07-13','10:30:00',3.89),('8537','2013-07-13','10:35:00',3.88),('8537','2013-07-13','10:40:00',2.72),('8537','2013-07-13','10:45:00',3.09),('8537','2013-07-13','10:50:00',4.37),('8537','2013-07-13','10:55:00',4.32),('8537','2013-07-13','11:00:00',4.35),('8537','2013-07-13','11:05:00',4.56),('8537','2013-07-13','11:10:00',4.22),('8537','2013-07-13','11:15:00',4.56),('8537','2013-07-13','11:20:00',3.39),('8537','2013-07-13','11:25:00',3.9),('8537','2013-07-13','11:30:00',4.56),('8537','2013-07-13','11:35:00',4.48),('8537','2013-07-13','11:40:00',4.27),('8537','2013-07-13','11:45:00',1.46),('8537','2013-07-13','11:50:00',4.18),('8537','2013-07-13','11:55:00',5.05),('8537','2013-07-13','12:00:00',2.96),('8537','2013-07-13','12:05:00',1.48),('8537','2013-07-13','12:10:00',5.02),('8537','2013-07-13','12:15:00',3.05),('8537','2013-07-13','12:20:00',2.6),('8537','2013-07-13','12:25:00',4.47),('8537','2013-07-13','12:30:00',3.99),('8537','2013-07-13','12:35:00',5.11),('8537','2013-07-13','12:40:00',5.07),('8537','2013-07-13','12:45:00',4.95),('8537','2013-07-13','12:50:00',4.53),('8537','2013-07-13','12:55:00',3.93),('8537','2013-07-13','13:00:00',4.62),('8537','2013-07-13','13:05:00',5.05),('8537','2013-07-13','13:10:00',4.38),('8537','2013-07-13','13:15:00',4.63),('8537','2013-07-13','13:20:00',5.01),('8537','2013-07-13','13:25:00',4.96),('8537','2013-07-13','13:30:00',4.92),('8537','2013-07-13','13:35:00',4.93),('8537','2013-07-13','13:40:00',4.96),('8537','2013-07-13','13:45:00',4.91),('8537','2013-07-13','13:50:00',4.95),('8537','2013-07-13','13:55:00',4.88),('8537','2013-07-13','14:00:00',4.86),('8537','2013-07-13','14:05:00',4.84),('8537','2013-07-13','14:10:00',4.8),('8537','2013-07-13','14:15:00',4.8),('8537','2013-07-13','14:20:00',4.8),('8537','2013-07-13','14:25:00',4.75),('8537','2013-07-13','14:30:00',4.72),('8537','2013-07-13','14:35:00',4.7),('8537','2013-07-13','14:40:00',4.67),('8537','2013-07-13','14:45:00',4.63),('8537','2013-07-13','14:50:00',4.51),('8537','2013-07-13','14:55:00',4.51),('8537','2013-07-13','15:00:00',4.46),('8537','2013-07-13','15:05:00',4.49),('8537','2013-07-13','15:10:00',4.45),('8537','2013-07-13','15:15:00',4.42),('8537','2013-07-13','15:20:00',4.2),('8537','2013-07-13','15:25:00',4.35),('8537','2013-07-13','15:30:00',4.22),('8537','2013-07-13','15:35:00',4.27),('8537','2013-07-13','15:40:00',4.2),('8537','2013-07-13','15:45:00',4.04),('8537','2013-07-13','15:50:00',3.98),('8537','2013-07-13','15:55:00',3.93),('8537','2013-07-13','16:00:00',3.86),('8537','2013-07-13','16:05:00',3.8),('8537','2013-07-13','16:10:00',3.74),('8537','2013-07-13','16:15:00',3.65),('8537','2013-07-13','16:20:00',3.58),('8537','2013-07-13','16:25:00',3.55),('8537','2013-07-13','16:30:00',3.34),('8537','2013-07-13','16:35:00',3.07),('8537','2013-07-13','16:40:00',3.26),('8537','2013-07-13','16:45:00',3.16),('8537','2013-07-13','16:50:00',3.07),('8537','2013-07-13','16:55:00',3),('8537','2013-07-13','17:00:00',2.91),('8537','2013-07-13','17:05:00',2.77),('8537','2013-07-13','17:10:00',2.59),('8537','2013-07-13','17:15:00',2.22),('8537','2013-07-13','17:20:00',2.47),('8537','2013-07-13','17:25:00',2.47),('8537','2013-07-13','17:30:00',2.28),('8537','2013-07-13','17:35:00',2.15),('8537','2013-07-13','17:40:00',2.1),('8537','2013-07-13','17:45:00',2.02),('8537','2013-07-13','17:50:00',1.89),('8537','2013-07-13','17:55:00',1.79),('8537','2013-07-13','18:00:00',1.7),('8537','2013-07-13','18:05:00',1.53),('8537','2013-07-13','18:10:00',1.51),('8537','2013-07-13','18:15:00',1.43),('8537','2013-07-13','18:20:00',1.34),('8537','2013-07-13','18:25:00',1.23),('8537','2013-07-13','18:30:00',1.11),('8537','2013-07-13','18:35:00',1.02),('8537','2013-07-12','08:10:00',1.32),('8537','2013-07-12','08:15:00',1.88),('8537','2013-07-12','08:20:00',2.06),('8537','2013-07-12','08:25:00',1.03),('8537','2013-07-12','08:35:00',1.07),('8537','2013-07-12','08:40:00',1.32),('8537','2013-07-12','08:45:00',1.56),('8537','2013-07-12','08:50:00',1.15),('8537','2013-07-12','09:05:00',1.03),('8537','2013-07-12','09:10:00',1.45),('8537','2013-07-12','09:15:00',1.81),('8537','2013-07-12','09:20:00',2.52),('8537','2013-07-12','09:25:00',2.86),('8537','2013-07-12','09:30:00',1.94),('8537','2013-07-12','09:35:00',2.35),('8537','2013-07-12','09:40:00',2.21),('8537','2013-07-12','09:45:00',3.14),('8537','2013-07-12','09:50:00',3.4),('8537','2013-07-12','09:55:00',3.46),('8537','2013-07-12','10:00:00',3.52),('8537','2013-07-12','10:05:00',3.4),('8537','2013-07-12','10:10:00',2.9),('8537','2013-07-12','10:15:00',2.75),('8537','2013-07-12','10:20:00',1.34),('8537','2013-07-12','10:25:00',1.92),('8537','2013-07-12','10:30:00',2.11),('8537','2013-07-12','10:35:00',2.05),('8537','2013-07-12','10:45:00',1.08),('8537','2013-07-12','10:50:00',1.91),('8537','2013-07-12','10:55:00',3.65),('8537','2013-07-12','11:00:00',4.57),('8537','2013-07-12','11:05:00',1.6),('8537','2013-07-12','11:10:00',1.63),('8537','2013-07-12','11:15:00',3.78),('8537','2013-07-12','11:20:00',2.12),('8537','2013-07-12','11:25:00',4.18),('8537','2013-07-12','11:30:00',4.7),('8537','2013-07-12','11:35:00',4.9),('8537','2013-07-12','11:40:00',2.89),('8537','2013-07-12','11:45:00',2.55),('8537','2013-07-12','11:50:00',1.88),('8537','2013-07-12','11:55:00',5.14),('8537','2013-07-12','12:00:00',5.04),('8537','2013-07-12','12:05:00',4.4),('8537','2013-07-12','12:10:00',4.26),('8537','2013-07-12','12:15:00',3.78),('8537','2013-07-12','12:20:00',5.14),('8537','2013-07-12','12:25:00',5.17),('8537','2013-07-12','12:30:00',4.34),('8537','2013-07-12','12:35:00',5.3),('8537','2013-07-12','12:40:00',2.14),('8537','2013-07-12','12:45:00',5.22),('8537','2013-07-12','12:50:00',2.7),('8537','2013-07-12','12:55:00',4.71),('8537','2013-07-12','13:00:00',5.13),('8537','2013-07-12','13:05:00',5.11),('8537','2013-07-12','13:10:00',5.05),('8537','2013-07-12','13:15:00',5),('8537','2013-07-12','13:20:00',4.98),('8537','2013-07-12','13:25:00',4.91),('8537','2013-07-12','13:30:00',5.03),('8537','2013-07-12','13:35:00',5.01),('8537','2013-07-12','13:40:00',5),('8537','2013-07-12','13:45:00',4.56),('8537','2013-07-12','13:50:00',3.25),('8537','2013-07-12','13:55:00',5.03),('8537','2013-07-12','14:00:00',5.08),('8537','2013-07-12','14:05:00',4.81),('8537','2013-07-12','14:10:00',2.88),('8537','2013-07-12','14:15:00',4.74),('8537','2013-07-12','14:20:00',5.23),('8537','2013-07-12','14:25:00',4.99),('8537','2013-07-12','14:30:00',4.78),('8537','2013-07-12','14:35:00',4.75),('8537','2013-07-12','14:40:00',4.63),('8537','2013-07-12','14:45:00',4.52),('8537','2013-07-12','14:50:00',4.37),('8537','2013-07-12','14:55:00',4.06),('8537','2013-07-12','15:00:00',3.94),('8537','2013-07-12','15:05:00',4.35),('8537','2013-07-12','15:10:00',4.33),('8537','2013-07-12','15:15:00',4.29),('8537','2013-07-12','15:20:00',4.24),('8537','2013-07-12','15:25:00',4.21),('8537','2013-07-12','15:30:00',4.19),('8537','2013-07-12','15:35:00',4.08),('8537','2013-07-12','15:40:00',4.12),('8537','2013-07-12','15:45:00',3.93),('8537','2013-07-12','15:50:00',3.82),('8537','2013-07-12','15:55:00',3.77),('8537','2013-07-12','16:00:00',3.72),('8537','2013-07-12','16:05:00',3.62),('8537','2013-07-12','16:10:00',3.6),('8537','2013-07-12','16:15:00',3.53),('8537','2013-07-12','16:20:00',3.42),('8537','2013-07-12','16:25:00',3.39),('8537','2013-07-12','16:30:00',3.17),('8537','2013-07-12','16:35:00',3.2),('8537','2013-07-12','16:40:00',3.14),('8537','2013-07-12','16:45:00',3.09),('8537','2013-07-12','16:50:00',2.99),('8537','2013-07-12','16:55:00',2.9),('8537','2013-07-12','17:00:00',2.8),('8537','2013-07-12','17:05:00',2.72),('8537','2013-07-12','17:10:00',2.48),('8537','2013-07-12','17:15:00',2.13),('8537','2013-07-12','17:20:00',2.41),('8537','2013-07-12','17:25:00',2.3),('8537','2013-07-12','17:30:00',2.2),('8537','2013-07-12','17:35:00',2.07),('8537','2013-07-12','17:40:00',2.02),('8537','2013-07-12','17:45:00',1.9),('8537','2013-07-12','17:50:00',1.82),('8537','2013-07-12','17:55:00',1.65),('8537','2013-07-12','18:00:00',1.62),('8537','2013-07-12','18:05:00',1.5),('8537','2013-07-12','18:10:00',1.43),('8537','2013-07-12','18:15:00',1.34),('8537','2013-07-12','18:20:00',1.24),('8537','2013-07-12','18:25:00',1.16),('8537','2013-07-12','18:30:00',1.07),('8537','2013-07-11','07:40:00',1.05),('8537','2013-07-11','07:45:00',1.13),('8537','2013-07-11','07:50:00',1.22),('8537','2013-07-11','07:55:00',1.31),('8537','2013-07-11','08:00:00',1.42),('8537','2013-07-11','08:05:00',1.51),('8537','2013-07-11','08:10:00',1.59),('8537','2013-07-11','08:15:00',1.68),('8537','2013-07-11','08:20:00',1.8),('8537','2013-07-11','08:25:00',1.9),('8537','2013-07-11','08:30:00',1.99),('8537','2013-07-11','08:35:00',2.08),('8537','2013-07-11','08:40:00',2.14),('8537','2013-07-11','08:45:00',2.26),('8537','2013-07-11','08:50:00',2.41),('8537','2013-07-11','08:55:00',2.49),('8537','2013-07-11','09:00:00',2.51),('8537','2013-07-11','09:05:00',2.62),('8537','2013-07-11','09:10:00',2.77),('8537','2013-07-11','09:15:00',2.93),('8537','2013-07-11','09:20:00',3.02),('8537','2013-07-11','09:25:00',3.28),('8537','2013-07-11','09:30:00',2.87),('8537','2013-07-11','09:35:00',3.01),('8537','2013-07-11','09:40:00',2.74),('8537','2013-07-11','09:45:00',3.14),('8537','2013-07-11','09:50:00',3.79),('8537','2013-07-11','09:55:00',3.17),('8537','2013-07-11','10:00:00',2.93),('8537','2013-07-11','10:05:00',1.64),('8537','2013-07-11','10:10:00',2.95),('8537','2013-07-11','10:15:00',3.85),('8537','2013-07-11','10:20:00',3.98),('8537','2013-07-11','10:25:00',3.18),('8537','2013-07-11','10:30:00',3.7),('8537','2013-07-11','10:35:00',1.82),('8537','2013-07-11','10:40:00',1.84),('8537','2013-07-11','10:45:00',2.19),('8537','2013-07-11','10:50:00',4.36),('8537','2013-07-11','10:55:00',4.54),('8537','2013-07-11','11:00:00',3.38),('8537','2013-07-11','11:05:00',3.19),('8537','2013-07-11','11:10:00',4.77),('8537','2013-07-11','11:15:00',4.56),('8537','2013-07-11','11:20:00',4.71),('8537','2013-07-11','11:25:00',3.91),('8537','2013-07-11','11:30:00',4.85),('8537','2013-07-11','11:35:00',4.62),('8537','2013-07-11','11:40:00',3.12),('8537','2013-07-11','11:45:00',3.95),('8537','2013-07-11','11:50:00',3.29),('8537','2013-07-11','11:55:00',3.54),('8537','2013-07-11','12:00:00',3.35),('8537','2013-07-11','12:05:00',1.4),('8537','2013-07-11','12:10:00',1.41),('8537','2013-07-11','12:15:00',2.31),('8537','2013-07-11','12:20:00',5.29),('8537','2013-07-11','12:25:00',5.04),('8537','2013-07-11','12:30:00',4.96),('8537','2013-07-11','12:35:00',5.27),('8537','2013-07-11','12:40:00',5.21),('8537','2013-07-11','12:45:00',5.08),('8537','2013-07-11','12:50:00',5.09),('8537','2013-07-11','12:55:00',4.48),('8537','2013-07-11','13:00:00',5.18),('8537','2013-07-11','13:05:00',2.81),('8537','2013-07-11','13:10:00',5.26),('8537','2013-07-11','13:15:00',5.16),('8537','2013-07-11','13:20:00',5.08),('8537','2013-07-11','13:25:00',4.86),('8537','2013-07-11','13:30:00',4.21),('8537','2013-07-11','13:35:00',5.22),('8537','2013-07-11','13:40:00',4.8),('8537','2013-07-11','13:45:00',4.45),('8537','2013-07-11','13:50:00',2.38),('8537','2013-07-11','13:55:00',3.22),('8537','2013-07-11','14:00:00',4.02),('8537','2013-07-11','14:05:00',5.14),('8537','2013-07-11','14:10:00',4.76),('8537','2013-07-11','14:15:00',5),('8537','2013-07-11','14:20:00',4.35),('8537','2013-07-11','14:25:00',3.64),('8537','2013-07-11','14:30:00',3.72),('8537','2013-07-11','14:35:00',4.85),('8537','2013-07-11','14:40:00',4.78),('8537','2013-07-11','14:45:00',4.79),('8537','2013-07-11','14:50:00',4.62),('8537','2013-07-11','14:55:00',3.36),('8537','2013-07-11','15:00:00',4.18),('8537','2013-07-11','15:05:00',2.79),('8537','2013-07-11','15:10:00',2.61),('8537','2013-07-11','15:15:00',3.5),('8537','2013-07-11','15:20:00',3.4),('8537','2013-07-11','15:25:00',2.13),('8537','2013-07-11','15:30:00',3.92),('8537','2013-07-11','15:35:00',4.38),('8537','2013-07-11','15:40:00',3.21),('8537','2013-07-11','15:45:00',2.87),('8537','2013-07-11','15:50:00',2.69),('8537','2013-07-11','15:55:00',1.89),('8537','2013-07-11','16:00:00',3.5),('8537','2013-07-11','16:05:00',2.66),('8537','2013-07-11','16:10:00',4.32),('8537','2013-07-11','16:15:00',2.17),('8537','2013-07-11','16:20:00',2.52),('8537','2013-07-11','16:25:00',2.23),('8537','2013-07-11','16:30:00',2.6),('8537','2013-07-11','16:35:00',1.98),('8537','2013-07-11','16:40:00',2.65),('8537','2013-07-11','16:45:00',2.54),('8537','2013-07-11','16:50:00',3.18),('8537','2013-07-11','16:55:00',3.09),('8537','2013-07-11','17:00:00',2.34),('8537','2013-07-11','17:05:00',2.59),('8537','2013-07-11','17:10:00',2.53),('8537','2013-07-11','17:15:00',1.61),('8537','2013-07-11','17:20:00',2.06),('8537','2013-07-11','17:25:00',1.65),('8537','2013-07-11','17:30:00',2.02),('8537','2013-07-11','17:35:00',2.44),('8537','2013-07-11','17:40:00',1.71),('8537','2013-07-11','17:45:00',1.65),('8537','2013-07-11','17:50:00',1.43),('8537','2013-07-11','17:55:00',1.51),('8537','2013-07-11','18:00:00',1.48),('8537','2013-07-11','18:05:00',1.46),('8537','2013-07-11','18:10:00',1.47),('8537','2013-07-11','18:15:00',1.34),('8537','2013-07-11','18:20:00',1.09),('8537','2013-07-11','18:25:00',1.22),('8537','2013-07-11','18:30:00',1.21),('8537','2013-07-11','18:35:00',1.08),('8537','2014-05-03','07:35:00',1.07),('8537','2014-05-03','07:40:00',1.19),('8537','2014-05-03','07:45:00',1.31),('8537','2014-05-03','07:50:00',1.43),('8537','2014-05-03','07:55:00',1.54),('8537','2014-05-03','08:00:00',1.61),('8537','2014-05-03','08:05:00',1.92),('8537','2014-05-03','08:10:00',2.28),('8537','2014-05-03','08:15:00',1.74),('8537','2014-05-03','08:20:00',1.41),('8537','2014-05-03','08:25:00',1.23),('8537','2014-05-03','08:30:00',1.37),('8537','2014-05-03','08:35:00',1.11),('8537','2014-05-03','08:40:00',1.39),('8537','2014-05-03','08:45:00',2.52),('8537','2014-05-03','08:50:00',3),('8537','2014-05-03','08:55:00',3.17),('8537','2014-05-03','09:00:00',3.78),('8537','2014-05-03','09:05:00',3.56),('8537','2014-05-03','09:10:00',1.99),('8537','2014-05-03','09:15:00',2.12),('8537','2014-05-03','09:20:00',2.93),('8537','2014-05-03','09:25:00',3.92),('8537','2014-05-03','09:30:00',3.21),('8537','2014-05-03','09:35:00',2.93),('8537','2014-05-03','09:40:00',2.08),('8537','2014-05-03','09:45:00',3.66),('8537','2014-05-03','09:50:00',1.62),('8537','2014-05-03','09:55:00',3.88),('8537','2014-05-03','10:00:00',4.25),('8537','2014-05-03','10:05:00',4.19),('8537','2014-05-03','10:10:00',4.43),('8537','2014-05-03','10:15:00',4.03),('8537','2014-05-03','10:20:00',3.44),('8537','2014-05-03','10:25:00',5.4),('8537','2014-05-03','10:30:00',2.74),('8537','2014-05-03','10:35:00',1.14),('8537','2014-05-03','10:40:00',1.22),('8537','2014-05-03','10:45:00',2.17),('8537','2014-05-03','10:50:00',1.36),('8537','2014-05-03','10:55:00',2.06),('8537','2014-05-03','11:00:00',1.48),('8537','2014-05-03','11:05:00',4.43),('8537','2014-05-03','11:10:00',5.21),('8537','2014-05-03','11:15:00',4.42),('8537','2014-05-03','11:20:00',4.07),('8537','2014-05-03','11:25:00',4.72),('8537','2014-05-03','11:30:00',5.13),('8537','2014-05-03','11:35:00',3.24),('8537','2014-05-03','11:40:00',3.47),('8537','2014-05-03','11:45:00',2.86),('8537','2014-05-03','11:50:00',2.74),('8537','2014-05-03','11:55:00',2.74),('8537','2014-05-03','12:00:00',2.33),('8537','2014-05-03','12:05:00',1.91),('8537','2014-05-03','12:10:00',1.75),('8537','2014-05-03','12:15:00',1.58),('8537','2014-05-03','12:20:00',1.43),('8537','2014-05-03','12:25:00',1.53),('8537','2014-05-03','12:30:00',2.07),('8537','2014-05-03','12:35:00',2.48),('8537','2014-05-03','12:40:00',2.24),('8537','2014-05-03','12:45:00',2.29),('8537','2014-05-03','12:50:00',2.21),('8537','2014-05-03','12:55:00',2.23),('8537','2014-05-03','13:00:00',2.3),('8537','2014-05-03','13:05:00',2.35),('8537','2014-05-03','13:10:00',3.87),('8537','2014-05-03','13:15:00',3.24),('8537','2014-05-03','13:20:00',2.92),('8537','2014-05-03','13:25:00',3.5),('8537','2014-05-03','13:30:00',3.58),('8537','2014-05-03','13:35:00',2.64),('8537','2014-05-03','13:40:00',2.14),('8537','2014-05-03','13:45:00',2.1),('8537','2014-05-03','13:50:00',2.11),('8537','2014-05-03','13:55:00',2.13),('8537','2014-05-03','14:00:00',2.09),('8537','2014-05-03','14:05:00',2.11),('8537','2014-05-03','14:10:00',2.31),('8537','2014-05-03','14:15:00',2.65),('8537','2014-05-03','14:20:00',3.13),('8537','2014-05-03','14:25:00',4.35),('8537','2014-05-03','14:30:00',2.46),('8537','2014-05-03','14:35:00',1.93),('8537','2014-05-03','14:40:00',1.56),('8537','2014-05-03','14:55:00',1.3),('8537','2014-05-03','15:00:00',1.41),('8537','2014-05-03','15:05:00',1.36),('8537','2014-05-03','15:10:00',1.06),('8537','2014-05-03','16:40:00',1.01),('8537','2014-05-03','16:45:00',1.09),('8537','2014-05-03','16:50:00',1.14),('8537','2014-05-03','16:55:00',1.15),('8537','2014-05-03','17:00:00',1.15),('8537','2014-05-03','17:05:00',1.14),('8537','2014-05-03','17:10:00',1.13),('8537','2014-05-03','17:15:00',1.11),('8537','2014-05-03','17:20:00',1.1),('8537','2014-05-03','17:25:00',1.1),('8537','2014-05-03','17:30:00',1.07),('8537','2014-05-03','17:35:00',1.01),('8537','2014-05-03','17:40:00',1.02),('8537','2014-05-03','17:45:00',1.08),('8537','2014-05-03','17:50:00',1.23),('8537','2014-05-03','17:55:00',1.2),('8537','2014-05-03','18:00:00',1.05),('8537','2014-04-06','08:15:00',1.4),('8537','2014-04-06','08:20:00',1.5),('8537','2014-04-06','08:25:00',1.65),('8537','2014-04-06','08:30:00',1.73),('8537','2014-04-06','08:35:00',1.88),('8537','2014-04-06','08:40:00',2.02),('8537','2014-04-06','08:45:00',2.09),('8537','2014-04-06','08:50:00',1.56),('8537','2014-04-06','08:55:00',1.24),('8537','2014-04-06','09:00:00',1.64),('8537','2014-04-06','09:05:00',2.24),('8537','2014-04-06','09:10:00',2.67),('8537','2014-04-06','09:15:00',2.92),('8537','2014-04-06','09:20:00',2.35),('8537','2014-04-06','09:25:00',2.4),('8537','2014-04-06','09:30:00',2.08),('8537','2014-04-06','09:35:00',2.92),('8537','2014-04-06','09:40:00',3.02),('8537','2014-04-06','09:45:00',4.09),('8537','2014-04-06','09:50:00',4.31),('8537','2014-04-06','09:55:00',4.34),('8537','2014-04-06','10:00:00',3.54),('8537','2014-04-06','10:05:00',3.71),('8537','2014-04-06','10:10:00',3.4),('8537','2014-04-06','10:15:00',3.6),('8537','2014-04-06','10:20:00',2.23),('8537','2014-04-06','10:25:00',1.48),('8537','2014-04-06','10:30:00',1.62),('8537','2014-04-06','10:35:00',1.79),('8537','2014-04-06','10:40:00',1.89),('8537','2014-04-06','10:45:00',3.51),('8537','2014-04-06','10:50:00',3.86),('8537','2014-04-06','10:55:00',1.81),('8537','2014-04-06','11:00:00',2.59),('8537','2014-04-06','11:05:00',2.41),('8537','2014-04-06','11:10:00',4.64),('8537','2014-04-06','11:15:00',3.85),('8537','2014-04-06','11:20:00',4.97),('8537','2014-04-06','11:25:00',4.92),('8537','2014-04-06','11:30:00',5.13),('8537','2014-04-06','11:35:00',5.47),('8537','2014-04-06','11:40:00',5.38),('8537','2014-04-06','11:45:00',5.27),('8537','2014-04-06','11:50:00',5.35),('8537','2014-04-06','11:55:00',4.56),('8537','2014-04-06','12:00:00',5.27),('8537','2014-04-06','12:05:00',5.21),('8537','2014-04-06','12:10:00',5.13),('8537','2014-04-06','12:15:00',5.27),('8537','2014-04-06','12:20:00',3.54),('8537','2014-04-06','12:25:00',4.21),('8537','2014-04-06','12:30:00',3.93),('8537','2014-04-06','12:35:00',3.71),('8537','2014-04-06','12:40:00',3.56),('8537','2014-04-06','12:45:00',3.2),('8537','2014-04-06','12:50:00',1.99),('8537','2014-04-06','12:55:00',4.9),('8537','2014-04-06','13:00:00',5.26),('8537','2014-04-06','13:05:00',3.98),('8537','2014-04-06','13:10:00',5.12),('8537','2014-04-06','13:15:00',5.06),('8537','2014-04-06','13:20:00',3.3),('8537','2014-04-06','13:25:00',1.32),('8537','2014-04-06','13:30:00',4.92),('8537','2014-04-06','13:35:00',3.51),('8537','2014-04-06','13:40:00',3.69),('8537','2014-04-06','13:45:00',5.53),('8537','2014-04-06','13:50:00',5.36),('8537','2014-04-06','13:55:00',5.24),('8537','2014-04-06','14:00:00',5.13),('8537','2014-04-06','14:05:00',4.85),('8537','2014-04-06','14:10:00',5.2),('8537','2014-04-06','14:15:00',4.6),('8537','2014-04-06','14:20:00',3.6),('8537','2014-04-06','14:25:00',1.91),('8537','2014-04-06','14:30:00',1.31),('8537','2014-04-06','14:35:00',1.73),('8537','2014-04-06','14:40:00',3.96),('8537','2014-04-06','14:45:00',5.68),('8537','2014-04-06','14:50:00',3.91),('8537','2014-04-06','14:55:00',2.7),('8537','2014-04-06','15:00:00',2.33),('8537','2014-04-06','15:05:00',1.54),('8537','2014-04-06','15:10:00',3.86),('8537','2014-04-06','15:15:00',4.21),('8537','2014-04-06','15:20:00',2.05),('8537','2014-04-06','15:25:00',1.28),('8537','2014-04-06','15:45:00',1.14),('8537','2014-04-06','15:50:00',1.66),('8537','2014-04-06','15:55:00',3.45),('8537','2014-04-06','16:00:00',3.43),('8537','2014-04-06','16:05:00',1.54),('8537','2014-04-06','16:10:00',1.54),('8537','2014-04-06','16:25:00',1.43),('8537','2014-04-06','16:30:00',1.25),('8537','2014-04-06','16:35:00',1.85),('8537','2014-04-06','16:40:00',2.02),('8537','2014-04-06','16:45:00',2.76),('8537','2014-04-06','16:50:00',3.33),('8537','2014-04-06','16:55:00',1.81),('8537','2014-04-06','17:00:00',1),('8537','2014-04-06','17:25:00',1.45),('8537','2014-04-06','17:30:00',1.47),('8537','2014-04-06','17:35:00',1.44),('8537','2014-04-06','17:45:00',1.02),('8537','2014-04-06','17:50:00',1.46),('8537','2014-04-06','17:55:00',1.33),('8537','2014-04-06','18:00:00',1.21),('8537','2014-04-06','18:05:00',1.09),('8537','2014-04-06','18:10:00',1),('8537','2013-07-10','07:25:00',1.16),('8537','2013-07-10','07:30:00',1.33),('8537','2013-07-10','07:35:00',1.5),('8537','2013-07-10','07:40:00',1.67),('8537','2013-07-10','07:45:00',1.8),('8537','2013-07-10','07:50:00',1.96),('8537','2013-07-10','07:55:00',2.13),('8537','2013-07-10','08:00:00',2.25),('8537','2013-07-10','08:05:00',1.62),('8537','2013-07-10','08:10:00',1.95),('8537','2013-07-10','08:15:00',2.1),('8537','2013-07-10','08:20:00',2.1),('8537','2013-07-10','08:25:00',2.72),('8537','2013-07-10','08:30:00',2.94),('8537','2013-07-10','08:35:00',2.96),('8537','2013-07-10','08:40:00',2.65),('8537','2013-07-10','08:45:00',2.71),('8537','2013-07-10','08:50:00',2.72),('8537','2013-07-10','08:55:00',2.65),('8537','2013-07-10','09:00:00',2.7),('8537','2013-07-10','09:05:00',2.84),('8537','2013-07-10','09:10:00',2.95),('8537','2013-07-10','09:15:00',3.08),('8537','2013-07-10','09:20:00',3.14),('8537','2013-07-10','09:25:00',3.21),('8537','2013-07-10','09:30:00',3.2),('8537','2013-07-10','09:35:00',3.28),('8537','2013-07-10','09:40:00',3.35),('8537','2013-07-10','09:45:00',3.42),('8537','2013-07-10','09:50:00',3.46),('8537','2013-07-10','09:55:00',3.33),('8537','2013-07-10','10:00:00',3.45),('8537','2013-07-10','10:05:00',3.67),('8537','2013-07-10','10:10:00',3.74),('8537','2013-07-10','10:15:00',3.79),('8537','2013-07-10','10:20:00',3.87),('8537','2013-07-10','10:25:00',3.9),('8537','2013-07-10','10:30:00',4),('8537','2013-07-10','10:35:00',4.06),('8537','2013-07-10','10:40:00',4.08),('8537','2013-07-10','10:45:00',4.09),('8537','2013-07-10','10:50:00',4.16),('8537','2013-07-10','10:55:00',4.22),('8537','2013-07-10','11:00:00',4.24),('8537','2013-07-10','11:05:00',4.27),('8537','2013-07-10','11:10:00',4.3),('8537','2013-07-10','11:15:00',4.32),('8537','2013-07-10','11:20:00',4.4),('8537','2013-07-10','11:25:00',4.43),('8537','2013-07-10','11:30:00',4.41),('8537','2013-07-10','11:35:00',4.41),('8537','2013-07-10','11:40:00',4.43),('8537','2013-07-10','11:45:00',4.49),('8537','2013-07-10','11:50:00',4.58),('8537','2013-07-10','11:55:00',4.63),('8537','2013-07-10','12:00:00',4.62),('8537','2013-07-10','12:05:00',4.65),('8537','2013-07-10','12:10:00',4.66),('8537','2013-07-10','12:15:00',4.69),('8537','2013-07-10','12:20:00',4.73),('8537','2013-07-10','12:25:00',4.84),('8537','2013-07-10','12:30:00',4.91),('8537','2013-07-10','12:35:00',4.95),('8537','2013-07-10','12:40:00',4.82),('8537','2013-07-10','12:45:00',4.85),('8537','2013-07-10','12:50:00',4.87),('8537','2013-07-10','12:55:00',4.87),('8537','2013-07-10','13:00:00',4.79),('8537','2013-07-10','13:05:00',4.93),('8537','2013-07-10','13:10:00',4.93),('8537','2013-07-10','13:15:00',4.89),('8537','2013-07-10','13:20:00',4.85),('8537','2013-07-10','13:25:00',4.84),('8537','2013-07-10','13:30:00',4.83),('8537','2013-07-10','13:35:00',4.86),('8537','2013-07-10','13:40:00',4.88),('8537','2013-07-10','13:45:00',4.89),('8537','2013-07-10','13:50:00',4.85),('8537','2013-07-10','13:55:00',4.84),('8537','2013-07-10','14:00:00',4.84),('8537','2013-07-10','14:05:00',4.84),('8537','2013-07-10','14:10:00',4.82),('8537','2013-07-10','14:15:00',4.78),('8537','2013-07-10','14:20:00',4.75),('8537','2013-07-10','14:25:00',4.73),('8537','2013-07-10','14:30:00',4.73),('8537','2013-07-10','14:35:00',4.72),('8537','2013-07-10','14:40:00',4.69),('8537','2013-07-10','14:45:00',4.59),('8537','2013-07-10','14:50:00',4.38),('8537','2013-07-10','14:55:00',4.05),('8537','2013-07-10','15:00:00',4.27),('8537','2013-07-10','15:05:00',4.44),('8537','2013-07-10','15:10:00',4.41),('8537','2013-07-10','15:15:00',4.36),('8537','2013-07-10','15:20:00',4.3),('8537','2013-07-10','15:25:00',4.27),('8537','2013-07-10','15:30:00',4.23),('8537','2013-07-10','15:35:00',4.21),('8537','2013-07-10','15:40:00',3.27),('8537','2013-07-10','15:45:00',3.99),('8537','2013-07-10','15:50:00',3.92),('8537','2013-07-10','15:55:00',3.87),('8537','2013-07-10','16:00:00',3.74),('8537','2013-07-10','16:05:00',3.75),('8537','2013-07-10','16:10:00',3.67),('8537','2013-07-10','16:15:00',3.6),('8537','2013-07-10','16:20:00',3.52),('8537','2013-07-10','16:25:00',3.46),('8537','2013-07-10','16:30:00',3.29),('8537','2013-07-10','16:35:00',3.23),('8537','2013-07-10','16:40:00',3.15),('8537','2013-07-10','16:45:00',3.08),('8537','2013-07-10','16:50:00',3),('8537','2013-07-10','16:55:00',2.98),('8537','2013-07-10','17:00:00',2.96),('8537','2013-07-10','17:05:00',2.91),('8537','2013-07-10','17:10:00',2.56),('8537','2013-07-10','17:15:00',1.65),('8537','2013-07-10','17:20:00',1.6),('8537','2013-07-10','17:35:00',2.2),('8537','2013-07-10','17:40:00',2.13),('8537','2013-07-10','17:45:00',1.66),('8537','2013-07-10','17:50:00',1.91),('8537','2013-07-10','17:55:00',1.68),('8537','2013-07-10','18:00:00',1.68),('8537','2013-07-10','18:05:00',1.03),('8537','2013-07-09','07:35:00',1.02),('8537','2013-07-09','07:40:00',1.12),('8537','2013-07-09','07:45:00',1.2),('8537','2013-07-09','07:50:00',1.3),('8537','2013-07-09','07:55:00',1.4),('8537','2013-07-09','08:00:00',1.48),('8537','2013-07-09','08:05:00',1.57),('8537','2013-07-09','08:10:00',1.67),('8537','2013-07-09','08:15:00',1.78),('8537','2013-07-09','08:20:00',1.86),('8537','2013-07-09','08:25:00',1.96),('8537','2013-07-09','08:30:00',2.06),('8537','2013-07-09','08:35:00',2.16),('8537','2013-07-09','08:40:00',2.23),('8537','2013-07-09','08:45:00',2.33),('8537','2013-07-09','08:50:00',2.43),('8537','2013-07-09','08:55:00',2.52),('8537','2013-07-09','09:00:00',2.61),('8537','2013-07-09','09:05:00',2.7),('8537','2013-07-09','09:10:00',2.78),('8537','2013-07-09','09:15:00',2.86),('8537','2013-07-09','09:20:00',2.94),('8537','2013-07-09','09:25:00',3.03),('8537','2013-07-09','09:30:00',3.11),('8537','2013-07-09','09:35:00',3.19),('8537','2013-07-09','09:40:00',3.27),('8537','2013-07-09','09:45:00',3.35),('8537','2013-07-09','09:50:00',3.43),('8537','2013-07-09','09:55:00',3.49),('8537','2013-07-09','10:00:00',3.55),('8537','2013-07-09','10:05:00',3.61),('8537','2013-07-09','10:10:00',3.68),('8537','2013-07-09','10:15:00',3.73),('8537','2013-07-09','10:20:00',3.8),('8537','2013-07-09','10:25:00',3.85),('8537','2013-07-09','10:30:00',3.88),('8537','2013-07-09','10:35:00',3.95),('8537','2013-07-09','10:40:00',4.02),('8537','2013-07-09','10:45:00',4.09),('8537','2013-07-09','10:50:00',4.16),('8537','2013-07-09','10:55:00',4.27),('8537','2013-07-09','11:00:00',4.29),('8537','2013-07-09','11:05:00',4.25),('8537','2013-07-09','11:10:00',4.09),('8537','2013-07-09','11:15:00',3.85),('8537','2013-07-09','11:20:00',4.01),('8537','2013-07-09','11:25:00',3.88),('8537','2013-07-09','11:30:00',2.19),('8537','2013-07-09','11:35:00',2.64),('8537','2013-07-09','11:40:00',2.37),('8537','2013-07-09','11:45:00',4.57),('8537','2013-07-09','11:50:00',5.2),('8537','2013-07-09','11:55:00',5.08),('8537','2013-07-09','12:00:00',5.05),('8537','2013-07-09','12:05:00',5.02),('8537','2013-07-09','12:10:00',4.82),('8537','2013-07-09','12:15:00',4.77),('8537','2013-07-09','12:20:00',4.67),('8537','2013-07-09','12:25:00',4.6),('8537','2013-07-09','12:30:00',4.58),('8537','2013-07-09','12:35:00',4.61),('8537','2013-07-09','12:40:00',4.72),('8537','2013-07-09','12:45:00',4.71),('8537','2013-07-09','12:50:00',4.8),('8537','2013-07-09','12:55:00',4.82),('8537','2013-07-09','13:00:00',4.81),('8537','2013-07-09','13:05:00',4.83),('8537','2013-07-09','13:10:00',4.56),('8537','2013-07-09','13:15:00',4.86),('8537','2013-07-09','13:20:00',4.95),('8537','2013-07-09','13:25:00',4.83),('8537','2013-07-09','13:30:00',5.03),('8537','2013-07-09','13:35:00',4.73),('8537','2013-07-09','13:40:00',4.67),('8537','2013-07-09','13:45:00',4.02),('8537','2013-07-09','13:50:00',3.63),('8537','2013-07-09','13:55:00',3.59),('8537','2013-07-09','14:00:00',3.68),('8537','2013-07-09','14:05:00',3.55),('8537','2013-07-09','14:10:00',4),('8537','2013-07-09','14:15:00',4.05),('8537','2013-07-09','14:20:00',3.04),('8537','2013-07-09','14:25:00',2.54),('8537','2013-07-09','14:30:00',1.65),('8537','2013-07-09','14:35:00',1.23),('8537','2013-07-09','14:40:00',1.14),('8537','2013-07-08','07:40:00',1.44),('8537','2013-07-08','07:45:00',1.34),('8537','2013-07-08','07:50:00',1.12),('8537','2013-07-08','07:55:00',1.13),('8537','2013-07-08','08:00:00',1.33),('8537','2013-07-08','08:05:00',1.32),('8537','2013-07-08','08:10:00',1.53),('8537','2013-07-08','08:15:00',1.73),('8537','2013-07-08','08:20:00',1.86),('8537','2013-07-08','08:25:00',1.97),('8537','2013-07-08','08:30:00',2.08),('8537','2013-07-08','08:35:00',2.17),('8537','2013-07-08','08:40:00',2.26),('8537','2013-07-08','08:45:00',2.34),('8537','2013-07-08','08:50:00',2.44),('8537','2013-07-08','08:55:00',2.52),('8537','2013-07-08','09:00:00',2.6),('8537','2013-07-08','09:05:00',2.68),('8537','2013-07-08','09:10:00',2.74),('8537','2013-07-08','09:15:00',2.8),('8537','2013-07-08','09:20:00',2.87),('8537','2013-07-08','09:25:00',2.89),('8537','2013-07-08','09:30:00',3.04),('8537','2013-07-08','09:35:00',3.24),('8537','2013-07-08','09:40:00',3.31),('8537','2013-07-08','09:45:00',3.33),('8537','2013-07-08','09:50:00',3.39),('8537','2013-07-08','09:55:00',3.5),('8537','2013-07-08','10:00:00',3.6),('8537','2013-07-08','10:05:00',3.65),('8537','2013-07-08','10:10:00',3.66),('8537','2013-07-08','10:15:00',3.78),('8537','2013-07-08','10:20:00',3.85),('8537','2013-07-08','10:25:00',3.89),('8537','2013-07-08','10:30:00',3.99),('8537','2013-07-08','10:35:00',4.01),('8537','2013-07-08','10:40:00',4.03),('8537','2013-07-08','10:45:00',4.06),('8537','2013-07-08','10:50:00',4.1),('8537','2013-07-08','10:55:00',4.13),('8537','2013-07-08','11:00:00',4.17),('8537','2013-07-08','11:05:00',4.27),('8537','2013-07-08','11:10:00',4.35),('8537','2013-07-08','11:15:00',4.42),('8537','2013-07-08','11:20:00',4.53),('8537','2013-07-08','11:25:00',4.56),('8537','2013-07-08','11:30:00',4.61),('8537','2013-07-08','11:35:00',4.66),('8537','2013-07-08','11:40:00',4.4),('8537','2013-07-08','11:45:00',4.68),('8537','2013-07-08','11:50:00',4.71),('8537','2013-07-08','11:55:00',4.64),('8537','2013-07-08','12:00:00',4.68),('8537','2013-07-08','12:05:00',4.8),('8537','2013-07-08','12:10:00',4.9),('8537','2013-07-08','12:15:00',4.98),('8537','2013-07-08','12:20:00',5.12),('8537','2013-07-08','12:25:00',5.02),('8537','2013-07-08','12:30:00',4.65),('8537','2013-07-08','12:35:00',5.03),('8537','2013-07-08','12:40:00',4.93),('8537','2013-07-08','12:45:00',4.92),('8537','2013-07-08','12:50:00',4.93),('8537','2013-07-08','12:55:00',5),('8537','2013-07-08','13:00:00',5.11),('8537','2013-07-08','13:05:00',5.25),('8537','2013-07-08','13:10:00',5.44),('8537','2013-07-08','13:15:00',5.13),('8537','2013-07-08','13:20:00',3.44),('8537','2013-07-08','13:25:00',1.64),('8537','2013-07-08','14:30:00',1.08),('8537','2013-07-08','14:35:00',1.26),('8537','2013-07-08','14:40:00',1.29),('8537','2013-07-08','14:45:00',1.23),('8537','2013-07-08','14:50:00',1.19),('8537','2013-07-08','14:55:00',1.16),('8537','2013-07-08','15:00:00',1.07),('8537','2013-07-08','17:30:00',1.06),('8537','2013-07-08','17:35:00',1.16),('8537','2013-07-08','17:40:00',1.2),('8537','2013-07-08','17:45:00',1.2),('8537','2013-07-08','17:50:00',1.2),('8537','2013-07-08','17:55:00',1.15),('8537','2013-07-08','18:00:00',1.07),('8537','2013-07-08','18:20:00',1.01),('8537','2013-07-08','18:40:00',1.18),('8537','2013-07-08','18:45:00',1.05),('8537','2013-07-07','07:35:00',1.06),('8537','2013-07-07','07:40:00',1.16),('8537','2013-07-07','07:45:00',1.26),('8537','2013-07-07','07:50:00',1.36),('8537','2013-07-07','07:55:00',1.46),('8537','2013-07-07','08:00:00',1.58),('8537','2013-07-07','08:05:00',1.68),('8537','2013-07-07','08:10:00',1.79),('8537','2013-07-07','08:15:00',1.69),('8537','2013-07-07','08:20:00',1.51),('8537','2013-07-07','08:25:00',1.64),('8537','2013-07-07','08:30:00',2.05),('8537','2013-07-07','08:35:00',2.38),('8537','2013-07-07','08:40:00',1.54),('8537','2013-07-07','08:45:00',1),('8537','2013-07-07','08:50:00',2.2),('8537','2013-07-07','08:55:00',2.64),('8537','2013-07-07','09:00:00',2.68),('8537','2013-07-07','09:05:00',2.47),('8537','2013-07-07','09:10:00',2.63),('8537','2013-07-07','09:15:00',2.67),('8537','2013-07-07','09:20:00',1.75),('8537','2013-07-07','09:25:00',2.48),('8537','2013-07-07','09:30:00',3.26),('8537','2013-07-07','09:35:00',3.3),('8537','2013-07-07','09:40:00',3.05),('8537','2013-07-07','09:45:00',3.65),('8537','2013-07-07','09:50:00',3.64),('8537','2013-07-07','09:55:00',3.72),('8537','2013-07-07','10:00:00',3.74),('8537','2013-07-07','10:05:00',3.59),('8537','2013-07-07','10:10:00',3.76),('8537','2013-07-07','10:15:00',3.62),('8537','2013-07-07','10:20:00',3.67),('8537','2013-07-07','10:25:00',3.6),('8537','2013-07-07','10:30:00',3.6),('8537','2013-07-07','10:35:00',4.29),('8537','2013-07-07','10:40:00',3.87),('8537','2013-07-07','10:45:00',4.25),('8537','2013-07-07','10:50:00',4.36),('8537','2013-07-07','10:55:00',4.32),('8537','2013-07-07','11:00:00',4.34),('8537','2013-07-07','11:05:00',4.43),('8537','2013-07-07','11:10:00',4.5),('8537','2013-07-07','11:15:00',4.51),('8537','2013-07-07','11:20:00',4.29),('8537','2013-07-07','11:25:00',3.83),('8537','2013-07-07','11:30:00',4.02),('8537','2013-07-07','11:35:00',3.9),('8537','2013-07-07','11:40:00',4.12),('8537','2013-07-07','11:45:00',3.28),('8537','2013-07-07','11:50:00',3.36),('8537','2013-07-07','11:55:00',2.35),('8537','2013-07-07','12:00:00',3.15),('8537','2013-07-07','12:05:00',4.63),('8537','2013-07-07','12:10:00',4.71),('8537','2013-07-07','12:15:00',4.95),('8537','2013-07-07','12:20:00',4.85),('8537','2013-07-07','12:25:00',4.56),('8537','2013-07-07','12:30:00',4.65),('8537','2013-07-07','12:35:00',4.92),('8537','2013-07-07','12:40:00',5.1),('8537','2013-07-07','12:45:00',5.07),('8537','2013-07-07','12:50:00',4.9),('8537','2013-07-07','12:55:00',5.14),('8537','2013-07-07','13:00:00',4.97),('8537','2013-07-07','13:05:00',4.81),('8537','2013-07-07','13:10:00',5.06),('8537','2013-07-07','13:15:00',4.99),('8537','2013-07-07','13:20:00',4.98),('8537','2013-07-07','13:25:00',3.76),('8537','2013-07-07','13:30:00',4.74),('8537','2013-07-07','13:35:00',5.12),('8537','2013-07-07','13:40:00',4.8),('8537','2013-07-07','13:45:00',5.28),('8537','2013-07-07','13:50:00',5.42),('8537','2013-07-07','13:55:00',3.54),('8537','2013-07-07','14:00:00',3.91),('8537','2013-07-07','14:05:00',4.55),('8537','2013-07-07','14:10:00',2.44),('8537','2013-07-07','14:15:00',2.61),('8537','2013-07-07','14:20:00',1.37),('8537','2013-07-07','14:25:00',1.15),('8537','2013-07-07','14:30:00',1.05),('8537','2013-07-07','15:00:00',1.1),('8537','2013-07-07','15:05:00',1.26),('8537','2013-07-07','15:10:00',1.06),('8537','2013-07-07','17:00:00',1.05),('8537','2013-07-07','17:05:00',1.11),('8537','2013-07-07','17:10:00',1.16),('8537','2013-07-07','17:15:00',1.18),('8537','2013-07-07','17:20:00',1.19),('8537','2013-07-07','17:25:00',1.17),('8537','2013-07-07','17:30:00',1.12),('8537','2013-07-07','17:35:00',1.06),('8537','2013-07-07','17:40:00',1.01),('8537','2013-07-06','07:35:00',1.02),('8537','2013-07-06','07:40:00',1.11),('8537','2013-07-06','07:45:00',1.22),('8537','2013-07-06','07:50:00',1.32),('8537','2013-07-06','07:55:00',1.42),('8537','2013-07-06','08:00:00',1.52),('8537','2013-07-06','08:05:00',1.63),('8537','2013-07-06','08:10:00',1.73),('8537','2013-07-06','08:15:00',1.82),('8537','2013-07-06','08:20:00',1.92),('8537','2013-07-06','08:25:00',2.02),('8537','2013-07-06','08:30:00',2.12),('8537','2013-07-06','08:35:00',2.22),('8537','2013-07-06','08:40:00',2.32),('8537','2013-07-06','08:45:00',2.4),('8537','2013-07-06','08:50:00',2.49),('8537','2013-07-06','08:55:00',2.58),('8537','2013-07-06','09:00:00',2.67),('8537','2013-07-06','09:05:00',2.77),('8537','2013-07-06','09:10:00',2.87),('8537','2013-07-06','09:15:00',2.95),('8537','2013-07-06','09:20:00',3.04),('8537','2013-07-06','09:25:00',3.1),('8537','2013-07-06','09:30:00',3.16),('8537','2013-07-06','09:35:00',3.24),('8537','2013-07-06','09:40:00',3.31),('8537','2013-07-06','09:45:00',3.37),('8537','2013-07-06','09:50:00',3.48),('8537','2013-07-06','09:55:00',3.57),('8537','2013-07-06','10:00:00',3.66),('8537','2013-07-06','10:05:00',3.74),('8537','2013-07-06','10:10:00',3.81),('8537','2013-07-06','10:15:00',3.87),('8537','2013-07-06','10:20:00',3.93),('8537','2013-07-06','10:25:00',3.97),('8537','2013-07-06','10:30:00',4.02),('8537','2013-07-06','10:35:00',4.07),('8537','2013-07-06','10:40:00',4.07),('8537','2013-07-06','10:45:00',4.19),('8537','2013-07-06','10:50:00',4.28),('8537','2013-07-06','10:55:00',4.33),('8537','2013-07-06','11:00:00',4.38),('8537','2013-07-06','11:05:00',4.43),('8537','2013-07-06','11:10:00',4.46),('8537','2013-07-06','11:15:00',4.45),('8537','2013-07-06','11:20:00',4.48),('8537','2013-07-06','11:25:00',4.54),('8537','2013-07-06','11:30:00',4.56),('8537','2013-07-06','11:35:00',4.61),('8537','2013-07-06','11:40:00',4.64),('8537','2013-07-06','11:45:00',4.7),('8537','2013-07-06','11:50:00',4.74),('8537','2013-07-06','11:55:00',4.71),('8537','2013-07-06','12:00:00',4.78),('8537','2013-07-06','12:05:00',4.83),('8537','2013-07-06','12:10:00',4.89),('8537','2013-07-06','12:15:00',4.89),('8537','2013-07-06','12:20:00',4.94),('8537','2013-07-06','12:25:00',4.91),('8537','2013-07-06','12:30:00',4.96),('8537','2013-07-06','12:35:00',4.92),('8537','2013-07-06','12:40:00',4.94),('8537','2013-07-06','12:45:00',4.99),('8537','2013-07-06','12:50:00',4.99),('8537','2013-07-06','12:55:00',5.02),('8537','2013-07-06','13:00:00',5.04),('8537','2013-07-06','13:05:00',5.06),('8537','2013-07-06','13:10:00',5.1),('8537','2013-07-06','13:15:00',5.08),('8537','2013-07-06','13:20:00',5.03),('8537','2013-07-06','13:25:00',4.99),('8537','2013-07-06','13:30:00',5.06),('8537','2013-07-06','13:35:00',5.03),('8537','2013-07-06','13:40:00',4.99),('8537','2013-07-06','13:45:00',5.05),('8537','2013-07-06','13:50:00',4.96),('8537','2013-07-06','13:55:00',4.96),('8537','2013-07-06','14:00:00',4.96),('8537','2013-07-06','14:05:00',4.98),('8537','2013-07-06','14:10:00',4.9),('8537','2013-07-06','14:15:00',4.12),('8537','2013-07-06','14:20:00',2.35),('8537','2013-07-06','14:25:00',4.93),('8537','2013-07-06','14:30:00',4.84),('8537','2013-07-06','14:35:00',4.83),('8537','2013-07-06','14:40:00',4.78),('8537','2013-07-06','14:45:00',4.74),('8537','2013-07-06','14:50:00',4.48),('8537','2013-07-06','14:55:00',3.88),('8537','2013-07-06','15:00:00',4.02),('8537','2013-07-06','15:05:00',4.52),('8537','2013-07-06','15:10:00',4.63),('8537','2013-07-06','15:15:00',4.5),('8537','2013-07-06','15:20:00',4.4),('8537','2013-07-06','15:25:00',4.36),('8537','2013-07-06','15:30:00',4.46),('8537','2013-07-06','15:35:00',2.46),('8537','2013-07-06','16:50:00',1.13),('8537','2013-07-06','16:55:00',1.4),('8537','2013-07-06','17:00:00',1.12),('8537','2013-07-06','17:05:00',1.06),('8537','2013-07-06','17:10:00',1.04),('8537','2013-07-06','17:15:00',1.15),('8537','2013-07-06','17:20:00',1.08),('8537','2013-07-06','17:25:00',1.13),('8537','2013-07-06','17:30:00',1.23),('8537','2013-07-06','17:35:00',1.23),('8537','2013-07-06','17:40:00',1.07),('8537','2013-07-06','17:45:00',1),('8537','2013-07-05','07:35:00',1.07),('8537','2013-07-05','07:40:00',1.16),('8537','2013-07-05','07:45:00',1.25),('8537','2013-07-05','07:50:00',1.32),('8537','2013-07-05','07:55:00',1.42),('8537','2013-07-05','08:00:00',1.55),('8537','2013-07-05','08:05:00',1.66),('8537','2013-07-05','08:10:00',1.75),('8537','2013-07-05','08:15:00',1.85),('8537','2013-07-05','08:20:00',1.92),('8537','2013-07-05','08:25:00',2.01),('8537','2013-07-05','08:30:00',2.12),('8537','2013-07-05','08:35:00',2.22),('8537','2013-07-05','08:40:00',2.31),('8537','2013-07-05','08:45:00',2.39),('8537','2013-07-05','08:50:00',2.48),('8537','2013-07-05','08:55:00',2.57),('8537','2013-07-05','09:00:00',2.65),('8537','2013-07-05','09:05:00',2.76),('8537','2013-07-05','09:10:00',2.83),('8537','2013-07-05','09:15:00',2.92),('8537','2013-07-05','09:20:00',3.02),('8537','2013-07-05','09:25:00',3.11),('8537','2013-07-05','09:30:00',3.21),('8537','2013-07-05','09:35:00',3.28),('8537','2013-07-05','09:40:00',3.33),('8537','2013-07-05','09:45:00',3.44),('8537','2013-07-05','09:50:00',3.5),('8537','2013-07-05','09:55:00',3.58),('8537','2013-07-05','10:00:00',3.61),('8537','2013-07-05','10:05:00',3.7),('8537','2013-07-05','10:10:00',3.76),('8537','2013-07-05','10:15:00',3.84),('8537','2013-07-05','10:20:00',3.91),('8537','2013-07-05','10:25:00',3.96),('8537','2013-07-05','10:30:00',4.01),('8537','2013-07-05','10:35:00',4.05),('8537','2013-07-05','10:40:00',4.09),('8537','2013-07-05','10:45:00',4.12),('8537','2013-07-05','10:50:00',4.18),('8537','2013-07-05','10:55:00',4.24),('8537','2013-07-05','11:00:00',4.28),('8537','2013-07-05','11:05:00',4.29),('8537','2013-07-05','11:10:00',4.33),('8537','2013-07-05','11:15:00',4.37),('8537','2013-07-05','11:20:00',4.4),('8537','2013-07-05','11:25:00',4.49),('8537','2013-07-05','11:30:00',4.54),('8537','2013-07-05','11:35:00',4.58),('8537','2013-07-05','11:40:00',4.6),('8537','2013-07-05','11:45:00',4.6),('8537','2013-07-05','11:50:00',4.69),('8537','2013-07-05','11:55:00',4.69),('8537','2013-07-05','12:00:00',4.68),('8537','2013-07-05','12:05:00',4.7),('8537','2013-07-05','12:10:00',4.72),('8537','2013-07-05','12:15:00',4.78),('8537','2013-07-05','12:20:00',4.79),('8537','2013-07-05','12:25:00',3.07),('8537','2013-07-05','12:30:00',4.58),('8537','2013-07-05','12:35:00',4.71),('8537','2013-07-05','12:40:00',4.8),('8537','2013-07-05','12:45:00',4.89),('8537','2013-07-05','12:50:00',4.71),('8537','2013-07-05','12:55:00',4.71),('8537','2013-07-05','13:00:00',4.8),('8537','2013-07-05','13:05:00',3.19),('8537','2013-07-05','13:10:00',5.08),('8537','2013-07-05','13:15:00',5.04),('8537','2013-07-05','13:20:00',4.29),('8537','2013-07-05','13:25:00',4.47),('8537','2013-07-05','13:30:00',5.1),('8537','2013-07-05','13:35:00',5.08),('8537','2013-07-05','13:40:00',5.07),('8537','2013-07-05','13:45:00',5),('8537','2013-07-05','13:50:00',4.88),('8537','2013-07-05','13:55:00',4.97),('8537','2013-07-05','14:00:00',5.01),('8537','2013-07-05','14:05:00',4.53),('8537','2013-07-05','14:10:00',4.95),('8537','2013-07-05','14:15:00',4.83),('8537','2013-07-05','14:20:00',4.8),('8537','2013-07-05','14:25:00',4.86),('8537','2013-07-05','14:30:00',4.71),('8537','2013-07-05','14:35:00',4.01),('8537','2013-07-05','14:40:00',4.75),('8537','2013-07-05','14:45:00',3.07),('8537','2013-07-05','14:50:00',3.53),('8537','2013-07-05','14:55:00',4.15),('8537','2013-07-05','15:00:00',4.55),('8537','2013-07-05','15:05:00',4.43),('8537','2013-07-05','15:10:00',4.54),('8537','2013-07-05','15:15:00',4.39),('8537','2013-07-05','15:20:00',3.03),('8537','2013-07-05','15:25:00',1.92),('8537','2013-07-05','15:30:00',3.9),('8537','2013-07-05','15:35:00',4.31),('8537','2013-07-05','15:40:00',4.2),('8537','2013-07-05','15:45:00',4.12),('8537','2013-07-05','15:50:00',3.81),('8537','2013-07-05','15:55:00',3.88),('8537','2013-07-05','16:00:00',3.82),('8537','2013-07-05','16:05:00',3.81),('8537','2013-07-05','16:10:00',3.69),('8537','2013-07-05','16:15:00',3.64),('8537','2013-07-05','16:20:00',3.6),('8537','2013-07-05','16:25:00',3.51),('8537','2013-07-05','16:30:00',3.34),('8537','2013-07-05','16:35:00',2.94),('8537','2013-07-05','16:40:00',3.19),('8537','2013-07-05','16:45:00',3.19),('8537','2013-07-05','16:50:00',3.04),('8537','2013-07-05','16:55:00',2.93),('8537','2013-07-05','17:00:00',2.66),('8537','2013-07-05','17:05:00',2.79),('8537','2013-07-05','17:10:00',2.63),('8537','2013-07-05','17:15:00',2.66),('8537','2013-07-05','17:20:00',2.63),('8537','2013-07-05','17:25:00',2.5),('8537','2013-07-05','17:30:00',2.35),('8537','2013-07-05','17:35:00',2.12),('8537','2013-07-05','17:40:00',2.03),('8537','2013-07-05','17:45:00',1.91),('8537','2013-07-05','17:50:00',1.83),('8537','2013-07-05','17:55:00',1.75),('8537','2013-07-05','18:00:00',1.72),('8537','2013-07-05','18:05:00',1.6),('8537','2013-07-05','18:10:00',1.23),('8537','2013-07-04','08:55:00',1.09),('8537','2013-07-04','09:00:00',1.07),('8537','2013-07-04','11:10:00',1.18),('8537','2013-07-04','11:15:00',1.27),('8537','2013-07-04','11:20:00',1.19),('8537','2013-07-04','11:25:00',1.24),('8537','2013-07-04','11:30:00',1.34),('8537','2013-07-04','11:35:00',1.53),('8537','2013-07-04','11:40:00',1.72),('8537','2013-07-04','11:45:00',1.89),('8537','2013-07-04','11:50:00',1.96),('8537','2013-07-04','11:55:00',1.8),('8537','2013-07-04','12:00:00',1.69),('8537','2013-07-04','12:05:00',1.86),('8537','2013-07-04','12:10:00',2.47),('8537','2013-07-04','12:15:00',3.1),('8537','2013-07-04','12:20:00',2.89),('8537','2013-07-04','12:25:00',3.91),('8537','2013-07-04','12:30:00',3.28),('8537','2013-07-04','12:35:00',3.05),('8537','2013-07-04','12:40:00',2.02),('8537','2013-07-04','12:45:00',1.63),('8537','2013-07-04','12:50:00',1.29),('8537','2013-07-04','12:55:00',1.15),('8537','2013-07-04','13:00:00',1.2),('8537','2013-07-04','13:05:00',1.37),('8537','2013-07-04','13:10:00',1.74),('8537','2013-07-04','13:15:00',2.02),('8537','2013-07-04','13:20:00',2.25),('8537','2013-07-04','13:25:00',3.05),('8537','2013-07-04','13:30:00',2.41),('8537','2013-07-04','13:35:00',2.46),('8537','2013-07-04','13:40:00',3.65),('8537','2013-07-04','13:45:00',2.6),('8537','2013-07-04','13:50:00',3.28),('8537','2013-07-04','13:55:00',3.35),('8537','2013-07-04','14:00:00',2.67),('8537','2013-07-04','14:05:00',2.58),('8537','2013-07-04','14:10:00',2.54),('8537','2013-07-04','14:15:00',2.5),('8537','2013-07-04','14:20:00',3.04),('8537','2013-07-04','14:25:00',2.24),('8537','2013-07-04','14:30:00',2.2),('8537','2013-07-04','14:35:00',2.29),('8537','2013-07-04','14:40:00',3.76),('8537','2013-07-04','14:45:00',5.03),('8537','2013-07-04','14:50:00',3.18),('8537','2013-07-04','14:55:00',2.52),('8537','2013-07-04','15:00:00',3.62),('8537','2013-07-04','15:05:00',3.77),('8537','2013-07-04','15:10:00',3.03),('8537','2013-07-04','15:15:00',5.17),('8537','2013-07-04','15:20:00',4.74),('8537','2013-07-04','15:25:00',4.23),('8537','2013-07-04','15:30:00',2.72),('8537','2013-07-04','15:35:00',3.29),('8537','2013-07-04','15:40:00',3.05),('8537','2013-07-04','15:45:00',3.75),('8537','2013-07-04','15:50:00',2.55),('8537','2013-07-04','15:55:00',2.49),('8537','2013-07-04','16:00:00',2.61),('8537','2013-07-04','16:05:00',2.72),('8537','2013-07-04','16:10:00',2.28),('8537','2013-07-04','16:15:00',1.96),('8537','2013-07-04','16:20:00',2.12),('8537','2013-07-04','16:25:00',2.36),('8537','2013-07-04','16:30:00',2.31),('8537','2013-07-04','16:35:00',2.32),('8537','2013-07-04','16:40:00',1.86),('8537','2013-07-04','16:45:00',1.72),('8537','2013-07-04','16:50:00',1.76),('8537','2013-07-04','16:55:00',1.71),('8537','2013-07-04','17:00:00',1.5),('8537','2013-07-04','17:05:00',1.42),('8537','2013-07-04','17:10:00',1.75),('8537','2013-07-04','17:15:00',2.24),('8537','2013-07-04','17:20:00',2.23),('8537','2013-07-04','17:25:00',2.6),('8537','2013-07-04','17:30:00',2.26),('8537','2013-07-04','17:35:00',1.97),('8537','2013-07-04','17:40:00',2.39),('8537','2013-07-04','17:45:00',2.26),('8537','2013-07-04','17:50:00',2.18),('8537','2013-07-04','17:55:00',2.08),('8537','2013-07-04','18:00:00',2.02),('8537','2013-07-04','18:05:00',1.89),('8537','2013-07-04','18:10:00',1.81),('8537','2013-07-04','18:15:00',1.75),('8537','2013-07-04','18:20:00',1.63),('8537','2013-07-04','18:25:00',1.49),('8537','2013-07-04','18:30:00',1.04),('8537','2013-07-03','07:35:00',1.09),('8537','2013-07-03','07:40:00',1.19),('8537','2013-07-03','07:45:00',1.3),('8537','2013-07-03','07:50:00',1.4),('8537','2013-07-03','07:55:00',1.51),('8537','2013-07-03','08:00:00',1.61),('8537','2013-07-03','08:05:00',1.72),('8537','2013-07-03','08:10:00',1.83),('8537','2013-07-03','08:15:00',1.92),('8537','2013-07-03','08:20:00',2.02),('8537','2013-07-03','08:25:00',2.13),('8537','2013-07-03','08:30:00',2.22),('8537','2013-07-03','08:35:00',2.32),('8537','2013-07-03','08:40:00',2.42),('8537','2013-07-03','08:45:00',2.51),('8537','2013-07-03','08:50:00',2.59),('8537','2013-07-03','08:55:00',2.7),('8537','2013-07-03','09:00:00',2.79),('8537','2013-07-03','09:05:00',2.85),('8537','2013-07-03','09:10:00',2.92),('8537','2013-07-03','09:15:00',3.03),('8537','2013-07-03','09:20:00',3.1),('8537','2013-07-03','09:25:00',3.17),('8537','2013-07-03','09:30:00',3.26),('8537','2013-07-03','09:35:00',3.32),('8537','2013-07-03','09:40:00',3.4),('8537','2013-07-03','09:45:00',3.44),('8537','2013-07-03','09:50:00',3.51),('8537','2013-07-03','09:55:00',3.56),('8537','2013-07-03','10:00:00',3.66),('8537','2013-07-03','10:05:00',3.69),('8537','2013-07-03','10:10:00',3.7),('8537','2013-07-03','10:15:00',3.77),('8537','2013-07-03','10:20:00',3.86),('8537','2013-07-03','10:25:00',3.92),('8537','2013-07-03','10:30:00',3.99),('8537','2013-07-03','10:35:00',4.03),('8537','2013-07-03','10:40:00',4.1),('8537','2013-07-03','10:45:00',4.13),('8537','2013-07-03','10:50:00',4.15),('8537','2013-07-03','10:55:00',4.22),('8537','2013-07-03','11:00:00',4.28),('8537','2013-07-03','11:05:00',4.32),('8537','2013-07-03','11:10:00',4.33),('8537','2013-07-03','11:15:00',4.48),('8537','2013-07-03','11:20:00',4.53),('8537','2013-07-03','11:25:00',4.52),('8537','2013-07-03','11:30:00',4.52),('8537','2013-07-03','11:35:00',4.53),('8537','2013-07-03','11:40:00',4.49),('8537','2013-07-03','11:45:00',4.65),('8537','2013-07-03','11:50:00',4.79),('8537','2013-07-03','11:55:00',4.79),('8537','2013-07-03','12:00:00',4.77),('8537','2013-07-03','12:05:00',4.86),('8537','2013-07-03','12:10:00',4.85),('8537','2013-07-03','12:15:00',4.84),('8537','2013-07-03','12:20:00',4.85),('8537','2013-07-03','12:25:00',4.84),('8537','2013-07-03','12:30:00',4.85),('8537','2013-07-03','12:35:00',4.92),('8537','2013-07-03','12:40:00',4.93),('8537','2013-07-03','12:45:00',4.96),('8537','2013-07-03','12:50:00',4.98),('8537','2013-07-03','12:55:00',5.01),('8537','2013-07-03','13:00:00',5.03),('8537','2013-07-03','13:05:00',5.04),('8537','2013-07-03','13:10:00',4.94),('8537','2013-07-03','13:15:00',5.03),('8537','2013-07-03','13:20:00',5.02),('8537','2013-07-03','13:25:00',4.95),('8537','2013-07-03','13:30:00',4.93),('8537','2013-07-03','13:35:00',4.94),('8537','2013-07-03','13:40:00',4.96),('8537','2013-07-03','13:45:00',4.97),('8537','2013-07-03','13:50:00',4.97),('8537','2013-07-03','13:55:00',4.93),('8537','2013-07-03','14:00:00',4.9),('8537','2013-07-03','14:05:00',4.89),('8537','2013-07-03','14:10:00',4.89),('8537','2013-07-03','14:15:00',4.87),('8537','2013-07-03','14:20:00',4.86),('8537','2013-07-03','14:25:00',4.81),('8537','2013-07-03','14:30:00',4.81),('8537','2013-07-03','14:35:00',4.79),('8537','2013-07-03','14:40:00',4.75),('8537','2013-07-03','14:45:00',4.67),('8537','2013-07-03','14:50:00',4.42),('8537','2013-07-03','14:55:00',4.36),('8537','2013-07-03','15:00:00',4.55),('8537','2013-07-03','15:05:00',4.51),('8537','2013-07-03','15:10:00',4.46),('8537','2013-07-03','15:15:00',4.44),('8537','2013-07-03','15:20:00',4.39),('8537','2013-07-03','15:25:00',4.36),('8537','2013-07-03','15:30:00',4.32),('8537','2013-07-03','15:35:00',4.25),('8537','2013-07-03','15:40:00',4.18),('8537','2013-07-03','15:45:00',4.04),('8537','2013-07-03','15:50:00',3.86),('8537','2013-07-03','15:55:00',3.96),('8537','2013-07-03','16:00:00',3.88),('8537','2013-07-03','16:05:00',3.81),('8537','2013-07-03','16:10:00',3.71),('8537','2013-07-03','16:15:00',3.7),('8537','2013-07-03','16:20:00',3.64),('8537','2013-07-03','16:25:00',3.57),('8537','2013-07-03','16:30:00',3.37),('8537','2013-07-03','16:35:00',3.09),('8537','2013-07-03','16:40:00',3.27),('8537','2013-07-03','16:45:00',3.2),('8537','2013-07-03','16:50:00',3.12),('8537','2013-07-03','16:55:00',3.05),('8537','2013-07-03','17:00:00',2.97),('8537','2013-07-03','17:05:00',2.88),('8537','2013-07-03','17:10:00',2.7),('8537','2013-07-03','17:15:00',2.68),('8537','2013-07-03','17:20:00',2.6),('8537','2013-07-03','17:25:00',2.51),('8537','2013-07-03','17:30:00',2.39),('8537','2013-07-03','17:35:00',2.24),('8537','2013-07-03','17:40:00',2.18),('8537','2013-07-03','17:45:00',2.09),('8537','2013-07-03','17:50:00',2),('8537','2013-07-03','17:55:00',1.87),('8537','2013-07-03','18:00:00',1.79),('8537','2013-07-03','18:05:00',1.62),('8537','2013-07-03','18:10:00',1.53),('8537','2013-07-03','18:15:00',1.46),('8537','2013-07-03','18:20:00',1.37),('8537','2013-07-03','18:25:00',1.26),('8537','2013-07-03','18:30:00',1.16),('8537','2013-07-03','18:35:00',1.08),('8537','2013-07-02','07:35:00',1.07),('8537','2013-07-02','07:40:00',1.17),('8537','2013-07-02','07:45:00',1.27),('8537','2013-07-02','07:50:00',1.37),('8537','2013-07-02','07:55:00',1.47),('8537','2013-07-02','08:00:00',1.57),('8537','2013-07-02','08:05:00',1.68),('8537','2013-07-02','08:10:00',1.79),('8537','2013-07-02','08:15:00',1.9),('8537','2013-07-02','08:20:00',1.97),('8537','2013-07-02','08:25:00',2.1),('8537','2013-07-02','08:30:00',2.19),('8537','2013-07-02','08:35:00',2.27),('8537','2013-07-02','08:40:00',2.38),('8537','2013-07-02','08:45:00',2.48),('8537','2013-07-02','08:50:00',2.56),('8537','2013-07-02','08:55:00',2.64),('8537','2013-07-02','09:00:00',2.73),('8537','2013-07-02','09:05:00',2.82),('8537','2013-07-02','09:10:00',2.91),('8537','2013-07-02','09:15:00',2.97),('8537','2013-07-02','09:20:00',3.05),('8537','2013-07-02','09:25:00',3.12),('8537','2013-07-02','09:30:00',3.2),('8537','2013-07-02','09:35:00',3.23),('8537','2013-07-02','09:40:00',3.37),('8537','2013-07-02','09:45:00',3.42),('8537','2013-07-02','09:50:00',3.49),('8537','2013-07-02','09:55:00',3.58),('8537','2013-07-02','10:00:00',3.65),('8537','2013-07-02','10:05:00',3.68),('8537','2013-07-02','10:10:00',3.74),('8537','2013-07-02','10:15:00',3.78),('8537','2013-07-02','10:20:00',3.86),('8537','2013-07-02','10:25:00',3.92),('8537','2013-07-02','10:30:00',3.98),('8537','2013-07-02','10:35:00',4.02),('8537','2013-07-02','10:40:00',4.06),('8537','2013-07-02','10:45:00',4.13),('8537','2013-07-02','10:50:00',4.17),('8537','2013-07-02','10:55:00',4.18),('8537','2013-07-02','11:00:00',4.21),('8537','2013-07-02','11:05:00',4.25),('8537','2013-07-02','11:10:00',4.26),('8537','2013-07-02','11:15:00',4.31),('8537','2013-07-02','11:20:00',4.36),('8537','2013-07-02','11:25:00',4.41),('8537','2013-07-02','11:30:00',4.45),('8537','2013-07-02','11:35:00',4.48),('8537','2013-07-02','11:40:00',4.46),('8537','2013-07-02','11:45:00',4.46),('8537','2013-07-02','11:50:00',4.51),('8537','2013-07-02','11:55:00',4.55),('8537','2013-07-02','12:00:00',4.49),('8537','2013-07-02','12:05:00',4.54),('8537','2013-07-02','12:10:00',4.67),('8537','2013-07-02','12:15:00',4.66),('8537','2013-07-02','12:20:00',4.74),('8537','2013-07-02','12:25:00',4.81),('8537','2013-07-02','12:30:00',4.87),('8537','2013-07-02','12:35:00',4.89),('8537','2013-07-02','12:40:00',4.78),('8537','2013-07-02','12:45:00',4.93),('8537','2013-07-02','12:50:00',5.03),('8537','2013-07-02','12:55:00',3.58),('8537','2013-07-02','13:00:00',4.84),('8537','2013-07-02','13:05:00',3.38),('8537','2013-07-02','13:10:00',3.78),('8537','2013-07-02','13:15:00',5.05),('8537','2013-07-02','13:20:00',4.97),('8537','2013-07-02','13:25:00',5.04),('8537','2013-07-02','13:30:00',4.96),('8537','2013-07-02','13:35:00',4.86),('8537','2013-07-02','13:40:00',4.93),('8537','2013-07-02','13:45:00',4.77),('8537','2013-07-02','13:50:00',4.64),('8537','2013-07-02','13:55:00',4.72),('8537','2013-07-02','14:00:00',4.75),('8537','2013-07-02','14:05:00',4.7),('8537','2013-07-02','14:10:00',4.64),('8537','2013-07-02','14:15:00',4.69),('8537','2013-07-02','14:20:00',4.71),('8537','2013-07-02','14:25:00',4.61),('8537','2013-07-02','14:30:00',4.68),('8537','2013-07-02','14:35:00',4.66),('8537','2013-07-02','14:40:00',4.62),('8537','2013-07-02','14:45:00',4.56),('8537','2013-07-02','14:50:00',4.29),('8537','2013-07-02','14:55:00',4.28),('8537','2013-07-02','15:00:00',4.43),('8537','2013-07-02','15:05:00',4.39),('8537','2013-07-02','15:10:00',4.35),('8537','2013-07-02','15:15:00',4.3),('8537','2013-07-02','15:20:00',4.26),('8537','2013-07-02','15:25:00',4.23),('8537','2013-07-02','15:30:00',4.18),('8537','2013-07-02','15:35:00',4.15),('8537','2013-07-02','15:40:00',4.04),('8537','2013-07-02','15:45:00',3.94),('8537','2013-07-02','15:50:00',3.75),('8537','2013-07-02','15:55:00',3.87),('8537','2013-07-02','16:00:00',3.82),('8537','2013-07-02','16:05:00',3.75),('8537','2013-07-02','16:10:00',3.67),('8537','2013-07-02','16:15:00',3.59),('8537','2013-07-02','16:20:00',3.52),('8537','2013-07-02','16:25:00',3.46),('8537','2013-07-02','16:30:00',3.26),('8537','2013-07-02','16:35:00',2.93),('8537','2013-07-02','16:40:00',3.17),('8537','2013-07-02','16:45:00',3.09),('8537','2013-07-02','16:50:00',3.01),('8537','2013-07-02','16:55:00',2.94),('8537','2013-07-02','17:00:00',2.9),('8537','2013-07-02','17:05:00',2.8),('8537','2013-07-02','17:10:00',2.62),('8537','2013-07-02','17:15:00',2.59),('8537','2013-07-02','17:20:00',2.5),('8537','2013-07-02','17:25:00',2.39),('8537','2013-07-02','17:30:00',2.29),('8537','2013-07-02','17:35:00',2.15),('8537','2013-07-02','17:40:00',2.08),('8537','2013-07-02','17:45:00',1.98),('8537','2013-07-02','17:50:00',1.9),('8537','2013-07-02','17:55:00',1.77),('8537','2013-07-02','18:00:00',1.67),('8537','2013-07-02','18:05:00',1.55),('8537','2013-07-02','18:10:00',1.48),('8537','2013-07-02','18:15:00',1.4),('8537','2013-07-02','18:20:00',1.31),('8537','2013-07-02','18:25:00',1.2),('8537','2013-07-02','18:30:00',1.1),('8537','2013-07-02','18:35:00',1.02),('8537','2013-07-01','07:30:00',1.01),('8537','2013-07-01','07:35:00',1.11),('8537','2013-07-01','07:40:00',1.19),('8537','2013-07-01','07:45:00',1.29),('8537','2013-07-01','07:50:00',1.39),('8537','2013-07-01','07:55:00',1.5),('8537','2013-07-01','08:00:00',1.61),('8537','2013-07-01','08:05:00',1.69),('8537','2013-07-01','08:10:00',1.81),('8537','2013-07-01','08:15:00',1.92),('8537','2013-07-01','08:20:00',2.02),('8537','2013-07-01','08:25:00',2.13),('8537','2013-07-01','08:30:00',2.22),('8537','2013-07-01','08:35:00',2.32),('8537','2013-07-01','08:40:00',2.43),('8537','2013-07-01','08:45:00',2.53),('8537','2013-07-01','08:50:00',2.61),('8537','2013-07-01','08:55:00',2.7),('8537','2013-07-01','09:00:00',2.79),('8537','2013-07-01','09:05:00',2.87),('8537','2013-07-01','09:10:00',2.97),('8537','2013-07-01','09:15:00',3.08),('8537','2013-07-01','09:20:00',3.18),('8537','2013-07-01','09:25:00',3.27),('8537','2013-07-01','09:30:00',3.33),('8537','2013-07-01','09:35:00',3.41),('8537','2013-07-01','09:40:00',3.47),('8537','2013-07-01','09:45:00',3.5),('8537','2013-07-01','09:50:00',3.57),('8537','2013-07-01','09:55:00',3.63),('8537','2013-07-01','10:00:00',3.71),('8537','2013-07-01','10:05:00',3.79),('8537','2013-07-01','10:10:00',3.88),('8537','2013-07-01','10:15:00',3.95),('8537','2013-07-01','10:20:00',4.04),('8537','2013-07-01','10:25:00',4.1),('8537','2013-07-01','10:30:00',4.14),('8537','2013-07-01','10:35:00',4.19),('8537','2013-07-01','10:40:00',4.3),('8537','2013-07-01','10:45:00',4.35),('8537','2013-07-01','10:50:00',4.39),('8537','2013-07-01','10:55:00',4.39),('8537','2013-07-01','11:00:00',4.42),('8537','2013-07-01','11:05:00',4.53),('8537','2013-07-01','11:10:00',4.6),('8537','2013-07-01','11:15:00',4.68),('8537','2013-07-01','11:20:00',4.65),('8537','2013-07-01','11:25:00',4.66),('8537','2013-07-01','11:30:00',4.75),('8537','2013-07-01','11:35:00',4.83),('8537','2013-07-01','11:40:00',4.83),('8537','2013-07-01','11:45:00',4.83),('8537','2013-07-01','11:50:00',4.82),('8537','2013-07-01','11:55:00',4.9),('8537','2013-07-01','12:00:00',4.86),('8537','2013-07-01','12:05:00',4.83),('8537','2013-07-01','12:10:00',4.84),('8537','2013-07-01','12:15:00',4.83),('8537','2013-07-01','12:20:00',4.89),('8537','2013-07-01','12:25:00',4.94),('8537','2013-07-01','12:30:00',4.91),('8537','2013-07-01','12:35:00',4.92),('8537','2013-07-01','12:40:00',4.91),('8537','2013-07-01','12:45:00',4.9),('8537','2013-07-01','12:50:00',4.89),('8537','2013-07-01','12:55:00',4.95),('8537','2013-07-01','13:00:00',5.02),('8537','2013-07-01','13:05:00',4.99),('8537','2013-07-01','13:10:00',5.02),('8537','2013-07-01','13:15:00',5),('8537','2013-07-01','13:20:00',5.03),('8537','2013-07-01','13:25:00',5.05),('8537','2013-07-01','13:30:00',5.05),('8537','2013-07-01','13:35:00',4.98),('8537','2013-07-01','13:40:00',4.98),('8537','2013-07-01','13:45:00',4.92),('8537','2013-07-01','13:50:00',4.89),('8537','2013-07-01','13:55:00',4.92),('8537','2013-07-01','14:00:00',4.88),('8537','2013-07-01','14:05:00',4.89),('8537','2013-07-01','14:10:00',4.83),('8537','2013-07-01','14:15:00',4.86),('8537','2013-07-01','14:20:00',4.8),('8537','2013-07-01','14:25:00',4.77),('8537','2013-07-01','14:30:00',4.72),('8537','2013-07-01','14:35:00',4.7),('8537','2013-07-01','14:40:00',4.67),('8537','2013-07-01','14:45:00',4.6),('8537','2013-07-01','14:50:00',4.32),('8537','2013-07-01','14:55:00',4.25),('8537','2013-07-01','15:00:00',4.42),('8537','2013-07-01','15:05:00',4.32),('8537','2013-07-01','15:10:00',4.33),('8537','2013-07-01','15:15:00',4.31),('8537','2013-07-01','15:20:00',4.26),('8537','2013-07-01','15:25:00',4.2),('8537','2013-07-01','15:30:00',4.15),('8537','2013-07-01','15:35:00',4.06),('8537','2013-07-01','15:40:00',3.99),('8537','2013-07-01','15:45:00',3.96),('8537','2013-07-01','15:50:00',3.87),('8537','2013-07-01','15:55:00',3.8),('8537','2013-07-01','16:00:00',3.75),('8537','2013-07-01','16:05:00',3.71),('8537','2013-07-01','16:10:00',3.64),('8537','2013-07-01','16:15:00',3.54),('8537','2013-07-01','16:20:00',3.46),('8537','2013-07-01','16:25:00',3.39),('8537','2013-07-01','16:30:00',3.2),('8537','2013-07-01','16:35:00',2.9),('8537','2013-07-01','16:40:00',3.14),('8537','2013-07-01','16:45:00',3.07),('8537','2013-07-01','16:50:00',3),('8537','2013-07-01','16:55:00',2.94),('8537','2013-07-01','17:00:00',2.87),('8537','2013-07-01','17:05:00',2.78),('8537','2013-07-01','17:10:00',2.55),('8537','2013-07-01','17:15:00',2.58),('8537','2013-07-01','17:20:00',2.47),('8537','2013-07-01','17:25:00',2.38),('8537','2013-07-01','17:30:00',2.26),('8537','2013-07-01','17:35:00',2.09),('8537','2013-07-01','17:40:00',2.05),('8537','2013-07-01','17:45:00',1.98),('8537','2013-07-01','17:50:00',1.9),('8537','2013-07-01','17:55:00',1.78),('8537','2013-07-01','18:00:00',1.57),('8537','2013-07-01','18:05:00',1.53),('8537','2013-07-01','18:10:00',1.48),('8537','2013-07-01','18:15:00',1.2),('8537','2013-07-01','18:20:00',1.2),('8537','2013-07-01','18:25:00',1.26),('8537','2013-07-01','18:30:00',1.16),('8537','2013-07-01','18:35:00',1.06),('8537','2014-04-05','09:10:00',1.05),('8537','2014-04-05','09:15:00',1.42),('8537','2014-04-05','09:20:00',1.87),('8537','2014-04-05','09:25:00',2.94),('8537','2014-04-05','09:30:00',4.18),('8537','2014-04-05','09:35:00',4.05),('8537','2014-04-05','09:40:00',3.99),('8537','2014-04-05','09:45:00',2.93),('8537','2014-04-05','09:50:00',1.86),('8537','2014-04-05','09:55:00',2.93),('8537','2014-04-05','10:00:00',2.81),('8537','2014-04-05','10:05:00',2.62),('8537','2014-04-05','10:10:00',2.72),('8537','2014-04-05','10:15:00',1.97),('8537','2014-04-05','10:20:00',2.64),('8537','2014-04-05','10:25:00',3.25),('8537','2014-04-05','10:30:00',3.21),('8537','2014-04-05','10:35:00',3.69),('8537','2014-04-05','10:40:00',3.84),('8537','2014-04-05','10:45:00',3.66),('8537','2014-04-05','10:50:00',3.23),('8537','2014-04-05','10:55:00',3.6),('8537','2014-04-05','11:00:00',4.3),('8537','2014-04-05','11:05:00',4.46),('8537','2014-04-05','11:10:00',4.8),('8537','2014-04-05','11:15:00',5.04),('8537','2014-04-05','11:20:00',5.06),('8537','2014-04-05','11:25:00',3.46),('8537','2014-04-05','11:30:00',2.64),('8537','2014-04-05','11:35:00',3.24),('8537','2014-04-05','11:40:00',4.27),('8537','2014-04-05','11:45:00',4.91),('8537','2014-04-05','11:50:00',5.25),('8537','2014-04-05','11:55:00',5.08),('8537','2014-04-05','12:00:00',3.85),('8537','2014-04-05','12:05:00',3.76),('8537','2014-04-05','12:10:00',3.78),('8537','2014-04-05','12:15:00',4.02),('8537','2014-04-05','12:20:00',4.42),('8537','2014-04-05','12:25:00',3.5),('8537','2014-04-05','12:30:00',3.19),('8537','2014-04-05','12:35:00',2.79),('8537','2014-04-05','12:40:00',4.68),('8537','2014-04-05','12:45:00',5.75),('8537','2014-04-05','12:50:00',5.85),('8537','2014-04-05','12:55:00',4.6),('8537','2014-04-05','13:00:00',4.83),('8537','2014-04-05','13:05:00',3.89),('8537','2014-04-05','13:10:00',4.66),('8537','2014-04-05','13:15:00',2.48),('8537','2014-04-05','13:20:00',4.85),('8537','2014-04-05','13:25:00',4.67),('8537','2014-04-05','13:30:00',4.9),('8537','2014-04-05','13:35:00',5.84),('8537','2014-04-05','13:40:00',4.59),('8537','2014-04-05','13:45:00',3.55),('8537','2014-04-05','13:50:00',4.83),('8537','2014-04-05','13:55:00',5),('8537','2014-04-05','14:00:00',4.41),('8537','2014-04-05','14:05:00',5.96),('8537','2014-04-05','14:10:00',3.15),('8537','2014-04-05','14:15:00',1.01),('8537','2014-04-05','14:20:00',1.14),('8537','2014-04-05','14:25:00',2.04),('8537','2014-04-05','14:30:00',2.03),('8537','2014-04-05','14:35:00',1.14),('8537','2014-04-05','14:50:00',1.85),('8537','2014-04-05','14:55:00',4.11),('8537','2014-04-05','15:00:00',4.23),('8537','2014-04-05','15:05:00',3.99),('8537','2014-04-05','15:10:00',2.71),('8537','2014-04-05','15:15:00',2.78),('8537','2014-04-05','15:20:00',5.02),('8537','2014-04-05','15:25:00',3.13),('8537','2014-04-05','15:30:00',1.7),('8537','2014-04-05','15:35:00',1.8),('8537','2014-04-05','15:40:00',2.58),('8537','2014-04-05','15:45:00',1.8),('8537','2014-04-05','15:50:00',1.98),('8537','2014-04-05','15:55:00',1.46),('8537','2014-04-05','16:00:00',1.52),('8537','2014-04-05','16:05:00',1.57),('8537','2014-04-05','16:10:00',1.5),('8537','2014-04-05','16:15:00',2.87),('8537','2014-04-05','16:20:00',3.86),('8537','2014-04-05','16:25:00',3.32),('8537','2014-04-05','16:30:00',2.03),('8537','2014-04-05','16:35:00',2.46),('8537','2014-04-05','16:40:00',1.82),('8537','2014-04-05','16:45:00',2.26),('8537','2014-04-05','16:50:00',1.77),('8537','2014-04-05','16:55:00',2.05),('8537','2014-04-05','17:00:00',2.1),('8537','2014-04-05','17:05:00',2.29),('8537','2014-04-05','17:10:00',2.01),('8537','2014-04-05','17:15:00',1.48),('8537','2014-04-05','17:20:00',1.47),('8537','2014-04-05','17:25:00',1.48),('8537','2014-04-05','17:30:00',1.39),('8537','2014-04-05','17:35:00',1.18),('8537','2014-04-05','17:40:00',1.17),('8537','2014-04-05','17:50:00',1.11),('8537','2014-04-05','17:55:00',1.19),('8537','2014-04-05','18:00:00',1.17),('8537','2014-04-05','18:05:00',1.07),('8537','2014-04-05','18:10:00',1.01),('8537','2013-06-30','07:30:00',1.05),('8537','2013-06-30','07:35:00',1.16),('8537','2013-06-30','07:40:00',1.26),('8537','2013-06-30','07:45:00',1.36),('8537','2013-06-30','07:50:00',1.47),('8537','2013-06-30','07:55:00',1.58),('8537','2013-06-30','08:00:00',1.69),('8537','2013-06-30','08:05:00',1.8),('8537','2013-06-30','08:10:00',1.9),('8537','2013-06-30','08:15:00',2),('8537','2013-06-30','08:20:00',2.1),('8537','2013-06-30','08:25:00',2.21),('8537','2013-06-30','08:30:00',2.32),('8537','2013-06-30','08:35:00',2.42),('8537','2013-06-30','08:40:00',2.52),('8537','2013-06-30','08:45:00',2.62),('8537','2013-06-30','08:50:00',2.7),('8537','2013-06-30','08:55:00',2.8),('8537','2013-06-30','09:00:00',2.89),('8537','2013-06-30','09:05:00',2.98),('8537','2013-06-30','09:10:00',3.08),('8537','2013-06-30','09:15:00',3.16),('8537','2013-06-30','09:20:00',3.24),('8537','2013-06-30','09:25:00',3.32),('8537','2013-06-30','09:30:00',3.42),('8537','2013-06-30','09:35:00',3.5),('8537','2013-06-30','09:40:00',3.55),('8537','2013-06-30','09:45:00',3.63),('8537','2013-06-30','09:50:00',3.72),('8537','2013-06-30','09:55:00',3.79),('8537','2013-06-30','10:00:00',3.85),('8537','2013-06-30','10:05:00',3.91),('8537','2013-06-30','10:10:00',4),('8537','2013-06-30','10:15:00',4.07),('8537','2013-06-30','10:20:00',4.15),('8537','2013-06-30','10:25:00',4.17),('8537','2013-06-30','10:30:00',4.19),('8537','2013-06-30','10:35:00',4.27),('8537','2013-06-30','10:40:00',4.36),('8537','2013-06-30','10:45:00',4.4),('8537','2013-06-30','10:50:00',4.4),('8537','2013-06-30','10:55:00',4.46),('8537','2013-06-30','11:00:00',4.53),('8537','2013-06-30','11:05:00',4.52),('8537','2013-06-30','11:10:00',4.59),('8537','2013-06-30','11:15:00',4.62),('8537','2013-06-30','11:20:00',4.67),('8537','2013-06-30','11:25:00',4.67),('8537','2013-06-30','11:30:00',4.75),('8537','2013-06-30','11:35:00',4.76),('8537','2013-06-30','11:40:00',4.78),('8537','2013-06-30','11:45:00',4.76),('8537','2013-06-30','11:50:00',4.75),('8537','2013-06-30','11:55:00',4.77),('8537','2013-06-30','12:00:00',4.82),('8537','2013-06-30','12:05:00',4.92),('8537','2013-06-30','12:10:00',4.96),('8537','2013-06-30','12:15:00',4.97),('8537','2013-06-30','12:20:00',4.98),('8537','2013-06-30','12:25:00',4.98),('8537','2013-06-30','12:30:00',4.99),('8537','2013-06-30','12:35:00',5.03),('8537','2013-06-30','12:40:00',4.99),('8537','2013-06-30','12:45:00',5.11),('8537','2013-06-30','12:50:00',5.2),('8537','2013-06-30','12:55:00',5.16),('8537','2013-06-30','13:00:00',5.13),('8537','2013-06-30','13:05:00',5.09),('8537','2013-06-30','13:10:00',5.02),('8537','2013-06-30','13:15:00',5.09),('8537','2013-06-30','13:20:00',5.15),('8537','2013-06-30','13:25:00',5.22),('8537','2013-06-30','13:30:00',5.16),('8537','2013-06-30','13:35:00',5.1),('8537','2013-06-30','13:40:00',5.08),('8537','2013-06-30','13:45:00',5.13),('8537','2013-06-30','13:50:00',5.15),('8537','2013-06-30','13:55:00',4.37),('8537','2013-06-30','14:00:00',5.05),('8537','2013-06-30','14:05:00',5.07),('8537','2013-06-30','14:10:00',5.03),('8537','2013-06-30','14:15:00',4.9),('8537','2013-06-30','14:20:00',4.84),('8537','2013-06-30','14:25:00',4.77),('8537','2013-06-30','14:30:00',4.75),('8537','2013-06-30','14:35:00',4.77),('8537','2013-06-30','14:40:00',4.82),('8537','2013-06-30','14:45:00',4.76),('8537','2013-06-30','14:50:00',4.47),('8537','2013-06-30','14:55:00',4.52),('8537','2013-06-30','15:00:00',4.6),('8537','2013-06-30','15:05:00',4.49),('8537','2013-06-30','15:10:00',4.5),('8537','2013-06-30','15:15:00',4.46),('8537','2013-06-30','15:20:00',4.43),('8537','2013-06-30','15:25:00',4.36),('8537','2013-06-30','15:30:00',4.31),('8537','2013-06-30','15:35:00',4.28),('8537','2013-06-30','15:40:00',4.23),('8537','2013-06-30','15:45:00',4.09),('8537','2013-06-30','15:50:00',3.9),('8537','2013-06-30','15:55:00',4.01),('8537','2013-06-30','16:00:00',3.95),('8537','2013-06-30','16:05:00',3.88),('8537','2013-06-30','16:10:00',3.83),('8537','2013-06-30','16:15:00',3.8),('8537','2013-06-30','16:20:00',3.8),('8537','2013-06-30','16:25:00',3.86),('8537','2013-06-30','16:30:00',3.7),('8537','2013-06-30','16:35:00',3.21),('8537','2013-06-30','16:40:00',3.25),('8537','2013-06-30','16:45:00',3.21),('8537','2013-06-30','16:50:00',3.14),('8537','2013-06-30','16:55:00',3.01),('8537','2013-06-30','17:00:00',2.9),('8537','2013-06-30','17:05:00',2.83),('8537','2013-06-30','17:10:00',2.76),('8537','2013-06-30','17:15:00',2.65),('8537','2013-06-30','17:20:00',2.55),('8537','2013-06-30','17:25:00',2.43),('8537','2013-06-30','17:30:00',2.29),('8537','2013-06-30','17:35:00',2.11),('8537','2013-06-30','17:40:00',2.1),('8537','2013-06-30','17:45:00',1.99),('8537','2013-06-30','17:50:00',1.92),('8537','2013-06-30','17:55:00',1.78),('8537','2013-06-30','18:00:00',1.71),('8537','2013-06-30','18:05:00',1.55),('8537','2013-06-30','18:10:00',1.5),('8537','2013-06-30','18:15:00',1.43),('8537','2013-06-30','18:20:00',1.34),('8537','2013-06-30','18:25:00',1.24),('8537','2013-06-30','18:30:00',1.13),('8537','2013-06-30','18:35:00',1.04),('8537','2013-06-29','07:30:00',1.27),('8537','2013-06-29','07:35:00',1.55),('8537','2013-06-29','07:40:00',1.63),('8537','2013-06-29','07:45:00',1.63),('8537','2013-06-29','07:50:00',1.75),('8537','2013-06-29','07:55:00',1.89),('8537','2013-06-29','08:00:00',2.19),('8537','2013-06-29','08:05:00',2.39),('8537','2013-06-29','08:10:00',2.49),('8537','2013-06-29','08:15:00',2.21),('8537','2013-06-29','08:20:00',1.46),('8537','2013-06-29','08:25:00',2.31),('8537','2013-06-29','08:30:00',2.48),('8537','2013-06-29','08:35:00',2.55),('8537','2013-06-29','08:40:00',1.57),('8537','2013-06-29','08:45:00',2.39),('8537','2013-06-29','08:50:00',2.73),('8537','2013-06-29','08:55:00',2.81),('8537','2013-06-29','09:00:00',2.86),('8537','2013-06-29','09:05:00',2.95),('8537','2013-06-29','09:10:00',3.04),('8537','2013-06-29','09:15:00',3.13),('8537','2013-06-29','09:20:00',3.21),('8537','2013-06-29','09:25:00',3.27),('8537','2013-06-29','09:30:00',3.29),('8537','2013-06-29','09:35:00',3.43),('8537','2013-06-29','09:40:00',3.55),('8537','2013-06-29','09:45:00',3.61),('8537','2013-06-29','09:50:00',3.69),('8537','2013-06-29','09:55:00',3.76),('8537','2013-06-29','10:00:00',3.81),('8537','2013-06-29','10:05:00',3.89),('8537','2013-06-29','10:10:00',3.99),('8537','2013-06-29','10:15:00',4.03),('8537','2013-06-29','10:20:00',4.03),('8537','2013-06-29','10:25:00',4.14),('8537','2013-06-29','10:30:00',4.19),('8537','2013-06-29','10:35:00',4.26),('8537','2013-06-29','10:40:00',4.31),('8537','2013-06-29','10:45:00',4.33),('8537','2013-06-29','10:50:00',4.46),('8537','2013-06-29','10:55:00',4.53),('8537','2013-06-29','11:00:00',4.45),('8537','2013-06-29','11:05:00',4.65),('8537','2013-06-29','11:10:00',4.73),('8537','2013-06-29','11:15:00',4.8),('8537','2013-06-29','11:20:00',3.49),('8537','2013-06-29','11:25:00',5.16),('8537','2013-06-29','11:30:00',5.2),('8537','2013-06-29','11:35:00',3.57),('8537','2013-06-29','11:40:00',5.26),('8537','2013-06-29','11:45:00',2.05),('8537','2013-06-29','11:50:00',3.07),('8537','2013-06-29','11:55:00',5.5),('8537','2013-06-29','12:00:00',3.41),('8537','2013-06-29','12:05:00',5.22),('8537','2013-06-29','12:10:00',5.32),('8537','2013-06-29','12:15:00',4.31),('8537','2013-06-29','12:20:00',1.26),('8537','2013-06-29','12:25:00',4.43),('8537','2013-06-29','12:30:00',5.45),('8537','2013-06-29','12:35:00',5.41),('8537','2013-06-29','12:40:00',5.42),('8537','2013-06-29','12:45:00',5.72),('8537','2013-06-29','12:50:00',2.59),('8537','2013-06-29','12:55:00',4.14),('8537','2013-06-29','13:00:00',4.4),('8537','2013-06-29','13:05:00',4.05),('8537','2013-06-29','13:10:00',5.68),('8537','2013-06-29','13:15:00',4.6),('8537','2013-06-29','13:20:00',2.31),('8537','2013-06-29','13:25:00',4.79),('8537','2013-06-29','13:30:00',2.82),('8537','2013-06-29','13:35:00',1.06),('8537','2013-06-29','13:40:00',1.09),('8537','2013-06-29','13:45:00',2.12),('8537','2013-06-29','13:50:00',3.08),('8537','2013-06-29','13:55:00',3.69),('8537','2013-06-29','14:00:00',5.32),('8537','2013-06-29','14:05:00',3.9),('8537','2013-06-29','14:10:00',5.45),('8537','2013-06-29','14:15:00',5.62),('8537','2013-06-29','14:20:00',5),('8537','2013-06-29','14:25:00',3.55),('8537','2013-06-29','14:30:00',5.71),('8537','2013-06-29','14:35:00',5.38),('8537','2013-06-29','14:40:00',5.38),('8537','2013-06-29','14:45:00',5.41),('8537','2013-06-29','14:50:00',4.85),('8537','2013-06-29','14:55:00',1.54),('8537','2013-06-29','15:00:00',3.07),('8537','2013-06-29','15:05:00',3.36),('8537','2013-06-29','15:10:00',2.08),('8537','2013-06-29','15:15:00',1.88),('8537','2013-06-29','15:20:00',1.2),('8537','2013-06-29','16:40:00',1.37),('8537','2013-06-29','16:45:00',1.79),('8537','2013-06-29','16:50:00',2.56),('8537','2013-06-29','16:55:00',1.62),('8537','2013-06-29','17:00:00',1.12),('8537','2013-06-29','17:05:00',1.36),('8537','2013-06-29','17:10:00',1.23),('8537','2013-06-29','17:15:00',1.15),('8537','2013-06-29','17:20:00',1.3),('8537','2013-06-29','17:25:00',1.52),('8537','2013-06-29','17:30:00',2.29),('8537','2013-06-29','17:35:00',2.05),('8537','2013-06-29','17:45:00',1.98),('8537','2013-06-29','17:50:00',2.04),('8537','2013-06-29','17:55:00',1.89),('8537','2013-06-29','18:00:00',1.77),('8537','2013-06-29','18:05:00',1.64),('8537','2013-06-29','18:10:00',1.5),('8537','2013-06-29','18:15:00',1.47),('8537','2013-06-29','18:20:00',1.35),('8537','2013-06-29','18:25:00',1.26),('8537','2013-06-29','18:30:00',1.03),('8537','2013-06-29','18:35:00',1.12),('8537','2013-06-29','18:40:00',1.12),('8537','2013-06-28','07:25:00',1),('8537','2013-06-28','07:30:00',1.12),('8537','2013-06-28','07:35:00',1.19),('8537','2013-06-28','07:40:00',1.24),('8537','2013-06-28','07:45:00',1.44),('8537','2013-06-28','07:50:00',1.5),('8537','2013-06-28','07:55:00',1.6),('8537','2013-06-28','08:00:00',1.69),('8537','2013-06-28','08:05:00',1.7),('8537','2013-06-28','08:10:00',1.78),('8537','2013-06-28','08:15:00',1.97),('8537','2013-06-28','08:20:00',2.07),('8537','2013-06-28','08:25:00',2.04),('8537','2013-06-28','08:30:00',2.25),('8537','2013-06-28','08:35:00',2.39),('8537','2013-06-28','08:40:00',2.5),('8537','2013-06-28','08:45:00',2.57),('8537','2013-06-28','08:50:00',2.65),('8537','2013-06-28','08:55:00',2.75),('8537','2013-06-28','09:00:00',2.82),('8537','2013-06-28','09:05:00',2.94),('8537','2013-06-28','09:10:00',3.18),('8537','2013-06-28','09:15:00',2.21),('8537','2013-06-28','09:20:00',1.23),('8537','2013-06-28','09:25:00',1.28),('8537','2013-06-28','09:30:00',3.38),('8537','2013-06-28','09:35:00',3.62),('8537','2013-06-28','09:40:00',3.57),('8537','2013-06-28','09:45:00',3.55),('8537','2013-06-28','09:50:00',3),('8537','2013-06-28','09:55:00',4.25),('8537','2013-06-28','10:00:00',2.64),('8537','2013-06-28','10:05:00',3.99),('8537','2013-06-28','10:10:00',4.12),('8537','2013-06-28','10:15:00',4.41),('8537','2013-06-28','10:20:00',3.89),('8537','2013-06-28','10:25:00',1.96),('8537','2013-06-28','10:30:00',1.57),('8537','2013-06-28','10:35:00',4.55),('8537','2013-06-28','10:40:00',4.73),('8537','2013-06-28','10:45:00',4.71),('8537','2013-06-28','10:50:00',4.07),('8537','2013-06-28','10:55:00',2.67),('8537','2013-06-28','11:00:00',3.13),('8537','2013-06-28','11:05:00',4.43),('8537','2013-06-28','11:10:00',3.03),('8537','2013-06-28','11:15:00',1.79),('8537','2013-06-28','11:20:00',1.45),('8537','2013-06-28','11:25:00',4.59),('8537','2013-06-28','11:30:00',5.22),('8537','2013-06-28','11:35:00',4.2),('8537','2013-06-28','11:40:00',3.77),('8537','2013-06-28','11:45:00',4.38),('8537','2013-06-28','11:50:00',5.42),('8537','2013-06-28','11:55:00',4.99),('8537','2013-06-28','12:00:00',3.34),('8537','2013-06-28','12:05:00',4.67),('8537','2013-06-28','12:10:00',4.6),('8537','2013-06-28','12:15:00',5.47),('8537','2013-06-28','12:20:00',5.33),('8537','2013-06-28','12:25:00',5.31),('8537','2013-06-28','12:30:00',5.02),('8537','2013-06-28','12:35:00',5.2),('8537','2013-06-28','12:40:00',4.19),('8537','2013-06-28','12:45:00',5.24),('8537','2013-06-28','12:50:00',4.2),('8537','2013-06-28','12:55:00',5.32),('8537','2013-06-28','13:00:00',4.34),('8537','2013-06-28','13:05:00',5.13),('8537','2013-06-28','13:10:00',5.41),('8537','2013-06-28','13:15:00',5.34),('8537','2013-06-28','13:20:00',3.98),('8537','2013-06-28','13:25:00',5.2),('8537','2013-06-28','13:30:00',5.28),('8537','2013-06-28','13:35:00',5.31),('8537','2013-06-28','13:40:00',4.58),('8537','2013-06-28','13:45:00',4.52),('8537','2013-06-28','13:50:00',4.2),('8537','2013-06-28','13:55:00',5.27),('8537','2013-06-28','14:00:00',4.7),('8537','2013-06-28','14:05:00',5.1),('8537','2013-06-28','14:10:00',4.38),('8537','2013-06-28','14:15:00',4.1),('8537','2013-06-28','14:20:00',5.14),('8537','2013-06-28','14:25:00',5.26),('8537','2013-06-28','14:30:00',4.87),('8537','2013-06-28','14:35:00',4.59),('8537','2013-06-28','14:40:00',3.15),('8537','2013-06-28','14:45:00',4.84),('8537','2013-06-28','14:50:00',5.03),('8537','2013-06-28','14:55:00',4.58),('8537','2013-06-28','15:00:00',4.33),('8537','2013-06-28','15:05:00',4.71),('8537','2013-06-28','15:10:00',4.1),('8537','2013-06-28','15:15:00',3.61),('8537','2013-06-28','15:20:00',2.38),('8537','2013-06-28','15:25:00',3.97),('8537','2013-06-28','15:30:00',3.01),('8537','2013-06-28','15:35:00',4.69),('8537','2013-06-28','15:40:00',2.34),('8537','2013-06-28','15:45:00',4.13),('8537','2013-06-28','15:50:00',4.56),('8537','2013-06-28','15:55:00',3.47),('8537','2013-06-28','16:00:00',3.81),('8537','2013-06-28','16:05:00',4.46),('8537','2013-06-28','16:10:00',3.56),('8537','2013-06-28','16:15:00',3.83),('8537','2013-06-28','16:20:00',2.81),('8537','2013-06-28','16:25:00',2.38),('8537','2013-06-28','16:30:00',2.02),('8537','2013-06-28','16:35:00',2.18),('8537','2013-06-28','16:40:00',2.75),('8537','2013-06-28','16:50:00',1.2),('8537','2013-06-28','16:55:00',1.88),('8537','2013-06-28','17:00:00',2.52),('8537','2013-06-28','17:05:00',2.87),('8537','2013-06-28','17:10:00',2.82),('8537','2013-06-28','17:15:00',2.69),('8537','2013-06-28','17:20:00',2.56),('8537','2013-06-28','17:25:00',2.54),('8537','2013-06-28','17:30:00',1.89),('8537','2013-06-28','17:35:00',2.26),('8537','2013-06-28','17:40:00',2.14),('8537','2013-06-28','17:45:00',2.07),('8537','2013-06-28','17:50:00',2),('8537','2013-06-28','17:55:00',1.86),('8537','2013-06-28','18:00:00',1.78),('8537','2013-06-28','18:05:00',1.64),('8537','2013-06-28','18:10:00',1.55),('8537','2013-06-28','18:15:00',1.15),('8537','2013-06-28','18:20:00',1.09),('8537','2013-06-28','18:25:00',1.03),('8537','2013-06-28','18:30:00',1.19),('8537','2013-06-27','07:30:00',1.05),('8537','2013-06-27','07:35:00',1.15),('8537','2013-06-27','07:40:00',1.26),('8537','2013-06-27','07:45:00',1.37),('8537','2013-06-27','07:50:00',1.5),('8537','2013-06-27','07:55:00',1.61),('8537','2013-06-27','08:00:00',1.71),('8537','2013-06-27','08:05:00',1.81),('8537','2013-06-27','08:10:00',1.93),('8537','2013-06-27','08:15:00',2.03),('8537','2013-06-27','08:20:00',2.12),('8537','2013-06-27','08:25:00',2.22),('8537','2013-06-27','08:30:00',2.3),('8537','2013-06-27','08:35:00',2.38),('8537','2013-06-27','08:40:00',2.47),('8537','2013-06-27','08:45:00',2.58),('8537','2013-06-27','08:50:00',2.66),('8537','2013-06-27','08:55:00',2.78),('8537','2013-06-27','09:00:00',2.9),('8537','2013-06-27','09:05:00',2.96),('8537','2013-06-27','09:10:00',3.05),('8537','2013-06-27','09:15:00',3.17),('8537','2013-06-27','09:20:00',3.29),('8537','2013-06-27','09:25:00',3.3),('8537','2013-06-27','09:30:00',3.43),('8537','2013-06-27','09:35:00',3.54),('8537','2013-06-27','09:40:00',3.58),('8537','2013-06-27','09:45:00',3.62),('8537','2013-06-27','09:50:00',3.76),('8537','2013-06-27','09:55:00',3.84),('8537','2013-06-27','10:00:00',3.96),('8537','2013-06-27','10:05:00',4.17),('8537','2013-06-27','10:10:00',4.1),('8537','2013-06-27','10:15:00',3.79),('8537','2013-06-27','10:20:00',3.73),('8537','2013-06-27','10:25:00',4.26),('8537','2013-06-27','10:30:00',4.33),('8537','2013-06-27','10:35:00',4.43),('8537','2013-06-27','10:40:00',4.56),('8537','2013-06-27','10:45:00',4.67),('8537','2013-06-27','10:50:00',4.69),('8537','2013-06-27','10:55:00',4.71),('8537','2013-06-27','11:00:00',4.74),('8537','2013-06-27','11:05:00',4.84),('8537','2013-06-27','11:10:00',4.74),('8537','2013-06-27','11:15:00',4.94),('8537','2013-06-27','11:20:00',4.92),('8537','2013-06-27','11:25:00',4.9),('8537','2013-06-27','11:30:00',4.95),('8537','2013-06-27','11:35:00',5.06),('8537','2013-06-27','11:40:00',4.73),('8537','2013-06-27','11:45:00',2.12),('8537','2013-06-27','11:50:00',1.5),('8537','2013-06-27','11:55:00',1.59),('8537','2013-06-27','12:00:00',1.71),('8537','2013-06-27','12:05:00',1.59),('8537','2013-06-27','12:10:00',1.63),('8537','2013-06-27','12:15:00',1.38),('8537','2013-06-27','12:20:00',1.43),('8537','2013-06-27','12:25:00',1.76),('8537','2013-06-27','12:30:00',2.14),('8537','2013-06-27','12:35:00',5.35),('8537','2013-06-27','12:40:00',2.31),('8537','2013-06-27','12:45:00',2),('8537','2013-06-27','12:50:00',1.66),('8537','2013-06-27','12:55:00',1.61),('8537','2013-06-27','13:00:00',1.15),('8537','2013-06-27','13:05:00',1.26),('8537','2013-06-27','13:10:00',1.6),('8537','2013-06-27','13:15:00',2.35),('8537','2013-06-27','13:20:00',2.08),('8537','2013-06-27','13:25:00',1.98),('8537','2013-06-27','13:30:00',1.72),('8537','2013-06-27','13:35:00',2.2),('8537','2013-06-27','13:40:00',1.44),('8537','2013-06-27','13:45:00',1.37),('8537','2013-06-27','13:50:00',1.49),('8537','2013-06-27','13:55:00',1.49),('8537','2013-06-27','14:00:00',1.6),('8537','2013-06-27','14:05:00',1.58),('8537','2013-06-27','14:10:00',1.88),('8537','2013-06-27','14:15:00',3.67),('8537','2013-06-27','14:20:00',2.07),('8537','2013-06-27','14:25:00',3.72),('8537','2013-06-27','14:30:00',5.34),('8537','2013-06-27','14:35:00',4.7),('8537','2013-06-27','14:40:00',3.66),('8537','2013-06-27','14:45:00',1.78),('8537','2013-06-27','14:50:00',3.24),('8537','2013-06-27','14:55:00',4.11),('8537','2013-06-27','15:00:00',4.58),('8537','2013-06-27','15:05:00',4.48),('8537','2013-06-27','15:10:00',4.39),('8537','2013-06-27','15:15:00',4.33),('8537','2013-06-27','15:20:00',4.3),('8537','2013-06-27','15:25:00',4.32),('8537','2013-06-27','15:30:00',4.27),('8537','2013-06-27','15:35:00',4.22),('8537','2013-06-27','15:40:00',4.17),('8537','2013-06-27','15:45:00',4.03),('8537','2013-06-27','15:50:00',3.86),('8537','2013-06-27','15:55:00',3.9),('8537','2013-06-27','16:00:00',3.78),('8537','2013-06-27','16:05:00',3.7),('8537','2013-06-27','16:10:00',3.66),('8537','2013-06-27','16:15:00',3.61),('8537','2013-06-27','16:20:00',3.56),('8537','2013-06-27','16:25:00',3.49),('8537','2013-06-27','16:30:00',3.32),('8537','2013-06-27','16:35:00',2.88),('8537','2013-06-27','16:40:00',3.12),('8537','2013-06-27','16:45:00',3.14),('8537','2013-06-27','16:50:00',3.06),('8537','2013-06-27','16:55:00',2.96),('8537','2013-06-27','17:00:00',2.89),('8537','2013-06-27','17:05:00',2.79),('8537','2013-06-27','17:10:00',2.48),('8537','2013-06-27','17:15:00',2.46),('8537','2013-06-27','17:20:00',2.52),('8537','2013-06-27','17:25:00',2.46),('8537','2013-06-27','17:30:00',2.35),('8537','2013-06-27','17:35:00',2.2),('8537','2013-06-27','17:40:00',1.35),('8537','2013-06-27','17:50:00',1.46),('8537','2013-06-27','17:55:00',1.43),('8537','2013-06-27','18:00:00',1.65),('8537','2013-06-27','18:05:00',1.56),('8537','2013-06-27','18:10:00',1.47),('8537','2013-06-27','18:15:00',1.37),('8537','2013-06-27','18:20:00',1.3),('8537','2013-06-27','18:25:00',1.27),('8537','2013-06-27','18:30:00',1.15),('8537','2013-06-27','18:35:00',1.07),('8537','2013-06-26','07:30:00',1.08),('8537','2013-06-26','07:35:00',1.19),('8537','2013-06-26','07:40:00',1.3),('8537','2013-06-26','07:45:00',1.41),('8537','2013-06-26','07:50:00',1.52),('8537','2013-06-26','07:55:00',1.62),('8537','2013-06-26','08:00:00',1.68),('8537','2013-06-26','08:05:00',1.8),('8537','2013-06-26','08:10:00',1.92),('8537','2013-06-26','08:15:00',2.01),('8537','2013-06-26','08:20:00',2.1),('8537','2013-06-26','08:25:00',2.2),('8537','2013-06-26','08:30:00',2.29),('8537','2013-06-26','08:35:00',2.36),('8537','2013-06-26','08:40:00',2.47),('8537','2013-06-26','08:45:00',2.56),('8537','2013-06-26','08:50:00',2.64),('8537','2013-06-26','08:55:00',2.73),('8537','2013-06-26','09:00:00',2.82),('8537','2013-06-26','09:05:00',2.9),('8537','2013-06-26','09:10:00',2.97),('8537','2013-06-26','09:15:00',3.07),('8537','2013-06-26','09:20:00',3.14),('8537','2013-06-26','09:25:00',3.23),('8537','2013-06-26','09:30:00',3.3),('8537','2013-06-26','09:35:00',3.39),('8537','2013-06-26','09:40:00',3.47),('8537','2013-06-26','09:45:00',3.54),('8537','2013-06-26','09:50:00',3.59),('8537','2013-06-26','09:55:00',3.64),('8537','2013-06-26','10:00:00',3.73),('8537','2013-06-26','10:05:00',3.84),('8537','2013-06-26','10:10:00',3.9),('8537','2013-06-26','10:15:00',3.99),('8537','2013-06-26','10:20:00',3.97),('8537','2013-06-26','10:25:00',4.03),('8537','2013-06-26','10:30:00',4.06),('8537','2013-06-26','10:35:00',4.15),('8537','2013-06-26','10:40:00',4.22),('8537','2013-06-26','10:45:00',4.27),('8537','2013-06-26','10:50:00',4.31),('8537','2013-06-26','10:55:00',4.35),('8537','2013-06-26','11:00:00',4.45),('8537','2013-06-26','11:05:00',4.46),('8537','2013-06-26','11:10:00',4.49),('8537','2013-06-26','11:15:00',4.53),('8537','2013-06-26','11:20:00',4.54),('8537','2013-06-26','11:25:00',4.55),('8537','2013-06-26','11:30:00',4.57),('8537','2013-06-26','11:35:00',4.59),('8537','2013-06-26','11:40:00',4.63),('8537','2013-06-26','11:45:00',4.71),('8537','2013-06-26','11:50:00',4.79),('8537','2013-06-26','11:55:00',4.83),('8537','2013-06-26','12:00:00',4.89),('8537','2013-06-26','12:05:00',4.75),('8537','2013-06-26','12:10:00',4.84),('8537','2013-06-26','12:15:00',4.91),('8537','2013-06-26','12:20:00',4.79),('8537','2013-06-26','12:25:00',4.83),('8537','2013-06-26','12:30:00',4.82),('8537','2013-06-26','12:35:00',4.97),('8537','2013-06-26','12:40:00',5.03),('8537','2013-06-26','12:45:00',5.05),('8537','2013-06-26','12:50:00',4.89),('8537','2013-06-26','12:55:00',2.24),('8537','2013-06-26','13:00:00',1.04),('8537','2013-06-26','13:05:00',1.17),('8537','2013-06-26','13:10:00',1.6),('8537','2013-06-26','13:15:00',3.8),('8537','2013-06-26','13:20:00',5.48),('8537','2013-06-26','13:25:00',5.02),('8537','2013-06-26','13:30:00',1.49),('8537','2013-06-26','13:35:00',1.18),('8537','2013-06-26','13:40:00',1.21),('8537','2013-06-26','13:45:00',2.19),('8537','2013-06-26','13:50:00',1.47),('8537','2013-06-26','13:55:00',2.85),('8537','2013-06-26','14:00:00',4.81),('8537','2013-06-26','14:05:00',3.05),('8537','2013-06-26','14:10:00',1.38),('8537','2013-06-26','14:15:00',5.3),('8537','2013-06-26','14:20:00',5.16),('8537','2013-06-26','14:25:00',4.07),('8537','2013-06-26','14:30:00',4.71),('8537','2013-06-26','14:35:00',3.76),('8537','2013-06-26','14:40:00',1.27),('8537','2013-06-26','14:45:00',3.8),('8537','2013-06-26','14:50:00',4.63),('8537','2013-06-26','14:55:00',4.4),('8537','2013-06-26','15:00:00',4.59),('8537','2013-06-26','15:05:00',4.53),('8537','2013-06-26','15:10:00',4.43),('8537','2013-06-26','15:15:00',4.35),('8537','2013-06-26','15:20:00',4.34),('8537','2013-06-26','15:25:00',4.28),('8537','2013-06-26','15:30:00',4.25),('8537','2013-06-26','15:35:00',4.27),('8537','2013-06-26','15:40:00',4.16),('8537','2013-06-26','15:45:00',4),('8537','2013-06-26','15:50:00',3.4),('8537','2013-06-26','15:55:00',3.55),('8537','2013-06-26','16:00:00',3.91),('8537','2013-06-26','16:05:00',3.81),('8537','2013-06-26','16:10:00',3.75),('8537','2013-06-26','16:15:00',3.7),('8537','2013-06-26','16:20:00',3.63),('8537','2013-06-26','16:25:00',3.49),('8537','2013-06-26','16:30:00',3.36),('8537','2013-06-26','16:35:00',3.05),('8537','2013-06-26','16:40:00',3.22),('8537','2013-06-26','16:45:00',3.16),('8537','2013-06-26','16:50:00',3.09),('8537','2013-06-26','16:55:00',3),('8537','2013-06-26','17:00:00',2.95),('8537','2013-06-26','17:05:00',2.88),('8537','2013-06-26','17:10:00',2.76),('8537','2013-06-26','17:15:00',2.64),('8537','2013-06-26','17:20:00',2.55),('8537','2013-06-26','17:25:00',2.45),('8537','2013-06-26','17:30:00',2.33),('8537','2013-06-26','17:35:00',2.19),('8537','2013-06-26','17:40:00',2.11),('8537','2013-06-26','17:45:00',2.02),('8537','2013-06-26','17:50:00',1.93),('8537','2013-06-26','17:55:00',1.81),('8537','2013-06-26','18:00:00',1.74),('8537','2013-06-26','18:05:00',1.7),('8537','2013-06-26','18:10:00',1.85),('8537','2013-06-25','07:30:00',1.05),('8537','2013-06-25','07:35:00',1.06),('8537','2013-06-25','07:40:00',1.25),('8537','2013-06-25','07:45:00',1.29),('8537','2013-06-25','07:50:00',1.14),('8537','2013-06-25','07:55:00',1.25),('8537','2013-06-25','08:00:00',1.61),('8537','2013-06-25','08:05:00',2.05),('8537','2013-06-25','08:10:00',1.9),('8537','2013-06-25','08:15:00',1.92),('8537','2013-06-25','08:20:00',1.52),('8537','2013-06-25','08:25:00',2.25),('8537','2013-06-25','08:30:00',2.3),('8537','2013-06-25','08:35:00',2.39),('8537','2013-06-25','08:40:00',2.49),('8537','2013-06-25','08:45:00',2.58),('8537','2013-06-25','08:50:00',2.63),('8537','2013-06-25','08:55:00',2.75),('8537','2013-06-25','09:00:00',2.87),('8537','2013-06-25','09:05:00',2.89),('8537','2013-06-25','09:10:00',2.9),('8537','2013-06-25','09:15:00',3.08),('8537','2013-06-25','09:20:00',3.2),('8537','2013-06-25','09:25:00',3.1),('8537','2013-06-25','09:30:00',2.74),('8537','2013-06-25','09:35:00',1.53),('8537','2013-06-25','09:40:00',1.33),('8537','2013-06-25','09:50:00',3.54),('8537','2013-06-25','09:55:00',4.05),('8537','2013-06-25','10:00:00',3.75),('8537','2013-06-25','10:05:00',3.04),('8537','2013-06-25','10:10:00',2.96),('8537','2013-06-25','10:15:00',4.48),('8537','2013-06-25','10:20:00',4.36),('8537','2013-06-25','10:25:00',2.9),('8537','2013-06-25','10:30:00',4.65),('8537','2013-06-25','10:35:00',4.65),('8537','2013-06-25','10:40:00',4.75),('8537','2013-06-25','10:45:00',4.63),('8537','2013-06-25','10:50:00',4.58),('8537','2013-06-25','10:55:00',2),('8537','2013-06-25','11:00:00',1.18),('8537','2013-06-25','11:05:00',3.43),('8537','2013-06-25','11:10:00',2.55),('8537','2013-06-25','11:15:00',1.26),('8537','2013-06-25','11:20:00',1.56),('8537','2013-06-25','11:25:00',1.61),('8537','2013-06-25','11:30:00',1.49),('8537','2013-06-25','11:35:00',5.42),('8537','2013-06-25','11:40:00',5.62),('8537','2013-06-25','11:45:00',5.45),('8537','2013-06-25','11:50:00',3.64),('8537','2013-06-25','11:55:00',4.76),('8537','2013-06-25','12:00:00',4.72),('8537','2013-06-25','12:05:00',1.75),('8537','2013-06-25','12:10:00',1.75),('8537','2013-06-25','12:15:00',1.6),('8537','2013-06-25','12:20:00',1.48),('8537','2013-06-25','12:25:00',1.27),('8537','2013-06-25','12:30:00',1.2),('8537','2013-06-25','12:35:00',1.29),('8537','2013-06-25','12:40:00',1.7),('8537','2013-06-25','12:45:00',2.1),('8537','2013-06-25','12:50:00',1.68),('8537','2013-06-25','12:55:00',2.1),('8537','2013-06-25','13:00:00',5.48),('8537','2013-06-25','13:05:00',5.58),('8537','2013-06-25','13:10:00',5.28),('8537','2013-06-25','13:15:00',5.41),('8537','2013-06-25','13:20:00',5.24),('8537','2013-06-25','13:25:00',5.25),('8537','2013-06-25','13:30:00',4.64),('8537','2013-06-25','13:35:00',4.94),('8537','2013-06-25','13:40:00',4.92),('8537','2013-06-25','13:45:00',5.45),('8537','2013-06-25','13:50:00',3.21),('8537','2013-06-25','13:55:00',3.41),('8537','2013-06-25','14:00:00',3.9),('8537','2013-06-25','14:05:00',5.17),('8537','2013-06-25','14:10:00',4.99),('8537','2013-06-25','14:15:00',4.56),('8537','2013-06-25','14:20:00',4.94),('8537','2013-06-25','14:25:00',5.06),('8537','2013-06-25','14:30:00',4.94),('8537','2013-06-25','14:35:00',4.86),('8537','2013-06-25','14:40:00',4.9),('8537','2013-06-25','14:45:00',4.8),('8537','2013-06-25','14:50:00',4.51),('8537','2013-06-25','14:55:00',4.71),('8537','2013-06-25','15:00:00',4.64),('8537','2013-06-25','15:05:00',4.59),('8537','2013-06-25','15:10:00',4.49),('8537','2013-06-25','15:15:00',4.5),('8537','2013-06-25','15:20:00',4.42),('8537','2013-06-25','15:25:00',4.33),('8537','2013-06-25','15:30:00',4.25),('8537','2013-06-25','15:35:00',4.21),('8537','2013-06-25','15:40:00',4.16),('8537','2013-06-25','15:45:00',3.97),('8537','2013-06-25','15:50:00',3.82),('8537','2013-06-25','15:55:00',3.91),('8537','2013-06-25','16:00:00',3.85),('8537','2013-06-25','16:05:00',3.79),('8537','2013-06-25','16:10:00',3.7),('8537','2013-06-25','16:15:00',3.63),('8537','2013-06-25','16:20:00',3.58),('8537','2013-06-25','16:25:00',3.51),('8537','2013-06-25','16:30:00',3.29),('8537','2013-06-25','16:35:00',3.01),('8537','2013-06-25','16:40:00',3.21),('8537','2013-06-25','16:45:00',3.13),('8537','2013-06-25','16:50:00',3.06),('8537','2013-06-25','16:55:00',2.94),('8537','2013-06-25','17:00:00',2.89),('8537','2013-06-25','17:05:00',2.82),('8537','2013-06-25','17:10:00',2.68),('8537','2013-06-25','17:15:00',2.61),('8537','2013-06-25','17:20:00',2.54),('8537','2013-06-25','17:25:00',2.43),('8537','2013-06-25','17:30:00',2.3),('8537','2013-06-25','17:35:00',2.18),('8537','2013-06-25','17:40:00',2.1),('8537','2013-06-25','17:45:00',2),('8537','2013-06-25','17:50:00',1.9),('8537','2013-06-25','17:55:00',1.8),('8537','2013-06-25','18:00:00',1.71),('8537','2013-06-25','18:05:00',1.58),('8537','2013-06-25','18:10:00',1.47),('8537','2013-06-25','18:15:00',1.39),('8537','2013-06-25','18:20:00',1.31),('8537','2013-06-25','18:25:00',1.21),('8537','2013-06-25','18:30:00',1.11),('8537','2013-06-25','18:35:00',1.03),('8537','2013-06-24','08:45:00',2.74),('8537','2013-06-24','08:50:00',2.83),('8537','2013-06-24','08:55:00',2.95),('8537','2013-06-24','09:00:00',2.44),('8537','2013-06-24','09:05:00',2.91),('8537','2013-06-24','09:10:00',1.89),('8537','2013-06-24','09:15:00',2.78),('8537','2013-06-24','09:20:00',3.7),('8537','2013-06-24','09:25:00',2.98),('8537','2013-06-24','09:30:00',3.78),('8537','2013-06-24','09:35:00',2.47),('8537','2013-06-24','09:40:00',1.94),('8537','2013-06-24','09:45:00',2.94),('8537','2013-06-24','09:50:00',4),('8537','2013-06-24','09:55:00',3.91),('8537','2013-06-24','10:00:00',3.93),('8537','2013-06-24','10:05:00',4.04),('8537','2013-06-24','10:10:00',4.22),('8537','2013-06-24','10:15:00',3),('8537','2013-06-24','10:20:00',4.22),('8537','2013-06-24','10:25:00',4.73),('8537','2013-06-24','10:30:00',3.19),('8537','2013-06-24','10:35:00',4.74),('8537','2013-06-24','10:40:00',1.83),('8537','2013-06-24','10:45:00',2.08),('8537','2013-06-24','10:50:00',4.62),('8537','2013-06-24','10:55:00',3.79),('8537','2013-06-24','11:00:00',5),('8537','2013-06-24','11:05:00',5.11),('8537','2013-06-24','11:10:00',2.28),('8537','2013-06-24','11:15:00',1.11),('8537','2013-06-24','11:20:00',4.92),('8537','2013-06-24','11:25:00',1.68),('8537','2013-06-24','11:30:00',2.83),('8537','2013-06-24','11:35:00',1.68),('8537','2013-06-24','11:40:00',1.54),('8537','2013-06-24','11:45:00',1.93),('8537','2013-06-24','11:50:00',3.47),('8537','2013-06-24','11:55:00',4.02),('8537','2013-06-24','12:00:00',4.06),('8537','2013-06-24','12:05:00',4.45),('8537','2013-06-24','12:10:00',4.11),('8537','2013-06-24','12:15:00',3.91),('8537','2013-06-24','12:20:00',4.82),('8537','2013-06-24','12:25:00',4.91),('8537','2013-06-24','12:30:00',3.58),('8537','2013-06-24','12:35:00',5.28),('8537','2013-06-24','12:40:00',5.41),('8537','2013-06-24','12:45:00',3.24),('8537','2013-06-24','12:50:00',5.44),('8537','2013-06-24','12:55:00',5.65),('8537','2013-06-24','13:00:00',4.6),('8537','2013-06-24','13:05:00',5.04),('8537','2013-06-24','13:10:00',4.5),('8537','2013-06-24','13:15:00',4.05),('8537','2013-06-24','13:20:00',2.68),('8537','2013-06-24','13:25:00',4.32),('8537','2013-06-24','13:30:00',5.77),('8537','2013-06-24','13:35:00',3.97),('8537','2013-06-24','13:40:00',5.09),('8537','2013-06-24','13:45:00',5.39),('8537','2013-06-24','13:50:00',5.27),('8537','2013-06-24','13:55:00',5.18),('8537','2013-06-24','14:00:00',5.06),('8537','2013-06-24','14:05:00',5.18),('8537','2013-06-24','14:10:00',5.13),('8537','2013-06-24','14:15:00',5.1),('8537','2013-06-24','14:20:00',5.1),('8537','2013-06-24','14:25:00',5.1),('8537','2013-06-24','14:30:00',5.14),('8537','2013-06-24','14:35:00',5.07),('8537','2013-06-24','14:40:00',5.03),('8537','2013-06-24','14:45:00',4.91),('8537','2013-06-24','14:50:00',4.24),('8537','2013-06-24','14:55:00',4.41),('8537','2013-06-24','15:00:00',4.59),('8537','2013-06-24','15:05:00',2.98),('8537','2013-06-24','15:10:00',4.37),('8537','2013-06-24','15:15:00',5.01),('8537','2013-06-24','15:20:00',4.61),('8537','2013-06-24','15:25:00',3),('8537','2013-06-24','15:30:00',3.22),('8537','2013-06-24','15:35:00',3.41),('8537','2013-06-24','15:40:00',2.77),('8537','2013-06-24','15:45:00',3.92),('8537','2013-06-24','15:50:00',3.19),('8537','2013-06-24','15:55:00',3.96),('8537','2013-06-24','16:00:00',4.55),('8537','2013-06-24','16:05:00',4.02),('8537','2013-06-24','16:10:00',3.2),('8537','2013-06-24','16:15:00',4.33),('8537','2013-06-24','16:20:00',2.6),('8537','2013-06-24','16:25:00',2.82),('8537','2013-06-24','16:30:00',3.54),('8537','2013-06-24','16:35:00',3.41),('8537','2013-06-24','16:40:00',1.96),('8537','2013-06-24','16:45:00',2.72),('8537','2013-06-24','16:50:00',2.09),('8537','2013-06-24','16:55:00',1.37),('8537','2013-06-24','17:00:00',1.46),('8537','2013-06-24','17:05:00',2.5),('8537','2013-06-24','17:10:00',2.35),('8537','2013-06-24','17:15:00',2.7),('8537','2013-06-24','17:20:00',2.08),('8537','2013-06-24','17:25:00',1.99),('8537','2013-06-24','17:30:00',1.75),('8537','2013-06-24','17:35:00',1.14),('8537','2013-06-24','17:50:00',1.47),('8537','2013-06-24','17:55:00',1.13),('8537','2013-06-24','18:00:00',2.04),('8537','2013-06-24','18:05:00',1.82),('8537','2013-06-24','18:10:00',1.18),('8537','2013-06-24','18:15:00',1.26),('8537','2013-06-24','18:20:00',1.3),('8537','2013-06-24','18:25:00',1.31),('8537','2013-06-24','18:30:00',1.15),('8537','2013-06-24','18:35:00',1.03),('8537','2013-06-23','08:45:00',1.17),('8537','2013-06-23','08:50:00',1.73),('8537','2013-06-23','08:55:00',1.19),('8537','2013-06-23','09:00:00',2),('8537','2013-06-23','09:05:00',1.83),('8537','2013-06-23','09:20:00',2.03),('8537','2013-06-23','09:25:00',3.03),('8537','2013-06-23','09:30:00',3.35),('8537','2013-06-23','09:35:00',3.44),('8537','2013-06-23','09:40:00',3.84),('8537','2013-06-23','09:45:00',2.64),('8537','2013-06-23','09:50:00',1.59),('8537','2013-06-23','09:55:00',1.56),('8537','2013-06-23','10:00:00',2.02),('8537','2013-06-23','10:05:00',3.72),('8537','2013-06-23','10:10:00',2.76),('8537','2013-06-23','10:15:00',2.54),('8537','2013-06-23','10:20:00',1.9),('8537','2013-06-23','10:25:00',1.38),('8537','2013-06-23','10:30:00',1.22),('8537','2013-06-23','10:35:00',4),('8537','2013-06-23','10:40:00',4.05),('8537','2013-06-23','10:45:00',4.21),('8537','2013-06-23','10:50:00',4.2),('8537','2013-06-23','10:55:00',3.77),('8537','2013-06-23','11:00:00',4.29),('8537','2013-06-23','11:05:00',4.36),('8537','2013-06-23','11:10:00',4.47),('8537','2013-06-23','11:15:00',4.53),('8537','2013-06-23','11:20:00',4.62),('8537','2013-06-23','11:25:00',4.55),('8537','2013-06-23','11:30:00',4.52),('8537','2013-06-23','11:35:00',4.44),('8537','2013-06-23','11:40:00',4.48),('8537','2013-06-23','11:45:00',4.49),('8537','2013-06-23','11:50:00',4.75),('8537','2013-06-23','11:55:00',4.7),('8537','2013-06-23','12:00:00',3.98),('8537','2013-06-23','12:05:00',5),('8537','2013-06-23','12:10:00',4.88),('8537','2013-06-23','12:15:00',4.87),('8537','2013-06-23','12:20:00',4.91),('8537','2013-06-23','12:25:00',5.02),('8537','2013-06-23','12:30:00',4.95),('8537','2013-06-23','12:35:00',4.94),('8537','2013-06-23','12:40:00',4.92),('8537','2013-06-23','12:45:00',4.99),('8537','2013-06-23','12:50:00',4.99),('8537','2013-06-23','12:55:00',4.96),('8537','2013-06-23','13:00:00',4.99),('8537','2013-06-23','13:05:00',5),('8537','2013-06-23','13:10:00',5),('8537','2013-06-23','13:15:00',5),('8537','2013-06-23','13:20:00',4.98),('8537','2013-06-23','13:25:00',5),('8537','2013-06-23','13:30:00',4.97),('8537','2013-06-23','13:35:00',5.03),('8537','2013-06-23','13:40:00',5.03),('8537','2013-06-23','13:45:00',5.01),('8537','2013-06-23','13:50:00',5.01),('8537','2013-06-23','13:55:00',5),('8537','2013-06-23','14:00:00',4.96),('8537','2013-06-23','14:05:00',4.93),('8537','2013-06-23','14:10:00',4.93),('8537','2013-06-23','14:15:00',4.9),('8537','2013-06-23','14:20:00',4.84),('8537','2013-06-23','14:25:00',4.86),('8537','2013-06-23','14:30:00',4.83),('8537','2013-06-23','14:35:00',4.81),('8537','2013-06-23','14:40:00',4.8),('8537','2013-06-23','14:45:00',4.69),('8537','2013-06-23','14:50:00',4.67),('8537','2013-06-23','14:55:00',4.63),('8537','2013-06-23','15:00:00',4.58),('8537','2013-06-23','15:05:00',4.54),('8537','2013-06-23','15:10:00',4.48),('8537','2013-06-23','15:15:00',4.45),('8537','2013-06-23','15:20:00',4.4),('8537','2013-06-23','15:25:00',4.36),('8537','2013-06-23','15:30:00',4.29),('8537','2013-06-23','15:35:00',4.22),('8537','2013-06-23','15:40:00',4.16),('8537','2013-06-23','15:45:00',3.99),('8537','2013-06-23','15:50:00',4.01),('8537','2013-06-23','15:55:00',3.94),('8537','2013-06-23','16:00:00',3.88),('8537','2013-06-23','16:05:00',3.81),('8537','2013-06-23','16:10:00',3.73),('8537','2013-06-23','16:15:00',3.65),('8537','2013-06-23','16:20:00',3.58),('8537','2013-06-23','16:25:00',3.49),('8537','2013-06-23','16:30:00',3.34),('8537','2013-06-23','16:35:00',3.3),('8537','2013-06-23','16:40:00',3.25),('8537','2013-06-23','16:45:00',3.18),('8537','2013-06-23','16:50:00',3.1),('8537','2013-06-23','16:55:00',3),('8537','2013-06-23','17:00:00',2.92),('8537','2013-06-23','17:05:00',2.82),('8537','2013-06-23','17:10:00',2.47),('8537','2013-06-23','17:15:00',2.11),('8537','2013-06-23','17:20:00',2.33),('8537','2013-06-23','17:25:00',2.35),('8537','2013-06-23','17:30:00',2.32),('8537','2013-06-23','17:35:00',2.21),('8537','2013-06-23','17:40:00',2.12),('8537','2013-06-23','17:45:00',1.94),('8537','2013-06-23','17:50:00',1.98),('8537','2013-06-23','17:55:00',1.84),('8537','2013-06-23','18:00:00',1.74),('8537','2013-06-23','18:05:00',1.62),('8537','2013-06-23','18:10:00',1.54),('8537','2013-06-23','18:15:00',1.41),('8537','2013-06-23','18:20:00',1.33),('8537','2013-06-23','18:25:00',1.21),('8537','2013-06-23','18:30:00',1.13),('8537','2013-06-23','18:35:00',1.04),('8537','2013-06-22','07:35:00',1.07),('8537','2013-06-22','07:40:00',1.16),('8537','2013-06-22','07:45:00',1.23),('8537','2013-06-22','07:50:00',1.34),('8537','2013-06-22','07:55:00',1.44),('8537','2013-06-22','08:00:00',1.54),('8537','2013-06-22','08:05:00',1.6),('8537','2013-06-22','08:10:00',1.69),('8537','2013-06-22','08:15:00',1.79),('8537','2013-06-22','08:20:00',1.9),('8537','2013-06-22','08:25:00',2.01),('8537','2013-06-22','08:30:00',2.12),('8537','2013-06-22','08:35:00',2.21),('8537','2013-06-22','08:40:00',2.32),('8537','2013-06-22','08:45:00',2.42),('8537','2013-06-22','08:50:00',2.5),('8537','2013-06-22','08:55:00',2.59),('8537','2013-06-22','09:00:00',2.64),('8537','2013-06-22','09:05:00',2.72),('8537','2013-06-22','09:10:00',2.79),('8537','2013-06-22','09:15:00',2.88),('8537','2013-06-22','09:20:00',2.95),('8537','2013-06-22','09:25:00',3),('8537','2013-06-22','09:30:00',3.08),('8537','2013-06-22','09:35:00',3.16),('8537','2013-06-22','09:40:00',3.26),('8537','2013-06-22','09:45:00',3.33),('8537','2013-06-22','09:50:00',3.39),('8537','2013-06-22','09:55:00',3.48),('8537','2013-06-22','10:00:00',3.54),('8537','2013-06-22','10:05:00',3.63),('8537','2013-06-22','10:10:00',3.7),('8537','2013-06-22','10:15:00',3.76),('8537','2013-06-22','10:20:00',3.83),('8537','2013-06-22','10:25:00',3.9),('8537','2013-06-22','10:30:00',3.91),('8537','2013-06-22','10:35:00',3.98),('8537','2013-06-22','10:40:00',4.04),('8537','2013-06-22','10:45:00',4.07),('8537','2013-06-22','10:50:00',4.17),('8537','2013-06-22','10:55:00',4.22),('8537','2013-06-22','11:00:00',4.27),('8537','2013-06-22','11:05:00',4.33),('8537','2013-06-22','11:10:00',4.37),('8537','2013-06-22','11:15:00',4.39),('8537','2013-06-22','11:20:00',4.43),('8537','2013-06-22','11:25:00',4.47),('8537','2013-06-22','11:30:00',4.49),('8537','2013-06-22','11:35:00',4.51),('8537','2013-06-22','11:40:00',4.55),('8537','2013-06-22','11:45:00',4.57),('8537','2013-06-22','11:50:00',4.58),('8537','2013-06-22','11:55:00',4.59),('8537','2013-06-22','12:00:00',4.63),('8537','2013-06-22','12:05:00',4.58),('8537','2013-06-22','12:10:00',4.5),('8537','2013-06-22','12:15:00',4.71),('8537','2013-06-22','12:20:00',4.72),('8537','2013-06-22','12:25:00',4.61),('8537','2013-06-22','12:30:00',4.73),('8537','2013-06-22','12:35:00',4.77),('8537','2013-06-22','12:40:00',4.78),('8537','2013-06-22','12:45:00',4.72),('8537','2013-06-22','12:50:00',4.67),('8537','2013-06-22','12:55:00',4.63),('8537','2013-06-22','13:00:00',4.59),('8537','2013-06-22','13:05:00',4.64),('8537','2013-06-22','13:10:00',4.58),('8537','2013-06-22','13:15:00',4.51),('8537','2013-06-22','13:20:00',4.38),('8537','2013-06-22','13:25:00',4.49),('8537','2013-06-22','13:30:00',4.95),('8537','2013-06-22','13:35:00',4.99),('8537','2013-06-22','13:40:00',4.58),('8537','2013-06-22','13:45:00',4.65),('8537','2013-06-22','13:50:00',4.83),('8537','2013-06-22','13:55:00',3.93),('8537','2013-06-22','14:00:00',2.75),('8537','2013-06-22','14:05:00',5.28),('8537','2013-06-22','14:10:00',4.99),('8537','2013-06-22','14:15:00',4.98),('8537','2013-06-22','14:20:00',4.05),('8537','2013-06-22','14:25:00',4.87),('8537','2013-06-22','14:30:00',3.65),('8537','2013-06-22','14:35:00',2.68),('8537','2013-06-22','14:40:00',2.02),('8537','2013-06-22','14:45:00',2.29),('8537','2013-06-22','14:50:00',3.97),('8537','2013-06-22','14:55:00',4.57),('8537','2013-06-22','15:00:00',4.38),('8537','2013-06-22','15:05:00',3.69),('8537','2013-06-22','15:10:00',4.24),('8537','2013-06-22','15:15:00',4.61),('8537','2013-06-22','15:20:00',4.23),('8537','2013-06-22','15:25:00',3.86),('8537','2013-06-22','15:30:00',2.62),('8537','2013-06-22','15:35:00',2.29),('8537','2013-06-22','15:40:00',2.21),('8537','2013-06-22','15:45:00',2.91),('8537','2013-06-22','15:50:00',2.84),('8537','2013-06-22','15:55:00',2.68),('8537','2013-06-22','16:00:00',2.19),('8537','2013-06-22','16:05:00',1.46),('8537','2013-06-22','16:10:00',1.41),('8537','2013-06-22','16:15:00',1.71),('8537','2013-06-22','16:20:00',2.06),('8537','2013-06-22','16:25:00',1.51),('8537','2013-06-22','16:30:00',1.19),('8537','2013-06-22','16:35:00',1.01),('8537','2013-06-22','16:55:00',1.29),('8537','2013-06-22','17:00:00',1.67),('8537','2013-06-22','17:05:00',1.63),('8537','2013-06-22','17:10:00',2.08),('8537','2013-06-22','17:15:00',2.78),('8537','2013-06-22','17:20:00',2.67),('8537','2013-06-22','17:25:00',2.88),('8537','2013-06-22','17:30:00',2.28),('8537','2013-06-22','17:35:00',1.96),('8537','2013-06-22','17:40:00',2.2),('8537','2013-06-22','17:45:00',2.16),('8537','2013-06-22','17:50:00',1.98),('8537','2013-06-22','17:55:00',1.87),('8537','2013-06-22','18:00:00',1.72),('8537','2013-06-22','18:05:00',1.38),('8537','2013-06-21','07:35:00',1.08),('8537','2013-06-21','07:40:00',1.17),('8537','2013-06-21','07:45:00',1.24),('8537','2013-06-21','07:50:00',1.36),('8537','2013-06-21','07:55:00',1.45),('8537','2013-06-21','08:00:00',1.54),('8537','2013-06-21','08:05:00',1.63),('8537','2013-06-21','08:10:00',1.73),('8537','2013-06-21','08:15:00',1.81),('8537','2013-06-21','08:20:00',1.91),('8537','2013-06-21','08:25:00',2),('8537','2013-06-21','08:30:00',2.09),('8537','2013-06-21','08:35:00',2.19),('8537','2013-06-21','08:40:00',2.29),('8537','2013-06-21','08:45:00',2.35),('8537','2013-06-21','08:50:00',2.43),('8537','2013-06-21','08:55:00',2.5),('8537','2013-06-21','09:00:00',2.57),('8537','2013-06-21','09:05:00',2.64),('8537','2013-06-21','09:10:00',2.71),('8537','2013-06-21','09:15:00',2.78),('8537','2013-06-21','09:20:00',2.87),('8537','2013-06-21','09:25:00',2.96),('8537','2013-06-21','09:30:00',3.02),('8537','2013-06-21','09:35:00',3.07),('8537','2013-06-21','09:40:00',3.13),('8537','2013-06-21','09:45:00',3.19),('8537','2013-06-21','09:50:00',3.21),('8537','2013-06-21','09:55:00',3.26),('8537','2013-06-21','10:00:00',3.36),('8537','2013-06-21','10:05:00',3.44),('8537','2013-06-21','10:10:00',3.49),('8537','2013-06-21','10:15:00',3.44),('8537','2013-06-21','10:20:00',3.51),('8537','2013-06-21','10:25:00',3.61),('8537','2013-06-21','10:30:00',3.68),('8537','2013-06-21','10:35:00',3.69),('8537','2013-06-21','10:40:00',3.76),('8537','2013-06-21','10:45:00',3.83),('8537','2013-06-21','10:50:00',3.91),('8537','2013-06-21','10:55:00',3.94),('8537','2013-06-21','11:00:00',3.99),('8537','2013-06-21','11:05:00',4.02),('8537','2013-06-21','11:10:00',4.03),('8537','2013-06-21','11:15:00',4.09),('8537','2013-06-21','11:20:00',4.18),('8537','2013-06-21','11:25:00',4.26),('8537','2013-06-21','11:30:00',4.27),('8537','2013-06-21','11:35:00',4.27),('8537','2013-06-21','11:40:00',4.26),('8537','2013-06-21','11:45:00',4.25),('8537','2013-06-21','11:50:00',4.34),('8537','2013-06-21','11:55:00',4.38),('8537','2013-06-21','12:00:00',4.38),('8537','2013-06-21','12:05:00',4.38),('8537','2013-06-21','12:10:00',4.39),('8537','2013-06-21','12:15:00',4.38),('8537','2013-06-21','12:20:00',4.34),('8537','2013-06-21','12:25:00',4.4),('8537','2013-06-21','12:30:00',4.44),('8537','2013-06-21','12:35:00',4.41),('8537','2013-06-21','12:40:00',4.45),('8537','2013-06-21','12:45:00',4.43),('8537','2013-06-21','12:50:00',4.42),('8537','2013-06-21','12:55:00',4.4),('8537','2013-06-21','13:00:00',4.44),('8537','2013-06-21','13:05:00',4.44),('8537','2013-06-21','13:10:00',4.39),('8537','2013-06-21','13:15:00',4.43),('8537','2013-06-21','13:20:00',4.46),('8537','2013-06-21','13:25:00',4.52),('8537','2013-06-21','13:30:00',4.52),('8537','2013-06-21','13:35:00',4.6),('8537','2013-06-21','13:40:00',4.51),('8537','2013-06-21','13:45:00',4.53),('8537','2013-06-21','13:50:00',4.54),('8537','2013-06-21','13:55:00',4.53),('8537','2013-06-21','14:00:00',4.54),('8537','2013-06-21','14:05:00',4.54),('8537','2013-06-21','14:10:00',4.52),('8537','2013-06-21','14:15:00',4.55),('8537','2013-06-21','14:20:00',4.52),('8537','2013-06-21','14:25:00',4.54),('8537','2013-06-21','14:30:00',4.52),('8537','2013-06-21','14:35:00',4.5),('8537','2013-06-21','14:40:00',4.47),('8537','2013-06-21','14:45:00',4.36),('8537','2013-06-21','14:50:00',4.16),('8537','2013-06-21','14:55:00',4.33),('8537','2013-06-21','15:00:00',4.28),('8537','2013-06-21','15:05:00',4.22),('8537','2013-06-21','15:10:00',4.2),('8537','2013-06-21','15:15:00',4.16),('8537','2013-06-21','15:20:00',4.11),('8537','2013-06-21','15:25:00',4.07),('8537','2013-06-21','15:30:00',4.03),('8537','2013-06-21','15:35:00',3.97),('8537','2013-06-21','15:40:00',3.91),('8537','2013-06-21','15:45:00',3.74),('8537','2013-06-21','15:50:00',3.64),('8537','2013-06-21','15:55:00',3.71),('8537','2013-06-21','16:00:00',3.65),('8537','2013-06-21','16:05:00',3.57),('8537','2013-06-21','16:10:00',3.53),('8537','2013-06-21','16:15:00',3.48),('8537','2013-06-21','16:20:00',3.41),('8537','2013-06-21','16:25:00',3.33),('8537','2013-06-21','16:30:00',3.08),('8537','2013-06-21','16:35:00',2.91),('8537','2013-06-21','16:40:00',3.06),('8537','2013-06-21','16:45:00',2.99),('8537','2013-06-21','16:50:00',2.89),('8537','2013-06-21','16:55:00',2.85),('8537','2013-06-21','17:00:00',2.77),('8537','2013-06-21','17:05:00',2.68),('8537','2013-06-21','17:10:00',2.56),('8537','2013-06-21','17:15:00',2.48),('8537','2013-06-21','17:20:00',2.4),('8537','2013-06-21','17:25:00',2.31),('8537','2013-06-21','17:30:00',2.17),('8537','2013-06-21','17:35:00',2.08),('8537','2013-06-21','17:40:00',2.01),('8537','2013-06-21','17:45:00',1.92),('8537','2013-06-21','17:50:00',1.82),('8537','2013-06-21','17:55:00',1.71),('8537','2013-06-21','18:00:00',1.6),('8537','2013-06-21','18:05:00',1.5),('8537','2013-06-21','18:10:00',1.42),('8537','2013-06-21','18:15:00',1.33),('8537','2013-06-21','18:20:00',1.24),('8537','2013-06-21','18:25:00',1.14),('8537','2013-06-21','18:30:00',1.05),('8537','2014-04-04','08:50:00',1.01),('8537','2014-04-04','08:55:00',1.01),('8537','2014-04-04','09:00:00',1.01),('8537','2014-04-04','09:05:00',1.47),('8537','2014-04-04','09:10:00',2.02),('8537','2014-04-04','09:15:00',1.8),('8537','2014-04-04','09:20:00',1.27),('8537','2014-04-04','09:25:00',1.07),('8537','2014-04-04','09:30:00',1.03),('8537','2014-04-04','09:35:00',1.04),('8537','2014-04-04','13:20:00',2.34),('8537','2014-04-04','13:25:00',3.07),('8537','2014-04-04','13:30:00',2.7),('8537','2014-04-04','13:35:00',3.43),('8537','2014-04-04','13:40:00',4.3),('8537','2014-04-04','13:45:00',4.25),('8537','2014-04-04','13:50:00',4.15),('8537','2014-04-04','13:55:00',2.96),('8537','2014-04-04','14:00:00',2.48),('8537','2014-04-04','14:05:00',5.16),('8537','2014-04-04','14:10:00',3.5),('8537','2014-04-04','14:15:00',4.78),('8537','2014-04-04','14:20:00',3.71),('8537','2014-04-04','14:25:00',4.21),('8537','2014-04-04','14:30:00',1.58),('8537','2014-04-04','14:35:00',2.74),('8537','2014-04-04','14:40:00',1.87),('8537','2014-04-04','14:45:00',2.43),('8537','2014-04-04','14:50:00',3.75),('8537','2014-04-04','14:55:00',3.83),('8537','2014-04-04','15:00:00',4.74),('8537','2014-04-04','15:05:00',4.76),('8537','2014-04-04','15:10:00',4.78),('8537','2014-04-04','15:15:00',4),('8537','2014-04-04','15:20:00',2.55),('8537','2014-04-04','15:25:00',2.2),('8537','2014-04-04','15:30:00',2.01),('8537','2014-04-04','15:35:00',2),('8537','2014-04-04','15:40:00',2.82),('8537','2014-04-04','15:45:00',2.48),('8537','2014-04-04','15:50:00',2.07),('8537','2014-04-04','15:55:00',2.9),('8537','2014-04-04','16:00:00',3.12),('8537','2014-04-04','16:05:00',2.02),('8537','2014-04-04','16:10:00',2.74),('8537','2014-04-04','16:15:00',1.96),('8537','2014-04-04','16:20:00',1.23),('8537','2014-04-04','16:25:00',1.14),('8537','2014-04-04','16:30:00',2.2),('8537','2014-04-04','16:35:00',1.84),('8537','2014-04-04','16:40:00',1.51),('8537','2014-04-04','16:45:00',2.92),('8537','2014-04-04','16:50:00',2.84),('8537','2014-04-04','16:55:00',2.22),('8537','2014-04-04','17:00:00',2.13),('8537','2014-04-04','17:05:00',2.13),('8537','2014-04-04','17:10:00',2.26),('8537','2014-04-04','17:15:00',2.27),('8537','2014-04-04','17:20:00',2.17),('8537','2014-04-04','17:25:00',1.87),('8537','2014-04-04','17:30:00',1.84),('8537','2014-04-04','17:35:00',1.46),('8537','2014-04-04','17:40:00',1.27),('8537','2014-04-04','17:45:00',1.52),('8537','2014-04-04','17:50:00',1.48),('8537','2014-04-04','17:55:00',1.33),('8537','2014-04-04','18:00:00',1.16),('8537','2014-04-04','18:05:00',1.02),('8537','2013-06-20','07:40:00',1.02),('8537','2013-06-20','07:45:00',1.13),('8537','2013-06-20','07:50:00',1.26),('8537','2013-06-20','07:55:00',1.39),('8537','2013-06-20','08:00:00',1.51),('8537','2013-06-20','08:05:00',1.6),('8537','2013-06-20','08:10:00',1.73),('8537','2013-06-20','08:15:00',1.81),('8537','2013-06-20','08:20:00',1.92),('8537','2013-06-20','08:25:00',2.02),('8537','2013-06-20','08:30:00',2.12),('8537','2013-06-20','08:35:00',2.22),('8537','2013-06-20','08:40:00',2.31),('8537','2013-06-20','08:45:00',2.4),('8537','2013-06-20','08:50:00',2.48),('8537','2013-06-20','08:55:00',2.56),('8537','2013-06-20','09:00:00',2.64),('8537','2013-06-20','09:05:00',2.72),('8537','2013-06-20','09:10:00',2.8),('8537','2013-06-20','09:15:00',2.86),('8537','2013-06-20','09:20:00',2.95),('8537','2013-06-20','09:25:00',3),('8537','2013-06-20','09:30:00',3.06),('8537','2013-06-20','09:35:00',3.18),('8537','2013-06-20','09:40:00',3.25),('8537','2013-06-20','09:45:00',3.32),('8537','2013-06-20','09:50:00',3.39),('8537','2013-06-20','09:55:00',3.47),('8537','2013-06-20','10:00:00',3.5),('8537','2013-06-20','10:05:00',3.57),('8537','2013-06-20','10:10:00',3.63),('8537','2013-06-20','10:15:00',3.66),('8537','2013-06-20','10:20:00',3.73),('8537','2013-06-20','10:25:00',3.81),('8537','2013-06-20','10:30:00',3.84),('8537','2013-06-20','10:35:00',3.88),('8537','2013-06-20','10:40:00',3.92),('8537','2013-06-20','10:45:00',3.96),('8537','2013-06-20','10:50:00',3.96),('8537','2013-06-20','10:55:00',4.01),('8537','2013-06-20','11:00:00',4.06),('8537','2013-06-20','11:05:00',4.12),('8537','2013-06-20','11:10:00',4.15),('8537','2013-06-20','11:15:00',4.2),('8537','2013-06-20','11:20:00',4.13),('8537','2013-06-20','11:25:00',4.21),('8537','2013-06-20','11:30:00',4.26),('8537','2013-06-20','11:35:00',4.31),('8537','2013-06-20','11:40:00',4.33),('8537','2013-06-20','11:45:00',4.36),('8537','2013-06-20','11:50:00',4.34),('8537','2013-06-20','11:55:00',4.3),('8537','2013-06-20','12:00:00',4.34),('8537','2013-06-20','12:05:00',4.37),('8537','2013-06-20','12:10:00',4.31),('8537','2013-06-20','12:15:00',4.29),('8537','2013-06-20','12:20:00',4.27),('8537','2013-06-20','12:25:00',4.44),('8537','2013-06-20','12:30:00',4.47),('8537','2013-06-20','12:35:00',4.67),('8537','2013-06-20','12:40:00',4.69),('8537','2013-06-20','12:45:00',4.59),('8537','2013-06-20','12:50:00',4.34),('8537','2013-06-20','12:55:00',3.25),('8537','2013-06-20','13:00:00',4.17),('8537','2013-06-20','13:05:00',4.76),('8537','2013-06-20','13:10:00',4.76),('8537','2013-06-20','13:15:00',4.08),('8537','2013-06-20','13:20:00',4.33),('8537','2013-06-20','13:25:00',2.98),('8537','2013-06-20','13:30:00',4.44),('8537','2013-06-20','13:35:00',4.65),('8537','2013-06-20','13:40:00',4.64),('8537','2013-06-20','13:45:00',4.6),('8537','2013-06-20','13:50:00',4.62),('8537','2013-06-20','13:55:00',4.57),('8537','2013-06-20','14:00:00',4.64),('8537','2013-06-20','14:05:00',4.72),('8537','2013-06-20','14:10:00',4.63),('8537','2013-06-20','14:15:00',4.65),('8537','2013-06-20','14:20:00',4.63),('8537','2013-06-20','14:25:00',4.61),('8537','2013-06-20','14:30:00',4.57),('8537','2013-06-20','14:35:00',4.65),('8537','2013-06-20','14:40:00',4.63),('8537','2013-06-20','14:45:00',4.46),('8537','2013-06-20','14:50:00',4.35),('8537','2013-06-20','14:55:00',4.46),('8537','2013-06-20','15:00:00',4.39),('8537','2013-06-20','15:05:00',4.37),('8537','2013-06-20','15:10:00',4.31),('8537','2013-06-20','15:15:00',4.27),('8537','2013-06-20','15:20:00',4.22),('8537','2013-06-20','15:25:00',4.17),('8537','2013-06-20','15:30:00',4.12),('8537','2013-06-20','15:35:00',4.05),('8537','2013-06-20','15:40:00',3.99),('8537','2013-06-20','15:45:00',3.87),('8537','2013-06-20','15:50:00',3.83),('8537','2013-06-20','15:55:00',3.77),('8537','2013-06-20','16:00:00',3.7),('8537','2013-06-20','16:05:00',3.67),('8537','2013-06-20','16:10:00',3.62),('8537','2013-06-20','16:15:00',3.55),('8537','2013-06-20','16:20:00',3.46),('8537','2013-06-20','16:25:00',3.37),('8537','2013-06-20','16:30:00',3.1),('8537','2013-06-20','16:35:00',3),('8537','2013-06-20','16:40:00',3.09),('8537','2013-06-20','16:45:00',3.02),('8537','2013-06-20','16:50:00',2.94),('8537','2013-06-20','16:55:00',2.86),('8537','2013-06-20','17:00:00',2.79),('8537','2013-06-20','17:05:00',2.69),('8537','2013-06-20','17:10:00',2.58),('8537','2013-06-20','17:15:00',2.5),('8537','2013-06-20','17:20:00',2.4),('8537','2013-06-20','17:25:00',2.33),('8537','2013-06-20','17:30:00',2.21),('8537','2013-06-20','17:35:00',2.1),('8537','2013-06-20','17:40:00',2.02),('8537','2013-06-20','17:45:00',1.94),('8537','2013-06-20','17:50:00',1.85),('8537','2013-06-20','17:55:00',1.74),('8537','2013-06-20','18:00:00',1.65),('8537','2013-06-20','18:05:00',1.52),('8537','2013-06-20','18:10:00',1.44),('8537','2013-06-20','18:15:00',1.35),('8537','2013-06-20','18:20:00',1.27),('8537','2013-06-20','18:25:00',1.16),('8537','2013-06-20','18:30:00',1.06),('8537','2013-06-19','07:35:00',1.05),('8537','2013-06-19','07:40:00',1.13),('8537','2013-06-19','07:45:00',1.21),('8537','2013-06-19','07:50:00',1.3),('8537','2013-06-19','07:55:00',1.39),('8537','2013-06-19','08:00:00',1.5),('8537','2013-06-19','08:05:00',1.6),('8537','2013-06-19','08:10:00',1.7),('8537','2013-06-19','08:15:00',1.78),('8537','2013-06-19','08:20:00',1.88),('8537','2013-06-19','08:25:00',1.96),('8537','2013-06-19','08:30:00',2.03),('8537','2013-06-19','08:35:00',2.14),('8537','2013-06-19','08:40:00',2.22),('8537','2013-06-19','08:45:00',2.31),('8537','2013-06-19','08:50:00',2.42),('8537','2013-06-19','08:55:00',2.51),('8537','2013-06-19','09:00:00',2.58),('8537','2013-06-19','09:05:00',2.66),('8537','2013-06-19','09:10:00',2.74),('8537','2013-06-19','09:15:00',2.84),('8537','2013-06-19','09:20:00',2.93),('8537','2013-06-19','09:25:00',2.99),('8537','2013-06-19','09:30:00',3.04),('8537','2013-06-19','09:35:00',3.1),('8537','2013-06-19','09:40:00',3.15),('8537','2013-06-19','09:45:00',3.22),('8537','2013-06-19','09:50:00',3.28),('8537','2013-06-19','09:55:00',3.35),('8537','2013-06-19','10:00:00',3.41),('8537','2013-06-19','10:05:00',3.46),('8537','2013-06-19','10:10:00',3.53),('8537','2013-06-19','10:15:00',3.61),('8537','2013-06-19','10:20:00',3.64),('8537','2013-06-19','10:25:00',3.71),('8537','2013-06-19','10:30:00',3.74),('8537','2013-06-19','10:35:00',3.79),('8537','2013-06-19','10:40:00',3.86),('8537','2013-06-19','10:45:00',3.9),('8537','2013-06-19','10:50:00',3.93),('8537','2013-06-19','10:55:00',3.97),('8537','2013-06-19','11:00:00',3.97),('8537','2013-06-19','11:05:00',3.95),('8537','2013-06-19','11:10:00',4.01),('8537','2013-06-19','11:15:00',4.06),('8537','2013-06-19','11:20:00',4.07),('8537','2013-06-19','11:25:00',4.18),('8537','2013-06-19','11:30:00',4.21),('8537','2013-06-19','11:35:00',4.24),('8537','2013-06-19','11:40:00',4.3),('8537','2013-06-19','11:45:00',4.27),('8537','2013-06-19','11:50:00',4.28),('8537','2013-06-19','11:55:00',4.33),('8537','2013-06-19','12:00:00',4.35),('8537','2013-06-19','12:05:00',4.32),('8537','2013-06-19','12:10:00',4.4),('8537','2013-06-19','12:15:00',4.29),('8537','2013-06-19','12:20:00',4.34),('8537','2013-06-19','12:25:00',4.29),('8537','2013-06-19','12:30:00',4.41),('8537','2013-06-19','12:35:00',4.48),('8537','2013-06-19','12:40:00',4.5),('8537','2013-06-19','12:45:00',4.54),('8537','2013-06-19','12:50:00',4.53),('8537','2013-06-19','12:55:00',4.58),('8537','2013-06-19','13:00:00',4.54),('8537','2013-06-19','13:05:00',4.54),('8537','2013-06-19','13:10:00',4.57),('8537','2013-06-19','13:15:00',4.55),('8537','2013-06-19','13:20:00',4.49),('8537','2013-06-19','13:25:00',4.64),('8537','2013-06-19','13:30:00',4.63),('8537','2013-06-19','13:35:00',4.61),('8537','2013-06-19','13:40:00',4.6),('8537','2013-06-19','13:45:00',4.58),('8537','2013-06-19','13:50:00',4.57),('8537','2013-06-19','13:55:00',4.6),('8537','2013-06-19','14:00:00',4.57),('8537','2013-06-19','14:05:00',4.6),('8537','2013-06-19','14:10:00',4.57),('8537','2013-06-19','14:15:00',4.51),('8537','2013-06-19','14:20:00',4.46),('8537','2013-06-19','14:25:00',4.44),('8537','2013-06-19','14:30:00',4.39),('8537','2013-06-19','14:35:00',4.29),('8537','2013-06-19','14:40:00',4.34),('8537','2013-06-19','14:45:00',4.17),('8537','2013-06-19','14:50:00',4.06),('8537','2013-06-19','14:55:00',4.16),('8537','2013-06-19','15:00:00',4.14),('8537','2013-06-19','15:05:00',4.11),('8537','2013-06-19','15:10:00',4.09),('8537','2013-06-19','15:15:00',4.05),('8537','2013-06-19','15:20:00',4),('8537','2013-06-19','15:25:00',3.95),('8537','2013-06-19','15:30:00',3.9),('8537','2013-06-19','15:35:00',3.85),('8537','2013-06-19','15:40:00',3.79),('8537','2013-06-19','15:45:00',3.6),('8537','2013-06-19','15:50:00',3.52),('8537','2013-06-19','15:55:00',3.55),('8537','2013-06-19','16:00:00',3.49),('8537','2013-06-19','16:05:00',3.43),('8537','2013-06-19','16:10:00',3.37),('8537','2013-06-19','16:15:00',3.31),('8537','2013-06-19','16:20:00',3.23),('8537','2013-06-19','16:25:00',3.19),('8537','2013-06-19','16:30:00',2.92),('8537','2013-06-19','16:35:00',2.82),('8537','2013-06-19','16:40:00',2.93),('8537','2013-06-19','16:45:00',2.87),('8537','2013-06-19','16:50:00',2.82),('8537','2013-06-19','16:55:00',2.75),('8537','2013-06-19','17:00:00',2.68),('8537','2013-06-19','17:05:00',2.56),('8537','2013-06-19','17:10:00',2.49),('8537','2013-06-19','17:15:00',2.41),('8537','2013-06-19','17:20:00',2.37),('8537','2013-06-19','17:25:00',2.3),('8537','2013-06-19','17:30:00',2.14),('8537','2013-06-19','17:35:00',2.02),('8537','2013-06-19','17:40:00',1.97),('8537','2013-06-19','17:45:00',1.89),('8537','2013-06-19','17:50:00',1.78),('8537','2013-06-19','17:55:00',1.67),('8537','2013-06-19','18:00:00',1.59),('8537','2013-06-19','18:05:00',1.46),('8537','2013-06-19','18:10:00',1.38),('8537','2013-06-19','18:15:00',1.28),('8537','2013-06-19','18:20:00',1.2),('8537','2013-06-19','18:25:00',1.1),('8537','2013-06-19','18:30:00',1),('8537','2013-06-18','07:35:00',1.04),('8537','2013-06-18','07:40:00',1.13),('8537','2013-06-18','07:45:00',1.22),('8537','2013-06-18','07:50:00',1.31),('8537','2013-06-18','07:55:00',1.41),('8537','2013-06-18','08:00:00',1.5),('8537','2013-06-18','08:05:00',1.58),('8537','2013-06-18','08:10:00',1.67),('8537','2013-06-18','08:15:00',1.76),('8537','2013-06-18','08:20:00',1.85),('8537','2013-06-18','08:25:00',1.96),('8537','2013-06-18','08:30:00',2.04),('8537','2013-06-18','08:35:00',2.13),('8537','2013-06-18','08:40:00',2.21),('8537','2013-06-18','08:45:00',2.31),('8537','2013-06-18','08:50:00',2.38),('8537','2013-06-18','08:55:00',2.45),('8537','2013-06-18','09:00:00',2.52),('8537','2013-06-18','09:05:00',2.62),('8537','2013-06-18','09:10:00',2.69),('8537','2013-06-18','09:15:00',2.77),('8537','2013-06-18','09:20:00',2.84),('8537','2013-06-18','09:25:00',2.93),('8537','2013-06-18','09:30:00',3.02),('8537','2013-06-18','09:35:00',3.09),('8537','2013-06-18','09:40:00',3.16),('8537','2013-06-18','09:45:00',3.23),('8537','2013-06-18','09:50:00',3.3),('8537','2013-06-18','09:55:00',3.35),('8537','2013-06-18','10:00:00',3.37),('8537','2013-06-18','10:05:00',3.43),('8537','2013-06-18','10:10:00',3.51),('8537','2013-06-18','10:15:00',3.59),('8537','2013-06-18','10:20:00',3.66),('8537','2013-06-18','10:25:00',3.69),('8537','2013-06-18','10:30:00',3.73),('8537','2013-06-18','10:35:00',3.77),('8537','2013-06-18','10:40:00',3.84),('8537','2013-06-18','10:45:00',3.94),('8537','2013-06-18','10:50:00',3.98),('8537','2013-06-18','10:55:00',3.96),('8537','2013-06-18','11:00:00',3.99),('8537','2013-06-18','11:05:00',4.07),('8537','2013-06-18','11:10:00',4.13),('8537','2013-06-18','11:15:00',4.13),('8537','2013-06-18','11:20:00',4.14),('8537','2013-06-18','11:25:00',4.2),('8537','2013-06-18','11:30:00',4.21),('8537','2013-06-18','11:35:00',4.2),('8537','2013-06-18','11:40:00',4.2),('8537','2013-06-18','11:45:00',4.2),('8537','2013-06-18','11:50:00',4.25),('8537','2013-06-18','11:55:00',4.23),('8537','2013-06-18','12:00:00',4.26),('8537','2013-06-18','12:05:00',4.31),('8537','2013-06-18','12:10:00',4.29),('8537','2013-06-18','12:15:00',4.24),('8537','2013-06-18','12:20:00',4.22),('8537','2013-06-18','12:25:00',4.24),('8537','2013-06-18','12:30:00',4.31),('8537','2013-06-18','12:35:00',3.45),('8537','2013-06-18','12:40:00',3.77),('8537','2013-06-18','12:45:00',2.09),('8537','2013-06-18','12:50:00',2.32),('8537','2013-06-18','12:55:00',4.55),('8537','2013-06-18','13:00:00',4.32),('8537','2013-06-18','13:05:00',2.19),('8537','2013-06-18','13:10:00',4.75),('8537','2013-06-18','13:15:00',4.53),('8537','2013-06-18','13:20:00',4.56),('8537','2013-06-18','13:25:00',4.29),('8537','2013-06-18','13:30:00',3.74),('8537','2013-06-18','13:35:00',4.46),('8537','2013-06-18','13:40:00',4.44),('8537','2013-06-18','13:45:00',4.5),('8537','2013-06-18','13:50:00',4.56),('8537','2013-06-18','13:55:00',4.66),('8537','2013-06-18','14:00:00',4.64),('8537','2013-06-18','14:05:00',4.57),('8537','2013-06-18','14:10:00',4.5),('8537','2013-06-18','14:15:00',4.47),('8537','2013-06-18','14:20:00',4.48),('8537','2013-06-18','14:25:00',4.43),('8537','2013-06-18','14:30:00',4.43),('8537','2013-06-18','14:35:00',4.43),('8537','2013-06-18','14:40:00',4.39),('8537','2013-06-18','14:45:00',4.33),('8537','2013-06-18','14:50:00',4.13),('8537','2013-06-18','14:55:00',4.27),('8537','2013-06-18','15:00:00',4.26),('8537','2013-06-18','15:05:00',4.19),('8537','2013-06-18','15:10:00',4.16),('8537','2013-06-18','15:15:00',4.07),('8537','2013-06-18','15:20:00',4),('8537','2013-06-18','15:25:00',4),('8537','2013-06-18','15:30:00',3.92),('8537','2013-06-18','15:35:00',3.9),('8537','2013-06-18','15:40:00',3.87),('8537','2013-06-18','15:45:00',3.7),('8537','2013-06-18','15:50:00',3.55),('8537','2013-06-18','15:55:00',3.7),('8537','2013-06-18','16:00:00',3.69),('8537','2013-06-18','16:05:00',3.64),('8537','2013-06-18','16:10:00',3.56),('8537','2013-06-18','16:15:00',3.53),('8537','2013-06-18','16:20:00',3.48),('8537','2013-06-18','16:25:00',3.3),('8537','2013-06-18','16:30:00',3.13),('8537','2013-06-18','16:35:00',3),('8537','2013-06-18','16:40:00',3.04),('8537','2013-06-18','16:45:00',2.9),('8537','2013-06-18','16:50:00',2.86),('8537','2013-06-18','16:55:00',2.79),('8537','2013-06-18','17:00:00',2.71),('8537','2013-06-18','17:05:00',2.61),('8537','2013-06-18','17:10:00',2.53),('8537','2013-06-18','17:15:00',2.44),('8537','2013-06-18','17:20:00',2.38),('8537','2013-06-18','17:25:00',2.29),('8537','2013-06-18','17:30:00',2.12),('8537','2013-06-18','17:35:00',2.04),('8537','2013-06-18','17:40:00',1.95),('8537','2013-06-18','17:45:00',1.88),('8537','2013-06-18','17:50:00',1.77),('8537','2013-06-18','17:55:00',1.69),('8537','2013-06-18','18:00:00',1.57),('8537','2013-06-18','18:05:00',1.48),('8537','2013-06-18','18:10:00',1.41),('8537','2013-06-18','18:15:00',1.33),('8537','2013-06-18','18:20:00',1.25),('8537','2013-06-18','18:25:00',1.14),('8537','2013-06-18','18:30:00',1.06),('8537','2013-06-17','07:30:00',1),('8537','2013-06-17','07:35:00',1.1),('8537','2013-06-17','07:40:00',1.2),('8537','2013-06-17','07:45:00',1.29),('8537','2013-06-17','07:50:00',1.38),('8537','2013-06-17','07:55:00',1.48),('8537','2013-06-17','08:00:00',1.57),('8537','2013-06-17','08:05:00',1.67),('8537','2013-06-17','08:10:00',1.77),('8537','2013-06-17','08:15:00',1.86),('8537','2013-06-17','08:20:00',1.96),('8537','2013-06-17','08:25:00',2.05),('8537','2013-06-17','08:30:00',2.12),('8537','2013-06-17','08:35:00',2.24),('8537','2013-06-17','08:40:00',2.31),('8537','2013-06-17','08:45:00',2.41),('8537','2013-06-17','08:50:00',2.53),('8537','2013-06-17','08:55:00',2.62),('8537','2013-06-17','09:00:00',2.71),('8537','2013-06-17','09:05:00',2.8),('8537','2013-06-17','09:10:00',2.87),('8537','2013-06-17','09:15:00',2.94),('8537','2013-06-17','09:20:00',3.01),('8537','2013-06-17','09:25:00',3.07),('8537','2013-06-17','09:30:00',3.15),('8537','2013-06-17','09:35:00',3.24),('8537','2013-06-17','09:40:00',3.3),('8537','2013-06-17','09:45:00',3.34),('8537','2013-06-17','09:50:00',3.41),('8537','2013-06-17','09:55:00',3.48),('8537','2013-06-17','10:00:00',3.54),('8537','2013-06-17','10:05:00',3.59),('8537','2013-06-17','10:10:00',3.65),('8537','2013-06-17','10:15:00',3.65),('8537','2013-06-17','10:20:00',3.75),('8537','2013-06-17','10:25:00',3.83),('8537','2013-06-17','10:30:00',3.88),('8537','2013-06-17','10:35:00',3.91),('8537','2013-06-17','10:40:00',3.95),('8537','2013-06-17','10:45:00',4.03),('8537','2013-06-17','10:50:00',4.07),('8537','2013-06-17','10:55:00',4.11),('8537','2013-06-17','11:00:00',4.16),('8537','2013-06-17','11:05:00',4.17),('8537','2013-06-17','11:10:00',4.19),('8537','2013-06-17','11:15:00',4.21),('8537','2013-06-17','11:20:00',4.24),('8537','2013-06-17','11:25:00',4.28),('8537','2013-06-17','11:30:00',4.29),('8537','2013-06-17','11:35:00',4.27),('8537','2013-06-17','11:40:00',4.36),('8537','2013-06-17','11:45:00',4.42),('8537','2013-06-17','11:50:00',4.47),('8537','2013-06-17','11:55:00',4.43),('8537','2013-06-17','12:00:00',4.41),('8537','2013-06-17','12:05:00',4.39),('8537','2013-06-17','12:10:00',4.46),('8537','2013-06-17','12:15:00',4.5),('8537','2013-06-17','12:20:00',4.51),('8537','2013-06-17','12:25:00',4.48),('8537','2013-06-17','12:30:00',4.49),('8537','2013-06-17','12:35:00',4.5),('8537','2013-06-17','12:40:00',4.51),('8537','2013-06-17','12:45:00',4.52),('8537','2013-06-17','12:50:00',4.58),('8537','2013-06-17','12:55:00',4.61),('8537','2013-06-17','13:00:00',4.67),('8537','2013-06-17','13:05:00',4.72),('8537','2013-06-17','13:10:00',4.72),('8537','2013-06-17','13:15:00',4.73),('8537','2013-06-17','13:20:00',4.63),('8537','2013-06-17','13:25:00',4.69),('8537','2013-06-17','13:30:00',4.71),('8537','2013-06-17','13:35:00',4.66),('8537','2013-06-17','13:40:00',4.65),('8537','2013-06-17','13:45:00',4.68),('8537','2013-06-17','13:50:00',4.62),('8537','2013-06-17','13:55:00',4.59),('8537','2013-06-17','14:00:00',4.57),('8537','2013-06-17','14:05:00',4.58),('8537','2013-06-17','14:10:00',4.56),('8537','2013-06-17','14:15:00',4.56),('8537','2013-06-17','14:20:00',4.51),('8537','2013-06-17','14:25:00',4.51),('8537','2013-06-17','14:30:00',4.5),('8537','2013-06-17','14:35:00',4.47),('8537','2013-06-17','14:40:00',4.42),('8537','2013-06-17','14:45:00',4.27),('8537','2013-06-17','14:50:00',4.17),('8537','2013-06-17','14:55:00',4.26),('8537','2013-06-17','15:00:00',4.24),('8537','2013-06-17','15:05:00',4.17),('8537','2013-06-17','15:10:00',4.13),('8537','2013-06-17','15:15:00',4.11),('8537','2013-06-17','15:20:00',4.08),('8537','2013-06-17','15:25:00',4.02),('8537','2013-06-17','15:30:00',3.97),('8537','2013-06-17','15:35:00',3.93),('8537','2013-06-17','15:40:00',3.85),('8537','2013-06-17','15:45:00',3.61),('8537','2013-06-17','15:50:00',3.67),('8537','2013-06-17','15:55:00',3.63),('8537','2013-06-17','16:00:00',3.59),('8537','2013-06-17','16:05:00',3.53),('8537','2013-06-17','16:10:00',3.48),('8537','2013-06-17','16:15:00',3.42),('8537','2013-06-17','16:20:00',3.31),('8537','2013-06-17','16:25:00',3.26),('8537','2013-06-17','16:30:00',3.06),('8537','2013-06-17','16:35:00',3.08),('8537','2013-06-17','16:40:00',3.01),('8537','2013-06-17','16:45:00',2.94),('8537','2013-06-17','16:50:00',2.88),('8537','2013-06-17','16:55:00',2.8),('8537','2013-06-17','17:00:00',2.73),('8537','2013-06-17','17:05:00',2.64),('8537','2013-06-17','17:10:00',2.55),('8537','2013-06-17','17:15:00',2.47),('8537','2013-06-17','17:20:00',2.4),('8537','2013-06-17','17:25:00',2.33),('8537','2013-06-17','17:30:00',2.17),('8537','2013-06-17','17:35:00',2.1),('8537','2013-06-17','17:40:00',2.02),('8537','2013-06-17','17:45:00',1.94),('8537','2013-06-17','17:50:00',1.84),('8537','2013-06-17','17:55:00',1.73),('8537','2013-06-17','18:00:00',1.62),('8537','2013-06-17','18:05:00',1.52),('8537','2013-06-17','18:10:00',1.46),('8537','2013-06-17','18:15:00',1.38),('8537','2013-06-17','18:20:00',1.29),('8537','2013-06-17','18:25:00',1.14),('8537','2013-06-17','18:30:00',1.11),('8537','2013-06-16','07:30:00',1.04),('8537','2013-06-16','07:35:00',1.14),('8537','2013-06-16','07:40:00',1.23),('8537','2013-06-16','07:45:00',1.32),('8537','2013-06-16','07:50:00',1.41),('8537','2013-06-16','07:55:00',1.51),('8537','2013-06-16','08:00:00',1.6),('8537','2013-06-16','08:05:00',1.7),('8537','2013-06-16','08:10:00',1.8),('8537','2013-06-16','08:15:00',1.89),('8537','2013-06-16','08:20:00',1.99),('8537','2013-06-16','08:25:00',2.09),('8537','2013-06-16','08:30:00',2.17),('8537','2013-06-16','08:35:00',2.3),('8537','2013-06-16','08:40:00',2.39),('8537','2013-06-16','08:45:00',2.48),('8537','2013-06-16','08:50:00',2.56),('8537','2013-06-16','08:55:00',2.63),('8537','2013-06-16','09:00:00',2.72),('8537','2013-06-16','09:05:00',2.79),('8537','2013-06-16','09:10:00',2.9),('8537','2013-06-16','09:15:00',3),('8537','2013-06-16','09:20:00',3.07),('8537','2013-06-16','09:25:00',3.14),('8537','2013-06-16','09:30:00',3.22),('8537','2013-06-16','09:35:00',3.3),('8537','2013-06-16','09:40:00',3.31),('8537','2013-06-16','09:45:00',3.38),('8537','2013-06-16','09:50:00',3.44),('8537','2013-06-16','09:55:00',3.47),('8537','2013-06-16','10:00:00',3.59),('8537','2013-06-16','10:05:00',3.67),('8537','2013-06-16','10:10:00',3.72),('8537','2013-06-16','10:15:00',3.78),('8537','2013-06-16','10:20:00',3.88),('8537','2013-06-16','10:25:00',3.88),('8537','2013-06-16','10:30:00',3.94),('8537','2013-06-16','10:35:00',3.99),('8537','2013-06-16','10:40:00',4.04),('8537','2013-06-16','10:45:00',4.11),('8537','2013-06-16','10:50:00',4.1),('8537','2013-06-16','10:55:00',4.16),('8537','2013-06-16','11:00:00',4.2),('8537','2013-06-16','11:05:00',4.28),('8537','2013-06-16','11:10:00',4.27),('8537','2013-06-16','11:15:00',4.33),('8537','2013-06-16','11:20:00',4.36),('8537','2013-06-16','11:25:00',4.44),('8537','2013-06-16','11:30:00',4.44),('8537','2013-06-16','11:35:00',4.51),('8537','2013-06-16','11:40:00',4.48),('8537','2013-06-16','11:45:00',4.53),('8537','2013-06-16','11:50:00',4.53),('8537','2013-06-16','11:55:00',4.62),('8537','2013-06-16','12:00:00',4.67),('8537','2013-06-16','12:05:00',4.64),('8537','2013-06-16','12:10:00',4.68),('8537','2013-06-16','12:15:00',4.7),('8537','2013-06-16','12:20:00',4.72),('8537','2013-06-16','12:25:00',4.72),('8537','2013-06-16','12:30:00',4.71),('8537','2013-06-16','12:35:00',4.74),('8537','2013-06-16','12:40:00',4.75),('8537','2013-06-16','12:45:00',4.74),('8537','2013-06-16','12:50:00',4.72),('8537','2013-06-16','12:55:00',4.74),('8537','2013-06-16','13:00:00',4.83),('8537','2013-06-16','13:05:00',4.89),('8537','2013-06-16','13:10:00',4.86),('8537','2013-06-16','13:15:00',4.83),('8537','2013-06-16','13:20:00',4.8),('8537','2013-06-16','13:25:00',4.85),('8537','2013-06-16','13:30:00',4.8),('8537','2013-06-16','13:35:00',4.84),('8537','2013-06-16','13:40:00',4.84),('8537','2013-06-16','13:45:00',4.78),('8537','2013-06-16','13:50:00',4.77),('8537','2013-06-16','13:55:00',4.75),('8537','2013-06-16','14:00:00',4.75),('8537','2013-06-16','14:05:00',4.69),('8537','2013-06-16','14:10:00',4.73),('8537','2013-06-16','14:15:00',4.7),('8537','2013-06-16','14:20:00',4.69),('8537','2013-06-16','14:25:00',4.64),('8537','2013-06-16','14:30:00',4.61),('8537','2013-06-16','14:35:00',4.55),('8537','2013-06-16','14:40:00',4.51),('8537','2013-06-16','14:45:00',4.32),('8537','2013-06-16','14:50:00',4.28),('8537','2013-06-16','14:55:00',4.36),('8537','2013-06-16','15:00:00',4.32),('8537','2013-06-16','15:05:00',4.3),('8537','2013-06-16','15:10:00',4.25),('8537','2013-06-16','15:15:00',4.21),('8537','2013-06-16','15:20:00',4.17),('8537','2013-06-16','15:25:00',4.14),('8537','2013-06-16','15:30:00',4.07),('8537','2013-06-16','15:35:00',4.03),('8537','2013-06-16','15:40:00',3.97),('8537','2013-06-16','15:45:00',3.86),('8537','2013-06-16','15:50:00',3.8),('8537','2013-06-16','15:55:00',3.74),('8537','2013-06-16','16:00:00',3.67),('8537','2013-06-16','16:05:00',3.62),('8537','2013-06-16','16:10:00',3.56),('8537','2013-06-16','16:15:00',3.5),('8537','2013-06-16','16:20:00',3.41),('8537','2013-06-16','16:25:00',3.34),('8537','2013-06-16','16:30:00',3.14),('8537','2013-06-16','16:35:00',3.16),('8537','2013-06-16','16:40:00',3.1),('8537','2013-06-16','16:45:00',3.02),('8537','2013-06-16','16:50:00',2.93),('8537','2013-06-16','16:55:00',2.85),('8537','2013-06-16','17:00:00',2.78),('8537','2013-06-16','17:05:00',2.68),('8537','2013-06-16','17:10:00',2.56),('8537','2013-06-16','17:15:00',2.49),('8537','2013-06-16','17:20:00',2.41),('8537','2013-06-16','17:25:00',2.31),('8537','2013-06-16','17:30:00',2.15),('8537','2013-06-16','17:35:00',2.07),('8537','2013-06-16','17:40:00',1.99),('8537','2013-06-16','17:45:00',1.9),('8537','2013-06-16','17:50:00',1.8),('8537','2013-06-16','17:55:00',1.68),('8537','2013-06-16','18:00:00',1.58),('8537','2013-06-16','18:05:00',1.48),('8537','2013-06-16','18:10:00',1.4),('8537','2013-06-16','18:15:00',1.31),('8537','2013-06-16','18:20:00',1.22),('8537','2013-06-16','18:25:00',1.12),('8537','2013-06-16','18:30:00',1.04),('8537','2013-06-15','07:35:00',1.09),('8537','2013-06-15','07:40:00',1.18),('8537','2013-06-15','07:45:00',1.29),('8537','2013-06-15','07:50:00',1.38),('8537','2013-06-15','07:55:00',1.47),('8537','2013-06-15','08:00:00',1.56),('8537','2013-06-15','08:05:00',1.67),('8537','2013-06-15','08:10:00',1.76),('8537','2013-06-15','08:15:00',1.88),('8537','2013-06-15','08:20:00',2),('8537','2013-06-15','08:25:00',2.05),('8537','2013-06-15','08:30:00',1.97),('8537','2013-06-15','08:35:00',2.13),('8537','2013-06-15','08:40:00',2.36),('8537','2013-06-15','08:45:00',2.45),('8537','2013-06-15','08:50:00',2.47),('8537','2013-06-15','08:55:00',2.62),('8537','2013-06-15','09:00:00',2.7),('8537','2013-06-15','09:05:00',2.83),('8537','2013-06-15','09:10:00',2.86),('8537','2013-06-15','09:15:00',2.84),('8537','2013-06-15','09:20:00',2.2),('8537','2013-06-15','09:25:00',3),('8537','2013-06-15','09:30:00',3.16),('8537','2013-06-15','09:35:00',3.08),('8537','2013-06-15','09:40:00',3.27),('8537','2013-06-15','09:45:00',3.07),('8537','2013-06-15','09:50:00',3.16),('8537','2013-06-15','09:55:00',3.58),('8537','2013-06-15','10:00:00',3.72),('8537','2013-06-15','10:05:00',3.79),('8537','2013-06-15','10:10:00',2.57),('8537','2013-06-15','10:15:00',1.46),('8537','2013-06-15','10:20:00',2.35),('8537','2013-06-15','10:25:00',3.29),('8537','2013-06-15','10:30:00',4.06),('8537','2013-06-15','10:35:00',3.74),('8537','2013-06-15','10:40:00',4.16),('8537','2013-06-15','10:45:00',4.19),('8537','2013-06-15','10:50:00',4.52),('8537','2013-06-15','10:55:00',4.2),('8537','2013-06-15','11:00:00',2.09),('8537','2013-06-15','11:05:00',1.65),('8537','2013-06-15','11:10:00',2.65),('8537','2013-06-15','11:15:00',4.64),('8537','2013-06-15','11:20:00',3.71),('8537','2013-06-15','11:25:00',2.51),('8537','2013-06-15','11:30:00',3.09),('8537','2013-06-15','11:35:00',4.64),('8537','2013-06-15','11:40:00',4.96),('8537','2013-06-15','11:45:00',4.72),('8537','2013-06-15','11:50:00',3.94),('8537','2013-06-15','11:55:00',4.89),('8537','2013-06-15','12:00:00',4.83),('8537','2013-06-15','12:05:00',4.78),('8537','2013-06-15','12:10:00',4.79),('8537','2013-06-15','12:15:00',4.93),('8537','2013-06-15','12:20:00',4.86),('8537','2013-06-15','12:25:00',4.74),('8537','2013-06-15','12:30:00',4.79),('8537','2013-06-15','12:35:00',4.86),('8537','2013-06-15','12:40:00',4.8),('8537','2013-06-15','12:45:00',4.86),('8537','2013-06-15','12:50:00',4.78),('8537','2013-06-15','12:55:00',4.84),('8537','2013-06-15','13:00:00',4.83),('8537','2013-06-15','13:05:00',4.86),('8537','2013-06-15','13:10:00',4.86),('8537','2013-06-15','13:15:00',4.89),('8537','2013-06-15','13:20:00',4.86),('8537','2013-06-15','13:25:00',4.82),('8537','2013-06-15','13:30:00',4.81),('8537','2013-06-15','13:35:00',4.73),('8537','2013-06-15','13:40:00',4.79),('8537','2013-06-15','13:45:00',4.77),('8537','2013-06-15','13:50:00',4.76),('8537','2013-06-15','13:55:00',4.75),('8537','2013-06-15','14:00:00',4.76),('8537','2013-06-15','14:05:00',4.73),('8537','2013-06-15','14:10:00',4.72),('8537','2013-06-15','14:15:00',4.7),('8537','2013-06-15','14:20:00',4.66),('8537','2013-06-15','14:25:00',4.64),('8537','2013-06-15','14:30:00',4.55),('8537','2013-06-15','14:35:00',4.54),('8537','2013-06-15','14:40:00',4.53),('8537','2013-06-15','14:45:00',4.32),('8537','2013-06-15','14:50:00',4.25),('8537','2013-06-15','14:55:00',4.36),('8537','2013-06-15','15:00:00',4.29),('8537','2013-06-15','15:05:00',4.24),('8537','2013-06-15','15:10:00',4.2),('8537','2013-06-15','15:15:00',4.19),('8537','2013-06-15','15:20:00',4.14),('8537','2013-06-15','15:25:00',4.13),('8537','2013-06-15','15:30:00',4.11),('8537','2013-06-15','15:35:00',4.06),('8537','2013-06-15','15:40:00',3.97),('8537','2013-06-15','15:45:00',3.7),('8537','2013-06-15','15:50:00',3.75),('8537','2013-06-15','15:55:00',3.76),('8537','2013-06-15','16:00:00',3.7),('8537','2013-06-15','16:05:00',3.62),('8537','2013-06-15','16:10:00',3.54),('8537','2013-06-15','16:15:00',3.48),('8537','2013-06-15','16:20:00',3.41),('8537','2013-06-15','16:25:00',3.3),('8537','2013-06-15','16:30:00',2.98),('8537','2013-06-15','16:35:00',3.02),('8537','2013-06-15','16:40:00',3.07),('8537','2013-06-15','16:45:00',3.01),('8537','2013-06-15','16:50:00',2.92),('8537','2013-06-15','16:55:00',2.84),('8537','2013-06-15','17:00:00',2.78),('8537','2013-06-15','17:05:00',2.64),('8537','2013-06-15','17:10:00',2.56),('8537','2013-06-15','17:15:00',2.47),('8537','2013-06-15','17:20:00',2.39),('8537','2013-06-15','17:25:00',2.29),('8537','2013-06-15','17:30:00',2.1),('8537','2013-06-15','17:35:00',2.05),('8537','2013-06-15','17:40:00',1.98),('8537','2013-06-15','17:45:00',1.86),('8537','2013-06-15','17:50:00',1.75),('8537','2013-06-15','17:55:00',1.65),('8537','2013-06-15','18:00:00',1.55),('8537','2013-06-15','18:05:00',1.46),('8537','2013-06-15','18:10:00',1.38),('8537','2013-06-15','18:15:00',1.3),('8537','2013-06-15','18:20:00',1.18),('8537','2013-06-15','18:25:00',1.1),('8537','2013-06-15','18:30:00',1.01),('8537','2013-06-14','07:25:00',1),('8537','2013-06-14','07:30:00',1.1),('8537','2013-06-14','07:35:00',1.21),('8537','2013-06-14','07:40:00',1.31),('8537','2013-06-14','07:45:00',1.41),('8537','2013-06-14','07:50:00',1.51),('8537','2013-06-14','07:55:00',1.61),('8537','2013-06-14','08:00:00',1.72),('8537','2013-06-14','08:05:00',1.82),('8537','2013-06-14','08:10:00',1.93),('8537','2013-06-14','08:15:00',2.03),('8537','2013-06-14','08:20:00',2.13),('8537','2013-06-14','08:25:00',2.23),('8537','2013-06-14','08:30:00',2.28),('8537','2013-06-14','08:35:00',2.42),('8537','2013-06-14','08:40:00',2.51),('8537','2013-06-14','08:45:00',2.62),('8537','2013-06-14','08:50:00',2.68),('8537','2013-06-14','08:55:00',2.75),('8537','2013-06-14','09:00:00',2.85),('8537','2013-06-14','09:05:00',2.93),('8537','2013-06-14','09:10:00',3.02),('8537','2013-06-14','09:15:00',3.1),('8537','2013-06-14','09:20:00',3.17),('8537','2013-06-14','09:25:00',3.24),('8537','2013-06-14','09:30:00',3.32),('8537','2013-06-14','09:35:00',3.42),('8537','2013-06-14','09:40:00',3.52),('8537','2013-06-14','09:45:00',3.58),('8537','2013-06-14','09:50:00',3.66),('8537','2013-06-14','09:55:00',3.72),('8537','2013-06-14','10:00:00',3.82),('8537','2013-06-14','10:05:00',3.85),('8537','2013-06-14','10:10:00',3.87),('8537','2013-06-14','10:15:00',3.89),('8537','2013-06-14','10:20:00',3.97),('8537','2013-06-14','10:25:00',4.02),('8537','2013-06-14','10:30:00',4.07),('8537','2013-06-14','10:35:00',4.19),('8537','2013-06-14','10:40:00',4.23),('8537','2013-06-14','10:45:00',4.3),('8537','2013-06-14','10:50:00',4.3),('8537','2013-06-14','10:55:00',4.28),('8537','2013-06-14','11:00:00',4.31),('8537','2013-06-14','11:05:00',4.37),('8537','2013-06-14','11:10:00',4.42),('8537','2013-06-14','11:15:00',4.5),('8537','2013-06-14','11:20:00',4.52),('8537','2013-06-14','11:25:00',4.48),('8537','2013-06-14','11:30:00',4.62),('8537','2013-06-14','11:35:00',4.64),('8537','2013-06-14','11:40:00',4.69),('8537','2013-06-14','11:45:00',4.7),('8537','2013-06-14','11:50:00',4.74),('8537','2013-06-14','11:55:00',4.71),('8537','2013-06-14','12:00:00',4.69),('8537','2013-06-14','12:05:00',4.71),('8537','2013-06-14','12:10:00',4.73),('8537','2013-06-14','12:15:00',4.75),('8537','2013-06-14','12:20:00',4.86),('8537','2013-06-14','12:25:00',4.84),('8537','2013-06-14','12:30:00',4.8),('8537','2013-06-14','12:35:00',4.82),('8537','2013-06-14','12:40:00',4.83),('8537','2013-06-14','12:45:00',4.83),('8537','2013-06-14','12:50:00',4.78),('8537','2013-06-14','12:55:00',4.76),('8537','2013-06-14','13:00:00',4.77),('8537','2013-06-14','13:05:00',4.8),('8537','2013-06-14','13:10:00',4.73),('8537','2013-06-14','13:15:00',4.77),('8537','2013-06-14','13:20:00',4.87),('8537','2013-06-14','13:25:00',4.53),('8537','2013-06-14','13:30:00',4.88),('8537','2013-06-14','13:35:00',4.82),('8537','2013-06-14','13:40:00',4.77),('8537','2013-06-14','13:45:00',4.79),('8537','2013-06-14','13:50:00',4.87),('8537','2013-06-14','13:55:00',4.8),('8537','2013-06-14','14:00:00',4.76),('8537','2013-06-14','14:05:00',4.82),('8537','2013-06-14','14:10:00',4.82),('8537','2013-06-14','14:15:00',4.74),('8537','2013-06-14','14:20:00',4.67),('8537','2013-06-14','14:25:00',4.67),('8537','2013-06-14','14:30:00',4.66),('8537','2013-06-14','14:35:00',4.54),('8537','2013-06-14','14:40:00',4.56),('8537','2013-06-14','14:45:00',4.33),('8537','2013-06-14','14:50:00',4.31),('8537','2013-06-14','14:55:00',4.44),('8537','2013-06-14','15:00:00',4.4),('8537','2013-06-14','15:05:00',4.34),('8537','2013-06-14','15:10:00',4.35),('8537','2013-06-14','15:15:00',4.31),('8537','2013-06-14','15:20:00',4.25),('8537','2013-06-14','15:25:00',4.18),('8537','2013-06-14','15:30:00',4.16),('8537','2013-06-14','15:35:00',4.11),('8537','2013-06-14','15:40:00',4.04),('8537','2013-06-14','15:45:00',3.79),('8537','2013-06-14','15:50:00',3.87),('8537','2013-06-14','15:55:00',3.81),('8537','2013-06-14','16:00:00',3.73),('8537','2013-06-14','16:05:00',3.68),('8537','2013-06-14','16:10:00',3.62),('8537','2013-06-14','16:15:00',3.54),('8537','2013-06-14','16:20:00',3.47),('8537','2013-06-14','16:25:00',3.36),('8537','2013-06-14','16:30:00',2.98),('8537','2013-06-14','16:35:00',3.08),('8537','2013-06-14','16:40:00',3.1),('8537','2013-06-14','16:45:00',3.04),('8537','2013-06-14','16:50:00',2.97),('8537','2013-06-14','16:55:00',2.89),('8537','2013-06-14','17:00:00',2.82),('8537','2013-06-14','17:05:00',2.63),('8537','2013-06-14','17:10:00',2.59),('8537','2013-06-14','17:15:00',2.56),('8537','2013-06-14','17:20:00',2.44),('8537','2013-06-14','17:25:00',2.33),('8537','2013-06-14','17:30:00',2.13),('8537','2013-06-14','17:35:00',2.08),('8537','2013-06-14','17:40:00',2.04),('8537','2013-06-14','17:45:00',1.95),('8537','2013-06-14','17:50:00',1.85),('8537','2013-06-14','17:55:00',1.74),('8537','2013-06-14','18:00:00',1.61),('8537','2013-06-14','18:05:00',1.54),('8537','2013-06-14','18:10:00',1.44),('8537','2013-06-14','18:15:00',1.36),('8537','2013-06-14','18:20:00',1.26),('8537','2013-06-14','18:25:00',1.15),('8537','2013-06-14','18:30:00',1.06),('8537','2013-06-13','07:25:00',1.01),('8537','2013-06-13','07:30:00',1.12),('8537','2013-06-13','07:35:00',1.22),('8537','2013-06-13','07:40:00',1.33),('8537','2013-06-13','07:45:00',1.42),('8537','2013-06-13','07:50:00',1.54),('8537','2013-06-13','07:55:00',1.64),('8537','2013-06-13','08:00:00',1.75),('8537','2013-06-13','08:05:00',1.85),('8537','2013-06-13','08:10:00',1.96),('8537','2013-06-13','08:15:00',2.05),('8537','2013-06-13','08:20:00',2.14),('8537','2013-06-13','08:25:00',2.21),('8537','2013-06-13','08:30:00',2.3),('8537','2013-06-13','08:35:00',2.41),('8537','2013-06-13','08:40:00',2.51),('8537','2013-06-13','08:45:00',2.6),('8537','2013-06-13','08:50:00',2.69),('8537','2013-06-13','08:55:00',2.78),('8537','2013-06-13','09:00:00',2.86),('8537','2013-06-13','09:05:00',2.97),('8537','2013-06-13','09:10:00',3.06),('8537','2013-06-13','09:15:00',3.18),('8537','2013-06-13','09:20:00',3.3),('8537','2013-06-13','09:25:00',3.4),('8537','2013-06-13','09:30:00',3.48),('8537','2013-06-13','09:35:00',3.54),('8537','2013-06-13','09:40:00',3.62),('8537','2013-06-13','09:45:00',3.69),('8537','2013-06-13','09:50:00',3.76),('8537','2013-06-13','09:55:00',3.83),('8537','2013-06-13','10:00:00',3.9),('8537','2013-06-13','10:05:00',3.98),('8537','2013-06-13','10:10:00',4.03),('8537','2013-06-13','10:15:00',4.09),('8537','2013-06-13','10:20:00',4.13),('8537','2013-06-13','10:25:00',4.18),('8537','2013-06-13','10:30:00',4.24),('8537','2013-06-13','10:35:00',4.31),('8537','2013-06-13','10:40:00',4.35),('8537','2013-06-13','10:45:00',4.47),('8537','2013-06-13','10:50:00',4.42),('8537','2013-06-13','10:55:00',4.55),('8537','2013-06-13','11:00:00',4.56),('8537','2013-06-13','11:05:00',4.64),('8537','2013-06-13','11:10:00',4.65),('8537','2013-06-13','11:15:00',4.71),('8537','2013-06-13','11:20:00',4.73),('8537','2013-06-13','11:25:00',4.8),('8537','2013-06-13','11:30:00',4.84),('8537','2013-06-13','11:35:00',4.88),('8537','2013-06-13','11:40:00',4.9),('8537','2013-06-13','11:45:00',4.94),('8537','2013-06-13','11:50:00',4.96),('8537','2013-06-13','11:55:00',4.94),('8537','2013-06-13','12:00:00',4.97),('8537','2013-06-13','12:05:00',5.01),('8537','2013-06-13','12:10:00',5.04),('8537','2013-06-13','12:15:00',5.07),('8537','2013-06-13','12:20:00',5.08),('8537','2013-06-13','12:25:00',5.11),('8537','2013-06-13','12:30:00',5.14),('8537','2013-06-13','12:35:00',5.12),('8537','2013-06-13','12:40:00',5.14),('8537','2013-06-13','12:45:00',5.15),('8537','2013-06-13','12:50:00',5.15),('8537','2013-06-13','12:55:00',5.13),('8537','2013-06-13','13:00:00',5.15),('8537','2013-06-13','13:05:00',5.16),('8537','2013-06-13','13:10:00',5.16),('8537','2013-06-13','13:15:00',5.15),('8537','2013-06-13','13:20:00',5.1),('8537','2013-06-13','13:25:00',5.09),('8537','2013-06-13','13:30:00',5.08),('8537','2013-06-13','13:35:00',5.1),('8537','2013-06-13','13:40:00',5.1),('8537','2013-06-13','13:45:00',5.06),('8537','2013-06-13','13:50:00',4.98),('8537','2013-06-13','13:55:00',5.01),('8537','2013-06-13','14:00:00',4.99),('8537','2013-06-13','14:05:00',4.98),('8537','2013-06-13','14:10:00',4.95),('8537','2013-06-13','14:15:00',4.97),('8537','2013-06-13','14:20:00',4.95),('8537','2013-06-13','14:25:00',5.02),('8537','2013-06-13','14:30:00',3.44),('8537','2013-06-13','14:35:00',3.47),('8537','2013-06-13','14:40:00',4.83),('8537','2013-06-13','14:45:00',4.63),('8537','2013-06-13','14:50:00',4.34),('8537','2013-06-13','14:55:00',4.58),('8537','2013-06-13','15:00:00',4.55),('8537','2013-06-13','15:05:00',4.47),('8537','2013-06-13','15:10:00',4.44),('8537','2013-06-13','15:15:00',4.39),('8537','2013-06-13','15:20:00',4.35),('8537','2013-06-13','15:25:00',4.28),('8537','2013-06-13','15:30:00',4.23),('8537','2013-06-13','15:35:00',4.19),('8537','2013-06-13','15:40:00',4.1),('8537','2013-06-13','15:45:00',3.78),('8537','2013-06-13','15:50:00',3.94),('8537','2013-06-13','15:55:00',3.91),('8537','2013-06-13','16:00:00',3.82),('8537','2013-06-13','16:05:00',3.75),('8537','2013-06-13','16:10:00',3.67),('8537','2013-06-13','16:15:00',3.59),('8537','2013-06-13','16:20:00',3.51),('8537','2013-06-13','16:25:00',3.36),('8537','2013-06-13','16:30:00',3.02),('8537','2013-06-13','16:35:00',3.22),('8537','2013-06-13','16:40:00',3.15),('8537','2013-06-13','16:45:00',3.07),('8537','2013-06-13','16:50:00',2.93),('8537','2013-06-13','16:55:00',2.88),('8537','2013-06-13','17:00:00',2.79),('8537','2013-06-13','17:05:00',2.62),('8537','2013-06-13','17:10:00',2.58),('8537','2013-06-13','17:15:00',2.52),('8537','2013-06-13','17:20:00',2.43),('8537','2013-06-13','17:25:00',2.34),('8537','2013-06-13','17:30:00',2.17),('8537','2013-06-13','17:35:00',2.11),('8537','2013-06-13','17:40:00',2.02),('8537','2013-06-13','17:45:00',1.93),('8537','2013-06-13','17:50:00',1.83),('8537','2013-06-13','17:55:00',1.72),('8537','2013-06-13','18:00:00',1.58),('8537','2013-06-13','18:05:00',1.5),('8537','2013-06-13','18:10:00',1.38),('8537','2013-06-13','18:15:00',1.33),('8537','2013-06-13','18:20:00',1.24),('8537','2013-06-13','18:25:00',1.13),('8537','2013-06-13','18:30:00',1.05),('8537','2013-06-12','07:25:00',1.03),('8537','2013-06-12','07:30:00',1.13),('8537','2013-06-12','07:35:00',1.23),('8537','2013-06-12','07:40:00',1.33),('8537','2013-06-12','07:45:00',1.43),('8537','2013-06-12','07:50:00',1.53),('8537','2013-06-12','07:55:00',1.64),('8537','2013-06-12','08:00:00',1.75),('8537','2013-06-12','08:05:00',1.85),('8537','2013-06-12','08:10:00',1.97),('8537','2013-06-12','08:15:00',2.08),('8537','2013-06-12','08:20:00',2.19),('8537','2013-06-12','08:25:00',2.3),('8537','2013-06-12','08:30:00',2.4),('8537','2013-06-12','08:35:00',2.49),('8537','2013-06-12','08:40:00',2.6),('8537','2013-06-12','08:45:00',2.71),('8537','2013-06-12','08:50:00',2.81),('8537','2013-06-12','08:55:00',2.9),('8537','2013-06-12','09:00:00',2.98),('8537','2013-06-12','09:05:00',3.07),('8537','2013-06-12','09:10:00',3.18),('8537','2013-06-12','09:15:00',3.27),('8537','2013-06-12','09:20:00',3.35),('8537','2013-06-12','09:25:00',3.43),('8537','2013-06-12','09:30:00',3.5),('8537','2013-06-12','09:35:00',3.58),('8537','2013-06-12','09:40:00',3.65),('8537','2013-06-12','09:45:00',3.73),('8537','2013-06-12','09:50:00',3.81),('8537','2013-06-12','09:55:00',3.89),('8537','2013-06-12','10:00:00',3.93),('8537','2013-06-12','10:05:00',3.98),('8537','2013-06-12','10:10:00',4.02),('8537','2013-06-12','10:15:00',4.1),('8537','2013-06-12','10:20:00',4.21),('8537','2013-06-12','10:25:00',4.26),('8537','2013-06-12','10:30:00',4.31),('8537','2013-06-12','10:35:00',4.32),('8537','2013-06-12','10:40:00',4.37),('8537','2013-06-12','10:45:00',4.44),('8537','2013-06-12','10:50:00',4.55),('8537','2013-06-12','10:55:00',4.62),('8537','2013-06-12','11:00:00',4.69),('8537','2013-06-12','11:05:00',4.7),('8537','2013-06-12','11:10:00',4.76),('8537','2013-06-12','11:15:00',4.79),('8537','2013-06-12','11:20:00',4.82),('8537','2013-06-12','11:25:00',4.84),('8537','2013-06-12','11:30:00',4.87),('8537','2013-06-12','11:35:00',4.89),('8537','2013-06-12','11:40:00',4.94),('8537','2013-06-12','11:45:00',4.95),('8537','2013-06-12','11:50:00',5),('8537','2013-06-12','11:55:00',5.08),('8537','2013-06-12','12:00:00',5.04),('8537','2013-06-12','12:05:00',5.09),('8537','2013-06-12','12:10:00',5.07),('8537','2013-06-12','12:15:00',5.1),('8537','2013-06-12','12:20:00',5.08),('8537','2013-06-12','12:25:00',4.8),('8537','2013-06-12','12:30:00',3.85),('8537','2013-06-12','12:35:00',5.48),('8537','2013-06-12','12:40:00',2.73),('8537','2013-06-12','12:45:00',3.73),('8537','2013-06-12','12:50:00',5.66),('8537','2013-06-12','12:55:00',3.6),('8537','2013-06-12','13:00:00',4.64),('8537','2013-06-12','13:05:00',4.09),('8537','2013-06-12','13:10:00',5.32),('8537','2013-06-12','13:15:00',5.17),('8537','2013-06-12','13:20:00',5.11),('8537','2013-06-12','13:25:00',5.02),('8537','2013-06-12','13:30:00',5.03),('8537','2013-06-12','13:35:00',5.14),('8537','2013-06-12','13:40:00',5.13),('8537','2013-06-12','13:45:00',5.15),('8537','2013-06-12','13:50:00',5.13),('8537','2013-06-12','13:55:00',5.22),('8537','2013-06-12','14:00:00',4.93),('8537','2013-06-12','14:05:00',2.88),('8537','2013-06-12','14:10:00',3.75),('8537','2013-06-12','14:15:00',5.26),('8537','2013-06-12','14:20:00',2.63),('8537','2013-06-12','14:25:00',2.33),('8537','2013-06-12','14:30:00',5.24),('8537','2013-06-12','14:35:00',4.91),('8537','2013-06-12','14:40:00',5.02),('8537','2013-06-12','14:45:00',4.58),('8537','2013-06-12','14:50:00',4.9),('8537','2013-06-12','14:55:00',4.92),('8537','2013-06-12','15:00:00',4.8),('8537','2013-06-12','15:05:00',4.42),('8537','2013-06-12','15:10:00',4.62),('8537','2013-06-12','15:15:00',3.58),('8537','2013-06-12','15:20:00',4.57),('8537','2013-06-12','15:25:00',4.32),('8537','2013-06-12','15:30:00',4.31),('8537','2013-06-12','15:35:00',4.31),('8537','2013-06-12','15:40:00',4.18),('8537','2013-06-12','15:45:00',3.92),('8537','2013-06-12','15:50:00',3.99),('8537','2013-06-12','15:55:00',4),('8537','2013-06-12','16:00:00',3.93),('8537','2013-06-12','16:05:00',3.67),('8537','2013-06-12','16:10:00',3.81),('8537','2013-06-12','16:15:00',3.73),('8537','2013-06-12','16:20:00',3.6),('8537','2013-06-12','16:25:00',3.5),('8537','2013-06-12','16:30:00',3.12),('8537','2013-06-12','16:35:00',3.28),('8537','2013-06-12','16:40:00',3.27),('8537','2013-06-12','16:45:00',2.97),('8537','2013-06-12','16:50:00',3.12),('8537','2013-06-12','16:55:00',3),('8537','2013-06-12','17:00:00',2.87),('8537','2013-06-12','17:05:00',2.72),('8537','2013-06-12','17:10:00',2.58),('8537','2013-06-12','17:15:00',2.6),('8537','2013-06-12','17:20:00',2.49),('8537','2013-06-12','17:25:00',2.37),('8537','2013-06-12','17:30:00',2.21),('8537','2013-06-12','17:35:00',2.18),('8537','2013-06-12','17:40:00',2.12),('8537','2013-06-12','17:45:00',1.76),('8537','2013-06-12','17:50:00',1.09),('8537','2013-06-12','18:05:00',1.37),('8537','2013-06-12','18:10:00',1.49),('8537','2013-06-12','18:15:00',1.42),('8537','2013-06-12','18:20:00',1.31),('8537','2013-06-12','18:25:00',1.09),('8537','2013-06-12','18:30:00',1.06),('8537','2013-06-11','07:25:00',1.2),('8537','2013-06-11','07:30:00',1.03),('8537','2013-06-11','07:35:00',1.21),('8537','2013-06-11','07:40:00',1.29),('8537','2013-06-11','07:45:00',1.26),('8537','2013-06-11','07:50:00',1.07),('8537','2013-06-11','08:00:00',1.85),('8537','2013-06-11','08:05:00',2.04),('8537','2013-06-11','08:10:00',2.19),('8537','2013-06-11','08:15:00',1.9),('8537','2013-06-11','08:20:00',1.07),('8537','2013-06-11','08:25:00',1.56),('8537','2013-06-11','08:30:00',2.46),('8537','2013-06-11','08:35:00',2.63),('8537','2013-06-11','08:40:00',2.89),('8537','2013-06-11','08:45:00',2.88),('8537','2013-06-11','08:50:00',3.01),('8537','2013-06-11','08:55:00',2.97),('8537','2013-06-11','09:00:00',1.16),('8537','2013-06-11','09:05:00',1.25),('8537','2013-06-11','09:10:00',2.92),('8537','2013-06-11','09:15:00',3.43),('8537','2013-06-11','09:20:00',3.5),('8537','2013-06-11','09:25:00',3.48),('8537','2013-06-11','09:30:00',2.48),('8537','2013-06-11','09:35:00',2.48),('8537','2013-06-11','09:45:00',1.99),('8537','2013-06-11','09:50:00',3.82),('8537','2013-06-11','09:55:00',4.15),('8537','2013-06-11','10:00:00',4.21),('8537','2013-06-11','10:05:00',2.11),('8537','2013-06-11','10:10:00',4.18),('8537','2013-06-11','10:15:00',4.24),('8537','2013-06-11','10:20:00',4.29),('8537','2013-06-11','10:25:00',4.36),('8537','2013-06-11','10:30:00',4.04),('8537','2013-06-11','10:35:00',4.41),('8537','2013-06-11','10:40:00',3.27),('8537','2013-06-11','10:45:00',3.79),('8537','2013-06-11','10:50:00',4.29),('8537','2013-06-11','10:55:00',2.29),('8537','2013-06-11','11:00:00',4.05),('8537','2013-06-11','11:05:00',4.43),('8537','2013-06-11','11:10:00',2.18),('8537','2013-06-11','11:15:00',5.2),('8537','2013-06-11','11:20:00',4.95),('8537','2013-06-11','11:25:00',4.91),('8537','2013-06-11','11:30:00',4.91),('8537','2013-06-11','11:35:00',4.87),('8537','2013-06-11','11:40:00',4.91),('8537','2013-06-11','11:45:00',4.95),('8537','2013-06-11','11:50:00',5.03),('8537','2013-06-11','11:55:00',5.07),('8537','2013-06-11','12:00:00',5.13),('8537','2013-06-11','12:05:00',5.17),('8537','2013-06-11','12:10:00',5.08),('8537','2013-06-11','12:15:00',5.11),('8537','2013-06-11','12:20:00',5.11),('8537','2013-06-11','12:25:00',5.15),('8537','2013-06-11','12:30:00',5.18),('8537','2013-06-11','12:35:00',5.18),('8537','2013-06-11','12:40:00',5.22),('8537','2013-06-11','12:45:00',5.22),('8537','2013-06-11','12:50:00',5.23),('8537','2013-06-11','12:55:00',5.26),('8537','2013-06-11','13:00:00',5.26),('8537','2013-06-11','13:05:00',5.26),('8537','2013-06-11','13:10:00',5.26),('8537','2013-06-11','13:15:00',5.3),('8537','2013-06-11','13:20:00',5.24),('8537','2013-06-11','13:25:00',5.19),('8537','2013-06-11','13:30:00',5.25),('8537','2013-06-11','13:35:00',5.27),('8537','2013-06-11','13:40:00',5.25),('8537','2013-06-11','13:45:00',5.27),('8537','2013-06-11','13:50:00',3.86),('8537','2013-06-11','13:55:00',5.3),('8537','2013-06-11','14:00:00',5.22),('8537','2013-06-11','14:05:00',5.13),('8537','2013-06-11','14:10:00',5.07),('8537','2013-06-11','14:15:00',5.02),('8537','2013-06-11','14:20:00',4.98),('8537','2013-06-11','14:25:00',4.95),('8537','2013-06-11','14:30:00',4.94),('8537','2013-06-11','14:35:00',4.89),('8537','2013-06-11','14:40:00',4.82),('8537','2013-06-11','14:45:00',4.57),('8537','2013-06-11','14:50:00',4.16),('8537','2013-06-11','14:55:00',4.51),('8537','2013-06-11','15:00:00',4.6),('8537','2013-06-11','15:05:00',4.58),('8537','2013-06-11','15:10:00',4.5),('8537','2013-06-11','15:15:00',4.48),('8537','2013-06-11','15:20:00',4.44),('8537','2013-06-11','15:25:00',4.34),('8537','2013-06-11','15:30:00',4.3),('8537','2013-06-11','15:35:00',4.33),('8537','2013-06-11','15:40:00',4.26),('8537','2013-06-11','15:45:00',4),('8537','2013-06-11','15:50:00',4.11),('8537','2013-06-11','15:55:00',4.06),('8537','2013-06-11','16:00:00',3.97),('8537','2013-06-11','16:05:00',3.88),('8537','2013-06-11','16:10:00',3.82),('8537','2013-06-11','16:15:00',3.75),('8537','2013-06-11','16:20:00',3.67),('8537','2013-06-11','16:25:00',3.55),('8537','2013-06-11','16:30:00',3.48),('8537','2013-06-11','16:35:00',3.41),('8537','2013-06-11','16:40:00',3.44),('8537','2013-06-11','16:45:00',3.56),('8537','2013-06-11','16:50:00',3.59),('8537','2013-06-11','16:55:00',3.43),('8537','2013-06-11','17:00:00',3.17),('8537','2013-06-11','17:05:00',2.2),('8537','2013-06-11','17:10:00',1.08),('8537','2014-04-03','08:45:00',1.08),('8537','2014-04-03','08:50:00',1.13),('8537','2014-04-03','08:55:00',1.3),('8537','2014-04-03','09:00:00',1.44),('8537','2014-04-03','09:05:00',1.56),('8537','2014-04-03','09:10:00',1.51),('8537','2014-04-03','09:15:00',1.38),('8537','2014-04-03','09:20:00',1.39),('8537','2014-04-03','09:25:00',1.48),('8537','2014-04-03','09:30:00',1.73),('8537','2014-04-03','09:35:00',2.1),('8537','2014-04-03','09:40:00',2.26),('8537','2014-04-03','09:45:00',2.21),('8537','2014-04-03','09:50:00',2.1),('8537','2014-04-03','09:55:00',2.18),('8537','2014-04-03','10:00:00',2.62),('8537','2014-04-03','10:05:00',3.08),('8537','2014-04-03','10:10:00',3.29),('8537','2014-04-03','10:15:00',3.74),('8537','2014-04-03','10:20:00',3.83),('8537','2014-04-03','10:25:00',3.43),('8537','2014-04-03','10:30:00',3.16),('8537','2014-04-03','10:35:00',3.48),('8537','2014-04-03','10:40:00',2.74),('8537','2014-04-03','10:45:00',2.92),('8537','2014-04-03','10:50:00',2.46),('8537','2014-04-03','10:55:00',2.56),('8537','2014-04-03','11:00:00',2.42),('8537','2014-04-03','11:05:00',1.99),('8537','2014-04-03','11:10:00',1.87),('8537','2014-04-03','11:15:00',1.74),('8537','2014-04-03','11:20:00',1.66),('8537','2014-04-03','11:25:00',1.54),('8537','2014-04-03','11:30:00',1.52),('8537','2014-04-03','11:35:00',1.62),('8537','2014-04-03','11:40:00',1.79),('8537','2014-04-03','11:45:00',2.03),('8537','2014-04-03','11:50:00',2.55),('8537','2014-04-03','11:55:00',2.86),('8537','2014-04-03','12:00:00',2.69),('8537','2014-04-03','12:05:00',2.7),('8537','2014-04-03','12:10:00',2.6),('8537','2014-04-03','12:15:00',2.54),('8537','2014-04-03','12:20:00',2.84),('8537','2014-04-03','12:25:00',3.42),('8537','2014-04-03','12:30:00',4.57),('8537','2014-04-03','12:35:00',4.45),('8537','2014-04-03','12:40:00',4.99),('8537','2014-04-03','12:45:00',2.84),('8537','2014-04-03','12:50:00',3.22),('8537','2014-04-03','12:55:00',3.16),('8537','2014-04-03','13:00:00',3.05),('8537','2014-04-03','13:05:00',3.97),('8537','2014-04-03','13:10:00',2.8),('8537','2014-04-03','13:15:00',5.43),('8537','2014-04-03','13:20:00',3.54),('8537','2014-04-03','13:25:00',3.36),('8537','2014-04-03','13:30:00',3.38),('8537','2014-04-03','13:35:00',5.31),('8537','2014-04-03','13:40:00',4.82),('8537','2014-04-03','13:45:00',2.7),('8537','2014-04-03','13:50:00',2.51),('8537','2014-04-03','13:55:00',3.09),('8537','2014-04-03','14:00:00',4.5),('8537','2014-04-03','14:05:00',4.23),('8537','2014-04-03','14:10:00',3.28),('8537','2014-04-03','14:15:00',4.3),('8537','2014-04-03','14:20:00',4.49),('8537','2014-04-03','14:25:00',4.57),('8537','2014-04-03','14:30:00',4.58),('8537','2014-04-03','14:35:00',4.59),('8537','2014-04-03','14:40:00',4.47),('8537','2014-04-03','14:45:00',4.38),('8537','2014-04-03','14:50:00',4.27),('8537','2014-04-03','14:55:00',4.23),('8537','2014-04-03','15:00:00',4.19),('8537','2014-04-03','15:05:00',4.15),('8537','2014-04-03','15:10:00',4.08),('8537','2014-04-03','15:15:00',4.07),('8537','2014-04-03','15:20:00',4.06),('8537','2014-04-03','15:25:00',3.96),('8537','2014-04-03','15:30:00',3.91),('8537','2014-04-03','15:35:00',3.84),('8537','2014-04-03','15:40:00',3.78),('8537','2014-04-03','15:45:00',3.75),('8537','2014-04-03','15:50:00',3.71),('8537','2014-04-03','15:55:00',3.68),('8537','2014-04-03','16:00:00',3.58),('8537','2014-04-03','16:05:00',3.43),('8537','2014-04-03','16:10:00',3.45),('8537','2014-04-03','16:15:00',3.32),('8537','2014-04-03','16:20:00',3.28),('8537','2014-04-03','16:25:00',3.17),('8537','2014-04-03','16:30:00',3.1),('8537','2014-04-03','16:35:00',2.91),('8537','2014-04-03','16:40:00',2.68),('8537','2014-04-03','16:45:00',2.67),('8537','2014-04-03','16:50:00',2.1),('8537','2014-04-03','16:55:00',1.61),('8537','2014-04-03','17:00:00',1.19),('8537','2014-04-03','17:05:00',1.09),('8537','2014-04-03','17:50:00',1.35),('8537','2014-04-03','17:55:00',1.2),('8537','2014-04-03','18:00:00',1.08),('8537','2013-06-10','07:30:00',1.26),('8537','2013-06-10','07:35:00',1.75),('8537','2013-06-10','07:40:00',1.23),('8537','2013-06-10','08:00:00',1.36),('8537','2013-06-10','08:05:00',1.73),('8537','2013-06-10','08:10:00',2.27),('8537','2013-06-10','08:15:00',1.94),('8537','2013-06-10','08:20:00',2.26),('8537','2013-06-10','08:25:00',1.43),('8537','2013-06-10','08:30:00',1.43),('8537','2013-06-10','08:35:00',1.34),('8537','2013-06-10','08:40:00',1.18),('8537','2013-06-10','08:50:00',1.07),('8537','2013-06-10','08:55:00',1.2),('8537','2013-06-10','09:00:00',1.37),('8537','2013-06-10','09:05:00',1.27),('8537','2013-06-10','09:10:00',2.2),('8537','2013-06-10','09:15:00',1.16),('8537','2013-06-10','09:20:00',2.07),('8537','2013-06-10','09:25:00',1.95),('8537','2013-06-10','09:30:00',2.45),('8537','2013-06-10','09:35:00',3.82),('8537','2013-06-10','09:40:00',2.75),('8537','2013-06-10','09:45:00',4.09),('8537','2013-06-10','09:50:00',2.15),('8537','2013-06-10','09:55:00',2.03),('8537','2013-06-10','10:00:00',2.66),('8537','2013-06-10','10:05:00',2.81),('8537','2013-06-10','10:10:00',3.32),('8537','2013-06-10','10:15:00',3.03),('8537','2013-06-10','10:20:00',2.92),('8537','2013-06-10','10:25:00',2.69),('8537','2013-06-10','10:30:00',1.8),('8537','2013-06-10','10:35:00',2.21),('8537','2013-06-10','10:40:00',1.85),('8537','2013-06-10','10:45:00',1.46),('8537','2013-06-10','10:50:00',2.39),('8537','2013-06-10','10:55:00',3.13),('8537','2013-06-10','11:00:00',3.45),('8537','2013-06-10','11:05:00',2.76),('8537','2013-06-10','11:10:00',3.73),('8537','2013-06-10','11:15:00',4.83),('8537','2013-06-10','11:20:00',4.53),('8537','2013-06-10','11:25:00',5.25),('8537','2013-06-10','11:30:00',4.75),('8537','2013-06-10','11:35:00',5.54),('8537','2013-06-10','11:40:00',4.01),('8537','2013-06-10','11:45:00',4.11),('8537','2013-06-10','11:50:00',2.72),('8537','2013-06-10','11:55:00',4.15),('8537','2013-06-10','12:00:00',5.78),('8537','2013-06-10','12:05:00',2.05),('8537','2013-06-10','12:10:00',5.19),('8537','2013-06-10','12:15:00',5.27),('8537','2013-06-10','12:20:00',5.39),('8537','2013-06-10','12:25:00',5.05),('8537','2013-06-10','12:30:00',5.41),('8537','2013-06-10','12:35:00',3.77),('8537','2013-06-10','12:40:00',3.68),('8537','2013-06-10','12:45:00',4.37),('8537','2013-06-10','12:50:00',3.25),('8537','2013-06-10','12:55:00',3.01),('8537','2013-06-10','13:00:00',5.62),('8537','2013-06-10','13:05:00',4.84),('8537','2013-06-10','13:10:00',3.02),('8537','2013-06-10','13:15:00',3.81),('8537','2013-06-10','13:20:00',2.91),('8537','2013-06-10','13:25:00',3.53),('8537','2013-06-10','13:30:00',2.88),('8537','2013-06-10','13:35:00',5.29),('8537','2013-06-10','13:40:00',4.13),('8537','2013-06-10','13:45:00',3.71),('8537','2013-06-10','13:50:00',4.3),('8537','2013-06-10','13:55:00',5.23),('8537','2013-06-10','14:00:00',5.46),('8537','2013-06-10','14:05:00',5.39),('8537','2013-06-10','14:10:00',4.73),('8537','2013-06-10','14:15:00',5.09),('8537','2013-06-10','14:20:00',5.14);
INSERT INTO `solarlogmod` VALUES ('8537','2013-06-10','14:25:00',5.07),('8537','2013-06-10','14:30:00',4.98),('8537','2013-06-10','14:35:00',4.95),('8537','2013-06-10','14:40:00',4.24),('8537','2013-06-10','14:45:00',4.87),('8537','2013-06-10','14:50:00',4.79),('8537','2013-06-10','14:55:00',4.76),('8537','2013-06-10','15:00:00',4.7),('8537','2013-06-10','15:05:00',4.66),('8537','2013-06-10','15:10:00',4.59),('8537','2013-06-10','15:15:00',4.56),('8537','2013-06-10','15:20:00',4.52),('8537','2013-06-10','15:25:00',4.46),('8537','2013-06-10','15:30:00',4.43),('8537','2013-06-10','15:35:00',4.37),('8537','2013-06-10','15:40:00',4.23),('8537','2013-06-10','15:45:00',4.1),('8537','2013-06-10','15:50:00',4.13),('8537','2013-06-10','15:55:00',4.08),('8537','2013-06-10','16:00:00',4),('8537','2013-06-10','16:05:00',3.93),('8537','2013-06-10','16:10:00',3.85),('8537','2013-06-10','16:15:00',3.79),('8537','2013-06-10','16:20:00',3.7),('8537','2013-06-10','16:25:00',3.5),('8537','2013-06-10','16:30:00',3.35),('8537','2013-06-10','16:35:00',3.43),('8537','2013-06-10','16:40:00',3.33),('8537','2013-06-10','16:45:00',3.25),('8537','2013-06-10','16:50:00',3.18),('8537','2013-06-10','16:55:00',3.09),('8537','2013-06-10','17:00:00',3.03),('8537','2013-06-10','17:05:00',2.76),('8537','2013-06-10','17:10:00',2.76),('8537','2013-06-10','17:15:00',2.72),('8537','2013-06-10','17:20:00',2.64),('8537','2013-06-10','17:25:00',2.51),('8537','2013-06-10','17:30:00',2.33),('8537','2013-06-10','17:35:00',2.27),('8537','2013-06-10','17:40:00',2.17),('8537','2013-06-10','17:45:00',2.06),('8537','2013-06-10','17:50:00',1.93),('8537','2013-06-10','17:55:00',1.85),('8537','2013-06-10','18:00:00',1.71),('8537','2013-06-10','18:05:00',1.62),('8537','2013-06-10','18:10:00',1.52),('8537','2013-06-10','18:15:00',1.42),('8537','2013-06-10','18:20:00',1.32),('8537','2013-06-10','18:25:00',1.2),('8537','2013-06-10','18:30:00',1.11),('8537','2013-06-10','18:35:00',1.02),('8537','2013-06-09','07:35:00',1.48),('8537','2013-06-09','07:40:00',1.31),('8537','2013-06-09','07:50:00',1.06),('8537','2013-06-09','07:55:00',1.62),('8537','2013-06-09','08:00:00',1.71),('8537','2013-06-09','08:05:00',1.82),('8537','2013-06-09','08:10:00',1.92),('8537','2013-06-09','08:15:00',2.16),('8537','2013-06-09','08:20:00',2.13),('8537','2013-06-09','08:25:00',2.15),('8537','2013-06-09','08:30:00',2.22),('8537','2013-06-09','08:35:00',2.34),('8537','2013-06-09','08:40:00',2.41),('8537','2013-06-09','08:45:00',2.55),('8537','2013-06-09','08:50:00',2.63),('8537','2013-06-09','08:55:00',2.67),('8537','2013-06-09','09:00:00',2.79),('8537','2013-06-09','09:05:00',2.88),('8537','2013-06-09','09:10:00',2.94),('8537','2013-06-09','09:15:00',3.04),('8537','2013-06-09','09:20:00',3.14),('8537','2013-06-09','09:25:00',3.21),('8537','2013-06-09','09:30:00',3.32),('8537','2013-06-09','09:35:00',3.38),('8537','2013-06-09','09:40:00',3.47),('8537','2013-06-09','09:45:00',3.51),('8537','2013-06-09','09:50:00',3.55),('8537','2013-06-09','09:55:00',3.66),('8537','2013-06-09','10:00:00',3.72),('8537','2013-06-09','10:05:00',3.76),('8537','2013-06-09','10:10:00',3.81),('8537','2013-06-09','10:15:00',3.85),('8537','2013-06-09','10:20:00',3.93),('8537','2013-06-09','10:25:00',3.96),('8537','2013-06-09','10:30:00',4.04),('8537','2013-06-09','10:35:00',4.12),('8537','2013-06-09','10:40:00',4.13),('8537','2013-06-09','10:45:00',4.17),('8537','2013-06-09','10:50:00',4.22),('8537','2013-06-09','10:55:00',4.29),('8537','2013-06-09','11:00:00',4.31),('8537','2013-06-09','11:05:00',4.32),('8537','2013-06-09','11:10:00',4.34),('8537','2013-06-09','11:15:00',4.4),('8537','2013-06-09','11:20:00',4.48),('8537','2013-06-09','11:25:00',4.51),('8537','2013-06-09','11:30:00',4.55),('8537','2013-06-09','11:35:00',4.53),('8537','2013-06-09','11:40:00',4.55),('8537','2013-06-09','11:45:00',4.62),('8537','2013-06-09','11:50:00',4.66),('8537','2013-06-09','11:55:00',4.64),('8537','2013-06-09','12:00:00',4.64),('8537','2013-06-09','12:05:00',4.73),('8537','2013-06-09','12:10:00',4.03),('8537','2013-06-09','12:15:00',4.46),('8537','2013-06-09','12:20:00',4.78),('8537','2013-06-09','12:25:00',4.67),('8537','2013-06-09','12:30:00',4.8),('8537','2013-06-09','12:35:00',4.8),('8537','2013-06-09','12:40:00',4.79),('8537','2013-06-09','12:45:00',4.75),('8537','2013-06-09','12:50:00',4.5),('8537','2013-06-09','12:55:00',4.82),('8537','2013-06-09','13:00:00',4.55),('8537','2013-06-09','13:05:00',4.45),('8537','2013-06-09','13:10:00',4.52),('8537','2013-06-09','13:15:00',4.14),('8537','2013-06-09','13:20:00',5.31),('8537','2013-06-09','13:25:00',5.2),('8537','2013-06-09','13:30:00',5.03),('8537','2013-06-09','13:35:00',5.01),('8537','2013-06-09','13:40:00',5.16),('8537','2013-06-09','13:45:00',5.22),('8537','2013-06-09','13:50:00',5.4),('8537','2013-06-09','13:55:00',5.46),('8537','2013-06-09','14:00:00',3.9),('8537','2013-06-09','14:05:00',5.15),('8537','2013-06-09','14:10:00',5.16),('8537','2013-06-09','14:15:00',3.5),('8537','2013-06-09','14:20:00',2.45),('8537','2013-06-09','14:25:00',1.38),('8537','2013-06-09','14:30:00',1.71),('8537','2013-06-09','14:35:00',4.3),('8537','2013-06-09','14:40:00',3.99),('8537','2013-06-09','14:45:00',4.35),('8537','2013-06-09','14:50:00',4.54),('8537','2013-06-09','14:55:00',4.63),('8537','2013-06-09','15:00:00',4.55),('8537','2013-06-09','15:05:00',4.35),('8537','2013-06-09','15:10:00',4.36),('8537','2013-06-09','15:15:00',4.12),('8537','2013-06-09','15:20:00',4.19),('8537','2013-06-09','15:25:00',4.23),('8537','2013-06-09','15:30:00',3.93),('8537','2013-06-09','15:35:00',4.08),('8537','2013-06-09','15:40:00',3.21),('8537','2013-06-09','15:45:00',3.28),('8537','2013-06-09','15:50:00',3.66),('8537','2013-06-09','15:55:00',3.99),('8537','2013-06-09','16:00:00',2.42),('8537','2013-06-09','16:05:00',3.63),('8537','2013-06-09','16:10:00',3.44),('8537','2013-06-09','16:15:00',1.91),('8537','2013-06-09','16:20:00',1.72),('8537','2013-06-09','16:25:00',2.35),('8537','2013-06-09','16:30:00',1.55),('8537','2013-06-09','16:35:00',1.14),('8537','2013-06-09','16:40:00',1.07),('8537','2013-06-09','16:45:00',1.07),('8537','2013-06-09','16:50:00',1.04),('8537','2013-06-09','17:00:00',1.02),('8537','2013-06-09','17:05:00',1.15),('8537','2013-06-09','17:10:00',1.11),('8537','2013-06-09','17:20:00',1.01),('8537','2013-06-09','18:00:00',1.12),('8537','2013-06-09','18:10:00',1.01),('8537','2013-06-08','07:30:00',1.08),('8537','2013-06-08','07:35:00',1.17),('8537','2013-06-08','07:40:00',1.28),('8537','2013-06-08','07:45:00',1.38),('8537','2013-06-08','07:50:00',1.47),('8537','2013-06-08','07:55:00',1.57),('8537','2013-06-08','08:00:00',1.64),('8537','2013-06-08','08:05:00',1.76),('8537','2013-06-08','08:10:00',1.86),('8537','2013-06-08','08:15:00',1.98),('8537','2013-06-08','08:20:00',2.08),('8537','2013-06-08','08:25:00',2.18),('8537','2013-06-08','08:30:00',2.27),('8537','2013-06-08','08:35:00',2.36),('8537','2013-06-08','08:40:00',2.46),('8537','2013-06-08','08:45:00',2.57),('8537','2013-06-08','08:50:00',2.68),('8537','2013-06-08','08:55:00',2.76),('8537','2013-06-08','09:00:00',2.83),('8537','2013-06-08','09:05:00',2.92),('8537','2013-06-08','09:10:00',3.02),('8537','2013-06-08','09:15:00',3.08),('8537','2013-06-08','09:20:00',3.18),('8537','2013-06-08','09:25:00',3.24),('8537','2013-06-08','09:30:00',3.27),('8537','2013-06-08','09:35:00',3.35),('8537','2013-06-08','09:40:00',3.41),('8537','2013-06-08','09:45:00',3.53),('8537','2013-06-08','09:50:00',3.53),('8537','2013-06-08','09:55:00',3.62),('8537','2013-06-08','10:00:00',3.73),('8537','2013-06-08','10:05:00',3.89),('8537','2013-06-08','10:10:00',3.4),('8537','2013-06-08','10:15:00',4.06),('8537','2013-06-08','10:20:00',4.04),('8537','2013-06-08','10:25:00',4.1),('8537','2013-06-08','10:30:00',4.09),('8537','2013-06-08','10:35:00',4.18),('8537','2013-06-08','10:40:00',4.12),('8537','2013-06-08','10:45:00',4.32),('8537','2013-06-08','10:50:00',4.19),('8537','2013-06-08','10:55:00',4.59),('8537','2013-06-08','11:00:00',2.91),('8537','2013-06-08','11:05:00',4.61),('8537','2013-06-08','11:10:00',4.63),('8537','2013-06-08','11:15:00',4.62),('8537','2013-06-08','11:20:00',4.96),('8537','2013-06-08','11:25:00',4.62),('8537','2013-06-08','11:30:00',1.54),('8537','2013-06-08','11:35:00',1.74),('8537','2013-06-08','11:40:00',5.04),('8537','2013-06-08','11:45:00',5.05),('8537','2013-06-08','11:50:00',5.14),('8537','2013-06-08','11:55:00',5.16),('8537','2013-06-08','12:00:00',1.74),('8537','2013-06-08','12:05:00',2.46),('8537','2013-06-08','12:10:00',1.13),('8537','2013-06-08','12:15:00',4.3),('8537','2013-06-08','12:20:00',3.63),('8537','2013-06-08','12:25:00',1.29),('8537','2013-06-08','12:30:00',4.23),('8537','2013-06-08','12:35:00',3.89),('8537','2013-06-08','12:40:00',5.07),('8537','2013-06-08','12:45:00',4.38),('8537','2013-06-08','12:50:00',1.66),('8537','2013-06-08','12:55:00',5.45),('8537','2013-06-08','13:00:00',5.3),('8537','2013-06-08','13:05:00',3.62),('8537','2013-06-08','13:10:00',4.17),('8537','2013-06-08','13:15:00',5.49),('8537','2013-06-08','13:20:00',5.24),('8537','2013-06-08','13:25:00',5.29),('8537','2013-06-08','13:30:00',5.31),('8537','2013-06-08','13:35:00',5.17),('8537','2013-06-08','13:40:00',5.1),('8537','2013-06-08','13:45:00',5.08),('8537','2013-06-08','13:50:00',5.02),('8537','2013-06-08','13:55:00',5),('8537','2013-06-08','14:00:00',4.99),('8537','2013-06-08','14:05:00',4.98),('8537','2013-06-08','14:10:00',4.99),('8537','2013-06-08','14:15:00',4.97),('8537','2013-06-08','14:20:00',4.94),('8537','2013-06-08','14:25:00',4.89),('8537','2013-06-08','14:30:00',4.88),('8537','2013-06-08','14:35:00',4.81),('8537','2013-06-08','14:40:00',4.74),('8537','2013-06-08','14:45:00',4.47),('8537','2013-06-08','14:50:00',4.54),('8537','2013-06-08','14:55:00',4.65),('8537','2013-06-08','15:00:00',4.65),('8537','2013-06-08','15:05:00',4.46),('8537','2013-06-08','15:10:00',4.15),('8537','2013-06-08','15:15:00',4.27),('8537','2013-06-08','15:20:00',4.38),('8537','2013-06-08','15:25:00',4.18),('8537','2013-06-08','15:30:00',4.23),('8537','2013-06-08','15:35:00',4.41),('8537','2013-06-08','15:40:00',4.13),('8537','2013-06-08','15:45:00',4.07),('8537','2013-06-08','15:50:00',3.63),('8537','2013-06-08','15:55:00',3.94),('8537','2013-06-08','16:00:00',3.93),('8537','2013-06-08','16:05:00',3.9),('8537','2013-06-08','16:10:00',3.84),('8537','2013-06-08','16:15:00',3.86),('8537','2013-06-08','16:20:00',3.75),('8537','2013-06-08','16:25:00',3.49),('8537','2013-06-08','16:30:00',3.16),('8537','2013-06-08','16:35:00',3.29),('8537','2013-06-08','16:40:00',3.24),('8537','2013-06-08','16:45:00',3.16),('8537','2013-06-08','16:50:00',2.69),('8537','2013-06-08','16:55:00',2.69),('8537','2013-06-08','17:00:00',2.93),('8537','2013-06-08','17:05:00',2.41),('8537','2013-06-08','17:10:00',2.94),('8537','2013-06-08','17:15:00',2.89),('8537','2013-06-08','17:20:00',2.73),('8537','2013-06-08','17:25:00',2.48),('8537','2013-06-08','17:30:00',1.71),('8537','2013-06-08','17:35:00',1.23),('8537','2013-06-08','17:40:00',1.93),('8537','2013-06-08','17:45:00',2.13),('8537','2013-06-08','17:50:00',1.87),('8537','2013-06-08','17:55:00',1.95),('8537','2013-06-08','18:00:00',1.51),('8537','2013-06-08','18:05:00',1.39),('8537','2013-06-08','18:10:00',1.14),('8537','2013-06-08','18:15:00',1.12),('8537','2013-06-08','18:20:00',1.09),('8537','2013-06-07','07:25:00',1.03),('8537','2013-06-07','07:30:00',1.13),('8537','2013-06-07','07:35:00',1.24),('8537','2013-06-07','07:40:00',1.35),('8537','2013-06-07','07:45:00',1.45),('8537','2013-06-07','07:50:00',1.56),('8537','2013-06-07','07:55:00',1.67),('8537','2013-06-07','08:00:00',1.77),('8537','2013-06-07','08:05:00',1.88),('8537','2013-06-07','08:10:00',1.99),('8537','2013-06-07','08:15:00',2.07),('8537','2013-06-07','08:20:00',2.21),('8537','2013-06-07','08:25:00',2.32),('8537','2013-06-07','08:30:00',2.42),('8537','2013-06-07','08:35:00',2.53),('8537','2013-06-07','08:40:00',2.63),('8537','2013-06-07','08:45:00',2.74),('8537','2013-06-07','08:50:00',2.83),('8537','2013-06-07','08:55:00',2.92),('8537','2013-06-07','09:00:00',3.01),('8537','2013-06-07','09:05:00',3.11),('8537','2013-06-07','09:10:00',3.21),('8537','2013-06-07','09:15:00',3.31),('8537','2013-06-07','09:20:00',3.38),('8537','2013-06-07','09:25:00',3.48),('8537','2013-06-07','09:30:00',3.57),('8537','2013-06-07','09:35:00',3.64),('8537','2013-06-07','09:40:00',3.74),('8537','2013-06-07','09:45:00',3.83),('8537','2013-06-07','09:50:00',3.89),('8537','2013-06-07','09:55:00',3.95),('8537','2013-06-07','10:00:00',4.03),('8537','2013-06-07','10:05:00',4.09),('8537','2013-06-07','10:10:00',4.15),('8537','2013-06-07','10:15:00',4.22),('8537','2013-06-07','10:20:00',4.29),('8537','2013-06-07','10:25:00',4.37),('8537','2013-06-07','10:30:00',4.42),('8537','2013-06-07','10:35:00',4.47),('8537','2013-06-07','10:40:00',4.54),('8537','2013-06-07','10:45:00',4.59),('8537','2013-06-07','10:50:00',4.63),('8537','2013-06-07','10:55:00',4.67),('8537','2013-06-07','11:00:00',4.74),('8537','2013-06-07','11:05:00',4.8),('8537','2013-06-07','11:10:00',4.81),('8537','2013-06-07','11:15:00',4.82),('8537','2013-06-07','11:20:00',4.78),('8537','2013-06-07','11:25:00',4.9),('8537','2013-06-07','11:30:00',4.95),('8537','2013-06-07','11:35:00',4.99),('8537','2013-06-07','11:40:00',5.05),('8537','2013-06-07','11:45:00',5.03),('8537','2013-06-07','11:50:00',5.06),('8537','2013-06-07','11:55:00',5.07),('8537','2013-06-07','12:00:00',5.11),('8537','2013-06-07','12:05:00',5.16),('8537','2013-06-07','12:10:00',5.17),('8537','2013-06-07','12:15:00',5.18),('8537','2013-06-07','12:20:00',5.21),('8537','2013-06-07','12:25:00',5.18),('8537','2013-06-07','12:30:00',5.17),('8537','2013-06-07','12:35:00',5.11),('8537','2013-06-07','12:40:00',5.19),('8537','2013-06-07','12:45:00',5.19),('8537','2013-06-07','12:50:00',5.19),('8537','2013-06-07','12:55:00',5.22),('8537','2013-06-07','13:00:00',5.25),('8537','2013-06-07','13:05:00',5.22),('8537','2013-06-07','13:10:00',5.21),('8537','2013-06-07','13:15:00',5.19),('8537','2013-06-07','13:20:00',5.16),('8537','2013-06-07','13:25:00',5.17),('8537','2013-06-07','13:30:00',5.14),('8537','2013-06-07','13:35:00',5.1),('8537','2013-06-07','13:40:00',5.05),('8537','2013-06-07','13:45:00',5.06),('8537','2013-06-07','13:50:00',5.07),('8537','2013-06-07','13:55:00',5.02),('8537','2013-06-07','14:00:00',4.99),('8537','2013-06-07','14:05:00',4.95),('8537','2013-06-07','14:10:00',4.93),('8537','2013-06-07','14:15:00',4.88),('8537','2013-06-07','14:20:00',4.78),('8537','2013-06-07','14:25:00',4.74),('8537','2013-06-07','14:30:00',4.79),('8537','2013-06-07','14:35:00',4.79),('8537','2013-06-07','14:40:00',4.73),('8537','2013-06-07','14:45:00',4.45),('8537','2013-06-07','14:50:00',4.32),('8537','2013-06-07','14:55:00',4.59),('8537','2013-06-07','15:00:00',4.57),('8537','2013-06-07','15:05:00',4.54),('8537','2013-06-07','15:10:00',4.51),('8537','2013-06-07','15:15:00',4.42),('8537','2013-06-07','15:20:00',4.31),('8537','2013-06-07','15:25:00',4.36),('8537','2013-06-07','15:30:00',4.31),('8537','2013-06-07','15:35:00',4.2),('8537','2013-06-07','15:40:00',4.02),('8537','2013-06-07','15:45:00',3.9),('8537','2013-06-07','15:50:00',3.96),('8537','2013-06-07','15:55:00',3.92),('8537','2013-06-07','16:00:00',3.85),('8537','2013-06-07','16:05:00',3.72),('8537','2013-06-07','16:10:00',3.61),('8537','2013-06-07','16:15:00',3.42),('8537','2013-06-07','16:20:00',3.43),('8537','2013-06-07','16:25:00',3.28),('8537','2013-06-07','16:30:00',3.17),('8537','2013-06-07','16:35:00',3.3),('8537','2013-06-07','16:40:00',3.22),('8537','2013-06-07','16:45:00',3.14),('8537','2013-06-07','16:50:00',3.07),('8537','2013-06-07','16:55:00',2.99),('8537','2013-06-07','17:00:00',2.9),('8537','2013-06-07','17:05:00',2.62),('8537','2013-06-07','17:10:00',2.65),('8537','2013-06-07','17:15:00',2.53),('8537','2013-06-07','17:20:00',2.39),('8537','2013-06-07','17:25:00',2.31),('8537','2013-06-07','17:30:00',2.18),('8537','2013-06-07','17:35:00',2.14),('8537','2013-06-07','17:40:00',2.08),('8537','2013-06-07','17:45:00',2.04),('8537','2013-06-07','17:50:00',1.93),('8537','2013-06-07','17:55:00',1.79),('8537','2013-06-07','18:00:00',1.62),('8537','2013-06-07','18:05:00',1.58),('8537','2013-06-07','18:10:00',1.48),('8537','2013-06-07','18:15:00',1.36),('8537','2013-06-07','18:20:00',1.24),('8537','2013-06-07','18:25:00',1.1),('8537','2013-06-07','18:30:00',1.03),('8537','2013-06-06','07:05:00',1.1),('8537','2013-06-06','07:10:00',1.03),('8537','2013-06-06','07:15:00',1.15),('8537','2013-06-06','07:50:00',1.34),('8537','2013-06-06','07:55:00',1.78),('8537','2013-06-06','08:00:00',1.95),('8537','2013-06-06','08:05:00',1.48),('8537','2013-06-06','08:10:00',1.88),('8537','2013-06-06','08:15:00',1.65),('8537','2013-06-06','08:20:00',1.9),('8537','2013-06-06','08:25:00',2.3),('8537','2013-06-06','08:30:00',2.37),('8537','2013-06-06','08:35:00',2.45),('8537','2013-06-06','08:40:00',2.55),('8537','2013-06-06','08:45:00',2.61),('8537','2013-06-06','08:50:00',2.74),('8537','2013-06-06','08:55:00',2.85),('8537','2013-06-06','09:00:00',2.95),('8537','2013-06-06','09:05:00',3.05),('8537','2013-06-06','09:10:00',3.05),('8537','2013-06-06','09:15:00',3.21),('8537','2013-06-06','09:20:00',3.33),('8537','2013-06-06','09:25:00',3.39),('8537','2013-06-06','09:30:00',3.43),('8537','2013-06-06','09:35:00',3.44),('8537','2013-06-06','09:40:00',3.59),('8537','2013-06-06','09:45:00',3.71),('8537','2013-06-06','09:50:00',3.77),('8537','2013-06-06','09:55:00',3.82),('8537','2013-06-06','10:00:00',3.82),('8537','2013-06-06','10:05:00',3.83),('8537','2013-06-06','10:10:00',4),('8537','2013-06-06','10:15:00',4.07),('8537','2013-06-06','10:20:00',4.15),('8537','2013-06-06','10:25:00',4.21),('8537','2013-06-06','10:30:00',4.25),('8537','2013-06-06','10:35:00',4.31),('8537','2013-06-06','10:40:00',4.37),('8537','2013-06-06','10:45:00',4.48),('8537','2013-06-06','10:50:00',4.5),('8537','2013-06-06','10:55:00',4.54),('8537','2013-06-06','11:00:00',4.55),('8537','2013-06-06','11:05:00',4.64),('8537','2013-06-06','11:10:00',4.68),('8537','2013-06-06','11:15:00',4.67),('8537','2013-06-06','11:20:00',4.77),('8537','2013-06-06','11:25:00',4.76),('8537','2013-06-06','11:30:00',4.81),('8537','2013-06-06','11:35:00',4.82),('8537','2013-06-06','11:40:00',4.88),('8537','2013-06-06','11:45:00',4.91),('8537','2013-06-06','11:50:00',4.75),('8537','2013-06-06','11:55:00',4.75),('8537','2013-06-06','12:00:00',4.6),('8537','2013-06-06','12:05:00',4.98),('8537','2013-06-06','12:10:00',4.95),('8537','2013-06-06','12:15:00',4.98),('8537','2013-06-06','12:20:00',5),('8537','2013-06-06','12:25:00',5.12),('8537','2013-06-06','12:30:00',5.13),('8537','2013-06-06','12:35:00',5.08),('8537','2013-06-06','12:40:00',5.13),('8537','2013-06-06','12:45:00',5.1),('8537','2013-06-06','12:50:00',5.11),('8537','2013-06-06','12:55:00',5.09),('8537','2013-06-06','13:00:00',5.05),('8537','2013-06-06','13:05:00',5.01),('8537','2013-06-06','13:10:00',5.11),('8537','2013-06-06','13:15:00',5.16),('8537','2013-06-06','13:20:00',5.15),('8537','2013-06-06','13:25:00',5.14),('8537','2013-06-06','13:30:00',5.1),('8537','2013-06-06','13:35:00',5.13),('8537','2013-06-06','13:40:00',5.11),('8537','2013-06-06','13:45:00',2.04),('8537','2013-06-06','13:50:00',2.97),('8537','2013-06-06','13:55:00',5.13),('8537','2013-06-06','14:00:00',5.08),('8537','2013-06-06','14:05:00',5.12),('8537','2013-06-06','14:10:00',5.07),('8537','2013-06-06','14:15:00',5.09),('8537','2013-06-06','14:20:00',3.37),('8537','2013-06-06','14:25:00',3.25),('8537','2013-06-06','14:30:00',5.05),('8537','2013-06-06','14:35:00',4.52),('8537','2013-06-06','14:40:00',3.47),('8537','2013-06-06','14:45:00',4.76),('8537','2013-06-06','14:50:00',4.86),('8537','2013-06-06','14:55:00',4.62),('8537','2013-06-06','15:00:00',4.74),('8537','2013-06-06','15:05:00',4.72),('8537','2013-06-06','15:10:00',4.63),('8537','2013-06-06','15:15:00',4.46),('8537','2013-06-06','15:20:00',4.47),('8537','2013-06-06','15:25:00',3.89),('8537','2013-06-06','15:30:00',3.94),('8537','2013-06-06','15:35:00',4.29),('8537','2013-06-06','15:40:00',3.91),('8537','2013-06-06','15:45:00',4.06),('8537','2013-06-06','15:50:00',3.85),('8537','2013-06-06','15:55:00',3.95),('8537','2013-06-06','16:00:00',3.38),('8537','2013-06-06','16:05:00',3.84),('8537','2013-06-06','16:10:00',3.6),('8537','2013-06-06','16:15:00',3.49),('8537','2013-06-06','16:20:00',3.4),('8537','2013-06-06','16:25:00',3.26),('8537','2013-06-06','16:30:00',3.06),('8537','2013-06-06','16:35:00',3.32),('8537','2013-06-06','16:40:00',3.22),('8537','2013-06-06','16:45:00',3.06),('8537','2013-06-06','16:50:00',2.98),('8537','2013-06-06','16:55:00',2.9),('8537','2013-06-06','17:00:00',2.74),('8537','2013-06-06','17:05:00',2.61),('8537','2013-06-06','17:10:00',2.57),('8537','2013-06-06','17:15:00',2.5),('8537','2013-06-06','17:20:00',2.39),('8537','2013-06-06','17:25:00',2.26),('8537','2013-06-06','17:30:00',2.17),('8537','2013-06-06','17:35:00',2.09),('8537','2013-06-06','17:40:00',1.98),('8537','2013-06-06','17:45:00',1.89),('8537','2013-06-06','17:50:00',1.75),('8537','2013-06-06','17:55:00',1.65),('8537','2013-06-06','18:00:00',1.55),('8537','2013-06-06','18:05:00',1.48),('8537','2013-06-06','18:10:00',1.38),('8537','2013-06-06','18:15:00',1.28),('8537','2013-06-06','18:20:00',1.17),('8537','2013-06-06','18:25:00',1.08),('8537','2013-06-05','07:50:00',1.01),('8537','2013-06-05','07:55:00',1.91),('8537','2013-06-05','08:00:00',1.52),('8537','2013-06-05','08:05:00',1.48),('8537','2013-06-05','08:10:00',1.75),('8537','2013-06-05','08:15:00',1.99),('8537','2013-06-05','08:20:00',2.12),('8537','2013-06-05','08:25:00',2.27),('8537','2013-06-05','08:30:00',2.36),('8537','2013-06-05','08:35:00',2.47),('8537','2013-06-05','08:40:00',2.58),('8537','2013-06-05','08:45:00',2.66),('8537','2013-06-05','08:50:00',2.79),('8537','2013-06-05','08:55:00',2.82),('8537','2013-06-05','09:00:00',2.99),('8537','2013-06-05','09:05:00',2.52),('8537','2013-06-05','09:10:00',3.11),('8537','2013-06-05','09:15:00',3.38),('8537','2013-06-05','09:20:00',3.63),('8537','2013-06-05','09:25:00',3.67),('8537','2013-06-05','09:30:00',3.57),('8537','2013-06-05','09:35:00',3.51),('8537','2013-06-05','09:40:00',3.97),('8537','2013-06-05','09:45:00',2.84),('8537','2013-06-05','09:50:00',1.59),('8537','2013-06-05','09:55:00',1.51),('8537','2013-06-05','10:00:00',3.12),('8537','2013-06-05','10:05:00',4.2),('8537','2013-06-05','10:10:00',3.27),('8537','2013-06-05','10:15:00',3.38),('8537','2013-06-05','10:20:00',1.52),('8537','2013-06-05','10:25:00',1.55),('8537','2013-06-05','10:30:00',1.57),('8537','2013-06-05','10:35:00',1.54),('8537','2013-06-05','10:40:00',2.26),('8537','2013-06-05','10:45:00',2.96),('8537','2013-06-05','10:50:00',3.47),('8537','2013-06-05','10:55:00',5.02),('8537','2013-06-05','11:00:00',5.08),('8537','2013-06-05','11:05:00',1.99),('8537','2013-06-05','11:10:00',1.66),('8537','2013-06-05','11:15:00',1.67),('8537','2013-06-05','11:20:00',1.42),('8537','2013-06-05','11:25:00',1.26),('8537','2013-06-05','11:30:00',1.3),('8537','2013-06-05','11:35:00',2.38),('8537','2013-06-05','11:40:00',3.67),('8537','2013-06-05','11:45:00',2.8),('8537','2013-06-05','11:50:00',2.21),('8537','2013-06-05','11:55:00',5.41),('8537','2013-06-05','12:00:00',3.47),('8537','2013-06-05','12:05:00',5.48),('8537','2013-06-05','12:10:00',5.33),('8537','2013-06-05','12:15:00',5.4),('8537','2013-06-05','12:20:00',5.8),('8537','2013-06-05','12:25:00',4.74),('8537','2013-06-05','12:30:00',4.01),('8537','2013-06-05','12:35:00',5.6),('8537','2013-06-05','12:40:00',5.65),('8537','2013-06-05','12:45:00',5.72),('8537','2013-06-05','12:50:00',3.1),('8537','2013-06-05','12:55:00',2.03),('8537','2013-06-05','13:00:00',4.16),('8537','2013-06-05','13:05:00',5.88),('8537','2013-06-05','13:10:00',3.43),('8537','2013-06-05','13:15:00',2.71),('8537','2013-06-05','13:20:00',3.09),('8537','2013-06-05','13:25:00',4.01),('8537','2013-06-05','13:30:00',3.47),('8537','2013-06-05','13:35:00',5.92),('8537','2013-06-05','13:40:00',5.6),('8537','2013-06-05','13:45:00',5.44),('8537','2013-06-05','13:50:00',5.32),('8537','2013-06-05','13:55:00',5.27),('8537','2013-06-05','14:00:00',5.18),('8537','2013-06-05','14:05:00',5.12),('8537','2013-06-05','14:10:00',5.02),('8537','2013-06-05','14:15:00',5.07),('8537','2013-06-05','14:20:00',5.04),('8537','2013-06-05','14:25:00',4.99),('8537','2013-06-05','14:30:00',4.96),('8537','2013-06-05','14:35:00',4.94),('8537','2013-06-05','14:40:00',4.88),('8537','2013-06-05','14:45:00',4.84),('8537','2013-06-05','14:50:00',4.78),('8537','2013-06-05','14:55:00',4.76),('8537','2013-06-05','15:00:00',4.63),('8537','2013-06-05','15:05:00',4.59),('8537','2013-06-05','15:10:00',4.55),('8537','2013-06-05','15:15:00',4.53),('8537','2013-06-05','15:20:00',4.45),('8537','2013-06-05','15:25:00',4.44),('8537','2013-06-05','15:30:00',4.41),('8537','2013-06-05','15:35:00',4.38),('8537','2013-06-05','15:40:00',4.31),('8537','2013-06-05','15:45:00',4.2),('8537','2013-06-05','15:50:00',4.13),('8537','2013-06-05','15:55:00',4.08),('8537','2013-06-05','16:00:00',4.02),('8537','2013-06-05','16:05:00',3.92),('8537','2013-06-05','16:10:00',3.82),('8537','2013-06-05','16:15:00',3.8),('8537','2013-06-05','16:20:00',3.7),('8537','2013-06-05','16:25:00',3.39),('8537','2013-06-05','16:30:00',3.39),('8537','2013-06-05','16:35:00',3.35),('8537','2013-06-05','16:40:00',3.29),('8537','2013-06-05','16:45:00',3.21),('8537','2013-06-05','16:50:00',3.16),('8537','2013-06-05','16:55:00',3.07),('8537','2013-06-05','17:00:00',2.75),('8537','2013-06-05','17:05:00',2.25),('8537','2013-06-05','17:10:00',1.94),('8537','2013-06-05','17:15:00',1.98),('8537','2013-06-05','17:25:00',2.48),('8537','2013-06-05','17:30:00',2.33),('8537','2013-06-05','17:35:00',2.09),('8537','2013-06-05','17:40:00',1.24),('8537','2013-06-05','17:45:00',1.39),('8537','2013-06-05','17:50:00',1.79),('8537','2013-06-05','17:55:00',1.71),('8537','2013-06-05','18:00:00',1.57),('8537','2013-06-05','18:05:00',1.56),('8537','2013-06-04','07:25:00',1.06),('8537','2013-06-04','07:30:00',1.17),('8537','2013-06-04','07:35:00',1.29),('8537','2013-06-04','07:40:00',1.44),('8537','2013-06-04','07:45:00',1.65),('8537','2013-06-04','07:50:00',1.83),('8537','2013-06-04','07:55:00',1.97),('8537','2013-06-04','08:00:00',2.21),('8537','2013-06-04','08:05:00',2.4),('8537','2013-06-04','08:10:00',2.48),('8537','2013-06-04','08:15:00',2.54),('8537','2013-06-04','08:20:00',2.6),('8537','2013-06-04','08:25:00',2.63),('8537','2013-06-04','08:30:00',2.41),('8537','2013-06-04','08:35:00',2.83),('8537','2013-06-04','08:40:00',2.33),('8537','2013-06-04','08:45:00',2.26),('8537','2013-06-04','08:50:00',1.61),('8537','2013-06-04','08:55:00',1.62),('8537','2013-06-04','09:00:00',1.95),('8537','2013-06-04','09:05:00',2.12),('8537','2013-06-04','09:10:00',2.72),('8537','2013-06-04','09:15:00',3.49),('8537','2013-06-04','09:20:00',3.94),('8537','2013-06-04','09:25:00',3.72),('8537','2013-06-04','09:30:00',3.34),('8537','2013-06-04','09:35:00',2.86),('8537','2013-06-04','09:40:00',1.96),('8537','2013-06-04','09:45:00',2),('8537','2013-06-04','09:50:00',2.09),('8537','2013-06-04','09:55:00',2.07),('8537','2013-06-04','10:00:00',2.42),('8537','2013-06-04','10:05:00',2.8),('8537','2013-06-04','10:10:00',3.21),('8537','2013-06-04','10:15:00',2.82),('8537','2013-06-04','10:20:00',2.22),('8537','2013-06-04','10:25:00',2.13),('8537','2013-06-04','10:30:00',1.96),('8537','2013-06-04','10:35:00',1.97),('8537','2013-06-04','10:40:00',2.13),('8537','2013-06-04','10:45:00',2.46),('8537','2013-06-04','10:50:00',3.19),('8537','2013-06-04','10:55:00',3.89),('8537','2013-06-04','11:00:00',2.58),('8537','2013-06-04','11:05:00',3.17),('8537','2013-06-04','11:10:00',4.28),('8537','2013-06-04','11:15:00',3.8),('8537','2013-06-04','11:20:00',2.61),('8537','2013-06-04','11:25:00',3.3),('8537','2013-06-04','11:30:00',4.07),('8537','2013-06-04','11:35:00',3.63),('8537','2013-06-04','11:40:00',3.58),('8537','2013-06-04','11:45:00',4.58),('8537','2013-06-04','11:50:00',5.44),('8537','2013-06-04','11:55:00',5.25),('8537','2013-06-04','12:00:00',3.99),('8537','2013-06-04','12:05:00',3.44),('8537','2013-06-04','12:10:00',3.11),('8537','2013-06-04','12:15:00',3.26),('8537','2013-06-04','12:20:00',2.44),('8537','2013-06-04','12:25:00',2.15),('8537','2013-06-04','12:30:00',3.03),('8537','2013-06-04','12:35:00',4.66),('8537','2013-06-04','12:40:00',2.97),('8537','2013-06-04','12:45:00',3.62),('8537','2013-06-04','12:50:00',3.19),('8537','2013-06-04','12:55:00',2.32),('8537','2013-06-04','13:00:00',2.7),('8537','2013-06-04','13:05:00',1.8),('8537','2013-06-04','13:10:00',1.57),('8537','2013-06-04','13:15:00',1.55),('8537','2013-06-04','13:20:00',1.29),('8537','2013-06-04','13:25:00',1.54),('8537','2013-06-04','13:30:00',2.01),('8537','2013-06-04','13:35:00',2.94),('8537','2013-06-04','13:40:00',4.47),('8537','2013-06-04','13:45:00',5.98),('8537','2013-06-04','13:50:00',5.97),('8537','2013-06-04','13:55:00',3.53),('8537','2013-06-04','14:00:00',2.3),('8537','2013-06-04','14:05:00',4.18),('8537','2013-06-04','14:10:00',5.89),('8537','2013-06-04','14:15:00',4.76),('8537','2013-06-04','14:20:00',4.25),('8537','2013-06-04','14:25:00',2.65),('8537','2013-06-04','14:30:00',1.58),('8537','2013-06-04','14:35:00',1.89),('8537','2013-06-04','14:40:00',3.11),('8537','2013-06-04','14:45:00',1.42),('8537','2013-06-04','14:50:00',1.25),('8537','2013-06-04','14:55:00',4.22),('8537','2013-06-04','15:00:00',5.98),('8537','2013-06-04','15:05:00',5.69),('8537','2013-06-04','15:10:00',1.82),('8537','2013-06-04','15:15:00',1.38),('8537','2013-06-04','15:20:00',1.23),('8537','2013-06-04','18:10:00',1.06),('8537','2013-06-03','07:40:00',1.21),('8537','2013-06-03','07:45:00',1.46),('8537','2013-06-03','07:50:00',1.53),('8537','2013-06-03','07:55:00',1.69),('8537','2013-06-03','08:00:00',1.79),('8537','2013-06-03','08:05:00',1.85),('8537','2013-06-03','08:10:00',1.95),('8537','2013-06-03','08:15:00',2.07),('8537','2013-06-03','08:20:00',2.16),('8537','2013-06-03','08:25:00',2.29),('8537','2013-06-03','08:30:00',2.37),('8537','2013-06-03','08:35:00',2.48),('8537','2013-06-03','08:40:00',2.58),('8537','2013-06-03','08:45:00',2.65),('8537','2013-06-03','08:50:00',2.75),('8537','2013-06-03','08:55:00',2.84),('8537','2013-06-03','09:00:00',2.93),('8537','2013-06-03','09:05:00',2.79),('8537','2013-06-03','09:10:00',3.18),('8537','2013-06-03','09:15:00',3.32),('8537','2013-06-03','09:20:00',3.69),('8537','2013-06-03','09:25:00',3.08),('8537','2013-06-03','09:30:00',2.8),('8537','2013-06-03','09:35:00',2.04),('8537','2013-06-03','09:40:00',2.79),('8537','2013-06-03','09:45:00',2.89),('8537','2013-06-03','09:50:00',4.61),('8537','2013-06-03','09:55:00',4.59),('8537','2013-06-03','10:00:00',4.56),('8537','2013-06-03','10:05:00',4.5),('8537','2013-06-03','10:10:00',4.15),('8537','2013-06-03','10:15:00',1.99),('8537','2013-06-03','10:20:00',1.74),('8537','2013-06-03','10:25:00',1.59),('8537','2013-06-03','10:30:00',1.31),('8537','2013-06-03','10:35:00',1.4),('8537','2013-06-03','10:40:00',1.6),('8537','2013-06-03','10:45:00',1.8),('8537','2013-06-03','10:50:00',2),('8537','2013-06-03','10:55:00',2.88),('8537','2013-06-03','11:00:00',2.6),('8537','2013-06-03','11:05:00',2.2),('8537','2013-06-03','11:10:00',1.59),('8537','2013-06-03','11:15:00',1.56),('8537','2013-06-03','11:20:00',1.95),('8537','2013-06-03','11:25:00',1.95),('8537','2013-06-03','11:30:00',1.79),('8537','2013-06-03','11:35:00',1.63),('8537','2013-06-03','11:40:00',2.13),('8537','2013-06-03','11:45:00',2.5),('8537','2013-06-03','11:50:00',1.84),('8537','2013-06-03','11:55:00',1.96),('8537','2013-06-03','12:00:00',2.27),('8537','2013-06-03','12:05:00',2.2),('8537','2013-06-03','12:10:00',2.88),('8537','2013-06-03','12:15:00',1.77),('8537','2013-06-03','12:20:00',1.76),('8537','2013-06-03','12:25:00',1.65),('8537','2013-06-03','12:30:00',2.2),('8537','2013-06-03','12:35:00',4.59),('8537','2013-06-03','12:40:00',5.01),('8537','2013-06-03','12:45:00',2.64),('8537','2013-06-03','12:50:00',2.61),('8537','2013-06-03','12:55:00',3.65),('8537','2013-06-03','13:00:00',2.43),('8537','2013-06-03','13:05:00',2.21),('8537','2013-06-03','13:10:00',2.29),('8537','2013-06-03','13:15:00',4.46),('8537','2013-06-03','13:20:00',6),('8537','2013-06-03','13:25:00',4.83),('8537','2013-06-03','13:30:00',4.46),('8537','2013-06-03','13:35:00',5.47),('8537','2013-06-03','13:40:00',5.21),('8537','2013-06-03','13:45:00',2.03),('8537','2013-06-03','13:50:00',4.58),('8537','2013-06-03','13:55:00',3.21),('8537','2013-06-03','14:00:00',4.67),('8537','2013-06-03','14:05:00',3.44),('8537','2013-06-03','14:10:00',2.55),('8537','2013-06-03','14:15:00',3.06),('8537','2013-06-03','14:20:00',3.06),('8537','2013-06-03','14:25:00',3.51),('8537','2013-06-03','14:30:00',5.48),('8537','2013-06-03','14:35:00',5.52),('8537','2013-06-03','14:40:00',3.9),('8537','2013-06-03','14:45:00',3.67),('8537','2013-06-03','14:50:00',3.17),('8537','2013-06-03','14:55:00',4.42),('8537','2013-06-03','15:00:00',4.53),('8537','2013-06-03','15:05:00',3.17),('8537','2013-06-03','15:10:00',4.72),('8537','2013-06-03','15:15:00',4.5),('8537','2013-06-03','15:20:00',3.38),('8537','2013-06-03','15:25:00',4.57),('8537','2013-06-03','15:30:00',4.45),('8537','2013-06-03','15:35:00',4.36),('8537','2013-06-03','15:40:00',4.22),('8537','2013-06-03','15:45:00',4.17),('8537','2013-06-03','15:50:00',4.15),('8537','2013-06-03','15:55:00',4.09),('8537','2013-06-03','16:00:00',3.99),('8537','2013-06-03','16:05:00',3.94),('8537','2013-06-03','16:10:00',3.9),('8537','2013-06-03','16:15:00',3.75),('8537','2013-06-03','16:20:00',3.58),('8537','2013-06-03','16:25:00',3.53),('8537','2013-06-03','16:30:00',3.67),('8537','2013-06-03','16:35:00',3.41),('8537','2013-06-03','16:40:00',3.46),('8537','2013-06-03','16:45:00',3.01),('8537','2013-06-03','16:50:00',2.26),('8537','2013-06-03','16:55:00',1.99),('8537','2013-06-03','17:00:00',2.55),('8537','2013-06-03','17:05:00',2.85),('8537','2013-06-03','17:10:00',2.77),('8537','2013-06-03','17:15:00',2.65),('8537','2013-06-03','17:20:00',2.2),('8537','2013-06-03','17:25:00',1.67),('8537','2013-06-02','06:55:00',1.01),('8537','2013-06-02','07:00:00',1.04),('8537','2013-06-02','08:35:00',1.04),('8537','2013-06-02','08:40:00',1.04),('8537','2013-06-02','08:45:00',1.14),('8537','2013-06-02','08:50:00',1.25),('8537','2013-06-02','08:55:00',1.1),('8537','2013-06-02','09:00:00',1.08),('8537','2013-06-02','09:05:00',1.17),('8537','2013-06-02','09:10:00',1.31),('8537','2013-06-02','09:15:00',1.37),('8537','2013-06-02','09:20:00',2.85),('8537','2013-06-02','09:25:00',3.9),('8537','2013-06-02','09:30:00',3.73),('8537','2013-06-02','09:35:00',3.7),('8537','2013-06-02','09:40:00',3.65),('8537','2013-06-02','09:45:00',3.76),('8537','2013-06-02','09:50:00',3.84),('8537','2013-06-02','09:55:00',3.89),('8537','2013-06-02','10:00:00',3.97),('8537','2013-06-02','10:05:00',3.98),('8537','2013-06-02','10:10:00',4.07),('8537','2013-06-02','10:15:00',4.17),('8537','2013-06-02','10:20:00',4.31),('8537','2013-06-02','10:25:00',4.35),('8537','2013-06-02','10:30:00',4.65),('8537','2013-06-02','10:35:00',5),('8537','2013-06-02','10:40:00',4.91),('8537','2013-06-02','10:45:00',3.27),('8537','2013-06-02','10:50:00',2.79),('8537','2013-06-02','10:55:00',3.38),('8537','2013-06-02','11:00:00',4.85),('8537','2013-06-02','11:05:00',5.19),('8537','2013-06-02','11:10:00',4.32),('8537','2013-06-02','11:15:00',2.19),('8537','2013-06-02','11:20:00',3.85),('8537','2013-06-02','11:25:00',4.46),('8537','2013-06-02','11:30:00',4.96),('8537','2013-06-02','11:35:00',1.92),('8537','2013-06-02','11:40:00',1.86),('8537','2013-06-02','11:45:00',1.54),('8537','2013-06-02','11:50:00',3.13),('8537','2013-06-02','11:55:00',3.39),('8537','2013-06-02','12:00:00',3.73),('8537','2013-06-02','12:05:00',1.87),('8537','2013-06-02','12:10:00',2.41),('8537','2013-06-02','12:15:00',5.13),('8537','2013-06-02','12:20:00',2.5),('8537','2013-06-02','12:25:00',2.3),('8537','2013-06-02','12:30:00',2.48),('8537','2013-06-02','12:35:00',4.64),('8537','2013-06-02','12:40:00',4.26),('8537','2013-06-02','12:45:00',4.69),('8537','2013-06-02','12:50:00',2.31),('8537','2013-06-02','12:55:00',3.43),('8537','2013-06-02','13:00:00',2.21),('8537','2013-06-02','13:05:00',1.61),('8537','2013-06-02','13:10:00',1.78),('8537','2013-06-02','13:15:00',5.9),('8537','2013-06-02','13:20:00',5.55),('8537','2013-06-02','13:25:00',5.33),('8537','2013-06-02','13:30:00',5.28),('8537','2013-06-02','13:35:00',5.27),('8537','2013-06-02','13:40:00',5.24),('8537','2013-06-02','13:45:00',5.17),('8537','2013-06-02','13:50:00',5.15),('8537','2013-06-02','13:55:00',5.16),('8537','2013-06-02','14:00:00',5.1),('8537','2013-06-02','14:05:00',5.1),('8537','2013-06-02','14:10:00',5.18),('8537','2013-06-02','14:15:00',5.13),('8537','2013-06-02','14:20:00',5.04),('8537','2013-06-02','14:25:00',5.02),('8537','2013-06-02','14:30:00',4.99),('8537','2013-06-02','14:35:00',4.93),('8537','2013-06-02','14:40:00',4.8),('8537','2013-06-02','14:45:00',4.44),('8537','2013-06-02','14:50:00',4.31),('8537','2013-06-02','14:55:00',4.67),('8537','2013-06-02','15:00:00',4.65),('8537','2013-06-02','15:05:00',4.59),('8537','2013-06-02','15:10:00',4.53),('8537','2013-06-02','15:15:00',4.55),('8537','2013-06-02','15:20:00',4.36),('8537','2013-06-02','15:25:00',3.97),('8537','2013-06-02','15:30:00',4.51),('8537','2013-06-02','15:35:00',2.93),('8537','2013-06-02','15:40:00',2.59),('8537','2013-06-02','15:45:00',4.22),('8537','2013-06-02','15:50:00',3.97),('8537','2013-06-02','15:55:00',2.82),('8537','2013-06-02','16:00:00',4.22),('8537','2013-06-02','16:05:00',4.02),('8537','2013-06-02','16:10:00',3.77),('8537','2013-06-02','16:15:00',3.59),('8537','2013-06-02','16:20:00',3.73),('8537','2013-06-02','16:25:00',3.32),('8537','2013-06-02','16:30:00',3.49),('8537','2013-06-02','16:35:00',3.21),('8537','2013-06-02','16:40:00',3.42),('8537','2013-06-02','16:45:00',3.28),('8537','2013-06-02','16:50:00',2.88),('8537','2013-06-02','16:55:00',3.11),('8537','2013-06-02','17:00:00',3.01),('8537','2013-06-02','17:05:00',2.58),('8537','2013-06-02','17:10:00',2.75),('8537','2013-06-02','17:15:00',2.68),('8537','2013-06-02','17:20:00',2.53),('8537','2013-06-02','17:25:00',2.42),('8537','2013-06-02','17:30:00',2.17),('8537','2013-06-02','17:35:00',1.65),('8537','2013-06-02','17:40:00',1.19),('8537','2013-06-02','17:45:00',1.04),('8537','2013-06-02','17:50:00',1.28),('8537','2013-06-02','18:00:00',1.14),('8537','2013-06-01','07:25:00',1.06),('8537','2013-06-01','07:30:00',1.16),('8537','2013-06-01','07:35:00',1.26),('8537','2013-06-01','07:40:00',1.4),('8537','2013-06-01','07:45:00',1.65),('8537','2013-06-01','07:50:00',1.13),('8537','2013-06-01','07:55:00',1.56),('8537','2013-06-01','08:10:00',1),('8537','2013-06-01','08:15:00',1.55),('8537','2013-06-01','08:20:00',1.36),('8537','2013-06-01','08:30:00',1.41),('8537','2013-06-01','08:35:00',2.01),('8537','2013-06-01','09:45:00',1),('8537','2013-06-01','09:50:00',1.2),('8537','2013-06-01','10:35:00',1.36),('8537','2013-06-01','10:40:00',1.36),('8537','2013-06-01','10:50:00',2.47),('8537','2013-06-01','10:55:00',3.09),('8537','2013-06-01','11:50:00',1.64),('8537','2013-06-01','11:55:00',2.15),('8537','2013-06-01','12:00:00',2.8),('8537','2013-06-01','12:05:00',3.62),('8537','2013-06-01','12:10:00',3.93),('8537','2013-06-01','12:15:00',1.71),('8537','2013-06-01','12:20:00',1.31),('8537','2013-06-01','12:25:00',1.44),('8537','2013-06-01','12:30:00',1.41),('8537','2013-06-01','12:35:00',1.07),('8537','2013-06-01','12:40:00',1.22),('8537','2013-06-01','12:45:00',1.99),('8537','2013-06-01','12:50:00',2.17),('8537','2013-06-01','12:55:00',2.16),('8537','2013-06-01','13:00:00',2.57),('8537','2013-06-01','13:05:00',2.74),('8537','2013-06-01','13:10:00',2.84),('8537','2013-06-01','13:15:00',3.07),('8537','2013-06-01','13:20:00',2.68),('8537','2013-06-01','13:25:00',2.09),('8537','2013-06-01','13:30:00',1.82),('8537','2013-06-01','13:35:00',1.44),('8537','2013-06-01','13:40:00',1.28),('8537','2013-06-01','13:45:00',1.45),('8537','2013-06-01','13:50:00',1.57),('8537','2013-06-01','13:55:00',1.77),('8537','2013-06-01','14:00:00',2.32),('8537','2013-06-01','14:05:00',2.81),('8537','2013-06-01','14:10:00',2.75),('8537','2013-06-01','14:15:00',2.92),('8537','2013-06-01','14:20:00',3),('8537','2013-06-01','14:25:00',1.91),('8537','2013-06-01','14:30:00',1.54),('8537','2013-06-01','14:35:00',1.59),('8537','2013-06-01','14:40:00',1.53),('8537','2013-06-01','14:45:00',1.45),('8537','2013-06-01','14:50:00',1.32),('8537','2013-06-01','14:55:00',1.05),('8537','2013-06-01','15:00:00',1.03),('8537','2013-06-01','15:05:00',1.03),('8537','2013-06-01','18:30:00',1.06),('8537','2013-06-01','18:35:00',1.25),('8537','2013-06-01','19:00:00',1.12),('8537','2014-04-02','08:05:00',1.13),('8537','2014-04-02','08:20:00',1.04),('8537','2014-04-02','08:50:00',1.24),('8537','2014-04-02','08:55:00',2.48),('8537','2014-04-02','09:00:00',1.24),('8537','2014-04-02','09:05:00',1.11),('8537','2014-04-02','09:15:00',1.05),('8537','2014-04-02','09:20:00',1.06),('8537','2014-04-02','09:40:00',1.37),('8537','2014-04-02','09:55:00',1.96),('8537','2014-04-02','10:00:00',3.52),('8537','2014-04-02','10:05:00',2.36),('8537','2014-04-02','10:10:00',3.77),('8537','2014-04-02','10:15:00',3.96),('8537','2014-04-02','10:20:00',4.4),('8537','2014-04-02','10:25:00',4.44),('8537','2014-04-02','10:30:00',3.01),('8537','2014-04-02','10:35:00',1.04),('8537','2014-04-02','10:40:00',1.11),('8537','2014-04-02','10:45:00',1.18),('8537','2014-04-02','10:50:00',2.04),('8537','2014-04-02','10:55:00',4.43),('8537','2014-04-02','11:00:00',4.23),('8537','2014-04-02','11:05:00',4.03),('8537','2014-04-02','11:10:00',2.86),('8537','2014-04-02','11:15:00',2.24),('8537','2014-04-02','11:20:00',4.59),('8537','2014-04-02','11:25:00',4.98),('8537','2014-04-02','11:30:00',4.29),('8537','2014-04-02','11:35:00',3.32),('8537','2014-04-02','11:40:00',3.63),('8537','2014-04-02','11:45:00',1.56),('8537','2014-04-02','11:50:00',3.94),('8537','2014-04-02','11:55:00',4.32),('8537','2014-04-02','12:00:00',5.49),('8537','2014-04-02','12:05:00',4.65),('8537','2014-04-02','12:10:00',1.51),('8537','2014-04-02','12:15:00',1.58),('8537','2014-04-02','12:20:00',4.67),('8537','2014-04-02','12:25:00',4.5),('8537','2014-04-02','12:30:00',1.96),('8537','2014-04-02','12:35:00',5.61),('8537','2014-04-02','12:40:00',5.39),('8537','2014-04-02','12:45:00',4.91),('8537','2014-04-02','12:50:00',5.34),('8537','2014-04-02','12:55:00',5.13),('8537','2014-04-02','13:00:00',2.32),('8537','2014-04-02','13:05:00',2.46),('8537','2014-04-02','13:10:00',5.15),('8537','2014-04-02','13:15:00',4.4),('8537','2014-04-02','13:20:00',3.65),('8537','2014-04-02','13:25:00',4.94),('8537','2014-04-02','13:30:00',5.32),('8537','2014-04-02','13:35:00',5.31),('8537','2014-04-02','13:40:00',5.44),('8537','2014-04-02','13:45:00',5.15),('8537','2014-04-02','13:50:00',4.99),('8537','2014-04-02','13:55:00',5.04),('8537','2014-04-02','14:00:00',4.98),('8537','2014-04-02','14:05:00',4.83),('8537','2014-04-02','14:10:00',4.99),('8537','2014-04-02','14:15:00',4.92),('8537','2014-04-02','14:20:00',4.85),('8537','2014-04-02','14:25:00',4.85),('8537','2014-04-02','14:30:00',4.77),('8537','2014-04-02','14:35:00',4.6),('8537','2014-04-02','14:40:00',4.3),('8537','2014-04-02','14:45:00',4.38),('8537','2014-04-02','14:50:00',3.17),('8537','2014-04-02','14:55:00',4.27),('8537','2014-04-02','15:00:00',4.09),('8537','2014-04-02','15:05:00',4.39),('8537','2014-04-02','15:10:00',4.08),('8537','2014-04-02','15:15:00',4.09),('8537','2014-04-02','15:20:00',4.08),('8537','2014-04-02','15:25:00',3.96),('8537','2014-04-02','15:30:00',3.74),('8537','2014-04-02','15:35:00',3.62),('8537','2014-04-02','15:40:00',3.78),('8537','2014-04-02','15:45:00',3.82),('8537','2014-04-02','15:50:00',3.76),('8537','2014-04-02','15:55:00',3.31),('8537','2014-04-02','16:00:00',3.4),('8537','2014-04-02','16:05:00',3.12),('8537','2014-04-02','16:10:00',3.29),('8537','2014-04-02','16:15:00',3.25),('8537','2014-04-02','16:20:00',3.11),('8537','2014-04-02','16:25:00',3.07),('8537','2014-04-02','16:30:00',3.04),('8537','2014-04-02','16:35:00',2.83),('8537','2014-04-02','16:40:00',2.78),('8537','2014-04-02','16:45:00',2.7),('8537','2014-04-02','16:50:00',2.48),('8537','2014-04-02','16:55:00',2.38),('8537','2014-04-02','17:00:00',2.31),('8537','2014-04-02','17:05:00',2.18),('8537','2014-04-02','17:10:00',2.08),('8537','2014-04-02','17:15:00',1.84),('8537','2014-04-02','17:20:00',1.82),('8537','2014-04-02','17:25:00',1.69),('8537','2014-04-02','17:30:00',1.51),('8537','2014-04-02','17:35:00',1.45),('8537','2014-04-02','17:40:00',1.08),('8537','2014-04-02','17:45:00',1.1),('8537','2014-04-02','17:50:00',1.29),('8537','2014-04-02','17:55:00',1.1),('8537','2014-04-02','18:00:00',1),('8537','2013-05-31','07:25:00',1.08),('8537','2013-05-31','07:30:00',1.19),('8537','2013-05-31','07:35:00',1.28),('8537','2013-05-31','07:40:00',1.41),('8537','2013-05-31','07:45:00',1.51),('8537','2013-05-31','07:50:00',1.62),('8537','2013-05-31','07:55:00',1.76),('8537','2013-05-31','08:00:00',1.88),('8537','2013-05-31','08:05:00',1.96),('8537','2013-05-31','08:10:00',2.06),('8537','2013-05-31','08:15:00',2.16),('8537','2013-05-31','08:20:00',2.26),('8537','2013-05-31','08:25:00',2.41),('8537','2013-05-31','08:30:00',2.58),('8537','2013-05-31','08:35:00',2.31),('8537','2013-05-31','08:40:00',2.99),('8537','2013-05-31','08:45:00',1.53),('8537','2013-05-31','08:50:00',2.69),('8537','2013-05-31','08:55:00',1.81),('8537','2013-05-31','09:00:00',1.07),('8537','2013-05-31','09:10:00',1.36),('8537','2013-05-31','09:15:00',1.59),('8537','2013-05-31','09:25:00',1.05),('8537','2013-05-31','09:30:00',1.84),('8537','2013-05-31','09:35:00',2.49),('8537','2013-05-31','09:40:00',2.97),('8537','2013-05-31','09:45:00',3.57),('8537','2013-05-31','09:50:00',4.27),('8537','2013-05-31','09:55:00',4.45),('8537','2013-05-31','10:00:00',4.17),('8537','2013-05-31','10:05:00',2.82),('8537','2013-05-31','10:10:00',2),('8537','2013-05-31','10:15:00',4.07),('8537','2013-05-31','10:20:00',4.11),('8537','2013-05-31','10:25:00',1.56),('8537','2013-05-31','10:30:00',2.7),('8537','2013-05-31','10:35:00',2.58),('8537','2013-05-31','10:40:00',4.46),('8537','2013-05-31','10:45:00',5.32),('8537','2013-05-31','10:50:00',2.91),('8537','2013-05-31','10:55:00',4.52),('8537','2013-05-31','11:00:00',1.71),('8537','2013-05-31','11:05:00',2.13),('8537','2013-05-31','11:10:00',5.33),('8537','2013-05-31','11:15:00',5.81),('8537','2013-05-31','11:20:00',1.52),('8537','2013-05-31','11:25:00',2.14),('8537','2013-05-31','11:30:00',4.32),('8537','2013-05-31','11:35:00',2.86),('8537','2013-05-31','11:40:00',1.11),('8537','2013-05-31','11:45:00',4.21),('8537','2013-05-31','11:50:00',4.75),('8537','2013-05-31','11:55:00',2.97),('8537','2013-05-31','12:00:00',2.94),('8537','2013-05-31','12:05:00',5.49),('8537','2013-05-31','12:10:00',4.7),('8537','2013-05-31','12:15:00',1.86),('8537','2013-05-31','12:20:00',1.87),('8537','2013-05-31','12:25:00',4.32),('8537','2013-05-31','12:30:00',2),('8537','2013-05-31','12:35:00',2.13),('8537','2013-05-31','12:40:00',4.83),('8537','2013-05-31','12:45:00',2.86),('8537','2013-05-31','12:50:00',1.04),('8537','2013-05-31','12:55:00',1.62),('8537','2013-05-31','13:00:00',5.05),('8537','2013-05-31','13:05:00',2.54),('8537','2013-05-31','13:20:00',1.27),('8537','2013-05-31','13:25:00',2.11),('8537','2013-05-31','13:30:00',4.11),('8537','2013-05-31','13:35:00',5.52),('8537','2013-05-31','13:40:00',3.23),('8537','2013-05-31','13:45:00',1.59),('8537','2013-05-31','13:55:00',1.11),('8537','2013-05-31','14:00:00',2.69),('8537','2013-05-31','14:05:00',1.03),('8537','2013-05-31','14:25:00',1.17),('8537','2013-05-31','15:05:00',1.71),('8537','2013-05-31','15:10:00',2.06),('8537','2013-05-31','15:15:00',2.9),('8537','2013-05-31','15:20:00',5.89),('8537','2013-05-31','15:25:00',4.16),('8537','2013-05-31','15:30:00',3.01),('8537','2013-05-31','15:35:00',2.43),('8537','2013-05-31','15:40:00',2.05),('8537','2013-05-31','15:45:00',1.83),('8537','2013-05-31','15:50:00',2.67),('8537','2013-05-31','15:55:00',2.44),('8537','2013-05-31','16:00:00',1.83),('8537','2013-05-31','16:05:00',1.51),('8537','2013-05-31','16:10:00',1.16),('8537','2013-05-31','16:15:00',1.05),('8537','2013-05-31','16:20:00',1.2),('8537','2013-05-31','16:25:00',1.54),('8537','2013-05-31','16:30:00',1.44),('8537','2013-05-31','16:35:00',1.22),('8537','2013-05-31','16:40:00',1.36),('8537','2013-05-31','16:45:00',1.43),('8537','2013-05-31','16:50:00',1.01),('8537','2013-05-30','07:50:00',1.25),('8537','2013-05-30','08:25:00',1.55),('8537','2013-05-30','08:30:00',1.17),('8537','2013-05-30','08:40:00',2.76),('8537','2013-05-30','08:45:00',2.89),('8537','2013-05-30','08:50:00',2.96),('8537','2013-05-30','08:55:00',3.04),('8537','2013-05-30','09:00:00',3.15),('8537','2013-05-30','09:05:00',3.22),('8537','2013-05-30','09:10:00',3.34),('8537','2013-05-30','09:15:00',3.44),('8537','2013-05-30','09:20:00',3.59),('8537','2013-05-30','09:25:00',3.69),('8537','2013-05-30','09:30:00',3.76),('8537','2013-05-30','09:35:00',3.77),('8537','2013-05-30','09:40:00',3.93),('8537','2013-05-30','09:45:00',3.71),('8537','2013-05-30','09:50:00',3.76),('8537','2013-05-30','09:55:00',2.98),('8537','2013-05-30','10:00:00',1.32),('8537','2013-05-30','10:05:00',1.88),('8537','2013-05-30','10:10:00',4.33),('8537','2013-05-30','10:15:00',1.71),('8537','2013-05-30','10:20:00',5.21),('8537','2013-05-30','10:25:00',1.4),('8537','2013-05-30','10:30:00',1.41),('8537','2013-05-30','10:35:00',1.5),('8537','2013-05-30','10:40:00',3.59),('8537','2013-05-30','10:45:00',4.4),('8537','2013-05-30','10:50:00',5.04),('8537','2013-05-30','10:55:00',4.1),('8537','2013-05-30','11:00:00',5.22),('8537','2013-05-30','11:05:00',5.54),('8537','2013-05-30','11:10:00',2.25),('8537','2013-05-30','11:15:00',2.1),('8537','2013-05-30','11:20:00',5.21),('8537','2013-05-30','11:25:00',2.13),('8537','2013-05-30','11:30:00',4.5),('8537','2013-05-30','11:35:00',5.96),('8537','2013-05-30','11:40:00',5.85),('8537','2013-05-30','11:45:00',4.44),('8537','2013-05-30','11:50:00',5.89),('8537','2013-05-30','11:55:00',1.29),('8537','2013-05-30','12:00:00',4.72),('8537','2013-05-30','12:05:00',5.98),('8537','2013-05-30','12:10:00',2.87),('8537','2013-05-30','12:15:00',5.42),('8537','2013-05-30','12:20:00',4.9),('8537','2013-05-30','12:25:00',3.87),('8537','2013-05-30','12:30:00',4.18),('8537','2013-05-30','12:35:00',3.99),('8537','2013-05-30','12:40:00',4.74),('8537','2013-05-30','12:45:00',2.19),('8537','2013-05-30','12:50:00',5.1),('8537','2013-05-30','12:55:00',5.24),('8537','2013-05-30','13:00:00',4.71),('8537','2013-05-30','13:05:00',4.12),('8537','2013-05-30','13:10:00',2.56),('8537','2013-05-30','13:15:00',3.15),('8537','2013-05-30','13:20:00',2.1),('8537','2013-05-30','13:25:00',2.14),('8537','2013-05-30','13:30:00',2.98),('8537','2013-05-30','13:35:00',2.04),('8537','2013-05-30','13:40:00',5.15),('8537','2013-05-30','13:45:00',4.85),('8537','2013-05-30','13:50:00',2.12),('8537','2013-05-30','13:55:00',2.19),('8537','2013-05-30','14:00:00',5.06),('8537','2013-05-30','14:05:00',5.67),('8537','2013-05-30','14:10:00',3.83),('8537','2013-05-30','14:15:00',4.77),('8537','2013-05-30','14:20:00',4.46),('8537','2013-05-30','14:25:00',4.5),('8537','2013-05-30','14:30:00',5.24),('8537','2013-05-30','14:35:00',4.42),('8537','2013-05-30','14:40:00',5.29),('8537','2013-05-30','14:45:00',4.95),('8537','2013-05-30','14:50:00',4.49),('8537','2013-05-30','14:55:00',5.12),('8537','2013-05-30','15:00:00',4.73),('8537','2013-05-30','15:05:00',4.62),('8537','2013-05-30','15:10:00',1.99),('8537','2013-05-30','15:15:00',4.87),('8537','2013-05-30','15:20:00',5.06),('8537','2013-05-30','15:25:00',4.79),('8537','2013-05-30','15:30:00',4.67),('8537','2013-05-30','15:35:00',4.58),('8537','2013-05-30','15:40:00',4.96),('8537','2013-05-30','15:45:00',4.98),('8537','2013-05-30','15:50:00',3.15),('8537','2013-05-30','15:55:00',3.73),('8537','2013-05-30','16:00:00',4.65),('8537','2013-05-30','16:05:00',4.45),('8537','2013-05-30','16:10:00',4.39),('8537','2013-05-30','16:15:00',4.14),('8537','2013-05-30','16:20:00',3.79),('8537','2013-05-30','16:25:00',2.84),('8537','2013-05-30','16:30:00',1.69),('8537','2013-05-30','16:35:00',2.25),('8537','2013-05-30','16:40:00',1.47),('8537','2013-05-30','16:45:00',2.75),('8537','2013-05-30','16:50:00',2.91),('8537','2013-05-30','16:55:00',2.58),('8537','2013-05-30','17:00:00',1.93),('8537','2013-05-30','17:05:00',1.75),('8537','2013-05-30','17:15:00',1.14),('8537','2013-05-30','17:20:00',1.22),('8537','2013-05-30','17:25:00',1.13),('8537','2013-05-30','17:30:00',1.11),('8537','2013-05-30','18:00:00',1.03),('8537','2013-05-30','18:05:00',1.16),('8537','2013-05-30','18:10:00',1.1),('8537','2013-05-30','18:35:00',1.21),('8537','2013-05-30','18:40:00',1.24),('8537','2013-05-30','18:45:00',1.35),('8537','2013-05-30','18:50:00',1.27),('8537','2013-05-29','07:25:00',1.02),('8537','2013-05-29','07:30:00',1.13),('8537','2013-05-29','07:35:00',1.25),('8537','2013-05-29','07:40:00',1.36),('8537','2013-05-29','07:45:00',1.46),('8537','2013-05-29','07:50:00',1.57),('8537','2013-05-29','07:55:00',1.67),('8537','2013-05-29','08:00:00',1.79),('8537','2013-05-29','08:05:00',1.9),('8537','2013-05-29','08:10:00',2.02),('8537','2013-05-29','08:15:00',2.12),('8537','2013-05-29','08:20:00',2.17),('8537','2013-05-29','08:25:00',2.31),('8537','2013-05-29','08:30:00',2.44),('8537','2013-05-29','08:35:00',2.55),('8537','2013-05-29','08:40:00',2.65),('8537','2013-05-29','08:45:00',2.74),('8537','2013-05-29','08:50:00',2.84),('8537','2013-05-29','08:55:00',2.95),('8537','2013-05-29','09:00:00',3.05),('8537','2013-05-29','09:05:00',3.14),('8537','2013-05-29','09:10:00',3.23),('8537','2013-05-29','09:15:00',3.32),('8537','2013-05-29','09:20:00',3.4),('8537','2013-05-29','09:25:00',3.49),('8537','2013-05-29','09:30:00',3.56),('8537','2013-05-29','09:35:00',3.61),('8537','2013-05-29','09:40:00',3.75),('8537','2013-05-29','09:45:00',3.82),('8537','2013-05-29','09:50:00',3.93),('8537','2013-05-29','09:55:00',4.01),('8537','2013-05-29','10:00:00',4.04),('8537','2013-05-29','10:05:00',4.14),('8537','2013-05-29','10:10:00',4.2),('8537','2013-05-29','10:15:00',4.26),('8537','2013-05-29','10:20:00',4.36),('8537','2013-05-29','10:25:00',4.43),('8537','2013-05-29','10:30:00',4.5),('8537','2013-05-29','10:35:00',4.58),('8537','2013-05-29','10:40:00',4.61),('8537','2013-05-29','10:45:00',4.7),('8537','2013-05-29','10:50:00',4.75),('8537','2013-05-29','10:55:00',4.8),('8537','2013-05-29','11:00:00',4.87),('8537','2013-05-29','11:05:00',4.35),('8537','2013-05-29','11:10:00',4.98),('8537','2013-05-29','11:15:00',3.22),('8537','2013-05-29','11:20:00',5.27),('8537','2013-05-29','11:25:00',5.35),('8537','2013-05-29','11:30:00',5.03),('8537','2013-05-29','11:35:00',5.46),('8537','2013-05-29','11:40:00',4.79),('8537','2013-05-29','11:45:00',4.48),('8537','2013-05-29','11:50:00',4.49),('8537','2013-05-29','11:55:00',4.93),('8537','2013-05-29','12:00:00',4.65),('8537','2013-05-29','12:05:00',2.94),('8537','2013-05-29','12:10:00',4.9),('8537','2013-05-29','12:15:00',4.46),('8537','2013-05-29','12:20:00',5.18),('8537','2013-05-29','12:25:00',5.6),('8537','2013-05-29','12:30:00',5.46),('8537','2013-05-29','12:35:00',5.37),('8537','2013-05-29','12:40:00',5.15),('8537','2013-05-29','12:45:00',4.95),('8537','2013-05-29','12:50:00',5.22),('8537','2013-05-29','12:55:00',5.35),('8537','2013-05-29','13:00:00',5.51),('8537','2013-05-29','13:05:00',5.2),('8537','2013-05-29','13:10:00',4.57),('8537','2013-05-29','13:15:00',4.61),('8537','2013-05-29','13:20:00',4.95),('8537','2013-05-29','13:25:00',5.67),('8537','2013-05-29','13:30:00',5.73),('8537','2013-05-29','13:35:00',5),('8537','2013-05-29','13:40:00',5.68),('8537','2013-05-29','13:45:00',5.07),('8537','2013-05-29','13:50:00',4.66),('8537','2013-05-29','13:55:00',4.51),('8537','2013-05-29','14:00:00',5.39),('8537','2013-05-29','14:05:00',5.25),('8537','2013-05-29','14:10:00',5.12),('8537','2013-05-29','14:15:00',5.27),('8537','2013-05-29','14:20:00',5.27),('8537','2013-05-29','14:25:00',4.92),('8537','2013-05-29','14:30:00',5.24),('8537','2013-05-29','14:35:00',3.25),('8537','2013-05-29','14:40:00',5.3),('8537','2013-05-29','14:45:00',5.19),('8537','2013-05-29','14:50:00',5.05),('8537','2013-05-29','14:55:00',4.77),('8537','2013-05-29','15:00:00',4.67),('8537','2013-05-29','15:05:00',5.27),('8537','2013-05-29','15:10:00',4.7),('8537','2013-05-29','15:15:00',2.56),('8537','2013-05-29','15:20:00',3.8),('8537','2013-05-29','15:25:00',3.45),('8537','2013-05-29','15:30:00',3.39),('8537','2013-05-29','15:35:00',3.6),('8537','2013-05-29','15:40:00',2.96),('8537','2013-05-29','15:45:00',3.59),('8537','2013-05-29','15:50:00',3.46),('8537','2013-05-29','15:55:00',3.35),('8537','2013-05-29','16:00:00',3),('8537','2013-05-29','16:05:00',2.99),('8537','2013-05-29','16:10:00',2.56),('8537','2013-05-29','16:15:00',2.41),('8537','2013-05-29','16:20:00',2.35),('8537','2013-05-29','16:25:00',2.32),('8537','2013-05-29','16:30:00',2.13),('8537','2013-05-29','16:35:00',2.07),('8537','2013-05-29','16:40:00',2.37),('8537','2013-05-29','16:45:00',2.18),('8537','2013-05-29','16:50:00',1.73),('8537','2013-05-29','16:55:00',1.68),('8537','2013-05-29','17:00:00',1.59),('8537','2013-05-29','17:35:00',1.22),('8537','2013-05-29','17:40:00',1.69),('8537','2013-05-29','17:45:00',1.28),('8537','2013-05-29','18:05:00',1.11),('8537','2013-05-29','18:10:00',1.16),('8537','2013-05-29','18:15:00',1.84),('8537','2013-05-29','18:20:00',1.63),('8537','2013-05-28','07:15:00',1.02),('8537','2013-05-28','07:20:00',1.2),('8537','2013-05-28','07:25:00',1.26),('8537','2013-05-28','07:30:00',1.02),('8537','2013-05-28','07:40:00',1.23),('8537','2013-05-28','07:45:00',1.33),('8537','2013-05-28','07:50:00',1.32),('8537','2013-05-28','07:55:00',1.34),('8537','2013-05-28','08:00:00',1.38),('8537','2013-05-28','08:05:00',1.47),('8537','2013-05-28','08:10:00',1.68),('8537','2013-05-28','08:15:00',1.95),('8537','2013-05-28','08:20:00',2.14),('8537','2013-05-28','08:25:00',1.94),('8537','2013-05-28','08:30:00',2.11),('8537','2013-05-28','08:35:00',1.97),('8537','2013-05-28','08:40:00',1.71),('8537','2013-05-28','08:45:00',1.64),('8537','2013-05-28','08:50:00',1.89),('8537','2013-05-28','08:55:00',1.79),('8537','2013-05-28','09:00:00',1.96),('8537','2013-05-28','09:05:00',2.13),('8537','2013-05-28','09:10:00',1.96),('8537','2013-05-28','09:15:00',1.85),('8537','2013-05-28','09:20:00',2.16),('8537','2013-05-28','09:25:00',2.51),('8537','2013-05-28','09:30:00',2.7),('8537','2013-05-28','09:35:00',2.78),('8537','2013-05-28','09:40:00',2.66),('8537','2013-05-28','09:45:00',2.45),('8537','2013-05-28','09:50:00',2.52),('8537','2013-05-28','09:55:00',2.65),('8537','2013-05-28','10:00:00',2.5),('8537','2013-05-28','10:05:00',2.66),('8537','2013-05-28','10:10:00',2.95),('8537','2013-05-28','10:15:00',3.08),('8537','2013-05-28','10:20:00',3.25),('8537','2013-05-28','10:25:00',3.18),('8537','2013-05-28','10:30:00',3.56),('8537','2013-05-28','10:35:00',3.69),('8537','2013-05-28','10:40:00',3.19),('8537','2013-05-28','10:45:00',3.02),('8537','2013-05-28','10:50:00',3.35),('8537','2013-05-28','10:55:00',2.85),('8537','2013-05-28','11:00:00',2.87),('8537','2013-05-28','11:05:00',2.85),('8537','2013-05-28','11:10:00',3.09),('8537','2013-05-28','11:15:00',2.42),('8537','2013-05-28','11:20:00',2.61),('8537','2013-05-28','11:25:00',2.33),('8537','2013-05-28','11:30:00',4.5),('8537','2013-05-28','11:35:00',3.52),('8537','2013-05-28','11:40:00',4.36),('8537','2013-05-28','11:45:00',4.32),('8537','2013-05-28','11:50:00',1.39),('8537','2013-05-28','11:55:00',1.94),('8537','2013-05-28','12:00:00',1.94),('8537','2013-05-28','12:05:00',2.19),('8537','2013-05-28','12:10:00',3.57),('8537','2013-05-28','12:15:00',3.23),('8537','2013-05-28','12:20:00',2.74),('8537','2013-05-28','12:25:00',2.83),('8537','2013-05-28','12:30:00',3.18),('8537','2013-05-28','12:35:00',3.06),('8537','2013-05-28','12:40:00',3.12),('8537','2013-05-28','12:45:00',3.58),('8537','2013-05-28','12:50:00',3.16),('8537','2013-05-28','12:55:00',3.16),('8537','2013-05-28','13:00:00',3.22),('8537','2013-05-28','13:05:00',3.48),('8537','2013-05-28','13:10:00',3.63),('8537','2013-05-28','13:15:00',3.2),('8537','2013-05-28','13:20:00',4.27),('8537','2013-05-28','13:25:00',2.19),('8537','2013-05-28','13:30:00',2.6),('8537','2013-05-28','13:35:00',2.13),('8537','2013-05-28','13:40:00',2.34),('8537','2013-05-28','13:45:00',2.25),('8537','2013-05-28','13:50:00',3.33),('8537','2013-05-28','13:55:00',3.16),('8537','2013-05-28','14:00:00',3.09),('8537','2013-05-28','14:05:00',3.25),('8537','2013-05-28','14:10:00',4.67),('8537','2013-05-28','14:15:00',4.58),('8537','2013-05-28','14:20:00',3),('8537','2013-05-28','14:25:00',3.33),('8537','2013-05-28','14:30:00',4.04),('8537','2013-05-28','14:35:00',3.64),('8537','2013-05-28','14:40:00',3.89),('8537','2013-05-28','14:45:00',4.6),('8537','2013-05-28','14:50:00',3.35),('8537','2013-05-28','14:55:00',3.04),('8537','2013-05-28','15:00:00',2.68),('8537','2013-05-28','15:05:00',4.31),('8537','2013-05-28','15:10:00',1.98),('8537','2013-05-28','15:15:00',2.97),('8537','2013-05-28','15:20:00',3.68),('8537','2013-05-28','15:25:00',2.42),('8537','2013-05-28','15:30:00',1.78),('8537','2013-05-28','15:35:00',1.82),('8537','2013-05-28','15:40:00',2.8),('8537','2013-05-28','15:45:00',4.27),('8537','2013-05-28','15:50:00',3.51),('8537','2013-05-28','15:55:00',2.72),('8537','2013-05-28','16:00:00',1.91),('8537','2013-05-28','16:05:00',1.54),('8537','2013-05-28','16:10:00',1.64),('8537','2013-05-28','16:15:00',1.74),('8537','2013-05-28','16:20:00',2.46),('8537','2013-05-28','16:25:00',2.3),('8537','2013-05-28','16:30:00',2.4),('8537','2013-05-28','16:35:00',3.36),('8537','2013-05-28','16:40:00',3.15),('8537','2013-05-28','16:45:00',3.03),('8537','2013-05-28','16:50:00',2.95),('8537','2013-05-28','16:55:00',2.87),('8537','2013-05-28','17:00:00',2.77),('8537','2013-05-28','17:05:00',2.68),('8537','2013-05-28','17:10:00',2.56),('8537','2013-05-28','17:15:00',2.49),('8537','2013-05-28','17:20:00',2.37),('8537','2013-05-28','17:25:00',2.2),('8537','2013-05-28','17:30:00',2.11),('8537','2013-05-28','17:35:00',1.99),('8537','2013-05-28','17:40:00',1.63),('8537','2013-05-28','17:45:00',1.72),('8537','2013-05-28','17:50:00',1.71),('8537','2013-05-28','17:55:00',1.59),('8537','2013-05-28','18:00:00',1.59),('8537','2013-05-28','18:05:00',1.49),('8537','2013-05-28','18:10:00',1.03),('8537','2013-05-27','07:25:00',1.04),('8537','2013-05-27','07:30:00',1.21),('8537','2013-05-27','07:35:00',1.27),('8537','2013-05-27','07:40:00',1.34),('8537','2013-05-27','07:45:00',1.52),('8537','2013-05-27','07:50:00',1.33),('8537','2013-05-27','08:00:00',1.53),('8537','2013-05-27','08:05:00',1.95),('8537','2013-05-27','08:10:00',2.23),('8537','2013-05-27','08:15:00',2.06),('8537','2013-05-27','08:20:00',1.93),('8537','2013-05-27','08:25:00',1.94),('8537','2013-05-27','08:30:00',2.5),('8537','2013-05-27','08:35:00',2.57),('8537','2013-05-27','08:40:00',2.71),('8537','2013-05-27','08:45:00',2.87),('8537','2013-05-27','08:50:00',3.27),('8537','2013-05-27','08:55:00',3.22),('8537','2013-05-27','09:00:00',3.29),('8537','2013-05-27','09:05:00',3.61),('8537','2013-05-27','09:10:00',2.75),('8537','2013-05-27','09:15:00',3.02),('8537','2013-05-27','09:20:00',2.53),('8537','2013-05-27','09:25:00',3.03),('8537','2013-05-27','09:30:00',3.69),('8537','2013-05-27','09:35:00',3.84),('8537','2013-05-27','09:40:00',3.9),('8537','2013-05-27','09:45:00',4),('8537','2013-05-27','09:50:00',3.95),('8537','2013-05-27','09:55:00',4.26),('8537','2013-05-27','10:00:00',4.33),('8537','2013-05-27','10:05:00',4.37),('8537','2013-05-27','10:10:00',4.43),('8537','2013-05-27','10:15:00',4.54),('8537','2013-05-27','10:20:00',3.6),('8537','2013-05-27','10:25:00',2.41),('8537','2013-05-27','10:30:00',3.41),('8537','2013-05-27','10:35:00',1.39),('8537','2013-05-27','10:40:00',2.55),('8537','2013-05-27','10:45:00',3.36),('8537','2013-05-27','10:50:00',3.02),('8537','2013-05-27','10:55:00',2.98),('8537','2013-05-27','11:00:00',3.91),('8537','2013-05-27','11:05:00',4.96),('8537','2013-05-27','11:10:00',3.65),('8537','2013-05-27','11:15:00',2.83),('8537','2013-05-27','11:20:00',3.63),('8537','2013-05-27','11:25:00',5.14),('8537','2013-05-27','11:30:00',2.67),('8537','2013-05-27','11:35:00',2.85),('8537','2013-05-27','11:40:00',4.08),('8537','2013-05-27','11:45:00',3.9),('8537','2013-05-27','11:50:00',2.53),('8537','2013-05-27','11:55:00',2.93),('8537','2013-05-27','12:00:00',5.56),('8537','2013-05-27','12:05:00',3.18),('8537','2013-05-27','12:10:00',4.19),('8537','2013-05-27','12:15:00',4.98),('8537','2013-05-27','12:20:00',5.32),('8537','2013-05-27','12:25:00',5.12),('8537','2013-05-27','12:30:00',5.56),('8537','2013-05-27','12:35:00',3.72),('8537','2013-05-27','12:40:00',5.67),('8537','2013-05-27','12:45:00',5.49),('8537','2013-05-27','12:50:00',5.5),('8537','2013-05-27','12:55:00',5.77),('8537','2013-05-27','13:00:00',5.11),('8537','2013-05-27','13:05:00',1.58),('8537','2013-05-27','13:10:00',5.51),('8537','2013-05-27','13:15:00',3.35),('8537','2013-05-27','13:20:00',3.99),('8537','2013-05-27','13:25:00',5.6),('8537','2013-05-27','13:30:00',5.63),('8537','2013-05-27','13:35:00',3.76),('8537','2013-05-27','13:40:00',5.93),('8537','2013-05-27','13:45:00',5.03),('8537','2013-05-27','13:50:00',4.16),('8537','2013-05-27','13:55:00',4.33),('8537','2013-05-27','14:00:00',5.33),('8537','2013-05-27','14:05:00',5.38),('8537','2013-05-27','14:10:00',4.45),('8537','2013-05-27','14:15:00',4.07),('8537','2013-05-27','14:20:00',3.3),('8537','2013-05-27','14:25:00',4.87),('8537','2013-05-27','14:30:00',4.59),('8537','2013-05-27','14:35:00',4.7),('8537','2013-05-27','14:40:00',1.41),('8537','2013-05-27','14:45:00',5.61),('8537','2013-05-27','14:50:00',5.26),('8537','2013-05-27','14:55:00',4.31),('8537','2013-05-27','15:00:00',3.3),('8537','2013-05-27','15:05:00',3.03),('8537','2013-05-27','15:10:00',4.84),('8537','2013-05-27','15:15:00',3.4),('8537','2013-05-27','15:20:00',4.09),('8537','2013-05-27','15:25:00',3.83),('8537','2013-05-27','15:30:00',4.15),('8537','2013-05-27','15:35:00',4.64),('8537','2013-05-27','15:40:00',3.8),('8537','2013-05-27','15:45:00',3.49),('8537','2013-05-27','15:50:00',4.24),('8537','2013-05-27','15:55:00',2.87),('8537','2013-05-27','16:00:00',3.48),('8537','2013-05-27','16:05:00',2.48),('8537','2013-05-27','16:10:00',2.97),('8537','2013-05-27','16:15:00',2.65),('8537','2013-05-27','16:20:00',4.18),('8537','2013-05-27','16:25:00',3.85),('8537','2013-05-27','16:30:00',3.59),('8537','2013-05-27','16:35:00',3.28),('8537','2013-05-27','16:40:00',1.54),('8537','2013-05-27','16:45:00',1.41),('8537','2013-05-27','16:50:00',1.47),('8537','2013-05-27','16:55:00',1.58),('8537','2013-05-27','17:00:00',1.64),('8537','2013-05-27','17:05:00',1.67),('8537','2013-05-27','17:10:00',1.99),('8537','2013-05-27','17:15:00',1.67),('8537','2013-05-27','17:20:00',1.46),('8537','2013-05-27','17:25:00',1.34),('8537','2013-05-27','17:30:00',1.31),('8537','2013-05-27','17:35:00',1.22),('8537','2013-05-27','17:40:00',1.12),('8537','2013-05-27','17:45:00',1.06),('8537','2013-05-27','17:50:00',1.02),('8537','2013-05-27','17:55:00',1.04),('8537','2013-05-27','18:00:00',1.03),('8537','2013-05-27','18:15:00',1.05),('8537','2013-05-27','18:20:00',1.24),('8537','2013-05-27','18:25:00',1.55),('8537','2013-05-27','18:30:00',1.3),('8537','2013-05-26','07:20:00',1.09),('8537','2013-05-26','07:35:00',1.16),('8537','2013-05-26','07:40:00',1.44),('8537','2013-05-26','07:45:00',1.64),('8537','2013-05-26','07:50:00',2.33),('8537','2013-05-26','08:05:00',1.94),('8537','2013-05-26','08:10:00',2.18),('8537','2013-05-26','08:20:00',1.11),('8537','2013-05-26','08:25:00',1.57),('8537','2013-05-26','08:30:00',2.53),('8537','2013-05-26','08:35:00',2.27),('8537','2013-05-26','08:40:00',2.7),('8537','2013-05-26','08:45:00',2.76),('8537','2013-05-26','08:50:00',3.16),('8537','2013-05-26','08:55:00',1.02),('8537','2013-05-26','09:00:00',2.44),('8537','2013-05-26','09:10:00',2.43),('8537','2013-05-26','09:15:00',2.26),('8537','2013-05-26','09:25:00',1.67),('8537','2013-05-26','09:40:00',1.07),('8537','2013-05-26','09:45:00',2.78),('8537','2013-05-26','09:55:00',1.25),('8537','2013-05-26','10:00:00',1.77),('8537','2013-05-26','10:05:00',3.29),('8537','2013-05-26','10:10:00',4.64),('8537','2013-05-26','10:15:00',3.01),('8537','2013-05-26','10:20:00',1.88),('8537','2013-05-26','10:25:00',3.51),('8537','2013-05-26','10:30:00',4.5),('8537','2013-05-26','10:35:00',4.37),('8537','2013-05-26','10:40:00',4.88),('8537','2013-05-26','10:45:00',4.93),('8537','2013-05-26','10:50:00',5),('8537','2013-05-26','10:55:00',5.13),('8537','2013-05-26','11:00:00',4.98),('8537','2013-05-26','11:05:00',5.16),('8537','2013-05-26','11:10:00',5.19),('8537','2013-05-26','11:15:00',5.21),('8537','2013-05-26','11:20:00',5.28),('8537','2013-05-26','11:25:00',5.3),('8537','2013-05-26','11:30:00',5.42),('8537','2013-05-26','11:35:00',5.13),('8537','2013-05-26','11:40:00',5.34),('8537','2013-05-26','11:45:00',5.57),('8537','2013-05-26','11:50:00',5.51),('8537','2013-05-26','11:55:00',5.66),('8537','2013-05-26','12:00:00',5.58),('8537','2013-05-26','12:05:00',5.63),('8537','2013-05-26','12:10:00',5.18),('8537','2013-05-26','12:15:00',4.67),('8537','2013-05-26','12:20:00',4.46),('8537','2013-05-26','12:25:00',5.02),('8537','2013-05-26','12:30:00',5.78),('8537','2013-05-26','12:35:00',5.75),('8537','2013-05-26','12:40:00',5.1),('8537','2013-05-26','12:45:00',4.06),('8537','2013-05-26','12:50:00',5.8),('8537','2013-05-26','12:55:00',5.77),('8537','2013-05-26','13:00:00',5.66),('8537','2013-05-26','13:05:00',5.19),('8537','2013-05-26','13:10:00',5.66),('8537','2013-05-26','13:15:00',5.15),('8537','2013-05-26','13:20:00',5.79),('8537','2013-05-26','13:25:00',5.66),('8537','2013-05-26','13:30:00',5.76),('8537','2013-05-26','13:35:00',5.7),('8537','2013-05-26','13:40:00',5.59),('8537','2013-05-26','13:45:00',5.59),('8537','2013-05-26','13:50:00',5.45),('8537','2013-05-26','13:55:00',5.47),('8537','2013-05-26','14:00:00',5.47),('8537','2013-05-26','14:05:00',5.45),('8537','2013-05-26','14:10:00',5.41),('8537','2013-05-26','14:15:00',5.38),('8537','2013-05-26','14:20:00',5.34),('8537','2013-05-26','14:25:00',5.27),('8537','2013-05-26','14:30:00',5.24),('8537','2013-05-26','14:35:00',5.16),('8537','2013-05-26','14:40:00',5.02),('8537','2013-05-26','14:45:00',4.88),('8537','2013-05-26','14:50:00',5.02),('8537','2013-05-26','14:55:00',4.99),('8537','2013-05-26','15:00:00',4.9),('8537','2013-05-26','15:05:00',4.89),('8537','2013-05-26','15:10:00',4.84),('8537','2013-05-26','15:15:00',4.78),('8537','2013-05-26','15:20:00',4.74),('8537','2013-05-26','15:25:00',4.68),('8537','2013-05-26','15:30:00',4.64),('8537','2013-05-26','15:35:00',4.41),('8537','2013-05-26','15:40:00',4.28),('8537','2013-05-26','15:45:00',4.35),('8537','2013-05-26','15:50:00',4.3),('8537','2013-05-26','15:55:00',4.23),('8537','2013-05-26','16:00:00',4.16),('8537','2013-05-26','16:05:00',4.09),('8537','2013-05-26','16:10:00',4.03),('8537','2013-05-26','16:15:00',3.94),('8537','2013-05-26','16:20:00',3.74),('8537','2013-05-26','16:25:00',3.48),('8537','2013-05-26','16:30:00',3.64),('8537','2013-05-26','16:35:00',3.54),('8537','2013-05-26','16:40:00',3.45),('8537','2013-05-26','16:45:00',3.38),('8537','2013-05-26','16:50:00',3.29),('8537','2013-05-26','16:55:00',3.18),('8537','2013-05-26','17:00:00',3.02),('8537','2013-05-26','17:05:00',2.96),('8537','2013-05-26','17:10:00',2.85),('8537','2013-05-26','17:15:00',2.76),('8537','2013-05-26','17:20:00',2.61),('8537','2013-05-26','17:25:00',2.46),('8537','2013-05-26','17:30:00',2.37),('8537','2013-05-26','17:35:00',2.26),('8537','2013-05-26','17:40:00',2.16),('8537','2013-05-26','17:45:00',2),('8537','2013-05-26','17:50:00',1.94),('8537','2013-05-26','17:55:00',1.79),('8537','2013-05-26','18:00:00',1.71),('8537','2013-05-26','18:05:00',1.6),('8537','2013-05-26','18:10:00',1.49),('8537','2013-05-26','18:15:00',1.37),('8537','2013-05-26','18:20:00',1.26),('8537','2013-05-26','18:25:00',1.16),('8537','2013-05-26','18:30:00',1.06),('8537','2013-05-25','07:15:00',1.19),('8537','2013-05-25','07:20:00',1.14),('8537','2013-05-25','07:30:00',1.29),('8537','2013-05-25','07:35:00',1.76),('8537','2013-05-25','07:40:00',1.56),('8537','2013-05-25','07:55:00',1.89),('8537','2013-05-25','08:00:00',2.3),('8537','2013-05-25','08:05:00',2.22),('8537','2013-05-25','08:10:00',1.85),('8537','2013-05-25','08:20:00',1.8),('8537','2013-05-25','08:25:00',2.78),('8537','2013-05-25','08:30:00',3),('8537','2013-05-25','08:35:00',1.79),('8537','2013-05-25','08:40:00',2.05),('8537','2013-05-25','08:45:00',1.5),('8537','2013-05-25','08:50:00',2.07),('8537','2013-05-25','08:55:00',2.16),('8537','2013-05-25','09:00:00',2.1),('8537','2013-05-25','09:05:00',3.55),('8537','2013-05-25','09:10:00',3.57),('8537','2013-05-25','09:15:00',4.15),('8537','2013-05-25','09:20:00',1.82),('8537','2013-05-25','09:25:00',1.81),('8537','2013-05-25','09:30:00',1.34),('8537','2013-05-25','09:35:00',2.91),('8537','2013-05-25','09:40:00',4.43),('8537','2013-05-25','09:45:00',3.13),('8537','2013-05-25','09:50:00',3.92),('8537','2013-05-25','09:55:00',2.66),('8537','2013-05-25','10:00:00',1.16),('8537','2013-05-25','10:10:00',1.24),('8537','2013-05-25','10:15:00',1.31),('8537','2013-05-25','10:25:00',1.04),('8537','2013-05-25','10:30:00',1.14),('8537','2013-05-25','10:35:00',1),('8537','2013-05-25','10:40:00',1.76),('8537','2013-05-25','10:45:00',1.69),('8537','2013-05-25','10:50:00',1.66),('8537','2013-05-25','10:55:00',1.04),('8537','2013-05-25','11:00:00',1.26),('8537','2013-05-25','11:05:00',2.3),('8537','2013-05-25','11:10:00',4.91),('8537','2013-05-25','11:15:00',4.41),('8537','2013-05-25','11:20:00',3.34),('8537','2013-05-25','11:25:00',1.21),('8537','2013-05-25','11:35:00',1.47),('8537','2013-05-25','11:40:00',2.28),('8537','2013-05-25','11:45:00',2.81),('8537','2013-05-25','11:50:00',2.16),('8537','2013-05-25','11:55:00',2.3),('8537','2013-05-25','12:00:00',1.58),('8537','2013-05-25','12:05:00',1.47),('8537','2013-05-25','12:10:00',1.93),('8537','2013-05-25','12:15:00',1.28),('8537','2013-05-25','12:20:00',1.54),('8537','2013-05-25','12:25:00',2.2),('8537','2013-05-25','12:30:00',1.77),('8537','2013-05-25','12:35:00',1.54),('8537','2013-05-25','12:40:00',1.94),('8537','2013-05-25','12:45:00',2.2),('8537','2013-05-25','12:50:00',1.63),('8537','2013-05-25','12:55:00',2.93),('8537','2013-05-25','13:00:00',1.27),('8537','2013-05-25','13:05:00',1.85),('8537','2013-05-25','13:10:00',1.71),('8537','2013-05-25','13:15:00',2.09),('8537','2013-05-25','13:20:00',2.39),('8537','2013-05-25','13:25:00',3.79),('8537','2013-05-25','13:30:00',2.37),('8537','2013-05-25','13:35:00',1.57),('8537','2013-05-25','13:40:00',2.38),('8537','2013-05-25','13:45:00',2.24),('8537','2013-05-25','13:50:00',2.64),('8537','2013-05-25','13:55:00',3.88),('8537','2013-05-25','14:00:00',4.09),('8537','2013-05-25','14:05:00',5.46),('8537','2013-05-25','14:10:00',5.28),('8537','2013-05-25','14:15:00',5.2),('8537','2013-05-25','14:20:00',4.34),('8537','2013-05-25','14:25:00',3.22),('8537','2013-05-25','14:30:00',3.93),('8537','2013-05-25','14:35:00',2.99),('8537','2013-05-25','14:40:00',1.51),('8537','2013-05-25','14:45:00',2.95),('8537','2013-05-25','14:50:00',1.93),('8537','2013-05-25','14:55:00',2),('8537','2013-05-25','15:00:00',4.09),('8537','2013-05-25','15:05:00',3.38),('8537','2013-05-25','15:10:00',2.2),('8537','2013-05-25','15:15:00',3),('8537','2013-05-25','15:20:00',1.57),('8537','2013-05-25','15:25:00',3.15),('8537','2013-05-25','15:30:00',2.92),('8537','2013-05-25','15:35:00',4.91),('8537','2013-05-25','15:40:00',4.29),('8537','2013-05-25','15:45:00',4.47),('8537','2013-05-25','15:50:00',4.81),('8537','2013-05-25','15:55:00',4.94),('8537','2013-05-25','16:00:00',3.65),('8537','2013-05-25','16:05:00',1.62),('8537','2013-05-25','16:10:00',2.68),('8537','2013-05-25','16:15:00',1.69),('8537','2013-05-25','16:20:00',1.92),('8537','2013-05-25','16:25:00',1.58),('8537','2013-05-25','16:30:00',2.97),('8537','2013-05-25','16:35:00',3.35),('8537','2013-05-25','16:40:00',3.42),('8537','2013-05-25','16:45:00',2.65),('8537','2013-05-25','16:50:00',1.94),('8537','2013-05-25','16:55:00',1.02),('8537','2013-05-25','17:00:00',1.04),('8537','2013-05-25','17:05:00',1.49),('8537','2013-05-25','17:10:00',3.18),('8537','2013-05-25','17:15:00',2.22),('8537','2013-05-25','17:20:00',2.39),('8537','2013-05-25','17:25:00',1.45),('8537','2013-05-25','17:35:00',1.7),('8537','2013-05-25','17:40:00',1.2),('8537','2013-05-25','17:45:00',1.13),('8537','2013-05-25','17:50:00',1.41),('8537','2013-05-24','08:05:00',2.1),('8537','2013-05-24','08:10:00',2.4),('8537','2013-05-24','08:15:00',2.4),('8537','2013-05-24','08:20:00',1.08),('8537','2013-05-24','08:25:00',1.11),('8537','2013-05-24','08:30:00',2.5),('8537','2013-05-24','08:35:00',1.97),('8537','2013-05-24','08:45:00',2.54),('8537','2013-05-24','08:50:00',2.9),('8537','2013-05-24','08:55:00',3.06),('8537','2013-05-24','09:00:00',3.27),('8537','2013-05-24','09:05:00',3.71),('8537','2013-05-24','09:10:00',1.29),('8537','2013-05-24','09:20:00',2.67),('8537','2013-05-24','09:25:00',2.17),('8537','2013-05-24','09:30:00',2.41),('8537','2013-05-24','09:40:00',1.72),('8537','2013-05-24','09:45:00',1.34),('8537','2013-05-24','09:50:00',1.72),('8537','2013-05-24','09:55:00',3.18),('8537','2013-05-24','10:00:00',2.76),('8537','2013-05-24','10:05:00',1),('8537','2013-05-24','10:20:00',1.15),('8537','2013-05-24','10:25:00',2.73),('8537','2013-05-24','10:30:00',4.91),('8537','2013-05-24','10:35:00',4.56),('8537','2013-05-24','10:40:00',4.15),('8537','2013-05-24','10:45:00',4.47),('8537','2013-05-24','10:50:00',3.36),('8537','2013-05-24','10:55:00',5.41),('8537','2013-05-24','11:00:00',4.19),('8537','2013-05-24','11:05:00',3.64),('8537','2013-05-24','11:10:00',4.67),('8537','2013-05-24','11:15:00',3.99),('8537','2013-05-24','11:20:00',5.53),('8537','2013-05-24','11:25:00',5.55),('8537','2013-05-24','11:30:00',3.81),('8537','2013-05-24','11:35:00',1.58),('8537','2013-05-24','11:40:00',1.12),('8537','2013-05-24','11:45:00',3.29),('8537','2013-05-24','11:50:00',5.79),('8537','2013-05-24','11:55:00',3.94),('8537','2013-05-24','12:00:00',2.42),('8537','2013-05-24','12:05:00',3.57),('8537','2013-05-24','12:10:00',4.48),('8537','2013-05-24','12:15:00',2.91),('8537','2013-05-24','12:20:00',2.52),('8537','2013-05-24','12:25:00',3.12),('8537','2013-05-24','12:30:00',5.31),('8537','2013-05-24','12:35:00',2.5),('8537','2013-05-24','12:40:00',3.24),('8537','2013-05-24','12:45:00',4.05),('8537','2013-05-24','12:50:00',3.57),('8537','2013-05-24','12:55:00',2.91),('8537','2013-05-24','13:00:00',2.8),('8537','2013-05-24','13:05:00',2.4),('8537','2013-05-24','13:10:00',3.02),('8537','2013-05-24','13:15:00',3.45),('8537','2013-05-24','13:20:00',3.92),('8537','2013-05-24','13:25:00',3),('8537','2013-05-24','13:30:00',2.41),('8537','2013-05-24','13:35:00',4.1),('8537','2013-05-24','13:40:00',2.98),('8537','2013-05-24','13:45:00',1.55),('8537','2013-05-24','13:50:00',1.49),('8537','2013-05-24','13:55:00',3.74),('8537','2013-05-24','14:00:00',3.16),('8537','2013-05-24','14:05:00',2.74),('8537','2013-05-24','14:10:00',1.46),('8537','2013-05-24','14:15:00',4.7),('8537','2013-05-24','14:20:00',4.26),('8537','2013-05-24','14:25:00',3.91),('8537','2013-05-24','14:30:00',3.18),('8537','2013-05-24','14:35:00',3.65),('8537','2013-05-24','14:40:00',2.95),('8537','2013-05-24','14:45:00',3.72),('8537','2013-05-24','14:50:00',1.68),('8537','2013-05-24','14:55:00',1.99),('8537','2013-05-24','15:00:00',2.72),('8537','2013-05-24','15:05:00',4.31),('8537','2013-05-24','15:10:00',3.06),('8537','2013-05-24','15:15:00',3.28),('8537','2013-05-24','15:20:00',4.33),('8537','2013-05-24','15:25:00',3.66),('8537','2013-05-24','15:30:00',4.34),('8537','2013-05-24','15:35:00',3.47),('8537','2013-05-24','15:40:00',3.67),('8537','2013-05-24','15:45:00',4.52),('8537','2013-05-24','15:50:00',4.83),('8537','2013-05-24','15:55:00',5.18),('8537','2013-05-24','16:00:00',2.6),('8537','2013-05-24','16:05:00',2.42),('8537','2013-05-24','16:10:00',2.48),('8537','2013-05-24','16:15:00',3.03),('8537','2013-05-24','16:20:00',2.28),('8537','2013-05-24','16:25:00',2.91),('8537','2013-05-24','16:30:00',3.41),('8537','2013-05-24','16:35:00',1.66),('8537','2013-05-24','16:50:00',1.57),('8537','2013-05-24','16:55:00',2.1),('8537','2013-05-24','17:00:00',1.54),('8537','2013-05-24','17:05:00',1.07),('8537','2013-05-24','17:20:00',1.11),('8537','2013-05-24','17:25:00',1.19),('8537','2013-05-24','17:30:00',1.26),('8537','2013-05-24','17:35:00',1.27),('8537','2013-05-24','17:40:00',1.08),('8537','2013-05-23','07:10:00',1.01),('8537','2013-05-23','07:55:00',1.09),('8537','2013-05-23','08:00:00',1.33),('8537','2013-05-23','08:05:00',1.76),('8537','2013-05-23','08:10:00',1.66),('8537','2013-05-23','08:30:00',1.56),('8537','2013-05-23','08:35:00',2.48),('8537','2013-05-23','08:40:00',2.63),('8537','2013-05-23','08:45:00',2.04),('8537','2013-05-23','08:50:00',1.65),('8537','2013-05-23','09:00:00',3.25),('8537','2013-05-23','09:05:00',1.73),('8537','2013-05-23','09:15:00',1.17),('8537','2013-05-23','09:20:00',2.4),('8537','2013-05-23','09:25:00',3.81),('8537','2013-05-23','09:30:00',4.28),('8537','2013-05-23','09:35:00',2.85),('8537','2013-05-23','09:40:00',3.2),('8537','2013-05-23','09:45:00',2.07),('8537','2013-05-23','09:50:00',4.05),('8537','2013-05-23','09:55:00',1.95),('8537','2013-05-23','10:00:00',1.42),('8537','2013-05-23','10:05:00',3.73),('8537','2013-05-23','10:10:00',4.27),('8537','2013-05-23','10:15:00',4.55),('8537','2013-05-23','10:20:00',2.89),('8537','2013-05-23','10:25:00',4.74),('8537','2013-05-23','10:30:00',4.47),('8537','2013-05-23','10:35:00',4),('8537','2013-05-23','10:40:00',4.23),('8537','2013-05-23','10:45:00',5.19),('8537','2013-05-23','10:50:00',4.42),('8537','2013-05-23','10:55:00',5.51),('8537','2013-05-23','11:00:00',3.07),('8537','2013-05-23','11:05:00',3.56),('8537','2013-05-23','11:10:00',2.79),('8537','2013-05-23','11:15:00',2.57),('8537','2013-05-23','11:20:00',2.07),('8537','2013-05-23','11:25:00',1.86),('8537','2013-05-23','11:30:00',3.46),('8537','2013-05-23','11:35:00',4.66),('8537','2013-05-23','11:40:00',5.27),('8537','2013-05-23','11:45:00',3.17),('8537','2013-05-23','11:50:00',2.86),('8537','2013-05-23','11:55:00',5.29),('8537','2013-05-23','12:00:00',5.48),('8537','2013-05-23','12:05:00',5.59),('8537','2013-05-23','12:10:00',5.63),('8537','2013-05-23','12:15:00',4.34),('8537','2013-05-23','12:20:00',3.92),('8537','2013-05-23','12:25:00',5.36),('8537','2013-05-23','12:30:00',5.13),('8537','2013-05-23','12:35:00',2.31),('8537','2013-05-23','12:40:00',5.35),('8537','2013-05-23','12:45:00',4.49),('8537','2013-05-23','12:50:00',3.6),('8537','2013-05-23','12:55:00',5.12),('8537','2013-05-23','13:00:00',5.9),('8537','2013-05-23','13:05:00',3.31),('8537','2013-05-23','13:10:00',4.71),('8537','2013-05-23','13:15:00',4.45),('8537','2013-05-23','13:20:00',4.19),('8537','2013-05-23','13:25:00',3.17),('8537','2013-05-23','13:30:00',2.14),('8537','2013-05-23','13:35:00',2.32),('8537','2013-05-23','13:40:00',2.47),('8537','2013-05-23','13:45:00',4.46),('8537','2013-05-23','13:50:00',3.38),('8537','2013-05-23','13:55:00',4.5),('8537','2013-05-23','14:00:00',5.25),('8537','2013-05-23','14:05:00',5.19),('8537','2013-05-23','14:10:00',5.85),('8537','2013-05-23','14:15:00',4.03),('8537','2013-05-23','14:20:00',5.4),('8537','2013-05-23','14:25:00',4.38),('8537','2013-05-23','14:30:00',1.54),('8537','2013-05-23','14:35:00',5.79),('8537','2013-05-23','14:40:00',4.49),('8537','2013-05-23','14:45:00',2.53),('8537','2013-05-23','14:50:00',2.34),('8537','2013-05-23','14:55:00',3.2),('8537','2013-05-23','15:00:00',4.05),('8537','2013-05-23','15:05:00',3.8),('8537','2013-05-23','15:10:00',1.6),('8537','2013-05-23','15:15:00',1.7),('8537','2013-05-23','15:20:00',3.57),('8537','2013-05-23','15:25:00',1.52),('8537','2013-05-23','15:30:00',3.6),('8537','2013-05-23','15:35:00',3.93),('8537','2013-05-23','15:40:00',1.8),('8537','2013-05-23','15:45:00',3.1),('8537','2013-05-23','15:50:00',1.4),('8537','2013-05-23','15:55:00',1.7),('8537','2013-05-23','16:00:00',3.07),('8537','2013-05-23','16:05:00',4.29),('8537','2013-05-23','16:10:00',2.38),('8537','2013-05-23','16:15:00',2.77),('8537','2013-05-23','16:20:00',3.45),('8537','2013-05-23','16:25:00',2.98),('8537','2013-05-23','16:30:00',3.58),('8537','2013-05-23','16:35:00',2.27),('8537','2013-05-23','16:40:00',1.89),('8537','2013-05-23','16:45:00',1.84),('8537','2013-05-23','16:50:00',1.77),('8537','2013-05-23','17:05:00',1.13),('8537','2013-05-23','17:10:00',2.42),('8537','2013-05-23','17:15:00',1.93),('8537','2013-05-23','17:20:00',1.33),('8537','2013-05-23','17:25:00',1.02),('8537','2013-05-23','17:30:00',1.14),('8537','2013-05-23','17:35:00',1.45),('8537','2013-05-23','17:40:00',1.21),('8537','2013-05-23','17:45:00',1.15),('8537','2013-05-23','17:55:00',1.35),('8537','2013-05-23','18:00:00',1.6),('8537','2013-05-23','18:05:00',2.13),('8537','2013-05-23','18:10:00',1.13),('8537','2013-05-23','18:50:00',1.1),('8537','2013-05-23','18:55:00',1.01),('8537','2013-05-22','07:50:00',1.11),('8537','2013-05-22','07:55:00',1.21),('8537','2013-05-22','08:00:00',1.4),('8537','2013-05-22','08:05:00',1.78),('8537','2013-05-22','08:10:00',1.39),('8537','2013-05-22','08:15:00',2.37),('8537','2013-05-22','08:20:00',2.34),('8537','2013-05-22','08:25:00',2.21),('8537','2013-05-22','08:30:00',2.49),('8537','2013-05-22','08:35:00',2.97),('8537','2013-05-22','08:40:00',1.74),('8537','2013-05-22','08:45:00',2.08),('8537','2013-05-22','08:50:00',1.36),('8537','2013-05-22','09:15:00',1.05),('8537','2013-05-22','09:20:00',1.02),('8537','2013-05-22','09:25:00',1.31),('8537','2013-05-22','09:30:00',3.4),('8537','2013-05-22','09:35:00',3.54),('8537','2013-05-22','09:40:00',3.52),('8537','2013-05-22','09:45:00',3.56),('8537','2013-05-22','09:50:00',3.65),('8537','2013-05-22','09:55:00',3.73),('8537','2013-05-22','10:00:00',3.81),('8537','2013-05-22','10:05:00',3.88),('8537','2013-05-22','10:10:00',3.97),('8537','2013-05-22','10:15:00',4),('8537','2013-05-22','10:20:00',4),('8537','2013-05-22','10:25:00',4.2),('8537','2013-05-22','10:30:00',4.24),('8537','2013-05-22','10:35:00',4.26),('8537','2013-05-22','10:40:00',4.43),('8537','2013-05-22','10:45:00',4.45),('8537','2013-05-22','10:50:00',4.42),('8537','2013-05-22','10:55:00',4.47),('8537','2013-05-22','11:00:00',4.49),('8537','2013-05-22','11:05:00',4.71),('8537','2013-05-22','11:10:00',4.13),('8537','2013-05-22','11:15:00',4.39),('8537','2013-05-22','11:20:00',4.84),('8537','2013-05-22','11:25:00',4.94),('8537','2013-05-22','11:30:00',4.42),('8537','2013-05-22','11:35:00',4.2),('8537','2013-05-22','11:40:00',4.29),('8537','2013-05-22','11:45:00',5.02),('8537','2013-05-22','11:50:00',2.97),('8537','2013-05-22','11:55:00',2.56),('8537','2013-05-22','12:00:00',3.67),('8537','2013-05-22','12:05:00',2.8),('8537','2013-05-22','12:10:00',2.68),('8537','2013-05-22','12:15:00',3.63),('8537','2013-05-22','12:20:00',4.76),('8537','2013-05-22','12:25:00',3.57),('8537','2013-05-22','12:30:00',2.75),('8537','2013-05-22','12:35:00',2.84),('8537','2013-05-22','12:40:00',1.91),('8537','2013-05-22','13:00:00',1.44),('8537','2013-05-22','13:05:00',4.96),('8537','2013-05-22','13:10:00',2.75),('8537','2013-05-22','13:15:00',2.76),('8537','2013-05-22','13:20:00',2.8),('8537','2013-05-22','13:25:00',1.38),('8537','2013-05-22','13:30:00',2.19),('8537','2013-05-22','13:35:00',3.96),('8537','2013-05-22','13:40:00',3.94),('8537','2013-05-22','13:45:00',3.08),('8537','2013-05-22','13:50:00',2.74),('8537','2013-05-22','13:55:00',2.82),('8537','2013-05-22','14:00:00',2.87),('8537','2013-05-22','14:05:00',4.56),('8537','2013-05-22','14:10:00',4.78),('8537','2013-05-22','14:15:00',5.13),('8537','2013-05-22','14:20:00',5),('8537','2013-05-22','14:25:00',4.91),('8537','2013-05-22','14:30:00',4.86),('8537','2013-05-22','14:35:00',4.73),('8537','2013-05-22','14:40:00',4.62),('8537','2013-05-22','14:45:00',4.52),('8537','2013-05-22','14:50:00',4.66),('8537','2013-05-22','14:55:00',4.59),('8537','2013-05-22','15:00:00',4.5),('8537','2013-05-22','15:05:00',4.48),('8537','2013-05-22','15:10:00',4.43),('8537','2013-05-22','15:15:00',4.34),('8537','2013-05-22','15:20:00',4),('8537','2013-05-22','15:25:00',2.7),('8537','2013-05-22','15:30:00',1.99),('8537','2013-05-22','15:35:00',2.66),('8537','2013-05-22','15:40:00',2.51),('8537','2013-05-22','15:45:00',3.17),('8537','2013-05-22','15:50:00',3.93),('8537','2013-05-22','15:55:00',3.74),('8537','2013-05-22','16:00:00',3.74),('8537','2013-05-22','16:05:00',3.65),('8537','2013-05-22','16:10:00',3.54),('8537','2013-05-22','16:15:00',3.51),('8537','2013-05-22','16:20:00',3.33),('8537','2013-05-22','16:25:00',3.09),('8537','2013-05-22','16:30:00',3.19),('8537','2013-05-22','16:35:00',3.09),('8537','2013-05-22','16:40:00',3.03),('8537','2013-05-22','16:45:00',2.41),('8537','2013-05-22','16:50:00',1.81),('8537','2013-05-22','17:15:00',1.11),('8537','2013-05-22','17:20:00',1.35),('8537','2013-05-22','17:25:00',1.87),('8537','2013-05-22','17:30:00',1.4),('8537','2013-05-22','17:35:00',1.63),('8537','2013-05-22','17:55:00',1.35),('8537','2013-05-22','18:00:00',1.37),('8537','2014-04-01','08:10:00',1.07),('8537','2014-04-01','08:15:00',1.18),('8537','2014-04-01','08:20:00',1.28),('8537','2014-04-01','08:25:00',1.4),('8537','2014-04-01','08:30:00',1.52),('8537','2014-04-01','08:35:00',1.64),('8537','2014-04-01','08:40:00',1.76),('8537','2014-04-01','08:45:00',1.87),('8537','2014-04-01','08:50:00',1.98),('8537','2014-04-01','08:55:00',2.09),('8537','2014-04-01','09:00:00',2.22),('8537','2014-04-01','09:05:00',2.33),('8537','2014-04-01','09:10:00',2.43),('8537','2014-04-01','09:15:00',2.53),('8537','2014-04-01','09:20:00',2.62),('8537','2014-04-01','09:25:00',2.72),('8537','2014-04-01','09:30:00',2.81),('8537','2014-04-01','09:35:00',2.88),('8537','2014-04-01','09:40:00',3.01),('8537','2014-04-01','09:45:00',3.13),('8537','2014-04-01','09:50:00',3.19),('8537','2014-04-01','09:55:00',3.28),('8537','2014-04-01','10:00:00',3.41),('8537','2014-04-01','10:05:00',3.4),('8537','2014-04-01','10:10:00',3.45),('8537','2014-04-01','10:15:00',3.64),('8537','2014-04-01','10:20:00',3.81),('8537','2014-04-01','10:25:00',4.01),('8537','2014-04-01','10:30:00',3.9),('8537','2014-04-01','10:35:00',3.81),('8537','2014-04-01','10:40:00',4.48),('8537','2014-04-01','10:45:00',2.66),('8537','2014-04-01','10:50:00',4.34),('8537','2014-04-01','10:55:00',4.28),('8537','2014-04-01','11:00:00',4.26),('8537','2014-04-01','11:05:00',4.38),('8537','2014-04-01','11:10:00',4.36),('8537','2014-04-01','11:15:00',4.41),('8537','2014-04-01','11:20:00',4.42),('8537','2014-04-01','11:25:00',4.45),('8537','2014-04-01','11:30:00',4.63),('8537','2014-04-01','11:35:00',4.66),('8537','2014-04-01','11:40:00',4.68),('8537','2014-04-01','11:45:00',4.73),('8537','2014-04-01','11:50:00',4.77),('8537','2014-04-01','11:55:00',4.74),('8537','2014-04-01','12:00:00',4.81),('8537','2014-04-01','12:05:00',4.87),('8537','2014-04-01','12:10:00',4.91),('8537','2014-04-01','12:15:00',4.92),('8537','2014-04-01','12:20:00',4.98),('8537','2014-04-01','12:25:00',5.03),('8537','2014-04-01','12:30:00',5.07),('8537','2014-04-01','12:35:00',5.12),('8537','2014-04-01','12:40:00',5.08),('8537','2014-04-01','12:45:00',5.14),('8537','2014-04-01','12:50:00',5.17),('8537','2014-04-01','12:55:00',5.14),('8537','2014-04-01','13:00:00',5.14),('8537','2014-04-01','13:05:00',5.18),('8537','2014-04-01','13:10:00',4.21),('8537','2014-04-01','13:15:00',5.15),('8537','2014-04-01','13:20:00',4.83),('8537','2014-04-01','13:25:00',5.14),('8537','2014-04-01','13:30:00',5.09),('8537','2014-04-01','13:35:00',5.14),('8537','2014-04-01','13:40:00',5.19),('8537','2014-04-01','13:45:00',5.14),('8537','2014-04-01','13:50:00',5.06),('8537','2014-04-01','13:55:00',5.11),('8537','2014-04-01','14:00:00',5.05),('8537','2014-04-01','14:05:00',5.05),('8537','2014-04-01','14:10:00',5.04),('8537','2014-04-01','14:15:00',3.91),('8537','2014-04-01','14:20:00',4.79),('8537','2014-04-01','14:25:00',4.76),('8537','2014-04-01','14:30:00',3.67),('8537','2014-04-01','14:35:00',4.6),('8537','2014-04-01','14:40:00',4.13),('8537','2014-04-01','14:45:00',5.06),('8537','2014-04-01','14:50:00',4.92),('8537','2014-04-01','14:55:00',3.9),('8537','2014-04-01','15:00:00',4.69),('8537','2014-04-01','15:05:00',4.41),('8537','2014-04-01','15:10:00',4.22),('8537','2014-04-01','15:15:00',4.64),('8537','2014-04-01','15:20:00',4),('8537','2014-04-01','15:25:00',3.59),('8537','2014-04-01','15:30:00',3.87),('8537','2014-04-01','15:35:00',3.56),('8537','2014-04-01','15:40:00',3.67),('8537','2014-04-01','15:45:00',3.19),('8537','2014-04-01','15:50:00',4.05),('8537','2014-04-01','15:55:00',3.45),('8537','2014-04-01','16:00:00',2.68),('8537','2014-04-01','16:05:00',3.12),('8537','2014-04-01','16:10:00',2.44),('8537','2014-04-01','16:15:00',2.91),('8537','2014-04-01','16:20:00',1.87),('8537','2014-04-01','16:25:00',2.17),('8537','2014-04-01','16:30:00',2.67),('8537','2014-04-01','16:35:00',3.11),('8537','2014-04-01','16:40:00',3),('8537','2014-04-01','16:45:00',2.08),('8537','2014-04-01','16:50:00',1.24),('8537','2014-04-01','16:55:00',1.88),('8537','2014-04-01','17:00:00',2.6),('8537','2014-04-01','17:05:00',2.23),('8537','2014-04-01','17:10:00',2),('8537','2014-04-01','17:15:00',2.16),('8537','2014-04-01','17:20:00',2),('8537','2014-04-01','17:25:00',1.88),('8537','2014-04-01','17:30:00',1.75),('8537','2014-04-01','17:35:00',1.6),('8537','2014-04-01','17:40:00',1.53),('8537','2014-04-01','17:45:00',1.38),('8537','2014-04-01','17:50:00',1.29),('8537','2014-04-01','17:55:00',1.15),('8537','2014-04-01','18:00:00',1.04),('8537','2013-05-21','07:25:00',1.02),('8537','2013-05-21','07:30:00',1.2),('8537','2013-05-21','07:35:00',1.49),('8537','2013-05-21','07:40:00',1.72),('8537','2013-05-21','07:45:00',1.49),('8537','2013-05-21','07:50:00',1.24),('8537','2013-05-21','07:55:00',1.15),('8537','2013-05-21','08:00:00',1.47),('8537','2013-05-21','08:05:00',1.05),('8537','2013-05-21','08:10:00',1.59),('8537','2013-05-21','08:15:00',2.2),('8537','2013-05-21','08:20:00',1.82),('8537','2013-05-21','08:25:00',2.21),('8537','2013-05-21','08:30:00',1.63),('8537','2013-05-21','08:35:00',1.49),('8537','2013-05-21','08:40:00',1.75),('8537','2013-05-21','08:45:00',1.5),('8537','2013-05-21','08:50:00',1.61),('8537','2013-05-21','08:55:00',2.14),('8537','2013-05-21','09:00:00',1.86),('8537','2013-05-21','09:05:00',1.61),('8537','2013-05-21','09:10:00',1.75),('8537','2013-05-21','09:15:00',1.94),('8537','2013-05-21','09:20:00',2.68),('8537','2013-05-21','09:25:00',2.93),('8537','2013-05-21','09:30:00',2.27),('8537','2013-05-21','09:35:00',2.39),('8537','2013-05-21','09:40:00',2.34),('8537','2013-05-21','09:45:00',2.02),('8537','2013-05-21','09:50:00',1.93),('8537','2013-05-21','09:55:00',2.21),('8537','2013-05-21','10:00:00',2.31),('8537','2013-05-21','10:05:00',2.68),('8537','2013-05-21','10:10:00',2.8),('8537','2013-05-21','10:15:00',2.73),('8537','2013-05-21','10:20:00',2.5),('8537','2013-05-21','10:25:00',2.27),('8537','2013-05-21','10:30:00',2.12),('8537','2013-05-21','10:35:00',2.2),('8537','2013-05-21','10:40:00',2.51),('8537','2013-05-21','10:45:00',3.6),('8537','2013-05-21','10:50:00',2.51),('8537','2013-05-21','10:55:00',1.94),('8537','2013-05-21','11:00:00',2.32),('8537','2013-05-21','11:05:00',2.17),('8537','2013-05-21','11:10:00',3.71),('8537','2013-05-21','11:15:00',4.75),('8537','2013-05-21','11:20:00',3.73),('8537','2013-05-21','11:25:00',4.89),('8537','2013-05-21','11:30:00',3.4),('8537','2013-05-21','11:35:00',3.08),('8537','2013-05-21','11:40:00',3.35),('8537','2013-05-21','11:45:00',3.96),('8537','2013-05-21','11:50:00',3.17),('8537','2013-05-21','11:55:00',4.47),('8537','2013-05-21','12:00:00',3.87),('8537','2013-05-21','12:05:00',4.23),('8537','2013-05-21','12:10:00',3.3),('8537','2013-05-21','12:15:00',3.88),('8537','2013-05-21','12:20:00',2.78),('8537','2013-05-21','12:25:00',3.96),('8537','2013-05-21','12:30:00',4.74),('8537','2013-05-21','12:35:00',3.03),('8537','2013-05-21','12:40:00',4.61),('8537','2013-05-21','12:45:00',4.74),('8537','2013-05-21','12:50:00',2.8),('8537','2013-05-21','12:55:00',5.18),('8537','2013-05-21','13:00:00',4.73),('8537','2013-05-21','13:05:00',5.07),('8537','2013-05-21','13:10:00',3.11),('8537','2013-05-21','13:15:00',4.36),('8537','2013-05-21','13:20:00',3.64),('8537','2013-05-21','13:25:00',4.07),('8537','2013-05-21','13:30:00',3.65),('8537','2013-05-21','13:35:00',1.74),('8537','2013-05-21','13:40:00',1.05),('8537','2013-05-21','14:05:00',1.31),('8537','2013-05-21','14:10:00',2),('8537','2013-05-21','14:15:00',2.3),('8537','2013-05-21','14:20:00',2.05),('8537','2013-05-21','14:25:00',2.99),('8537','2013-05-21','14:30:00',2.79),('8537','2013-05-21','14:35:00',2.32),('8537','2013-05-21','14:40:00',2.21),('8537','2013-05-21','14:45:00',1.85),('8537','2013-05-21','14:50:00',1.19),('8537','2013-05-21','15:15:00',1.27),('8537','2013-05-21','15:20:00',1.73),('8537','2013-05-21','15:25:00',1.79),('8537','2013-05-21','15:30:00',2.51),('8537','2013-05-21','15:35:00',1.88),('8537','2013-05-21','15:40:00',1.52),('8537','2013-05-21','15:45:00',1.58),('8537','2013-05-21','15:50:00',1.44),('8537','2013-05-21','15:55:00',1.43),('8537','2013-05-21','16:00:00',1.42),('8537','2013-05-21','16:05:00',1.4),('8537','2013-05-21','16:10:00',1.52),('8537','2013-05-21','16:15:00',1.34),('8537','2013-05-21','16:20:00',1.11),('8537','2013-05-21','16:25:00',1.49),('8537','2013-05-21','16:30:00',1.95),('8537','2013-05-21','16:35:00',2.11),('8537','2013-05-21','16:40:00',2.25),('8537','2013-05-21','16:45:00',2.01),('8537','2013-05-21','16:50:00',1.3),('8537','2013-05-20','07:30:00',1.12),('8537','2013-05-20','07:35:00',1.24),('8537','2013-05-20','07:40:00',1.33),('8537','2013-05-20','07:45:00',1.45),('8537','2013-05-20','07:50:00',1.53),('8537','2013-05-20','07:55:00',1.64),('8537','2013-05-20','08:00:00',1.84),('8537','2013-05-20','08:05:00',1.77),('8537','2013-05-20','08:10:00',1.53),('8537','2013-05-20','08:20:00',1.57),('8537','2013-05-20','08:25:00',1.11),('8537','2013-05-20','08:45:00',1.63),('8537','2013-05-20','08:50:00',3.16),('8537','2013-05-20','08:55:00',3.39),('8537','2013-05-20','09:00:00',3.51),('8537','2013-05-20','09:05:00',3.24),('8537','2013-05-20','09:10:00',3.84),('8537','2013-05-20','09:15:00',2.44),('8537','2013-05-20','09:20:00',2.97),('8537','2013-05-20','09:25:00',1.65),('8537','2013-05-20','09:35:00',2.7),('8537','2013-05-20','09:40:00',1.02),('8537','2013-05-20','09:50:00',2.7),('8537','2013-05-20','10:05:00',1.39),('8537','2013-05-20','10:10:00',2.03),('8537','2013-05-20','10:15:00',1.18),('8537','2013-05-20','10:25:00',1.08),('8537','2013-05-20','10:30:00',2.97),('8537','2013-05-20','10:35:00',2.64),('8537','2013-05-20','10:40:00',1.44),('8537','2013-05-20','10:45:00',1.33),('8537','2013-05-20','10:50:00',2.98),('8537','2013-05-20','10:55:00',2.15),('8537','2013-05-20','11:00:00',4.19),('8537','2013-05-20','11:05:00',5.32),('8537','2013-05-20','11:10:00',5.69),('8537','2013-05-20','11:15:00',5.06),('8537','2013-05-20','11:20:00',3.38),('8537','2013-05-20','11:25:00',4.73),('8537','2013-05-20','11:30:00',2.66),('8537','2013-05-20','11:35:00',4.68),('8537','2013-05-20','11:40:00',1.13),('8537','2013-05-20','11:45:00',2.17),('8537','2013-05-20','11:50:00',1.15),('8537','2013-05-20','11:55:00',5.03),('8537','2013-05-20','12:00:00',1.85),('8537','2013-05-20','12:05:00',3.43),('8537','2013-05-20','12:10:00',4.16),('8537','2013-05-20','12:15:00',1.98),('8537','2013-05-20','12:20:00',3.95),('8537','2013-05-20','12:25:00',2.39),('8537','2013-05-20','12:30:00',3.25),('8537','2013-05-20','12:35:00',1.88),('8537','2013-05-20','12:40:00',5.31),('8537','2013-05-20','12:45:00',5.89),('8537','2013-05-20','12:50:00',2.02),('8537','2013-05-20','12:55:00',2.32),('8537','2013-05-20','13:00:00',3.27),('8537','2013-05-20','13:05:00',4.89),('8537','2013-05-20','13:10:00',2.14),('8537','2013-05-20','13:15:00',1.82),('8537','2013-05-20','13:20:00',3.35),('8537','2013-05-20','13:25:00',3.95),('8537','2013-05-20','13:30:00',3.14),('8537','2013-05-20','13:35:00',3.67),('8537','2013-05-20','13:40:00',3.33),('8537','2013-05-20','13:45:00',3.67),('8537','2013-05-20','13:50:00',5.44),('8537','2013-05-20','13:55:00',3.66),('8537','2013-05-20','14:00:00',5.7),('8537','2013-05-20','14:05:00',2.75),('8537','2013-05-20','14:10:00',1.88),('8537','2013-05-20','14:15:00',5.33),('8537','2013-05-20','14:20:00',3.84),('8537','2013-05-20','14:25:00',3.22),('8537','2013-05-20','14:30:00',5.35),('8537','2013-05-20','14:35:00',2.56),('8537','2013-05-20','14:40:00',1.79),('8537','2013-05-20','14:45:00',3.75),('8537','2013-05-20','14:50:00',5.42),('8537','2013-05-20','14:55:00',2.89),('8537','2013-05-20','15:00:00',3.64),('8537','2013-05-20','15:05:00',1.42),('8537','2013-05-20','15:10:00',5.29),('8537','2013-05-20','15:15:00',3.15),('8537','2013-05-20','15:20:00',3.3),('8537','2013-05-20','15:25:00',3.82),('8537','2013-05-20','15:30:00',3.41),('8537','2013-05-20','15:35:00',4.85),('8537','2013-05-20','15:40:00',3.49),('8537','2013-05-20','15:45:00',1.75),('8537','2013-05-20','15:50:00',3.58),('8537','2013-05-20','15:55:00',1.42),('8537','2013-05-20','16:00:00',2.63),('8537','2013-05-20','16:05:00',3.8),('8537','2013-05-20','16:10:00',3.54),('8537','2013-05-20','16:15:00',2.85),('8537','2013-05-20','16:20:00',3.9),('8537','2013-05-20','16:25:00',3.81),('8537','2013-05-20','16:30:00',3.64),('8537','2013-05-20','16:35:00',3.5),('8537','2013-05-20','16:40:00',3.45),('8537','2013-05-20','16:45:00',3.2),('8537','2013-05-20','16:50:00',3.12),('8537','2013-05-20','16:55:00',2.94),('8537','2013-05-20','17:00:00',2.5),('8537','2013-05-20','17:05:00',2.89),('8537','2013-05-20','17:10:00',2),('8537','2013-05-20','17:15:00',1.35),('8537','2013-05-20','17:20:00',1.73),('8537','2013-05-20','17:25:00',2.2),('8537','2013-05-20','17:30:00',2.18),('8537','2013-05-20','17:35:00',2.14),('8537','2013-05-20','17:40:00',1.94),('8537','2013-05-20','17:45:00',1.88),('8537','2013-05-20','17:50:00',1.73),('8537','2013-05-20','17:55:00',1.65),('8537','2013-05-20','18:00:00',1.59),('8537','2013-05-20','18:05:00',1.63),('8537','2013-05-20','18:10:00',1.16),('8537','2013-05-20','18:15:00',1.24),('8537','2013-05-20','18:20:00',1.18),('8537','2013-05-20','18:25:00',1.08),('8537','2013-05-19','08:30:00',1.04),('8537','2013-05-19','08:35:00',1.38),('8537','2013-05-19','08:40:00',1.13),('8537','2013-05-19','08:45:00',1.2),('8537','2013-05-19','08:50:00',1.4),('8537','2013-05-19','08:55:00',2.03),('8537','2013-05-19','09:00:00',1.83),('8537','2013-05-19','09:05:00',1.35),('8537','2013-05-19','09:10:00',1.49),('8537','2013-05-19','09:15:00',1.6),('8537','2013-05-19','09:20:00',1.27),('8537','2013-05-19','09:40:00',1.21),('8537','2013-05-19','09:45:00',1.44),('8537','2013-05-19','09:55:00',1.12),('8537','2013-05-19','10:00:00',1.79),('8537','2013-05-19','10:05:00',1.88),('8537','2013-05-19','10:10:00',2.4),('8537','2013-05-19','10:15:00',4.14),('8537','2013-05-19','10:20:00',3.11),('8537','2013-05-19','10:25:00',2.92),('8537','2013-05-19','10:30:00',3.56),('8537','2013-05-19','10:35:00',2.79),('8537','2013-05-19','10:40:00',3.37),('8537','2013-05-19','10:45:00',3.72),('8537','2013-05-19','10:50:00',2.28),('8537','2013-05-19','10:55:00',2.67),('8537','2013-05-19','11:00:00',2.42),('8537','2013-05-19','11:05:00',3.89),('8537','2013-05-19','11:10:00',2.86),('8537','2013-05-19','11:15:00',4.78),('8537','2013-05-19','11:20:00',5.28),('8537','2013-05-19','11:25:00',5.29),('8537','2013-05-19','11:30:00',5.26),('8537','2013-05-19','11:35:00',5.25),('8537','2013-05-19','11:40:00',5.38),('8537','2013-05-19','11:45:00',5.4),('8537','2013-05-19','11:50:00',5.38),('8537','2013-05-19','11:55:00',5.46),('8537','2013-05-19','12:00:00',5.48),('8537','2013-05-19','12:05:00',5.47),('8537','2013-05-19','12:10:00',5.46),('8537','2013-05-19','12:15:00',5.5),('8537','2013-05-19','12:20:00',5.83),('8537','2013-05-19','12:25:00',5.66),('8537','2013-05-19','12:30:00',4.65),('8537','2013-05-19','12:35:00',5.48),('8537','2013-05-19','12:40:00',5.75),('8537','2013-05-19','12:45:00',5.57),('8537','2013-05-19','12:50:00',4.14),('8537','2013-05-19','12:55:00',3.2),('8537','2013-05-19','13:00:00',4.59),('8537','2013-05-19','13:05:00',5.19),('8537','2013-05-19','13:10:00',4.39),('8537','2013-05-19','13:15:00',4.48),('8537','2013-05-19','13:20:00',5.57),('8537','2013-05-19','13:25:00',4.99),('8537','2013-05-19','13:30:00',5.41),('8537','2013-05-19','13:35:00',5.37),('8537','2013-05-19','13:40:00',5.33),('8537','2013-05-19','13:45:00',5.32),('8537','2013-05-19','13:50:00',5.3),('8537','2013-05-19','13:55:00',5.28),('8537','2013-05-19','14:00:00',5.3),('8537','2013-05-19','14:05:00',5.23),('8537','2013-05-19','14:10:00',5.23),('8537','2013-05-19','14:15:00',5.21),('8537','2013-05-19','14:20:00',5.17),('8537','2013-05-19','14:25:00',5.14),('8537','2013-05-19','14:30:00',5.15),('8537','2013-05-19','14:35:00',5.05),('8537','2013-05-19','14:40:00',4.77),('8537','2013-05-19','14:45:00',4.35),('8537','2013-05-19','14:50:00',4.82),('8537','2013-05-19','14:55:00',4.88),('8537','2013-05-19','15:00:00',4.85),('8537','2013-05-19','15:05:00',4.81),('8537','2013-05-19','15:10:00',4.72),('8537','2013-05-19','15:15:00',4.68),('8537','2013-05-19','15:20:00',4.6),('8537','2013-05-19','15:25:00',4.58),('8537','2013-05-19','15:30:00',4.51),('8537','2013-05-19','15:35:00',4.37),('8537','2013-05-19','15:40:00',4.28),('8537','2013-05-19','15:45:00',4.21),('8537','2013-05-19','15:50:00',4.12),('8537','2013-05-19','15:55:00',4.14),('8537','2013-05-19','16:00:00',4.06),('8537','2013-05-19','16:05:00',4),('8537','2013-05-19','16:10:00',3.91),('8537','2013-05-19','16:15:00',3.81),('8537','2013-05-19','16:20:00',3.66),('8537','2013-05-19','16:25:00',3.63),('8537','2013-05-19','16:30:00',3.51),('8537','2013-05-19','16:35:00',3.46),('8537','2013-05-19','16:40:00',3.38),('8537','2013-05-19','16:45:00',3.3),('8537','2013-05-19','16:50:00',3.21),('8537','2013-05-19','16:55:00',3),('8537','2013-05-19','17:00:00',2.46),('8537','2013-05-19','17:05:00',2.61),('8537','2013-05-19','17:10:00',2.78),('8537','2013-05-19','17:15:00',2.67),('8537','2013-05-19','17:20:00',2.52),('8537','2013-05-19','17:25:00',2.41),('8537','2013-05-19','17:30:00',2.31),('8537','2013-05-19','17:35:00',2.22),('8537','2013-05-19','17:40:00',2.03),('8537','2013-05-19','17:45:00',1.98),('8537','2013-05-19','17:50:00',1.86),('8537','2013-05-19','17:55:00',1.74),('8537','2013-05-19','18:00:00',1.64),('8537','2013-05-19','18:05:00',1.54),('8537','2013-05-19','18:10:00',1.43),('8537','2013-05-19','18:15:00',1.32),('8537','2013-05-19','18:20:00',1.21),('8537','2013-05-19','18:25:00',1.12),('8537','2013-05-18','07:30:00',1.08),('8537','2013-05-18','07:35:00',1.19),('8537','2013-05-18','07:40:00',1.36),('8537','2013-05-18','07:45:00',1.5),('8537','2013-05-18','07:50:00',1.27),('8537','2013-05-18','07:55:00',2.09),('8537','2013-05-18','08:00:00',2.23),('8537','2013-05-18','08:05:00',2.27),('8537','2013-05-18','08:10:00',1.18),('8537','2013-05-18','08:15:00',1.15),('8537','2013-05-18','08:20:00',1.37),('8537','2013-05-18','08:25:00',2.97),('8537','2013-05-18','08:30:00',2.66),('8537','2013-05-18','08:35:00',2.29),('8537','2013-05-18','08:40:00',2.62),('8537','2013-05-18','08:45:00',2.68),('8537','2013-05-18','08:50:00',2.78),('8537','2013-05-18','08:55:00',2.88),('8537','2013-05-18','09:00:00',2.98),('8537','2013-05-18','09:05:00',3.03),('8537','2013-05-18','09:10:00',3.21),('8537','2013-05-18','09:15:00',3.27),('8537','2013-05-18','09:20:00',3.32),('8537','2013-05-18','09:25:00',3.4),('8537','2013-05-18','09:30:00',3.49),('8537','2013-05-18','09:35:00',3.61),('8537','2013-05-18','09:40:00',3.66),('8537','2013-05-18','09:45:00',3.72),('8537','2013-05-18','09:50:00',3.79),('8537','2013-05-18','09:55:00',3.88),('8537','2013-05-18','10:00:00',3.94),('8537','2013-05-18','10:05:00',4.02),('8537','2013-05-18','10:10:00',4.12),('8537','2013-05-18','10:15:00',4.14),('8537','2013-05-18','10:20:00',4.19),('8537','2013-05-18','10:25:00',4.24),('8537','2013-05-18','10:30:00',4.3),('8537','2013-05-18','10:35:00',4.29),('8537','2013-05-18','10:40:00',4.41),('8537','2013-05-18','10:45:00',4.47),('8537','2013-05-18','10:50:00',4.5),('8537','2013-05-18','10:55:00',4.64),('8537','2013-05-18','11:00:00',4.83),('8537','2013-05-18','11:05:00',4.5),('8537','2013-05-18','11:10:00',4),('8537','2013-05-18','11:15:00',5.04),('8537','2013-05-18','11:20:00',4.92),('8537','2013-05-18','11:25:00',5),('8537','2013-05-18','11:30:00',4.88),('8537','2013-05-18','11:35:00',4.72),('8537','2013-05-18','11:40:00',4.9),('8537','2013-05-18','11:45:00',4.59),('8537','2013-05-18','11:50:00',4.67),('8537','2013-05-18','11:55:00',4.85),('8537','2013-05-18','12:00:00',4.98),('8537','2013-05-18','12:05:00',4.87),('8537','2013-05-18','12:10:00',4.88),('8537','2013-05-18','12:15:00',4.89),('8537','2013-05-18','12:20:00',4.92),('8537','2013-05-18','12:25:00',5.04),('8537','2013-05-18','12:30:00',3.8),('8537','2013-05-18','12:35:00',5.13),('8537','2013-05-18','12:40:00',5.1),('8537','2013-05-18','12:45:00',5.01),('8537','2013-05-18','12:50:00',5.08),('8537','2013-05-18','12:55:00',5),('8537','2013-05-18','13:00:00',4.91),('8537','2013-05-18','13:05:00',4.94),('8537','2013-05-18','13:10:00',3.96),('8537','2013-05-18','13:15:00',4.98),('8537','2013-05-18','13:20:00',5.05),('8537','2013-05-18','13:25:00',4.99),('8537','2013-05-18','13:30:00',4.97),('8537','2013-05-18','13:35:00',4.44),('8537','2013-05-18','13:40:00',5.03),('8537','2013-05-18','13:45:00',5.28),('8537','2013-05-18','13:50:00',4.41),('8537','2013-05-18','13:55:00',4.37),('8537','2013-05-18','14:00:00',3.95),('8537','2013-05-18','14:05:00',3.73),('8537','2013-05-18','14:10:00',5.34),('8537','2013-05-18','14:15:00',5.11),('8537','2013-05-18','14:20:00',5.02),('8537','2013-05-18','14:25:00',4.79),('8537','2013-05-18','14:30:00',4.78),('8537','2013-05-18','14:35:00',4.72),('8537','2013-05-18','14:40:00',4.83),('8537','2013-05-18','14:45:00',4.55),('8537','2013-05-18','14:50:00',4.1),('8537','2013-05-18','14:55:00',3.8),('8537','2013-05-18','15:00:00',4.28),('8537','2013-05-18','15:05:00',4.25),('8537','2013-05-18','15:10:00',4.14),('8537','2013-05-18','15:15:00',4.06),('8537','2013-05-18','15:20:00',3.98),('8537','2013-05-18','15:25:00',3.91),('8537','2013-05-18','15:30:00',3.84),('8537','2013-05-18','15:35:00',3.64),('8537','2013-05-18','15:40:00',3.5),('8537','2013-05-18','15:45:00',3.59),('8537','2013-05-18','15:50:00',3.58),('8537','2013-05-18','15:55:00',3.49),('8537','2013-05-18','16:00:00',3.41),('8537','2013-05-18','16:05:00',3.36),('8537','2013-05-18','16:10:00',3.27),('8537','2013-05-18','16:15:00',3.18),('8537','2013-05-18','16:20:00',3.07),('8537','2013-05-18','16:25:00',3.01),('8537','2013-05-18','16:30:00',2.93),('8537','2013-05-18','16:35:00',2.85),('8537','2013-05-18','16:40:00',2.79),('8537','2013-05-18','16:45:00',2.7),('8537','2013-05-18','16:50:00',2.59),('8537','2013-05-18','16:55:00',2.47),('8537','2013-05-18','17:00:00',2.26),('8537','2013-05-18','17:05:00',2.32),('8537','2013-05-18','17:10:00',2.25),('8537','2013-05-18','17:15:00',2.15),('8537','2013-05-18','17:20:00',2.06),('8537','2013-05-18','17:25:00',1.96),('8537','2013-05-18','17:30:00',1.85),('8537','2013-05-18','17:35:00',1.77),('8537','2013-05-18','17:40:00',1.64),('8537','2013-05-18','17:45:00',1.56),('8537','2013-05-18','17:50:00',1.48),('8537','2013-05-18','17:55:00',1.42),('8537','2013-05-18','18:00:00',1.33),('8537','2013-05-18','18:05:00',1.24),('8537','2013-05-18','18:10:00',1.15),('8537','2013-05-18','18:15:00',1.07),('8537','2013-05-17','07:40:00',1.27),('8537','2013-05-17','07:45:00',1.28),('8537','2013-05-17','07:50:00',1.24),('8537','2013-05-17','07:55:00',1.08),('8537','2013-05-17','08:00:00',1.65),('8537','2013-05-17','08:05:00',1.04),('8537','2013-05-17','08:15:00',1.85),('8537','2013-05-17','08:20:00',2.52),('8537','2013-05-17','08:25:00',1.75),('8537','2013-05-17','08:30:00',1.14),('8537','2013-05-17','09:25:00',1.37),('8537','2013-05-17','10:20:00',1.03),('8537','2013-05-17','10:25:00',1.5),('8537','2013-05-17','10:30:00',1.87),('8537','2013-05-17','10:35:00',1.51),('8537','2013-05-17','10:40:00',1.71),('8537','2013-05-17','10:45:00',1.82),('8537','2013-05-17','10:50:00',3.39),('8537','2013-05-17','10:55:00',3.82),('8537','2013-05-17','11:00:00',2.62),('8537','2013-05-17','11:05:00',2.46),('8537','2013-05-17','11:10:00',1.69),('8537','2013-05-17','11:15:00',2.41),('8537','2013-05-17','11:20:00',2.35),('8537','2013-05-17','11:25:00',2.01),('8537','2013-05-17','11:30:00',2.43),('8537','2013-05-17','11:35:00',3.08),('8537','2013-05-17','11:40:00',1.89),('8537','2013-05-17','11:45:00',1.81),('8537','2013-05-17','11:50:00',2.94),('8537','2013-05-17','11:55:00',3.15),('8537','2013-05-17','12:00:00',2.02),('8537','2013-05-17','12:05:00',3.3),('8537','2013-05-17','12:10:00',3.75),('8537','2013-05-17','12:15:00',3.13),('8537','2013-05-17','12:20:00',2.96),('8537','2013-05-17','12:25:00',3.34),('8537','2013-05-17','12:30:00',3.03),('8537','2013-05-17','12:35:00',3.59),('8537','2013-05-17','12:40:00',4.89),('8537','2013-05-17','12:45:00',4.84),('8537','2013-05-17','12:50:00',5.57),('8537','2013-05-17','12:55:00',5.43),('8537','2013-05-17','13:00:00',4.9),('8537','2013-05-17','13:05:00',5.49),('8537','2013-05-17','13:10:00',3.47),('8537','2013-05-17','13:15:00',4.9),('8537','2013-05-17','13:20:00',5.62),('8537','2013-05-17','13:25:00',5.01),('8537','2013-05-17','13:30:00',3.91),('8537','2013-05-17','13:35:00',5.48),('8537','2013-05-17','13:40:00',3.92),('8537','2013-05-17','13:45:00',5.24),('8537','2013-05-17','13:50:00',5),('8537','2013-05-17','13:55:00',4.4),('8537','2013-05-17','14:00:00',3.95),('8537','2013-05-17','14:05:00',3.14),('8537','2013-05-17','14:10:00',4.65),('8537','2013-05-17','14:15:00',4.91),('8537','2013-05-17','14:20:00',5.48),('8537','2013-05-17','14:25:00',4.42),('8537','2013-05-17','14:30:00',4.86),('8537','2013-05-17','14:35:00',4.13),('8537','2013-05-17','14:40:00',3.72),('8537','2013-05-17','14:45:00',3.82),('8537','2013-05-17','14:50:00',3.3),('8537','2013-05-17','14:55:00',3.18),('8537','2013-05-17','15:00:00',4.15),('8537','2013-05-17','15:05:00',3.11),('8537','2013-05-17','15:10:00',2.04),('8537','2013-05-17','15:15:00',3.36),('8537','2013-05-17','15:20:00',3.47),('8537','2013-05-17','15:25:00',3.2),('8537','2013-05-17','15:30:00',2.67),('8537','2013-05-17','15:35:00',4.14),('8537','2013-05-17','15:40:00',4.49),('8537','2013-05-17','15:45:00',1.66),('8537','2013-05-17','15:50:00',2.87),('8537','2013-05-17','15:55:00',3.87),('8537','2013-05-17','16:00:00',3.5),('8537','2013-05-17','16:05:00',1.92),('8537','2013-05-17','16:10:00',2.34),('8537','2013-05-17','16:15:00',3.15),('8537','2013-05-17','16:20:00',3.48),('8537','2013-05-17','16:25:00',3.53),('8537','2013-05-17','16:30:00',3.66),('8537','2013-05-17','16:35:00',3.21),('8537','2013-05-17','16:40:00',3.63),('8537','2013-05-17','16:45:00',3.45),('8537','2013-05-17','16:50:00',3.15),('8537','2013-05-17','16:55:00',2.91),('8537','2013-05-17','17:00:00',2.85),('8537','2013-05-17','17:05:00',2.74),('8537','2013-05-17','17:10:00',2.66),('8537','2013-05-17','17:15:00',2.53),('8537','2013-05-17','17:20:00',2.39),('8537','2013-05-17','17:25:00',2.31),('8537','2013-05-17','17:30:00',2.23),('8537','2013-05-17','17:35:00',2.13),('8537','2013-05-17','17:40:00',1.99),('8537','2013-05-17','17:45:00',1.9),('8537','2013-05-17','17:50:00',1.76),('8537','2013-05-17','17:55:00',1.69),('8537','2013-05-17','18:00:00',1.59),('8537','2013-05-17','18:05:00',1.49),('8537','2013-05-17','18:10:00',1.35),('8537','2013-05-17','18:15:00',1.25),('8537','2013-05-17','18:20:00',1.15),('8537','2013-05-17','18:25:00',1.07),('8537','2013-05-16','09:15:00',1.08),('8537','2013-05-16','09:20:00',1.34),('8537','2013-05-16','09:25:00',1.93),('8537','2013-05-16','09:30:00',1.86),('8537','2013-05-16','09:35:00',2.17),('8537','2013-05-16','09:40:00',2.51),('8537','2013-05-16','09:45:00',2.95),('8537','2013-05-16','09:50:00',1.5),('8537','2013-05-16','09:55:00',1.42),('8537','2013-05-16','10:00:00',1.89),('8537','2013-05-16','10:05:00',1.55),('8537','2013-05-16','10:10:00',1.41),('8537','2013-05-16','10:15:00',1.83),('8537','2013-05-16','10:20:00',2.45),('8537','2013-05-16','10:25:00',2.74),('8537','2013-05-16','10:30:00',2.26),('8537','2013-05-16','10:35:00',1.64),('8537','2013-05-16','10:40:00',1.65),('8537','2013-05-16','10:45:00',1.51),('8537','2013-05-16','10:50:00',1.79),('8537','2013-05-16','10:55:00',2.17),('8537','2013-05-16','11:00:00',4.78),('8537','2013-05-16','11:05:00',4.09),('8537','2013-05-16','11:10:00',3.7),('8537','2013-05-16','11:15:00',2.19),('8537','2013-05-16','11:20:00',1.3),('8537','2013-05-16','11:25:00',1.5),('8537','2013-05-16','11:30:00',1.8),('8537','2013-05-16','11:35:00',3.31),('8537','2013-05-16','11:40:00',4.76),('8537','2013-05-16','11:45:00',4.28),('8537','2013-05-16','11:50:00',3.94),('8537','2013-05-16','11:55:00',2.74),('8537','2013-05-16','12:00:00',2.1),('8537','2013-05-16','12:05:00',1.96),('8537','2013-05-16','12:10:00',2.05),('8537','2013-05-16','12:15:00',3.35),('8537','2013-05-16','12:20:00',2.32),('8537','2013-05-16','12:25:00',2.63),('8537','2013-05-16','12:30:00',3.84),('8537','2013-05-16','12:35:00',4.01),('8537','2013-05-16','12:40:00',4.46),('8537','2013-05-16','12:45:00',4.26),('8537','2013-05-16','12:50:00',3.21),('8537','2013-05-16','12:55:00',5.17),('8537','2013-05-16','13:00:00',4.87),('8537','2013-05-16','13:05:00',4.69),('8537','2013-05-16','13:10:00',4.99),('8537','2013-05-16','13:15:00',4.25),('8537','2013-05-16','13:20:00',4.12),('8537','2013-05-16','13:25:00',4.99),('8537','2013-05-16','13:30:00',4.89),('8537','2013-05-16','13:35:00',4.88),('8537','2013-05-16','13:40:00',4.79),('8537','2013-05-16','13:45:00',4.77),('8537','2013-05-16','13:50:00',4.76),('8537','2013-05-16','13:55:00',4.79),('8537','2013-05-16','14:00:00',4.75),('8537','2013-05-16','14:05:00',4.73),('8537','2013-05-16','14:10:00',4.7),('8537','2013-05-16','14:15:00',4.66),('8537','2013-05-16','14:20:00',4.62),('8537','2013-05-16','14:25:00',4.49),('8537','2013-05-16','14:30:00',4.48),('8537','2013-05-16','14:35:00',4.33),('8537','2013-05-16','14:40:00',4.15),('8537','2013-05-16','14:45:00',3.92),('8537','2013-05-16','14:50:00',3.79),('8537','2013-05-16','14:55:00',3.65),('8537','2013-05-16','15:00:00',4.14),('8537','2013-05-16','15:05:00',4.16),('8537','2013-05-16','15:10:00',4.13),('8537','2013-05-16','15:15:00',3.66),('8537','2013-05-16','15:20:00',3.89),('8537','2013-05-16','15:25:00',3.91),('8537','2013-05-16','15:30:00',3.78),('8537','2013-05-16','15:35:00',3.59),('8537','2013-05-16','15:40:00',3.73),('8537','2013-05-16','15:45:00',3.6),('8537','2013-05-16','15:50:00',3.58),('8537','2013-05-16','15:55:00',3.57),('8537','2013-05-16','16:00:00',3.5),('8537','2013-05-16','16:05:00',3.32),('8537','2013-05-16','16:10:00',3.33),('8537','2013-05-16','16:15:00',3.08),('8537','2013-05-16','16:20:00',3.23),('8537','2013-05-16','16:25:00',3.08),('8537','2013-05-16','16:30:00',3.05),('8537','2013-05-16','16:35:00',2.89),('8537','2013-05-16','16:40:00',1.84),('8537','2013-05-16','16:45:00',1.66),('8537','2013-05-16','16:50:00',2.1),('8537','2013-05-16','16:55:00',1.65),('8537','2013-05-16','17:00:00',1.63),('8537','2013-05-16','17:05:00',1.03),('8537','2013-05-16','17:15:00',1.37),('8537','2013-05-16','17:20:00',1.57),('8537','2013-05-16','17:25:00',1.55),('8537','2013-05-16','17:30:00',1.82),('8537','2013-05-16','17:35:00',1.9),('8537','2013-05-16','17:40:00',1.55),('8537','2013-05-16','17:45:00',1.16),('8537','2013-05-16','18:50:00',1.02),('8537','2013-05-16','18:55:00',1.03),('8537','2013-05-16','19:00:00',1.09),('8537','2013-05-16','19:05:00',1.05),('8537','2013-05-15','07:30:00',1.07),('8537','2013-05-15','07:35:00',1.2),('8537','2013-05-15','07:40:00',1.33),('8537','2013-05-15','07:45:00',1.53),('8537','2013-05-15','07:50:00',1.58),('8537','2013-05-15','07:55:00',1.52),('8537','2013-05-15','08:00:00',1.62),('8537','2013-05-15','08:05:00',1.57),('8537','2013-05-15','08:10:00',1.87),('8537','2013-05-15','08:15:00',2.03),('8537','2013-05-15','08:20:00',2.08),('8537','2013-05-15','08:25:00',2.16),('8537','2013-05-15','08:30:00',2.2),('8537','2013-05-15','08:35:00',2.39),('8537','2013-05-15','08:40:00',2.52),('8537','2013-05-15','08:45:00',2.63),('8537','2013-05-15','08:50:00',2.73),('8537','2013-05-15','08:55:00',2.83),('8537','2013-05-15','09:00:00',2.73),('8537','2013-05-15','09:05:00',2.98),('8537','2013-05-15','09:10:00',2.95),('8537','2013-05-15','09:15:00',3.05),('8537','2013-05-15','09:20:00',3.03),('8537','2013-05-15','09:25:00',3.17),('8537','2013-05-15','09:30:00',3.35),('8537','2013-05-15','09:35:00',3.42),('8537','2013-05-15','09:40:00',3.43),('8537','2013-05-15','09:45:00',3.51),('8537','2013-05-15','09:50:00',3.65),('8537','2013-05-15','09:55:00',3.67),('8537','2013-05-15','10:00:00',3.79),('8537','2013-05-15','10:05:00',3.86),('8537','2013-05-15','10:10:00',3.99),('8537','2013-05-15','10:15:00',3.95),('8537','2013-05-15','10:20:00',4.12),('8537','2013-05-15','10:25:00',4.23),('8537','2013-05-15','10:30:00',4.08),('8537','2013-05-15','10:35:00',4.19),('8537','2013-05-15','10:40:00',4.34),('8537','2013-05-15','10:45:00',4.4),('8537','2013-05-15','10:50:00',4.42),('8537','2013-05-15','10:55:00',4.29),('8537','2013-05-15','11:00:00',4.31),('8537','2013-05-15','11:05:00',4.57),('8537','2013-05-15','11:10:00',4.58),('8537','2013-05-15','11:15:00',4.62),('8537','2013-05-15','11:20:00',4.43),('8537','2013-05-15','11:25:00',4.62),('8537','2013-05-15','11:30:00',4.62),('8537','2013-05-15','11:35:00',4.55),('8537','2013-05-15','11:40:00',4.03),('8537','2013-05-15','11:45:00',3.51),('8537','2013-05-15','11:50:00',3.04),('8537','2013-05-15','11:55:00',2.31),('8537','2013-05-15','12:00:00',2.47),('8537','2013-05-15','12:05:00',3.88),('8537','2013-05-15','12:10:00',5.11),('8537','2013-05-15','12:15:00',5.21),('8537','2013-05-15','12:20:00',3.14),('8537','2013-05-15','12:25:00',4.18),('8537','2013-05-15','12:30:00',3.42),('8537','2013-05-15','12:35:00',3.42),('8537','2013-05-15','12:40:00',5.46),('8537','2013-05-15','12:45:00',2.89),('8537','2013-05-15','12:50:00',2.89),('8537','2013-05-15','12:55:00',3.24),('8537','2013-05-15','13:00:00',3.28),('8537','2013-05-15','13:05:00',3.79),('8537','2013-05-15','13:10:00',3.34),('8537','2013-05-15','13:15:00',2.75),('8537','2013-05-15','13:20:00',3.23),('8537','2013-05-15','13:25:00',3.13),('8537','2013-05-15','13:30:00',3.24),('8537','2013-05-15','13:35:00',2.88),('8537','2013-05-15','13:40:00',2.93),('8537','2013-05-15','13:45:00',2.96),('8537','2013-05-15','13:50:00',2.48),('8537','2013-05-15','13:55:00',2.4),('8537','2013-05-15','14:00:00',2.09),('8537','2013-05-15','14:05:00',1.84),('8537','2013-05-15','14:10:00',1.9),('8537','2013-05-15','14:15:00',1.9),('8537','2013-05-15','14:20:00',1.96),('8537','2013-05-15','14:25:00',1.88),('8537','2013-05-15','14:30:00',1.67),('8537','2013-05-15','14:35:00',1.65),('8537','2013-05-15','14:40:00',1.81),('8537','2013-05-15','14:45:00',1.7),('8537','2013-05-15','14:50:00',1.71),('8537','2013-05-15','14:55:00',1.72),('8537','2013-05-15','15:00:00',1.68),('8537','2013-05-15','15:05:00',1.32),('8537','2013-05-15','15:10:00',1.03),('8537','2013-05-15','15:45:00',1.25),('8537','2013-05-15','15:50:00',1.71),('8537','2013-05-15','15:55:00',2.21),('8537','2013-05-15','16:00:00',2.19),('8537','2013-05-15','16:05:00',2.04),('8537','2013-05-15','16:10:00',1.85),('8537','2013-05-15','16:15:00',1.62),('8537','2013-05-15','16:20:00',1.79),('8537','2013-05-15','16:25:00',1.83),('8537','2013-05-15','16:30:00',1.65),('8537','2013-05-15','16:35:00',1.52),('8537','2013-05-15','16:40:00',1.41),('8537','2013-05-15','16:45:00',1.36),('8537','2013-05-15','16:50:00',1.37),('8537','2013-05-15','16:55:00',1.57),('8537','2013-05-15','17:00:00',1.86),('8537','2013-05-15','17:05:00',2.21),('8537','2013-05-15','17:10:00',2.02),('8537','2013-05-15','17:15:00',2.39),('8537','2013-05-15','17:20:00',2.19),('8537','2013-05-15','17:30:00',1.06),('8537','2013-05-14','07:30:00',1.1),('8537','2013-05-14','07:35:00',1.21),('8537','2013-05-14','07:40:00',1.33),('8537','2013-05-14','07:45:00',1.44),('8537','2013-05-14','07:50:00',1.56),('8537','2013-05-14','07:55:00',1.68),('8537','2013-05-14','08:00:00',1.79),('8537','2013-05-14','08:05:00',1.9),('8537','2013-05-14','08:10:00',2.03),('8537','2013-05-14','08:15:00',2.14),('8537','2013-05-14','08:20:00',2.25),('8537','2013-05-14','08:25:00',2.37),('8537','2013-05-14','08:30:00',2.46),('8537','2013-05-14','08:35:00',2.58),('8537','2013-05-14','08:40:00',2.68),('8537','2013-05-14','08:45:00',2.78),('8537','2013-05-14','08:50:00',2.88),('8537','2013-05-14','08:55:00',2.97),('8537','2013-05-14','09:00:00',3.07),('8537','2013-05-14','09:05:00',3.17),('8537','2013-05-14','09:10:00',3.25),('8537','2013-05-14','09:15:00',3.35),('8537','2013-05-14','09:20:00',3.42),('8537','2013-05-14','09:25:00',3.5),('8537','2013-05-14','09:30:00',3.58),('8537','2013-05-14','09:35:00',3.67),('8537','2013-05-14','09:40:00',3.74),('8537','2013-05-14','09:45:00',3.79),('8537','2013-05-14','09:50:00',3.87),('8537','2013-05-14','09:55:00',3.98),('8537','2013-05-14','10:00:00',4.04),('8537','2013-05-14','10:05:00',4.15),('8537','2013-05-14','10:10:00',4.18),('8537','2013-05-14','10:15:00',4.27),('8537','2013-05-14','10:20:00',4.35),('8537','2013-05-14','10:25:00',4.36),('8537','2013-05-14','10:30:00',4.41),('8537','2013-05-14','10:35:00',4.47),('8537','2013-05-14','10:40:00',4.52),('8537','2013-05-14','10:45:00',4.57),('8537','2013-05-14','10:50:00',4.63),('8537','2013-05-14','10:55:00',4.67),('8537','2013-05-14','11:00:00',4.66),('8537','2013-05-14','11:05:00',4.73),('8537','2013-05-14','11:10:00',4.78),('8537','2013-05-14','11:15:00',4.81),('8537','2013-05-14','11:20:00',4.82),('8537','2013-05-14','11:25:00',4.85),('8537','2013-05-14','11:30:00',4.88),('8537','2013-05-14','11:35:00',4.9),('8537','2013-05-14','11:40:00',4.93),('8537','2013-05-14','11:45:00',4.93),('8537','2013-05-14','11:50:00',4.98),('8537','2013-05-14','11:55:00',5.02),('8537','2013-05-14','12:00:00',5.06),('8537','2013-05-14','12:05:00',5.03),('8537','2013-05-14','12:10:00',5.07),('8537','2013-05-14','12:15:00',5.09),('8537','2013-05-14','12:20:00',5.19),('8537','2013-05-14','12:25:00',5.19),('8537','2013-05-14','12:30:00',5.21),('8537','2013-05-14','12:35:00',5.21),('8537','2013-05-14','12:40:00',5.17),('8537','2013-05-14','12:45:00',5.19),('8537','2013-05-14','12:50:00',5.19),('8537','2013-05-14','12:55:00',5.26),('8537','2013-05-14','13:00:00',5.26),('8537','2013-05-14','13:05:00',5.18),('8537','2013-05-14','13:10:00',5.18),('8537','2013-05-14','13:15:00',5.22),('8537','2013-05-14','13:20:00',5.18),('8537','2013-05-14','13:25:00',5.11),('8537','2013-05-14','13:30:00',5.03),('8537','2013-05-14','13:35:00',5.09),('8537','2013-05-14','13:40:00',5.12),('8537','2013-05-14','13:45:00',5.03),('8537','2013-05-14','13:50:00',5.04),('8537','2013-05-14','13:55:00',5.04),('8537','2013-05-14','14:00:00',5.02),('8537','2013-05-14','14:05:00',5.04),('8537','2013-05-14','14:10:00',5.01),('8537','2013-05-14','14:15:00',4.97),('8537','2013-05-14','14:20:00',4.86),('8537','2013-05-14','14:25:00',4.83),('8537','2013-05-14','14:30:00',4.77),('8537','2013-05-14','14:35:00',4.61),('8537','2013-05-14','14:40:00',4.39),('8537','2013-05-14','14:45:00',4.66),('8537','2013-05-14','14:50:00',4.67),('8537','2013-05-14','14:55:00',4.67),('8537','2013-05-14','15:00:00',4.65),('8537','2013-05-14','15:05:00',4.6),('8537','2013-05-14','15:10:00',4.54),('8537','2013-05-14','15:15:00',4.51),('8537','2013-05-14','15:20:00',4.45),('8537','2013-05-14','15:25:00',4.42),('8537','2013-05-14','15:30:00',4.3),('8537','2013-05-14','15:35:00',4.1),('8537','2013-05-14','15:40:00',4.16),('8537','2013-05-14','15:45:00',4.11),('8537','2013-05-14','15:50:00',4.02),('8537','2013-05-14','15:55:00',3.97),('8537','2013-05-14','16:00:00',3.91),('8537','2013-05-14','16:05:00',3.83),('8537','2013-05-14','16:10:00',3.73),('8537','2013-05-14','16:15:00',3.6),('8537','2013-05-14','16:20:00',3.51),('8537','2013-05-14','16:25:00',3.47),('8537','2013-05-14','16:30:00',3.38),('8537','2013-05-14','16:35:00',3.3),('8537','2013-05-14','16:40:00',3.2),('8537','2013-05-14','16:45:00',3.12),('8537','2013-05-14','16:50:00',3.01),('8537','2013-05-14','16:55:00',2.61),('8537','2013-05-14','17:00:00',2.38),('8537','2013-05-14','17:05:00',2.7),('8537','2013-05-14','17:10:00',2.61),('8537','2013-05-14','17:15:00',2.48),('8537','2013-05-14','17:20:00',2.35),('8537','2013-05-14','17:25:00',2.25),('8537','2013-05-14','17:30:00',2.16),('8537','2013-05-14','17:35:00',2.02),('8537','2013-05-14','17:40:00',1.92),('8537','2013-05-14','17:45:00',1.8),('8537','2013-05-14','17:50:00',1.69),('8537','2013-05-14','17:55:00',1.6),('8537','2013-05-14','18:00:00',1.49),('8537','2013-05-14','18:05:00',1.39),('8537','2013-05-14','18:10:00',1.26),('8537','2013-05-14','18:15:00',1.17),('8537','2013-05-14','18:20:00',1.08),('8537','2013-05-13','07:35:00',1.08),('8537','2013-05-13','07:40:00',1.16),('8537','2013-05-13','07:45:00',1.3),('8537','2013-05-13','07:50:00',1.34),('8537','2013-05-13','07:55:00',1.19),('8537','2013-05-13','08:00:00',1.58),('8537','2013-05-13','08:05:00',1.7),('8537','2013-05-13','08:10:00',1.84),('8537','2013-05-13','08:15:00',1.96),('8537','2013-05-13','08:20:00',2.07),('8537','2013-05-13','08:25:00',2.16),('8537','2013-05-13','08:30:00',2.23),('8537','2013-05-13','08:35:00',2.34),('8537','2013-05-13','08:40:00',2.47),('8537','2013-05-13','08:45:00',2.57),('8537','2013-05-13','08:50:00',2.66),('8537','2013-05-13','08:55:00',2.7),('8537','2013-05-13','09:00:00',2.84),('8537','2013-05-13','09:05:00',2.93),('8537','2013-05-13','09:10:00',3),('8537','2013-05-13','09:15:00',3.11),('8537','2013-05-13','09:20:00',3.24),('8537','2013-05-13','09:25:00',3.36),('8537','2013-05-13','09:30:00',3.44),('8537','2013-05-13','09:35:00',3.46),('8537','2013-05-13','09:40:00',3.59),('8537','2013-05-13','09:45:00',3.67),('8537','2013-05-13','09:50:00',3.8),('8537','2013-05-13','09:55:00',3.99),('8537','2013-05-13','10:00:00',4.1),('8537','2013-05-13','10:05:00',4.1),('8537','2013-05-13','10:10:00',4.05),('8537','2013-05-13','10:15:00',4.36),('8537','2013-05-13','10:20:00',3.89),('8537','2013-05-13','10:25:00',2.45),('8537','2013-05-13','10:30:00',3.85),('8537','2013-05-13','10:35:00',2.58),('8537','2013-05-13','10:40:00',1.18),('8537','2013-05-13','10:45:00',4.12),('8537','2013-05-13','10:50:00',5.23),('8537','2013-05-13','10:55:00',2.51),('8537','2013-05-13','11:00:00',2.83),('8537','2013-05-13','11:05:00',2.96),('8537','2013-05-13','11:10:00',2.21),('8537','2013-05-13','11:15:00',2.81),('8537','2013-05-13','11:20:00',1.84),('8537','2013-05-13','11:25:00',2.46),('8537','2013-05-13','11:30:00',2.07),('8537','2013-05-13','11:35:00',1.58),('8537','2013-05-13','11:40:00',2.87),('8537','2013-05-13','11:45:00',3.26),('8537','2013-05-13','11:50:00',2.29),('8537','2013-05-13','11:55:00',2.02),('8537','2013-05-13','12:00:00',2),('8537','2013-05-13','12:05:00',1.97),('8537','2013-05-13','12:10:00',3.44),('8537','2013-05-13','12:15:00',3.27),('8537','2013-05-13','12:20:00',1.81),('8537','2013-05-13','12:25:00',2.03),('8537','2013-05-13','12:30:00',2.71),('8537','2013-05-13','12:35:00',5.3),('8537','2013-05-13','12:40:00',4.56),('8537','2013-05-13','12:45:00',2.12),('8537','2013-05-13','12:50:00',4.41),('8537','2013-05-13','12:55:00',3.74),('8537','2013-05-13','13:00:00',5.91),('8537','2013-05-13','13:05:00',5.81),('8537','2013-05-13','13:10:00',5.42),('8537','2013-05-13','13:15:00',5.62),('8537','2013-05-13','13:20:00',4.2),('8537','2013-05-13','13:25:00',5.81),('8537','2013-05-13','13:30:00',5.89),('8537','2013-05-13','13:35:00',5.68),('8537','2013-05-13','13:40:00',5.25),('8537','2013-05-13','13:45:00',2.02),('8537','2013-05-13','13:50:00',1.51),('8537','2013-05-13','13:55:00',1.42),('8537','2013-05-13','14:00:00',1.35),('8537','2013-05-13','14:05:00',3.63),('8537','2013-05-13','14:10:00',5.81),('8537','2013-05-13','14:15:00',5.52),('8537','2013-05-13','14:20:00',5.18),('8537','2013-05-13','14:25:00',4.02),('8537','2013-05-13','14:30:00',1.06),('8537','2013-05-13','14:35:00',5.17),('8537','2013-05-13','14:40:00',5.22),('8537','2013-05-13','14:45:00',3.93),('8537','2013-05-13','14:50:00',1.33),('8537','2013-05-13','14:55:00',4.6),('8537','2013-05-13','15:00:00',3.73),('8537','2013-05-13','15:05:00',3.22),('8537','2013-05-13','15:10:00',1.32),('8537','2013-05-13','15:15:00',1.16),('8537','2013-05-13','15:20:00',1.33),('8537','2013-05-13','15:25:00',1.04),('8537','2013-05-13','16:00:00',1.27),('8537','2013-05-13','16:05:00',1.5),('8537','2013-05-13','16:10:00',2.21),('8537','2013-05-13','16:15:00',1.45),('8537','2013-05-13','16:20:00',1.63),('8537','2013-05-13','16:25:00',1.57),('8537','2013-05-13','16:30:00',2.05),('8537','2013-05-13','16:35:00',1.49),('8537','2013-05-13','16:40:00',1.96),('8537','2013-05-13','16:45:00',2.32),('8537','2013-05-13','16:50:00',3.6),('8537','2013-05-13','16:55:00',3.43),('8537','2013-05-13','17:00:00',3.07),('8537','2013-05-13','17:05:00',2.84),('8537','2013-05-13','17:10:00',2.07),('8537','2013-05-13','17:15:00',3.16),('8537','2013-05-13','17:20:00',3.15),('8537','2013-05-13','17:25:00',2.92),('8537','2013-05-13','17:30:00',2.65),('8537','2013-05-13','17:35:00',2.51),('8537','2013-05-13','17:40:00',2.3),('8537','2013-05-13','17:45:00',2.23),('8537','2013-05-13','17:50:00',1.76),('8537','2013-05-13','17:55:00',1.01),('8537','2013-05-12','08:05:00',1.17),('8537','2013-05-12','08:10:00',1.54),('8537','2013-05-12','08:15:00',2.31),('8537','2013-05-12','08:20:00',1.78),('8537','2013-05-12','08:25:00',1.42),('8537','2013-05-12','08:30:00',1.11),('8537','2013-05-12','08:40:00',1.08),('8537','2013-05-12','08:45:00',1.61),('8537','2013-05-12','08:50:00',1.64),('8537','2013-05-12','08:55:00',1.2),('8537','2013-05-12','09:00:00',1.5),('8537','2013-05-12','09:05:00',1.81),('8537','2013-05-12','09:10:00',1.29),('8537','2013-05-12','09:15:00',1.55),('8537','2013-05-12','09:20:00',1.64),('8537','2013-05-12','09:25:00',1.78),('8537','2013-05-12','09:30:00',3.22),('8537','2013-05-12','09:35:00',1.64),('8537','2013-05-12','09:40:00',1.51),('8537','2013-05-12','09:45:00',4.57),('8537','2013-05-12','09:50:00',4.42),('8537','2013-05-12','09:55:00',3.99),('8537','2013-05-12','10:00:00',3.64),('8537','2013-05-12','10:05:00',1.4),('8537','2013-05-12','10:10:00',2.76),('8537','2013-05-12','10:15:00',1.4),('8537','2013-05-12','10:20:00',1.03),('8537','2013-05-12','10:25:00',1.22),('8537','2013-05-12','10:30:00',1.59),('8537','2013-05-12','10:35:00',1.33),('8537','2013-05-12','10:40:00',1.17),('8537','2013-05-12','10:45:00',1.25),('8537','2013-05-12','10:50:00',2.45),('8537','2013-05-12','10:55:00',5.46),('8537','2013-05-12','11:00:00',2.08),('8537','2013-05-12','11:05:00',1.17),('8537','2013-05-12','11:10:00',1.56),('8537','2013-05-12','11:15:00',5.41),('8537','2013-05-12','11:20:00',4.5),('8537','2013-05-12','11:25:00',3.34),('8537','2013-05-12','11:30:00',5.36),('8537','2013-05-12','11:35:00',4.56),('8537','2013-05-12','11:40:00',3.83),('8537','2013-05-12','11:45:00',5.37),('8537','2013-05-12','11:50:00',4.32),('8537','2013-05-12','11:55:00',2.41),('8537','2013-05-12','12:00:00',3.52),('8537','2013-05-12','12:05:00',4.46),('8537','2013-05-12','12:10:00',4.92),('8537','2013-05-12','12:15:00',1.94),('8537','2013-05-12','12:20:00',1.31),('8537','2013-05-12','12:25:00',1.23),('8537','2013-05-12','12:30:00',1.32),('8537','2013-05-12','12:35:00',2.59),('8537','2013-05-12','12:40:00',3.32),('8537','2013-05-12','12:45:00',4.65),('8537','2013-05-12','12:50:00',4.92),('8537','2013-05-12','12:55:00',2.69),('8537','2013-05-12','13:00:00',1.68),('8537','2013-05-12','13:05:00',1.71),('8537','2013-05-12','13:10:00',3.08),('8537','2013-05-12','13:15:00',2.98),('8537','2013-05-12','13:20:00',2.04),('8537','2013-05-12','13:25:00',3.36),('8537','2013-05-12','13:30:00',4.13),('8537','2013-05-12','13:35:00',5.02),('8537','2013-05-12','13:40:00',5.69),('8537','2013-05-12','13:45:00',4.21),('8537','2013-05-12','13:50:00',3.44),('8537','2013-05-12','13:55:00',3.87),('8537','2013-05-12','14:00:00',3.14),('8537','2013-05-12','14:05:00',5.45),('8537','2013-05-12','14:10:00',4.31),('8537','2013-05-12','14:15:00',4.66),('8537','2013-05-12','14:20:00',5.53),('8537','2013-05-12','14:25:00',5.25),('8537','2013-05-12','14:30:00',5.19),('8537','2013-05-12','14:35:00',5.07),('8537','2013-05-12','14:40:00',5.07),('8537','2013-05-12','14:45:00',4.76),('8537','2013-05-12','14:50:00',4.87),('8537','2013-05-12','14:55:00',4.91),('8537','2013-05-12','15:00:00',4.12),('8537','2013-05-12','15:05:00',4.82),('8537','2013-05-12','15:10:00',4.81),('8537','2013-05-12','15:15:00',4.82),('8537','2013-05-12','15:20:00',3.34),('8537','2013-05-12','15:25:00',4.08),('8537','2013-05-12','15:30:00',3.99),('8537','2013-05-12','15:35:00',4.07),('8537','2013-05-12','15:40:00',4.16),('8537','2013-05-12','15:45:00',4.11),('8537','2013-05-12','15:50:00',3.99),('8537','2013-05-12','15:55:00',3.9),('8537','2013-05-12','16:00:00',3.83),('8537','2013-05-12','16:05:00',3.76),('8537','2013-05-12','16:10:00',3.69),('8537','2013-05-12','16:15:00',3.55),('8537','2013-05-12','16:20:00',3.51),('8537','2013-05-12','16:25:00',3.39),('8537','2013-05-12','16:30:00',3.27),('8537','2013-05-12','16:35:00',3.28),('8537','2013-05-12','16:40:00',3.26),('8537','2013-05-12','16:45:00',3.2),('8537','2013-05-12','16:50:00',3.11),('8537','2013-05-12','16:55:00',2.97),('8537','2013-05-12','17:00:00',3.14),('8537','2013-05-12','17:05:00',2.92),('8537','2013-05-12','17:10:00',2.77),('8537','2013-05-12','17:15:00',2.87),('8537','2013-05-12','17:20:00',2.47),('8537','2013-05-12','17:25:00',2.13),('8537','2013-05-12','17:30:00',2.15),('8537','2013-05-12','17:35:00',1.71),('8537','2013-05-12','17:40:00',1.87),('8537','2013-05-12','17:45:00',1.35),('8537','2013-05-12','17:50:00',1.24),('8537','2013-05-12','17:55:00',1.1),('8537','2013-05-12','18:00:00',1.38),('8537','2013-05-12','18:05:00',1.77),('8537','2013-05-12','18:10:00',1.77),('8537','2013-05-12','18:15:00',1.6),('8537','2013-05-12','18:20:00',1.21),('8537','2013-05-12','18:25:00',1.4),('8537','2013-05-12','18:30:00',1.22),('8537','2013-05-12','18:35:00',1.32),('8537','2013-05-12','18:40:00',1.11),('8537','2014-03-31','08:10:00',1.07),('8537','2014-03-31','08:15:00',1.19),('8537','2014-03-31','08:20:00',1.3),('8537','2014-03-31','08:25:00',1.41),('8537','2014-03-31','08:30:00',1.53),('8537','2014-03-31','08:35:00',1.63),('8537','2014-03-31','08:40:00',1.75),('8537','2014-03-31','08:45:00',1.83),('8537','2014-03-31','08:50:00',1.99),('8537','2014-03-31','08:55:00',2.11),('8537','2014-03-31','09:00:00',2.22),('8537','2014-03-31','09:05:00',2.33),('8537','2014-03-31','09:10:00',2.44),('8537','2014-03-31','09:15:00',2.55),('8537','2014-03-31','09:20:00',2.65),('8537','2014-03-31','09:25:00',2.75),('8537','2014-03-31','09:30:00',2.84),('8537','2014-03-31','09:35:00',2.94),('8537','2014-03-31','09:40:00',3.03),('8537','2014-03-31','09:45:00',3.12),('8537','2014-03-31','09:50:00',3.19),('8537','2014-03-31','09:55:00',3.27),('8537','2014-03-31','10:00:00',3.35),('8537','2014-03-31','10:05:00',3.43),('8537','2014-03-31','10:10:00',3.51),('8537','2014-03-31','10:15:00',3.6),('8537','2014-03-31','10:20:00',3.67),('8537','2014-03-31','10:25:00',3.7),('8537','2014-03-31','10:30:00',3.75),('8537','2014-03-31','10:35:00',3.82),('8537','2014-03-31','10:40:00',3.91),('8537','2014-03-31','10:45:00',3.96),('8537','2014-03-31','10:50:00',4.01),('8537','2014-03-31','10:55:00',4.09),('8537','2014-03-31','11:00:00',4.14),('8537','2014-03-31','11:05:00',4.18),('8537','2014-03-31','11:10:00',4.23),('8537','2014-03-31','11:15:00',4.31),('8537','2014-03-31','11:20:00',4.37),('8537','2014-03-31','11:25:00',4.43),('8537','2014-03-31','11:30:00',4.44),('8537','2014-03-31','11:35:00',4.48),('8537','2014-03-31','11:40:00',4.53),('8537','2014-03-31','11:45:00',4.52),('8537','2014-03-31','11:50:00',4.53),('8537','2014-03-31','11:55:00',4.65),('8537','2014-03-31','12:00:00',4.7),('8537','2014-03-31','12:05:00',4.64),('8537','2014-03-31','12:10:00',4.64),('8537','2014-03-31','12:15:00',4.68),('8537','2014-03-31','12:20:00',4.74),('8537','2014-03-31','12:25:00',4.76),('8537','2014-03-31','12:30:00',4.76),('8537','2014-03-31','12:35:00',4.79),('8537','2014-03-31','12:40:00',4.84),('8537','2014-03-31','12:45:00',4.83),('8537','2014-03-31','12:50:00',4.77),('8537','2014-03-31','12:55:00',4.74),('8537','2014-03-31','13:00:00',4.78),('8537','2014-03-31','13:05:00',4.83),('8537','2014-03-31','13:10:00',4.82),('8537','2014-03-31','13:15:00',4.85),('8537','2014-03-31','13:20:00',4.9),('8537','2014-03-31','13:25:00',4.84),('8537','2014-03-31','13:30:00',4.83),('8537','2014-03-31','13:35:00',4.88),('8537','2014-03-31','13:40:00',4.89),('8537','2014-03-31','13:45:00',4.87),('8537','2014-03-31','13:50:00',4.85),('8537','2014-03-31','13:55:00',4.82),('8537','2014-03-31','14:00:00',4.82),('8537','2014-03-31','14:05:00',4.82),('8537','2014-03-31','14:10:00',4.79),('8537','2014-03-31','14:15:00',4.79),('8537','2014-03-31','14:20:00',4.74),('8537','2014-03-31','14:25:00',4.69),('8537','2014-03-31','14:30:00',4.62),('8537','2014-03-31','14:35:00',4.48),('8537','2014-03-31','14:40:00',4.53),('8537','2014-03-31','14:45:00',4.51),('8537','2014-03-31','14:50:00',4.4),('8537','2014-03-31','14:55:00',4.39),('8537','2014-03-31','15:00:00',4.39),('8537','2014-03-31','15:05:00',4.32),('8537','2014-03-31','15:10:00',4.28),('8537','2014-03-31','15:15:00',4.25),('8537','2014-03-31','15:20:00',4.13),('8537','2014-03-31','15:25:00',3.75),('8537','2014-03-31','15:30:00',3.26),('8537','2014-03-31','15:35:00',3.23),('8537','2014-03-31','15:40:00',3.84),('8537','2014-03-31','15:45:00',3.78),('8537','2014-03-31','15:50:00',3.69),('8537','2014-03-31','15:55:00',3.6),('8537','2014-03-31','16:00:00',3.46),('8537','2014-03-31','16:05:00',3.33),('8537','2014-03-31','16:10:00',3.31),('8537','2014-03-31','16:15:00',3.22),('8537','2014-03-31','16:20:00',3.14),('8537','2014-03-31','16:25:00',3.05),('8537','2014-03-31','16:30:00',2.96),('8537','2014-03-31','16:35:00',2.79),('8537','2014-03-31','16:40:00',2.73),('8537','2014-03-31','16:45:00',2.66),('8537','2014-03-31','16:50:00',2.55),('8537','2014-03-31','16:55:00',2.37),('8537','2014-03-31','17:00:00',2.28),('8537','2014-03-31','17:05:00',2.19),('8537','2014-03-31','17:10:00',2.11),('8537','2014-03-31','17:15:00',1.99),('8537','2014-03-31','17:20:00',1.85),('8537','2014-03-31','17:25:00',1.7),('8537','2014-03-31','17:30:00',1.63),('8537','2014-03-31','17:35:00',1.53),('8537','2014-03-31','17:40:00',1.43),('8537','2014-03-31','17:45:00',1.31),('8537','2014-03-31','17:50:00',1.2),('8537','2014-03-31','17:55:00',1.11),('8537','2014-03-31','18:00:00',1.01),('8537','2013-05-11','07:45:00',1.24),('8537','2013-05-11','07:50:00',1.48),('8537','2013-05-11','07:55:00',1.67),('8537','2013-05-11','08:00:00',1.55),('8537','2013-05-11','08:05:00',1.53),('8537','2013-05-11','08:15:00',1.69),('8537','2013-05-11','08:20:00',1.53),('8537','2013-05-11','08:25:00',1.05),('8537','2013-05-11','08:30:00',1.09),('8537','2013-05-11','08:35:00',1.51),('8537','2013-05-11','09:05:00',1.21),('8537','2013-05-11','09:10:00',1.21),('8537','2013-05-11','09:15:00',1.34),('8537','2013-05-11','09:20:00',1.84),('8537','2013-05-11','09:25:00',2.01),('8537','2013-05-11','09:30:00',2.34),('8537','2013-05-11','09:35:00',3.76),('8537','2013-05-11','09:40:00',2.18),('8537','2013-05-11','09:45:00',2.15),('8537','2013-05-11','09:50:00',1.75),('8537','2013-05-11','09:55:00',1.59),('8537','2013-05-11','10:00:00',1.81),('8537','2013-05-11','10:05:00',2.05),('8537','2013-05-11','10:10:00',1.19),('8537','2013-05-11','10:20:00',1.26),('8537','2013-05-11','10:25:00',1.18),('8537','2013-05-11','10:30:00',1.39),('8537','2013-05-11','10:35:00',1.43),('8537','2013-05-11','10:40:00',1.15),('8537','2013-05-11','10:50:00',1.25),('8537','2013-05-11','10:55:00',4.36),('8537','2013-05-11','11:00:00',3.78),('8537','2013-05-11','11:05:00',3.15),('8537','2013-05-11','11:10:00',1.45),('8537','2013-05-11','11:15:00',1.11),('8537','2013-05-11','11:25:00',1.06),('8537','2013-05-11','11:30:00',1.68),('8537','2013-05-11','11:35:00',3.43),('8537','2013-05-11','11:40:00',2.54),('8537','2013-05-11','11:45:00',4.97),('8537','2013-05-11','11:50:00',2.81),('8537','2013-05-11','11:55:00',1.22),('8537','2013-05-11','12:00:00',1.53),('8537','2013-05-11','12:05:00',2.27),('8537','2013-05-11','12:10:00',1.72),('8537','2013-05-11','12:15:00',1.68),('8537','2013-05-11','12:20:00',2.35),('8537','2013-05-11','12:25:00',5.07),('8537','2013-05-11','12:30:00',3.81),('8537','2013-05-11','12:35:00',2.06),('8537','2013-05-11','12:40:00',2.26),('8537','2013-05-11','12:45:00',2.78),('8537','2013-05-11','12:50:00',2.26),('8537','2013-05-11','12:55:00',1.93),('8537','2013-05-11','13:00:00',1.81),('8537','2013-05-11','13:05:00',1.85),('8537','2013-05-11','13:10:00',1.4),('8537','2013-05-11','13:25:00',1.16),('8537','2013-05-11','13:30:00',1.29),('8537','2013-05-11','13:35:00',1.26),('8537','2013-05-11','14:00:00',1.98),('8537','2013-05-11','14:05:00',3.23),('8537','2013-05-11','14:10:00',3.62),('8537','2013-05-11','14:15:00',3.07),('8537','2013-05-11','14:20:00',4.97),('8537','2013-05-11','14:25:00',5.05),('8537','2013-05-11','14:30:00',3.24),('8537','2013-05-11','14:35:00',3.31),('8537','2013-05-11','14:40:00',4.51),('8537','2013-05-11','14:45:00',4.03),('8537','2013-05-11','14:50:00',5.22),('8537','2013-05-11','14:55:00',5.01),('8537','2013-05-11','15:00:00',4.83),('8537','2013-05-11','15:05:00',4.72),('8537','2013-05-11','15:10:00',4.24),('8537','2013-05-11','15:15:00',4.73),('8537','2013-05-11','15:20:00',4.2),('8537','2013-05-11','15:25:00',4.51),('8537','2013-05-11','15:30:00',4.4),('8537','2013-05-11','15:35:00',4.3),('8537','2013-05-11','15:40:00',4.27),('8537','2013-05-11','15:45:00',4.2),('8537','2013-05-11','15:50:00',4),('8537','2013-05-11','15:55:00',3.72),('8537','2013-05-11','16:00:00',2.66),('8537','2013-05-11','16:05:00',3.67),('8537','2013-05-11','16:10:00',3.63),('8537','2013-05-11','16:15:00',3.04),('8537','2013-05-11','16:20:00',3.49),('8537','2013-05-11','16:25:00',3.63),('8537','2013-05-11','16:30:00',3.56),('8537','2013-05-11','16:35:00',2.81),('8537','2013-05-11','16:40:00',3.19),('8537','2013-05-11','16:45:00',3.22),('8537','2013-05-11','16:50:00',2.75),('8537','2013-05-11','16:55:00',3.04),('8537','2013-05-11','17:00:00',2.94),('8537','2013-05-11','17:05:00',2.81),('8537','2013-05-11','17:10:00',2.65),('8537','2013-05-11','17:15:00',1.92),('8537','2013-05-11','17:20:00',2.36),('8537','2013-05-11','17:25:00',1.65),('8537','2013-05-11','17:30:00',1.72),('8537','2013-05-11','17:35:00',1.83),('8537','2013-05-11','17:40:00',1.67),('8537','2013-05-11','17:45:00',1.87),('8537','2013-05-11','17:50:00',1.27),('8537','2013-05-11','17:55:00',1.31),('8537','2013-05-11','18:05:00',1.04),('8537','2013-05-11','18:10:00',1.54),('8537','2013-05-11','18:15:00',1.41),('8537','2013-05-11','18:25:00',1.12),('8537','2013-05-10','07:40:00',1.02),('8537','2013-05-10','07:45:00',1.07),('8537','2013-05-10','07:55:00',1.25),('8537','2013-05-10','08:00:00',1.86),('8537','2013-05-10','08:05:00',2.22),('8537','2013-05-10','08:10:00',2.08),('8537','2013-05-10','08:15:00',2.47),('8537','2013-05-10','08:20:00',2.3),('8537','2013-05-10','08:25:00',2.21),('8537','2013-05-10','08:30:00',2.19),('8537','2013-05-10','08:35:00',2.36),('8537','2013-05-10','08:40:00',1.24),('8537','2013-05-10','09:00:00',1.76),('8537','2013-05-10','09:05:00',2.72),('8537','2013-05-10','09:10:00',3.17),('8537','2013-05-10','09:15:00',3.26),('8537','2013-05-10','09:20:00',3.11),('8537','2013-05-10','09:25:00',2.93),('8537','2013-05-10','09:30:00',2.86),('8537','2013-05-10','09:35:00',3.54),('8537','2013-05-10','09:40:00',3.07),('8537','2013-05-10','09:45:00',3.44),('8537','2013-05-10','09:50:00',2.91),('8537','2013-05-10','09:55:00',2.68),('8537','2013-05-10','10:00:00',2.39),('8537','2013-05-10','10:05:00',2.29),('8537','2013-05-10','10:10:00',3.77),('8537','2013-05-10','10:15:00',3.84),('8537','2013-05-10','10:20:00',3.43),('8537','2013-05-10','10:25:00',1.32),('8537','2013-05-10','10:30:00',1.82),('8537','2013-05-10','10:35:00',1.32),('8537','2013-05-10','10:40:00',4.03),('8537','2013-05-10','10:45:00',4.76),('8537','2013-05-10','10:50:00',4.91),('8537','2013-05-10','10:55:00',4.48),('8537','2013-05-10','11:00:00',4.53),('8537','2013-05-10','11:05:00',4.6),('8537','2013-05-10','11:10:00',4.63),('8537','2013-05-10','11:15:00',4.33),('8537','2013-05-10','11:20:00',5.18),('8537','2013-05-10','11:25:00',4.31),('8537','2013-05-10','11:30:00',4.19),('8537','2013-05-10','11:35:00',4.63),('8537','2013-05-10','11:40:00',3.7),('8537','2013-05-10','11:45:00',2.72),('8537','2013-05-10','11:50:00',3.15),('8537','2013-05-10','11:55:00',4.87),('8537','2013-05-10','12:00:00',4.51),('8537','2013-05-10','12:05:00',3.72),('8537','2013-05-10','12:10:00',3.17),('8537','2013-05-10','12:15:00',3.01),('8537','2013-05-10','12:20:00',3.14),('8537','2013-05-10','12:25:00',2.75),('8537','2013-05-10','12:30:00',2.52),('8537','2013-05-10','12:35:00',2.74),('8537','2013-05-10','12:40:00',3.59),('8537','2013-05-10','12:45:00',5.26),('8537','2013-05-10','12:50:00',4.5),('8537','2013-05-10','12:55:00',3.44),('8537','2013-05-10','13:00:00',4.24),('8537','2013-05-10','13:05:00',3.73),('8537','2013-05-10','13:10:00',5.41),('8537','2013-05-10','13:15:00',5.53),('8537','2013-05-10','13:20:00',3.7),('8537','2013-05-10','13:25:00',3.51),('8537','2013-05-10','13:30:00',4.16),('8537','2013-05-10','13:35:00',4.79),('8537','2013-05-10','13:40:00',5.15),('8537','2013-05-10','13:45:00',4.54),('8537','2013-05-10','13:50:00',2.89),('8537','2013-05-10','13:55:00',2.49),('8537','2013-05-10','14:00:00',2.27),('8537','2013-05-10','14:05:00',2.34),('8537','2013-05-10','14:10:00',2.73),('8537','2013-05-10','14:15:00',3.02),('8537','2013-05-10','14:20:00',3),('8537','2013-05-10','14:25:00',2.96),('8537','2013-05-10','14:30:00',3.02),('8537','2013-05-10','14:35:00',3.68),('8537','2013-05-10','14:40:00',3.29),('8537','2013-05-10','14:45:00',2.41),('8537','2013-05-10','14:50:00',1.77),('8537','2013-05-10','14:55:00',1.51),('8537','2013-05-10','15:00:00',1.42),('8537','2013-05-10','15:05:00',1.52),('8537','2013-05-10','15:10:00',2.04),('8537','2013-05-10','15:15:00',3.37),('8537','2013-05-10','15:20:00',3.36),('8537','2013-05-10','15:25:00',2.35),('8537','2013-05-10','15:30:00',2.21),('8537','2013-05-10','15:35:00',2.29),('8537','2013-05-10','15:40:00',2.38),('8537','2013-05-10','15:45:00',2.3),('8537','2013-05-10','15:50:00',2.09),('8537','2013-05-10','15:55:00',1.93),('8537','2013-05-10','16:00:00',1.9),('8537','2013-05-10','16:05:00',1.85),('8537','2013-05-10','16:10:00',1.81),('8537','2013-05-10','16:15:00',1.69),('8537','2013-05-10','16:20:00',1.52),('8537','2013-05-10','16:25:00',1.51),('8537','2013-05-10','16:30:00',1.59),('8537','2013-05-10','16:35:00',1.67),('8537','2013-05-10','16:40:00',1.6),('8537','2013-05-10','16:45:00',1.6),('8537','2013-05-10','16:50:00',1.57),('8537','2013-05-10','16:55:00',1.34),('8537','2013-05-10','17:00:00',1.08),('8537','2013-05-10','17:05:00',1.04),('8537','2013-05-10','17:10:00',1.29),('8537','2013-05-10','17:15:00',1.59),('8537','2013-05-10','17:20:00',2.14),('8537','2013-05-10','17:25:00',2.12),('8537','2013-05-10','17:30:00',1.97),('8537','2013-05-10','17:35:00',2.24),('8537','2013-05-10','17:40:00',1.6),('8537','2013-05-10','17:45:00',1.44),('8537','2013-05-10','17:50:00',1.26),('8537','2013-05-10','17:55:00',1.14),('8537','2013-05-10','18:00:00',1.05),('8537','2013-05-10','18:05:00',1.02),('8537','2013-05-09','07:35:00',1.08),('8537','2013-05-09','07:40:00',1.19),('8537','2013-05-09','07:45:00',1.3),('8537','2013-05-09','07:50:00',1.4),('8537','2013-05-09','07:55:00',1.5),('8537','2013-05-09','08:00:00',1.62),('8537','2013-05-09','08:05:00',1.73),('8537','2013-05-09','08:10:00',1.84),('8537','2013-05-09','08:15:00',1.96),('8537','2013-05-09','08:20:00',2.07),('8537','2013-05-09','08:25:00',2.18),('8537','2013-05-09','08:30:00',2.29),('8537','2013-05-09','08:35:00',2.38),('8537','2013-05-09','08:40:00',2.48),('8537','2013-05-09','08:45:00',2.6),('8537','2013-05-09','08:50:00',2.69),('8537','2013-05-09','08:55:00',2.79),('8537','2013-05-09','09:00:00',2.89),('8537','2013-05-09','09:05:00',2.98),('8537','2013-05-09','09:10:00',3.09),('8537','2013-05-09','09:15:00',3.2),('8537','2013-05-09','09:20:00',3.27),('8537','2013-05-09','09:25:00',3.36),('8537','2013-05-09','09:30:00',3.48),('8537','2013-05-09','09:35:00',3.57),('8537','2013-05-09','09:40:00',3.65),('8537','2013-05-09','09:45:00',3.72),('8537','2013-05-09','09:50:00',3.81),('8537','2013-05-09','09:55:00',3.86),('8537','2013-05-09','10:00:00',3.95),('8537','2013-05-09','10:05:00',4.01),('8537','2013-05-09','10:10:00',4.08),('8537','2013-05-09','10:15:00',4.16),('8537','2013-05-09','10:20:00',4.18),('8537','2013-05-09','10:25:00',4.25),('8537','2013-05-09','10:30:00',4.32),('8537','2013-05-09','10:35:00',4.34),('8537','2013-05-09','10:40:00',4.45),('8537','2013-05-09','10:45:00',4.48),('8537','2013-05-09','10:50:00',4.51),('8537','2013-05-09','10:55:00',4.61),('8537','2013-05-09','11:00:00',4.64),('8537','2013-05-09','11:05:00',4.69),('8537','2013-05-09','11:10:00',4.66),('8537','2013-05-09','11:15:00',4.79),('8537','2013-05-09','11:20:00',4.77),('8537','2013-05-09','11:25:00',4.79),('8537','2013-05-09','11:30:00',4.77),('8537','2013-05-09','11:35:00',4.81),('8537','2013-05-09','11:40:00',4.86),('8537','2013-05-09','11:45:00',4.9),('8537','2013-05-09','11:50:00',4.84),('8537','2013-05-09','11:55:00',4.86),('8537','2013-05-09','12:00:00',5),('8537','2013-05-09','12:05:00',5.02),('8537','2013-05-09','12:10:00',5.04),('8537','2013-05-09','12:15:00',5.04),('8537','2013-05-09','12:20:00',4.98),('8537','2013-05-09','12:25:00',4.86),('8537','2013-05-09','12:30:00',5.13),('8537','2013-05-09','12:35:00',5.11),('8537','2013-05-09','12:40:00',4.27),('8537','2013-05-09','12:45:00',1.99),('8537','2013-05-09','12:50:00',5.41),('8537','2013-05-09','12:55:00',5.21),('8537','2013-05-09','13:00:00',5.13),('8537','2013-05-09','13:05:00',5.08),('8537','2013-05-09','13:10:00',5.12),('8537','2013-05-09','13:15:00',5.09),('8537','2013-05-09','13:20:00',5.12),('8537','2013-05-09','13:25:00',5.1),('8537','2013-05-09','13:30:00',5.15),('8537','2013-05-09','13:35:00',5.18),('8537','2013-05-09','13:40:00',5.15),('8537','2013-05-09','13:45:00',5.17),('8537','2013-05-09','13:50:00',5.11),('8537','2013-05-09','13:55:00',5.08),('8537','2013-05-09','14:00:00',4.05),('8537','2013-05-09','14:05:00',5.15),('8537','2013-05-09','14:10:00',3.79),('8537','2013-05-09','14:15:00',4.14),('8537','2013-05-09','14:20:00',4.97),('8537','2013-05-09','14:25:00',4.54),('8537','2013-05-09','14:30:00',4.48),('8537','2013-05-09','14:35:00',4.65),('8537','2013-05-09','14:40:00',4.39),('8537','2013-05-09','14:45:00',4.64),('8537','2013-05-09','14:50:00',4.6),('8537','2013-05-09','14:55:00',4.62),('8537','2013-05-09','15:00:00',4.59),('8537','2013-05-09','15:05:00',4.51),('8537','2013-05-09','15:10:00',4.44),('8537','2013-05-09','15:15:00',4.39),('8537','2013-05-09','15:20:00',4.31),('8537','2013-05-09','15:25:00',4.26),('8537','2013-05-09','15:30:00',4.16),('8537','2013-05-09','15:35:00',4.06),('8537','2013-05-09','15:40:00',4.07),('8537','2013-05-09','15:45:00',4.01),('8537','2013-05-09','15:50:00',3.95),('8537','2013-05-09','15:55:00',3.85),('8537','2013-05-09','16:00:00',3.79),('8537','2013-05-09','16:05:00',3.72),('8537','2013-05-09','16:10:00',3.65),('8537','2013-05-09','16:15:00',3.52),('8537','2013-05-09','16:20:00',3.45),('8537','2013-05-09','16:25:00',3.34),('8537','2013-05-09','16:30:00',3.27),('8537','2013-05-09','16:35:00',3.2),('8537','2013-05-09','16:40:00',3.09),('8537','2013-05-09','16:45:00',3),('8537','2013-05-09','16:50:00',2.83),('8537','2013-05-09','16:55:00',2.37),('8537','2013-05-09','17:00:00',2.65),('8537','2013-05-09','17:05:00',2.58),('8537','2013-05-09','17:10:00',2.46),('8537','2013-05-09','17:15:00',2.31),('8537','2013-05-09','17:20:00',2.25),('8537','2013-05-09','17:25:00',2.16),('8537','2013-05-09','17:30:00',2.06),('8537','2013-05-09','17:35:00',1.93),('8537','2013-05-09','17:40:00',1.83),('8537','2013-05-09','17:45:00',1.68),('8537','2013-05-09','17:50:00',1.6),('8537','2013-05-09','17:55:00',1.5),('8537','2013-05-09','18:00:00',1.41),('8537','2013-05-09','18:05:00',1.3),('8537','2013-05-09','18:10:00',1.18),('8537','2013-05-09','18:15:00',1.1),('8537','2013-05-09','18:20:00',1.01),('8537','2013-05-08','08:05:00',1.61),('8537','2013-05-08','08:10:00',2.02),('8537','2013-05-08','08:15:00',2.07),('8537','2013-05-08','08:20:00',2.13),('8537','2013-05-08','08:25:00',2.15),('8537','2013-05-08','08:30:00',2.24),('8537','2013-05-08','08:35:00',2.36),('8537','2013-05-08','08:40:00',2.53),('8537','2013-05-08','08:45:00',2.74),('8537','2013-05-08','08:50:00',3.02),('8537','2013-05-08','08:55:00',3.08),('8537','2013-05-08','09:00:00',2.43),('8537','2013-05-08','09:05:00',3.04),('8537','2013-05-08','09:10:00',2.31),('8537','2013-05-08','09:15:00',2.17),('8537','2013-05-08','09:20:00',1.28),('8537','2013-05-08','09:35:00',1.04),('8537','2013-05-08','09:40:00',1.53),('8537','2013-05-08','09:45:00',1.43),('8537','2013-05-08','09:50:00',1.46),('8537','2013-05-08','09:55:00',1.83),('8537','2013-05-08','10:00:00',1.7),('8537','2013-05-08','10:05:00',4.44),('8537','2013-05-08','10:10:00',3.5),('8537','2013-05-08','10:15:00',1.67),('8537','2013-05-08','10:20:00',1.37),('8537','2013-05-08','10:25:00',1.28),('8537','2013-05-08','10:30:00',1.15),('8537','2013-05-08','10:35:00',1.05),('8537','2013-05-08','10:40:00',1.02),('8537','2013-05-08','10:55:00',1.72),('8537','2013-05-08','11:00:00',1.73),('8537','2013-05-08','11:05:00',3.65),('8537','2013-05-08','11:10:00',5.36),('8537','2013-05-08','11:15:00',5.2),('8537','2013-05-08','11:20:00',4.83),('8537','2013-05-08','11:25:00',4.96),('8537','2013-05-08','11:30:00',5.16),('8537','2013-05-08','11:35:00',5.28),('8537','2013-05-08','11:40:00',5.24),('8537','2013-05-08','11:45:00',3.24),('8537','2013-05-08','11:50:00',2.51),('8537','2013-05-08','11:55:00',2.03),('8537','2013-05-08','12:00:00',4.85),('8537','2013-05-08','12:05:00',1.9),('8537','2013-05-08','12:15:00',1.06),('8537','2013-05-08','12:20:00',1.63),('8537','2013-05-08','12:25:00',5.43),('8537','2013-05-08','12:30:00',2.86),('8537','2013-05-08','12:35:00',1.29),('8537','2013-05-08','12:40:00',1.44),('8537','2013-05-08','12:45:00',1.6),('8537','2013-05-08','12:50:00',2.67),('8537','2013-05-08','12:55:00',3.37),('8537','2013-05-08','13:00:00',4.93),('8537','2013-05-08','13:05:00',3.56),('8537','2013-05-08','13:10:00',5.9),('8537','2013-05-08','13:15:00',3.12),('8537','2013-05-08','13:20:00',1.33),('8537','2013-05-08','13:25:00',1.69),('8537','2013-05-08','13:30:00',1.13),('8537','2013-05-08','13:35:00',1.08),('8537','2013-05-08','13:40:00',1.26),('8537','2013-05-08','13:45:00',5.65),('8537','2013-05-08','13:50:00',5.24),('8537','2013-05-08','13:55:00',4.63),('8537','2013-05-08','14:00:00',3.84),('8537','2013-05-08','14:05:00',2.19),('8537','2013-05-08','14:10:00',1.79),('8537','2013-05-08','14:15:00',1.72),('8537','2013-05-08','14:20:00',3.9),('8537','2013-05-08','14:25:00',1.81),('8537','2013-05-08','14:30:00',4.06),('8537','2013-05-08','14:35:00',4.32),('8537','2013-05-08','14:40:00',4.54),('8537','2013-05-08','14:45:00',2.28),('8537','2013-05-08','14:50:00',3.24),('8537','2013-05-08','14:55:00',4.7),('8537','2013-05-08','15:00:00',4.15),('8537','2013-05-08','15:05:00',4.63),('8537','2013-05-08','15:10:00',3.63),('8537','2013-05-08','15:15:00',4.53),('8537','2013-05-08','15:20:00',4.45),('8537','2013-05-08','15:25:00',4.4),('8537','2013-05-08','15:30:00',4.3),('8537','2013-05-08','15:35:00',4.15),('8537','2013-05-08','15:40:00',4.07),('8537','2013-05-08','15:45:00',4.03),('8537','2013-05-08','15:50:00',3.96),('8537','2013-05-08','15:55:00',3.87),('8537','2013-05-08','16:00:00',3.86),('8537','2013-05-08','16:05:00',3.77),('8537','2013-05-08','16:10:00',3.68),('8537','2013-05-08','16:15:00',3.58),('8537','2013-05-08','16:20:00',3.48),('8537','2013-05-08','16:25:00',3.38),('8537','2013-05-08','16:30:00',3.41),('8537','2013-05-08','16:35:00',3.3),('8537','2013-05-08','16:40:00',3.18),('8537','2013-05-08','16:45:00',3.07),('8537','2013-05-08','16:50:00',3.09),('8537','2013-05-08','16:55:00',2.79),('8537','2013-05-08','17:00:00',2.37),('8537','2013-05-08','17:05:00',3.14),('8537','2013-05-08','17:10:00',2.22),('8537','2013-05-08','17:15:00',2.35),('8537','2013-05-08','17:20:00',2.47),('8537','2013-05-08','17:25:00',1.76),('8537','2013-05-08','17:30:00',2.1),('8537','2013-05-08','17:35:00',2.37),('8537','2013-05-08','17:40:00',2.3),('8537','2013-05-08','17:45:00',2.26),('8537','2013-05-08','17:50:00',2.26),('8537','2013-05-08','17:55:00',1.8),('8537','2013-05-08','18:15:00',1.3),('8537','2013-05-08','18:20:00',1.38),('8537','2013-05-08','18:25:00',1.23),('8537','2013-05-08','18:30:00',1.05),('8537','2013-05-07','07:35:00',1.08),('8537','2013-05-07','07:40:00',1.19),('8537','2013-05-07','07:45:00',1.3),('8537','2013-05-07','07:50:00',1.4),('8537','2013-05-07','07:55:00',1.49),('8537','2013-05-07','08:00:00',1.62),('8537','2013-05-07','08:05:00',1.72),('8537','2013-05-07','08:10:00',1.84),('8537','2013-05-07','08:15:00',1.95),('8537','2013-05-07','08:20:00',2.05),('8537','2013-05-07','08:25:00',2.16),('8537','2013-05-07','08:30:00',2.27),('8537','2013-05-07','08:35:00',2.39),('8537','2013-05-07','08:40:00',2.51),('8537','2013-05-07','08:45:00',2.61),('8537','2013-05-07','08:50:00',2.8),('8537','2013-05-07','08:55:00',2.99),('8537','2013-05-07','09:00:00',2.54),('8537','2013-05-07','09:05:00',2.77),('8537','2013-05-07','09:10:00',1.49),('8537','2013-05-07','09:15:00',1.69),('8537','2013-05-07','09:20:00',2.08),('8537','2013-05-07','09:30:00',1.35),('8537','2013-05-07','09:35:00',3.85),('8537','2013-05-07','09:45:00',1.57),('8537','2013-05-07','09:50:00',1.97),('8537','2013-05-07','09:55:00',1.66),('8537','2013-05-07','10:00:00',1.25),('8537','2013-05-07','10:05:00',1.08),('8537','2013-05-07','11:00:00',1.22),('8537','2013-05-07','11:05:00',1.41),('8537','2013-05-07','11:10:00',1.47),('8537','2013-05-07','11:15:00',1.59),('8537','2013-05-07','11:20:00',1.94),('8537','2013-05-07','11:25:00',2.95),('8537','2013-05-07','11:30:00',1.04),('8537','2013-05-07','12:05:00',1.07),('8537','2013-05-07','12:10:00',5),('8537','2013-05-07','12:15:00',1.28),('8537','2013-05-07','12:20:00',1.29),('8537','2013-05-07','12:25:00',3.53),('8537','2013-05-07','12:30:00',3.59),('8537','2013-05-07','12:35:00',1.22),('8537','2013-05-07','12:40:00',1.07),('8537','2013-05-07','13:15:00',1.32),('8537','2013-05-07','13:20:00',1.55),('8537','2013-05-07','13:25:00',1.74),('8537','2013-05-07','13:30:00',3.97),('8537','2013-05-07','13:35:00',3.84),('8537','2013-05-07','13:40:00',5),('8537','2013-05-07','13:45:00',5.27),('8537','2013-05-07','13:50:00',5.56),('8537','2013-05-07','13:55:00',5.59),('8537','2013-05-07','14:00:00',5.42),('8537','2013-05-07','14:05:00',5.36),('8537','2013-05-07','14:10:00',5.36),('8537','2013-05-07','14:15:00',5.36),('8537','2013-05-07','14:20:00',5.33),('8537','2013-05-07','14:25:00',5.29),('8537','2013-05-07','14:30:00',4),('8537','2013-05-07','14:35:00',5.18),('8537','2013-05-07','14:40:00',5.32),('8537','2013-05-07','14:45:00',5.15),('8537','2013-05-07','14:50:00',4.71),('8537','2013-05-07','14:55:00',4.85),('8537','2013-05-07','15:00:00',4.97),('8537','2013-05-07','15:05:00',4.87),('8537','2013-05-07','15:10:00',3.77),('8537','2013-05-07','15:15:00',4.5),('8537','2013-05-07','15:20:00',4.26),('8537','2013-05-07','15:25:00',3.12),('8537','2013-05-07','15:30:00',3.24),('8537','2013-05-07','15:35:00',2.86),('8537','2013-05-07','15:40:00',2.28),('8537','2013-05-07','15:45:00',2.37),('8537','2013-05-07','15:50:00',1.75),('8537','2013-05-07','15:55:00',2.2),('8537','2013-05-07','16:00:00',3.63),('8537','2013-05-07','16:05:00',3.12),('8537','2013-05-07','16:10:00',1.43),('8537','2013-05-07','16:15:00',2.53),('8537','2013-05-07','16:20:00',3.62),('8537','2013-05-07','16:25:00',3.39),('8537','2013-05-07','16:30:00',3.4),('8537','2013-05-07','16:35:00',4.02),('8537','2013-05-07','16:40:00',4.1),('8537','2013-05-07','16:45:00',3.11),('8537','2013-05-07','16:50:00',3.58),('8537','2013-05-07','16:55:00',2.79),('8537','2013-05-07','17:00:00',2.6),('8537','2013-05-07','17:05:00',2.81),('8537','2013-05-07','17:10:00',1.91),('8537','2013-05-07','17:15:00',1.41),('8537','2013-05-07','17:20:00',1.35),('8537','2013-05-07','17:25:00',1.41),('8537','2013-05-07','17:30:00',1.22),('8537','2013-05-07','17:35:00',1.17),('8537','2013-05-07','17:40:00',1.1),('8537','2013-05-07','17:45:00',1),('8537','2013-05-06','08:25:00',1.3),('8537','2013-05-06','08:30:00',1.51),('8537','2013-05-06','08:35:00',1.26),('8537','2013-05-06','08:40:00',1.05),('8537','2013-05-06','08:50:00',1.24),('8537','2013-05-06','08:55:00',2.07),('8537','2013-05-06','09:00:00',2.45),('8537','2013-05-06','09:05:00',1.6),('8537','2013-05-06','09:10:00',1.76),('8537','2013-05-06','09:15:00',1.52),('8537','2013-05-06','09:20:00',1.41),('8537','2013-05-06','09:25:00',1.21),('8537','2013-05-06','09:30:00',1.07),('8537','2013-05-06','09:55:00',1.19),('8537','2013-05-06','10:00:00',1.86),('8537','2013-05-06','10:05:00',1.5),('8537','2013-05-06','10:10:00',1.34),('8537','2013-05-06','10:15:00',1.75),('8537','2013-05-06','10:20:00',2.33),('8537','2013-05-06','10:25:00',1.99),('8537','2013-05-06','10:30:00',2.2),('8537','2013-05-06','10:35:00',2.04),('8537','2013-05-06','10:40:00',2.02),('8537','2013-05-06','10:45:00',3.56),('8537','2013-05-06','10:50:00',2.84),('8537','2013-05-06','10:55:00',2.36),('8537','2013-05-06','11:00:00',2.35),('8537','2013-05-06','11:05:00',2.37),('8537','2013-05-06','11:10:00',2.24),('8537','2013-05-06','11:15:00',2.08),('8537','2013-05-06','11:20:00',2.44),('8537','2013-05-06','11:25:00',2.54),('8537','2013-05-06','11:30:00',2.38),('8537','2013-05-06','11:35:00',2.25),('8537','2013-05-06','11:40:00',3.47),('8537','2013-05-06','11:45:00',4.5),('8537','2013-05-06','11:50:00',3.06),('8537','2013-05-06','11:55:00',2.03),('8537','2013-05-06','12:00:00',2.29),('8537','2013-05-06','12:05:00',2.11),('8537','2013-05-06','12:10:00',4.39),('8537','2013-05-06','12:15:00',2.86),('8537','2013-05-06','12:20:00',2.94),('8537','2013-05-06','12:25:00',4.63),('8537','2013-05-06','12:30:00',3.42),('8537','2013-05-06','12:35:00',4.81),('8537','2013-05-06','12:40:00',3.99),('8537','2013-05-06','12:45:00',2.32),('8537','2013-05-06','12:50:00',3.03),('8537','2013-05-06','12:55:00',4.61),('8537','2013-05-06','13:00:00',2.23),('8537','2013-05-06','13:05:00',2.87),('8537','2013-05-06','13:10:00',4.82),('8537','2013-05-06','13:15:00',3.84),('8537','2013-05-06','13:20:00',5.33),('8537','2013-05-06','13:25:00',3.52),('8537','2013-05-06','13:30:00',4.53),('8537','2013-05-06','13:35:00',2.56),('8537','2013-05-06','13:40:00',4.97),('8537','2013-05-06','13:45:00',4.69),('8537','2013-05-06','13:50:00',5.88),('8537','2013-05-06','13:55:00',5.07),('8537','2013-05-06','14:00:00',4.66),('8537','2013-05-06','14:05:00',5.01),('8537','2013-05-06','14:10:00',3.3),('8537','2013-05-06','14:15:00',5.31),('8537','2013-05-06','14:20:00',5),('8537','2013-05-06','14:25:00',2.89),('8537','2013-05-06','14:30:00',4.5),('8537','2013-05-06','14:35:00',5.13),('8537','2013-05-06','14:40:00',3.88),('8537','2013-05-06','14:45:00',3.39),('8537','2013-05-06','14:50:00',4.09),('8537','2013-05-06','14:55:00',4.7),('8537','2013-05-06','15:00:00',3.32),('8537','2013-05-06','15:05:00',2.15),('8537','2013-05-06','15:10:00',3.26),('8537','2013-05-06','15:15:00',3.83),('8537','2013-05-06','15:20:00',2.58),('8537','2013-05-06','15:25:00',1.91),('8537','2013-05-06','15:30:00',2.92),('8537','2013-05-06','15:35:00',2.67),('8537','2013-05-06','15:40:00',2.68),('8537','2013-05-06','15:45:00',1.57),('8537','2013-05-06','15:50:00',1.78),('8537','2013-05-06','15:55:00',2.62),('8537','2013-05-06','16:00:00',1.72),('8537','2013-05-06','16:05:00',1.74),('8537','2013-05-06','16:10:00',1.52),('8537','2013-05-06','16:15:00',1.5),('8537','2013-05-06','16:20:00',2.13),('8537','2013-05-06','16:25:00',2.15),('8537','2013-05-06','16:30:00',4.11),('8537','2013-05-06','16:35:00',2.22),('8537','2013-05-06','16:40:00',2.87),('8537','2013-05-06','16:45:00',2.05),('8537','2013-05-06','16:50:00',2.6),('8537','2013-05-06','16:55:00',2.91),('8537','2013-05-06','17:00:00',1.54),('8537','2013-05-06','17:15:00',1.69),('8537','2013-05-06','17:20:00',1.24),('8537','2013-05-06','17:35:00',1.52),('8537','2013-05-06','17:40:00',1.56),('8537','2013-05-06','17:45:00',1.16),('8537','2013-05-06','17:50:00',1.21),('8537','2013-05-06','18:00:00',1.05),('8537','2013-05-06','18:05:00',1.26),('8537','2013-05-06','18:20:00',1.06),('8537','2013-05-05','07:45:00',1.19),('8537','2013-05-05','07:50:00',1.25),('8537','2013-05-05','07:55:00',1.27),('8537','2013-05-05','08:00:00',1.4),('8537','2013-05-05','08:05:00',1.57),('8537','2013-05-05','08:10:00',1.7),('8537','2013-05-05','08:15:00',1.83),('8537','2013-05-05','08:20:00',2.11),('8537','2013-05-05','08:25:00',2.49),('8537','2013-05-05','08:30:00',2.58),('8537','2013-05-05','08:35:00',2.35),('8537','2013-05-05','08:40:00',2.49),('8537','2013-05-05','08:45:00',2),('8537','2013-05-05','08:50:00',1.61),('8537','2013-05-05','08:55:00',1.49),('8537','2013-05-05','09:00:00',1.62),('8537','2013-05-05','09:05:00',1.74),('8537','2013-05-05','09:10:00',1.99),('8537','2013-05-05','09:15:00',2.2),('8537','2013-05-05','09:20:00',1.88),('8537','2013-05-05','09:25:00',1.93),('8537','2013-05-05','09:30:00',2.1),('8537','2013-05-05','09:35:00',1.82),('8537','2013-05-05','09:40:00',2.4),('8537','2013-05-05','09:45:00',3.36),('8537','2013-05-05','09:50:00',2.69),('8537','2013-05-05','09:55:00',4.39),('8537','2013-05-05','10:00:00',2.97),('8537','2013-05-05','10:05:00',2.99),('8537','2013-05-05','10:10:00',2.71),('8537','2013-05-05','10:15:00',2.46),('8537','2013-05-05','10:20:00',4.21),('8537','2013-05-05','10:25:00',2.87),('8537','2013-05-05','10:30:00',3.07),('8537','2013-05-05','10:35:00',2.86),('8537','2013-05-05','10:40:00',2.94),('8537','2013-05-05','10:45:00',3.02),('8537','2013-05-05','10:50:00',2.28),('8537','2013-05-05','10:55:00',1.97),('8537','2013-05-05','11:00:00',1.83),('8537','2013-05-05','11:05:00',2.21),('8537','2013-05-05','11:10:00',2.05),('8537','2013-05-05','11:15:00',2.07),('8537','2013-05-05','11:20:00',2.91),('8537','2013-05-05','11:25:00',4.18),('8537','2013-05-05','11:30:00',3.27),('8537','2013-05-05','11:35:00',4.5),('8537','2013-05-05','11:40:00',3.68),('8537','2013-05-05','11:45:00',3.49),('8537','2013-05-05','11:50:00',3.18),('8537','2013-05-05','11:55:00',4.06),('8537','2013-05-05','12:00:00',3.11),('8537','2013-05-05','12:05:00',3.3),('8537','2013-05-05','12:10:00',2.95),('8537','2013-05-05','12:15:00',3.67),('8537','2013-05-05','12:20:00',3.56),('8537','2013-05-05','12:25:00',4.47),('8537','2013-05-05','12:30:00',4.95),('8537','2013-05-05','12:35:00',4.67),('8537','2013-05-05','12:40:00',4.73),('8537','2013-05-05','12:45:00',4.54),('8537','2013-05-05','12:50:00',4.62),('8537','2013-05-05','12:55:00',4.55),('8537','2013-05-05','13:00:00',5.1),('8537','2013-05-05','13:05:00',5.14),('8537','2013-05-05','13:10:00',4.58),('8537','2013-05-05','13:15:00',5.42),('8537','2013-05-05','13:20:00',3.96),('8537','2013-05-05','13:25:00',2.48),('8537','2013-05-05','13:30:00',1.87),('8537','2013-05-05','13:35:00',4.78),('8537','2013-05-05','13:40:00',5.33),('8537','2013-05-05','13:45:00',5.12),('8537','2013-05-05','13:50:00',5.14),('8537','2013-05-05','13:55:00',5.16),('8537','2013-05-05','14:00:00',5.23),('8537','2013-05-05','14:05:00',5.37),('8537','2013-05-05','14:10:00',4.09),('8537','2013-05-05','14:15:00',3.72),('8537','2013-05-05','14:20:00',4.79),('8537','2013-05-05','14:25:00',4.69),('8537','2013-05-05','14:30:00',4.56),('8537','2013-05-05','14:35:00',4.36),('8537','2013-05-05','14:40:00',4.06),('8537','2013-05-05','14:45:00',4.38),('8537','2013-05-05','14:50:00',4.31),('8537','2013-05-05','14:55:00',4.28),('8537','2013-05-05','15:00:00',4.25),('8537','2013-05-05','15:05:00',4.2),('8537','2013-05-05','15:10:00',4.15),('8537','2013-05-05','15:15:00',4.03),('8537','2013-05-05','15:20:00',4.03),('8537','2013-05-05','15:25:00',4),('8537','2013-05-05','15:30:00',3.82),('8537','2013-05-05','15:35:00',3.79),('8537','2013-05-05','15:40:00',3.78),('8537','2013-05-05','15:45:00',3.74),('8537','2013-05-05','15:50:00',3.67),('8537','2013-05-05','15:55:00',3.6),('8537','2013-05-05','16:00:00',3.56),('8537','2013-05-05','16:05:00',3.49),('8537','2013-05-05','16:10:00',3.39),('8537','2013-05-05','16:15:00',3.31),('8537','2013-05-05','16:20:00',3.24),('8537','2013-05-05','16:25:00',3.16),('8537','2013-05-05','16:30:00',3.07),('8537','2013-05-05','16:35:00',3),('8537','2013-05-05','16:40:00',2.92),('8537','2013-05-05','16:45:00',2.83),('8537','2013-05-05','16:50:00',2.71),('8537','2013-05-05','16:55:00',2.62),('8537','2013-05-05','17:00:00',2.51),('8537','2013-05-05','17:05:00',2.42),('8537','2013-05-05','17:10:00',2.27),('8537','2013-05-05','17:15:00',2.18),('8537','2013-05-05','17:20:00',2.09),('8537','2013-05-05','17:25:00',1.99),('8537','2013-05-05','17:30:00',1.89),('8537','2013-05-05','17:35:00',1.77),('8537','2013-05-05','17:40:00',1.67),('8537','2013-05-05','17:45:00',1.57),('8537','2013-05-05','17:50:00',1.48),('8537','2013-05-05','17:55:00',1.37),('8537','2013-05-05','18:00:00',1.28),('8537','2013-05-05','18:05:00',1.17),('8537','2013-05-05','18:10:00',1.08),('8537','2013-05-04','07:40:00',1.04),('8537','2013-05-04','07:45:00',1.06),('8537','2013-05-04','07:50:00',1.13),('8537','2013-05-04','07:55:00',1.32),('8537','2013-05-04','08:00:00',1.45),('8537','2013-05-04','08:05:00',1.53),('8537','2013-05-04','08:10:00',1.62),('8537','2013-05-04','08:15:00',1.72),('8537','2013-05-04','08:20:00',1.82),('8537','2013-05-04','08:25:00',1.89),('8537','2013-05-04','08:30:00',1.99),('8537','2013-05-04','08:35:00',2.09),('8537','2013-05-04','08:40:00',2.2),('8537','2013-05-04','08:45:00',2.33),('8537','2013-05-04','08:50:00',2.42),('8537','2013-05-04','08:55:00',2.51),('8537','2013-05-04','09:00:00',2.59),('8537','2013-05-04','09:05:00',2.71),('8537','2013-05-04','09:10:00',2.79),('8537','2013-05-04','09:15:00',2.87),('8537','2013-05-04','09:20:00',3),('8537','2013-05-04','09:25:00',3.05),('8537','2013-05-04','09:30:00',3.1),('8537','2013-05-04','09:35:00',3.23),('8537','2013-05-04','09:40:00',3.33),('8537','2013-05-04','09:45:00',3.45),('8537','2013-05-04','09:50:00',3.52),('8537','2013-05-04','09:55:00',3.57),('8537','2013-05-04','10:00:00',3.69),('8537','2013-05-04','10:05:00',3.74),('8537','2013-05-04','10:10:00',3.84),('8537','2013-05-04','10:15:00',3.9),('8537','2013-05-04','10:20:00',3.97),('8537','2013-05-04','10:25:00',3.98),('8537','2013-05-04','10:30:00',4.1),('8537','2013-05-04','10:35:00',4.14),('8537','2013-05-04','10:40:00',4.12),('8537','2013-05-04','10:45:00',4.1),('8537','2013-05-04','10:50:00',4.13),('8537','2013-05-04','10:55:00',4.07),('8537','2013-05-04','11:00:00',4.16),('8537','2013-05-04','11:05:00',4.18),('8537','2013-05-04','11:10:00',3.99),('8537','2013-05-04','11:15:00',3.82),('8537','2013-05-04','11:20:00',4.14),('8537','2013-05-04','11:25:00',4.17),('8537','2013-05-04','11:30:00',4.03),('8537','2013-05-04','11:35:00',4.15),('8537','2013-05-04','11:40:00',3.98),('8537','2013-05-04','11:45:00',4.09),('8537','2013-05-04','11:50:00',4.12),('8537','2013-05-04','11:55:00',4.11),('8537','2013-05-04','12:00:00',4.08),('8537','2013-05-04','12:05:00',4.21),('8537','2013-05-04','12:10:00',4.24),('8537','2013-05-04','12:15:00',4.4),('8537','2013-05-04','12:20:00',4.48),('8537','2013-05-04','12:25:00',4.56),('8537','2013-05-04','12:30:00',4.6),('8537','2013-05-04','12:35:00',4.64),('8537','2013-05-04','12:40:00',4.62),('8537','2013-05-04','12:45:00',4.63),('8537','2013-05-04','12:50:00',4.47),('8537','2013-05-04','12:55:00',4.38),('8537','2013-05-04','13:00:00',4.28),('8537','2013-05-04','13:05:00',3.93),('8537','2013-05-04','13:10:00',4.28),('8537','2013-05-04','13:15:00',4.83),('8537','2013-05-04','13:20:00',4.86),('8537','2013-05-04','13:25:00',4.57),('8537','2013-05-04','13:30:00',4.64),('8537','2013-05-04','13:35:00',4.41),('8537','2013-05-04','13:40:00',4.48),('8537','2013-05-04','13:45:00',4.43),('8537','2013-05-04','13:50:00',3.96),('8537','2013-05-04','13:55:00',4.23),('8537','2013-05-04','14:00:00',4.34),('8537','2013-05-04','14:05:00',4.42),('8537','2013-05-04','14:10:00',4.16),('8537','2013-05-04','14:15:00',4.25),('8537','2013-05-04','14:20:00',4.29),('8537','2013-05-04','14:25:00',4.04),('8537','2013-05-04','14:30:00',4.19),('8537','2013-05-04','14:35:00',3.87),('8537','2013-05-04','14:40:00',4.04),('8537','2013-05-04','14:45:00',3.99),('8537','2013-05-04','14:50:00',3.78),('8537','2013-05-04','14:55:00',3.89),('8537','2013-05-04','15:00:00',3.92),('8537','2013-05-04','15:05:00',3.97),('8537','2013-05-04','15:10:00',3.72),('8537','2013-05-04','15:15:00',3.85),('8537','2013-05-04','15:20:00',3.93),('8537','2013-05-04','15:25:00',3.94),('8537','2013-05-04','15:30:00',3.73),('8537','2013-05-04','15:35:00',3.62),('8537','2013-05-04','15:40:00',3.66),('8537','2013-05-04','15:45:00',3.66),('8537','2013-05-04','15:50:00',3.61),('8537','2013-05-04','15:55:00',3.52),('8537','2013-05-04','16:00:00',3.43),('8537','2013-05-04','16:05:00',3.37),('8537','2013-05-04','16:10:00',3.24),('8537','2013-05-04','16:15:00',3.15),('8537','2013-05-04','16:20:00',3.09),('8537','2013-05-04','16:25:00',3.02),('8537','2013-05-04','16:30:00',2.94),('8537','2013-05-04','16:35:00',2.88),('8537','2013-05-04','16:40:00',2.79),('8537','2013-05-04','16:45:00',2.7),('8537','2013-05-04','16:50:00',2.56),('8537','2013-05-04','16:55:00',2.48),('8537','2013-05-04','17:00:00',2.41),('8537','2013-05-04','17:05:00',2.27),('8537','2013-05-04','17:10:00',1.74),('8537','2013-05-04','17:15:00',1.97),('8537','2013-05-04','17:20:00',2.03),('8537','2013-05-04','17:25:00',1.93),('8537','2013-05-04','17:30:00',1.81),('8537','2013-05-04','17:35:00',1.65),('8537','2013-05-04','17:40:00',1.5),('8537','2013-05-04','17:45:00',1.46),('8537','2013-05-04','17:50:00',1.44),('8537','2013-05-04','17:55:00',1.36),('8537','2013-05-04','18:00:00',1.27),('8537','2013-05-04','18:05:00',1.18),('8537','2013-05-04','18:10:00',1.01),('8537','2013-05-03','08:00:00',1.04),('8537','2013-05-03','08:05:00',1.51),('8537','2013-05-03','08:10:00',1.79),('8537','2013-05-03','08:15:00',2.03),('8537','2013-05-03','08:20:00',1.99),('8537','2013-05-03','08:25:00',2.15),('8537','2013-05-03','08:30:00',2.24),('8537','2013-05-03','08:35:00',2.31),('8537','2013-05-03','08:40:00',2.39),('8537','2013-05-03','08:45:00',2.48),('8537','2013-05-03','08:50:00',2.45),('8537','2013-05-03','08:55:00',2.49),('8537','2013-05-03','09:00:00',2.64),('8537','2013-05-03','09:05:00',2.82),('8537','2013-05-03','09:10:00',2.87),('8537','2013-05-03','09:15:00',2.96),('8537','2013-05-03','09:20:00',3.04),('8537','2013-05-03','09:25:00',3.13),('8537','2013-05-03','09:30:00',3.24),('8537','2013-05-03','09:35:00',3.37),('8537','2013-05-03','09:40:00',3.45),('8537','2013-05-03','09:45:00',3.52),('8537','2013-05-03','09:50:00',3.61),('8537','2013-05-03','09:55:00',3.68),('8537','2013-05-03','10:00:00',3.77),('8537','2013-05-03','10:05:00',3.84),('8537','2013-05-03','10:10:00',3.86),('8537','2013-05-03','10:15:00',3.89),('8537','2013-05-03','10:20:00',3.96),('8537','2013-05-03','10:25:00',4.05),('8537','2013-05-03','10:30:00',4.14),('8537','2013-05-03','10:35:00',4.21),('8537','2013-05-03','10:40:00',4.23),('8537','2013-05-03','10:45:00',4.24),('8537','2013-05-03','10:50:00',4.31),('8537','2013-05-03','10:55:00',4.34),('8537','2013-05-03','11:00:00',4.36),('8537','2013-05-03','11:05:00',4.37),('8537','2013-05-03','11:10:00',4.45),('8537','2013-05-03','11:15:00',4.54),('8537','2013-05-03','11:20:00',4.57),('8537','2013-05-03','11:25:00',4.66),('8537','2013-05-03','11:30:00',4.68),('8537','2013-05-03','11:35:00',4.71),('8537','2013-05-03','11:40:00',4.75),('8537','2013-05-03','11:45:00',4.76),('8537','2013-05-03','11:50:00',4.73),('8537','2013-05-03','11:55:00',4.75),('8537','2013-05-03','12:00:00',4.78),('8537','2013-05-03','12:05:00',4.8),('8537','2013-05-03','12:10:00',4.89),('8537','2013-05-03','12:15:00',4.87),('8537','2013-05-03','12:20:00',4.86),('8537','2013-05-03','12:25:00',4.84),('8537','2013-05-03','12:30:00',4.83),('8537','2013-05-03','12:35:00',4.82),('8537','2013-05-03','12:40:00',4.83),('8537','2013-05-03','12:45:00',4.84),('8537','2013-05-03','12:50:00',4.95),('8537','2013-05-03','12:55:00',4.89),('8537','2013-05-03','13:00:00',4.86),('8537','2013-05-03','13:05:00',4.87),('8537','2013-05-03','13:10:00',4.87),('8537','2013-05-03','13:15:00',4.86),('8537','2013-05-03','13:20:00',4.88),('8537','2013-05-03','13:25:00',4.93),('8537','2013-05-03','13:30:00',4.85),('8537','2013-05-03','13:35:00',4.72),('8537','2013-05-03','13:40:00',4.65),('8537','2013-05-03','13:45:00',4.64),('8537','2013-05-03','13:50:00',4.63),('8537','2013-05-03','13:55:00',4.69),('8537','2013-05-03','14:00:00',4.65),('8537','2013-05-03','14:05:00',4.42),('8537','2013-05-03','14:10:00',4.53),('8537','2013-05-03','14:15:00',4.36),('8537','2013-05-03','14:20:00',4.5),('8537','2013-05-03','14:25:00',4.47),('8537','2013-05-03','14:30:00',4.41),('8537','2013-05-03','14:35:00',4.41),('8537','2013-05-03','14:40:00',4.31),('8537','2013-05-03','14:45:00',4.24),('8537','2013-05-03','14:50:00',4.2),('8537','2013-05-03','14:55:00',4.23),('8537','2013-05-03','15:00:00',4.23),('8537','2013-05-03','15:05:00',4.13),('8537','2013-05-03','15:10:00',4.14),('8537','2013-05-03','15:15:00',4.12),('8537','2013-05-03','15:20:00',4.06),('8537','2013-05-03','15:25:00',4),('8537','2013-05-03','15:30:00',3.83),('8537','2013-05-03','15:35:00',3.87),('8537','2013-05-03','15:40:00',3.8),('8537','2013-05-03','15:45:00',3.75),('8537','2013-05-03','15:50:00',3.64),('8537','2013-05-03','15:55:00',3.58),('8537','2013-05-03','16:00:00',3.55),('8537','2013-05-03','16:05:00',3.5),('8537','2013-05-03','16:10:00',3.38),('8537','2013-05-03','16:15:00',3.28),('8537','2013-05-03','16:20:00',3.12),('8537','2013-05-03','16:25:00',3.05),('8537','2013-05-03','16:30:00',3.05),('8537','2013-05-03','16:35:00',3),('8537','2013-05-03','16:40:00',2.89),('8537','2013-05-03','16:45:00',2.79),('8537','2013-05-03','16:50:00',2.66),('8537','2013-05-03','16:55:00',2.58),('8537','2013-05-03','17:00:00',2.49),('8537','2013-05-03','17:05:00',2.38),('8537','2013-05-03','17:10:00',2.22),('8537','2013-05-03','17:15:00',2.13),('8537','2013-05-03','17:20:00',2.01),('8537','2013-05-03','17:25:00',1.89),('8537','2013-05-03','17:30:00',1.78),('8537','2013-05-03','17:35:00',1.65),('8537','2013-05-03','17:40:00',1.53),('8537','2013-05-03','17:45:00',1.42),('8537','2013-05-03','17:50:00',1.36),('8537','2013-05-03','17:55:00',1.27),('8537','2013-05-03','18:00:00',1.21),('8537','2013-05-03','18:05:00',1.09),('8537','2013-05-03','18:10:00',1.03),('8537','2013-05-02','08:55:00',1.37),('8537','2013-05-02','09:00:00',2.3),('8537','2013-05-02','09:05:00',1.97),('8537','2013-05-02','09:10:00',1.06),('8537','2013-05-02','09:20:00',1.12),('8537','2013-05-02','09:25:00',1.91),('8537','2013-05-02','09:30:00',2.25),('8537','2013-05-02','09:35:00',2.4),('8537','2013-05-02','09:40:00',1.74),('8537','2013-05-02','09:45:00',3.05),('8537','2013-05-02','09:50:00',1.52),('8537','2013-05-02','09:55:00',1.16),('8537','2013-05-02','10:00:00',1.24),('8537','2013-05-02','10:05:00',1.77),('8537','2013-05-02','10:10:00',1.7),('8537','2013-05-02','10:15:00',1.75),('8537','2013-05-02','10:20:00',1.82),('8537','2013-05-02','10:25:00',2.23),('8537','2013-05-02','10:30:00',3.52),('8537','2013-05-02','10:35:00',3.21),('8537','2013-05-02','10:40:00',4.41),('8537','2013-05-02','10:45:00',3.21),('8537','2013-05-02','10:50:00',4.05),('8537','2013-05-02','10:55:00',4.66),('8537','2013-05-02','11:00:00',4.84),('8537','2013-05-02','11:05:00',4.53),('8537','2013-05-02','11:10:00',3.54),('8537','2013-05-02','11:15:00',3.46),('8537','2013-05-02','11:20:00',3.25),('8537','2013-05-02','11:25:00',4.78),('8537','2013-05-02','11:30:00',4.79),('8537','2013-05-02','11:35:00',4.68),('8537','2013-05-02','11:40:00',4.63),('8537','2013-05-02','11:45:00',4.61),('8537','2013-05-02','11:50:00',4.62),('8537','2013-05-02','11:55:00',4.65),('8537','2013-05-02','12:00:00',4.65),('8537','2013-05-02','12:05:00',4.61),('8537','2013-05-02','12:10:00',4.58),('8537','2013-05-02','12:15:00',4.61),('8537','2013-05-02','12:20:00',4.54),('8537','2013-05-02','12:25:00',4.65),('8537','2013-05-02','12:30:00',4.74),('8537','2013-05-02','12:35:00',4.78),('8537','2013-05-02','12:40:00',4.84),('8537','2013-05-02','12:45:00',4.83),('8537','2013-05-02','12:50:00',4.85),('8537','2013-05-02','12:55:00',4.88),('8537','2013-05-02','13:00:00',4.92),('8537','2013-05-02','13:05:00',4.96),('8537','2013-05-02','13:10:00',4.98),('8537','2013-05-02','13:15:00',4.98),('8537','2013-05-02','13:20:00',4.99),('8537','2013-05-02','13:25:00',4.98),('8537','2013-05-02','13:30:00',4.97),('8537','2013-05-02','13:35:00',4.95),('8537','2013-05-02','13:40:00',4.95),('8537','2013-05-02','13:45:00',4.94),('8537','2013-05-02','13:50:00',4.91),('8537','2013-05-02','13:55:00',4.91),('8537','2013-05-02','14:00:00',4.84),('8537','2013-05-02','14:05:00',4.76),('8537','2013-05-02','14:10:00',4.73),('8537','2013-05-02','14:15:00',4.71),('8537','2013-05-02','14:20:00',4.67),('8537','2013-05-02','14:25:00',4.62),('8537','2013-05-02','14:30:00',4.58),('8537','2013-05-02','14:35:00',4.52),('8537','2013-05-02','14:40:00',4.5),('8537','2013-05-02','14:45:00',4.47),('8537','2013-05-02','14:50:00',4.44),('8537','2013-05-02','14:55:00',4.41),('8537','2013-05-02','15:00:00',4.35),('8537','2013-05-02','15:05:00',4.28),('8537','2013-05-02','15:10:00',4.24),('8537','2013-05-02','15:15:00',4.18),('8537','2013-05-02','15:20:00',4.07),('8537','2013-05-02','15:25:00',4.04),('8537','2013-05-02','15:30:00',3.8),('8537','2013-05-02','15:35:00',3.8),('8537','2013-05-02','15:40:00',3.74),('8537','2013-05-02','15:45:00',3.67),('8537','2013-05-02','15:50:00',3.65),('8537','2013-05-02','15:55:00',3.56),('8537','2013-05-02','16:00:00',3.5),('8537','2013-05-02','16:05:00',3.46),('8537','2013-05-02','16:10:00',3.35),('8537','2013-05-02','16:15:00',3.27),('8537','2013-05-02','16:20:00',3.19),('8537','2013-05-02','16:25:00',3.13),('8537','2013-05-02','16:30:00',3.04),('8537','2013-05-02','16:35:00',2.93),('8537','2013-05-02','16:40:00',2.86),('8537','2013-05-02','16:45:00',2.76),('8537','2013-05-02','16:50:00',2.65),('8537','2013-05-02','16:55:00',2.57),('8537','2013-05-02','17:00:00',2.49),('8537','2013-05-02','17:05:00',2.39),('8537','2013-05-02','17:10:00',2.23),('8537','2013-05-02','17:15:00',2.16),('8537','2013-05-02','17:20:00',2.07),('8537','2013-05-02','17:25:00',1.98),('8537','2013-05-02','17:30:00',1.87),('8537','2013-05-02','17:35:00',1.76),('8537','2013-05-02','17:40:00',1.64),('8537','2013-05-02','17:45:00',1.56),('8537','2013-05-02','17:50:00',1.47),('8537','2013-05-02','17:55:00',1.37),('8537','2013-05-02','18:00:00',1.27),('8537','2013-05-02','18:05:00',1.17),('8537','2013-05-02','18:10:00',1.08),('8537','2014-03-30','08:10:00',1.02),('8537','2014-03-30','08:15:00',1.14),('8537','2014-03-30','08:20:00',1.31),('8537','2014-03-30','08:25:00',1.46),('8537','2014-03-30','08:30:00',1.54),('8537','2014-03-30','08:35:00',1.65),('8537','2014-03-30','08:40:00',1.67),('8537','2014-03-30','08:45:00',1.65),('8537','2014-03-30','08:50:00',1.65),('8537','2014-03-30','08:55:00',1.73),('8537','2014-03-30','09:00:00',1.8),('8537','2014-03-30','09:05:00',1.8),('8537','2014-03-30','09:10:00',1.76),('8537','2014-03-30','09:15:00',1.69),('8537','2014-03-30','09:20:00',1.99),('8537','2014-03-30','09:25:00',2.11),('8537','2014-03-30','09:30:00',2.44),('8537','2014-03-30','09:35:00',2.64),('8537','2014-03-30','09:40:00',2.74),('8537','2014-03-30','09:45:00',2.8),('8537','2014-03-30','09:50:00',2.89),('8537','2014-03-30','09:55:00',2.89),('8537','2014-03-30','10:00:00',2.89),('8537','2014-03-30','10:05:00',3.27),('8537','2014-03-30','10:10:00',3.33),('8537','2014-03-30','10:15:00',3.31),('8537','2014-03-30','10:20:00',3.35),('8537','2014-03-30','10:25:00',3.48),('8537','2014-03-30','10:30:00',3.62),('8537','2014-03-30','10:35:00',3.71),('8537','2014-03-30','10:40:00',3.82),('8537','2014-03-30','10:45:00',3.81),('8537','2014-03-30','10:50:00',3.81),('8537','2014-03-30','10:55:00',3.87),('8537','2014-03-30','11:00:00',3.86),('8537','2014-03-30','11:05:00',3.83),('8537','2014-03-30','11:10:00',3.9),('8537','2014-03-30','11:15:00',3.81),('8537','2014-03-30','11:20:00',3.73),('8537','2014-03-30','11:25:00',3.9),('8537','2014-03-30','11:30:00',4.05),('8537','2014-03-30','11:35:00',4.12),('8537','2014-03-30','11:40:00',4.32),('8537','2014-03-30','11:45:00',4.41),('8537','2014-03-30','11:50:00',4.52),('8537','2014-03-30','11:55:00',4.59),('8537','2014-03-30','12:00:00',4.62),('8537','2014-03-30','12:05:00',4.8),('8537','2014-03-30','12:10:00',4.9),('8537','2014-03-30','12:15:00',5.01),('8537','2014-03-30','12:20:00',4.94),('8537','2014-03-30','12:25:00',4.91),('8537','2014-03-30','12:30:00',4.49),('8537','2014-03-30','12:35:00',4.5),('8537','2014-03-30','12:40:00',4.82),('8537','2014-03-30','12:45:00',4.69),('8537','2014-03-30','12:50:00',4.78),('8537','2014-03-30','12:55:00',4.8),('8537','2014-03-30','13:00:00',4.97),('8537','2014-03-30','13:05:00',5),('8537','2014-03-30','13:10:00',4.99),('8537','2014-03-30','13:15:00',4.96),('8537','2014-03-30','13:20:00',4.95),('8537','2014-03-30','13:25:00',4.95),('8537','2014-03-30','13:30:00',4.97),('8537','2014-03-30','13:35:00',5.02),('8537','2014-03-30','13:40:00',4.99),('8537','2014-03-30','13:45:00',5.01),('8537','2014-03-30','13:50:00',4.98),('8537','2014-03-30','13:55:00',4.86),('8537','2014-03-30','14:00:00',4.78),('8537','2014-03-30','14:05:00',4.85),('8537','2014-03-30','14:10:00',4.68),('8537','2014-03-30','14:15:00',4.63),('8537','2014-03-30','14:20:00',4.76),('8537','2014-03-30','14:25:00',4.81),('8537','2014-03-30','14:30:00',4.74),('8537','2014-03-30','14:35:00',4.72),('8537','2014-03-30','14:40:00',4.42),('8537','2014-03-30','14:45:00',4.09),('8537','2014-03-30','14:50:00',3.6),('8537','2014-03-30','14:55:00',3.06),('8537','2014-03-30','15:00:00',2.53),('8537','2014-03-30','15:05:00',1.88),('8537','2014-03-30','15:10:00',1.46),('8537','2014-03-30','15:15:00',1.58),('8537','2014-03-30','15:20:00',2.76),('8537','2014-03-30','15:25:00',3.4),('8537','2014-03-30','15:30:00',3.19),('8537','2014-03-30','15:35:00',3.67),('8537','2014-03-30','15:40:00',3.67),('8537','2014-03-30','15:45:00',3.72),('8537','2014-03-30','15:50:00',3.7),('8537','2014-03-30','15:55:00',3.54),('8537','2014-03-30','16:00:00',3.36),('8537','2014-03-30','16:05:00',3.02),('8537','2014-03-30','16:10:00',2.98),('8537','2014-03-30','16:15:00',2.89),('8537','2014-03-30','16:20:00',3.14),('8537','2014-03-30','16:25:00',3.16),('8537','2014-03-30','16:30:00',3.04),('8537','2014-03-30','16:35:00',2.99),('8537','2014-03-30','16:40:00',2.48),('8537','2014-03-30','16:45:00',2.34),('8537','2014-03-30','16:50:00',2.32),('8537','2014-03-30','16:55:00',1.88),('8537','2014-03-30','17:00:00',1.93),('8537','2014-03-30','17:05:00',2.17),('8537','2014-03-30','17:10:00',2.24),('8537','2014-03-30','17:15:00',2.2),('8537','2014-03-30','17:20:00',2.08),('8537','2014-03-30','17:25:00',1.78),('8537','2014-03-30','17:30:00',1.76),('8537','2014-03-30','17:35:00',1.64),('8537','2014-03-30','17:40:00',1.45),('8537','2014-03-30','17:45:00',1.42),('8537','2014-03-30','17:50:00',1.2),('8537','2013-05-01','07:50:00',1.07),('8537','2013-05-01','07:55:00',1.18),('8537','2013-05-01','08:00:00',1.27),('8537','2013-05-01','08:05:00',1.34),('8537','2013-05-01','08:10:00',1.41),('8537','2013-05-01','08:15:00',1.53),('8537','2013-05-01','08:20:00',1.65),('8537','2013-05-01','08:25:00',1.76),('8537','2013-05-01','08:30:00',1.87),('8537','2013-05-01','08:35:00',1.98),('8537','2013-05-01','08:40:00',2.06),('8537','2013-05-01','08:45:00',2.15),('8537','2013-05-01','08:50:00',2.29),('8537','2013-05-01','08:55:00',2.39),('8537','2013-05-01','09:00:00',2.5),('8537','2013-05-01','09:05:00',2.58),('8537','2013-05-01','09:10:00',2.67),('8537','2013-05-01','09:15:00',2.73),('8537','2013-05-01','09:20:00',2.79),('8537','2013-05-01','09:25:00',2.86),('8537','2013-05-01','09:30:00',2.9),('8537','2013-05-01','09:35:00',2.96),('8537','2013-05-01','09:40:00',3.07),('8537','2013-05-01','09:45:00',3.16),('8537','2013-05-01','09:50:00',3.19),('8537','2013-05-01','09:55:00',3.26),('8537','2013-05-01','10:00:00',3.33),('8537','2013-05-01','10:05:00',3.36),('8537','2013-05-01','10:10:00',3.47),('8537','2013-05-01','10:15:00',3.57),('8537','2013-05-01','10:20:00',3.6),('8537','2013-05-01','10:25:00',3.68),('8537','2013-05-01','10:30:00',3.73),('8537','2013-05-01','10:35:00',3.77),('8537','2013-05-01','10:40:00',3.94),('8537','2013-05-01','10:45:00',4.11),('8537','2013-05-01','10:50:00',4.17),('8537','2013-05-01','10:55:00',4.2),('8537','2013-05-01','11:00:00',4.25),('8537','2013-05-01','11:05:00',4.28),('8537','2013-05-01','11:10:00',4.3),('8537','2013-05-01','11:15:00',4.03),('8537','2013-05-01','11:20:00',3.96),('8537','2013-05-01','11:25:00',3.92),('8537','2013-05-01','11:30:00',3.87),('8537','2013-05-01','11:35:00',4.06),('8537','2013-05-01','11:40:00',3.38),('8537','2013-05-01','11:45:00',3.27),('8537','2013-05-01','11:50:00',3.93),('8537','2013-05-01','11:55:00',4.6),('8537','2013-05-01','12:00:00',4.54),('8537','2013-05-01','12:05:00',4.47),('8537','2013-05-01','12:10:00',4.5),('8537','2013-05-01','12:15:00',4.5),('8537','2013-05-01','12:20:00',4.57),('8537','2013-05-01','12:25:00',4.65),('8537','2013-05-01','12:30:00',4.64),('8537','2013-05-01','12:35:00',4.67),('8537','2013-05-01','12:40:00',4.77),('8537','2013-05-01','12:45:00',4.35),('8537','2013-05-01','12:50:00',3.82),('8537','2013-05-01','12:55:00',1.74),('8537','2013-05-01','13:00:00',1.99),('8537','2013-05-01','13:05:00',2.1),('8537','2013-05-01','13:10:00',2.77),('8537','2013-05-01','13:15:00',5.02),('8537','2013-05-01','13:20:00',5.36),('8537','2013-05-01','13:25:00',4.46),('8537','2013-05-01','13:30:00',3.25),('8537','2013-05-01','13:35:00',3.88),('8537','2013-05-01','13:40:00',4.85),('8537','2013-05-01','13:45:00',5.08),('8537','2013-05-01','13:50:00',4.77),('8537','2013-05-01','13:55:00',4.64),('8537','2013-05-01','14:00:00',4.58),('8537','2013-05-01','14:05:00',4.47),('8537','2013-05-01','14:10:00',4.48),('8537','2013-05-01','14:15:00',3.85),('8537','2013-05-01','14:20:00',4.65),('8537','2013-05-01','14:25:00',4.65),('8537','2013-05-01','14:30:00',4.65),('8537','2013-05-01','14:35:00',4.36),('8537','2013-05-01','14:40:00',3.97),('8537','2013-05-01','14:45:00',4.18),('8537','2013-05-01','14:50:00',3.54),('8537','2013-05-01','14:55:00',3.27),('8537','2013-05-01','15:00:00',3.53),('8537','2013-05-01','15:05:00',3.93),('8537','2013-05-01','15:10:00',3.95),('8537','2013-05-01','15:15:00',3.84),('8537','2013-05-01','15:20:00',3.67),('8537','2013-05-01','15:25:00',3.79),('8537','2013-05-01','15:30:00',3.11),('8537','2013-05-01','15:35:00',2.66),('8537','2013-05-01','15:40:00',2.66),('8537','2013-05-01','15:45:00',2.63),('8537','2013-05-01','15:50:00',1.97),('8537','2013-05-01','15:55:00',1.9),('8537','2013-05-01','16:00:00',2.24),('8537','2013-05-01','16:05:00',2.17),('8537','2013-05-01','16:10:00',1.97),('8537','2013-05-01','16:15:00',1.79),('8537','2013-05-01','16:20:00',1.56),('8537','2013-05-01','16:25:00',1.26),('8537','2013-05-01','16:30:00',1.19),('8537','2013-05-01','16:35:00',1.25),('8537','2013-05-01','16:40:00',1.34),('8537','2013-05-01','16:45:00',1.26),('8537','2013-05-01','16:50:00',1.11),('8537','2013-05-01','16:55:00',1.01),('8537','2013-05-01','17:00:00',1.04),('8537','2013-05-01','17:05:00',1.05),('8537','2013-05-01','17:10:00',1.07),('8537','2013-05-01','17:15:00',1.06),('8537','2013-04-30','08:35:00',1.03),('8537','2013-04-30','08:45:00',1.03),('8537','2013-04-30','08:50:00',1.29),('8537','2013-04-30','08:55:00',1.84),('8537','2013-04-30','09:00:00',2.03),('8537','2013-04-30','09:05:00',1.8),('8537','2013-04-30','09:10:00',2.49),('8537','2013-04-30','09:15:00',3.01),('8537','2013-04-30','09:20:00',3.07),('8537','2013-04-30','09:25:00',3.28),('8537','2013-04-30','09:30:00',3.2),('8537','2013-04-30','09:35:00',2.66),('8537','2013-04-30','09:40:00',1.91),('8537','2013-04-30','09:45:00',2.34),('8537','2013-04-30','09:50:00',3.06),('8537','2013-04-30','09:55:00',3.4),('8537','2013-04-30','10:00:00',3.93),('8537','2013-04-30','10:05:00',3.87),('8537','2013-04-30','10:10:00',3.34),('8537','2013-04-30','10:15:00',2.87),('8537','2013-04-30','10:20:00',2.58),('8537','2013-04-30','10:25:00',2.83),('8537','2013-04-30','10:30:00',2.41),('8537','2013-04-30','10:35:00',2.19),('8537','2013-04-30','10:40:00',1.9),('8537','2013-04-30','10:45:00',1.53),('8537','2013-04-30','10:50:00',1.66),('8537','2013-04-30','10:55:00',1.76),('8537','2013-04-30','11:00:00',1.78),('8537','2013-04-30','11:05:00',2.03),('8537','2013-04-30','11:10:00',2.07),('8537','2013-04-30','11:15:00',2.18),('8537','2013-04-30','11:20:00',2.5),('8537','2013-04-30','11:25:00',2.28),('8537','2013-04-30','11:30:00',2.24),('8537','2013-04-30','11:35:00',2.38),('8537','2013-04-30','11:40:00',2.29),('8537','2013-04-30','11:45:00',1.94),('8537','2013-04-30','11:50:00',2),('8537','2013-04-30','11:55:00',2.04),('8537','2013-04-30','12:00:00',2.05),('8537','2013-04-30','12:05:00',2.07),('8537','2013-04-30','12:10:00',2.02),('8537','2013-04-30','12:15:00',1.86),('8537','2013-04-30','12:20:00',1.66),('8537','2013-04-30','12:25:00',1.52),('8537','2013-04-30','12:30:00',1.56),('8537','2013-04-30','12:35:00',2.82),('8537','2013-04-30','12:40:00',5.06),('8537','2013-04-30','12:45:00',5.34),('8537','2013-04-30','12:50:00',5.16),('8537','2013-04-30','12:55:00',4.59),('8537','2013-04-30','13:00:00',4.98),('8537','2013-04-30','13:05:00',4.81),('8537','2013-04-30','13:10:00',4.92),('8537','2013-04-30','13:15:00',4.84),('8537','2013-04-30','13:20:00',4.81),('8537','2013-04-30','13:25:00',4.77),('8537','2013-04-30','13:30:00',4.75),('8537','2013-04-30','13:35:00',4.75),('8537','2013-04-30','13:40:00',4.69),('8537','2013-04-30','13:45:00',4.64),('8537','2013-04-30','13:50:00',4.57),('8537','2013-04-30','13:55:00',4.53),('8537','2013-04-30','14:00:00',4.44),('8537','2013-04-30','14:05:00',4.5),('8537','2013-04-30','14:10:00',4.48),('8537','2013-04-30','14:15:00',4.45),('8537','2013-04-30','14:20:00',4.44),('8537','2013-04-30','14:25:00',4.42),('8537','2013-04-30','14:30:00',4.37),('8537','2013-04-30','14:35:00',4.23),('8537','2013-04-30','14:40:00',3.96),('8537','2013-04-30','14:45:00',3.64),('8537','2013-04-30','14:50:00',4.1),('8537','2013-04-30','14:55:00',4),('8537','2013-04-30','15:00:00',3.96),('8537','2013-04-30','15:05:00',3.89),('8537','2013-04-30','15:10:00',3.82),('8537','2013-04-30','15:15:00',3.75),('8537','2013-04-30','15:20:00',3.66),('8537','2013-04-30','15:25:00',3.61),('8537','2013-04-30','15:30:00',3.44),('8537','2013-04-30','15:35:00',3.52),('8537','2013-04-30','15:40:00',3.45),('8537','2013-04-30','15:45:00',3.39),('8537','2013-04-30','15:50:00',3.26),('8537','2013-04-30','15:55:00',3.23),('8537','2013-04-30','16:00:00',3.17),('8537','2013-04-30','16:05:00',3.11),('8537','2013-04-30','16:10:00',3.01),('8537','2013-04-30','16:15:00',2.92),('8537','2013-04-30','16:20:00',2.85),('8537','2013-04-30','16:25:00',2.77),('8537','2013-04-30','16:30:00',2.72),('8537','2013-04-30','16:35:00',2.58),('8537','2013-04-30','16:40:00',2.19),('8537','2013-04-30','16:45:00',2.23),('8537','2013-04-30','16:50:00',1.96),('8537','2013-04-30','16:55:00',2.23),('8537','2013-04-30','17:00:00',2.05),('8537','2013-04-30','17:05:00',2.02),('8537','2013-04-30','17:10:00',1.71),('8537','2013-04-30','17:20:00',1.39),('8537','2013-04-30','17:25:00',1.64),('8537','2013-04-30','17:30:00',1.55),('8537','2013-04-30','17:35:00',1.49),('8537','2013-04-30','17:40:00',1.38),('8537','2013-04-30','17:45:00',1.31),('8537','2013-04-30','17:50:00',1.22),('8537','2013-04-30','17:55:00',1.13),('8537','2013-04-30','18:00:00',1.05),('8537','2013-04-29','07:50:00',1.04),('8537','2013-04-29','07:55:00',1.21),('8537','2013-04-29','08:00:00',1.39),('8537','2013-04-29','08:05:00',1.49),('8537','2013-04-29','08:10:00',1.45),('8537','2013-04-29','08:15:00',1.48),('8537','2013-04-29','08:20:00',1.61),('8537','2013-04-29','08:25:00',1.84),('8537','2013-04-29','08:30:00',2.09),('8537','2013-04-29','08:35:00',2.35),('8537','2013-04-29','08:40:00',2.38),('8537','2013-04-29','08:45:00',2.33),('8537','2013-04-29','08:50:00',2.49),('8537','2013-04-29','08:55:00',2.49),('8537','2013-04-29','09:00:00',1.95),('8537','2013-04-29','09:05:00',2.66),('8537','2013-04-29','09:10:00',2.94),('8537','2013-04-29','09:15:00',3.11),('8537','2013-04-29','09:20:00',2.92),('8537','2013-04-29','09:25:00',2.87),('8537','2013-04-29','09:30:00',2.89),('8537','2013-04-29','09:35:00',3.08),('8537','2013-04-29','09:40:00',3.09),('8537','2013-04-29','09:45:00',3.21),('8537','2013-04-29','09:50:00',3.42),('8537','2013-04-29','09:55:00',3.2),('8537','2013-04-29','10:00:00',3.37),('8537','2013-04-29','10:05:00',3.32),('8537','2013-04-29','10:10:00',3.31),('8537','2013-04-29','10:15:00',2.79),('8537','2013-04-29','10:20:00',2.74),('8537','2013-04-29','10:25:00',3.28),('8537','2013-04-29','10:30:00',3.32),('8537','2013-04-29','10:35:00',3.86),('8537','2013-04-29','10:40:00',3.89),('8537','2013-04-29','10:45:00',3.96),('8537','2013-04-29','10:50:00',3.8),('8537','2013-04-29','10:55:00',3.58),('8537','2013-04-29','11:00:00',4.02),('8537','2013-04-29','11:05:00',3.86),('8537','2013-04-29','11:10:00',3.77),('8537','2013-04-29','11:15:00',3.51),('8537','2013-04-29','11:20:00',4),('8537','2013-04-29','11:25:00',4.16),('8537','2013-04-29','11:30:00',4.37),('8537','2013-04-29','11:35:00',4.17),('8537','2013-04-29','11:40:00',4.21),('8537','2013-04-29','11:45:00',4.12),('8537','2013-04-29','11:50:00',4.54),('8537','2013-04-29','11:55:00',4.51),('8537','2013-04-29','12:00:00',4.65),('8537','2013-04-29','12:05:00',4.64),('8537','2013-04-29','12:10:00',4.48),('8537','2013-04-29','12:15:00',4.53),('8537','2013-04-29','12:20:00',4.57),('8537','2013-04-29','12:25:00',4.45),('8537','2013-04-29','12:30:00',4.57),('8537','2013-04-29','12:35:00',4.64),('8537','2013-04-29','12:40:00',4.75),('8537','2013-04-29','12:45:00',4.75),('8537','2013-04-29','12:50:00',4.73),('8537','2013-04-29','12:55:00',4.62),('8537','2013-04-29','13:00:00',4.71),('8537','2013-04-29','13:05:00',4.65),('8537','2013-04-29','13:10:00',4.55),('8537','2013-04-29','13:15:00',4.24),('8537','2013-04-29','13:20:00',4.55),('8537','2013-04-29','13:25:00',4.78),('8537','2013-04-29','13:30:00',4.67),('8537','2013-04-29','13:35:00',4.62),('8537','2013-04-29','13:40:00',4.67),('8537','2013-04-29','13:45:00',4.66),('8537','2013-04-29','13:50:00',4.4),('8537','2013-04-29','13:55:00',4.82),('8537','2013-04-29','14:00:00',4.47),('8537','2013-04-29','14:05:00',4.44),('8537','2013-04-29','14:10:00',4.56),('8537','2013-04-29','14:15:00',4.63),('8537','2013-04-29','14:20:00',4.59),('8537','2013-04-29','14:25:00',4.46),('8537','2013-04-29','14:30:00',4.23),('8537','2013-04-29','14:35:00',4.07),('8537','2013-04-29','14:40:00',3.9),('8537','2013-04-29','14:45:00',4.21),('8537','2013-04-29','14:50:00',4.06),('8537','2013-04-29','14:55:00',4.16),('8537','2013-04-29','15:00:00',4),('8537','2013-04-29','15:05:00',4.24),('8537','2013-04-29','15:10:00',3.84),('8537','2013-04-29','15:15:00',3.58),('8537','2013-04-29','15:20:00',3.82),('8537','2013-04-29','15:25:00',4.02),('8537','2013-04-29','15:30:00',3.72),('8537','2013-04-29','15:35:00',3.41),('8537','2013-04-29','15:40:00',3.11),('8537','2013-04-29','15:45:00',3),('8537','2013-04-29','15:50:00',3.08),('8537','2013-04-29','15:55:00',3.27),('8537','2013-04-29','16:00:00',3.18),('8537','2013-04-29','16:05:00',3.4),('8537','2013-04-29','16:10:00',3.14),('8537','2013-04-29','16:15:00',3.51),('8537','2013-04-29','16:20:00',3.15),('8537','2013-04-29','16:25:00',2.66),('8537','2013-04-29','16:30:00',2.82),('8537','2013-04-29','16:35:00',2.84),('8537','2013-04-29','16:40:00',3),('8537','2013-04-29','16:45:00',2.91),('8537','2013-04-29','16:50:00',2.97),('8537','2013-04-29','16:55:00',3.07),('8537','2013-04-29','17:00:00',2.81),('8537','2013-04-29','17:05:00',2.41),('8537','2013-04-29','17:10:00',2.43),('8537','2013-04-29','17:15:00',2.07),('8537','2013-04-29','17:20:00',1.74),('8537','2013-04-29','17:25:00',1.64),('8537','2013-04-29','17:30:00',1.57),('8537','2013-04-29','17:35:00',1.39),('8537','2013-04-29','17:40:00',1.18),('8537','2013-04-29','17:45:00',1.12),('8537','2013-04-29','17:50:00',1.27),('8537','2013-04-29','17:55:00',1.44),('8537','2013-04-29','18:00:00',1.38),('8537','2013-04-29','18:05:00',1.48),('8537','2013-04-29','18:10:00',1.33),('8537','2013-04-29','18:15:00',1.24),('8537','2013-04-29','18:20:00',1.02),('8537','2013-04-28','07:40:00',1.01),('8537','2013-04-28','07:45:00',1.12),('8537','2013-04-28','07:50:00',1.2),('8537','2013-04-28','07:55:00',1.31),('8537','2013-04-28','08:00:00',1.4),('8537','2013-04-28','08:05:00',1.53),('8537','2013-04-28','08:10:00',1.66),('8537','2013-04-28','08:15:00',1.76),('8537','2013-04-28','08:20:00',1.87),('8537','2013-04-28','08:25:00',1.99),('8537','2013-04-28','08:30:00',2.06),('8537','2013-04-28','08:35:00',2.16),('8537','2013-04-28','08:40:00',2.27),('8537','2013-04-28','08:45:00',2.38),('8537','2013-04-28','08:50:00',2.47),('8537','2013-04-28','08:55:00',2.57),('8537','2013-04-28','09:00:00',2.67),('8537','2013-04-28','09:05:00',2.73),('8537','2013-04-28','09:10:00',2.88),('8537','2013-04-28','09:15:00',2.98),('8537','2013-04-28','09:20:00',3.06),('8537','2013-04-28','09:25:00',3.16),('8537','2013-04-28','09:30:00',3.26),('8537','2013-04-28','09:35:00',3.35),('8537','2013-04-28','09:40:00',3.43),('8537','2013-04-28','09:45:00',3.52),('8537','2013-04-28','09:50:00',3.6),('8537','2013-04-28','09:55:00',3.68),('8537','2013-04-28','10:00:00',3.73),('8537','2013-04-28','10:05:00',3.77),('8537','2013-04-28','10:10:00',3.84),('8537','2013-04-28','10:15:00',3.86),('8537','2013-04-28','10:20:00',3.94),('8537','2013-04-28','10:25:00',4.08),('8537','2013-04-28','10:30:00',4.02),('8537','2013-04-28','10:35:00',4.15),('8537','2013-04-28','10:40:00',3.83),('8537','2013-04-28','10:45:00',4.34),('8537','2013-04-28','10:50:00',4.33),('8537','2013-04-28','10:55:00',4.34),('8537','2013-04-28','11:00:00',4.38),('8537','2013-04-28','11:05:00',4.43),('8537','2013-04-28','11:10:00',4.55),('8537','2013-04-28','11:15:00',4.62),('8537','2013-04-28','11:20:00',4.58),('8537','2013-04-28','11:25:00',4.63),('8537','2013-04-28','11:30:00',4.65),('8537','2013-04-28','11:35:00',4.54),('8537','2013-04-28','11:40:00',4.57),('8537','2013-04-28','11:45:00',4.36),('8537','2013-04-28','11:50:00',4.42),('8537','2013-04-28','11:55:00',4.63),('8537','2013-04-28','12:00:00',4.13),('8537','2013-04-28','12:05:00',4.06),('8537','2013-04-28','12:10:00',4.51),('8537','2013-04-28','12:15:00',4.64),('8537','2013-04-28','12:20:00',4.55),('8537','2013-04-28','12:25:00',4.04),('8537','2013-04-28','12:30:00',3.9),('8537','2013-04-28','12:35:00',3.46),('8537','2013-04-28','12:40:00',3.58),('8537','2013-04-28','12:45:00',4.72),('8537','2013-04-28','12:50:00',4.77),('8537','2013-04-28','12:55:00',4.45),('8537','2013-04-28','13:00:00',4.64),('8537','2013-04-28','13:05:00',5.03),('8537','2013-04-28','13:10:00',4.83),('8537','2013-04-28','13:15:00',4.48),('8537','2013-04-28','13:20:00',4.59),('8537','2013-04-28','13:25:00',4.46),('8537','2013-04-28','13:30:00',4.8),('8537','2013-04-28','13:35:00',4.87),('8537','2013-04-28','13:40:00',5.12),('8537','2013-04-28','13:45:00',4.9),('8537','2013-04-28','13:50:00',3.45),('8537','2013-04-28','13:55:00',2.91),('8537','2013-04-28','14:00:00',4.9),('8537','2013-04-28','14:05:00',4.77),('8537','2013-04-28','14:10:00',4.65),('8537','2013-04-28','14:15:00',4.59),('8537','2013-04-28','14:20:00',2.47),('8537','2013-04-28','14:25:00',4.5),('8537','2013-04-28','14:30:00',4.56),('8537','2013-04-28','14:35:00',4.45),('8537','2013-04-28','14:40:00',4.4),('8537','2013-04-28','14:45:00',4.33),('8537','2013-04-28','14:50:00',4.29),('8537','2013-04-28','14:55:00',4.27),('8537','2013-04-28','15:00:00',4.24),('8537','2013-04-28','15:05:00',4.21),('8537','2013-04-28','15:10:00',4.16),('8537','2013-04-28','15:15:00',4.11),('8537','2013-04-28','15:20:00',4.03),('8537','2013-04-28','15:25:00',3.93),('8537','2013-04-28','15:30:00',3.81),('8537','2013-04-28','15:35:00',3.81),('8537','2013-04-28','15:40:00',3.77),('8537','2013-04-28','15:45:00',3.72),('8537','2013-04-28','15:50:00',3.64),('8537','2013-04-28','15:55:00',3.56),('8537','2013-04-28','16:00:00',3.49),('8537','2013-04-28','16:05:00',3.44),('8537','2013-04-28','16:10:00',3.31),('8537','2013-04-28','16:15:00',3.22),('8537','2013-04-28','16:20:00',3.14),('8537','2013-04-28','16:25:00',3.07),('8537','2013-04-28','16:30:00',3),('8537','2013-04-28','16:35:00',2.92),('8537','2013-04-28','16:40:00',2.84),('8537','2013-04-28','16:45:00',2.73),('8537','2013-04-28','16:50:00',2.65),('8537','2013-04-28','16:55:00',2.55),('8537','2013-04-28','17:00:00',2.48),('8537','2013-04-28','17:05:00',2.27),('8537','2013-04-28','17:10:00',2.12),('8537','2013-04-28','17:15:00',2.18),('8537','2013-04-28','17:20:00',2.06),('8537','2013-04-28','17:25:00',2),('8537','2013-04-28','17:30:00',1.68),('8537','2013-04-28','17:35:00',1.64),('8537','2013-04-28','17:40:00',1.5),('8537','2013-04-28','17:45:00',1.52),('8537','2013-04-28','17:50:00',1.44),('8537','2013-04-28','17:55:00',1.25),('8537','2013-04-28','18:00:00',1.2),('8537','2013-04-28','18:05:00',1.13),('8537','2013-04-27','12:45:00',1.01),('8537','2013-04-27','12:50:00',1.15),('8537','2013-04-27','12:55:00',1.51),('8537','2013-04-27','13:00:00',1.64),('8537','2013-04-27','13:05:00',1.26),('8537','2013-04-27','13:10:00',1.29),('8537','2013-04-27','13:15:00',1.63),('8537','2013-04-27','13:20:00',1.68),('8537','2013-04-27','13:25:00',1.27),('8537','2013-04-27','13:30:00',1.38),('8537','2013-04-27','13:35:00',1.7),('8537','2013-04-27','13:40:00',2.16),('8537','2013-04-27','13:45:00',1.35),('8537','2013-04-27','13:50:00',1.25),('8537','2013-04-27','14:25:00',1.55),('8537','2013-04-27','14:30:00',2.53),('8537','2013-04-27','14:35:00',2.13),('8537','2013-04-27','14:40:00',1.49),('8537','2013-04-27','14:45:00',1.43),('8537','2013-04-27','14:55:00',1.05),('8537','2013-04-27','15:00:00',1.29),('8537','2013-04-27','15:05:00',2.03),('8537','2013-04-27','15:10:00',1.59),('8537','2013-04-27','15:15:00',1.35),('8537','2013-04-27','16:40:00',1.05),('8537','2013-04-27','16:45:00',1.43),('8537','2013-04-27','16:50:00',2.05),('8537','2013-04-27','16:55:00',2.19),('8537','2013-04-27','17:00:00',2.7),('8537','2013-04-27','17:05:00',1.78),('8537','2013-04-27','17:20:00',1.13),('8537','2013-04-27','17:40:00',1.13),('8537','2013-04-26','08:05:00',1.1),('8537','2013-04-26','08:10:00',1.39),('8537','2013-04-26','08:15:00',1.55),('8537','2013-04-26','08:20:00',1.61),('8537','2013-04-26','08:25:00',1.7),('8537','2013-04-26','08:30:00',1.77),('8537','2013-04-26','08:35:00',1.92),('8537','2013-04-26','08:40:00',2),('8537','2013-04-26','08:45:00',2.11),('8537','2013-04-26','08:50:00',2.09),('8537','2013-04-26','08:55:00',1.73),('8537','2013-04-26','09:00:00',1.69),('8537','2013-04-26','09:05:00',2.25),('8537','2013-04-26','09:10:00',2.12),('8537','2013-04-26','09:15:00',1.36),('8537','2013-04-26','09:20:00',1.34),('8537','2013-04-26','09:25:00',1.57),('8537','2013-04-26','09:30:00',1.9),('8537','2013-04-26','09:35:00',2.2),('8537','2013-04-26','09:40:00',2.34),('8537','2013-04-26','09:45:00',3.12),('8537','2013-04-26','09:50:00',2.87),('8537','2013-04-26','09:55:00',1.97),('8537','2013-04-26','10:00:00',2.25),('8537','2013-04-26','10:05:00',2.89),('8537','2013-04-26','10:10:00',3.52),('8537','2013-04-26','10:15:00',3.73),('8537','2013-04-26','10:20:00',3.72),('8537','2013-04-26','10:25:00',3.03),('8537','2013-04-26','10:30:00',4.01),('8537','2013-04-26','10:35:00',4.15),('8537','2013-04-26','10:40:00',3.98),('8537','2013-04-26','10:45:00',3.52),('8537','2013-04-26','10:50:00',2.68),('8537','2013-04-26','10:55:00',2.83),('8537','2013-04-26','11:00:00',3.74),('8537','2013-04-26','11:05:00',4.11),('8537','2013-04-26','11:10:00',3.77),('8537','2013-04-26','11:15:00',4.25),('8537','2013-04-26','11:20:00',3.13),('8537','2013-04-26','11:25:00',3.61),('8537','2013-04-26','11:30:00',3.62),('8537','2013-04-26','11:35:00',4.19),('8537','2013-04-26','11:40:00',3.99),('8537','2013-04-26','11:45:00',3.9),('8537','2013-04-26','11:50:00',3.02),('8537','2013-04-26','11:55:00',3.01),('8537','2013-04-26','12:00:00',3.33),('8537','2013-04-26','12:05:00',2.99),('8537','2013-04-26','12:10:00',2.66),('8537','2013-04-26','12:15:00',3.1),('8537','2013-04-26','12:20:00',2.98),('8537','2013-04-26','12:25:00',2.27),('8537','2013-04-26','12:30:00',2.14),('8537','2013-04-26','12:35:00',2.59),('8537','2013-04-26','12:40:00',3.93),('8537','2013-04-26','12:45:00',4.24),('8537','2013-04-26','12:50:00',2.45),('8537','2013-04-26','12:55:00',2.25),('8537','2013-04-26','13:00:00',1.61),('8537','2013-04-26','13:05:00',1.54),('8537','2013-04-26','13:10:00',1.86),('8537','2013-04-26','13:15:00',2.68),('8537','2013-04-26','13:20:00',1.92),('8537','2013-04-26','13:25:00',2.31),('8537','2013-04-26','13:30:00',2.88),('8537','2013-04-26','13:35:00',2.63),('8537','2013-04-26','13:40:00',3.09),('8537','2013-04-26','13:45:00',2.53),('8537','2013-04-26','13:50:00',3.37),('8537','2013-04-26','13:55:00',2.89),('8537','2013-04-26','14:00:00',3.04),('8537','2013-04-26','14:05:00',4.19),('8537','2013-04-26','14:10:00',3.82),('8537','2013-04-26','14:15:00',4.02),('8537','2013-04-26','14:20:00',3.66),('8537','2013-04-26','14:25:00',4.12),('8537','2013-04-26','14:30:00',4.56),('8537','2013-04-26','14:35:00',3.31),('8537','2013-04-26','14:40:00',1.98),('8537','2013-04-26','14:45:00',2.02),('8537','2013-04-26','14:50:00',3.77),('8537','2013-04-26','14:55:00',3.7),('8537','2013-04-26','15:00:00',3.83),('8537','2013-04-26','15:05:00',3.16),('8537','2013-04-26','15:10:00',1.54),('8537','2013-04-26','15:15:00',2),('8537','2013-04-26','15:20:00',1.66),('8537','2013-04-26','15:25:00',1.81),('8537','2013-04-26','15:30:00',2.44),('8537','2013-04-26','15:35:00',2.13),('8537','2013-04-26','15:40:00',2.21),('8537','2013-04-26','15:45:00',2.23),('8537','2013-04-26','15:50:00',2),('8537','2013-04-26','15:55:00',1.26),('8537','2013-04-25','08:05:00',1.18),('8537','2013-04-25','08:10:00',1.26),('8537','2013-04-25','08:15:00',1.62),('8537','2013-04-25','08:20:00',1.34),('8537','2013-04-25','08:25:00',1.14),('8537','2013-04-25','08:30:00',1.16),('8537','2013-04-25','08:35:00',1.22),('8537','2013-04-25','08:40:00',1.28),('8537','2013-04-25','08:45:00',1.55),('8537','2013-04-25','08:50:00',2.42),('8537','2013-04-25','08:55:00',2.76),('8537','2013-04-25','09:00:00',2.37),('8537','2013-04-25','09:05:00',1.72),('8537','2013-04-25','09:10:00',1.59),('8537','2013-04-25','09:15:00',1.47),('8537','2013-04-25','09:20:00',1.54),('8537','2013-04-25','09:25:00',1.84),('8537','2013-04-25','09:30:00',1.66),('8537','2013-04-25','09:35:00',1.85),('8537','2013-04-25','09:40:00',2.59),('8537','2013-04-25','09:45:00',3.17),('8537','2013-04-25','09:50:00',3.65),('8537','2013-04-25','09:55:00',3.68),('8537','2013-04-25','10:00:00',3.73),('8537','2013-04-25','10:05:00',3.56),('8537','2013-04-25','10:10:00',3.23),('8537','2013-04-25','10:15:00',3.3),('8537','2013-04-25','10:20:00',3.86),('8537','2013-04-25','10:25:00',3.96),('8537','2013-04-25','10:30:00',4.14),('8537','2013-04-25','10:35:00',4.18),('8537','2013-04-25','10:40:00',4.18),('8537','2013-04-25','10:45:00',4.02),('8537','2013-04-25','10:50:00',4.22),('8537','2013-04-25','10:55:00',4.32),('8537','2013-04-25','11:00:00',4.44),('8537','2013-04-25','11:05:00',4.49),('8537','2013-04-25','11:10:00',4.53),('8537','2013-04-25','11:15:00',4.56),('8537','2013-04-25','11:20:00',4.6),('8537','2013-04-25','11:25:00',4.64),('8537','2013-04-25','11:30:00',4.65),('8537','2013-04-25','11:35:00',4.73),('8537','2013-04-25','11:40:00',4.78),('8537','2013-04-25','11:45:00',4.82),('8537','2013-04-25','11:50:00',4.84),('8537','2013-04-25','11:55:00',4.75),('8537','2013-04-25','12:00:00',4.68),('8537','2013-04-25','12:05:00',4.68),('8537','2013-04-25','12:10:00',4.8),('8537','2013-04-25','12:15:00',4.84),('8537','2013-04-25','12:20:00',4.87),('8537','2013-04-25','12:25:00',4.85),('8537','2013-04-25','12:30:00',4.88),('8537','2013-04-25','12:35:00',4.92),('8537','2013-04-25','12:40:00',4.89),('8537','2013-04-25','12:45:00',4.94),('8537','2013-04-25','12:50:00',4.93),('8537','2013-04-25','12:55:00',4.95),('8537','2013-04-25','13:00:00',5),('8537','2013-04-25','13:05:00',5.05),('8537','2013-04-25','13:10:00',4.84),('8537','2013-04-25','13:15:00',4.37),('8537','2013-04-25','13:20:00',4.48),('8537','2013-04-25','13:25:00',4.42),('8537','2013-04-25','13:30:00',3.37),('8537','2013-04-25','13:35:00',3.23),('8537','2013-04-25','13:40:00',2.79),('8537','2013-04-25','13:45:00',2.57),('8537','2013-04-25','13:50:00',2.42),('8537','2013-04-25','13:55:00',2.58),('8537','2013-04-25','14:00:00',2.63),('8537','2013-04-25','14:05:00',2.46),('8537','2013-04-25','14:10:00',2.69),('8537','2013-04-25','14:15:00',2.79),('8537','2013-04-25','14:20:00',2.84),('8537','2013-04-25','14:25:00',2.91),('8537','2013-04-25','14:30:00',3.38),('8537','2013-04-25','14:35:00',4.1),('8537','2013-04-25','14:40:00',3.91),('8537','2013-04-25','14:45:00',3.89),('8537','2013-04-25','14:50:00',3.68),('8537','2013-04-25','14:55:00',3.79),('8537','2013-04-25','15:00:00',3.68),('8537','2013-04-25','15:05:00',3.35),('8537','2013-04-25','15:10:00',3.29),('8537','2013-04-25','15:15:00',3.71),('8537','2013-04-25','15:20:00',3.92),('8537','2013-04-25','15:25:00',4.05),('8537','2013-04-25','15:30:00',3.86),('8537','2013-04-25','15:35:00',3.72),('8537','2013-04-25','15:40:00',3.47),('8537','2013-04-25','15:45:00',3.25),('8537','2013-04-25','15:50:00',3.04),('8537','2013-04-25','15:55:00',2.95),('8537','2013-04-25','16:00:00',3.04),('8537','2013-04-25','16:05:00',2.49),('8537','2013-04-25','16:10:00',2.5),('8537','2013-04-25','16:15:00',2.34),('8537','2013-04-25','16:20:00',2.5),('8537','2013-04-25','16:25:00',2.2),('8537','2013-04-25','16:30:00',2.11),('8537','2013-04-25','16:35:00',2.62),('8537','2013-04-25','16:40:00',2.27),('8537','2013-04-25','16:45:00',2.27),('8537','2013-04-25','16:50:00',1.95),('8537','2013-04-25','16:55:00',2.07),('8537','2013-04-25','17:00:00',1.92),('8537','2013-04-25','17:05:00',2.21),('8537','2013-04-25','17:10:00',2.29),('8537','2013-04-25','17:15:00',2.07),('8537','2013-04-25','17:20:00',2.19),('8537','2013-04-25','17:25:00',1.85),('8537','2013-04-25','17:30:00',1.45),('8537','2013-04-25','17:35:00',1.38),('8537','2013-04-25','17:40:00',1.39),('8537','2013-04-25','17:45:00',1.2),('8537','2013-04-25','17:50:00',1.04),('8537','2013-04-24','07:50:00',1.06),('8537','2013-04-24','07:55:00',1.19),('8537','2013-04-24','08:00:00',1.28),('8537','2013-04-24','08:05:00',1.33),('8537','2013-04-24','08:10:00',1.52),('8537','2013-04-24','08:15:00',1.74),('8537','2013-04-24','08:20:00',1.84),('8537','2013-04-24','08:25:00',2),('8537','2013-04-24','08:30:00',1.99),('8537','2013-04-24','08:35:00',1.93),('8537','2013-04-24','08:40:00',2.01),('8537','2013-04-24','08:45:00',2.08),('8537','2013-04-24','08:50:00',2.19),('8537','2013-04-24','08:55:00',2.31),('8537','2013-04-24','09:00:00',2.56),('8537','2013-04-24','09:05:00',2.79),('8537','2013-04-24','09:10:00',2.84),('8537','2013-04-24','09:15:00',2.74),('8537','2013-04-24','09:20:00',2.32),('8537','2013-04-24','09:25:00',2.81),('8537','2013-04-24','09:30:00',3.25),('8537','2013-04-24','09:35:00',3.4),('8537','2013-04-24','09:40:00',3.14),('8537','2013-04-24','09:45:00',3.03),('8537','2013-04-24','09:50:00',3.33),('8537','2013-04-24','09:55:00',3.75),('8537','2013-04-24','10:00:00',3.85),('8537','2013-04-24','10:05:00',3.97),('8537','2013-04-24','10:10:00',4.01),('8537','2013-04-24','10:15:00',4),('8537','2013-04-24','10:20:00',3.93),('8537','2013-04-24','10:25:00',3.94),('8537','2013-04-24','10:30:00',3.9),('8537','2013-04-24','10:35:00',3.88),('8537','2013-04-24','10:40:00',4.28),('8537','2013-04-24','10:45:00',4.35),('8537','2013-04-24','10:50:00',4.39),('8537','2013-04-24','10:55:00',4.52),('8537','2013-04-24','11:00:00',4.59),('8537','2013-04-24','11:05:00',4.47),('8537','2013-04-24','11:10:00',4.79),('8537','2013-04-24','11:15:00',4.9),('8537','2013-04-24','11:20:00',5.04),('8537','2013-04-24','11:25:00',5.11),('8537','2013-04-24','11:30:00',4.95),('8537','2013-04-24','11:35:00',4.22),('8537','2013-04-24','11:40:00',3.11),('8537','2013-04-24','11:45:00',3.5),('8537','2013-04-24','11:50:00',2.42),('8537','2013-04-24','11:55:00',3.39),('8537','2013-04-24','12:00:00',4.27),('8537','2013-04-24','12:05:00',2.8),('8537','2013-04-24','12:10:00',3.32),('8537','2013-04-24','12:15:00',4.65),('8537','2013-04-24','12:20:00',5.49),('8537','2013-04-24','12:25:00',4.75),('8537','2013-04-24','12:30:00',4.63),('8537','2013-04-24','12:35:00',4.72),('8537','2013-04-24','12:40:00',4.43),('8537','2013-04-24','12:45:00',4.64),('8537','2013-04-24','12:50:00',4.96),('8537','2013-04-24','12:55:00',4.81),('8537','2013-04-24','13:00:00',4.66),('8537','2013-04-24','13:05:00',4.05),('8537','2013-04-24','13:10:00',5.27),('8537','2013-04-24','13:15:00',4.86),('8537','2013-04-24','13:20:00',4.59),('8537','2013-04-24','13:25:00',4.76),('8537','2013-04-24','13:30:00',4.43),('8537','2013-04-24','13:35:00',4.63),('8537','2013-04-24','13:40:00',5.2),('8537','2013-04-24','13:45:00',4.43),('8537','2013-04-24','13:50:00',3.15),('8537','2013-04-24','13:55:00',4.91),('8537','2013-04-24','14:00:00',4.88),('8537','2013-04-24','14:05:00',3.46),('8537','2013-04-24','14:10:00',3.38),('8537','2013-04-24','14:15:00',4.91),('8537','2013-04-24','14:20:00',4.43),('8537','2013-04-24','14:25:00',4.56),('8537','2013-04-24','14:30:00',4.3),('8537','2013-04-24','14:35:00',3.75),('8537','2013-04-24','14:40:00',3.59),('8537','2013-04-24','14:45:00',3.47),('8537','2013-04-24','14:50:00',3.08),('8537','2013-04-24','14:55:00',2.73),('8537','2013-04-24','15:00:00',3.01),('8537','2013-04-24','15:05:00',2.73),('8537','2013-04-24','15:10:00',2.56),('8537','2013-04-24','15:15:00',2.71),('8537','2013-04-24','15:20:00',2.86),('8537','2013-04-24','15:25:00',2.41),('8537','2013-04-24','15:30:00',2.06),('8537','2013-04-24','15:35:00',2),('8537','2013-04-24','15:40:00',1.97),('8537','2013-04-24','15:45:00',1.98),('8537','2013-04-24','15:50:00',2.01),('8537','2013-04-24','15:55:00',2.33),('8537','2013-04-24','16:00:00',2.75),('8537','2013-04-24','16:05:00',2.9),('8537','2013-04-24','16:10:00',3.07),('8537','2013-04-24','16:15:00',2.74),('8537','2013-04-24','16:20:00',3.29),('8537','2013-04-24','16:25:00',2.79),('8537','2013-04-24','16:30:00',2.43),('8537','2013-04-24','16:35:00',2.02),('8537','2013-04-24','16:40:00',2.78),('8537','2013-04-24','16:45:00',2.8),('8537','2013-04-24','16:50:00',2.47),('8537','2013-04-24','16:55:00',2.96),('8537','2013-04-24','17:00:00',2.97),('8537','2013-04-24','17:05:00',2.72),('8537','2013-04-24','17:10:00',2.57),('8537','2013-04-24','17:15:00',1.91),('8537','2013-04-24','17:20:00',1.74),('8537','2013-04-24','17:25:00',1.69),('8537','2013-04-24','17:50:00',1.02),('8537','2013-04-24','17:55:00',1.37),('8537','2013-04-24','18:00:00',1.07),('8537','2013-04-24','18:05:00',1.08),('8537','2013-04-23','07:45:00',1.09),('8537','2013-04-23','07:50:00',1.2),('8537','2013-04-23','07:55:00',1.32),('8537','2013-04-23','08:00:00',1.43),('8537','2013-04-23','08:05:00',1.54),('8537','2013-04-23','08:10:00',1.66),('8537','2013-04-23','08:15:00',1.77),('8537','2013-04-23','08:20:00',1.89),('8537','2013-04-23','08:25:00',2.01),('8537','2013-04-23','08:30:00',2.09),('8537','2013-04-23','08:35:00',2.26),('8537','2013-04-23','08:40:00',2.37),('8537','2013-04-23','08:45:00',2.47),('8537','2013-04-23','08:50:00',2.58),('8537','2013-04-23','08:55:00',2.69),('8537','2013-04-23','09:00:00',2.8),('8537','2013-04-23','09:05:00',2.91),('8537','2013-04-23','09:10:00',3.02),('8537','2013-04-23','09:15:00',3.13),('8537','2013-04-23','09:20:00',3.24),('8537','2013-04-23','09:25:00',3.33),('8537','2013-04-23','09:30:00',3.4),('8537','2013-04-23','09:35:00',3.5),('8537','2013-04-23','09:40:00',3.29),('8537','2013-04-23','09:45:00',3.2),('8537','2013-04-23','09:50:00',3.83),('8537','2013-04-23','09:55:00',3.89),('8537','2013-04-23','10:00:00',3.93),('8537','2013-04-23','10:05:00',3.99),('8537','2013-04-23','10:10:00',4.07),('8537','2013-04-23','10:15:00',4.11),('8537','2013-04-23','10:20:00',4.22),('8537','2013-04-23','10:25:00',4.29),('8537','2013-04-23','10:30:00',4.34),('8537','2013-04-23','10:35:00',4.41),('8537','2013-04-23','10:40:00',4.49),('8537','2013-04-23','10:45:00',4.43),('8537','2013-04-23','10:50:00',4.54),('8537','2013-04-23','10:55:00',4.62),('8537','2013-04-23','11:00:00',4.64),('8537','2013-04-23','11:05:00',4.68),('8537','2013-04-23','11:10:00',4.73),('8537','2013-04-23','11:15:00',4.77),('8537','2013-04-23','11:20:00',4.81),('8537','2013-04-23','11:25:00',4.85),('8537','2013-04-23','11:30:00',4.85),('8537','2013-04-23','11:35:00',4.88),('8537','2013-04-23','11:40:00',4.86),('8537','2013-04-23','11:45:00',4.95),('8537','2013-04-23','11:50:00',5.02),('8537','2013-04-23','11:55:00',5.01),('8537','2013-04-23','12:00:00',4.96),('8537','2013-04-23','12:05:00',4.88),('8537','2013-04-23','12:10:00',4.91),('8537','2013-04-23','12:15:00',4.89),('8537','2013-04-23','12:20:00',4.92),('8537','2013-04-23','12:25:00',4.99),('8537','2013-04-23','12:30:00',3.41),('8537','2013-04-23','12:35:00',4.19),('8537','2013-04-23','12:40:00',4.97),('8537','2013-04-23','12:45:00',2.33),('8537','2013-04-23','12:50:00',3.04),('8537','2013-04-23','12:55:00',3.34),('8537','2013-04-23','13:00:00',3.07),('8537','2013-04-23','13:05:00',3.67),('8537','2013-04-23','13:10:00',1.87),('8537','2013-04-23','13:15:00',4.31),('8537','2013-04-23','13:20:00',5.55),('8537','2013-04-23','13:25:00',5.4),('8537','2013-04-23','13:30:00',5.17),('8537','2013-04-23','13:35:00',5.26),('8537','2013-04-23','13:40:00',5.3),('8537','2013-04-23','13:45:00',3.62),('8537','2013-04-23','13:50:00',4.59),('8537','2013-04-23','13:55:00',5.06),('8537','2013-04-23','14:00:00',2.31),('8537','2013-04-23','14:05:00',5.47),('8537','2013-04-23','14:10:00',3.06),('8537','2013-04-23','14:15:00',4.72),('8537','2013-04-23','14:20:00',4.63),('8537','2013-04-23','14:25:00',4.24),('8537','2013-04-23','14:30:00',4.83),('8537','2013-04-23','14:35:00',4.77),('8537','2013-04-23','14:40:00',4.72),('8537','2013-04-23','14:45:00',3.92),('8537','2013-04-23','14:50:00',2.5),('8537','2013-04-23','14:55:00',2.73),('8537','2013-04-23','15:00:00',2.66),('8537','2013-04-23','15:05:00',2.78),('8537','2013-04-23','15:10:00',3.07),('8537','2013-04-23','15:15:00',3.12),('8537','2013-04-23','15:20:00',3.14),('8537','2013-04-23','15:25:00',2.86),('8537','2013-04-23','15:30:00',2.8),('8537','2013-04-23','15:35:00',2.61),('8537','2013-04-23','15:40:00',2.3),('8537','2013-04-23','15:45:00',2.63),('8537','2013-04-23','15:50:00',2.16),('8537','2013-04-23','15:55:00',1.87),('8537','2013-04-23','16:00:00',2.03),('8537','2013-04-23','16:05:00',1.97),('8537','2013-04-23','16:10:00',1.93),('8537','2013-04-23','16:15:00',1.97),('8537','2013-04-23','16:20:00',1.44),('8537','2013-04-23','16:25:00',1.43),('8537','2013-04-23','16:30:00',1.32),('8537','2013-04-23','16:35:00',1.3),('8537','2013-04-23','16:40:00',1.34),('8537','2013-04-23','16:45:00',1.32),('8537','2013-04-23','16:50:00',1.17),('8537','2013-04-23','16:55:00',1.19),('8537','2013-04-23','17:00:00',1.22),('8537','2013-04-23','17:05:00',1.27),('8537','2013-04-23','17:10:00',1.7),('8537','2013-04-23','17:15:00',2.01),('8537','2013-04-23','17:20:00',1.17),('8537','2013-04-23','17:25:00',1.52),('8537','2013-04-23','17:30:00',1.36),('8537','2013-04-23','17:35:00',1.19),('8537','2013-04-23','17:40:00',1.23),('8537','2013-04-23','17:45:00',1.14),('8537','2013-04-23','17:50:00',1.02),('8537','2013-04-22','09:30:00',1.29),('8537','2013-04-22','09:35:00',1.16),('8537','2013-04-22','10:35:00',2.59),('8537','2013-04-22','10:40:00',4.22),('8537','2013-04-22','10:45:00',5.79),('8537','2013-04-22','10:50:00',2.56),('8537','2013-04-22','10:55:00',2.6),('8537','2013-04-22','11:00:00',2.43),('8537','2013-04-22','11:05:00',2.26),('8537','2013-04-22','11:10:00',2.71),('8537','2013-04-22','11:15:00',1.67),('8537','2013-04-22','11:20:00',1.7),('8537','2013-04-22','11:25:00',2.2),('8537','2013-04-22','11:30:00',3.55),('8537','2013-04-22','11:35:00',4.49),('8537','2013-04-22','11:40:00',4.79),('8537','2013-04-22','11:45:00',2.39),('8537','2013-04-22','11:50:00',1.98),('8537','2013-04-22','11:55:00',4.41),('8537','2013-04-22','12:00:00',4.21),('8537','2013-04-22','12:05:00',3.72),('8537','2013-04-22','12:10:00',4.19),('8537','2013-04-22','12:15:00',3.69),('8537','2013-04-22','12:20:00',3.66),('8537','2013-04-22','12:25:00',3.23),('8537','2013-04-22','12:30:00',2.51),('8537','2013-04-22','12:35:00',2.75),('8537','2013-04-22','12:40:00',5.5),('8537','2013-04-22','12:45:00',4.99),('8537','2013-04-22','12:50:00',5.6),('8537','2013-04-22','12:55:00',5.64),('8537','2013-04-22','13:00:00',5.65),('8537','2013-04-22','13:05:00',4.68),('8537','2013-04-22','13:10:00',4.58),('8537','2013-04-22','13:15:00',4.65),('8537','2013-04-22','13:20:00',3.45),('8537','2013-04-22','13:25:00',2.6),('8537','2013-04-22','13:30:00',2.86),('8537','2013-04-22','13:35:00',3.13),('8537','2013-04-22','13:40:00',2.34),('8537','2013-04-22','13:45:00',4.5),('8537','2013-04-22','13:50:00',1.31),('8537','2013-04-22','13:55:00',3.11),('8537','2013-04-22','14:00:00',1.41),('8537','2013-04-22','14:05:00',1.63),('8537','2013-04-22','14:10:00',2.35),('8537','2013-04-22','14:15:00',2.13),('8537','2013-04-22','14:20:00',5.27),('8537','2013-04-22','14:25:00',3.07),('8537','2013-04-22','14:30:00',5.95),('8537','2013-04-22','14:35:00',3.03),('8537','2013-04-22','14:40:00',5.43),('8537','2013-04-22','14:45:00',5.19),('8537','2013-04-22','14:50:00',5.2),('8537','2013-04-22','14:55:00',4.66),('8537','2013-04-22','15:00:00',3.27),('8537','2013-04-22','15:05:00',2.69),('8537','2013-04-22','15:10:00',2.22),('8537','2013-04-22','15:15:00',1.06),('8537','2013-04-22','15:20:00',1.12),('8537','2013-04-22','15:25:00',2.97),('8537','2013-04-22','15:30:00',1.81),('8537','2013-04-22','15:35:00',1.2),('8537','2013-04-22','15:40:00',2.25),('8537','2013-04-22','15:45:00',4.68),('8537','2013-04-22','15:50:00',3),('8537','2013-04-22','15:55:00',1.45),('8537','2013-04-22','16:45:00',1.65),('8537','2013-04-22','17:35:00',1.07),('8537','2014-03-29','07:15:00',1.1),('8537','2014-03-29','07:20:00',1.21),('8537','2014-03-29','07:25:00',1.31),('8537','2014-03-29','07:30:00',1.43),('8537','2014-03-29','07:35:00',1.53),('8537','2014-03-29','07:40:00',1.68),('8537','2014-03-29','07:45:00',1.79),('8537','2014-03-29','07:50:00',1.91),('8537','2014-03-29','07:55:00',2.02),('8537','2014-03-29','08:00:00',2.14),('8537','2014-03-29','08:05:00',2.28),('8537','2014-03-29','08:10:00',2.39),('8537','2014-03-29','08:15:00',2.48),('8537','2014-03-29','08:20:00',2.54),('8537','2014-03-29','08:25:00',2.7),('8537','2014-03-29','08:30:00',2.78),('8537','2014-03-29','08:35:00',2.88),('8537','2014-03-29','08:40:00',2.96),('8537','2014-03-29','08:45:00',3.05),('8537','2014-03-29','08:50:00',3.15),('8537','2014-03-29','08:55:00',3.2),('8537','2014-03-29','09:00:00',3.26),('8537','2014-03-29','09:05:00',3.34),('8537','2014-03-29','09:10:00',3.44),('8537','2014-03-29','09:15:00',3.55),('8537','2014-03-29','09:20:00',3.65),('8537','2014-03-29','09:25:00',3.73),('8537','2014-03-29','09:30:00',3.77),('8537','2014-03-29','09:35:00',3.84),('8537','2014-03-29','09:40:00',3.95),('8537','2014-03-29','09:45:00',3.98),('8537','2014-03-29','09:50:00',4.09),('8537','2014-03-29','09:55:00',4.18),('8537','2014-03-29','10:00:00',4.27),('8537','2014-03-29','10:05:00',4.31),('8537','2014-03-29','10:10:00',4.44),('8537','2014-03-29','10:15:00',4.51),('8537','2014-03-29','10:20:00',4.54),('8537','2014-03-29','10:25:00',4.59),('8537','2014-03-29','10:30:00',4.61),('8537','2014-03-29','10:35:00',4.64),('8537','2014-03-29','10:40:00',4.67),('8537','2014-03-29','10:45:00',4.68),('8537','2014-03-29','10:50:00',4.78),('8537','2014-03-29','10:55:00',4.83),('8537','2014-03-29','11:00:00',4.84),('8537','2014-03-29','11:05:00',4.84),('8537','2014-03-29','11:10:00',4.86),('8537','2014-03-29','11:15:00',4.9),('8537','2014-03-29','11:20:00',4.9),('8537','2014-03-29','11:25:00',4.91),('8537','2014-03-29','11:30:00',4.93),('8537','2014-03-29','11:35:00',4.87),('8537','2014-03-29','11:40:00',4.83),('8537','2014-03-29','11:45:00',5.04),('8537','2014-03-29','11:50:00',4.99),('8537','2014-03-29','11:55:00',4.94),('8537','2014-03-29','12:00:00',4.96),('8537','2014-03-29','12:05:00',4.99),('8537','2014-03-29','12:10:00',4.99),('8537','2014-03-29','12:15:00',4.97),('8537','2014-03-29','12:20:00',5.04),('8537','2014-03-29','12:25:00',5.02),('8537','2014-03-29','12:30:00',5.03),('8537','2014-03-29','12:35:00',5.02),('8537','2014-03-29','12:40:00',4.9),('8537','2014-03-29','12:45:00',4.99),('8537','2014-03-29','12:50:00',4.96),('8537','2014-03-29','12:55:00',4.92),('8537','2014-03-29','13:00:00',4.86),('8537','2014-03-29','13:05:00',4.89),('8537','2014-03-29','13:10:00',4.83),('8537','2014-03-29','13:15:00',4.82),('8537','2014-03-29','13:20:00',4.77),('8537','2014-03-29','13:25:00',4.69),('8537','2014-03-29','13:30:00',4.59),('8537','2014-03-29','13:35:00',4.26),('8537','2014-03-29','13:40:00',4.3),('8537','2014-03-29','13:45:00',4.36),('8537','2014-03-29','13:50:00',4.34),('8537','2014-03-29','13:55:00',4.3),('8537','2014-03-29','14:00:00',4.25),('8537','2014-03-29','14:05:00',4.23),('8537','2014-03-29','14:10:00',4.19),('8537','2014-03-29','14:15:00',4.08),('8537','2014-03-29','14:20:00',3.99),('8537','2014-03-29','14:25:00',3.82),('8537','2014-03-29','14:30:00',3.82),('8537','2014-03-29','14:35:00',3.34),('8537','2014-03-29','14:40:00',3.33),('8537','2014-03-29','14:45:00',3.44),('8537','2014-03-29','14:50:00',3.55),('8537','2014-03-29','14:55:00',3.57),('8537','2014-03-29','15:00:00',3.41),('8537','2014-03-29','15:05:00',3.28),('8537','2014-03-29','15:10:00',3.14),('8537','2014-03-29','15:15:00',3.13),('8537','2014-03-29','15:20:00',3.07),('8537','2014-03-29','15:25:00',2.97),('8537','2014-03-29','15:30:00',2.81),('8537','2014-03-29','15:35:00',2.6),('8537','2014-03-29','15:40:00',2.47),('8537','2014-03-29','15:45:00',2.54),('8537','2014-03-29','15:50:00',2.44),('8537','2014-03-29','15:55:00',2.29),('8537','2014-03-29','16:00:00',2.19),('8537','2014-03-29','16:05:00',2.1),('8537','2014-03-29','16:10:00',1.98),('8537','2014-03-29','16:15:00',1.88),('8537','2014-03-29','16:20:00',1.69),('8537','2014-03-29','16:25:00',1.62),('8537','2014-03-29','16:30:00',1.54),('8537','2014-03-29','16:35:00',1.38),('8537','2014-03-29','16:40:00',1.21),('8537','2014-03-29','16:50:00',1.02),('8537','2014-03-29','16:55:00',1.04),('8537','2013-04-21','08:00:00',1),('8537','2013-04-21','08:05:00',1.14),('8537','2013-04-21','08:10:00',1.24),('8537','2013-04-21','08:15:00',1.49),('8537','2013-04-21','08:20:00',1.18),('8537','2013-04-21','08:25:00',1.36),('8537','2013-04-21','08:30:00',1.25),('8537','2013-04-21','08:35:00',1.51),('8537','2013-04-21','08:40:00',1.73),('8537','2013-04-21','08:45:00',1.62),('8537','2013-04-21','08:50:00',1.6),('8537','2013-04-21','08:55:00',2.36),('8537','2013-04-21','09:00:00',2.25),('8537','2013-04-21','09:05:00',2.21),('8537','2013-04-21','09:10:00',2.91),('8537','2013-04-21','09:15:00',2.66),('8537','2013-04-21','09:20:00',1.98),('8537','2013-04-21','09:25:00',2.41),('8537','2013-04-21','09:30:00',3.57),('8537','2013-04-21','09:35:00',3.67),('8537','2013-04-21','09:40:00',3.73),('8537','2013-04-21','09:45:00',3.98),('8537','2013-04-21','09:50:00',4.54),('8537','2013-04-21','09:55:00',3.93),('8537','2013-04-21','10:00:00',3.6),('8537','2013-04-21','10:05:00',2.84),('8537','2013-04-21','10:10:00',2.35),('8537','2013-04-21','10:15:00',2.16),('8537','2013-04-21','10:20:00',3.83),('8537','2013-04-21','10:25:00',3.43),('8537','2013-04-21','10:30:00',3.46),('8537','2013-04-21','10:35:00',2.39),('8537','2013-04-21','10:40:00',3.3),('8537','2013-04-21','10:45:00',3.51),('8537','2013-04-21','10:50:00',4.77),('8537','2013-04-21','10:55:00',3.37),('8537','2013-04-21','11:00:00',4.8),('8537','2013-04-21','11:05:00',3.87),('8537','2013-04-21','11:10:00',4.59),('8537','2013-04-21','11:15:00',3.53),('8537','2013-04-21','11:20:00',3.7),('8537','2013-04-21','11:25:00',3.75),('8537','2013-04-21','11:30:00',3.34),('8537','2013-04-21','11:35:00',3.34),('8537','2013-04-21','11:40:00',3.67),('8537','2013-04-21','11:45:00',4.1),('8537','2013-04-21','11:50:00',3.62),('8537','2013-04-21','11:55:00',3.81),('8537','2013-04-21','12:00:00',2.88),('8537','2013-04-21','12:05:00',2.98),('8537','2013-04-21','12:10:00',2.97),('8537','2013-04-21','12:15:00',2.66),('8537','2013-04-21','12:20:00',2.41),('8537','2013-04-21','12:25:00',2.32),('8537','2013-04-21','12:30:00',2.55),('8537','2013-04-21','12:35:00',2.6),('8537','2013-04-21','12:40:00',2.6),('8537','2013-04-21','12:45:00',2.61),('8537','2013-04-21','12:50:00',2.43),('8537','2013-04-21','12:55:00',2.37),('8537','2013-04-21','13:00:00',2.72),('8537','2013-04-21','13:05:00',3.14),('8537','2013-04-21','13:10:00',3.26),('8537','2013-04-21','13:15:00',2.97),('8537','2013-04-21','13:20:00',2.8),('8537','2013-04-21','13:25:00',2.68),('8537','2013-04-21','13:30:00',4.05),('8537','2013-04-21','13:35:00',2.85),('8537','2013-04-21','13:40:00',3.44),('8537','2013-04-21','13:45:00',3.54),('8537','2013-04-21','13:50:00',3.12),('8537','2013-04-21','13:55:00',4.65),('8537','2013-04-21','14:00:00',5.56),('8537','2013-04-21','14:05:00',4.86),('8537','2013-04-21','14:10:00',4.91),('8537','2013-04-21','14:15:00',4.28),('8537','2013-04-21','14:20:00',5.88),('8537','2013-04-21','14:25:00',4.57),('8537','2013-04-21','14:30:00',4.8),('8537','2013-04-21','14:35:00',5.1),('8537','2013-04-21','14:40:00',5.41),('8537','2013-04-21','14:45:00',4.5),('8537','2013-04-21','14:50:00',2.56),('8537','2013-04-21','14:55:00',2.44),('8537','2013-04-21','15:00:00',3.05),('8537','2013-04-21','15:05:00',4.94),('8537','2013-04-21','15:10:00',4.97),('8537','2013-04-21','15:15:00',3.67),('8537','2013-04-21','15:20:00',2.51),('8537','2013-04-21','15:25:00',2.32),('8537','2013-04-21','15:30:00',2.04),('8537','2013-04-21','15:35:00',1.7),('8537','2013-04-21','15:40:00',1.77),('8537','2013-04-21','15:45:00',1.47),('8537','2013-04-21','15:50:00',1.24),('8537','2013-04-21','15:55:00',1.12),('8537','2013-04-21','16:00:00',1),('8537','2013-04-21','17:00:00',1.05),('8537','2013-04-21','17:05:00',1.05),('8537','2013-04-20','07:35:00',1.01),('8537','2013-04-20','07:40:00',1.08),('8537','2013-04-20','07:55:00',1.11),('8537','2013-04-20','08:00:00',1.26),('8537','2013-04-20','08:05:00',1.41),('8537','2013-04-20','08:10:00',1.57),('8537','2013-04-20','08:15:00',1.45),('8537','2013-04-20','08:20:00',1.41),('8537','2013-04-20','08:25:00',1.56),('8537','2013-04-20','08:30:00',1.81),('8537','2013-04-20','08:35:00',2),('8537','2013-04-20','08:40:00',2.15),('8537','2013-04-20','08:45:00',2.25),('8537','2013-04-20','08:50:00',2.24),('8537','2013-04-20','08:55:00',2.15),('8537','2013-04-20','09:00:00',2.63),('8537','2013-04-20','09:05:00',2.75),('8537','2013-04-20','09:10:00',2.72),('8537','2013-04-20','09:15:00',2.74),('8537','2013-04-20','09:20:00',3.14),('8537','2013-04-20','09:25:00',2.86),('8537','2013-04-20','09:30:00',2.53),('8537','2013-04-20','09:35:00',1.64),('8537','2013-04-20','09:40:00',1.3),('8537','2013-04-20','09:45:00',1.41),('8537','2013-04-20','09:50:00',1.4),('8537','2013-04-20','10:40:00',1.84),('8537','2013-04-20','10:45:00',4.02),('8537','2013-04-20','10:50:00',3.31),('8537','2013-04-20','10:55:00',2.22),('8537','2013-04-20','11:00:00',3.4),('8537','2013-04-20','11:05:00',2.85),('8537','2013-04-20','11:10:00',4.37),('8537','2013-04-20','11:15:00',5.31),('8537','2013-04-20','11:20:00',2.96),('8537','2013-04-20','11:25:00',3.73),('8537','2013-04-20','11:30:00',5.34),('8537','2013-04-20','11:35:00',3.26),('8537','2013-04-20','11:40:00',1.98),('8537','2013-04-20','11:45:00',3.19),('8537','2013-04-20','11:50:00',5.54),('8537','2013-04-20','11:55:00',5.47),('8537','2013-04-20','12:00:00',5.34),('8537','2013-04-20','12:05:00',4.73),('8537','2013-04-20','12:10:00',5.25),('8537','2013-04-20','12:15:00',3),('8537','2013-04-20','12:20:00',5.35),('8537','2013-04-20','12:25:00',2.76),('8537','2013-04-20','12:30:00',5.02),('8537','2013-04-20','12:35:00',3.31),('8537','2013-04-20','12:40:00',3.47),('8537','2013-04-20','12:45:00',5.73),('8537','2013-04-20','12:50:00',5.39),('8537','2013-04-20','12:55:00',5.18),('8537','2013-04-20','13:00:00',4.62),('8537','2013-04-20','13:05:00',3.05),('8537','2013-04-20','13:10:00',5.51),('8537','2013-04-20','13:15:00',4.38),('8537','2013-04-20','13:20:00',2.72),('8537','2013-04-20','13:25:00',5.52),('8537','2013-04-20','13:30:00',3.29),('8537','2013-04-20','13:35:00',2.18),('8537','2013-04-20','13:40:00',4.89),('8537','2013-04-20','13:45:00',3.12),('8537','2013-04-20','13:50:00',3.16),('8537','2013-04-20','13:55:00',3.85),('8537','2013-04-20','14:00:00',2.98),('8537','2013-04-20','14:05:00',5.41),('8537','2013-04-20','14:10:00',4.58),('8537','2013-04-20','14:15:00',5.01),('8537','2013-04-20','14:20:00',4.88),('8537','2013-04-20','14:25:00',4.84),('8537','2013-04-20','14:30:00',4.69),('8537','2013-04-20','14:35:00',4.45),('8537','2013-04-20','14:40:00',4.14),('8537','2013-04-20','14:45:00',4.27),('8537','2013-04-20','14:50:00',4.66),('8537','2013-04-20','14:55:00',4.65),('8537','2013-04-20','15:00:00',4.59),('8537','2013-04-20','15:05:00',4.51),('8537','2013-04-20','15:10:00',2.64),('8537','2013-04-20','15:15:00',3.31),('8537','2013-04-20','15:20:00',2.74),('8537','2013-04-20','15:25:00',3.84),('8537','2013-04-20','15:30:00',2.28),('8537','2013-04-20','15:35:00',1.04),('8537','2013-04-20','16:05:00',1.21),('8537','2013-04-20','16:10:00',1.67),('8537','2013-04-20','16:15:00',2.37),('8537','2013-04-20','16:20:00',2.38),('8537','2013-04-20','16:25:00',2.97),('8537','2013-04-20','16:30:00',3.08),('8537','2013-04-20','16:35:00',2.95),('8537','2013-04-20','16:40:00',3.26),('8537','2013-04-20','16:45:00',3.3),('8537','2013-04-20','16:50:00',3),('8537','2013-04-20','16:55:00',2.85),('8537','2013-04-20','17:00:00',2.69),('8537','2013-04-20','17:05:00',2.46),('8537','2013-04-20','17:10:00',2.35),('8537','2013-04-20','17:15:00',2.12),('8537','2013-04-20','17:20:00',1.9),('8537','2013-04-20','17:25:00',2.03),('8537','2013-04-20','17:30:00',2.15),('8537','2013-04-20','17:35:00',2.04),('8537','2013-04-20','17:40:00',1.91),('8537','2013-04-20','17:55:00',1.41),('8537','2013-04-20','18:00:00',1.19),('8537','2013-04-20','18:05:00',1.29),('8537','2013-04-20','18:10:00',1.24),('8537','2013-04-19','08:00:00',1.02),('8537','2013-04-19','08:05:00',1.35),('8537','2013-04-19','08:15:00',1.08),('8537','2013-04-19','08:20:00',1.68),('8537','2013-04-19','08:25:00',1.77),('8537','2013-04-19','08:30:00',1.71),('8537','2013-04-19','08:35:00',1.93),('8537','2013-04-19','08:40:00',2.15),('8537','2013-04-19','08:45:00',2.25),('8537','2013-04-19','08:50:00',2.37),('8537','2013-04-19','08:55:00',2.48),('8537','2013-04-19','09:00:00',2.59),('8537','2013-04-19','09:05:00',2.65),('8537','2013-04-19','09:10:00',2.74),('8537','2013-04-19','09:15:00',2.81),('8537','2013-04-19','09:20:00',2.92),('8537','2013-04-19','09:25:00',2.99),('8537','2013-04-19','09:30:00',3.1),('8537','2013-04-19','09:35:00',3.23),('8537','2013-04-19','09:40:00',3.31),('8537','2013-04-19','09:45:00',3.39),('8537','2013-04-19','09:50:00',3.41),('8537','2013-04-19','09:55:00',3.44),('8537','2013-04-19','10:00:00',3.5),('8537','2013-04-19','10:05:00',3.63),('8537','2013-04-19','10:10:00',3.68),('8537','2013-04-19','10:15:00',3.82),('8537','2013-04-19','10:20:00',3.63),('8537','2013-04-19','10:25:00',3.63),('8537','2013-04-19','10:30:00',3.48),('8537','2013-04-19','10:35:00',2.67),('8537','2013-04-19','10:40:00',4.12),('8537','2013-04-19','10:45:00',4.13),('8537','2013-04-19','10:50:00',4.14),('8537','2013-04-19','10:55:00',4.17),('8537','2013-04-19','11:00:00',4.22),('8537','2013-04-19','11:05:00',4.3),('8537','2013-04-19','11:10:00',4.31),('8537','2013-04-19','11:15:00',4.35),('8537','2013-04-19','11:20:00',4.4),('8537','2013-04-19','11:25:00',4.4),('8537','2013-04-19','11:30:00',4.43),('8537','2013-04-19','11:35:00',4.49),('8537','2013-04-19','11:40:00',4.56),('8537','2013-04-19','11:45:00',4.64),('8537','2013-04-19','11:50:00',4.68),('8537','2013-04-19','11:55:00',4.69),('8537','2013-04-19','12:00:00',4.67),('8537','2013-04-19','12:05:00',4.65),('8537','2013-04-19','12:10:00',4.68),('8537','2013-04-19','12:15:00',4.71),('8537','2013-04-19','12:20:00',4.78),('8537','2013-04-19','12:25:00',4.78),('8537','2013-04-19','12:30:00',4.73),('8537','2013-04-19','12:35:00',4.83),('8537','2013-04-19','12:40:00',4.84),('8537','2013-04-19','12:45:00',4.84),('8537','2013-04-19','12:50:00',4.71),('8537','2013-04-19','12:55:00',4.81),('8537','2013-04-19','13:00:00',4.87),('8537','2013-04-19','13:05:00',4.86),('8537','2013-04-19','13:10:00',4.92),('8537','2013-04-19','13:15:00',4.96),('8537','2013-04-19','13:20:00',4.86),('8537','2013-04-19','13:25:00',4.91),('8537','2013-04-19','13:30:00',4.97),('8537','2013-04-19','13:35:00',4.76),('8537','2013-04-19','13:40:00',4.84),('8537','2013-04-19','13:45:00',4.81),('8537','2013-04-19','13:50:00',4.76),('8537','2013-04-19','13:55:00',4.75),('8537','2013-04-19','14:00:00',4.71),('8537','2013-04-19','14:05:00',4.63),('8537','2013-04-19','14:10:00',4.7),('8537','2013-04-19','14:15:00',4.62),('8537','2013-04-19','14:20:00',4.61),('8537','2013-04-19','14:25:00',4.6),('8537','2013-04-19','14:30:00',4.47),('8537','2013-04-19','14:35:00',4.34),('8537','2013-04-19','14:40:00',4.39),('8537','2013-04-19','14:45:00',4.36),('8537','2013-04-19','14:50:00',4.33),('8537','2013-04-19','14:55:00',4.27),('8537','2013-04-19','15:00:00',4.21),('8537','2013-04-19','15:05:00',4.15),('8537','2013-04-19','15:10:00',4.1),('8537','2013-04-19','15:15:00',4.09),('8537','2013-04-19','15:20:00',3.97),('8537','2013-04-19','15:25:00',3.92),('8537','2013-04-19','15:30:00',3.69),('8537','2013-04-19','15:35:00',3.82),('8537','2013-04-19','15:40:00',3.71),('8537','2013-04-19','15:45:00',3.68),('8537','2013-04-19','15:50:00',3.6),('8537','2013-04-19','15:55:00',3.57),('8537','2013-04-19','16:00:00',3.51),('8537','2013-04-19','16:05:00',3.37),('8537','2013-04-19','16:10:00',3.26),('8537','2013-04-19','16:15:00',3.17),('8537','2013-04-19','16:20:00',3.09),('8537','2013-04-19','16:25:00',3.05),('8537','2013-04-19','16:30:00',2.94),('8537','2013-04-19','16:35:00',2.8),('8537','2013-04-19','16:40:00',2.76),('8537','2013-04-19','16:45:00',2.44),('8537','2013-04-19','16:50:00',2.09),('8537','2013-04-19','16:55:00',2.44),('8537','2013-04-19','17:00:00',2.35),('8537','2013-04-19','17:05:00',2.2),('8537','2013-04-19','17:10:00',2.07),('8537','2013-04-19','17:15:00',1.99),('8537','2013-04-19','17:20:00',1.89),('8537','2013-04-19','17:25:00',1.78),('8537','2013-04-19','17:30:00',1.69),('8537','2013-04-19','17:35:00',1.56),('8537','2013-04-19','17:40:00',1.47),('8537','2013-04-19','17:45:00',1.37),('8537','2013-04-19','17:50:00',1.24),('8537','2013-04-19','17:55:00',1.15),('8537','2013-04-19','18:00:00',1.07),('8537','2013-04-18','08:05:00',1.01),('8537','2013-04-18','08:10:00',1.29),('8537','2013-04-18','08:15:00',1.44),('8537','2013-04-18','08:20:00',1.46),('8537','2013-04-18','08:25:00',1.48),('8537','2013-04-18','08:30:00',1.67),('8537','2013-04-18','08:35:00',1.75),('8537','2013-04-18','08:40:00',1.72),('8537','2013-04-18','08:45:00',1.78),('8537','2013-04-18','08:50:00',1.96),('8537','2013-04-18','08:55:00',2.26),('8537','2013-04-18','09:00:00',2.11),('8537','2013-04-18','09:05:00',2.5),('8537','2013-04-18','09:10:00',2.52),('8537','2013-04-18','09:15:00',2.59),('8537','2013-04-18','09:20:00',2.73),('8537','2013-04-18','09:25:00',2.82),('8537','2013-04-18','09:30:00',3),('8537','2013-04-18','09:35:00',3.16),('8537','2013-04-18','09:40:00',3.61),('8537','2013-04-18','09:45:00',3.24),('8537','2013-04-18','09:50:00',2.85),('8537','2013-04-18','09:55:00',2.86),('8537','2013-04-18','10:00:00',3.4),('8537','2013-04-18','10:05:00',3.77),('8537','2013-04-18','10:10:00',3.83),('8537','2013-04-18','10:15:00',3.94),('8537','2013-04-18','10:20:00',4.05),('8537','2013-04-18','10:25:00',4),('8537','2013-04-18','10:30:00',4.12),('8537','2013-04-18','10:35:00',4.15),('8537','2013-04-18','10:40:00',4.24),('8537','2013-04-18','10:45:00',4.32),('8537','2013-04-18','10:50:00',4.38),('8537','2013-04-18','10:55:00',4.43),('8537','2013-04-18','11:00:00',4.49),('8537','2013-04-18','11:05:00',4.53),('8537','2013-04-18','11:10:00',4.59),('8537','2013-04-18','11:15:00',4.64),('8537','2013-04-18','11:20:00',4.67),('8537','2013-04-18','11:25:00',4.67),('8537','2013-04-18','11:30:00',4.68),('8537','2013-04-18','11:35:00',4.72),('8537','2013-04-18','11:40:00',4.75),('8537','2013-04-18','11:45:00',4.73),('8537','2013-04-18','11:50:00',4.78),('8537','2013-04-18','11:55:00',4.85),('8537','2013-04-18','12:00:00',4.75),('8537','2013-04-18','12:05:00',4.92),('8537','2013-04-18','12:10:00',4.95),('8537','2013-04-18','12:15:00',4.98),('8537','2013-04-18','12:20:00',5.03),('8537','2013-04-18','12:25:00',5.03),('8537','2013-04-18','12:30:00',5.04),('8537','2013-04-18','12:35:00',5.03),('8537','2013-04-18','12:40:00',5.02),('8537','2013-04-18','12:45:00',5.05),('8537','2013-04-18','12:50:00',5.05),('8537','2013-04-18','12:55:00',5.05),('8537','2013-04-18','13:00:00',5.07),('8537','2013-04-18','13:05:00',5.08),('8537','2013-04-18','13:10:00',5.09),('8537','2013-04-18','13:15:00',5.02),('8537','2013-04-18','13:20:00',5.05),('8537','2013-04-18','13:25:00',5.06),('8537','2013-04-18','13:30:00',5.09),('8537','2013-04-18','13:35:00',5.05),('8537','2013-04-18','13:40:00',5.02),('8537','2013-04-18','13:45:00',4.98),('8537','2013-04-18','13:50:00',5.02),('8537','2013-04-18','13:55:00',5.04),('8537','2013-04-18','14:00:00',5),('8537','2013-04-18','14:05:00',4.96),('8537','2013-04-18','14:10:00',4.93),('8537','2013-04-18','14:15:00',4.91),('8537','2013-04-18','14:20:00',4.87),('8537','2013-04-18','14:25:00',4.85),('8537','2013-04-18','14:30:00',4.77),('8537','2013-04-18','14:35:00',4.72),('8537','2013-04-18','14:40:00',4.65),('8537','2013-04-18','14:45:00',4.59),('8537','2013-04-18','14:50:00',4.56),('8537','2013-04-18','14:55:00',4.54),('8537','2013-04-18','15:00:00',4.44),('8537','2013-04-18','15:05:00',4.42),('8537','2013-04-18','15:10:00',4.37),('8537','2013-04-18','15:15:00',4.32),('8537','2013-04-18','15:20:00',4.26),('8537','2013-04-18','15:25:00',4.09),('8537','2013-04-18','15:30:00',3.89),('8537','2013-04-18','15:35:00',4.02),('8537','2013-04-18','15:40:00',3.98),('8537','2013-04-18','15:45:00',3.91),('8537','2013-04-18','15:50:00',3.84),('8537','2013-04-18','15:55:00',3.76),('8537','2013-04-18','16:00:00',3.66),('8537','2013-04-18','16:05:00',3.5),('8537','2013-04-18','16:10:00',3.01),('8537','2013-04-18','16:15:00',3.35),('8537','2013-04-18','16:20:00',3.26),('8537','2013-04-18','16:25:00',3.16),('8537','2013-04-18','16:30:00',3.09),('8537','2013-04-18','16:35:00',3.01),('8537','2013-04-18','16:40:00',2.88),('8537','2013-04-18','16:45:00',2.48),('8537','2013-04-18','16:50:00',2.63),('8537','2013-04-18','16:55:00',2.62),('8537','2013-04-18','17:00:00',2.48),('8537','2013-04-18','17:05:00',2.3),('8537','2013-04-18','17:10:00',2.23),('8537','2013-04-18','17:15:00',2.16),('8537','2013-04-18','17:20:00',2.05),('8537','2013-04-18','17:25:00',1.92),('8537','2013-04-18','17:30:00',1.82),('8537','2013-04-18','17:35:00',1.69),('8537','2013-04-18','17:40:00',1.59),('8537','2013-04-18','17:45:00',1.49),('8537','2013-04-18','17:50:00',1.4),('8537','2013-04-18','17:55:00',1.28),('8537','2013-04-18','18:00:00',1.18),('8537','2013-04-18','18:05:00',1.08),('8537','2013-04-17','07:50:00',1.05),('8537','2013-04-17','07:55:00',1.16),('8537','2013-04-17','08:00:00',1.28),('8537','2013-04-17','08:05:00',1.39),('8537','2013-04-17','08:10:00',1.52),('8537','2013-04-17','08:15:00',1.65),('8537','2013-04-17','08:20:00',1.76),('8537','2013-04-17','08:25:00',1.88),('8537','2013-04-17','08:30:00',1.99),('8537','2013-04-17','08:35:00',2.11),('8537','2013-04-17','08:40:00',2.22),('8537','2013-04-17','08:45:00',2.33),('8537','2013-04-17','08:50:00',2.44),('8537','2013-04-17','08:55:00',2.55),('8537','2013-04-17','09:00:00',2.65),('8537','2013-04-17','09:05:00',2.77),('8537','2013-04-17','09:10:00',2.87),('8537','2013-04-17','09:15:00',2.97),('8537','2013-04-17','09:20:00',3.06),('8537','2013-04-17','09:25:00',3.16),('8537','2013-04-17','09:30:00',3.24),('8537','2013-04-17','09:35:00',3.35),('8537','2013-04-17','09:40:00',3.45),('8537','2013-04-17','09:45:00',3.52),('8537','2013-04-17','09:50:00',3.59),('8537','2013-04-17','09:55:00',3.68),('8537','2013-04-17','10:00:00',3.74),('8537','2013-04-17','10:05:00',3.85),('8537','2013-04-17','10:10:00',3.93),('8537','2013-04-17','10:15:00',4),('8537','2013-04-17','10:20:00',4.04),('8537','2013-04-17','10:25:00',4.13),('8537','2013-04-17','10:30:00',4.19),('8537','2013-04-17','10:35:00',4.23),('8537','2013-04-17','10:40:00',4.3),('8537','2013-04-17','10:45:00',4.35),('8537','2013-04-17','10:50:00',4.41),('8537','2013-04-17','10:55:00',4.47),('8537','2013-04-17','11:00:00',4.55),('8537','2013-04-17','11:05:00',4.54),('8537','2013-04-17','11:10:00',4.68),('8537','2013-04-17','11:15:00',4.72),('8537','2013-04-17','11:20:00',4.71),('8537','2013-04-17','11:25:00',4.76),('8537','2013-04-17','11:30:00',4.78),('8537','2013-04-17','11:35:00',4.82),('8537','2013-04-17','11:40:00',4.84),('8537','2013-04-17','11:45:00',4.86),('8537','2013-04-17','11:50:00',4.92),('8537','2013-04-17','11:55:00',4.96),('8537','2013-04-17','12:00:00',4.95),('8537','2013-04-17','12:05:00',4.94),('8537','2013-04-17','12:10:00',4.93),('8537','2013-04-17','12:15:00',5.02),('8537','2013-04-17','12:20:00',5),('8537','2013-04-17','12:25:00',5.06),('8537','2013-04-17','12:30:00',5.13),('8537','2013-04-17','12:35:00',5.11),('8537','2013-04-17','12:40:00',5.06),('8537','2013-04-17','12:45:00',5.03),('8537','2013-04-17','12:50:00',4.97),('8537','2013-04-17','12:55:00',5.11),('8537','2013-04-17','13:00:00',5.13),('8537','2013-04-17','13:05:00',5.1),('8537','2013-04-17','13:10:00',5.1),('8537','2013-04-17','13:15:00',5.2),('8537','2013-04-17','13:20:00',5.23),('8537','2013-04-17','13:25:00',5.21),('8537','2013-04-17','13:30:00',5.16),('8537','2013-04-17','13:35:00',5.09),('8537','2013-04-17','13:40:00',5.2),('8537','2013-04-17','13:45:00',4.84),('8537','2013-04-17','13:50:00',4.78),('8537','2013-04-17','13:55:00',5.14),('8537','2013-04-17','14:00:00',4.99),('8537','2013-04-17','14:05:00',5.36),('8537','2013-04-17','14:10:00',5.21),('8537','2013-04-17','14:15:00',4.7),('8537','2013-04-17','14:20:00',4.61),('8537','2013-04-17','14:25:00',4.54),('8537','2013-04-17','14:30:00',4.5),('8537','2013-04-17','14:35:00',5.09),('8537','2013-04-17','14:40:00',4.88),('8537','2013-04-17','14:45:00',4.21),('8537','2013-04-17','14:50:00',4.82),('8537','2013-04-17','14:55:00',4.96),('8537','2013-04-17','15:00:00',4.88),('8537','2013-04-17','15:05:00',4.95),('8537','2013-04-17','15:10:00',5.11),('8537','2013-04-17','15:15:00',4.75),('8537','2013-04-17','15:20:00',2.53),('8537','2013-04-17','15:25:00',2.62),('8537','2013-04-17','15:30:00',4.02),('8537','2013-04-17','15:35:00',4.28),('8537','2013-04-17','15:40:00',4.28),('8537','2013-04-17','15:45:00',4.24),('8537','2013-04-17','15:50:00',4.22),('8537','2013-04-17','15:55:00',4.23),('8537','2013-04-17','16:00:00',4.09),('8537','2013-04-17','16:05:00',2.94),('8537','2013-04-17','16:10:00',3.82),('8537','2013-04-17','16:15:00',3.66),('8537','2013-04-17','16:20:00',3.5),('8537','2013-04-17','16:25:00',3.4),('8537','2013-04-17','16:30:00',3.32),('8537','2013-04-17','16:35:00',3.3),('8537','2013-04-17','16:40:00',2.97),('8537','2013-04-17','16:45:00',3.1),('8537','2013-04-17','16:50:00',2.87),('8537','2013-04-17','16:55:00',2.74),('8537','2013-04-17','17:00:00',2.6),('8537','2013-04-17','17:05:00',2.33),('8537','2013-04-17','17:10:00',2.31),('8537','2013-04-17','17:15:00',2.22),('8537','2013-04-17','17:20:00',2.1),('8537','2013-04-17','17:25:00',1.98),('8537','2013-04-17','17:30:00',1.86),('8537','2013-04-17','17:35:00',1.71),('8537','2013-04-17','17:40:00',1.61),('8537','2013-04-17','17:45:00',1.51),('8537','2013-04-17','17:50:00',1.39),('8537','2013-04-17','17:55:00',1.29),('8537','2013-04-17','18:00:00',1.19),('8537','2013-04-17','18:05:00',1.1),('8537','2013-04-16','07:55:00',1.02),('8537','2013-04-16','08:05:00',1.26),('8537','2013-04-16','08:10:00',1.32),('8537','2013-04-16','08:25:00',1.04),('8537','2013-04-16','08:30:00',1.06),('8537','2013-04-16','08:35:00',1.01),('8537','2013-04-16','08:40:00',1.04),('8537','2013-04-16','08:45:00',1.12),('8537','2013-04-16','08:50:00',1.25),('8537','2013-04-16','08:55:00',1.31),('8537','2013-04-16','09:00:00',1.47),('8537','2013-04-16','09:05:00',1.13),('8537','2013-04-16','09:10:00',1.61),('8537','2013-04-16','09:15:00',1.44),('8537','2013-04-16','09:20:00',1.53),('8537','2013-04-16','09:25:00',1.99),('8537','2013-04-16','09:30:00',2),('8537','2013-04-16','09:35:00',1.98),('8537','2013-04-16','09:40:00',1.67),('8537','2013-04-16','09:45:00',1.74),('8537','2013-04-16','09:50:00',1.68),('8537','2013-04-16','09:55:00',1.62),('8537','2013-04-16','10:00:00',1.56),('8537','2013-04-16','10:05:00',1.55),('8537','2013-04-16','10:10:00',1.63),('8537','2013-04-16','10:15:00',1.74),('8537','2013-04-16','10:20:00',1.83),('8537','2013-04-16','10:25:00',1.87),('8537','2013-04-16','10:30:00',1.89),('8537','2013-04-16','10:35:00',1.92),('8537','2013-04-16','10:40:00',1.87),('8537','2013-04-16','10:45:00',1.79),('8537','2013-04-16','10:50:00',1.81),('8537','2013-04-16','10:55:00',1.92),('8537','2013-04-16','11:00:00',2.1),('8537','2013-04-16','11:05:00',2.16),('8537','2013-04-16','11:10:00',2.16),('8537','2013-04-16','11:15:00',2.23),('8537','2013-04-16','11:20:00',2.29),('8537','2013-04-16','11:25:00',2.24),('8537','2013-04-16','11:30:00',2.2),('8537','2013-04-16','11:35:00',2.15),('8537','2013-04-16','11:40:00',2.37),('8537','2013-04-16','11:45:00',2.78),('8537','2013-04-16','11:50:00',2.97),('8537','2013-04-16','11:55:00',3.07),('8537','2013-04-16','12:00:00',3.15),('8537','2013-04-16','12:05:00',3.51),('8537','2013-04-16','12:10:00',3.64),('8537','2013-04-16','12:15:00',4.16),('8537','2013-04-16','12:20:00',3.73),('8537','2013-04-16','12:25:00',3.61),('8537','2013-04-16','12:30:00',4.22),('8537','2013-04-16','12:35:00',5.08),('8537','2013-04-16','12:40:00',5.22),('8537','2013-04-16','12:45:00',4.96),('8537','2013-04-16','12:50:00',3.76),('8537','2013-04-16','12:55:00',4.91),('8537','2013-04-16','13:00:00',5.04),('8537','2013-04-16','13:05:00',4.86),('8537','2013-04-16','13:10:00',4.88),('8537','2013-04-16','13:15:00',4.88),('8537','2013-04-16','13:20:00',4.96),('8537','2013-04-16','13:25:00',4.95),('8537','2013-04-16','13:30:00',4.97),('8537','2013-04-16','13:35:00',4.92),('8537','2013-04-16','13:40:00',4.88),('8537','2013-04-16','13:45:00',4.84),('8537','2013-04-16','13:50:00',4.81),('8537','2013-04-16','13:55:00',4.57),('8537','2013-04-16','14:00:00',4.73),('8537','2013-04-16','14:05:00',4.82),('8537','2013-04-16','14:10:00',4.83),('8537','2013-04-16','14:15:00',4.78),('8537','2013-04-16','14:20:00',4.7),('8537','2013-04-16','14:25:00',3.77),('8537','2013-04-16','14:30:00',3.94),('8537','2013-04-16','14:35:00',3.66),('8537','2013-04-16','14:40:00',4.37),('8537','2013-04-16','14:45:00',4.58),('8537','2013-04-16','14:50:00',4.38),('8537','2013-04-16','14:55:00',4.26),('8537','2013-04-16','15:00:00',4.39),('8537','2013-04-16','15:05:00',4.33),('8537','2013-04-16','15:10:00',4.31),('8537','2013-04-16','15:15:00',4.29),('8537','2013-04-16','15:20:00',4.23),('8537','2013-04-16','15:25:00',3.92),('8537','2013-04-16','15:30:00',3.88),('8537','2013-04-16','15:35:00',3.9),('8537','2013-04-16','15:40:00',3.88),('8537','2013-04-16','15:45:00',3.81),('8537','2013-04-16','15:50:00',3.79),('8537','2013-04-16','15:55:00',3.69),('8537','2013-04-16','16:00:00',3.5),('8537','2013-04-16','16:05:00',3.43),('8537','2013-04-16','16:10:00',3.01),('8537','2013-04-16','16:15:00',3.19),('8537','2013-04-16','16:20:00',3.28),('8537','2013-04-16','16:25:00',3.19),('8537','2013-04-16','16:30:00',3.11),('8537','2013-04-16','16:35:00',3.05),('8537','2013-04-16','16:40:00',3.12),('8537','2013-04-16','16:45:00',3.2),('8537','2013-04-16','16:50:00',2.92),('8537','2013-04-16','16:55:00',2.52),('8537','2013-04-16','17:00:00',2.49),('8537','2013-04-16','17:05:00',2.44),('8537','2013-04-16','17:10:00',2.5),('8537','2013-04-16','17:15:00',2.41),('8537','2013-04-16','17:20:00',2.32),('8537','2013-04-16','17:25:00',2.26),('8537','2013-04-16','17:30:00',2.02),('8537','2013-04-16','17:35:00',2),('8537','2013-04-16','17:40:00',1.95),('8537','2013-04-16','17:45:00',1.78),('8537','2013-04-16','17:50:00',1.6),('8537','2013-04-16','17:55:00',1.33),('8537','2013-04-15','07:50:00',1),('8537','2013-04-15','07:55:00',1.11),('8537','2013-04-15','08:00:00',1.22),('8537','2013-04-15','08:05:00',1.33),('8537','2013-04-15','08:10:00',1.43),('8537','2013-04-15','08:15:00',1.53),('8537','2013-04-15','08:20:00',1.64),('8537','2013-04-15','08:25:00',1.76),('8537','2013-04-15','08:30:00',1.87),('8537','2013-04-15','08:35:00',1.98),('8537','2013-04-15','08:40:00',2.09),('8537','2013-04-15','08:45:00',2.18),('8537','2013-04-15','08:50:00',2.3),('8537','2013-04-15','08:55:00',2.41),('8537','2013-04-15','09:00:00',2.5),('8537','2013-04-15','09:05:00',2.62),('8537','2013-04-15','09:10:00',2.74),('8537','2013-04-15','09:15:00',2.84),('8537','2013-04-15','09:20:00',2.93),('8537','2013-04-15','09:25:00',3.01),('8537','2013-04-15','09:30:00',3.12),('8537','2013-04-15','09:35:00',3.2),('8537','2013-04-15','09:40:00',3.23),('8537','2013-04-15','09:45:00',3.16),('8537','2013-04-15','09:50:00',3.33),('8537','2013-04-15','09:55:00',3.44),('8537','2013-04-15','10:00:00',3.42),('8537','2013-04-15','10:05:00',3.42),('8537','2013-04-15','10:10:00',3.5),('8537','2013-04-15','10:15:00',3.54),('8537','2013-04-15','10:20:00',3.67),('8537','2013-04-15','10:25:00',3.86),('8537','2013-04-15','10:30:00',3.64),('8537','2013-04-15','10:35:00',3.76),('8537','2013-04-15','10:40:00',3.94),('8537','2013-04-15','10:45:00',4.11),('8537','2013-04-15','10:50:00',4.2),('8537','2013-04-15','10:55:00',4.39),('8537','2013-04-15','11:00:00',4.29),('8537','2013-04-15','11:05:00',4.28),('8537','2013-04-15','11:10:00',4.39),('8537','2013-04-15','11:15:00',4.57),('8537','2013-04-15','11:20:00',4.75),('8537','2013-04-15','11:25:00',4.79),('8537','2013-04-15','11:30:00',4.82),('8537','2013-04-15','11:35:00',4.87),('8537','2013-04-15','11:40:00',4.86),('8537','2013-04-15','11:45:00',4.91),('8537','2013-04-15','11:50:00',4.92),('8537','2013-04-15','11:55:00',4.93),('8537','2013-04-15','12:00:00',4.96),('8537','2013-04-15','12:05:00',4.98),('8537','2013-04-15','12:10:00',4.98),('8537','2013-04-15','12:15:00',4.99),('8537','2013-04-15','12:20:00',5.05),('8537','2013-04-15','12:25:00',5),('8537','2013-04-15','12:30:00',5.07),('8537','2013-04-15','12:35:00',5.13),('8537','2013-04-15','12:40:00',5.04),('8537','2013-04-15','12:45:00',5.04),('8537','2013-04-15','12:50:00',5.02),('8537','2013-04-15','12:55:00',5),('8537','2013-04-15','13:00:00',5.07),('8537','2013-04-15','13:05:00',5.05),('8537','2013-04-15','13:10:00',5.11),('8537','2013-04-15','13:15:00',5.12),('8537','2013-04-15','13:20:00',5.11),('8537','2013-04-15','13:25:00',5.08),('8537','2013-04-15','13:30:00',5.04),('8537','2013-04-15','13:35:00',5.03),('8537','2013-04-15','13:40:00',4.98),('8537','2013-04-15','13:45:00',4.93),('8537','2013-04-15','13:50:00',4.94),('8537','2013-04-15','13:55:00',4.98),('8537','2013-04-15','14:00:00',4.97),('8537','2013-04-15','14:05:00',4.99),('8537','2013-04-15','14:10:00',4.98),('8537','2013-04-15','14:15:00',4.94),('8537','2013-04-15','14:20:00',4.92),('8537','2013-04-15','14:25:00',4.9),('8537','2013-04-15','14:30:00',4.78),('8537','2013-04-15','14:35:00',4.44),('8537','2013-04-15','14:40:00',4.04),('8537','2013-04-15','14:45:00',4.67),('8537','2013-04-15','14:50:00',4.62),('8537','2013-04-15','14:55:00',4.58),('8537','2013-04-15','15:00:00',4.53),('8537','2013-04-15','15:05:00',4.51),('8537','2013-04-15','15:10:00',4.46),('8537','2013-04-15','15:15:00',4.39),('8537','2013-04-15','15:20:00',4.32),('8537','2013-04-15','15:25:00',4.09),('8537','2013-04-15','15:30:00',4.09),('8537','2013-04-15','15:35:00',4.11),('8537','2013-04-15','15:40:00',4.04),('8537','2013-04-15','15:45:00',3.97),('8537','2013-04-15','15:50:00',3.9),('8537','2013-04-15','15:55:00',3.82),('8537','2013-04-15','16:00:00',3.74),('8537','2013-04-15','16:05:00',3.58),('8537','2013-04-15','16:10:00',3.54),('8537','2013-04-15','16:15:00',3.46),('8537','2013-04-15','16:20:00',3.36),('8537','2013-04-15','16:25:00',3.27),('8537','2013-04-15','16:30:00',3.19),('8537','2013-04-15','16:35:00',3.11),('8537','2013-04-15','16:40:00',2.88),('8537','2013-04-15','16:45:00',2.8),('8537','2013-04-15','16:50:00',2.77),('8537','2013-04-15','16:55:00',2.66),('8537','2013-04-15','17:00:00',2.53),('8537','2013-04-15','17:05:00',2.39),('8537','2013-04-15','17:10:00',2.3),('8537','2013-04-15','17:15:00',2.2),('8537','2013-04-15','17:20:00',2.09),('8537','2013-04-15','17:25:00',1.97),('8537','2013-04-15','17:30:00',1.84),('8537','2013-04-15','17:35:00',1.72),('8537','2013-04-15','17:40:00',1.62),('8537','2013-04-15','17:45:00',1.51),('8537','2013-04-15','17:50:00',1.4),('8537','2013-04-15','17:55:00',1.29),('8537','2013-04-15','18:00:00',1.19),('8537','2013-04-15','18:05:00',1.09),('8537','2013-04-14','07:55:00',1.07),('8537','2013-04-14','08:00:00',1.15),('8537','2013-04-14','08:05:00',1.13),('8537','2013-04-14','08:10:00',1.29),('8537','2013-04-14','08:15:00',1.43),('8537','2013-04-14','08:20:00',1.53),('8537','2013-04-14','08:25:00',1.64),('8537','2013-04-14','08:30:00',1.75),('8537','2013-04-14','08:35:00',1.85),('8537','2013-04-14','08:40:00',1.96),('8537','2013-04-14','08:45:00',2.06),('8537','2013-04-14','08:50:00',2.17),('8537','2013-04-14','08:55:00',2.28),('8537','2013-04-14','09:00:00',2.38),('8537','2013-04-14','09:05:00',2.47),('8537','2013-04-14','09:10:00',2.56),('8537','2013-04-14','09:15:00',2.65),('8537','2013-04-14','09:20:00',2.76),('8537','2013-04-14','09:25:00',2.86),('8537','2013-04-14','09:30:00',2.95),('8537','2013-04-14','09:35:00',3.04),('8537','2013-04-14','09:40:00',3.11),('8537','2013-04-14','09:45:00',3.22),('8537','2013-04-14','09:50:00',3.3),('8537','2013-04-14','09:55:00',3.41),('8537','2013-04-14','10:00:00',3.5),('8537','2013-04-14','10:05:00',3.56),('8537','2013-04-14','10:10:00',3.64),('8537','2013-04-14','10:15:00',3.71),('8537','2013-04-14','10:20:00',3.79),('8537','2013-04-14','10:25:00',3.83),('8537','2013-04-14','10:30:00',3.94),('8537','2013-04-14','10:35:00',3.98),('8537','2013-04-14','10:40:00',4.08),('8537','2013-04-14','10:45:00',4.11),('8537','2013-04-14','10:50:00',4.14),('8537','2013-04-14','10:55:00',4.19),('8537','2013-04-14','11:00:00',4.25),('8537','2013-04-14','11:05:00',4.35),('8537','2013-04-14','11:10:00',4.42),('8537','2013-04-14','11:15:00',4.47),('8537','2013-04-14','11:20:00',4.52),('8537','2013-04-14','11:25:00',4.48),('8537','2013-04-14','11:30:00',4.52),('8537','2013-04-14','11:35:00',4.53),('8537','2013-04-14','11:40:00',4.61),('8537','2013-04-14','11:45:00',4.64),('8537','2013-04-14','11:50:00',4.66),('8537','2013-04-14','11:55:00',4.7),('8537','2013-04-14','12:00:00',4.71),('8537','2013-04-14','12:05:00',4.74),('8537','2013-04-14','12:10:00',4.75),('8537','2013-04-14','12:15:00',4.73),('8537','2013-04-14','12:20:00',4.78),('8537','2013-04-14','12:25:00',4.8),('8537','2013-04-14','12:30:00',4.82),('8537','2013-04-14','12:35:00',4.8),('8537','2013-04-14','12:40:00',3.58),('8537','2013-04-14','12:45:00',3.28),('8537','2013-04-14','12:50:00',5.19),('8537','2013-04-14','12:55:00',4.86),('8537','2013-04-14','13:00:00',4.95),('8537','2013-04-14','13:05:00',3.46),('8537','2013-04-14','13:10:00',4.26),('8537','2013-04-14','13:15:00',5.1),('8537','2013-04-14','13:20:00',5.05),('8537','2013-04-14','13:25:00',4.99),('8537','2013-04-14','13:30:00',4.94),('8537','2013-04-14','13:35:00',4.91),('8537','2013-04-14','13:40:00',4.84),('8537','2013-04-14','13:45:00',4.83),('8537','2013-04-14','13:50:00',4.74),('8537','2013-04-14','13:55:00',4.72),('8537','2013-04-14','14:00:00',4.72),('8537','2013-04-14','14:05:00',4.76),('8537','2013-04-14','14:10:00',4.73),('8537','2013-04-14','14:15:00',4.75),('8537','2013-04-14','14:20:00',4.75),('8537','2013-04-14','14:25:00',4.67),('8537','2013-04-14','14:30:00',4.54),('8537','2013-04-14','14:35:00',4.37),('8537','2013-04-14','14:40:00',4.08),('8537','2013-04-14','14:45:00',4.55),('8537','2013-04-14','14:50:00',4.7),('8537','2013-04-14','14:55:00',4.53),('8537','2013-04-14','15:00:00',4.36),('8537','2013-04-14','15:05:00',4.35),('8537','2013-04-14','15:10:00',4.08),('8537','2013-04-14','15:15:00',3.38),('8537','2013-04-14','15:20:00',3.99),('8537','2013-04-14','15:25:00',3.43),('8537','2013-04-14','15:30:00',2.91),('8537','2013-04-14','15:35:00',4.02),('8537','2013-04-14','15:40:00',3.97),('8537','2013-04-14','15:45:00',3.91),('8537','2013-04-14','15:50:00',3.78),('8537','2013-04-14','15:55:00',2.86),('8537','2013-04-14','16:00:00',3.23),('8537','2013-04-14','16:05:00',3.28),('8537','2013-04-14','16:10:00',3.05),('8537','2013-04-14','16:15:00',3.11),('8537','2013-04-14','16:20:00',3.04),('8537','2013-04-14','16:25:00',3.05),('8537','2013-04-14','16:30:00',2.94),('8537','2013-04-14','16:35:00',2.81),('8537','2013-04-14','16:40:00',2.62),('8537','2013-04-14','16:45:00',2.42),('8537','2013-04-14','16:50:00',2.5),('8537','2013-04-14','16:55:00',2.38),('8537','2013-04-14','17:00:00',2.26),('8537','2013-04-14','17:05:00',2.14),('8537','2013-04-14','17:10:00',2.06),('8537','2013-04-14','17:15:00',1.95),('8537','2013-04-14','17:20:00',1.85),('8537','2013-04-14','17:25:00',1.72),('8537','2013-04-14','17:30:00',1.61),('8537','2013-04-14','17:35:00',1.53),('8537','2013-04-14','17:40:00',1.43),('8537','2013-04-14','17:45:00',1.35),('8537','2013-04-14','17:50:00',1.25),('8537','2013-04-14','17:55:00',1.13),('8537','2013-04-14','18:00:00',1.04),('8537','2013-04-13','08:00:00',1.11),('8537','2013-04-13','08:05:00',1.16),('8537','2013-04-13','08:10:00',1.25),('8537','2013-04-13','08:15:00',1.12),('8537','2013-04-13','08:50:00',1.01),('8537','2013-04-13','08:55:00',1.34),('8537','2013-04-13','09:00:00',1.23),('8537','2013-04-13','09:05:00',1.81),('8537','2013-04-13','09:10:00',1.5),('8537','2013-04-13','09:15:00',1.62),('8537','2013-04-13','09:20:00',1.14),('8537','2013-04-13','09:25:00',2.34),('8537','2013-04-13','09:30:00',2.91),('8537','2013-04-13','09:35:00',2.92),('8537','2013-04-13','09:40:00',2.73),('8537','2013-04-13','09:45:00',3.21),('8537','2013-04-13','09:50:00',3.33),('8537','2013-04-13','09:55:00',3.43),('8537','2013-04-13','10:00:00',3.48),('8537','2013-04-13','10:05:00',3.53),('8537','2013-04-13','10:10:00',3.83),('8537','2013-04-13','10:15:00',3.14),('8537','2013-04-13','10:20:00',1.79),('8537','2013-04-13','10:25:00',3.9),('8537','2013-04-13','10:30:00',4.19),('8537','2013-04-13','10:35:00',1.25),('8537','2013-04-13','10:40:00',3.54),('8537','2013-04-13','10:45:00',3.14),('8537','2013-04-13','10:50:00',1.87),('8537','2013-04-13','10:55:00',3.12),('8537','2013-04-13','11:00:00',1.92),('8537','2013-04-13','11:05:00',3.68),('8537','2013-04-13','11:10:00',4.38),('8537','2013-04-13','11:15:00',4.59),('8537','2013-04-13','11:20:00',4.93),('8537','2013-04-13','11:25:00',2.65),('8537','2013-04-13','11:30:00',3.01),('8537','2013-04-13','11:35:00',5.11),('8537','2013-04-13','11:40:00',4.96),('8537','2013-04-13','11:45:00',4.17),('8537','2013-04-13','11:50:00',4.09),('8537','2013-04-13','11:55:00',4.62),('8537','2013-04-13','12:00:00',5.13),('8537','2013-04-13','12:05:00',5),('8537','2013-04-13','12:10:00',5.12),('8537','2013-04-13','12:15:00',5.04),('8537','2013-04-13','12:20:00',4.95),('8537','2013-04-13','12:25:00',4.17),('8537','2013-04-13','12:30:00',4.6),('8537','2013-04-13','12:35:00',5.11),('8537','2013-04-13','12:40:00',5.1),('8537','2013-04-13','12:45:00',4.99),('8537','2013-04-13','12:50:00',4.91),('8537','2013-04-13','12:55:00',4.94),('8537','2013-04-13','13:00:00',4.78),('8537','2013-04-13','13:05:00',5.04),('8537','2013-04-13','13:10:00',5.14),('8537','2013-04-13','13:15:00',4.8),('8537','2013-04-13','13:20:00',4.86),('8537','2013-04-13','13:25:00',5.03),('8537','2013-04-13','13:30:00',4.17),('8537','2013-04-13','13:35:00',1.96),('8537','2013-04-13','13:40:00',2.8),('8537','2013-04-13','13:45:00',3.66),('8537','2013-04-13','13:50:00',2.48),('8537','2013-04-13','13:55:00',1.92),('8537','2013-04-13','14:00:00',1.87),('8537','2013-04-13','14:05:00',2.89),('8537','2013-04-13','14:10:00',1.87),('8537','2013-04-13','14:15:00',2.53),('8537','2013-04-13','14:20:00',4.21),('8537','2013-04-13','14:25:00',4.06),('8537','2013-04-13','14:30:00',4.29),('8537','2013-04-13','14:35:00',4.33),('8537','2013-04-13','14:40:00',4.23),('8537','2013-04-13','14:45:00',4.26),('8537','2013-04-13','14:50:00',4.05),('8537','2013-04-13','14:55:00',4.11),('8537','2013-04-13','15:00:00',3.77),('8537','2013-04-13','15:05:00',3.28),('8537','2013-04-13','15:10:00',3.6),('8537','2013-04-13','15:15:00',3.28),('8537','2013-04-13','15:20:00',3.26),('8537','2013-04-13','15:25:00',3.02),('8537','2013-04-13','15:30:00',3.05),('8537','2013-04-13','15:35:00',2.98),('8537','2013-04-13','15:40:00',3.1),('8537','2013-04-13','15:45:00',3.15),('8537','2013-04-13','15:50:00',3.04),('8537','2013-04-13','15:55:00',3.05),('8537','2013-04-13','16:00:00',3),('8537','2013-04-13','16:05:00',2.77),('8537','2013-04-13','16:10:00',2.56),('8537','2013-04-13','16:15:00',2.63),('8537','2013-04-13','16:20:00',2.57),('8537','2013-04-13','16:25:00',2.38),('8537','2013-04-13','16:30:00',2.27),('8537','2013-04-13','16:35:00',2.13),('8537','2013-04-13','16:40:00',2.02),('8537','2013-04-13','16:45:00',1.87),('8537','2013-04-13','16:50:00',1.94),('8537','2013-04-13','16:55:00',1.61),('8537','2013-04-13','17:00:00',1.39),('8537','2013-04-13','17:05:00',1.33),('8537','2013-04-13','17:10:00',1.63),('8537','2013-04-13','17:15:00',1.75),('8537','2013-04-13','17:20:00',1.68),('8537','2013-04-13','17:25:00',1.88),('8537','2013-04-13','17:30:00',1.62),('8537','2013-04-13','17:35:00',1.61),('8537','2013-04-13','17:40:00',1.52),('8537','2013-04-13','17:45:00',1.35),('8537','2013-04-13','17:50:00',1.17),('8537','2013-04-13','17:55:00',1.24),('8537','2013-04-12','08:00:00',1.13),('8537','2013-04-12','08:05:00',1.31),('8537','2013-04-12','08:10:00',1.34),('8537','2013-04-12','08:15:00',1.06),('8537','2013-04-12','08:20:00',1.23),('8537','2013-04-12','08:35:00',1.41),('8537','2013-04-12','08:40:00',1.18),('8537','2013-04-12','08:45:00',1.33),('8537','2013-04-12','08:50:00',1.58),('8537','2013-04-12','08:55:00',1.83),('8537','2013-04-12','09:00:00',2.48),('8537','2013-04-12','09:05:00',2.05),('8537','2013-04-12','09:10:00',1.69),('8537','2013-04-12','09:15:00',2.05),('8537','2013-04-12','09:20:00',2.34),('8537','2013-04-12','09:25:00',1.89),('8537','2013-04-12','09:30:00',1.79),('8537','2013-04-12','09:35:00',1.33),('8537','2013-04-12','09:40:00',1.53),('8537','2013-04-12','09:45:00',1.86),('8537','2013-04-12','09:50:00',1.34),('8537','2013-04-12','09:55:00',1.07),('8537','2013-04-12','10:05:00',1.05),('8537','2013-04-12','10:10:00',1),('8537','2013-04-12','10:15:00',1.15),('8537','2013-04-12','10:20:00',2.49),('8537','2013-04-12','10:25:00',1.72),('8537','2013-04-12','10:30:00',1.29),('8537','2013-04-12','10:35:00',1.72),('8537','2013-04-12','10:40:00',2.18),('8537','2013-04-12','10:45:00',5.15),('8537','2013-04-12','10:50:00',4.89),('8537','2013-04-12','10:55:00',4.74),('8537','2013-04-12','11:00:00',2),('8537','2013-04-12','11:05:00',2.29),('8537','2013-04-12','11:10:00',2.05),('8537','2013-04-12','11:15:00',3.97),('8537','2013-04-12','11:20:00',5.11),('8537','2013-04-12','11:25:00',4.85),('8537','2013-04-12','11:30:00',3.83),('8537','2013-04-12','11:35:00',3.97),('8537','2013-04-12','11:40:00',5.46),('8537','2013-04-12','11:45:00',3.3),('8537','2013-04-12','11:50:00',4.36),('8537','2013-04-12','11:55:00',5.07),('8537','2013-04-12','12:00:00',5),('8537','2013-04-12','12:05:00',4.82),('8537','2013-04-12','12:10:00',4.71),('8537','2013-04-12','12:15:00',4.91),('8537','2013-04-12','12:20:00',5.11),('8537','2013-04-12','12:25:00',4.89),('8537','2013-04-12','12:30:00',5.04),('8537','2013-04-12','12:35:00',5.02),('8537','2013-04-12','12:40:00',4.74),('8537','2013-04-12','12:45:00',4.86),('8537','2013-04-12','12:50:00',4.78),('8537','2013-04-12','12:55:00',4.94),('8537','2013-04-12','13:00:00',5.05),('8537','2013-04-12','13:05:00',5.01),('8537','2013-04-12','13:10:00',5.04),('8537','2013-04-12','13:15:00',5.02),('8537','2013-04-12','13:20:00',5.04),('8537','2013-04-12','13:25:00',5.03),('8537','2013-04-12','13:30:00',4.98),('8537','2013-04-12','13:35:00',5.03),('8537','2013-04-12','13:40:00',4.98),('8537','2013-04-12','13:45:00',5),('8537','2013-04-12','13:50:00',4.94),('8537','2013-04-12','13:55:00',4.91),('8537','2013-04-12','14:00:00',4.89),('8537','2013-04-12','14:05:00',4.88),('8537','2013-04-12','14:10:00',4.85),('8537','2013-04-12','14:15:00',4.81),('8537','2013-04-12','14:20:00',4.78),('8537','2013-04-12','14:25:00',4.73),('8537','2013-04-12','14:30:00',4.61),('8537','2013-04-12','14:35:00',4.3),('8537','2013-04-12','14:40:00',4.54),('8537','2013-04-12','14:45:00',4.5),('8537','2013-04-12','14:50:00',4.45),('8537','2013-04-12','14:55:00',4.38),('8537','2013-04-12','15:00:00',4.35),('8537','2013-04-12','15:05:00',4.29),('8537','2013-04-12','15:10:00',4.2),('8537','2013-04-12','15:15:00',4.16),('8537','2013-04-12','15:20:00',4.09),('8537','2013-04-12','15:25:00',3.96),('8537','2013-04-12','15:30:00',3.9),('8537','2013-04-12','15:35:00',3.86),('8537','2013-04-12','15:40:00',3.79),('8537','2013-04-12','15:45:00',3.73),('8537','2013-04-12','15:50:00',3.68),('8537','2013-04-12','15:55:00',3.52),('8537','2013-04-12','16:00:00',3.53),('8537','2013-04-12','16:05:00',3.34),('8537','2013-04-12','16:10:00',3.29),('8537','2013-04-12','16:15:00',2.94),('8537','2013-04-12','16:20:00',3.12),('8537','2013-04-12','16:25:00',3.09),('8537','2013-04-12','16:30:00',1.94),('8537','2013-04-12','16:35:00',1.39),('8537','2013-04-12','16:40:00',1.82),('8537','2013-04-12','16:45:00',2.78),('8537','2013-04-12','16:50:00',2.57),('8537','2013-04-12','16:55:00',2.48),('8537','2013-04-12','17:00:00',2.32),('8537','2013-04-12','17:05:00',2.22),('8537','2013-04-12','17:10:00',2.08),('8537','2013-04-12','17:15:00',1.99),('8537','2013-04-12','17:20:00',1.9),('8537','2013-04-12','17:25:00',1.77),('8537','2013-04-12','17:30:00',1.68),('8537','2013-04-12','17:35:00',1.57),('8537','2013-04-12','17:40:00',1.47),('8537','2013-04-12','17:45:00',1.37),('8537','2013-04-12','17:50:00',1.27),('8537','2013-04-12','17:55:00',1.15),('8537','2013-04-12','18:00:00',1.07),('8537','2014-03-28','07:10:00',1.1),('8537','2014-03-28','07:15:00',1.2),('8537','2014-03-28','07:20:00',1.29),('8537','2014-03-28','07:25:00',1.34),('8537','2014-03-28','07:30:00',1.39),('8537','2014-03-28','07:35:00',1.62),('8537','2014-03-28','07:40:00',1.68),('8537','2014-03-28','07:45:00',1.89),('8537','2014-03-28','07:50:00',2.02),('8537','2014-03-28','07:55:00',2.12),('8537','2014-03-28','08:00:00',2.22),('8537','2014-03-28','08:05:00',2.36),('8537','2014-03-28','08:10:00',2.48),('8537','2014-03-28','08:15:00',2.61),('8537','2014-03-28','08:20:00',2.72),('8537','2014-03-28','08:25:00',2.8),('8537','2014-03-28','08:30:00',2.9),('8537','2014-03-28','08:35:00',3),('8537','2014-03-28','08:40:00',3.11),('8537','2014-03-28','08:45:00',3.19),('8537','2014-03-28','08:50:00',3.3),('8537','2014-03-28','08:55:00',3.36),('8537','2014-03-28','09:00:00',3.42),('8537','2014-03-28','09:05:00',3.65),('8537','2014-03-28','09:10:00',3.84),('8537','2014-03-28','09:15:00',3.83),('8537','2014-03-28','09:20:00',3.34),('8537','2014-03-28','09:25:00',3.99),('8537','2014-03-28','09:30:00',4.27),('8537','2014-03-28','09:35:00',3.84),('8537','2014-03-28','09:40:00',2.55),('8537','2014-03-28','09:45:00',2.13),('8537','2014-03-28','09:50:00',2.74),('8537','2014-03-28','09:55:00',4.22),('8537','2014-03-28','10:00:00',4.59),('8537','2014-03-28','10:05:00',4.54),('8537','2014-03-28','10:10:00',3.83),('8537','2014-03-28','10:15:00',3.45),('8537','2014-03-28','10:20:00',3.24),('8537','2014-03-28','10:25:00',4.39),('8537','2014-03-28','10:30:00',4.64),('8537','2014-03-28','10:35:00',4.13),('8537','2014-03-28','10:40:00',4.31),('8537','2014-03-28','10:45:00',3.37),('8537','2014-03-28','10:50:00',4.83),('8537','2014-03-28','10:55:00',4.95),('8537','2014-03-28','11:00:00',4.5),('8537','2014-03-28','11:05:00',4.96),('8537','2014-03-28','11:10:00',4.16),('8537','2014-03-28','11:15:00',2.75),('8537','2014-03-28','11:20:00',4.27),('8537','2014-03-28','11:25:00',1.93),('8537','2014-03-28','11:30:00',3.3),('8537','2014-03-28','11:35:00',3.25),('8537','2014-03-28','11:40:00',2.82),('8537','2014-03-28','11:45:00',2.3),('8537','2014-03-28','11:50:00',1.55),('8537','2014-03-28','11:55:00',1.48),('8537','2014-03-28','12:00:00',4.18),('8537','2014-03-28','12:05:00',5.13),('8537','2014-03-28','12:10:00',5.45),('8537','2014-03-28','12:15:00',5.62),('8537','2014-03-28','12:20:00',5.12),('8537','2014-03-28','12:25:00',1.87),('8537','2014-03-28','12:30:00',1.22),('8537','2014-03-28','12:35:00',4.15),('8537','2014-03-28','12:40:00',4.52),('8537','2014-03-28','12:45:00',5.29),('8537','2014-03-28','12:50:00',5.19),('8537','2014-03-28','12:55:00',4.91),('8537','2014-03-28','13:00:00',5.68),('8537','2014-03-28','13:05:00',3.49),('8537','2014-03-28','13:10:00',1.77),('8537','2014-03-28','13:15:00',2.44),('8537','2014-03-28','13:20:00',4.7),('8537','2014-03-28','13:25:00',3.09),('8537','2014-03-28','13:30:00',1.95),('8537','2014-03-28','13:35:00',5.22),('8537','2014-03-28','13:40:00',5.02),('8537','2014-03-28','13:45:00',4.77),('8537','2014-03-28','13:50:00',4.61),('8537','2014-03-28','13:55:00',4.46),('8537','2014-03-28','14:00:00',4.55),('8537','2014-03-28','14:05:00',4.49),('8537','2014-03-28','14:10:00',4.24),('8537','2014-03-28','14:15:00',4.33),('8537','2014-03-28','14:20:00',4.18),('8537','2014-03-28','14:25:00',3.93),('8537','2014-03-28','14:30:00',4.1),('8537','2014-03-28','14:35:00',4.06),('8537','2014-03-28','14:40:00',4),('8537','2014-03-28','14:45:00',3.92),('8537','2014-03-28','14:50:00',3.86),('8537','2014-03-28','14:55:00',3.74),('8537','2014-03-28','15:00:00',3.69),('8537','2014-03-28','15:05:00',3.6),('8537','2014-03-28','15:10:00',3.5),('8537','2014-03-28','15:15:00',3.41),('8537','2014-03-28','15:20:00',3.31),('8537','2014-03-28','15:25:00',3.21),('8537','2014-03-28','15:30:00',3.15),('8537','2014-03-28','15:35:00',2.88),('8537','2014-03-28','15:40:00',2.66),('8537','2014-03-28','15:45:00',2.91),('8537','2014-03-28','15:50:00',2.83),('8537','2014-03-28','15:55:00',2.58),('8537','2014-03-28','16:00:00',2.7),('8537','2014-03-28','16:05:00',2.75),('8537','2014-03-28','16:10:00',2.64),('8537','2014-03-28','16:15:00',2.52),('8537','2014-03-28','16:20:00',2.18),('8537','2014-03-28','16:25:00',1.84),('8537','2014-03-28','16:30:00',1.55),('8537','2014-03-28','16:35:00',1.02),('8537','2014-03-28','16:45:00',1.15),('8537','2014-03-28','16:50:00',1.16),('8537','2013-04-11','08:00:00',1.1),('8537','2013-04-11','08:05:00',1.2),('8537','2013-04-11','08:10:00',1.31),('8537','2013-04-11','08:15:00',1.41),('8537','2013-04-11','08:20:00',1.52),('8537','2013-04-11','08:25:00',1.63),('8537','2013-04-11','08:30:00',1.73),('8537','2013-04-11','08:35:00',1.83),('8537','2013-04-11','08:40:00',1.94),('8537','2013-04-11','08:45:00',2.04),('8537','2013-04-11','08:50:00',2.16),('8537','2013-04-11','08:55:00',2.28),('8537','2013-04-11','09:00:00',2.37),('8537','2013-04-11','09:05:00',2.47),('8537','2013-04-11','09:10:00',2.57),('8537','2013-04-11','09:15:00',2.67),('8537','2013-04-11','09:20:00',2.78),('8537','2013-04-11','09:25:00',2.8),('8537','2013-04-11','09:30:00',2.94),('8537','2013-04-11','09:35:00',3.01),('8537','2013-04-11','09:40:00',3.15),('8537','2013-04-11','09:45:00',3.29),('8537','2013-04-11','09:50:00',3.47),('8537','2013-04-11','09:55:00',2.83),('8537','2013-04-11','10:00:00',1.12),('8537','2013-04-11','10:05:00',1.39),('8537','2013-04-11','10:10:00',1.53),('8537','2013-04-11','10:15:00',2.38),('8537','2013-04-11','10:20:00',3.04),('8537','2013-04-11','10:25:00',4.02),('8537','2013-04-11','10:30:00',4.07),('8537','2013-04-11','10:35:00',4.34),('8537','2013-04-11','10:40:00',4.54),('8537','2013-04-11','10:45:00',4.59),('8537','2013-04-11','10:50:00',2.74),('8537','2013-04-11','10:55:00',1.39),('8537','2013-04-11','11:05:00',3.46),('8537','2013-04-11','11:10:00',4.07),('8537','2013-04-11','11:15:00',4.8),('8537','2013-04-11','11:20:00',3.77),('8537','2013-04-11','11:25:00',1.18),('8537','2013-04-11','11:30:00',4.01),('8537','2013-04-11','11:35:00',3.8),('8537','2013-04-11','11:40:00',2.58),('8537','2013-04-11','11:45:00',1.62),('8537','2013-04-11','11:50:00',1.32),('8537','2013-04-11','11:55:00',4.51),('8537','2013-04-11','12:00:00',5.64),('8537','2013-04-11','12:05:00',5.39),('8537','2013-04-11','12:10:00',5.41),('8537','2013-04-11','12:15:00',2.62),('8537','2013-04-11','12:20:00',4.34),('8537','2013-04-11','12:25:00',5.33),('8537','2013-04-11','12:30:00',5.19),('8537','2013-04-11','12:35:00',4.83),('8537','2013-04-11','12:40:00',5.26),('8537','2013-04-11','12:45:00',5.05),('8537','2013-04-11','12:50:00',4.45),('8537','2013-04-11','12:55:00',5.02),('8537','2013-04-11','13:00:00',5.22),('8537','2013-04-11','13:05:00',5.35),('8537','2013-04-11','13:10:00',5.23),('8537','2013-04-11','13:15:00',5.13),('8537','2013-04-11','13:20:00',3.3),('8537','2013-04-11','13:25:00',5.13),('8537','2013-04-11','13:30:00',5.15),('8537','2013-04-11','13:35:00',5.11),('8537','2013-04-11','13:40:00',5.04),('8537','2013-04-11','13:45:00',5),('8537','2013-04-11','13:50:00',4.98),('8537','2013-04-11','13:55:00',4.99),('8537','2013-04-11','14:00:00',4.98),('8537','2013-04-11','14:05:00',4.93),('8537','2013-04-11','14:10:00',4.98),('8537','2013-04-11','14:15:00',4.92),('8537','2013-04-11','14:20:00',4.87),('8537','2013-04-11','14:25:00',4.83),('8537','2013-04-11','14:30:00',4.72),('8537','2013-04-11','14:35:00',4.72),('8537','2013-04-11','14:40:00',4.83),('8537','2013-04-11','14:45:00',4.71),('8537','2013-04-11','14:50:00',4.55),('8537','2013-04-11','14:55:00',4.48),('8537','2013-04-11','15:00:00',4.43),('8537','2013-04-11','15:05:00',4.37),('8537','2013-04-11','15:10:00',4.32),('8537','2013-04-11','15:15:00',4.25),('8537','2013-04-11','15:20:00',4.17),('8537','2013-04-11','15:25:00',3.89),('8537','2013-04-11','15:30:00',4.01),('8537','2013-04-11','15:35:00',3.95),('8537','2013-04-11','15:40:00',3.87),('8537','2013-04-11','15:45:00',3.81),('8537','2013-04-11','15:50:00',3.71),('8537','2013-04-11','15:55:00',3.64),('8537','2013-04-11','16:00:00',3.58),('8537','2013-04-11','16:05:00',3.42),('8537','2013-04-11','16:10:00',3.37),('8537','2013-04-11','16:15:00',3.28),('8537','2013-04-11','16:20:00',3.21),('8537','2013-04-11','16:25:00',3.13),('8537','2013-04-11','16:30:00',3.04),('8537','2013-04-11','16:35:00',2.95),('8537','2013-04-11','16:40:00',2.71),('8537','2013-04-11','16:45:00',2.14),('8537','2013-04-11','16:50:00',2.47),('8537','2013-04-11','16:55:00',2.54),('8537','2013-04-11','17:00:00',2.38),('8537','2013-04-11','17:05:00',2.25),('8537','2013-04-11','17:10:00',2.16),('8537','2013-04-11','17:15:00',2.07),('8537','2013-04-11','17:20:00',1.93),('8537','2013-04-11','17:25:00',1.83),('8537','2013-04-11','17:30:00',1.72),('8537','2013-04-11','17:35:00',1.62),('8537','2013-04-11','17:40:00',1.53),('8537','2013-04-11','17:45:00',1.42),('8537','2013-04-11','17:50:00',1.32),('8537','2013-04-11','17:55:00',1.19),('8537','2013-04-11','18:00:00',1.07),('8537','2013-04-10','08:55:00',2.04),('8537','2013-04-10','09:00:00',2.37),('8537','2013-04-10','09:05:00',2.58),('8537','2013-04-10','09:10:00',2.72),('8537','2013-04-10','09:15:00',2.58),('8537','2013-04-10','09:20:00',2.81),('8537','2013-04-10','09:25:00',2.62),('8537','2013-04-10','09:30:00',2.87),('8537','2013-04-10','09:35:00',3.15),('8537','2013-04-10','09:40:00',3.23),('8537','2013-04-10','09:45:00',3.35),('8537','2013-04-10','09:50:00',3.45),('8537','2013-04-10','09:55:00',3.57),('8537','2013-04-10','10:00:00',3.65),('8537','2013-04-10','10:05:00',3.79),('8537','2013-04-10','10:10:00',4.06),('8537','2013-04-10','10:15:00',4.16),('8537','2013-04-10','10:20:00',4.2),('8537','2013-04-10','10:25:00',4.25),('8537','2013-04-10','10:30:00',4.26),('8537','2013-04-10','10:35:00',4.28),('8537','2013-04-10','10:40:00',4.28),('8537','2013-04-10','10:45:00',4.44),('8537','2013-04-10','10:50:00',4.2),('8537','2013-04-10','10:55:00',4.09),('8537','2013-04-10','11:00:00',4.15),('8537','2013-04-10','11:05:00',4.15),('8537','2013-04-10','11:10:00',4.26),('8537','2013-04-10','11:15:00',3.66),('8537','2013-04-10','11:20:00',4.53),('8537','2013-04-10','11:25:00',4.32),('8537','2013-04-10','11:30:00',4.65),('8537','2013-04-10','11:35:00',4.77),('8537','2013-04-10','11:40:00',4.8),('8537','2013-04-10','11:45:00',4.81),('8537','2013-04-10','11:50:00',4.77),('8537','2013-04-10','11:55:00',4.91),('8537','2013-04-10','12:00:00',4.93),('8537','2013-04-10','12:05:00',4.99),('8537','2013-04-10','12:10:00',5.01),('8537','2013-04-10','12:15:00',5.02),('8537','2013-04-10','12:20:00',5.08),('8537','2013-04-10','12:25:00',5.12),('8537','2013-04-10','12:30:00',5.17),('8537','2013-04-10','12:35:00',5.13),('8537','2013-04-10','12:40:00',5.01),('8537','2013-04-10','12:45:00',5.12),('8537','2013-04-10','12:50:00',5.22),('8537','2013-04-10','12:55:00',5.14),('8537','2013-04-10','13:00:00',5.28),('8537','2013-04-10','13:05:00',4.71),('8537','2013-04-10','13:10:00',4.96),('8537','2013-04-10','13:15:00',3),('8537','2013-04-10','13:20:00',5.06),('8537','2013-04-10','13:25:00',2.39),('8537','2013-04-10','13:30:00',3.79),('8537','2013-04-10','13:35:00',4.35),('8537','2013-04-10','13:40:00',4.18),('8537','2013-04-10','13:45:00',5.04),('8537','2013-04-10','13:50:00',4.26),('8537','2013-04-10','13:55:00',2.64),('8537','2013-04-10','14:00:00',4.59),('8537','2013-04-10','14:05:00',5.08),('8537','2013-04-10','14:10:00',5.17),('8537','2013-04-10','14:15:00',5.01),('8537','2013-04-10','14:20:00',5.02),('8537','2013-04-10','14:25:00',4.95),('8537','2013-04-10','14:30:00',4.89),('8537','2013-04-10','14:35:00',4.72),('8537','2013-04-10','14:40:00',4.79),('8537','2013-04-10','14:45:00',4.16),('8537','2013-04-10','14:50:00',4.52),('8537','2013-04-10','14:55:00',4.48),('8537','2013-04-10','15:00:00',4.49),('8537','2013-04-10','15:05:00',3.92),('8537','2013-04-10','15:10:00',3.55),('8537','2013-04-10','15:15:00',3.67),('8537','2013-04-10','15:20:00',2.56),('8537','2013-04-10','15:25:00',4.14),('8537','2013-04-10','15:30:00',4.04),('8537','2013-04-10','15:35:00',3.23),('8537','2013-04-10','15:40:00',3.98),('8537','2013-04-10','15:45:00',3.94),('8537','2013-04-10','15:50:00',3.44),('8537','2013-04-10','15:55:00',3.99),('8537','2013-04-10','16:00:00',3.57),('8537','2013-04-10','16:05:00',3.08),('8537','2013-04-10','16:10:00',3.59),('8537','2013-04-10','16:15:00',3.21),('8537','2013-04-10','16:20:00',3.21),('8537','2013-04-10','16:25:00',3.19),('8537','2013-04-10','16:30:00',3.24),('8537','2013-04-10','16:35:00',1.82),('8537','2013-04-10','16:40:00',2.94),('8537','2013-04-10','16:45:00',2.57),('8537','2013-04-10','16:50:00',2.59),('8537','2013-04-10','16:55:00',1.18),('8537','2013-04-10','17:00:00',2.55),('8537','2013-04-10','17:05:00',2.47),('8537','2013-04-10','17:10:00',1.41),('8537','2013-04-10','17:15:00',1.87),('8537','2013-04-10','17:20:00',1.54),('8537','2013-04-10','17:25:00',1.19),('8537','2013-04-10','17:30:00',1.67),('8537','2013-04-10','17:40:00',1.35),('8537','2013-04-10','17:45:00',1.47),('8537','2013-04-10','17:50:00',1.21),('8537','2013-04-10','17:55:00',1.29),('8537','2013-04-10','18:00:00',1.15),('8537','2013-04-09','07:55:00',1.1),('8537','2013-04-09','08:00:00',1.36),('8537','2013-04-09','08:10:00',1.16),('8537','2013-04-09','08:20:00',1.56),('8537','2013-04-09','08:30:00',1.11),('8537','2013-04-09','08:35:00',1.14),('8537','2013-04-09','08:50:00',1.09),('8537','2013-04-09','09:05:00',1.12),('8537','2013-04-09','09:10:00',1.18),('8537','2013-04-09','09:15:00',1.31),('8537','2013-04-09','09:20:00',1.19),('8537','2013-04-09','09:25:00',1.26),('8537','2013-04-09','09:30:00',1.51),('8537','2013-04-09','09:45:00',2.27),('8537','2013-04-09','09:50:00',2.17),('8537','2013-04-09','09:55:00',4.14),('8537','2013-04-09','10:00:00',3.51),('8537','2013-04-09','10:05:00',1.44),('8537','2013-04-09','10:10:00',2.07),('8537','2013-04-09','10:15:00',2.7),('8537','2013-04-09','10:20:00',2.04),('8537','2013-04-09','10:25:00',1.27),('8537','2013-04-09','10:35:00',4.02),('8537','2013-04-09','10:40:00',3.17),('8537','2013-04-09','10:45:00',5.06),('8537','2013-04-09','10:50:00',4.87),('8537','2013-04-09','10:55:00',3.48),('8537','2013-04-09','11:00:00',4.88),('8537','2013-04-09','11:05:00',3.8),('8537','2013-04-09','11:10:00',5.01),('8537','2013-04-09','11:15:00',1.92),('8537','2013-04-09','11:20:00',1.17),('8537','2013-04-09','11:25:00',3.38),('8537','2013-04-09','11:30:00',4.92),('8537','2013-04-09','11:35:00',3.69),('8537','2013-04-09','11:40:00',1.71),('8537','2013-04-09','11:45:00',4.13),('8537','2013-04-09','11:50:00',4.77),('8537','2013-04-09','11:55:00',4.03),('8537','2013-04-09','12:00:00',5.44),('8537','2013-04-09','12:05:00',5.36),('8537','2013-04-09','12:10:00',5.38),('8537','2013-04-09','12:15:00',5.35),('8537','2013-04-09','12:20:00',5.01),('8537','2013-04-09','12:25:00',5.2),('8537','2013-04-09','12:30:00',5.24),('8537','2013-04-09','12:35:00',5.23),('8537','2013-04-09','12:40:00',5.32),('8537','2013-04-09','12:45:00',5.52),('8537','2013-04-09','12:50:00',5.42),('8537','2013-04-09','12:55:00',4.96),('8537','2013-04-09','13:00:00',5.07),('8537','2013-04-09','13:05:00',5.54),('8537','2013-04-09','13:10:00',5.68),('8537','2013-04-09','13:15:00',5.13),('8537','2013-04-09','13:20:00',2.37),('8537','2013-04-09','13:25:00',3.06),('8537','2013-04-09','13:30:00',2.63),('8537','2013-04-09','13:35:00',1.35),('8537','2013-04-09','13:40:00',4.01),('8537','2013-04-09','13:45:00',3.44),('8537','2013-04-09','13:50:00',3.69),('8537','2013-04-09','13:55:00',5.16),('8537','2013-04-09','14:00:00',4.87),('8537','2013-04-09','14:05:00',4.88),('8537','2013-04-09','14:10:00',2.92),('8537','2013-04-09','14:15:00',3.96),('8537','2013-04-09','14:20:00',2.75),('8537','2013-04-09','14:25:00',4.01),('8537','2013-04-09','14:30:00',3.72),('8537','2013-04-09','14:35:00',3.96),('8537','2013-04-09','14:40:00',4.31),('8537','2013-04-09','14:45:00',4.26),('8537','2013-04-09','14:50:00',4.02),('8537','2013-04-09','14:55:00',3.59),('8537','2013-04-09','15:00:00',3.87),('8537','2013-04-09','15:05:00',3.71),('8537','2013-04-09','15:10:00',4.64),('8537','2013-04-09','15:15:00',3.24),('8537','2013-04-09','15:20:00',4.21),('8537','2013-04-09','15:25:00',4.48),('8537','2013-04-09','15:30:00',3.03),('8537','2013-04-09','15:35:00',4.06),('8537','2013-04-09','15:40:00',3.82),('8537','2013-04-09','15:45:00',4.05),('8537','2013-04-09','15:50:00',4.15),('8537','2013-04-09','15:55:00',3.42),('8537','2013-04-09','16:00:00',3.11),('8537','2013-04-09','16:05:00',2.69),('8537','2013-04-09','16:10:00',2.74),('8537','2013-04-09','16:15:00',1.87),('8537','2013-04-09','16:25:00',1.18),('8537','2013-04-09','16:30:00',1.19),('8537','2013-04-09','16:35:00',1.24),('8537','2013-04-09','16:40:00',1.31),('8537','2013-04-09','16:45:00',1.17),('8537','2013-04-09','16:50:00',2.87),('8537','2013-04-09','16:55:00',2.65),('8537','2013-04-09','17:20:00',1.14),('8537','2013-04-09','17:25:00',1.21),('8537','2013-04-09','17:30:00',1.12),('8537','2013-04-08','08:10:00',1),('8537','2013-04-08','08:35:00',1.04),('8537','2013-04-08','08:40:00',1.95),('8537','2013-04-08','08:45:00',1.1),('8537','2013-04-08','08:50:00',1.75),('8537','2013-04-08','08:55:00',1.41),('8537','2013-04-08','09:00:00',1.85),('8537','2013-04-08','09:05:00',1.64),('8537','2013-04-08','09:10:00',2.64),('8537','2013-04-08','09:15:00',2.62),('8537','2013-04-08','09:20:00',2.38),('8537','2013-04-08','09:25:00',3.19),('8537','2013-04-08','09:30:00',3.22),('8537','2013-04-08','09:35:00',3.37),('8537','2013-04-08','09:40:00',3.41),('8537','2013-04-08','09:45:00',3.5),('8537','2013-04-08','09:50:00',2.17),('8537','2013-04-08','09:55:00',2.15),('8537','2013-04-08','10:00:00',3.7),('8537','2013-04-08','10:05:00',3.95),('8537','2013-04-08','10:10:00',3.73),('8537','2013-04-08','10:15:00',3.92),('8537','2013-04-08','10:20:00',3.86),('8537','2013-04-08','10:25:00',3.92),('8537','2013-04-08','10:30:00',4.01),('8537','2013-04-08','10:35:00',3.81),('8537','2013-04-08','10:40:00',4.21),('8537','2013-04-08','10:45:00',4.47),('8537','2013-04-08','10:50:00',4.46),('8537','2013-04-08','10:55:00',4.26),('8537','2013-04-08','11:00:00',4.47),('8537','2013-04-08','11:05:00',3.92),('8537','2013-04-08','11:10:00',3.62),('8537','2013-04-08','11:15:00',3.41),('8537','2013-04-08','11:20:00',2.85),('8537','2013-04-08','11:25:00',2.41),('8537','2013-04-08','11:30:00',2.65),('8537','2013-04-08','11:35:00',3.56),('8537','2013-04-08','11:40:00',3.89),('8537','2013-04-08','11:45:00',3.42),('8537','2013-04-08','11:50:00',3.19),('8537','2013-04-08','11:55:00',2.75),('8537','2013-04-08','12:00:00',2.61),('8537','2013-04-08','12:05:00',2.48),('8537','2013-04-08','12:10:00',2.66),('8537','2013-04-08','12:15:00',3.2),('8537','2013-04-08','12:20:00',3.28),('8537','2013-04-08','12:25:00',3.26),('8537','2013-04-08','12:30:00',3.61),('8537','2013-04-08','12:35:00',3.02),('8537','2013-04-08','12:40:00',2.83),('8537','2013-04-08','12:45:00',3.06),('8537','2013-04-08','12:50:00',2.99),('8537','2013-04-08','12:55:00',2.46),('8537','2013-04-08','13:00:00',1.94),('8537','2013-04-08','13:05:00',2.64),('8537','2013-04-08','13:10:00',3.27),('8537','2013-04-08','13:15:00',3.77),('8537','2013-04-08','13:20:00',4.37),('8537','2013-04-08','13:25:00',3.91),('8537','2013-04-08','13:30:00',3.41),('8537','2013-04-08','13:35:00',3.43),('8537','2013-04-08','13:40:00',3.52),('8537','2013-04-08','13:45:00',3.77),('8537','2013-04-08','13:50:00',3.54),('8537','2013-04-08','13:55:00',4.56),('8537','2013-04-08','14:00:00',4.54),('8537','2013-04-08','14:05:00',3.98),('8537','2013-04-08','14:10:00',4),('8537','2013-04-08','14:15:00',4.54),('8537','2013-04-08','14:20:00',4.04),('8537','2013-04-08','14:25:00',4.77),('8537','2013-04-08','14:30:00',4.63),('8537','2013-04-08','14:35:00',4.19),('8537','2013-04-08','14:40:00',3.95),('8537','2013-04-08','14:45:00',4.1),('8537','2013-04-08','14:50:00',4.28),('8537','2013-04-08','14:55:00',4.63),('8537','2013-04-08','15:00:00',3.62),('8537','2013-04-08','15:05:00',3.39),('8537','2013-04-08','15:10:00',3.32),('8537','2013-04-08','15:15:00',3.58),('8537','2013-04-08','15:20:00',3.39),('8537','2013-04-08','15:25:00',3.93),('8537','2013-04-08','15:30:00',4.22),('8537','2013-04-08','15:35:00',4.05),('8537','2013-04-08','15:40:00',3.9),('8537','2013-04-08','15:45:00',3.77),('8537','2013-04-08','15:50:00',3.77),('8537','2013-04-08','15:55:00',3.69),('8537','2013-04-08','16:00:00',3.55),('8537','2013-04-08','16:05:00',3.27),('8537','2013-04-08','16:10:00',3.14),('8537','2013-04-08','16:15:00',3.31),('8537','2013-04-08','16:20:00',3.31),('8537','2013-04-08','16:25:00',3.14),('8537','2013-04-08','16:30:00',3.06),('8537','2013-04-08','16:35:00',2.98),('8537','2013-04-08','16:40:00',2.68),('8537','2013-04-08','16:45:00',2.77),('8537','2013-04-08','16:50:00',2.68),('8537','2013-04-08','16:55:00',2.58),('8537','2013-04-08','17:00:00',2.41),('8537','2013-04-08','17:05:00',2.32),('8537','2013-04-08','17:10:00',2.16),('8537','2013-04-08','17:15:00',2.07),('8537','2013-04-08','17:20:00',1.9),('8537','2013-04-08','17:25:00',1.95),('8537','2013-04-08','17:30:00',1.76),('8537','2013-04-08','17:35:00',1.64),('8537','2013-04-08','17:40:00',1.46),('8537','2013-04-08','17:45:00',1.34),('8537','2013-04-08','17:50:00',1.08),('8537','2013-04-08','18:20:00',1.01),('8537','2013-04-07','08:25:00',1.12),('8537','2013-04-07','08:30:00',1.28),('8537','2013-04-07','08:35:00',1.42),('8537','2013-04-07','08:40:00',1.54),('8537','2013-04-07','08:45:00',1.57),('8537','2013-04-07','08:50:00',1.57),('8537','2013-04-07','08:55:00',1.63),('8537','2013-04-07','09:00:00',1.61),('8537','2013-04-07','09:05:00',1.66),('8537','2013-04-07','09:10:00',1.82),('8537','2013-04-07','09:15:00',1.8),('8537','2013-04-07','09:20:00',1.89),('8537','2013-04-07','09:25:00',1.86),('8537','2013-04-07','09:30:00',1.78),('8537','2013-04-07','09:35:00',1.69),('8537','2013-04-07','09:40:00',1.7),('8537','2013-04-07','09:45:00',2.19),('8537','2013-04-07','09:50:00',2.47),('8537','2013-04-07','09:55:00',2.69),('8537','2013-04-07','10:00:00',3.18),('8537','2013-04-07','10:05:00',3.31),('8537','2013-04-07','10:10:00',3.26),('8537','2013-04-07','10:15:00',3.47),('8537','2013-04-07','10:20:00',3.42),('8537','2013-04-07','10:25:00',3.45),('8537','2013-04-07','10:30:00',3),('8537','2013-04-07','10:35:00',3.32),('8537','2013-04-07','10:40:00',3.31),('8537','2013-04-07','10:45:00',3.23),('8537','2013-04-07','10:50:00',3.11),('8537','2013-04-07','10:55:00',2.73),('8537','2013-04-07','11:00:00',2.51),('8537','2013-04-07','11:05:00',2.19),('8537','2013-04-07','11:10:00',2.59),('8537','2013-04-07','11:15:00',3.6),('8537','2013-04-07','11:20:00',4.11),('8537','2013-04-07','11:25:00',4.55),('8537','2013-04-07','11:30:00',4.27),('8537','2013-04-07','11:35:00',4.09),('8537','2013-04-07','11:40:00',3.63),('8537','2013-04-07','11:45:00',2.97),('8537','2013-04-07','11:50:00',2.74),('8537','2013-04-07','11:55:00',2.88),('8537','2013-04-07','12:00:00',2.98),('8537','2013-04-07','12:05:00',2.9),('8537','2013-04-07','12:10:00',3.17),('8537','2013-04-07','12:15:00',3.04),('8537','2013-04-07','12:20:00',3.37),('8537','2013-04-07','12:25:00',3.67),('8537','2013-04-07','12:30:00',3.2),('8537','2013-04-07','12:35:00',3.46),('8537','2013-04-07','12:40:00',3.31),('8537','2013-04-07','12:45:00',2.83),('8537','2013-04-07','12:50:00',3.16),('8537','2013-04-07','12:55:00',3.21),('8537','2013-04-07','13:00:00',3.87),('8537','2013-04-07','13:05:00',4.25),('8537','2013-04-07','13:10:00',4.03),('8537','2013-04-07','13:15:00',3.68),('8537','2013-04-07','13:20:00',3.41),('8537','2013-04-07','13:25:00',3.94),('8537','2013-04-07','13:30:00',3.91),('8537','2013-04-07','13:35:00',3.65),('8537','2013-04-07','13:40:00',4.05),('8537','2013-04-07','13:45:00',4.03),('8537','2013-04-07','13:50:00',3.74),('8537','2013-04-07','13:55:00',3.62),('8537','2013-04-07','14:00:00',4.44),('8537','2013-04-07','14:05:00',3.83),('8537','2013-04-07','14:10:00',2.97),('8537','2013-04-07','14:15:00',2.94),('8537','2013-04-07','14:20:00',2.63),('8537','2013-04-07','14:25:00',2.71),('8537','2013-04-07','14:30:00',2.53),('8537','2013-04-07','14:35:00',2.85),('8537','2013-04-07','14:40:00',2.6),('8537','2013-04-07','14:45:00',2.48),('8537','2013-04-07','14:50:00',2.61),('8537','2013-04-07','14:55:00',3.03),('8537','2013-04-07','15:00:00',2.32),('8537','2013-04-07','15:05:00',3.46),('8537','2013-04-07','15:10:00',3.4),('8537','2013-04-07','15:15:00',3.49),('8537','2013-04-07','15:20:00',3.26),('8537','2013-04-07','15:25:00',3.32),('8537','2013-04-07','15:30:00',3.49),('8537','2013-04-07','15:35:00',3.28),('8537','2013-04-07','15:40:00',3.38),('8537','2013-04-07','15:45:00',3.11),('8537','2013-04-07','15:50:00',3.03),('8537','2013-04-07','15:55:00',2.87),('8537','2013-04-07','16:00:00',2.8),('8537','2013-04-07','16:05:00',2.39),('8537','2013-04-07','16:10:00',2.02),('8537','2013-04-07','16:15:00',1.81),('8537','2013-04-07','16:20:00',1.71),('8537','2013-04-07','16:25:00',1.54),('8537','2013-04-07','16:30:00',1.54),('8537','2013-04-07','16:35:00',1.77),('8537','2013-04-07','16:40:00',1.79),('8537','2013-04-07','16:45:00',2.18),('8537','2013-04-07','16:50:00',2.57),('8537','2013-04-07','16:55:00',2.48),('8537','2013-04-07','17:00:00',2.26),('8537','2013-04-07','17:05:00',1.86),('8537','2013-04-07','17:10:00',1.19),('8537','2013-04-07','17:15:00',1.04),('8537','2013-04-07','17:20:00',1.51),('8537','2013-04-07','17:25:00',1.76),('8537','2013-04-07','17:30:00',1.65),('8537','2013-04-07','17:35:00',1.75),('8537','2013-04-07','17:40:00',1.73),('8537','2013-04-07','17:45:00',1.63),('8537','2013-04-07','17:50:00',1.47),('8537','2013-04-07','17:55:00',1.24),('8537','2013-04-06','08:00:00',1.02),('8537','2013-04-06','08:05:00',1.12),('8537','2013-04-06','08:10:00',1.22),('8537','2013-04-06','08:15:00',1.33),('8537','2013-04-06','08:20:00',1.43),('8537','2013-04-06','08:25:00',1.54),('8537','2013-04-06','08:30:00',1.67),('8537','2013-04-06','08:35:00',1.79),('8537','2013-04-06','08:40:00',1.88),('8537','2013-04-06','08:45:00',2),('8537','2013-04-06','08:50:00',2.1),('8537','2013-04-06','08:55:00',2.21),('8537','2013-04-06','09:00:00',2.31),('8537','2013-04-06','09:05:00',2.42),('8537','2013-04-06','09:10:00',2.53),('8537','2013-04-06','09:15:00',2.65),('8537','2013-04-06','09:20:00',2.77),('8537','2013-04-06','09:25:00',2.88),('8537','2013-04-06','09:30:00',2.97),('8537','2013-04-06','09:35:00',3.02),('8537','2013-04-06','09:40:00',3.14),('8537','2013-04-06','09:45:00',3.2),('8537','2013-04-06','09:50:00',3.27),('8537','2013-04-06','09:55:00',3.3),('8537','2013-04-06','10:00:00',3.47),('8537','2013-04-06','10:05:00',3.55),('8537','2013-04-06','10:10:00',3.59),('8537','2013-04-06','10:15:00',3.64),('8537','2013-04-06','10:20:00',3.8),('8537','2013-04-06','10:25:00',3.8),('8537','2013-04-06','10:30:00',3.86),('8537','2013-04-06','10:35:00',3.93),('8537','2013-04-06','10:40:00',4.01),('8537','2013-04-06','10:45:00',4.07),('8537','2013-04-06','10:50:00',4.1),('8537','2013-04-06','10:55:00',4.19),('8537','2013-04-06','11:00:00',4.27),('8537','2013-04-06','11:05:00',4.34),('8537','2013-04-06','11:10:00',4.39),('8537','2013-04-06','11:15:00',4.45),('8537','2013-04-06','11:20:00',4.53),('8537','2013-04-06','11:25:00',4.52),('8537','2013-04-06','11:30:00',4.57),('8537','2013-04-06','11:35:00',4.58),('8537','2013-04-06','11:40:00',4.62),('8537','2013-04-06','11:45:00',4.65),('8537','2013-04-06','11:50:00',4.68),('8537','2013-04-06','11:55:00',4.71),('8537','2013-04-06','12:00:00',4.74),('8537','2013-04-06','12:05:00',4.74),('8537','2013-04-06','12:10:00',4.79),('8537','2013-04-06','12:15:00',4.81),('8537','2013-04-06','12:20:00',4.88),('8537','2013-04-06','12:25:00',3.27),('8537','2013-04-06','12:30:00',5.09),('8537','2013-04-06','12:35:00',5.04),('8537','2013-04-06','12:40:00',5.02),('8537','2013-04-06','12:45:00',5.07),('8537','2013-04-06','12:50:00',5.06),('8537','2013-04-06','12:55:00',5.03),('8537','2013-04-06','13:00:00',5.07),('8537','2013-04-06','13:05:00',4.87),('8537','2013-04-06','13:10:00',2.4),('8537','2013-04-06','13:15:00',1.27),('8537','2013-04-06','13:20:00',1.76),('8537','2013-04-06','13:25:00',2.45),('8537','2013-04-06','13:30:00',4.18),('8537','2013-04-06','13:35:00',4.32),('8537','2013-04-06','13:40:00',5.55),('8537','2013-04-06','13:45:00',5.52),('8537','2013-04-06','13:50:00',5.17),('8537','2013-04-06','13:55:00',5.32),('8537','2013-04-06','14:00:00',2.64),('8537','2013-04-06','14:05:00',2.43),('8537','2013-04-06','14:10:00',4.41),('8537','2013-04-06','14:15:00',3.17),('8537','2013-04-06','14:20:00',1.88),('8537','2013-04-06','14:25:00',1.36),('8537','2013-04-06','14:30:00',2.92),('8537','2013-04-06','14:35:00',4.44),('8537','2013-04-06','14:45:00',4.32),('8537','2013-04-06','14:50:00',4.64),('8537','2013-04-06','14:55:00',4.7),('8537','2013-04-06','15:00:00',4.38),('8537','2013-04-06','15:05:00',4.45),('8537','2013-04-06','15:10:00',4.21),('8537','2013-04-06','15:15:00',4.13),('8537','2013-04-06','15:20:00',4.07),('8537','2013-04-06','15:25:00',3.88),('8537','2013-04-06','15:30:00',3.8),('8537','2013-04-06','15:35:00',3.75),('8537','2013-04-06','15:40:00',3.73),('8537','2013-04-06','15:45:00',3.42),('8537','2013-04-06','15:50:00',3.32),('8537','2013-04-06','15:55:00',3.6),('8537','2013-04-06','16:00:00',3.27),('8537','2013-04-06','16:05:00',3.17),('8537','2013-04-06','16:10:00',3.32),('8537','2013-04-06','16:15:00',3.04),('8537','2013-04-06','16:20:00',2.6),('8537','2013-04-06','16:25:00',2.21),('8537','2013-04-06','16:30:00',2.7),('8537','2013-04-06','16:35:00',2.52),('8537','2013-04-06','16:40:00',1.93),('8537','2013-04-06','16:45:00',2.65),('8537','2013-04-06','16:50:00',2.47),('8537','2013-04-06','16:55:00',2.17),('8537','2013-04-06','17:00:00',2.07),('8537','2013-04-06','17:05:00',1.82),('8537','2013-04-06','17:10:00',1.63),('8537','2013-04-06','17:15:00',1.26),('8537','2013-04-06','17:25:00',1.04),('8537','2013-04-06','17:30:00',1.02),('8537','2013-04-05','08:15:00',1.33),('8537','2013-04-05','08:20:00',1.47),('8537','2013-04-05','08:25:00',1.02),('8537','2013-04-05','08:55:00',2),('8537','2013-04-05','09:00:00',1.07),('8537','2013-04-05','09:05:00',2.9),('8537','2013-04-05','09:10:00',1.63),('8537','2013-04-05','09:15:00',2.91),('8537','2013-04-05','09:20:00',2.22),('8537','2013-04-05','09:25:00',1.27),('8537','2013-04-05','09:35:00',1.25),('8537','2013-04-05','09:40:00',2.64),('8537','2013-04-05','09:45:00',2.54),('8537','2013-04-05','09:50:00',1.42),('8537','2013-04-05','09:55:00',1.21),('8537','2013-04-05','10:00:00',1.97),('8537','2013-04-05','10:05:00',1.07),('8537','2013-04-05','10:10:00',2.93),('8537','2013-04-05','10:15:00',3.73),('8537','2013-04-05','10:20:00',1.47),('8537','2013-04-05','10:25:00',2.98),('8537','2013-04-05','10:30:00',2.08),('8537','2013-04-05','10:35:00',1.62),('8537','2013-04-05','10:40:00',3.96),('8537','2013-04-05','10:45:00',2.45),('8537','2013-04-05','10:50:00',3.27),('8537','2013-04-05','10:55:00',2.63),('8537','2013-04-05','11:00:00',2.1),('8537','2013-04-05','11:05:00',3.68),('8537','2013-04-05','11:10:00',4.91),('8537','2013-04-05','11:15:00',4.94),('8537','2013-04-05','11:20:00',3.94),('8537','2013-04-05','11:25:00',4.41),('8537','2013-04-05','11:30:00',4.49),('8537','2013-04-05','11:35:00',5.05),('8537','2013-04-05','11:40:00',5.2),('8537','2013-04-05','11:45:00',4.18),('8537','2013-04-05','11:50:00',4.89),('8537','2013-04-05','11:55:00',5.13),('8537','2013-04-05','12:00:00',5.67),('8537','2013-04-05','12:05:00',3.2),('8537','2013-04-05','12:10:00',2.28),('8537','2013-04-05','12:15:00',3.75),('8537','2013-04-05','12:20:00',1.71),('8537','2013-04-05','12:25:00',2.68),('8537','2013-04-05','12:30:00',1.47),('8537','2013-04-05','12:35:00',1.56),('8537','2013-04-05','12:40:00',2.25),('8537','2013-04-05','12:45:00',3.97),('8537','2013-04-05','12:50:00',4.79),('8537','2013-04-05','12:55:00',5.58),('8537','2013-04-05','13:00:00',3.98),('8537','2013-04-05','13:05:00',3.94),('8537','2013-04-05','13:10:00',3.98),('8537','2013-04-05','13:15:00',4.63),('8537','2013-04-05','13:20:00',4.08),('8537','2013-04-05','13:25:00',5.1),('8537','2013-04-05','13:30:00',4.02),('8537','2013-04-05','13:35:00',4.23),('8537','2013-04-05','13:40:00',4.72),('8537','2013-04-05','13:45:00',3.47),('8537','2013-04-05','13:50:00',5.51),('8537','2013-04-05','13:55:00',4.89),('8537','2013-04-05','14:00:00',3.17),('8537','2013-04-05','14:05:00',5.62),('8537','2013-04-05','14:10:00',4.7),('8537','2013-04-05','14:15:00',4.88),('8537','2013-04-05','14:20:00',4.54),('8537','2013-04-05','14:25:00',5.26),('8537','2013-04-05','14:30:00',4.42),('8537','2013-04-05','14:35:00',4.39),('8537','2013-04-05','14:40:00',4.16),('8537','2013-04-05','14:45:00',4.8),('8537','2013-04-05','14:50:00',2.91),('8537','2013-04-05','14:55:00',5.56),('8537','2013-04-05','15:00:00',4.3),('8537','2013-04-05','15:05:00',3.39),('8537','2013-04-05','15:10:00',3.79),('8537','2013-04-05','15:15:00',1.96),('8537','2013-04-05','15:20:00',1.99),('8537','2013-04-05','15:25:00',2.94),('8537','2013-04-05','15:30:00',2.19),('8537','2013-04-05','15:35:00',1.67),('8537','2013-04-05','15:40:00',1.39),('8537','2013-04-05','15:45:00',1.72),('8537','2013-04-05','15:50:00',2.2),('8537','2013-04-05','15:55:00',1.96),('8537','2013-04-05','16:00:00',2.05),('8537','2013-04-05','16:05:00',1.89),('8537','2013-04-05','16:10:00',1.83),('8537','2013-04-05','16:15:00',2.45),('8537','2013-04-05','16:20:00',2.49),('8537','2013-04-05','16:25:00',2.09),('8537','2013-04-05','16:30:00',1.81),('8537','2013-04-05','16:35:00',2.4),('8537','2013-04-05','16:40:00',1.66),('8537','2013-04-05','16:45:00',2.04),('8537','2013-04-05','16:50:00',2.67),('8537','2013-04-05','16:55:00',1.84),('8537','2013-04-05','17:00:00',1.55),('8537','2013-04-05','17:05:00',1.24),('8537','2013-04-05','17:10:00',1.95),('8537','2013-04-05','17:15:00',2.14),('8537','2013-04-05','17:20:00',1.76),('8537','2013-04-05','17:25:00',1.71),('8537','2013-04-05','17:30:00',1.96),('8537','2013-04-05','17:35:00',1.24),('8537','2013-04-05','17:40:00',1.38),('8537','2013-04-05','17:55:00',1.34),('8537','2013-04-05','18:00:00',1.07),('8537','2013-04-04','08:35:00',1.03),('8537','2013-04-04','08:55:00',1.58),('8537','2013-04-04','09:00:00',2.37),('8537','2013-04-04','09:05:00',1.74),('8537','2013-04-04','09:10:00',1.54),('8537','2013-04-04','09:15:00',1.55),('8537','2013-04-04','09:20:00',1.58),('8537','2013-04-04','09:25:00',1.16),('8537','2013-04-04','09:30:00',1.74),('8537','2013-04-04','09:35:00',2.93),('8537','2013-04-04','09:40:00',2.83),('8537','2013-04-04','09:45:00',2.45),('8537','2013-04-04','09:50:00',1.3),('8537','2013-04-04','09:55:00',1.42),('8537','2013-04-04','10:00:00',2.15),('8537','2013-04-04','10:05:00',2.88),('8537','2013-04-04','10:10:00',2.55),('8537','2013-04-04','10:15:00',1.82),('8537','2013-04-04','10:20:00',2.06),('8537','2013-04-04','10:25:00',4.01),('8537','2013-04-04','10:30:00',3.7),('8537','2013-04-04','10:35:00',2.27),('8537','2013-04-04','10:40:00',4.6),('8537','2013-04-04','10:45:00',2.54),('8537','2013-04-04','10:50:00',2.7),('8537','2013-04-04','10:55:00',4.4),('8537','2013-04-04','11:00:00',2.72),('8537','2013-04-04','11:05:00',1.46),('8537','2013-04-04','11:10:00',1.23),('8537','2013-04-04','11:15:00',1.64),('8537','2013-04-04','11:20:00',1.61),('8537','2013-04-04','11:25:00',1.22),('8537','2013-04-04','11:30:00',1.34),('8537','2013-04-04','11:35:00',1.96),('8537','2013-04-04','11:40:00',3.39),('8537','2013-04-04','11:45:00',4.11),('8537','2013-04-04','11:50:00',4.66),('8537','2013-04-04','11:55:00',4.85),('8537','2013-04-04','12:00:00',4.85),('8537','2013-04-04','12:05:00',4.68),('8537','2013-04-04','12:10:00',4.73),('8537','2013-04-04','12:15:00',4.58),('8537','2013-04-04','12:20:00',3.89),('8537','2013-04-04','12:25:00',3.61),('8537','2013-04-04','12:30:00',3.3),('8537','2013-04-04','12:35:00',2.95),('8537','2013-04-04','12:40:00',4.44),('8537','2013-04-04','12:45:00',4.03),('8537','2013-04-04','12:50:00',4.92),('8537','2013-04-04','12:55:00',4.59),('8537','2013-04-04','13:00:00',4.46),('8537','2013-04-04','13:05:00',4.5),('8537','2013-04-04','13:10:00',4.62),('8537','2013-04-04','13:15:00',4.85),('8537','2013-04-04','13:20:00',4.7),('8537','2013-04-04','13:25:00',4.81),('8537','2013-04-04','13:30:00',4.73),('8537','2013-04-04','13:35:00',4.31),('8537','2013-04-04','13:40:00',3.67),('8537','2013-04-04','13:45:00',3.88),('8537','2013-04-04','13:50:00',3.83),('8537','2013-04-04','13:55:00',2.89),('8537','2013-04-04','14:00:00',3.04),('8537','2013-04-04','14:05:00',4.02),('8537','2013-04-04','14:10:00',4.58),('8537','2013-04-04','14:15:00',4.6),('8537','2013-04-04','14:20:00',4.55),('8537','2013-04-04','14:25:00',4.45),('8537','2013-04-04','14:30:00',4.4),('8537','2013-04-04','14:35:00',4.21),('8537','2013-04-04','14:40:00',4.32),('8537','2013-04-04','14:45:00',4.31),('8537','2013-04-04','14:50:00',4.24),('8537','2013-04-04','14:55:00',4.22),('8537','2013-04-04','15:00:00',4.16),('8537','2013-04-04','15:05:00',4.02),('8537','2013-04-04','15:10:00',3.82),('8537','2013-04-04','15:15:00',3.8),('8537','2013-04-04','15:20:00',3.79),('8537','2013-04-04','15:25:00',3.8),('8537','2013-04-04','15:30:00',3.76),('8537','2013-04-04','15:35:00',3.68),('8537','2013-04-04','15:40:00',3.59),('8537','2013-04-04','15:45:00',3.51),('8537','2013-04-04','15:50:00',3.37),('8537','2013-04-04','15:55:00',3.33),('8537','2013-04-04','16:00:00',3.24),('8537','2013-04-04','16:05:00',2.98),('8537','2013-04-04','16:10:00',2.85),('8537','2013-04-04','16:15:00',2.76),('8537','2013-04-04','16:20:00',2.5),('8537','2013-04-04','16:25:00',2.43),('8537','2013-04-04','16:30:00',2.03),('8537','2013-04-04','16:35:00',2.07),('8537','2013-04-04','16:40:00',2.06),('8537','2013-04-04','16:45:00',1.99),('8537','2013-04-04','16:50:00',1.59),('8537','2013-04-04','16:55:00',1.92),('8537','2013-04-04','17:00:00',1.8),('8537','2013-04-04','17:05:00',1.81),('8537','2013-04-04','17:10:00',1.62),('8537','2013-04-04','17:15:00',1.51),('8537','2013-04-04','17:20:00',1.08),('8537','2013-04-04','17:25:00',1.07),('8537','2013-04-04','17:55:00',1.09),('8537','2013-04-03','08:05:00',1.1),('8537','2013-04-03','08:10:00',1.22),('8537','2013-04-03','08:15:00',1.34),('8537','2013-04-03','08:20:00',1.48),('8537','2013-04-03','08:25:00',1.24),('8537','2013-04-03','08:30:00',1.75),('8537','2013-04-03','08:35:00',1.82),('8537','2013-04-03','08:40:00',1.29),('8537','2013-04-03','08:45:00',1.3),('8537','2013-04-03','08:50:00',1.68),('8537','2013-04-03','08:55:00',2.04),('8537','2013-04-03','09:00:00',2.46),('8537','2013-04-03','09:05:00',2.13),('8537','2013-04-03','09:10:00',2.8),('8537','2013-04-03','09:15:00',2.95),('8537','2013-04-03','09:20:00',2.43),('8537','2013-04-03','09:25:00',1.68),('8537','2013-04-03','09:30:00',2.34),('8537','2013-04-03','09:35:00',3.71),('8537','2013-04-03','09:40:00',3.61),('8537','2013-04-03','09:45:00',3.07),('8537','2013-04-03','09:50:00',3.12),('8537','2013-04-03','09:55:00',3.91),('8537','2013-04-03','10:00:00',3.15),('8537','2013-04-03','10:05:00',1.45),('8537','2013-04-03','10:10:00',1.34),('8537','2013-04-03','10:15:00',1.79),('8537','2013-04-03','10:20:00',3.78),('8537','2013-04-03','10:25:00',3.86),('8537','2013-04-03','10:30:00',3.6),('8537','2013-04-03','10:35:00',2.43),('8537','2013-04-03','10:40:00',2.19),('8537','2013-04-03','10:45:00',1.56),('8537','2013-04-03','10:50:00',2.66),('8537','2013-04-03','10:55:00',1.77),('8537','2013-04-03','11:00:00',4.08),('8537','2013-04-03','11:05:00',3.96),('8537','2013-04-03','11:10:00',3.26),('8537','2013-04-03','11:15:00',3.83),('8537','2013-04-03','11:20:00',4.27),('8537','2013-04-03','11:25:00',2.72),('8537','2013-04-03','11:30:00',2.03),('8537','2013-04-03','11:35:00',2.15),('8537','2013-04-03','11:40:00',2.57),('8537','2013-04-03','11:45:00',1.79),('8537','2013-04-03','11:50:00',4.22),('8537','2013-04-03','11:55:00',3.17),('8537','2013-04-03','12:00:00',3.83),('8537','2013-04-03','12:05:00',5.67),('8537','2013-04-03','12:10:00',4.3),('8537','2013-04-03','12:15:00',2.39),('8537','2013-04-03','12:20:00',4.41),('8537','2013-04-03','12:25:00',4.87),('8537','2013-04-03','12:30:00',4.63),('8537','2013-04-03','12:35:00',4.4),('8537','2013-04-03','12:40:00',5.56),('8537','2013-04-03','12:45:00',5.45),('8537','2013-04-03','12:50:00',4.89),('8537','2013-04-03','12:55:00',3.97),('8537','2013-04-03','13:00:00',4.57),('8537','2013-04-03','13:05:00',4.61),('8537','2013-04-03','13:10:00',3.38),('8537','2013-04-03','13:15:00',5.79),('8537','2013-04-03','13:20:00',4.23),('8537','2013-04-03','13:25:00',3.91),('8537','2013-04-03','13:30:00',2.9),('8537','2013-04-03','13:35:00',4.76),('8537','2013-04-03','13:40:00',4.38),('8537','2013-04-03','13:45:00',3.65),('8537','2013-04-03','13:50:00',3.69),('8537','2013-04-03','13:55:00',3.28),('8537','2013-04-03','14:00:00',4.69),('8537','2013-04-03','14:05:00',5.22),('8537','2013-04-03','14:10:00',4.82),('8537','2013-04-03','14:15:00',4.17),('8537','2013-04-03','14:20:00',2.4),('8537','2013-04-03','14:25:00',3.52),('8537','2013-04-03','14:30:00',4.14),('8537','2013-04-03','14:35:00',3.04),('8537','2013-04-03','14:40:00',3.53),('8537','2013-04-03','14:45:00',3.42),('8537','2013-04-03','14:50:00',2.82),('8537','2013-04-03','14:55:00',3.24),('8537','2013-04-03','15:00:00',4.26),('8537','2013-04-03','15:05:00',3.52),('8537','2013-04-03','15:10:00',4.42),('8537','2013-04-03','15:15:00',5.04),('8537','2013-04-03','15:20:00',4.56),('8537','2013-04-03','15:25:00',4.62),('8537','2013-04-03','15:30:00',2.87),('8537','2013-04-03','15:35:00',2.68),('8537','2013-04-03','15:40:00',4.16),('8537','2013-04-03','15:45:00',3.68),('8537','2013-04-03','15:50:00',4.32),('8537','2013-04-03','15:55:00',4.19),('8537','2013-04-03','16:00:00',3.95),('8537','2013-04-03','16:05:00',3.66),('8537','2013-04-03','16:10:00',3.74),('8537','2013-04-03','16:15:00',3.57),('8537','2013-04-03','16:20:00',3.45),('8537','2013-04-03','16:25:00',3.34),('8537','2013-04-03','16:30:00',3.23),('8537','2013-04-03','16:35:00',3.24),('8537','2013-04-03','16:40:00',3.02),('8537','2013-04-03','16:45:00',2.91),('8537','2013-04-03','16:50:00',2.82),('8537','2013-04-03','16:55:00',2.67),('8537','2013-04-03','17:00:00',2.51),('8537','2013-04-03','17:05:00',2.43),('8537','2013-04-03','17:10:00',2.32),('8537','2013-04-03','17:15:00',2.21),('8537','2013-04-03','17:20:00',2.07),('8537','2013-04-03','17:25:00',1.91),('8537','2013-04-03','17:30:00',1.81),('8537','2013-04-03','17:35:00',1.68),('8537','2013-04-03','17:40:00',1.58),('8537','2013-04-03','17:45:00',1.45),('8537','2013-04-03','17:50:00',1.34),('8537','2013-04-03','17:55:00',1.24),('8537','2013-04-03','18:00:00',1.12),('8537','2013-04-02','08:40:00',1.82),('8537','2013-04-02','08:45:00',2.14),('8537','2013-04-02','08:50:00',1.55),('8537','2013-04-02','08:55:00',1.31),('8537','2013-04-02','09:00:00',2.35),('8537','2013-04-02','09:05:00',2.45),('8537','2013-04-02','09:10:00',2.59),('8537','2013-04-02','09:15:00',2.82),('8537','2013-04-02','09:20:00',2.14),('8537','2013-04-02','09:25:00',1.2),('8537','2013-04-02','09:30:00',3.28),('8537','2013-04-02','09:35:00',3.02),('8537','2013-04-02','09:40:00',2.88),('8537','2013-04-02','09:45:00',3.47),('8537','2013-04-02','09:50:00',1.95),('8537','2013-04-02','09:55:00',2.41),('8537','2013-04-02','10:00:00',2.26),('8537','2013-04-02','10:05:00',2.34),('8537','2013-04-02','10:10:00',1.49),('8537','2013-04-02','10:15:00',1.53),('8537','2013-04-02','10:20:00',2.52),('8537','2013-04-02','10:25:00',1.76),('8537','2013-04-02','10:35:00',1.74),('8537','2013-04-02','10:40:00',1.93),('8537','2013-04-02','10:45:00',3.58),('8537','2013-04-02','10:50:00',4.27),('8537','2013-04-02','10:55:00',2.21),('8537','2013-04-02','11:00:00',1.12),('8537','2013-04-02','11:05:00',3.13),('8537','2013-04-02','11:10:00',2.81),('8537','2013-04-02','11:15:00',1.19),('8537','2013-04-02','11:25:00',1.17),('8537','2013-04-02','11:30:00',1.17),('8537','2013-04-02','11:35:00',1.88),('8537','2013-04-02','11:45:00',1.98),('8537','2013-04-02','11:50:00',2.1),('8537','2013-04-02','11:55:00',1.63),('8537','2013-04-02','12:00:00',1.21),('8537','2013-04-02','12:05:00',3.01),('8537','2013-04-02','12:10:00',2.64),('8537','2013-04-02','12:15:00',2.89),('8537','2013-04-02','12:35:00',1.91),('8537','2013-04-02','12:40:00',2.7),('8537','2013-04-02','12:45:00',2.44),('8537','2013-04-02','12:50:00',2.35),('8537','2013-04-02','12:55:00',2.65),('8537','2013-04-02','13:00:00',2.48),('8537','2013-04-02','13:05:00',2.93),('8537','2013-04-02','13:10:00',3.77),('8537','2013-04-02','13:15:00',2.68),('8537','2013-04-02','13:20:00',2.18),('8537','2013-04-02','13:25:00',3.93),('8537','2013-04-02','13:30:00',3.16),('8537','2013-04-02','13:35:00',2.17),('8537','2013-04-02','13:40:00',2.88),('8537','2013-04-02','13:45:00',2.92),('8537','2013-04-02','13:50:00',2.42),('8537','2013-04-02','13:55:00',1.99),('8537','2013-04-02','14:00:00',3.04),('8537','2013-04-02','14:05:00',2.65),('8537','2013-04-02','14:10:00',4.05),('8537','2013-04-02','14:15:00',2.73),('8537','2013-04-02','14:20:00',4.98),('8537','2013-04-02','14:25:00',5.63),('8537','2013-04-02','14:30:00',3.62),('8537','2013-04-02','14:35:00',2.16),('8537','2013-04-02','14:40:00',2.67),('8537','2013-04-02','14:45:00',2.6),('8537','2013-04-02','14:50:00',2.32),('8537','2013-04-02','14:55:00',1.89),('8537','2013-04-02','15:00:00',1.85),('8537','2013-04-02','15:40:00',1),('8537','2013-04-02','15:45:00',1.36),('8537','2013-04-02','16:00:00',1.11),('8537','2013-04-02','16:05:00',1.34),('8537','2013-04-02','16:10:00',1.02),('8537','2013-04-02','16:15:00',1.2),('8537','2013-04-02','16:20:00',1.25),('8537','2013-04-02','16:25:00',1.05),('8537','2013-04-02','16:30:00',1.04),('8537','2013-04-02','16:35:00',1.16),('8537','2013-04-02','16:40:00',1.01),('8537','2013-04-02','17:40:00',1.13),('8537','2013-04-02','17:45:00',1.24),('8537','2014-05-02','07:30:00',1.06),('8537','2014-05-02','07:35:00',1.05),('8537','2014-05-02','07:40:00',1.13),('8537','2014-05-02','07:45:00',1.22),('8537','2014-05-02','07:50:00',1.23),('8537','2014-05-02','08:00:00',1.51),('8537','2014-05-02','08:05:00',1.54),('8537','2014-05-02','08:15:00',1.92),('8537','2014-05-02','08:20:00',2.47),('8537','2014-05-02','08:25:00',1.49),('8537','2014-05-02','08:30:00',1.15),('8537','2014-05-02','08:45:00',1.22),('8537','2014-05-02','08:50:00',1.39),('8537','2014-05-02','09:15:00',1.23),('8537','2014-05-02','09:20:00',1.54),('8537','2014-05-02','09:25:00',1.79),('8537','2014-05-02','09:30:00',2.24),('8537','2014-05-02','09:35:00',1.95),('8537','2014-05-02','09:40:00',1.62),('8537','2014-05-02','09:45:00',1.72),('8537','2014-05-02','09:50:00',1.74),('8537','2014-05-02','09:55:00',1.7),('8537','2014-05-02','10:00:00',2.04),('8537','2014-05-02','10:05:00',2.06),('8537','2014-05-02','10:10:00',2.35),('8537','2014-05-02','10:15:00',1.99),('8537','2014-05-02','10:20:00',1.87),('8537','2014-05-02','10:25:00',1.38),('8537','2014-05-02','10:30:00',1.05),('8537','2014-05-02','10:35:00',1.02),('8537','2014-05-02','10:40:00',1.09),('8537','2014-05-02','10:45:00',1.35),('8537','2014-05-02','10:50:00',1.25),('8537','2014-05-02','10:55:00',1.01),('8537','2014-05-02','12:30:00',1.21),('8537','2014-05-02','12:35:00',1.36),('8537','2014-05-02','12:40:00',1.22),('8537','2014-05-02','12:45:00',1.39),('8537','2014-05-02','12:50:00',2),('8537','2014-05-02','12:55:00',1.83),('8537','2014-05-02','13:00:00',1.75),('8537','2014-05-02','13:05:00',2.09),('8537','2014-05-02','13:10:00',2.32),('8537','2014-05-02','13:15:00',2.41),('8537','2014-05-02','13:20:00',3.91),('8537','2014-05-02','13:25:00',3.33),('8537','2014-05-02','13:30:00',3.38),('8537','2014-05-02','13:35:00',2.72),('8537','2014-05-02','13:40:00',3.23),('8537','2014-05-02','13:45:00',2.32),('8537','2014-05-02','13:50:00',1.7),('8537','2014-05-02','13:55:00',1.54),('8537','2014-05-02','14:00:00',1.62),('8537','2014-05-02','14:05:00',2.03),('8537','2014-05-02','14:10:00',1.58),('8537','2014-05-02','14:30:00',1.39),('8537','2014-05-02','14:35:00',2.1),('8537','2014-05-02','14:40:00',3.84),('8537','2014-05-02','14:45:00',2.26),('8537','2014-05-02','14:50:00',1.64),('8537','2014-05-02','14:55:00',2.16),('8537','2014-05-02','15:00:00',3.05),('8537','2014-05-02','15:05:00',2.28),('8537','2014-05-02','15:10:00',3.4),('8537','2014-05-02','15:15:00',4.18),('8537','2014-05-02','15:20:00',2.05),('8537','2014-05-02','15:25:00',1.7),('8537','2014-05-02','15:30:00',1.42),('8537','2014-05-02','15:35:00',2.84),('8537','2014-05-02','15:40:00',4.7),('8537','2014-05-02','15:45:00',1.62),('8537','2014-05-02','16:00:00',1.39),('8537','2014-05-02','16:05:00',2.01),('8537','2014-05-02','16:10:00',1.36),('8537','2014-05-02','16:15:00',1.01),('8537','2014-05-02','16:20:00',3.29),('8537','2014-05-02','17:15:00',1.03),('8537','2014-05-02','17:20:00',1.21),('8537','2014-05-02','17:25:00',1.41),('8537','2014-05-02','17:30:00',1.09),('8537','2014-03-27','07:55:00',1.33),('8537','2014-03-27','08:00:00',1.59),('8537','2014-03-27','08:05:00',1.62),('8537','2014-03-27','10:00:00',1.04),('8537','2014-03-27','10:05:00',1.18),('8537','2014-03-27','10:10:00',1.53),('8537','2014-03-27','10:15:00',1.25),('8537','2014-03-27','10:20:00',1.8),('8537','2014-03-27','10:25:00',2.19),('8537','2014-03-27','10:30:00',2.42),('8537','2014-03-27','10:35:00',2.18),('8537','2014-03-27','10:40:00',2.79),('8537','2014-03-27','10:45:00',1.6),('8537','2014-03-27','11:10:00',3.32),('8537','2014-03-27','11:15:00',3.44),('8537','2014-03-27','11:20:00',2.36),('8537','2014-03-27','11:50:00',1.07),('8537','2014-03-27','11:55:00',1.59),('8537','2014-03-27','12:00:00',1.54),('8537','2014-03-27','12:05:00',1.07),('8537','2014-03-27','12:10:00',1.83),('8537','2014-03-27','12:15:00',1.35),('8537','2014-03-27','12:20:00',1.24),('8537','2014-03-27','13:00:00',1.08),('8537','2014-03-27','13:05:00',1.2),('8537','2014-03-27','13:10:00',1.73),('8537','2014-03-27','13:15:00',2.42),('8537','2014-03-27','13:20:00',2.62),('8537','2014-03-27','13:25:00',2.83),('8537','2014-03-27','13:30:00',2.43),('8537','2014-03-27','13:35:00',2.24),('8537','2014-03-27','13:40:00',2.08),('8537','2014-03-27','13:45:00',2),('8537','2014-03-27','13:50:00',2.35),('8537','2014-03-27','13:55:00',3.09),('8537','2014-03-27','14:00:00',2.44),('8537','2014-03-27','14:05:00',1.37),('8537','2014-03-27','14:15:00',2.39),('8537','2014-03-27','14:20:00',3.6),('8537','2014-03-27','14:25:00',3.54),('8537','2014-03-27','14:30:00',3.91),('8537','2014-03-27','14:35:00',2.58),('8537','2014-03-27','14:40:00',2.04),('8537','2014-03-27','14:45:00',1.92),('8537','2014-03-27','14:50:00',2.59),('8537','2014-03-27','14:55:00',2.5),('8537','2014-03-27','15:00:00',2.16),('8537','2014-03-27','15:05:00',1.67),('8537','2014-03-27','15:20:00',1.2),('8537','2014-03-27','15:25:00',2.78),('8537','2014-03-27','15:30:00',2.45),('8537','2014-03-27','15:35:00',1.62),('8537','2014-03-27','15:40:00',1.05),('8537','2014-03-27','15:50:00',1.13),('8537','2014-03-27','15:55:00',1.1),('8537','2014-03-27','16:05:00',1.15),('8537','2014-03-27','16:10:00',1.44),('8537','2014-03-27','16:15:00',1.39),('8537','2014-03-27','16:20:00',1.04),('8537','2014-03-27','16:25:00',1.14),('8537','2014-03-27','16:30:00',1.27),('8537','2014-03-27','16:35:00',1),('8537','2014-03-27','16:40:00',1.1),('8537','2014-03-27','16:45:00',1.11),('8537','2013-04-01','08:25:00',1.56),('8537','2013-04-01','08:30:00',1.61),('8537','2013-04-01','08:35:00',1.67),('8537','2013-04-01','08:40:00',1.99),('8537','2013-04-01','08:45:00',1.15),('8537','2013-04-01','08:50:00',1.77),('8537','2013-04-01','08:55:00',2.17),('8537','2013-04-01','09:00:00',2.34),('8537','2013-04-01','09:05:00',2.46),('8537','2013-04-01','09:10:00',2.66),('8537','2013-04-01','09:15:00',2.76),('8537','2013-04-01','09:20:00',2.53),('8537','2013-04-01','09:25:00',2.82),('8537','2013-04-01','09:30:00',2.92),('8537','2013-04-01','09:35:00',1.89),('8537','2013-04-01','09:40:00',2.98),('8537','2013-04-01','09:45:00',3.31),('8537','2013-04-01','09:50:00',3.38),('8537','2013-04-01','09:55:00',3.17),('8537','2013-04-01','10:00:00',3.52),('8537','2013-04-01','10:05:00',3.65),('8537','2013-04-01','10:10:00',3.43),('8537','2013-04-01','10:15:00',3.62),('8537','2013-04-01','10:20:00',3.33),('8537','2013-04-01','10:25:00',3.93),('8537','2013-04-01','10:30:00',2.61),('8537','2013-04-01','10:35:00',1.51),('8537','2013-04-01','10:40:00',2.42),('8537','2013-04-01','10:45:00',4.46),('8537','2013-04-01','10:50:00',2.32),('8537','2013-04-01','10:55:00',1.12),('8537','2013-04-01','11:00:00',1.6),('8537','2013-04-01','11:05:00',1.58),('8537','2013-04-01','11:10:00',3.07),('8537','2013-04-01','11:15:00',3.66),('8537','2013-04-01','11:20:00',3.65),('8537','2013-04-01','11:25:00',3),('8537','2013-04-01','11:30:00',1.99),('8537','2013-04-01','11:35:00',2.34),('8537','2013-04-01','11:40:00',3.81),('8537','2013-04-01','11:45:00',3.78),('8537','2013-04-01','11:50:00',2.94),('8537','2013-04-01','11:55:00',2.61),('8537','2013-04-01','12:00:00',3.51),('8537','2013-04-01','12:05:00',2.27),('8537','2013-04-01','12:10:00',2.75),('8537','2013-04-01','12:15:00',2.29),('8537','2013-04-01','12:20:00',2.01),('8537','2013-04-01','12:25:00',2.16),('8537','2013-04-01','12:30:00',2.98),('8537','2013-04-01','12:35:00',2.8),('8537','2013-04-01','12:40:00',2.73),('8537','2013-04-01','12:45:00',3.11),('8537','2013-04-01','12:50:00',3.3),('8537','2013-04-01','12:55:00',3.63),('8537','2013-04-01','13:00:00',3.46),('8537','2013-04-01','13:05:00',3.79),('8537','2013-04-01','13:10:00',3.38),('8537','2013-04-01','13:15:00',3.47),('8537','2013-04-01','13:20:00',3.42),('8537','2013-04-01','13:25:00',3.15),('8537','2013-04-01','13:30:00',3.58),('8537','2013-04-01','13:35:00',3.1),('8537','2013-04-01','13:40:00',3.97),('8537','2013-04-01','13:45:00',4.36),('8537','2013-04-01','13:50:00',4.83),('8537','2013-04-01','13:55:00',4.9),('8537','2013-04-01','14:00:00',2.79),('8537','2013-04-01','14:05:00',2.08),('8537','2013-04-01','14:10:00',2.69),('8537','2013-04-01','14:15:00',3.04),('8537','2013-04-01','14:20:00',3.16),('8537','2013-04-01','14:25:00',4.98),('8537','2013-04-01','14:30:00',3.23),('8537','2013-04-01','14:35:00',2.55),('8537','2013-04-01','14:40:00',2.27),('8537','2013-04-01','14:45:00',2.2),('8537','2013-04-01','14:50:00',2.37),('8537','2013-04-01','14:55:00',2.55),('8537','2013-04-01','15:00:00',2.27),('8537','2013-04-01','15:05:00',2.28),('8537','2013-04-01','15:10:00',2.32),('8537','2013-04-01','15:15:00',2.48),('8537','2013-04-01','15:20:00',2.54),('8537','2013-04-01','15:25:00',2.58),('8537','2013-04-01','15:30:00',2.26),('8537','2013-04-01','15:35:00',2.82),('8537','2013-04-01','15:40:00',2.71),('8537','2013-04-01','15:45:00',2.73),('8537','2013-04-01','15:50:00',3.17),('8537','2013-04-01','15:55:00',2.4),('8537','2013-04-01','16:00:00',2.18),('8537','2013-04-01','16:05:00',1.77),('8537','2013-04-01','16:10:00',1.5),('8537','2013-04-01','16:15:00',1.23),('8537','2013-04-01','16:20:00',1.16),('8537','2013-04-01','16:25:00',1.07),('8537','2013-03-31','08:20:00',1.03),('8537','2013-03-31','08:30:00',1.13),('8537','2013-03-31','08:35:00',1.35),('8537','2013-03-31','08:40:00',1.25),('8537','2013-03-31','08:45:00',1.5),('8537','2013-03-31','08:50:00',1.16),('8537','2013-03-31','08:55:00',1.28),('8537','2013-03-31','09:00:00',1.35),('8537','2013-03-31','09:05:00',1.24),('8537','2013-03-31','09:10:00',1.31),('8537','2013-03-31','09:15:00',1.37),('8537','2013-03-31','09:20:00',2.77),('8537','2013-03-31','09:25:00',3.33),('8537','2013-03-31','09:30:00',2.48),('8537','2013-03-31','09:35:00',2.44),('8537','2013-03-31','09:40:00',1.43),('8537','2013-03-31','09:45:00',3.17),('8537','2013-03-31','09:50:00',1.63),('8537','2013-03-31','09:55:00',2.31),('8537','2013-03-31','10:00:00',2.76),('8537','2013-03-31','10:15:00',1.04),('8537','2013-03-31','10:20:00',2.25),('8537','2013-03-31','10:25:00',2.96),('8537','2013-03-31','10:30:00',3.39),('8537','2013-03-31','10:35:00',3.36),('8537','2013-03-31','10:45:00',1.3),('8537','2013-03-31','10:50:00',2.3),('8537','2013-03-31','10:55:00',1.26),('8537','2013-03-31','11:10:00',1.68),('8537','2013-03-31','11:15:00',1.58),('8537','2013-03-31','11:20:00',1.31),('8537','2013-03-31','11:25:00',1.7),('8537','2013-03-31','11:30:00',1.22),('8537','2013-03-31','11:35:00',1.61),('8537','2013-03-31','11:40:00',1.85),('8537','2013-03-31','11:45:00',1.53),('8537','2013-03-31','11:50:00',1.7),('8537','2013-03-31','11:55:00',1.91),('8537','2013-03-31','12:00:00',1.73),('8537','2013-03-31','12:05:00',1.61),('8537','2013-03-31','12:10:00',1.5),('8537','2013-03-31','12:15:00',1.58),('8537','2013-03-31','12:20:00',1.52),('8537','2013-03-31','12:25:00',1.74),('8537','2013-03-31','12:30:00',2.07),('8537','2013-03-31','12:35:00',3.24),('8537','2013-03-31','12:40:00',3.36),('8537','2013-03-31','12:45:00',1.82),('8537','2013-03-31','12:50:00',1.86),('8537','2013-03-31','12:55:00',2.26),('8537','2013-03-31','13:00:00',2.78),('8537','2013-03-31','13:05:00',2.49),('8537','2013-03-31','13:10:00',3.32),('8537','2013-03-31','13:15:00',2.65),('8537','2013-03-31','13:20:00',4.4),('8537','2013-03-31','13:25:00',3.11),('8537','2013-03-31','13:40:00',1.58),('8537','2013-03-31','13:45:00',2.04),('8537','2013-03-31','13:50:00',2.49),('8537','2013-03-31','13:55:00',2.14),('8537','2013-03-31','14:00:00',1.93),('8537','2013-03-31','14:05:00',3.52),('8537','2013-03-31','14:10:00',2.35),('8537','2013-03-31','14:15:00',4),('8537','2013-03-31','14:20:00',1.81),('8537','2013-03-31','14:25:00',1.96),('8537','2013-03-31','14:30:00',3.63),('8537','2013-03-31','14:35:00',4.86),('8537','2013-03-31','14:40:00',5.45),('8537','2013-03-31','14:45:00',3.69),('8537','2013-03-31','14:50:00',3.9),('8537','2013-03-31','14:55:00',3.36),('8537','2013-03-31','15:00:00',3.06),('8537','2013-03-31','15:05:00',2.24),('8537','2013-03-31','15:10:00',3.11),('8537','2013-03-31','15:15:00',3.08),('8537','2013-03-31','15:20:00',4.64),('8537','2013-03-31','15:25:00',3.1),('8537','2013-03-31','15:30:00',2.68),('8537','2013-03-31','15:35:00',3.37),('8537','2013-03-31','15:40:00',4.68),('8537','2013-03-31','15:45:00',3.49),('8537','2013-03-31','15:50:00',1.22),('8537','2013-03-31','16:00:00',2.77),('8537','2013-03-31','16:05:00',1.51),('8537','2013-03-31','16:10:00',1.71),('8537','2013-03-31','16:15:00',2.11),('8537','2013-03-31','16:20:00',2.02),('8537','2013-03-31','16:25:00',1.5),('8537','2013-03-31','16:30:00',1.21),('8537','2013-03-31','16:35:00',1.28),('8537','2013-03-31','16:40:00',1.35),('8537','2013-03-31','16:45:00',1.16),('8537','2013-03-31','16:50:00',1.05),('8537','2013-03-31','17:00:00',1.38),('8537','2013-03-31','17:05:00',2),('8537','2013-03-31','17:10:00',1.72),('8537','2013-03-31','17:15:00',1.15),('8537','2013-03-31','17:20:00',1.24),('8537','2013-03-31','17:25:00',1.34),('8537','2013-03-31','17:30:00',1.45),('8537','2013-03-31','17:35:00',1.41),('8537','2013-03-31','17:50:00',1.05),('8537','2013-03-31','17:55:00',1.48),('8537','2013-03-31','18:15:00',1.11),('8537','2013-03-30','07:55:00',1.07),('8537','2013-03-30','08:25:00',1.02),('8537','2013-03-30','08:30:00',1.06),('8537','2013-03-30','08:35:00',1.27),('8537','2013-03-30','08:40:00',1.25),('8537','2013-03-30','08:50:00',1.04),('8537','2013-03-30','09:05:00',2.16),('8537','2013-03-30','09:10:00',2.06),('8537','2013-03-30','09:15:00',1.98),('8537','2013-03-30','09:20:00',4.51),('8537','2013-03-30','09:25:00',2.87),('8537','2013-03-30','09:30:00',1.54),('8537','2013-03-30','09:35:00',1.94),('8537','2013-03-30','09:40:00',1.66),('8537','2013-03-30','09:45:00',1.49),('8537','2013-03-30','09:50:00',1.17),('8537','2013-03-30','09:55:00',1.4),('8537','2013-03-30','10:00:00',1.88),('8537','2013-03-30','10:05:00',1.93),('8537','2013-03-30','10:10:00',2.14),('8537','2013-03-30','10:15:00',1.95),('8537','2013-03-30','10:20:00',1.66),('8537','2013-03-30','10:25:00',1.62),('8537','2013-03-30','10:30:00',1.87),('8537','2013-03-30','10:35:00',2.28),('8537','2013-03-30','10:40:00',2.92),('8537','2013-03-30','10:45:00',3.98),('8537','2013-03-30','10:50:00',3.84),('8537','2013-03-30','10:55:00',2.64),('8537','2013-03-30','11:00:00',3.84),('8537','2013-03-30','11:05:00',4.59),('8537','2013-03-30','11:10:00',5.43),('8537','2013-03-30','11:15:00',3.74),('8537','2013-03-30','11:20:00',5.83),('8537','2013-03-30','11:25:00',5.5),('8537','2013-03-30','11:30:00',2.82),('8537','2013-03-30','11:35:00',3.68),('8537','2013-03-30','11:40:00',2.64),('8537','2013-03-30','11:45:00',4.03),('8537','2013-03-30','11:50:00',4.26),('8537','2013-03-30','11:55:00',4.52),('8537','2013-03-30','12:00:00',4.95),('8537','2013-03-30','12:05:00',3.08),('8537','2013-03-30','12:10:00',2.31),('8537','2013-03-30','12:15:00',2.26),('8537','2013-03-30','12:20:00',2.21),('8537','2013-03-30','12:25:00',1.34),('8537','2013-03-30','12:30:00',1.34),('8537','2013-03-30','12:35:00',1.19),('8537','2013-03-30','13:10:00',1.28),('8537','2013-03-30','13:15:00',3.62),('8537','2013-03-30','13:20:00',3.69),('8537','2013-03-30','13:25:00',1.65),('8537','2013-03-30','13:45:00',1.54),('8537','2013-03-30','13:50:00',3.92),('8537','2013-03-30','13:55:00',3.07),('8537','2013-03-30','14:00:00',2.6),('8537','2013-03-30','14:05:00',2.48),('8537','2013-03-30','14:10:00',1.31),('8537','2013-03-30','14:15:00',1.68),('8537','2013-03-30','14:20:00',2.13),('8537','2013-03-30','14:25:00',1.57),('8537','2013-03-30','14:30:00',1.81),('8537','2013-03-30','14:35:00',1.86),('8537','2013-03-30','14:40:00',1.3),('8537','2013-03-30','14:45:00',1.33),('8537','2013-03-30','14:50:00',1.77),('8537','2013-03-30','14:55:00',1.16),('8537','2013-03-30','15:20:00',1.06),('8537','2013-03-30','15:25:00',1.08),('8537','2013-03-29','07:10:00',1.02),('8537','2013-03-29','07:15:00',1.12),('8537','2013-03-29','07:20:00',1.24),('8537','2013-03-29','07:25:00',1.38),('8537','2013-03-29','07:30:00',1.36),('8537','2013-03-29','07:35:00',1.32),('8537','2013-03-29','07:40:00',1.7),('8537','2013-03-29','07:45:00',1.91),('8537','2013-03-29','07:50:00',1.92),('8537','2013-03-29','07:55:00',1.19),('8537','2013-03-29','08:00:00',1.56),('8537','2013-03-29','08:05:00',2.05),('8537','2013-03-29','08:10:00',2.53),('8537','2013-03-29','08:15:00',2.51),('8537','2013-03-29','08:20:00',2.62),('8537','2013-03-29','08:25:00',2.68),('8537','2013-03-29','08:30:00',2.75),('8537','2013-03-29','08:35:00',2.92),('8537','2013-03-29','08:40:00',3.01),('8537','2013-03-29','08:45:00',2.95),('8537','2013-03-29','08:50:00',2.93),('8537','2013-03-29','08:55:00',2.86),('8537','2013-03-29','09:00:00',2.94),('8537','2013-03-29','09:05:00',3.16),('8537','2013-03-29','09:10:00',3.31),('8537','2013-03-29','09:15:00',3.68),('8537','2013-03-29','09:20:00',3.86),('8537','2013-03-29','09:25:00',3.55),('8537','2013-03-29','09:30:00',4.11),('8537','2013-03-29','09:35:00',4.12),('8537','2013-03-29','09:40:00',4.1),('8537','2013-03-29','09:45:00',3.67),('8537','2013-03-29','09:50:00',3.96),('8537','2013-03-29','09:55:00',4.01),('8537','2013-03-29','10:00:00',4.06),('8537','2013-03-29','10:05:00',3.78),('8537','2013-03-29','10:10:00',3.18),('8537','2013-03-29','10:15:00',4.04),('8537','2013-03-29','10:20:00',3.74),('8537','2013-03-29','10:25:00',3.67),('8537','2013-03-29','10:30:00',3.79),('8537','2013-03-29','10:35:00',3.38),('8537','2013-03-29','10:40:00',3.22),('8537','2013-03-29','10:45:00',2.65),('8537','2013-03-29','10:50:00',3.8),('8537','2013-03-29','10:55:00',4.16),('8537','2013-03-29','11:00:00',4.9),('8537','2013-03-29','11:05:00',4.8),('8537','2013-03-29','11:10:00',5.33),('8537','2013-03-29','11:15:00',3.06),('8537','2013-03-29','11:20:00',2.51),('8537','2013-03-29','11:25:00',5.14),('8537','2013-03-29','11:30:00',5.21),('8537','2013-03-29','11:35:00',4.31),('8537','2013-03-29','11:40:00',5.11),('8537','2013-03-29','11:45:00',5.08),('8537','2013-03-29','11:50:00',5.12),('8537','2013-03-29','11:55:00',5.11),('8537','2013-03-29','12:00:00',5.11),('8537','2013-03-29','12:05:00',5.23),('8537','2013-03-29','12:10:00',5.18),('8537','2013-03-29','12:15:00',4.78),('8537','2013-03-29','12:20:00',5.1),('8537','2013-03-29','12:25:00',4.9),('8537','2013-03-29','12:30:00',4.58),('8537','2013-03-29','12:35:00',4.86),('8537','2013-03-29','12:40:00',4.75),('8537','2013-03-29','12:45:00',3.64),('8537','2013-03-29','12:50:00',4.64),('8537','2013-03-29','12:55:00',3.54),('8537','2013-03-29','13:00:00',4.28),('8537','2013-03-29','13:05:00',3.45),('8537','2013-03-29','13:10:00',4.72),('8537','2013-03-29','13:15:00',4.06),('8537','2013-03-29','13:20:00',4.09),('8537','2013-03-29','13:25:00',5.09),('8537','2013-03-29','13:30:00',4.44),('8537','2013-03-29','13:35:00',3.83),('8537','2013-03-29','13:40:00',3.94),('8537','2013-03-29','13:45:00',3.97),('8537','2013-03-29','13:50:00',3.77),('8537','2013-03-29','13:55:00',3.99),('8537','2013-03-29','14:00:00',4.1),('8537','2013-03-29','14:05:00',3.46),('8537','2013-03-29','14:10:00',2.74),('8537','2013-03-29','14:15:00',2.79),('8537','2013-03-29','14:20:00',2.8),('8537','2013-03-29','14:25:00',2.8),('8537','2013-03-29','14:30:00',2.36),('8537','2013-03-29','14:35:00',2.38),('8537','2013-03-29','14:40:00',2.27),('8537','2013-03-29','14:45:00',2.11),('8537','2013-03-29','14:50:00',2.04),('8537','2013-03-29','14:55:00',1.97),('8537','2013-03-29','15:00:00',1.77),('8537','2013-03-29','15:05:00',1.78),('8537','2013-03-29','15:10:00',1.69),('8537','2013-03-29','15:15:00',1.64),('8537','2013-03-29','15:20:00',1.56),('8537','2013-03-29','15:25:00',1.42),('8537','2013-03-29','15:30:00',1.31),('8537','2013-03-29','15:35:00',1.25),('8537','2013-03-29','15:40:00',1.2),('8537','2013-03-29','15:45:00',1.15),('8537','2013-03-29','15:50:00',1.24),('8537','2013-03-29','15:55:00',1.41),('8537','2013-03-29','16:00:00',1.68),('8537','2013-03-29','16:05:00',1.57),('8537','2013-03-29','16:10:00',1.28),('8537','2013-03-29','16:15:00',1.13),('8537','2013-03-29','16:20:00',1.03),('8537','2013-03-29','16:25:00',1.07),('8537','2013-03-29','16:30:00',1.15),('8537','2013-03-29','16:35:00',1.11),('8537','2013-03-29','16:40:00',1.71),('8537','2013-03-29','16:45:00',1.49),('8537','2013-03-29','16:50:00',1.19),('8537','2013-03-29','17:00:00',1.02),('8537','2013-03-28','09:05:00',1.2),('8537','2013-03-28','09:10:00',2.01),('8537','2013-03-28','09:15:00',3.79),('8537','2013-03-28','09:20:00',1.91),('8537','2013-03-28','09:25:00',1.77),('8537','2013-03-28','09:30:00',1.31),('8537','2013-03-28','09:35:00',1.11),('8537','2013-03-28','09:45:00',1.16),('8537','2013-03-28','09:50:00',1.25),('8537','2013-03-28','09:55:00',1.23),('8537','2013-03-28','10:00:00',1.34),('8537','2013-03-28','10:05:00',1.04),('8537','2013-03-28','11:00:00',1.24),('8537','2013-03-28','11:30:00',1.01),('8537','2013-03-28','11:35:00',1.57),('8537','2013-03-28','11:40:00',2.12),('8537','2013-03-28','11:45:00',1.52),('8537','2013-03-28','11:50:00',1.51),('8537','2013-03-28','11:55:00',2.53),('8537','2013-03-28','12:00:00',1.99),('8537','2013-03-28','12:05:00',1.36),('8537','2013-03-28','12:10:00',1.25),('8537','2013-03-28','12:15:00',1.41),('8537','2013-03-28','12:20:00',1.45),('8537','2013-03-28','12:25:00',1.23),('8537','2013-03-28','12:30:00',1.16),('8537','2013-03-28','12:35:00',1.05),('8537','2013-03-28','12:40:00',1.44),('8537','2013-03-28','12:45:00',1.89),('8537','2013-03-28','12:50:00',3.7),('8537','2013-03-28','12:55:00',4.07),('8537','2013-03-28','13:00:00',3.93),('8537','2013-03-28','13:05:00',4.28),('8537','2013-03-28','13:10:00',4.5),('8537','2013-03-28','13:15:00',4.35),('8537','2013-03-28','13:20:00',3.65),('8537','2013-03-28','13:25:00',3.96),('8537','2013-03-28','13:30:00',4.42),('8537','2013-03-28','13:35:00',3.48),('8537','2013-03-28','13:40:00',2.75),('8537','2013-03-28','13:45:00',2.84),('8537','2013-03-28','13:50:00',3.46),('8537','2013-03-28','13:55:00',1.98),('8537','2013-03-28','14:00:00',2.06),('8537','2013-03-28','14:05:00',2.96),('8537','2013-03-28','14:10:00',1.8),('8537','2013-03-28','14:15:00',1.74),('8537','2013-03-28','14:20:00',1.77),('8537','2013-03-28','14:25:00',1.8),('8537','2013-03-28','14:30:00',2.08),('8537','2013-03-28','14:35:00',1.92),('8537','2013-03-28','14:40:00',1.41),('8537','2013-03-28','14:45:00',1.39),('8537','2013-03-28','14:50:00',1.23),('8537','2013-03-28','14:55:00',1.05),('8537','2013-03-28','15:00:00',1.34),('8537','2013-03-28','15:05:00',1.53),('8537','2013-03-28','15:10:00',2.36),('8537','2013-03-28','15:15:00',2.26),('8537','2013-03-28','15:20:00',2.07),('8537','2013-03-28','15:25:00',2.22),('8537','2013-03-28','15:30:00',1.71),('8537','2013-03-28','15:35:00',2.56),('8537','2013-03-28','15:40:00',1.86),('8537','2013-03-28','15:45:00',2.06),('8537','2013-03-28','15:50:00',1.53),('8537','2013-03-28','15:55:00',2.54),('8537','2013-03-28','16:00:00',1.53),('8537','2013-03-28','16:10:00',1.68),('8537','2013-03-28','16:35:00',1.46),('8537','2013-03-28','16:45:00',1.01),('8537','2013-03-28','17:00:00',1.27),('8537','2013-03-28','17:05:00',1.09),('8537','2013-03-27','07:15:00',1.06),('8537','2013-03-27','07:20:00',1.17),('8537','2013-03-27','07:25:00',1.29),('8537','2013-03-27','07:30:00',1.4),('8537','2013-03-27','07:35:00',1.37),('8537','2013-03-27','07:40:00',1.49),('8537','2013-03-27','07:45:00',1.36),('8537','2013-03-27','07:55:00',1.48),('8537','2013-03-27','08:00:00',1.55),('8537','2013-03-27','08:05:00',1.81),('8537','2013-03-27','08:10:00',1.56),('8537','2013-03-27','08:15:00',1.76),('8537','2013-03-27','08:20:00',1.52),('8537','2013-03-27','08:25:00',1.76),('8537','2013-03-27','08:30:00',2.36),('8537','2013-03-27','08:35:00',2.1),('8537','2013-03-27','08:40:00',1.62),('8537','2013-03-27','08:45:00',1.56),('8537','2013-03-27','08:50:00',1.76),('8537','2013-03-27','08:55:00',1.75),('8537','2013-03-27','09:00:00',1.61),('8537','2013-03-27','09:05:00',1.32),('8537','2013-03-27','09:15:00',2.2),('8537','2013-03-27','09:20:00',2.4),('8537','2013-03-27','09:25:00',1.6),('8537','2013-03-27','09:30:00',1.21),('8537','2013-03-27','09:40:00',1.14),('8537','2013-03-27','09:45:00',2),('8537','2013-03-27','09:50:00',3.04),('8537','2013-03-27','09:55:00',1.75),('8537','2013-03-27','10:00:00',2.02),('8537','2013-03-27','10:05:00',1.21),('8537','2013-03-27','10:10:00',1.69),('8537','2013-03-27','10:15:00',2.11),('8537','2013-03-27','10:20:00',1.82),('8537','2013-03-27','10:25:00',2.17),('8537','2013-03-27','10:30:00',2.67),('8537','2013-03-27','10:35:00',2.12),('8537','2013-03-27','10:40:00',2.3),('8537','2013-03-27','10:45:00',2.55),('8537','2013-03-27','10:50:00',2.35),('8537','2013-03-27','10:55:00',2.3),('8537','2013-03-27','11:00:00',1.87),('8537','2013-03-27','11:05:00',1.86),('8537','2013-03-27','11:10:00',2.02),('8537','2013-03-27','11:15:00',2.12),('8537','2013-03-27','11:20:00',2.18),('8537','2013-03-27','11:25:00',2.06),('8537','2013-03-27','11:30:00',2.33),('8537','2013-03-27','11:35:00',2.18),('8537','2013-03-27','11:40:00',2.06),('8537','2013-03-27','11:45:00',2.05),('8537','2013-03-27','11:50:00',1.96),('8537','2013-03-27','11:55:00',2.94),('8537','2013-03-27','12:00:00',3.46),('8537','2013-03-27','12:05:00',3.4),('8537','2013-03-27','12:10:00',3),('8537','2013-03-27','12:15:00',2.1),('8537','2013-03-27','12:20:00',2.32),('8537','2013-03-27','12:25:00',2.01),('8537','2013-03-27','12:30:00',3.83),('8537','2013-03-27','12:35:00',5.67),('8537','2013-03-27','12:40:00',5.38),('8537','2013-03-27','12:45:00',5.17),('8537','2013-03-27','12:50:00',3.58),('8537','2013-03-27','12:55:00',2.84),('8537','2013-03-27','13:00:00',1.8),('8537','2013-03-27','13:05:00',2.09),('8537','2013-03-27','13:10:00',3.07),('8537','2013-03-27','13:15:00',2.19),('8537','2013-03-27','13:20:00',1.63),('8537','2013-03-27','13:25:00',1.57),('8537','2013-03-27','13:30:00',2.39),('8537','2013-03-27','13:35:00',2.81),('8537','2013-03-27','13:40:00',2.19),('8537','2013-03-27','13:45:00',2.54),('8537','2013-03-27','13:50:00',2.87),('8537','2013-03-27','13:55:00',2.65),('8537','2013-03-27','14:00:00',2.11),('8537','2013-03-27','14:05:00',1.78),('8537','2013-03-27','14:10:00',1.87),('8537','2013-03-27','14:15:00',2.11),('8537','2013-03-27','14:20:00',2.49),('8537','2013-03-27','14:25:00',2.11),('8537','2013-03-27','14:30:00',1.74),('8537','2013-03-27','14:35:00',1.87),('8537','2013-03-27','14:40:00',2.57),('8537','2013-03-27','14:45:00',2.48),('8537','2013-03-27','14:50:00',1.77),('8537','2013-03-27','14:55:00',1.5),('8537','2013-03-27','15:00:00',1.26),('8537','2013-03-27','15:05:00',1.57),('8537','2013-03-27','15:10:00',1.78),('8537','2013-03-27','15:15:00',1.23),('8537','2013-03-27','15:20:00',1.23),('8537','2013-03-27','15:25:00',1.24),('8537','2013-03-27','16:40:00',1.04),('8537','2013-03-27','16:45:00',1.2),('8537','2013-03-27','16:50:00',1.09),('8537','2013-03-27','16:55:00',1.19),('8537','2013-03-27','17:00:00',1.23),('8537','2013-03-27','17:05:00',1.31),('8537','2013-03-27','17:10:00',1.07),('8537','2013-03-26','07:45:00',1.22),('8537','2013-03-26','07:50:00',2.14),('8537','2013-03-26','07:55:00',2.32),('8537','2013-03-26','08:30:00',1.03),('8537','2013-03-26','08:35:00',1.63),('8537','2013-03-26','08:40:00',1.75),('8537','2013-03-26','09:10:00',1.18),('8537','2013-03-26','09:15:00',1.98),('8537','2013-03-26','09:20:00',1.27),('8537','2013-03-26','09:50:00',1),('8537','2013-03-26','09:55:00',2.75),('8537','2013-03-26','10:00:00',1.62),('8537','2013-03-26','10:50:00',1.02),('8537','2013-03-26','11:00:00',1.26),('8537','2013-03-26','11:05:00',1.26),('8537','2013-03-26','11:10:00',3.06),('8537','2013-03-26','11:15:00',2.19),('8537','2013-03-26','11:20:00',2.13),('8537','2013-03-26','11:25:00',1.18),('8537','2013-03-26','11:50:00',2.04),('8537','2013-03-26','11:55:00',1.39),('8537','2013-03-26','12:00:00',1.27),('8537','2013-03-26','12:05:00',1.37),('8537','2013-03-26','12:10:00',1.49),('8537','2013-03-26','12:15:00',1.61),('8537','2013-03-26','12:20:00',1.71),('8537','2013-03-26','12:25:00',2.57),('8537','2013-03-26','12:30:00',2.21),('8537','2013-03-26','12:35:00',3.63),('8537','2013-03-26','12:40:00',2.4),('8537','2013-03-26','12:45:00',3.05),('8537','2013-03-26','12:50:00',2.12),('8537','2013-03-26','12:55:00',1.22),('8537','2013-03-26','13:00:00',1.83),('8537','2013-03-26','13:05:00',2.87),('8537','2013-03-26','13:10:00',2.95),('8537','2013-03-26','13:15:00',2.31),('8537','2013-03-26','13:20:00',1.68),('8537','2013-03-26','13:25:00',2.41),('8537','2013-03-26','13:30:00',1.85),('8537','2013-03-26','13:35:00',2.16),('8537','2013-03-26','13:40:00',2.55),('8537','2013-03-26','13:45:00',2.26),('8537','2013-03-26','13:50:00',1.97),('8537','2013-03-26','13:55:00',1.83),('8537','2013-03-26','14:00:00',1.76),('8537','2013-03-26','14:05:00',1.68),('8537','2013-03-26','14:10:00',1.72),('8537','2013-03-26','14:15:00',1.6),('8537','2013-03-26','14:20:00',1.4),('8537','2013-03-26','14:25:00',1.23),('8537','2013-03-26','14:30:00',1.03),('8537','2013-03-26','14:45:00',1.03),('8537','2013-03-26','15:35:00',1.07),('8537','2013-03-25','08:20:00',1.41),('8537','2013-03-25','08:25:00',2.13),('8537','2013-03-25','08:30:00',1.5),('8537','2013-03-25','08:45:00',1.09),('8537','2013-03-25','08:50:00',1.05),('8537','2013-03-25','08:55:00',1.3),('8537','2013-03-25','09:00:00',1.3),('8537','2013-03-25','09:05:00',1.24),('8537','2013-03-25','09:10:00',1.28),('8537','2013-03-25','09:15:00',1.25),('8537','2013-03-25','09:20:00',2.86),('8537','2013-03-25','09:25:00',3.51),('8537','2013-03-25','09:30:00',1.67),('8537','2013-03-25','09:35:00',1.11),('8537','2013-03-25','09:50:00',4.11),('8537','2013-03-25','09:55:00',4.37),('8537','2013-03-25','10:00:00',2.94),('8537','2013-03-25','10:05:00',1.66),('8537','2013-03-25','10:10:00',1.12),('8537','2013-03-25','10:15:00',1.23),('8537','2013-03-25','10:20:00',1.86),('8537','2013-03-25','10:25:00',3.01),('8537','2013-03-25','10:30:00',2.62),('8537','2013-03-25','10:35:00',1.77),('8537','2013-03-25','10:40:00',2.18),('8537','2013-03-25','10:45:00',3.05),('8537','2013-03-25','10:50:00',2.94),('8537','2013-03-25','10:55:00',2.99),('8537','2013-03-25','11:00:00',2.7),('8537','2013-03-25','11:05:00',2.26),('8537','2013-03-25','11:10:00',2.82),('8537','2013-03-25','11:15:00',3.11),('8537','2013-03-25','11:20:00',4.95),('8537','2013-03-25','11:25:00',4.28),('8537','2013-03-25','11:30:00',3.04),('8537','2013-03-25','11:35:00',3.24),('8537','2013-03-25','11:40:00',1.77),('8537','2013-03-25','11:45:00',1.91),('8537','2013-03-25','11:50:00',2.2),('8537','2013-03-25','11:55:00',3.71),('8537','2013-03-25','12:00:00',4.65),('8537','2013-03-25','12:05:00',3.81),('8537','2013-03-25','12:10:00',5.04),('8537','2013-03-25','12:15:00',4.9),('8537','2013-03-25','12:20:00',3.01),('8537','2013-03-25','12:25:00',4.42),('8537','2013-03-25','12:30:00',4.97),('8537','2013-03-25','12:35:00',3.91),('8537','2013-03-25','12:40:00',3.1),('8537','2013-03-25','12:45:00',2.95),('8537','2013-03-25','12:50:00',3.54),('8537','2013-03-25','12:55:00',3.34),('8537','2013-03-25','13:00:00',2.91),('8537','2013-03-25','13:05:00',5.25),('8537','2013-03-25','13:10:00',4.41),('8537','2013-03-25','13:15:00',4.4),('8537','2013-03-25','13:20:00',5.01),('8537','2013-03-25','13:25:00',2.48),('8537','2013-03-25','13:30:00',2.35),('8537','2013-03-25','13:35:00',1.4),('8537','2013-03-25','13:40:00',1.39),('8537','2013-03-25','13:45:00',2.16),('8537','2013-03-25','13:50:00',2.47),('8537','2013-03-25','13:55:00',2.33),('8537','2013-03-25','14:00:00',1.22),('8537','2013-03-25','14:05:00',1.27),('8537','2013-03-25','14:10:00',3.17),('8537','2013-03-25','14:15:00',1.96),('8537','2013-03-25','14:20:00',2.39),('8537','2013-03-25','14:25:00',3.28),('8537','2013-03-25','14:30:00',3.49),('8537','2013-03-25','14:35:00',2.54),('8537','2013-03-25','14:40:00',1.61),('8537','2013-03-25','14:45:00',1.97),('8537','2013-03-25','14:50:00',1.79),('8537','2013-03-25','14:55:00',2.77),('8537','2013-03-25','15:00:00',3.14),('8537','2013-03-25','15:05:00',2.83),('8537','2013-03-25','15:10:00',3.25),('8537','2013-03-25','15:15:00',2.67),('8537','2013-03-25','15:20:00',2.28),('8537','2013-03-25','15:25:00',3.45),('8537','2013-03-25','15:30:00',2.55),('8537','2013-03-25','15:35:00',2.42),('8537','2013-03-25','15:40:00',2.86),('8537','2013-03-25','15:45:00',2.33),('8537','2013-03-25','15:50:00',1.27),('8537','2013-03-25','15:55:00',1.25),('8537','2013-03-25','16:00:00',2.2),('8537','2013-03-25','16:05:00',1.33),('8537','2013-03-25','16:10:00',1.39),('8537','2013-03-25','16:15:00',1.29),('8537','2013-03-25','16:30:00',1.13),('8537','2013-03-25','16:35:00',1.65),('8537','2013-03-25','16:40:00',1.88),('8537','2013-03-25','16:45:00',1.13),('8537','2013-03-24','07:25:00',1.03),('8537','2013-03-24','07:35:00',1.1),('8537','2013-03-24','07:40:00',1.15),('8537','2013-03-24','07:45:00',1.27),('8537','2013-03-24','07:50:00',1.48),('8537','2013-03-24','07:55:00',1.69),('8537','2013-03-24','08:00:00',2.01),('8537','2013-03-24','08:05:00',2.14),('8537','2013-03-24','08:10:00',2.2),('8537','2013-03-24','08:15:00',2.35),('8537','2013-03-24','08:20:00',2.44),('8537','2013-03-24','08:25:00',2.58),('8537','2013-03-24','08:30:00',2.68),('8537','2013-03-24','08:35:00',2.77),('8537','2013-03-24','08:40:00',2.85),('8537','2013-03-24','08:45:00',2.94),('8537','2013-03-24','08:50:00',2.98),('8537','2013-03-24','08:55:00',3.08),('8537','2013-03-24','09:00:00',3.15),('8537','2013-03-24','09:05:00',3.25),('8537','2013-03-24','09:10:00',3.36),('8537','2013-03-24','09:15:00',3.43),('8537','2013-03-24','09:20:00',3.51),('8537','2013-03-24','09:25:00',3.59),('8537','2013-03-24','09:30:00',3.65),('8537','2013-03-24','09:35:00',3.69),('8537','2013-03-24','09:40:00',3.75),('8537','2013-03-24','09:45:00',3.85),('8537','2013-03-24','09:50:00',3.9),('8537','2013-03-24','09:55:00',3.97),('8537','2013-03-24','10:00:00',4.04),('8537','2013-03-24','10:05:00',4.08),('8537','2013-03-24','10:10:00',4.16),('8537','2013-03-24','10:15:00',4.2),('8537','2013-03-24','10:20:00',4.24),('8537','2013-03-24','10:25:00',4.3),('8537','2013-03-24','10:30:00',4.33),('8537','2013-03-24','10:35:00',4.36),('8537','2013-03-24','10:40:00',4.39),('8537','2013-03-24','10:45:00',4.4),('8537','2013-03-24','10:50:00',4.46),('8537','2013-03-24','10:55:00',4.5),('8537','2013-03-24','11:00:00',4.54),('8537','2013-03-24','11:05:00',4.57),('8537','2013-03-24','11:10:00',4.59),('8537','2013-03-24','11:15:00',4.64),('8537','2013-03-24','11:20:00',4.58),('8537','2013-03-24','11:25:00',4.6),('8537','2013-03-24','11:30:00',4.62),('8537','2013-03-24','11:35:00',4.64),('8537','2013-03-24','11:40:00',4.66),('8537','2013-03-24','11:45:00',4.68),('8537','2013-03-24','11:50:00',4.69),('8537','2013-03-24','11:55:00',4.7),('8537','2013-03-24','12:00:00',4.75),('8537','2013-03-24','12:05:00',4.73),('8537','2013-03-24','12:10:00',4.78),('8537','2013-03-24','12:15:00',4.81),('8537','2013-03-24','12:20:00',4.88),('8537','2013-03-24','12:25:00',4.94),('8537','2013-03-24','12:30:00',4.92),('8537','2013-03-24','12:35:00',4.89),('8537','2013-03-24','12:40:00',4.87),('8537','2013-03-24','12:45:00',4.88),('8537','2013-03-24','12:50:00',4.88),('8537','2013-03-24','12:55:00',4.85),('8537','2013-03-24','13:00:00',4.8),('8537','2013-03-24','13:05:00',4.81),('8537','2013-03-24','13:10:00',4.78),('8537','2013-03-24','13:15:00',4.76),('8537','2013-03-24','13:20:00',4.74),('8537','2013-03-24','13:25:00',4.65),('8537','2013-03-24','13:30:00',4.56),('8537','2013-03-24','13:35:00',4.39),('8537','2013-03-24','13:40:00',4.5),('8537','2013-03-24','13:45:00',4.45),('8537','2013-03-24','13:50:00',4.42),('8537','2013-03-24','13:55:00',4.35),('8537','2013-03-24','14:00:00',4.31),('8537','2013-03-24','14:05:00',4.24),('8537','2013-03-24','14:10:00',4.16),('8537','2013-03-24','14:15:00',4.11),('8537','2013-03-24','14:20:00',3.93),('8537','2013-03-24','14:25:00',3.92),('8537','2013-03-24','14:30:00',3.8),('8537','2013-03-24','14:35:00',3.66),('8537','2013-03-24','14:40:00',3.62),('8537','2013-03-24','14:45:00',3.58),('8537','2013-03-24','14:50:00',3.41),('8537','2013-03-24','14:55:00',3.39),('8537','2013-03-24','15:00:00',3.23),('8537','2013-03-24','15:05:00',3.17),('8537','2013-03-24','15:10:00',2.9),('8537','2013-03-24','15:15:00',3.23),('8537','2013-03-24','15:20:00',3.09),('8537','2013-03-24','15:25:00',2.91),('8537','2013-03-24','15:30:00',2.6),('8537','2013-03-24','15:35:00',2.4),('8537','2013-03-24','15:40:00',2.53),('8537','2013-03-24','15:45:00',2.09),('8537','2013-03-24','15:50:00',1.43),('8537','2013-03-24','15:55:00',1.38),('8537','2013-03-24','16:00:00',1.38),('8537','2013-03-24','16:05:00',1.57),('8537','2013-03-24','16:10:00',1.15),('8537','2013-03-24','16:15:00',1.44),('8537','2013-03-24','16:20:00',1.23),('8537','2013-03-24','16:25:00',1.16),('8537','2013-03-24','16:30:00',1.21),('8537','2013-03-24','16:35:00',1.12),('8537','2013-03-23','07:15:00',1.03),('8537','2013-03-23','07:20:00',1.1),('8537','2013-03-23','07:25:00',1.14),('8537','2013-03-23','07:30:00',1.2),('8537','2013-03-23','07:35:00',1.26),('8537','2013-03-23','07:40:00',1.44),('8537','2013-03-23','07:45:00',1.47),('8537','2013-03-23','07:50:00',1.62),('8537','2013-03-23','07:55:00',1.83),('8537','2013-03-23','08:00:00',2.01),('8537','2013-03-23','08:05:00',2.21),('8537','2013-03-23','08:10:00',2.3),('8537','2013-03-23','08:15:00',2.38),('8537','2013-03-23','08:20:00',2.49),('8537','2013-03-23','08:25:00',2.58),('8537','2013-03-23','08:30:00',2.62),('8537','2013-03-23','08:35:00',2.74),('8537','2013-03-23','08:40:00',2.87),('8537','2013-03-23','08:45:00',2.96),('8537','2013-03-23','08:50:00',3.06),('8537','2013-03-23','08:55:00',3.23),('8537','2013-03-23','09:00:00',3.31),('8537','2013-03-23','09:05:00',3.4),('8537','2013-03-23','09:10:00',3.45),('8537','2013-03-23','09:15:00',3.55),('8537','2013-03-23','09:20:00',3.67),('8537','2013-03-23','09:25:00',3.72),('8537','2013-03-23','09:30:00',3.74),('8537','2013-03-23','09:35:00',3.91),('8537','2013-03-23','09:40:00',3.77),('8537','2013-03-23','09:45:00',3.97),('8537','2013-03-23','09:50:00',3.99),('8537','2013-03-23','09:55:00',4.07),('8537','2013-03-23','10:00:00',4.17),('8537','2013-03-23','10:05:00',4.18),('8537','2013-03-23','10:10:00',4.22),('8537','2013-03-23','10:15:00',4.16),('8537','2013-03-23','10:20:00',4.16),('8537','2013-03-23','10:25:00',4.31),('8537','2013-03-23','10:30:00',4.48),('8537','2013-03-23','10:35:00',4.57),('8537','2013-03-23','10:40:00',4.47),('8537','2013-03-23','10:45:00',4.45),('8537','2013-03-23','10:50:00',4.5),('8537','2013-03-23','10:55:00',4.35),('8537','2013-03-23','11:00:00',4.33),('8537','2013-03-23','11:05:00',4.09),('8537','2013-03-23','11:10:00',3.35),('8537','2013-03-23','11:15:00',3.63),('8537','2013-03-23','11:20:00',4.56),('8537','2013-03-23','11:25:00',4.49),('8537','2013-03-23','11:30:00',4.55),('8537','2013-03-23','11:35:00',4.77),('8537','2013-03-23','11:40:00',4.72),('8537','2013-03-23','11:45:00',4.72),('8537','2013-03-23','11:50:00',4.57),('8537','2013-03-23','11:55:00',4.77),('8537','2013-03-23','12:00:00',4.78),('8537','2013-03-23','12:05:00',4.74),('8537','2013-03-23','12:10:00',4.78),('8537','2013-03-23','12:15:00',4.83),('8537','2013-03-23','12:20:00',4.91),('8537','2013-03-23','12:25:00',4.79),('8537','2013-03-23','12:30:00',4.81),('8537','2013-03-23','12:35:00',4.83),('8537','2013-03-23','12:40:00',4.59),('8537','2013-03-23','12:45:00',4.71),('8537','2013-03-23','12:50:00',4.82),('8537','2013-03-23','12:55:00',4.68),('8537','2013-03-23','13:00:00',3.76),('8537','2013-03-23','13:05:00',4.78),('8537','2013-03-23','13:10:00',4.78),('8537','2013-03-23','13:15:00',4.56),('8537','2013-03-23','13:20:00',4.66),('8537','2013-03-23','13:25:00',4.65),('8537','2013-03-23','13:30:00',4.38),('8537','2013-03-23','13:35:00',3.65),('8537','2013-03-23','13:40:00',4.32),('8537','2013-03-23','13:45:00',4.38),('8537','2013-03-23','13:50:00',4.48),('8537','2013-03-23','13:55:00',4.34),('8537','2013-03-23','14:00:00',4.27),('8537','2013-03-23','14:05:00',4.29),('8537','2013-03-23','14:10:00',4.19),('8537','2013-03-23','14:15:00',4.01),('8537','2013-03-23','14:20:00',4.03),('8537','2013-03-23','14:25:00',3.59),('8537','2013-03-23','14:30:00',3.13),('8537','2013-03-23','14:35:00',3.86),('8537','2013-03-23','14:40:00',3.79),('8537','2013-03-23','14:45:00',3.54),('8537','2013-03-23','14:50:00',3.49),('8537','2013-03-23','14:55:00',3.5),('8537','2013-03-23','15:00:00',3.32),('8537','2013-03-23','15:05:00',3.11),('8537','2013-03-23','15:10:00',3.22),('8537','2013-03-23','15:15:00',2.99),('8537','2013-03-23','15:20:00',3.01),('8537','2013-03-23','15:25:00',2.99),('8537','2013-03-23','15:30:00',2.69),('8537','2013-03-23','15:35:00',2.63),('8537','2013-03-23','15:40:00',2.49),('8537','2013-03-23','15:45:00',2.32),('8537','2013-03-23','15:50:00',2.15),('8537','2013-03-23','15:55:00',2.06),('8537','2013-03-23','16:00:00',1.92),('8537','2013-03-23','16:05:00',1.68),('8537','2013-03-23','16:10:00',2.15),('8537','2013-03-23','16:15:00',1.9),('8537','2013-03-23','16:20:00',1.58),('8537','2013-03-23','16:25:00',1.61),('8537','2013-03-23','16:30:00',1.23),('8537','2013-03-23','16:35:00',1.32),('8537','2013-03-23','16:40:00',1.13),('8537','2013-03-23','16:45:00',1.12),('8537','2013-03-23','17:00:00',1.02),('8537','2013-03-23','17:05:00',1.03),('8537','2014-03-26','07:15:00',1.11),('8537','2014-03-26','07:20:00',1.22),('8537','2014-03-26','07:25:00',1.33),('8537','2014-03-26','07:30:00',1.47),('8537','2014-03-26','07:35:00',1.57),('8537','2014-03-26','07:40:00',1.69),('8537','2014-03-26','07:45:00',1.81),('8537','2014-03-26','07:50:00',1.94),('8537','2014-03-26','07:55:00',2.06),('8537','2014-03-26','08:00:00',2.16),('8537','2014-03-26','08:05:00',2.32),('8537','2014-03-26','08:10:00',2.48),('8537','2014-03-26','08:15:00',2.71),('8537','2014-03-26','08:20:00',2.91),('8537','2014-03-26','08:25:00',1.58),('8537','2014-03-26','08:30:00',1.31),('8537','2014-03-26','08:35:00',1.07),('8537','2014-03-26','08:40:00',1.24),('8537','2014-03-26','08:45:00',1.38),('8537','2014-03-26','08:50:00',1.66),('8537','2014-03-26','08:55:00',1.48),('8537','2014-03-26','09:00:00',1.6),('8537','2014-03-26','09:05:00',1.55),('8537','2014-03-26','09:10:00',1.84),('8537','2014-03-26','09:15:00',1.54),('8537','2014-03-26','09:20:00',1.35),('8537','2014-03-26','09:25:00',1.86),('8537','2014-03-26','09:30:00',4.17),('8537','2014-03-26','09:35:00',4.06),('8537','2014-03-26','09:40:00',4.08),('8537','2014-03-26','09:45:00',4.12),('8537','2014-03-26','09:50:00',4.22),('8537','2014-03-26','09:55:00',3.97),('8537','2014-03-26','10:00:00',3.08),('8537','2014-03-26','10:05:00',4.66),('8537','2014-03-26','10:10:00',4.86),('8537','2014-03-26','10:15:00',4.67),('8537','2014-03-26','10:20:00',3.89),('8537','2014-03-26','10:25:00',5),('8537','2014-03-26','10:30:00',4.97),('8537','2014-03-26','10:35:00',3.5),('8537','2014-03-26','10:40:00',1.27),('8537','2014-03-26','10:45:00',4.04),('8537','2014-03-26','10:50:00',3.05),('8537','2014-03-26','10:55:00',4.35),('8537','2014-03-26','11:00:00',3.99),('8537','2014-03-26','11:05:00',2.3),('8537','2014-03-26','11:10:00',4.05),('8537','2014-03-26','11:15:00',4.9),('8537','2014-03-26','11:20:00',3.45),('8537','2014-03-26','11:25:00',1.52),('8537','2014-03-26','11:30:00',1.91),('8537','2014-03-26','11:35:00',2.13),('8537','2014-03-26','11:40:00',2.33),('8537','2014-03-26','11:45:00',2.89),('8537','2014-03-26','11:50:00',3.28),('8537','2014-03-26','11:55:00',5.22),('8537','2014-03-26','12:00:00',5.73),('8537','2014-03-26','12:05:00',4.48),('8537','2014-03-26','12:10:00',4.7),('8537','2014-03-26','12:15:00',1.82),('8537','2014-03-26','12:20:00',2.11),('8537','2014-03-26','12:25:00',2.06),('8537','2014-03-26','12:30:00',1.99),('8537','2014-03-26','12:35:00',1.96),('8537','2014-03-26','12:40:00',2.17),('8537','2014-03-26','12:45:00',2.75),('8537','2014-03-26','12:50:00',1.83),('8537','2014-03-26','12:55:00',1.49),('8537','2014-03-26','13:00:00',1.65),('8537','2014-03-26','13:05:00',1.45),('8537','2014-03-26','13:10:00',1.18),('8537','2014-03-26','13:20:00',1.48),('8537','2014-03-26','13:25:00',5.51),('8537','2014-03-26','13:30:00',4.85),('8537','2014-03-26','13:35:00',2.94),('8537','2014-03-26','13:40:00',3.16),('8537','2014-03-26','13:45:00',1.02),('8537','2014-03-26','13:55:00',1.35),('8537','2014-03-26','14:00:00',2.04),('8537','2014-03-26','14:05:00',3.96),('8537','2014-03-26','14:10:00',4.29),('8537','2014-03-26','14:15:00',1.69),('8537','2014-03-26','14:20:00',1.17),('8537','2014-03-26','14:45:00',2.19),('8537','2014-03-26','14:50:00',3.8),('8537','2014-03-26','14:55:00',3.94),('8537','2014-03-26','15:00:00',3.34),('8537','2014-03-26','15:05:00',3.6),('8537','2014-03-26','15:10:00',3.63),('8537','2014-03-26','15:15:00',3.75),('8537','2014-03-26','15:20:00',3.45),('8537','2014-03-26','15:25:00',3.6),('8537','2014-03-26','15:30:00',3.62),('8537','2014-03-26','15:35:00',3.29),('8537','2014-03-26','15:40:00',2.23),('8537','2014-03-26','15:45:00',2.21),('8537','2014-03-26','15:50:00',2.23),('8537','2014-03-26','15:55:00',2.03),('8537','2014-03-26','16:00:00',1.46),('8537','2014-03-26','16:05:00',1.4),('8537','2014-03-26','16:10:00',1.4),('8537','2014-03-26','16:15:00',1.27),('8537','2014-03-26','16:20:00',1.17),('8537','2013-03-22','07:20:00',1.08),('8537','2013-03-22','07:25:00',1.2),('8537','2013-03-22','07:30:00',1.32),('8537','2013-03-22','07:35:00',1.44),('8537','2013-03-22','07:40:00',1.57),('8537','2013-03-22','07:45:00',1.69),('8537','2013-03-22','07:50:00',1.79),('8537','2013-03-22','07:55:00',1.89),('8537','2013-03-22','08:00:00',2.01),('8537','2013-03-22','08:05:00',2.14),('8537','2013-03-22','08:10:00',2.25),('8537','2013-03-22','08:15:00',2.35),('8537','2013-03-22','08:20:00',2.49),('8537','2013-03-22','08:25:00',2.59),('8537','2013-03-22','08:30:00',2.71),('8537','2013-03-22','08:35:00',2.82),('8537','2013-03-22','08:40:00',2.91),('8537','2013-03-22','08:45:00',3),('8537','2013-03-22','08:50:00',3.11),('8537','2013-03-22','08:55:00',3.2),('8537','2013-03-22','09:00:00',3.28),('8537','2013-03-22','09:05:00',3.36),('8537','2013-03-22','09:10:00',3.44),('8537','2013-03-22','09:15:00',3.54),('8537','2013-03-22','09:20:00',3.59),('8537','2013-03-22','09:25:00',3.67),('8537','2013-03-22','09:30:00',3.74),('8537','2013-03-22','09:35:00',3.83),('8537','2013-03-22','09:40:00',3.89),('8537','2013-03-22','09:45:00',4),('8537','2013-03-22','09:50:00',4.04),('8537','2013-03-22','09:55:00',4.1),('8537','2013-03-22','10:00:00',4.17),('8537','2013-03-22','10:05:00',4.24),('8537','2013-03-22','10:10:00',4.31),('8537','2013-03-22','10:15:00',4.36),('8537','2013-03-22','10:20:00',4.38),('8537','2013-03-22','10:25:00',4.5),('8537','2013-03-22','10:30:00',4.58),('8537','2013-03-22','10:35:00',4.63),('8537','2013-03-22','10:40:00',4.65),('8537','2013-03-22','10:45:00',4.68),('8537','2013-03-22','10:50:00',4.73),('8537','2013-03-22','10:55:00',4.78),('8537','2013-03-22','11:00:00',4.77),('8537','2013-03-22','11:05:00',4.78),('8537','2013-03-22','11:10:00',4.81),('8537','2013-03-22','11:15:00',4.87),('8537','2013-03-22','11:20:00',4.87),('8537','2013-03-22','11:25:00',4.9),('8537','2013-03-22','11:30:00',4.97),('8537','2013-03-22','11:35:00',4.98),('8537','2013-03-22','11:40:00',4.98),('8537','2013-03-22','11:45:00',5.04),('8537','2013-03-22','11:50:00',5.03),('8537','2013-03-22','11:55:00',5.04),('8537','2013-03-22','12:00:00',5.07),('8537','2013-03-22','12:05:00',5.06),('8537','2013-03-22','12:10:00',5.06),('8537','2013-03-22','12:15:00',5.04),('8537','2013-03-22','12:20:00',5.03),('8537','2013-03-22','12:25:00',5.06),('8537','2013-03-22','12:30:00',5.05),('8537','2013-03-22','12:35:00',5),('8537','2013-03-22','12:40:00',5.06),('8537','2013-03-22','12:45:00',5.04),('8537','2013-03-22','12:50:00',4.96),('8537','2013-03-22','12:55:00',4.77),('8537','2013-03-22','13:00:00',5),('8537','2013-03-22','13:05:00',4.84),('8537','2013-03-22','13:10:00',4.98),('8537','2013-03-22','13:15:00',4.96),('8537','2013-03-22','13:20:00',4.9),('8537','2013-03-22','13:25:00',4.64),('8537','2013-03-22','13:30:00',4.55),('8537','2013-03-22','13:35:00',4.58),('8537','2013-03-22','13:40:00',3.97),('8537','2013-03-22','13:45:00',4.08),('8537','2013-03-22','13:50:00',4.68),('8537','2013-03-22','13:55:00',4.59),('8537','2013-03-22','14:00:00',4.47),('8537','2013-03-22','14:05:00',4.43),('8537','2013-03-22','14:10:00',4.39),('8537','2013-03-22','14:15:00',4.33),('8537','2013-03-22','14:20:00',4.18),('8537','2013-03-22','14:25:00',4.15),('8537','2013-03-22','14:30:00',4.1),('8537','2013-03-22','14:35:00',4.01),('8537','2013-03-22','14:40:00',3.92),('8537','2013-03-22','14:45:00',3.86),('8537','2013-03-22','14:50:00',3.81),('8537','2013-03-22','14:55:00',3.71),('8537','2013-03-22','15:00:00',3.62),('8537','2013-03-22','15:05:00',3.53),('8537','2013-03-22','15:10:00',3.15),('8537','2013-03-22','15:15:00',2.6),('8537','2013-03-22','15:20:00',2.55),('8537','2013-03-22','15:25:00',2.69),('8537','2013-03-22','15:30:00',2.44),('8537','2013-03-22','15:35:00',2.46),('8537','2013-03-22','15:40:00',2.62),('8537','2013-03-22','15:45:00',2.32),('8537','2013-03-22','15:50:00',2.45),('8537','2013-03-22','15:55:00',2.1),('8537','2013-03-22','16:00:00',1.53),('8537','2013-03-22','16:05:00',1.55),('8537','2013-03-22','16:10:00',1.77),('8537','2013-03-22','16:15:00',2.07),('8537','2013-03-22','16:20:00',1.66),('8537','2013-03-22','16:25:00',1.63),('8537','2013-03-22','16:30:00',1.75),('8537','2013-03-22','16:35:00',1.73),('8537','2013-03-22','16:40:00',1.64),('8537','2013-03-22','16:45:00',1.47),('8537','2013-03-22','16:50:00',1.35),('8537','2013-03-22','16:55:00',1.28),('8537','2013-03-22','17:00:00',1.12),('8537','2013-03-21','07:35:00',1.12),('8537','2013-03-21','07:40:00',1.49),('8537','2013-03-21','07:45:00',1.75),('8537','2013-03-21','07:50:00',1.94),('8537','2013-03-21','07:55:00',1.01),('8537','2013-03-21','08:10:00',1.22),('8537','2013-03-21','08:15:00',2.46),('8537','2013-03-21','08:20:00',2.7),('8537','2013-03-21','08:25:00',2.85),('8537','2013-03-21','08:30:00',2.74),('8537','2013-03-21','08:35:00',2.96),('8537','2013-03-21','08:40:00',3.24),('8537','2013-03-21','08:45:00',3.24),('8537','2013-03-21','08:50:00',3.19),('8537','2013-03-21','08:55:00',2.91),('8537','2013-03-21','09:00:00',3.49),('8537','2013-03-21','09:05:00',3.73),('8537','2013-03-21','09:10:00',4.21),('8537','2013-03-21','09:15:00',3.25),('8537','2013-03-21','09:20:00',3.69),('8537','2013-03-21','09:25:00',3.83),('8537','2013-03-21','09:30:00',4.12),('8537','2013-03-21','09:35:00',4.13),('8537','2013-03-21','09:40:00',3.89),('8537','2013-03-21','09:45:00',4.21),('8537','2013-03-21','09:50:00',4.36),('8537','2013-03-21','09:55:00',4.46),('8537','2013-03-21','10:00:00',4.53),('8537','2013-03-21','10:05:00',4.53),('8537','2013-03-21','10:10:00',4.59),('8537','2013-03-21','10:15:00',4.63),('8537','2013-03-21','10:20:00',4.7),('8537','2013-03-21','10:25:00',4.7),('8537','2013-03-21','10:30:00',4.74),('8537','2013-03-21','10:35:00',4.82),('8537','2013-03-21','10:40:00',4.88),('8537','2013-03-21','10:45:00',4.86),('8537','2013-03-21','10:50:00',4.85),('8537','2013-03-21','10:55:00',3.41),('8537','2013-03-21','11:00:00',3.44),('8537','2013-03-21','11:05:00',5.05),('8537','2013-03-21','11:10:00',5.08),('8537','2013-03-21','11:15:00',5.16),('8537','2013-03-21','11:20:00',5.17),('8537','2013-03-21','11:25:00',5.18),('8537','2013-03-21','11:30:00',5.23),('8537','2013-03-21','11:35:00',5.28),('8537','2013-03-21','11:40:00',5.29),('8537','2013-03-21','11:45:00',5.32),('8537','2013-03-21','11:50:00',5.34),('8537','2013-03-21','11:55:00',5.33),('8537','2013-03-21','12:00:00',5.32),('8537','2013-03-21','12:05:00',5.33),('8537','2013-03-21','12:10:00',5.34),('8537','2013-03-21','12:15:00',5.33),('8537','2013-03-21','12:20:00',5.32),('8537','2013-03-21','12:25:00',5.31),('8537','2013-03-21','12:30:00',5.32),('8537','2013-03-21','12:35:00',5.29),('8537','2013-03-21','12:40:00',5.29),('8537','2013-03-21','12:45:00',5.26),('8537','2013-03-21','12:50:00',5.23),('8537','2013-03-21','12:55:00',5.21),('8537','2013-03-21','13:00:00',5.18),('8537','2013-03-21','13:05:00',5.14),('8537','2013-03-21','13:10:00',5.03),('8537','2013-03-21','13:15:00',5.09),('8537','2013-03-21','13:20:00',5.03),('8537','2013-03-21','13:25:00',4.98),('8537','2013-03-21','13:30:00',4.93),('8537','2013-03-21','13:35:00',4.66),('8537','2013-03-21','13:40:00',4.64),('8537','2013-03-21','13:45:00',4.78),('8537','2013-03-21','13:50:00',4.72),('8537','2013-03-21','13:55:00',4.66),('8537','2013-03-21','14:00:00',4.61),('8537','2013-03-21','14:05:00',4.52),('8537','2013-03-21','14:10:00',4.43),('8537','2013-03-21','14:15:00',4.39),('8537','2013-03-21','14:20:00',4.19),('8537','2013-03-21','14:25:00',4.07),('8537','2013-03-21','14:30:00',4.14),('8537','2013-03-21','14:35:00',4.05),('8537','2013-03-21','14:40:00',3.97),('8537','2013-03-21','14:45:00',3.91),('8537','2013-03-21','14:50:00',3.85),('8537','2013-03-21','14:55:00',3.74),('8537','2013-03-21','15:00:00',3.62),('8537','2013-03-21','15:05:00',3.57),('8537','2013-03-21','15:10:00',3.48),('8537','2013-03-21','15:15:00',3.39),('8537','2013-03-21','15:20:00',3.29),('8537','2013-03-21','15:25:00',3.21),('8537','2013-03-21','15:30:00',3.05),('8537','2013-03-21','15:35:00',2.63),('8537','2013-03-21','15:40:00',2.88),('8537','2013-03-21','15:45:00',2.77),('8537','2013-03-21','15:50:00',2.6),('8537','2013-03-21','15:55:00',2.49),('8537','2013-03-21','16:00:00',2.39),('8537','2013-03-21','16:05:00',2.29),('8537','2013-03-21','16:10:00',2.12),('8537','2013-03-21','16:15:00',2.03),('8537','2013-03-21','16:20:00',1.89),('8537','2013-03-21','16:25:00',1.77),('8537','2013-03-21','16:30:00',1.65),('8537','2013-03-21','16:35:00',1.53),('8537','2013-03-21','16:40:00',1.38),('8537','2013-03-21','16:45:00',1.29),('8537','2013-03-21','16:50:00',1.19),('8537','2013-03-21','16:55:00',1.06),('8537','2013-03-20','07:20:00',1.05),('8537','2013-03-20','07:25:00',1.19),('8537','2013-03-20','07:30:00',1.33),('8537','2013-03-20','07:35:00',1.49),('8537','2013-03-20','07:40:00',1.52),('8537','2013-03-20','07:45:00',1.6),('8537','2013-03-20','07:50:00',1.64),('8537','2013-03-20','07:55:00',1.94),('8537','2013-03-20','08:00:00',1.71),('8537','2013-03-20','08:05:00',1.79),('8537','2013-03-20','08:10:00',2.21),('8537','2013-03-20','08:15:00',2.34),('8537','2013-03-20','08:20:00',2.43),('8537','2013-03-20','08:25:00',2.58),('8537','2013-03-20','08:30:00',2.73),('8537','2013-03-20','08:35:00',2.77),('8537','2013-03-20','08:40:00',2.77),('8537','2013-03-20','08:45:00',2.88),('8537','2013-03-20','08:50:00',3.02),('8537','2013-03-20','08:55:00',2.97),('8537','2013-03-20','09:00:00',3),('8537','2013-03-20','09:05:00',3.96),('8537','2013-03-20','09:10:00',3.46),('8537','2013-03-20','09:15:00',3.49),('8537','2013-03-20','09:20:00',3.51),('8537','2013-03-20','09:25:00',3.76),('8537','2013-03-20','09:30:00',3.82),('8537','2013-03-20','09:35:00',3.71),('8537','2013-03-20','09:40:00',3.84),('8537','2013-03-20','09:45:00',4.01),('8537','2013-03-20','09:50:00',4.04),('8537','2013-03-20','09:55:00',4.01),('8537','2013-03-20','10:00:00',4.18),('8537','2013-03-20','10:05:00',4.25),('8537','2013-03-20','10:10:00',3.54),('8537','2013-03-20','10:15:00',3.7),('8537','2013-03-20','10:20:00',3.4),('8537','2013-03-20','10:25:00',3.04),('8537','2013-03-20','10:30:00',3.78),('8537','2013-03-20','10:35:00',4.34),('8537','2013-03-20','10:40:00',3.89),('8537','2013-03-20','10:45:00',2.91),('8537','2013-03-20','10:50:00',4.01),('8537','2013-03-20','10:55:00',3.54),('8537','2013-03-20','11:00:00',3.48),('8537','2013-03-20','11:05:00',4.13),('8537','2013-03-20','11:10:00',3.21),('8537','2013-03-20','11:15:00',2.96),('8537','2013-03-20','11:20:00',3.35),('8537','2013-03-20','11:25:00',3.18),('8537','2013-03-20','11:30:00',2.95),('8537','2013-03-20','11:35:00',3.27),('8537','2013-03-20','11:40:00',2.65),('8537','2013-03-20','11:45:00',2.5),('8537','2013-03-20','11:50:00',2.36),('8537','2013-03-20','11:55:00',2.67),('8537','2013-03-20','12:00:00',2.56),('8537','2013-03-20','12:05:00',2.84),('8537','2013-03-20','12:10:00',2.31),('8537','2013-03-20','12:15:00',2),('8537','2013-03-20','12:20:00',1.85),('8537','2013-03-20','12:25:00',1.54),('8537','2013-03-20','12:30:00',1.24),('8537','2013-03-20','12:35:00',1.57),('8537','2013-03-20','12:40:00',1.12),('8537','2013-03-20','12:45:00',1.23),('8537','2013-03-20','12:50:00',1.72),('8537','2013-03-20','12:55:00',2.01),('8537','2013-03-20','13:00:00',2.19),('8537','2013-03-20','13:05:00',1.69),('8537','2013-03-20','13:10:00',1.71),('8537','2013-03-20','13:15:00',1.38),('8537','2013-03-20','13:20:00',1.48),('8537','2013-03-20','13:25:00',1.57),('8537','2013-03-20','13:30:00',1.7),('8537','2013-03-20','13:35:00',1.62),('8537','2013-03-20','13:40:00',2.05),('8537','2013-03-20','13:45:00',2.39),('8537','2013-03-20','13:50:00',2),('8537','2013-03-20','13:55:00',1.85),('8537','2013-03-20','14:00:00',1.85),('8537','2013-03-20','14:05:00',1.58),('8537','2013-03-20','14:10:00',1.5),('8537','2013-03-20','14:15:00',1.98),('8537','2013-03-20','14:20:00',2.46),('8537','2013-03-20','14:25:00',2.25),('8537','2013-03-20','14:30:00',1.93),('8537','2013-03-20','14:35:00',1.59),('8537','2013-03-20','14:40:00',1.27),('8537','2013-03-20','14:45:00',1.24),('8537','2013-03-20','14:50:00',1.01),('8537','2013-03-19','07:10:00',1.07),('8537','2013-03-19','07:15:00',1.16),('8537','2013-03-19','07:20:00',1.01),('8537','2013-03-19','07:25:00',1.12),('8537','2013-03-19','07:30:00',1.23),('8537','2013-03-19','07:35:00',1.34),('8537','2013-03-19','07:40:00',1.47),('8537','2013-03-19','07:45:00',1.6),('8537','2013-03-19','07:50:00',1.71),('8537','2013-03-19','07:55:00',1.76),('8537','2013-03-19','08:00:00',1.21),('8537','2013-03-19','08:05:00',1.74),('8537','2013-03-19','08:10:00',2.14),('8537','2013-03-19','08:15:00',2.33),('8537','2013-03-19','08:20:00',2.41),('8537','2013-03-19','08:25:00',2.5),('8537','2013-03-19','08:30:00',2.66),('8537','2013-03-19','08:35:00',2.49),('8537','2013-03-19','08:40:00',2.5),('8537','2013-03-19','08:45:00',3.05),('8537','2013-03-19','08:50:00',3.12),('8537','2013-03-19','08:55:00',3.21),('8537','2013-03-19','09:00:00',3.29),('8537','2013-03-19','09:05:00',3.3),('8537','2013-03-19','09:10:00',3.5),('8537','2013-03-19','09:15:00',3.14),('8537','2013-03-19','09:20:00',3.18),('8537','2013-03-19','09:25:00',3.07),('8537','2013-03-19','09:30:00',3.76),('8537','2013-03-19','09:35:00',3.91),('8537','2013-03-19','09:40:00',4.09),('8537','2013-03-19','09:45:00',4.23),('8537','2013-03-19','09:50:00',3.99),('8537','2013-03-19','09:55:00',3.27),('8537','2013-03-19','10:00:00',3.54),('8537','2013-03-19','10:05:00',3.64),('8537','2013-03-19','10:10:00',4.36),('8537','2013-03-19','10:15:00',4.52),('8537','2013-03-19','10:20:00',4.6),('8537','2013-03-19','10:25:00',4.12),('8537','2013-03-19','10:30:00',4.67),('8537','2013-03-19','10:35:00',4.77),('8537','2013-03-19','10:40:00',4.82),('8537','2013-03-19','10:45:00',4.9),('8537','2013-03-19','10:50:00',4.81),('8537','2013-03-19','10:55:00',5.03),('8537','2013-03-19','11:00:00',5.05),('8537','2013-03-19','11:05:00',5.05),('8537','2013-03-19','11:10:00',4.99),('8537','2013-03-19','11:15:00',5.16),('8537','2013-03-19','11:20:00',5.16),('8537','2013-03-19','11:25:00',5.15),('8537','2013-03-19','11:30:00',5.11),('8537','2013-03-19','11:35:00',3.17),('8537','2013-03-19','11:40:00',4.61),('8537','2013-03-19','11:45:00',4.77),('8537','2013-03-19','11:50:00',5.27),('8537','2013-03-19','11:55:00',5.31),('8537','2013-03-19','12:00:00',5.25),('8537','2013-03-19','12:05:00',5.2),('8537','2013-03-19','12:10:00',5.16),('8537','2013-03-19','12:15:00',4.86),('8537','2013-03-19','12:20:00',5.21),('8537','2013-03-19','12:25:00',5.13),('8537','2013-03-19','12:30:00',5.09),('8537','2013-03-19','12:35:00',5.14),('8537','2013-03-19','12:40:00',5.15),('8537','2013-03-19','12:45:00',5.15),('8537','2013-03-19','12:50:00',5.09),('8537','2013-03-19','12:55:00',5.09),('8537','2013-03-19','13:00:00',5.1),('8537','2013-03-19','13:05:00',5.06),('8537','2013-03-19','13:10:00',4.99),('8537','2013-03-19','13:15:00',4.94),('8537','2013-03-19','13:20:00',4.92),('8537','2013-03-19','13:25:00',4.86),('8537','2013-03-19','13:30:00',4.82),('8537','2013-03-19','13:35:00',4.64),('8537','2013-03-19','13:40:00',4.53),('8537','2013-03-19','13:45:00',4.65),('8537','2013-03-19','13:50:00',4.6),('8537','2013-03-19','13:55:00',4.53),('8537','2013-03-19','14:00:00',4.5),('8537','2013-03-19','14:05:00',4.46),('8537','2013-03-19','14:10:00',4.41),('8537','2013-03-19','14:15:00',4.33),('8537','2013-03-19','14:20:00',4.18),('8537','2013-03-19','14:25:00',4.06),('8537','2013-03-19','14:30:00',4.09),('8537','2013-03-19','14:35:00',4),('8537','2013-03-19','14:40:00',3.94),('8537','2013-03-19','14:45:00',3.86),('8537','2013-03-19','14:50:00',3.77),('8537','2013-03-19','14:55:00',3.69),('8537','2013-03-19','15:00:00',3.55),('8537','2013-03-19','15:05:00',3.47),('8537','2013-03-19','15:10:00',3.35),('8537','2013-03-19','15:15:00',3.32),('8537','2013-03-19','15:20:00',3.25),('8537','2013-03-19','15:25:00',3.14),('8537','2013-03-19','15:30:00',2.99),('8537','2013-03-19','15:35:00',2.56),('8537','2013-03-19','15:40:00',2.75),('8537','2013-03-19','15:45:00',2.73),('8537','2013-03-19','15:50:00',2.56),('8537','2013-03-19','15:55:00',2.45),('8537','2013-03-19','16:00:00',2.34),('8537','2013-03-19','16:05:00',2.24),('8537','2013-03-19','16:10:00',2.11),('8537','2013-03-19','16:15:00',1.98),('8537','2013-03-19','16:20:00',1.84),('8537','2013-03-19','16:25:00',1.74),('8537','2013-03-19','16:30:00',1.64),('8537','2013-03-19','16:35:00',1.54),('8537','2013-03-19','16:40:00',1.41),('8537','2013-03-19','16:45:00',1.13),('8537','2013-03-18','08:45:00',1.07),('8537','2013-03-18','09:55:00',1.12),('8537','2013-03-18','10:00:00',1.42),('8537','2013-03-18','10:05:00',1.77),('8537','2013-03-18','10:10:00',1.74),('8537','2013-03-18','10:15:00',1.5),('8537','2013-03-18','10:20:00',1.86),('8537','2013-03-18','10:25:00',2.41),('8537','2013-03-18','10:30:00',2.25),('8537','2013-03-18','10:35:00',1.79),('8537','2013-03-18','10:40:00',1.63),('8537','2013-03-18','10:45:00',1.69),('8537','2013-03-18','10:50:00',1.63),('8537','2013-03-18','10:55:00',1.36),('8537','2013-03-18','11:00:00',1.46),('8537','2013-03-18','11:05:00',1.61),('8537','2013-03-18','11:10:00',1.85),('8537','2013-03-18','11:15:00',2.01),('8537','2013-03-18','11:20:00',2.08),('8537','2013-03-18','11:25:00',2.22),('8537','2013-03-18','11:30:00',2.71),('8537','2013-03-18','11:35:00',2.29),('8537','2013-03-18','11:40:00',2.1),('8537','2013-03-18','11:45:00',1.77),('8537','2013-03-18','11:50:00',1.45),('8537','2013-03-18','11:55:00',1.72),('8537','2013-03-18','12:00:00',1.81),('8537','2013-03-18','12:05:00',3.15),('8537','2013-03-18','12:10:00',2.88),('8537','2013-03-18','12:15:00',3.39),('8537','2013-03-18','12:20:00',3.31),('8537','2013-03-18','12:25:00',2.26),('8537','2013-03-18','12:30:00',4),('8537','2013-03-18','12:35:00',4.37),('8537','2013-03-18','12:40:00',3.67),('8537','2013-03-18','12:45:00',3.11),('8537','2013-03-18','12:50:00',4.39),('8537','2013-03-18','12:55:00',4.76),('8537','2013-03-18','13:00:00',3.74),('8537','2013-03-18','13:05:00',1.97),('8537','2013-03-18','13:10:00',1.37),('8537','2013-03-18','13:15:00',1.03),('8537','2013-03-18','13:20:00',1.19),('8537','2013-03-18','13:25:00',2.14),('8537','2013-03-18','13:30:00',1.64),('8537','2013-03-18','13:35:00',1.36),('8537','2013-03-18','13:40:00',2.3),('8537','2013-03-18','13:45:00',2.08),('8537','2013-03-18','13:50:00',1.95),('8537','2013-03-18','13:55:00',1.8),('8537','2013-03-18','14:00:00',1.96),('8537','2013-03-18','14:05:00',3.01),('8537','2013-03-18','14:10:00',2.87),('8537','2013-03-18','14:15:00',1.47),('8537','2013-03-18','14:20:00',1.42),('8537','2013-03-18','14:25:00',2),('8537','2013-03-18','14:35:00',1.28),('8537','2013-03-18','14:40:00',1.42),('8537','2013-03-18','14:45:00',1.33),('8537','2013-03-18','14:55:00',1.07),('8537','2013-03-18','15:00:00',1.26),('8537','2013-03-18','15:05:00',1.05),('8537','2013-03-18','15:15:00',1.02),('8537','2013-03-17','08:10:00',1.13),('8537','2013-03-17','08:15:00',1.34),('8537','2013-03-17','08:20:00',1.55),('8537','2013-03-17','08:25:00',1.87),('8537','2013-03-17','08:30:00',1.6),('8537','2013-03-17','08:35:00',1.41),('8537','2013-03-17','08:40:00',1.44),('8537','2013-03-17','08:45:00',1.73),('8537','2013-03-17','08:50:00',1.69),('8537','2013-03-17','08:55:00',1.59),('8537','2013-03-17','09:00:00',1.55),('8537','2013-03-17','09:05:00',1.79),('8537','2013-03-17','09:10:00',2.04),('8537','2013-03-17','09:15:00',2.26),('8537','2013-03-17','09:20:00',1.85),('8537','2013-03-17','09:25:00',1.54),('8537','2013-03-17','09:30:00',1.68),('8537','2013-03-17','09:35:00',1.93),('8537','2013-03-17','09:40:00',1.8),('8537','2013-03-17','09:45:00',1.85),('8537','2013-03-17','09:50:00',2.07),('8537','2013-03-17','09:55:00',2.25),('8537','2013-03-17','10:00:00',2.49),('8537','2013-03-17','10:05:00',2.06),('8537','2013-03-17','10:10:00',2.01),('8537','2013-03-17','10:15:00',2.2),('8537','2013-03-17','10:20:00',2.23),('8537','2013-03-17','10:25:00',2.33),('8537','2013-03-17','10:30:00',2.26),('8537','2013-03-17','10:35:00',2.15),('8537','2013-03-17','10:40:00',2.02),('8537','2013-03-17','10:45:00',2.14),('8537','2013-03-17','10:50:00',2.09),('8537','2013-03-17','10:55:00',1.89),('8537','2013-03-17','11:00:00',1.91),('8537','2013-03-17','11:05:00',1.63),('8537','2013-03-17','11:10:00',1.56),('8537','2013-03-17','11:15:00',1.65),('8537','2013-03-17','11:20:00',1.9),('8537','2013-03-17','11:25:00',1.99),('8537','2013-03-17','11:30:00',1.79),('8537','2013-03-17','11:35:00',1.75),('8537','2013-03-17','11:40:00',1.64),('8537','2013-03-17','11:45:00',1.54),('8537','2013-03-17','11:50:00',1.42),('8537','2013-03-17','11:55:00',1.27),('8537','2013-03-17','12:00:00',1.25),('8537','2013-03-17','12:05:00',1.29),('8537','2013-03-17','12:10:00',1.64),('8537','2013-03-17','12:15:00',2.22),('8537','2013-03-17','12:20:00',2.72),('8537','2013-03-17','12:25:00',4.09),('8537','2013-03-17','12:30:00',4.36),('8537','2013-03-17','12:35:00',2.98),('8537','2013-03-17','12:40:00',3.23),('8537','2013-03-17','12:45:00',2.94),('8537','2013-03-17','12:50:00',2.56),('8537','2013-03-17','12:55:00',2.02),('8537','2013-03-17','13:00:00',2.4),('8537','2013-03-17','13:05:00',2.66),('8537','2013-03-17','13:10:00',2.93),('8537','2013-03-17','13:15:00',2.93),('8537','2013-03-17','13:20:00',2.42),('8537','2013-03-17','13:25:00',2.1),('8537','2013-03-17','13:30:00',3.15),('8537','2013-03-17','13:35:00',3.55),('8537','2013-03-17','13:40:00',2.38),('8537','2013-03-17','13:45:00',2.16),('8537','2013-03-17','13:50:00',1.68),('8537','2013-03-17','13:55:00',2.52),('8537','2013-03-17','14:00:00',2.51),('8537','2013-03-17','14:05:00',2.48),('8537','2013-03-17','14:10:00',2.92),('8537','2013-03-17','14:15:00',3.16),('8537','2013-03-17','14:20:00',3.11),('8537','2013-03-17','14:25:00',2.9),('8537','2013-03-17','14:30:00',2.7),('8537','2013-03-17','14:35:00',2.22),('8537','2013-03-17','14:40:00',1.74),('8537','2013-03-17','14:45:00',1.54),('8537','2013-03-17','14:50:00',1.34),('8537','2013-03-17','14:55:00',1.38),('8537','2013-03-17','15:00:00',1.8),('8537','2013-03-17','15:05:00',1.96),('8537','2013-03-17','15:10:00',2.38),('8537','2013-03-17','15:15:00',2.28),('8537','2013-03-17','15:20:00',2.74),('8537','2013-03-17','15:25:00',2.06),('8537','2013-03-17','15:30:00',1.49),('8537','2013-03-17','15:35:00',1.58),('8537','2013-03-17','15:40:00',1.68),('8537','2013-03-17','15:45:00',1.71),('8537','2013-03-17','15:50:00',1.04),('8537','2013-03-17','15:55:00',1.01),('8537','2013-03-17','16:45:00',1.16),('8537','2013-03-16','07:50:00',1.22),('8537','2013-03-16','08:00:00',1.2),('8537','2013-03-16','08:05:00',1.26),('8537','2013-03-16','08:10:00',1.28),('8537','2013-03-16','08:15:00',2.48),('8537','2013-03-16','08:20:00',2.85),('8537','2013-03-16','08:25:00',2.82),('8537','2013-03-16','08:30:00',2.75),('8537','2013-03-16','08:35:00',2.88),('8537','2013-03-16','08:40:00',3.03),('8537','2013-03-16','08:45:00',3.04),('8537','2013-03-16','08:50:00',3.28),('8537','2013-03-16','08:55:00',3.48),('8537','2013-03-16','09:00:00',3.48),('8537','2013-03-16','09:05:00',2.61),('8537','2013-03-16','09:10:00',3.7),('8537','2013-03-16','09:15:00',3.78),('8537','2013-03-16','09:20:00',3.74),('8537','2013-03-16','09:25:00',2.62),('8537','2013-03-16','09:30:00',3.79),('8537','2013-03-16','09:35:00',4.24),('8537','2013-03-16','09:40:00',3.84),('8537','2013-03-16','09:45:00',3.9),('8537','2013-03-16','09:50:00',4.43),('8537','2013-03-16','09:55:00',4.5),('8537','2013-03-16','10:00:00',3.59),('8537','2013-03-16','10:05:00',2.37),('8537','2013-03-16','10:10:00',3.32),('8537','2013-03-16','10:15:00',2.98),('8537','2013-03-16','10:20:00',2.43),('8537','2013-03-16','10:25:00',3.08),('8537','2013-03-16','10:30:00',2.75),('8537','2013-03-16','10:35:00',3.06),('8537','2013-03-16','10:40:00',4.49),('8537','2013-03-16','10:45:00',4.95),('8537','2013-03-16','10:50:00',4.96),('8537','2013-03-16','10:55:00',4.94),('8537','2013-03-16','11:00:00',5.03),('8537','2013-03-16','11:05:00',5.02),('8537','2013-03-16','11:10:00',5.1),('8537','2013-03-16','11:15:00',5.16),('8537','2013-03-16','11:20:00',5.12),('8537','2013-03-16','11:25:00',5.13),('8537','2013-03-16','11:30:00',5.17),('8537','2013-03-16','11:35:00',5.17),('8537','2013-03-16','11:40:00',5.17),('8537','2013-03-16','11:45:00',5.22),('8537','2013-03-16','11:50:00',5.21),('8537','2013-03-16','11:55:00',5.21),('8537','2013-03-16','12:00:00',5.22),('8537','2013-03-16','12:05:00',5.18),('8537','2013-03-16','12:10:00',5.21),('8537','2013-03-16','12:15:00',5.22),('8537','2013-03-16','12:20:00',5.16),('8537','2013-03-16','12:25:00',5.19),('8537','2013-03-16','12:30:00',5.21),('8537','2013-03-16','12:35:00',5.17),('8537','2013-03-16','12:40:00',5.16),('8537','2013-03-16','12:45:00',5.13),('8537','2013-03-16','12:50:00',5.05),('8537','2013-03-16','12:55:00',5),('8537','2013-03-16','13:00:00',4.99),('8537','2013-03-16','13:05:00',4.94),('8537','2013-03-16','13:10:00',4.85),('8537','2013-03-16','13:15:00',4.9),('8537','2013-03-16','13:20:00',3.76),('8537','2013-03-16','13:25:00',1.08),('8537','2013-03-16','13:30:00',1.1),('8537','2013-03-16','13:35:00',4.01),('8537','2013-03-16','13:40:00',4.91),('8537','2013-03-16','13:45:00',4.88),('8537','2013-03-16','13:50:00',4.43),('8537','2013-03-16','13:55:00',1.24),('8537','2013-03-16','14:00:00',4.66),('8537','2013-03-16','14:05:00',4.77),('8537','2013-03-16','14:10:00',2.43),('8537','2013-03-16','14:15:00',3.49),('8537','2013-03-16','14:20:00',2.73),('8537','2013-03-16','14:25:00',1.42),('8537','2013-03-16','14:30:00',2.51),('8537','2013-03-16','14:35:00',4.14),('8537','2013-03-16','14:40:00',2.06),('8537','2013-03-16','14:45:00',2.15),('8537','2013-03-16','15:40:00',1.05),('8537','2013-03-16','16:00:00',1),('8537','2013-03-16','16:05:00',1.59),('8537','2013-03-16','16:10:00',1.43),('8537','2013-03-16','16:15:00',1.37),('8537','2013-03-15','10:35:00',1.15),('8537','2013-03-15','10:40:00',1.34),('8537','2013-03-15','10:45:00',1.59),('8537','2013-03-15','10:50:00',1.57),('8537','2013-03-15','10:55:00',1.71),('8537','2013-03-15','11:00:00',1.67),('8537','2013-03-15','11:05:00',1.5),('8537','2013-03-15','11:10:00',1.42),('8537','2013-03-15','11:15:00',1.24),('8537','2013-03-15','11:20:00',1.48),('8537','2013-03-15','11:25:00',1.77),('8537','2013-03-15','11:30:00',1.96),('8537','2013-03-15','11:35:00',2.37),('8537','2013-03-15','11:40:00',2.82),('8537','2013-03-15','11:45:00',2.69),('8537','2013-03-15','11:50:00',2.35),('8537','2013-03-15','11:55:00',2.42),('8537','2013-03-15','12:00:00',2.17),('8537','2013-03-15','12:05:00',2.13),('8537','2013-03-15','12:10:00',2.23),('8537','2013-03-15','12:15:00',1.96),('8537','2013-03-15','12:20:00',1.96),('8537','2013-03-15','12:25:00',2),('8537','2013-03-15','12:30:00',2.07),('8537','2013-03-15','12:35:00',2.38),('8537','2013-03-15','12:40:00',2.11),('8537','2013-03-15','12:45:00',1.83),('8537','2013-03-15','12:50:00',1.71),('8537','2013-03-15','12:55:00',1.61),('8537','2013-03-15','13:00:00',1.5),('8537','2013-03-15','13:05:00',1.4),('8537','2013-03-15','13:10:00',1.42),('8537','2013-03-15','13:15:00',1.54),('8537','2013-03-15','13:20:00',1.64),('8537','2013-03-15','13:25:00',1.82),('8537','2013-03-15','13:30:00',1.78),('8537','2013-03-15','13:35:00',1.63),('8537','2013-03-15','13:40:00',1.71),('8537','2013-03-15','13:45:00',1.85),('8537','2013-03-15','13:50:00',1.54),('8537','2013-03-15','13:55:00',1.33),('8537','2013-03-15','14:00:00',1.19),('8537','2013-03-15','14:05:00',1.06),('8537','2013-03-15','14:50:00',1.09),('8537','2013-03-15','14:55:00',1.29),('8537','2013-03-15','15:00:00',1.38),('8537','2013-03-15','15:05:00',1.34),('8537','2013-03-15','15:10:00',1.32),('8537','2013-03-15','15:15:00',1.44),('8537','2013-03-15','15:20:00',1.45),('8537','2013-03-15','15:25:00',1.57),('8537','2013-03-15','15:30:00',1.44),('8537','2013-03-15','15:35:00',1.23),('8537','2013-03-15','15:40:00',1.01),('8537','2013-03-15','15:45:00',1.02),('8537','2013-03-15','15:50:00',1),('8537','2013-03-15','16:00:00',1.07),('8537','2013-03-14','11:40:00',1.01),('8537','2013-03-14','11:45:00',1.01),('8537','2013-03-14','12:50:00',1.05),('8537','2013-03-14','12:55:00',1.14),('8537','2013-03-14','13:00:00',1),('8537','2013-03-14','13:05:00',1.17),('8537','2013-03-14','13:10:00',1.25),('8537','2013-03-14','13:15:00',1.29),('8537','2013-03-14','13:20:00',1.39),('8537','2013-03-14','13:25:00',1.37),('8537','2013-03-14','13:30:00',1.35),('8537','2013-03-14','13:35:00',1.38),('8537','2013-03-14','13:40:00',1.32),('8537','2013-03-14','13:45:00',1.71),('8537','2013-03-14','13:50:00',2.14),('8537','2013-03-14','13:55:00',2.56),('8537','2013-03-14','14:00:00',2.22),('8537','2013-03-14','14:05:00',2.3),('8537','2013-03-14','14:10:00',1.77),('8537','2013-03-14','14:15:00',1.45),('8537','2013-03-14','14:20:00',1.29),('8537','2013-03-14','14:25:00',1.28),('8537','2013-03-14','14:30:00',1.24),('8537','2013-03-14','15:05:00',1.04),('8537','2013-03-14','15:10:00',1.49),('8537','2013-03-14','15:15:00',1.53),('8537','2013-03-14','15:20:00',1.41),('8537','2013-03-14','15:25:00',1.46),('8537','2013-03-14','15:30:00',1.42),('8537','2013-03-14','15:35:00',1.18),('8537','2013-03-13','08:50:00',1.37),('8537','2013-03-13','08:55:00',1.35),('8537','2013-03-13','09:10:00',1.45),('8537','2013-03-13','09:15:00',1.24),('8537','2013-03-13','09:20:00',1.28),('8537','2013-03-13','09:25:00',1.07),('8537','2013-03-13','09:45:00',1.21),('8537','2013-03-13','10:05:00',1.22),('8537','2013-03-13','10:10:00',1.47),('8537','2013-03-13','10:15:00',2.99),('8537','2013-03-13','10:20:00',2.06),('8537','2013-03-13','10:25:00',2.49),('8537','2013-03-13','10:30:00',4.39),('8537','2013-03-13','10:35:00',4.16),('8537','2013-03-13','10:40:00',3.48),('8537','2013-03-13','10:45:00',1.59),('8537','2013-03-13','10:50:00',1.45),('8537','2013-03-13','10:55:00',1.34),('8537','2013-03-13','11:00:00',1.36),('8537','2013-03-13','11:10:00',1.16),('8537','2013-03-13','11:15:00',1.15),('8537','2013-03-13','11:30:00',1.41),('8537','2013-03-13','11:35:00',1.39),('8537','2013-03-13','11:40:00',1.36),('8537','2013-03-13','11:45:00',1.48),('8537','2013-03-13','11:50:00',1.34),('8537','2013-03-13','11:55:00',1.07),('8537','2013-03-13','12:45:00',1.27),('8537','2013-03-13','12:50:00',1.53),('8537','2013-03-13','12:55:00',1.33),('8537','2013-03-13','13:00:00',1.31),('8537','2013-03-13','13:05:00',1.27),('8537','2013-03-13','13:10:00',1.15),('8537','2013-03-13','13:15:00',1.01),('8537','2013-03-13','13:35:00',1.15),('8537','2013-03-13','13:40:00',1),('8537','2014-03-25','07:10:00',1.1),('8537','2014-03-25','07:15:00',1.38),('8537','2014-03-25','07:20:00',1.6),('8537','2014-03-25','07:25:00',1.7),('8537','2014-03-25','07:30:00',1.82),('8537','2014-03-25','07:35:00',1.43),('8537','2014-03-25','07:40:00',1.32),('8537','2014-03-25','07:45:00',1.46),('8537','2014-03-25','07:50:00',1.55),('8537','2014-03-25','07:55:00',1.57),('8537','2014-03-25','08:00:00',1.47),('8537','2014-03-25','08:05:00',1.51),('8537','2014-03-25','08:10:00',1.63),('8537','2014-03-25','08:15:00',1.72),('8537','2014-03-25','08:20:00',1.56),('8537','2014-03-25','08:25:00',1.4),('8537','2014-03-25','08:30:00',1.26),('8537','2014-03-25','08:35:00',1.28),('8537','2014-03-25','08:40:00',1.52),('8537','2014-03-25','08:45:00',2.18),('8537','2014-03-25','08:50:00',2.27),('8537','2014-03-25','08:55:00',2.4),('8537','2014-03-25','09:00:00',2.18),('8537','2014-03-25','09:05:00',2.11),('8537','2014-03-25','09:10:00',2.15),('8537','2014-03-25','09:15:00',2.81),('8537','2014-03-25','09:20:00',3.02),('8537','2014-03-25','09:25:00',2.64),('8537','2014-03-25','09:30:00',2.35),('8537','2014-03-25','09:35:00',2.17),('8537','2014-03-25','09:40:00',2.22),('8537','2014-03-25','09:45:00',2.08),('8537','2014-03-25','09:50:00',2.16),('8537','2014-03-25','09:55:00',2.44),('8537','2014-03-25','10:00:00',2.87),('8537','2014-03-25','10:05:00',3.05),('8537','2014-03-25','10:10:00',3.25),('8537','2014-03-25','10:15:00',3.51),('8537','2014-03-25','10:20:00',3.51),('8537','2014-03-25','10:25:00',3.4),('8537','2014-03-25','10:30:00',3.65),('8537','2014-03-25','10:35:00',3.04),('8537','2014-03-25','10:40:00',2.49),('8537','2014-03-25','10:45:00',2.27),('8537','2014-03-25','10:50:00',2.2),('8537','2014-03-25','10:55:00',2.2),('8537','2014-03-25','11:00:00',2.38),('8537','2014-03-25','11:05:00',2.72),('8537','2014-03-25','11:10:00',3.06),('8537','2014-03-25','11:15:00',3.52),('8537','2014-03-25','11:20:00',3.64),('8537','2014-03-25','11:25:00',3.38),('8537','2014-03-25','11:30:00',3.02),('8537','2014-03-25','11:35:00',3.31),('8537','2014-03-25','11:40:00',2.77),('8537','2014-03-25','11:45:00',2.47),('8537','2014-03-25','11:50:00',2.48),('8537','2014-03-25','11:55:00',2.07),('8537','2014-03-25','12:00:00',1.47),('8537','2014-03-25','12:15:00',1.07),('8537','2014-03-25','12:20:00',1.44),('8537','2014-03-25','12:25:00',1.58),('8537','2014-03-25','12:30:00',1.14),('8537','2014-03-25','13:35:00',1.11),('8537','2014-03-25','13:40:00',1.07),('8537','2014-03-25','14:10:00',1),('8537','2014-03-25','14:15:00',1.08),('8537','2013-03-12','08:20:00',2.3),('8537','2013-03-12','08:25:00',2.31),('8537','2013-03-12','08:30:00',2.39),('8537','2013-03-12','08:35:00',2.18),('8537','2013-03-12','08:40:00',2.42),('8537','2013-03-12','08:45:00',2.91),('8537','2013-03-12','08:50:00',1.52),('8537','2013-03-12','09:00:00',1.71),('8537','2013-03-12','09:05:00',3.2),('8537','2013-03-12','09:10:00',3.26),('8537','2013-03-12','09:15:00',3.32),('8537','2013-03-12','09:20:00',3.4),('8537','2013-03-12','09:25:00',3.43),('8537','2013-03-12','09:30:00',3.4),('8537','2013-03-12','09:35:00',3.68),('8537','2013-03-12','09:40:00',3.65),('8537','2013-03-12','09:45:00',3.72),('8537','2013-03-12','09:50:00',2.38),('8537','2013-03-12','09:55:00',4.26),('8537','2013-03-12','10:00:00',4.11),('8537','2013-03-12','10:05:00',4.07),('8537','2013-03-12','10:10:00',3.63),('8537','2013-03-12','10:15:00',3.07),('8537','2013-03-12','10:20:00',1.25),('8537','2013-03-12','10:25:00',3.75),('8537','2013-03-12','10:30:00',3.04),('8537','2013-03-12','10:35:00',3.06),('8537','2013-03-12','10:40:00',2.83),('8537','2013-03-12','10:45:00',1.58),('8537','2013-03-12','10:50:00',4.19),('8537','2013-03-12','10:55:00',4.38),('8537','2013-03-12','11:00:00',5.07),('8537','2013-03-12','11:05:00',5.29),('8537','2013-03-12','11:10:00',4.11),('8537','2013-03-12','11:15:00',3.98),('8537','2013-03-12','11:20:00',5.08),('8537','2013-03-12','11:25:00',1.85),('8537','2013-03-12','11:30:00',1.79),('8537','2013-03-12','11:35:00',2.16),('8537','2013-03-12','11:40:00',2.5),('8537','2013-03-12','11:45:00',2.65),('8537','2013-03-12','11:50:00',2.9),('8537','2013-03-12','11:55:00',3.94),('8537','2013-03-12','12:00:00',1.06),('8537','2013-03-12','12:10:00',4.15),('8537','2013-03-12','12:15:00',3.26),('8537','2013-03-12','12:20:00',2.23),('8537','2013-03-12','12:25:00',2.48),('8537','2013-03-12','12:30:00',5.55),('8537','2013-03-12','12:35:00',3.16),('8537','2013-03-12','12:40:00',4.95),('8537','2013-03-12','12:45:00',1.27),('8537','2013-03-12','12:50:00',2.01),('8537','2013-03-12','12:55:00',3.6),('8537','2013-03-12','13:00:00',4.26),('8537','2013-03-12','13:05:00',4.28),('8537','2013-03-12','13:10:00',3.2),('8537','2013-03-12','13:15:00',2.34),('8537','2013-03-12','13:20:00',1.99),('8537','2013-03-12','13:25:00',2.44),('8537','2013-03-12','13:30:00',1.65),('8537','2013-03-12','13:35:00',1.81),('8537','2013-03-12','13:40:00',1.53),('8537','2013-03-12','13:45:00',1.13),('8537','2013-03-12','13:50:00',1.17),('8537','2013-03-12','13:55:00',1.75),('8537','2013-03-12','14:00:00',2.71),('8537','2013-03-12','14:05:00',3.66),('8537','2013-03-12','14:10:00',2.54),('8537','2013-03-12','14:15:00',1.45),('8537','2013-03-12','14:20:00',1.3),('8537','2013-03-12','15:10:00',1.06),('8537','2013-03-11','08:10:00',1.85),('8537','2013-03-11','08:15:00',2.03),('8537','2013-03-11','08:20:00',2.14),('8537','2013-03-11','08:25:00',2.27),('8537','2013-03-11','08:30:00',2.37),('8537','2013-03-11','08:35:00',2.51),('8537','2013-03-11','08:40:00',2.59),('8537','2013-03-11','08:45:00',2.7),('8537','2013-03-11','08:50:00',2.82),('8537','2013-03-11','08:55:00',2.91),('8537','2013-03-11','09:00:00',2.98),('8537','2013-03-11','09:05:00',3.09),('8537','2013-03-11','09:10:00',3.15),('8537','2013-03-11','09:15:00',3.3),('8537','2013-03-11','09:20:00',3.26),('8537','2013-03-11','09:25:00',1.86),('8537','2013-03-11','09:30:00',1.77),('8537','2013-03-11','09:35:00',3.74),('8537','2013-03-11','09:40:00',3.61),('8537','2013-03-11','09:45:00',3.18),('8537','2013-03-11','09:50:00',1.54),('8537','2013-03-11','09:55:00',1.02),('8537','2013-03-11','10:05:00',1.06),('8537','2013-03-11','10:10:00',1.29),('8537','2013-03-11','10:15:00',1.32),('8537','2013-03-11','10:20:00',1.47),('8537','2013-03-11','10:25:00',1.65),('8537','2013-03-11','10:30:00',1.58),('8537','2013-03-11','10:35:00',1.8),('8537','2013-03-11','10:40:00',2.84),('8537','2013-03-11','10:45:00',3.11),('8537','2013-03-11','10:50:00',3.36),('8537','2013-03-11','10:55:00',2.17),('8537','2013-03-11','11:00:00',1.8),('8537','2013-03-11','11:05:00',1.53),('8537','2013-03-11','11:10:00',1.78),('8537','2013-03-11','11:15:00',1.8),('8537','2013-03-11','11:20:00',1.56),('8537','2013-03-11','11:25:00',1.46),('8537','2013-03-11','11:30:00',2.38),('8537','2013-03-11','11:35:00',3.89),('8537','2013-03-11','11:40:00',2.53),('8537','2013-03-11','11:45:00',3.47),('8537','2013-03-11','11:50:00',2.55),('8537','2013-03-11','11:55:00',2.27),('8537','2013-03-11','12:00:00',2.04),('8537','2013-03-11','12:05:00',1.94),('8537','2013-03-11','12:10:00',1.72),('8537','2013-03-11','12:20:00',1.18),('8537','2013-03-11','12:25:00',1.08),('8537','2013-03-11','12:30:00',1.18),('8537','2013-03-11','12:35:00',1.51),('8537','2013-03-11','12:40:00',1.45),('8537','2013-03-11','12:45:00',1.51),('8537','2013-03-11','12:50:00',2.87),('8537','2013-03-11','12:55:00',4.55),('8537','2013-03-11','13:00:00',2.68),('8537','2013-03-11','13:05:00',3.02),('8537','2013-03-11','13:10:00',4.06),('8537','2013-03-11','13:15:00',4.25),('8537','2013-03-11','13:20:00',4.54),('8537','2013-03-11','13:25:00',4.5),('8537','2013-03-11','13:30:00',4.76),('8537','2013-03-11','13:35:00',4.65),('8537','2013-03-11','13:40:00',2.97),('8537','2013-03-11','13:45:00',3.73),('8537','2013-03-11','13:50:00',4.87),('8537','2013-03-11','13:55:00',1.47),('8537','2013-03-11','14:00:00',1.16),('8537','2013-03-11','14:05:00',1.01),('8537','2013-03-11','14:25:00',2.1),('8537','2013-03-11','14:30:00',1.35),('8537','2013-03-11','14:35:00',1.15),('8537','2013-03-11','14:40:00',1.42),('8537','2013-03-11','14:45:00',1.06),('8537','2013-03-11','15:30:00',1.34),('8537','2013-03-11','15:35:00',1.12),('8537','2013-03-11','15:40:00',1.38),('8537','2013-03-11','15:45:00',2.49),('8537','2013-03-11','15:50:00',2.55),('8537','2013-03-11','15:55:00',2.32),('8537','2013-03-11','16:00:00',2.17),('8537','2013-03-11','16:05:00',1.9),('8537','2013-03-11','16:10:00',1.6),('8537','2013-03-11','16:15:00',1.38),('8537','2013-03-11','16:20:00',1.81),('8537','2013-03-11','16:25:00',1.52),('8537','2013-03-11','16:30:00',1.58),('8537','2013-03-11','16:35:00',1.26),('8537','2013-03-11','16:45:00',1.44),('8537','2013-03-11','16:50:00',1.06),('8537','2013-03-10','07:45:00',1.21),('8537','2013-03-10','07:50:00',1.4),('8537','2013-03-10','07:55:00',1.61),('8537','2013-03-10','08:00:00',1.7),('8537','2013-03-10','08:05:00',1.84),('8537','2013-03-10','08:10:00',1.83),('8537','2013-03-10','08:15:00',1.85),('8537','2013-03-10','08:20:00',2.17),('8537','2013-03-10','08:25:00',2.27),('8537','2013-03-10','08:30:00',2.36),('8537','2013-03-10','08:35:00',2.48),('8537','2013-03-10','08:40:00',2.58),('8537','2013-03-10','08:45:00',2.69),('8537','2013-03-10','08:50:00',2.79),('8537','2013-03-10','08:55:00',2.91),('8537','2013-03-10','09:00:00',3.01),('8537','2013-03-10','09:05:00',3.08),('8537','2013-03-10','09:10:00',3.19),('8537','2013-03-10','09:15:00',3.28),('8537','2013-03-10','09:20:00',3.36),('8537','2013-03-10','09:25:00',3.46),('8537','2013-03-10','09:30:00',3.56),('8537','2013-03-10','09:35:00',3.63),('8537','2013-03-10','09:40:00',3.7),('8537','2013-03-10','09:45:00',3.85),('8537','2013-03-10','09:50:00',3.47),('8537','2013-03-10','09:55:00',4.19),('8537','2013-03-10','10:00:00',4.23),('8537','2013-03-10','10:05:00',2.53),('8537','2013-03-10','10:10:00',2.48),('8537','2013-03-10','10:15:00',3),('8537','2013-03-10','10:20:00',4.31),('8537','2013-03-10','10:25:00',3.44),('8537','2013-03-10','10:30:00',3.97),('8537','2013-03-10','10:35:00',4.14),('8537','2013-03-10','10:40:00',4.06),('8537','2013-03-10','10:45:00',3.52),('8537','2013-03-10','10:50:00',3.49),('8537','2013-03-10','10:55:00',3.04),('8537','2013-03-10','11:00:00',1.8),('8537','2013-03-10','11:05:00',4.12),('8537','2013-03-10','11:10:00',3.41),('8537','2013-03-10','11:15:00',2.53),('8537','2013-03-10','11:20:00',2.48),('8537','2013-03-10','11:25:00',3.86),('8537','2013-03-10','11:30:00',2.53),('8537','2013-03-10','11:35:00',3.91),('8537','2013-03-10','11:40:00',1.68),('8537','2013-03-10','11:45:00',2.23),('8537','2013-03-10','11:50:00',3.88),('8537','2013-03-10','11:55:00',5.04),('8537','2013-03-10','12:00:00',5),('8537','2013-03-10','12:05:00',4.83),('8537','2013-03-10','12:10:00',4.02),('8537','2013-03-10','12:15:00',4.12),('8537','2013-03-10','12:20:00',3.97),('8537','2013-03-10','12:25:00',4.69),('8537','2013-03-10','12:30:00',1.52),('8537','2013-03-10','12:35:00',2.44),('8537','2013-03-10','12:40:00',4.1),('8537','2013-03-10','12:45:00',4.98),('8537','2013-03-10','12:50:00',4.81),('8537','2013-03-10','12:55:00',4.95),('8537','2013-03-10','13:00:00',4.73),('8537','2013-03-10','13:05:00',4.67),('8537','2013-03-10','13:10:00',4.48),('8537','2013-03-10','13:15:00',4.65),('8537','2013-03-10','13:20:00',4.67),('8537','2013-03-10','13:25:00',4.3),('8537','2013-03-10','13:30:00',4.06),('8537','2013-03-10','13:35:00',3.97),('8537','2013-03-10','13:40:00',2.36),('8537','2013-03-10','13:45:00',2.61),('8537','2013-03-10','13:50:00',2.16),('8537','2013-03-10','13:55:00',2.04),('8537','2013-03-10','14:00:00',1.78),('8537','2013-03-10','14:05:00',2.18),('8537','2013-03-10','14:10:00',2.45),('8537','2013-03-10','14:15:00',3.15),('8537','2013-03-10','14:20:00',3.4),('8537','2013-03-10','14:25:00',1.95),('8537','2013-03-10','14:30:00',2.35),('8537','2013-03-10','14:35:00',3.54),('8537','2013-03-10','14:40:00',3.39),('8537','2013-03-10','14:45:00',1.88),('8537','2013-03-10','14:50:00',1.95),('8537','2013-03-10','14:55:00',1.79),('8537','2013-03-10','15:00:00',1.42),('8537','2013-03-10','15:05:00',1.6),('8537','2013-03-10','15:10:00',1.59),('8537','2013-03-10','15:15:00',1.04),('8537','2013-03-10','15:20:00',1.04),('8537','2013-03-10','15:50:00',1.03),('8537','2013-03-09','08:00:00',1.24),('8537','2013-03-09','08:05:00',2.04),('8537','2013-03-09','08:10:00',1.93),('8537','2013-03-09','08:15:00',1.94),('8537','2013-03-09','08:20:00',1.86),('8537','2013-03-09','08:25:00',2.22),('8537','2013-03-09','08:30:00',2.34),('8537','2013-03-09','08:35:00',2.09),('8537','2013-03-09','08:40:00',2.47),('8537','2013-03-09','08:45:00',1.82),('8537','2013-03-09','08:50:00',1.54),('8537','2013-03-09','08:55:00',2.12),('8537','2013-03-09','09:00:00',1.9),('8537','2013-03-09','09:05:00',1.04),('8537','2013-03-09','09:25:00',1.36),('8537','2013-03-09','09:30:00',3.03),('8537','2013-03-09','09:35:00',2.69),('8537','2013-03-09','09:40:00',4.08),('8537','2013-03-09','09:45:00',4.25),('8537','2013-03-09','09:50:00',2.62),('8537','2013-03-09','09:55:00',3.61),('8537','2013-03-09','10:00:00',1.73),('8537','2013-03-09','10:05:00',1.35),('8537','2013-03-09','10:10:00',1.4),('8537','2013-03-09','10:15:00',2),('8537','2013-03-09','10:20:00',1.4),('8537','2013-03-09','10:25:00',1.1),('8537','2013-03-09','10:30:00',1.14),('8537','2013-03-09','10:35:00',1.36),('8537','2013-03-09','10:40:00',1.63),('8537','2013-03-09','10:45:00',2.1),('8537','2013-03-09','10:50:00',3.53),('8537','2013-03-09','10:55:00',3.37),('8537','2013-03-09','11:00:00',3.08),('8537','2013-03-09','11:05:00',4.24),('8537','2013-03-09','11:10:00',4.02),('8537','2013-03-09','11:15:00',5),('8537','2013-03-09','11:20:00',5.03),('8537','2013-03-09','11:25:00',2.83),('8537','2013-03-09','11:30:00',3.28),('8537','2013-03-09','11:35:00',5.06),('8537','2013-03-09','11:40:00',4.48),('8537','2013-03-09','11:45:00',4.66),('8537','2013-03-09','11:50:00',4.9),('8537','2013-03-09','11:55:00',4.52),('8537','2013-03-09','12:00:00',3.61),('8537','2013-03-09','12:05:00',1.99),('8537','2013-03-09','12:10:00',2.14),('8537','2013-03-09','12:15:00',1.39),('8537','2013-03-09','12:20:00',1.63),('8537','2013-03-09','12:25:00',2.35),('8537','2013-03-09','12:30:00',1.63),('8537','2013-03-09','12:35:00',1.95),('8537','2013-03-09','12:40:00',1.71),('8537','2013-03-09','12:45:00',2.42),('8537','2013-03-09','12:50:00',2.52),('8537','2013-03-09','12:55:00',3.3),('8537','2013-03-09','13:00:00',4.94),('8537','2013-03-09','13:05:00',4.31),('8537','2013-03-09','13:10:00',4.72),('8537','2013-03-09','13:15:00',5.24),('8537','2013-03-09','13:20:00',4.45),('8537','2013-03-09','13:25:00',2.43),('8537','2013-03-09','13:30:00',4.51),('8537','2013-03-09','13:35:00',3.1),('8537','2013-03-09','13:40:00',4.2),('8537','2013-03-09','13:45:00',4.68),('8537','2013-03-09','13:50:00',4.08),('8537','2013-03-09','13:55:00',1.15),('8537','2013-03-09','14:00:00',1.27),('8537','2013-03-09','14:05:00',3.39),('8537','2013-03-09','14:10:00',4.59),('8537','2013-03-09','14:15:00',3.77),('8537','2013-03-09','14:20:00',4.02),('8537','2013-03-09','14:25:00',3.92),('8537','2013-03-09','14:30:00',3.87),('8537','2013-03-09','14:35:00',3.78),('8537','2013-03-09','14:40:00',3.72),('8537','2013-03-09','14:45:00',3.64),('8537','2013-03-09','14:50:00',3.46),('8537','2013-03-09','14:55:00',3.18),('8537','2013-03-09','15:00:00',3.31),('8537','2013-03-09','15:05:00',3.3),('8537','2013-03-09','15:10:00',3.21),('8537','2013-03-09','15:15:00',3.13),('8537','2013-03-09','15:20:00',3.03),('8537','2013-03-09','15:25:00',2.88),('8537','2013-03-09','15:30:00',2.79),('8537','2013-03-09','15:35:00',2.67),('8537','2013-03-09','15:40:00',2.65),('8537','2013-03-09','15:45:00',2.52),('8537','2013-03-09','15:50:00',2.4),('8537','2013-03-09','15:55:00',2.16),('8537','2013-03-09','16:00:00',1.93),('8537','2013-03-09','16:05:00',1.99),('8537','2013-03-09','16:10:00',1.6),('8537','2013-03-09','16:15:00',1.77),('8537','2013-03-09','16:20:00',1.43),('8537','2013-03-09','16:25:00',1.62),('8537','2013-03-09','16:30:00',1.45),('8537','2013-03-09','16:35:00',1.18),('8537','2013-03-09','16:40:00',1.04),('8537','2013-03-08','08:10:00',1.27),('8537','2013-03-08','08:15:00',1.22),('8537','2013-03-08','08:30:00',1.84),('8537','2013-03-08','08:35:00',1.92),('8537','2013-03-08','08:40:00',1.02),('8537','2013-03-08','08:50:00',1.36),('8537','2013-03-08','08:55:00',1.25),('8537','2013-03-08','09:15:00',1.3),('8537','2013-03-08','09:20:00',1.03),('8537','2013-03-08','09:30:00',1.87),('8537','2013-03-08','09:35:00',2.25),('8537','2013-03-08','09:40:00',1.42),('8537','2013-03-08','09:45:00',2.56),('8537','2013-03-08','09:50:00',2.96),('8537','2013-03-08','09:55:00',2.06),('8537','2013-03-08','10:00:00',1.21),('8537','2013-03-08','10:05:00',1.28),('8537','2013-03-08','10:10:00',1.69),('8537','2013-03-08','10:15:00',1.95),('8537','2013-03-08','10:20:00',2.11),('8537','2013-03-08','10:25:00',1.6),('8537','2013-03-08','10:30:00',2.14),('8537','2013-03-08','10:35:00',3.15),('8537','2013-03-08','10:40:00',2.37),('8537','2013-03-08','10:45:00',1.27),('8537','2013-03-08','10:50:00',1.56),('8537','2013-03-08','10:55:00',1.43),('8537','2013-03-08','11:00:00',1.37),('8537','2013-03-08','11:05:00',1.02),('8537','2013-03-08','11:35:00',2.08),('8537','2013-03-08','11:40:00',2.79),('8537','2013-03-08','11:45:00',2.17),('8537','2013-03-08','11:50:00',1.89),('8537','2013-03-08','11:55:00',2.05),('8537','2013-03-08','12:00:00',2.41),('8537','2013-03-08','12:05:00',1.48),('8537','2013-03-08','12:10:00',1.11),('8537','2013-03-08','12:20:00',1.65),('8537','2013-03-08','12:25:00',1.35),('8537','2013-03-08','12:30:00',1.24),('8537','2013-03-08','12:35:00',1.82),('8537','2013-03-08','12:40:00',2.55),('8537','2013-03-08','12:45:00',2.77),('8537','2013-03-08','12:50:00',2.9),('8537','2013-03-08','12:55:00',2.41),('8537','2013-03-08','13:00:00',2.64),('8537','2013-03-08','13:05:00',2.72),('8537','2013-03-08','13:10:00',1.76),('8537','2013-03-08','13:15:00',1.42),('8537','2013-03-08','13:20:00',1.35),('8537','2013-03-08','13:25:00',1.76),('8537','2013-03-08','13:30:00',2.21),('8537','2013-03-08','13:35:00',1.57),('8537','2013-03-08','13:40:00',1.45),('8537','2013-03-08','13:55:00',1.06),('8537','2013-03-08','17:10:00',1.16),('8537','2013-03-08','17:15:00',1.13),('8537','2013-03-07','08:40:00',1.05),('8537','2013-03-07','08:45:00',1.03),('8537','2013-03-07','08:50:00',1.23),('8537','2013-03-07','09:20:00',1.17),('8537','2013-03-07','10:30:00',1.09),('8537','2013-03-07','10:50:00',1.17),('8537','2013-03-07','10:55:00',1.47),('8537','2013-03-07','11:00:00',1.26),('8537','2013-03-07','11:05:00',1.8),('8537','2013-03-07','11:10:00',1.27),('8537','2013-03-07','11:30:00',1.71),('8537','2013-03-07','11:35:00',2.28),('8537','2013-03-07','11:40:00',2.14),('8537','2013-03-07','11:45:00',2.58),('8537','2013-03-07','11:50:00',2.35),('8537','2013-03-07','11:55:00',1.67),('8537','2013-03-07','12:00:00',1.33),('8537','2013-03-07','12:05:00',1.23),('8537','2013-03-07','12:30:00',1.09),('8537','2013-03-07','12:40:00',1.7),('8537','2013-03-07','12:45:00',2.5),('8537','2013-03-07','12:50:00',2.04),('8537','2013-03-07','12:55:00',1.81),('8537','2013-03-07','13:00:00',1.95),('8537','2013-03-07','13:05:00',1.9),('8537','2013-03-07','13:10:00',1.58),('8537','2013-03-07','13:15:00',1.9),('8537','2013-03-07','13:20:00',2.51),('8537','2013-03-07','13:25:00',2.21),('8537','2013-03-07','13:30:00',1.8),('8537','2013-03-07','13:35:00',1.57),('8537','2013-03-07','14:05:00',1.06),('8537','2013-03-07','14:10:00',1.14),('8537','2013-03-07','16:40:00',1.03),('8537','2013-03-05','08:10:00',1.14),('8537','2013-03-05','08:15:00',1.57),('8537','2013-03-05','08:20:00',1.34),('8537','2013-03-05','08:25:00',1.68),('8537','2013-03-05','08:30:00',2.51),('8537','2013-03-05','08:35:00',2.14),('8537','2013-03-05','08:40:00',2.26),('8537','2013-03-05','08:45:00',1.82),('8537','2013-03-05','08:50:00',1.93),('8537','2013-03-05','08:55:00',1.81),('8537','2013-03-05','09:00:00',2.02),('8537','2013-03-05','09:05:00',1.98),('8537','2013-03-05','09:10:00',1.85),('8537','2013-03-05','09:15:00',1.75),('8537','2013-03-05','09:20:00',1.74),('8537','2013-03-05','09:25:00',1.71),('8537','2013-03-05','09:30:00',1.81),('8537','2013-03-05','09:35:00',1.96),('8537','2013-03-05','09:40:00',2.08),('8537','2013-03-05','09:45:00',2.1),('8537','2013-03-05','09:50:00',2.13),('8537','2013-03-05','09:55:00',2),('8537','2013-03-05','10:00:00',1.92),('8537','2013-03-05','10:05:00',2.15),('8537','2013-03-05','10:10:00',2.25),('8537','2013-03-05','10:15:00',2.26),('8537','2013-03-05','10:20:00',2.54),('8537','2013-03-05','10:25:00',2.36),('8537','2013-03-05','10:30:00',2.27),('8537','2013-03-05','10:35:00',2.75),('8537','2013-03-05','10:40:00',2.84),('8537','2013-03-05','10:45:00',2.95),('8537','2013-03-05','10:50:00',3.16),('8537','2013-03-05','10:55:00',3.24),('8537','2013-03-05','11:00:00',3.06),('8537','2013-03-05','11:05:00',3.24),('8537','2013-03-05','11:10:00',3.37),('8537','2013-03-05','11:15:00',3.29),('8537','2013-03-05','11:20:00',3.18),('8537','2013-03-05','11:25:00',3.04),('8537','2013-03-05','11:30:00',3.07),('8537','2013-03-05','11:35:00',3.42),('8537','2013-03-05','11:40:00',3.76),('8537','2013-03-05','11:45:00',3.63),('8537','2013-03-05','11:50:00',3.7),('8537','2013-03-05','11:55:00',3.77),('8537','2013-03-05','12:00:00',3.88),('8537','2013-03-05','12:05:00',4.05),('8537','2013-03-05','12:10:00',4.19),('8537','2013-03-05','12:15:00',3.38),('8537','2013-03-05','12:20:00',3.82),('8537','2013-03-05','12:25:00',3.87),('8537','2013-03-05','12:30:00',3.24),('8537','2013-03-05','12:35:00',3.26),('8537','2013-03-05','12:40:00',3.07),('8537','2013-03-05','12:45:00',3.21),('8537','2013-03-05','12:50:00',2.78),('8537','2013-03-05','12:55:00',2.5),('8537','2013-03-05','13:00:00',2.03),('8537','2013-03-05','13:05:00',1.92),('8537','2013-03-05','13:10:00',2.05),('8537','2013-03-05','13:15:00',2.19),('8537','2013-03-05','13:20:00',2.11),('8537','2013-03-05','13:25:00',1.88),('8537','2013-03-05','13:30:00',1.72),('8537','2013-03-05','13:35:00',1.61),('8537','2013-03-05','13:40:00',1.53),('8537','2013-03-05','13:45:00',1.38),('8537','2013-03-05','13:50:00',1.26),('8537','2013-03-05','13:55:00',1.18),('8537','2013-03-05','14:00:00',1.17),('8537','2013-03-05','14:05:00',1.19),('8537','2013-03-05','14:10:00',1.25),('8537','2013-03-05','14:15:00',1.17),('8537','2013-03-05','14:20:00',1.1),('8537','2013-03-05','14:25:00',1.11),('8537','2013-03-05','14:30:00',1.06),('8537','2013-03-05','14:35:00',1.09),('8537','2013-03-05','14:40:00',1.13),('8537','2013-03-05','14:45:00',1.16),('8537','2013-03-05','14:50:00',1.13),('8537','2013-03-05','14:55:00',1.02),('8537','2013-03-05','15:40:00',1.04),('8537','2013-03-05','15:45:00',1.29),('8537','2013-03-05','15:50:00',1.29),('8537','2013-03-05','15:55:00',1.08),('8537','2013-03-04','07:45:00',1.1),('8537','2013-03-04','07:50:00',1.21),('8537','2013-03-04','07:55:00',1.33),('8537','2013-03-04','08:00:00',1.45),('8537','2013-03-04','08:05:00',1.57),('8537','2013-03-04','08:10:00',1.68),('8537','2013-03-04','08:15:00',1.8),('8537','2013-03-04','08:20:00',1.91),('8537','2013-03-04','08:25:00',2.03),('8537','2013-03-04','08:30:00',2.14),('8537','2013-03-04','08:35:00',2.24),('8537','2013-03-04','08:40:00',2.36),('8537','2013-03-04','08:45:00',2.45),('8537','2013-03-04','08:50:00',2.56),('8537','2013-03-04','08:55:00',2.67),('8537','2013-03-04','09:00:00',2.75),('8537','2013-03-04','09:05:00',2.84),('8537','2013-03-04','09:10:00',2.93),('8537','2013-03-04','09:15:00',3.02),('8537','2013-03-04','09:20:00',3.14),('8537','2013-03-04','09:25:00',3.22),('8537','2013-03-04','09:30:00',3.3),('8537','2013-03-04','09:35:00',3.4),('8537','2013-03-04','09:40:00',3.48),('8537','2013-03-04','09:45:00',3.55),('8537','2013-03-04','09:50:00',3.62),('8537','2013-03-04','09:55:00',3.7),('8537','2013-03-04','10:00:00',3.77),('8537','2013-03-04','10:05:00',3.82),('8537','2013-03-04','10:10:00',3.93),('8537','2013-03-04','10:15:00',3.98),('8537','2013-03-04','10:20:00',4),('8537','2013-03-04','10:25:00',4.07),('8537','2013-03-04','10:30:00',4.13),('8537','2013-03-04','10:35:00',4.19),('8537','2013-03-04','10:40:00',4.22),('8537','2013-03-04','10:45:00',4.25),('8537','2013-03-04','10:50:00',4.31),('8537','2013-03-04','10:55:00',4.36),('8537','2013-03-04','11:00:00',4.33),('8537','2013-03-04','11:05:00',4.38),('8537','2013-03-04','11:10:00',4.43),('8537','2013-03-04','11:15:00',4.51),('8537','2013-03-04','11:20:00',4.51),('8537','2013-03-04','11:25:00',4.52),('8537','2013-03-04','11:30:00',4.53),('8537','2013-03-04','11:35:00',4.57),('8537','2013-03-04','11:40:00',4.6),('8537','2013-03-04','11:45:00',4.59),('8537','2013-03-04','11:50:00',4.56),('8537','2013-03-04','11:55:00',4.57),('8537','2013-03-04','12:00:00',4.52),('8537','2013-03-04','12:05:00',4.49),('8537','2013-03-04','12:10:00',4.55),('8537','2013-03-04','12:15:00',4.6),('8537','2013-03-04','12:20:00',4.66),('8537','2013-03-04','12:25:00',4.64),('8537','2013-03-04','12:30:00',4.54),('8537','2013-03-04','12:35:00',4.55),('8537','2013-03-04','12:40:00',4.58),('8537','2013-03-04','12:45:00',4.52),('8537','2013-03-04','12:50:00',4.5),('8537','2013-03-04','12:55:00',4.47),('8537','2013-03-04','13:00:00',4.37),('8537','2013-03-04','13:05:00',4.36),('8537','2013-03-04','13:10:00',4.31),('8537','2013-03-04','13:15:00',4.34),('8537','2013-03-04','13:20:00',4.35),('8537','2013-03-04','13:25:00',4.29),('8537','2013-03-04','13:30:00',2.69),('8537','2013-03-04','13:35:00',3.43),('8537','2013-03-04','13:40:00',4.1),('8537','2013-03-04','13:45:00',3.68),('8537','2013-03-04','13:50:00',4.13),('8537','2013-03-04','13:55:00',4.05),('8537','2013-03-04','14:00:00',3.98),('8537','2013-03-04','14:05:00',4),('8537','2013-03-04','14:10:00',3.65),('8537','2013-03-04','14:15:00',3.4),('8537','2013-03-04','14:20:00',3.62),('8537','2013-03-04','14:25:00',3.42),('8537','2013-03-04','14:30:00',3.43),('8537','2013-03-04','14:35:00',3.46),('8537','2013-03-04','14:40:00',3.39),('8537','2013-03-04','14:45:00',3.33),('8537','2013-03-04','14:50:00',3.23),('8537','2013-03-04','14:55:00',3.21),('8537','2013-03-04','15:00:00',2.97),('8537','2013-03-04','15:05:00',2.95),('8537','2013-03-04','15:10:00',2.88),('8537','2013-03-04','15:15:00',2.75),('8537','2013-03-04','15:20:00',2.67),('8537','2013-03-04','15:25:00',2.56),('8537','2013-03-04','15:30:00',2.53),('8537','2013-03-04','15:35:00',2.4),('8537','2013-03-04','15:40:00',2.29),('8537','2013-03-04','15:45:00',2.13),('8537','2013-03-04','15:50:00',2.01),('8537','2013-03-04','15:55:00',1.97),('8537','2013-03-04','16:00:00',1.9),('8537','2013-03-04','16:05:00',1.8),('8537','2013-03-04','16:10:00',1.62),('8537','2013-03-04','16:15:00',1.43),('8537','2013-03-04','16:20:00',1.44),('8537','2013-03-04','16:25:00',1.36),('8537','2013-03-04','16:30:00',1.27),('8537','2013-03-04','16:35:00',1.14),('8537','2013-03-04','16:40:00',1.02),('8537','2013-03-03','07:40:00',1.03),('8537','2013-03-03','07:45:00',1.15),('8537','2013-03-03','07:50:00',1.27),('8537','2013-03-03','07:55:00',1.4),('8537','2013-03-03','08:00:00',1.52),('8537','2013-03-03','08:05:00',1.65),('8537','2013-03-03','08:10:00',1.78),('8537','2013-03-03','08:15:00',1.9),('8537','2013-03-03','08:20:00',2.03),('8537','2013-03-03','08:25:00',2.16),('8537','2013-03-03','08:30:00',2.28),('8537','2013-03-03','08:35:00',2.4),('8537','2013-03-03','08:40:00',2.53),('8537','2013-03-03','08:45:00',2.64),('8537','2013-03-03','08:50:00',2.74),('8537','2013-03-03','08:55:00',2.84),('8537','2013-03-03','09:00:00',2.93),('8537','2013-03-03','09:05:00',3.02),('8537','2013-03-03','09:10:00',3.11),('8537','2013-03-03','09:15:00',3.2),('8537','2013-03-03','09:20:00',3.29),('8537','2013-03-03','09:25:00',3.38),('8537','2013-03-03','09:30:00',3.48),('8537','2013-03-03','09:35:00',3.58),('8537','2013-03-03','09:40:00',3.65),('8537','2013-03-03','09:45:00',3.76),('8537','2013-03-03','09:50:00',3.82),('8537','2013-03-03','09:55:00',3.97),('8537','2013-03-03','10:00:00',4.04),('8537','2013-03-03','10:05:00',4.09),('8537','2013-03-03','10:10:00',4.16),('8537','2013-03-03','10:15:00',4.25),('8537','2013-03-03','10:20:00',4.32),('8537','2013-03-03','10:25:00',4.37),('8537','2013-03-03','10:30:00',4.41),('8537','2013-03-03','10:35:00',4.47),('8537','2013-03-03','10:40:00',4.49),('8537','2013-03-03','10:45:00',4.54),('8537','2013-03-03','10:50:00',4.58),('8537','2013-03-03','10:55:00',4.61),('8537','2013-03-03','11:00:00',4.6),('8537','2013-03-03','11:05:00',4.6),('8537','2013-03-03','11:10:00',4.6),('8537','2013-03-03','11:15:00',4.63),('8537','2013-03-03','11:20:00',4.67),('8537','2013-03-03','11:25:00',4.69),('8537','2013-03-03','11:30:00',4.72),('8537','2013-03-03','11:35:00',4.71),('8537','2013-03-03','11:40:00',4.75),('8537','2013-03-03','11:45:00',4.75),('8537','2013-03-03','11:50:00',4.79),('8537','2013-03-03','11:55:00',4.78),('8537','2013-03-03','12:00:00',4.8),('8537','2013-03-03','12:05:00',4.82),('8537','2013-03-03','12:10:00',4.8),('8537','2013-03-03','12:15:00',4.76),('8537','2013-03-03','12:20:00',4.76),('8537','2013-03-03','12:25:00',4.77),('8537','2013-03-03','12:30:00',4.77),('8537','2013-03-03','12:35:00',4.79),('8537','2013-03-03','12:40:00',4.76),('8537','2013-03-03','12:45:00',4.74),('8537','2013-03-03','12:50:00',4.72),('8537','2013-03-03','12:55:00',4.68),('8537','2013-03-03','13:00:00',4.64),('8537','2013-03-03','13:05:00',4.63),('8537','2013-03-03','13:10:00',4.62),('8537','2013-03-03','13:15:00',4.6),('8537','2013-03-03','13:20:00',4.6),('8537','2013-03-03','13:25:00',4.57),('8537','2013-03-03','13:30:00',4.54),('8537','2013-03-03','13:35:00',4.49),('8537','2013-03-03','13:40:00',4.44),('8537','2013-03-03','13:45:00',4.39),('8537','2013-03-03','13:50:00',4.29),('8537','2013-03-03','13:55:00',4.28),('8537','2013-03-03','14:00:00',4.2),('8537','2013-03-03','14:05:00',4.15),('8537','2013-03-03','14:10:00',4.06),('8537','2013-03-03','14:15:00',4.03),('8537','2013-03-03','14:20:00',3.98),('8537','2013-03-03','14:25:00',3.9),('8537','2013-03-03','14:30:00',3.81),('8537','2013-03-03','14:35:00',3.76),('8537','2013-03-03','14:40:00',3.7),('8537','2013-03-03','14:45:00',3.62),('8537','2013-03-03','14:50:00',3.53),('8537','2013-03-03','14:55:00',3.4),('8537','2013-03-03','15:00:00',3.22),('8537','2013-03-03','15:05:00',2.91),('8537','2013-03-03','15:10:00',3.09),('8537','2013-03-03','15:15:00',3.07),('8537','2013-03-03','15:20:00',2.99),('8537','2013-03-03','15:25:00',2.89),('8537','2013-03-03','15:30:00',2.81),('8537','2013-03-03','15:35:00',2.67),('8537','2013-03-03','15:40:00',2.56),('8537','2013-03-03','15:45:00',2.39),('8537','2013-03-03','15:50:00',2.31),('8537','2013-03-03','15:55:00',2.21),('8537','2013-03-03','16:00:00',2.11),('8537','2013-03-03','16:05:00',1.99),('8537','2013-03-03','16:10:00',1.86),('8537','2013-03-03','16:15:00',1.71),('8537','2013-03-03','16:20:00',1.6),('8537','2013-03-03','16:25:00',1.48),('8537','2013-03-03','16:30:00',1.35),('8537','2013-03-03','16:35:00',1.21),('8537','2013-03-03','16:40:00',1.1),('8537','2014-03-24','07:45:00',1.46),('8537','2014-03-24','07:50:00',1.02),('8537','2014-03-24','08:40:00',1.06),('8537','2014-03-24','08:55:00',1.85),('8537','2014-03-24','09:00:00',2.22),('8537','2014-03-24','09:05:00',1.69),('8537','2014-03-24','09:20:00',2.33),('8537','2014-03-24','09:25:00',1.01),('8537','2014-03-24','09:30:00',1.74),('8537','2014-03-24','09:35:00',1.03),('8537','2014-03-24','09:40:00',1.72),('8537','2014-03-24','09:45:00',1.39),('8537','2014-03-24','09:50:00',1.23),('8537','2014-03-24','10:00:00',2.41),('8537','2014-03-24','10:05:00',2.96),('8537','2014-03-24','10:10:00',4.19),('8537','2014-03-24','10:15:00',3.52),('8537','2014-03-24','10:20:00',1.1),('8537','2014-03-24','10:35:00',1.61),('8537','2014-03-24','10:40:00',1.32),('8537','2014-03-24','10:45:00',1.93),('8537','2014-03-24','10:50:00',5.77),('8537','2014-03-24','10:55:00',4.93),('8537','2014-03-24','11:00:00',1.9),('8537','2014-03-24','11:05:00',3.45),('8537','2014-03-24','11:10:00',2.79),('8537','2014-03-24','11:15:00',3.67),('8537','2014-03-24','11:20:00',2.95),('8537','2014-03-24','11:25:00',3.56),('8537','2014-03-24','11:30:00',4.16),('8537','2014-03-24','11:35:00',1.99),('8537','2014-03-24','12:30:00',1.26),('8537','2014-03-24','12:35:00',2.17),('8537','2014-03-24','12:40:00',2.35),('8537','2014-03-24','12:45:00',2.07),('8537','2014-03-24','12:50:00',1.72),('8537','2014-03-24','12:55:00',1.61),('8537','2014-03-24','13:00:00',1.64),('8537','2014-03-24','13:05:00',1.63),('8537','2014-03-24','13:10:00',1.45),('8537','2014-03-24','13:15:00',1.18),('8537','2014-03-24','13:20:00',1.15),('8537','2014-03-24','13:25:00',1.41),('8537','2014-03-24','13:30:00',1.64),('8537','2014-03-24','13:35:00',1.44),('8537','2014-03-24','13:45:00',1.07),('8537','2014-03-24','13:50:00',1.56),('8537','2014-03-24','13:55:00',1.52),('8537','2014-03-24','14:00:00',1.38),('8537','2014-03-24','14:05:00',1.23),('8537','2014-03-24','14:10:00',1.44),('8537','2014-03-24','14:15:00',1.87),('8537','2014-03-24','14:20:00',2.43),('8537','2014-03-24','14:25:00',2.36),('8537','2014-03-24','14:30:00',2.08),('8537','2014-03-24','14:35:00',2.58),('8537','2014-03-24','14:40:00',3.4),('8537','2014-03-24','14:45:00',3.92),('8537','2014-03-24','14:50:00',4.05),('8537','2014-03-24','14:55:00',3.54),('8537','2014-03-24','15:00:00',3.1),('8537','2014-03-24','15:05:00',2.76),('8537','2014-03-24','15:10:00',2.44),('8537','2014-03-24','15:15:00',1.6),('8537','2014-03-24','15:20:00',1.85),('8537','2014-03-24','15:25:00',1.56),('8537','2014-03-24','15:30:00',1.9),('8537','2014-03-24','15:35:00',1.63),('8537','2014-03-24','15:40:00',1.44),('8537','2014-03-24','15:45:00',1.31),('8537','2014-03-24','15:50:00',1.48),('8537','2014-03-24','15:55:00',1.42),('8537','2014-03-24','16:00:00',2.37),('8537','2014-03-24','16:05:00',1.49),('8537','2014-03-24','16:10:00',1.3),('8537','2014-03-24','16:15:00',1.01),('8537','2013-03-02','10:40:00',1.08),('8537','2013-03-02','10:45:00',1.08),('8537','2013-03-02','10:50:00',1.2),('8537','2013-03-02','10:55:00',1.26),('8537','2013-03-02','11:00:00',1.34),('8537','2013-03-02','11:05:00',1.35),('8537','2013-03-02','11:10:00',1.46),('8537','2013-03-02','11:15:00',1.64),('8537','2013-03-02','11:20:00',1.47),('8537','2013-03-02','11:25:00',1.27),('8537','2013-03-02','11:30:00',1.19),('8537','2013-03-02','11:35:00',1.24),('8537','2013-03-02','11:40:00',1.39),('8537','2013-03-02','11:45:00',1.26),('8537','2013-03-02','11:50:00',1.24),('8537','2013-03-02','11:55:00',1.18),('8537','2013-03-02','12:00:00',1.17),('8537','2013-03-02','12:05:00',1.35),('8537','2013-03-02','12:10:00',1.36),('8537','2013-03-02','12:15:00',1.38),('8537','2013-03-02','12:20:00',1.28),('8537','2013-03-02','12:25:00',1.38),('8537','2013-03-02','12:30:00',1.43),('8537','2013-03-02','12:35:00',1.6),('8537','2013-03-02','12:40:00',1.8),('8537','2013-03-02','12:45:00',1.59),('8537','2013-03-02','12:50:00',1.5),('8537','2013-03-02','12:55:00',1.74),('8537','2013-03-02','13:00:00',1.69),('8537','2013-03-02','13:05:00',1.48),('8537','2013-03-02','13:10:00',1.23),('8537','2013-03-02','13:15:00',1.07),('8537','2013-03-02','13:20:00',1.02),('8537','2013-03-02','13:30:00',1.08),('8537','2013-03-02','13:35:00',1.08),('8537','2013-03-02','13:40:00',1.17),('8537','2013-03-02','13:45:00',1.3),('8537','2013-03-02','13:50:00',1.26),('8537','2013-03-02','13:55:00',1.34),('8537','2013-03-02','14:00:00',1.53),('8537','2013-03-02','14:05:00',1.53),('8537','2013-03-02','14:10:00',1.3),('8537','2013-03-02','14:15:00',1.15),('8537','2013-03-02','14:20:00',1.1),('8537','2013-03-01','07:55:00',1.1),('8537','2013-03-01','08:00:00',1.23),('8537','2013-03-01','08:05:00',1.29),('8537','2013-03-01','08:10:00',1.28),('8537','2013-03-01','08:15:00',1.36),('8537','2013-03-01','08:20:00',1.44),('8537','2013-03-01','08:25:00',1.45),('8537','2013-03-01','08:30:00',1.56),('8537','2013-03-01','08:35:00',1.67),('8537','2013-03-01','08:40:00',1.8),('8537','2013-03-01','08:45:00',1.91),('8537','2013-03-01','08:50:00',2),('8537','2013-03-01','08:55:00',2.16),('8537','2013-03-01','09:00:00',2.3),('8537','2013-03-01','09:05:00',2.54),('8537','2013-03-01','09:10:00',2.53),('8537','2013-03-01','09:15:00',2.56),('8537','2013-03-01','09:20:00',2.64),('8537','2013-03-01','09:25:00',2.62),('8537','2013-03-01','09:30:00',2.92),('8537','2013-03-01','09:35:00',2.82),('8537','2013-03-01','09:40:00',3.01),('8537','2013-03-01','09:45:00',3.2),('8537','2013-03-01','09:50:00',3.21),('8537','2013-03-01','09:55:00',3.14),('8537','2013-03-01','10:00:00',3.26),('8537','2013-03-01','10:05:00',3.27),('8537','2013-03-01','10:10:00',3.22),('8537','2013-03-01','10:15:00',2.73),('8537','2013-03-01','10:20:00',2.62),('8537','2013-03-01','10:25:00',2.78),('8537','2013-03-01','10:30:00',3.1),('8537','2013-03-01','10:35:00',3.35),('8537','2013-03-01','10:40:00',2.97),('8537','2013-03-01','10:45:00',2.8),('8537','2013-03-01','10:50:00',2.64),('8537','2013-03-01','10:55:00',2.47),('8537','2013-03-01','11:00:00',2.13),('8537','2013-03-01','11:05:00',1.84),('8537','2013-03-01','11:10:00',1.77),('8537','2013-03-01','11:15:00',1.98),('8537','2013-03-01','11:20:00',2.09),('8537','2013-03-01','11:25:00',2.08),('8537','2013-03-01','11:30:00',2.11),('8537','2013-03-01','11:35:00',2.14),('8537','2013-03-01','11:40:00',2.02),('8537','2013-03-01','11:45:00',1.92),('8537','2013-03-01','11:50:00',1.9),('8537','2013-03-01','11:55:00',1.8),('8537','2013-03-01','12:00:00',1.72),('8537','2013-03-01','12:05:00',1.64),('8537','2013-03-01','12:10:00',1.52),('8537','2013-03-01','12:15:00',1.38),('8537','2013-03-01','12:20:00',1.29),('8537','2013-03-01','12:25:00',1.28),('8537','2013-03-01','12:30:00',1.32),('8537','2013-03-01','12:35:00',1.31),('8537','2013-03-01','12:40:00',1.26),('8537','2013-03-01','12:45:00',1.27),('8537','2013-03-01','12:50:00',1.29),('8537','2013-03-01','12:55:00',1.37),('8537','2013-03-01','13:00:00',1.45),('8537','2013-03-01','13:05:00',1.47),('8537','2013-03-01','13:10:00',1.52),('8537','2013-03-01','13:15:00',1.64),('8537','2013-03-01','13:20:00',1.77),('8537','2013-03-01','13:25:00',1.95),('8537','2013-03-01','13:30:00',1.9),('8537','2013-03-01','13:35:00',1.76),('8537','2013-03-01','13:40:00',1.68),('8537','2013-03-01','13:45:00',1.66),('8537','2013-03-01','13:50:00',1.65),('8537','2013-03-01','13:55:00',1.58),('8537','2013-03-01','14:00:00',1.53),('8537','2013-03-01','14:05:00',1.46),('8537','2013-03-01','14:10:00',1.37),('8537','2013-03-01','14:15:00',1.29),('8537','2013-03-01','14:20:00',1.25),('8537','2013-03-01','14:25:00',1.24),('8537','2013-03-01','14:30:00',1.29),('8537','2013-03-01','14:35:00',1.3),('8537','2013-03-01','14:40:00',1.23),('8537','2013-03-01','14:45:00',1.15),('8537','2013-03-01','14:50:00',1.09),('8537','2013-03-01','14:55:00',1.08),('8537','2013-03-01','15:00:00',1.09),('8537','2013-03-01','15:05:00',1.05),('8537','2013-02-28','07:50:00',1.01),('8537','2013-02-28','07:55:00',1.12),('8537','2013-02-28','08:00:00',1.23),('8537','2013-02-28','08:05:00',1.32),('8537','2013-02-28','08:10:00',1.43),('8537','2013-02-28','08:15:00',1.54),('8537','2013-02-28','08:20:00',1.66),('8537','2013-02-28','08:25:00',1.75),('8537','2013-02-28','08:30:00',1.87),('8537','2013-02-28','08:35:00',1.98),('8537','2013-02-28','08:40:00',2.1),('8537','2013-02-28','08:45:00',2.23),('8537','2013-02-28','08:50:00',2.37),('8537','2013-02-28','08:55:00',2.48),('8537','2013-02-28','09:00:00',2.59),('8537','2013-02-28','09:05:00',2.66),('8537','2013-02-28','09:10:00',2.72),('8537','2013-02-28','09:15:00',2.79),('8537','2013-02-28','09:20:00',2.92),('8537','2013-02-28','09:25:00',3),('8537','2013-02-28','09:30:00',3.09),('8537','2013-02-28','09:35:00',3.17),('8537','2013-02-28','09:40:00',3.24),('8537','2013-02-28','09:45:00',3.34),('8537','2013-02-28','09:50:00',3.17),('8537','2013-02-28','09:55:00',3.43),('8537','2013-02-28','10:00:00',3.56),('8537','2013-02-28','10:05:00',3.65),('8537','2013-02-28','10:10:00',3.68),('8537','2013-02-28','10:15:00',3.74),('8537','2013-02-28','10:20:00',3.77),('8537','2013-02-28','10:25:00',3.79),('8537','2013-02-28','10:30:00',3.82),('8537','2013-02-28','10:35:00',3.93),('8537','2013-02-28','10:40:00',3.99),('8537','2013-02-28','10:45:00',4.03),('8537','2013-02-28','10:50:00',4.03),('8537','2013-02-28','10:55:00',4.06),('8537','2013-02-28','11:00:00',4.16),('8537','2013-02-28','11:05:00',4.22),('8537','2013-02-28','11:10:00',4.24),('8537','2013-02-28','11:15:00',4.25),('8537','2013-02-28','11:20:00',4.35),('8537','2013-02-28','11:25:00',4.4),('8537','2013-02-28','11:30:00',4.41),('8537','2013-02-28','11:35:00',4.42),('8537','2013-02-28','11:40:00',4.41),('8537','2013-02-28','11:45:00',4.47),('8537','2013-02-28','11:50:00',4.49),('8537','2013-02-28','11:55:00',4.47),('8537','2013-02-28','12:00:00',4.2),('8537','2013-02-28','12:05:00',4.31),('8537','2013-02-28','12:10:00',4.51),('8537','2013-02-28','12:15:00',4.54),('8537','2013-02-28','12:20:00',4.51),('8537','2013-02-28','12:25:00',4.42),('8537','2013-02-28','12:30:00',4.44),('8537','2013-02-28','12:35:00',4.47),('8537','2013-02-28','12:40:00',4.44),('8537','2013-02-28','12:45:00',4.41),('8537','2013-02-28','12:50:00',4.36),('8537','2013-02-28','12:55:00',4.35),('8537','2013-02-28','13:00:00',4.26),('8537','2013-02-28','13:05:00',4.36),('8537','2013-02-28','13:10:00',4.33),('8537','2013-02-28','13:15:00',4.34),('8537','2013-02-28','13:20:00',4.31),('8537','2013-02-28','13:25:00',4.13),('8537','2013-02-28','13:30:00',3.67),('8537','2013-02-28','13:35:00',4.13),('8537','2013-02-28','13:40:00',4.14),('8537','2013-02-28','13:45:00',4.16),('8537','2013-02-28','13:50:00',4.22),('8537','2013-02-28','13:55:00',4.25),('8537','2013-02-28','14:00:00',4.26),('8537','2013-02-28','14:05:00',4.14),('8537','2013-02-28','14:10:00',3.95),('8537','2013-02-28','14:15:00',3.8),('8537','2013-02-28','14:20:00',3.3),('8537','2013-02-28','14:25:00',3.05),('8537','2013-02-28','14:30:00',3.35),('8537','2013-02-28','14:35:00',3.2),('8537','2013-02-28','14:40:00',3.29),('8537','2013-02-28','14:45:00',3.24),('8537','2013-02-28','14:50:00',3.18),('8537','2013-02-28','14:55:00',3.08),('8537','2013-02-28','15:00:00',2.98),('8537','2013-02-28','15:05:00',2.75),('8537','2013-02-28','15:10:00',2.51),('8537','2013-02-28','15:15:00',2.65),('8537','2013-02-28','15:20:00',2.59),('8537','2013-02-28','15:25:00',2.4),('8537','2013-02-28','15:30:00',2.27),('8537','2013-02-28','15:35:00',2.19),('8537','2013-02-28','15:40:00',2.1),('8537','2013-02-28','15:45:00',1.97),('8537','2013-02-28','15:50:00',1.95),('8537','2013-02-28','15:55:00',1.83),('8537','2013-02-28','16:00:00',1.73),('8537','2013-02-28','16:05:00',1.62),('8537','2013-02-28','16:10:00',1.5),('8537','2013-02-28','16:15:00',1.38),('8537','2013-02-28','16:20:00',1.23),('8537','2013-02-28','16:25:00',1.14),('8537','2013-02-28','16:30:00',1.01),('8537','2013-02-27','07:55:00',1.07),('8537','2013-02-27','08:00:00',1.19),('8537','2013-02-27','08:05:00',1.31),('8537','2013-02-27','08:10:00',1.41),('8537','2013-02-27','08:15:00',1.51),('8537','2013-02-27','08:20:00',1.63),('8537','2013-02-27','08:25:00',1.74),('8537','2013-02-27','08:30:00',1.86),('8537','2013-02-27','08:35:00',1.97),('8537','2013-02-27','08:40:00',2.03),('8537','2013-02-27','08:45:00',2.15),('8537','2013-02-27','08:50:00',2.26),('8537','2013-02-27','08:55:00',2.36),('8537','2013-02-27','09:00:00',2.48),('8537','2013-02-27','09:05:00',2.6),('8537','2013-02-27','09:10:00',2.7),('8537','2013-02-27','09:15:00',2.79),('8537','2013-02-27','09:20:00',2.86),('8537','2013-02-27','09:25:00',2.96),('8537','2013-02-27','09:30:00',3.05),('8537','2013-02-27','09:35:00',3.14),('8537','2013-02-27','09:40:00',3.2),('8537','2013-02-27','09:45:00',3.29),('8537','2013-02-27','09:50:00',3.35),('8537','2013-02-27','09:55:00',3.42),('8537','2013-02-27','10:00:00',3.48),('8537','2013-02-27','10:05:00',3.58),('8537','2013-02-27','10:10:00',3.62),('8537','2013-02-27','10:15:00',3.66),('8537','2013-02-27','10:20:00',3.75),('8537','2013-02-27','10:25:00',3.82),('8537','2013-02-27','10:30:00',3.83),('8537','2013-02-27','10:35:00',3.91),('8537','2013-02-27','10:40:00',4.03),('8537','2013-02-27','10:45:00',4.06),('8537','2013-02-27','10:50:00',4.08),('8537','2013-02-27','10:55:00',4.19),('8537','2013-02-27','11:00:00',4.2),('8537','2013-02-27','11:05:00',4.12),('8537','2013-02-27','11:10:00',4.13),('8537','2013-02-27','11:15:00',4.13),('8537','2013-02-27','11:20:00',4.17),('8537','2013-02-27','11:25:00',4.4),('8537','2013-02-27','11:30:00',4.26),('8537','2013-02-27','11:35:00',2.72),('8537','2013-02-27','11:40:00',2.63),('8537','2013-02-27','11:45:00',1.69),('8537','2013-02-27','11:50:00',2.65),('8537','2013-02-27','11:55:00',3.79),('8537','2013-02-27','12:00:00',4.67),('8537','2013-02-27','12:05:00',4.63),('8537','2013-02-27','12:10:00',4.58),('8537','2013-02-27','12:15:00',3.73),('8537','2013-02-27','12:20:00',4.8),('8537','2013-02-27','12:25:00',4.64),('8537','2013-02-27','12:30:00',4.49),('8537','2013-02-27','12:35:00',4.52),('8537','2013-02-27','12:40:00',4.57),('8537','2013-02-27','12:45:00',4.49),('8537','2013-02-27','12:50:00',4.46),('8537','2013-02-27','12:55:00',4.39),('8537','2013-02-27','13:00:00',4.4),('8537','2013-02-27','13:05:00',4.53),('8537','2013-02-27','13:10:00',4.31),('8537','2013-02-27','13:15:00',3.99),('8537','2013-02-27','13:20:00',2.08),('8537','2013-02-27','13:25:00',3.21),('8537','2013-02-27','13:30:00',4.03),('8537','2013-02-27','13:35:00',4.44),('8537','2013-02-27','13:40:00',4.42),('8537','2013-02-27','13:45:00',4.26),('8537','2013-02-27','13:50:00',4.09),('8537','2013-02-27','13:55:00',2.55),('8537','2013-02-27','14:00:00',3.79),('8537','2013-02-27','14:05:00',2.13),('8537','2013-02-27','14:10:00',3.77),('8537','2013-02-27','14:15:00',2.3),('8537','2013-02-27','14:20:00',3.39),('8537','2013-02-27','14:25:00',2.82),('8537','2013-02-27','14:30:00',2.18),('8537','2013-02-27','14:35:00',3.58),('8537','2013-02-27','14:40:00',3.51),('8537','2013-02-27','14:45:00',3.49),('8537','2013-02-27','14:50:00',3.17),('8537','2013-02-27','14:55:00',3.02),('8537','2013-02-27','15:00:00',3.14),('8537','2013-02-27','15:05:00',3.04),('8537','2013-02-27','15:10:00',2.71),('8537','2013-02-27','15:15:00',2.44),('8537','2013-02-27','15:20:00',2.27),('8537','2013-02-27','15:25:00',2.6),('8537','2013-02-27','15:30:00',2.55),('8537','2013-02-27','15:35:00',2.42),('8537','2013-02-27','15:40:00',2.28),('8537','2013-02-27','15:45:00',2.16),('8537','2013-02-27','15:50:00',2.06),('8537','2013-02-27','15:55:00',1.99),('8537','2013-02-27','16:00:00',1.86),('8537','2013-02-27','16:05:00',1.78),('8537','2013-02-27','16:10:00',1.63),('8537','2013-02-27','16:15:00',1.48),('8537','2013-02-27','16:20:00',1.35),('8537','2013-02-27','16:25:00',1.23),('8537','2013-02-27','16:30:00',1.09),('8537','2013-02-27','16:35:00',1.03),('8537','2013-02-26','09:10:00',1.03),('8537','2013-02-26','09:15:00',1.11),('8537','2013-02-26','09:20:00',1.19),('8537','2013-02-26','09:25:00',1.31),('8537','2013-02-26','09:30:00',1.6),('8537','2013-02-26','09:35:00',2),('8537','2013-02-26','09:40:00',2.24),('8537','2013-02-26','09:45:00',2.24),('8537','2013-02-26','09:50:00',2.31),('8537','2013-02-26','09:55:00',2.57),('8537','2013-02-26','10:00:00',2.44),('8537','2013-02-26','10:05:00',2.46),('8537','2013-02-26','10:10:00',2.8),('8537','2013-02-26','10:15:00',3.35),('8537','2013-02-26','10:20:00',3.95),('8537','2013-02-26','10:25:00',4.31),('8537','2013-02-26','10:30:00',4.2),('8537','2013-02-26','10:35:00',4.22),('8537','2013-02-26','10:40:00',2.4),('8537','2013-02-26','10:45:00',1.76),('8537','2013-02-26','10:50:00',2.01),('8537','2013-02-26','10:55:00',2.08),('8537','2013-02-26','11:00:00',2.65),('8537','2013-02-26','11:05:00',2.37),('8537','2013-02-26','11:10:00',2.29),('8537','2013-02-26','11:15:00',2.07),('8537','2013-02-26','11:20:00',2.03),('8537','2013-02-26','11:25:00',1.88),('8537','2013-02-26','11:30:00',1.82),('8537','2013-02-26','11:35:00',1.76),('8537','2013-02-26','11:40:00',1.88),('8537','2013-02-26','11:45:00',1.86),('8537','2013-02-26','11:50:00',2.04),('8537','2013-02-26','11:55:00',2.09),('8537','2013-02-26','12:00:00',1.98),('8537','2013-02-26','12:05:00',1.92),('8537','2013-02-26','12:10:00',1.95),('8537','2013-02-26','12:15:00',1.71),('8537','2013-02-26','12:20:00',1.71),('8537','2013-02-26','12:25:00',1.54),('8537','2013-02-26','12:30:00',1.53),('8537','2013-02-26','12:35:00',1.4),('8537','2013-02-26','12:40:00',1.26),('8537','2013-02-26','12:45:00',1.15),('8537','2013-02-26','12:50:00',1.07),('8537','2013-02-26','12:55:00',1.15),('8537','2013-02-26','13:00:00',1.15),('8537','2013-02-26','13:05:00',1),('8537','2013-02-26','13:15:00',1.01),('8537','2013-02-26','13:20:00',1.09),('8537','2013-02-26','13:25:00',1.13),('8537','2013-02-26','13:30:00',1.19),('8537','2013-02-26','13:35:00',1.19),('8537','2013-02-26','13:40:00',1.17),('8537','2013-02-26','13:45:00',1.03),('8537','2013-02-25','08:40:00',1.46),('8537','2013-02-25','08:45:00',1.3),('8537','2013-02-25','08:50:00',1.47),('8537','2013-02-25','08:55:00',1.13),('8537','2013-02-25','09:00:00',1.55),('8537','2013-02-25','09:10:00',1.02),('8537','2013-02-25','09:15:00',1.03),('8537','2013-02-25','09:20:00',1.16),('8537','2013-02-25','09:25:00',1.58),('8537','2013-02-25','09:30:00',1.72),('8537','2013-02-25','09:35:00',1.72),('8537','2013-02-25','09:40:00',1.3),('8537','2013-02-25','10:45:00',2.06),('8537','2013-02-25','10:50:00',3.68),('8537','2013-02-25','10:55:00',5.14),('8537','2013-02-25','11:00:00',5.31),('8537','2013-02-25','11:05:00',2.97),('8537','2013-02-25','11:10:00',2.32),('8537','2013-02-25','11:15:00',2.22),('8537','2013-02-25','11:20:00',1.31),('8537','2013-02-25','11:25:00',1.24),('8537','2013-02-25','11:30:00',1.91),('8537','2013-02-25','11:35:00',1.46),('8537','2013-02-25','11:40:00',1.59),('8537','2013-02-25','11:45:00',1.99),('8537','2013-02-25','11:50:00',2.83),('8537','2013-02-25','11:55:00',5.86),('8537','2013-02-25','12:00:00',3.31),('8537','2013-02-25','12:05:00',2.56),('8537','2013-02-25','12:10:00',2.26),('8537','2013-02-25','12:15:00',2.77),('8537','2013-02-25','12:20:00',5.17),('8537','2013-02-25','12:25:00',5.33),('8537','2013-02-25','12:30:00',4.6),('8537','2013-02-25','12:35:00',4.05),('8537','2013-02-25','12:40:00',5.13),('8537','2013-02-25','12:45:00',4.82),('8537','2013-02-25','12:50:00',4.65),('8537','2013-02-25','12:55:00',4.68),('8537','2013-02-25','13:00:00',4.89),('8537','2013-02-25','13:05:00',3.49),('8537','2013-02-25','13:10:00',3.41),('8537','2013-02-25','13:15:00',3.54),('8537','2013-02-25','13:20:00',2.88),('8537','2013-02-25','13:25:00',1.85),('8537','2013-02-25','13:30:00',1.86),('8537','2013-02-25','13:35:00',1.55),('8537','2013-02-25','13:40:00',1.19),('8537','2013-02-25','13:45:00',1.04),('8537','2013-02-25','13:50:00',1.06),('8537','2013-02-25','14:40:00',1.04),('8537','2013-02-24','08:05:00',1),('8537','2013-02-24','10:45:00',1.07),('8537','2013-02-24','10:50:00',1.51),('8537','2013-02-24','10:55:00',1.4),('8537','2013-02-24','11:00:00',1.09),('8537','2013-02-24','11:05:00',1.06),('8537','2013-02-24','11:25:00',1.02),('8537','2013-02-24','11:30:00',1.12),('8537','2013-02-24','11:45:00',1.05),('8537','2013-02-24','11:50:00',1.06),('8537','2013-02-24','11:55:00',1.03),('8537','2013-02-24','12:35:00',1.08),('8537','2013-02-24','12:40:00',1.29),('8537','2013-02-24','12:45:00',1.52),('8537','2013-02-24','12:50:00',1.37),('8537','2013-02-24','12:55:00',1.14),('8537','2013-02-24','13:00:00',1.37),('8537','2013-02-24','13:05:00',1.92),('8537','2013-02-24','13:10:00',1.91),('8537','2013-02-24','13:15:00',1.65),('8537','2013-02-24','13:20:00',1.77),('8537','2013-02-24','13:25:00',1.26),('8537','2013-02-24','13:30:00',1.08),('8537','2013-02-24','13:35:00',1.47),('8537','2013-02-24','13:40:00',1.65),('8537','2013-02-24','13:45:00',1.73),('8537','2013-02-24','13:50:00',1.32),('8537','2013-02-24','13:55:00',1.13),('8537','2013-02-24','14:00:00',1.26),('8537','2013-02-24','14:05:00',2.21),('8537','2013-02-24','14:10:00',1.78),('8537','2013-02-24','14:15:00',1.31),('8537','2013-02-24','14:20:00',1.2),('8537','2013-02-24','14:25:00',1.07),('8537','2013-02-24','14:30:00',1.33),('8537','2013-02-24','14:35:00',1.44),('8537','2013-02-24','15:10:00',2.58),('8537','2013-02-24','15:15:00',1.73),('8537','2013-02-24','15:20:00',1.26),('8537','2013-02-24','15:25:00',2.36),('8537','2013-02-24','15:30:00',1.43),('8537','2013-02-24','15:35:00',1.72),('8537','2013-02-24','15:40:00',1.74),('8537','2013-02-24','15:45:00',1.64),('8537','2013-02-24','15:50:00',1.37),('8537','2013-02-24','15:55:00',1.48),('8537','2013-02-24','16:00:00',1.75),('8537','2013-02-24','16:05:00',1.18),('8537','2013-02-23','07:50:00',1.02),('8537','2013-02-23','07:55:00',1.21),('8537','2013-02-23','08:00:00',1.34),('8537','2013-02-23','08:05:00',1.5),('8537','2013-02-23','08:10:00',1.82),('8537','2013-02-23','08:15:00',2.16),('8537','2013-02-23','08:20:00',1.27),('8537','2013-02-23','08:55:00',1.23),('8537','2013-02-23','09:00:00',1.55),('8537','2013-02-23','09:05:00',1.59),('8537','2013-02-23','09:10:00',1.19),('8537','2013-02-23','09:40:00',1.15),('8537','2013-02-23','09:45:00',1.59),('8537','2013-02-23','09:50:00',1.6),('8537','2013-02-23','09:55:00',1.53),('8537','2013-02-23','10:00:00',1.25),('8537','2013-02-23','10:05:00',1.18),('8537','2013-02-23','10:10:00',1.03),('8537','2013-02-23','10:25:00',1.2),('8537','2013-02-23','10:30:00',1.06),('8537','2013-02-23','10:35:00',1.03),('8537','2013-02-23','11:35:00',1.01),('8537','2013-02-23','11:40:00',1.03),('8537','2013-02-23','13:55:00',1.11),('8537','2013-02-23','14:00:00',1.18),('8537','2013-02-23','14:05:00',2.11),('8537','2013-02-23','14:10:00',1.72),('8537','2013-02-22','09:35:00',1),('8537','2013-02-22','09:40:00',1.1),('8537','2013-02-22','12:55:00',1.01),('8537','2013-02-22','14:20:00',1.03),('8537','2013-02-22','14:30:00',1.04),('8537','2013-02-22','14:35:00',1.44),('8537','2013-02-22','14:40:00',1.56),('8537','2013-02-22','14:45:00',1.28),('8537','2013-02-22','14:55:00',1.56),('8537','2013-02-22','16:20:00',1.18),('8537','2013-02-22','16:25:00',1.33),('8537','2013-02-22','16:30:00',1.13),('8537','2013-02-21','11:25:00',1.01),('8537','2013-02-21','11:30:00',1.07),('8537','2013-02-21','11:35:00',1.14),('8537','2013-02-21','11:40:00',1.12),('8537','2013-02-21','11:45:00',1.17),('8537','2013-02-21','11:50:00',1.3),('8537','2013-02-21','11:55:00',1.34),('8537','2013-02-21','12:00:00',1.33),('8537','2013-02-21','12:05:00',1.33),('8537','2013-02-21','12:10:00',1.38),('8537','2013-02-21','12:15:00',1.46),('8537','2013-02-21','12:20:00',1.58),('8537','2013-02-21','12:25:00',1.55),('8537','2013-02-21','12:30:00',1.46),('8537','2013-02-21','12:35:00',1.38),('8537','2013-02-21','12:40:00',1.34),('8537','2013-02-21','12:45:00',1.34),('8537','2013-02-21','12:50:00',1.36),('8537','2013-02-21','12:55:00',1.46),('8537','2013-02-21','13:00:00',1.48),('8537','2013-02-21','13:05:00',1.39),('8537','2013-02-21','13:10:00',1.31),('8537','2013-02-21','13:15:00',1.33),('8537','2013-02-21','13:20:00',1.39),('8537','2013-02-21','13:25:00',1.43),('8537','2013-02-21','13:30:00',1.45),('8537','2013-02-21','13:35:00',1.45),('8537','2013-02-21','13:40:00',1.41),('8537','2013-02-21','13:45:00',1.34),('8537','2013-02-21','13:50:00',1.36),('8537','2013-02-21','13:55:00',1.37),('8537','2013-02-21','14:00:00',1.38),('8537','2013-02-21','14:05:00',1.33),('8537','2013-02-21','14:10:00',1.24),('8537','2013-02-21','14:15:00',1.09),('8537','2013-02-21','16:00:00',1.03),('8537','2013-02-21','16:05:00',1.11),('8537','2013-02-21','16:20:00',1.33),('8537','2013-02-21','16:25:00',1.47),('8537','2013-02-21','16:30:00',1.37),('8537','2013-02-21','16:35:00',1.24),('8537','2014-03-23','08:25:00',1.04),('8537','2014-03-23','08:30:00',1.19),('8537','2014-03-23','08:35:00',1.33),('8537','2014-03-23','08:45:00',1.02),('8537','2014-03-23','08:50:00',1.43),('8537','2014-03-23','08:55:00',1.92),('8537','2014-03-23','09:00:00',1.16),('8537','2014-03-23','09:05:00',1.96),('8537','2014-03-23','09:10:00',3.14),('8537','2014-03-23','09:15:00',3.09),('8537','2014-03-23','09:20:00',2.17),('8537','2014-03-23','09:25:00',1.2),('8537','2014-03-23','09:30:00',1.62),('8537','2014-03-23','09:35:00',1.64),('8537','2014-03-23','09:40:00',1.48),('8537','2014-03-23','09:45:00',1.12),('8537','2014-03-23','10:25:00',1.34),('8537','2014-03-23','10:30:00',1.13),('8537','2014-03-23','10:40:00',1.35),('8537','2014-03-23','10:45:00',1.22),('8537','2014-03-23','10:50:00',1.32),('8537','2014-03-23','10:55:00',1.9),('8537','2014-03-23','11:00:00',1.47),('8537','2014-03-23','11:05:00',1.19),('8537','2014-03-23','11:10:00',1.53),('8537','2014-03-23','11:25:00',1.21),('8537','2014-03-23','11:35:00',1.55),('8537','2014-03-23','11:40:00',3.85),('8537','2014-03-23','11:45:00',1.17),('8537','2014-03-23','11:55:00',1.05),('8537','2014-03-23','12:00:00',1.09),('8537','2014-03-23','13:45:00',2.54),('8537','2014-03-23','13:50:00',2.03),('8537','2014-03-23','13:55:00',1.31),('8537','2014-03-23','14:00:00',1.18),('8537','2014-03-23','14:50:00',1.06),('8537','2014-03-23','14:55:00',1.16),('8537','2014-03-23','15:05:00',1.09),('8537','2014-03-23','15:10:00',1.48),('8537','2014-03-23','15:15:00',2.15),('8537','2014-03-23','15:20:00',1.71),('8537','2014-03-23','15:25:00',1.96),('8537','2014-03-23','15:30:00',1.17),('8537','2014-03-23','15:35:00',1.14),('8537','2014-03-23','15:40:00',1.25),('8537','2013-02-20','08:20:00',1.56),('8537','2013-02-20','08:25:00',1.72),('8537','2013-02-20','08:30:00',1.82),('8537','2013-02-20','08:35:00',1.96),('8537','2013-02-20','08:40:00',2.07),('8537','2013-02-20','08:45:00',2.18),('8537','2013-02-20','08:50:00',2.26),('8537','2013-02-20','08:55:00',2.42),('8537','2013-02-20','09:00:00',2.56),('8537','2013-02-20','09:05:00',1.6),('8537','2013-02-20','09:10:00',1.73),('8537','2013-02-20','09:15:00',1.81),('8537','2013-02-20','09:20:00',1.57),('8537','2013-02-20','09:25:00',2.38),('8537','2013-02-20','09:30:00',1.96),('8537','2013-02-20','09:35:00',2.29),('8537','2013-02-20','09:40:00',1.37),('8537','2013-02-20','09:45:00',1.57),('8537','2013-02-20','09:50:00',1.98),('8537','2013-02-20','09:55:00',2.24),('8537','2013-02-20','10:00:00',1.26),('8537','2013-02-20','10:05:00',1.89),('8537','2013-02-20','10:10:00',2.18),('8537','2013-02-20','10:15:00',1.77),('8537','2013-02-20','10:45:00',1.78),('8537','2013-02-20','10:50:00',4.6),('8537','2013-02-20','10:55:00',3),('8537','2013-02-20','11:05:00',2.31),('8537','2013-02-20','11:10:00',4.64),('8537','2013-02-20','11:15:00',4.28),('8537','2013-02-20','11:20:00',1.72),('8537','2013-02-20','11:25:00',3.53),('8537','2013-02-20','11:30:00',2.63),('8537','2013-02-20','11:35:00',4.36),('8537','2013-02-20','11:40:00',5),('8537','2013-02-20','11:45:00',5.12),('8537','2013-02-20','11:50:00',4.73),('8537','2013-02-20','11:55:00',1.88),('8537','2013-02-20','12:00:00',4.63),('8537','2013-02-20','12:05:00',2.41),('8537','2013-02-20','12:10:00',3.78),('8537','2013-02-20','12:15:00',2.4),('8537','2013-02-20','12:20:00',1.83),('8537','2013-02-20','12:25:00',3.25),('8537','2013-02-20','12:30:00',5.57),('8537','2013-02-20','12:35:00',3.87),('8537','2013-02-20','12:40:00',2.31),('8537','2013-02-20','12:45:00',1.76),('8537','2013-02-20','12:50:00',1.32),('8537','2013-02-20','12:55:00',1.48),('8537','2013-02-20','13:00:00',3.53),('8537','2013-02-20','13:05:00',4.1),('8537','2013-02-20','13:10:00',4.28),('8537','2013-02-20','13:15:00',4.36),('8537','2013-02-20','13:20:00',2.01),('8537','2013-02-20','13:25:00',2.66),('8537','2013-02-20','13:30:00',3.08),('8537','2013-02-20','13:35:00',2.82),('8537','2013-02-20','13:40:00',2.21),('8537','2013-02-20','13:45:00',1.54),('8537','2013-02-20','13:50:00',1.44),('8537','2013-02-20','13:55:00',1.32),('8537','2013-02-20','14:00:00',2.16),('8537','2013-02-20','14:05:00',1.2),('8537','2013-02-20','14:10:00',1.17),('8537','2013-02-20','14:15:00',1.08),('8537','2013-02-20','14:35:00',1.18),('8537','2013-02-20','14:40:00',1.24),('8537','2013-02-20','14:45:00',1.15),('8537','2013-02-20','14:50:00',1.07),('8537','2013-02-20','14:55:00',1.05),('8537','2013-02-20','15:05:00',1.09),('8537','2013-02-20','15:10:00',1.2),('8537','2013-02-20','15:15:00',2.4),('8537','2013-02-20','15:20:00',2.32),('8537','2013-02-20','15:25:00',2.64),('8537','2013-02-20','15:30:00',1.86),('8537','2013-02-20','15:55:00',1.03),('8537','2013-02-20','16:00:00',1.42),('8537','2013-02-20','16:05:00',1.64),('8537','2013-02-20','16:10:00',1.67),('8537','2013-02-20','16:15:00',1.82),('8537','2013-02-20','16:20:00',1.61),('8537','2013-02-20','16:25:00',1.34),('8537','2013-02-20','16:30:00',1.21),('8537','2013-02-19','08:00:00',1.01),('8537','2013-02-19','08:05:00',1.14),('8537','2013-02-19','08:10:00',1.29),('8537','2013-02-19','08:15:00',1.44),('8537','2013-02-19','08:20:00',1.56),('8537','2013-02-19','08:25:00',1.68),('8537','2013-02-19','08:30:00',1.79),('8537','2013-02-19','08:35:00',1.91),('8537','2013-02-19','08:40:00',2.01),('8537','2013-02-19','08:45:00',2.12),('8537','2013-02-19','08:50:00',2.25),('8537','2013-02-19','08:55:00',2.35),('8537','2013-02-19','09:00:00',2.44),('8537','2013-02-19','09:05:00',2.51),('8537','2013-02-19','09:10:00',2.64),('8537','2013-02-19','09:15:00',2.73),('8537','2013-02-19','09:20:00',2.84),('8537','2013-02-19','09:25:00',2.92),('8537','2013-02-19','09:30:00',3),('8537','2013-02-19','09:35:00',3.08),('8537','2013-02-19','09:40:00',3.15),('8537','2013-02-19','09:45:00',3.24),('8537','2013-02-19','09:50:00',3.32),('8537','2013-02-19','09:55:00',3.39),('8537','2013-02-19','10:00:00',3.47),('8537','2013-02-19','10:05:00',3.55),('8537','2013-02-19','10:10:00',3.64),('8537','2013-02-19','10:15:00',3.7),('8537','2013-02-19','10:20:00',3.74),('8537','2013-02-19','10:25:00',3.85),('8537','2013-02-19','10:30:00',3.9),('8537','2013-02-19','10:35:00',3.93),('8537','2013-02-19','10:40:00',3.99),('8537','2013-02-19','10:45:00',4.05),('8537','2013-02-19','10:50:00',4.01),('8537','2013-02-19','10:55:00',4.05),('8537','2013-02-19','11:00:00',4.13),('8537','2013-02-19','11:05:00',4.2),('8537','2013-02-19','11:10:00',4.26),('8537','2013-02-19','11:15:00',4.31),('8537','2013-02-19','11:20:00',4.31),('8537','2013-02-19','11:25:00',4.38),('8537','2013-02-19','11:30:00',4.32),('8537','2013-02-19','11:35:00',4.33),('8537','2013-02-19','11:40:00',4.41),('8537','2013-02-19','11:45:00',4.36),('8537','2013-02-19','11:50:00',4.45),('8537','2013-02-19','11:55:00',4.48),('8537','2013-02-19','12:00:00',4.46),('8537','2013-02-19','12:05:00',4.46),('8537','2013-02-19','12:10:00',4.43),('8537','2013-02-19','12:15:00',4.42),('8537','2013-02-19','12:20:00',4.36),('8537','2013-02-19','12:25:00',4.36),('8537','2013-02-19','12:30:00',4.4),('8537','2013-02-19','12:35:00',4.37),('8537','2013-02-19','12:40:00',4.44),('8537','2013-02-19','12:45:00',4.44),('8537','2013-02-19','12:50:00',4.39),('8537','2013-02-19','12:55:00',4.42),('8537','2013-02-19','13:00:00',4.36),('8537','2013-02-19','13:05:00',4.36),('8537','2013-02-19','13:10:00',4.34),('8537','2013-02-19','13:15:00',4.28),('8537','2013-02-19','13:20:00',4.22),('8537','2013-02-19','13:25:00',4.17),('8537','2013-02-19','13:30:00',4.24),('8537','2013-02-19','13:35:00',4.21),('8537','2013-02-19','13:40:00',4.15),('8537','2013-02-19','13:45:00',4.05),('8537','2013-02-19','13:50:00',4.02),('8537','2013-02-19','13:55:00',4),('8537','2013-02-19','14:00:00',3.88),('8537','2013-02-19','14:05:00',3.81),('8537','2013-02-19','14:10:00',3.76),('8537','2013-02-19','14:15:00',3.65),('8537','2013-02-19','14:20:00',3.41),('8537','2013-02-19','14:25:00',3.31),('8537','2013-02-19','14:30:00',3.37),('8537','2013-02-19','14:35:00',3.34),('8537','2013-02-19','14:40:00',3.2),('8537','2013-02-19','14:45:00',3.13),('8537','2013-02-19','14:50:00',3.12),('8537','2013-02-19','14:55:00',3.04),('8537','2013-02-19','15:00:00',2.96),('8537','2013-02-19','15:05:00',2.88),('8537','2013-02-19','15:10:00',2.83),('8537','2013-02-19','15:15:00',2.68),('8537','2013-02-19','15:20:00',2.38),('8537','2013-02-19','15:25:00',2.42),('8537','2013-02-19','15:30:00',2.36),('8537','2013-02-19','15:35:00',2.23),('8537','2013-02-19','15:40:00',2.14),('8537','2013-02-19','15:45:00',2.09),('8537','2013-02-19','15:50:00',1.96),('8537','2013-02-19','15:55:00',1.8),('8537','2013-02-19','16:00:00',1.56),('8537','2013-02-19','16:05:00',1.33),('8537','2013-02-19','16:10:00',1.35),('8537','2013-02-19','16:15:00',1.37),('8537','2013-02-19','16:20:00',1.23),('8537','2013-02-19','16:25:00',1.08),('8537','2013-02-18','08:05:00',1.04),('8537','2013-02-18','08:10:00',1.17),('8537','2013-02-18','08:15:00',1.32),('8537','2013-02-18','08:20:00',1.45),('8537','2013-02-18','08:25:00',1.56),('8537','2013-02-18','08:30:00',1.68),('8537','2013-02-18','08:35:00',1.8),('8537','2013-02-18','08:40:00',1.92),('8537','2013-02-18','08:45:00',1.99),('8537','2013-02-18','08:50:00',2.08),('8537','2013-02-18','08:55:00',2.19),('8537','2013-02-18','09:00:00',2.28),('8537','2013-02-18','09:05:00',2.38),('8537','2013-02-18','09:10:00',2.49),('8537','2013-02-18','09:15:00',2.58),('8537','2013-02-18','09:20:00',2.82),('8537','2013-02-18','09:25:00',3.08),('8537','2013-02-18','09:30:00',2.82),('8537','2013-02-18','09:35:00',1.42),('8537','2013-02-18','09:40:00',1.25),('8537','2013-02-18','09:45:00',1.43),('8537','2013-02-18','09:50:00',2),('8537','2013-02-18','10:05:00',1.51),('8537','2013-02-18','10:10:00',1.65),('8537','2013-02-18','10:55:00',1.13),('8537','2013-02-18','11:00:00',1.46),('8537','2013-02-18','11:05:00',1.47),('8537','2013-02-18','11:10:00',1.57),('8537','2013-02-18','11:15:00',1.39),('8537','2013-02-18','11:20:00',1.62),('8537','2013-02-18','11:25:00',1.84),('8537','2013-02-18','11:30:00',1.6),('8537','2013-02-18','11:35:00',1.64),('8537','2013-02-18','11:40:00',1.62),('8537','2013-02-18','11:45:00',1.54),('8537','2013-02-18','11:50:00',1.64),('8537','2013-02-18','11:55:00',1.92),('8537','2013-02-18','12:00:00',2.11),('8537','2013-02-18','12:05:00',1.84),('8537','2013-02-18','12:10:00',1.69),('8537','2013-02-18','12:15:00',1.64),('8537','2013-02-18','12:20:00',1.58),('8537','2013-02-18','12:25:00',1.63),('8537','2013-02-18','12:30:00',1.53),('8537','2013-02-18','12:35:00',1.43),('8537','2013-02-18','12:40:00',1.51),('8537','2013-02-18','12:45:00',1.82),('8537','2013-02-18','12:50:00',1.82),('8537','2013-02-18','12:55:00',1.68),('8537','2013-02-18','13:00:00',1.69),('8537','2013-02-18','13:05:00',1.72),('8537','2013-02-18','13:10:00',1.69),('8537','2013-02-18','13:15:00',2.11),('8537','2013-02-18','13:20:00',1.74),('8537','2013-02-18','13:25:00',2.12),('8537','2013-02-18','13:30:00',1.92),('8537','2013-02-18','13:35:00',1.6),('8537','2013-02-18','13:40:00',1.51),('8537','2013-02-18','13:45:00',1.36),('8537','2013-02-18','13:50:00',1.44),('8537','2013-02-18','13:55:00',1.82),('8537','2013-02-18','14:00:00',1.78),('8537','2013-02-18','14:05:00',1.58),('8537','2013-02-18','14:10:00',1.45),('8537','2013-02-18','14:15:00',1.22),('8537','2013-02-18','14:20:00',1.37),('8537','2013-02-17','08:10:00',1.05),('8537','2013-02-17','08:15:00',1.2),('8537','2013-02-17','08:20:00',1.37),('8537','2013-02-17','08:25:00',1.5),('8537','2013-02-17','08:30:00',1.67),('8537','2013-02-17','08:35:00',1.85),('8537','2013-02-17','08:40:00',2.02),('8537','2013-02-17','08:45:00',2),('8537','2013-02-17','08:50:00',1.71),('8537','2013-02-17','08:55:00',2.03),('8537','2013-02-17','09:00:00',2.23),('8537','2013-02-17','09:05:00',2.23),('8537','2013-02-17','09:10:00',2.38),('8537','2013-02-17','09:15:00',2.54),('8537','2013-02-17','09:20:00',2.66),('8537','2013-02-17','09:25:00',2.74),('8537','2013-02-17','09:30:00',2.81),('8537','2013-02-17','09:35:00',2.89),('8537','2013-02-17','09:40:00',2.96),('8537','2013-02-17','09:45:00',3.04),('8537','2013-02-17','09:50:00',3.13),('8537','2013-02-17','09:55:00',3.22),('8537','2013-02-17','10:00:00',3.31),('8537','2013-02-17','10:05:00',3.37),('8537','2013-02-17','10:10:00',3.39),('8537','2013-02-17','10:15:00',3.53),('8537','2013-02-17','10:20:00',3.57),('8537','2013-02-17','10:25:00',3.62),('8537','2013-02-17','10:30:00',3.69),('8537','2013-02-17','10:35:00',3.76),('8537','2013-02-17','10:40:00',3.78),('8537','2013-02-17','10:45:00',3.83),('8537','2013-02-17','10:50:00',3.83),('8537','2013-02-17','10:55:00',3.88),('8537','2013-02-17','11:00:00',3.97),('8537','2013-02-17','11:05:00',4.05),('8537','2013-02-17','11:10:00',4.03),('8537','2013-02-17','11:15:00',4.02),('8537','2013-02-17','11:20:00',4.1),('8537','2013-02-17','11:25:00',4.14),('8537','2013-02-17','11:30:00',4.17),('8537','2013-02-17','11:35:00',4.18),('8537','2013-02-17','11:40:00',4.21),('8537','2013-02-17','11:45:00',4.21),('8537','2013-02-17','11:50:00',4.21),('8537','2013-02-17','11:55:00',4.22),('8537','2013-02-17','12:00:00',4.23),('8537','2013-02-17','12:05:00',4.25),('8537','2013-02-17','12:10:00',4.28),('8537','2013-02-17','12:15:00',4.29),('8537','2013-02-17','12:20:00',4.29),('8537','2013-02-17','12:25:00',4.28),('8537','2013-02-17','12:30:00',4.23),('8537','2013-02-17','12:35:00',4.22),('8537','2013-02-17','12:40:00',4.21),('8537','2013-02-17','12:45:00',4.17),('8537','2013-02-17','12:50:00',4.13),('8537','2013-02-17','12:55:00',4.13),('8537','2013-02-17','13:00:00',4.12),('8537','2013-02-17','13:05:00',4.11),('8537','2013-02-17','13:10:00',3.96),('8537','2013-02-17','13:15:00',3.97),('8537','2013-02-17','13:20:00',2.57),('8537','2013-02-17','13:25:00',1.19),('8537','2013-02-17','13:30:00',2.64),('8537','2013-02-17','13:35:00',3.91),('8537','2013-02-17','13:40:00',3.76),('8537','2013-02-17','13:45:00',3.62),('8537','2013-02-17','13:50:00',3.44),('8537','2013-02-17','13:55:00',3.29),('8537','2013-02-17','14:10:00',3.39),('8537','2013-02-17','14:15:00',2.69),('8537','2013-02-17','14:20:00',1.33),('8537','2013-02-17','14:25:00',1.17),('8537','2013-02-17','14:30:00',2.5),('8537','2013-02-17','14:35:00',2.48),('8537','2013-02-17','14:40:00',1.13),('8537','2013-02-17','15:00:00',1.38),('8537','2013-02-17','15:05:00',2.6),('8537','2013-02-17','15:10:00',2.61),('8537','2013-02-17','15:15:00',3),('8537','2013-02-17','15:20:00',2.87),('8537','2013-02-17','15:25:00',2.55),('8537','2013-02-17','15:30:00',2.41),('8537','2013-02-17','15:35:00',2.48),('8537','2013-02-17','15:40:00',2.36),('8537','2013-02-17','15:45:00',2.27),('8537','2013-02-17','15:50:00',2.14),('8537','2013-02-17','15:55:00',1.94),('8537','2013-02-17','16:00:00',1.83),('8537','2013-02-17','16:05:00',1.65),('8537','2013-02-17','16:25:00',1.16),('8537','2013-02-17','16:30:00',1.23),('8537','2013-02-16','08:10:00',1.02),('8537','2013-02-16','08:15:00',1.15),('8537','2013-02-16','08:20:00',1.27),('8537','2013-02-16','08:25:00',1.45),('8537','2013-02-16','08:30:00',1.59),('8537','2013-02-16','08:35:00',1.72),('8537','2013-02-16','08:40:00',1.84),('8537','2013-02-16','08:45:00',1.91),('8537','2013-02-16','09:15:00',2.61),('8537','2013-02-16','09:20:00',2.78),('8537','2013-02-16','09:25:00',2.86),('8537','2013-02-16','09:30:00',2.92),('8537','2013-02-16','09:35:00',3),('8537','2013-02-16','09:40:00',3.07),('8537','2013-02-16','09:45:00',3.15),('8537','2013-02-16','09:50:00',3.26),('8537','2013-02-16','09:55:00',3.3),('8537','2013-02-16','10:00:00',3.34),('8537','2013-02-16','10:05:00',3.41),('8537','2013-02-16','10:10:00',3.55),('8537','2013-02-16','10:15:00',3.58),('8537','2013-02-16','10:20:00',3.68),('8537','2013-02-16','10:25:00',3.73),('8537','2013-02-16','10:30:00',3.77),('8537','2013-02-16','10:35:00',3.87),('8537','2013-02-16','10:40:00',3.83),('8537','2013-02-16','10:45:00',3.88),('8537','2013-02-16','10:50:00',4.11),('8537','2013-02-16','10:55:00',3.8),('8537','2013-02-16','11:00:00',4.17),('8537','2013-02-16','11:05:00',3.93),('8537','2013-02-16','11:10:00',3.97),('8537','2013-02-16','11:15:00',4.28),('8537','2013-02-16','11:20:00',3.86),('8537','2013-02-16','11:25:00',4.13),('8537','2013-02-16','11:30:00',4.31),('8537','2013-02-16','11:35:00',4.35),('8537','2013-02-16','11:40:00',4.35),('8537','2013-02-16','11:45:00',4.36),('8537','2013-02-16','11:50:00',4.45),('8537','2013-02-16','11:55:00',4.46),('8537','2013-02-16','12:00:00',4.46),('8537','2013-02-16','12:05:00',4.45),('8537','2013-02-16','12:10:00',4.42),('8537','2013-02-16','12:15:00',4.43),('8537','2013-02-16','12:20:00',4.41),('8537','2013-02-16','12:25:00',4.42),('8537','2013-02-16','12:30:00',4.43),('8537','2013-02-16','12:35:00',4.43),('8537','2013-02-16','12:40:00',4.42),('8537','2013-02-16','12:45:00',4.43),('8537','2013-02-16','12:50:00',4.45),('8537','2013-02-16','12:55:00',4.41),('8537','2013-02-16','13:00:00',4.34),('8537','2013-02-16','13:05:00',4.35),('8537','2013-02-16','13:10:00',4.29),('8537','2013-02-16','13:15:00',4.29),('8537','2013-02-16','13:20:00',4.24),('8537','2013-02-16','13:25:00',4.22),('8537','2013-02-16','13:30:00',4.18),('8537','2013-02-16','13:35:00',4.16),('8537','2013-02-16','13:40:00',4.14),('8537','2013-02-16','13:45:00',4.15),('8537','2013-02-16','13:50:00',4.12),('8537','2013-02-16','13:55:00',4.03),('8537','2013-02-16','14:00:00',3.95),('8537','2013-02-16','14:05:00',3.89),('8537','2013-02-16','14:10:00',3.84),('8537','2013-02-16','14:15:00',3.86),('8537','2013-02-16','14:20:00',3.25),('8537','2013-02-16','14:25:00',1.09),('8537','2013-02-16','14:30:00',1.2),('8537','2013-02-16','14:35:00',1.1),('8537','2013-02-16','14:40:00',1.14),('8537','2013-02-16','14:45:00',1.21),('8537','2013-02-16','14:50:00',1.21),('8537','2013-02-16','14:55:00',1.1),('8537','2013-02-16','15:15:00',1.14),('8537','2013-02-16','15:20:00',1.37),('8537','2013-02-16','15:25:00',1.26),('8537','2013-02-16','15:30:00',2.17),('8537','2013-02-16','15:35:00',2.32),('8537','2013-02-16','15:40:00',2.33),('8537','2013-02-16','15:45:00',2.63),('8537','2013-02-16','15:50:00',2.52),('8537','2013-02-16','15:55:00',1.57),('8537','2013-02-16','16:00:00',1.4),('8537','2013-02-16','16:05:00',1.8),('8537','2013-02-16','16:10:00',1.33),('8537','2013-02-15','09:20:00',1.25),('8537','2013-02-15','09:25:00',1.86),('8537','2013-02-15','09:30:00',1.32),('8537','2013-02-15','09:35:00',1.28),('8537','2013-02-15','09:40:00',1.24),('8537','2013-02-15','09:45:00',1.25),('8537','2013-02-15','09:50:00',1.29),('8537','2013-02-15','09:55:00',1.56),('8537','2013-02-15','10:00:00',2.12),('8537','2013-02-15','10:05:00',2.19),('8537','2013-02-15','10:10:00',1.62),('8537','2013-02-15','10:15:00',1.64),('8537','2013-02-15','10:20:00',1.73),('8537','2013-02-15','10:25:00',2.74),('8537','2013-02-15','10:30:00',2.25),('8537','2013-02-15','10:35:00',3.52),('8537','2013-02-15','10:40:00',3.47),('8537','2013-02-15','10:45:00',3.76),('8537','2013-02-15','10:50:00',3.55),('8537','2013-02-15','10:55:00',2.29),('8537','2013-02-15','11:00:00',2.15),('8537','2013-02-15','11:05:00',2.28),('8537','2013-02-15','11:10:00',2.5),('8537','2013-02-15','11:15:00',3.15),('8537','2013-02-15','11:20:00',4.3),('8537','2013-02-15','11:25:00',4.19),('8537','2013-02-15','11:30:00',4.18),('8537','2013-02-15','11:35:00',3.45),('8537','2013-02-15','11:40:00',2.37),('8537','2013-02-15','11:45:00',2.59),('8537','2013-02-15','11:50:00',4.66),('8537','2013-02-15','11:55:00',4.27),('8537','2013-02-15','12:00:00',3.5),('8537','2013-02-15','12:05:00',3.56),('8537','2013-02-15','12:10:00',3.3),('8537','2013-02-15','12:15:00',3.66),('8537','2013-02-15','12:20:00',4.82),('8537','2013-02-15','12:25:00',4.3),('8537','2013-02-15','12:30:00',4.43),('8537','2013-02-15','12:35:00',4.42),('8537','2013-02-15','12:40:00',4.34),('8537','2013-02-15','12:45:00',4.35),('8537','2013-02-15','12:50:00',4.34),('8537','2013-02-15','12:55:00',4.35),('8537','2013-02-15','13:00:00',4.28),('8537','2013-02-15','13:05:00',4.27),('8537','2013-02-15','13:10:00',4.25),('8537','2013-02-15','13:15:00',4.32),('8537','2013-02-15','13:20:00',4.04),('8537','2013-02-15','13:25:00',3.73),('8537','2013-02-15','13:30:00',2.79),('8537','2013-02-15','13:35:00',2.91),('8537','2013-02-15','13:40:00',3.87),('8537','2013-02-15','13:45:00',3.19),('8537','2013-02-15','13:50:00',3.07),('8537','2013-02-15','13:55:00',3.76),('8537','2013-02-15','14:00:00',2.53),('8537','2013-02-15','14:05:00',3.67),('8537','2013-02-15','14:10:00',4.46),('8537','2013-02-15','14:15:00',3),('8537','2013-02-15','14:20:00',3.11),('8537','2013-02-15','14:25:00',2.08),('8537','2013-02-15','14:30:00',2.15),('8537','2013-02-15','14:35:00',3.22),('8537','2013-02-15','14:40:00',3.41),('8537','2013-02-15','14:45:00',2.92),('8537','2013-02-15','14:50:00',1.54),('8537','2013-02-15','14:55:00',1.44),('8537','2013-02-15','15:00:00',2.12),('8537','2013-02-15','15:05:00',1.53),('8537','2013-02-15','15:10:00',1.62),('8537','2013-02-15','15:15:00',2.03),('8537','2013-02-15','15:20:00',1.58),('8537','2013-02-15','15:25:00',1.73),('8537','2013-02-15','15:30:00',1.97),('8537','2013-02-15','15:35:00',1.62),('8537','2013-02-15','15:40:00',1.45),('8537','2013-02-15','15:45:00',1.4),('8537','2013-02-14','08:10:00',1.09),('8537','2013-02-14','08:15:00',1.19),('8537','2013-02-14','08:20:00',1.3),('8537','2013-02-14','08:25:00',1.42),('8537','2013-02-14','08:30:00',1.63),('8537','2013-02-14','08:35:00',1.84),('8537','2013-02-14','08:40:00',1.98),('8537','2013-02-14','08:45:00',2.1),('8537','2013-02-14','08:50:00',2.2),('8537','2013-02-14','08:55:00',2.32),('8537','2013-02-14','09:00:00',2.41),('8537','2013-02-14','09:05:00',2.53),('8537','2013-02-14','09:10:00',2.63),('8537','2013-02-14','09:15:00',2.74),('8537','2013-02-14','09:20:00',2.84),('8537','2013-02-14','09:25:00',2.95),('8537','2013-02-14','09:30:00',3.03),('8537','2013-02-14','09:35:00',3.12),('8537','2013-02-14','09:40:00',3.2),('8537','2013-02-14','09:45:00',3.3),('8537','2013-02-14','09:50:00',3.38),('8537','2013-02-14','09:55:00',3.47),('8537','2013-02-14','10:00:00',3.54),('8537','2013-02-14','10:05:00',3.62),('8537','2013-02-14','10:10:00',3.7),('8537','2013-02-14','10:15:00',3.78),('8537','2013-02-14','10:20:00',3.84),('8537','2013-02-14','10:25:00',3.89),('8537','2013-02-14','10:30:00',3.94),('8537','2013-02-14','10:35:00',4.02),('8537','2013-02-14','10:40:00',4.07),('8537','2013-02-14','10:45:00',4.06),('8537','2013-02-14','10:50:00',4.17),('8537','2013-02-14','10:55:00',4.21),('8537','2013-02-14','11:00:00',4.25),('8537','2013-02-14','11:05:00',4.3),('8537','2013-02-14','11:10:00',4.33),('8537','2013-02-14','11:15:00',4.35),('8537','2013-02-14','11:20:00',4.38),('8537','2013-02-14','11:25:00',4.4),('8537','2013-02-14','11:30:00',4.42),('8537','2013-02-14','11:35:00',4.45),('8537','2013-02-14','11:40:00',4.46),('8537','2013-02-14','11:45:00',4.48),('8537','2013-02-14','11:50:00',4.5),('8537','2013-02-14','11:55:00',4.53),('8537','2013-02-14','12:00:00',4.51),('8537','2013-02-14','12:05:00',4.54),('8537','2013-02-14','12:10:00',4.53),('8537','2013-02-14','12:15:00',4.53),('8537','2013-02-14','12:20:00',4.53),('8537','2013-02-14','12:25:00',4.54),('8537','2013-02-14','12:30:00',4.51),('8537','2013-02-14','12:35:00',4.52),('8537','2013-02-14','12:40:00',4.5),('8537','2013-02-14','12:45:00',4.47),('8537','2013-02-14','12:50:00',4.44),('8537','2013-02-14','12:55:00',4.43),('8537','2013-02-14','13:00:00',4.4),('8537','2013-02-14','13:05:00',4.4),('8537','2013-02-14','13:10:00',4.38),('8537','2013-02-14','13:15:00',4.34),('8537','2013-02-14','13:20:00',4.32),('8537','2013-02-14','13:25:00',4.27),('8537','2013-02-14','13:30:00',4.22),('8537','2013-02-14','13:35:00',4.2),('8537','2013-02-14','13:40:00',4.16),('8537','2013-02-14','13:45:00',4.12),('8537','2013-02-14','13:50:00',4.05),('8537','2013-02-14','13:55:00',3.98),('8537','2013-02-14','14:00:00',3.93),('8537','2013-02-14','14:05:00',3.88),('8537','2013-02-14','14:10:00',3.81),('8537','2013-02-14','14:15:00',3.72),('8537','2013-02-14','14:20:00',3.67),('8537','2013-02-14','14:25:00',3.49),('8537','2013-02-14','14:30:00',3.23),('8537','2013-02-14','14:35:00',3.36),('8537','2013-02-14','14:40:00',3.33),('8537','2013-02-14','14:45:00',3.26),('8537','2013-02-14','14:50:00',3.18),('8537','2013-02-14','14:55:00',3.09),('8537','2013-02-14','15:00:00',3),('8537','2013-02-14','15:05:00',2.89),('8537','2013-02-14','15:10:00',2.83),('8537','2013-02-14','15:15:00',2.73),('8537','2013-02-14','15:20:00',2.59),('8537','2013-02-14','15:25:00',2.49),('8537','2013-02-14','15:30:00',2.4),('8537','2013-02-14','15:35:00',2.25),('8537','2013-02-14','15:40:00',2.14),('8537','2013-02-14','15:45:00',2.04),('8537','2013-02-14','15:50:00',1.88),('8537','2013-02-14','15:55:00',1.53),('8537','2013-02-14','16:00:00',1.17),('8537','2013-02-14','16:05:00',1.32),('8537','2013-02-14','16:10:00',1.33),('8537','2013-02-14','16:15:00',1.17),('8537','2013-02-14','16:20:00',1.03),('8537','2013-02-13','08:55:00',1.09),('8537','2013-02-13','09:00:00',1.3),('8537','2013-02-13','09:05:00',1.5),('8537','2013-02-13','09:10:00',1.62),('8537','2013-02-13','09:15:00',1.56),('8537','2013-02-13','09:20:00',1.58),('8537','2013-02-13','09:25:00',1.64),('8537','2013-02-13','09:30:00',1.75),('8537','2013-02-13','09:35:00',2.26),('8537','2013-02-13','09:40:00',2.64),('8537','2013-02-13','09:45:00',3.02),('8537','2013-02-13','09:50:00',3.13),('8537','2013-02-13','09:55:00',2.98),('8537','2013-02-13','10:00:00',2.98),('8537','2013-02-13','10:05:00',3.2),('8537','2013-02-13','10:10:00',3.36),('8537','2013-02-13','10:15:00',3.57),('8537','2013-02-13','10:20:00',3.67),('8537','2013-02-13','10:25:00',3.8),('8537','2013-02-13','10:30:00',3.88),('8537','2013-02-13','10:35:00',3.89),('8537','2013-02-13','10:40:00',3.97),('8537','2013-02-13','10:45:00',4.15),('8537','2013-02-13','10:50:00',4.26),('8537','2013-02-13','10:55:00',4.22),('8537','2013-02-13','11:00:00',4.23),('8537','2013-02-13','11:05:00',4.19),('8537','2013-02-13','11:10:00',4.12),('8537','2013-02-13','11:15:00',4.21),('8537','2013-02-13','11:20:00',4.14),('8537','2013-02-13','11:25:00',3.34),('8537','2013-02-13','11:30:00',3.04),('8537','2013-02-13','11:35:00',2.08),('8537','2013-02-13','11:40:00',2.08),('8537','2013-02-13','11:45:00',1.84),('8537','2013-02-13','11:50:00',2.61),('8537','2013-02-13','11:55:00',1.48),('8537','2013-02-13','12:00:00',1.2),('8537','2013-02-13','12:05:00',1.41),('8537','2013-02-13','12:10:00',2.6),('8537','2013-02-13','12:15:00',2.82),('8537','2013-02-13','12:20:00',2.28),('8537','2013-02-13','12:25:00',2.3),('8537','2013-02-13','12:30:00',1.2),('8537','2013-02-13','12:35:00',1.52),('8537','2013-02-13','12:40:00',1.36),('8537','2013-02-13','12:45:00',2.38),('8537','2013-02-13','12:50:00',3.12),('8537','2013-02-13','12:55:00',2.83),('8537','2013-02-13','13:00:00',3.29),('8537','2013-02-13','13:05:00',3.27),('8537','2013-02-13','13:10:00',3.13),('8537','2013-02-13','13:15:00',1.93),('8537','2013-02-13','13:20:00',4.31),('8537','2013-02-13','13:25:00',4.17),('8537','2013-02-13','13:30:00',4.4),('8537','2013-02-13','13:35:00',4.28),('8537','2013-02-13','13:40:00',3.91),('8537','2013-02-13','13:45:00',3.58),('8537','2013-02-13','13:50:00',3.24),('8537','2013-02-13','13:55:00',3.26),('8537','2013-02-13','14:00:00',3.84),('8537','2013-02-13','14:05:00',4.01),('8537','2013-02-13','14:10:00',3.44),('8537','2013-02-13','14:15:00',3.55),('8537','2013-02-13','14:20:00',3.26),('8537','2013-02-13','14:25:00',3.04),('8537','2013-02-13','14:30:00',3.23),('8537','2013-02-13','14:35:00',3.45),('8537','2013-02-13','14:40:00',3.33),('8537','2013-02-13','14:45:00',3.11),('8537','2013-02-13','14:50:00',3.15),('8537','2013-02-13','14:55:00',3.08),('8537','2013-02-13','15:00:00',2.96),('8537','2013-02-13','15:05:00',2.88),('8537','2013-02-13','15:10:00',2.79),('8537','2013-02-13','15:15:00',2.67),('8537','2013-02-13','15:20:00',2.5),('8537','2013-02-13','15:25:00',2.31),('8537','2013-02-13','15:30:00',2.24),('8537','2013-02-13','15:35:00',2.29),('8537','2013-02-13','15:40:00',2.19),('8537','2013-02-13','15:45:00',2.09),('8537','2013-02-13','15:50:00',1.84),('8537','2013-02-13','15:55:00',1.48),('8537','2013-02-13','16:00:00',1.41),('8537','2013-02-13','16:05:00',1.48),('8537','2013-02-13','16:10:00',1.33),('8537','2013-02-13','16:15:00',1.17),('8537','2013-02-13','16:20:00',1.01),('8537','2013-02-11','10:20:00',1.12),('8537','2013-02-11','10:25:00',1.17),('8537','2013-02-11','10:30:00',1.24),('8537','2013-02-11','10:35:00',1.48),('8537','2013-02-11','10:40:00',1.28),('8537','2013-02-11','11:00:00',1.19),('8537','2013-02-11','11:05:00',1.49),('8537','2013-02-11','11:10:00',1.63),('8537','2013-02-11','11:15:00',1.65),('8537','2013-02-11','11:20:00',1.32),('8537','2013-02-11','11:45:00',1.2),('8537','2013-02-11','12:45:00',1.43),('8537','2013-02-11','14:00:00',1.11),('8537','2013-02-11','14:05:00',1.2),('8537','2013-02-11','14:10:00',1.31),('8537','2013-02-11','14:15:00',1.09),('8537','2013-02-11','14:20:00',1.15),('8537','2013-02-11','14:25:00',1.74),('8537','2013-02-11','14:30:00',2.33),('8537','2013-02-11','14:35:00',1.17),('8537','2013-02-11','14:40:00',1.74),('8537','2013-02-11','14:45:00',1.42),('8537','2013-02-11','15:10:00',1.19),('8537','2014-03-22','07:40:00',1.56),('8537','2014-03-22','07:45:00',1.5),('8537','2014-03-22','07:50:00',1.41),('8537','2014-03-22','08:10:00',1.33),('8537','2014-03-22','08:15:00',1.76),('8537','2014-03-22','08:20:00',2.12),('8537','2014-03-22','08:25:00',2.06),('8537','2014-03-22','08:30:00',2.23),('8537','2014-03-22','08:35:00',1.12),('8537','2014-03-22','08:40:00',2.21),('8537','2014-03-22','08:45:00',2.81),('8537','2014-03-22','08:50:00',1.98),('8537','2014-03-22','08:55:00',1.96),('8537','2014-03-22','09:00:00',2.51),('8537','2014-03-22','09:05:00',1.5),('8537','2014-03-22','09:10:00',1.69),('8537','2014-03-22','09:15:00',1.45),('8537','2014-03-22','09:20:00',1.59),('8537','2014-03-22','09:25:00',1.91),('8537','2014-03-22','09:30:00',3.1),('8537','2014-03-22','09:35:00',2.05),('8537','2014-03-22','09:40:00',2.41),('8537','2014-03-22','09:45:00',3.74),('8537','2014-03-22','09:50:00',3.64),('8537','2014-03-22','09:55:00',3.8),('8537','2014-03-22','10:00:00',3.93),('8537','2014-03-22','10:05:00',3.75),('8537','2014-03-22','10:10:00',4.3),('8537','2014-03-22','10:15:00',2.4),('8537','2014-03-22','10:20:00',1.39),('8537','2014-03-22','10:25:00',1.2),('8537','2014-03-22','10:30:00',1.26),('8537','2014-03-22','10:35:00',1.82),('8537','2014-03-22','10:40:00',2.63),('8537','2014-03-22','10:45:00',3.04),('8537','2014-03-22','10:50:00',3.36),('8537','2014-03-22','10:55:00',1.86),('8537','2014-03-22','11:00:00',1.38),('8537','2014-03-22','11:05:00',1.58),('8537','2014-03-22','11:10:00',1.36),('8537','2014-03-22','11:15:00',1.75),('8537','2014-03-22','11:20:00',3.57),('8537','2014-03-22','11:25:00',5.26),('8537','2014-03-22','11:30:00',4.56),('8537','2014-03-22','11:35:00',1.73),('8537','2014-03-22','11:40:00',2.92),('8537','2014-03-22','11:45:00',2.08),('8537','2014-03-22','11:50:00',2.41),('8537','2014-03-22','11:55:00',3.49),('8537','2014-03-22','12:00:00',4.05),('8537','2014-03-22','12:05:00',1.86),('8537','2014-03-22','12:10:00',1.58),('8537','2014-03-22','12:15:00',3.2),('8537','2014-03-22','12:20:00',4.59),('8537','2014-03-22','12:25:00',3.34),('8537','2014-03-22','12:30:00',2.38),('8537','2014-03-22','12:35:00',3.09),('8537','2014-03-22','12:40:00',2.9),('8537','2014-03-22','12:45:00',5.07),('8537','2014-03-22','12:50:00',3.06),('8537','2014-03-22','12:55:00',2.35),('8537','2014-03-22','13:00:00',2.78),('8537','2014-03-22','13:05:00',2.44),('8537','2014-03-22','13:10:00',4.66),('8537','2014-03-22','13:15:00',2.45),('8537','2014-03-22','13:20:00',4.78),('8537','2014-03-22','13:25:00',3.62),('8537','2014-03-22','13:30:00',3.97),('8537','2014-03-22','13:35:00',3.69),('8537','2014-03-22','13:40:00',3.12),('8537','2014-03-22','13:45:00',4.23),('8537','2014-03-22','13:50:00',3.09),('8537','2014-03-22','13:55:00',1.81),('8537','2014-03-22','14:00:00',3.87),('8537','2014-03-22','14:05:00',1.86),('8537','2014-03-22','14:10:00',3.36),('8537','2014-03-22','14:15:00',3.61),('8537','2014-03-22','14:20:00',3.89),('8537','2014-03-22','14:25:00',3.48),('8537','2014-03-22','14:30:00',3.43),('8537','2014-03-22','14:35:00',3.65),('8537','2014-03-22','14:40:00',3.55),('8537','2014-03-22','14:45:00',3.49),('8537','2014-03-22','14:50:00',3.43),('8537','2014-03-22','14:55:00',3.33),('8537','2014-03-22','15:00:00',3.16),('8537','2014-03-22','15:05:00',3.19),('8537','2014-03-22','15:10:00',2.98),('8537','2014-03-22','15:15:00',2.88),('8537','2014-03-22','15:20:00',2.94),('8537','2014-03-22','15:25:00',2.45),('8537','2014-03-22','15:30:00',1.55),('8537','2014-03-22','15:35:00',1.91),('8537','2014-03-22','15:40:00',2.05),('8537','2014-03-22','15:45:00',1.89),('8537','2014-03-22','15:50:00',2.37),('8537','2014-03-22','15:55:00',2.24),('8537','2014-03-22','16:00:00',2.1),('8537','2014-03-22','16:05:00',2.15),('8537','2014-03-22','16:10:00',1.98),('8537','2014-03-22','16:15:00',1.5),('8537','2014-03-22','16:20:00',1.34),('8537','2014-03-22','16:25:00',1.1),('8537','2013-02-10','09:45:00',1.68),('8537','2013-02-10','09:50:00',2.24),('8537','2013-02-10','09:55:00',1.74),('8537','2013-02-10','10:00:00',3.1),('8537','2013-02-10','10:05:00',3.58),('8537','2013-02-10','10:10:00',3.56),('8537','2013-02-10','10:15:00',3.71),('8537','2013-02-10','10:20:00',3.75),('8537','2013-02-10','10:25:00',3.82),('8537','2013-02-10','10:30:00',3.89),('8537','2013-02-10','10:35:00',3.94),('8537','2013-02-10','10:40:00',3.98),('8537','2013-02-10','10:45:00',4.05),('8537','2013-02-10','10:50:00',4.09),('8537','2013-02-10','10:55:00',4.12),('8537','2013-02-10','11:00:00',4.18),('8537','2013-02-10','11:05:00',4.22),('8537','2013-02-10','11:10:00',4.25),('8537','2013-02-10','11:15:00',4.27),('8537','2013-02-10','11:20:00',4.29),('8537','2013-02-10','11:25:00',4.31),('8537','2013-02-10','11:30:00',4.35),('8537','2013-02-10','11:35:00',4.37),('8537','2013-02-10','11:40:00',4.39),('8537','2013-02-10','11:45:00',4.37),('8537','2013-02-10','11:50:00',4.44),('8537','2013-02-10','11:55:00',4.48),('8537','2013-02-10','12:00:00',4.51),('8537','2013-02-10','12:05:00',4.49),('8537','2013-02-10','12:10:00',4.52),('8537','2013-02-10','12:15:00',4.54),('8537','2013-02-10','12:20:00',4.54),('8537','2013-02-10','12:25:00',4.53),('8537','2013-02-10','12:30:00',4.54),('8537','2013-02-10','12:35:00',4.51),('8537','2013-02-10','12:40:00',4.46),('8537','2013-02-10','12:45:00',4.44),('8537','2013-02-10','12:50:00',4.46),('8537','2013-02-10','12:55:00',4.42),('8537','2013-02-10','13:00:00',4.35),('8537','2013-02-10','13:05:00',4.28),('8537','2013-02-10','13:10:00',4.26),('8537','2013-02-10','13:15:00',4.26),('8537','2013-02-10','13:20:00',4.23),('8537','2013-02-10','13:25:00',4.18),('8537','2013-02-10','13:30:00',4.17),('8537','2013-02-10','13:35:00',4.09),('8537','2013-02-10','13:40:00',4.02),('8537','2013-02-10','13:45:00',3.96),('8537','2013-02-10','13:50:00',3.94),('8537','2013-02-10','13:55:00',3.86),('8537','2013-02-10','14:00:00',3.76),('8537','2013-02-10','14:05:00',3.7),('8537','2013-02-10','14:10:00',3.64),('8537','2013-02-10','14:15:00',3.6),('8537','2013-02-10','14:20:00',3.56),('8537','2013-02-10','14:25:00',3.38),('8537','2013-02-10','14:30:00',3.26),('8537','2013-02-10','14:35:00',2.92),('8537','2013-02-10','14:40:00',3),('8537','2013-02-10','14:45:00',3.08),('8537','2013-02-10','14:50:00',3.07),('8537','2013-02-10','14:55:00',2.95),('8537','2013-02-10','15:00:00',1.84),('8537','2013-02-10','15:05:00',1.74),('8537','2013-02-10','15:10:00',2.37),('8537','2013-02-10','15:15:00',1.67),('8537','2013-02-10','15:20:00',1.37),('8537','2013-02-10','15:25:00',2.55),('8537','2013-02-10','15:30:00',1.82),('8537','2013-02-10','15:35:00',2.17),('8537','2013-02-10','15:40:00',1.16),('8537','2013-02-09','09:35:00',1.05),('8537','2013-02-09','10:50:00',1.01),('8537','2013-02-09','10:55:00',1.09),('8537','2013-02-09','11:00:00',1.16),('8537','2013-02-09','11:05:00',1.2),('8537','2013-02-09','11:10:00',1.24),('8537','2013-02-09','11:15:00',1.3),('8537','2013-02-09','11:20:00',1.34),('8537','2013-02-09','11:25:00',1.36),('8537','2013-02-09','11:30:00',1.35),('8537','2013-02-09','11:35:00',1.35),('8537','2013-02-09','11:40:00',1.31),('8537','2013-02-09','11:45:00',1.34),('8537','2013-02-09','11:50:00',1.33),('8537','2013-02-09','11:55:00',1.29),('8537','2013-02-09','12:00:00',1.3),('8537','2013-02-09','12:05:00',1.3),('8537','2013-02-09','12:10:00',1.28),('8537','2013-02-09','12:15:00',1.28),('8537','2013-02-09','12:20:00',1.31),('8537','2013-02-09','12:25:00',1.31),('8537','2013-02-09','12:30:00',1.34),('8537','2013-02-09','12:35:00',1.42),('8537','2013-02-09','12:40:00',1.45),('8537','2013-02-09','12:45:00',1.45),('8537','2013-02-09','12:50:00',1.48),('8537','2013-02-09','12:55:00',1.46),('8537','2013-02-09','13:00:00',1.56),('8537','2013-02-09','13:05:00',1.8),('8537','2013-02-09','13:10:00',2.03),('8537','2013-02-09','13:15:00',2.24),('8537','2013-02-09','13:20:00',2.5),('8537','2013-02-09','13:25:00',2.67),('8537','2013-02-09','13:30:00',3.17),('8537','2013-02-09','13:35:00',3.19),('8537','2013-02-09','13:40:00',3.39),('8537','2013-02-09','13:45:00',3.64),('8537','2013-02-09','13:50:00',3.91),('8537','2013-02-09','13:55:00',3.81),('8537','2013-02-09','14:00:00',3.91),('8537','2013-02-09','14:05:00',3.65),('8537','2013-02-09','14:10:00',2.79),('8537','2013-02-09','14:15:00',3.71),('8537','2013-02-09','14:20:00',4.02),('8537','2013-02-09','14:25:00',4.26),('8537','2013-02-09','14:30:00',3.73),('8537','2013-02-09','14:35:00',3.52),('8537','2013-02-09','14:40:00',3.21),('8537','2013-02-09','14:45:00',3.02),('8537','2013-02-09','14:50:00',2.96),('8537','2013-02-09','14:55:00',3.02),('8537','2013-02-09','15:00:00',2.88),('8537','2013-02-09','15:05:00',2.71),('8537','2013-02-09','15:10:00',2.63),('8537','2013-02-09','15:15:00',2.48),('8537','2013-02-09','15:20:00',2.38),('8537','2013-02-09','15:25:00',2.09),('8537','2013-02-09','15:30:00',2.13),('8537','2013-02-09','15:35:00',1.99),('8537','2013-02-09','15:40:00',1.81),('8537','2013-02-09','15:45:00',1.31),('8537','2013-02-09','15:50:00',1.54),('8537','2013-02-09','15:55:00',1.41),('8537','2013-02-08','09:30:00',1.03),('8537','2013-02-08','09:35:00',2.49),('8537','2013-02-08','09:40:00',3.2),('8537','2013-02-08','09:45:00',3.45),('8537','2013-02-08','09:50:00',3.81),('8537','2013-02-08','09:55:00',3.76),('8537','2013-02-08','10:00:00',3.95),('8537','2013-02-08','10:05:00',4.2),('8537','2013-02-08','10:10:00',4.25),('8537','2013-02-08','10:15:00',4.35),('8537','2013-02-08','10:20:00',3.6),('8537','2013-02-08','10:25:00',3.89),('8537','2013-02-08','10:30:00',4.24),('8537','2013-02-08','10:35:00',1.72),('8537','2013-02-08','10:40:00',3.99),('8537','2013-02-08','10:45:00',4.03),('8537','2013-02-08','10:50:00',4.53),('8537','2013-02-08','10:55:00',4.48),('8537','2013-02-08','11:00:00',4.36),('8537','2013-02-08','11:05:00',4.21),('8537','2013-02-08','11:10:00',4.34),('8537','2013-02-08','11:15:00',4.33),('8537','2013-02-08','11:20:00',4.35),('8537','2013-02-08','11:25:00',4.37),('8537','2013-02-08','11:30:00',4.37),('8537','2013-02-08','11:35:00',4.37),('8537','2013-02-08','11:40:00',4.4),('8537','2013-02-08','11:45:00',4.41),('8537','2013-02-08','11:50:00',4.43),('8537','2013-02-08','11:55:00',4.42),('8537','2013-02-08','12:00:00',4.43),('8537','2013-02-08','12:05:00',4.44),('8537','2013-02-08','12:10:00',4.45),('8537','2013-02-08','12:15:00',4.46),('8537','2013-02-08','12:20:00',4.46),('8537','2013-02-08','12:25:00',4.45),('8537','2013-02-08','12:30:00',4.47),('8537','2013-02-08','12:35:00',4.49),('8537','2013-02-08','12:40:00',4.59),('8537','2013-02-08','12:45:00',4.72),('8537','2013-02-08','12:50:00',3.48),('8537','2013-02-08','12:55:00',2.51),('8537','2013-02-08','13:00:00',2.37),('8537','2013-02-08','13:05:00',2.12),('8537','2013-02-08','13:10:00',2.36),('8537','2013-02-08','13:15:00',2.22),('8537','2013-02-08','13:20:00',2.33),('8537','2013-02-08','13:25:00',2.2),('8537','2013-02-08','13:30:00',2.18),('8537','2013-02-08','13:35:00',3.02),('8537','2013-02-08','13:40:00',2.31),('8537','2013-02-08','13:45:00',1.82),('8537','2013-02-08','13:50:00',1.9),('8537','2013-02-08','13:55:00',1.91),('8537','2013-02-08','14:00:00',1.77),('8537','2013-02-08','14:05:00',1.74),('8537','2013-02-08','14:10:00',1.58),('8537','2013-02-08','14:15:00',1.43),('8537','2013-02-08','14:20:00',1.44),('8537','2013-02-08','14:25:00',1.6),('8537','2013-02-08','14:30:00',2.47),('8537','2013-02-08','14:35:00',2.23),('8537','2013-02-08','14:40:00',4.1),('8537','2013-02-08','14:45:00',3.55),('8537','2013-02-08','14:50:00',2.64),('8537','2013-02-08','14:55:00',3.49),('8537','2013-02-08','15:00:00',3.1),('8537','2013-02-08','15:05:00',3.73),('8537','2013-02-08','15:10:00',3.62),('8537','2013-02-08','15:15:00',3.1),('8537','2013-02-08','15:20:00',2.11),('8537','2013-02-08','15:25:00',2.61),('8537','2013-02-08','15:30:00',2.26),('8537','2013-02-08','15:35:00',2.12),('8537','2013-02-08','15:40:00',2.03),('8537','2013-02-08','15:45:00',1.87),('8537','2013-02-08','15:50:00',1.66),('8537','2013-02-08','15:55:00',1.5),('8537','2013-02-08','16:00:00',1.33),('8537','2013-02-08','16:05:00',1.2),('8537','2013-02-08','16:10:00',1.16),('8537','2013-02-07','10:35:00',1.08),('8537','2013-02-07','10:40:00',1.44),('8537','2013-02-07','10:45:00',1.71),('8537','2013-02-07','10:55:00',1.58),('8537','2013-02-07','11:00:00',2.15),('8537','2013-02-07','11:05:00',1.5),('8537','2013-02-07','11:10:00',1),('8537','2013-02-07','12:25:00',3.59),('8537','2013-02-07','12:30:00',2.52),('8537','2013-02-07','12:35:00',1.2),('8537','2013-02-07','13:15:00',1.52),('8537','2013-02-07','13:20:00',1.75),('8537','2013-02-07','13:25:00',1.63),('8537','2013-02-07','13:30:00',1.2),('8537','2013-02-07','13:40:00',1.03),('8537','2013-02-07','13:45:00',1.03),('8537','2013-02-07','13:50:00',1.06),('8537','2013-02-07','13:55:00',1.24),('8537','2013-02-07','14:00:00',1.53),('8537','2013-02-07','14:05:00',2.24),('8537','2013-02-07','14:10:00',3.71),('8537','2013-02-07','14:15:00',3.32),('8537','2013-02-07','14:20:00',2.99),('8537','2013-02-07','14:25:00',1.33),('8537','2013-02-07','14:30:00',1.09),('8537','2013-02-07','14:35:00',2),('8537','2013-02-07','14:40:00',2.07),('8537','2013-02-07','14:45:00',2.09),('8537','2013-02-07','14:50:00',1.6),('8537','2013-02-07','14:55:00',1.6),('8537','2013-02-07','15:00:00',2.37),('8537','2013-02-07','15:05:00',2.97),('8537','2013-02-07','15:10:00',3.11),('8537','2013-02-07','15:15:00',2.64),('8537','2013-02-07','15:20:00',1.23),('8537','2013-02-07','15:25:00',2.23),('8537','2013-02-07','15:35:00',1.14),('8537','2013-02-06','08:40:00',1.01),('8537','2013-02-06','08:45:00',1.23),('8537','2013-02-06','08:50:00',1.64),('8537','2013-02-06','08:55:00',1.23),('8537','2013-02-06','09:00:00',1.39),('8537','2013-02-06','09:05:00',1.54),('8537','2013-02-06','09:10:00',1.97),('8537','2013-02-06','09:15:00',1.19),('8537','2013-02-06','09:20:00',1.21),('8537','2013-02-06','09:25:00',1.35),('8537','2013-02-06','09:30:00',1.9),('8537','2013-02-06','09:35:00',1.36),('8537','2013-02-06','09:40:00',2.09),('8537','2013-02-06','09:45:00',1.47),('8537','2013-02-06','09:50:00',1.49),('8537','2013-02-06','09:55:00',1.96),('8537','2013-02-06','10:00:00',1.58),('8537','2013-02-06','10:05:00',2.18),('8537','2013-02-06','10:10:00',1.81),('8537','2013-02-06','10:15:00',1.61),('8537','2013-02-06','10:20:00',1.45),('8537','2013-02-06','10:25:00',1.95),('8537','2013-02-06','10:30:00',1.74),('8537','2013-02-06','10:35:00',2.4),('8537','2013-02-06','10:40:00',1.67),('8537','2013-02-06','10:45:00',1.28),('8537','2013-02-06','10:50:00',2.19),('8537','2013-02-06','10:55:00',2.73),('8537','2013-02-06','11:00:00',2.17),('8537','2013-02-06','11:05:00',1.62),('8537','2013-02-06','11:10:00',1.91),('8537','2013-02-06','11:15:00',1.67),('8537','2013-02-06','11:20:00',2.15),('8537','2013-02-06','11:25:00',3.24),('8537','2013-02-06','11:30:00',2.05),('8537','2013-02-06','11:35:00',1.76),('8537','2013-02-06','11:40:00',1.91),('8537','2013-02-06','11:45:00',1.93),('8537','2013-02-06','11:50:00',1.98),('8537','2013-02-06','11:55:00',1.81),('8537','2013-02-06','12:00:00',1.57),('8537','2013-02-06','12:05:00',1.31),('8537','2013-02-06','12:15:00',1.23),('8537','2013-02-06','12:20:00',1.2),('8537','2013-02-06','12:25:00',1.16),('8537','2013-02-06','13:20:00',1.01),('8537','2013-02-06','13:25:00',1.12),('8537','2013-02-06','13:30:00',1.34),('8537','2013-02-06','13:35:00',1.46),('8537','2013-02-06','13:40:00',1.25),('8537','2013-02-06','13:45:00',1.14),('8537','2013-02-06','13:50:00',1.93),('8537','2013-02-06','13:55:00',1.51),('8537','2013-02-06','14:00:00',1.72),('8537','2013-02-06','14:05:00',1.52),('8537','2013-02-06','14:30:00',2.03),('8537','2013-02-06','14:35:00',2.84),('8537','2013-02-06','14:40:00',1.61),('8537','2013-02-06','15:25:00',1.12),('8537','2013-02-05','08:20:00',1.02),('8537','2013-02-05','08:25:00',1.13),('8537','2013-02-05','08:30:00',1.23),('8537','2013-02-05','08:35:00',1.34),('8537','2013-02-05','08:40:00',1.44),('8537','2013-02-05','08:45:00',1.53),('8537','2013-02-05','08:50:00',1.64),('8537','2013-02-05','08:55:00',1.76),('8537','2013-02-05','09:00:00',1.88),('8537','2013-02-05','09:05:00',2),('8537','2013-02-05','09:10:00',2.17),('8537','2013-02-05','09:15:00',2.34),('8537','2013-02-05','09:20:00',2.47),('8537','2013-02-05','09:25:00',2.57),('8537','2013-02-05','09:30:00',2.65),('8537','2013-02-05','09:35:00',2.73),('8537','2013-02-05','09:40:00',2.83),('8537','2013-02-05','09:45:00',2.91),('8537','2013-02-05','09:50:00',2.99),('8537','2013-02-05','09:55:00',3.07),('8537','2013-02-05','10:00:00',3.07),('8537','2013-02-05','10:05:00',3.15),('8537','2013-02-05','10:10:00',2.98),('8537','2013-02-05','10:15:00',3.04),('8537','2013-02-05','10:20:00',3.35),('8537','2013-02-05','10:25:00',3.45),('8537','2013-02-05','10:30:00',3.5),('8537','2013-02-05','10:35:00',3.5),('8537','2013-02-05','10:40:00',3.56),('8537','2013-02-05','10:45:00',3.6),('8537','2013-02-05','10:50:00',3.6),('8537','2013-02-05','10:55:00',3.63),('8537','2013-02-05','11:00:00',3.66),('8537','2013-02-05','11:05:00',3.7),('8537','2013-02-05','11:10:00',3.81),('8537','2013-02-05','11:15:00',3.83),('8537','2013-02-05','11:20:00',3.8),('8537','2013-02-05','11:25:00',3.82),('8537','2013-02-05','11:30:00',3.84),('8537','2013-02-05','11:35:00',3.6),('8537','2013-02-05','11:40:00',3.22),('8537','2013-02-05','11:45:00',2.54),('8537','2013-02-05','11:50:00',2.09),('8537','2013-02-05','11:55:00',1.73),('8537','2013-02-05','12:00:00',1.4),('8537','2013-02-05','12:05:00',1.75),('8537','2013-02-05','12:10:00',2.18),('8537','2013-02-05','12:15:00',1.93),('8537','2013-02-05','12:20:00',1.42),('8537','2013-02-05','12:25:00',1.32),('8537','2013-02-05','12:30:00',1.31),('8537','2013-02-05','12:35:00',1.53),('8537','2013-02-05','12:40:00',2.23),('8537','2013-02-05','12:45:00',2.29),('8537','2013-02-05','12:50:00',2.93),('8537','2013-02-05','12:55:00',1.1),('8537','2013-02-05','13:10:00',1.13),('8537','2013-02-05','13:15:00',1.48),('8537','2013-02-05','13:20:00',1.49),('8537','2013-02-05','13:25:00',1.41),('8537','2013-02-05','13:30:00',1.46),('8537','2013-02-05','13:35:00',1.09),('8537','2013-02-05','13:40:00',1.06),('8537','2013-02-05','13:45:00',1.46),('8537','2013-02-05','13:50:00',1.55),('8537','2013-02-05','13:55:00',1.33),('8537','2013-02-05','14:00:00',1.3),('8537','2013-02-05','14:05:00',1.36),('8537','2013-02-05','14:10:00',1.07),('8537','2013-02-05','14:15:00',1.18),('8537','2013-02-05','14:20:00',1.28),('8537','2013-02-05','14:25:00',1.85),('8537','2013-02-05','14:30:00',2.21),('8537','2013-02-05','14:35:00',1.66),('8537','2013-02-05','14:40:00',2.25),('8537','2013-02-05','14:45:00',1.56),('8537','2013-02-05','14:50:00',1.14),('8537','2013-02-05','15:05:00',1.2),('8537','2013-02-04','08:20:00',1.07),('8537','2013-02-04','08:25:00',1.16),('8537','2013-02-04','08:30:00',1.29),('8537','2013-02-04','08:35:00',1.4),('8537','2013-02-04','08:40:00',1.51),('8537','2013-02-04','08:45:00',1.61),('8537','2013-02-04','08:50:00',1.71),('8537','2013-02-04','08:55:00',1.58),('8537','2013-02-04','09:00:00',1.97),('8537','2013-02-04','09:05:00',2.18),('8537','2013-02-04','09:10:00',2.38),('8537','2013-02-04','09:15:00',2.52),('8537','2013-02-04','09:20:00',2.55),('8537','2013-02-04','09:25:00',2.55),('8537','2013-02-04','09:30:00',2.8),('8537','2013-02-04','09:35:00',2.81),('8537','2013-02-04','09:40:00',2.84),('8537','2013-02-04','09:45:00',2.58),('8537','2013-02-04','09:50:00',3.07),('8537','2013-02-04','09:55:00',3.33),('8537','2013-02-04','10:00:00',3.42),('8537','2013-02-04','10:05:00',3.49),('8537','2013-02-04','10:10:00',3.6),('8537','2013-02-04','10:15:00',3.72),('8537','2013-02-04','10:20:00',3.54),('8537','2013-02-04','10:25:00',3.69),('8537','2013-02-04','10:30:00',3.52),('8537','2013-02-04','10:35:00',3.34),('8537','2013-02-04','10:40:00',3.56),('8537','2013-02-04','10:45:00',3.88),('8537','2013-02-04','10:50:00',3.93),('8537','2013-02-04','10:55:00',3.94),('8537','2013-02-04','11:00:00',3.97),('8537','2013-02-04','11:05:00',4.04),('8537','2013-02-04','11:10:00',4.09),('8537','2013-02-04','11:15:00',4.12),('8537','2013-02-04','11:20:00',4.14),('8537','2013-02-04','11:25:00',4.16),('8537','2013-02-04','11:30:00',4.16),('8537','2013-02-04','11:35:00',4.19),('8537','2013-02-04','11:40:00',4.21),('8537','2013-02-04','11:45:00',4.22),('8537','2013-02-04','11:50:00',4.26),('8537','2013-02-04','11:55:00',4.24),('8537','2013-02-04','12:00:00',4.23),('8537','2013-02-04','12:05:00',4.29),('8537','2013-02-04','12:10:00',4.3),('8537','2013-02-04','12:15:00',4.27),('8537','2013-02-04','12:20:00',4.26),('8537','2013-02-04','12:25:00',4.24),('8537','2013-02-04','12:30:00',4.23),('8537','2013-02-04','12:35:00',4.23),('8537','2013-02-04','12:40:00',4.19),('8537','2013-02-04','12:45:00',4.17),('8537','2013-02-04','12:50:00',4.12),('8537','2013-02-04','12:55:00',4.13),('8537','2013-02-04','13:00:00',4.16),('8537','2013-02-04','13:05:00',4.14),('8537','2013-02-04','13:10:00',4.11),('8537','2013-02-04','13:15:00',4.09),('8537','2013-02-04','13:20:00',4.05),('8537','2013-02-04','13:25:00',4.02),('8537','2013-02-04','13:30:00',3.97),('8537','2013-02-04','13:35:00',3.93),('8537','2013-02-04','13:40:00',3.89),('8537','2013-02-04','13:45:00',3.87),('8537','2013-02-04','13:50:00',3.83),('8537','2013-02-04','13:55:00',3.79),('8537','2013-02-04','14:00:00',3.74),('8537','2013-02-04','14:05:00',3.68),('8537','2013-02-04','14:10:00',3.62),('8537','2013-02-04','14:15:00',3.55),('8537','2013-02-04','14:20:00',3.5),('8537','2013-02-04','14:25:00',3.41),('8537','2013-02-04','14:30:00',3.28),('8537','2013-02-04','14:35:00',3.03),('8537','2013-02-04','14:40:00',2.8),('8537','2013-02-04','14:45:00',3.08),('8537','2013-02-04','14:50:00',3),('8537','2013-02-04','14:55:00',2.9),('8537','2013-02-04','15:00:00',2.82),('8537','2013-02-04','15:05:00',2.72),('8537','2013-02-04','15:10:00',2.63),('8537','2013-02-04','15:15:00',2.49),('8537','2013-02-04','15:20:00',2.34),('8537','2013-02-04','15:25:00',2.2),('8537','2013-02-04','15:30:00',2.04),('8537','2013-02-04','15:35:00',1.85),('8537','2013-02-04','15:40:00',1.66),('8537','2013-02-04','15:45:00',1.52),('8537','2013-02-04','15:50:00',1.28),('8537','2013-02-04','15:55:00',1.16),('8537','2013-02-04','16:00:00',1.25),('8537','2013-02-04','16:05:00',1.18),('8537','2013-02-04','16:10:00',1.06),('8537','2013-02-03','09:20:00',1.15),('8537','2013-02-03','09:25:00',1.44),('8537','2013-02-03','09:30:00',1.12),('8537','2013-02-03','09:40:00',1.57),('8537','2013-02-03','09:45:00',2.09),('8537','2013-02-03','09:50:00',2.11),('8537','2013-02-03','09:55:00',1.64),('8537','2013-02-03','10:00:00',2.26),('8537','2013-02-03','10:05:00',1.21),('8537','2013-02-03','10:20:00',1.16),('8537','2013-02-03','11:20:00',1.56),('8537','2013-02-03','11:50:00',1.09),('8537','2013-02-03','11:55:00',1.35),('8537','2013-02-03','12:00:00',1.39),('8537','2013-02-03','12:05:00',1.34),('8537','2013-02-03','12:10:00',1.27),('8537','2013-02-02','10:15:00',1.17),('8537','2013-02-02','10:20:00',1.24),('8537','2013-02-02','10:25:00',1.23),('8537','2013-02-02','10:30:00',1.36),('8537','2013-02-02','10:35:00',1.54),('8537','2013-02-02','10:40:00',1.71),('8537','2013-02-02','10:45:00',1.81),('8537','2013-02-02','10:50:00',1.48),('8537','2013-02-02','10:55:00',2.09),('8537','2013-02-02','11:00:00',2.45),('8537','2013-02-02','11:05:00',2.21),('8537','2013-02-02','11:10:00',2.36),('8537','2013-02-02','11:15:00',2.38),('8537','2013-02-02','11:20:00',2.33),('8537','2013-02-02','11:25:00',2.68),('8537','2013-02-02','11:30:00',2.44),('8537','2013-02-02','11:35:00',2.11),('8537','2013-02-02','11:40:00',2.05),('8537','2013-02-02','11:45:00',1.37),('8537','2013-02-02','11:50:00',1.22),('8537','2013-02-02','11:55:00',1.35),('8537','2013-02-02','12:00:00',1.03),('8537','2013-02-02','12:55:00',2.82),('8537','2013-02-02','13:00:00',2.14),('8537','2013-02-02','13:05:00',2.38),('8537','2013-02-02','13:10:00',2.25),('8537','2013-02-02','13:15:00',2.67),('8537','2013-02-02','13:20:00',2.07),('8537','2013-02-02','13:25:00',2.08),('8537','2013-02-02','13:30:00',1.48),('8537','2013-02-02','13:35:00',2.58),('8537','2013-02-02','13:40:00',3.11),('8537','2013-02-02','13:45:00',2.46),('8537','2013-02-02','13:50:00',2.39),('8537','2013-02-02','13:55:00',1.42),('8537','2013-02-01','08:35:00',1.11),('8537','2013-02-01','08:40:00',1.16),('8537','2013-02-01','08:45:00',1.28),('8537','2013-02-01','08:55:00',1.06),('8537','2013-02-01','09:00:00',1.5),('8537','2013-02-01','09:05:00',1.83),('8537','2013-02-01','09:10:00',2.07),('8537','2013-02-01','09:25:00',2.16),('8537','2013-02-01','09:35:00',1.63),('8537','2013-02-01','09:40:00',2.08),('8537','2013-02-01','09:45:00',1.78),('8537','2013-02-01','09:50:00',1.17),('8537','2013-02-01','09:55:00',1.19),('8537','2013-02-01','10:00:00',1.69),('8537','2013-02-01','10:05:00',1.12),('8537','2013-02-01','10:10:00',1.27),('8537','2013-02-01','10:15:00',1.41),('8537','2013-02-01','10:20:00',2.07),('8537','2013-02-01','10:25:00',1.63),('8537','2013-02-01','10:30:00',1.95),('8537','2013-02-01','10:35:00',1.8),('8537','2013-02-01','10:45:00',1.25),('8537','2013-02-01','10:50:00',3.6),('8537','2013-02-01','10:55:00',3.24),('8537','2013-02-01','11:00:00',3.88),('8537','2013-02-01','11:05:00',3.36),('8537','2013-02-01','11:10:00',3.54),('8537','2013-02-01','11:15:00',2.43),('8537','2013-02-01','11:20:00',3.88),('8537','2013-02-01','11:25:00',2.21),('8537','2013-02-01','11:30:00',1.39),('8537','2013-02-01','11:35:00',2.98),('8537','2013-02-01','11:40:00',4.52),('8537','2013-02-01','11:45:00',2.08),('8537','2013-02-01','11:50:00',1.78),('8537','2013-02-01','11:55:00',1.37),('8537','2013-02-01','12:00:00',1.53),('8537','2013-02-01','12:05:00',2.3),('8537','2013-02-01','12:10:00',2.12),('8537','2013-02-01','12:15:00',2.69),('8537','2013-02-01','12:20:00',4.7),('8537','2013-02-01','12:25:00',3.37),('8537','2013-02-01','12:30:00',1.08),('8537','2013-02-01','12:35:00',1.91),('8537','2013-02-01','12:40:00',3.13),('8537','2013-02-01','12:45:00',4.01),('8537','2013-02-01','12:50:00',4.23),('8537','2013-02-01','12:55:00',4.38),('8537','2013-02-01','13:00:00',3.12),('8537','2013-02-01','13:05:00',3.51),('8537','2013-02-01','13:10:00',3.89),('8537','2013-02-01','13:15:00',3.74),('8537','2013-02-01','13:20:00',3.61),('8537','2013-02-01','13:25:00',2.8),('8537','2013-02-01','13:30:00',3.05),('8537','2013-02-01','13:35:00',2.8),('8537','2013-02-01','13:40:00',2.9),('8537','2013-02-01','13:45:00',2.55),('8537','2013-02-01','13:50:00',2.4),('8537','2013-02-01','13:55:00',1.3),('8537','2013-02-01','14:05:00',1),('8537','2013-02-01','14:10:00',1.29),('8537','2013-02-01','14:15:00',2.45),('8537','2013-02-01','14:20:00',3.57),('8537','2013-02-01','14:25:00',3.15),('8537','2013-02-01','14:30:00',3.1),('8537','2013-02-01','14:35:00',3.02),('8537','2013-02-01','14:40:00',2.67),('8537','2013-02-01','14:45:00',1.14),('8537','2013-02-01','14:55:00',1.01),('8537','2013-02-01','15:00:00',1.57),('8537','2013-02-01','15:05:00',2.73),('8537','2013-02-01','15:10:00',2.71),('8537','2013-02-01','15:15:00',1.68),('8537','2013-02-01','15:20:00',1.68),('8537','2013-02-01','15:30:00',1.11),('8537','2013-02-01','15:40:00',1.08),('8537','2014-03-21','07:35:00',1.08),('8537','2014-03-21','07:40:00',1.22),('8537','2014-03-21','07:45:00',1.37),('8537','2014-03-21','07:50:00',1.51),('8537','2014-03-21','07:55:00',1.64),('8537','2014-03-21','08:00:00',1.73),('8537','2014-03-21','08:05:00',1.8),('8537','2014-03-21','08:10:00',1.92),('8537','2014-03-21','08:15:00',2.05),('8537','2014-03-21','08:20:00',2.16),('8537','2014-03-21','08:25:00',2.29),('8537','2014-03-21','08:30:00',2.41),('8537','2014-03-21','08:35:00',2.52),('8537','2014-03-21','08:40:00',2.59),('8537','2014-03-21','08:45:00',2.68),('8537','2014-03-21','08:50:00',2.79),('8537','2014-03-21','08:55:00',2.91),('8537','2014-03-21','09:00:00',2.97),('8537','2014-03-21','09:05:00',3.05),('8537','2014-03-21','09:10:00',3.18),('8537','2014-03-21','09:15:00',3.25),('8537','2014-03-21','09:20:00',3.37),('8537','2014-03-21','09:25:00',3.29),('8537','2014-03-21','09:30:00',3.46),('8537','2014-03-21','09:35:00',3.51),('8537','2014-03-21','09:40:00',3.57),('8537','2014-03-21','09:45:00',3.66),('8537','2014-03-21','09:50:00',3.77),('8537','2014-03-21','09:55:00',3.82),('8537','2014-03-21','10:00:00',3.84),('8537','2014-03-21','10:05:00',3.88),('8537','2014-03-21','10:10:00',3.92),('8537','2014-03-21','10:15:00',4),('8537','2014-03-21','10:20:00',4.04),('8537','2014-03-21','10:25:00',4.16),('8537','2014-03-21','10:30:00',4.18),('8537','2014-03-21','10:35:00',4.16),('8537','2014-03-21','10:40:00',4.23),('8537','2014-03-21','10:45:00',4.21),('8537','2014-03-21','10:50:00',4.22),('8537','2014-03-21','10:55:00',4.23),('8537','2014-03-21','11:00:00',4.26),('8537','2014-03-21','11:05:00',4.26),('8537','2014-03-21','11:10:00',4.23),('8537','2014-03-21','11:15:00',4.17),('8537','2014-03-21','11:20:00',4.3),('8537','2014-03-21','11:25:00',4.42),('8537','2014-03-21','11:30:00',3.05),('8537','2014-03-21','11:35:00',2.43),('8537','2014-03-21','11:40:00',3.11),('8537','2014-03-21','11:45:00',2.54),('8537','2014-03-21','11:50:00',4.63),('8537','2014-03-21','11:55:00',4.57),('8537','2014-03-21','12:00:00',3.97),('8537','2014-03-21','12:05:00',4.58),('8537','2014-03-21','12:10:00',4.72),('8537','2014-03-21','12:15:00',4.82),('8537','2014-03-21','12:20:00',4.68),('8537','2014-03-21','12:25:00',4.61),('8537','2014-03-21','12:30:00',4.55),('8537','2014-03-21','12:35:00',4.54),('8537','2014-03-21','12:40:00',4.6),('8537','2014-03-21','12:45:00',4.61),('8537','2014-03-21','12:50:00',4.56),('8537','2014-03-21','12:55:00',4.53),('8537','2014-03-21','13:00:00',4.5),('8537','2014-03-21','13:05:00',4.53),('8537','2014-03-21','13:10:00',4.49),('8537','2014-03-21','13:15:00',4.47),('8537','2014-03-21','13:20:00',4.46),('8537','2014-03-21','13:25:00',4.41),('8537','2014-03-21','13:30:00',4.36),('8537','2014-03-21','13:35:00',4.24),('8537','2014-03-21','13:40:00',4.21),('8537','2014-03-21','13:45:00',4.19),('8537','2014-03-21','13:50:00',4.15),('8537','2014-03-21','13:55:00',4.08),('8537','2014-03-21','14:00:00',4.08),('8537','2014-03-21','14:05:00',4.08),('8537','2014-03-21','14:10:00',4.01),('8537','2014-03-21','14:15:00',3.99),('8537','2014-03-21','14:20:00',3.81),('8537','2014-03-21','14:25:00',3.7),('8537','2014-03-21','14:30:00',3.6),('8537','2014-03-21','14:35:00',3.47),('8537','2014-03-21','14:40:00',3.54),('8537','2014-03-21','14:45:00',3.44),('8537','2014-03-21','14:50:00',2.82),('8537','2014-03-21','14:55:00',1.56),('8537','2014-03-21','15:05:00',1.89),('8537','2014-03-21','15:10:00',3.5),('8537','2014-03-21','15:15:00',3.61),('8537','2014-03-21','15:20:00',3.32),('8537','2014-03-21','15:25:00',3.26),('8537','2014-03-21','15:30:00',3.33),('8537','2014-03-21','15:35:00',3),('8537','2014-03-21','15:40:00',3.05),('8537','2014-03-21','15:45:00',2.97),('8537','2014-03-21','15:50:00',2.83),('8537','2014-03-21','15:55:00',2.64),('8537','2014-03-21','16:00:00',2.53),('8537','2014-03-21','16:05:00',2.3),('8537','2014-03-21','16:10:00',2.15),('8537','2014-03-21','16:15:00',1.96),('8537','2014-03-21','16:20:00',1.76),('8537','2014-03-21','16:25:00',1.62),('8537','2014-03-21','16:30:00',1.52),('8537','2014-03-21','16:35:00',1.4),('8537','2014-03-21','16:40:00',1.28),('8537','2014-03-21','16:45:00',1.18),('8537','2014-03-21','16:50:00',1.08),('8537','2013-01-31','09:10:00',1.14),('8537','2013-01-31','09:20:00',1.14),('8537','2013-01-31','09:25:00',1.96),('8537','2013-01-31','09:30:00',2.69),('8537','2013-01-31','09:35:00',2.5),('8537','2013-01-31','09:40:00',2.57),('8537','2013-01-31','09:45:00',2.61),('8537','2013-01-31','09:50:00',2.68),('8537','2013-01-31','09:55:00',2.97),('8537','2013-01-31','10:00:00',2.9),('8537','2013-01-31','10:05:00',2.96),('8537','2013-01-31','10:10:00',3.02),('8537','2013-01-31','10:15:00',3.03),('8537','2013-01-31','10:20:00',2.98),('8537','2013-01-31','10:25:00',3.25),('8537','2013-01-31','10:30:00',3.42),('8537','2013-01-31','10:35:00',3.06),('8537','2013-01-31','10:40:00',3.57),('8537','2013-01-31','10:45:00',3.82),('8537','2013-01-31','10:50:00',3.49),('8537','2013-01-31','10:55:00',3),('8537','2013-01-31','11:00:00',1.13),('8537','2013-01-31','11:05:00',3.49),('8537','2013-01-31','11:10:00',4.14),('8537','2013-01-31','11:15:00',4.11),('8537','2013-01-31','11:20:00',4.2),('8537','2013-01-31','11:25:00',4.09),('8537','2013-01-31','11:30:00',3.87),('8537','2013-01-31','11:35:00',3.61),('8537','2013-01-31','11:40:00',3.87),('8537','2013-01-31','11:45:00',3.89),('8537','2013-01-31','11:50:00',3.81),('8537','2013-01-31','11:55:00',3.82),('8537','2013-01-31','12:00:00',3.84),('8537','2013-01-31','12:05:00',3.91),('8537','2013-01-31','12:10:00',3.92),('8537','2013-01-31','12:15:00',3.87),('8537','2013-01-31','12:20:00',3.89),('8537','2013-01-31','12:25:00',3.82),('8537','2013-01-31','12:30:00',3.87),('8537','2013-01-31','12:35:00',3.9),('8537','2013-01-31','12:40:00',3.84),('8537','2013-01-31','12:45:00',3.81),('8537','2013-01-31','12:50:00',3.79),('8537','2013-01-31','12:55:00',3.76),('8537','2013-01-31','13:00:00',3.72),('8537','2013-01-31','13:05:00',3.72),('8537','2013-01-31','13:10:00',3.55),('8537','2013-01-31','13:15:00',3.64),('8537','2013-01-31','13:20:00',3.58),('8537','2013-01-31','13:25:00',3.52),('8537','2013-01-31','13:30:00',3.52),('8537','2013-01-31','13:35:00',3.44),('8537','2013-01-31','13:40:00',3.39),('8537','2013-01-31','13:45:00',3.35),('8537','2013-01-31','13:50:00',3.51),('8537','2013-01-31','13:55:00',3.42),('8537','2013-01-31','14:00:00',3.37),('8537','2013-01-31','14:05:00',3.25),('8537','2013-01-31','14:10:00',3.09),('8537','2013-01-31','14:15:00',3.05),('8537','2013-01-31','14:20:00',3.05),('8537','2013-01-31','14:25:00',3),('8537','2013-01-31','14:30:00',2.83),('8537','2013-01-31','14:35:00',2.77),('8537','2013-01-31','14:40:00',2.74),('8537','2013-01-31','14:45:00',2.65),('8537','2013-01-31','14:50:00',2.52),('8537','2013-01-31','14:55:00',2.34),('8537','2013-01-31','15:00:00',2.25),('8537','2013-01-31','15:05:00',2.17),('8537','2013-01-31','15:10:00',2.05),('8537','2013-01-31','15:15:00',1.98),('8537','2013-01-31','15:20:00',1.86),('8537','2013-01-31','15:25:00',1.69),('8537','2013-01-31','15:30:00',1.56),('8537','2013-01-31','15:35:00',1.52),('8537','2013-01-31','15:40:00',1.4),('8537','2013-01-31','15:45:00',1.2),('8537','2013-01-31','15:50:00',1.11),('8537','2013-01-31','15:55:00',1.1),('8537','2013-01-30','10:00:00',1.1),('8537','2013-01-30','10:05:00',1.1),('8537','2013-01-30','10:10:00',2.27),('8537','2013-01-30','10:15:00',1.29),('8537','2013-01-30','10:20:00',2.06),('8537','2013-01-30','10:25:00',2.11),('8537','2013-01-30','10:30:00',1.87),('8537','2013-01-30','10:35:00',1.54),('8537','2013-01-30','10:40:00',1.57),('8537','2013-01-30','10:45:00',2.16),('8537','2013-01-30','10:50:00',3.45),('8537','2013-01-30','10:55:00',2.53),('8537','2013-01-30','11:00:00',3.57),('8537','2013-01-30','11:05:00',3.44),('8537','2013-01-30','11:10:00',3.45),('8537','2013-01-30','11:15:00',3.56),('8537','2013-01-30','11:20:00',3.62),('8537','2013-01-30','11:25:00',3.69),('8537','2013-01-30','11:30:00',3.59),('8537','2013-01-30','11:35:00',3.73),('8537','2013-01-30','11:40:00',3.46),('8537','2013-01-30','11:45:00',3.79),('8537','2013-01-30','11:50:00',3.83),('8537','2013-01-30','11:55:00',3.29),('8537','2013-01-30','12:00:00',3.74),('8537','2013-01-30','12:05:00',3.43),('8537','2013-01-30','12:10:00',2.46),('8537','2013-01-30','12:15:00',3.76),('8537','2013-01-30','12:20:00',2.13),('8537','2013-01-30','12:25:00',1.09),('8537','2013-01-30','12:35:00',1.11),('8537','2013-01-30','12:40:00',2.25),('8537','2013-01-30','12:45:00',1.1),('8537','2013-01-30','12:50:00',3.42),('8537','2013-01-30','12:55:00',4.31),('8537','2013-01-30','13:00:00',4.15),('8537','2013-01-30','13:05:00',4.27),('8537','2013-01-30','13:10:00',2.97),('8537','2013-01-30','13:15:00',3.61),('8537','2013-01-30','13:20:00',4.07),('8537','2013-01-30','13:25:00',3.92),('8537','2013-01-30','13:30:00',3.7),('8537','2013-01-30','13:35:00',2.59),('8537','2013-01-30','13:40:00',3.12),('8537','2013-01-30','13:45:00',1.65),('8537','2013-01-30','13:50:00',3.59),('8537','2013-01-30','13:55:00',2.56),('8537','2013-01-30','14:00:00',3.24),('8537','2013-01-30','14:05:00',3.26),('8537','2013-01-30','14:10:00',2.29),('8537','2013-01-30','14:15:00',1.31),('8537','2013-01-30','14:20:00',2),('8537','2013-01-30','14:25:00',2.73),('8537','2013-01-30','14:30:00',1.56),('8537','2013-01-30','14:35:00',2.45),('8537','2013-01-30','14:40:00',2.59),('8537','2013-01-30','14:45:00',2.06),('8537','2013-01-30','14:50:00',1.09),('8537','2013-01-30','14:55:00',1.21),('8537','2013-01-30','15:00:00',1.69),('8537','2013-01-30','15:05:00',1.6),('8537','2013-01-30','15:10:00',1.11),('8537','2013-01-29','08:30:00',1.02),('8537','2013-01-29','08:35:00',1.12),('8537','2013-01-29','08:40:00',1.24),('8537','2013-01-29','08:45:00',1.34),('8537','2013-01-29','08:50:00',1.4),('8537','2013-01-29','08:55:00',1.44),('8537','2013-01-29','09:00:00',1.54),('8537','2013-01-29','09:05:00',1.7),('8537','2013-01-29','09:10:00',1.78),('8537','2013-01-29','09:15:00',1.88),('8537','2013-01-29','09:20:00',2.02),('8537','2013-01-29','09:25:00',2.13),('8537','2013-01-29','09:30:00',2.26),('8537','2013-01-29','09:35:00',2.4),('8537','2013-01-29','09:40:00',2.54),('8537','2013-01-29','09:45:00',2.68),('8537','2013-01-29','09:50:00',2.8),('8537','2013-01-29','09:55:00',2.88),('8537','2013-01-29','10:00:00',2.96),('8537','2013-01-29','10:05:00',3.08),('8537','2013-01-29','10:10:00',3.19),('8537','2013-01-29','10:15:00',3.27),('8537','2013-01-29','10:20:00',3.35),('8537','2013-01-29','10:25:00',3.43),('8537','2013-01-29','10:30:00',3.48),('8537','2013-01-29','10:35:00',3.53),('8537','2013-01-29','10:40:00',3.58),('8537','2013-01-29','10:45:00',3.61),('8537','2013-01-29','10:50:00',3.67),('8537','2013-01-29','10:55:00',3.69),('8537','2013-01-29','11:00:00',3.69),('8537','2013-01-29','11:05:00',3.71),('8537','2013-01-29','11:10:00',3.72),('8537','2013-01-29','11:15:00',3.78),('8537','2013-01-29','11:20:00',3.84),('8537','2013-01-29','11:25:00',3.82),('8537','2013-01-29','11:30:00',3.77),('8537','2013-01-29','11:35:00',3.93),('8537','2013-01-29','11:40:00',3.98),('8537','2013-01-29','11:45:00',3.99),('8537','2013-01-29','11:50:00',3.99),('8537','2013-01-29','11:55:00',3.98),('8537','2013-01-29','12:00:00',3.94),('8537','2013-01-29','12:05:00',3.96),('8537','2013-01-29','12:10:00',4.01),('8537','2013-01-29','12:15:00',3.96),('8537','2013-01-29','12:20:00',4),('8537','2013-01-29','12:25:00',4.01),('8537','2013-01-29','12:30:00',3.95),('8537','2013-01-29','12:35:00',3.9),('8537','2013-01-29','12:40:00',3.9),('8537','2013-01-29','12:45:00',3.87),('8537','2013-01-29','12:50:00',3.85),('8537','2013-01-29','12:55:00',3.93),('8537','2013-01-29','13:00:00',3.9),('8537','2013-01-29','13:05:00',3.82),('8537','2013-01-29','13:10:00',3.82),('8537','2013-01-29','13:15:00',3.77),('8537','2013-01-29','13:20:00',3.67),('8537','2013-01-29','13:25:00',3.75),('8537','2013-01-29','13:30:00',3.7),('8537','2013-01-29','13:35:00',3.64),('8537','2013-01-29','13:40:00',3.58),('8537','2013-01-29','13:45:00',3.56),('8537','2013-01-29','13:50:00',3.48),('8537','2013-01-29','13:55:00',3.39),('8537','2013-01-29','14:00:00',3.36),('8537','2013-01-29','14:05:00',3.24),('8537','2013-01-29','14:10:00',3.15),('8537','2013-01-29','14:15:00',3.18),('8537','2013-01-29','14:20:00',3.2),('8537','2013-01-29','14:25:00',3.12),('8537','2013-01-29','14:30:00',3.01),('8537','2013-01-29','14:35:00',2.89),('8537','2013-01-29','14:40:00',2.81),('8537','2013-01-29','14:45:00',2.73),('8537','2013-01-29','14:50:00',2.61),('8537','2013-01-29','14:55:00',2.47),('8537','2013-01-29','15:00:00',2.31),('8537','2013-01-29','15:05:00',2.18),('8537','2013-01-29','15:10:00',2.03),('8537','2013-01-29','15:15:00',1.88),('8537','2013-01-29','15:20:00',1.73),('8537','2013-01-29','15:25:00',1.58),('8537','2013-01-29','15:30:00',1.42),('8537','2013-01-29','15:35:00',1.41),('8537','2013-01-29','15:40:00',1.34),('8537','2013-01-29','15:45:00',1.13),('8537','2013-01-29','15:50:00',1.13),('8537','2013-01-29','15:55:00',1.13),('8537','2013-01-29','16:00:00',1.09),('8537','2013-01-28','11:10:00',1.01),('8537','2013-01-28','12:45:00',1.21),('8537','2013-01-28','12:50:00',1.46),('8537','2013-01-28','12:55:00',1.37),('8537','2013-01-28','13:00:00',1.27),('8537','2013-01-28','13:05:00',1.23),('8537','2013-01-28','13:10:00',1.13),('8537','2013-01-28','13:15:00',1.08),('8537','2013-01-28','13:20:00',1.1),('8537','2013-01-28','13:25:00',1.12),('8537','2013-01-28','13:30:00',1.08),('8537','2013-01-27','08:30:00',1.1),('8537','2013-01-27','08:35:00',1.26),('8537','2013-01-27','08:40:00',1.37),('8537','2013-01-27','08:45:00',1.34),('8537','2013-01-27','08:50:00',1.37),('8537','2013-01-27','08:55:00',1.4),('8537','2013-01-27','09:00:00',1.48),('8537','2013-01-27','09:05:00',1.65),('8537','2013-01-27','09:10:00',1.72),('8537','2013-01-27','09:15:00',1.79),('8537','2013-01-27','09:20:00',1.9),('8537','2013-01-27','09:25:00',2.01),('8537','2013-01-27','09:30:00',2.14),('8537','2013-01-27','09:35:00',2.29),('8537','2013-01-27','09:40:00',2.44),('8537','2013-01-27','09:45:00',2.56),('8537','2013-01-27','09:50:00',2.7),('8537','2013-01-27','09:55:00',2.83),('8537','2013-01-27','10:00:00',2.94),('8537','2013-01-27','10:05:00',3.01),('8537','2013-01-27','10:10:00',3.07),('8537','2013-01-27','10:15:00',3.15),('8537','2013-01-27','10:20:00',3.19),('8537','2013-01-27','10:25:00',3.26),('8537','2013-01-27','10:30:00',3.34),('8537','2013-01-27','10:35:00',3.4),('8537','2013-01-27','10:40:00',3.43),('8537','2013-01-27','10:45:00',3.47),('8537','2013-01-27','10:50:00',3.52),('8537','2013-01-27','10:55:00',3.56),('8537','2013-01-27','11:00:00',3.57),('8537','2013-01-27','11:05:00',3.65),('8537','2013-01-27','11:10:00',3.69),('8537','2013-01-27','11:15:00',3.71),('8537','2013-01-27','11:20:00',3.75),('8537','2013-01-27','11:25:00',3.78),('8537','2013-01-27','11:30:00',3.79),('8537','2013-01-27','11:35:00',3.81),('8537','2013-01-27','11:40:00',3.81),('8537','2013-01-27','11:45:00',3.87),('8537','2013-01-27','11:50:00',3.88),('8537','2013-01-27','11:55:00',3.87),('8537','2013-01-27','12:00:00',3.9),('8537','2013-01-27','12:05:00',3.89),('8537','2013-01-27','12:10:00',3.9),('8537','2013-01-27','12:15:00',3.91),('8537','2013-01-27','12:20:00',3.97),('8537','2013-01-27','12:25:00',3.9),('8537','2013-01-27','12:30:00',3.89),('8537','2013-01-27','12:35:00',3.88),('8537','2013-01-27','12:40:00',3.88),('8537','2013-01-27','12:45:00',3.86),('8537','2013-01-27','12:50:00',3.91),('8537','2013-01-27','12:55:00',3.88),('8537','2013-01-27','13:00:00',3.87),('8537','2013-01-27','13:05:00',3.87),('8537','2013-01-27','13:10:00',3.84),('8537','2013-01-27','13:15:00',3.78),('8537','2013-01-27','13:20:00',3.66),('8537','2013-01-27','13:25:00',3.6),('8537','2013-01-27','13:30:00',3.55),('8537','2013-01-27','13:35:00',3.48),('8537','2013-01-27','13:40:00',3.45),('8537','2013-01-27','13:45:00',3.36),('8537','2013-01-27','13:50:00',3.3),('8537','2013-01-27','13:55:00',3.27),('8537','2013-01-27','14:00:00',3.25),('8537','2013-01-27','14:05:00',3.14),('8537','2013-01-27','14:10:00',3.11),('8537','2013-01-27','14:15:00',3.01),('8537','2013-01-27','14:20:00',2.98),('8537','2013-01-27','14:25:00',2.88),('8537','2013-01-27','14:30:00',2.76),('8537','2013-01-27','14:35:00',2.61),('8537','2013-01-27','14:40:00',2.43),('8537','2013-01-27','14:45:00',2.26),('8537','2013-01-27','14:50:00',2.32),('8537','2013-01-27','14:55:00',2.27),('8537','2013-01-27','15:00:00',2.12),('8537','2013-01-27','15:05:00',1.97),('8537','2013-01-27','15:10:00',1.81),('8537','2013-01-27','15:15:00',1.68),('8537','2013-01-27','15:20:00',1.6),('8537','2013-01-27','15:25:00',1.53),('8537','2013-01-27','15:30:00',1.46),('8537','2013-01-27','15:35:00',1.37),('8537','2013-01-27','15:40:00',1.21),('8537','2013-01-27','15:45:00',1.01),('8537','2013-01-27','15:50:00',1.05),('8537','2013-01-27','15:55:00',1.07),('8537','2013-01-26','09:00:00',1.47),('8537','2013-01-26','09:05:00',1.16),('8537','2013-01-26','09:10:00',1.42),('8537','2013-01-26','09:15:00',1.17),('8537','2013-01-26','09:20:00',1.26),('8537','2013-01-26','09:25:00',1.11),('8537','2013-01-26','09:35:00',1.06),('8537','2013-01-26','09:50:00',1.23),('8537','2013-01-26','09:55:00',1.67),('8537','2013-01-26','10:00:00',1.08),('8537','2013-01-26','10:05:00',1.07),('8537','2013-01-26','10:15:00',1.14),('8537','2013-01-26','10:20:00',1.44),('8537','2013-01-26','10:25:00',1.51),('8537','2013-01-26','10:40:00',1.03),('8537','2013-01-26','10:45:00',1.07),('8537','2013-01-26','10:50:00',1.31),('8537','2013-01-26','10:55:00',1.26),('8537','2013-01-26','11:00:00',1),('8537','2013-01-26','11:05:00',1.23),('8537','2013-01-26','11:10:00',1.09),('8537','2013-01-26','11:15:00',1.04),('8537','2013-01-26','11:25:00',1.15),('8537','2013-01-26','11:30:00',1.13),('8537','2013-01-26','11:35:00',1.06),('8537','2013-01-26','11:40:00',1.07),('8537','2013-01-26','11:50:00',1.02),('8537','2013-01-26','11:55:00',1.01),('8537','2013-01-26','12:25:00',1.12),('8537','2013-01-26','12:30:00',1.05),('8537','2013-01-26','12:35:00',1.04),('8537','2013-01-26','12:50:00',1.01),('8537','2013-01-25','08:30:00',1.02),('8537','2013-01-25','08:35:00',1.23),('8537','2013-01-25','08:40:00',1.34),('8537','2013-01-25','08:45:00',1.42),('8537','2013-01-25','08:50:00',1.42),('8537','2013-01-25','08:55:00',1.46),('8537','2013-01-25','09:00:00',1.71),('8537','2013-01-25','09:05:00',1.41),('8537','2013-01-25','09:10:00',1.57),('8537','2013-01-25','09:15:00',1.89),('8537','2013-01-25','09:20:00',2.04),('8537','2013-01-25','09:25:00',2.16),('8537','2013-01-25','09:30:00',2.27),('8537','2013-01-25','09:35:00',2.24),('8537','2013-01-25','09:40:00',2.24),('8537','2013-01-25','09:45:00',2.37),('8537','2013-01-25','09:50:00',2.96),('8537','2013-01-25','09:55:00',3.07),('8537','2013-01-25','10:00:00',3.19),('8537','2013-01-25','10:05:00',3.25),('8537','2013-01-25','10:10:00',3.32),('8537','2013-01-25','10:15:00',3.38),('8537','2013-01-25','10:20:00',3.37),('8537','2013-01-25','10:25:00',3.46),('8537','2013-01-25','10:30:00',3.17),('8537','2013-01-25','10:35:00',2.14),('8537','2013-01-25','10:40:00',3.37),('8537','2013-01-25','10:45:00',3.51),('8537','2013-01-25','10:50:00',2.43),('8537','2013-01-25','10:55:00',4.07),('8537','2013-01-25','11:00:00',2.08),('8537','2013-01-25','11:05:00',3.17),('8537','2013-01-25','11:10:00',3.52),('8537','2013-01-25','11:15:00',3.92),('8537','2013-01-25','11:20:00',3.91),('8537','2013-01-25','11:25:00',3.88),('8537','2013-01-25','11:30:00',3.92),('8537','2013-01-25','11:35:00',4),('8537','2013-01-25','11:40:00',3.98),('8537','2013-01-25','11:45:00',4.02),('8537','2013-01-25','11:50:00',4.07),('8537','2013-01-25','11:55:00',4.05),('8537','2013-01-25','12:00:00',4.02),('8537','2013-01-25','12:05:00',4),('8537','2013-01-25','12:10:00',4.04),('8537','2013-01-25','12:15:00',4.09),('8537','2013-01-25','12:20:00',4.1),('8537','2013-01-25','12:25:00',4.1),('8537','2013-01-25','12:30:00',4.05),('8537','2013-01-25','12:35:00',3.5),('8537','2013-01-25','12:40:00',3.67),('8537','2013-01-25','12:45:00',3.91),('8537','2013-01-25','12:50:00',3.95),('8537','2013-01-25','12:55:00',3.88),('8537','2013-01-25','13:00:00',3.87),('8537','2013-01-25','13:05:00',3.81),('8537','2013-01-25','13:10:00',3.8),('8537','2013-01-25','13:15:00',3.8),('8537','2013-01-25','13:20:00',3.79),('8537','2013-01-25','13:25:00',3.76),('8537','2013-01-25','13:30:00',3.91),('8537','2013-01-25','13:35:00',3.83),('8537','2013-01-25','13:40:00',3.75),('8537','2013-01-25','13:45:00',3.66),('8537','2013-01-25','13:50:00',3.55),('8537','2013-01-25','13:55:00',3.48),('8537','2013-01-25','14:00:00',3.37),('8537','2013-01-25','14:05:00',3.23),('8537','2013-01-25','14:10:00',2.99),('8537','2013-01-25','14:15:00',2.83),('8537','2013-01-25','14:20:00',2.64),('8537','2013-01-25','14:25:00',2.62),('8537','2013-01-25','14:30:00',2.44),('8537','2013-01-25','14:35:00',2.28),('8537','2013-01-25','14:40:00',2.17),('8537','2013-01-25','14:45:00',2),('8537','2013-01-25','14:50:00',1.96),('8537','2013-01-25','14:55:00',1.91),('8537','2013-01-25','15:00:00',1.73),('8537','2013-01-25','15:05:00',1.61),('8537','2013-01-25','15:10:00',1.55),('8537','2013-01-25','15:15:00',1.44),('8537','2013-01-25','15:20:00',1.38),('8537','2013-01-25','15:25:00',1.36),('8537','2013-01-25','15:30:00',1.4),('8537','2013-01-25','15:35:00',1.42),('8537','2013-01-25','15:40:00',1.28),('8537','2013-01-25','15:45:00',1.25),('8537','2013-01-25','15:50:00',1.3),('8537','2013-01-25','15:55:00',1.11),('8537','2013-01-24','09:25:00',1.01),('8537','2013-01-24','09:30:00',1.09),('8537','2013-01-24','09:45:00',1.77),('8537','2013-01-24','09:50:00',1.54),('8537','2013-01-24','09:55:00',2.7),('8537','2013-01-24','10:00:00',2.84),('8537','2013-01-24','10:05:00',2.97),('8537','2013-01-24','10:10:00',3.28),('8537','2013-01-24','10:15:00',3.28),('8537','2013-01-24','10:20:00',3.41),('8537','2013-01-24','10:25:00',3.43),('8537','2013-01-24','10:30:00',3.49),('8537','2013-01-24','10:35:00',3.52),('8537','2013-01-24','10:40:00',3.59),('8537','2013-01-24','10:45:00',3.64),('8537','2013-01-24','10:50:00',3.71),('8537','2013-01-24','10:55:00',3.25),('8537','2013-01-24','11:00:00',1.61),('8537','2013-01-24','11:05:00',1.23),('8537','2013-01-24','12:50:00',1.08),('8537','2013-01-24','12:55:00',1.11),('8537','2013-01-24','13:00:00',1.1),('8537','2013-01-24','13:05:00',1.07),('8537','2013-01-24','13:30:00',1.01),('8537','2013-01-24','13:45:00',1.01),('8537','2013-01-24','13:50:00',1.05),('8537','2013-01-24','13:55:00',1.11),('8537','2013-01-24','14:00:00',1.43),('8537','2013-01-24','14:05:00',1.39),('8537','2013-01-24','14:10:00',1.33),('8537','2013-01-24','14:15:00',1.55),('8537','2013-01-24','14:20:00',2.33),('8537','2013-01-24','14:25:00',4.04),('8537','2013-01-24','14:30:00',3.44),('8537','2013-01-24','14:35:00',2.51),('8537','2013-01-24','14:40:00',1.67),('8537','2013-01-24','14:45:00',2.27),('8537','2013-01-24','14:50:00',2.35),('8537','2013-01-24','14:55:00',2.35),('8537','2013-01-24','15:00:00',1.67),('8537','2013-01-24','15:05:00',1.19),('8537','2013-01-24','15:20:00',1.46),('8537','2013-01-24','15:25:00',1.47),('8537','2013-01-24','15:30:00',1.52),('8537','2013-01-24','15:35:00',1.28),('8537','2013-01-24','15:50:00',1.2),('8537','2013-01-24','15:55:00',1.09),('8537','2013-01-23','09:55:00',2.06),('8537','2013-01-23','10:00:00',1.06),('8537','2013-01-23','10:25:00',1.21),('8537','2013-01-23','10:30:00',2.49),('8537','2013-01-23','10:35:00',3.4),('8537','2013-01-23','10:40:00',1.57),('8537','2013-01-23','10:45:00',2.07),('8537','2013-01-23','10:50:00',2.62),('8537','2013-01-23','10:55:00',2.3),('8537','2013-01-22','08:50:00',1.07),('8537','2013-01-22','09:00:00',1.32),('8537','2013-01-22','09:05:00',1.47),('8537','2013-01-22','09:30:00',1.97),('8537','2013-01-22','09:35:00',2.29),('8537','2013-01-22','09:40:00',1.87),('8537','2013-01-22','09:45:00',3),('8537','2013-01-22','09:50:00',1.84),('8537','2013-01-22','09:55:00',2.28),('8537','2013-01-22','10:00:00',1.69),('8537','2013-01-22','10:05:00',2.72),('8537','2013-01-22','10:10:00',3.15),('8537','2013-01-22','10:15:00',2.95),('8537','2013-01-22','10:20:00',3.07),('8537','2013-01-22','10:25:00',3.29),('8537','2013-01-22','10:30:00',3.48),('8537','2013-01-22','10:35:00',3.63),('8537','2013-01-22','10:40:00',3.63),('8537','2013-01-22','10:45:00',3.31),('8537','2013-01-22','10:50:00',2.86),('8537','2013-01-22','10:55:00',1.6),('8537','2013-01-22','11:10:00',1.35),('8537','2013-01-22','11:15:00',2.13),('8537','2013-01-22','11:20:00',2.32),('8537','2013-01-22','11:25:00',1.38),('8537','2013-01-22','11:45:00',1.98),('8537','2013-01-22','11:50:00',2.73),('8537','2013-01-22','11:55:00',1.11),('8537','2013-01-22','12:00:00',1.21),('8537','2013-01-22','12:05:00',1.06),('8537','2013-01-22','12:10:00',3.17),('8537','2013-01-22','12:15:00',3.16),('8537','2013-01-22','12:20:00',2.09),('8537','2013-01-22','12:25:00',2.91),('8537','2013-01-22','12:30:00',1.3),('8537','2013-01-22','12:35:00',1.07),('8537','2013-01-22','12:40:00',4.34),('8537','2013-01-22','12:45:00',1.3),('8537','2013-01-22','12:50:00',1.1),('8537','2013-01-22','12:55:00',1.36),('8537','2013-01-22','13:00:00',2.76),('8537','2013-01-22','13:05:00',4.43),('8537','2013-01-22','13:10:00',3.12),('8537','2013-01-22','13:15:00',1.26),('8537','2013-01-22','13:20:00',3.42),('8537','2013-01-22','13:25:00',1.04),('8537','2013-01-22','13:30:00',1.23),('8537','2013-01-22','13:40:00',1.11),('8537','2013-01-22','13:45:00',1.21),('8537','2013-01-22','13:50:00',1.75),('8537','2013-01-22','14:10:00',1.52),('8537','2013-01-22','14:15:00',1.64),('8537','2013-01-22','14:20:00',1.27),('8537','2013-01-22','14:25:00',2.14),('8537','2013-01-22','14:35:00',1.78),('8537','2013-01-22','14:40:00',1.3),('8537','2013-01-22','14:45:00',1.91),('8537','2013-01-22','14:50:00',1.47),('8537','2014-03-20','07:25:00',1.08),('8537','2014-03-20','07:30:00',1.08),('8537','2014-03-20','07:35:00',1.28),('8537','2014-03-20','07:40:00',1.43),('8537','2014-03-20','07:45:00',1.55),('8537','2014-03-20','07:50:00',1.64),('8537','2014-03-20','07:55:00',1.75),('8537','2014-03-20','08:00:00',1.86),('8537','2014-03-20','08:05:00',1.97),('8537','2014-03-20','08:10:00',2.04),('8537','2014-03-20','08:15:00',2.1),('8537','2014-03-20','08:20:00',2.17),('8537','2014-03-20','08:25:00',2.26),('8537','2014-03-20','08:30:00',2.39),('8537','2014-03-20','08:35:00',2.52),('8537','2014-03-20','08:40:00',2.65),('8537','2014-03-20','08:45:00',2.77),('8537','2014-03-20','08:50:00',2.88),('8537','2014-03-20','08:55:00',2.94),('8537','2014-03-20','09:00:00',3),('8537','2014-03-20','09:05:00',3.1),('8537','2014-03-20','09:10:00',3.23),('8537','2014-03-20','09:15:00',3.28),('8537','2014-03-20','09:20:00',3.39),('8537','2014-03-20','09:25:00',3.44),('8537','2014-03-20','09:30:00',3.49),('8537','2014-03-20','09:35:00',3.61),('8537','2014-03-20','09:40:00',3.62),('8537','2014-03-20','09:45:00',3.66),('8537','2014-03-20','09:50:00',3.57),('8537','2014-03-20','09:55:00',3.71),('8537','2014-03-20','10:00:00',3.89),('8537','2014-03-20','10:05:00',4.04),('8537','2014-03-20','10:10:00',4.09),('8537','2014-03-20','10:15:00',4.04),('8537','2014-03-20','10:20:00',4.1),('8537','2014-03-20','10:25:00',4.15),('8537','2014-03-20','10:30:00',4.17),('8537','2014-03-20','10:35:00',4.1),('8537','2014-03-20','10:40:00',4),('8537','2014-03-20','10:45:00',4),('8537','2014-03-20','10:50:00',4.28),('8537','2014-03-20','10:55:00',4.5),('8537','2014-03-20','11:00:00',4.54),('8537','2014-03-20','11:05:00',4.45),('8537','2014-03-20','11:10:00',4.48),('8537','2014-03-20','11:15:00',4.28),('8537','2014-03-20','11:20:00',4.43),('8537','2014-03-20','11:25:00',4.49),('8537','2014-03-20','11:30:00',4.6),('8537','2014-03-20','11:35:00',4.75),('8537','2014-03-20','11:40:00',4.66),('8537','2014-03-20','11:45:00',4.74),('8537','2014-03-20','11:50:00',4.7),('8537','2014-03-20','11:55:00',4.49),('8537','2014-03-20','12:00:00',4.15),('8537','2014-03-20','12:05:00',4.45),('8537','2014-03-20','12:10:00',4.65),('8537','2014-03-20','12:15:00',4.69),('8537','2014-03-20','12:20:00',4.54),('8537','2014-03-20','12:25:00',4.31),('8537','2014-03-20','12:30:00',4.48),('8537','2014-03-20','12:35:00',4.57),('8537','2014-03-20','12:40:00',4.54),('8537','2014-03-20','12:45:00',4.71),('8537','2014-03-20','12:50:00',4.68),('8537','2014-03-20','12:55:00',4.59),('8537','2014-03-20','13:00:00',4.6),('8537','2014-03-20','13:05:00',4.57),('8537','2014-03-20','13:10:00',4.44),('8537','2014-03-20','13:15:00',4.43),('8537','2014-03-20','13:20:00',4.47),('8537','2014-03-20','13:25:00',4.34),('8537','2014-03-20','13:30:00',4.38),('8537','2014-03-20','13:35:00',4.22),('8537','2014-03-20','13:40:00',3.92),('8537','2014-03-20','13:45:00',3.8),('8537','2014-03-20','13:50:00',3.66),('8537','2014-03-20','13:55:00',3.48),('8537','2014-03-20','14:00:00',3.52),('8537','2014-03-20','14:05:00',3.76),('8537','2014-03-20','14:10:00',3.69),('8537','2014-03-20','14:15:00',3.48),('8537','2014-03-20','14:20:00',3.45),('8537','2014-03-20','14:25:00',3.47),('8537','2014-03-20','14:30:00',2.97),('8537','2014-03-20','14:35:00',2.7),('8537','2014-03-20','14:40:00',3.02),('8537','2014-03-20','14:45:00',2.96),('8537','2014-03-20','14:50:00',2.86),('8537','2014-03-20','14:55:00',2.7),('8537','2014-03-20','15:00:00',2.44),('8537','2014-03-20','15:05:00',2.44),('8537','2014-03-20','15:10:00',2.45),('8537','2014-03-20','15:15:00',2.28),('8537','2014-03-20','15:20:00',2.44),('8537','2014-03-20','15:25:00',2.23),('8537','2014-03-20','15:30:00',2.12),('8537','2014-03-20','15:35:00',2),('8537','2014-03-20','15:40:00',1.85),('8537','2014-03-20','15:45:00',1.84),('8537','2014-03-20','15:50:00',1.61),('8537','2014-03-20','15:55:00',1.44),('8537','2014-03-20','16:00:00',1.21),('8537','2014-03-20','16:05:00',1.1),('8537','2014-03-20','16:10:00',1.15),('8537','2014-03-20','16:15:00',1.1),('8537','2014-03-20','16:20:00',1.13),('8537','2014-03-20','16:25:00',1.15),('8537','2014-03-20','16:30:00',1.04),('8537','2013-01-21','11:00:00',1.02),('8537','2013-01-21','11:10:00',1.25),('8537','2013-01-21','11:15:00',1.41),('8537','2013-01-21','11:20:00',1.13),('8537','2013-01-21','11:25:00',1.06),('8537','2013-01-21','11:50:00',1.45),('8537','2013-01-21','11:55:00',4.26),('8537','2013-01-21','12:00:00',3.81),('8537','2013-01-21','12:05:00',3.73),('8537','2013-01-21','12:10:00',3.76),('8537','2013-01-21','12:15:00',3),('8537','2013-01-21','12:25:00',1.73),('8537','2013-01-21','12:40:00',1.34),('8537','2013-01-21','12:50:00',1.41),('8537','2013-01-21','13:00:00',1.03),('8537','2013-01-21','13:05:00',2.24),('8537','2013-01-21','13:10:00',1.71),('8537','2013-01-21','13:15:00',1.08),('8537','2013-01-21','13:20:00',1.02),('8537','2013-01-21','13:30:00',3.57),('8537','2013-01-21','13:35:00',4.1),('8537','2013-01-21','13:40:00',3.42),('8537','2013-01-21','13:45:00',1.06),('8537','2013-01-21','13:50:00',2.19),('8537','2013-01-21','13:55:00',3.44),('8537','2013-01-21','14:00:00',3.32),('8537','2013-01-21','14:05:00',3.24),('8537','2013-01-21','14:10:00',3.04),('8537','2013-01-21','14:15:00',2.42),('8537','2013-01-21','14:20:00',2.5),('8537','2013-01-21','14:25:00',2.89),('8537','2013-01-21','14:30:00',1.55),('8537','2013-01-20','10:50:00',1.15),('8537','2013-01-20','10:55:00',1.28),('8537','2013-01-20','11:00:00',1.41),('8537','2013-01-20','11:05:00',1.39),('8537','2013-01-20','11:10:00',1.46),('8537','2013-01-20','11:15:00',2.03),('8537','2013-01-20','11:20:00',1.58),('8537','2013-01-20','11:25:00',2.19),('8537','2013-01-20','11:30:00',2.89),('8537','2013-01-20','11:35:00',2.14),('8537','2013-01-20','11:40:00',1.21),('8537','2013-01-20','11:45:00',1.14),('8537','2013-01-20','12:20:00',1.07),('8537','2013-01-20','12:25:00',1.11),('8537','2013-01-20','12:30:00',1.03),('8537','2013-01-20','13:40:00',1.04),('8537','2013-01-20','13:45:00',1.01),('8537','2013-01-19','09:10:00',1),('8537','2013-01-19','09:15:00',1.46),('8537','2013-01-19','09:20:00',1.42),('8537','2013-01-19','09:25:00',1.1),('8537','2013-01-19','09:50:00',1.26),('8537','2013-01-19','09:55:00',1.8),('8537','2013-01-19','10:00:00',1.59),('8537','2013-01-19','10:05:00',1.24),('8537','2013-01-19','10:35:00',1.05),('8537','2013-01-19','10:40:00',1.3),('8537','2013-01-19','10:45:00',1.52),('8537','2013-01-19','10:50:00',1.64),('8537','2013-01-19','11:10:00',1),('8537','2013-01-19','11:15:00',1.07),('8537','2013-01-19','11:20:00',1.3),('8537','2013-01-19','11:25:00',1.33),('8537','2013-01-18','10:15:00',2.85),('8537','2013-01-18','10:20:00',2.67),('8537','2013-01-18','10:25:00',1.93),('8537','2013-01-18','10:30:00',1.57),('8537','2013-01-18','10:35:00',1.23),('8537','2013-01-18','11:05:00',1.03),('8537','2013-01-18','11:10:00',1.04),('8537','2013-01-18','11:30:00',1.15),('8537','2013-01-18','11:35:00',1.39),('8537','2013-01-18','11:40:00',1.34),('8537','2013-01-18','11:45:00',1.11),('8537','2013-01-18','12:00:00',1.02),('8537','2013-01-18','12:05:00',1.02),('8537','2013-01-18','12:10:00',1.15),('8537','2013-01-18','12:15:00',1.17),('8537','2013-01-18','12:20:00',1.15),('8537','2013-01-18','12:25:00',1.19),('8537','2013-01-18','12:30:00',1.21),('8537','2013-01-18','12:35:00',1.47),('8537','2013-01-18','12:40:00',1.68),('8537','2013-01-18','12:45:00',1.77),('8537','2013-01-18','12:50:00',2.54),('8537','2013-01-18','12:55:00',2.38),('8537','2013-01-18','13:00:00',2.99),('8537','2013-01-18','13:05:00',2.65),('8537','2013-01-18','13:10:00',2.55),('8537','2013-01-18','13:15:00',2.8),('8537','2013-01-18','13:20:00',2.25),('8537','2013-01-18','13:25:00',1.84),('8537','2013-01-18','13:30:00',1.72),('8537','2013-01-18','13:35:00',1.93),('8537','2013-01-18','13:40:00',1.78),('8537','2013-01-18','13:45:00',2.15),('8537','2013-01-18','13:50:00',3.32),('8537','2013-01-18','13:55:00',3.71),('8537','2013-01-18','14:00:00',2.94),('8537','2013-01-18','14:05:00',2.38),('8537','2013-01-18','14:10:00',3.14),('8537','2013-01-18','14:15:00',2.02),('8537','2013-01-18','14:20:00',2.03),('8537','2013-01-18','14:25:00',1.66),('8537','2013-01-18','14:30:00',1.36),('8537','2013-01-18','14:35:00',1.15),('8537','2013-01-18','14:40:00',1.05),('8537','2013-01-18','14:45:00',1.13),('8537','2013-01-18','14:50:00',1.2),('8537','2013-01-18','14:55:00',1.01),('8537','2013-01-18','15:25:00',1.03),('8537','2013-01-17','09:45:00',1.22),('8537','2013-01-17','09:50:00',1.5),('8537','2013-01-17','09:55:00',1.4),('8537','2013-01-17','10:00:00',1.03),('8537','2013-01-17','10:05:00',1.1),('8537','2013-01-17','10:10:00',1.3),('8537','2013-01-17','10:15:00',1.54),('8537','2013-01-17','10:20:00',1.52),('8537','2013-01-17','10:25:00',1.96),('8537','2013-01-17','10:30:00',2.08),('8537','2013-01-17','10:35:00',1.91),('8537','2013-01-17','10:40:00',1.81),('8537','2013-01-17','10:45:00',1.96),('8537','2013-01-17','10:50:00',1.85),('8537','2013-01-17','10:55:00',2.21),('8537','2013-01-17','11:00:00',1.96),('8537','2013-01-17','11:05:00',1.93),('8537','2013-01-17','11:10:00',2.33),('8537','2013-01-17','11:15:00',2.28),('8537','2013-01-17','11:20:00',2.14),('8537','2013-01-17','11:25:00',1.84),('8537','2013-01-17','11:30:00',1.62),('8537','2013-01-17','11:35:00',1.85),('8537','2013-01-17','11:40:00',1.95),('8537','2013-01-17','11:45:00',1.74),('8537','2013-01-17','11:50:00',1.86),('8537','2013-01-17','11:55:00',2),('8537','2013-01-17','12:00:00',2.23),('8537','2013-01-17','12:05:00',2.22),('8537','2013-01-17','12:10:00',2.23),('8537','2013-01-17','12:15:00',2.58),('8537','2013-01-17','12:20:00',2.17),('8537','2013-01-17','12:25:00',1.85),('8537','2013-01-17','12:30:00',1.55),('8537','2013-01-17','12:35:00',1.93),('8537','2013-01-17','12:40:00',2.08),('8537','2013-01-17','12:45:00',1.64),('8537','2013-01-17','12:50:00',1.02),('8537','2013-01-17','12:55:00',1.03),('8537','2013-01-17','13:00:00',2.03),('8537','2013-01-17','13:05:00',1.88),('8537','2013-01-17','13:10:00',1.26),('8537','2013-01-17','13:15:00',1.8),('8537','2013-01-17','13:20:00',1.93),('8537','2013-01-17','13:25:00',1.65),('8537','2013-01-17','13:30:00',1.49),('8537','2013-01-17','13:35:00',1.94),('8537','2013-01-17','13:40:00',2.29),('8537','2013-01-17','13:45:00',2.28),('8537','2013-01-17','13:50:00',2.02),('8537','2013-01-17','13:55:00',1.03),('8537','2013-01-17','14:00:00',1.31),('8537','2013-01-17','14:05:00',1.15),('8537','2013-01-17','14:10:00',1.02),('8537','2013-01-17','14:25:00',1),('8537','2013-01-17','14:30:00',1.36),('8537','2013-01-17','14:35:00',1.81),('8537','2013-01-16','09:15:00',1.38),('8537','2013-01-16','09:20:00',1.08),('8537','2013-01-16','09:25:00',1.82),('8537','2013-01-16','09:30:00',1.95),('8537','2013-01-16','09:35:00',2.03),('8537','2013-01-16','09:40:00',2.11),('8537','2013-01-16','09:45:00',1.27),('8537','2013-01-16','09:55:00',1.12),('8537','2013-01-16','10:00:00',1.17),('8537','2013-01-16','10:35:00',2.35),('8537','2013-01-16','10:40:00',2.53),('8537','2013-01-16','10:45:00',2.94),('8537','2013-01-16','10:55:00',2.56),('8537','2013-01-16','11:25:00',1.97),('8537','2013-01-16','12:00:00',1.68),('8537','2013-01-16','12:05:00',1.48),('8537','2013-01-16','12:10:00',1.84),('8537','2013-01-16','12:15:00',4.44),('8537','2013-01-16','12:20:00',4.18),('8537','2013-01-16','12:25:00',1.58),('8537','2013-01-16','13:05:00',2.44),('8537','2013-01-16','13:10:00',4.55),('8537','2013-01-16','13:15:00',4.85),('8537','2013-01-16','13:20:00',3.57),('8537','2013-01-16','13:25:00',2.4),('8537','2013-01-16','13:55:00',3.16),('8537','2013-01-16','14:00:00',1.98),('8537','2013-01-16','14:05:00',1.79),('8537','2013-01-16','15:05:00',1.01),('8537','2013-01-15','09:55:00',1.14),('8537','2013-01-15','10:00:00',1.24),('8537','2013-01-15','10:10:00',1.18),('8537','2013-01-15','10:15:00',1.12),('8537','2013-01-15','10:20:00',1.17),('8537','2013-01-15','10:25:00',1.21),('8537','2013-01-15','10:40:00',1.12),('8537','2013-01-15','10:45:00',1.29),('8537','2013-01-15','10:50:00',1.63),('8537','2013-01-15','10:55:00',1.78),('8537','2013-01-15','11:00:00',1.69),('8537','2013-01-15','11:05:00',1.81),('8537','2013-01-15','11:10:00',1.85),('8537','2013-01-15','11:15:00',1.77),('8537','2013-01-15','11:20:00',1.87),('8537','2013-01-15','11:25:00',1.83),('8537','2013-01-15','11:30:00',1.75),('8537','2013-01-15','11:35:00',1.63),('8537','2013-01-15','11:40:00',1.45),('8537','2013-01-15','11:45:00',1.24),('8537','2013-01-15','11:50:00',1.15),('8537','2013-01-15','11:55:00',1.25),('8537','2013-01-15','12:00:00',1.19),('8537','2013-01-15','12:05:00',1.14),('8537','2013-01-15','12:10:00',1.09),('8537','2013-01-15','12:15:00',1.29),('8537','2013-01-15','12:20:00',1.5),('8537','2013-01-15','12:25:00',1.45),('8537','2013-01-15','12:30:00',1.34),('8537','2013-01-15','12:35:00',1.35),('8537','2013-01-15','12:40:00',1.54),('8537','2013-01-15','12:45:00',1.65),('8537','2013-01-15','12:50:00',1.53),('8537','2013-01-15','12:55:00',1.32),('8537','2013-01-15','13:00:00',1.06),('8537','2013-01-15','13:05:00',1.13),('8537','2013-01-15','13:10:00',1.13),('8537','2013-01-15','13:15:00',1.16),('8537','2013-01-15','13:20:00',1.17),('8537','2013-01-15','13:25:00',1.13),('8537','2013-01-15','13:30:00',1.25),('8537','2013-01-15','13:35:00',1.28),('8537','2013-01-15','13:40:00',1.5),('8537','2013-01-15','13:45:00',1.35),('8537','2013-01-15','13:50:00',1.34),('8537','2013-01-15','13:55:00',1.49),('8537','2013-01-15','14:00:00',2.31),('8537','2013-01-15','14:05:00',3.04),('8537','2013-01-15','14:10:00',2.92),('8537','2013-01-15','14:15:00',3.16),('8537','2013-01-15','14:20:00',3.21),('8537','2013-01-15','14:25:00',3.04),('8537','2013-01-15','14:30:00',1.4),('8537','2013-01-15','14:35:00',1.92),('8537','2013-01-15','14:40:00',1.84),('8537','2013-01-15','14:45:00',2.01),('8537','2013-01-15','14:50:00',1.93),('8537','2013-01-15','14:55:00',1.87),('8537','2013-01-15','15:00:00',1.89),('8537','2013-01-15','15:05:00',1.89),('8537','2013-01-15','15:10:00',1.51),('8537','2013-01-15','15:25:00',1.02),('8537','2013-01-15','15:30:00',1.02),('8537','2013-01-14','12:40:00',1.04),('8537','2013-01-14','12:45:00',1.15),('8537','2013-01-14','12:50:00',1.38),('8537','2013-01-14','12:55:00',1.31),('8537','2013-01-14','13:00:00',1.37),('8537','2013-01-14','13:05:00',1.34),('8537','2013-01-14','13:10:00',1.2),('8537','2013-01-14','13:15:00',1.02),('8537','2013-01-14','15:15:00',1.34),('8537','2013-01-14','15:20:00',1),('8537','2013-01-14','15:25:00',1.01),('8537','2013-01-13','09:15:00',1.79),('8537','2013-01-13','09:20:00',1.89),('8537','2013-01-13','09:25:00',1.84),('8537','2013-01-13','09:30:00',1.92),('8537','2013-01-13','09:35:00',1.96),('8537','2013-01-13','09:40:00',1.29),('8537','2013-01-13','09:50:00',1.6),('8537','2013-01-13','09:55:00',1.93),('8537','2013-01-13','10:00:00',2.02),('8537','2013-01-13','10:05:00',2.25),('8537','2013-01-13','10:10:00',1.52),('8537','2013-01-13','10:20:00',1.71),('8537','2013-01-13','10:25:00',1.55),('8537','2013-01-13','10:30:00',2.33),('8537','2013-01-13','10:35:00',1.12),('8537','2013-01-12','08:40:00',1.09),('8537','2013-01-12','08:45:00',1.15),('8537','2013-01-12','08:50:00',1.24),('8537','2013-01-12','08:55:00',1.3),('8537','2013-01-12','09:00:00',1.38),('8537','2013-01-12','09:05:00',1.46),('8537','2013-01-12','09:10:00',1.52),('8537','2013-01-12','09:15:00',1.59),('8537','2013-01-12','09:20:00',1.66),('8537','2013-01-12','09:25:00',1.72),('8537','2013-01-12','09:30:00',1.8),('8537','2013-01-12','09:35:00',1.78),('8537','2013-01-12','09:40:00',1.87),('8537','2013-01-12','09:45:00',1.96),('8537','2013-01-12','09:50:00',2.02),('8537','2013-01-12','09:55:00',2.08),('8537','2013-01-12','10:00:00',2.14),('8537','2013-01-12','10:05:00',2.22),('8537','2013-01-12','10:10:00',2.28),('8537','2013-01-12','10:15:00',2.37),('8537','2013-01-12','10:20:00',2.43),('8537','2013-01-12','10:25:00',2.56),('8537','2013-01-12','10:30:00',2.67),('8537','2013-01-12','10:35:00',2.75),('8537','2013-01-12','10:40:00',2.83),('8537','2013-01-12','10:45:00',2.92),('8537','2013-01-12','10:50:00',2.99),('8537','2013-01-12','10:55:00',3.08),('8537','2013-01-12','11:00:00',3.11),('8537','2013-01-12','11:05:00',3.11),('8537','2013-01-12','11:10:00',3.17),('8537','2013-01-12','11:15:00',3.25),('8537','2013-01-12','11:20:00',3.3),('8537','2013-01-12','11:25:00',3.3),('8537','2013-01-12','11:30:00',3.34),('8537','2013-01-12','11:35:00',3.37),('8537','2013-01-12','11:40:00',3.39),('8537','2013-01-12','11:45:00',3.42),('8537','2013-01-12','11:50:00',3.46),('8537','2013-01-12','11:55:00',3.47),('8537','2013-01-12','12:00:00',3.46),('8537','2013-01-12','12:05:00',3.45),('8537','2013-01-12','12:10:00',3.41),('8537','2013-01-12','12:15:00',3.45),('8537','2013-01-12','12:20:00',3.43),('8537','2013-01-12','12:25:00',3.34),('8537','2013-01-12','12:30:00',3.35),('8537','2013-01-12','12:35:00',2.55),('8537','2013-01-12','12:40:00',1.69),('8537','2013-01-12','12:50:00',3.2),('8537','2013-01-12','12:55:00',2.22),('8537','2013-01-12','13:00:00',3.09),('8537','2013-01-12','13:05:00',3.16),('8537','2013-01-12','13:10:00',2.44),('8537','2013-01-12','13:15:00',1.74),('8537','2013-01-12','13:20:00',1.17),('8537','2013-01-12','13:25:00',2.61),('8537','2013-01-12','13:30:00',2.86),('8537','2013-01-12','13:35:00',2.84),('8537','2013-01-12','13:40:00',1.41),('8537','2013-01-12','13:45:00',1.82),('8537','2013-01-12','13:50:00',2.27),('8537','2013-01-12','13:55:00',2.95),('8537','2013-01-12','14:00:00',1.67),('8537','2013-01-12','14:05:00',2.34),('8537','2013-01-12','14:10:00',2.54),('8537','2013-01-12','14:15:00',2.38),('8537','2013-01-12','14:20:00',2.09),('8537','2013-01-12','14:25:00',2.03),('8537','2013-01-12','14:30:00',1.92),('8537','2013-01-12','14:35:00',1.9),('8537','2013-01-12','14:40:00',1.85),('8537','2013-01-12','14:45:00',1.75),('8537','2013-01-12','14:50:00',1.69),('8537','2013-01-12','14:55:00',1.66),('8537','2013-01-12','15:00:00',1.59),('8537','2013-01-12','15:05:00',1.49),('8537','2013-01-12','15:10:00',1.36),('8537','2013-01-12','15:15:00',1.15),('8537','2013-01-12','15:20:00',1.22),('8537','2013-01-12','15:25:00',1.14),('8537','2014-03-19','08:50:00',1.02),('8537','2014-03-19','08:55:00',1.13),('8537','2014-03-19','09:00:00',1.23),('8537','2014-03-19','09:05:00',1.39),('8537','2014-03-19','09:10:00',1.62),('8537','2014-03-19','09:15:00',1.82),('8537','2014-03-19','09:20:00',1.78),('8537','2014-03-19','09:25:00',2.58),('8537','2014-03-19','09:30:00',2.45),('8537','2014-03-19','09:35:00',2.69),('8537','2014-03-19','09:40:00',3.71),('8537','2014-03-19','09:45:00',4.12),('8537','2014-03-19','09:50:00',4.1),('8537','2014-03-19','09:55:00',2.9),('8537','2014-03-19','10:00:00',1.78),('8537','2014-03-19','10:05:00',1.37),('8537','2014-03-19','10:10:00',1.18),('8537','2014-03-19','10:15:00',1),('8537','2014-03-19','10:20:00',1.11),('8537','2014-03-19','10:25:00',1.15),('8537','2014-03-19','10:30:00',1.37),('8537','2014-03-19','10:35:00',2),('8537','2014-03-19','10:40:00',3.21),('8537','2014-03-19','10:45:00',3.99),('8537','2014-03-19','10:50:00',2.7),('8537','2014-03-19','10:55:00',1.74),('8537','2014-03-19','11:00:00',1.64),('8537','2014-03-19','11:05:00',4.38),('8537','2014-03-19','11:10:00',3.53),('8537','2014-03-19','11:15:00',2.06),('8537','2014-03-19','11:20:00',2.11),('8537','2014-03-19','11:25:00',2.31),('8537','2014-03-19','11:30:00',2.43),('8537','2014-03-19','11:35:00',2.56),('8537','2014-03-19','11:40:00',2.17),('8537','2014-03-19','11:45:00',2.18),('8537','2014-03-19','11:50:00',1.96),('8537','2014-03-19','11:55:00',1.91),('8537','2014-03-19','12:00:00',4.19),('8537','2014-03-19','12:05:00',4.94),('8537','2014-03-19','12:10:00',5.07),('8537','2014-03-19','12:15:00',5),('8537','2014-03-19','12:20:00',5.13),('8537','2014-03-19','12:25:00',4.87),('8537','2014-03-19','12:30:00',4.82),('8537','2014-03-19','12:35:00',4.65),('8537','2014-03-19','12:40:00',4.89),('8537','2014-03-19','12:45:00',4.66),('8537','2014-03-19','12:50:00',4.6),('8537','2014-03-19','12:55:00',3.09),('8537','2014-03-19','13:00:00',4.74),('8537','2014-03-19','13:05:00',4.52),('8537','2014-03-19','13:10:00',4.6),('8537','2014-03-19','13:15:00',4.52),('8537','2014-03-19','13:20:00',2.81),('8537','2014-03-19','13:25:00',3.13),('8537','2014-03-19','13:30:00',4.35),('8537','2014-03-19','13:35:00',4.26),('8537','2014-03-19','13:40:00',4.34),('8537','2014-03-19','13:45:00',4.29),('8537','2014-03-19','13:50:00',4.2),('8537','2014-03-19','13:55:00',3.81),('8537','2014-03-19','14:00:00',4.04),('8537','2014-03-19','14:05:00',4.04),('8537','2014-03-19','14:10:00',3.99),('8537','2014-03-19','14:15:00',3.8),('8537','2014-03-19','14:20:00',3.77),('8537','2014-03-19','14:25:00',3.53),('8537','2014-03-19','14:30:00',3.12),('8537','2014-03-19','14:35:00',3.51),('8537','2014-03-19','14:40:00',3.56),('8537','2014-03-19','14:45:00',3.48),('8537','2014-03-19','14:50:00',3.36),('8537','2014-03-19','14:55:00',3.32),('8537','2014-03-19','15:00:00',3.16),('8537','2014-03-19','15:05:00',3.11),('8537','2014-03-19','15:10:00',3.06),('8537','2014-03-19','15:15:00',3.02),('8537','2014-03-19','15:20:00',2.9),('8537','2014-03-19','15:25:00',2.84),('8537','2014-03-19','15:30:00',2.71),('8537','2014-03-19','15:35:00',2.53),('8537','2014-03-19','15:40:00',2.55),('8537','2014-03-19','15:45:00',2.47),('8537','2014-03-19','15:50:00',2.31),('8537','2014-03-19','15:55:00',2.22),('8537','2014-03-19','16:00:00',2.1),('8537','2014-03-19','16:05:00',2.02),('8537','2014-03-19','16:10:00',1.92),('8537','2014-03-19','16:15:00',1.79),('8537','2014-03-19','16:20:00',1.64),('8537','2014-03-19','16:25:00',1.5),('8537','2014-03-19','16:30:00',1.41),('8537','2014-03-19','16:35:00',1.24),('8537','2014-03-19','16:40:00',1.14),('8537','2014-03-19','16:45:00',1.08),('8537','2013-01-11','09:45:00',1.09),('8537','2013-01-11','10:00:00',1.49),('8537','2013-01-11','10:05:00',1.8),('8537','2013-01-11','10:10:00',1.57),('8537','2013-01-11','10:15:00',1.81),('8537','2013-01-11','10:20:00',1.4),('8537','2013-01-11','10:25:00',2.5),('8537','2013-01-11','10:30:00',2.61),('8537','2013-01-11','10:35:00',2.7),('8537','2013-01-11','10:40:00',2.76),('8537','2013-01-11','10:45:00',2.84),('8537','2013-01-11','10:50:00',2.88),('8537','2013-01-11','10:55:00',2.98),('8537','2013-01-11','11:00:00',3.02),('8537','2013-01-11','11:05:00',3.07),('8537','2013-01-11','11:10:00',3.02),('8537','2013-01-11','11:15:00',3.05),('8537','2013-01-11','11:20:00',3),('8537','2013-01-11','11:25:00',2.21),('8537','2013-01-11','11:30:00',1.37),('8537','2013-01-11','11:35:00',1.83),('8537','2013-01-11','11:40:00',1.68),('8537','2013-01-11','11:45:00',1.83),('8537','2013-01-11','11:50:00',1.71),('8537','2013-01-11','11:55:00',1.39),('8537','2013-01-11','12:00:00',1.12),('8537','2013-01-11','12:55:00',2.23),('8537','2013-01-11','13:00:00',1.61),('8537','2013-01-11','13:05:00',1.59),('8537','2013-01-11','13:10:00',2.24),('8537','2013-01-11','13:15:00',1.32),('8537','2013-01-11','13:20:00',1.02),('8537','2013-01-11','13:30:00',1.27),('8537','2013-01-11','13:35:00',2.88),('8537','2013-01-11','13:40:00',1.95),('8537','2013-01-11','13:45:00',1.7),('8537','2013-01-11','14:20:00',1.63),('8537','2013-01-11','14:25:00',1.47),('8537','2013-01-11','14:45:00',1.47),('8537','2013-01-11','14:50:00',1.69),('8537','2013-01-11','14:55:00',1.13),('8537','2013-01-11','15:00:00',1.51),('8537','2013-01-11','15:05:00',1.64),('8537','2013-01-10','11:30:00',1.15),('8537','2013-01-10','11:55:00',1.39),('8537','2013-01-10','12:00:00',1.42),('8537','2013-01-10','12:05:00',1.4),('8537','2013-01-10','12:10:00',1.24),('8537','2013-01-09','10:30:00',1.02),('8537','2013-01-09','10:35:00',1.08),('8537','2013-01-09','10:40:00',1.35),('8537','2013-01-09','10:45:00',1.66),('8537','2013-01-09','10:50:00',1.25),('8537','2013-01-09','10:55:00',1.87),('8537','2013-01-09','11:00:00',1.16),('8537','2013-01-09','11:05:00',1.23),('8537','2013-01-09','11:10:00',1.5),('8537','2013-01-09','11:15:00',2.5),('8537','2013-01-09','11:20:00',2.05),('8537','2013-01-09','11:25:00',1.41),('8537','2013-01-09','11:30:00',1.47),('8537','2013-01-09','11:35:00',1.43),('8537','2013-01-09','11:40:00',1.4),('8537','2013-01-09','11:45:00',1.29),('8537','2013-01-09','11:50:00',1.47),('8537','2013-01-09','11:55:00',1.55),('8537','2013-01-09','12:00:00',1.69),('8537','2013-01-09','12:05:00',1.39),('8537','2013-01-09','12:10:00',1.34),('8537','2013-01-09','12:15:00',1.3),('8537','2013-01-09','12:20:00',1.31),('8537','2013-01-09','12:25:00',1.2),('8537','2013-01-09','12:30:00',1.12),('8537','2013-01-09','12:35:00',1.19),('8537','2013-01-09','12:40:00',1.17),('8537','2013-01-09','12:45:00',1.12),('8537','2013-01-09','12:50:00',1.17),('8537','2013-01-09','12:55:00',1.31),('8537','2013-01-09','13:00:00',1.42),('8537','2013-01-09','13:05:00',2.03),('8537','2013-01-09','13:10:00',2.38),('8537','2013-01-09','13:15:00',1.45),('8537','2013-01-09','13:20:00',1.26),('8537','2013-01-09','13:25:00',1.1),('8537','2013-01-09','13:45:00',1.01),('8537','2013-01-08','08:35:00',1.11),('8537','2013-01-08','08:40:00',1.33),('8537','2013-01-08','08:45:00',1.42),('8537','2013-01-08','08:50:00',1.5),('8537','2013-01-08','08:55:00',1.59),('8537','2013-01-08','09:00:00',1.71),('8537','2013-01-08','09:05:00',1.72),('8537','2013-01-08','09:10:00',1.08),('8537','2013-01-08','09:15:00',1.44),('8537','2013-01-08','09:20:00',1.73),('8537','2013-01-08','09:25:00',1.84),('8537','2013-01-08','09:30:00',1.61),('8537','2013-01-08','09:35:00',1.32),('8537','2013-01-08','09:40:00',1.96),('8537','2013-01-08','09:45:00',2.21),('8537','2013-01-08','09:50:00',2.32),('8537','2013-01-08','09:55:00',2.26),('8537','2013-01-08','10:00:00',2.1),('8537','2013-01-08','10:05:00',2.02),('8537','2013-01-08','10:10:00',2.09),('8537','2013-01-08','10:15:00',2.19),('8537','2013-01-08','10:20:00',2.07),('8537','2013-01-08','10:25:00',2.29),('8537','2013-01-08','10:30:00',2.31),('8537','2013-01-08','10:35:00',2.55),('8537','2013-01-08','10:40:00',2.78),('8537','2013-01-08','10:45:00',2.78),('8537','2013-01-08','10:50:00',2.82),('8537','2013-01-08','10:55:00',2.91),('8537','2013-01-08','11:00:00',2.9),('8537','2013-01-08','11:05:00',3.05),('8537','2013-01-08','11:10:00',3.09),('8537','2013-01-08','11:15:00',3.13),('8537','2013-01-08','11:20:00',3.16),('8537','2013-01-08','11:25:00',3.2),('8537','2013-01-08','11:30:00',3.24),('8537','2013-01-08','11:35:00',3.26),('8537','2013-01-08','11:40:00',3.22),('8537','2013-01-08','11:45:00',3.8),('8537','2013-01-08','11:50:00',2.82),('8537','2013-01-08','11:55:00',2.13),('8537','2013-01-08','12:00:00',1.87),('8537','2013-01-08','12:05:00',1.78),('8537','2013-01-08','12:10:00',1.87),('8537','2013-01-08','12:15:00',1.72),('8537','2013-01-08','12:20:00',1.52),('8537','2013-01-08','12:25:00',1.49),('8537','2013-01-08','12:30:00',1.43),('8537','2013-01-08','12:35:00',1.41),('8537','2013-01-08','12:40:00',1.83),('8537','2013-01-08','12:45:00',2.27),('8537','2013-01-08','12:50:00',2.97),('8537','2013-01-08','12:55:00',2.11),('8537','2013-01-08','13:20:00',1.53),('8537','2013-01-08','13:25:00',1.14),('8537','2013-01-08','13:40:00',1.04),('8537','2013-01-08','13:45:00',1.29),('8537','2013-01-08','13:50:00',1.53),('8537','2013-01-08','13:55:00',1.65),('8537','2013-01-08','14:00:00',1.23),('8537','2013-01-08','14:05:00',1.63),('8537','2013-01-08','14:30:00',1.06),('8537','2013-01-08','14:35:00',1.05),('8537','2013-01-08','14:40:00',1.16),('8537','2013-01-07','08:45:00',1.05),('8537','2013-01-07','08:50:00',1.16),('8537','2013-01-07','08:55:00',1.24),('8537','2013-01-07','09:00:00',1.28),('8537','2013-01-07','09:05:00',1.15),('8537','2013-01-07','09:10:00',1.16),('8537','2013-01-07','09:20:00',1.52),('8537','2013-01-07','09:25:00',1.69),('8537','2013-01-07','09:30:00',1.72),('8537','2013-01-07','09:35:00',1.71),('8537','2013-01-07','09:40:00',1.74),('8537','2013-01-07','09:45:00',1.92),('8537','2013-01-07','09:50:00',1.96),('8537','2013-01-07','09:55:00',2.02),('8537','2013-01-07','10:00:00',2.09),('8537','2013-01-07','10:05:00',2.2),('8537','2013-01-07','10:10:00',2.26),('8537','2013-01-07','10:15:00',2.34),('8537','2013-01-07','10:20:00',2.35),('8537','2013-01-07','10:25:00',2.4),('8537','2013-01-07','10:30:00',2.5),('8537','2013-01-07','10:35:00',2.56),('8537','2013-01-07','10:40:00',2.65),('8537','2013-01-07','10:45:00',2.74),('8537','2013-01-07','10:50:00',2.75),('8537','2013-01-07','10:55:00',2.79),('8537','2013-01-07','11:00:00',2.86),('8537','2013-01-07','11:05:00',2.89),('8537','2013-01-07','11:10:00',2.98),('8537','2013-01-07','11:15:00',3.08),('8537','2013-01-07','11:20:00',3.09),('8537','2013-01-07','11:25:00',3.18),('8537','2013-01-07','11:30:00',3.17),('8537','2013-01-07','11:35:00',3.22),('8537','2013-01-07','11:40:00',3.22),('8537','2013-01-07','11:45:00',3.25),('8537','2013-01-07','11:50:00',3.28),('8537','2013-01-07','11:55:00',3.32),('8537','2013-01-07','12:00:00',3.34),('8537','2013-01-07','12:05:00',3.34),('8537','2013-01-07','12:10:00',3.34),('8537','2013-01-07','12:15:00',3.36),('8537','2013-01-07','12:20:00',3.33),('8537','2013-01-07','12:25:00',3.33),('8537','2013-01-07','12:30:00',3.31),('8537','2013-01-07','12:35:00',3.27),('8537','2013-01-07','12:40:00',3.24),('8537','2013-01-07','12:45:00',3.2),('8537','2013-01-07','12:50:00',3.17),('8537','2013-01-07','12:55:00',3.12),('8537','2013-01-07','13:00:00',3.09),('8537','2013-01-07','13:05:00',3.05),('8537','2013-01-07','13:10:00',2.98),('8537','2013-01-07','13:15:00',2.9),('8537','2013-01-07','13:20:00',2.83),('8537','2013-01-07','13:25:00',2.78),('8537','2013-01-07','13:30:00',2.73),('8537','2013-01-07','13:35:00',2.64),('8537','2013-01-07','13:40:00',2.56),('8537','2013-01-07','13:45:00',2.48),('8537','2013-01-07','13:50:00',2.38),('8537','2013-01-07','13:55:00',2.29),('8537','2013-01-07','14:00:00',2.23),('8537','2013-01-07','14:05:00',2.11),('8537','2013-01-07','14:10:00',2.01),('8537','2013-01-07','14:15:00',2.06),('8537','2013-01-07','14:20:00',2.07),('8537','2013-01-07','14:25:00',2),('8537','2013-01-07','14:30:00',1.93),('8537','2013-01-07','14:35:00',1.88),('8537','2013-01-07','14:40:00',1.83),('8537','2013-01-07','14:45:00',1.74),('8537','2013-01-07','14:50:00',1.71),('8537','2013-01-07','14:55:00',1.62),('8537','2013-01-07','15:00:00',1.53),('8537','2013-01-07','15:05:00',1.49),('8537','2013-01-07','15:10:00',1.39),('8537','2013-01-07','15:15:00',1.31),('8537','2013-01-07','15:20:00',1.29),('8537','2013-01-07','15:25:00',1.13),('8537','2013-01-07','15:30:00',1.14),('8537','2013-01-07','15:35:00',1.11),('8537','2013-01-07','15:40:00',1.01),('8537','2013-01-06','08:40:00',1.07),('8537','2013-01-06','08:45:00',1.15),('8537','2013-01-06','08:50:00',1.24),('8537','2013-01-06','08:55:00',1.29),('8537','2013-01-06','09:00:00',1.39),('8537','2013-01-06','09:05:00',1.46),('8537','2013-01-06','09:10:00',1.54),('8537','2013-01-06','09:15:00',1.63),('8537','2013-01-06','09:20:00',1.68),('8537','2013-01-06','09:25:00',1.74),('8537','2013-01-06','09:30:00',1.79),('8537','2013-01-06','09:35:00',1.76),('8537','2013-01-06','09:40:00',1.86),('8537','2013-01-06','09:45:00',1.98),('8537','2013-01-06','09:50:00',2.06),('8537','2013-01-06','09:55:00',2.1),('8537','2013-01-06','10:00:00',2.18),('8537','2013-01-06','10:05:00',2.23),('8537','2013-01-06','10:10:00',2.29),('8537','2013-01-06','10:15:00',2.32),('8537','2013-01-06','10:20:00',2.34),('8537','2013-01-06','10:25:00',2.42),('8537','2013-01-06','10:30:00',2.51),('8537','2013-01-06','10:35:00',2.61),('8537','2013-01-06','10:40:00',2.69),('8537','2013-01-06','10:45:00',2.77),('8537','2013-01-06','10:50:00',2.84),('8537','2013-01-06','10:55:00',2.9),('8537','2013-01-06','11:00:00',2.36),('8537','2013-01-06','11:05:00',2.99),('8537','2013-01-06','11:10:00',3.02),('8537','2013-01-06','11:15:00',3.08),('8537','2013-01-06','11:20:00',3.11),('8537','2013-01-06','11:25:00',3.17),('8537','2013-01-06','11:30:00',3.22),('8537','2013-01-06','11:35:00',3.24),('8537','2013-01-06','11:40:00',3.25),('8537','2013-01-06','11:45:00',3.27),('8537','2013-01-06','11:50:00',3.29),('8537','2013-01-06','11:55:00',3.32),('8537','2013-01-06','12:00:00',3.32),('8537','2013-01-06','12:05:00',3.34),('8537','2013-01-06','12:10:00',3.33),('8537','2013-01-06','12:15:00',3.3),('8537','2013-01-06','12:20:00',3.29),('8537','2013-01-06','12:25:00',3.17),('8537','2013-01-06','12:30:00',3.22),('8537','2013-01-06','12:35:00',3.15),('8537','2013-01-06','12:40:00',3.13),('8537','2013-01-06','12:45:00',3.15),('8537','2013-01-06','12:50:00',3.14),('8537','2013-01-06','12:55:00',3.14),('8537','2013-01-06','13:00:00',3.13),('8537','2013-01-06','13:05:00',3.06),('8537','2013-01-06','13:10:00',3.01),('8537','2013-01-06','13:15:00',2.94),('8537','2013-01-06','13:20:00',2.9),('8537','2013-01-06','13:25:00',2.83),('8537','2013-01-06','13:30:00',2.76),('8537','2013-01-06','13:35:00',2.69),('8537','2013-01-06','13:40:00',2.6),('8537','2013-01-06','13:45:00',2.52),('8537','2013-01-06','13:50:00',2.4),('8537','2013-01-06','13:55:00',2.31),('8537','2013-01-06','14:00:00',2.29),('8537','2013-01-06','14:05:00',2.26),('8537','2013-01-06','14:10:00',2.04),('8537','2013-01-06','14:15:00',1.85),('8537','2013-01-06','14:20:00',1.97),('8537','2013-01-06','14:25:00',1.89),('8537','2013-01-06','14:30:00',1.9),('8537','2013-01-06','14:35:00',1.83),('8537','2013-01-06','14:40:00',1.74),('8537','2013-01-06','14:45:00',1.68),('8537','2013-01-06','14:50:00',1.62),('8537','2013-01-06','14:55:00',1.55),('8537','2013-01-06','15:00:00',1.49),('8537','2013-01-06','15:05:00',1.38),('8537','2013-01-06','15:10:00',1.3),('8537','2013-01-06','15:15:00',1.25),('8537','2013-01-06','15:20:00',1.16),('8537','2013-01-06','15:25:00',1),('8537','2013-01-05','10:05:00',1.14),('8537','2013-01-05','10:10:00',1.28),('8537','2013-01-05','10:15:00',1.36),('8537','2013-01-05','10:20:00',1.24),('8537','2013-01-05','10:25:00',1.08),('8537','2013-01-05','10:30:00',1.11),('8537','2013-01-05','10:35:00',1.27),('8537','2013-01-05','10:40:00',1.35),('8537','2013-01-05','10:45:00',1.33),('8537','2013-01-05','10:50:00',1.55),('8537','2013-01-05','10:55:00',2.54),('8537','2013-01-05','11:00:00',2.17),('8537','2013-01-05','11:05:00',2.49),('8537','2013-01-05','11:10:00',2.48),('8537','2013-01-05','11:15:00',2.08),('8537','2013-01-05','11:20:00',2.78),('8537','2013-01-05','11:25:00',2.92),('8537','2013-01-05','11:30:00',2.95),('8537','2013-01-05','11:35:00',2.75),('8537','2013-01-05','11:40:00',2.49),('8537','2013-01-05','11:45:00',2.51),('8537','2013-01-05','11:50:00',2.18),('8537','2013-01-05','11:55:00',1.98),('8537','2013-01-05','12:00:00',1.84),('8537','2013-01-05','12:05:00',1.81),('8537','2013-01-05','12:10:00',1.79),('8537','2013-01-05','12:15:00',1.8),('8537','2013-01-05','12:20:00',1.63),('8537','2013-01-05','12:25:00',1.38),('8537','2013-01-05','12:30:00',1.43),('8537','2013-01-05','12:35:00',1.96),('8537','2013-01-05','12:40:00',2.4),('8537','2013-01-05','12:45:00',2.73),('8537','2013-01-05','12:50:00',1.71),('8537','2013-01-05','12:55:00',1.42),('8537','2013-01-05','13:00:00',1.5),('8537','2013-01-05','13:05:00',1.39),('8537','2013-01-05','13:10:00',1.34),('8537','2013-01-05','13:15:00',1.23),('8537','2013-01-05','13:20:00',1.22),('8537','2013-01-05','13:25:00',1.25),('8537','2013-01-05','13:30:00',2.12),('8537','2013-01-05','13:35:00',1.87),('8537','2013-01-05','13:40:00',1.34),('8537','2013-01-05','13:45:00',1.09),('8537','2013-01-05','13:50:00',1.21),('8537','2013-01-05','13:55:00',1.35),('8537','2013-01-05','14:00:00',1.26),('8537','2013-01-05','14:05:00',1.87),('8537','2013-01-05','14:10:00',1.72),('8537','2013-01-05','14:15:00',1.32),('8537','2013-01-05','14:20:00',1.18),('8537','2013-01-05','14:30:00',1.29),('8537','2013-01-05','14:35:00',1.28),('8537','2013-01-05','14:40:00',1.36),('8537','2013-01-05','14:45:00',1.41),('8537','2013-01-05','15:00:00',1.23),('8537','2013-01-05','15:05:00',1),('8537','2013-01-04','08:45:00',1.15),('8537','2013-01-04','08:50:00',1.25),('8537','2013-01-04','08:55:00',1.22),('8537','2013-01-04','09:00:00',1.27),('8537','2013-01-04','09:05:00',1.36),('8537','2013-01-04','09:10:00',1.44),('8537','2013-01-04','09:15:00',1.12),('8537','2013-01-04','09:20:00',1.45),('8537','2013-01-04','09:25:00',1.32),('8537','2013-01-04','09:30:00',1.31),('8537','2013-01-04','09:35:00',1.21),('8537','2013-01-04','09:40:00',1.3),('8537','2013-01-04','09:45:00',1.32),('8537','2013-01-04','09:50:00',1.43),('8537','2013-01-04','09:55:00',1.83),('8537','2013-01-04','10:00:00',2.24),('8537','2013-01-04','10:05:00',2.29),('8537','2013-01-04','10:10:00',1.96),('8537','2013-01-04','10:15:00',2.3),('8537','2013-01-04','10:20:00',1.97),('8537','2013-01-04','10:25:00',2.31),('8537','2013-01-04','10:30:00',2.47),('8537','2013-01-04','10:35:00',2.57),('8537','2013-01-04','10:40:00',2.67),('8537','2013-01-04','10:45:00',2.87),('8537','2013-01-04','10:50:00',3.06),('8537','2013-01-04','10:55:00',3.2),('8537','2013-01-04','11:00:00',2.83),('8537','2013-01-04','11:05:00',1.71),('8537','2013-01-04','11:10:00',1.08),('8537','2013-01-04','11:15:00',1.17),('8537','2013-01-04','11:20:00',1.37),('8537','2013-01-04','11:25:00',1.06),('8537','2013-01-04','11:30:00',1.09),('8537','2013-01-04','11:35:00',1.61),('8537','2013-01-04','11:40:00',1.31),('8537','2013-01-04','11:45:00',1.94),('8537','2013-01-04','11:50:00',3.07),('8537','2013-01-04','11:55:00',3.72),('8537','2013-01-04','12:00:00',3.71),('8537','2013-01-04','12:05:00',3.18),('8537','2013-01-04','12:10:00',2.51),('8537','2013-01-04','12:15:00',1.66),('8537','2013-01-04','12:20:00',1.31),('8537','2013-01-04','12:25:00',1.52),('8537','2013-01-04','12:30:00',2.32),('8537','2013-01-04','12:35:00',2.13),('8537','2013-01-04','12:40:00',3.15),('8537','2013-01-04','12:45:00',3.24),('8537','2013-01-04','12:50:00',3.27),('8537','2013-01-04','12:55:00',3.19),('8537','2013-01-04','13:00:00',3.06),('8537','2013-01-04','13:05:00',2.92),('8537','2013-01-04','13:10:00',2.81),('8537','2013-01-04','13:15:00',2.43),('8537','2013-01-04','13:20:00',2.7),('8537','2013-01-04','13:25:00',2.59),('8537','2013-01-04','13:30:00',2.52),('8537','2013-01-04','13:35:00',2.41),('8537','2013-01-04','13:40:00',2.33),('8537','2013-01-04','13:45:00',2.24),('8537','2013-01-04','13:50:00',2.2),('8537','2013-01-04','13:55:00',2.1),('8537','2013-01-04','14:00:00',2.06),('8537','2013-01-04','14:05:00',2.04),('8537','2013-01-04','14:10:00',1.97),('8537','2013-01-04','14:15:00',1.92),('8537','2013-01-04','14:20:00',1.9),('8537','2013-01-04','14:25:00',1.85),('8537','2013-01-04','14:30:00',1.79),('8537','2013-01-04','14:35:00',1.75),('8537','2013-01-04','14:40:00',1.69),('8537','2013-01-04','14:45:00',1.58),('8537','2013-01-04','14:50:00',1.52),('8537','2013-01-04','14:55:00',1.48),('8537','2013-01-04','15:00:00',1.43),('8537','2013-01-04','15:05:00',1.31),('8537','2013-01-04','15:10:00',1.13),('8537','2013-01-04','15:15:00',1.16),('8537','2013-01-04','15:20:00',1.05),('8537','2013-01-03','08:40:00',1.02),('8537','2013-01-03','08:45:00',1.09),('8537','2013-01-03','08:50:00',1.16),('8537','2013-01-03','08:55:00',1.21),('8537','2013-01-03','09:00:00',1.33),('8537','2013-01-03','09:05:00',1.42),('8537','2013-01-03','09:10:00',1.52),('8537','2013-01-03','09:15:00',1.6),('8537','2013-01-03','09:20:00',1.68),('8537','2013-01-03','09:25:00',1.75),('8537','2013-01-03','09:30:00',1.77),('8537','2013-01-03','09:35:00',1.75),('8537','2013-01-03','09:40:00',1.87),('8537','2013-01-03','09:45:00',2.14),('8537','2013-01-03','09:50:00',2.31),('8537','2013-01-03','09:55:00',2.46),('8537','2013-01-03','10:00:00',2.55),('8537','2013-01-03','10:05:00',2.61),('8537','2013-01-03','10:10:00',2.63),('8537','2013-01-03','10:15:00',2.9),('8537','2013-01-03','10:20:00',2.47),('8537','2013-01-03','10:25:00',2.7),('8537','2013-01-03','10:30:00',2.29),('8537','2013-01-03','10:35:00',2.24),('8537','2013-01-03','10:40:00',2.15),('8537','2013-01-03','10:45:00',1.94),('8537','2013-01-03','10:50:00',1.96),('8537','2013-01-03','10:55:00',1.82),('8537','2013-01-03','11:00:00',2),('8537','2013-01-03','11:05:00',1.91),('8537','2013-01-03','11:10:00',1.82),('8537','2013-01-03','11:15:00',1.74),('8537','2013-01-03','11:20:00',1.55),('8537','2013-01-03','11:25:00',1.37),('8537','2013-01-03','11:30:00',1.33),('8537','2013-01-03','11:35:00',2.26),('8537','2013-01-03','11:40:00',3.45),('8537','2013-01-03','11:45:00',3.35),('8537','2013-01-03','11:50:00',3.32),('8537','2013-01-03','11:55:00',3.3),('8537','2013-01-03','12:00:00',3.28),('8537','2013-01-03','12:05:00',3.28),('8537','2013-01-03','12:10:00',3.28),('8537','2013-01-03','12:15:00',3.26),('8537','2013-01-03','12:20:00',3.28),('8537','2013-01-03','12:25:00',3.26),('8537','2013-01-03','12:30:00',3.23),('8537','2013-01-03','12:35:00',3.21),('8537','2013-01-03','12:40:00',3.17),('8537','2013-01-03','12:45:00',3.15),('8537','2013-01-03','12:50:00',3.1),('8537','2013-01-03','12:55:00',3.05),('8537','2013-01-03','13:00:00',2.97),('8537','2013-01-03','13:05:00',2.96),('8537','2013-01-03','13:10:00',2.91),('8537','2013-01-03','13:15:00',2.84),('8537','2013-01-03','13:20:00',2.77),('8537','2013-01-03','13:25:00',2.71),('8537','2013-01-03','13:30:00',2.62),('8537','2013-01-03','13:35:00',2.56),('8537','2013-01-03','13:40:00',2.47),('8537','2013-01-03','13:45:00',2.39),('8537','2013-01-03','13:50:00',2.29),('8537','2013-01-03','13:55:00',2.21),('8537','2013-01-03','14:00:00',2.15),('8537','2013-01-03','14:05:00',2.2),('8537','2013-01-03','14:10:00',2.16),('8537','2013-01-03','14:15:00',2.13),('8537','2013-01-03','14:20:00',2.06),('8537','2013-01-03','14:25:00',2.01),('8537','2013-01-03','14:30:00',1.95),('8537','2013-01-03','14:35:00',1.89),('8537','2013-01-03','14:40:00',1.82),('8537','2013-01-03','14:45:00',1.74),('8537','2013-01-03','14:50:00',1.71),('8537','2013-01-03','14:55:00',1.64),('8537','2013-01-03','15:00:00',1.56),('8537','2013-01-03','15:05:00',1.47),('8537','2013-01-03','15:10:00',1.33),('8537','2013-01-03','15:15:00',1.24),('8537','2013-01-03','15:20:00',1.07),('8537','2013-01-02','13:40:00',1.05),('8537','2013-01-02','13:45:00',1.03),('8537','2013-01-02','13:50:00',1.01),('8537','2014-03-18','07:50:00',1.19),('8537','2014-03-18','07:55:00',1.79),('8537','2014-03-18','08:00:00',1.36),('8537','2014-03-18','08:10:00',1.07),('8537','2014-03-18','08:15:00',1.11),('8537','2014-03-18','08:20:00',1.53),('8537','2014-03-18','08:25:00',1.26),('8537','2014-03-18','08:30:00',1.13),('8537','2014-03-18','08:45:00',1.01),('8537','2014-03-18','08:50:00',1.51),('8537','2014-03-18','08:55:00',3.07),('8537','2014-03-18','09:00:00',2.54),('8537','2014-03-18','09:05:00',1.75),('8537','2014-03-18','09:10:00',1.71),('8537','2014-03-18','09:15:00',3.16),('8537','2014-03-18','09:20:00',3.91),('8537','2014-03-18','09:25:00',2.98),('8537','2014-03-18','09:30:00',1.52),('8537','2014-03-18','09:35:00',2.01),('8537','2014-03-18','09:40:00',2.22),('8537','2014-03-18','09:45:00',1.86),('8537','2014-03-18','09:50:00',2.55),('8537','2014-03-18','09:55:00',2.62),('8537','2014-03-18','10:00:00',2.37),('8537','2014-03-18','10:05:00',2.67),('8537','2014-03-18','10:10:00',4.16),('8537','2014-03-18','10:15:00',4.03),('8537','2014-03-18','10:20:00',4.41),('8537','2014-03-18','10:25:00',4.61),('8537','2014-03-18','10:30:00',2.46),('8537','2014-03-18','10:35:00',4.86),('8537','2014-03-18','10:40:00',4.92),('8537','2014-03-18','10:45:00',3.19),('8537','2014-03-18','10:50:00',4.28),('8537','2014-03-18','10:55:00',3.66),('8537','2014-03-18','11:00:00',4.85),('8537','2014-03-18','11:05:00',3.09),('8537','2014-03-18','11:10:00',3.24),('8537','2014-03-18','11:15:00',1.83),('8537','2014-03-18','11:20:00',1.75),('8537','2014-03-18','11:25:00',2.12),('8537','2014-03-18','11:30:00',3.74),('8537','2014-03-18','11:35:00',3.21),('8537','2014-03-18','11:40:00',3.71),('8537','2014-03-18','11:45:00',2.9),('8537','2014-03-18','11:50:00',3.12),('8537','2014-03-18','11:55:00',2.03),('8537','2014-03-18','12:00:00',1.94),('8537','2014-03-18','12:05:00',2.09),('8537','2014-03-18','12:10:00',2.23),('8537','2014-03-18','12:15:00',3.83),('8537','2014-03-18','12:20:00',3.25),('8537','2014-03-18','12:25:00',3.6),('8537','2014-03-18','12:30:00',2.95),('8537','2014-03-18','12:35:00',5.18),('8537','2014-03-18','12:40:00',3.25),('8537','2014-03-18','12:45:00',3.99),('8537','2014-03-18','12:50:00',3.55),('8537','2014-03-18','12:55:00',3.01),('8537','2014-03-18','13:00:00',4.96),('8537','2014-03-18','13:05:00',4.87),('8537','2014-03-18','13:10:00',4.77),('8537','2014-03-18','13:15:00',4.64),('8537','2014-03-18','13:20:00',4.59),('8537','2014-03-18','13:25:00',4.3),('8537','2014-03-18','13:30:00',4.23),('8537','2014-03-18','13:35:00',4.29),('8537','2014-03-18','13:40:00',4.09),('8537','2014-03-18','13:45:00',3.79),('8537','2014-03-18','13:50:00',4.12),('8537','2014-03-18','13:55:00',4.21),('8537','2014-03-18','14:00:00',4.16),('8537','2014-03-18','14:05:00',4.03),('8537','2014-03-18','14:10:00',4.07),('8537','2014-03-18','14:15:00',4),('8537','2014-03-18','14:20:00',3.91),('8537','2014-03-18','14:25:00',3.66),('8537','2014-03-18','14:31:00',3.77),('8537','2014-03-18','14:35:00',3.73),('8537','2014-03-18','14:40:00',3.64),('8537','2014-03-18','14:45:00',3.53),('8537','2014-03-18','14:50:00',3.49),('8537','2014-03-18','14:55:00',3.42),('8537','2014-03-18','15:01:00',3.24),('8537','2014-03-18','15:05:00',3.18),('8537','2014-03-18','15:10:00',3.11),('8537','2014-03-18','15:15:00',3.06),('8537','2014-03-18','15:20:00',2.97),('8537','2014-03-18','15:25:00',2.89),('8537','2014-03-18','15:31:00',2.69),('8537','2014-03-18','15:35:00',2.64),('8537','2014-03-18','15:40:00',2.56),('8537','2014-03-18','15:45:00',2.44),('8537','2014-03-18','15:50:00',2.29),('8537','2014-03-18','15:55:00',2.18),('8537','2014-03-18','16:01:00',2.13),('8537','2014-03-18','16:05:00',2),('8537','2014-03-18','16:10:00',1.9),('8537','2014-03-18','16:15:00',1.8),('8537','2014-03-18','16:20:00',1.65),('8537','2014-03-18','16:25:00',1.55),('8537','2014-03-18','16:32:00',1.47),('8537','2014-03-18','16:35:00',1.28),('8537','2014-03-18','16:40:00',1.23),('8537','2014-03-18','16:45:00',1.1),('8537','2014-03-18','16:50:00',1.02),('8537','2013-01-01','08:40:00',1.01),('8537','2013-01-01','08:45:00',1.09),('8537','2013-01-01','08:50:00',1.15),('8537','2013-01-01','08:55:00',1.21),('8537','2013-01-01','09:00:00',1.31),('8537','2013-01-01','09:05:00',1.38),('8537','2013-01-01','09:10:00',1.46),('8537','2013-01-01','09:15:00',1.52),('8537','2013-01-01','09:20:00',1.59),('8537','2013-01-01','09:25:00',1.66),('8537','2013-01-01','09:30:00',1.66),('8537','2013-01-01','09:35:00',1.66),('8537','2013-01-01','09:40:00',1.82),('8537','2013-01-01','09:45:00',1.9),('8537','2013-01-01','09:50:00',1.96),('8537','2013-01-01','09:55:00',2.01),('8537','2013-01-01','10:00:00',2.03),('8537','2013-01-01','10:05:00',2.09),('8537','2013-01-01','10:10:00',2.14),('8537','2013-01-01','10:15:00',2.18),('8537','2013-01-01','10:20:00',2.22),('8537','2013-01-01','10:25:00',2.27),('8537','2013-01-01','10:30:00',2.34),('8537','2013-01-01','10:35:00',2.37),('8537','2013-01-01','10:40:00',2.47),('8537','2013-01-01','10:45:00',2.63),('8537','2013-01-01','10:50:00',2.5),('8537','2013-01-01','10:55:00',1.7),('8537','2013-01-01','11:05:00',2.88),('8537','2013-01-01','11:10:00',2.97),('8537','2013-01-01','11:15:00',2.68),('8537','2013-01-01','11:20:00',1.97),('8537','2013-01-01','11:25:00',2.57),('8537','2013-01-01','11:30:00',2.92),('8537','2013-01-01','11:35:00',1.67),('8537','2013-01-01','11:40:00',2.19),('8537','2013-01-01','11:45:00',2.88),('8537','2013-01-01','11:50:00',2.77),('8537','2013-01-01','11:55:00',2.29),('8537','2013-01-01','12:00:00',1.69),('8537','2013-01-01','12:05:00',1.37),('8537','2013-01-01','12:10:00',1.48),('8537','2013-01-01','12:15:00',1.5),('8537','2013-01-01','12:20:00',1.49),('8537','2013-01-01','12:25:00',1.39),('8537','2013-01-01','12:30:00',1.22),('8537','2013-01-01','12:35:00',1.2),('8537','2013-01-01','12:40:00',1.32),('8537','2013-01-01','12:45:00',1.53),('8537','2013-01-01','12:50:00',1.32),('8537','2013-01-01','12:55:00',1.4),('8537','2013-01-01','13:00:00',1.11),('8537','2013-01-01','13:05:00',1.15),('8537','2012-12-31','08:30:00',1.03),('8537','2012-12-31','08:35:00',1.04),('8537','2012-12-31','09:00:00',1.02),('8537','2012-12-31','09:05:00',1.1),('8537','2012-12-31','09:10:00',1.15),('8537','2012-12-31','09:15:00',1.54),('8537','2012-12-31','09:20:00',1.71),('8537','2012-12-31','09:25:00',1.9),('8537','2012-12-31','09:30:00',1.81),('8537','2012-12-31','10:00:00',1.12),('8537','2012-12-31','10:10:00',1.7),('8537','2012-12-31','10:15:00',2.38),('8537','2012-12-31','10:20:00',2.54),('8537','2012-12-31','10:25:00',2.52),('8537','2012-12-31','10:30:00',2.54),('8537','2012-12-31','10:35:00',2.57),('8537','2012-12-31','10:40:00',2.66),('8537','2012-12-31','10:45:00',2.65),('8537','2012-12-31','10:50:00',2.68),('8537','2012-12-31','10:55:00',2.78),('8537','2012-12-31','11:00:00',2.84),('8537','2012-12-31','11:05:00',2.83),('8537','2012-12-31','11:10:00',2.8),('8537','2012-12-31','11:15:00',2.89),('8537','2012-12-31','11:20:00',3.03),('8537','2012-12-31','11:25:00',3.09),('8537','2012-12-31','11:30:00',3.14),('8537','2012-12-31','11:35:00',3.18),('8537','2012-12-31','11:40:00',3.22),('8537','2012-12-31','11:45:00',3.23),('8537','2012-12-31','11:50:00',3.25),('8537','2012-12-31','11:55:00',3.28),('8537','2012-12-31','12:00:00',3.3),('8537','2012-12-31','12:05:00',3.34),('8537','2012-12-31','12:10:00',3.34),('8537','2012-12-31','12:15:00',3.33),('8537','2012-12-31','12:20:00',3.33),('8537','2012-12-31','12:25:00',3.31),('8537','2012-12-31','12:30:00',3.26),('8537','2012-12-31','12:35:00',3.24),('8537','2012-12-31','12:40:00',3.21),('8537','2012-12-31','12:45:00',3.16),('8537','2012-12-31','12:50:00',3.12),('8537','2012-12-31','12:55:00',3.1),('8537','2012-12-31','13:00:00',3.02),('8537','2012-12-31','13:05:00',2.96),('8537','2012-12-31','13:10:00',2.92),('8537','2012-12-31','13:15:00',2.85),('8537','2012-12-31','13:20:00',2.76),('8537','2012-12-31','13:25:00',2.7),('8537','2012-12-31','13:30:00',2.62),('8537','2012-12-31','13:35:00',2.55),('8537','2012-12-31','13:40:00',2.48),('8537','2012-12-31','13:45:00',2.4),('8537','2012-12-31','13:50:00',2.32),('8537','2012-12-31','13:55:00',2.33),('8537','2012-12-31','14:00:00',2.26),('8537','2012-12-31','14:05:00',2.21),('8537','2012-12-31','14:10:00',2.14),('8537','2012-12-31','14:15:00',2.12),('8537','2012-12-31','14:20:00',2.06),('8537','2012-12-31','14:25:00',1.99),('8537','2012-12-31','14:30:00',1.94),('8537','2012-12-31','14:35:00',1.9),('8537','2012-12-31','14:40:00',1.82),('8537','2012-12-31','14:45:00',1.74),('8537','2012-12-31','14:50:00',1.7),('8537','2012-12-31','14:55:00',1.62),('8537','2012-12-31','15:00:00',1.55),('8537','2012-12-31','15:05:00',1.47),('8537','2012-12-31','15:10:00',1.37),('8537','2012-12-31','15:15:00',1.28),('8537','2012-12-31','15:20:00',1.1),('8537','2012-12-31','15:25:00',1.1),('8537','2012-12-31','15:30:00',1.05),('8537','2012-12-30','08:40:00',1.06),('8537','2012-12-30','08:45:00',1.15),('8537','2012-12-30','08:50:00',1.21),('8537','2012-12-30','08:55:00',1.29),('8537','2012-12-30','09:00:00',1.37),('8537','2012-12-30','09:05:00',1.46),('8537','2012-12-30','09:10:00',1.56),('8537','2012-12-30','09:15:00',1.62),('8537','2012-12-30','09:20:00',1.7),('8537','2012-12-30','09:25:00',1.77),('8537','2012-12-30','09:30:00',1.76),('8537','2012-12-30','09:35:00',1.77),('8537','2012-12-30','09:40:00',1.94),('8537','2012-12-30','09:45:00',2),('8537','2012-12-30','09:50:00',2.06),('8537','2012-12-30','09:55:00',2.1),('8537','2012-12-30','10:00:00',2.17),('8537','2012-12-30','10:05:00',2.25),('8537','2012-12-30','10:10:00',2.31),('8537','2012-12-30','10:15:00',2.36),('8537','2012-12-30','10:20:00',2.39),('8537','2012-12-30','10:25:00',2.41),('8537','2012-12-30','10:30:00',2.45),('8537','2012-12-30','10:35:00',2.49),('8537','2012-12-30','10:40:00',2.55),('8537','2012-12-30','10:45:00',2.67),('8537','2012-12-30','10:50:00',2.7),('8537','2012-12-30','10:55:00',2.73),('8537','2012-12-30','11:00:00',2.83),('8537','2012-12-30','11:05:00',2.89),('8537','2012-12-30','11:10:00',2.93),('8537','2012-12-30','11:15:00',2.99),('8537','2012-12-30','11:20:00',3.03),('8537','2012-12-30','11:25:00',3.04),('8537','2012-12-30','11:30:00',3.11),('8537','2012-12-30','11:35:00',3.14),('8537','2012-12-30','11:40:00',3.17),('8537','2012-12-30','11:45:00',3.2),('8537','2012-12-30','11:50:00',3.2),('8537','2012-12-30','11:55:00',3.18),('8537','2012-12-30','12:00:00',3.2),('8537','2012-12-30','12:05:00',3.2),('8537','2012-12-30','12:10:00',3.2),('8537','2012-12-30','12:15:00',3.2),('8537','2012-12-30','12:20:00',3.2),('8537','2012-12-30','12:25:00',3.18),('8537','2012-12-30','12:30:00',3.12),('8537','2012-12-30','12:35:00',3.1),('8537','2012-12-30','12:40:00',3.06),('8537','2012-12-30','12:45:00',3.02),('8537','2012-12-30','12:50:00',2.97),('8537','2012-12-30','12:55:00',2.92),('8537','2012-12-30','13:00:00',2.95),('8537','2012-12-30','13:05:00',2.94),('8537','2012-12-30','13:10:00',2.85),('8537','2012-12-30','13:15:00',2.81),('8537','2012-12-30','13:20:00',2.73),('8537','2012-12-30','13:25:00',2.65),('8537','2012-12-30','13:30:00',2.58),('8537','2012-12-30','13:35:00',2.52),('8537','2012-12-30','13:40:00',2.4),('8537','2012-12-30','13:45:00',2.45),('8537','2012-12-30','13:50:00',2.4),('8537','2012-12-30','13:55:00',2.35),('8537','2012-12-30','14:00:00',2.33),('8537','2012-12-30','14:05:00',2.26),('8537','2012-12-30','14:10:00',2.19),('8537','2012-12-30','14:15:00',2.15),('8537','2012-12-30','14:20:00',2.09),('8537','2012-12-30','14:25:00',2.02),('8537','2012-12-30','14:30:00',1.94),('8537','2012-12-30','14:35:00',1.89),('8537','2012-12-30','14:40:00',1.83),('8537','2012-12-30','14:45:00',1.76),('8537','2012-12-30','14:50:00',1.71),('8537','2012-12-30','14:55:00',1.62),('8537','2012-12-30','15:00:00',1.52),('8537','2012-12-30','15:05:00',1.44),('8537','2012-12-30','15:10:00',1.36),('8537','2012-12-30','15:15:00',1.26),('8537','2012-12-30','15:20:00',1.07),('8537','2012-12-30','15:30:00',1),('8537','2012-12-29','08:35:00',1),('8537','2012-12-29','08:40:00',1.12),('8537','2012-12-29','08:45:00',1.22),('8537','2012-12-29','08:50:00',1.29),('8537','2012-12-29','08:55:00',1.35),('8537','2012-12-29','09:00:00',1.42),('8537','2012-12-29','09:05:00',1.5),('8537','2012-12-29','09:10:00',1.6),('8537','2012-12-29','09:15:00',1.67),('8537','2012-12-29','09:20:00',1.73),('8537','2012-12-29','09:25:00',1.78),('8537','2012-12-29','09:30:00',1.76),('8537','2012-12-29','09:35:00',1.81),('8537','2012-12-29','09:40:00',1.97),('8537','2012-12-29','09:45:00',2.06),('8537','2012-12-29','09:50:00',2.13),('8537','2012-12-29','09:55:00',2.2),('8537','2012-12-29','10:00:00',2.26),('8537','2012-12-29','10:05:00',2.32),('8537','2012-12-29','10:10:00',2.34),('8537','2012-12-29','10:15:00',2.43),('8537','2012-12-29','10:20:00',2.46),('8537','2012-12-29','10:25:00',2.5),('8537','2012-12-29','10:30:00',2.53),('8537','2012-12-29','10:35:00',2.55),('8537','2012-12-29','10:40:00',2.59),('8537','2012-12-29','10:45:00',2.74),('8537','2012-12-29','10:50:00',2.8),('8537','2012-12-29','10:55:00',2.81),('8537','2012-12-29','11:00:00',2.93),('8537','2012-12-29','11:05:00',2.97),('8537','2012-12-29','11:10:00',3.03),('8537','2012-12-29','11:15:00',3.08),('8537','2012-12-29','11:20:00',3.13),('8537','2012-12-29','11:25:00',3.16),('8537','2012-12-29','11:30:00',3.18),('8537','2012-12-29','11:35:00',3.24),('8537','2012-12-29','11:40:00',3.24),('8537','2012-12-29','11:45:00',3.25),('8537','2012-12-29','11:50:00',3.28),('8537','2012-12-29','11:55:00',3.28),('8537','2012-12-29','12:00:00',3.3),('8537','2012-12-29','12:05:00',3.32),('8537','2012-12-29','12:10:00',3.33),('8537','2012-12-29','12:15:00',3.29),('8537','2012-12-29','12:20:00',3.24),('8537','2012-12-29','12:25:00',3.22),('8537','2012-12-29','12:30:00',3.21),('8537','2012-12-29','12:35:00',3.23),('8537','2012-12-29','12:40:00',3.19),('8537','2012-12-29','12:45:00',3.11),('8537','2012-12-29','12:50:00',3.05),('8537','2012-12-29','12:55:00',3.02),('8537','2012-12-29','13:00:00',3),('8537','2012-12-29','13:05:00',2.96),('8537','2012-12-29','13:10:00',2.89),('8537','2012-12-29','13:15:00',2.87),('8537','2012-12-29','13:20:00',2.77),('8537','2012-12-29','13:25:00',2.69),('8537','2012-12-29','13:30:00',2.6),('8537','2012-12-29','13:35:00',2.53),('8537','2012-12-29','13:40:00',2.45),('8537','2012-12-29','13:45:00',2.46),('8537','2012-12-29','13:50:00',2.43),('8537','2012-12-29','13:55:00',2.39),('8537','2012-12-29','14:00:00',2.34),('8537','2012-12-29','14:05:00',2.28),('8537','2012-12-29','14:10:00',2.24),('8537','2012-12-29','14:15:00',2.17),('8537','2012-12-29','14:20:00',2.13),('8537','2012-12-29','14:25:00',2.07),('8537','2012-12-29','14:30:00',2),('8537','2012-12-29','14:35:00',1.93),('8537','2012-12-29','14:40:00',1.87),('8537','2012-12-29','14:45:00',1.81),('8537','2012-12-29','14:50:00',1.77),('8537','2012-12-29','14:55:00',1.69),('8537','2012-12-29','15:00:00',1.62),('8537','2012-12-29','15:05:00',1.53),('8537','2012-12-29','15:10:00',1.44),('8537','2012-12-29','15:15:00',1.34),('8537','2012-12-29','15:20:00',1.25),('8537','2012-12-29','15:25:00',1.18),('8537','2012-12-29','15:30:00',1.08),('8537','2012-12-28','08:50:00',1.09),('8537','2012-12-28','08:55:00',1.2),('8537','2012-12-28','09:00:00',1.29),('8537','2012-12-28','09:05:00',1.38),('8537','2012-12-28','09:10:00',1.46),('8537','2012-12-28','09:15:00',1.52),('8537','2012-12-28','09:20:00',1.58),('8537','2012-12-28','09:25:00',1.61),('8537','2012-12-28','09:30:00',1.65),('8537','2012-12-28','09:35:00',1.73),('8537','2012-12-28','09:40:00',1.79),('8537','2012-12-28','09:45:00',1.84),('8537','2012-12-28','09:50:00',1.86),('8537','2012-12-28','09:55:00',1.92),('8537','2012-12-28','10:00:00',2.01),('8537','2012-12-28','10:05:00',2.09),('8537','2012-12-28','10:10:00',2.17),('8537','2012-12-28','10:15:00',2.25),('8537','2012-12-28','10:20:00',2.28),('8537','2012-12-28','10:25:00',2.32),('8537','2012-12-28','10:30:00',2.38),('8537','2012-12-28','10:35:00',2.45),('8537','2012-12-28','10:40:00',2.48),('8537','2012-12-28','10:45:00',2.54),('8537','2012-12-28','10:50:00',2.58),('8537','2012-12-28','10:55:00',2.64),('8537','2012-12-28','11:00:00',2.68),('8537','2012-12-28','11:05:00',2.8),('8537','2012-12-28','11:10:00',2.89),('8537','2012-12-28','11:15:00',2.92),('8537','2012-12-28','11:20:00',2.96),('8537','2012-12-28','11:25:00',2.99),('8537','2012-12-28','11:30:00',2.74),('8537','2012-12-28','11:35:00',3.08),('8537','2012-12-28','11:40:00',3.1),('8537','2012-12-28','11:45:00',3.05),('8537','2012-12-28','11:50:00',3.15),('8537','2012-12-28','11:55:00',2.96),('8537','2012-12-28','12:00:00',2.59),('8537','2012-12-28','12:05:00',2.39),('8537','2012-12-28','12:10:00',2.93),('8537','2012-12-28','12:15:00',3),('8537','2012-12-28','12:20:00',3.12),('8537','2012-12-28','12:25:00',3.05),('8537','2012-12-28','12:30:00',3.03),('8537','2012-12-28','12:35:00',2.96),('8537','2012-12-28','12:40:00',2.57),('8537','2012-12-28','12:45:00',2.73),('8537','2012-12-28','12:50:00',2.94),('8537','2012-12-28','12:55:00',2.89),('8537','2012-12-28','13:00:00',2.82),('8537','2012-12-28','13:05:00',2.77),('8537','2012-12-28','13:10:00',2.71),('8537','2012-12-28','13:15:00',2.58),('8537','2012-12-28','13:20:00',2.56),('8537','2012-12-28','13:25:00',2.49),('8537','2012-12-28','13:30:00',2.42),('8537','2012-12-28','13:35:00',2.32),('8537','2012-12-28','13:40:00',2.23),('8537','2012-12-28','13:45:00',2.15),('8537','2012-12-28','13:50:00',2.25),('8537','2012-12-28','13:55:00',2.17),('8537','2012-12-28','14:00:00',2.1),('8537','2012-12-28','14:05:00',2.04),('8537','2012-12-28','14:10:00',1.7),('8537','2012-12-28','14:15:00',1.88),('8537','2012-12-28','14:20:00',1.86),('8537','2012-12-28','14:25:00',1.83),('8537','2012-12-28','14:30:00',1.72),('8537','2012-12-28','14:35:00',1.52),('8537','2012-12-28','14:45:00',1.45),('8537','2012-12-28','14:50:00',1.54),('8537','2012-12-28','14:55:00',1.47),('8537','2012-12-28','15:00:00',1.41),('8537','2012-12-28','15:05:00',1.32),('8537','2012-12-28','15:10:00',1.24),('8537','2012-12-28','15:15:00',1.12),('8537','2012-12-28','15:20:00',1.05),('8537','2012-12-27','09:20:00',1.08),('8537','2012-12-27','09:25:00',1.1),('8537','2012-12-27','09:30:00',1.2),('8537','2012-12-27','09:35:00',1.5),('8537','2012-12-27','09:40:00',1.43),('8537','2012-12-27','09:45:00',1.48),('8537','2012-12-27','09:50:00',1.97),('8537','2012-12-27','09:55:00',1.38),('8537','2012-12-27','10:00:00',1.12),('8537','2012-12-27','10:05:00',1.22),('8537','2012-12-27','10:10:00',1.78),('8537','2012-12-27','10:15:00',2.1),('8537','2012-12-27','10:20:00',2.08),('8537','2012-12-27','10:25:00',2.06),('8537','2012-12-27','10:30:00',2.1),('8537','2012-12-27','10:35:00',2.24),('8537','2012-12-27','10:40:00',2.33),('8537','2012-12-27','10:45:00',2.42),('8537','2012-12-27','10:50:00',2.36),('8537','2012-12-27','10:55:00',2.45),('8537','2012-12-27','11:00:00',2.5),('8537','2012-12-27','11:05:00',2.56),('8537','2012-12-27','11:10:00',2.72),('8537','2012-12-27','11:15:00',1.52),('8537','2012-12-27','11:20:00',1.29),('8537','2012-12-27','11:50:00',1.27),('8537','2012-12-27','11:55:00',2.73),('8537','2012-12-27','12:00:00',2.79),('8537','2012-12-27','12:05:00',3.07),('8537','2012-12-27','12:10:00',3.3),('8537','2012-12-27','12:15:00',2.53),('8537','2012-12-27','12:20:00',1.6),('8537','2012-12-27','12:25:00',2.69),('8537','2012-12-27','12:30:00',2.72),('8537','2012-12-27','12:35:00',2.87),('8537','2012-12-27','12:40:00',2.87),('8537','2012-12-27','12:45:00',3.22),('8537','2012-12-27','12:50:00',2.78),('8537','2012-12-27','12:55:00',2.81),('8537','2012-12-27','13:00:00',2.71),('8537','2012-12-27','13:05:00',2.85),('8537','2012-12-27','13:10:00',2.36),('8537','2012-12-27','13:15:00',2.71),('8537','2012-12-27','13:20:00',2.43),('8537','2012-12-27','13:25:00',2.47),('8537','2012-12-27','13:30:00',2.52),('8537','2012-12-27','14:00:00',1.1),('8537','2012-12-27','14:05:00',1.8),('8537','2012-12-27','14:10:00',2.1),('8537','2012-12-27','14:15:00',2.05),('8537','2012-12-27','14:20:00',1.92),('8537','2012-12-27','14:25:00',1.84),('8537','2012-12-27','14:30:00',1.8),('8537','2012-12-27','14:35:00',1.76),('8537','2012-12-27','14:40:00',1.66),('8537','2012-12-27','14:45:00',1.44),('8537','2012-12-27','15:00:00',1.22),('8537','2012-12-27','15:05:00',1.18),('8537','2012-12-26','09:20:00',1.52),('8537','2012-12-26','09:25:00',1.67),('8537','2012-12-26','09:30:00',1.63),('8537','2012-12-26','09:35:00',1.74),('8537','2012-12-26','09:40:00',1.82),('8537','2012-12-26','09:45:00',1.89),('8537','2012-12-26','09:50:00',1.95),('8537','2012-12-26','09:55:00',2.01),('8537','2012-12-26','10:00:00',2.07),('8537','2012-12-26','10:05:00',2.11),('8537','2012-12-26','10:10:00',2.16),('8537','2012-12-26','10:15:00',2.18),('8537','2012-12-26','10:20:00',2.19),('8537','2012-12-26','10:25:00',2.2),('8537','2012-12-26','10:30:00',2.23),('8537','2012-12-26','10:35:00',2.29),('8537','2012-12-26','10:40:00',2.36),('8537','2012-12-26','10:45:00',2.39),('8537','2012-12-26','10:50:00',2.43),('8537','2012-12-26','10:55:00',2.52),('8537','2012-12-26','11:00:00',2.57),('8537','2012-12-26','11:05:00',2.61),('8537','2012-12-26','11:10:00',2.66),('8537','2012-12-26','11:15:00',2.7),('8537','2012-12-26','11:20:00',2.74),('8537','2012-12-26','11:25:00',2.76),('8537','2012-12-26','11:30:00',2.77),('8537','2012-12-26','11:35:00',2.8),('8537','2012-12-26','11:40:00',2.85),('8537','2012-12-26','11:45:00',2.9),('8537','2012-12-26','11:50:00',2.95),('8537','2012-12-26','11:55:00',2.98),('8537','2012-12-26','12:00:00',3.03),('8537','2012-12-26','12:05:00',2.98),('8537','2012-12-26','12:10:00',2.99),('8537','2012-12-26','12:15:00',3.01),('8537','2012-12-26','12:20:00',3),('8537','2012-12-26','12:25:00',3),('8537','2012-12-26','12:30:00',2.98),('8537','2012-12-26','12:35:00',2.96),('8537','2012-12-26','12:40:00',2.93),('8537','2012-12-26','12:45:00',2.89),('8537','2012-12-26','12:50:00',2.82),('8537','2012-12-26','12:55:00',2.74),('8537','2012-12-26','13:00:00',2.82),('8537','2012-12-26','13:05:00',2.76),('8537','2012-12-26','13:10:00',2.76),('8537','2012-12-26','13:15:00',2.65),('8537','2012-12-26','13:20:00',2.72),('8537','2012-12-26','13:25:00',2.77),('8537','2012-12-26','13:30:00',2.85),('8537','2012-12-26','13:35:00',2.88),('8537','2012-12-26','13:40:00',2.81),('8537','2012-12-26','13:45:00',2.76),('8537','2012-12-26','13:50:00',2.53),('8537','2012-12-26','13:55:00',2.42),('8537','2012-12-26','14:00:00',2.26),('8537','2012-12-26','14:05:00',2.28),('8537','2012-12-25','11:25:00',1.07),('8537','2012-12-25','11:30:00',1.03),('8537','2012-12-25','11:50:00',1),('8537','2012-12-25','11:55:00',1.08),('8537','2012-12-25','12:00:00',1.09),('8537','2012-12-25','13:15:00',1.04),('8537','2012-12-25','13:20:00',1.04),('8537','2012-12-25','14:45:00',1.03),('8537','2012-12-25','14:50:00',1.05),('8537','2012-12-25','14:55:00',1.05),('8537','2012-12-25','15:00:00',1.01),('8537','2012-12-23','08:40:00',1.09),('8537','2012-12-23','08:45:00',1.19),('8537','2012-12-23','08:50:00',1.24),('8537','2012-12-23','08:55:00',1.35),('8537','2012-12-23','09:00:00',1.43),('8537','2012-12-23','09:05:00',1.53),('8537','2012-12-23','09:10:00',1.6),('8537','2012-12-23','09:15:00',1.62),('8537','2012-12-23','09:20:00',1.69),('8537','2012-12-23','09:25:00',1.74),('8537','2012-12-23','09:30:00',1.65),('8537','2012-12-23','09:35:00',1.82),('8537','2012-12-23','09:40:00',1.89),('8537','2012-12-23','09:45:00',1.94),('8537','2012-12-23','09:50:00',2),('8537','2012-12-23','09:55:00',2.04),('8537','2012-12-23','10:00:00',2.07),('8537','2012-12-23','10:05:00',2.15),('8537','2012-12-23','10:10:00',2.19),('8537','2012-12-23','10:15:00',2.21),('8537','2012-12-23','10:20:00',2.25),('8537','2012-12-23','10:25:00',2.24),('8537','2012-12-23','10:30:00',2.21),('8537','2012-12-23','10:35:00',2.28),('8537','2012-12-23','10:40:00',2.42),('8537','2012-12-23','10:45:00',2.51),('8537','2012-12-23','10:50:00',2.48),('8537','2012-12-23','10:55:00',2.42),('8537','2012-12-23','11:00:00',2.65),('8537','2012-12-23','11:05:00',2.71),('8537','2012-12-23','11:10:00',2.73),('8537','2012-12-23','11:15:00',2.79),('8537','2012-12-23','11:20:00',2.91),('8537','2012-12-23','11:25:00',2.64),('8537','2012-12-23','11:30:00',2.79),('8537','2012-12-23','11:35:00',2.98),('8537','2012-12-23','11:40:00',2.99),('8537','2012-12-23','11:45:00',2.95),('8537','2012-12-23','11:50:00',3.05),('8537','2012-12-23','11:55:00',2.83),('8537','2012-12-23','12:00:00',2.65),('8537','2012-12-23','12:05:00',2.69),('8537','2012-12-23','12:10:00',2.71),('8537','2012-12-23','12:15:00',2.18),('8537','2012-12-23','12:20:00',1.95),('8537','2012-12-23','12:25:00',1.23),('8537','2012-12-23','12:30:00',1.62),('8537','2012-12-23','12:35:00',1.34),('8537','2012-12-23','12:40:00',1.65),('8537','2012-12-23','12:45:00',1.29),('8537','2012-12-23','12:50:00',1.88),('8537','2012-12-23','12:55:00',2.6),('8537','2012-12-23','13:00:00',2.67),('8537','2012-12-23','13:05:00',2.34),('8537','2012-12-23','13:10:00',2.55),('8537','2012-12-23','13:15:00',1.71),('8537','2012-12-23','13:20:00',1.44),('8537','2012-12-23','13:25:00',1.45),('8537','2012-12-23','13:30:00',1.3),('8537','2012-12-23','13:35:00',1.18),('8537','2012-12-23','13:40:00',1.7),('8537','2012-12-23','13:45:00',1.72),('8537','2012-12-23','13:50:00',1.56),('8537','2012-12-23','13:55:00',1.41),('8537','2012-12-23','14:00:00',1.95),('8537','2012-12-23','14:05:00',1.71),('8537','2012-12-23','14:10:00',1.64),('8537','2012-12-23','14:15:00',1.76),('8537','2012-12-23','14:20:00',1.38),('8537','2012-12-23','14:25:00',1.07),('8537','2012-12-23','14:30:00',1.06),('8537','2012-12-23','14:35:00',1.24),('8537','2012-12-23','14:40:00',1.49),('8537','2012-12-23','14:45:00',1.56),('8537','2012-12-23','14:50:00',1.13),('8537','2014-05-01','07:50:00',1.33),('8537','2014-05-01','07:55:00',1.48),('8537','2014-05-01','08:00:00',1.62),('8537','2014-05-01','08:05:00',1.69),('8537','2014-05-01','08:10:00',1.76),('8537','2014-05-01','08:15:00',1.9),('8537','2014-05-01','08:20:00',2.01),('8537','2014-05-01','08:25:00',2.13),('8537','2014-05-01','08:30:00',2.24),('8537','2014-05-01','08:35:00',2.35),('8537','2014-05-01','08:40:00',2.45),('8537','2014-05-01','08:45:00',2.56),('8537','2014-05-01','08:50:00',2.72),('8537','2014-05-01','08:55:00',2.97),('8537','2014-05-01','09:00:00',2.24),('8537','2014-05-01','09:05:00',1.6),('8537','2014-05-01','09:10:00',1.95),('8537','2014-05-01','09:15:00',2.01),('8537','2014-05-01','09:20:00',1.53),('8537','2014-05-01','09:25:00',3.44),('8537','2014-05-01','09:30:00',3.61),('8537','2014-05-01','09:35:00',3.71),('8537','2014-05-01','09:40:00',3.9),('8537','2014-05-01','09:45:00',2.92),('8537','2014-05-01','09:50:00',2.37),('8537','2014-05-01','09:55:00',2.19),('8537','2014-05-01','10:00:00',2.23),('8537','2014-05-01','10:05:00',2.45),('8537','2014-05-01','10:10:00',4.4),('8537','2014-05-01','10:15:00',2.81),('8537','2014-05-01','10:20:00',3.39),('8537','2014-05-01','10:25:00',3.68),('8537','2014-05-01','10:30:00',3.97),('8537','2014-05-01','10:35:00',3.29),('8537','2014-05-01','10:40:00',1.62),('8537','2014-05-01','10:45:00',4.97),('8537','2014-05-01','10:50:00',4.95),('8537','2014-05-01','10:55:00',3.81),('8537','2014-05-01','11:00:00',5.13),('8537','2014-05-01','11:05:00',3.69),('8537','2014-05-01','11:10:00',2.19),('8537','2014-05-01','11:15:00',3.7),('8537','2014-05-01','11:20:00',5.59),('8537','2014-05-01','11:25:00',3.54),('8537','2014-05-01','11:30:00',3.4),('8537','2014-05-01','11:35:00',5.57),('8537','2014-05-01','11:40:00',5.46),('8537','2014-05-01','11:45:00',5.16),('8537','2014-05-01','11:50:00',4.63),('8537','2014-05-01','11:55:00',5.61),('8537','2014-05-01','12:00:00',5.54),('8537','2014-05-01','12:05:00',4.81),('8537','2014-05-01','12:10:00',4.26),('8537','2014-05-01','12:15:00',4.28),('8537','2014-05-01','12:20:00',4.43),('8537','2014-05-01','12:25:00',2.86),('8537','2014-05-01','12:30:00',3.84),('8537','2014-05-01','12:35:00',5.87),('8537','2014-05-01','12:40:00',5.72),('8537','2014-05-01','12:45:00',5.66),('8537','2014-05-01','12:50:00',2.14),('8537','2014-05-01','12:55:00',3.74),('8537','2014-05-01','13:00:00',5.85),('8537','2014-05-01','13:05:00',5.55),('8537','2014-05-01','13:10:00',5.61),('8537','2014-05-01','13:15:00',5.03),('8537','2014-05-01','13:20:00',5.49),('8537','2014-05-01','13:25:00',4.25),('8537','2014-05-01','13:30:00',2.46),('8537','2014-05-01','13:35:00',5.27),('8537','2014-05-01','13:40:00',5.71),('8537','2014-05-01','13:45:00',5.7),('8537','2014-05-01','13:50:00',5.89),('8537','2014-05-01','13:55:00',5.32),('8537','2014-05-01','14:00:00',3.77),('8537','2014-05-01','14:05:00',4.28),('8537','2014-05-01','14:10:00',5.49),('8537','2014-05-01','14:15:00',5.43),('8537','2014-05-01','14:20:00',5.29),('8537','2014-05-01','14:25:00',5.39),('8537','2014-05-01','14:30:00',5.08),('8537','2014-05-01','14:35:00',2.74),('8537','2014-05-01','14:40:00',3.87),('8537','2014-05-01','14:45:00',5.35),('8537','2014-05-01','14:50:00',5.21),('8537','2014-05-01','14:55:00',5.02),('8537','2014-05-01','15:00:00',5.16),('8537','2014-05-01','15:05:00',5.12),('8537','2014-05-01','15:10:00',4.03),('8537','2014-05-01','15:15:00',4.66),('8537','2014-05-01','15:20:00',4.59),('8537','2014-05-01','15:25:00',4.47),('8537','2014-05-01','15:30:00',4.25),('8537','2014-05-01','15:35:00',4.25),('8537','2014-05-01','15:40:00',4.18),('8537','2014-05-01','15:45:00',4.12),('8537','2014-05-01','15:50:00',4.02),('8537','2014-05-01','15:55:00',3.94),('8537','2014-05-01','16:00:00',3.9),('8537','2014-05-01','16:05:00',3.87),('8537','2014-05-01','16:10:00',3.61),('8537','2014-05-01','16:15:00',3.39),('8537','2014-05-01','16:20:00',3.47),('8537','2014-05-01','16:25:00',3.15),('8537','2014-05-01','16:30:00',3.27),('8537','2014-05-01','16:35:00',3.26),('8537','2014-05-01','16:40:00',3.11),('8537','2014-05-01','16:45:00',2.6),('8537','2014-05-01','16:50:00',2.5),('8537','2014-05-01','16:55:00',2.5),('8537','2014-05-01','17:00:00',2.52),('8537','2014-05-01','17:05:00',2.5),('8537','2014-05-01','17:10:00',2.55),('8537','2014-05-01','17:15:00',2.43),('8537','2014-05-01','17:20:00',2.33),('8537','2014-05-01','17:25:00',2.21),('8537','2014-05-01','17:30:00',2.07),('8537','2014-05-01','17:35:00',1.98),('8537','2014-05-01','17:40:00',1.81),('8537','2014-05-01','17:45:00',1.73),('8537','2014-05-01','17:50:00',1.63),('8537','2014-05-01','17:55:00',1.56),('8537','2014-05-01','18:00:00',1.54),('8537','2014-05-01','18:05:00',1.35),('8537','2014-05-01','18:10:00',1.2),('8537','2014-05-01','18:15:00',1.09),('8537','2014-03-17','09:05:00',1.03),('8537','2014-03-17','09:10:00',1.13),('8537','2014-03-17','09:15:00',1.34),('8537','2014-03-17','09:20:00',1.45),('8537','2014-03-17','09:25:00',1.61),('8537','2014-03-17','09:30:00',1.86),('8537','2014-03-17','09:35:00',1.88),('8537','2014-03-17','09:40:00',1.53),('8537','2014-03-17','09:45:00',1.44),('8537','2014-03-17','09:50:00',2.47),('8537','2014-03-17','09:55:00',2.34),('8537','2014-03-17','10:00:00',2.45),('8537','2014-03-17','10:05:00',1.89),('8537','2014-03-17','10:10:00',2.04),('8537','2014-03-17','10:15:00',1.99),('8537','2014-03-17','10:20:00',2.94),('8537','2014-03-17','10:25:00',2.04),('8537','2014-03-17','10:30:00',1.58),('8537','2014-03-17','10:35:00',1.71),('8537','2014-03-17','10:40:00',1.63),('8537','2014-03-17','10:45:00',2.12),('8537','2014-03-17','10:50:00',1.79),('8537','2014-03-17','10:55:00',1.64),('8537','2014-03-17','11:00:00',1.69),('8537','2014-03-17','11:05:00',1.64),('8537','2014-03-17','11:10:00',2.02),('8537','2014-03-17','11:15:00',2.08),('8537','2014-03-17','11:20:00',1.56),('8537','2014-03-17','11:25:00',1.55),('8537','2014-03-17','11:30:00',1.88),('8537','2014-03-17','11:35:00',1.53),('8537','2014-03-17','11:40:00',1.4),('8537','2014-03-17','11:45:00',1.43),('8537','2014-03-17','11:50:00',2.26),('8537','2014-03-17','11:55:00',2.03),('8537','2014-03-17','12:00:00',2.94),('8537','2014-03-17','12:05:00',2.44),('8537','2014-03-17','12:10:00',1.96),('8537','2014-03-17','12:15:00',1.81),('8537','2014-03-17','12:20:00',2.41),('8537','2014-03-17','12:25:00',4.06),('8537','2014-03-17','12:30:00',1.92),('8537','2014-03-17','12:35:00',2.77),('8537','2014-03-17','12:40:00',2.4),('8537','2014-03-17','12:45:00',2.7),('8537','2014-03-17','12:50:00',3.92),('8537','2014-03-17','12:55:00',4.65),('8537','2014-03-17','13:00:00',4.77),('8537','2014-03-17','13:05:00',2.39),('8537','2014-03-17','13:10:00',3.3),('8537','2014-03-17','13:15:00',4.47),('8537','2014-03-17','13:20:00',4.44),('8537','2014-03-17','13:25:00',4.43),('8537','2014-03-17','13:30:00',3.5),('8537','2014-03-17','13:35:00',4.48),('8537','2014-03-17','13:40:00',4.3),('8537','2014-03-17','13:45:00',4.45),('8537','2014-03-17','13:50:00',3.98),('8537','2014-03-17','13:55:00',3.69),('8537','2014-03-17','14:00:00',2.44),('8537','2014-03-17','14:05:00',3.17),('8537','2014-03-17','14:10:00',1.83),('8537','2014-03-17','14:15:00',1.33),('8537','2014-03-17','14:20:00',2.6),('8537','2014-03-17','14:25:00',2.38),('8537','2014-03-17','14:30:00',2.7),('8537','2014-03-17','14:35:00',2.33),('8537','2014-03-17','14:40:00',2.67),('8537','2014-03-17','14:45:00',3.35),('8537','2014-03-17','14:50:00',3.63),('8537','2014-03-17','14:55:00',3.5),('8537','2014-03-17','15:00:00',3.33),('8537','2014-03-17','15:05:00',3.19),('8537','2014-03-17','15:10:00',3.18),('8537','2014-03-17','15:15:00',2.75),('8537','2014-03-17','15:20:00',2),('8537','2014-03-17','15:25:00',2.49),('8537','2014-03-17','15:30:00',2.59),('8537','2014-03-17','15:35:00',2.41),('8537','2014-03-17','15:40:00',1.99),('8537','2014-03-17','15:45:00',2.31),('8537','2014-03-17','15:50:00',2.08),('8537','2014-03-17','15:55:00',2.02),('8537','2014-03-17','16:00:00',1.91),('8537','2014-03-17','16:05:00',1.9),('8537','2014-03-17','16:10:00',1.17),('8537','2014-03-17','16:15:00',1.43),('8537','2014-03-17','16:20:00',1.75),('8537','2014-03-17','16:25:00',1.64),('8537','2014-03-17','16:30:00',1.17),('8537','2014-03-17','16:35:00',1.12),('8537','2014-03-17','16:40:00',1.05),('8537','2014-03-17','16:45:00',1.02),('8537','2012-12-22','10:20:00',1.06),('8537','2012-12-22','10:25:00',2.18),('8537','2012-12-22','10:30:00',2.38),('8537','2012-12-22','10:35:00',2.89),('8537','2012-12-22','10:40:00',2.88),('8537','2012-12-22','10:45:00',2.9),('8537','2012-12-22','10:50:00',2.89),('8537','2012-12-22','10:55:00',2.85),('8537','2012-12-22','11:00:00',1.33),('8537','2012-12-22','11:40:00',1.56),('8537','2012-12-22','11:45:00',2.1),('8537','2012-12-22','11:50:00',2.45),('8537','2012-12-22','11:55:00',1.92),('8537','2012-12-22','12:00:00',2.57),('8537','2012-12-22','12:05:00',1.36),('8537','2012-12-22','12:45:00',2.47),('8537','2012-12-22','12:50:00',2.7),('8537','2012-12-22','12:55:00',2.31),('8537','2012-12-22','13:00:00',2.84),('8537','2012-12-22','13:05:00',3.21),('8537','2012-12-22','13:10:00',3.28),('8537','2012-12-22','13:15:00',3.42),('8537','2012-12-22','13:20:00',3.38),('8537','2012-12-22','13:25:00',3.26),('8537','2012-12-22','13:30:00',2.87),('8537','2012-12-22','13:35:00',2.87),('8537','2012-12-22','13:40:00',2.48),('8537','2012-12-22','13:45:00',1.01),('8537','2012-12-22','13:55:00',1.11),('8537','2012-12-22','14:00:00',1.16),('8537','2012-12-22','14:05:00',1.33),('8537','2012-12-22','14:10:00',1.24),('8537','2012-12-22','14:15:00',1.48),('8537','2012-12-22','14:20:00',1.46),('8537','2012-12-22','15:00:00',1.1),('8537','2014-03-16','07:40:00',1),('8537','2014-03-16','07:45:00',1.08),('8537','2014-03-16','07:50:00',1.19),('8537','2014-03-16','07:55:00',1.35),('8537','2014-03-16','08:00:00',1.5),('8537','2014-03-16','08:05:00',1.58),('8537','2014-03-16','08:10:00',1.62),('8537','2014-03-16','08:15:00',1.69),('8537','2014-03-16','08:20:00',1.81),('8537','2014-03-16','08:25:00',1.92),('8537','2014-03-16','08:30:00',2.04),('8537','2014-03-16','08:35:00',2.13),('8537','2014-03-16','08:40:00',2.2),('8537','2014-03-16','08:45:00',2.33),('8537','2014-03-16','08:50:00',2.44),('8537','2014-03-16','08:55:00',2.48),('8537','2014-03-16','09:00:00',2.46),('8537','2014-03-16','09:05:00',2.57),('8537','2014-03-16','09:10:00',2.74),('8537','2014-03-16','09:15:00',2.94),('8537','2014-03-16','09:20:00',2.98),('8537','2014-03-16','09:25:00',2.97),('8537','2014-03-16','09:30:00',3.07),('8537','2014-03-16','09:35:00',3.06),('8537','2014-03-16','09:40:00',3.06),('8537','2014-03-16','09:45:00',3.31),('8537','2014-03-16','09:50:00',3.52),('8537','2014-03-16','09:55:00',3.53),('8537','2014-03-16','10:00:00',3.55),('8537','2014-03-16','10:05:00',3.64),('8537','2014-03-16','10:10:00',3.56),('8537','2014-03-16','10:15:00',3.76),('8537','2014-03-16','10:20:00',3.82),('8537','2014-03-16','10:25:00',3.74),('8537','2014-03-16','10:30:00',3.85),('8537','2014-03-16','10:35:00',3.89),('8537','2014-03-16','10:40:00',4.01),('8537','2014-03-16','10:45:00',4.06),('8537','2014-03-16','10:50:00',3.96),('8537','2014-03-16','10:55:00',3.89),('8537','2014-03-16','11:00:00',3.02),('8537','2014-03-16','11:05:00',4),('8537','2014-03-16','11:10:00',4.1),('8537','2014-03-16','11:15:00',4.1),('8537','2014-03-16','11:20:00',4.38),('8537','2014-03-16','11:25:00',4.38),('8537','2014-03-16','11:30:00',4.36),('8537','2014-03-16','11:35:00',4.4),('8537','2014-03-16','11:40:00',4.43),('8537','2014-03-16','11:45:00',4.33),('8537','2014-03-16','11:50:00',4.32),('8537','2014-03-16','11:55:00',4.35),('8537','2014-03-16','12:00:00',4.32),('8537','2014-03-16','12:05:00',4.31),('8537','2014-03-16','12:10:00',4.38),('8537','2014-03-16','12:15:00',4.35),('8537','2014-03-16','12:20:00',4.29),('8537','2014-03-16','12:25:00',4.2),('8537','2014-03-16','12:30:00',4.28),('8537','2014-03-16','12:35:00',4.34),('8537','2014-03-16','12:40:00',4.39),('8537','2014-03-16','12:45:00',4.34),('8537','2014-03-16','12:50:00',4.23),('8537','2014-03-16','12:55:00',4.26),('8537','2014-03-16','13:00:00',4.18),('8537','2014-03-16','13:05:00',4.19),('8537','2014-03-16','13:10:00',4.18),('8537','2014-03-16','13:15:00',4.19),('8537','2014-03-16','13:20:00',4.11),('8537','2014-03-16','13:25:00',4.1),('8537','2014-03-16','13:30:00',4.1),('8537','2014-03-16','13:35:00',4.03),('8537','2014-03-16','13:40:00',4.12),('8537','2014-03-16','13:45:00',3.99),('8537','2014-03-16','13:50:00',3.94),('8537','2014-03-16','13:55:00',3.95),('8537','2014-03-16','14:00:00',3.82),('8537','2014-03-16','14:05:00',3.78),('8537','2014-03-16','14:10:00',3.7),('8537','2014-03-16','14:15:00',3.6),('8537','2014-03-16','14:20:00',3.59),('8537','2014-03-16','14:25:00',3.46),('8537','2014-03-16','14:30:00',3.43),('8537','2014-03-16','14:35:00',3.35),('8537','2014-03-16','14:40:00',3.28),('8537','2014-03-16','14:45:00',3.18),('8537','2014-03-16','14:50:00',3),('8537','2014-03-16','14:55:00',2.98),('8537','2014-03-16','15:00:00',3.09),('8537','2014-03-16','15:05:00',2.88),('8537','2014-03-16','15:10:00',2.68),('8537','2014-03-16','15:15:00',2.5),('8537','2014-03-16','15:20:00',2.13),('8537','2014-03-16','15:25:00',2.37),('8537','2014-03-16','15:30:00',2.19),('8537','2014-03-16','15:35:00',2),('8537','2014-03-16','15:40:00',1.57),('8537','2014-03-16','15:45:00',1.56),('8537','2014-03-16','15:50:00',1.74),('8537','2014-03-16','15:55:00',1.53),('8537','2014-03-16','16:00:00',1.4),('8537','2014-03-16','16:06:00',1.67),('8537','2014-03-16','16:10:00',1.7),('8537','2014-03-16','16:15:00',1.64),('8537','2014-03-16','16:20:00',1.43),('8537','2014-03-16','16:25:00',1.46),('8537','2014-03-16','16:30:00',1.43),('8537','2014-03-16','16:35:00',1.3),('8537','2014-03-16','16:40:00',1.11),('8537','2014-03-15','07:45:00',1.06),('8537','2014-03-15','07:50:00',1.15),('8537','2014-03-15','07:55:00',1.27),('8537','2014-03-15','08:00:00',1.37),('8537','2014-03-15','08:05:00',1.46),('8537','2014-03-15','08:10:00',1.53),('8537','2014-03-15','08:15:00',1.65),('8537','2014-03-15','08:20:00',1.76),('8537','2014-03-15','08:25:00',1.87),('8537','2014-03-15','08:30:00',1.95),('8537','2014-03-15','08:35:00',2.05),('8537','2014-03-15','08:40:00',2.14),('8537','2014-03-15','08:45:00',2.23),('8537','2014-03-15','08:50:00',2.33),('8537','2014-03-15','08:55:00',2.41),('8537','2014-03-15','09:00:00',2.5),('8537','2014-03-15','09:05:00',2.58),('8537','2014-03-15','09:10:00',2.68),('8537','2014-03-15','09:15:00',2.81),('8537','2014-03-15','09:20:00',2.89),('8537','2014-03-15','09:25:00',2.97),('8537','2014-03-15','09:30:00',3.03),('8537','2014-03-15','09:35:00',3.07),('8537','2014-03-15','09:40:00',3.17),('8537','2014-03-15','09:45:00',3.21),('8537','2014-03-15','09:50:00',3.23),('8537','2014-03-15','09:55:00',3.32),('8537','2014-03-15','10:00:00',3.37),('8537','2014-03-15','10:05:00',3.43),('8537','2014-03-15','10:10:00',3.53),('8537','2014-03-15','10:15:00',3.54),('8537','2014-03-15','10:20:00',3.63),('8537','2014-03-15','10:25:00',3.74),('8537','2014-03-15','10:30:00',3.77),('8537','2014-03-15','10:35:00',3.8),('8537','2014-03-15','10:40:00',3.87),('8537','2014-03-15','10:45:00',3.92),('8537','2014-03-15','10:50:00',3.89),('8537','2014-03-15','10:55:00',3.87),('8537','2014-03-15','11:00:00',3.91),('8537','2014-03-15','11:05:00',4.01),('8537','2014-03-15','11:10:00',4),('8537','2014-03-15','11:15:00',4.03),('8537','2014-03-15','11:20:00',4.19),('8537','2014-03-15','11:25:00',4.27),('8537','2014-03-15','11:30:00',4.27),('8537','2014-03-15','11:35:00',4.28),('8537','2014-03-15','11:40:00',4.29),('8537','2014-03-15','11:45:00',4.3),('8537','2014-03-15','11:50:00',4.29),('8537','2014-03-15','11:55:00',4.27),('8537','2014-03-15','12:00:00',4.3),('8537','2014-03-15','12:05:00',4.24),('8537','2014-03-15','12:10:00',4.26),('8537','2014-03-15','12:15:00',4.35),('8537','2014-03-15','12:20:00',4.31),('8537','2014-03-15','12:25:00',4.28),('8537','2014-03-15','12:30:00',4.31),('8537','2014-03-15','12:35:00',4.35),('8537','2014-03-15','12:40:00',4.41),('8537','2014-03-15','12:45:00',4.36),('8537','2014-03-15','12:50:00',4.37),('8537','2014-03-15','12:55:00',4.33),('8537','2014-03-15','13:00:00',4.28),('8537','2014-03-15','13:05:00',4.34),('8537','2014-03-15','13:10:00',4.35),('8537','2014-03-15','13:15:00',4.3),('8537','2014-03-15','13:20:00',4.28),('8537','2014-03-15','13:25:00',4.25),('8537','2014-03-15','13:30:00',4.22),('8537','2014-03-15','13:35:00',4.2),('8537','2014-03-15','13:40:00',4.05),('8537','2014-03-15','13:45:00',3.9),('8537','2014-03-15','13:50:00',3.8),('8537','2014-03-15','13:55:00',4.01),('8537','2014-03-15','14:00:00',3.98),('8537','2014-03-15','14:05:00',3.96),('8537','2014-03-15','14:10:00',3.91),('8537','2014-03-15','14:15:00',3.83),('8537','2014-03-15','14:20:00',3.76),('8537','2014-03-15','14:25:00',3.64),('8537','2014-03-15','14:30:00',3.45),('8537','2014-03-15','14:35:00',3.32),('8537','2014-03-15','14:40:00',3.44),('8537','2014-03-15','14:45:00',3.34),('8537','2014-03-15','14:50:00',3.26),('8537','2014-03-15','14:55:00',3.22),('8537','2014-03-15','15:00:00',3.13),('8537','2014-03-15','15:05:00',3.03),('8537','2014-03-15','15:10:00',2.94),('8537','2014-03-15','15:15:00',2.87),('8537','2014-03-15','15:20:00',2.76),('8537','2014-03-15','15:25:00',2.66),('8537','2014-03-15','15:30:00',2.58),('8537','2014-03-15','15:35:00',2.41),('8537','2014-03-15','15:40:00',2.34),('8537','2014-03-15','15:45:00',2.23),('8537','2014-03-15','15:50:00',2.05),('8537','2014-03-15','15:55:00',1.99),('8537','2014-03-15','16:00:00',1.88),('8537','2014-03-15','16:05:00',1.72),('8537','2014-03-15','16:10:00',1.67),('8537','2014-03-15','16:15:00',1.51),('8537','2014-03-15','16:20:00',1.43),('8537','2014-03-15','16:25:00',1.31),('8537','2014-03-15','16:30:00',1.21),('8537','2014-03-15','16:35:00',1.1),('8537','2014-03-14','08:10:00',1.06),('8537','2014-03-14','08:15:00',1.21),('8537','2014-03-14','08:20:00',1.36),('8537','2014-03-14','08:25:00',1.43),('8537','2014-03-14','08:30:00',1.54),('8537','2014-03-14','08:35:00',1.55),('8537','2014-03-14','08:40:00',1.49),('8537','2014-03-14','08:45:00',1.27),('8537','2014-03-14','08:50:00',1.21),('8537','2014-03-14','08:55:00',1.26),('8537','2014-03-14','09:00:00',1.36),('8537','2014-03-14','09:05:00',1.56),('8537','2014-03-14','09:10:00',1.74),('8537','2014-03-14','09:15:00',1.77),('8537','2014-03-14','09:20:00',1.74),('8537','2014-03-14','09:25:00',1.87),('8537','2014-03-14','09:30:00',1.87),('8537','2014-03-14','09:35:00',2.23),('8537','2014-03-14','09:40:00',2.82),('8537','2014-03-14','09:45:00',3.23),('8537','2014-03-14','09:50:00',3.81),('8537','2014-03-14','09:55:00',3.97),('8537','2014-03-14','10:00:00',4.21),('8537','2014-03-14','10:05:00',4.19),('8537','2014-03-14','10:10:00',4.12),('8537','2014-03-14','10:15:00',4.05),('8537','2014-03-14','10:20:00',3.97),('8537','2014-03-14','10:25:00',3.84),('8537','2014-03-14','10:30:00',3.8),('8537','2014-03-14','10:35:00',4.02),('8537','2014-03-14','10:40:00',4.09),('8537','2014-03-14','10:45:00',3.66),('8537','2014-03-14','10:50:00',2.36),('8537','2014-03-14','10:55:00',3.17),('8537','2014-03-14','11:00:00',4.01),('8537','2014-03-14','11:05:00',4.17),('8537','2014-03-14','11:10:00',4.44),('8537','2014-03-14','11:15:00',4.5),('8537','2014-03-14','11:20:00',4.36),('8537','2014-03-14','11:25:00',4.29),('8537','2014-03-14','11:30:00',4.32),('8537','2014-03-14','11:35:00',4.4),('8537','2014-03-14','11:40:00',4.37),('8537','2014-03-14','11:45:00',4.43),('8537','2014-03-14','11:50:00',4.47),('8537','2014-03-14','11:55:00',4.61),('8537','2014-03-14','12:00:00',4.68),('8537','2014-03-14','12:05:00',4.63),('8537','2014-03-14','12:10:00',4.34),('8537','2014-03-14','12:15:00',4.12),('8537','2014-03-14','12:20:00',3.49),('8537','2014-03-14','12:25:00',2.95),('8537','2014-03-14','12:30:00',2.8),('8537','2014-03-14','12:35:00',2.3),('8537','2014-03-14','12:40:00',2.81),('8537','2014-03-14','12:45:00',3.03),('8537','2014-03-14','12:50:00',3.71),('8537','2014-03-14','12:55:00',3.66),('8537','2014-03-14','13:00:00',2.57),('8537','2014-03-14','13:05:00',2.31),('8537','2014-03-14','13:10:00',2.8),('8537','2014-03-14','13:15:00',3.21),('8537','2014-03-14','13:20:00',3.38),('8537','2014-03-14','13:25:00',3.15),('8537','2014-03-14','13:30:00',2.86),('8537','2014-03-14','13:35:00',2.59),('8537','2014-03-14','13:40:00',2.4),('8537','2014-03-14','13:45:00',2.47),('8537','2014-03-14','13:50:00',2.31),('8537','2014-03-14','13:55:00',2.37),('8537','2014-03-14','14:00:00',2.78),('8537','2014-03-14','14:05:00',3.09),('8537','2014-03-14','14:10:00',3.07),('8537','2014-03-14','14:15:00',3.24),('8537','2014-03-14','14:20:00',3.32),('8537','2014-03-14','14:25:00',3.32),('8537','2014-03-14','14:30:00',3.01),('8537','2014-03-14','14:35:00',2.77),('8537','2014-03-14','14:40:00',2.31),('8537','2014-03-14','14:45:00',1.88),('8537','2014-03-14','14:50:00',1.67),('8537','2014-03-14','14:55:00',1.54),('8537','2014-03-14','15:00:00',1.42),('8537','2014-03-14','15:05:00',1.39),('8537','2014-03-14','15:10:00',1.35),('8537','2014-03-14','15:15:00',1.35),('8537','2014-03-14','15:20:00',1.42),('8537','2014-03-14','15:25:00',1.49),('8537','2014-03-14','15:30:00',1.67),('8537','2014-03-14','15:35:00',1.78),('8537','2014-03-14','15:40:00',1.59),('8537','2014-03-14','15:45:00',1.41),('8537','2014-03-14','15:50:00',1.28),('8537','2014-03-14','15:55:00',1.3),('8537','2014-03-14','16:00:00',1.2),('8537','2014-03-14','16:05:00',1.15),('8537','2014-03-14','16:10:00',1.03),('8537','2014-03-13','07:30:00',1.02),('8537','2014-03-13','07:35:00',1.12),('8537','2014-03-13','07:40:00',1.23),('8537','2014-03-13','07:45:00',1.33),('8537','2014-03-13','07:50:00',1.47),('8537','2014-03-13','07:55:00',1.59),('8537','2014-03-13','08:00:00',1.7),('8537','2014-03-13','08:05:00',1.81),('8537','2014-03-13','08:10:00',1.93),('8537','2014-03-13','08:15:00',2.05),('8537','2014-03-13','08:20:00',2.16),('8537','2014-03-13','08:25:00',2.27),('8537','2014-03-13','08:30:00',2.36),('8537','2014-03-13','08:35:00',2.48),('8537','2014-03-13','08:40:00',2.58),('8537','2014-03-13','08:45:00',2.69),('8537','2014-03-13','08:50:00',2.78),('8537','2014-03-13','08:55:00',2.9),('8537','2014-03-13','09:00:00',3.01),('8537','2014-03-13','09:05:00',3.08),('8537','2014-03-13','09:10:00',3.18),('8537','2014-03-13','09:15:00',3.26),('8537','2014-03-13','09:20:00',3.35),('8537','2014-03-13','09:25:00',3.44),('8537','2014-03-13','09:30:00',3.52),('8537','2014-03-13','09:35:00',3.59),('8537','2014-03-13','09:40:00',3.69),('8537','2014-03-13','09:45:00',3.77),('8537','2014-03-13','09:50:00',3.85),('8537','2014-03-13','09:55:00',3.9),('8537','2014-03-13','10:00:00',3.99),('8537','2014-03-13','10:05:00',4.05),('8537','2014-03-13','10:10:00',4.12),('8537','2014-03-13','10:15:00',4.17),('8537','2014-03-13','10:20:00',4.18),('8537','2014-03-13','10:25:00',4.21),('8537','2014-03-13','10:30:00',4.28),('8537','2014-03-13','10:35:00',4.3),('8537','2014-03-13','10:40:00',4.31),('8537','2014-03-13','10:45:00',4.34),('8537','2014-03-13','10:50:00',4.35),('8537','2014-03-13','10:55:00',4.41),('8537','2014-03-13','11:00:00',4.43),('8537','2014-03-13','11:05:00',4.49),('8537','2014-03-13','11:10:00',4.52),('8537','2014-03-13','11:15:00',4.55),('8537','2014-03-13','11:20:00',4.55),('8537','2014-03-13','11:25:00',4.58),('8537','2014-03-13','11:30:00',4.63),('8537','2014-03-13','11:35:00',4.6),('8537','2014-03-13','11:40:00',4.63),('8537','2014-03-13','11:45:00',4.69),('8537','2014-03-13','11:50:00',4.67),('8537','2014-03-13','11:55:00',4.75),('8537','2014-03-13','12:00:00',4.75),('8537','2014-03-13','12:05:00',4.65),('8537','2014-03-13','12:10:00',4.66),('8537','2014-03-13','12:15:00',4.65),('8537','2014-03-13','12:20:00',4.66),('8537','2014-03-13','12:25:00',4.68),('8537','2014-03-13','12:30:00',4.69),('8537','2014-03-13','12:35:00',4.64),('8537','2014-03-13','12:40:00',4.62),('8537','2014-03-13','12:45:00',4.54),('8537','2014-03-13','12:50:00',4.53),('8537','2014-03-13','12:55:00',4.51),('8537','2014-03-13','13:00:00',4.48),('8537','2014-03-13','13:05:00',4.42),('8537','2014-03-13','13:10:00',4.38),('8537','2014-03-13','13:15:00',4.31),('8537','2014-03-13','13:20:00',4.34),('8537','2014-03-13','13:25:00',4.33),('8537','2014-03-13','13:30:00',4.35),('8537','2014-03-13','13:35:00',4.31),('8537','2014-03-13','13:40:00',4.2),('8537','2014-03-13','13:45:00',4.07),('8537','2014-03-13','13:50:00',3.98),('8537','2014-03-13','13:55:00',4),('8537','2014-03-13','14:00:00',3.93),('8537','2014-03-13','14:05:00',3.89),('8537','2014-03-13','14:10:00',3.85),('8537','2014-03-13','14:15:00',3.83),('8537','2014-03-13','14:20:00',3.75),('8537','2014-03-13','14:25:00',3.67),('8537','2014-03-13','14:30:00',3.55),('8537','2014-03-13','14:35:00',3.46),('8537','2014-03-13','14:40:00',3.46),('8537','2014-03-13','14:45:00',3.36),('8537','2014-03-13','14:50:00',3.3),('8537','2014-03-13','14:55:00',3.22),('8537','2014-03-13','15:00:00',3.14),('8537','2014-03-13','15:05:00',3.04),('8537','2014-03-13','15:10:00',2.94),('8537','2014-03-13','15:15:00',2.88),('8537','2014-03-13','15:20:00',2.8),('8537','2014-03-13','15:25:00',2.72),('8537','2014-03-13','15:30:00',2.64),('8537','2014-03-13','15:35:00',2.54),('8537','2014-03-13','15:40:00',2.43),('8537','2014-03-13','15:45:00',2.33),('8537','2014-03-13','15:50:00',2.17),('8537','2014-03-13','15:55:00',2.09),('8537','2014-03-13','16:00:00',1.98),('8537','2014-03-13','16:05:00',1.87),('8537','2014-03-13','16:10:00',1.77),('8537','2014-03-13','16:15:00',1.62),('8537','2014-03-13','16:20:00',1.51),('8537','2014-03-13','16:25:00',1.43),('8537','2014-03-13','16:30:00',1.31),('8537','2014-03-13','16:35:00',1.21),('8537','2014-03-13','16:40:00',1.09),('8537','2014-03-12','07:35:00',1.07),('8537','2014-03-12','07:40:00',1.19),('8537','2014-03-12','07:45:00',1.31),('8537','2014-03-12','07:50:00',1.43),('8537','2014-03-12','07:55:00',1.55),('8537','2014-03-12','08:00:00',1.67),('8537','2014-03-12','08:05:00',1.78),('8537','2014-03-12','08:10:00',1.91),('8537','2014-03-12','08:15:00',2.03),('8537','2014-03-12','08:20:00',2.14),('8537','2014-03-12','08:25:00',2.26),('8537','2014-03-12','08:30:00',2.37),('8537','2014-03-12','08:35:00',2.49),('8537','2014-03-12','08:40:00',2.6),('8537','2014-03-12','08:45:00',2.7),('8537','2014-03-12','08:50:00',2.8),('8537','2014-03-12','08:55:00',2.9),('8537','2014-03-12','09:00:00',2.98),('8537','2014-03-12','09:05:00',3.08),('8537','2014-03-12','09:10:00',3.18),('8537','2014-03-12','09:15:00',3.27),('8537','2014-03-12','09:20:00',3.33),('8537','2014-03-12','09:25:00',3.42),('8537','2014-03-12','09:30:00',3.5),('8537','2014-03-12','09:35:00',3.59),('8537','2014-03-12','09:40:00',3.65),('8537','2014-03-12','09:45:00',3.73),('8537','2014-03-12','09:50:00',3.8),('8537','2014-03-12','09:55:00',3.88),('8537','2014-03-12','10:00:00',3.95),('8537','2014-03-12','10:05:00',4.02),('8537','2014-03-12','10:10:00',4.08),('8537','2014-03-12','10:15:00',4.13),('8537','2014-03-12','10:20:00',4.18),('8537','2014-03-12','10:25:00',4.23),('8537','2014-03-12','10:30:00',4.28),('8537','2014-03-12','10:35:00',4.34),('8537','2014-03-12','10:40:00',4.43),('8537','2014-03-12','10:45:00',4.5),('8537','2014-03-12','10:50:00',4.53),('8537','2014-03-12','10:55:00',4.56),('8537','2014-03-12','11:00:00',4.6),('8537','2014-03-12','11:05:00',4.66),('8537','2014-03-12','11:10:00',4.7),('8537','2014-03-12','11:15:00',4.74),('8537','2014-03-12','11:20:00',4.77),('8537','2014-03-12','11:25:00',4.78),('8537','2014-03-12','11:30:00',4.8),('8537','2014-03-12','11:35:00',4.83),('8537','2014-03-12','11:40:00',4.86),('8537','2014-03-12','11:45:00',4.85),('8537','2014-03-12','11:50:00',4.82),('8537','2014-03-12','11:55:00',4.88),('8537','2014-03-12','12:00:00',4.87),('8537','2014-03-12','12:05:00',4.86),('8537','2014-03-12','12:10:00',4.82),('8537','2014-03-12','12:15:00',4.82),('8537','2014-03-12','12:20:00',4.72),('8537','2014-03-12','12:25:00',4.79),('8537','2014-03-12','12:30:00',4.79),('8537','2014-03-12','12:35:00',4.77),('8537','2014-03-12','12:40:00',4.73),('8537','2014-03-12','12:45:00',4.74),('8537','2014-03-12','12:50:00',4.72),('8537','2014-03-12','12:55:00',4.69),('8537','2014-03-12','13:00:00',4.7),('8537','2014-03-12','13:05:00',4.64),('8537','2014-03-12','13:10:00',4.6),('8537','2014-03-12','13:15:00',4.6),('8537','2014-03-12','13:20:00',4.56),('8537','2014-03-12','13:25:00',4.51),('8537','2014-03-12','13:30:00',4.45),('8537','2014-03-12','13:35:00',4.43),('8537','2014-03-12','13:40:00',4.34),('8537','2014-03-12','13:45:00',4.3),('8537','2014-03-12','13:50:00',4.16),('8537','2014-03-12','13:55:00',4.21),('8537','2014-03-12','14:00:00',4.18),('8537','2014-03-12','14:05:00',4.15),('8537','2014-03-12','14:10:00',4.06),('8537','2014-03-12','14:15:00',4.02),('8537','2014-03-12','14:20:00',3.93),('8537','2014-03-12','14:25:00',3.86),('8537','2014-03-12','14:30:00',3.79),('8537','2014-03-12','14:35:00',3.57),('8537','2014-03-12','14:40:00',3.52),('8537','2014-03-12','14:45:00',3.41),('8537','2014-03-12','14:50:00',3.36),('8537','2014-03-12','14:55:00',3.16),('8537','2014-03-12','15:00:00',3.12),('8537','2014-03-12','15:05:00',3.09),('8537','2014-03-12','15:10:00',3),('8537','2014-03-12','15:15:00',2.87),('8537','2014-03-12','15:20:00',2.81),('8537','2014-03-12','15:25:00',2.71),('8537','2014-03-12','15:30:00',2.59),('8537','2014-03-12','15:35:00',2.48),('8537','2014-03-12','15:40:00',2.42),('8537','2014-03-12','15:45:00',2.32),('8537','2014-03-12','15:50:00',2.21),('8537','2014-03-12','15:55:00',2.11),('8537','2014-03-12','16:00:00',2.04),('8537','2014-03-12','16:05:00',1.91),('8537','2014-03-12','16:10:00',1.78),('8537','2014-03-12','16:15:00',1.65),('8537','2014-03-12','16:20:00',1.54),('8537','2014-03-12','16:25:00',1.42),('8537','2014-03-12','16:30:00',1.3),('8537','2014-03-12','16:35:00',1.2),('8537','2014-03-12','16:40:00',1.1),('8537','2014-03-11','10:20:00',1),('8537','2014-03-11','10:25:00',1.03),('8537','2014-03-11','10:30:00',1.06),('8537','2014-03-11','10:35:00',1.07),('8537','2014-03-11','10:40:00',1.06),('8537','2014-03-11','11:00:00',1.08),('8537','2014-03-11','11:05:00',1.11),('8537','2014-03-11','11:10:00',1.13),('8537','2014-03-11','11:15:00',1.16),('8537','2014-03-11','11:20:00',1.05),('8537','2014-03-11','11:25:00',1.04),('8537','2014-03-11','11:30:00',1.03),('8537','2014-03-11','11:35:00',1.13),('8537','2014-03-11','11:40:00',1.21),('8537','2014-03-11','11:45:00',1.23),('8537','2014-03-11','11:50:00',1.06),('8537','2014-03-11','11:55:00',1.16),('8537','2014-03-11','12:00:00',1.21),('8537','2014-03-11','12:05:00',1.23),('8537','2014-03-11','12:10:00',1.28),('8537','2014-03-11','12:15:00',1.43),('8537','2014-03-11','12:20:00',1.52),('8537','2014-03-11','12:25:00',1.39),('8537','2014-03-11','12:30:00',1.33),('8537','2014-03-11','12:35:00',1.42),('8537','2014-03-11','12:40:00',1.55),('8537','2014-03-11','12:45:00',1.49),('8537','2014-03-11','12:50:00',1.45),('8537','2014-03-11','12:55:00',1.34),('8537','2014-03-11','13:00:00',1.24),('8537','2014-03-11','13:05:00',1.44),('8537','2014-03-11','13:10:00',1.48),('8537','2014-03-11','13:15:00',1.46),('8537','2014-03-11','13:20:00',1.47),('8537','2014-03-11','13:25:00',1.26),('8537','2014-03-11','13:30:00',1.24),('8537','2014-03-11','13:35:00',1.17),('8537','2014-03-11','13:40:00',1.22),('8537','2014-03-11','13:45:00',1.56),('8537','2014-03-11','13:50:00',1.86),('8537','2014-03-11','13:55:00',2.24),('8537','2014-03-11','14:00:00',2.25),('8537','2014-03-11','14:05:00',2.36),('8537','2014-03-11','14:10:00',2.74),('8537','2014-03-11','14:15:00',3.04),('8537','2014-03-11','14:20:00',2.43),('8537','2014-03-11','14:25:00',2.15),('8537','2014-03-11','14:30:00',1.58),('8537','2014-03-11','14:35:00',1.64),('8537','2014-03-11','14:40:00',1.61),('8537','2014-03-11','14:45:00',1.68),('8537','2014-03-11','14:50:00',1.53),('8537','2014-03-11','14:55:00',1.55),('8537','2014-03-11','15:00:00',1.79),('8537','2014-03-11','15:05:00',1.96),('8537','2014-03-11','15:10:00',2.07),('8537','2014-03-11','15:15:00',1.77),('8537','2014-03-11','15:20:00',1.67),('8537','2014-03-11','15:25:00',1.51),('8537','2014-03-11','15:30:00',1.45),('8537','2014-03-11','15:35:00',1.3),('8537','2014-03-11','15:40:00',1.29),('8537','2014-03-11','15:45:00',1.21),('8537','2014-03-11','15:50:00',1.2),('8537','2014-03-10','08:40:00',1.05),('8537','2014-03-10','08:45:00',1.04),('8537','2014-03-10','08:50:00',1.07),('8537','2014-03-10','08:55:00',1.08),('8537','2014-03-10','09:00:00',1.11),('8537','2014-03-10','09:05:00',1.2),('8537','2014-03-10','09:10:00',1.24),('8537','2014-03-10','09:15:00',1.17),('8537','2014-03-10','09:20:00',1.14),('8537','2014-03-10','09:25:00',1.14),('8537','2014-03-10','09:30:00',1.2),('8537','2014-03-10','09:35:00',1.15),('8537','2014-03-10','09:40:00',1.18),('8537','2014-03-10','09:45:00',1.06),('8537','2014-03-10','10:10:00',1.12),('8537','2014-03-10','10:15:00',1.31),('8537','2014-03-10','10:20:00',1.08),('8537','2014-03-10','10:25:00',1.05),('8537','2014-03-10','10:30:00',1.28),('8537','2014-03-10','10:35:00',1.43),('8537','2014-03-10','11:15:00',1.02),('8537','2014-03-10','11:20:00',1.13),('8537','2014-03-10','11:25:00',1.05),('8537','2014-03-10','12:40:00',1.03),('8537','2014-03-10','12:45:00',1.18),('8537','2014-03-10','12:50:00',1.31),('8537','2014-03-10','12:55:00',1.4),('8537','2014-03-10','13:00:00',1.48),('8537','2014-03-10','13:05:00',1.52),('8537','2014-03-10','13:10:00',1.72),('8537','2014-03-10','13:15:00',1.96),('8537','2014-03-10','13:20:00',1.84),('8537','2014-03-10','13:25:00',1.63),('8537','2014-03-10','13:30:00',1.37),('8537','2014-03-10','13:35:00',1.14),('8537','2014-03-10','13:40:00',1.04),('8537','2014-03-10','13:50:00',1.45),('8537','2014-03-10','13:55:00',1.26),('8537','2014-03-10','14:00:00',1.25),('8537','2014-03-10','14:05:00',1.86),('8537','2014-03-10','14:10:00',2.56),('8537','2014-03-10','14:15:00',3.44),('8537','2014-03-10','14:20:00',2.22),('8537','2014-03-10','14:25:00',1.83),('8537','2014-03-10','14:30:00',1.54),('8537','2014-03-10','14:35:00',2.66),('8537','2014-03-10','14:40:00',3.41),('8537','2014-03-10','14:45:00',2.67),('8537','2014-03-10','14:50:00',2.69),('8537','2014-03-10','14:55:00',1.77),('8537','2014-03-10','15:00:00',1.69),('8537','2014-03-10','15:05:00',1.44),('8537','2014-03-10','15:10:00',1.15),('8537','2014-03-10','15:15:00',1.36),('8537','2014-03-10','15:20:00',2.58),('8537','2014-03-10','15:25:00',2.67),('8537','2014-03-10','15:30:00',1.62),('8537','2014-03-10','15:35:00',1.14),('8537','2014-03-10','15:40:00',1.28),('8537','2014-03-10','15:45:00',1.03),('8537','2014-03-10','15:50:00',1.01),('8537','2014-03-10','16:00:00',1.02),('8537','2014-03-10','16:05:00',1.12),('8537','2014-03-10','16:25:00',1),('8537','2014-03-10','16:30:00',1.09),('8537','2014-03-09','07:50:00',1.3),('8537','2014-03-09','07:55:00',1.41),('8537','2014-03-09','08:00:00',1.55),('8537','2014-03-09','08:05:00',1.66),('8537','2014-03-09','08:10:00',1.8),('8537','2014-03-09','08:15:00',1.93),('8537','2014-03-09','08:20:00',1.86),('8537','2014-03-09','08:25:00',1.38),('8537','2014-03-09','08:30:00',1.63),('8537','2014-03-09','08:35:00',1.47),('8537','2014-03-09','08:40:00',1.67),('8537','2014-03-09','08:45:00',1.15),('8537','2014-03-09','08:50:00',1.5),('8537','2014-03-09','08:55:00',2.09),('8537','2014-03-09','09:00:00',2.57),('8537','2014-03-09','09:05:00',1.56),('8537','2014-03-09','09:15:00',2.04),('8537','2014-03-09','09:20:00',3.37),('8537','2014-03-09','09:25:00',3.57),('8537','2014-03-09','09:30:00',2.86),('8537','2014-03-09','09:35:00',3.75),('8537','2014-03-09','09:40:00',3.91),('8537','2014-03-09','09:45:00',4),('8537','2014-03-09','09:50:00',4.06),('8537','2014-03-09','09:55:00',4.04),('8537','2014-03-09','10:00:00',4.08),('8537','2014-03-09','10:05:00',4.16),('8537','2014-03-09','10:10:00',4.26),('8537','2014-03-09','10:15:00',4.27),('8537','2014-03-09','10:20:00',4.28),('8537','2014-03-09','10:25:00',4.26),('8537','2014-03-09','10:30:00',4.42),('8537','2014-03-09','10:35:00',4.48),('8537','2014-03-09','10:40:00',4.5),('8537','2014-03-09','10:45:00',4.55),('8537','2014-03-09','10:50:00',4.63),('8537','2014-03-09','10:55:00',4.7),('8537','2014-03-09','11:00:00',5.06),('8537','2014-03-09','11:05:00',4.49),('8537','2014-03-09','11:10:00',5.28),('8537','2014-03-09','11:15:00',5.36),('8537','2014-03-09','11:20:00',5.09),('8537','2014-03-09','11:25:00',3.75),('8537','2014-03-09','11:30:00',2.91),('8537','2014-03-09','11:35:00',3.35),('8537','2014-03-09','11:40:00',3.08),('8537','2014-03-09','11:45:00',3.14),('8537','2014-03-09','11:50:00',3.77),('8537','2014-03-09','11:55:00',4.95),('8537','2014-03-09','12:00:00',4.87),('8537','2014-03-09','12:05:00',5.61),('8537','2014-03-09','12:10:00',5.52),('8537','2014-03-09','12:15:00',5.44),('8537','2014-03-09','12:20:00',5.43),('8537','2014-03-09','12:25:00',5.37),('8537','2014-03-09','12:30:00',5.39),('8537','2014-03-09','12:35:00',5.49),('8537','2014-03-09','12:40:00',5.26),('8537','2014-03-09','12:45:00',5.16),('8537','2014-03-09','12:50:00',5.21),('8537','2014-03-09','12:55:00',5.25),('8537','2014-03-09','13:00:00',5.33),('8537','2014-03-09','13:05:00',5.35),('8537','2014-03-09','13:10:00',5.3),('8537','2014-03-09','13:15:00',4.95),('8537','2014-03-09','13:20:00',4.74),('8537','2014-03-09','13:25:00',4.92),('8537','2014-03-09','13:30:00',4.87),('8537','2014-03-09','13:35:00',3.33),('8537','2014-03-09','13:45:00',1.63),('8537','2014-03-09','13:50:00',2.53),('8537','2014-03-09','13:55:00',2.48),('8537','2014-03-09','14:00:00',4.57),('8537','2014-03-09','14:05:00',4.22),('8537','2014-03-09','14:10:00',3.88),('8537','2014-03-09','14:15:00',3.38),('8537','2014-03-09','14:20:00',3.96),('8537','2014-03-09','14:25:00',2.39),('8537','2014-03-09','14:30:00',1.19),('8537','2014-03-09','14:35:00',1.3),('8537','2014-03-09','14:40:00',2.64),('8537','2014-03-09','14:45:00',3.84),('8537','2014-03-09','14:50:00',3.25),('8537','2014-03-09','14:55:00',3.4),('8537','2014-03-09','15:00:00',3.34),('8537','2014-03-09','15:05:00',2.74),('8537','2014-03-09','15:10:00',3.3),('8537','2014-03-09','15:15:00',3.13),('8537','2014-03-09','15:20:00',3.09),('8537','2014-03-09','15:25:00',3.03),('8537','2014-03-09','15:30:00',2.94),('8537','2014-03-09','15:35:00',2.79),('8537','2014-03-09','15:40:00',2.65),('8537','2014-03-09','15:45:00',1.9),('8537','2014-03-09','15:50:00',1.08),('8537','2014-03-09','15:55:00',2.16),('8537','2014-03-09','16:00:00',2.2),('8537','2014-03-09','16:05:00',1.97),('8537','2014-03-09','16:10:00',1.4),('8537','2014-03-09','16:20:00',1.49),('8537','2014-03-09','16:25:00',1.44),('8537','2014-03-09','16:30:00',1.36),('8537','2014-03-09','16:35:00',1.27),('8537','2014-03-09','16:40:00',1.21),('8537','2014-03-09','16:45:00',1.04),('8537','2014-03-08','07:40:00',1.07),('8537','2014-03-08','07:45:00',1.19),('8537','2014-03-08','07:50:00',1.31),('8537','2014-03-08','07:55:00',1.42),('8537','2014-03-08','08:00:00',1.55),('8537','2014-03-08','08:05:00',1.66),('8537','2014-03-08','08:10:00',1.78),('8537','2014-03-08','08:15:00',1.91),('8537','2014-03-08','08:20:00',2.02),('8537','2014-03-08','08:25:00',2.15),('8537','2014-03-08','08:30:00',2.26),('8537','2014-03-08','08:35:00',2.37),('8537','2014-03-08','08:40:00',2.49),('8537','2014-03-08','08:45:00',2.59),('8537','2014-03-08','08:50:00',2.7),('8537','2014-03-08','08:55:00',2.81),('8537','2014-03-08','09:00:00',2.91),('8537','2014-03-08','09:05:00',3.01),('8537','2014-03-08','09:10:00',3.12),('8537','2014-03-08','09:15:00',3.2),('8537','2014-03-08','09:20:00',3.29),('8537','2014-03-08','09:25:00',3.37),('8537','2014-03-08','09:30:00',3.47),('8537','2014-03-08','09:35:00',3.54),('8537','2014-03-08','09:40:00',3.61),('8537','2014-03-08','09:45:00',3.7),('8537','2014-03-08','09:50:00',3.79),('8537','2014-03-08','09:55:00',3.86),('8537','2014-03-08','10:00:00',3.92),('8537','2014-03-08','10:05:00',3.98),('8537','2014-03-08','10:10:00',4.03),('8537','2014-03-08','10:15:00',4.12),('8537','2014-03-08','10:20:00',4.19),('8537','2014-03-08','10:25:00',4.24),('8537','2014-03-08','10:30:00',4.33),('8537','2014-03-08','10:35:00',4.37),('8537','2014-03-08','10:40:00',4.36),('8537','2014-03-08','10:45:00',4.45),('8537','2014-03-08','10:50:00',4.48),('8537','2014-03-08','10:55:00',4.5),('8537','2014-03-08','11:00:00',4.55),('8537','2014-03-08','11:05:00',4.58),('8537','2014-03-08','11:10:00',4.62),('8537','2014-03-08','11:15:00',4.7),('8537','2014-03-08','11:20:00',4.78),('8537','2014-03-08','11:25:00',4.92),('8537','2014-03-08','11:30:00',4.99),('8537','2014-03-08','11:35:00',3.1),('8537','2014-03-08','11:40:00',3.35),('8537','2014-03-08','11:45:00',1.67),('8537','2014-03-08','11:50:00',2.02),('8537','2014-03-08','11:55:00',4.02),('8537','2014-03-08','12:00:00',1.74),('8537','2014-03-08','12:05:00',1.22),('8537','2014-03-08','12:10:00',1.26),('8537','2014-03-08','12:15:00',1.36),('8537','2014-03-08','12:20:00',1.58),('8537','2014-03-08','12:25:00',1.73),('8537','2014-03-08','12:30:00',2.32),('8537','2014-03-08','12:35:00',4.67),('8537','2014-03-08','12:40:00',2.31),('8537','2014-03-08','12:45:00',2.52),('8537','2014-03-08','12:50:00',3.4),('8537','2014-03-08','12:55:00',4.54),('8537','2014-03-08','13:00:00',2.06),('8537','2014-03-08','13:05:00',1.89),('8537','2014-03-08','13:10:00',1.62),('8537','2014-03-08','13:15:00',1.27),('8537','2014-03-08','13:20:00',1.12),('8537','2014-03-08','13:25:00',1.28),('8537','2014-03-08','13:30:00',2.33),('8537','2014-03-08','13:35:00',1.89),('8537','2014-03-08','13:40:00',2.98),('8537','2014-03-08','13:45:00',3.09),('8537','2014-03-08','13:50:00',2.14),('8537','2014-03-08','13:55:00',1.54),('8537','2014-03-08','14:00:00',1.23),('8537','2014-03-08','14:05:00',1.17),('8537','2014-03-08','14:10:00',1.06),('8537','2014-03-08','14:35:00',1.11),('8537','2014-03-08','14:40:00',1.19),('8537','2014-03-08','14:45:00',1.1),('8537','2014-03-08','14:50:00',1.14),('8537','2014-03-08','14:55:00',1.19),('8537','2014-03-08','15:00:00',1.01),('8537','2014-03-08','15:10:00',1.02),('8537','2014-03-08','15:15:00',1.29),('8537','2014-03-08','15:20:00',2.07),('8537','2014-03-08','15:25:00',2.34),('8537','2014-03-08','15:30:00',1.59),('8537','2014-03-08','15:55:00',1.05),('8537','2014-03-08','16:00:00',1.27),('8537','2014-03-08','16:05:00',1.31),('8537','2014-03-08','16:30:00',1.3),('8537','2014-03-08','16:35:00',1.38),('8537','2014-03-08','16:40:00',1.18),('8537','2014-03-08','16:45:00',1.07),('8537','2014-04-30','07:40:00',1.09),('8537','2014-04-30','07:45:00',1.2),('8537','2014-04-30','07:50:00',1.3),('8537','2014-04-30','07:55:00',1.4),('8537','2014-04-30','08:00:00',1.51),('8537','2014-04-30','08:05:00',1.57),('8537','2014-04-30','08:10:00',1.75),('8537','2014-04-30','08:15:00',1.83),('8537','2014-04-30','08:20:00',1.94),('8537','2014-04-30','08:25:00',2.04),('8537','2014-04-30','08:30:00',2.14),('8537','2014-04-30','08:35:00',2.25),('8537','2014-04-30','08:40:00',2.36),('8537','2014-04-30','08:45:00',2.34),('8537','2014-04-30','08:50:00',2.22),('8537','2014-04-30','08:55:00',2.72),('8537','2014-04-30','09:00:00',2.88),('8537','2014-04-30','09:05:00',3.02),('8537','2014-04-30','09:10:00',2.92),('8537','2014-04-30','09:15:00',3.49),('8537','2014-04-30','09:20:00',1.28),('8537','2014-04-30','09:25:00',2.93),('8537','2014-04-30','09:30:00',1.71),('8537','2014-04-30','09:35:00',3.18),('8537','2014-04-30','09:40:00',3.74),('8537','2014-04-30','09:45:00',3.44),('8537','2014-04-30','09:50:00',1.96),('8537','2014-04-30','09:55:00',3.26),('8537','2014-04-30','10:00:00',3.61),('8537','2014-04-30','10:05:00',3.34),('8537','2014-04-30','10:10:00',1.79),('8537','2014-04-30','10:15:00',3.84),('8537','2014-04-30','10:20:00',2.15),('8537','2014-04-30','10:25:00',2.1),('8537','2014-04-30','10:30:00',2.09),('8537','2014-04-30','10:35:00',2.62),('8537','2014-04-30','10:40:00',2.51),('8537','2014-04-30','10:45:00',2.04),('8537','2014-04-30','10:50:00',1.8),('8537','2014-04-30','10:55:00',4.3),('8537','2014-04-30','11:00:00',5.2),('8537','2014-04-30','11:05:00',4.5),('8537','2014-04-30','11:10:00',3.58),('8537','2014-04-30','11:15:00',3.21),('8537','2014-04-30','11:20:00',1.97),('8537','2014-04-30','11:25:00',2.93),('8537','2014-04-30','11:30:00',2.51),('8537','2014-04-30','11:35:00',2.46),('8537','2014-04-30','11:40:00',3.55),('8537','2014-04-30','11:45:00',2.27),('8537','2014-04-30','11:50:00',3.87),('8537','2014-04-30','11:55:00',3.11),('8537','2014-04-30','12:00:00',4.42),('8537','2014-04-30','12:05:00',1.79),('8537','2014-04-30','12:10:00',1.58),('8537','2014-04-30','12:15:00',2.25),('8537','2014-04-30','12:20:00',2.14),('8537','2014-04-30','12:25:00',1.87),('8537','2014-04-30','12:30:00',2.11),('8537','2014-04-30','12:35:00',1.78),('8537','2014-04-30','12:40:00',1.73),('8537','2014-04-30','12:45:00',1.85),('8537','2014-04-30','12:50:00',1.95),('8537','2014-04-30','12:55:00',5.08),('8537','2014-04-30','13:00:00',5.39),('8537','2014-04-30','13:05:00',2.81),('8537','2014-04-30','13:10:00',4.26),('8537','2014-04-30','13:15:00',3.07),('8537','2014-04-30','13:20:00',2.49),('8537','2014-04-30','13:25:00',3.04),('8537','2014-04-30','13:30:00',2.52),('8537','2014-04-30','13:35:00',2.33),('8537','2014-04-30','13:40:00',4),('8537','2014-04-30','13:45:00',3.49),('8537','2014-04-30','13:50:00',3.21),('8537','2014-04-30','13:55:00',4.85),('8537','2014-04-30','14:00:00',2.71),('8537','2014-04-30','14:05:00',2.7),('8537','2014-04-30','14:10:00',1.9),('8537','2014-04-30','14:15:00',2.13),('8537','2014-04-30','14:20:00',3.72),('8537','2014-04-30','14:25:00',4.21),('8537','2014-04-30','14:30:00',5.24),('8537','2014-04-30','14:35:00',5.44),('8537','2014-04-30','14:40:00',2.73),('8537','2014-04-30','14:45:00',1.76),('8537','2014-04-30','14:50:00',1.92),('8537','2014-04-30','14:55:00',2.14),('8537','2014-04-30','15:00:00',1.8),('8537','2014-04-30','15:05:00',1.74),('8537','2014-04-30','15:10:00',1.65),('8537','2014-04-30','15:15:00',1.54),('8537','2014-04-30','15:20:00',1.4),('8537','2014-04-30','15:25:00',1.53),('8537','2014-04-30','15:30:00',2.09),('8537','2014-04-30','15:35:00',3.24),('8537','2014-04-30','15:40:00',4.1),('8537','2014-04-30','15:45:00',4.01),('8537','2014-04-30','15:50:00',4.94),('8537','2014-04-30','15:55:00',3.37),('8537','2014-04-30','16:00:00',1.53),('8537','2014-04-30','16:05:00',3.01),('8537','2014-04-30','16:10:00',2.1),('8537','2014-04-30','16:15:00',3.17),('8537','2014-04-30','16:20:00',2.05),('8537','2014-04-30','16:25:00',2.12),('8537','2014-04-30','16:30:00',2.52),('8537','2014-04-30','16:35:00',1.5),('8537','2014-04-30','16:40:00',2.41),('8537','2014-04-30','16:45:00',1.73),('8537','2014-04-30','16:50:00',2.2),('8537','2014-04-30','16:55:00',3.24),('8537','2014-04-30','17:00:00',1.55),('8537','2014-04-30','17:05:00',2.34),('8537','2014-04-30','17:10:00',1.45),('8537','2014-04-30','17:15:00',1.52),('8537','2014-04-30','17:20:00',1.11),('8537','2014-04-30','17:35:00',1.18),('8537','2014-04-30','17:40:00',1.29),('8537','2014-03-07','11:30:00',1.12),('8537','2014-03-07','11:35:00',1.03),('8537','2014-03-07','11:45:00',2.62),('8537','2014-03-07','11:50:00',2.37),('8537','2014-03-07','11:55:00',5.23),('8537','2014-03-07','12:00:00',5.72),('8537','2014-03-07','12:05:00',4.54),('8537','2014-03-07','12:10:00',5.52),('8537','2014-03-07','12:15:00',5.25),('8537','2014-03-07','12:20:00',5.35),('8537','2014-03-07','12:25:00',5.28),('8537','2014-03-07','12:30:00',5.35),('8537','2014-03-07','12:35:00',5.18),('8537','2014-03-07','12:40:00',3.39),('8537','2014-03-07','12:45:00',3.62),('8537','2014-03-07','12:50:00',2.27),('8537','2014-03-07','13:00:00',1.35),('8537','2014-03-07','13:05:00',3.32),('8537','2014-03-07','13:10:00',1.25),('8537','2014-03-07','13:15:00',1.69),('8537','2014-03-07','13:20:00',2.98),('8537','2014-03-07','13:25:00',3.89),('8537','2014-03-07','13:30:00',2.76),('8537','2014-03-07','13:35:00',3.37),('8537','2014-03-07','13:40:00',3.69),('8537','2014-03-07','13:45:00',2.94),('8537','2014-03-07','13:50:00',1.67),('8537','2014-03-07','13:55:00',1.36),('8537','2014-03-07','14:00:00',1.31),('8537','2014-03-07','14:05:00',1.26),('8537','2014-03-07','14:10:00',1.28),('8537','2014-03-07','14:15:00',1.25),('8537','2014-03-07','14:20:00',1.19),('8537','2014-03-07','14:25:00',1.16),('8537','2014-03-07','14:30:00',1.23),('8537','2014-03-07','14:35:00',1.29),('8537','2014-03-07','14:40:00',1.34),('8537','2014-03-07','14:45:00',1.29),('8537','2014-03-07','14:50:00',1.59),('8537','2014-03-07','14:55:00',2.28),('8537','2014-03-07','15:00:00',3.19),('8537','2014-03-07','15:05:00',3.63),('8537','2014-03-07','15:10:00',3.65),('8537','2014-03-07','15:15:00',3.76),('8537','2014-03-07','15:20:00',3.89),('8537','2014-03-07','15:25:00',3.72),('8537','2014-03-07','15:30:00',3.59),('8537','2014-03-07','15:35:00',3.34),('8537','2014-03-07','15:40:00',3.1),('8537','2014-03-07','15:45:00',2.48),('8537','2014-03-07','15:50:00',1.04),('8537','2014-03-07','16:00:00',1.46),('8537','2014-03-07','16:05:00',1.63),('8537','2014-03-07','16:10:00',1.61),('8537','2014-03-07','16:15:00',2.03),('8537','2014-03-07','16:20:00',1.9),('8537','2014-03-07','16:25:00',1.77),('8537','2014-03-07','16:30:00',1.58),('8537','2014-03-07','16:35:00',1.4),('8537','2014-03-07','16:40:00',1.46),('8537','2014-03-07','16:45:00',1.35),('8537','2014-03-07','16:50:00',1.23),('8537','2014-03-07','16:55:00',1.16),('8537','2014-03-07','17:00:00',1.06),('8537','2014-03-06','08:00:00',1.32),('8537','2014-03-06','08:05:00',1.23),('8537','2014-03-06','08:10:00',2),('8537','2014-03-06','08:15:00',2.29),('8537','2014-03-06','08:20:00',1.84),('8537','2014-03-06','08:25:00',1.65),('8537','2014-03-06','08:35:00',1.27),('8537','2014-03-06','08:40:00',1.26),('8537','2014-03-06','08:45:00',1.17),('8537','2014-03-06','08:50:00',1.24),('8537','2014-03-06','08:55:00',1.09),('8537','2014-03-06','09:00:00',1.1),('8537','2014-03-06','09:15:00',1.19),('8537','2014-03-06','09:20:00',1.29),('8537','2014-03-06','09:25:00',1.13),('8537','2014-03-06','09:30:00',1.26),('8537','2014-03-06','09:35:00',1.48),('8537','2014-03-06','09:40:00',1.8),('8537','2014-03-06','09:45:00',2.13),('8537','2014-03-06','09:50:00',2.23),('8537','2014-03-06','09:55:00',2.37),('8537','2014-03-06','10:00:00',2.36),('8537','2014-03-06','10:05:00',2.88),('8537','2014-03-06','10:10:00',3.6),('8537','2014-03-06','10:15:00',4.23),('8537','2014-03-06','10:20:00',3.6),('8537','2014-03-06','10:25:00',2.73),('8537','2014-03-06','10:30:00',1.51),('8537','2014-03-06','10:35:00',1.54),('8537','2014-03-06','10:40:00',1.94),('8537','2014-03-06','10:45:00',2.28),('8537','2014-03-06','10:50:00',1.57),('8537','2014-03-06','10:55:00',1.94),('8537','2014-03-06','11:00:00',2.99),('8537','2014-03-06','11:05:00',4.25),('8537','2014-03-06','11:10:00',2.83),('8537','2014-03-06','11:15:00',3.7),('8537','2014-03-06','11:20:00',2.04),('8537','2014-03-06','11:25:00',2.09),('8537','2014-03-06','11:30:00',2.18),('8537','2014-03-06','11:35:00',1.54),('8537','2014-03-06','11:40:00',1.95),('8537','2014-03-06','11:45:00',3.73),('8537','2014-03-06','11:50:00',4.33),('8537','2014-03-06','11:55:00',4.22),('8537','2014-03-06','12:00:00',1.82),('8537','2014-03-06','12:05:00',3.88),('8537','2014-03-06','12:10:00',5.72),('8537','2014-03-06','12:15:00',4.12),('8537','2014-03-06','12:20:00',2.8),('8537','2014-03-06','12:25:00',5.24),('8537','2014-03-06','12:30:00',5.29),('8537','2014-03-06','12:35:00',2.62),('8537','2014-03-06','12:40:00',1.84),('8537','2014-03-06','12:45:00',1.33),('8537','2014-03-06','12:50:00',1.22),('8537','2014-03-06','12:55:00',1.45),('8537','2014-03-06','13:00:00',1.54),('8537','2014-03-06','13:05:00',1.57),('8537','2014-03-06','13:10:00',1.48),('8537','2014-03-06','13:15:00',1.88),('8537','2014-03-06','13:20:00',1.41),('8537','2014-03-06','13:25:00',1.27),('8537','2014-03-06','13:30:00',1.38),('8537','2014-03-06','13:35:00',1.37),('8537','2014-03-06','13:40:00',1.47),('8537','2014-03-06','13:45:00',1.23),('8537','2014-03-06','13:50:00',1.13),('8537','2014-03-06','13:55:00',1.04),('8537','2014-03-06','14:00:00',1.06),('8537','2014-03-06','14:05:00',1.22),('8537','2014-03-06','14:10:00',1.23),('8537','2014-03-06','14:15:00',1.2),('8537','2014-03-06','14:20:00',1.39),('8537','2014-03-06','14:25:00',1.34),('8537','2014-03-06','14:30:00',1.33),('8537','2014-03-06','14:35:00',1.74),('8537','2014-03-06','14:40:00',1.31),('8537','2014-03-06','14:50:00',1.09),('8537','2014-03-06','14:55:00',1.02),('8537','2014-03-06','15:00:00',1.07),('8537','2014-03-06','15:05:00',1.24),('8537','2014-03-06','15:10:00',1.46),('8537','2014-03-06','16:25:00',1.55),('8537','2014-03-06','16:30:00',1.24),('8537','2014-03-05','07:30:00',1.04),('8537','2014-03-05','07:35:00',1.2),('8537','2014-03-05','07:40:00',1.34),('8537','2014-03-05','07:45:00',1.48),('8537','2014-03-05','07:50:00',1.59),('8537','2014-03-05','07:55:00',1.7),('8537','2014-03-05','08:00:00',1.73),('8537','2014-03-05','08:05:00',1.84),('8537','2014-03-05','08:10:00',2),('8537','2014-03-05','08:15:00',1.94),('8537','2014-03-05','08:20:00',1.12),('8537','2014-03-05','08:30:00',2.42),('8537','2014-03-05','08:35:00',2.78),('8537','2014-03-05','08:40:00',3.02),('8537','2014-03-05','08:45:00',2.7),('8537','2014-03-05','08:50:00',1),('8537','2014-03-05','08:55:00',1.23),('8537','2014-03-05','09:00:00',3.5),('8537','2014-03-05','09:05:00',1.52),('8537','2014-03-05','09:15:00',2.72),('8537','2014-03-05','09:20:00',3.44),('8537','2014-03-05','09:25:00',3.45),('8537','2014-03-05','09:30:00',3.5),('8537','2014-03-05','09:35:00',3.63),('8537','2014-03-05','09:40:00',3.69),('8537','2014-03-05','09:45:00',3.75),('8537','2014-03-05','09:50:00',3.8),('8537','2014-03-05','09:55:00',3.88),('8537','2014-03-05','10:00:00',3.97),('8537','2014-03-05','10:05:00',4.05),('8537','2014-03-05','10:10:00',4.14),('8537','2014-03-05','10:15:00',4.16),('8537','2014-03-05','10:20:00',4.21),('8537','2014-03-05','10:25:00',4.25),('8537','2014-03-05','10:30:00',4.3),('8537','2014-03-05','10:35:00',4.35),('8537','2014-03-05','10:40:00',4.37),('8537','2014-03-05','10:45:00',4.42),('8537','2014-03-05','10:50:00',4.48),('8537','2014-03-05','10:55:00',4.52),('8537','2014-03-05','11:00:00',4.56),('8537','2014-03-05','11:05:00',4.55),('8537','2014-03-05','11:10:00',4.69),('8537','2014-03-05','11:15:00',4.75),('8537','2014-03-05','11:20:00',4.77),('8537','2014-03-05','11:25:00',4.78),('8537','2014-03-05','11:30:00',4.89),('8537','2014-03-05','11:35:00',5.12),('8537','2014-03-05','11:40:00',4.97),('8537','2014-03-05','11:45:00',4.98),('8537','2014-03-05','11:50:00',4.94),('8537','2014-03-05','11:55:00',4.16),('8537','2014-03-05','12:00:00',4.31),('8537','2014-03-05','12:05:00',3.77),('8537','2014-03-05','12:10:00',1.43),('8537','2014-03-05','12:15:00',1.32),('8537','2014-03-05','12:25:00',1.03),('8537','2014-03-05','12:30:00',1.29),('8537','2014-03-05','12:35:00',1.98),('8537','2014-03-05','12:40:00',1.53),('8537','2014-03-05','12:45:00',1.49),('8537','2014-03-05','12:50:00',2.05),('8537','2014-03-05','12:55:00',2.24),('8537','2014-03-05','13:00:00',2.73),('8537','2014-03-05','13:05:00',3.41),('8537','2014-03-05','13:10:00',4.01),('8537','2014-03-05','13:15:00',3.35),('8537','2014-03-05','13:20:00',2.73),('8537','2014-03-05','13:25:00',2.21),('8537','2014-03-05','13:30:00',1.45),('8537','2014-03-05','13:35:00',1.6),('8537','2014-03-05','13:40:00',1.86),('8537','2014-03-05','13:45:00',1.71),('8537','2014-03-05','13:50:00',1.45),('8537','2014-03-05','13:55:00',1.32),('8537','2014-03-05','14:00:00',1.21),('8537','2014-03-05','14:05:00',1.19),('8537','2014-03-05','14:10:00',1.24),('8537','2014-03-05','14:15:00',1.4),('8537','2014-03-05','14:20:00',1.47),('8537','2014-03-05','14:25:00',1.6),('8537','2014-03-05','14:30:00',1.71),('8537','2014-03-05','14:35:00',1.45),('8537','2014-03-05','14:40:00',1.69),('8537','2014-03-05','14:45:00',1.92),('8537','2014-03-05','14:50:00',2.64),('8537','2014-03-05','14:55:00',1.63),('8537','2014-03-05','15:00:00',1.13),('8537','2014-03-05','15:30:00',1.17),('8537','2014-03-05','15:35:00',1.29),('8537','2014-03-05','15:40:00',2.38),('8537','2014-03-05','15:45:00',2.19),('8537','2014-03-05','15:50:00',1.49),('8537','2014-03-05','15:55:00',2.28),('8537','2014-03-05','16:00:00',2.64),('8537','2014-03-05','16:05:00',2.53),('8537','2014-03-05','16:10:00',2.28),('8537','2014-03-05','16:15:00',1.62),('8537','2014-03-04','09:05:00',1.23),('8537','2014-03-04','09:10:00',1.45),('8537','2014-03-04','09:15:00',2.48),('8537','2014-03-04','09:20:00',3.22),('8537','2014-03-04','09:25:00',1.12),('8537','2014-03-04','09:30:00',1.2),('8537','2014-03-04','09:35:00',1.2),('8537','2014-03-04','09:40:00',1.68),('8537','2014-03-04','09:45:00',2.01),('8537','2014-03-04','09:55:00',2.25),('8537','2014-03-04','10:00:00',1.97),('8537','2014-03-04','10:05:00',1.22),('8537','2014-03-04','10:20:00',1.04),('8537','2014-03-04','10:25:00',4.14),('8537','2014-03-04','10:30:00',3),('8537','2014-03-04','10:35:00',4.03),('8537','2014-03-04','10:40:00',5),('8537','2014-03-04','10:45:00',4.73),('8537','2014-03-04','10:50:00',1.66),('8537','2014-03-04','10:55:00',3.34),('8537','2014-03-04','11:00:00',3.04),('8537','2014-03-04','11:05:00',2.03),('8537','2014-03-04','11:10:00',4.32),('8537','2014-03-04','11:15:00',5.61),('8537','2014-03-04','11:20:00',4.08),('8537','2014-03-04','11:25:00',1.29),('8537','2014-03-04','11:30:00',1.12),('8537','2014-03-04','11:40:00',1.05),('8537','2014-03-04','11:45:00',2.56),('8537','2014-03-04','11:50:00',5.59),('8537','2014-03-04','11:55:00',5.16),('8537','2014-03-04','12:00:00',4.96),('8537','2014-03-04','12:05:00',4.9),('8537','2014-03-04','12:10:00',4.89),('8537','2014-03-04','12:15:00',4.86),('8537','2014-03-04','12:20:00',4.88),('8537','2014-03-04','12:25:00',4.82),('8537','2014-03-04','12:30:00',4.77),('8537','2014-03-04','12:35:00',4.73),('8537','2014-03-04','12:40:00',4.76),('8537','2014-03-04','12:45:00',4.07),('8537','2014-03-04','12:50:00',4.45),('8537','2014-03-04','12:55:00',3.22),('8537','2014-03-04','13:00:00',4.15),('8537','2014-03-04','13:05:00',4.76),('8537','2014-03-04','13:10:00',5.03),('8537','2014-03-04','13:15:00',3.98),('8537','2014-03-04','13:20:00',1.67),('8537','2014-03-04','13:25:00',1.18),('8537','2014-03-04','13:30:00',1.22),('8537','2014-03-04','13:45:00',1.04),('8537','2014-03-04','13:50:00',1.41),('8537','2014-03-04','13:55:00',1.34),('8537','2014-03-04','14:05:00',1.68),('8537','2014-03-04','14:10:00',4.01),('8537','2014-03-04','14:15:00',3.39),('8537','2014-03-04','14:20:00',1.55),('8537','2014-03-04','14:25:00',3.21),('8537','2014-03-04','14:30:00',4.03),('8537','2014-03-04','14:35:00',3.83),('8537','2014-03-04','14:40:00',3.78),('8537','2014-03-04','14:45:00',3.76),('8537','2014-03-04','14:50:00',3.15),('8537','2014-03-04','14:55:00',1.91),('8537','2014-03-04','15:00:00',3.24),('8537','2014-03-04','15:05:00',3.36),('8537','2014-03-04','15:10:00',3.28),('8537','2014-03-04','15:15:00',2.96),('8537','2014-03-04','15:20:00',1.93),('8537','2014-03-04','15:25:00',2.81),('8537','2014-03-04','15:30:00',1.54),('8537','2014-03-04','15:35:00',3.15),('8537','2014-03-04','15:40:00',2.91),('8537','2014-03-04','15:45:00',2.19),('8537','2014-03-04','15:50:00',1.93),('8537','2014-03-04','15:55:00',1.02),('8537','2014-03-04','16:05:00',1.05),('8537','2014-03-04','16:10:00',1.14),('8537','2014-03-04','16:20:00',1.04),('8537','2014-03-04','16:25:00',1.33),('8537','2014-03-04','16:30:00',1.03),('8537','2014-03-04','16:40:00',1.08),('8537','2014-03-04','16:45:00',1.11),('8537','2014-03-03','07:40:00',1.07),('8537','2014-03-03','07:45:00',1.19),('8537','2014-03-03','07:50:00',1.29),('8537','2014-03-03','07:55:00',1.13),('8537','2014-03-03','08:00:00',1.21),('8537','2014-03-03','08:05:00',1.23),('8537','2014-03-03','08:10:00',1.74),('8537','2014-03-03','08:15:00',1.92),('8537','2014-03-03','08:20:00',2.02),('8537','2014-03-03','08:25:00',2.1),('8537','2014-03-03','08:30:00',2.22),('8537','2014-03-03','08:35:00',2.32),('8537','2014-03-03','08:40:00',2.48),('8537','2014-03-03','08:45:00',2.56),('8537','2014-03-03','08:50:00',2.51),('8537','2014-03-03','08:55:00',2.83),('8537','2014-03-03','09:00:00',2.89),('8537','2014-03-03','09:05:00',2.93),('8537','2014-03-03','09:10:00',2.8),('8537','2014-03-03','09:15:00',2.85),('8537','2014-03-03','09:20:00',3.1),('8537','2014-03-03','09:25:00',3.26),('8537','2014-03-03','09:30:00',3.15),('8537','2014-03-03','09:35:00',2.9),('8537','2014-03-03','09:40:00',2.69),('8537','2014-03-03','09:45:00',2.77),('8537','2014-03-03','09:50:00',2.83),('8537','2014-03-03','09:55:00',3.34),('8537','2014-03-03','10:00:00',3.66),('8537','2014-03-03','10:05:00',3.87),('8537','2014-03-03','10:10:00',3.88),('8537','2014-03-03','10:15:00',3.94),('8537','2014-03-03','10:20:00',3.98),('8537','2014-03-03','10:25:00',4.05),('8537','2014-03-03','10:30:00',4.14),('8537','2014-03-03','10:35:00',4.17),('8537','2014-03-03','10:40:00',4.22),('8537','2014-03-03','10:45:00',4.23),('8537','2014-03-03','10:50:00',4.27),('8537','2014-03-03','10:55:00',4.3),('8537','2014-03-03','11:00:00',4.34),('8537','2014-03-03','11:05:00',4.28),('8537','2014-03-03','11:10:00',4.4),('8537','2014-03-03','11:15:00',4.43),('8537','2014-03-03','11:20:00',4.48),('8537','2014-03-03','11:25:00',4.56),('8537','2014-03-03','11:30:00',4.62),('8537','2014-03-03','11:35:00',4.56),('8537','2014-03-03','11:40:00',4.05),('8537','2014-03-03','11:45:00',4.73),('8537','2014-03-03','11:50:00',4.78),('8537','2014-03-03','11:55:00',4.78),('8537','2014-03-03','12:00:00',4.77),('8537','2014-03-03','12:05:00',4.78),('8537','2014-03-03','12:10:00',4.78),('8537','2014-03-03','12:15:00',4.76),('8537','2014-03-03','12:20:00',4.76),('8537','2014-03-03','12:25:00',4.71),('8537','2014-03-03','12:30:00',4.75),('8537','2014-03-03','12:35:00',4.74),('8537','2014-03-03','12:40:00',4.74),('8537','2014-03-03','12:45:00',4.7),('8537','2014-03-03','12:50:00',4.72),('8537','2014-03-03','12:55:00',4.69),('8537','2014-03-03','13:00:00',4.69),('8537','2014-03-03','13:05:00',4.67),('8537','2014-03-03','13:10:00',4.64),('8537','2014-03-03','13:15:00',4.59),('8537','2014-03-03','13:20:00',4.61),('8537','2014-03-03','13:25:00',4.57),('8537','2014-03-03','13:30:00',4.54),('8537','2014-03-03','13:35:00',4.5),('8537','2014-03-03','13:40:00',4.45),('8537','2014-03-03','13:45:00',4.42),('8537','2014-03-03','13:50:00',4.37),('8537','2014-03-03','13:55:00',4.33),('8537','2014-03-03','14:00:00',4.31),('8537','2014-03-03','14:05:00',4.25),('8537','2014-03-03','14:10:00',4.17),('8537','2014-03-03','14:15:00',4.18),('8537','2014-03-03','14:20:00',4.03),('8537','2014-03-03','14:25:00',3.13),('8537','2014-03-03','14:30:00',3.95),('8537','2014-03-03','14:35:00',3.89),('8537','2014-03-03','14:40:00',3.79),('8537','2014-03-03','14:45:00',3.68),('8537','2014-03-03','14:50:00',3.58),('8537','2014-03-03','14:55:00',3.51),('8537','2014-03-03','15:00:00',3.3),('8537','2014-03-03','15:05:00',2.97),('8537','2014-03-03','15:10:00',3.02),('8537','2014-03-03','15:15:00',3.12),('8537','2014-03-03','15:20:00',3.04),('8537','2014-03-03','15:25:00',2.93),('8537','2014-03-03','15:30:00',2.84),('8537','2014-03-03','15:35:00',2.72),('8537','2014-03-03','15:40:00',2.61),('8537','2014-03-03','15:45:00',2.44),('8537','2014-03-03','15:50:00',2.36),('8537','2014-03-03','15:55:00',2.24),('8537','2014-03-03','16:00:00',2.13),('8537','2014-03-03','16:05:00',2.02),('8537','2014-03-03','16:10:00',1.87),('8537','2014-03-03','16:15:00',1.62),('8537','2014-03-03','16:20:00',1.63),('8537','2014-03-03','16:25:00',1.52),('8537','2014-03-03','16:30:00',1.38),('8537','2014-03-03','16:35:00',1.23),('8537','2014-03-03','16:40:00',1.12),('8537','2014-03-03','16:45:00',1.04),('8537','2014-03-02','08:00:00',1.38),('8537','2014-03-02','08:05:00',1.62),('8537','2014-03-02','08:10:00',2.38),('8537','2014-03-02','08:15:00',2.33),('8537','2014-03-02','08:20:00',2.4),('8537','2014-03-02','08:25:00',2.18),('8537','2014-03-02','08:30:00',2.21),('8537','2014-03-02','08:35:00',2.34),('8537','2014-03-02','08:40:00',2.47),('8537','2014-03-02','08:45:00',2.59),('8537','2014-03-02','08:50:00',2.7),('8537','2014-03-02','08:55:00',2.81),('8537','2014-03-02','09:00:00',2.89),('8537','2014-03-02','09:05:00',3.02),('8537','2014-03-02','09:10:00',3.19),('8537','2014-03-02','09:15:00',3.29),('8537','2014-03-02','09:20:00',2.51),('8537','2014-03-02','09:25:00',3.32),('8537','2014-03-02','09:30:00',3.69),('8537','2014-03-02','09:35:00',3.69),('8537','2014-03-02','09:40:00',3.16),('8537','2014-03-02','09:45:00',1.75),('8537','2014-03-02','09:55:00',1.13),('8537','2014-03-02','10:00:00',1.7),('8537','2014-03-02','10:05:00',1.8),('8537','2014-03-02','10:10:00',1.73),('8537','2014-03-02','10:15:00',1.4),('8537','2014-03-02','10:20:00',1.43),('8537','2014-03-02','10:25:00',1.57),('8537','2014-03-02','10:30:00',1.77),('8537','2014-03-02','10:35:00',2.27),('8537','2014-03-02','10:40:00',3.13),('8537','2014-03-02','10:45:00',1.43),('8537','2014-03-02','10:50:00',1.37),('8537','2014-03-02','10:55:00',1.42),('8537','2014-03-02','11:00:00',2.66),('8537','2014-03-02','11:05:00',4.37),('8537','2014-03-02','11:10:00',1.9),('8537','2014-03-02','11:15:00',1.46),('8537','2014-03-02','11:20:00',1.82),('8537','2014-03-02','11:25:00',2.34),('8537','2014-03-02','11:30:00',2.35),('8537','2014-03-02','11:35:00',3.78),('8537','2014-03-02','11:40:00',3.99),('8537','2014-03-02','11:45:00',4.87),('8537','2014-03-02','11:50:00',5.72),('8537','2014-03-02','11:55:00',5.52),('8537','2014-03-02','12:00:00',3.72),('8537','2014-03-02','12:05:00',2.47),('8537','2014-03-02','12:10:00',2.39),('8537','2014-03-02','12:15:00',4.13),('8537','2014-03-02','12:20:00',2.91),('8537','2014-03-02','12:25:00',2.53),('8537','2014-03-02','12:30:00',1.74),('8537','2014-03-02','12:35:00',1.36),('8537','2014-03-02','12:40:00',1.15),('8537','2014-03-02','12:45:00',1.15),('8537','2014-03-02','12:50:00',1.27),('8537','2014-03-02','12:55:00',1.48),('8537','2014-03-02','13:00:00',1.69),('8537','2014-03-02','13:05:00',1.75),('8537','2014-03-02','13:10:00',1.74),('8537','2014-03-02','13:15:00',1.7),('8537','2014-03-02','13:20:00',1.62),('8537','2014-03-02','13:25:00',1.44),('8537','2014-03-02','13:30:00',1.29),('8537','2014-03-02','13:35:00',1.07),('8537','2014-03-02','13:50:00',1.02),('8537','2014-03-02','13:55:00',1.14),('8537','2014-03-02','14:00:00',1.44),('8537','2014-03-02','14:05:00',1.58),('8537','2014-03-02','14:10:00',1.53),('8537','2014-03-02','14:15:00',1.46),('8537','2014-03-02','14:20:00',1.37),('8537','2014-03-02','14:25:00',1.37),('8537','2014-03-02','14:30:00',1.47),('8537','2014-03-02','14:35:00',1.46),('8537','2014-03-02','14:40:00',1.48),('8537','2014-03-02','14:45:00',1.53),('8537','2014-03-02','14:50:00',1.51),('8537','2014-03-02','14:55:00',1.47),('8537','2014-03-02','15:00:00',1.52),('8537','2014-03-02','15:05:00',1.61),('8537','2014-03-02','15:10:00',1.62),('8537','2014-03-02','15:15:00',1.6),('8537','2014-03-02','15:20:00',1.51),('8537','2014-03-02','15:25:00',1.65),('8537','2014-03-02','15:30:00',1.6),('8537','2014-03-02','15:35:00',1.67),('8537','2014-03-02','15:40:00',1.55),('8537','2014-03-02','15:45:00',1.37),('8537','2014-03-02','15:50:00',1.25),('8537','2014-03-02','15:55:00',1.11),('8537','2014-02-28','07:45:00',1.03),('8537','2014-02-28','07:50:00',1.17),('8537','2014-02-28','07:55:00',1.38),('8537','2014-02-28','08:00:00',1.7),('8537','2014-02-28','08:05:00',1.2),('8537','2014-02-28','08:10:00',1),('8537','2014-02-28','08:15:00',1.53),('8537','2014-02-28','08:20:00',2.34),('8537','2014-02-28','08:25:00',1.78),('8537','2014-02-28','08:35:00',2.39),('8537','2014-02-28','08:40:00',1.17),('8537','2014-02-28','09:15:00',1.46),('8537','2014-02-28','09:20:00',1.52),('8537','2014-02-28','09:25:00',1.8),('8537','2014-02-28','09:30:00',2.28),('8537','2014-02-28','09:35:00',1.28),('8537','2014-02-28','09:40:00',2.68),('8537','2014-02-28','09:45:00',3.75),('8537','2014-02-28','09:50:00',4.33),('8537','2014-02-28','09:55:00',3.58),('8537','2014-02-28','10:00:00',1.56),('8537','2014-02-28','10:05:00',1.35),('8537','2014-02-28','10:10:00',2.23),('8537','2014-02-28','10:15:00',1.51),('8537','2014-02-28','10:20:00',2),('8537','2014-02-28','10:25:00',4.38),('8537','2014-02-28','10:30:00',4.78),('8537','2014-02-28','10:35:00',3.45),('8537','2014-02-28','10:40:00',1.64),('8537','2014-02-28','11:15:00',1.07),('8537','2014-02-28','11:20:00',1.47),('8537','2014-02-28','11:25:00',1.5),('8537','2014-02-28','11:30:00',1.27),('8537','2014-02-28','11:45:00',1.02),('8537','2014-02-28','11:50:00',1.31),('8537','2014-02-28','11:55:00',1.35),('8537','2014-02-28','12:00:00',1.68),('8537','2014-02-28','12:05:00',2.46),('8537','2014-02-28','12:10:00',2.49),('8537','2014-02-28','12:15:00',1.45),('8537','2014-02-28','12:20:00',1.16),('8537','2014-02-28','12:25:00',1.84),('8537','2014-02-28','12:30:00',2.73),('8537','2014-02-28','12:35:00',3.81),('8537','2014-02-28','12:40:00',3.68),('8537','2014-02-28','12:45:00',1.4),('8537','2014-02-28','12:50:00',3.33),('8537','2014-02-28','12:55:00',2.27),('8537','2014-02-28','13:00:00',2.94),('8537','2014-02-28','13:05:00',2.14),('8537','2014-02-28','13:10:00',1.89),('8537','2014-02-28','13:15:00',1.28),('8537','2014-02-28','13:45:00',1.03),('8537','2014-02-28','13:50:00',4.47),('8537','2014-02-28','13:55:00',4.11),('8537','2014-02-28','14:00:00',1.89),('8537','2014-02-28','14:05:00',1.21),('8537','2014-02-28','14:15:00',1.34),('8537','2014-02-28','14:20:00',2.02),('8537','2014-02-28','14:25:00',2.62),('8537','2014-02-28','14:30:00',2.19),('8537','2014-02-28','14:35:00',1.71),('8537','2014-02-28','14:40:00',1.51),('8537','2014-02-28','14:45:00',1.49),('8537','2014-02-28','14:50:00',1.59),('8537','2014-02-28','14:55:00',1.73),('8537','2014-02-28','15:00:00',2.21),('8537','2014-02-28','15:05:00',1.46),('8537','2014-02-28','15:25:00',2.57),('8537','2014-02-28','15:30:00',2.58),('8537','2014-02-28','15:35:00',2.89),('8537','2014-02-28','15:40:00',2.52),('8537','2014-02-28','16:10:00',1.15),('8537','2014-02-28','16:15:00',2.22),('8537','2014-02-28','16:20:00',1.89),('8537','2014-02-28','16:35:00',1.04),('8537','2014-02-28','16:40:00',1.25),('8537','2014-02-28','16:45:00',1.46),('8537','2014-02-28','16:50:00',1.31),('8537','2014-02-27','10:35:00',1.13),('8537','2014-02-27','10:40:00',1.29),('8537','2014-02-27','10:45:00',1.42),('8537','2014-02-27','10:50:00',1.5),('8537','2014-02-27','10:55:00',1.61),('8537','2014-02-27','11:00:00',1.83),('8537','2014-02-27','11:05:00',2.06),('8537','2014-02-27','11:10:00',1.89),('8537','2014-02-27','11:15:00',1.84),('8537','2014-02-27','11:20:00',1.72),('8537','2014-02-27','11:25:00',1.85),('8537','2014-02-27','11:30:00',2.31),('8537','2014-02-27','11:35:00',2.19),('8537','2014-02-27','11:40:00',1.78),('8537','2014-02-27','11:45:00',1.54),('8537','2014-02-27','11:50:00',1.46),('8537','2014-02-27','11:55:00',1.48),('8537','2014-02-27','12:00:00',1.45),('8537','2014-02-27','12:05:00',1.45),('8537','2014-02-27','12:10:00',1.26),('8537','2014-02-27','12:15:00',1.37),('8537','2014-02-27','12:20:00',1.48),('8537','2014-02-27','12:25:00',1.51),('8537','2014-02-27','12:30:00',1.41),('8537','2014-02-27','12:35:00',1.36),('8537','2014-02-27','12:40:00',1.33),('8537','2014-02-27','12:45:00',1.31),('8537','2014-02-27','12:50:00',1.28),('8537','2014-02-27','12:55:00',1.3),('8537','2014-02-27','13:00:00',1.38),('8537','2014-02-27','13:05:00',1.25),('8537','2014-02-27','13:10:00',1.3),('8537','2014-02-27','13:15:00',1.46),('8537','2014-02-27','13:20:00',1.47),('8537','2014-02-27','13:25:00',1.56),('8537','2014-02-27','13:30:00',1.75),('8537','2014-02-27','13:35:00',1.95),('8537','2014-02-27','13:40:00',1.97),('8537','2014-02-27','13:45:00',1.98),('8537','2014-02-27','13:50:00',2.05),('8537','2014-02-27','13:55:00',2.35),('8537','2014-02-27','14:00:00',2.32),('8537','2014-02-27','14:05:00',2.05),('8537','2014-02-27','14:10:00',1.79),('8537','2014-02-27','14:15:00',1.64),('8537','2014-02-27','14:20:00',1.67),('8537','2014-02-27','14:25:00',1.68),('8537','2014-02-27','14:30:00',1.82),('8537','2014-02-27','14:35:00',1.77),('8537','2014-02-27','14:40:00',1.56),('8537','2014-02-27','14:45:00',1.55),('8537','2014-02-27','14:50:00',1.45),('8537','2014-02-27','14:55:00',1.32),('8537','2014-02-27','15:00:00',1.39),('8537','2014-02-27','15:05:00',1.29),('8537','2014-02-27','15:10:00',1.37),('8537','2014-02-27','15:15:00',1.58),('8537','2014-02-27','15:20:00',1.7),('8537','2014-02-27','15:25:00',1.54),('8537','2014-02-27','15:30:00',1.5),('8537','2014-02-27','15:35:00',1.53),('8537','2014-02-27','15:40:00',1.27),('8537','2014-02-27','15:45:00',1.03),('8537','2014-02-27','16:40:00',1.09),('8537','2014-02-27','16:50:00',1.16),('8537','2014-02-27','16:55:00',1.14),('8537','2014-02-26','07:55:00',1.09),('8537','2014-02-26','08:00:00',1.3),('8537','2014-02-26','08:05:00',1.41),('8537','2014-02-26','08:10:00',1.59),('8537','2014-02-26','08:15:00',1.72),('8537','2014-02-26','08:20:00',1.83),('8537','2014-02-26','08:25:00',1.93),('8537','2014-02-26','08:30:00',2),('8537','2014-02-26','08:35:00',2.18),('8537','2014-02-26','08:40:00',2.31),('8537','2014-02-26','08:45:00',2.55),('8537','2014-02-26','08:50:00',2.51),('8537','2014-02-26','08:55:00',2.55),('8537','2014-02-26','09:00:00',2.62),('8537','2014-02-26','09:05:00',2.65),('8537','2014-02-26','09:10:00',2.69),('8537','2014-02-26','09:15:00',2.91),('8537','2014-02-26','09:20:00',2.99),('8537','2014-02-26','09:25:00',2.97),('8537','2014-02-26','09:30:00',2.69),('8537','2014-02-26','09:35:00',2.71),('8537','2014-02-26','09:40:00',2.52),('8537','2014-02-26','09:45:00',2.73),('8537','2014-02-26','09:50:00',2.98),('8537','2014-02-26','09:55:00',1.78),('8537','2014-02-26','10:00:00',1.71),('8537','2014-02-26','10:05:00',1.32),('8537','2014-02-26','10:10:00',1),('8537','2014-02-26','10:20:00',1.19),('8537','2014-02-26','10:25:00',1.16),('8537','2014-02-26','10:30:00',1.17),('8537','2014-02-26','10:35:00',1.08),('8537','2014-02-26','11:00:00',1.09),('8537','2014-02-26','11:05:00',1.21),('8537','2014-02-26','11:10:00',1.2),('8537','2014-02-26','11:15:00',1.19),('8537','2014-02-26','11:50:00',1.02),('8537','2014-02-26','11:55:00',1.13),('8537','2014-02-26','12:00:00',1.38),('8537','2014-02-26','12:05:00',2.62),('8537','2014-02-26','12:10:00',2.27),('8537','2014-02-26','12:15:00',1.47),('8537','2014-02-26','12:20:00',1.22),('8537','2014-02-26','12:25:00',1.48),('8537','2014-02-26','12:30:00',2.46),('8537','2014-02-26','12:35:00',2.26),('8537','2014-02-26','12:40:00',2.89),('8537','2014-02-26','12:45:00',3.14),('8537','2014-02-26','12:50:00',3.86),('8537','2014-02-26','12:55:00',3.51),('8537','2014-02-26','13:00:00',4.39),('8537','2014-02-26','13:05:00',3.92),('8537','2014-02-26','13:10:00',3.78),('8537','2014-02-26','13:15:00',3.63),('8537','2014-02-26','13:20:00',3.81),('8537','2014-02-26','13:25:00',2.89),('8537','2014-02-26','13:30:00',4.61),('8537','2014-02-26','13:35:00',4.28),('8537','2014-02-26','13:40:00',3.92),('8537','2014-02-26','13:45:00',3.62),('8537','2014-02-26','13:50:00',2.3),('8537','2014-02-26','13:55:00',1.46),('8537','2014-02-26','14:00:00',4.4),('8537','2014-02-26','14:05:00',4.08),('8537','2014-02-26','14:10:00',2.02),('8537','2014-02-26','14:15:00',2.72),('8537','2014-02-26','14:20:00',4.32),('8537','2014-02-26','14:25:00',3.95),('8537','2014-02-26','14:30:00',1.76),('8537','2014-02-26','14:35:00',1.89),('8537','2014-02-26','14:40:00',3.9),('8537','2014-02-26','14:45:00',3.6),('8537','2014-02-26','14:50:00',3.15),('8537','2014-02-26','14:55:00',3.71),('8537','2014-02-26','15:00:00',3.41),('8537','2014-02-26','15:05:00',3.15),('8537','2014-02-26','15:10:00',2.95),('8537','2014-02-26','15:15:00',2.59),('8537','2014-02-26','15:20:00',2.16),('8537','2014-02-26','15:25:00',1.14),('8537','2014-02-26','15:30:00',1.48),('8537','2014-02-26','15:35:00',2.05),('8537','2014-02-26','15:40:00',1.98),('8537','2014-02-26','15:45:00',1.59),('8537','2014-02-26','15:50:00',1.44),('8537','2014-02-26','15:55:00',1.79),('8537','2014-02-26','16:00:00',2.08),('8537','2014-02-26','16:05:00',1.9),('8537','2014-02-26','16:10:00',1.31),('8537','2014-04-29','09:50:00',1.17),('8537','2014-04-29','09:55:00',1.31),('8537','2014-04-29','10:00:00',1.34),('8537','2014-04-29','10:05:00',2.07),('8537','2014-04-29','10:10:00',3.79),('8537','2014-04-29','10:15:00',3.94),('8537','2014-04-29','10:20:00',3.72),('8537','2014-04-29','10:25:00',4.37),('8537','2014-04-29','10:30:00',4.68),('8537','2014-04-29','10:35:00',4.64),('8537','2014-04-29','10:40:00',4.67),('8537','2014-04-29','10:45:00',4.69),('8537','2014-04-29','10:50:00',4.78),('8537','2014-04-29','10:55:00',4.58),('8537','2014-04-29','11:00:00',4.69),('8537','2014-04-29','11:05:00',4.74),('8537','2014-04-29','11:10:00',4.77),('8537','2014-04-29','11:15:00',4.41),('8537','2014-04-29','11:20:00',5.28),('8537','2014-04-29','11:25:00',4.07),('8537','2014-04-29','11:30:00',4.72),('8537','2014-04-29','11:35:00',4.85),('8537','2014-04-29','11:40:00',4.02),('8537','2014-04-29','11:45:00',2.44),('8537','2014-04-29','11:50:00',1.69),('8537','2014-04-29','11:55:00',1.35),('8537','2014-04-29','12:00:00',1.6),('8537','2014-04-29','12:05:00',2.26),('8537','2014-04-29','12:10:00',2.48),('8537','2014-04-29','12:15:00',2.81),('8537','2014-04-29','12:20:00',2.53),('8537','2014-04-29','12:25:00',3.35),('8537','2014-04-29','12:30:00',3.46),('8537','2014-04-29','12:35:00',2.12),('8537','2014-04-29','12:40:00',4.64),('8537','2014-04-29','12:45:00',3.24),('8537','2014-04-29','12:50:00',4.85),('8537','2014-04-29','12:55:00',2.43),('8537','2014-04-29','13:00:00',2.53),('8537','2014-04-29','13:05:00',2.15),('8537','2014-04-29','13:10:00',2.15),('8537','2014-04-29','13:15:00',2.88),('8537','2014-04-29','13:20:00',3.63),('8537','2014-04-29','13:25:00',4.13),('8537','2014-04-29','13:30:00',3.63),('8537','2014-04-29','13:35:00',2.12),('8537','2014-04-29','13:40:00',1.75),('8537','2014-04-29','13:45:00',1.89),('8537','2014-04-29','13:50:00',1.95),('8537','2014-04-29','13:55:00',1.39),('8537','2014-04-29','15:05:00',1.3),('8537','2014-04-29','16:15:00',1.05),('8537','2014-04-29','16:20:00',1.22),('8537','2014-04-29','16:25:00',1.36),('8537','2014-04-29','16:30:00',1.17),('8537','2014-04-29','17:00:00',1.1),('8537','2014-04-29','17:05:00',1.39),('8537','2014-04-29','17:10:00',1.37),('8537','2014-04-29','17:15:00',1.07),('8537','2014-04-29','17:25:00',2.08),('8537','2014-04-29','17:30:00',1.85),('8537','2014-04-29','17:35:00',1.64),('8537','2014-04-29','17:40:00',1.88),('8537','2014-04-29','17:45:00',1.73),('8537','2014-02-25','07:50:00',1.02),('8537','2014-02-25','07:55:00',1.14),('8537','2014-02-25','08:00:00',1.26),('8537','2014-02-25','08:05:00',1.39),('8537','2014-02-25','08:10:00',1.5),('8537','2014-02-25','08:15:00',1.63),('8537','2014-02-25','08:20:00',1.74),('8537','2014-02-25','08:25:00',1.86),('8537','2014-02-25','08:30:00',1.96),('8537','2014-02-25','08:35:00',2.07),('8537','2014-02-25','08:40:00',2.17),('8537','2014-02-25','08:45:00',2.27),('8537','2014-02-25','08:50:00',2.37),('8537','2014-02-25','08:55:00',2.47),('8537','2014-02-25','09:00:00',2.58),('8537','2014-02-25','09:05:00',2.68),('8537','2014-02-25','09:10:00',2.78),('8537','2014-02-25','09:15:00',2.87),('8537','2014-02-25','09:20:00',2.95),('8537','2014-02-25','09:25:00',3.04),('8537','2014-02-25','09:30:00',3.11),('8537','2014-02-25','09:35:00',3.16),('8537','2014-02-25','09:40:00',3.25),('8537','2014-02-25','09:45:00',3.34),('8537','2014-02-25','09:50:00',3.4),('8537','2014-02-25','09:55:00',3.46),('8537','2014-02-25','10:00:00',3.51),('8537','2014-02-25','10:05:00',3.59),('8537','2014-02-25','10:10:00',3.68),('8537','2014-02-25','10:15:00',3.75),('8537','2014-02-25','10:20:00',3.79),('8537','2014-02-25','10:25:00',3.84),('8537','2014-02-25','10:30:00',3.91),('8537','2014-02-25','10:35:00',3.93),('8537','2014-02-25','10:40:00',3.96),('8537','2014-02-25','10:45:00',3.98),('8537','2014-02-25','10:50:00',4.05),('8537','2014-02-25','10:55:00',4.05),('8537','2014-02-25','11:00:00',4.09),('8537','2014-02-25','11:05:00',4.14),('8537','2014-02-25','11:10:00',4.22),('8537','2014-02-25','11:15:00',4.24),('8537','2014-02-25','11:20:00',4.26),('8537','2014-02-25','11:25:00',4.24),('8537','2014-02-25','11:30:00',4.23),('8537','2014-02-25','11:35:00',4.32),('8537','2014-02-25','11:40:00',4.29),('8537','2014-02-25','11:45:00',4.28),('8537','2014-02-25','11:50:00',4.29),('8537','2014-02-25','11:55:00',4.34),('8537','2014-02-25','12:00:00',4.37),('8537','2014-02-25','12:05:00',4.42),('8537','2014-02-25','12:10:00',4.48),('8537','2014-02-25','12:15:00',4.39),('8537','2014-02-25','12:20:00',4.36),('8537','2014-02-25','12:25:00',4.37),('8537','2014-02-25','12:30:00',4.41),('8537','2014-02-25','12:35:00',4.39),('8537','2014-02-25','12:40:00',4.43),('8537','2014-02-25','12:45:00',4.46),('8537','2014-02-25','12:50:00',4.49),('8537','2014-02-25','12:55:00',4.43),('8537','2014-02-25','13:00:00',4.34),('8537','2014-02-25','13:05:00',4.33),('8537','2014-02-25','13:10:00',4.3),('8537','2014-02-25','13:15:00',3.45),('8537','2014-02-25','13:20:00',1.2),('8537','2014-02-25','13:25:00',1.2),('8537','2014-02-25','13:30:00',1.06),('8537','2014-02-25','13:35:00',1.25),('8537','2014-02-25','13:40:00',2.07),('8537','2014-02-25','13:45:00',1.33),('8537','2014-02-25','13:50:00',1.21),('8537','2014-02-25','13:55:00',1.44),('8537','2014-02-25','14:00:00',1.55),('8537','2014-02-25','14:05:00',1.39),('8537','2014-02-25','14:10:00',1.21),('8537','2014-02-25','14:15:00',1.31),('8537','2014-02-25','14:20:00',1.38),('8537','2014-02-25','14:25:00',1.66),('8537','2014-02-25','14:30:00',1.69),('8537','2014-02-25','14:35:00',2.63),('8537','2014-02-25','14:40:00',3.61),('8537','2014-02-25','14:45:00',3.62),('8537','2014-02-25','14:50:00',3.37),('8537','2014-02-25','14:55:00',2.36),('8537','2014-02-25','15:00:00',2.7),('8537','2014-02-25','15:05:00',2.85),('8537','2014-02-25','15:10:00',2.8),('8537','2014-02-25','15:15:00',2.65),('8537','2014-02-25','15:20:00',2.68),('8537','2014-02-25','15:25:00',2.33),('8537','2014-02-25','15:30:00',2.06),('8537','2014-02-25','15:35:00',1.93),('8537','2014-02-25','15:40:00',2.06),('8537','2014-02-25','15:45:00',1.42),('8537','2014-02-25','15:50:00',1.06),('8537','2014-02-25','15:55:00',1.27),('8537','2014-02-25','16:00:00',1.1),('8537','2014-02-25','16:05:00',1.19),('8537','2014-02-25','16:10:00',1.1),('8537','2014-02-25','16:15:00',1.19),('8537','2014-02-25','16:20:00',1.27),('8537','2014-02-24','07:55:00',1.14),('8537','2014-02-24','08:00:00',1.33),('8537','2014-02-24','08:05:00',1.57),('8537','2014-02-24','08:10:00',1.78),('8537','2014-02-24','08:15:00',1.93),('8537','2014-02-24','08:20:00',2.09),('8537','2014-02-24','08:25:00',2.24),('8537','2014-02-24','08:30:00',2.29),('8537','2014-02-24','08:35:00',2.49),('8537','2014-02-24','08:40:00',2.13),('8537','2014-02-24','08:45:00',2.55),('8537','2014-02-24','08:50:00',2.58),('8537','2014-02-24','08:55:00',2.56),('8537','2014-02-24','09:00:00',2.6),('8537','2014-02-24','09:05:00',2.67),('8537','2014-02-24','09:10:00',2.76),('8537','2014-02-24','09:15:00',2.87),('8537','2014-02-24','09:20:00',2.97),('8537','2014-02-24','09:25:00',3.07),('8537','2014-02-24','09:30:00',3.16),('8537','2014-02-24','09:35:00',3.24),('8537','2014-02-24','09:40:00',3.31),('8537','2014-02-24','09:45:00',3.41),('8537','2014-02-24','09:50:00',3.47),('8537','2014-02-24','09:55:00',3.55),('8537','2014-02-24','10:00:00',3.6),('8537','2014-02-24','10:05:00',3.68),('8537','2014-02-24','10:10:00',3.77),('8537','2014-02-24','10:15:00',3.85),('8537','2014-02-24','10:20:00',3.92),('8537','2014-02-24','10:25:00',3.97),('8537','2014-02-24','10:30:00',4.04),('8537','2014-02-24','10:35:00',4.07),('8537','2014-02-24','10:40:00',4.08),('8537','2014-02-24','10:45:00',4.15),('8537','2014-02-24','10:50:00',4.23),('8537','2014-02-24','10:55:00',4.26),('8537','2014-02-24','11:00:00',4.3),('8537','2014-02-24','11:05:00',4.33),('8537','2014-02-24','11:10:00',4.36),('8537','2014-02-24','11:15:00',4.3),('8537','2014-02-24','11:20:00',4.41),('8537','2014-02-24','11:25:00',4.55),('8537','2014-02-24','11:30:00',4.89),('8537','2014-02-24','11:35:00',3.44),('8537','2014-02-24','11:40:00',3.87),('8537','2014-02-24','11:45:00',4.76),('8537','2014-02-24','11:50:00',3.77),('8537','2014-02-24','11:55:00',3.73),('8537','2014-02-24','12:00:00',4.06),('8537','2014-02-24','12:05:00',3.69),('8537','2014-02-24','12:10:00',2.66),('8537','2014-02-24','12:15:00',2.9),('8537','2014-02-24','12:20:00',2.22),('8537','2014-02-24','12:25:00',4.1),('8537','2014-02-24','12:30:00',4.33),('8537','2014-02-24','12:35:00',3.74),('8537','2014-02-24','12:40:00',5.06),('8537','2014-02-24','12:45:00',4.47),('8537','2014-02-24','12:50:00',4.73),('8537','2014-02-24','12:55:00',4.5),('8537','2014-02-24','13:00:00',4.74),('8537','2014-02-24','13:05:00',3.89),('8537','2014-02-24','13:10:00',5.12),('8537','2014-02-24','13:15:00',4.99),('8537','2014-02-24','13:20:00',1.81),('8537','2014-02-24','13:25:00',1.25),('8537','2014-02-24','13:30:00',1.12),('8537','2014-02-24','13:35:00',1.03),('8537','2014-02-24','14:00:00',1.01),('8537','2014-02-24','14:05:00',1.06),('8537','2014-02-24','14:10:00',1.13),('8537','2014-02-24','14:15:00',1.13),('8537','2014-02-24','14:20:00',1.11),('8537','2014-02-24','14:25:00',1.14),('8537','2014-02-24','14:30:00',1.21),('8537','2014-02-24','14:35:00',1.2),('8537','2014-02-24','14:40:00',1.2),('8537','2014-02-24','14:45:00',1.29),('8537','2014-02-24','14:50:00',1.18),('8537','2014-02-24','15:05:00',1),('8537','2014-02-24','15:10:00',1.1),('8537','2014-02-24','15:15:00',1.16),('8537','2014-02-24','15:20:00',1.35),('8537','2014-02-24','15:25:00',1.65),('8537','2014-02-24','15:30:00',1.4),('8537','2014-02-24','15:35:00',2.74),('8537','2014-02-24','15:40:00',3.09),('8537','2014-02-24','15:45:00',2.81),('8537','2014-02-24','15:50:00',2.56),('8537','2014-02-24','15:55:00',2.29),('8537','2014-02-24','16:00:00',2.45),('8537','2014-02-24','16:05:00',2.41),('8537','2014-02-24','16:10:00',2.16),('8537','2014-02-24','16:15:00',1.9),('8537','2014-02-24','16:20:00',1.69),('8537','2014-02-24','16:25:00',1.32),('8537','2014-02-23','07:55:00',1.08),('8537','2014-02-23','08:00:00',1.22),('8537','2014-02-23','08:05:00',1.33),('8537','2014-02-23','08:10:00',1.46),('8537','2014-02-23','08:15:00',1.57),('8537','2014-02-23','08:20:00',1.69),('8537','2014-02-23','08:25:00',1.8),('8537','2014-02-23','08:30:00',1.9),('8537','2014-02-23','08:35:00',1.98),('8537','2014-02-23','08:40:00',2.12),('8537','2014-02-23','08:45:00',2.23),('8537','2014-02-23','08:50:00',2.34),('8537','2014-02-23','08:55:00',2.42),('8537','2014-02-23','09:00:00',2.54),('8537','2014-02-23','09:05:00',2.65),('8537','2014-02-23','09:10:00',2.76),('8537','2014-02-23','09:15:00',2.87),('8537','2014-02-23','09:20:00',2.98),('8537','2014-02-23','09:25:00',2.96),('8537','2014-02-23','09:30:00',2.79),('8537','2014-02-23','09:35:00',3.23),('8537','2014-02-23','09:40:00',3.3),('8537','2014-02-23','09:45:00',3.36),('8537','2014-02-23','09:50:00',3.36),('8537','2014-02-23','09:55:00',3.47),('8537','2014-02-23','10:00:00',3.54),('8537','2014-02-23','10:05:00',3.59),('8537','2014-02-23','10:10:00',3.62),('8537','2014-02-23','10:15:00',3.64),('8537','2014-02-23','10:20:00',3.81),('8537','2014-02-23','10:25:00',3.85),('8537','2014-02-23','10:30:00',3.92),('8537','2014-02-23','10:35:00',4.01),('8537','2014-02-23','10:40:00',4.01),('8537','2014-02-23','10:45:00',4.02),('8537','2014-02-23','10:50:00',4.01),('8537','2014-02-23','10:55:00',4.15),('8537','2014-02-23','11:00:00',4.18),('8537','2014-02-23','11:05:00',3.25),('8537','2014-02-23','11:10:00',4.34),('8537','2014-02-23','11:15:00',4.31),('8537','2014-02-23','11:20:00',3.68),('8537','2014-02-23','11:25:00',4.46),('8537','2014-02-23','11:30:00',4.57),('8537','2014-02-23','11:35:00',4.56),('8537','2014-02-23','11:40:00',4.6),('8537','2014-02-23','11:45:00',4.35),('8537','2014-02-23','11:50:00',3.27),('8537','2014-02-23','11:55:00',4.24),('8537','2014-02-23','12:00:00',2.27),('8537','2014-02-23','12:05:00',4.84),('8537','2014-02-23','12:10:00',4.92),('8537','2014-02-23','12:15:00',4.92),('8537','2014-02-23','12:20:00',4.47),('8537','2014-02-23','12:25:00',2.9),('8537','2014-02-23','12:30:00',3.34),('8537','2014-02-23','12:35:00',5.01),('8537','2014-02-23','12:40:00',2.87),('8537','2014-02-23','12:45:00',2.89),('8537','2014-02-23','12:50:00',2.21),('8537','2014-02-23','12:55:00',2.68),('8537','2014-02-23','13:00:00',2.92),('8537','2014-02-23','13:05:00',4.61),('8537','2014-02-23','13:10:00',4.56),('8537','2014-02-23','13:15:00',4.5),('8537','2014-02-23','13:20:00',4.44),('8537','2014-02-23','13:25:00',4.44),('8537','2014-02-23','13:30:00',4.32),('8537','2014-02-23','13:35:00',2.51),('8537','2014-02-23','13:40:00',3.5),('8537','2014-02-23','13:45:00',3.78),('8537','2014-02-23','13:50:00',2.19),('8537','2014-02-23','14:00:00',3.61),('8537','2014-02-23','14:05:00',3.83),('8537','2014-02-23','14:10:00',4.22),('8537','2014-02-23','14:15:00',3.06),('8537','2014-02-23','14:20:00',2.38),('8537','2014-02-23','14:25:00',3.13),('8537','2014-02-23','14:30:00',3.51),('8537','2014-02-23','14:35:00',2.15),('8537','2014-02-23','14:40:00',1.35),('8537','2014-02-23','14:45:00',1.9),('8537','2014-02-23','14:50:00',1.66),('8537','2014-02-22','09:05:00',1),('8537','2014-02-22','09:10:00',1.34),('8537','2014-02-22','09:40:00',1),('8537','2014-02-22','09:45:00',1.02),('8537','2014-02-22','09:50:00',1.14),('8537','2014-02-22','09:55:00',1.16),('8537','2014-02-22','10:00:00',1.9),('8537','2014-02-22','10:05:00',2.81),('8537','2014-02-22','10:10:00',2.73),('8537','2014-02-22','10:15:00',2.6),('8537','2014-02-22','10:20:00',1.54),('8537','2014-02-22','10:25:00',2.4),('8537','2014-02-22','10:30:00',3.11),('8537','2014-02-22','10:35:00',2.15),('8537','2014-02-22','10:40:00',2.08),('8537','2014-02-22','10:45:00',4.01),('8537','2014-02-22','10:50:00',4.62),('8537','2014-02-22','10:55:00',1.38),('8537','2014-02-22','11:10:00',1.02),('8537','2014-02-22','12:00:00',1.12),('8537','2014-02-22','12:05:00',1.46),('8537','2014-02-22','12:10:00',1.74),('8537','2014-02-22','12:15:00',2.42),('8537','2014-02-22','12:20:00',2.09),('8537','2014-02-22','12:25:00',2.09),('8537','2014-02-22','12:30:00',1.25),('8537','2014-02-22','12:35:00',1.3),('8537','2014-02-22','12:40:00',1.53),('8537','2014-02-22','12:45:00',4.43),('8537','2014-02-22','12:50:00',3.94),('8537','2014-02-22','12:55:00',1.75),('8537','2014-02-22','13:00:00',1.66),('8537','2014-02-22','13:05:00',2.2),('8537','2014-02-22','13:10:00',5.51),('8537','2014-02-22','13:15:00',3.17),('8537','2014-02-22','13:20:00',1.77),('8537','2014-02-22','13:25:00',1.2),('8537','2014-02-22','13:30:00',1.38),('8537','2014-02-22','13:35:00',1.88),('8537','2014-02-22','13:40:00',2.78),('8537','2014-02-22','13:45:00',2.16),('8537','2014-02-22','13:50:00',1.91),('8537','2014-02-22','13:55:00',4.05),('8537','2014-02-22','14:00:00',4.4),('8537','2014-02-22','14:05:00',3.4),('8537','2014-02-22','14:10:00',4.23),('8537','2014-02-22','14:15:00',3.69),('8537','2014-02-22','14:20:00',3.9),('8537','2014-02-22','14:25:00',3.49),('8537','2014-02-22','14:30:00',3.45),('8537','2014-02-22','14:35:00',1.99),('8537','2014-02-22','14:40:00',3.18),('8537','2014-02-22','14:45:00',3.71),('8537','2014-02-22','14:50:00',3.46),('8537','2014-02-22','14:55:00',1.01),('8537','2014-02-22','15:00:00',1.97),('8537','2014-02-22','15:05:00',2.74),('8537','2014-02-22','15:10:00',1.77),('8537','2014-02-22','15:15:00',1.88),('8537','2014-02-22','15:20:00',1.22),('8537','2014-02-22','15:25:00',1.47),('8537','2014-02-22','15:30:00',2.16),('8537','2014-02-22','15:35:00',2.35),('8537','2014-02-22','15:45:00',2.37),('8537','2014-02-22','15:50:00',2.23),('8537','2014-02-22','15:55:00',1.19),('8537','2014-02-22','16:00:00',1.59),('8537','2014-02-22','16:10:00',1.26),('8537','2014-02-22','16:15:00',1.56),('8537','2014-02-22','16:20:00',1.4),('8537','2014-02-22','16:25:00',1.27),('8537','2014-02-22','16:30:00',1.07),('8537','2014-02-21','09:20:00',1),('8537','2014-02-21','09:25:00',1.06),('8537','2014-02-21','09:30:00',1.07),('8537','2014-02-21','09:35:00',1.14),('8537','2014-02-21','09:40:00',1.18),('8537','2014-02-21','09:45:00',1.24),('8537','2014-02-21','09:50:00',1.42),('8537','2014-02-21','09:55:00',1.45),('8537','2014-02-21','10:00:00',1.44),('8537','2014-02-21','10:05:00',1.74),('8537','2014-02-21','10:10:00',1.64),('8537','2014-02-21','10:15:00',1.8),('8537','2014-02-21','10:20:00',2.47),('8537','2014-02-21','10:25:00',3.04),('8537','2014-02-21','10:30:00',3.56),('8537','2014-02-21','10:35:00',2.64),('8537','2014-02-21','10:40:00',2.28),('8537','2014-02-21','10:45:00',2.18),('8537','2014-02-21','10:50:00',1.85),('8537','2014-02-21','10:55:00',2.67),('8537','2014-02-21','11:00:00',2.38),('8537','2014-02-21','11:05:00',1.81),('8537','2014-02-21','11:10:00',1.76),('8537','2014-02-21','11:15:00',1.96),('8537','2014-02-21','11:20:00',1.93),('8537','2014-02-21','11:25:00',2.58),('8537','2014-02-21','11:30:00',4.26),('8537','2014-02-21','11:35:00',3.04),('8537','2014-02-21','11:40:00',3.11),('8537','2014-02-21','11:45:00',3.6),('8537','2014-02-21','11:50:00',2.07),('8537','2014-02-21','11:55:00',2.96),('8537','2014-02-21','12:00:00',5.37),('8537','2014-02-21','12:05:00',4.34),('8537','2014-02-21','12:10:00',4.61),('8537','2014-02-21','12:15:00',2.63),('8537','2014-02-21','12:20:00',1.72),('8537','2014-02-21','12:25:00',1.87),('8537','2014-02-21','12:30:00',1.75),('8537','2014-02-21','12:35:00',1.51),('8537','2014-02-21','12:40:00',1.28),('8537','2014-02-21','12:45:00',1.01),('8537','2014-02-21','15:00:00',1.09),('8537','2014-02-21','15:05:00',1.47),('8537','2014-02-21','15:20:00',1.4),('8537','2014-02-21','15:25:00',2.02),('8537','2014-02-21','15:30:00',2.36),('8537','2014-02-21','15:35:00',2.34),('8537','2014-02-21','15:40:00',2.16),('8537','2014-02-21','15:45:00',2.12),('8537','2014-02-21','15:50:00',1.95),('8537','2014-02-21','15:55:00',1.81),('8537','2014-02-21','16:00:00',1.62),('8537','2014-02-21','16:05:00',1.52),('8537','2014-02-21','16:10:00',1.4),('8537','2014-02-21','16:15:00',1.35),('8537','2014-02-21','16:20:00',1.22),('8537','2014-02-21','16:25:00',1.11),('8537','2014-02-20','11:20:00',1.01),('8537','2014-02-20','11:25:00',1.23),('8537','2014-02-20','11:30:00',1.23),('8537','2014-02-20','11:35:00',1.03),('8537','2014-02-20','12:00:00',1.11),('8537','2014-02-20','12:25:00',1.07),('8537','2014-02-20','12:30:00',1.17),('8537','2014-02-20','12:35:00',1.16),('8537','2014-02-20','12:40:00',1.2),('8537','2014-02-20','12:45:00',1),('8537','2014-02-20','12:50:00',1.04),('8537','2014-02-20','12:55:00',1.34),('8537','2014-02-20','13:00:00',1.61),('8537','2014-02-20','13:15:00',1.44),('8537','2014-02-20','13:20:00',1.24),('8537','2014-02-20','13:30:00',1.32),('8537','2014-02-20','13:35:00',1.23),('8537','2014-02-20','14:00:00',1.04),('8537','2014-02-19','09:20:00',1.03),('8537','2014-02-19','09:25:00',1.18),('8537','2014-02-19','09:30:00',1.22),('8537','2014-02-19','09:35:00',1.42),('8537','2014-02-19','09:40:00',1.51),('8537','2014-02-19','09:45:00',1.82),('8537','2014-02-19','09:50:00',1.69),('8537','2014-02-19','09:55:00',1.56),('8537','2014-02-19','10:00:00',1.5),('8537','2014-02-19','10:05:00',1.49),('8537','2014-02-19','10:10:00',1.62),('8537','2014-02-19','10:15:00',1.68),('8537','2014-02-19','10:20:00',1.51),('8537','2014-02-19','10:25:00',1.54),('8537','2014-02-19','10:30:00',1.69),('8537','2014-02-19','10:35:00',1.77),('8537','2014-02-19','10:40:00',2.06),('8537','2014-02-19','10:45:00',2.3),('8537','2014-02-19','10:50:00',2.08),('8537','2014-02-19','10:55:00',1.83),('8537','2014-02-19','11:00:00',1.67),('8537','2014-02-19','11:05:00',1.76),('8537','2014-02-19','11:10:00',2.06),('8537','2014-02-19','11:15:00',1.99),('8537','2014-02-19','11:20:00',2.14),('8537','2014-02-19','11:25:00',2.02),('8537','2014-02-19','11:30:00',1.91),('8537','2014-02-19','11:35:00',1.84),('8537','2014-02-19','11:40:00',1.71),('8537','2014-02-19','11:45:00',1.65),('8537','2014-02-19','11:50:00',1.61),('8537','2014-02-19','11:55:00',1.4),('8537','2014-02-19','12:00:00',1.54),('8537','2014-02-19','12:05:00',1.75),('8537','2014-02-19','12:10:00',1.7),('8537','2014-02-19','12:15:00',1.64),('8537','2014-02-19','12:20:00',1.41),('8537','2014-02-19','12:25:00',1.66),('8537','2014-02-19','12:30:00',1.91),('8537','2014-02-19','12:35:00',1.58),('8537','2014-02-19','12:40:00',1.5),('8537','2014-02-19','12:45:00',1.51),('8537','2014-02-19','12:50:00',1.19),('8537','2014-02-19','13:00:00',1.15),('8537','2014-02-19','13:05:00',1.34),('8537','2014-02-19','13:10:00',1.25),('8537','2014-02-19','13:15:00',1.39),('8537','2014-02-19','13:20:00',1.5),('8537','2014-02-19','13:25:00',1.62),('8537','2014-02-19','13:30:00',1.63),('8537','2014-02-19','13:35:00',2),('8537','2014-02-19','13:40:00',1.86),('8537','2014-02-19','13:45:00',2.12),('8537','2014-02-19','13:50:00',2.46),('8537','2014-02-19','13:55:00',2.24),('8537','2014-02-19','14:00:00',2.05),('8537','2014-02-19','14:05:00',2.27),('8537','2014-02-19','14:10:00',1.84),('8537','2014-02-19','14:15:00',1.61),('8537','2014-02-19','14:20:00',2.49),('8537','2014-02-19','14:25:00',1.97),('8537','2014-02-19','14:30:00',1.83),('8537','2014-02-19','14:35:00',1.95),('8537','2014-02-19','14:40:00',1.61),('8537','2014-02-19','14:45:00',1.56),('8537','2014-02-19','14:50:00',1.96),('8537','2014-02-19','14:55:00',1.74),('8537','2014-02-19','15:00:00',1.43),('8537','2014-02-19','15:05:00',1.4),('8537','2014-02-19','15:10:00',1.34),('8537','2014-02-19','15:15:00',1.54),('8537','2014-02-19','15:20:00',1.21),('8537','2014-02-19','15:25:00',1.38),('8537','2014-02-19','15:30:00',1.18),('8537','2014-02-19','15:35:00',1.05),('8537','2014-02-19','15:40:00',1.1),('8537','2014-02-19','15:45:00',1.11),('8537','2014-02-19','15:50:00',1.36),('8537','2014-02-19','15:55:00',1.13),('8537','2014-04-28','08:15:00',1.89),('8537','2014-04-28','08:20:00',1.95),('8537','2014-04-28','08:25:00',1.95),('8537','2014-04-28','08:30:00',1.5),('8537','2014-04-28','08:35:00',1.43),('8537','2014-04-28','08:40:00',1.34),('8537','2014-04-28','08:45:00',1.59),('8537','2014-04-28','08:50:00',1.64),('8537','2014-04-28','08:55:00',1.59),('8537','2014-04-28','09:00:00',1.24),('8537','2014-04-28','09:05:00',1.13),('8537','2014-04-28','09:10:00',2.28),('8537','2014-04-28','09:15:00',3.52),('8537','2014-04-28','09:20:00',2.66),('8537','2014-04-28','09:25:00',2.74),('8537','2014-04-28','09:30:00',2.04),('8537','2014-04-28','09:35:00',2.62),('8537','2014-04-28','09:40:00',2.25),('8537','2014-04-28','09:45:00',2.36),('8537','2014-04-28','09:50:00',3.01),('8537','2014-04-28','09:55:00',1.48),('8537','2014-04-28','10:00:00',2.09),('8537','2014-04-28','10:05:00',2.7),('8537','2014-04-28','10:10:00',2.7),('8537','2014-04-28','10:15:00',2.58),('8537','2014-04-28','10:20:00',2.14),('8537','2014-04-28','10:25:00',1.56),('8537','2014-04-28','10:40:00',1.01),('8537','2014-04-28','10:45:00',1.74),('8537','2014-04-28','10:50:00',2.37),('8537','2014-04-28','10:55:00',2.25),('8537','2014-04-28','11:00:00',2.18),('8537','2014-04-28','11:05:00',2.73),('8537','2014-04-28','11:10:00',3.05),('8537','2014-04-28','11:15:00',2.94),('8537','2014-04-28','11:20:00',2.82),('8537','2014-04-28','11:25:00',2.17),('8537','2014-04-28','11:30:00',2.3),('8537','2014-04-28','11:35:00',2.15),('8537','2014-04-28','11:40:00',1.8),('8537','2014-04-28','11:45:00',1.89),('8537','2014-04-28','11:50:00',2.15),('8537','2014-04-28','11:55:00',2.31),('8537','2014-04-28','12:00:00',2.09),('8537','2014-04-28','12:05:00',1.56),('8537','2014-04-28','12:10:00',2.15),('8537','2014-04-28','12:15:00',3.23),('8537','2014-04-28','12:20:00',3.46),('8537','2014-04-28','12:25:00',3.3),('8537','2014-04-28','12:30:00',3.17),('8537','2014-04-28','12:35:00',2.89),('8537','2014-04-28','12:40:00',2.59),('8537','2014-04-28','12:45:00',2.24),('8537','2014-04-28','12:50:00',2.71),('8537','2014-04-28','12:55:00',2.6),('8537','2014-04-28','13:00:00',2.72),('8537','2014-04-28','13:05:00',3.16),('8537','2014-04-28','13:10:00',4.43),('8537','2014-04-28','13:15:00',2.71),('8537','2014-04-28','13:20:00',2.66),('8537','2014-04-28','13:25:00',3.16),('8537','2014-04-28','13:30:00',5.14),('8537','2014-04-28','13:35:00',4.16),('8537','2014-04-28','13:40:00',4.49),('8537','2014-04-28','13:45:00',2.81),('8537','2014-04-28','13:50:00',4.81),('8537','2014-04-28','13:55:00',4.43),('8537','2014-04-28','14:00:00',2.48),('8537','2014-04-28','14:05:00',3.62),('8537','2014-04-28','14:10:00',4.2),('8537','2014-04-28','14:15:00',3.78),('8537','2014-04-28','14:20:00',4.5),('8537','2014-04-28','14:25:00',3.7),('8537','2014-04-28','14:30:00',2.83),('8537','2014-04-28','14:35:00',5.1),('8537','2014-04-28','14:40:00',4.87),('8537','2014-04-28','14:45:00',2.42),('8537','2014-04-28','14:50:00',2.98),('8537','2014-04-28','14:55:00',4.26),('8537','2014-04-28','15:00:00',2.84),('8537','2014-04-28','15:05:00',3.45),('8537','2014-04-28','15:10:00',2.99),('8537','2014-04-28','15:15:00',2.96),('8537','2014-04-28','15:20:00',2.21),('8537','2014-04-28','15:25:00',2.16),('8537','2014-04-28','15:30:00',2.48),('8537','2014-04-28','15:35:00',3.31),('8537','2014-04-28','15:40:00',2.52),('8537','2014-04-28','15:45:00',2.1),('8537','2014-04-28','15:50:00',4.17),('8537','2014-04-28','15:55:00',1.97),('8537','2014-04-28','16:00:00',3.25),('8537','2014-04-28','16:05:00',3.79),('8537','2014-04-28','16:10:00',4),('8537','2014-04-28','16:15:00',2.95),('8537','2014-04-28','16:20:00',2.91),('8537','2014-04-28','16:25:00',1.81),('8537','2014-04-28','16:30:00',3.33),('8537','2014-04-28','16:35:00',3.41),('8537','2014-04-28','16:55:00',1.88),('8537','2014-04-28','17:00:00',1.05),('8537','2014-04-28','17:25:00',1.13),('8537','2014-04-28','17:30:00',1.04),('8537','2014-04-28','17:35:00',1.06),('8537','2014-04-28','17:40:00',1.37),('8537','2014-04-27','09:20:00',1.04),('8537','2014-04-27','09:45:00',1.04),('8537','2014-04-27','10:00:00',1.26),('8537','2014-04-27','10:05:00',1.27),('8537','2014-04-27','10:10:00',1.34),('8537','2014-04-27','10:15:00',1.16),('8537','2014-04-27','10:20:00',1.16),('8537','2014-04-27','10:25:00',1.01),('8537','2014-04-27','11:00:00',1.31),('8537','2014-04-27','11:05:00',1.57),('8537','2014-04-27','11:10:00',1.76),('8537','2014-04-27','11:15:00',1.72),('8537','2014-04-27','11:20:00',1.35),('8537','2014-04-27','11:30:00',1.11),('8537','2014-04-27','11:35:00',1.79),('8537','2014-04-27','11:40:00',1.95),('8537','2014-04-27','11:45:00',3.8),('8537','2014-04-27','11:50:00',3.27),('8537','2014-04-27','11:55:00',2.98),('8537','2014-04-27','12:00:00',2.97),('8537','2014-04-27','12:05:00',3.25),('8537','2014-04-27','12:10:00',3.74),('8537','2014-04-27','12:15:00',3.49),('8537','2014-04-27','12:20:00',3.42),('8537','2014-04-27','12:25:00',3.38),('8537','2014-04-27','12:30:00',3.03),('8537','2014-04-27','12:35:00',3.13),('8537','2014-04-27','12:40:00',2.79),('8537','2014-04-27','12:45:00',3.11),('8537','2014-04-27','12:50:00',2.5),('8537','2014-04-27','12:55:00',1.95),('8537','2014-04-27','13:00:00',2.47),('8537','2014-04-27','13:05:00',2.49),('8537','2014-04-27','13:10:00',2.05),('8537','2014-04-27','13:15:00',2.13),('8537','2014-04-27','13:20:00',2.86),('8537','2014-04-27','13:25:00',2.63),('8537','2014-04-27','13:30:00',2.35),('8537','2014-04-27','13:35:00',2.06),('8537','2014-04-27','13:40:00',1.94),('8537','2014-04-27','13:45:00',1.9),('8537','2014-04-27','13:50:00',1.84),('8537','2014-04-27','13:55:00',1.7),('8537','2014-04-27','14:00:00',2.13),('8537','2014-04-27','14:05:00',2.75),('8537','2014-04-27','14:10:00',1.97),('8537','2014-04-27','14:15:00',1.77),('8537','2014-04-27','14:20:00',2.1),('8537','2014-04-27','14:25:00',2.6),('8537','2014-04-27','14:30:00',2.73),('8537','2014-04-27','14:35:00',2.64),('8537','2014-04-27','14:40:00',2.67),('8537','2014-04-27','14:45:00',2.33),('8537','2014-04-27','14:50:00',2.21),('8537','2014-04-27','14:55:00',2.39),('8537','2014-04-27','15:00:00',2.53),('8537','2014-04-27','15:05:00',3.43),('8537','2014-04-27','15:10:00',4.58),('8537','2014-04-27','15:15:00',3.45),('8537','2014-04-27','15:20:00',2.21),('8537','2014-04-27','15:25:00',1.41),('8537','2014-04-27','15:30:00',1.11),('8537','2014-04-27','15:35:00',1.21),('8537','2014-04-27','15:40:00',1.24),('8537','2014-04-27','15:45:00',1.07),('8537','2014-04-27','15:50:00',1.06),('8784','2014-05-05','07:45:00',1.31),('8784','2014-05-05','07:50:00',1.43),('8784','2014-05-05','07:55:00',1.52),('8784','2014-05-05','08:00:00',1.6),('8784','2014-05-05','08:05:00',1.68),('8784','2014-05-05','08:10:00',1.78),('8784','2014-05-05','08:15:00',1.88),('8784','2014-05-05','08:20:00',1.96),('8784','2014-05-05','08:25:00',2.03),('8784','2014-05-05','08:30:00',2.15),('8784','2014-05-05','08:35:00',2.27),('8784','2014-05-05','08:40:00',2.36),('8784','2014-05-05','08:45:00',2.44),('8784','2014-05-05','08:50:00',2.52),('8784','2014-05-05','08:55:00',2.6),('8784','2014-05-05','09:00:00',2.67),('8784','2014-05-05','09:05:00',2.73),('8784','2014-05-05','09:10:00',2.82),('8784','2014-05-05','09:15:00',2.87),('8784','2014-05-05','09:20:00',2.97),('8784','2014-05-05','09:25:00',3.04),('8784','2014-05-05','09:30:00',3.14),('8784','2014-05-05','09:35:00',3.23),('8784','2014-05-05','09:40:00',3.29),('8784','2014-05-05','09:45:00',3.35),('8784','2014-05-05','09:50:00',3.42),('8784','2014-05-05','09:55:00',3.5),('8784','2014-05-05','10:00:00',3.57),('8784','2014-05-05','10:05:00',3.66),('8784','2014-05-05','10:10:00',3.72),('8784','2014-05-05','10:15:00',3.73),('8784','2014-05-05','10:20:00',3.7),('8784','2014-05-05','10:25:00',3.84),('8784','2014-05-05','10:30:00',3.89),('8784','2014-05-05','10:35:00',3.83),('8784','2014-05-05','10:40:00',3.86),('8784','2014-05-05','10:45:00',3.94),('8784','2014-05-05','10:50:00',4),('8784','2014-05-05','10:55:00',4),('8784','2014-05-05','11:00:00',4.05),('8784','2014-05-05','11:05:00',4.06),('8784','2014-05-05','11:10:00',4.16),('8784','2014-05-05','11:15:00',4.29),('8784','2014-05-05','11:20:00',4.29),('8784','2014-05-05','11:25:00',4.22),('8784','2014-05-05','11:30:00',4.2),('8784','2014-05-05','11:35:00',4.34),('8784','2014-05-05','11:40:00',4.37),('8784','2014-05-05','11:45:00',4.44),('8784','2014-05-05','11:50:00',4.46),('8784','2014-05-05','11:55:00',4.38),('8784','2014-05-05','12:00:00',4.71),('8784','2014-05-05','12:05:00',3.29),('8784','2014-05-05','12:10:00',1.35),('8784','2014-05-05','12:15:00',2.62),('8784','2014-05-05','12:20:00',1.95),('8784','2014-05-05','12:25:00',2.06),('8784','2014-05-05','12:30:00',4),('8784','2014-05-05','12:35:00',2.98),('8784','2014-05-05','12:40:00',2.05),('8784','2014-05-05','12:45:00',2.42),('8784','2014-05-05','12:50:00',4.95),('8784','2014-05-05','12:55:00',1.97),('8784','2014-05-05','13:00:00',1.36),('8784','2014-05-05','13:05:00',2.75),('8784','2014-05-05','13:10:00',5.02),('8784','2014-05-05','13:15:00',4.81),('8784','2014-05-05','13:20:00',4.68),('8784','2014-05-05','13:25:00',4.57),('8784','2014-05-05','13:30:00',4.54),('8784','2014-05-05','13:35:00',4.54),('8784','2014-05-05','13:40:00',4.49),('8784','2014-05-05','13:45:00',4.58),('8784','2014-05-05','13:50:00',4.58),('8784','2014-05-05','13:55:00',4.6),('8784','2014-05-05','14:00:00',4.53),('8784','2014-05-05','14:05:00',3.06),('8784','2014-05-05','14:10:00',3.13),('8784','2014-05-05','14:15:00',4.21),('8784','2014-05-05','14:20:00',4.9),('8784','2014-05-05','14:25:00',4.76),('8784','2014-05-05','14:30:00',3.92),('8784','2014-05-05','14:35:00',2.85),('8784','2014-05-05','14:40:00',2.61),('8784','2014-05-05','14:45:00',1.55),('8784','2014-05-05','14:50:00',1.51),('8784','2014-05-05','14:55:00',1.73),('8784','2014-05-05','15:00:00',2.64),('8784','2014-05-05','15:05:00',3.64),('8784','2014-05-05','15:10:00',2.73),('8784','2014-05-05','15:15:00',1.4),('8784','2014-05-05','15:20:00',1.42),('8784','2014-05-05','15:25:00',1.84),('8784','2014-05-05','15:30:00',2.96),('8784','2014-05-05','15:35:00',1.93),('8784','2014-05-05','15:40:00',3.72),('8784','2014-05-05','15:45:00',3.3),('8784','2014-05-05','15:50:00',1.33),('8784','2014-05-05','15:55:00',1.4),('8784','2014-05-05','16:00:00',1.68),('8784','2014-05-05','16:05:00',2.71),('8784','2014-05-05','16:10:00',1.88),('8784','2014-05-05','16:15:00',1.38),('8784','2014-05-05','16:20:00',1.66),('8784','2014-05-05','16:25:00',1.25),('8784','2014-05-05','16:30:00',1.27),('8784','2014-05-05','16:35:00',3.32),('8784','2014-05-05','16:40:00',2.7),('8784','2014-05-05','16:45:00',2.73),('8784','2014-05-05','16:50:00',3.08),('8784','2014-05-05','16:55:00',2.89),('8784','2014-05-05','17:00:00',2.66),('8784','2014-05-05','17:05:00',2.54),('8784','2014-05-05','17:10:00',2.56),('8784','2014-05-05','17:15:00',2.49),('8784','2014-05-05','17:20:00',2.39),('8784','2014-05-05','17:25:00',2.23),('8784','2014-05-05','17:30:00',2.1),('8784','2014-05-05','17:35:00',1.98),('8784','2014-05-05','17:40:00',1.85),('8784','2014-05-05','17:45:00',1.79),('8784','2014-05-05','17:50:00',1.7),('8784','2014-05-05','17:55:00',1.62),('8784','2014-05-05','18:00:00',1.49),('8784','2014-05-05','18:05:00',1.43),('8784','2014-05-05','18:10:00',1.36),('8784','2014-05-05','18:15:00',1.25),('8784','2014-05-05','18:20:00',1.16),('8784','2014-05-05','18:25:00',1.09),('8784','2014-05-05','18:30:00',1),('8784','2014-04-26','09:05:00',1.1),('8784','2014-04-26','09:40:00',1.03),('8784','2014-04-26','09:50:00',1.03),('8784','2014-04-26','09:55:00',1.49),('8784','2014-04-26','10:00:00',1.58),('8784','2014-04-26','10:05:00',1.44),('8784','2014-04-26','10:10:00',1.38),('8784','2014-04-26','10:15:00',1.45),('8784','2014-04-26','10:20:00',1.64),('8784','2014-04-26','10:25:00',1.78),('8784','2014-04-26','10:30:00',2.07),('8784','2014-04-26','10:35:00',2.24),('8784','2014-04-26','10:40:00',2.32),('8784','2014-04-26','10:45:00',1.34),('8784','2014-04-26','10:50:00',2.65),('8784','2014-04-26','10:55:00',3.94),('8784','2014-04-26','11:00:00',3.86),('8784','2014-04-26','11:05:00',3.72),('8784','2014-04-26','11:10:00',3.52),('8784','2014-04-26','11:15:00',3.44),('8784','2014-04-26','11:20:00',3.27),('8784','2014-04-26','11:25:00',3.21),('8784','2014-04-26','11:30:00',3.36),('8784','2014-04-26','11:35:00',3.25),('8784','2014-04-26','11:40:00',3.05),('8784','2014-04-26','11:45:00',3.28),('8784','2014-04-26','11:50:00',3.21),('8784','2014-04-26','11:55:00',3.07),('8784','2014-04-26','12:00:00',3.19),('8784','2014-04-26','12:05:00',3.44),('8784','2014-04-26','12:10:00',3.43),('8784','2014-04-26','12:15:00',2.81),('8784','2014-04-26','12:20:00',3.1),('8784','2014-04-26','12:25:00',2.75),('8784','2014-04-26','12:30:00',2.4),('8784','2014-04-26','12:35:00',3.81),('8784','2014-04-26','12:40:00',3.69),('8784','2014-04-26','12:45:00',3.99),('8784','2014-04-26','12:50:00',4.25),('8784','2014-04-26','12:55:00',4.5),('8784','2014-04-26','13:00:00',4.02),('8784','2014-04-26','13:05:00',3.02),('8784','2014-04-26','13:10:00',3.57),('8784','2014-04-26','13:15:00',4.47),('8784','2014-04-26','13:20:00',4.88),('8784','2014-04-26','13:25:00',4),('8784','2014-04-26','13:30:00',1.56),('8784','2014-04-26','13:35:00',1.95),('8784','2014-04-26','13:40:00',4.82),('8784','2014-04-26','13:45:00',4.51),('8784','2014-04-26','13:50:00',4.35),('8784','2014-04-26','13:55:00',4.57),('8784','2014-04-26','14:00:00',3.4),('8784','2014-04-26','14:10:00',2.15),('8784','2014-04-26','14:15:00',2.1),('8784','2014-04-26','14:30:00',1),('8784','2014-04-26','14:35:00',1.52),('8784','2014-04-26','14:40:00',2.26),('8784','2014-04-26','18:45:00',1),('8784','2014-01-26','09:30:00',1.05),('8784','2014-01-26','09:35:00',1.01),('8784','2014-01-26','09:45:00',1.1),('8784','2014-01-26','09:50:00',1.24),('8784','2014-01-26','09:55:00',1.02),('8784','2014-01-26','10:10:00',1.54),('8784','2014-01-26','10:15:00',2.03),('8784','2014-01-26','10:20:00',1.12),('8784','2014-01-26','10:25:00',1.02),('8784','2014-01-26','11:25:00',1.14),('8784','2014-01-26','12:15:00',1.22),('8784','2014-01-26','12:20:00',1.29),('8784','2014-01-26','12:25:00',1.4),('8784','2014-01-26','12:30:00',2.46),('8784','2014-01-26','12:35:00',1.95),('8784','2014-01-26','12:40:00',1.33),('8784','2014-01-26','12:45:00',1.17),('8784','2014-01-26','12:50:00',1.04),('8784','2014-01-26','13:00:00',1.08),('8784','2014-01-26','13:05:00',1.22),('8784','2014-01-26','13:10:00',1.33),('8784','2014-01-26','13:15:00',1.51),('8784','2014-01-26','13:20:00',1.54),('8784','2014-01-26','13:25:00',1.24),('8784','2014-01-26','15:45:00',1.06),('8784','2014-01-25','09:50:00',1.12),('8784','2014-01-25','09:55:00',1.6),('8784','2014-01-25','10:00:00',1.04),('8784','2014-01-25','10:05:00',1.9),('8784','2014-01-25','10:10:00',2.16),('8784','2014-01-25','10:15:00',2.43),('8784','2014-01-25','10:20:00',2.49),('8784','2014-01-25','10:25:00',1.72),('8784','2014-01-25','10:30:00',1.63),('8784','2014-01-25','10:35:00',1.6),('8784','2014-01-25','10:40:00',1.99),('8784','2014-01-25','10:45:00',1.57),('8784','2014-01-25','10:50:00',1.92),('8784','2014-01-25','10:55:00',1.61),('8784','2014-01-25','11:00:00',1.29),('8784','2014-01-25','11:05:00',1.22),('8784','2014-01-25','11:10:00',1.09),('8784','2014-01-25','11:15:00',1.13),('8784','2014-01-25','11:20:00',1.17),('8784','2014-01-25','11:25:00',1.45),('8784','2014-01-25','11:30:00',3.2),('8784','2014-01-25','11:35:00',3.37),('8784','2014-01-25','11:40:00',2.01),('8784','2014-01-25','11:45:00',1.46),('8784','2014-01-25','11:50:00',1.62),('8784','2014-01-25','11:55:00',1.68),('8784','2014-01-25','12:00:00',1.63),('8784','2014-01-25','12:05:00',1.74),('8784','2014-01-25','12:10:00',1.85),('8784','2014-01-25','12:15:00',1.77),('8784','2014-01-25','12:20:00',1.83),('8784','2014-01-25','12:25:00',1.97),('8784','2014-01-25','12:30:00',1.87),('8784','2014-01-25','12:35:00',1.67),('8784','2014-01-25','12:40:00',1.76),('8784','2014-01-25','12:45:00',2.08),('8784','2014-01-25','12:50:00',2.09),('8784','2014-01-25','12:55:00',2.3),('8784','2014-01-25','13:00:00',2.27),('8784','2014-01-25','13:05:00',2.12),('8784','2014-01-25','13:10:00',2.52),('8784','2014-01-25','13:15:00',2.27),('8784','2014-01-25','13:20:00',1.34),('8784','2014-01-25','13:25:00',1.48),('8784','2014-01-25','13:30:00',1.35),('8784','2014-01-25','13:35:00',1.22),('8784','2014-01-25','13:45:00',1.37),('8784','2014-01-25','13:50:00',1.29),('8784','2014-01-25','14:00:00',1.26),('8784','2014-01-25','14:05:00',1.47),('8784','2014-01-25','14:10:00',1.88),('8784','2014-01-25','14:15:00',1.3),('8784','2014-01-25','14:20:00',1.88),('8784','2014-01-25','14:25:00',2.05),('8784','2014-01-25','14:30:00',2.31),('8784','2014-01-25','14:35:00',2.36),('8784','2014-01-25','14:40:00',2.14),('8784','2014-01-25','14:45:00',2.21),('8784','2014-01-25','14:50:00',2.03),('8784','2014-01-25','14:55:00',1.82),('8784','2014-01-25','15:00:00',1.59),('8784','2014-01-25','15:05:00',1.47),('8784','2014-01-25','15:10:00',1.38),('8784','2014-01-25','15:15:00',1.28),('8784','2014-01-25','15:20:00',1.21),('8784','2014-01-25','15:25:00',1.12),('8784','2014-01-25','15:30:00',1.06),('8784','2014-01-24','10:15:00',1.55),('8784','2014-01-24','10:30:00',1.54),('8784','2014-01-24','10:35:00',1.52),('8784','2014-01-24','10:40:00',1.87),('8784','2014-01-24','10:45:00',1.76),('8784','2014-01-24','10:50:00',1.14),('8784','2014-01-24','10:55:00',1.08),('8784','2014-01-24','11:00:00',1.15),('8784','2014-01-24','11:25:00',1.17),('8784','2014-01-24','11:30:00',1.46),('8784','2014-01-24','11:35:00',1.29),('8784','2014-01-24','11:45:00',1.65),('8784','2014-01-24','11:50:00',2.81),('8784','2014-01-24','11:55:00',2.85),('8784','2014-01-24','12:00:00',1.52),('8784','2014-01-24','12:05:00',1.27),('8784','2014-01-24','12:10:00',1.08),('8784','2014-01-24','12:25:00',1.87),('8784','2014-01-24','12:30:00',1.29),('8784','2014-01-24','12:35:00',2.7),('8784','2014-01-24','12:40:00',2.46),('8784','2014-01-24','12:45:00',1.59),('8784','2014-01-24','12:50:00',1.27),('8784','2014-01-24','12:55:00',1.5),('8784','2014-01-24','13:00:00',1.73),('8784','2014-01-24','13:05:00',1.99),('8784','2014-01-24','13:10:00',1.28),('8784','2014-01-24','13:30:00',1.28),('8784','2014-01-24','13:35:00',1.62),('8784','2014-01-24','13:40:00',1.37),('8784','2014-01-24','13:45:00',1.18),('8784','2014-01-24','13:50:00',1.17),('8784','2014-01-24','13:55:00',1.63),('8784','2014-01-24','14:00:00',1.46),('8784','2014-01-24','14:10:00',2.71),('8784','2014-01-24','14:15:00',2.23),('8784','2014-01-24','14:20:00',1.99),('8784','2014-01-24','14:25:00',1.83),('8784','2014-01-24','14:45:00',1.03),('8784','2014-01-23','11:00:00',1.11),('8784','2014-01-23','11:05:00',1.11),('8784','2014-01-23','11:10:00',1.1),('8784','2014-01-23','11:15:00',1.11),('8784','2014-01-23','11:20:00',1.08),('8784','2014-01-23','12:30:00',1.1),('8784','2014-01-22','10:15:00',1.01),('8784','2014-01-22','11:05:00',1.03),('8784','2014-01-22','11:10:00',1.08),('8784','2014-01-22','11:20:00',1.07),('8784','2014-01-22','11:25:00',1.01),('8784','2014-01-22','11:40:00',1.04),('8784','2014-01-22','13:10:00',1.06),('8784','2014-01-22','13:15:00',1.83),('8784','2014-01-22','13:20:00',1.07),('8784','2014-01-21','09:55:00',1),('8784','2014-01-21','10:00:00',1.21),('8784','2014-01-21','10:05:00',1.23),('8784','2014-01-21','10:55:00',1.58),('8784','2014-01-21','11:00:00',2.2),('8784','2014-01-21','11:50:00',1.07),('8784','2014-01-21','11:55:00',1.02),('8784','2014-01-21','12:05:00',1.64),('8784','2014-01-21','12:10:00',1.84),('8784','2014-01-21','12:15:00',1.37),('8784','2014-01-21','12:20:00',1.14),('8784','2014-01-21','12:25:00',1.48),('8784','2014-01-21','12:30:00',1.88),('8784','2014-01-21','12:35:00',1.64),('8784','2014-01-21','12:40:00',1.43),('8784','2014-01-21','12:45:00',1.33),('8784','2014-01-21','12:50:00',1.79),('8784','2014-01-21','13:20:00',1.03),('8784','2014-01-21','14:00:00',1.06),('8784','2014-01-21','14:05:00',1.37),('8784','2014-01-21','14:10:00',1.26),('8784','2014-01-21','14:15:00',1.05),('8784','2014-01-20','11:20:00',1.59),('8784','2014-01-20','11:25:00',1.87),('8784','2014-01-20','11:30:00',1.94),('8784','2014-01-20','11:35:00',1.93),('8784','2014-01-20','11:40:00',2.77),('8784','2014-01-20','11:45:00',2.88),('8784','2014-01-20','11:50:00',1.69),('8784','2014-01-20','12:05:00',1.04),('8784','2014-01-20','12:25:00',1.2),('8784','2014-01-20','12:30:00',1.2),('8784','2014-01-20','13:15:00',1.16),('8784','2014-01-20','13:20:00',3.59),('8784','2014-01-20','13:25:00',3.19),('8784','2014-01-20','13:30:00',2.7),('8784','2014-01-20','13:35:00',2.41),('8784','2014-01-20','13:40:00',1.96),('8784','2014-01-20','13:45:00',1.97),('8784','2014-01-20','13:50:00',1.18),('8784','2014-01-20','13:55:00',1.38),('8784','2014-01-20','14:00:00',2.69),('8784','2014-01-20','14:05:00',1.7),('8784','2014-01-20','14:10:00',1.18),('8784','2014-01-20','14:15:00',1.01),('8784','2014-01-19','11:55:00',1.01),('8784','2014-01-19','12:00:00',1.1),('8784','2014-01-19','12:05:00',1.13),('8784','2014-01-19','12:10:00',1.09),('8784','2014-01-19','13:05:00',1.07),('8784','2014-01-19','13:10:00',1.2),('8784','2014-01-19','13:15:00',1.05),('8784','2014-01-19','14:20:00',1.37),('8784','2014-01-19','14:25:00',1.58),('8784','2014-01-19','14:30:00',1.8),('8784','2014-01-19','14:35:00',1.22),('8784','2014-01-19','14:40:00',1.02),('8784','2014-01-18','10:00:00',1.08),('8784','2014-01-18','10:05:00',1.16),('8784','2014-01-18','10:10:00',1.73),('8784','2014-01-18','10:15:00',1.99),('8784','2014-01-18','10:20:00',1.81),('8784','2014-01-18','10:25:00',1.48),('8784','2014-01-18','10:30:00',1.58),('8784','2014-01-18','10:35:00',1.14),('8784','2014-01-18','10:40:00',1.08),('8784','2014-01-18','10:45:00',1.19),('8784','2014-01-18','10:50:00',1.26),('8784','2014-01-18','10:55:00',1.14),('8784','2014-01-18','11:05:00',1.25),('8784','2014-01-18','11:10:00',1.82),('8784','2014-01-18','11:15:00',2.41),('8784','2014-01-18','11:20:00',2.16),('8784','2014-01-18','11:25:00',2.08),('8784','2014-01-18','11:30:00',2.19),('8784','2014-01-18','11:35:00',2.23),('8784','2014-01-18','11:40:00',2.36),('8784','2014-01-18','11:45:00',2.6),('8784','2014-01-18','11:50:00',2.44),('8784','2014-01-18','11:55:00',2.77),('8784','2014-01-18','12:00:00',2.55),('8784','2014-01-18','12:05:00',1.89),('8784','2014-01-18','12:10:00',2.41),('8784','2014-01-18','12:15:00',2.27),('8784','2014-01-18','12:20:00',2.26),('8784','2014-01-18','12:25:00',2.25),('8784','2014-01-18','12:30:00',2.23),('8784','2014-01-18','12:35:00',2.22),('8784','2014-01-18','12:40:00',2.26),('8784','2014-01-18','12:45:00',2.23),('8784','2014-01-18','12:50:00',1.95),('8784','2014-01-18','12:55:00',2.25),('8784','2014-01-18','13:00:00',1.61),('8784','2014-01-18','13:05:00',1.51),('8784','2014-01-18','13:10:00',2.09),('8784','2014-01-18','13:15:00',2.36),('8784','2014-01-18','13:20:00',1.58),('8784','2014-01-18','13:25:00',1.18),('8784','2014-01-18','13:30:00',1.85),('8784','2014-01-18','13:35:00',1.24),('8784','2014-01-18','13:40:00',1.79),('8784','2014-01-18','13:45:00',2.05),('8784','2014-01-18','13:50:00',1.46),('8784','2014-01-18','13:55:00',1.87),('8784','2014-01-18','14:00:00',1.95),('8784','2014-01-18','14:05:00',1.83),('8784','2014-01-18','14:10:00',1.65),('8784','2014-01-18','14:15:00',1.62),('8784','2014-01-18','14:20:00',1.67),('8784','2014-01-18','14:25:00',1.58),('8784','2014-01-18','14:30:00',1.5),('8784','2014-01-18','14:35:00',1.43),('8784','2014-01-18','14:40:00',1.39),('8784','2014-01-18','14:45:00',1.33),('8784','2014-01-18','14:50:00',1.25),('8784','2014-01-17','09:40:00',1.03),('8784','2014-01-17','09:45:00',1.24),('8784','2014-01-17','11:25:00',1.18),('8784','2014-01-17','11:30:00',1.75),('8784','2014-01-17','11:35:00',1.82),('8784','2014-01-17','11:40:00',1.58),('8784','2014-01-17','11:55:00',1.1),('8784','2014-01-17','12:00:00',1.35),('8784','2014-01-17','12:05:00',1.56),('8784','2014-01-17','12:10:00',1.29),('8784','2014-01-17','12:40:00',1.06),('8784','2014-01-17','12:45:00',1.18),('8784','2014-04-25','08:00:00',1.19),('8784','2014-04-25','08:05:00',1.4),('8784','2014-04-25','08:10:00',1.48),('8784','2014-04-25','08:15:00',1.5),('8784','2014-04-25','08:20:00',1.6),('8784','2014-04-25','08:25:00',1.69),('8784','2014-04-25','08:30:00',1.77),('8784','2014-04-25','08:35:00',1.82),('8784','2014-04-25','08:40:00',1.87),('8784','2014-04-25','08:45:00',1.89),('8784','2014-04-25','08:50:00',1.95),('8784','2014-04-25','08:55:00',1.35),('8784','2014-04-25','09:00:00',1.27),('8784','2014-04-25','09:05:00',1.16),('8784','2014-04-25','09:10:00',1.03),('8784','2014-04-25','09:20:00',1.11),('8784','2014-04-25','09:25:00',1.33),('8784','2014-04-25','09:30:00',1.18),('8784','2014-04-25','09:35:00',1.11),('8784','2014-04-25','09:40:00',1.04),('8784','2014-04-25','09:45:00',1.08),('8784','2014-04-25','09:50:00',1.08),('8784','2014-04-25','09:55:00',1.19),('8784','2014-04-25','10:00:00',1.4),('8784','2014-04-25','10:05:00',1.3),('8784','2014-04-25','10:10:00',1.38),('8784','2014-04-25','10:15:00',1.33),('8784','2014-04-25','10:20:00',1.42),('8784','2014-04-25','10:25:00',1.48),('8784','2014-04-25','10:30:00',1.91),('8784','2014-04-25','10:35:00',3.39),('8784','2014-04-25','10:40:00',2.31),('8784','2014-04-25','10:45:00',3.8),('8784','2014-04-25','10:50:00',2.34),('8784','2014-04-25','10:55:00',3.57),('8784','2014-04-25','11:00:00',2.84),('8784','2014-04-25','11:05:00',2.32),('8784','2014-04-25','11:10:00',3.81),('8784','2014-04-25','11:15:00',4.23),('8784','2014-04-25','11:20:00',3.2),('8784','2014-04-25','11:25:00',3.88),('8784','2014-04-25','11:30:00',2.3),('8784','2014-04-25','11:35:00',3.28),('8784','2014-04-25','11:40:00',3.04),('8784','2014-04-25','11:45:00',1.51),('8784','2014-04-25','11:50:00',1.48),('8784','2014-04-25','11:55:00',4.52),('8784','2014-04-25','12:00:00',2.93),('8784','2014-04-25','12:05:00',4.32),('8784','2014-04-25','12:10:00',4.28),('8784','2014-04-25','12:15:00',1.68),('8784','2014-04-25','12:20:00',3.89),('8784','2014-04-25','12:25:00',3.87),('8784','2014-04-25','12:30:00',4.47),('8784','2014-04-25','12:35:00',4.63),('8784','2014-04-25','12:40:00',4.84),('8784','2014-04-25','12:45:00',4.89),('8784','2014-04-25','12:50:00',2.47),('8784','2014-04-25','12:55:00',3.22),('8784','2014-04-25','13:00:00',3.08),('8784','2014-04-25','13:05:00',2.4),('8784','2014-04-25','13:10:00',4.02),('8784','2014-04-25','13:15:00',1.94),('8784','2014-04-25','13:20:00',1.57),('8784','2014-04-25','13:25:00',3.69),('8784','2014-04-25','13:30:00',1.36),('8784','2014-04-25','13:35:00',1.15),('8784','2014-04-25','13:40:00',1.44),('8784','2014-04-25','13:45:00',1.52),('8784','2014-04-25','13:50:00',1.46),('8784','2014-04-25','13:55:00',2.64),('8784','2014-04-25','14:00:00',1.48),('8784','2014-04-25','14:05:00',1.58),('8784','2014-04-25','14:10:00',1.29),('8784','2014-04-25','14:15:00',1.43),('8784','2014-04-25','14:20:00',4.28),('8784','2014-04-25','14:25:00',2.62),('8784','2014-04-25','14:30:00',2.24),('8784','2014-04-25','14:35:00',3.41),('8784','2014-04-25','14:40:00',4.09),('8784','2014-04-25','14:45:00',3.97),('8784','2014-04-25','14:50:00',3.94),('8784','2014-04-25','14:55:00',3.91),('8784','2014-04-25','15:00:00',3.84),('8784','2014-04-25','15:05:00',3.82),('8784','2014-04-25','15:10:00',3.78),('8784','2014-04-25','15:15:00',3.73),('8784','2014-04-25','15:20:00',3.56),('8784','2014-04-25','15:25:00',3.54),('8784','2014-04-25','15:30:00',3.45),('8784','2014-04-25','15:35:00',3.5),('8784','2014-04-25','15:40:00',3.44),('8784','2014-04-25','15:45:00',3.33),('8784','2014-04-25','15:50:00',3.31),('8784','2014-04-25','15:55:00',3.26),('8784','2014-04-25','16:00:00',3.2),('8784','2014-04-25','16:05:00',3.09),('8784','2014-04-25','16:10:00',2.95),('8784','2014-04-25','16:15:00',2.82),('8784','2014-04-25','16:20:00',2.63),('8784','2014-04-25','16:25:00',2.69),('8784','2014-04-25','16:30:00',2.76),('8784','2014-04-25','16:35:00',2.75),('8784','2014-04-25','16:40:00',2.72),('8784','2014-04-25','16:45:00',2.6),('8784','2014-04-25','16:50:00',2.34),('8784','2014-04-25','16:55:00',2.03),('8784','2014-04-25','17:00:00',2.02),('8784','2014-04-25','17:05:00',2.2),('8784','2014-04-25','17:10:00',1.83),('8784','2014-04-25','17:15:00',1.93),('8784','2014-04-25','17:20:00',1.31),('8784','2014-04-25','17:25:00',1.02),('8784','2014-04-25','17:30:00',1.09),('8784','2014-04-25','17:35:00',1.09),('8784','2014-04-25','17:40:00',1.07),('8784','2014-01-16','09:40:00',1.19),('8784','2014-01-16','09:45:00',1.2),('8784','2014-01-16','09:50:00',1.09),('8784','2014-01-16','10:10:00',1.03),('8784','2014-01-16','10:15:00',1.15),('8784','2014-01-16','10:20:00',1.2),('8784','2014-01-16','10:25:00',1.39),('8784','2014-01-16','10:30:00',1.88),('8784','2014-01-16','10:35:00',2.35),('8784','2014-01-16','10:40:00',2.13),('8784','2014-01-16','10:45:00',1.61),('8784','2014-01-16','10:50:00',1.71),('8784','2014-01-16','10:55:00',1.86),('8784','2014-01-16','11:00:00',1.88),('8784','2014-01-16','11:05:00',1.86),('8784','2014-01-16','11:10:00',1.97),('8784','2014-01-16','11:15:00',1.88),('8784','2014-01-16','11:20:00',1.7),('8784','2014-01-16','11:25:00',1.76),('8784','2014-01-16','11:30:00',1.65),('8784','2014-01-16','11:35:00',1.57),('8784','2014-01-16','11:40:00',1.42),('8784','2014-01-16','11:45:00',1.63),('8784','2014-01-16','11:50:00',1.41),('8784','2014-01-16','11:55:00',1.48),('8784','2014-01-16','12:00:00',1.44),('8784','2014-01-16','12:05:00',1.53),('8784','2014-01-16','12:10:00',1.67),('8784','2014-01-16','12:15:00',1.58),('8784','2014-01-16','12:20:00',1.46),('8784','2014-01-16','12:25:00',1.4),('8784','2014-01-16','12:30:00',1.48),('8784','2014-01-16','12:35:00',1.73),('8784','2014-01-16','12:40:00',1.77),('8784','2014-01-16','12:45:00',1.8),('8784','2014-01-16','12:50:00',1.93),('8784','2014-01-16','12:55:00',1.91),('8784','2014-01-16','13:00:00',2.05),('8784','2014-01-16','13:05:00',1.85),('8784','2014-01-16','13:10:00',2),('8784','2014-01-16','13:15:00',1.65),('8784','2014-01-16','13:20:00',1.39),('8784','2014-01-16','13:25:00',1.89),('8784','2014-01-16','13:30:00',1.22),('8784','2014-01-16','13:35:00',1.11),('8784','2014-01-16','13:40:00',1.29),('8784','2014-01-16','13:45:00',1.83),('8784','2014-01-16','13:50:00',1.71),('8784','2014-01-16','13:55:00',1.88),('8784','2014-01-16','14:00:00',1.11),('8784','2014-01-16','14:05:00',1.12),('8784','2014-01-16','14:10:00',1.07),('8784','2014-01-15','10:15:00',1.17),('8784','2014-01-15','10:20:00',1.61),('8784','2014-01-15','10:25:00',1.85),('8784','2014-01-15','10:30:00',1.73),('8784','2014-01-15','10:35:00',1.39),('8784','2014-01-15','10:40:00',1.64),('8784','2014-01-15','10:45:00',1.49),('8784','2014-01-15','10:55:00',1.03),('8784','2014-01-15','11:00:00',1.25),('8784','2014-01-15','11:05:00',1.74),('8784','2014-01-15','11:10:00',2.12),('8784','2014-01-15','11:15:00',2.25),('8784','2014-01-15','11:20:00',2.05),('8784','2014-01-15','11:25:00',1.98),('8784','2014-01-15','11:30:00',1.82),('8784','2014-01-15','11:35:00',1.24),('8784','2014-01-15','11:40:00',1.69),('8784','2014-01-15','11:45:00',2),('8784','2014-01-15','11:50:00',2.02),('8784','2014-01-15','11:55:00',1.74),('8784','2014-01-15','12:00:00',1.71),('8784','2014-01-15','12:05:00',1.58),('8784','2014-01-15','12:10:00',1.54),('8784','2014-01-15','12:15:00',1.76),('8784','2014-01-15','12:20:00',2.24),('8784','2014-01-15','12:25:00',1.8),('8784','2014-01-15','12:30:00',1.36),('8784','2014-01-15','12:35:00',1.51),('8784','2014-01-15','12:40:00',1.31),('8784','2014-01-15','12:45:00',1.34),('8784','2014-01-15','12:50:00',1.44),('8784','2014-01-15','12:55:00',1.26),('8784','2014-01-15','13:00:00',1.22),('8784','2014-01-15','13:05:00',1.35),('8784','2014-01-15','13:10:00',1.6),('8784','2014-01-15','13:15:00',2.42),('8784','2014-01-15','13:20:00',2.46),('8784','2014-01-15','13:25:00',2.31),('8784','2014-01-15','13:30:00',2.19),('8784','2014-01-15','13:35:00',1.92),('8784','2014-01-15','13:40:00',1.98),('8784','2014-01-15','13:45:00',1.92),('8784','2014-01-15','13:50:00',1.69),('8784','2014-01-15','14:00:00',1.73),('8784','2014-01-15','14:05:00',1.71),('8784','2014-01-15','14:10:00',1.66),('8784','2014-01-15','14:15:00',1.59),('8784','2014-01-15','14:20:00',1.59),('8784','2014-01-15','14:25:00',1.54),('8784','2014-01-15','14:30:00',1.49),('8784','2014-01-15','14:35:00',1.5),('8784','2014-01-15','14:40:00',1.56),('8784','2014-01-15','14:45:00',1.5),('8784','2014-01-15','14:50:00',1.4),('8784','2014-01-15','14:55:00',1.35),('8784','2014-01-15','15:00:00',1.3),('8784','2014-01-15','15:05:00',1.12),('8784','2014-01-15','15:10:00',1.21),('8784','2014-01-15','15:15:00',1.15),('8784','2014-01-14','10:25:00',1.48),('8784','2014-01-14','10:30:00',2.51),('8784','2014-01-14','10:35:00',2.53),('8784','2014-01-14','10:40:00',2.24),('8784','2014-01-14','10:45:00',2.13),('8784','2014-01-14','10:50:00',1.38),('8784','2014-01-14','10:55:00',1.26),('8784','2014-01-14','11:00:00',1.45),('8784','2014-01-14','11:05:00',1.19),('8784','2014-01-14','11:20:00',1.01),('8784','2014-01-14','11:30:00',1.05),('8784','2014-01-14','11:35:00',1.17),('8784','2014-01-14','11:40:00',1.33),('8784','2014-01-13','09:50:00',1.11),('8784','2014-01-13','09:55:00',1.22),('8784','2014-01-13','10:00:00',1.26),('8784','2014-01-13','10:05:00',1.3),('8784','2014-01-13','10:10:00',1.28),('8784','2014-01-13','10:15:00',1.41),('8784','2014-01-13','10:20:00',1.57),('8784','2014-01-13','10:25:00',1.67),('8784','2014-01-13','10:30:00',1.71),('8784','2014-01-13','10:35:00',1.75),('8784','2014-01-13','10:40:00',1.8),('8784','2014-01-13','10:45:00',1.83),('8784','2014-01-13','10:50:00',1.87),('8784','2014-01-13','10:55:00',1.9),('8784','2014-01-13','11:00:00',1.95),('8784','2014-01-13','11:05:00',2),('8784','2014-01-13','11:10:00',2.03),('8784','2014-01-13','11:15:00',1.99),('8784','2014-01-13','11:20:00',2.01),('8784','2014-01-13','11:25:00',2.02),('8784','2014-01-13','11:30:00',2.02),('8784','2014-01-13','11:35:00',2.01),('8784','2014-01-13','11:40:00',2.03),('8784','2014-01-13','11:45:00',2.02),('8784','2014-01-13','11:50:00',2.01),('8784','2014-01-13','11:55:00',2),('8784','2014-01-13','12:00:00',2.01),('8784','2014-01-13','12:05:00',1.99),('8784','2014-01-13','12:10:00',1.97),('8784','2014-01-13','12:15:00',1.97),('8784','2014-01-13','12:20:00',2),('8784','2014-01-13','12:25:00',2.02),('8784','2014-01-13','12:30:00',2),('8784','2014-01-13','12:35:00',1.97),('8784','2014-01-13','12:40:00',1.92),('8784','2014-01-13','12:45:00',1.93),('8784','2014-01-13','12:50:00',1.82),('8784','2014-01-13','12:55:00',1.8),('8784','2014-01-13','13:00:00',1.78),('8784','2014-01-13','13:05:00',1.8),('8784','2014-01-13','13:10:00',1.83),('8784','2014-01-13','13:15:00',1.82),('8784','2014-01-13','13:20:00',1.86),('8784','2014-01-13','13:25:00',1.82),('8784','2014-01-13','13:30:00',1.73),('8784','2014-01-13','13:35:00',1.7),('8784','2014-01-13','13:40:00',1.65),('8784','2014-01-13','13:45:00',1.57),('8784','2014-01-13','13:50:00',1.64),('8784','2014-01-13','13:55:00',1.61),('8784','2014-01-13','14:00:00',1.56),('8784','2014-01-13','14:05:00',1.48),('8784','2014-01-13','14:10:00',1.43),('8784','2014-01-13','14:15:00',1.44),('8784','2014-01-13','14:20:00',1.42),('8784','2014-01-13','14:25:00',1.36),('8784','2014-01-13','14:30:00',1.3),('8784','2014-01-13','14:35:00',1.25),('8784','2014-01-13','14:40:00',1.21),('8784','2014-01-13','14:45:00',1.12),('8784','2014-01-13','14:50:00',1.07),('8784','2014-01-13','14:55:00',1.07),('8784','2014-01-12','10:20:00',1.08),('8784','2014-01-12','10:25:00',1.06),('8784','2014-01-12','10:30:00',1.05),('8784','2014-01-12','10:35:00',1.2),('8784','2014-01-12','10:40:00',1.36),('8784','2014-01-12','10:45:00',1.34),('8784','2014-01-12','10:50:00',1.45),('8784','2014-01-12','10:55:00',1.52),('8784','2014-01-12','11:00:00',1.47),('8784','2014-01-12','11:05:00',1.54),('8784','2014-01-12','11:10:00',1.82),('8784','2014-01-12','11:15:00',1.57),('8784','2014-01-12','11:20:00',1.42),('8784','2014-01-12','11:25:00',1.42),('8784','2014-01-12','11:30:00',1.52),('8784','2014-01-12','11:35:00',1.4),('8784','2014-01-12','11:40:00',1.7),('8784','2014-01-12','11:45:00',1.8),('8784','2014-01-12','11:50:00',1.89),('8784','2014-01-12','11:55:00',1.77),('8784','2014-01-12','12:00:00',1.45),('8784','2014-01-12','12:05:00',1.48),('8784','2014-01-12','12:10:00',1.26),('8784','2014-01-12','12:20:00',1.25),('8784','2014-01-12','12:25:00',1.21),('8784','2014-01-12','12:30:00',1.25),('8784','2014-01-12','12:35:00',1.26),('8784','2014-01-12','12:40:00',1.31),('8784','2014-01-12','12:45:00',1.28),('8784','2014-01-12','12:50:00',1.32),('8784','2014-01-12','12:55:00',1.28),('8784','2014-01-12','13:00:00',1.28),('8784','2014-01-12','13:05:00',1.2),('8784','2014-01-12','13:10:00',1.14),('8784','2014-01-12','13:15:00',1.05),('8784','2014-01-12','13:25:00',1.18),('8784','2014-01-12','13:30:00',1.34),('8784','2014-01-12','13:35:00',1.25),('8784','2014-01-12','13:40:00',1.13),('8784','2014-01-12','13:45:00',1.01),('8784','2014-01-11','10:15:00',1.08),('8784','2014-01-11','10:20:00',1.14),('8784','2014-01-11','10:25:00',1.41),('8784','2014-01-11','10:30:00',1.38),('8784','2014-01-11','10:35:00',1.46),('8784','2014-01-11','10:40:00',1.83),('8784','2014-01-11','10:45:00',1.93),('8784','2014-01-11','10:50:00',1.97),('8784','2014-01-11','10:55:00',1.97),('8784','2014-01-11','11:00:00',1.9),('8784','2014-01-11','11:05:00',1.9),('8784','2014-01-11','11:10:00',2.02),('8784','2014-01-11','11:15:00',1.78),('8784','2014-01-11','11:20:00',1.67),('8784','2014-01-11','11:25:00',1.68),('8784','2014-01-11','11:30:00',1.68),('8784','2014-01-11','11:35:00',1.48),('8784','2014-01-11','11:40:00',1.4),('8784','2014-01-11','11:45:00',1.45),('8784','2014-01-11','11:50:00',1.65),('8784','2014-01-11','11:55:00',1.63),('8784','2014-01-11','12:00:00',1.67),('8784','2014-01-11','12:05:00',1.83),('8784','2014-01-11','12:10:00',1.71),('8784','2014-01-11','12:15:00',1.68),('8784','2014-01-11','12:20:00',1.68),('8784','2014-01-11','12:25:00',1.58),('8784','2014-01-11','12:30:00',1.43),('8784','2014-01-11','12:35:00',1.37),('8784','2014-01-11','12:40:00',1.23),('8784','2014-01-11','12:45:00',1.43),('8784','2014-01-11','12:50:00',1.69),('8784','2014-01-11','12:55:00',1.83),('8784','2014-01-11','13:00:00',1.81),('8784','2014-01-11','13:05:00',1.61),('8784','2014-01-11','13:10:00',1.34),('8784','2014-01-11','13:15:00',1.84),('8784','2014-01-11','13:20:00',1.58),('8784','2014-01-11','13:25:00',1.34),('8784','2014-01-11','13:30:00',1.06),('8784','2014-01-11','13:35:00',1.04),('8784','2014-01-11','13:40:00',1.05),('8784','2014-01-11','13:45:00',1.15),('8784','2014-01-11','13:55:00',1.05),('8784','2014-01-11','14:00:00',1.35),('8784','2014-01-11','14:05:00',1.41),('8784','2014-01-11','14:10:00',1.19),('8784','2014-04-24','07:45:00',1.03),('8784','2014-04-24','07:50:00',1.12),('8784','2014-04-24','07:55:00',1.19),('8784','2014-04-24','08:05:00',1.37),('8784','2014-04-24','08:10:00',1.45),('8784','2014-04-24','08:15:00',1.56),('8784','2014-04-24','08:20:00',1.62),('8784','2014-04-24','08:25:00',1.73),('8784','2014-04-24','08:30:00',1.81),('8784','2014-04-24','08:35:00',1.91),('8784','2014-04-24','08:40:00',1.99),('8784','2014-04-24','08:45:00',2.08),('8784','2014-04-24','08:50:00',2.17),('8784','2014-04-24','08:55:00',2.23),('8784','2014-04-24','09:00:00',2.27),('8784','2014-04-24','09:05:00',2.35),('8784','2014-04-24','09:10:00',2.47),('8784','2014-04-24','09:15:00',2.56),('8784','2014-04-24','09:20:00',2.62),('8784','2014-04-24','09:25:00',2.67),('8784','2014-04-24','09:30:00',2.75),('8784','2014-04-24','09:35:00',2.83),('8784','2014-04-24','09:40:00',2.9),('8784','2014-04-24','09:45:00',2.97),('8784','2014-04-24','09:50:00',2.98),('8784','2014-04-24','09:55:00',3.09),('8784','2014-04-24','10:00:00',3.16),('8784','2014-04-24','10:05:00',3.2),('8784','2014-04-24','10:10:00',3.25),('8784','2014-04-24','10:15:00',3.32),('8784','2014-04-24','10:20:00',3.38),('8784','2014-04-24','10:25:00',3.44),('8784','2014-04-24','10:30:00',3.48),('8784','2014-04-24','10:35:00',3.53),('8784','2014-04-24','10:40:00',3.57),('8784','2014-04-24','10:45:00',3.61),('8784','2014-04-24','10:50:00',3.67),('8784','2014-04-24','10:55:00',3.71),('8784','2014-04-24','11:00:00',3.7),('8784','2014-04-24','11:05:00',3.75),('8784','2014-04-24','11:10:00',3.82),('8784','2014-04-24','11:15:00',3.86),('8784','2014-04-24','11:20:00',3.88),('8784','2014-04-24','11:25:00',3.84),('8784','2014-04-24','11:30:00',3.83),('8784','2014-04-24','11:35:00',3.93),('8784','2014-04-24','11:40:00',3.97),('8784','2014-04-24','11:45:00',4.02),('8784','2014-04-24','11:50:00',3.97),('8784','2014-04-24','11:55:00',3.99),('8784','2014-04-24','12:00:00',4.02),('8784','2014-04-24','12:05:00',4.13),('8784','2014-04-24','12:10:00',3.28),('8784','2014-04-24','12:15:00',4.29),('8784','2014-04-24','12:20:00',4.18),('8784','2014-04-24','12:25:00',4.25),('8784','2014-04-24','12:30:00',4.31),('8784','2014-04-24','12:35:00',4.34),('8784','2014-04-24','12:40:00',4.3),('8784','2014-04-24','12:45:00',4.26),('8784','2014-04-24','12:50:00',4.24),('8784','2014-04-24','12:55:00',4.32),('8784','2014-04-24','13:00:00',4.31),('8784','2014-04-24','13:05:00',4.24),('8784','2014-04-24','13:10:00',4.35),('8784','2014-04-24','13:15:00',4.45),('8784','2014-04-24','13:20:00',4.37),('8784','2014-04-24','13:25:00',4.36),('8784','2014-04-24','13:30:00',2.92),('8784','2014-04-24','13:35:00',2.36),('8784','2014-04-24','13:40:00',1.19),('8784','2014-04-24','13:45:00',1.25),('8784','2014-04-24','13:50:00',4.57),('8784','2014-04-24','13:55:00',4.95),('8784','2014-04-24','14:00:00',4.71),('8784','2014-04-24','14:05:00',4.84),('8784','2014-04-24','14:10:00',4.87),('8784','2014-04-24','14:15:00',3.39),('8784','2014-04-24','14:20:00',4.19),('8784','2014-04-24','14:25:00',4.41),('8784','2014-04-24','14:30:00',3.97),('8784','2014-04-24','14:35:00',4.13),('8784','2014-04-24','14:40:00',3.02),('8784','2014-04-24','14:45:00',2.3),('8784','2014-04-24','14:50:00',2.32),('8784','2014-04-24','14:55:00',4.51),('8784','2014-04-24','15:00:00',4.56),('8784','2014-04-24','15:05:00',4.5),('8784','2014-04-24','15:10:00',4.51),('8784','2014-04-24','15:15:00',4.4),('8784','2014-04-24','15:20:00',2.98),('8784','2014-04-24','15:25:00',2.4),('8784','2014-04-24','15:30:00',2.84),('8784','2014-04-24','15:35:00',2.76),('8784','2014-04-24','15:40:00',2.51),('8784','2014-04-24','15:45:00',2.23),('8784','2014-04-24','15:50:00',2.42),('8784','2014-04-24','15:55:00',2.61),('8784','2014-04-24','16:00:00',4.03),('8784','2014-04-24','16:05:00',3.68),('8784','2014-04-24','16:10:00',3.12),('8784','2014-04-24','16:15:00',3.77),('8784','2014-04-24','16:20:00',3.02),('8784','2014-04-24','16:25:00',3.34),('8784','2014-04-24','16:30:00',3.13),('8784','2014-04-24','16:35:00',2.05),('8784','2014-04-24','16:40:00',2.02),('8784','2014-04-24','16:45:00',1.64),('8784','2014-04-24','16:50:00',1.4),('8784','2014-04-24','16:55:00',1.46),('8784','2014-04-24','17:00:00',1.49),('8784','2014-04-24','17:05:00',1.37),('8784','2014-04-24','17:10:00',1.29),('8784','2014-04-24','17:15:00',1.16),('8784','2014-04-24','17:20:00',1.13),('8784','2014-04-24','17:25:00',1.13),('8784','2014-04-24','17:30:00',1.14),('8784','2014-04-24','17:35:00',1.03),('8784','2014-04-23','13:10:00',1.1),('8784','2014-04-23','13:15:00',1.27),('8784','2014-04-23','13:20:00',1.39),('8784','2014-04-23','13:25:00',1.44),('8784','2014-04-23','13:30:00',1.55),('8784','2014-04-23','13:35:00',1.61),('8784','2014-04-23','13:40:00',1.71),('8784','2014-04-23','13:45:00',1.73),('8784','2014-04-23','13:50:00',1.73),('8784','2014-04-23','13:55:00',1.73),('8784','2014-04-23','14:00:00',1.63),('8784','2014-04-23','14:05:00',1.64),('8784','2014-04-23','14:10:00',1.56),('8784','2014-04-23','14:15:00',1.31),('8784','2014-04-23','14:20:00',1.15),('8784','2014-04-23','14:25:00',1.05),('8784','2014-04-23','14:45:00',1.15),('8784','2014-04-23','14:50:00',1.39),('8784','2014-04-23','14:55:00',1.6),('8784','2014-04-23','15:00:00',1.78),('8784','2014-04-23','15:05:00',1.87),('8784','2014-04-23','15:10:00',1.8),('8784','2014-04-23','15:15:00',1.9),('8784','2014-04-23','15:20:00',1.57),('8784','2014-04-23','15:25:00',1.44),('8784','2014-04-23','15:30:00',1.38),('8784','2014-04-23','15:35:00',1.32),('8784','2014-04-23','15:40:00',1.33),('8784','2014-04-23','15:45:00',1.49),('8784','2014-04-23','15:50:00',1.16),('8784','2014-04-23','15:55:00',1.08),('8784','2014-04-22','07:50:00',1.05),('8784','2014-04-22','07:55:00',1.13),('8784','2014-04-22','08:00:00',1.22),('8784','2014-04-22','08:05:00',1.29),('8784','2014-04-22','08:10:00',1.4),('8784','2014-04-22','08:15:00',1.5),('8784','2014-04-22','08:20:00',1.58),('8784','2014-04-22','08:25:00',1.67),('8784','2014-04-22','08:30:00',1.77),('8784','2014-04-22','08:35:00',1.84),('8784','2014-04-22','08:40:00',1.94),('8784','2014-04-22','08:45:00',2.01),('8784','2014-04-22','08:50:00',2.08),('8784','2014-04-22','08:55:00',2.1),('8784','2014-04-22','09:00:00',2.12),('8784','2014-04-22','09:05:00',2.45),('8784','2014-04-22','09:10:00',2.12),('8784','2014-04-22','09:15:00',2.24),('8784','2014-04-22','09:20:00',2.51),('8784','2014-04-22','09:25:00',2.74),('8784','2014-04-22','09:30:00',2.76),('8784','2014-04-22','09:35:00',2.92),('8784','2014-04-22','09:40:00',2.9),('8784','2014-04-22','09:45:00',2.98),('8784','2014-04-22','09:50:00',2.31),('8784','2014-04-22','09:55:00',1.54),('8784','2014-04-22','10:00:00',1.45),('8784','2014-04-22','10:05:00',1.55),('8784','2014-04-22','10:10:00',2.09),('8784','2014-04-22','10:15:00',2.21),('8784','2014-04-22','10:20:00',3.29),('8784','2014-04-22','10:25:00',2.31),('8784','2014-04-22','10:30:00',3.79),('8784','2014-04-22','10:35:00',3.81),('8784','2014-04-22','10:40:00',3.59),('8784','2014-04-22','10:45:00',3.92),('8784','2014-04-22','10:50:00',4.1),('8784','2014-04-22','10:55:00',2.97),('8784','2014-04-22','11:00:00',2.14),('8784','2014-04-22','11:05:00',2.41),('8784','2014-04-22','11:10:00',1.78),('8784','2014-04-22','11:15:00',1.47),('8784','2014-04-22','11:20:00',1.33),('8784','2014-04-22','11:25:00',1.31),('8784','2014-04-22','11:30:00',1.2),('8784','2014-04-22','11:35:00',1.26),('8784','2014-04-22','11:40:00',1.14),('8784','2014-04-22','11:50:00',1.01),('8784','2014-04-22','12:00:00',1.06),('8784','2014-04-22','12:05:00',1.28),('8784','2014-04-22','12:10:00',1.3),('8784','2014-04-22','12:15:00',1.31),('8784','2014-04-22','12:20:00',1.36),('8784','2014-04-22','12:25:00',1.47),('8784','2014-04-22','12:30:00',1.69),('8784','2014-04-22','12:35:00',1.47),('8784','2014-04-22','12:40:00',1.12),('8784','2014-04-22','13:10:00',1.01),('8784','2014-04-22','13:15:00',1.57),('8784','2014-04-22','13:20:00',2.39),('8784','2014-04-22','13:25:00',2.76),('8784','2014-04-22','13:30:00',2.95),('8784','2014-04-22','13:35:00',2.79),('8784','2014-04-22','13:40:00',3.33),('8784','2014-04-22','13:45:00',3.35),('8784','2014-04-22','13:50:00',2.82),('8784','2014-04-22','13:55:00',1.66),('8784','2014-04-22','14:00:00',1.48),('8784','2014-04-22','14:05:00',2),('8784','2014-04-22','14:10:00',3.68),('8784','2014-04-22','14:15:00',3.46),('8784','2014-04-22','14:20:00',4.14),('8784','2014-04-22','14:25:00',2.55),('8784','2014-04-22','14:30:00',2.21),('8784','2014-04-22','14:35:00',2.64),('8784','2014-04-22','14:40:00',3.48),('8784','2014-04-22','14:45:00',4.3),('8784','2014-04-22','14:50:00',3.91),('8784','2014-04-22','14:55:00',3),('8784','2014-04-22','15:00:00',1.43),('8784','2014-04-22','15:05:00',1.38),('8784','2014-04-22','15:10:00',1.27),('8784','2014-04-22','15:15:00',1.27),('8784','2014-04-22','15:20:00',1.42),('8784','2014-04-22','15:25:00',1.55),('8784','2014-04-22','15:30:00',1.93),('8784','2014-04-22','15:35:00',2.65),('8784','2014-04-22','15:40:00',2.17),('8784','2014-04-22','15:45:00',1.97),('8784','2014-04-22','15:50:00',2.28),('8784','2014-04-22','15:55:00',1.92),('8784','2014-04-22','16:00:00',2.24),('8784','2014-04-22','16:05:00',1.6),('8784','2014-04-22','16:10:00',1.54),('8784','2014-04-22','16:15:00',1.5),('8784','2014-04-22','16:20:00',1.73),('8784','2014-04-22','16:25:00',1.64),('8784','2014-04-22','16:30:00',1.4),('8784','2014-04-22','16:35:00',1.53),('8784','2014-04-22','16:40:00',1.92),('8784','2014-04-22','16:45:00',1.74),('8784','2014-04-22','16:50:00',1.39),('8784','2014-04-22','16:55:00',1.22),('8784','2014-04-22','17:00:00',1.38),('8784','2014-04-22','17:05:00',1.54),('8784','2014-04-22','17:10:00',1.2),('8784','2014-04-22','17:15:00',1.08),('8784','2014-04-21','08:40:00',1.01),('8784','2014-04-21','09:00:00',1.05),('8784','2014-04-21','09:05:00',1.04),('8784','2014-04-21','09:10:00',1.05),('8784','2014-04-21','09:15:00',1.17),('8784','2014-04-21','09:20:00',1.69),('8784','2014-04-21','09:25:00',1.47),('8784','2014-04-21','09:50:00',1.05),('8784','2014-04-21','09:55:00',1.12),('8784','2014-04-21','10:00:00',1.49),('8784','2014-04-21','10:05:00',3.35),('8784','2014-04-21','10:10:00',3.4),('8784','2014-04-21','10:15:00',3.51),('8784','2014-04-21','10:20:00',3.41),('8784','2014-04-21','10:25:00',3.43),('8784','2014-04-21','10:30:00',3.43),('8784','2014-04-21','10:35:00',3.46),('8784','2014-04-21','10:40:00',3.5),('8784','2014-04-21','10:45:00',3.56),('8784','2014-04-21','10:50:00',3.6),('8784','2014-04-21','10:55:00',3.64),('8784','2014-04-21','11:00:00',3.67),('8784','2014-04-21','11:05:00',3.72),('8784','2014-04-21','11:10:00',3.73),('8784','2014-04-21','11:15:00',3.77),('8784','2014-04-21','11:20:00',3.8),('8784','2014-04-21','11:25:00',3.87),('8784','2014-04-21','11:30:00',3.9),('8784','2014-04-21','11:35:00',3.92),('8784','2014-04-21','11:40:00',3.95),('8784','2014-04-21','11:45:00',3.98),('8784','2014-04-21','11:50:00',4.01),('8784','2014-04-21','11:55:00',4.04),('8784','2014-04-21','12:00:00',4.07),('8784','2014-04-21','12:05:00',4.09),('8784','2014-04-21','12:10:00',4.13),('8784','2014-04-21','12:15:00',4.17),('8784','2014-04-21','12:20:00',4.2),('8784','2014-04-21','12:25:00',4.21),('8784','2014-04-21','12:30:00',4.23),('8784','2014-04-21','12:35:00',4.22),('8784','2014-04-21','12:40:00',4.24),('8784','2014-04-21','12:45:00',4.24),('8784','2014-04-21','12:50:00',4.26),('8784','2014-04-21','12:55:00',4.23),('8784','2014-04-21','13:00:00',4.25),('8784','2014-04-21','13:05:00',4.27),('8784','2014-04-21','13:10:00',4.25),('8784','2014-04-21','13:15:00',4.25),('8784','2014-04-21','13:20:00',4.24),('8784','2014-04-21','13:25:00',4.24),('8784','2014-04-21','13:30:00',4.23),('8784','2014-04-21','13:35:00',4.21),('8784','2014-04-21','13:40:00',4.21),('8784','2014-04-21','13:45:00',4.25),('8784','2014-04-21','13:50:00',4.25),('8784','2014-04-21','13:55:00',4.24),('8784','2014-04-21','14:00:00',4.21),('8784','2014-04-21','14:05:00',4.2),('8784','2014-04-21','14:10:00',4.19),('8784','2014-04-21','14:15:00',4.18),('8784','2014-04-21','14:20:00',4.16),('8784','2014-04-21','14:25:00',4.12),('8784','2014-04-21','14:30:00',4.1),('8784','2014-04-21','14:35:00',4.07),('8784','2014-04-21','14:40:00',4.02),('8784','2014-04-21','14:45:00',3.98),('8784','2014-04-21','14:50:00',3.95),('8784','2014-04-21','14:55:00',3.92),('8784','2014-04-21','15:00:00',3.88),('8784','2014-04-21','15:05:00',3.85),('8784','2014-04-21','15:10:00',3.79),('8784','2014-04-21','15:15:00',3.74),('8784','2014-04-21','15:20:00',3.68),('8784','2014-04-21','15:25:00',3.63),('8784','2014-04-21','15:30:00',3.57),('8784','2014-04-21','15:35:00',3.52),('8784','2014-04-21','15:40:00',3.47),('8784','2014-04-21','15:45:00',3.41),('8784','2014-04-21','15:50:00',3.33),('8784','2014-04-21','15:55:00',3.28),('8784','2014-04-21','16:00:00',3.21),('8784','2014-04-21','16:05:00',3.2),('8784','2014-04-21','16:10:00',3.14),('8784','2014-04-21','16:15:00',3.08),('8784','2014-04-21','16:20:00',3.02),('8784','2014-04-21','16:25:00',2.63),('8784','2014-04-21','16:30:00',2.84),('8784','2014-04-21','16:35:00',2.78),('8784','2014-04-21','16:40:00',2.71),('8784','2014-04-21','16:45:00',2.63),('8784','2014-04-21','16:50:00',2.55),('8784','2014-04-21','16:55:00',2.47),('8784','2014-04-21','17:00:00',2.38),('8784','2014-04-21','17:05:00',2.32),('8784','2014-04-21','17:10:00',2.23),('8784','2014-04-21','17:15:00',2.14),('8784','2014-04-21','17:20:00',2.03),('8784','2014-04-21','17:25:00',1.98),('8784','2014-04-21','17:30:00',1.91),('8784','2014-04-21','17:35:00',1.83),('8784','2014-04-21','17:40:00',1.65),('8784','2014-04-21','17:45:00',1.64),('8784','2014-04-21','17:50:00',1.56),('8784','2014-04-21','17:55:00',1.46),('8784','2014-04-21','18:00:00',1.36),('8784','2014-04-21','18:05:00',1.27),('8784','2014-04-21','18:10:00',1.18),('8784','2014-04-21','18:15:00',1.1),('8784','2014-04-21','18:20:00',1.02),('8784','2013-12-04','09:35:00',1.18),('8784','2013-12-04','09:40:00',1.27),('8784','2013-12-04','09:45:00',1.33),('8784','2013-12-04','09:50:00',1.38),('8784','2013-12-04','09:55:00',1.42),('8784','2013-12-04','10:00:00',1.57),('8784','2013-12-04','10:05:00',1.71),('8784','2013-12-04','10:10:00',1.78),('8784','2013-12-04','10:15:00',1.85),('8784','2013-12-04','10:20:00',1.91),('8784','2013-12-04','10:25:00',1.95),('8784','2013-12-04','10:30:00',1.99),('8784','2013-12-04','10:35:00',2.04),('8784','2013-12-04','10:40:00',2.07),('8784','2013-12-04','10:45:00',2.1),('8784','2013-12-04','10:50:00',2.15),('8784','2013-12-04','10:55:00',2.13),('8784','2013-12-04','11:00:00',2.13),('8784','2013-12-04','11:05:00',2.12),('8784','2013-12-04','11:10:00',2.13),('8784','2013-12-04','11:15:00',2.15),('8784','2013-12-04','11:20:00',2.17),('8784','2013-12-04','11:25:00',2.19),('8784','2013-12-04','11:30:00',2.19),('8784','2013-12-04','11:35:00',2.18),('8784','2013-12-04','11:40:00',2.16),('8784','2013-12-04','11:45:00',2.17),('8784','2013-12-04','11:50:00',2.14),('8784','2013-12-04','11:55:00',2.18),('8784','2013-12-04','12:00:00',2.17),('8784','2013-12-04','12:05:00',2.17),('8784','2013-12-04','12:10:00',2.16),('8784','2013-12-04','12:15:00',2.14),('8784','2013-12-04','12:20:00',2.09),('8784','2013-12-04','12:25:00',2.09),('8784','2013-12-04','12:30:00',1.92),('8784','2013-12-04','12:35:00',1.98),('8784','2013-12-04','12:40:00',2.07),('8784','2013-12-04','12:45:00',2.04),('8784','2013-12-04','12:50:00',2),('8784','2013-12-04','12:55:00',1.96),('8784','2013-12-04','13:00:00',1.93),('8784','2013-12-04','13:05:00',1.93),('8784','2013-12-04','13:10:00',1.9),('8784','2013-12-04','13:15:00',1.85),('8784','2013-12-04','13:20:00',1.8),('8784','2013-12-04','13:25:00',1.74),('8784','2013-12-04','13:30:00',1.74),('8784','2013-12-04','13:35:00',1.69),('8784','2013-12-04','13:40:00',1.66),('8784','2013-12-04','13:45:00',1.64),('8784','2013-12-04','13:50:00',1.58),('8784','2013-12-04','13:55:00',1.51),('8784','2013-12-04','14:00:00',1.49),('8784','2013-12-04','14:05:00',1.4),('8784','2013-12-04','14:10:00',1.35),('8784','2013-12-04','14:15:00',1.37),('8784','2013-12-04','14:20:00',1.27),('8784','2013-12-04','14:25:00',1.25),('8784','2013-12-04','14:30:00',1.22),('8784','2013-12-04','14:35:00',1.17),('8784','2013-12-04','14:40:00',1.1),('8784','2013-12-04','14:45:00',1.04),('8784','2013-12-03','09:45:00',1.11),('8784','2013-12-03','09:50:00',1.18),('8784','2013-12-03','09:55:00',1.11),('8784','2013-12-03','10:00:00',1.54),('8784','2013-12-03','10:05:00',1.72),('8784','2013-12-03','10:10:00',1.77),('8784','2013-12-03','10:15:00',1.81),('8784','2013-12-03','10:20:00',1.85),('8784','2013-12-03','10:25:00',1.91),('8784','2013-12-03','10:30:00',1.94),('8784','2013-12-03','10:35:00',2),('8784','2013-12-03','10:40:00',2.03),('8784','2013-12-03','10:45:00',2.06),('8784','2013-12-03','10:50:00',2.13),('8784','2013-12-03','10:55:00',2.13),('8784','2013-12-03','11:00:00',2.14),('8784','2013-12-03','11:05:00',2.15),('8784','2013-12-03','11:10:00',2.16),('8784','2013-12-03','11:15:00',2.15),('8784','2013-12-03','11:20:00',2.14),('8784','2013-12-03','11:25:00',2.1),('8784','2013-12-03','11:30:00',2.16),('8784','2013-12-03','11:35:00',2.2),('8784','2013-12-03','11:40:00',2.2),('8784','2013-12-03','11:45:00',2.21),('8784','2013-12-03','11:50:00',2.19),('8784','2013-12-03','11:55:00',2.23),('8784','2013-12-03','12:00:00',2.1),('8784','2013-12-03','12:05:00',2.22),('8784','2013-12-03','12:10:00',2.24),('8784','2013-12-03','12:15:00',2.29),('8784','2013-12-03','12:20:00',2.24),('8784','2013-12-03','12:25:00',2.24),('8784','2013-12-03','12:30:00',2.24),('8784','2013-12-03','12:35:00',2.31),('8784','2013-12-03','12:40:00',2.41),('8784','2013-12-03','12:45:00',2.47),('8784','2013-12-03','12:50:00',2.54),('8784','2013-12-03','12:55:00',2.64),('8784','2013-12-03','13:00:00',2.59),('8784','2013-12-03','13:05:00',2.61),('8784','2013-12-03','13:10:00',2.68),('8784','2013-12-03','13:15:00',2.58),('8784','2013-12-03','13:20:00',2.54),('8784','2013-12-03','13:25:00',2.41),('8784','2013-12-03','13:30:00',2.28),('8784','2013-12-03','13:35:00',2.18),('8784','2013-12-03','13:40:00',2.07),('8784','2013-12-03','13:45:00',1.91),('8784','2013-12-03','13:50:00',1.82),('8784','2013-12-03','13:55:00',1.69),('8784','2013-12-03','14:00:00',1.61),('8784','2013-12-03','14:05:00',1.49),('8784','2013-12-03','14:10:00',1.32),('8784','2013-12-03','14:15:00',1.34),('8784','2013-12-03','14:20:00',1.1),('8784','2013-12-03','14:25:00',1.06),('8784','2013-12-03','14:30:00',1.12),('8784','2013-12-03','14:35:00',1.13),('8784','2013-12-03','14:40:00',1.11),('8784','2013-12-03','14:45:00',1.04),('8784','2013-12-01','11:35:00',1.18),('8784','2013-12-01','11:40:00',1.19),('8784','2013-12-01','11:55:00',1.32),('8784','2013-12-01','12:00:00',1.17),('8784','2013-12-01','12:05:00',1.32),('8784','2013-12-01','12:10:00',1.61),('8784','2013-12-01','12:15:00',1.21),('8784','2013-11-30','09:20:00',1.01),('8784','2013-11-30','09:25:00',1.07),('8784','2013-11-30','09:30:00',1.17),('8784','2013-11-30','09:35:00',1.32),('8784','2013-11-30','09:40:00',1.62),('8784','2013-11-30','09:45:00',1.32),('8784','2013-11-30','09:50:00',1.17),('8784','2013-11-30','09:55:00',1.15),('8784','2013-11-30','10:00:00',1.15),('8784','2013-11-30','10:05:00',1.06),('8784','2013-11-30','10:10:00',1.03),('8784','2013-11-30','10:15:00',1.12),('8784','2013-11-30','10:20:00',1.23),('8784','2013-11-30','10:25:00',1.19),('8784','2013-11-30','10:30:00',1.25),('8784','2013-11-30','10:35:00',1.37),('8784','2013-11-30','10:40:00',1.49),('8784','2013-11-30','10:45:00',1.4),('8784','2013-11-30','10:50:00',1.29),('8784','2013-11-30','10:55:00',1.17),('8784','2013-11-30','11:00:00',1.13),('8784','2013-11-30','11:05:00',1.34),('8784','2013-11-30','11:10:00',1.42),('8784','2013-11-30','11:15:00',1.37),('8784','2013-11-30','11:20:00',1.29),('8784','2013-11-30','11:25:00',1.33),('8784','2013-11-30','11:30:00',1.2),('8784','2013-11-30','11:35:00',1.13),('8784','2013-11-30','11:40:00',1.07),('8784','2013-11-29','09:30:00',1.18),('8784','2013-11-29','09:35:00',1.29),('8784','2013-11-29','09:40:00',1.35),('8784','2013-11-29','09:45:00',1.38),('8784','2013-11-29','09:50:00',1.41),('8784','2013-11-29','09:55:00',1.56),('8784','2013-11-29','10:00:00',1.72),('8784','2013-11-29','10:05:00',1.82),('8784','2013-11-29','10:10:00',1.88),('8784','2013-11-29','10:15:00',1.92),('8784','2013-11-29','10:20:00',1.96),('8784','2013-11-29','10:25:00',2.02),('8784','2013-11-29','10:30:00',2.06),('8784','2013-11-29','10:35:00',2.09),('8784','2013-11-29','10:40:00',2.13),('8784','2013-11-29','10:45:00',2.18),('8784','2013-11-29','10:50:00',2.21),('8784','2013-11-29','10:55:00',2.1),('8784','2013-11-29','11:00:00',2.15),('8784','2013-11-29','11:05:00',2.16),('8784','2013-11-29','11:10:00',2.19),('8784','2013-11-29','11:15:00',2.17),('8784','2013-11-29','11:20:00',2.2),('8784','2013-11-29','11:25:00',2.25),('8784','2013-11-29','11:30:00',2.26),('8784','2013-11-29','11:35:00',2.27),('8784','2013-11-29','11:40:00',2.28),('8784','2013-11-29','11:45:00',2.28),('8784','2013-11-29','11:50:00',2.28),('8784','2013-11-29','11:55:00',2.28),('8784','2013-11-29','12:00:00',2.26),('8784','2013-11-29','12:05:00',2.22),('8784','2013-11-29','12:10:00',2.22),('8784','2013-11-29','12:15:00',2.21),('8784','2013-11-29','12:20:00',2.2),('8784','2013-11-29','12:25:00',2.09),('8784','2013-11-29','12:30:00',2.14),('8784','2013-11-29','12:35:00',2.11),('8784','2013-11-29','12:40:00',2.09),('8784','2013-11-29','12:45:00',2.11),('8784','2013-11-29','12:50:00',2.09),('8784','2013-11-29','12:55:00',2.06),('8784','2013-11-29','13:00:00',2.03),('8784','2013-11-29','13:05:00',1.96),('8784','2013-11-29','13:10:00',1.92),('8784','2013-11-29','13:15:00',1.92),('8784','2013-11-29','13:20:00',1.87),('8784','2013-11-29','13:25:00',1.84),('8784','2013-11-29','13:30:00',1.75),('8784','2013-11-29','13:35:00',1.74),('8784','2013-11-29','13:40:00',1.72),('8784','2013-11-29','13:45:00',1.68),('8784','2013-11-29','13:50:00',1.59),('8784','2013-11-29','13:55:00',1.58),('8784','2013-11-29','14:00:00',1.53),('8784','2013-11-29','14:05:00',1.46),('8784','2013-11-29','14:10:00',1.42),('8784','2013-11-29','14:15:00',1.38),('8784','2013-11-29','14:20:00',1.29),('8784','2013-11-29','14:25:00',1.27),('8784','2013-11-29','14:30:00',1.23),('8784','2013-11-29','14:35:00',1.16),('8784','2013-11-29','14:40:00',1.07),('8784','2013-11-29','14:45:00',1.05),('8784','2013-11-28','12:55:00',1.13),('8784','2014-04-20','07:50:00',1.14),('8784','2014-04-20','07:55:00',1.25),('8784','2014-04-20','08:00:00',1.21),('8784','2014-04-20','08:05:00',1.26),('8784','2014-04-20','08:10:00',1.37),('8784','2014-04-20','08:15:00',1.52),('8784','2014-04-20','08:20:00',1.91),('8784','2014-04-20','08:25:00',2.34),('8784','2014-04-20','08:30:00',2.44),('8784','2014-04-20','08:35:00',2.19),('8784','2014-04-20','08:45:00',2.06),('8784','2014-04-20','08:50:00',1.43),('8784','2014-04-20','08:55:00',1.35),('8784','2014-04-20','09:00:00',1.79),('8784','2014-04-20','09:05:00',1.09),('8784','2014-04-20','09:10:00',2.53),('8784','2014-04-20','09:15:00',2.69),('8784','2014-04-20','09:20:00',2.84),('8784','2014-04-20','09:25:00',3.18),('8784','2014-04-20','09:30:00',3.66),('8784','2014-04-20','09:35:00',3.28),('8784','2014-04-20','09:40:00',2.07),('8784','2014-04-20','09:45:00',1.45),('8784','2014-04-20','09:50:00',1.73),('8784','2014-04-20','09:55:00',1.96),('8784','2014-04-20','10:00:00',2.39),('8784','2014-04-20','10:05:00',3.01),('8784','2014-04-20','10:10:00',2.88),('8784','2014-04-20','10:15:00',3.11),('8784','2014-04-20','10:20:00',3.19),('8784','2014-04-20','10:25:00',2.99),('8784','2014-04-20','10:30:00',2.78),('8784','2014-04-20','10:35:00',2.96),('8784','2014-04-20','10:40:00',2.79),('8784','2014-04-20','10:45:00',2.9),('8784','2014-04-20','10:50:00',3.1),('8784','2014-04-20','10:55:00',3.06),('8784','2014-04-20','11:00:00',3.56),('8784','2014-04-20','11:05:00',3.53),('8784','2014-04-20','11:10:00',3.67),('8784','2014-04-20','11:15:00',2.69),('8784','2014-04-20','11:20:00',2.8),('8784','2014-04-20','11:25:00',4.28),('8784','2014-04-20','11:30:00',4.31),('8784','2014-04-20','11:35:00',4.44),('8784','2014-04-20','11:40:00',2.42),('8784','2014-04-20','11:45:00',1.6),('8784','2014-04-20','11:50:00',2.99),('8784','2014-04-20','11:55:00',3.96),('8784','2014-04-20','12:00:00',4.3),('8784','2014-04-20','12:05:00',4.5),('8784','2014-04-20','12:10:00',2.82),('8784','2014-04-20','12:15:00',1.46),('8784','2014-04-20','12:20:00',3.34),('8784','2014-04-20','12:25:00',2.81),('8784','2014-04-20','12:30:00',4.46),('8784','2014-04-20','12:35:00',4.51),('8784','2014-04-20','12:40:00',4.51),('8784','2014-04-20','12:45:00',4.46),('8784','2014-04-20','12:50:00',4.48),('8784','2014-04-20','12:55:00',4.45),('8784','2014-04-20','13:00:00',4.47),('8784','2014-04-20','13:05:00',4.43),('8784','2014-04-20','13:10:00',4.4),('8784','2014-04-20','13:15:00',4.45),('8784','2014-04-20','13:20:00',4.39),('8784','2014-04-20','13:25:00',4.38),('8784','2014-04-20','13:30:00',4.39),('8784','2014-04-20','13:35:00',4.4),('8784','2014-04-20','13:40:00',4.4),('8784','2014-04-20','13:45:00',4.39),('8784','2014-04-20','13:50:00',4.34),('8784','2014-04-20','13:55:00',4.34),('8784','2014-04-20','14:00:00',4.26),('8784','2014-04-20','14:05:00',4.3),('8784','2014-04-20','14:10:00',4.32),('8784','2014-04-20','14:15:00',4.48),('8784','2014-04-20','14:20:00',3.31),('8784','2014-04-20','14:25:00',3.28),('8784','2014-04-20','14:30:00',3.09),('8784','2014-04-20','14:35:00',2.63),('8784','2014-04-20','14:40:00',2.62),('8784','2014-04-20','14:45:00',2.86),('8784','2014-04-20','14:50:00',2.77),('8784','2014-04-20','14:55:00',3.1),('8784','2014-04-20','15:00:00',4.1),('8784','2014-04-20','15:05:00',3.51),('8784','2014-04-20','15:10:00',3.95),('8784','2014-04-20','15:15:00',3.9),('8784','2014-04-20','15:20:00',3.79),('8784','2014-04-20','15:25:00',3.71),('8784','2014-04-20','15:30:00',3.65),('8784','2014-04-20','15:35:00',3.54),('8784','2014-04-20','15:40:00',3.6),('8784','2014-04-20','15:45:00',2.62),('8784','2014-04-20','15:50:00',2.65),('8784','2014-04-20','15:55:00',3.47),('8784','2014-04-20','16:00:00',3.3),('8784','2014-04-20','16:05:00',3.24),('8784','2014-04-20','16:10:00',3.2),('8784','2014-04-20','16:15:00',3.17),('8784','2014-04-20','16:20:00',3.13),('8784','2014-04-20','16:25:00',2.8),('8784','2014-04-20','16:30:00',3.06),('8784','2014-04-20','16:35:00',2.81),('8784','2014-04-20','16:40:00',2.36),('8784','2014-04-20','16:45:00',2.11),('8784','2014-04-20','16:50:00',2.52),('8784','2014-04-20','16:55:00',2.63),('8784','2014-04-20','17:00:00',2.49),('8784','2014-04-20','17:05:00',2.37),('8784','2014-04-20','17:10:00',2.24),('8784','2014-04-20','17:15:00',2.14),('8784','2014-04-20','17:20:00',2.06),('8784','2014-04-20','17:25:00',1.96),('8784','2014-04-20','17:30:00',1.89),('8784','2014-04-20','17:35:00',1.8),('8784','2014-04-20','17:40:00',1.71),('8784','2014-04-20','17:45:00',1.61),('8784','2014-04-20','17:50:00',1.52),('8784','2014-04-20','17:55:00',1.43),('8784','2014-04-20','18:00:00',1.35),('8784','2014-04-20','18:05:00',1.26),('8784','2014-04-20','18:10:00',1.17),('8784','2014-04-20','18:15:00',1.04),('8784','2013-11-27','09:50:00',1.05),('8784','2013-11-27','09:55:00',1.25),('8784','2013-11-27','10:00:00',1.23),('8784','2013-11-27','10:05:00',1.26),('8784','2013-11-27','10:10:00',1.25),('8784','2013-11-27','10:15:00',1.25),('8784','2013-11-27','10:20:00',1.17),('8784','2013-11-27','10:25:00',1.08),('8784','2013-11-27','10:30:00',1.08),('8784','2013-11-27','10:35:00',1.14),('8784','2013-11-27','10:40:00',1.29),('8784','2013-11-27','10:45:00',1.43),('8784','2013-11-27','10:50:00',1.34),('8784','2013-11-27','10:55:00',1.35),('8784','2013-11-27','11:00:00',1.4),('8784','2013-11-27','11:05:00',1.44),('8784','2013-11-27','11:10:00',1.83),('8784','2013-11-27','11:15:00',1.38),('8784','2013-11-27','11:20:00',1.41),('8784','2013-11-27','11:25:00',1.45),('8784','2013-11-27','11:30:00',2.22),('8784','2013-11-27','11:35:00',2.06),('8784','2013-11-27','11:40:00',1.59),('8784','2013-11-27','11:45:00',1.57),('8784','2013-11-27','11:50:00',2.31),('8784','2013-11-27','11:55:00',2.56),('8784','2013-11-27','12:00:00',2.64),('8784','2013-11-27','12:05:00',2.02),('8784','2013-11-27','12:10:00',1.37),('8784','2013-11-27','12:15:00',1.67),('8784','2013-11-27','12:20:00',2.55),('8784','2013-11-27','12:25:00',1.64),('8784','2013-11-27','12:30:00',1.34),('8784','2013-11-27','12:35:00',2.49),('8784','2013-11-27','12:40:00',1.34),('8784','2013-11-27','12:55:00',1.01),('8784','2013-11-27','13:00:00',1.08),('8784','2013-11-27','13:05:00',1.07),('8784','2013-11-27','13:10:00',1.07),('8784','2013-11-27','13:15:00',1.05),('8784','2013-11-27','13:20:00',1.03),('8784','2013-11-27','13:25:00',1.01),('8784','2013-11-27','13:30:00',1.02),('8784','2013-11-27','13:40:00',1.01),('8784','2013-11-26','09:35:00',1.1),('8784','2013-11-26','09:40:00',1.31),('8784','2013-11-26','09:50:00',1.07),('8784','2013-11-26','09:55:00',1.68),('8784','2013-11-26','10:00:00',1.26),('8784','2013-11-26','10:05:00',1.49),('8784','2013-11-26','10:10:00',1.25),('8784','2013-11-26','10:20:00',1.35),('8784','2013-11-26','10:25:00',1.6),('8784','2013-11-26','10:30:00',1.88),('8784','2013-11-26','10:35:00',2.3),('8784','2013-11-26','10:40:00',2.33),('8784','2013-11-26','10:45:00',2.41),('8784','2013-11-26','10:50:00',2.37),('8784','2013-11-26','10:55:00',2.23),('8784','2013-11-26','11:00:00',2.48),('8784','2013-11-26','11:05:00',2.34),('8784','2013-11-26','11:10:00',2.77),('8784','2013-11-26','11:15:00',2.97),('8784','2013-11-26','11:20:00',2.35),('8784','2013-11-26','11:25:00',2.69),('8784','2013-11-26','11:30:00',2.61),('8784','2013-11-26','11:35:00',2.03),('8784','2013-11-26','11:40:00',2.57),('8784','2013-11-26','11:45:00',2.91),('8784','2013-11-26','11:50:00',2.58),('8784','2013-11-26','11:55:00',1.9),('8784','2013-11-26','12:00:00',1.16),('8784','2013-11-26','12:05:00',1.47),('8784','2013-11-26','12:15:00',1.07),('8784','2013-11-26','12:20:00',2.44),('8784','2013-11-26','12:25:00',2.27),('8784','2013-11-26','12:30:00',2.27),('8784','2013-11-26','12:35:00',2.31),('8784','2013-11-26','12:40:00',2.35),('8784','2013-11-26','12:45:00',2.3),('8784','2013-11-26','12:50:00',2.26),('8784','2013-11-26','12:55:00',2.22),('8784','2013-11-26','13:00:00',2.18),('8784','2013-11-26','13:05:00',2.16),('8784','2013-11-26','13:10:00',2.12),('8784','2013-11-26','13:15:00',1.99),('8784','2013-11-26','13:20:00',2.02),('8784','2013-11-26','13:25:00',2.01),('8784','2013-11-26','13:30:00',1.95),('8784','2013-11-26','13:35:00',1.93),('8784','2013-11-26','13:40:00',1.9),('8784','2013-11-26','13:45:00',1.88),('8784','2013-11-26','13:50:00',1.89),('8784','2013-11-26','13:55:00',1.81),('8784','2013-11-26','14:00:00',2.1),('8784','2013-11-26','14:05:00',1.9),('8784','2013-11-26','14:10:00',2.11),('8784','2013-11-26','14:15:00',2.45),('8784','2013-11-26','14:20:00',2.19),('8784','2013-11-26','14:25:00',1.46),('8784','2013-11-26','14:30:00',1.01),('8784','2013-11-26','14:35:00',1.27),('8784','2013-11-26','14:40:00',1.34),('8784','2013-11-26','14:45:00',1.31),('8784','2013-11-26','14:50:00',1.33),('8784','2013-11-26','14:55:00',1.58),('8784','2013-11-26','15:00:00',1.43),('8784','2013-11-26','15:05:00',1.21),('8784','2013-11-26','15:10:00',1.04),('8784','2013-11-25','09:00:00',1.08),('8784','2013-11-25','09:05:00',1.23),('8784','2013-11-25','09:10:00',1.25),('8784','2013-11-25','09:15:00',1.35),('8784','2013-11-25','09:20:00',1.52),('8784','2013-11-25','09:25:00',1.32),('8784','2013-11-25','09:30:00',1.19),('8784','2013-11-25','09:35:00',1.47),('8784','2013-11-25','09:40:00',1.52),('8784','2013-11-25','09:45:00',1.01),('8784','2013-11-25','09:50:00',1.14),('8784','2013-11-25','09:55:00',1.26),('8784','2013-11-25','10:00:00',1.23),('8784','2013-11-25','10:05:00',1.9),('8784','2013-11-25','10:10:00',1.35),('8784','2013-11-25','10:15:00',2.01),('8784','2013-11-25','10:20:00',1.18),('8784','2013-11-25','10:25:00',1.41),('8784','2013-11-25','10:30:00',1.73),('8784','2013-11-25','10:35:00',2.13),('8784','2013-11-25','10:40:00',2.85),('8784','2013-11-25','10:45:00',2.63),('8784','2013-11-25','10:50:00',2.12),('8784','2013-11-25','10:55:00',1.75),('8784','2013-11-25','11:00:00',2.18),('8784','2013-11-25','11:05:00',2.54),('8784','2013-11-25','11:10:00',2.96),('8784','2013-11-25','11:15:00',2.67),('8784','2013-11-25','11:20:00',1.17),('8784','2013-11-25','11:25:00',1.25),('8784','2013-11-25','11:30:00',1.41),('8784','2013-11-25','11:35:00',1.2),('8784','2013-11-25','11:40:00',1.08),('8784','2013-11-25','11:45:00',1.18),('8784','2013-11-25','11:50:00',1.35),('8784','2013-11-25','11:55:00',1.18),('8784','2013-11-25','12:00:00',1.48),('8784','2013-11-25','12:05:00',1.48),('8784','2013-11-25','12:10:00',1.98),('8784','2013-11-25','12:15:00',1.62),('8784','2013-11-25','12:20:00',1.39),('8784','2013-11-25','12:25:00',1.43),('8784','2013-11-25','12:30:00',1.26),('8784','2013-11-25','12:35:00',1.17),('8784','2013-11-25','12:40:00',2.53),('8784','2013-11-25','12:45:00',2.48),('8784','2013-11-25','12:50:00',2.01),('8784','2013-11-25','12:55:00',2.18),('8784','2013-11-25','13:00:00',2.72),('8784','2013-11-25','13:05:00',2.57),('8784','2013-11-25','13:10:00',1.76),('8784','2013-11-25','13:15:00',1.67),('8784','2013-11-25','13:20:00',2.86),('8784','2013-11-25','13:25:00',2.73),('8784','2013-11-25','13:30:00',1.5),('8784','2013-11-25','13:35:00',1.04),('8784','2013-11-24','09:55:00',1.25),('8784','2013-11-24','10:00:00',1.5),('8784','2013-11-24','10:05:00',1.59),('8784','2013-11-24','10:10:00',1.62),('8784','2013-11-24','10:15:00',1.48),('8784','2013-11-24','10:20:00',1.31),('8784','2013-11-24','10:25:00',1.79),('8784','2013-11-24','10:30:00',1.54),('8784','2013-11-24','10:35:00',1.33),('8784','2013-11-24','10:40:00',1.09),('8784','2013-11-24','10:45:00',1.01),('8784','2013-11-24','10:50:00',1.05),('8784','2013-11-24','10:55:00',1.16),('8784','2013-11-24','11:00:00',1.21),('8784','2013-11-24','11:05:00',1.27),('8784','2013-11-24','11:10:00',1.34),('8784','2013-11-24','11:15:00',1.38),('8784','2013-11-24','11:20:00',1.52),('8784','2013-11-24','11:25:00',1.53),('8784','2013-11-24','11:30:00',1.46),('8784','2013-11-24','11:35:00',1.26),('8784','2013-11-24','11:40:00',1.17),('8784','2013-11-24','11:45:00',1.17),('8784','2013-11-24','11:50:00',1.29),('8784','2013-11-24','11:55:00',1.17),('8784','2013-11-24','12:25:00',1.03),('8784','2013-11-24','12:30:00',1.02),('8784','2013-11-24','12:35:00',1.01),('8784','2013-11-24','12:40:00',1.03),('8784','2013-11-24','13:00:00',1.1),('8784','2013-11-24','13:05:00',1.37),('8784','2013-11-24','13:10:00',1.44),('8784','2013-11-24','13:15:00',1.4),('8784','2013-11-24','13:20:00',1.17),('8784','2013-11-24','13:25:00',1),('8784','2013-11-23','10:15:00',1.15),('8784','2013-11-23','10:20:00',1.2),('8784','2013-11-23','10:25:00',1.53),('8784','2013-11-23','10:30:00',1.65),('8784','2013-11-23','10:35:00',1.04),('8784','2013-11-23','10:40:00',2.34),('8784','2013-11-23','13:20:00',1.03),('8784','2013-11-23','13:25:00',1.26),('8784','2013-11-23','13:30:00',1.15),('8784','2013-11-23','13:35:00',1.47),('8784','2013-11-23','13:40:00',1.25),('8784','2013-11-23','13:55:00',1.08),('8784','2013-11-23','14:00:00',1.14),('8784','2013-11-23','14:05:00',1.08),('8784','2013-11-21','09:45:00',1.46),('8784','2013-11-21','09:50:00',1.23),('8784','2013-11-21','09:55:00',1.66),('8784','2013-11-21','10:00:00',1.63),('8784','2013-11-21','10:05:00',1.98),('8784','2013-11-21','10:10:00',1.84),('8784','2013-11-21','10:15:00',2.18),('8784','2013-11-21','10:20:00',1.98),('8784','2013-11-21','10:25:00',1.33),('8784','2013-11-21','10:30:00',2.13),('8784','2013-11-21','10:35:00',2.27),('8784','2013-11-21','10:40:00',2.52),('8784','2013-11-21','10:45:00',1.78),('8784','2013-11-21','11:15:00',1.26),('8784','2013-11-21','11:20:00',1.3),('8784','2013-11-21','11:25:00',1.32),('8784','2013-11-21','11:30:00',1.91),('8784','2013-11-21','11:35:00',1.64),('8784','2013-11-21','11:40:00',1.91),('8784','2013-11-21','11:45:00',1.9),('8784','2013-11-21','11:50:00',2.19),('8784','2013-11-21','11:55:00',2.23),('8784','2013-11-21','12:00:00',1.07),('8784','2013-11-21','12:05:00',2.41),('8784','2013-11-21','12:10:00',2.39),('8784','2013-11-21','12:15:00',2.39),('8784','2013-11-21','12:20:00',2.41),('8784','2013-11-21','12:25:00',2.41),('8784','2013-11-21','12:30:00',2.62),('8784','2013-11-21','12:35:00',2.55),('8784','2013-11-21','12:40:00',2.61),('8784','2013-11-21','12:45:00',2.69),('8784','2013-11-21','12:50:00',2.66),('8784','2013-11-21','12:55:00',2.72),('8784','2013-11-21','13:00:00',2.78),('8784','2013-11-21','13:05:00',2.55),('8784','2013-11-21','13:10:00',2.38),('8784','2013-11-21','13:15:00',2.58),('8784','2013-11-21','13:20:00',2.38),('8784','2013-11-21','13:25:00',1.86),('8784','2013-11-21','13:40:00',1.72),('8784','2013-11-21','13:45:00',2.08),('8784','2013-11-21','13:50:00',1.19),('8784','2013-11-21','13:55:00',1.89),('8784','2013-11-21','14:00:00',2.01),('8784','2013-11-21','14:05:00',1.11),('8784','2013-11-21','14:25:00',1.01),('8784','2013-11-21','14:40:00',1.25),('8784','2013-11-21','14:45:00',1.18),('8784','2013-11-21','14:50:00',1.13),('8784','2013-11-21','14:55:00',1),('8784','2013-11-20','09:20:00',1.13),('8784','2013-11-20','09:25:00',1.26),('8784','2013-11-20','09:30:00',1.08),('8784','2013-11-20','10:00:00',1.52),('8784','2013-11-20','10:15:00',1.92),('8784','2013-11-20','11:20:00',1.05),('8784','2013-11-20','11:25:00',1.26),('8784','2013-11-20','11:30:00',1.17),('8784','2013-11-20','11:35:00',1.15),('8784','2013-11-20','11:40:00',1.24),('8784','2013-11-20','11:45:00',3.55),('8784','2013-11-20','11:50:00',3.49),('8784','2013-11-20','11:55:00',1.88),('8784','2013-11-20','12:15:00',1.06),('8784','2013-11-20','12:20:00',1.76),('8784','2013-11-20','12:25:00',1.28),('8784','2013-11-20','12:40:00',1.01),('8784','2013-11-20','12:45:00',1.17),('8784','2013-11-20','12:50:00',1.86),('8784','2013-11-20','12:55:00',2.41),('8784','2013-11-20','13:00:00',1.66),('8784','2013-11-20','13:05:00',1.57),('8784','2013-11-20','13:20:00',1.42),('8784','2013-11-20','13:25:00',1.24),('8784','2013-11-20','13:35:00',1.06),('8784','2013-11-20','13:45:00',1.27),('8784','2013-11-20','13:50:00',1.77),('8784','2013-11-20','14:25:00',1.31),('8784','2013-11-20','14:45:00',1.15),('8784','2013-11-20','15:05:00',1.06),('8784','2013-11-20','15:10:00',1.03),('8784','2013-11-19','09:40:00',1.6),('8784','2013-11-19','09:45:00',1.63),('8784','2013-11-19','10:00:00',1.13),('8784','2013-11-19','10:05:00',1.2),('8784','2013-11-19','10:50:00',1.46),('8784','2013-11-19','11:20:00',2.34),('8784','2013-11-19','11:25:00',1.95),('8784','2013-11-19','11:30:00',2.05),('8784','2013-11-19','11:35:00',2.54),('8784','2013-11-19','11:40:00',1.94),('8784','2013-11-19','11:45:00',2.3),('8784','2013-11-19','11:50:00',2.26),('8784','2013-11-19','11:55:00',1.97),('8784','2013-11-19','12:00:00',1.85),('8784','2013-11-19','12:05:00',2.29),('8784','2013-11-19','12:10:00',2.21),('8784','2013-11-19','12:15:00',2.19),('8784','2013-11-19','12:20:00',1.07),('8784','2013-11-19','12:30:00',1.52),('8784','2013-11-19','12:40:00',1.28),('8784','2013-11-19','12:45:00',2.06),('8784','2013-11-19','12:50:00',2.04),('8784','2013-11-19','12:55:00',2.67),('8784','2013-11-19','13:00:00',1.1),('8784','2013-11-19','13:05:00',1.1),('8784','2013-11-19','13:10:00',1.12),('8784','2013-11-19','13:15:00',2.06),('8784','2013-11-19','13:20:00',1.72),('8784','2013-11-19','15:25:00',1.16),('8784','2013-11-19','15:30:00',1.37),('8784','2013-11-18','09:20:00',1.19),('8784','2013-11-18','09:25:00',1.37),('8784','2013-11-18','09:30:00',1.27),('8784','2013-11-18','09:35:00',1.63),('8784','2013-11-18','09:40:00',1.26),('8784','2013-11-18','09:45:00',1.17),('8784','2013-11-18','09:50:00',1.02),('8784','2013-11-18','09:55:00',1.09),('8784','2013-11-18','10:00:00',1.24),('8784','2013-11-18','10:05:00',1.38),('8784','2013-11-18','10:10:00',1.63),('8784','2013-11-18','10:15:00',1.72),('8784','2013-11-18','10:20:00',1.41),('8784','2013-11-18','10:25:00',1.36),('8784','2013-11-18','10:30:00',1.25),('8784','2013-11-18','10:35:00',1.25),('8784','2013-11-18','10:40:00',1.31),('8784','2013-11-18','10:45:00',1.35),('8784','2013-11-18','10:50:00',1.28),('8784','2013-11-18','10:55:00',1.14),('8784','2013-11-18','11:00:00',1.04),('8784','2013-11-18','11:25:00',1.02),('8784','2013-11-18','11:30:00',1.13),('8784','2013-11-18','11:35:00',1.2),('8784','2013-11-18','11:40:00',1.23),('8784','2013-11-18','11:45:00',1.25),('8784','2013-11-18','11:50:00',1.32),('8784','2013-11-18','11:55:00',1.41),('8784','2013-11-18','12:00:00',1.47),('8784','2013-11-18','12:05:00',1.54),('8784','2013-11-18','12:10:00',1.52),('8784','2013-11-18','12:15:00',1.57),('8784','2013-11-18','12:20:00',1.64),('8784','2013-11-18','12:25:00',1.64),('8784','2013-11-18','12:30:00',1.52),('8784','2013-11-18','12:35:00',1.35),('8784','2013-11-18','12:40:00',1.18),('8784','2013-11-18','12:45:00',1.06),('8784','2013-11-18','13:10:00',1.09),('8784','2013-11-18','13:15:00',1.03),('8784','2013-11-18','13:35:00',1.18),('8784','2013-11-18','13:40:00',1.23),('8784','2013-11-18','13:45:00',1.14),('8784','2013-11-18','13:50:00',1.08),('8784','2014-04-19','07:35:00',1.1),('8784','2014-04-19','07:40:00',1.25),('8784','2014-04-19','07:55:00',2.05),('8784','2014-04-19','08:00:00',1.59),('8784','2014-04-19','08:05:00',1.23),('8784','2014-04-19','08:10:00',1.62),('8784','2014-04-19','08:15:00',1.2),('8784','2014-04-19','08:20:00',1.31),('8784','2014-04-19','08:25:00',1.73),('8784','2014-04-19','08:30:00',2.35),('8784','2014-04-19','08:35:00',2.51),('8784','2014-04-19','08:40:00',2.16),('8784','2014-04-19','08:45:00',1.93),('8784','2014-04-19','08:50:00',1.54),('8784','2014-04-19','08:55:00',1.05),('8784','2014-04-19','09:20:00',1.15),('8784','2014-04-19','09:25:00',1.61),('8784','2014-04-19','09:30:00',2.3),('8784','2014-04-19','09:35:00',2.09),('8784','2014-04-19','09:40:00',1.28),('8784','2014-04-19','10:35:00',1.02),('8784','2014-04-19','10:40:00',1.33),('8784','2014-04-19','10:45:00',1.26),('8784','2014-04-19','10:50:00',1.34),('8784','2014-04-19','10:55:00',1.72),('8784','2014-04-19','11:00:00',1.73),('8784','2014-04-19','11:05:00',1.37),('8784','2014-04-19','11:10:00',1.36),('8784','2014-04-19','11:15:00',2.09),('8784','2014-04-19','11:20:00',3.31),('8784','2014-04-19','11:25:00',2.72),('8784','2014-04-19','11:30:00',2.77),('8784','2014-04-19','11:35:00',2.74),('8784','2014-04-19','11:40:00',2.56),('8784','2014-04-19','11:45:00',2.23),('8784','2014-04-19','11:50:00',1.79),('8784','2014-04-19','11:55:00',1.14),('8784','2014-04-19','13:15:00',1.67),('8784','2014-04-19','13:20:00',1.39),('8784','2014-04-19','14:30:00',1.52),('8784','2014-04-19','14:35:00',1.64),('8784','2014-04-19','14:40:00',1.97),('8784','2014-04-19','14:45:00',2.06),('8784','2014-04-19','14:50:00',1.3),('8784','2014-04-19','14:55:00',1.17),('8784','2014-04-19','15:00:00',1.55),('8784','2014-04-19','15:05:00',1.3),('8784','2014-04-19','15:25:00',1.21),('8784','2014-04-19','15:30:00',1.15),('8784','2014-04-19','15:45:00',1.15),('8784','2014-04-19','15:50:00',3.84),('8784','2014-04-19','15:55:00',2.83),('8784','2014-04-19','16:00:00',2.43),('8784','2014-04-19','16:05:00',2.24),('8784','2014-04-19','16:10:00',1.97),('8784','2014-04-19','16:15:00',1.83),('8784','2014-04-19','16:20:00',2.15),('8784','2014-04-19','16:25:00',2.09),('8784','2014-04-19','16:30:00',3.01),('8784','2014-04-19','16:35:00',1.63),('8784','2014-04-19','16:40:00',1.2),('8784','2014-04-19','16:45:00',1.08),('8784','2014-04-19','17:05:00',1),('8784','2014-04-19','17:10:00',1.05),('8784','2014-04-19','17:15:00',1.14),('8784','2014-04-19','17:20:00',1.84),('8784','2014-04-19','17:25:00',1.42),('8784','2014-04-19','17:30:00',1.27),('8784','2014-04-19','17:35:00',1.03),('8784','2013-11-17','08:55:00',1.18),('8784','2013-11-17','09:00:00',1.09),('8784','2013-11-17','09:10:00',1.04),('8784','2013-11-17','09:20:00',1.35),('8784','2013-11-17','09:25:00',1.49),('8784','2013-11-17','09:30:00',1.53),('8784','2013-11-17','09:35:00',1.52),('8784','2013-11-17','09:40:00',1.56),('8784','2013-11-17','09:45:00',1.69),('8784','2013-11-17','09:50:00',1.82),('8784','2013-11-17','09:55:00',1.87),('8784','2013-11-17','10:00:00',1.94),('8784','2013-11-17','10:05:00',1.99),('8784','2013-11-17','10:10:00',2.05),('8784','2013-11-17','10:15:00',2.08),('8784','2013-11-17','10:20:00',2.12),('8784','2013-11-17','10:25:00',2.12),('8784','2013-11-17','10:30:00',2.21),('8784','2013-11-17','10:35:00',2.23),('8784','2013-11-17','10:40:00',2.24),('8784','2013-11-17','10:45:00',2.18),('8784','2013-11-17','10:50:00',2.15),('8784','2013-11-17','10:55:00',2.25),('8784','2013-11-17','11:00:00',2.28),('8784','2013-11-17','11:05:00',2.24),('8784','2013-11-17','11:10:00',2.25),('8784','2013-11-17','11:15:00',2.27),('8784','2013-11-17','11:20:00',2.32),('8784','2013-11-17','11:25:00',2.32),('8784','2013-11-17','11:30:00',2.31),('8784','2013-11-17','11:35:00',2.3),('8784','2013-11-17','11:40:00',2.32),('8784','2013-11-17','11:45:00',2.32),('8784','2013-11-17','11:50:00',2.31),('8784','2013-11-17','11:55:00',2.32),('8784','2013-11-17','12:00:00',2.31),('8784','2013-11-17','12:05:00',2.29),('8784','2013-11-17','12:10:00',2.27),('8784','2013-11-17','12:15:00',2.24),('8784','2013-11-17','12:20:00',2.22),('8784','2013-11-17','12:25:00',2.06),('8784','2013-11-17','12:30:00',2.15),('8784','2013-11-17','12:35:00',2.12),('8784','2013-11-17','12:40:00',2.13),('8784','2013-11-17','12:45:00',2.15),('8784','2013-11-17','12:50:00',2.07),('8784','2013-11-17','12:55:00',2.03),('8784','2013-11-17','13:00:00',2.03),('8784','2013-11-17','13:05:00',1.98),('8784','2013-11-17','13:10:00',1.96),('8784','2013-11-17','13:15:00',1.96),('8784','2013-11-17','13:20:00',1.88),('8784','2013-11-17','13:25:00',1.52),('8784','2013-11-17','13:30:00',1.69),('8784','2013-11-17','13:35:00',1.14),('8784','2013-11-17','13:40:00',1.61),('8784','2013-11-17','14:10:00',1.54),('8784','2013-11-17','14:15:00',1.46),('8784','2013-11-17','14:20:00',1.35),('8784','2013-11-17','14:25:00',1.31),('8784','2013-11-17','14:30:00',1.24),('8784','2013-11-17','14:35:00',1.19),('8784','2013-11-17','14:40:00',1.13),('8784','2013-11-16','13:05:00',1.09),('8784','2013-11-15','09:10:00',1.11),('8784','2013-11-15','09:15:00',1.28),('8784','2013-11-15','09:20:00',1.07),('8784','2013-11-15','09:25:00',1.01),('8784','2013-11-15','09:30:00',1.26),('8784','2013-11-15','09:35:00',1.36),('8784','2013-11-15','09:40:00',1.15),('8784','2013-11-15','10:10:00',1.13),('8784','2013-11-15','10:15:00',1.41),('8784','2013-11-15','10:20:00',1.32),('8784','2013-11-15','10:25:00',1.05),('8784','2013-11-15','10:50:00',1.17),('8784','2013-11-15','10:55:00',1.44),('8784','2013-11-15','11:00:00',1.35),('8784','2013-11-15','11:05:00',1.27),('8784','2013-11-15','11:10:00',1.23),('8784','2013-11-15','11:15:00',1.32),('8784','2013-11-15','11:20:00',1.68),('8784','2013-11-15','11:25:00',1.81),('8784','2013-11-15','11:30:00',1.79),('8784','2013-11-15','11:35:00',1.74),('8784','2013-11-15','11:40:00',2.03),('8784','2013-11-15','11:45:00',1.53),('8784','2013-11-15','11:50:00',1.33),('8784','2013-11-15','11:55:00',1.22),('8784','2013-11-15','12:00:00',1.23),('8784','2013-11-15','12:05:00',1.31),('8784','2013-11-15','12:10:00',1.13),('8784','2013-11-15','12:15:00',1.2),('8784','2013-11-15','12:20:00',1.42),('8784','2013-11-15','12:25:00',1.6),('8784','2013-11-15','12:30:00',1.34),('8784','2013-11-15','12:35:00',1.22),('8784','2013-11-15','12:40:00',1.15),('8784','2013-11-15','12:45:00',1.12),('8784','2013-11-15','12:50:00',1.17),('8784','2013-11-15','12:55:00',1.35),('8784','2013-11-15','13:00:00',1.4),('8784','2013-11-15','13:05:00',1.23),('8784','2013-11-15','13:10:00',1.11),('8784','2013-11-15','13:30:00',1.08),('8784','2013-11-15','13:35:00',1.21),('8784','2013-11-15','13:40:00',1.35),('8784','2013-11-15','13:45:00',1.71),('8784','2013-11-15','13:50:00',1.82),('8784','2013-11-15','13:55:00',1.19),('8784','2013-11-15','14:00:00',1.08),('8784','2013-11-14','09:15:00',1.16),('8784','2013-11-14','09:20:00',1.45),('8784','2013-11-14','09:25:00',1.49),('8784','2013-11-14','09:30:00',1.41),('8784','2013-11-14','09:35:00',1.53),('8784','2013-11-14','09:40:00',1.69),('8784','2013-11-14','09:45:00',1.75),('8784','2013-11-14','09:50:00',1.28),('8784','2013-11-14','09:55:00',1.06),('8784','2013-11-14','10:00:00',1),('8784','2013-11-14','10:05:00',1.46),('8784','2013-11-14','10:10:00',1.35),('8784','2013-11-14','10:15:00',2.15),('8784','2013-11-14','10:20:00',2.2),('8784','2013-11-14','10:25:00',2.18),('8784','2013-11-14','10:30:00',2.23),('8784','2013-11-14','10:35:00',2.25),('8784','2013-11-14','10:40:00',2.26),('8784','2013-11-14','10:45:00',2.19),('8784','2013-11-14','10:50:00',2.17),('8784','2013-11-14','10:55:00',2.16),('8784','2013-11-14','11:00:00',2.26),('8784','2013-11-14','11:05:00',2.38),('8784','2013-11-14','11:10:00',2.43),('8784','2013-11-14','11:15:00',2.47),('8784','2013-11-14','11:20:00',2.53),('8784','2013-11-14','11:25:00',2.53),('8784','2013-11-14','11:30:00',2.52),('8784','2013-11-14','11:35:00',2.24),('8784','2013-11-14','11:40:00',2.16),('8784','2013-11-14','11:45:00',1.62),('8784','2013-11-14','11:50:00',1.77),('8784','2013-11-14','11:55:00',1.87),('8784','2013-11-14','12:00:00',2.83),('8784','2013-11-14','12:05:00',1.9),('8784','2013-11-14','12:10:00',1.36),('8784','2013-11-14','12:15:00',1.42),('8784','2013-11-14','12:20:00',1.31),('8784','2013-11-14','12:25:00',1.13),('8784','2013-11-14','12:30:00',1.12),('8784','2013-11-14','12:35:00',1.17),('8784','2013-11-14','12:40:00',1.15),('8784','2013-11-14','12:45:00',1.17),('8784','2013-11-14','12:50:00',1.22),('8784','2013-11-14','12:55:00',1.19),('8784','2013-11-14','13:00:00',1.17),('8784','2013-11-14','13:05:00',1.05),('8784','2013-11-14','13:30:00',1),('8784','2013-11-14','13:55:00',1.38),('8784','2013-11-13','10:05:00',1.11),('8784','2013-11-13','10:10:00',1.13),('8784','2013-11-13','10:15:00',1.12),('8784','2013-11-13','10:20:00',2.27),('8784','2013-11-13','10:25:00',3.26),('8784','2013-11-13','10:30:00',2.85),('8784','2013-11-13','10:35:00',3.22),('8784','2013-11-13','10:40:00',2.94),('8784','2013-11-13','10:45:00',2.83),('8784','2013-11-13','10:50:00',3.26),('8784','2013-11-13','10:55:00',3),('8784','2013-11-13','11:00:00',1.5),('8784','2013-11-13','11:25:00',1.02),('8784','2013-11-13','11:30:00',1.08),('8784','2013-11-13','11:45:00',1.11),('8784','2013-11-13','11:50:00',1.26),('8784','2013-11-13','11:55:00',1.16),('8784','2013-11-13','12:55:00',1.05),('8784','2013-11-13','13:00:00',1.18),('8784','2013-11-13','13:05:00',1.37),('8784','2013-11-13','13:10:00',1.26),('8784','2013-11-13','13:15:00',1.25),('8784','2013-11-13','13:20:00',1.01),('8784','2013-11-13','13:40:00',1.03),('8784','2013-11-13','13:55:00',1.52),('8784','2013-11-13','14:00:00',1.69),('8784','2013-11-13','14:05:00',1.58),('8784','2013-11-13','14:10:00',1.52),('8784','2013-11-13','14:15:00',1.53),('8784','2013-11-13','14:20:00',1.43),('8784','2013-11-13','14:25:00',1.52),('8784','2013-11-13','14:30:00',1.41),('8784','2013-11-13','14:35:00',1.08),('8784','2013-11-12','11:25:00',1.39),('8784','2013-11-12','11:35:00',1.16),('8784','2013-11-12','11:40:00',2.29),('8784','2013-11-12','11:45:00',1.2),('8784','2013-11-12','11:50:00',1.78),('8784','2013-11-12','11:55:00',1.06),('8784','2013-11-12','12:00:00',2.44),('8784','2013-11-12','12:05:00',1.43),('8784','2013-11-12','12:30:00',3.27),('8784','2013-11-12','12:35:00',3.17),('8784','2013-11-12','12:40:00',2.08),('8784','2013-11-12','12:45:00',2.01),('8784','2013-11-12','12:50:00',2),('8784','2013-11-12','12:55:00',2.23),('8784','2013-11-12','13:00:00',1.98),('8784','2013-11-12','13:05:00',1.94),('8784','2013-11-12','13:10:00',2.24),('8784','2013-11-12','13:15:00',2.06),('8784','2013-11-12','13:20:00',1.98),('8784','2013-11-12','13:25:00',2.12),('8784','2013-11-12','13:30:00',1.91),('8784','2013-11-12','13:35:00',1.99),('8784','2013-11-12','13:40:00',2.12),('8784','2013-11-12','13:45:00',1.67),('8784','2013-11-12','13:50:00',1.31),('8784','2013-11-12','13:55:00',1.44),('8784','2013-11-12','14:00:00',1.39),('8784','2013-11-12','14:05:00',1.24),('8784','2013-11-12','14:10:00',2.38),('8784','2013-11-12','14:15:00',2.35),('8784','2013-11-12','14:20:00',2.06),('8784','2013-11-12','14:25:00',1.26),('8784','2013-11-12','14:30:00',1.6),('8784','2013-11-12','14:35:00',1.35),('8784','2013-11-12','14:40:00',1.46),('8784','2013-11-12','14:45:00',1.25),('8784','2013-11-11','09:50:00',1.27),('8784','2013-11-11','09:55:00',1.33),('8784','2013-11-11','10:00:00',1.04),('8784','2013-11-11','10:05:00',1.28),('8784','2013-11-11','10:10:00',1.27),('8784','2013-11-11','10:15:00',1.93),('8784','2013-11-11','10:20:00',2.47),('8784','2013-11-11','10:25:00',1.35),('8784','2013-11-11','11:05:00',1.52),('8784','2013-11-11','11:10:00',3.2),('8784','2013-11-11','11:15:00',2.54),('8784','2013-11-11','11:20:00',2.06),('8784','2013-11-11','11:25:00',2.45),('8784','2013-11-11','11:30:00',3.33),('8784','2013-11-11','11:35:00',2.37),('8784','2013-11-11','11:40:00',3.54),('8784','2013-11-11','11:45:00',2.73),('8784','2013-11-11','11:50:00',3.36),('8784','2013-11-11','11:55:00',3.1),('8784','2013-11-11','12:00:00',2.84),('8784','2013-11-11','12:05:00',2.73),('8784','2013-11-11','12:10:00',2.68),('8784','2013-11-11','12:15:00',2.22),('8784','2013-11-11','12:20:00',2.69),('8784','2013-11-11','12:25:00',2.51),('8784','2013-11-11','12:30:00',1.1),('8784','2013-11-11','12:40:00',1.74),('8784','2013-11-11','12:45:00',1.9),('8784','2013-11-11','13:00:00',1.15),('8784','2013-11-11','13:10:00',1.78),('8784','2013-11-11','13:15:00',1.7),('8784','2013-11-11','13:35:00',1.13),('8784','2013-11-11','13:40:00',1.63),('8784','2013-11-11','14:00:00',2.16),('8784','2013-11-11','14:05:00',1.29),('8784','2013-11-11','14:20:00',1.41),('8784','2013-11-11','14:25:00',1.89),('8784','2013-11-11','14:30:00',1.66),('8784','2013-11-11','14:35:00',1.6),('8784','2013-11-11','14:40:00',1.41),('8784','2013-11-10','08:35:00',1.03),('8784','2013-11-10','08:50:00',1.19),('8784','2013-11-10','08:55:00',1.24),('8784','2013-11-10','09:00:00',1.18),('8784','2013-11-10','09:20:00',1.33),('8784','2013-11-10','09:25:00',1.76),('8784','2013-11-10','09:30:00',1.53),('8784','2013-11-10','09:35:00',1.52),('8784','2013-11-10','09:40:00',1.69),('8784','2013-11-10','09:45:00',1.95),('8784','2013-11-10','09:50:00',2.04),('8784','2013-11-10','09:55:00',2),('8784','2013-11-10','10:00:00',2.06),('8784','2013-11-10','10:05:00',2.34),('8784','2013-11-10','10:10:00',2.46),('8784','2013-11-10','10:15:00',2.45),('8784','2013-11-10','10:20:00',2.27),('8784','2013-11-10','10:25:00',2.71),('8784','2013-11-10','10:30:00',2.72),('8784','2013-11-10','10:35:00',1.86),('8784','2013-11-10','10:40:00',2.67),('8784','2013-11-10','10:45:00',2.1),('8784','2013-11-10','10:50:00',3.05),('8784','2013-11-10','10:55:00',2.91),('8784','2013-11-10','11:00:00',1.82),('8784','2013-11-10','11:05:00',1.47),('8784','2013-11-10','11:10:00',1.02),('8784','2013-11-10','11:20:00',1.03),('8784','2013-11-10','11:25:00',1.32),('8784','2013-11-10','11:35:00',1.24),('8784','2013-11-10','11:40:00',2.03),('8784','2013-11-10','11:45:00',2.19),('8784','2013-11-10','11:55:00',1.52),('8784','2013-11-10','12:05:00',1.22),('8784','2013-11-10','12:10:00',1.59),('8784','2013-11-10','12:15:00',2.58),('8784','2013-11-10','12:20:00',2.32),('8784','2013-11-10','12:25:00',2.2),('8784','2013-11-10','12:30:00',1.55),('8784','2013-11-10','12:35:00',2.17),('8784','2013-11-10','12:40:00',2.7),('8784','2013-11-10','12:45:00',2.9),('8784','2013-11-10','12:50:00',2.89),('8784','2013-11-10','12:55:00',1.59),('8784','2013-11-10','13:00:00',1.36),('8784','2013-11-10','13:45:00',1.17),('8784','2013-11-10','13:50:00',2.16),('8784','2013-11-10','13:55:00',1.71),('8784','2013-11-10','14:30:00',1.05),('8784','2013-11-09','09:40:00',1.65),('8784','2013-11-09','09:45:00',1.45),('8784','2013-11-09','09:50:00',2.66),('8784','2013-11-09','09:55:00',2.52),('8784','2013-11-09','10:00:00',2.44),('8784','2013-11-09','10:05:00',2.17),('8784','2013-11-09','10:10:00',1.93),('8784','2013-11-09','10:15:00',2.11),('8784','2013-11-09','10:20:00',2.13),('8784','2013-11-09','10:25:00',1.4),('8784','2013-11-09','10:30:00',1.19),('8784','2013-11-09','10:35:00',1.39),('8784','2013-11-09','10:40:00',1.39),('8784','2013-11-09','10:45:00',1.47),('8784','2013-11-09','10:50:00',1.62),('8784','2013-11-09','10:55:00',1.94),('8784','2013-11-09','11:00:00',1.86),('8784','2013-11-09','11:05:00',2.51),('8784','2013-11-09','11:10:00',2.95),('8784','2013-11-09','11:15:00',2.8),('8784','2013-11-09','11:20:00',1.65),('8784','2013-11-09','11:25:00',2.09),('8784','2013-11-09','11:30:00',1.82),('8784','2013-11-09','11:35:00',1.82),('8784','2013-11-09','11:40:00',2.62),('8784','2013-11-09','11:45:00',2.11),('8784','2013-11-09','11:50:00',2.35),('8784','2013-11-09','11:55:00',2.8),('8784','2013-11-09','12:00:00',3.2),('8784','2013-11-09','12:05:00',3.16),('8784','2013-11-09','12:10:00',1.71),('8784','2013-11-09','12:15:00',1.74),('8784','2013-11-09','12:20:00',1.18),('8784','2013-11-09','12:25:00',1.78),('8784','2013-11-09','12:30:00',2.18),('8784','2013-11-09','12:35:00',2.93),('8784','2013-11-09','12:40:00',3.25),('8784','2013-11-09','12:45:00',1.66),('8784','2013-11-09','12:50:00',1.77),('8784','2013-11-09','12:55:00',1.85),('8784','2013-11-09','13:00:00',2.74),('8784','2013-11-09','13:05:00',2.2),('8784','2013-11-09','13:10:00',2.65),('8784','2013-11-09','13:15:00',2.53),('8784','2013-11-09','13:25:00',2.27),('8784','2013-11-09','13:30:00',2.16),('8784','2013-11-09','13:35:00',2.16),('8784','2013-11-09','13:40:00',2.05),('8784','2013-11-09','13:45:00',2.03),('8784','2013-11-09','13:50:00',2.05),('8784','2013-11-09','13:55:00',2),('8784','2013-11-09','14:00:00',1.88),('8784','2013-11-09','14:05:00',1.63),('8784','2013-11-09','14:10:00',1.07),('8784','2013-11-09','14:15:00',1.29),('8784','2013-11-09','14:20:00',1.9),('8784','2013-11-09','14:25:00',1.38),('8784','2013-11-09','14:35:00',1.08),('8784','2013-11-09','14:40:00',1.26),('8784','2013-11-09','14:50:00',1.26),('8784','2013-11-08','09:10:00',1.09),('8784','2013-11-08','09:15:00',1.01),('8784','2013-11-08','09:25:00',1.11),('8784','2013-11-08','09:30:00',1.44),('8784','2013-11-08','09:35:00',1.52),('8784','2013-11-08','09:40:00',1.26),('8784','2013-11-08','09:45:00',1.3),('8784','2013-11-08','09:50:00',2.13),('8784','2013-11-08','09:55:00',1.45),('8784','2013-11-08','10:00:00',2.46),('8784','2013-11-08','10:05:00',1.58),('8784','2013-11-08','10:10:00',1.28),('8784','2013-11-08','10:45:00',1.25),('8784','2013-11-08','10:50:00',2.31),('8784','2013-11-08','10:55:00',1),('8784','2013-11-08','11:20:00',1.48),('8784','2013-11-08','11:35:00',2.05),('8784','2013-11-08','11:40:00',2.58),('8784','2013-11-08','11:45:00',2.67),('8784','2013-11-08','11:50:00',2.92),('8784','2013-11-08','11:55:00',2.86),('8784','2013-11-08','12:00:00',2.41),('8784','2013-11-08','12:05:00',2.55),('8784','2013-11-08','12:10:00',2.51),('8784','2013-11-08','12:35:00',2.3),('8784','2013-11-08','12:40:00',2.66),('8784','2013-11-08','12:45:00',2.66),('8784','2013-11-08','12:55:00',2.67),('8784','2013-11-08','13:00:00',2.52),('8784','2013-11-08','13:05:00',2.46),('8784','2013-11-08','13:10:00',2.5),('8784','2013-11-08','13:15:00',1.31),('8784','2013-11-08','13:20:00',2.22),('8784','2013-11-08','13:25:00',1.07),('8784','2013-11-08','13:30:00',1.21),('8784','2013-11-08','13:35:00',2.16),('8784','2013-11-08','13:40:00',2.09),('8784','2013-11-08','13:45:00',2.02),('8784','2013-11-08','13:50:00',1.7),('8784','2013-11-08','13:55:00',1.9),('8784','2013-11-08','14:00:00',1.9),('8784','2013-11-08','14:05:00',1.8),('8784','2013-11-08','14:10:00',1.75),('8784','2013-11-08','14:15:00',1.51),('8784','2013-11-08','14:20:00',1.47),('8784','2013-11-08','14:25:00',1.54),('8784','2013-11-08','14:30:00',1.6),('8784','2013-11-08','14:35:00',1.6),('8784','2013-11-08','14:40:00',1.44),('8784','2013-11-08','14:45:00',1.33),('8784','2013-11-08','14:50:00',1.17),('8784','2013-11-08','15:00:00',1.1),('8784','2013-11-08','15:05:00',1.1),('8784','2013-11-08','15:10:00',1.05),('8784','2014-04-18','08:05:00',1.76),('8784','2014-04-18','08:10:00',1.71),('8784','2014-04-18','08:35:00',1.07),('8784','2014-04-18','08:40:00',1.57),('8784','2014-04-18','08:45:00',1.65),('8784','2014-04-18','08:50:00',1.2),('8784','2014-04-18','08:55:00',1.1),('8784','2014-04-18','09:00:00',1.26),('8784','2014-04-18','09:05:00',2.53),('8784','2014-04-18','09:10:00',3.36),('8784','2014-04-18','09:15:00',3.08),('8784','2014-04-18','09:20:00',2.87),('8784','2014-04-18','09:25:00',1.85),('8784','2014-04-18','09:30:00',3.25),('8784','2014-04-18','09:35:00',1.95),('8784','2014-04-18','09:40:00',1.16),('8784','2014-04-18','09:45:00',1.99),('8784','2014-04-18','09:50:00',3.05),('8784','2014-04-18','09:55:00',3.34),('8784','2014-04-18','10:00:00',2.77),('8784','2014-04-18','10:05:00',1.83),('8784','2014-04-18','10:10:00',1.62),('8784','2014-04-18','10:15:00',1.77),('8784','2014-04-18','10:20:00',1.62),('8784','2014-04-18','10:25:00',1.66),('8784','2014-04-18','10:30:00',1.39),('8784','2014-04-18','10:35:00',1.28),('8784','2014-04-18','10:40:00',1.51),('8784','2014-04-18','10:45:00',2.55),('8784','2014-04-18','10:50:00',2.99),('8784','2014-04-18','10:55:00',3.21),('8784','2014-04-18','11:00:00',2.06),('8784','2014-04-18','11:05:00',1.82),('8784','2014-04-18','11:10:00',2.01),('8784','2014-04-18','11:15:00',3.36),('8784','2014-04-18','11:20:00',2.07),('8784','2014-04-18','11:25:00',1.54),('8784','2014-04-18','11:30:00',1.82),('8784','2014-04-18','11:35:00',1.79),('8784','2014-04-18','11:40:00',1.86),('8784','2014-04-18','11:45:00',1.79),('8784','2014-04-18','11:50:00',2.16),('8784','2014-04-18','11:55:00',1.93),('8784','2014-04-18','12:00:00',2),('8784','2014-04-18','12:05:00',3.7),('8784','2014-04-18','12:10:00',3.59),('8784','2014-04-18','12:15:00',3.8),('8784','2014-04-18','12:20:00',4.09),('8784','2014-04-18','12:25:00',3.04),('8784','2014-04-18','12:30:00',4.65),('8784','2014-04-18','12:35:00',4.39),('8784','2014-04-18','12:40:00',4.65),('8784','2014-04-18','12:45:00',3.79),('8784','2014-04-18','12:50:00',3.8),('8784','2014-04-18','12:55:00',2.86),('8784','2014-04-18','13:00:00',4.55),('8784','2014-04-18','13:05:00',2.75),('8784','2014-04-18','13:10:00',2.67),('8784','2014-04-18','13:15:00',2.57),('8784','2014-04-18','13:20:00',2.43),('8784','2014-04-18','13:25:00',1.82),('8784','2014-04-18','13:30:00',1.49),('8784','2014-04-18','13:35:00',1.51),('8784','2014-04-18','13:40:00',1.44),('8784','2014-04-18','13:45:00',1.24),('8784','2014-04-18','13:50:00',1.5),('8784','2014-04-18','13:55:00',2.49),('8784','2014-04-18','14:00:00',2.19),('8784','2014-04-18','14:05:00',1.88),('8784','2014-04-18','14:10:00',1.61),('8784','2014-04-18','14:15:00',1.46),('8784','2014-04-18','14:20:00',1.71),('8784','2014-04-18','14:25:00',2.18),('8784','2014-04-18','14:30:00',2.45),('8784','2014-04-18','14:35:00',2.76),('8784','2014-04-18','14:40:00',2.43),('8784','2014-04-18','14:45:00',2.85),('8784','2014-04-18','14:50:00',3.12),('8784','2014-04-18','14:55:00',2.46),('8784','2014-04-18','15:00:00',4.46),('8784','2014-04-18','15:05:00',2.76),('8784','2014-04-18','15:10:00',1.96),('8784','2014-04-18','15:15:00',2.57),('8784','2014-04-18','15:20:00',1.97),('8784','2014-04-18','15:25:00',2.35),('8784','2014-04-18','15:30:00',3.44),('8784','2014-04-18','15:35:00',3.67),('8784','2014-04-18','15:40:00',3.49),('8784','2014-04-18','15:45:00',2.48),('8784','2014-04-18','15:50:00',2.85),('8784','2014-04-18','15:55:00',2.96),('8784','2014-04-18','16:00:00',2.52),('8784','2014-04-18','16:05:00',1.98),('8784','2014-04-18','16:10:00',1.59),('8784','2014-04-18','16:15:00',1.39),('8784','2014-04-18','16:20:00',1.43),('8784','2014-04-18','16:25:00',2.48),('8784','2014-04-18','16:30:00',2.49),('8784','2014-04-18','16:35:00',2.8),('8784','2014-04-18','16:40:00',3.08),('8784','2014-04-18','16:45:00',2.8),('8784','2014-04-18','16:50:00',2.79),('8784','2014-04-18','16:55:00',2.65),('8784','2014-04-18','17:00:00',2.76),('8784','2014-04-18','17:05:00',2.78),('8784','2014-04-18','17:10:00',2.39),('8784','2014-04-18','17:15:00',2.06),('8784','2014-04-18','17:20:00',2.09),('8784','2014-04-18','17:25:00',2.07),('8784','2014-04-18','17:30:00',1.88),('8784','2014-04-18','17:35:00',1.79),('8784','2014-04-18','17:40:00',1.73),('8784','2014-04-18','17:45:00',1.63),('8784','2014-04-18','17:50:00',1.55),('8784','2014-04-18','17:55:00',1.47),('8784','2014-04-18','18:00:00',1.39),('8784','2014-04-18','18:05:00',1.25),('8784','2014-04-18','18:10:00',1.16),('8784','2014-04-18','18:15:00',1.02),('8784','2013-11-07','08:45:00',1.05),('8784','2013-11-07','08:50:00',1.15),('8784','2013-11-07','08:55:00',1.19),('8784','2013-11-07','09:00:00',1.26),('8784','2013-11-07','09:05:00',1.35),('8784','2013-11-07','09:10:00',1.5),('8784','2013-11-07','09:15:00',1.6),('8784','2013-11-07','09:20:00',1.66),('8784','2013-11-07','09:25:00',1.7),('8784','2013-11-07','09:30:00',1.75),('8784','2013-11-07','09:35:00',1.79),('8784','2013-11-07','09:40:00',1.88),('8784','2013-11-07','09:45:00',2.02),('8784','2013-11-07','09:50:00',2.06),('8784','2013-11-07','09:55:00',2.11),('8784','2013-11-07','10:00:00',2.15),('8784','2013-11-07','10:05:00',2.18),('8784','2013-11-07','10:10:00',2.19),('8784','2013-11-07','10:15:00',2.22),('8784','2013-11-07','10:20:00',2.24),('8784','2013-11-07','10:25:00',2.29),('8784','2013-11-07','10:30:00',2.31),('8784','2013-11-07','10:35:00',2.34),('8784','2013-11-07','10:40:00',2.33),('8784','2013-11-07','10:45:00',2.34),('8784','2013-11-07','10:50:00',2.35),('8784','2013-11-07','10:55:00',2.36),('8784','2013-11-07','11:00:00',2.35),('8784','2013-11-07','11:05:00',2.33),('8784','2013-11-07','11:10:00',2.35),('8784','2013-11-07','11:15:00',2.36),('8784','2013-11-07','11:20:00',2.34),('8784','2013-11-07','11:25:00',2.33),('8784','2013-11-07','11:30:00',2.38),('8784','2013-11-07','11:35:00',2.43),('8784','2013-11-07','11:40:00',2.42),('8784','2013-11-07','11:45:00',2.42),('8784','2013-11-07','11:50:00',2.43),('8784','2013-11-07','11:55:00',2.42),('8784','2013-11-07','12:00:00',2.39),('8784','2013-11-07','12:05:00',2.36),('8784','2013-11-07','12:10:00',2.36),('8784','2013-11-07','12:15:00',2.34),('8784','2013-11-07','12:20:00',2.32),('8784','2013-11-07','12:25:00',2.22),('8784','2013-11-07','12:30:00',2.28),('8784','2013-11-07','12:35:00',2.23),('8784','2013-11-07','12:40:00',2.25),('8784','2013-11-07','12:45:00',2.24),('8784','2013-11-07','12:50:00',2.24),('8784','2013-11-07','12:55:00',2.24),('8784','2013-11-07','13:00:00',2.44),('8784','2013-11-07','13:05:00',2.43),('8784','2013-11-07','13:10:00',1.44),('8784','2013-11-07','13:15:00',1.07),('8784','2013-11-07','13:20:00',1.02),('8784','2013-11-07','13:25:00',1.3),('8784','2013-11-07','13:30:00',1.56),('8784','2013-11-07','13:35:00',2.22),('8784','2013-11-07','13:40:00',1.64),('8784','2013-11-07','13:45:00',1.41),('8784','2013-11-07','13:50:00',2.06),('8784','2013-11-07','13:55:00',1.72),('8784','2013-11-07','14:05:00',1.17),('8784','2013-11-07','14:10:00',1.4),('8784','2013-11-07','14:15:00',1.23),('8784','2013-11-07','14:20:00',1.1),('8784','2013-11-07','14:25:00',1.29),('8784','2013-11-07','14:30:00',1.54),('8784','2013-11-07','14:35:00',1.34),('8784','2013-11-07','14:40:00',1.39),('8784','2013-11-07','14:45:00',1.27),('8784','2013-11-07','14:50:00',1.26),('8784','2013-11-07','14:55:00',1.22),('8784','2013-11-07','15:00:00',1.12),('8784','2013-11-07','15:05:00',1.08),('8784','2013-11-06','08:40:00',1.02),('8784','2013-11-06','08:45:00',1.09),('8784','2013-11-06','08:50:00',1.07),('8784','2013-11-06','08:55:00',1.18),('8784','2013-11-06','09:15:00',1.35),('8784','2013-11-06','09:20:00',1.44),('8784','2013-11-06','09:25:00',1.72),('8784','2013-11-06','09:30:00',1.85),('8784','2013-11-06','09:35:00',1.89),('8784','2013-11-06','09:40:00',1.93),('8784','2013-11-06','09:45:00',1.97),('8784','2013-11-06','09:50:00',2.09),('8784','2013-11-06','09:55:00',2.14),('8784','2013-11-06','10:00:00',2.18),('8784','2013-11-06','10:05:00',2.27),('8784','2013-11-06','10:10:00',2.34),('8784','2013-11-06','10:15:00',2.37),('8784','2013-11-06','10:20:00',2.41),('8784','2013-11-06','10:25:00',2.45),('8784','2013-11-06','10:30:00',2.41),('8784','2013-11-06','10:35:00',2.48),('8784','2013-11-06','10:40:00',2.5),('8784','2013-11-06','10:45:00',2.48),('8784','2013-11-06','10:50:00',2.5),('8784','2013-11-06','10:55:00',2.5),('8784','2013-11-06','11:00:00',2.5),('8784','2013-11-06','11:05:00',2.56),('8784','2013-11-06','11:10:00',2.56),('8784','2013-11-06','11:15:00',2.58),('8784','2013-11-06','11:20:00',2.57),('8784','2013-11-06','11:25:00',2.6),('8784','2013-11-06','11:30:00',2.62),('8784','2013-11-06','11:35:00',2.61),('8784','2013-11-06','11:40:00',2.6),('8784','2013-11-06','11:45:00',2.58),('8784','2013-11-06','11:50:00',2.6),('8784','2013-11-06','11:55:00',2.6),('8784','2013-11-06','12:00:00',2.59),('8784','2013-11-06','12:05:00',2.59),('8784','2013-11-06','12:10:00',2.57),('8784','2013-11-06','12:15:00',2.55),('8784','2013-11-06','12:20:00',2.55),('8784','2013-11-06','12:25:00',2.39),('8784','2013-11-06','12:30:00',2.08),('8784','2013-11-06','12:35:00',2.35),('8784','2013-11-06','12:40:00',2.38),('8784','2013-11-06','12:45:00',2.32),('8784','2013-11-06','12:50:00',2.36),('8784','2013-11-06','12:55:00',2.38),('8784','2013-11-06','13:00:00',2.34),('8784','2013-11-06','13:05:00',2.33),('8784','2013-11-06','13:10:00',2.26),('8784','2013-11-06','13:15:00',2.21),('8784','2013-11-06','13:20:00',2.21),('8784','2013-11-06','13:25:00',2.18),('8784','2013-11-06','13:30:00',2.13),('8784','2013-11-06','13:35:00',2.06),('8784','2013-11-06','13:40:00',1.92),('8784','2013-11-06','13:45:00',1.99),('8784','2013-11-06','13:50:00',1.95),('8784','2013-11-06','13:55:00',1.93),('8784','2013-11-06','14:00:00',1.87),('8784','2013-11-06','14:05:00',1.78),('8784','2013-11-06','14:10:00',1.74),('8784','2013-11-06','14:15:00',1.73),('8784','2013-11-06','14:20:00',1.67),('8784','2013-11-06','14:25:00',1.6),('8784','2013-11-06','14:30:00',1.53),('8784','2013-11-06','14:35:00',1.45),('8784','2013-11-06','14:40:00',1.38),('8784','2013-11-06','14:45:00',1.36),('8784','2013-11-06','14:50:00',1.29),('8784','2013-11-06','14:55:00',1.2),('8784','2013-11-06','15:00:00',1.14),('8784','2013-11-06','15:05:00',1.12),('8784','2013-11-06','15:10:00',1.04),('8784','2013-11-06','15:15:00',1),('8784','2013-11-05','08:35:00',1.18),('8784','2013-11-05','08:40:00',1.26),('8784','2013-11-05','10:15:00',1),('8784','2013-11-05','10:20:00',1.73),('8784','2013-11-05','10:25:00',2.22),('8784','2013-11-05','10:30:00',1.59),('8784','2013-11-05','10:35:00',2.37),('8784','2013-11-05','10:40:00',1.61),('8784','2013-11-05','10:45:00',1.76),('8784','2013-11-05','10:50:00',1.51),('8784','2013-11-05','10:55:00',1.33),('8784','2013-11-05','11:00:00',1.12),('8784','2013-11-05','11:35:00',1.18),('8784','2013-11-05','11:40:00',1.57),('8784','2013-11-05','11:45:00',1.52),('8784','2013-11-05','11:50:00',1.4),('8784','2013-11-05','11:55:00',1.19),('8784','2013-11-05','12:00:00',1.05),('8784','2013-11-05','12:05:00',1.28),('8784','2013-11-05','12:10:00',1.59),('8784','2013-11-05','12:15:00',1.56),('8784','2013-11-05','12:20:00',1.66),('8784','2013-11-05','12:25:00',1.48),('8784','2013-11-05','12:30:00',1.27),('8784','2013-11-05','12:35:00',1.09),('8784','2013-11-05','13:30:00',1.19),('8784','2013-11-05','13:35:00',2.14),('8784','2013-11-05','13:40:00',2.21),('8784','2013-11-05','13:45:00',2.07),('8784','2013-11-05','13:50:00',1.13),('8784','2013-11-05','13:55:00',1.37),('8784','2013-11-05','14:00:00',1.62),('8784','2013-11-05','14:05:00',1.98),('8784','2013-11-05','14:10:00',2.29),('8784','2013-11-05','14:20:00',1.61),('8784','2013-11-05','14:25:00',1.5),('8784','2013-11-05','14:30:00',1.66),('8784','2013-11-05','14:35:00',1.66),('8784','2013-11-05','14:45:00',1.28),('8784','2013-11-04','09:10:00',1.67),('8784','2013-11-04','09:15:00',1.88),('8784','2013-11-04','09:20:00',1.77),('8784','2013-11-04','09:25:00',1.64),('8784','2013-11-04','09:30:00',1.12),('8784','2013-11-04','10:00:00',1.71),('8784','2013-11-04','10:05:00',2.4),('8784','2013-11-04','10:10:00',2.43),('8784','2013-11-04','10:15:00',2.48),('8784','2013-11-04','10:20:00',2.53),('8784','2013-11-04','10:25:00',2.84),('8784','2013-11-04','10:30:00',2.87),('8784','2013-11-04','10:35:00',2.7),('8784','2013-11-04','10:40:00',3.04),('8784','2013-11-04','10:45:00',1.88),('8784','2013-11-04','10:50:00',1.97),('8784','2013-11-04','10:55:00',2.84),('8784','2013-11-04','11:00:00',2.39),('8784','2013-11-04','11:05:00',2.71),('8784','2013-11-04','11:10:00',1.35),('8784','2013-11-04','11:15:00',2.06),('8784','2013-11-04','11:20:00',1.57),('8784','2013-11-04','11:25:00',1.38),('8784','2013-11-04','11:30:00',2.49),('8784','2013-11-04','11:35:00',2.44),('8784','2013-11-04','11:40:00',2.07),('8784','2013-11-04','11:45:00',2.52),('8784','2013-11-04','11:50:00',3.55),('8784','2013-11-04','11:55:00',3.06),('8784','2013-11-04','12:00:00',3.06),('8784','2013-11-04','12:05:00',2.68),('8784','2013-11-04','12:10:00',2.73),('8784','2013-11-04','12:15:00',2.67),('8784','2013-11-04','12:20:00',2.53),('8784','2013-11-04','12:25:00',2.55),('8784','2013-11-04','12:30:00',2.54),('8784','2013-11-04','12:35:00',2.59),('8784','2013-11-04','12:40:00',2.57),('8784','2013-11-04','12:45:00',2.55),('8784','2013-11-04','12:50:00',2.51),('8784','2013-11-04','12:55:00',2.45),('8784','2013-11-04','13:00:00',2.42),('8784','2013-11-04','13:05:00',2.27),('8784','2013-11-04','13:10:00',2.39),('8784','2013-11-04','13:15:00',2.28),('8784','2013-11-04','13:20:00',1.8),('8784','2013-11-04','13:25:00',2.31),('8784','2013-11-04','13:30:00',2.25),('8784','2013-11-04','13:35:00',2.34),('8784','2013-11-04','13:40:00',1.69),('8784','2013-11-04','13:45:00',2.33),('8784','2013-11-04','13:50:00',2.18),('8784','2013-11-04','13:55:00',1.45),('8784','2013-11-04','14:00:00',1.33),('8784','2013-11-04','14:05:00',1.52),('8784','2013-11-04','14:10:00',1.99),('8784','2013-11-04','14:15:00',2.01),('8784','2013-11-04','14:20:00',2.03),('8784','2013-11-04','14:25:00',1.19),('8784','2013-11-04','14:30:00',1.25),('8784','2013-11-04','14:35:00',1.94),('8784','2013-11-04','14:40:00',1.65),('8784','2013-11-04','14:45:00',1.58),('8784','2013-11-04','14:50:00',1.52),('8784','2013-11-04','14:55:00',1.3),('8784','2013-11-04','15:00:00',1.28),('8784','2013-11-04','15:25:00',1.01),('8784','2013-11-03','09:40:00',2.44),('8784','2013-11-03','09:45:00',1.44),('8784','2013-11-03','10:10:00',1.39),('8784','2013-11-03','10:20:00',2.24),('8784','2013-11-03','10:25:00',1.68),('8784','2013-11-03','10:30:00',2.51),('8784','2013-11-03','10:35:00',1.63),('8784','2013-11-03','11:15:00',1.05),('8784','2013-11-03','11:20:00',1.78),('8784','2013-11-03','11:25:00',1.07),('8784','2013-11-03','11:30:00',2.37),('8784','2013-11-03','11:35:00',2.55),('8784','2013-11-03','11:40:00',2.96),('8784','2013-11-03','11:45:00',3.05),('8784','2013-11-03','11:50:00',3.21),('8784','2013-11-03','11:55:00',2.32),('8784','2013-11-03','12:00:00',2.89),('8784','2013-11-03','12:05:00',3.13),('8784','2013-11-03','12:10:00',2.84),('8784','2013-11-03','12:15:00',1.72),('8784','2013-11-03','12:25:00',1.46),('8784','2013-11-03','12:35:00',1.17),('8784','2013-11-03','12:40:00',1.37),('8784','2013-11-03','12:45:00',1.14),('8784','2013-11-03','12:50:00',1.13),('8784','2013-11-03','13:25:00',1.05),('8784','2013-11-03','13:30:00',1.01),('8784','2013-11-03','13:35:00',1.2),('8784','2013-11-03','13:40:00',1.42),('8784','2013-11-03','13:45:00',2.06),('8784','2013-11-03','13:55:00',1.23),('8784','2013-11-03','14:00:00',1.41),('8784','2013-11-03','14:05:00',2.11),('8784','2013-11-03','14:10:00',2.21),('8784','2013-11-03','14:15:00',2.05),('8784','2013-11-03','14:20:00',1.76),('8784','2013-11-03','14:25:00',1.95),('8784','2013-11-03','14:30:00',1.22),('8784','2013-11-03','14:35:00',1.23),('8784','2013-11-03','14:40:00',1.68),('8784','2013-11-03','14:45:00',1.46),('8784','2013-11-03','14:50:00',1.14),('8784','2013-11-02','08:40:00',1.07),('8784','2013-11-02','08:45:00',1.14),('8784','2013-11-02','08:50:00',1.18),('8784','2013-11-02','08:55:00',1.24),('8784','2013-11-02','09:00:00',1.36),('8784','2013-11-02','09:05:00',1.58),('8784','2013-11-02','09:10:00',1.54),('8784','2013-11-02','09:15:00',1.61),('8784','2013-11-02','09:20:00',1.55),('8784','2013-11-02','09:25:00',1.72),('8784','2013-11-02','09:30:00',1.83),('8784','2013-11-02','09:35:00',1.83),('8784','2013-11-02','09:40:00',1.98),('8784','2013-11-02','09:45:00',2.03),('8784','2013-11-02','09:50:00',2.28),('8784','2013-11-02','09:55:00',2.25),('8784','2013-11-02','10:00:00',2.21),('8784','2013-11-02','10:05:00',1.81),('8784','2013-11-02','10:10:00',1.34),('8784','2013-11-02','10:15:00',1.28),('8784','2013-11-02','11:00:00',1.3),('8784','2013-11-02','11:05:00',1.47),('8784','2013-11-02','11:10:00',1.26),('8784','2013-11-02','11:50:00',1.28),('8784','2013-11-02','11:55:00',2.07),('8784','2013-11-02','12:00:00',3.02),('8784','2013-11-02','12:05:00',3.05),('8784','2013-11-02','12:10:00',2.83),('8784','2013-11-02','12:15:00',2.67),('8784','2013-11-02','12:20:00',3.08),('8784','2013-11-02','12:25:00',3.04),('8784','2013-11-02','12:30:00',3.38),('8784','2013-11-02','12:35:00',2.86),('8784','2013-11-02','12:40:00',2.69),('8784','2013-11-02','12:45:00',2),('8784','2013-11-02','12:50:00',2.8),('8784','2013-11-02','12:55:00',2.93),('8784','2013-11-02','13:00:00',2.27),('8784','2013-11-02','13:05:00',2.98),('8784','2013-11-02','13:10:00',3.07),('8784','2013-11-02','13:15:00',1.45),('8784','2013-11-02','13:20:00',1.05),('8784','2013-11-02','13:25:00',1.08),('8784','2013-11-02','13:30:00',1.47),('8784','2013-11-02','13:35:00',2.52),('8784','2013-11-02','13:40:00',2.42),('8784','2013-11-02','13:45:00',2.73),('8784','2013-11-02','13:50:00',2.79),('8784','2013-11-02','13:55:00',2.65),('8784','2013-11-02','14:00:00',2.39),('8784','2013-11-02','14:05:00',2.07),('8784','2013-11-02','14:10:00',1.88),('8784','2013-11-02','14:15:00',1.81),('8784','2013-11-02','14:20:00',1.73),('8784','2013-11-02','14:25:00',1.67),('8784','2013-11-02','14:30:00',1.61),('8784','2013-11-02','14:35:00',1.56),('8784','2013-11-02','14:40:00',1.46),('8784','2013-11-02','14:45:00',1.42),('8784','2013-11-02','14:50:00',1.37),('8784','2013-11-02','14:55:00',1.22),('8784','2013-11-02','15:00:00',1.24),('8784','2013-11-02','15:10:00',1.13),('8784','2013-11-01','08:40:00',1.11),('8784','2013-11-01','08:45:00',1.14),('8784','2013-11-01','08:50:00',1.11),('8784','2013-11-01','08:55:00',1.12),('8784','2013-11-01','09:00:00',1.21),('8784','2013-11-01','09:05:00',1.44),('8784','2013-11-01','09:10:00',1.55),('8784','2013-11-01','09:15:00',1.62),('8784','2013-11-01','09:20:00',1.67),('8784','2013-11-01','09:25:00',1.71),('8784','2013-11-01','09:30:00',1.77),('8784','2013-11-01','09:35:00',1.86),('8784','2013-11-01','09:40:00',2),('8784','2013-11-01','09:45:00',2.01),('8784','2013-11-01','09:50:00',2.09),('8784','2013-11-01','09:55:00',2.15),('8784','2013-11-01','10:00:00',2.22),('8784','2013-11-01','10:05:00',2.27),('8784','2013-11-01','10:10:00',2.26),('8784','2013-11-01','10:15:00',2.32),('8784','2013-11-01','10:20:00',2.37),('8784','2013-11-01','10:25:00',2.42),('8784','2013-11-01','10:30:00',2.37),('8784','2013-11-01','10:35:00',2.41),('8784','2013-11-01','10:40:00',2.45),('8784','2013-11-01','10:45:00',2.43),('8784','2013-11-01','10:50:00',2.42),('8784','2013-11-01','10:55:00',2.43),('8784','2013-11-01','11:00:00',2.42),('8784','2013-11-01','11:05:00',2.22),('8784','2013-11-01','11:10:00',1.98),('8784','2013-11-01','11:15:00',2.24),('8784','2013-11-01','11:20:00',2.56),('8784','2013-11-01','11:25:00',2.71),('8784','2013-11-01','11:30:00',2.75),('8784','2013-11-01','11:35:00',2.65),('8784','2013-11-01','11:40:00',2.34),('8784','2013-11-01','11:45:00',2.5),('8784','2013-11-01','11:50:00',2.73),('8784','2013-11-01','11:55:00',2.78),('8784','2013-11-01','12:00:00',2.71),('8784','2013-11-01','12:05:00',2.62),('8784','2013-11-01','12:10:00',2.44),('8784','2013-11-01','12:15:00',2.24),('8784','2013-11-01','12:20:00',2.08),('8784','2013-11-01','12:25:00',2.13),('8784','2013-11-01','12:30:00',1.88),('8784','2013-11-01','13:15:00',1.17),('8784','2013-11-01','13:20:00',1.17),('8784','2013-11-01','13:25:00',1.04),('8784','2013-11-01','13:30:00',1.23),('8784','2013-11-01','13:35:00',1.23),('8784','2013-11-01','13:40:00',1.09),('8784','2013-10-31','08:40:00',1.22),('8784','2013-10-31','08:45:00',1.24),('8784','2013-10-31','08:50:00',1.33),('8784','2013-10-31','08:55:00',1.29),('8784','2013-10-31','09:00:00',1.29),('8784','2013-10-31','09:05:00',1.2),('8784','2013-10-31','09:20:00',1.41),('8784','2013-10-31','09:25:00',1.44),('8784','2013-10-31','09:30:00',1.47),('8784','2013-10-31','09:35:00',1.64),('8784','2013-10-31','09:40:00',1.6),('8784','2013-10-31','09:50:00',1.61),('8784','2013-10-31','09:55:00',1.67),('8784','2013-10-31','10:00:00',1.73),('8784','2013-10-31','10:05:00',1.71),('8784','2013-10-31','10:10:00',1.59),('8784','2013-10-31','10:15:00',1.44),('8784','2013-10-31','10:20:00',1.39),('8784','2013-10-31','10:25:00',1.52),('8784','2013-10-31','10:30:00',1.58),('8784','2013-10-31','10:35:00',1.77),('8784','2013-10-31','10:40:00',1.82),('8784','2013-10-31','10:45:00',1.67),('8784','2013-10-31','10:50:00',1.7),('8784','2013-10-31','10:55:00',1.87),('8784','2013-10-31','11:00:00',2.25),('8784','2013-10-31','11:05:00',2.56),('8784','2013-10-31','11:10:00',2.5),('8784','2013-10-31','11:15:00',2.54),('8784','2013-10-31','11:20:00',2.42),('8784','2013-10-31','11:25:00',2.14),('8784','2013-10-31','11:30:00',2.42),('8784','2013-10-31','11:35:00',2.31),('8784','2013-10-31','11:40:00',2.56),('8784','2013-10-31','11:45:00',2.65),('8784','2013-10-31','11:50:00',2.63),('8784','2013-10-31','11:55:00',2.62),('8784','2013-10-31','12:00:00',2.57),('8784','2013-10-31','12:05:00',2.49),('8784','2013-10-31','12:10:00',2.58),('8784','2013-10-31','12:15:00',2.54),('8784','2013-10-31','12:20:00',2.49),('8784','2013-10-31','12:25:00',2.47),('8784','2013-10-31','12:30:00',2.22),('8784','2013-10-31','12:35:00',2.31),('8784','2013-10-31','12:40:00',2.4),('8784','2013-10-31','12:45:00',2.46),('8784','2013-10-31','12:50:00',2.53),('8784','2013-10-31','12:55:00',2.56),('8784','2013-10-31','13:00:00',2.49),('8784','2013-10-31','13:05:00',2.4),('8784','2013-10-31','13:10:00',2.35),('8784','2013-10-31','13:15:00',2.3),('8784','2013-10-31','13:20:00',2.26),('8784','2013-10-31','13:25:00',2.19),('8784','2013-10-31','13:30:00',2.1),('8784','2013-10-31','13:35:00',2.07),('8784','2013-10-31','13:40:00',1.91),('8784','2013-10-31','13:45:00',1.75),('8784','2013-10-31','13:50:00',1.36),('8784','2013-10-31','13:55:00',1.37),('8784','2013-10-31','14:00:00',1.78),('8784','2013-10-31','14:05:00',1.8),('8784','2013-10-31','14:10:00',1.65),('8784','2013-10-31','14:15:00',1.16),('8784','2013-10-31','14:25:00',1.22),('8784','2013-10-30','08:50:00',1.2),('8784','2013-10-30','08:55:00',1.16),('8784','2013-10-30','09:00:00',1.31),('8784','2013-10-30','09:05:00',1.45),('8784','2013-10-30','09:10:00',1.56),('8784','2013-10-30','09:15:00',1.59),('8784','2013-10-30','09:20:00',1.67),('8784','2013-10-30','09:25:00',1.76),('8784','2013-10-30','09:30:00',1.79),('8784','2013-10-30','09:35:00',1.87),('8784','2013-10-30','09:40:00',1.94),('8784','2013-10-30','09:45:00',2.03),('8784','2013-10-30','09:50:00',2.03),('8784','2013-10-30','09:55:00',1.94),('8784','2013-10-30','10:00:00',1.78),('8784','2013-10-30','10:05:00',1.95),('8784','2013-10-30','10:10:00',2.2),('8784','2013-10-30','10:15:00',2.37),('8784','2013-10-30','10:20:00',2.31),('8784','2013-10-30','10:25:00',2.22),('8784','2013-10-30','10:30:00',2.3),('8784','2013-10-30','10:35:00',2.22),('8784','2013-10-30','10:40:00',2.41),('8784','2013-10-30','10:45:00',2.44),('8784','2013-10-30','10:50:00',1.26),('8784','2013-10-30','10:55:00',1.53),('8784','2013-10-30','11:00:00',2.51),('8784','2013-10-30','11:05:00',2.49),('8784','2013-10-30','11:10:00',2.56),('8784','2013-10-30','11:15:00',2.52),('8784','2013-10-30','11:20:00',1.97),('8784','2013-10-30','11:25:00',1.44),('8784','2013-10-30','11:30:00',1.1),('8784','2013-10-30','11:40:00',1.14),('8784','2013-10-30','11:45:00',1.56),('8784','2013-10-30','11:50:00',1.43),('8784','2013-10-30','12:00:00',1.05),('8784','2013-10-30','12:05:00',1.15),('8784','2013-10-30','12:10:00',1.17),('8784','2013-10-30','12:15:00',2.37),('8784','2013-10-30','12:20:00',2.17),('8784','2013-10-30','12:25:00',2.64),('8784','2013-10-30','12:30:00',2.34),('8784','2013-10-30','12:35:00',1.26),('8784','2013-10-30','12:40:00',1.22),('8784','2013-10-30','12:45:00',1.21),('8784','2013-10-30','12:50:00',1.26),('8784','2013-10-30','12:55:00',2.62),('8784','2013-10-30','13:00:00',1.85),('8784','2013-10-30','13:05:00',2.49),('8784','2013-10-30','13:10:00',2.53),('8784','2013-10-30','13:15:00',2.71),('8784','2013-10-30','13:20:00',2.63),('8784','2013-10-30','13:25:00',2.66),('8784','2013-10-30','13:30:00',1.47),('8784','2013-10-30','13:35:00',1.29),('8784','2013-10-30','13:40:00',2.27),('8784','2013-10-30','13:45:00',2.13),('8784','2013-10-30','13:50:00',1.23),('8784','2013-10-30','13:55:00',2.1),('8784','2013-10-30','14:00:00',2.27),('8784','2013-10-30','14:05:00',2.3),('8784','2013-10-30','14:10:00',1.11),('8784','2013-10-30','14:40:00',1.54),('8784','2013-10-30','14:45:00',1.33),('8784','2013-10-30','15:15:00',1.02),('8784','2013-10-30','15:20:00',1.02),('8784','2013-10-29','08:50:00',1.06),('8784','2013-10-29','08:55:00',1.35),('8784','2013-10-29','09:00:00',1.44),('8784','2013-10-29','09:05:00',1.54),('8784','2013-10-29','09:10:00',1.62),('8784','2013-10-29','09:15:00',1.69),('8784','2013-10-29','09:20:00',1.8),('8784','2013-10-29','09:25:00',1.83),('8784','2013-10-29','09:30:00',1.89),('8784','2013-10-29','09:35:00',2),('8784','2013-10-29','09:40:00',1.88),('8784','2013-10-29','09:45:00',2.11),('8784','2013-10-29','09:50:00',2.06),('8784','2013-10-29','09:55:00',2.14),('8784','2013-10-29','10:00:00',2.31),('8784','2013-10-29','10:05:00',1.59),('8784','2013-10-29','10:10:00',1.59),('8784','2013-10-29','10:15:00',1.05),('8784','2013-10-29','10:25:00',1.1),('8784','2013-10-29','10:30:00',1),('8784','2013-10-29','10:35:00',1.96),('8784','2013-10-29','10:40:00',2.55),('8784','2013-10-29','10:45:00',2.88),('8784','2013-10-29','10:50:00',2.82),('8784','2013-10-29','10:55:00',3.03),('8784','2013-10-29','11:00:00',2.95),('8784','2013-10-29','11:05:00',2.89),('8784','2013-10-29','11:10:00',2.95),('8784','2013-10-29','11:15:00',2.77),('8784','2013-10-29','11:20:00',2.73),('8784','2013-10-29','11:25:00',2.75),('8784','2013-10-29','11:30:00',2.76),('8784','2013-10-29','11:35:00',2.81),('8784','2013-10-29','11:40:00',2.72),('8784','2013-10-29','11:45:00',2.78),('8784','2013-10-29','11:50:00',2.75),('8784','2013-10-29','11:55:00',2.7),('8784','2013-10-29','12:00:00',2.6),('8784','2013-10-29','12:05:00',2.6),('8784','2013-10-29','12:10:00',2.61),('8784','2013-10-29','12:15:00',2.59),('8784','2013-10-29','12:20:00',2.56),('8784','2013-10-29','12:25:00',2.45),('8784','2013-10-29','12:30:00',2.28),('8784','2013-10-29','12:35:00',2.49),('8784','2013-10-29','12:40:00',2.45),('8784','2013-10-29','12:45:00',2.33),('8784','2013-10-29','12:50:00',2.16),('8784','2013-10-29','12:55:00',2.29),('8784','2013-10-29','13:00:00',2.27),('8784','2013-10-29','13:05:00',2.27),('8784','2013-10-29','13:10:00',2.32),('8784','2013-10-29','13:15:00',2.27),('8784','2013-10-29','13:20:00',2.26),('8784','2013-10-29','13:25:00',2.17),('8784','2013-10-29','13:30:00',2.18),('8784','2013-10-29','13:35:00',2.13),('8784','2013-10-29','13:40:00',1.99),('8784','2013-10-29','13:45:00',1.78),('8784','2013-10-29','13:50:00',1.74),('8784','2013-10-29','13:55:00',1.8),('8784','2013-10-29','14:00:00',1.55),('8784','2013-10-29','14:05:00',1.81),('8784','2013-10-29','14:10:00',1.75),('8784','2013-10-29','14:15:00',1.72),('8784','2013-10-29','14:20:00',1.69),('8784','2013-10-29','14:25:00',1.62),('8784','2013-10-29','14:30:00',1.57),('8784','2013-10-29','14:35:00',1.52),('8784','2013-10-29','14:40:00',1.44),('8784','2013-10-29','14:45:00',1.37),('8784','2013-10-29','14:50:00',1.32),('8784','2013-10-29','14:55:00',1.25),('8784','2013-10-29','15:00:00',1.18),('8784','2013-10-29','15:05:00',1.14),('8784','2013-10-29','15:10:00',1.1),('8784','2013-10-29','15:15:00',1.05),('8784','2014-04-17','08:00:00',1.25),('8784','2014-04-17','08:05:00',1.38),('8784','2014-04-17','08:10:00',1.48),('8784','2014-04-17','08:15:00',1.58),('8784','2014-04-17','08:20:00',1.62),('8784','2014-04-17','08:25:00',1.73),('8784','2014-04-17','08:30:00',1.8),('8784','2014-04-17','08:35:00',1.91),('8784','2014-04-17','08:40:00',2.02),('8784','2014-04-17','08:45:00',2.11),('8784','2014-04-17','08:50:00',2.23),('8784','2014-04-17','08:55:00',2.07),('8784','2014-04-17','09:00:00',1.96),('8784','2014-04-17','09:05:00',2.34),('8784','2014-04-17','09:10:00',2.55),('8784','2014-04-17','09:15:00',2.62),('8784','2014-04-17','09:20:00',2.75),('8784','2014-04-17','09:25:00',2.82),('8784','2014-04-17','09:30:00',2.9),('8784','2014-04-17','09:35:00',3),('8784','2014-04-17','09:40:00',3.08),('8784','2014-04-17','09:45:00',3.15),('8784','2014-04-17','09:50:00',3.2),('8784','2014-04-17','09:55:00',3.35),('8784','2014-04-17','10:00:00',3.49),('8784','2014-04-17','10:05:00',3.8),('8784','2014-04-17','10:10:00',3.65),('8784','2014-04-17','10:15:00',2.75),('8784','2014-04-17','10:20:00',3.87),('8784','2014-04-17','10:25:00',4.03),('8784','2014-04-17','10:30:00',4.28),('8784','2014-04-17','10:35:00',4.49),('8784','2014-04-17','10:40:00',4.09),('8784','2014-04-17','10:45:00',3.75),('8784','2014-04-17','10:50:00',2.77),('8784','2014-04-17','10:55:00',2.58),('8784','2014-04-17','11:00:00',2.91),('8784','2014-04-17','11:05:00',3.15),('8784','2014-04-17','11:10:00',3.32),('8784','2014-04-17','11:15:00',2.5),('8784','2014-04-17','11:20:00',3.26),('8784','2014-04-17','11:25:00',4.29),('8784','2014-04-17','11:30:00',2.67),('8784','2014-04-17','11:35:00',2.49),('8784','2014-04-17','11:40:00',2.62),('8784','2014-04-17','11:45:00',4.24),('8784','2014-04-17','11:50:00',3.29),('8784','2014-04-17','11:55:00',2.4),('8784','2014-04-17','12:00:00',3.06),('8784','2014-04-17','12:05:00',3.24),('8784','2014-04-17','12:10:00',2.83),('8784','2014-04-17','12:15:00',2.51),('8784','2014-04-17','12:20:00',2.55),('8784','2014-04-17','12:25:00',2.8),('8784','2014-04-17','12:30:00',3.63),('8784','2014-04-17','12:35:00',3.87),('8784','2014-04-17','12:40:00',4.56),('8784','2014-04-17','12:45:00',4.31),('8784','2014-04-17','12:50:00',1.8),('8784','2014-04-17','12:55:00',3.74),('8784','2014-04-17','13:00:00',4.79),('8784','2014-04-17','13:05:00',4.14),('8784','2014-04-17','13:10:00',4.4),('8784','2014-04-17','13:15:00',2.97),('8784','2014-04-17','13:20:00',1.52),('8784','2014-04-17','13:25:00',4.19),('8784','2014-04-17','13:30:00',5.4),('8784','2014-04-17','13:35:00',2.04),('8784','2014-04-17','13:40:00',1.01),('8784','2014-04-17','13:45:00',1.02),('8784','2014-04-17','13:50:00',1.38),('8784','2014-04-17','13:55:00',1.43),('8784','2014-04-17','14:00:00',1.14),('8784','2014-04-17','14:05:00',1.25),('8784','2014-04-17','14:10:00',2.74),('8784','2014-04-17','14:15:00',4.09),('8784','2014-04-17','14:20:00',1.55),('8784','2014-04-17','14:25:00',2.05),('8784','2014-04-17','14:30:00',2.23),('8784','2014-04-17','14:35:00',2.35),('8784','2014-04-17','14:40:00',4.09),('8784','2014-04-17','14:45:00',1.58),('8784','2014-04-17','15:25:00',1.3),('8784','2014-04-17','15:30:00',2.07),('8784','2014-04-17','15:35:00',2.75),('8784','2014-04-17','15:40:00',1.95),('8784','2014-04-17','15:45:00',1.44),('8784','2014-04-17','15:50:00',1.32),('8784','2014-04-17','15:55:00',1.47),('8784','2014-04-17','16:00:00',1.23),('8784','2014-04-17','16:05:00',1),('8784','2014-04-17','16:10:00',1.13),('8784','2014-04-17','16:15:00',1.15),('8784','2014-04-17','16:20:00',1.12),('8784','2014-04-17','16:25:00',1.26),('8784','2014-04-17','16:30:00',1.28),('8784','2014-04-17','16:35:00',1.16),('8784','2014-04-17','16:40:00',1.34),('8784','2014-04-17','16:45:00',1.79),('8784','2014-04-17','16:50:00',1.73),('8784','2014-04-17','16:55:00',1.3),('8784','2014-04-17','17:00:00',1.08),('8784','2014-04-17','17:15:00',1.04),('8784','2014-04-17','17:20:00',1.16),('8784','2014-04-17','17:25:00',1.02),('8784','2014-04-17','17:30:00',1.05),('8784','2014-04-17','17:35:00',1.09),('8784','2014-04-17','17:40:00',1.04),('8784','2013-10-28','09:00:00',1.17),('8784','2013-10-28','09:05:00',1.78),('8784','2013-10-28','09:10:00',1.89),('8784','2013-10-28','09:15:00',1.9),('8784','2013-10-28','09:20:00',1.72),('8784','2013-10-28','09:25:00',1.97),('8784','2013-10-28','09:30:00',2.01),('8784','2013-10-28','09:35:00',1.63),('8784','2013-10-28','09:40:00',2.22),('8784','2013-10-28','09:45:00',2.31),('8784','2013-10-28','09:50:00',2.13),('8784','2013-10-28','09:55:00',1.65),('8784','2013-10-28','10:50:00',2.69),('8784','2013-10-28','10:55:00',2.65),('8784','2013-10-28','11:00:00',2.65),('8784','2013-10-28','11:05:00',2.63),('8784','2013-10-28','11:10:00',2.64),('8784','2013-10-28','11:15:00',2.66),('8784','2013-10-28','11:20:00',2.7),('8784','2013-10-28','11:25:00',2.69),('8784','2013-10-28','11:30:00',2.7),('8784','2013-10-28','11:35:00',2.68),('8784','2013-10-28','11:40:00',2.71),('8784','2013-10-28','11:45:00',2.71),('8784','2013-10-28','11:50:00',2.73),('8784','2013-10-28','11:55:00',2.3),('8784','2013-10-28','12:00:00',2.08),('8784','2013-10-28','12:05:00',2.07),('8784','2013-10-28','12:10:00',2.8),('8784','2013-10-28','12:15:00',2.82),('8784','2013-10-28','12:20:00',2.49),('8784','2013-10-28','12:25:00',2.04),('8784','2013-10-28','12:30:00',2.79),('8784','2013-10-28','12:35:00',3.14),('8784','2013-10-28','12:40:00',2.81),('8784','2013-10-28','12:45:00',2.91),('8784','2013-10-28','12:50:00',2.85),('8784','2013-10-28','12:55:00',2.59),('8784','2013-10-28','13:00:00',2.51),('8784','2013-10-28','13:05:00',2.51),('8784','2013-10-28','13:10:00',2.45),('8784','2013-10-28','13:15:00',2.43),('8784','2013-10-28','13:20:00',2.32),('8784','2013-10-28','13:25:00',2.31),('8784','2013-10-28','13:30:00',2.26),('8784','2013-10-28','13:35:00',2.2),('8784','2013-10-28','13:40:00',2.2),('8784','2013-10-28','13:45:00',1.91),('8784','2013-10-28','13:50:00',2.03),('8784','2013-10-28','13:55:00',2.11),('8784','2013-10-28','14:00:00',2.14),('8784','2013-10-28','14:05:00',2.18),('8784','2013-10-28','14:10:00',2.08),('8784','2013-10-28','14:15:00',1.94),('8784','2013-10-28','14:20:00',1.96),('8784','2013-10-28','14:25:00',1.97),('8784','2013-10-28','14:30:00',1.02),('8784','2013-10-28','14:35:00',1.58),('8784','2013-10-28','14:45:00',1.64),('8784','2013-10-28','14:50:00',1.48),('8784','2013-10-28','14:55:00',1.43),('8784','2013-10-28','15:00:00',1.35),('8784','2013-10-28','15:05:00',1.28),('8784','2013-10-28','15:10:00',1.22),('8784','2013-10-28','15:40:00',1.01),('8784','2013-10-27','09:55:00',1.08),('8784','2013-10-27','10:00:00',1.13),('8784','2013-10-27','10:05:00',1.15),('8784','2013-10-27','10:10:00',1.21),('8784','2013-10-27','10:15:00',1.28),('8784','2013-10-27','10:20:00',1.36),('8784','2013-10-27','10:25:00',1.34),('8784','2013-10-27','10:30:00',1.32),('8784','2013-10-27','10:35:00',1.36),('8784','2013-10-27','10:40:00',1.38),('8784','2013-10-27','10:45:00',1.51),('8784','2013-10-27','10:50:00',1.52),('8784','2013-10-27','10:55:00',1.38),('8784','2013-10-27','11:00:00',1.23),('8784','2013-10-27','11:05:00',1.07),('8784','2013-10-27','11:30:00',1.16),('8784','2013-10-27','11:35:00',1.55),('8784','2013-10-27','11:40:00',2.29),('8784','2013-10-27','11:45:00',2.48),('8784','2013-10-27','11:50:00',1.35),('8784','2013-10-27','11:55:00',1.17),('8784','2013-10-27','12:00:00',1.28),('8784','2013-10-27','12:05:00',1.33),('8784','2013-10-27','12:10:00',1.2),('8784','2013-10-27','12:15:00',1.6),('8784','2013-10-27','12:20:00',2.5),('8784','2013-10-27','12:25:00',2.63),('8784','2013-10-27','12:30:00',2.32),('8784','2013-10-27','12:35:00',3.32),('8784','2013-10-27','12:40:00',1.93),('8784','2013-10-27','12:45:00',2.61),('8784','2013-10-27','12:50:00',2.95),('8784','2013-10-27','12:55:00',2.3),('8784','2013-10-27','13:00:00',1.42),('8784','2013-10-27','13:05:00',1.4),('8784','2013-10-27','13:10:00',1.71),('8784','2013-10-27','13:15:00',1.03),('8784','2013-10-27','13:25:00',1.85),('8784','2013-10-27','13:30:00',2.46),('8784','2013-10-27','13:35:00',2.1),('8784','2013-10-27','13:40:00',1.16),('8784','2013-10-27','14:00:00',1.17),('8784','2013-10-27','14:10:00',1.06),('8784','2013-10-27','14:15:00',1.25),('8784','2013-10-27','14:20:00',1.13),('8784','2013-10-27','14:25:00',1.09),('8784','2013-10-27','14:30:00',1.67),('8784','2013-10-27','14:35:00',1.51),('8784','2013-10-27','14:40:00',1.62),('8784','2013-10-27','14:45:00',1.16),('8784','2013-10-27','14:55:00',1.1),('8784','2013-10-27','15:00:00',1.33),('8784','2013-10-27','15:05:00',1.18),('8784','2013-10-27','15:10:00',1.22),('8784','2013-10-27','15:15:00',1.16),('8784','2013-10-27','15:20:00',1.1),('8784','2013-10-26','09:20:00',1.05),('8784','2013-10-26','09:25:00',1.14),('8784','2013-10-26','09:35:00',1.07),('8784','2013-10-26','09:40:00',1.16),('8784','2013-10-26','09:45:00',1.35),('8784','2013-10-26','09:50:00',1.36),('8784','2013-10-26','09:55:00',1.49),('8784','2013-10-26','10:00:00',1.6),('8784','2013-10-26','10:05:00',1.66),('8784','2013-10-26','10:10:00',1.74),('8784','2013-10-26','10:15:00',1.8),('8784','2013-10-26','10:20:00',1.86),('8784','2013-10-26','10:25:00',1.94),('8784','2013-10-26','10:30:00',1.99),('8784','2013-10-26','10:35:00',2.07),('8784','2013-10-26','10:40:00',2.13),('8784','2013-10-26','10:45:00',2.19),('8784','2013-10-26','10:50:00',2.25),('8784','2013-10-26','10:55:00',2.29),('8784','2013-10-26','11:00:00',2.32),('8784','2013-10-26','11:05:00',2.35),('8784','2013-10-26','11:10:00',2.37),('8784','2013-10-26','11:15:00',2.4),('8784','2013-10-26','11:20:00',2.46),('8784','2013-10-26','11:25:00',2.49),('8784','2013-10-26','11:30:00',2.5),('8784','2013-10-26','11:35:00',2.54),('8784','2013-10-26','11:40:00',2.57),('8784','2013-10-26','11:45:00',2.57),('8784','2013-10-26','11:50:00',2.6),('8784','2013-10-26','11:55:00',2.6),('8784','2013-10-26','12:00:00',2.62),('8784','2013-10-26','12:05:00',2.6),('8784','2013-10-26','12:10:00',2.62),('8784','2013-10-26','12:15:00',2.6),('8784','2013-10-26','12:20:00',2.67),('8784','2013-10-26','12:25:00',2.66),('8784','2013-10-26','12:30:00',2.58),('8784','2013-10-26','12:35:00',2.66),('8784','2013-10-26','12:40:00',2.69),('8784','2013-10-26','12:45:00',2.5),('8784','2013-10-26','12:50:00',2.58),('8784','2013-10-26','12:55:00',2.58),('8784','2013-10-26','13:00:00',2.61),('8784','2013-10-26','13:05:00',2.52),('8784','2013-10-26','13:10:00',2.17),('8784','2013-10-26','13:15:00',2.67),('8784','2013-10-26','13:20:00',2.49),('8784','2013-10-26','13:25:00',2.54),('8784','2013-10-26','13:30:00',2.57),('8784','2013-10-26','13:35:00',2.65),('8784','2013-10-26','13:40:00',2.58),('8784','2013-10-26','13:45:00',2.52),('8784','2013-10-26','13:50:00',2.47),('8784','2013-10-26','13:55:00',2.33),('8784','2013-10-26','14:00:00',2.19),('8784','2013-10-26','14:05:00',2.13),('8784','2013-10-26','14:10:00',2.18),('8784','2013-10-26','14:15:00',1.55),('8784','2013-10-26','14:20:00',1.51),('8784','2013-10-26','14:25:00',1.43),('8784','2013-10-26','14:30:00',1.78),('8784','2013-10-26','14:35:00',1.82),('8784','2013-10-26','14:40:00',1.85),('8784','2013-10-26','14:45:00',1.74),('8784','2013-10-26','14:50:00',1.32),('8784','2013-10-26','14:55:00',1.67),('8784','2013-10-26','15:00:00',1.83),('8784','2013-10-26','15:05:00',1.8),('8784','2013-10-26','15:10:00',1.84),('8784','2013-10-26','15:15:00',1.66),('8784','2013-10-26','15:20:00',1.58),('8784','2013-10-26','15:25:00',1.68),('8784','2013-10-26','15:30:00',1.64),('8784','2013-10-26','15:35:00',1.74),('8784','2013-10-26','15:40:00',1.59),('8784','2013-10-26','15:45:00',1.51),('8784','2013-10-26','15:50:00',1.4),('8784','2013-10-26','15:55:00',1.28),('8784','2013-10-26','16:00:00',1.22),('8784','2013-10-26','16:05:00',1.18),('8784','2013-10-26','16:10:00',1.15),('8784','2013-10-26','16:15:00',1.05),('8784','2013-10-26','16:20:00',1.01),('8784','2013-10-25','09:15:00',1.02),('8784','2013-10-25','09:20:00',1.1),('8784','2013-10-25','09:25:00',1.16),('8784','2013-10-25','09:30:00',1.01),('8784','2013-10-25','09:35:00',1.26),('8784','2013-10-25','09:40:00',1.31),('8784','2013-10-25','09:45:00',1.37),('8784','2013-10-25','09:50:00',1.51),('8784','2013-10-25','09:55:00',1.56),('8784','2013-10-25','10:00:00',1.64),('8784','2013-10-25','10:05:00',1.71),('8784','2013-10-25','10:10:00',1.72),('8784','2013-10-25','10:15:00',1.88),('8784','2013-10-25','10:20:00',1.93),('8784','2013-10-25','10:25:00',1.99),('8784','2013-10-25','10:30:00',2.06),('8784','2013-10-25','10:35:00',2.14),('8784','2013-10-25','10:40:00',2.17),('8784','2013-10-25','10:45:00',2.19),('8784','2013-10-25','10:50:00',2.24),('8784','2013-10-25','10:55:00',2.3),('8784','2013-10-25','11:00:00',2.33),('8784','2013-10-25','11:05:00',2.38),('8784','2013-10-25','11:10:00',2.46),('8784','2013-10-25','11:15:00',2.44),('8784','2013-10-25','11:20:00',2.43),('8784','2013-10-25','11:25:00',2.45),('8784','2013-10-25','11:30:00',2.52),('8784','2013-10-25','11:35:00',2.57),('8784','2013-10-25','11:40:00',2.63),('8784','2013-10-25','11:45:00',2.68),('8784','2013-10-25','11:50:00',2.7),('8784','2013-10-25','11:55:00',2.71),('8784','2013-10-25','12:00:00',2.73),('8784','2013-10-25','12:05:00',2.74),('8784','2013-10-25','12:10:00',2.76),('8784','2013-10-25','12:15:00',2.78),('8784','2013-10-25','12:20:00',2.79),('8784','2013-10-25','12:25:00',2.79),('8784','2013-10-25','12:30:00',2.78),('8784','2013-10-25','12:35:00',2.81),('8784','2013-10-25','12:40:00',2.8),('8784','2013-10-25','12:45:00',2.81),('8784','2013-10-25','12:50:00',2.8),('8784','2013-10-25','12:55:00',2.8),('8784','2013-10-25','13:00:00',2.75),('8784','2013-10-25','13:05:00',2.75),('8784','2013-10-25','13:10:00',2.68),('8784','2013-10-25','13:15:00',2.72),('8784','2013-10-25','13:20:00',2.7),('8784','2013-10-25','13:25:00',2.67),('8784','2013-10-25','13:30:00',2.62),('8784','2013-10-25','13:35:00',2.61),('8784','2013-10-25','13:40:00',2.52),('8784','2013-10-25','13:45:00',2.58),('8784','2013-10-25','13:50:00',2.56),('8784','2013-10-25','13:55:00',2.49),('8784','2013-10-25','14:00:00',2.48),('8784','2013-10-25','14:05:00',2.44),('8784','2013-10-25','14:10:00',2.37),('8784','2013-10-25','14:15:00',2.38),('8784','2013-10-25','14:20:00',2.38),('8784','2013-10-25','14:25:00',2.34),('8784','2013-10-25','14:30:00',2.32),('8784','2013-10-25','14:35:00',2.25),('8784','2013-10-25','14:40:00',2.17),('8784','2013-10-25','14:45:00',2.11),('8784','2013-10-25','14:50:00',2.03),('8784','2013-10-25','14:55:00',1.99),('8784','2013-10-25','15:00:00',1.93),('8784','2013-10-25','15:05:00',1.92),('8784','2013-10-25','15:10:00',1.88),('8784','2013-10-25','15:15:00',1.83),('8784','2013-10-25','15:20:00',1.79),('8784','2013-10-25','15:25:00',1.71),('8784','2013-10-25','15:30:00',1.63),('8784','2013-10-25','15:35:00',1.57),('8784','2013-10-25','15:40:00',1.57),('8784','2013-10-25','15:45:00',1.5),('8784','2013-10-25','15:50:00',1.42),('8784','2013-10-25','15:55:00',1.38),('8784','2013-10-25','16:00:00',1.31),('8784','2013-10-25','16:05:00',1.27),('8784','2013-10-25','16:10:00',1.19),('8784','2013-10-25','16:15:00',1.15),('8784','2013-10-25','16:20:00',1.11),('8784','2013-10-25','16:25:00',1.04),('8784','2013-10-24','09:05:00',1.08),('8784','2013-10-24','09:15:00',1.14),('8784','2013-10-24','09:20:00',1.01),('8784','2013-10-24','09:35:00',1.07),('8784','2013-10-24','09:40:00',1.14),('8784','2013-10-24','09:45:00',1.17),('8784','2013-10-24','09:50:00',1.19),('8784','2013-10-24','09:55:00',1.13),('8784','2013-10-24','10:00:00',1.11),('8784','2013-10-24','10:05:00',1.07),('8784','2013-10-24','10:20:00',1.48),('8784','2013-10-24','10:35:00',1.66),('8784','2013-10-24','10:40:00',1.12),('8784','2013-10-24','10:45:00',2.07),('8784','2013-10-24','10:50:00',1.63),('8784','2013-10-24','10:55:00',1.99),('8784','2013-10-24','11:00:00',2.87),('8784','2013-10-24','11:05:00',3.29),('8784','2013-10-24','11:10:00',2.19),('8784','2013-10-24','11:15:00',1.89),('8784','2013-10-24','11:20:00',1.77),('8784','2013-10-24','11:25:00',1.54),('8784','2013-10-24','11:30:00',1.21),('8784','2013-10-24','11:35:00',1.2),('8784','2013-10-24','11:40:00',1.14),('8784','2013-10-24','11:45:00',1.25),('8784','2013-10-24','11:50:00',1.88),('8784','2013-10-24','11:55:00',2.66),('8784','2013-10-24','12:00:00',1.74),('8784','2013-10-24','12:05:00',1.46),('8784','2013-10-24','12:10:00',1.36),('8784','2013-10-24','12:15:00',1.36),('8784','2013-10-24','12:20:00',1.43),('8784','2013-10-24','12:25:00',1.54),('8784','2013-10-24','12:30:00',1.6),('8784','2013-10-24','12:35:00',1.75),('8784','2013-10-24','12:40:00',2),('8784','2013-10-24','12:45:00',2.34),('8784','2013-10-24','12:50:00',1.97),('8784','2013-10-24','12:55:00',2.9),('8784','2013-10-24','13:00:00',3.06),('8784','2013-10-24','13:05:00',3.17),('8784','2013-10-24','13:10:00',2.58),('8784','2013-10-24','13:15:00',2.27),('8784','2013-10-24','13:20:00',2.27),('8784','2013-10-24','13:25:00',1.84),('8784','2013-10-24','13:30:00',1.38),('8784','2013-10-24','13:35:00',1.33),('8784','2013-10-24','13:40:00',1.33),('8784','2013-10-24','13:45:00',1.43),('8784','2013-10-24','13:50:00',1.91),('8784','2013-10-24','13:55:00',2.15),('8784','2013-10-24','14:00:00',2.23),('8784','2013-10-24','14:05:00',1.56),('8784','2013-10-24','14:10:00',1.42),('8784','2013-10-24','14:15:00',1.37),('8784','2013-10-24','14:20:00',1.49),('8784','2013-10-24','14:25:00',1.51),('8784','2013-10-24','14:30:00',1.56),('8784','2013-10-24','14:35:00',1.78),('8784','2013-10-24','14:40:00',1.92),('8784','2013-10-24','14:45:00',2.08),('8784','2013-10-24','14:50:00',1.51),('8784','2013-10-24','15:05:00',1.23),('8784','2013-10-24','15:10:00',1.78),('8784','2013-10-24','15:15:00',1.14),('8784','2013-10-24','15:20:00',1.26),('8784','2013-10-24','15:25:00',1.03),('8784','2013-10-24','15:30:00',1.28),('8784','2013-10-24','15:35:00',1.99),('8784','2013-10-24','15:40:00',1.86),('8784','2013-10-24','15:45:00',1.75),('8784','2013-10-24','15:50:00',1.09),('8784','2013-10-23','10:20:00',1.15),('8784','2013-10-23','10:25:00',1.19),('8784','2013-10-23','10:30:00',1.21),('8784','2013-10-23','10:35:00',1.31),('8784','2013-10-23','10:40:00',1.16),('8784','2013-10-23','10:45:00',1.16),('8784','2013-10-23','10:50:00',1.37),('8784','2013-10-23','10:55:00',1.31),('8784','2013-10-23','11:00:00',1.45),('8784','2013-10-23','11:05:00',1.64),('8784','2013-10-23','11:10:00',1.82),('8784','2013-10-23','11:15:00',1.79),('8784','2013-10-23','11:20:00',2.54),('8784','2013-10-23','11:25:00',2.52),('8784','2013-10-23','11:30:00',2.64),('8784','2013-10-23','11:35:00',2.6),('8784','2013-10-23','11:40:00',2.57),('8784','2013-10-23','11:45:00',2.63),('8784','2013-10-23','11:50:00',2.7),('8784','2013-10-23','11:55:00',2.65),('8784','2013-10-23','12:00:00',2.58),('8784','2013-10-23','12:05:00',2.56),('8784','2013-10-23','12:10:00',2.47),('8784','2013-10-23','12:15:00',2.34),('8784','2013-10-23','12:20:00',2.59),('8784','2013-10-23','12:25:00',2.65),('8784','2013-10-23','12:30:00',2.66),('8784','2013-10-23','12:35:00',2.7),('8784','2013-10-23','12:40:00',2.63),('8784','2013-10-23','12:45:00',2.58),('8784','2013-10-23','12:50:00',1.87),('8784','2013-10-23','12:55:00',2.02),('8784','2013-10-23','13:00:00',2.38),('8784','2013-10-23','13:05:00',2.64),('8784','2013-10-23','13:10:00',2.55),('8784','2013-10-23','13:15:00',2.41),('8784','2013-10-23','13:20:00',2.54),('8784','2013-10-23','13:25:00',2.58),('8784','2013-10-23','13:30:00',2.46),('8784','2013-10-23','13:35:00',2.43),('8784','2013-10-23','13:40:00',2.38),('8784','2013-10-23','13:45:00',2.35),('8784','2013-10-23','13:50:00',2.13),('8784','2013-10-23','13:55:00',2.19),('8784','2013-10-23','14:00:00',2.09),('8784','2013-10-23','14:05:00',2.33),('8784','2013-10-23','14:10:00',2.17),('8784','2013-10-23','14:15:00',2.26),('8784','2013-10-23','14:20:00',2.13),('8784','2013-10-23','14:25:00',2.04),('8784','2013-10-23','14:30:00',2.08),('8784','2013-10-23','14:35:00',2.03),('8784','2013-10-23','14:40:00',2.17),('8784','2013-10-23','14:45:00',2.08),('8784','2013-10-23','14:50:00',1.86),('8784','2013-10-23','14:55:00',1.96),('8784','2013-10-23','15:00:00',2.03),('8784','2013-10-23','15:05:00',2),('8784','2013-10-23','15:10:00',1.85),('8784','2013-10-23','15:15:00',1.74),('8784','2013-10-23','15:20:00',1.65),('8784','2013-10-23','15:25:00',1.81),('8784','2013-10-23','15:30:00',1.64),('8784','2013-10-23','15:35:00',1.52),('8784','2013-10-23','15:40:00',1.69),('8784','2013-10-23','15:45:00',1.68),('8784','2013-10-23','15:50:00',1.51),('8784','2013-10-23','15:55:00',1.2),('8784','2013-10-22','09:15:00',1.05),('8784','2013-10-22','09:20:00',1.11),('8784','2013-10-22','09:25:00',1.15),('8784','2013-10-22','09:30:00',1.21),('8784','2013-10-22','09:35:00',1.37),('8784','2013-10-22','09:40:00',1.43),('8784','2013-10-22','09:45:00',1.48),('8784','2013-10-22','09:50:00',1.57),('8784','2013-10-22','09:55:00',1.64),('8784','2013-10-22','10:00:00',1.72),('8784','2013-10-22','10:05:00',1.77),('8784','2013-10-22','10:10:00',1.83),('8784','2013-10-22','10:15:00',1.87),('8784','2013-10-22','10:20:00',1.94),('8784','2013-10-22','10:25:00',1.97),('8784','2013-10-22','10:30:00',1.99),('8784','2013-10-22','10:35:00',2.13),('8784','2013-10-22','10:40:00',2.13),('8784','2013-10-22','10:45:00',2.22),('8784','2013-10-22','10:50:00',2.26),('8784','2013-10-22','10:55:00',2.32),('8784','2013-10-22','11:00:00',2.35),('8784','2013-10-22','11:05:00',2.39),('8784','2013-10-22','11:10:00',2.41),('8784','2013-10-22','11:15:00',2.42),('8784','2013-10-22','11:20:00',2.42),('8784','2013-10-22','11:25:00',2.46),('8784','2013-10-22','11:30:00',2.49),('8784','2013-10-22','11:35:00',2.49),('8784','2013-10-22','11:40:00',2.54),('8784','2013-10-22','11:45:00',2.53),('8784','2013-10-22','11:50:00',2.57),('8784','2013-10-22','11:55:00',2.55),('8784','2013-10-22','12:00:00',2.61),('8784','2013-10-22','12:05:00',2.62),('8784','2013-10-22','12:10:00',2.64),('8784','2013-10-22','12:15:00',2.68),('8784','2013-10-22','12:20:00',2.64),('8784','2013-10-22','12:25:00',2.66),('8784','2013-10-22','12:30:00',2.7),('8784','2013-10-22','12:35:00',2.73),('8784','2013-10-22','12:40:00',2.7),('8784','2013-10-22','12:45:00',2.68),('8784','2013-10-22','12:50:00',2.7),('8784','2013-10-22','12:55:00',2.68),('8784','2013-10-22','13:00:00',2.61),('8784','2013-10-22','13:05:00',2.62),('8784','2013-10-22','13:10:00',2.62),('8784','2013-10-22','13:15:00',2.63),('8784','2013-10-22','13:20:00',2.6),('8784','2013-10-22','13:25:00',2.66),('8784','2013-10-22','13:30:00',2.55),('8784','2013-10-22','13:35:00',2.52),('8784','2013-10-22','13:40:00',2.39),('8784','2013-10-22','13:45:00',2.36),('8784','2013-10-22','13:50:00',2.41),('8784','2013-10-22','13:55:00',2.39),('8784','2013-10-22','14:00:00',2.17),('8784','2013-10-22','14:05:00',2.07),('8784','2013-10-22','14:10:00',2.49),('8784','2013-10-22','14:15:00',2.52),('8784','2013-10-22','14:20:00',2.59),('8784','2013-10-22','14:25:00',2.65),('8784','2013-10-22','14:30:00',2.49),('8784','2013-10-22','14:35:00',2.35),('8784','2013-10-22','14:40:00',2.13),('8784','2013-10-22','14:45:00',2.21),('8784','2013-10-22','14:50:00',1.98),('8784','2013-10-22','14:55:00',1.94),('8784','2013-10-22','15:00:00',1.97),('8784','2013-10-22','15:05:00',1.93),('8784','2013-10-22','15:10:00',1.86),('8784','2013-10-22','15:15:00',1.82),('8784','2013-10-22','15:20:00',1.72),('8784','2013-10-22','15:25:00',1.61),('8784','2013-10-22','15:30:00',1.68),('8784','2013-10-22','15:35:00',1.75),('8784','2013-10-22','15:40:00',1.74),('8784','2013-10-22','15:45:00',1.22),('8784','2013-10-22','15:50:00',1.43),('8784','2013-10-22','15:55:00',1.32),('8784','2013-10-22','16:00:00',1.3),('8784','2013-10-22','16:05:00',1.21),('8784','2013-10-22','16:10:00',1.19),('8784','2013-10-22','16:15:00',1.15),('8784','2013-10-22','16:20:00',1.06),('8784','2013-10-22','16:25:00',1.02),('8784','2013-10-21','09:15:00',1.1),('8784','2013-10-21','09:20:00',1.34),('8784','2013-10-21','09:25:00',1.37),('8784','2013-10-21','09:30:00',1.19),('8784','2013-10-21','09:35:00',1.24),('8784','2013-10-21','09:40:00',1.44),('8784','2013-10-21','09:45:00',1.31),('8784','2013-10-21','09:50:00',1.45),('8784','2013-10-21','09:55:00',1.64),('8784','2013-10-21','10:00:00',1.55),('8784','2013-10-21','10:05:00',1.85),('8784','2013-10-21','10:10:00',1.92),('8784','2013-10-21','10:15:00',2),('8784','2013-10-21','10:20:00',1.98),('8784','2013-10-21','10:25:00',2.15),('8784','2013-10-21','10:30:00',2.1),('8784','2013-10-21','10:35:00',2.15),('8784','2013-10-21','10:40:00',2.09),('8784','2013-10-21','10:45:00',2.12),('8784','2013-10-21','10:50:00',2.3),('8784','2013-10-21','10:55:00',2.27),('8784','2013-10-21','11:00:00',2.48),('8784','2013-10-21','11:05:00',2.18),('8784','2013-10-21','11:10:00',2.27),('8784','2013-10-21','11:15:00',2.58),('8784','2013-10-21','11:20:00',2.56),('8784','2013-10-21','11:25:00',2.52),('8784','2013-10-21','11:30:00',2.63),('8784','2013-10-21','11:35:00',2.59),('8784','2013-10-21','11:40:00',2.57),('8784','2013-10-21','11:45:00',2.67),('8784','2013-10-21','11:50:00',2.7),('8784','2013-10-21','11:55:00',2.75),('8784','2013-10-21','12:00:00',2.77),('8784','2013-10-21','12:05:00',2.85),('8784','2013-10-21','12:10:00',2.88),('8784','2013-10-21','12:15:00',2.85),('8784','2013-10-21','12:20:00',2.83),('8784','2013-10-21','12:25:00',2.82),('8784','2013-10-21','12:30:00',2.72),('8784','2013-10-21','12:35:00',2.86),('8784','2013-10-21','12:40:00',2.89),('8784','2013-10-21','12:45:00',2.87),('8784','2013-10-21','12:50:00',2.87),('8784','2013-10-21','12:55:00',2.85),('8784','2013-10-21','13:00:00',2.81),('8784','2013-10-21','13:05:00',2.76),('8784','2013-10-21','13:10:00',2.7),('8784','2013-10-21','13:15:00',2.75),('8784','2013-10-21','13:20:00',2.71),('8784','2013-10-21','13:25:00',2.78),('8784','2013-10-21','13:30:00',2.8),('8784','2013-10-21','13:35:00',2.77),('8784','2013-10-21','13:40:00',2.72),('8784','2013-10-21','13:45:00',2.68),('8784','2013-10-21','13:50:00',2.56),('8784','2013-10-21','13:55:00',2.52),('8784','2013-10-21','14:00:00',2.52),('8784','2013-10-21','14:05:00',2.55),('8784','2013-10-21','14:10:00',2.5),('8784','2013-10-21','14:15:00',2.47),('8784','2013-10-21','14:20:00',2.44),('8784','2013-10-21','14:25:00',2.34),('8784','2013-10-21','14:30:00',2.34),('8784','2013-10-21','14:35:00',2.27),('8784','2013-10-21','14:40:00',2.13),('8784','2013-10-21','14:45:00',2.1),('8784','2013-10-21','14:50:00',1.92),('8784','2013-10-21','14:55:00',1.66),('8784','2013-10-21','15:00:00',1.76),('8784','2013-10-21','15:05:00',1.99),('8784','2013-10-21','15:10:00',1.94),('8784','2013-10-21','15:15:00',1.91),('8784','2013-10-21','15:20:00',1.85),('8784','2013-10-21','15:25:00',1.73),('8784','2013-10-21','15:30:00',1.56),('8784','2013-10-21','15:35:00',1.65),('8784','2013-10-21','15:40:00',1.63),('8784','2013-10-21','15:45:00',1.57),('8784','2013-10-21','15:50:00',1.51),('8784','2013-10-21','15:55:00',1.48),('8784','2013-10-21','16:00:00',1.43),('8784','2013-10-21','16:05:00',1.36),('8784','2013-10-21','16:10:00',1.32),('8784','2013-10-21','16:15:00',1.25),('8784','2013-10-21','16:20:00',1.17),('8784','2013-10-21','16:25:00',1.1),('8784','2013-10-21','16:30:00',1.04),('8784','2013-10-20','09:05:00',1.06),('8784','2013-10-20','09:10:00',1.15),('8784','2013-10-20','09:15:00',1.2),('8784','2013-10-20','09:20:00',1.32),('8784','2013-10-20','09:25:00',1.06),('8784','2013-10-20','09:30:00',1.19),('8784','2013-10-20','09:35:00',1.31),('8784','2013-10-20','09:40:00',1.61),('8784','2013-10-20','09:45:00',1.66),('8784','2013-10-20','09:50:00',1.72),('8784','2013-10-20','09:55:00',1.78),('8784','2013-10-20','10:00:00',1.89),('8784','2013-10-20','10:05:00',1.92),('8784','2013-10-20','10:10:00',2.01),('8784','2013-10-20','10:15:00',2.07),('8784','2013-10-20','10:20:00',2.13),('8784','2013-10-20','10:25:00',2.18),('8784','2013-10-20','10:30:00',2.23),('8784','2013-10-20','10:35:00',2.28),('8784','2013-10-20','10:40:00',2.31),('8784','2013-10-20','10:45:00',2.37),('8784','2013-10-20','10:50:00',2.38),('8784','2013-10-20','10:55:00',2.48),('8784','2013-10-20','11:00:00',2.52),('8784','2013-10-20','11:05:00',2.56),('8784','2013-10-20','11:10:00',2.58),('8784','2013-10-20','11:15:00',2.6),('8784','2013-10-20','11:20:00',2.64),('8784','2013-10-20','11:25:00',2.69),('8784','2013-10-20','11:30:00',2.75),('8784','2013-10-20','11:35:00',2.78),('8784','2013-10-20','11:40:00',2.79),('8784','2013-10-20','11:45:00',2.79),('8784','2013-10-20','11:50:00',2.82),('8784','2013-10-20','11:55:00',2.83),('8784','2013-10-20','12:00:00',2.81),('8784','2013-10-20','12:05:00',2.89),('8784','2013-10-20','12:10:00',2.91),('8784','2013-10-20','12:15:00',2.81),('8784','2013-10-20','12:20:00',2.17),('8784','2013-10-20','12:25:00',1.96),('8784','2013-10-20','12:30:00',3.23),('8784','2013-10-20','12:35:00',2.37),('8784','2013-10-20','12:40:00',1.19),('8784','2013-10-20','12:45:00',2.86),('8784','2013-10-20','12:50:00',2.5),('8784','2013-10-20','12:55:00',1.71),('8784','2013-10-20','13:00:00',2.69),('8784','2013-10-20','13:05:00',1.24),('8784','2013-10-20','13:10:00',1.66),('8784','2013-10-20','13:15:00',1.1),('8784','2013-10-20','13:20:00',1.68),('8784','2013-10-20','13:25:00',1.95),('8784','2013-10-20','13:30:00',1.16),('8784','2013-10-20','13:35:00',1.09),('8784','2013-10-20','13:40:00',1.87),('8784','2013-10-20','13:45:00',1.8),('8784','2013-10-20','13:50:00',1.14),('8784','2013-10-20','13:55:00',1.39),('8784','2013-10-20','14:00:00',1),('8784','2013-10-20','14:10:00',1.06),('8784','2013-10-20','16:35:00',1.04),('8784','2013-10-20','16:50:00',1.22),('8784','2013-10-20','16:55:00',1.2),('8784','2013-10-20','17:00:00',1.1),('8784','2013-10-19','08:50:00',1.08),('8784','2013-10-19','09:05:00',1.03),('8784','2013-10-19','09:15:00',1.58),('8784','2013-10-19','09:20:00',1.64),('8784','2013-10-19','09:25:00',1.7),('8784','2013-10-19','09:30:00',1.75),('8784','2013-10-19','09:35:00',1.8),('8784','2013-10-19','09:40:00',1.91),('8784','2013-10-19','09:45:00',1.99),('8784','2013-10-19','09:50:00',2.06),('8784','2013-10-19','09:55:00',2.17),('8784','2013-10-19','10:00:00',2.11),('8784','2013-10-19','10:05:00',2.12),('8784','2013-10-19','10:10:00',2.26),('8784','2013-10-19','10:15:00',2.18),('8784','2013-10-19','10:20:00',2.27),('8784','2013-10-19','10:25:00',2.53),('8784','2013-10-19','10:30:00',2.58),('8784','2013-10-19','10:35:00',2.57),('8784','2013-10-19','10:40:00',2.55),('8784','2013-10-19','10:45:00',2.57),('8784','2013-10-19','10:50:00',2.6),('8784','2013-10-19','10:55:00',2.68),('8784','2013-10-19','11:00:00',2.57),('8784','2013-10-19','11:05:00',2.61),('8784','2013-10-19','11:10:00',1.11),('8784','2013-10-19','11:15:00',1.2),('8784','2013-10-19','11:20:00',2.59),('8784','2013-10-19','11:25:00',3.05),('8784','2013-10-19','11:30:00',3.1),('8784','2013-10-19','11:35:00',3.03),('8784','2013-10-19','11:40:00',2.94),('8784','2013-10-19','11:45:00',3.12),('8784','2013-10-19','11:50:00',2.81),('8784','2013-10-19','11:55:00',3.12),('8784','2013-10-19','12:00:00',3.18),('8784','2013-10-19','12:05:00',3.19),('8784','2013-10-19','12:10:00',3.13),('8784','2013-10-19','12:15:00',3.15),('8784','2013-10-19','12:20:00',3.1),('8784','2013-10-19','12:25:00',2.93),('8784','2013-10-19','12:30:00',3.15),('8784','2013-10-19','12:35:00',3.25),('8784','2013-10-19','12:40:00',3.35),('8784','2013-10-19','12:45:00',3.41),('8784','2013-10-19','12:50:00',3.43),('8784','2013-10-19','12:55:00',3.54),('8784','2013-10-19','13:00:00',3.74),('8784','2013-10-19','13:05:00',3.01),('8784','2013-10-19','13:10:00',3.27),('8784','2013-10-19','13:15:00',3.08),('8784','2013-10-19','13:20:00',3.11),('8784','2013-10-19','13:25:00',3.17),('8784','2013-10-19','13:30:00',3.44),('8784','2013-10-19','13:35:00',2.48),('8784','2013-10-19','13:40:00',2.19),('8784','2013-10-19','13:45:00',2.07),('8784','2013-10-19','13:50:00',2.7),('8784','2013-10-19','13:55:00',3.29),('8784','2013-10-19','14:00:00',2.66),('8784','2013-10-19','14:05:00',2.26),('8784','2013-10-19','14:10:00',1.69),('8784','2013-10-19','14:15:00',2.33),('8784','2013-10-19','14:20:00',1.86),('8784','2013-10-19','14:25:00',1.63),('8784','2013-10-19','14:30:00',2.23),('8784','2013-10-19','14:35:00',2.77),('8784','2013-10-19','14:40:00',2.36),('8784','2013-10-19','14:45:00',1.94),('8784','2013-10-19','14:50:00',2.65),('8784','2013-10-19','14:55:00',2.48),('8784','2013-10-19','15:00:00',2.46),('8784','2013-10-19','15:05:00',2.4),('8784','2013-10-19','15:10:00',2.33),('8784','2013-10-19','15:15:00',2.28),('8784','2013-10-19','15:20:00',2.11),('8784','2013-10-19','15:25:00',2.02),('8784','2013-10-19','15:30:00',1.9),('8784','2013-10-19','15:35:00',1.83),('8784','2013-10-19','15:40:00',1.69),('8784','2013-10-19','15:45:00',1.51),('8784','2013-10-19','15:50:00',1.67),('8784','2013-10-19','15:55:00',1.77),('8784','2013-10-19','16:00:00',1.43),('8784','2013-10-19','16:05:00',1.55),('8784','2013-10-19','16:10:00',1.47),('8784','2013-10-19','16:15:00',1.57),('8784','2013-10-19','16:20:00',1.38),('8784','2013-10-19','16:25:00',1.08),('8784','2013-10-19','16:30:00',1.35),('8784','2013-10-19','16:35:00',1.31),('8784','2013-10-19','16:40:00',1.26),('8784','2013-10-19','16:45:00',1.19),('8784','2013-10-19','16:50:00',1.08),('8784','2014-05-04','07:45:00',1.42),('8784','2014-05-04','07:50:00',1.48),('8784','2014-05-04','07:55:00',1.55),('8784','2014-05-04','08:00:00',1.63),('8784','2014-05-04','08:05:00',1.74),('8784','2014-05-04','08:10:00',1.79),('8784','2014-05-04','08:15:00',1.91),('8784','2014-05-04','08:20:00',2.05),('8784','2014-05-04','08:25:00',2.18),('8784','2014-05-04','08:30:00',2.22),('8784','2014-05-04','08:35:00',2.62),('8784','2014-05-04','08:40:00',1.74),('8784','2014-05-04','08:45:00',1.31),('8784','2014-05-04','08:50:00',1.71),('8784','2014-05-04','08:55:00',1.33),('8784','2014-05-04','09:00:00',1.47),('8784','2014-05-04','09:05:00',2.27),('8784','2014-05-04','09:10:00',2.4),('8784','2014-05-04','09:15:00',2.09),('8784','2014-05-04','09:20:00',3.66),('8784','2014-05-04','09:25:00',3.62),('8784','2014-05-04','09:30:00',2.01),('8784','2014-05-04','09:35:00',1.31),('8784','2014-05-04','09:40:00',1.49),('8784','2014-05-04','09:45:00',2.16),('8784','2014-05-04','09:50:00',2.12),('8784','2014-05-04','09:55:00',2.17),('8784','2014-05-04','10:00:00',3.95),('8784','2014-05-04','10:05:00',3.83),('8784','2014-05-04','10:10:00',3.83),('8784','2014-05-04','10:15:00',2.75),('8784','2014-05-04','10:20:00',2.12),('8784','2014-05-04','10:25:00',2.1),('8784','2014-05-04','10:30:00',2.21),('8784','2014-05-04','10:35:00',2.35),('8784','2014-05-04','10:40:00',2.35),('8784','2014-05-04','10:45:00',2.92),('8784','2014-05-04','10:50:00',3.28),('8784','2014-05-04','10:55:00',2.61),('8784','2014-05-04','11:00:00',2.49),('8784','2014-05-04','11:05:00',3.05),('8784','2014-05-04','11:10:00',4.58),('8784','2014-05-04','11:15:00',3.86),('8784','2014-05-04','11:20:00',4.74),('8784','2014-05-04','11:25:00',4.62),('8784','2014-05-04','11:30:00',3.9),('8784','2014-05-04','11:35:00',3.61),('8784','2014-05-04','11:40:00',3.26),('8784','2014-05-04','11:45:00',4.22),('8784','2014-05-04','11:50:00',3.64),('8784','2014-05-04','11:55:00',4.12),('8784','2014-05-04','12:00:00',2.79),('8784','2014-05-04','12:05:00',2.42),('8784','2014-05-04','12:10:00',1.91),('8784','2014-05-04','12:15:00',1.73),('8784','2014-05-04','12:20:00',1.7),('8784','2014-05-04','12:25:00',1.92),('8784','2014-05-04','12:30:00',3.21),('8784','2014-05-04','12:35:00',5.37),('8784','2014-05-04','12:40:00',3.36),('8784','2014-05-04','12:45:00',3.13),('8784','2014-05-04','12:50:00',1.9),('8784','2014-05-04','12:55:00',2.23),('8784','2014-05-04','13:00:00',2.69),('8784','2014-05-04','13:05:00',1.89),('8784','2014-05-04','13:10:00',1.97),('8784','2014-05-04','13:15:00',1.91),('8784','2014-05-04','13:20:00',1.78),('8784','2014-05-04','13:25:00',1.69),('8784','2014-05-04','13:30:00',1.64),('8784','2014-05-04','13:35:00',1.76),('8784','2014-05-04','13:40:00',1.75),('8784','2014-05-04','13:45:00',1.53),('8784','2014-05-04','13:50:00',1.45),('8784','2014-05-04','13:55:00',1.53),('8784','2014-05-04','14:00:00',1.55),('8784','2014-05-04','14:05:00',1.54),('8784','2014-05-04','14:10:00',1.5),('8784','2014-05-04','14:15:00',1.37),('8784','2014-05-04','14:20:00',1.05),('8784','2014-05-04','14:50:00',1.33),('8784','2014-05-04','14:55:00',1.9),('8784','2014-05-04','15:00:00',2.17),('8784','2014-05-04','15:05:00',2.46),('8784','2014-05-04','15:10:00',3.48),('8784','2014-05-04','15:15:00',2.5),('8784','2014-05-04','15:20:00',2.1),('8784','2014-05-04','15:25:00',1.6),('8784','2014-05-04','15:30:00',1.32),('8784','2014-05-04','15:45:00',1),('8784','2014-05-04','15:50:00',1.21),('8784','2014-05-04','15:55:00',1.24),('8784','2014-05-04','16:00:00',1.09),('8784','2014-05-04','16:05:00',1.13),('8784','2014-05-04','16:10:00',1.37),('8784','2014-05-04','16:15:00',1.31),('8784','2014-05-04','16:20:00',1.11),('8784','2014-05-04','17:25:00',1.01),('8784','2014-05-04','17:30:00',1.03),('8784','2014-05-04','17:35:00',1.1),('8784','2014-05-04','17:40:00',1.13),('8784','2014-04-16','07:50:00',1.08),('8784','2014-04-16','07:55:00',1.16),('8784','2014-04-16','08:00:00',1.25),('8784','2014-04-16','08:05:00',1.34),('8784','2014-04-16','08:10:00',1.44),('8784','2014-04-16','08:15:00',1.55),('8784','2014-04-16','08:20:00',1.66),('8784','2014-04-16','08:25:00',1.74),('8784','2014-04-16','08:30:00',1.3),('8784','2014-04-16','08:35:00',1.02),('8784','2014-04-16','08:40:00',1.07),('8784','2014-04-16','08:45:00',1.88),('8784','2014-04-16','08:50:00',2),('8784','2014-04-16','08:55:00',2.32),('8784','2014-04-16','09:00:00',2.4),('8784','2014-04-16','09:05:00',2.48),('8784','2014-04-16','09:10:00',2.56),('8784','2014-04-16','09:15:00',2.62),('8784','2014-04-16','09:20:00',2.72),('8784','2014-04-16','09:25:00',2.85),('8784','2014-04-16','09:30:00',1.95),('8784','2014-04-16','09:35:00',1.1),('8784','2014-04-16','09:50:00',1.06),('8784','2014-04-16','09:55:00',3.34),('8784','2014-04-16','10:00:00',3.47),('8784','2014-04-16','10:05:00',3.51),('8784','2014-04-16','10:10:00',3.58),('8784','2014-04-16','10:15:00',3.65),('8784','2014-04-16','10:20:00',3.73),('8784','2014-04-16','10:25:00',3.78),('8784','2014-04-16','10:30:00',3.83),('8784','2014-04-16','10:35:00',3.89),('8784','2014-04-16','10:40:00',3.96),('8784','2014-04-16','10:45:00',4.04),('8784','2014-04-16','10:50:00',4.19),('8784','2014-04-16','10:55:00',3.93),('8784','2014-04-16','11:00:00',4.05),('8784','2014-04-16','11:05:00',2.15),('8784','2014-04-16','11:10:00',1.62),('8784','2014-04-16','11:15:00',2.08),('8784','2014-04-16','11:20:00',3.83),('8784','2014-04-16','11:25:00',3.62),('8784','2014-04-16','11:30:00',4.03),('8784','2014-04-16','11:35:00',2.99),('8784','2014-04-16','11:40:00',3.52),('8784','2014-04-16','11:45:00',4.01),('8784','2014-04-16','11:50:00',4.68),('8784','2014-04-16','11:55:00',5.02),('8784','2014-04-16','12:00:00',5.05),('8784','2014-04-16','12:05:00',3.86),('8784','2014-04-16','12:10:00',3.84),('8784','2014-04-16','12:15:00',4.66),('8784','2014-04-16','12:20:00',2.61),('8784','2014-04-16','12:25:00',1.38),('8784','2014-04-16','12:30:00',1.59),('8784','2014-04-16','12:35:00',4.92),('8784','2014-04-16','12:40:00',5.03),('8784','2014-04-16','12:45:00',4.93),('8784','2014-04-16','12:50:00',4.46),('8784','2014-04-16','12:55:00',1.16),('8784','2014-04-16','13:00:00',2.81),('8784','2014-04-16','13:05:00',1.48),('8784','2014-04-16','13:20:00',1.57),('8784','2014-04-16','13:25:00',1.25),('8784','2014-04-16','13:30:00',1.02),('8784','2014-04-16','13:35:00',1.86),('8784','2014-04-16','13:40:00',2.76),('8784','2014-04-16','13:45:00',5.45),('8784','2014-04-16','13:50:00',4.8),('8784','2014-04-16','13:55:00',4.21),('8784','2014-04-16','14:00:00',1.87),('8784','2014-04-16','14:05:00',4),('8784','2014-04-16','14:10:00',5.06),('8784','2014-04-16','14:15:00',5.27),('8784','2014-04-16','14:20:00',4.25),('8784','2014-04-16','14:25:00',4.51),('8784','2014-04-16','14:30:00',4.76),('8784','2014-04-16','14:35:00',4.52),('8784','2014-04-16','14:40:00',4.41),('8784','2014-04-16','14:45:00',4.42),('8784','2014-04-16','14:50:00',4.57),('8784','2014-04-16','14:55:00',1.66),('8784','2014-04-16','15:00:00',1.33),('8784','2014-04-16','15:05:00',3.66),('8784','2014-04-16','15:10:00',4.92),('8784','2014-04-16','15:15:00',3.11),('8784','2014-04-16','15:25:00',1.32),('8784','2014-04-16','15:30:00',3.15),('8784','2014-04-16','15:35:00',4.22),('8784','2014-04-16','15:40:00',4.07),('8784','2014-04-16','15:45:00',3.89),('8784','2014-04-16','15:50:00',3.63),('8784','2014-04-16','15:55:00',3.67),('8784','2014-04-16','16:00:00',3.56),('8784','2014-04-16','16:05:00',3.43),('8784','2014-04-16','16:10:00',3.34),('8784','2014-04-16','16:15:00',3.27),('8784','2014-04-16','16:20:00',3.27),('8784','2014-04-16','16:25:00',3.15),('8784','2014-04-16','16:30:00',3.08),('8784','2014-04-16','16:35:00',2.99),('8784','2014-04-16','16:40:00',2.92),('8784','2014-04-16','16:45:00',2.84),('8784','2014-04-16','16:50:00',2.73),('8784','2014-04-16','16:55:00',2.64),('8784','2014-04-16','17:00:00',2.56),('8784','2014-04-16','17:05:00',2.46),('8784','2014-04-16','17:10:00',2.36),('8784','2014-04-16','17:15:00',2.29),('8784','2014-04-16','17:20:00',2.18),('8784','2014-04-16','17:25:00',2.07),('8784','2014-04-16','17:30:00',1.99),('8784','2014-04-16','17:35:00',1.92),('8784','2014-04-16','17:40:00',1.81),('8784','2014-04-16','17:45:00',1.74),('8784','2014-04-16','17:50:00',1.72),('8784','2014-04-16','17:55:00',1.73),('8784','2014-04-16','18:00:00',1.55),('8784','2014-04-16','18:05:00',1.46),('8784','2014-04-16','18:10:00',1.27),('8784','2014-04-16','18:15:00',1.02),('8784','2014-04-16','18:20:00',1.19),('8784','2014-04-16','18:25:00',1.01),('8784','2013-10-18','08:55:00',1.02),('8784','2013-10-18','09:00:00',1.15),('8784','2013-10-18','09:05:00',1.27),('8784','2013-10-18','09:10:00',1.36),('8784','2013-10-18','09:15:00',1.38),('8784','2013-10-18','09:20:00',1.55),('8784','2013-10-18','09:25:00',1.6),('8784','2013-10-18','09:30:00',1.69),('8784','2013-10-18','09:35:00',1.77),('8784','2013-10-18','09:40:00',1.85),('8784','2013-10-18','09:45:00',1.92),('8784','2013-10-18','09:50:00',1.99),('8784','2013-10-18','09:55:00',2.06),('8784','2013-10-18','10:00:00',2.11),('8784','2013-10-18','10:05:00',2.17),('8784','2013-10-18','10:10:00',2.2),('8784','2013-10-18','10:15:00',2.19),('8784','2013-10-18','10:20:00',2.22),('8784','2013-10-18','10:25:00',2.34),('8784','2013-10-18','10:30:00',2.47),('8784','2013-10-18','10:35:00',2.49),('8784','2013-10-18','10:40:00',2.51),('8784','2013-10-18','10:45:00',2.57),('8784','2013-10-18','10:50:00',2.64),('8784','2013-10-18','10:55:00',2.69),('8784','2013-10-18','11:00:00',2.62),('8784','2013-10-18','11:05:00',2.59),('8784','2013-10-18','11:10:00',2.66),('8784','2013-10-18','11:15:00',2.71),('8784','2013-10-18','11:20:00',2.91),('8784','2013-10-18','11:25:00',2.89),('8784','2013-10-18','11:30:00',2.86),('8784','2013-10-18','11:35:00',2.93),('8784','2013-10-18','11:40:00',3.02),('8784','2013-10-18','11:45:00',2.93),('8784','2013-10-18','11:50:00',2.93),('8784','2013-10-18','11:55:00',3.08),('8784','2013-10-18','12:00:00',3.04),('8784','2013-10-18','12:05:00',3.04),('8784','2013-10-18','12:10:00',3.06),('8784','2013-10-18','12:15:00',3.02),('8784','2013-10-18','12:20:00',3),('8784','2013-10-18','12:25:00',3.05),('8784','2013-10-18','12:30:00',3.09),('8784','2013-10-18','12:35:00',3.04),('8784','2013-10-18','12:40:00',3.04),('8784','2013-10-18','12:45:00',2.97),('8784','2013-10-18','12:50:00',2.98),('8784','2013-10-18','12:55:00',3.04),('8784','2013-10-18','13:00:00',3),('8784','2013-10-18','13:05:00',2.95),('8784','2013-10-18','13:10:00',2.83),('8784','2013-10-18','13:15:00',2.91),('8784','2013-10-18','13:20:00',2.99),('8784','2013-10-18','13:25:00',3.03),('8784','2013-10-18','13:30:00',3.05),('8784','2013-10-18','13:35:00',3.01),('8784','2013-10-18','13:40:00',2.97),('8784','2013-10-18','13:45:00',2.88),('8784','2013-10-18','13:50:00',2.88),('8784','2013-10-18','13:55:00',2.84),('8784','2013-10-18','14:00:00',2.67),('8784','2013-10-18','14:05:00',2.64),('8784','2013-10-18','14:10:00',2.6),('8784','2013-10-18','14:15:00',2.62),('8784','2013-10-18','14:20:00',2.63),('8784','2013-10-18','14:25:00',2.62),('8784','2013-10-18','14:30:00',2.58),('8784','2013-10-18','14:35:00',2.47),('8784','2013-10-18','14:40:00',2.49),('8784','2013-10-18','14:45:00',2.36),('8784','2013-10-18','14:50:00',2.28),('8784','2013-10-18','14:55:00',1.92),('8784','2013-10-18','15:00:00',1.7),('8784','2013-10-18','15:05:00',1.8),('8784','2013-10-18','15:10:00',2.03),('8784','2013-10-18','15:15:00',2.01),('8784','2013-10-18','15:20:00',2.07),('8784','2013-10-18','15:25:00',1.94),('8784','2013-10-18','15:30:00',1.84),('8784','2013-10-18','15:35:00',1.81),('8784','2013-10-18','15:40:00',1.7),('8784','2013-10-18','15:45:00',1.6),('8784','2013-10-18','15:50:00',1.52),('8784','2013-10-18','15:55:00',1.41),('8784','2013-10-18','16:00:00',1.49),('8784','2013-10-18','16:05:00',1.39),('8784','2013-10-18','16:10:00',1.36),('8784','2013-10-18','16:15:00',1.24),('8784','2013-10-18','16:20:00',1.18),('8784','2013-10-18','16:25:00',1.02),('8784','2013-10-17','08:50:00',1.07),('8784','2013-10-17','08:55:00',1.15),('8784','2013-10-17','09:00:00',1.22),('8784','2013-10-17','09:05:00',1.31),('8784','2013-10-17','09:10:00',1.39),('8784','2013-10-17','09:15:00',1.46),('8784','2013-10-17','09:20:00',1.54),('8784','2013-10-17','09:25:00',1.6),('8784','2013-10-17','09:30:00',1.67),('8784','2013-10-17','09:35:00',1.73),('8784','2013-10-17','09:40:00',1.82),('8784','2013-10-17','09:45:00',1.9),('8784','2013-10-17','09:50:00',1.98),('8784','2013-10-17','09:55:00',2.05),('8784','2013-10-17','10:00:00',2.1),('8784','2013-10-17','10:05:00',2.16),('8784','2013-10-17','10:10:00',2.22),('8784','2013-10-17','10:15:00',2.3),('8784','2013-10-17','10:20:00',2.37),('8784','2013-10-17','10:25:00',2.43),('8784','2013-10-17','10:30:00',2.48),('8784','2013-10-17','10:35:00',2.54),('8784','2013-10-17','10:40:00',2.6),('8784','2013-10-17','10:45:00',2.67),('8784','2013-10-17','10:50:00',2.72),('8784','2013-10-17','10:55:00',2.76),('8784','2013-10-17','11:00:00',2.79),('8784','2013-10-17','11:05:00',2.83),('8784','2013-10-17','11:10:00',2.88),('8784','2013-10-17','11:15:00',2.93),('8784','2013-10-17','11:20:00',2.96),('8784','2013-10-17','11:25:00',2.99),('8784','2013-10-17','11:30:00',3),('8784','2013-10-17','11:35:00',3.06),('8784','2013-10-17','11:40:00',3.1),('8784','2013-10-17','11:45:00',3.11),('8784','2013-10-17','11:50:00',3.12),('8784','2013-10-17','11:55:00',3.14),('8784','2013-10-17','12:00:00',3.16),('8784','2013-10-17','12:05:00',3.18),('8784','2013-10-17','12:10:00',3.19),('8784','2013-10-17','12:15:00',3.2),('8784','2013-10-17','12:20:00',3.19),('8784','2013-10-17','12:25:00',3.19),('8784','2013-10-17','12:30:00',3.19),('8784','2013-10-17','12:35:00',3.2),('8784','2013-10-17','12:40:00',3.24),('8784','2013-10-17','12:45:00',3.23),('8784','2013-10-17','12:50:00',3.26),('8784','2013-10-17','12:55:00',3.25),('8784','2013-10-17','13:00:00',3.24),('8784','2013-10-17','13:05:00',3.21),('8784','2013-10-17','13:10:00',3.2),('8784','2013-10-17','13:15:00',3.19),('8784','2013-10-17','13:20:00',3.16),('8784','2013-10-17','13:25:00',3.15),('8784','2013-10-17','13:30:00',3.13),('8784','2013-10-17','13:35:00',3.13),('8784','2013-10-17','13:40:00',3.09),('8784','2013-10-17','13:45:00',3.06),('8784','2013-10-17','13:50:00',3.04),('8784','2013-10-17','13:55:00',3),('8784','2013-10-17','14:00:00',2.97),('8784','2013-10-17','14:05:00',2.94),('8784','2013-10-17','14:10:00',2.91),('8784','2013-10-17','14:15:00',2.87),('8784','2013-10-17','14:20:00',2.85),('8784','2013-10-17','14:25:00',2.82),('8784','2013-10-17','14:30:00',2.76),('8784','2013-10-17','14:35:00',2.7),('8784','2013-10-17','14:40:00',2.68),('8784','2013-10-17','14:45:00',2.6),('8784','2013-10-17','14:50:00',2.51),('8784','2013-10-17','14:55:00',2.13),('8784','2013-10-17','15:00:00',2.21),('8784','2013-10-17','15:05:00',2.36),('8784','2013-10-17','15:10:00',2.34),('8784','2013-10-17','15:15:00',2.29),('8784','2013-10-17','15:20:00',2.22),('8784','2013-10-17','15:25:00',2.16),('8784','2013-10-17','15:30:00',2.09),('8784','2013-10-17','15:35:00',2),('8784','2013-10-17','15:40:00',1.94),('8784','2013-10-17','15:45:00',1.9),('8784','2013-10-17','15:50:00',1.82),('8784','2013-10-17','15:55:00',1.77),('8784','2013-10-17','16:00:00',1.69),('8784','2013-10-17','16:05:00',1.62),('8784','2013-10-17','16:10:00',1.57),('8784','2013-10-17','16:15:00',1.49),('8784','2013-10-17','16:20:00',1.44),('8784','2013-10-17','16:25:00',1.36),('8784','2013-10-17','16:30:00',1.28),('8784','2013-10-17','16:35:00',1.21),('8784','2013-10-17','16:40:00',1.1),('8784','2013-10-17','16:45:00',1.05),('8784','2013-10-16','09:45:00',1.64),('8784','2013-10-16','09:50:00',1.08),('8784','2013-10-16','11:15:00',1.37),('8784','2013-10-16','11:55:00',1.25),('8784','2013-10-16','12:00:00',1.02),('8784','2013-10-16','12:10:00',1.46),('8784','2013-10-16','12:15:00',3.25),('8784','2013-10-16','12:20:00',1.82),('8784','2013-10-16','12:30:00',1.33),('8784','2013-10-16','12:35:00',1.36),('8784','2013-10-16','12:40:00',3.68),('8784','2013-10-16','12:45:00',2.57),('8784','2013-10-16','12:50:00',3.29),('8784','2013-10-16','12:55:00',2.28),('8784','2013-10-16','13:00:00',2.43),('8784','2013-10-16','13:05:00',3.57),('8784','2013-10-16','13:10:00',2.08),('8784','2013-10-16','13:15:00',3.26),('8784','2013-10-16','13:20:00',3.47),('8784','2013-10-16','13:25:00',3.29),('8784','2013-10-16','13:30:00',3.29),('8784','2013-10-16','13:35:00',3.13),('8784','2013-10-16','13:40:00',3.15),('8784','2013-10-16','13:45:00',3.11),('8784','2013-10-16','13:50:00',2.9),('8784','2013-10-16','13:55:00',3.26),('8784','2013-10-16','14:00:00',2.74),('8784','2013-10-16','14:05:00',2.06),('8784','2013-10-16','14:10:00',3.25),('8784','2013-10-16','14:15:00',2.76),('8784','2013-10-16','14:20:00',2.49),('8784','2013-10-16','14:25:00',3.24),('8784','2013-10-16','14:30:00',2.93),('8784','2013-10-16','14:35:00',2.84),('8784','2013-10-16','14:40:00',2.82),('8784','2013-10-16','14:45:00',2.34),('8784','2013-10-16','14:50:00',2.3),('8784','2013-10-16','14:55:00',2.44),('8784','2013-10-16','15:00:00',2.51),('8784','2013-10-16','15:05:00',1.57),('8784','2013-10-16','15:10:00',2.06),('8784','2013-10-16','15:15:00',2.09),('8784','2013-10-16','15:20:00',1.85),('8784','2013-10-16','15:25:00',1.61),('8784','2013-10-16','15:35:00',1.42),('8784','2013-10-16','15:40:00',2.08),('8784','2013-10-16','15:45:00',1.92),('8784','2013-10-16','15:50:00',1.85),('8784','2013-10-16','15:55:00',1.81),('8784','2013-10-16','16:00:00',1.74),('8784','2013-10-16','16:05:00',1.68),('8784','2013-10-16','16:10:00',1.57),('8784','2013-10-16','16:15:00',1.52),('8784','2013-10-16','16:20:00',1.44),('8784','2013-10-16','16:25:00',1.36),('8784','2013-10-16','16:30:00',1.28),('8784','2013-10-16','16:35:00',1.06),('8784','2013-10-16','16:40:00',1.17),('8784','2013-10-16','16:45:00',1.07),('8784','2013-10-16','16:50:00',1.01),('8784','2013-10-15','09:10:00',1.03),('8784','2013-10-15','09:20:00',1.06),('8784','2013-10-15','09:25:00',1.09),('8784','2013-10-15','09:30:00',1.5),('8784','2013-10-15','09:35:00',1.02),('8784','2013-10-15','09:40:00',1.38),('8784','2013-10-15','09:45:00',1.82),('8784','2013-10-15','09:50:00',2),('8784','2013-10-15','09:55:00',2.12),('8784','2013-10-15','10:00:00',2.11),('8784','2013-10-15','10:05:00',2.37),('8784','2013-10-15','10:10:00',1.83),('8784','2013-10-15','10:15:00',1.19),('8784','2013-10-15','10:20:00',1.19),('8784','2013-10-15','10:25:00',1.54),('8784','2013-10-15','10:30:00',1.94),('8784','2013-10-15','10:35:00',1.66),('8784','2013-10-15','10:40:00',1.96),('8784','2013-10-15','10:45:00',2.28),('8784','2013-10-15','10:50:00',2.18),('8784','2013-10-15','10:55:00',1.9),('8784','2013-10-15','11:00:00',1.89),('8784','2013-10-15','11:05:00',2.04),('8784','2013-10-15','11:10:00',2.61),('8784','2013-10-15','11:15:00',2.83),('8784','2013-10-15','11:20:00',2.88),('8784','2013-10-15','11:25:00',2.68),('8784','2013-10-15','11:30:00',2.77),('8784','2013-10-15','11:35:00',2.34),('8784','2013-10-15','11:40:00',1.9),('8784','2013-10-15','11:45:00',1.58),('8784','2013-10-15','11:50:00',1.52),('8784','2013-10-15','11:55:00',1.52),('8784','2013-10-15','12:00:00',1.59),('8784','2013-10-15','12:05:00',1.61),('8784','2013-10-15','12:10:00',1.63),('8784','2013-10-15','12:15:00',1.59),('8784','2013-10-15','12:20:00',1.67),('8784','2013-10-15','12:25:00',1.51),('8784','2013-10-15','12:30:00',1.39),('8784','2013-10-15','12:35:00',1.37),('8784','2013-10-15','12:40:00',1.37),('8784','2013-10-15','12:45:00',1.51),('8784','2013-10-15','12:50:00',1.44),('8784','2013-10-15','12:55:00',1.31),('8784','2013-10-15','13:00:00',1.29),('8784','2013-10-15','13:05:00',1.67),('8784','2013-10-15','13:10:00',1.87),('8784','2013-10-15','13:15:00',1.87),('8784','2013-10-15','13:20:00',2.63),('8784','2013-10-15','13:25:00',2.95),('8784','2013-10-15','13:30:00',1.91),('8784','2013-10-15','13:35:00',1.66),('8784','2013-10-15','13:40:00',1.6),('8784','2013-10-15','13:45:00',1.66),('8784','2013-10-15','13:50:00',1.53),('8784','2013-10-15','13:55:00',1.39),('8784','2013-10-15','14:00:00',1.27),('8784','2013-10-15','14:05:00',1.27),('8784','2013-10-15','14:10:00',1.39),('8784','2013-10-15','14:15:00',1.87),('8784','2013-10-15','14:20:00',2.03),('8784','2013-10-15','14:25:00',2.24),('8784','2013-10-15','14:30:00',2.06),('8784','2013-10-15','14:35:00',1.42),('8784','2013-10-15','14:40:00',1.97),('8784','2013-10-15','14:45:00',1.98),('8784','2013-10-15','14:50:00',2.44),('8784','2013-10-15','14:55:00',1.89),('8784','2013-10-15','15:00:00',1.32),('8784','2013-10-15','15:05:00',1.36),('8784','2013-10-15','15:10:00',1.37),('8784','2013-10-15','15:15:00',1.28),('8784','2013-10-15','15:20:00',1.17),('8784','2013-10-15','15:25:00',1.07),('8784','2013-10-15','15:30:00',1.03),('8784','2013-10-15','15:35:00',1.1),('8784','2013-10-15','15:40:00',1.15),('8784','2013-10-15','15:45:00',1.11),('8784','2013-10-15','16:30:00',1.18),('8784','2013-10-15','16:35:00',1.21),('8784','2013-10-14','08:45:00',1.09),('8784','2013-10-14','08:50:00',1.02),('8784','2013-10-14','08:55:00',1.18),('8784','2013-10-14','09:00:00',1.04),('8784','2013-10-14','09:05:00',1.12),('8784','2013-10-14','09:20:00',1.02),('8784','2013-10-14','09:25:00',1.52),('8784','2013-10-14','09:30:00',1.69),('8784','2013-10-14','09:35:00',1.56),('8784','2013-10-14','09:40:00',1.45),('8784','2013-10-14','09:45:00',1.23),('8784','2013-10-14','09:50:00',1.59),('8784','2013-10-14','09:55:00',1.84),('8784','2013-10-14','10:00:00',1.82),('8784','2013-10-14','10:05:00',1.99),('8784','2013-10-14','10:10:00',2.11),('8784','2013-10-14','10:15:00',2.25),('8784','2013-10-14','10:20:00',2.29),('8784','2013-10-14','10:25:00',2.34),('8784','2013-10-14','10:30:00',2.38),('8784','2013-10-14','10:35:00',2.41),('8784','2013-10-14','10:40:00',2.39),('8784','2013-10-14','10:45:00',2.46),('8784','2013-10-14','10:50:00',2.55),('8784','2013-10-14','10:55:00',2.61),('8784','2013-10-14','11:00:00',2.65),('8784','2013-10-14','11:05:00',2.66),('8784','2013-10-14','11:10:00',2.8),('8784','2013-10-14','11:15:00',2.77),('8784','2013-10-14','11:20:00',2.79),('8784','2013-10-14','11:25:00',2.86),('8784','2013-10-14','11:30:00',2.93),('8784','2013-10-14','11:35:00',2.87),('8784','2013-10-14','11:40:00',2.89),('8784','2013-10-14','11:45:00',2.87),('8784','2013-10-14','11:50:00',2.92),('8784','2013-10-14','11:55:00',2.94),('8784','2013-10-14','12:00:00',2.96),('8784','2013-10-14','12:05:00',2.98),('8784','2013-10-14','12:10:00',3.04),('8784','2013-10-14','12:15:00',2.96),('8784','2013-10-14','12:20:00',2.79),('8784','2013-10-14','12:25:00',2.96),('8784','2013-10-14','12:30:00',3.1),('8784','2013-10-14','12:35:00',3.07),('8784','2013-10-14','12:40:00',3.07),('8784','2013-10-14','12:45:00',3.08),('8784','2013-10-14','12:50:00',3.01),('8784','2013-10-14','12:55:00',3.04),('8784','2013-10-14','13:00:00',3.03),('8784','2013-10-14','13:05:00',3.02),('8784','2013-10-14','13:10:00',3.01),('8784','2013-10-14','13:15:00',3),('8784','2013-10-14','13:20:00',3.01),('8784','2013-10-14','13:25:00',2.98),('8784','2013-10-14','13:30:00',2.96),('8784','2013-10-14','13:35:00',2.94),('8784','2013-10-14','13:40:00',2.94),('8784','2013-10-14','13:45:00',2.9),('8784','2013-10-14','13:50:00',2.9),('8784','2013-10-14','13:55:00',2.87),('8784','2013-10-14','14:00:00',2.84),('8784','2013-10-14','14:05:00',2.81),('8784','2013-10-14','14:10:00',2.8),('8784','2013-10-14','14:15:00',2.76),('8784','2013-10-14','14:20:00',2.71),('8784','2013-10-14','14:25:00',2.67),('8784','2013-10-14','14:30:00',2.64),('8784','2013-10-14','14:35:00',2.58),('8784','2013-10-14','14:40:00',2.56),('8784','2013-10-14','14:45:00',2.49),('8784','2013-10-14','14:50:00',2.43),('8784','2013-10-14','14:55:00',2.34),('8784','2013-10-14','15:00:00',2.32),('8784','2013-10-14','15:05:00',2.27),('8784','2013-10-14','15:10:00',2.22),('8784','2013-10-14','15:15:00',2.15),('8784','2013-10-14','15:20:00',2.08),('8784','2013-10-14','15:25:00',2.02),('8784','2013-10-14','15:30:00',1.93),('8784','2013-10-14','15:35:00',1.86),('8784','2013-10-14','15:40:00',1.68),('8784','2013-10-14','15:45:00',1.36),('8784','2013-10-14','15:50:00',1.41),('8784','2013-10-14','16:00:00',1.21),('8784','2013-10-14','16:05:00',1.05),('8784','2013-10-13','09:00:00',1.01),('8784','2013-10-13','09:10:00',1.03),('8784','2013-10-13','09:15:00',1.51),('8784','2013-10-13','09:20:00',1.6),('8784','2013-10-13','09:25:00',1.47),('8784','2013-10-13','09:30:00',1.05),('8784','2013-10-13','09:35:00',1.35),('8784','2013-10-13','09:40:00',1.98),('8784','2013-10-13','09:45:00',2.48),('8784','2013-10-13','09:50:00',2.46),('8784','2013-10-13','09:55:00',2.55),('8784','2013-10-13','10:00:00',1.85),('8784','2013-10-13','10:05:00',1.49),('8784','2013-10-13','10:10:00',2.12),('8784','2013-10-13','10:15:00',2.2),('8784','2013-10-13','10:20:00',1.86),('8784','2013-10-13','10:25:00',2.08),('8784','2013-10-13','10:30:00',2.65),('8784','2013-10-13','10:35:00',3.06),('8784','2013-10-13','10:40:00',3.15),('8784','2013-10-13','10:45:00',3.23),('8784','2013-10-13','10:50:00',2.69),('8784','2013-10-13','10:55:00',2.23),('8784','2013-10-13','11:00:00',2.84),('8784','2013-10-13','11:05:00',2.83),('8784','2013-10-13','11:10:00',2.84),('8784','2013-10-13','11:15:00',3.07),('8784','2013-10-13','11:20:00',2.96),('8784','2013-10-13','11:25:00',2.9),('8784','2013-10-13','11:30:00',2.98),('8784','2013-10-13','11:35:00',2.95),('8784','2013-10-13','11:40:00',2.96),('8784','2013-10-13','11:45:00',2.97),('8784','2013-10-13','11:50:00',3.01),('8784','2013-10-13','11:55:00',3),('8784','2013-10-13','12:00:00',3.04),('8784','2013-10-13','12:05:00',3.05),('8784','2013-10-13','12:10:00',3.05),('8784','2013-10-13','12:15:00',3.08),('8784','2013-10-13','12:20:00',2.99),('8784','2013-10-13','12:25:00',2.99),('8784','2013-10-13','12:30:00',3.1),('8784','2013-10-13','12:35:00',3.14),('8784','2013-10-13','12:40:00',3.14),('8784','2013-10-13','12:45:00',3.09),('8784','2013-10-13','12:50:00',3.05),('8784','2013-10-13','12:55:00',3.04),('8784','2013-10-13','13:00:00',3.06),('8784','2013-10-13','13:05:00',3.04),('8784','2013-10-13','13:10:00',3.08),('8784','2013-10-13','13:15:00',3.08),('8784','2013-10-13','13:20:00',3.14),('8784','2013-10-13','13:25:00',2.76),('8784','2013-10-13','13:30:00',2.31),('8784','2013-10-13','13:35:00',2.54),('8784','2013-10-13','13:40:00',1.77),('8784','2013-10-13','13:45:00',2.02),('8784','2013-10-13','13:50:00',2.24),('8784','2013-10-13','13:55:00',2.42),('8784','2013-10-13','14:00:00',3),('8784','2013-10-13','14:05:00',2.98),('8784','2013-10-13','14:10:00',2.96),('8784','2013-10-13','14:15:00',2.7),('8784','2013-10-13','14:20:00',2.98),('8784','2013-10-13','14:25:00',2.96),('8784','2013-10-13','14:30:00',2.46),('8784','2013-10-13','14:35:00',2.29),('8784','2013-10-13','14:40:00',2.56),('8784','2013-10-13','14:45:00',1.99),('8784','2013-10-13','14:50:00',1.69),('8784','2013-10-13','14:55:00',2.03),('8784','2013-10-13','15:00:00',2.49),('8784','2013-10-13','15:05:00',2.15),('8784','2013-10-13','15:10:00',1.56),('8784','2013-10-13','15:15:00',1.81),('8784','2013-10-13','15:20:00',2.01),('8784','2013-10-13','15:25:00',2.06),('8784','2013-10-13','15:30:00',1.63),('8784','2013-10-13','15:35:00',1.5),('8784','2013-10-13','15:40:00',1.47),('8784','2013-10-13','15:45:00',1.43),('8784','2013-10-13','15:50:00',1.34),('8784','2013-10-13','15:55:00',1.3),('8784','2013-10-13','16:00:00',1.43),('8784','2013-10-13','16:05:00',1.68),('8784','2013-10-13','16:10:00',1.43),('8784','2013-10-13','16:15:00',1.26),('8784','2013-10-13','16:20:00',1.34),('8784','2013-10-13','16:25:00',1.68),('8784','2013-10-13','16:30:00',1.6),('8784','2013-10-13','16:35:00',1.34),('8784','2013-10-13','16:40:00',1.1),('8784','2013-10-12','11:15:00',1.02),('8784','2013-10-12','11:20:00',1.19),('8784','2013-10-12','11:25:00',1.26),('8784','2013-10-12','11:30:00',1.5),('8784','2013-10-12','11:35:00',1.96),('8784','2013-10-12','11:40:00',2.94),('8784','2013-10-12','11:45:00',1.58),('8784','2013-10-12','11:50:00',1.5),('8784','2013-10-12','11:55:00',1.29),('8784','2013-10-12','12:15:00',1.17),('8784','2013-10-12','12:20:00',2.08),('8784','2013-10-12','12:25:00',3.44),('8784','2013-10-12','12:30:00',2.58),('8784','2013-10-12','12:35:00',3.12),('8784','2013-10-12','12:40:00',2.94),('8784','2013-10-12','12:45:00',2.91),('8784','2013-10-12','12:50:00',2.65),('8784','2013-10-12','12:55:00',2.31),('8784','2013-10-12','13:00:00',1.73),('8784','2013-10-12','13:05:00',1.14),('8784','2013-10-12','13:15:00',1.34),('8784','2013-10-12','13:20:00',1.44),('8784','2013-10-12','13:25:00',1.68),('8784','2013-10-12','13:30:00',3.69),('8784','2013-10-12','13:35:00',1.57),('8784','2013-10-12','15:55:00',1.02),('8784','2013-10-12','16:00:00',1.18),('8784','2013-10-12','16:05:00',1.12),('8784','2013-10-12','16:10:00',1.17),('8784','2013-10-12','16:15:00',1.78),('8784','2013-10-12','16:20:00',1.8),('8784','2013-10-12','16:25:00',1.13),('8784','2013-10-11','09:20:00',1.11),('8784','2013-10-11','09:40:00',1.28),('8784','2013-10-11','09:45:00',2.04),('8784','2013-10-11','09:50:00',2.11),('8784','2013-10-11','09:55:00',2.18),('8784','2013-10-11','10:00:00',2.24),('8784','2013-10-11','10:05:00',2.33),('8784','2013-10-11','10:10:00',2.4),('8784','2013-10-11','10:15:00',2.06),('8784','2013-10-11','10:20:00',2.13),('8784','2013-10-11','10:25:00',2.29),('8784','2013-10-11','10:30:00',2.56),('8784','2013-10-11','10:35:00',2.7),('8784','2013-10-11','10:40:00',1.53),('8784','2013-10-11','11:05:00',2.69),('8784','2013-10-11','11:10:00',2.34),('8784','2013-10-11','11:15:00',1.08),('8784','2013-10-11','11:20:00',1.13),('8784','2013-10-11','11:25:00',1.11),('8784','2013-10-11','11:35:00',1.44),('8784','2013-10-11','11:40:00',2.16),('8784','2013-10-11','11:45:00',1.86),('8784','2013-10-11','11:50:00',2.12),('8784','2013-10-11','11:55:00',1.92),('8784','2013-10-11','12:00:00',2.99),('8784','2013-10-11','12:05:00',3.18),('8784','2013-10-11','12:10:00',1.56),('8784','2013-10-11','12:15:00',1.23),('8784','2013-10-11','12:20:00',1.01),('8784','2013-10-11','12:25:00',1.36),('8784','2013-10-11','12:30:00',1.28),('8784','2013-10-11','13:05:00',2.44),('8784','2013-10-11','13:10:00',1.96),('8784','2013-10-11','13:15:00',1.58),('8784','2013-10-11','13:20:00',2.3),('8784','2013-10-11','13:25:00',4.08),('8784','2013-10-11','13:30:00',1.64),('8784','2013-10-11','13:40:00',2.97),('8784','2013-10-11','13:45:00',3.18),('8784','2013-10-11','15:30:00',1.03),('8784','2013-10-11','15:35:00',1.19),('8784','2013-10-11','15:40:00',1.72),('8784','2013-10-11','15:45:00',1.2),('8784','2013-10-11','16:00:00',2.27),('8784','2013-10-11','16:30:00',1.02),('8784','2013-10-11','16:35:00',1.06),('8784','2013-10-11','17:00:00',1.03),('8784','2013-10-10','08:50:00',1.05),('8784','2013-10-10','08:55:00',1.26),('8784','2013-10-10','09:10:00',1.49),('8784','2013-10-10','09:15:00',1.6),('8784','2013-10-10','09:20:00',1.64),('8784','2013-10-10','09:25:00',1.65),('8784','2013-10-10','09:30:00',1.78),('8784','2013-10-10','09:35:00',1.22),('8784','2013-10-10','09:40:00',1.53),('8784','2013-10-10','09:45:00',1.45),('8784','2013-10-10','09:50:00',1.74),('8784','2013-10-10','09:55:00',2.03),('8784','2013-10-10','10:10:00',1.5),('8784','2013-10-10','10:15:00',2.4),('8784','2013-10-10','10:20:00',2.43),('8784','2013-10-10','10:25:00',1.37),('8784','2013-10-10','10:30:00',1.08),('8784','2013-10-10','10:40:00',2.22),('8784','2013-10-10','10:45:00',2.55),('8784','2013-10-10','10:50:00',2.23),('8784','2013-10-10','10:55:00',1.7),('8784','2013-10-10','11:20:00',2.17),('8784','2013-10-10','11:25:00',3.2),('8784','2013-10-10','11:30:00',1.03),('8784','2013-10-10','11:35:00',2.89),('8784','2013-10-10','11:40:00',1.74),('8784','2013-10-10','11:50:00',2.81),('8784','2013-10-10','11:55:00',3.51),('8784','2013-10-10','12:00:00',3.5),('8784','2013-10-10','12:05:00',3.57),('8784','2013-10-10','12:10:00',1.19),('8784','2013-10-10','12:20:00',2.5),('8784','2013-10-10','12:25:00',3.53),('8784','2013-10-10','12:35:00',3.74),('8784','2013-10-10','12:40:00',3.78),('8784','2013-10-10','12:45:00',2.68),('8784','2013-10-10','12:50:00',1.76),('8784','2013-10-10','12:55:00',3.69),('8784','2013-10-10','13:00:00',3.92),('8784','2013-10-10','13:05:00',3.94),('8784','2013-10-10','13:10:00',3.76),('8784','2013-10-10','13:15:00',2.55),('8784','2013-10-10','13:20:00',1.45),('8784','2013-10-10','13:25:00',4.06),('8784','2013-10-10','13:30:00',3.68),('8784','2013-10-10','13:35:00',2.03),('8784','2013-10-10','13:40:00',2.22),('8784','2013-10-10','13:45:00',2.99),('8784','2013-10-10','13:50:00',3.28),('8784','2013-10-10','13:55:00',3.45),('8784','2013-10-10','14:00:00',3.34),('8784','2013-10-10','14:05:00',3.44),('8784','2013-10-10','14:10:00',2.88),('8784','2013-10-10','14:15:00',1.76),('8784','2013-10-10','14:20:00',2.66),('8784','2013-10-10','14:25:00',3.49),('8784','2013-10-10','14:30:00',3.51),('8784','2013-10-10','14:35:00',3.47),('8784','2013-10-10','14:40:00',3.22),('8784','2013-10-10','14:45:00',3.08),('8784','2013-10-10','14:50:00',2.95),('8784','2013-10-10','14:55:00',2.84),('8784','2013-10-10','15:00:00',2.78),('8784','2013-10-10','15:05:00',2.78),('8784','2013-10-10','15:10:00',2.77),('8784','2013-10-10','15:15:00',1.58),('8784','2013-10-10','15:20:00',2.58),('8784','2013-10-10','15:25:00',1.76),('8784','2013-10-10','15:30:00',2.44),('8784','2013-10-10','15:40:00',2.29),('8784','2013-10-10','15:45:00',1.31),('8784','2013-10-10','15:50:00',1.45),('8784','2013-10-10','15:55:00',1.85),('8784','2013-10-10','16:00:00',1.37),('8784','2013-10-10','16:15:00',1.45),('8784','2013-10-10','16:25:00',1.72),('8784','2013-10-10','16:45:00',1.32),('8784','2013-10-10','16:50:00',1.11),('8784','2013-10-10','16:55:00',1.12),('8784','2013-10-09','08:40:00',1.06),('8784','2013-10-09','08:45:00',1.11),('8784','2013-10-09','08:50:00',1.18),('8784','2013-10-09','08:55:00',1.29),('8784','2013-10-09','09:00:00',1.36),('8784','2013-10-09','09:05:00',1.48),('8784','2013-10-09','09:10:00',1.58),('8784','2013-10-09','09:15:00',1.47),('8784','2013-10-09','09:20:00',1.55),('8784','2013-10-09','09:25:00',1.81),('8784','2013-10-09','09:30:00',1.88),('8784','2013-10-09','09:35:00',1.95),('8784','2013-10-09','09:40:00',2.07),('8784','2013-10-09','09:45:00',2.15),('8784','2013-10-09','09:50:00',2.22),('8784','2013-10-09','09:55:00',2.3),('8784','2013-10-09','10:00:00',2.5),('8784','2013-10-09','10:05:00',2.65),('8784','2013-10-09','10:10:00',2.06),('8784','2013-10-09','10:15:00',1.42),('8784','2013-10-09','10:25:00',1.05),('8784','2013-10-09','10:30:00',1.22),('8784','2013-10-09','10:35:00',1.32),('8784','2013-10-09','10:40:00',1.38),('8784','2013-10-09','10:45:00',2.16),('8784','2013-10-09','10:50:00',3.85),('8784','2013-10-09','10:55:00',2.83),('8784','2013-10-09','11:00:00',3.06),('8784','2013-10-09','11:05:00',3.85),('8784','2013-10-09','11:10:00',3.89),('8784','2013-10-09','11:15:00',3.8),('8784','2013-10-09','11:20:00',2.52),('8784','2013-10-09','11:25:00',3.43),('8784','2013-10-09','11:30:00',3.89),('8784','2013-10-09','11:35:00',4.11),('8784','2013-10-09','11:40:00',3.7),('8784','2013-10-09','11:45:00',3.61),('8784','2013-10-09','11:50:00',2.87),('8784','2013-10-09','11:55:00',3.44),('8784','2013-10-09','12:00:00',1.64),('8784','2013-10-09','12:05:00',2.4),('8784','2013-10-09','12:10:00',1.77),('8784','2013-10-09','12:15:00',4.27),('8784','2013-10-09','12:20:00',3.89),('8784','2013-10-09','12:25:00',2.62),('8784','2013-10-09','12:30:00',2.09),('8784','2013-10-09','12:35:00',2.43),('8784','2013-10-09','12:40:00',1.47),('8784','2013-10-09','12:55:00',1.18),('8784','2013-10-09','13:10:00',1.18),('8784','2013-10-09','13:15:00',1.5),('8784','2013-10-09','13:20:00',2.25),('8784','2013-10-09','13:25:00',2.62),('8784','2013-10-09','13:30:00',2.32),('8784','2013-10-09','13:35:00',3.22),('8784','2013-10-09','13:40:00',2.45),('8784','2013-10-09','13:45:00',2.16),('8784','2013-10-09','13:50:00',2.44),('8784','2013-10-09','13:55:00',3.93),('8784','2013-10-09','14:00:00',2.28),('8784','2013-10-09','14:05:00',2.32),('8784','2013-10-09','14:10:00',1.04),('8784','2013-10-09','14:55:00',2.44),('8784','2013-10-09','15:00:00',1.45),('8784','2013-10-09','15:05:00',3.19),('8784','2013-10-09','15:10:00',2.87),('8784','2013-10-09','15:15:00',2.82),('8784','2013-10-09','15:20:00',2.46),('8784','2013-10-09','15:25:00',2.52),('8784','2013-10-09','15:30:00',2.34),('8784','2013-10-09','15:35:00',2.41),('8784','2013-10-09','15:40:00',1.99),('8784','2013-10-09','15:45:00',1.33),('8784','2013-10-09','16:15:00',1.17),('8784','2013-10-09','16:20:00',1.57),('8784','2013-10-09','16:25:00',1.76),('8784','2013-10-09','16:30:00',1.83),('8784','2013-10-09','16:35:00',1.47),('8784','2013-10-09','16:40:00',1.38),('8784','2013-10-09','17:35:00',1.13),('8784','2014-04-15','09:00:00',1.85),('8784','2014-04-15','09:05:00',1.64),('8784','2014-04-15','09:10:00',1.74),('8784','2014-04-15','09:15:00',2.33),('8784','2014-04-15','09:20:00',2.78),('8784','2014-04-15','09:25:00',2.99),('8784','2014-04-15','09:30:00',1.91),('8784','2014-04-15','09:35:00',1.06),('8784','2014-04-15','09:45:00',1.34),('8784','2014-04-15','09:50:00',2.41),('8784','2014-04-15','09:55:00',1.16),('8784','2014-04-15','10:00:00',1.75),('8784','2014-04-15','10:05:00',1.96),('8784','2014-04-15','10:10:00',2.36),('8784','2014-04-15','10:15:00',1.96),('8784','2014-04-15','10:20:00',2.22),('8784','2014-04-15','10:25:00',2.47),('8784','2014-04-15','10:30:00',3.81),('8784','2014-04-15','10:35:00',2.05),('8784','2014-04-15','10:40:00',2.85),('8784','2014-04-15','10:45:00',3.01),('8784','2014-04-15','10:50:00',2.64),('8784','2014-04-15','10:55:00',1.83),('8784','2014-04-15','11:00:00',2.37),('8784','2014-04-15','11:05:00',3.4),('8784','2014-04-15','11:10:00',1.86),('8784','2014-04-15','11:15:00',1.55),('8784','2014-04-15','11:20:00',1.19),('8784','2014-04-15','11:25:00',1.75),('8784','2014-04-15','11:30:00',1.31),('8784','2014-04-15','11:35:00',1.04),('8784','2014-04-15','11:45:00',1.2),('8784','2014-04-15','11:50:00',1.49),('8784','2014-04-15','11:55:00',1.11),('8784','2014-04-15','12:10:00',1.07),('8784','2014-04-15','12:15:00',1.74),('8784','2014-04-15','12:20:00',1.81),('8784','2014-04-15','13:05:00',1.13),('8784','2014-04-15','13:10:00',1.52),('8784','2014-04-15','13:15:00',2.52),('8784','2014-04-15','13:20:00',2.75),('8784','2014-04-15','13:25:00',2.3),('8784','2014-04-15','13:30:00',2.77),('8784','2014-04-15','13:35:00',3.32),('8784','2014-04-15','13:40:00',1.83),('8784','2014-04-15','14:00:00',3.59),('8784','2014-04-15','14:05:00',1.63),('8784','2014-04-15','14:10:00',2.99),('8784','2014-04-15','14:15:00',2.66),('8784','2014-04-15','14:20:00',3.89),('8784','2014-04-15','14:25:00',3.38),('8784','2014-04-15','14:30:00',2.3),('8784','2014-04-15','14:35:00',1.57),('8784','2014-04-15','14:40:00',2.51),('8784','2014-04-15','14:45:00',3.01),('8784','2014-04-15','14:50:00',2.17),('8784','2014-04-15','14:55:00',1.49),('8784','2014-04-15','15:05:00',1.03),('8784','2014-04-15','15:10:00',1.21),('8784','2014-04-15','15:15:00',1.79),('8784','2014-04-15','15:20:00',2.27),('8784','2014-04-15','15:25:00',2.03),('8784','2014-04-15','15:30:00',1.7),('8784','2014-04-15','15:35:00',1.57),('8784','2014-04-15','15:40:00',1.58),('8784','2014-04-15','15:45:00',1.48),('8784','2014-04-15','15:50:00',1.49),('8784','2014-04-15','15:55:00',1.52),('8784','2014-04-15','16:00:00',1.66),('8784','2014-04-15','16:05:00',1.7),('8784','2013-10-08','08:15:00',1.2),('8784','2013-10-08','08:20:00',1.19),('8784','2013-10-08','10:05:00',1.03),('8784','2013-10-08','10:55:00',1.38),('8784','2013-10-08','11:00:00',1.78),('8784','2013-10-08','11:05:00',1.37),('8784','2013-10-08','11:10:00',2.05),('8784','2013-10-08','11:15:00',2.96),('8784','2013-10-08','11:20:00',3.83),('8784','2013-10-08','11:25:00',2.07),('8784','2013-10-08','11:30:00',2.45),('8784','2013-10-08','11:35:00',2.24),('8784','2013-10-08','11:40:00',1.63),('8784','2013-10-08','11:45:00',1.46),('8784','2013-10-08','12:20:00',1.19),('8784','2013-10-08','12:25:00',1.61),('8784','2013-10-08','12:30:00',2.48),('8784','2013-10-08','12:35:00',2.16),('8784','2013-10-08','12:40:00',3.94),('8784','2013-10-08','12:45:00',3.97),('8784','2013-10-08','12:50:00',3.25),('8784','2013-10-08','12:55:00',3.76),('8784','2013-10-08','13:00:00',3.69),('8784','2013-10-08','13:05:00',2.72),('8784','2013-10-08','13:10:00',1.77),('8784','2013-10-08','13:15:00',2.89),('8784','2013-10-08','13:20:00',1.52),('8784','2013-10-08','13:25:00',2.91),('8784','2013-10-08','13:30:00',1.96),('8784','2013-10-08','13:35:00',1.42),('8784','2013-10-08','13:40:00',1.21),('8784','2013-10-08','14:05:00',1.52),('8784','2013-10-08','14:10:00',1.93),('8784','2013-10-08','14:15:00',2.35),('8784','2013-10-08','14:20:00',2.64),('8784','2013-10-08','14:25:00',2.84),('8784','2013-10-08','14:30:00',2.55),('8784','2013-10-08','14:35:00',1.34),('8784','2013-10-08','14:40:00',1.5),('8784','2013-10-08','14:45:00',2.93),('8784','2013-10-08','14:50:00',3.12),('8784','2013-10-08','14:55:00',2.86),('8784','2013-10-08','15:00:00',2.76),('8784','2013-10-08','15:05:00',2.63),('8784','2013-10-08','15:10:00',2.79),('8784','2013-10-08','15:15:00',2.64),('8784','2013-10-08','15:20:00',2.46),('8784','2013-10-08','15:25:00',3.16),('8784','2013-10-08','15:30:00',3.16),('8784','2013-10-08','15:35:00',2.69),('8784','2013-10-08','15:40:00',1.73),('8784','2013-10-08','15:45:00',1.08),('8784','2013-10-08','15:50:00',2.13),('8784','2013-10-08','15:55:00',1.31),('8784','2013-10-08','16:00:00',1.09),('8784','2013-10-07','08:35:00',1.03),('8784','2013-10-07','08:40:00',1.06),('8784','2013-10-07','09:00:00',1.59),('8784','2013-10-07','09:05:00',1.65),('8784','2013-10-07','09:10:00',1.61),('8784','2013-10-07','09:15:00',1.65),('8784','2013-10-07','09:20:00',1.71),('8784','2013-10-07','09:25:00',1.8),('8784','2013-10-07','09:30:00',1.86),('8784','2013-10-07','09:35:00',1.95),('8784','2013-10-07','09:40:00',1.99),('8784','2013-10-07','09:45:00',2.08),('8784','2013-10-07','09:50:00',2.16),('8784','2013-10-07','09:55:00',2.22),('8784','2013-10-07','10:00:00',2.29),('8784','2013-10-07','10:05:00',2.36),('8784','2013-10-07','10:10:00',2.38),('8784','2013-10-07','10:15:00',2.44),('8784','2013-10-07','10:20:00',2.5),('8784','2013-10-07','10:25:00',2.28),('8784','2013-10-07','10:30:00',2.66),('8784','2013-10-07','10:35:00',2.87),('8784','2013-10-07','10:40:00',2.79),('8784','2013-10-07','10:45:00',2.82),('8784','2013-10-07','10:50:00',2.88),('8784','2013-10-07','10:55:00',2.83),('8784','2013-10-07','11:00:00',3),('8784','2013-10-07','11:05:00',3.06),('8784','2013-10-07','11:10:00',1.94),('8784','2013-10-07','11:15:00',2.63),('8784','2013-10-07','11:20:00',2.65),('8784','2013-10-07','11:25:00',3.16),('8784','2013-10-07','11:30:00',3.16),('8784','2013-10-07','11:35:00',3.19),('8784','2013-10-07','11:40:00',3.17),('8784','2013-10-07','11:45:00',3.24),('8784','2013-10-07','11:50:00',3.28),('8784','2013-10-07','11:55:00',3.32),('8784','2013-10-07','12:00:00',3.32),('8784','2013-10-07','12:05:00',3.41),('8784','2013-10-07','12:10:00',3.63),('8784','2013-10-07','12:15:00',1.67),('8784','2013-10-07','12:20:00',2.01),('8784','2013-10-07','12:25:00',4.04),('8784','2013-10-07','12:30:00',3.85),('8784','2013-10-07','12:35:00',3.62),('8784','2013-10-07','12:40:00',2.76),('8784','2013-10-07','12:45:00',3.67),('8784','2013-10-07','12:50:00',2.49),('8784','2013-10-07','12:55:00',3.79),('8784','2013-10-07','13:00:00',3.7),('8784','2013-10-07','13:05:00',3.68),('8784','2013-10-07','13:10:00',3.81),('8784','2013-10-07','13:15:00',3.77),('8784','2013-10-07','13:20:00',3.09),('8784','2013-10-07','13:25:00',1.49),('8784','2013-10-07','13:30:00',1.53),('8784','2013-10-07','13:35:00',2.29),('8784','2013-10-07','13:40:00',3.63),('8784','2013-10-07','13:45:00',1.37),('8784','2013-10-07','13:50:00',2.26),('8784','2013-10-07','13:55:00',3.69),('8784','2013-10-07','14:00:00',2.84),('8784','2013-10-07','14:05:00',1.83),('8784','2013-10-07','14:10:00',1.27),('8784','2013-10-07','14:15:00',1.15),('8784','2013-10-07','14:20:00',1.6),('8784','2013-10-07','14:30:00',2.71),('8784','2013-10-07','14:35:00',3.76),('8784','2013-10-07','14:40:00',2.31),('8784','2013-10-07','14:45:00',3.14),('8784','2013-10-07','14:50:00',3.49),('8784','2013-10-07','14:55:00',3.43),('8784','2013-10-07','15:00:00',2.68),('8784','2013-10-07','15:05:00',2.31),('8784','2013-10-07','15:10:00',2.36),('8784','2013-10-07','15:15:00',1.82),('8784','2013-10-07','15:20:00',1.28),('8784','2013-10-07','15:25:00',2.89),('8784','2013-10-07','15:30:00',1.32),('8784','2013-10-07','15:35:00',1.03),('8784','2013-10-07','15:40:00',1.67),('8784','2013-10-07','15:45:00',2.91),('8784','2013-10-07','15:50:00',2.25),('8784','2013-10-07','16:00:00',1.04),('8784','2013-10-07','16:05:00',2.13),('8784','2013-10-07','16:10:00',2.28),('8784','2013-10-07','16:15:00',2.07),('8784','2013-10-07','16:20:00',1.96),('8784','2013-10-07','16:25:00',1.9),('8784','2013-10-07','16:30:00',1.11),('8784','2013-10-07','16:35:00',1.45),('8784','2013-10-07','16:40:00',1.56),('8784','2013-10-07','16:45:00',1.52),('8784','2013-10-07','16:50:00',1.41),('8784','2013-10-07','16:55:00',1.27),('8784','2013-10-07','17:00:00',1.13),('8784','2013-10-07','17:05:00',1.03),('8784','2013-10-06','09:05:00',1.21),('8784','2013-10-06','09:30:00',1.22),('8784','2013-10-06','09:35:00',1.5),('8784','2013-10-06','09:40:00',1.34),('8784','2013-10-06','09:45:00',1.18),('8784','2013-10-06','09:50:00',2.08),('8784','2013-10-06','09:55:00',2.44),('8784','2013-10-06','10:00:00',2.81),('8784','2013-10-06','10:05:00',2.89),('8784','2013-10-06','10:10:00',2.82),('8784','2013-10-06','10:15:00',2.6),('8784','2013-10-06','10:20:00',2.66),('8784','2013-10-06','10:25:00',2.95),('8784','2013-10-06','10:30:00',2.87),('8784','2013-10-06','10:35:00',2.82),('8784','2013-10-06','10:40:00',2.42),('8784','2013-10-06','10:45:00',1.91),('8784','2013-10-06','10:50:00',2.26),('8784','2013-10-06','10:55:00',2.32),('8784','2013-10-06','11:00:00',2.47),('8784','2013-10-06','11:05:00',2.71),('8784','2013-10-06','11:10:00',2.76),('8784','2013-10-06','11:15:00',2.71),('8784','2013-10-06','11:20:00',2.82),('8784','2013-10-06','11:25:00',2.88),('8784','2013-10-06','11:30:00',2.81),('8784','2013-10-06','11:35:00',2.59),('8784','2013-10-06','11:40:00',2.17),('8784','2013-10-06','11:45:00',2.08),('8784','2013-10-06','11:50:00',1.88),('8784','2013-10-06','11:55:00',2.19),('8784','2013-10-06','12:00:00',2.56),('8784','2013-10-06','12:05:00',2.23),('8784','2013-10-06','12:10:00',3.3),('8784','2013-10-06','12:15:00',3.11),('8784','2013-10-06','12:20:00',3.09),('8784','2013-10-06','12:25:00',2.4),('8784','2013-10-06','12:30:00',2.49),('8784','2013-10-06','12:35:00',2.63),('8784','2013-10-06','12:40:00',2.53),('8784','2013-10-06','12:45:00',2.57),('8784','2013-10-06','12:50:00',2.74),('8784','2013-10-06','12:55:00',2.93),('8784','2013-10-06','13:00:00',3.28),('8784','2013-10-06','13:05:00',3.15),('8784','2013-10-06','13:10:00',3.02),('8784','2013-10-06','13:15:00',3.77),('8784','2013-10-06','13:20:00',2.19),('8784','2013-10-06','13:25:00',1.12),('8784','2013-10-06','13:45:00',1.58),('8784','2013-10-06','13:50:00',3.43),('8784','2013-10-06','13:55:00',3.56),('8784','2013-10-06','14:00:00',2.52),('8784','2013-10-06','14:05:00',1.97),('8784','2013-10-06','14:10:00',1.64),('8784','2013-10-06','14:15:00',1.48),('8784','2013-10-06','14:20:00',1.71),('8784','2013-10-06','14:25:00',1.77),('8784','2013-10-06','14:30:00',2.59),('8784','2013-10-06','14:35:00',2.19),('8784','2013-10-06','14:40:00',2.11),('8784','2013-10-06','14:45:00',1.69),('8784','2013-10-06','14:50:00',1.83),('8784','2013-10-06','14:55:00',2.52),('8784','2013-10-06','15:00:00',2.11),('8784','2013-10-06','15:05:00',1.49),('8784','2013-10-06','15:10:00',1.23),('8784','2013-10-06','15:15:00',1.21),('8784','2013-10-06','15:20:00',1.05),('8784','2013-10-06','15:55:00',1.14),('8784','2013-10-06','16:00:00',1.16),('8784','2013-10-05','16:00:00',1.07),('8784','2013-10-05','16:05:00',1.29),('8784','2013-10-05','16:10:00',1.25),('8784','2013-10-05','16:15:00',1.14),('8784','2013-10-05','16:20:00',1.16),('8784','2013-10-05','16:25:00',1.12),('8784','2013-10-04','09:25:00',1.05),('8784','2013-10-04','09:30:00',1.14),('8784','2013-10-04','09:35:00',1.21),('8784','2013-10-04','09:40:00',1.21),('8784','2013-10-04','09:45:00',1.19),('8784','2013-10-04','09:50:00',1.45),('8784','2013-10-04','09:55:00',2.83),('8784','2013-10-04','10:00:00',2.1),('8784','2013-10-04','10:05:00',1.52),('8784','2013-10-04','10:10:00',1.57),('8784','2013-10-04','10:15:00',1.78),('8784','2013-10-04','10:20:00',1.54),('8784','2013-10-04','10:25:00',1.76),('8784','2013-10-04','10:30:00',2.55),('8784','2013-10-04','10:35:00',2.16),('8784','2013-10-04','10:40:00',2.44),('8784','2013-10-04','10:45:00',2.18),('8784','2013-10-04','10:50:00',1.95),('8784','2013-10-04','10:55:00',2.71),('8784','2013-10-04','11:00:00',2.18),('8784','2013-10-04','11:05:00',1.73),('8784','2013-10-04','11:10:00',1.93),('8784','2013-10-04','11:15:00',3.04),('8784','2013-10-04','11:20:00',3),('8784','2013-10-04','11:25:00',2.83),('8784','2013-10-04','11:30:00',3.72),('8784','2013-10-04','11:35:00',3.5),('8784','2013-10-04','11:40:00',3.47),('8784','2013-10-04','11:45:00',3.47),('8784','2013-10-04','11:50:00',3.43),('8784','2013-10-04','11:55:00',3.44),('8784','2013-10-04','12:00:00',3.46),('8784','2013-10-04','12:05:00',3.48),('8784','2013-10-04','12:10:00',3.5),('8784','2013-10-04','12:15:00',3.25),('8784','2013-10-04','12:20:00',3.45),('8784','2013-10-04','12:25:00',3.57),('8784','2013-10-04','12:30:00',3.7),('8784','2013-10-04','12:35:00',3.37),('8784','2013-10-04','12:40:00',3.46),('8784','2013-10-04','12:45:00',3.48),('8784','2013-10-04','12:50:00',3.41),('8784','2013-10-04','12:55:00',3.4),('8784','2013-10-04','13:00:00',3.42),('8784','2013-10-04','13:05:00',3.48),('8784','2013-10-04','13:10:00',3.52),('8784','2013-10-04','13:15:00',3.69),('8784','2013-10-04','13:20:00',3.59),('8784','2013-10-04','13:25:00',3.33),('8784','2013-10-04','13:30:00',3.58),('8784','2013-10-04','13:35:00',3.58),('8784','2013-10-04','13:40:00',3.33),('8784','2013-10-04','13:45:00',3.32),('8784','2013-10-04','13:50:00',3.29),('8784','2013-10-04','13:55:00',3.25),('8784','2013-10-04','14:00:00',3.25),('8784','2013-10-04','14:05:00',3.21),('8784','2013-10-04','14:10:00',2.93),('8784','2013-10-04','14:15:00',2.46),('8784','2013-10-04','14:20:00',2.95),('8784','2013-10-04','14:25:00',3.09),('8784','2013-10-04','14:30:00',2.68),('8784','2013-10-04','14:35:00',1.91),('8784','2013-10-04','14:40:00',1.61),('8784','2013-10-04','14:45:00',1.94),('8784','2013-10-04','14:50:00',2.47),('8784','2013-10-04','14:55:00',2.43),('8784','2013-10-04','15:00:00',2.08),('8784','2013-10-04','15:05:00',2.33),('8784','2013-10-04','15:10:00',1.92),('8784','2013-10-04','15:15:00',1.56),('8784','2013-10-04','15:20:00',1.39),('8784','2013-10-04','15:25:00',2.51),('8784','2013-10-04','15:30:00',2.16),('8784','2013-10-04','15:35:00',1.24),('8784','2013-10-04','16:00:00',1.15),('8784','2013-10-04','16:05:00',1.19),('8784','2013-10-04','16:10:00',1.1),('8784','2013-10-03','08:30:00',1.05),('8784','2013-10-03','08:35:00',1.13),('8784','2013-10-03','08:40:00',1.21),('8784','2013-10-03','08:45:00',1.3),('8784','2013-10-03','08:50:00',1.39),('8784','2013-10-03','08:55:00',1.48),('8784','2013-10-03','09:00:00',1.57),('8784','2013-10-03','09:05:00',1.65),('8784','2013-10-03','09:10:00',1.74),('8784','2013-10-03','09:15:00',1.83),('8784','2013-10-03','09:20:00',1.91),('8784','2013-10-03','09:25:00',1.99),('8784','2013-10-03','09:30:00',2.08),('8784','2013-10-03','09:35:00',2.16),('8784','2013-10-03','09:40:00',2.24),('8784','2013-10-03','09:45:00',2.31),('8784','2013-10-03','09:50:00',2.39),('8784','2013-10-03','09:55:00',2.47),('8784','2013-10-03','10:00:00',2.54),('8784','2013-10-03','10:05:00',2.61),('8784','2013-10-03','10:10:00',2.68),('8784','2013-10-03','10:15:00',2.74),('8784','2013-10-03','10:20:00',2.8),('8784','2013-10-03','10:25:00',2.87),('8784','2013-10-03','10:30:00',2.91),('8784','2013-10-03','10:35:00',2.99),('8784','2013-10-03','10:40:00',3.05),('8784','2013-10-03','10:45:00',3.1),('8784','2013-10-03','10:50:00',3.14),('8784','2013-10-03','10:55:00',3.19),('8784','2013-10-03','11:00:00',3.18),('8784','2013-10-03','11:05:00',3.26),('8784','2013-10-03','11:10:00',3.32),('8784','2013-10-03','11:15:00',3.35),('8784','2013-10-03','11:20:00',3.4),('8784','2013-10-03','11:25:00',3.44),('8784','2013-10-03','11:30:00',3.47),('8784','2013-10-03','11:35:00',3.5),('8784','2013-10-03','11:40:00',3.54),('8784','2013-10-03','11:45:00',3.56),('8784','2013-10-03','11:50:00',3.6),('8784','2013-10-03','11:55:00',3.63),('8784','2013-10-03','12:00:00',3.64),('8784','2013-10-03','12:05:00',3.66),('8784','2013-10-03','12:10:00',3.67),('8784','2013-10-03','12:15:00',3.66),('8784','2013-10-03','12:20:00',3.67),('8784','2013-10-03','12:25:00',3.68),('8784','2013-10-03','12:30:00',3.7),('8784','2013-10-03','12:35:00',3.71),('8784','2013-10-03','12:40:00',3.69),('8784','2013-10-03','12:45:00',3.68),('8784','2013-10-03','12:50:00',3.68),('8784','2013-10-03','12:55:00',3.69),('8784','2013-10-03','13:00:00',3.68),('8784','2013-10-03','13:05:00',3.61),('8784','2013-10-03','13:10:00',3.66),('8784','2013-10-03','13:15:00',3.64),('8784','2013-10-03','13:20:00',3.62),('8784','2013-10-03','13:25:00',3.61),('8784','2013-10-03','13:30:00',3.62),('8784','2013-10-03','13:35:00',3.62),('8784','2013-10-03','13:40:00',3.6),('8784','2013-10-03','13:45:00',3.57),('8784','2013-10-03','13:50:00',3.54),('8784','2013-10-03','13:55:00',3.51),('8784','2013-10-03','14:00:00',3.5),('8784','2013-10-03','14:05:00',3.45),('8784','2013-10-03','14:10:00',3.45),('8784','2013-10-03','14:15:00',3.41),('8784','2013-10-03','14:20:00',3.37),('8784','2013-10-03','14:25:00',3.32),('8784','2013-10-03','14:30:00',3.3),('8784','2013-10-03','14:35:00',3.26),('8784','2013-10-03','14:40:00',3.2),('8784','2013-10-03','14:45:00',3.16),('8784','2013-10-03','14:50:00',3.11),('8784','2013-10-03','14:55:00',3.05),('8784','2013-10-03','15:00:00',2.99),('8784','2013-10-03','15:05:00',2.95),('8784','2013-10-03','15:10:00',2.89),('8784','2013-10-03','15:15:00',2.83),('8784','2013-10-03','15:20:00',2.77),('8784','2013-10-03','15:25:00',2.71),('8784','2013-10-03','15:30:00',2.65),('8784','2013-10-03','15:35:00',2.58),('8784','2013-10-03','15:40:00',2.51),('8784','2013-10-03','15:45:00',2.43),('8784','2013-10-03','15:50:00',2.34),('8784','2013-10-03','15:55:00',2.29),('8784','2013-10-03','16:00:00',2.21),('8784','2013-10-03','16:05:00',2.13),('8784','2013-10-03','16:10:00',2.06),('8784','2013-10-03','16:15:00',1.97),('8784','2013-10-03','16:20:00',1.88),('8784','2013-10-03','16:25:00',1.81),('8784','2013-10-03','16:30:00',1.73),('8784','2013-10-03','16:35:00',1.66),('8784','2013-10-03','16:40:00',1.56),('8784','2013-10-03','16:45:00',1.48),('8784','2013-10-03','16:50:00',1.4),('8784','2013-10-03','16:55:00',1.31),('8784','2013-10-03','17:00:00',1.22),('8784','2013-10-03','17:05:00',1.14),('8784','2013-10-03','17:10:00',1.06),('8784','2013-10-02','08:30:00',1.04),('8784','2013-10-02','08:35:00',1.07),('8784','2013-10-02','08:40:00',1.13),('8784','2013-10-02','08:45:00',1.22),('8784','2013-10-02','08:50:00',1.31),('8784','2013-10-02','08:55:00',1.4),('8784','2013-10-02','09:00:00',1.49),('8784','2013-10-02','09:05:00',1.57),('8784','2013-10-02','09:10:00',1.66),('8784','2013-10-02','09:15:00',1.74),('8784','2013-10-02','09:20:00',1.82),('8784','2013-10-02','09:25:00',1.9),('8784','2013-10-02','09:30:00',1.98),('8784','2013-10-02','09:35:00',2.06),('8784','2013-10-02','09:40:00',2.13),('8784','2013-10-02','09:45:00',2.17),('8784','2013-10-02','09:50:00',2.27),('8784','2013-10-02','09:55:00',2.34),('8784','2013-10-02','10:00:00',1.78),('8784','2013-10-02','10:05:00',2.45),('8784','2013-10-02','10:10:00',2.5),('8784','2013-10-02','10:15:00',2.57),('8784','2013-10-02','10:20:00',2.64),('8784','2013-10-02','10:25:00',2.71),('8784','2013-10-02','10:30:00',2.77),('8784','2013-10-02','10:35:00',2.83),('8784','2013-10-02','10:40:00',2.9),('8784','2013-10-02','10:45:00',2.97),('8784','2013-10-02','10:50:00',3.02),('8784','2013-10-02','10:55:00',3.07),('8784','2013-10-02','11:00:00',3.12),('8784','2013-10-02','11:05:00',3.16),('8784','2013-10-02','11:10:00',3.2),('8784','2013-10-02','11:15:00',3.21),('8784','2013-10-02','11:20:00',3.28),('8784','2013-10-02','11:25:00',3.3),('8784','2013-10-02','11:30:00',3.33),('8784','2013-10-02','11:35:00',3.36),('8784','2013-10-02','11:40:00',3.38),('8784','2013-10-02','11:45:00',3.41),('8784','2013-10-02','11:50:00',3.45),('8784','2013-10-02','11:55:00',3.48),('8784','2013-10-02','12:00:00',3.49),('8784','2013-10-02','12:05:00',3.51),('8784','2013-10-02','12:10:00',3.53),('8784','2013-10-02','12:15:00',3.55),('8784','2013-10-02','12:20:00',3.56),('8784','2013-10-02','12:25:00',3.56),('8784','2013-10-02','12:30:00',3.56),('8784','2013-10-02','12:35:00',3.56),('8784','2013-10-02','12:40:00',3.56),('8784','2013-10-02','12:45:00',3.56),('8784','2013-10-02','12:50:00',3.58),('8784','2013-10-02','12:55:00',3.58),('8784','2013-10-02','13:00:00',3.56),('8784','2013-10-02','13:05:00',3.53),('8784','2013-10-02','13:10:00',3.56),('8784','2013-10-02','13:15:00',3.56),('8784','2013-10-02','13:20:00',3.54),('8784','2013-10-02','13:25:00',3.53),('8784','2013-10-02','13:30:00',3.52),('8784','2013-10-02','13:35:00',3.51),('8784','2013-10-02','13:40:00',3.51),('8784','2013-10-02','13:45:00',3.48),('8784','2013-10-02','13:50:00',3.44),('8784','2013-10-02','13:55:00',3.41),('8784','2013-10-02','14:00:00',3.39),('8784','2013-10-02','14:05:00',3.38),('8784','2013-10-02','14:10:00',3.35),('8784','2013-10-02','14:15:00',3.3),('8784','2013-10-02','14:20:00',3.24),('8784','2013-10-02','14:25:00',3.23),('8784','2013-10-02','14:30:00',3.2),('8784','2013-10-02','14:35:00',3.15),('8784','2013-10-02','14:40:00',3.11),('8784','2013-10-02','14:45:00',3.06),('8784','2013-10-02','14:50:00',3.02),('8784','2013-10-02','14:55:00',2.98),('8784','2013-10-02','15:00:00',2.93),('8784','2013-10-02','15:05:00',2.88),('8784','2013-10-02','15:10:00',2.81),('8784','2013-10-02','15:15:00',2.77),('8784','2013-10-02','15:20:00',2.71),('8784','2013-10-02','15:25:00',2.64),('8784','2013-10-02','15:30:00',2.58),('8784','2013-10-02','15:35:00',2.52),('8784','2013-10-02','15:40:00',2.45),('8784','2013-10-02','15:45:00',2.39),('8784','2013-10-02','15:50:00',2.32),('8784','2013-10-02','15:55:00',2.26),('8784','2013-10-02','16:00:00',2.17),('8784','2013-10-02','16:05:00',2.09),('8784','2013-10-02','16:10:00',2.02),('8784','2013-10-02','16:15:00',1.94),('8784','2013-10-02','16:20:00',1.86),('8784','2013-10-02','16:25:00',1.78),('8784','2013-10-02','16:30:00',1.7),('8784','2013-10-02','16:35:00',1.63),('8784','2013-10-02','16:40:00',1.55),('8784','2013-10-02','16:45:00',1.47),('8784','2013-10-02','16:50:00',1.39),('8784','2013-10-02','16:55:00',1.3),('8784','2013-10-02','17:00:00',1.22),('8784','2013-10-02','17:05:00',1.14),('8784','2013-10-02','17:10:00',1.05),('8784','2013-10-01','08:30:00',1.04),('8784','2013-10-01','08:35:00',1.09),('8784','2013-10-01','08:40:00',1.17),('8784','2013-10-01','08:45:00',1.26),('8784','2013-10-01','08:50:00',1.36),('8784','2013-10-01','08:55:00',1.42),('8784','2013-10-01','09:00:00',1.51),('8784','2013-10-01','09:05:00',1.58),('8784','2013-10-01','09:10:00',1.68),('8784','2013-10-01','09:15:00',1.7),('8784','2013-10-01','09:20:00',1.69),('8784','2013-10-01','09:25:00',1.84),('8784','2013-10-01','09:30:00',1.91),('8784','2013-10-01','09:35:00',2.01),('8784','2013-10-01','09:40:00',2.11),('8784','2013-10-01','09:45:00',2.16),('8784','2013-10-01','09:50:00',2.24),('8784','2013-10-01','09:55:00',2.29),('8784','2013-10-01','10:00:00',2.36),('8784','2013-10-01','10:05:00',2.42),('8784','2013-10-01','10:10:00',2.46),('8784','2013-10-01','10:15:00',2.54),('8784','2013-10-01','10:20:00',2.62),('8784','2013-10-01','10:25:00',2.69),('8784','2013-10-01','10:30:00',2.75),('8784','2013-10-01','10:35:00',2.8),('8784','2013-10-01','10:40:00',2.84),('8784','2013-10-01','10:45:00',2.91),('8784','2013-10-01','10:50:00',2.97),('8784','2013-10-01','10:55:00',3.06),('8784','2013-10-01','11:00:00',3.12),('8784','2013-10-01','11:05:00',3.37),('8784','2013-10-01','11:10:00',3.61),('8784','2013-10-01','11:15:00',3.63),('8784','2013-10-01','11:20:00',2.44),('8784','2013-10-01','11:25:00',1.07),('8784','2013-10-01','11:30:00',2.05),('8784','2013-10-01','11:35:00',3.65),('8784','2013-10-01','11:40:00',3.54),('8784','2013-10-01','11:45:00',3.56),('8784','2013-10-01','11:50:00',2.87),('8784','2013-10-01','11:55:00',1.82),('8784','2013-10-01','12:00:00',2.74),('8784','2013-10-01','12:05:00',2.95),('8784','2013-10-01','12:10:00',3.64),('8784','2013-10-01','12:15:00',3.69),('8784','2013-10-01','12:20:00',3.77),('8784','2013-10-01','12:25:00',3.5),('8784','2013-10-01','12:30:00',3.25),('8784','2013-10-01','12:35:00',1.29),('8784','2013-10-01','12:40:00',1.13),('8784','2013-10-01','12:45:00',3.72),('8784','2013-10-01','12:50:00',1.8),('8784','2013-10-01','12:55:00',1.75),('8784','2013-10-01','13:00:00',3.84),('8784','2013-10-01','13:05:00',3.13),('8784','2013-10-01','13:10:00',1.04),('8784','2013-10-01','13:15:00',1.95),('8784','2013-10-01','13:20:00',3.96),('8784','2013-10-01','13:25:00',2.51),('8784','2013-10-01','13:30:00',1.53),('8784','2013-10-01','13:35:00',4.09),('8784','2013-10-01','13:40:00',3.9),('8784','2013-10-01','13:45:00',3.79),('8784','2013-10-01','13:50:00',3.51),('8784','2013-10-01','13:55:00',3.51),('8784','2013-10-01','14:00:00',3.35),('8784','2013-10-01','14:05:00',3.32),('8784','2013-10-01','14:10:00',3.26),('8784','2013-10-01','14:15:00',3.21),('8784','2013-10-01','14:20:00',3.22),('8784','2013-10-01','14:25:00',3.1),('8784','2013-10-01','14:30:00',3.14),('8784','2013-10-01','14:35:00',3.16),('8784','2013-10-01','14:40:00',2.96),('8784','2013-10-01','14:45:00',3.15),('8784','2013-10-01','14:50:00',3.18),('8784','2013-10-01','14:55:00',3.1),('8784','2013-10-01','15:00:00',3.01),('8784','2013-10-01','15:05:00',2.91),('8784','2013-10-01','15:10:00',2.82),('8784','2013-10-01','15:15:00',2.78),('8784','2013-10-01','15:20:00',2.72),('8784','2013-10-01','15:25:00',2.66),('8784','2013-10-01','15:30:00',2.61),('8784','2013-10-01','15:35:00',2.51),('8784','2013-10-01','15:40:00',2.48),('8784','2013-10-01','15:45:00',2.41),('8784','2013-10-01','15:50:00',2.34),('8784','2013-10-01','15:55:00',2.26),('8784','2013-10-01','16:00:00',2.18),('8784','2013-10-01','16:05:00',2.13),('8784','2013-10-01','16:10:00',2.04),('8784','2013-10-01','16:15:00',1.97),('8784','2013-10-01','16:20:00',1.89),('8784','2013-10-01','16:25:00',1.82),('8784','2013-10-01','16:30:00',1.74),('8784','2013-10-01','16:35:00',1.65),('8784','2013-10-01','16:40:00',1.55),('8784','2013-10-01','16:45:00',1.48),('8784','2013-10-01','16:50:00',1.41),('8784','2013-10-01','16:55:00',1.32),('8784','2013-10-01','17:00:00',1.25),('8784','2013-10-01','17:05:00',1.17),('8784','2013-10-01','17:10:00',1.09),('8784','2013-09-30','09:45:00',1.01),('8784','2013-09-30','09:50:00',1.28),('8784','2013-09-30','09:55:00',1.11),('8784','2013-09-30','10:00:00',1.06),('8784','2013-09-30','10:05:00',1.05),('8784','2013-09-30','10:10:00',1.15),('8784','2013-09-30','10:15:00',1.17),('8784','2013-09-30','10:20:00',1.18),('8784','2013-09-30','10:25:00',1.34),('8784','2013-09-30','10:30:00',1.51),('8784','2013-09-30','10:35:00',1.66),('8784','2013-09-30','10:40:00',2.15),('8784','2013-09-30','10:45:00',3.08),('8784','2013-09-30','10:50:00',3.19),('8784','2013-09-30','10:55:00',2.93),('8784','2013-09-30','11:00:00',2.11),('8784','2013-09-30','11:05:00',1.87),('8784','2013-09-30','11:10:00',3.2),('8784','2013-09-30','11:15:00',2.22),('8784','2013-09-30','11:20:00',3.26),('8784','2013-09-30','11:25:00',2),('8784','2013-09-30','11:30:00',2.22),('8784','2013-09-30','11:35:00',1.73),('8784','2013-09-30','11:40:00',3.97),('8784','2013-09-30','11:45:00',1.93),('8784','2013-09-30','11:50:00',1.6),('8784','2013-09-30','11:55:00',1.38),('8784','2013-09-30','12:00:00',1.55),('8784','2013-09-30','12:05:00',1.02),('8784','2013-09-30','12:10:00',1.76),('8784','2013-09-30','12:15:00',3.83),('8784','2013-09-30','12:20:00',3.87),('8784','2013-09-30','12:25:00',3.8),('8784','2013-09-30','12:30:00',3.66),('8784','2013-09-30','12:35:00',3.68),('8784','2013-09-30','12:40:00',3.51),('8784','2013-09-30','12:45:00',3.11),('8784','2013-09-30','12:50:00',3.83),('8784','2013-09-30','12:55:00',3.75),('8784','2013-09-30','13:00:00',3.81),('8784','2013-09-30','13:05:00',3.94),('8784','2013-09-30','13:10:00',3.83),('8784','2013-09-30','13:15:00',3.97),('8784','2013-09-30','13:20:00',4.14),('8784','2013-09-30','13:25:00',4.39),('8784','2013-09-30','13:30:00',4.15),('8784','2013-09-30','13:35:00',3.59),('8784','2013-09-30','13:40:00',3.45),('8784','2013-09-30','13:45:00',1.92),('8784','2013-09-30','13:50:00',3.4),('8784','2013-09-30','13:55:00',2.65),('8784','2013-09-30','14:00:00',1.96),('8784','2013-09-30','14:05:00',1.39),('8784','2013-09-30','14:10:00',1.38),('8784','2013-09-30','14:15:00',1.31),('8784','2013-09-30','14:20:00',1.13),('8784','2013-09-30','14:25:00',1.27),('8784','2013-09-30','14:30:00',2.78),('8784','2013-09-30','14:35:00',2.54),('8784','2013-09-30','14:40:00',3.81),('8784','2013-09-30','14:45:00',3.36),('8784','2013-09-30','14:50:00',2.55),('8784','2013-09-30','14:55:00',2.42),('8784','2013-09-30','15:00:00',2.05),('8784','2013-09-30','15:05:00',2.77),('8784','2013-09-30','15:10:00',3.62),('8784','2013-09-30','15:15:00',2.31),('8784','2013-09-30','15:20:00',1.55),('8784','2013-09-30','15:25:00',2.79),('8784','2013-09-30','15:30:00',1.86),('8784','2013-09-30','15:35:00',3.18),('8784','2013-09-30','15:40:00',3.1),('8784','2013-09-30','15:45:00',1.86),('8784','2013-09-30','16:10:00',1.19),('8784','2013-09-30','16:15:00',1.74),('8784','2013-09-30','16:20:00',1.75),('8784','2013-09-30','16:25:00',1.08),('8784','2013-09-30','16:45:00',1.31),('8784','2013-09-29','08:45:00',1.02),('8784','2013-09-29','08:50:00',1.29),('8784','2013-09-29','08:55:00',1.09),('8784','2013-09-29','09:00:00',1.08),('8784','2013-09-29','09:10:00',1.07),('8784','2013-09-29','09:15:00',1.28),('8784','2013-09-29','09:50:00',1.05),('8784','2013-09-29','09:55:00',1.1),('8784','2013-09-29','10:00:00',1.28),('8784','2013-09-29','10:05:00',1.73),('8784','2013-09-29','10:10:00',2),('8784','2013-09-29','10:15:00',2.51),('8784','2013-09-29','10:20:00',2.08),('8784','2013-09-29','10:25:00',2.01),('8784','2013-09-29','10:30:00',2.3),('8784','2013-09-29','10:35:00',2.45),('8784','2013-09-29','10:40:00',2.46),('8784','2013-09-29','10:45:00',2.58),('8784','2013-09-29','10:50:00',2.7),('8784','2013-09-29','10:55:00',2.72),('8784','2013-09-29','11:00:00',2.77),('8784','2013-09-29','11:05:00',2.66),('8784','2013-09-29','11:10:00',2.7),('8784','2013-09-29','11:15:00',2.9),('8784','2013-09-29','11:20:00',2.82),('8784','2013-09-29','11:25:00',2.69),('8784','2013-09-29','11:30:00',2.91),('8784','2013-09-29','11:35:00',2.88),('8784','2013-09-29','11:40:00',2.93),('8784','2013-09-29','11:45:00',3.09),('8784','2013-09-29','11:50:00',3.18),('8784','2013-09-29','11:55:00',3.24),('8784','2013-09-29','12:00:00',2.9),('8784','2013-09-29','12:05:00',2.45),('8784','2013-09-29','12:10:00',3.35),('8784','2013-09-29','12:15:00',3.67),('8784','2013-09-29','12:20:00',2.09),('8784','2013-09-29','12:25:00',1.85),('8784','2013-09-29','12:30:00',1.96),('8784','2013-09-29','12:35:00',1.87),('8784','2013-09-29','12:40:00',1.66),('8784','2013-09-29','12:45:00',1.47),('8784','2013-09-29','12:50:00',1.46),('8784','2013-09-29','12:55:00',1.3),('8784','2013-09-29','13:00:00',1.26),('8784','2013-09-29','13:05:00',1.11),('8784','2013-09-29','13:10:00',1.15),('8784','2013-09-29','13:20:00',1.03),('8784','2013-09-29','13:25:00',1.49),('8784','2013-09-29','13:30:00',1.86),('8784','2013-09-29','13:35:00',1.96),('8784','2013-09-29','13:40:00',1.78),('8784','2013-09-29','13:45:00',1.62),('8784','2013-09-29','13:50:00',1.76),('8784','2013-09-29','13:55:00',2.07),('8784','2013-09-29','14:00:00',2.03),('8784','2013-09-29','14:05:00',2.27),('8784','2013-09-29','14:10:00',1.38),('8784','2013-09-29','14:15:00',1.78),('8784','2013-09-29','14:20:00',2.58),('8784','2013-09-29','14:25:00',1.53),('8784','2013-09-29','14:30:00',1.56),('8784','2013-09-29','14:35:00',1.31),('8784','2013-09-29','14:40:00',1.02),('8784','2013-09-29','14:50:00',1.02),('8784','2013-09-29','14:55:00',1.09),('8784','2013-09-29','15:00:00',1.27),('8784','2013-09-29','15:20:00',1.02),('8784','2013-09-29','15:55:00',1.04),('8784','2013-09-29','16:00:00',1.23),('8784','2013-09-29','16:05:00',1.02),('8784','2013-09-29','16:30:00',1.24),('8784','2013-09-29','16:35:00',1.11),('8784','2014-04-14','07:55:00',1.08),('8784','2014-04-14','08:00:00',1.16),('8784','2014-04-14','08:05:00',1.23),('8784','2014-04-14','08:10:00',1.33),('8784','2014-04-14','08:15:00',1.41),('8784','2014-04-14','08:20:00',1.51),('8784','2014-04-14','08:25:00',1.6),('8784','2014-04-14','08:30:00',1.7),('8784','2014-04-14','08:35:00',1.79),('8784','2014-04-14','08:40:00',1.87),('8784','2014-04-14','08:45:00',1.96),('8784','2014-04-14','08:50:00',2.04),('8784','2014-04-14','08:55:00',2.13),('8784','2014-04-14','09:00:00',2.23),('8784','2014-04-14','09:05:00',2.3),('8784','2014-04-14','09:10:00',2.36),('8784','2014-04-14','09:15:00',2.46),('8784','2014-04-14','09:20:00',2.54),('8784','2014-04-14','09:25:00',2.63),('8784','2014-04-14','09:30:00',2.7),('8784','2014-04-14','09:35:00',2.77),('8784','2014-04-14','09:40:00',2.84),('8784','2014-04-14','09:45:00',2.9),('8784','2014-04-14','09:50:00',2.98),('8784','2014-04-14','09:55:00',3.07),('8784','2014-04-14','10:00:00',3.13),('8784','2014-04-14','10:05:00',3.18),('8784','2014-04-14','10:10:00',3.24),('8784','2014-04-14','10:15:00',3.33),('8784','2014-04-14','10:20:00',3.37),('8784','2014-04-14','10:25:00',3.43),('8784','2014-04-14','10:30:00',3.51),('8784','2014-04-14','10:35:00',3.57),('8784','2014-04-14','10:40:00',3.61),('8784','2014-04-14','10:45:00',3.63),('8784','2014-04-14','10:50:00',3.71),('8784','2014-04-14','10:55:00',3.75),('8784','2014-04-14','11:00:00',3.8),('8784','2014-04-14','11:05:00',3.81),('8784','2014-04-14','11:10:00',3.89),('8784','2014-04-14','11:15:00',3.92),('8784','2014-04-14','11:20:00',3.95),('8784','2014-04-14','11:25:00',3.95),('8784','2014-04-14','11:30:00',4.04),('8784','2014-04-14','11:35:00',4.07),('8784','2014-04-14','11:40:00',4.1),('8784','2014-04-14','11:45:00',4.12),('8784','2014-04-14','11:50:00',4.12),('8784','2014-04-14','11:55:00',4.17),('8784','2014-04-14','12:00:00',4.17),('8784','2014-04-14','12:05:00',4.21),('8784','2014-04-14','12:10:00',4.18),('8784','2014-04-14','12:15:00',4.25),('8784','2014-04-14','12:20:00',4.27),('8784','2014-04-14','12:25:00',4.25),('8784','2014-04-14','12:30:00',4.21),('8784','2014-04-14','12:35:00',4.29),('8784','2014-04-14','12:40:00',4.27),('8784','2014-04-14','12:45:00',4.3),('8784','2014-04-14','12:50:00',4.3),('8784','2014-04-14','12:55:00',4.35),('8784','2014-04-14','13:00:00',4.35),('8784','2014-04-14','13:05:00',4.3),('8784','2014-04-14','13:10:00',4.26),('8784','2014-04-14','13:15:00',4.33),('8784','2014-04-14','13:20:00',4.34),('8784','2014-04-14','13:25:00',4.34),('8784','2014-04-14','13:30:00',4.31),('8784','2014-04-14','13:35:00',4.34),('8784','2014-04-14','13:40:00',4.33),('8784','2014-04-14','13:45:00',4.31),('8784','2014-04-14','13:50:00',4.32),('8784','2014-04-14','13:55:00',4.32),('8784','2014-04-14','14:00:00',4.28),('8784','2014-04-14','14:05:00',4.29),('8784','2014-04-14','14:10:00',4.26),('8784','2014-04-14','14:15:00',4.24),('8784','2014-04-14','14:20:00',4.22),('8784','2014-04-14','14:25:00',4.19),('8784','2014-04-14','14:30:00',4.17),('8784','2014-04-14','14:35:00',4.13),('8784','2014-04-14','14:40:00',4.1),('8784','2014-04-14','14:45:00',4.07),('8784','2014-04-14','14:50:00',4.04),('8784','2014-04-14','14:55:00',4),('8784','2014-04-14','15:00:00',3.96),('8784','2014-04-14','15:05:00',3.91),('8784','2014-04-14','15:10:00',3.87),('8784','2014-04-14','15:15:00',3.74),('8784','2014-04-14','15:20:00',3.77),('8784','2014-04-14','15:25:00',3.72),('8784','2014-04-14','15:30:00',3.67),('8784','2014-04-14','15:35:00',3.58),('8784','2014-04-14','15:40:00',3.5),('8784','2014-04-14','15:45:00',3.48),('8784','2014-04-14','15:50:00',3.44),('8784','2014-04-14','15:55:00',3.37),('8784','2014-04-14','16:00:00',3.27),('8784','2014-04-14','16:05:00',3.21),('8784','2014-04-14','16:10:00',3.14),('8784','2014-04-14','16:15:00',3.07),('8784','2014-04-14','16:20:00',3.01),('8784','2014-04-14','16:25:00',2.94),('8784','2014-04-14','16:30:00',2.85),('8784','2014-04-14','16:35:00',2.79),('8784','2014-04-14','16:40:00',2.7),('8784','2014-04-14','16:45:00',2.62),('8784','2014-04-14','16:50:00',2.54),('8784','2014-04-14','16:55:00',2.43),('8784','2014-04-14','17:00:00',2.36),('8784','2014-04-14','17:05:00',2.27),('8784','2014-04-14','17:10:00',2.18),('8784','2014-04-14','17:15:00',2.09),('8784','2014-04-14','17:20:00',1.98),('8784','2014-04-14','17:25:00',1.9),('8784','2014-04-14','17:30:00',1.78),('8784','2014-04-14','17:35:00',1.7),('8784','2014-04-14','17:40:00',1.62),('8784','2014-04-14','17:45:00',1.53),('8784','2014-04-14','17:50:00',1.44),('8784','2014-04-14','17:55:00',1.35),('8784','2014-04-14','18:00:00',1.25),('8784','2014-04-14','18:05:00',1.16),('8784','2014-04-14','18:10:00',1.07),('8784','2013-09-28','08:35:00',1.02),('8784','2013-09-28','08:40:00',1.12),('8784','2013-09-28','08:45:00',1.19),('8784','2013-09-28','08:50:00',1.28),('8784','2013-09-28','08:55:00',1.35),('8784','2013-09-28','09:00:00',1.42),('8784','2013-09-28','09:05:00',1.53),('8784','2013-09-28','09:10:00',1.63),('8784','2013-09-28','09:15:00',1.67),('8784','2013-09-28','09:20:00',1.77),('8784','2013-09-28','09:25:00',1.86),('8784','2013-09-28','09:30:00',1.78),('8784','2013-09-28','09:35:00',1.66),('8784','2013-09-28','09:40:00',1.94),('8784','2013-09-28','09:45:00',2.18),('8784','2013-09-28','09:50:00',2.26),('8784','2013-09-28','09:55:00',2.52),('8784','2013-09-28','10:00:00',1.8),('8784','2013-09-28','10:05:00',1.43),('8784','2013-09-28','10:10:00',1.1),('8784','2013-09-28','10:15:00',1.58),('8784','2013-09-28','10:20:00',2.59),('8784','2013-09-28','10:25:00',1.25),('8784','2013-09-28','10:30:00',2.31),('8784','2013-09-28','10:35:00',1.87),('8784','2013-09-28','10:40:00',1.9),('8784','2013-09-28','10:45:00',3.44),('8784','2013-09-28','10:50:00',3.56),('8784','2013-09-28','10:55:00',3.09),('8784','2013-09-28','11:00:00',1.91),('8784','2013-09-28','11:05:00',1.34),('8784','2013-09-28','11:10:00',3),('8784','2013-09-28','11:15:00',3.57),('8784','2013-09-28','11:20:00',3.64),('8784','2013-09-28','11:25:00',3.74),('8784','2013-09-28','11:30:00',3.75),('8784','2013-09-28','11:35:00',2.71),('8784','2013-09-28','11:40:00',1.26),('8784','2013-09-28','11:50:00',1.9),('8784','2013-09-28','11:55:00',2.12),('8784','2013-09-28','12:00:00',3.92),('8784','2013-09-28','12:05:00',2.72),('8784','2013-09-28','12:10:00',3.6),('8784','2013-09-28','12:15:00',3.54),('8784','2013-09-28','12:20:00',3.26),('8784','2013-09-28','12:25:00',1.91),('8784','2013-09-28','12:30:00',2.63),('8784','2013-09-28','12:35:00',2.9),('8784','2013-09-28','12:40:00',3.31),('8784','2013-09-28','12:45:00',3.68),('8784','2013-09-28','12:50:00',2.98),('8784','2013-09-28','12:55:00',3.92),('8784','2013-09-28','13:00:00',3.5),('8784','2013-09-28','13:05:00',1.23),('8784','2013-09-28','13:10:00',1.43),('8784','2013-09-28','13:15:00',3.61),('8784','2013-09-28','13:20:00',3.89),('8784','2013-09-28','13:25:00',2.27),('8784','2013-09-28','13:30:00',1.59),('8784','2013-09-28','13:35:00',1.73),('8784','2013-09-28','13:40:00',1.72),('8784','2013-09-28','13:45:00',2.84),('8784','2013-09-28','13:50:00',1.72),('8784','2013-09-28','13:55:00',1.79),('8784','2013-09-28','14:00:00',2),('8784','2013-09-28','14:05:00',2.46),('8784','2013-09-28','14:10:00',3.67),('8784','2013-09-28','14:15:00',4),('8784','2013-09-28','14:20:00',3.78),('8784','2013-09-28','14:25:00',3.49),('8784','2013-09-28','14:30:00',3.57),('8784','2013-09-28','14:35:00',3.52),('8784','2013-09-28','14:40:00',3.44),('8784','2013-09-28','14:45:00',3.33),('8784','2013-09-28','14:50:00',3.24),('8784','2013-09-28','14:55:00',3.22),('8784','2013-09-28','15:00:00',3.28),('8784','2013-09-28','15:05:00',3.13),('8784','2013-09-28','15:10:00',2.98),('8784','2013-09-28','15:15:00',2.82),('8784','2013-09-28','15:20:00',2.96),('8784','2013-09-28','15:25:00',2.8),('8784','2013-09-28','15:30:00',2.67),('8784','2013-09-28','15:35:00',2.64),('8784','2013-09-28','15:40:00',2.58),('8784','2013-09-28','15:45:00',2.16),('8784','2013-09-28','15:50:00',2.23),('8784','2013-09-28','15:55:00',2.37),('8784','2013-09-28','16:00:00',2.41),('8784','2013-09-28','16:05:00',2.34),('8784','2013-09-28','16:10:00',2.27),('8784','2013-09-28','16:15:00',1.82),('8784','2013-09-28','16:20:00',1.4),('8784','2013-09-28','16:25:00',1.74),('8784','2013-09-28','16:30:00',1.69),('8784','2013-09-28','16:35:00',1.7),('8784','2013-09-28','16:40:00',1.61),('8784','2013-09-28','16:45:00',1.5),('8784','2013-09-28','16:50:00',1.44),('8784','2013-09-28','16:55:00',1.35),('8784','2013-09-28','17:00:00',1.27),('8784','2013-09-28','17:05:00',1.19),('8784','2013-09-28','17:10:00',1.1),('8784','2013-09-28','17:15:00',1.03),('8784','2013-09-27','08:25:00',1.03),('8784','2013-09-27','08:30:00',1),('8784','2013-09-27','08:35:00',1.17),('8784','2013-09-27','08:40:00',1.12),('8784','2013-09-27','08:45:00',1.1),('8784','2013-09-27','08:50:00',1.29),('8784','2013-09-27','08:55:00',1.57),('8784','2013-09-27','09:00:00',1.39),('8784','2013-09-27','09:05:00',1.08),('8784','2013-09-27','09:15:00',1.14),('8784','2013-09-27','09:50:00',2.12),('8784','2013-09-27','09:55:00',2.11),('8784','2013-09-27','10:00:00',2.21),('8784','2013-09-27','10:05:00',1.94),('8784','2013-09-27','10:10:00',2.28),('8784','2013-09-27','10:15:00',1.88),('8784','2013-09-27','10:20:00',2.65),('8784','2013-09-27','10:25:00',1.66),('8784','2013-09-27','10:30:00',1.35),('8784','2013-09-27','10:35:00',1.54),('8784','2013-09-27','10:40:00',1.4),('8784','2013-09-27','10:45:00',1.19),('8784','2013-09-27','10:50:00',1.22),('8784','2013-09-27','10:55:00',2.48),('8784','2013-09-27','11:00:00',2.7),('8784','2013-09-27','11:05:00',2.5),('8784','2013-09-27','11:10:00',2.38),('8784','2013-09-27','11:15:00',2.43),('8784','2013-09-27','11:20:00',3.39),('8784','2013-09-27','11:25:00',3.04),('8784','2013-09-27','11:30:00',1.93),('8784','2013-09-27','11:35:00',1.12),('8784','2013-09-27','11:45:00',1.34),('8784','2013-09-27','11:50:00',1.33),('8784','2013-09-27','11:55:00',1.68),('8784','2013-09-27','12:00:00',3.23),('8784','2013-09-27','12:05:00',2.21),('8784','2013-09-27','12:10:00',3.78),('8784','2013-09-27','12:15:00',1.29),('8784','2013-09-27','12:30:00',1),('8784','2013-09-27','12:40:00',1.12),('8784','2013-09-27','12:45:00',1.67),('8784','2013-09-27','12:50:00',3.07),('8784','2013-09-27','12:55:00',3.59),('8784','2013-09-27','13:00:00',3.47),('8784','2013-09-27','13:05:00',3.38),('8784','2013-09-27','13:10:00',3.38),('8784','2013-09-27','13:15:00',1.65),('8784','2013-09-27','13:20:00',2.12),('8784','2013-09-27','13:25:00',1.2),('8784','2013-09-27','13:40:00',1.28),('8784','2013-09-27','13:45:00',1.15),('8784','2013-09-27','13:50:00',1.06),('8784','2013-09-27','13:55:00',1.97),('8784','2013-09-27','14:00:00',3.36),('8784','2013-09-27','14:05:00',3.24),('8784','2013-09-27','14:10:00',3.47),('8784','2013-09-27','14:15:00',3.45),('8784','2013-09-27','14:20:00',3.32),('8784','2013-09-27','14:25:00',2.7),('8784','2013-09-27','14:30:00',3.28),('8784','2013-09-27','14:35:00',3.18),('8784','2013-09-27','14:40:00',3.18),('8784','2013-09-27','14:45:00',3.12),('8784','2013-09-27','14:50:00',2.75),('8784','2013-09-27','14:55:00',3.07),('8784','2013-09-27','15:00:00',3.07),('8784','2013-09-27','15:05:00',1.44),('8784','2013-09-27','15:10:00',2.69),('8784','2013-09-27','15:15:00',2.68),('8784','2013-09-27','15:20:00',2.51),('8784','2013-09-27','15:25:00',2.47),('8784','2013-09-27','15:30:00',2.63),('8784','2013-09-27','15:35:00',2.67),('8784','2013-09-27','15:40:00',1.59),('8784','2013-09-27','15:45:00',2.28),('8784','2013-09-27','15:50:00',2.63),('8784','2013-09-27','15:55:00',2.4),('8784','2013-09-27','16:00:00',2.07),('8784','2013-09-27','16:05:00',1.35),('8784','2013-09-27','16:10:00',1.19),('8784','2013-09-27','16:15:00',1.68),('8784','2013-09-27','16:20:00',2.01),('8784','2013-09-27','16:25:00',1.73),('8784','2013-09-27','16:30:00',1.79),('8784','2013-09-27','16:35:00',1.69),('8784','2013-09-27','16:40:00',1.64),('8784','2013-09-27','16:45:00',1.61),('8784','2013-09-27','16:50:00',1.48),('8784','2013-09-27','17:10:00',1.26),('8784','2013-09-27','17:15:00',1.23),('8784','2013-09-27','17:20:00',1.06),('8784','2013-09-26','08:40:00',1.2),('8784','2013-09-26','08:45:00',1.29),('8784','2013-09-26','08:50:00',1.37),('8784','2013-09-26','08:55:00',1.49),('8784','2013-09-26','09:00:00',1.57),('8784','2013-09-26','09:05:00',1.66),('8784','2013-09-26','09:10:00',1.7),('8784','2013-09-26','09:15:00',1.82),('8784','2013-09-26','09:20:00',1.89),('8784','2013-09-26','09:25:00',1.95),('8784','2013-09-26','09:30:00',2.03),('8784','2013-09-26','09:35:00',2.11),('8784','2013-09-26','09:40:00',2.17),('8784','2013-09-26','09:45:00',2.25),('8784','2013-09-26','09:50:00',2.32),('8784','2013-09-26','09:55:00',2.38),('8784','2013-09-26','10:00:00',2.44),('8784','2013-09-26','10:05:00',2.5),('8784','2013-09-26','10:10:00',2.52),('8784','2013-09-26','10:15:00',2.57),('8784','2013-09-26','10:20:00',2.66),('8784','2013-09-26','10:25:00',2.67),('8784','2013-09-26','10:30:00',2.77),('8784','2013-09-26','10:35:00',2.8),('8784','2013-09-26','10:40:00',2.84),('8784','2013-09-26','10:45:00',2.88),('8784','2013-09-26','10:50:00',2.93),('8784','2013-09-26','10:55:00',2.91),('8784','2013-09-26','11:00:00',2.97),('8784','2013-09-26','11:05:00',3.02),('8784','2013-09-26','11:10:00',3.09),('8784','2013-09-26','11:15:00',3.1),('8784','2013-09-26','11:20:00',3.1),('8784','2013-09-26','11:25:00',3.08),('8784','2013-09-26','11:30:00',2.83),('8784','2013-09-26','11:35:00',1.96),('8784','2013-09-26','11:40:00',3.26),('8784','2013-09-26','11:45:00',2.79),('8784','2013-09-26','11:50:00',3.43),('8784','2013-09-26','11:55:00',3.67),('8784','2013-09-26','12:00:00',2.64),('8784','2013-09-26','12:05:00',3.73),('8784','2013-09-26','12:10:00',1.35),('8784','2013-09-26','12:15:00',1.43),('8784','2013-09-26','12:20:00',1.83),('8784','2013-09-26','12:25:00',1.27),('8784','2013-09-26','12:30:00',1.47),('8784','2013-09-26','12:35:00',1.68),('8784','2013-09-26','12:40:00',1.62),('8784','2013-09-26','12:45:00',1.63),('8784','2013-09-26','12:50:00',1.66),('8784','2013-09-26','12:55:00',3.54),('8784','2013-09-26','13:00:00',2.61),('8784','2013-09-26','13:05:00',2.24),('8784','2013-09-26','13:10:00',2.24),('8784','2013-09-26','13:15:00',4.13),('8784','2013-09-26','13:20:00',3.98),('8784','2013-09-26','13:25:00',2.39),('8784','2013-09-26','13:30:00',2.2),('8784','2013-09-26','13:35:00',2.08),('8784','2013-09-26','13:40:00',1.63),('8784','2013-09-26','13:45:00',1.57),('8784','2013-09-26','13:50:00',2.44),('8784','2013-09-26','13:55:00',2.09),('8784','2013-09-26','14:00:00',2.52),('8784','2013-09-26','14:05:00',3.61),('8784','2013-09-26','14:10:00',3.48),('8784','2013-09-26','14:15:00',2.79),('8784','2013-09-26','14:20:00',1.55),('8784','2013-09-26','14:30:00',2.03),('8784','2013-09-26','14:35:00',1.09),('8784','2013-09-26','14:40:00',1.8),('8784','2013-09-26','14:45:00',3.82),('8784','2013-09-26','14:50:00',3.52),('8784','2013-09-26','14:55:00',1.83),('8784','2013-09-26','15:00:00',1.23),('8784','2013-09-26','15:05:00',1.86),('8784','2013-09-26','15:10:00',1.1),('8784','2013-09-26','15:15:00',1.09),('8784','2013-09-26','15:20:00',2.61),('8784','2013-09-26','15:25:00',1.3),('8784','2013-09-26','15:35:00',2.28),('8784','2013-09-26','15:45:00',1.41),('8784','2013-09-26','15:50:00',2.03),('8784','2013-09-26','15:55:00',2.44),('8784','2013-09-26','16:00:00',2.23),('8784','2013-09-26','16:05:00',1.17),('8784','2013-09-26','16:10:00',2.16),('8784','2013-09-26','16:15:00',1.99),('8784','2013-09-26','16:20:00',2.02),('8784','2013-09-26','16:25:00',2),('8784','2013-09-26','16:30:00',1.86),('8784','2013-09-26','16:35:00',1.77),('8784','2013-09-26','16:40:00',1.68),('8784','2013-09-26','16:45:00',1.59),('8784','2013-09-26','16:50:00',1.5),('8784','2013-09-26','16:55:00',1.44),('8784','2013-09-26','17:00:00',1.32),('8784','2013-09-26','17:05:00',1.29),('8784','2013-09-26','17:10:00',1.26),('8784','2013-09-26','17:15:00',1.1),('8784','2013-09-26','17:20:00',1.08),('8784','2013-09-25','08:25:00',1),('8784','2013-09-25','08:30:00',1.04),('8784','2013-09-25','08:45:00',1.56),('8784','2013-09-25','08:50:00',1.03),('8784','2013-09-25','09:05:00',1.47),('8784','2013-09-25','09:10:00',1.51),('8784','2013-09-25','09:15:00',1.44),('8784','2013-09-25','09:20:00',1.12),('8784','2013-09-25','09:25:00',1.76),('8784','2013-09-25','09:30:00',1.41),('8784','2013-09-25','09:35:00',2.23),('8784','2013-09-25','09:40:00',1.8),('8784','2013-09-25','09:50:00',2.2),('8784','2013-09-25','09:55:00',1.43),('8784','2013-09-25','10:00:00',1.78),('8784','2013-09-25','10:05:00',1.02),('8784','2013-09-25','10:20:00',1.02),('8784','2013-09-25','10:25:00',1.62),('8784','2013-09-25','10:30:00',1.31),('8784','2013-09-25','10:35:00',1.05),('8784','2013-09-25','10:40:00',1.62),('8784','2013-09-25','10:45:00',2.98),('8784','2013-09-25','10:50:00',3.31),('8784','2013-09-25','10:55:00',3.46),('8784','2013-09-25','11:00:00',2.7),('8784','2013-09-25','11:05:00',1.63),('8784','2013-09-25','11:10:00',1.73),('8784','2013-09-25','11:15:00',3.09),('8784','2013-09-25','11:20:00',2.91),('8784','2013-09-25','11:25:00',3.3),('8784','2013-09-25','11:30:00',3.15),('8784','2013-09-25','11:35:00',2.76),('8784','2013-09-25','11:40:00',3.65),('8784','2013-09-25','11:45:00',3.16),('8784','2013-09-25','11:50:00',1.88),('8784','2013-09-25','11:55:00',1.76),('8784','2013-09-25','12:10:00',2.54),('8784','2013-09-25','12:15:00',3.74),('8784','2013-09-25','12:20:00',1.3),('8784','2013-09-25','12:25:00',1.34),('8784','2013-09-25','12:30:00',3.52),('8784','2013-09-25','12:35:00',3.73),('8784','2013-09-25','12:40:00',1.13),('8784','2013-09-25','12:45:00',1.2),('8784','2013-09-25','12:50:00',1.32),('8784','2013-09-25','13:00:00',1.24),('8784','2013-09-25','13:05:00',1.02),('8784','2013-09-25','13:10:00',1.38),('8784','2013-09-25','13:15:00',1.51),('8784','2013-09-25','13:20:00',1.28),('8784','2013-09-25','13:25:00',3.53),('8784','2013-09-25','13:30:00',3.77),('8784','2013-09-25','13:35:00',4.04),('8784','2013-09-25','13:40:00',4.28),('8784','2013-09-25','13:45:00',4.26),('8784','2013-09-25','13:50:00',4.14),('8784','2013-09-25','13:55:00',1.48),('8784','2013-09-25','14:05:00',1.09),('8784','2013-09-25','14:10:00',1.19),('8784','2013-09-25','14:15:00',1),('8784','2013-09-25','14:20:00',1.14),('8784','2013-09-25','14:25:00',1.34),('8784','2013-09-25','14:30:00',3.46),('8784','2013-09-25','14:35:00',3.89),('8784','2013-09-25','14:40:00',3.76),('8784','2013-09-25','14:45:00',2.6),('8784','2013-09-25','14:50:00',3.18),('8784','2013-09-25','14:55:00',2.55),('8784','2013-09-25','15:00:00',3.67),('8784','2013-09-25','15:05:00',3.32),('8784','2013-09-25','15:10:00',3.18),('8784','2013-09-25','15:15:00',3.13),('8784','2013-09-25','15:20:00',2.69),('8784','2013-09-25','15:25:00',2.91),('8784','2013-09-25','15:30:00',2.66),('8784','2013-09-25','15:35:00',3.09),('8784','2013-09-25','15:40:00',2.94),('8784','2013-09-25','15:45:00',2.65),('8784','2013-09-25','15:50:00',2.67),('8784','2013-09-25','15:55:00',2.6),('8784','2013-09-25','16:00:00',2.53),('8784','2013-09-25','16:05:00',2.4),('8784','2013-09-25','16:10:00',2.32),('8784','2013-09-25','16:15:00',2.24),('8784','2013-09-25','16:20:00',1.83),('8784','2013-09-25','16:25:00',1.47),('8784','2013-09-25','16:30:00',2.04),('8784','2013-09-25','16:35:00',1.86),('8784','2013-09-25','16:40:00',1.36),('8784','2013-09-25','16:45:00',1.71),('8784','2013-09-25','16:50:00',1.63),('8784','2013-09-25','16:55:00',1.54),('8784','2013-09-25','17:00:00',1.45),('8784','2013-09-25','17:05:00',1.38),('8784','2013-09-25','17:10:00',1.29),('8784','2013-09-25','17:15:00',1.19),('8784','2013-09-25','17:20:00',1.1),('8784','2013-09-25','17:25:00',1.03),('8784','2013-09-24','08:25:00',1.08),('8784','2013-09-24','08:30:00',1.16),('8784','2013-09-24','08:35:00',1.24),('8784','2013-09-24','08:40:00',1.33),('8784','2013-09-24','08:45:00',1.41),('8784','2013-09-24','08:50:00',1.5),('8784','2013-09-24','08:55:00',1.59),('8784','2013-09-24','09:00:00',1.65),('8784','2013-09-24','09:05:00',1.74),('8784','2013-09-24','09:10:00',1.83),('8784','2013-09-24','09:15:00',1.89),('8784','2013-09-24','09:20:00',1.99),('8784','2013-09-24','09:25:00',2.08),('8784','2013-09-24','09:30:00',2.15),('8784','2013-09-24','09:35:00',2.23),('8784','2013-09-24','09:40:00',2.29),('8784','2013-09-24','09:45:00',2.36),('8784','2013-09-24','09:50:00',2.43),('8784','2013-09-24','09:55:00',2.5),('8784','2013-09-24','10:00:00',2.56),('8784','2013-09-24','10:05:00',2.61),('8784','2013-09-24','10:10:00',2.69),('8784','2013-09-24','10:15:00',2.77),('8784','2013-09-24','10:20:00',2.83),('8784','2013-09-24','10:25:00',2.89),('8784','2013-09-24','10:30:00',2.94),('8784','2013-09-24','10:35:00',2.99),('8784','2013-09-24','10:40:00',3.03),('8784','2013-09-24','10:45:00',3.08),('8784','2013-09-24','10:50:00',3.13),('8784','2013-09-24','10:55:00',3.17),('8784','2013-09-24','11:00:00',3.2),('8784','2013-09-24','11:05:00',3.24),('8784','2013-09-24','11:10:00',3.27),('8784','2013-09-24','11:15:00',3.28),('8784','2013-09-24','11:20:00',3.32),('8784','2013-09-24','11:25:00',3.35),('8784','2013-09-24','11:30:00',3.4),('8784','2013-09-24','11:35:00',3.4),('8784','2013-09-24','11:40:00',3.43),('8784','2013-09-24','11:45:00',3.45),('8784','2013-09-24','11:50:00',3.46),('8784','2013-09-24','11:55:00',3.5),('8784','2013-09-24','12:00:00',3.51),('8784','2013-09-24','12:05:00',3.51),('8784','2013-09-24','12:10:00',3.53),('8784','2013-09-24','12:15:00',3.54),('8784','2013-09-24','12:20:00',3.55),('8784','2013-09-24','12:25:00',3.55),('8784','2013-09-24','12:30:00',3.59),('8784','2013-09-24','12:35:00',3.6),('8784','2013-09-24','12:40:00',3.65),('8784','2013-09-24','12:45:00',3.65),('8784','2013-09-24','12:50:00',3.63),('8784','2013-09-24','12:55:00',3.63),('8784','2013-09-24','13:00:00',3.64),('8784','2013-09-24','13:05:00',3.63),('8784','2013-09-24','13:10:00',3.61),('8784','2013-09-24','13:15:00',3.61),('8784','2013-09-24','13:20:00',3.62),('8784','2013-09-24','13:25:00',3.55),('8784','2013-09-24','13:30:00',3.58),('8784','2013-09-24','13:35:00',3.59),('8784','2013-09-24','13:40:00',3.61),('8784','2013-09-24','13:45:00',3.55),('8784','2013-09-24','13:50:00',3.53),('8784','2013-09-24','13:55:00',3.5),('8784','2013-09-24','14:00:00',3.52),('8784','2013-09-24','14:05:00',3.46),('8784','2013-09-24','14:10:00',3.46),('8784','2013-09-24','14:15:00',3.42),('8784','2013-09-24','14:20:00',3.39),('8784','2013-09-24','14:25:00',3.36),('8784','2013-09-24','14:30:00',3.32),('8784','2013-09-24','14:35:00',3.27),('8784','2013-09-24','14:40:00',3.25),('8784','2013-09-24','14:45:00',3.21),('8784','2013-09-24','14:50:00',3.16),('8784','2013-09-24','14:55:00',3.07),('8784','2013-09-24','15:00:00',3.08),('8784','2013-09-24','15:05:00',3.06),('8784','2013-09-24','15:10:00',2.97),('8784','2013-09-24','15:15:00',2.92),('8784','2013-09-24','15:20:00',2.9),('8784','2013-09-24','15:25:00',2.87),('8784','2013-09-24','15:30:00',2.8),('8784','2013-09-24','15:35:00',2.73),('8784','2013-09-24','15:40:00',2.69),('8784','2013-09-24','15:45:00',2.65),('8784','2013-09-24','15:50:00',2.57),('8784','2013-09-24','15:55:00',2.51),('8784','2013-09-24','16:00:00',2.44),('8784','2013-09-24','16:05:00',2.36),('8784','2013-09-24','16:10:00',2.28),('8784','2013-09-24','16:15:00',2.22),('8784','2013-09-24','16:20:00',2.15),('8784','2013-09-24','16:25:00',2.05),('8784','2013-09-24','16:30:00',1.97),('8784','2013-09-24','16:35:00',1.89),('8784','2013-09-24','16:40:00',1.8),('8784','2013-09-24','16:45:00',1.74),('8784','2013-09-24','16:50:00',1.68),('8784','2013-09-24','16:55:00',1.59),('8784','2013-09-24','17:00:00',1.5),('8784','2013-09-24','17:05:00',1.4),('8784','2013-09-24','17:10:00',1.32),('8784','2013-09-24','17:15:00',1.24),('8784','2013-09-24','17:20:00',1.15),('8784','2013-09-24','17:25:00',1.06),('8784','2013-09-23','08:20:00',1.03),('8784','2013-09-23','08:25:00',1.12),('8784','2013-09-23','08:30:00',1.2),('8784','2013-09-23','08:35:00',1.28),('8784','2013-09-23','08:40:00',1.37),('8784','2013-09-23','08:45:00',1.45),('8784','2013-09-23','08:50:00',1.52),('8784','2013-09-23','08:55:00',1.63),('8784','2013-09-23','09:00:00',1.67),('8784','2013-09-23','09:05:00',1.79),('8784','2013-09-23','09:10:00',1.89),('8784','2013-09-23','09:15:00',1.97),('8784','2013-09-23','09:20:00',2.05),('8784','2013-09-23','09:25:00',2.13),('8784','2013-09-23','09:30:00',2.21),('8784','2013-09-23','09:35:00',2.28),('8784','2013-09-23','09:40:00',2.36),('8784','2013-09-23','09:45:00',2.42),('8784','2013-09-23','09:50:00',2.46),('8784','2013-09-23','09:55:00',2.56),('8784','2013-09-23','10:00:00',2.62),('8784','2013-09-23','10:05:00',2.69),('8784','2013-09-23','10:10:00',2.75),('8784','2013-09-23','10:15:00',2.81),('8784','2013-09-23','10:20:00',2.87),('8784','2013-09-23','10:25:00',2.93),('8784','2013-09-23','10:30:00',2.97),('8784','2013-09-23','10:35:00',3.03),('8784','2013-09-23','10:40:00',3.09),('8784','2013-09-23','10:45:00',3.14),('8784','2013-09-23','10:50:00',3.19),('8784','2013-09-23','10:55:00',3.25),('8784','2013-09-23','11:00:00',3.26),('8784','2013-09-23','11:05:00',3.3),('8784','2013-09-23','11:10:00',3.37),('8784','2013-09-23','11:15:00',3.43),('8784','2013-09-23','11:20:00',3.47),('8784','2013-09-23','11:25:00',3.5),('8784','2013-09-23','11:30:00',3.53),('8784','2013-09-23','11:35:00',3.54),('8784','2013-09-23','11:40:00',3.59),('8784','2013-09-23','11:45:00',3.6),('8784','2013-09-23','11:50:00',3.64),('8784','2013-09-23','11:55:00',3.68),('8784','2013-09-23','12:00:00',3.71),('8784','2013-09-23','12:05:00',3.72),('8784','2013-09-23','12:10:00',3.74),('8784','2013-09-23','12:15:00',3.76),('8784','2013-09-23','12:20:00',3.75),('8784','2013-09-23','12:25:00',3.78),('8784','2013-09-23','12:30:00',3.77),('8784','2013-09-23','12:35:00',3.76),('8784','2013-09-23','12:40:00',3.75),('8784','2013-09-23','12:45:00',3.75),('8784','2013-09-23','12:50:00',3.75),('8784','2013-09-23','12:55:00',3.72),('8784','2013-09-23','13:00:00',3.76),('8784','2013-09-23','13:05:00',3.73),('8784','2013-09-23','13:10:00',3.71),('8784','2013-09-23','13:15:00',3.69),('8784','2013-09-23','13:20:00',3.67),('8784','2013-09-23','13:25:00',3.62),('8784','2013-09-23','13:30:00',3.67),('8784','2013-09-23','13:35:00',3.66),('8784','2013-09-23','13:40:00',3.66),('8784','2013-09-23','13:45:00',3.64),('8784','2013-09-23','13:50:00',3.59),('8784','2013-09-23','13:55:00',3.57),('8784','2013-09-23','14:00:00',3.54),('8784','2013-09-23','14:05:00',3.47),('8784','2013-09-23','14:10:00',3.43),('8784','2013-09-23','14:15:00',3.51),('8784','2013-09-23','14:20:00',3.42),('8784','2013-09-23','14:25:00',3.42),('8784','2013-09-23','14:30:00',3.44),('8784','2013-09-23','14:35:00',3.36),('8784','2013-09-23','14:40:00',3.22),('8784','2013-09-23','14:45:00',3.25),('8784','2013-09-23','14:50:00',3.01),('8784','2013-09-23','14:55:00',2.69),('8784','2013-09-23','15:00:00',3.2),('8784','2013-09-23','15:05:00',3.16),('8784','2013-09-23','15:10:00',2.13),('8784','2013-09-23','15:15:00',2.31),('8784','2013-09-23','15:20:00',2.23),('8784','2013-09-23','15:25:00',2.52),('8784','2013-09-23','15:30:00',2.84),('8784','2013-09-23','15:35:00',2.77),('8784','2013-09-23','15:40:00',2.72),('8784','2013-09-23','15:45:00',2.65),('8784','2013-09-23','15:50:00',2.57),('8784','2013-09-23','15:55:00',2.4),('8784','2013-09-23','16:00:00',2.4),('8784','2013-09-23','16:05:00',2.35),('8784','2013-09-23','16:10:00',2.05),('8784','2013-09-23','16:15:00',2.22),('8784','2013-09-23','16:20:00',2.01),('8784','2013-09-23','16:25:00',2.05),('8784','2013-09-23','16:30:00',1.78),('8784','2013-09-23','16:35:00',1.75),('8784','2013-09-23','16:40:00',1.77),('8784','2013-09-23','16:45:00',1.71),('8784','2013-09-23','16:50:00',1.61),('8784','2013-09-23','16:55:00',1.53),('8784','2013-09-23','17:00:00',1.46),('8784','2013-09-23','17:05:00',1.38),('8784','2013-09-23','17:10:00',1.3),('8784','2013-09-23','17:15:00',1.22),('8784','2013-09-23','17:20:00',1.14),('8784','2013-09-23','17:25:00',1.06),('8784','2013-09-22','08:20:00',1.11),('8784','2013-09-22','08:25:00',1.12),('8784','2013-09-22','08:30:00',1.19),('8784','2013-09-22','08:35:00',1.27),('8784','2013-09-22','08:40:00',1.34),('8784','2013-09-22','08:45:00',1.42),('8784','2013-09-22','08:50:00',1.51),('8784','2013-09-22','08:55:00',1.59),('8784','2013-09-22','09:00:00',1.69),('8784','2013-09-22','09:05:00',1.78),('8784','2013-09-22','09:10:00',1.88),('8784','2013-09-22','09:15:00',1.97),('8784','2013-09-22','09:20:00',2.05),('8784','2013-09-22','09:25:00',2.12),('8784','2013-09-22','09:30:00',2.2),('8784','2013-09-22','09:35:00',2.29),('8784','2013-09-22','09:40:00',2.35),('8784','2013-09-22','09:45:00',2.4),('8784','2013-09-22','09:50:00',2.49),('8784','2013-09-22','09:55:00',2.55),('8784','2013-09-22','10:00:00',2.64),('8784','2013-09-22','10:05:00',2.71),('8784','2013-09-22','10:10:00',2.79),('8784','2013-09-22','10:15:00',2.85),('8784','2013-09-22','10:20:00',2.91),('8784','2013-09-22','10:25:00',2.96),('8784','2013-09-22','10:30:00',3.02),('8784','2013-09-22','10:35:00',3.08),('8784','2013-09-22','10:40:00',3.08),('8784','2013-09-22','10:45:00',3.16),('8784','2013-09-22','10:50:00',3.22),('8784','2013-09-22','10:55:00',3.26),('8784','2013-09-22','11:00:00',3.29),('8784','2013-09-22','11:05:00',3.32),('8784','2013-09-22','11:10:00',3.35),('8784','2013-09-22','11:15:00',3.42),('8784','2013-09-22','11:20:00',3.47),('8784','2013-09-22','11:25:00',3.51),('8784','2013-09-22','11:30:00',3.54),('8784','2013-09-22','11:35:00',3.6),('8784','2013-09-22','11:40:00',3.64),('8784','2013-09-22','11:45:00',3.67),('8784','2013-09-22','11:50:00',3.7),('8784','2013-09-22','11:55:00',3.7),('8784','2013-09-22','12:00:00',3.74),('8784','2013-09-22','12:05:00',3.76),('8784','2013-09-22','12:10:00',3.78),('8784','2013-09-22','12:15:00',3.77),('8784','2013-09-22','12:20:00',3.8),('8784','2013-09-22','12:25:00',3.76),('8784','2013-09-22','12:30:00',3.81),('8784','2013-09-22','12:35:00',3.8),('8784','2013-09-22','12:40:00',3.84),('8784','2013-09-22','12:45:00',3.83),('8784','2013-09-22','12:50:00',3.85),('8784','2013-09-22','12:55:00',3.91),('8784','2013-09-22','13:00:00',3.87),('8784','2013-09-22','13:05:00',3.85),('8784','2013-09-22','13:10:00',3.88),('8784','2013-09-22','13:15:00',3.83),('8784','2013-09-22','13:20:00',3.81),('8784','2013-09-22','13:25:00',3.77),('8784','2013-09-22','13:30:00',3.81),('8784','2013-09-22','13:35:00',3.76),('8784','2013-09-22','13:40:00',3.69),('8784','2013-09-22','13:45:00',3.74),('8784','2013-09-22','13:50:00',3.75),('8784','2013-09-22','13:55:00',3.72),('8784','2013-09-22','14:00:00',3.66),('8784','2013-09-22','14:05:00',3.71),('8784','2013-09-22','14:10:00',3.72),('8784','2013-09-22','14:15:00',3.29),('8784','2013-09-22','14:20:00',2.62),('8784','2013-09-22','14:25:00',3.43),('8784','2013-09-22','14:30:00',1.17),('8784','2013-09-22','14:35:00',3.54),('8784','2013-09-22','14:40:00',3.55),('8784','2013-09-22','14:45:00',3.45),('8784','2013-09-22','14:50:00',3.36),('8784','2013-09-22','14:55:00',3.32),('8784','2013-09-22','15:00:00',3.36),('8784','2013-09-22','15:05:00',3.43),('8784','2013-09-22','15:10:00',3.32),('8784','2013-09-22','15:15:00',3.46),('8784','2013-09-22','15:20:00',3.66),('8784','2013-09-22','15:25:00',1.99),('8784','2013-09-22','15:30:00',1.31),('8784','2013-09-22','15:35:00',1.1),('8784','2013-09-22','15:40:00',3.07),('8784','2013-09-22','15:45:00',2.89),('8784','2013-09-22','15:50:00',2.73),('8784','2013-09-22','15:55:00',2.67),('8784','2013-09-22','16:00:00',2.91),('8784','2013-09-22','16:05:00',2.89),('8784','2013-09-22','16:10:00',2.96),('8784','2013-09-22','16:15:00',2.76),('8784','2013-09-22','16:20:00',1.61),('8784','2013-09-22','16:25:00',1.6),('8784','2013-09-22','16:30:00',1.46),('8784','2013-09-22','16:35:00',1.11),('8784','2013-09-22','16:40:00',1.06),('8784','2013-09-22','16:45:00',1.6),('8784','2013-09-22','16:50:00',1.89),('8784','2013-09-22','16:55:00',1.51),('8784','2013-09-22','17:00:00',1.29),('8784','2013-09-22','17:05:00',1.81),('8784','2013-09-22','17:10:00',1.56),('8784','2013-09-21','08:20:00',1.04),('8784','2013-09-21','08:25:00',1.11),('8784','2013-09-21','08:30:00',1.2),('8784','2013-09-21','08:35:00',1.28),('8784','2013-09-21','08:40:00',1.34),('8784','2013-09-21','08:45:00',1.37),('8784','2013-09-21','08:50:00',1.48),('8784','2013-09-21','08:55:00',1.59),('8784','2013-09-21','09:00:00',1.69),('8784','2013-09-21','09:05:00',1.77),('8784','2013-09-21','09:10:00',1.85),('8784','2013-09-21','09:15:00',1.93),('8784','2013-09-21','09:20:00',1.99),('8784','2013-09-21','09:25:00',2.08),('8784','2013-09-21','09:30:00',2.13),('8784','2013-09-21','09:35:00',2.24),('8784','2013-09-21','09:40:00',2.29),('8784','2013-09-21','09:45:00',2.36),('8784','2013-09-21','09:50:00',2.45),('8784','2013-09-21','09:55:00',2.51),('8784','2013-09-21','10:00:00',2.58),('8784','2013-09-21','10:05:00',2.64),('8784','2013-09-21','10:10:00',2.71),('8784','2013-09-21','10:15:00',2.78),('8784','2013-09-21','10:20:00',2.83),('8784','2013-09-21','10:25:00',2.89),('8784','2013-09-21','10:30:00',2.96),('8784','2013-09-21','10:35:00',3.01),('8784','2013-09-21','10:40:00',3.05),('8784','2013-09-21','10:45:00',3.1),('8784','2013-09-21','10:50:00',3.16),('8784','2013-09-21','10:55:00',3.2),('8784','2013-09-21','11:00:00',3.23),('8784','2013-09-21','11:05:00',3.21),('8784','2013-09-21','11:10:00',3.31),('8784','2013-09-21','11:15:00',3.34),('8784','2013-09-21','11:20:00',3.39),('8784','2013-09-21','11:25:00',3.43),('8784','2013-09-21','11:30:00',3.46),('8784','2013-09-21','11:35:00',3.5),('8784','2013-09-21','11:40:00',3.55),('8784','2013-09-21','11:45:00',3.58),('8784','2013-09-21','11:50:00',3.61),('8784','2013-09-21','11:55:00',3.55),('8784','2013-09-21','12:00:00',3.59),('8784','2013-09-21','12:05:00',3.68),('8784','2013-09-21','12:10:00',3.7),('8784','2013-09-21','12:15:00',3.73),('8784','2013-09-21','12:20:00',3.55),('8784','2013-09-21','12:25:00',3.42),('8784','2013-09-21','12:30:00',3.79),('8784','2013-09-21','12:35:00',3.68),('8784','2013-09-21','12:40:00',3.55),('8784','2013-09-21','12:45:00',3.65),('8784','2013-09-21','12:50:00',3.72),('8784','2013-09-21','12:55:00',3.78),('8784','2013-09-21','13:00:00',3.78),('8784','2013-09-21','13:05:00',3.67),('8784','2013-09-21','13:10:00',3.75),('8784','2013-09-21','13:15:00',3.84),('8784','2013-09-21','13:20:00',3.17),('8784','2013-09-21','13:25:00',3.61),('8784','2013-09-21','13:30:00',3.6),('8784','2013-09-21','13:35:00',3.6),('8784','2013-09-21','13:40:00',3.19),('8784','2013-09-21','13:45:00',3.19),('8784','2013-09-21','13:50:00',3.26),('8784','2013-09-21','13:55:00',3.17),('8784','2013-09-21','14:00:00',3.39),('8784','2013-09-21','14:05:00',3.5),('8784','2013-09-21','14:10:00',3.4),('8784','2013-09-21','14:15:00',3.53),('8784','2013-09-21','14:20:00',3.51),('8784','2013-09-21','14:25:00',3.48),('8784','2013-09-21','14:30:00',3.41),('8784','2013-09-21','14:35:00',3.38),('8784','2013-09-21','14:40:00',3.34),('8784','2013-09-21','14:45:00',3.28),('8784','2013-09-21','14:50:00',3.25),('8784','2013-09-21','14:55:00',3.19),('8784','2013-09-21','15:00:00',3.16),('8784','2013-09-21','15:05:00',3.11),('8784','2013-09-21','15:10:00',3.02),('8784','2013-09-21','15:15:00',2.94),('8784','2013-09-21','15:20:00',2.94),('8784','2013-09-21','15:25:00',2.88),('8784','2013-09-21','15:30:00',2.83),('8784','2013-09-21','15:35:00',2.79),('8784','2013-09-21','15:40:00',2.5),('8784','2013-09-21','15:45:00',1.82),('8784','2013-09-21','15:50:00',2.6),('8784','2013-09-21','15:55:00',2.4),('8784','2013-09-21','16:00:00',1.87),('8784','2013-09-21','16:05:00',1.31),('8784','2013-09-21','16:10:00',1.54),('8784','2013-09-21','16:15:00',1.38),('8784','2013-09-21','16:20:00',1.59),('8784','2013-09-21','16:30:00',1.18),('8784','2013-09-21','16:35:00',1.41),('8784','2013-09-21','16:55:00',1.12),('8784','2013-09-20','08:30:00',1.23),('8784','2013-09-20','08:35:00',1.33),('8784','2013-09-20','08:40:00',1.51),('8784','2013-09-20','08:45:00',1.28),('8784','2013-09-20','08:50:00',1.04),('8784','2013-09-20','08:55:00',1),('8784','2013-09-20','09:00:00',1.13),('8784','2013-09-20','09:05:00',1.26),('8784','2013-09-20','09:10:00',1.14),('8784','2013-09-20','09:15:00',1.34),('8784','2013-09-20','09:20:00',1.41),('8784','2013-09-20','09:25:00',1.44),('8784','2013-09-20','09:30:00',1.28),('8784','2013-09-20','09:35:00',1.3),('8784','2013-09-20','09:40:00',1.34),('8784','2013-09-20','09:45:00',1.38),('8784','2013-09-20','09:50:00',1.39),('8784','2013-09-20','09:55:00',1.58),('8784','2013-09-20','10:00:00',1.93),('8784','2013-09-20','10:05:00',2.41),('8784','2013-09-20','10:10:00',2.48),('8784','2013-09-20','10:15:00',3.5),('8784','2013-09-20','10:20:00',2.85),('8784','2013-09-20','10:25:00',2.54),('8784','2013-09-20','10:30:00',2.85),('8784','2013-09-20','10:35:00',2.46),('8784','2013-09-20','10:40:00',3.7),('8784','2013-09-20','10:45:00',3.14),('8784','2013-09-20','10:50:00',2.75),('8784','2013-09-20','10:55:00',2.17),('8784','2013-09-20','11:00:00',1.99),('8784','2013-09-20','11:05:00',2.02),('8784','2013-09-20','11:10:00',2.31),('8784','2013-09-20','11:15:00',2.44),('8784','2013-09-20','11:20:00',2.52),('8784','2013-09-20','11:25:00',2.34),('8784','2013-09-20','11:30:00',2.83),('8784','2013-09-20','11:35:00',2.52),('8784','2013-09-20','11:40:00',3.85),('8784','2013-09-20','11:45:00',3.8),('8784','2013-09-20','11:50:00',3.86),('8784','2013-09-20','11:55:00',3.77),('8784','2013-09-20','12:00:00',3.72),('8784','2013-09-20','12:05:00',3.72),('8784','2013-09-20','12:10:00',3.75),('8784','2013-09-20','12:15:00',3.83),('8784','2013-09-20','12:20:00',3.91),('8784','2013-09-20','12:25:00',3.2),('8784','2013-09-20','12:30:00',3.64),('8784','2013-09-20','12:35:00',2.71),('8784','2013-09-20','12:40:00',3.31),('8784','2013-09-20','12:45:00',2.38),('8784','2013-09-20','12:50:00',4.02),('8784','2013-09-20','12:55:00',3.91),('8784','2013-09-20','13:00:00',3.02),('8784','2013-09-20','13:05:00',3.78),('8784','2013-09-20','13:10:00',3.74),('8784','2013-09-20','13:15:00',2.29),('8784','2013-09-20','13:20:00',1.16),('8784','2013-09-20','13:25:00',2.72),('8784','2013-09-20','13:30:00',3.88),('8784','2013-09-20','13:35:00',3.4),('8784','2013-09-20','13:40:00',3.46),('8784','2013-09-20','13:45:00',3.79),('8784','2013-09-20','13:50:00',3.59),('8784','2013-09-20','13:55:00',3.3),('8784','2013-09-20','14:00:00',1.77),('8784','2013-09-20','14:10:00',2.84),('8784','2013-09-20','14:15:00',3.26),('8784','2013-09-20','14:20:00',1.53),('8784','2013-09-20','14:25:00',3.77),('8784','2013-09-20','14:30:00',3.76),('8784','2013-09-20','14:35:00',3.57),('8784','2013-09-20','14:40:00',2.72),('8784','2013-09-20','14:45:00',3.48),('8784','2013-09-20','14:50:00',3.55),('8784','2013-09-20','14:55:00',3.51),('8784','2013-09-20','15:00:00',2.31),('8784','2013-09-20','15:05:00',3.45),('8784','2013-09-20','15:10:00',2.33),('8784','2013-09-20','15:15:00',2.2),('8784','2013-09-20','15:20:00',2.3),('8784','2013-09-20','15:25:00',1.11),('8784','2013-09-20','15:30:00',1.48),('8784','2013-09-20','15:35:00',3.26),('8784','2013-09-20','15:40:00',3.08),('8784','2013-09-20','15:45:00',2.9),('8784','2013-09-20','15:50:00',2.83),('8784','2013-09-20','15:55:00',2.91),('8784','2013-09-20','16:00:00',3.08),('8784','2013-09-20','16:05:00',2.15),('8784','2013-09-20','16:10:00',1.59),('8784','2013-09-20','16:15:00',2.36),('8784','2013-09-20','16:20:00',1.55),('8784','2013-09-20','16:25:00',1.32),('8784','2013-09-20','16:45:00',1.8),('8784','2013-09-20','16:50:00',2.16),('8784','2013-09-20','16:55:00',2.16),('8784','2013-09-20','17:00:00',2.04),('8784','2013-09-20','17:05:00',2.15),('8784','2013-09-20','17:10:00',2.2),('8784','2013-09-20','17:15:00',2.06),('8784','2013-09-20','17:20:00',2),('8784','2013-09-20','17:25:00',1.7),('8784','2013-09-20','17:30:00',1.43),('8784','2013-09-20','17:35:00',1.06),('8784','2013-09-20','17:40:00',1.05),('8784','2013-09-20','17:45:00',1.09),('8784','2013-09-20','17:50:00',1.01),('8784','2013-09-20','18:05:00',1.01),('8784','2013-09-19','08:20:00',1.03),('8784','2013-09-19','08:25:00',1.06),('8784','2013-09-19','08:30:00',1.27),('8784','2013-09-19','08:35:00',1.27),('8784','2013-09-19','08:40:00',1.21),('8784','2013-09-19','08:45:00',1.23),('8784','2013-09-19','08:50:00',1.21),('8784','2013-09-19','08:55:00',1.35),('8784','2013-09-19','09:00:00',1.25),('8784','2013-09-19','09:10:00',1.82),('8784','2013-09-19','09:15:00',1.75),('8784','2013-09-19','09:20:00',1.34),('8784','2013-09-19','10:05:00',2.46),('8784','2013-09-19','10:10:00',1.74),('8784','2013-09-19','10:15:00',1.31),('8784','2013-09-19','10:25:00',1.14),('8784','2013-09-19','10:30:00',1.19),('8784','2013-09-19','10:35:00',3.45),('8784','2013-09-19','10:40:00',3.04),('8784','2013-09-19','10:45:00',2.9),('8784','2013-09-19','10:50:00',1.65),('8784','2013-09-19','10:55:00',3.7),('8784','2013-09-19','11:00:00',3.98),('8784','2013-09-19','11:05:00',3.12),('8784','2013-09-19','11:10:00',2.24),('8784','2013-09-19','11:15:00',1.78),('8784','2013-09-19','11:20:00',2.59),('8784','2013-09-19','11:25:00',2.94),('8784','2013-09-19','11:30:00',3.45),('8784','2013-09-19','11:35:00',3.49),('8784','2013-09-19','11:40:00',2.54),('8784','2013-09-19','11:45:00',4.01),('8784','2013-09-19','11:50:00',3.5),('8784','2013-09-19','11:55:00',3.37),('8784','2013-09-19','12:00:00',2.7),('8784','2013-09-19','12:05:00',1.76),('8784','2013-09-19','12:10:00',3.64),('8784','2013-09-19','12:15:00',2.02),('8784','2013-09-19','12:20:00',4.13),('8784','2013-09-19','12:25:00',3.73),('8784','2013-09-19','12:30:00',4.17),('8784','2013-09-19','12:35:00',3.98),('8784','2013-09-19','12:40:00',3.73),('8784','2013-09-19','12:45:00',2.91),('8784','2013-09-19','12:50:00',4.21),('8784','2013-09-19','12:55:00',4.14),('8784','2013-09-19','13:00:00',4.14),('8784','2013-09-19','13:05:00',4.18),('8784','2013-09-19','13:10:00',4.39),('8784','2013-09-19','13:15:00',4.34),('8784','2013-09-19','13:20:00',3.97),('8784','2013-09-19','13:25:00',3.51),('8784','2013-09-19','13:30:00',4.02),('8784','2013-09-19','13:35:00',4.09),('8784','2013-09-19','13:40:00',4.39),('8784','2013-09-19','13:45:00',4.48),('8784','2013-09-19','13:50:00',3.44),('8784','2013-09-19','13:55:00',1.56),('8784','2013-09-19','14:00:00',1.24),('8784','2013-09-19','14:05:00',4),('8784','2013-09-19','14:10:00',3.87),('8784','2013-09-19','14:15:00',3.74),('8784','2013-09-19','14:20:00',3.66),('8784','2013-09-19','14:25:00',3.58),('8784','2013-09-19','14:30:00',3.56),('8784','2013-09-19','14:35:00',3.53),('8784','2013-09-19','14:40:00',3.21),('8784','2013-09-19','14:45:00',3.38),('8784','2013-09-19','14:50:00',3.24),('8784','2013-09-19','14:55:00',3.5),('8784','2013-09-19','15:00:00',3.28),('8784','2013-09-19','15:05:00',2.88),('8784','2013-09-19','15:10:00',2.81),('8784','2013-09-19','15:15:00',2.84),('8784','2013-09-19','15:20:00',3.26),('8784','2013-09-19','15:25:00',2.82),('8784','2013-09-19','15:30:00',2.08),('8784','2013-09-19','15:35:00',2.12),('8784','2013-09-19','15:40:00',3.19),('8784','2013-09-19','15:45:00',2.99),('8784','2013-09-19','15:50:00',2.78),('8784','2013-09-19','15:55:00',2.52),('8784','2013-09-19','16:00:00',2.61),('8784','2013-09-19','16:05:00',2.55),('8784','2013-09-19','16:10:00',2.36),('8784','2013-09-19','16:15:00',2.41),('8784','2013-09-19','16:20:00',2.48),('8784','2013-09-19','16:25:00',2.12),('8784','2013-09-19','16:30:00',1.77),('8784','2013-09-19','16:35:00',1.92),('8784','2013-09-19','16:40:00',1.36),('8784','2013-09-19','16:45:00',1.71),('8784','2013-09-19','16:50:00',1.61),('8784','2013-09-19','16:55:00',1.94),('8784','2013-09-19','17:00:00',1.56),('8784','2013-09-19','17:05:00',1.57),('8784','2013-09-19','17:10:00',1.47),('8784','2013-09-19','17:15:00',1.4),('8784','2013-09-19','17:20:00',1.22),('8784','2013-09-19','17:25:00',1.18),('8784','2013-09-19','17:30:00',1.08),('8784','2014-04-13','09:00:00',1.01),('8784','2014-04-13','09:05:00',1.37),('8784','2014-04-13','09:10:00',1.6),('8784','2014-04-13','09:15:00',1.35),('8784','2014-04-13','09:20:00',1.53),('8784','2014-04-13','09:25:00',1.73),('8784','2014-04-13','09:30:00',2.51),('8784','2014-04-13','09:35:00',1.7),('8784','2014-04-13','09:40:00',2.24),('8784','2014-04-13','09:45:00',1.99),('8784','2014-04-13','09:50:00',1.51),('8784','2014-04-13','09:55:00',1.55),('8784','2014-04-13','10:00:00',2.74),('8784','2014-04-13','10:05:00',3.93),('8784','2014-04-13','10:10:00',2.65),('8784','2014-04-13','10:15:00',2.5),('8784','2014-04-13','10:20:00',2.86),('8784','2014-04-13','10:25:00',1.96),('8784','2014-04-13','10:30:00',3.46),('8784','2014-04-13','10:35:00',3.13),('8784','2014-04-13','10:40:00',3.52),('8784','2014-04-13','10:45:00',3.7),('8784','2014-04-13','10:50:00',3.7),('8784','2014-04-13','10:55:00',3.76),('8784','2014-04-13','11:00:00',3.75),('8784','2014-04-13','11:05:00',3.87),('8784','2014-04-13','11:10:00',3.79),('8784','2014-04-13','11:15:00',4.06),('8784','2014-04-13','11:20:00',3.7),('8784','2014-04-13','11:25:00',3.08),('8784','2014-04-13','11:30:00',2.23),('8784','2014-04-13','11:35:00',2.53),('8784','2014-04-13','11:40:00',4.04),('8784','2014-04-13','11:45:00',3.93),('8784','2014-04-13','11:50:00',4.08),('8784','2014-04-13','11:55:00',2.88),('8784','2014-04-13','12:00:00',2.29),('8784','2014-04-13','12:05:00',1.82),('8784','2014-04-13','12:10:00',1.61),('8784','2014-04-13','12:15:00',1.5),('8784','2014-04-13','12:20:00',1.34),('8784','2014-04-13','13:05:00',1.45),('8784','2014-04-13','13:10:00',2.12),('8784','2014-04-13','13:15:00',2.12),('8784','2014-04-13','13:20:00',2.95),('8784','2014-04-13','13:25:00',3.21),('8784','2014-04-13','13:30:00',4.64),('8784','2014-04-13','13:35:00',4.14),('8784','2014-04-13','13:40:00',3.8),('8784','2014-04-13','13:45:00',2.09),('8784','2014-04-13','13:50:00',3.11),('8784','2014-04-13','13:55:00',2.75),('8784','2014-04-13','14:00:00',4.37),('8784','2014-04-13','14:05:00',4.16),('8784','2014-04-13','14:10:00',4.31),('8784','2014-04-13','14:15:00',4.46),('8784','2014-04-13','14:20:00',2.13),('8784','2014-04-13','14:25:00',1.79),('8784','2014-04-13','14:30:00',1.79),('8784','2014-04-13','14:35:00',1.71),('8784','2014-04-13','14:40:00',1.48),('8784','2014-04-13','14:45:00',2.08),('8784','2014-04-13','14:50:00',4.27),('8784','2014-04-13','14:55:00',3.42),('8784','2014-04-13','15:00:00',3.38),('8784','2014-04-13','15:05:00',3.82),('8784','2014-04-13','15:10:00',3.96),('8784','2014-04-13','15:15:00',3.41),('8784','2014-04-13','15:20:00',3.34),('8784','2014-04-13','15:25:00',3.57),('8784','2014-04-13','15:30:00',3.39),('8784','2014-04-13','15:35:00',2.37),('8784','2014-04-13','15:40:00',1.47),('8784','2014-04-13','15:45:00',1.72),('8784','2014-04-13','15:50:00',1.88),('8784','2014-04-13','15:55:00',1.81),('8784','2014-04-13','16:00:00',3.46),('8784','2014-04-13','16:05:00',2.84),('8784','2014-04-13','16:10:00',1.34),('8784','2014-04-13','16:15:00',1.42),('8784','2014-04-13','16:20:00',1.47),('8784','2014-04-13','16:25:00',1.77),('8784','2014-04-13','16:30:00',1.4),('8784','2014-04-13','16:35:00',1.54),('8784','2014-04-13','16:40:00',2.89),('8784','2014-04-13','16:45:00',2.82),('8784','2014-04-13','16:50:00',2.43),('8784','2014-04-13','16:55:00',2.36),('8784','2014-04-13','17:00:00',2.22),('8784','2014-04-13','17:05:00',1.52),('8784','2014-04-13','17:10:00',1.06),('8784','2014-04-13','17:15:00',1.15),('8784','2014-04-13','17:20:00',1.7),('8784','2014-04-13','17:25:00',1.38),('8784','2014-04-13','17:50:00',1.02),('8784','2014-04-13','17:55:00',1.23),('8784','2014-04-13','18:00:00',1.1),('8784','2013-09-18','08:45:00',1.32),('8784','2013-09-18','08:50:00',1.11),('8784','2013-09-18','08:55:00',1.4),('8784','2013-09-18','09:00:00',1.56),('8784','2013-09-18','09:05:00',1.54),('8784','2013-09-18','09:15:00',1.67),('8784','2013-09-18','09:20:00',2.36),('8784','2013-09-18','09:25:00',1.87),('8784','2013-09-18','09:30:00',1.06),('8784','2013-09-18','09:35:00',2.3),('8784','2013-09-18','09:40:00',2.07),('8784','2013-09-18','09:55:00',2.02),('8784','2013-09-18','10:00:00',2.65),('8784','2013-09-18','10:05:00',2.87),('8784','2013-09-18','10:10:00',2.93),('8784','2013-09-18','10:15:00',2.79),('8784','2013-09-18','10:20:00',2.86),('8784','2013-09-18','10:25:00',2.88),('8784','2013-09-18','10:30:00',2.92),('8784','2013-09-18','10:35:00',2.98),('8784','2013-09-18','10:40:00',3.02),('8784','2013-09-18','10:45:00',2.93),('8784','2013-09-18','10:50:00',2.73),('8784','2013-09-18','10:55:00',2.81),('8784','2013-09-18','11:00:00',3.45),('8784','2013-09-18','11:05:00',3.5),('8784','2013-09-18','11:10:00',3.57),('8784','2013-09-18','11:15:00',2.4),('8784','2013-09-18','11:20:00',3.05),('8784','2013-09-18','11:25:00',3.56),('8784','2013-09-18','11:30:00',3.64),('8784','2013-09-18','11:35:00',3.91),('8784','2013-09-18','11:40:00',2.87),('8784','2013-09-18','11:45:00',3.76),('8784','2013-09-18','11:50:00',3.71),('8784','2013-09-18','11:55:00',3.56),('8784','2013-09-18','12:00:00',3.85),('8784','2013-09-18','12:05:00',3.96),('8784','2013-09-18','12:10:00',3.96),('8784','2013-09-18','12:15:00',4.04),('8784','2013-09-18','12:20:00',3.79),('8784','2013-09-18','12:25:00',2.19),('8784','2013-09-18','12:30:00',2.28),('8784','2013-09-18','12:35:00',4.44),('8784','2013-09-18','12:40:00',3.08),('8784','2013-09-18','12:45:00',2.84),('8784','2013-09-18','12:50:00',3.26),('8784','2013-09-18','12:55:00',3.83),('8784','2013-09-18','13:00:00',1.54),('8784','2013-09-18','13:05:00',3.72),('8784','2013-09-18','13:10:00',4.17),('8784','2013-09-18','13:15:00',4.07),('8784','2013-09-18','13:20:00',3.99),('8784','2013-09-18','13:25:00',4.03),('8784','2013-09-18','13:30:00',3.98),('8784','2013-09-18','13:35:00',3.95),('8784','2013-09-18','13:40:00',3.96),('8784','2013-09-18','13:45:00',3.84),('8784','2013-09-18','13:50:00',4.12),('8784','2013-09-18','13:55:00',3.99),('8784','2013-09-18','14:00:00',3.51),('8784','2013-09-18','14:05:00',2.54),('8784','2013-09-18','14:10:00',3.27),('8784','2013-09-18','14:15:00',3.12),('8784','2013-09-18','14:20:00',3.74),('8784','2013-09-18','14:25:00',3.67),('8784','2013-09-18','14:30:00',3.6),('8784','2013-09-18','14:35:00',3.57),('8784','2013-09-18','14:40:00',3.56),('8784','2013-09-18','14:45:00',3.41),('8784','2013-09-18','14:50:00',3.34),('8784','2013-09-18','14:55:00',2.63),('8784','2013-09-18','15:00:00',3.16),('8784','2013-09-18','15:10:00',1.39),('8784','2013-09-18','15:15:00',2.18),('8784','2013-09-18','15:20:00',2.41),('8784','2013-09-18','15:25:00',3.25),('8784','2013-09-18','15:30:00',3.21),('8784','2013-09-18','15:35:00',3.19),('8784','2013-09-18','15:40:00',3.02),('8784','2013-09-18','15:45:00',2.85),('8784','2013-09-18','15:50:00',1.89),('8784','2013-09-18','15:55:00',2.43),('8784','2013-09-18','16:00:00',2.88),('8784','2013-09-18','16:05:00',2.91),('8784','2013-09-18','16:10:00',2.67),('8784','2013-09-18','16:15:00',2.53),('8784','2013-09-18','16:20:00',2.38),('8784','2013-09-18','16:25:00',2.07),('8784','2013-09-18','16:30:00',2),('8784','2013-09-18','16:35:00',1.86),('8784','2013-09-18','16:40:00',1.92),('8784','2013-09-18','16:45:00',1.87),('8784','2013-09-18','16:50:00',1.66),('8784','2013-09-18','16:55:00',1.63),('8784','2013-09-18','17:00:00',1.71),('8784','2013-09-18','17:05:00',1.5),('8784','2013-09-18','17:10:00',1.52),('8784','2013-09-18','17:15:00',1.45),('8784','2013-09-18','17:20:00',1.25),('8784','2013-09-18','17:25:00',1.11),('8784','2013-09-18','17:30:00',1.23),('8784','2013-09-18','17:35:00',1.1),('8784','2013-09-18','17:40:00',1.02),('8784','2013-09-17','09:20:00',1.44),('8784','2013-09-17','09:30:00',1.21),('8784','2013-09-17','09:40:00',1.42),('8784','2013-09-17','09:45:00',2.2),('8784','2013-09-17','09:50:00',1.33),('8784','2013-09-17','09:55:00',1.84),('8784','2013-09-17','10:00:00',2.13),('8784','2013-09-17','10:05:00',1.5),('8784','2013-09-17','10:10:00',1.78),('8784','2013-09-17','10:20:00',1.38),('8784','2013-09-17','10:25:00',2.36),('8784','2013-09-17','10:30:00',3.21),('8784','2013-09-17','10:35:00',1.76),('8784','2013-09-17','10:40:00',1.87),('8784','2013-09-17','10:45:00',2.4),('8784','2013-09-17','10:50:00',3.75),('8784','2013-09-17','10:55:00',3.03),('8784','2013-09-17','11:00:00',2.36),('8784','2013-09-17','11:05:00',2.08),('8784','2013-09-17','11:10:00',3.63),('8784','2013-09-17','11:15:00',2.88),('8784','2013-09-17','11:20:00',2.49),('8784','2013-09-17','11:25:00',1.8),('8784','2013-09-17','11:30:00',1.95),('8784','2013-09-17','11:35:00',3.22),('8784','2013-09-17','11:40:00',3.26),('8784','2013-09-17','11:45:00',2.96),('8784','2013-09-17','11:50:00',3.57),('8784','2013-09-17','11:55:00',3.25),('8784','2013-09-17','12:00:00',3.53),('8784','2013-09-17','12:05:00',3.13),('8784','2013-09-17','12:10:00',1.83),('8784','2013-09-17','12:15:00',2.27),('8784','2013-09-17','12:20:00',2.27),('8784','2013-09-17','12:25:00',4.08),('8784','2013-09-17','12:30:00',2.77),('8784','2013-09-17','12:35:00',2.31),('8784','2013-09-17','12:40:00',3.22),('8784','2013-09-17','12:45:00',3.94),('8784','2013-09-17','12:50:00',3.07),('8784','2013-09-17','12:55:00',3.09),('8784','2013-09-17','13:00:00',2.2),('8784','2013-09-17','13:05:00',1.56),('8784','2013-09-17','13:10:00',2.98),('8784','2013-09-17','13:15:00',3.06),('8784','2013-09-17','13:20:00',2.71),('8784','2013-09-17','13:25:00',2.53),('8784','2013-09-17','13:30:00',1.9),('8784','2013-09-17','13:35:00',2.25),('8784','2013-09-17','13:40:00',2.55),('8784','2013-09-17','13:45:00',1.53),('8784','2013-09-17','13:50:00',1.02),('8784','2013-09-17','13:55:00',1.4),('8784','2013-09-17','14:00:00',2.04),('8784','2013-09-17','14:05:00',1.28),('8784','2013-09-17','14:10:00',1.04),('8784','2013-09-17','14:15:00',1.37),('8784','2013-09-17','14:25:00',1.75),('8784','2013-09-17','14:30:00',1.05),('8784','2013-09-17','14:35:00',1.25),('8784','2013-09-17','14:50:00',1.44),('8784','2013-09-17','14:55:00',3.46),('8784','2013-09-17','15:00:00',3.39),('8784','2013-09-17','15:05:00',2.74),('8784','2013-09-17','15:10:00',2.45),('8784','2013-09-17','15:15:00',2.96),('8784','2013-09-17','15:20:00',3.04),('8784','2013-09-17','15:25:00',2.75),('8784','2013-09-17','15:30:00',2.38),('8784','2013-09-17','15:35:00',1.23),('8784','2013-09-17','15:45:00',1.39),('8784','2013-09-17','15:50:00',1.87),('8784','2013-09-17','15:55:00',2.07),('8784','2013-09-17','16:00:00',1.44),('8784','2013-09-17','16:05:00',2.04),('8784','2013-09-17','16:10:00',1.79),('8784','2013-09-17','16:15:00',1.61),('8784','2013-09-17','16:20:00',1.08),('8784','2013-09-17','16:40:00',1.29),('8784','2013-09-17','16:45:00',1.56),('8784','2013-09-17','16:50:00',1.26),('8784','2013-09-17','16:55:00',1.06),('8784','2013-09-17','17:00:00',1.57),('8784','2013-09-17','17:05:00',1.72),('8784','2013-09-17','17:10:00',1.59),('8784','2013-09-17','17:15:00',1.58),('8784','2013-09-17','17:20:00',1.23),('8784','2013-09-17','17:25:00',1.3),('8784','2013-09-17','17:30:00',1.27),('8784','2013-09-17','17:40:00',1.02),('8784','2013-09-16','08:10:00',1.09),('8784','2013-09-16','08:15:00',1.09),('8784','2013-09-16','08:20:00',1.12),('8784','2013-09-16','08:25:00',1.19),('8784','2013-09-16','08:30:00',1.27),('8784','2013-09-16','08:35:00',1.36),('8784','2013-09-16','08:40:00',1.57),('8784','2013-09-16','08:45:00',1.46),('8784','2013-09-16','08:50:00',1.17),('8784','2013-09-16','09:05:00',1.98),('8784','2013-09-16','09:10:00',1.87),('8784','2013-09-16','09:15:00',2.12),('8784','2013-09-16','09:20:00',2.13),('8784','2013-09-16','09:25:00',2),('8784','2013-09-16','09:30:00',1.7),('8784','2013-09-16','09:35:00',2.29),('8784','2013-09-16','09:40:00',2.36),('8784','2013-09-16','09:45:00',2.42),('8784','2013-09-16','09:50:00',2.5),('8784','2013-09-16','09:55:00',2.09),('8784','2013-09-16','10:00:00',2.66),('8784','2013-09-16','10:05:00',2.86),('8784','2013-09-16','10:10:00',1.89),('8784','2013-09-16','10:15:00',1.05),('8784','2013-09-16','10:20:00',2.77),('8784','2013-09-16','10:25:00',2.01),('8784','2013-09-16','10:30:00',3.28),('8784','2013-09-16','10:35:00',3.49),('8784','2013-09-16','10:40:00',3.7),('8784','2013-09-16','10:45:00',3.92),('8784','2013-09-16','10:50:00',2.75),('8784','2013-09-16','11:00:00',1.27),('8784','2013-09-16','11:05:00',1.18),('8784','2013-09-16','11:25:00',3.5),('8784','2013-09-16','11:30:00',3.87),('8784','2013-09-16','11:35:00',3.86),('8784','2013-09-16','11:40:00',3.94),('8784','2013-09-16','11:45:00',2.89),('8784','2013-09-16','11:50:00',4.1),('8784','2013-09-16','11:55:00',3.95),('8784','2013-09-16','12:00:00',4.11),('8784','2013-09-16','12:05:00',4.03),('8784','2013-09-16','12:10:00',4.42),('8784','2013-09-16','12:15:00',3.9),('8784','2013-09-16','12:20:00',3.98),('8784','2013-09-16','12:25:00',3.96),('8784','2013-09-16','12:30:00',3.94),('8784','2013-09-16','12:35:00',3.88),('8784','2013-09-16','12:40:00',4.17),('8784','2013-09-16','12:45:00',3.25),('8784','2013-09-16','12:50:00',4.6),('8784','2013-09-16','12:55:00',4.19),('8784','2013-09-16','13:00:00',3.19),('8784','2013-09-16','13:05:00',2.99),('8784','2013-09-16','13:10:00',4.23),('8784','2013-09-16','13:15:00',3.85),('8784','2013-09-16','13:20:00',3.94),('8784','2013-09-16','13:25:00',3.94),('8784','2013-09-16','13:30:00',3.89),('8784','2013-09-16','13:35:00',3.91),('8784','2013-09-16','13:40:00',3.91),('8784','2013-09-16','13:45:00',3.9),('8784','2013-09-16','13:50:00',3.95),('8784','2013-09-16','13:55:00',3.99),('8784','2013-09-16','14:00:00',3.68),('8784','2013-09-16','14:05:00',3.83),('8784','2013-09-16','14:10:00',3.74),('8784','2013-09-16','14:15:00',3.71),('8784','2013-09-16','14:20:00',3.67),('8784','2013-09-16','14:25:00',3.64),('8784','2013-09-16','14:30:00',3.6),('8784','2013-09-16','14:35:00',3.56),('8784','2013-09-16','14:40:00',3.5),('8784','2013-09-16','14:45:00',3.48),('8784','2013-09-16','14:50:00',3.45),('8784','2013-09-16','14:55:00',3.4),('8784','2013-09-16','15:00:00',3.38),('8784','2013-09-16','15:05:00',3.32),('8784','2013-09-16','15:10:00',3.28),('8784','2013-09-16','15:15:00',3.25),('8784','2013-09-16','15:20:00',3.18),('8784','2013-09-16','15:25:00',3.13),('8784','2013-09-16','15:30:00',3.06),('8784','2013-09-16','15:35:00',3.02),('8784','2013-09-16','15:40:00',2.97),('8784','2013-09-16','15:45:00',2.89),('8784','2013-09-16','15:50:00',2.8),('8784','2013-09-16','15:55:00',2.77),('8784','2013-09-16','16:00:00',2.61),('8784','2013-09-16','16:05:00',2.13),('8784','2013-09-16','16:10:00',2.66),('8784','2013-09-16','16:15:00',2.51),('8784','2013-09-16','16:20:00',2.42),('8784','2013-09-16','16:25:00',2.35),('8784','2013-09-16','16:30:00',2.27),('8784','2013-09-16','16:35:00',2.19),('8784','2013-09-16','16:40:00',2.13),('8784','2013-09-16','16:45:00',2.04),('8784','2013-09-16','16:50:00',1.92),('8784','2013-09-16','16:55:00',1.86),('8784','2013-09-16','17:00:00',1.78),('8784','2013-09-16','17:05:00',1.7),('8784','2013-09-16','17:10:00',1.61),('8784','2013-09-16','17:15:00',1.51),('8784','2013-09-16','17:20:00',1.43),('8784','2013-09-16','17:25:00',1.35),('8784','2013-09-16','17:30:00',1.29),('8784','2013-09-16','17:45:00',1.04),('8784','2013-09-15','08:15:00',1.09),('8784','2013-09-15','08:20:00',1.17),('8784','2013-09-15','08:25:00',1.26),('8784','2013-09-15','08:30:00',1.35),('8784','2013-09-15','08:35:00',1.45),('8784','2013-09-15','08:40:00',1.56),('8784','2013-09-15','08:45:00',1.66),('8784','2013-09-15','08:50:00',1.68),('8784','2013-09-15','08:55:00',1.62),('8784','2013-09-15','09:00:00',1.72),('8784','2013-09-15','09:05:00',1.79),('8784','2013-09-15','09:10:00',1.96),('8784','2013-09-15','09:15:00',2.14),('8784','2013-09-15','09:20:00',2.08),('8784','2013-09-15','09:25:00',2.19),('8784','2013-09-15','09:30:00',2.21),('8784','2013-09-15','09:35:00',2.38),('8784','2013-09-15','09:40:00',2.43),('8784','2013-09-15','09:45:00',2.47),('8784','2013-09-15','09:50:00',2.59),('8784','2013-09-15','09:55:00',2.65),('8784','2013-09-15','10:00:00',2.73),('8784','2013-09-15','10:05:00',2.81),('8784','2013-09-15','10:10:00',2.84),('8784','2013-09-15','10:15:00',2.81),('8784','2013-09-15','10:20:00',2.85),('8784','2013-09-15','10:25:00',2.92),('8784','2013-09-15','10:30:00',2.81),('8784','2013-09-15','10:35:00',1.61),('8784','2013-09-15','10:40:00',1.61),('8784','2013-09-15','10:50:00',2.12),('8784','2013-09-15','10:55:00',3.45),('8784','2013-09-15','11:00:00',3.76),('8784','2013-09-15','11:05:00',3.84),('8784','2013-09-15','11:10:00',1.93),('8784','2013-09-15','11:15:00',1.27),('8784','2013-09-15','11:20:00',1.38),('8784','2013-09-15','11:30:00',3.01),('8784','2013-09-15','11:35:00',2.1),('8784','2013-09-15','11:40:00',1.52),('8784','2013-09-15','11:45:00',2.57),('8784','2013-09-15','11:50:00',2.53),('8784','2013-09-15','11:55:00',1.54),('8784','2013-09-15','12:00:00',1.43),('8784','2013-09-15','12:05:00',1.24),('8784','2013-09-15','12:10:00',1.22),('8784','2013-09-15','12:15:00',1.32),('8784','2013-09-15','12:20:00',1.63),('8784','2013-09-15','12:25:00',1.83),('8784','2013-09-15','12:30:00',1.72),('8784','2013-09-15','12:35:00',1.58),('8784','2013-09-15','12:40:00',1.54),('8784','2013-09-15','12:45:00',1.23),('8784','2013-09-15','12:50:00',1.45),('8784','2013-09-15','12:55:00',1.44),('8784','2013-09-15','13:00:00',1.34),('8784','2013-09-15','13:05:00',1.11),('8784','2013-09-15','13:25:00',1.14),('8784','2013-09-15','13:30:00',1.17),('8784','2013-09-15','13:35:00',1.28),('8784','2013-09-15','13:40:00',1.49),('8784','2013-09-15','13:45:00',2.35),('8784','2013-09-15','13:50:00',1.81),('8784','2013-09-15','13:55:00',1.3),('8784','2013-09-15','14:00:00',2.01),('8784','2013-09-15','14:05:00',1.86),('8784','2013-09-15','14:10:00',1.66),('8784','2013-09-15','14:15:00',1.6),('8784','2013-09-15','14:20:00',1.53),('8784','2013-09-15','14:25:00',1.5),('8784','2013-09-15','14:30:00',1.41),('8784','2013-09-15','14:35:00',1.19),('8784','2013-09-15','14:40:00',1.22),('8784','2013-09-15','14:45:00',1.11),('8784','2013-09-15','14:50:00',1.18),('8784','2013-09-15','14:55:00',1.19),('8784','2013-09-15','15:00:00',1.21),('8784','2013-09-15','15:05:00',1.29),('8784','2013-09-15','15:10:00',1.48),('8784','2013-09-15','15:15:00',2.96),('8784','2013-09-15','15:20:00',2.13),('8784','2013-09-15','15:25:00',1.58),('8784','2013-09-15','15:30:00',1.19),('8784','2013-09-15','15:35:00',1.19),('8784','2013-09-15','15:40:00',1.11),('8784','2013-09-15','15:45:00',1.07),('8784','2013-09-15','15:50:00',1.06),('8784','2013-09-15','15:55:00',1.04),('8784','2013-09-15','16:05:00',1.01),('8784','2013-09-14','08:15:00',1.05),('8784','2013-09-14','08:20:00',1.12),('8784','2013-09-14','08:25:00',1.2),('8784','2013-09-14','08:30:00',1.28),('8784','2013-09-14','08:35:00',1.37),('8784','2013-09-14','08:40:00',1.47),('8784','2013-09-14','08:45:00',1.54),('8784','2013-09-14','08:50:00',1.64),('8784','2013-09-14','08:55:00',1.72),('8784','2013-09-14','09:00:00',1.82),('8784','2013-09-14','09:05:00',1.9),('8784','2013-09-14','09:10:00',1.98),('8784','2013-09-14','09:15:00',2.07),('8784','2013-09-14','09:20:00',2.14),('8784','2013-09-14','09:25:00',2.22),('8784','2013-09-14','09:30:00',2.29),('8784','2013-09-14','09:35:00',2.33),('8784','2013-09-14','09:40:00',2.41),('8784','2013-09-14','09:45:00',2.49),('8784','2013-09-14','09:50:00',2.53),('8784','2013-09-14','09:55:00',2.64),('8784','2013-09-14','10:00:00',2.58),('8784','2013-09-14','10:05:00',2.69),('8784','2013-09-14','10:10:00',2.53),('8784','2013-09-14','10:15:00',2.64),('8784','2013-09-14','10:20:00',2.84),('8784','2013-09-14','10:25:00',2.94),('8784','2013-09-14','10:30:00',2.97),('8784','2013-09-14','10:35:00',3.17),('8784','2013-09-14','10:40:00',3.31),('8784','2013-09-14','10:45:00',2.46),('8784','2013-09-14','10:50:00',3.95),('8784','2013-09-14','10:55:00',3.01),('8784','2013-09-14','11:00:00',2.69),('8784','2013-09-14','11:05:00',1.06),('8784','2013-09-14','11:10:00',2.32),('8784','2013-09-14','11:15:00',1.21),('8784','2013-09-14','11:25:00',3.74),('8784','2013-09-14','11:30:00',3.72),('8784','2013-09-14','11:35:00',3.91),('8784','2013-09-14','11:40:00',3.89),('8784','2013-09-14','11:45:00',3.9),('8784','2013-09-14','11:50:00',2.17),('8784','2013-09-14','11:55:00',1.08),('8784','2013-09-14','12:10:00',2.36),('8784','2013-09-14','12:30:00',1.52),('8784','2013-09-14','12:35:00',2.64),('8784','2013-09-14','12:40:00',1.29),('8784','2013-09-14','12:45:00',1.08),('8784','2013-09-14','12:55:00',1.04),('8784','2013-09-14','13:00:00',1.01),('8784','2013-09-14','13:10:00',2.51),('8784','2013-09-14','13:15:00',4.14),('8784','2013-09-14','13:20:00',3.25),('8784','2013-09-14','13:25:00',4.24),('8784','2013-09-14','13:30:00',3.3),('8784','2013-09-14','13:35:00',2.43),('8784','2013-09-14','13:40:00',3.48),('8784','2013-09-14','13:45:00',2.7),('8784','2013-09-14','13:50:00',3.2),('8784','2013-09-14','13:55:00',4.58),('8784','2013-09-14','14:00:00',4.13),('8784','2013-09-14','14:05:00',3.92),('8784','2013-09-14','14:10:00',3.82),('8784','2013-09-14','14:15:00',3.83),('8784','2013-09-14','14:20:00',3.72),('8784','2013-09-14','14:25:00',3.73),('8784','2013-09-14','14:30:00',3.69),('8784','2013-09-14','14:35:00',3.62),('8784','2013-09-14','14:40:00',3.61),('8784','2013-09-14','14:45:00',3.54),('8784','2013-09-14','14:50:00',3.51),('8784','2013-09-14','14:55:00',3.47),('8784','2013-09-14','15:00:00',3.4),('8784','2013-09-14','15:05:00',3.32),('8784','2013-09-14','15:10:00',3.3),('8784','2013-09-14','15:15:00',3.25),('8784','2013-09-14','15:20:00',3.2),('8784','2013-09-14','15:25:00',2.5),('8784','2013-09-14','15:30:00',3.14),('8784','2013-09-14','15:35:00',3.05),('8784','2013-09-14','15:40:00',2.99),('8784','2013-09-14','15:45:00',2.91),('8784','2013-09-14','15:50:00',2.84),('8784','2013-09-14','15:55:00',2.77),('8784','2013-09-14','16:00:00',2.69),('8784','2013-09-14','16:05:00',2.63),('8784','2013-09-14','16:10:00',2.55),('8784','2013-09-14','16:15:00',2.49),('8784','2013-09-14','16:20:00',2.39),('8784','2013-09-14','16:25:00',2.37),('8784','2013-09-14','16:30:00',2.29),('8784','2013-09-14','16:35:00',2.2),('8784','2013-09-14','16:40:00',2.12),('8784','2013-09-14','16:45:00',2.05),('8784','2013-09-14','16:50:00',1.98),('8784','2013-09-14','16:55:00',1.88),('8784','2013-09-14','17:00:00',1.79),('8784','2013-09-14','17:05:00',1.72),('8784','2013-09-14','17:10:00',1.61),('8784','2013-09-14','17:15:00',1.57),('8784','2013-09-14','17:20:00',1.46),('8784','2013-09-14','17:25:00',1.37),('8784','2013-09-14','17:30:00',1.28),('8784','2013-09-14','17:40:00',1.12),('8784','2013-09-14','17:45:00',1.06),('8784','2013-09-13','08:50:00',1.02),('8784','2013-09-13','08:55:00',1.1),('8784','2013-09-13','09:00:00',1.05),('8784','2013-09-13','09:05:00',1.02),('8784','2013-09-13','09:15:00',1.04),('8784','2013-09-13','09:20:00',1.08),('8784','2013-09-13','09:25:00',1.2),('8784','2013-09-13','09:30:00',1.28),('8784','2013-09-13','09:35:00',1.38),('8784','2013-09-13','09:40:00',1.48),('8784','2013-09-13','09:45:00',1.41),('8784','2013-09-13','09:50:00',1.7),('8784','2013-09-13','09:55:00',2.86),('8784','2013-09-13','10:00:00',2.37),('8784','2013-09-13','10:05:00',1.42),('8784','2013-09-13','10:10:00',2.35),('8784','2013-09-13','10:15:00',3.75),('8784','2013-09-13','10:20:00',3.46),('8784','2013-09-13','10:25:00',1.67),('8784','2013-09-13','10:30:00',2.59),('8784','2013-09-13','10:35:00',3.25),('8784','2013-09-13','10:40:00',3.23),('8784','2013-09-13','10:45:00',3.25),('8784','2013-09-13','10:50:00',3.31),('8784','2013-09-13','10:55:00',3.35),('8784','2013-09-13','11:00:00',3.39),('8784','2013-09-13','11:05:00',3.41),('8784','2013-09-13','11:10:00',3.47),('8784','2013-09-13','11:15:00',3.51),('8784','2013-09-13','11:20:00',3.54),('8784','2013-09-13','11:25:00',3.57),('8784','2013-09-13','11:30:00',3.61),('8784','2013-09-13','11:35:00',3.67),('8784','2013-09-13','11:40:00',3.69),('8784','2013-09-13','11:45:00',3.71),('8784','2013-09-13','11:50:00',3.69),('8784','2013-09-13','11:55:00',3.75),('8784','2013-09-13','12:00:00',3.72),('8784','2013-09-13','12:05:00',3.79),('8784','2013-09-13','12:10:00',3.71),('8784','2013-09-13','12:15:00',3.84),('8784','2013-09-13','12:20:00',3.9),('8784','2013-09-13','12:25:00',3.91),('8784','2013-09-13','12:30:00',3.98),('8784','2013-09-13','12:35:00',3.97),('8784','2013-09-13','12:40:00',4.03),('8784','2013-09-13','12:45:00',4.04),('8784','2013-09-13','12:50:00',4.03),('8784','2013-09-13','12:55:00',4.03),('8784','2013-09-13','13:00:00',3.97),('8784','2013-09-13','13:05:00',3.93),('8784','2013-09-13','13:10:00',3.93),('8784','2013-09-13','13:15:00',3.88),('8784','2013-09-13','13:20:00',3.86),('8784','2013-09-13','13:25:00',3.85),('8784','2013-09-13','13:30:00',3.81),('8784','2013-09-13','13:35:00',3.79),('8784','2013-09-13','13:40:00',3.78),('8784','2013-09-13','13:45:00',3.8),('8784','2013-09-13','13:50:00',3.78),('8784','2013-09-13','13:55:00',3.75),('8784','2013-09-13','14:00:00',3.74),('8784','2013-09-13','14:05:00',3.71),('8784','2013-09-13','14:10:00',3.71),('8784','2013-09-13','14:15:00',3.68),('8784','2013-09-13','14:20:00',3.68),('8784','2013-09-13','14:25:00',1.86),('8784','2013-09-13','14:35:00',2.43),('8784','2013-09-13','14:40:00',3.62),('8784','2013-09-13','14:45:00',2.29),('8784','2013-09-13','14:50:00',3.39),('8784','2013-09-13','14:55:00',3.36),('8784','2013-09-13','15:00:00',3.42),('8784','2013-09-13','15:05:00',3.37),('8784','2013-09-13','15:10:00',3.34),('8784','2013-09-13','15:15:00',3.27),('8784','2013-09-13','15:20:00',3.18),('8784','2013-09-13','15:25:00',3.16),('8784','2013-09-13','15:30:00',3.12),('8784','2013-09-13','15:35:00',3.07),('8784','2013-09-13','15:40:00',3.01),('8784','2013-09-13','15:45:00',2.96),('8784','2013-09-13','15:50:00',2.9),('8784','2013-09-13','15:55:00',2.82),('8784','2013-09-13','16:00:00',2.76),('8784','2013-09-13','16:05:00',2.7),('8784','2013-09-13','16:10:00',2.64),('8784','2013-09-13','16:15:00',2.56),('8784','2013-09-13','16:20:00',2.48),('8784','2013-09-13','16:25:00',2.41),('8784','2013-09-13','16:30:00',2.34),('8784','2013-09-13','16:35:00',2.24),('8784','2013-09-13','16:40:00',2.16),('8784','2013-09-13','16:45:00',2.08),('8784','2013-09-13','16:50:00',1.99),('8784','2013-09-13','16:55:00',1.9),('8784','2013-09-13','17:00:00',1.82),('8784','2013-09-13','17:05:00',1.73),('8784','2013-09-13','17:10:00',1.64),('8784','2013-09-13','17:15:00',1.56),('8784','2013-09-13','17:20:00',1.48),('8784','2013-09-13','17:25:00',1.39),('8784','2013-09-13','17:30:00',1.29),('8784','2013-09-13','17:35:00',1.22),('8784','2013-09-13','17:40:00',1.13),('8784','2013-09-13','17:45:00',1.05),('8784','2013-09-12','08:00:00',1.01),('8784','2013-09-12','08:15:00',1.27),('8784','2013-09-12','08:20:00',1.28),('8784','2013-09-12','08:25:00',1.5),('8784','2013-09-12','08:30:00',1.61),('8784','2013-09-12','08:35:00',1.58),('8784','2013-09-12','08:40:00',1.06),('8784','2013-09-12','08:55:00',1.5),('8784','2013-09-12','09:00:00',1.83),('8784','2013-09-12','09:05:00',1.71),('8784','2013-09-12','09:10:00',1.27),('8784','2013-09-12','09:15:00',1.97),('8784','2013-09-12','09:20:00',2.06),('8784','2013-09-12','09:25:00',2.25),('8784','2013-09-12','09:30:00',2.42),('8784','2013-09-12','09:35:00',2.32),('8784','2013-09-12','09:40:00',1.78),('8784','2013-09-12','09:45:00',2.42),('8784','2013-09-12','09:50:00',2.09),('8784','2013-09-12','09:55:00',1.24),('8784','2013-09-12','10:00:00',1.16),('8784','2013-09-12','10:05:00',1.53),('8784','2013-09-12','10:10:00',1.85),('8784','2013-09-12','10:15:00',1.9),('8784','2013-09-12','10:20:00',1.23),('8784','2013-09-12','10:25:00',1.12),('8784','2013-09-12','10:30:00',2.52),('8784','2013-09-12','10:35:00',1.94),('8784','2013-09-12','10:55:00',2.09),('8784','2013-09-12','11:00:00',2.53),('8784','2013-09-12','11:05:00',3.62),('8784','2013-09-12','11:10:00',2.87),('8784','2013-09-12','11:15:00',2.63),('8784','2013-09-12','11:20:00',1.4),('8784','2013-09-12','11:40:00',1.39),('8784','2013-09-12','11:45:00',2.3),('8784','2013-09-12','11:50:00',1.71),('8784','2013-09-12','11:55:00',2.53),('8784','2013-09-12','12:00:00',2.96),('8784','2013-09-12','12:05:00',3.73),('8784','2013-09-12','12:10:00',2.72),('8784','2013-09-12','12:15:00',2.82),('8784','2013-09-12','12:20:00',1.45),('8784','2013-09-12','12:25:00',2.06),('8784','2013-09-12','12:30:00',1.54),('8784','2013-09-12','12:35:00',3.14),('8784','2013-09-12','12:40:00',2.96),('8784','2013-09-12','12:45:00',1.08),('8784','2013-09-12','12:50:00',2.18),('8784','2013-09-12','12:55:00',2.49),('8784','2013-09-12','13:00:00',3.9),('8784','2013-09-12','13:05:00',2.25),('8784','2013-09-12','13:10:00',2.19),('8784','2013-09-12','13:15:00',4.13),('8784','2013-09-12','13:20:00',4.52),('8784','2013-09-12','13:25:00',4.44),('8784','2013-09-12','13:30:00',3.42),('8784','2013-09-12','13:35:00',2.37),('8784','2013-09-12','13:40:00',3.27),('8784','2013-09-12','13:45:00',2.63),('8784','2013-09-12','13:50:00',3.79),('8784','2013-09-12','13:55:00',4),('8784','2013-09-12','14:00:00',3.63),('8784','2013-09-12','14:05:00',3.58),('8784','2013-09-12','14:10:00',3.63),('8784','2013-09-12','14:15:00',3.67),('8784','2013-09-12','14:20:00',3.95),('8784','2013-09-12','14:25:00',3.77),('8784','2013-09-12','14:30:00',3.95),('8784','2013-09-12','14:35:00',2),('8784','2013-09-12','14:40:00',1.93),('8784','2013-09-12','14:45:00',3.58),('8784','2013-09-12','14:50:00',3.63),('8784','2013-09-12','14:55:00',3.54),('8784','2013-09-12','15:00:00',2.93),('8784','2013-09-12','15:05:00',2.34),('8784','2013-09-12','15:10:00',2.52),('8784','2013-09-12','15:15:00',3.32),('8784','2013-09-12','15:20:00',3.27),('8784','2013-09-12','15:25:00',3.09),('8784','2013-09-12','15:30:00',3.2),('8784','2013-09-12','15:35:00',3.12),('8784','2013-09-12','15:40:00',3.08),('8784','2013-09-12','15:45:00',3.03),('8784','2013-09-12','15:50:00',2.97),('8784','2013-09-12','15:55:00',2.92),('8784','2013-09-12','16:00:00',2.92),('8784','2013-09-12','16:05:00',1.6),('8784','2013-09-12','16:10:00',2.88),('8784','2013-09-12','16:15:00',1.8),('8784','2013-09-12','16:20:00',1.99),('8784','2013-09-12','16:25:00',1.49),('8784','2013-09-12','16:30:00',2.34),('8784','2013-09-12','16:40:00',2.41),('8784','2013-09-12','16:45:00',2.29),('8784','2013-09-12','16:55:00',1.18),('8784','2013-09-12','17:00:00',1.85),('8784','2013-09-12','17:05:00',1.92),('8784','2013-09-12','17:10:00',1.66),('8784','2013-09-12','17:15:00',1.39),('8784','2013-09-12','17:30:00',1.5),('8784','2013-09-12','17:35:00',1.38),('8784','2013-09-12','17:40:00',1.27),('8784','2013-09-12','17:45:00',1.17),('8784','2013-09-12','17:50:00',1.04),('8784','2013-09-11','08:05:00',1.18),('8784','2013-09-11','08:10:00',1.13),('8784','2013-09-11','08:15:00',1.03),('8784','2013-09-11','08:30:00',1.16),('8784','2013-09-11','08:55:00',1.17),('8784','2013-09-11','09:00:00',1.93),('8784','2013-09-11','09:05:00',2.14),('8784','2013-09-11','09:10:00',1.87),('8784','2013-09-11','09:15:00',2.3),('8784','2013-09-11','09:20:00',2.49),('8784','2013-09-11','09:25:00',1.68),('8784','2013-09-11','09:30:00',1.3),('8784','2013-09-11','09:35:00',2.04),('8784','2013-09-11','09:40:00',1.54),('8784','2013-09-11','10:00:00',1.11),('8784','2013-09-11','10:05:00',1.98),('8784','2013-09-11','10:15:00',2.73),('8784','2013-09-11','10:20:00',2.47),('8784','2013-09-11','10:25:00',1.92),('8784','2013-09-11','10:30:00',3.21),('8784','2013-09-11','10:35:00',2.33),('8784','2013-09-11','10:40:00',2.6),('8784','2013-09-11','10:45:00',2.51),('8784','2013-09-11','10:50:00',2.67),('8784','2013-09-11','10:55:00',1.73),('8784','2013-09-11','11:00:00',1.91),('8784','2013-09-11','11:05:00',2.84),('8784','2013-09-11','11:10:00',3.38),('8784','2013-09-11','11:15:00',3.32),('8784','2013-09-11','11:20:00',3.48),('8784','2013-09-11','11:25:00',2.08),('8784','2013-09-11','11:30:00',2.1),('8784','2013-09-11','11:35:00',2.31),('8784','2013-09-11','11:40:00',4),('8784','2013-09-11','11:45:00',3.91),('8784','2013-09-11','11:50:00',3.85),('8784','2013-09-11','11:55:00',3.01),('8784','2013-09-11','12:00:00',3.87),('8784','2013-09-11','12:05:00',3.53),('8784','2013-09-11','12:10:00',2.43),('8784','2013-09-11','12:15:00',1.87),('8784','2013-09-11','12:20:00',2.3),('8784','2013-09-11','12:25:00',2.83),('8784','2013-09-11','12:30:00',2.07),('8784','2013-09-11','12:35:00',2.75),('8784','2013-09-11','12:40:00',2.2),('8784','2013-09-11','12:45:00',3.14),('8784','2013-09-11','14:05:00',2.55),('8784','2013-09-11','14:10:00',2.8),('8784','2013-09-11','14:15:00',3.79),('8784','2013-09-11','14:20:00',3.17),('8784','2013-09-11','14:25:00',3.48),('8784','2013-09-11','14:30:00',1.16),('8784','2013-09-11','14:35:00',2.87),('8784','2013-09-11','14:40:00',2.54),('8784','2013-09-11','14:45:00',3.38),('8784','2013-09-11','14:50:00',2.4),('8784','2013-09-11','14:55:00',1.79),('8784','2013-09-11','15:00:00',3.45),('8784','2013-09-11','15:05:00',3.74),('8784','2013-09-11','15:10:00',2.51),('8784','2013-09-11','15:15:00',3.7),('8784','2013-09-11','15:20:00',3.66),('8784','2013-09-11','15:25:00',1.42),('8784','2013-09-11','15:30:00',1.59),('8784','2013-09-11','15:40:00',1.41),('8784','2013-09-11','15:45:00',2.9),('8784','2013-09-11','15:50:00',3.09),('8784','2013-09-11','15:55:00',2.8),('8784','2013-09-11','16:00:00',2.33),('8784','2013-09-11','16:05:00',3.04),('8784','2013-09-11','16:10:00',2.81),('8784','2013-09-11','16:15:00',2.64),('8784','2013-09-11','16:20:00',2.21),('8784','2013-09-11','16:25:00',2.14),('8784','2013-09-11','16:30:00',1.5),('8784','2013-09-11','16:35:00',1.28),('8784','2013-09-11','16:40:00',1.66),('8784','2013-09-11','16:45:00',2.21),('8784','2013-09-11','16:50:00',1.84),('8784','2013-09-11','16:55:00',1.21),('8784','2013-09-11','17:00:00',1.86),('8784','2013-09-11','17:05:00',1.82),('8784','2013-09-11','17:10:00',1.74),('8784','2013-09-11','17:15:00',1.62),('8784','2013-09-11','17:20:00',1.55),('8784','2013-09-11','17:25:00',1.44),('8784','2013-09-11','17:30:00',1.36),('8784','2013-09-11','17:35:00',1.29),('8784','2013-09-11','17:40:00',1.06),('8784','2013-09-11','17:45:00',1.11),('8784','2013-09-10','08:55:00',1.66),('8784','2013-09-10','09:00:00',1.75),('8784','2013-09-10','09:05:00',1.82),('8784','2013-09-10','09:10:00',2.33),('8784','2013-09-10','09:15:00',1.91),('8784','2013-09-10','09:20:00',1.55),('8784','2013-09-10','09:25:00',1.6),('8784','2013-09-10','09:30:00',2.65),('8784','2013-09-10','09:35:00',2.85),('8784','2013-09-10','09:40:00',1.66),('8784','2013-09-10','09:45:00',1.42),('8784','2013-09-10','09:50:00',1.31),('8784','2013-09-10','09:55:00',1.18),('8784','2013-09-10','10:25:00',1.1),('8784','2013-09-10','10:30:00',1.08),('8784','2013-09-10','10:35:00',1.23),('8784','2013-09-10','10:40:00',1.64),('8784','2013-09-10','10:45:00',2.28),('8784','2013-09-10','10:50:00',1.35),('8784','2013-09-10','10:55:00',1.43),('8784','2013-09-10','11:00:00',1.71),('8784','2013-09-10','11:05:00',1.5),('8784','2013-09-10','11:10:00',1.5),('8784','2013-09-10','11:15:00',1.3),('8784','2013-09-10','11:20:00',1.42),('8784','2013-09-10','11:25:00',1.52),('8784','2013-09-10','11:30:00',1.18),('8784','2013-09-10','11:45:00',1.43),('8784','2013-09-10','11:50:00',1.4),('8784','2013-09-10','11:55:00',1.71),('8784','2013-09-10','12:00:00',1.49),('8784','2013-09-10','12:05:00',1.12),('8784','2013-09-10','12:10:00',1.12),('8784','2013-09-10','12:15:00',1.1),('8784','2013-09-10','12:20:00',1.08),('8784','2013-09-10','12:25:00',1.01),('8784','2013-09-10','13:25:00',1.2),('8784','2013-09-10','13:30:00',1.1),('8784','2013-09-10','13:35:00',1.2),('8784','2013-09-10','13:40:00',1.96),('8784','2013-09-10','13:45:00',2.86),('8784','2013-09-10','13:50:00',1.91),('8784','2013-09-10','13:55:00',1.63),('8784','2013-09-10','14:00:00',1.21),('8784','2013-09-10','14:05:00',1.42),('8784','2013-09-10','14:10:00',1.46),('8784','2013-09-10','14:15:00',1.73),('8784','2013-09-10','14:20:00',1.71),('8784','2013-09-10','14:25:00',2.32),('8784','2013-09-10','14:30:00',2.03),('8784','2013-09-10','14:35:00',1.56),('8784','2013-09-10','14:40:00',1.87),('8784','2013-09-10','14:45:00',1.97),('8784','2013-09-10','14:50:00',2.25),('8784','2013-09-10','14:55:00',1.95),('8784','2013-09-10','15:00:00',2.53),('8784','2013-09-10','15:05:00',2.27),('8784','2013-09-10','15:10:00',1.76),('8784','2013-09-10','15:15:00',1.66),('8784','2013-09-10','15:20:00',2.04),('8784','2013-09-10','15:25:00',1.83),('8784','2013-09-10','15:30:00',2.15),('8784','2013-09-10','15:35:00',1.78),('8784','2013-09-10','15:40:00',1.26),('8784','2013-09-10','15:45:00',1.1),('8784','2013-09-10','15:50:00',1.14),('8784','2013-09-10','15:55:00',1.11),('8784','2013-09-10','16:00:00',1.1),('8784','2013-09-10','16:05:00',1.19),('8784','2013-09-10','16:10:00',1.39),('8784','2013-09-10','16:15:00',1.51),('8784','2013-09-10','16:20:00',1.09),('8784','2013-09-10','16:25:00',1.02),('8784','2013-09-09','07:45:00',1.06),('8784','2013-09-09','07:50:00',1.09),('8784','2013-09-09','08:50:00',1.05),('8784','2013-09-09','08:55:00',1.27),('8784','2013-09-09','09:00:00',1.3),('8784','2013-09-09','09:05:00',1.18),('8784','2013-09-09','09:10:00',1.02),('8784','2013-09-09','09:35:00',1.21),('8784','2013-09-09','09:40:00',1.07),('8784','2013-09-09','10:00:00',1.53),('8784','2013-09-09','10:05:00',1.88),('8784','2013-09-09','10:10:00',1.84),('8784','2013-09-09','10:15:00',1.77),('8784','2013-09-09','10:20:00',1.65),('8784','2013-09-09','10:25:00',1.61),('8784','2013-09-09','10:30:00',1.66),('8784','2013-09-09','10:35:00',1.67),('8784','2013-09-09','10:40:00',1.84),('8784','2013-09-09','10:45:00',2.08),('8784','2013-09-09','10:50:00',2.63),('8784','2013-09-09','10:55:00',2.53),('8784','2013-09-09','11:00:00',2.81),('8784','2013-09-09','11:05:00',2.12),('8784','2013-09-09','11:10:00',2.21),('8784','2013-09-09','11:15:00',2.3),('8784','2013-09-09','11:20:00',2.53),('8784','2013-09-09','11:25:00',2.54),('8784','2013-09-09','11:30:00',2.22),('8784','2013-09-09','11:35:00',2.3),('8784','2013-09-09','11:40:00',3.29),('8784','2013-09-09','11:45:00',3.5),('8784','2013-09-09','11:50:00',3.67),('8784','2013-09-09','11:55:00',2.89),('8784','2013-09-09','12:00:00',2.82),('8784','2013-09-09','12:05:00',2.81),('8784','2013-09-09','12:10:00',2.98),('8784','2013-09-09','12:15:00',2.5),('8784','2013-09-09','12:20:00',1.53),('8784','2013-09-09','12:25:00',1.23),('8784','2013-09-09','12:30:00',1.14),('8784','2013-09-09','12:35:00',1.12),('8784','2013-09-09','12:40:00',1.69),('8784','2013-09-09','12:45:00',1.58),('8784','2013-09-09','12:50:00',1.3),('8784','2013-09-09','12:55:00',1.69),('8784','2013-09-09','13:00:00',1.78),('8784','2013-09-09','13:05:00',2.56),('8784','2013-09-09','13:10:00',2.34),('8784','2013-09-09','13:15:00',3.43),('8784','2013-09-09','13:20:00',3.04),('8784','2013-09-09','13:25:00',2.76),('8784','2013-09-09','13:30:00',3.33),('8784','2013-09-09','13:35:00',3.88),('8784','2013-09-09','13:40:00',3.16),('8784','2013-09-09','13:45:00',3.84),('8784','2013-09-09','13:50:00',3.89),('8784','2013-09-09','13:55:00',3.92),('8784','2013-09-09','14:00:00',3.6),('8784','2013-09-09','14:05:00',3.42),('8784','2013-09-09','14:10:00',3.46),('8784','2013-09-09','14:15:00',2.21),('8784','2013-09-09','14:20:00',2.17),('8784','2013-09-09','14:25:00',1.62),('8784','2013-09-09','14:30:00',2.18),('8784','2013-09-09','14:35:00',3.62),('8784','2013-09-09','14:40:00',3.56),('8784','2013-09-09','14:45:00',2.67),('8784','2013-09-09','14:50:00',3.38),('8784','2013-09-09','14:55:00',2.75),('8784','2013-09-09','15:00:00',2.59),('8784','2013-09-09','15:05:00',2.68),('8784','2013-09-09','15:10:00',2.49),('8784','2013-09-09','15:15:00',1.38),('8784','2013-09-09','15:20:00',2.38),('8784','2013-09-09','15:25:00',1.34),('8784','2013-09-09','15:30:00',2.5),('8784','2013-09-09','15:35:00',2.06),('8784','2013-09-09','15:40:00',2.21),('8784','2013-09-09','15:45:00',1.42),('8784','2013-09-09','15:50:00',1.43),('8784','2013-09-09','15:55:00',1.57),('8784','2013-09-09','16:00:00',1.77),('8784','2013-09-09','16:05:00',1.38),('8784','2013-09-09','16:10:00',1.83),('8784','2013-09-09','16:15:00',2.31),('8784','2013-09-09','16:20:00',1.79),('8784','2013-09-09','16:25:00',1.17),('8784','2013-09-09','16:30:00',1.15),('8784','2013-09-09','16:35:00',1.31),('8784','2013-09-09','16:40:00',1.44),('8784','2013-09-09','16:45:00',2),('8784','2013-09-09','17:00:00',1.07),('8784','2014-04-12','09:10:00',1.13),('8784','2014-04-12','09:15:00',1.55),('8784','2014-04-12','09:20:00',2.55),('8784','2014-04-12','09:25:00',2.65),('8784','2014-04-12','09:30:00',1.91),('8784','2014-04-12','09:35:00',1.54),('8784','2014-04-12','09:40:00',1.39),('8784','2014-04-12','09:45:00',1.4),('8784','2014-04-12','09:50:00',1.53),('8784','2014-04-12','09:55:00',1.48),('8784','2014-04-12','10:00:00',1.49),('8784','2014-04-12','10:05:00',1.52),('8784','2014-04-12','10:10:00',1.64),('8784','2014-04-12','10:15:00',1.79),('8784','2014-04-12','10:20:00',1.95),('8784','2014-04-12','10:25:00',2.01),('8784','2014-04-12','10:30:00',2.12),('8784','2014-04-12','10:35:00',2.42),('8784','2014-04-12','10:40:00',2.38),('8784','2014-04-12','10:45:00',2.84),('8784','2014-04-12','10:50:00',2.67),('8784','2014-04-12','10:55:00',3.28),('8784','2014-04-12','11:00:00',3.08),('8784','2014-04-12','11:05:00',2.56),('8784','2014-04-12','11:10:00',2.68),('8784','2014-04-12','11:15:00',2.86),('8784','2014-04-12','11:20:00',4.06),('8784','2014-04-12','11:25:00',3.55),('8784','2014-04-12','11:30:00',3.6),('8784','2014-04-12','11:35:00',4.04),('8784','2014-04-12','11:40:00',3.72),('8784','2014-04-12','11:45:00',3.91),('8784','2014-04-12','11:50:00',2.58),('8784','2014-04-12','11:55:00',3.29),('8784','2014-04-12','12:00:00',2.93),('8784','2014-04-12','12:05:00',1.9),('8784','2014-04-12','12:10:00',1.84),('8784','2014-04-12','12:15:00',1.92),('8784','2014-04-12','12:20:00',2.69),('8784','2014-04-12','12:25:00',3.12),('8784','2014-04-12','12:30:00',2.77),('8784','2014-04-12','12:35:00',2.76),('8784','2014-04-12','12:40:00',3.12),('8784','2014-04-12','12:45:00',2.54),('8784','2014-04-12','12:50:00',2.03),('8784','2014-04-12','12:55:00',2.05),('8784','2014-04-12','13:00:00',2.05),('8784','2014-04-12','13:05:00',3.29);
INSERT INTO `solarlogmod` VALUES ('8784','2014-04-12','13:10:00',3.11),('8784','2014-04-12','13:15:00',3.91),('8784','2014-04-12','13:20:00',4.09),('8784','2014-04-12','13:25:00',4.25),('8784','2014-04-12','13:30:00',2.8),('8784','2014-04-12','13:35:00',1.53),('8784','2014-04-12','13:40:00',1.85),('8784','2014-04-12','13:45:00',4.12),('8784','2014-04-12','13:50:00',2.52),('8784','2014-04-12','13:55:00',2.77),('8784','2014-04-12','14:00:00',4),('8784','2014-04-12','14:05:00',4.35),('8784','2014-04-12','14:10:00',3.69),('8784','2014-04-12','14:15:00',2.14),('8784','2014-04-12','14:20:00',3.7),('8784','2014-04-12','14:25:00',1.8),('8784','2014-04-12','14:30:00',3.3),('8784','2014-04-12','14:35:00',2.14),('8784','2014-04-12','14:40:00',1.58),('8784','2014-04-12','14:45:00',3.56),('8784','2014-04-12','14:50:00',4.42),('8784','2014-04-12','14:55:00',3.72),('8784','2014-04-12','15:00:00',2.75),('8784','2014-04-12','15:05:00',3.51),('8784','2014-04-12','15:10:00',3.63),('8784','2014-04-12','15:15:00',3.59),('8784','2014-04-12','15:20:00',2.83),('8784','2014-04-12','15:25:00',2),('8784','2014-04-12','15:30:00',2.31),('8784','2014-04-12','15:35:00',2.14),('8784','2014-04-12','15:40:00',2.72),('8784','2014-04-12','15:45:00',3.08),('8784','2014-04-12','15:50:00',3.49),('8784','2014-04-12','15:55:00',3.38),('8784','2014-04-12','16:00:00',3.36),('8784','2014-04-12','16:05:00',3.3),('8784','2014-04-12','16:10:00',3.07),('8784','2014-04-12','16:15:00',3.25),('8784','2014-04-12','16:20:00',3.28),('8784','2014-04-12','16:25:00',2.94),('8784','2014-04-12','16:30:00',2.81),('8784','2014-04-12','16:35:00',2.42),('8784','2014-04-12','16:40:00',2.32),('8784','2014-04-12','16:45:00',2.39),('8784','2014-04-12','16:50:00',1.62),('8784','2014-04-12','16:55:00',2.4),('8784','2014-04-12','17:00:00',2.3),('8784','2014-04-12','17:05:00',2.14),('8784','2014-04-12','17:10:00',2.09),('8784','2014-04-12','17:15:00',2.02),('8784','2014-04-12','17:20:00',1.61),('8784','2014-04-12','17:25:00',1.88),('8784','2014-04-12','17:30:00',1.82),('8784','2014-04-12','17:35:00',1.36),('8784','2014-04-12','17:40:00',1.8),('8784','2014-04-12','17:45:00',1.84),('8784','2014-04-12','17:50:00',1.59),('8784','2014-04-12','17:55:00',1.52),('8784','2014-04-12','18:00:00',1.13),('8784','2013-09-08','09:00:00',1.02),('8784','2013-09-08','09:05:00',1.18),('8784','2013-09-08','09:10:00',1.2),('8784','2013-09-08','09:15:00',1.25),('8784','2013-09-08','09:20:00',1.32),('8784','2013-09-08','09:25:00',1.53),('8784','2013-09-08','09:30:00',2.33),('8784','2013-09-08','09:35:00',2.18),('8784','2013-09-08','09:40:00',2.2),('8784','2013-09-08','09:45:00',2.41),('8784','2013-09-08','09:50:00',2.41),('8784','2013-09-08','09:55:00',2.44),('8784','2013-09-08','10:00:00',2.54),('8784','2013-09-08','10:05:00',2.63),('8784','2013-09-08','10:10:00',2.7),('8784','2013-09-08','10:15:00',2.71),('8784','2013-09-08','10:20:00',2.8),('8784','2013-09-08','10:25:00',2.84),('8784','2013-09-08','10:30:00',2.9),('8784','2013-09-08','10:35:00',2.97),('8784','2013-09-08','10:40:00',3.02),('8784','2013-09-08','10:45:00',3.06),('8784','2013-09-08','10:50:00',3.05),('8784','2013-09-08','10:55:00',3.05),('8784','2013-09-08','11:00:00',3.01),('8784','2013-09-08','11:05:00',3.11),('8784','2013-09-08','11:10:00',3.19),('8784','2013-09-08','11:15:00',3.26),('8784','2013-09-08','11:20:00',3.29),('8784','2013-09-08','11:25:00',3.26),('8784','2013-09-08','11:30:00',3.27),('8784','2013-09-08','11:35:00',3.28),('8784','2013-09-08','11:40:00',3.36),('8784','2013-09-08','11:45:00',3.39),('8784','2013-09-08','11:50:00',3.36),('8784','2013-09-08','11:55:00',3.34),('8784','2013-09-08','12:00:00',3.33),('8784','2013-09-08','12:05:00',3.26),('8784','2013-09-08','12:10:00',3.31),('8784','2013-09-08','12:15:00',3.53),('8784','2013-09-08','12:20:00',3.52),('8784','2013-09-08','12:25:00',3.53),('8784','2013-09-08','12:30:00',3.51),('8784','2013-09-08','12:35:00',3.4),('8784','2013-09-08','12:40:00',3.35),('8784','2013-09-08','12:45:00',3.52),('8784','2013-09-08','12:50:00',3.52),('8784','2013-09-08','12:55:00',3.55),('8784','2013-09-08','13:00:00',3.52),('8784','2013-09-08','13:05:00',3.61),('8784','2013-09-08','13:10:00',3.5),('8784','2013-09-08','13:15:00',3.52),('8784','2013-09-08','13:20:00',3.55),('8784','2013-09-08','13:25:00',3.23),('8784','2013-09-08','13:30:00',3.18),('8784','2013-09-08','13:35:00',3.12),('8784','2013-09-08','13:40:00',2.31),('8784','2013-09-08','13:45:00',2.13),('8784','2013-09-08','13:50:00',2.85),('8784','2013-09-08','13:55:00',2.93),('8784','2013-09-08','14:00:00',3.4),('8784','2013-09-08','14:05:00',3.28),('8784','2013-09-08','14:10:00',3.71),('8784','2013-09-08','14:15:00',3.28),('8784','2013-09-08','14:20:00',3.7),('8784','2013-09-08','14:25:00',3.91),('8784','2013-09-08','14:30:00',3.39),('8784','2013-09-08','14:35:00',3.6),('8784','2013-09-08','14:40:00',3.45),('8784','2013-09-08','14:45:00',3.37),('8784','2013-09-08','14:50:00',3.41),('8784','2013-09-08','14:55:00',3.37),('8784','2013-09-08','15:00:00',3.34),('8784','2013-09-08','15:05:00',2.67),('8784','2013-09-08','15:10:00',1.85),('8784','2013-09-08','15:15:00',2.46),('8784','2013-09-08','15:20:00',3.18),('8784','2013-09-08','15:25:00',3.19),('8784','2013-09-08','15:30:00',3.2),('8784','2013-09-08','15:35:00',3.08),('8784','2013-09-08','15:40:00',2.85),('8784','2013-09-08','15:45:00',2.91),('8784','2013-09-08','15:50:00',2.82),('8784','2013-09-08','15:55:00',2.29),('8784','2013-09-08','16:00:00',2.43),('8784','2013-09-08','16:05:00',2.42),('8784','2013-09-08','16:10:00',2.19),('8784','2013-09-08','16:15:00',2.49),('8784','2013-09-08','16:20:00',2.21),('8784','2013-09-08','16:25:00',2.16),('8784','2013-09-08','16:30:00',2.24),('8784','2013-09-08','16:35:00',2.05),('8784','2013-09-08','16:40:00',1.74),('8784','2013-09-08','16:45:00',1.29),('8784','2013-09-08','16:50:00',1.26),('8784','2013-09-08','16:55:00',1.17),('8784','2013-09-08','17:00:00',1.48),('8784','2013-09-08','17:05:00',1.95),('8784','2013-09-08','17:10:00',1.83),('8784','2013-09-08','17:15:00',1.67),('8784','2013-09-08','17:20:00',1.42),('8784','2013-09-08','17:25:00',1.42),('8784','2013-09-08','17:30:00',1.29),('8784','2013-09-08','17:45:00',1.03),('8784','2013-09-08','17:50:00',1.03),('8784','2013-09-07','08:10:00',1.01),('8784','2013-09-07','08:15:00',1.09),('8784','2013-09-07','08:20:00',1.16),('8784','2013-09-07','08:25:00',1.23),('8784','2013-09-07','08:30:00',1.32),('8784','2013-09-07','08:35:00',1.4),('8784','2013-09-07','08:40:00',1.49),('8784','2013-09-07','08:45:00',1.56),('8784','2013-09-07','08:50:00',1.64),('8784','2013-09-07','08:55:00',1.72),('8784','2013-09-07','09:00:00',1.8),('8784','2013-09-07','09:05:00',1.87),('8784','2013-09-07','09:10:00',1.95),('8784','2013-09-07','09:15:00',2),('8784','2013-09-07','09:20:00',2.11),('8784','2013-09-07','09:25:00',2.2),('8784','2013-09-07','09:30:00',2.26),('8784','2013-09-07','09:35:00',2.33),('8784','2013-09-07','09:40:00',2.39),('8784','2013-09-07','09:45:00',2.44),('8784','2013-09-07','09:50:00',2.49),('8784','2013-09-07','09:55:00',2.58),('8784','2013-09-07','10:00:00',2.64),('8784','2013-09-07','10:05:00',2.7),('8784','2013-09-07','10:10:00',2.72),('8784','2013-09-07','10:15:00',2.79),('8784','2013-09-07','10:20:00',2.88),('8784','2013-09-07','10:25:00',2.91),('8784','2013-09-07','10:30:00',2.95),('8784','2013-09-07','10:35:00',3.02),('8784','2013-09-07','10:40:00',3.06),('8784','2013-09-07','10:45:00',3.1),('8784','2013-09-07','10:50:00',3.16),('8784','2013-09-07','10:55:00',3.2),('8784','2013-09-07','11:00:00',3.25),('8784','2013-09-07','11:05:00',3.25),('8784','2013-09-07','11:10:00',3.31),('8784','2013-09-07','11:15:00',3.34),('8784','2013-09-07','11:20:00',3.37),('8784','2013-09-07','11:25:00',3.41),('8784','2013-09-07','11:30:00',3.45),('8784','2013-09-07','11:35:00',3.44),('8784','2013-09-07','11:40:00',3.53),('8784','2013-09-07','11:45:00',3.55),('8784','2013-09-07','11:50:00',3.56),('8784','2013-09-07','11:55:00',3.58),('8784','2013-09-07','12:00:00',3.61),('8784','2013-09-07','12:05:00',3.63),('8784','2013-09-07','12:10:00',3.65),('8784','2013-09-07','12:15:00',3.66),('8784','2013-09-07','12:20:00',3.66),('8784','2013-09-07','12:25:00',3.66),('8784','2013-09-07','12:30:00',3.65),('8784','2013-09-07','12:35:00',3.67),('8784','2013-09-07','12:40:00',3.65),('8784','2013-09-07','12:45:00',3.66),('8784','2013-09-07','12:50:00',3.68),('8784','2013-09-07','12:55:00',3.6),('8784','2013-09-07','13:00:00',3.59),('8784','2013-09-07','13:05:00',3.71),('8784','2013-09-07','13:10:00',3.65),('8784','2013-09-07','13:15:00',3.67),('8784','2013-09-07','13:20:00',3.7),('8784','2013-09-07','13:25:00',3.73),('8784','2013-09-07','13:30:00',3.78),('8784','2013-09-07','13:35:00',3.73),('8784','2013-09-07','13:40:00',3.44),('8784','2013-09-07','13:45:00',3.29),('8784','2013-09-07','13:50:00',3.12),('8784','2013-09-07','13:55:00',3.61),('8784','2013-09-07','14:00:00',3.74),('8784','2013-09-07','14:05:00',3.71),('8784','2013-09-07','14:10:00',3.7),('8784','2013-09-07','14:15:00',3.64),('8784','2013-09-07','14:20:00',3.56),('8784','2013-09-07','14:25:00',3.52),('8784','2013-09-07','14:30:00',3.48),('8784','2013-09-07','14:35:00',3.5),('8784','2013-09-07','14:40:00',3.43),('8784','2013-09-07','14:45:00',3.47),('8784','2013-09-07','14:50:00',3.4),('8784','2013-09-07','14:55:00',3.37),('8784','2013-09-07','15:00:00',3.33),('8784','2013-09-07','15:05:00',3.29),('8784','2013-09-07','15:10:00',3.25),('8784','2013-09-07','15:15:00',3.22),('8784','2013-09-07','15:20:00',3.18),('8784','2013-09-07','15:25:00',3.15),('8784','2013-09-07','15:30:00',3.09),('8784','2013-09-07','15:35:00',3.03),('8784','2013-09-07','15:40:00',2.95),('8784','2013-09-07','15:45:00',2.89),('8784','2013-09-07','15:50:00',2.82),('8784','2013-09-07','15:55:00',2.75),('8784','2013-09-07','16:00:00',2.71),('8784','2013-09-07','16:05:00',2.64),('8784','2013-09-07','16:10:00',2.58),('8784','2013-09-07','16:15:00',2.51),('8784','2013-09-07','16:20:00',2.43),('8784','2013-09-07','16:25:00',2.32),('8784','2013-09-07','16:30:00',2.27),('8784','2013-09-07','16:35:00',2.2),('8784','2013-09-07','16:40:00',2.13),('8784','2013-09-07','16:45:00',2.07),('8784','2013-09-07','16:50:00',1.98),('8784','2013-09-07','16:55:00',1.91),('8784','2013-09-07','17:00:00',1.82),('8784','2013-09-07','17:05:00',1.74),('8784','2013-09-07','17:10:00',1.66),('8784','2013-09-07','17:15:00',1.6),('8784','2013-09-07','17:20:00',1.52),('8784','2013-09-07','17:25:00',1.43),('8784','2013-09-07','17:30:00',1.33),('8784','2013-09-07','17:35:00',1.27),('8784','2013-09-07','17:40:00',1.19),('8784','2013-09-07','17:45:00',1.12),('8784','2013-09-07','17:50:00',1.04),('8784','2013-09-06','08:10:00',1.04),('8784','2013-09-06','08:15:00',1.11),('8784','2013-09-06','08:20:00',1.2),('8784','2013-09-06','08:25:00',1.25),('8784','2013-09-06','08:30:00',1.33),('8784','2013-09-06','08:35:00',1.41),('8784','2013-09-06','08:40:00',1.51),('8784','2013-09-06','08:45:00',1.61),('8784','2013-09-06','08:50:00',1.67),('8784','2013-09-06','08:55:00',1.76),('8784','2013-09-06','09:00:00',1.85),('8784','2013-09-06','09:05:00',1.93),('8784','2013-09-06','09:10:00',2),('8784','2013-09-06','09:15:00',2.07),('8784','2013-09-06','09:20:00',2.14),('8784','2013-09-06','09:25:00',2.21),('8784','2013-09-06','09:30:00',2.29),('8784','2013-09-06','09:35:00',2.35),('8784','2013-09-06','09:40:00',2.44),('8784','2013-09-06','09:45:00',2.51),('8784','2013-09-06','09:50:00',2.56),('8784','2013-09-06','09:55:00',2.61),('8784','2013-09-06','10:00:00',2.68),('8784','2013-09-06','10:05:00',2.74),('8784','2013-09-06','10:10:00',2.79),('8784','2013-09-06','10:15:00',2.84),('8784','2013-09-06','10:20:00',2.89),('8784','2013-09-06','10:25:00',2.94),('8784','2013-09-06','10:30:00',3.02),('8784','2013-09-06','10:35:00',3.09),('8784','2013-09-06','10:40:00',3.16),('8784','2013-09-06','10:45:00',3.21),('8784','2013-09-06','10:50:00',3.2),('8784','2013-09-06','10:55:00',3.26),('8784','2013-09-06','11:00:00',3.29),('8784','2013-09-06','11:05:00',3.34),('8784','2013-09-06','11:10:00',3.4),('8784','2013-09-06','11:15:00',3.44),('8784','2013-09-06','11:20:00',3.45),('8784','2013-09-06','11:25:00',3.46),('8784','2013-09-06','11:30:00',3.51),('8784','2013-09-06','11:35:00',3.57),('8784','2013-09-06','11:40:00',3.58),('8784','2013-09-06','11:45:00',3.61),('8784','2013-09-06','11:50:00',3.61),('8784','2013-09-06','11:55:00',3.62),('8784','2013-09-06','12:00:00',3.61),('8784','2013-09-06','12:05:00',3.59),('8784','2013-09-06','12:10:00',3.66),('8784','2013-09-06','12:15:00',3.71),('8784','2013-09-06','12:20:00',3.71),('8784','2013-09-06','12:25:00',3.73),('8784','2013-09-06','12:30:00',3.76),('8784','2013-09-06','12:35:00',3.79),('8784','2013-09-06','12:40:00',3.78),('8784','2013-09-06','12:45:00',3.75),('8784','2013-09-06','12:50:00',3.74),('8784','2013-09-06','12:55:00',3.74),('8784','2013-09-06','13:00:00',3.75),('8784','2013-09-06','13:05:00',3.76),('8784','2013-09-06','13:10:00',3.74),('8784','2013-09-06','13:15:00',3.78),('8784','2013-09-06','13:20:00',3.75),('8784','2013-09-06','13:25:00',3.71),('8784','2013-09-06','13:30:00',3.7),('8784','2013-09-06','13:35:00',3.71),('8784','2013-09-06','13:40:00',3.67),('8784','2013-09-06','13:45:00',3.66),('8784','2013-09-06','13:50:00',3.64),('8784','2013-09-06','13:55:00',3.58),('8784','2013-09-06','14:00:00',3.57),('8784','2013-09-06','14:05:00',3.54),('8784','2013-09-06','14:10:00',3.54),('8784','2013-09-06','14:15:00',3.54),('8784','2013-09-06','14:20:00',3.51),('8784','2013-09-06','14:25:00',3.49),('8784','2013-09-06','14:30:00',3.43),('8784','2013-09-06','14:35:00',3.31),('8784','2013-09-06','14:40:00',3.33),('8784','2013-09-06','14:45:00',3.33),('8784','2013-09-06','14:50:00',3.35),('8784','2013-09-06','14:55:00',3.37),('8784','2013-09-06','15:00:00',3.3),('8784','2013-09-06','15:05:00',3.24),('8784','2013-09-06','15:10:00',3.17),('8784','2013-09-06','15:15:00',3.17),('8784','2013-09-06','15:20:00',3.15),('8784','2013-09-06','15:25:00',3.02),('8784','2013-09-06','15:30:00',2.97),('8784','2013-09-06','15:35:00',2.87),('8784','2013-09-06','15:40:00',2.87),('8784','2013-09-06','15:45:00',2.87),('8784','2013-09-06','15:50:00',2.74),('8784','2013-09-06','15:55:00',2.72),('8784','2013-09-06','16:00:00',2.68),('8784','2013-09-06','16:05:00',2.63),('8784','2013-09-06','16:10:00',2.56),('8784','2013-09-06','16:15:00',2.51),('8784','2013-09-06','16:20:00',2.45),('8784','2013-09-06','16:25:00',2.39),('8784','2013-09-06','16:30:00',2.36),('8784','2013-09-06','16:35:00',2.27),('8784','2013-09-06','16:40:00',2.2),('8784','2013-09-06','16:45:00',2.1),('8784','2013-09-06','16:50:00',2.03),('8784','2013-09-06','16:55:00',1.93),('8784','2013-09-06','17:00:00',1.89),('8784','2013-09-06','17:05:00',1.78),('8784','2013-09-06','17:10:00',1.69),('8784','2013-09-06','17:15:00',1.64),('8784','2013-09-06','17:20:00',1.54),('8784','2013-09-06','17:25:00',1.44),('8784','2013-09-06','17:30:00',1.36),('8784','2013-09-06','17:35:00',1.28),('8784','2013-09-06','17:40:00',1.23),('8784','2013-09-06','17:45:00',1.13),('8784','2013-09-06','17:50:00',1.03),('8784','2013-09-05','08:05:00',1.06),('8784','2013-09-05','08:10:00',1.13),('8784','2013-09-05','08:15:00',1.22),('8784','2013-09-05','08:20:00',1.31),('8784','2013-09-05','08:25:00',1.4),('8784','2013-09-05','08:30:00',1.48),('8784','2013-09-05','08:35:00',1.57),('8784','2013-09-05','08:40:00',1.65),('8784','2013-09-05','08:45:00',1.72),('8784','2013-09-05','08:50:00',1.79),('8784','2013-09-05','08:55:00',1.9),('8784','2013-09-05','09:00:00',1.98),('8784','2013-09-05','09:05:00',2.07),('8784','2013-09-05','09:10:00',2.15),('8784','2013-09-05','09:15:00',2.22),('8784','2013-09-05','09:20:00',2.3),('8784','2013-09-05','09:25:00',2.37),('8784','2013-09-05','09:30:00',2.43),('8784','2013-09-05','09:35:00',2.49),('8784','2013-09-05','09:40:00',2.52),('8784','2013-09-05','09:45:00',2.62),('8784','2013-09-05','09:50:00',2.7),('8784','2013-09-05','09:55:00',2.76),('8784','2013-09-05','10:00:00',2.78),('8784','2013-09-05','10:05:00',2.87),('8784','2013-09-05','10:10:00',2.93),('8784','2013-09-05','10:15:00',2.99),('8784','2013-09-05','10:20:00',3.05),('8784','2013-09-05','10:25:00',3.1),('8784','2013-09-05','10:30:00',3.14),('8784','2013-09-05','10:35:00',3.15),('8784','2013-09-05','10:40:00',3.23),('8784','2013-09-05','10:45:00',3.29),('8784','2013-09-05','10:50:00',3.32),('8784','2013-09-05','10:55:00',3.36),('8784','2013-09-05','11:00:00',3.42),('8784','2013-09-05','11:05:00',3.45),('8784','2013-09-05','11:10:00',3.49),('8784','2013-09-05','11:15:00',3.5),('8784','2013-09-05','11:20:00',3.51),('8784','2013-09-05','11:25:00',3.58),('8784','2013-09-05','11:30:00',3.61),('8784','2013-09-05','11:35:00',3.62),('8784','2013-09-05','11:40:00',3.57),('8784','2013-09-05','11:45:00',3.59),('8784','2013-09-05','11:50:00',3.64),('8784','2013-09-05','11:55:00',3.72),('8784','2013-09-05','12:00:00',3.72),('8784','2013-09-05','12:05:00',3.74),('8784','2013-09-05','12:10:00',3.79),('8784','2013-09-05','12:15:00',3.81),('8784','2013-09-05','12:20:00',3.78),('8784','2013-09-05','12:25:00',3.81),('8784','2013-09-05','12:30:00',3.82),('8784','2013-09-05','12:35:00',3.84),('8784','2013-09-05','12:40:00',3.85),('8784','2013-09-05','12:45:00',3.86),('8784','2013-09-05','12:50:00',3.88),('8784','2013-09-05','12:55:00',3.87),('8784','2013-09-05','13:00:00',3.85),('8784','2013-09-05','13:05:00',3.81),('8784','2013-09-05','13:10:00',3.85),('8784','2013-09-05','13:15:00',3.84),('8784','2013-09-05','13:20:00',3.84),('8784','2013-09-05','13:25:00',3.84),('8784','2013-09-05','13:30:00',3.87),('8784','2013-09-05','13:35:00',3.84),('8784','2013-09-05','13:40:00',3.82),('8784','2013-09-05','13:45:00',3.79),('8784','2013-09-05','13:50:00',3.74),('8784','2013-09-05','13:55:00',3.73),('8784','2013-09-05','14:00:00',3.71),('8784','2013-09-05','14:05:00',3.73),('8784','2013-09-05','14:10:00',3.73),('8784','2013-09-05','14:15:00',3.68),('8784','2013-09-05','14:20:00',3.64),('8784','2013-09-05','14:25:00',3.57),('8784','2013-09-05','14:30:00',3.57),('8784','2013-09-05','14:35:00',3.51),('8784','2013-09-05','14:40:00',3.49),('8784','2013-09-05','14:45:00',3.48),('8784','2013-09-05','14:50:00',3.44),('8784','2013-09-05','14:55:00',3.44),('8784','2013-09-05','15:00:00',3.42),('8784','2013-09-05','15:05:00',3.39),('8784','2013-09-05','15:10:00',3.31),('8784','2013-09-05','15:15:00',3.28),('8784','2013-09-05','15:20:00',3.19),('8784','2013-09-05','15:25:00',3.17),('8784','2013-09-05','15:30:00',3.11),('8784','2013-09-05','15:35:00',3.07),('8784','2013-09-05','15:40:00',3.02),('8784','2013-09-05','15:45:00',2.96),('8784','2013-09-05','15:50:00',2.91),('8784','2013-09-05','15:55:00',2.86),('8784','2013-09-05','16:00:00',2.79),('8784','2013-09-05','16:05:00',2.75),('8784','2013-09-05','16:10:00',2.69),('8784','2013-09-05','16:15:00',2.63),('8784','2013-09-05','16:20:00',2.53),('8784','2013-09-05','16:25:00',2.5),('8784','2013-09-05','16:30:00',2.45),('8784','2013-09-05','16:35:00',2.42),('8784','2013-09-05','16:40:00',2.35),('8784','2013-09-05','16:45:00',2.3),('8784','2013-09-05','16:50:00',1.9),('8784','2013-09-05','16:55:00',1.53),('8784','2013-09-05','17:00:00',1.23),('8784','2013-09-05','17:05:00',1.37),('8784','2013-09-05','17:10:00',1.35),('8784','2013-09-05','17:15:00',1.21),('8784','2013-09-05','17:20:00',1.37),('8784','2013-09-05','17:25:00',1.37),('8784','2013-09-05','17:30:00',1.35),('8784','2013-09-05','17:35:00',1.44),('8784','2013-09-05','17:40:00',1.51),('8784','2013-09-05','17:45:00',1.35),('8784','2013-09-05','17:50:00',1.23),('8784','2013-09-05','17:55:00',1.07),('8784','2013-09-04','08:05:00',1.07),('8784','2013-09-04','08:10:00',1.15),('8784','2013-09-04','08:15:00',1.24),('8784','2013-09-04','08:20:00',1.32),('8784','2013-09-04','08:25:00',1.4),('8784','2013-09-04','08:30:00',1.49),('8784','2013-09-04','08:35:00',1.56),('8784','2013-09-04','08:40:00',1.64),('8784','2013-09-04','08:45:00',1.72),('8784','2013-09-04','08:50:00',1.82),('8784','2013-09-04','08:55:00',1.87),('8784','2013-09-04','09:00:00',1.96),('8784','2013-09-04','09:05:00',2.08),('8784','2013-09-04','09:10:00',2.16),('8784','2013-09-04','09:15:00',2.25),('8784','2013-09-04','09:20:00',2.34),('8784','2013-09-04','09:25:00',2.42),('8784','2013-09-04','09:30:00',2.45),('8784','2013-09-04','09:35:00',2.59),('8784','2013-09-04','09:40:00',2.67),('8784','2013-09-04','09:45:00',2.73),('8784','2013-09-04','09:50:00',2.78),('8784','2013-09-04','09:55:00',2.85),('8784','2013-09-04','10:00:00',2.93),('8784','2013-09-04','10:05:00',2.99),('8784','2013-09-04','10:10:00',3.04),('8784','2013-09-04','10:15:00',3.09),('8784','2013-09-04','10:20:00',3.14),('8784','2013-09-04','10:25:00',3.2),('8784','2013-09-04','10:30:00',3.26),('8784','2013-09-04','10:35:00',3.31),('8784','2013-09-04','10:40:00',3.36),('8784','2013-09-04','10:45:00',3.4),('8784','2013-09-04','10:50:00',3.39),('8784','2013-09-04','10:55:00',3.48),('8784','2013-09-04','11:00:00',3.53),('8784','2013-09-04','11:05:00',3.58),('8784','2013-09-04','11:10:00',3.61),('8784','2013-09-04','11:15:00',3.63),('8784','2013-09-04','11:20:00',3.68),('8784','2013-09-04','11:25:00',3.71),('8784','2013-09-04','11:30:00',3.74),('8784','2013-09-04','11:35:00',3.79),('8784','2013-09-04','11:40:00',3.81),('8784','2013-09-04','11:45:00',3.84),('8784','2013-09-04','11:50:00',3.87),('8784','2013-09-04','11:55:00',3.9),('8784','2013-09-04','12:00:00',3.91),('8784','2013-09-04','12:05:00',3.92),('8784','2013-09-04','12:10:00',3.94),('8784','2013-09-04','12:15:00',3.93),('8784','2013-09-04','12:20:00',3.95),('8784','2013-09-04','12:25:00',3.99),('8784','2013-09-04','12:30:00',4.01),('8784','2013-09-04','12:35:00',3.97),('8784','2013-09-04','12:40:00',4.04),('8784','2013-09-04','12:45:00',4.02),('8784','2013-09-04','12:50:00',3.99),('8784','2013-09-04','12:55:00',4.01),('8784','2013-09-04','13:00:00',4.01),('8784','2013-09-04','13:05:00',4),('8784','2013-09-04','13:10:00',4.02),('8784','2013-09-04','13:15:00',4),('8784','2013-09-04','13:20:00',4),('8784','2013-09-04','13:25:00',3.98),('8784','2013-09-04','13:30:00',3.97),('8784','2013-09-04','13:35:00',3.96),('8784','2013-09-04','13:40:00',3.96),('8784','2013-09-04','13:45:00',3.94),('8784','2013-09-04','13:50:00',3.91),('8784','2013-09-04','13:55:00',3.9),('8784','2013-09-04','14:00:00',3.87),('8784','2013-09-04','14:05:00',3.86),('8784','2013-09-04','14:10:00',3.85),('8784','2013-09-04','14:15:00',3.82),('8784','2013-09-04','14:20:00',3.77),('8784','2013-09-04','14:25:00',3.76),('8784','2013-09-04','14:30:00',3.74),('8784','2013-09-04','14:35:00',3.7),('8784','2013-09-04','14:40:00',3.66),('8784','2013-09-04','14:45:00',3.62),('8784','2013-09-04','14:50:00',3.6),('8784','2013-09-04','14:55:00',3.55),('8784','2013-09-04','15:00:00',3.51),('8784','2013-09-04','15:05:00',3.46),('8784','2013-09-04','15:10:00',3.43),('8784','2013-09-04','15:15:00',3.38),('8784','2013-09-04','15:20:00',3.34),('8784','2013-09-04','15:25:00',3.28),('8784','2013-09-04','15:30:00',3.23),('8784','2013-09-04','15:35:00',3.16),('8784','2013-09-04','15:40:00',3.11),('8784','2013-09-04','15:45:00',3.06),('8784','2013-09-04','15:50:00',3),('8784','2013-09-04','15:55:00',2.93),('8784','2013-09-04','16:00:00',2.86),('8784','2013-09-04','16:05:00',2.78),('8784','2013-09-04','16:10:00',2.72),('8784','2013-09-04','16:15:00',2.67),('8784','2013-09-04','16:20:00',2.6),('8784','2013-09-04','16:25:00',2.53),('8784','2013-09-04','16:30:00',2.46),('8784','2013-09-04','16:35:00',2.39),('8784','2013-09-04','16:40:00',2.31),('8784','2013-09-04','16:45:00',2.25),('8784','2013-09-04','16:50:00',2.15),('8784','2013-09-04','16:55:00',2.08),('8784','2013-09-04','17:00:00',2),('8784','2013-09-04','17:05:00',1.91),('8784','2013-09-04','17:10:00',1.83),('8784','2013-09-04','17:15:00',1.75),('8784','2013-09-04','17:20:00',1.66),('8784','2013-09-04','17:25:00',1.58),('8784','2013-09-04','17:30:00',1.51),('8784','2013-09-04','17:35:00',1.42),('8784','2013-09-04','17:40:00',1.32),('8784','2013-09-04','17:45:00',1.23),('8784','2013-09-04','17:50:00',1.14),('8784','2013-09-04','17:55:00',1.05),('8784','2013-09-03','08:10:00',1.03),('8784','2013-09-03','08:15:00',1.11),('8784','2013-09-03','08:20:00',1.18),('8784','2013-09-03','08:25:00',1.25),('8784','2013-09-03','08:30:00',1.35),('8784','2013-09-03','08:35:00',1.44),('8784','2013-09-03','08:40:00',1.51),('8784','2013-09-03','08:45:00',1.6),('8784','2013-09-03','08:50:00',1.69),('8784','2013-09-03','08:55:00',1.78),('8784','2013-09-03','09:00:00',1.85),('8784','2013-09-03','09:05:00',1.91),('8784','2013-09-03','09:10:00',2.02),('8784','2013-09-03','09:15:00',2.09),('8784','2013-09-03','09:20:00',2.18),('8784','2013-09-03','09:25:00',2.28),('8784','2013-09-03','09:30:00',2.35),('8784','2013-09-03','09:35:00',2.43),('8784','2013-09-03','09:40:00',2.49),('8784','2013-09-03','09:45:00',2.55),('8784','2013-09-03','09:50:00',2.61),('8784','2013-09-03','09:55:00',2.66),('8784','2013-09-03','10:00:00',2.72),('8784','2013-09-03','10:05:00',2.78),('8784','2013-09-03','10:10:00',2.83),('8784','2013-09-03','10:15:00',2.9),('8784','2013-09-03','10:20:00',2.98),('8784','2013-09-03','10:25:00',3.04),('8784','2013-09-03','10:30:00',3.09),('8784','2013-09-03','10:35:00',3.17),('8784','2013-09-03','10:40:00',3.24),('8784','2013-09-03','10:45:00',3.31),('8784','2013-09-03','10:50:00',3.34),('8784','2013-09-03','10:55:00',3.37),('8784','2013-09-03','11:00:00',3.41),('8784','2013-09-03','11:05:00',3.45),('8784','2013-09-03','11:10:00',3.48),('8784','2013-09-03','11:15:00',3.51),('8784','2013-09-03','11:20:00',3.54),('8784','2013-09-03','11:25:00',3.56),('8784','2013-09-03','11:30:00',3.59),('8784','2013-09-03','11:35:00',3.64),('8784','2013-09-03','11:40:00',3.65),('8784','2013-09-03','11:45:00',3.68),('8784','2013-09-03','11:50:00',3.72),('8784','2013-09-03','11:55:00',3.78),('8784','2013-09-03','12:00:00',3.79),('8784','2013-09-03','12:05:00',3.8),('8784','2013-09-03','12:10:00',3.81),('8784','2013-09-03','12:15:00',3.86),('8784','2013-09-03','12:20:00',3.88),('8784','2013-09-03','12:25:00',3.89),('8784','2013-09-03','12:30:00',3.91),('8784','2013-09-03','12:35:00',3.92),('8784','2013-09-03','12:40:00',3.94),('8784','2013-09-03','12:45:00',3.94),('8784','2013-09-03','12:50:00',3.9),('8784','2013-09-03','12:55:00',3.94),('8784','2013-09-03','13:00:00',3.94),('8784','2013-09-03','13:05:00',3.92),('8784','2013-09-03','13:10:00',3.94),('8784','2013-09-03','13:15:00',3.92),('8784','2013-09-03','13:20:00',3.9),('8784','2013-09-03','13:25:00',3.88),('8784','2013-09-03','13:30:00',3.87),('8784','2013-09-03','13:35:00',3.89),('8784','2013-09-03','13:40:00',3.87),('8784','2013-09-03','13:45:00',3.84),('8784','2013-09-03','13:50:00',3.87),('8784','2013-09-03','13:55:00',3.86),('8784','2013-09-03','14:00:00',3.79),('8784','2013-09-03','14:05:00',3.73),('8784','2013-09-03','14:10:00',3.68),('8784','2013-09-03','14:15:00',3.7),('8784','2013-09-03','14:20:00',3.69),('8784','2013-09-03','14:25:00',3.68),('8784','2013-09-03','14:30:00',3.67),('8784','2013-09-03','14:35:00',3.66),('8784','2013-09-03','14:40:00',3.64),('8784','2013-09-03','14:45:00',3.57),('8784','2013-09-03','14:50:00',3.57),('8784','2013-09-03','14:55:00',3.55),('8784','2013-09-03','15:00:00',3.48),('8784','2013-09-03','15:05:00',3.39),('8784','2013-09-03','15:10:00',3.31),('8784','2013-09-03','15:15:00',3.33),('8784','2013-09-03','15:20:00',3.3),('8784','2013-09-03','15:25:00',3.22),('8784','2013-09-03','15:30:00',3.18),('8784','2013-09-03','15:35:00',3.09),('8784','2013-09-03','15:40:00',3.04),('8784','2013-09-03','15:45:00',2.96),('8784','2013-09-03','15:50:00',2.92),('8784','2013-09-03','15:55:00',2.88),('8784','2013-09-03','16:00:00',2.84),('8784','2013-09-03','16:05:00',2.8),('8784','2013-09-03','16:10:00',2.73),('8784','2013-09-03','16:15:00',2.64),('8784','2013-09-03','16:20:00',2.58),('8784','2013-09-03','16:25:00',2.52),('8784','2013-09-03','16:30:00',2.45),('8784','2013-09-03','16:35:00',2.38),('8784','2013-09-03','16:40:00',2.3),('8784','2013-09-03','16:45:00',2.24),('8784','2013-09-03','16:50:00',2.16),('8784','2013-09-03','16:55:00',2.09),('8784','2013-09-03','17:00:00',2.01),('8784','2013-09-03','17:05:00',1.92),('8784','2013-09-03','17:10:00',1.85),('8784','2013-09-03','17:15:00',1.76),('8784','2013-09-03','17:20:00',1.68),('8784','2013-09-03','17:25:00',1.6),('8784','2013-09-03','17:30:00',1.53),('8784','2013-09-03','17:35:00',1.42),('8784','2013-09-03','17:40:00',1.35),('8784','2013-09-03','17:45:00',1.27),('8784','2013-09-03','17:50:00',1.19),('8784','2013-09-03','17:55:00',1.08),('8784','2013-09-02','08:10:00',1.08),('8784','2013-09-02','08:15:00',1.16),('8784','2013-09-02','08:20:00',1.24),('8784','2013-09-02','08:25:00',1.31),('8784','2013-09-02','08:30:00',1.37),('8784','2013-09-02','08:35:00',1.41),('8784','2013-09-02','08:40:00',1.52),('8784','2013-09-02','08:45:00',1.61),('8784','2013-09-02','08:50:00',1.68),('8784','2013-09-02','08:55:00',1.77),('8784','2013-09-02','09:00:00',1.83),('8784','2013-09-02','09:05:00',1.9),('8784','2013-09-02','09:10:00',1.96),('8784','2013-09-02','09:15:00',2.04),('8784','2013-09-02','09:20:00',2.09),('8784','2013-09-02','09:25:00',2.23),('8784','2013-09-02','09:30:00',2.25),('8784','2013-09-02','09:35:00',2.31),('8784','2013-09-02','09:40:00',2.46),('8784','2013-09-02','09:45:00',2.52),('8784','2013-09-02','09:50:00',2.68),('8784','2013-09-02','09:55:00',2.74),('8784','2013-09-02','10:00:00',2.79),('8784','2013-09-02','10:05:00',2.86),('8784','2013-09-02','10:10:00',2.92),('8784','2013-09-02','10:15:00',2.98),('8784','2013-09-02','10:20:00',3.06),('8784','2013-09-02','10:25:00',3.12),('8784','2013-09-02','10:30:00',3.18),('8784','2013-09-02','10:35:00',3.22),('8784','2013-09-02','10:40:00',3.26),('8784','2013-09-02','10:45:00',3.28),('8784','2013-09-02','10:50:00',3.35),('8784','2013-09-02','10:55:00',3.38),('8784','2013-09-02','11:00:00',3.4),('8784','2013-09-02','11:05:00',3.46),('8784','2013-09-02','11:10:00',3.51),('8784','2013-09-02','11:15:00',3.53),('8784','2013-09-02','11:20:00',3.56),('8784','2013-09-02','11:25:00',3.59),('8784','2013-09-02','11:30:00',3.65),('8784','2013-09-02','11:35:00',3.66),('8784','2013-09-02','11:40:00',3.68),('8784','2013-09-02','11:45:00',3.69),('8784','2013-09-02','11:50:00',3.72),('8784','2013-09-02','11:55:00',3.73),('8784','2013-09-02','12:00:00',3.75),('8784','2013-09-02','12:05:00',3.77),('8784','2013-09-02','12:10:00',3.81),('8784','2013-09-02','12:15:00',3.86),('8784','2013-09-02','12:20:00',3.84),('8784','2013-09-02','12:25:00',3.87),('8784','2013-09-02','12:30:00',3.83),('8784','2013-09-02','12:35:00',3.76),('8784','2013-09-02','12:40:00',3.85),('8784','2013-09-02','12:45:00',3.84),('8784','2013-09-02','12:50:00',3.89),('8784','2013-09-02','12:55:00',3.91),('8784','2013-09-02','13:00:00',3.9),('8784','2013-09-02','13:05:00',3.87),('8784','2013-09-02','13:10:00',3.87),('8784','2013-09-02','13:15:00',3.85),('8784','2013-09-02','13:20:00',3.83),('8784','2013-09-02','13:25:00',3.83),('8784','2013-09-02','13:30:00',3.79),('8784','2013-09-02','13:35:00',3.75),('8784','2013-09-02','13:40:00',3.78),('8784','2013-09-02','13:45:00',2.37),('8784','2013-09-02','13:50:00',1.01),('8784','2013-09-02','14:00:00',3.56),('8784','2013-09-02','14:05:00',3.97),('8784','2013-09-02','14:10:00',3.84),('8784','2013-09-02','14:15:00',3.81),('8784','2013-09-02','14:20:00',3.74),('8784','2013-09-02','14:25:00',3.71),('8784','2013-09-02','14:30:00',3.69),('8784','2013-09-02','14:35:00',3.62),('8784','2013-09-02','14:40:00',3.6),('8784','2013-09-02','14:45:00',3.71),('8784','2013-09-02','14:50:00',3.55),('8784','2013-09-02','14:55:00',2.65),('8784','2013-09-02','15:00:00',1.9),('8784','2013-09-02','15:05:00',3.51),('8784','2013-09-02','15:10:00',3.29),('8784','2013-09-02','15:15:00',2.53),('8784','2013-09-02','15:25:00',2.51),('8784','2013-09-02','15:30:00',3.04),('8784','2013-09-02','15:35:00',2.56),('8784','2013-09-02','15:40:00',2.72),('8784','2013-09-02','15:45:00',2.89),('8784','2013-09-02','15:50:00',3.04),('8784','2013-09-02','15:55:00',2.97),('8784','2013-09-02','16:00:00',2.92),('8784','2013-09-02','16:05:00',2.82),('8784','2013-09-02','16:10:00',2.77),('8784','2013-09-02','16:15:00',2.75),('8784','2013-09-02','16:20:00',2.69),('8784','2013-09-02','16:25:00',2.58),('8784','2013-09-02','16:30:00',2.5),('8784','2013-09-02','16:35:00',2.43),('8784','2013-09-02','16:40:00',2.32),('8784','2013-09-02','16:45:00',2.23),('8784','2013-09-02','16:50:00',2.14),('8784','2013-09-02','16:55:00',2.02),('8784','2013-09-02','17:00:00',1.95),('8784','2013-09-02','17:05:00',1.85),('8784','2013-09-02','17:10:00',1.79),('8784','2013-09-02','17:15:00',1.72),('8784','2013-09-02','17:20:00',1.62),('8784','2013-09-02','17:25:00',1.58),('8784','2013-09-02','17:30:00',1.49),('8784','2013-09-02','17:35:00',1.4),('8784','2013-09-02','17:40:00',1.32),('8784','2013-09-02','17:45:00',1.25),('8784','2013-09-02','17:50:00',1.16),('8784','2013-09-02','17:55:00',1.09),('8784','2013-09-02','18:00:00',1.02),('8784','2013-09-01','08:05:00',1.05),('8784','2013-09-01','08:10:00',1.12),('8784','2013-09-01','08:15:00',1.19),('8784','2013-09-01','08:20:00',1.24),('8784','2013-09-01','08:25:00',1.36),('8784','2013-09-01','08:30:00',1.35),('8784','2013-09-01','08:35:00',1.51),('8784','2013-09-01','08:40:00',1.57),('8784','2013-09-01','08:45:00',1.65),('8784','2013-09-01','08:50:00',1.73),('8784','2013-09-01','08:55:00',1.73),('8784','2013-09-01','09:00:00',1.79),('8784','2013-09-01','09:05:00',1.87),('8784','2013-09-01','09:10:00',1.89),('8784','2013-09-01','09:15:00',2.1),('8784','2013-09-01','09:20:00',2.15),('8784','2013-09-01','09:25:00',2.28),('8784','2013-09-01','09:30:00',2.41),('8784','2013-09-01','09:35:00',2.47),('8784','2013-09-01','09:40:00',2.49),('8784','2013-09-01','09:45:00',2.55),('8784','2013-09-01','09:50:00',2.72),('8784','2013-09-01','09:55:00',2.78),('8784','2013-09-01','10:00:00',2.82),('8784','2013-09-01','10:05:00',2.89),('8784','2013-09-01','10:10:00',2.96),('8784','2013-09-01','10:15:00',3.01),('8784','2013-09-01','10:20:00',3.06),('8784','2013-09-01','10:25:00',3.12),('8784','2013-09-01','10:30:00',3.17),('8784','2013-09-01','10:35:00',3.22),('8784','2013-09-01','10:40:00',3.27),('8784','2013-09-01','10:45:00',3.29),('8784','2013-09-01','10:50:00',3.33),('8784','2013-09-01','10:55:00',3.38),('8784','2013-09-01','11:00:00',3.43),('8784','2013-09-01','11:05:00',3.49),('8784','2013-09-01','11:10:00',3.51),('8784','2013-09-01','11:15:00',3.51),('8784','2013-09-01','11:20:00',3.54),('8784','2013-09-01','11:25:00',3.59),('8784','2013-09-01','11:30:00',3.59),('8784','2013-09-01','11:35:00',3.64),('8784','2013-09-01','11:40:00',3.7),('8784','2013-09-01','11:45:00',3.76),('8784','2013-09-01','11:50:00',3.77),('8784','2013-09-01','11:55:00',3.78),('8784','2013-09-01','12:00:00',3.78),('8784','2013-09-01','12:05:00',3.73),('8784','2013-09-01','12:10:00',3.82),('8784','2013-09-01','12:15:00',3.86),('8784','2013-09-01','12:20:00',3.88),('8784','2013-09-01','12:25:00',3.75),('8784','2013-09-01','12:30:00',3.88),('8784','2013-09-01','12:35:00',3.89),('8784','2013-09-01','12:40:00',3.9),('8784','2013-09-01','12:45:00',3.86),('8784','2013-09-01','12:50:00',3.89),('8784','2013-09-01','12:55:00',3.88),('8784','2013-09-01','13:00:00',3.9),('8784','2013-09-01','13:05:00',3.93),('8784','2013-09-01','13:10:00',3.94),('8784','2013-09-01','13:15:00',3.58),('8784','2013-09-01','13:20:00',3.97),('8784','2013-09-01','13:25:00',3.93),('8784','2013-09-01','13:30:00',3.97),('8784','2013-09-01','13:35:00',3.91),('8784','2013-09-01','13:40:00',3.91),('8784','2013-09-01','13:45:00',3.7),('8784','2013-09-01','13:50:00',3.27),('8784','2013-09-01','13:55:00',3.31),('8784','2013-09-01','14:00:00',3.04),('8784','2013-09-01','14:05:00',3.04),('8784','2013-09-01','14:10:00',3.47),('8784','2013-09-01','14:15:00',3.43),('8784','2013-09-01','14:20:00',3.12),('8784','2013-09-01','14:25:00',3.16),('8784','2013-09-01','14:30:00',3.3),('8784','2013-09-01','14:35:00',3.24),('8784','2013-09-01','14:40:00',3.27),('8784','2013-09-01','14:45:00',3.31),('8784','2013-09-01','14:50:00',3.29),('8784','2013-09-01','14:55:00',3.19),('8784','2013-09-01','15:00:00',3.19),('8784','2013-09-01','15:05:00',3.14),('8784','2013-09-01','15:10:00',3.12),('8784','2013-09-01','15:15:00',3.1),('8784','2013-09-01','15:20:00',2.91),('8784','2013-09-01','15:25:00',2.54),('8784','2013-09-01','15:30:00',2.16),('8784','2013-09-01','15:35:00',2.37),('8784','2013-09-01','15:40:00',2.78),('8784','2013-09-01','15:45:00',2.53),('8784','2013-09-01','15:50:00',1.89),('8784','2013-09-01','15:55:00',2.17),('8784','2013-09-01','16:00:00',2.64),('8784','2013-09-01','16:05:00',2.77),('8784','2013-09-01','16:10:00',2.74),('8784','2013-09-01','16:15:00',2.66),('8784','2013-09-01','16:20:00',2.43),('8784','2013-09-01','16:25:00',2.51),('8784','2013-09-01','16:30:00',2.64),('8784','2013-09-01','16:35:00',2.51),('8784','2013-09-01','16:40:00',2.47),('8784','2013-09-01','16:45:00',2.23),('8784','2013-09-01','16:50:00',2.2),('8784','2013-09-01','16:55:00',1.95),('8784','2013-09-01','17:00:00',1.59),('8784','2013-09-01','17:05:00',1.68),('8784','2013-09-01','17:10:00',1.4),('8784','2013-09-01','17:15:00',1.43),('8784','2013-09-01','17:20:00',1.55),('8784','2013-09-01','17:25:00',1.48),('8784','2013-09-01','17:30:00',1.31),('8784','2013-09-01','17:35:00',1.31),('8784','2013-09-01','17:40:00',1.37),('8784','2013-09-01','17:45:00',1.14),('8784','2013-09-01','17:50:00',1.02),('8784','2013-09-01','17:55:00',1),('8784','2013-09-01','18:00:00',1),('8784','2013-09-01','18:10:00',1.04),('8784','2013-08-31','08:20:00',1.07),('8784','2013-08-31','08:25:00',1.27),('8784','2013-08-31','08:30:00',1.49),('8784','2013-08-31','08:35:00',1.56),('8784','2013-08-31','08:40:00',1.68),('8784','2013-08-31','08:45:00',1.79),('8784','2013-08-31','08:50:00',1.97),('8784','2013-08-31','08:55:00',2.14),('8784','2013-08-31','09:00:00',2.25),('8784','2013-08-31','09:05:00',2.02),('8784','2013-08-31','09:10:00',1.65),('8784','2013-08-31','09:15:00',2.11),('8784','2013-08-31','09:20:00',2.3),('8784','2013-08-31','09:25:00',2.5),('8784','2013-08-31','09:30:00',2.57),('8784','2013-08-31','09:35:00',2.68),('8784','2013-08-31','09:40:00',2.72),('8784','2013-08-31','09:45:00',2.59),('8784','2013-08-31','09:50:00',2.62),('8784','2013-08-31','09:55:00',2.82),('8784','2013-08-31','10:00:00',2.98),('8784','2013-08-31','10:05:00',2.95),('8784','2013-08-31','10:10:00',3.09),('8784','2013-08-31','10:15:00',3.11),('8784','2013-08-31','10:20:00',3.15),('8784','2013-08-31','10:25:00',3.2),('8784','2013-08-31','10:30:00',3.28),('8784','2013-08-31','10:35:00',3.37),('8784','2013-08-31','10:40:00',3.37),('8784','2013-08-31','10:45:00',3.44),('8784','2013-08-31','10:50:00',3.52),('8784','2013-08-31','10:55:00',3.56),('8784','2013-08-31','11:00:00',3.63),('8784','2013-08-31','11:05:00',3.66),('8784','2013-08-31','11:10:00',3.69),('8784','2013-08-31','11:15:00',3.74),('8784','2013-08-31','11:20:00',3.75),('8784','2013-08-31','11:25:00',3.75),('8784','2013-08-31','11:30:00',3.84),('8784','2013-08-31','11:35:00',3.88),('8784','2013-08-31','11:40:00',3.91),('8784','2013-08-31','11:45:00',3.94),('8784','2013-08-31','11:50:00',3.97),('8784','2013-08-31','11:55:00',3.99),('8784','2013-08-31','12:00:00',3.78),('8784','2013-08-31','12:05:00',3.18),('8784','2013-08-31','12:10:00',3.35),('8784','2013-08-31','12:15:00',3.74),('8784','2013-08-31','12:20:00',4.02),('8784','2013-08-31','12:25:00',3.99),('8784','2013-08-31','12:30:00',4),('8784','2013-08-31','12:35:00',4.04),('8784','2013-08-31','12:40:00',3.97),('8784','2013-08-31','12:45:00',4.01),('8784','2013-08-31','12:50:00',4),('8784','2013-08-31','12:55:00',4.03),('8784','2013-08-31','13:00:00',4.01),('8784','2013-08-31','13:05:00',4.02),('8784','2013-08-31','13:10:00',3.96),('8784','2013-08-31','13:15:00',4.02),('8784','2013-08-31','13:20:00',3.99),('8784','2013-08-31','13:25:00',3.98),('8784','2013-08-31','13:30:00',4.02),('8784','2013-08-31','13:35:00',3.96),('8784','2013-08-31','13:40:00',3.96),('8784','2013-08-31','13:45:00',3.91),('8784','2013-08-31','13:50:00',3.94),('8784','2013-08-31','13:55:00',3.9),('8784','2013-08-31','14:00:00',3.88),('8784','2013-08-31','14:05:00',3.87),('8784','2013-08-31','14:10:00',3.83),('8784','2013-08-31','14:15:00',3.8),('8784','2013-08-31','14:20:00',3.75),('8784','2013-08-31','14:25:00',3.68),('8784','2013-08-31','14:30:00',3.68),('8784','2013-08-31','14:35:00',3.52),('8784','2013-08-31','14:40:00',3.57),('8784','2013-08-31','14:45:00',3.57),('8784','2013-08-31','14:50:00',3.56),('8784','2013-08-31','14:55:00',3.43),('8784','2013-08-31','15:00:00',3.39),('8784','2013-08-31','15:05:00',3.39),('8784','2013-08-31','15:10:00',3.37),('8784','2013-08-31','15:15:00',3.31),('8784','2013-08-31','15:20:00',3.27),('8784','2013-08-31','15:25:00',3.22),('8784','2013-08-31','15:30:00',3.19),('8784','2013-08-31','15:35:00',3.09),('8784','2013-08-31','15:40:00',3.06),('8784','2013-08-31','15:45:00',3.01),('8784','2013-08-31','15:50:00',2.94),('8784','2013-08-31','15:55:00',2.87),('8784','2013-08-31','16:00:00',2.83),('8784','2013-08-31','16:05:00',2.77),('8784','2013-08-31','16:10:00',2.69),('8784','2013-08-31','16:15:00',2.67),('8784','2013-08-31','16:20:00',2.62),('8784','2013-08-31','16:25:00',2.52),('8784','2013-08-31','16:30:00',2.46),('8784','2013-08-31','16:35:00',2.45),('8784','2013-08-31','16:40:00',2.36),('8784','2013-08-31','16:45:00',2.23),('8784','2013-08-31','16:50:00',2.15),('8784','2013-08-31','16:55:00',2.08),('8784','2013-08-31','17:00:00',1.99),('8784','2013-08-31','17:05:00',1.98),('8784','2013-08-31','17:10:00',1.88),('8784','2013-08-31','17:15:00',1.78),('8784','2013-08-31','17:20:00',1.72),('8784','2013-08-31','17:25:00',1.63),('8784','2013-08-31','17:30:00',1.54),('8784','2013-08-31','17:35:00',1.42),('8784','2013-08-31','17:40:00',1.37),('8784','2013-08-31','17:45:00',1.26),('8784','2013-08-31','17:50:00',1.17),('8784','2013-08-31','17:55:00',1.02),('8784','2013-08-30','08:00:00',1.03),('8784','2013-08-30','08:05:00',1.23),('8784','2013-08-30','08:10:00',1.38),('8784','2013-08-30','08:15:00',1.33),('8784','2013-08-30','08:20:00',1.4),('8784','2013-08-30','08:25:00',1.45),('8784','2013-08-30','08:30:00',1.5),('8784','2013-08-30','08:35:00',1.59),('8784','2013-08-30','08:40:00',1.61),('8784','2013-08-30','08:45:00',1.45),('8784','2013-08-30','08:50:00',1.32),('8784','2013-08-30','08:55:00',1.34),('8784','2013-08-30','09:00:00',1.55),('8784','2013-08-30','09:05:00',1.69),('8784','2013-08-30','09:10:00',1.5),('8784','2013-08-30','09:15:00',1.39),('8784','2013-08-30','09:20:00',1.24),('8784','2013-08-30','09:25:00',1.34),('8784','2013-08-30','09:30:00',1.71),('8784','2013-08-30','09:35:00',1.92),('8784','2013-08-30','09:40:00',1.83),('8784','2013-08-30','09:45:00',1.86),('8784','2013-08-30','09:50:00',1.88),('8784','2013-08-30','09:55:00',1.98),('8784','2013-08-30','10:00:00',2.02),('8784','2013-08-30','10:05:00',2.01),('8784','2013-08-30','10:10:00',2.02),('8784','2013-08-30','10:15:00',2.16),('8784','2013-08-30','10:20:00',2.24),('8784','2013-08-30','10:25:00',2.08),('8784','2013-08-30','10:30:00',2.29),('8784','2013-08-30','10:35:00',2.19),('8784','2013-08-30','10:40:00',2.09),('8784','2013-08-30','10:45:00',2.05),('8784','2013-08-30','10:50:00',2.18),('8784','2013-08-30','10:55:00',2.07),('8784','2013-08-30','11:00:00',2.18),('8784','2013-08-30','11:05:00',2.28),('8784','2013-08-30','11:10:00',2.41),('8784','2013-08-30','11:15:00',2.43),('8784','2013-08-30','11:20:00',2.45),('8784','2013-08-30','11:25:00',2.52),('8784','2013-08-30','11:30:00',2.66),('8784','2013-08-30','11:35:00',2.52),('8784','2013-08-30','11:40:00',2.73),('8784','2013-08-30','11:45:00',2.71),('8784','2013-08-30','11:50:00',3.07),('8784','2013-08-30','11:55:00',2.7),('8784','2013-08-30','12:00:00',2.44),('8784','2013-08-30','12:05:00',2.13),('8784','2013-08-30','12:10:00',2.32),('8784','2013-08-30','12:15:00',2.54),('8784','2013-08-30','12:20:00',2.65),('8784','2013-08-30','12:25:00',3.04),('8784','2013-08-30','12:30:00',3.35),('8784','2013-08-30','12:35:00',3.18),('8784','2013-08-30','12:40:00',3.11),('8784','2013-08-30','12:45:00',3.22),('8784','2013-08-30','12:50:00',3.14),('8784','2013-08-30','12:55:00',2.94),('8784','2013-08-30','13:00:00',2.9),('8784','2013-08-30','13:05:00',2.91),('8784','2013-08-30','13:10:00',2.91),('8784','2013-08-30','13:15:00',2.83),('8784','2013-08-30','13:20:00',3.35),('8784','2013-08-30','13:25:00',3.8),('8784','2013-08-30','13:30:00',4.03),('8784','2013-08-30','13:35:00',3.73),('8784','2013-08-30','13:40:00',3.93),('8784','2013-08-30','13:45:00',3.55),('8784','2013-08-30','13:50:00',3.54),('8784','2013-08-30','13:55:00',3.86),('8784','2013-08-30','14:00:00',4),('8784','2013-08-30','14:05:00',3.8),('8784','2013-08-30','14:10:00',3.85),('8784','2013-08-30','14:15:00',3.76),('8784','2013-08-30','14:20:00',3.88),('8784','2013-08-30','14:25:00',3.82),('8784','2013-08-30','14:30:00',3.8),('8784','2013-08-30','14:35:00',3.86),('8784','2013-08-30','14:40:00',3.67),('8784','2013-08-30','14:45:00',2.92),('8784','2013-08-30','14:50:00',2.54),('8784','2013-08-30','14:55:00',2.93),('8784','2013-08-30','15:00:00',2.5),('8784','2013-08-30','15:05:00',2.32),('8784','2013-08-30','15:10:00',2.37),('8784','2013-08-30','15:15:00',2.93),('8784','2013-08-30','15:20:00',2.48),('8784','2013-08-30','15:25:00',2.24),('8784','2013-08-30','15:30:00',2.13),('8784','2013-08-30','15:35:00',1.75),('8784','2013-08-30','15:40:00',1.91),('8784','2013-08-30','15:45:00',2.27),('8784','2013-08-30','15:50:00',2.43),('8784','2013-08-30','15:55:00',2.36),('8784','2013-08-30','16:00:00',2.23),('8784','2013-08-30','16:05:00',1.96),('8784','2013-08-30','16:10:00',1.65),('8784','2013-08-30','16:15:00',1.52),('8784','2013-08-30','16:20:00',1.72),('8784','2013-08-30','16:25:00',1.67),('8784','2013-08-30','16:30:00',1.88),('8784','2013-08-30','16:35:00',1.4),('8784','2013-08-30','16:40:00',2.13),('8784','2013-08-30','16:45:00',2.5),('8784','2013-08-30','16:50:00',2.32),('8784','2013-08-30','16:55:00',1.6),('8784','2013-08-30','17:00:00',1.89),('8784','2013-08-30','17:05:00',1.37),('8784','2013-08-30','17:10:00',1.54),('8784','2013-08-30','17:15:00',1.43),('8784','2013-08-30','17:20:00',1.23),('8784','2013-08-30','17:25:00',1.3),('8784','2013-08-30','17:30:00',1.37),('8784','2013-08-30','17:35:00',1.52),('8784','2013-08-30','17:40:00',1.11),('8784','2013-08-30','17:45:00',1.4),('8784','2013-08-30','17:50:00',1.17),('8784','2013-08-30','17:55:00',1.17),('8784','2013-08-30','18:00:00',1.09),('8784','2014-04-11','07:50:00',1.02),('8784','2014-04-11','07:55:00',1.05),('8784','2014-04-11','08:35:00',1.84),('8784','2014-04-11','08:40:00',1.96),('8784','2014-04-11','08:45:00',2.03),('8784','2014-04-11','08:50:00',2.05),('8784','2014-04-11','08:55:00',2.05),('8784','2014-04-11','09:00:00',2.1),('8784','2014-04-11','09:05:00',2.16),('8784','2014-04-11','09:10:00',2.25),('8784','2014-04-11','09:15:00',2.33),('8784','2014-04-11','09:20:00',2.41),('8784','2014-04-11','09:25:00',2.49),('8784','2014-04-11','09:30:00',2.56),('8784','2014-04-11','09:35:00',2.64),('8784','2014-04-11','09:40:00',2.73),('8784','2014-04-11','09:45:00',2.77),('8784','2014-04-11','09:50:00',2.87),('8784','2014-04-11','09:55:00',2.95),('8784','2014-04-11','10:00:00',3.03),('8784','2014-04-11','10:05:00',3.11),('8784','2014-04-11','10:10:00',3.18),('8784','2014-04-11','10:15:00',3.25),('8784','2014-04-11','10:20:00',3.32),('8784','2014-04-11','10:25:00',3.39),('8784','2014-04-11','10:30:00',3.43),('8784','2014-04-11','10:35:00',3.44),('8784','2014-04-11','10:40:00',3.53),('8784','2014-04-11','10:45:00',3.61),('8784','2014-04-11','10:50:00',3.68),('8784','2014-04-11','10:55:00',3.72),('8784','2014-04-11','11:00:00',3.79),('8784','2014-04-11','11:05:00',3.83),('8784','2014-04-11','11:10:00',3.81),('8784','2014-04-11','11:15:00',3.87),('8784','2014-04-11','11:20:00',3.94),('8784','2014-04-11','11:25:00',4.01),('8784','2014-04-11','11:30:00',4.03),('8784','2014-04-11','11:35:00',4.07),('8784','2014-04-11','11:40:00',4.04),('8784','2014-04-11','11:45:00',4.08),('8784','2014-04-11','11:50:00',4.19),('8784','2014-04-11','11:55:00',4.36),('8784','2014-04-11','12:00:00',4.41),('8784','2014-04-11','12:05:00',4.32),('8784','2014-04-11','12:10:00',4.46),('8784','2014-04-11','12:15:00',3.54),('8784','2014-04-11','12:20:00',4.35),('8784','2014-04-11','12:25:00',4.41),('8784','2014-04-11','12:30:00',4.46),('8784','2014-04-11','12:35:00',4.53),('8784','2014-04-11','12:40:00',4.58),('8784','2014-04-11','12:45:00',3.9),('8784','2014-04-11','12:50:00',4.72),('8784','2014-04-11','12:55:00',4.57),('8784','2014-04-11','13:00:00',3.8),('8784','2014-04-11','13:05:00',4.05),('8784','2014-04-11','13:10:00',3.2),('8784','2014-04-11','13:15:00',3.38),('8784','2014-04-11','13:20:00',3.54),('8784','2014-04-11','13:25:00',3.31),('8784','2014-04-11','13:30:00',2.51),('8784','2014-04-11','13:35:00',3.48),('8784','2014-04-11','13:40:00',1.99),('8784','2014-04-11','13:45:00',4.63),('8784','2014-04-11','13:50:00',3.2),('8784','2014-04-11','13:55:00',4.37),('8784','2014-04-11','14:00:00',3.05),('8784','2014-04-11','14:05:00',4.55),('8784','2014-04-11','14:10:00',2.61),('8784','2014-04-11','14:15:00',2.85),('8784','2014-04-11','14:20:00',3.75),('8784','2014-04-11','14:25:00',2.88),('8784','2014-04-11','14:30:00',4.52),('8784','2014-04-11','14:35:00',4.52),('8784','2014-04-11','14:40:00',2.43),('8784','2014-04-11','14:45:00',3.64),('8784','2014-04-11','14:50:00',4.26),('8784','2014-04-11','14:55:00',3.08),('8784','2014-04-11','15:00:00',4.41),('8784','2014-04-11','15:05:00',3.86),('8784','2014-04-11','15:10:00',3.85),('8784','2014-04-11','15:15:00',3.92),('8784','2014-04-11','15:20:00',3.23),('8784','2014-04-11','15:25:00',3.78),('8784','2014-04-11','15:30:00',3.71),('8784','2014-04-11','15:35:00',1.91),('8784','2014-04-11','15:40:00',3.55),('8784','2014-04-11','15:45:00',3.41),('8784','2014-04-11','15:50:00',3.4),('8784','2014-04-11','15:55:00',3.36),('8784','2014-04-11','16:00:00',3.24),('8784','2014-04-11','16:05:00',3.11),('8784','2014-04-11','16:10:00',2.32),('8784','2014-04-11','16:15:00',2.97),('8784','2014-04-11','16:20:00',2.9),('8784','2014-04-11','16:25:00',2.84),('8784','2014-04-11','16:30:00',2.79),('8784','2014-04-11','16:35:00',2.33),('8784','2014-04-11','16:40:00',2.68),('8784','2014-04-11','16:45:00',2.59),('8784','2014-04-11','16:50:00',1.81),('8784','2014-04-11','16:55:00',2.15),('8784','2014-04-11','17:00:00',2.39),('8784','2014-04-11','17:05:00',2.06),('8784','2014-04-11','17:10:00',2),('8784','2014-04-11','17:15:00',2.06),('8784','2014-04-11','17:20:00',1.99),('8784','2014-04-11','17:25:00',1.9),('8784','2014-04-11','17:30:00',1.92),('8784','2014-04-11','17:35:00',1.87),('8784','2014-04-11','17:40:00',1.77),('8784','2014-04-11','17:45:00',1.57),('8784','2014-04-11','17:50:00',1.41),('8784','2014-04-11','17:55:00',1.31),('8784','2014-04-11','18:00:00',1.19),('8784','2014-04-11','18:05:00',1.11),('8784','2014-04-11','18:10:00',1.03),('8784','2013-08-29','07:55:00',1.01),('8784','2013-08-29','08:00:00',1.1),('8784','2013-08-29','08:05:00',1.15),('8784','2013-08-29','08:10:00',1.25),('8784','2013-08-29','08:15:00',1.37),('8784','2013-08-29','08:20:00',1.45),('8784','2013-08-29','08:25:00',1.67),('8784','2013-08-29','08:30:00',1.95),('8784','2013-08-29','08:35:00',1.89),('8784','2013-08-29','08:40:00',1.46),('8784','2013-08-29','08:45:00',1.17),('8784','2013-08-29','08:50:00',1.38),('8784','2013-08-29','08:55:00',1.8),('8784','2013-08-29','09:00:00',1.73),('8784','2013-08-29','09:05:00',1.69),('8784','2013-08-29','09:10:00',1.65),('8784','2013-08-29','09:15:00',1.76),('8784','2013-08-29','09:20:00',1.73),('8784','2013-08-29','09:25:00',1.58),('8784','2013-08-29','09:30:00',1.66),('8784','2013-08-29','09:35:00',1.82),('8784','2013-08-29','09:40:00',1.83),('8784','2013-08-29','09:45:00',1.64),('8784','2013-08-29','09:50:00',1.58),('8784','2013-08-29','09:55:00',1.64),('8784','2013-08-29','10:00:00',1.72),('8784','2013-08-29','10:05:00',1.65),('8784','2013-08-29','10:10:00',1.62),('8784','2013-08-29','10:15:00',1.62),('8784','2013-08-29','10:20:00',1.65),('8784','2013-08-29','10:25:00',1.65),('8784','2013-08-29','10:30:00',1.69),('8784','2013-08-29','10:35:00',1.6),('8784','2013-08-29','10:40:00',1.47),('8784','2013-08-29','10:45:00',1.38),('8784','2013-08-29','10:50:00',1.37),('8784','2013-08-29','10:55:00',1.53),('8784','2013-08-29','11:00:00',1.63),('8784','2013-08-29','11:05:00',1.65),('8784','2013-08-29','11:10:00',2.4),('8784','2013-08-29','11:15:00',2.63),('8784','2013-08-29','11:20:00',2.43),('8784','2013-08-29','11:25:00',1.89),('8784','2013-08-29','11:30:00',1.67),('8784','2013-08-29','11:35:00',1.51),('8784','2013-08-29','11:40:00',1.72),('8784','2013-08-29','11:45:00',1.99),('8784','2013-08-29','11:50:00',2.05),('8784','2013-08-29','11:55:00',1.97),('8784','2013-08-29','12:00:00',1.94),('8784','2013-08-29','12:05:00',2.23),('8784','2013-08-29','12:10:00',2.64),('8784','2013-08-29','12:15:00',3.01),('8784','2013-08-29','12:20:00',2.7),('8784','2013-08-29','12:25:00',2.71),('8784','2013-08-29','12:30:00',2.79),('8784','2013-08-29','12:35:00',3.34),('8784','2013-08-29','12:40:00',4.6),('8784','2013-08-29','12:45:00',4.33),('8784','2013-08-29','12:50:00',2.72),('8784','2013-08-29','12:55:00',3.91),('8784','2013-08-29','13:00:00',2.9),('8784','2013-08-29','13:05:00',2.72),('8784','2013-08-29','13:10:00',2.6),('8784','2013-08-29','13:15:00',2.51),('8784','2013-08-29','13:20:00',2.44),('8784','2013-08-29','13:25:00',2.11),('8784','2013-08-29','13:30:00',2),('8784','2013-08-29','13:35:00',1.88),('8784','2013-08-29','13:40:00',1.79),('8784','2013-08-29','13:45:00',1.69),('8784','2013-08-29','13:50:00',1.65),('8784','2013-08-29','13:55:00',1.92),('8784','2013-08-29','14:00:00',2.45),('8784','2013-08-29','14:05:00',1.81),('8784','2013-08-29','14:10:00',1.63),('8784','2013-08-29','14:15:00',1.36),('8784','2013-08-29','14:20:00',1.11),('8784','2013-08-29','14:40:00',1.02),('8784','2013-08-29','14:45:00',1.13),('8784','2013-08-29','14:50:00',1.31),('8784','2013-08-29','14:55:00',1.5),('8784','2013-08-29','15:00:00',1.65),('8784','2013-08-29','15:05:00',1.84),('8784','2013-08-29','15:10:00',1.46),('8784','2013-08-29','15:15:00',1.28),('8784','2013-08-29','15:20:00',1.41),('8784','2013-08-29','15:25:00',1.61),('8784','2013-08-29','15:30:00',2.58),('8784','2013-08-29','15:35:00',2.35),('8784','2013-08-29','15:40:00',2.29),('8784','2013-08-29','15:45:00',2.47),('8784','2013-08-29','15:50:00',3.01),('8784','2013-08-29','15:55:00',3.28),('8784','2013-08-29','16:00:00',3.01),('8784','2013-08-29','16:05:00',3.46),('8784','2013-08-29','16:10:00',3.22),('8784','2013-08-29','16:15:00',2.99),('8784','2013-08-29','16:20:00',2.85),('8784','2013-08-29','16:25:00',2.71),('8784','2013-08-29','16:30:00',2.64),('8784','2013-08-29','16:35:00',2.57),('8784','2013-08-29','16:40:00',2.49),('8784','2013-08-29','16:45:00',2.4),('8784','2013-08-29','16:50:00',2.33),('8784','2013-08-29','16:55:00',2.27),('8784','2013-08-29','17:00:00',2.19),('8784','2013-08-29','17:05:00',2.11),('8784','2013-08-29','17:10:00',2.02),('8784','2013-08-29','17:15:00',1.92),('8784','2013-08-29','17:20:00',1.86),('8784','2013-08-29','17:25:00',1.75),('8784','2013-08-29','17:30:00',1.67),('8784','2013-08-29','17:35:00',1.58),('8784','2013-08-29','17:40:00',1.49),('8784','2013-08-29','17:45:00',1.38),('8784','2013-08-29','17:50:00',1.3),('8784','2013-08-29','17:55:00',1.22),('8784','2013-08-29','18:00:00',1.13),('8784','2013-08-29','18:05:00',1.06),('8784','2013-08-28','08:00:00',1.1),('8784','2013-08-28','08:05:00',1.15),('8784','2013-08-28','08:10:00',1.22),('8784','2013-08-28','08:15:00',1.3),('8784','2013-08-28','08:20:00',1.38),('8784','2013-08-28','08:25:00',1.42),('8784','2013-08-28','08:30:00',1.54),('8784','2013-08-28','08:35:00',1.71),('8784','2013-08-28','08:40:00',1.54),('8784','2013-08-28','08:45:00',1.3),('8784','2013-08-28','08:50:00',1.39),('8784','2013-08-28','08:55:00',1.1),('8784','2013-08-28','09:00:00',1.78),('8784','2013-08-28','09:10:00',1.17),('8784','2013-08-28','09:15:00',2.25),('8784','2013-08-28','09:20:00',1.16),('8784','2013-08-28','09:30:00',1.35),('8784','2013-08-28','09:35:00',2.25),('8784','2013-08-28','09:40:00',2.62),('8784','2013-08-28','09:45:00',2.73),('8784','2013-08-28','09:50:00',2.81),('8784','2013-08-28','09:55:00',2.83),('8784','2013-08-28','10:00:00',2.85),('8784','2013-08-28','10:05:00',2.88),('8784','2013-08-28','10:10:00',3.03),('8784','2013-08-28','10:15:00',3.18),('8784','2013-08-28','10:20:00',2.97),('8784','2013-08-28','10:25:00',1.67),('8784','2013-08-28','10:30:00',2.33),('8784','2013-08-28','10:35:00',1.82),('8784','2013-08-28','10:40:00',2.76),('8784','2013-08-28','10:45:00',3.67),('8784','2013-08-28','10:50:00',2.27),('8784','2013-08-28','10:55:00',3.49),('8784','2013-08-28','11:00:00',1.39),('8784','2013-08-28','11:05:00',3.71),('8784','2013-08-28','11:10:00',1.33),('8784','2013-08-28','11:15:00',3.89),('8784','2013-08-28','11:20:00',4),('8784','2013-08-28','11:25:00',4.05),('8784','2013-08-28','11:30:00',4.14),('8784','2013-08-28','11:35:00',4.15),('8784','2013-08-28','11:40:00',4.28),('8784','2013-08-28','11:45:00',2.81),('8784','2013-08-28','11:50:00',3.22),('8784','2013-08-28','11:55:00',2.06),('8784','2013-08-28','12:00:00',3.21),('8784','2013-08-28','12:05:00',3.2),('8784','2013-08-28','12:10:00',3.77),('8784','2013-08-28','12:15:00',4.29),('8784','2013-08-28','12:20:00',3.94),('8784','2013-08-28','12:25:00',4.19),('8784','2013-08-28','12:30:00',4.16),('8784','2013-08-28','12:35:00',4.18),('8784','2013-08-28','12:40:00',4.23),('8784','2013-08-28','12:45:00',4.34),('8784','2013-08-28','12:50:00',4.28),('8784','2013-08-28','12:55:00',4.23),('8784','2013-08-28','13:00:00',4.3),('8784','2013-08-28','13:05:00',4.02),('8784','2013-08-28','13:10:00',4.4),('8784','2013-08-28','13:15:00',4.31),('8784','2013-08-28','13:20:00',4.25),('8784','2013-08-28','13:25:00',4.25),('8784','2013-08-28','13:30:00',4.04),('8784','2013-08-28','13:35:00',4.26),('8784','2013-08-28','13:40:00',3.59),('8784','2013-08-28','13:45:00',3.72),('8784','2013-08-28','13:50:00',4.31),('8784','2013-08-28','13:55:00',3.01),('8784','2013-08-28','14:00:00',4.23),('8784','2013-08-28','14:05:00',4.11),('8784','2013-08-28','14:10:00',4.14),('8784','2013-08-28','14:15:00',4.11),('8784','2013-08-28','14:20:00',4.06),('8784','2013-08-28','14:25:00',4.06),('8784','2013-08-28','14:30:00',3.45),('8784','2013-08-28','14:35:00',3.23),('8784','2013-08-28','14:40:00',4.1),('8784','2013-08-28','14:45:00',3.94),('8784','2013-08-28','14:50:00',3.88),('8784','2013-08-28','14:55:00',3.82),('8784','2013-08-28','15:00:00',3.74),('8784','2013-08-28','15:05:00',3.31),('8784','2013-08-28','15:10:00',3.8),('8784','2013-08-28','15:15:00',3.73),('8784','2013-08-28','15:20:00',3.55),('8784','2013-08-28','15:25:00',2.3),('8784','2013-08-28','15:30:00',2.69),('8784','2013-08-28','15:35:00',2.98),('8784','2013-08-28','15:40:00',1.35),('8784','2013-08-28','15:45:00',1.98),('8784','2013-08-28','15:50:00',1.8),('8784','2013-08-28','15:55:00',3.16),('8784','2013-08-28','16:00:00',3.4),('8784','2013-08-28','16:05:00',2.7),('8784','2013-08-28','16:10:00',2.1),('8784','2013-08-28','16:15:00',2.28),('8784','2013-08-28','16:20:00',2.28),('8784','2013-08-28','16:25:00',3.03),('8784','2013-08-28','16:30:00',2.83),('8784','2013-08-28','16:35:00',2.77),('8784','2013-08-28','16:40:00',2.7),('8784','2013-08-28','16:45:00',2.52),('8784','2013-08-28','16:50:00',2.31),('8784','2013-08-28','16:55:00',2.33),('8784','2013-08-28','17:00:00',2.28),('8784','2013-08-28','17:05:00',2.15),('8784','2013-08-28','17:10:00',1.77),('8784','2013-08-28','17:20:00',1.26),('8784','2013-08-28','17:25:00',1.6),('8784','2013-08-28','17:35:00',1.69),('8784','2013-08-28','17:40:00',1.66),('8784','2013-08-28','17:55:00',1.18),('8784','2013-08-28','18:15:00',1.03),('8784','2013-08-27','08:20:00',1.24),('8784','2013-08-27','08:25:00',1.59),('8784','2013-08-27','08:30:00',1.58),('8784','2013-08-27','08:35:00',1.12),('8784','2013-08-27','08:40:00',1.07),('8784','2013-08-27','08:45:00',1.25),('8784','2013-08-27','09:05:00',1.08),('8784','2013-08-27','09:10:00',1.09),('8784','2013-08-27','09:15:00',1.37),('8784','2013-08-27','09:20:00',1.63),('8784','2013-08-27','09:25:00',2.1),('8784','2013-08-27','09:30:00',2.29),('8784','2013-08-27','09:35:00',1.33),('8784','2013-08-27','09:40:00',1.06),('8784','2013-08-27','09:45:00',1.11),('8784','2013-08-27','09:50:00',1.17),('8784','2013-08-27','09:55:00',1.52),('8784','2013-08-27','10:00:00',1.93),('8784','2013-08-27','10:05:00',2.29),('8784','2013-08-27','10:10:00',2.85),('8784','2013-08-27','10:15:00',2.9),('8784','2013-08-27','10:20:00',3.06),('8784','2013-08-27','10:25:00',3.14),('8784','2013-08-27','10:30:00',3.11),('8784','2013-08-27','10:35:00',3.21),('8784','2013-08-27','10:40:00',3.15),('8784','2013-08-27','10:45:00',3.2),('8784','2013-08-27','10:50:00',3.18),('8784','2013-08-27','10:55:00',3.31),('8784','2013-08-27','11:00:00',3.36),('8784','2013-08-27','11:05:00',3.47),('8784','2013-08-27','11:10:00',3.49),('8784','2013-08-27','11:15:00',3.46),('8784','2013-08-27','11:20:00',3.47),('8784','2013-08-27','11:25:00',3.5),('8784','2013-08-27','11:30:00',3.53),('8784','2013-08-27','11:35:00',3.55),('8784','2013-08-27','11:40:00',3.43),('8784','2013-08-27','11:45:00',4.36),('8784','2013-08-27','11:50:00',3.2),('8784','2013-08-27','11:55:00',4.06),('8784','2013-08-27','12:00:00',4.15),('8784','2013-08-27','12:05:00',3.79),('8784','2013-08-27','12:10:00',3.18),('8784','2013-08-27','12:15:00',3.82),('8784','2013-08-27','12:20:00',4.06),('8784','2013-08-27','12:25:00',3.73),('8784','2013-08-27','12:30:00',3.9),('8784','2013-08-27','12:35:00',4.26),('8784','2013-08-27','12:40:00',4.37),('8784','2013-08-27','12:45:00',3.04),('8784','2013-08-27','12:50:00',2.17),('8784','2013-08-27','12:55:00',1.93),('8784','2013-08-27','13:00:00',1.4),('8784','2013-08-27','13:05:00',1.69),('8784','2013-08-27','13:10:00',2.11),('8784','2013-08-27','13:15:00',1.88),('8784','2013-08-27','13:20:00',2.19),('8784','2013-08-27','13:25:00',2.39),('8784','2013-08-27','13:30:00',2.56),('8784','2013-08-27','13:35:00',2.08),('8784','2013-08-27','13:40:00',1.96),('8784','2013-08-27','13:45:00',2.92),('8784','2013-08-27','13:50:00',3.75),('8784','2013-08-27','13:55:00',3.13),('8784','2013-08-27','14:00:00',4.12),('8784','2013-08-27','14:05:00',1.98),('8784','2013-08-27','14:10:00',2.38),('8784','2013-08-27','14:15:00',3.33),('8784','2013-08-27','14:20:00',2.06),('8784','2013-08-27','14:25:00',1.35),('8784','2013-08-27','14:30:00',1.32),('8784','2013-08-27','14:35:00',1.19),('8784','2013-08-27','14:40:00',1.33),('8784','2013-08-27','14:45:00',1.36),('8784','2013-08-27','14:50:00',1.06),('8784','2013-08-27','15:55:00',1.42),('8784','2013-08-27','16:00:00',1.54),('8784','2013-08-27','16:05:00',1.9),('8784','2013-08-27','16:10:00',3.67),('8784','2013-08-27','16:15:00',3.26),('8784','2013-08-27','16:20:00',2.2),('8784','2013-08-27','16:25:00',2.22),('8784','2013-08-27','16:35:00',1.26),('8784','2013-08-27','16:40:00',1.45),('8784','2013-08-27','16:45:00',1.98),('8784','2013-08-27','16:50:00',2.53),('8784','2013-08-27','16:55:00',1.83),('8784','2013-08-27','17:05:00',1.26),('8784','2013-08-27','17:10:00',2.64),('8784','2013-08-27','17:15:00',1.37),('8784','2013-08-27','17:45:00',1.28),('8784','2013-08-27','17:50:00',1.47),('8784','2013-08-27','17:55:00',1.47),('8784','2013-08-27','18:00:00',1.27),('8784','2013-08-26','08:05:00',1.51),('8784','2013-08-26','08:10:00',1.31),('8784','2013-08-26','08:20:00',1.59),('8784','2013-08-26','08:25:00',1.33),('8784','2013-08-26','08:30:00',1.55),('8784','2013-08-26','08:35:00',1.42),('8784','2013-08-26','08:40:00',1.72),('8784','2013-08-26','08:45:00',1.8),('8784','2013-08-26','08:50:00',1.85),('8784','2013-08-26','08:55:00',1.93),('8784','2013-08-26','09:00:00',1.99),('8784','2013-08-26','09:05:00',2.07),('8784','2013-08-26','09:10:00',2.11),('8784','2013-08-26','09:15:00',2.18),('8784','2013-08-26','09:20:00',2.3),('8784','2013-08-26','09:25:00',2.41),('8784','2013-08-26','09:30:00',2.44),('8784','2013-08-26','09:35:00',2.52),('8784','2013-08-26','09:40:00',2.58),('8784','2013-08-26','09:45:00',2.69),('8784','2013-08-26','09:50:00',2.74),('8784','2013-08-26','09:55:00',2.77),('8784','2013-08-26','10:00:00',2.82),('8784','2013-08-26','10:05:00',2.89),('8784','2013-08-26','10:10:00',2.96),('8784','2013-08-26','10:15:00',2.98),('8784','2013-08-26','10:20:00',3.1),('8784','2013-08-26','10:25:00',3.15),('8784','2013-08-26','10:30:00',3.18),('8784','2013-08-26','10:35:00',3.24),('8784','2013-08-26','10:40:00',3.32),('8784','2013-08-26','10:45:00',3.38),('8784','2013-08-26','10:50:00',3.41),('8784','2013-08-26','10:55:00',3.41),('8784','2013-08-26','11:00:00',3.48),('8784','2013-08-26','11:05:00',3.43),('8784','2013-08-26','11:10:00',3.54),('8784','2013-08-26','11:15:00',3.59),('8784','2013-08-26','11:20:00',3.61),('8784','2013-08-26','11:25:00',3.65),('8784','2013-08-26','11:30:00',3.7),('8784','2013-08-26','11:35:00',3.74),('8784','2013-08-26','11:40:00',3.75),('8784','2013-08-26','11:45:00',3.77),('8784','2013-08-26','11:50:00',3.8),('8784','2013-08-26','11:55:00',3.77),('8784','2013-08-26','12:00:00',3.82),('8784','2013-08-26','12:05:00',3.85),('8784','2013-08-26','12:10:00',3.87),('8784','2013-08-26','12:15:00',3.88),('8784','2013-08-26','12:20:00',3.84),('8784','2013-08-26','12:25:00',3.86),('8784','2013-08-26','12:30:00',3.87),('8784','2013-08-26','12:35:00',3.91),('8784','2013-08-26','12:40:00',3.93),('8784','2013-08-26','12:45:00',3.97),('8784','2013-08-26','12:50:00',3.97),('8784','2013-08-26','12:55:00',4.01),('8784','2013-08-26','13:00:00',4.15),('8784','2013-08-26','13:05:00',4.65),('8784','2013-08-26','13:10:00',4.07),('8784','2013-08-26','13:15:00',3.62),('8784','2013-08-26','13:20:00',2.65),('8784','2013-08-26','13:25:00',2.99),('8784','2013-08-26','13:30:00',2.89),('8784','2013-08-26','13:35:00',3.61),('8784','2013-08-26','13:40:00',3.92),('8784','2013-08-26','13:45:00',3.98),('8784','2013-08-26','13:50:00',3.98),('8784','2013-08-26','13:55:00',2.88),('8784','2013-08-26','14:00:00',2.69),('8784','2013-08-26','14:05:00',3.4),('8784','2013-08-26','14:10:00',2.67),('8784','2013-08-26','14:15:00',3.75),('8784','2013-08-26','14:20:00',3.83),('8784','2013-08-26','14:25:00',3.77),('8784','2013-08-26','14:30:00',3.72),('8784','2013-08-26','14:35:00',3.54),('8784','2013-08-26','14:40:00',3.19),('8784','2013-08-26','14:45:00',2.37),('8784','2013-08-26','14:50:00',2.13),('8784','2013-08-26','14:55:00',1.99),('8784','2013-08-26','15:00:00',1.9),('8784','2013-08-26','15:05:00',1.38),('8784','2013-08-26','15:10:00',1.12),('8784','2013-08-26','15:35:00',1.05),('8784','2013-08-26','15:40:00',1.66),('8784','2013-08-26','15:45:00',1.78),('8784','2013-08-26','15:50:00',1.73),('8784','2013-08-26','15:55:00',1.65),('8784','2013-08-26','16:00:00',2.57),('8784','2013-08-26','16:05:00',3.28),('8784','2013-08-26','16:10:00',2.9),('8784','2013-08-26','16:15:00',2.75),('8784','2013-08-26','16:20:00',2.69),('8784','2013-08-26','16:25:00',2.59),('8784','2013-08-26','16:30:00',2.5),('8784','2013-08-26','16:35:00',2.44),('8784','2013-08-26','16:40:00',2.38),('8784','2013-08-26','16:45:00',2.32),('8784','2013-08-26','16:50:00',2.14),('8784','2013-08-26','16:55:00',2.14),('8784','2013-08-26','17:00:00',2.1),('8784','2013-08-26','17:05:00',1.89),('8784','2013-08-26','17:10:00',1.93),('8784','2013-08-26','17:15:00',1.85),('8784','2013-08-26','17:20:00',1.33),('8784','2013-08-26','17:30:00',1.38),('8784','2013-08-26','17:35:00',1.06),('8784','2013-08-26','17:40:00',1.11),('8784','2013-08-26','17:45:00',1.3),('8784','2013-08-26','17:50:00',1.47),('8784','2013-08-26','17:55:00',1.44),('8784','2013-08-26','18:00:00',1.25),('8784','2013-08-26','18:05:00',1.09),('8784','2013-08-25','08:05:00',1.1),('8784','2013-08-25','08:10:00',1.28),('8784','2013-08-25','08:15:00',1.3),('8784','2013-08-25','08:20:00',1.23),('8784','2013-08-25','08:25:00',1.28),('8784','2013-08-25','08:35:00',1.06),('8784','2013-08-25','08:40:00',1.39),('8784','2013-08-25','08:45:00',1.5),('8784','2013-08-25','09:15:00',1.15),('8784','2013-08-25','09:20:00',2.36),('8784','2013-08-25','09:25:00',2.37),('8784','2013-08-25','09:30:00',2.02),('8784','2013-08-25','09:35:00',1.05),('8784','2013-08-25','09:40:00',2.71),('8784','2013-08-25','09:45:00',2.25),('8784','2013-08-25','09:50:00',3.15),('8784','2013-08-25','09:55:00',2.97),('8784','2013-08-25','10:00:00',2.46),('8784','2013-08-25','10:05:00',1.57),('8784','2013-08-25','15:05:00',1.04),('8784','2013-08-25','15:10:00',1.14),('8784','2013-08-25','15:15:00',1.32),('8784','2013-08-25','15:20:00',1.55),('8784','2013-08-25','15:25:00',1.65),('8784','2013-08-25','15:30:00',2.2),('8784','2013-08-25','15:35:00',3.37),('8784','2013-08-25','15:40:00',3.42),('8784','2013-08-25','15:45:00',3.71),('8784','2013-08-25','15:50:00',2.27),('8784','2013-08-25','15:55:00',2.72),('8784','2013-08-25','16:00:00',3.41),('8784','2013-08-25','16:05:00',3.2),('8784','2013-08-25','16:10:00',3),('8784','2013-08-25','16:15:00',2.92),('8784','2013-08-25','16:20:00',2.84),('8784','2013-08-25','16:25:00',2.8),('8784','2013-08-25','16:30:00',2.72),('8784','2013-08-25','16:35:00',2.6),('8784','2013-08-25','16:40:00',1.83),('8784','2013-08-25','16:45:00',1.24),('8784','2013-08-25','16:50:00',1.92),('8784','2013-08-25','17:40:00',1.37),('8784','2013-08-25','17:45:00',1.45),('8784','2013-08-25','17:50:00',1.3),('8784','2013-08-25','17:55:00',1.13),('8784','2013-08-24','08:10:00',1.05),('8784','2013-08-24','08:20:00',1.09),('8784','2013-08-24','08:25:00',1.34),('8784','2013-08-24','08:30:00',1.41),('8784','2013-08-24','08:35:00',1.55),('8784','2013-08-24','08:40:00',1.68),('8784','2013-08-24','08:45:00',1.75),('8784','2013-08-24','08:50:00',1.77),('8784','2013-08-24','08:55:00',1.96),('8784','2013-08-24','09:00:00',2.07),('8784','2013-08-24','09:05:00',2.18),('8784','2013-08-24','09:10:00',2.1),('8784','2013-08-24','09:15:00',2.21),('8784','2013-08-24','09:20:00',1.28),('8784','2013-08-24','09:25:00',2.12),('8784','2013-08-24','09:30:00',2.5),('8784','2013-08-24','09:35:00',2.61),('8784','2013-08-24','09:40:00',2.06),('8784','2013-08-24','09:45:00',2.58),('8784','2013-08-24','09:50:00',2.41),('8784','2013-08-24','09:55:00',2.08),('8784','2013-08-24','10:00:00',2.9),('8784','2013-08-24','10:05:00',2.93),('8784','2013-08-24','10:10:00',2.98),('8784','2013-08-24','10:15:00',3.03),('8784','2013-08-24','10:20:00',3.09),('8784','2013-08-24','10:25:00',3.13),('8784','2013-08-24','10:30:00',3.16),('8784','2013-08-24','10:35:00',3.26),('8784','2013-08-24','10:40:00',3.27),('8784','2013-08-24','10:45:00',2.86),('8784','2013-08-24','10:50:00',2.41),('8784','2013-08-24','10:55:00',3.53),('8784','2013-08-24','11:00:00',3.49),('8784','2013-08-24','11:05:00',3.59),('8784','2013-08-24','11:10:00',3.59),('8784','2013-08-24','11:15:00',3.54),('8784','2013-08-24','11:20:00',3.6),('8784','2013-08-24','11:25:00',3.64),('8784','2013-08-24','11:30:00',3.68),('8784','2013-08-24','11:35:00',3.71),('8784','2013-08-24','11:40:00',3.76),('8784','2013-08-24','11:45:00',3.78),('8784','2013-08-24','11:50:00',3.76),('8784','2013-08-24','11:55:00',3.79),('8784','2013-08-24','12:00:00',3.81),('8784','2013-08-24','12:05:00',3.84),('8784','2013-08-24','12:10:00',3.91),('8784','2013-08-24','12:15:00',3.87),('8784','2013-08-24','12:20:00',3.94),('8784','2013-08-24','12:25:00',3.9),('8784','2013-08-24','12:30:00',3.91),('8784','2013-08-24','12:35:00',3.93),('8784','2013-08-24','12:40:00',3.92),('8784','2013-08-24','12:45:00',3.91),('8784','2013-08-24','12:50:00',3.94),('8784','2013-08-24','12:55:00',3.87),('8784','2013-08-24','13:00:00',3.89),('8784','2013-08-24','13:05:00',3.96),('8784','2013-08-24','13:10:00',3.95),('8784','2013-08-24','13:15:00',3.94),('8784','2013-08-24','13:20:00',4.02),('8784','2013-08-24','13:25:00',3.96),('8784','2013-08-24','13:30:00',3.99),('8784','2013-08-24','13:35:00',3.99),('8784','2013-08-24','13:40:00',3.98),('8784','2013-08-24','13:45:00',3.95),('8784','2013-08-24','13:50:00',3.92),('8784','2013-08-24','13:55:00',3.93),('8784','2013-08-24','14:00:00',3.89),('8784','2013-08-24','14:05:00',3.91),('8784','2013-08-24','14:10:00',3.87),('8784','2013-08-24','14:15:00',3.86),('8784','2013-08-24','14:20:00',3.84),('8784','2013-08-24','14:25:00',3.8),('8784','2013-08-24','14:30:00',3.8),('8784','2013-08-24','14:35:00',3.72),('8784','2013-08-24','14:40:00',3.69),('8784','2013-08-24','14:45:00',3.65),('8784','2013-08-24','14:50:00',3.63),('8784','2013-08-24','14:55:00',3.55),('8784','2013-08-24','15:00:00',3.54),('8784','2013-08-24','15:05:00',3.54),('8784','2013-08-24','15:10:00',3.43),('8784','2013-08-24','15:15:00',3.4),('8784','2013-08-24','15:20:00',3.36),('8784','2013-08-24','15:25:00',3.32),('8784','2013-08-24','15:30:00',3.27),('8784','2013-08-24','15:35:00',3.23),('8784','2013-08-24','15:40:00',3.17),('8784','2013-08-24','15:45:00',3.09),('8784','2013-08-24','15:50:00',3.04),('8784','2013-08-24','15:55:00',3.01),('8784','2013-08-24','16:00:00',2.96),('8784','2013-08-24','16:05:00',2.9),('8784','2013-08-24','16:10:00',2.84),('8784','2013-08-24','16:15:00',2.82),('8784','2013-08-24','16:20:00',2.77),('8784','2013-08-24','16:25:00',2.7),('8784','2013-08-24','16:30:00',2.61),('8784','2013-08-24','16:35:00',2.52),('8784','2013-08-24','16:40:00',2.47),('8784','2013-08-24','16:45:00',2.37),('8784','2013-08-24','16:50:00',2.32),('8784','2013-08-24','16:55:00',2.25),('8784','2013-08-24','17:00:00',2.18),('8784','2013-08-24','17:05:00',2.11),('8784','2013-08-24','17:10:00',2.04),('8784','2013-08-24','17:15:00',1.97),('8784','2013-08-24','17:20:00',1.88),('8784','2013-08-24','17:25:00',1.8),('8784','2013-08-24','17:30:00',1.72),('8784','2013-08-24','17:35:00',1.63),('8784','2013-08-24','17:40:00',1.55),('8784','2013-08-24','17:45:00',1.48),('8784','2013-08-24','17:50:00',1.39),('8784','2013-08-24','17:55:00',1.31),('8784','2013-08-24','18:00:00',1.22),('8784','2013-08-24','18:05:00',1.15),('8784','2013-08-24','18:10:00',1.06),('8784','2013-08-23','08:10:00',1.06),('8784','2013-08-23','08:15:00',1.16),('8784','2013-08-23','08:20:00',1.22),('8784','2013-08-23','08:25:00',1.29),('8784','2013-08-23','08:30:00',1.37),('8784','2013-08-23','08:35:00',1.41),('8784','2013-08-23','08:40:00',1.49),('8784','2013-08-23','08:45:00',1.6),('8784','2013-08-23','08:50:00',1.65),('8784','2013-08-23','08:55:00',1.74),('8784','2013-08-23','09:00:00',1.79),('8784','2013-08-23','09:05:00',1.87),('8784','2013-08-23','09:10:00',1.94),('8784','2013-08-23','09:15:00',2.04),('8784','2013-08-23','09:20:00',2.14),('8784','2013-08-23','09:25:00',2.19),('8784','2013-08-23','09:30:00',2.24),('8784','2013-08-23','09:35:00',2.31),('8784','2013-08-23','09:40:00',2.34),('8784','2013-08-23','09:45:00',2.45),('8784','2013-08-23','09:50:00',2.48),('8784','2013-08-23','09:55:00',2.55),('8784','2013-08-23','10:00:00',2.6),('8784','2013-08-23','10:05:00',2.66),('8784','2013-08-23','10:10:00',2.71),('8784','2013-08-23','10:15:00',2.78),('8784','2013-08-23','10:20:00',2.81),('8784','2013-08-23','10:25:00',2.9),('8784','2013-08-23','10:30:00',2.95),('8784','2013-08-23','10:35:00',2.92),('8784','2013-08-23','10:40:00',3),('8784','2013-08-23','10:45:00',2.99),('8784','2013-08-23','10:50:00',3.16),('8784','2013-08-23','10:55:00',3.17),('8784','2013-08-23','11:00:00',3.12),('8784','2013-08-23','11:05:00',2.88),('8784','2013-08-23','11:10:00',1.2),('8784','2013-08-23','11:15:00',1.25),('8784','2013-08-23','11:20:00',1.49),('8784','2013-08-23','11:25:00',1.58),('8784','2013-08-23','11:30:00',2.84),('8784','2013-08-23','11:35:00',3.64),('8784','2013-08-23','11:40:00',3.68),('8784','2013-08-23','11:45:00',3.7),('8784','2013-08-23','11:50:00',3.82),('8784','2013-08-23','11:55:00',1.96),('8784','2013-08-23','12:00:00',1.85),('8784','2013-08-23','12:05:00',3.4),('8784','2013-08-23','12:10:00',3.91),('8784','2013-08-23','12:15:00',1.09),('8784','2013-08-23','12:20:00',1),('8784','2013-08-23','12:25:00',1.05),('8784','2013-08-23','12:30:00',1.59),('8784','2013-08-23','12:35:00',1.87),('8784','2013-08-23','12:40:00',1.33),('8784','2013-08-23','12:45:00',1.53),('8784','2013-08-23','12:50:00',2.11),('8784','2013-08-23','12:55:00',1.03),('8784','2013-08-23','13:00:00',1.59),('8784','2013-08-23','13:05:00',2.58),('8784','2013-08-23','13:10:00',1.38),('8784','2013-08-23','13:15:00',2.74),('8784','2013-08-23','13:20:00',3.66),('8784','2013-08-23','13:25:00',4.32),('8784','2013-08-23','13:30:00',4.22),('8784','2013-08-23','13:35:00',2.8),('8784','2013-08-23','13:40:00',3.83),('8784','2013-08-23','13:45:00',3.11),('8784','2013-08-23','13:50:00',2.47),('8784','2013-08-23','13:55:00',4.31),('8784','2013-08-23','14:00:00',4.22),('8784','2013-08-23','14:05:00',4.09),('8784','2013-08-23','14:10:00',3.99),('8784','2013-08-23','14:15:00',3.91),('8784','2013-08-23','14:20:00',3.84),('8784','2013-08-23','14:25:00',3.78),('8784','2013-08-23','14:30:00',3.43),('8784','2013-08-23','14:35:00',3.75),('8784','2013-08-23','14:40:00',3.69),('8784','2013-08-23','14:45:00',3.71),('8784','2013-08-23','14:50:00',3.58),('8784','2013-08-23','14:55:00',3.4),('8784','2013-08-23','15:00:00',3.41),('8784','2013-08-23','15:05:00',3.28),('8784','2013-08-23','15:10:00',3.49),('8784','2013-08-23','15:15:00',3.34),('8784','2013-08-23','15:20:00',3.33),('8784','2013-08-23','15:25:00',3.37),('8784','2013-08-23','15:30:00',3.45),('8784','2013-08-23','15:35:00',3.16),('8784','2013-08-23','15:40:00',3.12),('8784','2013-08-23','15:45:00',3.11),('8784','2013-08-23','15:50:00',2.83),('8784','2013-08-23','15:55:00',3.06),('8784','2013-08-23','16:00:00',2.91),('8784','2013-08-23','16:05:00',2.76),('8784','2013-08-23','16:10:00',2.52),('8784','2013-08-23','16:15:00',2.68),('8784','2013-08-23','16:20:00',2.88),('8784','2013-08-23','16:25:00',2.8),('8784','2013-08-23','16:30:00',2.71),('8784','2013-08-23','16:35:00',2.67),('8784','2013-08-23','16:40:00',2.59),('8784','2013-08-23','16:45:00',2.55),('8784','2013-08-23','16:50:00',2.43),('8784','2013-08-23','16:55:00',2.33),('8784','2013-08-23','17:00:00',2.23),('8784','2013-08-23','17:05:00',2.12),('8784','2013-08-23','17:10:00',2.03),('8784','2013-08-23','17:15:00',1.94),('8784','2013-08-23','17:20:00',1.86),('8784','2013-08-23','17:25:00',1.77),('8784','2013-08-23','17:30:00',1.67),('8784','2013-08-23','17:35:00',1.6),('8784','2013-08-23','17:40:00',1.5),('8784','2013-08-23','17:45:00',1.44),('8784','2013-08-23','17:50:00',1.37),('8784','2013-08-23','17:55:00',1.3),('8784','2013-08-23','18:00:00',1.2),('8784','2013-08-23','18:05:00',1.11),('8784','2013-08-22','08:05:00',1.03),('8784','2013-08-22','08:10:00',1.15),('8784','2013-08-22','08:15:00',1.21),('8784','2013-08-22','08:20:00',1.28),('8784','2013-08-22','08:25:00',1.35),('8784','2013-08-22','08:30:00',1.43),('8784','2013-08-22','08:35:00',1.52),('8784','2013-08-22','08:40:00',1.61),('8784','2013-08-22','08:45:00',1.72),('8784','2013-08-22','08:50:00',1.79),('8784','2013-08-22','08:55:00',1.9),('8784','2013-08-22','09:00:00',1.91),('8784','2013-08-22','09:05:00',2.08),('8784','2013-08-22','09:10:00',2.2),('8784','2013-08-22','09:15:00',2.32),('8784','2013-08-22','09:20:00',2.46),('8784','2013-08-22','09:25:00',2.57),('8784','2013-08-22','09:30:00',2.64),('8784','2013-08-22','09:35:00',1.69),('8784','2013-08-22','09:40:00',1.75),('8784','2013-08-22','09:45:00',2.51),('8784','2013-08-22','09:50:00',2.8),('8784','2013-08-22','09:55:00',2.38),('8784','2013-08-22','10:00:00',3.03),('8784','2013-08-22','10:05:00',3.05),('8784','2013-08-22','10:10:00',3.07),('8784','2013-08-22','10:15:00',3.05),('8784','2013-08-22','10:20:00',3.05),('8784','2013-08-22','10:25:00',3.1),('8784','2013-08-22','10:30:00',3.18),('8784','2013-08-22','10:35:00',3.21),('8784','2013-08-22','10:40:00',3.25),('8784','2013-08-22','10:45:00',3.27),('8784','2013-08-22','10:50:00',3.32),('8784','2013-08-22','10:55:00',3.37),('8784','2013-08-22','11:00:00',3.42),('8784','2013-08-22','11:05:00',3.44),('8784','2013-08-22','11:10:00',3.47),('8784','2013-08-22','11:15:00',3.48),('8784','2013-08-22','11:20:00',3.51),('8784','2013-08-22','11:25:00',3.55),('8784','2013-08-22','11:30:00',3.59),('8784','2013-08-22','11:35:00',3.63),('8784','2013-08-22','11:40:00',3.62),('8784','2013-08-22','11:45:00',3.69),('8784','2013-08-22','11:50:00',3.69),('8784','2013-08-22','11:55:00',3.73),('8784','2013-08-22','12:00:00',3.75),('8784','2013-08-22','12:05:00',3.78),('8784','2013-08-22','12:10:00',3.75),('8784','2013-08-22','12:15:00',3.78),('8784','2013-08-22','12:20:00',3.81),('8784','2013-08-22','12:25:00',3.8),('8784','2013-08-22','12:30:00',3.79),('8784','2013-08-22','12:35:00',3.79),('8784','2013-08-22','12:40:00',3.8),('8784','2013-08-22','12:45:00',3.83),('8784','2013-08-22','12:50:00',3.83),('8784','2013-08-22','12:55:00',3.83),('8784','2013-08-22','13:00:00',3.82),('8784','2013-08-22','13:05:00',3.78),('8784','2013-08-22','13:10:00',3.72),('8784','2013-08-22','13:15:00',3.73),('8784','2013-08-22','13:20:00',3.74),('8784','2013-08-22','13:25:00',3.77),('8784','2013-08-22','13:30:00',3.8),('8784','2013-08-22','13:35:00',3.77),('8784','2013-08-22','13:40:00',3.73),('8784','2013-08-22','13:45:00',3.77),('8784','2013-08-22','13:50:00',3.78),('8784','2013-08-22','13:55:00',3.71),('8784','2013-08-22','14:00:00',3.72),('8784','2013-08-22','14:05:00',3.72),('8784','2013-08-22','14:10:00',3.69),('8784','2013-08-22','14:15:00',3.69),('8784','2013-08-22','14:20:00',3.69),('8784','2013-08-22','14:25:00',3.7),('8784','2013-08-22','14:30:00',3.38),('8784','2013-08-22','14:35:00',3.68),('8784','2013-08-22','14:40:00',3.66),('8784','2013-08-22','14:45:00',3.58),('8784','2013-08-22','14:50:00',3.57),('8784','2013-08-22','14:55:00',3.54),('8784','2013-08-22','15:00:00',3.49),('8784','2013-08-22','15:05:00',3.4),('8784','2013-08-22','15:10:00',3.4),('8784','2013-08-22','15:15:00',3.28),('8784','2013-08-22','15:20:00',3.29),('8784','2013-08-22','15:25:00',3.24),('8784','2013-08-22','15:30:00',3.16),('8784','2013-08-22','15:35:00',3.09),('8784','2013-08-22','15:40:00',3.07),('8784','2013-08-22','15:45:00',3.05),('8784','2013-08-22','15:50:00',3.02),('8784','2013-08-22','15:55:00',2.92),('8784','2013-08-22','16:00:00',2.83),('8784','2013-08-22','16:05:00',2.76),('8784','2013-08-22','16:10:00',2.7),('8784','2013-08-22','16:15:00',2.71),('8784','2013-08-22','16:20:00',2.62),('8784','2013-08-22','16:25:00',2.57),('8784','2013-08-22','16:30:00',2.5),('8784','2013-08-22','16:35:00',2.42),('8784','2013-08-22','16:40:00',2.37),('8784','2013-08-22','16:45:00',2.31),('8784','2013-08-22','16:50:00',2.22),('8784','2013-08-22','16:55:00',2.16),('8784','2013-08-22','17:00:00',2.1),('8784','2013-08-22','17:05:00',2),('8784','2013-08-22','17:10:00',1.93),('8784','2013-08-22','17:15:00',1.85),('8784','2013-08-22','17:20:00',1.77),('8784','2013-08-22','17:25:00',1.7),('8784','2013-08-22','17:30:00',1.62),('8784','2013-08-22','17:35:00',1.56),('8784','2013-08-22','17:40:00',1.48),('8784','2013-08-22','17:45:00',1.39),('8784','2013-08-22','17:50:00',1.3),('8784','2013-08-22','17:55:00',1.25),('8784','2013-08-22','18:00:00',1.19),('8784','2013-08-22','18:05:00',1.12),('8784','2013-08-22','18:10:00',1.09),('8784','2013-08-22','18:15:00',1.1),('8784','2013-08-21','09:05:00',1.46),('8784','2013-08-21','09:10:00',1.45),('8784','2013-08-21','09:15:00',2.59),('8784','2013-08-21','09:20:00',2.54),('8784','2013-08-21','09:25:00',1.27),('8784','2013-08-21','09:40:00',1.08),('8784','2013-08-21','09:45:00',1.33),('8784','2013-08-21','09:50:00',2.64),('8784','2013-08-21','09:55:00',3.66),('8784','2013-08-21','10:00:00',3.39),('8784','2013-08-21','10:05:00',2.67),('8784','2013-08-21','10:10:00',2.41),('8784','2013-08-21','10:15:00',2.17),('8784','2013-08-21','10:20:00',2.27),('8784','2013-08-21','10:25:00',1.76),('8784','2013-08-21','10:30:00',2.57),('8784','2013-08-21','10:35:00',3.11),('8784','2013-08-21','10:40:00',2.08),('8784','2013-08-21','10:45:00',2.22),('8784','2013-08-21','10:50:00',2.16),('8784','2013-08-21','10:55:00',1.83),('8784','2013-08-21','11:00:00',2.63),('8784','2013-08-21','11:05:00',2),('8784','2013-08-21','11:10:00',1.83),('8784','2013-08-21','11:15:00',2.21),('8784','2013-08-21','11:20:00',2.9),('8784','2013-08-21','11:25:00',2.57),('8784','2013-08-21','11:30:00',3.23),('8784','2013-08-21','11:35:00',4.41),('8784','2013-08-21','11:40:00',4.14),('8784','2013-08-21','11:45:00',4.1),('8784','2013-08-21','11:50:00',3.8),('8784','2013-08-21','11:55:00',3.77),('8784','2013-08-21','12:00:00',4.06),('8784','2013-08-21','12:05:00',4.03),('8784','2013-08-21','12:10:00',4.02),('8784','2013-08-21','12:15:00',4.06),('8784','2013-08-21','12:20:00',3.95),('8784','2013-08-21','12:25:00',2.69),('8784','2013-08-21','12:30:00',2.49),('8784','2013-08-21','12:35:00',2.03),('8784','2013-08-21','12:40:00',3.73),('8784','2013-08-21','12:45:00',3.94),('8784','2013-08-21','12:50:00',3.77),('8784','2013-08-21','12:55:00',3.72),('8784','2013-08-21','13:00:00',3.88),('8784','2013-08-21','13:05:00',3.92),('8784','2013-08-21','13:10:00',3.96),('8784','2013-08-21','13:15:00',4.02),('8784','2013-08-21','13:20:00',4.05),('8784','2013-08-21','13:25:00',4.04),('8784','2013-08-21','13:30:00',3.94),('8784','2013-08-21','13:35:00',3.9),('8784','2013-08-21','13:40:00',3.84),('8784','2013-08-21','13:45:00',3.97),('8784','2013-08-21','13:50:00',3.85),('8784','2013-08-21','13:55:00',3.68),('8784','2013-08-21','14:00:00',3.53),('8784','2013-08-21','14:05:00',3.69),('8784','2013-08-21','14:10:00',3.85),('8784','2013-08-21','14:15:00',2.81),('8784','2013-08-21','14:20:00',1.58),('8784','2013-08-21','14:25:00',2.01),('8784','2013-08-21','14:30:00',3.38),('8784','2013-08-21','14:35:00',3.46),('8784','2013-08-21','14:40:00',3.46),('8784','2013-08-21','14:45:00',3.38),('8784','2013-08-21','14:50:00',3.26),('8784','2013-08-21','14:55:00',3.34),('8784','2013-08-21','15:00:00',3.44),('8784','2013-08-21','15:05:00',3.4),('8784','2013-08-21','15:10:00',3.31),('8784','2013-08-21','15:15:00',3.25),('8784','2013-08-21','15:20:00',3.18),('8784','2013-08-21','15:25:00',3),('8784','2013-08-21','15:30:00',2.97),('8784','2013-08-21','15:35:00',2.83),('8784','2013-08-21','15:40:00',2.66),('8784','2013-08-21','15:45:00',2.67),('8784','2013-08-21','15:50:00',2.7),('8784','2013-08-21','15:55:00',2.71),('8784','2013-08-21','16:00:00',2.54),('8784','2013-08-21','16:05:00',2.4),('8784','2013-08-21','16:10:00',2.37),('8784','2013-08-21','16:15:00',2.39),('8784','2013-08-21','16:20:00',2.54),('8784','2013-08-21','16:25:00',2.52),('8784','2013-08-21','16:30:00',2.68),('8784','2013-08-21','16:35:00',2.64),('8784','2013-08-21','16:40:00',2.53),('8784','2013-08-21','16:45:00',2.44),('8784','2013-08-21','16:50:00',2.37),('8784','2013-08-21','16:55:00',2.3),('8784','2013-08-21','17:00:00',2.24),('8784','2013-08-21','17:05:00',2.16),('8784','2013-08-21','17:10:00',2.12),('8784','2013-08-21','17:15:00',2.08),('8784','2013-08-21','17:20:00',2.06),('8784','2013-08-21','17:25:00',1.99),('8784','2013-08-21','17:30:00',1.89),('8784','2013-08-21','17:35:00',1.83),('8784','2013-08-21','17:40:00',1.77),('8784','2013-08-21','17:45:00',1.7),('8784','2013-08-21','17:50:00',1.66),('8784','2013-08-21','17:55:00',1.59),('8784','2013-08-21','18:00:00',1.5),('8784','2013-08-21','18:05:00',1.38),('8784','2013-08-21','18:10:00',1.27),('8784','2013-08-21','18:15:00',1.2),('8784','2013-08-21','18:20:00',1.09),('8784','2013-08-20','07:55:00',1.15),('8784','2013-08-20','08:00:00',1.01),('8784','2013-08-20','08:50:00',1.01),('8784','2013-08-20','08:55:00',1.17),('8784','2013-08-20','09:00:00',1.05),('8784','2013-08-20','09:05:00',1.02),('8784','2013-08-20','09:20:00',1.27),('8784','2013-08-20','09:25:00',2.03),('8784','2013-08-20','09:30:00',2.62),('8784','2013-08-20','09:35:00',2.98),('8784','2013-08-20','09:40:00',2.87),('8784','2013-08-20','09:45:00',2.28),('8784','2013-08-20','09:50:00',2.11),('8784','2013-08-20','09:55:00',3.23),('8784','2013-08-20','10:00:00',2.18),('8784','2013-08-20','10:05:00',1.66),('8784','2013-08-20','10:10:00',1.58),('8784','2013-08-20','10:15:00',2.93),('8784','2013-08-20','10:20:00',1.63),('8784','2013-08-20','10:25:00',1.06),('8784','2013-08-20','10:30:00',1.1),('8784','2013-08-20','10:35:00',1.09),('8784','2013-08-20','10:40:00',1.57),('8784','2013-08-20','10:45:00',3.34),('8784','2013-08-20','10:50:00',3.54),('8784','2013-08-20','10:55:00',1.63),('8784','2013-08-20','11:00:00',1.03),('8784','2013-08-20','11:10:00',2.35),('8784','2013-08-20','11:15:00',4.01),('8784','2013-08-20','11:20:00',4.01),('8784','2013-08-20','11:25:00',2.94),('8784','2013-08-20','11:30:00',1.79),('8784','2013-08-20','11:35:00',4.06),('8784','2013-08-20','11:40:00',4.22),('8784','2013-08-20','11:45:00',4.3),('8784','2013-08-20','11:50:00',4.64),('8784','2013-08-20','11:55:00',3.11),('8784','2013-08-20','12:00:00',2.27),('8784','2013-08-20','12:05:00',1.9),('8784','2013-08-20','12:10:00',1.48),('8784','2013-08-20','12:25:00',1.24),('8784','2013-08-20','12:30:00',1.61),('8784','2013-08-20','12:35:00',1.79),('8784','2013-08-20','12:40:00',1.9),('8784','2013-08-20','12:45:00',1.84),('8784','2013-08-20','12:50:00',1.85),('8784','2013-08-20','12:55:00',1.97),('8784','2013-08-20','13:00:00',1.95),('8784','2013-08-20','13:05:00',1.79),('8784','2013-08-20','13:10:00',1.75),('8784','2013-08-20','13:15:00',1.77),('8784','2013-08-20','13:20:00',1.8),('8784','2013-08-20','13:25:00',1.9),('8784','2013-08-20','13:30:00',2.1),('8784','2013-08-20','13:35:00',2.82),('8784','2013-08-20','13:40:00',4.45),('8784','2013-08-20','13:45:00',3.53),('8784','2013-08-20','13:50:00',4.35),('8784','2013-08-20','13:55:00',4.18),('8784','2013-08-20','14:00:00',4.14),('8784','2013-08-20','14:05:00',4.06),('8784','2013-08-20','14:10:00',3.42),('8784','2013-08-20','14:15:00',4.02),('8784','2013-08-20','14:20:00',4.02),('8784','2013-08-20','14:25:00',3.43),('8784','2013-08-20','14:30:00',3.75),('8784','2013-08-20','14:35:00',4.26),('8784','2013-08-20','14:40:00',4.08),('8784','2013-08-20','14:45:00',3.81),('8784','2013-08-20','14:50:00',3.95),('8784','2013-08-20','14:55:00',3.83),('8784','2013-08-20','15:00:00',3.69),('8784','2013-08-20','15:05:00',4),('8784','2013-08-20','15:10:00',3.89),('8784','2013-08-20','15:15:00',3.86),('8784','2013-08-20','15:20:00',3.74),('8784','2013-08-20','15:25:00',3.73),('8784','2013-08-20','15:30:00',3.74),('8784','2013-08-20','15:35:00',3.69),('8784','2013-08-20','15:40:00',3.78),('8784','2013-08-20','15:45:00',3.89),('8784','2013-08-20','15:50:00',4.04),('8784','2013-08-20','15:55:00',4.09),('8784','2013-08-20','16:00:00',3.87),('8784','2013-08-20','16:05:00',3.76),('8784','2013-08-20','16:10:00',3.69),('8784','2013-08-20','16:15:00',3.64),('8784','2013-08-20','16:20:00',3.6),('8784','2013-08-20','16:25:00',3.51),('8784','2013-08-20','16:30:00',3.26),('8784','2013-08-20','16:35:00',3.24),('8784','2013-08-20','16:40:00',3.25),('8784','2013-08-20','16:45:00',3.11),('8784','2013-08-20','16:50:00',2.93),('8784','2013-08-20','16:55:00',2.7),('8784','2013-08-20','17:00:00',2.51),('8784','2013-08-20','17:05:00',2.36),('8784','2013-08-20','17:10:00',2.27),('8784','2013-08-20','17:15:00',2.14),('8784','2013-08-20','17:20:00',2.07),('8784','2013-08-20','17:25:00',1.98),('8784','2013-08-20','17:30:00',1.92),('8784','2013-08-20','17:35:00',1.85),('8784','2013-08-20','17:40:00',1.77),('8784','2013-08-20','17:45:00',1.65),('8784','2013-08-20','17:50:00',1.5),('8784','2013-08-20','17:55:00',1.38),('8784','2013-08-20','18:00:00',1.25),('8784','2013-08-20','18:05:00',1.22),('8784','2013-08-20','18:10:00',1.26),('8784','2013-08-20','18:15:00',1.25),('8784','2013-08-20','18:20:00',1.19),('8784','2013-08-20','18:25:00',1.14),('8784','2013-08-20','18:30:00',1.15),('8784','2013-08-20','18:35:00',1.03),('8784','2014-04-10','07:55:00',1),('8784','2014-04-10','08:00:00',1.08),('8784','2014-04-10','08:05:00',1.18),('8784','2014-04-10','08:10:00',1.27),('8784','2014-04-10','08:15:00',1.36),('8784','2014-04-10','08:20:00',1.46),('8784','2014-04-10','08:25:00',1.55),('8784','2014-04-10','08:30:00',1.65),('8784','2014-04-10','08:35:00',1.76),('8784','2014-04-10','08:40:00',1.86),('8784','2014-04-10','08:45:00',1.96),('8784','2014-04-10','08:50:00',2.05),('8784','2014-04-10','08:55:00',2.13),('8784','2014-04-10','09:00:00',2.18),('8784','2014-04-10','09:05:00',2.32),('8784','2014-04-10','09:10:00',2.38),('8784','2014-04-10','09:15:00',2.42),('8784','2014-04-10','09:20:00',2.45),('8784','2014-04-10','09:25:00',2.6),('8784','2014-04-10','09:30:00',2.72),('8784','2014-04-10','09:35:00',2.8),('8784','2014-04-10','09:40:00',2.86),('8784','2014-04-10','09:45:00',2.92),('8784','2014-04-10','09:50:00',3.01),('8784','2014-04-10','09:55:00',3.1),('8784','2014-04-10','10:00:00',3.15),('8784','2014-04-10','10:05:00',3.2),('8784','2014-04-10','10:10:00',3.3),('8784','2014-04-10','10:15:00',3.3),('8784','2014-04-10','10:20:00',3.38),('8784','2014-04-10','10:25:00',3.44),('8784','2014-04-10','10:30:00',3.46),('8784','2014-04-10','10:35:00',3.59),('8784','2014-04-10','10:40:00',3.66),('8784','2014-04-10','10:45:00',3.67),('8784','2014-04-10','10:50:00',3.57),('8784','2014-04-10','10:55:00',3.69),('8784','2014-04-10','11:00:00',3.73),('8784','2014-04-10','11:05:00',3.87),('8784','2014-04-10','11:10:00',3.79),('8784','2014-04-10','11:15:00',3.95),('8784','2014-04-10','11:20:00',4.05),('8784','2014-04-10','11:25:00',4.11),('8784','2014-04-10','11:30:00',4.12),('8784','2014-04-10','11:35:00',4.19),('8784','2014-04-10','11:40:00',4.04),('8784','2014-04-10','11:45:00',4.17),('8784','2014-04-10','11:50:00',4.03),('8784','2014-04-10','11:55:00',4.23),('8784','2014-04-10','12:00:00',4.14),('8784','2014-04-10','12:05:00',3.93),('8784','2014-04-10','12:10:00',4.08),('8784','2014-04-10','12:15:00',4.16),('8784','2014-04-10','12:20:00',4.21),('8784','2014-04-10','12:25:00',3.99),('8784','2014-04-10','12:30:00',4.07),('8784','2014-04-10','12:35:00',4.31),('8784','2014-04-10','12:40:00',4.15),('8784','2014-04-10','12:45:00',4.26),('8784','2014-04-10','12:50:00',4.22),('8784','2014-04-10','12:55:00',4.18),('8784','2014-04-10','13:00:00',4.11),('8784','2014-04-10','13:05:00',3.95),('8784','2014-04-10','13:10:00',4.1),('8784','2014-04-10','13:15:00',4.06),('8784','2014-04-10','13:20:00',3.95),('8784','2014-04-10','13:25:00',4.27),('8784','2014-04-10','13:30:00',4.24),('8784','2014-04-10','13:35:00',4.31),('8784','2014-04-10','13:40:00',4.05),('8784','2014-04-10','13:45:00',4.3),('8784','2014-04-10','13:50:00',4.29),('8784','2014-04-10','13:55:00',4.25),('8784','2014-04-10','14:00:00',4.21),('8784','2014-04-10','14:05:00',4.13),('8784','2014-04-10','14:10:00',4.12),('8784','2014-04-10','14:15:00',4.11),('8784','2014-04-10','14:20:00',4.14),('8784','2014-04-10','14:25:00',4.08),('8784','2014-04-10','14:30:00',4.04),('8784','2014-04-10','14:35:00',4.01),('8784','2014-04-10','14:40:00',3.96),('8784','2014-04-10','14:45:00',3.56),('8784','2014-04-10','14:50:00',3.98),('8784','2014-04-10','14:55:00',3.91),('8784','2014-04-10','15:00:00',3.88),('8784','2014-04-10','15:05:00',3.83),('8784','2014-04-10','15:10:00',3.7),('8784','2014-04-10','15:15:00',3.71),('8784','2014-04-10','15:20:00',3.67),('8784','2014-04-10','15:25:00',3.6),('8784','2014-04-10','15:30:00',3.31),('8784','2014-04-10','15:35:00',3.13),('8784','2014-04-10','15:40:00',3.2),('8784','2014-04-10','15:45:00',3.23),('8784','2014-04-10','15:50:00',3.23),('8784','2014-04-10','15:55:00',3.18),('8784','2014-04-10','16:00:00',3.1),('8784','2014-04-10','16:05:00',3.14),('8784','2014-04-10','16:10:00',3.15),('8784','2014-04-10','16:15:00',3.19),('8784','2014-04-10','16:20:00',3.05),('8784','2014-04-10','16:25:00',3.01),('8784','2014-04-10','16:30:00',2.97),('8784','2014-04-10','16:35:00',2.83),('8784','2014-04-10','16:40:00',2.79),('8784','2014-04-10','16:45:00',2.77),('8784','2014-04-10','16:50:00',2.57),('8784','2014-04-10','16:55:00',2.51),('8784','2014-04-10','17:00:00',2.4),('8784','2014-04-10','17:05:00',2.32),('8784','2014-04-10','17:10:00',2.2),('8784','2014-04-10','17:15:00',2.07),('8784','2014-04-10','17:20:00',2.01),('8784','2014-04-10','17:25:00',1.9),('8784','2014-04-10','17:30:00',1.79),('8784','2014-04-10','17:35:00',1.69),('8784','2014-04-10','17:40:00',1.58),('8784','2014-04-10','17:45:00',1.49),('8784','2014-04-10','17:50:00',1.39),('8784','2014-04-10','17:55:00',1.3),('8784','2014-04-10','18:00:00',1.21),('8784','2014-04-10','18:05:00',1.12),('8784','2014-04-10','18:10:00',1.03),('8784','2013-08-19','07:55:00',1.01),('8784','2013-08-19','08:00:00',1.08),('8784','2013-08-19','08:05:00',1.17),('8784','2013-08-19','08:10:00',1.24),('8784','2013-08-19','08:15:00',1.32),('8784','2013-08-19','08:20:00',1.32),('8784','2013-08-19','08:25:00',1.41),('8784','2013-08-19','08:30:00',1.48),('8784','2013-08-19','08:35:00',1.59),('8784','2013-08-19','08:40:00',1.68),('8784','2013-08-19','08:45:00',1.78),('8784','2013-08-19','08:50:00',1.88),('8784','2013-08-19','08:55:00',1.97),('8784','2013-08-19','09:00:00',2.05),('8784','2013-08-19','09:05:00',2.11),('8784','2013-08-19','09:10:00',2.16),('8784','2013-08-19','09:15:00',2.27),('8784','2013-08-19','09:20:00',2.35),('8784','2013-08-19','09:25:00',2.46),('8784','2013-08-19','09:30:00',2.53),('8784','2013-08-19','09:35:00',2.57),('8784','2013-08-19','09:40:00',2.61),('8784','2013-08-19','09:45:00',2.7),('8784','2013-08-19','09:50:00',2.79),('8784','2013-08-19','09:55:00',2.84),('8784','2013-08-19','10:00:00',2.9),('8784','2013-08-19','10:05:00',2.95),('8784','2013-08-19','10:10:00',3),('8784','2013-08-19','10:15:00',3.07),('8784','2013-08-19','10:20:00',3.1),('8784','2013-08-19','10:25:00',3.13),('8784','2013-08-19','10:30:00',3.21),('8784','2013-08-19','10:35:00',3.21),('8784','2013-08-19','10:40:00',3.24),('8784','2013-08-19','10:45:00',3.33),('8784','2013-08-19','10:50:00',3.38),('8784','2013-08-19','10:55:00',3.43),('8784','2013-08-19','11:00:00',3.4),('8784','2013-08-19','11:05:00',3.47),('8784','2013-08-19','11:10:00',3.54),('8784','2013-08-19','11:15:00',3.58),('8784','2013-08-19','11:20:00',3.61),('8784','2013-08-19','11:25:00',3.6),('8784','2013-08-19','11:30:00',3.64),('8784','2013-08-19','11:35:00',3.7),('8784','2013-08-19','11:40:00',3.7),('8784','2013-08-19','11:45:00',3.7),('8784','2013-08-19','11:50:00',3.67),('8784','2013-08-19','11:55:00',3.68),('8784','2013-08-19','12:00:00',3.73),('8784','2013-08-19','12:05:00',3.79),('8784','2013-08-19','12:10:00',3.81),('8784','2013-08-19','12:15:00',3.87),('8784','2013-08-19','12:20:00',3.86),('8784','2013-08-19','12:25:00',3.89),('8784','2013-08-19','12:30:00',3.91),('8784','2013-08-19','12:35:00',3.91),('8784','2013-08-19','12:40:00',3.95),('8784','2013-08-19','12:45:00',3.98),('8784','2013-08-19','12:50:00',3.96),('8784','2013-08-19','12:55:00',4.01),('8784','2013-08-19','13:00:00',4),('8784','2013-08-19','13:05:00',4.01),('8784','2013-08-19','13:10:00',4),('8784','2013-08-19','13:15:00',4),('8784','2013-08-19','13:20:00',4.03),('8784','2013-08-19','13:25:00',3.97),('8784','2013-08-19','13:30:00',3.95),('8784','2013-08-19','13:35:00',3.96),('8784','2013-08-19','13:40:00',4),('8784','2013-08-19','13:45:00',4.02),('8784','2013-08-19','13:50:00',4),('8784','2013-08-19','13:55:00',3.98),('8784','2013-08-19','14:00:00',3.94),('8784','2013-08-19','14:05:00',3.91),('8784','2013-08-19','14:10:00',3.94),('8784','2013-08-19','14:15:00',3.91),('8784','2013-08-19','14:20:00',3.89),('8784','2013-08-19','14:25:00',3.84),('8784','2013-08-19','14:30:00',3.84),('8784','2013-08-19','14:35:00',3.83),('8784','2013-08-19','14:40:00',3.81),('8784','2013-08-19','14:45:00',3.8),('8784','2013-08-19','14:50:00',3.77),('8784','2013-08-19','14:55:00',3.73),('8784','2013-08-19','15:00:00',3.68),('8784','2013-08-19','15:05:00',3.65),('8784','2013-08-19','15:10:00',3.63),('8784','2013-08-19','15:15:00',3.58),('8784','2013-08-19','15:20:00',3.56),('8784','2013-08-19','15:25:00',3.48),('8784','2013-08-19','15:30:00',3.44),('8784','2013-08-19','15:35:00',3.42),('8784','2013-08-19','15:40:00',3.34),('8784','2013-08-19','15:45:00',3.27),('8784','2013-08-19','15:50:00',3.24),('8784','2013-08-19','15:55:00',3.19),('8784','2013-08-19','16:00:00',3.13),('8784','2013-08-19','16:05:00',3.09),('8784','2013-08-19','16:10:00',3.02),('8784','2013-08-19','16:15:00',2.97),('8784','2013-08-19','16:20:00',2.9),('8784','2013-08-19','16:25:00',2.76),('8784','2013-08-19','16:30:00',2.72),('8784','2013-08-19','16:35:00',2.66),('8784','2013-08-19','16:40:00',2.6),('8784','2013-08-19','16:45:00',2.54),('8784','2013-08-19','16:50:00',2.46),('8784','2013-08-19','16:55:00',2.4),('8784','2013-08-19','17:00:00',2.3),('8784','2013-08-19','17:05:00',2.24),('8784','2013-08-19','17:10:00',2.13),('8784','2013-08-19','17:15:00',2.08),('8784','2013-08-19','17:20:00',2.01),('8784','2013-08-19','17:25:00',1.92),('8784','2013-08-19','17:30:00',1.85),('8784','2013-08-19','17:35:00',1.77),('8784','2013-08-19','17:40:00',1.7),('8784','2013-08-19','17:45:00',1.61),('8784','2013-08-19','17:50:00',1.51),('8784','2013-08-19','17:55:00',1.42),('8784','2013-08-19','18:00:00',1.36),('8784','2013-08-19','18:05:00',1.3),('8784','2013-08-19','18:10:00',1.15),('8784','2013-08-19','18:15:00',1.11),('8784','2013-08-19','18:20:00',1.04),('8784','2013-08-18','07:55:00',1.03),('8784','2013-08-18','08:00:00',1.14),('8784','2013-08-18','08:05:00',1.22),('8784','2013-08-18','08:10:00',1.3),('8784','2013-08-18','08:15:00',1.39),('8784','2013-08-18','08:20:00',1.48),('8784','2013-08-18','08:25:00',1.47),('8784','2013-08-18','08:30:00',1.59),('8784','2013-08-18','08:35:00',1.71),('8784','2013-08-18','08:40:00',1.7),('8784','2013-08-18','08:45:00',1.82),('8784','2013-08-18','08:50:00',1.9),('8784','2013-08-18','08:55:00',1.98),('8784','2013-08-18','09:00:00',2.03),('8784','2013-08-18','09:05:00',2.13),('8784','2013-08-18','09:10:00',2.21),('8784','2013-08-18','09:15:00',2.31),('8784','2013-08-18','09:20:00',2.38),('8784','2013-08-18','09:25:00',2.48),('8784','2013-08-18','09:30:00',2.51),('8784','2013-08-18','09:35:00',2.64),('8784','2013-08-18','09:40:00',2.7),('8784','2013-08-18','09:45:00',2.57),('8784','2013-08-18','09:50:00',2.7),('8784','2013-08-18','09:55:00',1.27),('8784','2013-08-18','10:00:00',2.8),('8784','2013-08-18','10:05:00',2.4),('8784','2013-08-18','10:10:00',2.99),('8784','2013-08-18','10:15:00',3.1),('8784','2013-08-18','10:20:00',3.13),('8784','2013-08-18','10:25:00',3.18),('8784','2013-08-18','10:30:00',3.22),('8784','2013-08-18','10:35:00',3.26),('8784','2013-08-18','10:40:00',3.28),('8784','2013-08-18','10:45:00',3.27),('8784','2013-08-18','10:50:00',3.36),('8784','2013-08-18','10:55:00',3.34),('8784','2013-08-18','11:00:00',3.44),('8784','2013-08-18','11:05:00',3.51),('8784','2013-08-18','11:10:00',3.52),('8784','2013-08-18','11:15:00',3.57),('8784','2013-08-18','11:20:00',3.56),('8784','2013-08-18','11:25:00',3.59),('8784','2013-08-18','11:30:00',3.63),('8784','2013-08-18','11:35:00',3.67),('8784','2013-08-18','11:40:00',3.7),('8784','2013-08-18','11:45:00',3.72),('8784','2013-08-18','11:50:00',3.72),('8784','2013-08-18','11:55:00',3.73),('8784','2013-08-18','12:00:00',3.8),('8784','2013-08-18','12:05:00',3.82),('8784','2013-08-18','12:10:00',3.92),('8784','2013-08-18','12:15:00',4),('8784','2013-08-18','12:20:00',3.99),('8784','2013-08-18','12:25:00',3.96),('8784','2013-08-18','12:30:00',1.98),('8784','2013-08-18','12:45:00',1.76),('8784','2013-08-18','12:50:00',1.96),('8784','2013-08-18','12:55:00',1.15),('8784','2013-08-18','13:00:00',3.23),('8784','2013-08-18','13:05:00',4.16),('8784','2013-08-18','13:10:00',4.08),('8784','2013-08-18','13:15:00',4.09),('8784','2013-08-18','13:20:00',4.1),('8784','2013-08-18','13:25:00',4),('8784','2013-08-18','13:30:00',3.99),('8784','2013-08-18','13:35:00',3.99),('8784','2013-08-18','13:40:00',4.03),('8784','2013-08-18','13:45:00',4),('8784','2013-08-18','13:50:00',3.92),('8784','2013-08-18','13:55:00',3.9),('8784','2013-08-18','14:00:00',3.99),('8784','2013-08-18','14:05:00',3.94),('8784','2013-08-18','14:10:00',3.93),('8784','2013-08-18','14:15:00',3.91),('8784','2013-08-18','14:20:00',3.87),('8784','2013-08-18','14:25:00',3.86),('8784','2013-08-18','14:30:00',3.85),('8784','2013-08-18','14:35:00',3.84),('8784','2013-08-18','14:40:00',3.77),('8784','2013-08-18','14:45:00',3.73),('8784','2013-08-18','14:50:00',3.68),('8784','2013-08-18','14:55:00',3.65),('8784','2013-08-18','15:00:00',3.69),('8784','2013-08-18','15:05:00',3.65),('8784','2013-08-18','15:10:00',3.63),('8784','2013-08-18','15:15:00',3.55),('8784','2013-08-18','15:20:00',3.5),('8784','2013-08-18','15:25:00',3.47),('8784','2013-08-18','15:30:00',3.43),('8784','2013-08-18','15:35:00',3.37),('8784','2013-08-18','15:40:00',3.35),('8784','2013-08-18','15:45:00',3.29),('8784','2013-08-18','15:50:00',3.23),('8784','2013-08-18','15:55:00',3.17),('8784','2013-08-18','16:00:00',3.11),('8784','2013-08-18','16:05:00',3.05),('8784','2013-08-18','16:10:00',3.01),('8784','2013-08-18','16:15:00',2.94),('8784','2013-08-18','16:20:00',2.86),('8784','2013-08-18','16:25:00',2.82),('8784','2013-08-18','16:30:00',2.76),('8784','2013-08-18','16:35:00',2.69),('8784','2013-08-18','16:40:00',2.62),('8784','2013-08-18','16:45:00',2.56),('8784','2013-08-18','16:50:00',2.47),('8784','2013-08-18','16:55:00',2.41),('8784','2013-08-18','17:00:00',2.34),('8784','2013-08-18','17:05:00',2.27),('8784','2013-08-18','17:10:00',2.2),('8784','2013-08-18','17:15:00',2.12),('8784','2013-08-18','17:20:00',2.04),('8784','2013-08-18','17:25:00',1.97),('8784','2013-08-18','17:30:00',1.89),('8784','2013-08-18','17:35:00',1.8),('8784','2013-08-18','17:40:00',1.72),('8784','2013-08-18','17:45:00',1.63),('8784','2013-08-18','17:50:00',1.55),('8784','2013-08-18','17:55:00',1.46),('8784','2013-08-18','18:00:00',1.38),('8784','2013-08-18','18:05:00',1.3),('8784','2013-08-18','18:10:00',1.22),('8784','2013-08-18','18:15:00',1.15),('8784','2013-08-18','18:20:00',1.07),('8784','2013-08-17','07:55:00',1.05),('8784','2013-08-17','08:00:00',1.11),('8784','2013-08-17','08:05:00',1.17),('8784','2013-08-17','08:10:00',1.26),('8784','2013-08-17','08:15:00',1.28),('8784','2013-08-17','08:20:00',1.4),('8784','2013-08-17','08:25:00',1.5),('8784','2013-08-17','08:30:00',1.58),('8784','2013-08-17','08:35:00',1.69),('8784','2013-08-17','08:40:00',1.75),('8784','2013-08-17','08:45:00',1.79),('8784','2013-08-17','08:50:00',1.88),('8784','2013-08-17','08:55:00',1.93),('8784','2013-08-17','09:00:00',2.08),('8784','2013-08-17','09:05:00',2.17),('8784','2013-08-17','09:10:00',2.2),('8784','2013-08-17','09:15:00',2.31),('8784','2013-08-17','09:20:00',2.36),('8784','2013-08-17','09:25:00',2.45),('8784','2013-08-17','09:30:00',2.53),('8784','2013-08-17','09:35:00',2.61),('8784','2013-08-17','09:40:00',2.66),('8784','2013-08-17','09:45:00',2.71),('8784','2013-08-17','09:50:00',2.8),('8784','2013-08-17','09:55:00',2.88),('8784','2013-08-17','10:00:00',2.94),('8784','2013-08-17','10:05:00',3),('8784','2013-08-17','10:10:00',3.06),('8784','2013-08-17','10:15:00',3.11),('8784','2013-08-17','10:20:00',3.16),('8784','2013-08-17','10:25:00',3.22),('8784','2013-08-17','10:30:00',3.2),('8784','2013-08-17','10:35:00',3.29),('8784','2013-08-17','10:40:00',3.34),('8784','2013-08-17','10:45:00',3.39),('8784','2013-08-17','10:50:00',3.43),('8784','2013-08-17','10:55:00',3.46),('8784','2013-08-17','11:00:00',3.5),('8784','2013-08-17','11:05:00',3.55),('8784','2013-08-17','11:10:00',3.57),('8784','2013-08-17','11:15:00',3.59),('8784','2013-08-17','11:20:00',3.65),('8784','2013-08-17','11:25:00',3.68),('8784','2013-08-17','11:30:00',3.67),('8784','2013-08-17','11:35:00',3.7),('8784','2013-08-17','11:40:00',3.75),('8784','2013-08-17','11:45:00',3.78),('8784','2013-08-17','11:50:00',3.74),('8784','2013-08-17','11:55:00',3.65),('8784','2013-08-17','12:00:00',3.68),('8784','2013-08-17','12:05:00',3.89),('8784','2013-08-17','12:10:00',3.82),('8784','2013-08-17','12:15:00',3.77),('8784','2013-08-17','12:20:00',3.81),('8784','2013-08-17','12:25:00',3.97),('8784','2013-08-17','12:30:00',3.98),('8784','2013-08-17','12:35:00',4.01),('8784','2013-08-17','12:40:00',3.7),('8784','2013-08-17','12:45:00',3.93),('8784','2013-08-17','12:50:00',4),('8784','2013-08-17','12:55:00',4.01),('8784','2013-08-17','13:00:00',4.09),('8784','2013-08-17','13:05:00',3.97),('8784','2013-08-17','13:10:00',2.28),('8784','2013-08-17','13:15:00',4),('8784','2013-08-17','13:20:00',4.1),('8784','2013-08-17','13:25:00',4.19),('8784','2013-08-17','13:30:00',4.17),('8784','2013-08-17','13:35:00',4.11),('8784','2013-08-17','13:40:00',1.33),('8784','2013-08-17','13:45:00',3.52),('8784','2013-08-17','13:50:00',2.02),('8784','2013-08-17','13:55:00',2.61),('8784','2013-08-17','14:00:00',2.56),('8784','2013-08-17','14:05:00',3.85),('8784','2013-08-17','14:10:00',3.83),('8784','2013-08-17','14:15:00',3.75),('8784','2013-08-17','14:20:00',3.88),('8784','2013-08-17','14:25:00',3.88),('8784','2013-08-17','14:30:00',3.55),('8784','2013-08-17','14:35:00',3.83),('8784','2013-08-17','14:40:00',3.74),('8784','2013-08-17','14:45:00',3.76),('8784','2013-08-17','14:50:00',3.75),('8784','2013-08-17','14:55:00',3.67),('8784','2013-08-17','15:00:00',3.65),('8784','2013-08-17','15:05:00',3.64),('8784','2013-08-17','15:10:00',3.57),('8784','2013-08-17','15:15:00',3.52),('8784','2013-08-17','15:20:00',3.49),('8784','2013-08-17','15:25:00',3.48),('8784','2013-08-17','15:30:00',3.43),('8784','2013-08-17','15:35:00',3.4),('8784','2013-08-17','15:40:00',3.35),('8784','2013-08-17','15:45:00',3.31),('8784','2013-08-17','15:50:00',3.26),('8784','2013-08-17','15:55:00',3.19),('8784','2013-08-17','16:00:00',3.14),('8784','2013-08-17','16:05:00',3.07),('8784','2013-08-17','16:10:00',3),('8784','2013-08-17','16:15:00',2.96),('8784','2013-08-17','16:20:00',2.87),('8784','2013-08-17','16:25:00',2.82),('8784','2013-08-17','16:30:00',2.78),('8784','2013-08-17','16:35:00',2.72),('8784','2013-08-17','16:40:00',2.67),('8784','2013-08-17','16:45:00',2.56),('8784','2013-08-17','16:50:00',2.48),('8784','2013-08-17','16:55:00',2.44),('8784','2013-08-17','17:00:00',2.4),('8784','2013-08-17','17:05:00',2.28),('8784','2013-08-17','17:10:00',2.14),('8784','2013-08-17','17:15:00',1.97),('8784','2013-08-17','17:20:00',2),('8784','2013-08-17','17:25:00',2.05),('8784','2013-08-17','17:30:00',2),('8784','2013-08-17','17:35:00',1.91),('8784','2013-08-17','17:40:00',1.82),('8784','2013-08-17','17:45:00',1.75),('8784','2013-08-17','17:50:00',1.65),('8784','2013-08-17','17:55:00',1.57),('8784','2013-08-17','18:00:00',1.45),('8784','2013-08-17','18:05:00',1.35),('8784','2013-08-17','18:10:00',1.3),('8784','2013-08-17','18:15:00',1.22),('8784','2013-08-17','18:20:00',1.13),('8784','2013-08-17','18:25:00',1.04),('8784','2013-08-16','07:55:00',1.07),('8784','2013-08-16','08:00:00',1.13),('8784','2013-08-16','08:05:00',1.23),('8784','2013-08-16','08:10:00',1.32),('8784','2013-08-16','08:15:00',1.4),('8784','2013-08-16','08:20:00',1.5),('8784','2013-08-16','08:25:00',1.58),('8784','2013-08-16','08:30:00',1.67),('8784','2013-08-16','08:35:00',1.76),('8784','2013-08-16','08:40:00',1.84),('8784','2013-08-16','08:45:00',1.92),('8784','2013-08-16','08:50:00',1.99),('8784','2013-08-16','08:55:00',2.06),('8784','2013-08-16','09:00:00',2.09),('8784','2013-08-16','09:05:00',2.16),('8784','2013-08-16','09:10:00',2.26),('8784','2013-08-16','09:15:00',2.37),('8784','2013-08-16','09:20:00',2.48),('8784','2013-08-16','09:25:00',2.51),('8784','2013-08-16','09:30:00',2.62),('8784','2013-08-16','09:35:00',2.72),('8784','2013-08-16','09:40:00',2.79),('8784','2013-08-16','09:45:00',2.83),('8784','2013-08-16','09:50:00',2.89),('8784','2013-08-16','09:55:00',2.94),('8784','2013-08-16','10:00:00',3.01),('8784','2013-08-16','10:05:00',3.09),('8784','2013-08-16','10:10:00',3.16),('8784','2013-08-16','10:15:00',3.22),('8784','2013-08-16','10:20:00',3.28),('8784','2013-08-16','10:25:00',3.34),('8784','2013-08-16','10:30:00',3.38),('8784','2013-08-16','10:35:00',3.42),('8784','2013-08-16','10:40:00',3.47),('8784','2013-08-16','10:45:00',3.5),('8784','2013-08-16','10:50:00',3.57),('8784','2013-08-16','10:55:00',3.61),('8784','2013-08-16','11:00:00',3.65),('8784','2013-08-16','11:05:00',3.68),('8784','2013-08-16','11:10:00',3.72),('8784','2013-08-16','11:15:00',3.75),('8784','2013-08-16','11:20:00',3.78),('8784','2013-08-16','11:25:00',3.8),('8784','2013-08-16','11:30:00',3.8),('8784','2013-08-16','11:35:00',3.85),('8784','2013-08-16','11:40:00',3.87),('8784','2013-08-16','11:45:00',3.89),('8784','2013-08-16','11:50:00',3.89),('8784','2013-08-16','11:55:00',3.9),('8784','2013-08-16','12:00:00',3.92),('8784','2013-08-16','12:05:00',3.98),('8784','2013-08-16','12:10:00',3.99),('8784','2013-08-16','12:15:00',4),('8784','2013-08-16','12:20:00',4.01),('8784','2013-08-16','12:25:00',4.01),('8784','2013-08-16','12:30:00',4),('8784','2013-08-16','12:35:00',4.05),('8784','2013-08-16','12:40:00',4.03),('8784','2013-08-16','12:45:00',4.04),('8784','2013-08-16','12:50:00',4.06),('8784','2013-08-16','12:55:00',4.05),('8784','2013-08-16','13:00:00',4.05),('8784','2013-08-16','13:05:00',4.04),('8784','2013-08-16','13:10:00',4.03),('8784','2013-08-16','13:15:00',4.01),('8784','2013-08-16','13:20:00',4),('8784','2013-08-16','13:25:00',4),('8784','2013-08-16','13:30:00',3.99),('8784','2013-08-16','13:35:00',3.98),('8784','2013-08-16','13:40:00',3.92),('8784','2013-08-16','13:45:00',3.88),('8784','2013-08-16','13:50:00',3.94),('8784','2013-08-16','13:55:00',3.94),('8784','2013-08-16','14:00:00',3.92),('8784','2013-08-16','14:05:00',3.86),('8784','2013-08-16','14:10:00',3.85),('8784','2013-08-16','14:15:00',3.82),('8784','2013-08-16','14:20:00',3.83),('8784','2013-08-16','14:25:00',3.79),('8784','2013-08-16','14:30:00',3.74),('8784','2013-08-16','14:35:00',3.71),('8784','2013-08-16','14:40:00',3.74),('8784','2013-08-16','14:45:00',3.72),('8784','2013-08-16','14:50:00',3.67),('8784','2013-08-16','14:55:00',3.62),('8784','2013-08-16','15:00:00',3.57),('8784','2013-08-16','15:05:00',3.51),('8784','2013-08-16','15:10:00',3.52),('8784','2013-08-16','15:15:00',3.49),('8784','2013-08-16','15:20:00',3.5),('8784','2013-08-16','15:25:00',3.47),('8784','2013-08-16','15:30:00',3.42),('8784','2013-08-16','15:35:00',3.38),('8784','2013-08-16','15:40:00',3.33),('8784','2013-08-16','15:45:00',3.29),('8784','2013-08-16','15:50:00',3.25),('8784','2013-08-16','15:55:00',3.2),('8784','2013-08-16','16:00:00',3.15),('8784','2013-08-16','16:05:00',3.08),('8784','2013-08-16','16:10:00',3.03),('8784','2013-08-16','16:15:00',2.97),('8784','2013-08-16','16:20:00',2.9),('8784','2013-08-16','16:25:00',2.84),('8784','2013-08-16','16:30:00',2.79),('8784','2013-08-16','16:35:00',2.73),('8784','2013-08-16','16:40:00',2.66),('8784','2013-08-16','16:45:00',2.59),('8784','2013-08-16','16:50:00',2.52),('8784','2013-08-16','16:55:00',2.44),('8784','2013-08-16','17:00:00',2.36),('8784','2013-08-16','17:05:00',2.3),('8784','2013-08-16','17:10:00',2.22),('8784','2013-08-16','17:15:00',2.14),('8784','2013-08-16','17:20:00',2.03),('8784','2013-08-16','17:25:00',1.97),('8784','2013-08-16','17:30:00',1.89),('8784','2013-08-16','17:35:00',1.81),('8784','2013-08-16','17:40:00',1.73),('8784','2013-08-16','17:45:00',1.65),('8784','2013-08-16','17:50:00',1.57),('8784','2013-08-16','17:55:00',1.48),('8784','2013-08-16','18:00:00',1.39),('8784','2013-08-16','18:05:00',1.32),('8784','2013-08-16','18:10:00',1.24),('8784','2013-08-16','18:15:00',1.16),('8784','2013-08-16','18:20:00',1.09),('8784','2013-08-16','18:25:00',1.01),('8784','2013-08-15','08:05:00',1.36),('8784','2013-08-15','08:10:00',1.5),('8784','2013-08-15','08:15:00',1.44),('8784','2013-08-15','08:20:00',1.44),('8784','2013-08-15','08:25:00',1.66),('8784','2013-08-15','08:30:00',1.73),('8784','2013-08-15','08:35:00',1.8),('8784','2013-08-15','08:40:00',1.88),('8784','2013-08-15','08:45:00',1.97),('8784','2013-08-15','08:50:00',2.04),('8784','2013-08-15','08:55:00',2.14),('8784','2013-08-15','09:00:00',2.28),('8784','2013-08-15','09:05:00',2.2),('8784','2013-08-15','09:10:00',1.46),('8784','2013-08-15','09:15:00',2.12),('8784','2013-08-15','09:20:00',2.64),('8784','2013-08-15','09:25:00',2.61),('8784','2013-08-15','09:30:00',2.65),('8784','2013-08-15','09:35:00',2.71),('8784','2013-08-15','09:40:00',2.79),('8784','2013-08-15','09:45:00',2.85),('8784','2013-08-15','09:50:00',2.94),('8784','2013-08-15','09:55:00',3),('8784','2013-08-15','10:00:00',3.06),('8784','2013-08-15','10:05:00',3.12),('8784','2013-08-15','10:10:00',3.19),('8784','2013-08-15','10:15:00',3.25),('8784','2013-08-15','10:20:00',3.29),('8784','2013-08-15','10:25:00',3.37),('8784','2013-08-15','10:30:00',3.42),('8784','2013-08-15','10:35:00',3.47),('8784','2013-08-15','10:40:00',3.5),('8784','2013-08-15','10:45:00',3.52),('8784','2013-08-15','10:50:00',3.56),('8784','2013-08-15','10:55:00',3.26),('8784','2013-08-15','11:00:00',2.99),('8784','2013-08-15','11:05:00',3.03),('8784','2013-08-15','11:10:00',2.31),('8784','2013-08-15','11:15:00',2.37),('8784','2013-08-15','11:20:00',2.79),('8784','2013-08-15','11:25:00',3.16),('8784','2013-08-15','11:30:00',3.4),('8784','2013-08-15','11:35:00',3.86),('8784','2013-08-15','11:40:00',4.08),('8784','2013-08-15','11:45:00',4.18),('8784','2013-08-15','11:50:00',4.24),('8784','2013-08-15','11:55:00',4.25),('8784','2013-08-15','12:00:00',4.28),('8784','2013-08-15','12:05:00',4.23),('8784','2013-08-15','12:10:00',4.2),('8784','2013-08-15','12:15:00',4.18),('8784','2013-08-15','12:20:00',4.23),('8784','2013-08-15','12:25:00',4.21),('8784','2013-08-15','12:30:00',4.2),('8784','2013-08-15','12:35:00',4.2),('8784','2013-08-15','12:40:00',4.21),('8784','2013-08-15','12:45:00',4.19),('8784','2013-08-15','12:50:00',4.19),('8784','2013-08-15','12:55:00',4.07),('8784','2013-08-15','13:00:00',3.93),('8784','2013-08-15','13:05:00',4.01),('8784','2013-08-15','13:10:00',4.04),('8784','2013-08-15','13:15:00',3.94),('8784','2013-08-15','13:20:00',3.88),('8784','2013-08-15','13:25:00',3.97),('8784','2013-08-15','13:30:00',4.06),('8784','2013-08-15','13:35:00',4.12),('8784','2013-08-15','13:40:00',4.11),('8784','2013-08-15','13:45:00',4.08),('8784','2013-08-15','13:50:00',3.98),('8784','2013-08-15','13:55:00',3.98),('8784','2013-08-15','14:00:00',3.97),('8784','2013-08-15','14:05:00',4.01),('8784','2013-08-15','14:10:00',4),('8784','2013-08-15','14:15:00',3.99),('8784','2013-08-15','14:20:00',3.96),('8784','2013-08-15','14:25:00',3.89),('8784','2013-08-15','14:30:00',3.78),('8784','2013-08-15','14:35:00',3.83),('8784','2013-08-15','14:40:00',3.81),('8784','2013-08-15','14:45:00',3.76),('8784','2013-08-15','14:50:00',3.7),('8784','2013-08-15','14:55:00',3.67),('8784','2013-08-15','15:00:00',3.6),('8784','2013-08-15','15:05:00',3.59),('8784','2013-08-15','15:10:00',3.57),('8784','2013-08-15','15:15:00',3.54),('8784','2013-08-15','15:20:00',3.49),('8784','2013-08-15','15:25:00',3.43),('8784','2013-08-15','15:30:00',3.37),('8784','2013-08-15','15:35:00',3.31),('8784','2013-08-15','15:40:00',3.27),('8784','2013-08-15','15:45:00',3.22),('8784','2013-08-15','15:50:00',3.18),('8784','2013-08-15','15:55:00',3.11),('8784','2013-08-15','16:00:00',3.02),('8784','2013-08-15','16:05:00',2.99),('8784','2013-08-15','16:10:00',2.92),('8784','2013-08-15','16:15:00',2.78),('8784','2013-08-15','16:20:00',2.81),('8784','2013-08-15','16:25:00',2.73),('8784','2013-08-15','16:30:00',2.64),('8784','2013-08-15','16:35:00',2.52),('8784','2013-08-15','16:40:00',2.47),('8784','2013-08-15','16:45:00',2.45),('8784','2013-08-15','16:50:00',2.37),('8784','2013-08-15','16:55:00',2.35),('8784','2013-08-15','17:00:00',2.29),('8784','2013-08-15','17:05:00',2.2),('8784','2013-08-15','17:10:00',2.12),('8784','2013-08-15','17:15:00',2.01),('8784','2013-08-15','17:20:00',1.79),('8784','2013-08-15','17:25:00',1.84),('8784','2013-08-15','17:30:00',1.85),('8784','2013-08-15','17:35:00',1.78),('8784','2013-08-15','17:40:00',1.7),('8784','2013-08-15','17:45:00',1.62),('8784','2013-08-15','17:50:00',1.53),('8784','2013-08-15','17:55:00',1.47),('8784','2013-08-15','18:00:00',1.39),('8784','2013-08-15','18:05:00',1.29),('8784','2013-08-15','18:10:00',1.18),('8784','2013-08-15','18:15:00',1.13),('8784','2013-08-15','18:20:00',1.08),('8784','2013-08-14','07:55:00',1.07),('8784','2013-08-14','08:00:00',1.12),('8784','2013-08-14','08:05:00',1.24),('8784','2013-08-14','08:10:00',1.31),('8784','2013-08-14','08:15:00',1.4),('8784','2013-08-14','08:20:00',1.45),('8784','2013-08-14','08:25:00',1.5),('8784','2013-08-14','08:30:00',1.62),('8784','2013-08-14','08:35:00',1.68),('8784','2013-08-14','08:40:00',1.78),('8784','2013-08-14','08:45:00',1.78),('8784','2013-08-14','08:50:00',1.94),('8784','2013-08-14','08:55:00',2.01),('8784','2013-08-14','09:00:00',1.98),('8784','2013-08-14','09:05:00',1.98),('8784','2013-08-14','09:10:00',2.35),('8784','2013-08-14','09:15:00',2.47),('8784','2013-08-14','09:20:00',2.54),('8784','2013-08-14','09:25:00',2.32),('8784','2013-08-14','09:30:00',2.7),('8784','2013-08-14','09:35:00',2.06),('8784','2013-08-14','09:40:00',1.26),('8784','2013-08-14','09:45:00',2.43),('8784','2013-08-14','09:50:00',2.5),('8784','2013-08-14','09:55:00',2.92),('8784','2013-08-14','10:00:00',3.13),('8784','2013-08-14','10:05:00',2.75),('8784','2013-08-14','10:10:00',1.69),('8784','2013-08-14','10:15:00',1.09),('8784','2013-08-14','10:20:00',2.1),('8784','2013-08-14','10:25:00',3.55),('8784','2013-08-14','10:30:00',3.81),('8784','2013-08-14','10:35:00',3.47),('8784','2013-08-14','10:40:00',2.36),('8784','2013-08-14','10:45:00',1.11),('8784','2013-08-14','10:50:00',1.13),('8784','2013-08-14','10:55:00',1.23),('8784','2013-08-14','11:00:00',1.55),('8784','2013-08-14','11:05:00',3.84),('8784','2013-08-14','11:10:00',3.65),('8784','2013-08-14','11:15:00',3.65),('8784','2013-08-14','11:20:00',3.42),('8784','2013-08-14','11:25:00',3.59),('8784','2013-08-14','11:30:00',4.22),('8784','2013-08-14','11:35:00',3.9),('8784','2013-08-14','11:40:00',1.76),('8784','2013-08-14','11:45:00',1.55),('8784','2013-08-14','11:50:00',3.09),('8784','2013-08-14','11:55:00',4.05),('8784','2013-08-14','12:00:00',3.91),('8784','2013-08-14','12:05:00',3.36),('8784','2013-08-14','12:10:00',1.83),('8784','2013-08-14','12:15:00',1.4),('8784','2013-08-14','12:20:00',1.22),('8784','2013-08-14','12:25:00',1.55),('8784','2013-08-14','12:30:00',1.26),('8784','2013-08-14','12:35:00',1.31),('8784','2013-08-14','12:40:00',1.49),('8784','2013-08-14','12:45:00',2.04),('8784','2013-08-14','12:50:00',2.24),('8784','2013-08-14','12:55:00',2.58),('8784','2013-08-14','13:00:00',2.8),('8784','2013-08-14','13:05:00',1.16),('8784','2013-08-14','13:10:00',1.18),('8784','2013-08-14','13:15:00',1.53),('8784','2013-08-14','13:20:00',1.27),('8784','2013-08-14','13:25:00',3.38),('8784','2013-08-14','13:30:00',3.13),('8784','2013-08-14','13:35:00',1.85),('8784','2013-08-14','13:40:00',3.53),('8784','2013-08-14','13:45:00',4.24),('8784','2013-08-14','13:50:00',4.11),('8784','2013-08-14','13:55:00',2.44),('8784','2013-08-14','14:00:00',4.69),('8784','2013-08-14','14:05:00',4.5),('8784','2013-08-14','14:10:00',3.39),('8784','2013-08-14','14:15:00',4.35),('8784','2013-08-14','14:20:00',3.38),('8784','2013-08-14','14:25:00',2.84),('8784','2013-08-14','14:30:00',3.67),('8784','2013-08-14','14:35:00',4.16),('8784','2013-08-14','14:40:00',3.99),('8784','2013-08-14','14:45:00',3.95),('8784','2013-08-14','14:50:00',3.92),('8784','2013-08-14','14:55:00',3.88),('8784','2013-08-14','15:00:00',3.75),('8784','2013-08-14','15:05:00',3.67),('8784','2013-08-14','15:10:00',3.66),('8784','2013-08-14','15:15:00',3.78),('8784','2013-08-14','15:20:00',3.72),('8784','2013-08-14','15:25:00',3.62),('8784','2013-08-14','15:30:00',3.51),('8784','2013-08-14','15:35:00',3.43),('8784','2013-08-14','15:40:00',3.4),('8784','2013-08-14','15:45:00',3.34),('8784','2013-08-14','15:50:00',3.31),('8784','2013-08-14','15:55:00',3.26),('8784','2013-08-14','16:00:00',3.18),('8784','2013-08-14','16:05:00',3.13),('8784','2013-08-14','16:10:00',3.13),('8784','2013-08-14','16:15:00',3.11),('8784','2013-08-14','16:20:00',3.03),('8784','2013-08-14','16:25:00',2.95),('8784','2013-08-14','16:30:00',2.88),('8784','2013-08-14','16:35:00',2.81),('8784','2013-08-14','16:40:00',2.77),('8784','2013-08-14','16:45:00',2.68),('8784','2013-08-14','16:50:00',2.6),('8784','2013-08-14','16:55:00',2.54),('8784','2013-08-14','17:00:00',2.43),('8784','2013-08-14','17:05:00',2.38),('8784','2013-08-14','17:10:00',2.29),('8784','2013-08-14','17:15:00',2.22),('8784','2013-08-14','17:20:00',2.13),('8784','2013-08-14','17:25:00',2.04),('8784','2013-08-14','17:30:00',1.95),('8784','2013-08-14','17:35:00',1.86),('8784','2013-08-14','17:40:00',1.82),('8784','2013-08-14','17:45:00',1.72),('8784','2013-08-14','17:50:00',1.66),('8784','2013-08-14','17:55:00',1.56),('8784','2013-08-14','18:00:00',1.48),('8784','2013-08-14','18:05:00',1.42),('8784','2013-08-14','18:10:00',1.33),('8784','2013-08-14','18:15:00',1.25),('8784','2013-08-14','18:20:00',1.23),('8784','2013-08-14','18:25:00',1.22),('8784','2013-08-14','18:30:00',1.13),('8784','2013-08-13','07:50:00',1.03),('8784','2013-08-13','07:55:00',1.09),('8784','2013-08-13','08:00:00',1.17),('8784','2013-08-13','08:05:00',1.16),('8784','2013-08-13','08:10:00',1.33),('8784','2013-08-13','08:15:00',1.41),('8784','2013-08-13','08:20:00',1.48),('8784','2013-08-13','08:25:00',1.56),('8784','2013-08-13','08:30:00',1.64),('8784','2013-08-13','08:35:00',1.72),('8784','2013-08-13','08:40:00',1.84),('8784','2013-08-13','08:45:00',1.91),('8784','2013-08-13','08:50:00',2.02),('8784','2013-08-13','08:55:00',2.02),('8784','2013-08-13','09:00:00',2.19),('8784','2013-08-13','09:05:00',2.28),('8784','2013-08-13','09:10:00',2.34),('8784','2013-08-13','09:15:00',2.41),('8784','2013-08-13','09:20:00',2.5),('8784','2013-08-13','09:25:00',2.57),('8784','2013-08-13','09:30:00',2.62),('8784','2013-08-13','09:35:00',1.03),('8784','2013-08-13','09:40:00',2.78),('8784','2013-08-13','09:45:00',2.82),('8784','2013-08-13','09:50:00',2.84),('8784','2013-08-13','09:55:00',2.94),('8784','2013-08-13','10:00:00',3.02),('8784','2013-08-13','10:05:00',3.1),('8784','2013-08-13','10:10:00',3.01),('8784','2013-08-13','10:15:00',3.12),('8784','2013-08-13','10:20:00',3.23),('8784','2013-08-13','10:25:00',3.31),('8784','2013-08-13','10:30:00',3.37),('8784','2013-08-13','10:35:00',3.35),('8784','2013-08-13','10:40:00',3.32),('8784','2013-08-13','10:45:00',3.33),('8784','2013-08-13','10:50:00',3.47),('8784','2013-08-13','10:55:00',3.51),('8784','2013-08-13','11:00:00',3.56),('8784','2013-08-13','11:05:00',3.58),('8784','2013-08-13','11:10:00',3.6),('8784','2013-08-13','11:15:00',3.63),('8784','2013-08-13','11:20:00',3.66),('8784','2013-08-13','11:25:00',3.65),('8784','2013-08-13','11:30:00',3.71),('8784','2013-08-13','11:35:00',3.72),('8784','2013-08-13','11:40:00',3.76),('8784','2013-08-13','11:45:00',3.79),('8784','2013-08-13','11:50:00',3.84),('8784','2013-08-13','11:55:00',3.91),('8784','2013-08-13','12:00:00',3.75),('8784','2013-08-13','12:05:00',4.02),('8784','2013-08-13','12:10:00',4.02),('8784','2013-08-13','12:15:00',4.06),('8784','2013-08-13','12:20:00',4.16),('8784','2013-08-13','12:25:00',4.26),('8784','2013-08-13','12:30:00',4.3),('8784','2013-08-13','12:35:00',3.82),('8784','2013-08-13','12:40:00',1.31),('8784','2013-08-13','12:45:00',1.34),('8784','2013-08-13','12:50:00',2.81),('8784','2013-08-13','12:55:00',1.97),('8784','2013-08-13','13:00:00',1.39),('8784','2013-08-13','13:05:00',1.51),('8784','2013-08-13','13:10:00',4.47),('8784','2013-08-13','13:15:00',4.64),('8784','2013-08-13','13:20:00',4),('8784','2013-08-13','13:25:00',1.47),('8784','2013-08-13','13:30:00',2.88),('8784','2013-08-13','13:35:00',4.56),('8784','2013-08-13','13:40:00',3.41),('8784','2013-08-13','13:45:00',1.81),('8784','2013-08-13','13:50:00',1.58),('8784','2013-08-13','13:55:00',3.54),('8784','2013-08-13','14:00:00',4.3),('8784','2013-08-13','14:05:00',3.32),('8784','2013-08-13','14:10:00',4.34),('8784','2013-08-13','14:15:00',4.16),('8784','2013-08-13','14:20:00',3.89),('8784','2013-08-13','14:25:00',4.14),('8784','2013-08-13','14:30:00',4.57),('8784','2013-08-13','14:35:00',3.17),('8784','2013-08-13','14:40:00',3.44),('8784','2013-08-13','14:45:00',1.96),('8784','2013-08-13','14:50:00',3.1),('8784','2013-08-13','14:55:00',3.18),('8784','2013-08-13','15:00:00',3.96),('8784','2013-08-13','15:05:00',3.1),('8784','2013-08-13','15:10:00',3.9),('8784','2013-08-13','15:15:00',3.62),('8784','2013-08-13','15:20:00',2.86),('8784','2013-08-13','15:25:00',3.63),('8784','2013-08-13','15:30:00',3.32),('8784','2013-08-13','15:35:00',3.41),('8784','2013-08-13','15:40:00',3.46),('8784','2013-08-13','15:45:00',3.41),('8784','2013-08-13','15:50:00',3.31),('8784','2013-08-13','15:55:00',3.23),('8784','2013-08-13','16:00:00',3.21),('8784','2013-08-13','16:05:00',3.16),('8784','2013-08-13','16:10:00',3.08),('8784','2013-08-13','16:15:00',3.03),('8784','2013-08-13','16:20:00',2.99),('8784','2013-08-13','16:25:00',2.92),('8784','2013-08-13','16:30:00',2.86),('8784','2013-08-13','16:35:00',2.79),('8784','2013-08-13','16:40:00',2.72),('8784','2013-08-13','16:45:00',2.63),('8784','2013-08-13','16:50:00',2.58),('8784','2013-08-13','16:55:00',2.5),('8784','2013-08-13','17:00:00',2.44),('8784','2013-08-13','17:05:00',2.37),('8784','2013-08-13','17:10:00',2.29),('8784','2013-08-13','17:15:00',2.21),('8784','2013-08-13','17:20:00',2.14),('8784','2013-08-13','17:25:00',2.05),('8784','2013-08-13','17:30:00',1.96),('8784','2013-08-13','17:35:00',1.89),('8784','2013-08-13','17:40:00',1.81),('8784','2013-08-13','17:45:00',1.72),('8784','2013-08-13','17:50:00',1.65),('8784','2013-08-13','17:55:00',1.56),('8784','2013-08-13','18:00:00',1.47),('8784','2013-08-13','18:05:00',1.39),('8784','2013-08-13','18:10:00',1.3),('8784','2013-08-13','18:15:00',1.21),('8784','2013-08-13','18:20:00',1.15),('8784','2013-08-13','18:25:00',1.06),('8784','2013-08-12','07:50:00',1.02),('8784','2013-08-12','07:55:00',1.1),('8784','2013-08-12','08:00:00',1.18),('8784','2013-08-12','08:05:00',1.26),('8784','2013-08-12','08:10:00',1.33),('8784','2013-08-12','08:15:00',1.41),('8784','2013-08-12','08:20:00',1.45),('8784','2013-08-12','08:25:00',1.53),('8784','2013-08-12','08:30:00',1.66),('8784','2013-08-12','08:35:00',1.73),('8784','2013-08-12','08:40:00',1.79),('8784','2013-08-12','08:45:00',1.87),('8784','2013-08-12','08:50:00',1.91),('8784','2013-08-12','08:55:00',2.02),('8784','2013-08-12','09:00:00',2.14),('8784','2013-08-12','09:05:00',2.23),('8784','2013-08-12','09:10:00',2.31),('8784','2013-08-12','09:15:00',2.37),('8784','2013-08-12','09:20:00',2.45),('8784','2013-08-12','09:25:00',2.5),('8784','2013-08-12','09:30:00',2.58),('8784','2013-08-12','09:35:00',2.64),('8784','2013-08-12','09:40:00',2.7),('8784','2013-08-12','09:45:00',2.78),('8784','2013-08-12','09:50:00',2.83),('8784','2013-08-12','09:55:00',2.9),('8784','2013-08-12','10:00:00',2.9),('8784','2013-08-12','10:05:00',2.98),('8784','2013-08-12','10:10:00',3.05),('8784','2013-08-12','10:15:00',3.09),('8784','2013-08-12','10:20:00',3.09),('8784','2013-08-12','10:25:00',3.2),('8784','2013-08-12','10:30:00',3.21),('8784','2013-08-12','10:35:00',3.26),('8784','2013-08-12','10:40:00',3.3),('8784','2013-08-12','10:45:00',3.39),('8784','2013-08-12','10:50:00',3.41),('8784','2013-08-12','10:55:00',3.46),('8784','2013-08-12','11:00:00',3.47),('8784','2013-08-12','11:05:00',3.53),('8784','2013-08-12','11:10:00',3.56),('8784','2013-08-12','11:15:00',3.56),('8784','2013-08-12','11:20:00',3.61),('8784','2013-08-12','11:25:00',3.68),('8784','2013-08-12','11:30:00',3.73),('8784','2013-08-12','11:35:00',3.78),('8784','2013-08-12','11:40:00',3.79),('8784','2013-08-12','11:45:00',3.83),('8784','2013-08-12','11:50:00',3.92),('8784','2013-08-12','11:55:00',3.97),('8784','2013-08-12','12:00:00',4.02),('8784','2013-08-12','12:05:00',4),('8784','2013-08-12','12:10:00',4.06),('8784','2013-08-12','12:15:00',2.7),('8784','2013-08-12','12:20:00',1.48),('8784','2013-08-12','12:25:00',2.29),('8784','2013-08-12','12:30:00',1.59),('8784','2013-08-12','12:35:00',3.57),('8784','2013-08-12','12:40:00',3.18),('8784','2013-08-12','12:45:00',1.59),('8784','2013-08-12','12:50:00',1.35),('8784','2013-08-12','12:55:00',2.24),('8784','2013-08-12','13:15:00',1.06),('8784','2013-08-12','13:20:00',1.28),('8784','2013-08-12','13:25:00',1.59),('8784','2013-08-12','13:30:00',1.37),('8784','2013-08-12','13:35:00',1.36),('8784','2013-08-12','13:40:00',1.21),('8784','2013-08-12','13:45:00',1.27),('8784','2013-08-12','13:50:00',4.55),('8784','2013-08-12','13:55:00',4.05),('8784','2013-08-12','14:00:00',2.87),('8784','2013-08-12','14:05:00',3.52),('8784','2013-08-12','14:10:00',1.51),('8784','2013-08-12','14:15:00',1.15),('8784','2013-08-12','14:20:00',1),('8784','2013-08-12','14:35:00',1.2),('8784','2013-08-12','14:40:00',1.3),('8784','2013-08-12','14:45:00',1.42),('8784','2013-08-12','14:50:00',2.28),('8784','2013-08-12','14:55:00',4.34),('8784','2013-08-12','15:00:00',4.29),('8784','2013-08-12','15:05:00',3.78),('8784','2013-08-12','15:10:00',3.23),('8784','2013-08-12','15:15:00',2.81),('8784','2013-08-12','15:20:00',3.4),('8784','2013-08-12','15:25:00',3.61),('8784','2013-08-12','15:30:00',3.54),('8784','2013-08-12','15:35:00',3.46),('8784','2013-08-12','15:40:00',3.44),('8784','2013-08-12','15:45:00',3.39),('8784','2013-08-12','15:50:00',3.35),('8784','2013-08-12','15:55:00',3.27),('8784','2013-08-12','16:00:00',3.22),('8784','2013-08-12','16:05:00',3.12),('8784','2013-08-12','16:10:00',3.06),('8784','2013-08-12','16:15:00',2.96),('8784','2013-08-12','16:20:00',2.95),('8784','2013-08-12','16:25:00',2.91),('8784','2013-08-12','16:30:00',2.81),('8784','2013-08-12','16:35:00',2.77),('8784','2013-08-12','16:40:00',2.57),('8784','2013-08-12','16:45:00',2.57),('8784','2013-08-12','16:50:00',2.45),('8784','2013-08-12','16:55:00',2.53),('8784','2013-08-12','17:00:00',2.42),('8784','2013-08-12','17:05:00',2.35),('8784','2013-08-12','17:10:00',2.24),('8784','2013-08-12','17:15:00',2.17),('8784','2013-08-12','17:20:00',2.1),('8784','2013-08-12','17:25:00',2.04),('8784','2013-08-12','17:30:00',1.95),('8784','2013-08-12','17:35:00',1.88),('8784','2013-08-12','17:40:00',1.78),('8784','2013-08-12','17:45:00',1.7),('8784','2013-08-12','17:50:00',1.63),('8784','2013-08-12','17:55:00',1.56),('8784','2013-08-12','18:00:00',1.48),('8784','2013-08-12','18:05:00',1.38),('8784','2013-08-12','18:10:00',1.31),('8784','2013-08-12','18:15:00',1.24),('8784','2013-08-12','18:20:00',1.17),('8784','2013-08-12','18:25:00',1.11),('8784','2013-08-12','18:30:00',1.03),('8784','2013-08-11','07:50:00',1.07),('8784','2013-08-11','07:55:00',1.14),('8784','2013-08-11','08:00:00',1.23),('8784','2013-08-11','08:05:00',1.31),('8784','2013-08-11','08:10:00',1.39),('8784','2013-08-11','08:15:00',1.48),('8784','2013-08-11','08:20:00',1.55),('8784','2013-08-11','08:25:00',1.61),('8784','2013-08-11','08:30:00',1.71),('8784','2013-08-11','08:35:00',1.77),('8784','2013-08-11','08:40:00',1.87),('8784','2013-08-11','08:45:00',1.94),('8784','2013-08-11','08:50:00',1.98),('8784','2013-08-11','08:55:00',2.07),('8784','2013-08-11','09:00:00',2.16),('8784','2013-08-11','09:05:00',2.25),('8784','2013-08-11','09:10:00',2.28),('8784','2013-08-11','09:15:00',2.42),('8784','2013-08-11','09:20:00',2.47),('8784','2013-08-11','09:25:00',2.58),('8784','2013-08-11','09:30:00',2.65),('8784','2013-08-11','09:35:00',2.72),('8784','2013-08-11','09:40:00',2.78),('8784','2013-08-11','09:45:00',2.86),('8784','2013-08-11','09:50:00',2.92),('8784','2013-08-11','09:55:00',2.98),('8784','2013-08-11','10:00:00',3.04),('8784','2013-08-11','10:05:00',3.11),('8784','2013-08-11','10:10:00',3.15),('8784','2013-08-11','10:15:00',3.23),('8784','2013-08-11','10:20:00',3.27),('8784','2013-08-11','10:25:00',3.33),('8784','2013-08-11','10:30:00',3.38),('8784','2013-08-11','10:35:00',3.42),('8784','2013-08-11','10:40:00',3.45),('8784','2013-08-11','10:45:00',3.5),('8784','2013-08-11','10:50:00',3.54),('8784','2013-08-11','10:55:00',3.6),('8784','2013-08-11','11:00:00',3.64),('8784','2013-08-11','11:05:00',3.7),('8784','2013-08-11','11:10:00',3.75),('8784','2013-08-11','11:15:00',3.76),('8784','2013-08-11','11:20:00',3.76),('8784','2013-08-11','11:25:00',3.77),('8784','2013-08-11','11:30:00',3.85),('8784','2013-08-11','11:35:00',3.87),('8784','2013-08-11','11:40:00',3.9),('8784','2013-08-11','11:45:00',3.92),('8784','2013-08-11','11:50:00',3.91),('8784','2013-08-11','11:55:00',3.97),('8784','2013-08-11','12:00:00',4.01),('8784','2013-08-11','12:05:00',3.99),('8784','2013-08-11','12:10:00',4.02),('8784','2013-08-11','12:15:00',4.02),('8784','2013-08-11','12:20:00',4.03),('8784','2013-08-11','12:25:00',4.03),('8784','2013-08-11','12:30:00',4.07),('8784','2013-08-11','12:35:00',4.08),('8784','2013-08-11','12:40:00',4.06),('8784','2013-08-11','12:45:00',4.1),('8784','2013-08-11','12:50:00',4.06),('8784','2013-08-11','12:55:00',4.06),('8784','2013-08-11','13:00:00',4.07),('8784','2013-08-11','13:05:00',4.08),('8784','2013-08-11','13:10:00',4.02),('8784','2013-08-11','13:15:00',4.05),('8784','2013-08-11','13:20:00',3.99),('8784','2013-08-11','13:25:00',4.02),('8784','2013-08-11','13:30:00',4.02),('8784','2013-08-11','13:35:00',4.08),('8784','2013-08-11','13:40:00',4.05),('8784','2013-08-11','13:45:00',4.03),('8784','2013-08-11','13:50:00',3.99),('8784','2013-08-11','13:55:00',3.99),('8784','2013-08-11','14:00:00',3.98),('8784','2013-08-11','14:05:00',3.96),('8784','2013-08-11','14:10:00',3.95),('8784','2013-08-11','14:15:00',3.94),('8784','2013-08-11','14:20:00',3.84),('8784','2013-08-11','14:25:00',3.83),('8784','2013-08-11','14:30:00',3.83),('8784','2013-08-11','14:35:00',3.73),('8784','2013-08-11','14:40:00',3.77),('8784','2013-08-11','14:45:00',3.79),('8784','2013-08-11','14:50:00',3.76),('8784','2013-08-11','14:55:00',3.65),('8784','2013-08-11','15:00:00',2.65),('8784','2013-08-11','15:05:00',3.07),('8784','2013-08-11','15:10:00',3.6),('8784','2013-08-11','15:15:00',3.51),('8784','2013-08-11','15:20:00',3.08),('8784','2013-08-11','15:25:00',3.03),('8784','2013-08-11','15:30:00',3.08),('8784','2013-08-11','15:35:00',3.34),('8784','2013-08-11','15:40:00',3.33),('8784','2013-08-11','15:45:00',3.3),('8784','2013-08-11','15:50:00',3.27),('8784','2013-08-11','15:55:00',3.26),('8784','2013-08-11','16:00:00',3.18),('8784','2013-08-11','16:05:00',3.13),('8784','2013-08-11','16:10:00',3.09),('8784','2013-08-11','16:15:00',2.98),('8784','2013-08-11','16:20:00',2.95),('8784','2013-08-11','16:25:00',2.88),('8784','2013-08-11','16:30:00',2.82),('8784','2013-08-11','16:35:00',2.77),('8784','2013-08-11','16:40:00',2.69),('8784','2013-08-11','16:45:00',2.61),('8784','2013-08-11','16:50:00',2.54),('8784','2013-08-11','16:55:00',2.48),('8784','2013-08-11','17:00:00',2.41),('8784','2013-08-11','17:05:00',2.33),('8784','2013-08-11','17:10:00',2.26),('8784','2013-08-11','17:15:00',2.2),('8784','2013-08-11','17:20:00',2.11),('8784','2013-08-11','17:25:00',2.03),('8784','2013-08-11','17:30:00',1.96),('8784','2013-08-11','17:35:00',1.89),('8784','2013-08-11','17:40:00',1.8),('8784','2013-08-11','17:45:00',1.72),('8784','2013-08-11','17:50:00',1.64),('8784','2013-08-11','17:55:00',1.54),('8784','2013-08-11','18:00:00',1.44),('8784','2013-08-11','18:05:00',1.38),('8784','2013-08-11','18:10:00',1.25),('8784','2013-08-11','18:15:00',1.2),('8784','2013-08-11','18:20:00',1.14),('8784','2013-08-11','18:25:00',1.07),('8784','2013-08-10','07:50:00',1.06),('8784','2013-08-10','07:55:00',1.14),('8784','2013-08-10','08:00:00',1.23),('8784','2013-08-10','08:05:00',1.32),('8784','2013-08-10','08:10:00',1.38),('8784','2013-08-10','08:15:00',1.49),('8784','2013-08-10','08:20:00',1.61),('8784','2013-08-10','08:25:00',1.65),('8784','2013-08-10','08:30:00',1.78),('8784','2013-08-10','08:35:00',1.86),('8784','2013-08-10','08:40:00',1.94),('8784','2013-08-10','08:45:00',2.01),('8784','2013-08-10','08:50:00',2.1),('8784','2013-08-10','08:55:00',2.18),('8784','2013-08-10','09:00:00',2.25),('8784','2013-08-10','09:05:00',2.32),('8784','2013-08-10','09:10:00',2.37),('8784','2013-08-10','09:15:00',2.49),('8784','2013-08-10','09:20:00',2.56),('8784','2013-08-10','09:25:00',2.56),('8784','2013-08-10','09:30:00',2.6),('8784','2013-08-10','09:35:00',2.76),('8784','2013-08-10','09:40:00',2.82),('8784','2013-08-10','09:45:00',2.8),('8784','2013-08-10','09:50:00',2.95),('8784','2013-08-10','09:55:00',3.01),('8784','2013-08-10','10:00:00',3.05),('8784','2013-08-10','10:05:00',3.12),('8784','2013-08-10','10:30:00',3.39),('8784','2013-08-10','10:35:00',3.38),('8784','2013-08-10','10:40:00',3.45),('8784','2013-08-10','10:45:00',3.42),('8784','2013-08-10','10:50:00',3.54),('8784','2013-08-10','10:55:00',3.62),('8784','2013-08-10','11:00:00',3.73),('8784','2013-08-10','11:05:00',3.76),('8784','2013-08-10','11:10:00',3.9),('8784','2013-08-10','11:15:00',3.77),('8784','2013-08-10','11:20:00',3.68),('8784','2013-08-10','11:25:00',2.87),('8784','2013-08-10','11:30:00',3.88),('8784','2013-08-10','11:35:00',3.75),('8784','2013-08-10','11:40:00',3.96),('8784','2013-08-10','11:45:00',3.97),('8784','2013-08-10','11:50:00',3.98),('8784','2013-08-10','11:55:00',4.03),('8784','2013-08-10','12:00:00',4.04),('8784','2013-08-10','12:05:00',4.05),('8784','2013-08-10','12:10:00',4.05),('8784','2013-08-10','12:15:00',4.05),('8784','2013-08-10','12:20:00',4.05),('8784','2013-08-10','12:25:00',4.09),('8784','2013-08-10','12:30:00',4.12),('8784','2013-08-10','12:35:00',4.14),('8784','2013-08-10','12:40:00',4.17),('8784','2013-08-10','12:45:00',4.22),('8784','2013-08-10','12:50:00',4.33),('8784','2013-08-10','12:55:00',4.28),('8784','2013-08-10','13:00:00',4.25),('8784','2013-08-10','13:05:00',4.17),('8784','2013-08-10','13:10:00',4.25),('8784','2013-08-10','13:15:00',4.39),('8784','2013-08-10','13:20:00',4.31),('8784','2013-08-10','13:25:00',4.49),('8784','2013-08-10','13:30:00',4.6),('8784','2013-08-10','13:35:00',2.76),('8784','2013-08-10','13:40:00',1.57),('8784','2013-08-10','13:50:00',2.35),('8784','2013-08-10','13:55:00',4.39),('8784','2013-08-10','14:00:00',4.49),('8784','2013-08-10','14:05:00',4.32),('8784','2013-08-10','14:10:00',3.65),('8784','2013-08-10','14:15:00',4.69),('8784','2013-08-10','14:20:00',2.82),('8784','2013-08-10','14:25:00',1.39),('8784','2013-08-10','14:30:00',1.31),('8784','2013-08-10','14:35:00',1.17),('8784','2013-08-10','14:40:00',1.08),('8784','2013-08-10','14:45:00',1.04),('8784','2013-08-10','15:00:00',1.09),('8784','2013-08-10','15:05:00',1.14),('8784','2013-08-10','15:10:00',1.21),('8784','2013-08-10','15:15:00',1.34),('8784','2013-08-10','15:20:00',1.32),('8784','2013-08-10','15:25:00',1.17),('8784','2013-08-10','15:30:00',1.14),('8784','2013-08-10','15:35:00',1.44),('8784','2013-08-10','15:40:00',1.38),('8784','2013-08-10','15:45:00',1.55),('8784','2013-08-10','15:50:00',1.95),('8784','2013-08-10','15:55:00',2.19),('8784','2013-08-10','16:00:00',2.36),('8784','2013-08-10','16:05:00',4.49),('8784','2013-08-10','16:10:00',2.58),('8784','2013-08-10','16:15:00',2.4),('8784','2013-08-10','16:20:00',3.58),('8784','2013-08-10','16:25:00',1.16),('8784','2013-08-10','16:30:00',2.04),('8784','2013-08-10','16:35:00',2.38),('8784','2013-08-10','16:40:00',2.64),('8784','2013-08-10','16:45:00',2.98),('8784','2013-08-10','16:50:00',2.81),('8784','2013-08-10','16:55:00',2.66),('8784','2013-08-10','17:00:00',2.04),('8784','2013-08-10','17:05:00',1.7),('8784','2013-08-10','17:10:00',1.11),('8784','2013-08-10','17:15:00',1.2),('8784','2013-08-10','17:20:00',1.25),('8784','2013-08-10','17:25:00',1.56),('8784','2014-04-09','08:05:00',1.19),('8784','2014-04-09','08:10:00',1.04),('8784','2014-04-09','08:15:00',1.02),('8784','2014-04-09','08:20:00',1.23),('8784','2014-04-09','09:00:00',1.09),('8784','2014-04-09','09:25:00',1.01),('8784','2014-04-09','09:30:00',1.05),('8784','2014-04-09','09:50:00',2.41),('8784','2014-04-09','09:55:00',2.93),('8784','2014-04-09','10:00:00',2.96),('8784','2014-04-09','10:05:00',2.98),('8784','2014-04-09','10:10:00',3.1),('8784','2014-04-09','10:15:00',3.15),('8784','2014-04-09','10:20:00',3.31),('8784','2014-04-09','10:25:00',3.53),('8784','2014-04-09','10:30:00',3.47),('8784','2014-04-09','10:35:00',2.57),('8784','2014-04-09','10:40:00',1.52),('8784','2014-04-09','10:45:00',2.04),('8784','2014-04-09','10:50:00',1.28),('8784','2014-04-09','10:55:00',3.53),('8784','2014-04-09','11:00:00',3.37),('8784','2014-04-09','11:05:00',4.3),('8784','2014-04-09','11:10:00',4.34),('8784','2014-04-09','11:15:00',4.46),('8784','2014-04-09','11:20:00',3.67),('8784','2014-04-09','11:25:00',1.6),('8784','2014-04-09','11:30:00',1.2),('8784','2014-04-09','11:35:00',4.34),('8784','2014-04-09','11:40:00',4.56),('8784','2014-04-09','11:45:00',2.81),('8784','2014-04-09','11:50:00',4.21),('8784','2014-04-09','11:55:00',4.71),('8784','2014-04-09','12:00:00',4.78),('8784','2014-04-09','12:05:00',4.52),('8784','2014-04-09','12:10:00',3.86),('8784','2014-04-09','12:15:00',1.93),('8784','2014-04-09','12:20:00',1.52),('8784','2014-04-09','12:25:00',1.12),('8784','2014-04-09','13:15:00',1.1),('8784','2014-04-09','13:20:00',1.55),('8784','2014-04-09','13:25:00',1.49),('8784','2014-04-09','13:30:00',1.27),('8784','2014-04-09','13:35:00',1.27),('8784','2014-04-09','13:40:00',1.08),('8784','2014-04-09','14:00:00',1.14),('8784','2014-04-09','14:05:00',1.57),('8784','2014-04-09','14:10:00',1.7),('8784','2014-04-09','14:15:00',1.64),('8784','2014-04-09','14:20:00',1.5),('8784','2014-04-09','14:25:00',1.51),('8784','2014-04-09','14:30:00',1.77),('8784','2014-04-09','14:35:00',1.97),('8784','2014-04-09','14:40:00',1.94),('8784','2014-04-09','14:45:00',2.24),('8784','2014-04-09','14:50:00',2.27),('8784','2014-04-09','14:55:00',2.72),('8784','2014-04-09','15:00:00',2.1),('8784','2014-04-09','15:05:00',3.67),('8784','2014-04-09','15:10:00',4.31),('8784','2014-04-09','15:15:00',4.11),('8784','2014-04-09','15:20:00',4.05),('8784','2014-04-09','15:25:00',3.01),('8784','2014-04-09','15:30:00',2.53),('8784','2014-04-09','15:35:00',2.2),('8784','2014-04-09','15:40:00',2.25),('8784','2014-04-09','15:45:00',1.9),('8784','2014-04-09','15:50:00',1.42),('8784','2014-04-09','15:55:00',1.28),('8784','2014-04-09','16:00:00',1.56),('8784','2014-04-09','16:05:00',2.17),('8784','2014-04-09','16:10:00',2.86),('8784','2014-04-09','16:15:00',3.03),('8784','2014-04-09','16:20:00',2.96),('8784','2014-04-09','16:25:00',2.83),('8784','2014-04-09','16:30:00',3.15),('8784','2014-04-09','16:35:00',3),('8784','2014-04-09','16:40:00',2.45),('8784','2014-04-09','16:45:00',2.62),('8784','2014-04-09','16:50:00',2.95),('8784','2014-04-09','16:55:00',1.98),('8784','2014-04-09','17:00:00',2),('8784','2014-04-09','17:05:00',2.79),('8784','2014-04-09','17:10:00',2.24),('8784','2014-04-09','17:15:00',1.97),('8784','2014-04-09','17:20:00',1.9),('8784','2014-04-09','17:25:00',1.86),('8784','2014-04-09','17:30:00',1.51),('8784','2014-04-09','17:45:00',1.26),('8784','2014-04-09','17:50:00',1.26),('8784','2014-04-09','17:55:00',1.23),('8784','2014-04-09','18:00:00',1.05),('8784','2013-08-09','08:00:00',1.08),('8784','2013-08-09','08:05:00',1.2),('8784','2013-08-09','08:35:00',1.12),('8784','2013-08-09','08:40:00',1.63),('8784','2013-08-09','08:45:00',1.82),('8784','2013-08-09','08:50:00',1.94),('8784','2013-08-09','08:55:00',1.99),('8784','2013-08-09','09:00:00',2.07),('8784','2013-08-09','09:05:00',2.19),('8784','2013-08-09','09:10:00',1.88),('8784','2013-08-09','09:15:00',2.27),('8784','2013-08-09','09:20:00',1.83),('8784','2013-08-09','09:25:00',1.77),('8784','2013-08-09','09:30:00',1.74),('8784','2013-08-09','09:35:00',2.17),('8784','2013-08-09','09:40:00',2.07),('8784','2013-08-09','09:45:00',2.62),('8784','2013-08-09','09:50:00',2.16),('8784','2013-08-09','09:55:00',1.67),('8784','2013-08-09','10:00:00',1.98),('8784','2013-08-09','10:05:00',1.97),('8784','2013-08-09','10:10:00',2.46),('8784','2013-08-09','10:15:00',2.91),('8784','2013-08-09','10:20:00',2.88),('8784','2013-08-09','10:25:00',2.94),('8784','2013-08-09','10:30:00',2.69),('8784','2013-08-09','10:35:00',2.56),('8784','2013-08-09','10:40:00',2.89),('8784','2013-08-09','10:45:00',3.17),('8784','2013-08-09','10:50:00',3.16),('8784','2013-08-09','10:55:00',3.28),('8784','2013-08-09','11:00:00',3.36),('8784','2013-08-09','11:05:00',3.37),('8784','2013-08-09','11:10:00',3.39),('8784','2013-08-09','11:15:00',3.49),('8784','2013-08-09','11:20:00',3.49),('8784','2013-08-09','11:25:00',3.52),('8784','2013-08-09','11:30:00',3.55),('8784','2013-08-09','11:35:00',3.54),('8784','2013-08-09','11:40:00',3.64),('8784','2013-08-09','11:45:00',3.64),('8784','2013-08-09','11:50:00',3.64),('8784','2013-08-09','11:55:00',3.66),('8784','2013-08-09','12:00:00',3.69),('8784','2013-08-09','12:05:00',3.69),('8784','2013-08-09','12:10:00',3.7),('8784','2013-08-09','12:15:00',3.78),('8784','2013-08-09','12:20:00',3.87),('8784','2013-08-09','12:25:00',2.89),('8784','2013-08-09','12:30:00',2.44),('8784','2013-08-09','12:35:00',2.79),('8784','2013-08-09','12:40:00',4.14),('8784','2013-08-09','12:45:00',3.11),('8784','2013-08-09','12:50:00',2.26),('8784','2013-08-09','12:55:00',3.03),('8784','2013-08-09','13:00:00',1.32),('8784','2013-08-09','13:15:00',1.16),('8784','2013-08-09','13:20:00',1.62),('8784','2013-08-09','13:25:00',2.27),('8784','2013-08-09','13:30:00',1.99),('8784','2013-08-09','13:35:00',1.6),('8784','2013-08-09','13:40:00',1.56),('8784','2013-08-09','13:45:00',1.5),('8784','2013-08-09','13:50:00',1.59),('8784','2013-08-09','13:55:00',1.41),('8784','2013-08-09','14:00:00',1.35),('8784','2013-08-09','14:05:00',1.33),('8784','2013-08-09','14:10:00',1.54),('8784','2013-08-09','14:15:00',1.07),('8784','2013-08-09','14:25:00',1.09),('8784','2013-08-09','14:30:00',1.1),('8784','2013-08-09','15:05:00',1.36),('8784','2013-08-09','15:10:00',2.89),('8784','2013-08-09','15:15:00',2.65),('8784','2013-08-09','15:20:00',1.66),('8784','2013-08-09','15:25:00',1.27),('8784','2013-08-09','15:30:00',1.3),('8784','2013-08-09','15:35:00',2.28),('8784','2013-08-09','15:40:00',1.76),('8784','2013-08-09','15:45:00',2.61),('8784','2013-08-09','15:50:00',2.19),('8784','2013-08-09','15:55:00',1.89),('8784','2013-08-09','16:00:00',1.24),('8784','2013-08-09','16:50:00',1.61),('8784','2013-08-09','16:55:00',2.48),('8784','2013-08-09','17:00:00',1.61),('8784','2013-08-09','17:05:00',1.84),('8784','2013-08-09','17:10:00',1.05),('8784','2013-08-09','19:20:00',1.11),('8784','2013-08-09','19:25:00',1.1),('8784','2013-08-08','07:55:00',1.03),('8784','2013-08-08','08:00:00',1.1),('8784','2013-08-08','08:05:00',1.18),('8784','2013-08-08','08:10:00',1.27),('8784','2013-08-08','08:15:00',1.35),('8784','2013-08-08','08:20:00',1.42),('8784','2013-08-08','08:25:00',1.5),('8784','2013-08-08','08:30:00',1.58),('8784','2013-08-08','08:35:00',1.66),('8784','2013-08-08','08:40:00',1.73),('8784','2013-08-08','08:45:00',1.81),('8784','2013-08-08','08:50:00',1.89),('8784','2013-08-08','08:55:00',1.97),('8784','2013-08-08','09:00:00',2.05),('8784','2013-08-08','09:05:00',2.12),('8784','2013-08-08','09:10:00',2.16),('8784','2013-08-08','09:15:00',2.26),('8784','2013-08-08','09:20:00',2.35),('8784','2013-08-08','09:25:00',2.42),('8784','2013-08-08','09:30:00',2.47),('8784','2013-08-08','09:35:00',2.51),('8784','2013-08-08','09:40:00',2.6),('8784','2013-08-08','09:45:00',2.66),('8784','2013-08-08','09:50:00',2.72),('8784','2013-08-08','09:55:00',2.78),('8784','2013-08-08','10:00:00',2.83),('8784','2013-08-08','10:05:00',2.88),('8784','2013-08-08','10:10:00',2.95),('8784','2013-08-08','10:15:00',3),('8784','2013-08-08','10:20:00',3.04),('8784','2013-08-08','10:25:00',3.09),('8784','2013-08-08','10:30:00',3.13),('8784','2013-08-08','10:35:00',3.17),('8784','2013-08-08','10:40:00',3.21),('8784','2013-08-08','10:45:00',3.27),('8784','2013-08-08','10:50:00',3.3),('8784','2013-08-08','10:55:00',3.29),('8784','2013-08-08','11:00:00',3.36),('8784','2013-08-08','11:05:00',3.39),('8784','2013-08-08','11:10:00',3.43),('8784','2013-08-08','11:15:00',3.47),('8784','2013-08-08','11:20:00',3.42),('8784','2013-08-08','11:25:00',3.5),('8784','2013-08-08','11:30:00',3.54),('8784','2013-08-08','11:35:00',3.51),('8784','2013-08-08','11:40:00',3.56),('8784','2013-08-08','11:45:00',3.59),('8784','2013-08-08','11:50:00',3.64),('8784','2013-08-08','11:55:00',3.65),('8784','2013-08-08','12:00:00',3.65),('8784','2013-08-08','12:05:00',3.69),('8784','2013-08-08','12:10:00',3.71),('8784','2013-08-08','12:15:00',3.68),('8784','2013-08-08','12:20:00',3.7),('8784','2013-08-08','12:25:00',3.71),('8784','2013-08-08','12:30:00',3.65),('8784','2013-08-08','12:35:00',3.76),('8784','2013-08-08','12:40:00',3.79),('8784','2013-08-08','12:45:00',3.81),('8784','2013-08-08','12:50:00',3.84),('8784','2013-08-08','12:55:00',3.82),('8784','2013-08-08','13:00:00',3.82),('8784','2013-08-08','13:05:00',3.87),('8784','2013-08-08','13:10:00',3.85),('8784','2013-08-08','13:15:00',3.82),('8784','2013-08-08','13:20:00',3.88),('8784','2013-08-08','13:25:00',3.87),('8784','2013-08-08','13:30:00',3.85),('8784','2013-08-08','13:35:00',3.84),('8784','2013-08-08','13:40:00',3.79),('8784','2013-08-08','13:45:00',3.81),('8784','2013-08-08','13:50:00',3.81),('8784','2013-08-08','13:55:00',3.78),('8784','2013-08-08','14:00:00',3.81),('8784','2013-08-08','14:05:00',3.78),('8784','2013-08-08','14:10:00',3.74),('8784','2013-08-08','14:15:00',3.72),('8784','2013-08-08','14:20:00',3.69),('8784','2013-08-08','14:25:00',3.67),('8784','2013-08-08','14:30:00',3.67),('8784','2013-08-08','14:35:00',3.64),('8784','2013-08-08','14:40:00',3.59),('8784','2013-08-08','14:45:00',3.56),('8784','2013-08-08','14:50:00',3.53),('8784','2013-08-08','14:55:00',3.49),('8784','2013-08-08','15:00:00',3.47),('8784','2013-08-08','15:05:00',3.44),('8784','2013-08-08','15:10:00',3.42),('8784','2013-08-08','15:15:00',3.35),('8784','2013-08-08','15:20:00',3.3),('8784','2013-08-08','15:25:00',3.26),('8784','2013-08-08','15:30:00',3.21),('8784','2013-08-08','15:35:00',3.18),('8784','2013-08-08','15:40:00',3.13),('8784','2013-08-08','15:45:00',3.1),('8784','2013-08-08','15:50:00',3.05),('8784','2013-08-08','15:55:00',3.01),('8784','2013-08-08','16:00:00',2.98),('8784','2013-08-08','16:05:00',2.93),('8784','2013-08-08','16:10:00',2.88),('8784','2013-08-08','16:15:00',2.86),('8784','2013-08-08','16:20:00',2.83),('8784','2013-08-08','16:25:00',2.77),('8784','2013-08-08','16:30:00',2.72),('8784','2013-08-08','16:35:00',2.67),('8784','2013-08-08','16:40:00',2.58),('8784','2013-08-08','16:45:00',2.52),('8784','2013-08-08','16:50:00',2.43),('8784','2013-08-08','16:55:00',2.36),('8784','2013-08-08','17:00:00',2.3),('8784','2013-08-08','17:05:00',2.21),('8784','2013-08-08','17:10:00',2.15),('8784','2013-08-08','17:15:00',2.08),('8784','2013-08-08','17:20:00',2),('8784','2013-08-08','17:25:00',1.91),('8784','2013-08-08','17:30:00',1.85),('8784','2013-08-08','17:35:00',1.76),('8784','2013-08-08','17:40:00',1.7),('8784','2013-08-08','17:45:00',1.63),('8784','2013-08-08','17:50:00',1.56),('8784','2013-08-08','17:55:00',1.49),('8784','2013-08-08','18:00:00',1.42),('8784','2013-08-08','18:05:00',1.34),('8784','2013-08-08','18:10:00',1.26),('8784','2013-08-08','18:15:00',1.19),('8784','2013-08-08','18:20:00',1.11),('8784','2013-08-08','18:25:00',1.04),('8784','2013-08-07','07:50:00',1.03),('8784','2013-08-07','07:55:00',1.11),('8784','2013-08-07','08:00:00',1.18),('8784','2013-08-07','08:05:00',1.25),('8784','2013-08-07','08:10:00',1.33),('8784','2013-08-07','08:15:00',1.41),('8784','2013-08-07','08:20:00',1.49),('8784','2013-08-07','08:25:00',1.57),('8784','2013-08-07','08:30:00',1.55),('8784','2013-08-07','08:35:00',1.63),('8784','2013-08-07','08:40:00',1.8),('8784','2013-08-07','08:45:00',1.88),('8784','2013-08-07','08:50:00',1.95),('8784','2013-08-07','08:55:00',2.02),('8784','2013-08-07','09:00:00',2.08),('8784','2013-08-07','09:05:00',2.16),('8784','2013-08-07','09:10:00',2.24),('8784','2013-08-07','09:15:00',2.31),('8784','2013-08-07','09:20:00',2.38),('8784','2013-08-07','09:25:00',2.45),('8784','2013-08-07','09:30:00',2.5),('8784','2013-08-07','09:35:00',2.58),('8784','2013-08-07','09:40:00',2.64),('8784','2013-08-07','09:45:00',2.7),('8784','2013-08-07','09:50:00',2.76),('8784','2013-08-07','09:55:00',2.82),('8784','2013-08-07','10:00:00',2.85),('8784','2013-08-07','10:05:00',2.96),('8784','2013-08-07','10:10:00',2.97),('8784','2013-08-07','10:15:00',3.04),('8784','2013-08-07','10:20:00',3.07),('8784','2013-08-07','10:25:00',3.14),('8784','2013-08-07','10:30:00',3.19),('8784','2013-08-07','10:35:00',3.22),('8784','2013-08-07','10:40:00',3.25),('8784','2013-08-07','10:45:00',3.28),('8784','2013-08-07','10:50:00',3.33),('8784','2013-08-07','10:55:00',3.37),('8784','2013-08-07','11:00:00',3.39),('8784','2013-08-07','11:05:00',3.43),('8784','2013-08-07','11:10:00',3.45),('8784','2013-08-07','11:15:00',3.5),('8784','2013-08-07','11:20:00',3.53),('8784','2013-08-07','11:25:00',3.55),('8784','2013-08-07','11:30:00',3.57),('8784','2013-08-07','11:35:00',3.58),('8784','2013-08-07','11:40:00',3.6),('8784','2013-08-07','11:45:00',3.63),('8784','2013-08-07','11:50:00',3.66),('8784','2013-08-07','11:55:00',3.71),('8784','2013-08-07','12:00:00',3.71),('8784','2013-08-07','12:05:00',3.72),('8784','2013-08-07','12:10:00',3.75),('8784','2013-08-07','12:15:00',3.69),('8784','2013-08-07','12:20:00',3.68),('8784','2013-08-07','12:25:00',3.71),('8784','2013-08-07','12:30:00',3.75),('8784','2013-08-07','12:35:00',3.75),('8784','2013-08-07','12:40:00',3.78),('8784','2013-08-07','12:45:00',3.82),('8784','2013-08-07','12:50:00',3.82),('8784','2013-08-07','12:55:00',3.8),('8784','2013-08-07','13:00:00',3.76),('8784','2013-08-07','13:05:00',3.93),('8784','2013-08-07','13:10:00',3.91),('8784','2013-08-07','13:15:00',3.93),('8784','2013-08-07','13:20:00',3.88),('8784','2013-08-07','13:25:00',3.81),('8784','2013-08-07','13:30:00',3.88),('8784','2013-08-07','13:35:00',3.83),('8784','2013-08-07','13:40:00',3.91),('8784','2013-08-07','13:45:00',3.84),('8784','2013-08-07','13:50:00',3.86),('8784','2013-08-07','13:55:00',3.88),('8784','2013-08-07','14:00:00',3.86),('8784','2013-08-07','14:05:00',3.82),('8784','2013-08-07','14:10:00',3.74),('8784','2013-08-07','14:15:00',3.72),('8784','2013-08-07','14:20:00',3.67),('8784','2013-08-07','14:25:00',3.66),('8784','2013-08-07','14:30:00',3.58),('8784','2013-08-07','14:35:00',3.55),('8784','2013-08-07','14:40:00',3.58),('8784','2013-08-07','14:45:00',3.57),('8784','2013-08-07','14:50:00',3.6),('8784','2013-08-07','14:55:00',3.55),('8784','2013-08-07','15:00:00',3.54),('8784','2013-08-07','15:05:00',3.49),('8784','2013-08-07','15:10:00',3.43),('8784','2013-08-07','15:15:00',3.42),('8784','2013-08-07','15:20:00',3.4),('8784','2013-08-07','15:25:00',3.31),('8784','2013-08-07','15:30:00',3.31),('8784','2013-08-07','15:35:00',3.28),('8784','2013-08-07','15:40:00',3.23),('8784','2013-08-07','15:45:00',3.2),('8784','2013-08-07','15:50:00',3.13),('8784','2013-08-07','15:55:00',3.07),('8784','2013-08-07','16:00:00',3),('8784','2013-08-07','16:05:00',2.94),('8784','2013-08-07','16:10:00',2.87),('8784','2013-08-07','16:15:00',2.83),('8784','2013-08-07','16:20:00',2.78),('8784','2013-08-07','16:25:00',2.74),('8784','2013-08-07','16:30:00',2.71),('8784','2013-08-07','16:35:00',2.67),('8784','2013-08-07','16:40:00',2.59),('8784','2013-08-07','16:45:00',2.55),('8784','2013-08-07','16:50:00',2.48),('8784','2013-08-07','16:55:00',2.44),('8784','2013-08-07','17:00:00',2.37),('8784','2013-08-07','17:05:00',2.29),('8784','2013-08-07','17:10:00',2.21),('8784','2013-08-07','17:15:00',2.14),('8784','2013-08-07','17:20:00',2.08),('8784','2013-08-07','17:25:00',1.97),('8784','2013-08-07','17:30:00',1.89),('8784','2013-08-07','17:35:00',1.83),('8784','2013-08-07','17:40:00',1.74),('8784','2013-08-07','17:45:00',1.67),('8784','2013-08-07','17:50:00',1.59),('8784','2013-08-07','17:55:00',1.51),('8784','2013-08-07','18:00:00',1.44),('8784','2013-08-07','18:05:00',1.34),('8784','2013-08-07','18:10:00',1.24),('8784','2013-08-07','18:15:00',1.19),('8784','2013-08-07','18:20:00',1.12),('8784','2013-08-07','18:25:00',1.06),('8784','2013-08-06','07:55:00',1.07),('8784','2013-08-06','08:00:00',1.14),('8784','2013-08-06','08:05:00',1.22),('8784','2013-08-06','08:10:00',1.3),('8784','2013-08-06','08:15:00',1.38),('8784','2013-08-06','08:20:00',1.46),('8784','2013-08-06','08:25:00',1.52),('8784','2013-08-06','08:30:00',1.6),('8784','2013-08-06','08:35:00',1.66),('8784','2013-08-06','08:40:00',1.74),('8784','2013-08-06','08:45:00',1.84),('8784','2013-08-06','08:50:00',1.93),('8784','2013-08-06','08:55:00',2),('8784','2013-08-06','09:00:00',2.07),('8784','2013-08-06','09:05:00',2.14),('8784','2013-08-06','09:10:00',2.21),('8784','2013-08-06','09:15:00',2.3),('8784','2013-08-06','09:20:00',2.36),('8784','2013-08-06','09:25:00',2.43),('8784','2013-08-06','09:30:00',2.49),('8784','2013-08-06','09:35:00',2.57),('8784','2013-08-06','09:40:00',2.63),('8784','2013-08-06','09:45:00',2.69),('8784','2013-08-06','09:50:00',2.74),('8784','2013-08-06','09:55:00',2.8),('8784','2013-08-06','10:00:00',2.87),('8784','2013-08-06','10:05:00',2.93),('8784','2013-08-06','10:10:00',2.97),('8784','2013-08-06','10:15:00',3.03),('8784','2013-08-06','10:20:00',3.07),('8784','2013-08-06','10:25:00',3.11),('8784','2013-08-06','10:30:00',3.16),('8784','2013-08-06','10:35:00',3.16),('8784','2013-08-06','10:40:00',3.24),('8784','2013-08-06','10:45:00',3.27),('8784','2013-08-06','10:50:00',3.32),('8784','2013-08-06','10:55:00',3.36),('8784','2013-08-06','11:00:00',3.41),('8784','2013-08-06','11:05:00',3.42),('8784','2013-08-06','11:10:00',3.44),('8784','2013-08-06','11:15:00',3.45),('8784','2013-08-06','11:20:00',3.5),('8784','2013-08-06','11:25:00',3.55),('8784','2013-08-06','11:30:00',3.58),('8784','2013-08-06','11:35:00',3.61),('8784','2013-08-06','11:40:00',3.64),('8784','2013-08-06','11:45:00',3.63),('8784','2013-08-06','11:50:00',3.63),('8784','2013-08-06','11:55:00',3.68),('8784','2013-08-06','12:00:00',3.69),('8784','2013-08-06','12:05:00',3.7),('8784','2013-08-06','12:10:00',3.71),('8784','2013-08-06','12:15:00',3.69),('8784','2013-08-06','12:20:00',3.71),('8784','2013-08-06','12:25:00',3.74),('8784','2013-08-06','12:30:00',3.71),('8784','2013-08-06','12:35:00',3.73),('8784','2013-08-06','12:40:00',3.75),('8784','2013-08-06','12:45:00',3.82),('8784','2013-08-06','12:50:00',3.8),('8784','2013-08-06','12:55:00',3.79),('8784','2013-08-06','13:00:00',3.79),('8784','2013-08-06','13:05:00',3.75),('8784','2013-08-06','13:10:00',3.86),('8784','2013-08-06','13:15:00',3.89),('8784','2013-08-06','13:20:00',3.87),('8784','2013-08-06','13:25:00',3.81),('8784','2013-08-06','13:30:00',3.9),('8784','2013-08-06','13:35:00',3.91),('8784','2013-08-06','13:40:00',3.88),('8784','2013-08-06','13:45:00',3.9),('8784','2013-08-06','13:50:00',3.93),('8784','2013-08-06','13:55:00',3.93),('8784','2013-08-06','14:00:00',3.93),('8784','2013-08-06','14:05:00',3.92),('8784','2013-08-06','14:10:00',3.9),('8784','2013-08-06','14:15:00',3.9),('8784','2013-08-06','14:20:00',3.88),('8784','2013-08-06','14:25:00',3.86),('8784','2013-08-06','14:30:00',3.82),('8784','2013-08-06','14:35:00',3.8),('8784','2013-08-06','14:40:00',3.77),('8784','2013-08-06','14:45:00',3.75),('8784','2013-08-06','14:50:00',3.73),('8784','2013-08-06','14:55:00',3.69),('8784','2013-08-06','15:00:00',3.67),('8784','2013-08-06','15:05:00',3.64),('8784','2013-08-06','15:10:00',3.6),('8784','2013-08-06','15:15:00',3.58),('8784','2013-08-06','15:20:00',3.54),('8784','2013-08-06','15:25:00',3.45),('8784','2013-08-06','15:30:00',3.45),('8784','2013-08-06','15:35:00',3.41),('8784','2013-08-06','15:40:00',3.37),('8784','2013-08-06','15:45:00',3.3),('8784','2013-08-06','15:50:00',3.26),('8784','2013-08-06','15:55:00',3.2),('8784','2013-08-06','16:00:00',3.15),('8784','2013-08-06','16:05:00',3.09),('8784','2013-08-06','16:10:00',3.04),('8784','2013-08-06','16:15:00',3),('8784','2013-08-06','16:20:00',2.93),('8784','2013-08-06','16:25:00',2.86),('8784','2013-08-06','16:30:00',2.79),('8784','2013-08-06','16:35:00',2.73),('8784','2013-08-06','16:40:00',2.66),('8784','2013-08-06','16:45:00',2.6),('8784','2013-08-06','16:50:00',2.53),('8784','2013-08-06','16:55:00',2.48),('8784','2013-08-06','17:00:00',2.42),('8784','2013-08-06','17:05:00',2.35),('8784','2013-08-06','17:10:00',2.23),('8784','2013-08-06','17:15:00',2.19),('8784','2013-08-06','17:20:00',2.12),('8784','2013-08-06','17:25:00',2.05),('8784','2013-08-06','17:30:00',1.97),('8784','2013-08-06','17:35:00',1.89),('8784','2013-08-06','17:40:00',1.81),('8784','2013-08-06','17:45:00',1.73),('8784','2013-08-06','17:50:00',1.65),('8784','2013-08-06','17:55:00',1.57),('8784','2013-08-06','18:00:00',1.49),('8784','2013-08-06','18:05:00',1.41),('8784','2013-08-06','18:10:00',1.34),('8784','2013-08-06','18:15:00',1.26),('8784','2013-08-06','18:20:00',1.19),('8784','2013-08-06','18:25:00',1.09),('8784','2013-08-06','18:30:00',1.04),('8784','2013-08-05','07:50:00',1.07),('8784','2013-08-05','07:55:00',1.16),('8784','2013-08-05','08:00:00',1.23),('8784','2013-08-05','08:05:00',1.3),('8784','2013-08-05','08:10:00',1.39),('8784','2013-08-05','08:15:00',1.46),('8784','2013-08-05','08:20:00',1.54),('8784','2013-08-05','08:25:00',1.61),('8784','2013-08-05','08:30:00',1.68),('8784','2013-08-05','08:35:00',1.75),('8784','2013-08-05','08:40:00',1.83),('8784','2013-08-05','08:45:00',1.9),('8784','2013-08-05','08:50:00',1.97),('8784','2013-08-05','08:55:00',2.05),('8784','2013-08-05','09:00:00',2.11),('8784','2013-08-05','09:05:00',2.15),('8784','2013-08-05','09:10:00',2.24),('8784','2013-08-05','09:15:00',2.33),('8784','2013-08-05','09:20:00',2.38),('8784','2013-08-05','09:25:00',2.4),('8784','2013-08-05','09:30:00',2.49),('8784','2013-08-05','09:35:00',2.57),('8784','2013-08-05','09:40:00',2.65),('8784','2013-08-05','09:45:00',2.7),('8784','2013-08-05','09:50:00',2.75),('8784','2013-08-05','09:55:00',2.82),('8784','2013-08-05','10:00:00',2.89),('8784','2013-08-05','10:05:00',2.94),('8784','2013-08-05','10:10:00',2.99),('8784','2013-08-05','10:15:00',3.06),('8784','2013-08-05','10:20:00',3.08),('8784','2013-08-05','10:25:00',3.16),('8784','2013-08-05','10:30:00',3.18),('8784','2013-08-05','10:35:00',3.22),('8784','2013-08-05','10:40:00',3.28),('8784','2013-08-05','10:45:00',3.34),('8784','2013-08-05','10:50:00',3.38),('8784','2013-08-05','10:55:00',3.43),('8784','2013-08-05','11:00:00',3.46),('8784','2013-08-05','11:05:00',3.51),('8784','2013-08-05','11:10:00',3.53),('8784','2013-08-05','11:15:00',3.57),('8784','2013-08-05','11:20:00',3.61),('8784','2013-08-05','11:25:00',3.64),('8784','2013-08-05','11:30:00',3.66),('8784','2013-08-05','11:35:00',3.73),('8784','2013-08-05','11:40:00',3.74),('8784','2013-08-05','11:45:00',3.72),('8784','2013-08-05','11:50:00',3.75),('8784','2013-08-05','11:55:00',3.79),('8784','2013-08-05','12:00:00',3.82),('8784','2013-08-05','12:05:00',3.82),('8784','2013-08-05','12:10:00',3.84),('8784','2013-08-05','12:15:00',3.83),('8784','2013-08-05','12:20:00',3.83),('8784','2013-08-05','12:25:00',3.89),('8784','2013-08-05','12:30:00',3.9),('8784','2013-08-05','12:35:00',3.88),('8784','2013-08-05','12:40:00',3.91),('8784','2013-08-05','12:45:00',3.91),('8784','2013-08-05','12:50:00',3.89),('8784','2013-08-05','12:55:00',3.87),('8784','2013-08-05','13:00:00',3.88),('8784','2013-08-05','13:05:00',3.89),('8784','2013-08-05','13:10:00',3.89),('8784','2013-08-05','13:15:00',3.9),('8784','2013-08-05','13:20:00',3.85),('8784','2013-08-05','13:25:00',3.91),('8784','2013-08-05','13:30:00',3.9),('8784','2013-08-05','13:35:00',3.89),('8784','2013-08-05','13:40:00',3.87),('8784','2013-08-05','13:45:00',3.79),('8784','2013-08-05','13:50:00',3.84),('8784','2013-08-05','13:55:00',3.81),('8784','2013-08-05','14:00:00',3.83),('8784','2013-08-05','14:05:00',3.86),('8784','2013-08-05','14:10:00',3.83),('8784','2013-08-05','14:15:00',3.79),('8784','2013-08-05','14:20:00',3.78),('8784','2013-08-05','14:25:00',3.74),('8784','2013-08-05','14:30:00',3.71),('8784','2013-08-05','14:35:00',3.72),('8784','2013-08-05','14:40:00',3.71),('8784','2013-08-05','14:45:00',3.66),('8784','2013-08-05','14:50:00',3.62),('8784','2013-08-05','14:55:00',3.6),('8784','2013-08-05','15:00:00',3.57),('8784','2013-08-05','15:05:00',3.58),('8784','2013-08-05','15:10:00',3.54),('8784','2013-08-05','15:15:00',3.52),('8784','2013-08-05','15:20:00',3.48),('8784','2013-08-05','15:25:00',3.47),('8784','2013-08-05','15:30:00',3.44),('8784','2013-08-05','15:35:00',3.39),('8784','2013-08-05','15:40:00',3.33),('8784','2013-08-05','15:45:00',3.3),('8784','2013-08-05','15:50:00',3.25),('8784','2013-08-05','15:55:00',3.17),('8784','2013-08-05','16:00:00',3.16),('8784','2013-08-05','16:05:00',3.1),('8784','2013-08-05','16:10:00',3.06),('8784','2013-08-05','16:15:00',2.99),('8784','2013-08-05','16:20:00',2.91),('8784','2013-08-05','16:25:00',2.84),('8784','2013-08-05','16:30:00',2.78),('8784','2013-08-05','16:35:00',2.74),('8784','2013-08-05','16:40:00',2.66),('8784','2013-08-05','16:45:00',2.6),('8784','2013-08-05','16:50:00',2.53),('8784','2013-08-05','16:55:00',2.46),('8784','2013-08-05','17:00:00',2.38),('8784','2013-08-05','17:05:00',2.32),('8784','2013-08-05','17:10:00',2.24),('8784','2013-08-05','17:15:00',2.16),('8784','2013-08-05','17:20:00',2.09),('8784','2013-08-05','17:25:00',2.01),('8784','2013-08-05','17:30:00',1.94),('8784','2013-08-05','17:35:00',1.88),('8784','2013-08-05','17:40:00',1.81),('8784','2013-08-05','17:45:00',1.72),('8784','2013-08-05','17:50:00',1.63),('8784','2013-08-05','17:55:00',1.55),('8784','2013-08-05','18:00:00',1.47),('8784','2013-08-05','18:05:00',1.38),('8784','2013-08-05','18:10:00',1.3),('8784','2013-08-05','18:15:00',1.22),('8784','2013-08-05','18:20:00',1.15),('8784','2013-08-05','18:25:00',1.08),('8784','2013-08-05','18:30:00',1.01),('8784','2013-08-04','07:45:00',1.07),('8784','2013-08-04','07:50:00',1.15),('8784','2013-08-04','07:55:00',1.23),('8784','2013-08-04','08:00:00',1.31),('8784','2013-08-04','08:05:00',1.39),('8784','2013-08-04','08:10:00',1.47),('8784','2013-08-04','08:15:00',1.56),('8784','2013-08-04','08:20:00',1.64),('8784','2013-08-04','08:25:00',1.72),('8784','2013-08-04','08:30:00',1.78),('8784','2013-08-04','08:35:00',1.88),('8784','2013-08-04','08:40:00',1.95),('8784','2013-08-04','08:45:00',2.03),('8784','2013-08-04','08:50:00',2.1),('8784','2013-08-04','08:55:00',2.19),('8784','2013-08-04','09:00:00',2.26),('8784','2013-08-04','09:05:00',2.34),('8784','2013-08-04','09:10:00',2.4),('8784','2013-08-04','09:15:00',2.47),('8784','2013-08-04','09:20:00',2.52),('8784','2013-08-04','09:25:00',2.6),('8784','2013-08-04','09:30:00',2.66),('8784','2013-08-04','09:35:00',2.74),('8784','2013-08-04','09:40:00',2.8),('8784','2013-08-04','09:45:00',2.87),('8784','2013-08-04','09:50:00',2.92),('8784','2013-08-04','09:55:00',2.98),('8784','2013-08-04','10:00:00',3.03),('8784','2013-08-04','10:05:00',3.08),('8784','2013-08-04','10:10:00',3.14),('8784','2013-08-04','10:15:00',3.2),('8784','2013-08-04','10:20:00',3.25),('8784','2013-08-04','10:25:00',3.3),('8784','2013-08-04','10:30:00',3.34),('8784','2013-08-04','10:35:00',3.37),('8784','2013-08-04','10:40:00',3.41),('8784','2013-08-04','10:45:00',3.44),('8784','2013-08-04','10:50:00',3.48),('8784','2013-08-04','10:55:00',3.53),('8784','2013-08-04','11:00:00',3.55),('8784','2013-08-04','11:05:00',3.57),('8784','2013-08-04','11:10:00',3.59),('8784','2013-08-04','11:15:00',3.63),('8784','2013-08-04','11:20:00',3.67),('8784','2013-08-04','11:25:00',3.73),('8784','2013-08-04','11:30:00',3.75),('8784','2013-08-04','11:35:00',3.82),('8784','2013-08-04','11:40:00',3.83),('8784','2013-08-04','11:45:00',3.87),('8784','2013-08-04','11:50:00',3.9),('8784','2013-08-04','11:55:00',3.95),('8784','2013-08-04','12:00:00',3.96),('8784','2013-08-04','12:05:00',3.93),('8784','2013-08-04','12:10:00',3.97),('8784','2013-08-04','12:15:00',3.98),('8784','2013-08-04','12:20:00',3.98),('8784','2013-08-04','12:25:00',4),('8784','2013-08-04','12:30:00',4.01),('8784','2013-08-04','12:35:00',3.99),('8784','2013-08-04','12:40:00',4.03),('8784','2013-08-04','12:45:00',4.02),('8784','2013-08-04','12:50:00',4.03),('8784','2013-08-04','12:55:00',4.02),('8784','2013-08-04','13:00:00',3.93),('8784','2013-08-04','13:05:00',3.95),('8784','2013-08-04','13:10:00',4),('8784','2013-08-04','13:15:00',3.96),('8784','2013-08-04','13:20:00',3.99),('8784','2013-08-04','13:25:00',4.03),('8784','2013-08-04','13:30:00',4.01),('8784','2013-08-04','13:35:00',4.06),('8784','2013-08-04','13:40:00',4.05),('8784','2013-08-04','13:45:00',4.07),('8784','2013-08-04','13:50:00',4.05),('8784','2013-08-04','13:55:00',4.04),('8784','2013-08-04','14:00:00',4.05),('8784','2013-08-04','14:05:00',4.04),('8784','2013-08-04','14:10:00',4.02),('8784','2013-08-04','14:15:00',3.98),('8784','2013-08-04','14:20:00',3.96),('8784','2013-08-04','14:25:00',3.95),('8784','2013-08-04','14:30:00',3.89),('8784','2013-08-04','14:35:00',3.87),('8784','2013-08-04','14:40:00',3.85),('8784','2013-08-04','14:45:00',3.84),('8784','2013-08-04','14:50:00',3.81),('8784','2013-08-04','14:55:00',3.77),('8784','2013-08-04','15:00:00',3.72),('8784','2013-08-04','15:05:00',3.7),('8784','2013-08-04','15:10:00',3.69),('8784','2013-08-04','15:15:00',3.65),('8784','2013-08-04','15:20:00',3.61),('8784','2013-08-04','15:25:00',3.55),('8784','2013-08-04','15:30:00',3.48),('8784','2013-08-04','15:35:00',3.48),('8784','2013-08-04','15:40:00',3.39),('8784','2013-08-04','15:45:00',3.32),('8784','2013-08-04','15:50:00',3.24),('8784','2013-08-04','15:55:00',3.26),('8784','2013-08-04','16:00:00',3.15),('8784','2013-08-04','16:05:00',3.17),('8784','2013-08-04','16:10:00',3.13),('8784','2013-08-04','16:15:00',3.06),('8784','2013-08-04','16:20:00',2.96),('8784','2013-08-04','16:25:00',2.96),('8784','2013-08-04','16:30:00',2.89),('8784','2013-08-04','16:35:00',2.83),('8784','2013-08-04','16:40:00',2.77),('8784','2013-08-04','16:45:00',2.7),('8784','2013-08-04','16:50:00',2.6),('8784','2013-08-04','16:55:00',2.53),('8784','2013-08-04','17:00:00',2.51),('8784','2013-08-04','17:05:00',2.44),('8784','2013-08-04','17:10:00',2.36),('8784','2013-08-04','17:15:00',2.27),('8784','2013-08-04','17:20:00',2.2),('8784','2013-08-04','17:25:00',2.11),('8784','2013-08-04','17:30:00',2.03),('8784','2013-08-04','17:35:00',1.95),('8784','2013-08-04','17:40:00',1.87),('8784','2013-08-04','17:45:00',1.79),('8784','2013-08-04','17:50:00',1.71),('8784','2013-08-04','17:55:00',1.62),('8784','2013-08-04','18:00:00',1.54),('8784','2013-08-04','18:05:00',1.43),('8784','2013-08-04','18:10:00',1.35),('8784','2013-08-04','18:15:00',1.29),('8784','2013-08-04','18:20:00',1.22),('8784','2013-08-04','18:25:00',1.13),('8784','2013-08-04','18:30:00',1.05),('8784','2013-08-03','07:45:00',1.07),('8784','2013-08-03','07:50:00',1.15),('8784','2013-08-03','07:55:00',1.23),('8784','2013-08-03','08:00:00',1.29),('8784','2013-08-03','08:05:00',1.38),('8784','2013-08-03','08:10:00',1.46),('8784','2013-08-03','08:15:00',1.54),('8784','2013-08-03','08:20:00',1.62),('8784','2013-08-03','08:25:00',1.7),('8784','2013-08-03','08:30:00',1.79),('8784','2013-08-03','08:35:00',1.86),('8784','2013-08-03','08:40:00',1.93),('8784','2013-08-03','08:45:00',2.01),('8784','2013-08-03','08:50:00',2.06),('8784','2013-08-03','08:55:00',2.16),('8784','2013-08-03','09:00:00',2.24),('8784','2013-08-03','09:05:00',2.31),('8784','2013-08-03','09:10:00',2.39),('8784','2013-08-03','09:15:00',2.45),('8784','2013-08-03','09:20:00',2.52),('8784','2013-08-03','09:25:00',2.58),('8784','2013-08-03','09:30:00',2.64),('8784','2013-08-03','09:35:00',2.72),('8784','2013-08-03','09:40:00',2.78),('8784','2013-08-03','09:45:00',2.83),('8784','2013-08-03','09:50:00',2.89),('8784','2013-08-03','09:55:00',2.95),('8784','2013-08-03','10:00:00',3.01),('8784','2013-08-03','10:05:00',3.06),('8784','2013-08-03','10:10:00',3.1),('8784','2013-08-03','10:15:00',3.18),('8784','2013-08-03','10:20:00',3.24),('8784','2013-08-03','10:25:00',3.29),('8784','2013-08-03','10:30:00',3.31),('8784','2013-08-03','10:35:00',3.34),('8784','2013-08-03','10:40:00',3.4),('8784','2013-08-03','10:45:00',3.47),('8784','2013-08-03','10:50:00',3.5),('8784','2013-08-03','10:55:00',3.56),('8784','2013-08-03','11:00:00',3.56),('8784','2013-08-03','11:05:00',3.63),('8784','2013-08-03','11:10:00',3.63),('8784','2013-08-03','11:15:00',3.69),('8784','2013-08-03','11:20:00',3.7),('8784','2013-08-03','11:25:00',3.74),('8784','2013-08-03','11:30:00',3.77),('8784','2013-08-03','11:35:00',3.75),('8784','2013-08-03','11:40:00',3.8),('8784','2013-08-03','11:45:00',3.84),('8784','2013-08-03','11:50:00',3.84),('8784','2013-08-03','11:55:00',3.86),('8784','2013-08-03','12:00:00',3.89),('8784','2013-08-03','12:05:00',3.9),('8784','2013-08-03','12:10:00',3.87),('8784','2013-08-03','12:15:00',3.87),('8784','2013-08-03','12:20:00',3.91),('8784','2013-08-03','12:25:00',3.91),('8784','2013-08-03','12:30:00',3.92),('8784','2013-08-03','12:35:00',3.92),('8784','2013-08-03','12:40:00',3.91),('8784','2013-08-03','12:45:00',3.92),('8784','2013-08-03','12:50:00',3.83),('8784','2013-08-03','12:55:00',3.87),('8784','2013-08-03','13:00:00',3.89),('8784','2013-08-03','13:05:00',3.94),('8784','2013-08-03','13:10:00',3.92),('8784','2013-08-03','13:15:00',3.89),('8784','2013-08-03','13:20:00',3.86),('8784','2013-08-03','13:25:00',3.82),('8784','2013-08-03','13:30:00',3.82),('8784','2013-08-03','13:35:00',3.89),('8784','2013-08-03','13:40:00',3.93),('8784','2013-08-03','13:45:00',3.89),('8784','2013-08-03','13:50:00',3.86),('8784','2013-08-03','13:55:00',3.8),('8784','2013-08-03','14:00:00',3.81),('8784','2013-08-03','14:05:00',3.79),('8784','2013-08-03','14:10:00',3.77),('8784','2013-08-03','14:15:00',3.72),('8784','2013-08-03','14:20:00',3.76),('8784','2013-08-03','14:25:00',3.76),('8784','2013-08-03','14:30:00',3.76),('8784','2013-08-03','14:35:00',3.82),('8784','2013-08-03','14:40:00',3.82),('8784','2013-08-03','14:45:00',3.79),('8784','2013-08-03','14:50:00',3.8),('8784','2013-08-03','14:55:00',3.76),('8784','2013-08-03','15:00:00',3.73),('8784','2013-08-03','15:05:00',3.69),('8784','2013-08-03','15:10:00',3.64),('8784','2013-08-03','15:15:00',3.58),('8784','2013-08-03','15:20:00',3.54),('8784','2013-08-03','15:25:00',3.54),('8784','2013-08-03','15:30:00',3.52),('8784','2013-08-03','15:35:00',3.45),('8784','2013-08-03','15:40:00',3.41),('8784','2013-08-03','15:45:00',3.38),('8784','2013-08-03','15:50:00',3.32),('8784','2013-08-03','15:55:00',3.27),('8784','2013-08-03','16:00:00',3.2),('8784','2013-08-03','16:05:00',3.11),('8784','2013-08-03','16:10:00',3.06),('8784','2013-08-03','16:15:00',2.98),('8784','2013-08-03','16:20:00',2.93),('8784','2013-08-03','16:25:00',2.88),('8784','2013-08-03','16:30:00',2.83),('8784','2013-08-03','16:35:00',2.77),('8784','2013-08-03','16:40:00',2.71),('8784','2013-08-03','16:45:00',2.65),('8784','2013-08-03','16:50:00',2.61),('8784','2013-08-03','16:55:00',2.53),('8784','2013-08-03','17:00:00',2.47),('8784','2013-08-03','17:05:00',2.38),('8784','2013-08-03','17:10:00',2.32),('8784','2013-08-03','17:15:00',2.24),('8784','2013-08-03','17:20:00',2.16),('8784','2013-08-03','17:25:00',2.08),('8784','2013-08-03','17:30:00',2.01),('8784','2013-08-03','17:35:00',1.92),('8784','2013-08-03','17:40:00',1.87),('8784','2013-08-03','17:45:00',1.79),('8784','2013-08-03','17:50:00',1.7),('8784','2013-08-03','17:55:00',1.63),('8784','2013-08-03','18:00:00',1.55),('8784','2013-08-03','18:05:00',1.46),('8784','2013-08-03','18:10:00',1.39),('8784','2013-08-03','18:15:00',1.31),('8784','2013-08-03','18:20:00',1.24),('8784','2013-08-03','18:25:00',1.16),('8784','2013-08-03','18:30:00',1.09),('8784','2013-08-03','18:35:00',1.02),('8784','2013-08-02','07:40:00',1.06),('8784','2013-08-02','07:45:00',1.14),('8784','2013-08-02','07:50:00',1.22),('8784','2013-08-02','07:55:00',1.31),('8784','2013-08-02','08:00:00',1.39),('8784','2013-08-02','08:05:00',1.47),('8784','2013-08-02','08:10:00',1.55),('8784','2013-08-02','08:15:00',1.61),('8784','2013-08-02','08:20:00',1.72),('8784','2013-08-02','08:25:00',1.8),('8784','2013-08-02','08:30:00',1.88),('8784','2013-08-02','08:35:00',1.95),('8784','2013-08-02','08:40:00',2.03),('8784','2013-08-02','08:45:00',2.1),('8784','2013-08-02','08:50:00',2.18),('8784','2013-08-02','08:55:00',2.25),('8784','2013-08-02','09:00:00',2.32),('8784','2013-08-02','09:05:00',2.41),('8784','2013-08-02','09:10:00',2.48),('8784','2013-08-02','09:15:00',2.54),('8784','2013-08-02','09:20:00',2.62),('8784','2013-08-02','09:25:00',2.69),('8784','2013-08-02','09:30:00',2.69),('8784','2013-08-02','09:35:00',2.81),('8784','2013-08-02','09:40:00',2.86),('8784','2013-08-02','09:45:00',2.92),('8784','2013-08-02','09:50:00',2.97),('8784','2013-08-02','09:55:00',3.02),('8784','2013-08-02','10:00:00',3.09),('8784','2013-08-02','10:05:00',3.15),('8784','2013-08-02','10:10:00',3.19),('8784','2013-08-02','10:15:00',3.24),('8784','2013-08-02','10:20:00',3.29),('8784','2013-08-02','10:25:00',3.33),('8784','2013-08-02','10:30:00',3.37),('8784','2013-08-02','10:35:00',3.44),('8784','2013-08-02','10:40:00',3.48),('8784','2013-08-02','10:45:00',3.53),('8784','2013-08-02','10:50:00',3.56),('8784','2013-08-02','10:55:00',3.57),('8784','2013-08-02','11:00:00',3.61),('8784','2013-08-02','11:05:00',3.66),('8784','2013-08-02','11:10:00',3.7),('8784','2013-08-02','11:15:00',3.71),('8784','2013-08-02','11:20:00',3.76),('8784','2013-08-02','11:25:00',3.81),('8784','2013-08-02','11:30:00',3.85),('8784','2013-08-02','11:35:00',3.88),('8784','2013-08-02','11:40:00',3.88),('8784','2013-08-02','11:45:00',3.88),('8784','2013-08-02','11:50:00',3.92),('8784','2013-08-02','11:55:00',3.96),('8784','2013-08-02','12:00:00',4),('8784','2013-08-02','12:05:00',4),('8784','2013-08-02','12:10:00',4.01),('8784','2013-08-02','12:15:00',4.04),('8784','2013-08-02','12:20:00',4.03),('8784','2013-08-02','12:25:00',4.03),('8784','2013-08-02','12:30:00',4.01),('8784','2013-08-02','12:35:00',4.05),('8784','2013-08-02','12:40:00',4.04),('8784','2013-08-02','12:45:00',4.04),('8784','2013-08-02','12:50:00',4.04),('8784','2013-08-02','12:55:00',4.05),('8784','2013-08-02','13:00:00',4.05),('8784','2013-08-02','13:05:00',4.06),('8784','2013-08-02','13:10:00',4.05),('8784','2013-08-02','13:15:00',4.07),('8784','2013-08-02','13:20:00',4.04),('8784','2013-08-02','13:25:00',4.04),('8784','2013-08-02','13:30:00',4.01),('8784','2013-08-02','13:35:00',4.04),('8784','2013-08-02','13:40:00',4.05),('8784','2013-08-02','13:45:00',4.03),('8784','2013-08-02','13:50:00',4.01),('8784','2013-08-02','13:55:00',4.02),('8784','2013-08-02','14:00:00',4.02),('8784','2013-08-02','14:05:00',4),('8784','2013-08-02','14:10:00',3.94),('8784','2013-08-02','14:15:00',3.94),('8784','2013-08-02','14:20:00',3.82),('8784','2013-08-02','14:25:00',3.83),('8784','2013-08-02','14:30:00',3.86),('8784','2013-08-02','14:35:00',3.91),('8784','2013-08-02','14:40:00',3.91),('8784','2013-08-02','14:45:00',3.89),('8784','2013-08-02','14:50:00',3.84),('8784','2013-08-02','14:55:00',3.82),('8784','2013-08-02','15:00:00',3.78),('8784','2013-08-02','15:05:00',3.73),('8784','2013-08-02','15:10:00',3.68),('8784','2013-08-02','15:15:00',3.63),('8784','2013-08-02','15:20:00',3.62),('8784','2013-08-02','15:25:00',3.62),('8784','2013-08-02','15:30:00',3.57),('8784','2013-08-02','15:35:00',3.52),('8784','2013-08-02','15:40:00',3.46),('8784','2013-08-02','15:45:00',3.43),('8784','2013-08-02','15:50:00',3.35),('8784','2013-08-02','15:55:00',3.3),('8784','2013-08-02','16:00:00',3.29),('8784','2013-08-02','16:05:00',3.23),('8784','2013-08-02','16:10:00',3.16),('8784','2013-08-02','16:15:00',3.11),('8784','2013-08-02','16:20:00',3.05),('8784','2013-08-02','16:25:00',2.98),('8784','2013-08-02','16:30:00',2.93),('8784','2013-08-02','16:35:00',2.89),('8784','2013-08-02','16:40:00',2.82),('8784','2013-08-02','16:45:00',2.76),('8784','2013-08-02','16:50:00',2.68),('8784','2013-08-02','16:55:00',2.6),('8784','2013-08-02','17:00:00',2.51),('8784','2013-08-02','17:05:00',2.44),('8784','2013-08-02','17:10:00',2.39),('8784','2013-08-02','17:15:00',2.34),('8784','2013-08-02','17:20:00',2.24),('8784','2013-08-02','17:25:00',2.17),('8784','2013-08-02','17:30:00',2.08),('8784','2013-08-02','17:35:00',2.02),('8784','2013-08-02','17:40:00',1.94),('8784','2013-08-02','17:45:00',1.86),('8784','2013-08-02','17:50:00',1.76),('8784','2013-08-02','17:55:00',1.67),('8784','2013-08-02','18:00:00',1.61),('8784','2013-08-02','18:05:00',1.53),('8784','2013-08-02','18:10:00',1.44),('8784','2013-08-02','18:15:00',1.37),('8784','2013-08-02','18:20:00',1.28),('8784','2013-08-02','18:25:00',1.21),('8784','2013-08-02','18:30:00',1.13),('8784','2013-08-02','18:35:00',1.05),('8784','2013-08-01','07:40:00',1.08),('8784','2013-08-01','07:45:00',1.16),('8784','2013-08-01','07:50:00',1.23),('8784','2013-08-01','07:55:00',1.31),('8784','2013-08-01','08:00:00',1.39),('8784','2013-08-01','08:05:00',1.47),('8784','2013-08-01','08:10:00',1.55),('8784','2013-08-01','08:15:00',1.64),('8784','2013-08-01','08:20:00',1.72),('8784','2013-08-01','08:25:00',1.81),('8784','2013-08-01','08:30:00',1.89),('8784','2013-08-01','08:35:00',1.99),('8784','2013-08-01','08:40:00',2.07),('8784','2013-08-01','08:45:00',2.15),('8784','2013-08-01','08:50:00',2.23),('8784','2013-08-01','08:55:00',2.31),('8784','2013-08-01','09:00:00',2.39),('8784','2013-08-01','09:05:00',2.46),('8784','2013-08-01','09:10:00',2.54),('8784','2013-08-01','09:15:00',2.63),('8784','2013-08-01','09:20:00',2.71),('8784','2013-08-01','09:25:00',2.77),('8784','2013-08-01','09:30:00',2.83),('8784','2013-08-01','09:35:00',2.89),('8784','2013-08-01','09:40:00',2.96),('8784','2013-08-01','09:45:00',3.01),('8784','2013-08-01','09:50:00',3.1),('8784','2013-08-01','09:55:00',3.16),('8784','2013-08-01','10:00:00',3.23),('8784','2013-08-01','10:05:00',3.29),('8784','2013-08-01','10:10:00',3.36),('8784','2013-08-01','10:15:00',3.4),('8784','2013-08-01','10:20:00',3.41),('8784','2013-08-01','10:25:00',3.48),('8784','2013-08-01','10:30:00',3.56),('8784','2013-08-01','10:35:00',3.59),('8784','2013-08-01','10:40:00',3.62),('8784','2013-08-01','10:45:00',3.67),('8784','2013-08-01','10:50:00',3.74),('8784','2013-08-01','10:55:00',3.75),('8784','2013-08-01','11:00:00',3.78),('8784','2013-08-01','11:05:00',3.85),('8784','2013-08-01','11:10:00',3.91),('8784','2013-08-01','11:15:00',3.95),('8784','2013-08-01','11:20:00',3.97),('8784','2013-08-01','11:25:00',4.02),('8784','2013-08-01','11:30:00',3.97),('8784','2013-08-01','11:35:00',4.07),('8784','2013-08-01','11:40:00',4.12),('8784','2013-08-01','11:45:00',4.15),('8784','2013-08-01','11:50:00',4.17),('8784','2013-08-01','11:55:00',4.18),('8784','2013-08-01','12:00:00',4.19),('8784','2013-08-01','12:05:00',4.21),('8784','2013-08-01','12:10:00',4.2),('8784','2013-08-01','12:15:00',4.23),('8784','2013-08-01','12:20:00',4.26),('8784','2013-08-01','12:25:00',4.28),('8784','2013-08-01','12:30:00',4.27),('8784','2013-08-01','12:35:00',4.28),('8784','2013-08-01','12:40:00',4.3),('8784','2013-08-01','12:45:00',4.27),('8784','2013-08-01','12:50:00',4.34),('8784','2013-08-01','12:55:00',4.3),('8784','2013-08-01','13:00:00',4.31),('8784','2013-08-01','13:05:00',4.3),('8784','2013-08-01','13:10:00',4.32),('8784','2013-08-01','13:15:00',3.96),('8784','2013-08-01','13:20:00',4.36),('8784','2013-08-01','13:25:00',4.32),('8784','2013-08-01','13:30:00',4.27),('8784','2013-08-01','13:35:00',4.32),('8784','2013-08-01','13:40:00',4.29),('8784','2013-08-01','13:45:00',4.36),('8784','2013-08-01','13:50:00',4.27),('8784','2013-08-01','13:55:00',3.9),('8784','2013-08-01','14:00:00',3.99),('8784','2013-08-01','14:05:00',4.22),('8784','2013-08-01','14:10:00',4.16),('8784','2013-08-01','14:15:00',4.09),('8784','2013-08-01','14:20:00',4.04),('8784','2013-08-01','14:25:00',4.05),('8784','2013-08-01','14:30:00',3.98),('8784','2013-08-01','14:35:00',3.9),('8784','2013-08-01','14:40:00',3.84),('8784','2013-08-01','14:45:00',4),('8784','2013-08-01','14:50:00',2.89),('8784','2013-08-01','14:55:00',3.95),('8784','2013-08-01','15:00:00',3.84),('8784','2013-08-01','15:05:00',3.86),('8784','2013-08-01','15:10:00',3.87),('8784','2013-08-01','15:15:00',3.88),('8784','2013-08-01','15:20:00',3.81),('8784','2013-08-01','15:25:00',3.74),('8784','2013-08-01','15:30:00',3.66),('8784','2013-08-01','15:35:00',3.67),('8784','2013-08-01','15:40:00',2.88),('8784','2013-08-01','15:45:00',3.53),('8784','2013-08-01','15:50:00',3.45),('8784','2013-08-01','15:55:00',3.44),('8784','2013-08-01','16:00:00',3.43),('8784','2013-08-01','16:05:00',3.38),('8784','2013-08-01','16:10:00',3.26),('8784','2013-08-01','16:15:00',3.18),('8784','2013-08-01','16:20:00',3.13),('8784','2013-08-01','16:25:00',3.09),('8784','2013-08-01','16:30:00',3),('8784','2013-08-01','16:35:00',2.96),('8784','2013-08-01','16:40:00',2.89),('8784','2013-08-01','16:45:00',2.81),('8784','2013-08-01','16:50:00',2.74),('8784','2013-08-01','16:55:00',2.67),('8784','2013-08-01','17:00:00',2.59),('8784','2013-08-01','17:05:00',2.52),('8784','2013-08-01','17:10:00',2.45),('8784','2013-08-01','17:15:00',2.37),('8784','2013-08-01','17:20:00',2.29),('8784','2013-08-01','17:25:00',2.21),('8784','2013-08-01','17:30:00',2.14),('8784','2013-08-01','17:35:00',2.05),('8784','2013-08-01','17:40:00',1.98),('8784','2013-08-01','17:45:00',1.9),('8784','2013-08-01','17:50:00',1.82),('8784','2013-08-01','17:55:00',1.75),('8784','2013-08-01','18:00:00',1.66),('8784','2013-08-01','18:05:00',1.57),('8784','2013-08-01','18:10:00',1.49),('8784','2013-08-01','18:15:00',1.41),('8784','2013-08-01','18:20:00',1.34),('8784','2013-08-01','18:25:00',1.26),('8784','2013-08-01','18:30:00',1.18),('8784','2013-08-01','18:35:00',1.1),('8784','2013-08-01','18:40:00',1.02),('8784','2013-07-31','07:40:00',1.11),('8784','2013-07-31','07:45:00',1.2),('8784','2013-07-31','07:50:00',1.27),('8784','2013-07-31','07:55:00',1.35),('8784','2013-07-31','08:00:00',1.44),('8784','2013-07-31','08:05:00',1.53),('8784','2013-07-31','08:10:00',1.61),('8784','2013-07-31','08:15:00',1.7),('8784','2013-07-31','08:20:00',1.79),('8784','2013-07-31','08:25:00',1.86),('8784','2013-07-31','08:30:00',1.95),('8784','2013-07-31','08:35:00',2.04),('8784','2013-07-31','08:40:00',2.11),('8784','2013-07-31','08:45:00',2.19),('8784','2013-07-31','08:50:00',2.28),('8784','2013-07-31','08:55:00',2.36),('8784','2013-07-31','09:00:00',2.43),('8784','2013-07-31','09:05:00',2.51),('8784','2013-07-31','09:10:00',2.59),('8784','2013-07-31','09:15:00',2.66),('8784','2013-07-31','09:20:00',2.73),('8784','2013-07-31','09:25:00',2.79),('8784','2013-07-31','09:30:00',2.85),('8784','2013-07-31','09:35:00',2.94),('8784','2013-07-31','09:40:00',3),('8784','2013-07-31','09:45:00',3.05),('8784','2013-07-31','09:50:00',3.13),('8784','2013-07-31','09:55:00',3.19),('8784','2013-07-31','10:00:00',3.23),('8784','2013-07-31','10:05:00',3.31),('8784','2013-07-31','10:10:00',3.34),('8784','2013-07-31','10:15:00',3.37),('8784','2013-07-31','10:20:00',3.45),('8784','2013-07-31','10:25:00',3.5),('8784','2013-07-31','10:30:00',3.57),('8784','2013-07-31','10:35:00',3.61),('8784','2013-07-31','10:40:00',3.66),('8784','2013-07-31','10:45:00',3.71),('8784','2013-07-31','10:50:00',3.77),('8784','2013-07-31','10:55:00',3.82),('8784','2013-07-31','11:00:00',3.87),('8784','2013-07-31','11:05:00',3.89),('8784','2013-07-31','11:10:00',3.93),('8784','2013-07-31','11:15:00',3.98),('8784','2013-07-31','11:20:00',3.99),('8784','2013-07-31','11:25:00',4.04),('8784','2013-07-31','11:30:00',4.05),('8784','2013-07-31','11:35:00',4.09),('8784','2013-07-31','11:40:00',4.11),('8784','2013-07-31','11:45:00',4.17),('8784','2013-07-31','11:50:00',4.21),('8784','2013-07-31','11:55:00',4.23),('8784','2013-07-31','12:00:00',4.2),('8784','2013-07-31','12:05:00',4.23),('8784','2013-07-31','12:10:00',4.27),('8784','2013-07-31','12:15:00',4.31),('8784','2013-07-31','12:20:00',4.29),('8784','2013-07-31','12:25:00',4.36),('8784','2013-07-31','12:30:00',4.36),('8784','2013-07-31','12:35:00',4.32),('8784','2013-07-31','12:40:00',4.37),('8784','2013-07-31','12:45:00',3.84),('8784','2013-07-31','12:50:00',2.03),('8784','2013-07-31','12:55:00',4.56),('8784','2013-07-31','13:00:00',1.86),('8784','2013-07-31','13:05:00',3.62),('8784','2013-07-31','13:10:00',4.1),('8784','2013-07-31','13:15:00',4.42),('8784','2013-07-31','13:20:00',4.14),('8784','2013-07-31','13:25:00',4.17),('8784','2013-07-31','13:30:00',4.05),('8784','2013-07-31','13:35:00',4.39),('8784','2013-07-31','13:40:00',4.37),('8784','2013-07-31','13:45:00',4.46),('8784','2013-07-31','13:50:00',4.44),('8784','2013-07-31','13:55:00',3),('8784','2013-07-31','14:00:00',3.49),('8784','2013-07-31','14:05:00',4.39),('8784','2013-07-31','14:10:00',4.38),('8784','2013-07-31','14:15:00',3.69),('8784','2013-07-31','14:20:00',4.02),('8784','2013-07-31','14:25:00',3.63),('8784','2013-07-31','14:30:00',4.2),('8784','2013-07-31','14:35:00',4.12),('8784','2013-07-31','14:40:00',4.16),('8784','2013-07-31','14:45:00',4.06),('8784','2013-07-31','14:50:00',4.29),('8784','2013-07-31','14:55:00',3.09),('8784','2013-07-31','15:00:00',1.22),('8784','2013-07-31','15:05:00',3.61),('8784','2013-07-31','15:10:00',4.01),('8784','2013-07-31','15:15:00',3.48),('8784','2013-07-31','15:20:00',3.37),('8784','2013-07-31','15:25:00',3.88),('8784','2013-07-31','15:30:00',2.97),('8784','2013-07-31','15:35:00',3.7),('8784','2013-07-31','15:40:00',3.74),('8784','2013-07-31','15:45:00',3.28),('8784','2013-07-31','15:50:00',3.51),('8784','2013-07-31','15:55:00',3.46),('8784','2013-07-31','16:00:00',3.37),('8784','2013-07-31','16:05:00',3.37),('8784','2013-07-31','16:10:00',3.36),('8784','2013-07-31','16:15:00',3.24),('8784','2013-07-31','16:20:00',3.28),('8784','2013-07-31','16:25:00',3.28),('8784','2013-07-31','16:30:00',3.18),('8784','2013-07-31','16:35:00',3),('8784','2013-07-31','16:40:00',2.89),('8784','2013-07-31','16:45:00',2.74),('8784','2013-07-31','16:50:00',2.76),('8784','2013-07-31','16:55:00',2.69),('8784','2013-07-31','17:00:00',2.62),('8784','2013-07-31','17:05:00',2.5),('8784','2013-07-31','17:10:00',2.25),('8784','2013-07-31','17:15:00',2.45),('8784','2013-07-31','17:20:00',1.71),('8784','2013-07-31','17:25:00',2.24),('8784','2013-07-31','17:30:00',2.14),('8784','2013-07-31','17:35:00',2.02),('8784','2013-07-31','17:40:00',1.98),('8784','2013-07-31','17:45:00',1.9),('8784','2013-07-31','17:50:00',1.81),('8784','2013-07-31','17:55:00',1.73),('8784','2013-07-31','18:00:00',1.66),('8784','2013-07-31','18:05:00',1.57),('8784','2013-07-31','18:10:00',1.48),('8784','2013-07-31','18:15:00',1.43),('8784','2013-07-31','18:20:00',1.35),('8784','2013-07-31','18:25:00',1.29),('8784','2013-07-31','18:30:00',1.21),('8784','2013-07-31','18:35:00',1.13),('8784','2013-07-31','18:40:00',1.06),('8784','2014-04-08','08:15:00',1.15),('8784','2014-04-08','08:20:00',1.49),('8784','2014-04-08','08:25:00',1),('8784','2014-04-08','08:30:00',1.5),('8784','2014-04-08','08:35:00',1.47),('8784','2014-04-08','08:40:00',1.27),('8784','2014-04-08','08:45:00',1.67),('8784','2014-04-08','08:50:00',1.71),('8784','2014-04-08','08:55:00',1.84),('8784','2014-04-08','09:00:00',1.92),('8784','2014-04-08','09:05:00',1.98),('8784','2014-04-08','09:10:00',2.07),('8784','2014-04-08','09:15:00',2.15),('8784','2014-04-08','09:20:00',2.22),('8784','2014-04-08','09:25:00',2.34),('8784','2014-04-08','09:30:00',2.4),('8784','2014-04-08','09:35:00',2.45),('8784','2014-04-08','09:40:00',2.51),('8784','2014-04-08','09:45:00',2.57),('8784','2014-04-08','09:50:00',2.65),('8784','2014-04-08','09:55:00',2.69),('8784','2014-04-08','10:00:00',2.73),('8784','2014-04-08','10:05:00',2.71),('8784','2014-04-08','10:10:00',2.86),('8784','2014-04-08','10:15:00',3.01),('8784','2014-04-08','10:20:00',3.09),('8784','2014-04-08','10:25:00',3.13),('8784','2014-04-08','10:30:00',3.2),('8784','2014-04-08','10:35:00',3.28),('8784','2014-04-08','10:40:00',3.29),('8784','2014-04-08','10:45:00',3.33),('8784','2014-04-08','10:50:00',3.39),('8784','2014-04-08','10:55:00',3.46),('8784','2014-04-08','11:00:00',3.43),('8784','2014-04-08','11:05:00',3.47),('8784','2014-04-08','11:10:00',3.55),('8784','2014-04-08','11:15:00',3.19),('8784','2014-04-08','11:20:00',3.66),('8784','2014-04-08','11:25:00',3.65),('8784','2014-04-08','11:30:00',3.66),('8784','2014-04-08','11:35:00',3.56),('8784','2014-04-08','11:40:00',3.74),('8784','2014-04-08','11:45:00',3.74),('8784','2014-04-08','11:50:00',3.79),('8784','2014-04-08','11:55:00',3.84),('8784','2014-04-08','12:00:00',3.89),('8784','2014-04-08','12:05:00',3.84),('8784','2014-04-08','12:10:00',3.75),('8784','2014-04-08','12:15:00',3.53),('8784','2014-04-08','12:20:00',3.58),('8784','2014-04-08','12:25:00',3.56),('8784','2014-04-08','12:30:00',4.16),('8784','2014-04-08','12:35:00',4.1),('8784','2014-04-08','12:40:00',3.4),('8784','2014-04-08','12:45:00',2.65),('8784','2014-04-08','12:50:00',3.54),('8784','2014-04-08','12:55:00',4.03),('8784','2014-04-08','13:00:00',3.79),('8784','2014-04-08','13:05:00',3.99),('8784','2014-04-08','13:10:00',4.08),('8784','2014-04-08','13:15:00',4.18),('8784','2014-04-08','13:20:00',4.14),('8784','2014-04-08','13:25:00',4.19),('8784','2014-04-08','13:30:00',4.17),('8784','2014-04-08','13:35:00',4.18),('8784','2014-04-08','13:40:00',4.14),('8784','2014-04-08','13:45:00',4.07),('8784','2014-04-08','13:50:00',4.1),('8784','2014-04-08','13:55:00',4.12),('8784','2014-04-08','14:00:00',4.09),('8784','2014-04-08','14:05:00',4.08),('8784','2014-04-08','14:10:00',4.07),('8784','2014-04-08','14:15:00',3.99),('8784','2014-04-08','14:20:00',3.75),('8784','2014-04-08','14:25:00',3.79),('8784','2014-04-08','14:30:00',4.01),('8784','2014-04-08','14:35:00',3.82),('8784','2014-04-08','14:40:00',3.45),('8784','2014-04-08','14:45:00',3.44),('8784','2014-04-08','14:50:00',3.73),('8784','2014-04-08','14:55:00',3.83),('8784','2014-04-08','15:00:00',3.73),('8784','2014-04-08','15:05:00',3.64),('8784','2014-04-08','15:10:00',3.67),('8784','2014-04-08','15:15:00',3.59),('8784','2014-04-08','15:20:00',3.49),('8784','2014-04-08','15:25:00',3.31),('8784','2014-04-08','15:30:00',3.18),('8784','2014-04-08','15:35:00',3.37),('8784','2014-04-08','15:40:00',3.26),('8784','2014-04-08','15:45:00',3.12),('8784','2014-04-08','15:50:00',3.15),('8784','2014-04-08','15:55:00',3.1),('8784','2014-04-08','16:00:00',2.98),('8784','2014-04-08','16:05:00',2.94),('8784','2014-04-08','16:10:00',2.83),('8784','2014-04-08','16:15:00',2.64),('8784','2014-04-08','16:20:00',2.43),('8784','2014-04-08','16:25:00',2.56),('8784','2014-04-08','16:30:00',2.72),('8784','2014-04-08','16:35:00',2.62),('8784','2014-04-08','16:40:00',2.45),('8784','2014-04-08','16:45:00',2.33),('8784','2014-04-08','16:50:00',2.36),('8784','2014-04-08','16:55:00',2.17),('8784','2014-04-08','17:00:00',2.02),('8784','2014-04-08','17:05:00',2.09),('8784','2014-04-08','17:10:00',1.96),('8784','2014-04-08','17:15:00',1.87),('8784','2014-04-08','17:20:00',1.8),('8784','2014-04-08','17:25:00',1.59),('8784','2014-04-08','17:30:00',1.51),('8784','2014-04-08','17:35:00',1.38),('8784','2014-04-08','17:40:00',1.36),('8784','2014-04-08','17:45:00',1.31),('8784','2014-04-08','17:50:00',1.24),('8784','2014-04-08','17:55:00',1.1),('8784','2014-04-08','18:00:00',1.09),('8784','2014-04-08','18:05:00',1.05),('8784','2013-07-30','07:40:00',1.1),('8784','2013-07-30','07:45:00',1.16),('8784','2013-07-30','07:50:00',1.2),('8784','2013-07-30','07:55:00',1.27),('8784','2013-07-30','08:00:00',1.41),('8784','2013-07-30','08:05:00',1.53),('8784','2013-07-30','08:10:00',1.61),('8784','2013-07-30','08:15:00',1.72),('8784','2013-07-30','08:20:00',1.94),('8784','2013-07-30','08:25:00',1.87),('8784','2013-07-30','08:30:00',1.93),('8784','2013-07-30','08:35:00',1.97),('8784','2013-07-30','08:40:00',2.04),('8784','2013-07-30','08:45:00',2.13),('8784','2013-07-30','08:50:00',2.21),('8784','2013-07-30','08:55:00',2.35),('8784','2013-07-30','09:00:00',2.42),('8784','2013-07-30','09:05:00',2.51),('8784','2013-07-30','09:10:00',2.52),('8784','2013-07-30','09:15:00',2.68),('8784','2013-07-30','09:20:00',2.79),('8784','2013-07-30','09:25:00',2.8),('8784','2013-07-30','09:30:00',2.48),('8784','2013-07-30','09:35:00',2.92),('8784','2013-07-30','09:40:00',1.68),('8784','2013-07-30','09:45:00',1.75),('8784','2013-07-30','09:50:00',1.33),('8784','2013-07-30','09:55:00',2.8),('8784','2013-07-30','10:00:00',2.08),('8784','2013-07-30','10:05:00',1.38),('8784','2013-07-30','10:10:00',3.61),('8784','2013-07-30','10:15:00',3.55),('8784','2013-07-30','10:20:00',3.63),('8784','2013-07-30','10:25:00',3.7),('8784','2013-07-30','10:30:00',3.68),('8784','2013-07-30','10:35:00',3.66),('8784','2013-07-30','10:40:00',3.63),('8784','2013-07-30','10:45:00',3.68),('8784','2013-07-30','10:50:00',3.63),('8784','2013-07-30','10:55:00',3.65),('8784','2013-07-30','11:00:00',3.74),('8784','2013-07-30','11:05:00',3.77),('8784','2013-07-30','11:10:00',3.97),('8784','2013-07-30','11:15:00',3.32),('8784','2013-07-30','11:20:00',2.04),('8784','2013-07-30','11:25:00',1.11),('8784','2013-07-30','11:30:00',4.12),('8784','2013-07-30','11:35:00',4.25),('8784','2013-07-30','11:40:00',4.16),('8784','2013-07-30','11:45:00',4.08),('8784','2013-07-30','11:50:00',1.5),('8784','2013-07-30','11:55:00',4.02),('8784','2013-07-30','12:00:00',4.05),('8784','2013-07-30','12:05:00',4.14),('8784','2013-07-30','12:10:00',3.99),('8784','2013-07-30','12:15:00',4.08),('8784','2013-07-30','12:20:00',4.19),('8784','2013-07-30','12:25:00',4.21),('8784','2013-07-30','12:30:00',4.19),('8784','2013-07-30','12:35:00',3.04),('8784','2013-07-30','12:45:00',2.91),('8784','2013-07-30','12:50:00',4.54),('8784','2013-07-30','12:55:00',4.55),('8784','2013-07-30','13:00:00',3.29),('8784','2013-07-30','13:05:00',3.6),('8784','2013-07-30','13:10:00',4.04),('8784','2013-07-30','13:15:00',2.38),('8784','2013-07-30','13:20:00',4.02),('8784','2013-07-30','13:25:00',4.5),('8784','2013-07-30','13:30:00',4.47),('8784','2013-07-30','13:35:00',4.37),('8784','2013-07-30','13:40:00',4.39),('8784','2013-07-30','13:45:00',4.31),('8784','2013-07-30','13:50:00',4.34),('8784','2013-07-30','13:55:00',4.41),('8784','2013-07-30','14:00:00',4.37),('8784','2013-07-30','14:05:00',2.32),('8784','2013-07-30','14:10:00',2.23),('8784','2013-07-30','14:15:00',4.29),('8784','2013-07-30','14:20:00',4.28),('8784','2013-07-30','14:25:00',4.09),('8784','2013-07-30','14:30:00',4.09),('8784','2013-07-30','14:35:00',4.13),('8784','2013-07-30','14:40:00',3.99),('8784','2013-07-30','14:45:00',3.97),('8784','2013-07-30','14:50:00',3.98),('8784','2013-07-30','14:55:00',3.85),('8784','2013-07-30','15:00:00',3.87),('8784','2013-07-30','15:05:00',3.78),('8784','2013-07-30','15:10:00',3.7),('8784','2013-07-30','15:15:00',3.68),('8784','2013-07-30','15:20:00',3.64),('8784','2013-07-30','15:25:00',3.63),('8784','2013-07-30','15:30:00',3.59),('8784','2013-07-30','15:35:00',3.51),('8784','2013-07-30','15:40:00',3.49),('8784','2013-07-30','15:45:00',3.46),('8784','2013-07-30','15:50:00',3.4),('8784','2013-07-30','15:55:00',3.33),('8784','2013-07-30','16:00:00',3.31),('8784','2013-07-30','16:05:00',3.24),('8784','2013-07-30','16:10:00',3.16),('8784','2013-07-30','16:15:00',3.11),('8784','2013-07-30','16:20:00',3.08),('8784','2013-07-30','16:25:00',3.03),('8784','2013-07-30','16:30:00',2.93),('8784','2013-07-30','16:35:00',2.88),('8784','2013-07-30','16:40:00',2.86),('8784','2013-07-30','16:45:00',2.78),('8784','2013-07-30','16:50:00',2.69),('8784','2013-07-30','16:55:00',2.63),('8784','2013-07-30','17:00:00',2.56),('8784','2013-07-30','17:05:00',2.49),('8784','2013-07-30','17:10:00',2.41),('8784','2013-07-30','17:15:00',2.34),('8784','2013-07-30','17:20:00',2.26),('8784','2013-07-30','17:25:00',2.21),('8784','2013-07-30','17:30:00',2.13),('8784','2013-07-30','17:35:00',2.03),('8784','2013-07-30','17:40:00',1.97),('8784','2013-07-30','17:45:00',1.9),('8784','2013-07-30','17:50:00',1.79),('8784','2013-07-30','17:55:00',1.7),('8784','2013-07-30','18:00:00',1.62),('8784','2013-07-30','18:05:00',1.53),('8784','2013-07-30','18:10:00',1.45),('8784','2013-07-30','18:15:00',1.38),('8784','2013-07-30','18:20:00',1.32),('8784','2013-07-30','18:25:00',1.25),('8784','2013-07-30','18:30:00',1.16),('8784','2013-07-30','18:35:00',1.07),('8784','2013-07-29','07:45:00',1.05),('8784','2013-07-29','07:50:00',1.12),('8784','2013-07-29','07:55:00',1.2),('8784','2013-07-29','08:00:00',1.29),('8784','2013-07-29','08:05:00',1.38),('8784','2013-07-29','08:10:00',1.45),('8784','2013-07-29','08:15:00',1.51),('8784','2013-07-29','08:20:00',1.59),('8784','2013-07-29','08:25:00',1.66),('8784','2013-07-29','08:30:00',1.71),('8784','2013-07-29','08:35:00',1.8),('8784','2013-07-29','08:40:00',1.82),('8784','2013-07-29','08:45:00',1.92),('8784','2013-07-29','08:50:00',2.03),('8784','2013-07-29','08:55:00',2.06),('8784','2013-07-29','09:00:00',2.14),('8784','2013-07-29','09:05:00',2.23),('8784','2013-07-29','09:10:00',2.29),('8784','2013-07-29','09:15:00',2.35),('8784','2013-07-29','09:20:00',2.41),('8784','2013-07-29','09:25:00',2.47),('8784','2013-07-29','09:30:00',2.52),('8784','2013-07-29','09:35:00',2.6),('8784','2013-07-29','09:40:00',2.69),('8784','2013-07-29','09:45:00',2.77),('8784','2013-07-29','09:50:00',2.85),('8784','2013-07-29','09:55:00',2.9),('8784','2013-07-29','10:00:00',2.97),('8784','2013-07-29','10:05:00',3.04),('8784','2013-07-29','10:10:00',3.08),('8784','2013-07-29','10:15:00',3.14),('8784','2013-07-29','10:20:00',3.21),('8784','2013-07-29','10:25:00',3.28),('8784','2013-07-29','10:30:00',3.32),('8784','2013-07-29','10:35:00',3.32),('8784','2013-07-29','10:40:00',3.39),('8784','2013-07-29','10:45:00',3.42),('8784','2013-07-29','10:50:00',3.47),('8784','2013-07-29','10:55:00',3.47),('8784','2013-07-29','11:00:00',3.49),('8784','2013-07-29','11:05:00',3.54),('8784','2013-07-29','11:10:00',3.6),('8784','2013-07-29','11:15:00',3.61),('8784','2013-07-29','11:20:00',3.67),('8784','2013-07-29','11:25:00',3.68),('8784','2013-07-29','11:30:00',3.68),('8784','2013-07-29','11:35:00',3.7),('8784','2013-07-29','11:40:00',3.74),('8784','2013-07-29','11:45:00',3.74),('8784','2013-07-29','11:50:00',3.75),('8784','2013-07-29','11:55:00',3.74),('8784','2013-07-29','12:00:00',3.8),('8784','2013-07-29','12:05:00',3.85),('8784','2013-07-29','12:10:00',3.89),('8784','2013-07-29','12:15:00',3.87),('8784','2013-07-29','12:20:00',3.88),('8784','2013-07-29','12:25:00',3.9),('8784','2013-07-29','12:30:00',3.91),('8784','2013-07-29','12:35:00',3.92),('8784','2013-07-29','12:40:00',3.94),('8784','2013-07-29','12:45:00',3.94),('8784','2013-07-29','12:50:00',3.93),('8784','2013-07-29','12:55:00',3.86),('8784','2013-07-29','13:00:00',3.95),('8784','2013-07-29','13:05:00',3.93),('8784','2013-07-29','13:10:00',3.98),('8784','2013-07-29','13:15:00',3.98),('8784','2013-07-29','13:20:00',4.08),('8784','2013-07-29','13:25:00',4.11),('8784','2013-07-29','13:30:00',4.12),('8784','2013-07-29','13:35:00',4.12),('8784','2013-07-29','13:40:00',4.11),('8784','2013-07-29','13:45:00',4.11),('8784','2013-07-29','13:50:00',4.11),('8784','2013-07-29','13:55:00',4.09),('8784','2013-07-29','14:00:00',4.06),('8784','2013-07-29','14:05:00',4.05),('8784','2013-07-29','14:10:00',4.04),('8784','2013-07-29','14:15:00',4.05),('8784','2013-07-29','14:20:00',4.01),('8784','2013-07-29','14:25:00',3.96),('8784','2013-07-29','14:30:00',3.91),('8784','2013-07-29','14:35:00',3.93),('8784','2013-07-29','14:40:00',3.9),('8784','2013-07-29','14:45:00',3.85),('8784','2013-07-29','14:50:00',3.82),('8784','2013-07-29','14:55:00',3.8),('8784','2013-07-29','15:00:00',3.77),('8784','2013-07-29','15:05:00',3.75),('8784','2013-07-29','15:10:00',3.71),('8784','2013-07-29','15:15:00',3.66),('8784','2013-07-29','15:20:00',3.63),('8784','2013-07-29','15:25:00',3.6),('8784','2013-07-29','15:30:00',3.55),('8784','2013-07-29','15:35:00',3.53),('8784','2013-07-29','15:40:00',3.57),('8784','2013-07-29','15:45:00',3.62),('8784','2013-07-29','15:50:00',2.8),('8784','2013-07-29','15:55:00',2.02),('8784','2013-07-29','16:00:00',1.92),('8784','2013-07-29','16:05:00',2.94),('8784','2013-07-29','16:10:00',3.19),('8784','2013-07-29','16:15:00',2.45),('8784','2013-07-29','16:20:00',2.59),('8784','2013-07-29','16:25:00',2.6),('8784','2013-07-29','16:30:00',3.05),('8784','2013-07-29','16:35:00',2.58),('8784','2013-07-29','16:40:00',2.58),('8784','2013-07-29','16:45:00',3.04),('8784','2013-07-29','16:50:00',2.68),('8784','2013-07-29','16:55:00',1.93),('8784','2013-07-29','17:00:00',1.42),('8784','2013-07-29','17:05:00',2.09),('8784','2013-07-29','17:10:00',1.44),('8784','2013-07-29','17:15:00',1.2),('8784','2013-07-29','17:20:00',2.24),('8784','2013-07-29','17:25:00',2.12),('8784','2013-07-29','17:30:00',1.39),('8784','2013-07-29','17:40:00',1.27),('8784','2013-07-29','17:45:00',2.04),('8784','2013-07-29','17:50:00',1.81),('8784','2013-07-29','17:55:00',1.64),('8784','2013-07-29','18:00:00',1.16),('8784','2013-07-29','18:10:00',1.41),('8784','2013-07-29','18:15:00',1.17),('8784','2013-07-29','18:20:00',1.31),('8784','2013-07-29','18:25:00',1.26),('8784','2013-07-29','18:30:00',1.2),('8784','2013-07-29','18:35:00',1.04),('8784','2013-07-28','07:45:00',1.03),('8784','2013-07-28','07:50:00',1.11),('8784','2013-07-28','07:55:00',1.16),('8784','2013-07-28','08:00:00',1.26),('8784','2013-07-28','08:05:00',1.35),('8784','2013-07-28','08:10:00',1.43),('8784','2013-07-28','08:15:00',1.5),('8784','2013-07-28','08:20:00',1.59),('8784','2013-07-28','08:25:00',1.67),('8784','2013-07-28','08:30:00',1.77),('8784','2013-07-28','08:35:00',1.84),('8784','2013-07-28','08:40:00',1.92),('8784','2013-07-28','08:45:00',1.98),('8784','2013-07-28','08:50:00',2.07),('8784','2013-07-28','08:55:00',2.12),('8784','2013-07-28','09:00:00',2.19),('8784','2013-07-28','09:05:00',2.26),('8784','2013-07-28','09:10:00',2.37),('8784','2013-07-28','09:15:00',2.43),('8784','2013-07-28','09:20:00',2.5),('8784','2013-07-28','09:25:00',2.56),('8784','2013-07-28','09:30:00',2.61),('8784','2013-07-28','09:35:00',2.66),('8784','2013-07-28','09:40:00',2.74),('8784','2013-07-28','09:45:00',2.81),('8784','2013-07-28','09:50:00',2.86),('8784','2013-07-28','09:55:00',2.94),('8784','2013-07-28','10:00:00',2.98),('8784','2013-07-28','10:05:00',3.05),('8784','2013-07-28','10:10:00',3.11),('8784','2013-07-28','10:15:00',3.18),('8784','2013-07-28','10:20:00',3.19),('8784','2013-07-28','10:25:00',3.24),('8784','2013-07-28','10:30:00',3.31),('8784','2013-07-28','10:35:00',3.37),('8784','2013-07-28','10:40:00',3.4),('8784','2013-07-28','10:45:00',3.42),('8784','2013-07-28','10:50:00',3.48),('8784','2013-07-28','10:55:00',3.49),('8784','2013-07-28','11:00:00',3.53),('8784','2013-07-28','11:05:00',3.57),('8784','2013-07-28','11:10:00',3.55),('8784','2013-07-28','11:15:00',3.61),('8784','2013-07-28','11:20:00',3.63),('8784','2013-07-28','11:25:00',3.63),('8784','2013-07-28','11:30:00',3.71),('8784','2013-07-28','11:35:00',3.7),('8784','2013-07-28','11:40:00',3.75),('8784','2013-07-28','11:45:00',3.79),('8784','2013-07-28','11:50:00',3.81),('8784','2013-07-28','11:55:00',3.8),('8784','2013-07-28','12:00:00',3.85),('8784','2013-07-28','12:05:00',3.82),('8784','2013-07-28','12:10:00',3.77),('8784','2013-07-28','12:15:00',3.79),('8784','2013-07-28','12:20:00',3.88),('8784','2013-07-28','12:25:00',3.9),('8784','2013-07-28','12:30:00',3.97),('8784','2013-07-28','12:35:00',3.98),('8784','2013-07-28','12:40:00',3.98),('8784','2013-07-28','12:45:00',3.92),('8784','2013-07-28','12:50:00',3.94),('8784','2013-07-28','12:55:00',3.9),('8784','2013-07-28','13:00:00',3.85),('8784','2013-07-28','13:05:00',3.96),('8784','2013-07-28','13:10:00',4.04),('8784','2013-07-28','13:15:00',3.93),('8784','2013-07-28','13:20:00',3.97),('8784','2013-07-28','13:25:00',4.01),('8784','2013-07-28','13:30:00',4.04),('8784','2013-07-28','13:35:00',4.05),('8784','2013-07-28','13:40:00',4.05),('8784','2013-07-28','13:45:00',4.11),('8784','2013-07-28','13:50:00',4.04),('8784','2013-07-28','13:55:00',4),('8784','2013-07-28','14:00:00',3.99),('8784','2013-07-28','14:05:00',4.01),('8784','2013-07-28','14:10:00',4.02),('8784','2013-07-28','14:15:00',3.97),('8784','2013-07-28','14:20:00',3.92),('8784','2013-07-28','14:25:00',3.93),('8784','2013-07-28','14:30:00',3.91),('8784','2013-07-28','14:35:00',3.85),('8784','2013-07-28','14:40:00',3.84),('8784','2013-07-28','14:45:00',3.8),('8784','2013-07-28','14:50:00',3.78),('8784','2013-07-28','14:55:00',3.75),('8784','2013-07-28','15:00:00',3.73),('8784','2013-07-28','15:05:00',3.73),('8784','2013-07-28','15:10:00',3.67),('8784','2013-07-28','15:15:00',3.6),('8784','2013-07-28','15:20:00',3.54),('8784','2013-07-28','15:25:00',3.56),('8784','2013-07-28','15:30:00',3.49),('8784','2013-07-28','15:35:00',3.46),('8784','2013-07-28','15:40:00',3.45),('8784','2013-07-28','15:45:00',3.36),('8784','2013-07-28','15:50:00',3.32),('8784','2013-07-28','15:55:00',3.29),('8784','2013-07-28','16:00:00',3.26),('8784','2013-07-28','16:05:00',3.23),('8784','2013-07-28','16:10:00',3.17),('8784','2013-07-28','16:15:00',3.14),('8784','2013-07-28','16:20:00',3.07),('8784','2013-07-28','16:25:00',3.03),('8784','2013-07-28','16:30:00',2.97),('8784','2013-07-28','16:35:00',2.9),('8784','2013-07-28','16:40:00',2.84),('8784','2013-07-28','16:45:00',2.78),('8784','2013-07-28','16:50:00',2.73),('8784','2013-07-28','16:55:00',2.66),('8784','2013-07-28','17:00:00',2.58),('8784','2013-07-28','17:05:00',2.51),('8784','2013-07-28','17:10:00',2.44),('8784','2013-07-28','17:15:00',2.38),('8784','2013-07-28','17:20:00',2.31),('8784','2013-07-28','17:25:00',2.22),('8784','2013-07-28','17:30:00',2.15),('8784','2013-07-28','17:35:00',2.07),('8784','2013-07-28','17:40:00',2),('8784','2013-07-28','17:45:00',1.93),('8784','2013-07-28','17:50:00',1.84),('8784','2013-07-28','17:55:00',1.76),('8784','2013-07-28','18:00:00',1.66),('8784','2013-07-28','18:05:00',1.58),('8784','2013-07-28','18:10:00',1.5),('8784','2013-07-28','18:15:00',1.42),('8784','2013-07-28','18:20:00',1.35),('8784','2013-07-28','18:25:00',1.28),('8784','2013-07-28','18:30:00',1.19),('8784','2013-07-28','18:35:00',1.11),('8784','2013-07-28','18:40:00',1.03),('8784','2013-07-27','07:45:00',1.04),('8784','2013-07-27','07:50:00',1.13),('8784','2013-07-27','07:55:00',1.23),('8784','2013-07-27','08:00:00',1.32),('8784','2013-07-27','08:05:00',1.39),('8784','2013-07-27','08:10:00',1.47),('8784','2013-07-27','08:15:00',1.56),('8784','2013-07-27','08:20:00',1.64),('8784','2013-07-27','08:25:00',1.71),('8784','2013-07-27','08:30:00',1.79),('8784','2013-07-27','08:35:00',1.87),('8784','2013-07-27','08:40:00',1.95),('8784','2013-07-27','08:45:00',2.02),('8784','2013-07-27','08:50:00',2.08),('8784','2013-07-27','08:55:00',2.18),('8784','2013-07-27','09:00:00',2.24),('8784','2013-07-27','09:05:00',2.35),('8784','2013-07-27','09:10:00',2.42),('8784','2013-07-27','09:15:00',2.48),('8784','2013-07-27','09:20:00',2.56),('8784','2013-07-27','09:25:00',2.64),('8784','2013-07-27','09:30:00',2.71),('8784','2013-07-27','09:35:00',2.79),('8784','2013-07-27','09:40:00',2.82),('8784','2013-07-27','09:45:00',2.88),('8784','2013-07-27','09:50:00',2.95),('8784','2013-07-27','09:55:00',3),('8784','2013-07-27','10:00:00',3.08),('8784','2013-07-27','10:05:00',3.12),('8784','2013-07-27','10:10:00',3.2),('8784','2013-07-27','10:15:00',3.24),('8784','2013-07-27','10:20:00',3.27),('8784','2013-07-27','10:25:00',3.34),('8784','2013-07-27','10:30:00',3.38),('8784','2013-07-27','10:35:00',3.42),('8784','2013-07-27','10:40:00',3.46),('8784','2013-07-27','10:45:00',3.5),('8784','2013-07-27','10:50:00',3.54),('8784','2013-07-27','10:55:00',3.54),('8784','2013-07-27','11:00:00',3.58),('8784','2013-07-27','11:05:00',3.65),('8784','2013-07-27','11:10:00',3.74),('8784','2013-07-27','11:15:00',3.79),('8784','2013-07-27','11:20:00',3.79),('8784','2013-07-27','11:25:00',3.79),('8784','2013-07-27','11:30:00',3.8),('8784','2013-07-27','11:35:00',3.85),('8784','2013-07-27','11:40:00',3.85),('8784','2013-07-27','11:45:00',3.88),('8784','2013-07-27','11:50:00',3.91),('8784','2013-07-27','11:55:00',3.92),('8784','2013-07-27','12:00:00',3.94),('8784','2013-07-27','12:05:00',3.94),('8784','2013-07-27','12:10:00',3.94),('8784','2013-07-27','12:15:00',3.95),('8784','2013-07-27','12:20:00',3.89),('8784','2013-07-27','12:25:00',3.94),('8784','2013-07-27','12:30:00',3.98),('8784','2013-07-27','12:35:00',3.9),('8784','2013-07-27','12:40:00',3.82),('8784','2013-07-27','12:45:00',3.97),('8784','2013-07-27','12:50:00',4.01),('8784','2013-07-27','12:55:00',4.1),('8784','2013-07-27','13:00:00',3.9),('8784','2013-07-27','13:05:00',1.03),('8784','2013-07-27','13:10:00',1.81),('8784','2013-07-27','13:15:00',3.88),('8784','2013-07-27','13:20:00',4.12),('8784','2013-07-27','13:25:00',4.12),('8784','2013-07-27','13:30:00',4.09),('8784','2013-07-27','13:35:00',4.04),('8784','2013-07-27','13:40:00',4.11),('8784','2013-07-27','13:45:00',4.05),('8784','2013-07-27','13:50:00',4.06),('8784','2013-07-27','13:55:00',4.08),('8784','2013-07-27','14:00:00',3.98),('8784','2013-07-27','14:05:00',4.13),('8784','2013-07-27','14:10:00',4.15),('8784','2013-07-27','14:15:00',3.98),('8784','2013-07-27','14:20:00',3.94),('8784','2013-07-27','14:25:00',3.95),('8784','2013-07-27','14:30:00',3.88),('8784','2013-07-27','14:35:00',3.87),('8784','2013-07-27','14:40:00',3.85),('8784','2013-07-27','14:45:00',3.83),('8784','2013-07-27','14:50:00',3.85),('8784','2013-07-27','14:55:00',3.82),('8784','2013-07-27','15:00:00',3.76),('8784','2013-07-27','15:05:00',3.76),('8784','2013-07-27','15:10:00',3.71),('8784','2013-07-27','15:15:00',3.7),('8784','2013-07-27','15:20:00',3.66),('8784','2013-07-27','15:25:00',3.62),('8784','2013-07-27','15:30:00',3.57),('8784','2013-07-27','15:35:00',3.53),('8784','2013-07-27','15:40:00',3.47),('8784','2013-07-27','15:45:00',3.41),('8784','2013-07-27','15:50:00',3.39),('8784','2013-07-27','15:55:00',3.34),('8784','2013-07-27','16:00:00',3.3),('8784','2013-07-27','16:05:00',3.25),('8784','2013-07-27','16:10:00',3.19),('8784','2013-07-27','16:15:00',3.12),('8784','2013-07-27','16:20:00',3.08),('8784','2013-07-27','16:25:00',3.03),('8784','2013-07-27','16:30:00',3),('8784','2013-07-27','16:35:00',2.92),('8784','2013-07-27','16:40:00',2.88),('8784','2013-07-27','16:45:00',2.81),('8784','2013-07-27','16:50:00',2.75),('8784','2013-07-27','16:55:00',2.68),('8784','2013-07-27','17:00:00',2.58),('8784','2013-07-27','17:05:00',2.53),('8784','2013-07-27','17:10:00',2.46),('8784','2013-07-27','17:15:00',2.39),('8784','2013-07-27','17:20:00',2.31),('8784','2013-07-27','17:25:00',2.23),('8784','2013-07-27','17:30:00',2.13),('8784','2013-07-27','17:35:00',2.07),('8784','2013-07-27','17:40:00',2),('8784','2013-07-27','17:45:00',1.92),('8784','2013-07-27','17:50:00',1.85),('8784','2013-07-27','17:55:00',1.78),('8784','2013-07-27','18:00:00',1.7),('8784','2013-07-27','18:05:00',1.62),('8784','2013-07-27','18:10:00',1.54),('8784','2013-07-27','18:15:00',1.45),('8784','2013-07-27','18:20:00',1.37),('8784','2013-07-27','18:25:00',1.3),('8784','2013-07-27','18:30:00',1.23),('8784','2013-07-27','18:35:00',1.15),('8784','2013-07-27','18:40:00',1.07),('8784','2013-07-26','07:40:00',1.01),('8784','2013-07-26','07:45:00',1.06),('8784','2013-07-26','07:50:00',1.1),('8784','2013-07-26','07:55:00',1.17),('8784','2013-07-26','08:00:00',1.27),('8784','2013-07-26','08:05:00',1.36),('8784','2013-07-26','08:10:00',1.41),('8784','2013-07-26','08:15:00',1.49),('8784','2013-07-26','08:20:00',1.55),('8784','2013-07-26','08:25:00',1.66),('8784','2013-07-26','08:30:00',1.76),('8784','2013-07-26','08:35:00',1.84),('8784','2013-07-26','08:40:00',1.88),('8784','2013-07-26','08:45:00',1.99),('8784','2013-07-26','08:50:00',2.07),('8784','2013-07-26','08:55:00',2.15),('8784','2013-07-26','09:00:00',2.2),('8784','2013-07-26','09:05:00',2.28),('8784','2013-07-26','09:10:00',2.35),('8784','2013-07-26','09:15:00',2.39),('8784','2013-07-26','09:20:00',2.47),('8784','2013-07-26','09:25:00',2.54),('8784','2013-07-26','09:30:00',2.45),('8784','2013-07-26','09:35:00',2.55),('8784','2013-07-26','09:40:00',2.71),('8784','2013-07-26','09:45:00',2.8),('8784','2013-07-26','09:50:00',2.82),('8784','2013-07-26','09:55:00',2.97),('8784','2013-07-26','10:00:00',3.03),('8784','2013-07-26','10:05:00',3.11),('8784','2013-07-26','10:10:00',3.1),('8784','2013-07-26','10:15:00',3.08),('8784','2013-07-26','10:20:00',3.22),('8784','2013-07-26','10:25:00',3.28),('8784','2013-07-26','10:30:00',3.31),('8784','2013-07-26','10:35:00',3.36),('8784','2013-07-26','10:40:00',3.37),('8784','2013-07-26','10:45:00',3.46),('8784','2013-07-26','10:50:00',3.44),('8784','2013-07-26','10:55:00',3.43),('8784','2013-07-26','11:00:00',3.46),('8784','2013-07-26','11:05:00',3.53),('8784','2013-07-26','11:10:00',3.68),('8784','2013-07-26','11:15:00',3.71),('8784','2013-07-26','11:20:00',3.7),('8784','2013-07-26','11:25:00',3.74),('8784','2013-07-26','11:30:00',3.79),('8784','2013-07-26','11:35:00',3.85),('8784','2013-07-26','11:40:00',3.83),('8784','2013-07-26','11:45:00',3.86),('8784','2013-07-26','11:50:00',3.97),('8784','2013-07-26','11:55:00',3.97),('8784','2013-07-26','12:00:00',3.88),('8784','2013-07-26','12:05:00',3.95),('8784','2013-07-26','12:10:00',2.93),('8784','2013-07-26','12:15:00',3.91),('8784','2013-07-26','12:20:00',4.19),('8784','2013-07-26','12:25:00',4.17),('8784','2013-07-26','12:30:00',4.13),('8784','2013-07-26','12:35:00',4.11),('8784','2013-07-26','12:40:00',4.23),('8784','2013-07-26','12:45:00',4.27),('8784','2013-07-26','12:50:00',3.72),('8784','2013-07-26','12:55:00',1.99),('8784','2013-07-26','13:00:00',1.39),('8784','2013-07-26','13:05:00',1.23),('8784','2013-07-26','13:10:00',1.58),('8784','2013-07-26','13:15:00',2.11),('8784','2013-07-26','13:20:00',1.53),('8784','2013-07-26','13:25:00',2.38),('8784','2013-07-26','13:30:00',4.43),('8784','2013-07-26','13:35:00',4.23),('8784','2013-07-26','13:40:00',4.31),('8784','2013-07-26','13:45:00',4.4),('8784','2013-07-26','13:50:00',4.34),('8784','2013-07-26','13:55:00',3.93),('8784','2013-07-26','14:00:00',4.34),('8784','2013-07-26','14:05:00',3.08),('8784','2013-07-26','14:10:00',4.23),('8784','2013-07-26','14:15:00',4.18),('8784','2013-07-26','14:20:00',4.06),('8784','2013-07-26','14:25:00',4.01),('8784','2013-07-26','14:30:00',4.03),('8784','2013-07-26','14:35:00',4.05),('8784','2013-07-26','14:40:00',3.96),('8784','2013-07-26','14:45:00',3.94),('8784','2013-07-26','14:50:00',3.87),('8784','2013-07-26','14:55:00',3.84),('8784','2013-07-26','15:00:00',3.85),('8784','2013-07-26','15:05:00',3.79),('8784','2013-07-26','15:10:00',3.76),('8784','2013-07-26','15:15:00',3.75),('8784','2013-07-26','15:20:00',3.66),('8784','2013-07-26','15:25:00',3.61),('8784','2013-07-26','15:30:00',3.58),('8784','2013-07-26','15:35:00',3.55),('8784','2013-07-26','15:40:00',3.54),('8784','2013-07-26','15:45:00',3.47),('8784','2013-07-26','15:50:00',3.43),('8784','2013-07-26','15:55:00',3.39),('8784','2013-07-26','16:00:00',3.33),('8784','2013-07-26','16:05:00',3.29),('8784','2013-07-26','16:10:00',3.21),('8784','2013-07-26','16:15:00',3.11),('8784','2013-07-26','16:20:00',3.11),('8784','2013-07-26','16:25:00',3.07),('8784','2013-07-26','16:30:00',3.01),('8784','2013-07-26','16:35:00',2.93),('8784','2013-07-26','16:40:00',2.88),('8784','2013-07-26','16:45:00',2.82),('8784','2013-07-26','16:50:00',2.75),('8784','2013-07-26','16:55:00',2.63),('8784','2013-07-26','17:00:00',2.59),('8784','2013-07-26','17:05:00',2.54),('8784','2013-07-26','17:10:00',2.48),('8784','2013-07-26','17:15:00',2.38),('8784','2013-07-26','17:20:00',2.3),('8784','2013-07-26','17:25:00',2.23),('8784','2013-07-26','17:30:00',2.13),('8784','2013-07-26','17:35:00',2.05),('8784','2013-07-26','17:40:00',1.98),('8784','2013-07-26','17:45:00',1.9),('8784','2013-07-26','17:50:00',1.78),('8784','2013-07-26','17:55:00',1.68),('8784','2013-07-26','18:00:00',1.58),('8784','2013-07-26','18:05:00',1.54),('8784','2013-07-26','18:10:00',1.46),('8784','2013-07-26','18:15:00',1.36),('8784','2013-07-26','18:20:00',1.3),('8784','2013-07-26','18:25:00',1.26),('8784','2013-07-26','18:30:00',1.18),('8784','2013-07-26','18:35:00',1.1),('8784','2013-07-26','18:40:00',1.01),('8784','2013-07-25','07:45:00',1.08),('8784','2013-07-25','07:50:00',1.14),('8784','2013-07-25','07:55:00',1.23),('8784','2013-07-25','08:00:00',1.29),('8784','2013-07-25','08:05:00',1.37),('8784','2013-07-25','08:10:00',1.46),('8784','2013-07-25','08:15:00',1.49),('8784','2013-07-25','08:20:00',1.6),('8784','2013-07-25','08:25:00',1.68),('8784','2013-07-25','08:30:00',1.74),('8784','2013-07-25','08:35:00',1.83),('8784','2013-07-25','08:40:00',1.91),('8784','2013-07-25','08:45:00',2),('8784','2013-07-25','08:50:00',2.07),('8784','2013-07-25','08:55:00',2.18),('8784','2013-07-25','09:00:00',2.15),('8784','2013-07-25','09:05:00',2.23),('8784','2013-07-25','09:10:00',2.46),('8784','2013-07-25','09:15:00',2.67),('8784','2013-07-25','09:20:00',2.01),('8784','2013-07-25','09:25:00',1.81),('8784','2013-07-25','09:30:00',1.43),('8784','2013-07-25','09:35:00',1.74),('8784','2013-07-25','09:40:00',1.62),('8784','2013-07-25','09:45:00',1.25),('8784','2013-07-25','09:50:00',1.58),('8784','2013-07-25','10:00:00',2.09),('8784','2013-07-25','10:05:00',3.14),('8784','2013-07-25','10:10:00',3.16),('8784','2013-07-25','10:15:00',3.17),('8784','2013-07-25','10:20:00',3.28),('8784','2013-07-25','10:25:00',2.42),('8784','2013-07-25','10:30:00',1.7),('8784','2013-07-25','10:35:00',2.04),('8784','2013-07-25','10:40:00',2.28),('8784','2013-07-25','10:45:00',3.07),('8784','2013-07-25','10:50:00',3.74),('8784','2013-07-25','10:55:00',3.6),('8784','2013-07-25','11:00:00',3.88),('8784','2013-07-25','11:05:00',3.9),('8784','2013-07-25','11:10:00',3.83),('8784','2013-07-25','11:15:00',3.96),('8784','2013-07-25','11:20:00',3.86),('8784','2013-07-25','11:25:00',4.13),('8784','2013-07-25','11:30:00',4.03),('8784','2013-07-25','11:35:00',2.82),('8784','2013-07-25','11:40:00',3.69),('8784','2013-07-25','11:45:00',3.76),('8784','2013-07-25','11:50:00',4.25),('8784','2013-07-25','11:55:00',4.15),('8784','2013-07-25','12:00:00',4.15),('8784','2013-07-25','12:05:00',1.43),('8784','2013-07-25','12:10:00',2.91),('8784','2013-07-25','12:15:00',2.13),('8784','2013-07-25','12:20:00',2.73),('8784','2013-07-25','12:25:00',4.23),('8784','2013-07-25','12:30:00',4.55),('8784','2013-07-25','12:35:00',3.35),('8784','2013-07-25','12:40:00',4.2),('8784','2013-07-25','12:45:00',3.79),('8784','2013-07-25','12:50:00',2.98),('8784','2013-07-25','12:55:00',4.5),('8784','2013-07-25','13:00:00',4.36),('8784','2013-07-25','13:05:00',4.38),('8784','2013-07-25','13:10:00',4.49),('8784','2013-07-25','13:15:00',4.43),('8784','2013-07-25','13:20:00',4.34),('8784','2013-07-25','13:25:00',4.32),('8784','2013-07-25','13:30:00',4.27),('8784','2013-07-25','13:35:00',4.25),('8784','2013-07-25','13:40:00',4.26),('8784','2013-07-25','13:45:00',4.25),('8784','2013-07-25','13:50:00',4.28),('8784','2013-07-25','13:55:00',4.24),('8784','2013-07-25','14:00:00',4.26),('8784','2013-07-25','14:05:00',4.3),('8784','2013-07-25','14:10:00',4.24),('8784','2013-07-25','14:15:00',4.23),('8784','2013-07-25','14:20:00',4.21),('8784','2013-07-25','14:25:00',4.16),('8784','2013-07-25','14:30:00',4.16),('8784','2013-07-25','14:35:00',4.13),('8784','2013-07-25','14:40:00',4.11),('8784','2013-07-25','14:45:00',4.08),('8784','2013-07-25','14:50:00',4.05),('8784','2013-07-25','14:55:00',4.01),('8784','2013-07-25','15:00:00',4),('8784','2013-07-25','15:05:00',3.94),('8784','2013-07-25','15:10:00',3.88),('8784','2013-07-25','15:15:00',3.86),('8784','2013-07-25','15:20:00',3.83),('8784','2013-07-25','15:25:00',3.72),('8784','2013-07-25','15:30:00',3.75),('8784','2013-07-25','15:35:00',3.72),('8784','2013-07-25','15:40:00',3.69),('8784','2013-07-25','15:45:00',3.65),('8784','2013-07-25','15:50:00',3.57),('8784','2013-07-25','15:55:00',3.51),('8784','2013-07-25','16:00:00',3.47),('8784','2013-07-25','16:05:00',3.41),('8784','2013-07-25','16:10:00',3.37),('8784','2013-07-25','16:15:00',3.32),('8784','2013-07-25','16:20:00',3.24),('8784','2013-07-25','16:25:00',3.14),('8784','2013-07-25','16:30:00',3.08),('8784','2013-07-25','16:35:00',3.04),('8784','2013-07-25','16:40:00',3),('8784','2013-07-25','16:45:00',2.93),('8784','2013-07-25','16:50:00',2.86),('8784','2013-07-25','16:55:00',2.8),('8784','2013-07-25','17:00:00',2.73),('8784','2013-07-25','17:05:00',2.66),('8784','2013-07-25','17:10:00',2.57),('8784','2013-07-25','17:15:00',2.5),('8784','2013-07-25','17:20:00',2.42),('8784','2013-07-25','17:25:00',2.37),('8784','2013-07-25','17:30:00',2.29),('8784','2013-07-25','17:35:00',2.21),('8784','2013-07-25','17:40:00',2.12),('8784','2013-07-25','17:45:00',2.04),('8784','2013-07-25','17:50:00',1.94),('8784','2013-07-25','17:55:00',1.87),('8784','2013-07-25','18:00:00',1.78),('8784','2013-07-25','18:05:00',1.69),('8784','2013-07-25','18:10:00',1.6),('8784','2013-07-25','18:15:00',1.49),('8784','2013-07-25','18:20:00',1.42),('8784','2013-07-25','18:25:00',1.28),('8784','2013-07-25','18:30:00',1.26),('8784','2013-07-25','18:35:00',1.19),('8784','2013-07-25','18:40:00',1.1),('8784','2013-07-25','18:45:00',1.02),('8784','2013-07-24','08:00:00',1.12),('8784','2013-07-24','08:05:00',1.1),('8784','2013-07-24','08:10:00',1.04),('8784','2013-07-24','08:15:00',1.24),('8784','2013-07-24','08:20:00',1.28),('8784','2013-07-24','08:25:00',1.2),('8784','2013-07-24','08:30:00',1.17),('8784','2013-07-24','08:35:00',1.22),('8784','2013-07-24','08:40:00',1.21),('8784','2013-07-24','08:45:00',1.81),('8784','2013-07-24','08:50:00',2.25),('8784','2013-07-24','08:55:00',2.28),('8784','2013-07-24','09:00:00',2.39),('8784','2013-07-24','09:05:00',2.16),('8784','2013-07-24','09:10:00',2.6),('8784','2013-07-24','09:15:00',1.81),('8784','2013-07-24','09:20:00',2.12),('8784','2013-07-24','09:25:00',1.46),('8784','2013-07-24','09:30:00',2.11),('8784','2013-07-24','09:35:00',1.96),('8784','2013-07-24','09:40:00',1.85),('8784','2013-07-24','09:45:00',2),('8784','2013-07-24','09:50:00',1.48),('8784','2013-07-24','09:55:00',1.54),('8784','2013-07-24','10:15:00',1.29),('8784','2013-07-24','10:20:00',2.49),('8784','2013-07-24','10:25:00',3.61),('8784','2013-07-24','10:30:00',3.6),('8784','2013-07-24','10:35:00',3.81),('8784','2013-07-24','10:40:00',2.91),('8784','2013-07-24','10:45:00',1.66),('8784','2013-07-24','10:50:00',2.37),('8784','2013-07-24','10:55:00',2.59),('8784','2013-07-24','11:00:00',2.99),('8784','2013-07-24','11:05:00',1.84),('8784','2013-07-24','11:10:00',3.28),('8784','2013-07-24','11:15:00',4.1),('8784','2013-07-24','11:20:00',4.08),('8784','2013-07-24','11:25:00',3.77),('8784','2013-07-24','11:30:00',3.38),('8784','2013-07-24','11:35:00',3.8),('8784','2013-07-24','11:40:00',4.1),('8784','2013-07-24','11:45:00',4.12),('8784','2013-07-24','11:50:00',4.11),('8784','2013-07-24','11:55:00',4.14),('8784','2013-07-24','12:00:00',4.31),('8784','2013-07-24','12:05:00',4.09),('8784','2013-07-24','12:10:00',4.54),('8784','2013-07-24','12:15:00',4.33),('8784','2013-07-24','12:20:00',3.78),('8784','2013-07-24','12:25:00',1.8),('8784','2013-07-24','12:30:00',4.54),('8784','2013-07-24','12:35:00',2.15),('8784','2013-07-24','12:40:00',2.46),('8784','2013-07-24','12:45:00',2.81),('8784','2013-07-24','12:50:00',1.7),('8784','2013-07-24','12:55:00',4.25),('8784','2013-07-24','13:00:00',4.47),('8784','2013-07-24','13:05:00',4.23),('8784','2013-07-24','13:10:00',3.06),('8784','2013-07-24','13:15:00',2.45),('8784','2013-07-24','13:20:00',1.93),('8784','2013-07-24','13:25:00',4.12),('8784','2013-07-24','13:30:00',4.34),('8784','2013-07-24','13:35:00',2.9),('8784','2013-07-24','13:40:00',1.11),('8784','2013-07-24','13:45:00',3.15),('8784','2013-07-24','13:50:00',4.58),('8784','2013-07-24','13:55:00',4.59),('8784','2013-07-24','14:00:00',4.46),('8784','2013-07-24','14:05:00',4.29),('8784','2013-07-24','14:10:00',4.5),('8784','2013-07-24','14:15:00',4.21),('8784','2013-07-24','14:20:00',4.29),('8784','2013-07-24','14:25:00',4.4),('8784','2013-07-24','14:30:00',4.39),('8784','2013-07-24','14:35:00',4.48),('8784','2013-07-24','14:40:00',4.21),('8784','2013-07-24','14:45:00',4.26),('8784','2013-07-24','14:50:00',4.21),('8784','2013-07-24','14:55:00',4.17),('8784','2013-07-24','15:00:00',4.11),('8784','2013-07-24','15:05:00',4.05),('8784','2013-07-24','15:10:00',4.01),('8784','2013-07-24','15:15:00',3.99),('8784','2013-07-24','15:20:00',3.92),('8784','2013-07-24','15:25:00',3.89),('8784','2013-07-24','15:30:00',3.69),('8784','2013-07-24','15:35:00',3.62),('8784','2013-07-24','15:40:00',3.75),('8784','2013-07-24','15:45:00',3.62),('8784','2013-07-24','15:50:00',3.56),('8784','2013-07-24','15:55:00',3.56),('8784','2013-07-24','16:00:00',3.54),('8784','2013-07-24','16:05:00',3.43),('8784','2013-07-24','16:10:00',3.41),('8784','2013-07-24','16:15:00',3.4),('8784','2013-07-24','16:20:00',3.4),('8784','2013-07-24','16:25:00',3.36),('8784','2013-07-24','16:30:00',3.29),('8784','2013-07-24','16:35:00',3.21),('8784','2013-07-24','16:40:00',3.17),('8784','2013-07-24','16:45:00',3.04),('8784','2013-07-24','16:50:00',3.01),('8784','2013-07-24','16:55:00',3.04),('8784','2013-07-24','17:00:00',2.98),('8784','2013-07-24','17:05:00',2.86),('8784','2013-07-24','17:10:00',2.61),('8784','2013-07-24','17:15:00',2.61),('8784','2013-07-24','17:20:00',2.52),('8784','2013-07-24','17:25:00',2.41),('8784','2013-07-24','17:30:00',2.34),('8784','2013-07-24','17:35:00',2.21),('8784','2013-07-24','17:40:00',2.13),('8784','2013-07-24','17:45:00',2.03),('8784','2013-07-24','17:50:00',1.93),('8784','2013-07-24','17:55:00',1.84),('8784','2013-07-24','18:00:00',1.75),('8784','2013-07-24','18:05:00',1.64),('8784','2013-07-24','18:10:00',1.53),('8784','2013-07-24','18:15:00',1.46),('8784','2013-07-24','18:20:00',1.37),('8784','2013-07-24','18:25:00',1.33),('8784','2013-07-24','18:30:00',1.27),('8784','2013-07-24','18:35:00',1.21),('8784','2013-07-24','18:40:00',1.11),('8784','2013-07-23','07:35:00',1.05),('8784','2013-07-23','07:40:00',1.14),('8784','2013-07-23','07:45:00',1.2),('8784','2013-07-23','07:50:00',1.26),('8784','2013-07-23','07:55:00',1.33),('8784','2013-07-23','08:00:00',1.35),('8784','2013-07-23','08:05:00',1.48),('8784','2013-07-23','08:10:00',1.61),('8784','2013-07-23','08:15:00',1.71),('8784','2013-07-23','08:20:00',1.74),('8784','2013-07-23','08:25:00',1.84),('8784','2013-07-23','08:30:00',1.94),('8784','2013-07-23','08:35:00',2.02),('8784','2013-07-23','08:40:00',2.12),('8784','2013-07-23','08:45:00',2.2),('8784','2013-07-23','08:50:00',2.29),('8784','2013-07-23','08:55:00',2.38),('8784','2013-07-23','09:00:00',2.46),('8784','2013-07-23','09:05:00',2.49),('8784','2013-07-23','09:10:00',2.55),('8784','2013-07-23','09:15:00',2.61),('8784','2013-07-23','09:20:00',2.66),('8784','2013-07-23','09:25:00',2.74),('8784','2013-07-23','09:30:00',2.78),('8784','2013-07-23','09:35:00',2.81),('8784','2013-07-23','09:40:00',2.88),('8784','2013-07-23','09:45:00',2.92),('8784','2013-07-23','09:50:00',2.98),('8784','2013-07-23','09:55:00',3.05),('8784','2013-07-23','10:00:00',3.08),('8784','2013-07-23','10:05:00',3.13),('8784','2013-07-23','10:10:00',3.18),('8784','2013-07-23','10:15:00',3.2),('8784','2013-07-23','10:20:00',3.29),('8784','2013-07-23','10:25:00',3.38),('8784','2013-07-23','10:30:00',3.48),('8784','2013-07-23','10:35:00',3.53),('8784','2013-07-23','10:40:00',3.58),('8784','2013-07-23','10:45:00',3.6),('8784','2013-07-23','10:50:00',3.62),('8784','2013-07-23','10:55:00',3.7),('8784','2013-07-23','11:00:00',3.71),('8784','2013-07-23','11:05:00',3.75),('8784','2013-07-23','11:10:00',3.81),('8784','2013-07-23','11:15:00',3.86),('8784','2013-07-23','11:20:00',3.88),('8784','2013-07-23','11:25:00',3.88),('8784','2013-07-23','11:30:00',3.92),('8784','2013-07-23','11:35:00',3.96),('8784','2013-07-23','11:40:00',4.02),('8784','2013-07-23','11:45:00',4.02),('8784','2013-07-23','11:50:00',4.01),('8784','2013-07-23','11:55:00',4.11),('8784','2013-07-23','12:00:00',4.13),('8784','2013-07-23','12:05:00',4.17),('8784','2013-07-23','12:10:00',4.2),('8784','2013-07-23','12:15:00',4.22),('8784','2013-07-23','12:20:00',4.18),('8784','2013-07-23','12:25:00',4.1),('8784','2013-07-23','12:30:00',3.99),('8784','2013-07-23','12:35:00',2.05),('8784','2013-07-23','12:45:00',1.88),('8784','2013-07-23','12:50:00',1.81),('8784','2013-07-23','12:55:00',4.12),('8784','2013-07-23','13:00:00',1.52),('8784','2013-07-23','13:05:00',1),('8784','2013-07-23','13:30:00',2.83),('8784','2013-07-23','13:35:00',4.51),('8784','2013-07-23','13:40:00',2.27),('8784','2013-07-23','13:55:00',2),('8784','2013-07-23','14:00:00',4.18),('8784','2013-07-23','14:05:00',4.13),('8784','2013-07-23','14:10:00',1.21),('8784','2013-07-23','14:25:00',1.64),('8784','2013-07-23','14:30:00',2.27),('8784','2013-07-23','14:35:00',2.25),('8784','2013-07-23','14:40:00',1.79),('8784','2013-07-23','14:45:00',2.97),('8784','2013-07-23','14:50:00',2),('8784','2013-07-23','14:55:00',3),('8784','2013-07-23','15:00:00',4.67),('8784','2013-07-23','15:05:00',3.72),('8784','2013-07-23','15:10:00',4),('8784','2013-07-23','15:15:00',4.01),('8784','2013-07-23','15:20:00',3.85),('8784','2013-07-23','15:25:00',3.8),('8784','2013-07-23','15:30:00',3.73),('8784','2013-07-23','15:35:00',3.76),('8784','2013-07-23','15:40:00',3.56),('8784','2013-07-23','15:45:00',3.52),('8784','2013-07-23','15:50:00',3.52),('8784','2013-07-23','15:55:00',3.48),('8784','2013-07-23','16:00:00',3.44),('8784','2013-07-23','16:05:00',3.38),('8784','2013-07-23','16:10:00',3.29),('8784','2013-07-23','16:15:00',3.24),('8784','2013-07-23','16:20:00',3.22),('8784','2013-07-23','16:25:00',3.15),('8784','2013-07-23','16:30:00',3.08),('8784','2013-07-23','16:35:00',3.01),('8784','2013-07-23','16:40:00',2.96),('8784','2013-07-23','16:45:00',2.89),('8784','2013-07-23','16:50:00',2.84),('8784','2013-07-23','16:55:00',2.77),('8784','2013-07-23','17:00:00',2.69),('8784','2013-07-23','17:05:00',2.61),('8784','2013-07-23','17:10:00',2.57),('8784','2013-07-23','17:15:00',2.5),('8784','2013-07-23','17:20:00',2.44),('8784','2013-07-23','17:25:00',2.36),('8784','2013-07-23','17:30:00',2.29),('8784','2013-07-23','17:35:00',2.23),('8784','2013-07-23','17:40:00',2.15),('8784','2013-07-23','17:45:00',2.07),('8784','2013-07-23','17:50:00',1.99),('8784','2013-07-23','17:55:00',1.9),('8784','2013-07-23','18:00:00',1.83),('8784','2013-07-23','18:05:00',1.74),('8784','2013-07-23','18:10:00',1.65),('8784','2013-07-23','18:15:00',1.57),('8784','2013-07-23','18:20:00',1.5),('8784','2013-07-23','18:25:00',1.41),('8784','2013-07-23','18:30:00',1.34),('8784','2013-07-23','18:35:00',1.23),('8784','2013-07-22','07:35:00',1.02),('8784','2013-07-22','07:40:00',1.1),('8784','2013-07-22','07:45:00',1.16),('8784','2013-07-22','07:50:00',1.23),('8784','2013-07-22','07:55:00',1.3),('8784','2013-07-22','08:00:00',1.4),('8784','2013-07-22','08:05:00',1.49),('8784','2013-07-22','08:10:00',1.59),('8784','2013-07-22','08:15:00',1.67),('8784','2013-07-22','08:20:00',1.75),('8784','2013-07-22','08:25:00',1.85),('8784','2013-07-22','08:30:00',1.93),('8784','2013-07-22','08:35:00',2.01),('8784','2013-07-22','08:40:00',2.1),('8784','2013-07-22','08:45:00',2.16),('8784','2013-07-22','08:50:00',2.24),('8784','2013-07-22','08:55:00',2.31),('8784','2013-07-22','09:00:00',2.39),('8784','2013-07-22','09:05:00',2.49),('8784','2013-07-22','09:10:00',2.55),('8784','2013-07-22','09:15:00',2.63),('8784','2013-07-22','09:20:00',2.69),('8784','2013-07-22','09:25:00',2.74),('8784','2013-07-22','09:30:00',2.81),('8784','2013-07-22','09:35:00',2.87),('8784','2013-07-22','09:40:00',2.93),('8784','2013-07-22','09:45:00',2.99),('8784','2013-07-22','09:50:00',3.07),('8784','2013-07-22','09:55:00',3.13),('8784','2013-07-22','10:00:00',3.2),('8784','2013-07-22','10:05:00',3.22),('8784','2013-07-22','10:10:00',3.3),('8784','2013-07-22','10:15:00',3.36),('8784','2013-07-22','10:20:00',3.42),('8784','2013-07-22','10:25:00',3.46),('8784','2013-07-22','10:30:00',3.52),('8784','2013-07-22','10:35:00',3.57),('8784','2013-07-22','10:40:00',3.6),('8784','2013-07-22','10:45:00',3.63),('8784','2013-07-22','10:50:00',3.67),('8784','2013-07-22','10:55:00',3.71),('8784','2013-07-22','11:00:00',3.74),('8784','2013-07-22','11:05:00',3.78),('8784','2013-07-22','11:10:00',3.8),('8784','2013-07-22','11:15:00',3.86),('8784','2013-07-22','11:20:00',3.85),('8784','2013-07-22','11:25:00',3.9),('8784','2013-07-22','11:30:00',3.9),('8784','2013-07-22','11:35:00',3.91),('8784','2013-07-22','11:40:00',3.98),('8784','2013-07-22','11:45:00',3.98),('8784','2013-07-22','11:50:00',4),('8784','2013-07-22','11:55:00',4.02),('8784','2013-07-22','12:00:00',4.02),('8784','2013-07-22','12:05:00',4.06),('8784','2013-07-22','12:10:00',4.1),('8784','2013-07-22','12:15:00',4.13),('8784','2013-07-22','12:20:00',4.19),('8784','2013-07-22','12:25:00',4.17),('8784','2013-07-22','12:30:00',4.18),('8784','2013-07-22','12:35:00',4.21),('8784','2013-07-22','12:40:00',4.23),('8784','2013-07-22','12:45:00',4.18),('8784','2013-07-22','12:50:00',4.19),('8784','2013-07-22','12:55:00',4.18),('8784','2013-07-22','13:00:00',4.16),('8784','2013-07-22','13:05:00',4.16),('8784','2013-07-22','13:10:00',4.18),('8784','2013-07-22','13:15:00',4.19),('8784','2013-07-22','13:20:00',4.21),('8784','2013-07-22','13:25:00',4.24),('8784','2013-07-22','13:30:00',4.2),('8784','2013-07-22','13:35:00',4.19),('8784','2013-07-22','13:40:00',4.2),('8784','2013-07-22','13:45:00',4.23),('8784','2013-07-22','13:50:00',4.2),('8784','2013-07-22','13:55:00',4.15),('8784','2013-07-22','14:00:00',4.12),('8784','2013-07-22','14:05:00',4.12),('8784','2013-07-22','14:10:00',4.11),('8784','2013-07-22','14:15:00',4.07),('8784','2013-07-22','14:20:00',4.03),('8784','2013-07-22','14:25:00',4.03),('8784','2013-07-22','14:30:00',4.04),('8784','2013-07-22','14:35:00',3.98),('8784','2013-07-22','14:40:00',3.95),('8784','2013-07-22','14:45:00',3.96),('8784','2013-07-22','14:50:00',3.92),('8784','2013-07-22','14:55:00',3.8),('8784','2013-07-22','15:00:00',3.8),('8784','2013-07-22','15:05:00',3.79),('8784','2013-07-22','15:10:00',3.83),('8784','2013-07-22','15:15:00',3.77),('8784','2013-07-22','15:20:00',3.73),('8784','2013-07-22','15:25:00',3.74),('8784','2013-07-22','15:30:00',1.78),('8784','2013-07-22','15:40:00',1.53),('8784','2013-07-22','15:45:00',3.12),('8784','2013-07-22','15:50:00',3.82),('8784','2013-07-22','15:55:00',3.94),('8784','2013-07-22','16:00:00',3.92),('8784','2013-07-22','16:05:00',3.79),('8784','2013-07-22','16:10:00',3.32),('8784','2013-07-22','16:15:00',3.13),('8784','2013-07-22','16:20:00',3.56),('8784','2013-07-22','16:25:00',3.38),('8784','2013-07-22','16:30:00',3.21),('8784','2013-07-22','16:35:00',3.14),('8784','2013-07-22','16:40:00',2.91),('8784','2013-07-22','16:45:00',2.84),('8784','2013-07-22','16:50:00',2.77),('8784','2013-07-22','16:55:00',2.73),('8784','2013-07-22','17:00:00',2.66),('8784','2013-07-22','17:05:00',2.62),('8784','2013-07-22','17:10:00',2.54),('8784','2013-07-22','17:15:00',2.47),('8784','2013-07-22','17:20:00',2.4),('8784','2013-07-22','17:25:00',2.26),('8784','2013-07-22','17:30:00',2.16),('8784','2013-07-22','17:35:00',2.2),('8784','2013-07-22','17:40:00',2.1),('8784','2013-07-22','17:45:00',1.89),('8784','2013-07-22','17:50:00',1.83),('8784','2013-07-22','17:55:00',1.8),('8784','2013-07-22','18:00:00',1.8),('8784','2013-07-22','18:05:00',1.7),('8784','2013-07-22','18:10:00',1.55),('8784','2013-07-22','18:15:00',1.42),('8784','2013-07-22','18:20:00',1.37),('8784','2013-07-22','18:25:00',1.33),('8784','2013-07-22','18:30:00',1.24),('8784','2013-07-22','18:35:00',1.17),('8784','2013-07-22','18:40:00',1.05),('8784','2013-07-21','07:40:00',1.08),('8784','2013-07-21','07:45:00',1.19),('8784','2013-07-21','07:50:00',1.23),('8784','2013-07-21','07:55:00',1.28),('8784','2013-07-21','08:00:00',1.33),('8784','2013-07-21','08:05:00',1.41),('8784','2013-07-21','08:10:00',1.5),('8784','2013-07-21','08:15:00',1.58),('8784','2013-07-21','08:20:00',1.61),('8784','2013-07-21','08:25:00',1.69),('8784','2013-07-21','08:30:00',1.8),('8784','2013-07-21','08:35:00',1.89),('8784','2013-07-21','08:40:00',1.99),('8784','2013-07-21','08:45:00',2.05),('8784','2013-07-21','08:50:00',2.07),('8784','2013-07-21','08:55:00',2.22),('8784','2013-07-21','09:00:00',2.3),('8784','2013-07-21','09:05:00',2.36),('8784','2013-07-21','09:10:00',2.46),('8784','2013-07-21','09:15:00',2.54),('8784','2013-07-21','09:20:00',2.58),('8784','2013-07-21','09:25:00',2.67),('8784','2013-07-21','09:30:00',2.73),('8784','2013-07-21','09:35:00',2.78),('8784','2013-07-21','09:40:00',2.85),('8784','2013-07-21','09:45:00',2.92),('8784','2013-07-21','09:50:00',2.96),('8784','2013-07-21','09:55:00',3.01),('8784','2013-07-21','10:00:00',3.1),('8784','2013-07-21','10:05:00',3.16),('8784','2013-07-21','10:10:00',3.2),('8784','2013-07-21','10:15:00',3.26),('8784','2013-07-21','10:20:00',3.29),('8784','2013-07-21','10:25:00',3.36),('8784','2013-07-21','10:30:00',3.41),('8784','2013-07-21','10:35:00',3.45),('8784','2013-07-21','10:40:00',3.48),('8784','2013-07-21','10:45:00',3.53),('8784','2013-07-21','10:50:00',3.61),('8784','2013-07-21','10:55:00',3.61),('8784','2013-07-21','11:00:00',3.68),('8784','2013-07-21','11:05:00',3.71),('8784','2013-07-21','11:10:00',3.73),('8784','2013-07-21','11:15:00',3.75),('8784','2013-07-21','11:20:00',3.77),('8784','2013-07-21','11:25:00',3.86),('8784','2013-07-21','11:30:00',3.91),('8784','2013-07-21','11:35:00',3.89),('8784','2013-07-21','11:40:00',4.03),('8784','2013-07-21','11:45:00',4.07),('8784','2013-07-21','11:50:00',4.02),('8784','2013-07-21','11:55:00',4.03),('8784','2013-07-21','12:00:00',4.05),('8784','2013-07-21','12:05:00',4.15),('8784','2013-07-21','12:10:00',4.23),('8784','2013-07-21','12:15:00',4.34),('8784','2013-07-21','12:20:00',4.39),('8784','2013-07-21','12:25:00',4.69),('8784','2013-07-21','12:30:00',4.77),('8784','2013-07-21','12:35:00',4.84),('8784','2013-07-21','12:40:00',4.93),('8784','2013-07-21','12:45:00',4.72),('8784','2013-07-21','12:50:00',3.83),('8784','2013-07-21','12:55:00',5.16),('8784','2013-07-21','13:00:00',4.45),('8784','2013-07-21','13:05:00',4.95),('8784','2013-07-21','13:10:00',4.05),('8784','2013-07-21','13:15:00',3.95),('8784','2013-07-21','13:20:00',4.17),('8784','2013-07-21','13:25:00',4.29),('8784','2013-07-21','13:30:00',4.66),('8784','2013-07-21','13:35:00',4.54),('8784','2013-07-21','13:40:00',4.4),('8784','2013-07-21','13:45:00',4.3),('8784','2013-07-21','13:50:00',2.25),('8784','2013-07-21','13:55:00',1.06),('8784','2013-07-21','14:00:00',1.11),('8784','2013-07-21','14:05:00',1.21),('8784','2013-07-21','14:10:00',1.13),('8784','2013-07-21','14:15:00',1.12),('8784','2013-07-21','14:20:00',1.38),('8784','2013-07-21','14:25:00',1.52),('8784','2013-07-21','14:30:00',1.31),('8784','2013-07-21','14:35:00',1.4),('8784','2013-07-21','14:40:00',1.34),('8784','2013-07-21','14:45:00',1.51),('8784','2013-07-21','14:50:00',1.77),('8784','2013-07-21','14:55:00',1.75),('8784','2013-07-21','15:00:00',1.97),('8784','2013-07-21','15:05:00',1.78),('8784','2013-07-21','15:10:00',1.86),('8784','2013-07-21','15:15:00',4.06),('8784','2013-07-21','15:20:00',4.86),('8784','2013-07-21','15:25:00',1.76),('8784','2013-07-21','15:30:00',1.56),('8784','2013-07-21','15:35:00',1.75),('8784','2013-07-21','15:40:00',2.73),('8784','2013-07-21','15:45:00',3.92),('8784','2013-07-21','15:50:00',3.2),('8784','2013-07-21','15:55:00',2.2),('8784','2013-07-21','16:00:00',1.44),('8784','2013-07-21','16:05:00',1.09),('8784','2013-07-21','16:50:00',1.01),('8784','2013-07-21','16:55:00',1.13),('8784','2013-07-21','17:00:00',1.25),('8784','2013-07-21','17:05:00',1.35),('8784','2013-07-21','17:10:00',1.41),('8784','2013-07-21','17:15:00',1.17),('8784','2013-07-21','17:20:00',1.05),('8784','2014-04-07','08:20:00',1.1),('8784','2014-04-07','08:25:00',1.14),('8784','2014-04-07','08:30:00',1.29),('8784','2014-04-07','08:35:00',1.74),('8784','2014-04-07','08:40:00',1.79),('8784','2014-04-07','08:45:00',1.6),('8784','2014-04-07','08:50:00',1.49),('8784','2014-04-07','08:55:00',1.33),('8784','2014-04-07','09:00:00',1.25),('8784','2014-04-07','09:05:00',1.27),('8784','2014-04-07','09:10:00',1.47),('8784','2014-04-07','09:15:00',1.73),('8784','2014-04-07','09:20:00',1.38),('8784','2014-04-07','09:25:00',1.29),('8784','2014-04-07','09:30:00',1.28),('8784','2014-04-07','09:35:00',1.23),('8784','2014-04-07','09:40:00',1.26),('8784','2014-04-07','09:45:00',1.33),('8784','2014-04-07','09:50:00',1.4),('8784','2014-04-07','09:55:00',1.48),('8784','2014-04-07','10:00:00',1.48),('8784','2014-04-07','10:05:00',1.48),('8784','2014-04-07','10:10:00',1.52),('8784','2014-04-07','10:15:00',1.4),('8784','2014-04-07','10:20:00',1.4),('8784','2014-04-07','10:25:00',1.44),('8784','2014-04-07','10:30:00',1.48),('8784','2014-04-07','10:35:00',1.57),('8784','2014-04-07','10:40:00',1.6),('8784','2014-04-07','10:45:00',1.66),('8784','2014-04-07','10:50:00',1.74),('8784','2014-04-07','10:55:00',1.86),('8784','2014-04-07','11:00:00',2.01),('8784','2014-04-07','11:05:00',2.08),('8784','2014-04-07','11:10:00',2.32),('8784','2014-04-07','11:15:00',2.43),('8784','2014-04-07','11:20:00',2.46),('8784','2014-04-07','11:25:00',2.14),('8784','2014-04-07','11:30:00',2.15),('8784','2014-04-07','11:35:00',2.13),('8784','2014-04-07','11:40:00',2.07),('8784','2014-04-07','11:45:00',1.97),('8784','2014-04-07','11:50:00',1.86),('8784','2014-04-07','11:55:00',1.8),('8784','2014-04-07','12:00:00',2),('8784','2014-04-07','12:05:00',2.45),('8784','2014-04-07','12:10:00',2.62),('8784','2014-04-07','12:15:00',3.47),('8784','2014-04-07','12:20:00',4.13),('8784','2014-04-07','12:25:00',3.84),('8784','2014-04-07','12:30:00',2.41),('8784','2014-04-07','12:35:00',2.2),('8784','2014-04-07','12:40:00',2.7),('8784','2014-04-07','12:45:00',4.05),('8784','2014-04-07','12:50:00',4.1),('8784','2014-04-07','12:55:00',4.02),('8784','2014-04-07','13:00:00',4.04),('8784','2014-04-07','13:05:00',4.06),('8784','2014-04-07','13:10:00',4.01),('8784','2014-04-07','13:15:00',4),('8784','2014-04-07','13:20:00',3.98),('8784','2014-04-07','13:25:00',3.98),('8784','2014-04-07','13:30:00',3.99),('8784','2014-04-07','13:35:00',3.96),('8784','2014-04-07','13:40:00',3.94),('8784','2014-04-07','13:45:00',3.92),('8784','2014-04-07','13:50:00',3.95),('8784','2014-04-07','13:55:00',3.96),('8784','2014-04-07','14:00:00',3.95),('8784','2014-04-07','14:05:00',3.91),('8784','2014-04-07','14:10:00',3.85),('8784','2014-04-07','14:15:00',3.81),('8784','2014-04-07','14:20:00',3.81),('8784','2014-04-07','14:25:00',3.91),('8784','2014-04-07','14:30:00',3.87),('8784','2014-04-07','14:35:00',3.77),('8784','2014-04-07','14:40:00',3.73),('8784','2014-04-07','14:45:00',3.61),('8784','2014-04-07','14:50:00',3.71),('8784','2014-04-07','14:55:00',3.56),('8784','2014-04-07','15:00:00',2.99),('8784','2014-04-07','15:05:00',3.7),('8784','2014-04-07','15:10:00',3.58),('8784','2014-04-07','15:15:00',3.7),('8784','2014-04-07','15:20:00',3.83),('8784','2014-04-07','15:25:00',3.79),('8784','2014-04-07','15:30:00',3.46),('8784','2014-04-07','15:35:00',3.48),('8784','2014-04-07','15:40:00',3.4),('8784','2014-04-07','15:45:00',3.49),('8784','2014-04-07','15:50:00',3.65),('8784','2014-04-07','15:55:00',3.59),('8784','2014-04-07','16:00:00',2.61),('8784','2014-04-07','16:05:00',1.96),('8784','2014-04-07','16:10:00',3.03),('8784','2014-04-07','16:15:00',2.89),('8784','2014-04-07','16:20:00',2.66),('8784','2014-04-07','16:25:00',2.6),('8784','2014-04-07','16:30:00',2.42),('8784','2014-04-07','16:35:00',1.37),('8784','2014-04-07','16:40:00',1.38),('8784','2014-04-07','16:45:00',1.82),('8784','2014-04-07','16:50:00',2.42),('8784','2014-04-07','16:55:00',2.49),('8784','2014-04-07','17:00:00',2.56),('8784','2014-04-07','17:05:00',2.39),('8784','2014-04-07','17:10:00',1.78),('8784','2014-04-07','17:15:00',1.87),('8784','2014-04-07','17:20:00',1.48),('8784','2014-04-07','17:55:00',1.13),('8784','2014-04-07','18:00:00',1.03),('8784','2013-07-20','07:35:00',1.04),('8784','2013-07-20','07:40:00',1.1),('8784','2013-07-20','07:45:00',1.18),('8784','2013-07-20','07:50:00',1.27),('8784','2013-07-20','07:55:00',1.34),('8784','2013-07-20','08:00:00',1.41),('8784','2013-07-20','08:05:00',1.49),('8784','2013-07-20','08:10:00',1.58),('8784','2013-07-20','08:15:00',1.67),('8784','2013-07-20','08:20:00',1.73),('8784','2013-07-20','08:25:00',1.85),('8784','2013-07-20','08:30:00',1.93),('8784','2013-07-20','08:35:00',2),('8784','2013-07-20','08:40:00',2.1),('8784','2013-07-20','08:45:00',2.19),('8784','2013-07-20','08:50:00',2.24),('8784','2013-07-20','08:55:00',2.34),('8784','2013-07-20','09:00:00',2.42),('8784','2013-07-20','09:05:00',2.53),('8784','2013-07-20','09:10:00',2.65),('8784','2013-07-20','09:15:00',2.75),('8784','2013-07-20','09:20:00',2.76),('8784','2013-07-20','09:25:00',2.73),('8784','2013-07-20','09:30:00',2.72),('8784','2013-07-20','09:35:00',2.76),('8784','2013-07-20','09:40:00',2.78),('8784','2013-07-20','09:45:00',3.03),('8784','2013-07-20','09:50:00',2.97),('8784','2013-07-20','09:55:00',2.97),('8784','2013-07-20','10:00:00',3.17),('8784','2013-07-20','10:05:00',3.24),('8784','2013-07-20','10:10:00',3.32),('8784','2013-07-20','10:15:00',3.34),('8784','2013-07-20','10:20:00',3.4),('8784','2013-07-20','10:25:00',3.44),('8784','2013-07-20','10:30:00',3.48),('8784','2013-07-20','10:35:00',3.51),('8784','2013-07-20','10:40:00',3.55),('8784','2013-07-20','10:45:00',3.58),('8784','2013-07-20','10:50:00',3.62),('8784','2013-07-20','10:55:00',3.69),('8784','2013-07-20','11:00:00',3.74),('8784','2013-07-20','11:05:00',3.73),('8784','2013-07-20','11:10:00',3.76),('8784','2013-07-20','11:15:00',3.79),('8784','2013-07-20','11:20:00',3.78),('8784','2013-07-20','11:25:00',3.81),('8784','2013-07-20','11:30:00',3.87),('8784','2013-07-20','11:35:00',3.91),('8784','2013-07-20','11:40:00',3.95),('8784','2013-07-20','11:45:00',4.03),('8784','2013-07-20','11:50:00',4.02),('8784','2013-07-20','11:55:00',4.09),('8784','2013-07-20','12:00:00',4.12),('8784','2013-07-20','12:05:00',4.2),('8784','2013-07-20','12:10:00',4.23),('8784','2013-07-20','12:15:00',4.2),('8784','2013-07-20','12:20:00',4.21),('8784','2013-07-20','12:25:00',4.19),('8784','2013-07-20','12:30:00',4.16),('8784','2013-07-20','12:35:00',4.21),('8784','2013-07-20','12:40:00',4.24),('8784','2013-07-20','12:45:00',4.31),('8784','2013-07-20','12:50:00',4.31),('8784','2013-07-20','12:55:00',4.3),('8784','2013-07-20','13:00:00',4.42),('8784','2013-07-20','13:05:00',4.41),('8784','2013-07-20','13:10:00',2.24),('8784','2013-07-20','13:15:00',1.07),('8784','2013-07-20','13:20:00',1.98),('8784','2013-07-20','13:25:00',1.56),('8784','2013-07-20','13:30:00',4.61),('8784','2013-07-20','13:35:00',4.55),('8784','2013-07-20','13:40:00',4.56),('8784','2013-07-20','13:45:00',3.98),('8784','2013-07-20','13:50:00',1.26),('8784','2013-07-20','14:00:00',3.07),('8784','2013-07-20','14:05:00',4.45),('8784','2013-07-20','14:10:00',4.46),('8784','2013-07-20','14:15:00',4.5),('8784','2013-07-20','14:20:00',4.36),('8784','2013-07-20','14:25:00',4.23),('8784','2013-07-20','14:30:00',4.08),('8784','2013-07-20','14:35:00',4.14),('8784','2013-07-20','14:40:00',4.21),('8784','2013-07-20','14:45:00',4.16),('8784','2013-07-20','14:50:00',4.2),('8784','2013-07-20','14:55:00',4.12),('8784','2013-07-20','15:00:00',4.17),('8784','2013-07-20','15:05:00',4.04),('8784','2013-07-20','15:10:00',4),('8784','2013-07-20','15:15:00',3.91),('8784','2013-07-20','15:20:00',3.82),('8784','2013-07-20','15:25:00',3.78),('8784','2013-07-20','15:30:00',3.73),('8784','2013-07-20','15:35:00',3.67),('8784','2013-07-20','15:40:00',3.64),('8784','2013-07-20','15:45:00',3.6),('8784','2013-07-20','15:50:00',3.54),('8784','2013-07-20','15:55:00',3.47),('8784','2013-07-20','16:00:00',3.43),('8784','2013-07-20','16:05:00',3.41),('8784','2013-07-20','16:10:00',3.34),('8784','2013-07-20','16:15:00',3.32),('8784','2013-07-20','16:20:00',3.25),('8784','2013-07-20','16:25:00',3.19),('8784','2013-07-20','16:30:00',3.11),('8784','2013-07-20','16:35:00',3),('8784','2013-07-20','16:40:00',2.97),('8784','2013-07-20','16:45:00',2.91),('8784','2013-07-20','16:50:00',2.85),('8784','2013-07-20','16:55:00',2.73),('8784','2013-07-20','17:00:00',2.67),('8784','2013-07-20','17:05:00',2.61),('8784','2013-07-20','17:10:00',2.53),('8784','2013-07-20','17:15:00',2.46),('8784','2013-07-20','17:20:00',2.37),('8784','2013-07-20','17:25:00',2.31),('8784','2013-07-20','17:30:00',2.25),('8784','2013-07-20','17:35:00',2.19),('8784','2013-07-20','17:40:00',2.1),('8784','2013-07-20','17:45:00',2.03),('8784','2013-07-20','17:50:00',1.96),('8784','2013-07-20','17:55:00',1.86),('8784','2013-07-20','18:00:00',1.79),('8784','2013-07-20','18:05:00',1.7),('8784','2013-07-20','18:10:00',1.62),('8784','2013-07-20','18:15:00',1.53),('8784','2013-07-20','18:20:00',1.46),('8784','2013-07-20','18:25:00',1.38),('8784','2013-07-20','18:30:00',1.3),('8784','2013-07-20','18:35:00',1.21),('8784','2013-07-20','18:40:00',1.13),('8784','2013-07-20','18:45:00',1.04),('8784','2013-07-19','07:35:00',1),('8784','2013-07-19','07:40:00',1.08),('8784','2013-07-19','07:45:00',1.16),('8784','2013-07-19','07:50:00',1.24),('8784','2013-07-19','07:55:00',1.31),('8784','2013-07-19','08:00:00',1.39),('8784','2013-07-19','08:05:00',1.45),('8784','2013-07-19','08:10:00',1.53),('8784','2013-07-19','08:15:00',1.61),('8784','2013-07-19','08:20:00',1.67),('8784','2013-07-19','08:25:00',1.75),('8784','2013-07-19','08:30:00',1.84),('8784','2013-07-19','08:35:00',1.93),('8784','2013-07-19','08:40:00',2.02),('8784','2013-07-19','08:45:00',2.12),('8784','2013-07-19','08:50:00',2.17),('8784','2013-07-19','08:55:00',2.26),('8784','2013-07-19','09:00:00',2.31),('8784','2013-07-19','09:05:00',2.39),('8784','2013-07-19','09:10:00',2.46),('8784','2013-07-19','09:15:00',2.53),('8784','2013-07-19','09:20:00',2.59),('8784','2013-07-19','09:25:00',2.63),('8784','2013-07-19','09:30:00',2.72),('8784','2013-07-19','09:35:00',2.75),('8784','2013-07-19','09:40:00',2.82),('8784','2013-07-19','09:45:00',2.89),('8784','2013-07-19','09:50:00',2.94),('8784','2013-07-19','09:55:00',2.99),('8784','2013-07-19','10:00:00',3.04),('8784','2013-07-19','10:05:00',3.08),('8784','2013-07-19','10:10:00',3.15),('8784','2013-07-19','10:15:00',3.2),('8784','2013-07-19','10:20:00',3.22),('8784','2013-07-19','10:25:00',3.31),('8784','2013-07-19','10:30:00',3.31),('8784','2013-07-19','10:35:00',3.38),('8784','2013-07-19','10:40:00',3.44),('8784','2013-07-19','10:45:00',3.49),('8784','2013-07-19','10:50:00',3.48),('8784','2013-07-19','10:55:00',3.51),('8784','2013-07-19','11:00:00',3.54),('8784','2013-07-19','11:05:00',3.59),('8784','2013-07-19','11:10:00',3.65),('8784','2013-07-19','11:15:00',3.7),('8784','2013-07-19','11:20:00',3.76),('8784','2013-07-19','11:25:00',3.77),('8784','2013-07-19','11:30:00',3.77),('8784','2013-07-19','11:35:00',3.81),('8784','2013-07-19','11:40:00',3.9),('8784','2013-07-19','11:45:00',3.87),('8784','2013-07-19','11:50:00',3.82),('8784','2013-07-19','11:55:00',3.88),('8784','2013-07-19','12:00:00',3.72),('8784','2013-07-19','12:05:00',4.15),('8784','2013-07-19','12:10:00',4.12),('8784','2013-07-19','12:15:00',4.24),('8784','2013-07-19','12:20:00',4.24),('8784','2013-07-19','12:25:00',4.15),('8784','2013-07-19','12:30:00',4.16),('8784','2013-07-19','12:35:00',4.12),('8784','2013-07-19','12:40:00',4.08),('8784','2013-07-19','12:45:00',3.94),('8784','2013-07-19','12:50:00',4.19),('8784','2013-07-19','12:55:00',4.28),('8784','2013-07-19','13:00:00',4.15),('8784','2013-07-19','13:05:00',4.24),('8784','2013-07-19','13:10:00',3.75),('8784','2013-07-19','13:15:00',1.57),('8784','2013-07-19','13:20:00',2.93),('8784','2013-07-19','13:25:00',4.69),('8784','2013-07-19','13:30:00',4.48),('8784','2013-07-19','13:35:00',4.37),('8784','2013-07-19','13:40:00',4.37),('8784','2013-07-19','13:45:00',4.34),('8784','2013-07-19','13:50:00',4.39),('8784','2013-07-19','13:55:00',4.38),('8784','2013-07-19','14:00:00',4.34),('8784','2013-07-19','14:05:00',4.32),('8784','2013-07-19','14:10:00',3.57),('8784','2013-07-19','14:15:00',3.93),('8784','2013-07-19','14:20:00',4.24),('8784','2013-07-19','14:25:00',3.98),('8784','2013-07-19','14:30:00',4.31),('8784','2013-07-19','14:35:00',3.99),('8784','2013-07-19','14:40:00',3.68),('8784','2013-07-19','14:45:00',4.18),('8784','2013-07-19','14:50:00',3.94),('8784','2013-07-19','14:55:00',4.2),('8784','2013-07-19','15:00:00',4.08),('8784','2013-07-19','15:05:00',4.1),('8784','2013-07-19','15:10:00',4.01),('8784','2013-07-19','15:15:00',2.2),('8784','2013-07-19','15:20:00',3.12),('8784','2013-07-19','15:25:00',3.37),('8784','2013-07-19','15:30:00',4.04),('8784','2013-07-19','15:35:00',3.94),('8784','2013-07-19','15:40:00',3.92),('8784','2013-07-19','15:45:00',3.78),('8784','2013-07-19','15:50:00',3.72),('8784','2013-07-19','15:55:00',3.66),('8784','2013-07-19','16:00:00',3.58),('8784','2013-07-19','16:05:00',3.53),('8784','2013-07-19','16:10:00',3.5),('8784','2013-07-19','16:15:00',3.42),('8784','2013-07-19','16:20:00',3.37),('8784','2013-07-19','16:25:00',3.31),('8784','2013-07-19','16:30:00',3.29),('8784','2013-07-19','16:35:00',3.25),('8784','2013-07-19','16:40:00',3.18),('8784','2013-07-19','16:45:00',3.14),('8784','2013-07-19','16:50:00',3.09),('8784','2013-07-19','16:55:00',3.1),('8784','2013-07-19','17:00:00',2.7),('8784','2013-07-19','17:05:00',3.08),('8784','2013-07-19','17:10:00',2.69),('8784','2013-07-19','17:15:00',2.74),('8784','2013-07-19','17:20:00',2.47),('8784','2013-07-19','17:25:00',2.01),('8784','2013-07-19','17:30:00',2.36),('8784','2013-07-19','17:35:00',2.53),('8784','2013-07-19','17:40:00',1.98),('8784','2013-07-19','17:45:00',1.45),('8784','2013-07-19','17:50:00',1.06),('8784','2013-07-18','07:30:00',1.01),('8784','2013-07-18','07:35:00',1.09),('8784','2013-07-18','07:40:00',1.16),('8784','2013-07-18','07:45:00',1.25),('8784','2013-07-18','07:50:00',1.34),('8784','2013-07-18','07:55:00',1.42),('8784','2013-07-18','08:00:00',1.48),('8784','2013-07-18','08:05:00',1.55),('8784','2013-07-18','08:10:00',1.64),('8784','2013-07-18','08:15:00',1.65),('8784','2013-07-18','08:20:00',1.75),('8784','2013-07-18','08:25:00',1.84),('8784','2013-07-18','08:30:00',1.95),('8784','2013-07-18','08:35:00',2.06),('8784','2013-07-18','08:40:00',2.14),('8784','2013-07-18','08:45:00',2.21),('8784','2013-07-18','08:50:00',2.28),('8784','2013-07-18','08:55:00',2.34),('8784','2013-07-18','09:00:00',2.43),('8784','2013-07-18','09:05:00',2.47),('8784','2013-07-18','09:10:00',2.55),('8784','2013-07-18','09:15:00',2.63),('8784','2013-07-18','09:20:00',2.7),('8784','2013-07-18','09:25:00',2.75),('8784','2013-07-18','09:30:00',2.83),('8784','2013-07-18','09:35:00',2.9),('8784','2013-07-18','09:40:00',2.96),('8784','2013-07-18','09:45:00',2.99),('8784','2013-07-18','09:50:00',3.08),('8784','2013-07-18','09:55:00',3.13),('8784','2013-07-18','10:00:00',3.18),('8784','2013-07-18','10:05:00',3.21),('8784','2013-07-18','10:10:00',3.3),('8784','2013-07-18','10:15:00',3.32),('8784','2013-07-18','10:20:00',3.37),('8784','2013-07-18','10:25:00',3.43),('8784','2013-07-18','10:30:00',3.49),('8784','2013-07-18','10:35:00',3.55),('8784','2013-07-18','10:40:00',3.6),('8784','2013-07-18','10:45:00',3.66),('8784','2013-07-18','10:50:00',3.69),('8784','2013-07-18','10:55:00',3.71),('8784','2013-07-18','11:00:00',3.72),('8784','2013-07-18','11:05:00',3.75),('8784','2013-07-18','11:10:00',3.78),('8784','2013-07-18','11:15:00',3.83),('8784','2013-07-18','11:20:00',3.87),('8784','2013-07-18','11:25:00',3.88),('8784','2013-07-18','11:30:00',3.9),('8784','2013-07-18','11:35:00',3.89),('8784','2013-07-18','11:40:00',3.95),('8784','2013-07-18','11:45:00',3.97),('8784','2013-07-18','11:50:00',3.99),('8784','2013-07-18','11:55:00',4.05),('8784','2013-07-18','12:00:00',4.04),('8784','2013-07-18','12:05:00',4),('8784','2013-07-18','12:10:00',3.95),('8784','2013-07-18','12:15:00',3.97),('8784','2013-07-18','12:20:00',3.96),('8784','2013-07-18','12:25:00',4.08),('8784','2013-07-18','12:30:00',4.28),('8784','2013-07-18','12:35:00',4.24),('8784','2013-07-18','12:40:00',4.35),('8784','2013-07-18','12:45:00',4.54),('8784','2013-07-18','12:50:00',3.95),('8784','2013-07-18','12:55:00',4.3),('8784','2013-07-18','13:00:00',4.22),('8784','2013-07-18','13:05:00',3.19),('8784','2013-07-18','13:10:00',3.97),('8784','2013-07-18','13:15:00',4.21),('8784','2013-07-18','13:20:00',4.23),('8784','2013-07-18','13:25:00',3.84),('8784','2013-07-18','13:30:00',3.83),('8784','2013-07-18','13:35:00',4.29),('8784','2013-07-18','13:40:00',3.68),('8784','2013-07-18','13:45:00',4.29),('8784','2013-07-18','13:50:00',4.36),('8784','2013-07-18','13:55:00',4.32),('8784','2013-07-18','14:00:00',4.23),('8784','2013-07-18','14:05:00',4.18),('8784','2013-07-18','14:10:00',4.21),('8784','2013-07-18','14:15:00',4.21),('8784','2013-07-18','14:20:00',4.19),('8784','2013-07-18','14:25:00',4.1),('8784','2013-07-18','14:30:00',4.07),('8784','2013-07-18','14:35:00',4.06),('8784','2013-07-18','14:40:00',4.04),('8784','2013-07-18','14:45:00',4),('8784','2013-07-18','14:50:00',3.94),('8784','2013-07-18','14:55:00',3.91),('8784','2013-07-18','15:00:00',3.92),('8784','2013-07-18','15:05:00',3.91),('8784','2013-07-18','15:10:00',3.84),('8784','2013-07-18','15:15:00',3.8),('8784','2013-07-18','15:20:00',3.83),('8784','2013-07-18','15:25:00',3.78),('8784','2013-07-18','15:30:00',3.72),('8784','2013-07-18','15:35:00',3.7),('8784','2013-07-18','15:40:00',3.62),('8784','2013-07-18','15:45:00',3.59),('8784','2013-07-18','15:50:00',3.53),('8784','2013-07-18','15:55:00',3.48),('8784','2013-07-18','16:00:00',3.45),('8784','2013-07-18','16:05:00',3.38),('8784','2013-07-18','16:10:00',3.33),('8784','2013-07-18','16:15:00',3.24),('8784','2013-07-18','16:20:00',3.15),('8784','2013-07-18','16:25:00',3.14),('8784','2013-07-18','16:30:00',3.08),('8784','2013-07-18','16:35:00',3.02),('8784','2013-07-18','16:40:00',2.93),('8784','2013-07-18','16:45:00',2.89),('8784','2013-07-18','16:50:00',2.81),('8784','2013-07-18','16:55:00',2.72),('8784','2013-07-18','17:00:00',2.65),('8784','2013-07-18','17:05:00',2.58),('8784','2013-07-18','17:10:00',2.46),('8784','2013-07-18','17:15:00',2.43),('8784','2013-07-18','17:20:00',2.39),('8784','2013-07-18','17:25:00',2.29),('8784','2013-07-18','17:30:00',2.19),('8784','2013-07-18','17:35:00',2.09),('8784','2013-07-18','17:40:00',1.87),('8784','2013-07-18','17:45:00',1.92),('8784','2013-07-18','17:50:00',1.83),('8784','2013-07-18','17:55:00',1.72),('8784','2013-07-18','18:00:00',1.62),('8784','2013-07-18','18:05:00',1.4),('8784','2013-07-18','18:10:00',1.46),('8784','2013-07-18','18:15:00',1.37),('8784','2013-07-18','18:20:00',1.29),('8784','2013-07-18','18:25:00',1.21),('8784','2013-07-17','07:30:00',1.01),('8784','2013-07-17','07:35:00',1.08),('8784','2013-07-17','07:40:00',1.16),('8784','2013-07-17','07:45:00',1.27),('8784','2013-07-17','07:50:00',1.34),('8784','2013-07-17','07:55:00',1.41),('8784','2013-07-17','08:00:00',1.52),('8784','2013-07-17','08:05:00',1.63),('8784','2013-07-17','08:10:00',1.72),('8784','2013-07-17','08:15:00',1.81),('8784','2013-07-17','08:20:00',1.91),('8784','2013-07-17','08:25:00',1.98),('8784','2013-07-17','08:30:00',2.04),('8784','2013-07-17','08:35:00',2.16),('8784','2013-07-17','08:40:00',2.24),('8784','2013-07-17','08:45:00',2.33),('8784','2013-07-17','08:50:00',2.4),('8784','2013-07-17','08:55:00',2.47),('8784','2013-07-17','09:00:00',2.55),('8784','2013-07-17','09:05:00',2.63),('8784','2013-07-17','09:10:00',2.71),('8784','2013-07-17','09:15:00',2.79),('8784','2013-07-17','09:20:00',2.86),('8784','2013-07-17','09:25:00',2.93),('8784','2013-07-17','09:30:00',2.99),('8784','2013-07-17','09:35:00',3.03),('8784','2013-07-17','09:40:00',3.1),('8784','2013-07-17','09:45:00',3.19),('8784','2013-07-17','09:50:00',3.24),('8784','2013-07-17','09:55:00',3.28),('8784','2013-07-17','10:00:00',3.33),('8784','2013-07-17','10:05:00',3.39),('8784','2013-07-17','10:10:00',3.44),('8784','2013-07-17','10:15:00',3.46),('8784','2013-07-17','10:20:00',3.54),('8784','2013-07-17','10:25:00',3.57),('8784','2013-07-17','10:30:00',3.63),('8784','2013-07-17','10:35:00',3.7),('8784','2013-07-17','10:40:00',3.72),('8784','2013-07-17','10:45:00',3.76),('8784','2013-07-17','10:50:00',3.83),('8784','2013-07-17','10:55:00',3.84),('8784','2013-07-17','11:00:00',3.88),('8784','2013-07-17','11:05:00',3.95),('8784','2013-07-17','11:10:00',3.98),('8784','2013-07-17','11:15:00',4),('8784','2013-07-17','11:20:00',4.04),('8784','2013-07-17','11:25:00',4.06),('8784','2013-07-17','11:30:00',4.1),('8784','2013-07-17','11:35:00',4.11),('8784','2013-07-17','11:40:00',4.14),('8784','2013-07-17','11:45:00',4.16),('8784','2013-07-17','11:50:00',4.19),('8784','2013-07-17','11:55:00',4.21),('8784','2013-07-17','12:00:00',4.28),('8784','2013-07-17','12:05:00',4.21),('8784','2013-07-17','12:10:00',4.28),('8784','2013-07-17','12:15:00',4.31),('8784','2013-07-17','12:20:00',4.26),('8784','2013-07-17','12:25:00',4.26),('8784','2013-07-17','12:30:00',4.32),('8784','2013-07-17','12:35:00',4.3),('8784','2013-07-17','12:40:00',4.3),('8784','2013-07-17','12:45:00',4.3),('8784','2013-07-17','12:50:00',4.28),('8784','2013-07-17','12:55:00',4.29),('8784','2013-07-17','13:00:00',4.33),('8784','2013-07-17','13:05:00',4.33),('8784','2013-07-17','13:10:00',4.32),('8784','2013-07-17','13:15:00',4.34),('8784','2013-07-17','13:20:00',4.3),('8784','2013-07-17','13:25:00',4.23),('8784','2013-07-17','13:30:00',4.24),('8784','2013-07-17','13:35:00',4.24),('8784','2013-07-17','13:40:00',4.2),('8784','2013-07-17','13:45:00',4.22),('8784','2013-07-17','13:50:00',4.15),('8784','2013-07-17','13:55:00',4.15),('8784','2013-07-17','14:00:00',4.22),('8784','2013-07-17','14:05:00',4.25),('8784','2013-07-17','14:10:00',4.23),('8784','2013-07-17','14:15:00',4.22),('8784','2013-07-17','14:20:00',4.16),('8784','2013-07-17','14:25:00',4.14),('8784','2013-07-17','14:30:00',4.08),('8784','2013-07-17','14:35:00',4.04),('8784','2013-07-17','14:40:00',4.18),('8784','2013-07-17','14:45:00',4.11),('8784','2013-07-17','14:50:00',3.98),('8784','2013-07-17','14:55:00',3.93),('8784','2013-07-17','15:00:00',3.9),('8784','2013-07-17','15:05:00',3.91),('8784','2013-07-17','15:10:00',3.01),('8784','2013-07-17','15:15:00',3.94),('8784','2013-07-17','15:20:00',3.84),('8784','2013-07-17','15:25:00',3.82),('8784','2013-07-17','15:30:00',3.77),('8784','2013-07-17','15:35:00',3.75),('8784','2013-07-17','15:40:00',3.69),('8784','2013-07-17','15:45:00',3.57),('8784','2013-07-17','15:50:00',3.32),('8784','2013-07-17','15:55:00',3.32),('8784','2013-07-17','16:00:00',3.51),('8784','2013-07-17','16:05:00',3.44),('8784','2013-07-17','16:10:00',3.43),('8784','2013-07-17','16:15:00',3.36),('8784','2013-07-17','16:20:00',3.26),('8784','2013-07-17','16:25:00',3.13),('8784','2013-07-17','16:30:00',3.03),('8784','2013-07-17','16:35:00',3.01),('8784','2013-07-17','16:40:00',2.8),('8784','2013-07-17','16:45:00',2.92),('8784','2013-07-17','16:50:00',2.83),('8784','2013-07-17','16:55:00',2.78),('8784','2013-07-17','17:00:00',2.77),('8784','2013-07-17','17:05:00',2.68),('8784','2013-07-17','17:10:00',2.67),('8784','2013-07-17','17:15:00',2.56),('8784','2013-07-17','17:20:00',2.47),('8784','2013-07-17','17:25:00',2.36),('8784','2013-07-17','17:30:00',2.27),('8784','2013-07-17','17:35:00',2.21),('8784','2013-07-17','17:40:00',2.1),('8784','2013-07-17','17:45:00',2.03),('8784','2013-07-17','17:50:00',1.98),('8784','2013-07-17','17:55:00',1.89),('8784','2013-07-17','18:00:00',1.79),('8784','2013-07-17','18:05:00',1.72),('8784','2013-07-17','18:10:00',1.65),('8784','2013-07-17','18:15:00',1.57),('8784','2013-07-17','18:20:00',1.47),('8784','2013-07-17','18:25:00',1.4),('8784','2013-07-17','18:30:00',1.32),('8784','2013-07-17','18:35:00',1.23),('8784','2013-07-17','18:40:00',1.16),('8784','2013-07-17','18:45:00',1.07),('8784','2013-07-17','18:50:00',1),('8784','2013-07-16','07:30:00',1.05),('8784','2013-07-16','07:35:00',1.09),('8784','2013-07-16','07:40:00',1.18),('8784','2013-07-16','07:45:00',1.27),('8784','2013-07-16','07:50:00',1.37),('8784','2013-07-16','07:55:00',1.4),('8784','2013-07-16','08:00:00',1.48),('8784','2013-07-16','08:05:00',1.54),('8784','2013-07-16','08:10:00',1.63),('8784','2013-07-16','08:15:00',1.71),('8784','2013-07-16','08:20:00',1.81),('8784','2013-07-16','08:25:00',1.9),('8784','2013-07-16','08:30:00',1.98),('8784','2013-07-16','08:35:00',2.07),('8784','2013-07-16','08:40:00',2.14),('8784','2013-07-16','08:45:00',2.2),('8784','2013-07-16','08:50:00',2.28),('8784','2013-07-16','08:55:00',2.38),('8784','2013-07-16','09:00:00',2.46),('8784','2013-07-16','09:05:00',2.52),('8784','2013-07-16','09:10:00',2.6),('8784','2013-07-16','09:15:00',2.61),('8784','2013-07-16','09:20:00',2.64),('8784','2013-07-16','09:25:00',2.74),('8784','2013-07-16','09:30:00',2.82),('8784','2013-07-16','09:35:00',2.87),('8784','2013-07-16','09:40:00',2.98),('8784','2013-07-16','09:45:00',3.03),('8784','2013-07-16','09:50:00',3.11),('8784','2013-07-16','09:55:00',3.19),('8784','2013-07-16','10:00:00',3.27),('8784','2013-07-16','10:05:00',3.31),('8784','2013-07-16','10:10:00',3.39),('8784','2013-07-16','10:15:00',3.43),('8784','2013-07-16','10:20:00',3.49),('8784','2013-07-16','10:25:00',3.55),('8784','2013-07-16','10:30:00',3.61),('8784','2013-07-16','10:35:00',3.64),('8784','2013-07-16','10:40:00',3.67),('8784','2013-07-16','10:45:00',3.64),('8784','2013-07-16','10:50:00',3.76),('8784','2013-07-16','10:55:00',3.79),('8784','2013-07-16','11:00:00',3.84),('8784','2013-07-16','11:05:00',3.89),('8784','2013-07-16','11:10:00',3.92),('8784','2013-07-16','11:15:00',3.93),('8784','2013-07-16','11:20:00',3.96),('8784','2013-07-16','11:25:00',4),('8784','2013-07-16','11:30:00',4.04),('8784','2013-07-16','11:35:00',4.05),('8784','2013-07-16','11:40:00',4.05),('8784','2013-07-16','11:45:00',4.09),('8784','2013-07-16','11:50:00',4.15),('8784','2013-07-16','11:55:00',4.21),('8784','2013-07-16','12:00:00',4.23),('8784','2013-07-16','12:05:00',4.24),('8784','2013-07-16','12:10:00',4.24),('8784','2013-07-16','12:15:00',4.27),('8784','2013-07-16','12:20:00',4.28),('8784','2013-07-16','12:25:00',4.26),('8784','2013-07-16','12:30:00',4.28),('8784','2013-07-16','12:35:00',4.2),('8784','2013-07-16','12:40:00',4.25),('8784','2013-07-16','12:45:00',4.28),('8784','2013-07-16','12:50:00',4.22),('8784','2013-07-16','12:55:00',4.24),('8784','2013-07-16','13:00:00',4.25),('8784','2013-07-16','13:05:00',4.28),('8784','2013-07-16','13:10:00',4.24),('8784','2013-07-16','13:15:00',4.3),('8784','2013-07-16','13:20:00',4.3),('8784','2013-07-16','13:25:00',4.3),('8784','2013-07-16','13:30:00',4.3),('8784','2013-07-16','13:35:00',4.25),('8784','2013-07-16','13:40:00',4.32),('8784','2013-07-16','13:45:00',4.39),('8784','2013-07-16','13:50:00',4.48),('8784','2013-07-16','13:55:00',3.98),('8784','2013-07-16','14:00:00',4.24),('8784','2013-07-16','14:05:00',4.16),('8784','2013-07-16','14:10:00',2.33),('8784','2013-07-16','14:15:00',4.25),('8784','2013-07-16','14:20:00',1.52),('8784','2013-07-16','14:25:00',3.44),('8784','2013-07-16','14:30:00',4.25),('8784','2013-07-16','14:35:00',4.17),('8784','2013-07-16','14:40:00',4.12),('8784','2013-07-16','14:45:00',4.06),('8784','2013-07-16','14:50:00',4.04),('8784','2013-07-16','14:55:00',4.03),('8784','2013-07-16','15:00:00',3.98),('8784','2013-07-16','15:05:00',3.93),('8784','2013-07-16','15:10:00',3.88),('8784','2013-07-16','15:15:00',3.82),('8784','2013-07-16','15:20:00',3.79),('8784','2013-07-16','15:25:00',3.8),('8784','2013-07-16','15:30:00',3.78),('8784','2013-07-16','15:35:00',3.31),('8784','2013-07-16','15:40:00',3.67),('8784','2013-07-16','15:45:00',2.13),('8784','2013-07-16','15:50:00',3.57),('8784','2013-07-16','15:55:00',3.55),('8784','2013-07-16','16:00:00',3.46),('8784','2013-07-16','16:05:00',1.65),('8784','2013-07-16','16:10:00',3.01),('8784','2013-07-16','16:15:00',2.49),('8784','2013-07-16','16:20:00',1.71),('8784','2013-07-16','16:25:00',1.56),('8784','2013-07-16','16:30:00',1.26),('8784','2013-07-16','16:45:00',1.32),('8784','2013-07-16','16:50:00',1.68),('8784','2013-07-16','16:55:00',1.84),('8784','2013-07-16','17:00:00',2.81),('8784','2013-07-16','17:05:00',3.1),('8784','2013-07-16','17:10:00',2.78),('8784','2013-07-16','17:15:00',2.66),('8784','2013-07-16','17:20:00',1.31),('8784','2013-07-16','17:25:00',2.03),('8784','2013-07-16','17:30:00',1.66),('8784','2013-07-16','17:35:00',2.11),('8784','2013-07-16','17:40:00',2.27),('8784','2013-07-16','17:45:00',2.32),('8784','2013-07-16','17:50:00',2.04),('8784','2013-07-16','17:55:00',1.22),('8784','2013-07-16','18:05:00',1.49),('8784','2013-07-16','18:10:00',1.29),('8784','2013-07-16','18:15:00',1.56),('8784','2013-07-16','18:20:00',1.43),('8784','2013-07-16','18:25:00',1.4),('8784','2013-07-16','18:30:00',1.32),('8784','2013-07-16','18:35:00',1.23),('8784','2013-07-16','18:40:00',1.11),('8784','2013-07-16','18:45:00',1.02),('8784','2013-07-15','07:25:00',1.01),('8784','2013-07-15','07:30:00',1.08),('8784','2013-07-15','07:35:00',1.16),('8784','2013-07-15','07:40:00',1.24),('8784','2013-07-15','07:45:00',1.33),('8784','2013-07-15','07:50:00',1.41),('8784','2013-07-15','07:55:00',1.49),('8784','2013-07-15','08:00:00',1.58),('8784','2013-07-15','08:05:00',1.66),('8784','2013-07-15','08:10:00',1.75),('8784','2013-07-15','08:15:00',1.83),('8784','2013-07-15','08:20:00',1.92),('8784','2013-07-15','08:25:00',2),('8784','2013-07-15','08:30:00',2.08),('8784','2013-07-15','08:35:00',2.15),('8784','2013-07-15','08:40:00',2.16),('8784','2013-07-15','08:45:00',2.27),('8784','2013-07-15','08:50:00',2.4),('8784','2013-07-15','08:55:00',2.47),('8784','2013-07-15','09:00:00',2.55),('8784','2013-07-15','09:05:00',2.63),('8784','2013-07-15','09:10:00',2.7),('8784','2013-07-15','09:15:00',2.76),('8784','2013-07-15','09:20:00',2.85),('8784','2013-07-15','09:25:00',2.9),('8784','2013-07-15','09:30:00',2.97),('8784','2013-07-15','09:35:00',3.03),('8784','2013-07-15','09:40:00',3.09),('8784','2013-07-15','09:45:00',3.16),('8784','2013-07-15','09:50:00',3.2),('8784','2013-07-15','09:55:00',3.26),('8784','2013-07-15','10:00:00',3.3),('8784','2013-07-15','10:05:00',3.36),('8784','2013-07-15','10:10:00',3.41),('8784','2013-07-15','10:15:00',3.47),('8784','2013-07-15','10:20:00',3.51),('8784','2013-07-15','10:25:00',3.55),('8784','2013-07-15','10:30:00',3.57),('8784','2013-07-15','10:35:00',3.62),('8784','2013-07-15','10:40:00',3.65),('8784','2013-07-15','10:45:00',3.67),('8784','2013-07-15','10:50:00',3.71),('8784','2013-07-15','10:55:00',3.79),('8784','2013-07-15','11:00:00',3.83),('8784','2013-07-15','11:05:00',3.87),('8784','2013-07-15','11:10:00',3.89),('8784','2013-07-15','11:15:00',3.9),('8784','2013-07-15','11:20:00',3.92),('8784','2013-07-15','11:25:00',3.97),('8784','2013-07-15','11:30:00',3.99),('8784','2013-07-15','11:35:00',4.04),('8784','2013-07-15','11:40:00',4.06),('8784','2013-07-15','11:45:00',4.07),('8784','2013-07-15','11:50:00',4.1),('8784','2013-07-15','11:55:00',4.12),('8784','2013-07-15','12:00:00',4.21),('8784','2013-07-15','12:05:00',4.19),('8784','2013-07-15','12:10:00',4.18),('8784','2013-07-15','12:15:00',4.2),('8784','2013-07-15','12:20:00',4.3),('8784','2013-07-15','12:25:00',4.28),('8784','2013-07-15','12:30:00',4.27),('8784','2013-07-15','12:35:00',4.28),('8784','2013-07-15','12:40:00',4.25),('8784','2013-07-15','12:45:00',4.22),('8784','2013-07-15','12:50:00',4.19),('8784','2013-07-15','12:55:00',4.18),('8784','2013-07-15','13:00:00',4.33),('8784','2013-07-15','13:05:00',3.24),('8784','2013-07-15','13:10:00',2.44),('8784','2013-07-15','13:15:00',4.44),('8784','2013-07-15','13:20:00',4.36),('8784','2013-07-15','13:25:00',4.49),('8784','2013-07-15','13:30:00',4.62),('8784','2013-07-15','13:35:00',4.64),('8784','2013-07-15','13:40:00',1.96),('8784','2013-07-15','13:45:00',2.83),('8784','2013-07-15','13:50:00',1.74),('8784','2013-07-15','13:55:00',3.75),('8784','2013-07-15','14:00:00',4.61),('8784','2013-07-15','14:05:00',4.6),('8784','2013-07-15','14:10:00',2.77),('8784','2013-07-15','14:20:00',1.69),('8784','2013-07-15','14:25:00',4.58),('8784','2013-07-15','14:30:00',4.39),('8784','2013-07-15','14:35:00',4.33),('8784','2013-07-15','14:40:00',4.25),('8784','2013-07-15','14:45:00',4.24),('8784','2013-07-15','14:50:00',4.16),('8784','2013-07-15','14:55:00',4.18),('8784','2013-07-15','15:00:00',4.15),('8784','2013-07-15','15:05:00',4.06),('8784','2013-07-15','15:10:00',4),('8784','2013-07-15','15:15:00',3.92),('8784','2013-07-15','15:20:00',2.8),('8784','2013-07-15','15:30:00',3.92),('8784','2013-07-15','15:35:00',3.93),('8784','2013-07-15','15:40:00',3.89),('8784','2013-07-15','15:45:00',3.69),('8784','2013-07-15','15:50:00',3.71),('8784','2013-07-15','15:55:00',3.63),('8784','2013-07-15','16:00:00',3.49),('8784','2013-07-15','16:05:00',3.46),('8784','2013-07-15','16:10:00',3.38),('8784','2013-07-15','16:15:00',3.29),('8784','2013-07-15','16:20:00',3.18),('8784','2013-07-15','16:25:00',3.11),('8784','2013-07-15','16:30:00',3.09),('8784','2013-07-15','16:35:00',3.02),('8784','2013-07-15','16:40:00',2.99),('8784','2013-07-15','16:45:00',2.91),('8784','2013-07-15','16:50:00',2.85),('8784','2013-07-15','16:55:00',2.8),('8784','2013-07-15','17:00:00',2.72),('8784','2013-07-15','17:05:00',2.66),('8784','2013-07-15','17:10:00',2.57),('8784','2013-07-15','17:15:00',2.51),('8784','2013-07-15','17:20:00',2.43),('8784','2013-07-15','17:25:00',2.37),('8784','2013-07-15','17:30:00',2.3),('8784','2013-07-15','17:35:00',2.19),('8784','2013-07-15','17:40:00',2.11),('8784','2013-07-15','17:45:00',2.03),('8784','2013-07-15','17:50:00',1.93),('8784','2013-07-15','17:55:00',1.85),('8784','2013-07-15','18:00:00',1.77),('8784','2013-07-15','18:05:00',1.69),('8784','2013-07-15','18:10:00',1.62),('8784','2013-07-15','18:15:00',1.53),('8784','2013-07-15','18:20:00',1.44),('8784','2013-07-15','18:25:00',1.37),('8784','2013-07-15','18:30:00',1.29),('8784','2013-07-15','18:35:00',1.19),('8784','2013-07-15','18:40:00',1.13),('8784','2013-07-15','18:45:00',1.06),('8784','2013-07-14','07:50:00',1.41),('8784','2013-07-14','07:55:00',1.69),('8784','2013-07-14','08:00:00',1.67),('8784','2013-07-14','08:05:00',1.5),('8784','2013-07-14','08:10:00',2.03),('8784','2013-07-14','08:15:00',1.47),('8784','2013-07-14','08:20:00',2.3),('8784','2013-07-14','08:25:00',1.6),('8784','2013-07-14','08:30:00',1.09),('8784','2013-07-14','08:35:00',1.32),('8784','2013-07-14','08:40:00',1.17),('8784','2013-07-14','08:45:00',1.03),('8784','2013-07-14','08:50:00',1.12),('8784','2013-07-14','08:55:00',1.13),('8784','2013-07-14','09:00:00',1.14),('8784','2013-07-14','09:05:00',1.23),('8784','2013-07-14','09:10:00',1.65),('8784','2013-07-14','09:15:00',1.49),('8784','2013-07-14','09:20:00',1.46),('8784','2013-07-14','09:25:00',2.38),('8784','2013-07-14','09:30:00',2.45),('8784','2013-07-14','09:35:00',2.2),('8784','2013-07-14','09:40:00',1.82),('8784','2013-07-14','09:45:00',1.79),('8784','2013-07-14','09:50:00',1.72),('8784','2013-07-14','09:55:00',1.74),('8784','2013-07-14','10:00:00',1.71),('8784','2013-07-14','10:05:00',1.92),('8784','2013-07-14','10:10:00',1.73),('8784','2013-07-14','10:15:00',1.7),('8784','2013-07-14','10:20:00',2.42),('8784','2013-07-14','10:25:00',3.17),('8784','2013-07-14','10:30:00',3.08),('8784','2013-07-14','10:35:00',3.73),('8784','2013-07-14','10:40:00',3.34),('8784','2013-07-14','10:45:00',3.04),('8784','2013-07-14','10:50:00',3.98),('8784','2013-07-14','10:55:00',3.58),('8784','2013-07-14','11:00:00',3.08),('8784','2013-07-14','11:05:00',1.22),('8784','2013-07-14','11:10:00',1.47),('8784','2013-07-14','11:15:00',1.91),('8784','2013-07-14','11:20:00',2.69),('8784','2013-07-14','11:25:00',1.49),('8784','2013-07-14','11:30:00',1.47),('8784','2013-07-14','11:35:00',2.3),('8784','2013-07-14','11:40:00',4.06),('8784','2013-07-14','11:45:00',1.96),('8784','2013-07-14','11:50:00',1.83),('8784','2013-07-14','11:55:00',3.8),('8784','2013-07-14','12:00:00',3.34),('8784','2013-07-14','12:05:00',3.97),('8784','2013-07-14','12:10:00',2.9),('8784','2013-07-14','12:15:00',3.23),('8784','2013-07-14','12:20:00',2.72),('8784','2013-07-14','12:25:00',4.11),('8784','2013-07-14','12:30:00',4.76),('8784','2013-07-14','12:35:00',4.79),('8784','2013-07-14','12:40:00',4.82),('8784','2013-07-14','12:45:00',4.53),('8784','2013-07-14','12:50:00',4.62),('8784','2013-07-14','12:55:00',4.6),('8784','2013-07-14','13:00:00',2.42),('8784','2013-07-14','13:05:00',4.89),('8784','2013-07-14','13:10:00',4.74),('8784','2013-07-14','13:15:00',4.58),('8784','2013-07-14','13:20:00',4.54),('8784','2013-07-14','13:25:00',4.4),('8784','2013-07-14','13:30:00',4.48),('8784','2013-07-14','13:35:00',4.4),('8784','2013-07-14','13:40:00',4.45),('8784','2013-07-14','13:45:00',4.45),('8784','2013-07-14','13:50:00',4.5),('8784','2013-07-14','13:55:00',4.46),('8784','2013-07-14','14:00:00',4.49),('8784','2013-07-14','14:05:00',4.49),('8784','2013-07-14','14:10:00',4.49),('8784','2013-07-14','14:15:00',4.38),('8784','2013-07-14','14:20:00',4.4),('8784','2013-07-14','14:25:00',4.37),('8784','2013-07-14','14:30:00',4.33),('8784','2013-07-14','14:35:00',4.25),('8784','2013-07-14','14:40:00',4.19),('8784','2013-07-14','14:45:00',4.13),('8784','2013-07-14','14:50:00',4.06),('8784','2013-07-14','14:55:00',4.02),('8784','2013-07-14','15:00:00',4.02),('8784','2013-07-14','15:05:00',3.99),('8784','2013-07-14','15:10:00',3.94),('8784','2013-07-14','15:15:00',3.94),('8784','2013-07-14','15:20:00',3.87),('8784','2013-07-14','15:25:00',3.81),('8784','2013-07-14','15:30:00',3.77),('8784','2013-07-14','15:35:00',3.77),('8784','2013-07-14','15:40:00',3.7),('8784','2013-07-14','15:45:00',3.63),('8784','2013-07-14','15:50:00',3.57),('8784','2013-07-14','15:55:00',3.58),('8784','2013-07-14','16:00:00',3.48),('8784','2013-07-14','16:05:00',3.29),('8784','2013-07-14','16:10:00',3.43),('8784','2013-07-14','16:15:00',3.34),('8784','2013-07-14','16:20:00',3.35),('8784','2013-07-14','16:25:00',2.37),('8784','2013-07-14','16:30:00',2.94),('8784','2013-07-14','16:35:00',3.28),('8784','2013-07-14','16:40:00',3.08),('8784','2013-07-14','16:45:00',2.74),('8784','2013-07-14','16:50:00',2.32),('8784','2013-07-14','16:55:00',2.1),('8784','2013-07-14','17:00:00',2.99),('8784','2013-07-14','17:05:00',1.64),('8784','2013-07-14','17:10:00',2.42),('8784','2013-07-14','17:15:00',2.43),('8784','2013-07-14','17:20:00',1.47),('8784','2013-07-14','17:25:00',2.16),('8784','2013-07-14','17:30:00',2.74),('8784','2013-07-14','17:35:00',2.36),('8784','2013-07-14','17:40:00',1.66),('8784','2013-07-14','17:45:00',1.9),('8784','2013-07-14','17:50:00',1.75),('8784','2013-07-14','17:55:00',1.96),('8784','2013-07-14','18:00:00',1.43),('8784','2013-07-14','18:05:00',1.58),('8784','2013-07-13','07:40:00',1.11),('8784','2013-07-13','07:45:00',1.17),('8784','2013-07-13','07:50:00',1.31),('8784','2013-07-13','07:55:00',1.38),('8784','2013-07-13','08:00:00',1.44),('8784','2013-07-13','08:05:00',1.51),('8784','2013-07-13','08:10:00',1.58),('8784','2013-07-13','08:15:00',1.6),('8784','2013-07-13','08:20:00',1.68),('8784','2013-07-13','08:25:00',1.85),('8784','2013-07-13','08:30:00',1.95),('8784','2013-07-13','08:35:00',2.02),('8784','2013-07-13','08:40:00',2.13),('8784','2013-07-13','08:45:00',2.17),('8784','2013-07-13','08:50:00',2.28),('8784','2013-07-13','08:55:00',2.34),('8784','2013-07-13','09:00:00',2.4),('8784','2013-07-13','09:05:00',2.5),('8784','2013-07-13','09:10:00',2.51),('8784','2013-07-13','09:15:00',2.58),('8784','2013-07-13','09:20:00',2.63),('8784','2013-07-13','09:25:00',2.78),('8784','2013-07-13','09:30:00',2.84),('8784','2013-07-13','09:35:00',2.88),('8784','2013-07-13','09:40:00',2.96),('8784','2013-07-13','09:45:00',3.03),('8784','2013-07-13','09:50:00',3.09),('8784','2013-07-13','09:55:00',3.16),('8784','2013-07-13','10:00:00',3.17),('8784','2013-07-13','10:05:00',3.24),('8784','2013-07-13','10:10:00',3.3),('8784','2013-07-13','10:15:00',3.39),('8784','2013-07-13','10:20:00',3.48),('8784','2013-07-13','10:25:00',2.91),('8784','2013-07-13','10:30:00',2.87),('8784','2013-07-13','10:35:00',3.45),('8784','2013-07-13','10:40:00',3.69),('8784','2013-07-13','10:45:00',3.66),('8784','2013-07-13','10:50:00',3.57),('8784','2013-07-13','10:55:00',3.9),('8784','2013-07-13','11:00:00',4.04),('8784','2013-07-13','11:05:00',3.6),('8784','2013-07-13','11:10:00',3.62),('8784','2013-07-13','11:15:00',3.75),('8784','2013-07-13','11:20:00',2.74),('8784','2013-07-13','11:25:00',2.77),('8784','2013-07-13','11:30:00',4.36),('8784','2013-07-13','11:35:00',4.38),('8784','2013-07-13','11:40:00',2.49),('8784','2013-07-13','11:45:00',1.04),('8784','2013-07-13','11:50:00',3.45),('8784','2013-07-13','11:55:00',4.07),('8784','2013-07-13','12:00:00',1.9),('8784','2013-07-13','12:05:00',4.59),('8784','2013-07-13','12:10:00',4.51),('8784','2013-07-13','12:15:00',4.47),('8784','2013-07-13','12:20:00',4.43),('8784','2013-07-13','12:25:00',4.42),('8784','2013-07-13','12:30:00',3.77),('8784','2013-07-13','12:35:00',4.15),('8784','2013-07-13','12:40:00',4.1),('8784','2013-07-13','12:45:00',3.67),('8784','2013-07-13','12:50:00',2.13),('8784','2013-07-13','12:55:00',3.64),('8784','2013-07-13','13:00:00',4.63),('8784','2013-07-13','13:05:00',4.59),('8784','2013-07-13','13:10:00',4),('8784','2013-07-13','13:15:00',4.53),('8784','2013-07-13','13:20:00',4.46),('8784','2013-07-13','13:25:00',4.38),('8784','2013-07-13','13:30:00',4.37),('8784','2013-07-13','13:35:00',4.42),('8784','2013-07-13','13:40:00',4.4),('8784','2013-07-13','13:45:00',4.4),('8784','2013-07-13','13:50:00',4.38),('8784','2013-07-13','13:55:00',4.34),('8784','2013-07-13','14:00:00',4.35),('8784','2013-07-13','14:05:00',4.34),('8784','2013-07-13','14:10:00',4.32),('8784','2013-07-13','14:15:00',4.3),('8784','2013-07-13','14:20:00',4.28),('8784','2013-07-13','14:25:00',4.26),('8784','2013-07-13','14:30:00',4.24),('8784','2013-07-13','14:35:00',4.23),('8784','2013-07-13','14:40:00',4.19),('8784','2013-07-13','14:45:00',4.2),('8784','2013-07-13','14:50:00',4.12),('8784','2013-07-13','14:55:00',4.13),('8784','2013-07-13','15:00:00',4.12),('8784','2013-07-13','15:05:00',4.13),('8784','2013-07-13','15:10:00',4.08),('8784','2013-07-13','15:15:00',4.06),('8784','2013-07-13','15:20:00',3.84),('8784','2013-07-13','15:25:00',4),('8784','2013-07-13','15:30:00',3.87),('8784','2013-07-13','15:35:00',3.91),('8784','2013-07-13','15:40:00',3.84),('8784','2013-07-13','15:45:00',3.77),('8784','2013-07-13','15:50:00',3.71),('8784','2013-07-13','15:55:00',3.67),('8784','2013-07-13','16:00:00',3.61),('8784','2013-07-13','16:05:00',3.56),('8784','2013-07-13','16:10:00',3.5),('8784','2013-07-13','16:15:00',3.44),('8784','2013-07-13','16:20:00',3.39),('8784','2013-07-13','16:25:00',3.37),('8784','2013-07-13','16:30:00',3.28),('8784','2013-07-13','16:35:00',3.19),('8784','2013-07-13','16:40:00',3.16),('8784','2013-07-13','16:45:00',3.07),('8784','2013-07-13','16:50:00',2.99),('8784','2013-07-13','16:55:00',2.93),('8784','2013-07-13','17:00:00',2.83),('8784','2013-07-13','17:05:00',2.72),('8784','2013-07-13','17:10:00',2.69),('8784','2013-07-13','17:15:00',2.61),('8784','2013-07-13','17:20:00',2.46),('8784','2013-07-13','17:25:00',2.5),('8784','2013-07-13','17:30:00',2.34),('8784','2013-07-13','17:35:00',2.25),('8784','2013-07-13','17:40:00',2.21),('8784','2013-07-13','17:45:00',2.15),('8784','2013-07-13','17:50:00',2.02),('8784','2013-07-13','17:55:00',2.03),('8784','2013-07-13','18:00:00',1.85),('8784','2013-07-13','18:05:00',1.72),('8784','2013-07-13','18:10:00',1.72),('8784','2013-07-13','18:15:00',1.65),('8784','2013-07-13','18:20:00',1.56),('8784','2013-07-13','18:25:00',1.5),('8784','2013-07-13','18:30:00',1.4),('8784','2013-07-13','18:35:00',1.3),('8784','2013-07-13','18:55:00',1.08),('8784','2013-07-12','08:10:00',1.47),('8784','2013-07-12','08:15:00',1.56),('8784','2013-07-12','08:20:00',1.35),('8784','2013-07-12','08:40:00',1.14),('8784','2013-07-12','08:45:00',1.31),('8784','2013-07-12','08:50:00',1.02),('8784','2013-07-12','09:05:00',1.02),('8784','2013-07-12','09:10:00',1.5),('8784','2013-07-12','09:15:00',1.84),('8784','2013-07-12','09:20:00',2.79),('8784','2013-07-12','09:25:00',2.61),('8784','2013-07-12','09:30:00',1.68),('8784','2013-07-12','09:35:00',2.49),('8784','2013-07-12','09:40:00',2.42),('8784','2013-07-12','09:45:00',2.94),('8784','2013-07-12','09:50:00',3.05),('8784','2013-07-12','09:55:00',3.21),('8784','2013-07-12','10:00:00',2.92),('8784','2013-07-12','10:05:00',3.28),('8784','2013-07-12','10:10:00',3.46),('8784','2013-07-12','10:15:00',3.38),('8784','2013-07-12','10:20:00',3.31),('8784','2013-07-12','10:25:00',2.53),('8784','2013-07-12','10:30:00',1.25),('8784','2013-07-12','10:40:00',1.05),('8784','2013-07-12','10:45:00',1.33),('8784','2013-07-12','10:50:00',2.65),('8784','2013-07-12','10:55:00',4.38),('8784','2013-07-12','11:00:00',1.74),('8784','2013-07-12','11:05:00',1.49),('8784','2013-07-12','11:10:00',1.97),('8784','2013-07-12','11:15:00',3.38),('8784','2013-07-12','11:20:00',4.36),('8784','2013-07-12','11:25:00',3.57),('8784','2013-07-12','11:30:00',3.75),('8784','2013-07-12','11:35:00',3.2),('8784','2013-07-12','11:40:00',4.48),('8784','2013-07-12','11:45:00',2.48),('8784','2013-07-12','11:50:00',3.22),('8784','2013-07-12','11:55:00',4.43),('8784','2013-07-12','12:00:00',4.52),('8784','2013-07-12','12:05:00',2.46),('8784','2013-07-12','12:10:00',3.51),('8784','2013-07-12','12:15:00',4.62),('8784','2013-07-12','12:20:00',4.16),('8784','2013-07-12','12:25:00',4.58),('8784','2013-07-12','12:30:00',4.83),('8784','2013-07-12','12:35:00',4.01),('8784','2013-07-12','12:40:00',3.97),('8784','2013-07-12','12:45:00',4.77),('8784','2013-07-12','12:50:00',2.73),('8784','2013-07-12','12:55:00',3.69),('8784','2013-07-12','13:00:00',4.55),('8784','2013-07-12','13:05:00',4.32),('8784','2013-07-12','13:10:00',4.55),('8784','2013-07-12','13:15:00',4.46),('8784','2013-07-12','13:20:00',3.88),('8784','2013-07-12','13:25:00',4.49),('8784','2013-07-12','13:30:00',4.48),('8784','2013-07-12','13:35:00',4.46),('8784','2013-07-12','13:40:00',4.5),('8784','2013-07-12','13:45:00',3.1),('8784','2013-07-12','13:50:00',4.55),('8784','2013-07-12','13:55:00',4.42),('8784','2013-07-12','14:00:00',4.53),('8784','2013-07-12','14:05:00',3.69),('8784','2013-07-12','14:10:00',3.13),('8784','2013-07-12','14:15:00',4.74),('8784','2013-07-12','14:20:00',4.68),('8784','2013-07-12','14:25:00',4.51),('8784','2013-07-12','14:30:00',3.7),('8784','2013-07-12','14:35:00',4.2),('8784','2013-07-12','14:40:00',4.19),('8784','2013-07-12','14:45:00',4.15),('8784','2013-07-12','14:50:00',4.1),('8784','2013-07-12','14:55:00',4.07),('8784','2013-07-12','15:00:00',3.98),('8784','2013-07-12','15:05:00',4.02),('8784','2013-07-12','15:10:00',4),('8784','2013-07-12','15:15:00',3.92),('8784','2013-07-12','15:20:00',3.91),('8784','2013-07-12','15:25:00',3.89),('8784','2013-07-12','15:30:00',3.82),('8784','2013-07-12','15:35:00',3.76),('8784','2013-07-12','15:40:00',3.7),('8784','2013-07-12','15:45:00',3.71),('8784','2013-07-12','15:50:00',3.57),('8784','2013-07-12','15:55:00',3.57),('8784','2013-07-12','16:00:00',3.51),('8784','2013-07-12','16:05:00',3.43),('8784','2013-07-12','16:10:00',3.4),('8784','2013-07-12','16:15:00',3.34),('8784','2013-07-12','16:20:00',3.26),('8784','2013-07-12','16:25:00',3.22),('8784','2013-07-12','16:30:00',3.15),('8784','2013-07-12','16:35:00',3.12),('8784','2013-07-12','16:40:00',3.07),('8784','2013-07-12','16:45:00',2.97),('8784','2013-07-12','16:50:00',2.9),('8784','2013-07-12','16:55:00',2.81),('8784','2013-07-12','17:00:00',2.75),('8784','2013-07-12','17:05:00',2.68),('8784','2013-07-12','17:10:00',2.62),('8784','2013-07-12','17:15:00',2.56),('8784','2013-07-12','17:20:00',2.44),('8784','2013-07-12','17:25:00',2.32),('8784','2013-07-12','17:30:00',2.26),('8784','2013-07-12','17:35:00',2.24),('8784','2013-07-12','17:40:00',2.15),('8784','2013-07-12','17:45:00',2.06),('8784','2013-07-12','17:50:00',2),('8784','2013-07-12','17:55:00',1.89),('8784','2013-07-12','18:00:00',1.82),('8784','2013-07-12','18:05:00',1.72),('8784','2013-07-12','18:10:00',1.62),('8784','2013-07-12','18:15:00',1.59),('8784','2013-07-12','18:20:00',1.43),('8784','2013-07-12','18:25:00',1.44),('8784','2013-07-12','18:30:00',1.35),('8784','2013-07-12','18:35:00',1.27),('8784','2013-07-12','18:40:00',1.18),('8784','2013-07-12','18:45:00',1.1),('8784','2013-07-12','18:50:00',1.02),('8784','2013-07-11','07:30:00',1.01),('8784','2013-07-11','07:35:00',1.09),('8784','2013-07-11','07:40:00',1.16),('8784','2013-07-11','07:45:00',1.22),('8784','2013-07-11','07:50:00',1.32),('8784','2013-07-11','07:55:00',1.38),('8784','2013-07-11','08:00:00',1.48),('8784','2013-07-11','08:05:00',1.53),('8784','2013-07-11','08:10:00',1.58),('8784','2013-07-11','08:15:00',1.63),('8784','2013-07-11','08:20:00',1.78),('8784','2013-07-11','08:25:00',1.89),('8784','2013-07-11','08:30:00',1.95),('8784','2013-07-11','08:35:00',1.99),('8784','2013-07-11','08:40:00',2.1),('8784','2013-07-11','08:45:00',2.11),('8784','2013-07-11','08:50:00',2.23),('8784','2013-07-11','08:55:00',2.32),('8784','2013-07-11','09:00:00',2.4),('8784','2013-07-11','09:05:00',2.31),('8784','2013-07-11','09:10:00',2.58),('8784','2013-07-11','09:15:00',2.64),('8784','2013-07-11','09:20:00',2.65),('8784','2013-07-11','09:25:00',2.66),('8784','2013-07-11','09:30:00',2.76),('8784','2013-07-11','09:35:00',2.92),('8784','2013-07-11','09:40:00',2.9),('8784','2013-07-11','09:45:00',3.18),('8784','2013-07-11','09:50:00',3.02),('8784','2013-07-11','09:55:00',1.99),('8784','2013-07-11','10:00:00',1.74),('8784','2013-07-11','10:05:00',2.52),('8784','2013-07-11','10:10:00',3.48),('8784','2013-07-11','10:15:00',3.28),('8784','2013-07-11','10:20:00',3.61),('8784','2013-07-11','10:25:00',3.4),('8784','2013-07-11','10:30:00',2.99),('8784','2013-07-11','10:35:00',2.64),('8784','2013-07-11','10:40:00',2.58),('8784','2013-07-11','10:45:00',3.83),('8784','2013-07-11','10:50:00',3.96),('8784','2013-07-11','10:55:00',4.06),('8784','2013-07-11','11:00:00',4.02),('8784','2013-07-11','11:05:00',3.52),('8784','2013-07-11','11:10:00',4.23),('8784','2013-07-11','11:15:00',4.2),('8784','2013-07-11','11:20:00',4.38),('8784','2013-07-11','11:25:00',2.69),('8784','2013-07-11','11:30:00',3.59),('8784','2013-07-11','11:35:00',2.08),('8784','2013-07-11','11:40:00',3.63),('8784','2013-07-11','11:45:00',1.82),('8784','2013-07-11','11:50:00',3.58),('8784','2013-07-11','11:55:00',4.81),('8784','2013-07-11','12:00:00',3.33),('8784','2013-07-11','12:05:00',1.31),('8784','2013-07-11','12:10:00',1.64),('8784','2013-07-11','12:15:00',3.59),('8784','2013-07-11','12:20:00',4.71),('8784','2013-07-11','12:25:00',4.78),('8784','2013-07-11','12:30:00',4.79),('8784','2013-07-11','12:35:00',4.67),('8784','2013-07-11','12:40:00',4.7),('8784','2013-07-11','12:45:00',4.52),('8784','2013-07-11','12:50:00',4.6),('8784','2013-07-11','12:55:00',2.46),('8784','2013-07-11','13:00:00',4.65),('8784','2013-07-11','13:05:00',4.59),('8784','2013-07-11','13:10:00',4.38),('8784','2013-07-11','13:15:00',4.51),('8784','2013-07-11','13:20:00',4.2),('8784','2013-07-11','13:25:00',3.78),('8784','2013-07-11','13:30:00',4.45),('8784','2013-07-11','13:35:00',3.43),('8784','2013-07-11','13:40:00',3.77),('8784','2013-07-11','13:45:00',4.13),('8784','2013-07-11','13:50:00',2.83),('8784','2013-07-11','13:55:00',2.36),('8784','2013-07-11','14:00:00',4.51),('8784','2013-07-11','14:05:00',4.42),('8784','2013-07-11','14:10:00',4.24),('8784','2013-07-11','14:15:00',4.22),('8784','2013-07-11','14:20:00',4.38),('8784','2013-07-11','14:25:00',4.42),('8784','2013-07-11','14:30:00',4.4),('8784','2013-07-11','14:35:00',4.3),('8784','2013-07-11','14:40:00',4.22),('8784','2013-07-11','14:45:00',4.28),('8784','2013-07-11','14:50:00',4.2),('8784','2013-07-11','14:55:00',3.49),('8784','2013-07-11','15:00:00',2.97),('8784','2013-07-11','15:05:00',2.1),('8784','2013-07-11','15:10:00',4.16),('8784','2013-07-11','15:15:00',2.18),('8784','2013-07-11','15:20:00',3.87),('8784','2013-07-11','15:25:00',3.38),('8784','2013-07-11','15:30:00',3.68),('8784','2013-07-11','15:35:00',3.06),('8784','2013-07-11','15:40:00',4.01),('8784','2013-07-11','15:45:00',3.24),('8784','2013-07-11','15:50:00',2.68),('8784','2013-07-11','15:55:00',1.48),('8784','2013-07-11','16:00:00',3.63),('8784','2013-07-11','16:05:00',2.6),('8784','2013-07-11','16:10:00',3.71),('8784','2013-07-11','16:15:00',1.85),('8784','2013-07-11','16:20:00',3.15),('8784','2013-07-11','16:25:00',1.66),('8784','2013-07-11','16:30:00',3),('8784','2013-07-11','16:35:00',2.02),('8784','2013-07-11','16:40:00',3.16),('8784','2013-07-11','16:45:00',3.45),('8784','2013-07-11','16:50:00',3.06),('8784','2013-07-11','16:55:00',2.89),('8784','2013-07-11','17:00:00',2.01),('8784','2013-07-11','17:05:00',2.38),('8784','2013-07-11','17:10:00',2.76),('8784','2013-07-11','17:15:00',2.51),('8784','2013-07-11','17:20:00',2.41),('8784','2013-07-11','17:25:00',2.38),('8784','2013-07-11','17:30:00',2.63),('8784','2013-07-11','17:35:00',2.11),('8784','2013-07-11','17:40:00',2.19),('8784','2013-07-11','17:45:00',1.79),('8784','2013-07-11','17:50:00',1.94),('8784','2013-07-11','17:55:00',2.07),('8784','2013-07-11','18:00:00',2.12),('8784','2013-07-11','18:05:00',1.49),('8784','2013-07-11','18:10:00',1.99),('8784','2013-07-11','18:15:00',1.79),('8784','2013-07-11','18:20:00',1.36),('8784','2013-07-11','18:25:00',1.45),('8784','2013-07-11','18:30:00',1.32),('8784','2013-07-11','18:35:00',1.05),('8784','2014-05-03','07:30:00',1.08),('8784','2014-05-03','07:35:00',1.17),('8784','2014-05-03','07:40:00',1.27),('8784','2014-05-03','07:45:00',1.33),('8784','2014-05-03','07:50:00',1.43),('8784','2014-05-03','07:55:00',1.49),('8784','2014-05-03','08:00:00',1.69),('8784','2014-05-03','08:05:00',1.73),('8784','2014-05-03','08:10:00',2.08),('8784','2014-05-03','08:15:00',1.72),('8784','2014-05-03','08:20:00',1.17),('8784','2014-05-03','08:25:00',1.16),('8784','2014-05-03','08:30:00',1.47),('8784','2014-05-03','08:45:00',1.96),('8784','2014-05-03','08:50:00',2.75),('8784','2014-05-03','08:55:00',3.21),('8784','2014-05-03','09:00:00',2.39),('8784','2014-05-03','09:05:00',1.9),('8784','2014-05-03','09:10:00',1.67),('8784','2014-05-03','09:15:00',2.76),('8784','2014-05-03','09:20:00',3.33),('8784','2014-05-03','09:25:00',2.16),('8784','2014-05-03','09:30:00',2.87),('8784','2014-05-03','09:35:00',3.38),('8784','2014-05-03','09:40:00',2.93),('8784','2014-05-03','09:45:00',3.36),('8784','2014-05-03','09:50:00',1.64),('8784','2014-05-03','09:55:00',3.34),('8784','2014-05-03','10:00:00',3.75),('8784','2014-05-03','10:05:00',3.74),('8784','2014-05-03','10:10:00',4.03),('8784','2014-05-03','10:15:00',4.34),('8784','2014-05-03','10:20:00',4.12),('8784','2014-05-03','10:25:00',2.25),('8784','2014-05-03','10:30:00',2.11),('8784','2014-05-03','10:35:00',1.16),('8784','2014-05-03','10:40:00',1.16),('8784','2014-05-03','10:45:00',1.25),('8784','2014-05-03','10:50:00',1.17),('8784','2014-05-03','10:55:00',1.57),('8784','2014-05-03','11:00:00',1.33),('8784','2014-05-03','11:05:00',4.2),('8784','2014-05-03','11:10:00',4.35),('8784','2014-05-03','11:15:00',5.29),('8784','2014-05-03','11:20:00',4.8),('8784','2014-05-03','11:25:00',3.77),('8784','2014-05-03','11:30:00',4.84),('8784','2014-05-03','11:35:00',2.96),('8784','2014-05-03','11:40:00',3.28),('8784','2014-05-03','11:45:00',2.75),('8784','2014-05-03','11:50:00',2.47),('8784','2014-05-03','11:55:00',2.55),('8784','2014-05-03','12:00:00',1.99),('8784','2014-05-03','12:05:00',1.61),('8784','2014-05-03','12:10:00',1.48),('8784','2014-05-03','12:15:00',1.39),('8784','2014-05-03','12:20:00',1.31),('8784','2014-05-03','12:25:00',1.38),('8784','2014-05-03','12:30:00',1.81),('8784','2014-05-03','12:35:00',2.27),('8784','2014-05-03','12:40:00',2.19),('8784','2014-05-03','12:45:00',2.21),('8784','2014-05-03','12:50:00',1.96),('8784','2014-05-03','12:55:00',1.93),('8784','2014-05-03','13:00:00',2.13),('8784','2014-05-03','13:05:00',2.55),('8784','2014-05-03','13:10:00',3.08),('8784','2014-05-03','13:15:00',2.98),('8784','2014-05-03','13:20:00',2.47),('8784','2014-05-03','13:25:00',2.99),('8784','2014-05-03','13:30:00',3.76),('8784','2014-05-03','13:35:00',2.96),('8784','2014-05-03','13:40:00',2.17),('8784','2014-05-03','13:45:00',2.03),('8784','2014-05-03','13:50:00',2),('8784','2014-05-03','13:55:00',2.01),('8784','2014-05-03','14:00:00',1.98),('8784','2014-05-03','14:05:00',1.99),('8784','2014-05-03','14:10:00',2.22),('8784','2014-05-03','14:15:00',2.58),('8784','2014-05-03','14:20:00',2.99),('8784','2014-05-03','14:25:00',3.51),('8784','2014-05-03','14:30:00',2.19),('8784','2014-05-03','14:35:00',1.68),('8784','2014-05-03','14:40:00',1.27),('8784','2014-05-03','14:55:00',3.38),('8784','2014-05-03','15:00:00',2.51),('8784','2014-05-03','15:05:00',1.27),('8784','2014-05-03','15:10:00',1),('8784','2014-05-03','16:50:00',1),('8784','2014-05-03','16:55:00',1.03),('8784','2014-05-03','17:00:00',1.05),('8784','2014-05-03','17:05:00',1.04),('8784','2014-05-03','17:10:00',1.03),('8784','2014-05-03','17:15:00',1.04),('8784','2014-05-03','17:20:00',1.02),('8784','2014-05-03','17:25:00',1.04),('8784','2014-05-03','17:45:00',1.04),('8784','2014-05-03','17:50:00',1.2),('8784','2014-05-03','17:55:00',1.23),('8784','2014-04-06','08:15:00',1.22),('8784','2014-04-06','08:20:00',1.29),('8784','2014-04-06','08:25:00',1.4),('8784','2014-04-06','08:30:00',1.48),('8784','2014-04-06','08:35:00',1.59),('8784','2014-04-06','08:40:00',1.71),('8784','2014-04-06','08:45:00',1.77),('8784','2014-04-06','08:50:00',1.67),('8784','2014-04-06','09:10:00',1.79),('8784','2014-04-06','09:15:00',2.49),('8784','2014-04-06','09:20:00',2.17),('8784','2014-04-06','09:25:00',1.85),('8784','2014-04-06','09:30:00',1.84),('8784','2014-04-06','09:35:00',2.41),('8784','2014-04-06','09:40:00',2.6),('8784','2014-04-06','09:45:00',3.2),('8784','2014-04-06','09:50:00',3.71),('8784','2014-04-06','09:55:00',3.75),('8784','2014-04-06','10:00:00',3.47),('8784','2014-04-06','10:05:00',2.54),('8784','2014-04-06','10:10:00',2.1),('8784','2014-04-06','10:15:00',2.44),('8784','2014-04-06','10:20:00',1.76),('8784','2014-04-06','10:25:00',1.35),('8784','2014-04-06','10:30:00',1.44),('8784','2014-04-06','10:35:00',1.59),('8784','2014-04-06','10:40:00',1.71),('8784','2014-04-06','10:45:00',2.84),('8784','2014-04-06','10:50:00',3.34),('8784','2014-04-06','10:55:00',1.6),('8784','2014-04-06','11:00:00',3),('8784','2014-04-06','11:05:00',3.18),('8784','2014-04-06','11:10:00',4.35),('8784','2014-04-06','11:15:00',1.76),('8784','2014-04-06','11:20:00',4.05),('8784','2014-04-06','11:25:00',4.16),('8784','2014-04-06','11:30:00',4.38),('8784','2014-04-06','11:35:00',4.69),('8784','2014-04-06','11:40:00',4.65),('8784','2014-04-06','11:45:00',4.52),('8784','2014-04-06','11:50:00',3.6),('8784','2014-04-06','11:55:00',4.55),('8784','2014-04-06','12:00:00',4.47),('8784','2014-04-06','12:05:00',4.36),('8784','2014-04-06','12:10:00',4.34),('8784','2014-04-06','12:15:00',4.48),('8784','2014-04-06','12:20:00',3.5),('8784','2014-04-06','12:25:00',1.9),('8784','2014-04-06','12:30:00',2.18),('8784','2014-04-06','12:35:00',2.04),('8784','2014-04-06','12:40:00',1.49),('8784','2014-04-06','12:45:00',1.16),('8784','2014-04-06','12:50:00',1.18),('8784','2014-04-06','12:55:00',1.9),('8784','2014-04-06','13:00:00',4.35),('8784','2014-04-06','13:05:00',3.24),('8784','2014-04-06','13:10:00',4.62),('8784','2014-04-06','13:15:00',3.87),('8784','2014-04-06','13:20:00',3.16),('8784','2014-04-06','13:25:00',1.21),('8784','2014-04-06','13:30:00',3.56),('8784','2014-04-06','13:35:00',3.41),('8784','2014-04-06','13:40:00',1.39),('8784','2014-04-06','13:45:00',4.12),('8784','2014-04-06','13:50:00',4.54),('8784','2014-04-06','13:55:00',4.48),('8784','2014-04-06','14:00:00',4.32),('8784','2014-04-06','14:05:00',4.17),('8784','2014-04-06','14:10:00',4.39),('8784','2014-04-06','14:15:00',4.51),('8784','2014-04-06','14:20:00',2.06),('8784','2014-04-06','14:25:00',1.64),('8784','2014-04-06','14:30:00',1.16),('8784','2014-04-06','14:35:00',1.36),('8784','2014-04-06','14:40:00',1.94),('8784','2014-04-06','14:45:00',4.97),('8784','2014-04-06','14:50:00',3.76),('8784','2014-04-06','14:55:00',3),('8784','2014-04-06','15:00:00',2.33),('8784','2014-04-06','15:05:00',1.33),('8784','2014-04-06','15:10:00',3.12),('8784','2014-04-06','15:15:00',3.15),('8784','2014-04-06','15:20:00',2.79),('8784','2014-04-06','15:25:00',1.38),('8784','2014-04-06','15:30:00',1.21),('8784','2014-04-06','15:45:00',1.01),('8784','2014-04-06','15:50:00',1.64),('8784','2014-04-06','15:55:00',3.76),('8784','2014-04-06','16:00:00',3.3),('8784','2014-04-06','16:05:00',1.53),('8784','2014-04-06','16:10:00',2.2),('8784','2014-04-06','16:15:00',1.31),('8784','2014-04-06','16:30:00',1.03),('8784','2014-04-06','16:35:00',1.53),('8784','2014-04-06','16:40:00',2.41),('8784','2014-04-06','16:45:00',3.09),('8784','2014-04-06','16:50:00',3.03),('8784','2014-04-06','16:55:00',2.59),('8784','2014-04-06','17:25:00',1.83),('8784','2014-04-06','17:30:00',1.85),('8784','2014-04-06','17:35:00',1.27),('8784','2014-04-06','17:45:00',1.11),('8784','2014-04-06','17:50:00',1.49),('8784','2014-04-06','17:55:00',1.33),('8784','2014-04-06','18:00:00',1.22),('8784','2014-04-06','18:05:00',1.11),('8784','2014-04-06','18:10:00',1.06),('8784','2014-04-06','18:15:00',1.04),('8784','2014-04-06','18:20:00',1.04),('8784','2013-07-10','07:20:00',1.19),('8784','2013-07-10','07:25:00',1.37),('8784','2013-07-10','07:30:00',1.51),('8784','2013-07-10','07:35:00',1.67),('8784','2013-07-10','07:40:00',1.79),('8784','2013-07-10','07:45:00',1.91),('8784','2013-07-10','07:50:00',2.04),('8784','2013-07-10','07:55:00',2.18),('8784','2013-07-10','08:00:00',1.86),('8784','2013-07-10','08:05:00',1.52),('8784','2013-07-10','08:10:00',1.95),('8784','2013-07-10','08:15:00',2.01),('8784','2013-07-10','08:20:00',2.16),('8784','2013-07-10','08:25:00',2.23),('8784','2013-07-10','08:30:00',1.86),('8784','2013-07-10','08:35:00',2),('8784','2013-07-10','08:40:00',2.74),('8784','2013-07-10','08:45:00',2.53),('8784','2013-07-10','08:50:00',2.56),('8784','2013-07-10','08:55:00',2.56),('8784','2013-07-10','09:00:00',2.51),('8784','2013-07-10','09:05:00',2.65),('8784','2013-07-10','09:10:00',2.81),('8784','2013-07-10','09:15:00',2.91),('8784','2013-07-10','09:20:00',2.56),('8784','2013-07-10','09:25:00',1.87),('8784','2013-07-10','09:30:00',2.8),('8784','2013-07-10','09:35:00',3.04),('8784','2013-07-10','09:40:00',3.05),('8784','2013-07-10','09:45:00',3.12),('8784','2013-07-10','09:50:00',3.15),('8784','2013-07-10','09:55:00',2.35),('8784','2013-07-10','10:00:00',3.28),('8784','2013-07-10','10:05:00',3.32),('8784','2013-07-10','10:10:00',3.36),('8784','2013-07-10','10:15:00',3.43),('8784','2013-07-10','10:20:00',3.52),('8784','2013-07-10','10:25:00',3.57),('8784','2013-07-10','10:30:00',3.6),('8784','2013-07-10','10:35:00',3.63),('8784','2013-07-10','10:40:00',3.69),('8784','2013-07-10','10:45:00',3.74),('8784','2013-07-10','10:50:00',3.78),('8784','2013-07-10','10:55:00',3.8),('8784','2013-07-10','11:00:00',3.82),('8784','2013-07-10','11:05:00',3.83),('8784','2013-07-10','11:10:00',3.87),('8784','2013-07-10','11:15:00',3.92),('8784','2013-07-10','11:20:00',3.94),('8784','2013-07-10','11:25:00',3.96),('8784','2013-07-10','11:30:00',3.96),('8784','2013-07-10','11:35:00',3.99),('8784','2013-07-10','11:40:00',4.02),('8784','2013-07-10','11:45:00',4.07),('8784','2013-07-10','11:50:00',4.07),('8784','2013-07-10','11:55:00',4.11),('8784','2013-07-10','12:00:00',4.12),('8784','2013-07-10','12:05:00',4.18),('8784','2013-07-10','12:10:00',4.2),('8784','2013-07-10','12:15:00',4.23),('8784','2013-07-10','12:20:00',4.24),('8784','2013-07-10','12:25:00',4.3),('8784','2013-07-10','12:30:00',4.27),('8784','2013-07-10','12:35:00',4.33),('8784','2013-07-10','12:40:00',4.33),('8784','2013-07-10','12:45:00',4.31),('8784','2013-07-10','12:50:00',4.32),('8784','2013-07-10','12:55:00',4.28),('8784','2013-07-10','13:00:00',4.37),('8784','2013-07-10','13:05:00',4.37),('8784','2013-07-10','13:10:00',4.4),('8784','2013-07-10','13:15:00',4.35),('8784','2013-07-10','13:20:00',4.35),('8784','2013-07-10','13:25:00',4.35),('8784','2013-07-10','13:30:00',4.33),('8784','2013-07-10','13:35:00',4.36),('8784','2013-07-10','13:40:00',4.37),('8784','2013-07-10','13:45:00',4.36),('8784','2013-07-10','13:50:00',4.37),('8784','2013-07-10','13:55:00',4.35),('8784','2013-07-10','14:00:00',4.35),('8784','2013-07-10','14:05:00',4.37),('8784','2013-07-10','14:10:00',4.34),('8784','2013-07-10','14:15:00',4.31),('8784','2013-07-10','14:20:00',4.32),('8784','2013-07-10','14:25:00',4.29),('8784','2013-07-10','14:30:00',4.29),('8784','2013-07-10','14:35:00',4.25),('8784','2013-07-10','14:40:00',4.23),('8784','2013-07-10','14:45:00',4.16),('8784','2013-07-10','14:50:00',4.14),('8784','2013-07-10','14:55:00',4.13),('8784','2013-07-10','15:00:00',4.09),('8784','2013-07-10','15:05:00',4.08),('8784','2013-07-10','15:10:00',4.04),('8784','2013-07-10','15:15:00',4),('8784','2013-07-10','15:20:00',3.94),('8784','2013-07-10','15:25:00',3.92),('8784','2013-07-10','15:30:00',3.87),('8784','2013-07-10','15:35:00',3.85),('8784','2013-07-10','15:40:00',3.01),('8784','2013-07-10','15:45:00',3.73),('8784','2013-07-10','15:50:00',3.69),('8784','2013-07-10','15:55:00',3.66),('8784','2013-07-10','16:00:00',3.6),('8784','2013-07-10','16:05:00',3.53),('8784','2013-07-10','16:10:00',3.49),('8784','2013-07-10','16:15:00',3.41),('8784','2013-07-10','16:20:00',3.38),('8784','2013-07-10','16:25:00',3.3),('8784','2013-07-10','16:30:00',3.21),('8784','2013-07-10','16:35:00',3.14),('8784','2013-07-10','16:40:00',3.08),('8784','2013-07-10','16:45:00',3.02),('8784','2013-07-10','16:50:00',2.98),('8784','2013-07-10','16:55:00',2.96),('8784','2013-07-10','17:00:00',3),('8784','2013-07-10','17:05:00',2.53),('8784','2013-07-10','17:10:00',2.43),('8784','2013-07-10','17:15:00',1.57),('8784','2013-07-10','17:20:00',1.85),('8784','2013-07-10','17:35:00',2.06),('8784','2013-07-10','17:40:00',2.03),('8784','2013-07-10','17:45:00',2.06),('8784','2013-07-10','17:50:00',2.04),('8784','2013-07-10','17:55:00',1.88),('8784','2013-07-10','18:00:00',1.98),('8784','2013-07-10','18:05:00',1.6),('8784','2013-07-10','18:10:00',1.38),('8784','2013-07-10','18:20:00',1.03),('8784','2013-07-09','07:40:00',1.29),('8784','2013-07-09','07:45:00',1.35),('8784','2013-07-09','07:50:00',1.43),('8784','2013-07-09','07:55:00',1.47),('8784','2013-07-09','08:00:00',1.52),('8784','2013-07-09','08:05:00',1.65),('8784','2013-07-09','08:10:00',1.65),('8784','2013-07-09','08:15:00',1.76),('8784','2013-07-09','08:20:00',1.86),('8784','2013-07-09','08:25:00',1.89),('8784','2013-07-09','08:30:00',1.98),('8784','2013-07-09','08:35:00',2.08),('8784','2013-07-09','08:40:00',2.14),('8784','2013-07-09','08:45:00',2.26),('8784','2013-07-09','08:50:00',2.33),('8784','2013-07-09','08:55:00',2.38),('8784','2013-07-09','09:00:00',2.45),('8784','2013-07-09','09:05:00',2.55),('8784','2013-07-09','09:10:00',2.64),('8784','2013-07-09','09:15:00',2.73),('8784','2013-07-09','09:20:00',2.78),('8784','2013-07-09','09:25:00',2.84),('8784','2013-07-09','09:30:00',2.91),('8784','2013-07-09','09:35:00',2.97),('8784','2013-07-09','09:40:00',3.03),('8784','2013-07-09','09:45:00',3.07),('8784','2013-07-09','09:50:00',3.14),('8784','2013-07-09','09:55:00',3.21),('8784','2013-07-09','10:00:00',2.97),('8784','2013-07-09','10:05:00',3.2),('8784','2013-07-09','10:10:00',3.34),('8784','2013-07-09','10:15:00',3.38),('8784','2013-07-09','10:20:00',3.41),('8784','2013-07-09','10:25:00',3.47),('8784','2013-07-09','10:30:00',3.54),('8784','2013-07-09','10:35:00',3.59),('8784','2013-07-09','10:40:00',3.64),('8784','2013-07-09','10:45:00',3.69),('8784','2013-07-09','10:50:00',3.72),('8784','2013-07-09','10:55:00',3.8),('8784','2013-07-09','11:00:00',3.87),('8784','2013-07-09','11:05:00',3.89),('8784','2013-07-09','11:10:00',3.9),('8784','2013-07-09','11:15:00',3.82),('8784','2013-07-09','11:20:00',3.84),('8784','2013-07-09','11:25:00',3.61),('8784','2013-07-09','11:30:00',2.26),('8784','2013-07-09','11:35:00',2.97),('8784','2013-07-09','11:40:00',3.4),('8784','2013-07-09','11:45:00',4.19),('8784','2013-07-09','11:50:00',4.64),('8784','2013-07-09','11:55:00',4.52),('8784','2013-07-09','12:00:00',4.49),('8784','2013-07-09','12:05:00',4.42),('8784','2013-07-09','12:10:00',4.35),('8784','2013-07-09','12:15:00',4.31),('8784','2013-07-09','12:20:00',4.25),('8784','2013-07-09','12:25:00',4.22),('8784','2013-07-09','12:30:00',4.21),('8784','2013-07-09','12:35:00',4.17),('8784','2013-07-09','12:40:00',4.24),('8784','2013-07-09','12:45:00',4.24),('8784','2013-07-09','12:50:00',4.28),('8784','2013-07-09','12:55:00',4.23),('8784','2013-07-09','13:00:00',4.28),('8784','2013-07-09','13:05:00',4.42),('8784','2013-07-09','13:10:00',4.39),('8784','2013-07-09','13:15:00',4.37),('8784','2013-07-09','13:20:00',4.26),('8784','2013-07-09','13:25:00',4.46),('8784','2013-07-09','13:30:00',4.53),('8784','2013-07-09','13:35:00',4.35),('8784','2013-07-09','13:40:00',4.33),('8784','2013-07-09','13:45:00',3.78),('8784','2013-07-09','13:50:00',3.29),('8784','2013-07-09','13:55:00',3.44),('8784','2013-07-09','14:00:00',3.5),('8784','2013-07-09','14:05:00',3.3),('8784','2013-07-09','14:10:00',3.65),('8784','2013-07-09','14:15:00',3.75),('8784','2013-07-09','14:20:00',2.69),('8784','2013-07-09','14:25:00',2.86),('8784','2013-07-09','14:30:00',1.76),('8784','2013-07-09','14:35:00',1.1),('8784','2013-07-08','07:40:00',1.57),('8784','2013-07-08','07:45:00',1.49),('8784','2013-07-08','07:50:00',1.14),('8784','2013-07-08','07:55:00',1.17),('8784','2013-07-08','08:00:00',1.41),('8784','2013-07-08','08:05:00',1.42),('8784','2013-07-08','08:10:00',1.6),('8784','2013-07-08','08:15:00',1.78),('8784','2013-07-08','08:20:00',1.89),('8784','2013-07-08','08:25:00',1.98),('8784','2013-07-08','08:30:00',2.08),('8784','2013-07-08','08:35:00',2.15),('8784','2013-07-08','08:40:00',2.19),('8784','2013-07-08','08:45:00',2.28),('8784','2013-07-08','08:50:00',2.36),('8784','2013-07-08','08:55:00',2.43),('8784','2013-07-08','09:00:00',2.48),('8784','2013-07-08','09:05:00',2.56),('8784','2013-07-08','09:10:00',2.61),('8784','2013-07-08','09:15:00',2.66),('8784','2013-07-08','09:20:00',2.69),('8784','2013-07-08','09:25:00',2.66),('8784','2013-07-08','09:30:00',2.82),('8784','2013-07-08','09:35:00',2.97),('8784','2013-07-08','09:40:00',3.06),('8784','2013-07-08','09:45:00',3.08),('8784','2013-07-08','09:50:00',3.16),('8784','2013-07-08','09:55:00',3.23),('8784','2013-07-08','10:00:00',3.32),('8784','2013-07-08','10:05:00',3.37),('8784','2013-07-08','10:10:00',3.38),('8784','2013-07-08','10:15:00',3.44),('8784','2013-07-08','10:20:00',3.5),('8784','2013-07-08','10:25:00',3.54),('8784','2013-07-08','10:30:00',3.61),('8784','2013-07-08','10:35:00',3.63),('8784','2013-07-08','10:40:00',3.63),('8784','2013-07-08','10:45:00',3.68),('8784','2013-07-08','10:50:00',3.71),('8784','2013-07-08','10:55:00',3.72),('8784','2013-07-08','11:00:00',3.73),('8784','2013-07-08','11:05:00',3.82),('8784','2013-07-08','11:10:00',3.88),('8784','2013-07-08','11:15:00',3.96),('8784','2013-07-08','11:20:00',4.01),('8784','2013-07-08','11:25:00',4.07),('8784','2013-07-08','11:30:00',4.1),('8784','2013-07-08','11:35:00',4.14),('8784','2013-07-08','11:40:00',3.95),('8784','2013-07-08','11:45:00',4.13),('8784','2013-07-08','11:50:00',4.19),('8784','2013-07-08','11:55:00',4.16),('8784','2013-07-08','12:00:00',4.18),('8784','2013-07-08','12:05:00',4.29),('8784','2013-07-08','12:10:00',4.38),('8784','2013-07-08','12:15:00',4.51),('8784','2013-07-08','12:20:00',4.57),('8784','2013-07-08','12:25:00',4.53),('8784','2013-07-08','12:30:00',3.89),('8784','2013-07-08','12:35:00',4.4),('8784','2013-07-08','12:40:00',4.34),('8784','2013-07-08','12:45:00',4.28),('8784','2013-07-08','12:50:00',4.3),('8784','2013-07-08','12:55:00',4.42),('8784','2013-07-08','13:00:00',4.59),('8784','2013-07-08','13:05:00',4.7),('8784','2013-07-08','13:10:00',4.63),('8784','2013-07-08','13:15:00',4.98),('8784','2013-07-08','13:20:00',3.28),('8784','2013-07-08','13:25:00',1.45),('8784','2013-07-08','14:30:00',1.06),('8784','2013-07-08','14:35:00',1.26),('8784','2013-07-08','14:40:00',1.32),('8784','2013-07-08','14:45:00',1.25),('8784','2013-07-08','14:50:00',1.23),('8784','2013-07-08','14:55:00',1.22),('8784','2013-07-08','15:00:00',1.13),('8784','2013-07-08','15:05:00',1.02),('8784','2013-07-08','17:30:00',1.02),('8784','2013-07-08','17:35:00',1.11),('8784','2013-07-08','17:40:00',1.13),('8784','2013-07-08','17:45:00',1.13),('8784','2013-07-08','17:50:00',1.13),('8784','2013-07-08','17:55:00',1.08),('8784','2013-07-08','18:25:00',1.02),('8784','2013-07-08','18:40:00',1.39),('8784','2013-07-08','18:45:00',1.38),('8784','2013-07-08','18:50:00',1.22),('8784','2013-07-08','18:55:00',1.02),('8784','2013-07-07','07:20:00',1.01),('8784','2013-07-07','07:25:00',1.09),('8784','2013-07-07','07:30:00',1.17),('8784','2013-07-07','07:35:00',1.25),('8784','2013-07-07','07:40:00',1.34),('8784','2013-07-07','07:45:00',1.42),('8784','2013-07-07','07:50:00',1.5),('8784','2013-07-07','07:55:00',1.57),('8784','2013-07-07','08:00:00',1.61),('8784','2013-07-07','08:05:00',1.7),('8784','2013-07-07','08:10:00',1.79),('8784','2013-07-07','08:15:00',1.84),('8784','2013-07-07','08:20:00',1.44),('8784','2013-07-07','08:25:00',1.58),('8784','2013-07-07','08:30:00',1.88),('8784','2013-07-07','08:35:00',2.26),('8784','2013-07-07','08:40:00',1.79),('8784','2013-07-07','08:50:00',1.95),('8784','2013-07-07','08:55:00',2.6),('8784','2013-07-07','09:00:00',2.63),('8784','2013-07-07','09:05:00',2.41),('8784','2013-07-07','09:10:00',2.54),('8784','2013-07-07','09:15:00',2.68),('8784','2013-07-07','09:20:00',1.72),('8784','2013-07-07','09:25:00',2.15),('8784','2013-07-07','09:30:00',3.03),('8784','2013-07-07','09:35:00',3.08),('8784','2013-07-07','09:40:00',2.99),('8784','2013-07-07','09:45:00',3.2),('8784','2013-07-07','09:50:00',3.32),('8784','2013-07-07','09:55:00',3.46),('8784','2013-07-07','10:00:00',3.54),('8784','2013-07-07','10:05:00',3.29),('8784','2013-07-07','10:10:00',3.35),('8784','2013-07-07','10:15:00',3.32),('8784','2013-07-07','10:20:00',3.27),('8784','2013-07-07','10:25:00',3.51),('8784','2013-07-07','10:30:00',3.11),('8784','2013-07-07','10:35:00',3.86),('8784','2013-07-07','10:40:00',3.65),('8784','2013-07-07','10:45:00',3.75),('8784','2013-07-07','10:50:00',3.91),('8784','2013-07-07','10:55:00',3.89),('8784','2013-07-07','11:00:00',3.93),('8784','2013-07-07','11:05:00',3.97),('8784','2013-07-07','11:10:00',4.06),('8784','2013-07-07','11:15:00',4.06),('8784','2013-07-07','11:20:00',3.8),('8784','2013-07-07','11:25:00',3.48),('8784','2013-07-07','11:30:00',3.56),('8784','2013-07-07','11:35:00',3.44),('8784','2013-07-07','11:40:00',3.62),('8784','2013-07-07','11:45:00',3.01),('8784','2013-07-07','11:50:00',3.16),('8784','2013-07-07','11:55:00',2.26),('8784','2013-07-07','12:00:00',2.31),('8784','2013-07-07','12:05:00',4.09),('8784','2013-07-07','12:10:00',4.17),('8784','2013-07-07','12:15:00',4.22),('8784','2013-07-07','12:20:00',4.3),('8784','2013-07-07','12:25:00',4.11),('8784','2013-07-07','12:30:00',4.05),('8784','2013-07-07','12:35:00',4.24),('8784','2013-07-07','12:40:00',4.43),('8784','2013-07-07','12:45:00',4.47),('8784','2013-07-07','12:50:00',4.28),('8784','2013-07-07','12:55:00',4.54),('8784','2013-07-07','13:00:00',4.4),('8784','2013-07-07','13:05:00',4.41),('8784','2013-07-07','13:10:00',4.44),('8784','2013-07-07','13:15:00',4.45),('8784','2013-07-07','13:20:00',4.4),('8784','2013-07-07','13:25:00',3.63),('8784','2013-07-07','13:30:00',3.9),('8784','2013-07-07','13:35:00',4.53),('8784','2013-07-07','13:40:00',4.47),('8784','2013-07-07','13:45:00',4.2),('8784','2013-07-07','13:50:00',4.9),('8784','2013-07-07','13:55:00',4.1),('8784','2013-07-07','14:00:00',2.68),('8784','2013-07-07','14:05:00',3.76),('8784','2013-07-07','14:10:00',2.44),('8784','2013-07-07','14:15:00',1.61),('8784','2013-07-07','14:20:00',1.34),('8784','2013-07-07','14:25:00',1.18),('8784','2013-07-07','14:30:00',1.11),('8784','2013-07-07','14:35:00',1.02),('8784','2013-07-07','15:00:00',1.09),('8784','2013-07-07','15:05:00',1.23),('8784','2013-07-07','17:00:00',1.02),('8784','2013-07-07','17:05:00',1.1),('8784','2013-07-07','17:10:00',1.14),('8784','2013-07-07','17:15:00',1.18),('8784','2013-07-07','17:20:00',1.19),('8784','2013-07-07','17:25:00',1.17),('8784','2013-07-07','17:30:00',1.14),('8784','2013-07-07','17:35:00',1.07),('8784','2013-07-07','17:40:00',1.01),('8784','2013-07-06','07:25:00',1.04),('8784','2013-07-06','07:30:00',1.1),('8784','2013-07-06','07:35:00',1.15),('8784','2013-07-06','07:40:00',1.24),('8784','2013-07-06','07:45:00',1.33),('8784','2013-07-06','07:50:00',1.43),('8784','2013-07-06','07:55:00',1.52),('8784','2013-07-06','08:00:00',1.6),('8784','2013-07-06','08:05:00',1.7),('8784','2013-07-06','08:10:00',1.74),('8784','2013-07-06','08:15:00',1.84),('8784','2013-07-06','08:20:00',1.88),('8784','2013-07-06','08:25:00',2.02),('8784','2013-07-06','08:30:00',2.11),('8784','2013-07-06','08:35:00',2.19),('8784','2013-07-06','08:40:00',2.27),('8784','2013-07-06','08:45:00',2.34),('8784','2013-07-06','08:50:00',2.4),('8784','2013-07-06','08:55:00',2.47),('8784','2013-07-06','09:00:00',2.55),('8784','2013-07-06','09:05:00',2.63),('8784','2013-07-06','09:10:00',2.71),('8784','2013-07-06','09:15:00',2.78),('8784','2013-07-06','09:20:00',2.85),('8784','2013-07-06','09:25:00',2.86),('8784','2013-07-06','09:30:00',2.94),('8784','2013-07-06','09:35:00',3.01),('8784','2013-07-06','09:40:00',3.07),('8784','2013-07-06','09:45:00',3.12),('8784','2013-07-06','09:50:00',3.2),('8784','2013-07-06','09:55:00',3.28),('8784','2013-07-06','10:00:00',3.34),('8784','2013-07-06','10:05:00',3.41),('8784','2013-07-06','10:10:00',3.48),('8784','2013-07-06','10:15:00',3.51),('8784','2013-07-06','10:20:00',3.54),('8784','2013-07-06','10:25:00',3.59),('8784','2013-07-06','10:30:00',3.63),('8784','2013-07-06','10:35:00',3.66),('8784','2013-07-06','10:40:00',3.69),('8784','2013-07-06','10:45:00',3.76),('8784','2013-07-06','10:50:00',3.81),('8784','2013-07-06','10:55:00',3.87),('8784','2013-07-06','11:00:00',3.92),('8784','2013-07-06','11:05:00',3.95),('8784','2013-07-06','11:10:00',3.96),('8784','2013-07-06','11:15:00',4),('8784','2013-07-06','11:20:00',4),('8784','2013-07-06','11:25:00',4.05),('8784','2013-07-06','11:30:00',4.09),('8784','2013-07-06','11:35:00',4.1),('8784','2013-07-06','11:40:00',4.1),('8784','2013-07-06','11:45:00',4.17),('8784','2013-07-06','11:50:00',4.2),('8784','2013-07-06','11:55:00',4.17),('8784','2013-07-06','12:00:00',4.19),('8784','2013-07-06','12:05:00',4.23),('8784','2013-07-06','12:10:00',4.32),('8784','2013-07-06','12:15:00',4.35),('8784','2013-07-06','12:20:00',4.38),('8784','2013-07-06','12:25:00',4.36),('8784','2013-07-06','12:30:00',4.4),('8784','2013-07-06','12:35:00',4.4),('8784','2013-07-06','12:40:00',4.37),('8784','2013-07-06','12:45:00',4.4),('8784','2013-07-06','12:50:00',4.38),('8784','2013-07-06','12:55:00',4.37),('8784','2013-07-06','13:00:00',4.43),('8784','2013-07-06','13:05:00',4.42),('8784','2013-07-06','13:10:00',4.43),('8784','2013-07-06','13:15:00',4.45),('8784','2013-07-06','13:20:00',4.46),('8784','2013-07-06','13:25:00',4.43),('8784','2013-07-06','13:30:00',4.45),('8784','2013-07-06','13:35:00',4.36),('8784','2013-07-06','13:40:00',4.45),('8784','2013-07-06','13:45:00',4.44),('8784','2013-07-06','13:50:00',4.38),('8784','2013-07-06','13:55:00',4.36),('8784','2013-07-06','14:00:00',4.36),('8784','2013-07-06','14:05:00',4.4),('8784','2013-07-06','14:10:00',4.29),('8784','2013-07-06','14:15:00',4.35),('8784','2013-07-06','14:20:00',4.23),('8784','2013-07-06','14:25:00',4.33),('8784','2013-07-06','14:30:00',4.23),('8784','2013-07-06','14:35:00',4.23),('8784','2013-07-06','14:40:00',4.19),('8784','2013-07-06','14:45:00',4.11),('8784','2013-07-06','14:50:00',4.06),('8784','2013-07-06','14:55:00',2.78),('8784','2013-07-06','15:00:00',3.12),('8784','2013-07-06','15:05:00',4.28),('8784','2013-07-06','15:10:00',4.14),('8784','2013-07-06','15:15:00',4.04),('8784','2013-07-06','15:20:00',3.95),('8784','2013-07-06','15:25:00',3.97),('8784','2013-07-06','15:30:00',3.33),('8784','2013-07-06','15:35:00',2.31),('8784','2013-07-06','16:50:00',1.64),('8784','2013-07-06','16:55:00',2.06),('8784','2013-07-06','17:00:00',1.2),('8784','2013-07-06','17:05:00',1.11),('8784','2013-07-06','17:10:00',1.35),('8784','2013-07-06','17:15:00',2.14),('8784','2013-07-06','17:20:00',1.21),('8784','2013-07-06','17:25:00',1.09),('8784','2013-07-06','17:30:00',1.27),('8784','2013-07-06','17:35:00',1.18),('8784','2013-07-05','07:20:00',1.02),('8784','2013-07-05','07:25:00',1.07),('8784','2013-07-05','07:30:00',1.16),('8784','2013-07-05','07:35:00',1.25),('8784','2013-07-05','07:40:00',1.33),('8784','2013-07-05','07:45:00',1.39),('8784','2013-07-05','07:50:00',1.48),('8784','2013-07-05','07:55:00',1.52),('8784','2013-07-05','08:00:00',1.62),('8784','2013-07-05','08:05:00',1.62),('8784','2013-07-05','08:10:00',1.75),('8784','2013-07-05','08:15:00',1.82),('8784','2013-07-05','08:20:00',1.86),('8784','2013-07-05','08:25:00',2),('8784','2013-07-05','08:30:00',2.07),('8784','2013-07-05','08:35:00',2.18),('8784','2013-07-05','08:40:00',2.25),('8784','2013-07-05','08:45:00',2.3),('8784','2013-07-05','08:50:00',2.39),('8784','2013-07-05','08:55:00',2.43),('8784','2013-07-05','09:00:00',2.53),('8784','2013-07-05','09:05:00',2.62),('8784','2013-07-05','09:10:00',2.69),('8784','2013-07-05','09:15:00',2.76),('8784','2013-07-05','09:20:00',2.83),('8784','2013-07-05','09:25:00',2.91),('8784','2013-07-05','09:30:00',2.97),('8784','2013-07-05','09:35:00',3.02),('8784','2013-07-05','09:40:00',3.07),('8784','2013-07-05','09:45:00',3.14),('8784','2013-07-05','09:50:00',3.2),('8784','2013-07-05','09:55:00',3.26),('8784','2013-07-05','10:00:00',3.31),('8784','2013-07-05','10:05:00',3.36),('8784','2013-07-05','10:10:00',3.43),('8784','2013-07-05','10:15:00',3.47),('8784','2013-07-05','10:20:00',3.52),('8784','2013-07-05','10:25:00',3.57),('8784','2013-07-05','10:30:00',3.62),('8784','2013-07-05','10:35:00',3.66),('8784','2013-07-05','10:40:00',3.71),('8784','2013-07-05','10:45:00',3.74),('8784','2013-07-05','10:50:00',3.76),('8784','2013-07-05','10:55:00',3.76),('8784','2013-07-05','11:00:00',3.82),('8784','2013-07-05','11:05:00',3.85),('8784','2013-07-05','11:10:00',3.88),('8784','2013-07-05','11:15:00',3.9),('8784','2013-07-05','11:20:00',3.95),('8784','2013-07-05','11:25:00',4),('8784','2013-07-05','11:30:00',4.07),('8784','2013-07-05','11:35:00',4.1),('8784','2013-07-05','11:40:00',4.11),('8784','2013-07-05','11:45:00',4.11),('8784','2013-07-05','11:50:00',4.13),('8784','2013-07-05','11:55:00',4.2),('8784','2013-07-05','12:00:00',4.19),('8784','2013-07-05','12:05:00',4.21),('8784','2013-07-05','12:10:00',4.23),('8784','2013-07-05','12:15:00',4.24),('8784','2013-07-05','12:20:00',4.34),('8784','2013-07-05','12:25:00',3.35),('8784','2013-07-05','12:30:00',3.99),('8784','2013-07-05','12:35:00',3.55),('8784','2013-07-05','12:40:00',3.76),('8784','2013-07-05','12:45:00',4.39),('8784','2013-07-05','12:50:00',4.42),('8784','2013-07-05','12:55:00',4.45),('8784','2013-07-05','13:00:00',3.66),('8784','2013-07-05','13:05:00',2.83),('8784','2013-07-05','13:10:00',4.58),('8784','2013-07-05','13:15:00',4.52),('8784','2013-07-05','13:20:00',2.9),('8784','2013-07-05','13:25:00',4.39),('8784','2013-07-05','13:30:00',4.49),('8784','2013-07-05','13:35:00',4.39),('8784','2013-07-05','13:40:00',4.45),('8784','2013-07-05','13:45:00',4.45),('8784','2013-07-05','13:50:00',4.41),('8784','2013-07-05','13:55:00',4.41),('8784','2013-07-05','14:00:00',4.45),('8784','2013-07-05','14:05:00',4.22),('8784','2013-07-05','14:10:00',2.12),('8784','2013-07-05','14:15:00',4.33),('8784','2013-07-05','14:20:00',4.24),('8784','2013-07-05','14:25:00',4.24),('8784','2013-07-05','14:30:00',4.18),('8784','2013-07-05','14:35:00',3.6),('8784','2013-07-05','14:40:00',4.22),('8784','2013-07-05','14:45:00',2.86),('8784','2013-07-05','14:50:00',3.51),('8784','2013-07-05','14:55:00',3.7),('8784','2013-07-05','15:00:00',4.04),('8784','2013-07-05','15:05:00',2.86),('8784','2013-07-05','15:10:00',4.18),('8784','2013-07-05','15:15:00',4.05),('8784','2013-07-05','15:20:00',3.08),('8784','2013-07-05','15:25:00',3.37),('8784','2013-07-05','15:30:00',3.47),('8784','2013-07-05','15:35:00',3.92),('8784','2013-07-05','15:40:00',3.8),('8784','2013-07-05','15:45:00',3.81),('8784','2013-07-05','15:50:00',3.75),('8784','2013-07-05','15:55:00',3.64),('8784','2013-07-05','16:00:00',3.56),('8784','2013-07-05','16:05:00',3.54),('8784','2013-07-05','16:10:00',3.44),('8784','2013-07-05','16:15:00',3.38),('8784','2013-07-05','16:20:00',3.36),('8784','2013-07-05','16:25:00',3.31),('8784','2013-07-05','16:30:00',3.23),('8784','2013-07-05','16:35:00',3.17),('8784','2013-07-05','16:40:00',3.09),('8784','2013-07-05','16:45:00',3.06),('8784','2013-07-05','16:50:00',2.93),('8784','2013-07-05','16:55:00',2.84),('8784','2013-07-05','17:00:00',2.79),('8784','2013-07-05','17:05:00',2.72),('8784','2013-07-05','17:10:00',2.7),('8784','2013-07-05','17:15:00',2.67),('8784','2013-07-05','17:20:00',2.61),('8784','2013-07-05','17:25:00',2.46),('8784','2013-07-05','17:30:00',2.42),('8784','2013-07-05','17:35:00',2.31),('8784','2013-07-05','17:40:00',2.18),('8784','2013-07-05','17:45:00',2.08),('8784','2013-07-05','17:50:00',1.98),('8784','2013-07-05','17:55:00',1.92),('8784','2013-07-05','18:00:00',1.91),('8784','2013-07-05','18:05:00',1.84),('8784','2013-07-05','18:10:00',1.61),('8784','2013-07-05','18:15:00',1.06),('8784','2013-07-05','18:20:00',1.3),('8784','2013-07-05','18:30:00',1.14),('8784','2013-07-05','18:35:00',1.23),('8784','2013-07-05','18:40:00',1.18),('8784','2013-07-05','18:45:00',1.12),('8784','2013-07-05','18:50:00',1.04),('8784','2013-07-04','08:55:00',1),('8784','2013-07-04','11:10:00',1.15),('8784','2013-07-04','11:15:00',1.19),('8784','2013-07-04','11:20:00',1.14),('8784','2013-07-04','11:25:00',1.21),('8784','2013-07-04','11:30:00',1.31),('8784','2013-07-04','11:35:00',1.51),('8784','2013-07-04','11:40:00',1.71),('8784','2013-07-04','11:45:00',1.83),('8784','2013-07-04','11:50:00',1.85),('8784','2013-07-04','11:55:00',1.68),('8784','2013-07-04','12:00:00',1.6),('8784','2013-07-04','12:05:00',2.12),('8784','2013-07-04','12:10:00',2.65),('8784','2013-07-04','12:15:00',2.74),('8784','2013-07-04','12:20:00',2.65),('8784','2013-07-04','12:25:00',3.5),('8784','2013-07-04','12:30:00',2.89),('8784','2013-07-04','12:35:00',2.45),('8784','2013-07-04','12:40:00',1.77),('8784','2013-07-04','12:45:00',1.42),('8784','2013-07-04','12:50:00',1.11),('8784','2013-07-04','12:55:00',1.01),('8784','2013-07-04','13:00:00',1.13),('8784','2013-07-04','13:05:00',1.36),('8784','2013-07-04','13:10:00',1.79),('8784','2013-07-04','13:15:00',2.08),('8784','2013-07-04','13:20:00',2.15),('8784','2013-07-04','13:25:00',2.98),('8784','2013-07-04','13:30:00',2.4),('8784','2013-07-04','13:35:00',2.55),('8784','2013-07-04','13:40:00',2.97),('8784','2013-07-04','13:45:00',4.28),('8784','2013-07-04','13:50:00',5.14),('8784','2013-07-04','13:55:00',3.7),('8784','2013-07-04','14:00:00',2.82),('8784','2013-07-04','14:05:00',2.51),('8784','2013-07-04','14:10:00',2.37),('8784','2013-07-04','14:15:00',2.44),('8784','2013-07-04','14:20:00',2.52),('8784','2013-07-04','14:25:00',2.16),('8784','2013-07-04','14:30:00',2.18),('8784','2013-07-04','14:35:00',2.3),('8784','2013-07-04','14:40:00',2.82),('8784','2013-07-04','14:45:00',3.53),('8784','2013-07-04','14:50:00',2.67),('8784','2013-07-04','14:55:00',2.33),('8784','2013-07-04','15:00:00',1.99),('8784','2013-07-04','15:05:00',2.3),('8784','2013-07-04','15:10:00',3.5),('8784','2013-07-04','15:15:00',3.46),('8784','2013-07-04','15:20:00',2.98),('8784','2013-07-04','15:25:00',2.55),('8784','2013-07-04','15:30:00',2.81),('8784','2013-07-04','15:35:00',2.63),('8784','2013-07-04','15:40:00',2.74),('8784','2013-07-04','15:45:00',3.71),('8784','2013-07-04','15:50:00',2.23),('8784','2013-07-04','15:55:00',2.34),('8784','2013-07-04','16:00:00',2.47),('8784','2013-07-04','16:05:00',2.48),('8784','2013-07-04','16:10:00',2),('8784','2013-07-04','16:15:00',1.92),('8784','2013-07-04','16:20:00',2.02),('8784','2013-07-04','16:25:00',2.28),('8784','2013-07-04','16:30:00',2.52),('8784','2013-07-04','16:35:00',2.43),('8784','2013-07-04','16:40:00',1.9),('8784','2013-07-04','16:45:00',1.77),('8784','2013-07-04','16:50:00',1.66),('8784','2013-07-04','16:55:00',1.59),('8784','2013-07-04','17:00:00',1.41),('8784','2013-07-04','17:05:00',1.38),('8784','2013-07-04','17:10:00',2.27),('8784','2013-07-04','17:15:00',2.71),('8784','2013-07-04','17:20:00',2.29),('8784','2013-07-04','17:25:00',2.9),('8784','2013-07-04','17:30:00',2.66),('8784','2013-07-04','17:35:00',2.11),('8784','2013-07-04','17:40:00',2.56),('8784','2013-07-04','17:45:00',2.4),('8784','2013-07-04','17:50:00',2.37),('8784','2013-07-04','17:55:00',2.23),('8784','2013-07-04','18:00:00',2.25),('8784','2013-07-04','18:05:00',2.14),('8784','2013-07-04','18:10:00',2.03),('8784','2013-07-04','18:15:00',2.02),('8784','2013-07-04','18:20:00',1.85),('8784','2013-07-04','18:25:00',1.48),('8784','2013-07-04','18:30:00',1.04),('8784','2013-07-03','07:20:00',1.06),('8784','2013-07-03','07:25:00',1.14),('8784','2013-07-03','07:30:00',1.21),('8784','2013-07-03','07:35:00',1.29),('8784','2013-07-03','07:40:00',1.37),('8784','2013-07-03','07:45:00',1.46),('8784','2013-07-03','07:50:00',1.53),('8784','2013-07-03','07:55:00',1.63),('8784','2013-07-03','08:00:00',1.71),('8784','2013-07-03','08:05:00',1.77),('8784','2013-07-03','08:10:00',1.86),('8784','2013-07-03','08:15:00',1.95),('8784','2013-07-03','08:20:00',2.04),('8784','2013-07-03','08:25:00',2.12),('8784','2013-07-03','08:30:00',2.2),('8784','2013-07-03','08:35:00',2.23),('8784','2013-07-03','08:40:00',2.32),('8784','2013-07-03','08:45:00',2.44),('8784','2013-07-03','08:50:00',2.5),('8784','2013-07-03','08:55:00',2.59),('8784','2013-07-03','09:00:00',2.64),('8784','2013-07-03','09:05:00',2.7),('8784','2013-07-03','09:10:00',2.76),('8784','2013-07-03','09:15:00',2.82),('8784','2013-07-03','09:20:00',2.88),('8784','2013-07-03','09:25:00',2.96),('8784','2013-07-03','09:30:00',3.05),('8784','2013-07-03','09:35:00',3.12),('8784','2013-07-03','09:40:00',3.17),('8784','2013-07-03','09:45:00',3.19),('8784','2013-07-03','09:50:00',3.2),('8784','2013-07-03','09:55:00',3.3),('8784','2013-07-03','10:00:00',3.37),('8784','2013-07-03','10:05:00',3.43),('8784','2013-07-03','10:10:00',3.43),('8784','2013-07-03','10:15:00',3.52),('8784','2013-07-03','10:20:00',3.53),('8784','2013-07-03','10:25:00',3.51),('8784','2013-07-03','10:30:00',3.56),('8784','2013-07-03','10:35:00',3.7),('8784','2013-07-03','10:40:00',3.72),('8784','2013-07-03','10:45:00',3.77),('8784','2013-07-03','10:50:00',3.77),('8784','2013-07-03','10:55:00',3.8),('8784','2013-07-03','11:00:00',3.9),('8784','2013-07-03','11:05:00',3.94),('8784','2013-07-03','11:10:00',4.01),('8784','2013-07-03','11:15:00',4.05),('8784','2013-07-03','11:20:00',4.07),('8784','2013-07-03','11:25:00',4.03),('8784','2013-07-03','11:30:00',4.06),('8784','2013-07-03','11:35:00',4.06),('8784','2013-07-03','11:40:00',4.19),('8784','2013-07-03','11:45:00',4.22),('8784','2013-07-03','11:50:00',4.2),('8784','2013-07-03','11:55:00',4.24),('8784','2013-07-03','12:00:00',4.28),('8784','2013-07-03','12:05:00',4.26),('8784','2013-07-03','12:10:00',4.29),('8784','2013-07-03','12:15:00',4.3),('8784','2013-07-03','12:20:00',4.33),('8784','2013-07-03','12:25:00',4.34),('8784','2013-07-03','12:30:00',4.41),('8784','2013-07-03','12:35:00',4.42),('8784','2013-07-03','12:40:00',4.41),('8784','2013-07-03','12:45:00',4.45),('8784','2013-07-03','12:50:00',4.47),('8784','2013-07-03','12:55:00',4.45),('8784','2013-07-03','13:00:00',4.49),('8784','2013-07-03','13:05:00',4.51),('8784','2013-07-03','13:10:00',4.5),('8784','2013-07-03','13:15:00',4.53),('8784','2013-07-03','13:20:00',4.47),('8784','2013-07-03','13:25:00',4.46),('8784','2013-07-03','13:30:00',4.47),('8784','2013-07-03','13:35:00',4.47),('8784','2013-07-03','13:40:00',4.48),('8784','2013-07-03','13:45:00',4.46),('8784','2013-07-03','13:50:00',4.42),('8784','2013-07-03','13:55:00',4.43),('8784','2013-07-03','14:00:00',4.41),('8784','2013-07-03','14:05:00',4.41),('8784','2013-07-03','14:10:00',4.37),('8784','2013-07-03','14:15:00',4.38),('8784','2013-07-03','14:20:00',4.36),('8784','2013-07-03','14:25:00',4.34),('8784','2013-07-03','14:30:00',4.34),('8784','2013-07-03','14:35:00',4.32),('8784','2013-07-03','14:40:00',4.25),('8784','2013-07-03','14:45:00',4.29),('8784','2013-07-03','14:50:00',4.25),('8784','2013-07-03','14:55:00',4.21),('8784','2013-07-03','15:00:00',4.2),('8784','2013-07-03','15:05:00',4.13),('8784','2013-07-03','15:10:00',4.11),('8784','2013-07-03','15:15:00',4.1),('8784','2013-07-03','15:20:00',4.06),('8784','2013-07-03','15:25:00',4),('8784','2013-07-03','15:30:00',3.96),('8784','2013-07-03','15:35:00',3.9),('8784','2013-07-03','15:40:00',3.86),('8784','2013-07-03','15:45:00',3.81),('8784','2013-07-03','15:50:00',3.76),('8784','2013-07-03','15:55:00',3.69),('8784','2013-07-03','16:00:00',3.63),('8784','2013-07-03','16:05:00',3.62),('8784','2013-07-03','16:10:00',3.56),('8784','2013-07-03','16:15:00',3.5),('8784','2013-07-03','16:20:00',3.44),('8784','2013-07-03','16:25:00',3.36),('8784','2013-07-03','16:30:00',3.34),('8784','2013-07-03','16:35:00',3.27),('8784','2013-07-03','16:40:00',3.21),('8784','2013-07-03','16:45:00',3.11),('8784','2013-07-03','16:50:00',3.06),('8784','2013-07-03','16:55:00',3),('8784','2013-07-03','17:00:00',2.93),('8784','2013-07-03','17:05:00',2.86),('8784','2013-07-03','17:10:00',2.79),('8784','2013-07-03','17:15:00',2.72),('8784','2013-07-03','17:20:00',2.65),('8784','2013-07-03','17:25:00',2.57),('8784','2013-07-03','17:30:00',2.5),('8784','2013-07-03','17:35:00',2.43),('8784','2013-07-03','17:40:00',2.34),('8784','2013-07-03','17:45:00',2.27),('8784','2013-07-03','17:50:00',2.18),('8784','2013-07-03','17:55:00',2.1),('8784','2013-07-03','18:00:00',2.02),('8784','2013-07-03','18:05:00',1.89),('8784','2013-07-03','18:10:00',1.82),('8784','2013-07-03','18:15:00',1.76),('8784','2013-07-03','18:20:00',1.67),('8784','2013-07-03','18:25:00',1.6),('8784','2013-07-03','18:30:00',1.51),('8784','2013-07-03','18:35:00',1.43),('8784','2013-07-03','18:40:00',1.34),('8784','2013-07-03','18:45:00',1.26),('8784','2013-07-03','18:50:00',1.17),('8784','2013-07-03','18:55:00',1.1),('8784','2013-07-03','19:00:00',1.02),('8784','2013-07-02','07:20:00',1.02),('8784','2013-07-02','07:25:00',1.1),('8784','2013-07-02','07:30:00',1.16),('8784','2013-07-02','07:35:00',1.25),('8784','2013-07-02','07:40:00',1.35),('8784','2013-07-02','07:45:00',1.41),('8784','2013-07-02','07:50:00',1.48),('8784','2013-07-02','07:55:00',1.59),('8784','2013-07-02','08:00:00',1.67),('8784','2013-07-02','08:05:00',1.76),('8784','2013-07-02','08:10:00',1.82),('8784','2013-07-02','08:15:00',1.93),('8784','2013-07-02','08:20:00',2.01),('8784','2013-07-02','08:25:00',2.1),('8784','2013-07-02','08:30:00',2.18),('8784','2013-07-02','08:35:00',2.26),('8784','2013-07-02','08:40:00',2.32),('8784','2013-07-02','08:45:00',2.39),('8784','2013-07-02','08:50:00',2.47),('8784','2013-07-02','08:55:00',2.54),('8784','2013-07-02','09:00:00',2.61),('8784','2013-07-02','09:05:00',2.67),('8784','2013-07-02','09:10:00',2.73),('8784','2013-07-02','09:15:00',2.77),('8784','2013-07-02','09:20:00',2.88),('8784','2013-07-02','09:25:00',2.93),('8784','2013-07-02','09:30:00',3),('8784','2013-07-02','09:35:00',3.05),('8784','2013-07-02','09:40:00',3.1),('8784','2013-07-02','09:45:00',3.19),('8784','2013-07-02','09:50:00',3.24),('8784','2013-07-02','09:55:00',3.29),('8784','2013-07-02','10:00:00',3.36),('8784','2013-07-02','10:05:00',3.41),('8784','2013-07-02','10:10:00',3.44),('8784','2013-07-02','10:15:00',3.48),('8784','2013-07-02','10:20:00',3.55),('8784','2013-07-02','10:25:00',3.58),('8784','2013-07-02','10:30:00',3.6),('8784','2013-07-02','10:35:00',3.61),('8784','2013-07-02','10:40:00',3.67),('8784','2013-07-02','10:45:00',3.71),('8784','2013-07-02','10:50:00',3.72),('8784','2013-07-02','10:55:00',3.78),('8784','2013-07-02','11:00:00',3.81),('8784','2013-07-02','11:05:00',3.81),('8784','2013-07-02','11:10:00',3.84),('8784','2013-07-02','11:15:00',3.86),('8784','2013-07-02','11:20:00',3.91),('8784','2013-07-02','11:25:00',3.96),('8784','2013-07-02','11:30:00',3.94),('8784','2013-07-02','11:35:00',3.96),('8784','2013-07-02','11:40:00',4),('8784','2013-07-02','11:45:00',4.02),('8784','2013-07-02','11:50:00',4.04),('8784','2013-07-02','11:55:00',4.04),('8784','2013-07-02','12:00:00',4.06),('8784','2013-07-02','12:05:00',4.18),('8784','2013-07-02','12:10:00',4.18),('8784','2013-07-02','12:15:00',4.18),('8784','2013-07-02','12:20:00',4.17),('8784','2013-07-02','12:25:00',4.18),('8784','2013-07-02','12:30:00',4.23),('8784','2013-07-02','12:35:00',4.4),('8784','2013-07-02','12:40:00',4.46),('8784','2013-07-02','12:45:00',4.52),('8784','2013-07-02','12:50:00',4.68),('8784','2013-07-02','12:55:00',3.99),('8784','2013-07-02','13:00:00',2.32),('8784','2013-07-02','13:05:00',4.85),('8784','2013-07-02','13:10:00',4.45),('8784','2013-07-02','13:15:00',3.71),('8784','2013-07-02','13:20:00',4.45),('8784','2013-07-02','13:25:00',4.37),('8784','2013-07-02','13:30:00',4.43),('8784','2013-07-02','13:35:00',4.43),('8784','2013-07-02','13:40:00',4.3),('8784','2013-07-02','13:45:00',4.28),('8784','2013-07-02','13:50:00',4.24),('8784','2013-07-02','13:55:00',4.24),('8784','2013-07-02','14:00:00',4.25),('8784','2013-07-02','14:05:00',4.25),('8784','2013-07-02','14:10:00',4.27),('8784','2013-07-02','14:15:00',4.3),('8784','2013-07-02','14:20:00',4.28),('8784','2013-07-02','14:25:00',4.24),('8784','2013-07-02','14:30:00',4.21),('8784','2013-07-02','14:35:00',4.2),('8784','2013-07-02','14:40:00',4.18),('8784','2013-07-02','14:45:00',4.14),('8784','2013-07-02','14:50:00',4.07),('8784','2013-07-02','14:55:00',4.08),('8784','2013-07-02','15:00:00',4.06),('8784','2013-07-02','15:05:00',4.05),('8784','2013-07-02','15:10:00',4.01),('8784','2013-07-02','15:15:00',3.97),('8784','2013-07-02','15:20:00',3.94),('8784','2013-07-02','15:25:00',3.91),('8784','2013-07-02','15:30:00',3.88),('8784','2013-07-02','15:35:00',3.84),('8784','2013-07-02','15:40:00',3.75),('8784','2013-07-02','15:45:00',3.72),('8784','2013-07-02','15:50:00',3.69),('8784','2013-07-02','15:55:00',3.64),('8784','2013-07-02','16:00:00',3.59),('8784','2013-07-02','16:05:00',3.56),('8784','2013-07-02','16:10:00',3.5),('8784','2013-07-02','16:15:00',3.41),('8784','2013-07-02','16:20:00',3.36),('8784','2013-07-02','16:25:00',3.31),('8784','2013-07-02','16:30:00',3.22),('8784','2013-07-02','16:35:00',3.17),('8784','2013-07-02','16:40:00',3.12),('8784','2013-07-02','16:45:00',3.05),('8784','2013-07-02','16:50:00',2.97),('8784','2013-07-02','16:55:00',2.93),('8784','2013-07-02','17:00:00',2.86),('8784','2013-07-02','17:05:00',2.78),('8784','2013-07-02','17:10:00',2.7),('8784','2013-07-02','17:15:00',2.64),('8784','2013-07-02','17:20:00',2.56),('8784','2013-07-02','17:25:00',2.46),('8784','2013-07-02','17:30:00',2.41),('8784','2013-07-02','17:35:00',2.33),('8784','2013-07-02','17:40:00',2.24),('8784','2013-07-02','17:45:00',2.15),('8784','2013-07-02','17:50:00',2.08),('8784','2013-07-02','17:55:00',2),('8784','2013-07-02','18:00:00',1.91),('8784','2013-07-02','18:05:00',1.83),('8784','2013-07-02','18:10:00',1.74),('8784','2013-07-02','18:15:00',1.68),('8784','2013-07-02','18:20:00',1.6),('8784','2013-07-02','18:25:00',1.51),('8784','2013-07-02','18:30:00',1.42),('8784','2013-07-02','18:35:00',1.35),('8784','2013-07-02','18:40:00',1.26),('8784','2013-07-02','18:45:00',1.18),('8784','2013-07-02','18:50:00',1.1),('8784','2013-07-02','18:55:00',1.04),('8784','2013-07-01','07:20:00',1.04),('8784','2013-07-01','07:25:00',1.11),('8784','2013-07-01','07:30:00',1.19),('8784','2013-07-01','07:35:00',1.28),('8784','2013-07-01','07:40:00',1.36),('8784','2013-07-01','07:45:00',1.44),('8784','2013-07-01','07:50:00',1.5),('8784','2013-07-01','07:55:00',1.62),('8784','2013-07-01','08:00:00',1.72),('8784','2013-07-01','08:05:00',1.79),('8784','2013-07-01','08:10:00',1.88),('8784','2013-07-01','08:15:00',1.97),('8784','2013-07-01','08:20:00',2.04),('8784','2013-07-01','08:25:00',2.13),('8784','2013-07-01','08:30:00',2.22),('8784','2013-07-01','08:35:00',2.26),('8784','2013-07-01','08:40:00',2.39),('8784','2013-07-01','08:45:00',2.46),('8784','2013-07-01','08:50:00',2.53),('8784','2013-07-01','08:55:00',2.6),('8784','2013-07-01','09:00:00',2.66),('8784','2013-07-01','09:05:00',2.73),('8784','2013-07-01','09:10:00',2.81),('8784','2013-07-01','09:15:00',2.88),('8784','2013-07-01','09:20:00',2.96),('8784','2013-07-01','09:25:00',3.03),('8784','2013-07-01','09:30:00',3.13),('8784','2013-07-01','09:35:00',3.18),('8784','2013-07-01','09:40:00',3.23),('8784','2013-07-01','09:45:00',3.28),('8784','2013-07-01','09:50:00',3.34),('8784','2013-07-01','09:55:00',3.37),('8784','2013-07-01','10:00:00',3.38),('8784','2013-07-01','10:05:00',3.4),('8784','2013-07-01','10:10:00',3.46),('8784','2013-07-01','10:15:00',3.55),('8784','2013-07-01','10:20:00',3.62),('8784','2013-07-01','10:25:00',3.66),('8784','2013-07-01','10:30:00',3.75),('8784','2013-07-01','10:35:00',3.8),('8784','2013-07-01','10:40:00',3.85),('8784','2013-07-01','10:45:00',3.91),('8784','2013-07-01','10:50:00',3.93),('8784','2013-07-01','10:55:00',3.94),('8784','2013-07-01','11:00:00',4.02),('8784','2013-07-01','11:05:00',4),('8784','2013-07-01','11:10:00',4.06),('8784','2013-07-01','11:15:00',4.13),('8784','2013-07-01','11:20:00',4.2),('8784','2013-07-01','11:25:00',4.24),('8784','2013-07-01','11:30:00',4.19),('8784','2013-07-01','11:35:00',4.2),('8784','2013-07-01','11:40:00',4.28),('8784','2013-07-01','11:45:00',4.31),('8784','2013-07-01','11:50:00',4.34),('8784','2013-07-01','11:55:00',4.31),('8784','2013-07-01','12:00:00',4.31),('8784','2013-07-01','12:05:00',4.3),('8784','2013-07-01','12:10:00',4.31),('8784','2013-07-01','12:15:00',4.33),('8784','2013-07-01','12:20:00',4.37),('8784','2013-07-01','12:25:00',4.36),('8784','2013-07-01','12:30:00',4.39),('8784','2013-07-01','12:35:00',4.41),('8784','2013-07-01','12:40:00',4.37),('8784','2013-07-01','12:45:00',4.36),('8784','2013-07-01','12:50:00',4.41),('8784','2013-07-01','12:55:00',4.42),('8784','2013-07-01','13:00:00',4.41),('8784','2013-07-01','13:05:00',4.43),('8784','2013-07-01','13:10:00',4.45),('8784','2013-07-01','13:15:00',4.44),('8784','2013-07-01','13:20:00',4.48),('8784','2013-07-01','13:25:00',4.48),('8784','2013-07-01','13:30:00',4.45),('8784','2013-07-01','13:35:00',4.46),('8784','2013-07-01','13:40:00',4.46),('8784','2013-07-01','13:45:00',4.4),('8784','2013-07-01','13:50:00',4.38),('8784','2013-07-01','13:55:00',4.34),('8784','2013-07-01','14:00:00',4.38),('8784','2013-07-01','14:05:00',4.42),('8784','2013-07-01','14:10:00',4.43),('8784','2013-07-01','14:15:00',4.36),('8784','2013-07-01','14:20:00',4.33),('8784','2013-07-01','14:25:00',4.26),('8784','2013-07-01','14:30:00',4.28),('8784','2013-07-01','14:35:00',4.24),('8784','2013-07-01','14:40:00',4.21),('8784','2013-07-01','14:45:00',4.17),('8784','2013-07-01','14:50:00',4.12),('8784','2013-07-01','14:55:00',4.08),('8784','2013-07-01','15:00:00',4.03),('8784','2013-07-01','15:05:00',4.01),('8784','2013-07-01','15:10:00',4),('8784','2013-07-01','15:15:00',3.97),('8784','2013-07-01','15:20:00',3.93),('8784','2013-07-01','15:25:00',3.89),('8784','2013-07-01','15:30:00',3.83),('8784','2013-07-01','15:35:00',3.76),('8784','2013-07-01','15:40:00',3.67),('8784','2013-07-01','15:45:00',3.71),('8784','2013-07-01','15:50:00',3.67),('8784','2013-07-01','15:55:00',3.59),('8784','2013-07-01','16:00:00',3.55),('8784','2013-07-01','16:05:00',3.5),('8784','2013-07-01','16:10:00',3.44),('8784','2013-07-01','16:15:00',3.35),('8784','2013-07-01','16:20:00',3.28),('8784','2013-07-01','16:25:00',3.22),('8784','2013-07-01','16:30:00',3.17),('8784','2013-07-01','16:35:00',3.11),('8784','2013-07-01','16:40:00',3.05),('8784','2013-07-01','16:45:00',3.02),('8784','2013-07-01','16:50:00',2.95),('8784','2013-07-01','16:55:00',2.91),('8784','2013-07-01','17:00:00',2.81),('8784','2013-07-01','17:05:00',2.77),('8784','2013-07-01','17:10:00',2.7),('8784','2013-07-01','17:15:00',2.62),('8784','2013-07-01','17:20:00',2.53),('8784','2013-07-01','17:25:00',2.44),('8784','2013-07-01','17:30:00',2.37),('8784','2013-07-01','17:35:00',2.29),('8784','2013-07-01','17:40:00',2.21),('8784','2013-07-01','17:45:00',2.14),('8784','2013-07-01','17:50:00',2.08),('8784','2013-07-01','17:55:00',2),('8784','2013-07-01','18:00:00',1.76),('8784','2013-07-01','18:05:00',1.81),('8784','2013-07-01','18:10:00',1.72),('8784','2013-07-01','18:15:00',1.39),('8784','2013-07-01','18:20:00',1.47),('8784','2013-07-01','18:25:00',1.56),('8784','2013-07-01','18:30:00',1.48),('8784','2013-07-01','18:35:00',1.37),('8784','2013-07-01','18:40:00',1.22),('8784','2013-07-01','18:45:00',1.17),('8784','2013-07-01','18:50:00',1.07),('8784','2014-04-05','09:15:00',1.23),('8784','2014-04-05','09:20:00',1.68),('8784','2014-04-05','09:25:00',2.11),('8784','2014-04-05','09:30:00',3.79),('8784','2014-04-05','09:35:00',3.73),('8784','2014-04-05','09:40:00',3.69),('8784','2014-04-05','09:45:00',3.44),('8784','2014-04-05','09:50:00',2.05),('8784','2014-04-05','09:55:00',1.69),('8784','2014-04-05','10:00:00',2.12),('8784','2014-04-05','10:05:00',2.16),('8784','2014-04-05','10:10:00',2.48),('8784','2014-04-05','10:15:00',1.81),('8784','2014-04-05','10:20:00',2.38),('8784','2014-04-05','10:25:00',2.68),('8784','2014-04-05','10:30:00',2.62),('8784','2014-04-05','10:35:00',2.83),('8784','2014-04-05','10:40:00',3.19),('8784','2014-04-05','10:45:00',3.4),('8784','2014-04-05','10:50:00',2.71),('8784','2014-04-05','10:55:00',2.95),('8784','2014-04-05','11:00:00',3.36),('8784','2014-04-05','11:05:00',3.5),('8784','2014-04-05','11:10:00',3.98),('8784','2014-04-05','11:15:00',4.07),('8784','2014-04-05','11:20:00',4.35),('8784','2014-04-05','11:25:00',3.88),('8784','2014-04-05','11:30:00',2.63),('8784','2014-04-05','11:35:00',2.25),('8784','2014-04-05','11:40:00',3.03),('8784','2014-04-05','11:45:00',3.99),('8784','2014-04-05','11:50:00',4.17),('8784','2014-04-05','11:55:00',4.09),('8784','2014-04-05','12:00:00',4.15),('8784','2014-04-05','12:05:00',3.2),('8784','2014-04-05','12:10:00',3.05),('8784','2014-04-05','12:15:00',3.54),('8784','2014-04-05','12:20:00',3.26),('8784','2014-04-05','12:25:00',3.77),('8784','2014-04-05','12:30:00',2.9),('8784','2014-04-05','12:35:00',2.44),('8784','2014-04-05','12:40:00',3.25),('8784','2014-04-05','12:45:00',4.67),('8784','2014-04-05','12:50:00',4.41),('8784','2014-04-05','12:55:00',4.56),('8784','2014-04-05','13:00:00',3.74),('8784','2014-04-05','13:05:00',3.04),('8784','2014-04-05','13:10:00',2.81),('8784','2014-04-05','13:15:00',1.98),('8784','2014-04-05','13:20:00',2.91),('8784','2014-04-05','13:25:00',4.62),('8784','2014-04-05','13:30:00',4),('8784','2014-04-05','13:35:00',4.33),('8784','2014-04-05','13:40:00',3.05),('8784','2014-04-05','13:45:00',4.28),('8784','2014-04-05','13:50:00',4.75),('8784','2014-04-05','13:55:00',3.61),('8784','2014-04-05','14:00:00',3.82),('8784','2014-04-05','14:05:00',4.98),('8784','2014-04-05','14:10:00',3.28),('8784','2014-04-05','14:25:00',1.34),('8784','2014-04-05','14:30:00',1.88),('8784','2014-04-05','14:35:00',1.26),('8784','2014-04-05','14:55:00',3.86),('8784','2014-04-05','15:00:00',4.19),('8784','2014-04-05','15:05:00',3.51),('8784','2014-04-05','15:10:00',3.2),('8784','2014-04-05','15:15:00',1.9),('8784','2014-04-05','15:20:00',3.89),('8784','2014-04-05','15:25:00',2.58),('8784','2014-04-05','15:30:00',1.61),('8784','2014-04-05','15:35:00',1.6),('8784','2014-04-05','15:40:00',1.97),('8784','2014-04-05','15:45:00',2.14),('8784','2014-04-05','15:50:00',2.5),('8784','2014-04-05','15:55:00',1.41),('8784','2014-04-05','16:00:00',1.37),('8784','2014-04-05','16:05:00',1.36),('8784','2014-04-05','16:10:00',1.32),('8784','2014-04-05','16:15:00',1.87),('8784','2014-04-05','16:20:00',4),('8784','2014-04-05','16:25:00',2.69),('8784','2014-04-05','16:30:00',2.1),('8784','2014-04-05','16:35:00',2.88),('8784','2014-04-05','16:40:00',1.61),('8784','2014-04-05','16:45:00',2.42),('8784','2014-04-05','16:50:00',1.59),('8784','2014-04-05','16:55:00',2.57),('8784','2014-04-05','17:00:00',1.54),('8784','2014-04-05','17:05:00',2.06),('8784','2014-04-05','17:10:00',1.74),('8784','2014-04-05','17:20:00',1.27),('8784','2014-04-05','17:25:00',1.27),('8784','2014-04-05','17:30:00',1.34),('8784','2014-04-05','17:35:00',1.13),('8784','2014-04-05','17:40:00',1),('8784','2014-04-05','17:50:00',1.17),('8784','2014-04-05','17:55:00',1.17),('8784','2014-04-05','18:00:00',1.11),('8784','2014-04-05','18:05:00',1.06),('8784','2014-04-05','18:10:00',1.01),('8784','2014-04-05','18:15:00',1.04),('8784','2013-06-30','07:15:00',1.05),('8784','2013-06-30','07:20:00',1.13),('8784','2013-06-30','07:25:00',1.21),('8784','2013-06-30','07:30:00',1.29),('8784','2013-06-30','07:35:00',1.37),('8784','2013-06-30','07:40:00',1.47),('8784','2013-06-30','07:45:00',1.54),('8784','2013-06-30','07:50:00',1.63),('8784','2013-06-30','07:55:00',1.72),('8784','2013-06-30','08:00:00',1.8),('8784','2013-06-30','08:05:00',1.89),('8784','2013-06-30','08:10:00',1.97),('8784','2013-06-30','08:15:00',2.05),('8784','2013-06-30','08:20:00',2.14),('8784','2013-06-30','08:25:00',2.23),('8784','2013-06-30','08:30:00',2.31),('8784','2013-06-30','08:35:00',2.39),('8784','2013-06-30','08:40:00',2.47),('8784','2013-06-30','08:45:00',2.55),('8784','2013-06-30','08:50:00',2.61),('8784','2013-06-30','08:55:00',2.7),('8784','2013-06-30','09:00:00',2.77),('8784','2013-06-30','09:05:00',2.84),('8784','2013-06-30','09:10:00',2.91),('8784','2013-06-30','09:15:00',2.98),('8784','2013-06-30','09:20:00',3.04),('8784','2013-06-30','09:25:00',3.08),('8784','2013-06-30','09:30:00',3.13),('8784','2013-06-30','09:35:00',3.2),('8784','2013-06-30','09:40:00',3.29),('8784','2013-06-30','09:45:00',3.39),('8784','2013-06-30','09:50:00',3.44),('8784','2013-06-30','09:55:00',3.49),('8784','2013-06-30','10:00:00',3.54),('8784','2013-06-30','10:05:00',3.6),('8784','2013-06-30','10:10:00',3.66),('8784','2013-06-30','10:15:00',3.71),('8784','2013-06-30','10:20:00',3.76),('8784','2013-06-30','10:25:00',3.8),('8784','2013-06-30','10:30:00',3.83),('8784','2013-06-30','10:35:00',3.85),('8784','2013-06-30','10:40:00',3.93),('8784','2013-06-30','10:45:00',3.96),('8784','2013-06-30','10:50:00',4),('8784','2013-06-30','10:55:00',4.03),('8784','2013-06-30','11:00:00',4.07),('8784','2013-06-30','11:05:00',4.13),('8784','2013-06-30','11:10:00',4.14),('8784','2013-06-30','11:15:00',4.15),('8784','2013-06-30','11:20:00',4.17),('8784','2013-06-30','11:25:00',4.2),('8784','2013-06-30','11:30:00',4.23),('8784','2013-06-30','11:35:00',4.24),('8784','2013-06-30','11:40:00',4.27),('8784','2013-06-30','11:45:00',4.31),('8784','2013-06-30','11:50:00',4.29),('8784','2013-06-30','11:55:00',4.34),('8784','2013-06-30','12:00:00',4.35),('8784','2013-06-30','12:05:00',4.37),('8784','2013-06-30','12:10:00',4.42),('8784','2013-06-30','12:15:00',4.44),('8784','2013-06-30','12:20:00',4.44),('8784','2013-06-30','12:25:00',4.43),('8784','2013-06-30','12:30:00',4.45),('8784','2013-06-30','12:35:00',4.48),('8784','2013-06-30','12:40:00',4.49),('8784','2013-06-30','12:45:00',4.45),('8784','2013-06-30','12:50:00',4.52),('8784','2013-06-30','12:55:00',4.56),('8784','2013-06-30','13:00:00',4.55),('8784','2013-06-30','13:05:00',4.52),('8784','2013-06-30','13:10:00',4.49),('8784','2013-06-30','13:15:00',4.54),('8784','2013-06-30','13:20:00',4.52),('8784','2013-06-30','13:25:00',4.57),('8784','2013-06-30','13:30:00',4.56),('8784','2013-06-30','13:35:00',4.54),('8784','2013-06-30','13:40:00',4.24),('8784','2013-06-30','13:45:00',4.19),('8784','2013-06-30','13:50:00',4.61),('8784','2013-06-30','13:55:00',4.42),('8784','2013-06-30','14:00:00',4.32),('8784','2013-06-30','14:05:00',4.51),('8784','2013-06-30','14:10:00',4.48),('8784','2013-06-30','14:15:00',4.38),('8784','2013-06-30','14:20:00',4.4),('8784','2013-06-30','14:25:00',4.37),('8784','2013-06-30','14:30:00',4.27),('8784','2013-06-30','14:35:00',4.24),('8784','2013-06-30','14:40:00',4.26),('8784','2013-06-30','14:45:00',4.27),('8784','2013-06-30','14:50:00',4.2),('8784','2013-06-30','14:55:00',4.18),('8784','2013-06-30','15:00:00',4.14),('8784','2013-06-30','15:05:00',4.06),('8784','2013-06-30','15:10:00',4.06),('8784','2013-06-30','15:15:00',4.01),('8784','2013-06-30','15:20:00',4.05),('8784','2013-06-30','15:25:00',4.01),('8784','2013-06-30','15:30:00',3.98),('8784','2013-06-30','15:35:00',3.94),('8784','2013-06-30','15:40:00',3.92),('8784','2013-06-30','15:45:00',3.87),('8784','2013-06-30','15:50:00',3.84),('8784','2013-06-30','15:55:00',3.75),('8784','2013-06-30','16:00:00',3.71),('8784','2013-06-30','16:05:00',3.66),('8784','2013-06-30','16:10:00',3.65),('8784','2013-06-30','16:15:00',3.59),('8784','2013-06-30','16:20:00',3.6),('8784','2013-06-30','16:25:00',3.62),('8784','2013-06-30','16:30:00',3.49),('8784','2013-06-30','16:35:00',3.41),('8784','2013-06-30','16:40:00',3.16),('8784','2013-06-30','16:45:00',3.14),('8784','2013-06-30','16:50:00',3.08),('8784','2013-06-30','16:55:00',2.98),('8784','2013-06-30','17:00:00',2.87),('8784','2013-06-30','17:05:00',2.79),('8784','2013-06-30','17:10:00',2.76),('8784','2013-06-30','17:15:00',2.67),('8784','2013-06-30','17:20:00',2.58),('8784','2013-06-30','17:25:00',2.49),('8784','2013-06-30','17:30:00',2.4),('8784','2013-06-30','17:35:00',2.32),('8784','2013-06-30','17:40:00',2.27),('8784','2013-06-30','17:45:00',2.17),('8784','2013-06-30','17:50:00',2.1),('8784','2013-06-30','17:55:00',2),('8784','2013-06-30','18:00:00',1.89),('8784','2013-06-30','18:05:00',1.75),('8784','2013-06-30','18:10:00',1.75),('8784','2013-06-30','18:15:00',1.68),('8784','2013-06-30','18:20:00',1.6),('8784','2013-06-30','18:25:00',1.52),('8784','2013-06-30','18:30:00',1.43),('8784','2013-06-30','18:35:00',1.35),('8784','2013-06-30','18:40:00',1.28),('8784','2013-06-30','18:45:00',1.19),('8784','2013-06-30','18:50:00',1.12),('8784','2013-06-30','18:55:00',1.05),('8784','2013-06-29','07:30:00',1.51),('8784','2013-06-29','07:35:00',1.77),('8784','2013-06-29','07:40:00',1.82),('8784','2013-06-29','07:45:00',1.83),('8784','2013-06-29','07:50:00',1.94),('8784','2013-06-29','07:55:00',2.15),('8784','2013-06-29','08:00:00',2.3),('8784','2013-06-29','08:05:00',2.52),('8784','2013-06-29','08:10:00',2.56),('8784','2013-06-29','08:15:00',2.06),('8784','2013-06-29','08:20:00',1.44),('8784','2013-06-29','08:25:00',2.32),('8784','2013-06-29','08:30:00',2.41),('8784','2013-06-29','08:35:00',2.5),('8784','2013-06-29','08:40:00',1.42),('8784','2013-06-29','08:45:00',2.45),('8784','2013-06-29','08:50:00',2.63),('8784','2013-06-29','08:55:00',2.69),('8784','2013-06-29','09:00:00',2.74),('8784','2013-06-29','09:05:00',2.8),('8784','2013-06-29','09:10:00',2.87),('8784','2013-06-29','09:15:00',2.93),('8784','2013-06-29','09:20:00',3),('8784','2013-06-29','09:25:00',3.05),('8784','2013-06-29','09:30:00',3.08),('8784','2013-06-29','09:35:00',3.16),('8784','2013-06-29','09:40:00',3.26),('8784','2013-06-29','09:45:00',3.35),('8784','2013-06-29','09:50:00',3.38),('8784','2013-06-29','09:55:00',3.42),('8784','2013-06-29','10:00:00',3.49),('8784','2013-06-29','10:05:00',3.55),('8784','2013-06-29','10:10:00',3.62),('8784','2013-06-29','10:15:00',3.66),('8784','2013-06-29','10:20:00',3.7),('8784','2013-06-29','10:25:00',3.77),('8784','2013-06-29','10:30:00',3.79),('8784','2013-06-29','10:35:00',3.83),('8784','2013-06-29','10:40:00',3.91),('8784','2013-06-29','10:45:00',3.81),('8784','2013-06-29','10:50:00',1.69),('8784','2013-06-29','10:55:00',2.91),('8784','2013-06-29','11:00:00',4.04),('8784','2013-06-29','11:05:00',4.19),('8784','2013-06-29','11:10:00',4.29),('8784','2013-06-29','11:15:00',4.4),('8784','2013-06-29','11:20:00',4.58),('8784','2013-06-29','11:25:00',4.67),('8784','2013-06-29','11:30:00',3.87),('8784','2013-06-29','11:35:00',3.42),('8784','2013-06-29','11:40:00',3.44),('8784','2013-06-29','11:45:00',4.98),('8784','2013-06-29','11:50:00',4.77),('8784','2013-06-29','11:55:00',4.26),('8784','2013-06-29','12:00:00',3.8),('8784','2013-06-29','12:05:00',3.81),('8784','2013-06-29','12:10:00',4.73),('8784','2013-06-29','12:15:00',4.77),('8784','2013-06-29','12:20:00',2.1),('8784','2013-06-29','12:25:00',4.4),('8784','2013-06-29','12:30:00',4.89),('8784','2013-06-29','12:35:00',3.52),('8784','2013-06-29','12:40:00',2.92),('8784','2013-06-29','12:45:00',5.23),('8784','2013-06-29','12:50:00',3.37),('8784','2013-06-29','12:55:00',5.15),('8784','2013-06-29','13:00:00',3.4),('8784','2013-06-29','13:05:00',4.7),('8784','2013-06-29','13:10:00',3.65),('8784','2013-06-29','13:15:00',3.95),('8784','2013-06-29','13:20:00',2.21),('8784','2013-06-29','13:25:00',3.63),('8784','2013-06-29','13:30:00',1.2),('8784','2013-06-29','13:40:00',1.07),('8784','2013-06-29','13:45:00',1.78),('8784','2013-06-29','13:50:00',1.93),('8784','2013-06-29','13:55:00',3.86),('8784','2013-06-29','14:00:00',4.71),('8784','2013-06-29','14:05:00',5.21),('8784','2013-06-29','14:10:00',4.92),('8784','2013-06-29','14:15:00',5.04),('8784','2013-06-29','14:20:00',4.95),('8784','2013-06-29','14:25:00',5.06),('8784','2013-06-29','14:30:00',4.89),('8784','2013-06-29','14:35:00',4.82),('8784','2013-06-29','14:40:00',4.83),('8784','2013-06-29','14:45:00',4.9),('8784','2013-06-29','14:50:00',5.11),('8784','2013-06-29','14:55:00',2.7),('8784','2013-06-29','15:00:00',4.05),('8784','2013-06-29','15:05:00',5.25),('8784','2013-06-29','15:10:00',2.64),('8784','2013-06-29','15:15:00',2.4),('8784','2013-06-29','15:20:00',1.49),('8784','2013-06-29','15:25:00',1.12),('8784','2013-06-29','16:35:00',1.02),('8784','2013-06-29','16:40:00',1.37),('8784','2013-06-29','16:45:00',1.7),('8784','2013-06-29','16:50:00',2.67),('8784','2013-06-29','16:55:00',1.41),('8784','2013-06-29','17:00:00',1.25),('8784','2013-06-29','17:05:00',1.61),('8784','2013-06-29','17:10:00',1.24),('8784','2013-06-29','17:15:00',1.17),('8784','2013-06-29','17:20:00',1.41),('8784','2013-06-29','17:25:00',1.65),('8784','2013-06-29','17:30:00',2.82),('8784','2013-06-29','17:35:00',2.06),('8784','2013-06-29','17:40:00',1.16),('8784','2013-06-29','17:45:00',2.22),('8784','2013-06-29','17:50:00',2.17),('8784','2013-06-29','17:55:00',2.09),('8784','2013-06-29','18:00:00',1.96),('8784','2013-06-29','18:05:00',1.88),('8784','2013-06-29','18:15:00',1.66),('8784','2013-06-29','18:20:00',1.65),('8784','2013-06-29','18:25:00',1.37),('8784','2013-06-29','18:35:00',1.35),('8784','2013-06-29','18:40:00',1.36),('8784','2013-06-28','07:10:00',1.09),('8784','2013-06-28','07:15:00',1.08),('8784','2013-06-28','07:20:00',1.11),('8784','2013-06-28','07:25:00',1.19),('8784','2013-06-28','07:30:00',1.28),('8784','2013-06-28','07:35:00',1.34),('8784','2013-06-28','07:40:00',1.34),('8784','2013-06-28','07:45:00',1.57),('8784','2013-06-28','07:50:00',1.61),('8784','2013-06-28','07:55:00',1.69),('8784','2013-06-28','08:00:00',1.73),('8784','2013-06-28','08:05:00',1.67),('8784','2013-06-28','08:10:00',1.74),('8784','2013-06-28','08:15:00',1.95),('8784','2013-06-28','08:20:00',1.99),('8784','2013-06-28','08:25:00',1.99),('8784','2013-06-28','08:30:00',2.2),('8784','2013-06-28','08:35:00',2.29),('8784','2013-06-28','08:40:00',2.35),('8784','2013-06-28','08:45:00',2.46),('8784','2013-06-28','08:50:00',2.51),('8784','2013-06-28','08:55:00',2.64),('8784','2013-06-28','09:00:00',2.7),('8784','2013-06-28','09:05:00',2.74),('8784','2013-06-28','09:10:00',2.85),('8784','2013-06-28','09:15:00',2.16),('8784','2013-06-28','09:20:00',1.18),('8784','2013-06-28','09:25:00',1.52),('8784','2013-06-28','09:30:00',3.19),('8784','2013-06-28','09:35:00',3.33),('8784','2013-06-28','09:40:00',3.48),('8784','2013-06-28','09:45:00',3.59),('8784','2013-06-28','09:50:00',3.51),('8784','2013-06-28','09:55:00',3.62),('8784','2013-06-28','10:05:00',2.3),('8784','2013-06-28','10:10:00',3.93),('8784','2013-06-28','10:15:00',4.06),('8784','2013-06-28','10:20:00',1.57),('8784','2013-06-28','10:25:00',1.44),('8784','2013-06-28','10:30:00',3.18),('8784','2013-06-28','10:35:00',4.82),('8784','2013-06-28','10:40:00',3.97),('8784','2013-06-28','10:45:00',4.38),('8784','2013-06-28','10:50:00',1.72),('8784','2013-06-28','10:55:00',2.18),('8784','2013-06-28','11:00:00',2.89),('8784','2013-06-28','11:05:00',2.2),('8784','2013-06-28','11:10:00',1.78),('8784','2013-06-28','11:15:00',2.01),('8784','2013-06-28','11:20:00',1.41),('8784','2013-06-28','11:25:00',3.63),('8784','2013-06-28','11:30:00',4.74),('8784','2013-06-28','11:35:00',3.87),('8784','2013-06-28','11:40:00',3.54),('8784','2013-06-28','11:45:00',3.47),('8784','2013-06-28','11:50:00',4.55),('8784','2013-06-28','11:55:00',3),('8784','2013-06-28','12:00:00',2.39),('8784','2013-06-28','12:05:00',3.24),('8784','2013-06-28','12:10:00',5.17),('8784','2013-06-28','12:15:00',4.85),('8784','2013-06-28','12:20:00',4.65),('8784','2013-06-28','12:25:00',4.79),('8784','2013-06-28','12:30:00',4.57),('8784','2013-06-28','12:35:00',3.86),('8784','2013-06-28','12:40:00',2.66),('8784','2013-06-28','12:45:00',4.81),('8784','2013-06-28','12:50:00',4.77),('8784','2013-06-28','12:55:00',4.63),('8784','2013-06-28','13:00:00',4.7),('8784','2013-06-28','13:05:00',4.73),('8784','2013-06-28','13:10:00',4.88),('8784','2013-06-28','13:15:00',4.56),('8784','2013-06-28','13:20:00',3.55),('8784','2013-06-28','13:25:00',4.64),('8784','2013-06-28','13:30:00',4.66),('8784','2013-06-28','13:35:00',4.72),('8784','2013-06-28','13:40:00',4.19),('8784','2013-06-28','13:45:00',4.59),('8784','2013-06-28','13:50:00',4.51),('8784','2013-06-28','13:55:00',4.74),('8784','2013-06-28','14:00:00',3.93),('8784','2013-06-28','14:05:00',4.48),('8784','2013-06-28','14:10:00',3.97),('8784','2013-06-28','14:15:00',4.39),('8784','2013-06-28','14:20:00',4.7),('8784','2013-06-28','14:25:00',2.72),('8784','2013-06-28','14:30:00',3.44),('8784','2013-06-28','14:35:00',4.28),('8784','2013-06-28','14:40:00',3.97),('8784','2013-06-28','14:45:00',4.75),('8784','2013-06-28','14:50:00',4.43),('8784','2013-06-28','14:55:00',4.24),('8784','2013-06-28','15:00:00',3.83),('8784','2013-06-28','15:05:00',4.28),('8784','2013-06-28','15:10:00',4.38),('8784','2013-06-28','15:15:00',4.29),('8784','2013-06-28','15:20:00',4.44),('8784','2013-06-28','15:25:00',4.36),('8784','2013-06-28','15:30:00',2.46),('8784','2013-06-28','15:35:00',3.91),('8784','2013-06-28','15:40:00',2.39),('8784','2013-06-28','15:45:00',3.52),('8784','2013-06-28','15:50:00',4.17),('8784','2013-06-28','15:55:00',3.3),('8784','2013-06-28','16:00:00',3.86),('8784','2013-06-28','16:05:00',3.53),('8784','2013-06-28','16:10:00',1.73),('8784','2013-06-28','16:15:00',3.18),('8784','2013-06-28','16:20:00',3.61),('8784','2013-06-28','16:25:00',2.05),('8784','2013-06-28','16:30:00',3.07),('8784','2013-06-28','16:35:00',1.01),('8784','2013-06-28','16:40:00',1.9),('8784','2013-06-28','16:45:00',1.63),('8784','2013-06-28','16:50:00',3.35),('8784','2013-06-28','16:55:00',3.01),('8784','2013-06-28','17:00:00',3.08),('8784','2013-06-28','17:05:00',2.53),('8784','2013-06-28','17:10:00',2.76),('8784','2013-06-28','17:15:00',2.69),('8784','2013-06-28','17:20:00',2.58),('8784','2013-06-28','17:25:00',2.57),('8784','2013-06-28','17:30:00',2.46),('8784','2013-06-28','17:35:00',2.38),('8784','2013-06-28','17:40:00',2.26),('8784','2013-06-28','17:45:00',2.22),('8784','2013-06-28','17:50:00',2.14),('8784','2013-06-28','17:55:00',2.07),('8784','2013-06-28','18:00:00',2),('8784','2013-06-28','18:05:00',1.9),('8784','2013-06-28','18:10:00',1.81),('8784','2013-06-28','18:15:00',1.75),('8784','2013-06-28','18:20:00',1.68),('8784','2013-06-28','18:25:00',1.6),('8784','2013-06-28','18:30:00',1.27),('8784','2013-06-28','18:40:00',1.29),('8784','2013-06-28','18:50:00',1.14),('8784','2013-06-27','07:25:00',1.07),('8784','2013-06-27','07:30:00',1.24),('8784','2013-06-27','07:35:00',1.32),('8784','2013-06-27','07:40:00',1.41),('8784','2013-06-27','07:45:00',1.5),('8784','2013-06-27','07:50:00',1.62),('8784','2013-06-27','07:55:00',1.68),('8784','2013-06-27','08:00:00',1.77),('8784','2013-06-27','08:05:00',1.87),('8784','2013-06-27','08:10:00',1.93),('8784','2013-06-27','08:15:00',2.02),('8784','2013-06-27','08:20:00',2.11),('8784','2013-06-27','08:25:00',2.17),('8784','2013-06-27','08:30:00',2.25),('8784','2013-06-27','08:35:00',2.3),('8784','2013-06-27','08:40:00',2.38),('8784','2013-06-27','08:45:00',2.48),('8784','2013-06-27','08:50:00',2.56),('8784','2013-06-27','08:55:00',2.65),('8784','2013-06-27','09:00:00',2.74),('8784','2013-06-27','09:05:00',2.79),('8784','2013-06-27','09:10:00',2.88),('8784','2013-06-27','09:15:00',2.92),('8784','2013-06-27','09:20:00',3.05),('8784','2013-06-27','09:25:00',3.1),('8784','2013-06-27','09:30:00',3.11),('8784','2013-06-27','09:35:00',3.15),('8784','2013-06-27','09:40:00',3.24),('8784','2013-06-27','09:45:00',3.28),('8784','2013-06-27','09:50:00',3.44),('8784','2013-06-27','09:55:00',3.38),('8784','2013-06-27','10:00:00',3.42),('8784','2013-06-27','10:05:00',3.86),('8784','2013-06-27','10:10:00',3.82),('8784','2013-06-27','10:15:00',2.89),('8784','2013-06-27','10:20:00',2.09),('8784','2013-06-27','10:25:00',3.84),('8784','2013-06-27','10:30:00',3.91),('8784','2013-06-27','10:35:00',4.03),('8784','2013-06-27','10:40:00',4.24),('8784','2013-06-27','10:45:00',4.27),('8784','2013-06-27','10:50:00',3.78),('8784','2013-06-27','10:55:00',4.24),('8784','2013-06-27','11:00:00',4.23),('8784','2013-06-27','11:05:00',4.3),('8784','2013-06-27','11:10:00',4.37),('8784','2013-06-27','11:15:00',4.42),('8784','2013-06-27','11:20:00',4.41),('8784','2013-06-27','11:25:00',4.46),('8784','2013-06-27','11:30:00',4.42),('8784','2013-06-27','11:35:00',4.46),('8784','2013-06-27','11:40:00',4.65),('8784','2013-06-27','11:45:00',4.67),('8784','2013-06-27','11:50:00',2.37),('8784','2013-06-27','11:55:00',1.45),('8784','2013-06-27','12:00:00',1.46),('8784','2013-06-27','12:05:00',1.35),('8784','2013-06-27','12:10:00',1.32),('8784','2013-06-27','12:15:00',1.14),('8784','2013-06-27','12:20:00',1.22),('8784','2013-06-27','12:25:00',2.02),('8784','2013-06-27','12:30:00',1.74),('8784','2013-06-27','12:35:00',3.4),('8784','2013-06-27','12:40:00',1.86),('8784','2013-06-27','12:45:00',1.77),('8784','2013-06-27','12:50:00',1.45),('8784','2013-06-27','12:55:00',1.26),('8784','2013-06-27','13:00:00',1.06),('8784','2013-06-27','13:05:00',1.22),('8784','2013-06-27','13:10:00',1.49),('8784','2013-06-27','13:15:00',1.8),('8784','2013-06-27','13:20:00',1.62),('8784','2013-06-27','13:25:00',1.72),('8784','2013-06-27','13:30:00',1.55),('8784','2013-06-27','13:35:00',1.47),('8784','2013-06-27','13:40:00',1.36),('8784','2013-06-27','13:45:00',1.41),('8784','2013-06-27','13:50:00',1.67),('8784','2013-06-27','13:55:00',1.46),('8784','2013-06-27','14:00:00',1.48),('8784','2013-06-27','14:05:00',1.46),('8784','2013-06-27','14:10:00',2.19),('8784','2013-06-27','14:15:00',2.75),('8784','2013-06-27','14:20:00',3.84),('8784','2013-06-27','14:25:00',3.22),('8784','2013-06-27','14:30:00',3.31),('8784','2013-06-27','14:35:00',2.31),('8784','2013-06-27','14:40:00',3.97),('8784','2013-06-27','14:45:00',1.58),('8784','2013-06-27','14:50:00',2.4),('8784','2013-06-27','14:55:00',4.12),('8784','2013-06-27','15:00:00',4.18),('8784','2013-06-27','15:05:00',4.08),('8784','2013-06-27','15:10:00',4.05),('8784','2013-06-27','15:15:00',3.99),('8784','2013-06-27','15:20:00',3.94),('8784','2013-06-27','15:25:00',3.91),('8784','2013-06-27','15:30:00',3.9),('8784','2013-06-27','15:35:00',3.87),('8784','2013-06-27','15:40:00',3.76),('8784','2013-06-27','15:45:00',3.76),('8784','2013-06-27','15:50:00',3.72),('8784','2013-06-27','15:55:00',3.5),('8784','2013-06-27','16:00:00',3.56),('8784','2013-06-27','16:05:00',3.47),('8784','2013-06-27','16:10:00',3.45),('8784','2013-06-27','16:15:00',3.42),('8784','2013-06-27','16:20:00',3.36),('8784','2013-06-27','16:25:00',3.32),('8784','2013-06-27','16:30:00',3.26),('8784','2013-06-27','16:35:00',3.02),('8784','2013-06-27','16:40:00',3.08),('8784','2013-06-27','16:45:00',3.08),('8784','2013-06-27','16:50:00',2.97),('8784','2013-06-27','16:55:00',2.9),('8784','2013-06-27','17:00:00',2.85),('8784','2013-06-27','17:05:00',2.76),('8784','2013-06-27','17:10:00',2.61),('8784','2013-06-27','17:15:00',2.53),('8784','2013-06-27','17:20:00',2.6),('8784','2013-06-27','17:25:00',2.52),('8784','2013-06-27','17:30:00',2.47),('8784','2013-06-27','17:35:00',2.38),('8784','2013-06-27','17:40:00',1.69),('8784','2013-06-27','17:45:00',1.19),('8784','2013-06-27','17:50:00',1.98),('8784','2013-06-27','17:55:00',2),('8784','2013-06-27','18:00:00',1.89),('8784','2013-06-27','18:05:00',1.81),('8784','2013-06-27','18:10:00',1.72),('8784','2013-06-27','18:15:00',1.61),('8784','2013-06-27','18:20:00',1.54),('8784','2013-06-27','18:25:00',1.55),('8784','2013-06-27','18:30:00',1.46),('8784','2013-06-27','18:35:00',1.35),('8784','2013-06-27','18:40:00',1.18),('8784','2013-06-27','18:45:00',1.09),('8784','2013-06-27','18:50:00',1.07),('8784','2013-06-27','18:55:00',1.02),('8784','2013-06-26','07:15:00',1.04),('8784','2013-06-26','07:20:00',1.11),('8784','2013-06-26','07:25:00',1.19),('8784','2013-06-26','07:30:00',1.27),('8784','2013-06-26','07:35:00',1.36),('8784','2013-06-26','07:40:00',1.45),('8784','2013-06-26','07:45:00',1.54),('8784','2013-06-26','07:50:00',1.65),('8784','2013-06-26','07:55:00',1.69),('8784','2013-06-26','08:00:00',1.75),('8784','2013-06-26','08:05:00',1.85),('8784','2013-06-26','08:10:00',1.95),('8784','2013-06-26','08:15:00',2.02),('8784','2013-06-26','08:20:00',2.09),('8784','2013-06-26','08:25:00',2.17),('8784','2013-06-26','08:30:00',2.24),('8784','2013-06-26','08:35:00',2.3),('8784','2013-06-26','08:40:00',2.38),('8784','2013-06-26','08:45:00',2.47),('8784','2013-06-26','08:50:00',2.53),('8784','2013-06-26','08:55:00',2.6),('8784','2013-06-26','09:00:00',2.67),('8784','2013-06-26','09:05:00',2.75),('8784','2013-06-26','09:10:00',2.8),('8784','2013-06-26','09:15:00',2.84),('8784','2013-06-26','09:20:00',2.88),('8784','2013-06-26','09:25:00',3.01),('8784','2013-06-26','09:30:00',3.07),('8784','2013-06-26','09:35:00',3.11),('8784','2013-06-26','09:40:00',3.17),('8784','2013-06-26','09:45:00',3.25),('8784','2013-06-26','09:50:00',3.24),('8784','2013-06-26','09:55:00',3.31),('8784','2013-06-26','10:00:00',3.39),('8784','2013-06-26','10:05:00',3.46),('8784','2013-06-26','10:10:00',3.54),('8784','2013-06-26','10:15:00',3.62),('8784','2013-06-26','10:20:00',3.66),('8784','2013-06-26','10:25:00',3.68),('8784','2013-06-26','10:30:00',3.7),('8784','2013-06-26','10:35:00',3.74),('8784','2013-06-26','10:40:00',3.8),('8784','2013-06-26','10:45:00',3.85),('8784','2013-06-26','10:50:00',3.91),('8784','2013-06-26','10:55:00',3.93),('8784','2013-06-26','11:00:00',3.95),('8784','2013-06-26','11:05:00',3.99),('8784','2013-06-26','11:10:00',4),('8784','2013-06-26','11:15:00',4.03),('8784','2013-06-26','11:20:00',4.11),('8784','2013-06-26','11:25:00',4.08),('8784','2013-06-26','11:30:00',4.13),('8784','2013-06-26','11:35:00',4.14),('8784','2013-06-26','11:40:00',4.16),('8784','2013-06-26','11:45:00',4.18),('8784','2013-06-26','11:50:00',4.24),('8784','2013-06-26','11:55:00',4.27),('8784','2013-06-26','12:00:00',4.33),('8784','2013-06-26','12:05:00',4.36),('8784','2013-06-26','12:10:00',4.32),('8784','2013-06-26','12:15:00',4.36),('8784','2013-06-26','12:20:00',4.31),('8784','2013-06-26','12:25:00',4.28),('8784','2013-06-26','12:30:00',3.99),('8784','2013-06-26','12:35:00',2.4),('8784','2013-06-26','12:40:00',3.16),('8784','2013-06-26','12:45:00',1.76),('8784','2013-06-26','12:50:00',1.02),('8784','2013-06-26','12:55:00',1.1),('8784','2013-06-26','13:00:00',1.06),('8784','2013-06-26','13:05:00',1.52),('8784','2013-06-26','13:10:00',2.31),('8784','2013-06-26','13:15:00',4.91),('8784','2013-06-26','13:20:00',4.82),('8784','2013-06-26','13:25:00',4.89),('8784','2013-06-26','13:30:00',4.05),('8784','2013-06-26','13:35:00',1.08),('8784','2013-06-26','13:40:00',1.16),('8784','2013-06-26','13:45:00',1.59),('8784','2013-06-26','13:50:00',3.29),('8784','2013-06-26','13:55:00',1.45),('8784','2013-06-26','14:00:00',4.86),('8784','2013-06-26','14:05:00',4.84),('8784','2013-06-26','14:10:00',2.87),('8784','2013-06-26','14:15:00',3.22),('8784','2013-06-26','14:20:00',4.64),('8784','2013-06-26','14:25:00',3.96),('8784','2013-06-26','14:30:00',4.04),('8784','2013-06-26','14:35:00',4.01),('8784','2013-06-26','14:40:00',3.7),('8784','2013-06-26','14:45:00',2.73),('8784','2013-06-26','14:50:00',4.6),('8784','2013-06-26','14:55:00',4.43),('8784','2013-06-26','15:00:00',4.18),('8784','2013-06-26','15:05:00',4.14),('8784','2013-06-26','15:10:00',4.07),('8784','2013-06-26','15:15:00',4.01),('8784','2013-06-26','15:20:00',3.99),('8784','2013-06-26','15:25:00',3.9),('8784','2013-06-26','15:30:00',3.87),('8784','2013-06-26','15:35:00',3.79),('8784','2013-06-26','15:40:00',3.75),('8784','2013-06-26','15:45:00',3.76),('8784','2013-06-26','15:50:00',3.77),('8784','2013-06-26','15:55:00',3.68),('8784','2013-06-26','16:00:00',3.61),('8784','2013-06-26','16:05:00',3.58),('8784','2013-06-26','16:10:00',3.43),('8784','2013-06-26','16:15:00',3.37),('8784','2013-06-26','16:20:00',3.41),('8784','2013-06-26','16:25:00',3.35),('8784','2013-06-26','16:30:00',3.27),('8784','2013-06-26','16:35:00',3.19),('8784','2013-06-26','16:40:00',3.1),('8784','2013-06-26','16:45:00',3.06),('8784','2013-06-26','16:50:00',2.99),('8784','2013-06-26','16:55:00',2.93),('8784','2013-06-26','17:00:00',2.87),('8784','2013-06-26','17:05:00',2.81),('8784','2013-06-26','17:10:00',2.75),('8784','2013-06-26','17:15:00',2.65),('8784','2013-06-26','17:20:00',2.56),('8784','2013-06-26','17:25:00',2.48),('8784','2013-06-26','17:30:00',2.41),('8784','2013-06-26','17:35:00',2.34),('8784','2013-06-26','17:40:00',2.23),('8784','2013-06-26','17:45:00',2.18),('8784','2013-06-26','17:50:00',2.09),('8784','2013-06-26','17:55:00',2.01),('8784','2013-06-26','18:00:00',1.92),('8784','2013-06-26','18:05:00',1.93),('8784','2013-06-26','18:10:00',2.14),('8784','2013-06-26','18:15:00',1.46),('8784','2013-06-25','07:15:00',1.01),('8784','2013-06-25','07:20:00',1.08),('8784','2013-06-25','07:25:00',1.14),('8784','2013-06-25','07:30:00',1.23),('8784','2013-06-25','07:35:00',1.38),('8784','2013-06-25','07:40:00',1.49),('8784','2013-06-25','07:45:00',1.61),('8784','2013-06-25','07:50:00',1.26),('8784','2013-06-25','07:55:00',1.04),('8784','2013-06-25','08:00:00',2.02),('8784','2013-06-25','08:05:00',1.67),('8784','2013-06-25','08:10:00',1.16),('8784','2013-06-25','08:20:00',1.49),('8784','2013-06-25','08:25:00',2.24),('8784','2013-06-25','08:30:00',2.31),('8784','2013-06-25','08:35:00',2.37),('8784','2013-06-25','08:40:00',2.46),('8784','2013-06-25','08:45:00',2.53),('8784','2013-06-25','08:50:00',2.56),('8784','2013-06-25','08:55:00',2.67),('8784','2013-06-25','09:00:00',2.75),('8784','2013-06-25','09:05:00',2.75),('8784','2013-06-25','09:10:00',2.83),('8784','2013-06-25','09:15:00',2.97),('8784','2013-06-25','09:20:00',3.03),('8784','2013-06-25','09:25:00',3.08),('8784','2013-06-25','09:30:00',3.15),('8784','2013-06-25','09:35:00',3.37),('8784','2013-06-25','09:40:00',3.49),('8784','2013-06-25','09:45:00',3.28),('8784','2013-06-25','09:50:00',2.39),('8784','2013-06-25','09:55:00',3.4),('8784','2013-06-25','10:00:00',3.96),('8784','2013-06-25','10:05:00',3.96),('8784','2013-06-25','10:10:00',4.15),('8784','2013-06-25','10:15:00',4.12),('8784','2013-06-25','10:20:00',1.55),('8784','2013-06-25','10:25:00',1.09),('8784','2013-06-25','10:30:00',4.23),('8784','2013-06-25','10:35:00',4.3),('8784','2013-06-25','10:40:00',4.28),('8784','2013-06-25','10:45:00',4),('8784','2013-06-25','10:50:00',1.96),('8784','2013-06-25','10:55:00',3.52),('8784','2013-06-25','11:00:00',2.35),('8784','2013-06-25','11:05:00',3.89),('8784','2013-06-25','11:10:00',2.43),('8784','2013-06-25','11:15:00',1.23),('8784','2013-06-25','11:20:00',1.15),('8784','2013-06-25','11:25:00',1.19),('8784','2013-06-25','11:30:00',1.23),('8784','2013-06-25','11:35:00',3.6),('8784','2013-06-25','11:40:00',5.23),('8784','2013-06-25','11:45:00',4.87),('8784','2013-06-25','11:50:00',4.98),('8784','2013-06-25','11:55:00',2.2),('8784','2013-06-25','12:00:00',1.23),('8784','2013-06-25','12:05:00',1.16),('8784','2013-06-25','12:10:00',1.29),('8784','2013-06-25','12:15:00',1.26),('8784','2013-06-25','12:20:00',1.35),('8784','2013-06-25','12:25:00',1.31),('8784','2013-06-25','12:30:00',1.3),('8784','2013-06-25','12:35:00',2.41),('8784','2013-06-25','12:40:00',3.25),('8784','2013-06-25','12:45:00',4.74),('8784','2013-06-25','12:50:00',2.01),('8784','2013-06-25','12:55:00',1.82),('8784','2013-06-25','13:00:00',4.72),('8784','2013-06-25','13:05:00',4.51),('8784','2013-06-25','13:10:00',2.91),('8784','2013-06-25','13:15:00',4.45),('8784','2013-06-25','13:20:00',4.86),('8784','2013-06-25','13:25:00',4.79),('8784','2013-06-25','13:30:00',3.58),('8784','2013-06-25','13:35:00',4.22),('8784','2013-06-25','13:40:00',4.96),('8784','2013-06-25','13:45:00',4.32),('8784','2013-06-25','13:50:00',3.96),('8784','2013-06-25','13:55:00',4.22),('8784','2013-06-25','14:00:00',3.9),('8784','2013-06-25','14:05:00',4.66),('8784','2013-06-25','14:10:00',4.6),('8784','2013-06-25','14:15:00',4.61),('8784','2013-06-25','14:20:00',4.55),('8784','2013-06-25','14:25:00',4.39),('8784','2013-06-25','14:30:00',4.37),('8784','2013-06-25','14:35:00',4.3),('8784','2013-06-25','14:40:00',3.89),('8784','2013-06-25','14:45:00',4.36),('8784','2013-06-25','14:50:00',4.29),('8784','2013-06-25','14:55:00',4.24),('8784','2013-06-25','15:00:00',4.19),('8784','2013-06-25','15:05:00',4.17),('8784','2013-06-25','15:10:00',4.14),('8784','2013-06-25','15:15:00',4.07),('8784','2013-06-25','15:20:00',4.04),('8784','2013-06-25','15:25:00',3.96),('8784','2013-06-25','15:30:00',3.92),('8784','2013-06-25','15:35:00',3.86),('8784','2013-06-25','15:40:00',3.83),('8784','2013-06-25','15:45:00',3.77),('8784','2013-06-25','15:50:00',3.72),('8784','2013-06-25','15:55:00',3.64),('8784','2013-06-25','16:00:00',3.59),('8784','2013-06-25','16:05:00',3.54),('8784','2013-06-25','16:10:00',3.45),('8784','2013-06-25','16:15:00',3.42),('8784','2013-06-25','16:20:00',3.36),('8784','2013-06-25','16:25:00',3.26),('8784','2013-06-25','16:30:00',3.25),('8784','2013-06-25','16:35:00',3.18),('8784','2013-06-25','16:40:00',3.1),('8784','2013-06-25','16:45:00',3.03),('8784','2013-06-25','16:50:00',2.98),('8784','2013-06-25','16:55:00',2.91),('8784','2013-06-25','17:00:00',2.84),('8784','2013-06-25','17:05:00',2.78),('8784','2013-06-25','17:10:00',2.69),('8784','2013-06-25','17:15:00',2.62),('8784','2013-06-25','17:20:00',2.52),('8784','2013-06-25','17:25:00',2.43),('8784','2013-06-25','17:30:00',2.4),('8784','2013-06-25','17:35:00',2.31),('8784','2013-06-25','17:40:00',2.24),('8784','2013-06-25','17:45:00',2.15),('8784','2013-06-25','17:50:00',2.07),('8784','2013-06-25','17:55:00',2),('8784','2013-06-25','18:00:00',1.92),('8784','2013-06-25','18:05:00',1.83),('8784','2013-06-25','18:10:00',1.74),('8784','2013-06-25','18:15:00',1.65),('8784','2013-06-25','18:20:00',1.58),('8784','2013-06-25','18:25:00',1.49),('8784','2013-06-25','18:30:00',1.42),('8784','2013-06-25','18:35:00',1.35),('8784','2013-06-25','18:40:00',1.22),('8784','2013-06-25','18:45:00',1.17),('8784','2013-06-25','18:50:00',1.09),('8784','2013-06-25','18:55:00',1.02),('8784','2013-06-24','07:10:00',1.05),('8784','2013-06-24','08:40:00',1.76),('8784','2013-06-24','08:45:00',2.69),('8784','2013-06-24','08:50:00',2.73),('8784','2013-06-24','08:55:00',2.66),('8784','2013-06-24','09:00:00',2.3),('8784','2013-06-24','09:05:00',2.12),('8784','2013-06-24','09:10:00',1.92),('8784','2013-06-24','09:15:00',2.51),('8784','2013-06-24','09:20:00',2.9),('8784','2013-06-24','09:25:00',3.67),('8784','2013-06-24','09:30:00',3.09),('8784','2013-06-24','09:35:00',2.35),('8784','2013-06-24','09:40:00',3.56),('8784','2013-06-24','09:45:00',3.76),('8784','2013-06-24','09:50:00',3.71),('8784','2013-06-24','09:55:00',3.62),('8784','2013-06-24','10:00:00',3.64),('8784','2013-06-24','10:05:00',3.75),('8784','2013-06-24','10:10:00',3.96),('8784','2013-06-24','10:15:00',3.02),('8784','2013-06-24','10:20:00',4.18),('8784','2013-06-24','10:25:00',4.45),('8784','2013-06-24','10:30:00',4.11),('8784','2013-06-24','10:35:00',4.43),('8784','2013-06-24','10:40:00',1.82),('8784','2013-06-24','10:45:00',1.84),('8784','2013-06-24','10:50:00',3.1),('8784','2013-06-24','10:55:00',3.22),('8784','2013-06-24','11:00:00',4.29),('8784','2013-06-24','11:05:00',4.09),('8784','2013-06-24','11:10:00',1.45),('8784','2013-06-24','11:15:00',4.08),('8784','2013-06-24','11:20:00',3.78),('8784','2013-06-24','11:25:00',1.71),('8784','2013-06-24','11:30:00',2.37),('8784','2013-06-24','11:35:00',1.53),('8784','2013-06-24','11:40:00',1.39),('8784','2013-06-24','11:45:00',2.46),('8784','2013-06-24','11:50:00',2.08),('8784','2013-06-24','11:55:00',4.3),('8784','2013-06-24','12:00:00',3.09),('8784','2013-06-24','12:05:00',3.59),('8784','2013-06-24','12:10:00',4.65),('8784','2013-06-24','12:15:00',2.59),('8784','2013-06-24','12:20:00',5.2),('8784','2013-06-24','12:25:00',4.23),('8784','2013-06-24','12:30:00',3.22),('8784','2013-06-24','12:35:00',5.17),('8784','2013-06-24','12:40:00',3.87),('8784','2013-06-24','12:45:00',3.78),('8784','2013-06-24','12:50:00',4.68),('8784','2013-06-24','12:55:00',4.8),('8784','2013-06-24','13:00:00',3.75),('8784','2013-06-24','13:05:00',5.2),('8784','2013-06-24','13:10:00',3.58),('8784','2013-06-24','13:15:00',3.4),('8784','2013-06-24','13:20:00',1.99),('8784','2013-06-24','13:25:00',4.2),('8784','2013-06-24','13:30:00',4.9),('8784','2013-06-24','13:35:00',3.58),('8784','2013-06-24','13:40:00',4.52),('8784','2013-06-24','13:45:00',4.78),('8784','2013-06-24','13:50:00',4.75),('8784','2013-06-24','13:55:00',4.7),('8784','2013-06-24','14:00:00',4.24),('8784','2013-06-24','14:05:00',4.64),('8784','2013-06-24','14:10:00',4.63),('8784','2013-06-24','14:15:00',4.62),('8784','2013-06-24','14:20:00',4.57),('8784','2013-06-24','14:25:00',4.59),('8784','2013-06-24','14:30:00',4.59),('8784','2013-06-24','14:35:00',4.56),('8784','2013-06-24','14:40:00',4.56),('8784','2013-06-24','14:45:00',4.66),('8784','2013-06-24','14:50:00',4.15),('8784','2013-06-24','14:55:00',3.21),('8784','2013-06-24','15:00:00',4.29),('8784','2013-06-24','15:05:00',2.31),('8784','2013-06-24','15:10:00',3.84),('8784','2013-06-24','15:15:00',4.3),('8784','2013-06-24','15:20:00',3.73),('8784','2013-06-24','15:25:00',2.88),('8784','2013-06-24','15:30:00',3.44),('8784','2013-06-24','15:35:00',2.04),('8784','2013-06-24','15:40:00',2.97),('8784','2013-06-24','15:45:00',2.96),('8784','2013-06-24','15:50:00',3.46),('8784','2013-06-24','15:55:00',3.86),('8784','2013-06-24','16:00:00',4.24),('8784','2013-06-24','16:05:00',3.96),('8784','2013-06-24','16:10:00',3.04),('8784','2013-06-24','16:15:00',3.95),('8784','2013-06-24','16:20:00',2.33),('8784','2013-06-24','16:25:00',2.91),('8784','2013-06-24','16:30:00',3.54),('8784','2013-06-24','16:35:00',3.13),('8784','2013-06-24','16:40:00',2.42),('8784','2013-06-24','16:45:00',2.33),('8784','2013-06-24','16:50:00',2.01),('8784','2013-06-24','16:55:00',1.36),('8784','2013-06-24','17:00:00',1.49),('8784','2013-06-24','17:05:00',2.58),('8784','2013-06-24','17:10:00',2.59),('8784','2013-06-24','17:15:00',3.04),('8784','2013-06-24','17:20:00',2.15),('8784','2013-06-24','17:25:00',2.72),('8784','2013-06-24','17:30:00',1.63),('8784','2013-06-24','17:35:00',1.05),('8784','2013-06-24','17:50:00',1.62),('8784','2013-06-24','17:55:00',1.4),('8784','2013-06-24','18:00:00',2.32),('8784','2013-06-24','18:05:00',1.91),('8784','2013-06-24','18:10:00',1.69),('8784','2013-06-24','18:15:00',1.83),('8784','2013-06-24','18:20:00',1.67),('8784','2013-06-24','18:25:00',1.6),('8784','2013-06-24','18:30:00',1.18),('8784','2013-06-24','18:35:00',1.48),('8784','2013-06-24','18:45:00',1.35),('8784','2013-06-24','18:50:00',1.16),('8784','2013-06-24','18:55:00',1.06),('8784','2013-06-24','19:00:00',1.04),('8784','2013-06-23','08:45:00',1.16),('8784','2013-06-23','08:50:00',1.62),('8784','2013-06-23','08:55:00',1.17),('8784','2013-06-23','09:00:00',2.04),('8784','2013-06-23','09:05:00',1.47),('8784','2013-06-23','09:20:00',1.96),('8784','2013-06-23','09:25:00',2.94),('8784','2013-06-23','09:30:00',3.11),('8784','2013-06-23','09:35:00',3.24),('8784','2013-06-23','09:40:00',3.71),('8784','2013-06-23','09:45:00',2.2),('8784','2013-06-23','09:50:00',1.14),('8784','2013-06-23','09:55:00',1.17),('8784','2013-06-23','10:00:00',3.4),('8784','2013-06-23','10:05:00',2.87),('8784','2013-06-23','10:10:00',1.22),('8784','2013-06-23','10:15:00',2.3),('8784','2013-06-23','10:20:00',1.26),('8784','2013-06-23','10:25:00',2.77),('8784','2013-06-23','10:30:00',3.09),('8784','2013-06-23','10:35:00',1.38),('8784','2013-06-23','10:40:00',3.74),('8784','2013-06-23','10:45:00',3.57),('8784','2013-06-23','10:50:00',3.87),('8784','2013-06-23','10:55:00',3.81),('8784','2013-06-23','11:00:00',3.88),('8784','2013-06-23','11:05:00',3.97),('8784','2013-06-23','11:10:00',4.03),('8784','2013-06-23','11:15:00',3.85),('8784','2013-06-23','11:20:00',4.06),('8784','2013-06-23','11:25:00',4.13),('8784','2013-06-23','11:30:00',3.96),('8784','2013-06-23','11:35:00',3.88),('8784','2013-06-23','11:40:00',4.08),('8784','2013-06-23','11:45:00',4.17),('8784','2013-06-23','11:50:00',4.1),('8784','2013-06-23','11:55:00',4.13),('8784','2013-06-23','12:00:00',4.29),('8784','2013-06-23','12:05:00',4.34),('8784','2013-06-23','12:10:00',4.38),('8784','2013-06-23','12:15:00',4.3),('8784','2013-06-23','12:20:00',4.33),('8784','2013-06-23','12:25:00',4.45),('8784','2013-06-23','12:30:00',4.43),('8784','2013-06-23','12:35:00',4.41),('8784','2013-06-23','12:40:00',4.45),('8784','2013-06-23','12:45:00',4.42),('8784','2013-06-23','12:50:00',4.43),('8784','2013-06-23','12:55:00',4.42),('8784','2013-06-23','13:00:00',4.43),('8784','2013-06-23','13:05:00',4.43),('8784','2013-06-23','13:10:00',4.44),('8784','2013-06-23','13:15:00',4.46),('8784','2013-06-23','13:20:00',4.45),('8784','2013-06-23','13:25:00',4.46),('8784','2013-06-23','13:30:00',4.48),('8784','2013-06-23','13:35:00',4.51),('8784','2013-06-23','13:40:00',4.49),('8784','2013-06-23','13:45:00',4.51),('8784','2013-06-23','13:50:00',4.48),('8784','2013-06-23','13:55:00',4.46),('8784','2013-06-23','14:00:00',4.44),('8784','2013-06-23','14:05:00',4.45),('8784','2013-06-23','14:10:00',4.36),('8784','2013-06-23','14:15:00',4.32),('8784','2013-06-23','14:20:00',4.29),('8784','2013-06-23','14:25:00',4.38),('8784','2013-06-23','14:30:00',4.32),('8784','2013-06-23','14:35:00',4.31),('8784','2013-06-23','14:40:00',4.24),('8784','2013-06-23','14:45:00',4.27),('8784','2013-06-23','14:50:00',4.25),('8784','2013-06-23','14:55:00',4.23),('8784','2013-06-23','15:00:00',4.2),('8784','2013-06-23','15:05:00',4.16),('8784','2013-06-23','15:10:00',4.13),('8784','2013-06-23','15:15:00',4.09),('8784','2013-06-23','15:20:00',4.04),('8784','2013-06-23','15:25:00',3.98),('8784','2013-06-23','15:30:00',3.92),('8784','2013-06-23','15:35:00',3.88),('8784','2013-06-23','15:40:00',3.75),('8784','2013-06-23','15:45:00',3.7),('8784','2013-06-23','15:50:00',3.71),('8784','2013-06-23','15:55:00',3.68),('8784','2013-06-23','16:00:00',3.66),('8784','2013-06-23','16:05:00',3.58),('8784','2013-06-23','16:10:00',3.52),('8784','2013-06-23','16:15:00',3.43),('8784','2013-06-23','16:20:00',3.37),('8784','2013-06-23','16:25:00',3.32),('8784','2013-06-23','16:30:00',3.24),('8784','2013-06-23','16:35:00',3.21),('8784','2013-06-23','16:40:00',3.16),('8784','2013-06-23','16:45:00',3.09),('8784','2013-06-23','16:50:00',3.02),('8784','2013-06-23','16:55:00',2.95),('8784','2013-06-23','17:00:00',2.87),('8784','2013-06-23','17:05:00',2.81),('8784','2013-06-23','17:10:00',2.75),('8784','2013-06-23','17:15:00',2.68),('8784','2013-06-23','17:20:00',2.42),('8784','2013-06-23','17:25:00',2.53),('8784','2013-06-23','17:30:00',2.42),('8784','2013-06-23','17:35:00',2.36),('8784','2013-06-23','17:40:00',2.3),('8784','2013-06-23','17:45:00',2.24),('8784','2013-06-23','17:50:00',2.15),('8784','2013-06-23','17:55:00',2.04),('8784','2013-06-23','18:00:00',1.97),('8784','2013-06-23','18:05:00',1.89),('8784','2013-06-23','18:10:00',1.81),('8784','2013-06-23','18:15:00',1.7),('8784','2013-06-23','18:20:00',1.6),('8784','2013-06-23','18:25:00',1.51),('8784','2013-06-23','18:30:00',1.45),('8784','2013-06-23','18:35:00',1.37),('8784','2013-06-23','18:40:00',1.31),('8784','2013-06-23','18:45:00',1.24),('8784','2013-06-23','18:50:00',1.17),('8784','2013-06-23','18:55:00',1.05),('8784','2013-06-22','07:20:00',1.02),('8784','2013-06-22','07:25:00',1.09),('8784','2013-06-22','07:30:00',1.17),('8784','2013-06-22','07:35:00',1.24),('8784','2013-06-22','07:40:00',1.31),('8784','2013-06-22','07:45:00',1.4),('8784','2013-06-22','07:50:00',1.47),('8784','2013-06-22','07:55:00',1.56),('8784','2013-06-22','08:00:00',1.6),('8784','2013-06-22','08:05:00',1.69),('8784','2013-06-22','08:10:00',1.77),('8784','2013-06-22','08:15:00',1.85),('8784','2013-06-22','08:20:00',1.95),('8784','2013-06-22','08:25:00',2.04),('8784','2013-06-22','08:30:00',2.12),('8784','2013-06-22','08:35:00',2.21),('8784','2013-06-22','08:40:00',2.3),('8784','2013-06-22','08:45:00',2.37),('8784','2013-06-22','08:50:00',2.44),('8784','2013-06-22','08:55:00',2.51),('8784','2013-06-22','09:00:00',2.56),('8784','2013-06-22','09:05:00',2.63),('8784','2013-06-22','09:10:00',2.69),('8784','2013-06-22','09:15:00',2.74),('8784','2013-06-22','09:20:00',2.8),('8784','2013-06-22','09:25:00',2.86),('8784','2013-06-22','09:30:00',2.92),('8784','2013-06-22','09:35:00',2.98),('8784','2013-06-22','09:40:00',3.05),('8784','2013-06-22','09:45:00',3.05),('8784','2013-06-22','09:50:00',3.16),('8784','2013-06-22','09:55:00',3.25),('8784','2013-06-22','10:00:00',3.29),('8784','2013-06-22','10:05:00',3.35),('8784','2013-06-22','10:10:00',3.4),('8784','2013-06-22','10:15:00',3.47),('8784','2013-06-22','10:20:00',3.52),('8784','2013-06-22','10:25:00',3.56),('8784','2013-06-22','10:30:00',3.55),('8784','2013-06-22','10:35:00',3.61),('8784','2013-06-22','10:40:00',3.69),('8784','2013-06-22','10:45:00',3.75),('8784','2013-06-22','10:50:00',3.81),('8784','2013-06-22','10:55:00',3.84),('8784','2013-06-22','11:00:00',3.8),('8784','2013-06-22','11:05:00',3.9),('8784','2013-06-22','11:10:00',3.95),('8784','2013-06-22','11:15:00',3.96),('8784','2013-06-22','11:20:00',4.01),('8784','2013-06-22','11:25:00',4.02),('8784','2013-06-22','11:30:00',4.07),('8784','2013-06-22','11:35:00',4.11),('8784','2013-06-22','11:40:00',4.12),('8784','2013-06-22','11:45:00',4.14),('8784','2013-06-22','11:50:00',4.14),('8784','2013-06-22','11:55:00',4.15),('8784','2013-06-22','12:00:00',4.22),('8784','2013-06-22','12:05:00',4.15),('8784','2013-06-22','12:10:00',4.09),('8784','2013-06-22','12:15:00',4.27),('8784','2013-06-22','12:20:00',4.21),('8784','2013-06-22','12:25:00',4.22),('8784','2013-06-22','12:30:00',4.26),('8784','2013-06-22','12:35:00',4.29),('8784','2013-06-22','12:40:00',4.31),('8784','2013-06-22','12:45:00',4.24),('8784','2013-06-22','12:50:00',4.19),('8784','2013-06-22','12:55:00',4.18),('8784','2013-06-22','13:00:00',4.13),('8784','2013-06-22','13:05:00',4.17),('8784','2013-06-22','13:10:00',4.13),('8784','2013-06-22','13:15:00',4.06),('8784','2013-06-22','13:20:00',4),('8784','2013-06-22','13:25:00',4.28),('8784','2013-06-22','13:30:00',4.48),('8784','2013-06-22','13:35:00',4.5),('8784','2013-06-22','13:40:00',4.04),('8784','2013-06-22','13:45:00',4.33),('8784','2013-06-22','13:50:00',4.42),('8784','2013-06-22','13:55:00',3.16),('8784','2013-06-22','14:00:00',2.88),('8784','2013-06-22','14:05:00',4.75),('8784','2013-06-22','14:10:00',4.55),('8784','2013-06-22','14:15:00',4.52),('8784','2013-06-22','14:20:00',3.75),('8784','2013-06-22','14:25:00',4.38),('8784','2013-06-22','14:30:00',3.12),('8784','2013-06-22','14:35:00',2.41),('8784','2013-06-22','14:40:00',1.85),('8784','2013-06-22','14:45:00',2.38),('8784','2013-06-22','14:50:00',3.88),('8784','2013-06-22','14:55:00',4.31),('8784','2013-06-22','15:00:00',4.17),('8784','2013-06-22','15:05:00',3.23),('8784','2013-06-22','15:10:00',4.12),('8784','2013-06-22','15:15:00',4.24),('8784','2013-06-22','15:20:00',3.81),('8784','2013-06-22','15:25:00',3.43),('8784','2013-06-22','15:30:00',2.51),('8784','2013-06-22','15:35:00',1.96),('8784','2013-06-22','15:40:00',2.26),('8784','2013-06-22','15:45:00',2.97),('8784','2013-06-22','15:50:00',2.62),('8784','2013-06-22','15:55:00',2.65),('8784','2013-06-22','16:00:00',1.98),('8784','2013-06-22','16:05:00',1.35),('8784','2013-06-22','16:10:00',1.38),('8784','2013-06-22','16:15:00',1.74),('8784','2013-06-22','16:20:00',2),('8784','2013-06-22','16:25:00',1.42),('8784','2013-06-22','16:30:00',1.15),('8784','2013-06-22','16:55:00',1.35),('8784','2013-06-22','17:00:00',1.66),('8784','2013-06-22','17:05:00',1.61),('8784','2013-06-22','17:10:00',2.27),('8784','2013-06-22','17:15:00',3.14),('8784','2013-06-22','17:20:00',2.98),('8784','2013-06-22','17:25:00',2.95),('8784','2013-06-22','17:30:00',2.32),('8784','2013-06-22','17:35:00',2.06),('8784','2013-06-22','17:40:00',2.33),('8784','2013-06-22','17:45:00',2.32),('8784','2013-06-22','17:50:00',2.11),('8784','2013-06-22','17:55:00',2.08),('8784','2013-06-22','18:00:00',1.9),('8784','2013-06-22','18:05:00',1.57),('8784','2013-06-22','18:10:00',1.07),('8784','2013-06-22','18:15:00',1.13),('8784','2013-06-22','18:20:00',1.14),('8784','2013-06-21','07:20:00',1.01),('8784','2013-06-21','07:25:00',1.09),('8784','2013-06-21','07:30:00',1.17),('8784','2013-06-21','07:35:00',1.24),('8784','2013-06-21','07:40:00',1.31),('8784','2013-06-21','07:45:00',1.38),('8784','2013-06-21','07:50:00',1.48),('8784','2013-06-21','07:55:00',1.57),('8784','2013-06-21','08:00:00',1.65),('8784','2013-06-21','08:05:00',1.73),('8784','2013-06-21','08:10:00',1.8),('8784','2013-06-21','08:15:00',1.87),('8784','2013-06-21','08:20:00',1.92),('8784','2013-06-21','08:25:00',1.99),('8784','2013-06-21','08:30:00',2.09),('8784','2013-06-21','08:35:00',2.15),('8784','2013-06-21','08:40:00',2.21),('8784','2013-06-21','08:45:00',2.3),('8784','2013-06-21','08:50:00',2.36),('8784','2013-06-21','08:55:00',2.43),('8784','2013-06-21','09:00:00',2.48),('8784','2013-06-21','09:05:00',2.52),('8784','2013-06-21','09:10:00',2.58),('8784','2013-06-21','09:15:00',2.63),('8784','2013-06-21','09:20:00',2.66),('8784','2013-06-21','09:25:00',2.76),('8784','2013-06-21','09:30:00',2.78),('8784','2013-06-21','09:35:00',2.85),('8784','2013-06-21','09:40:00',2.9),('8784','2013-06-21','09:45:00',2.98),('8784','2013-06-21','09:50:00',3.03),('8784','2013-06-21','09:55:00',3.07),('8784','2013-06-21','10:00:00',3.13),('8784','2013-06-21','10:05:00',3.17),('8784','2013-06-21','10:10:00',3.23),('8784','2013-06-21','10:15:00',3.27),('8784','2013-06-21','10:20:00',3.28),('8784','2013-06-21','10:25:00',3.34),('8784','2013-06-21','10:30:00',3.34),('8784','2013-06-21','10:35:00',3.4),('8784','2013-06-21','10:40:00',3.43),('8784','2013-06-21','10:45:00',3.51),('8784','2013-06-21','10:50:00',3.46),('8784','2013-06-21','10:55:00',3.5),('8784','2013-06-21','11:00:00',3.56),('8784','2013-06-21','11:05:00',3.6),('8784','2013-06-21','11:10:00',3.65),('8784','2013-06-21','11:15:00',3.69),('8784','2013-06-21','11:20:00',3.78),('8784','2013-06-21','11:25:00',3.82),('8784','2013-06-21','11:30:00',3.84),('8784','2013-06-21','11:35:00',3.85),('8784','2013-06-21','11:40:00',3.85),('8784','2013-06-21','11:45:00',3.87),('8784','2013-06-21','11:50:00',3.9),('8784','2013-06-21','11:55:00',3.93),('8784','2013-06-21','12:00:00',3.92),('8784','2013-06-21','12:05:00',3.94),('8784','2013-06-21','12:10:00',3.98),('8784','2013-06-21','12:15:00',3.96),('8784','2013-06-21','12:20:00',3.99),('8784','2013-06-21','12:25:00',3.96),('8784','2013-06-21','12:30:00',3.97),('8784','2013-06-21','12:35:00',3.92),('8784','2013-06-21','12:40:00',4),('8784','2013-06-21','12:45:00',4.06),('8784','2013-06-21','12:50:00',4.01),('8784','2013-06-21','12:55:00',3.97),('8784','2013-06-21','13:00:00',3.99),('8784','2013-06-21','13:05:00',3.96),('8784','2013-06-21','13:10:00',3.94),('8784','2013-06-21','13:15:00',4),('8784','2013-06-21','13:20:00',4.08),('8784','2013-06-21','13:25:00',4.11),('8784','2013-06-21','13:30:00',4.13),('8784','2013-06-21','13:35:00',4.09),('8784','2013-06-21','13:40:00',4.07),('8784','2013-06-21','13:45:00',4.09),('8784','2013-06-21','13:50:00',4.04),('8784','2013-06-21','13:55:00',4.05),('8784','2013-06-21','14:00:00',4.08),('8784','2013-06-21','14:05:00',4.1),('8784','2013-06-21','14:10:00',4.1),('8784','2013-06-21','14:15:00',4.06),('8784','2013-06-21','14:20:00',4.08),('8784','2013-06-21','14:25:00',4.09),('8784','2013-06-21','14:30:00',4.07),('8784','2013-06-21','14:35:00',4.04),('8784','2013-06-21','14:40:00',4.02),('8784','2013-06-21','14:45:00',3.99),('8784','2013-06-21','14:50:00',3.98),('8784','2013-06-21','14:55:00',3.96),('8784','2013-06-21','15:00:00',3.93),('8784','2013-06-21','15:05:00',3.91),('8784','2013-06-21','15:10:00',3.87),('8784','2013-06-21','15:15:00',3.85),('8784','2013-06-21','15:20:00',3.82),('8784','2013-06-21','15:25:00',3.74),('8784','2013-06-21','15:30:00',3.71),('8784','2013-06-21','15:35:00',3.6),('8784','2013-06-21','15:40:00',3.63),('8784','2013-06-21','15:45:00',3.55),('8784','2013-06-21','15:50:00',3.53),('8784','2013-06-21','15:55:00',3.5),('8784','2013-06-21','16:00:00',3.44),('8784','2013-06-21','16:05:00',3.4),('8784','2013-06-21','16:10:00',3.37),('8784','2013-06-21','16:15:00',3.31),('8784','2013-06-21','16:20:00',3.26),('8784','2013-06-21','16:25:00',3.2),('8784','2013-06-21','16:30:00',3.15),('8784','2013-06-21','16:35:00',3.08),('8784','2013-06-21','16:40:00',3.02),('8784','2013-06-21','16:45:00',2.96),('8784','2013-06-21','16:50:00',2.89),('8784','2013-06-21','16:55:00',2.83),('8784','2013-06-21','17:00:00',2.75),('8784','2013-06-21','17:05:00',2.68),('8784','2013-06-21','17:10:00',2.6),('8784','2013-06-21','17:15:00',2.54),('8784','2013-06-21','17:20:00',2.44),('8784','2013-06-21','17:25:00',2.4),('8784','2013-06-21','17:30:00',2.31),('8784','2013-06-21','17:35:00',2.25),('8784','2013-06-21','17:40:00',2.18),('8784','2013-06-21','17:45:00',2.09),('8784','2013-06-21','17:50:00',2.02),('8784','2013-06-21','17:55:00',1.93),('8784','2013-06-21','18:00:00',1.86),('8784','2013-06-21','18:05:00',1.78),('8784','2013-06-21','18:10:00',1.7),('8784','2013-06-21','18:15:00',1.61),('8784','2013-06-21','18:20:00',1.53),('8784','2013-06-21','18:25:00',1.45),('8784','2013-06-21','18:30:00',1.36),('8784','2013-06-21','18:35:00',1.29),('8784','2013-06-21','18:40:00',1.19),('8784','2013-06-21','18:45:00',1.13),('8784','2013-06-21','18:50:00',1.05),('8784','2014-04-04','08:50:00',1.03),('8784','2014-04-04','08:55:00',1),('8784','2014-04-04','09:00:00',1.03),('8784','2014-04-04','09:05:00',1.65),('8784','2014-04-04','09:10:00',2.09),('8784','2014-04-04','09:15:00',2.02),('8784','2014-04-04','09:20:00',1.29),('8784','2014-04-04','13:10:00',1.26),('8784','2014-04-04','13:20:00',2.03),('8784','2014-04-04','13:25:00',2.29),('8784','2014-04-04','13:30:00',2.24),('8784','2014-04-04','13:35:00',2.7),('8784','2014-04-04','13:40:00',4.56),('8784','2014-04-04','13:45:00',3.45),('8784','2014-04-04','13:50:00',4.6),('8784','2014-04-04','13:55:00',2.14),('8784','2014-04-04','14:00:00',3.21),('8784','2014-04-04','14:05:00',4.9),('8784','2014-04-04','14:10:00',4.53),('8784','2014-04-04','14:15:00',3.59),('8784','2014-04-04','14:20:00',3.25),('8784','2014-04-04','14:25:00',3.7),('8784','2014-04-04','14:30:00',1.37),('8784','2014-04-04','14:35:00',2.45),('8784','2014-04-04','14:40:00',1.46),('8784','2014-04-04','14:45:00',1.52),('8784','2014-04-04','14:50:00',3.4),('8784','2014-04-04','14:55:00',3.85),('8784','2014-04-04','15:00:00',3.65),('8784','2014-04-04','15:05:00',3.92),('8784','2014-04-04','15:10:00',3.24),('8784','2014-04-04','15:15:00',3.46),('8784','2014-04-04','15:20:00',2.3),('8784','2014-04-04','15:25:00',1.96),('8784','2014-04-04','15:30:00',1.55),('8784','2014-04-04','15:35:00',1.63),('8784','2014-04-04','15:40:00',2.43),('8784','2014-04-04','15:45:00',1.94),('8784','2014-04-04','15:50:00',1.76),('8784','2014-04-04','15:55:00',3.31),('8784','2014-04-04','16:00:00',2.71),('8784','2014-04-04','16:05:00',2.42),('8784','2014-04-04','16:10:00',3.44),('8784','2014-04-04','16:15:00',1.83),('8784','2014-04-04','16:20:00',1.22),('8784','2014-04-04','16:25:00',1.16),('8784','2014-04-04','16:30:00',2.33),('8784','2014-04-04','16:35:00',1.78),('8784','2014-04-04','16:40:00',1.5),('8784','2014-04-04','16:45:00',2.71),('8784','2014-04-04','16:50:00',2.89),('8784','2014-04-04','16:55:00',2.54),('8784','2014-04-04','17:00:00',2.11),('8784','2014-04-04','17:05:00',1.95),('8784','2014-04-04','17:10:00',1.88),('8784','2014-04-04','17:15:00',1.62),('8784','2014-04-04','17:20:00',2.08),('8784','2014-04-04','17:25:00',1.73),('8784','2014-04-04','17:30:00',2.09),('8784','2014-04-04','17:35:00',1.7),('8784','2014-04-04','17:40:00',1.6),('8784','2014-04-04','17:45:00',1.6),('8784','2014-04-04','17:50:00',1.51),('8784','2014-04-04','17:55:00',1.31),('8784','2014-04-04','18:00:00',1.16),('8784','2014-04-04','18:05:00',1.05),('8784','2013-06-20','07:25:00',1.06),('8784','2013-06-20','07:30:00',1.14),('8784','2013-06-20','07:35:00',1.2),('8784','2013-06-20','07:40:00',1.24),('8784','2013-06-20','07:45:00',1.34),('8784','2013-06-20','07:50:00',1.41),('8784','2013-06-20','07:55:00',1.5),('8784','2013-06-20','08:00:00',1.6),('8784','2013-06-20','08:05:00',1.69),('8784','2013-06-20','08:10:00',1.79),('8784','2013-06-20','08:15:00',1.89),('8784','2013-06-20','08:20:00',1.96),('8784','2013-06-20','08:25:00',2.03),('8784','2013-06-20','08:30:00',2.08),('8784','2013-06-20','08:35:00',2.19),('8784','2013-06-20','08:40:00',2.27),('8784','2013-06-20','08:45:00',2.34),('8784','2013-06-20','08:50:00',2.41),('8784','2013-06-20','08:55:00',2.48),('8784','2013-06-20','09:00:00',2.54),('8784','2013-06-20','09:05:00',2.58),('8784','2013-06-20','09:10:00',2.66),('8784','2013-06-20','09:15:00',2.69),('8784','2013-06-20','09:20:00',2.77),('8784','2013-06-20','09:25:00',2.83),('8784','2013-06-20','09:30:00',2.89),('8784','2013-06-20','09:35:00',2.95),('8784','2013-06-20','09:40:00',3.01),('8784','2013-06-20','09:45:00',3.01),('8784','2013-06-20','09:50:00',3.12),('8784','2013-06-20','09:55:00',3.19),('8784','2013-06-20','10:00:00',3.24),('8784','2013-06-20','10:05:00',3.28),('8784','2013-06-20','10:10:00',3.35),('8784','2013-06-20','10:15:00',3.37),('8784','2013-06-20','10:20:00',3.45),('8784','2013-06-20','10:25:00',3.46),('8784','2013-06-20','10:30:00',3.54),('8784','2013-06-20','10:35:00',3.59),('8784','2013-06-20','10:40:00',3.62),('8784','2013-06-20','10:45:00',3.62),('8784','2013-06-20','10:50:00',3.64),('8784','2013-06-20','10:55:00',3.69),('8784','2013-06-20','11:00:00',3.72),('8784','2013-06-20','11:05:00',3.75),('8784','2013-06-20','11:10:00',3.77),('8784','2013-06-20','11:15:00',3.77),('8784','2013-06-20','11:20:00',3.76),('8784','2013-06-20','11:25:00',3.76),('8784','2013-06-20','11:30:00',3.79),('8784','2013-06-20','11:35:00',3.89),('8784','2013-06-20','11:40:00',3.94),('8784','2013-06-20','11:45:00',3.91),('8784','2013-06-20','11:50:00',3.81),('8784','2013-06-20','11:55:00',3.86),('8784','2013-06-20','12:00:00',3.79),('8784','2013-06-20','12:05:00',3.87),('8784','2013-06-20','12:10:00',3.49),('8784','2013-06-20','12:15:00',3.63),('8784','2013-06-20','12:20:00',3.01),('8784','2013-06-20','12:25:00',3.77),('8784','2013-06-20','12:30:00',4.16),('8784','2013-06-20','12:35:00',4.1),('8784','2013-06-20','12:40:00',4.06),('8784','2013-06-20','12:45:00',3.84),('8784','2013-06-20','12:50:00',3.72),('8784','2013-06-20','12:55:00',3.45),('8784','2013-06-20','13:00:00',4.21),('8784','2013-06-20','13:05:00',4.21),('8784','2013-06-20','13:10:00',3.64),('8784','2013-06-20','13:15:00',2.5),('8784','2013-06-20','13:20:00',4.16),('8784','2013-06-20','13:25:00',4.07),('8784','2013-06-20','13:30:00',4.08),('8784','2013-06-20','13:35:00',4.16),('8784','2013-06-20','13:40:00',4.16),('8784','2013-06-20','13:45:00',4.19),('8784','2013-06-20','13:50:00',4.2),('8784','2013-06-20','13:55:00',4.15),('8784','2013-06-20','14:00:00',4.23),('8784','2013-06-20','14:05:00',4.23),('8784','2013-06-20','14:10:00',4.2),('8784','2013-06-20','14:15:00',4.2),('8784','2013-06-20','14:20:00',4.22),('8784','2013-06-20','14:25:00',4.18),('8784','2013-06-20','14:30:00',4.2),('8784','2013-06-20','14:35:00',4.17),('8784','2013-06-20','14:40:00',4.19),('8784','2013-06-20','14:45:00',4.17),('8784','2013-06-20','14:50:00',4.13),('8784','2013-06-20','14:55:00',4.1),('8784','2013-06-20','15:00:00',4.06),('8784','2013-06-20','15:05:00',4.02),('8784','2013-06-20','15:10:00',3.98),('8784','2013-06-20','15:15:00',3.94),('8784','2013-06-20','15:20:00',3.88),('8784','2013-06-20','15:25:00',3.85),('8784','2013-06-20','15:30:00',3.81),('8784','2013-06-20','15:35:00',3.76),('8784','2013-06-20','15:40:00',3.73),('8784','2013-06-20','15:45:00',3.66),('8784','2013-06-20','15:50:00',3.62),('8784','2013-06-20','15:55:00',3.56),('8784','2013-06-20','16:00:00',3.52),('8784','2013-06-20','16:05:00',3.48),('8784','2013-06-20','16:10:00',3.43),('8784','2013-06-20','16:15:00',3.38),('8784','2013-06-20','16:20:00',3.27),('8784','2013-06-20','16:25:00',3.26),('8784','2013-06-20','16:30:00',3.19),('8784','2013-06-20','16:35:00',3.11),('8784','2013-06-20','16:40:00',3.04),('8784','2013-06-20','16:45:00',2.98),('8784','2013-06-20','16:50:00',2.9),('8784','2013-06-20','16:55:00',2.85),('8784','2013-06-20','17:00:00',2.76),('8784','2013-06-20','17:05:00',2.71),('8784','2013-06-20','17:10:00',2.64),('8784','2013-06-20','17:15:00',2.57),('8784','2013-06-20','17:20:00',2.49),('8784','2013-06-20','17:25:00',2.41),('8784','2013-06-20','17:30:00',2.34),('8784','2013-06-20','17:35:00',2.26),('8784','2013-06-20','17:40:00',2.21),('8784','2013-06-20','17:45:00',2.13),('8784','2013-06-20','17:50:00',2.06),('8784','2013-06-20','17:55:00',1.98),('8784','2013-06-20','18:00:00',1.91),('8784','2013-06-20','18:05:00',1.81),('8784','2013-06-20','18:10:00',1.74),('8784','2013-06-20','18:15:00',1.66),('8784','2013-06-20','18:20:00',1.58),('8784','2013-06-20','18:25:00',1.49),('8784','2013-06-20','18:30:00',1.39),('8784','2013-06-20','18:35:00',1.32),('8784','2013-06-20','18:40:00',1.23),('8784','2013-06-20','18:45:00',1.15),('8784','2013-06-20','18:50:00',1.06),('8784','2013-06-19','07:25:00',1.05),('8784','2013-06-19','07:30:00',1.12),('8784','2013-06-19','07:35:00',1.21),('8784','2013-06-19','07:40:00',1.28),('8784','2013-06-19','07:45:00',1.36),('8784','2013-06-19','07:50:00',1.44),('8784','2013-06-19','07:55:00',1.51),('8784','2013-06-19','08:00:00',1.56),('8784','2013-06-19','08:05:00',1.65),('8784','2013-06-19','08:10:00',1.74),('8784','2013-06-19','08:15:00',1.81),('8784','2013-06-19','08:20:00',1.88),('8784','2013-06-19','08:25:00',1.97),('8784','2013-06-19','08:30:00',2.05),('8784','2013-06-19','08:35:00',2.12),('8784','2013-06-19','08:40:00',2.19),('8784','2013-06-19','08:45:00',2.26),('8784','2013-06-19','08:50:00',2.33),('8784','2013-06-19','08:55:00',2.4),('8784','2013-06-19','09:00:00',2.47),('8784','2013-06-19','09:05:00',2.55),('8784','2013-06-19','09:10:00',2.59),('8784','2013-06-19','09:15:00',2.63),('8784','2013-06-19','09:20:00',2.72),('8784','2013-06-19','09:25:00',2.81),('8784','2013-06-19','09:30:00',2.85),('8784','2013-06-19','09:35:00',2.88),('8784','2013-06-19','09:40:00',2.91),('8784','2013-06-19','09:45:00',3),('8784','2013-06-19','09:50:00',3.06),('8784','2013-06-19','09:55:00',3.11),('8784','2013-06-19','10:00:00',3.16),('8784','2013-06-19','10:05:00',3.2),('8784','2013-06-19','10:10:00',3.26),('8784','2013-06-19','10:15:00',3.31),('8784','2013-06-19','10:20:00',3.34),('8784','2013-06-19','10:25:00',3.4),('8784','2013-06-19','10:30:00',3.41),('8784','2013-06-19','10:35:00',3.45),('8784','2013-06-19','10:40:00',3.48),('8784','2013-06-19','10:45:00',3.51),('8784','2013-06-19','10:50:00',3.54),('8784','2013-06-19','10:55:00',3.57),('8784','2013-06-19','11:00:00',3.6),('8784','2013-06-19','11:05:00',3.6),('8784','2013-06-19','11:10:00',3.67),('8784','2013-06-19','11:15:00',3.63),('8784','2013-06-19','11:20:00',3.71),('8784','2013-06-19','11:25:00',3.74),('8784','2013-06-19','11:30:00',3.81),('8784','2013-06-19','11:35:00',3.84),('8784','2013-06-19','11:40:00',3.82),('8784','2013-06-19','11:45:00',3.87),('8784','2013-06-19','11:50:00',3.87),('8784','2013-06-19','11:55:00',3.92),('8784','2013-06-19','12:00:00',3.89),('8784','2013-06-19','12:05:00',3.92),('8784','2013-06-19','12:10:00',3.88),('8784','2013-06-19','12:15:00',3.91),('8784','2013-06-19','12:20:00',3.9),('8784','2013-06-19','12:25:00',3.87),('8784','2013-06-19','12:30:00',4),('8784','2013-06-19','12:35:00',4.1),('8784','2013-06-19','12:40:00',4.1),('8784','2013-06-19','12:45:00',4.05),('8784','2013-06-19','12:50:00',4.06),('8784','2013-06-19','12:55:00',4.12),('8784','2013-06-19','13:00:00',4.09),('8784','2013-06-19','13:05:00',4.12),('8784','2013-06-19','13:10:00',4.09),('8784','2013-06-19','13:15:00',4.06),('8784','2013-06-19','13:20:00',4.13),('8784','2013-06-19','13:25:00',4.16),('8784','2013-06-19','13:30:00',4.12),('8784','2013-06-19','13:35:00',4.13),('8784','2013-06-19','13:40:00',4.11),('8784','2013-06-19','13:45:00',4.11),('8784','2013-06-19','13:50:00',4.15),('8784','2013-06-19','13:55:00',4.15),('8784','2013-06-19','14:00:00',4.15),('8784','2013-06-19','14:05:00',4.12),('8784','2013-06-19','14:10:00',4.1),('8784','2013-06-19','14:15:00',4.07),('8784','2013-06-19','14:20:00',4.07),('8784','2013-06-19','14:25:00',4.04),('8784','2013-06-19','14:30:00',4),('8784','2013-06-19','14:35:00',3.98),('8784','2013-06-19','14:40:00',3.94),('8784','2013-06-19','14:45:00',3.9),('8784','2013-06-19','14:50:00',3.88),('8784','2013-06-19','14:55:00',3.87),('8784','2013-06-19','15:00:00',3.85),('8784','2013-06-19','15:05:00',3.82),('8784','2013-06-19','15:10:00',3.78),('8784','2013-06-19','15:15:00',3.71),('8784','2013-06-19','15:20:00',3.71),('8784','2013-06-19','15:25:00',3.7),('8784','2013-06-19','15:30:00',3.65),('8784','2013-06-19','15:35:00',3.61),('8784','2013-06-19','15:40:00',3.54),('8784','2013-06-19','15:45:00',3.48),('8784','2013-06-19','15:50:00',3.37),('8784','2013-06-19','15:55:00',3.37),('8784','2013-06-19','16:00:00',3.34),('8784','2013-06-19','16:05:00',3.27),('8784','2013-06-19','16:10:00',3.22),('8784','2013-06-19','16:15:00',3.17),('8784','2013-06-19','16:20:00',3.11),('8784','2013-06-19','16:25:00',3.06),('8784','2013-06-19','16:30:00',3),('8784','2013-06-19','16:35:00',2.95),('8784','2013-06-19','16:40:00',2.89),('8784','2013-06-19','16:45:00',2.84),('8784','2013-06-19','16:50:00',2.79),('8784','2013-06-19','16:55:00',2.73),('8784','2013-06-19','17:00:00',2.67),('8784','2013-06-19','17:05:00',2.59),('8784','2013-06-19','17:10:00',2.51),('8784','2013-06-19','17:15:00',2.47),('8784','2013-06-19','17:20:00',2.44),('8784','2013-06-19','17:25:00',2.38),('8784','2013-06-19','17:30:00',2.31),('8784','2013-06-19','17:35:00',2.19),('8784','2013-06-19','17:40:00',2.15),('8784','2013-06-19','17:45:00',2.08),('8784','2013-06-19','17:50:00',1.99),('8784','2013-06-19','18:00:00',1.85),('8784','2013-06-19','18:05:00',1.75),('8784','2013-06-19','18:10:00',1.64),('8784','2013-06-19','18:15:00',1.55),('8784','2013-06-19','18:20:00',1.49),('8784','2013-06-19','18:25:00',1.41),('8784','2013-06-19','18:30:00',1.29),('8784','2013-06-19','18:35:00',1.19),('8784','2013-06-19','18:40:00',1.06),('8784','2013-06-19','18:45:00',1.03),('8784','2013-06-18','07:30:00',1.09),('8784','2013-06-18','07:35:00',1.18),('8784','2013-06-18','07:40:00',1.25),('8784','2013-06-18','07:45:00',1.33),('8784','2013-06-18','07:50:00',1.41),('8784','2013-06-18','07:55:00',1.49),('8784','2013-06-18','08:00:00',1.55),('8784','2013-06-18','08:05:00',1.65),('8784','2013-06-18','08:10:00',1.74),('8784','2013-06-18','08:15:00',1.8),('8784','2013-06-18','08:20:00',1.88),('8784','2013-06-18','08:25:00',1.96),('8784','2013-06-18','08:30:00',2.03),('8784','2013-06-18','08:35:00',2.1),('8784','2013-06-17','07:20:00',1.03),('8784','2013-06-17','07:25:00',1.11),('8784','2013-06-17','07:30:00',1.19),('8784','2013-06-17','07:35:00',1.27),('8784','2013-06-17','07:40:00',1.35),('8784','2013-06-17','07:45:00',1.43),('8784','2013-06-17','07:50:00',1.52),('8784','2013-06-17','07:55:00',1.6),('8784','2013-06-17','08:00:00',1.68),('8784','2013-06-17','08:05:00',1.76),('8784','2013-06-17','08:10:00',1.84),('8784','2013-06-17','08:15:00',1.92),('8784','2013-06-17','08:20:00',1.99),('8784','2013-06-17','08:25:00',2.07),('8784','2013-06-17','08:30:00',2.12),('8784','2013-06-17','08:35:00',2.21),('8784','2013-06-17','08:40:00',2.3),('8784','2013-06-17','08:45:00',2.38),('8784','2013-06-17','08:50:00',2.44),('8784','2013-06-17','08:55:00',2.51),('8784','2013-06-17','09:00:00',2.58),('8784','2013-06-17','09:05:00',2.65),('8784','2013-06-17','09:10:00',2.72),('8784','2013-06-17','09:15:00',2.79),('8784','2013-06-17','09:20:00',2.85),('8784','2013-06-17','09:25:00',2.9),('8784','2013-06-17','09:30:00',2.97),('8784','2013-06-17','09:35:00',3.01),('8784','2013-06-17','09:40:00',3.07),('8784','2013-06-17','09:45:00',3.11),('8784','2013-06-17','09:50:00',3.19),('8784','2013-06-17','09:55:00',3.24),('8784','2013-06-17','10:00:00',3.27),('8784','2013-06-17','10:05:00',3.32),('8784','2013-06-17','10:10:00',3.36),('8784','2013-06-17','10:15:00',3.39),('8784','2013-06-17','10:20:00',3.43),('8784','2013-06-17','10:25:00',3.48),('8784','2013-06-17','10:30:00',3.54),('8784','2013-06-17','10:35:00',3.58),('8784','2013-06-17','10:40:00',3.61),('8784','2013-06-17','10:45:00',3.64),('8784','2013-06-17','10:50:00',3.69),('8784','2013-06-17','10:55:00',3.71),('8784','2013-06-17','11:00:00',3.74),('8784','2013-06-17','11:05:00',3.77),('8784','2013-06-17','11:10:00',3.78),('8784','2013-06-17','11:15:00',3.81),('8784','2013-06-17','11:20:00',3.84),('8784','2013-06-17','11:25:00',3.87),('8784','2013-06-17','11:30:00',3.89),('8784','2013-06-17','11:35:00',3.9),('8784','2013-06-17','11:40:00',3.92),('8784','2013-06-17','11:45:00',3.94),('8784','2013-06-17','11:50:00',3.96),('8784','2013-06-17','11:55:00',3.97),('8784','2013-06-17','12:00:00',3.94),('8784','2013-06-17','12:05:00',3.98),('8784','2013-06-17','12:10:00',3.97),('8784','2013-06-17','12:15:00',4),('8784','2013-06-17','12:20:00',4.01),('8784','2013-06-17','12:25:00',4.03),('8784','2013-06-17','12:30:00',3.99),('8784','2013-06-17','12:35:00',4.05),('8784','2013-06-17','12:40:00',4.06),('8784','2013-06-17','12:45:00',4.14),('8784','2013-06-17','12:50:00',4.13),('8784','2013-06-17','12:55:00',4.23),('8784','2013-06-17','13:00:00',4.26),('8784','2013-06-17','13:05:00',4.21),('8784','2013-06-17','13:10:00',4.18),('8784','2013-06-17','13:15:00',4.2),('8784','2013-06-17','13:20:00',4.18),('8784','2013-06-17','13:25:00',4.19),('8784','2013-06-17','13:30:00',4.16),('8784','2013-06-17','13:35:00',4.17),('8784','2013-06-17','13:40:00',4.15),('8784','2013-06-17','13:45:00',4.15),('8784','2013-06-17','13:50:00',4.16),('8784','2013-06-17','13:55:00',4.12),('8784','2013-06-17','14:00:00',4.1),('8784','2013-06-17','14:05:00',4.11),('8784','2013-06-17','14:10:00',4.11),('8784','2013-06-17','14:15:00',4.09),('8784','2013-06-17','14:20:00',4.08),('8784','2013-06-17','14:25:00',4.06),('8784','2013-06-17','14:30:00',4.01),('8784','2013-06-17','14:35:00',3.97),('8784','2013-06-17','14:40:00',4),('8784','2013-06-17','14:45:00',3.97),('8784','2013-06-17','14:50:00',3.93),('8784','2013-06-17','14:55:00',3.89),('8784','2013-06-17','15:00:00',3.87),('8784','2013-06-17','15:05:00',3.84),('8784','2013-06-17','15:10:00',3.8),('8784','2013-06-17','15:15:00',3.76),('8784','2013-06-17','15:20:00',3.75),('8784','2013-06-17','15:25:00',3.71),('8784','2013-06-17','15:30:00',3.66),('8784','2013-06-17','15:35:00',3.64),('8784','2013-06-17','15:40:00',3.58),('8784','2013-06-17','15:45:00',3.52),('8784','2013-06-17','15:50:00',3.48),('8784','2013-06-17','15:55:00',3.44),('8784','2013-06-17','16:00:00',3.4),('8784','2013-06-17','16:05:00',3.36),('8784','2013-06-17','16:10:00',3.32),('8784','2013-06-17','16:15:00',3.27),('8784','2013-06-17','16:20:00',3.19),('8784','2013-06-17','16:25:00',3.15),('8784','2013-06-17','16:30:00',3.1),('8784','2013-06-17','16:35:00',3.02),('8784','2013-06-17','16:40:00',2.97),('8784','2013-06-17','16:45:00',2.91),('8784','2013-06-17','16:50:00',2.86),('8784','2013-06-17','16:55:00',2.81),('8784','2013-06-17','17:00:00',2.73),('8784','2013-06-17','17:05:00',2.67),('8784','2013-06-17','17:10:00',2.61),('8784','2013-06-17','17:15:00',2.55),('8784','2013-06-17','17:20:00',2.49),('8784','2013-06-17','17:25:00',2.42),('8784','2013-06-17','17:30:00',2.37),('8784','2013-06-17','17:35:00',2.3),('8784','2013-06-17','17:40:00',2.22),('8784','2013-06-17','17:45:00',2.14),('8784','2013-06-17','17:50:00',2.06),('8784','2013-06-17','17:55:00',1.99),('8784','2013-06-17','18:00:00',1.91),('8784','2013-06-17','18:05:00',1.81),('8784','2013-06-17','18:10:00',1.76),('8784','2013-06-17','18:15:00',1.67),('8784','2013-06-17','18:20:00',1.61),('8784','2013-06-17','18:25:00',1.44),('8784','2013-06-17','18:30:00',1.43),('8784','2013-06-17','18:35:00',1.26),('8784','2013-06-17','18:40:00',1.29),('8784','2013-06-17','18:45:00',1.26),('8784','2013-06-17','18:50:00',1.19),('8784','2013-06-17','18:55:00',1.13),('8784','2013-06-17','19:00:00',1.06),('8784','2013-06-16','07:20:00',1.07),('8784','2013-06-16','07:25:00',1.11),('8784','2013-06-16','07:30:00',1.21),('8784','2013-06-16','07:35:00',1.31),('8784','2013-06-16','07:40:00',1.39),('8784','2013-06-16','07:45:00',1.47),('8784','2013-06-16','07:50:00',1.55),('8784','2013-06-16','07:55:00',1.62),('8784','2013-06-16','08:00:00',1.7),('8784','2013-06-16','08:05:00',1.77),('8784','2013-06-16','08:10:00',1.86),('8784','2013-06-16','08:15:00',1.93),('8784','2013-06-16','08:20:00',2.02),('8784','2013-06-16','08:25:00',2.11),('8784','2013-06-16','08:30:00',2.13),('8784','2013-06-16','08:35:00',2.23),('8784','2013-06-16','08:40:00',2.32),('8784','2013-06-16','08:45:00',2.42),('8784','2013-06-16','08:50:00',2.49),('8784','2013-06-16','08:55:00',2.53),('8784','2013-06-16','09:00:00',2.61),('8784','2013-06-16','09:05:00',2.68),('8784','2013-06-16','09:10:00',2.76),('8784','2013-06-16','09:15:00',2.82),('8784','2013-06-16','09:20:00',2.89),('8784','2013-06-16','09:25:00',2.97),('8784','2013-06-16','09:30:00',3),('8784','2013-06-16','09:35:00',3.07),('8784','2013-06-16','09:40:00',3.13),('8784','2013-06-16','09:45:00',3.12),('8784','2013-06-16','09:50:00',3.21),('8784','2013-06-16','09:55:00',3.28),('8784','2013-06-16','10:00:00',3.35),('8784','2013-06-16','10:05:00',3.39),('8784','2013-06-16','10:10:00',3.41),('8784','2013-06-16','10:15:00',3.43),('8784','2013-06-16','10:20:00',3.5),('8784','2013-06-16','10:25:00',3.54),('8784','2013-06-16','10:30:00',3.58),('8784','2013-06-16','10:35:00',3.6),('8784','2013-06-16','10:40:00',3.67),('8784','2013-06-16','10:45:00',3.71),('8784','2013-06-16','10:50:00',3.76),('8784','2013-06-16','10:55:00',3.8),('8784','2013-06-16','11:00:00',3.83),('8784','2013-06-16','11:05:00',3.86),('8784','2013-06-16','11:10:00',3.89),('8784','2013-06-16','11:15:00',3.95),('8784','2013-06-16','11:20:00',3.96),('8784','2013-06-16','11:25:00',4.02),('8784','2013-06-16','11:30:00',4.02),('8784','2013-06-16','11:35:00',4.08),('8784','2013-06-16','11:40:00',4.07),('8784','2013-06-16','11:45:00',4.09),('8784','2013-06-16','11:50:00',4.11),('8784','2013-06-16','11:55:00',4.14),('8784','2013-06-16','12:00:00',4.16),('8784','2013-06-16','12:05:00',4.21),('8784','2013-06-16','12:10:00',4.2),('8784','2013-06-16','12:15:00',4.23),('8784','2013-06-16','12:20:00',4.23),('8784','2013-06-16','12:25:00',4.2),('8784','2013-06-16','12:30:00',4.22),('8784','2013-06-16','12:35:00',4.22),('8784','2013-06-16','12:40:00',4.23),('8784','2013-06-16','12:45:00',4.24),('8784','2013-06-16','12:50:00',4.21),('8784','2013-06-16','12:55:00',4.28),('8784','2013-06-16','13:00:00',4.32),('8784','2013-06-16','13:05:00',4.34),('8784','2013-06-16','13:10:00',4.37),('8784','2013-06-16','13:15:00',4.34),('8784','2013-06-16','13:20:00',4.36),('8784','2013-06-16','13:25:00',4.36),('8784','2013-06-16','13:30:00',4.34),('8784','2013-06-16','13:35:00',4.38),('8784','2013-06-16','13:40:00',4.35),('8784','2013-06-16','13:45:00',4.33),('8784','2013-06-16','13:50:00',4.33),('8784','2013-06-16','13:55:00',4.28),('8784','2013-06-16','14:00:00',4.28),('8784','2013-06-16','14:05:00',4.26),('8784','2013-06-16','14:10:00',4.27),('8784','2013-06-16','14:15:00',4.26),('8784','2013-06-16','14:20:00',4.24),('8784','2013-06-16','14:25:00',4.21),('8784','2013-06-16','14:30:00',4.18),('8784','2013-06-16','14:35:00',4.1),('8784','2013-06-16','14:40:00',4.11),('8784','2013-06-16','14:45:00',4.08),('8784','2013-06-16','14:50:00',4.05),('8784','2013-06-16','14:55:00',4.02),('8784','2013-06-16','15:00:00',3.99),('8784','2013-06-16','15:05:00',3.97),('8784','2013-06-16','15:10:00',3.95),('8784','2013-06-16','15:15:00',3.9),('8784','2013-06-16','15:20:00',3.86),('8784','2013-06-16','15:25:00',3.83),('8784','2013-06-16','15:30:00',3.77),('8784','2013-06-16','15:35:00',3.74),('8784','2013-06-16','15:40:00',3.7),('8784','2013-06-16','15:45:00',3.68),('8784','2013-06-16','15:50:00',3.61),('8784','2013-06-16','15:55:00',3.55),('8784','2013-06-16','16:00:00',3.49),('8784','2013-06-16','16:05:00',3.44),('8784','2013-06-16','16:10:00',3.41),('8784','2013-06-16','16:15:00',3.34),('8784','2013-06-16','16:20:00',3.24),('8784','2013-06-16','16:25:00',3.23),('8784','2013-06-16','16:30:00',3.16),('8784','2013-06-16','16:35:00',3.1),('8784','2013-06-16','16:40:00',3.04),('8784','2013-06-16','16:45:00',2.96),('8784','2013-06-16','16:50:00',2.9),('8784','2013-06-16','16:55:00',2.83),('8784','2013-06-16','17:00:00',2.76),('8784','2013-06-16','17:05:00',2.68),('8784','2013-06-16','17:10:00',2.6),('8784','2013-06-16','17:15:00',2.54),('8784','2013-06-16','17:20:00',2.47),('8784','2013-06-16','17:25:00',2.39),('8784','2013-06-16','17:30:00',2.32),('8784','2013-06-16','17:35:00',2.23),('8784','2013-06-16','17:40:00',2.15),('8784','2013-06-16','17:45:00',2.07),('8784','2013-06-16','17:50:00',1.98),('8784','2013-06-16','17:55:00',1.9),('8784','2013-06-16','18:00:00',1.84),('8784','2013-06-16','18:05:00',1.75),('8784','2013-06-16','18:10:00',1.68),('8784','2013-06-16','18:15:00',1.59),('8784','2013-06-16','18:20:00',1.51),('8784','2013-06-16','18:25:00',1.44),('8784','2013-06-16','18:30:00',1.36),('8784','2013-06-16','18:35:00',1.28),('8784','2013-06-16','18:40:00',1.21),('8784','2013-06-16','18:45:00',1.13),('8784','2013-06-16','18:50:00',1.05),('8784','2013-06-15','07:20:00',1),('8784','2013-06-15','07:25:00',1.07),('8784','2013-06-15','07:30:00',1.15),('8784','2013-06-15','07:35:00',1.24),('8784','2013-06-15','07:40:00',1.32),('8784','2013-06-15','07:45:00',1.41),('8784','2013-06-15','07:50:00',1.49),('8784','2013-06-15','07:55:00',1.55),('8784','2013-06-15','08:00:00',1.63),('8784','2013-06-15','08:05:00',1.73),('8784','2013-06-15','08:10:00',1.78),('8784','2013-06-15','08:15:00',1.88),('8784','2013-06-15','08:20:00',1.95),('8784','2013-06-15','08:25:00',2),('8784','2013-06-15','08:30:00',2.12),('8784','2013-06-15','08:35:00',2.18),('8784','2013-06-15','08:40:00',2.19),('8784','2013-06-15','08:45:00',1.93),('8784','2013-06-15','08:50:00',2.43),('8784','2013-06-15','08:55:00',2.49),('8784','2013-06-15','09:00:00',2.46),('8784','2013-06-15','09:05:00',2.44),('8784','2013-06-15','09:10:00',2.66),('8784','2013-06-15','09:15:00',2.69),('8784','2013-06-15','09:20:00',2.16),('8784','2013-06-15','09:25:00',2.92),('8784','2013-06-15','09:30:00',2.97),('8784','2013-06-15','09:35:00',3.21),('8784','2013-06-15','09:40:00',3.19),('8784','2013-06-15','09:45:00',3.05),('8784','2013-06-15','09:50:00',3.17),('8784','2013-06-15','09:55:00',2.29),('8784','2013-06-15','10:00:00',2.18),('8784','2013-06-15','10:05:00',3.48),('8784','2013-06-15','10:10:00',3.35),('8784','2013-06-15','10:15:00',3.23),('8784','2013-06-15','10:20:00',2.71),('8784','2013-06-15','10:25:00',3.46),('8784','2013-06-15','10:30:00',2.75),('8784','2013-06-15','10:35:00',2.27),('8784','2013-06-15','10:40:00',2.64),('8784','2013-06-15','10:45:00',3.5),('8784','2013-06-15','10:50:00',2.4),('8784','2013-06-15','10:55:00',2.3),('8784','2013-06-15','11:00:00',3.81),('8784','2013-06-15','11:05:00',3.99),('8784','2013-06-15','11:10:00',3.58),('8784','2013-06-15','11:15:00',3.32),('8784','2013-06-15','11:20:00',2.2),('8784','2013-06-15','11:25:00',3.89),('8784','2013-06-15','11:30:00',4.19),('8784','2013-06-15','11:35:00',4.21),('8784','2013-06-15','11:40:00',4.24),('8784','2013-06-15','11:45:00',4.03),('8784','2013-06-15','11:50:00',4.37),('8784','2013-06-15','11:55:00',4.36),('8784','2013-06-15','12:00:00',4.39),('8784','2013-06-15','12:05:00',4.23),('8784','2013-06-15','12:10:00',4.38),('8784','2013-06-15','12:15:00',4.38),('8784','2013-06-15','12:20:00',4.36),('8784','2013-06-15','12:25:00',4.34),('8784','2013-06-15','12:30:00',4.35),('8784','2013-06-15','12:35:00',4.35),('8784','2013-06-15','12:40:00',4.37),('8784','2013-06-15','12:45:00',4.33),('8784','2013-06-15','12:50:00',4.38),('8784','2013-06-15','12:55:00',4.4),('8784','2013-06-15','13:00:00',4.38),('8784','2013-06-15','13:05:00',4.4),('8784','2013-06-15','13:10:00',4.38),('8784','2013-06-15','13:15:00',4.41),('8784','2013-06-15','13:20:00',4.36),('8784','2013-06-15','13:25:00',4.36),('8784','2013-06-15','13:30:00',4.32),('8784','2013-06-15','13:35:00',4.3),('8784','2013-06-15','13:40:00',4.34),('8784','2013-06-15','13:45:00',4.33),('8784','2013-06-15','13:50:00',4.26),('8784','2013-06-15','13:55:00',4.32),('8784','2013-06-15','14:00:00',4.28),('8784','2013-06-15','14:05:00',4.26),('8784','2013-06-15','14:10:00',4.24),('8784','2013-06-15','14:15:00',4.19),('8784','2013-06-15','14:20:00',4.19),('8784','2013-06-15','14:25:00',4.13),('8784','2013-06-15','14:30:00',4.1),('8784','2013-06-15','14:35:00',4.04),('8784','2013-06-15','14:40:00',4.08),('8784','2013-06-15','14:45:00',4.03),('8784','2013-06-15','14:50:00',4),('8784','2013-06-15','14:55:00',4),('8784','2013-06-15','15:00:00',3.93),('8784','2013-06-15','15:05:00',3.94),('8784','2013-06-15','15:10:00',3.92),('8784','2013-06-15','15:15:00',3.9),('8784','2013-06-15','15:20:00',3.87),('8784','2013-06-15','15:25:00',3.84),('8784','2013-06-15','15:30:00',3.81),('8784','2013-06-15','15:35:00',3.71),('8784','2013-06-15','15:40:00',3.71),('8784','2013-06-15','15:45:00',3.66),('8784','2013-06-15','15:50:00',3.61),('8784','2013-06-15','15:55:00',3.57),('8784','2013-06-15','16:00:00',3.51),('8784','2013-06-15','16:05:00',3.44),('8784','2013-06-15','16:10:00',3.38),('8784','2013-06-15','16:15:00',3.33),('8784','2013-06-15','16:20:00',3.27),('8784','2013-06-15','16:25:00',3.21),('8784','2013-06-15','16:30:00',3.16),('8784','2013-06-15','16:35:00',3.08),('8784','2013-06-15','16:40:00',3.01),('8784','2013-06-15','16:45:00',2.95),('8784','2013-06-15','16:50:00',2.88),('8784','2013-06-15','16:55:00',2.82),('8784','2013-06-15','17:00:00',2.75),('8784','2013-06-15','17:05:00',2.67),('8784','2013-06-15','17:10:00',2.61),('8784','2013-06-15','17:15:00',2.53),('8784','2013-06-15','17:20:00',2.45),('8784','2013-06-15','17:25:00',2.38),('8784','2013-06-15','17:30:00',2.29),('8784','2013-06-15','17:35:00',2.2),('8784','2013-06-15','17:40:00',2.12),('8784','2013-06-15','17:45:00',2.02),('8784','2013-06-15','17:50:00',1.93),('8784','2013-06-15','17:55:00',1.87),('8784','2013-06-15','18:00:00',1.81),('8784','2013-06-15','18:05:00',1.72),('8784','2013-06-15','18:10:00',1.64),('8784','2013-06-15','18:15:00',1.54),('8784','2013-06-15','18:20:00',1.47),('8784','2013-06-15','18:25:00',1.38),('8784','2013-06-15','18:30:00',1.32),('8784','2013-06-15','18:35:00',1.23),('8784','2013-06-15','18:40:00',1.18),('8784','2013-06-15','18:45:00',1.09),('8784','2013-06-15','18:50:00',1.01),('8784','2013-06-14','07:15:00',1.08),('8784','2013-06-14','07:20:00',1.16),('8784','2013-06-14','07:25:00',1.25),('8784','2013-06-14','07:30:00',1.32),('8784','2013-06-14','07:35:00',1.42),('8784','2013-06-14','07:40:00',1.5),('8784','2013-06-14','07:45:00',1.58),('8784','2013-06-14','07:50:00',1.66),('8784','2013-06-14','07:55:00',1.74),('8784','2013-06-14','08:00:00',1.82),('8784','2013-06-14','08:05:00',1.92),('8784','2013-06-14','08:10:00',2),('8784','2013-06-14','08:15:00',2.07),('8784','2013-06-14','08:20:00',2.15),('8784','2013-06-14','08:25:00',2.23),('8784','2013-06-14','08:30:00',2.31),('8784','2013-06-14','08:35:00',2.38),('8784','2013-06-14','08:40:00',2.46),('8784','2013-06-14','08:45:00',2.53),('8784','2013-06-14','08:50:00',2.62),('8784','2013-06-14','08:55:00',2.67),('8784','2013-06-14','09:00:00',2.75),('8784','2013-06-14','09:05:00',2.81),('8784','2013-06-14','09:10:00',2.88),('8784','2013-06-14','09:15:00',2.92),('8784','2013-06-14','09:20:00',3),('8784','2013-06-14','09:25:00',3.07),('8784','2013-06-14','09:30:00',3.1),('8784','2013-06-14','09:35:00',3.2),('8784','2013-06-14','09:40:00',3.27),('8784','2013-06-14','09:45:00',3.32),('8784','2013-06-14','09:50:00',3.37),('8784','2013-06-14','09:55:00',3.44),('8784','2013-06-14','10:00:00',3.48),('8784','2013-06-14','10:05:00',3.51),('8784','2013-06-14','10:10:00',3.57),('8784','2013-06-14','10:15:00',3.6),('8784','2013-06-14','10:20:00',3.64),('8784','2013-06-14','10:25:00',3.68),('8784','2013-06-14','10:30:00',3.66),('8784','2013-06-14','10:35:00',3.85),('8784','2013-06-14','10:40:00',3.88),('8784','2013-06-14','10:45:00',3.91),('8784','2013-06-14','10:50:00',3.91),('8784','2013-06-14','10:55:00',3.9),('8784','2013-06-14','11:00:00',3.87),('8784','2013-06-14','11:05:00',3.94),('8784','2013-06-14','11:10:00',3.99),('8784','2013-06-14','11:15:00',4.06),('8784','2013-06-14','11:20:00',4.05),('8784','2013-06-14','11:25:00',3.98),('8784','2013-06-14','11:30:00',4.18),('8784','2013-06-14','11:35:00',4.19),('8784','2013-06-14','11:40:00',4.22),('8784','2013-06-14','11:45:00',4.21),('8784','2013-06-14','11:50:00',4.22),('8784','2013-06-14','11:55:00',4.23),('8784','2013-06-14','12:00:00',4.24),('8784','2013-06-14','12:05:00',4.28),('8784','2013-06-14','12:10:00',4.27),('8784','2013-06-14','12:15:00',4.27),('8784','2013-06-14','12:20:00',4.28),('8784','2013-06-14','12:25:00',4.26),('8784','2013-06-14','12:30:00',4.3),('8784','2013-06-14','12:35:00',4.29),('8784','2013-06-14','12:40:00',4.27),('8784','2013-06-14','12:45:00',4.37),('8784','2013-06-14','12:50:00',4.31),('8784','2013-06-14','12:55:00',4.3),('8784','2013-06-14','13:00:00',4.33),('8784','2013-06-14','13:05:00',4.36),('8784','2013-06-14','13:10:00',4.42),('8784','2013-06-14','13:15:00',4.45),('8784','2013-06-14','13:20:00',4.43),('8784','2013-06-14','13:25:00',4.42),('8784','2013-06-14','13:30:00',4.34),('8784','2013-06-14','13:35:00',4.3),('8784','2013-06-14','13:40:00',4.34),('8784','2013-06-14','13:45:00',4.3),('8784','2013-06-14','13:50:00',4.34),('8784','2013-06-14','13:55:00',4.26),('8784','2013-06-14','14:00:00',4.23),('8784','2013-06-14','14:05:00',4.27),('8784','2013-06-14','14:10:00',4.29),('8784','2013-06-14','14:15:00',4.27),('8784','2013-06-14','14:20:00',4.21),('8784','2013-06-14','14:25:00',4.17),('8784','2013-06-14','14:30:00',4.15),('8784','2013-06-14','14:35:00',4.15),('8784','2013-06-14','14:40:00',4.13),('8784','2013-06-14','14:45:00',4.09),('8784','2013-06-14','14:50:00',4.06),('8784','2013-06-14','14:55:00',4.09),('8784','2013-06-14','15:00:00',4.06),('8784','2013-06-14','15:05:00',4.03),('8784','2013-06-14','15:10:00',4.01),('8784','2013-06-14','15:15:00',3.95),('8784','2013-06-14','15:20:00',3.86),('8784','2013-06-14','15:25:00',3.89),('8784','2013-06-14','15:30:00',3.87),('8784','2013-06-14','15:35:00',3.82),('8784','2013-06-14','15:40:00',3.77),('8784','2013-06-14','15:45:00',3.73),('8784','2013-06-14','15:50:00',3.69),('8784','2013-06-14','15:55:00',3.62),('8784','2013-06-14','16:00:00',3.56),('8784','2013-06-14','16:05:00',3.51),('8784','2013-06-14','16:10:00',3.44),('8784','2013-06-14','16:15:00',3.38),('8784','2013-06-14','16:20:00',3.32),('8784','2013-06-14','16:25:00',3.25),('8784','2013-06-14','16:30:00',3.18),('8784','2013-06-14','16:35:00',3.09),('8784','2013-06-14','16:40:00',3.05),('8784','2013-06-14','16:45:00',3.01),('8784','2013-06-14','16:50:00',2.95),('8784','2013-06-14','16:55:00',2.87),('8784','2013-06-14','17:00:00',2.82),('8784','2013-06-14','17:05:00',2.66),('8784','2013-06-14','17:10:00',2.64),('8784','2013-06-14','17:15:00',2.61),('8784','2013-06-14','17:20:00',2.52),('8784','2013-06-14','17:25:00',2.43),('8784','2013-06-14','17:30:00',2.29),('8784','2013-06-14','17:35:00',2.26),('8784','2013-06-14','17:40:00',2.23),('8784','2013-06-14','17:45:00',2.15),('8784','2013-06-14','17:50:00',2.07),('8784','2013-06-14','17:55:00',1.98),('8784','2013-06-14','18:00:00',1.88),('8784','2013-06-14','18:05:00',1.82),('8784','2013-06-14','18:10:00',1.74),('8784','2013-06-14','18:15:00',1.66),('8784','2013-06-14','18:20:00',1.56),('8784','2013-06-14','18:25:00',1.49),('8784','2013-06-14','18:30:00',1.41),('8784','2013-06-14','18:35:00',1.33),('8784','2013-06-14','18:40:00',1.26),('8784','2013-06-14','18:45:00',1.18),('8784','2013-06-14','18:50:00',1.09),('8784','2013-06-14','18:55:00',1.02),('8784','2013-06-13','07:10:00',1.01),('8784','2013-06-13','07:15:00',1.09),('8784','2013-06-13','07:20:00',1.17),('8784','2013-06-13','07:25:00',1.26),('8784','2013-06-13','07:30:00',1.34),('8784','2013-06-13','07:35:00',1.44),('8784','2013-06-13','07:40:00',1.52),('8784','2013-06-13','07:45:00',1.61),('8784','2013-06-13','07:50:00',1.69),('8784','2013-06-13','07:55:00',1.78),('8784','2013-06-13','08:00:00',1.86),('8784','2013-06-13','08:05:00',1.95),('8784','2013-06-13','08:10:00',2.03),('8784','2013-06-13','08:15:00',2.08),('8784','2013-06-13','08:20:00',2.18),('8784','2013-06-13','08:25:00',2.24),('8784','2013-06-13','08:30:00',2.3),('8784','2013-06-13','08:35:00',2.39),('8784','2013-06-13','08:40:00',2.46),('8784','2013-06-13','08:45:00',2.53),('8784','2013-06-13','08:50:00',2.6),('8784','2013-06-13','08:55:00',2.67),('8784','2013-06-13','09:00:00',2.75),('8784','2013-06-13','09:05:00',2.84),('8784','2013-06-13','09:10:00',2.91),('8784','2013-06-13','09:15:00',2.98),('8784','2013-06-13','09:20:00',3.04),('8784','2013-06-13','09:25:00',3.13),('8784','2013-06-13','09:30:00',3.21),('8784','2013-06-13','09:35:00',3.3),('8784','2013-06-13','09:40:00',3.37),('8784','2013-06-13','09:45:00',3.42),('8784','2013-06-13','09:50:00',3.49),('8784','2013-06-13','09:55:00',3.54),('8784','2013-06-13','10:00:00',3.57),('8784','2013-06-13','10:05:00',3.62),('8784','2013-06-13','10:10:00',3.67),('8784','2013-06-13','10:15:00',3.71),('8784','2013-06-13','10:20:00',3.76),('8784','2013-06-13','10:25:00',3.8),('8784','2013-06-13','10:30:00',3.85),('8784','2013-06-13','10:35:00',3.93),('8784','2013-06-13','10:40:00',3.95),('8784','2013-06-13','10:45:00',4.03),('8784','2013-06-13','10:50:00',4.06),('8784','2013-06-13','10:55:00',4.1),('8784','2013-06-13','11:00:00',4.12),('8784','2013-06-13','11:05:00',4.13),('8784','2013-06-13','11:10:00',4.16),('8784','2013-06-13','11:15:00',4.2),('8784','2013-06-13','11:20:00',4.17),('8784','2013-06-13','11:25:00',4.29),('8784','2013-06-13','11:30:00',4.32),('8784','2013-06-13','11:35:00',4.35),('8784','2013-06-13','11:40:00',4.39),('8784','2013-06-13','11:45:00',4.42),('8784','2013-06-13','11:50:00',4.45),('8784','2013-06-13','11:55:00',4.44),('8784','2013-06-13','12:00:00',4.45),('8784','2013-06-13','12:05:00',4.5),('8784','2013-06-13','12:10:00',4.51),('8784','2013-06-13','12:15:00',4.49),('8784','2013-06-13','12:20:00',4.5),('8784','2013-06-13','12:25:00',4.52),('8784','2013-06-13','12:30:00',4.56),('8784','2013-06-13','12:35:00',4.54),('8784','2013-06-13','12:40:00',4.53),('8784','2013-06-13','12:45:00',4.53),('8784','2013-06-13','12:50:00',4.54),('8784','2013-06-13','12:55:00',4.52),('8784','2013-06-13','13:00:00',4.55),('8784','2013-06-13','13:05:00',4.55),('8784','2013-06-13','13:10:00',4.53),('8784','2013-06-13','13:15:00',4.55),('8784','2013-06-13','13:20:00',4.5),('8784','2013-06-13','13:25:00',4.52),('8784','2013-06-13','13:30:00',4.49),('8784','2013-06-13','13:35:00',4.52),('8784','2013-06-13','13:40:00',4.5),('8784','2013-06-13','13:45:00',4.46),('8784','2013-06-13','13:50:00',4.46),('8784','2013-06-13','13:55:00',4.41),('8784','2013-06-13','14:00:00',4.43),('8784','2013-06-13','14:05:00',4.43),('8784','2013-06-13','14:10:00',4.39),('8784','2013-06-13','14:15:00',4.39),('8784','2013-06-13','14:20:00',4.39),('8784','2013-06-13','14:25:00',4.39),('8784','2013-06-13','14:30:00',3.57),('8784','2013-06-13','14:35:00',2.89),('8784','2013-06-13','14:40:00',4.42),('8784','2013-06-13','14:45:00',4.3),('8784','2013-06-13','14:50:00',4.17),('8784','2013-06-13','14:55:00',4.11),('8784','2013-06-13','15:00:00',4.15),('8784','2013-06-13','15:05:00',4.1),('8784','2013-06-13','15:10:00',4),('8784','2013-06-13','15:15:00',3.98),('8784','2013-06-13','15:20:00',3.93),('8784','2013-06-13','15:25:00',3.92),('8784','2013-06-13','15:30:00',3.87),('8784','2013-06-13','15:35:00',3.82),('8784','2013-06-13','15:40:00',3.77),('8784','2013-06-13','15:45:00',3.74),('8784','2013-06-13','15:50:00',3.69),('8784','2013-06-13','15:55:00',3.62),('8784','2013-06-13','16:00:00',3.57),('8784','2013-06-13','16:05:00',3.48),('8784','2013-06-13','16:10:00',3.43),('8784','2013-06-13','16:15:00',3.37),('8784','2013-06-13','16:20:00',3.29),('8784','2013-06-13','16:25:00',3.23),('8784','2013-06-13','16:30:00',3.16),('8784','2013-06-13','16:35:00',3.11),('8784','2013-06-13','16:40:00',3.04),('8784','2013-06-13','16:45:00',2.96),('8784','2013-06-13','16:50:00',2.86),('8784','2013-06-13','16:55:00',2.81),('8784','2013-06-13','17:00:00',2.75),('8784','2013-06-13','17:05:00',2.71),('8784','2013-06-13','17:10:00',2.63),('8784','2013-06-13','17:15:00',2.56),('8784','2013-06-13','17:20:00',2.52),('8784','2013-06-13','17:25:00',2.45),('8784','2013-06-13','17:30:00',2.37),('8784','2013-06-13','17:35:00',2.29),('8784','2013-06-13','17:40:00',2.19),('8784','2013-06-13','17:45:00',2.12),('8784','2013-06-13','17:50:00',2.03),('8784','2013-06-13','17:55:00',1.93),('8784','2013-06-13','18:00:00',1.85),('8784','2013-06-13','18:05:00',1.76),('8784','2013-06-13','18:10:00',1.68),('8784','2013-06-13','18:15:00',1.62),('8784','2013-06-13','18:20:00',1.55),('8784','2013-06-13','18:25:00',1.46),('8784','2013-06-13','18:30:00',1.38),('8784','2013-06-13','18:35:00',1.29),('8784','2013-06-13','18:40:00',1.21),('8784','2013-06-13','18:45:00',1.13),('8784','2013-06-13','18:50:00',1.06),('8784','2013-06-12','07:10:00',1.04),('8784','2013-06-12','07:15:00',1.11),('8784','2013-06-12','07:20:00',1.2),('8784','2013-06-12','07:25:00',1.28),('8784','2013-06-12','07:30:00',1.36),('8784','2013-06-12','07:35:00',1.44),('8784','2013-06-12','07:40:00',1.53),('8784','2013-06-12','07:45:00',1.62),('8784','2013-06-12','07:50:00',1.7),('8784','2013-06-12','07:55:00',1.78),('8784','2013-06-12','08:00:00',1.87),('8784','2013-06-12','08:05:00',1.95),('8784','2013-06-12','08:10:00',2.05),('8784','2013-06-12','08:15:00',2.13),('8784','2013-06-12','08:20:00',2.22),('8784','2013-06-12','08:25:00',2.31),('8784','2013-06-12','08:30:00',2.39),('8784','2013-06-12','08:35:00',2.45),('8784','2013-06-12','08:40:00',2.54),('8784','2013-06-12','08:45:00',2.63),('8784','2013-06-12','08:50:00',2.71),('8784','2013-06-12','08:55:00',2.77),('8784','2013-06-12','09:00:00',2.85),('8784','2013-06-12','09:05:00',2.93),('8784','2013-06-12','09:10:00',3),('8784','2013-06-12','09:15:00',3.08),('8784','2013-06-12','09:20:00',3.15),('8784','2013-06-12','09:25:00',3.2),('8784','2013-06-12','09:30:00',3.27),('8784','2013-06-12','09:35:00',3.32),('8784','2013-06-12','09:40:00',3.4),('8784','2013-06-12','09:45:00',3.46),('8784','2013-06-12','09:50:00',3.48),('8784','2013-06-12','09:55:00',3.55),('8784','2013-06-12','10:00:00',3.58),('8784','2013-06-12','10:05:00',3.66),('8784','2013-06-12','10:10:00',3.71),('8784','2013-06-12','10:15:00',3.74),('8784','2013-06-12','10:20:00',3.82),('8784','2013-06-12','10:25:00',3.88),('8784','2013-06-12','10:30:00',3.81),('8784','2013-06-12','10:35:00',3.92),('8784','2013-06-12','10:40:00',3.94),('8784','2013-06-12','10:45:00',3.99),('8784','2013-06-12','10:50:00',4.06),('8784','2013-06-12','10:55:00',4.14),('8784','2013-06-12','11:00:00',4.2),('8784','2013-06-12','11:05:00',4.24),('8784','2013-06-12','11:10:00',4.28),('8784','2013-06-12','11:15:00',4.29),('8784','2013-06-12','11:20:00',4.32),('8784','2013-06-12','11:25:00',4.3),('8784','2013-06-12','11:30:00',4.34),('8784','2013-06-12','11:35:00',4.31),('8784','2013-06-12','11:40:00',4.35),('8784','2013-06-12','11:45:00',4.4),('8784','2013-06-12','11:50:00',4.39),('8784','2013-06-12','11:55:00',4.46),('8784','2013-06-12','12:00:00',4.48),('8784','2013-06-12','12:05:00',4.42),('8784','2013-06-12','12:10:00',4.49),('8784','2013-06-12','12:15:00',4.51),('8784','2013-06-12','12:20:00',4.65),('8784','2013-06-12','12:25:00',3.45),('8784','2013-06-12','12:30:00',2.48),('8784','2013-06-12','12:35:00',4.86),('8784','2013-06-12','12:40:00',3.38),('8784','2013-06-12','12:45:00',1.26),('8784','2013-06-12','12:50:00',1.87),('8784','2013-06-12','12:55:00',2.65),('8784','2013-06-12','13:00:00',4.59),('8784','2013-06-12','13:05:00',1.67),('8784','2013-06-12','13:10:00',4.83),('8784','2013-06-12','13:15:00',4.68),('8784','2013-06-12','13:20:00',4.62),('8784','2013-06-12','13:25:00',4.42),('8784','2013-06-12','13:30:00',4.55),('8784','2013-06-12','13:35:00',4.58),('8784','2013-06-12','13:40:00',4.6),('8784','2013-06-12','13:45:00',4.19),('8784','2013-06-12','13:50:00',4.54),('8784','2013-06-12','13:55:00',4.64),('8784','2013-06-12','14:00:00',3.57),('8784','2013-06-12','14:05:00',2.73),('8784','2013-06-12','14:10:00',1.68),('8784','2013-06-12','14:15:00',4.6),('8784','2013-06-12','14:20:00',2.46),('8784','2013-06-12','14:25:00',2.9),('8784','2013-06-12','14:30:00',4.48),('8784','2013-06-12','14:35:00',3.69),('8784','2013-06-12','14:40:00',3.81),('8784','2013-06-12','14:45:00',4.51),('8784','2013-06-12','14:50:00',4.49),('8784','2013-06-12','14:55:00',4.46),('8784','2013-06-12','15:00:00',4.38),('8784','2013-06-12','15:05:00',4.32),('8784','2013-06-12','15:10:00',4.25),('8784','2013-06-12','15:15:00',3.56),('8784','2013-06-12','15:20:00',4.2),('8784','2013-06-12','15:25:00',4.01),('8784','2013-06-12','15:30:00',3.99),('8784','2013-06-12','15:35:00',3.99),('8784','2013-06-12','15:40:00',3.96),('8784','2013-06-12','15:45:00',3.9),('8784','2013-06-12','15:50:00',3.8),('8784','2013-06-12','15:55:00',3.82),('8784','2013-06-12','16:00:00',3.82),('8784','2013-06-12','16:05:00',3.62),('8784','2013-06-12','16:10:00',3.6),('8784','2013-06-12','16:15:00',3.54),('8784','2013-06-12','16:20:00',3.43),('8784','2013-06-12','16:25:00',3.44),('8784','2013-06-12','16:30:00',3.04),('8784','2013-06-12','16:35:00',3.16),('8784','2013-06-12','16:40:00',3.26),('8784','2013-06-12','16:45:00',2.93),('8784','2013-06-12','16:50:00',3.1),('8784','2013-06-12','16:55:00',2.4),('8784','2013-06-12','17:00:00',2.85),('8784','2013-06-12','17:05:00',2.81),('8784','2013-06-12','17:10:00',2.74),('8784','2013-06-12','17:15:00',2.66),('8784','2013-06-12','17:20:00',2.58),('8784','2013-06-12','17:25:00',2.5),('8784','2013-06-12','17:30:00',2.43),('8784','2013-06-12','17:35:00',2.38),('8784','2013-06-12','17:40:00',2.3),('8784','2013-06-12','17:45:00',1.08),('8784','2013-06-12','18:05:00',1.67),('8784','2013-06-12','18:10:00',1.77),('8784','2013-06-12','18:15:00',1.72),('8784','2013-06-12','18:20:00',1.65),('8784','2013-06-12','18:25:00',1.44),('8784','2013-06-12','18:30:00',1.41),('8784','2013-06-12','18:35:00',1.3),('8784','2013-06-12','18:40:00',1.21),('8784','2013-06-12','18:45:00',1.11),('8784','2013-06-12','18:50:00',1.03),('8784','2013-06-11','07:25:00',1.26),('8784','2013-06-11','07:30:00',1.27),('8784','2013-06-11','07:35:00',1.36),('8784','2013-06-11','07:40:00',1.45),('8784','2013-06-11','07:50:00',1.68),('8784','2013-06-11','07:55:00',1.82),('8784','2013-06-11','08:00:00',1.96),('8784','2013-06-11','08:05:00',2.06),('8784','2013-06-11','08:10:00',2.15),('8784','2013-06-11','08:15:00',1.69),('8784','2013-06-11','08:20:00',1.04),('8784','2013-06-11','08:25:00',2.56),('8784','2013-06-11','08:30:00',2.55),('8784','2013-06-11','08:35:00',2.61),('8784','2013-06-11','08:40:00',1.3),('8784','2013-06-11','08:45:00',2.17),('8784','2013-06-11','08:50:00',1.24),('8784','2013-06-11','09:00:00',2.2),('8784','2013-06-11','09:05:00',2.62),('8784','2013-06-11','09:10:00',3.15),('8784','2013-06-11','09:15:00',3.27),('8784','2013-06-11','09:20:00',3.35),('8784','2013-06-11','09:25:00',2.03),('8784','2013-06-11','09:30:00',2.75),('8784','2013-06-11','09:35:00',1.52),('8784','2013-06-11','09:40:00',2.47),('8784','2013-06-11','09:45:00',3.64),('8784','2013-06-11','09:50:00',3.64),('8784','2013-06-11','09:55:00',3.39),('8784','2013-06-11','10:00:00',2.79),('8784','2013-06-11','10:05:00',2.27),('8784','2013-06-11','10:10:00',3.28),('8784','2013-06-11','10:15:00',3.95),('8784','2013-06-11','10:20:00',4.04),('8784','2013-06-11','10:25:00',4.02),('8784','2013-06-11','10:30:00',4),('8784','2013-06-11','10:35:00',4.07),('8784','2013-06-11','10:40:00',3.92),('8784','2013-06-11','10:45:00',4.18),('8784','2013-06-11','10:50:00',3.24),('8784','2013-06-11','10:55:00',1.09),('8784','2013-06-11','11:00:00',4.55),('8784','2013-06-11','11:05:00',2.76),('8784','2013-06-11','11:10:00',2.69),('8784','2013-06-11','11:15:00',4.6),('8784','2013-06-11','11:20:00',4.41),('8784','2013-06-11','11:25:00',4.42),('8784','2013-06-11','11:30:00',4.42),('8784','2013-06-11','11:35:00',4.42),('8784','2013-06-11','11:40:00',4.42),('8784','2013-06-11','11:45:00',4.5),('8784','2013-06-11','11:50:00',4.55),('8784','2013-06-11','11:55:00',4.55),('8784','2013-06-11','12:00:00',4.6),('8784','2013-06-11','12:05:00',4.67),('8784','2013-06-11','12:10:00',4.62),('8784','2013-06-11','12:15:00',4.63),('8784','2013-06-11','12:20:00',4.68),('8784','2013-06-11','12:25:00',4.63),('8784','2013-06-11','12:30:00',4.66),('8784','2013-06-11','12:35:00',4.67),('8784','2013-06-11','12:40:00',4.68),('8784','2013-06-11','12:45:00',4.7),('8784','2013-06-11','12:50:00',4.75),('8784','2013-06-11','12:55:00',4.73),('8784','2013-06-11','13:00:00',4.71),('8784','2013-06-11','13:05:00',4.73),('8784','2013-06-11','13:10:00',4.74),('8784','2013-06-11','13:15:00',4.77),('8784','2013-06-11','13:20:00',4.74),('8784','2013-06-11','13:25:00',4.73),('8784','2013-06-11','13:30:00',4.75),('8784','2013-06-11','13:35:00',4.7),('8784','2013-06-11','13:40:00',4.76),('8784','2013-06-11','13:45:00',4.3),('8784','2013-06-11','13:50:00',3.5),('8784','2013-06-11','13:55:00',4.74),('8784','2013-06-11','14:00:00',4.72),('8784','2013-06-11','14:05:00',4.62),('8784','2013-06-11','14:10:00',4.59),('8784','2013-06-11','14:15:00',4.54),('8784','2013-06-11','14:20:00',4.51),('8784','2013-06-11','14:25:00',4.49),('8784','2013-06-11','14:30:00',4.46),('8784','2013-06-11','14:35:00',4.41),('8784','2013-06-11','14:40:00',4.34),('8784','2013-06-11','14:45:00',4.39),('8784','2013-06-11','14:50:00',4.34),('8784','2013-06-11','14:55:00',4.28),('8784','2013-06-11','15:00:00',4.26),('8784','2013-06-11','15:05:00',4.24),('8784','2013-06-11','15:10:00',4.22),('8784','2013-06-11','15:15:00',4.16),('8784','2013-06-11','15:20:00',4.12),('8784','2013-06-11','15:25:00',4.04),('8784','2013-06-11','15:30:00',4.04),('8784','2013-06-11','15:35:00',4.05),('8784','2013-06-11','15:40:00',3.89),('8784','2013-06-11','15:45:00',4.08),('8784','2013-06-11','15:50:00',3.86),('8784','2013-06-11','15:55:00',3.86),('8784','2013-06-11','16:00:00',3.71),('8784','2013-06-11','16:05:00',3.74),('8784','2013-06-11','16:10:00',3.65),('8784','2013-06-11','16:15:00',3.59),('8784','2013-06-11','16:20:00',3.54),('8784','2013-06-11','16:25:00',3.43),('8784','2013-06-11','16:30:00',3.44),('8784','2013-06-11','16:35:00',3.38),('8784','2013-06-11','16:40:00',3.41),('8784','2013-06-11','16:45:00',3.57),('8784','2013-06-11','16:50:00',3.58),('8784','2013-06-11','16:55:00',3.44),('8784','2013-06-11','17:00:00',2.87),('8784','2013-06-11','17:05:00',1.89),('8784','2014-04-03','08:50:00',1.02),('8784','2014-04-03','08:55:00',1.17),('8784','2014-04-03','09:00:00',1.3),('8784','2014-04-03','09:05:00',1.41),('8784','2014-04-03','09:10:00',1.36),('8784','2014-04-03','09:15:00',1.25),('8784','2014-04-03','09:20:00',1.27),('8784','2014-04-03','09:25:00',1.35),('8784','2014-04-03','09:30:00',1.59),('8784','2014-04-03','09:35:00',1.89),('8784','2014-04-03','09:40:00',2),('8784','2014-04-03','09:45:00',1.97),('8784','2014-04-03','09:50:00',1.87),('8784','2014-04-03','09:55:00',1.97),('8784','2014-04-03','10:00:00',2.33),('8784','2014-04-03','10:05:00',2.69),('8784','2014-04-03','10:10:00',2.85),('8784','2014-04-03','10:15:00',3.23),('8784','2014-04-03','10:20:00',3.25),('8784','2014-04-03','10:25:00',2.89),('8784','2014-04-03','10:30:00',2.77),('8784','2014-04-03','10:35:00',2.97),('8784','2014-04-03','10:40:00',2.35),('8784','2014-04-03','10:45:00',2.54),('8784','2014-04-03','10:50:00',2.22),('8784','2014-04-03','10:55:00',2.31),('8784','2014-04-03','11:00:00',2.17),('8784','2014-04-03','11:05:00',1.84),('8784','2014-04-03','11:10:00',1.75),('8784','2014-04-03','11:15:00',1.64),('8784','2014-04-03','11:20:00',1.57),('8784','2014-04-03','11:25:00',1.45),('8784','2014-04-03','11:30:00',1.44),('8784','2014-04-03','11:35:00',1.53),('8784','2014-04-03','11:40:00',1.67),('8784','2014-04-03','11:45:00',1.91),('8784','2014-04-03','11:50:00',2.32),('8784','2014-04-03','11:55:00',2.54),('8784','2014-04-03','12:00:00',2.42),('8784','2014-04-03','12:05:00',2.44),('8784','2014-04-03','12:10:00',2.37),('8784','2014-04-03','12:15:00',2.32),('8784','2014-04-03','12:20:00',2.6),('8784','2014-04-03','12:25:00',3.16),('8784','2014-04-03','12:30:00',3.93),('8784','2014-04-03','12:35:00',3.87),('8784','2014-04-03','12:40:00',4.3),('8784','2014-04-03','12:45:00',2.42),('8784','2014-04-03','12:50:00',2.93),('8784','2014-04-03','12:55:00',2.83),('8784','2014-04-03','13:00:00',2.74),('8784','2014-04-03','13:05:00',3.47),('8784','2014-04-03','13:10:00',2.68),('8784','2014-04-03','13:15:00',4.7),('8784','2014-04-03','13:20:00',2.83),('8784','2014-04-03','13:25:00',2.95),('8784','2014-04-03','13:30:00',3.01),('8784','2014-04-03','13:35:00',4.67),('8784','2014-04-03','13:40:00',4.03),('8784','2014-04-03','13:45:00',2.25),('8784','2014-04-03','13:50:00',2.26),('8784','2014-04-03','13:55:00',2.76),('8784','2014-04-03','14:00:00',3.84),('8784','2014-04-03','14:05:00',3.55),('8784','2014-04-03','14:10:00',2.81),('8784','2014-04-03','14:15:00',3.72),('8784','2014-04-03','14:20:00',3.77),('8784','2014-04-03','14:25:00',3.89),('8784','2014-04-03','14:30:00',3.93),('8784','2014-04-03','14:35:00',3.97),('8784','2014-04-03','14:40:00',3.82),('8784','2014-04-03','14:45:00',3.74),('8784','2014-04-03','14:50:00',3.68),('8784','2014-04-03','14:55:00',3.57),('8784','2014-04-03','15:00:00',3.51),('8784','2014-04-03','15:05:00',3.49),('8784','2014-04-03','15:10:00',3.45),('8784','2014-04-03','15:15:00',3.43),('8784','2014-04-03','15:20:00',3.42),('8784','2014-04-03','15:25:00',3.39),('8784','2014-04-03','15:30:00',3.34),('8784','2014-04-03','15:35:00',3.27),('8784','2014-04-03','15:40:00',3.24),('8784','2014-04-03','15:45:00',3.19),('8784','2014-04-03','15:50:00',3.13),('8784','2014-04-03','15:55:00',3.1),('8784','2014-04-03','16:00:00',3.08),('8784','2014-04-03','16:05:00',2.99),('8784','2014-04-03','16:10:00',2.97),('8784','2014-04-03','16:15:00',2.85),('8784','2014-04-03','16:20:00',2.81),('8784','2014-04-03','16:25:00',2.7),('8784','2014-04-03','16:30:00',2.62),('8784','2014-04-03','16:35:00',2.56),('8784','2014-04-03','16:40:00',2.49),('8784','2014-04-03','16:45:00',2.35),('8784','2014-04-03','16:50:00',1.74),('8784','2014-04-03','16:55:00',1.43),('8784','2014-04-03','17:00:00',1.1),('8784','2014-04-03','17:05:00',1),('8784','2014-04-03','17:25:00',1.02),('8784','2014-04-03','17:45:00',1.11),('8784','2014-04-03','17:50:00',1.33),('8784','2014-04-03','17:55:00',1.18),('8784','2014-04-03','18:00:00',1.07),('8784','2013-06-10','07:25:00',1.03),('8784','2013-06-10','07:30:00',1.37),('8784','2013-06-10','07:35:00',1.88),('8784','2013-06-10','07:40:00',1.1),('8784','2013-06-10','08:00:00',1.32),('8784','2013-06-10','08:05:00',1.85),('8784','2013-06-10','08:10:00',2.38),('8784','2013-06-10','08:15:00',1.74),('8784','2013-06-10','08:20:00',1.95),('8784','2013-06-10','08:25:00',1.7),('8784','2013-06-10','08:30:00',1.27),('8784','2013-06-10','08:35:00',1.14),('8784','2013-06-10','08:40:00',1.45),('8784','2013-06-10','08:55:00',1.15),('8784','2013-06-10','09:00:00',1.24),('8784','2013-06-10','09:05:00',1.2),('8784','2013-06-10','09:10:00',1.58),('8784','2013-06-10','09:15:00',1.41),('8784','2013-06-10','09:20:00',2.02),('8784','2013-06-10','09:25:00',3.07),('8784','2013-06-10','09:30:00',2.46),('8784','2013-06-10','09:35:00',3.56),('8784','2013-06-10','09:40:00',2.02),('8784','2013-06-10','09:45:00',3.64),('8784','2013-06-10','09:50:00',2.05),('8784','2013-06-10','09:55:00',1.73),('8784','2013-06-10','10:00:00',2.39),('8784','2013-06-10','10:05:00',2.46),('8784','2013-06-10','10:10:00',1.58),('8784','2013-06-10','10:15:00',2.26),('8784','2013-06-10','10:20:00',2.35),('8784','2013-06-10','10:25:00',1.82),('8784','2013-06-10','10:30:00',1.57),('8784','2013-06-10','10:35:00',2.01),('8784','2013-06-10','10:40:00',1.73),('8784','2013-06-10','10:45:00',1.34),('8784','2013-06-10','10:50:00',1.92),('8784','2013-06-10','10:55:00',3.76),('8784','2013-06-10','11:00:00',2.61),('8784','2013-06-10','11:05:00',2.43),('8784','2013-06-10','11:10:00',2.88),('8784','2013-06-10','11:15:00',4.12),('8784','2013-06-10','11:20:00',4.51),('8784','2013-06-10','11:25:00',4.06),('8784','2013-06-10','11:30:00',4.38),('8784','2013-06-10','11:35:00',4.53),('8784','2013-06-10','11:40:00',2.91),('8784','2013-06-10','11:45:00',3.63),('8784','2013-06-10','11:50:00',2.02),('8784','2013-06-10','11:55:00',4.6),('8784','2013-06-10','12:00:00',4.13),('8784','2013-06-10','12:05:00',1.51),('8784','2013-06-10','12:10:00',4.75),('8784','2013-06-10','12:15:00',4.67),('8784','2013-06-10','12:20:00',4.87),('8784','2013-06-10','12:25:00',5.05),('8784','2013-06-10','12:30:00',5.17),('8784','2013-06-10','12:35:00',4.23),('8784','2013-06-10','12:40:00',3.5),('8784','2013-06-10','12:45:00',3.26),('8784','2013-06-10','12:50:00',2.71),('8784','2013-06-10','12:55:00',3.62),('8784','2013-06-10','13:00:00',5.6),('8784','2013-06-10','13:05:00',4.1),('8784','2013-06-10','13:10:00',2.32),('8784','2013-06-10','13:15:00',4.49),('8784','2013-06-10','13:20:00',3.56),('8784','2013-06-10','13:25:00',2.97),('8784','2013-06-10','13:30:00',2.71),('8784','2013-06-10','13:35:00',4.72),('8784','2013-06-10','13:40:00',3.55),('8784','2013-06-10','13:45:00',3.83),('8784','2013-06-10','13:50:00',3.83),('8784','2013-06-10','13:55:00',4.81),('8784','2013-06-10','14:00:00',4.47),('8784','2013-06-10','14:05:00',4.92),('8784','2013-06-10','14:10:00',4.16),('8784','2013-06-10','14:15:00',4.75),('8784','2013-06-10','14:20:00',4.65),('8784','2013-06-10','14:25:00',4.57),('8784','2013-06-10','14:30:00',4.47),('8784','2013-06-10','14:35:00',4.49),('8784','2013-06-10','14:40:00',3.99),('8784','2013-06-10','14:45:00',4.45),('8784','2013-06-10','14:50:00',4.37),('8784','2013-06-10','14:55:00',4.34),('8784','2013-06-10','15:00:00',4.3),('8784','2013-06-10','15:05:00',4.18),('8784','2013-06-10','15:10:00',4.22),('8784','2013-06-10','15:15:00',4.19),('8784','2013-06-10','15:20:00',4.15),('8784','2013-06-10','15:25:00',4.12),('8784','2013-06-10','15:30:00',4.09),('8784','2013-06-10','15:35:00',4.06),('8784','2013-06-10','15:40:00',4.01),('8784','2013-06-10','15:45:00',3.96),('8784','2013-06-10','15:50:00',3.9),('8784','2013-06-10','15:55:00',3.85),('8784','2013-06-10','16:00:00',3.77),('8784','2013-06-10','16:05:00',3.71),('8784','2013-06-10','16:10:00',3.66),('8784','2013-06-10','16:15:00',3.61),('8784','2013-06-10','16:20:00',3.51),('8784','2013-06-10','16:25:00',3.47),('8784','2013-06-10','16:30:00',3.39),('8784','2013-06-10','16:35:00',3.34),('8784','2013-06-10','16:40:00',3.26),('8784','2013-06-10','16:45:00',3.19),('8784','2013-06-10','16:50:00',3.13),('8784','2013-06-10','16:55:00',3.04),('8784','2013-06-10','17:00:00',2.99),('8784','2013-06-10','17:05:00',2.93),('8784','2013-06-10','17:10:00',2.85),('8784','2013-06-10','17:15:00',2.78),('8784','2013-06-10','17:20:00',2.7),('8784','2013-06-10','17:25:00',2.61),('8784','2013-06-10','17:30:00',2.52),('8784','2013-06-10','17:35:00',2.44),('8784','2013-06-10','17:40:00',2.33),('8784','2013-06-10','17:45:00',2.26),('8784','2013-06-10','17:50:00',2.18),('8784','2013-06-10','17:55:00',2.09),('8784','2013-06-10','18:00:00',2.02),('8784','2013-06-10','18:05:00',1.92),('8784','2013-06-10','18:10:00',1.81),('8784','2013-06-10','18:15:00',1.74),('8784','2013-06-10','18:20:00',1.66),('8784','2013-06-10','18:25:00',1.57),('8784','2013-06-10','18:30:00',1.48),('8784','2013-06-10','18:35:00',1.39),('8784','2013-06-10','18:40:00',1.3),('8784','2013-06-10','18:45:00',1.22),('8784','2013-06-10','18:50:00',1.14),('8784','2013-06-10','18:55:00',1.05),('8784','2013-06-09','07:35:00',1.42),('8784','2013-06-09','07:40:00',1.32),('8784','2013-06-09','07:50:00',1.18),('8784','2013-06-09','07:55:00',1.65),('8784','2013-06-09','08:00:00',1.69),('8784','2013-06-09','08:05:00',1.74),('8784','2013-06-09','08:10:00',1.89),('8784','2013-06-09','08:15:00',1.53),('8784','2013-06-09','08:20:00',1.33),('8784','2013-06-09','08:25:00',2.2),('8784','2013-06-09','08:30:00',2.28),('8784','2013-06-09','08:35:00',2.37),('8784','2013-06-09','08:40:00',2.4),('8784','2013-06-09','08:45:00',2.45),('8784','2013-06-09','08:50:00',2.57),('8784','2013-06-09','08:55:00',2.63),('8784','2013-06-09','09:00:00',2.68),('8784','2013-06-09','09:05:00',2.74),('8784','2013-06-09','09:10:00',2.77),('8784','2013-06-09','09:15:00',2.89),('8784','2013-06-09','09:20:00',2.92),('8784','2013-06-09','09:25:00',3.02),('8784','2013-06-09','09:30:00',3.12),('8784','2013-06-09','09:35:00',3.14),('8784','2013-06-09','09:40:00',3.14),('8784','2013-06-09','09:45:00',3.21),('8784','2013-06-09','09:50:00',3.33),('8784','2013-06-09','09:55:00',3.39),('8784','2013-06-09','10:00:00',3.42),('8784','2013-06-09','10:05:00',3.46),('8784','2013-06-09','10:10:00',3.52),('8784','2013-06-09','10:15:00',3.55),('8784','2013-06-09','10:20:00',3.57),('8784','2013-06-09','10:25:00',3.61),('8784','2013-06-09','10:30:00',3.73),('8784','2013-06-09','10:35:00',3.77),('8784','2013-06-09','10:40:00',3.81),('8784','2013-06-09','10:45:00',3.81),('8784','2013-06-09','10:50:00',3.87),('8784','2013-06-09','10:55:00',3.88),('8784','2013-06-09','11:00:00',3.87),('8784','2013-06-09','11:05:00',3.87),('8784','2013-06-09','11:10:00',3.93),('8784','2013-06-09','11:15:00',4.03),('8784','2013-06-09','11:20:00',4),('8784','2013-06-09','11:25:00',4),('8784','2013-06-09','11:30:00',4.02),('8784','2013-06-09','11:35:00',4.07),('8784','2013-06-09','11:40:00',4.11),('8784','2013-06-09','11:45:00',4.22),('8784','2013-06-09','11:50:00',4.21),('8784','2013-06-09','11:55:00',4.15),('8784','2013-06-09','12:00:00',4.18),('8784','2013-06-09','12:05:00',4.22),('8784','2013-06-09','12:10:00',3.69),('8784','2013-06-09','12:15:00',4.18),('8784','2013-06-09','12:20:00',4.21),('8784','2013-06-09','12:25:00',4.26),('8784','2013-06-09','12:30:00',4.27),('8784','2013-06-09','12:35:00',4.22),('8784','2013-06-09','12:40:00',4.27),('8784','2013-06-09','12:45:00',4.23),('8784','2013-06-09','12:50:00',4.44),('8784','2013-06-09','12:55:00',4.05),('8784','2013-06-09','13:00:00',4.03),('8784','2013-06-09','13:05:00',3.22),('8784','2013-06-09','13:10:00',2.26),('8784','2013-06-09','13:15:00',2.73),('8784','2013-06-09','13:20:00',3.51),('8784','2013-06-09','13:25:00',4.72),('8784','2013-06-09','13:30:00',4.5),('8784','2013-06-09','13:35:00',4.57),('8784','2013-06-09','13:40:00',4.73),('8784','2013-06-09','13:45:00',4.76),('8784','2013-06-09','13:50:00',4.94),('8784','2013-06-09','13:55:00',4.31),('8784','2013-06-09','14:00:00',4.61),('8784','2013-06-09','14:05:00',4.59),('8784','2013-06-09','14:10:00',4.48),('8784','2013-06-09','14:15:00',3),('8784','2013-06-09','14:20:00',1.93),('8784','2013-06-09','14:25:00',1.24),('8784','2013-06-09','14:30:00',1.68),('8784','2013-06-09','14:35:00',4.03),('8784','2013-06-09','14:40:00',4.23),('8784','2013-06-09','14:45:00',4.11),('8784','2013-06-09','14:50:00',4.28),('8784','2013-06-09','14:55:00',4.3),('8784','2013-06-09','15:00:00',4.21),('8784','2013-06-09','15:05:00',4.03),('8784','2013-06-09','15:10:00',4.07),('8784','2013-06-09','15:15:00',3.97),('8784','2013-06-09','15:20:00',3.92),('8784','2013-06-09','15:25:00',3.93),('8784','2013-06-09','15:30:00',3.74),('8784','2013-06-09','15:35:00',3.8),('8784','2013-06-09','15:40:00',3.04),('8784','2013-06-09','15:45:00',3.16),('8784','2013-06-09','15:50:00',3.57),('8784','2013-06-09','15:55:00',3.75),('8784','2013-06-09','16:00:00',2.48),('8784','2013-06-09','16:05:00',3.46),('8784','2013-06-09','16:10:00',3.34),('8784','2013-06-09','16:15:00',1.56),('8784','2013-06-09','16:20:00',1.68),('8784','2013-06-09','16:25:00',2.38),('8784','2013-06-09','16:30:00',1.46),('8784','2013-06-09','16:35:00',1.05),('8784','2013-06-09','16:40:00',1.02),('8784','2013-06-09','16:45:00',1.03),('8784','2013-06-09','17:05:00',1.08),('8784','2013-06-09','17:10:00',1.05),('8784','2013-06-09','18:00:00',1.09),('8784','2013-06-09','18:10:00',1.52),('8784','2013-06-09','18:15:00',1.05),('8784','2013-06-09','18:30:00',1),('8784','2013-06-08','07:15:00',1.04),('8784','2013-06-08','07:20:00',1.12),('8784','2013-06-08','07:25:00',1.2),('8784','2013-06-08','07:30:00',1.25),('8784','2013-06-08','07:35:00',1.35),('8784','2013-06-08','07:40:00',1.45),('8784','2013-06-08','07:45:00',1.52),('8784','2013-06-08','07:50:00',1.6),('8784','2013-06-08','07:55:00',1.67),('8784','2013-06-08','08:00:00',1.73),('8784','2013-06-08','08:05:00',1.83),('8784','2013-06-08','08:10:00',1.92),('8784','2013-06-08','08:15:00',2),('8784','2013-06-08','08:20:00',2.09),('8784','2013-06-08','08:25:00',2.16),('8784','2013-06-08','08:30:00',2.25),('8784','2013-06-08','08:35:00',2.33),('8784','2013-06-08','08:40:00',2.41),('8784','2013-06-08','08:45:00',2.5),('8784','2013-06-08','08:50:00',2.58),('8784','2013-06-08','08:55:00',2.64),('8784','2013-06-08','09:00:00',2.68),('8784','2013-06-08','09:05:00',2.76),('8784','2013-06-08','09:10:00',2.83),('8784','2013-06-08','09:15:00',2.88),('8784','2013-06-08','09:20:00',2.93),('8784','2013-06-08','09:25:00',2.98),('8784','2013-06-08','09:30:00',3.09),('8784','2013-06-08','09:35:00',3.14),('8784','2013-06-08','09:40:00',3.21),('8784','2013-06-08','09:45:00',3.26),('8784','2013-06-08','09:50:00',3.35),('8784','2013-06-08','09:55:00',3.45),('8784','2013-06-08','10:00:00',3.45),('8784','2013-06-08','10:05:00',3.43),('8784','2013-06-08','10:10:00',3.62),('8784','2013-06-08','10:15:00',3.43),('8784','2013-06-08','10:20:00',3.65),('8784','2013-06-08','10:25:00',3.57),('8784','2013-06-08','10:30:00',3.37),('8784','2013-06-08','10:35:00',3.79),('8784','2013-06-08','10:40:00',3.96),('8784','2013-06-08','10:45:00',4),('8784','2013-06-08','10:50:00',4.19),('8784','2013-06-08','10:55:00',2),('8784','2013-06-08','11:00:00',2.13),('8784','2013-06-08','11:05:00',4.02),('8784','2013-06-08','11:10:00',2.66),('8784','2013-06-08','11:15:00',4.8),('8784','2013-06-08','11:20:00',4.65),('8784','2013-06-08','11:25:00',1.93),('8784','2013-06-08','11:30:00',1.17),('8784','2013-06-08','11:35:00',4.44),('8784','2013-06-08','11:40:00',4.69),('8784','2013-06-08','11:45:00',2.71),('8784','2013-06-08','11:50:00',4.42),('8784','2013-06-08','11:55:00',3.62),('8784','2013-06-08','12:00:00',4.69),('8784','2013-06-08','12:05:00',1.24),('8784','2013-06-08','12:10:00',3.59),('8784','2013-06-08','12:15:00',3.38),('8784','2013-06-08','12:20:00',1.28),('8784','2013-06-08','12:25:00',3.14),('8784','2013-06-08','12:30:00',1.2),('8784','2013-06-08','12:35:00',3.91),('8784','2013-06-08','12:40:00',4.62),('8784','2013-06-08','12:45:00',4.16),('8784','2013-06-08','12:50:00',4.75),('8784','2013-06-08','12:55:00',4.61),('8784','2013-06-08','13:00:00',4.69),('8784','2013-06-08','13:05:00',4.63),('8784','2013-06-08','13:10:00',4.16),('8784','2013-06-08','13:15:00',4.17),('8784','2013-06-08','13:20:00',4.75),('8784','2013-06-08','13:25:00',4.7),('8784','2013-06-08','13:30:00',4.76),('8784','2013-06-08','13:35:00',4.61),('8784','2013-06-08','13:40:00',4.59),('8784','2013-06-08','13:45:00',4.56),('8784','2013-06-08','13:50:00',4.55),('8784','2013-06-08','13:55:00',4.51),('8784','2013-06-08','14:00:00',4.53),('8784','2013-06-08','14:05:00',4.52),('8784','2013-06-08','14:10:00',4.52),('8784','2013-06-08','14:15:00',4.47),('8784','2013-06-08','14:20:00',4.43),('8784','2013-06-08','14:25:00',4.43),('8784','2013-06-08','14:30:00',4.38),('8784','2013-06-08','14:35:00',4.34),('8784','2013-06-08','14:40:00',4.35),('8784','2013-06-08','14:45:00',4.31),('8784','2013-06-08','14:50:00',4.31),('8784','2013-06-08','14:55:00',4.28),('8784','2013-06-08','15:00:00',4.26),('8784','2013-06-08','15:05:00',4.1),('8784','2013-06-08','15:10:00',3.78),('8784','2013-06-08','15:15:00',3.97),('8784','2013-06-08','15:20:00',4.11),('8784','2013-06-08','15:25:00',3.84),('8784','2013-06-08','15:30:00',3.9),('8784','2013-06-08','15:35:00',3.9),('8784','2013-06-08','15:40:00',3.85),('8784','2013-06-08','15:45:00',4.01),('8784','2013-06-08','15:50:00',4.03),('8784','2013-06-08','15:55:00',3.67),('8784','2013-06-08','16:00:00',3.77),('8784','2013-06-08','16:05:00',3.76),('8784','2013-06-08','16:10:00',3.75),('8784','2013-06-08','16:15:00',3.72),('8784','2013-06-08','16:20:00',3.63),('8784','2013-06-08','16:25:00',3.47),('8784','2013-06-08','16:30:00',3.3),('8784','2013-06-08','16:35:00',3.21),('8784','2013-06-08','16:40:00',3.17),('8784','2013-06-08','16:45:00',3.1),('8784','2013-06-08','16:50:00',2.63),('8784','2013-06-08','16:55:00',2.69),('8784','2013-06-08','17:00:00',2.95),('8784','2013-06-08','17:05:00',2.81),('8784','2013-06-08','17:10:00',3.09),('8784','2013-06-08','17:15:00',3.03),('8784','2013-06-08','17:20:00',2.87),('8784','2013-06-08','17:25:00',2.67),('8784','2013-06-08','17:30:00',1.95),('8784','2013-06-08','17:35:00',1.48),('8784','2013-06-08','17:40:00',2.26),('8784','2013-06-08','17:45:00',2.38),('8784','2013-06-08','17:50:00',2.18),('8784','2013-06-08','17:55:00',2.2),('8784','2013-06-08','18:00:00',1.8),('8784','2013-06-08','18:05:00',1.58),('8784','2013-06-08','18:10:00',1.31),('8784','2013-06-08','18:15:00',1.35),('8784','2013-06-08','18:20:00',1.29),('8784','2013-06-08','18:25:00',1.2),('8784','2013-06-07','07:10:00',1.01),('8784','2013-06-07','07:15:00',1.09),('8784','2013-06-07','07:20:00',1.18),('8784','2013-06-07','07:25:00',1.27),('8784','2013-06-07','07:30:00',1.35),('8784','2013-06-07','07:35:00',1.44),('8784','2013-06-07','07:40:00',1.53),('8784','2013-06-07','07:45:00',1.61),('8784','2013-06-07','07:50:00',1.71),('8784','2013-06-07','07:55:00',1.79),('8784','2013-06-07','08:00:00',1.87),('8784','2013-06-07','08:05:00',1.96),('8784','2013-06-07','08:10:00',2.04),('8784','2013-06-07','08:15:00',2.11),('8784','2013-06-07','08:20:00',2.22),('8784','2013-06-07','08:25:00',2.3),('8784','2013-06-07','08:30:00',2.38),('8784','2013-06-07','08:35:00',2.47),('8784','2013-06-07','08:40:00',2.56),('8784','2013-06-07','08:45:00',2.64),('8784','2013-06-07','08:50:00',2.72),('8784','2013-06-07','08:55:00',2.8),('8784','2013-06-07','09:00:00',2.84),('8784','2013-06-07','09:05:00',2.96),('8784','2013-06-07','09:10:00',3.03),('8784','2013-06-07','09:15:00',3.1),('8784','2013-06-07','09:20:00',3.16),('8784','2013-06-07','09:25:00',3.23),('8784','2013-06-07','09:30:00',3.3),('8784','2013-06-07','09:35:00',3.36),('8784','2013-06-07','09:40:00',3.44),('8784','2013-06-07','09:45:00',3.53),('8784','2013-06-07','09:50:00',3.6),('8784','2013-06-07','09:55:00',3.64),('8784','2013-06-07','10:00:00',3.71),('8784','2013-06-07','10:05:00',3.76),('8784','2013-06-07','10:10:00',3.81),('8784','2013-06-07','10:15:00',3.82),('8784','2013-06-07','10:20:00',3.92),('8784','2013-06-07','10:25:00',3.96),('8784','2013-06-07','10:30:00',3.99),('8784','2013-06-07','10:35:00',4.02),('8784','2013-06-07','10:40:00',4.06),('8784','2013-06-07','10:45:00',4.08),('8784','2013-06-07','10:50:00',4.13),('8784','2013-06-07','10:55:00',4.18),('8784','2013-06-07','11:00:00',4.24),('8784','2013-06-07','11:05:00',4.27),('8784','2013-06-07','11:10:00',4.31),('8784','2013-06-07','11:15:00',4.31),('8784','2013-06-07','11:20:00',4.33),('8784','2013-06-07','11:25:00',4.35),('8784','2013-06-07','11:30:00',4.43),('8784','2013-06-07','11:35:00',4.45),('8784','2013-06-07','11:40:00',4.48),('8784','2013-06-07','11:45:00',4.51),('8784','2013-06-07','11:50:00',4.52),('8784','2013-06-07','11:55:00',4.53),('8784','2013-06-07','12:00:00',4.55),('8784','2013-06-07','12:05:00',4.5),('8784','2013-06-07','12:10:00',4.57),('8784','2013-06-07','12:15:00',4.57),('8784','2013-06-07','12:20:00',4.59),('8784','2013-06-07','12:25:00',4.58),('8784','2013-06-07','12:30:00',4.6),('8784','2013-06-07','12:35:00',4.6),('8784','2013-06-07','12:40:00',4.59),('8784','2013-06-07','12:45:00',4.62),('8784','2013-06-07','12:50:00',4.62),('8784','2013-06-07','12:55:00',4.61),('8784','2013-06-07','13:00:00',4.62),('8784','2013-06-07','13:05:00',4.61),('8784','2013-06-07','13:10:00',4.59),('8784','2013-06-07','13:15:00',4.56),('8784','2013-06-07','13:20:00',4.56),('8784','2013-06-07','13:25:00',4.57),('8784','2013-06-07','13:30:00',4.57),('8784','2013-06-07','13:35:00',4.54),('8784','2013-06-07','13:40:00',4.48),('8784','2013-06-07','13:45:00',4.45),('8784','2013-06-07','13:50:00',4.43),('8784','2013-06-07','13:55:00',4.45),('8784','2013-06-07','14:00:00',4.41),('8784','2013-06-07','14:05:00',4.37),('8784','2013-06-07','14:10:00',4.36),('8784','2013-06-07','14:15:00',4.33),('8784','2013-06-07','14:20:00',4.27),('8784','2013-06-07','14:25:00',4.24),('8784','2013-06-07','14:30:00',4.22),('8784','2013-06-07','14:35:00',4.17),('8784','2013-06-07','14:40:00',4.19),('8784','2013-06-07','14:45:00',4.18),('8784','2013-06-07','14:50:00',4.16),('8784','2013-06-07','14:55:00',4.09),('8784','2013-06-07','15:00:00',4.07),('8784','2013-06-07','15:05:00',4.06),('8784','2013-06-07','15:10:00',4.06),('8784','2013-06-07','15:15:00',3.99),('8784','2013-06-07','15:20:00',3.96),('8784','2013-06-07','15:25:00',4),('8784','2013-06-07','15:30:00',3.98),('8784','2013-06-07','15:35:00',3.91),('8784','2013-06-07','15:40:00',3.85),('8784','2013-06-07','15:45:00',3.81),('8784','2013-06-07','15:50:00',3.75),('8784','2013-06-07','15:55:00',3.7),('8784','2013-06-07','16:00:00',3.64),('8784','2013-06-07','16:05:00',3.58),('8784','2013-06-07','16:10:00',3.45),('8784','2013-06-07','16:15:00',3.27),('8784','2013-06-07','16:20:00',3.27),('8784','2013-06-07','16:25:00',3.32),('8784','2013-06-07','16:30:00',3.29),('8784','2013-06-07','16:35:00',3.24),('8784','2013-06-07','16:40:00',3.16),('8784','2013-06-07','16:45:00',3.1),('8784','2013-06-07','16:50:00',3.02),('8784','2013-06-07','16:55:00',2.98),('8784','2013-06-07','17:00:00',2.9),('8784','2013-06-07','17:05:00',2.82),('8784','2013-06-07','17:10:00',2.77),('8784','2013-06-07','17:15:00',2.62),('8784','2013-06-07','17:20:00',2.56),('8784','2013-06-07','17:25:00',2.51),('8784','2013-06-07','17:30:00',2.44),('8784','2013-06-07','17:35:00',2.36),('8784','2013-06-07','17:40:00',2.3),('8784','2013-06-07','17:45:00',2.25),('8784','2013-06-07','17:50:00',2.23),('8784','2013-06-07','17:55:00',2.11),('8784','2013-06-07','18:00:00',1.98),('8784','2013-06-07','18:05:00',1.89),('8784','2013-06-07','18:10:00',1.78),('8784','2013-06-07','18:15:00',1.65),('8784','2013-06-07','18:20:00',1.54),('8784','2013-06-07','18:25:00',1.39),('8784','2013-06-07','18:30:00',1.34),('8784','2013-06-07','18:35:00',1.26),('8784','2013-06-07','18:40:00',1.18),('8784','2013-06-07','18:45:00',1.08),('8784','2013-06-07','18:50:00',1.01),('8784','2013-06-06','07:00:00',1.17),('8784','2013-06-06','07:05:00',1.29),('8784','2013-06-06','07:10:00',1.15),('8784','2013-06-06','07:15:00',1.32),('8784','2013-06-06','07:50:00',1.41),('8784','2013-06-06','07:55:00',1.87),('8784','2013-06-06','08:00:00',1.91),('8784','2013-06-06','08:05:00',1.47),('8784','2013-06-06','08:10:00',1.96),('8784','2013-06-06','08:15:00',1.57),('8784','2013-06-06','08:20:00',1.91),('8784','2013-06-06','08:25:00',2.3),('8784','2013-06-06','08:30:00',2.37),('8784','2013-06-06','08:35:00',2.43),('8784','2013-06-06','08:40:00',2.5),('8784','2013-06-06','08:45:00',2.55),('8784','2013-06-06','08:50:00',2.65),('8784','2013-06-06','08:55:00',2.7),('8784','2013-06-06','09:00:00',2.82),('8784','2013-06-06','09:05:00',2.89),('8784','2013-06-06','09:10:00',2.95),('8784','2013-06-06','09:15:00',3.04),('8784','2013-06-06','09:20:00',3.1),('8784','2013-06-06','09:25:00',3.17),('8784','2013-06-06','09:30:00',3.22),('8784','2013-06-06','09:35:00',3.24),('8784','2013-06-06','09:40:00',3.31),('8784','2013-06-06','09:45:00',3.4),('8784','2013-06-06','09:50:00',3.47),('8784','2013-06-06','09:55:00',3.53),('8784','2013-06-06','10:00:00',3.54),('8784','2013-06-06','10:05:00',3.49),('8784','2013-06-06','10:10:00',3.62),('8784','2013-06-06','10:15:00',3.69),('8784','2013-06-06','10:20:00',3.78),('8784','2013-06-06','10:25:00',3.76),('8784','2013-06-06','10:30:00',3.86),('8784','2013-06-06','10:35:00',3.85),('8784','2013-06-06','10:40:00',3.94),('8784','2013-06-06','10:45:00',3.98),('8784','2013-06-06','10:50:00',4.04),('8784','2013-06-06','10:55:00',4.11),('8784','2013-06-06','11:00:00',4.13),('8784','2013-06-06','11:05:00',4.08),('8784','2013-06-06','11:10:00',4.13),('8784','2013-06-06','11:15:00',4.14),('8784','2013-06-06','11:20:00',4.11),('8784','2013-06-06','11:25:00',4.26),('8784','2013-06-06','11:30:00',4.31),('8784','2013-06-06','11:35:00',4.32),('8784','2013-06-06','11:40:00',4.29),('8784','2013-06-06','11:45:00',4.34),('8784','2013-06-06','11:50:00',4.38),('8784','2013-06-06','11:55:00',4.41),('8784','2013-06-06','12:00:00',4.45),('8784','2013-06-06','12:05:00',4.43),('8784','2013-06-06','12:10:00',4.39),('8784','2013-06-06','12:15:00',4.38),('8784','2013-06-06','12:20:00',4.39),('8784','2013-06-06','12:25:00',4.42),('8784','2013-06-06','12:30:00',4.42),('8784','2013-06-06','12:35:00',4.38),('8784','2013-06-06','12:40:00',4.4),('8784','2013-06-06','12:45:00',4.43),('8784','2013-06-06','12:50:00',4.52),('8784','2013-06-06','12:55:00',4.5),('8784','2013-06-06','13:00:00',4.49),('8784','2013-06-06','13:05:00',4.53),('8784','2013-06-06','13:10:00',4.57),('8784','2013-06-06','13:15:00',4.59),('8784','2013-06-06','13:20:00',4.55),('8784','2013-06-06','13:25:00',3.96),('8784','2013-06-06','13:30:00',4.67),('8784','2013-06-06','13:35:00',4.57),('8784','2013-06-06','13:40:00',1.48),('8784','2013-06-06','13:50:00',1.68),('8784','2013-06-06','13:55:00',4.17),('8784','2013-06-06','14:00:00',4.35),('8784','2013-06-06','14:05:00',2.44),('8784','2013-06-06','14:10:00',2.6),('8784','2013-06-06','14:15:00',4.65),('8784','2013-06-06','14:20:00',3.36),('8784','2013-06-06','14:25:00',3.48),('8784','2013-06-06','14:30:00',3.72),('8784','2013-06-06','14:35:00',4.29),('8784','2013-06-06','14:40:00',4.47),('8784','2013-06-06','14:45:00',3.52),('8784','2013-06-06','14:50:00',4.59),('8784','2013-06-06','14:55:00',4.3),('8784','2013-06-06','15:00:00',4.18),('8784','2013-06-06','15:05:00',4.25),('8784','2013-06-06','15:10:00',4.2),('8784','2013-06-06','15:15:00',4.07),('8784','2013-06-06','15:20:00',4.06),('8784','2013-06-06','15:25:00',3.65),('8784','2013-06-06','15:30:00',3.83),('8784','2013-06-06','15:35:00',3.84),('8784','2013-06-06','15:40:00',3.85),('8784','2013-06-06','15:45:00',3.78),('8784','2013-06-06','15:50:00',3.71),('8784','2013-06-06','15:55:00',3.72),('8784','2013-06-06','16:00:00',3.59),('8784','2013-06-06','16:05:00',3.63),('8784','2013-06-06','16:10:00',3.52),('8784','2013-06-06','16:15:00',3.25),('8784','2013-06-06','16:20:00',3.28),('8784','2013-06-06','16:25:00',3.21),('8784','2013-06-06','16:30:00',3.16),('8784','2013-06-06','16:35:00',3.15),('8784','2013-06-06','16:40:00',3.1),('8784','2013-06-06','16:45:00',2.98),('8784','2013-06-06','16:50:00',2.92),('8784','2013-06-06','16:55:00',2.82),('8784','2013-06-06','17:00:00',2.72),('8784','2013-06-06','17:05:00',2.66),('8784','2013-06-06','17:10:00',2.6),('8784','2013-06-06','17:15:00',2.51),('8784','2013-06-06','17:20:00',2.43),('8784','2013-06-06','17:25:00',2.39),('8784','2013-06-06','17:30:00',2.33),('8784','2013-06-06','17:35:00',2.23),('8784','2013-06-06','17:40:00',2.15),('8784','2013-06-06','17:45:00',2.07),('8784','2013-06-06','17:50:00',1.96),('8784','2013-06-06','17:55:00',1.88),('8784','2013-06-06','18:00:00',1.81),('8784','2013-06-06','18:05:00',1.75),('8784','2013-06-06','18:10:00',1.65),('8784','2013-06-06','18:15:00',1.54),('8784','2013-06-06','18:20:00',1.45),('8784','2013-06-06','18:25:00',1.37),('8784','2013-06-06','18:30:00',1.29),('8784','2013-06-06','18:35:00',1.22),('8784','2013-06-06','18:40:00',1.16),('8784','2013-06-06','18:45:00',1.07),('8784','2013-06-05','07:25:00',1.06),('8784','2013-06-05','07:45:00',1.2),('8784','2013-06-05','07:50:00',1.75),('8784','2013-06-05','07:55:00',1.91),('8784','2013-06-05','08:00:00',2.03),('8784','2013-06-05','08:05:00',1.59),('8784','2013-06-05','08:10:00',1.84),('8784','2013-06-05','08:15:00',2.01),('8784','2013-06-05','08:20:00',2.09),('8784','2013-06-05','08:25:00',2.22),('8784','2013-06-05','08:30:00',2.32),('8784','2013-06-05','08:35:00',2.4),('8784','2013-06-05','08:40:00',2.49),('8784','2013-06-05','08:45:00',2.56),('8784','2013-06-05','08:50:00',2.66),('8784','2013-06-05','08:55:00',2.74),('8784','2013-06-05','09:00:00',2.79),('8784','2013-06-05','09:05:00',3),('8784','2013-06-05','09:10:00',2.71),('8784','2013-06-05','09:15:00',3.15),('8784','2013-06-05','09:20:00',3.43),('8784','2013-06-05','09:25:00',3.6),('8784','2013-06-05','09:30:00',3.11),('8784','2013-06-05','09:35:00',2.14),('8784','2013-06-05','09:40:00',3.51),('8784','2013-06-05','09:45:00',1.3),('8784','2013-06-05','09:50:00',1.35),('8784','2013-06-05','09:55:00',2.43),('8784','2013-06-05','10:00:00',4.12),('8784','2013-06-05','10:05:00',3.46),('8784','2013-06-05','10:10:00',3.43),('8784','2013-06-05','10:15:00',1.26),('8784','2013-06-05','10:20:00',1.6),('8784','2013-06-05','10:25:00',1.54),('8784','2013-06-05','10:30:00',1.63),('8784','2013-06-05','10:35:00',1.74),('8784','2013-06-05','10:40:00',4.53),('8784','2013-06-05','10:45:00',4.61),('8784','2013-06-05','10:50:00',4.43),('8784','2013-06-05','10:55:00',3.94),('8784','2013-06-05','11:00:00',2.89),('8784','2013-06-05','11:05:00',2.68),('8784','2013-06-05','11:10:00',1.51),('8784','2013-06-05','11:15:00',1.23),('8784','2013-06-05','11:20:00',1.15),('8784','2013-06-05','11:25:00',1.19),('8784','2013-06-05','11:30:00',1.34),('8784','2013-06-05','11:35:00',3.37),('8784','2013-06-05','11:40:00',4.99),('8784','2013-06-05','11:45:00',4.08),('8784','2013-06-05','11:50:00',1.98),('8784','2013-06-05','11:55:00',4.8),('8784','2013-06-05','12:00:00',5.04),('8784','2013-06-05','12:05:00',4.96),('8784','2013-06-05','12:10:00',4.99),('8784','2013-06-05','12:15:00',4.99),('8784','2013-06-05','12:20:00',5.22),('8784','2013-06-05','12:25:00',4.6),('8784','2013-06-05','12:30:00',4.84),('8784','2013-06-05','12:35:00',2.17),('8784','2013-06-05','12:40:00',4.6),('8784','2013-06-05','12:45:00',5.42),('8784','2013-06-05','12:50:00',2.09),('8784','2013-06-05','12:55:00',3.34),('8784','2013-06-05','13:00:00',5.77),('8784','2013-06-05','13:05:00',2.8),('8784','2013-06-05','13:10:00',4.19),('8784','2013-06-05','13:15:00',3.34),('8784','2013-06-05','13:20:00',2.86),('8784','2013-06-05','13:25:00',2.75),('8784','2013-06-05','13:30:00',4.49),('8784','2013-06-05','13:35:00',5.19),('8784','2013-06-05','13:40:00',4.92),('8784','2013-06-05','13:45:00',4.88),('8784','2013-06-05','13:50:00',4.79),('8784','2013-06-05','13:55:00',4.74),('8784','2013-06-05','14:00:00',4.69),('8784','2013-06-05','14:05:00',4.69),('8784','2013-06-05','14:10:00',4.61),('8784','2013-06-05','14:15:00',4.55),('8784','2013-06-05','14:20:00',4.51),('8784','2013-06-05','14:25:00',4.49),('8784','2013-06-05','14:30:00',4.15),('8784','2013-06-05','14:35:00',4.09),('8784','2013-06-05','14:40:00',4.44),('8784','2013-06-05','14:45:00',4.44),('8784','2013-06-05','14:50:00',4.37),('8784','2013-06-05','14:55:00',4.34),('8784','2013-06-05','15:00:00',4.24),('8784','2013-06-05','15:05:00',4.21),('8784','2013-06-05','15:10:00',4.2),('8784','2013-06-05','15:15:00',4.17),('8784','2013-06-05','15:20:00',4.13),('8784','2013-06-05','15:25:00',4.09),('8784','2013-06-05','15:30:00',4.14),('8784','2013-06-05','15:35:00',4.17),('8784','2013-06-05','15:40:00',4.05),('8784','2013-06-05','15:45:00',3.99),('8784','2013-06-05','15:50:00',3.92),('8784','2013-06-05','15:55:00',3.86),('8784','2013-06-05','16:00:00',3.81),('8784','2013-06-05','16:05:00',3.63),('8784','2013-06-05','16:10:00',3.31),('8784','2013-06-05','16:15:00',3.63),('8784','2013-06-05','16:20:00',3.51),('8784','2013-06-05','16:25:00',3.44),('8784','2013-06-05','16:30:00',3.38),('8784','2013-06-05','16:35:00',3.28),('8784','2013-06-05','16:40:00',3.17),('8784','2013-06-05','16:45:00',3.18),('8784','2013-06-05','16:50:00',3.08),('8784','2013-06-05','16:55:00',3.03),('8784','2013-06-05','17:00:00',1.5),('8784','2013-06-05','17:05:00',2.47),('8784','2013-06-05','17:10:00',1.43),('8784','2013-06-05','17:15:00',2.22),('8784','2013-06-05','17:20:00',2.05),('8784','2013-06-05','17:25:00',2.11),('8784','2013-06-05','17:30:00',2.07),('8784','2013-06-05','17:35:00',1.75),('8784','2013-06-05','17:40:00',2.3),('8784','2013-06-05','17:45:00',2.17),('8784','2013-06-05','17:50:00',2.06),('8784','2013-06-05','17:55:00',1.94),('8784','2013-06-05','18:00:00',1.79),('8784','2013-06-05','18:05:00',1.16),('8784','2013-06-05','18:10:00',1.33),('8784','2013-06-05','18:15:00',1.16),('8784','2013-06-05','18:25:00',1.46),('8784','2013-06-05','18:30:00',1.43),('8784','2013-06-05','18:35:00',1.45),('8784','2013-06-05','18:40:00',1.31),('8784','2013-06-05','18:55:00',1.01),('8784','2013-06-04','07:05:00',1.03),('8784','2013-06-04','07:10:00',1.09),('8784','2013-06-04','07:15:00',1.13),('8784','2013-06-04','07:20:00',1.16),('8784','2013-06-04','07:25:00',1.26),('8784','2013-06-04','07:30:00',1.35),('8784','2013-06-04','07:35:00',1.45),('8784','2013-06-04','07:40:00',1.62),('8784','2013-06-04','07:45:00',1.84),('8784','2013-06-04','07:50:00',2.01),('8784','2013-06-04','07:55:00',2.12),('8784','2013-06-04','08:00:00',2.33),('8784','2013-06-04','08:05:00',2.5),('8784','2013-06-04','08:10:00',2.51),('8784','2013-06-04','08:15:00',2.54),('8784','2013-06-04','08:20:00',2.54),('8784','2013-06-04','08:25:00',2.53),('8784','2013-06-04','08:30:00',2.81),('8784','2013-06-04','08:35:00',2.52),('8784','2013-06-04','08:40:00',2.18),('8784','2013-06-04','08:45:00',1.96),('8784','2013-06-04','08:50:00',1.57),('8784','2013-06-04','08:55:00',1.58),('8784','2013-06-04','09:00:00',1.86),('8784','2013-06-04','09:05:00',1.88),('8784','2013-06-04','09:10:00',2.63),('8784','2013-06-04','09:15:00',3.38),('8784','2013-06-04','09:20:00',3.7),('8784','2013-06-04','09:25:00',2.83),('8784','2013-06-04','09:30:00',3.43),('8784','2013-06-04','09:35:00',2.57),('8784','2013-06-04','09:40:00',2.19),('8784','2013-06-04','09:45:00',2.36),('8784','2013-06-04','09:50:00',2.06),('8784','2013-06-04','09:55:00',1.92),('8784','2013-06-04','10:00:00',2.18),('8784','2013-06-04','10:05:00',2.9),('8784','2013-06-04','10:10:00',2.67),('8784','2013-06-04','10:15:00',2),('8784','2013-06-04','10:20:00',2.09),('8784','2013-06-04','10:25:00',2.03),('8784','2013-06-04','10:30:00',1.86),('8784','2013-06-04','10:35:00',1.89),('8784','2013-06-04','10:40:00',2.08),('8784','2013-06-04','10:45:00',2.48),('8784','2013-06-04','10:50:00',3.23),('8784','2013-06-04','10:55:00',3),('8784','2013-06-04','11:00:00',2.44),('8784','2013-06-04','11:05:00',3.06),('8784','2013-06-04','11:10:00',4.16),('8784','2013-06-04','11:15:00',3.43),('8784','2013-06-04','11:20:00',2.46),('8784','2013-06-04','11:25:00',3.07),('8784','2013-06-04','11:30:00',3.63),('8784','2013-06-04','11:35:00',3.26),('8784','2013-06-04','11:40:00',3.49),('8784','2013-06-04','11:45:00',4.13),('8784','2013-06-04','11:50:00',4.53),('8784','2013-06-04','11:55:00',4.12),('8784','2013-06-04','12:00:00',2.41),('8784','2013-06-04','12:05:00',4.33),('8784','2013-06-04','12:10:00',2.86),('8784','2013-06-04','12:15:00',2.73),('8784','2013-06-04','12:20:00',1.99),('8784','2013-06-04','12:25:00',2.28),('8784','2013-06-04','12:30:00',3.33),('8784','2013-06-04','12:35:00',4.01),('8784','2013-06-04','12:40:00',2.52),('8784','2013-06-04','12:45:00',3.18),('8784','2013-06-04','12:50:00',2.38),('8784','2013-06-04','12:55:00',1.96),('8784','2013-06-04','13:00:00',1.87),('8784','2013-06-04','13:05:00',1.6),('8784','2013-06-04','13:10:00',1.54),('8784','2013-06-04','13:15:00',1.26),('8784','2013-06-04','13:20:00',1.27),('8784','2013-06-04','13:25:00',1.54),('8784','2013-06-04','13:30:00',2.16),('8784','2013-06-04','13:35:00',4.5),('8784','2013-06-04','13:40:00',3.93),('8784','2013-06-04','13:45:00',3.14),('8784','2013-06-04','13:50:00',4.12),('8784','2013-06-04','13:55:00',3.9),('8784','2013-06-04','14:00:00',2.41),('8784','2013-06-04','14:05:00',4.09),('8784','2013-06-04','14:10:00',4.85),('8784','2013-06-04','14:15:00',2.12),('8784','2013-06-04','14:20:00',4.84),('8784','2013-06-04','14:25:00',1.75),('8784','2013-06-04','14:30:00',1.3),('8784','2013-06-04','14:35:00',1.64),('8784','2013-06-04','14:40:00',2.77),('8784','2013-06-04','14:45:00',1.37),('8784','2013-06-04','14:50:00',1.41),('8784','2013-06-04','14:55:00',3.87),('8784','2013-06-04','15:00:00',5.3),('8784','2013-06-04','15:05:00',2.68),('8784','2013-06-04','15:10:00',1.69),('8784','2013-06-04','15:15:00',1.9),('8784','2013-06-04','15:20:00',1.22),('8784','2013-06-04','17:40:00',1.01),('8784','2013-06-04','18:40:00',1.02),('8784','2013-06-04','18:45:00',1.05),('8784','2013-06-03','07:20:00',1.09),('8784','2013-06-03','07:25:00',1.21),('8784','2013-06-03','07:40:00',1.44),('8784','2013-06-03','07:45:00',1.48),('8784','2013-06-03','07:50:00',1.69),('8784','2013-06-03','07:55:00',1.75),('8784','2013-06-03','08:00:00',1.8),('8784','2013-06-03','08:05:00',1.87),('8784','2013-06-03','08:10:00',1.95),('8784','2013-06-03','08:15:00',2.02),('8784','2013-06-03','08:20:00',2.09),('8784','2013-06-03','08:25:00',2.27),('8784','2013-06-03','08:30:00',2.36),('8784','2013-06-03','08:35:00',2.42),('8784','2013-06-03','08:40:00',2.5),('8784','2013-06-03','08:45:00',2.58),('8784','2013-06-03','08:50:00',2.62),('8784','2013-06-03','08:55:00',2.73),('8784','2013-06-03','09:00:00',2.85),('8784','2013-06-03','09:05:00',2.92),('8784','2013-06-03','09:10:00',3.04),('8784','2013-06-03','09:15:00',3.33),('8784','2013-06-03','09:20:00',2.89),('8784','2013-06-03','09:25:00',2.62),('8784','2013-06-03','09:30:00',1.99),('8784','2013-06-03','09:35:00',1.97),('8784','2013-06-03','09:40:00',2.85),('8784','2013-06-03','09:45:00',3.72),('8784','2013-06-03','09:50:00',3.06),('8784','2013-06-03','09:55:00',4.18),('8784','2013-06-03','10:00:00',3.96),('8784','2013-06-03','10:05:00',4.18),('8784','2013-06-03','10:10:00',2.69),('8784','2013-06-03','10:15:00',1.37),('8784','2013-06-03','10:20:00',1.01),('8784','2013-06-03','10:30:00',1.15),('8784','2013-06-03','10:35:00',1.31),('8784','2013-06-03','10:40:00',1.47),('8784','2013-06-03','10:45:00',2.61),('8784','2013-06-03','10:50:00',3.98),('8784','2013-06-03','10:55:00',2.78),('8784','2013-06-03','11:00:00',3.05),('8784','2013-06-03','11:05:00',2.87),('8784','2013-06-03','11:10:00',1.62),('8784','2013-06-03','11:15:00',1.46),('8784','2013-06-03','11:20:00',1.79),('8784','2013-06-03','11:25:00',1.74),('8784','2013-06-03','11:30:00',2.38),('8784','2013-06-03','11:35:00',1.52),('8784','2013-06-03','11:40:00',1.56),('8784','2013-06-03','11:45:00',1.62),('8784','2013-06-03','11:50:00',1.75),('8784','2013-06-03','11:55:00',1.78),('8784','2013-06-03','12:00:00',1.9),('8784','2013-06-03','12:05:00',1.65),('8784','2013-06-03','12:10:00',2.25),('8784','2013-06-03','12:15:00',1.5),('8784','2013-06-03','12:20:00',1.59),('8784','2013-06-03','12:25:00',1.36),('8784','2013-06-03','12:30:00',1.59),('8784','2013-06-03','12:35:00',2.96),('8784','2013-06-03','12:40:00',5.41),('8784','2013-06-03','12:45:00',3.1),('8784','2013-06-03','12:50:00',2.33),('8784','2013-06-03','12:55:00',3.95),('8784','2013-06-03','13:00:00',2.89),('8784','2013-06-03','13:05:00',2.29),('8784','2013-06-03','13:10:00',2.3),('8784','2013-06-03','13:15:00',4.92),('8784','2013-06-03','13:20:00',5.52),('8784','2013-06-03','13:25:00',5.43),('8784','2013-06-03','13:30:00',3.88),('8784','2013-06-03','13:35:00',5.09),('8784','2013-06-03','13:40:00',4.89),('8784','2013-06-03','13:45:00',4.09),('8784','2013-06-03','13:50:00',4.5),('8784','2013-06-03','13:55:00',2.1),('8784','2013-06-03','14:00:00',3.19),('8784','2013-06-03','14:05:00',3.54),('8784','2013-06-03','14:10:00',2.42),('8784','2013-06-03','14:15:00',2.9),('8784','2013-06-03','14:20:00',3.09),('8784','2013-06-03','14:25:00',2.94),('8784','2013-06-03','14:30:00',4.99),('8784','2013-06-03','14:35:00',4.78),('8784','2013-06-03','14:40:00',3.63),('8784','2013-06-03','14:45:00',3),('8784','2013-06-03','14:50:00',2.73),('8784','2013-06-03','14:55:00',3.68),('8784','2013-06-03','15:00:00',4.17),('8784','2013-06-03','15:05:00',4.35),('8784','2013-06-03','15:10:00',3.96),('8784','2013-06-03','15:15:00',4.7),('8784','2013-06-03','15:20:00',3.39),('8784','2013-06-03','15:25:00',4.19),('8784','2013-06-03','15:30:00',4.11),('8784','2013-06-03','15:35:00',4.05),('8784','2013-06-03','15:40:00',3.98),('8784','2013-06-03','15:45:00',3.91),('8784','2013-06-03','15:50:00',3.88),('8784','2013-06-03','15:55:00',3.84),('8784','2013-06-03','16:00:00',3.77),('8784','2013-06-03','16:05:00',3.73),('8784','2013-06-03','16:10:00',3.67),('8784','2013-06-03','16:15:00',3.6),('8784','2013-06-03','16:20:00',3.34),('8784','2013-06-03','16:25:00',3.48),('8784','2013-06-03','16:30:00',3.65),('8784','2013-06-03','16:35:00',3.47),('8784','2013-06-03','16:40:00',3.53),('8784','2013-06-03','16:45:00',2.97),('8784','2013-06-03','16:50:00',2.51),('8784','2013-06-03','16:55:00',2.08),('8784','2013-06-03','17:00:00',2.78),('8784','2013-06-03','17:05:00',3.3),('8784','2013-06-03','17:10:00',3.13),('8784','2013-06-03','17:15:00',2.57),('8784','2013-06-03','17:20:00',2.31),('8784','2013-06-03','17:25:00',1.66),('8784','2013-06-02','06:50:00',1.11),('8784','2013-06-02','06:55:00',1.35),('8784','2013-06-02','07:00:00',1.18),('8784','2013-06-02','08:35:00',1.02),('8784','2013-06-02','08:40:00',1),('8784','2013-06-02','08:45:00',1.11),('8784','2013-06-02','08:50:00',1.13),('8784','2013-06-02','09:00:00',1.03),('8784','2013-06-02','09:05:00',1.1),('8784','2013-06-02','09:10:00',1.22),('8784','2013-06-02','09:15:00',1.35),('8784','2013-06-02','09:20:00',2.27),('8784','2013-06-02','09:25:00',3.66),('8784','2013-06-02','09:30:00',3.52),('8784','2013-06-02','09:35:00',3.46),('8784','2013-06-02','09:40:00',3.48),('8784','2013-06-02','09:45:00',3.5),('8784','2013-06-02','09:50:00',3.58),('8784','2013-06-02','09:55:00',3.63),('8784','2013-06-02','10:00:00',3.69),('8784','2013-06-02','10:05:00',3.74),('8784','2013-06-02','10:10:00',3.8),('8784','2013-06-02','10:15:00',3.82),('8784','2013-06-02','10:20:00',3.92),('8784','2013-06-02','10:25:00',3.89),('8784','2013-06-02','10:30:00',3.35),('8784','2013-06-02','10:35:00',1.36),('8784','2013-06-02','10:40:00',1.58),('8784','2013-06-02','10:45:00',3.12),('8784','2013-06-02','10:50:00',3.09),('8784','2013-06-02','10:55:00',4.76),('8784','2013-06-02','11:00:00',4.86),('8784','2013-06-02','11:05:00',4.75),('8784','2013-06-02','11:10:00',1.59),('8784','2013-06-02','11:15:00',3.75),('8784','2013-06-02','11:20:00',4.4),('8784','2013-06-02','11:25:00',3.63),('8784','2013-06-02','11:30:00',1.81),('8784','2013-06-02','11:35:00',2.15),('8784','2013-06-02','11:40:00',2.73),('8784','2013-06-02','11:45:00',1.72),('8784','2013-06-02','11:50:00',1.47),('8784','2013-06-02','11:55:00',3.76),('8784','2013-06-02','12:00:00',1.89),('8784','2013-06-02','12:05:00',1.58),('8784','2013-06-02','12:10:00',3.21),('8784','2013-06-02','12:15:00',3.07),('8784','2013-06-02','12:20:00',2.7),('8784','2013-06-02','12:25:00',4.18),('8784','2013-06-02','12:30:00',3.49),('8784','2013-06-02','12:35:00',3.75),('8784','2013-06-02','12:40:00',4.39),('8784','2013-06-02','12:45:00',3.57),('8784','2013-06-02','12:50:00',2.11),('8784','2013-06-02','12:55:00',3.87),('8784','2013-06-02','13:00:00',2.32),('8784','2013-06-02','13:05:00',2.43),('8784','2013-06-02','13:10:00',4.37),('8784','2013-06-02','13:15:00',5.03),('8784','2013-06-02','13:20:00',4.87),('8784','2013-06-02','13:25:00',4.79),('8784','2013-06-02','13:30:00',4.76),('8784','2013-06-02','13:35:00',4.68),('8784','2013-06-02','13:40:00',4.69),('8784','2013-06-02','13:45:00',4.66),('8784','2013-06-02','13:50:00',4.63),('8784','2013-06-02','13:55:00',4.62),('8784','2013-06-02','14:00:00',4.59),('8784','2013-06-02','14:05:00',4.58),('8784','2013-06-02','14:10:00',4.67),('8784','2013-06-02','14:15:00',4.59),('8784','2013-06-02','14:20:00',4.55),('8784','2013-06-02','14:25:00',4.53),('8784','2013-06-02','14:30:00',4.51),('8784','2013-06-02','14:35:00',4.47),('8784','2013-06-02','14:40:00',4.42),('8784','2013-06-02','14:45:00',4.41),('8784','2013-06-02','14:50:00',4.38),('8784','2013-06-02','14:55:00',4.3),('8784','2013-06-02','15:00:00',4.28),('8784','2013-06-02','15:05:00',4.23),('8784','2013-06-02','15:10:00',4.17),('8784','2013-06-02','15:15:00',4.18),('8784','2013-06-02','15:20:00',3.06),('8784','2013-06-02','15:25:00',3.67),('8784','2013-06-02','15:30:00',3.89),('8784','2013-06-02','15:35:00',2.85),('8784','2013-06-02','15:40:00',3.35),('8784','2013-06-02','15:45:00',3.3),('8784','2013-06-02','15:50:00',2.75),('8784','2013-06-02','15:55:00',3.75),('8784','2013-06-02','16:00:00',3.93),('8784','2013-06-02','16:05:00',3.45),('8784','2013-06-02','16:10:00',3.64),('8784','2013-06-02','16:15:00',3.75),('8784','2013-06-02','16:20:00',3.6),('8784','2013-06-02','16:25:00',3.53),('8784','2013-06-02','16:30:00',3.37),('8784','2013-06-02','16:35:00',3.33),('8784','2013-06-02','16:40:00',3.31),('8784','2013-06-02','16:45:00',2.91),('8784','2013-06-02','16:50:00',3.21),('8784','2013-06-02','16:55:00',3.01),('8784','2013-06-02','17:00:00',2.6),('8784','2013-06-02','17:05:00',2.9),('8784','2013-06-02','17:10:00',2.78),('8784','2013-06-02','17:15:00',2.73),('8784','2013-06-02','17:20:00',2.61),('8784','2013-06-02','17:25:00',2.5),('8784','2013-06-02','17:30:00',1.97),('8784','2013-06-02','17:35:00',1.81),('8784','2013-06-02','17:40:00',1.26),('8784','2013-06-02','17:45:00',1.5),('8784','2013-06-02','17:50:00',1.6),('8784','2013-06-02','17:55:00',1.05),('8784','2013-06-02','18:10:00',1.03),('8784','2013-06-01','07:10:00',1.06),('8784','2013-06-01','07:15:00',1.14),('8784','2013-06-01','07:20:00',1.22),('8784','2013-06-01','07:25:00',1.3),('8784','2013-06-01','07:30:00',1.39),('8784','2013-06-01','07:35:00',1.46),('8784','2013-06-01','07:40:00',1.59),('8784','2013-06-01','07:45:00',1.61),('8784','2013-06-01','07:50:00',1.17),('8784','2013-06-01','07:55:00',1.47),('8784','2013-06-01','08:10:00',1.11),('8784','2013-06-01','08:15:00',1.59),('8784','2013-06-01','08:20:00',1.18),('8784','2013-06-01','08:30:00',1.58),('8784','2013-06-01','08:35:00',1.34),('8784','2013-06-01','09:00:00',1.06),('8784','2013-06-01','09:50:00',1.03),('8784','2013-06-01','10:35:00',1.39),('8784','2013-06-01','10:40:00',1.18),('8784','2013-06-01','10:50:00',2.69),('8784','2013-06-01','10:55:00',1.26),('8784','2013-06-01','11:50:00',1.57),('8784','2013-06-01','11:55:00',1.92),('8784','2013-06-01','12:00:00',3.37),('8784','2013-06-01','12:05:00',2.75),('8784','2013-06-01','12:10:00',3.26),('8784','2013-06-01','12:15:00',1.42),('8784','2013-06-01','12:20:00',1.1),('8784','2013-06-01','12:25:00',1.33),('8784','2013-06-01','12:30:00',1.24),('8784','2013-06-01','12:40:00',1.2),('8784','2013-06-01','12:45:00',1.96),('8784','2013-06-01','12:50:00',2.13),('8784','2013-06-01','12:55:00',2.23),('8784','2013-06-01','13:00:00',2.41),('8784','2013-06-01','13:05:00',2.51),('8784','2013-06-01','13:10:00',2.65),('8784','2013-06-01','13:15:00',2.8),('8784','2013-06-01','13:20:00',2.37),('8784','2013-06-01','13:25:00',2.01),('8784','2013-06-01','13:30:00',1.71),('8784','2013-06-01','13:35:00',1.36),('8784','2013-06-01','13:40:00',1.19),('8784','2013-06-01','13:45:00',1.3),('8784','2013-06-01','13:50:00',1.43),('8784','2013-06-01','13:55:00',1.64),('8784','2013-06-01','14:00:00',2.3),('8784','2013-06-01','14:05:00',2.58),('8784','2013-06-01','14:10:00',2.57),('8784','2013-06-01','14:15:00',2.78),('8784','2013-06-01','14:20:00',2.59),('8784','2013-06-01','14:25:00',1.78),('8784','2013-06-01','14:30:00',1.49),('8784','2013-06-01','14:35:00',1.51),('8784','2013-06-01','14:40:00',1.41),('8784','2013-06-01','14:45:00',1.32),('8784','2013-06-01','14:50:00',1.24),('8784','2013-06-01','18:30:00',1.06),('8784','2013-06-01','18:35:00',1.11),('8784','2013-06-01','19:00:00',1.58),('8784','2014-04-02','08:50:00',1.27),('8784','2014-04-02','08:55:00',1.6),('8784','2014-04-02','09:15:00',1.16),('8784','2014-04-02','09:50:00',1.07),('8784','2014-04-02','09:55:00',2.84),('8784','2014-04-02','10:00:00',2.42),('8784','2014-04-02','10:05:00',3.03),('8784','2014-04-02','10:10:00',3.49),('8784','2014-04-02','10:15:00',3.23),('8784','2014-04-02','10:20:00',3.08),('8784','2014-04-02','10:25:00',2.5),('8784','2014-04-02','10:30:00',1.65),('8784','2014-04-02','10:35:00',1.23),('8784','2014-04-02','10:40:00',1.33),('8784','2014-04-02','10:45:00',1.34),('8784','2014-04-02','10:50:00',3.02),('8784','2014-04-02','10:55:00',3.93),('8784','2014-04-02','11:00:00',3.31),('8784','2014-04-02','11:05:00',1.74),('8784','2014-04-02','11:10:00',1.23),('8784','2014-04-02','11:15:00',3.8),('8784','2014-04-02','11:20:00',3.89),('8784','2014-04-02','11:25:00',4.41),('8784','2014-04-02','11:30:00',3.9),('8784','2014-04-02','11:35:00',1.43),('8784','2014-04-02','11:40:00',1.27),('8784','2014-04-02','11:45:00',2.8),('8784','2014-04-02','11:50:00',4.33),('8784','2014-04-02','11:55:00',4.38),('8784','2014-04-02','12:00:00',4.85),('8784','2014-04-02','12:05:00',2.32),('8784','2014-04-02','12:10:00',1.5),('8784','2014-04-02','12:15:00',4.61),('8784','2014-04-02','12:20:00',4.3),('8784','2014-04-02','12:25:00',1.38),('8784','2014-04-02','12:30:00',4.42),('8784','2014-04-02','12:35:00',4.13),('8784','2014-04-02','12:40:00',4.27),('8784','2014-04-02','12:45:00',4.17),('8784','2014-04-02','12:50:00',4.63),('8784','2014-04-02','12:55:00',2.09),('8784','2014-04-02','13:00:00',3.09),('8784','2014-04-02','13:05:00',4.39),('8784','2014-04-02','13:10:00',4.22),('8784','2014-04-02','13:15:00',4.57),('8784','2014-04-02','13:20:00',4.33),('8784','2014-04-02','13:25:00',4.39),('8784','2014-04-02','13:30:00',4.42),('8784','2014-04-02','13:35:00',4.35),('8784','2014-04-02','13:40:00',4.48),('8784','2014-04-02','13:45:00',4.25),('8784','2014-04-02','13:50:00',4.21),('8784','2014-04-02','13:55:00',4.25),('8784','2014-04-02','14:00:00',4.12),('8784','2014-04-02','14:05:00',4.15),('8784','2014-04-02','14:10:00',4.13),('8784','2014-04-02','14:15:00',4.1),('8784','2014-04-02','14:20:00',4.02),('8784','2014-04-02','14:25:00',4.09),('8784','2014-04-02','14:30:00',4.01),('8784','2014-04-02','14:35:00',4),('8784','2014-04-02','14:40:00',3.83),('8784','2014-04-02','14:45:00',3.88),('8784','2014-04-02','14:50:00',3.64),('8784','2014-04-02','14:55:00',3.49),('8784','2014-04-02','15:00:00',3.65),('8784','2014-04-02','15:05:00',3.69),('8784','2014-04-02','15:10:00',3.32),('8784','2014-04-02','15:15:00',3.47),('8784','2014-04-02','15:20:00',3.45),('8784','2014-04-02','15:25:00',3.41),('8784','2014-04-02','15:30:00',3.2),('8784','2014-04-02','15:35:00',3.12),('8784','2014-04-02','15:40:00',3.14),('8784','2014-04-02','15:45:00',3.22),('8784','2014-04-02','15:50:00',3.24),('8784','2014-04-02','15:55:00',2.81),('8784','2014-04-02','16:00:00',2.94),('8784','2014-04-02','16:05:00',2.92),('8784','2014-04-02','16:10:00',2.86),('8784','2014-04-02','16:15:00',2.77),('8784','2014-04-02','16:20:00',2.67),('8784','2014-04-02','16:25:00',2.57),('8784','2014-04-02','16:30:00',2.62),('8784','2014-04-02','16:35:00',2.56),('8784','2014-04-02','16:40:00',2.47),('8784','2014-04-02','16:45:00',2.36),('8784','2014-04-02','16:50:00',2.14),('8784','2014-04-02','16:55:00',2.12),('8784','2014-04-02','17:00:00',2.17),('8784','2014-04-02','17:05:00',1.95),('8784','2014-04-02','17:10:00',1.86),('8784','2014-04-02','17:15:00',1.64),('8784','2014-04-02','17:20:00',1.65),('8784','2014-04-02','17:25:00',1.56),('8784','2014-04-02','17:30:00',1.4),('8784','2014-04-02','17:35:00',1.37),('8784','2014-04-02','17:40:00',1.03),('8784','2014-04-02','17:45:00',1.04),('8784','2014-04-02','17:50:00',1.27),('8784','2014-04-02','17:55:00',1.1),('8784','2014-04-02','18:00:00',1.01),('8784','2013-05-31','07:10:00',1.03),('8784','2013-05-31','07:15:00',1.11),('8784','2013-05-31','07:20:00',1.21),('8784','2013-05-31','07:25:00',1.3),('8784','2013-05-31','07:30:00',1.39),('8784','2013-05-31','07:35:00',1.48),('8784','2013-05-31','07:40:00',1.59),('8784','2013-05-31','07:45:00',1.67),('8784','2013-05-31','07:50:00',1.74),('8784','2013-05-31','07:55:00',1.89),('8784','2013-05-31','08:00:00',2),('8784','2013-05-31','08:05:00',2.06),('8784','2013-05-31','08:10:00',2.12),('8784','2013-05-31','08:15:00',2.18),('8784','2013-05-31','08:20:00',2.22),('8784','2013-05-31','08:25:00',2.39),('8784','2013-05-31','08:30:00',2.09),('8784','2013-05-31','08:35:00',2.67),('8784','2013-05-31','08:40:00',1.52),('8784','2013-05-31','08:45:00',1.8),('8784','2013-05-31','08:50:00',2.87),('8784','2013-05-31','08:55:00',1.21),('8784','2013-05-31','09:10:00',1.2),('8784','2013-05-31','09:15:00',1.43),('8784','2013-05-31','09:25:00',1.04),('8784','2013-05-31','09:30:00',2.21),('8784','2013-05-31','09:35:00',2.54),('8784','2013-05-31','09:40:00',2.83),('8784','2013-05-31','09:45:00',3.62),('8784','2013-05-31','09:50:00',4),('8784','2013-05-31','09:55:00',3.74),('8784','2013-05-31','10:00:00',3.97),('8784','2013-05-31','10:05:00',2.88),('8784','2013-05-31','10:10:00',1.92),('8784','2013-05-31','10:15:00',3.66),('8784','2013-05-31','10:20:00',3.82),('8784','2013-05-31','10:25:00',1.69),('8784','2013-05-31','10:30:00',2.89),('8784','2013-05-31','10:35:00',2.31),('8784','2013-05-31','10:40:00',4.44),('8784','2013-05-31','10:45:00',4.57),('8784','2013-05-31','10:50:00',2.07),('8784','2013-05-31','10:55:00',4.2),('8784','2013-05-31','11:00:00',1.77),('8784','2013-05-31','11:05:00',2.43),('8784','2013-05-31','11:10:00',5.4),('8784','2013-05-31','11:15:00',4.53),('8784','2013-05-31','11:20:00',1.37),('8784','2013-05-31','11:25:00',2.71),('8784','2013-05-31','11:30:00',3.62),('8784','2013-05-31','11:35:00',2.59),('8784','2013-05-31','11:45:00',4.91),('8784','2013-05-31','11:50:00',3.55),('8784','2013-05-31','11:55:00',3.69),('8784','2013-05-31','12:00:00',1.74),('8784','2013-05-31','12:05:00',5.37),('8784','2013-05-31','12:10:00',3.86),('8784','2013-05-31','12:15:00',1.76),('8784','2013-05-31','12:20:00',1.93),('8784','2013-05-31','12:25:00',3.88),('8784','2013-05-31','12:30:00',1.85),('8784','2013-05-31','12:35:00',2.5),('8784','2013-05-31','12:40:00',4.46),('8784','2013-05-31','12:45:00',2.11),('8784','2013-05-31','12:50:00',1.02),('8784','2013-05-31','12:55:00',1.67),('8784','2013-05-31','13:00:00',5.56),('8784','2013-05-31','13:05:00',1.85),('8784','2013-05-31','13:20:00',1.4),('8784','2013-05-31','13:25:00',2.05),('8784','2013-05-31','13:30:00',4.27),('8784','2013-05-31','13:35:00',5.15),('8784','2013-05-31','13:40:00',2.58),('8784','2013-05-31','13:45:00',1.42),('8784','2013-05-31','13:55:00',1.52),('8784','2013-05-31','14:00:00',2.2),('8784','2013-05-31','14:25:00',1.14),('8784','2013-05-31','15:00:00',1.11),('8784','2013-05-31','15:05:00',1.7),('8784','2013-05-31','15:10:00',2.02),('8784','2013-05-31','15:15:00',3.22),('8784','2013-05-31','15:20:00',5.2),('8784','2013-05-31','15:25:00',3.68),('8784','2013-05-31','15:30:00',2.59),('8784','2013-05-31','15:35:00',2.22),('8784','2013-05-31','15:40:00',1.9),('8784','2013-05-31','15:45:00',1.76),('8784','2013-05-31','15:50:00',2.59),('8784','2013-05-31','15:55:00',2.42),('8784','2013-05-31','16:00:00',1.64),('8784','2013-05-31','16:05:00',1.42),('8784','2013-05-31','16:10:00',1.06),('8784','2013-05-31','16:20:00',1.18),('8784','2013-05-31','16:25:00',1.46),('8784','2013-05-31','16:30:00',1.3),('8784','2013-05-31','16:35:00',1.12),('8784','2013-05-31','16:40:00',1.29),('8784','2013-05-31','16:45:00',1.32),('8784','2013-05-30','07:45:00',1.06),('8784','2013-05-30','07:50:00',1.41),('8784','2013-05-30','08:20:00',1.03),('8784','2013-05-30','08:25:00',1.47),('8784','2013-05-30','08:30:00',1.05),('8784','2013-05-30','08:35:00',1.16),('8784','2013-05-30','08:40:00',2.78),('8784','2013-05-30','08:45:00',2.79),('8784','2013-05-30','08:50:00',2.84),('8784','2013-05-30','08:55:00',2.91),('8784','2013-05-30','09:00:00',2.98),('8784','2013-05-30','09:05:00',2.83),('8784','2013-05-30','09:10:00',3.15),('8784','2013-05-30','09:15:00',3.25),('8784','2013-05-30','09:20:00',3.34),('8784','2013-05-30','09:25:00',3.44),('8784','2013-05-30','09:30:00',3.47),('8784','2013-05-30','09:35:00',3.55),('8784','2013-05-30','09:40:00',3.64),('8784','2013-05-30','09:45:00',3),('8784','2013-05-30','09:50:00',4.37),('8784','2013-05-30','09:55:00',1.71),('8784','2013-05-30','10:00:00',1.57),('8784','2013-05-30','10:05:00',1.82),('8784','2013-05-30','10:10:00',3.32),('8784','2013-05-30','10:15:00',2.51),('8784','2013-05-30','10:20:00',4.3),('8784','2013-05-30','10:25:00',1.21),('8784','2013-05-30','10:30:00',1.91),('8784','2013-05-30','10:35:00',1.75),('8784','2013-05-30','10:40:00',3.05),('8784','2013-05-30','10:45:00',4.41),('8784','2013-05-30','10:50:00',4.13),('8784','2013-05-30','10:55:00',3.64),('8784','2013-05-30','11:00:00',5.17),('8784','2013-05-30','11:05:00',4.84),('8784','2013-05-30','11:10:00',1.31),('8784','2013-05-30','11:15:00',2.31),('8784','2013-05-30','11:20:00',3.43),('8784','2013-05-30','11:25:00',1.86),('8784','2013-05-30','11:30:00',4.34),('8784','2013-05-30','11:35:00',5.09),('8784','2013-05-30','11:40:00',4.97),('8784','2013-05-30','11:45:00',4.01),('8784','2013-05-30','11:50:00',4.56),('8784','2013-05-30','11:55:00',1.44),('8784','2013-05-30','12:00:00',5.44),('8784','2013-05-30','12:05:00',5.44),('8784','2013-05-30','12:10:00',2.62),('8784','2013-05-30','12:15:00',4.44),('8784','2013-05-30','12:20:00',3.42),('8784','2013-05-30','12:25:00',5.05),('8784','2013-05-30','12:30:00',3.77),('8784','2013-05-30','12:35:00',3.43),('8784','2013-05-30','12:40:00',5.11),('8784','2013-05-30','12:45:00',3.08),('8784','2013-05-30','12:50:00',4.35),('8784','2013-05-30','12:55:00',5.18),('8784','2013-05-30','13:00:00',4.66),('8784','2013-05-30','13:05:00',3.96),('8784','2013-05-30','13:10:00',2.8),('8784','2013-05-30','13:15:00',2.32),('8784','2013-05-30','13:20:00',2.17),('8784','2013-05-30','13:25:00',1.92),('8784','2013-05-30','13:30:00',2.43),('8784','2013-05-30','13:35:00',2.26),('8784','2013-05-30','13:40:00',4.55),('8784','2013-05-30','13:45:00',4.88),('8784','2013-05-30','13:50:00',1.77),('8784','2013-05-30','13:55:00',2.01),('8784','2013-05-30','14:00:00',4.08),('8784','2013-05-30','14:05:00',5.49),('8784','2013-05-30','14:10:00',3.76),('8784','2013-05-30','14:15:00',5.32),('8784','2013-05-30','14:20:00',3.58),('8784','2013-05-30','14:25:00',4.68),('8784','2013-05-30','14:30:00',4.89),('8784','2013-05-30','14:35:00',4.06),('8784','2013-05-30','14:40:00',4.93),('8784','2013-05-30','14:45:00',5),('8784','2013-05-30','14:50:00',4.91),('8784','2013-05-30','14:55:00',4.43),('8784','2013-05-30','15:00:00',3.09),('8784','2013-05-30','15:05:00',3.26),('8784','2013-05-30','15:10:00',2.29),('8784','2013-05-30','15:15:00',4.48),('8784','2013-05-30','15:20:00',4.64),('8784','2013-05-30','15:25:00',4.42),('8784','2013-05-30','15:30:00',4.05),('8784','2013-05-30','15:35:00',4.38),('8784','2013-05-30','15:40:00',4.39),('8784','2013-05-30','15:45:00',4.61),('8784','2013-05-30','15:50:00',2.2),('8784','2013-05-30','15:55:00',3.96),('8784','2013-05-30','16:00:00',4.24),('8784','2013-05-30','16:05:00',4.48),('8784','2013-05-30','16:10:00',4.13),('8784','2013-05-30','16:15:00',3.89),('8784','2013-05-30','16:20:00',3.59),('8784','2013-05-30','16:25:00',2.33),('8784','2013-05-30','16:30:00',1.39),('8784','2013-05-30','16:35:00',2.34),('8784','2013-05-30','16:40:00',1.19),('8784','2013-05-30','16:45:00',3.12),('8784','2013-05-30','16:50:00',2.88),('8784','2013-05-30','16:55:00',2.37),('8784','2013-05-30','17:00:00',1.79),('8784','2013-05-30','17:05:00',2.13),('8784','2013-05-30','17:15:00',1.05),('8784','2013-05-30','17:20:00',1.41),('8784','2013-05-30','17:25:00',1.03),('8784','2013-05-30','17:30:00',1.12),('8784','2013-05-30','18:00:00',1.05),('8784','2013-05-30','18:05:00',1.15),('8784','2013-05-30','18:10:00',1.39),('8784','2013-05-30','18:35:00',1.53),('8784','2013-05-30','18:40:00',1.42),('8784','2013-05-30','18:45:00',1.64),('8784','2013-05-30','18:50:00',1.51),('8784','2013-05-29','07:15:00',1.08),('8784','2013-05-29','07:20:00',1.16),('8784','2013-05-29','07:25:00',1.25),('8784','2013-05-29','07:30:00',1.34),('8784','2013-05-29','07:35:00',1.44),('8784','2013-05-29','07:40:00',1.53),('8784','2013-05-29','07:45:00',1.61),('8784','2013-05-29','07:50:00',1.69),('8784','2013-05-29','07:55:00',1.78),('8784','2013-05-29','08:00:00',1.88),('8784','2013-05-29','08:05:00',1.96),('8784','2013-05-29','08:10:00',2.06),('8784','2013-05-29','08:15:00',2.14),('8784','2013-05-29','08:20:00',2.23),('8784','2013-05-29','08:25:00',2.31),('8784','2013-05-29','08:30:00',2.4),('8784','2013-05-29','08:35:00',2.49),('8784','2013-05-29','08:40:00',2.58),('8784','2013-05-29','08:45:00',2.66),('8784','2013-05-29','08:50:00',2.74),('8784','2013-05-29','08:55:00',2.83),('8784','2013-05-29','09:00:00',2.91),('8784','2013-05-29','09:05:00',2.98),('8784','2013-05-29','09:10:00',3.05),('8784','2013-05-29','09:15:00',3.12),('8784','2013-05-29','09:20:00',3.2),('8784','2013-05-29','09:25:00',3.26),('8784','2013-05-29','09:30:00',3.32),('8784','2013-05-29','09:35:00',3.41),('8784','2013-05-29','09:40:00',3.49),('8784','2013-05-29','09:45:00',3.55),('8784','2013-05-29','09:50:00',3.63),('8784','2013-05-29','09:55:00',3.69),('8784','2013-05-29','10:00:00',3.72),('8784','2013-05-29','10:05:00',3.79),('8784','2013-05-29','10:10:00',3.85),('8784','2013-05-29','10:15:00',3.91),('8784','2013-05-29','10:20:00',3.93),('8784','2013-05-29','10:25:00',4.01),('8784','2013-05-29','10:30:00',4.08),('8784','2013-05-29','10:35:00',4.16),('8784','2013-05-29','10:40:00',4.2),('8784','2013-05-29','10:45:00',4.25),('8784','2013-05-29','10:50:00',4.29),('8784','2013-05-29','10:55:00',4.32),('8784','2013-05-29','11:00:00',4.39),('8784','2013-05-29','11:05:00',4.38),('8784','2013-05-29','11:10:00',4.39),('8784','2013-05-29','11:15:00',3.62),('8784','2013-05-29','11:20:00',4.81),('8784','2013-05-29','11:25:00',4.34),('8784','2013-05-29','11:30:00',4.78),('8784','2013-05-29','11:35:00',4.75),('8784','2013-05-29','11:40:00',3.8),('8784','2013-05-29','11:45:00',3.37),('8784','2013-05-29','11:50:00',3.99),('8784','2013-05-29','11:55:00',4.63),('8784','2013-05-29','12:00:00',3.47),('8784','2013-05-29','12:05:00',3.17),('8784','2013-05-29','12:10:00',4.7),('8784','2013-05-29','12:15:00',3.79),('8784','2013-05-29','12:20:00',5.02),('8784','2013-05-29','12:25:00',4.99),('8784','2013-05-29','12:30:00',4.89),('8784','2013-05-29','12:35:00',4.91),('8784','2013-05-29','12:40:00',3.74),('8784','2013-05-29','12:45:00',4.9),('8784','2013-05-29','12:50:00',4.64),('8784','2013-05-29','12:55:00',4.86),('8784','2013-05-29','13:00:00',4.9),('8784','2013-05-29','13:05:00',4.54),('8784','2013-05-29','13:10:00',4.49),('8784','2013-05-29','13:15:00',4.17),('8784','2013-05-29','13:20:00',3.91),('8784','2013-05-29','13:25:00',5.33),('8784','2013-05-29','13:30:00',5.19),('8784','2013-05-29','13:35:00',4.01),('8784','2013-05-29','13:40:00',5.05),('8784','2013-05-29','13:45:00',4.57),('8784','2013-05-29','13:50:00',4.33),('8784','2013-05-29','13:55:00',4.17),('8784','2013-05-29','14:00:00',4.92),('8784','2013-05-29','14:05:00',4.65),('8784','2013-05-29','14:10:00',4.66),('8784','2013-05-29','14:15:00',4.74),('8784','2013-05-29','14:20:00',4.73),('8784','2013-05-29','14:25:00',4.41),('8784','2013-05-29','14:30:00',4.72),('8784','2013-05-29','14:35:00',3.51),('8784','2013-05-29','14:40:00',4.83),('8784','2013-05-29','14:45:00',4.75),('8784','2013-05-29','14:50:00',4.09),('8784','2013-05-29','14:55:00',4.3),('8784','2013-05-29','15:00:00',4.67),('8784','2013-05-29','15:05:00',4.34),('8784','2013-05-29','15:10:00',3.53),('8784','2013-05-29','15:15:00',3.15),('8784','2013-05-29','15:20:00',3.78),('8784','2013-05-29','15:25:00',3.02),('8784','2013-05-29','15:30:00',3.72),('8784','2013-05-29','15:35:00',3.37),('8784','2013-05-29','15:40:00',2.76),('8784','2013-05-29','15:45:00',3.23),('8784','2013-05-29','15:50:00',3.22),('8784','2013-05-29','15:55:00',3.05),('8784','2013-05-29','16:00:00',2.87),('8784','2013-05-29','16:05:00',2.89),('8784','2013-05-29','16:10:00',2.52),('8784','2013-05-29','16:15:00',2.41),('8784','2013-05-29','16:20:00',2.34),('8784','2013-05-29','16:25:00',2.4),('8784','2013-05-29','16:30:00',2.01),('8784','2013-05-29','16:35:00',2.06),('8784','2013-05-29','16:40:00',2.49),('8784','2013-05-29','16:45:00',2.22),('8784','2013-05-29','16:50:00',1.72),('8784','2013-05-29','16:55:00',1.6),('8784','2013-05-29','17:00:00',1.47),('8784','2013-05-29','17:35:00',1.26),('8784','2013-05-29','17:40:00',1.74),('8784','2013-05-29','17:45:00',1.23),('8784','2013-05-29','18:00:00',1.05),('8784','2013-05-29','18:05:00',1.32),('8784','2013-05-29','18:10:00',1.45),('8784','2013-05-29','18:15:00',2.42),('8784','2013-05-29','18:20:00',1.66),('8784','2013-05-28','07:15:00',1.2),('8784','2013-05-28','07:20:00',1.35),('8784','2013-05-28','07:25:00',1.4),('8784','2013-05-28','07:30:00',1.02),('8784','2013-05-28','07:40:00',1.26),('8784','2013-05-28','07:45:00',1.33),('8784','2013-05-28','07:50:00',1.35),('8784','2013-05-28','07:55:00',1.31),('8784','2013-05-28','08:00:00',1.38),('8784','2013-05-28','08:05:00',1.48),('8784','2013-05-28','08:10:00',1.69),('8784','2013-05-28','08:15:00',1.96),('8784','2013-05-28','08:20:00',2.08),('8784','2013-05-28','08:25:00',1.79),('8784','2013-05-28','08:30:00',2.05),('8784','2013-05-28','08:35:00',1.85),('8784','2013-05-28','08:40:00',1.64),('8784','2013-05-28','08:45:00',1.58),('8784','2013-05-28','08:50:00',1.83),('8784','2013-05-28','08:55:00',1.73),('8784','2013-05-28','09:00:00',1.81),('8784','2013-05-28','09:05:00',2.05),('8784','2013-05-28','09:10:00',1.85),('8784','2013-05-28','09:15:00',1.77),('8784','2013-05-28','09:20:00',2.06),('8784','2013-05-28','09:25:00',2.32),('8784','2013-05-28','09:30:00',2.51),('8784','2013-05-28','09:35:00',2.55),('8784','2013-05-28','09:40:00',2.44),('8784','2013-05-28','09:45:00',2.3),('8784','2013-05-28','09:50:00',2.35),('8784','2013-05-28','09:55:00',2.51),('8784','2013-05-28','10:00:00',2.34),('8784','2013-05-28','10:05:00',2.51),('8784','2013-05-28','10:10:00',2.78),('8784','2013-05-28','10:15:00',2.91),('8784','2013-05-28','10:20:00',3.04),('8784','2013-05-28','10:25:00',3.01),('8784','2013-05-28','10:30:00',3.29),('8784','2013-05-28','10:35:00',3.32),('8784','2013-05-28','10:40:00',3.02),('8784','2013-05-28','10:45:00',2.84),('8784','2013-05-28','10:50:00',3.08),('8784','2013-05-28','10:55:00',2.59),('8784','2013-05-28','11:00:00',2.69),('8784','2013-05-28','11:05:00',2.62),('8784','2013-05-28','11:10:00',2.69),('8784','2013-05-28','11:15:00',2.54),('8784','2013-05-28','11:20:00',2.39),('8784','2013-05-28','11:25:00',2.5),('8784','2013-05-28','11:30:00',4.53),('8784','2013-05-28','11:35:00',3.3),('8784','2013-05-28','11:40:00',4.24),('8784','2013-05-28','11:45:00',3.5),('8784','2013-05-28','11:50:00',1.26),('8784','2013-05-28','11:55:00',1.86),('8784','2013-05-28','12:00:00',1.66),('8784','2013-05-28','12:05:00',2.13),('8784','2013-05-28','12:10:00',3.04),('8784','2013-05-28','12:15:00',2.88),('8784','2013-05-28','12:20:00',2.57),('8784','2013-05-28','12:25:00',2.65),('8784','2013-05-28','12:30:00',2.93),('8784','2013-05-28','12:35:00',2.84),('8784','2013-05-28','12:40:00',2.91),('8784','2013-05-28','12:45:00',3.24),('8784','2013-05-28','12:50:00',2.89),('8784','2013-05-28','12:55:00',2.96),('8784','2013-05-28','13:00:00',3.01),('8784','2013-05-28','13:05:00',3.23),('8784','2013-05-28','13:10:00',3.35),('8784','2013-05-28','13:15:00',2.94),('8784','2013-05-28','13:20:00',3.38),('8784','2013-05-28','13:25:00',1.94),('8784','2013-05-28','13:30:00',2.35),('8784','2013-05-28','13:35:00',1.98),('8784','2013-05-28','13:40:00',2.23),('8784','2013-05-28','13:45:00',2.15),('8784','2013-05-28','13:50:00',2.88),('8784','2013-05-28','13:55:00',2.76),('8784','2013-05-28','14:00:00',2.87),('8784','2013-05-28','14:05:00',3),('8784','2013-05-28','14:10:00',4.27),('8784','2013-05-28','14:15:00',4.13),('8784','2013-05-28','14:20:00',2.74),('8784','2013-05-28','14:25:00',2.97),('8784','2013-05-28','14:30:00',3.71),('8784','2013-05-28','14:35:00',3.17),('8784','2013-05-28','14:40:00',3.49),('8784','2013-05-28','14:45:00',4.03),('8784','2013-05-28','14:50:00',3.18),('8784','2013-05-28','14:55:00',2.89),('8784','2013-05-28','15:00:00',2.71),('8784','2013-05-28','15:05:00',3.77),('8784','2013-05-28','15:10:00',1.8),('8784','2013-05-28','15:15:00',2.9),('8784','2013-05-28','15:20:00',3.29),('8784','2013-05-28','15:25:00',2.43),('8784','2013-05-28','15:30:00',1.63),('8784','2013-05-28','15:35:00',1.69),('8784','2013-05-28','15:40:00',2.77),('8784','2013-05-28','15:45:00',3.88),('8784','2013-05-28','15:50:00',3.29),('8784','2013-05-28','15:55:00',2.34),('8784','2013-05-28','16:00:00',1.74),('8784','2013-05-28','16:05:00',1.47),('8784','2013-05-28','16:10:00',1.53),('8784','2013-05-28','16:15:00',1.76),('8784','2013-05-28','16:20:00',2.78),('8784','2013-05-28','16:25:00',2.34),('8784','2013-05-28','16:30:00',2.8),('8784','2013-05-28','16:35:00',3.3),('8784','2013-05-28','16:40:00',3.06),('8784','2013-05-28','16:45:00',2.94),('8784','2013-05-28','16:50:00',2.87),('8784','2013-05-28','16:55:00',2.8),('8784','2013-05-28','17:00:00',2.74),('8784','2013-05-28','17:05:00',2.66),('8784','2013-05-28','17:10:00',2.56),('8784','2013-05-28','17:15:00',2.49),('8784','2013-05-28','17:20:00',2.41),('8784','2013-05-28','17:25:00',2.3),('8784','2013-05-28','17:30:00',2.23),('8784','2013-05-28','17:35:00',2.11),('8784','2013-05-28','17:40:00',2.02),('8784','2013-05-28','17:45:00',1.94),('8784','2013-05-28','17:50:00',1.88),('8784','2013-05-28','17:55:00',1.81),('8784','2013-05-28','18:00:00',1.8),('8784','2013-05-28','18:05:00',1.71),('8784','2013-05-28','18:35:00',1.17),('8784','2013-05-28','18:40:00',1.1),('8784','2013-05-28','18:45:00',1.02),('8784','2013-05-27','07:25:00',1.29),('8784','2013-05-27','07:30:00',1.34),('8784','2013-05-27','07:35:00',1.44),('8784','2013-05-27','07:40:00',1.5),('8784','2013-05-27','07:45:00',1.67),('8784','2013-05-27','07:50:00',1.62),('8784','2013-05-27','08:00:00',1.7),('8784','2013-05-27','08:05:00',2.17),('8784','2013-05-27','08:10:00',2.28),('8784','2013-05-27','08:15:00',2.28),('8784','2013-05-27','08:20:00',1.62),('8784','2013-05-27','08:25:00',2.06),('8784','2013-05-27','08:30:00',2.47),('8784','2013-05-27','08:35:00',2.53),('8784','2013-05-27','08:40:00',2.63),('8784','2013-05-27','08:45:00',2.77),('8784','2013-05-27','08:50:00',2.75),('8784','2013-05-27','08:55:00',3.08),('8784','2013-05-27','09:00:00',3.31),('8784','2013-05-27','09:05:00',3.51),('8784','2013-05-27','09:10:00',1.91),('8784','2013-05-27','09:15:00',2.93),('8784','2013-05-27','09:20:00',1.88),('8784','2013-05-27','09:25:00',2.83),('8784','2013-05-27','09:30:00',3.53),('8784','2013-05-27','09:35:00',3.58),('8784','2013-05-27','09:40:00',3.62),('8784','2013-05-27','09:45:00',3.69),('8784','2013-05-27','09:50:00',2.7),('8784','2013-05-27','09:55:00',3.89),('8784','2013-05-27','10:00:00',3.99),('8784','2013-05-27','10:05:00',3.91),('8784','2013-05-27','10:10:00',4.1),('8784','2013-05-27','10:15:00',3.75),('8784','2013-05-27','10:20:00',2.11),('8784','2013-05-27','10:25:00',4.26),('8784','2013-05-27','10:30:00',2.08),('8784','2013-05-27','10:35:00',1.79),('8784','2013-05-27','10:40:00',4.33),('8784','2013-05-27','10:45:00',1.99),('8784','2013-05-27','10:50:00',1.73),('8784','2013-05-27','10:55:00',1.69),('8784','2013-05-27','11:00:00',4.26),('8784','2013-05-27','11:05:00',3.02),('8784','2013-05-27','11:10:00',4.07),('8784','2013-05-27','11:15:00',1.85),('8784','2013-05-27','11:20:00',3.78),('8784','2013-05-27','11:25:00',4.22),('8784','2013-05-27','11:30:00',2.78),('8784','2013-05-27','11:35:00',1.57),('8784','2013-05-27','11:40:00',5.53),('8784','2013-05-27','11:45:00',2.2),('8784','2013-05-27','11:50:00',1.93),('8784','2013-05-27','11:55:00',2.62),('8784','2013-05-27','12:00:00',5.46),('8784','2013-05-27','12:05:00',2.14),('8784','2013-05-27','12:10:00',5.13),('8784','2013-05-27','12:15:00',4.13),('8784','2013-05-27','12:20:00',5.56),('8784','2013-05-27','12:25:00',4.4),('8784','2013-05-27','12:30:00',5.21),('8784','2013-05-27','12:35:00',3.74),('8784','2013-05-27','12:40:00',5.32),('8784','2013-05-27','12:45:00',2.43),('8784','2013-05-27','12:50:00',5.27),('8784','2013-05-27','12:55:00',3.51),('8784','2013-05-27','13:00:00',1.67),('8784','2013-05-27','13:05:00',2.79),('8784','2013-05-27','13:10:00',4.71),('8784','2013-05-27','13:15:00',1.71),('8784','2013-05-27','13:20:00',5.26),('8784','2013-05-27','13:25:00',4.81),('8784','2013-05-27','13:30:00',5.05),('8784','2013-05-27','13:35:00',2.8),('8784','2013-05-27','13:40:00',4.73),('8784','2013-05-27','13:45:00',4.74),('8784','2013-05-27','13:50:00',4.87),('8784','2013-05-27','13:55:00',4.85),('8784','2013-05-27','14:00:00',4.7),('8784','2013-05-27','14:05:00',4.71),('8784','2013-05-27','14:10:00',4.16),('8784','2013-05-27','14:15:00',4.28),('8784','2013-05-27','14:20:00',2.71),('8784','2013-05-27','14:25:00',4.74),('8784','2013-05-27','14:30:00',4.43),('8784','2013-05-27','14:35:00',3.37),('8784','2013-05-27','14:40:00',3.03),('8784','2013-05-27','14:45:00',4.84),('8784','2013-05-27','14:50:00',4.72),('8784','2013-05-27','14:55:00',3.97),('8784','2013-05-27','15:00:00',3.01),('8784','2013-05-27','15:05:00',2.87),('8784','2013-05-27','15:10:00',4.49),('8784','2013-05-27','15:15:00',3.16),('8784','2013-05-27','15:20:00',3.88),('8784','2013-05-27','15:25:00',3.46),('8784','2013-05-27','15:30:00',3.97),('8784','2013-05-27','15:35:00',4.4),('8784','2013-05-27','15:40:00',3.65),('8784','2013-05-27','15:45:00',3.33),('8784','2013-05-27','15:50:00',4.1),('8784','2013-05-27','15:55:00',2.73),('8784','2013-05-27','16:00:00',3.28),('8784','2013-05-27','16:05:00',2.33),('8784','2013-05-27','16:10:00',2.69),('8784','2013-05-27','16:15:00',2.52),('8784','2013-05-27','16:20:00',4.04),('8784','2013-05-27','16:25:00',3.82),('8784','2013-05-27','16:30:00',3.54),('8784','2013-05-27','16:35:00',2.99),('8784','2013-05-27','16:40:00',1.52),('8784','2013-05-27','16:45:00',1.37),('8784','2013-05-27','16:50:00',1.4),('8784','2013-05-27','16:55:00',1.49),('8784','2013-05-27','17:00:00',1.56),('8784','2013-05-27','17:05:00',1.63),('8784','2013-05-27','17:10:00',2.05),('8784','2013-05-27','17:15:00',1.62),('8784','2013-05-27','17:20:00',1.4),('8784','2013-05-27','17:25:00',1.29),('8784','2013-05-27','17:30:00',1.26),('8784','2013-05-27','17:35:00',1.17),('8784','2013-05-27','17:40:00',1.08),('8784','2013-05-27','17:45:00',1.02),('8784','2013-05-27','18:15:00',1.05),('8784','2013-05-27','18:20:00',1.43),('8784','2013-05-27','18:25:00',2.03),('8784','2013-05-27','18:30:00',1.61),('8784','2013-05-27','18:35:00',1.14),('8784','2013-05-27','18:45:00',1.15),('8784','2013-05-27','18:55:00',1.17),('8784','2013-05-27','19:00:00',1.24),('8784','2013-05-27','19:05:00',1.19),('8784','2013-05-27','19:10:00',1.06),('8784','2013-05-26','07:20:00',1.23),('8784','2013-05-26','07:35:00',1.39),('8784','2013-05-26','07:40:00',1.61),('8784','2013-05-26','07:45:00',1.81),('8784','2013-05-26','07:50:00',2.48),('8784','2013-05-26','08:05:00',2.52),('8784','2013-05-26','08:10:00',1.82),('8784','2013-05-26','08:20:00',1.21),('8784','2013-05-26','08:25:00',1.57),('8784','2013-05-26','08:30:00',2.37),('8784','2013-05-26','08:35:00',1.85),('8784','2013-05-26','08:40:00',2.53),('8784','2013-05-26','08:45:00',3.03),('8784','2013-05-26','08:50:00',3.2),('8784','2013-05-26','08:55:00',1.01),('8784','2013-05-26','09:00:00',1.98),('8784','2013-05-26','09:10:00',2.83),('8784','2013-05-26','09:15:00',1.36),('8784','2013-05-26','09:25:00',1.62),('8784','2013-05-26','09:40:00',1.5),('8784','2013-05-26','09:45:00',2.23),('8784','2013-05-26','09:55:00',1.39),('8784','2013-05-26','10:00:00',1.29),('8784','2013-05-26','10:05:00',3.67),('8784','2013-05-26','10:10:00',4.39),('8784','2013-05-26','10:15:00',2.18),('8784','2013-05-26','10:20:00',2.93),('8784','2013-05-26','10:25:00',3.5),('8784','2013-05-26','10:30:00',4.16),('8784','2013-05-26','10:35:00',4.55),('8784','2013-05-26','10:40:00',4.41),('8784','2013-05-26','10:45:00',4.48),('8784','2013-05-26','10:50:00',4.56),('8784','2013-05-26','10:55:00',4.01),('8784','2013-05-26','11:00:00',4.61),('8784','2013-05-26','11:05:00',4.63),('8784','2013-05-26','11:10:00',4.65),('8784','2013-05-26','11:15:00',4.66),('8784','2013-05-26','11:20:00',4.58),('8784','2013-05-26','11:25:00',4.78),('8784','2013-05-26','11:30:00',4.85),('8784','2013-05-26','11:35:00',4.58),('8784','2013-05-26','11:40:00',4.58),('8784','2013-05-26','11:45:00',4.71),('8784','2013-05-26','11:50:00',4.92),('8784','2013-05-26','11:55:00',4.6),('8784','2013-05-26','12:00:00',4.82),('8784','2013-05-26','12:05:00',5.01),('8784','2013-05-26','12:10:00',4.37),('8784','2013-05-26','12:15:00',3.11),('8784','2013-05-26','12:20:00',4.48),('8784','2013-05-26','12:25:00',4.56),('8784','2013-05-26','12:30:00',5.17),('8784','2013-05-26','12:35:00',5.17),('8784','2013-05-26','12:40:00',4.84),('8784','2013-05-26','12:45:00',4.73),('8784','2013-05-26','12:50:00',5.11),('8784','2013-05-26','12:55:00',5.1),('8784','2013-05-26','13:00:00',4.39),('8784','2013-05-26','13:05:00',4.76),('8784','2013-05-26','13:10:00',5.16),('8784','2013-05-26','13:15:00',5.14),('8784','2013-05-26','13:20:00',5.1),('8784','2013-05-26','13:25:00',5.05),('8784','2013-05-26','13:30:00',4.94),('8784','2013-05-26','13:35:00',5.06),('8784','2013-05-26','13:40:00',4.98),('8784','2013-05-26','13:45:00',5),('8784','2013-05-26','13:50:00',4.99),('8784','2013-05-26','13:55:00',4.9),('8784','2013-05-26','14:00:00',4.94),('8784','2013-05-26','14:05:00',4.88),('8784','2013-05-26','14:10:00',4.84),('8784','2013-05-26','14:15:00',4.8),('8784','2013-05-26','14:20:00',4.78),('8784','2013-05-26','14:25:00',4.71),('8784','2013-05-26','14:30:00',4.72),('8784','2013-05-26','14:35:00',4.67),('8784','2013-05-26','14:40:00',4.67),('8784','2013-05-26','14:45:00',4.6),('8784','2013-05-26','14:50:00',4.59),('8784','2013-05-26','14:55:00',4.54),('8784','2013-05-26','15:00:00',4.48),('8784','2013-05-26','15:05:00',4.46),('8784','2013-05-26','15:10:00',4.43),('8784','2013-05-26','15:15:00',4.41),('8784','2013-05-26','15:20:00',4.35),('8784','2013-05-26','15:25:00',4.3),('8784','2013-05-26','15:30:00',4.27),('8784','2013-05-26','15:35:00',4.21),('8784','2013-05-26','15:40:00',4.16),('8784','2013-05-26','15:45:00',4.08),('8784','2013-05-26','15:50:00',4.03),('8784','2013-05-26','15:55:00',3.98),('8784','2013-05-26','16:00:00',3.9),('8784','2013-05-26','16:05:00',3.87),('8784','2013-05-26','16:10:00',3.8),('8784','2013-05-26','16:15:00',3.71),('8784','2013-05-26','16:20:00',3.64),('8784','2013-05-26','16:25:00',3.58),('8784','2013-05-26','16:30:00',3.5),('8784','2013-05-26','16:35:00',3.42),('8784','2013-05-26','16:40:00',3.35),('8784','2013-05-26','16:45:00',3.28),('8784','2013-05-26','16:50:00',3.19),('8784','2013-05-26','16:55:00',3.11),('8784','2013-05-26','17:00:00',3.03),('8784','2013-05-26','17:05:00',2.96),('8784','2013-05-26','17:10:00',2.86),('8784','2013-05-26','17:15:00',2.77),('8784','2013-05-26','17:20:00',2.69),('8784','2013-05-26','17:25:00',2.61),('8784','2013-05-26','17:30:00',2.52),('8784','2013-05-26','17:35:00',2.35),('8784','2013-05-26','17:40:00',2.35),('8784','2013-05-26','17:45:00',2.24),('8784','2013-05-26','17:50:00',2.15),('8784','2013-05-26','17:55:00',2.06),('8784','2013-05-26','18:00:00',1.98),('8784','2013-05-26','18:05:00',1.88),('8784','2013-05-26','18:10:00',1.78),('8784','2013-05-26','18:15:00',1.68),('8784','2013-05-26','18:20:00',1.6),('8784','2013-05-26','18:25:00',1.51),('8784','2013-05-26','18:30:00',1.42),('8784','2013-05-26','18:35:00',1.32),('8784','2013-05-26','18:40:00',1.22),('8784','2013-05-26','18:45:00',1.14),('8784','2013-05-26','18:50:00',1.06),('8784','2013-05-25','07:15:00',1.34),('8784','2013-05-25','07:20:00',1.2),('8784','2013-05-25','07:25:00',1.03),('8784','2013-05-25','07:30:00',1.52),('8784','2013-05-25','07:35:00',1.97),('8784','2013-05-25','07:40:00',1.46),('8784','2013-05-25','07:50:00',1.04),('8784','2013-05-25','07:55:00',2.02),('8784','2013-05-25','08:00:00',2.46),('8784','2013-05-25','08:05:00',2.16),('8784','2013-05-25','08:10:00',1.56),('8784','2013-05-25','08:20:00',1.83),('8784','2013-05-25','08:25:00',2.76),('8784','2013-05-25','08:30:00',2.92),('8784','2013-05-25','08:35:00',1.67),('8784','2013-05-25','08:40:00',1.64),('8784','2013-05-25','08:45:00',1.35),('8784','2013-05-25','08:50:00',2.1),('8784','2013-05-25','08:55:00',1.7),('8784','2013-05-25','09:00:00',2.46),('8784','2013-05-25','09:05:00',2.92),('8784','2013-05-25','09:10:00',3.4),('8784','2013-05-25','09:15:00',3.74),('8784','2013-05-25','09:20:00',1.6),('8784','2013-05-25','09:25:00',1.64),('8784','2013-05-25','09:30:00',1.2),('8784','2013-05-25','09:35:00',2.85),('8784','2013-05-25','09:40:00',3.85),('8784','2013-05-25','09:45:00',2.88),('8784','2013-05-25','09:50:00',4.01),('8784','2013-05-25','09:55:00',2.24),('8784','2013-05-25','10:10:00',1.29),('8784','2013-05-25','10:15:00',1.15),('8784','2013-05-25','10:25:00',1),('8784','2013-05-25','10:40:00',1.71),('8784','2013-05-25','10:45:00',1.51),('8784','2013-05-25','10:50:00',1.49),('8784','2013-05-25','11:00:00',1.25),('8784','2013-05-25','11:05:00',2.15),('8784','2013-05-25','11:10:00',4.48),('8784','2013-05-25','11:15:00',4.29),('8784','2013-05-25','11:20:00',3),('8784','2013-05-25','11:25:00',1.06),('8784','2013-05-25','11:35:00',1.87),('8784','2013-05-25','11:40:00',2.37),('8784','2013-05-25','11:45:00',2.69),('8784','2013-05-25','11:50:00',2.16),('8784','2013-05-25','11:55:00',2.1),('8784','2013-05-25','12:00:00',1.78),('8784','2013-05-25','12:05:00',1.51),('8784','2013-05-25','12:10:00',1.93),('8784','2013-05-25','12:15:00',1.34),('8784','2013-05-25','12:20:00',1.69),('8784','2013-05-25','12:25:00',2.16),('8784','2013-05-25','12:30:00',1.5),('8784','2013-05-25','12:35:00',1.7),('8784','2013-05-25','12:40:00',1.98),('8784','2013-05-25','12:45:00',1.96),('8784','2013-05-25','12:50:00',1.47),('8784','2013-05-25','12:55:00',2.12),('8784','2013-05-25','13:00:00',1.14),('8784','2013-05-25','13:05:00',1.81),('8784','2013-05-25','13:10:00',1.59),('8784','2013-05-25','13:15:00',2.06),('8784','2013-05-25','13:20:00',2.3),('8784','2013-05-25','13:25:00',4.17),('8784','2013-05-25','13:30:00',1.81),('8784','2013-05-25','13:35:00',1.59),('8784','2013-05-25','13:40:00',2.27),('8784','2013-05-25','13:45:00',2.05),('8784','2013-05-25','13:50:00',2.58),('8784','2013-05-25','13:55:00',3.85),('8784','2013-05-25','14:00:00',3.89),('8784','2013-05-25','14:05:00',4.33),('8784','2013-05-25','14:10:00',4.68),('8784','2013-05-25','14:15:00',3.95),('8784','2013-05-25','14:20:00',4.54),('8784','2013-05-25','14:25:00',3.09),('8784','2013-05-25','14:30:00',3.56),('8784','2013-05-25','14:35:00',3.03),('8784','2013-05-25','14:40:00',1.45),('8784','2013-05-25','14:45:00',3.46),('8784','2013-05-25','14:50:00',1.32),('8784','2013-05-25','14:55:00',2.03),('8784','2013-05-25','15:00:00',4.39),('8784','2013-05-25','15:05:00',2.67),('8784','2013-05-25','15:10:00',2.32),('8784','2013-05-25','15:15:00',2.6),('8784','2013-05-25','15:20:00',1.6),('8784','2013-05-25','15:25:00',3.04),('8784','2013-05-25','15:30:00',2.91),('8784','2013-05-25','15:35:00',4.71),('8784','2013-05-25','15:40:00',4.46),('8784','2013-05-25','15:45:00',3.92),('8784','2013-05-25','15:50:00',4.61),('8784','2013-05-25','15:55:00',4.44),('8784','2013-05-25','16:00:00',2.78),('8784','2013-05-25','16:05:00',2.31),('8784','2013-05-25','16:10:00',2.73),('8784','2013-05-25','16:15:00',2.27),('8784','2013-05-25','16:20:00',1.72),('8784','2013-05-25','16:25:00',1.94),('8784','2013-05-25','16:30:00',2.79),('8784','2013-05-25','16:35:00',3.56),('8784','2013-05-25','16:40:00',3.25),('8784','2013-05-25','16:45:00',2.74),('8784','2013-05-25','16:50:00',1.73),('8784','2013-05-25','16:55:00',1.05),('8784','2013-05-25','17:00:00',1.01),('8784','2013-05-25','17:05:00',1.98),('8784','2013-05-25','17:10:00',3.2),('8784','2013-05-25','17:15:00',2.55),('8784','2013-05-25','17:20:00',2.16),('8784','2013-05-25','17:25:00',1.33),('8784','2013-05-25','17:30:00',1.03),('8784','2013-05-25','17:35:00',1.67),('8784','2013-05-25','17:40:00',1.12),('8784','2013-05-25','17:45:00',1.18),('8784','2013-05-25','17:50:00',1.78),('8784','2013-05-25','18:00:00',1.04),('8784','2013-05-25','18:10:00',1.1),('8784','2013-05-24','07:00:00',1.03),('8784','2013-05-24','08:00:00',1.13),('8784','2013-05-24','08:05:00',2.14),('8784','2013-05-24','08:10:00',2.5),('8784','2013-05-24','08:15:00',1.94),('8784','2013-05-24','08:25:00',1.58),('8784','2013-05-24','08:30:00',2.56),('8784','2013-05-24','08:35:00',1.72),('8784','2013-05-24','08:40:00',1.49),('8784','2013-05-24','08:45:00',2.68),('8784','2013-05-24','08:50:00',2.76),('8784','2013-05-24','08:55:00',2.88),('8784','2013-05-24','09:00:00',3.11),('8784','2013-05-24','09:05:00',3.53),('8784','2013-05-24','09:20:00',2.79),('8784','2013-05-24','09:25:00',1.57),('8784','2013-05-24','09:30:00',1.83),('8784','2013-05-24','09:40:00',1.69),('8784','2013-05-24','09:45:00',1.23),('8784','2013-05-24','09:50:00',1.61),('8784','2013-05-24','09:55:00',3.4),('8784','2013-05-24','10:00:00',1.89),('8784','2013-05-24','10:20:00',1.38),('8784','2013-05-24','10:25:00',2.83),('8784','2013-05-24','10:30:00',4.36),('8784','2013-05-24','10:35:00',4.11),('8784','2013-05-24','10:40:00',3.9),('8784','2013-05-24','10:45:00',4.12),('8784','2013-05-24','10:50:00',3.25),('8784','2013-05-24','10:55:00',4.94),('8784','2013-05-24','11:00:00',3.38),('8784','2013-05-24','11:05:00',3.69),('8784','2013-05-24','11:10:00',4.55),('8784','2013-05-24','11:15:00',3.69),('8784','2013-05-24','11:20:00',4.71),('8784','2013-05-24','11:25:00',4.98),('8784','2013-05-24','11:30:00',3.02),('8784','2013-05-24','11:35:00',1.5),('8784','2013-05-24','11:40:00',1.02),('8784','2013-05-24','11:45:00',3.39),('8784','2013-05-24','11:50:00',5.41),('8784','2013-05-24','11:55:00',3.37),('8784','2013-05-24','12:00:00',2.74),('8784','2013-05-24','12:05:00',2.88),('8784','2013-05-24','12:10:00',4.09),('8784','2013-05-24','12:15:00',2.7),('8784','2013-05-24','12:20:00',2.44),('8784','2013-05-24','12:25:00',4.31),('8784','2013-05-24','12:30:00',4.72),('8784','2013-05-24','12:35:00',2.45),('8784','2013-05-24','12:40:00',3.11),('8784','2013-05-24','12:45:00',3.9),('8784','2013-05-24','12:50:00',3.26),('8784','2013-05-24','12:55:00',2.91),('8784','2013-05-24','13:00:00',2.75),('8784','2013-05-24','13:05:00',2.3),('8784','2013-05-24','13:10:00',2.87),('8784','2013-05-24','13:15:00',3.2),('8784','2013-05-24','13:20:00',3.37),('8784','2013-05-24','13:25:00',2.6),('8784','2013-05-24','13:30:00',2.26),('8784','2013-05-24','13:35:00',2.83),('8784','2013-05-24','13:40:00',2.39),('8784','2013-05-24','13:45:00',1.27),('8784','2013-05-24','13:50:00',1.4),('8784','2013-05-24','13:55:00',2.89),('8784','2013-05-24','14:00:00',2.37),('8784','2013-05-24','14:05:00',2.12),('8784','2013-05-24','14:10:00',1.54),('8784','2013-05-24','14:15:00',3.75),('8784','2013-05-24','14:20:00',3.53),('8784','2013-05-24','14:25:00',3.69),('8784','2013-05-24','14:30:00',2.76),('8784','2013-05-24','14:35:00',3.69),('8784','2013-05-24','14:40:00',2.71),('8784','2013-05-24','14:45:00',3.09),('8784','2013-05-24','14:50:00',1.54),('8784','2013-05-24','14:55:00',1.85),('8784','2013-05-24','15:00:00',3),('8784','2013-05-24','15:05:00',2.85),('8784','2013-05-24','15:10:00',2.43),('8784','2013-05-24','15:15:00',4.07),('8784','2013-05-24','15:20:00',4.25),('8784','2013-05-24','15:25:00',3.68),('8784','2013-05-24','15:30:00',4.98),('8784','2013-05-24','15:35:00',4.22),('8784','2013-05-24','15:40:00',3.43),('8784','2013-05-24','15:45:00',4.3),('8784','2013-05-24','15:50:00',4.8),('8784','2013-05-24','15:55:00',4.78),('8784','2013-05-24','16:00:00',2.36),('8784','2013-05-24','16:05:00',2.38),('8784','2013-05-24','16:10:00',2.5),('8784','2013-05-24','16:15:00',3.09),('8784','2013-05-24','16:20:00',2.4),('8784','2013-05-24','16:25:00',3.33),('8784','2013-05-24','16:30:00',3.14),('8784','2013-05-24','16:35:00',1.76),('8784','2013-05-24','16:50:00',1.65),('8784','2013-05-24','16:55:00',1.98),('8784','2013-05-24','17:00:00',1.5),('8784','2013-05-24','17:05:00',1.1),('8784','2013-05-24','17:20:00',1.14),('8784','2013-05-24','17:25:00',1.18),('8784','2013-05-24','17:30:00',1.22),('8784','2013-05-24','17:35:00',1.23),('8784','2013-05-24','17:40:00',1.06),('8784','2013-05-23','07:55:00',1.06),('8784','2013-05-23','08:00:00',1.3),('8784','2013-05-23','08:05:00',1.79),('8784','2013-05-23','08:10:00',1.34),('8784','2013-05-23','08:30:00',2.23),('8784','2013-05-23','08:35:00',2.19),('8784','2013-05-23','08:40:00',2.73),('8784','2013-05-23','08:45:00',1.72),('8784','2013-05-23','08:55:00',1.15),('8784','2013-05-23','09:00:00',3.06),('8784','2013-05-23','09:05:00',1.25),('8784','2013-05-23','09:15:00',1.12),('8784','2013-05-23','09:20:00',2.44),('8784','2013-05-23','09:25:00',3.63),('8784','2013-05-23','09:30:00',3.58),('8784','2013-05-23','09:35:00',2.81),('8784','2013-05-23','09:40:00',3.3),('8784','2013-05-23','09:45:00',2.18),('8784','2013-05-23','09:50:00',3.16),('8784','2013-05-23','09:55:00',1.83),('8784','2013-05-23','10:00:00',1.27),('8784','2013-05-23','10:05:00',3.91),('8784','2013-05-23','10:10:00',4.25),('8784','2013-05-23','10:15:00',4.3),('8784','2013-05-23','10:20:00',2.33),('8784','2013-05-23','10:25:00',3.74),('8784','2013-05-23','10:30:00',3.87),('8784','2013-05-23','10:35:00',3.92),('8784','2013-05-23','10:40:00',4.02),('8784','2013-05-23','10:45:00',4.4),('8784','2013-05-23','10:50:00',3.01),('8784','2013-05-23','10:55:00',4.02),('8784','2013-05-23','11:00:00',2.54),('8784','2013-05-23','11:05:00',4.14),('8784','2013-05-23','11:10:00',2.31),('8784','2013-05-23','11:15:00',2.61),('8784','2013-05-23','11:20:00',1.89),('8784','2013-05-23','11:25:00',2.74),('8784','2013-05-23','11:30:00',3.31),('8784','2013-05-23','11:35:00',3.48),('8784','2013-05-23','11:40:00',4.9),('8784','2013-05-23','11:45:00',2.52),('8784','2013-05-23','11:50:00',3.71),('8784','2013-05-23','11:55:00',4.39),('8784','2013-05-23','12:00:00',5.04),('8784','2013-05-23','12:05:00',5.06),('8784','2013-05-23','12:10:00',5.17),('8784','2013-05-23','12:15:00',3.25),('8784','2013-05-23','12:20:00',3.52),('8784','2013-05-23','12:25:00',4.33),('8784','2013-05-23','12:30:00',5.1),('8784','2013-05-23','12:35:00',1.69),('8784','2013-05-23','12:40:00',5.71),('8784','2013-05-23','12:45:00',3.32),('8784','2013-05-23','12:50:00',4.05),('8784','2013-05-23','12:55:00',5.29),('8784','2013-05-23','13:00:00',4.97),('8784','2013-05-23','13:05:00',3.85),('8784','2013-05-23','13:10:00',4.64),('8784','2013-05-23','13:15:00',4.36),('8784','2013-05-23','13:20:00',3.86),('8784','2013-05-23','13:25:00',4.56),('8784','2013-05-23','13:30:00',3.26),('8784','2013-05-23','13:35:00',2.65),('8784','2013-05-23','13:40:00',2.8),('8784','2013-05-23','13:45:00',3.55),('8784','2013-05-23','13:50:00',3.87),('8784','2013-05-23','13:55:00',4.56),('8784','2013-05-23','14:00:00',4.85),('8784','2013-05-23','14:05:00',4.99),('8784','2013-05-23','14:10:00',4.92),('8784','2013-05-23','14:15:00',3.84),('8784','2013-05-23','14:20:00',4.29),('8784','2013-05-23','14:25:00',3.15),('8784','2013-05-23','14:30:00',2.04),('8784','2013-05-23','14:35:00',5.28),('8784','2013-05-23','14:40:00',3.7),('8784','2013-05-23','14:45:00',2.05),('8784','2013-05-23','14:50:00',2.19),('8784','2013-05-23','14:55:00',3.4),('8784','2013-05-23','15:00:00',3.37),('8784','2013-05-23','15:05:00',3.3),('8784','2013-05-23','15:10:00',1.48),('8784','2013-05-23','15:15:00',2),('8784','2013-05-23','15:20:00',3.46),('8784','2013-05-23','15:25:00',1.56),('8784','2013-05-23','15:30:00',4.01),('8784','2013-05-23','15:35:00',3.5),('8784','2013-05-23','15:40:00',1.5),('8784','2013-05-23','15:45:00',2.6),('8784','2013-05-23','15:50:00',1.3),('8784','2013-05-23','15:55:00',2.12),('8784','2013-05-23','16:00:00',2.93),('8784','2013-05-23','16:05:00',4.05),('8784','2013-05-23','16:10:00',2.06),('8784','2013-05-23','16:15:00',3.44),('8784','2013-05-23','16:20:00',2.81),('8784','2013-05-23','16:25:00',2.96),('8784','2013-05-23','16:30:00',3.37),('8784','2013-05-23','16:35:00',1.74),('8784','2013-05-23','16:40:00',1.31),('8784','2013-05-23','16:45:00',1.99),('8784','2013-05-23','16:50:00',1.28),('8784','2013-05-23','17:05:00',1.3),('8784','2013-05-23','17:10:00',2.69),('8784','2013-05-23','17:15:00',2.12),('8784','2013-05-23','17:20:00',1.59),('8784','2013-05-23','17:25:00',1.05),('8784','2013-05-23','17:35:00',1.73),('8784','2013-05-23','17:40:00',1.11),('8784','2013-05-23','17:45:00',1.05),('8784','2013-05-23','17:55:00',1.55),('8784','2013-05-23','18:00:00',2.08),('8784','2013-05-23','18:05:00',2.6),('8784','2013-05-23','18:45:00',1.11),('8784','2013-05-23','18:50:00',1.32),('8784','2013-05-23','18:55:00',1.03),('8784','2013-05-22','07:50:00',1.08),('8784','2013-05-22','07:55:00',1.18),('8784','2013-05-22','08:00:00',1.31),('8784','2013-05-22','08:05:00',1.63),('8784','2013-05-22','08:10:00',1.44),('8784','2013-05-22','08:15:00',2.38),('8784','2013-05-22','08:20:00',2.25),('8784','2013-05-22','08:25:00',1.97),('8784','2013-05-22','08:30:00',2.49),('8784','2013-05-22','08:35:00',2.99),('8784','2013-05-22','08:40:00',1.64),('8784','2013-05-22','08:45:00',1.83),('8784','2013-05-22','08:50:00',1.11),('8784','2013-05-22','09:25:00',1.43),('8784','2013-05-22','09:30:00',3.27),('8784','2013-05-22','09:35:00',3.25),('8784','2013-05-22','09:40:00',3.23),('8784','2013-05-22','09:45:00',3.24),('8784','2013-05-22','09:50:00',3.3),('8784','2013-05-22','09:55:00',3.36),('8784','2013-05-22','10:00:00',3.43),('8784','2013-05-22','10:05:00',3.48),('8784','2013-05-22','10:10:00',3.55),('8784','2013-05-22','10:15:00',3.61),('8784','2013-05-22','10:20:00',3.47),('8784','2013-05-22','10:25:00',3.76),('8784','2013-05-22','10:30:00',3.8),('8784','2013-05-22','10:35:00',3.81),('8784','2013-05-22','10:40:00',4.04),('8784','2013-05-22','10:45:00',4.02),('8784','2013-05-22','10:50:00',3.95),('8784','2013-05-22','10:55:00',3.97),('8784','2013-05-22','11:00:00',4.06),('8784','2013-05-22','11:05:00',4.19),('8784','2013-05-22','11:10:00',3.03),('8784','2013-05-22','11:15:00',4.11),('8784','2013-05-22','11:20:00',4.28),('8784','2013-05-22','11:25:00',4.34),('8784','2013-05-22','11:30:00',3.54),('8784','2013-05-22','11:35:00',3.73),('8784','2013-05-22','11:40:00',2.96),('8784','2013-05-22','11:45:00',4.37),('8784','2013-05-22','11:50:00',2.62),('8784','2013-05-22','11:55:00',2.21),('8784','2013-05-22','12:00:00',3.2),('8784','2013-05-22','12:05:00',2.54),('8784','2013-05-22','12:10:00',2.52),('8784','2013-05-22','12:15:00',3.3),('8784','2013-05-22','12:20:00',4.05),('8784','2013-05-22','12:25:00',3.44),('8784','2013-05-22','12:30:00',2.36),('8784','2013-05-22','12:35:00',2.59),('8784','2013-05-22','12:40:00',1.78),('8784','2013-05-22','13:00:00',1.11),('8784','2013-05-22','13:05:00',4.6),('8784','2013-05-22','13:10:00',2.9),('8784','2013-05-22','13:15:00',2.92),('8784','2013-05-22','13:20:00',3.3),('8784','2013-05-22','13:25:00',1.23),('8784','2013-05-22','13:30:00',1.85),('8784','2013-05-22','13:35:00',4.07),('8784','2013-05-22','13:40:00',2.82),('8784','2013-05-22','13:45:00',2.36),('8784','2013-05-22','13:50:00',1.85),('8784','2013-05-22','13:55:00',2.14),('8784','2013-05-22','14:00:00',2.93),('8784','2013-05-22','14:05:00',3.51),('8784','2013-05-22','14:10:00',4.53),('8784','2013-05-22','14:15:00',4.47),('8784','2013-05-22','14:20:00',4.35),('8784','2013-05-22','14:25:00',4.29),('8784','2013-05-22','14:30:00',4.24),('8784','2013-05-22','14:35:00',4.09),('8784','2013-05-22','14:40:00',4.17),('8784','2013-05-22','14:45:00',4.18),('8784','2013-05-22','14:50:00',4.15),('8784','2013-05-22','14:55:00',4.1),('8784','2013-05-22','15:00:00',4.06),('8784','2013-05-22','15:05:00',4),('8784','2013-05-22','15:10:00',3.87),('8784','2013-05-22','15:15:00',3.84),('8784','2013-05-22','15:20:00',3.39),('8784','2013-05-22','15:25:00',2.33),('8784','2013-05-22','15:30:00',2.1),('8784','2013-05-22','15:35:00',2.23),('8784','2013-05-22','15:40:00',3.67),('8784','2013-05-22','15:45:00',2.95),('8784','2013-05-22','15:50:00',3.62),('8784','2013-05-22','15:55:00',3.52),('8784','2013-05-22','16:00:00',3.47),('8784','2013-05-22','16:05:00',3.36),('8784','2013-05-22','16:10:00',3.31),('8784','2013-05-22','16:15:00',3.2),('8784','2013-05-22','16:20:00',3.17),('8784','2013-05-22','16:25:00',3.11),('8784','2013-05-22','16:30:00',3.01),('8784','2013-05-22','16:35:00',2.86),('8784','2013-05-22','16:40:00',2.88),('8784','2013-05-22','16:45:00',2.63),('8784','2013-05-22','16:50:00',1.25),('8784','2013-05-22','17:15:00',1.19),('8784','2013-05-22','17:20:00',1.32),('8784','2013-05-22','17:25:00',1.74),('8784','2013-05-22','17:30:00',1.43),('8784','2013-05-22','17:35:00',1.73),('8784','2013-05-22','17:55:00',1.6),('8784','2013-05-22','18:00:00',1.76),('8784','2014-04-01','08:15:00',1.02),('8784','2014-04-01','08:20:00',1.1),('8784','2014-04-01','08:25:00',1.19),('8784','2014-04-01','08:30:00',1.29),('8784','2014-04-01','08:35:00',1.36),('8784','2014-04-01','08:40:00',1.47),('8784','2014-04-01','08:45:00',1.57),('8784','2014-04-01','08:50:00',1.67),('8784','2014-04-01','08:55:00',1.76),('8784','2014-04-01','09:00:00',1.84),('8784','2014-04-01','09:05:00',1.95),('8784','2014-04-01','09:10:00',2.02),('8784','2014-04-01','09:15:00',2.09),('8784','2014-04-01','09:20:00',2.16),('8784','2014-04-01','09:25:00',2.26),('8784','2014-04-01','09:30:00',2.3),('8784','2014-04-01','09:35:00',2.41),('8784','2014-04-01','09:40:00',2.54),('8784','2014-04-01','09:45:00',2.58),('8784','2014-04-01','09:50:00',2.67),('8784','2014-04-01','09:55:00',2.77),('8784','2014-04-01','10:00:00',2.84),('8784','2014-04-01','10:05:00',2.89),('8784','2014-04-01','10:10:00',2.95),('8784','2014-04-01','10:15:00',3.08),('8784','2014-04-01','10:20:00',3.25),('8784','2014-04-01','10:25:00',3.44),('8784','2014-04-01','10:30:00',3.59),('8784','2014-04-01','10:35:00',3.16),('8784','2014-04-01','10:40:00',2.39),('8784','2014-04-01','10:45:00',2.6),('8784','2014-04-01','10:50:00',3.58),('8784','2014-04-01','10:55:00',3.54),('8784','2014-04-01','11:00:00',3.6),('8784','2014-04-01','11:05:00',3.63),('8784','2014-04-01','11:10:00',3.66),('8784','2014-04-01','11:15:00',3.68),('8784','2014-04-01','11:20:00',3.76),('8784','2014-04-01','11:25:00',3.78),('8784','2014-04-01','11:30:00',3.87),('8784','2014-04-01','11:35:00',3.9),('8784','2014-04-01','11:40:00',3.92),('8784','2014-04-01','11:45:00',3.98),('8784','2014-04-01','11:50:00',3.97),('8784','2014-04-01','11:55:00',4),('8784','2014-04-01','12:00:00',4.05),('8784','2014-04-01','12:05:00',4.08),('8784','2014-04-01','12:10:00',4.12),('8784','2014-04-01','12:15:00',4.13),('8784','2014-04-01','12:20:00',4.16),('8784','2014-04-01','12:25:00',4.2),('8784','2014-04-01','12:30:00',4.24),('8784','2014-04-01','12:35:00',4.25),('8784','2014-04-01','12:40:00',4.24),('8784','2014-04-01','12:45:00',4.31),('8784','2014-04-01','12:50:00',4.1),('8784','2014-04-01','12:55:00',4.31),('8784','2014-04-01','13:00:00',4.33),('8784','2014-04-01','13:05:00',4.03),('8784','2014-04-01','13:10:00',4.38),('8784','2014-04-01','13:15:00',3.83),('8784','2014-04-01','13:20:00',4),('8784','2014-04-01','13:25:00',4.3),('8784','2014-04-01','13:30:00',4.3),('8784','2014-04-01','13:35:00',4.33),('8784','2014-04-01','13:40:00',4.43),('8784','2014-04-01','13:45:00',4.34),('8784','2014-04-01','13:50:00',4.22),('8784','2014-04-01','13:55:00',4.24),('8784','2014-04-01','14:00:00',4.19),('8784','2014-04-01','14:05:00',4.22),('8784','2014-04-01','14:10:00',3.82),('8784','2014-04-01','14:15:00',3.54),('8784','2014-04-01','14:20:00',3.08),('8784','2014-04-01','14:25:00',3.83),('8784','2014-04-01','14:30:00',3.47),('8784','2014-04-01','14:35:00',3.99),('8784','2014-04-01','14:40:00',3.39),('8784','2014-04-01','14:45:00',4.3),('8784','2014-04-01','14:50:00',3.92),('8784','2014-04-01','14:55:00',3.05),('8784','2014-04-01','15:00:00',4.02),('8784','2014-04-01','15:05:00',3.25),('8784','2014-04-01','15:10:00',3.66),('8784','2014-04-01','15:15:00',2.99),('8784','2014-04-01','15:20:00',2.04),('8784','2014-04-01','15:25:00',3.37),('8784','2014-04-01','15:30:00',3.32),('8784','2014-04-01','15:35:00',2.71),('8784','2014-04-01','15:40:00',3.81),('8784','2014-04-01','15:45:00',2.91),('8784','2014-04-01','15:50:00',3.38),('8784','2014-04-01','15:55:00',3.05),('8784','2014-04-01','16:00:00',1.96),('8784','2014-04-01','16:05:00',3.09),('8784','2014-04-01','16:10:00',2.77),('8784','2014-04-01','16:15:00',2.12),('8784','2014-04-01','16:20:00',1.31),('8784','2014-04-01','16:25:00',2.37),('8784','2014-04-01','16:30:00',2.56),('8784','2014-04-01','16:35:00',2.79),('8784','2014-04-01','16:40:00',2.34),('8784','2014-04-01','16:45:00',1.33),('8784','2014-04-01','16:50:00',1.61),('8784','2014-04-01','16:55:00',1.99),('8784','2014-04-01','17:00:00',2.24),('8784','2014-04-01','17:05:00',2.1),('8784','2014-04-01','17:10:00',1.62),('8784','2014-04-01','17:15:00',1.96),('8784','2014-04-01','17:20:00',1.83),('8784','2014-04-01','17:25:00',1.54),('8784','2014-04-01','17:30:00',1.62),('8784','2014-04-01','17:35:00',1.49),('8784','2014-04-01','17:40:00',1.42),('8784','2014-04-01','17:45:00',1.33),('8784','2014-04-01','17:50:00',1.25),('8784','2014-04-01','17:55:00',1.13),('8784','2014-04-01','18:00:00',1.04),('8784','2013-05-21','07:20:00',1.04),('8784','2013-05-21','07:25:00',1.14),('8784','2013-05-21','07:30:00',1.3),('8784','2013-05-21','07:35:00',1.57),('8784','2013-05-21','07:40:00',1.78),('8784','2013-05-21','07:45:00',1.44),('8784','2013-05-21','07:50:00',1.21),('8784','2013-05-21','07:55:00',1.25),('8784','2013-05-21','08:00:00',1.37),('8784','2013-05-21','08:05:00',1.02),('8784','2013-05-21','08:10:00',1.69),('8784','2013-05-21','08:15:00',2.16),('8784','2013-05-21','08:20:00',1.8),('8784','2013-05-21','08:25:00',2.11),('8784','2013-05-21','08:30:00',1.51),('8784','2013-05-21','08:35:00',1.44),('8784','2013-05-21','08:40:00',1.64),('8784','2013-05-21','08:45:00',1.41),('8784','2013-05-21','08:50:00',1.54),('8784','2013-05-21','08:55:00',1.97),('8784','2013-05-21','09:00:00',1.68),('8784','2013-05-21','09:05:00',1.5),('8784','2013-05-21','09:10:00',1.66),('8784','2013-05-21','09:15:00',1.83),('8784','2013-05-21','09:20:00',2.63),('8784','2013-05-21','09:25:00',2.55),('8784','2013-05-21','09:30:00',2.09),('8784','2013-05-21','09:35:00',2.19),('8784','2013-05-21','09:40:00',2.18),('8784','2013-05-21','09:45:00',1.87),('8784','2013-05-21','09:50:00',1.82),('8784','2013-05-21','09:55:00',2.05),('8784','2013-05-21','10:00:00',2.22),('8784','2013-05-21','10:05:00',2.48),('8784','2013-05-21','10:10:00',2.5),('8784','2013-05-21','10:15:00',2.67),('8784','2013-05-21','10:20:00',2.22),('8784','2013-05-21','10:25:00',2.12),('8784','2013-05-21','10:30:00',1.97),('8784','2013-05-21','10:35:00',2.06),('8784','2013-05-21','10:40:00',2.28),('8784','2013-05-21','10:45:00',3.22),('8784','2013-05-21','10:50:00',2.31),('8784','2013-05-21','10:55:00',1.81),('8784','2013-05-21','11:00:00',2.12),('8784','2013-05-21','11:05:00',2),('8784','2013-05-21','11:10:00',2.98),('8784','2013-05-21','11:15:00',4.1),('8784','2013-05-21','11:20:00',3.88),('8784','2013-05-21','11:25:00',4.42),('8784','2013-05-21','11:30:00',3.25),('8784','2013-05-21','11:35:00',2.83),('8784','2013-05-21','11:40:00',2.84),('8784','2013-05-21','11:45:00',2.38),('8784','2013-05-21','11:50:00',3.03),('8784','2013-05-21','11:55:00',3.86),('8784','2013-05-21','12:00:00',3.47),('8784','2013-05-21','12:05:00',4.07),('8784','2013-05-21','12:10:00',2.96),('8784','2013-05-21','12:15:00',3.34),('8784','2013-05-21','12:20:00',2.58),('8784','2013-05-21','12:25:00',3.44),('8784','2013-05-21','12:30:00',4.37),('8784','2013-05-21','12:35:00',2.93),('8784','2013-05-21','12:40:00',4.59),('8784','2013-05-21','12:45:00',4.17),('8784','2013-05-21','12:50:00',2.9),('8784','2013-05-21','12:55:00',4.99),('8784','2013-05-21','13:00:00',4.26),('8784','2013-05-21','13:05:00',4.31),('8784','2013-05-21','13:10:00',2.75),('8784','2013-05-21','13:15:00',3.84),('8784','2013-05-21','13:20:00',3.28),('8784','2013-05-21','13:25:00',3.27),('8784','2013-05-21','13:30:00',3.14),('8784','2013-05-21','13:35:00',1.59),('8784','2013-05-21','14:05:00',1.19),('8784','2013-05-21','14:10:00',1.89),('8784','2013-05-21','14:15:00',2.26),('8784','2013-05-21','14:20:00',1.89),('8784','2013-05-21','14:25:00',2.91),('8784','2013-05-21','14:30:00',2.78),('8784','2013-05-21','14:35:00',2.14),('8784','2013-05-21','14:40:00',2.05),('8784','2013-05-21','14:45:00',1.73),('8784','2013-05-21','14:50:00',1.09),('8784','2013-05-21','15:15:00',1.24),('8784','2013-05-21','15:20:00',1.65),('8784','2013-05-21','15:25:00',1.69),('8784','2013-05-21','15:30:00',2.63),('8784','2013-05-21','15:35:00',1.78),('8784','2013-05-21','15:40:00',1.46),('8784','2013-05-21','15:45:00',1.52),('8784','2013-05-21','15:50:00',1.37),('8784','2013-05-21','15:55:00',1.32),('8784','2013-05-21','16:00:00',1.29),('8784','2013-05-21','16:05:00',1.3),('8784','2013-05-21','16:10:00',1.44),('8784','2013-05-21','16:15:00',1.21),('8784','2013-05-21','16:20:00',1.01),('8784','2013-05-21','16:25:00',1.38),('8784','2013-05-21','16:30:00',1.9),('8784','2013-05-21','16:35:00',2.2),('8784','2013-05-21','16:40:00',2.07),('8784','2013-05-21','16:45:00',1.88),('8784','2013-05-21','16:50:00',1.21),('8784','2013-05-20','07:15:00',1.03),('8784','2013-05-20','07:20:00',1.1),('8784','2013-05-20','07:25:00',1.08),('8784','2013-05-20','07:30:00',1.27),('8784','2013-05-20','07:35:00',1.39),('8784','2013-05-20','07:40:00',1.47),('8784','2013-05-20','07:45:00',1.55),('8784','2013-05-20','07:50:00',1.6),('8784','2013-05-20','07:55:00',1.7),('8784','2013-05-20','08:00:00',1.83),('8784','2013-05-20','08:05:00',1.52),('8784','2013-05-20','08:10:00',1.52),('8784','2013-05-20','08:15:00',1.88),('8784','2013-05-20','08:20:00',1.94),('8784','2013-05-20','08:45:00',2.46),('8784','2013-05-20','08:50:00',3.47),('8784','2013-05-20','08:55:00',3.02),('8784','2013-05-20','09:00:00',3.08),('8784','2013-05-20','09:05:00',2.5),('8784','2013-05-20','09:10:00',3.74),('8784','2013-05-20','09:15:00',1.69),('8784','2013-05-20','09:20:00',2.26),('8784','2013-05-20','09:25:00',1.38),('8784','2013-05-20','09:35:00',2.91),('8784','2013-05-20','09:45:00',2.2),('8784','2013-05-20','09:50:00',2.56),('8784','2013-05-20','10:00:00',1.11),('8784','2013-05-20','10:05:00',1.49),('8784','2013-05-20','10:10:00',2.6),('8784','2013-05-20','10:25:00',2.07),('8784','2013-05-20','10:30:00',3.32),('8784','2013-05-20','10:35:00',1.54),('8784','2013-05-20','10:40:00',1.72),('8784','2013-05-20','10:45:00',1.93),('8784','2013-05-20','10:50:00',2.02),('8784','2013-05-20','10:55:00',1.22),('8784','2013-05-20','11:00:00',4.51),('8784','2013-05-20','11:05:00',4.06),('8784','2013-05-20','11:10:00',5.05),('8784','2013-05-20','11:15:00',4.35),('8784','2013-05-20','11:20:00',2.67),('8784','2013-05-20','11:25:00',4.22),('8784','2013-05-20','11:30:00',3.78),('8784','2013-05-20','11:35:00',3.75),('8784','2013-05-20','11:40:00',1.88),('8784','2013-05-20','11:45:00',1.95),('8784','2013-05-20','11:50:00',1.47),('8784','2013-05-20','11:55:00',4.59),('8784','2013-05-20','12:00:00',2.98),('8784','2013-05-20','12:05:00',3.39),('8784','2013-05-20','12:10:00',2.71),('8784','2013-05-20','12:15:00',2.53),('8784','2013-05-20','12:20:00',4.28),('8784','2013-05-20','12:25:00',2.83),('8784','2013-05-20','12:30:00',2.67),('8784','2013-05-20','12:35:00',1.89),('8784','2013-05-20','12:40:00',4.98),('8784','2013-05-20','12:45:00',4.2),('8784','2013-05-20','12:50:00',1.39),('8784','2013-05-20','12:55:00',3.97),('8784','2013-05-20','13:00:00',2.99),('8784','2013-05-20','13:05:00',3.1),('8784','2013-05-20','13:10:00',2.21),('8784','2013-05-20','13:15:00',2.23),('8784','2013-05-20','13:20:00',3.86),('8784','2013-05-20','13:25:00',5.37),('8784','2013-05-20','13:30:00',1.35),('8784','2013-05-20','13:35:00',4.72),('8784','2013-05-20','13:40:00',1.78),('8784','2013-05-20','13:45:00',4.78),('8784','2013-05-20','13:50:00',3.34),('8784','2013-05-20','13:55:00',4.41),('8784','2013-05-20','14:00:00',4.58),('8784','2013-05-20','14:05:00',1.02),('8784','2013-05-20','14:10:00',3.1),('8784','2013-05-20','14:15:00',3.92),('8784','2013-05-20','14:20:00',2.14),('8784','2013-05-20','14:25:00',4.27),('8784','2013-05-20','14:30:00',4.82),('8784','2013-05-20','14:35:00',2.93),('8784','2013-05-20','14:40:00',2.08),('8784','2013-05-20','14:45:00',4.26),('8784','2013-05-20','14:50:00',3.6),('8784','2013-05-20','14:55:00',4.14),('8784','2013-05-20','15:00:00',2.64),('8784','2013-05-20','15:05:00',2.69),('8784','2013-05-20','15:10:00',4.73),('8784','2013-05-20','15:15:00',1.96),('8784','2013-05-20','15:20:00',4.62),('8784','2013-05-20','15:25:00',4.07),('8784','2013-05-20','15:30:00',4.49),('8784','2013-05-20','15:35:00',4.5),('8784','2013-05-20','15:40:00',2.58),('8784','2013-05-20','15:45:00',2.07),('8784','2013-05-20','15:50:00',2.98),('8784','2013-05-20','15:55:00',2.32),('8784','2013-05-20','16:00:00',2.15),('8784','2013-05-20','16:05:00',3.74),('8784','2013-05-20','16:10:00',3.84),('8784','2013-05-20','16:15:00',3.25),('8784','2013-05-20','16:20:00',3.66),('8784','2013-05-20','16:25:00',3.57),('8784','2013-05-20','16:30:00',3.38),('8784','2013-05-20','16:35:00',3.31),('8784','2013-05-20','16:40:00',3.25),('8784','2013-05-20','16:45:00',3.02),('8784','2013-05-20','16:50:00',3.01),('8784','2013-05-20','16:55:00',2.86),('8784','2013-05-20','17:00:00',2.84),('8784','2013-05-20','17:05:00',2.81),('8784','2013-05-20','17:10:00',1.99),('8784','2013-05-20','17:15:00',1.39),('8784','2013-05-20','17:20:00',2.33),('8784','2013-05-20','17:25:00',2.88),('8784','2013-05-20','17:30:00',2.77),('8784','2013-05-20','17:35:00',2.3),('8784','2013-05-20','17:40:00',2.15),('8784','2013-05-20','17:45:00',2.05),('8784','2013-05-20','17:50:00',1.94),('8784','2013-05-20','17:55:00',1.87),('8784','2013-05-20','18:00:00',1.81),('8784','2013-05-20','18:05:00',1.78),('8784','2013-05-20','18:10:00',1.48),('8784','2013-05-20','18:15:00',1.72),('8784','2013-05-20','18:20:00',1.47),('8784','2013-05-20','18:25:00',1.35),('8784','2013-05-20','18:30:00',1.25),('8784','2013-05-20','18:35:00',1.16),('8784','2013-05-20','18:40:00',1.01),('8784','2013-05-19','08:30:00',1.01),('8784','2013-05-19','08:35:00',1.33),('8784','2013-05-19','08:40:00',1.04),('8784','2013-05-19','08:45:00',1.15),('8784','2013-05-19','08:50:00',1.4),('8784','2013-05-19','08:55:00',1.54),('8784','2013-05-19','09:00:00',1.44),('8784','2013-05-19','09:05:00',1.31),('8784','2013-05-19','09:10:00',1.48),('8784','2013-05-19','09:15:00',1.51),('8784','2013-05-19','09:20:00',1.05),('8784','2013-05-19','09:40:00',1.25),('8784','2013-05-19','09:45:00',1.38),('8784','2013-05-19','09:55:00',1.19),('8784','2013-05-19','10:00:00',1.54),('8784','2013-05-19','10:05:00',1.8),('8784','2013-05-19','10:10:00',2.64),('8784','2013-05-19','10:15:00',3.1),('8784','2013-05-19','10:20:00',3.18),('8784','2013-05-19','10:25:00',2.65),('8784','2013-05-19','10:30:00',3.52),('8784','2013-05-19','10:35:00',3.79),('8784','2013-05-19','10:40:00',4.38),('8784','2013-05-19','10:45:00',4.4),('8784','2013-05-19','10:50:00',4.1),('8784','2013-05-19','10:55:00',4.99),('8784','2013-05-19','11:00:00',3.87),('8784','2013-05-19','11:05:00',2.39),('8784','2013-05-19','11:10:00',3.23),('8784','2013-05-19','11:15:00',4.71),('8784','2013-05-19','11:20:00',4.61),('8784','2013-05-19','11:25:00',4.65),('8784','2013-05-19','11:30:00',4.67),('8784','2013-05-19','11:35:00',4.66),('8784','2013-05-19','11:40:00',4.71),('8784','2013-05-19','11:45:00',4.76),('8784','2013-05-19','11:50:00',4.76),('8784','2013-05-19','11:55:00',4.83),('8784','2013-05-19','12:00:00',4.87),('8784','2013-05-19','12:05:00',4.82),('8784','2013-05-19','12:10:00',4.8),('8784','2013-05-19','12:15:00',4.89),('8784','2013-05-19','12:20:00',5.28),('8784','2013-05-19','12:25:00',3.65),('8784','2013-05-19','12:30:00',3.25),('8784','2013-05-19','12:35:00',3.44),('8784','2013-05-19','12:40:00',4.4),('8784','2013-05-19','12:45:00',4.52),('8784','2013-05-19','12:50:00',3.44),('8784','2013-05-19','12:55:00',2.8),('8784','2013-05-19','13:00:00',4.28),('8784','2013-05-19','13:05:00',4.67),('8784','2013-05-19','13:10:00',4.21),('8784','2013-05-19','13:15:00',3.69),('8784','2013-05-19','13:20:00',4.19),('8784','2013-05-19','13:25:00',4.47),('8784','2013-05-19','13:30:00',4.68),('8784','2013-05-19','13:35:00',4.74),('8784','2013-05-19','13:40:00',4.73),('8784','2013-05-19','13:45:00',4.68),('8784','2013-05-19','13:50:00',4.73),('8784','2013-05-19','13:55:00',4.69),('8784','2013-05-19','14:00:00',4.7),('8784','2013-05-19','14:05:00',4.64),('8784','2013-05-19','14:10:00',4.67),('8784','2013-05-19','14:15:00',4.65),('8784','2013-05-19','14:20:00',4.65),('8784','2013-05-19','14:25:00',4.63),('8784','2013-05-19','14:30:00',4.59),('8784','2013-05-19','14:35:00',4.54),('8784','2013-05-19','14:40:00',4.51),('8784','2013-05-19','14:45:00',4.47),('8784','2013-05-19','14:50:00',4.43),('8784','2013-05-19','14:55:00',4.41),('8784','2013-05-19','15:00:00',4.37),('8784','2013-05-19','15:05:00',4.33),('8784','2013-05-19','15:10:00',4.27),('8784','2013-05-19','15:15:00',4.22),('8784','2013-05-19','15:20:00',4.18),('8784','2013-05-19','15:25:00',4.17),('8784','2013-05-19','15:30:00',4.14),('8784','2013-05-19','15:35:00',4),('8784','2013-05-19','15:40:00',3.97),('8784','2013-05-19','15:45:00',3.93),('8784','2013-05-19','15:50:00',3.9),('8784','2013-05-19','15:55:00',3.82),('8784','2013-05-19','16:00:00',3.8),('8784','2013-05-19','16:05:00',3.71),('8784','2013-05-19','16:10:00',3.63),('8784','2013-05-19','16:15:00',3.57),('8784','2013-05-19','16:20:00',3.49),('8784','2013-05-19','16:25:00',3.44),('8784','2013-05-19','16:30:00',3.35),('8784','2013-05-19','16:35:00',3.3),('8784','2013-05-19','16:40:00',3.24),('8784','2013-05-19','16:45:00',3.17),('8784','2013-05-19','16:50:00',3.05),('8784','2013-05-19','16:55:00',3.01),('8784','2013-05-19','17:00:00',2.94),('8784','2013-05-19','17:05:00',2.84),('8784','2013-05-19','17:10:00',2.76),('8784','2013-05-19','17:15:00',2.68),('8784','2013-05-19','17:20:00',2.6),('8784','2013-05-19','17:25:00',2.51),('8784','2013-05-19','17:30:00',2.41),('8784','2013-05-19','17:35:00',2.34),('8784','2013-05-19','17:40:00',2.24),('8784','2013-05-19','17:45:00',2.16),('8784','2013-05-19','17:50:00',2.07),('8784','2013-05-19','17:55:00',1.97),('8784','2013-05-19','18:00:00',1.89),('8784','2013-05-19','18:05:00',1.8),('8784','2013-05-19','18:10:00',1.71),('8784','2013-05-19','18:15:00',1.6),('8784','2013-05-19','18:20:00',1.52),('8784','2013-05-19','18:25:00',1.43),('8784','2013-05-19','18:30:00',1.34),('8784','2013-05-19','18:35:00',1.25),('8784','2013-05-19','18:40:00',1.17),('8784','2013-05-19','18:45:00',1.07),('8784','2013-05-18','07:20:00',1.04),('8784','2013-05-18','07:25:00',1.12),('8784','2013-05-18','07:30:00',1.21),('8784','2013-05-18','07:35:00',1.3),('8784','2013-05-18','07:40:00',1.44),('8784','2013-05-18','07:45:00',1.37),('8784','2013-05-18','07:50:00',1.33),('8784','2013-05-18','07:55:00',2.03),('8784','2013-05-18','08:00:00',2.2),('8784','2013-05-18','08:05:00',2),('8784','2013-05-18','08:10:00',1.11),('8784','2013-05-18','08:15:00',1.1),('8784','2013-05-18','08:20:00',1.58),('8784','2013-05-18','08:25:00',2.65),('8784','2013-05-18','08:30:00',2.36),('8784','2013-05-18','08:35:00',2.16),('8784','2013-05-18','08:40:00',2.49),('8784','2013-05-18','08:45:00',2.53),('8784','2013-05-18','08:50:00',2.58),('8784','2013-05-18','08:55:00',2.67),('8784','2013-05-18','09:00:00',2.75),('8784','2013-05-18','09:05:00',2.77),('8784','2013-05-18','09:10:00',2.93),('8784','2013-05-18','09:15:00',2.98),('8784','2013-05-18','09:20:00',3.06),('8784','2013-05-18','09:25:00',3.12),('8784','2013-05-18','09:30:00',3.18),('8784','2013-05-18','09:35:00',3.25),('8784','2013-05-18','09:40:00',3.32),('8784','2013-05-18','09:45:00',3.38),('8784','2013-05-18','09:50:00',3.43),('8784','2013-05-18','09:55:00',3.5),('8784','2013-05-18','10:00:00',3.55),('8784','2013-05-18','10:05:00',3.6),('8784','2013-05-18','10:10:00',3.67),('8784','2013-05-18','10:15:00',3.71),('8784','2013-05-18','10:20:00',3.76),('8784','2013-05-18','10:25:00',3.78),('8784','2013-05-18','10:30:00',3.83),('8784','2013-05-18','10:35:00',3.87),('8784','2013-05-18','10:40:00',3.91),('8784','2013-05-18','10:45:00',3.96),('8784','2013-05-18','10:50:00',4.02),('8784','2013-05-18','10:55:00',3.94),('8784','2013-05-18','11:00:00',4.26),('8784','2013-05-18','11:05:00',3.85),('8784','2013-05-18','11:10:00',3.4),('8784','2013-05-18','11:15:00',4.49),('8784','2013-05-18','11:20:00',4.35),('8784','2013-05-18','11:25:00',4.44),('8784','2013-05-18','11:30:00',4.17),('8784','2013-05-18','11:35:00',4.19),('8784','2013-05-18','11:40:00',4.33),('8784','2013-05-18','11:45:00',4.3),('8784','2013-05-18','11:50:00',4.15),('8784','2013-05-18','11:55:00',4.1),('8784','2013-05-18','12:00:00',4.13),('8784','2013-05-18','12:05:00',4.34),('8784','2013-05-18','12:10:00',4.31),('8784','2013-05-18','12:15:00',4.32),('8784','2013-05-18','12:20:00',4.36),('8784','2013-05-18','12:25:00',4.44),('8784','2013-05-18','12:30:00',3.33),('8784','2013-05-18','12:35:00',4.43),('8784','2013-05-18','12:40:00',4.39),('8784','2013-05-18','12:45:00',4.03),('8784','2013-05-18','12:50:00',4.39),('8784','2013-05-18','12:55:00',4.34),('8784','2013-05-18','13:00:00',4.38),('8784','2013-05-18','13:05:00',4.37),('8784','2013-05-18','13:10:00',3.51),('8784','2013-05-18','13:15:00',4.35),('8784','2013-05-18','13:20:00',4.39),('8784','2013-05-18','13:25:00',4.39),('8784','2013-05-18','13:30:00',4.37),('8784','2013-05-18','13:35:00',4.07),('8784','2013-05-18','13:40:00',4.34),('8784','2013-05-18','13:45:00',4.59),('8784','2013-05-18','13:50:00',3.99),('8784','2013-05-18','13:55:00',3.34),('8784','2013-05-18','14:00:00',3.29),('8784','2013-05-18','14:05:00',3.73),('8784','2013-05-18','14:10:00',4.69),('8784','2013-05-18','14:15:00',4.51),('8784','2013-05-18','14:20:00',4.48),('8784','2013-05-18','14:25:00',4.36),('8784','2013-05-18','14:30:00',4.34),('8784','2013-05-18','14:35:00',4.17),('8784','2013-05-18','14:40:00',4.48),('8784','2013-05-18','14:45:00',4.15),('8784','2013-05-18','14:50:00',4.21),('8784','2013-05-18','14:55:00',3.74),('8784','2013-05-18','15:00:00',3.84),('8784','2013-05-18','15:05:00',3.76),('8784','2013-05-18','15:10:00',3.69),('8784','2013-05-18','15:15:00',3.65),('8784','2013-05-18','15:20:00',3.59),('8784','2013-05-18','15:25:00',3.54),('8784','2013-05-18','15:30:00',3.5),('8784','2013-05-18','15:35:00',3.47),('8784','2013-05-18','15:40:00',3.41),('8784','2013-05-18','15:45:00',3.32),('8784','2013-05-18','15:50:00',3.27),('8784','2013-05-18','15:55:00',3.22),('8784','2013-05-18','16:00:00',3.16),('8784','2013-05-18','16:05:00',3.12),('8784','2013-05-18','16:10:00',3.04),('8784','2013-05-18','16:15:00',2.97),('8784','2013-05-18','16:20:00',2.93),('8784','2013-05-18','16:25:00',2.87),('8784','2013-05-18','16:30:00',2.79),('8784','2013-05-18','16:35:00',2.72),('8784','2013-05-18','16:40:00',2.66),('8784','2013-05-18','16:45:00',2.59),('8784','2013-05-18','16:50:00',2.51),('8784','2013-05-18','16:55:00',2.45),('8784','2013-05-18','17:00:00',2.37),('8784','2013-05-18','17:05:00',2.3),('8784','2013-05-18','17:10:00',2.25),('8784','2013-05-18','17:15:00',2.18),('8784','2013-05-18','17:20:00',2.11),('8784','2013-05-18','17:25:00',2.03),('8784','2013-05-18','17:30:00',1.94),('8784','2013-05-18','17:35:00',1.86),('8784','2013-05-18','17:40:00',1.79),('8784','2013-05-18','17:45:00',1.72),('8784','2013-05-18','17:50:00',1.65),('8784','2013-05-18','17:55:00',1.58),('8784','2013-05-18','18:00:00',1.49),('8784','2013-05-18','18:05:00',1.4),('8784','2013-05-18','18:10:00',1.33),('8784','2013-05-18','18:15:00',1.25),('8784','2013-05-18','18:20:00',1.17),('8784','2013-05-18','18:25:00',1.09),('8784','2013-05-18','18:30:00',1.02),('8784','2013-05-17','07:40:00',1.34),('8784','2013-05-17','07:45:00',1.38),('8784','2013-05-17','07:50:00',1.32),('8784','2013-05-17','07:55:00',1.31),('8784','2013-05-17','08:00:00',1.34),('8784','2013-05-17','08:05:00',1.08),('8784','2013-05-17','08:10:00',1.29),('8784','2013-05-17','08:15:00',2.07),('8784','2013-05-17','08:20:00',2.37),('8784','2013-05-17','08:25:00',1.75),('8784','2013-05-17','08:30:00',1.02),('8784','2013-05-17','09:25:00',1.2),('8784','2013-05-17','10:20:00',1.02),('8784','2013-05-17','10:25:00',1.45),('8784','2013-05-17','10:30:00',1.76),('8784','2013-05-17','10:35:00',1.37),('8784','2013-05-17','10:40:00',1.54),('8784','2013-05-17','10:45:00',1.7),('8784','2013-05-17','10:50:00',3.14),('8784','2013-05-17','10:55:00',3.37),('8784','2013-05-17','11:00:00',2.56),('8784','2013-05-17','11:05:00',2.17),('8784','2013-05-17','11:10:00',1.6),('8784','2013-05-17','11:15:00',2.27),('8784','2013-05-17','11:20:00',2.12),('8784','2013-05-17','11:25:00',1.86),('8784','2013-05-17','11:30:00',1.74),('8784','2013-05-17','11:35:00',2.35),('8784','2013-05-17','11:40:00',1.72),('8784','2013-05-17','11:45:00',3.88),('8784','2013-05-17','11:50:00',4.8),('8784','2013-05-17','11:55:00',4.04),('8784','2013-05-17','12:00:00',4.15),('8784','2013-05-17','12:05:00',3.86),('8784','2013-05-17','12:10:00',3.32),('8784','2013-05-17','12:15:00',2.49),('8784','2013-05-17','12:20:00',3.57),('8784','2013-05-17','12:25:00',3.22),('8784','2013-05-17','12:30:00',2.73),('8784','2013-05-17','12:35:00',3.52),('8784','2013-05-17','12:40:00',4.61),('8784','2013-05-17','12:45:00',5.02),('8784','2013-05-17','12:50:00',5.09),('8784','2013-05-17','12:55:00',4.65),('8784','2013-05-17','13:00:00',4.23),('8784','2013-05-17','13:05:00',4.81),('8784','2013-05-17','13:10:00',4.29),('8784','2013-05-17','13:15:00',4.71),('8784','2013-05-17','13:20:00',5.23),('8784','2013-05-17','13:25:00',4.54),('8784','2013-05-17','13:30:00',3.76),('8784','2013-05-17','13:35:00',4.8),('8784','2013-05-17','13:40:00',4.32),('8784','2013-05-17','13:45:00',4.3),('8784','2013-05-17','13:50:00',4.4),('8784','2013-05-17','13:55:00',5.17),('8784','2013-05-17','14:00:00',3.04),('8784','2013-05-17','14:05:00',3.66),('8784','2013-05-17','14:10:00',4.29),('8784','2013-05-17','14:15:00',4.37),('8784','2013-05-17','14:20:00',4.79),('8784','2013-05-17','14:25:00',4.03),('8784','2013-05-17','14:30:00',4.37),('8784','2013-05-17','14:35:00',4.18),('8784','2013-05-17','14:40:00',2.98),('8784','2013-05-17','14:45:00',3.51),('8784','2013-05-17','14:50:00',4.6),('8784','2013-05-17','14:55:00',2.6),('8784','2013-05-17','15:00:00',4.33),('8784','2013-05-17','15:05:00',3.21),('8784','2013-05-17','15:10:00',1.58),('8784','2013-05-17','15:15:00',3.81),('8784','2013-05-17','15:20:00',2.33),('8784','2013-05-17','15:25:00',2.08),('8784','2013-05-17','15:30:00',2.3),('8784','2013-05-17','15:35:00',3.03),('8784','2013-05-17','15:40:00',3.7),('8784','2013-05-17','15:45:00',1.85),('8784','2013-05-17','15:50:00',3.14),('8784','2013-05-17','15:55:00',4.4),('8784','2013-05-17','16:00:00',4.17),('8784','2013-05-17','16:05:00',2.2),('8784','2013-05-17','16:10:00',3.4),('8784','2013-05-17','16:15:00',3.32),('8784','2013-05-17','16:20:00',2.89),('8784','2013-05-17','16:25:00',3.43),('8784','2013-05-17','16:30:00',3.59),('8784','2013-05-17','16:35:00',3.55),('8784','2013-05-17','16:40:00',3.57),('8784','2013-05-17','16:45:00',3.28),('8784','2013-05-17','16:50:00',3),('8784','2013-05-17','16:55:00',2.86),('8784','2013-05-17','17:00:00',2.82),('8784','2013-05-17','17:05:00',2.7),('8784','2013-05-17','17:10:00',2.62),('8784','2013-05-17','17:15:00',2.56),('8784','2013-05-17','17:20:00',2.49),('8784','2013-05-17','17:25:00',2.41),('8784','2013-05-17','17:30:00',2.33),('8784','2013-05-17','17:35:00',2.24),('8784','2013-05-17','17:40:00',2.15),('8784','2013-05-17','17:45:00',2.06),('8784','2013-05-17','17:50:00',1.98),('8784','2013-05-17','17:55:00',1.88),('8784','2013-05-17','18:00:00',1.81),('8784','2013-05-17','18:05:00',1.73),('8784','2013-05-17','18:10:00',1.62),('8784','2013-05-17','18:15:00',1.52),('8784','2013-05-17','18:20:00',1.43),('8784','2013-05-17','18:25:00',1.35),('8784','2013-05-17','18:30:00',1.26),('8784','2013-05-17','18:35:00',1.2),('8784','2013-05-17','18:40:00',1.09),('8784','2013-05-16','09:20:00',1.23),('8784','2013-05-16','09:25:00',1.7),('8784','2013-05-16','09:30:00',1.73),('8784','2013-05-16','09:35:00',2.06),('8784','2013-05-16','09:40:00',2.31),('8784','2013-05-16','09:45:00',2.75),('8784','2013-05-16','09:50:00',1.42),('8784','2013-05-16','09:55:00',1.38),('8784','2013-05-16','10:00:00',1.67),('8784','2013-05-16','10:05:00',1.39),('8784','2013-05-16','10:10:00',1.29),('8784','2013-05-16','10:15:00',1.68),('8784','2013-05-16','10:20:00',2.21),('8784','2013-05-16','10:25:00',2.02),('8784','2013-05-16','10:30:00',2.06),('8784','2013-05-16','10:35:00',1.5),('8784','2013-05-16','10:40:00',1.5),('8784','2013-05-16','10:45:00',1.36),('8784','2013-05-16','10:50:00',1.56),('8784','2013-05-16','10:55:00',1.82),('8784','2013-05-16','11:00:00',4.34),('8784','2013-05-16','11:05:00',3.64),('8784','2013-05-16','11:10:00',3.4),('8784','2013-05-16','11:15:00',2.37),('8784','2013-05-16','11:20:00',1.28),('8784','2013-05-16','11:25:00',1.38),('8784','2013-05-16','11:30:00',1.68),('8784','2013-05-16','11:35:00',2.67),('8784','2013-05-16','11:40:00',3.76),('8784','2013-05-16','11:45:00',3.54),('8784','2013-05-16','11:50:00',3.56),('8784','2013-05-16','11:55:00',2.76),('8784','2013-05-16','12:00:00',2),('8784','2013-05-16','12:05:00',1.85),('8784','2013-05-16','12:10:00',1.87),('8784','2013-05-16','12:15:00',2.61),('8784','2013-05-16','12:20:00',2.15),('8784','2013-05-16','12:25:00',2.29),('8784','2013-05-16','12:30:00',3.64),('8784','2013-05-16','12:35:00',3.67),('8784','2013-05-16','12:40:00',4.96),('8784','2013-05-16','12:45:00',3.44),('8784','2013-05-16','12:50:00',2.87),('8784','2013-05-16','12:55:00',4.26),('8784','2013-05-16','13:00:00',4.31),('8784','2013-05-16','13:05:00',4.28),('8784','2013-05-16','13:10:00',4.3),('8784','2013-05-16','13:15:00',3.93),('8784','2013-05-16','13:20:00',3.14),('8784','2013-05-16','13:25:00',4.34),('8784','2013-05-16','13:30:00',4.26),('8784','2013-05-16','13:35:00',4.21),('8784','2013-05-16','13:40:00',4.16),('8784','2013-05-16','13:45:00',4.16),('8784','2013-05-16','13:50:00',4.19),('8784','2013-05-16','13:55:00',4.17),('8784','2013-05-16','14:00:00',4.13),('8784','2013-05-16','14:05:00',4.13),('8784','2013-05-16','14:10:00',4.08),('8784','2013-05-16','14:15:00',4.04),('8784','2013-05-16','14:20:00',4),('8784','2013-05-16','14:25:00',3.91),('8784','2013-05-16','14:30:00',3.91),('8784','2013-05-16','14:35:00',3.85),('8784','2013-05-16','14:40:00',3.84),('8784','2013-05-16','14:45:00',3.81),('8784','2013-05-16','14:50:00',3.47),('8784','2013-05-16','14:55:00',3.31),('8784','2013-05-16','15:00:00',3.75),('8784','2013-05-16','15:05:00',3.64),('8784','2013-05-16','15:10:00',3.61),('8784','2013-05-16','15:15:00',3.24),('8784','2013-05-16','15:20:00',3.55),('8784','2013-05-16','15:25:00',3.5),('8784','2013-05-16','15:30:00',3.39),('8784','2013-05-16','15:35:00',3.3),('8784','2013-05-16','15:40:00',3.4),('8784','2013-05-16','15:45:00',3.28),('8784','2013-05-16','15:50:00',3.26),('8784','2013-05-16','15:55:00',3.22),('8784','2013-05-16','16:00:00',3.17),('8784','2013-05-16','16:05:00',3.01),('8784','2013-05-16','16:10:00',3.05),('8784','2013-05-16','16:15:00',2.8),('8784','2013-05-16','16:20:00',3.01),('8784','2013-05-16','16:25:00',2.9),('8784','2013-05-16','16:30:00',2.88),('8784','2013-05-16','16:35:00',2.71),('8784','2013-05-16','16:40:00',1.73),('8784','2013-05-16','16:45:00',1.53),('8784','2013-05-16','16:50:00',2.04),('8784','2013-05-16','16:55:00',1.89),('8784','2013-05-16','17:00:00',1.72),('8784','2013-05-16','17:15:00',1.46),('8784','2013-05-16','17:20:00',1.56),('8784','2013-05-16','17:25:00',1.68),('8784','2013-05-16','17:30:00',1.98),('8784','2013-05-16','17:35:00',1.85),('8784','2013-05-16','17:40:00',1.57),('8784','2013-05-16','17:45:00',1.14),('8784','2013-05-16','18:45:00',1.03),('8784','2013-05-16','18:50:00',1.08),('8784','2013-05-16','18:55:00',1.09),('8784','2013-05-16','19:00:00',1.12),('8784','2013-05-16','19:05:00',1.04),('8784','2013-05-15','07:20:00',1.03),('8784','2013-05-15','07:25:00',1.13),('8784','2013-05-15','07:30:00',1.24),('8784','2013-05-15','07:35:00',1.32),('8784','2013-05-15','07:40:00',1.42),('8784','2013-05-15','07:45:00',1.61),('8784','2013-05-15','07:50:00',1.63),('8784','2013-05-15','07:55:00',1.54),('8784','2013-05-15','08:00:00',1.62),('8784','2013-05-15','08:05:00',1.56),('8784','2013-05-15','08:10:00',1.84),('8784','2013-05-15','08:15:00',1.98),('8784','2013-05-15','08:20:00',2.02),('8784','2013-05-15','08:25:00',2.07),('8784','2013-05-15','08:30:00',2.11),('8784','2013-05-15','08:35:00',2.26),('8784','2013-05-15','08:40:00',2.36),('8784','2013-05-15','08:45:00',2.46),('8784','2013-05-15','08:50:00',2.54),('8784','2013-05-15','08:55:00',2.62),('8784','2013-05-15','09:00:00',2.55),('8784','2013-05-15','09:05:00',2.76),('8784','2013-05-15','09:10:00',2.74),('8784','2013-05-15','09:15:00',2.79),('8784','2013-05-15','09:20:00',2.8),('8784','2013-05-15','09:25:00',2.9),('8784','2013-05-15','09:30:00',3.07),('8784','2013-05-15','09:35:00',3.13),('8784','2013-05-15','09:40:00',3.13),('8784','2013-05-15','09:45:00',3.23),('8784','2013-05-15','09:50:00',3.29),('8784','2013-05-15','09:55:00',3.32),('8784','2013-05-15','10:00:00',3.41),('8784','2013-05-15','10:05:00',3.48),('8784','2013-05-15','10:10:00',3.5),('8784','2013-05-15','10:15:00',3.45),('8784','2013-05-15','10:20:00',3.57),('8784','2013-05-15','10:25:00',3.7),('8784','2013-05-15','10:30:00',3.64),('8784','2013-05-15','10:35:00',3.76),('8784','2013-05-15','10:40:00',3.85),('8784','2013-05-15','10:45:00',3.89),('8784','2013-05-15','10:50:00',3.91),('8784','2013-05-15','10:55:00',3.78),('8784','2013-05-15','11:00:00',3.77),('8784','2013-05-15','11:05:00',3.99),('8784','2013-05-15','11:10:00',4.03),('8784','2013-05-15','11:15:00',4.08),('8784','2013-05-15','11:20:00',3.88),('8784','2013-05-15','11:25:00',4.12),('8784','2013-05-15','11:30:00',4.01),('8784','2013-05-15','11:35:00',4.08),('8784','2013-05-15','11:40:00',3.28),('8784','2013-05-15','11:45:00',3.17),('8784','2013-05-15','11:50:00',2.64),('8784','2013-05-15','11:55:00',1.97),('8784','2013-05-15','12:00:00',2.19),('8784','2013-05-15','12:05:00',3.41),('8784','2013-05-15','12:10:00',4.99),('8784','2013-05-15','12:15:00',4.52),('8784','2013-05-15','12:20:00',3.24),('8784','2013-05-15','12:25:00',3.88),('8784','2013-05-15','12:30:00',3.02),('8784','2013-05-15','12:35:00',3.68),('8784','2013-05-15','12:40:00',4.86),('8784','2013-05-15','12:45:00',2.67),('8784','2013-05-15','12:50:00',2.68),('8784','2013-05-15','12:55:00',2.99),('8784','2013-05-15','13:00:00',2.95),('8784','2013-05-15','13:05:00',3.63),('8784','2013-05-15','13:10:00',2.93),('8784','2013-05-15','13:15:00',2.67),('8784','2013-05-15','13:20:00',2.93),('8784','2013-05-15','13:25:00',2.95),('8784','2013-05-15','13:30:00',2.97),('8784','2013-05-15','13:35:00',2.6),('8784','2013-05-15','13:40:00',2.88),('8784','2013-05-15','13:45:00',2.68),('8784','2013-05-15','13:50:00',2.31),('8784','2013-05-15','13:55:00',2.3),('8784','2013-05-15','14:00:00',2.01),('8784','2013-05-15','14:05:00',1.8),('8784','2013-05-15','14:10:00',1.88),('8784','2013-05-15','14:15:00',1.85),('8784','2013-05-15','14:20:00',1.95),('8784','2013-05-15','14:25:00',1.82),('8784','2013-05-15','14:30:00',1.62),('8784','2013-05-15','14:35:00',1.59),('8784','2013-05-15','14:40:00',1.75),('8784','2013-05-15','14:45:00',1.61),('8784','2013-05-15','14:50:00',1.59),('8784','2013-05-15','14:55:00',1.61),('8784','2013-05-15','15:00:00',1.55),('8784','2013-05-15','15:05:00',1.24),('8784','2013-05-15','15:45:00',1.19),('8784','2013-05-15','15:50:00',1.64),('8784','2013-05-15','15:55:00',2.14),('8784','2013-05-15','16:00:00',2.06),('8784','2013-05-15','16:05:00',1.95),('8784','2013-05-15','16:10:00',1.76),('8784','2013-05-15','16:15:00',1.57),('8784','2013-05-15','16:20:00',1.7),('8784','2013-05-15','16:25:00',1.72),('8784','2013-05-15','16:30:00',1.53),('8784','2013-05-15','16:35:00',1.42),('8784','2013-05-15','16:40:00',1.34),('8784','2013-05-15','16:45:00',1.29),('8784','2013-05-15','16:50:00',1.32),('8784','2013-05-15','16:55:00',1.51),('8784','2013-05-15','17:00:00',1.81),('8784','2013-05-15','17:05:00',2.09),('8784','2013-05-15','17:10:00',2.57),('8784','2013-05-15','17:15:00',2.8),('8784','2013-05-15','17:20:00',1.93),('8784','2013-05-15','17:30:00',1.09),('8784','2013-05-14','07:20:00',1.08),('8784','2013-05-14','07:25:00',1.17),('8784','2013-05-14','07:30:00',1.25),('8784','2013-05-14','07:35:00',1.35),('8784','2013-05-14','07:40:00',1.43),('8784','2013-05-14','07:45:00',1.52),('8784','2013-05-14','07:50:00',1.62),('8784','2013-05-14','07:55:00',1.72),('8784','2013-05-14','08:00:00',1.78),('8784','2013-05-14','08:05:00',1.9),('8784','2013-05-14','08:10:00',1.99),('8784','2013-05-14','08:15:00',2.08),('8784','2013-05-14','08:20:00',2.17),('8784','2013-05-14','08:25:00',2.26),('8784','2013-05-14','08:30:00',2.32),('8784','2013-05-14','08:35:00',2.44),('8784','2013-05-14','08:40:00',2.52),('8784','2013-05-14','08:45:00',2.6),('8784','2013-05-14','08:50:00',2.68),('8784','2013-05-14','08:55:00',2.75),('8784','2013-05-14','09:00:00',2.83),('8784','2013-05-14','09:05:00',2.91),('8784','2013-05-14','09:10:00',2.98),('8784','2013-05-14','09:15:00',3.05),('8784','2013-05-14','09:20:00',3.13),('8784','2013-05-14','09:25:00',3.19),('8784','2013-05-14','09:30:00',3.25),('8784','2013-05-14','09:35:00',3.32),('8784','2013-05-14','09:40:00',3.38),('8784','2013-05-14','09:45:00',3.4),('8784','2013-05-14','09:50:00',3.49),('8784','2013-05-14','09:55:00',3.54),('8784','2013-05-14','10:00:00',3.62),('8784','2013-05-14','10:05:00',3.68),('8784','2013-05-14','10:10:00',3.76),('8784','2013-05-14','10:15:00',3.8),('8784','2013-05-14','10:20:00',3.86),('8784','2013-05-14','10:25:00',3.87),('8784','2013-05-14','10:30:00',3.9),('8784','2013-05-14','10:35:00',3.98),('8784','2013-05-14','10:40:00',4),('8784','2013-05-14','10:45:00',4.08),('8784','2013-05-14','10:50:00',4.1),('8784','2013-05-14','10:55:00',4.12),('8784','2013-05-14','11:00:00',4.14),('8784','2013-05-14','11:05:00',4.19),('8784','2013-05-14','11:10:00',4.22),('8784','2013-05-14','11:15:00',4.24),('8784','2013-05-14','11:20:00',4.27),('8784','2013-05-14','11:25:00',4.28),('8784','2013-05-14','11:30:00',4.26),('8784','2013-05-14','11:35:00',4.29),('8784','2013-05-14','11:40:00',4.32),('8784','2013-05-14','11:45:00',4.34),('8784','2013-05-14','11:50:00',4.36),('8784','2013-05-14','11:55:00',4.38),('8784','2013-05-14','12:00:00',4.4),('8784','2013-05-14','12:05:00',4.43),('8784','2013-05-14','12:10:00',4.47),('8784','2013-05-14','12:15:00',4.5),('8784','2013-05-14','12:20:00',4.55),('8784','2013-05-14','12:25:00',4.55),('8784','2013-05-14','12:30:00',4.55),('8784','2013-05-14','12:35:00',4.56),('8784','2013-05-14','12:40:00',4.56),('8784','2013-05-14','12:45:00',4.57),('8784','2013-05-14','12:50:00',4.53),('8784','2013-05-14','12:55:00',4.56),('8784','2013-05-14','13:00:00',4.58),('8784','2013-05-14','13:05:00',4.56),('8784','2013-05-14','13:10:00',4.55),('8784','2013-05-14','13:15:00',4.54),('8784','2013-05-14','13:20:00',4.5),('8784','2013-05-14','13:25:00',4.48),('8784','2013-05-14','13:30:00',4.47),('8784','2013-05-14','13:35:00',4.47),('8784','2013-05-14','13:40:00',4.51),('8784','2013-05-14','13:45:00',4.49),('8784','2013-05-14','13:50:00',4.45),('8784','2013-05-14','13:55:00',4.45),('8784','2013-05-14','14:00:00',4.39),('8784','2013-05-14','14:05:00',4.33),('8784','2013-05-14','14:10:00',4.3),('8784','2013-05-14','14:15:00',4.29),('8784','2013-05-14','14:20:00',4.25),('8784','2013-05-14','14:25:00',4.22),('8784','2013-05-14','14:30:00',4.2),('8784','2013-05-14','14:35:00',4.15),('8784','2013-05-14','14:40:00',4.2),('8784','2013-05-14','14:45:00',4.23),('8784','2013-05-14','14:50:00',4.24),('8784','2013-05-14','14:55:00',4.19),('8784','2013-05-14','15:00:00',4.18),('8784','2013-05-14','15:05:00',4.15),('8784','2013-05-14','15:10:00',4.11),('8784','2013-05-14','15:15:00',4.07),('8784','2013-05-14','15:20:00',4.02),('8784','2013-05-14','15:25:00',4.01),('8784','2013-05-14','15:30:00',3.96),('8784','2013-05-14','15:35:00',3.91),('8784','2013-05-14','15:40:00',3.85),('8784','2013-05-14','15:45:00',3.79),('8784','2013-05-14','15:50:00',3.71),('8784','2013-05-14','15:55:00',3.66),('8784','2013-05-14','16:00:00',3.6),('8784','2013-05-14','16:05:00',3.54),('8784','2013-05-14','16:10:00',3.48),('8784','2013-05-14','16:15:00',3.4),('8784','2013-05-14','16:20:00',3.33),('8784','2013-05-14','16:25:00',3.28),('8784','2013-05-14','16:30:00',3.21),('8784','2013-05-14','16:35:00',3.14),('8784','2013-05-14','16:40:00',3.06),('8784','2013-05-14','16:45:00',2.98),('8784','2013-05-14','16:50:00',2.91),('8784','2013-05-14','16:55:00',2.83),('8784','2013-05-14','17:00:00',2.75),('8784','2013-05-14','17:05:00',2.66),('8784','2013-05-14','17:10:00',2.58),('8784','2013-05-14','17:15:00',2.47),('8784','2013-05-14','17:20:00',2.41),('8784','2013-05-14','17:25:00',2.33),('8784','2013-05-14','17:30:00',2.25),('8784','2013-05-14','17:35:00',2.14),('8784','2013-05-14','17:40:00',2.07),('8784','2013-05-14','17:45:00',1.98),('8784','2013-05-14','17:50:00',1.88),('8784','2013-05-14','17:55:00',1.8),('8784','2013-05-14','18:00:00',1.7),('8784','2013-05-14','18:05:00',1.59),('8784','2013-05-14','18:10:00',1.52),('8784','2013-05-14','18:15:00',1.42),('8784','2013-05-14','18:20:00',1.34),('8784','2013-05-14','18:25:00',1.27),('8784','2013-05-14','18:30:00',1.17),('8784','2013-05-14','18:35:00',1.1),('8784','2013-05-14','18:40:00',1.01),('8784','2013-05-13','07:35:00',1.18),('8784','2013-05-13','07:40:00',1.27),('8784','2013-05-13','07:45:00',1.36),('8784','2013-05-13','07:50:00',1.43),('8784','2013-05-13','07:55:00',1.33),('8784','2013-05-13','08:00:00',1.54),('8784','2013-05-13','08:05:00',1.59),('8784','2013-05-13','08:10:00',1.8),('8784','2013-05-13','08:15:00',1.91),('8784','2013-05-13','08:20:00',2.01),('8784','2013-05-13','08:25:00',2.07),('8784','2013-05-13','08:30:00',2.14),('8784','2013-05-13','08:35:00',2.23),('8784','2013-05-13','08:40:00',2.31),('8784','2013-05-13','08:45:00',2.41),('8784','2013-05-13','08:50:00',2.48),('8784','2013-05-13','08:55:00',2.58),('8784','2013-05-13','09:00:00',2.66),('8784','2013-05-13','09:05:00',2.71),('8784','2013-05-13','09:10:00',2.78),('8784','2013-05-13','09:15:00',2.85),('8784','2013-05-13','09:20:00',2.94),('8784','2013-05-13','09:25:00',3.02),('8784','2013-05-13','09:30:00',3.09),('8784','2013-05-13','09:35:00',3.14),('8784','2013-05-13','09:40:00',3.22),('8784','2013-05-13','09:45:00',3.35),('8784','2013-05-13','09:50:00',3.07),('8784','2013-05-13','09:55:00',3.61),('8784','2013-05-13','10:00:00',3.45),('8784','2013-05-13','10:05:00',3.76),('8784','2013-05-13','10:10:00',3.68),('8784','2013-05-13','10:15:00',3.76),('8784','2013-05-13','10:20:00',3.6),('8784','2013-05-13','10:25:00',4.09),('8784','2013-05-13','10:30:00',4.08),('8784','2013-05-13','10:35:00',1.38),('8784','2013-05-13','10:40:00',1.23),('8784','2013-05-13','10:45:00',1.03),('8784','2013-05-13','10:50:00',3.83),('8784','2013-05-13','10:55:00',2.46),('8784','2013-05-13','11:00:00',3.87),('8784','2013-05-13','11:05:00',3.64),('8784','2013-05-13','11:10:00',3.31),('8784','2013-05-13','11:15:00',1.98),('8784','2013-05-13','11:20:00',1.67),('8784','2013-05-13','11:25:00',1.76),('8784','2013-05-13','11:30:00',1.82),('8784','2013-05-13','11:35:00',2.72),('8784','2013-05-13','11:40:00',3.92),('8784','2013-05-13','11:45:00',2.63),('8784','2013-05-13','11:50:00',3.06),('8784','2013-05-13','11:55:00',1.93),('8784','2013-05-13','12:00:00',2),('8784','2013-05-13','12:05:00',1.97),('8784','2013-05-13','12:10:00',3.97),('8784','2013-05-13','12:15:00',2.4),('8784','2013-05-13','12:20:00',1.32),('8784','2013-05-13','12:25:00',1.21),('8784','2013-05-13','12:30:00',1.42),('8784','2013-05-13','12:35:00',5.44),('8784','2013-05-13','12:40:00',5.07),('8784','2013-05-13','12:45:00',4.18),('8784','2013-05-13','12:50:00',4.3),('8784','2013-05-13','12:55:00',3.42),('8784','2013-05-13','13:00:00',3.72),('8784','2013-05-13','13:05:00',5.17),('8784','2013-05-13','13:10:00',4.06),('8784','2013-05-13','13:15:00',2.83),('8784','2013-05-13','13:20:00',5.13),('8784','2013-05-13','13:25:00',4.99),('8784','2013-05-13','13:30:00',4.75),('8784','2013-05-13','13:35:00',4.8),('8784','2013-05-13','13:40:00',4.75),('8784','2013-05-13','13:45:00',4.59),('8784','2013-05-13','13:50:00',1.9),('8784','2013-05-13','13:55:00',3.02),('8784','2013-05-13','14:00:00',3.24),('8784','2013-05-13','14:05:00',4.15),('8784','2013-05-13','14:10:00',4.99),('8784','2013-05-13','14:15:00',4.85),('8784','2013-05-13','14:20:00',4.66),('8784','2013-05-13','14:25:00',4.62),('8784','2013-05-13','14:30:00',4.2),('8784','2013-05-13','14:35:00',2.37),('8784','2013-05-13','14:40:00',2.53),('8784','2013-05-13','14:45:00',2.59),('8784','2013-05-13','14:50:00',4.68),('8784','2013-05-13','14:55:00',4.75),('8784','2013-05-13','15:00:00',4.28),('8784','2013-05-13','15:05:00',1.73),('8784','2013-05-13','15:10:00',1.28),('8784','2013-05-13','15:15:00',1.07),('8784','2013-05-13','15:20:00',1.26),('8784','2013-05-13','15:40:00',1.18),('8784','2013-05-13','16:00:00',1.68),('8784','2013-05-13','16:05:00',2.11),('8784','2013-05-13','16:10:00',2.16),('8784','2013-05-13','16:15:00',1.45),('8784','2013-05-13','16:20:00',1.44),('8784','2013-05-13','16:25:00',1.47),('8784','2013-05-13','16:30:00',2),('8784','2013-05-13','16:35:00',1.31),('8784','2013-05-13','16:40:00',1.69),('8784','2013-05-13','16:45:00',2.47),('8784','2013-05-13','16:50:00',3.33),('8784','2013-05-13','16:55:00',3.18),('8784','2013-05-13','17:00:00',2.99),('8784','2013-05-13','17:05:00',3.07),('8784','2013-05-13','17:10:00',1.29),('8784','2013-05-13','17:15:00',2.84),('8784','2013-05-13','17:20:00',3.36),('8784','2013-05-13','17:25:00',3.19),('8784','2013-05-13','17:30:00',3.01),('8784','2013-05-13','17:35:00',2.83),('8784','2013-05-13','17:40:00',2.64),('8784','2013-05-13','17:45:00',2.51),('8784','2013-05-13','17:50:00',2.15),('8784','2013-05-13','17:55:00',1.28),('8784','2013-05-13','18:00:00',1.97),('8784','2013-05-13','18:05:00',1.5),('8784','2013-05-13','18:10:00',1.34),('8784','2013-05-13','18:15:00',1.53),('8784','2013-05-13','18:20:00',1.06),('8784','2013-05-12','08:05:00',1.19),('8784','2013-05-12','08:10:00',2.08),('8784','2013-05-12','08:15:00',1.77),('8784','2013-05-12','08:20:00',1.46),('8784','2013-05-12','08:25:00',1.96),('8784','2013-05-12','08:30:00',1.16),('8784','2013-05-12','08:40:00',1.03),('8784','2013-05-12','08:45:00',2.36),('8784','2013-05-12','08:50:00',1.43),('8784','2013-05-12','08:55:00',1.18),('8784','2013-05-12','09:00:00',1.8),('8784','2013-05-12','09:05:00',2.5),('8784','2013-05-12','09:10:00',1.74),('8784','2013-05-12','09:15:00',2.13),('8784','2013-05-12','09:20:00',3.19),('8784','2013-05-12','09:25:00',1.86),('8784','2013-05-12','09:30:00',1.29),('8784','2013-05-12','09:35:00',1.25),('8784','2013-05-12','09:40:00',1.25),('8784','2013-05-12','09:45:00',2.49),('8784','2013-05-12','09:50:00',3.99),('8784','2013-05-12','09:55:00',4.02),('8784','2013-05-12','10:00:00',3.9),('8784','2013-05-12','10:05:00',2.58),('8784','2013-05-12','10:10:00',3.79),('8784','2013-05-12','10:15:00',1.81),('8784','2013-05-12','10:20:00',1.3),('8784','2013-05-12','10:25:00',4.18),('8784','2013-05-12','10:30:00',1.76),('8784','2013-05-12','10:35:00',1.29),('8784','2013-05-12','10:40:00',1.09),('8784','2013-05-12','10:45:00',1.19),('8784','2013-05-12','10:50:00',2.31),('8784','2013-05-12','10:55:00',4.23),('8784','2013-05-12','11:00:00',2.48),('8784','2013-05-12','11:05:00',3.68),('8784','2013-05-12','11:10:00',4.67),('8784','2013-05-12','11:15:00',4.61),('8784','2013-05-12','11:20:00',4.33),('8784','2013-05-12','11:25:00',3.72),('8784','2013-05-12','11:30:00',3.31),('8784','2013-05-12','11:35:00',4.69),('8784','2013-05-12','11:40:00',3.73),('8784','2013-05-12','11:45:00',3.36),('8784','2013-05-12','11:50:00',2.01),('8784','2013-05-12','11:55:00',1.56),('8784','2013-05-12','12:00:00',3.17),('8784','2013-05-12','12:05:00',3.16),('8784','2013-05-12','12:10:00',1.76),('8784','2013-05-12','12:15:00',1.34),('8784','2013-05-12','12:20:00',1.22),('8784','2013-05-12','12:25:00',1.24),('8784','2013-05-12','12:30:00',1.88),('8784','2013-05-12','12:35:00',2.12),('8784','2013-05-12','12:40:00',2.62),('8784','2013-05-12','12:45:00',4.58),('8784','2013-05-12','12:50:00',3.45),('8784','2013-05-12','12:55:00',3.4),('8784','2013-05-12','13:00:00',1.78),('8784','2013-05-12','13:05:00',2.54),('8784','2013-05-12','13:10:00',4.5),('8784','2013-05-12','13:15:00',1.76),('8784','2013-05-12','13:20:00',3.51),('8784','2013-05-12','13:25:00',3.22),('8784','2013-05-12','13:30:00',5.11),('8784','2013-05-12','13:35:00',4.59),('8784','2013-05-12','13:40:00',3.94),('8784','2013-05-12','13:45:00',3.9),('8784','2013-05-12','13:50:00',4.86),('8784','2013-05-12','13:55:00',2.08),('8784','2013-05-12','14:00:00',4.09),('8784','2013-05-12','14:05:00',4.76),('8784','2013-05-12','14:10:00',5.01),('8784','2013-05-12','14:15:00',4.2),('8784','2013-05-12','14:20:00',4.83),('8784','2013-05-12','14:25:00',4.59),('8784','2013-05-12','14:30:00',4.68),('8784','2013-05-12','14:35:00',4.56),('8784','2013-05-12','14:40:00',4.5),('8784','2013-05-12','14:45:00',4.47),('8784','2013-05-12','14:50:00',4.53),('8784','2013-05-12','14:55:00',3.91),('8784','2013-05-12','15:00:00',4.49),('8784','2013-05-12','15:05:00',4.4),('8784','2013-05-12','15:10:00',3.77),('8784','2013-05-12','15:15:00',4.09),('8784','2013-05-12','15:20:00',2.21),('8784','2013-05-12','15:25:00',4.18),('8784','2013-05-12','15:30:00',3.82),('8784','2013-05-12','15:35:00',3.91),('8784','2013-05-12','15:40:00',3.87),('8784','2013-05-12','15:45:00',3.78),('8784','2013-05-12','15:50:00',3.7),('8784','2013-05-12','15:55:00',3.61),('8784','2013-05-12','16:00:00',3.43),('8784','2013-05-12','16:05:00',3.47),('8784','2013-05-12','16:10:00',3.44),('8784','2013-05-12','16:15:00',3.37),('8784','2013-05-12','16:20:00',3.32),('8784','2013-05-12','16:25:00',3.21),('8784','2013-05-12','16:30:00',3.14),('8784','2013-05-12','16:35:00',3.12),('8784','2013-05-12','16:40:00',3.12),('8784','2013-05-12','16:45:00',3.08),('8784','2013-05-12','16:50:00',2.85),('8784','2013-05-12','16:55:00',3.68),('8784','2013-05-12','17:00:00',3.59),('8784','2013-05-12','17:05:00',3.06),('8784','2013-05-12','17:10:00',3.41),('8784','2013-05-12','17:15:00',3.24),('8784','2013-05-12','17:20:00',2.99),('8784','2013-05-12','17:25:00',2.37),('8784','2013-05-12','17:30:00',2.01),('8784','2013-05-12','17:35:00',2.62),('8784','2013-05-12','17:40:00',1.85),('8784','2013-05-12','17:45:00',1.67),('8784','2013-05-12','17:50:00',1.47),('8784','2013-05-12','17:55:00',1.01),('8784','2013-05-12','18:00:00',1.88),('8784','2013-05-12','18:05:00',1.99),('8784','2013-05-12','18:10:00',1.91),('8784','2013-05-12','18:15:00',1.72),('8784','2013-05-12','18:20:00',1.19),('8784','2013-05-12','18:25:00',1.43),('8784','2013-05-12','18:30:00',1.24),('8784','2013-05-12','18:35:00',1.34),('8784','2013-05-12','18:40:00',1.08),('8784','2014-03-31','08:15:00',1.03),('8784','2014-03-31','08:20:00',1.12),('8784','2014-03-31','08:25:00',1.21),('8784','2014-03-31','08:30:00',1.29),('8784','2014-03-31','08:35:00',1.38),('8784','2014-03-31','08:40:00',1.47),('8784','2014-03-31','08:45:00',1.51),('8784','2014-03-31','08:50:00',1.61),('8784','2014-03-31','08:55:00',1.72),('8784','2014-03-31','09:00:00',1.81),('8784','2014-03-31','09:05:00',1.91),('8784','2014-03-31','09:10:00',1.99),('8784','2014-03-31','09:15:00',2.1),('8784','2014-03-31','09:20:00',2.13),('8784','2014-03-31','09:25:00',2.27),('8784','2014-03-31','09:30:00',2.35),('8784','2014-03-31','09:35:00',2.44),('8784','2014-03-31','09:40:00',2.51),('8784','2014-03-31','09:45:00',2.58),('8784','2014-03-31','09:50:00',2.65),('8784','2014-03-31','09:55:00',2.7),('8784','2014-03-31','10:00:00',2.77),('8784','2014-03-31','10:05:00',2.83),('8784','2014-03-31','10:10:00',2.89),('8784','2014-03-31','10:15:00',2.94),('8784','2014-03-31','10:20:00',3.02),('8784','2014-03-31','10:25:00',3.12),('8784','2014-03-31','10:30:00',3.16),('8784','2014-03-31','10:35:00',3.18),('8784','2014-03-31','10:40:00',3.25),('8784','2014-03-31','10:45:00',3.32),('8784','2014-03-31','10:50:00',3.37),('8784','2014-03-31','10:55:00',3.42),('8784','2014-03-31','11:00:00',3.45),('8784','2014-03-31','11:05:00',3.5),('8784','2014-03-31','11:10:00',3.54),('8784','2014-03-31','11:15:00',3.57),('8784','2014-03-31','11:20:00',3.63),('8784','2014-03-31','11:25:00',3.66),('8784','2014-03-31','11:30:00',3.7),('8784','2014-03-31','11:35:00',3.72),('8784','2014-03-31','11:40:00',3.74),('8784','2014-03-31','11:45:00',3.8),('8784','2014-03-31','11:50:00',3.85),('8784','2014-03-31','11:55:00',3.89),('8784','2014-03-31','12:00:00',3.87),('8784','2014-03-31','12:05:00',3.87),('8784','2014-03-31','12:10:00',3.92),('8784','2014-03-31','12:15:00',3.97),('8784','2014-03-31','12:20:00',3.92),('8784','2014-03-31','12:25:00',3.98),('8784','2014-03-31','12:30:00',4),('8784','2014-03-31','12:35:00',4.02),('8784','2014-03-31','12:40:00',4.03),('8784','2014-03-31','12:45:00',4),('8784','2014-03-31','12:50:00',3.99),('8784','2014-03-31','12:55:00',3.99),('8784','2014-03-31','13:00:00',4.02),('8784','2014-03-31','13:05:00',4.07),('8784','2014-03-31','13:10:00',4.06),('8784','2014-03-31','13:15:00',4.06),('8784','2014-03-31','13:20:00',4.07),('8784','2014-03-31','13:25:00',4.05),('8784','2014-03-31','13:30:00',4.07),('8784','2014-03-31','13:35:00',4.04),('8784','2014-03-31','13:40:00',4.08),('8784','2014-03-31','13:45:00',4.07),('8784','2014-03-31','13:50:00',4.04),('8784','2014-03-31','13:55:00',4.02),('8784','2014-03-31','14:00:00',4.01),('8784','2014-03-31','14:05:00',3.99),('8784','2014-03-31','14:10:00',3.97),('8784','2014-03-31','14:15:00',3.95),('8784','2014-03-31','14:20:00',3.94),('8784','2014-03-31','14:25:00',3.9),('8784','2014-03-31','14:30:00',3.88),('8784','2014-03-31','14:35:00',3.86),('8784','2014-03-31','14:40:00',3.83),('8784','2014-03-31','14:45:00',3.79),('8784','2014-03-31','14:50:00',3.75),('8784','2014-03-31','14:55:00',3.7),('8784','2014-03-31','15:00:00',3.69),('8784','2014-03-31','15:05:00',3.63),('8784','2014-03-31','15:10:00',3.59),('8784','2014-03-31','15:15:00',3.55),('8784','2014-03-31','15:20:00',3.48),('8784','2014-03-31','15:25:00',3.45),('8784','2014-03-31','15:30:00',3.38),('8784','2014-03-31','15:35:00',3.32),('8784','2014-03-31','15:40:00',3.26),('8784','2014-03-31','15:45:00',3.21),('8784','2014-03-31','15:50:00',3.12),('8784','2014-03-31','15:55:00',3.04),('8784','2014-03-31','16:00:00',2.98),('8784','2014-03-31','16:05:00',2.89),('8784','2014-03-31','16:10:00',2.83),('8784','2014-03-31','16:15:00',2.74),('8784','2014-03-31','16:20:00',2.68),('8784','2014-03-31','16:25:00',2.59),('8784','2014-03-31','16:30:00',2.53),('8784','2014-03-31','16:35:00',2.42),('8784','2014-03-31','16:40:00',2.37),('8784','2014-03-31','16:45:00',2.3),('8784','2014-03-31','16:50:00',2.21),('8784','2014-03-31','16:55:00',2.13),('8784','2014-03-31','17:00:00',2.04),('8784','2014-03-31','17:05:00',1.93),('8784','2014-03-31','17:10:00',1.88),('8784','2014-03-31','17:15:00',1.77),('8784','2014-03-31','17:20:00',1.67),('8784','2014-03-31','17:25:00',1.6),('8784','2014-03-31','17:30:00',1.52),('8784','2014-03-31','17:35:00',1.41),('8784','2014-03-31','17:40:00',1.35),('8784','2014-03-31','17:45:00',1.26),('8784','2014-03-31','17:50:00',1.18),('8784','2014-03-31','17:55:00',1.09),('8784','2014-03-31','18:00:00',1.01),('8784','2013-05-11','07:30:00',1.05),('8784','2013-05-11','07:40:00',1.1),('8784','2013-05-11','07:45:00',1.37),('8784','2013-05-11','07:50:00',1.53),('8784','2013-05-11','07:55:00',1.71),('8784','2013-05-11','08:00:00',1.51),('8784','2013-05-11','08:05:00',1.35),('8784','2013-05-11','08:10:00',1.01),('8784','2013-05-11','08:15:00',1.65),('8784','2013-05-11','08:20:00',1.74),('8784','2013-05-11','08:35:00',1.04),('8784','2013-05-11','09:05:00',1.43),('8784','2013-05-11','09:10:00',1.4),('8784','2013-05-11','09:15:00',1.53),('8784','2013-05-11','09:20:00',1.94),('8784','2013-05-11','09:25:00',2.19),('8784','2013-05-11','09:30:00',2.78),('8784','2013-05-11','09:35:00',2.24),('8784','2013-05-11','09:40:00',1.42),('8784','2013-05-11','09:45:00',1.54),('8784','2013-05-11','09:50:00',1.58),('8784','2013-05-11','09:55:00',2.07),('8784','2013-05-11','10:00:00',3.04),('8784','2013-05-11','10:05:00',1.36),('8784','2013-05-11','10:20:00',1.22),('8784','2013-05-11','10:25:00',1.08),('8784','2013-05-11','10:30:00',1.48),('8784','2013-05-11','10:35:00',1.3),('8784','2013-05-11','10:40:00',1.01),('8784','2013-05-11','10:45:00',1.05),('8784','2013-05-11','10:50:00',1.5),('8784','2013-05-11','10:55:00',4.29),('8784','2013-05-11','11:00:00',4.78),('8784','2013-05-11','11:05:00',1.99),('8784','2013-05-11','11:10:00',1.31),('8784','2013-05-11','11:15:00',1.02),('8784','2013-05-11','11:25:00',1.17),('8784','2013-05-11','11:30:00',2.89),('8784','2013-05-11','11:35:00',2.69),('8784','2013-05-11','11:40:00',2.89),('8784','2013-05-11','11:45:00',4.98),('8784','2013-05-11','11:50:00',1.74),('8784','2013-05-11','11:55:00',1.15),('8784','2013-05-11','12:00:00',1.79),('8784','2013-05-11','12:05:00',2.31),('8784','2013-05-11','12:10:00',1.55),('8784','2013-05-11','12:15:00',1.49),('8784','2013-05-11','12:20:00',3.04),('8784','2013-05-11','12:25:00',5.08),('8784','2013-05-11','12:30:00',2.57),('8784','2013-05-11','12:35:00',2.02),('8784','2013-05-11','12:40:00',1.98),('8784','2013-05-11','12:45:00',2.06),('8784','2013-05-11','12:50:00',1.77),('8784','2013-05-11','12:55:00',1.7),('8784','2013-05-11','13:00:00',1.84),('8784','2013-05-11','13:05:00',1.6),('8784','2013-05-11','13:10:00',1.12),('8784','2013-05-11','13:25:00',1.07),('8784','2013-05-11','13:30:00',1.19),('8784','2013-05-11','13:35:00',1.24),('8784','2013-05-11','13:50:00',1.04),('8784','2013-05-11','13:55:00',1.16),('8784','2013-05-11','14:00:00',2.06),('8784','2013-05-11','14:05:00',4.1),('8784','2013-05-11','14:10:00',2.66),('8784','2013-05-11','14:15:00',3.3),('8784','2013-05-11','14:20:00',3.09),('8784','2013-05-11','14:25:00',3.82),('8784','2013-05-11','14:30:00',2.04),('8784','2013-05-11','14:35:00',3.4),('8784','2013-05-11','14:40:00',3.42),('8784','2013-05-11','14:45:00',4.29),('8784','2013-05-11','14:50:00',4.75),('8784','2013-05-11','14:55:00',4.4),('8784','2013-05-11','15:00:00',4.28),('8784','2013-05-11','15:05:00',4.29),('8784','2013-05-11','15:10:00',4.36),('8784','2013-05-11','15:15:00',4.19),('8784','2013-05-11','15:20:00',4.01),('8784','2013-05-11','15:25:00',4.11),('8784','2013-05-11','15:30:00',4.04),('8784','2013-05-11','15:35:00',3.43),('8784','2013-05-11','15:40:00',4.06),('8784','2013-05-11','15:45:00',3.48),('8784','2013-05-11','15:50:00',3.31),('8784','2013-05-11','15:55:00',3.53),('8784','2013-05-11','16:00:00',2.97),('8784','2013-05-11','16:05:00',3.75),('8784','2013-05-11','16:10:00',2.97),('8784','2013-05-11','16:15:00',3.56),('8784','2013-05-11','16:20:00',3.58),('8784','2013-05-11','16:25:00',3.37),('8784','2013-05-11','16:30:00',3.11),('8784','2013-05-11','16:35:00',2.24),('8784','2013-05-11','16:40:00',2.9),('8784','2013-05-11','16:45:00',3.05),('8784','2013-05-11','16:50:00',2.99),('8784','2013-05-11','16:55:00',2.97),('8784','2013-05-11','17:00:00',2.87),('8784','2013-05-11','17:05:00',1.86),('8784','2013-05-11','17:10:00',2.56),('8784','2013-05-11','17:15:00',1.62),('8784','2013-05-11','17:20:00',2.03),('8784','2013-05-11','17:25:00',1.63),('8784','2013-05-11','17:30:00',2.28),('8784','2013-05-11','17:35:00',1.81),('8784','2013-05-11','17:40:00',2.22),('8784','2013-05-11','17:45:00',1.87),('8784','2013-05-11','17:50:00',1.01),('8784','2013-05-11','17:55:00',1.42),('8784','2013-05-11','18:00:00',1.01),('8784','2013-05-11','18:05:00',1.71),('8784','2013-05-11','18:10:00',1.99),('8784','2013-05-11','18:15:00',1.19),('8784','2013-05-11','18:20:00',1.16),('8784','2013-05-11','18:25:00',1.24),('8784','2013-05-11','18:30:00',1.31),('8784','2013-05-11','18:40:00',1.1),('8784','2013-05-10','07:30:00',1.05),('8784','2013-05-10','07:40:00',1.29),('8784','2013-05-10','07:45:00',1.1),('8784','2013-05-10','07:55:00',1.42),('8784','2013-05-10','08:00:00',1.72),('8784','2013-05-10','08:05:00',2.23),('8784','2013-05-10','08:10:00',2.26),('8784','2013-05-10','08:15:00',2.4),('8784','2013-05-10','08:20:00',2.18),('8784','2013-05-10','08:25:00',2.14),('8784','2013-05-10','08:30:00',2.14),('8784','2013-05-10','08:35:00',2.16),('8784','2013-05-10','09:00:00',1.68),('8784','2013-05-10','09:05:00',2.52),('8784','2013-05-10','09:10:00',2.84),('8784','2013-05-10','09:15:00',2.95),('8784','2013-05-10','09:20:00',2.81),('8784','2013-05-10','09:25:00',2.68),('8784','2013-05-10','09:30:00',2.68),('8784','2013-05-10','09:35:00',3.25),('8784','2013-05-10','09:40:00',3.01),('8784','2013-05-10','09:45:00',2.97),('8784','2013-05-10','09:50:00',3.37),('8784','2013-05-10','09:55:00',1.5),('8784','2013-05-10','10:00:00',1.6),('8784','2013-05-10','10:05:00',1.54),('8784','2013-05-10','10:10:00',1.65),('8784','2013-05-10','10:15:00',1.42),('8784','2013-05-10','10:20:00',2.78),('8784','2013-05-10','10:25:00',1.56),('8784','2013-05-10','10:30:00',1.77),('8784','2013-05-10','10:35:00',3.88),('8784','2013-05-10','10:40:00',4.2),('8784','2013-05-10','10:45:00',4.36),('8784','2013-05-10','10:50:00',3.42),('8784','2013-05-10','10:55:00',4.25),('8784','2013-05-10','11:00:00',4.2),('8784','2013-05-10','11:05:00',4.19),('8784','2013-05-10','11:10:00',4.1),('8784','2013-05-10','11:15:00',4.26),('8784','2013-05-10','11:20:00',4.63),('8784','2013-05-10','11:25:00',3.52),('8784','2013-05-10','11:30:00',3.93),('8784','2013-05-10','11:35:00',2.87),('8784','2013-05-10','11:40:00',4.11),('8784','2013-05-10','11:45:00',3.14),('8784','2013-05-10','11:50:00',3.78),('8784','2013-05-10','11:55:00',4.59),('8784','2013-05-10','12:00:00',2.91),('8784','2013-05-10','12:05:00',2.29),('8784','2013-05-10','12:10:00',2.38),('8784','2013-05-10','12:15:00',2.89),('8784','2013-05-10','12:20:00',3.39),('8784','2013-05-10','12:25:00',2.43),('8784','2013-05-10','12:30:00',2.47),('8784','2013-05-10','12:35:00',2.1),('8784','2013-05-10','12:40:00',3.43),('8784','2013-05-10','12:45:00',4.64),('8784','2013-05-10','12:50:00',3.43),('8784','2013-05-10','12:55:00',3.02),('8784','2013-05-10','13:00:00',4.09),('8784','2013-05-10','13:05:00',4.43),('8784','2013-05-10','13:10:00',5.41),('8784','2013-05-10','13:15:00',4.61),('8784','2013-05-10','13:20:00',3.43),('8784','2013-05-10','13:25:00',2.98),('8784','2013-05-10','13:30:00',3.71),('8784','2013-05-10','13:35:00',4.1),('8784','2013-05-10','13:40:00',4.07),('8784','2013-05-10','13:45:00',4.11),('8784','2013-05-10','13:50:00',2.44),('8784','2013-05-10','13:55:00',2.32),('8784','2013-05-10','14:00:00',2.13),('8784','2013-05-10','14:05:00',2.28),('8784','2013-05-10','14:10:00',2.7),('8784','2013-05-10','14:15:00',2.96),('8784','2013-05-10','14:20:00',2.77),('8784','2013-05-10','14:25:00',2.88),('8784','2013-05-10','14:30:00',2.81),('8784','2013-05-10','14:35:00',3.26),('8784','2013-05-10','14:40:00',2.92),('8784','2013-05-10','14:45:00',2.09),('8784','2013-05-10','14:50:00',1.61),('8784','2013-05-10','14:55:00',1.41),('8784','2013-05-10','15:00:00',1.35),('8784','2013-05-10','15:05:00',1.53),('8784','2013-05-10','15:10:00',2.14),('8784','2013-05-10','15:15:00',3.59),('8784','2013-05-10','15:20:00',2.64),('8784','2013-05-10','15:25:00',2.16),('8784','2013-05-10','15:30:00',2.1),('8784','2013-05-10','15:35:00',2.15),('8784','2013-05-10','15:40:00',2.24),('8784','2013-05-10','15:45:00',2.12),('8784','2013-05-10','15:50:00',1.93),('8784','2013-05-10','15:55:00',1.83),('8784','2013-05-10','16:00:00',1.8),('8784','2013-05-10','16:05:00',1.76),('8784','2013-05-10','16:10:00',1.7),('8784','2013-05-10','16:15:00',1.56),('8784','2013-05-10','16:20:00',1.43),('8784','2013-05-10','16:25:00',1.45),('8784','2013-05-10','16:30:00',1.6),('8784','2013-05-10','16:35:00',1.65),('8784','2013-05-10','16:40:00',1.55),('8784','2013-05-10','16:45:00',1.58),('8784','2013-05-10','16:50:00',1.48),('8784','2013-05-10','16:55:00',1.21),('8784','2013-05-10','17:00:00',1.01),('8784','2013-05-10','17:05:00',1.07),('8784','2013-05-10','17:10:00',1.43),('8784','2013-05-10','17:15:00',1.66),('8784','2013-05-10','17:20:00',2.61),('8784','2013-05-10','17:25:00',2.3),('8784','2013-05-10','17:30:00',2.16),('8784','2013-05-10','17:35:00',2.31),('8784','2013-05-10','17:40:00',1.5),('8784','2013-05-10','17:45:00',1.56),('8784','2013-05-10','17:50:00',1.2),('8784','2013-05-10','17:55:00',1.06),('8784','2013-05-10','18:00:00',1.01),('8784','2013-05-09','07:25:00',1.04),('8784','2013-05-09','07:30:00',1.11),('8784','2013-05-09','07:35:00',1.2),('8784','2013-05-09','07:40:00',1.28),('8784','2013-05-09','07:45:00',1.37),('8784','2013-05-09','07:50:00',1.46),('8784','2013-05-09','07:55:00',1.54),('8784','2013-05-09','08:00:00',1.63),('8784','2013-05-09','08:05:00',1.73),('8784','2013-05-09','08:10:00',1.78),('8784','2013-05-09','08:15:00',1.91),('8784','2013-05-09','08:20:00',1.99),('8784','2013-05-09','08:25:00',2.07),('8784','2013-05-09','08:30:00',2.16),('8784','2013-05-09','08:35:00',2.24),('8784','2013-05-09','08:40:00',2.34),('8784','2013-05-09','08:45:00',2.4),('8784','2013-05-09','08:50:00',2.49),('8784','2013-05-09','08:55:00',2.56),('8784','2013-05-09','09:00:00',2.65),('8784','2013-05-09','09:05:00',2.71),('8784','2013-05-09','09:10:00',2.8),('8784','2013-05-09','09:15:00',2.89),('8784','2013-05-09','09:20:00',2.96),('8784','2013-05-09','09:25:00',3.01),('8784','2013-05-09','09:30:00',3.12),('8784','2013-05-09','09:35:00',3.2),('8784','2013-05-09','09:40:00',3.26),('8784','2013-05-09','09:45:00',3.33),('8784','2013-05-09','09:50:00',3.39),('8784','2013-05-09','09:55:00',3.43),('8784','2013-05-09','10:00:00',3.52),('8784','2013-05-09','10:05:00',3.57),('8784','2013-05-09','10:10:00',3.61),('8784','2013-05-09','10:15:00',3.68),('8784','2013-05-09','10:20:00',3.72),('8784','2013-05-09','10:25:00',3.75),('8784','2013-05-09','10:30:00',3.8),('8784','2013-05-09','10:35:00',3.84),('8784','2013-05-09','10:40:00',3.9),('8784','2013-05-09','10:45:00',3.9),('8784','2013-05-09','10:50:00',3.94),('8784','2013-05-09','10:55:00',4.01),('8784','2013-05-09','11:00:00',4.03),('8784','2013-05-09','11:05:00',4.06),('8784','2013-05-09','11:10:00',4.07),('8784','2013-05-09','11:15:00',4.17),('8784','2013-05-09','11:20:00',4.18),('8784','2013-05-09','11:25:00',4.21),('8784','2013-05-09','11:30:00',4.24),('8784','2013-05-09','11:35:00',4.22),('8784','2013-05-09','11:40:00',4.24),('8784','2013-05-09','11:45:00',4.3),('8784','2013-05-09','11:50:00',4.31),('8784','2013-05-09','11:55:00',4.31),('8784','2013-05-09','12:00:00',4.34),('8784','2013-05-09','12:05:00',4.35),('8784','2013-05-09','12:10:00',4.41),('8784','2013-05-09','12:15:00',4.44),('8784','2013-05-09','12:20:00',4.47),('8784','2013-05-09','12:25:00',4.48),('8784','2013-05-09','12:30:00',4.46),('8784','2013-05-09','12:35:00',4.48),('8784','2013-05-09','12:40:00',4.49),('8784','2013-05-09','12:45:00',4.51),('8784','2013-05-09','12:50:00',4.48),('8784','2013-05-09','12:55:00',4.49),('8784','2013-05-09','13:00:00',4.46),('8784','2013-05-09','13:05:00',4.44),('8784','2013-05-09','13:10:00',4.43),('8784','2013-05-09','13:15:00',4.48),('8784','2013-05-09','13:20:00',4.48),('8784','2013-05-09','13:25:00',4.42),('8784','2013-05-09','13:30:00',4.46),('8784','2013-05-09','13:35:00',4.49),('8784','2013-05-09','13:40:00',4.53),('8784','2013-05-09','13:45:00',4.58),('8784','2013-05-09','13:50:00',4.54),('8784','2013-05-09','13:55:00',4.59),('8784','2013-05-09','14:00:00',3.94),('8784','2013-05-09','14:05:00',3.13),('8784','2013-05-09','14:10:00',4.34),('8784','2013-05-09','14:15:00',4.53),('8784','2013-05-09','14:20:00',3.94),('8784','2013-05-09','14:25:00',3.67),('8784','2013-05-09','14:30:00',4.31),('8784','2013-05-09','14:35:00',4.22),('8784','2013-05-09','14:40:00',4.18),('8784','2013-05-09','14:45:00',4.18),('8784','2013-05-09','14:50:00',4.11),('8784','2013-05-09','14:55:00',4.16),('8784','2013-05-09','15:00:00',4.09),('8784','2013-05-09','15:05:00',4.05),('8784','2013-05-09','15:10:00',4),('8784','2013-05-09','15:15:00',3.97),('8784','2013-05-09','15:20:00',3.91),('8784','2013-05-09','15:25:00',3.88),('8784','2013-05-09','15:30:00',3.8),('8784','2013-05-09','15:35:00',3.77),('8784','2013-05-09','15:40:00',3.71),('8784','2013-05-09','15:45:00',3.67),('8784','2013-05-09','15:50:00',3.62),('8784','2013-05-09','15:55:00',3.51),('8784','2013-05-09','16:00:00',3.46),('8784','2013-05-09','16:05:00',3.43),('8784','2013-05-09','16:10:00',3.38),('8784','2013-05-09','16:15:00',3.28),('8784','2013-05-09','16:20:00',3.23),('8784','2013-05-09','16:25:00',3.15),('8784','2013-05-09','16:30:00',3.09),('8784','2013-05-09','16:35:00',3.03),('8784','2013-05-09','16:40:00',2.92),('8784','2013-05-09','16:45:00',2.84),('8784','2013-05-09','16:50:00',2.77),('8784','2013-05-09','16:55:00',2.69),('8784','2013-05-09','17:00:00',2.61),('8784','2013-05-09','17:05:00',2.53),('8784','2013-05-09','17:10:00',2.44),('8784','2013-05-09','17:15:00',2.36),('8784','2013-05-09','17:20:00',2.29),('8784','2013-05-09','17:25:00',2.21),('8784','2013-05-09','17:30:00',2.12),('8784','2013-05-09','17:35:00',2.02),('8784','2013-05-09','17:40:00',1.95),('8784','2013-05-09','17:45:00',1.85),('8784','2013-05-09','17:50:00',1.77),('8784','2013-05-09','17:55:00',1.69),('8784','2013-05-09','18:00:00',1.59),('8784','2013-05-09','18:05:00',1.5),('8784','2013-05-09','18:10:00',1.41),('8784','2013-05-09','18:15:00',1.34),('8784','2013-05-09','18:20:00',1.25),('8784','2013-05-09','18:25:00',1.16),('8784','2013-05-09','18:30:00',1.07),('8784','2013-05-08','08:05:00',1.85),('8784','2013-05-08','08:10:00',1.85),('8784','2013-05-08','08:15:00',1.93),('8784','2013-05-08','08:20:00',2),('8784','2013-05-08','08:25:00',2.03),('8784','2013-05-08','08:30:00',2.09),('8784','2013-05-08','08:35:00',2.18),('8784','2013-05-08','08:40:00',2.29),('8784','2013-05-08','08:45:00',1.83),('8784','2013-05-08','08:50:00',1.06),('8784','2013-05-08','08:55:00',1.21),('8784','2013-05-08','09:00:00',1.04),('8784','2013-05-08','09:05:00',1.52),('8784','2013-05-08','09:35:00',2.75),('8784','2013-05-08','09:40:00',3.91),('8784','2013-05-08','09:45:00',2.28),('8784','2013-05-08','09:50:00',3.36),('8784','2013-05-08','09:55:00',1.67),('8784','2013-05-08','10:00:00',1.5),('8784','2013-05-08','10:05:00',3.82),('8784','2013-05-08','10:10:00',2.2),('8784','2013-05-08','10:15:00',1.1),('8784','2013-05-08','10:20:00',1.15),('8784','2013-05-08','10:25:00',1.04),('8784','2013-05-08','10:30:00',1.07),('8784','2013-05-08','10:35:00',1.04),('8784','2013-05-08','10:55:00',1.62),('8784','2013-05-08','11:00:00',2.5),('8784','2013-05-08','11:05:00',4.63),('8784','2013-05-08','11:10:00',4.34),('8784','2013-05-08','11:15:00',3.84),('8784','2013-05-08','11:20:00',3.67),('8784','2013-05-08','11:25:00',4.56),('8784','2013-05-08','11:30:00',4.67),('8784','2013-05-08','11:35:00',4.73),('8784','2013-05-08','11:40:00',2.8),('8784','2013-05-08','11:45:00',3.49),('8784','2013-05-08','11:50:00',2.45),('8784','2013-05-08','11:55:00',2.56),('8784','2013-05-08','12:00:00',2.95),('8784','2013-05-08','12:05:00',1.11),('8784','2013-05-08','12:15:00',1.19),('8784','2013-05-08','12:20:00',2.86),('8784','2013-05-08','12:25:00',1.9),('8784','2013-05-08','12:30:00',1.63),('8784','2013-05-08','12:35:00',1.35),('8784','2013-05-08','12:40:00',1.3),('8784','2013-05-08','12:45:00',1.36),('8784','2013-05-08','12:50:00',2.76),('8784','2013-05-08','12:55:00',3.42),('8784','2013-05-08','13:00:00',1.69),('8784','2013-05-08','13:05:00',1.6),('8784','2013-05-08','13:10:00',5.38),('8784','2013-05-08','13:15:00',3.44),('8784','2013-05-08','13:20:00',1.22),('8784','2013-05-08','13:25:00',2.52),('8784','2013-05-08','13:30:00',1.09),('8784','2013-05-08','13:35:00',1.06),('8784','2013-05-08','13:40:00',2.86),('8784','2013-05-08','13:45:00',5.29),('8784','2013-05-08','13:50:00',5.23),('8784','2013-05-08','13:55:00',4.82),('8784','2013-05-08','14:00:00',2.89),('8784','2013-05-08','14:05:00',3.23),('8784','2013-05-08','14:10:00',1.84),('8784','2013-05-08','14:15:00',3.14),('8784','2013-05-08','14:20:00',2.76),('8784','2013-05-08','14:25:00',1.81),('8784','2013-05-08','14:30:00',3.87),('8784','2013-05-08','14:35:00',4.15),('8784','2013-05-08','14:40:00',4.82),('8784','2013-05-08','14:45:00',4.76),('8784','2013-05-08','14:50:00',4.5),('8784','2013-05-08','14:55:00',4.32),('8784','2013-05-08','15:00:00',4.21),('8784','2013-05-08','15:05:00',4.12),('8784','2013-05-08','15:10:00',4.14),('8784','2013-05-08','15:15:00',4.09),('8784','2013-05-08','15:20:00',4),('8784','2013-05-08','15:25:00',3.99),('8784','2013-05-08','15:30:00',3.93),('8784','2013-05-08','15:35:00',3.81),('8784','2013-05-08','15:40:00',3.74),('8784','2013-05-08','15:45:00',3.7),('8784','2013-05-08','15:50:00',3.67),('8784','2013-05-08','15:55:00',3.64),('8784','2013-05-08','16:00:00',3.59),('8784','2013-05-08','16:05:00',3.51),('8784','2013-05-08','16:10:00',3.37),('8784','2013-05-08','16:15:00',3.37),('8784','2013-05-08','16:20:00',3.3),('8784','2013-05-08','16:25:00',3.24),('8784','2013-05-08','16:30:00',3.27),('8784','2013-05-08','16:35:00',3.17),('8784','2013-05-08','16:40:00',2.41),('8784','2013-05-08','16:45:00',3.1),('8784','2013-05-08','16:50:00',2.06),('8784','2013-05-08','16:55:00',2.72),('8784','2013-05-08','17:00:00',2.64),('8784','2013-05-08','17:05:00',2.94),('8784','2013-05-08','17:10:00',2.49),('8784','2013-05-08','17:15:00',2.51),('8784','2013-05-08','17:20:00',2.39),('8784','2013-05-08','17:25:00',2.22),('8784','2013-05-08','17:30:00',2.56),('8784','2013-05-08','17:35:00',2.46),('8784','2013-05-08','17:40:00',2.43),('8784','2013-05-08','17:45:00',2.47),('8784','2013-05-08','17:50:00',2.47),('8784','2013-05-08','17:55:00',2.36),('8784','2013-05-08','18:00:00',1.2),('8784','2013-05-08','18:10:00',1.02),('8784','2013-05-08','18:15:00',1.76),('8784','2013-05-08','18:20:00',1.65),('8784','2013-05-08','18:25:00',1.49),('8784','2013-05-08','18:30:00',1.29),('8784','2013-05-08','18:35:00',1.11),('8784','2013-05-07','07:25:00',1),('8784','2013-05-07','07:30:00',1.09),('8784','2013-05-07','07:35:00',1.18),('8784','2013-05-07','07:40:00',1.27),('8784','2013-05-07','07:45:00',1.34),('8784','2013-05-07','07:50:00',1.43),('8784','2013-05-07','07:55:00',1.51),('8784','2013-05-07','08:00:00',1.6),('8784','2013-05-07','08:05:00',1.67),('8784','2013-05-07','08:10:00',1.77),('8784','2013-05-07','08:15:00',1.86),('8784','2013-05-07','08:20:00',1.95),('8784','2013-05-07','08:25:00',2.04),('8784','2013-05-07','08:30:00',2.09),('8784','2013-05-07','08:35:00',2.23),('8784','2013-05-07','08:40:00',2.3),('8784','2013-05-07','08:45:00',2.4),('8784','2013-05-07','08:50:00',2.56),('8784','2013-05-07','08:55:00',2.55),('8784','2013-05-07','09:00:00',2.56),('8784','2013-05-07','09:15:00',2.79),('8784','2013-05-07','09:20:00',1.01),('8784','2013-05-07','09:30:00',1.63),('8784','2013-05-07','09:35:00',3.11),('8784','2013-05-07','09:40:00',2.06),('8784','2013-05-07','09:45:00',1.7),('8784','2013-05-07','09:50:00',1.58),('8784','2013-05-07','09:55:00',1.1),('8784','2013-05-07','10:50:00',1),('8784','2013-05-07','10:55:00',1.25),('8784','2013-05-07','11:00:00',1.41),('8784','2013-05-07','11:05:00',1.48),('8784','2013-05-07','11:10:00',1.56),('8784','2013-05-07','11:15:00',1.54),('8784','2013-05-07','11:20:00',2.82),('8784','2013-05-07','11:25:00',1.6),('8784','2013-05-07','11:55:00',1.03),('8784','2013-05-07','12:00:00',1.72),('8784','2013-05-07','12:05:00',4.25),('8784','2013-05-07','12:10:00',4.21),('8784','2013-05-07','12:15:00',2.46),('8784','2013-05-07','12:20:00',5.35),('8784','2013-05-07','12:25:00',3.23),('8784','2013-05-07','12:30:00',1.17),('8784','2013-05-07','12:40:00',1.02),('8784','2013-05-07','13:10:00',1.22),('8784','2013-05-07','13:15:00',1.45),('8784','2013-05-07','13:20:00',1.71),('8784','2013-05-07','13:25:00',2.8),('8784','2013-05-07','13:30:00',3.2),('8784','2013-05-07','13:35:00',5.55),('8784','2013-05-07','13:40:00',5.48),('8784','2013-05-07','13:45:00',5.11),('8784','2013-05-07','13:50:00',4.87),('8784','2013-05-07','13:55:00',1.65),('8784','2013-05-07','14:00:00',5.05),('8784','2013-05-07','14:05:00',4.96),('8784','2013-05-07','14:10:00',4.24),('8784','2013-05-07','14:15:00',4.94),('8784','2013-05-07','14:20:00',2.28),('8784','2013-05-07','14:25:00',4.47),('8784','2013-05-07','14:30:00',2.68),('8784','2013-05-07','14:35:00',5.04),('8784','2013-05-07','14:40:00',4.43),('8784','2013-05-07','14:45:00',3.14),('8784','2013-05-07','14:50:00',3.68),('8784','2013-05-07','14:55:00',3.49),('8784','2013-05-07','15:00:00',4.57),('8784','2013-05-07','15:05:00',4.03),('8784','2013-05-07','15:10:00',4.04),('8784','2013-05-07','15:15:00',4.34),('8784','2013-05-07','15:20:00',4.41),('8784','2013-05-07','15:25:00',3.08),('8784','2013-05-07','15:30:00',2.88),('8784','2013-05-07','15:35:00',3.13),('8784','2013-05-07','15:40:00',3.5),('8784','2013-05-07','15:45:00',3.37),('8784','2013-05-07','15:50:00',2.07),('8784','2013-05-07','15:55:00',2.55),('8784','2013-05-07','16:00:00',4.29),('8784','2013-05-07','16:05:00',1.76),('8784','2013-05-07','16:10:00',1.83),('8784','2013-05-07','16:15:00',3.6),('8784','2013-05-07','16:20:00',4.3),('8784','2013-05-07','16:25:00',4.19),('8784','2013-05-07','16:30:00',3.91),('8784','2013-05-07','16:35:00',3.81),('8784','2013-05-07','16:40:00',3.55),('8784','2013-05-07','16:45:00',3.54),('8784','2013-05-07','16:50:00',3.35),('8784','2013-05-07','16:55:00',2.72),('8784','2013-05-07','17:00:00',2.99),('8784','2013-05-07','17:05:00',3.1),('8784','2013-05-07','17:10:00',1.43),('8784','2013-05-07','17:15:00',1.32),('8784','2013-05-07','17:20:00',1.33),('8784','2013-05-07','17:25:00',1.31),('8784','2013-05-07','17:30:00',1.18),('8784','2013-05-07','17:35:00',1.11),('8784','2013-05-07','17:40:00',1.04),('8784','2013-05-06','08:25:00',1.26),('8784','2013-05-06','08:30:00',1.37),('8784','2013-05-06','08:35:00',1.25),('8784','2013-05-06','08:40:00',1.14),('8784','2013-05-06','08:50:00',1.4),('8784','2013-05-06','08:55:00',2.54),('8784','2013-05-06','09:00:00',2.58),('8784','2013-05-06','09:05:00',1.66),('8784','2013-05-06','09:10:00',1.5),('8784','2013-05-06','09:15:00',1.4),('8784','2013-05-06','09:20:00',1.51),('8784','2013-05-06','09:25:00',1.3),('8784','2013-05-06','09:30:00',1.06),('8784','2013-05-06','09:55:00',1.19),('8784','2013-05-06','10:00:00',2.1),('8784','2013-05-06','10:05:00',1.26),('8784','2013-05-06','10:10:00',1.14),('8784','2013-05-06','10:15:00',1.65),('8784','2013-05-06','10:20:00',2.53),('8784','2013-05-06','10:25:00',2.11),('8784','2013-05-06','10:30:00',2.14),('8784','2013-05-06','10:35:00',2.07),('8784','2013-05-06','10:40:00',2.01),('8784','2013-05-06','10:45:00',3.01),('8784','2013-05-06','10:50:00',2.41),('8784','2013-05-06','10:55:00',2.08),('8784','2013-05-06','11:00:00',1.95),('8784','2013-05-06','11:05:00',2.27),('8784','2013-05-06','11:10:00',2.26),('8784','2013-05-06','11:15:00',1.93),('8784','2013-05-06','11:20:00',2.24),('8784','2013-05-06','11:25:00',2.24),('8784','2013-05-06','11:30:00',1.4),('8784','2013-05-06','11:35:00',2.04),('8784','2013-05-06','11:40:00',2.46),('8784','2013-05-06','11:45:00',3.98),('8784','2013-05-06','11:50:00',2.51),('8784','2013-05-06','11:55:00',1.8),('8784','2013-05-06','12:00:00',2.06),('8784','2013-05-06','12:05:00',1.95),('8784','2013-05-06','12:10:00',2.85),('8784','2013-05-06','12:15:00',2.45),('8784','2013-05-06','12:20:00',2.58),('8784','2013-05-06','12:25:00',4.1),('8784','2013-05-06','12:30:00',3.92),('8784','2013-05-06','12:35:00',4.7),('8784','2013-05-06','12:40:00',2.29),('8784','2013-05-06','12:45:00',2.31),('8784','2013-05-06','12:50:00',3.3),('8784','2013-05-06','12:55:00',3),('8784','2013-05-06','13:00:00',2.3),('8784','2013-05-06','13:05:00',3.67),('8784','2013-05-06','13:10:00',4.28),('8784','2013-05-06','13:15:00',3.5),('8784','2013-05-06','13:20:00',4.34),('8784','2013-05-06','13:25:00',3.29),('8784','2013-05-06','13:30:00',3.3),('8784','2013-05-06','13:35:00',3.14),('8784','2013-05-06','13:40:00',3.29),('8784','2013-05-06','13:45:00',3.99),('8784','2013-05-06','13:50:00',4.78),('8784','2013-05-06','13:55:00',4.7),('8784','2013-05-06','14:00:00',4.24),('8784','2013-05-06','14:05:00',3.51),('8784','2013-05-06','14:10:00',3.93),('8784','2013-05-06','14:15:00',4.77),('8784','2013-05-06','14:20:00',4.72),('8784','2013-05-06','14:25:00',2.17),('8784','2013-05-06','14:30:00',4.65),('8784','2013-05-06','14:35:00',4.43),('8784','2013-05-06','14:40:00',3.47),('8784','2013-05-06','14:45:00',2.75),('8784','2013-05-06','14:50:00',3.52),('8784','2013-05-06','14:55:00',4.27),('8784','2013-05-06','15:00:00',2.72),('8784','2013-05-06','15:05:00',2.68),('8784','2013-05-06','15:10:00',2.71),('8784','2013-05-06','15:15:00',3.11),('8784','2013-05-06','15:20:00',2.27),('8784','2013-05-06','15:25:00',2.2),('8784','2013-05-06','15:30:00',2.7),('8784','2013-05-06','15:35:00',3.14),('8784','2013-05-06','15:40:00',1.41),('8784','2013-05-06','15:45:00',1.52),('8784','2013-05-06','15:50:00',2.36),('8784','2013-05-06','15:55:00',1.57),('8784','2013-05-06','16:00:00',1.77),('8784','2013-05-06','16:05:00',1.61),('8784','2013-05-06','16:10:00',1.6),('8784','2013-05-06','16:15:00',1.62),('8784','2013-05-06','16:20:00',2.66),('8784','2013-05-06','16:25:00',2.37),('8784','2013-05-06','16:30:00',3.12),('8784','2013-05-06','16:35:00',2.49),('8784','2013-05-06','16:40:00',2.86),('8784','2013-05-06','16:45:00',1.91),('8784','2013-05-06','16:50:00',3.27),('8784','2013-05-06','16:55:00',2.52),('8784','2013-05-06','17:15:00',1.49),('8784','2013-05-06','17:20:00',1.12),('8784','2013-05-06','17:35:00',1.88),('8784','2013-05-06','17:40:00',1.61),('8784','2013-05-06','17:45:00',1.27),('8784','2013-05-06','17:50:00',1.16),('8784','2013-05-06','17:55:00',1.34),('8784','2013-05-06','18:00:00',1.57),('8784','2013-05-06','18:05:00',1.88),('8784','2013-05-06','18:15:00',1.17),('8784','2013-05-06','18:20:00',1.71),('8784','2013-05-06','18:25:00',1.36),('8784','2013-05-06','18:30:00',1.11),('8784','2013-05-05','07:45:00',1.2),('8784','2013-05-05','07:50:00',1.25),('8784','2013-05-05','07:55:00',1.15),('8784','2013-05-05','08:00:00',1.34),('8784','2013-05-05','08:05:00',1.53),('8784','2013-05-05','08:10:00',1.62),('8784','2013-05-05','08:15:00',1.75),('8784','2013-05-05','08:20:00',1.99),('8784','2013-05-05','08:25:00',2.37),('8784','2013-05-05','08:30:00',2.45),('8784','2013-05-05','08:35:00',2.36),('8784','2013-05-05','08:40:00',2.3),('8784','2013-05-05','08:45:00',1.74),('8784','2013-05-05','08:50:00',1.43),('8784','2013-05-05','08:55:00',1.5),('8784','2013-05-05','09:00:00',1.5),('8784','2013-05-05','09:05:00',1.48),('8784','2013-05-05','09:10:00',1.52),('8784','2013-05-05','09:15:00',1.47),('8784','2013-05-05','09:20:00',1.34),('8784','2013-05-05','09:25:00',1.71),('8784','2013-05-05','09:30:00',1.73),('8784','2013-05-05','09:35:00',1.62),('8784','2013-05-05','09:40:00',2.69),('8784','2013-05-05','09:45:00',3.37),('8784','2013-05-05','09:50:00',3.39),('8784','2013-05-05','09:55:00',3.21),('8784','2013-05-05','10:00:00',3.18),('8784','2013-05-05','10:05:00',2.78),('8784','2013-05-05','10:10:00',2.31),('8784','2013-05-05','10:15:00',3.3),('8784','2013-05-05','10:20:00',4.02),('8784','2013-05-05','10:25:00',2.41),('8784','2013-05-05','10:30:00',2.86),('8784','2013-05-05','10:35:00',3.03),('8784','2013-05-05','10:40:00',3.12),('8784','2013-05-05','10:45:00',2.91),('8784','2013-05-05','10:50:00',1.89),('8784','2013-05-05','10:55:00',1.64),('8784','2013-05-05','11:00:00',1.61),('8784','2013-05-05','11:05:00',1.87),('8784','2013-05-05','11:10:00',1.7),('8784','2013-05-05','11:15:00',1.84),('8784','2013-05-05','11:20:00',2.87),('8784','2013-05-05','11:25:00',3.72),('8784','2013-05-05','11:30:00',2.8),('8784','2013-05-05','11:35:00',3.89),('8784','2013-05-05','11:40:00',2.88),('8784','2013-05-05','11:45:00',2.9),('8784','2013-05-05','11:50:00',3.14),('8784','2013-05-05','11:55:00',4.26),('8784','2013-05-05','12:00:00',3.31),('8784','2013-05-05','12:05:00',3.45),('8784','2013-05-05','12:10:00',3.12),('8784','2013-05-05','12:15:00',3.78),('8784','2013-05-05','12:20:00',2.11),('8784','2013-05-05','12:25:00',4.25),('8784','2013-05-05','12:30:00',3.64),('8784','2013-05-05','12:35:00',4.15),('8784','2013-05-05','12:40:00',4.74),('8784','2013-05-05','12:45:00',4.74),('8784','2013-05-05','12:50:00',4.33),('8784','2013-05-05','12:55:00',4.67),('8784','2013-05-05','13:00:00',4.65),('8784','2013-05-05','13:05:00',4.51),('8784','2013-05-05','13:10:00',4.56),('8784','2013-05-05','13:15:00',3.69),('8784','2013-05-05','13:20:00',3.01),('8784','2013-05-05','13:25:00',2.08),('8784','2013-05-05','13:30:00',1.88),('8784','2013-05-05','13:35:00',4.79),('8784','2013-05-05','13:40:00',4.66),('8784','2013-05-05','13:45:00',4.53),('8784','2013-05-05','13:50:00',4.6),('8784','2013-05-05','13:55:00',4.61),('8784','2013-05-05','14:00:00',4.71),('8784','2013-05-05','14:05:00',4.4),('8784','2013-05-05','14:10:00',3.46),('8784','2013-05-05','14:15:00',3.92),('8784','2013-05-05','14:20:00',4.34),('8784','2013-05-05','14:25:00',4.08),('8784','2013-05-05','14:30:00',3.96),('8784','2013-05-05','14:35:00',3.94),('8784','2013-05-05','14:40:00',3.92),('8784','2013-05-05','14:45:00',3.89),('8784','2013-05-05','14:50:00',3.85),('8784','2013-05-05','14:55:00',3.82),('8784','2013-05-05','15:00:00',3.72),('8784','2013-05-05','15:05:00',3.73),('8784','2013-05-05','15:10:00',3.71),('8784','2013-05-05','15:15:00',3.66),('8784','2013-05-05','15:20:00',3.6),('8784','2013-05-05','15:25:00',3.59),('8784','2013-05-05','15:30:00',3.57),('8784','2013-05-05','15:35:00',3.54),('8784','2013-05-05','15:40:00',3.47),('8784','2013-05-05','15:45:00',3.4),('8784','2013-05-05','15:50:00',3.35),('8784','2013-05-05','15:55:00',3.29),('8784','2013-05-05','16:00:00',3.25),('8784','2013-05-05','16:05:00',3.19),('8784','2013-05-05','16:10:00',3.13),('8784','2013-05-05','16:15:00',3.05),('8784','2013-05-05','16:20:00',2.99),('8784','2013-05-05','16:25:00',2.94),('8784','2013-05-05','16:30:00',2.88),('8784','2013-05-05','16:35:00',2.8),('8784','2013-05-05','16:40:00',2.73),('8784','2013-05-05','16:45:00',2.64),('8784','2013-05-05','16:50:00',2.57),('8784','2013-05-05','16:55:00',2.5),('8784','2013-05-05','17:00:00',2.41),('8784','2013-05-05','17:05:00',2.34),('8784','2013-05-05','17:10:00',2.26),('8784','2013-05-05','17:15:00',2.19),('8784','2013-05-05','17:20:00',2.11),('8784','2013-05-05','17:25:00',2),('8784','2013-05-05','17:30:00',1.92),('8784','2013-05-05','17:35:00',1.84),('8784','2013-05-05','17:40:00',1.76),('8784','2013-05-05','17:45:00',1.69),('8784','2013-05-05','17:50:00',1.6),('8784','2013-05-05','17:55:00',1.5),('8784','2013-05-05','18:00:00',1.41),('8784','2013-05-05','18:05:00',1.34),('8784','2013-05-05','18:10:00',1.25),('8784','2013-05-05','18:15:00',1.18),('8784','2013-05-05','18:20:00',1.1),('8784','2013-05-05','18:25:00',1.02),('8784','2013-05-04','07:40:00',1.08),('8784','2013-05-04','07:45:00',1.05),('8784','2013-05-04','07:50:00',1.11),('8784','2013-05-04','07:55:00',1.29),('8784','2013-05-04','08:00:00',1.41),('8784','2013-05-04','08:05:00',1.48),('8784','2013-05-04','08:10:00',1.56),('8784','2013-05-04','08:15:00',1.64),('8784','2013-05-04','08:20:00',1.72),('8784','2013-05-04','08:25:00',1.78),('8784','2013-05-04','08:30:00',1.86),('8784','2013-05-04','08:35:00',1.92),('8784','2013-05-04','08:40:00',1.97),('8784','2013-05-04','08:45:00',2.06),('8784','2013-05-04','08:50:00',2.13),('8784','2013-05-04','08:55:00',2.19),('8784','2013-05-04','09:00:00',2.26),('8784','2013-05-04','09:05:00',2.36),('8784','2013-05-04','09:10:00',2.43),('8784','2013-05-04','09:15:00',2.49),('8784','2013-05-04','09:20:00',2.61),('8784','2013-05-04','09:25:00',2.64),('8784','2013-05-04','09:30:00',2.68),('8784','2013-05-04','09:35:00',2.8),('8784','2013-05-04','09:40:00',2.89),('8784','2013-05-04','09:45:00',2.97),('8784','2013-05-04','09:50:00',3.04),('8784','2013-05-04','09:55:00',3.05),('8784','2013-05-04','10:00:00',3.14),('8784','2013-05-04','10:05:00',3.18),('8784','2013-05-04','10:10:00',3.29),('8784','2013-05-04','10:15:00',3.36),('8784','2013-05-04','10:20:00',3.4),('8784','2013-05-04','10:25:00',3.44),('8784','2013-05-04','10:30:00',3.48),('8784','2013-05-04','10:35:00',3.52),('8784','2013-05-04','10:40:00',3.5),('8784','2013-05-04','10:45:00',3.53),('8784','2013-05-04','10:50:00',3.45),('8784','2013-05-04','10:55:00',3.47),('8784','2013-05-04','11:00:00',3.47),('8784','2013-05-04','11:05:00',3.45),('8784','2013-05-04','11:10:00',3.29),('8784','2013-05-04','11:15:00',3.26),('8784','2013-05-04','11:20:00',3.57),('8784','2013-05-04','11:25:00',3.58),('8784','2013-05-04','11:30:00',3.49),('8784','2013-05-04','11:35:00',3.53),('8784','2013-05-04','11:40:00',3.39),('8784','2013-05-04','11:45:00',3.57),('8784','2013-05-04','11:50:00',3.53),('8784','2013-05-04','11:55:00',3.52),('8784','2013-05-04','12:00:00',3.51),('8784','2013-05-04','12:05:00',3.64),('8784','2013-05-04','12:10:00',3.66),('8784','2013-05-04','12:15:00',3.75),('8784','2013-05-04','12:20:00',3.79),('8784','2013-05-04','12:25:00',3.88),('8784','2013-05-04','12:30:00',3.92),('8784','2013-05-04','12:35:00',3.95),('8784','2013-05-04','12:40:00',3.92),('8784','2013-05-04','12:45:00',3.92),('8784','2013-05-04','12:50:00',3.8),('8784','2013-05-04','12:55:00',3.76),('8784','2013-05-04','13:00:00',3.71),('8784','2013-05-04','13:05:00',3.32),('8784','2013-05-04','13:10:00',3.7),('8784','2013-05-04','13:15:00',4.1),('8784','2013-05-04','13:20:00',4.1),('8784','2013-05-04','13:25:00',3.91),('8784','2013-05-04','13:30:00',4.01),('8784','2013-05-04','13:35:00',3.67),('8784','2013-05-04','13:40:00',3.82),('8784','2013-05-04','13:45:00',3.81),('8784','2013-05-04','13:50:00',3.38),('8784','2013-05-04','13:55:00',3.48),('8784','2013-05-04','14:00:00',3.81),('8784','2013-05-04','14:05:00',3.7),('8784','2013-05-04','14:10:00',3.58),('8784','2013-05-04','14:15:00',3.69),('8784','2013-05-04','14:20:00',3.65),('8784','2013-05-04','14:25:00',3.41),('8784','2013-05-04','14:30:00',3.57),('8784','2013-05-04','14:35:00',3.33),('8784','2013-05-04','14:40:00',3.47),('8784','2013-05-04','14:45:00',3.41),('8784','2013-05-04','14:50:00',3.33),('8784','2013-05-04','14:55:00',3.44),('8784','2013-05-04','15:00:00',3.5),('8784','2013-05-04','15:05:00',3.57),('8784','2013-05-04','15:10:00',3.35),('8784','2013-05-04','15:15:00',3.43),('8784','2013-05-04','15:20:00',3.39),('8784','2013-05-04','15:25:00',3.41),('8784','2013-05-04','15:30:00',3.37),('8784','2013-05-04','15:35:00',3.22),('8784','2013-05-04','15:40:00',3.34),('8784','2013-05-04','15:45:00',3.27),('8784','2013-05-04','15:50:00',3.21),('8784','2013-05-04','15:55:00',3.15),('8784','2013-05-04','16:00:00',3.09),('8784','2013-05-04','16:05:00',3.03),('8784','2013-05-04','16:10:00',2.97),('8784','2013-05-04','16:15:00',2.91),('8784','2013-05-04','16:20:00',2.85),('8784','2013-05-04','16:25:00',2.78),('8784','2013-05-04','16:30:00',2.66),('8784','2013-05-04','16:35:00',2.63),('8784','2013-05-04','16:40:00',2.57),('8784','2013-05-04','16:45:00',2.49),('8784','2013-05-04','16:50:00',2.4),('8784','2013-05-04','16:55:00',2.34),('8784','2013-05-04','17:00:00',2.29),('8784','2013-05-04','17:05:00',2.18),('8784','2013-05-04','17:10:00',1.69),('8784','2013-05-04','17:15:00',1.98),('8784','2013-05-04','17:20:00',2.03),('8784','2013-05-04','17:25:00',1.94),('8784','2013-05-04','17:30:00',1.82),('8784','2013-05-04','17:35:00',1.67),('8784','2013-05-04','17:40:00',1.59),('8784','2013-05-04','17:45:00',1.56),('8784','2013-05-04','17:50:00',1.55),('8784','2013-05-04','17:55:00',1.48),('8784','2013-05-04','18:00:00',1.41),('8784','2013-05-04','18:05:00',1.33),('8784','2013-05-04','18:10:00',1.12),('8784','2013-05-03','08:05:00',1.45),('8784','2013-05-03','08:10:00',1.64),('8784','2013-05-03','08:15:00',1.85),('8784','2013-05-03','08:20:00',1.81),('8784','2013-05-03','08:25:00',1.96),('8784','2013-05-03','08:30:00',2.03),('8784','2013-05-03','08:35:00',2.08),('8784','2013-05-03','08:40:00',2.15),('8784','2013-05-03','08:45:00',2.19),('8784','2013-05-03','08:50:00',2.16),('8784','2013-05-03','08:55:00',2.22),('8784','2013-05-03','09:00:00',2.4),('8784','2013-05-03','09:05:00',2.49),('8784','2013-05-03','09:10:00',2.55),('8784','2013-05-03','09:15:00',2.63),('8784','2013-05-03','09:20:00',2.7),('8784','2013-05-03','09:25:00',2.75),('8784','2013-05-03','09:30:00',2.84),('8784','2013-05-03','09:35:00',2.91),('8784','2013-05-03','09:40:00',2.98),('8784','2013-05-03','09:45:00',3.05),('8784','2013-05-03','09:50:00',3.09),('8784','2013-05-03','09:55:00',3.18),('8784','2013-05-03','10:00:00',3.25),('8784','2013-05-03','10:05:00',3.31),('8784','2013-05-03','10:10:00',3.36),('8784','2013-05-03','10:15:00',3.4),('8784','2013-05-03','10:20:00',3.45),('8784','2013-05-03','10:25:00',3.49),('8784','2013-05-03','10:30:00',3.49),('8784','2013-05-03','10:35:00',3.58),('8784','2013-05-03','10:40:00',3.64),('8784','2013-05-03','10:45:00',3.7),('8784','2013-05-03','10:50:00',3.76),('8784','2013-05-03','10:55:00',3.79),('8784','2013-05-03','11:00:00',3.8),('8784','2013-05-03','11:05:00',3.83),('8784','2013-05-03','11:10:00',3.86),('8784','2013-05-03','11:15:00',3.9),('8784','2013-05-03','11:20:00',3.93),('8784','2013-05-03','11:25:00',3.98),('8784','2013-05-03','11:30:00',3.97),('8784','2013-05-03','11:35:00',4.03),('8784','2013-05-03','11:40:00',4.07),('8784','2013-05-03','11:45:00',4.05),('8784','2013-05-03','11:50:00',4.09),('8784','2013-05-03','11:55:00',4.12),('8784','2013-05-03','12:00:00',4.09),('8784','2013-05-03','12:05:00',4.06),('8784','2013-05-03','12:10:00',4.11),('8784','2013-05-03','12:15:00',4.17),('8784','2013-05-03','12:20:00',4.2),('8784','2013-05-03','12:25:00',4.19),('8784','2013-05-03','12:30:00',4.18),('8784','2013-05-03','12:35:00',4.18),('8784','2013-05-03','12:40:00',4.18),('8784','2013-05-03','12:45:00',4.11),('8784','2013-05-03','12:50:00',4.23),('8784','2013-05-03','12:55:00',4.24),('8784','2013-05-03','13:00:00',4.22),('8784','2013-05-03','13:05:00',4.2),('8784','2013-05-03','13:10:00',4.2),('8784','2013-05-03','13:15:00',4.19),('8784','2013-05-03','13:20:00',4.18),('8784','2013-05-03','13:25:00',4.19),('8784','2013-05-03','13:30:00',4.16),('8784','2013-05-03','13:35:00',4.05),('8784','2013-05-03','13:40:00',4),('8784','2013-05-03','13:45:00',4),('8784','2013-05-03','13:50:00',4.02),('8784','2013-05-03','13:55:00',4.01),('8784','2013-05-03','14:00:00',3.95),('8784','2013-05-03','14:05:00',3.8),('8784','2013-05-03','14:10:00',3.83),('8784','2013-05-03','14:15:00',3.79),('8784','2013-05-03','14:20:00',3.92),('8784','2013-05-03','14:25:00',3.88),('8784','2013-05-03','14:30:00',3.86),('8784','2013-05-03','14:35:00',3.87),('8784','2013-05-03','14:40:00',3.8),('8784','2013-05-03','14:45:00',3.77),('8784','2013-05-03','14:50:00',3.72),('8784','2013-05-03','14:55:00',3.73),('8784','2013-05-03','15:00:00',3.74),('8784','2013-05-03','15:05:00',3.66),('8784','2013-05-03','15:10:00',3.66),('8784','2013-05-03','15:15:00',3.66),('8784','2013-05-03','15:20:00',3.58),('8784','2013-05-03','15:25:00',3.58),('8784','2013-05-03','15:30:00',3.56),('8784','2013-05-03','15:35:00',3.47),('8784','2013-05-03','15:40:00',3.43),('8784','2013-05-03','15:45:00',3.37),('8784','2013-05-03','15:50:00',3.3),('8784','2013-05-03','15:55:00',3.24),('8784','2013-05-03','16:00:00',3.21),('8784','2013-05-03','16:05:00',3.15),('8784','2013-05-03','16:10:00',3.1),('8784','2013-05-03','16:15:00',3.01),('8784','2013-05-03','16:20:00',2.87),('8784','2013-05-03','16:25:00',2.85),('8784','2013-05-03','16:30:00',2.84),('8784','2013-05-03','16:35:00',2.77),('8784','2013-05-03','16:40:00',2.69),('8784','2013-05-03','16:45:00',2.62),('8784','2013-05-03','16:50:00',2.54),('8784','2013-05-03','16:55:00',2.45),('8784','2013-05-03','17:00:00',2.38),('8784','2013-05-03','17:05:00',2.29),('8784','2013-05-03','17:10:00',2.18),('8784','2013-05-03','17:15:00',2.11),('8784','2013-05-03','17:20:00',2),('8784','2013-05-03','17:25:00',1.9),('8784','2013-05-03','17:30:00',1.8),('8784','2013-05-03','17:35:00',1.71),('8784','2013-05-03','17:40:00',1.63),('8784','2013-05-03','17:45:00',1.54),('8784','2013-05-03','17:50:00',1.44),('8784','2013-05-03','17:55:00',1.39),('8784','2013-05-03','18:00:00',1.34),('8784','2013-05-03','18:05:00',1.27),('8784','2013-05-03','18:10:00',1.19),('8784','2013-05-03','18:15:00',1.11),('8784','2013-05-03','18:20:00',1.03),('8784','2013-05-02','08:55:00',1.36),('8784','2013-05-02','09:00:00',1.95),('8784','2013-05-02','09:05:00',1.52),('8784','2013-05-02','09:20:00',1.12),('8784','2013-05-02','09:25:00',1.83),('8784','2013-05-02','09:30:00',2.36),('8784','2013-05-02','09:35:00',2.05),('8784','2013-05-02','09:40:00',1.6),('8784','2013-05-02','09:45:00',2.79),('8784','2013-05-02','09:50:00',1.46),('8784','2013-05-02','09:55:00',1.13),('8784','2013-05-02','10:00:00',1.13),('8784','2013-05-02','10:05:00',1.57),('8784','2013-05-02','10:10:00',1.51),('8784','2013-05-02','10:15:00',1.63),('8784','2013-05-02','10:20:00',1.59),('8784','2013-05-02','10:25:00',1.89),('8784','2013-05-02','10:30:00',3.01),('8784','2013-05-02','10:35:00',2.85),('8784','2013-05-02','10:40:00',3.63),('8784','2013-05-02','10:45:00',3.33),('8784','2013-05-02','10:50:00',3.89),('8784','2013-05-02','10:55:00',4.14),('8784','2013-05-02','11:00:00',4.06),('8784','2013-05-02','11:05:00',3.66),('8784','2013-05-02','11:10:00',3.14),('8784','2013-05-02','11:15:00',3.04),('8784','2013-05-02','11:20:00',3.07),('8784','2013-05-02','11:25:00',4.01),('8784','2013-05-02','11:30:00',4.19),('8784','2013-05-02','11:35:00',4.02),('8784','2013-05-02','11:40:00',3.99),('8784','2013-05-02','11:45:00',3.99),('8784','2013-05-02','11:50:00',3.99),('8784','2013-05-02','11:55:00',4.01),('8784','2013-05-02','12:00:00',4),('8784','2013-05-02','12:05:00',4),('8784','2013-05-02','12:10:00',4),('8784','2013-05-02','12:15:00',4.04),('8784','2013-05-02','12:20:00',4.04),('8784','2013-05-02','12:25:00',4.05),('8784','2013-05-02','12:30:00',4.11),('8784','2013-05-02','12:35:00',4.12),('8784','2013-05-02','12:40:00',4.18),('8784','2013-05-02','12:45:00',4.19),('8784','2013-05-02','12:50:00',4.19),('8784','2013-05-02','12:55:00',4.23),('8784','2013-05-02','13:00:00',4.26),('8784','2013-05-02','13:05:00',4.29),('8784','2013-05-02','13:10:00',4.32),('8784','2013-05-02','13:15:00',4.31),('8784','2013-05-02','13:20:00',4.31),('8784','2013-05-02','13:25:00',4.32),('8784','2013-05-02','13:30:00',4.32),('8784','2013-05-02','13:35:00',4.3),('8784','2013-05-02','13:40:00',4.27),('8784','2013-05-02','13:45:00',4.24),('8784','2013-05-02','13:50:00',4.22),('8784','2013-05-02','13:55:00',4.22),('8784','2013-05-02','14:00:00',4.17),('8784','2013-05-02','14:05:00',4.12),('8784','2013-05-02','14:10:00',4.08),('8784','2013-05-02','14:15:00',4.09),('8784','2013-05-02','14:20:00',4),('8784','2013-05-02','14:25:00',4.02),('8784','2013-05-02','14:30:00',3.97),('8784','2013-05-02','14:35:00',3.94),('8784','2013-05-02','14:40:00',3.92),('8784','2013-05-02','14:45:00',3.88),('8784','2013-05-02','14:50:00',3.85),('8784','2013-05-02','14:55:00',3.81),('8784','2013-05-02','15:00:00',3.79),('8784','2013-05-02','15:05:00',3.74),('8784','2013-05-02','15:10:00',3.69),('8784','2013-05-02','15:15:00',3.62),('8784','2013-05-02','15:20:00',3.58),('8784','2013-05-02','15:25:00',3.52),('8784','2013-05-02','15:30:00',3.46),('8784','2013-05-02','15:35:00',3.42),('8784','2013-05-02','15:40:00',3.37),('8784','2013-05-02','15:45:00',3.34),('8784','2013-05-02','15:50:00',3.28),('8784','2013-05-02','15:55:00',3.24),('8784','2013-05-02','16:00:00',3.19),('8784','2013-05-02','16:05:00',3.09),('8784','2013-05-02','16:10:00',3.07),('8784','2013-05-02','16:15:00',2.99),('8784','2013-05-02','16:20:00',2.93),('8784','2013-05-02','16:25:00',2.87),('8784','2013-05-02','16:30:00',2.79),('8784','2013-05-02','16:35:00',2.73),('8784','2013-05-02','16:40:00',2.66),('8784','2013-05-02','16:45:00',2.58),('8784','2013-05-02','16:50:00',2.51),('8784','2013-05-02','16:55:00',2.44),('8784','2013-05-02','17:00:00',2.38),('8784','2013-05-02','17:05:00',2.3),('8784','2013-05-02','17:10:00',2.23),('8784','2013-05-02','17:15:00',2.15),('8784','2013-05-02','17:20:00',2.05),('8784','2013-05-02','17:25:00',1.99),('8784','2013-05-02','17:30:00',1.91),('8784','2013-05-02','17:35:00',1.81),('8784','2013-05-02','17:40:00',1.74),('8784','2013-05-02','17:45:00',1.66),('8784','2013-05-02','17:50:00',1.58),('8784','2013-05-02','17:55:00',1.49),('8784','2013-05-02','18:00:00',1.41),('8784','2013-05-02','18:05:00',1.34),('8784','2013-05-02','18:10:00',1.25),('8784','2013-05-02','18:15:00',1.17),('8784','2013-05-02','18:20:00',1.09),('8784','2013-05-02','18:25:00',1.01),('8784','2014-03-30','08:20:00',1.16),('8784','2014-03-30','08:25:00',1.25),('8784','2014-03-30','08:30:00',1.35),('8784','2014-03-30','08:35:00',1.38),('8784','2014-03-30','08:40:00',1.42),('8784','2014-03-30','08:45:00',1.39),('8784','2014-03-30','08:50:00',1.41),('8784','2014-03-30','08:55:00',1.47),('8784','2014-03-30','09:00:00',1.53),('8784','2014-03-30','09:05:00',1.5),('8784','2014-03-30','09:10:00',1.44),('8784','2014-03-30','09:15:00',1.52),('8784','2014-03-30','09:20:00',1.74),('8784','2014-03-30','09:25:00',1.9),('8784','2014-03-30','09:30:00',2.13),('8784','2014-03-30','09:35:00',2.25),('8784','2014-03-30','09:40:00',2.3),('8784','2014-03-30','09:45:00',2.39),('8784','2014-03-30','09:50:00',2.46),('8784','2014-03-30','09:55:00',2.38),('8784','2014-03-30','10:00:00',2.51),('8784','2014-03-30','10:05:00',2.76),('8784','2014-03-30','10:10:00',2.76),('8784','2014-03-30','10:15:00',2.75),('8784','2014-03-30','10:20:00',2.8),('8784','2014-03-30','10:25:00',2.98),('8784','2014-03-30','10:30:00',3.06),('8784','2014-03-30','10:35:00',3.13),('8784','2014-03-30','10:40:00',3.18),('8784','2014-03-30','10:45:00',3.2),('8784','2014-03-30','10:50:00',3.21),('8784','2014-03-30','10:55:00',3.23),('8784','2014-03-30','11:00:00',3.2),('8784','2014-03-30','11:05:00',3.17),('8784','2014-03-30','11:10:00',3.17),('8784','2014-03-30','11:15:00',3.1),('8784','2014-03-30','11:20:00',3.09),('8784','2014-03-30','11:25:00',3.24),('8784','2014-03-30','11:30:00',3.48),('8784','2014-03-30','11:35:00',3.52),('8784','2014-03-30','11:40:00',3.65),('8784','2014-03-30','11:45:00',3.78),('8784','2014-03-30','11:50:00',3.81),('8784','2014-03-30','11:55:00',3.92),('8784','2014-03-30','12:00:00',3.96),('8784','2014-03-30','12:05:00',4.05),('8784','2014-03-30','12:10:00',4.15),('8784','2014-03-30','12:15:00',4.24),('8784','2014-03-30','12:20:00',4.13),('8784','2014-03-30','12:25:00',4.09),('8784','2014-03-30','12:30:00',3.76),('8784','2014-03-30','12:35:00',3.82),('8784','2014-03-30','12:40:00',4),('8784','2014-03-30','12:45:00',3.96),('8784','2014-03-30','12:50:00',3.96),('8784','2014-03-30','12:55:00',4.07),('8784','2014-03-30','13:00:00',4.13),('8784','2014-03-30','13:05:00',4.21),('8784','2014-03-30','13:10:00',4.14),('8784','2014-03-30','13:15:00',4.14),('8784','2014-03-30','13:20:00',4.14),('8784','2014-03-30','13:25:00',4.13),('8784','2014-03-30','13:30:00',4.14),('8784','2014-03-30','13:35:00',4.16),('8784','2014-03-30','13:40:00',4.16),('8784','2014-03-30','13:45:00',4.18),('8784','2014-03-30','13:50:00',4.12),('8784','2014-03-30','13:55:00',4),('8784','2014-03-30','14:00:00',3.97),('8784','2014-03-30','14:05:00',3.96),('8784','2014-03-30','14:10:00',3.8),('8784','2014-03-30','14:15:00',3.8),('8784','2014-03-30','14:20:00',3.94),('8784','2014-03-30','14:25:00',4),('8784','2014-03-30','14:30:00',3.92),('8784','2014-03-30','14:35:00',3.48),('8784','2014-03-30','14:40:00',3.5),('8784','2014-03-30','14:45:00',3.19),('8784','2014-03-30','14:50:00',2.4),('8784','2014-03-30','14:55:00',2.28),('8784','2014-03-30','15:00:00',1.48),('8784','2014-03-30','15:05:00',1.7),('8784','2014-03-30','15:10:00',1.73),('8784','2014-03-30','15:15:00',2.83),('8784','2014-03-30','15:20:00',2.94),('8784','2014-03-30','15:25:00',3.18),('8784','2014-03-30','15:30:00',3.2),('8784','2014-03-30','15:35:00',3.19),('8784','2014-03-30','15:40:00',3.14),('8784','2014-03-30','15:45:00',3.21),('8784','2014-03-30','15:50:00',3.13),('8784','2014-03-30','15:55:00',3.07),('8784','2014-03-30','16:00:00',2.7),('8784','2014-03-30','16:05:00',2.57),('8784','2014-03-30','16:10:00',2.46),('8784','2014-03-30','16:15:00',2.74),('8784','2014-03-30','16:20:00',2.79),('8784','2014-03-30','16:25:00',2.74),('8784','2014-03-30','16:30:00',2.64),('8784','2014-03-30','16:35:00',2.65),('8784','2014-03-30','16:40:00',2.48),('8784','2014-03-30','16:45:00',2.23),('8784','2014-03-30','16:50:00',1.93),('8784','2014-03-30','16:55:00',1.81),('8784','2014-03-30','17:00:00',1.94),('8784','2014-03-30','17:05:00',2.03),('8784','2014-03-30','17:10:00',2.08),('8784','2014-03-30','17:15:00',2.01),('8784','2014-03-30','17:20:00',1.89),('8784','2014-03-30','17:25:00',1.67),('8784','2014-03-30','17:30:00',1.66),('8784','2014-03-30','17:35:00',1.54),('8784','2014-03-30','17:40:00',1.38),('8784','2014-03-30','17:45:00',1.36),('8784','2014-03-30','17:50:00',1.15),('8784','2013-05-01','07:50:00',1.08),('8784','2013-05-01','07:55:00',1.15),('8784','2013-05-01','08:00:00',1.24),('8784','2013-05-01','08:05:00',1.3),('8784','2013-05-01','08:10:00',1.35),('8784','2013-05-01','08:15:00',1.47),('8784','2013-05-01','08:20:00',1.56),('8784','2013-05-01','08:25:00',1.66),('8784','2013-05-01','08:30:00',1.75),('8784','2013-05-01','08:35:00',1.85),('8784','2013-05-01','08:40:00',1.92),('8784','2013-05-01','08:45:00',2),('8784','2013-05-01','08:50:00',2.09),('8784','2013-05-01','08:55:00',2.18),('8784','2013-05-01','09:00:00',2.26),('8784','2013-05-01','09:05:00',2.35),('8784','2013-05-01','09:10:00',2.41),('8784','2013-05-01','09:15:00',2.47),('8784','2013-05-01','09:20:00',2.51),('8784','2013-05-01','09:25:00',2.57),('8784','2013-05-01','09:30:00',2.58),('8784','2013-05-01','09:35:00',2.68),('8784','2013-05-01','09:40:00',2.75),('8784','2013-05-01','09:45:00',2.81),('8784','2013-05-01','09:50:00',2.87),('8784','2013-05-01','09:55:00',2.93),('8784','2013-05-01','10:00:00',2.96),('8784','2013-05-01','10:05:00',2.97),('8784','2013-05-01','10:10:00',3.12),('8784','2013-05-01','10:15:00',3.18),('8784','2013-05-01','10:20:00',3.23),('8784','2013-05-01','10:25:00',3.27),('8784','2013-05-01','10:30:00',3.34),('8784','2013-05-01','10:35:00',3.36),('8784','2013-05-01','10:40:00',3.58),('8784','2013-05-01','10:45:00',3.65),('8784','2013-05-01','10:50:00',3.68),('8784','2013-05-01','10:55:00',3.69),('8784','2013-05-01','11:00:00',3.75),('8784','2013-05-01','11:05:00',3.75),('8784','2013-05-01','11:10:00',3.8),('8784','2013-05-01','11:15:00',3.5),('8784','2013-05-01','11:20:00',3.55),('8784','2013-05-01','11:25:00',3.53),('8784','2013-05-01','11:30:00',3.45),('8784','2013-05-01','11:35:00',3.56),('8784','2013-05-01','11:40:00',2.76),('8784','2013-05-01','11:45:00',2.76),('8784','2013-05-01','11:50:00',3.57),('8784','2013-05-01','11:55:00',4.05),('8784','2013-05-01','12:00:00',4.02),('8784','2013-05-01','12:05:00',3.96),('8784','2013-05-01','12:10:00',3.98),('8784','2013-05-01','12:15:00',3.93),('8784','2013-05-01','12:20:00',3.98),('8784','2013-05-01','12:25:00',4.04),('8784','2013-05-01','12:30:00',4.07),('8784','2013-05-01','12:35:00',4.13),('8784','2013-05-01','12:40:00',4.23),('8784','2013-05-01','12:45:00',3.83),('8784','2013-05-01','12:50:00',2.62),('8784','2013-05-01','12:55:00',1.58),('8784','2013-05-01','13:00:00',1.7),('8784','2013-05-01','13:05:00',1.98),('8784','2013-05-01','13:10:00',2.49),('8784','2013-05-01','13:15:00',4.39),('8784','2013-05-01','13:20:00',4.8),('8784','2013-05-01','13:25:00',4.16),('8784','2013-05-01','13:30:00',3.64),('8784','2013-05-01','13:35:00',4.21),('8784','2013-05-01','13:40:00',4.39),('8784','2013-05-01','13:45:00',4.46),('8784','2013-05-01','13:50:00',4.22),('8784','2013-05-01','13:55:00',4.09),('8784','2013-05-01','14:00:00',4.02),('8784','2013-05-01','14:05:00',3.99),('8784','2013-05-01','14:10:00',3.96),('8784','2013-05-01','14:15:00',3.48),('8784','2013-05-01','14:20:00',4.14),('8784','2013-05-01','14:25:00',4.12),('8784','2013-05-01','14:30:00',4.12),('8784','2013-05-01','14:35:00',3.9),('8784','2013-05-01','14:40:00',3.63),('8784','2013-05-01','14:45:00',3.68),('8784','2013-05-01','14:50:00',3.19),('8784','2013-05-01','14:55:00',2.94),('8784','2013-05-01','15:00:00',3.16),('8784','2013-05-01','15:05:00',3.58),('8784','2013-05-01','15:10:00',3.63),('8784','2013-05-01','15:15:00',3.45),('8784','2013-05-01','15:20:00',3.39),('8784','2013-05-01','15:25:00',3.38),('8784','2013-05-01','15:30:00',2.78),('8784','2013-05-01','15:35:00',2.48),('8784','2013-05-01','15:40:00',2.49),('8784','2013-05-01','15:45:00',2.44),('8784','2013-05-01','15:50:00',1.83),('8784','2013-05-01','15:55:00',1.83),('8784','2013-05-01','16:00:00',2.17),('8784','2013-05-01','16:05:00',2.07),('8784','2013-05-01','16:10:00',1.88),('8784','2013-05-01','16:15:00',1.74),('8784','2013-05-01','16:20:00',1.52),('8784','2013-05-01','16:25:00',1.22),('8784','2013-05-01','16:30:00',1.13),('8784','2013-05-01','16:35:00',1.18),('8784','2013-05-01','16:40:00',1.25),('8784','2013-05-01','16:45:00',1.18),('8784','2013-05-01','16:50:00',1.04),('8784','2013-05-01','17:10:00',1),('8784','2013-04-30','08:50:00',1.28),('8784','2013-04-30','08:55:00',1.93),('8784','2013-04-30','09:00:00',1.85),('8784','2013-04-30','09:05:00',1.59),('8784','2013-04-30','09:10:00',2.45),('8784','2013-04-30','09:15:00',2.77),('8784','2013-04-30','09:20:00',2.85),('8784','2013-04-30','09:25:00',3.03),('8784','2013-04-30','09:30:00',2.91),('8784','2013-04-30','09:35:00',2.36),('8784','2013-04-30','09:40:00',1.6),('8784','2013-04-30','09:45:00',2.29),('8784','2013-04-30','09:50:00',2.78),('8784','2013-04-30','09:55:00',3.09),('8784','2013-04-30','10:00:00',3.51),('8784','2013-04-30','10:05:00',3.2),('8784','2013-04-30','10:10:00',2.91),('8784','2013-04-30','10:15:00',2.39),('8784','2013-04-30','10:20:00',2.29),('8784','2013-04-30','10:25:00',3.56),('8784','2013-04-30','10:30:00',2.38),('8784','2013-04-30','10:35:00',2),('8784','2013-04-30','10:40:00',1.8),('8784','2013-04-30','10:45:00',1.45),('8784','2013-04-30','10:50:00',1.57),('8784','2013-04-30','10:55:00',1.68),('8784','2013-04-30','11:00:00',1.75),('8784','2013-04-30','11:05:00',1.97),('8784','2013-04-30','11:10:00',1.97),('8784','2013-04-30','11:15:00',2.08),('8784','2013-04-30','11:20:00',2.41),('8784','2013-04-30','11:25:00',2.16),('8784','2013-04-30','11:30:00',2.18),('8784','2013-04-30','11:35:00',2.37),('8784','2013-04-30','11:40:00',2.13),('8784','2013-04-30','11:45:00',1.77),('8784','2013-04-30','11:50:00',1.83),('8784','2013-04-30','11:55:00',1.88),('8784','2013-04-30','12:00:00',1.91),('8784','2013-04-30','12:05:00',1.96),('8784','2013-04-30','12:10:00',1.87),('8784','2013-04-30','12:15:00',1.73),('8784','2013-04-30','12:20:00',1.59),('8784','2013-04-30','12:25:00',1.48),('8784','2013-04-30','12:30:00',1.52),('8784','2013-04-30','12:35:00',2.93),('8784','2013-04-30','12:40:00',4.53),('8784','2013-04-30','12:45:00',4.73),('8784','2013-04-30','12:50:00',4.49),('8784','2013-04-30','12:55:00',4.09),('8784','2013-04-30','13:00:00',4.32),('8784','2013-04-30','13:05:00',4.28),('8784','2013-04-30','13:10:00',4.24),('8784','2013-04-30','13:15:00',4.21),('8784','2013-04-30','13:20:00',4.15),('8784','2013-04-30','13:25:00',4.11),('8784','2013-04-30','13:30:00',4.08),('8784','2013-04-30','13:35:00',4.05),('8784','2013-04-30','13:40:00',4.03),('8784','2013-04-30','13:45:00',3.96),('8784','2013-04-30','13:50:00',3.96),('8784','2013-04-30','13:55:00',3.92),('8784','2013-04-30','14:00:00',3.89),('8784','2013-04-30','14:05:00',3.88),('8784','2013-04-30','14:10:00',3.87),('8784','2013-04-30','14:15:00',3.84),('8784','2013-04-30','14:20:00',3.8),('8784','2013-04-30','14:25:00',3.78),('8784','2013-04-30','14:30:00',3.78),('8784','2013-04-30','14:35:00',3.75),('8784','2013-04-30','14:40:00',3.72),('8784','2013-04-30','14:45:00',3.65),('8784','2013-04-30','14:50:00',3.6),('8784','2013-04-30','14:55:00',3.56),('8784','2013-04-30','15:00:00',3.51),('8784','2013-04-30','15:05:00',3.44),('8784','2013-04-30','15:10:00',3.4),('8784','2013-04-30','15:15:00',3.36),('8784','2013-04-30','15:20:00',3.32),('8784','2013-04-30','15:25:00',3.24),('8784','2013-04-30','15:30:00',3.23),('8784','2013-04-30','15:35:00',3.2),('8784','2013-04-30','15:40:00',3.13),('8784','2013-04-30','15:45:00',3.07),('8784','2013-04-30','15:50:00',3),('8784','2013-04-30','15:55:00',2.94),('8784','2013-04-30','16:00:00',2.89),('8784','2013-04-30','16:05:00',2.83),('8784','2013-04-30','16:10:00',2.79),('8784','2013-04-30','16:15:00',2.72),('8784','2013-04-30','16:20:00',2.66),('8784','2013-04-30','16:25:00',2.61),('8784','2013-04-30','16:30:00',2.55),('8784','2013-04-30','16:35:00',2.3),('8784','2013-04-30','16:40:00',2),('8784','2013-04-30','16:45:00',2.05),('8784','2013-04-30','16:50:00',1.99),('8784','2013-04-30','16:55:00',2.15),('8784','2013-04-30','17:00:00',2.05),('8784','2013-04-30','17:05:00',1.99),('8784','2013-04-30','17:10:00',1.65),('8784','2013-04-30','17:20:00',1.53),('8784','2013-04-30','17:25:00',1.68),('8784','2013-04-30','17:30:00',1.6),('8784','2013-04-30','17:35:00',1.55),('8784','2013-04-30','17:40:00',1.48),('8784','2013-04-30','17:45:00',1.4),('8784','2013-04-30','17:50:00',1.31),('8784','2013-04-30','17:55:00',1.23),('8784','2013-04-30','18:00:00',1.16),('8784','2013-04-30','18:05:00',1.08),('8784','2013-04-30','18:10:00',1.02),('8784','2013-04-29','07:50:00',1),('8784','2013-04-29','07:55:00',1.19),('8784','2013-04-29','08:00:00',1.36),('8784','2013-04-29','08:05:00',1.44),('8784','2013-04-29','08:10:00',1.38),('8784','2013-04-29','08:15:00',1.43),('8784','2013-04-29','08:20:00',1.53),('8784','2013-04-29','08:25:00',1.75),('8784','2013-04-29','08:30:00',1.98),('8784','2013-04-29','08:35:00',2.22),('8784','2013-04-29','08:40:00',2.22),('8784','2013-04-29','08:45:00',2.17),('8784','2013-04-29','08:50:00',2.3),('8784','2013-04-29','08:55:00',2.23),('8784','2013-04-29','09:00:00',1.83),('8784','2013-04-29','09:05:00',2.6),('8784','2013-04-29','09:10:00',2.68),('8784','2013-04-29','09:15:00',2.81),('8784','2013-04-29','09:20:00',2.61),('8784','2013-04-29','09:25:00',2.55),('8784','2013-04-29','09:30:00',2.61),('8784','2013-04-29','09:35:00',2.74),('8784','2013-04-29','09:40:00',2.78),('8784','2013-04-29','09:45:00',2.83),('8784','2013-04-29','09:50:00',2.98),('8784','2013-04-29','09:55:00',2.83),('8784','2013-04-29','10:00:00',2.96),('8784','2013-04-29','10:05:00',2.93),('8784','2013-04-29','10:10:00',2.88),('8784','2013-04-29','10:15:00',2.36),('8784','2013-04-29','10:20:00',2.49),('8784','2013-04-29','10:25:00',2.89),('8784','2013-04-29','10:30:00',3.1),('8784','2013-04-29','10:35:00',3.34),('8784','2013-04-29','10:40:00',3.42),('8784','2013-04-29','10:45:00',3.44),('8784','2013-04-29','10:50:00',3.34),('8784','2013-04-29','10:55:00',3.12),('8784','2013-04-29','11:00:00',3.54),('8784','2013-04-29','11:05:00',3.29),('8784','2013-04-29','11:10:00',3.21),('8784','2013-04-29','11:15:00',3.1),('8784','2013-04-29','11:20:00',3.64),('8784','2013-04-29','11:25:00',3.68),('8784','2013-04-29','11:30:00',3.84),('8784','2013-04-29','11:35:00',3.64),('8784','2013-04-29','11:40:00',3.74),('8784','2013-04-29','11:45:00',3.56),('8784','2013-04-29','11:50:00',4.01),('8784','2013-04-29','11:55:00',3.93),('8784','2013-04-29','12:00:00',4.05),('8784','2013-04-29','12:05:00',3.98),('8784','2013-04-29','12:10:00',3.91),('8784','2013-04-29','12:15:00',3.97),('8784','2013-04-29','12:20:00',3.95),('8784','2013-04-29','12:25:00',3.88),('8784','2013-04-29','12:30:00',3.99),('8784','2013-04-29','12:35:00',4.04),('8784','2013-04-29','12:40:00',4.07),('8784','2013-04-29','12:45:00',4.08),('8784','2013-04-29','12:50:00',4.02),('8784','2013-04-29','12:55:00',4.04),('8784','2013-04-29','13:00:00',4.13),('8784','2013-04-29','13:05:00',4.04),('8784','2013-04-29','13:10:00',3.91),('8784','2013-04-29','13:15:00',3.49),('8784','2013-04-29','13:20:00',3.99),('8784','2013-04-29','13:25:00',4.17),('8784','2013-04-29','13:30:00',4.02),('8784','2013-04-29','13:35:00',3.87),('8784','2013-04-29','13:40:00',4),('8784','2013-04-29','13:45:00',3.99),('8784','2013-04-29','13:50:00',3.8),('8784','2013-04-29','13:55:00',4.3),('8784','2013-04-29','14:00:00',3.9),('8784','2013-04-29','14:05:00',3.83),('8784','2013-04-29','14:10:00',3.95),('8784','2013-04-29','14:15:00',4.04),('8784','2013-04-29','14:20:00',4.07),('8784','2013-04-29','14:25:00',3.84),('8784','2013-04-29','14:30:00',3.68),('8784','2013-04-29','14:35:00',3.63),('8784','2013-04-29','14:40:00',3.43),('8784','2013-04-29','14:45:00',3.69),('8784','2013-04-29','14:50:00',3.65),('8784','2013-04-29','14:55:00',3.66),('8784','2013-04-29','15:00:00',3.58),('8784','2013-04-29','15:05:00',3.65),('8784','2013-04-29','15:10:00',3.26),('8784','2013-04-29','15:15:00',3.24),('8784','2013-04-29','15:20:00',3.48),('8784','2013-04-29','15:25:00',3.57),('8784','2013-04-29','15:30:00',3.46),('8784','2013-04-29','15:35:00',3),('8784','2013-04-29','15:40:00',2.78),('8784','2013-04-29','15:45:00',2.71),('8784','2013-04-29','15:50:00',2.83),('8784','2013-04-29','15:55:00',2.98),('8784','2013-04-29','16:00:00',2.92),('8784','2013-04-29','16:05:00',3.13),('8784','2013-04-29','16:10:00',3.01),('8784','2013-04-29','16:15:00',3.51),('8784','2013-04-29','16:20:00',3.2),('8784','2013-04-29','16:25:00',2.56),('8784','2013-04-29','16:30:00',2.64),('8784','2013-04-29','16:35:00',2.68),('8784','2013-04-29','16:40:00',2.78),('8784','2013-04-29','16:45:00',2.78),('8784','2013-04-29','16:50:00',2.86),('8784','2013-04-29','16:55:00',2.93),('8784','2013-04-29','17:00:00',2.69),('8784','2013-04-29','17:05:00',2.33),('8784','2013-04-29','17:10:00',2.38),('8784','2013-04-29','17:15:00',2.01),('8784','2013-04-29','17:20:00',1.72),('8784','2013-04-29','17:25:00',1.6),('8784','2013-04-29','17:30:00',1.58),('8784','2013-04-29','17:35:00',1.46),('8784','2013-04-29','17:40:00',1.24),('8784','2013-04-29','17:45:00',1.15),('8784','2013-04-29','17:50:00',1.43),('8784','2013-04-29','17:55:00',1.6),('8784','2013-04-29','18:00:00',1.55),('8784','2013-04-29','18:05:00',1.73),('8784','2013-04-29','18:10:00',1.55),('8784','2013-04-29','18:15:00',1.45),('8784','2013-04-29','18:20:00',1.24),('8784','2013-04-29','18:25:00',1.19),('8784','2013-04-29','18:30:00',1.09),('8784','2013-04-28','07:40:00',1.05),('8784','2013-04-28','07:45:00',1.14),('8784','2013-04-28','07:50:00',1.23),('8784','2013-04-28','07:55:00',1.29),('8784','2013-04-28','08:00:00',1.35),('8784','2013-04-28','08:05:00',1.47),('8784','2013-04-28','08:10:00',1.58),('8784','2013-04-28','08:15:00',1.67),('8784','2013-04-28','08:20:00',1.77),('8784','2013-04-28','08:25:00',1.87),('8784','2013-04-28','08:30:00',1.92),('8784','2013-04-28','08:35:00',2.01),('8784','2013-04-28','08:40:00',2.09),('8784','2013-04-28','08:45:00',2.17),('8784','2013-04-28','08:50:00',2.25),('8784','2013-04-28','08:55:00',2.33),('8784','2013-04-28','09:00:00',2.41),('8784','2013-04-28','09:05:00',2.49),('8784','2013-04-28','09:10:00',2.58),('8784','2013-04-28','09:15:00',2.65),('8784','2013-04-28','09:20:00',2.73),('8784','2013-04-28','09:25:00',2.81),('8784','2013-04-28','09:30:00',2.88),('8784','2013-04-28','09:35:00',2.95),('8784','2013-04-28','09:40:00',3.01),('8784','2013-04-28','09:45:00',3.09),('8784','2013-04-28','09:50:00',3.16),('8784','2013-04-28','09:55:00',3.22),('8784','2013-04-28','10:00:00',3.28),('8784','2013-04-28','10:05:00',3.3),('8784','2013-04-28','10:10:00',3.35),('8784','2013-04-28','10:15:00',3.41),('8784','2013-04-28','10:20:00',3.47),('8784','2013-04-28','10:25:00',3.59),('8784','2013-04-28','10:30:00',3.51),('8784','2013-04-28','10:35:00',3.59),('8784','2013-04-28','10:40:00',3.32),('8784','2013-04-28','10:45:00',3.76),('8784','2013-04-28','10:50:00',3.78),('8784','2013-04-28','10:55:00',3.82),('8784','2013-04-28','11:00:00',3.85),('8784','2013-04-28','11:05:00',3.88),('8784','2013-04-28','11:10:00',3.95),('8784','2013-04-28','11:15:00',3.99),('8784','2013-04-28','11:20:00',3.97),('8784','2013-04-28','11:25:00',4.03),('8784','2013-04-28','11:30:00',4.01),('8784','2013-04-28','11:35:00',3.94),('8784','2013-04-28','11:40:00',4),('8784','2013-04-28','11:45:00',3.86),('8784','2013-04-28','11:50:00',3.82),('8784','2013-04-28','11:55:00',4.05),('8784','2013-04-28','12:00:00',3.55),('8784','2013-04-28','12:05:00',3.54),('8784','2013-04-28','12:10:00',3.92),('8784','2013-04-28','12:15:00',3.99),('8784','2013-04-28','12:20:00',4),('8784','2013-04-28','12:25:00',3.58),('8784','2013-04-28','12:30:00',3.38),('8784','2013-04-28','12:35:00',3.18),('8784','2013-04-28','12:40:00',3.21),('8784','2013-04-28','12:45:00',4.18),('8784','2013-04-28','12:50:00',4.16),('8784','2013-04-28','12:55:00',3.92),('8784','2013-04-28','13:00:00',4.05),('8784','2013-04-28','13:05:00',4.34),('8784','2013-04-28','13:10:00',4.22),('8784','2013-04-28','13:15:00',3.91),('8784','2013-04-28','13:20:00',4.03),('8784','2013-04-28','13:25:00',3.83),('8784','2013-04-28','13:30:00',4.19),('8784','2013-04-28','13:35:00',4.02),('8784','2013-04-28','13:40:00',2.73),('8784','2013-04-28','13:45:00',1.57),('8784','2013-04-28','13:50:00',2.06),('8784','2013-04-28','13:55:00',1.6),('8784','2013-04-28','14:00:00',2.51),('8784','2013-04-28','14:05:00',3.54),('8784','2013-04-28','14:10:00',3.97),('8784','2013-04-28','14:15:00',3.79),('8784','2013-04-28','14:20:00',3.28),('8784','2013-04-28','14:25:00',3.87),('8784','2013-04-28','14:30:00',3.97),('8784','2013-04-28','14:35:00',3.98),('8784','2013-04-28','14:40:00',3.91),('8784','2013-04-28','14:45:00',3.85),('8784','2013-04-28','14:50:00',3.82),('8784','2013-04-28','14:55:00',3.75),('8784','2013-04-28','15:00:00',3.75),('8784','2013-04-28','15:05:00',3.73),('8784','2013-04-28','15:10:00',3.68),('8784','2013-04-28','15:15:00',3.61),('8784','2013-04-28','15:20:00',3.57),('8784','2013-04-28','15:25:00',3.51),('8784','2013-04-28','15:30:00',3.46),('8784','2013-04-28','15:35:00',3.41),('8784','2013-04-28','15:40:00',3.35),('8784','2013-04-28','15:45:00',3.31),('8784','2013-04-28','15:50:00',3.27),('8784','2013-04-28','15:55:00',3.2),('8784','2013-04-28','16:00:00',3.15),('8784','2013-04-28','16:05:00',3.09),('8784','2013-04-28','16:10:00',3.02),('8784','2013-04-28','16:15:00',2.97),('8784','2013-04-28','16:20:00',2.9),('8784','2013-04-28','16:25:00',2.84),('8784','2013-04-28','16:30:00',2.77),('8784','2013-04-28','16:35:00',2.7),('8784','2013-04-28','16:40:00',2.61),('8784','2013-04-28','16:45:00',2.56),('8784','2013-04-28','16:50:00',2.49),('8784','2013-04-28','16:55:00',2.4),('8784','2013-04-28','17:00:00',2.33),('8784','2013-04-28','17:05:00',2.14),('8784','2013-04-28','17:10:00',2.07),('8784','2013-04-28','17:15:00',2.14),('8784','2013-04-28','17:20:00',2.02),('8784','2013-04-28','17:25:00',1.97),('8784','2013-04-28','17:30:00',1.68),('8784','2013-04-28','17:35:00',1.68),('8784','2013-04-28','17:40:00',1.58),('8784','2013-04-28','17:45:00',1.6),('8784','2013-04-28','17:50:00',1.52),('8784','2013-04-28','17:55:00',1.34),('8784','2013-04-28','18:00:00',1.32),('8784','2013-04-28','18:05:00',1.24),('8784','2013-04-28','18:20:00',1.06),('8784','2013-04-28','18:25:00',1),('8784','2013-04-27','12:50:00',1.11),('8784','2013-04-27','12:55:00',1.45),('8784','2013-04-27','13:00:00',1.56),('8784','2013-04-27','13:05:00',1.18),('8784','2013-04-27','13:10:00',1.27),('8784','2013-04-27','13:15:00',1.65),('8784','2013-04-27','13:20:00',1.73),('8784','2013-04-27','13:25:00',1.24),('8784','2013-04-27','13:30:00',1.36),('8784','2013-04-27','13:35:00',1.67),('8784','2013-04-27','13:40:00',1.89),('8784','2013-04-27','13:45:00',1.28),('8784','2013-04-27','13:50:00',1.23),('8784','2013-04-27','14:25:00',1.39),('8784','2013-04-27','14:30:00',2.35),('8784','2013-04-27','14:35:00',1.98),('8784','2013-04-27','14:40:00',1.42),('8784','2013-04-27','14:45:00',1.24),('8784','2013-04-27','15:00:00',1.15),('8784','2013-04-27','15:05:00',1.88),('8784','2013-04-27','15:10:00',1.44),('8784','2013-04-27','15:15:00',1.11),('8784','2013-04-27','16:40:00',1.1),('8784','2013-04-27','16:45:00',1.55),('8784','2013-04-27','16:50:00',1.97),('8784','2013-04-27','16:55:00',2.25),('8784','2013-04-27','17:00:00',2.59),('8784','2013-04-27','17:05:00',1.67),('8784','2013-04-27','17:20:00',1.18),('8784','2013-04-27','17:40:00',1.28),('8784','2013-04-27','17:45:00',1.1),('8784','2013-04-26','08:05:00',1.11),('8784','2013-04-26','08:10:00',1.34),('8784','2013-04-26','08:15:00',1.46),('8784','2013-04-26','08:20:00',1.53),('8784','2013-04-26','08:25:00',1.58),('8784','2013-04-26','08:30:00',1.66),('8784','2013-04-26','08:35:00',1.79),('8784','2013-04-26','08:40:00',1.84),('8784','2013-04-26','08:45:00',1.94),('8784','2013-04-26','08:50:00',1.66),('8784','2013-04-26','08:55:00',1.48),('8784','2013-04-26','09:00:00',1.52),('8784','2013-04-26','09:05:00',2.2),('8784','2013-04-26','09:10:00',1.82),('8784','2013-04-26','09:15:00',1.29),('8784','2013-04-26','09:20:00',1.3),('8784','2013-04-26','09:25:00',1.86),('8784','2013-04-26','09:30:00',2.17),('8784','2013-04-26','09:35:00',1.92),('8784','2013-04-26','09:40:00',2.02),('8784','2013-04-26','09:45:00',2.58),('8784','2013-04-26','09:50:00',2.95),('8784','2013-04-26','09:55:00',1.89),('8784','2013-04-26','10:00:00',2.71),('8784','2013-04-26','10:05:00',3.21),('8784','2013-04-26','10:10:00',3.19),('8784','2013-04-26','10:15:00',3.33),('8784','2013-04-26','10:20:00',3.15),('8784','2013-04-26','10:25:00',3.19),('8784','2013-04-26','10:30:00',3.4),('8784','2013-04-26','10:35:00',3.62),('8784','2013-04-26','10:40:00',3.47),('8784','2013-04-26','10:45:00',3.49),('8784','2013-04-26','10:50:00',2.61),('8784','2013-04-26','10:55:00',1.93),('8784','2013-04-26','11:00:00',3.43),('8784','2013-04-26','11:05:00',3.56),('8784','2013-04-26','11:10:00',3.38),('8784','2013-04-26','11:15:00',3.15),('8784','2013-04-26','11:20:00',2.55),('8784','2013-04-26','11:25:00',3.27),('8784','2013-04-26','11:30:00',3.26),('8784','2013-04-26','11:35:00',3.75),('8784','2013-04-26','11:40:00',3.01),('8784','2013-04-26','11:45:00',3.27),('8784','2013-04-26','11:50:00',2.7),('8784','2013-04-26','11:55:00',2.64),('8784','2013-04-26','12:00:00',3.12),('8784','2013-04-26','12:05:00',2.76),('8784','2013-04-26','12:10:00',2.63),('8784','2013-04-26','12:15:00',2.93),('8784','2013-04-26','12:20:00',2.82),('8784','2013-04-26','12:25:00',1.93),('8784','2013-04-26','12:30:00',1.91),('8784','2013-04-26','12:35:00',2.57),('8784','2013-04-26','12:40:00',3.24),('8784','2013-04-26','12:45:00',3.06),('8784','2013-04-26','12:50:00',2.26),('8784','2013-04-26','12:55:00',2.01),('8784','2013-04-26','13:00:00',1.45),('8784','2013-04-26','13:05:00',1.41),('8784','2013-04-26','13:10:00',1.75),('8784','2013-04-26','13:15:00',2.68),('8784','2013-04-26','13:20:00',1.9),('8784','2013-04-26','13:25:00',2.26),('8784','2013-04-26','13:30:00',3.31),('8784','2013-04-26','13:35:00',2.55),('8784','2013-04-26','13:40:00',2.98),('8784','2013-04-26','13:45:00',2.38),('8784','2013-04-26','13:50:00',3.44),('8784','2013-04-26','13:55:00',2.6),('8784','2013-04-26','14:00:00',2.93),('8784','2013-04-26','14:05:00',3.68),('8784','2013-04-26','14:10:00',3.2),('8784','2013-04-26','14:15:00',3.26),('8784','2013-04-26','14:20:00',3.65),('8784','2013-04-26','14:25:00',3.92),('8784','2013-04-26','14:30:00',3.95),('8784','2013-04-26','14:35:00',2.68),('8784','2013-04-26','14:40:00',1.78),('8784','2013-04-26','14:45:00',1.65),('8784','2013-04-26','14:50:00',3.98),('8784','2013-04-26','14:55:00',4.09),('8784','2013-04-26','15:00:00',3.75),('8784','2013-04-26','15:05:00',2.31),('8784','2013-04-26','15:10:00',1.64),('8784','2013-04-26','15:15:00',2.18),('8784','2013-04-26','15:20:00',1.55),('8784','2013-04-26','15:25:00',1.71),('8784','2013-04-26','15:30:00',2.46),('8784','2013-04-26','15:35:00',1.98),('8784','2013-04-26','15:40:00',2.12),('8784','2013-04-26','15:45:00',2.52),('8784','2013-04-26','15:50:00',1.94),('8784','2013-04-26','15:55:00',1.16),('8784','2013-04-25','08:05:00',1.17),('8784','2013-04-25','08:10:00',1.19),('8784','2013-04-25','08:15:00',1.54),('8784','2013-04-25','08:20:00',1.2),('8784','2013-04-25','08:25:00',1.03),('8784','2013-04-25','08:30:00',1.08),('8784','2013-04-25','08:35:00',1.12),('8784','2013-04-25','08:40:00',1.19),('8784','2013-04-25','08:45:00',1.57),('8784','2013-04-25','08:50:00',2.38),('8784','2013-04-25','08:55:00',2.54),('8784','2013-04-25','09:00:00',1.98),('8784','2013-04-25','09:05:00',1.5),('8784','2013-04-25','09:10:00',1.49),('8784','2013-04-25','09:15:00',1.34),('8784','2013-04-25','09:20:00',1.48),('8784','2013-04-25','09:25:00',1.61),('8784','2013-04-25','09:30:00',1.48),('8784','2013-04-25','09:35:00',1.7),('8784','2013-04-25','09:40:00',2.35),('8784','2013-04-25','09:45:00',2.88),('8784','2013-04-25','09:50:00',3.23),('8784','2013-04-25','09:55:00',3.27),('8784','2013-04-25','10:00:00',3.26),('8784','2013-04-25','10:05:00',3.08),('8784','2013-04-25','10:10:00',2.85),('8784','2013-04-25','10:15:00',3.01),('8784','2013-04-25','10:20:00',3.31),('8784','2013-04-25','10:25:00',3.45),('8784','2013-04-25','10:30:00',3.61),('8784','2013-04-25','10:35:00',3.62),('8784','2013-04-25','10:40:00',3.6),('8784','2013-04-25','10:45:00',3.46),('8784','2013-04-25','10:50:00',3.72),('8784','2013-04-25','10:55:00',3.62),('8784','2013-04-25','11:00:00',3.83),('8784','2013-04-25','11:05:00',3.83),('8784','2013-04-25','11:10:00',3.87),('8784','2013-04-25','11:15:00',3.9),('8784','2013-04-25','11:20:00',3.96),('8784','2013-04-25','11:25:00',3.99),('8784','2013-04-25','11:30:00',4.03),('8784','2013-04-25','11:35:00',3.98),('8784','2013-04-25','11:40:00',4.1),('8784','2013-04-25','11:45:00',4.14),('8784','2013-04-25','11:50:00',4.16),('8784','2013-04-25','11:55:00',4.12),('8784','2013-04-25','12:00:00',4.01),('8784','2013-04-25','12:05:00',4.08),('8784','2013-04-25','12:10:00',4.17),('8784','2013-04-25','12:15:00',4.21),('8784','2013-04-25','12:20:00',4.19),('8784','2013-04-25','12:25:00',4.19),('8784','2013-04-25','12:30:00',4.21),('8784','2013-04-25','12:35:00',4.22),('8784','2013-04-25','12:40:00',4.2),('8784','2013-04-25','12:45:00',4.22),('8784','2013-04-25','12:50:00',4.2),('8784','2013-04-25','12:55:00',4.23),('8784','2013-04-25','13:00:00',4.28),('8784','2013-04-25','13:05:00',4.35),('8784','2013-04-25','13:10:00',4.13),('8784','2013-04-25','13:15:00',4.18),('8784','2013-04-25','13:20:00',3.85),('8784','2013-04-25','13:25:00',3.59),('8784','2013-04-25','13:30:00',2.77),('8784','2013-04-25','13:35:00',2.74),('8784','2013-04-25','13:40:00',2.5),('8784','2013-04-25','13:45:00',2.35),('8784','2013-04-25','13:50:00',2.26),('8784','2013-04-25','13:55:00',2.43),('8784','2013-04-25','14:00:00',2.46),('8784','2013-04-25','14:05:00',2.3),('8784','2013-04-25','14:10:00',2.47),('8784','2013-04-25','14:15:00',2.64),('8784','2013-04-25','14:20:00',2.69),('8784','2013-04-25','14:25:00',2.82),('8784','2013-04-25','14:30:00',3.3),('8784','2013-04-25','14:35:00',3.67),('8784','2013-04-25','14:40:00',3.53),('8784','2013-04-25','14:45:00',3.56),('8784','2013-04-25','14:50:00',3.25),('8784','2013-04-25','14:55:00',3.37),('8784','2013-04-25','15:00:00',3.2),('8784','2013-04-25','15:05:00',2.91),('8784','2013-04-25','15:10:00',2.93),('8784','2013-04-25','15:15:00',3.31),('8784','2013-04-25','15:20:00',3.52),('8784','2013-04-25','15:25:00',3.6),('8784','2013-04-25','15:30:00',3.49),('8784','2013-04-25','15:35:00',3.31),('8784','2013-04-25','15:40:00',3.04),('8784','2013-04-25','15:45:00',2.95),('8784','2013-04-25','15:50:00',2.73),('8784','2013-04-25','15:55:00',2.68),('8784','2013-04-25','16:00:00',2.68),('8784','2013-04-25','16:05:00',2.28),('8784','2013-04-25','16:10:00',2.29),('8784','2013-04-25','16:15:00',2.26),('8784','2013-04-25','16:20:00',2.38),('8784','2013-04-25','16:25:00',2.07),('8784','2013-04-25','16:30:00',2.05),('8784','2013-04-25','16:35:00',2.45),('8784','2013-04-25','16:40:00',2.15),('8784','2013-04-25','16:45:00',2.15),('8784','2013-04-25','16:50:00',1.86),('8784','2013-04-25','16:55:00',1.98),('8784','2013-04-25','17:00:00',1.89),('8784','2013-04-25','17:05:00',2.33),('8784','2013-04-25','17:10:00',2.43),('8784','2013-04-25','17:15:00',2.24),('8784','2013-04-25','17:20:00',2.2),('8784','2013-04-25','17:25:00',1.84),('8784','2013-04-25','17:30:00',1.48),('8784','2013-04-25','17:35:00',1.43),('8784','2013-04-25','17:40:00',1.45),('8784','2013-04-25','17:45:00',1.24),('8784','2013-04-25','17:50:00',1.04),('8784','2013-04-24','07:50:00',1.09),('8784','2013-04-24','07:55:00',1.2),('8784','2013-04-24','08:00:00',1.23),('8784','2013-04-24','08:05:00',1.3),('8784','2013-04-24','08:10:00',1.47),('8784','2013-04-24','08:15:00',1.67),('8784','2013-04-24','08:20:00',1.72),('8784','2013-04-24','08:25:00',1.85),('8784','2013-04-24','08:30:00',1.82),('8784','2013-04-24','08:35:00',1.77),('8784','2013-04-24','08:40:00',1.83),('8784','2013-04-24','08:45:00',1.89),('8784','2013-04-24','08:50:00',1.99),('8784','2013-04-24','08:55:00',2.07),('8784','2013-04-24','09:00:00',2.31),('8784','2013-04-24','09:05:00',2.53),('8784','2013-04-24','09:10:00',2.63),('8784','2013-04-24','09:15:00',2.26),('8784','2013-04-24','09:20:00',2.01),('8784','2013-04-24','09:25:00',2.7),('8784','2013-04-24','09:30:00',2.82),('8784','2013-04-24','09:35:00',2.99),('8784','2013-04-24','09:40:00',2.85),('8784','2013-04-24','09:45:00',2.85),('8784','2013-04-24','09:50:00',2.97),('8784','2013-04-24','09:55:00',3.28),('8784','2013-04-24','10:00:00',3.39),('8784','2013-04-24','10:05:00',3.48),('8784','2013-04-24','10:10:00',3.53),('8784','2013-04-24','10:15:00',3.5),('8784','2013-04-24','10:20:00',3.42),('8784','2013-04-24','10:25:00',3.39),('8784','2013-04-24','10:30:00',3.34),('8784','2013-04-24','10:35:00',3.37),('8784','2013-04-24','10:40:00',3.74),('8784','2013-04-24','10:45:00',3.75),('8784','2013-04-24','10:50:00',3.81),('8784','2013-04-24','10:55:00',3.94),('8784','2013-04-24','11:00:00',3.92),('8784','2013-04-24','11:05:00',3.86),('8784','2013-04-24','11:10:00',4.18),('8784','2013-04-24','11:15:00',4.19),('8784','2013-04-24','11:20:00',4.32),('8784','2013-04-24','11:25:00',4.27),('8784','2013-04-24','11:30:00',4.17),('8784','2013-04-24','11:35:00',3.78),('8784','2013-04-24','11:40:00',3.01),('8784','2013-04-24','11:45:00',2.83),('8784','2013-04-24','11:50:00',2.17),('8784','2013-04-24','11:55:00',3.19),('8784','2013-04-24','12:00:00',3.53),('8784','2013-04-24','12:05:00',2.51),('8784','2013-04-24','12:10:00',3.08),('8784','2013-04-24','12:15:00',4.16),('8784','2013-04-24','12:20:00',4.76),('8784','2013-04-24','12:25:00',4.07),('8784','2013-04-24','12:30:00',4.02),('8784','2013-04-24','12:35:00',4.14),('8784','2013-04-24','12:40:00',3.94),('8784','2013-04-24','12:45:00',4.07),('8784','2013-04-24','12:50:00',4.3),('8784','2013-04-24','12:55:00',4.16),('8784','2013-04-24','13:00:00',4.04),('8784','2013-04-24','13:05:00',3.59),('8784','2013-04-24','13:10:00',4.62),('8784','2013-04-24','13:15:00',4.29),('8784','2013-04-24','13:20:00',4.02),('8784','2013-04-24','13:25:00',4.21),('8784','2013-04-24','13:30:00',3.81),('8784','2013-04-24','13:35:00',4.18),('8784','2013-04-24','13:40:00',4.55),('8784','2013-04-24','13:45:00',3.8),('8784','2013-04-24','13:50:00',2.94),('8784','2013-04-24','13:55:00',4.4),('8784','2013-04-24','14:00:00',4.22),('8784','2013-04-24','14:05:00',3.02),('8784','2013-04-24','14:10:00',3.15),('8784','2013-04-24','14:15:00',4.21),('8784','2013-04-24','14:20:00',3.87),('8784','2013-04-24','14:25:00',3.97),('8784','2013-04-24','14:30:00',3.7),('8784','2013-04-24','14:35:00',3.38),('8784','2013-04-24','14:40:00',3.17),('8784','2013-04-24','14:45:00',3.12),('8784','2013-04-24','14:50:00',2.81),('8784','2013-04-24','14:55:00',2.46),('8784','2013-04-24','15:00:00',2.7),('8784','2013-04-24','15:05:00',2.48),('8784','2013-04-24','15:10:00',2.3),('8784','2013-04-24','15:15:00',2.45),('8784','2013-04-24','15:20:00',2.64),('8784','2013-04-24','15:25:00',2.18),('8784','2013-04-24','15:30:00',1.9),('8784','2013-04-24','15:35:00',1.84),('8784','2013-04-24','15:40:00',1.81),('8784','2013-04-24','15:45:00',1.82),('8784','2013-04-24','15:50:00',1.85),('8784','2013-04-24','15:55:00',2.35),('8784','2013-04-24','16:00:00',2.84),('8784','2013-04-24','16:05:00',2.95),('8784','2013-04-24','16:10:00',2.87),('8784','2013-04-24','16:15:00',2.71),('8784','2013-04-24','16:20:00',3.4),('8784','2013-04-24','16:25:00',2.62),('8784','2013-04-24','16:30:00',2.24),('8784','2013-04-24','16:35:00',2),('8784','2013-04-24','16:40:00',2.63),('8784','2013-04-24','16:45:00',2.66),('8784','2013-04-24','16:50:00',2.46),('8784','2013-04-24','16:55:00',2.86),('8784','2013-04-24','17:00:00',2.85),('8784','2013-04-24','17:05:00',2.66),('8784','2013-04-24','17:10:00',2.5),('8784','2013-04-24','17:15:00',1.83),('8784','2013-04-24','17:20:00',1.85),('8784','2013-04-24','17:25:00',1.58),('8784','2013-04-24','17:30:00',1.04),('8784','2013-04-24','17:50:00',1.15),('8784','2013-04-24','17:55:00',1.49),('8784','2013-04-24','18:00:00',1.15),('8784','2013-04-24','18:05:00',1.22),('8784','2013-04-24','18:20:00',1.01),('8784','2013-04-23','07:40:00',1.09),('8784','2013-04-23','07:45:00',1.17),('8784','2013-04-23','07:50:00',1.26),('8784','2013-04-23','07:55:00',1.35),('8784','2013-04-23','08:00:00',1.43),('8784','2013-04-23','08:05:00',1.52),('8784','2013-04-23','08:10:00',1.62),('8784','2013-04-23','08:15:00',1.7),('8784','2013-04-23','08:20:00',1.8),('8784','2013-04-23','08:25:00',1.9),('8784','2013-04-23','08:30:00',1.98),('8784','2013-04-23','08:35:00',2.08),('8784','2013-04-23','08:40:00',2.16),('8784','2013-04-23','08:45:00',2.25),('8784','2013-04-23','08:50:00',2.34),('8784','2013-04-23','08:55:00',2.43),('8784','2013-04-23','09:00:00',2.49),('8784','2013-04-23','09:05:00',2.57),('8784','2013-04-23','09:10:00',2.66),('8784','2013-04-23','09:15:00',2.76),('8784','2013-04-23','09:20:00',2.84),('8784','2013-04-23','09:25:00',2.93),('8784','2013-04-23','09:30:00',3),('8784','2013-04-23','09:35:00',3.08),('8784','2013-04-23','09:40:00',2.85),('8784','2013-04-23','09:45:00',2.81),('8784','2013-04-23','09:50:00',3.34),('8784','2013-04-23','09:55:00',3.38),('8784','2013-04-23','10:00:00',3.42),('8784','2013-04-23','10:05:00',3.48),('8784','2013-04-23','10:10:00',3.53),('8784','2013-04-23','10:15:00',3.57),('8784','2013-04-23','10:20:00',3.6),('8784','2013-04-23','10:25:00',3.66),('8784','2013-04-23','10:30:00',3.74),('8784','2013-04-23','10:35:00',3.8),('8784','2013-04-23','10:40:00',3.84),('8784','2013-04-23','10:45:00',3.79),('8784','2013-04-23','10:50:00',3.94),('8784','2013-04-23','10:55:00',4),('8784','2013-04-23','11:00:00',4.01),('8784','2013-04-23','11:05:00',4.03),('8784','2013-04-23','11:10:00',4.06),('8784','2013-04-23','11:15:00',4.09),('8784','2013-04-23','11:20:00',4.15),('8784','2013-04-23','11:25:00',4.16),('8784','2013-04-23','11:30:00',4.16),('8784','2013-04-23','11:35:00',4.2),('8784','2013-04-23','11:40:00',4.22),('8784','2013-04-23','11:45:00',4.21),('8784','2013-04-23','11:50:00',4.18),('8784','2013-04-23','11:55:00',4.2),('8784','2013-04-23','12:00:00',4.22),('8784','2013-04-23','12:05:00',4.26),('8784','2013-04-23','12:10:00',4.28),('8784','2013-04-23','12:15:00',4.25),('8784','2013-04-23','12:20:00',4.33),('8784','2013-04-23','12:25:00',4.38),('8784','2013-04-23','12:30:00',4.56),('8784','2013-04-23','12:35:00',4.82),('8784','2013-04-23','12:40:00',4.97),('8784','2013-04-23','12:45:00',3.86),('8784','2013-04-23','12:50:00',1.91),('8784','2013-04-23','12:55:00',5.14),('8784','2013-04-23','13:00:00',5.13),('8784','2013-04-23','13:05:00',4.46),('8784','2013-04-23','13:10:00',2.15),('8784','2013-04-23','13:15:00',3.62),('8784','2013-04-23','13:20:00',4.74),('8784','2013-04-23','13:25:00',4.63),('8784','2013-04-23','13:30:00',4.52),('8784','2013-04-23','13:35:00',4.61),('8784','2013-04-23','13:40:00',4.56),('8784','2013-04-23','13:45:00',3.2),('8784','2013-04-23','13:50:00',4.16),('8784','2013-04-23','13:55:00',4.51),('8784','2013-04-23','14:00:00',4.01),('8784','2013-04-23','14:05:00',4.61),('8784','2013-04-23','14:10:00',4.13),('8784','2013-04-23','14:15:00',4.03),('8784','2013-04-23','14:20:00',3.96),('8784','2013-04-23','14:25:00',3.66),('8784','2013-04-23','14:30:00',4.28),('8784','2013-04-23','14:35:00',4.06),('8784','2013-04-23','14:40:00',4.09),('8784','2013-04-23','14:45:00',3.5),('8784','2013-04-23','14:50:00',2.22),('8784','2013-04-23','14:55:00',2.42),('8784','2013-04-23','15:00:00',2.48),('8784','2013-04-23','15:05:00',2.63),('8784','2013-04-23','15:10:00',3.22),('8784','2013-04-23','15:15:00',3.12),('8784','2013-04-23','15:20:00',2.87),('8784','2013-04-23','15:25:00',2.61),('8784','2013-04-23','15:30:00',2.6),('8784','2013-04-23','15:35:00',2.46),('8784','2013-04-23','15:40:00',2.52),('8784','2013-04-23','15:45:00',2.72),('8784','2013-04-23','15:50:00',2.1),('8784','2013-04-23','15:55:00',1.92),('8784','2013-04-23','16:00:00',2.29),('8784','2013-04-23','16:05:00',2.49),('8784','2013-04-23','16:10:00',2.52),('8784','2013-04-23','16:15:00',2.24),('8784','2013-04-23','16:20:00',1.43),('8784','2013-04-23','16:25:00',1.47),('8784','2013-04-23','16:30:00',1.26),('8784','2013-04-23','16:35:00',1.2),('8784','2013-04-23','16:40:00',1.18),('8784','2013-04-23','16:45:00',1.26),('8784','2013-04-23','16:50:00',1.08),('8784','2013-04-23','16:55:00',1.12),('8784','2013-04-23','17:00:00',1.18),('8784','2013-04-23','17:05:00',1.23),('8784','2013-04-23','17:10:00',2.04),('8784','2013-04-23','17:15:00',1.25),('8784','2013-04-23','17:20:00',1.03),('8784','2013-04-23','17:25:00',1.76),('8784','2013-04-23','17:30:00',1.56),('8784','2013-04-23','17:35:00',1.14),('8784','2013-04-22','09:30:00',1.26),('8784','2013-04-22','09:35:00',1.13),('8784','2013-04-22','10:35:00',2.2),('8784','2013-04-22','10:40:00',3.53),('8784','2013-04-22','10:45:00',4.74),('8784','2013-04-22','10:50:00',2.53),('8784','2013-04-22','10:55:00',2.51),('8784','2013-04-22','11:00:00',2.22),('8784','2013-04-22','11:05:00',1.92),('8784','2013-04-22','11:10:00',2.47),('8784','2013-04-22','11:15:00',1.51),('8784','2013-04-22','11:20:00',1.57),('8784','2013-04-22','11:25:00',2.08),('8784','2013-04-22','11:30:00',3.11),('8784','2013-04-22','11:35:00',4.52),('8784','2013-04-22','11:40:00',3.6),('8784','2013-04-22','11:45:00',2.48),('8784','2013-04-22','11:50:00',1.83),('8784','2013-04-22','11:55:00',3.95),('8784','2013-04-22','12:00:00',3.87),('8784','2013-04-22','12:05:00',4.18),('8784','2013-04-22','12:10:00',2.29),('8784','2013-04-22','12:15:00',2.68),('8784','2013-04-22','12:20:00',2.5),('8784','2013-04-22','12:25:00',1.96),('8784','2013-04-22','12:30:00',2.23),('8784','2013-04-22','12:35:00',2.26),('8784','2013-04-22','12:40:00',3.66),('8784','2013-04-22','12:45:00',3.69),('8784','2013-04-22','12:50:00',4.83),('8784','2013-04-22','12:55:00',4.8),('8784','2013-04-22','13:00:00',4.36),('8784','2013-04-22','13:05:00',3.71),('8784','2013-04-22','13:10:00',3.38),('8784','2013-04-22','13:15:00',4.25),('8784','2013-04-22','13:20:00',4.98),('8784','2013-04-22','13:25:00',2.05),('8784','2013-04-22','13:30:00',1.69),('8784','2013-04-22','13:35:00',2.39),('8784','2013-04-22','13:40:00',2.49),('8784','2013-04-22','13:45:00',1.68),('8784','2013-04-22','13:50:00',1.21),('8784','2013-04-22','13:55:00',2.55),('8784','2013-04-22','14:00:00',1.29),('8784','2013-04-22','14:05:00',2.3),('8784','2013-04-22','14:10:00',2.88),('8784','2013-04-22','14:15:00',4.47),('8784','2013-04-22','14:20:00',5.42),('8784','2013-04-22','14:25:00',3.26),('8784','2013-04-22','14:30:00',3.57),('8784','2013-04-22','14:35:00',3.42),('8784','2013-04-22','14:40:00',4.72),('8784','2013-04-22','14:45:00',3.71),('8784','2013-04-22','14:50:00',4.47),('8784','2013-04-22','14:55:00',3.57),('8784','2013-04-22','15:00:00',1.26),('8784','2013-04-22','15:05:00',1.81),('8784','2013-04-22','15:10:00',1.24),('8784','2013-04-22','15:15:00',1.18),('8784','2013-04-22','15:20:00',2.46),('8784','2013-04-22','15:25:00',4.21),('8784','2013-04-22','15:30:00',1.43),('8784','2013-04-22','15:35:00',1.92),('8784','2013-04-22','15:40:00',2.63),('8784','2013-04-22','15:45:00',4.13),('8784','2013-04-22','15:50:00',2.51),('8784','2013-04-22','15:55:00',1.34),('8784','2013-04-22','16:45:00',1.2),('8784','2013-04-22','16:50:00',1.09),('8784','2014-03-29','07:20:00',1.05),('8784','2014-03-29','07:25:00',1.12),('8784','2014-03-29','07:30:00',1.21),('8784','2014-03-29','07:35:00',1.29),('8784','2014-03-29','07:40:00',1.39),('8784','2014-03-29','07:45:00',1.49),('8784','2014-03-29','07:50:00',1.58),('8784','2014-03-29','07:55:00',1.67),('8784','2014-03-29','08:00:00',1.77),('8784','2014-03-29','08:05:00',1.86),('8784','2014-03-29','08:10:00',1.96),('8784','2014-03-29','08:15:00',2.03),('8784','2014-03-29','08:20:00',2.11),('8784','2014-03-29','08:25:00',2.21),('8784','2014-03-29','08:30:00',2.28),('8784','2014-03-29','08:35:00',2.35),('8784','2014-03-29','08:40:00',2.43),('8784','2014-03-29','08:45:00',2.49),('8784','2014-03-29','08:50:00',2.57),('8784','2014-03-29','08:55:00',2.62),('8784','2014-03-29','09:00:00',2.66),('8784','2014-03-29','09:05:00',2.73),('8784','2014-03-29','09:10:00',2.77),('8784','2014-03-29','09:15:00',2.91),('8784','2014-03-29','09:20:00',2.93),('8784','2014-03-29','09:25:00',3.06),('8784','2014-03-29','09:30:00',3.1),('8784','2014-03-29','09:35:00',3.16),('8784','2014-03-29','09:40:00',3.25),('8784','2014-03-29','09:45:00',3.28),('8784','2014-03-29','09:50:00',3.36),('8784','2014-03-29','09:55:00',3.43),('8784','2014-03-29','10:00:00',3.48),('8784','2014-03-29','10:05:00',3.51),('8784','2014-03-29','10:10:00',3.58),('8784','2014-03-29','10:15:00',3.68),('8784','2014-03-29','10:20:00',3.7),('8784','2014-03-29','10:25:00',3.74),('8784','2014-03-29','10:30:00',3.76),('8784','2014-03-29','10:35:00',3.76),('8784','2014-03-29','10:40:00',3.81),('8784','2014-03-29','10:45:00',3.81),('8784','2014-03-29','10:50:00',3.88),('8784','2014-03-29','10:55:00',3.94),('8784','2014-03-29','11:00:00',3.97),('8784','2014-03-29','11:05:00',3.98),('8784','2014-03-29','11:10:00',3.98),('8784','2014-03-29','11:15:00',4.02),('8784','2014-03-29','11:20:00',4.04),('8784','2014-03-29','11:25:00',4.05),('8784','2014-03-29','11:30:00',4.04),('8784','2014-03-29','11:35:00',4.04),('8784','2014-03-29','11:40:00',3.92),('8784','2014-03-29','11:45:00',4.12),('8784','2014-03-29','11:50:00',4.12),('8784','2014-03-29','11:55:00',4.1),('8784','2014-03-29','12:00:00',4.1),('8784','2014-03-29','12:05:00',4.12),('8784','2014-03-29','12:10:00',4.1),('8784','2014-03-29','12:15:00',4.08),('8784','2014-03-29','12:20:00',4.12),('8784','2014-03-29','12:25:00',4.08),('8784','2014-03-29','12:30:00',4.12),('8784','2014-03-29','12:35:00',4.09),('8784','2014-03-29','12:40:00',4.05),('8784','2014-03-29','12:45:00',4.08),('8784','2014-03-29','12:50:00',4.07),('8784','2014-03-29','12:55:00',4.03),('8784','2014-03-29','13:00:00',3.97),('8784','2014-03-29','13:05:00',4),('8784','2014-03-29','13:10:00',3.94),('8784','2014-03-29','13:15:00',3.93),('8784','2014-03-29','13:20:00',3.91),('8784','2014-03-29','13:25:00',3.83),('8784','2014-03-29','13:30:00',3.79),('8784','2014-03-29','13:35:00',3.72),('8784','2014-03-29','13:40:00',3.7),('8784','2014-03-29','13:45:00',3.63),('8784','2014-03-29','13:50:00',3.58),('8784','2014-03-29','13:55:00',3.56),('8784','2014-03-29','14:00:00',3.54),('8784','2014-03-29','14:05:00',3.49),('8784','2014-03-29','14:10:00',3.46),('8784','2014-03-29','14:15:00',3.41),('8784','2014-03-29','14:20:00',3.35),('8784','2014-03-29','14:25:00',3.06),('8784','2014-03-29','14:30:00',3.21),('8784','2014-03-29','14:35:00',3.01),('8784','2014-03-29','14:40:00',2.56),('8784','2014-03-29','14:45:00',2.97),('8784','2014-03-29','14:50:00',3.01),('8784','2014-03-29','14:55:00',2.98),('8784','2014-03-29','15:00:00',2.96),('8784','2014-03-29','15:05:00',2.83),('8784','2014-03-29','15:10:00',2.73),('8784','2014-03-29','15:15:00',2.69),('8784','2014-03-29','15:20:00',2.63),('8784','2014-03-29','15:25:00',2.5),('8784','2014-03-29','15:30:00',2.37),('8784','2014-03-29','15:35:00',2.29),('8784','2014-03-29','15:40:00',2.25),('8784','2014-03-29','15:45:00',2.19),('8784','2014-03-29','15:50:00',2.1),('8784','2014-03-29','15:55:00',2.01),('8784','2014-03-29','16:00:00',1.95),('8784','2014-03-29','16:05:00',1.86),('8784','2014-03-29','16:10:00',1.75),('8784','2014-03-29','16:15:00',1.67),('8784','2014-03-29','16:20:00',1.51),('8784','2014-03-29','16:25:00',1.49),('8784','2014-03-29','16:30:00',1.43),('8784','2014-03-29','16:35:00',1.29),('8784','2014-03-29','16:40:00',1.12),('8784','2013-04-21','08:05:00',1.27),('8784','2013-04-21','08:10:00',1.07),('8784','2013-04-21','08:15:00',1.19),('8784','2013-04-21','08:20:00',1.13),('8784','2013-04-21','08:25:00',1.34),('8784','2013-04-21','08:30:00',1.46),('8784','2013-04-21','08:35:00',1.44),('8784','2013-04-21','08:40:00',1.53),('8784','2013-04-21','08:45:00',1.2),('8784','2013-04-21','08:50:00',1.36),('8784','2013-04-21','08:55:00',1.96),('8784','2013-04-21','09:00:00',2.05),('8784','2013-04-21','09:05:00',2.42),('8784','2013-04-21','09:10:00',2.08),('8784','2013-04-21','09:15:00',1.69),('8784','2013-04-21','09:20:00',1.5),('8784','2013-04-21','09:25:00',2.47),('8784','2013-04-21','09:30:00',2.97),('8784','2013-04-21','09:35:00',3.06),('8784','2013-04-21','09:40:00',2.88),('8784','2013-04-21','09:45:00',3.37),('8784','2013-04-21','09:50:00',3.47),('8784','2013-04-21','09:55:00',4.14),('8784','2013-04-21','10:00:00',2.84),('8784','2013-04-21','10:05:00',1.97),('8784','2013-04-21','10:10:00',2.06),('8784','2013-04-21','10:15:00',1.84),('8784','2013-04-21','10:20:00',4.14),('8784','2013-04-21','10:25:00',2.75),('8784','2013-04-21','10:30:00',2.28),('8784','2013-04-21','10:35:00',1.87),('8784','2013-04-21','10:40:00',2.54),('8784','2013-04-21','10:45:00',2.55),('8784','2013-04-21','10:50:00',2.53),('8784','2013-04-21','10:55:00',2.47),('8784','2013-04-21','11:00:00',4.24),('8784','2013-04-21','11:05:00',3.5),('8784','2013-04-21','11:10:00',4.16),('8784','2013-04-21','11:15:00',3.23),('8784','2013-04-21','11:20:00',3.04),('8784','2013-04-21','11:25:00',2.92),('8784','2013-04-21','11:30:00',2.78),('8784','2013-04-21','11:35:00',2.69),('8784','2013-04-21','11:40:00',2.83),('8784','2013-04-21','11:45:00',3.04),('8784','2013-04-21','11:50:00',3.17),('8784','2013-04-21','11:55:00',3.44),('8784','2013-04-21','12:00:00',2.48),('8784','2013-04-21','12:05:00',2.61),('8784','2013-04-21','12:10:00',2.42),('8784','2013-04-21','12:15:00',2.29),('8784','2013-04-21','12:20:00',2.07),('8784','2013-04-21','12:25:00',2.06),('8784','2013-04-21','12:30:00',2.19),('8784','2013-04-21','12:35:00',2.26),('8784','2013-04-21','12:40:00',2.24),('8784','2013-04-21','12:45:00',2.27),('8784','2013-04-21','12:50:00',2.16),('8784','2013-04-21','12:55:00',2.09),('8784','2013-04-21','13:00:00',2.4),('8784','2013-04-21','13:05:00',2.75),('8784','2013-04-21','13:10:00',2.66),('8784','2013-04-21','13:15:00',2.5),('8784','2013-04-21','13:20:00',2.38),('8784','2013-04-21','13:25:00',2.35),('8784','2013-04-21','13:30:00',3.29),('8784','2013-04-21','13:35:00',3.81),('8784','2013-04-21','13:40:00',2.99),('8784','2013-04-21','13:45:00',3.35),('8784','2013-04-21','13:50:00',3.27),('8784','2013-04-21','13:55:00',4.03),('8784','2013-04-21','14:00:00',4.01),('8784','2013-04-21','14:05:00',4.68),('8784','2013-04-21','14:10:00',4.17),('8784','2013-04-21','14:15:00',4.47),('8784','2013-04-21','14:20:00',4.83),('8784','2013-04-21','14:25:00',4.32),('8784','2013-04-21','14:30:00',3.97),('8784','2013-04-21','14:35:00',4.53),('8784','2013-04-21','14:40:00',4.59),('8784','2013-04-21','14:45:00',3.44),('8784','2013-04-21','14:50:00',2.24),('8784','2013-04-21','14:55:00',2.23),('8784','2013-04-21','15:00:00',2.03),('8784','2013-04-21','15:05:00',3.76),('8784','2013-04-21','15:10:00',4),('8784','2013-04-21','15:15:00',2.66),('8784','2013-04-21','15:20:00',1.8),('8784','2013-04-21','15:25:00',1.98),('8784','2013-04-21','15:30:00',1.77),('8784','2013-04-21','15:35:00',1.52),('8784','2013-04-21','15:40:00',1.6),('8784','2013-04-21','15:45:00',1.32),('8784','2013-04-21','15:50:00',1.07),('8784','2013-04-20','07:35:00',1.01),('8784','2013-04-20','07:40:00',1.08),('8784','2013-04-20','07:55:00',1.08),('8784','2013-04-20','08:00:00',1.18),('8784','2013-04-20','08:05:00',1.27),('8784','2013-04-20','08:10:00',1.36),('8784','2013-04-20','08:15:00',1.23),('8784','2013-04-20','08:20:00',1.26),('8784','2013-04-20','08:25:00',1.34),('8784','2013-04-20','08:30:00',1.54),('8784','2013-04-20','08:35:00',1.67),('8784','2013-04-20','08:40:00',1.88),('8784','2013-04-20','08:45:00',1.92),('8784','2013-04-20','08:50:00',1.93),('8784','2013-04-20','08:55:00',1.97),('8784','2013-04-20','09:00:00',2.19),('8784','2013-04-20','09:05:00',2.28),('8784','2013-04-20','09:10:00',2.15),('8784','2013-04-20','09:15:00',2.28),('8784','2013-04-20','09:20:00',2.7),('8784','2013-04-20','09:25:00',2.3),('8784','2013-04-20','09:30:00',2.25),('8784','2013-04-20','09:35:00',1.57),('8784','2013-04-20','09:40:00',1.02),('8784','2013-04-20','09:45:00',1.13),('8784','2013-04-20','09:50:00',1.07),('8784','2013-04-20','10:40:00',1.45),('8784','2013-04-20','10:45:00',3.12),('8784','2013-04-20','10:50:00',2.58),('8784','2013-04-20','10:55:00',3.24),('8784','2013-04-20','11:00:00',3.73),('8784','2013-04-20','11:05:00',3.52),('8784','2013-04-20','11:10:00',3.99),('8784','2013-04-20','11:15:00',4.4),('8784','2013-04-20','11:20:00',3.23),('8784','2013-04-20','11:25:00',4.39),('8784','2013-04-20','11:30:00',3.97),('8784','2013-04-20','11:35:00',2.09),('8784','2013-04-20','11:40:00',2.3),('8784','2013-04-20','11:45:00',3.08),('8784','2013-04-20','11:50:00',4.18),('8784','2013-04-20','11:55:00',4.61),('8784','2013-04-20','12:00:00',4.56),('8784','2013-04-20','12:05:00',3.89),('8784','2013-04-20','12:10:00',4.43),('8784','2013-04-20','12:15:00',4.5),('8784','2013-04-20','12:20:00',4.38),('8784','2013-04-20','12:25:00',4.48),('8784','2013-04-20','12:30:00',3.99),('8784','2013-04-20','12:35:00',1.51),('8784','2013-04-20','12:40:00',4.24),('8784','2013-04-20','12:45:00',4.71),('8784','2013-04-20','12:50:00',1.57),('8784','2013-04-20','12:55:00',4.8),('8784','2013-04-20','13:00:00',1.5),('8784','2013-04-20','13:05:00',2.89),('8784','2013-04-20','13:10:00',3.09),('8784','2013-04-20','13:15:00',4.42),('8784','2013-04-20','13:20:00',3.05),('8784','2013-04-20','13:25:00',1.77),('8784','2013-04-20','13:30:00',2.64),('8784','2013-04-20','13:35:00',4.48),('8784','2013-04-20','13:40:00',3.1),('8784','2013-04-20','13:45:00',2.2),('8784','2013-04-20','13:50:00',1.7),('8784','2013-04-20','13:55:00',3.31),('8784','2013-04-20','14:00:00',2.43),('8784','2013-04-20','14:05:00',3.28),('8784','2013-04-20','14:10:00',4.17),('8784','2013-04-20','14:15:00',4.12),('8784','2013-04-20','14:20:00',3.51),('8784','2013-04-20','14:25:00',3.93),('8784','2013-04-20','14:30:00',3.81),('8784','2013-04-20','14:35:00',3.78),('8784','2013-04-20','14:40:00',3.77),('8784','2013-04-20','14:45:00',3.8),('8784','2013-04-20','14:50:00',3.77),('8784','2013-04-20','14:55:00',3.77),('8784','2013-04-20','15:00:00',3.73),('8784','2013-04-20','15:05:00',3.72),('8784','2013-04-20','15:10:00',2.17),('8784','2013-04-20','15:15:00',2.38),('8784','2013-04-20','15:20:00',2.93),('8784','2013-04-20','15:25:00',3.14),('8784','2013-04-20','15:30:00',1.47),('8784','2013-04-20','16:05:00',1.15),('8784','2013-04-20','16:10:00',2),('8784','2013-04-20','16:15:00',2.29),('8784','2013-04-20','16:20:00',2.17),('8784','2013-04-20','16:25:00',2.61),('8784','2013-04-20','16:30:00',2.94),('8784','2013-04-20','16:35:00',2.63),('8784','2013-04-20','16:40:00',3.02),('8784','2013-04-20','16:45:00',2.91),('8784','2013-04-20','16:50:00',2.6),('8784','2013-04-20','16:55:00',2.46),('8784','2013-04-20','17:00:00',2.33),('8784','2013-04-20','17:05:00',2.26),('8784','2013-04-20','17:10:00',2.19),('8784','2013-04-20','17:15:00',1.82),('8784','2013-04-20','17:20:00',2.03),('8784','2013-04-20','17:25:00',1.91),('8784','2013-04-20','17:30:00',2),('8784','2013-04-20','17:35:00',2),('8784','2013-04-20','17:40:00',1.79),('8784','2013-04-20','17:55:00',1.65),('8784','2013-04-20','18:00:00',1.22),('8784','2013-04-20','18:05:00',1.24),('8784','2013-04-20','18:10:00',1.42),('8784','2013-04-20','18:15:00',1.15),('8784','2013-04-19','08:05:00',1.09),('8784','2013-04-19','08:15:00',1.01),('8784','2013-04-19','08:20:00',1.43),('8784','2013-04-19','08:25:00',1.42),('8784','2013-04-19','08:30:00',1.37),('8784','2013-04-19','08:35:00',1.67),('8784','2013-04-19','08:40:00',1.75),('8784','2013-04-19','08:45:00',1.86),('8784','2013-04-19','08:50:00',1.91),('8784','2013-04-19','08:55:00',2.01),('8784','2013-04-19','09:00:00',2.07),('8784','2013-04-19','09:05:00',2.13),('8784','2013-04-19','09:10:00',2.18),('8784','2013-04-19','09:15:00',2.24),('8784','2013-04-19','09:20:00',2.35),('8784','2013-04-19','09:25:00',2.41),('8784','2013-04-19','09:30:00',2.51),('8784','2013-04-19','09:35:00',2.58),('8784','2013-04-19','09:40:00',2.62),('8784','2013-04-19','09:45:00',2.68),('8784','2013-04-19','09:50:00',2.73),('8784','2013-04-19','09:55:00',2.77),('8784','2013-04-19','10:00:00',2.82),('8784','2013-04-19','10:05:00',2.89),('8784','2013-04-19','10:10:00',2.93),('8784','2013-04-19','10:15:00',3.03),('8784','2013-04-19','10:20:00',3.14),('8784','2013-04-19','10:25:00',3.18),('8784','2013-04-19','10:30:00',3.21),('8784','2013-04-19','10:35:00',2.44),('8784','2013-04-19','10:40:00',3.27),('8784','2013-04-19','10:45:00',3.35),('8784','2013-04-19','10:50:00',3.31),('8784','2013-04-19','10:55:00',3.36),('8784','2013-04-19','11:00:00',3.38),('8784','2013-04-19','11:05:00',3.44),('8784','2013-04-19','11:10:00',3.49),('8784','2013-04-19','11:15:00',3.55),('8784','2013-04-19','11:20:00',3.56),('8784','2013-04-19','11:25:00',3.61),('8784','2013-04-19','11:30:00',3.56),('8784','2013-04-19','11:35:00',3.65),('8784','2013-04-19','11:40:00',3.74),('8784','2013-04-19','11:45:00',3.77),('8784','2013-04-19','11:50:00',3.8),('8784','2013-04-19','11:55:00',3.8),('8784','2013-04-19','12:00:00',3.85),('8784','2013-04-19','12:05:00',3.83),('8784','2013-04-19','12:10:00',3.88),('8784','2013-04-19','12:15:00',3.86),('8784','2013-04-19','12:20:00',3.83),('8784','2013-04-19','12:25:00',3.89),('8784','2013-04-19','12:30:00',3.95),('8784','2013-04-19','12:35:00',3.87),('8784','2013-04-19','12:40:00',3.93),('8784','2013-04-19','12:45:00',3.8),('8784','2013-04-19','12:50:00',3.92),('8784','2013-04-19','12:55:00',3.95),('8784','2013-04-19','13:00:00',3.93),('8784','2013-04-19','13:05:00',3.96),('8784','2013-04-19','13:10:00',3.97),('8784','2013-04-19','13:15:00',3.96),('8784','2013-04-19','13:20:00',3.94),('8784','2013-04-19','13:25:00',4.01),('8784','2013-04-19','13:30:00',3.96),('8784','2013-04-19','13:35:00',3.9),('8784','2013-04-19','13:40:00',3.97),('8784','2013-04-19','13:45:00',3.87),('8784','2013-04-19','13:50:00',3.77),('8784','2013-04-19','13:55:00',3.85),('8784','2013-04-19','14:00:00',3.8),('8784','2013-04-19','14:05:00',3.79),('8784','2013-04-19','14:10:00',3.78),('8784','2013-04-19','14:15:00',3.76),('8784','2013-04-19','14:20:00',3.71),('8784','2013-04-19','14:25:00',3.72),('8784','2013-04-19','14:30:00',3.67),('8784','2013-04-19','14:35:00',3.65),('8784','2013-04-19','14:40:00',3.58),('8784','2013-04-19','14:45:00',3.57),('8784','2013-04-19','14:50:00',3.56),('8784','2013-04-19','14:55:00',3.54),('8784','2013-04-19','15:00:00',3.48),('8784','2013-04-19','15:05:00',3.42),('8784','2013-04-19','15:10:00',3.38),('8784','2013-04-19','15:15:00',3.32),('8784','2013-04-19','15:20:00',3.25),('8784','2013-04-19','15:25:00',3.25),('8784','2013-04-19','15:30:00',3.18),('8784','2013-04-19','15:35:00',3.16),('8784','2013-04-19','15:40:00',3.12),('8784','2013-04-19','15:45:00',3.07),('8784','2013-04-19','15:50:00',2.99),('8784','2013-04-19','15:55:00',2.95),('8784','2013-04-19','16:00:00',2.89),('8784','2013-04-19','16:05:00',2.83),('8784','2013-04-19','16:10:00',2.76),('8784','2013-04-19','16:15:00',2.7),('8784','2013-04-19','16:20:00',2.64),('8784','2013-04-19','16:25:00',2.59),('8784','2013-04-19','16:30:00',2.51),('8784','2013-04-19','16:35:00',2.41),('8784','2013-04-19','16:40:00',2.36),('8784','2013-04-19','16:45:00',2.28),('8784','2013-04-19','16:50:00',2.2),('8784','2013-04-19','16:55:00',2.1),('8784','2013-04-19','17:00:00',2.04),('8784','2013-04-19','17:05:00',1.96),('8784','2013-04-19','17:10:00',1.86),('8784','2013-04-19','17:15:00',1.78),('8784','2013-04-19','17:20:00',1.71),('8784','2013-04-19','17:25:00',1.62),('8784','2013-04-19','17:30:00',1.55),('8784','2013-04-19','17:35:00',1.47),('8784','2013-04-19','17:40:00',1.39),('8784','2013-04-19','17:45:00',1.31),('8784','2013-04-19','17:50:00',1.2),('8784','2013-04-19','17:55:00',1.13),('8784','2013-04-19','18:00:00',1.07),('8784','2013-04-19','18:05:00',1),('8784','2013-04-18','08:10:00',1.2),('8784','2013-04-18','08:15:00',1.21),('8784','2013-04-18','08:20:00',1.31),('8784','2013-04-18','08:25:00',1.25),('8784','2013-04-18','08:30:00',1.38),('8784','2013-04-18','08:35:00',1.46),('8784','2013-04-18','08:40:00',1.38),('8784','2013-04-18','08:45:00',1.41),('8784','2013-04-18','08:50:00',1.57),('8784','2013-04-18','08:55:00',1.76),('8784','2013-04-18','09:00:00',1.86),('8784','2013-04-18','09:05:00',1.95),('8784','2013-04-18','09:10:00',1.99),('8784','2013-04-18','09:15:00',2.08),('8784','2013-04-18','09:20:00',2.07),('8784','2013-04-18','09:25:00',2.11),('8784','2013-04-18','09:30:00',2.28),('8784','2013-04-18','09:35:00',2.55),('8784','2013-04-18','09:40:00',2.79),('8784','2013-04-18','09:45:00',2.74),('8784','2013-04-18','09:50:00',2.37),('8784','2013-04-18','09:55:00',2.24),('8784','2013-04-18','10:00:00',2.59),('8784','2013-04-18','10:05:00',2.88),('8784','2013-04-18','10:10:00',3.08),('8784','2013-04-18','10:15:00',3.28),('8784','2013-04-18','10:20:00',3.31),('8784','2013-04-18','10:25:00',3.28),('8784','2013-04-18','10:30:00',3.34),('8784','2013-04-18','10:35:00',3.38),('8784','2013-04-18','10:40:00',3.42),('8784','2013-04-18','10:45:00',3.49),('8784','2013-04-18','10:50:00',3.51),('8784','2013-04-18','10:55:00',3.55),('8784','2013-04-18','11:00:00',3.6),('8784','2013-04-18','11:05:00',3.65),('8784','2013-04-18','11:10:00',3.66),('8784','2013-04-18','11:15:00',3.73),('8784','2013-04-18','11:20:00',3.77),('8784','2013-04-18','11:25:00',3.8),('8784','2013-04-18','11:30:00',3.82),('8784','2013-04-18','11:35:00',3.85),('8784','2013-04-18','11:40:00',3.87),('8784','2013-04-18','11:45:00',3.79),('8784','2013-04-18','11:50:00',3.94),('8784','2013-04-18','11:55:00',3.96),('8784','2013-04-18','12:00:00',3.93),('8784','2013-04-18','12:05:00',4.01),('8784','2013-04-18','12:10:00',4.06),('8784','2013-04-18','12:15:00',4.03),('8784','2013-04-18','12:20:00',4.08),('8784','2013-04-18','12:25:00',4.09),('8784','2013-04-18','12:30:00',4.11),('8784','2013-04-18','12:35:00',4.11),('8784','2013-04-18','12:40:00',4.13),('8784','2013-04-18','12:45:00',4.16),('8784','2013-04-18','12:50:00',4.15),('8784','2013-04-18','12:55:00',4.18),('8784','2013-04-18','13:00:00',4.15),('8784','2013-04-18','13:05:00',4.12),('8784','2013-04-18','13:10:00',4.08),('8784','2013-04-18','13:15:00',4.15),('8784','2013-04-18','13:20:00',4.15),('8784','2013-04-18','13:25:00',4.17),('8784','2013-04-18','13:30:00',4.15),('8784','2013-04-18','13:35:00',4.16),('8784','2013-04-18','13:40:00',4.12),('8784','2013-04-18','13:45:00',4.11),('8784','2013-04-18','13:50:00',4.12),('8784','2013-04-18','13:55:00',4.09),('8784','2013-04-18','14:00:00',4.07),('8784','2013-04-18','14:05:00',4.05),('8784','2013-04-18','14:10:00',4.03),('8784','2013-04-18','14:15:00',4.02),('8784','2013-04-18','14:20:00',3.97),('8784','2013-04-18','14:25:00',3.95),('8784','2013-04-18','14:30:00',3.93),('8784','2013-04-18','14:35:00',3.91),('8784','2013-04-18','14:40:00',3.87),('8784','2013-04-18','14:45:00',3.77),('8784','2013-04-18','14:50:00',3.77),('8784','2013-04-18','14:55:00',3.73),('8784','2013-04-18','15:00:00',3.69),('8784','2013-04-18','15:05:00',3.65),('8784','2013-04-18','15:10:00',3.6),('8784','2013-04-18','15:15:00',3.55),('8784','2013-04-18','15:20:00',3.49),('8784','2013-04-18','15:25:00',3.46),('8784','2013-04-18','15:30:00',3.38),('8784','2013-04-18','15:35:00',3.33),('8784','2013-04-18','15:40:00',3.28),('8784','2013-04-18','15:45:00',3.23),('8784','2013-04-18','15:50:00',3.18),('8784','2013-04-18','15:55:00',3.1),('8784','2013-04-18','16:00:00',3.04),('8784','2013-04-18','16:05:00',2.98),('8784','2013-04-18','16:10:00',2.9),('8784','2013-04-18','16:15:00',2.82),('8784','2013-04-18','16:20:00',2.76),('8784','2013-04-18','16:25:00',2.68),('8784','2013-04-18','16:30:00',2.58),('8784','2013-04-18','16:35:00',2.52),('8784','2013-04-18','16:40:00',2.46),('8784','2013-04-18','16:45:00',2.4),('8784','2013-04-18','16:50:00',2.33),('8784','2013-04-18','16:55:00',2.24),('8784','2013-04-18','17:00:00',2.14),('8784','2013-04-18','17:05:00',2),('8784','2013-04-18','17:10:00',1.98),('8784','2013-04-18','17:15:00',1.92),('8784','2013-04-18','17:20:00',1.83),('8784','2013-04-18','17:25:00',1.74),('8784','2013-04-18','17:30:00',1.66),('8784','2013-04-18','17:35:00',1.58),('8784','2013-04-18','17:40:00',1.5),('8784','2013-04-18','17:45:00',1.43),('8784','2013-04-18','17:50:00',1.36),('8784','2013-04-18','17:55:00',1.27),('8784','2013-04-18','18:00:00',1.19),('8784','2013-04-18','18:05:00',1.1),('8784','2013-04-18','18:10:00',1.01),('8784','2013-04-17','07:55:00',1.04),('8784','2013-04-17','08:00:00',1.12),('8784','2013-04-17','08:05:00',1.2),('8784','2013-04-17','08:10:00',1.29),('8784','2013-04-17','08:15:00',1.38),('8784','2013-04-17','08:20:00',1.46),('8784','2013-04-17','08:25:00',1.55),('8784','2013-04-17','08:30:00',1.63),('8784','2013-04-17','08:35:00',1.71),('8784','2013-04-17','08:40:00',1.79),('8784','2013-04-17','08:45:00',1.88),('8784','2013-04-17','08:50:00',1.97),('8784','2013-04-17','08:55:00',2.04),('8784','2013-04-17','09:00:00',2.12),('8784','2013-04-17','09:05:00',2.21),('8784','2013-04-17','09:10:00',2.29),('8784','2013-04-17','09:15:00',2.36),('8784','2013-04-17','09:20:00',2.44),('8784','2013-04-17','09:25:00',2.52),('8784','2013-04-17','09:30:00',2.59),('8784','2013-04-17','09:35:00',2.67),('8784','2013-04-17','09:40:00',2.76),('8784','2013-04-17','09:45:00',2.82),('8784','2013-04-17','09:50:00',2.89),('8784','2013-04-17','09:55:00',2.95),('8784','2013-04-17','10:00:00',3.01),('8784','2013-04-17','10:05:00',3.08),('8784','2013-04-17','10:10:00',3.15),('8784','2013-04-17','10:15:00',3.2),('8784','2013-04-17','10:20:00',3.25),('8784','2013-04-17','10:25:00',3.33),('8784','2013-04-17','10:30:00',3.36),('8784','2013-04-17','10:35:00',3.38),('8784','2013-04-17','10:40:00',3.48),('8784','2013-04-17','10:45:00',3.51),('8784','2013-04-17','10:50:00',3.55),('8784','2013-04-17','10:55:00',3.6),('8784','2013-04-17','11:00:00',3.64),('8784','2013-04-17','11:05:00',3.69),('8784','2013-04-17','11:10:00',3.74),('8784','2013-04-17','11:15:00',3.77),('8784','2013-04-17','11:20:00',3.81),('8784','2013-04-17','11:25:00',3.8),('8784','2013-04-17','11:30:00',3.84),('8784','2013-04-17','11:35:00',3.86),('8784','2013-04-17','11:40:00',3.9),('8784','2013-04-17','11:45:00',3.93),('8784','2013-04-17','11:50:00',3.92),('8784','2013-04-17','11:55:00',4.02),('8784','2013-04-17','12:00:00',4.01),('8784','2013-04-17','12:05:00',4.01),('8784','2013-04-17','12:10:00',4.02),('8784','2013-04-17','12:15:00',4.03),('8784','2013-04-17','12:20:00',4.05),('8784','2013-04-17','12:25:00',4.09),('8784','2013-04-17','12:30:00',4.11),('8784','2013-04-17','12:35:00',4.14),('8784','2013-04-17','12:40:00',4.15),('8784','2013-04-17','12:45:00',4.15),('8784','2013-04-17','12:50:00',4.13),('8784','2013-04-17','12:55:00',4.13),('8784','2013-04-17','13:00:00',4.1),('8784','2013-04-17','13:05:00',4.1),('8784','2013-04-17','13:10:00',4.1),('8784','2013-04-17','13:15:00',4.17),('8784','2013-04-17','13:20:00',4.19),('8784','2013-04-17','13:25:00',4.18),('8784','2013-04-17','13:30:00',4.16),('8784','2013-04-17','13:35:00',4.12),('8784','2013-04-17','13:40:00',4.13),('8784','2013-04-17','13:45:00',4.07),('8784','2013-04-17','13:50:00',3.96),('8784','2013-04-17','13:55:00',4.22),('8784','2013-04-17','14:00:00',4.04),('8784','2013-04-17','14:05:00',4.38),('8784','2013-04-17','14:10:00',4.37),('8784','2013-04-17','14:15:00',4),('8784','2013-04-17','14:20:00',3.96),('8784','2013-04-17','14:25:00',3.72),('8784','2013-04-17','14:30:00',4.03),('8784','2013-04-17','14:35:00',4.21),('8784','2013-04-17','14:40:00',3.83),('8784','2013-04-17','14:45:00',3.68),('8784','2013-04-17','14:50:00',4.18),('8784','2013-04-17','14:55:00',4.06),('8784','2013-04-17','15:00:00',4.03),('8784','2013-04-17','15:05:00',4.11),('8784','2013-04-17','15:10:00',4.24),('8784','2013-04-17','15:15:00',3.82),('8784','2013-04-17','15:20:00',2.28),('8784','2013-04-17','15:25:00',1.79),('8784','2013-04-17','15:30:00',3.13),('8784','2013-04-17','15:35:00',3.48),('8784','2013-04-17','15:40:00',3.57),('8784','2013-04-17','15:45:00',3.56),('8784','2013-04-17','15:50:00',3.55),('8784','2013-04-17','15:55:00',3.45),('8784','2013-04-17','16:00:00',3.31),('8784','2013-04-17','16:05:00',2.44),('8784','2013-04-17','16:10:00',3.13),('8784','2013-04-17','16:15:00',3.05),('8784','2013-04-17','16:20:00',2.92),('8784','2013-04-17','16:25:00',2.83),('8784','2013-04-17','16:30:00',2.76),('8784','2013-04-17','16:35:00',2.74),('8784','2013-04-17','16:40:00',2.35),('8784','2013-04-17','16:45:00',2.6),('8784','2013-04-17','16:50:00',2.42),('8784','2013-04-17','16:55:00',2.3),('8784','2013-04-17','17:00:00',2.21),('8784','2013-04-17','17:05:00',2.11),('8784','2013-04-17','17:10:00',2.02),('8784','2013-04-17','17:15:00',1.93),('8784','2013-04-17','17:20:00',1.85),('8784','2013-04-17','17:25:00',1.77),('8784','2013-04-17','17:30:00',1.68),('8784','2013-04-17','17:35:00',1.6),('8784','2013-04-17','17:40:00',1.51),('8784','2013-04-17','17:45:00',1.43),('8784','2013-04-17','17:50:00',1.34),('8784','2013-04-17','17:55:00',1.26),('8784','2013-04-17','18:00:00',1.18),('8784','2013-04-17','18:05:00',1.11),('8784','2013-04-17','18:10:00',1.03),('8784','2013-04-16','08:05:00',1.1),('8784','2013-04-16','08:10:00',1.07),('8784','2013-04-16','08:50:00',1.11),('8784','2013-04-16','08:55:00',1.07),('8784','2013-04-16','09:10:00',1.76),('8784','2013-04-16','09:15:00',2.35),('8784','2013-04-16','09:20:00',1.28),('8784','2013-04-16','09:25:00',1.38),('8784','2013-04-16','09:30:00',1.73),('8784','2013-04-16','09:35:00',1.64),('8784','2013-04-16','09:40:00',1.52),('8784','2013-04-16','09:45:00',1.6),('8784','2013-04-16','09:50:00',1.48),('8784','2013-04-16','09:55:00',1.42),('8784','2013-04-16','10:00:00',1.36),('8784','2013-04-16','10:05:00',1.35),('8784','2013-04-16','10:10:00',1.44),('8784','2013-04-16','10:15:00',1.53),('8784','2013-04-16','10:20:00',1.61),('8784','2013-04-16','10:25:00',1.62),('8784','2013-04-16','10:30:00',1.65),('8784','2013-04-16','10:35:00',1.69),('8784','2013-04-16','10:40:00',1.66),('8784','2013-04-16','10:45:00',1.6),('8784','2013-04-16','10:50:00',1.61),('8784','2013-04-16','10:55:00',1.69),('8784','2013-04-16','11:00:00',1.86),('8784','2013-04-16','11:05:00',1.92),('8784','2013-04-16','11:10:00',1.91),('8784','2013-04-16','11:15:00',1.95),('8784','2013-04-16','11:20:00',2.01),('8784','2013-04-16','11:25:00',1.93),('8784','2013-04-16','11:30:00',1.91),('8784','2013-04-16','11:35:00',1.84),('8784','2013-04-16','11:40:00',2),('8784','2013-04-16','11:45:00',2.31),('8784','2013-04-16','11:50:00',2.48),('8784','2013-04-16','11:55:00',2.55),('8784','2013-04-16','12:00:00',2.59),('8784','2013-04-16','12:05:00',2.82),('8784','2013-04-16','12:10:00',3.06),('8784','2013-04-16','12:15:00',3.02),('8784','2013-04-16','12:20:00',3.21),('8784','2013-04-16','12:25:00',3.07),('8784','2013-04-16','12:30:00',2.42),('8784','2013-04-16','12:35:00',2.98),('8784','2013-04-16','12:40:00',4.12),('8784','2013-04-16','12:45:00',3.48),('8784','2013-04-16','12:50:00',3.13),('8784','2013-04-16','12:55:00',3.74),('8784','2013-04-16','13:00:00',4.07),('8784','2013-04-16','13:05:00',4.06),('8784','2013-04-16','13:10:00',3.96),('8784','2013-04-16','13:15:00',4.05),('8784','2013-04-16','13:20:00',4.08),('8784','2013-04-16','13:25:00',4.09),('8784','2013-04-16','13:30:00',4.06),('8784','2013-04-16','13:35:00',4),('8784','2013-04-16','13:40:00',4.02),('8784','2013-04-16','13:45:00',3.84),('8784','2013-04-16','13:50:00',3.95),('8784','2013-04-16','13:55:00',3.82),('8784','2013-04-16','14:00:00',3.9),('8784','2013-04-16','14:05:00',3.95),('8784','2013-04-16','14:10:00',3.92),('8784','2013-04-16','14:15:00',3.97),('8784','2013-04-16','14:20:00',3.91),('8784','2013-04-16','14:25:00',3.55),('8784','2013-04-16','14:30:00',3.44),('8784','2013-04-16','14:35:00',2.76),('8784','2013-04-16','14:40:00',3.56),('8784','2013-04-16','14:45:00',3.65),('8784','2013-04-16','14:50:00',3.63),('8784','2013-04-16','14:55:00',3.56),('8784','2013-04-16','15:00:00',3.59),('8784','2013-04-16','15:05:00',3.61),('8784','2013-04-16','15:10:00',3.61),('8784','2013-04-16','15:15:00',3.5),('8784','2013-04-16','15:20:00',3.42),('8784','2013-04-16','15:25:00',3.18),('8784','2013-04-16','15:30:00',3.08),('8784','2013-04-16','15:35:00',3.24),('8784','2013-04-16','15:40:00',3.2),('8784','2013-04-16','15:45:00',3.16),('8784','2013-04-16','15:50:00',3.11),('8784','2013-04-16','15:55:00',3.07),('8784','2013-04-16','16:00:00',2.93),('8784','2013-04-16','16:05:00',2.91),('8784','2013-04-16','16:10:00',2.84),('8784','2013-04-16','16:15:00',2.71),('8784','2013-04-16','16:20:00',2.75),('8784','2013-04-16','16:25:00',2.68),('8784','2013-04-16','16:30:00',2.63),('8784','2013-04-16','16:35:00',2.59),('8784','2013-04-16','16:40:00',2.68),('8784','2013-04-16','16:45:00',2.74),('8784','2013-04-16','16:50:00',2.5),('8784','2013-04-16','16:55:00',2.1),('8784','2013-04-16','17:00:00',2.11),('8784','2013-04-16','17:05:00',2.21),('8784','2013-04-16','17:10:00',2.21),('8784','2013-04-16','17:15:00',2.12),('8784','2013-04-16','17:20:00',2.08),('8784','2013-04-16','17:25:00',2.06),('8784','2013-04-16','17:30:00',1.85),('8784','2013-04-16','17:35:00',1.91),('8784','2013-04-16','17:40:00',1.82),('8784','2013-04-16','17:45:00',1.66),('8784','2013-04-16','17:50:00',1.51),('8784','2013-04-16','17:55:00',1.31),('8784','2013-04-15','07:55:00',1.04),('8784','2013-04-15','08:00:00',1.12),('8784','2013-04-15','08:05:00',1.2),('8784','2013-04-15','08:10:00',1.27),('8784','2013-04-15','08:15:00',1.35),('8784','2013-04-15','08:20:00',1.43),('8784','2013-04-15','08:25:00',1.51),('8784','2013-04-15','08:30:00',1.61),('8784','2013-04-15','08:35:00',1.7),('8784','2013-04-15','08:40:00',1.79),('8784','2013-04-15','08:45:00',1.87),('8784','2013-04-15','08:50:00',1.95),('8784','2013-04-15','08:55:00',2),('8784','2013-04-15','09:00:00',2.13),('8784','2013-04-15','09:05:00',2.21),('8784','2013-04-15','09:10:00',2.29),('8784','2013-04-15','09:15:00',2.38),('8784','2013-04-15','09:20:00',2.45),('8784','2013-04-15','09:25:00',2.52),('8784','2013-04-15','09:30:00',2.6),('8784','2013-04-15','09:35:00',2.66),('8784','2013-04-15','09:40:00',2.73),('8784','2013-04-15','09:45:00',2.79),('8784','2013-04-15','09:50:00',2.87),('8784','2013-04-15','09:55:00',2.93),('8784','2013-04-15','10:00:00',3),('8784','2013-04-15','10:05:00',3.06),('8784','2013-04-15','10:10:00',3.12),('8784','2013-04-15','10:15:00',3.18),('8784','2013-04-15','10:20:00',3.26),('8784','2013-04-15','10:25:00',3.3),('8784','2013-04-15','10:30:00',3.35),('8784','2013-04-15','10:35:00',3.4),('8784','2013-04-15','10:40:00',3.45),('8784','2013-04-15','10:45:00',3.5),('8784','2013-04-15','10:50:00',3.53),('8784','2013-04-15','10:55:00',3.56),('8784','2013-04-15','11:00:00',3.63),('8784','2013-04-15','11:05:00',3.67),('8784','2013-04-15','11:10:00',3.68),('8784','2013-04-15','11:15:00',3.76),('8784','2013-04-15','11:20:00',3.79),('8784','2013-04-15','11:25:00',3.82),('8784','2013-04-15','11:30:00',3.84),('8784','2013-04-15','11:35:00',3.89),('8784','2013-04-15','11:40:00',3.92),('8784','2013-04-15','11:45:00',3.97),('8784','2013-04-15','11:50:00',3.97),('8784','2013-04-15','11:55:00',3.98),('8784','2013-04-15','12:00:00',3.99),('8784','2013-04-15','12:05:00',4.04),('8784','2013-04-15','12:10:00',4.05),('8784','2013-04-15','12:15:00',4.03),('8784','2013-04-15','12:20:00',4.04),('8784','2013-04-15','12:25:00',4.04),('8784','2013-04-15','12:30:00',4.06),('8784','2013-04-15','12:35:00',4.09),('8784','2013-04-15','12:40:00',4.12),('8784','2013-04-15','12:45:00',4.11),('8784','2013-04-15','12:50:00',4.08),('8784','2013-04-15','12:55:00',4.06),('8784','2013-04-15','13:00:00',4.11),('8784','2013-04-15','13:05:00',4.12),('8784','2013-04-15','13:10:00',4.14),('8784','2013-04-15','13:15:00',4.12),('8784','2013-04-15','13:20:00',4.09),('8784','2013-04-15','13:25:00',4.13),('8784','2013-04-15','13:30:00',4.1),('8784','2013-04-15','13:35:00',4.08),('8784','2013-04-15','13:40:00',4.04),('8784','2013-04-15','13:45:00',4.04),('8784','2013-04-15','13:50:00',4.06),('8784','2013-04-15','13:55:00',4.08),('8784','2013-04-15','14:00:00',4.06),('8784','2013-04-15','14:05:00',4.05),('8784','2013-04-15','14:10:00',3.99),('8784','2013-04-15','14:15:00',4.01),('8784','2013-04-15','14:20:00',4),('8784','2013-04-15','14:25:00',3.99),('8784','2013-04-15','14:30:00',3.95),('8784','2013-04-15','14:35:00',3.92),('8784','2013-04-15','14:40:00',3.89),('8784','2013-04-15','14:45:00',3.84),('8784','2013-04-15','14:50:00',3.81),('8784','2013-04-15','14:55:00',3.76),('8784','2013-04-15','15:00:00',3.72),('8784','2013-04-15','15:05:00',3.69),('8784','2013-04-15','15:10:00',3.64),('8784','2013-04-15','15:15:00',3.6),('8784','2013-04-15','15:20:00',3.55),('8784','2013-04-15','15:25:00',3.5),('8784','2013-04-15','15:30:00',3.46),('8784','2013-04-15','15:35:00',3.39),('8784','2013-04-15','15:40:00',3.32),('8784','2013-04-15','15:45:00',3.26),('8784','2013-04-15','15:50:00',3.22),('8784','2013-04-15','15:55:00',3.16),('8784','2013-04-15','16:00:00',3.07),('8784','2013-04-15','16:05:00',3.01),('8784','2013-04-15','16:10:00',2.94),('8784','2013-04-15','16:15:00',2.87),('8784','2013-04-15','16:20:00',2.79),('8784','2013-04-15','16:25:00',2.72),('8784','2013-04-15','16:30:00',2.64),('8784','2013-04-15','16:35:00',2.57),('8784','2013-04-15','16:40:00',2.49),('8784','2013-04-15','16:45:00',2.42),('8784','2013-04-15','16:50:00',2.34),('8784','2013-04-15','16:55:00',2.25),('8784','2013-04-15','17:00:00',2.17),('8784','2013-04-15','17:05:00',2.09),('8784','2013-04-15','17:10:00',2.01),('8784','2013-04-15','17:15:00',1.93),('8784','2013-04-15','17:20:00',1.85),('8784','2013-04-15','17:25:00',1.77),('8784','2013-04-15','17:30:00',1.67),('8784','2013-04-15','17:35:00',1.59),('8784','2013-04-15','17:40:00',1.5),('8784','2013-04-15','17:45:00',1.42),('8784','2013-04-15','17:50:00',1.34),('8784','2013-04-15','17:55:00',1.26),('8784','2013-04-15','18:00:00',1.18),('8784','2013-04-15','18:05:00',1.09),('8784','2013-04-15','18:10:00',1.01),('8784','2013-04-14','07:55:00',1.02),('8784','2013-04-14','08:00:00',1.08),('8784','2013-04-14','08:05:00',1.06),('8784','2013-04-14','08:10:00',1.18),('8784','2013-04-14','08:15:00',1.3),('8784','2013-04-14','08:20:00',1.39),('8784','2013-04-14','08:25:00',1.46),('8784','2013-04-14','08:30:00',1.57),('8784','2013-04-14','08:35:00',1.65),('8784','2013-04-14','08:40:00',1.73),('8784','2013-04-14','08:45:00',1.8),('8784','2013-04-14','08:50:00',1.88),('8784','2013-04-14','08:55:00',1.94),('8784','2013-04-14','09:00:00',2.02),('8784','2013-04-14','09:05:00',2.11),('8784','2013-04-14','09:10:00',2.2),('8784','2013-04-14','09:15:00',2.27),('8784','2013-04-14','09:20:00',2.33),('8784','2013-04-14','09:25:00',2.38),('8784','2013-04-14','09:30:00',2.48),('8784','2013-04-14','09:35:00',2.56),('8784','2013-04-14','09:40:00',2.62),('8784','2013-04-14','09:45:00',2.69),('8784','2013-04-14','09:50:00',2.7),('8784','2013-04-14','09:55:00',2.77),('8784','2013-04-14','10:00:00',2.89),('8784','2013-04-14','10:05:00',2.97),('8784','2013-04-14','10:10:00',3.03),('8784','2013-04-14','10:15:00',3.09),('8784','2013-04-14','10:20:00',3.15),('8784','2013-04-14','10:25:00',3.2),('8784','2013-04-14','10:30:00',3.25),('8784','2013-04-14','10:35:00',3.3),('8784','2013-04-14','10:40:00',3.37),('8784','2013-04-14','10:45:00',3.43),('8784','2013-04-14','10:50:00',3.44),('8784','2013-04-14','10:55:00',3.5),('8784','2013-04-14','11:00:00',3.56),('8784','2013-04-14','11:05:00',3.59),('8784','2013-04-14','11:10:00',3.58),('8784','2013-04-14','11:15:00',3.69),('8784','2013-04-14','11:20:00',3.75),('8784','2013-04-14','11:25:00',3.77),('8784','2013-04-14','11:30:00',3.77),('8784','2013-04-14','11:35:00',3.78),('8784','2013-04-14','11:40:00',3.8),('8784','2013-04-14','11:45:00',3.86),('8784','2013-04-14','11:50:00',3.89),('8784','2013-04-14','11:55:00',3.88),('8784','2013-04-14','12:00:00',3.93),('8784','2013-04-14','12:05:00',3.91),('8784','2013-04-14','12:10:00',3.94),('8784','2013-04-14','12:15:00',3.98),('8784','2013-04-14','12:20:00',4),('8784','2013-04-14','12:25:00',4.03),('8784','2013-04-14','12:30:00',4.03),('8784','2013-04-14','12:35:00',4.03),('8784','2013-04-14','12:40:00',3),('8784','2013-04-14','12:45:00',1.75),('8784','2013-04-14','12:50:00',4.19),('8784','2013-04-14','12:55:00',4.27),('8784','2013-04-14','13:00:00',3.43),('8784','2013-04-14','13:05:00',3.31),('8784','2013-04-14','13:10:00',4.2),('8784','2013-04-14','13:15:00',3.86),('8784','2013-04-14','13:20:00',4.2),('8784','2013-04-14','13:25:00',4.16),('8784','2013-04-14','13:30:00',4.14),('8784','2013-04-14','13:35:00',4.09),('8784','2013-04-14','13:40:00',4.05),('8784','2013-04-14','13:45:00',4.02),('8784','2013-04-14','13:50:00',3.97),('8784','2013-04-14','13:55:00',3.98),('8784','2013-04-14','14:00:00',3.97),('8784','2013-04-14','14:05:00',3.97),('8784','2013-04-14','14:10:00',3.93),('8784','2013-04-14','14:15:00',3.88),('8784','2013-04-14','14:20:00',3.85),('8784','2013-04-14','14:25:00',3.85),('8784','2013-04-14','14:30:00',3.84),('8784','2013-04-14','14:35:00',3.92),('8784','2013-04-14','14:40:00',3.91),('8784','2013-04-14','14:45:00',3.99),('8784','2013-04-14','14:50:00',3.94),('8784','2013-04-14','14:55:00',3.83),('8784','2013-04-14','15:00:00',3.79),('8784','2013-04-14','15:05:00',3.73),('8784','2013-04-14','15:10:00',3.71),('8784','2013-04-14','15:15:00',3.24),('8784','2013-04-14','15:20:00',3.5),('8784','2013-04-14','15:25:00',3.36),('8784','2013-04-14','15:30:00',2.88),('8784','2013-04-14','15:35:00',3.44),('8784','2013-04-14','15:40:00',3.43),('8784','2013-04-14','15:45:00',3.38),('8784','2013-04-14','15:50:00',3.3),('8784','2013-04-14','15:55:00',3.14),('8784','2013-04-14','16:00:00',2.6),('8784','2013-04-14','16:05:00',2.9),('8784','2013-04-14','16:10:00',2.83),('8784','2013-04-14','16:15:00',2.76),('8784','2013-04-14','16:20:00',2.67),('8784','2013-04-14','16:25:00',2.63),('8784','2013-04-14','16:30:00',2.57),('8784','2013-04-14','16:35:00',2.48),('8784','2013-04-14','16:40:00',2.42),('8784','2013-04-14','16:45:00',2.32),('8784','2013-04-14','16:50:00',2.27),('8784','2013-04-14','16:55:00',2.19),('8784','2013-04-14','17:00:00',2.07),('8784','2013-04-14','17:05:00',1.99),('8784','2013-04-14','17:10:00',1.93),('8784','2013-04-14','17:15:00',1.85),('8784','2013-04-14','17:20:00',1.76),('8784','2013-04-14','17:25:00',1.68),('8784','2013-04-14','17:30:00',1.59),('8784','2013-04-14','17:35:00',1.52),('8784','2013-04-14','17:40:00',1.44),('8784','2013-04-14','17:45:00',1.36),('8784','2013-04-14','17:50:00',1.29),('8784','2013-04-14','17:55:00',1.21),('8784','2013-04-14','18:00:00',1.12),('8784','2013-04-14','18:05:00',1.04),('8784','2013-04-13','08:05:00',1.02),('8784','2013-04-13','08:10:00',1.15),('8784','2013-04-13','08:15:00',1.22),('8784','2013-04-13','08:50:00',1.13),('8784','2013-04-13','08:55:00',1.48),('8784','2013-04-13','09:00:00',1.06),('8784','2013-04-13','09:05:00',1.7),('8784','2013-04-13','09:10:00',1.81),('8784','2013-04-13','09:15:00',1.17),('8784','2013-04-13','09:20:00',1.44),('8784','2013-04-13','09:25:00',1.34),('8784','2013-04-13','09:30:00',2.54),('8784','2013-04-13','09:35:00',2.49),('8784','2013-04-13','09:40:00',2.35),('8784','2013-04-13','09:45:00',2.72),('8784','2013-04-13','09:50:00',2.78),('8784','2013-04-13','09:55:00',2.85),('8784','2013-04-13','10:00:00',2.96),('8784','2013-04-13','10:05:00',3.02),('8784','2013-04-13','10:10:00',2.98),('8784','2013-04-13','10:15:00',2.81),('8784','2013-04-13','10:20:00',2.62),('8784','2013-04-13','10:25:00',3.47),('8784','2013-04-13','10:30:00',2.88),('8784','2013-04-13','10:35:00',3.37),('8784','2013-04-13','10:40:00',3.54),('8784','2013-04-13','10:45:00',3.37),('8784','2013-04-13','10:50:00',3.46),('8784','2013-04-13','10:55:00',2.83),('8784','2013-04-13','11:00:00',1.68),('8784','2013-04-13','11:05:00',4),('8784','2013-04-13','11:10:00',4.01),('8784','2013-04-13','11:15:00',4.24),('8784','2013-04-13','11:20:00',2.59),('8784','2013-04-13','11:25:00',1.26),('8784','2013-04-13','11:30:00',4.09),('8784','2013-04-13','11:35:00',4.26),('8784','2013-04-13','11:40:00',3.57),('8784','2013-04-13','11:45:00',3.22),('8784','2013-04-13','11:50:00',2.41),('8784','2013-04-13','11:55:00',4.31),('8784','2013-04-13','12:00:00',4.4),('8784','2013-04-13','12:05:00',4.31),('8784','2013-04-13','12:10:00',4.35),('8784','2013-04-13','12:15:00',3.99),('8784','2013-04-13','12:20:00',4.24),('8784','2013-04-13','12:25:00',4.39),('8784','2013-04-13','12:30:00',4.34),('8784','2013-04-13','12:35:00',4.28),('8784','2013-04-13','12:40:00',4.23),('8784','2013-04-13','12:45:00',4.15),('8784','2013-04-13','12:50:00',4.08),('8784','2013-04-13','12:55:00',3.98),('8784','2013-04-13','13:00:00',4.12),('8784','2013-04-13','13:05:00',4.21),('8784','2013-04-13','13:10:00',4.39),('8784','2013-04-13','13:15:00',4.26),('8784','2013-04-13','13:20:00',4.27),('8784','2013-04-13','13:25:00',4.24),('8784','2013-04-13','13:30:00',3.86),('8784','2013-04-13','13:35:00',2.91),('8784','2013-04-13','13:40:00',3.61),('8784','2013-04-13','13:45:00',3.22),('8784','2013-04-13','13:50:00',1.84),('8784','2013-04-13','13:55:00',1.95),('8784','2013-04-13','14:00:00',2.22),('8784','2013-04-13','14:05:00',2.16),('8784','2013-04-13','14:10:00',2.31),('8784','2013-04-13','14:15:00',3.62),('8784','2013-04-13','14:20:00',3.56),('8784','2013-04-13','14:25:00',3.65),('8784','2013-04-13','14:30:00',3.61),('8784','2013-04-13','14:35:00',3.72),('8784','2013-04-13','14:40:00',3.65),('8784','2013-04-13','14:45:00',3.69),('8784','2013-04-13','14:50:00',3.52),('8784','2013-04-13','14:55:00',3.62),('8784','2013-04-13','15:00:00',3.28),('8784','2013-04-13','15:05:00',2.64),('8784','2013-04-13','15:10:00',3.1),('8784','2013-04-13','15:15:00',2.83),('8784','2013-04-13','15:20:00',2.87),('8784','2013-04-13','15:25:00',2.67),('8784','2013-04-13','15:30:00',2.71),('8784','2013-04-13','15:35:00',2.65),('8784','2013-04-13','15:40:00',2.74),('8784','2013-04-13','15:45:00',2.78),('8784','2013-04-13','15:50:00',2.66),('8784','2013-04-13','15:55:00',2.71),('8784','2013-04-13','16:00:00',2.65),('8784','2013-04-13','16:05:00',2.51),('8784','2013-04-13','16:10:00',2.38),('8784','2013-04-13','16:15:00',2.43),('8784','2013-04-13','16:20:00',2.35),('8784','2013-04-13','16:25:00',2.17),('8784','2013-04-13','16:30:00',2.06),('8784','2013-04-13','16:35:00',1.95),('8784','2013-04-13','16:40:00',1.84),('8784','2013-04-13','16:45:00',1.75),('8784','2013-04-13','16:50:00',1.76),('8784','2013-04-13','16:55:00',1.47),('8784','2013-04-13','17:00:00',1.26),('8784','2013-04-13','17:05:00',1.21),('8784','2013-04-13','17:10:00',1.69),('8784','2013-04-13','17:15:00',1.91),('8784','2013-04-13','17:20:00',1.59),('8784','2013-04-13','17:25:00',1.79),('8784','2013-04-13','17:30:00',1.56),('8784','2013-04-13','17:35:00',1.55),('8784','2013-04-13','17:40:00',1.49),('8784','2013-04-13','17:45:00',1.34),('8784','2013-04-13','17:50:00',1.17),('8784','2013-04-13','17:55:00',1.28),('8784','2013-04-12','07:55:00',1.06),('8784','2013-04-12','08:00:00',1.11),('8784','2013-04-12','08:05:00',1.21),('8784','2013-04-12','08:10:00',1.1),('8784','2013-04-12','08:35:00',1.22),('8784','2013-04-12','08:45:00',1.13),('8784','2013-04-12','08:50:00',1.44),('8784','2013-04-12','08:55:00',1.99),('8784','2013-04-12','09:00:00',1.78),('8784','2013-04-12','09:05:00',1.41),('8784','2013-04-12','09:10:00',1.3),('8784','2013-04-12','09:15:00',1.8),('8784','2013-04-12','09:20:00',2.5),('8784','2013-04-12','09:25:00',2.12),('8784','2013-04-12','09:30:00',1.34),('8784','2013-04-12','09:35:00',1.26),('8784','2013-04-12','09:40:00',1.3),('8784','2013-04-12','09:45:00',1.42),('8784','2013-04-12','10:05:00',1.17),('8784','2013-04-12','10:15:00',1.15),('8784','2013-04-12','10:20:00',3.26),('8784','2013-04-12','10:25:00',2.66),('8784','2013-04-12','10:30:00',1.93),('8784','2013-04-12','10:35:00',3.48),('8784','2013-04-12','10:40:00',4.07),('8784','2013-04-12','10:45:00',4.48),('8784','2013-04-12','10:50:00',3.28),('8784','2013-04-12','10:55:00',1.43),('8784','2013-04-12','11:00:00',1.39),('8784','2013-04-12','11:05:00',1.94),('8784','2013-04-12','11:10:00',2.67),('8784','2013-04-12','11:15:00',4.68),('8784','2013-04-12','11:20:00',4.46),('8784','2013-04-12','11:25:00',4.48),('8784','2013-04-12','11:30:00',4.62),('8784','2013-04-12','11:35:00',2.46),('8784','2013-04-12','11:40:00',1.8),('8784','2013-04-12','11:45:00',1.97),('8784','2013-04-12','11:50:00',1.8),('8784','2013-04-12','11:55:00',4.22),('8784','2013-04-12','12:00:00',4.43),('8784','2013-04-12','12:05:00',4.27),('8784','2013-04-12','12:10:00',4.11),('8784','2013-04-12','12:15:00',4.3),('8784','2013-04-12','12:20:00',4.28),('8784','2013-04-12','12:25:00',4.22),('8784','2013-04-12','12:30:00',4.13),('8784','2013-04-12','12:35:00',4.12),('8784','2013-04-12','12:40:00',4.01),('8784','2013-04-12','12:45:00',4.14),('8784','2013-04-12','12:50:00',3.12),('8784','2013-04-12','12:55:00',3.89),('8784','2013-04-12','13:00:00',4.18),('8784','2013-04-12','13:05:00',4.13),('8784','2013-04-12','13:10:00',4.15),('8784','2013-04-12','13:15:00',4.18),('8784','2013-04-12','13:20:00',4.18),('8784','2013-04-12','13:25:00',4.17),('8784','2013-04-12','13:30:00',4.12),('8784','2013-04-12','13:35:00',4.2),('8784','2013-04-12','13:40:00',4.13),('8784','2013-04-12','13:45:00',4.13),('8784','2013-04-12','13:50:00',4.09),('8784','2013-04-12','13:55:00',4.09),('8784','2013-04-12','14:00:00',4.08),('8784','2013-04-12','14:05:00',4.05),('8784','2013-04-12','14:10:00',4),('8784','2013-04-12','14:15:00',3.98),('8784','2013-04-12','14:20:00',3.95),('8784','2013-04-12','14:25:00',3.93),('8784','2013-04-12','14:30:00',3.89),('8784','2013-04-12','14:35:00',3.86),('8784','2013-04-12','14:40:00',3.81),('8784','2013-04-12','14:45:00',3.77),('8784','2013-04-12','14:50:00',3.74),('8784','2013-04-12','14:55:00',3.68),('8784','2013-04-12','15:00:00',3.65),('8784','2013-04-12','15:05:00',3.6),('8784','2013-04-12','15:10:00',3.52),('8784','2013-04-12','15:15:00',3.49),('8784','2013-04-12','15:20:00',3.44),('8784','2013-04-12','15:25:00',3.38),('8784','2013-04-12','15:30:00',3.34),('8784','2013-04-12','15:35:00',3.3),('8784','2013-04-12','15:40:00',3.24),('8784','2013-04-12','15:45:00',3.21),('8784','2013-04-12','15:50:00',3.14),('8784','2013-04-12','15:55:00',3.09),('8784','2013-04-12','16:00:00',3.04),('8784','2013-04-12','16:05:00',2.97),('8784','2013-04-12','16:10:00',2.94),('8784','2013-04-12','16:15:00',2.56),('8784','2013-04-12','16:20:00',2.73),('8784','2013-04-12','16:25:00',2.71),('8784','2013-04-12','16:30:00',1.59),('8784','2013-04-12','16:35:00',1.23),('8784','2013-04-12','16:40:00',1.78),('8784','2013-04-12','16:45:00',2.48),('8784','2013-04-12','16:50:00',2.31),('8784','2013-04-12','16:55:00',2.23),('8784','2013-04-12','17:00:00',2.13),('8784','2013-04-12','17:05:00',2.04),('8784','2013-04-12','17:10:00',1.95),('8784','2013-04-12','17:15:00',1.88),('8784','2013-04-12','17:20:00',1.79),('8784','2013-04-12','17:25:00',1.72),('8784','2013-04-12','17:30:00',1.66),('8784','2013-04-12','17:35:00',1.56),('8784','2013-04-12','17:40:00',1.45),('8784','2013-04-12','17:45:00',1.35),('8784','2013-04-12','17:50:00',1.29),('8784','2013-04-12','17:55:00',1.22),('8784','2013-04-12','18:00:00',1.13),('8784','2013-04-12','18:05:00',1.04),('8784','2014-03-28','07:15:00',1.05),('8784','2014-03-28','07:20:00',1.09),('8784','2014-03-28','07:25:00',1.09),('8784','2014-03-28','07:30:00',1.17),('8784','2014-03-28','07:35:00',1.32),('8784','2014-03-28','07:40:00',1.37),('8784','2014-03-28','07:45:00',1.54),('8784','2014-03-28','07:50:00',1.63),('8784','2014-03-28','07:55:00',1.71),('8784','2014-03-28','08:00:00',1.79),('8784','2014-03-28','08:05:00',1.89),('8784','2014-03-28','08:10:00',2),('8784','2014-03-28','08:15:00',2.09),('8784','2014-03-28','08:20:00',2.18),('8784','2014-03-28','08:25:00',2.26),('8784','2014-03-28','08:30:00',2.33),('8784','2014-03-28','08:35:00',2.4),('8784','2014-03-28','08:40:00',2.51),('8784','2014-03-28','08:45:00',2.57),('8784','2014-03-28','08:50:00',2.68),('8784','2014-03-28','08:55:00',2.78),('8784','2014-03-28','09:00:00',2.86),('8784','2014-03-28','09:05:00',2.99),('8784','2014-03-28','09:10:00',3.14),('8784','2014-03-28','09:15:00',3.13),('8784','2014-03-28','09:20:00',2.96),('8784','2014-03-28','09:25:00',3.54),('8784','2014-03-28','09:30:00',3.6),('8784','2014-03-28','09:35:00',3.22),('8784','2014-03-28','09:40:00',1.96),('8784','2014-03-28','09:45:00',1.9),('8784','2014-03-28','09:50:00',2.53),('8784','2014-03-28','09:55:00',3.69),('8784','2014-03-28','10:00:00',3.64),('8784','2014-03-28','10:05:00',3.72),('8784','2014-03-28','10:10:00',3.5),('8784','2014-03-28','10:15:00',2.66),('8784','2014-03-28','10:20:00',2.57),('8784','2014-03-28','10:25:00',3.65),('8784','2014-03-28','10:30:00',3.82),('8784','2014-03-28','10:35:00',3.77),('8784','2014-03-28','10:40:00',3.55),('8784','2014-03-28','10:45:00',2.83),('8784','2014-03-28','10:50:00',4.01),('8784','2014-03-28','10:55:00',4.07),('8784','2014-03-28','11:00:00',4.08),('8784','2014-03-28','11:05:00',3.65),('8784','2014-03-28','11:10:00',2.92),('8784','2014-03-28','11:15:00',3.06),('8784','2014-03-28','11:20:00',2.27),('8784','2014-03-28','11:25:00',2.48),('8784','2014-03-28','11:30:00',1.87),('8784','2014-03-28','11:35:00',1.76),('8784','2014-03-28','11:40:00',1.53),('8784','2014-03-28','11:45:00',3.9),('8784','2014-03-28','11:50:00',2.19),('8784','2014-03-28','11:55:00',1.48),('8784','2014-03-28','12:00:00',1.34),('8784','2014-03-28','12:05:00',4.67),('8784','2014-03-28','12:10:00',4.57),('8784','2014-03-28','12:15:00',4.76),('8784','2014-03-28','12:20:00',4.91),('8784','2014-03-28','12:25:00',1.39),('8784','2014-03-28','12:35:00',3.76),('8784','2014-03-28','12:40:00',4.51),('8784','2014-03-28','12:45:00',4.39),('8784','2014-03-28','12:50:00',4.44),('8784','2014-03-28','12:55:00',1.82),('8784','2014-03-28','13:00:00',4.85),('8784','2014-03-28','13:05:00',2.65),('8784','2014-03-28','13:10:00',2.84),('8784','2014-03-28','13:15:00',1.69),('8784','2014-03-28','13:20:00',2.68),('8784','2014-03-28','13:25:00',1.62),('8784','2014-03-28','13:30:00',1.47),('8784','2014-03-28','13:35:00',3.75),('8784','2014-03-28','13:40:00',4.41),('8784','2014-03-28','13:45:00',4.05),('8784','2014-03-28','13:50:00',3.85),('8784','2014-03-28','13:55:00',3.74),('8784','2014-03-28','14:00:00',3.79),('8784','2014-03-28','14:05:00',3.72),('8784','2014-03-28','14:10:00',3.64),('8784','2014-03-28','14:15:00',3.6),('8784','2014-03-28','14:20:00',3.55),('8784','2014-03-28','14:25:00',3.51),('8784','2014-03-28','14:30:00',3.45),('8784','2014-03-28','14:35:00',3.38),('8784','2014-03-28','14:40:00',3.35),('8784','2014-03-28','14:45:00',3.29),('8784','2014-03-28','14:50:00',3.24),('8784','2014-03-28','14:55:00',3.18),('8784','2014-03-28','15:00:00',3.15),('8784','2014-03-28','15:05:00',3.06),('8784','2014-03-28','15:10:00',2.96),('8784','2014-03-28','15:15:00',2.88),('8784','2014-03-28','15:20:00',2.8),('8784','2014-03-28','15:25:00',2.72),('8784','2014-03-28','15:30:00',2.65),('8784','2014-03-28','15:35:00',2.58),('8784','2014-03-28','15:40:00',2.5),('8784','2014-03-28','15:45:00',2.48),('8784','2014-03-28','15:50:00',2.45),('8784','2014-03-28','15:55:00',1.93),('8784','2014-03-28','16:00:00',2.46),('8784','2014-03-28','16:05:00',2.49),('8784','2014-03-28','16:10:00',2.39),('8784','2014-03-28','16:15:00',2.28),('8784','2014-03-28','16:20:00',1.94),('8784','2014-03-28','16:25:00',1.69),('8784','2014-03-28','16:30:00',1.6),('8784','2014-03-28','16:40:00',1.01),('8784','2014-03-28','16:45:00',1.11),('8784','2014-03-28','16:50:00',1.15),('8784','2013-04-11','08:05:00',1.09),('8784','2013-04-11','08:10:00',1.18),('8784','2013-04-11','08:15:00',1.27),('8784','2013-04-11','08:20:00',1.36),('8784','2013-04-11','08:25:00',1.45),('8784','2013-04-11','08:30:00',1.53),('8784','2013-04-11','08:35:00',1.62),('8784','2013-04-11','08:40:00',1.69),('8784','2013-04-11','08:45:00',1.77),('8784','2013-04-11','08:50:00',1.85),('8784','2013-04-11','08:55:00',1.92),('8784','2013-04-11','09:00:00',2),('8784','2013-04-11','09:05:00',2.08),('8784','2013-04-11','09:10:00',2.16),('8784','2013-04-11','09:15:00',2.23),('8784','2013-04-11','09:20:00',2.3),('8784','2013-04-11','09:25:00',2.35),('8784','2013-04-11','09:30:00',2.44),('8784','2013-04-11','09:35:00',2.51),('8784','2013-04-11','09:40:00',1.93),('8784','2013-04-11','09:45:00',2.74),('8784','2013-04-11','09:50:00',1.77),('8784','2013-04-11','10:00:00',1.81),('8784','2013-04-11','10:05:00',1.07),('8784','2013-04-11','10:10:00',2.2),('8784','2013-04-11','10:15:00',3.22),('8784','2013-04-11','10:20:00',3.25),('8784','2013-04-11','10:25:00',3.49),('8784','2013-04-11','10:30:00',3.58),('8784','2013-04-11','10:35:00',3.61),('8784','2013-04-11','10:40:00',3.85),('8784','2013-04-11','10:45:00',3.25),('8784','2013-04-11','11:00:00',1.37),('8784','2013-04-11','11:05:00',3.75),('8784','2013-04-11','11:10:00',4),('8784','2013-04-11','11:15:00',3.76),('8784','2013-04-11','11:20:00',1.96),('8784','2013-04-11','11:25:00',2.92),('8784','2013-04-11','11:30:00',4.31),('8784','2013-04-11','11:35:00',3.29),('8784','2013-04-11','11:40:00',1.29),('8784','2013-04-11','11:45:00',1.17),('8784','2013-04-11','11:50:00',3.78),('8784','2013-04-11','11:55:00',4.87),('8784','2013-04-11','12:00:00',4.42),('8784','2013-04-11','12:05:00',4.53),('8784','2013-04-11','12:10:00',4.67),('8784','2013-04-11','12:15:00',4.55),('8784','2013-04-11','12:20:00',4.03),('8784','2013-04-11','12:25:00',4.35),('8784','2013-04-11','12:30:00',4.17),('8784','2013-04-11','12:35:00',3.71),('8784','2013-04-11','12:40:00',3.23),('8784','2013-04-11','12:45:00',1.74),('8784','2013-04-11','12:50:00',4.61),('8784','2013-04-11','12:55:00',4.49),('8784','2013-04-11','13:00:00',4.61),('8784','2013-04-11','13:05:00',4.57),('8784','2013-04-11','13:10:00',4.37),('8784','2013-04-11','13:15:00',3.77),('8784','2013-04-11','13:20:00',4.09),('8784','2013-04-11','13:25:00',4.32),('8784','2013-04-11','13:30:00',4.27),('8784','2013-04-11','13:35:00',4.29),('8784','2013-04-11','13:40:00',4.23),('8784','2013-04-11','13:45:00',4.15),('8784','2013-04-11','13:50:00',4.15),('8784','2013-04-11','13:55:00',4.18),('8784','2013-04-11','14:00:00',4.08),('8784','2013-04-11','14:05:00',4.17),('8784','2013-04-11','14:10:00',4.21),('8784','2013-04-11','14:15:00',4.17),('8784','2013-04-11','14:20:00',4.13),('8784','2013-04-11','14:25:00',4.04),('8784','2013-04-11','14:30:00',3.99),('8784','2013-04-11','14:35:00',4.02),('8784','2013-04-11','14:40:00',4.04),('8784','2013-04-11','14:45:00',3.94),('8784','2013-04-11','14:50:00',3.85),('8784','2013-04-11','14:55:00',3.83),('8784','2013-04-11','15:00:00',3.74),('8784','2013-04-11','15:05:00',3.68),('8784','2013-04-11','15:10:00',3.66),('8784','2013-04-11','15:15:00',3.59),('8784','2013-04-11','15:20:00',3.54),('8784','2013-04-11','15:25:00',3.49),('8784','2013-04-11','15:30:00',3.43),('8784','2013-04-11','15:35:00',3.38),('8784','2013-04-11','15:40:00',3.31),('8784','2013-04-11','15:45:00',3.25),('8784','2013-04-11','15:50:00',3.2),('8784','2013-04-11','15:55:00',3.14),('8784','2013-04-11','16:00:00',3.09),('8784','2013-04-11','16:05:00',3.01),('8784','2013-04-11','16:10:00',2.94),('8784','2013-04-11','16:15:00',2.88),('8784','2013-04-11','16:20:00',2.82),('8784','2013-04-11','16:25:00',2.75),('8784','2013-04-11','16:30:00',2.67),('8784','2013-04-11','16:35:00',2.59),('8784','2013-04-11','16:40:00',2.52),('8784','2013-04-11','16:45:00',2.45),('8784','2013-04-11','16:50:00',2.36),('8784','2013-04-11','16:55:00',2.29),('8784','2013-04-11','17:00:00',2.17),('8784','2013-04-11','17:05:00',2.08),('8784','2013-04-11','17:10:00',2.01),('8784','2013-04-11','17:15:00',1.93),('8784','2013-04-11','17:20:00',1.83),('8784','2013-04-11','17:25:00',1.76),('8784','2013-04-11','17:30:00',1.68),('8784','2013-04-11','17:35:00',1.57),('8784','2013-04-11','17:40:00',1.51),('8784','2013-04-11','17:45:00',1.42),('8784','2013-04-11','17:50:00',1.34),('8784','2013-04-11','17:55:00',1.22),('8784','2013-04-11','18:00:00',1.11),('8784','2013-04-11','18:05:00',1.01),('8784','2013-04-10','08:50:00',1.07),('8784','2013-04-10','08:55:00',1.87),('8784','2013-04-10','09:00:00',2.03),('8784','2013-04-10','09:05:00',2.21),('8784','2013-04-10','09:10:00',2.31),('8784','2013-04-10','09:15:00',2.35),('8784','2013-04-10','09:20:00',2.37),('8784','2013-04-10','09:25:00',2.45),('8784','2013-04-10','09:30:00',2.54),('8784','2013-04-10','09:35:00',2.59),('8784','2013-04-10','09:40:00',2.69),('8784','2013-04-10','09:45:00',2.67),('8784','2013-04-10','09:50:00',2.75),('8784','2013-04-10','09:55:00',2.9),('8784','2013-04-10','10:00:00',3.05),('8784','2013-04-10','10:05:00',3.16),('8784','2013-04-10','10:10:00',3.3),('8784','2013-04-10','10:15:00',3.44),('8784','2013-04-10','10:20:00',3.47),('8784','2013-04-10','10:25:00',3.49),('8784','2013-04-10','10:30:00',3.51),('8784','2013-04-10','10:35:00',3.56),('8784','2013-04-10','10:40:00',3.54),('8784','2013-04-10','10:45:00',3.67),('8784','2013-04-10','10:50:00',3.47),('8784','2013-04-10','10:55:00',3.15),('8784','2013-04-10','11:00:00',3.55),('8784','2013-04-10','11:05:00',3.51),('8784','2013-04-10','11:10:00',3.63),('8784','2013-04-10','11:15:00',3.62),('8784','2013-04-10','11:20:00',3.75),('8784','2013-04-10','11:25:00',3.92),('8784','2013-04-10','11:30:00',3.84),('8784','2013-04-10','11:35:00',3.97),('8784','2013-04-10','11:40:00',4.04),('8784','2013-04-10','11:45:00',4.02),('8784','2013-04-10','11:50:00',4.09),('8784','2013-04-10','11:55:00',4.11),('8784','2013-04-10','12:00:00',4.19),('8784','2013-04-10','12:05:00',4.25),('8784','2013-04-10','12:10:00',4.25),('8784','2013-04-10','12:15:00',4.3),('8784','2013-04-10','12:20:00',4.3),('8784','2013-04-10','12:25:00',4.33),('8784','2013-04-10','12:30:00',4.37),('8784','2013-04-10','12:35:00',4.07),('8784','2013-04-10','12:40:00',4.37),('8784','2013-04-10','12:45:00',4.36),('8784','2013-04-10','12:50:00',4.31),('8784','2013-04-10','12:55:00',4.37),('8784','2013-04-10','13:00:00',3.31),('8784','2013-04-10','13:05:00',3.55),('8784','2013-04-10','13:10:00',1.57),('8784','2013-04-10','13:15:00',3.45),('8784','2013-04-10','13:20:00',4.8),('8784','2013-04-10','13:25:00',4.25),('8784','2013-04-10','13:30:00',4.06),('8784','2013-04-10','13:35:00',3.92),('8784','2013-04-10','13:40:00',3.58),('8784','2013-04-10','13:45:00',2.15),('8784','2013-04-10','13:50:00',4.82),('8784','2013-04-10','13:55:00',2.84),('8784','2013-04-10','14:00:00',4.47),('8784','2013-04-10','14:05:00',4.27),('8784','2013-04-10','14:10:00',4.25),('8784','2013-04-10','14:15:00',4.16),('8784','2013-04-10','14:20:00',4.15),('8784','2013-04-10','14:25:00',4.2),('8784','2013-04-10','14:30:00',4.18),('8784','2013-04-10','14:35:00',3.89),('8784','2013-04-10','14:40:00',4.08),('8784','2013-04-10','14:45:00',4.16),('8784','2013-04-10','14:50:00',4.11),('8784','2013-04-10','14:55:00',4),('8784','2013-04-10','15:00:00',4.04),('8784','2013-04-10','15:05:00',3.63),('8784','2013-04-10','15:10:00',3.23),('8784','2013-04-10','15:15:00',3.54),('8784','2013-04-10','15:20:00',3.89),('8784','2013-04-10','15:25:00',3.61),('8784','2013-04-10','15:30:00',3.51),('8784','2013-04-10','15:35:00',3.49),('8784','2013-04-10','15:40:00',3.11),('8784','2013-04-10','15:45:00',3.34),('8784','2013-04-10','15:50:00',3.37),('8784','2013-04-10','15:55:00',3.16),('8784','2013-04-10','16:00:00',2.77),('8784','2013-04-10','16:05:00',3.23),('8784','2013-04-10','16:10:00',3.12),('8784','2013-04-10','16:15:00',2.95),('8784','2013-04-10','16:20:00',2.61),('8784','2013-04-10','16:25:00',2.75),('8784','2013-04-10','16:30:00',2.57),('8784','2013-04-10','16:35:00',1.92),('8784','2013-04-10','16:40:00',2.41),('8784','2013-04-10','16:45:00',2.62),('8784','2013-04-10','16:50:00',2.07),('8784','2013-04-10','16:55:00',2.34),('8784','2013-04-10','17:00:00',2.16),('8784','2013-04-10','17:05:00',1.75),('8784','2013-04-10','17:10:00',1.78),('8784','2013-04-10','17:15:00',2.01),('8784','2013-04-10','17:20:00',1.96),('8784','2013-04-10','17:25:00',1.75),('8784','2013-04-10','17:30:00',1.71),('8784','2013-04-10','17:35:00',1.41),('8784','2013-04-10','17:40:00',1.18),('8784','2013-04-10','17:45:00',1.47),('8784','2013-04-10','17:50:00',1.21),('8784','2013-04-10','17:55:00',1.27),('8784','2013-04-09','07:55:00',1.11),('8784','2013-04-09','08:00:00',1.1),('8784','2013-04-09','08:10:00',1.12),('8784','2013-04-09','08:20:00',1.47),('8784','2013-04-09','08:30:00',1.04),('8784','2013-04-09','09:05:00',1.01),('8784','2013-04-09','09:10:00',1.07),('8784','2013-04-09','09:15:00',1.12),('8784','2013-04-09','09:20:00',1.01),('8784','2013-04-09','09:25:00',1.13),('8784','2013-04-09','09:30:00',1.13),('8784','2013-04-09','09:45:00',1.75),('8784','2013-04-09','09:50:00',2.81),('8784','2013-04-09','09:55:00',3.27),('8784','2013-04-09','10:00:00',1.76),('8784','2013-04-09','10:05:00',1.22),('8784','2013-04-09','10:10:00',1.89),('8784','2013-04-09','10:15:00',2.13),('8784','2013-04-09','10:20:00',1.54),('8784','2013-04-09','10:30:00',1.27),('8784','2013-04-09','10:35:00',2.7),('8784','2013-04-09','10:40:00',3.01),('8784','2013-04-09','10:45:00',4.34),('8784','2013-04-09','10:50:00',3.59),('8784','2013-04-09','10:55:00',3.95),('8784','2013-04-09','11:00:00',3.51),('8784','2013-04-09','11:05:00',3.84),('8784','2013-04-09','11:10:00',3.58),('8784','2013-04-09','11:20:00',1.45),('8784','2013-04-09','11:25:00',3.18),('8784','2013-04-09','11:30:00',4.49),('8784','2013-04-09','11:35:00',2.09),('8784','2013-04-09','11:40:00',1.77),('8784','2013-04-09','11:45:00',3.21),('8784','2013-04-09','11:50:00',4.19),('8784','2013-04-09','11:55:00',3.31),('8784','2013-04-09','12:00:00',4.66),('8784','2013-04-09','12:05:00',4.62),('8784','2013-04-09','12:10:00',4.64),('8784','2013-04-09','12:15:00',4.61),('8784','2013-04-09','12:20:00',3.92),('8784','2013-04-09','12:25:00',4.38),('8784','2013-04-09','12:30:00',4.48),('8784','2013-04-09','12:35:00',4.52),('8784','2013-04-09','12:40:00',4.53),('8784','2013-04-09','12:45:00',4.37),('8784','2013-04-09','12:50:00',4.64),('8784','2013-04-09','12:55:00',4.37),('8784','2013-04-09','13:00:00',4.55),('8784','2013-04-09','13:05:00',4.46),('8784','2013-04-09','13:10:00',4.92),('8784','2013-04-09','13:15:00',3.81),('8784','2013-04-09','13:20:00',2.98),('8784','2013-04-09','13:25:00',4),('8784','2013-04-09','13:30:00',1.6),('8784','2013-04-09','13:35:00',1.99),('8784','2013-04-09','13:40:00',1.92),('8784','2013-04-09','13:45:00',2.2),('8784','2013-04-09','13:50:00',4.54),('8784','2013-04-09','13:55:00',4.31),('8784','2013-04-09','14:00:00',4.03),('8784','2013-04-09','14:05:00',3.15),('8784','2013-04-09','14:10:00',3.36),('8784','2013-04-09','14:15:00',3.78),('8784','2013-04-09','14:20:00',2.44),('8784','2013-04-09','14:25:00',2.73),('8784','2013-04-09','14:30:00',3.1),('8784','2013-04-09','14:35:00',3.77),('8784','2013-04-09','14:40:00',3.91),('8784','2013-04-09','14:45:00',3.61),('8784','2013-04-09','14:50:00',3.26),('8784','2013-04-09','14:55:00',2.66),('8784','2013-04-09','15:00:00',3.88),('8784','2013-04-09','15:05:00',3.79),('8784','2013-04-09','15:10:00',3.49),('8784','2013-04-09','15:15:00',3.01),('8784','2013-04-09','15:20:00',3.88),('8784','2013-04-09','15:25:00',3.81),('8784','2013-04-09','15:30:00',2.01),('8784','2013-04-09','15:35:00',3.84),('8784','2013-04-09','15:40:00',3.63),('8784','2013-04-09','15:45:00',3.13),('8784','2013-04-09','15:50:00',3.53),('8784','2013-04-09','15:55:00',2.86),('8784','2013-04-09','16:00:00',2.63),('8784','2013-04-09','16:05:00',2.82),('8784','2013-04-09','16:10:00',1.92),('8784','2013-04-09','16:15:00',1.97),('8784','2013-04-09','16:25:00',1.36),('8784','2013-04-09','16:30:00',1.09),('8784','2013-04-09','16:35:00',1.27),('8784','2013-04-09','16:40:00',1.19),('8784','2013-04-09','16:45:00',1.07),('8784','2013-04-09','16:50:00',2.91),('8784','2013-04-09','16:55:00',2.03),('8784','2013-04-09','17:15:00',1.21),('8784','2013-04-09','17:20:00',1.22),('8784','2013-04-09','17:30:00',1.19),('8784','2013-04-08','08:40:00',1.28),('8784','2013-04-08','08:45:00',1.13),('8784','2013-04-08','08:50:00',1.89),('8784','2013-04-08','08:55:00',1.88),('8784','2013-04-08','09:00:00',1.7),('8784','2013-04-08','09:05:00',1.78),('8784','2013-04-08','09:10:00',1.29),('8784','2013-04-08','09:15:00',2.21),('8784','2013-04-08','09:20:00',2.57),('8784','2013-04-08','09:25:00',2.64),('8784','2013-04-08','09:30:00',2.63),('8784','2013-04-08','09:35:00',2.8),('8784','2013-04-08','09:40:00',2.79),('8784','2013-04-08','09:45:00',2.85),('8784','2013-04-08','09:50:00',1.65),('8784','2013-04-08','09:55:00',1.92),('8784','2013-04-08','10:00:00',3.01),('8784','2013-04-08','10:05:00',3.06),('8784','2013-04-08','10:10:00',3.07),('8784','2013-04-08','10:15:00',3.17),('8784','2013-04-08','10:20:00',3.16),('8784','2013-04-08','10:25:00',3.19),('8784','2013-04-08','10:30:00',3.3),('8784','2013-04-08','10:35:00',3.13),('8784','2013-04-08','10:40:00',3.51),('8784','2013-04-08','10:45:00',3.69),('8784','2013-04-08','10:50:00',3.69),('8784','2013-04-08','10:55:00',3.52),('8784','2013-04-08','11:00:00',3.69),('8784','2013-04-08','11:05:00',3.22),('8784','2013-04-08','11:10:00',3.14),('8784','2013-04-08','11:15:00',2.79),('8784','2013-04-08','11:20:00',2.39),('8784','2013-04-08','11:25:00',2.11),('8784','2013-04-08','11:30:00',2.44),('8784','2013-04-08','11:35:00',3.2),('8784','2013-04-08','11:40:00',3.33),('8784','2013-04-08','11:45:00',2.96),('8784','2013-04-08','11:50:00',2.71),('8784','2013-04-08','11:55:00',2.47),('8784','2013-04-08','12:00:00',2.32),('8784','2013-04-08','12:05:00',2.24),('8784','2013-04-08','12:10:00',2.44),('8784','2013-04-08','12:15:00',2.85),('8784','2013-04-08','12:20:00',2.87),('8784','2013-04-08','12:25:00',2.82),('8784','2013-04-08','12:30:00',3.18),('8784','2013-04-08','12:35:00',2.68),('8784','2013-04-08','12:40:00',2.85),('8784','2013-04-08','12:45:00',3.81),('8784','2013-04-08','12:50:00',2.47),('8784','2013-04-08','12:55:00',1.96),('8784','2013-04-08','13:00:00',1.94),('8784','2013-04-08','13:05:00',2.82),('8784','2013-04-08','13:10:00',2.87),('8784','2013-04-08','13:15:00',3.14),('8784','2013-04-08','13:20:00',3.73),('8784','2013-04-08','13:25:00',3.39),('8784','2013-04-08','13:30:00',2.9),('8784','2013-04-08','13:35:00',2.21),('8784','2013-04-08','13:40:00',2.8),('8784','2013-04-08','13:45:00',3.07),('8784','2013-04-08','13:50:00',3.17),('8784','2013-04-08','13:55:00',4.02),('8784','2013-04-08','14:00:00',3.8),('8784','2013-04-08','14:05:00',3.39),('8784','2013-04-08','14:10:00',3.42),('8784','2013-04-08','14:15:00',3.86),('8784','2013-04-08','14:20:00',3.44),('8784','2013-04-08','14:25:00',4.04),('8784','2013-04-08','14:30:00',3.88),('8784','2013-04-08','14:35:00',3.58),('8784','2013-04-08','14:40:00',3.69),('8784','2013-04-08','14:45:00',3.83),('8784','2013-04-08','14:50:00',3.73),('8784','2013-04-08','14:55:00',3.84),('8784','2013-04-08','15:00:00',2.88),('8784','2013-04-08','15:05:00',2.81),('8784','2013-04-08','15:10:00',3.03),('8784','2013-04-08','15:15:00',2.94),('8784','2013-04-08','15:20:00',3.09),('8784','2013-04-08','15:25:00',3.55),('8784','2013-04-08','15:30:00',3.62),('8784','2013-04-08','15:35:00',3.47),('8784','2013-04-08','15:40:00',3.34),('8784','2013-04-08','15:45:00',3.28),('8784','2013-04-08','15:50:00',3.21),('8784','2013-04-08','15:55:00',3.17),('8784','2013-04-08','16:00:00',3.06),('8784','2013-04-08','16:05:00',2.89),('8784','2013-04-08','16:10:00',2.75),('8784','2013-04-08','16:15:00',2.87),('8784','2013-04-08','16:20:00',2.87),('8784','2013-04-08','16:25:00',2.73),('8784','2013-04-08','16:30:00',2.66),('8784','2013-04-08','16:35:00',2.58),('8784','2013-04-08','16:40:00',2.5),('8784','2013-04-08','16:45:00',2.4),('8784','2013-04-08','16:50:00',2.37),('8784','2013-04-08','16:55:00',2.28),('8784','2013-04-08','17:00:00',2.22),('8784','2013-04-08','17:05:00',2.13),('8784','2013-04-08','17:10:00',1.98),('8784','2013-04-08','17:15:00',1.87),('8784','2013-04-08','17:20:00',1.79),('8784','2013-04-08','17:25:00',1.82),('8784','2013-04-08','17:30:00',1.68),('8784','2013-04-08','17:35:00',1.57),('8784','2013-04-08','17:40:00',1.4),('8784','2013-04-08','17:45:00',1.31),('8784','2013-04-08','17:50:00',1.07),('8784','2013-04-08','18:00:00',1.02),('8784','2013-04-08','18:20:00',1.16),('8784','2013-04-08','18:25:00',1.05),('8784','2013-04-07','08:30:00',1.09),('8784','2013-04-07','08:35:00',1.19),('8784','2013-04-07','08:40:00',1.24),('8784','2013-04-07','08:45:00',1.26),('8784','2013-04-07','08:50:00',1.25),('8784','2013-04-07','08:55:00',1.3),('8784','2013-04-07','09:00:00',1.35),('8784','2013-04-07','09:05:00',1.4),('8784','2013-04-07','09:10:00',1.51),('8784','2013-04-07','09:15:00',1.56),('8784','2013-04-07','09:20:00',1.66),('8784','2013-04-07','09:25:00',1.67),('8784','2013-04-07','09:30:00',1.56),('8784','2013-04-07','09:35:00',1.49),('8784','2013-04-07','09:40:00',1.45),('8784','2013-04-07','09:45:00',1.6),('8784','2013-04-07','09:50:00',2.02),('8784','2013-04-07','09:55:00',2.18),('8784','2013-04-07','10:00:00',2.54),('8784','2013-04-07','10:05:00',2.75),('8784','2013-04-07','10:10:00',2.76),('8784','2013-04-07','10:15:00',2.83),('8784','2013-04-07','10:20:00',2.86),('8784','2013-04-07','10:25:00',2.98),('8784','2013-04-07','10:30:00',2.57),('8784','2013-04-07','10:35:00',2.67),('8784','2013-04-07','10:40:00',2.83),('8784','2013-04-07','10:45:00',2.74),('8784','2013-04-07','10:50:00',2.67),('8784','2013-04-07','10:55:00',2.36),('8784','2013-04-07','11:00:00',2.2),('8784','2013-04-07','11:05:00',1.97),('8784','2013-04-07','11:10:00',2.09),('8784','2013-04-07','11:15:00',2.83),('8784','2013-04-07','11:20:00',3.6),('8784','2013-04-07','11:25:00',3.8),('8784','2013-04-07','11:30:00',3.87),('8784','2013-04-07','11:35:00',3.58),('8784','2013-04-07','11:40:00',3.3),('8784','2013-04-07','11:45:00',2.63),('8784','2013-04-07','11:50:00',2.38),('8784','2013-04-07','11:55:00',2.49),('8784','2013-04-07','12:00:00',2.55),('8784','2013-04-07','12:05:00',2.56),('8784','2013-04-07','12:10:00',2.75),('8784','2013-04-07','12:15:00',2.69),('8784','2013-04-07','12:20:00',2.9),('8784','2013-04-07','12:25:00',3.22),('8784','2013-04-07','12:30:00',2.91),('8784','2013-04-07','12:35:00',2.94),('8784','2013-04-07','12:40:00',2.95),('8784','2013-04-07','12:45:00',2.52),('8784','2013-04-07','12:50:00',2.73),('8784','2013-04-07','12:55:00',2.73),('8784','2013-04-07','13:00:00',3.24),('8784','2013-04-07','13:05:00',3.57),('8784','2013-04-07','13:10:00',3.41),('8784','2013-04-07','13:15:00',3.09),('8784','2013-04-07','13:20:00',2.97),('8784','2013-04-07','13:25:00',3.33),('8784','2013-04-07','13:30:00',2.91),('8784','2013-04-07','13:35:00',3.11),('8784','2013-04-07','13:40:00',3.42),('8784','2013-04-07','13:45:00',3.21),('8784','2013-04-07','13:50:00',2.78),('8784','2013-04-07','13:55:00',2.96),('8784','2013-04-07','14:00:00',3.72),('8784','2013-04-07','14:05:00',3.43),('8784','2013-04-07','14:10:00',1.9),('8784','2013-04-07','14:15:00',2.65),('8784','2013-04-07','14:20:00',2.53),('8784','2013-04-07','14:25:00',2.09),('8784','2013-04-07','14:30:00',1.65),('8784','2013-04-07','14:35:00',1.87),('8784','2013-04-07','14:40:00',2.18),('8784','2013-04-07','14:45:00',1.9),('8784','2013-04-07','14:50:00',2.25),('8784','2013-04-07','14:55:00',2.49),('8784','2013-04-07','15:00:00',1.74),('8784','2013-04-07','15:05:00',2.4),('8784','2013-04-07','15:10:00',2.06),('8784','2013-04-07','15:15:00',2.75),('8784','2013-04-07','15:20:00',2.72),('8784','2013-04-07','15:25:00',2.92),('8784','2013-04-07','15:30:00',2.99),('8784','2013-04-07','15:35:00',2.88),('8784','2013-04-07','15:40:00',2.58),('8784','2013-04-07','15:45:00',2.5),('8784','2013-04-07','15:50:00',2.65),('8784','2013-04-07','15:55:00',2.41),('8784','2013-04-07','16:00:00',2.34),('8784','2013-04-07','16:05:00',2.02),('8784','2013-04-07','16:10:00',1.81),('8784','2013-04-07','16:15:00',1.56),('8784','2013-04-07','16:20:00',1.55),('8784','2013-04-07','16:25:00',1.3),('8784','2013-04-07','16:30:00',1.42),('8784','2013-04-07','16:35:00',1.92),('8784','2013-04-07','16:40:00',1.66),('8784','2013-04-07','16:45:00',2.08),('8784','2013-04-07','16:50:00',2.34),('8784','2013-04-07','16:55:00',2.28),('8784','2013-04-07','17:00:00',2.17),('8784','2013-04-07','17:05:00',1.95),('8784','2013-04-07','17:10:00',1.6),('8784','2013-04-07','17:15:00',1.1),('8784','2013-04-07','17:20:00',1.63),('8784','2013-04-07','17:25:00',1.96),('8784','2013-04-07','17:30:00',1.77),('8784','2013-04-07','17:35:00',1.7),('8784','2013-04-07','17:40:00',1.69),('8784','2013-04-07','17:45:00',1.63),('8784','2013-04-07','17:50:00',1.48),('8784','2013-04-07','17:55:00',1.24),('8784','2013-04-06','08:05:00',1.01),('8784','2013-04-06','08:10:00',1.08),('8784','2013-04-06','08:15:00',1.17),('8784','2013-04-06','08:20:00',1.25),('8784','2013-04-06','08:25:00',1.34),('8784','2013-04-06','08:30:00',1.42),('8784','2013-04-06','08:35:00',1.52),('8784','2013-04-06','08:40:00',1.61),('8784','2013-04-06','08:45:00',1.7),('8784','2013-04-06','08:50:00',1.79),('8784','2013-04-06','08:55:00',1.87),('8784','2013-04-06','09:00:00',1.94),('8784','2013-04-06','09:05:00',2.02),('8784','2013-04-06','09:10:00',2.11),('8784','2013-04-06','09:15:00',2.18),('8784','2013-04-06','09:20:00',2.29),('8784','2013-04-06','09:25:00',2.39),('8784','2013-04-06','09:30:00',2.45),('8784','2013-04-06','09:35:00',2.48),('8784','2013-04-06','09:40:00',2.58),('8784','2013-04-06','09:45:00',2.65),('8784','2013-04-06','09:50:00',2.73),('8784','2013-04-06','09:55:00',2.78),('8784','2013-04-06','10:00:00',2.85),('8784','2013-04-06','10:05:00',2.94),('8784','2013-04-06','10:10:00',2.97),('8784','2013-04-06','10:15:00',3.03),('8784','2013-04-06','10:20:00',3.13),('8784','2013-04-06','10:25:00',3.13),('8784','2013-04-06','10:30:00',3.18),('8784','2013-04-06','10:35:00',3.21),('8784','2013-04-06','10:40:00',3.34),('8784','2013-04-06','10:45:00',3.39),('8784','2013-04-06','10:50:00',3.43),('8784','2013-04-06','10:55:00',3.49),('8784','2013-04-06','11:00:00',3.58),('8784','2013-04-06','11:05:00',3.63),('8784','2013-04-06','11:10:00',3.64),('8784','2013-04-06','11:15:00',3.66),('8784','2013-04-06','11:20:00',3.73),('8784','2013-04-06','11:25:00',3.75),('8784','2013-04-06','11:30:00',3.77),('8784','2013-04-06','11:35:00',3.8),('8784','2013-04-06','11:40:00',3.78),('8784','2013-04-06','11:45:00',3.81),('8784','2013-04-06','11:50:00',3.89),('8784','2013-04-06','11:55:00',3.91),('8784','2013-04-06','12:00:00',3.93),('8784','2013-04-06','12:05:00',3.99),('8784','2013-04-06','12:10:00',3.95),('8784','2013-04-06','12:15:00',4.04),('8784','2013-04-06','12:20:00',4.07),('8784','2013-04-06','12:25:00',4.1),('8784','2013-04-06','12:30:00',4.13),('8784','2013-04-06','12:35:00',4.19),('8784','2013-04-06','12:40:00',4.18),('8784','2013-04-06','12:45:00',4.23),('8784','2013-04-06','12:50:00',4.23),('8784','2013-04-06','12:55:00',4.31),('8784','2013-04-06','13:00:00',2.32),('8784','2013-04-06','13:05:00',4.06),('8784','2013-04-06','13:10:00',4.4),('8784','2013-04-06','13:15:00',4.73),('8784','2013-04-06','13:20:00',3.13),('8784','2013-04-06','13:25:00',1.23),('8784','2013-04-06','13:30:00',4.22),('8784','2013-04-06','13:35:00',4.17),('8784','2013-04-06','13:40:00',1.26),('8784','2013-04-06','13:45:00',2.52),('8784','2013-04-06','13:50:00',4.66),('8784','2013-04-06','13:55:00',4.79),('8784','2013-04-06','14:00:00',4.69),('8784','2013-04-06','14:05:00',4.62),('8784','2013-04-06','14:10:00',4.48),('8784','2013-04-06','14:15:00',2.06),('8784','2013-04-06','14:20:00',2.37),('8784','2013-04-06','14:25:00',1.12),('8784','2013-04-06','14:30:00',3.65),('8784','2013-04-06','14:35:00',4.11),('8784','2013-04-06','14:40:00',3.76),('8784','2013-04-06','14:45:00',3.02),('8784','2013-04-06','14:50:00',3.85),('8784','2013-04-06','14:55:00',2.59),('8784','2013-04-06','15:00:00',3.48),('8784','2013-04-06','15:05:00',3.67),('8784','2013-04-06','15:10:00',3.52),('8784','2013-04-06','15:15:00',3.5),('8784','2013-04-06','15:20:00',3.46),('8784','2013-04-06','15:25:00',3.38),('8784','2013-04-06','15:30:00',3.2),('8784','2013-04-06','15:35:00',3.2),('8784','2013-04-06','15:40:00',3.16),('8784','2013-04-06','15:45:00',2.72),('8784','2013-04-06','15:50:00',2.78),('8784','2013-04-06','15:55:00',2.97),('8784','2013-04-06','16:00:00',2.74),('8784','2013-04-06','16:05:00',2.96),('8784','2013-04-06','16:10:00',2.87),('8784','2013-04-06','16:15:00',2.61),('8784','2013-04-06','16:20:00',2.13),('8784','2013-04-06','16:25:00',1.91),('8784','2013-04-06','16:30:00',2.31),('8784','2013-04-06','16:35:00',2.12),('8784','2013-04-06','16:40:00',1.8),('8784','2013-04-06','16:45:00',2.32),('8784','2013-04-06','16:50:00',2.16),('8784','2013-04-06','16:55:00',1.97),('8784','2013-04-06','17:00:00',1.89),('8784','2013-04-06','17:05:00',1.67),('8784','2013-04-06','17:10:00',1.49),('8784','2013-04-06','17:15:00',1.14),('8784','2013-04-05','08:15:00',1.19),('8784','2013-04-05','08:20:00',1.3),('8784','2013-04-05','08:55:00',1.04),('8784','2013-04-05','09:05:00',2.39),('8784','2013-04-05','09:10:00',1.41),('8784','2013-04-05','09:15:00',2.31),('8784','2013-04-05','09:20:00',2.43),('8784','2013-04-05','09:25:00',1.15),('8784','2013-04-05','09:35:00',1.17),('8784','2013-04-05','09:40:00',2.53),('8784','2013-04-05','09:45:00',1.99),('8784','2013-04-05','09:50:00',1.39),('8784','2013-04-05','09:55:00',1.05),('8784','2013-04-05','10:00:00',1.64),('8784','2013-04-05','10:05:00',1.15),('8784','2013-04-05','10:10:00',2.72),('8784','2013-04-05','10:15:00',3.08),('8784','2013-04-05','10:20:00',1.16),('8784','2013-04-05','10:25:00',2.65),('8784','2013-04-05','10:30:00',1.78),('8784','2013-04-05','10:35:00',1.76),('8784','2013-04-05','10:40:00',4.11),('8784','2013-04-05','10:45:00',1.46),('8784','2013-04-05','10:50:00',2.6),('8784','2013-04-05','10:55:00',2.7),('8784','2013-04-05','11:00:00',2.83),('8784','2013-04-05','11:05:00',3.22),('8784','2013-04-05','11:10:00',4.02),('8784','2013-04-05','11:15:00',3.68),('8784','2013-04-05','11:20:00',3.39),('8784','2013-04-05','11:25:00',3.45),('8784','2013-04-05','11:30:00',3.9),('8784','2013-04-05','11:35:00',4.44),('8784','2013-04-05','11:40:00',4.25),('8784','2013-04-05','11:45:00',3.7),('8784','2013-04-05','11:50:00',4.24),('8784','2013-04-05','11:55:00',4.32),('8784','2013-04-05','12:00:00',4.34),('8784','2013-04-05','12:05:00',2.88),('8784','2013-04-05','12:10:00',2.32),('8784','2013-04-05','12:15:00',3.44),('8784','2013-04-05','12:20:00',1.65),('8784','2013-04-05','12:25:00',2.5),('8784','2013-04-05','12:30:00',1.39),('8784','2013-04-05','12:35:00',1.52),('8784','2013-04-05','12:40:00',1.98),('8784','2013-04-05','12:45:00',3.59),('8784','2013-04-05','12:50:00',4.4),('8784','2013-04-05','12:55:00',3.61),('8784','2013-04-05','13:00:00',3.62),('8784','2013-04-05','13:05:00',3.41),('8784','2013-04-05','13:10:00',3.16),('8784','2013-04-05','13:15:00',4.35),('8784','2013-04-05','13:20:00',4),('8784','2013-04-05','13:25:00',3.67),('8784','2013-04-05','13:30:00',4),('8784','2013-04-05','13:35:00',3.76),('8784','2013-04-05','13:40:00',3.27),('8784','2013-04-05','13:45:00',3.94),('8784','2013-04-05','13:50:00',4.42),('8784','2013-04-05','13:55:00',3.41),('8784','2013-04-05','14:00:00',3.29),('8784','2013-04-05','14:05:00',4.89),('8784','2013-04-05','14:10:00',4.32),('8784','2013-04-05','14:15:00',4.11),('8784','2013-04-05','14:20:00',2.63),('8784','2013-04-05','14:25:00',3.96),('8784','2013-04-05','14:30:00',4.25),('8784','2013-04-05','14:35:00',3.63),('8784','2013-04-05','14:40:00',3.42),('8784','2013-04-05','14:45:00',3.21),('8784','2013-04-05','14:50:00',2.84),('8784','2013-04-05','14:55:00',4.22),('8784','2013-04-05','15:00:00',4.01),('8784','2013-04-05','15:05:00',4.03),('8784','2013-04-05','15:10:00',2.63),('8784','2013-04-05','15:15:00',1.75),('8784','2013-04-05','15:20:00',1.84),('8784','2013-04-05','15:25:00',1.99),('8784','2013-04-05','15:30:00',1.7),('8784','2013-04-05','15:35:00',1.34),('8784','2013-04-05','15:40:00',1.21),('8784','2013-04-05','15:45:00',1.5),('8784','2013-04-05','15:50:00',1.87),('8784','2013-04-05','15:55:00',1.77),('8784','2013-04-05','16:00:00',1.81),('8784','2013-04-05','16:05:00',1.71),('8784','2013-04-05','16:10:00',1.76),('8784','2013-04-05','16:15:00',2.03),('8784','2013-04-05','16:20:00',1.85),('8784','2013-04-05','16:25:00',1.58),('8784','2013-04-05','16:30:00',1.63),('8784','2013-04-05','16:35:00',2.11),('8784','2013-04-05','16:40:00',1.67),('8784','2013-04-05','16:45:00',2.15),('8784','2013-04-05','16:50:00',2.65),('8784','2013-04-05','16:55:00',1.4),('8784','2013-04-05','17:00:00',1.36),('8784','2013-04-05','17:05:00',1.1),('8784','2013-04-05','17:10:00',2.81),('8784','2013-04-05','17:15:00',2.32),('8784','2013-04-05','17:20:00',1.83),('8784','2013-04-05','17:25:00',2.14),('8784','2013-04-05','17:30:00',1.41),('8784','2013-04-05','17:35:00',1.77),('8784','2013-04-05','17:40:00',1.21),('8784','2013-04-05','17:50:00',1.17),('8784','2013-04-05','17:55:00',1.66),('8784','2013-04-04','08:55:00',1.47),('8784','2013-04-04','09:00:00',2.1),('8784','2013-04-04','09:05:00',1.49),('8784','2013-04-04','09:10:00',1.42),('8784','2013-04-04','09:15:00',1.4),('8784','2013-04-04','09:20:00',1.37),('8784','2013-04-04','09:25:00',1.09),('8784','2013-04-04','09:30:00',1.66),('8784','2013-04-04','09:35:00',2.68),('8784','2013-04-04','09:40:00',2.42),('8784','2013-04-04','09:45:00',2.13),('8784','2013-04-04','09:50:00',1.19),('8784','2013-04-04','09:55:00',1.35),('8784','2013-04-04','10:00:00',1.97),('8784','2013-04-04','10:05:00',2.56),('8784','2013-04-04','10:10:00',2.13),('8784','2013-04-04','10:15:00',1.69),('8784','2013-04-04','10:20:00',2),('8784','2013-04-04','10:25:00',3.68),('8784','2013-04-04','10:30:00',3.07),('8784','2013-04-04','10:35:00',2.1),('8784','2013-04-04','10:40:00',3.91),('8784','2013-04-04','10:45:00',2.13),('8784','2013-04-04','10:50:00',2.38),('8784','2013-04-04','10:55:00',3.97),('8784','2013-04-04','11:00:00',2.4),('8784','2013-04-04','11:05:00',1.33),('8784','2013-04-04','11:10:00',1.19),('8784','2013-04-04','11:15:00',1.61),('8784','2013-04-04','11:20:00',1.46),('8784','2013-04-04','11:25:00',1.14),('8784','2013-04-04','11:30:00',1.25),('8784','2013-04-04','11:35:00',1.86),('8784','2013-04-04','11:40:00',3.07),('8784','2013-04-04','11:45:00',3.53),('8784','2013-04-04','11:50:00',4.01),('8784','2013-04-04','11:55:00',3.77),('8784','2013-04-04','12:00:00',3.46),('8784','2013-04-04','12:05:00',4),('8784','2013-04-04','12:10:00',4.14),('8784','2013-04-04','12:15:00',3.98),('8784','2013-04-04','12:20:00',3.39),('8784','2013-04-04','12:25:00',2.61),('8784','2013-04-04','12:30:00',3.33),('8784','2013-04-04','12:35:00',3.75),('8784','2013-04-04','12:40:00',3.97),('8784','2013-04-04','12:45:00',3.96),('8784','2013-04-04','12:50:00',4.02),('8784','2013-04-04','12:55:00',3.86),('8784','2013-04-04','13:00:00',3.87),('8784','2013-04-04','13:05:00',3.83),('8784','2013-04-04','13:10:00',3.99),('8784','2013-04-04','13:15:00',4.1),('8784','2013-04-04','13:20:00',3.97),('8784','2013-04-04','13:25:00',4.13),('8784','2013-04-04','13:30:00',3.95),('8784','2013-04-04','13:35:00',3.57),('8784','2013-04-04','13:40:00',3.05),('8784','2013-04-04','13:45:00',3.4),('8784','2013-04-04','13:50:00',3.29),('8784','2013-04-04','13:55:00',2.54),('8784','2013-04-04','14:00:00',2.77),('8784','2013-04-04','14:05:00',3.68),('8784','2013-04-04','14:10:00',3.99),('8784','2013-04-04','14:15:00',3.9),('8784','2013-04-04','14:20:00',3.85),('8784','2013-04-04','14:25:00',3.75),('8784','2013-04-04','14:30:00',3.72),('8784','2013-04-04','14:35:00',3.47),('8784','2013-04-04','14:40:00',3.72),('8784','2013-04-04','14:45:00',3.65),('8784','2013-04-04','14:50:00',3.6),('8784','2013-04-04','14:55:00',3.57),('8784','2013-04-04','15:00:00',3.53),('8784','2013-04-04','15:05:00',3.38),('8784','2013-04-04','15:10:00',3.21),('8784','2013-04-04','15:15:00',3.21),('8784','2013-04-04','15:20:00',3.24),('8784','2013-04-04','15:25:00',3.29),('8784','2013-04-04','15:30:00',3.25),('8784','2013-04-04','15:35:00',3.15),('8784','2013-04-04','15:40:00',3.1),('8784','2013-04-04','15:45:00',3.05),('8784','2013-04-04','15:50:00',2.93),('8784','2013-04-04','15:55:00',2.89),('8784','2013-04-04','16:00:00',2.8),('8784','2013-04-04','16:05:00',2.7),('8784','2013-04-04','16:10:00',2.51),('8784','2013-04-04','16:15:00',2.43),('8784','2013-04-04','16:20:00',2.35),('8784','2013-04-04','16:25:00',2.2),('8784','2013-04-04','16:30:00',1.87),('8784','2013-04-04','16:35:00',1.83),('8784','2013-04-04','16:40:00',1.92),('8784','2013-04-04','16:45:00',1.73),('8784','2013-04-04','16:50:00',1.62),('8784','2013-04-04','16:55:00',1.85),('8784','2013-04-04','17:00:00',1.71),('8784','2013-04-04','17:05:00',1.68),('8784','2013-04-04','17:10:00',1.55),('8784','2013-04-04','17:15:00',1.38),('8784','2013-04-04','17:25:00',1.07),('8784','2013-04-04','17:55:00',1.13),('8784','2013-04-03','08:05:00',1.01),('8784','2013-04-03','08:10:00',1.11),('8784','2013-04-03','08:15:00',1.21),('8784','2013-04-03','08:20:00',1.31),('8784','2013-04-03','08:25:00',1.21),('8784','2013-04-03','08:30:00',1.58),('8784','2013-04-03','08:45:00',1.71),('8784','2013-04-03','08:50:00',1.9),('8784','2013-04-03','08:55:00',1.98),('8784','2013-04-03','09:00:00',2.05),('8784','2013-04-03','09:05:00',2.21),('8784','2013-04-03','09:10:00',2.25),('8784','2013-04-03','09:15:00',2.46),('8784','2013-04-03','09:20:00',2.29),('8784','2013-04-03','09:25:00',2.88),('8784','2013-04-03','09:30:00',2.61),('8784','2013-04-03','09:35:00',1.76),('8784','2013-04-03','09:40:00',2.85),('8784','2013-04-03','09:45:00',2.85),('8784','2013-04-03','09:50:00',2.98),('8784','2013-04-03','09:55:00',2.35),('8784','2013-04-03','10:00:00',1.9),('8784','2013-04-03','10:05:00',1.25),('8784','2013-04-03','10:10:00',1.32),('8784','2013-04-03','10:15:00',2),('8784','2013-04-03','10:20:00',3.82),('8784','2013-04-03','10:25:00',3.41),('8784','2013-04-03','10:30:00',4),('8784','2013-04-03','10:35:00',2.48),('8784','2013-04-03','10:40:00',1.77),('8784','2013-04-03','10:45:00',1.44),('8784','2013-04-03','10:50:00',1.72),('8784','2013-04-03','10:55:00',1.82),('8784','2013-04-03','11:00:00',4.5),('8784','2013-04-03','11:05:00',3.45),('8784','2013-04-03','11:10:00',2.05),('8784','2013-04-03','11:15:00',4.55),('8784','2013-04-03','11:20:00',3.78),('8784','2013-04-03','11:25:00',1.91),('8784','2013-04-03','11:30:00',2.02),('8784','2013-04-03','11:35:00',2.96),('8784','2013-04-03','11:40:00',1.68),('8784','2013-04-03','11:45:00',1.93),('8784','2013-04-03','11:50:00',4.26),('8784','2013-04-03','11:55:00',2.57),('8784','2013-04-03','12:00:00',3.48),('8784','2013-04-03','12:05:00',4.31),('8784','2013-04-03','12:10:00',2.9),('8784','2013-04-03','12:15:00',3.41),('8784','2013-04-03','12:20:00',3.89),('8784','2013-04-03','12:25:00',4.98),('8784','2013-04-03','12:30:00',4.63),('8784','2013-04-03','12:35:00',4.92),('8784','2013-04-03','12:40:00',4.83),('8784','2013-04-03','12:45:00',4.61),('8784','2013-04-03','12:50:00',4.84),('8784','2013-04-03','12:55:00',3.43),('8784','2013-04-03','13:00:00',2.98),('8784','2013-04-03','13:05:00',4.43),('8784','2013-04-03','13:10:00',3.63),('8784','2013-04-03','13:15:00',4.84),('8784','2013-04-03','13:20:00',3.19),('8784','2013-04-03','13:25:00',3.55),('8784','2013-04-03','13:30:00',3.78),('8784','2013-04-03','13:35:00',4.03),('8784','2013-04-03','13:40:00',3.94),('8784','2013-04-03','13:45:00',3.47),('8784','2013-04-03','13:50:00',2.26),('8784','2013-04-03','13:55:00',2.96),('8784','2013-04-03','14:00:00',4.11),('8784','2013-04-03','14:05:00',5.09),('8784','2013-04-03','14:10:00',4.09),('8784','2013-04-03','14:15:00',2),('8784','2013-04-03','14:20:00',3.17),('8784','2013-04-03','14:25:00',3.81),('8784','2013-04-03','14:30:00',4.62),('8784','2013-04-03','14:35:00',4.14),('8784','2013-04-03','14:40:00',2.14),('8784','2013-04-03','14:45:00',2.96),('8784','2013-04-03','14:50:00',3.85),('8784','2013-04-03','14:55:00',3.94),('8784','2013-04-03','15:00:00',3.18),('8784','2013-04-03','15:05:00',3.78),('8784','2013-04-03','15:10:00',3.87),('8784','2013-04-03','15:15:00',4.2),('8784','2013-04-03','15:20:00',3.09),('8784','2013-04-03','15:25:00',3.79),('8784','2013-04-03','15:30:00',2.23),('8784','2013-04-03','15:35:00',2.71),('8784','2013-04-03','15:40:00',3.06),('8784','2013-04-03','15:45:00',3.03),('8784','2013-04-03','15:50:00',3.78),('8784','2013-04-03','15:55:00',3.6),('8784','2013-04-03','16:00:00',3.39),('8784','2013-04-03','16:05:00',3.36),('8784','2013-04-03','16:10:00',3.03),('8784','2013-04-03','16:15:00',3.11),('8784','2013-04-03','16:20:00',3.02),('8784','2013-04-03','16:25:00',2.94),('8784','2013-04-03','16:30:00',2.87),('8784','2013-04-03','16:35:00',2.59),('8784','2013-04-03','16:40:00',2.65),('8784','2013-04-03','16:45:00',2.52),('8784','2013-04-03','16:50:00',2.46),('8784','2013-04-03','16:55:00',2.38),('8784','2013-04-03','17:00:00',2.28),('8784','2013-04-03','17:05:00',2.2),('8784','2013-04-03','17:10:00',2.1),('8784','2013-04-03','17:15:00',2.02),('8784','2013-04-03','17:20:00',1.91),('8784','2013-04-03','17:25:00',1.75),('8784','2013-04-03','17:30:00',1.73),('8784','2013-04-03','17:35:00',1.61),('8784','2013-04-03','17:40:00',1.52),('8784','2013-04-03','17:45:00',1.42),('8784','2013-04-03','17:50:00',1.31),('8784','2013-04-03','17:55:00',1.23),('8784','2013-04-03','18:00:00',1.13),('8784','2013-04-03','18:05:00',1.03),('8784','2013-04-02','08:40:00',1.7),('8784','2013-04-02','08:45:00',1.79),('8784','2013-04-02','08:50:00',1.34),('8784','2013-04-02','08:55:00',1.33),('8784','2013-04-02','09:00:00',1.98),('8784','2013-04-02','09:05:00',2.04),('8784','2013-04-02','09:10:00',1.95),('8784','2013-04-02','09:15:00',1.7),('8784','2013-04-02','09:20:00',1.8),('8784','2013-04-02','09:25:00',1.18),('8784','2013-04-02','09:30:00',1.62),('8784','2013-04-02','09:35:00',2.83),('8784','2013-04-02','09:40:00',2.76),('8784','2013-04-02','09:45:00',2.4),('8784','2013-04-02','09:50:00',2.24),('8784','2013-04-02','09:55:00',1.87),('8784','2013-04-02','10:00:00',2.13),('8784','2013-04-02','10:05:00',1.39),('8784','2013-04-02','10:10:00',1.41),('8784','2013-04-02','10:15:00',1.57),('8784','2013-04-02','10:20:00',1.84),('8784','2013-04-02','10:25:00',1.81),('8784','2013-04-02','10:35:00',3.15),('8784','2013-04-02','10:40:00',2.1),('8784','2013-04-02','10:45:00',2.37),('8784','2013-04-02','10:50:00',3.89),('8784','2013-04-02','10:55:00',1.56),('8784','2013-04-02','11:00:00',1.19),('8784','2013-04-02','11:05:00',3.14),('8784','2013-04-02','11:10:00',1.54),('8784','2013-04-02','11:15:00',1.19),('8784','2013-04-02','11:20:00',1.01),('8784','2013-04-02','11:25:00',1.2),('8784','2013-04-02','11:30:00',1.32),('8784','2013-04-02','11:35:00',1.25),('8784','2013-04-02','11:40:00',1.08),('8784','2013-04-02','11:45:00',2.57),('8784','2013-04-02','11:50:00',2.36),('8784','2013-04-02','11:55:00',1.19),('8784','2013-04-02','12:00:00',1.11),('8784','2013-04-02','12:05:00',3.22),('8784','2013-04-02','12:10:00',2.09),('8784','2013-04-02','12:15:00',2.11),('8784','2013-04-02','12:30:00',1.04),('8784','2013-04-02','12:35:00',1.87),('8784','2013-04-02','12:40:00',2.03),('8784','2013-04-02','12:45:00',2.36),('8784','2013-04-02','12:50:00',2.32),('8784','2013-04-02','12:55:00',2.3),('8784','2013-04-02','13:00:00',2.55),('8784','2013-04-02','13:05:00',2.76),('8784','2013-04-02','13:10:00',3.36),('8784','2013-04-02','13:15:00',2.59),('8784','2013-04-02','13:20:00',2.12),('8784','2013-04-02','13:25:00',3.55),('8784','2013-04-02','13:30:00',2.67),('8784','2013-04-02','13:35:00',2.06),('8784','2013-04-02','13:40:00',3.07),('8784','2013-04-02','13:45:00',2.77),('8784','2013-04-02','13:50:00',2.26),('8784','2013-04-02','13:55:00',2.11),('8784','2013-04-02','14:00:00',2.62),('8784','2013-04-02','14:05:00',2.07),('8784','2013-04-02','14:10:00',2.62),('8784','2013-04-02','14:15:00',2.35),('8784','2013-04-02','14:20:00',4.14),('8784','2013-04-02','14:25:00',4.16),('8784','2013-04-02','14:30:00',2.34),('8784','2013-04-02','14:35:00',1.97),('8784','2013-04-02','14:40:00',2.63),('8784','2013-04-02','14:45:00',2.68),('8784','2013-04-02','14:50:00',2),('8784','2013-04-02','14:55:00',1.79),('8784','2013-04-02','15:00:00',1.55),('8784','2013-04-02','15:20:00',1.01),('8784','2013-04-02','15:45:00',1.25),('8784','2013-04-02','16:00:00',1.14),('8784','2013-04-02','16:05:00',1.25),('8784','2013-04-02','16:15:00',1.15),('8784','2013-04-02','16:20:00',1.11),('8784','2013-04-02','16:30:00',1.03),('8784','2013-04-02','16:35:00',1.03),('8784','2013-04-02','17:40:00',1.01),('8784','2014-05-02','07:35:00',1.07),('8784','2014-05-02','07:40:00',1.22),('8784','2014-05-02','07:45:00',1.31),('8784','2014-05-02','07:50:00',1.39),('8784','2014-05-02','07:55:00',1.56),('8784','2014-05-02','08:00:00',1.52),('8784','2014-05-02','08:05:00',1.49),('8784','2014-05-02','08:15:00',2.49),('8784','2014-05-02','08:20:00',1.99),('8784','2014-05-02','08:25:00',1.22),('8784','2014-05-02','08:45:00',1.34),('8784','2014-05-02','08:50:00',1.98),('8784','2014-05-02','09:15:00',1.3),('8784','2014-05-02','09:20:00',1.59),('8784','2014-05-02','09:25:00',1.83),('8784','2014-05-02','09:30:00',2.09),('8784','2014-05-02','09:35:00',1.9),('8784','2014-05-02','09:40:00',1.75),('8784','2014-05-02','09:45:00',1.89),('8784','2014-05-02','09:50:00',1.74),('8784','2014-05-02','09:55:00',1.66),('8784','2014-05-02','10:00:00',2),('8784','2014-05-02','10:05:00',2.24),('8784','2014-05-02','10:10:00',2.03),('8784','2014-05-02','10:15:00',1.78),('8784','2014-05-02','10:20:00',1.62),('8784','2014-05-02','10:25:00',1.35),('8784','2014-05-02','10:40:00',1.09),('8784','2014-05-02','10:45:00',1.36),('8784','2014-05-02','10:50:00',1.14),('8784','2014-05-02','12:30:00',1.18),('8784','2014-05-02','12:35:00',1.29),('8784','2014-05-02','12:40:00',1.27),('8784','2014-05-02','12:45:00',1.62),('8784','2014-05-02','12:50:00',2.07),('8784','2014-05-02','12:55:00',1.58),('8784','2014-05-02','13:00:00',1.77),('8784','2014-05-02','13:05:00',1.97),('8784','2014-05-02','13:10:00',2.03),('8784','2014-05-02','13:15:00',2.51),('8784','2014-05-02','13:20:00',3.32),('8784','2014-05-02','13:25:00',3.74),('8784','2014-05-02','13:30:00',2.99),('8784','2014-05-02','13:35:00',2.93),('8784','2014-05-02','13:40:00',2.68),('8784','2014-05-02','13:45:00',2.22),('8784','2014-05-02','13:50:00',1.83),('8784','2014-05-02','13:55:00',1.48),('8784','2014-05-02','14:00:00',1.6),('8784','2014-05-02','14:05:00',2.52),('8784','2014-05-02','14:10:00',1.12),('8784','2014-05-02','14:30:00',1.21),('8784','2014-05-02','14:35:00',1.83),('8784','2014-05-02','14:40:00',3.07),('8784','2014-05-02','14:45:00',1.72),('8784','2014-05-02','14:50:00',1.51),('8784','2014-05-02','14:55:00',2.09),('8784','2014-05-02','15:00:00',2.66),('8784','2014-05-02','15:05:00',2.09),('8784','2014-05-02','15:10:00',4.35),('8784','2014-05-02','15:15:00',2.84),('8784','2014-05-02','15:20:00',2.88),('8784','2014-05-02','15:25:00',1.62),('8784','2014-05-02','15:30:00',1.38),('8784','2014-05-02','15:35:00',2.92),('8784','2014-05-02','15:40:00',3.76),('8784','2014-05-02','15:45:00',1.41),('8784','2014-05-02','16:00:00',1.53),('8784','2014-05-02','16:05:00',1.88),('8784','2014-05-02','16:10:00',1.21),('8784','2014-05-02','16:15:00',1.34),('8784','2014-05-02','16:20:00',2.5),('8784','2014-05-02','17:20:00',1.09),('8784','2014-05-02','17:25:00',1.28),('8784','2014-03-27','07:55:00',1.26),('8784','2014-03-27','08:00:00',1.5),('8784','2014-03-27','08:05:00',1.58),('8784','2014-03-27','09:15:00',1.03),('8784','2014-03-27','10:05:00',1.22),('8784','2014-03-27','10:10:00',1.4),('8784','2014-03-27','10:15:00',1.31),('8784','2014-03-27','10:20:00',1.81),('8784','2014-03-27','10:25:00',2.24),('8784','2014-03-27','10:30:00',2.17),('8784','2014-03-27','10:35:00',1.95),('8784','2014-03-27','10:40:00',2.21),('8784','2014-03-27','10:45:00',1.14),('8784','2014-03-27','11:10:00',3.21),('8784','2014-03-27','11:15:00',2.38),('8784','2014-03-27','11:20:00',1.24),('8784','2014-03-27','11:50:00',1.16),('8784','2014-03-27','11:55:00',1.5),('8784','2014-03-27','12:00:00',1.25),('8784','2014-03-27','12:05:00',1.14),('8784','2014-03-27','12:10:00',1.39),('8784','2014-03-27','12:15:00',1.05),('8784','2014-03-27','12:20:00',1.12),('8784','2014-03-27','13:00:00',1.02),('8784','2014-03-27','13:05:00',1.25),('8784','2014-03-27','13:10:00',1.74),('8784','2014-03-27','13:15:00',2.34),('8784','2014-03-27','13:20:00',2.49),('8784','2014-03-27','13:25:00',2.56),('8784','2014-03-27','13:30:00',2.22),('8784','2014-03-27','13:35:00',2.01),('8784','2014-03-27','13:40:00',1.91),('8784','2014-03-27','13:45:00',1.77),('8784','2014-03-27','13:50:00',2.25),('8784','2014-03-27','13:55:00',2.89),('8784','2014-03-27','14:00:00',2.15),('8784','2014-03-27','14:05:00',1.18),('8784','2014-03-27','14:15:00',2.74),('8784','2014-03-27','14:20:00',3.73),('8784','2014-03-27','14:25:00',3.95),('8784','2014-03-27','14:30:00',3.78),('8784','2014-03-27','14:35:00',2.26),('8784','2014-03-27','14:40:00',1.97),('8784','2014-03-27','14:45:00',1.84),('8784','2014-03-27','14:50:00',2.34),('8784','2014-03-27','14:55:00',1.82),('8784','2014-03-27','15:00:00',3.77),('8784','2014-03-27','15:05:00',1.43),('8784','2014-03-27','15:20:00',1.05),('8784','2014-03-27','15:25:00',2.94),('8784','2014-03-27','15:30:00',2.73),('8784','2014-03-27','15:35:00',2.65),('8784','2014-03-27','15:40:00',1.24),('8784','2014-03-27','16:05:00',1.08),('8784','2014-03-27','16:10:00',1.28),('8784','2014-03-27','16:15:00',1.1),('8784','2014-03-27','16:25:00',1.1),('8784','2014-03-27','16:30:00',1.26),('8784','2013-04-01','08:25:00',1.4),('8784','2013-04-01','08:30:00',1.36),('8784','2013-04-01','08:35:00',1.49),('8784','2013-04-01','08:40:00',1.36),('8784','2013-04-01','08:50:00',1.15),('8784','2013-04-01','08:55:00',1.52),('8784','2013-04-01','09:00:00',1.94),('8784','2013-04-01','09:05:00',2.04),('8784','2013-04-01','09:10:00',2.19),('8784','2013-04-01','09:15:00',1.76),('8784','2013-04-01','09:20:00',1.96),('8784','2013-04-01','09:25:00',1.89),('8784','2013-04-01','09:30:00',1.9),('8784','2013-04-01','09:35:00',2.19),('8784','2013-04-01','09:40:00',1.97),('8784','2013-04-01','09:45:00',2.82),('8784','2013-04-01','09:50:00',2.86),('8784','2013-04-01','09:55:00',2.74),('8784','2013-04-01','10:00:00',3.07),('8784','2013-04-01','10:05:00',3.11),('8784','2013-04-01','10:10:00',2.46),('8784','2013-04-01','10:15:00',2.87),('8784','2013-04-01','10:20:00',2.39),('8784','2013-04-01','10:25:00',3.03),('8784','2013-04-01','10:30:00',2.39),('8784','2013-04-01','10:35:00',1.39),('8784','2013-04-01','10:40:00',2),('8784','2013-04-01','10:45:00',3.8),('8784','2013-04-01','10:50:00',1.81),('8784','2013-04-01','10:55:00',2.12),('8784','2013-04-01','11:00:00',1.23),('8784','2013-04-01','11:05:00',1.55),('8784','2013-04-01','11:10:00',2.87),('8784','2013-04-01','11:15:00',2.78),('8784','2013-04-01','11:20:00',3.92),('8784','2013-04-01','11:25:00',1.92),('8784','2013-04-01','11:30:00',1.68),('8784','2013-04-01','11:35:00',1.98),('8784','2013-04-01','11:40:00',3.19),('8784','2013-04-01','11:45:00',3.15),('8784','2013-04-01','11:50:00',2.62),('8784','2013-04-01','11:55:00',2.28),('8784','2013-04-01','12:00:00',3.01),('8784','2013-04-01','12:05:00',1.89),('8784','2013-04-01','12:10:00',2.51),('8784','2013-04-01','12:15:00',2.06),('8784','2013-04-01','12:20:00',1.75),('8784','2013-04-01','12:25:00',1.95),('8784','2013-04-01','12:30:00',2.73),('8784','2013-04-01','12:35:00',2.49),('8784','2013-04-01','12:40:00',2.55),('8784','2013-04-01','12:45:00',2.86),('8784','2013-04-01','12:50:00',3.03),('8784','2013-04-01','12:55:00',3.2),('8784','2013-04-01','13:00:00',3.15),('8784','2013-04-01','13:05:00',3.35),('8784','2013-04-01','13:10:00',3),('8784','2013-04-01','13:15:00',3.18),('8784','2013-04-01','13:20:00',3.03),('8784','2013-04-01','13:25:00',2.84),('8784','2013-04-01','13:30:00',3.06),('8784','2013-04-01','13:35:00',2.79),('8784','2013-04-01','13:40:00',3.68),('8784','2013-04-01','13:45:00',3.92),('8784','2013-04-01','13:50:00',4.32),('8784','2013-04-01','13:55:00',4.15),('8784','2013-04-01','14:00:00',2.48),('8784','2013-04-01','14:05:00',1.99),('8784','2013-04-01','14:10:00',2.52),('8784','2013-04-01','14:15:00',2.77),('8784','2013-04-01','14:20:00',2.93),('8784','2013-04-01','14:25:00',4.29),('8784','2013-04-01','14:30:00',2.63),('8784','2013-04-01','14:35:00',2.26),('8784','2013-04-01','14:40:00',1.97),('8784','2013-04-01','14:45:00',2.02),('8784','2013-04-01','14:50:00',2.18),('8784','2013-04-01','14:55:00',2.31),('8784','2013-04-01','15:00:00',2.1),('8784','2013-04-01','15:05:00',2.11),('8784','2013-04-01','15:10:00',2.17),('8784','2013-04-01','15:15:00',2.32),('8784','2013-04-01','15:20:00',2.36),('8784','2013-04-01','15:25:00',2.38),('8784','2013-04-01','15:30:00',2.1),('8784','2013-04-01','15:35:00',2.65),('8784','2013-04-01','15:40:00',2.45),('8784','2013-04-01','15:45:00',2.56),('8784','2013-04-01','15:50:00',2.83),('8784','2013-04-01','15:55:00',2.13),('8784','2013-04-01','16:00:00',1.99),('8784','2013-04-01','16:05:00',1.64),('8784','2013-04-01','16:10:00',1.4),('8784','2013-04-01','16:15:00',1.14),('8784','2013-04-01','16:20:00',1.1),('8784','2013-04-01','16:25:00',1.03),('8784','2013-03-31','08:30:00',1.11),('8784','2013-03-31','08:35:00',1.14),('8784','2013-03-31','08:40:00',1.14),('8784','2013-03-31','08:45:00',1.38),('8784','2013-03-31','08:50:00',1.13),('8784','2013-03-31','08:55:00',1.24),('8784','2013-03-31','09:00:00',1.17),('8784','2013-03-31','09:05:00',1.11),('8784','2013-03-31','09:10:00',1.2),('8784','2013-03-31','09:15:00',1.56),('8784','2013-03-31','09:20:00',2.52),('8784','2013-03-31','09:25:00',2.95),('8784','2013-03-31','09:30:00',2.12),('8784','2013-03-31','09:35:00',2.24),('8784','2013-03-31','09:40:00',1.42),('8784','2013-03-31','09:45:00',2.49),('8784','2013-03-31','09:50:00',1.65),('8784','2013-03-31','09:55:00',2.06),('8784','2013-03-31','10:00:00',1.96),('8784','2013-03-31','10:15:00',1.09),('8784','2013-03-31','10:20:00',2.32),('8784','2013-03-31','10:25:00',2.51),('8784','2013-03-31','10:30:00',3.01),('8784','2013-03-31','10:35:00',3.02),('8784','2013-03-31','10:45:00',1.32),('8784','2013-03-31','10:50:00',2.15),('8784','2013-03-31','10:55:00',1.02),('8784','2013-03-31','11:10:00',1.53),('8784','2013-03-31','11:15:00',1.38),('8784','2013-03-31','11:20:00',1.25),('8784','2013-03-31','11:25:00',1.68),('8784','2013-03-31','11:30:00',1.29),('8784','2013-03-31','11:35:00',1.67),('8784','2013-03-31','11:40:00',1.71),('8784','2013-03-31','11:45:00',1.52),('8784','2013-03-31','11:50:00',1.67),('8784','2013-03-31','11:55:00',1.81),('8784','2013-03-31','12:00:00',1.68),('8784','2013-03-31','12:05:00',1.55),('8784','2013-03-31','12:10:00',1.4),('8784','2013-03-31','12:15:00',1.55),('8784','2013-03-31','12:20:00',1.38),('8784','2013-03-31','12:25:00',1.7),('8784','2013-03-31','12:30:00',2),('8784','2013-03-31','12:35:00',3.14),('8784','2013-03-31','12:40:00',3.02),('8784','2013-03-31','12:45:00',1.76),('8784','2013-03-31','12:50:00',1.84),('8784','2013-03-31','12:55:00',2.17),('8784','2013-03-31','13:00:00',2.62),('8784','2013-03-31','13:05:00',2.1),('8784','2013-03-31','13:10:00',3.04),('8784','2013-03-31','13:15:00',3.5),('8784','2013-03-31','13:20:00',3.72),('8784','2013-03-31','13:25:00',2.33),('8784','2013-03-31','13:40:00',1.87),('8784','2013-03-31','13:45:00',1.77),('8784','2013-03-31','13:50:00',2.31),('8784','2013-03-31','13:55:00',1.68),('8784','2013-03-31','14:00:00',1.98),('8784','2013-03-31','14:05:00',2.96),('8784','2013-03-31','14:10:00',2.62),('8784','2013-03-31','14:15:00',2.9),('8784','2013-03-31','14:20:00',1.67),('8784','2013-03-31','14:25:00',1.84),('8784','2013-03-31','14:30:00',3.21),('8784','2013-03-31','14:35:00',4.45),('8784','2013-03-31','14:40:00',4.59),('8784','2013-03-31','14:45:00',3.34),('8784','2013-03-31','14:50:00',3.16),('8784','2013-03-31','14:55:00',3.1),('8784','2013-03-31','15:00:00',3.37),('8784','2013-03-31','15:05:00',2.23),('8784','2013-03-31','15:10:00',3.3),('8784','2013-03-31','15:15:00',3.29),('8784','2013-03-31','15:20:00',4.08),('8784','2013-03-31','15:25:00',2.63),('8784','2013-03-31','15:30:00',2.51),('8784','2013-03-31','15:35:00',3.4),('8784','2013-03-31','15:40:00',4.08),('8784','2013-03-31','15:45:00',2.62),('8784','2013-03-31','15:50:00',1.02),('8784','2013-03-31','15:55:00',1.03),('8784','2013-03-31','16:00:00',3.11),('8784','2013-03-31','16:05:00',1.21),('8784','2013-03-31','16:10:00',1.75),('8784','2013-03-31','16:15:00',2.38),('8784','2013-03-31','16:20:00',1.88),('8784','2013-03-31','16:25:00',1.4),('8784','2013-03-31','16:30:00',1.17),('8784','2013-03-31','16:35:00',1.23),('8784','2013-03-31','16:40:00',1.42),('8784','2013-03-31','16:45:00',1.14),('8784','2013-03-31','17:00:00',1.25),('8784','2013-03-31','17:05:00',1.4),('8784','2013-03-31','17:10:00',1.22),('8784','2013-03-31','17:20:00',1.16),('8784','2013-03-31','17:25:00',1.23),('8784','2013-03-31','17:30:00',1.33),('8784','2013-03-31','17:35:00',1.26),('8784','2013-03-31','17:45:00',1.03),('8784','2013-03-31','17:50:00',1.09),('8784','2013-03-31','17:55:00',1.6),('8784','2013-03-31','18:15:00',1.33),('8784','2013-03-30','08:30:00',1.03),('8784','2013-03-30','08:35:00',1.23),('8784','2013-03-30','08:40:00',1.16),('8784','2013-03-30','08:50:00',1),('8784','2013-03-30','09:00:00',1),('8784','2013-03-30','09:05:00',1.8),('8784','2013-03-30','09:10:00',1.9),('8784','2013-03-30','09:16:00',1.95),('8784','2013-03-30','09:20:00',4.26),('8784','2013-03-30','09:25:00',1.83),('8784','2013-03-30','09:30:00',1.27),('8784','2013-03-30','09:35:00',1.42),('8784','2013-03-30','09:40:00',1.48),('8784','2013-03-30','09:45:00',1.28),('8784','2013-03-30','09:55:00',1.3),('8784','2013-03-30','10:00:00',1.95),('8784','2013-03-30','10:05:00',1.87),('8784','2013-03-30','10:10:00',2.05),('8784','2013-03-30','10:15:00',1.84),('8784','2013-03-30','10:20:00',1.6),('8784','2013-03-30','10:25:00',1.58),('8784','2013-03-30','10:30:00',1.8),('8784','2013-03-30','10:35:00',2.16),('8784','2013-03-30','10:40:00',2.58),('8784','2013-03-30','10:45:00',3.46),('8784','2013-03-30','10:50:00',3.12),('8784','2013-03-30','10:55:00',2.34),('8784','2013-03-30','11:00:00',3.48),('8784','2013-03-30','11:05:00',4.16),('8784','2013-03-30','11:10:00',4.51),('8784','2013-03-30','11:15:00',3.8),('8784','2013-03-30','11:20:00',5.2),('8784','2013-03-30','11:25:00',4.72),('8784','2013-03-30','11:30:00',2.71),('8784','2013-03-30','11:35:00',3.47),('8784','2013-03-30','11:40:00',3.14),('8784','2013-03-30','11:45:00',4.01),('8784','2013-03-30','11:50:00',4.45),('8784','2013-03-30','11:55:00',4.1),('8784','2013-03-30','12:00:00',3.99),('8784','2013-03-30','12:05:00',2.76),('8784','2013-03-30','12:10:00',2.2),('8784','2013-03-30','12:15:00',2.18),('8784','2013-03-30','12:20:00',1.95),('8784','2013-03-30','12:25:00',1.13),('8784','2013-03-30','12:30:00',1.09),('8784','2013-03-30','12:35:00',1),('8784','2013-03-30','13:10:00',2.04),('8784','2013-03-30','13:15:00',3.79),('8784','2013-03-30','13:20:00',2.25),('8784','2013-03-30','13:25:00',1.95),('8784','2013-03-30','13:30:00',1.11),('8784','2013-03-30','13:45:00',2.68),('8784','2013-03-30','13:50:00',4.38),('8784','2013-03-30','13:55:00',1.73),('8784','2013-03-30','14:00:00',2.17),('8784','2013-03-30','14:05:00',1.87),('8784','2013-03-30','14:10:00',1.17),('8784','2013-03-30','14:15:00',1.15),('8784','2013-03-30','14:20:00',1.85),('8784','2013-03-30','14:25:00',1.41),('8784','2013-03-30','14:30:00',2.15),('8784','2013-03-30','14:35:00',2.06),('8784','2013-03-30','14:40:00',1.32),('8784','2013-03-30','14:45:00',1.08),('8784','2013-03-30','14:50:00',1.54),('8784','2013-03-30','15:25:00',1.06),('8784','2013-03-29','07:20:00',1.07),('8784','2013-03-29','07:25:00',1.21),('8784','2013-03-29','07:30:00',1.13),('8784','2013-03-29','07:35:00',1.24),('8784','2013-03-29','07:40:00',1.43),('8784','2013-03-29','07:45:00',1.57),('8784','2013-03-29','07:50:00',1.17),('8784','2013-03-29','07:55:00',1.04),('8784','2013-03-29','08:00:00',1.21),('8784','2013-03-29','08:05:00',1.71),('8784','2013-03-29','08:10:00',2.1),('8784','2013-03-29','08:15:00',2.06),('8784','2013-03-29','08:20:00',2.16),('8784','2013-03-29','08:25:00',2.25),('8784','2013-03-29','08:30:00',2.34),('8784','2013-03-29','08:35:00',2.46),('8784','2013-03-29','08:40:00',2.52),('8784','2013-03-29','08:45:00',2.48),('8784','2013-03-29','08:50:00',2.54),('8784','2013-03-29','08:55:00',2.29),('8784','2013-03-29','09:00:00',2.42),('8784','2013-03-29','09:05:00',2.73),('8784','2013-03-29','09:10:00',2.73),('8784','2013-03-29','09:15:00',3.11),('8784','2013-03-29','09:20:00',3.21),('8784','2013-03-29','09:25:00',3.07),('8784','2013-03-29','09:30:00',3.61),('8784','2013-03-29','09:35:00',3.58),('8784','2013-03-29','09:40:00',3.58),('8784','2013-03-29','09:45:00',3.14),('8784','2013-03-29','09:50:00',3.33),('8784','2013-03-29','09:55:00',3.54),('8784','2013-03-29','10:00:00',3.42),('8784','2013-03-29','10:05:00',3.42),('8784','2013-03-29','10:10:00',2.95),('8784','2013-03-29','10:15:00',3.48),('8784','2013-03-29','10:20:00',3.26),('8784','2013-03-29','10:25:00',2.93),('8784','2013-03-29','10:30:00',3.18),('8784','2013-03-29','10:35:00',2.83),('8784','2013-03-29','10:40:00',3.67),('8784','2013-03-29','10:45:00',3.19),('8784','2013-03-29','10:50:00',3.02),('8784','2013-03-29','10:55:00',3.56),('8784','2013-03-29','11:00:00',4.03),('8784','2013-03-29','11:05:00',3.99),('8784','2013-03-29','11:10:00',2.71),('8784','2013-03-29','11:15:00',1.7),('8784','2013-03-29','11:20:00',4.1),('8784','2013-03-29','11:25:00',4.55),('8784','2013-03-29','11:30:00',4.33),('8784','2013-03-29','11:35:00',4.18),('8784','2013-03-29','11:40:00',4.23),('8784','2013-03-29','11:45:00',4.15),('8784','2013-03-29','11:50:00',4.28),('8784','2013-03-29','11:55:00',4.3),('8784','2013-03-29','12:00:00',4.29),('8784','2013-03-29','12:05:00',4.37),('8784','2013-03-29','12:10:00',4.32),('8784','2013-03-29','12:15:00',4),('8784','2013-03-29','12:20:00',4.28),('8784','2013-03-29','12:25:00',4),('8784','2013-03-29','12:30:00',3.96),('8784','2013-03-29','12:35:00',4.1),('8784','2013-03-29','12:40:00',4.06),('8784','2013-03-29','12:45:00',3.72),('8784','2013-03-29','12:50:00',4.27),('8784','2013-03-29','12:55:00',3.95),('8784','2013-03-29','13:00:00',4.13),('8784','2013-03-29','13:05:00',3.54),('8784','2013-03-29','13:10:00',4.03),('8784','2013-03-29','13:15:00',3.62),('8784','2013-03-29','13:20:00',3.65),('8784','2013-03-29','13:25:00',4.21),('8784','2013-03-29','13:30:00',3.77),('8784','2013-03-29','13:35:00',3.39),('8784','2013-03-29','13:40:00',3.37),('8784','2013-03-29','13:45:00',3.62),('8784','2013-03-29','13:50:00',3.4),('8784','2013-03-29','13:55:00',3.51),('8784','2013-03-29','14:00:00',3.73),('8784','2013-03-29','14:05:00',3.01),('8784','2013-03-29','14:10:00',2.5),('8784','2013-03-29','14:15:00',2.5),('8784','2013-03-29','14:20:00',2.51),('8784','2013-03-29','14:25:00',2.6),('8784','2013-03-29','14:30:00',2.19),('8784','2013-03-29','14:35:00',2.16),('8784','2013-03-29','14:40:00',2.11),('8784','2013-03-29','14:45:00',1.94),('8784','2013-03-29','14:50:00',1.9),('8784','2013-03-29','14:55:00',1.85),('8784','2013-03-29','15:00:00',1.67),('8784','2013-03-29','15:05:00',1.66),('8784','2013-03-29','15:10:00',1.58),('8784','2013-03-29','15:15:00',1.55),('8784','2013-03-29','15:20:00',1.45),('8784','2013-03-29','15:25:00',1.33),('8784','2013-03-29','15:30:00',1.24),('8784','2013-03-29','15:35:00',1.18),('8784','2013-03-29','15:40:00',1.12),('8784','2013-03-29','15:45:00',1.09),('8784','2013-03-29','15:50:00',1.19),('8784','2013-03-29','15:55:00',1.37),('8784','2013-03-29','16:00:00',1.71),('8784','2013-03-29','16:05:00',1.6),('8784','2013-03-29','16:10:00',1.17),('8784','2013-03-29','16:15:00',1.06),('8784','2013-03-29','16:25:00',1.09),('8784','2013-03-29','16:30:00',1.12),('8784','2013-03-29','16:35:00',1.23),('8784','2013-03-29','16:40:00',1.97),('8784','2013-03-29','16:45:00',1.62),('8784','2013-03-29','16:50:00',1.19),('8784','2013-03-29','16:55:00',1),('8784','2013-03-29','17:00:00',1.14),('8784','2013-03-28','09:05:00',1.03),('8784','2013-03-28','09:10:00',1.88),('8784','2013-03-28','09:15:00',3.14),('8784','2013-03-28','09:20:00',1.64),('8784','2013-03-28','09:25:00',1.63),('8784','2013-03-28','09:30:00',1.19),('8784','2013-03-28','09:35:00',1.03),('8784','2013-03-28','09:45:00',1.15),('8784','2013-03-28','09:50:00',1.19),('8784','2013-03-28','09:55:00',1.1),('8784','2013-03-28','10:00:00',1.17),('8784','2013-03-28','10:05:00',1.02),('8784','2013-03-28','11:00:00',1.04),('8784','2013-03-28','11:35:00',1.29),('8784','2013-03-28','11:40:00',1.69),('8784','2013-03-28','11:45:00',1.28),('8784','2013-03-28','11:50:00',1.3),('8784','2013-03-28','11:55:00',2.41),('8784','2013-03-28','12:00:00',1.55),('8784','2013-03-28','12:10:00',1.11),('8784','2013-03-28','12:15:00',1.39),('8784','2013-03-28','12:20:00',1.1),('8784','2013-03-28','12:30:00',1.26),('8784','2013-03-28','12:35:00',1.01),('8784','2013-03-28','12:40:00',1.48),('8784','2013-03-28','12:45:00',1.85),('8784','2013-03-28','12:50:00',3.54),('8784','2013-03-28','12:55:00',3.71),('8784','2013-03-28','13:00:00',3.35),('8784','2013-03-28','13:05:00',4.77),('8784','2013-03-28','13:10:00',3.92),('8784','2013-03-28','13:15:00',3.26),('8784','2013-03-28','13:20:00',2.85),('8784','2013-03-28','13:25:00',2.25),('8784','2013-03-28','13:30:00',2.7),('8784','2013-03-28','13:35:00',3.15),('8784','2013-03-28','13:40:00',2.39),('8784','2013-03-28','13:45:00',2.65),('8784','2013-03-28','13:50:00',2.79),('8784','2013-03-28','13:55:00',1.78),('8784','2013-03-28','14:00:00',1.96),('8784','2013-03-28','14:05:00',2.15),('8784','2013-03-28','14:10:00',1.4),('8784','2013-03-28','14:15:00',1.53),('8784','2013-03-28','14:20:00',1.86),('8784','2013-03-28','14:25:00',1.64),('8784','2013-03-28','14:30:00',2.49),('8784','2013-03-28','14:35:00',1.71),('8784','2013-03-28','14:40:00',1.15),('8784','2013-03-28','14:45:00',1.24),('8784','2013-03-28','14:50:00',1.06),('8784','2013-03-28','15:00:00',1.29),('8784','2013-03-28','15:05:00',1.47),('8784','2013-03-28','15:10:00',2.64),('8784','2013-03-28','15:15:00',1.89),('8784','2013-03-28','15:20:00',1.87),('8784','2013-03-28','15:25:00',1.05),('8784','2013-03-28','15:30:00',1.46),('8784','2013-03-28','15:35:00',2.26),('8784','2013-03-28','15:40:00',1.72),('8784','2013-03-28','15:45:00',2.08),('8784','2013-03-28','15:50:00',1.49),('8784','2013-03-28','15:55:00',2.77),('8784','2013-03-28','16:00:00',1.28),('8784','2013-03-28','16:05:00',1.08),('8784','2013-03-28','16:10:00',1.78),('8784','2013-03-28','16:35:00',1.59),('8784','2013-03-28','16:40:00',1.09),('8784','2013-03-28','16:45:00',1.02),('8784','2013-03-28','17:00:00',1.46),('8784','2013-03-28','17:05:00',1.24),('8784','2013-03-28','17:10:00',1.01),('8784','2013-03-27','07:20:00',1.02),('8784','2013-03-27','07:25:00',1.11),('8784','2013-03-27','07:30:00',1.17),('8784','2013-03-27','07:40:00',1.27),('8784','2013-03-27','07:45:00',1.1),('8784','2013-03-27','07:55:00',1.32),('8784','2013-03-27','08:00:00',1.49),('8784','2013-03-27','08:05:00',1.51),('8784','2013-03-27','08:10:00',1.4),('8784','2013-03-27','08:15:00',1.53),('8784','2013-03-27','08:20:00',1.36),('8784','2013-03-27','08:25:00',1.64),('8784','2013-03-27','08:30:00',2.08),('8784','2013-03-27','08:35:00',1.72),('8784','2013-03-27','08:40:00',1.33),('8784','2013-03-27','08:45:00',1.4),('8784','2013-03-27','08:50:00',1.85),('8784','2013-03-27','08:55:00',1.38),('8784','2013-03-27','09:00:00',1.52),('8784','2013-03-27','09:05:00',1.2),('8784','2013-03-27','09:15:00',1.86),('8784','2013-03-27','09:20:00',1.65),('8784','2013-03-27','09:25:00',1.14),('8784','2013-03-27','09:40:00',1.04),('8784','2013-03-27','09:45:00',1.83),('8784','2013-03-27','09:50:00',1.72),('8784','2013-03-27','09:55:00',1.52),('8784','2013-03-27','10:00:00',1.58),('8784','2013-03-27','10:10:00',1.5),('8784','2013-03-27','10:15:00',1.98),('8784','2013-03-27','10:20:00',1.52),('8784','2013-03-27','10:25:00',2.03),('8784','2013-03-27','10:30:00',2.6),('8784','2013-03-27','10:35:00',2.09),('8784','2013-03-27','10:40:00',2.45),('8784','2013-03-27','10:45:00',2.23),('8784','2013-03-27','10:50:00',2.45),('8784','2013-03-27','10:55:00',2.23),('8784','2013-03-27','11:00:00',1.92),('8784','2013-03-27','11:05:00',1.73),('8784','2013-03-27','11:10:00',1.81),('8784','2013-03-27','11:15:00',1.94),('8784','2013-03-27','11:20:00',1.98),('8784','2013-03-27','11:25:00',1.82),('8784','2013-03-27','11:30:00',2.03),('8784','2013-03-27','11:35:00',1.92),('8784','2013-03-27','11:40:00',1.74),('8784','2013-03-27','11:45:00',1.9),('8784','2013-03-27','11:50:00',1.82),('8784','2013-03-27','11:55:00',2.87),('8784','2013-03-27','12:00:00',2.83),('8784','2013-03-27','12:05:00',2.64),('8784','2013-03-27','12:10:00',2.26),('8784','2013-03-27','12:15:00',1.78),('8784','2013-03-27','12:20:00',1.97),('8784','2013-03-27','12:25:00',1.83),('8784','2013-03-27','12:30:00',4.05),('8784','2013-03-27','12:35:00',4.39),('8784','2013-03-27','12:40:00',4.23),('8784','2013-03-27','12:45:00',3.95),('8784','2013-03-27','12:50:00',3.04),('8784','2013-03-27','12:55:00',1.77),('8784','2013-03-27','13:00:00',1.6),('8784','2013-03-27','13:05:00',1.7),('8784','2013-03-27','13:10:00',2.41),('8784','2013-03-27','13:15:00',1.8),('8784','2013-03-27','13:20:00',1.41),('8784','2013-03-27','13:25:00',1.48),('8784','2013-03-27','13:30:00',1.75),('8784','2013-03-27','13:35:00',2.45),('8784','2013-03-27','13:40:00',1.79),('8784','2013-03-27','13:45:00',2.15),('8784','2013-03-27','13:50:00',2.35),('8784','2013-03-27','13:55:00',2.03),('8784','2013-03-27','14:00:00',1.88),('8784','2013-03-27','14:05:00',1.64),('8784','2013-03-27','14:10:00',1.69),('8784','2013-03-27','14:15:00',1.89),('8784','2013-03-27','14:20:00',2.37),('8784','2013-03-27','14:25:00',1.91),('8784','2013-03-27','14:30:00',1.59),('8784','2013-03-27','14:35:00',1.87),('8784','2013-03-27','14:40:00',2.62),('8784','2013-03-27','14:45:00',2.39),('8784','2013-03-27','14:50:00',1.79),('8784','2013-03-27','14:55:00',1.3),('8784','2013-03-27','15:00:00',1.08),('8784','2013-03-27','15:05:00',1.42),('8784','2013-03-27','15:10:00',1.47),('8784','2013-03-27','15:15:00',1.11),('8784','2013-03-27','15:20:00',1.09),('8784','2013-03-27','15:25:00',1.13),('8784','2013-03-27','16:40:00',1.06),('8784','2013-03-27','16:45:00',1.22),('8784','2013-03-27','16:50:00',1.08),('8784','2013-03-27','16:55:00',1.23),('8784','2013-03-27','17:00:00',1.25),('8784','2013-03-27','17:05:00',1.41),('8784','2013-03-27','17:10:00',1.15),('8784','2013-03-26','07:45:00',1.29),('8784','2013-03-26','07:50:00',1.83),('8784','2013-03-26','07:55:00',1.71),('8784','2013-03-26','08:30:00',1.04),('8784','2013-03-26','08:35:00',1.59),('8784','2013-03-26','08:40:00',1.62),('8784','2013-03-26','09:10:00',1.28),('8784','2013-03-26','09:15:00',1.97),('8784','2013-03-26','09:20:00',1.13),('8784','2013-03-26','09:50:00',1.41),('8784','2013-03-26','09:55:00',2.6),('8784','2013-03-26','10:00:00',1.21),('8784','2013-03-26','10:50:00',1.07),('8784','2013-03-26','10:55:00',1.06),('8784','2013-03-26','11:00:00',1.26),('8784','2013-03-26','11:05:00',1.19),('8784','2013-03-26','11:10:00',2.47),('8784','2013-03-26','11:15:00',1.73),('8784','2013-03-26','11:20:00',1.89),('8784','2013-03-26','11:45:00',1.3),('8784','2013-03-26','11:50:00',2.44),('8784','2013-03-26','11:55:00',1.17),('8784','2013-03-26','12:00:00',1.51),('8784','2013-03-26','12:05:00',1.35),('8784','2013-03-26','12:10:00',1.48),('8784','2013-03-26','12:15:00',1.56),('8784','2013-03-26','12:20:00',1.68),('8784','2013-03-26','12:25:00',2.35),('8784','2013-03-26','12:30:00',2.03),('8784','2013-03-26','12:35:00',3.28),('8784','2013-03-26','12:40:00',2.01),('8784','2013-03-26','12:45:00',2.67),('8784','2013-03-26','12:50:00',1.84),('8784','2013-03-26','12:55:00',1.21),('8784','2013-03-26','13:00:00',2.01),('8784','2013-03-26','13:05:00',2.59),('8784','2013-03-26','13:10:00',2.77),('8784','2013-03-26','13:15:00',1.84),('8784','2013-03-26','13:20:00',1.98),('8784','2013-03-26','13:25:00',2.25),('8784','2013-03-26','13:30:00',1.78),('8784','2013-03-26','13:35:00',2.28),('8784','2013-03-26','13:40:00',2.43),('8784','2013-03-26','13:45:00',2.14),('8784','2013-03-26','13:50:00',1.81),('8784','2013-03-26','13:55:00',1.69),('8784','2013-03-26','14:00:00',1.66),('8784','2013-03-26','14:05:00',1.62),('8784','2013-03-26','14:10:00',1.7),('8784','2013-03-26','14:15:00',1.58),('8784','2013-03-26','14:20:00',1.34),('8784','2013-03-26','14:25:00',1.23),('8784','2013-03-26','15:35:00',1.03),('8784','2013-03-25','08:20:00',1.16),('8784','2013-03-25','08:25:00',2.28),('8784','2013-03-25','08:30:00',1.48),('8784','2013-03-25','08:50:00',1.03),('8784','2013-03-25','08:55:00',1.31),('8784','2013-03-25','09:00:00',1.19),('8784','2013-03-25','09:05:00',1.18),('8784','2013-03-25','09:10:00',1.32),('8784','2013-03-25','09:15:00',1.26),('8784','2013-03-25','09:20:00',2.32),('8784','2013-03-25','09:25:00',2.67),('8784','2013-03-25','09:30:00',1.63),('8784','2013-03-25','09:35:00',1.11),('8784','2013-03-25','09:45:00',1.14),('8784','2013-03-25','09:50:00',4.56),('8784','2013-03-25','09:55:00',4.03),('8784','2013-03-25','10:00:00',1.31),('8784','2013-03-25','10:05:00',1.21),('8784','2013-03-25','10:10:00',1.24),('8784','2013-03-25','10:15:00',1.2),('8784','2013-03-25','10:20:00',1.66),('8784','2013-03-25','10:25:00',2.84),('8784','2013-03-25','10:30:00',2.29),('8784','2013-03-25','10:35:00',1.98),('8784','2013-03-25','10:40:00',1.99),('8784','2013-03-25','10:45:00',2.7),('8784','2013-03-25','10:50:00',3.02),('8784','2013-03-25','10:55:00',3.6),('8784','2013-03-25','11:00:00',2.49),('8784','2013-03-25','11:05:00',2.35),('8784','2013-03-25','11:10:00',2.56),('8784','2013-03-25','11:15:00',2.71),('8784','2013-03-25','11:20:00',3.99),('8784','2013-03-25','11:25:00',4.03),('8784','2013-03-25','11:30:00',5.11),('8784','2013-03-25','11:35:00',3.23),('8784','2013-03-25','11:40:00',1.42),('8784','2013-03-25','11:45:00',1.73),('8784','2013-03-25','11:50:00',1.99),('8784','2013-03-25','11:55:00',3.51),('8784','2013-03-25','12:00:00',4.44),('8784','2013-03-25','12:05:00',4.45),('8784','2013-03-25','12:10:00',4.01),('8784','2013-03-25','12:15:00',3.49),('8784','2013-03-25','12:20:00',2.99),('8784','2013-03-25','12:25:00',4.18),('8784','2013-03-25','12:30:00',3.37),('8784','2013-03-25','12:35:00',3.02),('8784','2013-03-25','12:40:00',2.77),('8784','2013-03-25','12:45:00',2.63),('8784','2013-03-25','12:50:00',2.95),('8784','2013-03-25','12:55:00',3.31),('8784','2013-03-25','13:00:00',3.38),('8784','2013-03-25','13:05:00',4.89),('8784','2013-03-25','13:10:00',4.66),('8784','2013-03-25','13:15:00',4.37),('8784','2013-03-25','13:20:00',3.88),('8784','2013-03-25','13:25:00',1.75),('8784','2013-03-25','13:30:00',2.06),('8784','2013-03-25','13:35:00',1.23),('8784','2013-03-25','13:40:00',1.31),('8784','2013-03-25','13:45:00',2.51),('8784','2013-03-25','13:50:00',2.17),('8784','2013-03-25','13:55:00',1.93),('8784','2013-03-25','14:00:00',1.05),('8784','2013-03-25','14:05:00',1.39),('8784','2013-03-25','14:10:00',3.51),('8784','2013-03-25','14:15:00',1.93),('8784','2013-03-25','14:20:00',2.64),('8784','2013-03-25','14:25:00',3.57),('8784','2013-03-25','14:30:00',2.35),('8784','2013-03-25','14:35:00',1.79),('8784','2013-03-25','14:40:00',1.46),('8784','2013-03-25','14:45:00',2.2),('8784','2013-03-25','14:50:00',1.8),('8784','2013-03-25','14:55:00',2.92),('8784','2013-03-25','15:00:00',2.78),('8784','2013-03-25','15:05:00',2.79),('8784','2013-03-25','15:10:00',3.3),('8784','2013-03-25','15:15:00',2.53),('8784','2013-03-25','15:20:00',2.16),('8784','2013-03-25','15:25:00',2.52),('8784','2013-03-25','15:30:00',2.76),('8784','2013-03-25','15:35:00',2.09),('8784','2013-03-25','15:40:00',3.15),('8784','2013-03-25','15:45:00',2.34),('8784','2013-03-25','15:50:00',1.44),('8784','2013-03-25','15:55:00',1.97),('8784','2013-03-25','16:00:00',2.42),('8784','2013-03-25','16:05:00',1.08),('8784','2013-03-25','16:10:00',1.33),('8784','2013-03-25','16:30:00',1.44),('8784','2013-03-25','16:35:00',2.09),('8784','2013-03-25','16:40:00',1.71),('8784','2013-03-25','16:45:00',1.03),('8784','2013-03-24','07:40:00',1.01),('8784','2013-03-24','07:45:00',1.09),('8784','2013-03-24','07:50:00',1.27),('8784','2013-03-24','07:55:00',1.44),('8784','2013-03-24','08:00:00',1.69),('8784','2013-03-24','08:05:00',1.77),('8784','2013-03-24','08:10:00',1.81),('8784','2013-03-24','08:15:00',1.93),('8784','2013-03-24','08:20:00',2.02),('8784','2013-03-24','08:25:00',2.1),('8784','2013-03-24','08:30:00',2.17),('8784','2013-03-24','08:35:00',2.25),('8784','2013-03-24','08:40:00',2.32),('8784','2013-03-24','08:45:00',2.37),('8784','2013-03-24','08:50:00',2.42),('8784','2013-03-24','08:55:00',2.5),('8784','2013-03-24','09:00:00',2.56),('8784','2013-03-24','09:05:00',2.64),('8784','2013-03-24','09:10:00',2.73),('8784','2013-03-24','09:15:00',2.79),('8784','2013-03-24','09:20:00',2.86),('8784','2013-03-24','09:25:00',2.91),('8784','2013-03-24','09:30:00',2.97),('8784','2013-03-24','09:35:00',2.97),('8784','2013-03-24','09:40:00',3.07),('8784','2013-03-24','09:45:00',3.14),('8784','2013-03-24','09:50:00',3.19),('8784','2013-03-24','09:55:00',3.23),('8784','2013-03-24','10:00:00',3.3),('8784','2013-03-24','10:05:00',3.36),('8784','2013-03-24','10:10:00',3.42),('8784','2013-03-24','10:15:00',3.47),('8784','2013-03-24','10:20:00',3.5),('8784','2013-03-24','10:25:00',3.54),('8784','2013-03-24','10:30:00',3.59),('8784','2013-03-24','10:35:00',3.61),('8784','2013-03-24','10:40:00',3.63),('8784','2013-03-24','10:45:00',3.65),('8784','2013-03-24','10:50:00',3.65),('8784','2013-03-24','10:55:00',3.69),('8784','2013-03-24','11:00:00',3.71),('8784','2013-03-24','11:05:00',3.75),('8784','2013-03-24','11:10:00',3.76),('8784','2013-03-24','11:15:00',3.75),('8784','2013-03-24','11:20:00',3.8),('8784','2013-03-24','11:25:00',3.84),('8784','2013-03-24','11:30:00',3.83),('8784','2013-03-24','11:35:00',3.84),('8784','2013-03-24','11:40:00',3.84),('8784','2013-03-24','11:45:00',3.83),('8784','2013-03-24','11:50:00',3.86),('8784','2013-03-24','11:55:00',3.87),('8784','2013-03-24','12:00:00',3.88),('8784','2013-03-24','12:05:00',3.91),('8784','2013-03-24','12:10:00',3.94),('8784','2013-03-24','12:15:00',3.98),('8784','2013-03-24','12:20:00',4),('8784','2013-03-24','12:25:00',4.01),('8784','2013-03-24','12:30:00',4),('8784','2013-03-24','12:35:00',3.97),('8784','2013-03-24','12:40:00',4.01),('8784','2013-03-24','12:45:00',4.02),('8784','2013-03-24','12:50:00',3.97),('8784','2013-03-24','12:55:00',3.95),('8784','2013-03-24','13:00:00',3.9),('8784','2013-03-24','13:05:00',3.92),('8784','2013-03-24','13:10:00',3.9),('8784','2013-03-24','13:15:00',3.88),('8784','2013-03-24','13:20:00',3.88),('8784','2013-03-24','13:25:00',3.81),('8784','2013-03-24','13:30:00',3.76),('8784','2013-03-24','13:35:00',3.73),('8784','2013-03-24','13:40:00',3.71),('8784','2013-03-24','13:45:00',3.68),('8784','2013-03-24','13:50:00',3.62),('8784','2013-03-24','13:55:00',3.6),('8784','2013-03-24','14:00:00',3.54),('8784','2013-03-24','14:05:00',3.48),('8784','2013-03-24','14:10:00',3.43),('8784','2013-03-24','14:15:00',3.39),('8784','2013-03-24','14:20:00',3.32),('8784','2013-03-24','14:25:00',3.26),('8784','2013-03-24','14:30:00',3.16),('8784','2013-03-24','14:35:00',3.05),('8784','2013-03-24','14:40:00',3),('8784','2013-03-24','14:45:00',2.96),('8784','2013-03-24','14:50:00',2.82),('8784','2013-03-24','14:55:00',2.84),('8784','2013-03-24','15:00:00',2.73),('8784','2013-03-24','15:05:00',2.66),('8784','2013-03-24','15:10:00',2.49),('8784','2013-03-24','15:15:00',2.73),('8784','2013-03-24','15:20:00',2.61),('8784','2013-03-24','15:25:00',2.43),('8784','2013-03-24','15:30:00',2.19),('8784','2013-03-24','15:35:00',2.17),('8784','2013-03-24','15:40:00',2.13),('8784','2013-03-24','15:45:00',1.78),('8784','2013-03-24','15:50:00',1.27),('8784','2013-03-24','15:55:00',1.23),('8784','2013-03-24','16:00:00',1.24),('8784','2013-03-24','16:05:00',1.45),('8784','2013-03-24','16:10:00',1.08),('8784','2013-03-24','16:15:00',1.48),('8784','2013-03-24','16:20:00',1.21),('8784','2013-03-24','16:25:00',1.1),('8784','2013-03-24','16:30:00',1.23),('8784','2013-03-24','16:35:00',1.07),('8784','2013-03-23','07:30:00',1.01),('8784','2013-03-23','07:35:00',1.03),('8784','2013-03-23','07:40:00',1.19),('8784','2013-03-23','07:45:00',1.18),('8784','2013-03-23','07:50:00',1.3),('8784','2013-03-23','07:55:00',1.48),('8784','2013-03-23','08:00:00',1.61),('8784','2013-03-23','08:05:00',1.77),('8784','2013-03-23','08:10:00',1.85),('8784','2013-03-23','08:15:00',1.92),('8784','2013-03-23','08:20:00',2),('8784','2013-03-23','08:25:00',2.08),('8784','2013-03-23','08:30:00',2.12),('8784','2013-03-23','08:35:00',2.21),('8784','2013-03-23','08:40:00',2.33),('8784','2013-03-23','08:45:00',2.41),('8784','2013-03-23','08:50:00',2.47),('8784','2013-03-23','08:55:00',2.61),('8784','2013-03-23','09:00:00',2.69),('8784','2013-03-23','09:05:00',2.77),('8784','2013-03-23','09:10:00',2.81),('8784','2013-03-23','09:15:00',2.87),('8784','2013-03-23','09:20:00',2.9),('8784','2013-03-23','09:25:00',3.01),('8784','2013-03-23','09:30:00',3.1),('8784','2013-03-23','09:35:00',3.16),('8784','2013-03-23','09:40:00',3.08),('8784','2013-03-23','09:45:00',3.19),('8784','2013-03-23','09:50:00',3.27),('8784','2013-03-23','09:55:00',3.41),('8784','2013-03-23','10:00:00',3.41),('8784','2013-03-23','10:05:00',2.63),('8784','2013-03-23','10:10:00',3.27),('8784','2013-03-23','10:15:00',3.5),('8784','2013-03-23','10:20:00',3.52),('8784','2013-03-23','10:25:00',3.53),('8784','2013-03-23','10:30:00',3.69),('8784','2013-03-23','10:35:00',3.74),('8784','2013-03-23','10:40:00',3.73),('8784','2013-03-23','10:45:00',3.69),('8784','2013-03-23','10:50:00',3.66),('8784','2013-03-23','10:55:00',3.62),('8784','2013-03-23','11:00:00',3.54),('8784','2013-03-23','11:05:00',3.26),('8784','2013-03-23','11:10:00',2.95),('8784','2013-03-23','11:15:00',3.21),('8784','2013-03-23','11:20:00',3.53),('8784','2013-03-23','11:25:00',3.69),('8784','2013-03-23','11:30:00',3.68),('8784','2013-03-23','11:35:00',3.89),('8784','2013-03-23','11:40:00',3.88),('8784','2013-03-23','11:45:00',3.87),('8784','2013-03-23','11:50:00',3.69),('8784','2013-03-23','11:55:00',3.88),('8784','2013-03-23','12:00:00',3.94),('8784','2013-03-23','12:05:00',3.88),('8784','2013-03-23','12:10:00',3.92),('8784','2013-03-23','12:15:00',4.05),('8784','2013-03-23','12:20:00',4.07),('8784','2013-03-23','12:25:00',3.95),('8784','2013-03-23','12:30:00',3.98),('8784','2013-03-23','12:35:00',3.97),('8784','2013-03-23','12:40:00',3.85),('8784','2013-03-23','12:45:00',3.95),('8784','2013-03-23','12:50:00',4),('8784','2013-03-23','12:55:00',3.85),('8784','2013-03-23','13:00:00',3.17),('8784','2013-03-23','13:05:00',3.94),('8784','2013-03-23','13:10:00',3.92),('8784','2013-03-23','13:15:00',3.78),('8784','2013-03-23','13:20:00',3.83),('8784','2013-03-23','13:25:00',3.69),('8784','2013-03-23','13:30:00',3.57),('8784','2013-03-23','13:35:00',3.74),('8784','2013-03-23','13:40:00',3.69),('8784','2013-03-23','13:45:00',3.68),('8784','2013-03-23','13:50:00',3.68),('8784','2013-03-23','13:55:00',3.55),('8784','2013-03-23','14:00:00',3.51),('8784','2013-03-23','14:05:00',3.52),('8784','2013-03-23','14:10:00',3.38),('8784','2013-03-23','14:15:00',3.27),('8784','2013-03-23','14:20:00',3.37),('8784','2013-03-23','14:25:00',3.3),('8784','2013-03-23','14:30:00',3.28),('8784','2013-03-23','14:35:00',3.2),('8784','2013-03-23','14:40:00',3.1),('8784','2013-03-23','14:45:00',2.93),('8784','2013-03-23','14:50:00',2.89),('8784','2013-03-23','14:55:00',2.95),('8784','2013-03-23','15:00:00',2.83),('8784','2013-03-23','15:05:00',2.64),('8784','2013-03-23','15:10:00',2.72),('8784','2013-03-23','15:15:00',2.53),('8784','2013-03-23','15:20:00',2.55),('8784','2013-03-23','15:25:00',2.51),('8784','2013-03-23','15:30:00',2.3),('8784','2013-03-23','15:35:00',2.22),('8784','2013-03-23','15:40:00',2.16),('8784','2013-03-23','15:45:00',1.98),('8784','2013-03-23','15:50:00',1.88),('8784','2013-03-23','15:55:00',1.84),('8784','2013-03-23','16:00:00',1.7),('8784','2013-03-23','16:05:00',1.56),('8784','2013-03-23','16:10:00',1.94),('8784','2013-03-23','16:15:00',1.73),('8784','2013-03-23','16:20:00',1.48),('8784','2013-03-23','16:25:00',1.48),('8784','2013-03-23','16:30:00',1.14),('8784','2013-03-23','16:35:00',1.24),('8784','2013-03-23','16:40:00',1.07),('8784','2013-03-23','16:45:00',1.06),('8784','2013-03-23','17:00:00',1.03),('8784','2013-03-23','17:05:00',1.04),('8784','2014-03-26','07:25:00',1.09),('8784','2014-03-26','07:30:00',1.19),('8784','2014-03-26','07:35:00',1.28),('8784','2014-03-26','07:40:00',1.37),('8784','2014-03-26','07:45:00',1.47),('8784','2014-03-26','07:50:00',1.57),('8784','2014-03-26','07:55:00',1.66),('8784','2014-03-26','08:00:00',1.76),('8784','2014-03-26','08:05:00',1.89),('8784','2014-03-26','08:10:00',1.99),('8784','2014-03-26','08:15:00',2.2),('8784','2014-03-26','08:20:00',2.04),('8784','2014-03-26','08:25:00',1.28),('8784','2014-03-26','08:30:00',1.16),('8784','2014-03-26','08:40:00',1.13),('8784','2014-03-26','08:45:00',1.23),('8784','2014-03-26','08:50:00',1.46),('8784','2014-03-26','08:55:00',1.29),('8784','2014-03-26','09:00:00',1.43),('8784','2014-03-26','09:05:00',1.35),('8784','2014-03-26','09:10:00',1.61),('8784','2014-03-26','09:15:00',1.32),('8784','2014-03-26','09:20:00',1.08),('8784','2014-03-26','09:25:00',2.15),('8784','2014-03-26','09:30:00',3.32),('8784','2014-03-26','09:35:00',3.28),('8784','2014-03-26','09:40:00',3.31),('8784','2014-03-26','09:45:00',3.35),('8784','2014-03-26','09:50:00',3.41),('8784','2014-03-26','09:55:00',2.57),('8784','2014-03-26','10:00:00',3.79),('8784','2014-03-26','10:05:00',1.72),('8784','2014-03-26','10:10:00',4.26),('8784','2014-03-26','10:15:00',4.34),('8784','2014-03-26','10:20:00',2.48),('8784','2014-03-26','10:25:00',4.02),('8784','2014-03-26','10:30:00',3.38),('8784','2014-03-26','10:35:00',1.82),('8784','2014-03-26','10:45:00',1.72),('8784','2014-03-26','10:50:00',2.94),('8784','2014-03-26','10:55:00',5.05),('8784','2014-03-26','11:00:00',3.73),('8784','2014-03-26','11:05:00',1.23),('8784','2014-03-26','11:10:00',4.21),('8784','2014-03-26','11:15:00',5.17),('8784','2014-03-26','11:20:00',2.06),('8784','2014-03-26','11:25:00',1.36),('8784','2014-03-26','11:30:00',1.81),('8784','2014-03-26','11:35:00',1.86),('8784','2014-03-26','11:40:00',2.07),('8784','2014-03-26','11:45:00',3.86),('8784','2014-03-26','11:50:00',4.21),('8784','2014-03-26','11:55:00',5.05),('8784','2014-03-26','12:00:00',4.89),('8784','2014-03-26','12:05:00',4.29),('8784','2014-03-26','12:10:00',3.97),('8784','2014-03-26','12:15:00',1.72),('8784','2014-03-26','12:20:00',2),('8784','2014-03-26','12:25:00',1.87),('8784','2014-03-26','12:30:00',1.83),('8784','2014-03-26','12:35:00',1.75),('8784','2014-03-26','12:40:00',2.24),('8784','2014-03-26','12:45:00',2.24),('8784','2014-03-26','12:50:00',1.7),('8784','2014-03-26','12:55:00',1.33),('8784','2014-03-26','13:00:00',1.45),('8784','2014-03-26','13:05:00',1.3),('8784','2014-03-26','13:10:00',1.16),('8784','2014-03-26','13:20:00',2.85),('8784','2014-03-26','13:25:00',4.55),('8784','2014-03-26','13:30:00',3.68),('8784','2014-03-26','13:35:00',1.87),('8784','2014-03-26','13:40:00',1.26),('8784','2014-03-26','13:45:00',1),('8784','2014-03-26','13:55:00',1.38),('8784','2014-03-26','14:00:00',3.01),('8784','2014-03-26','14:05:00',4.45),('8784','2014-03-26','14:10:00',4.03),('8784','2014-03-26','14:15:00',1.18),('8784','2014-03-26','14:20:00',1.03),('8784','2014-03-26','14:45:00',2.26),('8784','2014-03-26','14:50:00',3.2),('8784','2014-03-26','14:55:00',3.4),('8784','2014-03-26','15:00:00',3.08),('8784','2014-03-26','15:05:00',3.05),('8784','2014-03-26','15:10:00',3.08),('8784','2014-03-26','15:15:00',3.18),('8784','2014-03-26','15:20:00',2.9),('8784','2014-03-26','15:25:00',2.97),('8784','2014-03-26','15:30:00',3.06),('8784','2014-03-26','15:35:00',2.89),('8784','2014-03-26','15:40:00',2.37),('8784','2014-03-26','15:45:00',2.3),('8784','2014-03-26','15:50:00',1.88),('8784','2014-03-26','15:55:00',1.6),('8784','2014-03-26','16:00:00',1.34),('8784','2014-03-26','16:05:00',1.28),('8784','2014-03-26','16:10:00',1.44),('8784','2014-03-26','16:15:00',1.56),('8784','2014-03-26','16:20:00',1.13),('8784','2013-03-22','07:30:00',1.08),('8784','2013-03-22','07:35:00',1.15),('8784','2013-03-22','07:40:00',1.25),('8784','2013-03-22','07:45:00',1.34),('8784','2013-03-22','07:50:00',1.43),('8784','2013-03-22','07:55:00',1.51),('8784','2013-03-22','08:00:00',1.59),('8784','2013-03-22','08:05:00',1.69),('8784','2013-03-22','08:10:00',1.8),('8784','2013-03-22','08:15:00',1.89),('8784','2013-03-22','08:20:00',1.99),('8784','2013-03-22','08:25:00',2.08),('8784','2013-03-22','08:30:00',2.16),('8784','2013-03-22','08:35:00',2.26),('8784','2013-03-22','08:40:00',2.33),('8784','2013-03-22','08:45:00',2.42),('8784','2013-03-22','08:50:00',2.48),('8784','2013-03-22','08:55:00',2.54),('8784','2013-03-22','09:00:00',2.61),('8784','2013-03-22','09:05:00',2.69),('8784','2013-03-22','09:10:00',2.77),('8784','2013-03-22','09:15:00',2.81),('8784','2013-03-22','09:20:00',2.87),('8784','2013-03-22','09:25:00',2.94),('8784','2013-03-22','09:30:00',3.02),('8784','2013-03-22','09:35:00',3.09),('8784','2013-03-22','09:40:00',3.13),('8784','2013-03-22','09:45:00',3.23),('8784','2013-03-22','09:50:00',3.21),('8784','2013-03-22','09:55:00',3.32),('8784','2013-03-22','10:00:00',3.4),('8784','2013-03-22','10:05:00',3.46),('8784','2013-03-22','10:10:00',3.47),('8784','2013-03-22','10:15:00',3.49),('8784','2013-03-22','10:20:00',3.59),('8784','2013-03-22','10:25:00',3.68),('8784','2013-03-22','10:30:00',3.73),('8784','2013-03-22','10:35:00',3.75),('8784','2013-03-22','10:40:00',3.79),('8784','2013-03-22','10:45:00',3.81),('8784','2013-03-22','10:50:00',3.86),('8784','2013-03-22','10:55:00',3.88),('8784','2013-03-22','11:00:00',3.92),('8784','2013-03-22','11:05:00',3.91),('8784','2013-03-22','11:10:00',3.95),('8784','2013-03-22','11:15:00',3.98),('8784','2013-03-22','11:20:00',4),('8784','2013-03-22','11:25:00',3.98),('8784','2013-03-22','11:30:00',4.05),('8784','2013-03-22','11:35:00',4.03),('8784','2013-03-22','11:40:00',4.12),('8784','2013-03-22','11:45:00',4.11),('8784','2013-03-22','11:50:00',4.13),('8784','2013-03-22','11:55:00',4.13),('8784','2013-03-22','12:00:00',4.14),('8784','2013-03-22','12:05:00',4.14),('8784','2013-03-22','12:10:00',4.15),('8784','2013-03-22','12:15:00',4.13),('8784','2013-03-22','12:20:00',4.14),('8784','2013-03-22','12:25:00',4.16),('8784','2013-03-22','12:30:00',4.15),('8784','2013-03-22','12:35:00',4.16),('8784','2013-03-22','12:40:00',4.16),('8784','2013-03-22','12:45:00',4.13),('8784','2013-03-22','12:50:00',3.98),('8784','2013-03-22','12:55:00',3.98),('8784','2013-03-22','13:00:00',4.09),('8784','2013-03-22','13:05:00',4.05),('8784','2013-03-22','13:10:00',4.1),('8784','2013-03-22','13:15:00',4.07),('8784','2013-03-22','13:20:00',4.01),('8784','2013-03-22','13:25:00',3.75),('8784','2013-03-22','13:30:00',3.71),('8784','2013-03-22','13:35:00',3.89),('8784','2013-03-22','13:40:00',3.36),('8784','2013-03-22','13:45:00',3.53),('8784','2013-03-22','13:50:00',3.85),('8784','2013-03-22','13:55:00',3.76),('8784','2013-03-22','14:00:00',3.68),('8784','2013-03-22','14:05:00',3.63),('8784','2013-03-22','14:10:00',3.6),('8784','2013-03-22','14:15:00',3.54),('8784','2013-03-22','14:20:00',3.49),('8784','2013-03-22','14:25:00',3.45),('8784','2013-03-22','14:30:00',3.39),('8784','2013-03-22','14:35:00',3.32),('8784','2013-03-22','14:40:00',3.25),('8784','2013-03-22','14:45:00',3.19),('8784','2013-03-22','14:50:00',3.13),('8784','2013-03-22','14:55:00',3.06),('8784','2013-03-22','15:00:00',2.98),('8784','2013-03-22','15:05:00',2.91),('8784','2013-03-22','15:10:00',2.56),('8784','2013-03-22','15:15:00',2.13),('8784','2013-03-22','15:20:00',2.03),('8784','2013-03-22','15:25:00',2.15),('8784','2013-03-22','15:30:00',2.05),('8784','2013-03-22','15:35:00',2.26),('8784','2013-03-22','15:40:00',2.14),('8784','2013-03-22','15:45:00',1.9),('8784','2013-03-22','15:50:00',2.05),('8784','2013-03-22','15:55:00',1.79),('8784','2013-03-22','16:00:00',1.35),('8784','2013-03-22','16:05:00',1.4),('8784','2013-03-22','16:10:00',1.58),('8784','2013-03-22','16:15:00',1.84),('8784','2013-03-22','16:20:00',1.48),('8784','2013-03-22','16:25:00',1.51),('8784','2013-03-22','16:30:00',1.61),('8784','2013-03-22','16:35:00',1.58),('8784','2013-03-22','16:40:00',1.52),('8784','2013-03-22','16:45:00',1.38),('8784','2013-03-22','16:50:00',1.31),('8784','2013-03-22','16:55:00',1.23),('8784','2013-03-22','17:00:00',1.1),('8784','2013-03-21','07:40:00',1.26),('8784','2013-03-21','07:45:00',1.42),('8784','2013-03-21','07:50:00',1.54),('8784','2013-03-21','08:10:00',1.11),('8784','2013-03-21','08:15:00',1.2),('8784','2013-03-21','08:20:00',1.95),('8784','2013-03-21','08:25:00',1.9),('8784','2013-03-21','08:30:00',1.87),('8784','2013-03-21','08:35:00',2.34),('8784','2013-03-21','08:40:00',2.59),('8784','2013-03-21','08:45:00',2.64),('8784','2013-03-21','08:50:00',2.13),('8784','2013-03-21','08:55:00',2.67),('8784','2013-03-21','09:00:00',2.8),('8784','2013-03-21','09:05:00',3.13),('8784','2013-03-21','09:10:00',3.34),('8784','2013-03-21','09:15:00',2.41),('8784','2013-03-21','09:20:00',2.23),('8784','2013-03-21','09:25:00',1.99),('8784','2013-03-21','09:30:00',2.24),('8784','2013-03-21','09:35:00',3.2),('8784','2013-03-21','09:40:00',3.09),('8784','2013-03-21','09:45:00',3.43),('8784','2013-03-21','09:50:00',3.48),('8784','2013-03-21','09:55:00',3.55),('8784','2013-03-21','10:00:00',3.59),('8784','2013-03-21','10:05:00',3.65),('8784','2013-03-21','10:10:00',3.69),('8784','2013-03-21','10:15:00',3.73),('8784','2013-03-21','10:20:00',3.75),('8784','2013-03-21','10:25:00',3.8),('8784','2013-03-21','10:30:00',3.86),('8784','2013-03-21','10:35:00',3.92),('8784','2013-03-21','10:40:00',3.93),('8784','2013-03-21','10:45:00',3.91),('8784','2013-03-21','10:50:00',3.93),('8784','2013-03-21','10:55:00',3.71),('8784','2013-03-21','11:00:00',4.02),('8784','2013-03-21','11:05:00',4.08),('8784','2013-03-21','11:10:00',4.09),('8784','2013-03-21','11:15:00',4.14),('8784','2013-03-21','11:20:00',4.16),('8784','2013-03-21','11:25:00',4.22),('8784','2013-03-21','11:30:00',4.24),('8784','2013-03-21','11:35:00',4.25),('8784','2013-03-21','11:40:00',4.26),('8784','2013-03-21','11:45:00',4.29),('8784','2013-03-21','11:50:00',4.31),('8784','2013-03-21','11:55:00',4.33),('8784','2013-03-21','12:00:00',4.33),('8784','2013-03-21','12:05:00',4.34),('8784','2013-03-21','12:10:00',4.33),('8784','2013-03-21','12:15:00',4.34),('8784','2013-03-21','12:20:00',4.31),('8784','2013-03-21','12:25:00',4.32),('8784','2013-03-21','12:30:00',4.31),('8784','2013-03-21','12:35:00',4.28),('8784','2013-03-21','12:40:00',4.28),('8784','2013-03-21','12:45:00',4.25),('8784','2013-03-21','12:50:00',4.23),('8784','2013-03-21','12:55:00',4.24),('8784','2013-03-21','13:00:00',4.2),('8784','2013-03-21','13:05:00',4.17),('8784','2013-03-21','13:10:00',4.14),('8784','2013-03-21','13:15:00',4.12),('8784','2013-03-21','13:20:00',4.09),('8784','2013-03-21','13:25:00',4.02),('8784','2013-03-21','13:30:00',4),('8784','2013-03-21','13:35:00',3.98),('8784','2013-03-21','13:40:00',3.94),('8784','2013-03-21','13:45:00',3.9),('8784','2013-03-21','13:50:00',3.86),('8784','2013-03-21','13:55:00',3.81),('8784','2013-03-21','14:00:00',3.74),('8784','2013-03-21','14:05:00',3.65),('8784','2013-03-21','14:10:00',3.61),('8784','2013-03-21','14:15:00',3.57),('8784','2013-03-21','14:20:00',3.51),('8784','2013-03-21','14:25:00',3.45),('8784','2013-03-21','14:30:00',3.38),('8784','2013-03-21','14:35:00',3.32),('8784','2013-03-21','14:40:00',3.25),('8784','2013-03-21','14:45:00',3.21),('8784','2013-03-21','14:50:00',3.16),('8784','2013-03-21','14:55:00',3.08),('8784','2013-03-21','15:00:00',3.01),('8784','2013-03-21','15:05:00',2.94),('8784','2013-03-21','15:10:00',2.85),('8784','2013-03-21','15:15:00',2.79),('8784','2013-03-21','15:20:00',2.72),('8784','2013-03-21','15:25:00',2.64),('8784','2013-03-21','15:30:00',2.55),('8784','2013-03-21','15:35:00',2.47),('8784','2013-03-21','15:40:00',2.37),('8784','2013-03-21','15:45:00',2.29),('8784','2013-03-21','15:50:00',2.2),('8784','2013-03-21','15:55:00',2.11),('8784','2013-03-21','16:00:00',2.02),('8784','2013-03-21','16:05:00',1.93),('8784','2013-03-21','16:10:00',1.8),('8784','2013-03-21','16:15:00',1.74),('8784','2013-03-21','16:20:00',1.66),('8784','2013-03-21','16:25:00',1.54),('8784','2013-03-21','16:30:00',1.44),('8784','2013-03-21','16:35:00',1.35),('8784','2013-03-21','16:40:00',1.23),('8784','2013-03-21','16:45:00',1.17),('8784','2013-03-21','16:50:00',1.08),('8784','2013-03-20','07:30:00',1.07),('8784','2013-03-20','07:35:00',1.16),('8784','2013-03-20','07:40:00',1.19),('8784','2013-03-20','07:45:00',1.26),('8784','2013-03-20','07:50:00',1.3),('8784','2013-03-20','07:55:00',1.59),('8784','2013-03-20','08:00:00',1.26),('8784','2013-03-20','08:05:00',1.53),('8784','2013-03-20','08:10:00',1.72),('8784','2013-03-20','08:15:00',1.82),('8784','2013-03-20','08:20:00',1.89),('8784','2013-03-20','08:25:00',2),('8784','2013-03-20','08:30:00',2.14),('8784','2013-03-20','08:35:00',2.23),('8784','2013-03-20','08:40:00',2.18),('8784','2013-03-20','08:45:00',2.29),('8784','2013-03-20','08:50:00',2.38),('8784','2013-03-20','08:55:00',2.35),('8784','2013-03-20','09:00:00',2.39),('8784','2013-03-20','09:05:00',3.12),('8784','2013-03-20','09:10:00',2.67),('8784','2013-03-20','09:15:00',2.77),('8784','2013-03-20','09:20:00',2.94),('8784','2013-03-20','09:25:00',2.94),('8784','2013-03-20','09:30:00',2.98),('8784','2013-03-20','09:35:00',2.87),('8784','2013-03-20','09:40:00',3.11),('8784','2013-03-20','09:45:00',3.18),('8784','2013-03-20','09:50:00',3.23),('8784','2013-03-20','09:55:00',3.23),('8784','2013-03-20','10:00:00',3.35),('8784','2013-03-20','10:05:00',3.19),('8784','2013-03-20','10:10:00',2.88),('8784','2013-03-20','10:15:00',3.13),('8784','2013-03-20','10:20:00',2.42),('8784','2013-03-20','10:25:00',2.58),('8784','2013-03-20','10:30:00',3.02),('8784','2013-03-20','10:35:00',3.95),('8784','2013-03-20','10:40:00',3),('8784','2013-03-20','10:45:00',2.71),('8784','2013-03-20','10:50:00',3.21),('8784','2013-03-20','10:55:00',2.95),('8784','2013-03-20','11:00:00',3.03),('8784','2013-03-20','11:05:00',3.48),('8784','2013-03-20','11:10:00',2.52),('8784','2013-03-20','11:15:00',2.47),('8784','2013-03-20','11:20:00',2.84),('8784','2013-03-20','11:25:00',2.68),('8784','2013-03-20','11:30:00',2.52),('8784','2013-03-20','11:35:00',2.79),('8784','2013-03-20','11:40:00',2.27),('8784','2013-03-20','11:45:00',2.19),('8784','2013-03-20','11:50:00',2.14),('8784','2013-03-20','11:55:00',2.34),('8784','2013-03-20','12:00:00',2.31),('8784','2013-03-20','12:05:00',2.53),('8784','2013-03-20','12:10:00',2.07),('8784','2013-03-20','12:15:00',1.83),('8784','2013-03-20','12:20:00',1.68),('8784','2013-03-20','12:25:00',1.42),('8784','2013-03-20','12:30:00',1.16),('8784','2013-03-20','12:35:00',1.5),('8784','2013-03-20','12:40:00',1.06),('8784','2013-03-20','12:45:00',1.17),('8784','2013-03-20','12:50:00',1.6),('8784','2013-03-20','12:55:00',1.9),('8784','2013-03-20','13:00:00',2.02),('8784','2013-03-20','13:05:00',1.56),('8784','2013-03-20','13:10:00',1.56),('8784','2013-03-20','13:15:00',1.29),('8784','2013-03-20','13:20:00',1.38),('8784','2013-03-20','13:25:00',1.47),('8784','2013-03-20','13:30:00',1.6),('8784','2013-03-20','13:35:00',1.52),('8784','2013-03-20','13:40:00',1.91),('8784','2013-03-20','13:45:00',2.18),('8784','2013-03-20','13:50:00',1.84),('8784','2013-03-20','13:55:00',1.72),('8784','2013-03-20','14:00:00',1.72),('8784','2013-03-20','14:05:00',1.47),('8784','2013-03-20','14:10:00',1.39),('8784','2013-03-20','14:15:00',1.87),('8784','2013-03-20','14:20:00',2.26),('8784','2013-03-20','14:25:00',2.08),('8784','2013-03-20','14:30:00',1.83),('8784','2013-03-20','14:35:00',1.5),('8784','2013-03-20','14:40:00',1.2),('8784','2013-03-20','14:45:00',1.17),('8784','2013-03-19','07:35:00',1.03),('8784','2013-03-19','07:40:00',1.14),('8784','2013-03-19','07:45:00',1.24),('8784','2013-03-19','07:50:00',1.35),('8784','2013-03-19','07:55:00',1.33),('8784','2013-03-19','08:00:00',1.01),('8784','2013-03-19','08:05:00',1.33),('8784','2013-03-19','08:10:00',1.66),('8784','2013-03-19','08:15:00',1.8),('8784','2013-03-19','08:20:00',1.87),('8784','2013-03-19','08:25:00',1.93),('8784','2013-03-19','08:30:00',2.06),('8784','2013-03-19','08:35:00',1.65),('8784','2013-03-19','08:40:00',2.1),('8784','2013-03-19','08:45:00',2.36),('8784','2013-03-19','08:50:00',2.43),('8784','2013-03-19','08:55:00',2.5),('8784','2013-03-19','09:00:00',2.56),('8784','2013-03-19','09:05:00',2.65),('8784','2013-03-19','09:10:00',2.72),('8784','2013-03-19','09:15:00',2.83),('8784','2013-03-19','09:20:00',2.04),('8784','2013-03-19','09:25:00',2.74),('8784','2013-03-19','09:30:00',3.07),('8784','2013-03-19','09:35:00',3.08),('8784','2013-03-19','09:40:00',3.22),('8784','2013-03-19','09:45:00',3.24),('8784','2013-03-19','09:50:00',2.97),('8784','2013-03-19','09:55:00',3),('8784','2013-03-19','10:00:00',2.75),('8784','2013-03-19','10:05:00',3.12),('8784','2013-03-19','10:10:00',3.56),('8784','2013-03-19','10:15:00',3.59),('8784','2013-03-19','10:20:00',3.65),('8784','2013-03-19','10:25:00',3.37),('8784','2013-03-19','10:30:00',3.74),('8784','2013-03-19','10:35:00',3.79),('8784','2013-03-19','10:40:00',3.8),('8784','2013-03-19','10:45:00',3.86),('8784','2013-03-19','10:50:00',3.83),('8784','2013-03-19','10:55:00',4.01),('8784','2013-03-19','11:00:00',4.01),('8784','2013-03-19','11:05:00',4.01),('8784','2013-03-19','11:10:00',3.92),('8784','2013-03-19','11:15:00',4.1),('8784','2013-03-19','11:20:00',4.09),('8784','2013-03-19','11:25:00',4.09),('8784','2013-03-19','11:30:00',4.09),('8784','2013-03-19','11:35:00',2.52),('8784','2013-03-19','11:40:00',3.8),('8784','2013-03-19','11:45:00',3.78),('8784','2013-03-19','11:50:00',4.35),('8784','2013-03-19','11:55:00',4.25),('8784','2013-03-19','12:00:00',4.2),('8784','2013-03-19','12:05:00',4.16),('8784','2013-03-19','12:10:00',4.16),('8784','2013-03-19','12:15:00',3.96),('8784','2013-03-19','12:20:00',4.18),('8784','2013-03-19','12:25:00',4.11),('8784','2013-03-19','12:30:00',4.07),('8784','2013-03-19','12:35:00',4.13),('8784','2013-03-19','12:40:00',4.13),('8784','2013-03-19','12:45:00',4.09),('8784','2013-03-19','12:50:00',4.12),('8784','2013-03-19','12:55:00',4.1),('8784','2013-03-19','13:00:00',4.08),('8784','2013-03-19','13:05:00',4.03),('8784','2013-03-19','13:10:00',4),('8784','2013-03-19','13:15:00',3.96),('8784','2013-03-19','13:20:00',3.94),('8784','2013-03-19','13:25:00',3.91),('8784','2013-03-19','13:30:00',3.89),('8784','2013-03-19','13:35:00',3.84),('8784','2013-03-19','13:40:00',3.74),('8784','2013-03-19','13:45:00',3.74),('8784','2013-03-19','13:50:00',3.72),('8784','2013-03-19','13:55:00',3.62),('8784','2013-03-19','14:00:00',3.63),('8784','2013-03-19','14:05:00',3.57),('8784','2013-03-19','14:10:00',3.52),('8784','2013-03-19','14:15:00',3.46),('8784','2013-03-19','14:20:00',3.42),('8784','2013-03-19','14:25:00',3.38),('8784','2013-03-19','14:30:00',3.31),('8784','2013-03-19','14:35:00',3.24),('8784','2013-03-19','14:40:00',3.19),('8784','2013-03-19','14:45:00',3.12),('8784','2013-03-19','14:50:00',3.06),('8784','2013-03-19','14:55:00',3),('8784','2013-03-19','15:00:00',2.93),('8784','2013-03-19','15:05:00',2.84),('8784','2013-03-19','15:10:00',2.77),('8784','2013-03-19','15:15:00',2.69),('8784','2013-03-19','15:20:00',2.64),('8784','2013-03-19','15:25:00',2.54),('8784','2013-03-19','15:30:00',2.48),('8784','2013-03-19','15:35:00',2.4),('8784','2013-03-19','15:40:00',2.32),('8784','2013-03-19','15:45:00',2.22),('8784','2013-03-19','15:50:00',2.14),('8784','2013-03-19','15:55:00',2.05),('8784','2013-03-19','16:00:00',1.96),('8784','2013-03-19','16:05:00',1.87),('8784','2013-03-19','16:10:00',1.78),('8784','2013-03-19','16:15:00',1.68),('8784','2013-03-19','16:20:00',1.58),('8784','2013-03-19','16:25:00',1.5),('8784','2013-03-19','16:30:00',1.43),('8784','2013-03-19','16:35:00',1.34),('8784','2013-03-19','16:40:00',1.23),('8784','2013-03-19','16:45:00',1),('8784','2013-03-18','08:45:00',1.03),('8784','2013-03-18','09:55:00',1.08),('8784','2013-03-18','10:00:00',1.34),('8784','2013-03-18','10:05:00',1.6),('8784','2013-03-18','10:10:00',1.6),('8784','2013-03-18','10:15:00',1.38),('8784','2013-03-18','10:20:00',1.65),('8784','2013-03-18','10:25:00',2),('8784','2013-03-18','10:30:00',1.91),('8784','2013-03-18','10:35:00',1.61),('8784','2013-03-18','10:40:00',1.53),('8784','2013-03-18','10:45:00',1.6),('8784','2013-03-18','10:50:00',1.51),('8784','2013-03-18','10:55:00',1.26),('8784','2013-03-18','11:00:00',1.37),('8784','2013-03-18','11:05:00',1.51),('8784','2013-03-18','11:10:00',1.72),('8784','2013-03-18','11:15:00',1.88),('8784','2013-03-18','11:20:00',1.93),('8784','2013-03-18','11:25:00',2.04),('8784','2013-03-18','11:30:00',2.5),('8784','2013-03-18','11:35:00',2.1),('8784','2013-03-18','11:40:00',1.92),('8784','2013-03-18','11:45:00',1.64),('8784','2013-03-18','11:50:00',1.35),('8784','2013-03-18','11:55:00',1.62),('8784','2013-03-18','12:00:00',1.68),('8784','2013-03-18','12:05:00',2.95),('8784','2013-03-18','12:10:00',2.69),('8784','2013-03-18','12:15:00',3.17),('8784','2013-03-18','12:20:00',2.99),('8784','2013-03-18','12:25:00',2.22),('8784','2013-03-18','12:30:00',3.36),('8784','2013-03-18','12:35:00',3.96),('8784','2013-03-18','12:40:00',2.96),('8784','2013-03-18','12:45:00',2.79),('8784','2013-03-18','12:50:00',3.76),('8784','2013-03-18','12:55:00',4.03),('8784','2013-03-18','13:00:00',3.64),('8784','2013-03-18','13:05:00',1.74),('8784','2013-03-18','13:10:00',1.29),('8784','2013-03-18','13:20:00',1.2),('8784','2013-03-18','13:25:00',2.12),('8784','2013-03-18','13:30:00',1.42),('8784','2013-03-18','13:35:00',1.28),('8784','2013-03-18','13:40:00',2.21),('8784','2013-03-18','13:45:00',1.95),('8784','2013-03-18','13:50:00',1.79),('8784','2013-03-18','13:55:00',1.62),('8784','2013-03-18','14:00:00',1.82),('8784','2013-03-18','14:05:00',2.72),('8784','2013-03-18','14:10:00',2.44),('8784','2013-03-18','14:15:00',1.32),('8784','2013-03-18','14:20:00',1.31),('8784','2013-03-18','14:25:00',1.83),('8784','2013-03-18','14:35:00',1.21),('8784','2013-03-18','14:40:00',1.28),('8784','2013-03-18','14:45:00',1.14),('8784','2013-03-18','15:00:00',1.15),('8784','2013-03-17','08:15:00',1.09),('8784','2013-03-17','08:20:00',1.23),('8784','2013-03-17','08:25:00',1.61),('8784','2013-03-17','08:30:00',1.44),('8784','2013-03-17','08:35:00',1.25),('8784','2013-03-17','08:40:00',1.3),('8784','2013-03-17','08:45:00',1.54),('8784','2013-03-17','08:50:00',1.49),('8784','2013-03-17','08:55:00',1.41),('8784','2013-03-17','09:00:00',1.38),('8784','2013-03-17','09:05:00',1.59),('8784','2013-03-17','09:10:00',1.84),('8784','2013-03-17','09:15:00',1.99),('8784','2013-03-17','09:20:00',1.65),('8784','2013-03-17','09:25:00',1.4),('8784','2013-03-17','09:30:00',1.57),('8784','2013-03-17','09:35:00',1.71),('8784','2013-03-17','09:40:00',1.67),('8784','2013-03-17','09:45:00',1.7),('8784','2013-03-17','09:50:00',1.9),('8784','2013-03-17','09:55:00',2.04),('8784','2013-03-17','10:00:00',2.27),('8784','2013-03-17','10:05:00',1.87),('8784','2013-03-17','10:10:00',1.86),('8784','2013-03-17','10:15:00',2.02),('8784','2013-03-17','10:20:00',2.05),('8784','2013-03-17','10:25:00',2.14),('8784','2013-03-17','10:30:00',2.07),('8784','2013-03-17','10:35:00',1.99),('8784','2013-03-17','10:40:00',1.89),('8784','2013-03-17','10:45:00',1.99),('8784','2013-03-17','10:50:00',1.88),('8784','2013-03-17','10:55:00',1.76),('8784','2013-03-17','11:00:00',1.72),('8784','2013-03-17','11:05:00',1.47),('8784','2013-03-17','11:10:00',1.44),('8784','2013-03-17','11:15:00',1.61),('8784','2013-03-17','11:20:00',1.84),('8784','2013-03-17','11:25:00',1.86),('8784','2013-03-17','11:30:00',1.68),('8784','2013-03-17','11:35:00',1.66),('8784','2013-03-17','11:40:00',1.58),('8784','2013-03-17','11:45:00',1.46),('8784','2013-03-17','11:50:00',1.35),('8784','2013-03-17','11:55:00',1.2),('8784','2013-03-17','12:00:00',1.15),('8784','2013-03-17','12:05:00',1.18),('8784','2013-03-17','12:10:00',1.55),('8784','2013-03-17','12:15:00',2.09),('8784','2013-03-17','12:20:00',2.53),('8784','2013-03-17','12:25:00',3.43),('8784','2013-03-17','12:30:00',3.56),('8784','2013-03-17','12:35:00',2.62),('8784','2013-03-17','12:40:00',2.75),('8784','2013-03-17','12:45:00',2.53),('8784','2013-03-17','12:50:00',2.27),('8784','2013-03-17','12:55:00',1.88),('8784','2013-03-17','13:00:00',2.2),('8784','2013-03-17','13:05:00',2.38),('8784','2013-03-17','13:10:00',2.66),('8784','2013-03-17','13:15:00',2.61),('8784','2013-03-17','13:20:00',2.18),('8784','2013-03-17','13:25:00',1.95),('8784','2013-03-17','13:30:00',2.83),('8784','2013-03-17','13:35:00',2.86),('8784','2013-03-17','13:40:00',2.12),('8784','2013-03-17','13:45:00',1.94),('8784','2013-03-17','13:50:00',1.55),('8784','2013-03-17','13:55:00',2.39),('8784','2013-03-17','14:00:00',2.21),('8784','2013-03-17','14:05:00',2.3),('8784','2013-03-17','14:10:00',2.67),('8784','2013-03-17','14:15:00',2.66),('8784','2013-03-17','14:20:00',2.85),('8784','2013-03-17','14:25:00',2.37),('8784','2013-03-17','14:30:00',2.35),('8784','2013-03-17','14:35:00',1.99),('8784','2013-03-17','14:40:00',1.5),('8784','2013-03-17','14:45:00',1.38),('8784','2013-03-17','14:50:00',1.2),('8784','2013-03-17','14:55:00',1.3),('8784','2013-03-17','15:00:00',1.67),('8784','2013-03-17','15:05:00',1.83),('8784','2013-03-17','15:10:00',2.33),('8784','2013-03-17','15:15:00',2.18),('8784','2013-03-17','15:20:00',2.66),('8784','2013-03-17','15:25:00',2.42),('8784','2013-03-17','15:30:00',1.5),('8784','2013-03-17','15:35:00',2.04),('8784','2013-03-17','15:40:00',1.69),('8784','2013-03-17','15:45:00',1.39),('8784','2013-03-17','16:45:00',1.19),('8784','2013-03-16','08:05:00',1.04),('8784','2013-03-16','08:10:00',1.72),('8784','2013-03-16','08:15:00',1.99),('8784','2013-03-16','08:20:00',2.13),('8784','2013-03-16','08:25:00',2.12),('8784','2013-03-16','08:30:00',2.08),('8784','2013-03-16','08:35:00',2.23),('8784','2013-03-16','08:40:00',2.29),('8784','2013-03-16','08:45:00',2.32),('8784','2013-03-16','08:50:00',2.53),('8784','2013-03-16','08:55:00',2.72),('8784','2013-03-16','09:00:00',2.7),('8784','2013-03-16','09:05:00',2.75),('8784','2013-03-16','09:10:00',2.57),('8784','2013-03-16','09:15:00',2.92),('8784','2013-03-16','09:20:00',2.73),('8784','2013-03-16','09:25:00',1.7),('8784','2013-03-16','09:30:00',2.58),('8784','2013-03-16','09:35:00',3.35),('8784','2013-03-16','09:40:00',2.87),('8784','2013-03-16','09:45:00',3.1),('8784','2013-03-16','09:50:00',3.44),('8784','2013-03-16','09:55:00',3.54),('8784','2013-03-16','10:00:00',2.82),('8784','2013-03-16','10:05:00',2.56),('8784','2013-03-16','10:10:00',3.27),('8784','2013-03-16','10:15:00',2.39),('8784','2013-03-16','10:20:00',2.24),('8784','2013-03-16','10:25:00',2.71),('8784','2013-03-16','10:30:00',2.32),('8784','2013-03-16','10:35:00',3.52),('8784','2013-03-16','10:40:00',3.95),('8784','2013-03-16','10:45:00',3.87),('8784','2013-03-16','10:50:00',3.92),('8784','2013-03-16','10:55:00',3.93),('8784','2013-03-16','11:00:00',3.96),('8784','2013-03-16','11:05:00',3.98),('8784','2013-03-16','11:10:00',4.01),('8784','2013-03-16','11:15:00',4.03),('8784','2013-03-16','11:20:00',4.05),('8784','2013-03-16','11:25:00',4.06),('8784','2013-03-16','11:30:00',4.11),('8784','2013-03-16','11:35:00',4.11),('8784','2013-03-16','11:40:00',4.12),('8784','2013-03-16','11:45:00',4.12),('8784','2013-03-16','11:50:00',4.14),('8784','2013-03-16','11:55:00',4.13),('8784','2013-03-16','12:00:00',4.14),('8784','2013-03-16','12:05:00',4.13),('8784','2013-03-16','12:10:00',4.08),('8784','2013-03-16','12:15:00',4.12),('8784','2013-03-16','12:20:00',4.12),('8784','2013-03-16','12:25:00',4.12),('8784','2013-03-16','12:30:00',4.13),('8784','2013-03-16','12:35:00',4.1),('8784','2013-03-16','12:40:00',4.11),('8784','2013-03-16','12:45:00',4.09),('8784','2013-03-16','12:50:00',4.06),('8784','2013-03-16','12:55:00',4.04),('8784','2013-03-16','13:00:00',3.99),('8784','2013-03-16','13:05:00',3.96),('8784','2013-03-16','13:10:00',3.93),('8784','2013-03-16','13:15:00',3.91),('8784','2013-03-16','13:20:00',4.02),('8784','2013-03-16','13:25:00',1.93),('8784','2013-03-16','13:30:00',1.4),('8784','2013-03-16','13:35:00',1.09),('8784','2013-03-16','13:40:00',2.88),('8784','2013-03-16','13:45:00',2.95),('8784','2013-03-16','13:50:00',3.24),('8784','2013-03-16','13:55:00',1.9),('8784','2013-03-16','14:00:00',3.31),('8784','2013-03-16','14:05:00',3.04),('8784','2013-03-16','14:10:00',1.08),('8784','2013-03-16','14:15:00',3.6),('8784','2013-03-16','14:20:00',1.26),('8784','2013-03-16','14:25:00',1.23),('8784','2013-03-16','14:30:00',3.66),('8784','2013-03-16','14:35:00',3.26),('8784','2013-03-16','14:40:00',2.55),('8784','2013-03-16','14:45:00',1.05),('8784','2013-03-16','16:00:00',1.72),('8784','2013-03-16','16:05:00',1.91),('8784','2013-03-16','16:10:00',1.85),('8784','2013-03-16','16:15:00',1.82),('8784','2013-03-16','16:20:00',1.05),('8784','2013-03-16','16:55:00',1.09),('8784','2013-03-16','17:00:00',1.01),('8784','2013-03-15','10:35:00',1.15),('8784','2013-03-15','10:40:00',1.3),('8784','2013-03-15','10:45:00',1.51),('8784','2013-03-15','10:50:00',1.49),('8784','2013-03-15','10:55:00',1.65),('8784','2013-03-15','11:00:00',1.63),('8784','2013-03-15','11:05:00',1.4),('8784','2013-03-15','11:10:00',1.39),('8784','2013-03-15','11:15:00',1.17),('8784','2013-03-15','11:20:00',1.35),('8784','2013-03-15','11:25:00',1.68),('8784','2013-03-15','11:30:00',1.86),('8784','2013-03-15','11:35:00',2.39),('8784','2013-03-15','11:40:00',2.59),('8784','2013-03-15','11:45:00',2.43),('8784','2013-03-15','11:50:00',2.17),('8784','2013-03-15','11:55:00',2.26),('8784','2013-03-15','12:00:00',2.05),('8784','2013-03-15','12:05:00',1.98),('8784','2013-03-15','12:10:00',2.14),('8784','2013-03-15','12:15:00',1.9),('8784','2013-03-15','12:20:00',1.86),('8784','2013-03-15','12:25:00',1.97),('8784','2013-03-15','12:30:00',2.05),('8784','2013-03-15','12:35:00',2.33),('8784','2013-03-15','12:40:00',1.98),('8784','2013-03-15','12:45:00',1.64),('8784','2013-03-15','12:50:00',1.54),('8784','2013-03-15','12:55:00',1.49),('8784','2013-03-15','13:00:00',1.39),('8784','2013-03-15','13:05:00',1.29),('8784','2013-03-15','13:10:00',1.35),('8784','2013-03-15','13:15:00',1.49),('8784','2013-03-15','13:20:00',1.6),('8784','2013-03-15','13:25:00',1.78),('8784','2013-03-15','13:30:00',1.7),('8784','2013-03-15','13:35:00',1.57),('8784','2013-03-15','13:40:00',1.63),('8784','2013-03-15','13:45:00',1.74),('8784','2013-03-15','13:50:00',1.42),('8784','2013-03-15','13:55:00',1.22),('8784','2013-03-15','14:00:00',1.11),('8784','2013-03-15','14:50:00',1.11),('8784','2013-03-15','14:55:00',1.26),('8784','2013-03-15','15:00:00',1.34),('8784','2013-03-15','15:05:00',1.27),('8784','2013-03-15','15:10:00',1.26),('8784','2013-03-15','15:15:00',1.35),('8784','2013-03-15','15:20:00',1.41),('8784','2013-03-15','15:25:00',1.51),('8784','2013-03-15','15:30:00',1.32),('8784','2013-03-15','15:35:00',1.12),('8784','2013-03-15','16:00:00',1),('8784','2013-03-14','13:05:00',1.09),('8784','2013-03-14','13:10:00',1.21),('8784','2013-03-14','13:15:00',1.23),('8784','2013-03-14','13:20:00',1.23),('8784','2013-03-14','13:25:00',1.21),('8784','2013-03-14','13:30:00',1.28),('8784','2013-03-14','13:35:00',1.4),('8784','2013-03-14','13:40:00',1.25),('8784','2013-03-14','13:45:00',1.34),('8784','2013-03-14','13:50:00',1.68),('8784','2013-03-14','13:55:00',1.93),('8784','2013-03-14','14:00:00',1.81),('8784','2013-03-14','14:05:00',1.97),('8784','2013-03-14','14:10:00',1.58),('8784','2013-03-14','14:15:00',1.36),('8784','2013-03-14','14:20:00',1.29),('8784','2013-03-14','14:25:00',1.29),('8784','2013-03-14','14:30:00',1.11),('8784','2013-03-14','15:10:00',1.39),('8784','2013-03-14','15:15:00',1.37),('8784','2013-03-14','15:20:00',1.3),('8784','2013-03-14','15:25:00',1.36),('8784','2013-03-14','15:30:00',1.35),('8784','2013-03-14','15:35:00',1.07),('8784','2013-03-13','08:50:00',1.26),('8784','2013-03-13','08:55:00',1.17),('8784','2013-03-13','09:10:00',1.27),('8784','2013-03-13','09:20:00',1.07),('8784','2013-03-13','09:45:00',1.1),('8784','2013-03-13','10:05:00',1.14),('8784','2013-03-13','10:10:00',1.43),('8784','2013-03-13','10:15:00',2.44),('8784','2013-03-13','10:20:00',1.68),('8784','2013-03-13','10:25:00',2.45),('8784','2013-03-13','10:30:00',3.56),('8784','2013-03-13','10:35:00',3.45),('8784','2013-03-13','10:40:00',2.4),('8784','2013-03-13','10:45:00',1.57),('8784','2013-03-13','10:50:00',1.29),('8784','2013-03-13','10:55:00',1.12),('8784','2013-03-13','11:00:00',1.25),('8784','2013-03-13','11:10:00',1.31),('8784','2013-03-13','11:15:00',1.18),('8784','2013-03-13','11:30:00',1.32),('8784','2013-03-13','11:35:00',1.36),('8784','2013-03-13','11:40:00',1.35),('8784','2013-03-13','11:45:00',1.53),('8784','2013-03-13','11:50:00',1.36),('8784','2013-03-13','11:55:00',1.03),('8784','2013-03-13','12:40:00',1),('8784','2013-03-13','12:45:00',1.22),('8784','2013-03-13','12:50:00',1.42),('8784','2013-03-13','12:55:00',1.29),('8784','2013-03-13','13:00:00',1.26),('8784','2013-03-13','13:05:00',1.22),('8784','2013-03-13','13:10:00',1.11),('8784','2013-03-13','13:35:00',1.13),('8784','2014-03-25','07:15:00',1.19),('8784','2014-03-25','07:20:00',1.36),('8784','2014-03-25','07:25:00',1.45),('8784','2014-03-25','07:30:00',1.52),('8784','2014-03-25','07:35:00',1.18),('8784','2014-03-25','07:40:00',1.14),('8784','2014-03-25','07:45:00',1.27),('8784','2014-03-25','07:50:00',1.36),('8784','2014-03-25','07:55:00',1.37),('8784','2014-03-25','08:00:00',1.31),('8784','2014-03-25','08:05:00',1.35),('8784','2014-03-25','08:10:00',1.41),('8784','2014-03-25','08:15:00',1.51),('8784','2014-03-25','08:20:00',1.39),('8784','2014-03-25','08:25:00',1.26),('8784','2014-03-25','08:30:00',1.15),('8784','2014-03-25','08:35:00',1.18),('8784','2014-03-25','08:40:00',1.39),('8784','2014-03-25','08:45:00',1.91),('8784','2014-03-25','08:50:00',2),('8784','2014-03-25','08:55:00',2.1),('8784','2014-03-25','09:00:00',1.9),('8784','2014-03-25','09:05:00',1.86),('8784','2014-03-25','09:10:00',1.87),('8784','2014-03-25','09:15:00',2.42),('8784','2014-03-25','09:20:00',2.63),('8784','2014-03-25','09:25:00',2.29),('8784','2014-03-25','09:30:00',2.09),('8784','2014-03-25','09:35:00',1.95),('8784','2014-03-25','09:40:00',1.95),('8784','2014-03-25','09:45:00',1.84),('8784','2014-03-25','09:50:00',1.91),('8784','2014-03-25','09:55:00',2.15),('8784','2014-03-25','10:00:00',2.44),('8784','2014-03-25','10:05:00',2.58),('8784','2014-03-25','10:10:00',2.7),('8784','2014-03-25','10:15:00',2.9),('8784','2014-03-25','10:20:00',2.87),('8784','2014-03-25','10:25:00',2.76),('8784','2014-03-25','10:30:00',3.05),('8784','2014-03-25','10:35:00',2.59),('8784','2014-03-25','10:40:00',2.19),('8784','2014-03-25','10:45:00',2.05),('8784','2014-03-25','10:50:00',1.99),('8784','2014-03-25','10:55:00',2),('8784','2014-03-25','11:00:00',2.17),('8784','2014-03-25','11:05:00',2.43),('8784','2014-03-25','11:10:00',2.68),('8784','2014-03-25','11:15:00',3.04),('8784','2014-03-25','11:20:00',3.08),('8784','2014-03-25','11:25:00',2.62),('8784','2014-03-25','11:30:00',3.02),('8784','2014-03-25','11:35:00',2.48),('8784','2014-03-25','11:40:00',2.73),('8784','2014-03-25','11:45:00',2.05),('8784','2014-03-25','11:50:00',2.56),('8784','2014-03-25','11:55:00',1.82),('8784','2014-03-25','12:00:00',1.29),('8784','2014-03-25','12:20:00',1.28),('8784','2014-03-25','12:25:00',1.37),('8784','2014-03-25','12:30:00',1.06),('8784','2013-03-12','08:20:00',1.82),('8784','2013-03-12','08:25:00',1.81),('8784','2013-03-12','08:30:00',1.9),('8784','2013-03-12','08:35:00',1.62),('8784','2013-03-12','08:40:00',1.79),('8784','2013-03-12','08:45:00',2.26),('8784','2013-03-12','08:50:00',1.09),('8784','2013-03-12','09:00:00',1.57),('8784','2013-03-12','09:05:00',2.46),('8784','2013-03-12','09:10:00',2.51),('8784','2013-03-12','09:15:00',2.57),('8784','2013-03-12','09:20:00',2.64),('8784','2013-03-12','09:25:00',2.69),('8784','2013-03-12','09:30:00',2.81),('8784','2013-03-12','09:35:00',2.86),('8784','2013-03-12','09:40:00',2.85),('8784','2013-03-12','09:45:00',2.06),('8784','2013-03-12','09:50:00',2.36),('8784','2013-03-12','09:55:00',3.3),('8784','2013-03-12','10:00:00',3.09),('8784','2013-03-12','10:05:00',3.34),('8784','2013-03-12','10:10:00',3.32),('8784','2013-03-12','10:15:00',2.42),('8784','2013-03-12','10:20:00',1.57),('8784','2013-03-12','10:25:00',2.82),('8784','2013-03-12','10:30:00',1.66),('8784','2013-03-12','10:35:00',2.32),('8784','2013-03-12','10:40:00',2.76),('8784','2013-03-12','10:45:00',1.52),('8784','2013-03-12','10:50:00',3.95),('8784','2013-03-12','10:55:00',3.72),('8784','2013-03-12','11:00:00',4.05),('8784','2013-03-12','11:05:00',3.73),('8784','2013-03-12','11:10:00',3.67),('8784','2013-03-12','11:15:00',3.67),('8784','2013-03-12','11:20:00',4.04),('8784','2013-03-12','11:25:00',1.54),('8784','2013-03-12','11:30:00',1.75),('8784','2013-03-12','11:35:00',2.18),('8784','2013-03-12','11:40:00',2.23),('8784','2013-03-12','11:45:00',2.52),('8784','2013-03-12','11:50:00',2.8),('8784','2013-03-12','11:55:00',2.9),('8784','2013-03-12','12:10:00',4.75),('8784','2013-03-12','12:15:00',2.16),('8784','2013-03-12','12:20:00',2.33),('8784','2013-03-12','12:25:00',3.18),('8784','2013-03-12','12:30:00',5.02),('8784','2013-03-12','12:35:00',2.86),('8784','2013-03-12','12:40:00',3.71),('8784','2013-03-12','12:45:00',1.29),('8784','2013-03-12','12:50:00',1.86),('8784','2013-03-12','12:55:00',2.63),('8784','2013-03-12','13:00:00',4.03),('8784','2013-03-12','13:05:00',2.15),('8784','2013-03-12','13:10:00',2.77),('8784','2013-03-12','13:15:00',1.94),('8784','2013-03-12','13:20:00',3.13),('8784','2013-03-12','13:25:00',1.94),('8784','2013-03-12','13:30:00',1.61),('8784','2013-03-12','13:35:00',1.8),('8784','2013-03-12','13:40:00',1.67),('8784','2013-03-12','13:45:00',1.28),('8784','2013-03-12','13:50:00',1.26),('8784','2013-03-12','13:55:00',1.81),('8784','2013-03-12','14:00:00',2.67),('8784','2013-03-12','14:05:00',2.72),('8784','2013-03-12','14:10:00',1.6),('8784','2013-03-12','14:15:00',1.21),('8784','2013-03-12','14:20:00',1.01),('8784','2013-03-12','15:00:00',1.06),('8784','2013-03-12','15:10:00',1.02),('8784','2013-03-12','15:20:00',1.06),('8784','2013-03-11','07:40:00',1.02),('8784','2013-03-11','08:10:00',1.35),('8784','2013-03-11','08:15:00',1.5),('8784','2013-03-11','08:20:00',1.6),('8784','2013-03-11','08:25:00',1.68),('8784','2013-03-11','08:30:00',1.79),('8784','2013-03-11','08:35:00',1.88),('8784','2013-03-11','08:40:00',1.95),('8784','2013-03-11','08:45:00',2.04),('8784','2013-03-11','08:50:00',2.16),('8784','2013-03-11','08:55:00',2.22),('8784','2013-03-11','09:00:00',2.3),('8784','2013-03-11','09:05:00',2.35),('8784','2013-03-11','09:10:00',2.45),('8784','2013-03-11','09:15:00',2.53),('8784','2013-03-11','09:20:00',2.13),('8784','2013-03-11','09:25:00',1.43),('8784','2013-03-11','09:30:00',1.01),('8784','2013-03-11','09:35:00',3.83),('8784','2013-03-11','09:40:00',2.68),('8784','2013-03-11','09:45:00',2.28),('8784','2013-03-11','10:05:00',1.03),('8784','2013-03-11','10:10:00',1.24),('8784','2013-03-11','10:15:00',1.26),('8784','2013-03-11','10:20:00',1.42),('8784','2013-03-11','10:25:00',1.54),('8784','2013-03-11','10:30:00',1.45),('8784','2013-03-11','10:35:00',1.69),('8784','2013-03-11','10:40:00',2.26),('8784','2013-03-11','10:45:00',2.55),('8784','2013-03-11','10:50:00',3.37),('8784','2013-03-11','10:55:00',1.97),('8784','2013-03-11','11:00:00',1.69),('8784','2013-03-11','11:05:00',1.4),('8784','2013-03-11','11:10:00',1.54),('8784','2013-03-11','11:15:00',1.59),('8784','2013-03-11','11:20:00',1.4),('8784','2013-03-11','11:25:00',1.32),('8784','2013-03-11','11:30:00',2.3),('8784','2013-03-11','11:35:00',2.26),('8784','2013-03-11','11:40:00',2.08),('8784','2013-03-11','11:45:00',2.69),('8784','2013-03-11','11:50:00',2.39),('8784','2013-03-11','11:55:00',2.12),('8784','2013-03-11','12:00:00',1.91),('8784','2013-03-11','12:05:00',1.86),('8784','2013-03-11','12:10:00',2.38),('8784','2013-03-11','12:25:00',1.03),('8784','2013-03-11','12:30:00',1.14),('8784','2013-03-11','12:35:00',1.58),('8784','2013-03-11','12:40:00',1.27),('8784','2013-03-11','12:45:00',1.41),('8784','2013-03-11','12:50:00',2.4),('8784','2013-03-11','12:55:00',2.94),('8784','2013-03-11','13:00:00',1.96),('8784','2013-03-11','13:05:00',1.96),('8784','2013-03-11','13:10:00',3.37),('8784','2013-03-11','13:15:00',3.26),('8784','2013-03-11','13:20:00',4.2),('8784','2013-03-11','13:25:00',3.65),('8784','2013-03-11','13:30:00',3.55),('8784','2013-03-11','13:35:00',3.88),('8784','2013-03-11','13:40:00',2.56),('8784','2013-03-11','13:45:00',4.03),('8784','2013-03-11','13:50:00',3.46),('8784','2013-03-11','13:55:00',1.69),('8784','2013-03-11','14:20:00',1.37),('8784','2013-03-11','14:25:00',1.82),('8784','2013-03-11','14:30:00',1.29),('8784','2013-03-11','14:35:00',1.07),('8784','2013-03-11','14:40:00',1.86),('8784','2013-03-11','15:25:00',1.23),('8784','2013-03-11','15:30:00',2.61),('8784','2013-03-11','15:35:00',1.26),('8784','2013-03-11','15:40:00',1.81),('8784','2013-03-11','15:45:00',2.65),('8784','2013-03-11','15:50:00',2.06),('8784','2013-03-11','15:55:00',1.81),('8784','2013-03-11','16:00:00',1.67),('8784','2013-03-11','16:05:00',1.53),('8784','2013-03-11','16:10:00',1.42),('8784','2013-03-11','16:15:00',1.19),('8784','2013-03-11','16:20:00',1.33),('8784','2013-03-11','16:25:00',1.21),('8784','2013-03-11','16:30:00',1.34),('8784','2013-03-11','16:35:00',1.12),('8784','2013-03-11','16:40:00',1.16),('8784','2013-03-11','16:45:00',1.29),('8784','2013-03-10','07:50:00',1.11),('8784','2013-03-10','07:55:00',1.19),('8784','2013-03-10','08:00:00',1.27),('8784','2013-03-10','08:05:00',1.37),('8784','2013-03-10','08:10:00',1.29),('8784','2013-03-10','08:15:00',1.43),('8784','2013-03-10','08:20:00',1.61),('8784','2013-03-10','08:25:00',1.7),('8784','2013-03-10','08:30:00',1.79),('8784','2013-03-10','08:35:00',1.87),('8784','2013-03-10','08:40:00',1.95),('8784','2013-03-10','08:45:00',2.03),('8784','2013-03-10','08:50:00',2.12),('8784','2013-03-10','08:55:00',2.21),('8784','2013-03-10','09:00:00',2.29),('8784','2013-03-10','09:05:00',2.36),('8784','2013-03-10','09:10:00',2.42),('8784','2013-03-10','09:15:00',2.51),('8784','2013-03-10','09:20:00',2.55),('8784','2013-03-10','09:25:00',2.64),('8784','2013-03-10','09:30:00',2.72),('8784','2013-03-10','09:35:00',2.76),('8784','2013-03-10','09:40:00',2.92),('8784','2013-03-10','09:45:00',2.71),('8784','2013-03-10','09:50:00',3.18),('8784','2013-03-10','09:55:00',2.79),('8784','2013-03-10','10:00:00',3.46),('8784','2013-03-10','10:05:00',2.07),('8784','2013-03-10','10:10:00',2.86),('8784','2013-03-10','10:15:00',2.99),('8784','2013-03-10','10:20:00',2.3),('8784','2013-03-10','10:25:00',3.55),('8784','2013-03-10','10:30:00',2.64),('8784','2013-03-10','10:35:00',2.36),('8784','2013-03-10','10:40:00',3.18),('8784','2013-03-10','10:45:00',3.58),('8784','2013-03-10','10:50:00',1.91),('8784','2013-03-10','10:55:00',2.01),('8784','2013-03-10','11:00:00',1.8),('8784','2013-03-10','11:05:00',2.89),('8784','2013-03-10','11:10:00',2.06),('8784','2013-03-10','11:15:00',1.92),('8784','2013-03-10','11:20:00',2.25),('8784','2013-03-10','11:25:00',2.86),('8784','2013-03-10','11:30:00',2),('8784','2013-03-10','11:35:00',2.7),('8784','2013-03-10','11:40:00',1.36),('8784','2013-03-10','11:45:00',1.59),('8784','2013-03-10','11:50:00',3.87),('8784','2013-03-10','11:55:00',3.95),('8784','2013-03-10','12:00:00',3.95),('8784','2013-03-10','12:05:00',3.82),('8784','2013-03-10','12:10:00',3.95),('8784','2013-03-10','12:15:00',3.01),('8784','2013-03-10','12:20:00',4.22),('8784','2013-03-10','12:25:00',3.25),('8784','2013-03-10','12:30:00',3.5),('8784','2013-03-10','12:35:00',3.21),('8784','2013-03-10','12:40:00',4.12),('8784','2013-03-10','12:45:00',4.12),('8784','2013-03-10','12:50:00',4.04),('8784','2013-03-10','12:55:00',3.92),('8784','2013-03-10','13:00:00',3.77),('8784','2013-03-10','13:05:00',3.7),('8784','2013-03-10','13:10:00',3.54),('8784','2013-03-10','13:15:00',3.75),('8784','2013-03-10','13:20:00',3.68),('8784','2013-03-10','13:25:00',3.6),('8784','2013-03-10','13:30:00',3.44),('8784','2013-03-10','13:35:00',3.37),('8784','2013-03-10','13:40:00',2.09),('8784','2013-03-10','13:45:00',2.31),('8784','2013-03-10','13:50:00',1.98),('8784','2013-03-10','13:55:00',1.88),('8784','2013-03-10','14:00:00',1.6),('8784','2013-03-10','14:05:00',2.12),('8784','2013-03-10','14:10:00',2.15),('8784','2013-03-10','14:15:00',2.91),('8784','2013-03-10','14:20:00',2.96),('8784','2013-03-10','14:25:00',1.76),('8784','2013-03-10','14:30:00',2.55),('8784','2013-03-10','14:35:00',3.01),('8784','2013-03-10','14:40:00',2.65),('8784','2013-03-10','14:45:00',1.73),('8784','2013-03-10','14:50:00',1.73),('8784','2013-03-10','14:55:00',1.53),('8784','2013-03-10','15:00:00',1.23),('8784','2013-03-10','15:05:00',1.45),('8784','2013-03-10','15:10:00',1.42),('8784','2013-03-09','08:00:00',1.27),('8784','2013-03-09','08:05:00',1.53),('8784','2013-03-09','08:10:00',1.41),('8784','2013-03-09','08:15:00',1.46),('8784','2013-03-09','08:20:00',1.53),('8784','2013-03-09','08:25:00',1.6),('8784','2013-03-09','08:30:00',1.72),('8784','2013-03-09','08:35:00',1.76),('8784','2013-03-09','08:40:00',1.83),('8784','2013-03-09','08:45:00',1.91),('8784','2013-03-09','08:50:00',1.6),('8784','2013-03-09','08:55:00',2.01),('8784','2013-03-09','09:00:00',2),('8784','2013-03-09','09:05:00',1.17),('8784','2013-03-09','09:15:00',1.01),('8784','2013-03-09','09:20:00',1.13),('8784','2013-03-09','09:25:00',2.14),('8784','2013-03-09','09:30:00',2.54),('8784','2013-03-09','09:35:00',2.78),('8784','2013-03-09','09:40:00',2.81),('8784','2013-03-09','09:45:00',3.54),('8784','2013-03-09','09:50:00',1.73),('8784','2013-03-09','09:55:00',2.93),('8784','2013-03-09','10:05:00',1.17),('8784','2013-03-09','10:10:00',1.11),('8784','2013-03-09','10:15:00',1.4),('8784','2013-03-09','10:20:00',1.1),('8784','2013-03-09','10:25:00',1.04),('8784','2013-03-09','10:30:00',1.05),('8784','2013-03-09','10:35:00',1.56),('8784','2013-03-09','10:40:00',2.12),('8784','2013-03-09','10:45:00',4),('8784','2013-03-09','10:50:00',3.74),('8784','2013-03-09','10:55:00',3.03),('8784','2013-03-09','11:00:00',3.07),('8784','2013-03-09','11:05:00',3.86),('8784','2013-03-09','11:10:00',3.88),('8784','2013-03-09','11:15:00',3.92),('8784','2013-03-09','11:20:00',3.96),('8784','2013-03-09','11:25:00',3.53),('8784','2013-03-09','11:30:00',3.78),('8784','2013-03-09','11:35:00',3.88),('8784','2013-03-09','11:40:00',3.89),('8784','2013-03-09','11:45:00',3.91),('8784','2013-03-09','11:50:00',3.83),('8784','2013-03-09','11:55:00',3.65),('8784','2013-03-09','12:00:00',2.79),('8784','2013-03-09','12:05:00',1.37),('8784','2013-03-09','12:10:00',1.87),('8784','2013-03-09','12:15:00',1.56),('8784','2013-03-09','12:20:00',2.09),('8784','2013-03-09','12:25:00',1.82),('8784','2013-03-09','12:30:00',1.65),('8784','2013-03-09','12:35:00',1.85),('8784','2013-03-09','12:40:00',1.68),('8784','2013-03-09','12:45:00',2.35),('8784','2013-03-09','12:50:00',2.01),('8784','2013-03-09','12:55:00',3.76),('8784','2013-03-09','13:00:00',3.83),('8784','2013-03-09','13:05:00',3.7),('8784','2013-03-09','13:10:00',3.76),('8784','2013-03-09','13:15:00',4.07),('8784','2013-03-09','13:20:00',3.38),('8784','2013-03-09','13:25:00',2.39),('8784','2013-03-09','13:30:00',3.92),('8784','2013-03-09','13:35:00',3.6),('8784','2013-03-09','13:40:00',3.76),('8784','2013-03-09','13:45:00',3.64),('8784','2013-03-09','13:50:00',2.74),('8784','2013-03-09','14:00:00',1.12),('8784','2013-03-09','14:05:00',1.54),('8784','2013-03-09','14:10:00',3.25),('8784','2013-03-09','14:15:00',3.38),('8784','2013-03-09','14:20:00',3.17),('8784','2013-03-09','14:25:00',3.05),('8784','2013-03-09','14:30:00',3),('8784','2013-03-09','14:35:00',2.93),('8784','2013-03-09','14:40:00',2.87),('8784','2013-03-09','14:45:00',2.8),('8784','2013-03-09','14:50:00',2.74),('8784','2013-03-09','14:55:00',2.69),('8784','2013-03-09','15:00:00',2.61),('8784','2013-03-09','15:05:00',2.53),('8784','2013-03-09','15:10:00',2.47),('8784','2013-03-09','15:15:00',2.38),('8784','2013-03-09','15:20:00',2.31),('8784','2013-03-09','15:25:00',2.23),('8784','2013-03-09','15:30:00',2.09),('8784','2013-03-09','15:35:00',1.98),('8784','2013-03-09','15:40:00',2),('8784','2013-03-09','15:45:00',1.94),('8784','2013-03-09','15:50:00',1.81),('8784','2013-03-09','15:55:00',1.63),('8784','2013-03-09','16:00:00',1.51),('8784','2013-03-09','16:05:00',1.56),('8784','2013-03-09','16:10:00',1.25),('8784','2013-03-09','16:15:00',1.44),('8784','2013-03-09','16:20:00',1.17),('8784','2013-03-09','16:25:00',1.35),('8784','2013-03-09','16:30:00',1.18),('8784','2013-03-08','08:25:00',1.04),('8784','2013-03-08','08:30:00',1.84),('8784','2013-03-08','08:35:00',1.68),('8784','2013-03-08','08:50:00',1.13),('8784','2013-03-08','09:30:00',2.09),('8784','2013-03-08','09:35:00',1.88),('8784','2013-03-08','09:40:00',1.77),('8784','2013-03-08','09:45:00',1.39),('8784','2013-03-08','09:50:00',1.69),('8784','2013-03-08','09:55:00',1.63),('8784','2013-03-08','10:00:00',1.04),('8784','2013-03-08','10:05:00',1.22),('8784','2013-03-08','10:10:00',1.6),('8784','2013-03-08','10:15:00',1.86),('8784','2013-03-08','10:20:00',1.42),('8784','2013-03-08','10:25:00',1.55),('8784','2013-03-08','10:30:00',1.98),('8784','2013-03-08','10:35:00',2.47),('8784','2013-03-08','10:40:00',1.66),('8784','2013-03-08','10:45:00',1.17),('8784','2013-03-08','10:50:00',1.49),('8784','2013-03-08','10:55:00',1.33),('8784','2013-03-08','11:00:00',1.23),('8784','2013-03-08','11:35:00',1.85),('8784','2013-03-08','11:40:00',2.32),('8784','2013-03-08','11:45:00',1.88),('8784','2013-03-08','11:50:00',1.64),('8784','2013-03-08','11:55:00',2),('8784','2013-03-08','12:00:00',2.27),('8784','2013-03-08','12:05:00',1.47),('8784','2013-03-08','12:10:00',1.13),('8784','2013-03-08','12:15:00',1.05),('8784','2013-03-08','12:20:00',1.5),('8784','2013-03-08','12:25:00',1.28),('8784','2013-03-08','12:30:00',1.16),('8784','2013-03-08','12:35:00',1.81),('8784','2013-03-08','12:40:00',2.3),('8784','2013-03-08','12:45:00',2.21),('8784','2013-03-08','12:50:00',2.64),('8784','2013-03-08','12:55:00',2.37),('8784','2013-03-08','13:00:00',2.3),('8784','2013-03-08','13:05:00',2.42),('8784','2013-03-08','13:10:00',1.57),('8784','2013-03-08','13:15:00',1.27),('8784','2013-03-08','13:20:00',1.22),('8784','2013-03-08','13:25:00',1.62),('8784','2013-03-08','13:30:00',2.22),('8784','2013-03-08','13:35:00',1.62),('8784','2013-03-08','13:40:00',1.4),('8784','2013-03-08','17:10:00',1.28),('8784','2013-03-07','08:40:00',1.05),('8784','2013-03-07','08:45:00',1.05),('8784','2013-03-07','08:50:00',1.2),('8784','2013-03-07','10:50:00',1.28),('8784','2013-03-07','10:55:00',1.32),('8784','2013-03-07','11:00:00',1.28),('8784','2013-03-07','11:05:00',1.56),('8784','2013-03-07','11:10:00',1.12),('8784','2013-03-07','11:30:00',1.96),('8784','2013-03-07','11:35:00',2.48),('8784','2013-03-07','11:40:00',2.32),('8784','2013-03-07','11:45:00',2.46),('8784','2013-03-07','11:50:00',2.72),('8784','2013-03-07','11:55:00',1.72),('8784','2013-03-07','12:00:00',1.35),('8784','2013-03-07','12:05:00',1.19),('8784','2013-03-07','12:25:00',1.16),('8784','2013-03-07','12:30:00',1.01),('8784','2013-03-07','12:40:00',1.47),('8784','2013-03-07','12:45:00',2.1),('8784','2013-03-07','12:50:00',1.86),('8784','2013-03-07','12:55:00',1.66),('8784','2013-03-07','13:00:00',1.93),('8784','2013-03-07','13:05:00',1.98),('8784','2013-03-07','13:10:00',1.75),('8784','2013-03-07','13:15:00',2.01),('8784','2013-03-07','13:20:00',2.37),('8784','2013-03-07','13:25:00',2.04),('8784','2013-03-07','13:30:00',1.71),('8784','2013-03-07','13:35:00',1.6),('8784','2013-03-07','14:05:00',1.04),('8784','2013-03-07','14:10:00',1.13),('8784','2013-03-05','08:15:00',1.26),('8784','2013-03-05','08:25:00',1.31),('8784','2013-03-05','08:30:00',1.86),('8784','2013-03-05','08:35:00',1.66),('8784','2013-03-05','08:40:00',1.73),('8784','2013-03-05','08:45:00',1.45),('8784','2013-03-05','08:50:00',1.65),('8784','2013-03-05','08:55:00',1.56),('8784','2013-03-05','09:00:00',1.63),('8784','2013-03-05','09:05:00',1.7),('8784','2013-03-05','09:10:00',1.58),('8784','2013-03-05','09:15:00',1.54),('8784','2013-03-05','09:20:00',1.57),('8784','2013-03-05','09:25:00',1.55),('8784','2013-03-05','09:30:00',1.63),('8784','2013-03-05','09:35:00',1.76),('8784','2013-03-05','09:40:00',1.86),('8784','2013-03-05','09:45:00',1.87),('8784','2013-03-05','09:50:00',1.85),('8784','2013-03-05','09:55:00',1.78),('8784','2013-03-05','10:00:00',1.69),('8784','2013-03-05','10:05:00',1.84),('8784','2013-03-05','10:10:00',1.89),('8784','2013-03-05','10:15:00',1.99),('8784','2013-03-05','10:20:00',2.16),('8784','2013-03-05','10:25:00',1.96),('8784','2013-03-05','10:30:00',1.94),('8784','2013-03-05','10:35:00',2.27),('8784','2013-03-05','10:40:00',2.32),('8784','2013-03-05','10:45:00',2.43),('8784','2013-03-05','10:50:00',2.61),('8784','2013-03-05','10:55:00',2.63),('8784','2013-03-05','11:00:00',2.45),('8784','2013-03-05','11:05:00',2.65),('8784','2013-03-05','11:10:00',2.73),('8784','2013-03-05','11:15:00',2.69),('8784','2013-03-05','11:20:00',2.65),('8784','2013-03-05','11:25:00',2.56),('8784','2013-03-05','11:30:00',2.64),('8784','2013-03-05','11:35:00',2.9),('8784','2013-03-05','11:40:00',3.13),('8784','2013-03-05','11:45:00',2.99),('8784','2013-03-05','11:50:00',3.04),('8784','2013-03-05','11:55:00',3.09),('8784','2013-03-05','12:00:00',3.18),('8784','2013-03-05','12:05:00',3.24),('8784','2013-03-05','12:10:00',3.36),('8784','2013-03-05','12:15:00',2.73),('8784','2013-03-05','12:20:00',3.11),('8784','2013-03-05','12:25:00',3.08),('8784','2013-03-05','12:30:00',2.59),('8784','2013-03-05','12:35:00',2.48),('8784','2013-03-05','12:40:00',2.5),('8784','2013-03-05','12:45:00',2.67),('8784','2013-03-05','12:50:00',2.34),('8784','2013-03-05','12:55:00',2.12),('8784','2013-03-05','13:00:00',1.8),('8784','2013-03-05','13:05:00',1.74),('8784','2013-03-05','13:10:00',1.86),('8784','2013-03-05','13:15:00',1.98),('8784','2013-03-05','13:20:00',1.89),('8784','2013-03-05','13:25:00',1.71),('8784','2013-03-05','13:30:00',1.58),('8784','2013-03-05','13:35:00',1.5),('8784','2013-03-05','13:40:00',1.42),('8784','2013-03-05','13:45:00',1.3),('8784','2013-03-05','13:50:00',1.19),('8784','2013-03-05','13:55:00',1.13),('8784','2013-03-05','14:00:00',1.12),('8784','2013-03-05','14:05:00',1.15),('8784','2013-03-05','14:10:00',1.19),('8784','2013-03-05','14:15:00',1.11),('8784','2013-03-05','14:20:00',1.04),('8784','2013-03-05','14:25:00',1.05),('8784','2013-03-05','14:30:00',1.03),('8784','2013-03-05','14:35:00',1.04),('8784','2013-03-05','14:40:00',1.07),('8784','2013-03-05','14:45:00',1.09),('8784','2013-03-05','14:50:00',1.07),('8784','2013-03-05','15:40:00',1),('8784','2013-03-05','15:45:00',1.21),('8784','2013-03-05','15:50:00',1.17),('8784','2013-03-04','08:00:00',1.05),('8784','2013-03-04','08:05:00',1.13),('8784','2013-03-04','08:10:00',1.21),('8784','2013-03-04','08:15:00',1.3),('8784','2013-03-04','08:20:00',1.38),('8784','2013-03-04','08:25:00',1.48),('8784','2013-03-04','08:30:00',1.57),('8784','2013-03-04','08:35:00',1.65),('8784','2013-03-04','08:40:00',1.73),('8784','2013-03-04','08:45:00',1.81),('8784','2013-03-04','08:50:00',1.89),('8784','2013-03-04','08:55:00',1.97),('8784','2013-03-04','09:00:00',2.04),('8784','2013-03-04','09:05:00',2.12),('8784','2013-03-04','09:10:00',2.2),('8784','2013-03-04','09:15:00',2.26),('8784','2013-03-04','09:20:00',2.34),('8784','2013-03-04','09:25:00',2.42),('8784','2013-03-04','09:30:00',2.5),('8784','2013-03-04','09:35:00',2.55),('8784','2013-03-04','09:40:00',2.61),('8784','2013-03-04','09:46:00',2.63),('8784','2013-03-04','09:50:00',2.75),('8784','2013-03-04','09:55:00',2.81),('8784','2013-03-04','10:00:00',2.84),('8784','2013-03-04','10:05:00',2.93),('8784','2013-03-04','10:10:00',2.94),('8784','2013-03-04','10:15:00',3),('8784','2013-03-04','10:20:00',3.07),('8784','2013-03-04','10:25:00',3.11),('8784','2013-03-04','10:30:00',3.11),('8784','2013-03-04','10:35:00',3.21),('8784','2013-03-04','10:40:00',3.23),('8784','2013-03-04','10:45:00',3.25),('8784','2013-03-04','10:50:00',3.28),('8784','2013-03-04','10:55:00',3.3),('8784','2013-03-04','11:00:00',3.33),('8784','2013-03-04','11:05:00',3.41),('8784','2013-03-04','11:10:00',3.45),('8784','2013-03-04','11:15:00',3.46),('8784','2013-03-04','11:20:00',3.47),('8784','2013-03-04','11:25:00',3.49),('8784','2013-03-04','11:30:00',3.49),('8784','2013-03-04','11:35:00',3.47),('8784','2013-03-04','11:40:00',3.52),('8784','2013-03-04','11:45:00',3.52),('8784','2013-03-04','11:50:00',3.53),('8784','2013-03-04','11:55:00',3.55),('8784','2013-03-04','12:00:00',3.54),('8784','2013-03-04','12:05:00',3.56),('8784','2013-03-04','12:10:00',3.6),('8784','2013-03-04','12:15:00',3.62),('8784','2013-03-04','12:20:00',3.59),('8784','2013-03-04','12:25:00',3.59),('8784','2013-03-04','12:30:00',3.54),('8784','2013-03-04','12:35:00',3.56),('8784','2013-03-04','12:40:00',3.56),('8784','2013-03-04','12:45:00',3.52),('8784','2013-03-04','12:50:00',3.49),('8784','2013-03-04','12:55:00',3.42),('8784','2013-03-04','13:00:00',3.4),('8784','2013-03-04','13:05:00',3.38),('8784','2013-03-04','13:10:00',3.39),('8784','2013-03-04','13:15:00',3.37),('8784','2013-03-04','13:20:00',3.32),('8784','2013-03-04','13:25:00',2.91),('8784','2013-03-04','13:30:00',3.04),('8784','2013-03-04','13:35:00',3.48),('8784','2013-03-04','13:40:00',3.27),('8784','2013-03-04','13:45:00',3.07),('8784','2013-03-04','13:50:00',3.11),('8784','2013-03-04','13:55:00',3.09),('8784','2013-03-04','14:00:00',3.08),('8784','2013-03-04','14:05:00',3),('8784','2013-03-04','14:10:00',2.86),('8784','2013-03-04','14:15:00',2.77),('8784','2013-03-04','14:20:00',2.77),('8784','2013-03-04','14:25:00',2.75),('8784','2013-03-04','14:30:00',2.66),('8784','2013-03-04','14:35:00',2.49),('8784','2013-03-04','14:40:00',2.53),('8784','2013-03-04','14:45:00',2.45),('8784','2013-03-04','14:50:00',2.34),('8784','2013-03-04','14:55:00',2.32),('8784','2013-03-04','15:00:00',2.3),('8784','2013-03-04','15:05:00',2.24),('8784','2013-03-04','15:10:00',2.17),('8784','2013-03-04','15:15:00',2.06),('8784','2013-03-04','15:20:00',2.01),('8784','2013-03-04','15:25:00',1.92),('8784','2013-03-04','15:30:00',1.9),('8784','2013-03-04','15:35:00',1.83),('8784','2013-03-04','15:40:00',1.75),('8784','2013-03-04','15:45:00',1.66),('8784','2013-03-04','15:50:00',1.59),('8784','2013-03-04','15:55:00',1.52),('8784','2013-03-04','16:00:00',1.44),('8784','2013-03-04','16:05:00',1.37),('8784','2013-03-04','16:10:00',1.29),('8784','2013-03-04','16:15:00',1.21),('8784','2013-03-04','16:20:00',1.15),('8784','2013-03-04','16:25:00',1.1),('8784','2013-03-04','16:30:00',1.03),('8784','2013-03-03','08:00:00',1.06),('8784','2013-03-03','08:05:00',1.15),('8784','2013-03-03','08:10:00',1.24),('8784','2013-03-03','08:15:00',1.33),('8784','2013-03-03','08:20:00',1.42),('8784','2013-03-03','08:25:00',1.52),('8784','2013-03-03','08:30:00',1.61),('8784','2013-03-03','08:35:00',1.7),('8784','2013-03-03','08:40:00',1.79),('8784','2013-03-03','08:45:00',1.86),('8784','2013-03-03','08:50:00',1.96),('8784','2013-03-03','08:55:00',2.04),('8784','2013-03-03','09:00:00',2.12),('8784','2013-03-03','09:05:00',2.2),('8784','2013-03-03','09:10:00',2.27),('8784','2013-03-03','09:15:00',2.33),('8784','2013-03-03','09:20:00',2.43),('8784','2013-03-03','09:25:00',2.49),('8784','2013-03-03','09:30:00',2.57),('8784','2013-03-03','09:35:00',2.63),('8784','2013-03-03','09:40:00',2.7),('8784','2013-03-03','09:45:00',2.77),('8784','2013-03-03','09:50:00',2.82),('8784','2013-03-03','09:55:00',2.94),('8784','2013-03-03','10:00:00',3),('8784','2013-03-03','10:05:00',3.05),('8784','2013-03-03','10:10:00',3.12),('8784','2013-03-03','10:15:00',3.18),('8784','2013-03-03','10:20:00',3.2),('8784','2013-03-03','10:25:00',3.29),('8784','2013-03-03','10:30:00',3.33),('8784','2013-03-03','10:35:00',3.37),('8784','2013-03-03','10:40:00',3.4),('8784','2013-03-03','10:45:00',3.44),('8784','2013-03-03','10:50:00',3.46),('8784','2013-03-03','10:55:00',3.48),('8784','2013-03-03','11:00:00',3.51),('8784','2013-03-03','11:05:00',3.53),('8784','2013-03-03','11:10:00',3.54),('8784','2013-03-03','11:15:00',3.57),('8784','2013-03-03','11:20:00',3.6),('8784','2013-03-03','11:25:00',3.61),('8784','2013-03-03','11:30:00',3.63),('8784','2013-03-03','11:35:00',3.65),('8784','2013-03-03','11:40:00',3.63),('8784','2013-03-03','11:45:00',3.67),('8784','2013-03-03','11:50:00',3.67),('8784','2013-03-03','11:55:00',3.67),('8784','2013-03-03','12:00:00',3.68),('8784','2013-03-03','12:05:00',3.66),('8784','2013-03-03','12:10:00',3.71),('8784','2013-03-03','12:15:00',3.7),('8784','2013-03-03','12:20:00',3.68),('8784','2013-03-03','12:25:00',3.67),('8784','2013-03-03','12:30:00',3.68),('8784','2013-03-03','12:35:00',3.67),('8784','2013-03-03','12:40:00',3.65),('8784','2013-03-03','12:45:00',3.67),('8784','2013-03-03','12:50:00',3.64),('8784','2013-03-03','12:55:00',3.62),('8784','2013-03-03','13:00:00',3.6),('8784','2013-03-03','13:05:00',3.59),('8784','2013-03-03','13:10:00',3.55),('8784','2013-03-03','13:15:00',3.51),('8784','2013-03-03','13:20:00',3.4),('8784','2013-03-03','13:25:00',3.46),('8784','2013-03-03','13:30:00',3.43),('8784','2013-03-03','13:35:00',3.39),('8784','2013-03-03','13:40:00',3.37),('8784','2013-03-03','13:45:00',3.3),('8784','2013-03-03','13:50:00',3.27),('8784','2013-03-03','13:55:00',3.23),('8784','2013-03-03','14:00:00',3.18),('8784','2013-03-03','14:05:00',3.15),('8784','2013-03-03','14:10:00',3.11),('8784','2013-03-03','14:15:00',3.05),('8784','2013-03-03','14:20:00',2.98),('8784','2013-03-03','14:25:00',2.9),('8784','2013-03-03','14:30:00',2.86),('8784','2013-03-03','14:35:00',2.81),('8784','2013-03-03','14:40:00',2.75),('8784','2013-03-03','14:45:00',2.69),('8784','2013-03-03','14:50:00',2.62),('8784','2013-03-03','14:55:00',2.53),('8784','2013-03-03','15:00:00',2.47),('8784','2013-03-03','15:05:00',2.4),('8784','2013-03-03','15:10:00',2.3),('8784','2013-03-03','15:15:00',2.27),('8784','2013-03-03','15:20:00',2.21),('8784','2013-03-03','15:25:00',2.14),('8784','2013-03-03','15:30:00',2.08),('8784','2013-03-03','15:35:00',1.99),('8784','2013-03-03','15:40:00',1.9),('8784','2013-03-03','15:45:00',1.81),('8784','2013-03-03','15:50:00',1.73),('8784','2013-03-03','15:55:00',1.65),('8784','2013-03-03','16:00:00',1.56),('8784','2013-03-03','16:05:00',1.48),('8784','2013-03-03','16:10:00',1.39),('8784','2013-03-03','16:15:00',1.3),('8784','2013-03-03','16:20:00',1.23),('8784','2013-03-03','16:25:00',1.14),('8784','2013-03-03','16:30:00',1.05),('8784','2014-03-24','07:45:00',1.37),('8784','2014-03-24','08:55:00',1.71),('8784','2014-03-24','09:00:00',1.92),('8784','2014-03-24','09:05:00',1.2),('8784','2014-03-24','09:15:00',1.05),('8784','2014-03-24','09:20:00',1.6),('8784','2014-03-24','09:30:00',1.36),('8784','2014-03-24','09:40:00',1.61),('8784','2014-03-24','09:45:00',1.18),('8784','2014-03-24','09:50:00',1.14),('8784','2014-03-24','10:00:00',2.39),('8784','2014-03-24','10:05:00',2.7),('8784','2014-03-24','10:10:00',3.55),('8784','2014-03-24','10:15:00',2.49),('8784','2014-03-24','10:20:00',1.01),('8784','2014-03-24','10:35:00',1.46),('8784','2014-03-24','10:40:00',1.11),('8784','2014-03-24','10:45:00',2.1),('8784','2014-03-24','10:50:00',4.75),('8784','2014-03-24','10:55:00',3.68),('8784','2014-03-24','11:00:00',1.82),('8784','2014-03-24','11:05:00',2.26),('8784','2014-03-24','11:10:00',2.99),('8784','2014-03-24','11:15:00',3.44),('8784','2014-03-24','11:20:00',2.83),('8784','2014-03-24','11:25:00',3.22),('8784','2014-03-24','11:30:00',3.82),('8784','2014-03-24','11:35:00',1.63),('8784','2014-03-24','12:30:00',1.27),('8784','2014-03-24','12:35:00',2.14),('8784','2014-03-24','12:40:00',2.18),('8784','2014-03-24','12:45:00',1.9),('8784','2014-03-24','12:50:00',1.61),('8784','2014-03-24','12:55:00',1.55),('8784','2014-03-24','13:00:00',1.57),('8784','2014-03-24','13:05:00',1.55),('8784','2014-03-24','13:10:00',1.34),('8784','2014-03-24','13:15:00',1.13),('8784','2014-03-24','13:20:00',1.15),('8784','2014-03-24','13:25:00',1.34),('8784','2014-03-24','13:30:00',1.51),('8784','2014-03-24','13:35:00',1.27),('8784','2014-03-24','13:45:00',1.23),('8784','2014-03-24','13:50:00',1.48),('8784','2014-03-24','13:55:00',1.45),('8784','2014-03-24','14:00:00',1.27),('8784','2014-03-24','14:05:00',1.17),('8784','2014-03-24','14:10:00',1.39),('8784','2014-03-24','14:15:00',1.77),('8784','2014-03-24','14:20:00',2.28),('8784','2014-03-24','14:25:00',2.22),('8784','2014-03-24','14:30:00',2.06),('8784','2014-03-24','14:35:00',2.48),('8784','2014-03-24','14:40:00',3.08),('8784','2014-03-24','14:45:00',3.45),('8784','2014-03-24','14:50:00',3.32),('8784','2014-03-24','14:55:00',3.02),('8784','2014-03-24','15:00:00',2.64),('8784','2014-03-24','15:05:00',2.36),('8784','2014-03-24','15:10:00',2.14),('8784','2014-03-24','15:15:00',1.56),('8784','2014-03-24','15:20:00',1.73),('8784','2014-03-24','15:25:00',1.61),('8784','2014-03-24','15:30:00',1.7),('8784','2014-03-24','15:35:00',1.56),('8784','2014-03-24','15:40:00',1.31),('8784','2014-03-24','15:45:00',1.16),('8784','2014-03-24','15:50:00',1.32),('8784','2014-03-24','15:55:00',1.49),('8784','2014-03-24','16:00:00',2.45),('8784','2014-03-24','16:05:00',1.39),('8784','2014-03-24','16:10:00',1.14),('8784','2013-03-02','10:40:00',1.07),('8784','2013-03-02','10:45:00',1.07),('8784','2013-03-02','10:50:00',1.18),('8784','2013-03-02','10:55:00',1.23),('8784','2013-03-02','11:00:00',1.31),('8784','2013-03-02','11:05:00',1.37),('8784','2013-03-02','11:10:00',1.45),('8784','2013-03-02','11:15:00',1.65),('8784','2013-03-02','11:20:00',1.46),('8784','2013-03-02','11:25:00',1.29),('8784','2013-03-02','11:30:00',1.19),('8784','2013-03-02','11:35:00',1.22),('8784','2013-03-02','11:40:00',1.39),('8784','2013-03-02','11:45:00',1.25),('8784','2013-03-02','11:50:00',1.29),('8784','2013-03-02','11:55:00',1.2),('8784','2013-03-02','12:00:00',1.18),('8784','2013-03-02','12:05:00',1.35),('8784','2013-03-02','12:10:00',1.33),('8784','2013-03-02','12:15:00',1.39),('8784','2013-03-02','12:20:00',1.3),('8784','2013-03-02','12:25:00',1.35),('8784','2013-03-02','12:30:00',1.48),('8784','2013-03-02','12:35:00',1.58),('8784','2013-03-02','12:40:00',1.8),('8784','2013-03-02','12:45:00',1.74),('8784','2013-03-02','12:50:00',1.54),('8784','2013-03-02','12:55:00',1.82),('8784','2013-03-02','13:00:00',1.62),('8784','2013-03-02','13:05:00',1.43),('8784','2013-03-02','13:10:00',1.13),('8784','2013-03-02','13:15:00',1.01),('8784','2013-03-02','13:30:00',1.07),('8784','2013-03-02','13:35:00',1.1),('8784','2013-03-02','13:40:00',1.17),('8784','2013-03-02','13:45:00',1.26),('8784','2013-03-02','13:50:00',1.23),('8784','2013-03-02','13:55:00',1.28),('8784','2013-03-02','14:00:00',1.42),('8784','2013-03-02','14:05:00',1.38),('8784','2013-03-02','14:10:00',1.2),('8784','2013-03-02','14:15:00',1.08),('8784','2013-03-02','14:20:00',1.04),('8784','2013-03-01','08:05:00',1.01),('8784','2013-03-01','08:10:00',1),('8784','2013-03-01','08:15:00',1.08),('8784','2013-03-01','08:20:00',1.14),('8784','2013-03-01','08:25:00',1.15),('8784','2013-03-01','08:30:00',1.25),('8784','2013-03-01','08:35:00',1.33),('8784','2013-03-01','08:40:00',1.43),('8784','2013-03-01','08:45:00',1.5),('8784','2013-03-01','08:50:00',1.59),('8784','2013-03-01','08:55:00',1.7),('8784','2013-03-01','09:00:00',1.81),('8784','2013-03-01','09:05:00',1.95),('8784','2013-03-01','09:10:00',1.93),('8784','2013-03-01','09:15:00',1.97),('8784','2013-03-01','09:20:00',2.01),('8784','2013-03-01','09:25:00',2),('8784','2013-03-01','09:30:00',2.19),('8784','2013-03-01','09:35:00',2.14),('8784','2013-03-01','09:40:00',2.31),('8784','2013-03-01','09:45:00',2.42),('8784','2013-03-01','09:50:00',2.41),('8784','2013-03-01','09:55:00',2.4),('8784','2013-03-01','10:00:00',2.47),('8784','2013-03-01','10:05:00',2.46),('8784','2013-03-01','10:10:00',2.4),('8784','2013-03-01','10:15:00',2.09),('8784','2013-03-01','10:20:00',2.1),('8784','2013-03-01','10:25:00',2.24),('8784','2013-03-01','10:30:00',2.57),('8784','2013-03-01','10:35:00',2.66),('8784','2013-03-01','10:40:00',2.37),('8784','2013-03-01','10:45:00',2.29),('8784','2013-03-01','10:50:00',2.19),('8784','2013-03-01','10:55:00',2.07),('8784','2013-03-01','11:00:00',1.81),('8784','2013-03-01','11:05:00',1.65),('8784','2013-03-01','11:10:00',1.61),('8784','2013-03-01','11:15:00',1.81),('8784','2013-03-01','11:20:00',1.87),('8784','2013-03-01','11:25:00',1.87),('8784','2013-03-01','11:30:00',1.92),('8784','2013-03-01','11:35:00',1.92),('8784','2013-03-01','11:40:00',1.79),('8784','2013-03-01','11:45:00',1.76),('8784','2013-03-01','11:50:00',1.73),('8784','2013-03-01','11:55:00',1.67),('8784','2013-03-01','12:00:00',1.6),('8784','2013-03-01','12:05:00',1.52),('8784','2013-03-01','12:10:00',1.41),('8784','2013-03-01','12:15:00',1.3),('8784','2013-03-01','12:20:00',1.23),('8784','2013-03-01','12:25:00',1.22),('8784','2013-03-01','12:30:00',1.26),('8784','2013-03-01','12:35:00',1.25),('8784','2013-03-01','12:40:00',1.21),('8784','2013-03-01','12:45:00',1.21),('8784','2013-03-01','12:50:00',1.24),('8784','2013-03-01','12:55:00',1.32),('8784','2013-03-01','13:00:00',1.38),('8784','2013-03-01','13:05:00',1.4),('8784','2013-03-01','13:10:00',1.45),('8784','2013-03-01','13:15:00',1.54),('8784','2013-03-01','13:20:00',1.67),('8784','2013-03-01','13:25:00',1.81),('8784','2013-03-01','13:30:00',1.75),('8784','2013-03-01','13:35:00',1.63),('8784','2013-03-01','13:40:00',1.56),('8784','2013-03-01','13:45:00',1.55),('8784','2013-03-01','13:50:00',1.53),('8784','2013-03-01','13:55:00',1.47),('8784','2013-03-01','14:00:00',1.43),('8784','2013-03-01','14:05:00',1.37),('8784','2013-03-01','14:10:00',1.29),('8784','2013-03-01','14:15:00',1.22),('8784','2013-03-01','14:20:00',1.18),('8784','2013-03-01','14:25:00',1.18),('8784','2013-03-01','14:30:00',1.21),('8784','2013-03-01','14:35:00',1.2),('8784','2013-03-01','14:40:00',1.15),('8784','2013-03-01','14:45:00',1.07),('8784','2013-03-01','14:50:00',1.02),('8784','2013-03-01','14:55:00',1.02),('8784','2013-03-01','15:00:00',1.02),('8784','2013-02-28','08:10:00',1.04),('8784','2013-02-28','08:15:00',1.12),('8784','2013-02-28','08:20:00',1.21),('8784','2013-02-28','08:25:00',1.27),('8784','2013-02-28','08:30:00',1.36),('8784','2013-02-28','08:35:00',1.45),('8784','2013-02-28','08:40:00',1.53),('8784','2013-02-28','08:45:00',1.61),('8784','2013-02-28','08:50:00',1.72),('8784','2013-02-28','08:55:00',1.78),('8784','2013-02-28','09:00:00',1.89),('8784','2013-02-28','09:05:00',1.96),('8784','2013-02-28','09:10:00',1.99),('8784','2013-02-28','09:15:00',2.07),('8784','2013-02-28','09:20:00',2.17),('8784','2013-02-28','09:25:00',2.19),('8784','2013-02-28','09:30:00',2.29),('8784','2013-02-28','09:35:00',2.37),('8784','2013-02-28','09:40:00',2.43),('8784','2013-02-28','09:45:00',2.53),('8784','2013-02-28','09:50:00',2.39),('8784','2013-02-28','09:55:00',2.59),('8784','2013-02-28','10:00:00',2.68),('8784','2013-02-28','10:05:00',2.74),('8784','2013-02-28','10:10:00',2.78),('8784','2013-02-28','10:15:00',2.8),('8784','2013-02-28','10:20:00',2.87),('8784','2013-02-28','10:25:00',2.94),('8784','2013-02-28','10:30:00',2.89),('8784','2013-02-28','10:35:00',2.94),('8784','2013-02-28','10:40:00',3),('8784','2013-02-28','10:45:00',3.06),('8784','2013-02-28','10:50:00',3.12),('8784','2013-02-28','10:55:00',3.1),('8784','2013-02-28','11:00:00',3.2),('8784','2013-02-28','11:05:00',3.26),('8784','2013-02-28','11:10:00',3.26),('8784','2013-02-28','11:15:00',3.29),('8784','2013-02-28','11:20:00',3.31),('8784','2013-02-28','11:25:00',3.4),('8784','2013-02-28','11:30:00',3.39),('8784','2013-02-28','11:35:00',3.34),('8784','2013-02-28','11:40:00',3.35),('8784','2013-02-28','11:45:00',3.23),('8784','2013-02-28','11:50:00',3.25),('8784','2013-02-28','11:55:00',3.29),('8784','2013-02-28','12:00:00',3.31),('8784','2013-02-28','12:05:00',3.3),('8784','2013-02-28','12:10:00',3.31),('8784','2013-02-28','12:15:00',3.38),('8784','2013-02-28','12:20:00',3.47),('8784','2013-02-28','12:25:00',3.45),('8784','2013-02-28','12:30:00',3.48),('8784','2013-02-28','12:35:00',3.49),('8784','2013-02-28','12:40:00',3.4),('8784','2013-02-28','12:45:00',3.33),('8784','2013-02-28','12:50:00',3.34),('8784','2013-02-28','12:55:00',3.3),('8784','2013-02-28','13:00:00',3.17),('8784','2013-02-28','13:05:00',3.37),('8784','2013-02-28','13:10:00',3.26),('8784','2013-02-28','13:15:00',3.22),('8784','2013-02-28','13:20:00',2.3),('8784','2013-02-28','13:25:00',2.82),('8784','2013-02-28','13:30:00',2.8),('8784','2013-02-28','13:35:00',3.24),('8784','2013-02-28','13:40:00',3.26),('8784','2013-02-28','13:45:00',3.25),('8784','2013-02-28','13:50:00',3.21),('8784','2013-02-28','13:55:00',3.2),('8784','2013-02-28','14:00:00',3.27),('8784','2013-02-28','14:05:00',3.28),('8784','2013-02-28','14:10:00',3.14),('8784','2013-02-28','14:15:00',2.99),('8784','2013-02-28','14:20:00',2.87),('8784','2013-02-28','14:25:00',2.71),('8784','2013-02-28','14:30:00',2.58),('8784','2013-02-28','14:35:00',2.43),('8784','2013-02-28','14:40:00',2.5),('8784','2013-02-28','14:45:00',2.44),('8784','2013-02-28','14:50:00',2.39),('8784','2013-02-28','14:55:00',2.3),('8784','2013-02-28','15:00:00',2.23),('8784','2013-02-28','15:05:00',2.15),('8784','2013-02-28','15:10:00',2.06),('8784','2013-02-28','15:15:00',1.98),('8784','2013-02-28','15:20:00',1.99),('8784','2013-02-28','15:25:00',1.84),('8784','2013-02-28','15:30:00',1.72),('8784','2013-02-28','15:35:00',1.67),('8784','2013-02-28','15:40:00',1.6),('8784','2013-02-28','15:45:00',1.56),('8784','2013-02-28','15:50:00',1.48),('8784','2013-02-28','15:55:00',1.4),('8784','2013-02-28','16:00:00',1.33),('8784','2013-02-28','16:05:00',1.24),('8784','2013-02-28','16:10:00',1.15),('8784','2013-02-28','16:15:00',1.09),('8784','2013-02-28','16:20:00',1.02),('8784','2013-02-27','08:15:00',1.07),('8784','2013-02-27','08:20:00',1.15),('8784','2013-02-27','08:25:00',1.23),('8784','2013-02-27','08:30:00',1.32),('8784','2013-02-27','08:35:00',1.41),('8784','2013-02-27','08:40:00',1.48),('8784','2013-02-27','08:45:00',1.56),('8784','2013-02-27','08:50:00',1.63),('8784','2013-02-27','08:55:00',1.7),('8784','2013-02-27','09:00:00',1.78),('8784','2013-02-27','09:05:00',1.87),('8784','2013-02-27','09:10:00',1.95),('8784','2013-02-27','09:15:00',2.02),('8784','2013-02-27','09:20:00',2.1),('8784','2013-02-27','09:25:00',2.18),('8784','2013-02-27','09:30:00',2.25),('8784','2013-02-27','09:35:00',2.31),('8784','2013-02-27','09:40:00',2.36),('8784','2013-02-27','09:45:00',2.43),('8784','2013-02-27','09:50:00',2.5),('8784','2013-02-27','09:55:00',2.57),('8784','2013-02-27','10:00:00',2.63),('8784','2013-02-27','10:05:00',2.69),('8784','2013-02-27','10:10:00',2.74),('8784','2013-02-27','10:15:00',2.79),('8784','2013-02-27','10:20:00',2.85),('8784','2013-02-27','10:25:00',2.91),('8784','2013-02-27','10:30:00',2.91),('8784','2013-02-27','10:35:00',2.99),('8784','2013-02-27','10:40:00',2.97),('8784','2013-02-27','10:46:00',3.05),('8784','2013-02-27','10:50:00',3.09),('8784','2013-02-27','10:58:00',3.11),('8784','2013-02-27','11:00:00',3.19),('8784','2013-02-27','11:05:00',3.2),('8784','2013-02-27','11:10:00',3.25),('8784','2013-02-27','11:15:00',3.14),('8784','2013-02-27','11:20:00',3.21),('8784','2013-02-27','11:25:00',2.86),('8784','2013-02-27','11:30:00',1.3),('8784','2013-02-27','11:35:00',1.87),('8784','2013-02-27','11:40:00',1.17),('8784','2013-02-27','11:45:00',1.2),('8784','2013-02-27','11:50:00',2.02),('8784','2013-02-27','11:55:00',2.6),('8784','2013-02-27','12:00:00',3.6),('8784','2013-02-27','12:05:00',3.11),('8784','2013-02-27','12:15:00',3),('8784','2013-02-27','12:20:00',3.74),('8784','2013-02-27','12:25:00',3.24),('8784','2013-02-27','12:30:00',3.54),('8784','2013-02-27','12:35:00',3.55),('8784','2013-02-27','12:40:00',3.55),('8784','2013-02-27','12:45:00',3.52),('8784','2013-02-27','12:50:00',3.43),('8784','2013-02-27','12:55:00',3.43),('8784','2013-02-27','13:00:00',3.44),('8784','2013-02-27','13:05:00',3.43),('8784','2013-02-27','13:10:00',3.31),('8784','2013-02-27','13:15:00',3.36),('8784','2013-02-27','13:20:00',3.43),('8784','2013-02-27','13:25:00',3.45),('8784','2013-02-27','13:30:00',3.43),('8784','2013-02-27','13:35:00',3.32),('8784','2013-02-27','13:40:00',3.33),('8784','2013-02-27','13:45:00',3.26),('8784','2013-02-27','13:50:00',3.2),('8784','2013-02-27','13:55:00',3.2),('8784','2013-02-27','14:00:00',3.01),('8784','2013-02-27','14:05:00',2.6),('8784','2013-02-27','14:10:00',2.07),('8784','2013-02-27','14:15:00',2.72),('8784','2013-02-27','14:20:00',2.68),('8784','2013-02-27','14:25:00',1.52),('8784','2013-02-27','14:30:00',2.07),('8784','2013-02-27','14:35:00',2.68),('8784','2013-02-27','14:40:00',2.6),('8784','2013-02-27','14:45:00',2.56),('8784','2013-02-27','14:50:00',1.78),('8784','2013-02-27','14:55:00',2.24),('8784','2013-02-27','15:00:00',2.28),('8784','2013-02-27','15:05:00',2.3),('8784','2013-02-27','15:10:00',2.09),('8784','2013-02-27','15:15:00',2.01),('8784','2013-02-27','15:20:00',1.94),('8784','2013-02-27','15:25:00',1.91),('8784','2013-02-27','15:30:00',1.85),('8784','2013-02-27','15:35:00',1.78),('8784','2013-02-27','15:40:00',1.72),('8784','2013-02-27','15:45:00',1.65),('8784','2013-02-27','15:50:00',1.56),('8784','2013-02-27','15:55:00',1.5),('8784','2013-02-27','16:00:00',1.4),('8784','2013-02-27','16:05:00',1.32),('8784','2013-02-27','16:10:00',1.24),('8784','2013-02-27','16:15:00',1.16),('8784','2013-02-27','16:20:00',1.09),('8784','2013-02-26','09:15:00',1.02),('8784','2013-02-26','09:20:00',1.08),('8784','2013-02-26','09:25:00',1.16),('8784','2013-02-26','09:30:00',1.35),('8784','2013-02-26','09:35:00',1.68),('8784','2013-02-26','09:40:00',1.85),('8784','2013-02-26','09:45:00',1.85),('8784','2013-02-26','09:50:00',1.89),('8784','2013-02-26','09:55:00',2.08),('8784','2013-02-26','10:00:00',1.99),('8784','2013-02-26','10:05:00',1.94),('8784','2013-02-26','10:10:00',2.26),('8784','2013-02-26','10:15:00',2.47),('8784','2013-02-26','10:20:00',3),('8784','2013-02-26','10:25:00',2.89),('8784','2013-02-26','10:30:00',2.9),('8784','2013-02-26','10:35:00',2.78),('8784','2013-02-26','10:40:00',2.13),('8784','2013-02-26','10:45:00',1.56),('8784','2013-02-26','10:50:00',1.79),('8784','2013-02-26','10:55:00',1.83),('8784','2013-02-26','11:00:00',2.23),('8784','2013-02-26','11:05:00',2.3),('8784','2013-02-26','11:10:00',2.38),('8784','2013-02-26','11:15:00',1.86),('8784','2013-02-26','11:20:00',1.9),('8784','2013-02-26','11:25:00',1.78),('8784','2013-02-26','11:30:00',1.64),('8784','2013-02-26','11:35:00',1.54),('8784','2013-02-26','11:40:00',1.57),('8784','2013-02-26','11:45:00',1.61),('8784','2013-02-26','11:50:00',1.74),('8784','2013-02-26','11:55:00',1.92),('8784','2013-02-26','12:00:00',1.67),('8784','2013-02-26','12:05:00',1.65),('8784','2013-02-26','12:10:00',1.72),('8784','2013-02-26','12:15:00',1.57),('8784','2013-02-26','12:20:00',1.59),('8784','2013-02-26','12:25:00',1.47),('8784','2013-02-26','12:30:00',1.46),('8784','2013-02-26','12:35:00',1.35),('8784','2013-02-26','12:40:00',1.25),('8784','2013-02-26','12:45:00',1.13),('8784','2013-02-26','12:50:00',1.05),('8784','2013-02-26','12:55:00',1.12),('8784','2013-02-26','13:00:00',1.16),('8784','2013-02-26','13:05:00',1.04),('8784','2013-02-26','13:15:00',1.01),('8784','2013-02-26','13:20:00',1.05),('8784','2013-02-26','13:25:00',1.08),('8784','2013-02-26','13:30:00',1.1),('8784','2013-02-26','13:35:00',1.11),('8784','2013-02-26','13:40:00',1.11),('8784','2013-02-26','13:45:00',1.04),('8784','2013-02-25','08:40:00',1.14),('8784','2013-02-25','08:45:00',1.1),('8784','2013-02-25','08:50:00',1.03),('8784','2013-02-25','09:00:00',1.24),('8784','2013-02-25','09:20:00',1.12),('8784','2013-02-25','09:25:00',1.48),('8784','2013-02-25','09:30:00',1.63),('8784','2013-02-25','09:35:00',1.59),('8784','2013-02-25','09:40:00',1.17),('8784','2013-02-25','10:45:00',1.86),('8784','2013-02-25','10:50:00',3.33),('8784','2013-02-25','10:55:00',4.46),('8784','2013-02-25','11:00:00',3.85),('8784','2013-02-25','11:05:00',2.09),('8784','2013-02-25','11:10:00',2.27),('8784','2013-02-25','11:15:00',2.27),('8784','2013-02-25','11:20:00',1.19),('8784','2013-02-25','11:25:00',1.2),('8784','2013-02-25','11:30:00',1.36),('8784','2013-02-25','11:35:00',1.39),('8784','2013-02-25','11:40:00',1.65),('8784','2013-02-25','11:45:00',1.85),('8784','2013-02-25','11:50:00',2.76),('8784','2013-02-25','11:55:00',4.69),('8784','2013-02-25','12:00:00',3.01),('8784','2013-02-25','12:05:00',2.44),('8784','2013-02-25','12:10:00',2.06),('8784','2013-02-25','12:15:00',2.06),('8784','2013-02-25','12:20:00',3.86),('8784','2013-02-25','12:25:00',4.17),('8784','2013-02-25','12:30:00',3.15),('8784','2013-02-25','12:35:00',2.93),('8784','2013-02-25','12:40:00',3.76),('8784','2013-02-25','12:45:00',3.28),('8784','2013-02-25','12:50:00',3.63),('8784','2013-02-25','12:55:00',3.58),('8784','2013-02-25','13:00:00',2.18),('8784','2013-02-25','13:05:00',2.88),('8784','2013-02-25','13:10:00',1.55),('8784','2013-02-25','13:15:00',2.36),('8784','2013-02-25','13:20:00',1.89),('8784','2013-02-25','13:25:00',1.7),('8784','2013-02-25','13:30:00',1.73),('8784','2013-02-25','13:35:00',1.6),('8784','2013-02-25','13:40:00',1.26),('8784','2013-02-25','13:45:00',1.08),('8784','2013-02-24','10:45:00',1.06),('8784','2013-02-24','10:50:00',1.54),('8784','2013-02-24','10:55:00',1.42),('8784','2013-02-24','11:00:00',1.11),('8784','2013-02-24','11:05:00',1.05),('8784','2013-02-24','11:25:00',1.01),('8784','2013-02-24','11:30:00',1.06),('8784','2013-02-24','11:45:00',1.01),('8784','2013-02-24','11:50:00',1),('8784','2013-02-24','12:35:00',1.07),('8784','2013-02-24','12:40:00',1.22),('8784','2013-02-24','12:45:00',1.33),('8784','2013-02-24','12:50:00',1.09),('8784','2013-02-24','12:55:00',1.03),('8784','2013-02-24','13:00:00',1.28),('8784','2013-02-24','13:05:00',1.58),('8784','2013-02-24','13:10:00',1.59),('8784','2013-02-24','13:15:00',1.49),('8784','2013-02-24','13:20:00',1.61),('8784','2013-02-24','13:25:00',1.02),('8784','2013-02-24','13:30:00',1.17),('8784','2013-02-24','13:35:00',1.43),('8784','2013-02-24','13:40:00',1.28),('8784','2013-02-24','13:45:00',1.37),('8784','2013-02-24','13:50:00',1.13),('8784','2013-02-24','13:55:00',1.08),('8784','2013-02-24','14:00:00',1.15),('8784','2013-02-24','14:05:00',1.81),('8784','2013-02-24','14:10:00',1.56),('8784','2013-02-24','14:15:00',1.15),('8784','2013-02-24','14:20:00',1.03),('8784','2013-02-24','14:25:00',1),('8784','2013-02-24','14:30:00',1.25),('8784','2013-02-24','14:35:00',1.28),('8784','2013-02-24','15:10:00',2.44),('8784','2013-02-24','15:20:00',1.42),('8784','2013-02-24','15:25:00',1.57),('8784','2013-02-24','15:30:00',1.62),('8784','2013-02-24','15:35:00',1.34),('8784','2013-02-24','15:40:00',1.12),('8784','2013-02-24','15:45:00',1.48),('8784','2013-02-24','15:55:00',1.53),('8784','2013-02-24','16:00:00',1.66),('8784','2013-02-23','08:05:00',1.06),('8784','2013-02-23','08:10:00',1.3),('8784','2013-02-23','08:15:00',1.62),('8784','2013-02-23','08:20:00',1.01),('8784','2013-02-23','08:55:00',1.11),('8784','2013-02-23','09:00:00',1.41),('8784','2013-02-23','09:05:00',1.36),('8784','2013-02-23','09:10:00',1.06),('8784','2013-02-23','09:40:00',1.08),('8784','2013-02-23','09:45:00',1.43),('8784','2013-02-23','09:50:00',1.48),('8784','2013-02-23','09:55:00',1.46),('8784','2013-02-23','10:00:00',1.16),('8784','2013-02-23','10:05:00',1.1),('8784','2013-02-23','10:25:00',1.17),('8784','2013-02-23','10:30:00',1.1),('8784','2013-02-23','10:35:00',1.03),('8784','2013-02-23','10:50:00',1.05),('8784','2013-02-23','13:55:00',1.03),('8784','2013-02-23','14:00:00',1.1),('8784','2013-02-23','14:05:00',1.89),('8784','2013-02-23','14:10:00',1.39),('8784','2013-02-22','12:55:00',1.05),('8784','2013-02-22','14:15:00',1.02),('8784','2013-02-22','14:20:00',1.01),('8784','2013-02-22','14:35:00',1.42),('8784','2013-02-22','14:40:00',1.45),('8784','2013-02-22','14:45:00',1.08),('8784','2013-02-22','14:50:00',1.01),('8784','2013-02-22','14:55:00',1.29),('8784','2013-02-22','16:20:00',1.2),('8784','2013-02-22','16:25:00',1.35),('8784','2013-02-22','16:30:00',1.03),('8784','2013-02-21','11:30:00',1.05),('8784','2013-02-21','11:35:00',1.1),('8784','2013-02-21','11:40:00',1.08),('8784','2013-02-21','11:45:00',1.14),('8784','2013-02-21','11:50:00',1.27),('8784','2013-02-21','11:55:00',1.28),('8784','2013-02-21','12:00:00',1.26),('8784','2013-02-21','12:05:00',1.27),('8784','2013-02-21','12:10:00',1.31),('8784','2013-02-21','12:15:00',1.4),('8784','2013-02-21','12:20:00',1.49),('8784','2013-02-21','12:25:00',1.44),('8784','2013-02-21','12:30:00',1.35),('8784','2013-02-21','12:35:00',1.29),('8784','2013-02-21','12:40:00',1.26),('8784','2013-02-21','12:45:00',1.27),('8784','2013-02-21','12:50:00',1.29),('8784','2013-02-21','12:55:00',1.38),('8784','2013-02-21','13:00:00',1.38),('8784','2013-02-21','13:05:00',1.28),('8784','2013-02-21','13:10:00',1.23),('8784','2013-02-21','13:15:00',1.26),('8784','2013-02-21','13:20:00',1.34),('8784','2013-02-21','13:25:00',1.37),('8784','2013-02-21','13:30:00',1.38),('8784','2013-02-21','13:35:00',1.37),('8784','2013-02-21','13:40:00',1.32),('8784','2013-02-21','13:45:00',1.23),('8784','2013-02-21','13:50:00',1.27),('8784','2013-02-21','13:55:00',1.27),('8784','2013-02-21','14:00:00',1.28),('8784','2013-02-21','14:05:00',1.22),('8784','2013-02-21','14:10:00',1.13),('8784','2013-02-21','16:05:00',1),('8784','2013-02-21','16:20:00',1.27),('8784','2013-02-21','16:25:00',1.34),('8784','2013-02-21','16:30:00',1.21),('8784','2013-02-21','16:35:00',1.03),('8784','2014-03-23','08:30:00',1.03),('8784','2014-03-23','08:35:00',1.09),('8784','2014-03-23','08:50:00',1.23),('8784','2014-03-23','08:55:00',1.56),('8784','2014-03-23','09:00:00',1.01),('8784','2014-03-23','09:05:00',1.78),('8784','2014-03-23','09:10:00',2.59),('8784','2014-03-23','09:15:00',2.54),('8784','2014-03-23','09:20:00',1.81),('8784','2014-03-23','09:25:00',1.13),('8784','2014-03-23','09:30:00',1.51),('8784','2014-03-23','09:35:00',1.55),('8784','2014-03-23','09:40:00',1.37),('8784','2014-03-23','10:25:00',1.26),('8784','2014-03-23','10:40:00',1.3),('8784','2014-03-23','10:45:00',1.2),('8784','2014-03-23','10:50:00',1.33),('8784','2014-03-23','10:55:00',1.79),('8784','2014-03-23','11:00:00',1.31),('8784','2014-03-23','11:05:00',1.1),('8784','2014-03-23','11:10:00',1.4),('8784','2014-03-23','11:25:00',1.11),('8784','2014-03-23','11:35:00',1.73),('8784','2014-03-23','11:40:00',3.69),('8784','2014-03-23','11:45:00',1.01),('8784','2014-03-23','13:40:00',1.1),('8784','2014-03-23','13:45:00',2.45),('8784','2014-03-23','13:50:00',1.71),('8784','2014-03-23','13:55:00',1.4),('8784','2014-03-23','14:00:00',1.01),('8784','2014-03-23','15:05:00',1.08),('8784','2014-03-23','15:10:00',1.38),('8784','2014-03-23','15:15:00',1.66),('8784','2014-03-23','15:20:00',1.69),('8784','2014-03-23','15:25:00',1.81),('8784','2014-03-23','15:30:00',1.23),('8784','2014-03-23','15:40:00',1.08),('8784','2013-02-20','08:20:00',1.06),('8784','2013-02-20','08:25:00',1.14),('8784','2013-02-20','08:30:00',1.21),('8784','2013-02-20','08:35:00',1.28),('8784','2013-02-20','08:40:00',1.37),('8784','2013-02-20','08:45:00',1.46),('8784','2013-02-20','08:50:00',1.54),('8784','2013-02-20','08:55:00',1.51),('8784','2013-02-20','09:00:00',1.72),('8784','2013-02-20','09:05:00',1.05),('8784','2013-02-20','09:10:00',1.47),('8784','2013-02-20','09:15:00',1.54),('8784','2013-02-20','09:20:00',1.45),('8784','2013-02-20','09:25:00',2.15),('8784','2013-02-20','09:30:00',1.35),('8784','2013-02-20','09:35:00',1.89),('8784','2013-02-20','09:40:00',1.06),('8784','2013-02-20','09:45:00',1.31),('8784','2013-02-20','09:50:00',1.94),('8784','2013-02-20','09:55:00',1.89),('8784','2013-02-20','10:05:00',2.37),('8784','2013-02-20','10:10:00',1.67),('8784','2013-02-20','10:15:00',1.04),('8784','2013-02-20','10:45:00',2.45),('8784','2013-02-20','10:50:00',2.73),('8784','2013-02-20','10:55:00',1.25),('8784','2013-02-20','11:05:00',2.47),('8784','2013-02-20','11:10:00',3.89),('8784','2013-02-20','11:15:00',3.01),('8784','2013-02-20','11:20:00',2.96),('8784','2013-02-20','11:25:00',2.05),('8784','2013-02-20','11:30:00',1.34),('8784','2013-02-20','11:35:00',3.78),('8784','2013-02-20','11:40:00',3.9),('8784','2013-02-20','11:45:00',4.14),('8784','2013-02-20','11:50:00',3.16),('8784','2013-02-20','11:55:00',3.45),('8784','2013-02-20','12:00:00',1.71),('8784','2013-02-20','12:05:00',1.09),('8784','2013-02-20','12:10:00',2.47),('8784','2013-02-20','12:15:00',3.76),('8784','2013-02-20','12:20:00',1.85),('8784','2013-02-20','12:25:00',3.81),('8784','2013-02-20','12:30:00',4.15),('8784','2013-02-20','12:35:00',2.12),('8784','2013-02-20','12:45:00',1.13),('8784','2013-02-20','12:50:00',1.23),('8784','2013-02-20','12:55:00',2.17),('8784','2013-02-20','13:00:00',3.54),('8784','2013-02-20','13:05:00',2.6),('8784','2013-02-20','13:10:00',3.76),('8784','2013-02-20','13:15:00',3.85),('8784','2013-02-20','13:20:00',1.79),('8784','2013-02-20','13:25:00',1.65),('8784','2013-02-20','13:30:00',1.91),('8784','2013-02-20','13:35:00',1.48),('8784','2013-02-20','13:40:00',1.8),('8784','2013-02-20','13:45:00',1.4),('8784','2013-02-20','13:50:00',1.25),('8784','2013-02-20','13:55:00',1.68),('8784','2013-02-20','14:00:00',1.42),('8784','2013-02-20','14:40:00',1.35),('8784','2013-02-20','14:45:00',1.13),('8784','2013-02-20','15:05:00',1.43),('8784','2013-02-20','15:10:00',2.17),('8784','2013-02-20','15:15:00',2.57),('8784','2013-02-20','15:20:00',2.28),('8784','2013-02-20','15:25:00',2.19),('8784','2013-02-20','15:30:00',1.7),('8784','2013-02-20','15:35:00',1.02),('8784','2013-02-20','16:05:00',1.66),('8784','2013-02-20','16:10:00',1.59),('8784','2013-02-20','16:15:00',1.46),('8784','2013-02-20','16:20:00',1.27),('8784','2013-02-20','16:25:00',1.05),('8784','2013-02-19','08:25:00',1.05),('8784','2013-02-19','08:30:00',1.15),('8784','2013-02-19','08:35:00',1.22),('8784','2013-02-19','08:40:00',1.2),('8784','2013-02-19','08:45:00',1.35),('8784','2013-02-19','08:50:00',1.45),('8784','2013-02-19','08:55:00',1.46),('8784','2013-02-19','09:00:00',1.6),('8784','2013-02-19','09:05:00',1.66),('8784','2013-02-19','09:10:00',1.76),('8784','2013-02-19','09:15:00',1.84),('8784','2013-02-19','09:20:00',1.95),('8784','2013-02-19','09:25:00',2.02),('8784','2013-02-19','09:30:00',2.09),('8784','2013-02-19','09:35:00',2.11),('8784','2013-02-19','09:40:00',2.21),('8784','2013-02-19','09:45:00',2.32),('8784','2013-02-19','09:50:00',2.39),('8784','2013-02-19','09:55:00',2.45),('8784','2013-02-19','10:00:00',2.52),('8784','2013-02-19','10:05:00',2.57),('8784','2013-02-19','10:10:00',2.62),('8784','2013-02-19','10:15:00',2.68),('8784','2013-02-19','10:20:00',2.74),('8784','2013-02-19','10:25:00',2.79),('8784','2013-02-19','10:30:00',2.83),('8784','2013-02-19','10:35:00',2.89),('8784','2013-02-19','10:40:00',2.91),('8784','2013-02-19','10:45:00',2.94),('8784','2013-02-19','10:50:00',2.99),('8784','2013-02-19','10:55:00',3.01),('8784','2013-02-19','11:00:00',3.07),('8784','2013-02-19','11:05:00',3.07),('8784','2013-02-19','11:10:00',3.14),('8784','2013-02-19','11:15:00',3.19),('8784','2013-02-19','11:20:00',3.19),('8784','2013-02-19','11:25:00',3.23),('8784','2013-02-19','11:30:00',3.24),('8784','2013-02-19','11:35:00',3.25),('8784','2013-02-19','11:40:00',3.23),('8784','2013-02-19','11:45:00',3.25),('8784','2013-02-19','11:50:00',3.27),('8784','2013-02-19','11:55:00',3.24),('8784','2013-02-19','12:00:00',3.26),('8784','2013-02-19','12:05:00',3.29),('8784','2013-02-19','12:10:00',3.25),('8784','2013-02-19','12:15:00',3.28),('8784','2013-02-19','12:20:00',3.27),('8784','2013-02-19','12:25:00',3.24),('8784','2013-02-19','12:30:00',3.23),('8784','2013-02-19','12:35:00',3.29),('8784','2013-02-19','12:40:00',3.26),('8784','2013-02-19','12:45:00',3.25),('8784','2013-02-19','12:50:00',3.26),('8784','2013-02-19','12:55:00',3.24),('8784','2013-02-19','13:00:00',3.21),('8784','2013-02-19','13:05:00',3.22),('8784','2013-02-19','13:10:00',3.19),('8784','2013-02-19','13:15:00',3.19),('8784','2013-02-19','13:20:00',3.18),('8784','2013-02-19','13:25:00',3.12),('8784','2013-02-19','13:30:00',3.06),('8784','2013-02-19','13:35:00',3.02),('8784','2013-02-19','13:40:00',2.98),('8784','2013-02-19','13:45:00',2.95),('8784','2013-02-19','13:50:00',2.9),('8784','2013-02-19','13:55:00',2.87),('8784','2013-02-19','14:00:00',2.77),('8784','2013-02-19','14:05:00',2.71),('8784','2013-02-19','14:10:00',2.67),('8784','2013-02-19','14:15:00',2.52),('8784','2013-02-19','14:20:00',2.02),('8784','2013-02-19','14:25:00',2.14),('8784','2013-02-19','14:30:00',2.39),('8784','2013-02-19','14:35:00',2.31),('8784','2013-02-19','14:40:00',2.25),('8784','2013-02-19','14:45:00',2.21),('8784','2013-02-19','14:50:00',2.06),('8784','2013-02-19','14:55:00',2.06),('8784','2013-02-19','15:00:00',2.06),('8784','2013-02-19','15:05:00',1.98),('8784','2013-02-19','15:10:00',1.92),('8784','2013-02-19','15:15:00',1.9),('8784','2013-02-19','15:20:00',1.81),('8784','2013-02-19','15:25:00',1.72),('8784','2013-02-19','15:30:00',1.63),('8784','2013-02-19','15:35:00',1.55),('8784','2013-02-19','15:40:00',1.52),('8784','2013-02-19','15:45:00',1.47),('8784','2013-02-19','15:50:00',1.38),('8784','2013-02-19','15:55:00',1.31),('8784','2013-02-19','16:00:00',1.22),('8784','2013-02-19','16:05:00',1.14),('8784','2013-02-19','16:10:00',1.07),('8784','2013-02-18','08:30:00',1.06),('8784','2013-02-18','08:35:00',1.14),('8784','2013-02-18','08:40:00',1.15),('8784','2013-02-18','08:45:00',1.24),('8784','2013-02-18','08:50:00',1.35),('8784','2013-02-18','08:55:00',1.38),('8784','2013-02-18','09:00:00',1.28),('8784','2013-02-18','09:05:00',1.27),('8784','2013-02-18','09:10:00',1.64),('8784','2013-02-18','09:15:00',1.75),('8784','2013-02-18','09:20:00',1.83),('8784','2013-02-18','09:25:00',2.18),('8784','2013-02-18','09:30:00',1.49),('8784','2013-02-18','09:35:00',1.26),('8784','2013-02-18','09:50:00',1.52),('8784','2013-02-18','09:55:00',1.18),('8784','2013-02-18','10:05:00',1.07),('8784','2013-02-18','10:55:00',1.04),('8784','2013-02-18','11:00:00',1.3),('8784','2013-02-18','11:05:00',1.3),('8784','2013-02-18','11:10:00',1.39),('8784','2013-02-18','11:15:00',1.25),('8784','2013-02-18','11:20:00',1.57),('8784','2013-02-18','11:25:00',1.59),('8784','2013-02-18','11:30:00',1.49),('8784','2013-02-18','11:35:00',1.56),('8784','2013-02-18','11:40:00',1.51),('8784','2013-02-18','11:45:00',1.39),('8784','2013-02-18','11:50:00',1.49),('8784','2013-02-18','11:55:00',1.91),('8784','2013-02-18','12:00:00',2.02),('8784','2013-02-18','12:05:00',1.72),('8784','2013-02-18','12:10:00',1.57),('8784','2013-02-18','12:15:00',1.54),('8784','2013-02-18','12:20:00',1.5),('8784','2013-02-18','12:25:00',1.56),('8784','2013-02-18','12:30:00',1.42),('8784','2013-02-18','12:35:00',1.35),('8784','2013-02-18','12:40:00',1.41),('8784','2013-02-18','12:45:00',1.67),('8784','2013-02-18','12:50:00',1.66),('8784','2013-02-18','12:55:00',1.53),('8784','2013-02-18','13:00:00',1.54),('8784','2013-02-18','13:05:00',1.56),('8784','2013-02-18','13:10:00',1.51),('8784','2013-02-18','13:15:00',1.88),('8784','2013-02-18','13:20:00',1.52),('8784','2013-02-18','13:25:00',1.74),('8784','2013-02-18','13:30:00',1.57),('8784','2013-02-18','13:35:00',1.38),('8784','2013-02-18','13:40:00',1.37),('8784','2013-02-18','13:45:00',1.27),('8784','2013-02-18','13:50:00',1.29),('8784','2013-02-18','13:55:00',1.54),('8784','2013-02-18','14:00:00',1.57),('8784','2013-02-18','14:05:00',1.42),('8784','2013-02-18','14:10:00',1.26),('8784','2013-02-18','14:15:00',1.11),('8784','2013-02-18','14:20:00',1.2),('8784','2013-02-17','08:30:00',1.08),('8784','2013-02-17','08:35:00',1.22),('8784','2013-02-17','08:40:00',1.26),('8784','2013-02-17','08:45:00',1.31),('8784','2013-02-17','08:50:00',1.12),('8784','2013-02-17','08:55:00',1.38),('8784','2013-02-17','09:10:00',1.16),('8784','2013-02-17','09:15:00',1.69),('8784','2013-02-17','09:20:00',1.75),('8784','2013-02-17','09:25:00',1.77),('8784','2013-02-17','09:30:00',1.89),('8784','2013-02-17','09:35:00',1.99),('8784','2013-02-17','09:40:00',2.08),('8784','2013-02-17','09:45:00',2.14),('8784','2013-02-17','09:50:00',2.2),('8784','2013-02-17','09:55:00',2.27),('8784','2013-02-17','10:00:00',2.33),('8784','2013-02-17','10:05:00',2.41),('8784','2013-02-17','10:10:00',2.5),('8784','2013-02-17','10:15:00',2.54),('8784','2013-02-17','10:20:00',2.56),('8784','2013-02-17','10:25:00',2.61),('8784','2013-02-17','10:30:00',2.7),('8784','2013-02-17','10:35:00',2.74),('8784','2013-02-17','10:40:00',2.78),('8784','2013-02-17','10:45:00',2.82),('8784','2013-02-17','10:50:00',2.85),('8784','2013-02-17','10:55:00',2.88),('8784','2013-02-17','11:00:00',2.91),('8784','2013-02-17','11:05:00',2.94),('8784','2013-02-17','11:10:00',2.96),('8784','2013-02-17','11:15:00',3.02),('8784','2013-02-17','11:20:00',3.06),('8784','2013-02-17','11:25:00',3.07),('8784','2013-02-17','11:30:00',3.07),('8784','2013-02-17','11:35:00',3.09),('8784','2013-02-17','11:40:00',3.1),('8784','2013-02-17','11:45:00',3.15),('8784','2013-02-17','11:50:00',3.18),('8784','2013-02-17','11:55:00',3.19),('8784','2013-02-17','12:00:00',3.19),('8784','2013-02-17','12:05:00',3.21),('8784','2013-02-17','12:10:00',3.19),('8784','2013-02-17','12:15:00',3.18),('8784','2013-02-17','12:20:00',3.16),('8784','2013-02-17','12:25:00',3.12),('8784','2013-02-17','12:30:00',3.13),('8784','2013-02-17','12:35:00',3.11),('8784','2013-02-17','12:40:00',3.05),('8784','2013-02-17','12:45:00',3.05),('8784','2013-02-17','12:50:00',3.03),('8784','2013-02-17','12:55:00',3.05),('8784','2013-02-17','13:00:00',3.03),('8784','2013-02-17','13:05:00',2.29),('8784','2013-02-17','13:10:00',2.52),('8784','2013-02-17','13:15:00',2.52),('8784','2013-02-17','13:25:00',1.5),('8784','2013-02-17','13:30:00',2.79),('8784','2013-02-17','13:35:00',1.5),('8784','2013-02-17','13:40:00',2.7),('8784','2013-02-17','13:45:00',2.5),('8784','2013-02-17','13:50:00',2.34),('8784','2013-02-17','13:55:00',1.88),('8784','2013-02-17','14:10:00',2.61),('8784','2013-02-17','14:15:00',1.64),('8784','2013-02-17','14:25:00',1.73),('8784','2013-02-17','14:30:00',2.42),('8784','2013-02-17','14:35:00',2.25),('8784','2013-02-17','14:40:00',1.15),('8784','2013-02-17','15:00:00',1.99),('8784','2013-02-17','15:05:00',2.09),('8784','2013-02-17','15:10:00',2.3),('8784','2013-02-17','15:15:00',2.2),('8784','2013-02-17','15:20:00',2.14),('8784','2013-02-17','15:25:00',1.96),('8784','2013-02-17','15:30:00',1.81),('8784','2013-02-17','15:35:00',1.81),('8784','2013-02-17','15:40:00',1.77),('8784','2013-02-17','15:45:00',1.62),('8784','2013-02-17','15:50:00',1.53),('8784','2013-02-17','15:55:00',1.45),('8784','2013-02-17','16:00:00',1.33),('8784','2013-02-17','16:05:00',1.23),('8784','2013-02-17','16:25:00',1.13),('8784','2013-02-17','16:30:00',1.11),('8784','2013-02-16','08:35:00',1.05),('8784','2013-02-16','08:40:00',1.07),('8784','2013-02-16','08:45:00',1.12),('8784','2013-02-16','09:15:00',1.52),('8784','2013-02-16','09:20:00',1.84),('8784','2013-02-16','09:25:00',1.87),('8784','2013-02-16','09:30:00',1.93),('8784','2013-02-16','09:35:00',2.02),('8784','2013-02-16','09:40:00',2.07),('8784','2013-02-16','09:45:00',2.17),('8784','2013-02-16','09:50:00',2.26),('8784','2013-02-16','09:55:00',2.29),('8784','2013-02-16','10:00:00',2.33),('8784','2013-02-16','10:05:00',2.4),('8784','2013-02-16','10:10:00',2.51),('8784','2013-02-16','10:15:00',2.55),('8784','2013-02-16','10:20:00',2.62),('8784','2013-02-16','10:25:00',2.67),('8784','2013-02-16','10:30:00',2.7),('8784','2013-02-16','10:35:00',2.71),('8784','2013-02-16','10:40:00',2.69),('8784','2013-02-16','10:45:00',2.98),('8784','2013-02-16','10:50:00',2.89),('8784','2013-02-16','10:55:00',2.78),('8784','2013-02-16','11:00:00',3.01),('8784','2013-02-16','11:05:00',2.98),('8784','2013-02-16','11:10:00',3.01),('8784','2013-02-16','11:15:00',3.04),('8784','2013-02-16','11:20:00',2.98),('8784','2013-02-16','11:25:00',3.02),('8784','2013-02-16','11:30:00',3.14),('8784','2013-02-16','11:35:00',3.16),('8784','2013-02-16','11:40:00',3.16),('8784','2013-02-16','11:45:00',3.19),('8784','2013-02-16','11:50:00',3.22),('8784','2013-02-16','11:55:00',3.23),('8784','2013-02-16','12:00:00',3.22),('8784','2013-02-16','12:05:00',3.23),('8784','2013-02-16','12:10:00',3.21),('8784','2013-02-16','12:15:00',3.21),('8784','2013-02-16','12:20:00',3.19),('8784','2013-02-16','12:25:00',3.19),('8784','2013-02-16','12:30:00',3.17),('8784','2013-02-16','12:35:00',3.18),('8784','2013-02-16','12:40:00',3.15),('8784','2013-02-16','12:45:00',3.18),('8784','2013-02-16','12:50:00',3.19),('8784','2013-02-16','12:55:00',3.11),('8784','2013-02-16','13:00:00',3.07),('8784','2013-02-16','13:05:00',3.08),('8784','2013-02-16','13:10:00',3.06),('8784','2013-02-16','13:20:00',2.98),('8784','2013-02-16','13:25:00',2.99),('8784','2013-02-16','13:30:00',2.94),('8784','2013-02-16','13:35:00',2.93),('8784','2013-02-16','13:40:00',2.86),('8784','2013-02-16','13:45:00',2.88),('8784','2013-02-16','13:50:00',2.84),('8784','2013-02-16','13:55:00',2.74),('8784','2013-02-16','14:00:00',2.67),('8784','2013-02-16','14:05:00',2.7),('8784','2013-02-16','14:10:00',2.63),('8784','2013-02-16','14:15:00',2.48),('8784','2013-02-16','14:20:00',2.22),('8784','2013-02-16','14:25:00',1.28),('8784','2013-02-16','14:45:00',1.02),('8784','2013-02-16','14:55:00',1.06),('8784','2013-02-16','15:20:00',1.09),('8784','2013-02-16','15:25:00',1.13),('8784','2013-02-16','15:30:00',1.94),('8784','2013-02-16','15:35:00',2.01),('8784','2013-02-16','15:40:00',1.9),('8784','2013-02-16','15:45:00',1.64),('8784','2013-02-16','15:50:00',1.81),('8784','2013-02-16','15:55:00',1.36),('8784','2013-02-16','16:05:00',1.33),('8784','2013-02-15','09:20:00',1.34),('8784','2013-02-15','09:25:00',1.45),('8784','2013-02-15','09:30:00',1.02),('8784','2013-02-15','09:50:00',1.12),('8784','2013-02-15','09:55:00',1.42),('8784','2013-02-15','10:00:00',1.77),('8784','2013-02-15','10:05:00',1.78),('8784','2013-02-15','10:10:00',1.23),('8784','2013-02-15','10:15:00',1.22),('8784','2013-02-15','10:20:00',1.66),('8784','2013-02-15','10:25:00',2.17),('8784','2013-02-15','10:30:00',1.94),('8784','2013-02-15','10:35:00',2.71),('8784','2013-02-15','10:40:00',2.55),('8784','2013-02-15','10:45:00',2.64),('8784','2013-02-15','10:50:00',2.29),('8784','2013-02-15','10:55:00',1.74),('8784','2013-02-15','11:00:00',1.79),('8784','2013-02-15','11:05:00',2),('8784','2013-02-15','11:10:00',1.91),('8784','2013-02-15','11:15:00',2.73),('8784','2013-02-15','11:20:00',2.98),('8784','2013-02-15','11:25:00',3.11),('8784','2013-02-15','11:30:00',3.05),('8784','2013-02-15','11:35:00',2.24),('8784','2013-02-15','11:40:00',1.8),('8784','2013-02-15','11:45:00',2.34),('8784','2013-02-15','11:50:00',3.64),('8784','2013-02-15','11:55:00',2.92),('8784','2013-02-15','12:00:00',2.82),('8784','2013-02-15','12:05:00',2.74),('8784','2013-02-15','12:10:00',2.86),('8784','2013-02-15','12:15:00',3.22),('8784','2013-02-15','12:20:00',3.57),('8784','2013-02-15','12:25:00',3.22),('8784','2013-02-15','12:30:00',3.28),('8784','2013-02-15','12:35:00',3.23),('8784','2013-02-15','12:40:00',3.17),('8784','2013-02-15','12:45:00',3.19),('8784','2013-02-15','12:50:00',3.17),('8784','2013-02-15','12:55:00',3.13),('8784','2013-02-15','13:00:00',3.06),('8784','2013-02-15','13:05:00',3.05),('8784','2013-02-15','13:10:00',3.11),('8784','2013-02-15','13:15:00',3.09),('8784','2013-02-15','13:20:00',2.87),('8784','2013-02-15','13:25:00',2.69),('8784','2013-02-15','13:30:00',2.01),('8784','2013-02-15','13:35:00',2.15),('8784','2013-02-15','13:40:00',2.84),('8784','2013-02-15','13:45:00',2.24),('8784','2013-02-15','13:50:00',2.27),('8784','2013-02-15','13:55:00',2.42),('8784','2013-02-15','14:00:00',1.87),('8784','2013-02-15','14:05:00',3.03),('8784','2013-02-15','14:10:00',3.14),('8784','2013-02-15','14:15:00',2.01),('8784','2013-02-15','14:20:00',1.92),('8784','2013-02-15','14:25:00',1.45),('8784','2013-02-15','14:30:00',1.44),('8784','2013-02-15','14:35:00',2.02),('8784','2013-02-15','14:40:00',2.13),('8784','2013-02-15','14:45:00',1.82),('8784','2013-02-15','14:50:00',1.15),('8784','2013-02-15','14:55:00',1.09),('8784','2013-02-15','15:00:00',1.62),('8784','2013-02-15','15:05:00',1.15),('8784','2013-02-15','15:10:00',1.25),('8784','2013-02-15','15:15:00',1.42),('8784','2013-02-15','15:20:00',1.16),('8784','2013-02-15','15:25:00',1.35),('8784','2013-02-15','15:30:00',1.45),('8784','2013-02-15','15:35:00',1.21),('8784','2013-02-15','15:40:00',1.21),('8784','2013-02-15','15:45:00',1.11),('8784','2013-02-14','08:35:00',1.03),('8784','2013-02-14','08:40:00',1.08),('8784','2013-02-14','08:45:00',1.16),('8784','2013-02-14','08:50:00',1.25),('8784','2013-02-14','08:55:00',1.33),('8784','2013-02-14','09:00:00',1.14),('8784','2013-02-14','09:05:00',1.28),('8784','2013-02-14','09:10:00',1.54),('8784','2013-02-14','09:15:00',1.6),('8784','2013-02-14','09:20:00',1.69),('8784','2013-02-14','09:25:00',1.79),('8784','2013-02-14','09:30:00',1.88),('8784','2013-02-14','09:35:00',2.01),('8784','2013-02-14','09:40:00',2.09),('8784','2013-02-14','09:45:00',2.18),('8784','2013-02-14','09:50:00',2.25),('8784','2013-02-14','09:55:00',2.32),('8784','2013-02-14','10:00:00',2.4),('8784','2013-02-14','10:05:00',2.52),('8784','2013-02-14','10:10:00',2.59),('8784','2013-02-14','10:15:00',2.64),('8784','2013-02-14','10:20:00',2.69),('8784','2013-02-14','10:25:00',2.74),('8784','2013-02-14','10:30:00',2.79),('8784','2013-02-14','10:35:00',2.84),('8784','2013-02-14','10:40:00',2.89),('8784','2013-02-14','10:45:00',2.94),('8784','2013-02-14','10:50:00',2.98),('8784','2013-02-14','10:55:00',3.02),('8784','2013-02-14','11:00:00',3.06),('8784','2013-02-14','11:05:00',3.08),('8784','2013-02-14','11:10:00',3.11),('8784','2013-02-14','11:15:00',3.13),('8784','2013-02-14','11:20:00',3.14),('8784','2013-02-14','11:25:00',3.17),('8784','2013-02-14','11:30:00',3.19),('8784','2013-02-14','11:35:00',3.21),('8784','2013-02-14','11:40:00',3.23),('8784','2013-02-14','11:45:00',3.23),('8784','2013-02-14','11:50:00',3.23),('8784','2013-02-14','11:55:00',3.25),('8784','2013-02-14','12:00:00',3.24),('8784','2013-02-14','12:05:00',3.25),('8784','2013-02-14','12:10:00',3.23),('8784','2013-02-14','12:15:00',3.23),('8784','2013-02-14','12:20:00',3.22),('8784','2013-02-14','12:25:00',3.22),('8784','2013-02-14','12:30:00',3.22),('8784','2013-02-14','12:35:00',3.2),('8784','2013-02-14','12:40:00',3.21),('8784','2013-02-14','12:45:00',3.19),('8784','2013-02-14','12:50:00',3.16),('8784','2013-02-14','12:55:00',3.1),('8784','2013-02-14','13:00:00',2.99),('8784','2013-02-14','13:05:00',3.07),('8784','2013-02-14','13:10:00',3.08),('8784','2013-02-14','13:15:00',3.08),('8784','2013-02-14','13:20:00',3.04),('8784','2013-02-14','13:25:00',2.97),('8784','2013-02-14','13:30:00',2.92),('8784','2013-02-14','13:35:00',2.91),('8784','2013-02-14','13:40:00',2.89),('8784','2013-02-14','13:45:00',2.85),('8784','2013-02-14','13:50:00',2.8),('8784','2013-02-14','13:55:00',2.74),('8784','2013-02-14','14:00:00',2.67),('8784','2013-02-14','14:05:00',2.65),('8784','2013-02-14','14:10:00',2.57),('8784','2013-02-14','14:15:00',2.34),('8784','2013-02-14','14:20:00',2.19),('8784','2013-02-14','14:25:00',2.4),('8784','2013-02-14','14:30:00',2.36),('8784','2013-02-14','14:35:00',2.28),('8784','2013-02-14','14:40:00',2.25),('8784','2013-02-14','14:45:00',2.19),('8784','2013-02-14','14:50:00',2.11),('8784','2013-02-14','14:55:00',2.05),('8784','2013-02-14','15:00:00',1.98),('8784','2013-02-14','15:05:00',1.92),('8784','2013-02-14','15:10:00',1.85),('8784','2013-02-14','15:15:00',1.76),('8784','2013-02-14','15:20:00',1.7),('8784','2013-02-14','15:25:00',1.62),('8784','2013-02-14','15:30:00',1.56),('8784','2013-02-14','15:35:00',1.48),('8784','2013-02-14','15:40:00',1.4),('8784','2013-02-14','15:45:00',1.33),('8784','2013-02-14','15:50:00',1.27),('8784','2013-02-14','15:55:00',1.18),('8784','2013-02-14','16:00:00',1.1),('8784','2013-02-14','16:05:00',1.02),('8784','2013-02-13','09:00:00',1.01),('8784','2013-02-13','09:05:00',1.06),('8784','2013-02-13','09:10:00',1.08),('8784','2013-02-13','09:15:00',1.07),('8784','2013-02-13','09:20:00',1.07),('8784','2013-02-13','09:25:00',1.14),('8784','2013-02-13','09:30:00',1.35),('8784','2013-02-13','09:35:00',1.81),('8784','2013-02-13','09:40:00',1.9),('8784','2013-02-13','09:45:00',2.1),('8784','2013-02-13','09:50:00',2.19),('8784','2013-02-13','09:55:00',2.09),('8784','2013-02-13','10:00:00',2.12),('8784','2013-02-13','10:05:00',2.27),('8784','2013-02-13','10:10:00',2.5),('8784','2013-02-13','10:15:00',2.62),('8784','2013-02-13','10:20:00',2.71),('8784','2013-02-13','10:25:00',2.77),('8784','2013-02-13','10:30:00',2.9),('8784','2013-02-13','10:35:00',2.97),('8784','2013-02-13','10:40:00',2.94),('8784','2013-02-13','10:45:00',3.07),('8784','2013-02-13','10:50:00',3.15),('8784','2013-02-13','10:55:00',3.15),('8784','2013-02-13','11:00:00',3.13),('8784','2013-02-13','11:05:00',3.21),('8784','2013-02-13','11:10:00',3.05),('8784','2013-02-13','11:15:00',3.06),('8784','2013-02-13','11:20:00',2.97),('8784','2013-02-13','11:25:00',2.69),('8784','2013-02-13','11:30:00',2.91),('8784','2013-02-13','11:35:00',1.71),('8784','2013-02-13','11:40:00',1.48),('8784','2013-02-13','11:45:00',1.67),('8784','2013-02-13','11:50:00',2.09),('8784','2013-02-13','11:55:00',1.41),('8784','2013-02-13','12:00:00',1.11),('8784','2013-02-13','12:05:00',1.58),('8784','2013-02-13','12:10:00',2.59),('8784','2013-02-13','12:15:00',2.11),('8784','2013-02-13','12:20:00',2.79),('8784','2013-02-13','12:25:00',1.86),('8784','2013-02-13','12:30:00',1.12),('8784','2013-02-13','12:35:00',1.49),('8784','2013-02-13','12:40:00',1.2),('8784','2013-02-13','12:45:00',2.36),('8784','2013-02-13','12:50:00',2.55),('8784','2013-02-13','12:55:00',2.3),('8784','2013-02-13','13:00:00',2.48),('8784','2013-02-13','13:05:00',1.71),('8784','2013-02-13','13:10:00',2.42),('8784','2013-02-13','13:15:00',2.28),('8784','2013-02-13','13:20:00',3.07),('8784','2013-02-13','13:25:00',3.07),('8784','2013-02-13','13:30:00',3.11),('8784','2013-02-13','13:35:00',3.17),('8784','2013-02-13','13:40:00',2.93),('8784','2013-02-13','13:45:00',2.54),('8784','2013-02-13','13:50:00',2.4),('8784','2013-02-13','13:55:00',2.5),('8784','2013-02-13','14:00:00',2.64),('8784','2013-02-13','14:05:00',2.81),('8784','2013-02-13','14:10:00',2.63),('8784','2013-02-13','14:15:00',2.36),('8784','2013-02-13','14:20:00',2.19),('8784','2013-02-13','14:25:00',1.8),('8784','2013-02-13','14:30:00',2.14),('8784','2013-02-13','14:35:00',2.32),('8784','2013-02-13','14:40:00',2.23),('8784','2013-02-13','14:45:00',2.1),('8784','2013-02-13','14:50:00',2.16),('8784','2013-02-13','14:55:00',2.07),('8784','2013-02-13','15:00:00',1.97),('8784','2013-02-13','15:05:00',1.92),('8784','2013-02-13','15:10:00',1.84),('8784','2013-02-13','15:15:00',1.76),('8784','2013-02-13','15:20:00',1.69),('8784','2013-02-13','15:25:00',1.65),('8784','2013-02-13','15:30:00',1.56),('8784','2013-02-13','15:35:00',1.52),('8784','2013-02-13','15:40:00',1.44),('8784','2013-02-13','15:45:00',1.36),('8784','2013-02-13','15:50:00',1.27),('8784','2013-02-13','15:55:00',1.2),('8784','2013-02-13','16:00:00',1.13),('8784','2013-02-13','16:05:00',1.04),('8784','2013-02-11','10:20:00',1.09),('8784','2013-02-11','10:25:00',1.13),('8784','2013-02-11','10:30:00',1.13),('8784','2013-02-11','10:35:00',1.35),('8784','2013-02-11','10:40:00',1.18),('8784','2013-02-11','11:00:00',1.03),('8784','2013-02-11','11:05:00',1.22),('8784','2013-02-11','11:10:00',1.45),('8784','2013-02-11','11:15:00',1.54),('8784','2013-02-11','11:20:00',1.2),('8784','2013-02-11','11:45:00',1.3),('8784','2013-02-11','12:45:00',1.37),('8784','2013-02-11','14:00:00',1.05),('8784','2013-02-11','14:05:00',1.14),('8784','2013-02-11','14:10:00',1.27),('8784','2013-02-11','14:15:00',1.05),('8784','2013-02-11','14:20:00',1.09),('8784','2013-02-11','14:25:00',1.62),('8784','2013-02-11','14:30:00',2.08),('8784','2013-02-11','14:35:00',1.21),('8784','2013-02-11','14:40:00',1.72),('8784','2013-02-11','14:45:00',1.39),('8784','2014-03-22','07:40:00',1.37),('8784','2014-03-22','07:45:00',1.32),('8784','2014-03-22','07:50:00',1.16),('8784','2014-03-22','08:10:00',1.19),('8784','2014-03-22','08:15:00',1.42),('8784','2014-03-22','08:20:00',1.7),('8784','2014-03-22','08:25:00',1.7),('8784','2014-03-22','08:30:00',1.63),('8784','2014-03-22','08:35:00',1.04),('8784','2014-03-22','08:40:00',2.18),('8784','2014-03-22','08:45:00',2.16),('8784','2014-03-22','08:50:00',1.77),('8784','2014-03-22','08:55:00',1.94),('8784','2014-03-22','09:00:00',2.07),('8784','2014-03-22','09:05:00',1.39),('8784','2014-03-22','09:10:00',1.53),('8784','2014-03-22','09:15:00',1.33),('8784','2014-03-22','09:20:00',1.46),('8784','2014-03-22','09:25:00',1.92),('8784','2014-03-22','09:30:00',2.44),('8784','2014-03-22','09:35:00',1.59),('8784','2014-03-22','09:40:00',2.22),('8784','2014-03-22','09:45:00',2.91),('8784','2014-03-22','09:50:00',3.03),('8784','2014-03-22','09:55:00',2.98),('8784','2014-03-22','10:00:00',3.11),('8784','2014-03-22','10:05:00',2.1),('8784','2014-03-22','10:10:00',2.01),('8784','2014-03-22','10:15:00',2),('8784','2014-03-22','10:20:00',1.17),('8784','2014-03-22','10:30:00',1.09),('8784','2014-03-22','10:35:00',1.66),('8784','2014-03-22','10:40:00',2.02),('8784','2014-03-22','10:45:00',2.69),('8784','2014-03-22','10:50:00',2.14),('8784','2014-03-22','10:55:00',1.42),('8784','2014-03-22','11:00:00',1.35),('8784','2014-03-22','11:05:00',1.17),('8784','2014-03-22','11:10:00',1.48),('8784','2014-03-22','11:15:00',1.86),('8784','2014-03-22','11:20:00',3.79),('8784','2014-03-22','11:25:00',4.45),('8784','2014-03-22','11:30:00',3.15),('8784','2014-03-22','11:35:00',2.04),('8784','2014-03-22','11:40:00',2.95),('8784','2014-03-22','11:45:00',1.55),('8784','2014-03-22','11:50:00',3.35),('8784','2014-03-22','11:55:00',4.31),('8784','2014-03-22','12:00:00',1.97),('8784','2014-03-22','12:05:00',1.54),('8784','2014-03-22','12:10:00',1.39),('8784','2014-03-22','12:15:00',2.66),('8784','2014-03-22','12:20:00',3.83),('8784','2014-03-22','12:25:00',1.98),('8784','2014-03-22','12:30:00',1.96),('8784','2014-03-22','12:35:00',2.53),('8784','2014-03-22','12:40:00',3.98),('8784','2014-03-22','12:45:00',3.48),('8784','2014-03-22','12:50:00',2.87),('8784','2014-03-22','12:55:00',2.09),('8784','2014-03-22','13:00:00',1.57),('8784','2014-03-22','13:05:00',3.4),('8784','2014-03-22','13:10:00',4.06),('8784','2014-03-22','13:15:00',2.93),('8784','2014-03-22','13:20:00',3.64),('8784','2014-03-22','13:25:00',3.46),('8784','2014-03-22','13:30:00',2.66),('8784','2014-03-22','13:35:00',3.16),('8784','2014-03-22','13:40:00',3.69),('8784','2014-03-22','13:45:00',3.16),('8784','2014-03-22','13:50:00',3.01),('8784','2014-03-22','13:55:00',2.59),('8784','2014-03-22','14:00:00',3.01),('8784','2014-03-22','14:05:00',2.47),('8784','2014-03-22','14:10:00',3.04),('8784','2014-03-22','14:15:00',2.43),('8784','2014-03-22','14:20:00',3.16),('8784','2014-03-22','14:25:00',3.15),('8784','2014-03-22','14:30:00',3.08),('8784','2014-03-22','14:35:00',3.01),('8784','2014-03-22','14:40:00',2.93),('8784','2014-03-22','14:45:00',2.85),('8784','2014-03-22','14:50:00',2.81),('8784','2014-03-22','14:55:00',2.74),('8784','2014-03-22','15:00:00',2.63),('8784','2014-03-22','15:05:00',2.61),('8784','2014-03-22','15:10:00',2.42),('8784','2014-03-22','15:15:00',2.43),('8784','2014-03-22','15:20:00',2.4),('8784','2014-03-22','15:25:00',1.87),('8784','2014-03-22','15:30:00',1.35),('8784','2014-03-22','15:35:00',2.35),('8784','2014-03-22','15:40:00',2.69),('8784','2014-03-22','15:45:00',2.63),('8784','2014-03-22','15:50:00',2.6),('8784','2014-03-22','15:55:00',2.3),('8784','2014-03-22','16:00:00',2.11),('8784','2014-03-22','16:05:00',1.84),('8784','2014-03-22','16:10:00',1.67),('8784','2014-03-22','16:15:00',1.52),('8784','2014-03-22','16:20:00',1.3),('8784','2014-03-22','16:25:00',1.29),('8784','2013-02-10','09:50:00',1.35),('8784','2013-02-10','10:00:00',2.22),('8784','2013-02-10','10:05:00',2.35),('8784','2013-02-10','10:10:00',2.45),('8784','2013-02-10','10:15:00',2.55),('8784','2013-02-10','10:20:00',2.61),('8784','2013-02-10','10:25:00',2.67),('8784','2013-02-10','10:30:00',2.72),('8784','2013-02-10','10:35:00',2.75),('8784','2013-02-10','10:40:00',2.8),('8784','2013-02-10','10:45:00',2.83),('8784','2013-02-10','10:50:00',2.87),('8784','2013-02-10','10:55:00',2.91),('8784','2013-02-10','11:00:00',2.95),('8784','2013-02-10','11:05:00',2.97),('8784','2013-02-10','11:10:00',2.99),('8784','2013-02-10','11:15:00',2.99),('8784','2013-02-10','11:20:00',3.02),('8784','2013-02-10','11:25:00',3.03),('8784','2013-02-10','11:30:00',3.02),('8784','2013-02-10','11:35:00',3.07),('8784','2013-02-10','11:40:00',3.08),('8784','2013-02-10','11:45:00',3.1),('8784','2013-02-10','11:50:00',3.12),('8784','2013-02-10','11:55:00',3.12),('8784','2013-02-10','12:00:00',3.1),('8784','2013-02-10','12:05:00',3.17),('8784','2013-02-10','12:10:00',3.17),('8784','2013-02-10','12:15:00',3.19),('8784','2013-02-10','12:20:00',3.18),('8784','2013-02-10','12:25:00',3.17),('8784','2013-02-10','12:30:00',3.12),('8784','2013-02-10','12:35:00',3.15),('8784','2013-02-10','12:40:00',3.12),('8784','2013-02-10','12:45:00',3.09),('8784','2013-02-10','12:50:00',3.07),('8784','2013-02-10','12:55:00',3.02),('8784','2013-02-10','13:00:00',2.98),('8784','2013-02-10','13:05:00',2.96),('8784','2013-02-10','13:10:00',2.86),('8784','2013-02-10','13:15:00',2.85),('8784','2013-02-10','13:20:00',2.91),('8784','2013-02-10','13:25:00',2.9),('8784','2013-02-10','13:30:00',2.84),('8784','2013-02-10','13:35:00',2.8),('8784','2013-02-10','13:40:00',2.73),('8784','2013-02-10','13:45:00',2.63),('8784','2013-02-10','13:50:00',2.66),('8784','2013-02-10','13:55:00',2.61),('8784','2013-02-10','14:00:00',2.54),('8784','2013-02-10','14:05:00',2.5),('8784','2013-02-10','14:10:00',2.39),('8784','2013-02-10','14:15:00',2.05),('8784','2013-02-10','14:20:00',2.33),('8784','2013-02-10','14:25:00',2.28),('8784','2013-02-10','14:30:00',2.28),('8784','2013-02-10','14:35:00',2.18),('8784','2013-02-10','14:40:00',2.16),('8784','2013-02-10','14:45:00',2.02),('8784','2013-02-10','14:50:00',1.99),('8784','2013-02-10','14:55:00',1.69),('8784','2013-02-10','15:00:00',1.34),('8784','2013-02-10','15:05:00',1.64),('8784','2013-02-10','15:10:00',1.78),('8784','2013-02-10','15:15:00',1.54),('8784','2013-02-10','15:20:00',1.73),('8784','2013-02-10','15:25:00',1.93),('8784','2013-02-10','15:30:00',1.49),('8784','2013-02-10','15:35:00',1.44),('8784','2013-02-10','15:40:00',1.19),('8784','2013-02-09','10:55:00',1.06),('8784','2013-02-09','11:00:00',1.14),('8784','2013-02-09','11:05:00',1.18),('8784','2013-02-09','11:10:00',1.21),('8784','2013-02-09','11:15:00',1.26),('8784','2013-02-09','11:20:00',1.3),('8784','2013-02-09','11:25:00',1.31),('8784','2013-02-09','11:30:00',1.33),('8784','2013-02-09','11:35:00',1.29),('8784','2013-02-09','11:40:00',1.26),('8784','2013-02-09','11:45:00',1.28),('8784','2013-02-09','11:50:00',1.26),('8784','2013-02-09','11:55:00',1.23),('8784','2013-02-09','12:00:00',1.25),('8784','2013-02-09','12:05:00',1.25),('8784','2013-02-09','12:10:00',1.22),('8784','2013-02-09','12:15:00',1.21),('8784','2013-02-09','12:20:00',1.23),('8784','2013-02-09','12:25:00',1.24),('8784','2013-02-09','12:30:00',1.27),('8784','2013-02-09','12:35:00',1.34),('8784','2013-02-09','12:40:00',1.36),('8784','2013-02-09','12:45:00',1.37),('8784','2013-02-09','12:50:00',1.38),('8784','2013-02-09','12:55:00',1.36),('8784','2013-02-09','13:00:00',1.46),('8784','2013-02-09','13:05:00',1.64),('8784','2013-02-09','13:10:00',1.82),('8784','2013-02-09','13:15:00',1.94),('8784','2013-02-09','13:20:00',2.12),('8784','2013-02-09','13:25:00',2.21),('8784','2013-02-09','13:30:00',2.38),('8784','2013-02-09','13:35:00',2.57),('8784','2013-02-09','13:40:00',2.53),('8784','2013-02-09','13:45:00',2.72),('8784','2013-02-09','13:50:00',2.78),('8784','2013-02-09','13:55:00',2.9),('8784','2013-02-09','14:00:00',2.69),('8784','2013-02-09','14:05:00',2.49),('8784','2013-02-09','14:10:00',2.18),('8784','2013-02-09','14:15:00',2.44),('8784','2013-02-09','14:20:00',3.01),('8784','2013-02-09','14:25:00',2.92),('8784','2013-02-09','14:30:00',2.6),('8784','2013-02-09','14:35:00',2.39),('8784','2013-02-09','14:40:00',2.16),('8784','2013-02-09','14:45:00',2.05),('8784','2013-02-09','14:50:00',1.97),('8784','2013-02-09','14:55:00',1.95),('8784','2013-02-09','15:00:00',1.86),('8784','2013-02-09','15:05:00',1.79),('8784','2013-02-09','15:10:00',1.72),('8784','2013-02-09','15:15:00',1.62),('8784','2013-02-09','15:20:00',1.58),('8784','2013-02-09','15:25:00',1.35),('8784','2013-02-09','15:30:00',1.4),('8784','2013-02-09','15:35:00',1.34),('8784','2013-02-09','15:40:00',1.25),('8784','2013-02-09','15:45:00',1.17),('8784','2013-02-09','15:50:00',1.14),('8784','2013-02-08','09:35:00',1.23),('8784','2013-02-08','09:40:00',1.33),('8784','2013-02-08','09:45:00',1.28),('8784','2013-02-08','09:50:00',2.06),('8784','2013-02-08','09:55:00',2.42),('8784','2013-02-08','10:00:00',2.33),('8784','2013-02-08','10:05:00',2.77),('8784','2013-02-08','10:10:00',2.91),('8784','2013-02-08','10:15:00',3.05),('8784','2013-02-08','10:20:00',2.85),('8784','2013-02-08','10:25:00',2.9),('8784','2013-02-08','10:30:00',2.56),('8784','2013-02-08','10:35:00',1.28),('8784','2013-02-08','10:40:00',3.21),('8784','2013-02-08','10:45:00',3.12),('8784','2013-02-08','10:50:00',3.19),('8784','2013-02-08','10:55:00',3.15),('8784','2013-02-08','11:00:00',3.06),('8784','2013-02-08','11:05:00',2.99),('8784','2013-02-08','11:10:00',3.02),('8784','2013-02-08','11:15:00',3.01),('8784','2013-02-08','11:20:00',3.02),('8784','2013-02-08','11:25:00',3),('8784','2013-02-08','11:30:00',3.04),('8784','2013-02-08','11:35:00',3.04),('8784','2013-02-08','11:40:00',3.07),('8784','2013-02-08','11:45:00',3.08),('8784','2013-02-08','11:50:00',3.09),('8784','2013-02-08','11:55:00',3.09),('8784','2013-02-08','12:00:00',3.1),('8784','2013-02-08','12:05:00',3.1),('8784','2013-02-08','12:10:00',3.1),('8784','2013-02-08','12:15:00',3.1),('8784','2013-02-08','12:20:00',3.11),('8784','2013-02-08','12:25:00',3.13),('8784','2013-02-08','12:30:00',3.09),('8784','2013-02-08','12:35:00',3.08),('8784','2013-02-08','12:40:00',3.2),('8784','2013-02-08','12:45:00',3.4),('8784','2013-02-08','12:50:00',2.01),('8784','2013-02-08','12:55:00',2.14),('8784','2013-02-08','13:00:00',2.02),('8784','2013-02-08','13:05:00',1.74),('8784','2013-02-08','13:10:00',1.89),('8784','2013-02-08','13:15:00',1.85),('8784','2013-02-08','13:20:00',1.93),('8784','2013-02-08','13:25:00',1.8),('8784','2013-02-08','13:30:00',1.81),('8784','2013-02-08','13:35:00',2.28),('8784','2013-02-08','13:40:00',1.85),('8784','2013-02-08','13:45:00',1.47),('8784','2013-02-08','13:50:00',1.54),('8784','2013-02-08','13:55:00',1.6),('8784','2013-02-08','14:00:00',1.46),('8784','2013-02-08','14:05:00',1.45),('8784','2013-02-08','14:10:00',1.35),('8784','2013-02-08','14:15:00',1.27),('8784','2013-02-08','14:20:00',1.31),('8784','2013-02-08','14:25:00',1.69),('8784','2013-02-08','14:30:00',2.25),('8784','2013-02-08','14:35:00',2.1),('8784','2013-02-08','14:40:00',3.13),('8784','2013-02-08','14:45:00',2.27),('8784','2013-02-08','14:50:00',2.2),('8784','2013-02-08','14:55:00',2.55),('8784','2013-02-08','15:00:00',2.44),('8784','2013-02-08','15:05:00',2.65),('8784','2013-02-08','15:10:00',2.46),('8784','2013-02-08','15:15:00',2.09),('8784','2013-02-08','15:20:00',1.27),('8784','2013-02-08','15:25:00',1.53),('8784','2013-02-08','15:30:00',1.52),('8784','2013-02-08','15:35:00',1.43),('8784','2013-02-08','15:40:00',1.36),('8784','2013-02-08','15:45:00',1.28),('8784','2013-02-08','15:50:00',1.18),('8784','2013-02-08','15:55:00',1.1),('8784','2013-02-08','16:00:00',1.01),('8784','2013-02-07','10:35:00',1.11),('8784','2013-02-07','10:40:00',1.35),('8784','2013-02-07','10:45:00',1.2),('8784','2013-02-07','10:55:00',1.39),('8784','2013-02-07','11:00:00',1.88),('8784','2013-02-07','11:05:00',1.19),('8784','2013-02-07','12:20:00',1.28),('8784','2013-02-07','12:25:00',2.5),('8784','2013-02-07','12:30:00',1.93),('8784','2013-02-07','12:35:00',1.01),('8784','2013-02-07','13:15:00',1.93),('8784','2013-02-07','13:20:00',1.43),('8784','2013-02-07','13:25:00',1.42),('8784','2013-02-07','13:30:00',1.04),('8784','2013-02-07','13:55:00',1.17),('8784','2013-02-07','14:00:00',1.42),('8784','2013-02-07','14:05:00',1.95),('8784','2013-02-07','14:10:00',2.82),('8784','2013-02-07','14:15:00',2.5),('8784','2013-02-07','14:20:00',2.15),('8784','2013-02-07','14:25:00',1.18),('8784','2013-02-07','14:30:00',1.02),('8784','2013-02-07','14:35:00',1.76),('8784','2013-02-07','14:40:00',2.08),('8784','2013-02-07','14:45:00',1.96),('8784','2013-02-07','14:50:00',1.24),('8784','2013-02-07','14:55:00',1.56),('8784','2013-02-07','15:00:00',1.92),('8784','2013-02-07','15:05:00',2.32),('8784','2013-02-07','15:10:00',2.33),('8784','2013-02-07','15:15:00',1.63),('8784','2013-02-07','15:20:00',1.05),('8784','2013-02-07','15:25:00',1.22),('8784','2013-02-06','09:00:00',1.01),('8784','2013-02-06','09:10:00',1.1),('8784','2013-02-06','09:20:00',1.04),('8784','2013-02-06','09:25:00',1.13),('8784','2013-02-06','09:30:00',1.3),('8784','2013-02-06','09:35:00',1.16),('8784','2013-02-06','09:40:00',1.3),('8784','2013-02-06','09:45:00',1.23),('8784','2013-02-06','09:50:00',1.26),('8784','2013-02-06','09:55:00',1.46),('8784','2013-02-06','10:00:00',1.33),('8784','2013-02-06','10:05:00',1.56),('8784','2013-02-06','10:10:00',1.38),('8784','2013-02-06','10:15:00',1.36),('8784','2013-02-06','10:20:00',1.23),('8784','2013-02-06','10:25:00',1.71),('8784','2013-02-06','10:30:00',1.46),('8784','2013-02-06','10:35:00',2.02),('8784','2013-02-06','10:40:00',1.35),('8784','2013-02-06','10:45:00',1.14),('8784','2013-02-06','10:50:00',1.87),('8784','2013-02-06','10:55:00',2.15),('8784','2013-02-06','11:00:00',1.77),('8784','2013-02-06','11:05:00',1.49),('8784','2013-02-06','11:10:00',1.64),('8784','2013-02-06','11:15:00',1.53),('8784','2013-02-06','11:20:00',1.9),('8784','2013-02-06','11:25:00',2.74),('8784','2013-02-06','11:30:00',1.58),('8784','2013-02-06','11:35:00',1.52),('8784','2013-02-06','11:40:00',1.69),('8784','2013-02-06','11:45:00',1.71),('8784','2013-02-06','11:50:00',1.78),('8784','2013-02-06','11:55:00',1.66),('8784','2013-02-06','12:00:00',1.44),('8784','2013-02-06','12:05:00',1.14),('8784','2013-02-06','12:15:00',1.25),('8784','2013-02-06','12:20:00',1.17),('8784','2013-02-06','12:25:00',1.12),('8784','2013-02-06','13:20:00',1.02),('8784','2013-02-06','13:25:00',1.14),('8784','2013-02-06','13:30:00',1.33),('8784','2013-02-06','13:35:00',1.4),('8784','2013-02-06','13:40:00',1.16),('8784','2013-02-06','13:45:00',1.19),('8784','2013-02-06','13:50:00',1.63),('8784','2013-02-06','13:55:00',1.34),('8784','2013-02-06','14:00:00',1.47),('8784','2013-02-06','14:05:00',1.36),('8784','2013-02-06','14:30:00',1.82),('8784','2013-02-06','14:35:00',1.99),('8784','2013-02-06','14:40:00',1.4),('8784','2013-02-06','15:25:00',1.1),('8784','2013-02-05','09:10:00',1.1),('8784','2013-02-05','09:15:00',1.24),('8784','2013-02-05','09:20:00',1.29),('8784','2013-02-05','09:25:00',1.36),('8784','2013-02-05','09:30:00',1.42),('8784','2013-02-05','09:35:00',1.52),('8784','2013-02-05','09:40:00',1.71),('8784','2013-02-05','09:45:00',1.78),('8784','2013-02-05','09:50:00',1.86),('8784','2013-02-05','09:55:00',1.93),('8784','2013-02-05','10:00:00',1.99),('8784','2013-02-05','10:05:00',2.01),('8784','2013-02-05','10:10:00',1.95),('8784','2013-02-05','10:15:00',2.03),('8784','2013-02-05','10:20:00',2.32),('8784','2013-02-05','10:25:00',2.39),('8784','2013-02-05','10:30:00',2.44),('8784','2013-02-05','10:35:00',2.46),('8784','2013-02-05','10:40:00',2.48),('8784','2013-02-05','10:45:00',2.49),('8784','2013-02-05','10:50:00',2.52),('8784','2013-02-05','10:55:00',2.55),('8784','2013-02-05','11:00:00',2.6),('8784','2013-02-05','11:05:00',2.61),('8784','2013-02-05','11:10:00',2.67),('8784','2013-02-05','11:15:00',2.64),('8784','2013-02-05','11:20:00',2.64),('8784','2013-02-05','11:25:00',2.73),('8784','2013-02-05','11:30:00',2.69),('8784','2013-02-05','11:35:00',2.52),('8784','2013-02-05','11:40:00',2.23),('8784','2013-02-05','11:45:00',2.33),('8784','2013-02-05','11:50:00',1.64),('8784','2013-02-05','11:55:00',1.4),('8784','2013-02-05','12:00:00',1.11),('8784','2013-02-05','12:05:00',1.51),('8784','2013-02-05','12:10:00',1.41),('8784','2013-02-05','12:15:00',1.53),('8784','2013-02-05','12:20:00',1.31),('8784','2013-02-05','12:25:00',1.3),('8784','2013-02-05','12:30:00',1.21),('8784','2013-02-05','12:35:00',1.89),('8784','2013-02-05','12:40:00',1.97),('8784','2013-02-05','12:45:00',2.18),('8784','2013-02-05','12:50:00',1.97),('8784','2013-02-05','13:10:00',1.16),('8784','2013-02-05','13:15:00',1.41),('8784','2013-02-05','13:20:00',1.4),('8784','2013-02-05','13:25:00',1.42),('8784','2013-02-05','13:30:00',1.32),('8784','2013-02-05','13:35:00',1.04),('8784','2013-02-05','13:40:00',1.15),('8784','2013-02-05','13:45:00',1.43),('8784','2013-02-05','13:50:00',1.45),('8784','2013-02-05','13:55:00',1.28),('8784','2013-02-05','14:00:00',1.29),('8784','2013-02-05','14:05:00',1.27),('8784','2013-02-05','14:10:00',1.02),('8784','2013-02-05','14:15:00',1.14),('8784','2013-02-05','14:20:00',1.32),('8784','2013-02-05','14:25:00',1.74),('8784','2013-02-05','14:30:00',1.72),('8784','2013-02-05','14:35:00',1.46),('8784','2013-02-05','14:40:00',1.52),('8784','2013-02-05','14:45:00',1.07),('8784','2013-02-05','15:05:00',1.01),('8784','2013-02-04','09:15:00',1.34),('8784','2013-02-04','09:20:00',1.32),('8784','2013-02-04','09:25:00',1.35),('8784','2013-02-04','09:30:00',1.44),('8784','2013-02-04','09:35:00',1.52),('8784','2013-02-04','09:40:00',1.68),('8784','2013-02-04','09:45:00',1.54),('8784','2013-02-04','09:50:00',1.92),('8784','2013-02-04','09:55:00',2.05),('8784','2013-02-04','10:00:00',2.08),('8784','2013-02-04','10:05:00',2.2),('8784','2013-02-04','10:10:00',2.31),('8784','2013-02-04','10:15:00',2.5),('8784','2013-02-04','10:20:00',2.39),('8784','2013-02-04','10:25:00',2.53),('8784','2013-02-04','10:30:00',2.4),('8784','2013-02-04','10:35:00',2.26),('8784','2013-02-04','10:40:00',2.41),('8784','2013-02-04','10:45:00',2.66),('8784','2013-02-04','10:50:00',2.73),('8784','2013-02-04','10:55:00',2.74),('8784','2013-02-04','11:00:00',2.75),('8784','2013-02-04','11:05:00',2.81),('8784','2013-02-04','11:10:00',2.82),('8784','2013-02-04','11:15:00',2.81),('8784','2013-02-04','11:20:00',2.85),('8784','2013-02-04','11:25:00',2.87),('8784','2013-02-04','11:30:00',2.86),('8784','2013-02-04','11:35:00',2.89),('8784','2013-02-04','11:40:00',2.89),('8784','2013-02-04','11:45:00',2.9),('8784','2013-02-04','11:50:00',2.87),('8784','2013-02-04','11:55:00',2.85),('8784','2013-02-04','12:00:00',2.91),('8784','2013-02-04','12:05:00',2.94),('8784','2013-02-04','12:10:00',2.94),('8784','2013-02-04','12:15:00',2.93),('8784','2013-02-04','12:20:00',2.92),('8784','2013-02-04','12:25:00',2.92),('8784','2013-02-04','12:30:00',2.9),('8784','2013-02-04','12:35:00',2.89),('8784','2013-02-04','12:40:00',2.88),('8784','2013-02-04','12:45:00',2.88),('8784','2013-02-04','12:50:00',2.88),('8784','2013-02-04','12:55:00',2.7),('8784','2013-02-04','13:00:00',2.74),('8784','2013-02-04','13:05:00',2.73),('8784','2013-02-04','13:10:00',2.74),('8784','2013-02-04','13:15:00',2.75),('8784','2013-02-04','13:20:00',2.72),('8784','2013-02-04','13:25:00',2.68),('8784','2013-02-04','13:30:00',2.64),('8784','2013-02-04','13:35:00',2.59),('8784','2013-02-04','13:40:00',2.56),('8784','2013-02-04','13:45:00',2.52),('8784','2013-02-04','13:50:00',2.47),('8784','2013-02-04','13:55:00',2.36),('8784','2013-02-04','14:00:00',2.38),('8784','2013-02-04','14:05:00',2.34),('8784','2013-02-04','14:10:00',2.06),('8784','2013-02-04','14:15:00',2.23),('8784','2013-02-04','14:20:00',2.21),('8784','2013-02-04','14:25:00',2.18),('8784','2013-02-04','14:30:00',2.12),('8784','2013-02-04','14:35:00',2.03),('8784','2013-02-04','14:40:00',1.96),('8784','2013-02-04','14:45:00',1.92),('8784','2013-02-04','14:50:00',1.86),('8784','2013-02-04','14:55:00',1.78),('8784','2013-02-04','15:00:00',1.75),('8784','2013-02-04','15:05:00',1.69),('8784','2013-02-04','15:10:00',1.61),('8784','2013-02-04','15:15:00',1.53),('8784','2013-02-04','15:20:00',1.47),('8784','2013-02-04','15:25:00',1.4),('8784','2013-02-04','15:30:00',1.32),('8784','2013-02-04','15:35:00',1.24),('8784','2013-02-04','15:40:00',1.18),('8784','2013-02-04','15:45:00',1.12),('8784','2013-02-04','15:50:00',1.04),('8784','2013-02-03','09:20:00',1.03),('8784','2013-02-03','09:25:00',1.31),('8784','2013-02-03','09:40:00',1.15),('8784','2013-02-03','09:45:00',1.37),('8784','2013-02-03','09:50:00',1.47),('8784','2013-02-03','09:55:00',1.33),('8784','2013-02-03','10:00:00',1.58),('8784','2013-02-03','10:20:00',1.12),('8784','2013-02-03','11:20:00',1.46),('8784','2013-02-03','11:50:00',1.22),('8784','2013-02-03','11:55:00',1.57),('8784','2013-02-03','12:00:00',1.41),('8784','2013-02-03','12:05:00',1.37),('8784','2013-02-03','12:10:00',1.37),('8784','2013-02-02','10:15:00',1.2),('8784','2013-02-02','10:20:00',1.09),('8784','2013-02-02','10:25:00',1.17),('8784','2013-02-02','10:30:00',1.24),('8784','2013-02-02','10:35:00',1.33),('8784','2013-02-02','10:40:00',1.45),('8784','2013-02-02','10:45:00',1.55),('8784','2013-02-02','10:50:00',1.28),('8784','2013-02-02','10:55:00',1.88),('8784','2013-02-02','11:00:00',1.96),('8784','2013-02-02','11:05:00',1.77),('8784','2013-02-02','11:10:00',1.89),('8784','2013-02-02','11:15:00',1.87),('8784','2013-02-02','11:20:00',1.8),('8784','2013-02-02','11:25:00',2.15),('8784','2013-02-02','11:30:00',2.02),('8784','2013-02-02','11:35:00',1.88),('8784','2013-02-02','11:40:00',1.81),('8784','2013-02-02','11:45:00',1.3),('8784','2013-02-02','11:50:00',1.21),('8784','2013-02-02','11:55:00',1.23),('8784','2013-02-02','12:55:00',2.07),('8784','2013-02-02','13:00:00',1.62),('8784','2013-02-02','13:05:00',1.6),('8784','2013-02-02','13:10:00',2.24),('8784','2013-02-02','13:15:00',2.01),('8784','2013-02-02','13:20:00',1.7),('8784','2013-02-02','13:25:00',1.74),('8784','2013-02-02','13:30:00',1.48),('8784','2013-02-02','13:35:00',1.9),('8784','2013-02-02','13:40:00',2.29),('8784','2013-02-02','13:45:00',1.98),('8784','2013-02-02','13:50:00',1.87),('8784','2013-02-02','13:55:00',1.03),('8784','2013-02-01','09:10:00',1.05),('8784','2013-02-01','09:30:00',1.26),('8784','2013-02-01','09:35:00',1.6),('8784','2013-02-01','09:40:00',1.8),('8784','2013-02-01','09:45:00',1.11),('8784','2013-02-01','09:50:00',1.15),('8784','2013-02-01','09:55:00',1.4),('8784','2013-02-01','10:00:00',1.14),('8784','2013-02-01','10:05:00',1.17),('8784','2013-02-01','10:15:00',1.65),('8784','2013-02-01','10:25:00',1.08),('8784','2013-02-01','10:30:00',1.15),('8784','2013-02-01','10:35:00',1.03),('8784','2013-02-01','10:45:00',1.09),('8784','2013-02-01','10:50:00',3.19),('8784','2013-02-01','10:55:00',2.79),('8784','2013-02-01','11:00:00',2.8),('8784','2013-02-01','11:05:00',2.76),('8784','2013-02-01','11:10:00',1.5),('8784','2013-02-01','11:15:00',1.64),('8784','2013-02-01','11:20:00',2.01),('8784','2013-02-01','11:30:00',1.56),('8784','2013-02-01','11:35:00',1.68),('8784','2013-02-01','11:40:00',1.45),('8784','2013-02-01','11:45:00',1.55),('8784','2013-02-01','11:50:00',1.48),('8784','2013-02-01','11:55:00',1.14),('8784','2013-02-01','12:00:00',1.46),('8784','2013-02-01','12:05:00',2.35),('8784','2013-02-01','12:10:00',1.99),('8784','2013-02-01','12:15:00',2.83),('8784','2013-02-01','12:20:00',2.96),('8784','2013-02-01','12:25:00',2.24),('8784','2013-02-01','12:30:00',2.13),('8784','2013-02-01','12:35:00',3.01),('8784','2013-02-01','12:40:00',2.95),('8784','2013-02-01','12:45:00',2.73),('8784','2013-02-01','12:50:00',2.63),('8784','2013-02-01','12:55:00',1.68),('8784','2013-02-01','13:00:00',1.36),('8784','2013-02-01','13:05:00',2.64),('8784','2013-02-01','13:10:00',2.64),('8784','2013-02-01','13:15:00',2.51),('8784','2013-02-01','13:20:00',2.64),('8784','2013-02-01','13:25:00',1.78),('8784','2013-02-01','13:30:00',2.13),('8784','2013-02-01','13:35:00',1.89),('8784','2013-02-01','13:40:00',1.78),('8784','2013-02-01','13:45:00',1.06),('8784','2013-02-01','13:50:00',1.05),('8784','2013-02-01','13:55:00',1.04),('8784','2013-02-01','14:00:00',1.02),('8784','2013-02-01','14:05:00',1.08),('8784','2013-02-01','14:10:00',2.5),('8784','2013-02-01','14:15:00',2.61),('8784','2013-02-01','14:20:00',1.98),('8784','2013-02-01','14:25:00',2.01),('8784','2013-02-01','14:30:00',2.01),('8784','2013-02-01','14:35:00',1.97),('8784','2013-02-01','14:40:00',1.24),('8784','2013-02-01','15:00:00',1.08),('8784','2013-02-01','15:05:00',1.58),('8784','2013-02-01','15:10:00',1.56),('8784','2013-02-01','15:15:00',1.51),('8784','2013-02-01','15:20:00',1.36),('8784','2013-02-01','15:25:00',1.18),('8784','2014-03-21','07:40:00',1.03),('8784','2014-03-21','07:45:00',1.12),('8784','2014-03-21','07:50:00',1.23),('8784','2014-03-21','07:55:00',1.35),('8784','2014-03-21','08:00:00',1.4),('8784','2014-03-21','08:05:00',1.47),('8784','2014-03-21','08:10:00',1.53),('8784','2014-03-21','08:15:00',1.62),('8784','2014-03-21','08:20:00',1.67),('8784','2014-03-21','08:25:00',1.72),('8784','2014-03-21','08:30:00',1.87),('8784','2014-03-21','08:35:00',1.94),('8784','2014-03-21','08:40:00',2.02),('8784','2014-03-21','08:45:00',2.03),('8784','2014-03-21','08:50:00',2.13),('8784','2014-03-21','08:55:00',2.23),('8784','2014-03-21','09:00:00',2.34),('8784','2014-03-21','09:05:00',2.42),('8784','2014-03-21','09:10:00',2.53),('8784','2014-03-21','09:15:00',2.58),('8784','2014-03-21','09:20:00',2.68),('8784','2014-03-21','09:25:00',2.61),('8784','2014-03-21','09:30:00',2.79),('8784','2014-03-21','09:35:00',2.79),('8784','2014-03-21','09:40:00',2.89),('8784','2014-03-21','09:45:00',2.93),('8784','2014-03-21','09:50:00',2.95),('8784','2014-03-21','09:55:00',2.99),('8784','2014-03-21','10:00:00',3.09),('8784','2014-03-21','10:05:00',3.11),('8784','2014-03-21','10:10:00',3.16),('8784','2014-03-21','10:15:00',3.18),('8784','2014-03-21','10:20:00',3.25),('8784','2014-03-21','10:25:00',3.28),('8784','2014-03-21','10:30:00',3.32),('8784','2014-03-21','10:35:00',3.37),('8784','2014-03-21','10:40:00',3.36),('8784','2014-03-21','10:45:00',3.36),('8784','2014-03-21','10:50:00',3.37),('8784','2014-03-21','10:55:00',3.38),('8784','2014-03-21','11:00:00',3.42),('8784','2014-03-21','11:05:00',3.46),('8784','2014-03-21','11:10:00',3.45),('8784','2014-03-21','11:15:00',3.56),('8784','2014-03-21','11:20:00',3.61),('8784','2014-03-21','11:25:00',3.65),('8784','2014-03-21','11:30:00',1.54),('8784','2014-03-21','11:35:00',2.6),('8784','2014-03-21','11:40:00',3.41),('8784','2014-03-21','11:45:00',3.96),('8784','2014-03-21','11:50:00',3.89),('8784','2014-03-21','11:55:00',3.94),('8784','2014-03-21','12:00:00',2.18),('8784','2014-03-21','12:05:00',2.96),('8784','2014-03-21','12:10:00',3.87),('8784','2014-03-21','12:15:00',3.88),('8784','2014-03-21','12:20:00',3.77),('8784','2014-03-21','12:25:00',3.75),('8784','2014-03-21','12:30:00',3.75),('8784','2014-03-21','12:35:00',3.7),('8784','2014-03-21','12:40:00',3.74),('8784','2014-03-21','12:45:00',3.74),('8784','2014-03-21','12:50:00',3.69),('8784','2014-03-21','12:55:00',3.65),('8784','2014-03-21','13:00:00',3.67),('8784','2014-03-21','13:05:00',3.65),('8784','2014-03-21','13:10:00',3.65),('8784','2014-03-21','13:15:00',3.65),('8784','2014-03-21','13:20:00',3.59),('8784','2014-03-21','13:25:00',3.55),('8784','2014-03-21','13:30:00',3.5),('8784','2014-03-21','13:35:00',3.47),('8784','2014-03-21','13:40:00',3.46),('8784','2014-03-21','13:45:00',3.44),('8784','2014-03-21','13:50:00',3.41),('8784','2014-03-21','13:55:00',3.37),('8784','2014-03-21','14:00:00',3.38),('8784','2014-03-21','14:05:00',3.33),('8784','2014-03-21','14:10:00',3.29),('8784','2014-03-21','14:15:00',3.24),('8784','2014-03-21','14:20:00',3.19),('8784','2014-03-21','14:25:00',3.12),('8784','2014-03-21','14:30:00',2.97),('8784','2014-03-21','14:35:00',2.87),('8784','2014-03-21','14:40:00',2.9),('8784','2014-03-21','14:45:00',2.79),('8784','2014-03-21','14:50:00',2.36),('8784','2014-03-21','14:55:00',1.06),('8784','2014-03-21','15:05:00',1.81),('8784','2014-03-21','15:10:00',2.99),('8784','2014-03-21','15:15:00',3.01),('8784','2014-03-21','15:20:00',2.61),('8784','2014-03-21','15:25:00',2.92),('8784','2014-03-21','15:30:00',2.82),('8784','2014-03-21','15:35:00',2.61),('8784','2014-03-21','15:40:00',2.62),('8784','2014-03-21','15:45:00',2.56),('8784','2014-03-21','15:50:00',2.49),('8784','2014-03-21','15:55:00',2.42),('8784','2014-03-21','16:00:00',2.24),('8784','2014-03-21','16:05:00',2.07),('8784','2014-03-21','16:10:00',1.92),('8784','2014-03-21','16:15:00',1.72),('8784','2014-03-21','16:20:00',1.58),('8784','2014-03-21','16:25:00',1.45),('8784','2014-03-21','16:30:00',1.34),('8784','2014-03-21','16:35:00',1.23),('8784','2014-03-21','16:40:00',1.14),('8784','2014-03-21','16:45:00',1.07),('8784','2013-01-31','09:30:00',1.27),('8784','2013-01-31','09:35:00',1.32),('8784','2013-01-31','09:40:00',1.39),('8784','2013-01-31','09:45:00',1.6),('8784','2013-01-31','09:50:00',1.65),('8784','2013-01-31','09:55:00',1.73),('8784','2013-01-31','10:00:00',1.72),('8784','2013-01-31','10:05:00',1.78),('8784','2013-01-31','10:10:00',1.87),('8784','2013-01-31','10:15:00',2.07),('8784','2013-01-31','10:20:00',2.07),('8784','2013-01-31','10:25:00',2.16),('8784','2013-01-31','10:30:00',2.33),('8784','2013-01-31','10:35:00',2.47),('8784','2013-01-31','10:40:00',2.09),('8784','2013-01-31','10:45:00',2.18),('8784','2013-01-31','10:50:00',2.92),('8784','2013-01-31','10:55:00',2.48),('8784','2013-01-31','11:00:00',2.85),('8784','2013-01-31','11:05:00',2.25),('8784','2013-01-31','11:10:00',1.38),('8784','2013-01-31','11:15:00',2.12),('8784','2013-01-31','11:20:00',3.11),('8784','2013-01-31','11:25:00',3.04),('8784','2013-01-31','11:30:00',2.77),('8784','2013-01-31','11:35:00',2.65),('8784','2013-01-31','11:40:00',2.58),('8784','2013-01-31','11:45:00',2.6),('8784','2013-01-31','11:50:00',2.64),('8784','2013-01-31','11:55:00',2.61),('8784','2013-01-31','12:00:00',2.63),('8784','2013-01-31','12:05:00',2.74),('8784','2013-01-31','12:10:00',2.67),('8784','2013-01-31','12:15:00',2.69),('8784','2013-01-31','12:20:00',2.74),('8784','2013-01-31','12:25:00',2.64),('8784','2013-01-31','12:30:00',2.61),('8784','2013-01-31','12:35:00',2.61),('8784','2013-01-31','12:40:00',2.57),('8784','2013-01-31','12:45:00',2.56),('8784','2013-01-31','12:50:00',2.55),('8784','2013-01-31','12:55:00',2.28),('8784','2013-01-31','13:00:00',2.25),('8784','2013-01-31','13:05:00',2.45),('8784','2013-01-31','13:10:00',2.45),('8784','2013-01-31','13:15:00',2.26),('8784','2013-01-31','13:20:00',2.39),('8784','2013-01-31','13:25:00',2.36),('8784','2013-01-31','13:30:00',2.29),('8784','2013-01-31','13:35:00',2.28),('8784','2013-01-31','13:40:00',2.24),('8784','2013-01-31','13:45:00',2.26),('8784','2013-01-31','13:50:00',2.32),('8784','2013-01-31','13:55:00',2.17),('8784','2013-01-31','14:00:00',2.06),('8784','2013-01-31','14:05:00',2.02),('8784','2013-01-31','14:10:00',2),('8784','2013-01-31','14:15:00',1.97),('8784','2013-01-31','14:20:00',1.96),('8784','2013-01-31','14:25:00',1.89),('8784','2013-01-31','14:30:00',1.83),('8784','2013-01-31','14:35:00',1.75),('8784','2013-01-31','14:40:00',1.73),('8784','2013-01-31','14:45:00',1.67),('8784','2013-01-31','14:50:00',1.62),('8784','2013-01-31','14:55:00',1.5),('8784','2013-01-31','15:00:00',1.44),('8784','2013-01-31','15:05:00',1.45),('8784','2013-01-31','15:10:00',1.4),('8784','2013-01-31','15:15:00',1.37),('8784','2013-01-31','15:20:00',1.3),('8784','2013-01-31','15:25:00',1.19),('8784','2013-01-31','15:30:00',1.15),('8784','2013-01-31','15:35:00',1.14),('8784','2013-01-31','15:40:00',1.06),('8784','2013-01-30','10:00:00',1.09),('8784','2013-01-30','10:05:00',1.29),('8784','2013-01-30','10:10:00',1.54),('8784','2013-01-30','10:15:00',1.19),('8784','2013-01-30','10:20:00',1.71),('8784','2013-01-30','10:25:00',1.77),('8784','2013-01-30','10:30:00',1.55),('8784','2013-01-30','10:35:00',1.33),('8784','2013-01-30','10:40:00',1.21),('8784','2013-01-30','10:45:00',1.83),('8784','2013-01-30','10:50:00',2.34),('8784','2013-01-30','10:55:00',2.11),('8784','2013-01-30','11:00:00',2.44),('8784','2013-01-30','11:05:00',2.34),('8784','2013-01-30','11:10:00',2.35),('8784','2013-01-30','11:15:00',2.38),('8784','2013-01-30','11:20:00',2.42),('8784','2013-01-30','11:25:00',2.48),('8784','2013-01-30','11:30:00',2.46),('8784','2013-01-30','11:35:00',2.31),('8784','2013-01-30','11:40:00',2.04),('8784','2013-01-30','11:45:00',2.3),('8784','2013-01-30','11:50:00',2.25),('8784','2013-01-30','11:55:00',2.52),('8784','2013-01-30','12:00:00',2.63),('8784','2013-01-30','12:05:00',2.03),('8784','2013-01-30','12:10:00',1.31),('8784','2013-01-30','12:15:00',1.64),('8784','2013-01-30','12:20:00',1.43),('8784','2013-01-30','12:35:00',1.13),('8784','2013-01-30','12:40:00',1.12),('8784','2013-01-30','12:45:00',1.95),('8784','2013-01-30','12:50:00',3.19),('8784','2013-01-30','12:55:00',2.83),('8784','2013-01-30','13:00:00',2.68),('8784','2013-01-30','13:05:00',2.94),('8784','2013-01-30','13:10:00',2.76),('8784','2013-01-30','13:15:00',2.73),('8784','2013-01-30','13:20:00',2.68),('8784','2013-01-30','13:25:00',2.69),('8784','2013-01-30','13:30:00',2.65),('8784','2013-01-30','13:35:00',2.05),('8784','2013-01-30','13:40:00',2),('8784','2013-01-30','13:45:00',2.1),('8784','2013-01-30','13:50:00',2.59),('8784','2013-01-30','13:55:00',2.54),('8784','2013-01-30','14:00:00',2.59),('8784','2013-01-30','14:05:00',2.57),('8784','2013-01-30','14:10:00',1.35),('8784','2013-01-30','14:15:00',1.83),('8784','2013-01-30','14:20:00',1.78),('8784','2013-01-30','14:25:00',2.24),('8784','2013-01-30','14:30:00',2.08),('8784','2013-01-30','14:35:00',1.89),('8784','2013-01-30','14:40:00',1.95),('8784','2013-01-30','14:45:00',1.55),('8784','2013-01-30','15:00:00',1.03),('8784','2013-01-30','15:05:00',1.11),('8784','2013-01-29','09:20:00',1.01),('8784','2013-01-29','09:25:00',1.08),('8784','2013-01-29','09:30:00',1.16),('8784','2013-01-29','09:35:00',1.2),('8784','2013-01-29','09:40:00',1.32),('8784','2013-01-29','09:45:00',1.53),('8784','2013-01-29','09:50:00',1.62),('8784','2013-01-29','09:55:00',1.71),('8784','2013-01-29','10:00:00',1.71),('8784','2013-01-29','10:05:00',1.82),('8784','2013-01-29','10:10:00',1.92),('8784','2013-01-29','10:15:00',2.06),('8784','2013-01-29','10:20:00',2.15),('8784','2013-01-29','10:25:00',2.22),('8784','2013-01-29','10:30:00',2.27),('8784','2013-01-29','10:35:00',2.32),('8784','2013-01-29','10:40:00',2.39),('8784','2013-01-29','10:45:00',2.43),('8784','2013-01-29','10:50:00',2.47),('8784','2013-01-29','10:55:00',2.5),('8784','2013-01-29','11:00:00',2.51),('8784','2013-01-29','11:05:00',2.53),('8784','2013-01-29','11:10:00',2.52),('8784','2013-01-29','11:15:00',2.52),('8784','2013-01-29','11:20:00',2.54),('8784','2013-01-29','11:25:00',2.54),('8784','2013-01-29','11:30:00',2.5),('8784','2013-01-29','11:35:00',2.63),('8784','2013-01-29','11:40:00',2.65),('8784','2013-01-29','11:45:00',2.65),('8784','2013-01-29','11:50:00',2.64),('8784','2013-01-29','11:55:00',2.66),('8784','2013-01-29','12:00:00',2.65),('8784','2013-01-29','12:05:00',2.64),('8784','2013-01-29','12:10:00',2.68),('8784','2013-01-29','12:15:00',2.65),('8784','2013-01-29','12:20:00',2.64),('8784','2013-01-29','12:25:00',2.64),('8784','2013-01-29','12:30:00',2.59),('8784','2013-01-29','12:35:00',2.6),('8784','2013-01-29','12:40:00',2.62),('8784','2013-01-29','12:45:00',2.55),('8784','2013-01-29','12:50:00',2.45),('8784','2013-01-29','12:55:00',2.26),('8784','2013-01-29','13:00:00',2.42),('8784','2013-01-29','13:05:00',2.48),('8784','2013-01-29','13:10:00',2.49),('8784','2013-01-29','13:15:00',2.37),('8784','2013-01-29','13:20:00',2.38),('8784','2013-01-29','13:25:00',2.36),('8784','2013-01-29','13:30:00',2.38),('8784','2013-01-29','13:35:00',2.33),('8784','2013-01-29','13:40:00',2.26),('8784','2013-01-29','13:45:00',2.25),('8784','2013-01-29','13:50:00',2.2),('8784','2013-01-29','13:55:00',2.16),('8784','2013-01-29','14:00:00',2.11),('8784','2013-01-29','14:05:00',2.04),('8784','2013-01-29','14:10:00',1.97),('8784','2013-01-29','14:15:00',1.91),('8784','2013-01-29','14:20:00',1.74),('8784','2013-01-29','14:25:00',1.92),('8784','2013-01-29','14:30:00',1.87),('8784','2013-01-29','14:35:00',1.79),('8784','2013-01-29','14:40:00',1.74),('8784','2013-01-29','14:45:00',1.66),('8784','2013-01-29','14:50:00',1.64),('8784','2013-01-29','14:55:00',1.54),('8784','2013-01-29','15:00:00',1.44),('8784','2013-01-29','15:05:00',1.42),('8784','2013-01-29','15:10:00',1.4),('8784','2013-01-29','15:15:00',1.31),('8784','2013-01-29','15:20:00',1.22),('8784','2013-01-29','15:25:00',1.16),('8784','2013-01-29','15:30:00',1.11),('8784','2013-01-29','15:35:00',1.05),('8784','2013-01-28','12:45:00',1.17),('8784','2013-01-28','12:50:00',1.35),('8784','2013-01-28','12:55:00',1.27),('8784','2013-01-28','13:00:00',1.17),('8784','2013-01-28','13:05:00',1.15),('8784','2013-01-28','13:10:00',1.06),('8784','2013-01-28','13:15:00',1.02),('8784','2013-01-28','13:20:00',1.02),('8784','2013-01-28','13:25:00',1.03),('8784','2013-01-27','09:30:00',1.11),('8784','2013-01-27','09:35:00',1.17),('8784','2013-01-27','09:40:00',1.26),('8784','2013-01-27','09:45:00',1.43),('8784','2013-01-27','09:50:00',1.56),('8784','2013-01-27','09:55:00',1.64),('8784','2013-01-27','10:00:00',1.65),('8784','2013-01-27','10:05:00',1.75),('8784','2013-01-27','10:10:00',1.83),('8784','2013-01-27','10:15:00',1.99),('8784','2013-01-27','10:20:00',2.05),('8784','2013-01-27','10:25:00',2.11),('8784','2013-01-27','10:30:00',2.18),('8784','2013-01-27','10:35:00',2.22),('8784','2013-01-27','10:40:00',2.26),('8784','2013-01-27','10:45:00',2.31),('8784','2013-01-27','10:50:00',2.37),('8784','2013-01-27','10:55:00',2.4),('8784','2013-01-27','11:00:00',2.44),('8784','2013-01-27','11:05:00',2.46),('8784','2013-01-27','11:10:00',2.47),('8784','2013-01-27','11:15:00',2.47),('8784','2013-01-27','11:20:00',2.45),('8784','2013-01-27','11:25:00',2.5),('8784','2013-01-27','11:30:00',2.51),('8784','2013-01-27','11:35:00',2.52),('8784','2013-01-27','11:40:00',2.55),('8784','2013-01-27','11:45:00',2.55),('8784','2013-01-27','11:50:00',2.55),('8784','2013-01-27','11:55:00',2.57),('8784','2013-01-27','12:00:00',2.54),('8784','2013-01-27','12:05:00',2.57),('8784','2013-01-27','12:10:00',2.61),('8784','2013-01-27','12:15:00',2.61),('8784','2013-01-27','12:20:00',2.6),('8784','2013-01-27','12:25:00',2.6),('8784','2013-01-27','12:30:00',2.57),('8784','2013-01-27','12:35:00',2.56),('8784','2013-01-27','12:40:00',2.53),('8784','2013-01-27','12:45:00',2.56),('8784','2013-01-27','12:50:00',2.49),('8784','2013-01-27','12:55:00',2.21),('8784','2013-01-27','13:00:00',2.37),('8784','2013-01-27','13:05:00',2.46),('8784','2013-01-27','13:10:00',2.46),('8784','2013-01-27','13:15:00',2.4),('8784','2013-01-27','13:20:00',2.38),('8784','2013-01-27','13:25:00',2.33),('8784','2013-01-27','13:30:00',2.28),('8784','2013-01-27','13:35:00',2.2),('8784','2013-01-27','13:40:00',2.15),('8784','2013-01-27','13:45:00',2.12),('8784','2013-01-27','13:50:00',2.09),('8784','2013-01-27','13:55:00',2.01),('8784','2013-01-27','14:00:00',1.91),('8784','2013-01-27','14:05:00',1.93),('8784','2013-01-27','14:10:00',1.94),('8784','2013-01-27','14:15:00',1.91),('8784','2013-01-27','14:20:00',1.85),('8784','2013-01-27','14:25:00',1.8),('8784','2013-01-27','14:30:00',1.72),('8784','2013-01-27','14:35:00',1.66),('8784','2013-01-27','14:40:00',1.62),('8784','2013-01-27','14:45:00',1.6),('8784','2013-01-27','14:50:00',1.57),('8784','2013-01-27','14:55:00',1.53),('8784','2013-01-27','15:00:00',1.47),('8784','2013-01-27','15:05:00',1.38),('8784','2013-01-27','15:10:00',1.29),('8784','2013-01-27','15:15:00',1.21),('8784','2013-01-27','15:20:00',1.15),('8784','2013-01-27','15:25:00',1.1),('8784','2013-01-27','15:30:00',1.03),('8784','2013-01-26','09:50:00',1.05),('8784','2013-01-26','09:55:00',1.04),('8784','2013-01-26','10:15:00',1.05),('8784','2013-01-26','10:20:00',1.14),('8784','2013-01-26','10:25:00',1.2),('8784','2013-01-26','10:45:00',1.02),('8784','2013-01-26','10:50:00',1.24),('8784','2013-01-26','10:55:00',1.23),('8784','2013-01-26','11:05:00',1.13),('8784','2013-01-26','11:25:00',1.09),('8784','2013-01-26','11:30:00',1.09),('8784','2013-01-26','11:40:00',1.01),('8784','2013-01-26','12:25:00',1.01),('8784','2013-01-25','09:25:00',1.04),('8784','2013-01-25','09:30:00',1.14),('8784','2013-01-25','09:35:00',1.14),('8784','2013-01-25','09:40:00',1.09),('8784','2013-01-25','09:45:00',1.39),('8784','2013-01-25','09:50:00',1.76),('8784','2013-01-25','09:55:00',1.77),('8784','2013-01-25','10:00:00',1.78),('8784','2013-01-25','10:05:00',1.79),('8784','2013-01-25','10:10:00',1.91),('8784','2013-01-25','10:15:00',2),('8784','2013-01-25','10:20:00',2.12),('8784','2013-01-25','10:25:00',2.21),('8784','2013-01-25','10:30:00',1.9),('8784','2013-01-25','10:35:00',1.28),('8784','2013-01-25','10:40:00',2.29),('8784','2013-01-25','10:45:00',2.06),('8784','2013-01-25','10:50:00',1.92),('8784','2013-01-25','10:55:00',2.61),('8784','2013-01-25','11:00:00',1.13),('8784','2013-01-25','11:05:00',1.15),('8784','2013-01-25','11:10:00',2.39),('8784','2013-01-25','11:15:00',2.46),('8784','2013-01-25','11:20:00',2.48),('8784','2013-01-25','11:25:00',2.54),('8784','2013-01-25','11:30:00',2.57),('8784','2013-01-25','11:35:00',2.56),('8784','2013-01-25','11:40:00',2.57),('8784','2013-01-25','11:45:00',2.56),('8784','2013-01-25','11:50:00',2.6),('8784','2013-01-25','11:55:00',2.6),('8784','2013-01-25','12:00:00',2.6),('8784','2013-01-25','12:05:00',2.58),('8784','2013-01-25','12:10:00',2.61),('8784','2013-01-25','12:15:00',2.61),('8784','2013-01-25','12:20:00',2.62),('8784','2013-01-25','12:25:00',2.59),('8784','2013-01-25','12:30:00',2.44),('8784','2013-01-25','12:35:00',2.19),('8784','2013-01-25','12:40:00',2.4),('8784','2013-01-25','12:45:00',2.51),('8784','2013-01-25','12:50:00',2.34),('8784','2013-01-25','12:55:00',2.24),('8784','2013-01-25','13:00:00',2.36),('8784','2013-01-25','13:05:00',2.35),('8784','2013-01-25','13:10:00',2.35),('8784','2013-01-25','13:15:00',2.32),('8784','2013-01-25','13:20:00',2.3),('8784','2013-01-25','13:25:00',2.35),('8784','2013-01-25','13:30:00',2.43),('8784','2013-01-25','13:35:00',2.37),('8784','2013-01-25','13:40:00',2.3),('8784','2013-01-25','13:45:00',2.26),('8784','2013-01-25','13:50:00',2.1),('8784','2013-01-25','13:55:00',2.02),('8784','2013-01-25','14:00:00',2.05),('8784','2013-01-25','14:05:00',1.94),('8784','2013-01-25','14:10:00',1.86),('8784','2013-01-25','14:15:00',1.72),('8784','2013-01-25','14:20:00',1.69),('8784','2013-01-25','14:25:00',1.68),('8784','2013-01-25','14:30:00',1.6),('8784','2013-01-25','14:35:00',1.53),('8784','2013-01-25','14:40:00',1.49),('8784','2013-01-25','14:45:00',1.43),('8784','2013-01-25','14:50:00',1.4),('8784','2013-01-25','14:55:00',1.33),('8784','2013-01-25','15:00:00',1.23),('8784','2013-01-25','15:05:00',1.18),('8784','2013-01-25','15:10:00',1.15),('8784','2013-01-25','15:15:00',1.09),('8784','2013-01-25','15:20:00',1),('8784','2013-01-25','15:30:00',1.06),('8784','2013-01-25','15:35:00',1.08),('8784','2013-01-25','15:40:00',1.04),('8784','2013-01-25','15:45:00',1.03),('8784','2013-01-25','15:50:00',1),('8784','2013-01-24','09:50:00',1.39),('8784','2013-01-24','09:55:00',1.57),('8784','2013-01-24','10:00:00',1.66),('8784','2013-01-24','10:05:00',1.71),('8784','2013-01-24','10:10:00',1.78),('8784','2013-01-24','10:15:00',1.98),('8784','2013-01-24','10:20:00',2.13),('8784','2013-01-24','10:25:00',2.19),('8784','2013-01-24','10:30:00',2.22),('8784','2013-01-24','10:35:00',2.26),('8784','2013-01-24','10:40:00',2.32),('8784','2013-01-24','10:45:00',2.32),('8784','2013-01-24','10:50:00',2.45),('8784','2013-01-24','10:55:00',2),('8784','2013-01-24','11:00:00',1.31),('8784','2013-01-24','12:50:00',1.05),('8784','2013-01-24','12:55:00',1.04),('8784','2013-01-24','13:55:00',1.03),('8784','2013-01-24','14:00:00',1.26),('8784','2013-01-24','14:05:00',1.19),('8784','2013-01-24','14:10:00',1.17),('8784','2013-01-24','14:15:00',1.31),('8784','2013-01-24','14:20:00',2.03),('8784','2013-01-24','14:25:00',2.81),('8784','2013-01-24','14:30:00',2.35),('8784','2013-01-24','14:35:00',1.64),('8784','2013-01-24','14:40:00',1.36),('8784','2013-01-24','14:45:00',1.63),('8784','2013-01-24','14:50:00',1.71),('8784','2013-01-24','14:55:00',1.62),('8784','2013-01-24','15:00:00',1.13),('8784','2013-01-24','15:20:00',1.03),('8784','2013-01-24','15:30:00',1.11),('8784','2013-01-23','09:55:00',1.18),('8784','2013-01-23','10:25:00',1.11),('8784','2013-01-23','10:30:00',2.22),('8784','2013-01-23','10:35:00',2.24),('8784','2013-01-23','10:40:00',1.46),('8784','2013-01-23','10:45:00',1.41),('8784','2013-01-23','10:50:00',2.11),('8784','2013-01-23','10:55:00',1.41),('8784','2013-01-22','09:00:00',1.19),('8784','2013-01-22','09:40:00',1.06),('8784','2013-01-22','09:45:00',1.82),('8784','2013-01-22','09:55:00',1.14),('8784','2013-01-22','10:10:00',1.72),('8784','2013-01-22','10:15:00',1.66),('8784','2013-01-22','10:20:00',2.08),('8784','2013-01-22','10:25:00',2.22),('8784','2013-01-22','10:30:00',2.27),('8784','2013-01-22','10:35:00',2.47),('8784','2013-01-22','10:40:00',2.73),('8784','2013-01-22','10:45:00',2.36),('8784','2013-01-22','10:50:00',1.85),('8784','2013-01-22','10:55:00',1.21),('8784','2013-01-22','11:10:00',1.11),('8784','2013-01-22','11:15:00',1.4),('8784','2013-01-22','11:20:00',1.56),('8784','2013-01-22','11:45:00',1.58),('8784','2013-01-22','11:50:00',1.84),('8784','2013-01-22','12:10:00',2.52),('8784','2013-01-22','12:15:00',2.19),('8784','2013-01-22','12:20:00',1.72),('8784','2013-01-22','12:25:00',1.99),('8784','2013-01-22','12:30:00',1.03),('8784','2013-01-22','12:35:00',1.19),('8784','2013-01-22','12:40:00',2.58),('8784','2013-01-22','12:50:00',1.25),('8784','2013-01-22','13:00:00',2.31),('8784','2013-01-22','13:05:00',2.9),('8784','2013-01-22','13:10:00',2.08),('8784','2013-01-22','13:15:00',1.32),('8784','2013-01-22','13:20:00',1.93),('8784','2013-01-22','13:40:00',1.05),('8784','2013-01-22','13:45:00',1.24),('8784','2013-01-22','13:50:00',1.1),('8784','2013-01-22','14:10:00',1.4),('8784','2013-01-22','14:15:00',1.24),('8784','2013-01-22','14:20:00',1.05),('8784','2013-01-22','14:25:00',1.54),('8784','2013-01-22','14:35:00',1.39),('8784','2013-01-22','14:40:00',1.16),('8784','2013-01-22','14:45:00',1.54),('8784','2013-01-22','14:50:00',1.04),('8784','2014-03-20','07:35:00',1.02),('8784','2014-03-20','07:40:00',1.15),('8784','2014-03-20','07:45:00',1.23),('8784','2014-03-20','07:50:00',1.3),('8784','2014-03-20','07:55:00',1.38),('8784','2014-03-20','08:00:00',1.46),('8784','2014-03-20','08:05:00',1.53),('8784','2014-03-20','08:10:00',1.56),('8784','2014-03-20','08:15:00',1.65),('8784','2014-03-20','08:20:00',1.67),('8784','2014-03-20','08:25:00',1.75),('8784','2014-03-20','08:30:00',1.82),('8784','2014-03-20','08:35:00',1.97),('8784','2014-03-20','08:40:00',2.08),('8784','2014-03-20','08:45:00',2.16),('8784','2014-03-20','08:50:00',2.17),('8784','2014-03-20','08:55:00',2.29),('8784','2014-03-20','09:00:00',2.34),('8784','2014-03-20','09:05:00',2.45),('8784','2014-03-20','09:10:00',2.53),('8784','2014-03-20','09:15:00',2.58),('8784','2014-03-20','09:20:00',2.65),('8784','2014-03-20','09:25:00',2.68),('8784','2014-03-20','09:30:00',2.73),('8784','2014-03-20','09:35:00',2.82),('8784','2014-03-20','09:40:00',2.84),('8784','2014-03-20','09:45:00',2.87),('8784','2014-03-20','09:50:00',2.83),('8784','2014-03-20','09:55:00',2.91),('8784','2014-03-20','10:00:00',3.03),('8784','2014-03-20','10:05:00',3.18),('8784','2014-03-20','10:10:00',3.2),('8784','2014-03-20','10:15:00',3.15),('8784','2014-03-20','10:20:00',3.2),('8784','2014-03-20','10:25:00',3.27),('8784','2014-03-20','10:30:00',3.29),('8784','2014-03-20','10:35:00',3.18),('8784','2014-03-20','10:40:00',3.13),('8784','2014-03-20','10:45:00',3.18),('8784','2014-03-20','10:50:00',3.39),('8784','2014-03-20','10:55:00',3.59),('8784','2014-03-20','11:00:00',3.64),('8784','2014-03-20','11:05:00',3.59),('8784','2014-03-20','11:10:00',3.56),('8784','2014-03-20','11:15:00',3.38),('8784','2014-03-20','11:20:00',3.57),('8784','2014-03-20','11:25:00',3.58),('8784','2014-03-20','11:30:00',3.66),('8784','2014-03-20','11:35:00',3.78),('8784','2014-03-20','11:40:00',3.71),('8784','2014-03-20','11:45:00',3.71),('8784','2014-03-20','11:50:00',3.75),('8784','2014-03-20','11:55:00',3.46),('8784','2014-03-20','12:00:00',3.28),('8784','2014-03-20','12:05:00',3.54),('8784','2014-03-20','12:10:00',3.71),('8784','2014-03-20','12:15:00',3.75),('8784','2014-03-20','12:20:00',3.63),('8784','2014-03-20','12:25:00',3.5),('8784','2014-03-20','12:30:00',3.63),('8784','2014-03-20','12:35:00',3.68),('8784','2014-03-20','12:40:00',3.68),('8784','2014-03-20','12:45:00',3.75),('8784','2014-03-20','12:50:00',3.72),('8784','2014-03-20','12:55:00',3.7),('8784','2014-03-20','13:00:00',3.64),('8784','2014-03-20','13:05:00',3.6),('8784','2014-03-20','13:10:00',3.52),('8784','2014-03-20','13:15:00',3.46),('8784','2014-03-20','13:20:00',3.5),('8784','2014-03-20','13:25:00',3.39),('8784','2014-03-20','13:30:00',3.46),('8784','2014-03-20','13:35:00',3.35),('8784','2014-03-20','13:40:00',3.18),('8784','2014-03-20','13:45:00',3.04),('8784','2014-03-20','13:50:00',2.93),('8784','2014-03-20','13:55:00',2.75),('8784','2014-03-20','14:00:00',2.89),('8784','2014-03-20','14:05:00',3.1),('8784','2014-03-20','14:10:00',2.99),('8784','2014-03-20','14:15:00',2.81),('8784','2014-03-20','14:20:00',2.75),('8784','2014-03-20','14:25:00',2.78),('8784','2014-03-20','14:30:00',2.32),('8784','2014-03-20','14:35:00',2.17),('8784','2014-03-20','14:40:00',2.43),('8784','2014-03-20','14:45:00',2.38),('8784','2014-03-20','14:50:00',2.25),('8784','2014-03-20','14:55:00',2.19),('8784','2014-03-20','15:00:00',2),('8784','2014-03-20','15:05:00',2),('8784','2014-03-20','15:10:00',2.03),('8784','2014-03-20','15:15:00',1.95),('8784','2014-03-20','15:20:00',2.07),('8784','2014-03-20','15:25:00',1.85),('8784','2014-03-20','15:30:00',1.79),('8784','2014-03-20','15:35:00',1.72),('8784','2014-03-20','15:40:00',1.58),('8784','2014-03-20','15:45:00',1.58),('8784','2014-03-20','15:50:00',1.39),('8784','2014-03-20','15:55:00',1.26),('8784','2014-03-20','16:00:00',1.08),('8784','2014-03-20','16:10:00',1),('8784','2014-03-20','16:25:00',1.04),('8784','2013-01-21','11:10:00',1.19),('8784','2013-01-21','11:15:00',1.29),('8784','2013-01-21','11:20:00',1.1),('8784','2013-01-21','11:25:00',1.03),('8784','2013-01-21','11:50:00',1.68),('8784','2013-01-21','11:55:00',2.79),('8784','2013-01-21','12:00:00',2.44),('8784','2013-01-21','12:05:00',2.44),('8784','2013-01-21','12:10:00',2.5),('8784','2013-01-21','12:15:00',1.74),('8784','2013-01-21','12:25:00',1.63),('8784','2013-01-21','12:40:00',1.05),('8784','2013-01-21','12:50:00',1.32),('8784','2013-01-21','13:05:00',1.87),('8784','2013-01-21','13:10:00',1.44),('8784','2013-01-21','13:30:00',2.91),('8784','2013-01-21','13:35:00',2.55),('8784','2013-01-21','13:40:00',2.12),('8784','2013-01-21','13:50:00',1.93),('8784','2013-01-21','13:55:00',2.69),('8784','2013-01-21','14:00:00',1.89),('8784','2013-01-21','14:05:00',2.43),('8784','2013-01-21','14:10:00',2.02),('8784','2013-01-21','14:15:00',1.41),('8784','2013-01-21','14:20:00',1.9),('8784','2013-01-21','14:25:00',1.89),('8784','2013-01-21','14:30:00',1.26),('8784','2013-01-20','10:50:00',1),('8784','2013-01-20','10:55:00',1.07),('8784','2013-01-20','11:00:00',1.19),('8784','2013-01-20','11:05:00',1.24),('8784','2013-01-20','11:10:00',1.33),('8784','2013-01-20','11:15:00',1.69),('8784','2013-01-20','11:20:00',1.37),('8784','2013-01-20','11:25:00',1.78),('8784','2013-01-20','11:30:00',2.21),('8784','2013-01-20','11:35:00',1.79),('8784','2013-01-20','11:40:00',1.11),('8784','2013-01-20','11:45:00',1.05),('8784','2013-01-20','12:25:00',1.03),('8784','2013-01-19','09:50:00',1.08),('8784','2013-01-19','09:55:00',1.41),('8784','2013-01-19','10:00:00',1.37),('8784','2013-01-19','10:05:00',1.1),('8784','2013-01-19','10:40:00',1.15),('8784','2013-01-19','10:45:00',1.38),('8784','2013-01-19','10:50:00',1.36),('8784','2013-01-19','11:20:00',1.23),('8784','2013-01-19','11:25:00',1.22),('8784','2013-01-18','10:15:00',2.04),('8784','2013-01-18','10:20:00',2.29),('8784','2013-01-18','10:25:00',1.61),('8784','2013-01-18','10:30:00',1.3),('8784','2013-01-18','10:35:00',1.08),('8784','2013-01-18','11:30:00',1.11),('8784','2013-01-18','11:35:00',1.29),('8784','2013-01-18','11:40:00',1.19),('8784','2013-01-18','12:10:00',1.1),('8784','2013-01-18','12:15:00',1.11),('8784','2013-01-18','12:20:00',1.1),('8784','2013-01-18','12:25:00',1.13),('8784','2013-01-18','12:30:00',1.13),('8784','2013-01-18','12:35:00',1.33),('8784','2013-01-18','12:40:00',1.42),('8784','2013-01-18','12:45:00',1.5),('8784','2013-01-18','12:50:00',1.9),('8784','2013-01-18','12:55:00',2.06),('8784','2013-01-18','13:00:00',2.54),('8784','2013-01-18','13:05:00',2.44),('8784','2013-01-18','13:10:00',2.22),('8784','2013-01-18','13:15:00',2.4),('8784','2013-01-18','13:20:00',1.9),('8784','2013-01-18','13:25:00',1.52),('8784','2013-01-18','13:30:00',1.43),('8784','2013-01-18','13:35:00',1.33),('8784','2013-01-18','13:40:00',1.51),('8784','2013-01-18','13:45:00',2.56),('8784','2013-01-18','13:50:00',2.63),('8784','2013-01-18','13:55:00',2.52),('8784','2013-01-18','14:00:00',2.5),('8784','2013-01-18','14:05:00',2.52),('8784','2013-01-18','14:10:00',1.64),('8784','2013-01-18','14:15:00',2.23),('8784','2013-01-18','14:20:00',1.83),('8784','2013-01-18','14:25:00',1.59),('8784','2013-01-18','14:30:00',1.21),('8784','2013-01-18','14:35:00',1.02),('8784','2013-01-17','09:50:00',1.04),('8784','2013-01-17','09:55:00',1.02),('8784','2013-01-17','10:10:00',1.14),('8784','2013-01-17','10:15:00',1.3),('8784','2013-01-17','10:20:00',1.27),('8784','2013-01-17','10:25:00',1.56),('8784','2013-01-17','10:30:00',1.62),('8784','2013-01-17','10:35:00',1.52),('8784','2013-01-17','10:40:00',1.5),('8784','2013-01-17','10:45:00',1.58),('8784','2013-01-17','10:50:00',1.52),('8784','2013-01-17','10:55:00',1.72),('8784','2013-01-17','11:00:00',1.56),('8784','2013-01-17','11:05:00',1.56),('8784','2013-01-17','11:10:00',1.81),('8784','2013-01-17','11:15:00',1.72),('8784','2013-01-17','11:20:00',1.62),('8784','2013-01-17','11:25:00',1.42),('8784','2013-01-17','11:30:00',1.28),('8784','2013-01-17','11:35:00',1.43),('8784','2013-01-17','11:40:00',1.47),('8784','2013-01-17','11:45:00',1.34),('8784','2013-01-17','11:50:00',1.44),('8784','2013-01-17','11:55:00',1.54),('8784','2013-01-17','12:00:00',1.7),('8784','2013-01-17','12:05:00',1.7),('8784','2013-01-17','12:10:00',1.77),('8784','2013-01-17','12:15:00',1.88),('8784','2013-01-17','12:20:00',1.78),('8784','2013-01-17','12:25:00',1.6),('8784','2013-01-17','12:30:00',1.33),('8784','2013-01-17','12:35:00',1.59),('8784','2013-01-17','12:40:00',1.62),('8784','2013-01-17','12:45:00',1.39),('8784','2013-01-17','12:55:00',1.11),('8784','2013-01-17','13:00:00',1.51),('8784','2013-01-17','13:05:00',1.42),('8784','2013-01-17','13:10:00',1.15),('8784','2013-01-17','13:15:00',1.43),('8784','2013-01-17','13:20:00',1.45),('8784','2013-01-17','13:25:00',1.25),('8784','2013-01-17','13:30:00',1.15),('8784','2013-01-17','13:35:00',1.51),('8784','2013-01-17','13:40:00',1.54),('8784','2013-01-17','13:45:00',1.42),('8784','2013-01-17','13:50:00',1.34),('8784','2013-01-17','14:00:00',1.34),('8784','2013-01-17','14:05:00',1.02),('8784','2013-01-17','14:30:00',1.19),('8784','2013-01-17','14:35:00',1.6),('8784','2013-01-16','10:35:00',1.61),('8784','2013-01-16','10:40:00',1.82),('8784','2013-01-16','10:45:00',1.72),('8784','2013-01-16','10:55:00',1.69),('8784','2013-01-16','11:25:00',1.56),('8784','2013-01-16','12:00:00',1.72),('8784','2013-01-16','12:05:00',1.33),('8784','2013-01-16','12:10:00',1.78),('8784','2013-01-16','12:15:00',3.11),('8784','2013-01-16','12:20:00',2.65),('8784','2013-01-16','13:05:00',2.24),('8784','2013-01-16','13:10:00',3.17),('8784','2013-01-16','13:15:00',3.35),('8784','2013-01-16','13:20:00',2.29),('8784','2013-01-16','13:25:00',1.51),('8784','2013-01-16','13:55:00',2.66),('8784','2013-01-16','14:00:00',1.85),('8784','2013-01-16','14:05:00',1.33),('8784','2013-01-15','10:00:00',1.02),('8784','2013-01-15','10:10:00',1.14),('8784','2013-01-15','10:25:00',1.02),('8784','2013-01-15','10:45:00',1.07),('8784','2013-01-15','10:50:00',1.33),('8784','2013-01-15','10:55:00',1.47),('8784','2013-01-15','11:00:00',1.45),('8784','2013-01-15','11:05:00',1.51),('8784','2013-01-15','11:10:00',1.55),('8784','2013-01-15','11:15:00',1.46),('8784','2013-01-15','11:20:00',1.49),('8784','2013-01-15','11:25:00',1.48),('8784','2013-01-15','11:30:00',1.43),('8784','2013-01-15','11:35:00',1.35),('8784','2013-01-15','11:40:00',1.21),('8784','2013-01-15','11:45:00',1.14),('8784','2013-01-15','11:50:00',1.09),('8784','2013-01-15','11:55:00',1.17),('8784','2013-01-15','12:00:00',1.11),('8784','2013-01-15','12:05:00',1.05),('8784','2013-01-15','12:10:00',1.02),('8784','2013-01-15','12:15:00',1.16),('8784','2013-01-15','12:20:00',1.31),('8784','2013-01-15','12:25:00',1.29),('8784','2013-01-15','12:30:00',1.23),('8784','2013-01-15','12:35:00',1.24),('8784','2013-01-15','12:40:00',1.37),('8784','2013-01-15','12:45:00',1.4),('8784','2013-01-15','12:50:00',1.42),('8784','2013-01-15','12:55:00',1.21),('8784','2013-01-15','13:00:00',1.01),('8784','2013-01-15','13:05:00',1.07),('8784','2013-01-15','13:10:00',1.08),('8784','2013-01-15','13:15:00',1.11),('8784','2013-01-15','13:20:00',1.11),('8784','2013-01-15','13:25:00',1.08),('8784','2013-01-15','13:30:00',1.18),('8784','2013-01-15','13:35:00',1.21),('8784','2013-01-15','13:40:00',1.37),('8784','2013-01-15','13:45:00',1.25),('8784','2013-01-15','13:50:00',1.19),('8784','2013-01-15','13:55:00',1.38),('8784','2013-01-15','14:00:00',2),('8784','2013-01-15','14:05:00',1.86),('8784','2013-01-15','14:10:00',1.47),('8784','2013-01-15','14:15:00',2.3),('8784','2013-01-15','14:20:00',2.36),('8784','2013-01-15','14:25:00',1.91),('8784','2013-01-15','14:30:00',1.91),('8784','2013-01-15','14:35:00',1.38),('8784','2013-01-15','14:40:00',1.13),('8784','2013-01-15','14:45:00',1.4),('8784','2013-01-15','14:50:00',1.15),('8784','2013-01-15','14:55:00',1.36),('8784','2013-01-15','15:00:00',1.36),('8784','2013-01-15','15:05:00',1.16),('8784','2013-01-14','12:45:00',1.1),('8784','2013-01-14','12:50:00',1.23),('8784','2013-01-14','12:55:00',1.21),('8784','2013-01-14','13:00:00',1.25),('8784','2013-01-14','13:05:00',1.21),('8784','2013-01-14','15:15:00',1.09),('8784','2013-01-13','09:15:00',1.05),('8784','2013-01-13','09:20:00',1.1),('8784','2013-01-13','09:25:00',1.03),('8784','2013-01-13','09:30:00',1.07),('8784','2013-01-13','09:35:00',1.05),('8784','2013-01-13','10:00:00',1.03),('8784','2013-01-13','10:05:00',1.49),('8784','2013-01-13','10:20:00',1.26),('8784','2013-01-13','10:25:00',1.33),('8784','2013-01-13','10:30:00',1.72),('8784','2013-01-12','09:50:00',1.11),('8784','2013-01-12','09:55:00',1.25),('8784','2013-01-12','10:00:00',1.31),('8784','2013-01-12','10:05:00',1.32),('8784','2013-01-12','10:10:00',1.35),('8784','2013-01-12','10:15:00',1.5),('8784','2013-01-12','10:20:00',1.64),('8784','2013-01-12','10:25:00',1.73),('8784','2013-01-12','10:30:00',1.79),('8784','2013-01-12','10:35:00',1.83),('8784','2013-01-12','10:40:00',1.88),('8784','2013-01-12','10:45:00',1.94),('8784','2013-01-12','10:50:00',1.96),('8784','2013-01-12','10:55:00',1.99),('8784','2013-01-12','11:00:00',2.02),('8784','2013-01-12','11:05:00',2.08),('8784','2013-01-12','11:10:00',2.11),('8784','2013-01-12','11:15:00',2),('8784','2013-01-12','11:20:00',2.06),('8784','2013-01-12','11:25:00',2.05),('8784','2013-01-12','11:30:00',2.07),('8784','2013-01-12','11:35:00',2.05),('8784','2013-01-12','11:40:00',2.07),('8784','2013-01-12','11:45:00',2.1),('8784','2013-01-12','11:50:00',2.1),('8784','2013-01-12','11:55:00',2.09),('8784','2013-01-12','12:00:00',2.14),('8784','2013-01-12','12:05:00',2.1),('8784','2013-01-12','12:10:00',2.07),('8784','2013-01-12','12:15:00',2.04),('8784','2013-01-12','12:20:00',2.06),('8784','2013-01-12','12:25:00',2.05),('8784','2013-01-12','12:30:00',2.03),('8784','2013-01-12','12:35:00',2.08),('8784','2013-01-12','12:40:00',1.75),('8784','2013-01-12','12:45:00',1.32),('8784','2013-01-12','12:50:00',1.64),('8784','2013-01-12','13:00:00',1.87),('8784','2013-01-12','13:05:00',2.09),('8784','2013-01-12','13:10:00',1.82),('8784','2013-01-12','13:15:00',1.18),('8784','2013-01-12','13:25:00',1.4),('8784','2013-01-12','13:30:00',1.71),('8784','2013-01-12','13:35:00',1.03),('8784','2013-01-12','13:45:00',1.35),('8784','2013-01-12','13:50:00',1.86),('8784','2013-01-12','13:55:00',2.17),('8784','2013-01-12','14:00:00',1.45),('8784','2013-01-12','14:05:00',1.85),('8784','2013-01-12','14:10:00',1.69),('8784','2013-01-12','14:15:00',1.25),('8784','2013-01-12','14:20:00',1.42),('8784','2013-01-12','14:25:00',1.42),('8784','2013-01-12','14:30:00',1.37),('8784','2013-01-12','14:35:00',1.34),('8784','2013-01-12','14:40:00',1.25),('8784','2013-01-12','14:45:00',1.19),('8784','2013-01-12','14:50:00',1.08),('8784','2013-01-12','14:55:00',1.11),('8784','2013-01-12','15:00:00',1.04),('8784','2014-03-19','08:50:00',1.01),('8784','2014-03-19','08:55:00',1.05),('8784','2014-03-19','09:00:00',1.09),('8784','2014-03-19','09:05:00',1.32),('8784','2014-03-19','09:10:00',1.44),('8784','2014-03-19','09:15:00',1.72),('8784','2014-03-19','09:20:00',1.65),('8784','2014-03-19','09:25:00',2.7),('8784','2014-03-19','09:30:00',3.41),('8784','2014-03-19','09:35:00',3.21),('8784','2014-03-19','09:40:00',3.14),('8784','2014-03-19','09:45:00',2.81),('8784','2014-03-19','09:50:00',2.88),('8784','2014-03-19','09:55:00',2.03),('8784','2014-03-19','10:00:00',1.41),('8784','2014-03-19','10:05:00',1.07),('8784','2014-03-19','10:25:00',1.11),('8784','2014-03-19','10:30:00',1.43),('8784','2014-03-19','10:35:00',2.77),('8784','2014-03-19','10:40:00',1.96),('8784','2014-03-19','10:45:00',1.81),('8784','2014-03-19','10:50:00',1.63),('8784','2014-03-19','10:55:00',1.69),('8784','2014-03-19','11:00:00',3.61),('8784','2014-03-19','11:05:00',3.68),('8784','2014-03-19','11:10:00',1.93),('8784','2014-03-19','11:15:00',1.81),('8784','2014-03-19','11:20:00',1.74),('8784','2014-03-19','11:25:00',1.88),('8784','2014-03-19','11:30:00',1.82),('8784','2014-03-19','11:35:00',2.3),('8784','2014-03-19','11:40:00',2.03),('8784','2014-03-19','11:45:00',1.97),('8784','2014-03-19','11:50:00',1.83),('8784','2014-03-19','11:55:00',1.88),('8784','2014-03-19','12:00:00',2.94),('8784','2014-03-19','12:05:00',4.16),('8784','2014-03-19','12:10:00',4.17),('8784','2014-03-19','12:15:00',4.22),('8784','2014-03-19','12:20:00',4.27),('8784','2014-03-19','12:25:00',3.8),('8784','2014-03-19','12:30:00',3.73),('8784','2014-03-19','12:35:00',3.63),('8784','2014-03-19','12:40:00',3.76),('8784','2014-03-19','12:45:00',3.91),('8784','2014-03-19','12:50:00',3.61),('8784','2014-03-19','12:55:00',3.29),('8784','2014-03-19','13:00:00',3.7),('8784','2014-03-19','13:05:00',3.6),('8784','2014-03-19','13:10:00',3.63),('8784','2014-03-19','13:15:00',3.5),('8784','2014-03-19','13:20:00',3.26),('8784','2014-03-19','13:25:00',3.12),('8784','2014-03-19','13:30:00',3.51),('8784','2014-03-19','13:35:00',3.62),('8784','2014-03-19','13:40:00',3.43),('8784','2014-03-19','13:45:00',3.35),('8784','2014-03-19','13:50:00',3.25),('8784','2014-03-19','13:55:00',3.41),('8784','2014-03-19','14:00:00',3.28),('8784','2014-03-19','14:05:00',3.3),('8784','2014-03-19','14:10:00',3.22),('8784','2014-03-19','14:15:00',3.13),('8784','2014-03-19','14:20:00',3.08),('8784','2014-03-19','14:25:00',3.02),('8784','2014-03-19','14:30:00',2.93),('8784','2014-03-19','14:35:00',2.97),('8784','2014-03-19','14:40:00',2.91),('8784','2014-03-19','14:45:00',2.84),('8784','2014-03-19','14:50:00',2.74),('8784','2014-03-19','14:55:00',2.7),('8784','2014-03-19','15:00:00',2.61),('8784','2014-03-19','15:05:00',2.55),('8784','2014-03-19','15:10:00',2.51),('8784','2014-03-19','15:15:00',2.46),('8784','2014-03-19','15:20:00',2.36),('8784','2014-03-19','15:25:00',2.32),('8784','2014-03-19','15:30:00',2.21),('8784','2014-03-19','15:35:00',2.09),('8784','2014-03-19','15:40:00',2.09),('8784','2014-03-19','15:45:00',2.01),('8784','2014-03-19','15:50:00',1.91),('8784','2014-03-19','15:55:00',1.87),('8784','2014-03-19','16:00:00',1.75),('8784','2014-03-19','16:05:00',1.69),('8784','2014-03-19','16:10:00',1.62),('8784','2014-03-19','16:15:00',1.52),('8784','2014-03-19','16:20:00',1.43),('8784','2014-03-19','16:25:00',1.29),('8784','2014-03-19','16:30:00',1.23),('8784','2014-03-19','16:35:00',1.1),('8784','2014-03-19','16:40:00',1.02),('8784','2013-01-11','10:05:00',1.11),('8784','2013-01-11','10:10:00',1.09),('8784','2013-01-11','10:15:00',1.29),('8784','2013-01-11','10:20:00',1.31),('8784','2013-01-11','10:25:00',1.75),('8784','2013-01-11','10:30:00',1.7),('8784','2013-01-11','10:35:00',1.78),('8784','2013-01-11','10:40:00',1.83),('8784','2013-01-11','10:45:00',1.89),('8784','2013-01-11','10:50:00',1.9),('8784','2013-01-11','10:55:00',1.94),('8784','2013-01-11','11:00:00',1.96),('8784','2013-01-11','11:05:00',2.03),('8784','2013-01-11','11:10:00',2.07),('8784','2013-01-11','11:15:00',2.02),('8784','2013-01-11','11:20:00',1.95),('8784','2013-01-11','11:25:00',1.28),('8784','2013-01-11','11:30:00',1.17),('8784','2013-01-11','11:35:00',1.32),('8784','2013-01-11','11:40:00',1.2),('8784','2013-01-11','11:45:00',1.46),('8784','2013-01-11','11:50:00',1.4),('8784','2013-01-11','11:55:00',1.25),('8784','2013-01-11','12:00:00',1.06),('8784','2013-01-11','12:55:00',1.93),('8784','2013-01-11','13:00:00',1.4),('8784','2013-01-11','13:05:00',1.14),('8784','2013-01-11','13:10:00',1.74),('8784','2013-01-11','13:15:00',1.13),('8784','2013-01-11','13:30:00',1.14),('8784','2013-01-11','13:35:00',2.33),('8784','2013-01-11','13:40:00',1.54),('8784','2013-01-11','13:45:00',1.17),('8784','2013-01-11','14:20:00',1.41),('8784','2013-01-11','14:25:00',1.15),('8784','2013-01-11','14:45:00',1.24),('8784','2013-01-11','14:50:00',1.35),('8784','2013-01-11','15:00:00',1.23),('8784','2013-01-11','15:05:00',1.1),('8784','2013-01-10','11:30:00',1.08),('8784','2013-01-10','11:55:00',1.26),('8784','2013-01-10','12:00:00',1.28),('8784','2013-01-10','12:05:00',1.26),('8784','2013-01-10','12:10:00',1.11),('8784','2013-01-09','10:40:00',1.01),('8784','2013-01-09','10:45:00',1.1),('8784','2013-01-09','10:50:00',1.14),('8784','2013-01-09','10:55:00',1.25),('8784','2013-01-09','11:00:00',1.01),('8784','2013-01-09','11:05:00',1.13),('8784','2013-01-09','11:10:00',1.58),('8784','2013-01-09','11:15:00',1.63),('8784','2013-01-09','11:20:00',1.34),('8784','2013-01-09','11:25:00',1.22),('8784','2013-01-09','11:30:00',1.21),('8784','2013-01-09','11:35:00',1.24),('8784','2013-01-09','11:40:00',1.17),('8784','2013-01-09','11:45:00',1.15),('8784','2013-01-09','11:50:00',1.23),('8784','2013-01-09','11:55:00',1.32),('8784','2013-01-09','12:00:00',1.18),('8784','2013-01-09','12:05:00',1.19),('8784','2013-01-09','12:10:00',1.2),('8784','2013-01-09','12:15:00',1.18),('8784','2013-01-09','12:20:00',1.17),('8784','2013-01-09','12:25:00',1.05),('8784','2013-01-09','12:30:00',1.03),('8784','2013-01-09','12:35:00',1.09),('8784','2013-01-09','12:40:00',1.05),('8784','2013-01-09','12:45:00',1.04),('8784','2013-01-09','12:50:00',1.1),('8784','2013-01-09','12:55:00',1.22),('8784','2013-01-09','13:00:00',1.23),('8784','2013-01-09','13:05:00',1.23),('8784','2013-01-09','13:10:00',1.33),('8784','2013-01-09','13:15:00',1.2),('8784','2013-01-09','13:20:00',1),('8784','2013-01-08','09:45:00',1.07),('8784','2013-01-08','09:50:00',1.38),('8784','2013-01-08','09:55:00',1.46),('8784','2013-01-08','10:00:00',1.42),('8784','2013-01-08','10:05:00',1.34),('8784','2013-01-08','10:10:00',1.34),('8784','2013-01-08','10:15:00',1.38),('8784','2013-01-08','10:20:00',1.4),('8784','2013-01-08','10:25:00',1.56),('8784','2013-01-08','10:30:00',1.59),('8784','2013-01-08','10:35:00',1.71),('8784','2013-01-08','10:40:00',1.89),('8784','2013-01-08','10:45:00',1.83),('8784','2013-01-08','10:50:00',1.83),('8784','2013-01-08','10:55:00',1.91),('8784','2013-01-08','11:00:00',1.92),('8784','2013-01-08','11:05:00',2.01),('8784','2013-01-08','11:10:00',2.05),('8784','2013-01-08','11:15:00',1.96),('8784','2013-01-08','11:20:00',2.03),('8784','2013-01-08','11:25:00',2.05),('8784','2013-01-08','11:30:00',2.05),('8784','2013-01-08','11:35:00',2.07),('8784','2013-01-08','11:40:00',2.09),('8784','2013-01-08','11:45:00',2.59),('8784','2013-01-08','11:50:00',1.96),('8784','2013-01-08','11:55:00',1.65),('8784','2013-01-08','12:00:00',1.58),('8784','2013-01-08','12:05:00',1.51),('8784','2013-01-08','12:10:00',1.6),('8784','2013-01-08','12:15:00',1.51),('8784','2013-01-08','12:20:00',1.32),('8784','2013-01-08','12:25:00',1.28),('8784','2013-01-08','12:30:00',1.23),('8784','2013-01-08','12:35:00',1.19),('8784','2013-01-08','12:40:00',1.49),('8784','2013-01-08','12:45:00',1.79),('8784','2013-01-08','12:50:00',1.89),('8784','2013-01-08','12:55:00',1.35),('8784','2013-01-08','13:40:00',1.01),('8784','2013-01-08','13:45:00',1.18),('8784','2013-01-08','13:50:00',1.48),('8784','2013-01-08','13:55:00',2.16),('8784','2013-01-08','14:00:00',1.19),('8784','2013-01-08','14:05:00',1.12),('8784','2013-01-08','14:40:00',1.03),('8784','2013-01-07','09:50:00',1.03),('8784','2013-01-07','09:55:00',1.18),('8784','2013-01-07','10:00:00',1.26),('8784','2013-01-07','10:05:00',1.32),('8784','2013-01-07','10:10:00',1.35),('8784','2013-01-07','10:15:00',1.5),('8784','2013-01-07','10:20:00',1.65),('8784','2013-01-07','10:25:00',1.68),('8784','2013-01-07','10:30:00',1.76),('8784','2013-01-07','10:35:00',1.81),('8784','2013-01-07','10:40:00',1.87),('8784','2013-01-07','10:45:00',1.91),('8784','2013-01-07','10:50:00',1.95),('8784','2013-01-07','10:55:00',1.97),('8784','2013-01-07','11:00:00',1.99),('8784','2013-01-07','11:05:00',2.03),('8784','2013-01-07','11:10:00',2.06),('8784','2013-01-07','11:15:00',2.03),('8784','2013-01-07','11:20:00',2.02),('8784','2013-01-07','11:25:00',2.02),('8784','2013-01-07','11:30:00',2.01),('8784','2013-01-07','11:35:00',2.05),('8784','2013-01-07','11:40:00',2.06),('8784','2013-01-07','11:45:00',2.05),('8784','2013-01-07','11:50:00',2.06),('8784','2013-01-07','11:55:00',2.02),('8784','2013-01-07','12:00:00',2.04),('8784','2013-01-07','12:05:00',2.03),('8784','2013-01-07','12:10:00',2.04),('8784','2013-01-07','12:15:00',2.01),('8784','2013-01-07','12:20:00',2.04),('8784','2013-01-07','12:25:00',2.06),('8784','2013-01-07','12:30:00',2.05),('8784','2013-01-07','12:35:00',1.99),('8784','2013-01-07','12:40:00',1.98),('8784','2013-01-07','12:45:00',1.94),('8784','2013-01-07','12:50:00',1.93),('8784','2013-01-07','12:55:00',1.95),('8784','2013-01-07','13:00:00',1.93),('8784','2013-01-07','13:05:00',1.91),('8784','2013-01-07','13:10:00',1.83),('8784','2013-01-07','13:15:00',1.83),('8784','2013-01-07','13:20:00',1.81),('8784','2013-01-07','13:25:00',1.77),('8784','2013-01-07','13:30:00',1.76),('8784','2013-01-07','13:35:00',1.68),('8784','2013-01-07','13:40:00',1.63),('8784','2013-01-07','13:45:00',1.64),('8784','2013-01-07','13:50:00',1.57),('8784','2013-01-07','13:55:00',1.55),('8784','2013-01-07','14:00:00',1.53),('8784','2013-01-07','14:05:00',1.49),('8784','2013-01-07','14:10:00',1.41),('8784','2013-01-07','14:15:00',1.39),('8784','2013-01-07','14:20:00',1.34),('8784','2013-01-07','14:25:00',1.21),('8784','2013-01-07','14:30:00',1.29),('8784','2013-01-07','14:35:00',1.17),('8784','2013-01-07','14:40:00',1.12),('8784','2013-01-07','14:45:00',1.14),('8784','2013-01-07','14:50:00',1.11),('8784','2013-01-07','14:55:00',1.05),('8784','2013-01-06','09:50:00',1.07),('8784','2013-01-06','09:55:00',1.2),('8784','2013-01-06','10:00:00',1.26),('8784','2013-01-06','10:05:00',1.28),('8784','2013-01-06','10:10:00',1.32),('8784','2013-01-06','10:15:00',1.45),('8784','2013-01-06','10:20:00',1.57),('8784','2013-01-06','10:25:00',1.67),('8784','2013-01-06','10:30:00',1.76),('8784','2013-01-06','10:35:00',1.81),('8784','2013-01-06','10:40:00',1.87),('8784','2013-01-06','10:45:00',1.9),('8784','2013-01-06','10:50:00',1.93),('8784','2013-01-06','10:55:00',1.98),('8784','2013-01-06','11:00:00',1.58),('8784','2013-01-06','11:05:00',2.03),('8784','2013-01-06','11:10:00',2.05),('8784','2013-01-06','11:15:00',2.01),('8784','2013-01-06','11:20:00',2),('8784','2013-01-06','11:25:00',1.98),('8784','2013-01-06','11:30:00',2),('8784','2013-01-06','11:35:00',2.03),('8784','2013-01-06','11:40:00',2.05),('8784','2013-01-06','11:45:00',2.05),('8784','2013-01-06','11:50:00',2.07),('8784','2013-01-06','11:55:00',2.05),('8784','2013-01-06','12:00:00',2.07),('8784','2013-01-06','12:05:00',2.01),('8784','2013-01-06','12:10:00',1.96),('8784','2013-01-06','12:15:00',2.02),('8784','2013-01-06','12:20:00',2.02),('8784','2013-01-06','12:25:00',2.01),('8784','2013-01-06','12:30:00',2),('8784','2013-01-06','12:35:00',1.94),('8784','2013-01-06','12:40:00',1.93),('8784','2013-01-06','12:45:00',1.9),('8784','2013-01-06','12:50:00',1.95),('8784','2013-01-06','12:55:00',1.98),('8784','2013-01-06','13:00:00',1.96),('8784','2013-01-06','13:05:00',1.91),('8784','2013-01-06','13:10:00',1.81),('8784','2013-01-06','13:15:00',1.78),('8784','2013-01-06','13:20:00',1.85),('8784','2013-01-06','13:25:00',1.8),('8784','2013-01-06','13:30:00',1.8),('8784','2013-01-06','13:35:00',1.73),('8784','2013-01-06','13:40:00',1.71),('8784','2013-01-06','13:45:00',1.68),('8784','2013-01-06','13:50:00',1.63),('8784','2013-01-06','13:55:00',1.6),('8784','2013-01-06','14:00:00',1.59),('8784','2013-01-06','14:05:00',1.6),('8784','2013-01-06','14:10:00',1.44),('8784','2013-01-06','14:15:00',1.45),('8784','2013-01-06','14:20:00',1.35),('8784','2013-01-06','14:25:00',1.25),('8784','2013-01-06','14:30:00',1.29),('8784','2013-01-06','14:35:00',1.14),('8784','2013-01-06','14:50:00',1.07),('8784','2013-01-06','14:55:00',1.01),('8784','2013-01-05','10:15:00',1.04),('8784','2013-01-05','10:35:00',1.06),('8784','2013-01-05','10:40:00',1.1),('8784','2013-01-05','10:45:00',1.07),('8784','2013-01-05','10:50:00',1.19),('8784','2013-01-05','10:55:00',1.81),('8784','2013-01-05','11:00:00',1.58),('8784','2013-01-05','11:05:00',1.81),('8784','2013-01-05','11:10:00',1.78),('8784','2013-01-05','11:15:00',1.47),('8784','2013-01-05','11:20:00',1.93),('8784','2013-01-05','11:25:00',2.02),('8784','2013-01-05','11:30:00',2.04),('8784','2013-01-05','11:35:00',1.99),('8784','2013-01-05','11:40:00',1.88),('8784','2013-01-05','11:45:00',1.92),('8784','2013-01-05','11:50:00',1.74),('8784','2013-01-05','11:55:00',1.6),('8784','2013-01-05','12:00:00',1.48),('8784','2013-01-05','12:05:00',1.46),('8784','2013-01-05','12:10:00',1.47),('8784','2013-01-05','12:15:00',1.51),('8784','2013-01-05','12:20:00',1.37),('8784','2013-01-05','12:25:00',1.18),('8784','2013-01-05','12:30:00',1.16),('8784','2013-01-05','12:35:00',1.48),('8784','2013-01-05','12:40:00',1.88),('8784','2013-01-05','12:45:00',2.05),('8784','2013-01-05','12:50:00',1.45),('8784','2013-01-05','12:55:00',1.22),('8784','2013-01-05','13:00:00',1.25),('8784','2013-01-05','13:05:00',1.22),('8784','2013-01-05','13:10:00',1.17),('8784','2013-01-05','13:25:00',1.08),('8784','2013-01-05','13:30:00',1.66),('8784','2013-01-05','13:35:00',1.38),('8784','2013-01-05','13:40:00',1.06),('8784','2013-01-05','13:50:00',1.01),('8784','2013-01-05','13:55:00',1.18),('8784','2013-01-05','14:00:00',1.06);
INSERT INTO `solarlogmod` VALUES ('8784','2013-01-05','14:05:00',1.54),('8784','2013-01-05','14:10:00',1.37),('8784','2013-01-05','14:15:00',1.16),('8784','2013-01-05','14:30:00',1.07),('8784','2013-01-05','14:35:00',1.03),('8784','2013-01-05','14:40:00',1.07),('8784','2013-01-05','14:45:00',1.17),('8784','2013-01-05','15:00:00',1.04),('8784','2013-01-04','09:55:00',1.03),('8784','2013-01-04','10:00:00',1.39),('8784','2013-01-04','10:05:00',1.43),('8784','2013-01-04','10:10:00',1.22),('8784','2013-01-04','10:15:00',1.47),('8784','2013-01-04','10:20:00',1.41),('8784','2013-01-04','10:25:00',1.55),('8784','2013-01-04','10:30:00',1.78),('8784','2013-01-04','10:35:00',1.85),('8784','2013-01-04','10:40:00',1.93),('8784','2013-01-04','10:45:00',2.06),('8784','2013-01-04','10:50:00',2.2),('8784','2013-01-04','10:55:00',2.35),('8784','2013-01-04','11:00:00',2.13),('8784','2013-01-04','11:05:00',1.48),('8784','2013-01-04','11:45:00',1.17),('8784','2013-01-04','11:50:00',1.91),('8784','2013-01-04','11:55:00',2.4),('8784','2013-01-04','12:00:00',2.62),('8784','2013-01-04','12:05:00',2.26),('8784','2013-01-04','12:10:00',1.81),('8784','2013-01-04','12:15:00',1.25),('8784','2013-01-04','12:25:00',1.01),('8784','2013-01-04','12:30:00',1.71),('8784','2013-01-04','12:35:00',1.42),('8784','2013-01-04','12:40:00',2.06),('8784','2013-01-04','12:45:00',2.05),('8784','2013-01-04','12:50:00',2.1),('8784','2013-01-04','12:55:00',2.07),('8784','2013-01-04','13:00:00',2),('8784','2013-01-04','13:05:00',1.88),('8784','2013-01-04','13:10:00',1.4),('8784','2013-01-04','13:15:00',1.65),('8784','2013-01-04','13:20:00',1.76),('8784','2013-01-04','13:25:00',1.71),('8784','2013-01-04','13:30:00',1.65),('8784','2013-01-04','13:35:00',1.65),('8784','2013-01-04','13:40:00',1.6),('8784','2013-01-04','13:45:00',1.58),('8784','2013-01-04','13:50:00',1.53),('8784','2013-01-04','13:55:00',1.5),('8784','2013-01-04','14:00:00',1.45),('8784','2013-01-04','14:05:00',1.37),('8784','2013-01-04','14:10:00',1.37),('8784','2013-01-04','14:15:00',1.33),('8784','2013-01-04','14:20:00',1.29),('8784','2013-01-04','14:25:00',1.28),('8784','2013-01-04','14:30:00',1.24),('8784','2013-01-04','14:50:00',1.02),('8784','2013-01-03','09:50:00',1.3),('8784','2013-01-03','09:55:00',1.49),('8784','2013-01-03','10:00:00',1.62),('8784','2013-01-03','10:05:00',1.7),('8784','2013-01-03','10:10:00',1.4),('8784','2013-01-03','10:15:00',1.89),('8784','2013-01-03','10:20:00',1.89),('8784','2013-01-03','10:25:00',2.11),('8784','2013-01-03','10:30:00',1.75),('8784','2013-01-03','10:35:00',1.76),('8784','2013-01-03','10:40:00',1.58),('8784','2013-01-03','10:45:00',1.49),('8784','2013-01-03','10:50:00',1.51),('8784','2013-01-03','10:55:00',1.42),('8784','2013-01-03','11:00:00',1.54),('8784','2013-01-03','11:05:00',1.49),('8784','2013-01-03','11:10:00',1.49),('8784','2013-01-03','11:15:00',1.33),('8784','2013-01-03','11:20:00',1.21),('8784','2013-01-03','11:40:00',2.13),('8784','2013-01-03','11:45:00',2.12),('8784','2013-01-03','11:50:00',2.07),('8784','2013-01-03','11:55:00',2.05),('8784','2013-01-03','12:00:00',2.04),('8784','2013-01-03','12:05:00',2.04),('8784','2013-01-03','12:10:00',2.06),('8784','2013-01-03','12:15:00',2.04),('8784','2013-01-03','12:20:00',2.02),('8784','2013-01-03','12:25:00',2.03),('8784','2013-01-03','12:30:00',2.03),('8784','2013-01-03','12:35:00',2.01),('8784','2013-01-03','12:40:00',1.93),('8784','2013-01-03','12:45:00',1.81),('8784','2013-01-03','12:50:00',1.94),('8784','2013-01-03','12:55:00',1.94),('8784','2013-01-03','13:00:00',1.89),('8784','2013-01-03','13:05:00',1.9),('8784','2013-01-03','13:10:00',1.88),('8784','2013-01-03','13:15:00',1.82),('8784','2013-01-03','13:20:00',1.81),('8784','2013-01-03','13:25:00',1.77),('8784','2013-01-03','13:30:00',1.72),('8784','2013-01-03','13:35:00',1.69),('8784','2013-01-03','13:40:00',1.67),('8784','2013-01-03','13:45:00',1.63),('8784','2013-01-03','13:50:00',1.58),('8784','2013-01-03','13:55:00',1.56),('8784','2013-01-03','14:00:00',1.49),('8784','2013-01-03','14:05:00',1.41),('8784','2013-01-03','14:10:00',1.41),('8784','2013-01-03','14:15:00',1.39),('8784','2013-01-03','14:20:00',1.35),('8784','2013-01-03','14:25:00',1.32),('8784','2013-01-03','14:30:00',1.28),('8784','2013-01-03','14:50:00',1.08),('8784','2013-01-03','14:55:00',1.03),('8784','2014-03-18','07:55:00',1.08),('8784','2014-03-18','08:15:00',1.01),('8784','2014-03-18','08:20:00',1.65),('8784','2014-03-18','08:25:00',1.09),('8784','2014-03-18','08:30:00',1.11),('8784','2014-03-18','08:50:00',2.01),('8784','2014-03-18','08:55:00',2.69),('8784','2014-03-18','09:00:00',2.24),('8784','2014-03-18','09:05:00',1.81),('8784','2014-03-18','09:10:00',1.73),('8784','2014-03-18','09:15:00',2.17),('8784','2014-03-18','09:20:00',2.31),('8784','2014-03-18','09:25:00',1.53),('8784','2014-03-18','09:30:00',2.49),('8784','2014-03-18','09:35:00',1.81),('8784','2014-03-18','09:40:00',1.42),('8784','2014-03-18','09:45:00',1.7),('8784','2014-03-18','09:50:00',2.04),('8784','2014-03-18','09:55:00',1.4),('8784','2014-03-18','10:00:00',2.62),('8784','2014-03-18','10:05:00',3.26),('8784','2014-03-18','10:10:00',3.47),('8784','2014-03-18','10:15:00',3.3),('8784','2014-03-18','10:20:00',3.26),('8784','2014-03-18','10:25:00',2.27),('8784','2014-03-18','10:30:00',3.19),('8784','2014-03-18','10:35:00',3.49),('8784','2014-03-18','10:40:00',2.27),('8784','2014-03-18','10:45:00',3.26),('8784','2014-03-18','10:50:00',4.42),('8784','2014-03-18','10:55:00',3.4),('8784','2014-03-18','11:00:00',2.08),('8784','2014-03-18','11:05:00',2.25),('8784','2014-03-18','11:10:00',1.52),('8784','2014-03-18','11:15:00',2.9),('8784','2014-03-18','11:20:00',3.65),('8784','2014-03-18','11:25:00',3.62),('8784','2014-03-18','11:30:00',2.68),('8784','2014-03-18','11:35:00',4.45),('8784','2014-03-18','11:40:00',2.49),('8784','2014-03-18','11:45:00',3.41),('8784','2014-03-18','11:50:00',2.23),('8784','2014-03-18','11:55:00',1.82),('8784','2014-03-18','12:00:00',2.12),('8784','2014-03-18','12:05:00',3.76),('8784','2014-03-18','12:10:00',3.06),('8784','2014-03-18','12:15:00',2.52),('8784','2014-03-18','12:20:00',1.53),('8784','2014-03-18','12:25:00',1.25),('8784','2014-03-18','12:30:00',1.95),('8784','2014-03-18','12:35:00',2.05),('8784','2014-03-18','12:40:00',1.76),('8784','2014-03-18','12:45:00',4.23),('8784','2014-03-18','12:50:00',2.74),('8784','2014-03-18','12:55:00',3.91),('8784','2014-03-18','13:00:00',3.86),('8784','2014-03-18','13:05:00',3.82),('8784','2014-03-18','13:10:00',3.75),('8784','2014-03-18','13:15:00',3.71),('8784','2014-03-18','13:20:00',3.57),('8784','2014-03-18','13:25:00',2.92),('8784','2014-03-18','13:30:00',3.55),('8784','2014-03-18','13:35:00',3.5),('8784','2014-03-18','13:40:00',3.5),('8784','2014-03-18','13:45:00',3.43),('8784','2014-03-18','13:50:00',3.39),('8784','2014-03-18','13:55:00',3.44),('8784','2014-03-18','14:00:00',3.31),('8784','2014-03-18','14:05:00',3.32),('8784','2014-03-18','14:10:00',3.28),('8784','2014-03-18','14:15:00',3.22),('8784','2014-03-18','14:20:00',3.17),('8784','2014-03-18','14:25:00',3.11),('8784','2014-03-18','14:30:00',3.07),('8784','2014-03-18','14:35:00',3),('8784','2014-03-18','14:40:00',2.92),('8784','2014-03-18','14:45:00',2.86),('8784','2014-03-18','14:50:00',2.83),('8784','2014-03-18','14:55:00',2.75),('8784','2014-03-18','15:00:00',2.65),('8784','2014-03-18','15:05:00',2.61),('8784','2014-03-18','15:10:00',2.55),('8784','2014-03-18','15:15:00',2.49),('8784','2014-03-18','15:20:00',2.4),('8784','2014-03-18','15:25:00',2.31),('8784','2014-03-18','15:30:00',2.24),('8784','2014-03-18','15:35:00',2.17),('8784','2014-03-18','15:40:00',2.07),('8784','2014-03-18','15:45:00',1.99),('8784','2014-03-18','15:50:00',1.9),('8784','2014-03-18','15:55:00',1.84),('8784','2014-03-18','16:00:00',1.76),('8784','2014-03-18','16:05:00',1.68),('8784','2014-03-18','16:10:00',1.59),('8784','2014-03-18','16:15:00',1.5),('8784','2014-03-18','16:20:00',1.4),('8784','2014-03-18','16:25:00',1.34),('8784','2014-03-18','16:30:00',1.27),('8784','2014-03-18','16:35:00',1.17),('8784','2014-03-18','16:40:00',1.09),('8784','2013-01-01','09:50:00',1.03),('8784','2013-01-01','09:55:00',1.15),('8784','2013-01-01','10:00:00',1.2),('8784','2013-01-01','10:05:00',1.22),('8784','2013-01-01','10:10:00',1.28),('8784','2013-01-01','10:15:00',1.39),('8784','2013-01-01','10:20:00',1.52),('8784','2013-01-01','10:25:00',1.59),('8784','2013-01-01','10:30:00',1.65),('8784','2013-01-01','10:35:00',1.69),('8784','2013-01-01','10:40:00',1.78),('8784','2013-01-01','10:45:00',1.96),('8784','2013-01-01','10:50:00',1.91),('8784','2013-01-01','10:55:00',1.18),('8784','2013-01-01','11:05:00',1.87),('8784','2013-01-01','11:10:00',1.85),('8784','2013-01-01','11:15:00',1.48),('8784','2013-01-01','11:20:00',1.28),('8784','2013-01-01','11:25:00',1.78),('8784','2013-01-01','11:30:00',2.31),('8784','2013-01-01','11:35:00',1.35),('8784','2013-01-01','11:40:00',1.62),('8784','2013-01-01','11:45:00',1.84),('8784','2013-01-01','11:50:00',1.57),('8784','2013-01-01','11:55:00',1.31),('8784','2013-01-01','12:00:00',1.3),('8784','2013-01-01','12:05:00',1.12),('8784','2013-01-01','12:10:00',1.29),('8784','2013-01-01','12:15:00',1.18),('8784','2013-01-01','12:20:00',1.28),('8784','2013-01-01','12:25:00',1.18),('8784','2013-01-01','12:30:00',1.04),('8784','2013-01-01','12:40:00',1.14),('8784','2013-01-01','12:45:00',1.35),('8784','2013-01-01','12:50:00',1.3),('8784','2013-01-01','12:55:00',1.19),('8784','2013-01-01','13:00:00',1.05),('8784','2013-01-01','13:05:00',1.01),('8784','2012-12-31','10:10:00',1.22),('8784','2012-12-31','10:15:00',1.54),('8784','2012-12-31','10:20:00',1.68),('8784','2012-12-31','10:25:00',1.75),('8784','2012-12-31','10:30:00',1.79),('8784','2012-12-31','10:35:00',1.81),('8784','2012-12-31','10:40:00',1.85),('8784','2012-12-31','10:45:00',1.83),('8784','2012-12-31','10:50:00',1.83),('8784','2012-12-31','10:55:00',1.91),('8784','2012-12-31','11:00:00',1.96),('8784','2012-12-31','11:05:00',1.96),('8784','2012-12-31','11:10:00',1.94),('8784','2012-12-31','11:15:00',1.92),('8784','2012-12-31','11:20:00',2.01),('8784','2012-12-31','11:25:00',2.04),('8784','2012-12-31','11:30:00',1.98),('8784','2012-12-31','11:35:00',2.02),('8784','2012-12-31','11:40:00',2.04),('8784','2012-12-31','11:45:00',2.05),('8784','2012-12-31','11:50:00',2.07),('8784','2012-12-31','11:55:00',2.07),('8784','2012-12-31','12:00:00',2.09),('8784','2012-12-31','12:05:00',2.1),('8784','2012-12-31','12:10:00',2.12),('8784','2012-12-31','12:15:00',2.1),('8784','2012-12-31','12:20:00',2.11),('8784','2012-12-31','12:25:00',2.11),('8784','2012-12-31','12:30:00',2.08),('8784','2012-12-31','12:35:00',2.06),('8784','2012-12-31','12:40:00',1.85),('8784','2012-12-31','12:45:00',1.9),('8784','2012-12-31','12:50:00',1.97),('8784','2012-12-31','12:55:00',1.96),('8784','2012-12-31','13:00:00',1.93),('8784','2012-12-31','13:05:00',1.9),('8784','2012-12-31','13:10:00',1.91),('8784','2012-12-31','13:15:00',1.85),('8784','2012-12-31','13:20:00',1.83),('8784','2012-12-31','13:25:00',1.79),('8784','2012-12-31','13:30:00',1.76),('8784','2012-12-31','13:35:00',1.72),('8784','2012-12-31','13:40:00',1.67),('8784','2012-12-31','13:45:00',1.63),('8784','2012-12-31','13:50:00',1.6),('8784','2012-12-31','13:55:00',1.56),('8784','2012-12-31','14:00:00',1.5),('8784','2012-12-31','14:05:00',1.47),('8784','2012-12-31','14:10:00',1.43),('8784','2012-12-31','14:15:00',1.4),('8784','2012-12-31','14:20:00',1.29),('8784','2012-12-31','14:25:00',1.29),('8784','2012-12-31','14:30:00',1.19),('8784','2012-12-31','14:35:00',1.1),('8784','2012-12-31','14:40:00',1.17),('8784','2012-12-31','14:45:00',1.12),('8784','2012-12-31','14:50:00',1.07),('8784','2012-12-31','14:55:00',1.01),('8784','2012-12-30','09:50:00',1.06),('8784','2012-12-30','09:55:00',1.17),('8784','2012-12-30','10:00:00',1.22),('8784','2012-12-30','10:05:00',1.22),('8784','2012-12-30','10:10:00',1.32),('8784','2012-12-30','10:15:00',1.45),('8784','2012-12-30','10:20:00',1.6),('8784','2012-12-30','10:25:00',1.66),('8784','2012-12-30','10:30:00',1.72),('8784','2012-12-30','10:35:00',1.76),('8784','2012-12-30','10:40:00',1.8),('8784','2012-12-30','10:45:00',1.8),('8784','2012-12-30','10:50:00',1.83),('8784','2012-12-30','10:55:00',1.89),('8784','2012-12-30','11:00:00',1.95),('8784','2012-12-30','11:05:00',2.02),('8784','2012-12-30','11:10:00',1.99),('8784','2012-12-30','11:15:00',1.89),('8784','2012-12-30','11:20:00',1.99),('8784','2012-12-30','11:25:00',1.99),('8784','2012-12-30','11:30:00',1.99),('8784','2012-12-30','11:35:00',2),('8784','2012-12-30','11:40:00',2),('8784','2012-12-30','11:45:00',2.02),('8784','2012-12-30','11:50:00',2.03),('8784','2012-12-30','11:55:00',2.06),('8784','2012-12-30','12:00:00',2.06),('8784','2012-12-30','12:05:00',2.07),('8784','2012-12-30','12:10:00',2.06),('8784','2012-12-30','12:15:00',2.06),('8784','2012-12-30','12:20:00',2.05),('8784','2012-12-30','12:25:00',2.04),('8784','2012-12-30','12:30:00',2),('8784','2012-12-30','12:35:00',2),('8784','2012-12-30','12:40:00',1.74),('8784','2012-12-30','12:45:00',1.9),('8784','2012-12-30','12:50:00',1.88),('8784','2012-12-30','12:55:00',1.78),('8784','2012-12-30','13:00:00',1.86),('8784','2012-12-30','13:05:00',1.91),('8784','2012-12-30','13:10:00',1.87),('8784','2012-12-30','13:15:00',1.84),('8784','2012-12-30','13:20:00',1.81),('8784','2012-12-30','13:25:00',1.79),('8784','2012-12-30','13:30:00',1.74),('8784','2012-12-30','13:35:00',1.72),('8784','2012-12-30','13:40:00',1.63),('8784','2012-12-30','13:45:00',1.63),('8784','2012-12-30','13:50:00',1.62),('8784','2012-12-30','13:55:00',1.57),('8784','2012-12-30','14:00:00',1.52),('8784','2012-12-30','14:05:00',1.48),('8784','2012-12-30','14:10:00',1.43),('8784','2012-12-30','14:15:00',1.4),('8784','2012-12-30','14:20:00',1.33),('8784','2012-12-30','14:25:00',1.29),('8784','2012-12-30','14:30:00',1.24),('8784','2012-12-30','14:35:00',1.18),('8784','2012-12-30','14:40:00',1.15),('8784','2012-12-30','14:45:00',1.09),('8784','2012-12-30','14:50:00',1.04),('8784','2012-12-29','09:50:00',1.06),('8784','2012-12-29','09:55:00',1.18),('8784','2012-12-29','10:00:00',1.24),('8784','2012-12-29','10:05:00',1.29),('8784','2012-12-29','10:10:00',1.36),('8784','2012-12-29','10:15:00',1.46),('8784','2012-12-29','10:20:00',1.61),('8784','2012-12-29','10:25:00',1.67),('8784','2012-12-29','10:30:00',1.73),('8784','2012-12-29','10:35:00',1.76),('8784','2012-12-29','10:40:00',1.8),('8784','2012-12-29','10:45:00',1.86),('8784','2012-12-29','10:50:00',1.91),('8784','2012-12-29','10:55:00',1.94),('8784','2012-12-29','11:00:00',1.97),('8784','2012-12-29','11:05:00',2.03),('8784','2012-12-29','11:10:00',2),('8784','2012-12-29','11:15:00',1.98),('8784','2012-12-29','11:20:00',1.98),('8784','2012-12-29','11:25:00',2),('8784','2012-12-29','11:30:00',1.99),('8784','2012-12-29','11:35:00',2.03),('8784','2012-12-29','11:40:00',2.02),('8784','2012-12-29','11:45:00',2.03),('8784','2012-12-29','11:50:00',2.06),('8784','2012-12-29','11:55:00',2.06),('8784','2012-12-29','12:00:00',2.08),('8784','2012-12-29','12:05:00',2.11),('8784','2012-12-29','12:10:00',2.11),('8784','2012-12-29','12:15:00',2.1),('8784','2012-12-29','12:20:00',2.06),('8784','2012-12-29','12:25:00',2.05),('8784','2012-12-29','12:30:00',2.03),('8784','2012-12-29','12:35:00',2.01),('8784','2012-12-29','12:40:00',1.81),('8784','2012-12-29','12:45:00',1.98),('8784','2012-12-29','12:50:00',1.88),('8784','2012-12-29','12:55:00',1.82),('8784','2012-12-29','13:00:00',1.94),('8784','2012-12-29','13:05:00',1.91),('8784','2012-12-29','13:10:00',1.88),('8784','2012-12-29','13:15:00',1.87),('8784','2012-12-29','13:20:00',1.84),('8784','2012-12-29','13:25:00',1.8),('8784','2012-12-29','13:30:00',1.75),('8784','2012-12-29','13:35:00',1.72),('8784','2012-12-29','13:40:00',1.67),('8784','2012-12-29','13:45:00',1.63),('8784','2012-12-29','13:50:00',1.62),('8784','2012-12-29','13:55:00',1.57),('8784','2012-12-29','14:00:00',1.52),('8784','2012-12-29','14:05:00',1.48),('8784','2012-12-29','14:10:00',1.42),('8784','2012-12-29','14:15:00',1.41),('8784','2012-12-29','14:20:00',1.35),('8784','2012-12-29','14:25:00',1.32),('8784','2012-12-29','14:30:00',1.22),('8784','2012-12-29','14:35:00',1.18),('8784','2012-12-29','14:40:00',1.17),('8784','2012-12-29','14:45:00',1.12),('8784','2012-12-29','14:50:00',1.06),('8784','2012-12-29','14:55:00',1.01),('8784','2012-12-28','09:55:00',1.05),('8784','2012-12-28','10:00:00',1.12),('8784','2012-12-28','10:05:00',1.16),('8784','2012-12-28','10:10:00',1.2),('8784','2012-12-28','10:15:00',1.34),('8784','2012-12-28','10:20:00',1.51),('8784','2012-12-28','10:25:00',1.57),('8784','2012-12-28','10:30:00',1.58),('8784','2012-12-28','10:35:00',1.68),('8784','2012-12-28','10:40:00',1.7),('8784','2012-12-28','10:45:00',1.75),('8784','2012-12-28','10:50:00',1.79),('8784','2012-12-28','10:55:00',1.8),('8784','2012-12-28','11:00:00',1.86),('8784','2012-12-28','11:05:00',1.95),('8784','2012-12-28','11:10:00',1.86),('8784','2012-12-28','11:15:00',1.85),('8784','2012-12-28','11:20:00',1.91),('8784','2012-12-28','11:25:00',1.94),('8784','2012-12-28','11:30:00',1.93),('8784','2012-12-28','11:35:00',1.98),('8784','2012-12-28','11:40:00',1.97),('8784','2012-12-28','11:45:00',2.02),('8784','2012-12-28','11:50:00',1.75),('8784','2012-12-28','11:55:00',1.98),('8784','2012-12-28','12:00:00',1.99),('8784','2012-12-28','12:05:00',2.02),('8784','2012-12-28','12:10:00',2.02),('8784','2012-12-28','12:15:00',2),('8784','2012-12-28','12:20:00',1.99),('8784','2012-12-28','12:25:00',1.98),('8784','2012-12-28','12:30:00',1.98),('8784','2012-12-28','12:35:00',1.94),('8784','2012-12-28','12:40:00',1.68),('8784','2012-12-28','12:45:00',1.83),('8784','2012-12-28','12:50:00',1.8),('8784','2012-12-28','12:55:00',1.63),('8784','2012-12-28','13:00:00',1.85),('8784','2012-12-28','13:05:00',1.82),('8784','2012-12-28','13:10:00',1.79),('8784','2012-12-28','13:15:00',1.77),('8784','2012-12-28','13:20:00',1.7),('8784','2012-12-28','13:25:00',1.71),('8784','2012-12-28','13:30:00',1.68),('8784','2012-12-28','13:35:00',1.65),('8784','2012-12-28','13:40:00',1.56),('8784','2012-12-28','13:45:00',1.53),('8784','2012-12-28','13:50:00',1.52),('8784','2012-12-28','13:55:00',1.43),('8784','2012-12-28','14:00:00',1.35),('8784','2012-12-28','14:05:00',1.32),('8784','2012-12-28','14:10:00',1.27),('8784','2012-12-28','14:15:00',1.28),('8784','2012-12-28','14:20:00',1.22),('8784','2012-12-28','14:25:00',1.19),('8784','2012-12-27','09:50:00',1.23),('8784','2012-12-27','10:15:00',1.19),('8784','2012-12-27','10:20:00',1.44),('8784','2012-12-27','10:25:00',1.44),('8784','2012-12-27','10:30:00',1.45),('8784','2012-12-27','10:35:00',1.6),('8784','2012-12-27','10:40:00',1.6),('8784','2012-12-27','10:45:00',1.71),('8784','2012-12-27','10:50:00',1.73),('8784','2012-12-27','10:55:00',1.51),('8784','2012-12-27','11:00:00',1.74),('8784','2012-12-27','11:05:00',1.76),('8784','2012-12-27','11:10:00',1.64),('8784','2012-12-27','11:50:00',1.65),('8784','2012-12-27','11:55:00',1.96),('8784','2012-12-27','12:00:00',1.99),('8784','2012-12-27','12:05:00',2.17),('8784','2012-12-27','12:10:00',2.26),('8784','2012-12-27','12:20:00',1.53),('8784','2012-12-27','12:25:00',1.85),('8784','2012-12-27','12:30:00',1.92),('8784','2012-12-27','12:35:00',1.89),('8784','2012-12-27','12:40:00',1.94),('8784','2012-12-27','12:45:00',2.2),('8784','2012-12-27','12:50:00',1.78),('8784','2012-12-27','12:55:00',1.92),('8784','2012-12-27','13:00:00',1.87),('8784','2012-12-27','13:05:00',1.96),('8784','2012-12-27','13:10:00',1.96),('8784','2012-12-27','13:15:00',2.05),('8784','2012-12-27','13:20:00',1.95),('8784','2012-12-27','13:25:00',1.93),('8784','2012-12-27','13:30:00',1.75),('8784','2012-12-27','14:00:00',1.35),('8784','2012-12-27','14:05:00',1.63),('8784','2012-12-27','14:10:00',1.69),('8784','2012-12-27','14:15:00',1.36),('8784','2012-12-27','14:20:00',1.27),('8784','2012-12-27','14:25:00',1.22),('8784','2012-12-27','14:35:00',1.07),('8784','2012-12-27','14:40:00',1.09),('8784','2012-12-26','09:50:00',1.02),('8784','2012-12-26','09:55:00',1.1),('8784','2012-12-26','10:00:00',1.16),('8784','2012-12-26','10:05:00',1.19),('8784','2012-12-26','10:10:00',1.28),('8784','2012-12-26','10:15:00',1.39),('8784','2012-12-26','10:20:00',1.49),('8784','2012-12-26','10:25:00',1.53),('8784','2012-12-26','10:30:00',1.57),('8784','2012-12-26','10:35:00',1.58),('8784','2012-12-26','10:40:00',1.66),('8784','2012-12-26','10:45:00',1.7),('8784','2012-12-26','10:50:00',1.72),('8784','2012-12-26','10:55:00',1.75),('8784','2012-12-26','11:00:00',1.82),('8784','2012-12-26','11:05:00',1.87),('8784','2012-12-26','11:10:00',1.8),('8784','2012-12-26','11:15:00',1.75),('8784','2012-12-26','11:20:00',1.78),('8784','2012-12-26','11:25:00',1.85),('8784','2012-12-26','11:30:00',1.81),('8784','2012-12-26','11:35:00',1.86),('8784','2012-12-26','11:40:00',1.9),('8784','2012-12-26','11:45:00',1.91),('8784','2012-12-26','11:50:00',1.95),('8784','2012-12-26','11:55:00',1.97),('8784','2012-12-26','12:00:00',1.98),('8784','2012-12-26','12:05:00',2.04),('8784','2012-12-26','12:10:00',2.01),('8784','2012-12-26','12:15:00',2.01),('8784','2012-12-26','12:20:00',2.01),('8784','2012-12-26','12:25:00',2.02),('8784','2012-12-26','12:30:00',1.99),('8784','2012-12-26','12:35:00',1.95),('8784','2012-12-26','12:40:00',1.95),('8784','2012-12-26','12:45:00',1.91),('8784','2012-12-26','12:50:00',1.77),('8784','2012-12-26','12:55:00',1.62),('8784','2012-12-26','13:00:00',1.93),('8784','2012-12-26','13:05:00',1.36),('8784','2012-12-26','13:10:00',1.95),('8784','2012-12-26','13:15:00',1.86),('8784','2012-12-26','13:20:00',2.02),('8784','2012-12-26','13:25:00',1.97),('8784','2012-12-26','13:30:00',2.22),('8784','2012-12-26','13:35:00',2.17),('8784','2012-12-26','13:40:00',2.06),('8784','2012-12-26','13:45:00',2.16),('8784','2012-12-26','13:50:00',1.98),('8784','2012-12-26','13:55:00',1.92),('8784','2012-12-26','14:00:00',1.8),('8784','2012-12-26','14:05:00',1.87),('8784','2012-12-26','14:10:00',1.13),('8784','2012-12-23','09:50:00',1.08),('8784','2012-12-23','09:55:00',1.17),('8784','2012-12-23','10:00:00',1.21),('8784','2012-12-23','10:05:00',1.19),('8784','2012-12-23','10:10:00',1.34),('8784','2012-12-23','10:15:00',1.49),('8784','2012-12-23','10:20:00',1.57),('8784','2012-12-23','10:25:00',1.56),('8784','2012-12-23','10:30:00',1.57),('8784','2012-12-23','10:35:00',1.61),('8784','2012-12-23','10:40:00',1.69),('8784','2012-12-23','10:45:00',1.76),('8784','2012-12-23','10:50:00',1.78),('8784','2012-12-23','10:55:00',1.72),('8784','2012-12-23','11:00:00',1.88),('8784','2012-12-23','11:05:00',1.91),('8784','2012-12-23','11:10:00',1.81),('8784','2012-12-23','11:15:00',1.85),('8784','2012-12-23','11:20:00',1.87),('8784','2012-12-23','11:25:00',1.72),('8784','2012-12-23','11:30:00',1.86),('8784','2012-12-23','11:35:00',1.97),('8784','2012-12-23','11:40:00',1.99),('8784','2012-12-23','11:45:00',1.97),('8784','2012-12-23','11:50:00',2.02),('8784','2012-12-23','11:55:00',1.9),('8784','2012-12-23','12:00:00',1.84),('8784','2012-12-23','12:05:00',1.87),('8784','2012-12-23','12:10:00',1.88),('8784','2012-12-23','12:15:00',1.48),('8784','2012-12-23','12:20:00',1.49),('8784','2012-12-23','12:30:00',1.08),('8784','2012-12-23','12:35:00',1.12),('8784','2012-12-23','12:40:00',1.31),('8784','2012-12-23','12:50:00',1.28),('8784','2012-12-23','12:55:00',1.68),('8784','2012-12-23','13:00:00',1.98),('8784','2012-12-23','13:05:00',1.69),('8784','2012-12-23','13:10:00',1.83),('8784','2012-12-23','13:15:00',1.37),('8784','2012-12-23','13:20:00',1.25),('8784','2012-12-23','13:25:00',1.11),('8784','2012-12-23','13:35:00',1.05),('8784','2012-12-23','13:40:00',1.27),('8784','2012-12-23','13:45:00',1.29),('8784','2012-12-23','13:50:00',1.22),('8784','2012-12-23','13:55:00',1.14),('8784','2012-12-23','14:00:00',1.54),('8784','2012-12-23','14:05:00',1.37),('8784','2012-12-23','14:10:00',1.26),('8784','2012-12-23','14:15:00',1.29),('8784','2012-12-23','14:20:00',1.02),('8784','2012-12-23','14:45:00',1.03),('8784','2014-05-01','07:50:00',1.38),('8784','2014-05-01','07:55:00',1.48),('8784','2014-05-01','08:00:00',1.63),('8784','2014-05-01','08:05:00',1.61),('8784','2014-05-01','08:10:00',1.66),('8784','2014-05-01','08:15:00',1.76),('8784','2014-05-01','08:20:00',1.85),('8784','2014-05-01','08:25:00',1.97),('8784','2014-05-01','08:30:00',2.05),('8784','2014-05-01','08:35:00',2.17),('8784','2014-05-01','08:40:00',2.25),('8784','2014-05-01','08:45:00',2.37),('8784','2014-05-01','08:50:00',2.56),('8784','2014-05-01','08:55:00',2.9),('8784','2014-05-01','09:00:00',1.72),('8784','2014-05-01','09:05:00',1.28),('8784','2014-05-01','09:10:00',2.21),('8784','2014-05-01','09:15:00',2.66),('8784','2014-05-01','09:20:00',2.02),('8784','2014-05-01','09:25:00',3.13),('8784','2014-05-01','09:30:00',3.23),('8784','2014-05-01','09:35:00',3.29),('8784','2014-05-01','09:40:00',3.61),('8784','2014-05-01','09:45:00',2.31),('8784','2014-05-01','09:50:00',2.58),('8784','2014-05-01','09:55:00',2.17),('8784','2014-05-01','10:00:00',2.19),('8784','2014-05-01','10:05:00',1.81),('8784','2014-05-01','10:10:00',3.14),('8784','2014-05-01','10:15:00',2.9),('8784','2014-05-01','10:20:00',1.86),('8784','2014-05-01','10:25:00',1.37),('8784','2014-05-01','10:30:00',2.96),('8784','2014-05-01','10:35:00',3.97),('8784','2014-05-01','10:40:00',2.11),('8784','2014-05-01','10:45:00',3.22),('8784','2014-05-01','10:50:00',4.35),('8784','2014-05-01','10:55:00',3.97),('8784','2014-05-01','11:00:00',3.57),('8784','2014-05-01','11:05:00',4.43),('8784','2014-05-01','11:10:00',3.74),('8784','2014-05-01','11:20:00',1.37),('8784','2014-05-01','11:25:00',4.89),('8784','2014-05-01','11:30:00',4.74),('8784','2014-05-01','11:35:00',4.71),('8784','2014-05-01','11:40:00',1.65),('8784','2014-05-01','11:45:00',2.83),('8784','2014-05-01','11:50:00',5.07),('8784','2014-05-01','11:55:00',2.89),('8784','2014-05-01','12:00:00',1.03),('8784','2014-05-01','12:05:00',4.46),('8784','2014-05-01','12:10:00',4.04),('8784','2014-05-01','12:15:00',3.79),('8784','2014-05-01','12:20:00',3.62),('8784','2014-05-01','12:25:00',4.9),('8784','2014-05-01','12:30:00',3.75),('8784','2014-05-01','12:35:00',4.84),('8784','2014-05-01','12:40:00',5),('8784','2014-05-01','12:45:00',2.92),('8784','2014-05-01','12:50:00',3.69),('8784','2014-05-01','12:55:00',5.12),('8784','2014-05-01','13:00:00',5.15),('8784','2014-05-01','13:05:00',4.91),('8784','2014-05-01','13:10:00',4.89),('8784','2014-05-01','13:15:00',4.22),('8784','2014-05-01','13:20:00',4.95),('8784','2014-05-01','13:25:00',1.81),('8784','2014-05-01','13:30:00',2.28),('8784','2014-05-01','13:35:00',2.85),('8784','2014-05-01','13:40:00',5.1),('8784','2014-05-01','13:45:00',5.08),('8784','2014-05-01','13:50:00',5.29),('8784','2014-05-01','13:55:00',5.06),('8784','2014-05-01','14:00:00',4.7),('8784','2014-05-01','14:05:00',4.78),('8784','2014-05-01','14:10:00',4.67),('8784','2014-05-01','14:15:00',4.58),('8784','2014-05-01','14:20:00',4.49),('8784','2014-05-01','14:25:00',4.51),('8784','2014-05-01','14:30:00',4.29),('8784','2014-05-01','14:35:00',4.26),('8784','2014-05-01','14:40:00',4.59),('8784','2014-05-01','14:45:00',4.58),('8784','2014-05-01','14:50:00',4.53),('8784','2014-05-01','14:55:00',4.1),('8784','2014-05-01','15:00:00',4.47),('8784','2014-05-01','15:05:00',4.48),('8784','2014-05-01','15:10:00',3.84),('8784','2014-05-01','15:15:00',4.02),('8784','2014-05-01','15:20:00',4.07),('8784','2014-05-01','15:25:00',4.01),('8784','2014-05-01','15:30:00',3.9),('8784','2014-05-01','15:35:00',3.82),('8784','2014-05-01','15:40:00',3.75),('8784','2014-05-01','15:45:00',3.58),('8784','2014-05-01','15:50:00',3.69),('8784','2014-05-01','15:55:00',3.55),('8784','2014-05-01','16:00:00',3.55),('8784','2014-05-01','16:05:00',3.53),('8784','2014-05-01','16:10:00',3.36),('8784','2014-05-01','16:15:00',3.28),('8784','2014-05-01','16:20:00',3.16),('8784','2014-05-01','16:25:00',2.89),('8784','2014-05-01','16:30:00',3.03),('8784','2014-05-01','16:35:00',3.04),('8784','2014-05-01','16:40:00',2.88),('8784','2014-05-01','16:45:00',2.41),('8784','2014-05-01','16:50:00',2.21),('8784','2014-05-01','16:55:00',2.44),('8784','2014-05-01','17:00:00',2.46),('8784','2014-05-01','17:05:00',2.35),('8784','2014-05-01','17:10:00',2.53),('8784','2014-05-01','17:15:00',2.38),('8784','2014-05-01','17:20:00',2.28),('8784','2014-05-01','17:25:00',2.19),('8784','2014-05-01','17:30:00',2.09),('8784','2014-05-01','17:35:00',2),('8784','2014-05-01','17:40:00',1.91),('8784','2014-05-01','17:45:00',1.83),('8784','2014-05-01','17:50:00',1.74),('8784','2014-05-01','17:55:00',1.67),('8784','2014-05-01','18:00:00',1.66),('8784','2014-05-01','18:05:00',1.51),('8784','2014-05-01','18:10:00',1.32),('8784','2014-05-01','18:15:00',1.28),('8784','2014-05-01','18:20:00',1.2),('8784','2014-05-01','18:25:00',1.12),('8784','2014-05-01','18:30:00',1.04),('8784','2014-03-17','09:10:00',1.05),('8784','2014-03-17','09:15:00',1.24),('8784','2014-03-17','09:20:00',1.27),('8784','2014-03-17','09:25:00',1.52),('8784','2014-03-17','09:30:00',1.72),('8784','2014-03-17','09:35:00',1.47),('8784','2014-03-17','09:40:00',1.29),('8784','2014-03-17','09:45:00',1.31),('8784','2014-03-17','09:50:00',2.24),('8784','2014-03-17','09:55:00',1.91),('8784','2014-03-17','10:00:00',2),('8784','2014-03-17','10:05:00',1.78),('8784','2014-03-17','10:10:00',1.72),('8784','2014-03-17','10:15:00',1.81),('8784','2014-03-17','10:20:00',2.16),('8784','2014-03-17','10:25:00',1.79),('8784','2014-03-17','10:30:00',1.5),('8784','2014-03-17','10:35:00',1.4),('8784','2014-03-17','10:40:00',1.52),('8784','2014-03-17','10:45:00',1.93),('8784','2014-03-17','10:50:00',1.55),('8784','2014-03-17','10:55:00',1.5),('8784','2014-03-17','11:00:00',1.59),('8784','2014-03-17','11:05:00',1.46),('8784','2014-03-17','11:10:00',1.99),('8784','2014-03-17','11:15:00',1.66),('8784','2014-03-17','11:20:00',1.42),('8784','2014-03-17','11:25:00',1.86),('8784','2014-03-17','11:30:00',1.56),('8784','2014-03-17','11:35:00',1.47),('8784','2014-03-17','11:40:00',1.31),('8784','2014-03-17','11:45:00',1.61),('8784','2014-03-17','11:50:00',1.78),('8784','2014-03-17','11:55:00',1.83),('8784','2014-03-17','12:00:00',2.18),('8784','2014-03-17','12:05:00',2.13),('8784','2014-03-17','12:10:00',1.56),('8784','2014-03-17','12:15:00',1.76),('8784','2014-03-17','12:20:00',3.43),('8784','2014-03-17','12:25:00',1.74),('8784','2014-03-17','12:30:00',1.72),('8784','2014-03-17','12:35:00',2.02),('8784','2014-03-17','12:40:00',2.93),('8784','2014-03-17','12:45:00',2.44),('8784','2014-03-17','12:50:00',4.01),('8784','2014-03-17','12:55:00',3.67),('8784','2014-03-17','13:00:00',2.34),('8784','2014-03-17','13:05:00',1.99),('8784','2014-03-17','13:10:00',3.46),('8784','2014-03-17','13:15:00',3.71),('8784','2014-03-17','13:20:00',3.63),('8784','2014-03-17','13:25:00',3.21),('8784','2014-03-17','13:30:00',3.53),('8784','2014-03-17','13:35:00',3.49),('8784','2014-03-17','13:40:00',3.66),('8784','2014-03-17','13:45:00',2.26),('8784','2014-03-17','13:50:00',3.59),('8784','2014-03-17','13:55:00',1.99),('8784','2014-03-17','14:00:00',2.62),('8784','2014-03-17','14:05:00',2.85),('8784','2014-03-17','14:10:00',1.14),('8784','2014-03-17','14:15:00',2.73),('8784','2014-03-17','14:20:00',1.92),('8784','2014-03-17','14:25:00',2.78),('8784','2014-03-17','14:30:00',1.83),('8784','2014-03-17','14:35:00',1.99),('8784','2014-03-17','14:40:00',2.82),('8784','2014-03-17','14:45:00',2.7),('8784','2014-03-17','14:50:00',3.01),('8784','2014-03-17','14:55:00',2.79),('8784','2014-03-17','15:00:00',2.83),('8784','2014-03-17','15:05:00',2.6),('8784','2014-03-17','15:10:00',2.36),('8784','2014-03-17','15:15:00',1.55),('8784','2014-03-17','15:20:00',2.06),('8784','2014-03-17','15:25:00',2.29),('8784','2014-03-17','15:30:00',2.15),('8784','2014-03-17','15:35:00',1.94),('8784','2014-03-17','15:40:00',1.92),('8784','2014-03-17','15:45:00',1.68),('8784','2014-03-17','15:50:00',1.59),('8784','2014-03-17','15:55:00',1.75),('8784','2014-03-17','16:00:00',1.67),('8784','2014-03-17','16:05:00',1.32),('8784','2014-03-17','16:15:00',1.01),('8784','2014-03-17','16:20:00',1.47),('8784','2014-03-17','16:25:00',1.41),('8784','2014-03-17','16:30:00',1.24),('8784','2014-03-17','16:35:00',1.28),('8784','2014-03-17','16:40:00',1.11),('8784','2014-03-17','16:45:00',1.06),('8784','2012-12-22','10:25:00',1.14),('8784','2012-12-22','10:30:00',1.6),('8784','2012-12-22','10:35:00',2.25),('8784','2012-12-22','10:40:00',2.17),('8784','2012-12-22','10:45:00',2.15),('8784','2012-12-22','10:50:00',2.07),('8784','2012-12-22','10:55:00',1.54),('8784','2012-12-22','11:35:00',1.19),('8784','2012-12-22','11:40:00',2.11),('8784','2012-12-22','11:45:00',2.27),('8784','2012-12-22','11:50:00',1.92),('8784','2012-12-22','11:55:00',1.5),('8784','2012-12-22','12:00:00',1.72),('8784','2012-12-22','12:30:00',1.05),('8784','2012-12-22','12:40:00',1.64),('8784','2012-12-22','12:45:00',2.53),('8784','2012-12-22','12:50:00',2.26),('8784','2012-12-22','12:55:00',2.03),('8784','2012-12-22','13:00:00',2.3),('8784','2012-12-22','13:05:00',1.96),('8784','2012-12-22','13:10:00',2.43),('8784','2012-12-22','13:15:00',2.53),('8784','2012-12-22','13:20:00',2.52),('8784','2012-12-22','13:25:00',2.44),('8784','2012-12-22','13:30:00',2.2),('8784','2012-12-22','13:35:00',2.23),('8784','2012-12-22','13:40:00',1.27),('8784','2012-12-22','13:50:00',1),('8784','2012-12-22','14:00:00',1.02),('8784','2012-12-22','14:10:00',1.2),('8784','2012-12-22','14:15:00',1),('8784','2014-03-16','07:55:00',1.09),('8784','2014-03-16','08:00:00',1.23),('8784','2014-03-16','08:05:00',1.29),('8784','2014-03-16','08:10:00',1.33),('8784','2014-03-16','08:15:00',1.36),('8784','2014-03-16','08:20:00',1.46),('8784','2014-03-16','08:25:00',1.55),('8784','2014-03-16','08:30:00',1.63),('8784','2014-03-16','08:35:00',1.69),('8784','2014-03-16','08:40:00',1.74),('8784','2014-03-16','08:45:00',1.81),('8784','2014-03-16','08:50:00',1.9),('8784','2014-03-16','08:55:00',1.93),('8784','2014-03-16','09:00:00',1.91),('8784','2014-03-16','09:05:00',1.99),('8784','2014-03-16','09:10:00',2.15),('8784','2014-03-16','09:15:00',2.32),('8784','2014-03-16','09:20:00',2.36),('8784','2014-03-16','09:25:00',2.36),('8784','2014-03-16','09:30:00',2.39),('8784','2014-03-16','09:35:00',2.43),('8784','2014-03-16','09:40:00',2.47),('8784','2014-03-16','09:45:00',2.64),('8784','2014-03-16','09:50:00',2.76),('8784','2014-03-16','09:55:00',2.73),('8784','2014-03-16','10:00:00',2.77),('8784','2014-03-16','10:05:00',2.86),('8784','2014-03-16','10:10:00',2.86),('8784','2014-03-16','10:15:00',3),('8784','2014-03-16','10:20:00',2.94),('8784','2014-03-16','10:25:00',2.98),('8784','2014-03-16','10:30:00',2.98),('8784','2014-03-16','10:35:00',3.1),('8784','2014-03-16','10:40:00',3.16),('8784','2014-03-16','10:45:00',3.14),('8784','2014-03-16','10:50:00',3.29),('8784','2014-03-16','10:55:00',3.22),('8784','2014-03-16','11:00:00',3.32),('8784','2014-03-16','11:05:00',3.35),('8784','2014-03-16','11:10:00',3.4),('8784','2014-03-16','11:15:00',3.39),('8784','2014-03-16','11:20:00',3.42),('8784','2014-03-16','11:25:00',3.43),('8784','2014-03-16','11:30:00',3.49),('8784','2014-03-16','11:35:00',3.51),('8784','2014-03-16','11:40:00',3.51),('8784','2014-03-16','11:45:00',3.43),('8784','2014-03-16','11:50:00',3.37),('8784','2014-03-16','11:55:00',3.36),('8784','2014-03-16','12:00:00',3.42),('8784','2014-03-16','12:05:00',3.51),('8784','2014-03-16','12:10:00',3.46),('8784','2014-03-16','12:15:00',3.33),('8784','2014-03-16','12:20:00',3.33),('8784','2014-03-16','12:25:00',3.44),('8784','2014-03-16','12:30:00',3.49),('8784','2014-03-16','12:35:00',3.49),('8784','2014-03-16','12:40:00',3.5),('8784','2014-03-16','12:45:00',3.48),('8784','2014-03-16','12:50:00',3.44),('8784','2014-03-16','12:55:00',3.44),('8784','2014-03-16','13:00:00',3.38),('8784','2014-03-16','13:05:00',3.39),('8784','2014-03-16','13:10:00',3.3),('8784','2014-03-16','13:15:00',3.32),('8784','2014-03-16','13:20:00',3.24),('8784','2014-03-16','13:25:00',3.25),('8784','2014-03-16','13:30:00',3.27),('8784','2014-03-16','13:35:00',3.2),('8784','2014-03-16','13:40:00',3.3),('8784','2014-03-16','13:45:00',3.27),('8784','2014-03-16','13:50:00',3.21),('8784','2014-03-16','13:55:00',3.17),('8784','2014-03-16','14:00:00',3.08),('8784','2014-03-16','14:05:00',3.02),('8784','2014-03-16','14:10:00',2.96),('8784','2014-03-16','14:15:00',2.9),('8784','2014-03-16','14:20:00',2.89),('8784','2014-03-16','14:25:00',2.85),('8784','2014-03-16','14:30:00',2.82),('8784','2014-03-16','14:35:00',2.75),('8784','2014-03-16','14:40:00',2.69),('8784','2014-03-16','14:45:00',2.63),('8784','2014-03-16','14:50:00',2.47),('8784','2014-03-16','14:55:00',2.47),('8784','2014-03-16','15:00:00',2.54),('8784','2014-03-16','15:05:00',2.45),('8784','2014-03-16','15:10:00',2.21),('8784','2014-03-16','15:15:00',2.12),('8784','2014-03-16','15:20:00',1.8),('8784','2014-03-16','15:25:00',2.01),('8784','2014-03-16','15:30:00',1.86),('8784','2014-03-16','15:35:00',1.74),('8784','2014-03-16','15:40:00',1.38),('8784','2014-03-16','15:45:00',1.33),('8784','2014-03-16','15:50:00',1.47),('8784','2014-03-16','15:55:00',1.35),('8784','2014-03-16','16:00:00',1.17),('8784','2014-03-16','16:05:00',1.39),('8784','2014-03-16','16:10:00',1.46),('8784','2014-03-16','16:15:00',1.43),('8784','2014-03-16','16:20:00',1.31),('8784','2014-03-16','16:25:00',1.3),('8784','2014-03-16','16:30:00',1.31),('8784','2014-03-16','16:35:00',1.19),('8784','2014-03-16','16:40:00',1.04),('8784','2014-03-15','07:55:00',1.03),('8784','2014-03-15','08:00:00',1.11),('8784','2014-03-15','08:05:00',1.17),('8784','2014-03-15','08:10:00',1.26),('8784','2014-03-15','08:15:00',1.34),('8784','2014-03-15','08:20:00',1.42),('8784','2014-03-15','08:25:00',1.49),('8784','2014-03-15','08:30:00',1.56),('8784','2014-03-15','08:35:00',1.62),('8784','2014-03-15','08:40:00',1.7),('8784','2014-03-15','08:45:00',1.77),('8784','2014-03-15','08:50:00',1.85),('8784','2014-03-15','08:55:00',1.93),('8784','2014-03-15','09:00:00',2),('8784','2014-03-15','09:05:00',2.03),('8784','2014-03-15','09:10:00',2.15),('8784','2014-03-15','09:15:00',2.23),('8784','2014-03-15','09:20:00',2.29),('8784','2014-03-15','09:25:00',2.35),('8784','2014-03-15','09:30:00',2.41),('8784','2014-03-15','09:35:00',2.46),('8784','2014-03-15','09:40:00',2.52),('8784','2014-03-15','09:45:00',2.57),('8784','2014-03-15','09:50:00',2.6),('8784','2014-03-15','09:55:00',2.65),('8784','2014-03-15','10:00:00',2.69),('8784','2014-03-15','10:05:00',2.76),('8784','2014-03-15','10:10:00',2.83),('8784','2014-03-15','10:15:00',2.9),('8784','2014-03-15','10:20:00',2.93),('8784','2014-03-15','10:25:00',2.95),('8784','2014-03-15','10:30:00',2.99),('8784','2014-03-15','10:35:00',2.99),('8784','2014-03-15','10:40:00',3.03),('8784','2014-03-15','10:45:00',3.11),('8784','2014-03-15','10:50:00',3.1),('8784','2014-03-15','10:55:00',3.12),('8784','2014-03-15','11:00:00',3.18),('8784','2014-03-15','11:05:00',3.21),('8784','2014-03-15','11:10:00',3.22),('8784','2014-03-15','11:15:00',3.31),('8784','2014-03-15','11:20:00',3.36),('8784','2014-03-15','11:25:00',3.45),('8784','2014-03-15','11:30:00',3.36),('8784','2014-03-15','11:35:00',3.39),('8784','2014-03-15','11:40:00',3.4),('8784','2014-03-15','11:45:00',3.52),('8784','2014-03-15','11:50:00',3.4),('8784','2014-03-15','11:55:00',3.39),('8784','2014-03-15','12:00:00',3.4),('8784','2014-03-15','12:05:00',3.37),('8784','2014-03-15','12:10:00',3.46),('8784','2014-03-15','12:15:00',3.51),('8784','2014-03-15','12:20:00',3.44),('8784','2014-03-15','12:25:00',3.49),('8784','2014-03-15','12:30:00',3.54),('8784','2014-03-15','12:35:00',3.57),('8784','2014-03-15','12:40:00',3.53),('8784','2014-03-15','12:45:00',3.52),('8784','2014-03-15','12:50:00',3.53),('8784','2014-03-15','12:55:00',3.46),('8784','2014-03-15','13:00:00',3.49),('8784','2014-03-15','13:05:00',3.49),('8784','2014-03-15','13:10:00',3.46),('8784','2014-03-15','13:15:00',3.34),('8784','2014-03-15','13:20:00',3.32),('8784','2014-03-15','13:25:00',3.35),('8784','2014-03-15','13:30:00',3.36),('8784','2014-03-15','13:35:00',3.36),('8784','2014-03-15','13:40:00',3.31),('8784','2014-03-15','13:45:00',3.28),('8784','2014-03-15','13:50:00',3.24),('8784','2014-03-15','13:55:00',3.23),('8784','2014-03-15','14:00:00',3.15),('8784','2014-03-15','14:05:00',3.17),('8784','2014-03-15','14:10:00',3.13),('8784','2014-03-15','14:15:00',3.06),('8784','2014-03-15','14:20:00',3),('8784','2014-03-15','14:25:00',2.95),('8784','2014-03-15','14:30:00',2.9),('8784','2014-03-15','14:35:00',2.84),('8784','2014-03-15','14:40:00',2.76),('8784','2014-03-15','14:45:00',2.69),('8784','2014-03-15','14:50:00',2.62),('8784','2014-03-15','14:55:00',2.59),('8784','2014-03-15','15:00:00',2.53),('8784','2014-03-15','15:05:00',2.46),('8784','2014-03-15','15:10:00',2.37),('8784','2014-03-15','15:15:00',2.31),('8784','2014-03-15','15:20:00',2.22),('8784','2014-03-15','15:25:00',2.15),('8784','2014-03-15','15:30:00',2.08),('8784','2014-03-15','15:35:00',1.98),('8784','2014-03-15','15:40:00',1.9),('8784','2014-03-15','15:45:00',1.82),('8784','2014-03-15','15:50:00',1.75),('8784','2014-03-15','15:55:00',1.67),('8784','2014-03-15','16:00:00',1.58),('8784','2014-03-15','16:05:00',1.45),('8784','2014-03-15','16:10:00',1.39),('8784','2014-03-15','16:15:00',1.3),('8784','2014-03-15','16:20:00',1.24),('8784','2014-03-15','16:25:00',1.13),('8784','2014-03-15','16:30:00',1.07),('8784','2014-03-14','08:15:00',1.08),('8784','2014-03-14','08:20:00',1.2),('8784','2014-03-14','08:25:00',1.23),('8784','2014-03-14','08:30:00',1.29),('8784','2014-03-14','08:35:00',1.29),('8784','2014-03-14','08:40:00',1.26),('8784','2014-03-14','08:45:00',1.1),('8784','2014-03-14','08:50:00',1.07),('8784','2014-03-14','08:55:00',1.11),('8784','2014-03-14','09:00:00',1.21),('8784','2014-03-14','09:05:00',1.38),('8784','2014-03-14','09:10:00',1.51),('8784','2014-03-14','09:15:00',1.55),('8784','2014-03-14','09:20:00',1.5),('8784','2014-03-14','09:25:00',1.59),('8784','2014-03-14','09:30:00',1.59),('8784','2014-03-14','09:35:00',1.84),('8784','2014-03-14','09:40:00',2.28),('8784','2014-03-14','09:45:00',2.65),('8784','2014-03-14','09:50:00',3.15),('8784','2014-03-14','09:55:00',3.31),('8784','2014-03-14','10:00:00',3.45),('8784','2014-03-14','10:05:00',3.45),('8784','2014-03-14','10:10:00',3.33),('8784','2014-03-14','10:15:00',3.28),('8784','2014-03-14','10:20:00',3.22),('8784','2014-03-14','10:25:00',3.07),('8784','2014-03-14','10:30:00',3.08),('8784','2014-03-14','10:35:00',3.23),('8784','2014-03-14','10:40:00',3.37),('8784','2014-03-14','10:45:00',2.88),('8784','2014-03-14','10:50:00',1.93),('8784','2014-03-14','10:55:00',2.66),('8784','2014-03-14','11:00:00',3.15),('8784','2014-03-14','11:05:00',3.36),('8784','2014-03-14','11:10:00',3.68),('8784','2014-03-14','11:15:00',3.72),('8784','2014-03-14','11:20:00',3.61),('8784','2014-03-14','11:25:00',3.51),('8784','2014-03-14','11:30:00',3.47),('8784','2014-03-14','11:35:00',3.52),('8784','2014-03-14','11:40:00',3.47),('8784','2014-03-14','11:45:00',3.6),('8784','2014-03-14','11:50:00',3.69),('8784','2014-03-14','11:55:00',3.72),('8784','2014-03-14','12:00:00',3.73),('8784','2014-03-14','12:05:00',3.66),('8784','2014-03-14','12:10:00',3.44),('8784','2014-03-14','12:15:00',3.34),('8784','2014-03-14','12:20:00',2.77),('8784','2014-03-14','12:25:00',2.4),('8784','2014-03-14','12:30:00',2.23),('8784','2014-03-14','12:35:00',1.84),('8784','2014-03-14','12:40:00',2.23),('8784','2014-03-14','12:45:00',2.43),('8784','2014-03-14','14:00:00',2.49),('8784','2014-03-14','14:05:00',2.71),('8784','2014-03-14','14:10:00',2.6),('8784','2014-03-14','14:15:00',2.82),('8784','2014-03-14','14:20:00',2.86),('8784','2014-03-14','14:25:00',2.57),('8784','2014-03-14','14:30:00',2.52),('8784','2014-03-14','14:35:00',2.4),('8784','2014-03-14','14:40:00',1.97),('8784','2014-03-14','14:45:00',1.64),('8784','2014-03-14','14:50:00',1.51),('8784','2014-03-14','14:55:00',1.39),('8784','2014-03-14','15:00:00',1.29),('8784','2014-03-14','15:05:00',1.28),('8784','2014-03-14','15:10:00',1.21),('8784','2014-03-14','15:15:00',1.18),('8784','2014-03-14','15:20:00',1.25),('8784','2014-03-14','15:25:00',1.36),('8784','2014-03-14','15:30:00',1.46),('8784','2014-03-14','15:35:00',1.65),('8784','2014-03-14','15:40:00',1.5),('8784','2014-03-14','15:45:00',1.28),('8784','2014-03-14','15:50:00',1.15),('8784','2014-03-14','15:55:00',1.17),('8784','2014-03-14','16:00:00',1.1),('8784','2014-03-14','16:05:00',1.09),('8784','2014-03-13','07:45:00',1.07),('8784','2014-03-13','07:50:00',1.15),('8784','2014-03-13','07:55:00',1.24),('8784','2014-03-13','08:00:00',1.31),('8784','2014-03-13','08:05:00',1.4),('8784','2014-03-13','08:10:00',1.48),('8784','2014-03-13','08:15:00',1.56),('8784','2014-03-13','08:20:00',1.66),('8784','2014-03-13','08:25:00',1.74),('8784','2014-03-13','08:30:00',1.82),('8784','2014-03-13','08:35:00',1.88),('8784','2014-03-13','08:40:00',1.98),('8784','2014-03-13','08:45:00',2.06),('8784','2014-03-13','08:50:00',2.13),('8784','2014-03-13','08:55:00',2.22),('8784','2014-03-13','09:00:00',2.31),('8784','2014-03-13','09:05:00',2.38),('8784','2014-03-13','09:10:00',2.45),('8784','2014-03-13','09:15:00',2.52),('8784','2014-03-13','09:20:00',2.55),('8784','2014-03-13','09:25:00',2.64),('8784','2014-03-13','09:30:00',2.71),('8784','2014-03-13','09:35:00',2.78),('8784','2014-03-13','09:40:00',2.85),('8784','2014-03-13','09:45:00',2.91),('8784','2014-03-13','09:50:00',2.98),('8784','2014-03-13','09:55:00',3.04),('8784','2014-03-13','10:00:00',3.1),('8784','2014-03-13','10:05:00',3.14),('8784','2014-03-13','10:10:00',3.2),('8784','2014-03-13','10:15:00',3.24),('8784','2014-03-13','10:20:00',3.28),('8784','2014-03-13','10:25:00',3.3),('8784','2014-03-13','10:30:00',3.33),('8784','2014-03-13','10:35:00',3.36),('8784','2014-03-13','10:40:00',3.4),('8784','2014-03-13','10:45:00',3.43),('8784','2014-03-13','10:50:00',3.47),('8784','2014-03-13','10:55:00',3.51),('8784','2014-03-13','11:00:00',3.54),('8784','2014-03-13','11:05:00',3.55),('8784','2014-03-13','11:10:00',3.57),('8784','2014-03-13','11:15:00',3.6),('8784','2014-03-13','11:20:00',3.65),('8784','2014-03-13','11:25:00',3.66),('8784','2014-03-13','11:30:00',3.66),('8784','2014-03-13','11:35:00',3.68),('8784','2014-03-13','11:40:00',3.7),('8784','2014-03-13','11:45:00',3.71),('8784','2014-03-13','11:50:00',3.72),('8784','2014-03-13','11:55:00',3.73),('8784','2014-03-13','12:00:00',3.75),('8784','2014-03-13','12:05:00',3.75),('8784','2014-03-13','12:10:00',3.69),('8784','2014-03-13','12:15:00',3.71),('8784','2014-03-13','12:20:00',3.68),('8784','2014-03-13','12:25:00',3.67),('8784','2014-03-13','12:30:00',3.67),('8784','2014-03-13','12:35:00',3.67),('8784','2014-03-13','12:40:00',3.64),('8784','2014-03-13','12:45:00',3.63),('8784','2014-03-13','12:50:00',3.58),('8784','2014-03-13','12:55:00',3.52),('8784','2014-03-13','13:00:00',3.53),('8784','2014-03-13','13:05:00',3.53),('8784','2014-03-13','13:10:00',3.44),('8784','2014-03-13','13:15:00',3.44),('8784','2014-03-13','13:20:00',3.45),('8784','2014-03-13','13:25:00',3.42),('8784','2014-03-13','13:30:00',3.43),('8784','2014-03-13','13:35:00',3.4),('8784','2014-03-13','13:40:00',3.35),('8784','2014-03-13','13:45:00',3.33),('8784','2014-03-13','13:50:00',3.28),('8784','2014-03-13','13:55:00',3.22),('8784','2014-03-13','14:00:00',3.14),('8784','2014-03-13','14:05:00',3.09),('8784','2014-03-13','14:10:00',3.07),('8784','2014-03-13','14:15:00',3.03),('8784','2014-03-13','14:20:00',2.99),('8784','2014-03-13','14:25:00',2.93),('8784','2014-03-13','14:30:00',2.87),('8784','2014-03-13','14:35:00',2.83),('8784','2014-03-13','14:40:00',2.77),('8784','2014-03-13','14:45:00',2.7),('8784','2014-03-13','14:50:00',2.63),('8784','2014-03-13','14:55:00',2.56),('8784','2014-03-13','15:00:00',2.5),('8784','2014-03-13','15:05:00',2.43),('8784','2014-03-13','15:10:00',2.37),('8784','2014-03-13','15:15:00',2.31),('8784','2014-03-13','15:20:00',2.23),('8784','2014-03-13','15:25:00',2.16),('8784','2014-03-13','15:30:00',2.09),('8784','2014-03-13','15:35:00',2.01),('8784','2014-03-13','15:40:00',1.93),('8784','2014-03-13','15:45:00',1.84),('8784','2014-03-13','15:50:00',1.77),('8784','2014-03-13','15:55:00',1.67),('8784','2014-03-13','16:00:00',1.55),('8784','2014-03-13','16:05:00',1.48),('8784','2014-03-13','16:10:00',1.41),('8784','2014-03-13','16:15:00',1.32),('8784','2014-03-13','16:20:00',1.25),('8784','2014-03-13','16:25:00',1.18),('8784','2014-03-13','16:30:00',1.09),('8784','2014-03-13','16:35:00',1.01),('8784','2014-03-12','07:50:00',1.07),('8784','2014-03-12','07:55:00',1.15),('8784','2014-03-12','08:00:00',1.23),('8784','2014-03-12','08:05:00',1.32),('8784','2014-03-12','08:10:00',1.41),('8784','2014-03-12','08:15:00',1.51),('8784','2014-03-12','08:20:00',1.59),('8784','2014-03-12','08:25:00',1.67),('8784','2014-03-12','08:30:00',1.75),('8784','2014-03-12','08:35:00',1.86),('8784','2014-03-12','08:40:00',1.94),('8784','2014-03-12','08:45:00',2.02),('8784','2014-03-12','08:50:00',2.1),('8784','2014-03-12','08:55:00',2.19),('8784','2014-03-12','09:00:00',2.27),('8784','2014-03-12','09:05:00',2.34),('8784','2014-03-12','09:10:00',2.4),('8784','2014-03-12','09:15:00',2.47),('8784','2014-03-12','09:20:00',2.56),('8784','2014-03-12','09:25:00',2.63),('8784','2014-03-12','09:30:00',2.69),('8784','2014-03-12','09:35:00',2.74),('8784','2014-03-12','09:40:00',2.81),('8784','2014-03-12','09:45:00',2.87),('8784','2014-03-12','09:50:00',2.92),('8784','2014-03-12','09:55:00',2.99),('8784','2014-03-12','10:00:00',3.06),('8784','2014-03-12','10:05:00',3.05),('8784','2014-03-12','10:10:00',3.17),('8784','2014-03-12','10:15:00',3.21),('8784','2014-03-12','10:20:00',3.24),('8784','2014-03-12','10:25:00',3.28),('8784','2014-03-12','10:30:00',3.33),('8784','2014-03-12','10:35:00',3.37),('8784','2014-03-12','10:40:00',3.44),('8784','2014-03-12','10:45:00',3.5),('8784','2014-03-12','10:50:00',3.54),('8784','2014-03-12','10:55:00',3.55),('8784','2014-03-12','11:00:00',3.59),('8784','2014-03-12','11:05:00',3.63),('8784','2014-03-12','11:10:00',3.66),('8784','2014-03-12','11:15:00',3.7),('8784','2014-03-12','11:20:00',3.72),('8784','2014-03-12','11:25:00',3.74),('8784','2014-03-12','11:30:00',3.77),('8784','2014-03-12','11:35:00',3.77),('8784','2014-03-12','11:40:00',3.8),('8784','2014-03-12','11:45:00',3.8),('8784','2014-03-12','11:50:00',3.8),('8784','2014-03-12','11:55:00',3.81),('8784','2014-03-12','12:00:00',3.81),('8784','2014-03-12','12:05:00',3.8),('8784','2014-03-12','12:10:00',3.81),('8784','2014-03-12','12:15:00',3.79),('8784','2014-03-12','12:20:00',3.77),('8784','2014-03-12','12:25:00',3.78),('8784','2014-03-12','12:30:00',3.75),('8784','2014-03-12','12:35:00',3.75),('8784','2014-03-12','12:40:00',3.73),('8784','2014-03-12','12:45:00',3.7),('8784','2014-03-12','12:50:00',3.69),('8784','2014-03-12','12:55:00',3.68),('8784','2014-03-12','13:00:00',3.66),('8784','2014-03-12','13:05:00',3.63),('8784','2014-03-12','13:10:00',3.57),('8784','2014-03-12','13:15:00',3.57),('8784','2014-03-12','13:20:00',3.58),('8784','2014-03-12','13:25:00',3.53),('8784','2014-03-12','13:30:00',3.51),('8784','2014-03-12','13:35:00',3.44),('8784','2014-03-12','13:40:00',3.4),('8784','2014-03-12','13:45:00',3.38),('8784','2014-03-12','13:50:00',3.32),('8784','2014-03-12','13:55:00',3.28),('8784','2014-03-12','14:00:00',3.28),('8784','2014-03-12','14:05:00',3.24),('8784','2014-03-12','14:10:00',3.18),('8784','2014-03-12','14:15:00',3.14),('8784','2014-03-12','14:20:00',3.09),('8784','2014-03-12','14:25:00',3.02),('8784','2014-03-12','14:30:00',2.99),('8784','2014-03-12','14:35:00',2.84),('8784','2014-03-12','14:40:00',2.78),('8784','2014-03-12','14:45:00',2.69),('8784','2014-03-12','14:50:00',2.65),('8784','2014-03-12','14:55:00',2.57),('8784','2014-03-12','15:00:00',2.3),('8784','2014-03-12','15:05:00',2.41),('8784','2014-03-12','15:10:00',2.35),('8784','2014-03-12','15:15:00',2.26),('8784','2014-03-12','15:20:00',2.21),('8784','2014-03-12','15:25:00',2.1),('8784','2014-03-12','15:30:00',2.02),('8784','2014-03-12','15:35:00',1.95),('8784','2014-03-12','15:40:00',1.9),('8784','2014-03-12','15:45:00',1.84),('8784','2014-03-12','15:50:00',1.77),('8784','2014-03-12','15:55:00',1.68),('8784','2014-03-12','16:00:00',1.63),('8784','2014-03-12','16:05:00',1.53),('8784','2014-03-12','16:10:00',1.43),('8784','2014-03-12','16:15:00',1.36),('8784','2014-03-12','16:20:00',1.27),('8784','2014-03-12','16:25:00',1.18),('8784','2014-03-12','16:30:00',1.09),('8784','2014-03-12','16:35:00',1.03),('8784','2014-03-11','10:25:00',1),('8784','2014-03-11','10:30:00',1.04),('8784','2014-03-11','10:35:00',1.03),('8784','2014-03-11','10:40:00',1.03),('8784','2014-03-11','11:00:00',1.07),('8784','2014-03-11','11:05:00',1.11),('8784','2014-03-11','11:10:00',1.11),('8784','2014-03-11','11:15:00',1.13),('8784','2014-03-11','11:20:00',1.03),('8784','2014-03-11','11:40:00',1.08),('8784','2014-03-11','11:45:00',1.13),('8784','2014-03-11','11:55:00',1.08),('8784','2014-03-11','12:00:00',1.14),('8784','2014-03-11','12:05:00',1.14),('8784','2014-03-11','12:10:00',1.18),('8784','2014-03-11','12:15:00',1.33),('8784','2014-03-11','12:20:00',1.43),('8784','2014-03-11','12:25:00',1.3),('8784','2014-03-11','12:30:00',1.25),('8784','2014-03-11','12:35:00',1.35),('8784','2014-03-11','12:40:00',1.49),('8784','2014-03-11','12:45:00',1.46),('8784','2014-03-11','12:50:00',1.4),('8784','2014-03-11','12:55:00',1.29),('8784','2014-03-11','13:00:00',1.24),('8784','2014-03-11','13:05:00',1.42),('8784','2014-03-11','13:10:00',1.42),('8784','2014-03-11','13:15:00',1.36),('8784','2014-03-11','13:20:00',1.42),('8784','2014-03-11','13:25:00',1.24),('8784','2014-03-11','13:30:00',1.2),('8784','2014-03-11','13:35:00',1.15),('8784','2014-03-11','13:40:00',1.19),('8784','2014-03-11','13:45:00',1.46),('8784','2014-03-11','13:50:00',1.7),('8784','2014-03-11','13:55:00',1.97),('8784','2014-03-11','14:00:00',2.05),('8784','2014-03-11','14:05:00',2.07),('8784','2014-03-11','14:10:00',2.5),('8784','2014-03-11','14:15:00',2.67),('8784','2014-03-11','14:20:00',2.34),('8784','2014-03-11','14:25:00',2.08),('8784','2014-03-11','14:30:00',1.5),('8784','2014-03-11','14:35:00',1.58),('8784','2014-03-11','14:40:00',1.5),('8784','2014-03-11','14:45:00',1.59),('8784','2014-03-11','14:50:00',1.45),('8784','2014-03-11','14:55:00',1.43),('8784','2014-03-11','15:00:00',1.63),('8784','2014-03-11','15:05:00',1.73),('8784','2014-03-11','15:10:00',1.82),('8784','2014-03-11','15:15:00',1.71),('8784','2014-03-11','15:20:00',1.87),('8784','2014-03-11','15:25:00',1.44),('8784','2014-03-11','15:30:00',1.35),('8784','2014-03-11','15:35:00',1.22),('8784','2014-03-11','15:40:00',1.18),('8784','2014-03-11','15:45:00',1.13),('8784','2014-03-11','15:50:00',1.12),('8784','2014-03-10','08:55:00',1.01),('8784','2014-03-10','09:00:00',1.03),('8784','2014-03-10','09:05:00',1.12),('8784','2014-03-10','09:10:00',1.12),('8784','2014-03-10','09:15:00',1.07),('8784','2014-03-10','09:20:00',1.01),('8784','2014-03-10','09:25:00',1.05),('8784','2014-03-10','09:30:00',1.1),('8784','2014-03-10','09:35:00',1.11),('8784','2014-03-10','09:40:00',1.15),('8784','2014-03-10','09:45:00',1.05),('8784','2014-03-10','10:10:00',1.08),('8784','2014-03-10','10:15:00',1.25),('8784','2014-03-10','10:20:00',1.02),('8784','2014-03-10','10:30:00',1.15),('8784','2014-03-10','10:35:00',1.32),('8784','2014-03-10','11:20:00',1.07),('8784','2014-03-10','12:45:00',1.09),('8784','2014-03-10','12:50:00',1.21),('8784','2014-03-10','12:55:00',1.29),('8784','2014-03-10','13:00:00',1.35),('8784','2014-03-10','13:05:00',1.36),('8784','2014-03-10','13:10:00',1.46),('8784','2014-03-10','13:15:00',1.59),('8784','2014-03-10','13:20:00',1.59),('8784','2014-03-10','13:25:00',1.43),('8784','2014-03-10','13:30:00',1.22),('8784','2014-03-10','13:35:00',1.01),('8784','2014-03-10','13:50:00',1.28),('8784','2014-03-10','13:55:00',1.38),('8784','2014-03-10','14:00:00',1.23),('8784','2014-03-10','14:05:00',1.82),('8784','2014-03-10','14:10:00',2.27),('8784','2014-03-10','14:15:00',3.09),('8784','2014-03-10','14:20:00',2.24),('8784','2014-03-10','14:25:00',1.68),('8784','2014-03-10','14:30:00',1.42),('8784','2014-03-10','14:35:00',1.95),('8784','2014-03-10','14:40:00',2.65),('8784','2014-03-10','14:45:00',2.73),('8784','2014-03-10','14:50:00',2.6),('8784','2014-03-10','14:55:00',1.33),('8784','2014-03-10','15:00:00',1.75),('8784','2014-03-10','15:05:00',1.34),('8784','2014-03-10','15:10:00',1),('8784','2014-03-10','15:15:00',1.21),('8784','2014-03-10','15:20:00',1.82),('8784','2014-03-10','15:25:00',2.35),('8784','2014-03-10','15:30:00',1.65),('8784','2014-03-10','15:35:00',1.11),('8784','2014-03-10','15:40:00',1.06),('8784','2014-03-10','16:30:00',1),('8784','2014-03-09','07:55:00',1.05),('8784','2014-03-09','08:00:00',1.14),('8784','2014-03-09','08:05:00',1.23),('8784','2014-03-09','08:10:00',1.32),('8784','2014-03-09','08:15:00',1.41),('8784','2014-03-09','08:20:00',1.43),('8784','2014-03-09','08:25:00',1.33),('8784','2014-03-09','08:30:00',1.31),('8784','2014-03-09','08:35:00',1.2),('8784','2014-03-09','08:40:00',1.22),('8784','2014-03-09','08:45:00',1.14),('8784','2014-03-09','08:55:00',1.64),('8784','2014-03-09','09:00:00',2.05),('8784','2014-03-09','09:05:00',1.72),('8784','2014-03-09','09:15:00',2.37),('8784','2014-03-09','09:20:00',2.54),('8784','2014-03-09','09:25:00',2.69),('8784','2014-03-09','09:30:00',2.77),('8784','2014-03-09','09:35:00',2.99),('8784','2014-03-09','09:40:00',3.02),('8784','2014-03-09','09:45:00',3.08),('8784','2014-03-09','09:50:00',3.11),('8784','2014-03-09','09:55:00',3.09),('8784','2014-03-09','10:00:00',3.12),('8784','2014-03-09','10:05:00',3.16),('8784','2014-03-09','10:10:00',3.25),('8784','2014-03-09','10:15:00',3.28),('8784','2014-03-09','10:20:00',3.27),('8784','2014-03-09','10:25:00',3.22),('8784','2014-03-09','10:30:00',3.4),('8784','2014-03-09','10:35:00',3.43),('8784','2014-03-09','10:40:00',3.46),('8784','2014-03-09','10:45:00',3.51),('8784','2014-03-09','10:50:00',3.62),('8784','2014-03-09','10:55:00',3.72),('8784','2014-03-09','11:00:00',3.94),('8784','2014-03-09','11:05:00',3.93),('8784','2014-03-09','11:10:00',4.09),('8784','2014-03-09','11:15:00',4.22),('8784','2014-03-09','11:20:00',2.8),('8784','2014-03-09','11:25:00',1.94),('8784','2014-03-09','11:30:00',1.41),('8784','2014-03-09','11:35:00',2.77),('8784','2014-03-09','11:40:00',2.17),('8784','2014-03-09','11:45:00',1.95),('8784','2014-03-09','11:50:00',3.27),('8784','2014-03-09','11:55:00',3.49),('8784','2014-03-09','12:00:00',3.69),('8784','2014-03-09','12:05:00',4.31),('8784','2014-03-09','12:10:00',4.43),('8784','2014-03-09','12:15:00',4.38),('8784','2014-03-09','12:20:00',4.32),('8784','2014-03-09','12:25:00',4.23),('8784','2014-03-09','12:30:00',4.25),('8784','2014-03-09','12:35:00',4.4),('8784','2014-03-09','12:40:00',4.14),('8784','2014-03-09','12:45:00',4.04),('8784','2014-03-09','12:50:00',4.07),('8784','2014-03-09','12:55:00',4.12),('8784','2014-03-09','13:00:00',4.22),('8784','2014-03-09','13:05:00',4.23),('8784','2014-03-09','13:10:00',4.2),('8784','2014-03-09','13:15:00',3.89),('8784','2014-03-09','13:20:00',3.8),('8784','2014-03-09','13:25:00',3.73),('8784','2014-03-09','13:30:00',3.69),('8784','2014-03-09','13:35:00',3.52),('8784','2014-03-09','13:45:00',1.03),('8784','2014-03-09','13:50:00',2.96),('8784','2014-03-09','14:00:00',2.12),('8784','2014-03-09','14:05:00',3.47),('8784','2014-03-09','14:10:00',3.36),('8784','2014-03-09','14:15:00',3.14),('8784','2014-03-09','14:20:00',1.74),('8784','2014-03-09','14:25:00',3.14),('8784','2014-03-09','14:30:00',1.16),('8784','2014-03-09','14:45:00',2.46),('8784','2014-03-09','14:50:00',1.6),('8784','2014-03-09','14:55:00',2.82),('8784','2014-03-09','15:00:00',2.7),('8784','2014-03-09','15:05:00',2.12),('8784','2014-03-09','15:10:00',2.48),('8784','2014-03-09','15:15:00',2.42),('8784','2014-03-09','15:20:00',2.39),('8784','2014-03-09','15:25:00',2.36),('8784','2014-03-09','15:30:00',2.3),('8784','2014-03-09','15:35:00',2.18),('8784','2014-03-09','15:40:00',2.05),('8784','2014-03-09','15:45:00',1.67),('8784','2014-03-09','15:55:00',1.38),('8784','2014-03-09','16:00:00',1.78),('8784','2014-03-09','16:05:00',1.59),('8784','2014-03-09','16:10:00',1.13),('8784','2014-03-09','16:15:00',1.05),('8784','2014-03-09','16:25:00',1.17),('8784','2014-03-09','16:30:00',1.12),('8784','2014-03-09','16:35:00',1.09),('8784','2014-03-09','16:40:00',1.05),('8784','2014-03-08','07:55:00',1.03),('8784','2014-03-08','08:00:00',1.12),('8784','2014-03-08','08:05:00',1.21),('8784','2014-03-08','08:10:00',1.29),('8784','2014-03-08','08:15:00',1.38),('8784','2014-03-08','08:20:00',1.47),('8784','2014-03-08','08:25:00',1.55),('8784','2014-03-08','08:30:00',1.65),('8784','2014-03-08','08:35:00',1.73),('8784','2014-03-08','08:40:00',1.83),('8784','2014-03-08','08:45:00',1.91),('8784','2014-03-08','08:50:00',1.96),('8784','2014-03-08','08:55:00',2.06),('8784','2014-03-08','09:00:00',2.15),('8784','2014-03-08','09:05:00',2.23),('8784','2014-03-08','09:10:00',2.31),('8784','2014-03-08','09:15:00',2.38),('8784','2014-03-08','09:20:00',2.46),('8784','2014-03-08','09:25:00',2.54),('8784','2014-03-08','09:30:00',2.62),('8784','2014-03-08','09:35:00',2.67),('8784','2014-03-08','09:40:00',2.72),('8784','2014-03-08','09:45:00',2.79),('8784','2014-03-08','09:50:00',2.85),('8784','2014-03-08','09:55:00',2.9),('8784','2014-03-08','10:00:00',2.97),('8784','2014-03-08','10:05:00',3.02),('8784','2014-03-08','10:10:00',3.08),('8784','2014-03-08','10:15:00',3.13),('8784','2014-03-08','10:20:00',3.19),('8784','2014-03-08','10:25:00',3.23),('8784','2014-03-08','10:30:00',3.3),('8784','2014-03-08','10:35:00',3.35),('8784','2014-03-08','10:40:00',3.39),('8784','2014-03-08','10:45:00',3.44),('8784','2014-03-08','10:50:00',3.47),('8784','2014-03-08','10:55:00',3.5),('8784','2014-03-08','11:00:00',3.54),('8784','2014-03-08','11:05:00',3.56),('8784','2014-03-08','11:10:00',3.59),('8784','2014-03-08','11:15:00',3.65),('8784','2014-03-08','11:20:00',3.71),('8784','2014-03-08','11:25:00',3.82),('8784','2014-03-08','11:30:00',4),('8784','2014-03-08','11:35:00',3.58),('8784','2014-03-08','11:40:00',2.62),('8784','2014-03-08','11:45:00',1.77),('8784','2014-03-08','11:50:00',1.53),('8784','2014-03-08','11:55:00',2.73),('8784','2014-03-08','12:00:00',2.25),('8784','2014-03-08','12:05:00',1.11),('8784','2014-03-08','12:10:00',1.15),('8784','2014-03-08','12:15:00',1.22),('8784','2014-03-08','12:20:00',1.4),('8784','2014-03-08','12:25:00',1.55),('8784','2014-03-08','12:30:00',1.67),('8784','2014-03-08','12:35:00',3.38),('8784','2014-03-08','12:40:00',2.1),('8784','2014-03-08','12:45:00',2.33),('8784','2014-03-08','12:50:00',2.52),('8784','2014-03-08','12:55:00',3.33),('8784','2014-03-08','13:00:00',2.09),('8784','2014-03-08','13:05:00',1.77),('8784','2014-03-08','13:10:00',1.56),('8784','2014-03-08','13:15:00',1.25),('8784','2014-03-08','13:20:00',1.06),('8784','2014-03-08','13:25:00',1.09),('8784','2014-03-08','13:30:00',1.65),('8784','2014-03-08','13:35:00',1.71),('8784','2014-03-08','13:40:00',2.34),('8784','2014-03-08','13:45:00',2.58),('8784','2014-03-08','13:50:00',2.32),('8784','2014-03-08','13:55:00',1.48),('8784','2014-03-08','14:00:00',1.18),('8784','2014-03-08','14:05:00',1.12),('8784','2014-03-08','14:10:00',1.03),('8784','2014-03-08','14:35:00',1.02),('8784','2014-03-08','14:40:00',1.1),('8784','2014-03-08','14:45:00',1.03),('8784','2014-03-08','14:50:00',1.05),('8784','2014-03-08','14:55:00',1.11),('8784','2014-03-08','15:15:00',1.27),('8784','2014-03-08','15:20:00',1.61),('8784','2014-03-08','15:25:00',1.53),('8784','2014-03-08','15:30:00',1.79),('8784','2014-03-08','16:00:00',1),('8784','2014-03-08','16:30:00',1),('8784','2014-03-08','16:35:00',1.16),('8784','2014-04-30','07:35:00',1.02),('8784','2014-04-30','07:40:00',1.11),('8784','2014-04-30','07:45:00',1.23),('8784','2014-04-30','07:50:00',1.31),('8784','2014-04-30','07:55:00',1.4),('8784','2014-04-30','08:00:00',1.47),('8784','2014-04-30','08:05:00',1.5),('8784','2014-04-30','08:10:00',1.63),('8784','2014-04-30','08:15:00',1.74),('8784','2014-04-30','08:20:00',1.82),('8784','2014-04-30','08:25:00',1.89),('8784','2014-04-30','08:30:00',1.93),('8784','2014-04-30','08:35:00',2.05),('8784','2014-04-30','08:40:00',2.12),('8784','2014-04-30','08:45:00',2.2),('8784','2014-04-30','08:50:00',2.29),('8784','2014-04-30','08:55:00',2.35),('8784','2014-04-30','09:00:00',2.63),('8784','2014-04-30','09:05:00',2.64),('8784','2014-04-30','09:10:00',2.83),('8784','2014-04-30','09:15:00',1.78),('8784','2014-04-30','09:20:00',2.46),('8784','2014-04-30','09:25:00',2.37),('8784','2014-04-30','09:30:00',1.79),('8784','2014-04-30','09:35:00',3.21),('8784','2014-04-30','09:40:00',3.22),('8784','2014-04-30','09:45:00',2.53),('8784','2014-04-30','09:50:00',2.09),('8784','2014-04-30','09:55:00',3.25),('8784','2014-04-30','10:00:00',3.86),('8784','2014-04-30','10:05:00',2.17),('8784','2014-04-30','10:10:00',2.84),('8784','2014-04-30','10:15:00',2.58),('8784','2014-04-30','10:20:00',1.83),('8784','2014-04-30','10:25:00',1.83),('8784','2014-04-30','10:30:00',2.09),('8784','2014-04-30','10:35:00',2.29),('8784','2014-04-30','10:40:00',2.32),('8784','2014-04-30','10:45:00',1.78),('8784','2014-04-30','10:50:00',2.11),('8784','2014-04-30','10:55:00',4.48),('8784','2014-04-30','11:00:00',4.27),('8784','2014-04-30','11:05:00',3.31),('8784','2014-04-30','11:10:00',3.11),('8784','2014-04-30','11:15:00',2.26),('8784','2014-04-30','11:20:00',2.33),('8784','2014-04-30','11:25:00',2.46),('8784','2014-04-30','11:30:00',2.35),('8784','2014-04-30','11:35:00',3.57),('8784','2014-04-30','11:40:00',2.97),('8784','2014-04-30','11:45:00',2.95),('8784','2014-04-30','11:50:00',4.13),('8784','2014-04-30','11:55:00',3.76),('8784','2014-04-30','12:00:00',3.17),('8784','2014-04-30','12:05:00',1.56),('8784','2014-04-30','12:10:00',1.51),('8784','2014-04-30','12:15:00',2.06),('8784','2014-04-30','12:20:00',1.86),('8784','2014-04-30','12:25:00',1.69),('8784','2014-04-30','12:30:00',2.19),('8784','2014-04-30','12:35:00',2),('8784','2014-04-30','12:40:00',1.61),('8784','2014-04-30','12:45:00',1.5),('8784','2014-04-30','12:50:00',2.01),('8784','2014-04-30','12:55:00',4.87),('8784','2014-04-30','13:00:00',4.18),('8784','2014-04-30','13:05:00',2.91),('8784','2014-04-30','13:10:00',3.95),('8784','2014-04-30','13:15:00',2.35),('8784','2014-04-30','13:20:00',2.52),('8784','2014-04-30','13:25:00',3.57),('8784','2014-04-30','13:30:00',2.2),('8784','2014-04-30','13:35:00',2.45),('8784','2014-04-30','13:40:00',3.76),('8784','2014-04-30','13:45:00',3.69),('8784','2014-04-30','13:50:00',3.07),('8784','2014-04-30','13:55:00',3.93),('8784','2014-04-30','14:00:00',2.19),('8784','2014-04-30','14:05:00',1.99),('8784','2014-04-30','14:10:00',1.77),('8784','2014-04-30','14:15:00',2.09),('8784','2014-04-30','14:20:00',4.11),('8784','2014-04-30','14:25:00',4.36),('8784','2014-04-30','14:30:00',4.77),('8784','2014-04-30','14:35:00',3.77),('8784','2014-04-30','14:40:00',2.24),('8784','2014-04-30','14:45:00',1.56),('8784','2014-04-30','14:50:00',1.86),('8784','2014-04-30','14:55:00',2.01),('8784','2014-04-30','15:00:00',1.69),('8784','2014-04-30','15:05:00',1.66),('8784','2014-04-30','15:10:00',1.78),('8784','2014-04-30','15:15:00',1.47),('8784','2014-04-30','15:20:00',1.37),('8784','2014-04-30','15:25:00',1.52),('8784','2014-04-30','15:30:00',1.92),('8784','2014-04-30','15:35:00',3.44),('8784','2014-04-30','15:40:00',4.88),('8784','2014-04-30','15:45:00',3.78),('8784','2014-04-30','15:50:00',4.18),('8784','2014-04-30','15:55:00',2.81),('8784','2014-04-30','16:00:00',1.59),('8784','2014-04-30','16:05:00',2.12),('8784','2014-04-30','16:10:00',2.26),('8784','2014-04-30','16:15:00',3.44),('8784','2014-04-30','16:20:00',2.1),('8784','2014-04-30','16:25:00',2.22),('8784','2014-04-30','16:30:00',2.19),('8784','2014-04-30','16:35:00',1.45),('8784','2014-04-30','16:40:00',2.68),('8784','2014-04-30','16:45:00',1.71),('8784','2014-04-30','16:50:00',2.67),('8784','2014-04-30','16:55:00',2.81),('8784','2014-04-30','17:00:00',2.13),('8784','2014-04-30','17:05:00',1.95),('8784','2014-04-30','17:15:00',1.02),('8784','2014-04-30','17:20:00',1.08),('8784','2014-04-30','17:35:00',1.12),('8784','2014-04-30','17:40:00',1.15),('8784','2014-03-07','11:20:00',1.02),('8784','2014-03-07','11:25:00',1.02),('8784','2014-03-07','11:30:00',1.12),('8784','2014-03-07','11:35:00',1.05),('8784','2014-03-07','11:45:00',2.02),('8784','2014-03-07','11:50:00',3.06),('8784','2014-03-07','11:55:00',3.84),('8784','2014-03-07','12:00:00',4.64),('8784','2014-03-07','12:05:00',3.77),('8784','2014-03-07','12:10:00',4.26),('8784','2014-03-07','12:15:00',4.12),('8784','2014-03-07','12:20:00',4.15),('8784','2014-03-07','12:25:00',4.12),('8784','2014-03-07','12:30:00',2.43),('8784','2014-03-07','12:35:00',3.75),('8784','2014-03-07','12:40:00',2.4),('8784','2014-03-07','12:45:00',1.02),('8784','2014-03-07','12:50:00',1.33),('8784','2014-03-07','13:00:00',3.19),('8784','2014-03-07','13:05:00',3.3),('8784','2014-03-07','13:10:00',1.61),('8784','2014-03-07','13:15:00',1.29),('8784','2014-03-07','13:20:00',2.49),('8784','2014-03-07','13:25:00',3.54),('8784','2014-03-07','13:30:00',3.37),('8784','2014-03-07','13:35:00',2.76),('8784','2014-03-07','13:40:00',2.8),('8784','2014-03-07','13:45:00',2.46),('8784','2014-03-07','13:50:00',1.61),('8784','2014-03-07','13:55:00',1.29),('8784','2014-03-07','14:00:00',1.23),('8784','2014-03-07','14:05:00',1.18),('8784','2014-03-07','14:10:00',1.2),('8784','2014-03-07','14:15:00',1.19),('8784','2014-03-07','14:20:00',1.16),('8784','2014-03-07','14:25:00',1.13),('8784','2014-03-07','14:30:00',1.19),('8784','2014-03-07','14:35:00',1.24),('8784','2014-03-07','14:40:00',1.31),('8784','2014-03-07','14:45:00',1.31),('8784','2014-03-07','14:50:00',1.67),('8784','2014-03-07','14:55:00',2.38),('8784','2014-03-07','15:00:00',2.83),('8784','2014-03-07','15:05:00',3.08),('8784','2014-03-07','15:10:00',3.08),('8784','2014-03-07','15:15:00',3.11),('8784','2014-03-07','15:20:00',3.11),('8784','2014-03-07','15:25:00',2.97),('8784','2014-03-07','15:30:00',2.84),('8784','2014-03-07','15:35:00',2.66),('8784','2014-03-07','15:40:00',1.97),('8784','2014-03-07','15:45:00',2.15),('8784','2014-03-07','15:50:00',1.67),('8784','2014-03-07','15:55:00',1.25),('8784','2014-03-07','16:00:00',1.78),('8784','2014-03-07','16:05:00',1.72),('8784','2014-03-07','16:10:00',1.65),('8784','2014-03-07','16:15:00',1.65),('8784','2014-03-07','16:20:00',1.48),('8784','2014-03-07','16:25:00',1.39),('8784','2014-03-07','16:30:00',1.27),('8784','2014-03-07','16:35:00',1.21),('8784','2014-03-07','16:40:00',1.25),('8784','2014-03-07','16:45:00',1.19),('8784','2014-03-07','16:50:00',1.12),('8784','2014-03-07','16:55:00',1.05),('8784','2014-03-06','08:00:00',1.39),('8784','2014-03-06','08:05:00',1.16),('8784','2014-03-06','08:10:00',1.46),('8784','2014-03-06','08:15:00',1.9),('8784','2014-03-06','08:20:00',1.77),('8784','2014-03-06','08:25:00',1.48),('8784','2014-03-06','08:45:00',1),('8784','2014-03-06','09:15:00',1.12),('8784','2014-03-06','09:20:00',1.22),('8784','2014-03-06','09:25:00',1.04),('8784','2014-03-06','09:30:00',1.05),('8784','2014-03-06','09:35:00',1.23),('8784','2014-03-06','09:40:00',1.38),('8784','2014-03-06','09:45:00',1.54),('8784','2014-03-06','09:50:00',1.75),('8784','2014-03-06','09:55:00',2.14),('8784','2014-03-06','10:00:00',2.24),('8784','2014-03-06','10:05:00',2.37),('8784','2014-03-06','10:10:00',2.58),('8784','2014-03-06','10:15:00',3.1),('8784','2014-03-06','10:20:00',3.06),('8784','2014-03-06','10:25:00',1.75),('8784','2014-03-06','10:30:00',1.05),('8784','2014-03-06','10:35:00',1.23),('8784','2014-03-06','10:40:00',2.41),('8784','2014-03-06','10:45:00',1.22),('8784','2014-03-06','10:50:00',1.76),('8784','2014-03-06','10:55:00',1.45),('8784','2014-03-06','11:00:00',2.91),('8784','2014-03-06','11:05:00',3.27),('8784','2014-03-06','11:10:00',2.86),('8784','2014-03-06','11:15:00',2.48),('8784','2014-03-06','11:20:00',2.36),('8784','2014-03-06','11:25:00',2.35),('8784','2014-03-06','11:30:00',1.66),('8784','2014-03-06','11:35:00',1.42),('8784','2014-03-06','11:40:00',1.79),('8784','2014-03-06','11:45:00',3.17),('8784','2014-03-06','11:50:00',3.44),('8784','2014-03-06','11:55:00',3.63),('8784','2014-03-06','12:00:00',1.55),('8784','2014-03-06','12:05:00',2.65),('8784','2014-03-06','12:10:00',3.97),('8784','2014-03-06','12:15:00',2.9),('8784','2014-03-06','12:20:00',1.42),('8784','2014-03-06','12:25:00',2.27),('8784','2014-03-06','12:30:00',4.11),('8784','2014-03-06','12:35:00',2.03),('8784','2014-03-06','12:40:00',1.54),('8784','2014-03-06','12:45:00',1.15),('8784','2014-03-06','12:50:00',1.13),('8784','2014-03-06','12:55:00',1.38),('8784','2014-03-06','13:00:00',1.68),('8784','2014-03-06','13:05:00',1.45),('8784','2014-03-06','13:10:00',1.35),('8784','2014-03-06','13:15:00',1.47),('8784','2014-03-06','13:20:00',1.21),('8784','2014-03-06','13:25:00',1.09),('8784','2014-03-06','13:30:00',1.2),('8784','2014-03-06','13:35:00',1.14),('8784','2014-03-06','13:40:00',1.26),('8784','2014-03-06','13:45:00',1.12),('8784','2014-03-06','13:50:00',1.01),('8784','2014-03-06','14:05:00',1.15),('8784','2014-03-06','14:10:00',1.17),('8784','2014-03-06','14:15:00',1.11),('8784','2014-03-06','14:20:00',1.34),('8784','2014-03-06','14:25:00',1.24),('8784','2014-03-06','14:30:00',1.14),('8784','2014-03-06','14:35:00',1.81),('8784','2014-03-06','14:40:00',1.35),('8784','2014-03-06','15:00:00',1.04),('8784','2014-03-06','15:05:00',1.33),('8784','2014-03-06','15:10:00',1.22),('8784','2014-03-05','07:40:00',1.08),('8784','2014-03-05','07:45:00',1.16),('8784','2014-03-05','07:50:00',1.23),('8784','2014-03-05','07:55:00',1.29),('8784','2014-03-05','08:00:00',1.29),('8784','2014-03-05','08:05:00',1.35),('8784','2014-03-05','08:10:00',1.48),('8784','2014-03-05','08:15:00',1.61),('8784','2014-03-05','08:30:00',1.04),('8784','2014-03-05','08:35:00',2.31),('8784','2014-03-05','08:40:00',2.03),('8784','2014-03-05','08:45:00',2.26),('8784','2014-03-05','08:50:00',1.5),('8784','2014-03-05','09:00:00',1.96),('8784','2014-03-05','09:05:00',2.1),('8784','2014-03-05','09:15:00',2.29),('8784','2014-03-05','09:20:00',2.55),('8784','2014-03-05','09:25:00',2.56),('8784','2014-03-05','09:30:00',2.61),('8784','2014-03-05','09:35:00',2.47),('8784','2014-03-05','09:40:00',2.75),('8784','2014-03-05','09:45:00',2.81),('8784','2014-03-05','09:50:00',2.86),('8784','2014-03-05','09:55:00',2.93),('8784','2014-03-05','10:00:00',2.99),('8784','2014-03-05','10:05:00',3.06),('8784','2014-03-05','10:10:00',3.15),('8784','2014-03-05','10:15:00',3.15),('8784','2014-03-05','10:20:00',3.12),('8784','2014-03-05','10:25:00',3.23),('8784','2014-03-05','10:30:00',3.26),('8784','2014-03-05','10:35:00',3.31),('8784','2014-03-05','10:40:00',3.33),('8784','2014-03-05','10:45:00',3.37),('8784','2014-03-05','10:50:00',3.41),('8784','2014-03-05','10:55:00',3.45),('8784','2014-03-05','11:00:00',3.51),('8784','2014-03-05','11:05:00',3.58),('8784','2014-03-05','11:10:00',3.6),('8784','2014-03-05','11:15:00',3.66),('8784','2014-03-05','11:20:00',3.7),('8784','2014-03-05','11:25:00',3.73),('8784','2014-03-05','11:30:00',3.79),('8784','2014-03-05','11:35:00',3.91),('8784','2014-03-05','11:40:00',3.85),('8784','2014-03-05','11:45:00',3.89),('8784','2014-03-05','11:50:00',3.83),('8784','2014-03-05','11:55:00',3.23),('8784','2014-03-05','12:00:00',3.44),('8784','2014-03-05','12:05:00',3.03),('8784','2014-03-05','12:10:00',2.04),('8784','2014-03-05','12:15:00',1.06),('8784','2014-03-05','12:30:00',1.29),('8784','2014-03-05','12:35:00',1.66),('8784','2014-03-05','12:40:00',1.81),('8784','2014-03-05','12:45:00',1.14),('8784','2014-03-05','12:50:00',1.55),('8784','2014-03-05','12:55:00',1.48),('8784','2014-03-05','13:00:00',1.99),('8784','2014-03-05','13:05:00',2.75),('8784','2014-03-05','13:10:00',3.34),('8784','2014-03-05','13:15:00',2.56),('8784','2014-03-05','13:20:00',2.28),('8784','2014-03-05','13:25:00',1.56),('8784','2014-03-05','13:30:00',1.29),('8784','2014-03-05','13:35:00',1.37),('8784','2014-03-05','13:40:00',1.64),('8784','2014-03-05','13:45:00',1.56),('8784','2014-03-05','13:50:00',1.33),('8784','2014-03-05','13:55:00',1.21),('8784','2014-03-05','14:00:00',1.13),('8784','2014-03-05','14:05:00',1.19),('8784','2014-03-05','14:10:00',1.14),('8784','2014-03-05','14:15:00',1.27),('8784','2014-03-05','14:20:00',1.33),('8784','2014-03-05','14:25:00',1.52),('8784','2014-03-05','14:30:00',1.51),('8784','2014-03-05','14:35:00',1.33),('8784','2014-03-05','14:40:00',1.72),('8784','2014-03-05','14:45:00',2.6),('8784','2014-03-05','14:50:00',2.84),('8784','2014-03-05','14:55:00',1.94),('8784','2014-03-05','15:00:00',1.01),('8784','2014-03-05','15:30:00',1.05),('8784','2014-03-05','15:35:00',1.23),('8784','2014-03-05','15:40:00',1.54),('8784','2014-03-05','15:45:00',1.93),('8784','2014-03-05','15:50:00',1.37),('8784','2014-03-05','15:55:00',2.03),('8784','2014-03-05','16:00:00',2.7),('8784','2014-03-05','16:05:00',2.39),('8784','2014-03-05','16:10:00',1.99),('8784','2014-03-05','16:15:00',1.43),('8784','2014-03-04','09:05:00',1.11),('8784','2014-03-04','09:10:00',1.36),('8784','2014-03-04','09:15:00',2.26),('8784','2014-03-04','09:20:00',2.25),('8784','2014-03-04','09:30:00',1.05),('8784','2014-03-04','09:35:00',1.04),('8784','2014-03-04','09:40:00',1.26),('8784','2014-03-04','09:45:00',1.14),('8784','2014-03-04','09:55:00',1.98),('8784','2014-03-04','10:00:00',1.41),('8784','2014-03-04','10:05:00',1.01),('8784','2014-03-04','10:20:00',1.02),('8784','2014-03-04','10:25:00',3.26),('8784','2014-03-04','10:30:00',2),('8784','2014-03-04','10:35:00',3.5),('8784','2014-03-04','10:40:00',4.06),('8784','2014-03-04','10:45:00',3.74),('8784','2014-03-04','10:50:00',1.07),('8784','2014-03-04','10:55:00',3.29),('8784','2014-03-04','11:00:00',2.1),('8784','2014-03-04','11:05:00',2.37),('8784','2014-03-04','11:10:00',4),('8784','2014-03-04','11:15:00',4.53),('8784','2014-03-04','11:20:00',2.69),('8784','2014-03-04','11:25:00',1.11),('8784','2014-03-04','11:30:00',1.12),('8784','2014-03-04','11:40:00',1),('8784','2014-03-04','11:45:00',2.01),('8784','2014-03-04','11:50:00',4.78),('8784','2014-03-04','11:55:00',4.07),('8784','2014-03-04','12:00:00',3.94),('8784','2014-03-04','12:05:00',3.83),('8784','2014-03-04','12:10:00',3.82),('8784','2014-03-04','12:15:00',3.78),('8784','2014-03-04','12:20:00',3.79),('8784','2014-03-04','12:25:00',3.78),('8784','2014-03-04','12:30:00',3.72),('8784','2014-03-04','12:35:00',3.71),('8784','2014-03-04','12:40:00',3.72),('8784','2014-03-04','12:45:00',2.5),('8784','2014-03-04','12:50:00',3.33),('8784','2014-03-04','12:55:00',2.34),('8784','2014-03-04','13:00:00',3.81),('8784','2014-03-04','13:05:00',3.24),('8784','2014-03-04','13:10:00',4.04),('8784','2014-03-04','13:15:00',2.42),('8784','2014-03-04','13:20:00',1.8),('8784','2014-03-04','13:25:00',1.05),('8784','2014-03-04','13:30:00',1.12),('8784','2014-03-04','13:45:00',1.23),('8784','2014-03-04','13:50:00',1.36),('8784','2014-03-04','13:55:00',1.19),('8784','2014-03-04','14:05:00',1.69),('8784','2014-03-04','14:10:00',2.42),('8784','2014-03-04','14:15:00',3.43),('8784','2014-03-04','14:20:00',1.89),('8784','2014-03-04','14:25:00',3.44),('8784','2014-03-04','14:30:00',3.03),('8784','2014-03-04','14:35:00',2.89),('8784','2014-03-04','14:40:00',2.82),('8784','2014-03-04','14:45:00',2.65),('8784','2014-03-04','14:50:00',2.99),('8784','2014-03-04','14:55:00',1.87),('8784','2014-03-04','15:00:00',2.81),('8784','2014-03-04','15:05:00',2.59),('8784','2014-03-04','15:10:00',2.41),('8784','2014-03-04','15:15:00',2.09),('8784','2014-03-04','15:20:00',1.23),('8784','2014-03-04','15:25:00',1.92),('8784','2014-03-04','15:30:00',1.03),('8784','2014-03-04','15:35:00',2.56),('8784','2014-03-04','15:40:00',2.12),('8784','2014-03-04','15:45:00',1.66),('8784','2014-03-04','15:50:00',1.49),('8784','2014-03-04','16:20:00',1.03),('8784','2014-03-04','16:25:00',1.24),('8784','2014-03-03','08:10:00',1.21),('8784','2014-03-03','08:15:00',1.35),('8784','2014-03-03','08:20:00',1.43),('8784','2014-03-03','08:25:00',1.52),('8784','2014-03-03','08:30:00',1.61),('8784','2014-03-03','08:35:00',1.69),('8784','2014-03-03','08:40:00',1.8),('8784','2014-03-03','08:45:00',1.89),('8784','2014-03-03','08:50:00',1.84),('8784','2014-03-03','08:55:00',2.08),('8784','2014-03-03','09:00:00',2.12),('8784','2014-03-03','09:05:00',2.11),('8784','2014-03-03','09:10:00',1.96),('8784','2014-03-03','09:15:00',2.07),('8784','2014-03-03','09:20:00',2.29),('8784','2014-03-03','09:25:00',2.48),('8784','2014-03-03','09:30:00',2.52),('8784','2014-03-03','09:35:00',2.27),('8784','2014-03-03','09:40:00',1.99),('8784','2014-03-03','09:45:00',2.24),('8784','2014-03-03','09:50:00',2.29),('8784','2014-03-03','09:55:00',2.56),('8784','2014-03-03','10:00:00',2.79),('8784','2014-03-03','10:05:00',2.95),('8784','2014-03-03','10:10:00',2.97),('8784','2014-03-03','10:15:00',3.05),('8784','2014-03-03','10:20:00',3.1),('8784','2014-03-03','10:25:00',3.11),('8784','2014-03-03','10:30:00',3.16),('8784','2014-03-03','10:35:00',3.19),('8784','2014-03-03','10:40:00',3.23),('8784','2014-03-03','10:45:00',3.28),('8784','2014-03-03','10:50:00',3.28),('8784','2014-03-03','10:55:00',3.32),('8784','2014-03-03','11:00:00',3.37),('8784','2014-03-03','11:05:00',3.41),('8784','2014-03-03','11:10:00',3.42),('8784','2014-03-03','11:15:00',3.43),('8784','2014-03-03','11:20:00',3.48),('8784','2014-03-03','11:25:00',3.5),('8784','2014-03-03','11:30:00',3.39),('8784','2014-03-03','11:35:00',1.92),('8784','2014-03-03','11:40:00',3.73),('8784','2014-03-03','11:45:00',3.66),('8784','2014-03-03','11:50:00',3.72),('8784','2014-03-03','11:55:00',3.7),('8784','2014-03-03','12:00:00',3.69),('8784','2014-03-03','12:05:00',3.73),('8784','2014-03-03','12:10:00',3.73),('8784','2014-03-03','12:15:00',3.72),('8784','2014-03-03','12:20:00',3.72),('8784','2014-03-03','12:25:00',3.71),('8784','2014-03-03','12:30:00',3.71),('8784','2014-03-03','12:35:00',3.71),('8784','2014-03-03','12:40:00',3.69),('8784','2014-03-03','12:45:00',3.68),('8784','2014-03-03','12:50:00',3.65),('8784','2014-03-03','12:55:00',3.64),('8784','2014-03-03','13:00:00',3.6),('8784','2014-03-03','13:05:00',3.58),('8784','2014-03-03','13:10:00',3.56),('8784','2014-03-03','13:15:00',3.54),('8784','2014-03-03','13:20:00',3.54),('8784','2014-03-03','13:25:00',3.44),('8784','2014-03-03','13:30:00',3.5),('8784','2014-03-03','13:35:00',3.46),('8784','2014-03-03','13:40:00',3.41),('8784','2014-03-03','13:45:00',3.37),('8784','2014-03-03','13:50:00',3.36),('8784','2014-03-03','13:55:00',3.3),('8784','2014-03-03','14:00:00',3.26),('8784','2014-03-03','14:05:00',3.22),('8784','2014-03-03','14:10:00',3.21),('8784','2014-03-03','14:15:00',3.18),('8784','2014-03-03','14:20:00',3),('8784','2014-03-03','14:25:00',2.52),('8784','2014-03-03','14:30:00',2.94),('8784','2014-03-03','14:35:00',2.88),('8784','2014-03-03','14:40:00',2.8),('8784','2014-03-03','14:45:00',2.72),('8784','2014-03-03','14:50:00',2.65),('8784','2014-03-03','14:55:00',2.6),('8784','2014-03-03','15:00:00',2.49),('8784','2014-03-03','15:05:00',2.43),('8784','2014-03-03','15:10:00',2.35),('8784','2014-03-03','15:15:00',2.3),('8784','2014-03-03','15:20:00',2.23),('8784','2014-03-03','15:25:00',2.17),('8784','2014-03-03','15:30:00',2.09),('8784','2014-03-03','15:35:00',2.01),('8784','2014-03-03','15:40:00',1.91),('8784','2014-03-03','15:45:00',1.83),('8784','2014-03-03','15:50:00',1.73),('8784','2014-03-03','15:55:00',1.64),('8784','2014-03-03','16:00:00',1.55),('8784','2014-03-03','16:05:00',1.46),('8784','2014-03-03','16:10:00',1.36),('8784','2014-03-03','16:15:00',1.29),('8784','2014-03-03','16:20:00',1.21),('8784','2014-03-03','16:25:00',1.12),('8784','2014-03-03','16:30:00',1.03),('8784','2014-03-02','08:05:00',1.19),('8784','2014-03-02','08:10:00',1.78),('8784','2014-03-02','08:15:00',1.66),('8784','2014-03-02','08:20:00',1.68),('8784','2014-03-02','08:25:00',1.55),('8784','2014-03-02','08:30:00',1.56),('8784','2014-03-02','08:35:00',1.64),('8784','2014-03-02','08:40:00',1.74),('8784','2014-03-02','08:45:00',1.83),('8784','2014-03-02','08:50:00',1.91),('8784','2014-03-02','08:55:00',2.01),('8784','2014-03-02','09:00:00',2.1),('8784','2014-03-02','09:05:00',2.19),('8784','2014-03-02','09:10:00',2.33),('8784','2014-03-02','09:15:00',2.41),('8784','2014-03-02','09:20:00',1.83),('8784','2014-03-02','09:25:00',2.67),('8784','2014-03-02','09:30:00',2.79),('8784','2014-03-02','09:35:00',2.77),('8784','2014-03-02','09:40:00',2.25),('8784','2014-03-02','09:55:00',1.23),('8784','2014-03-02','10:00:00',1.64),('8784','2014-03-02','10:05:00',1.66),('8784','2014-03-02','10:10:00',1.47),('8784','2014-03-02','10:15:00',1.34),('8784','2014-03-02','10:20:00',1.36),('8784','2014-03-02','10:25:00',1.6),('8784','2014-03-02','10:30:00',1.66),('8784','2014-03-02','10:35:00',2.76),('8784','2014-03-02','10:40:00',2.37),('8784','2014-03-02','10:45:00',1.04),('8784','2014-03-02','10:50:00',1.55),('8784','2014-03-02','10:55:00',1.35),('8784','2014-03-02','11:00:00',3.15),('8784','2014-03-02','11:05:00',2.9),('8784','2014-03-02','11:10:00',1.79),('8784','2014-03-02','11:15:00',1.32),('8784','2014-03-02','11:20:00',1.85),('8784','2014-03-02','11:25:00',1.98),('8784','2014-03-02','11:30:00',2.26),('8784','2014-03-02','11:35:00',3.01),('8784','2014-03-02','11:40:00',2.61),('8784','2014-03-02','11:45:00',4.67),('8784','2014-03-02','11:50:00',4.44),('8784','2014-03-02','11:55:00',3.99),('8784','2014-03-02','12:00:00',2.79),('8784','2014-03-02','12:05:00',2.02),('8784','2014-03-02','12:10:00',1.88),('8784','2014-03-02','12:15:00',2.83),('8784','2014-03-02','12:20:00',2.39),('8784','2014-03-02','12:25:00',2.36),('8784','2014-03-02','12:30:00',1.5),('8784','2014-03-02','12:35:00',1.21),('8784','2014-03-02','12:50:00',1.13),('8784','2014-03-02','12:55:00',1.37),('8784','2014-03-02','13:00:00',1.57),('8784','2014-03-02','13:05:00',1.66),('8784','2014-03-02','13:10:00',1.63),('8784','2014-03-02','13:15:00',1.47),('8784','2014-03-02','13:20:00',1.38),('8784','2014-03-02','13:25:00',1.29),('8784','2014-03-02','13:30:00',1.2),('8784','2014-03-02','13:35:00',1.05),('8784','2014-03-02','13:50:00',1.06),('8784','2014-03-02','13:55:00',1.11),('8784','2014-03-02','14:00:00',1.34),('8784','2014-03-02','14:05:00',1.47),('8784','2014-03-02','14:10:00',1.42),('8784','2014-03-02','14:15:00',1.37),('8784','2014-03-02','14:20:00',1.26),('8784','2014-03-02','14:25:00',1.27),('8784','2014-03-02','14:30:00',1.31),('8784','2014-03-02','14:35:00',1.3),('8784','2014-03-02','14:40:00',1.29),('8784','2014-03-02','14:45:00',1.34),('8784','2014-03-02','14:50:00',1.33),('8784','2014-03-02','14:55:00',1.31),('8784','2014-03-02','15:00:00',1.35),('8784','2014-03-02','15:05:00',1.44),('8784','2014-03-02','15:10:00',1.45),('8784','2014-03-02','15:15:00',1.42),('8784','2014-03-02','15:20:00',1.41),('8784','2014-03-02','15:25:00',1.44),('8784','2014-03-02','15:30:00',1.42),('8784','2014-03-02','15:35:00',1.4),('8784','2014-03-02','15:40:00',1.4),('8784','2014-03-02','15:45:00',1.2),('8784','2014-03-02','15:50:00',1.09),('8784','2014-02-28','08:00:00',1.27),('8784','2014-02-28','08:05:00',1.03),('8784','2014-02-28','08:15:00',1.14),('8784','2014-02-28','08:20:00',1.64),('8784','2014-02-28','08:25:00',1.28),('8784','2014-02-28','08:35:00',2.08),('8784','2014-02-28','09:15:00',1.2),('8784','2014-02-28','09:20:00',1.29),('8784','2014-02-28','09:25:00',1.46),('8784','2014-02-28','09:30:00',1.75),('8784','2014-02-28','09:40:00',2.33),('8784','2014-02-28','09:45:00',2.84),('8784','2014-02-28','09:50:00',3.3),('8784','2014-02-28','09:55:00',2.34),('8784','2014-02-28','10:00:00',1.21),('8784','2014-02-28','10:05:00',1.22),('8784','2014-02-28','10:10:00',1.63),('8784','2014-02-28','10:15:00',1.21),('8784','2014-02-28','10:20:00',1.94),('8784','2014-02-28','10:25:00',3.02),('8784','2014-02-28','10:30:00',3.66),('8784','2014-02-28','10:35:00',2.67),('8784','2014-02-28','10:40:00',1.29),('8784','2014-02-28','11:15:00',1.13),('8784','2014-02-28','11:20:00',1.48),('8784','2014-02-28','11:25:00',1.46),('8784','2014-02-28','11:30:00',1.19),('8784','2014-02-28','11:45:00',1.01),('8784','2014-02-28','11:50:00',1.16),('8784','2014-02-28','11:55:00',1.23),('8784','2014-02-28','12:00:00',1.57),('8784','2014-02-28','12:05:00',2.3),('8784','2014-02-28','12:10:00',2.04),('8784','2014-02-28','12:15:00',1.14),('8784','2014-02-28','12:20:00',1.04),('8784','2014-02-28','12:25:00',1.98),('8784','2014-02-28','12:30:00',2.14),('8784','2014-02-28','12:35:00',3.75),('8784','2014-02-28','12:40:00',2.65),('8784','2014-02-28','12:45:00',1.33),('8784','2014-02-28','12:50:00',3.12),('8784','2014-02-28','12:55:00',1.93),('8784','2014-02-28','13:00:00',2.53),('8784','2014-02-28','13:05:00',1.85),('8784','2014-02-28','13:10:00',1.71),('8784','2014-02-28','13:15:00',1.17),('8784','2014-02-28','13:45:00',1.1),('8784','2014-02-28','13:50:00',4.34),('8784','2014-02-28','13:55:00',2.16),('8784','2014-02-28','14:00:00',1.42),('8784','2014-02-28','14:15:00',1.16),('8784','2014-02-28','14:20:00',1.48),('8784','2014-02-28','14:25:00',2.35),('8784','2014-02-28','14:30:00',1.93),('8784','2014-02-28','14:35:00',1.54),('8784','2014-02-28','14:40:00',1.41),('8784','2014-02-28','14:45:00',1.33),('8784','2014-02-28','14:50:00',1.45),('8784','2014-02-28','14:55:00',1.57),('8784','2014-02-28','15:00:00',2.31),('8784','2014-02-28','15:05:00',1.46),('8784','2014-02-28','15:25:00',2.27),('8784','2014-02-28','15:30:00',2.05),('8784','2014-02-28','15:35:00',1.93),('8784','2014-02-28','15:40:00',1.86),('8784','2014-02-28','16:10:00',1.09),('8784','2014-02-28','16:15:00',1.8),('8784','2014-02-28','16:20:00',1.47),('8784','2014-02-28','16:40:00',1.16),('8784','2014-02-28','16:45:00',1.34),('8784','2014-02-28','16:50:00',1.15),('8784','2014-02-27','10:35:00',1.07),('8784','2014-02-27','10:40:00',1.26),('8784','2014-02-27','10:45:00',1.36),('8784','2014-02-27','10:50:00',1.41),('8784','2014-02-27','10:55:00',1.48),('8784','2014-02-27','11:00:00',1.69),('8784','2014-02-27','11:05:00',1.84),('8784','2014-02-27','11:10:00',1.72),('8784','2014-02-27','11:15:00',1.69),('8784','2014-02-27','11:20:00',1.55),('8784','2014-02-27','11:25:00',1.74),('8784','2014-02-27','11:30:00',2.06),('8784','2014-02-27','11:35:00',1.9),('8784','2014-02-27','11:40:00',1.62),('8784','2014-02-27','11:45:00',1.39),('8784','2014-02-27','11:50:00',1.36),('8784','2014-02-27','11:55:00',1.42),('8784','2014-02-27','12:00:00',1.39),('8784','2014-02-27','12:05:00',1.36),('8784','2014-02-27','12:10:00',1.26),('8784','2014-02-27','12:15:00',1.36),('8784','2014-02-27','12:20:00',1.43),('8784','2014-02-27','12:25:00',1.44),('8784','2014-02-27','12:30:00',1.35),('8784','2014-02-27','12:35:00',1.32),('8784','2014-02-27','12:40:00',1.29),('8784','2014-02-27','12:45:00',1.28),('8784','2014-02-27','12:50:00',1.26),('8784','2014-02-27','12:55:00',1.28),('8784','2014-02-27','13:00:00',1.35),('8784','2014-02-27','13:05:00',1.21),('8784','2014-02-27','13:10:00',1.27),('8784','2014-02-27','13:15:00',1.39),('8784','2014-02-27','13:20:00',1.4),('8784','2014-02-27','13:25:00',1.48),('8784','2014-02-27','13:30:00',1.67),('8784','2014-02-27','13:35:00',1.79),('8784','2014-02-27','13:40:00',1.83),('8784','2014-02-27','13:45:00',1.82),('8784','2014-02-27','13:50:00',1.83),('8784','2014-02-27','13:55:00',2.05),('8784','2014-02-27','14:00:00',2.07),('8784','2014-02-27','14:05:00',1.81),('8784','2014-02-27','14:10:00',1.62),('8784','2014-02-27','14:15:00',1.53),('8784','2014-02-27','14:20:00',1.54),('8784','2014-02-27','14:25:00',1.53),('8784','2014-02-27','14:30:00',1.57),('8784','2014-02-27','14:35:00',1.5),('8784','2014-02-27','14:40:00',1.34),('8784','2014-02-27','14:45:00',1.39),('8784','2014-02-27','14:50:00',1.32),('8784','2014-02-27','14:55:00',1.21),('8784','2014-02-27','15:00:00',1.26),('8784','2014-02-27','15:05:00',1.24),('8784','2014-02-27','15:10:00',1.27),('8784','2014-02-27','15:15:00',1.42),('8784','2014-02-27','15:20:00',1.52),('8784','2014-02-27','15:25:00',1.35),('8784','2014-02-27','15:30:00',1.33),('8784','2014-02-27','15:35:00',1.3),('8784','2014-02-27','15:40:00',1.06),('8784','2014-02-27','16:45:00',1.1),('8784','2014-02-27','16:50:00',1.17),('8784','2014-02-27','16:55:00',1.06),('8784','2014-02-26','08:10:00',1.1),('8784','2014-02-26','08:15:00',1.2),('8784','2014-02-26','08:20:00',1.28),('8784','2014-02-26','08:25:00',1.36),('8784','2014-02-26','08:30:00',1.38),('8784','2014-02-26','08:35:00',1.56),('8784','2014-02-26','08:40:00',1.68),('8784','2014-02-26','08:45:00',1.92),('8784','2014-02-26','08:50:00',1.87),('8784','2014-02-26','08:55:00',1.88),('8784','2014-02-26','09:00:00',1.9),('8784','2014-02-26','09:05:00',1.91),('8784','2014-02-26','09:10:00',1.97),('8784','2014-02-26','09:15:00',2.1),('8784','2014-02-26','09:20:00',2.22),('8784','2014-02-26','09:25:00',2.23),('8784','2014-02-26','09:30:00',2.16),('8784','2014-02-26','09:35:00',1.87),('8784','2014-02-26','09:40:00',1.99),('8784','2014-02-26','09:45:00',1.83),('8784','2014-02-26','09:50:00',1.9),('8784','2014-02-26','09:55:00',1.35),('8784','2014-02-26','10:00:00',1.35),('8784','2014-02-26','10:05:00',1.07),('8784','2014-02-26','10:20:00',1.01),('8784','2014-02-26','11:00:00',1.07),('8784','2014-02-26','11:05:00',1.12),('8784','2014-02-26','11:10:00',1.11),('8784','2014-02-26','11:15:00',1.08),('8784','2014-02-26','11:50:00',1.11),('8784','2014-02-26','11:55:00',1.22),('8784','2014-02-26','12:00:00',1.44),('8784','2014-02-26','12:05:00',1.73),('8784','2014-02-26','12:10:00',1.45),('8784','2014-02-26','12:15:00',1.26),('8784','2014-02-26','12:20:00',1.37),('8784','2014-02-26','12:25:00',1.9),('8784','2014-02-26','12:30:00',2.33),('8784','2014-02-26','12:35:00',2.64),('8784','2014-02-26','12:40:00',3.81),('8784','2014-02-26','12:45:00',2.9),('8784','2014-02-26','12:50:00',3.37),('8784','2014-02-26','12:55:00',3.55),('8784','2014-02-26','13:00:00',2.76),('8784','2014-02-26','13:05:00',2.84),('8784','2014-02-26','13:10:00',3.01),('8784','2014-02-26','13:15:00',2.9),('8784','2014-02-26','13:20:00',2.64),('8784','2014-02-26','13:25:00',3.09),('8784','2014-02-26','13:30:00',3.73),('8784','2014-02-26','13:35:00',3.07),('8784','2014-02-26','13:40:00',3.38),('8784','2014-02-26','13:45:00',2.18),('8784','2014-02-26','13:50:00',1.46),('8784','2014-02-26','13:55:00',2.52),('8784','2014-02-26','14:00:00',3.48),('8784','2014-02-26','14:05:00',1.88),('8784','2014-02-26','14:10:00',1.82),('8784','2014-02-26','14:15:00',2.64),('8784','2014-02-26','14:20:00',2.77),('8784','2014-02-26','14:25:00',3.04),('8784','2014-02-26','14:30:00',1.1),('8784','2014-02-26','14:35:00',2.6),('8784','2014-02-26','14:40:00',2.92),('8784','2014-02-26','14:45:00',2.71),('8784','2014-02-26','14:50:00',2.48),('8784','2014-02-26','14:55:00',2.64),('8784','2014-02-26','15:00:00',2.12),('8784','2014-02-26','15:05:00',2.26),('8784','2014-02-26','15:10:00',2.02),('8784','2014-02-26','15:15:00',1.9),('8784','2014-02-26','15:20:00',1.44),('8784','2014-02-26','15:25:00',1.06),('8784','2014-02-26','15:30:00',1.19),('8784','2014-02-26','15:35:00',1.56),('8784','2014-02-26','15:40:00',1.58),('8784','2014-02-26','15:45:00',1.24),('8784','2014-02-26','15:50:00',1.25),('8784','2014-02-26','15:55:00',1.45),('8784','2014-02-26','16:00:00',1.67),('8784','2014-02-26','16:05:00',1.48),('8784','2014-04-29','09:50:00',1.13),('8784','2014-04-29','09:55:00',1.24),('8784','2014-04-29','10:00:00',1.27),('8784','2014-04-29','10:05:00',2.25),('8784','2014-04-29','10:10:00',4.41),('8784','2014-04-29','10:15:00',3.25),('8784','2014-04-29','10:20:00',3.13),('8784','2014-04-29','10:25:00',4.15),('8784','2014-04-29','10:30:00',3.91),('8784','2014-04-29','10:35:00',4.03),('8784','2014-04-29','10:40:00',4.02),('8784','2014-04-29','10:45:00',4.09),('8784','2014-04-29','10:50:00',4.19),('8784','2014-04-29','10:55:00',3.92),('8784','2014-04-29','11:00:00',4.12),('8784','2014-04-29','11:05:00',4.12),('8784','2014-04-29','11:10:00',3.96),('8784','2014-04-29','11:15:00',5.12),('8784','2014-04-29','11:20:00',3.22),('8784','2014-04-29','11:25:00',3.43),('8784','2014-04-29','11:30:00',2.44),('8784','2014-04-29','11:35:00',2.97),('8784','2014-04-29','11:40:00',3.85),('8784','2014-04-29','11:45:00',1.79),('8784','2014-04-29','11:50:00',1.19),('8784','2014-04-29','11:55:00',1.19),('8784','2014-04-29','12:00:00',1.63),('8784','2014-04-29','12:05:00',1.84),('8784','2014-04-29','12:10:00',1.88),('8784','2014-04-29','12:15:00',1.76),('8784','2014-04-29','12:20:00',2.88),('8784','2014-04-29','12:25:00',2.17),('8784','2014-04-29','12:30:00',1.67),('8784','2014-04-29','12:35:00',1.92),('8784','2014-04-29','12:40:00',1.99),('8784','2014-04-29','12:45:00',3.45),('8784','2014-04-29','12:50:00',2.56),('8784','2014-04-29','12:55:00',1.87),('8784','2014-04-29','13:00:00',2.41),('8784','2014-04-29','13:05:00',2.73),('8784','2014-04-29','13:10:00',2.43),('8784','2014-04-29','13:15:00',2.57),('8784','2014-04-29','13:20:00',3.93),('8784','2014-04-29','13:25:00',3.11),('8784','2014-04-29','13:30:00',3.04),('8784','2014-04-29','13:35:00',1.62),('8784','2014-04-29','13:40:00',1.74),('8784','2014-04-29','13:45:00',3.62),('8784','2014-04-29','13:50:00',3.08),('8784','2014-04-29','13:55:00',1.08),('8784','2014-04-29','15:05:00',1.03),('8784','2014-04-29','16:20:00',1.02),('8784','2014-04-29','16:25:00',1.09),('8784','2014-04-29','17:00:00',1),('8784','2014-04-29','17:05:00',1.28),('8784','2014-04-29','17:10:00',1.2),('8784','2014-04-29','17:20:00',1.38),('8784','2014-04-29','17:25:00',1.35),('8784','2014-04-29','17:30:00',1.86),('8784','2014-04-29','17:35:00',1.29),('8784','2014-04-29','17:40:00',1.98),('8784','2014-04-29','17:45:00',1.99),('8784','2014-02-25','08:10:00',1.01),('8784','2014-02-25','08:15:00',1.1),('8784','2014-02-25','08:20:00',1.17),('8784','2014-02-25','08:25:00',1.26),('8784','2014-02-25','08:30:00',1.31),('8784','2014-02-25','08:35:00',1.41),('8784','2014-02-25','08:40:00',1.49),('8784','2014-02-25','08:45:00',1.58),('8784','2014-02-25','08:50:00',1.67),('8784','2014-02-25','08:55:00',1.75),('8784','2014-02-25','09:00:00',1.84),('8784','2014-02-25','09:05:00',1.91),('8784','2014-02-25','09:10:00',1.98),('8784','2014-02-25','09:15:00',2.05),('8784','2014-02-25','09:20:00',2.12),('8784','2014-02-25','09:25:00',2.18),('8784','2014-02-25','09:30:00',2.24),('8784','2014-02-25','09:35:00',2.29),('8784','2014-02-25','09:40:00',2.37),('8784','2014-02-25','09:45:00',2.45),('8784','2014-02-25','09:50:00',2.49),('8784','2014-02-25','09:55:00',2.56),('8784','2014-02-25','10:00:00',2.59),('8784','2014-02-25','10:05:00',2.65),('8784','2014-02-25','10:10:00',2.69),('8784','2014-02-25','10:15:00',2.76),('8784','2014-02-25','10:20:00',2.83),('8784','2014-02-25','10:25:00',2.87),('8784','2014-02-25','10:30:00',2.88),('8784','2014-02-25','10:35:00',2.98),('8784','2014-02-25','10:40:00',3.01),('8784','2014-02-25','10:45:00',3.03),('8784','2014-02-25','10:50:00',3.06),('8784','2014-02-25','10:55:00',3.07),('8784','2014-02-25','11:00:00',3.11),('8784','2014-02-25','11:05:00',3.08),('8784','2014-02-25','11:10:00',3.14),('8784','2014-02-25','11:15:00',3.19),('8784','2014-02-25','11:20:00',3.21),('8784','2014-02-25','11:25:00',3.21),('8784','2014-02-25','11:30:00',3.22),('8784','2014-02-25','11:35:00',3.26),('8784','2014-02-25','11:40:00',3.27),('8784','2014-02-25','11:45:00',3.24),('8784','2014-02-25','11:50:00',3.23),('8784','2014-02-25','11:55:00',3.29),('8784','2014-02-25','12:00:00',3.32),('8784','2014-02-25','12:05:00',3.32),('8784','2014-02-25','12:10:00',3.32),('8784','2014-02-25','12:15:00',3.33),('8784','2014-02-25','12:20:00',3.32),('8784','2014-02-25','12:25:00',3.38),('8784','2014-02-25','12:30:00',3.35),('8784','2014-02-25','12:35:00',3.34),('8784','2014-02-25','12:40:00',3.33),('8784','2014-02-25','12:45:00',3.29),('8784','2014-02-25','12:50:00',3.31),('8784','2014-02-25','12:55:00',3.3),('8784','2014-02-25','13:00:00',3.22),('8784','2014-02-25','13:05:00',3.14),('8784','2014-02-25','13:10:00',2.66),('8784','2014-02-25','13:20:00',1.04),('8784','2014-02-25','13:35:00',1.19),('8784','2014-02-25','13:40:00',1.38),('8784','2014-02-25','13:45:00',1.25),('8784','2014-02-25','13:50:00',1.09),('8784','2014-02-25','13:55:00',1.3),('8784','2014-02-25','14:00:00',1.36),('8784','2014-02-25','14:05:00',1.17),('8784','2014-02-25','14:10:00',1.12),('8784','2014-02-25','14:15:00',1.17),('8784','2014-02-25','14:20:00',1.75),('8784','2014-02-25','14:25:00',1.92),('8784','2014-02-25','14:30:00',2.27),('8784','2014-02-25','14:35:00',2.01),('8784','2014-02-25','14:40:00',2.42),('8784','2014-02-25','14:45:00',2.65),('8784','2014-02-25','14:50:00',2.16),('8784','2014-02-25','14:55:00',1.68),('8784','2014-02-25','15:00:00',2.18),('8784','2014-02-25','15:05:00',2.21),('8784','2014-02-25','15:10:00',2.15),('8784','2014-02-25','15:15:00',2.03),('8784','2014-02-25','15:20:00',1.94),('8784','2014-02-25','15:25:00',1.67),('8784','2014-02-25','15:30:00',1.53),('8784','2014-02-25','15:35:00',1.42),('8784','2014-02-25','15:40:00',1.48),('8784','2014-02-25','15:45:00',1.01),('8784','2014-02-24','08:05:00',1.12),('8784','2014-02-24','08:10:00',1.23),('8784','2014-02-24','08:15:00',1.37),('8784','2014-02-24','08:20:00',1.48),('8784','2014-02-24','08:25:00',1.58),('8784','2014-02-24','08:30:00',1.56),('8784','2014-02-24','08:35:00',1.48),('8784','2014-02-24','08:40:00',1.12),('8784','2014-02-24','08:45:00',1.55),('8784','2014-02-24','08:50:00',1.74),('8784','2014-02-24','08:55:00',1.79),('8784','2014-02-24','09:00:00',1.81),('8784','2014-02-24','09:05:00',1.87),('8784','2014-02-24','09:10:00',1.95),('8784','2014-02-24','09:15:00',2.02),('8784','2014-02-24','09:20:00',2.08),('8784','2014-02-24','09:25:00',2.15),('8784','2014-02-24','09:30:00',2.24),('8784','2014-02-24','09:35:00',2.33),('8784','2014-02-24','09:40:00',2.39),('8784','2014-02-24','09:45:00',2.45),('8784','2014-02-24','09:50:00',2.51),('8784','2014-02-24','09:55:00',2.57),('8784','2014-02-24','10:00:00',2.64),('8784','2014-02-24','10:05:00',2.7),('8784','2014-02-24','10:10:00',2.75),('8784','2014-02-24','10:15:00',2.8),('8784','2014-02-24','10:20:00',2.88),('8784','2014-02-24','10:25:00',2.94),('8784','2014-02-24','10:30:00',2.98),('8784','2014-02-24','10:35:00',3.02),('8784','2014-02-24','10:40:00',3.05),('8784','2014-02-24','10:45:00',3.08),('8784','2014-02-24','10:50:00',3.15),('8784','2014-02-24','10:55:00',3.18),('8784','2014-02-24','11:00:00',3.19),('8784','2014-02-24','11:05:00',3.23),('8784','2014-02-24','11:10:00',3.27),('8784','2014-02-24','11:15:00',3.3),('8784','2014-02-24','11:20:00',3.32),('8784','2014-02-24','11:25:00',3.43),('8784','2014-02-24','11:30:00',3.82),('8784','2014-02-24','11:35:00',2.52),('8784','2014-02-24','11:40:00',3.01),('8784','2014-02-24','11:45:00',3.25),('8784','2014-02-24','11:50:00',3.19),('8784','2014-02-24','11:55:00',2.6),('8784','2014-02-24','12:00:00',3.35),('8784','2014-02-24','12:05:00',3.52),('8784','2014-02-24','12:10:00',3.44),('8784','2014-02-24','12:15:00',3.5),('8784','2014-02-24','12:20:00',3.07),('8784','2014-02-24','12:25:00',3.03),('8784','2014-02-24','12:30:00',1.15),('8784','2014-02-24','12:35:00',3.27),('8784','2014-02-24','12:40:00',3.92),('8784','2014-02-24','12:45:00',3.76),('8784','2014-02-24','12:50:00',3.65),('8784','2014-02-24','12:55:00',3.35),('8784','2014-02-24','13:00:00',3.24),('8784','2014-02-24','13:05:00',2.78),('8784','2014-02-24','13:10:00',4.19),('8784','2014-02-24','13:15:00',2.4),('8784','2014-02-24','13:20:00',1.23),('8784','2014-02-24','14:10:00',1.07),('8784','2014-02-24','14:15:00',1.08),('8784','2014-02-24','14:20:00',1.05),('8784','2014-02-24','14:25:00',1.07),('8784','2014-02-24','14:30:00',1.11),('8784','2014-02-24','14:35:00',1.09),('8784','2014-02-24','14:40:00',1.06),('8784','2014-02-24','14:45:00',1.12),('8784','2014-02-24','14:50:00',1.08),('8784','2014-02-24','15:15:00',1.05),('8784','2014-02-24','15:20:00',1.17),('8784','2014-02-24','15:25:00',1.24),('8784','2014-02-24','15:30:00',1.02),('8784','2014-02-24','15:35:00',2.22),('8784','2014-02-24','15:40:00',2.29),('8784','2014-02-24','15:45:00',2.16),('8784','2014-02-24','15:50:00',2),('8784','2014-02-24','15:55:00',1.84),('8784','2014-02-24','16:00:00',1.97),('8784','2014-02-24','16:05:00',1.89),('8784','2014-02-24','16:10:00',1.76),('8784','2014-02-24','16:15:00',1.58),('8784','2014-02-24','16:20:00',1.3),('8784','2014-02-24','16:25:00',1.04),('8784','2014-02-23','08:15:00',1.02),('8784','2014-02-23','08:20:00',1.1),('8784','2014-02-23','08:25:00',1.16),('8784','2014-02-23','08:30:00',1.27),('8784','2014-02-23','08:35:00',1.36),('8784','2014-02-23','08:40:00',1.45),('8784','2014-02-23','08:45:00',1.53),('8784','2014-02-23','08:50:00',1.62),('8784','2014-02-23','08:55:00',1.69),('8784','2014-02-23','09:00:00',1.78),('8784','2014-02-23','09:05:00',1.87),('8784','2014-02-23','09:10:00',1.96),('8784','2014-02-23','09:15:00',2.04),('8784','2014-02-23','09:20:00',2.13),('8784','2014-02-23','09:25:00',1.95),('8784','2014-02-23','09:30:00',1.97),('8784','2014-02-23','09:35:00',2.27),('8784','2014-02-23','09:40:00',2.34),('8784','2014-02-23','09:45:00',2.4),('8784','2014-02-23','09:50:00',2.43),('8784','2014-02-23','09:55:00',2.47),('8784','2014-02-23','10:00:00',2.54),('8784','2014-02-23','10:05:00',2.61),('8784','2014-02-23','10:10:00',2.64),('8784','2014-02-23','10:15:00',2.69),('8784','2014-02-23','10:20:00',2.75),('8784','2014-02-23','10:25:00',2.8),('8784','2014-02-23','10:30:00',2.86),('8784','2014-02-23','10:35:00',2.92),('8784','2014-02-23','10:40:00',2.93),('8784','2014-02-23','10:45:00',3.03),('8784','2014-02-23','10:50:00',3.01),('8784','2014-02-23','10:55:00',3.06),('8784','2014-02-23','11:00:00',3.13),('8784','2014-02-23','11:05:00',3.17),('8784','2014-02-23','11:10:00',3.2),('8784','2014-02-23','11:15:00',3.26),('8784','2014-02-23','11:20:00',3.3),('8784','2014-02-23','11:25:00',3.32),('8784','2014-02-23','11:30:00',3.34),('8784','2014-02-23','11:35:00',3.37),('8784','2014-02-23','11:40:00',3.04),('8784','2014-02-23','11:45:00',1.91),('8784','2014-02-23','11:50:00',3.01),('8784','2014-02-23','11:55:00',2.87),('8784','2014-02-23','12:00:00',3.61),('8784','2014-02-23','12:05:00',3.66),('8784','2014-02-23','12:10:00',1.47),('8784','2014-02-23','12:15:00',3.86),('8784','2014-02-23','12:20:00',3.37),('8784','2014-02-23','12:25:00',2.26),('8784','2014-02-23','12:30:00',2.81),('8784','2014-02-23','12:35:00',3.68),('8784','2014-02-23','12:40:00',2.09),('8784','2014-02-23','12:45:00',2.39),('8784','2014-02-23','12:50:00',1.93),('8784','2014-02-23','12:55:00',1.97),('8784','2014-02-23','13:00:00',2.5),('8784','2014-02-23','13:05:00',3.49),('8784','2014-02-23','13:10:00',3.39),('8784','2014-02-23','13:15:00',3.33),('8784','2014-02-23','13:20:00',3.3),('8784','2014-02-23','13:25:00',3.26),('8784','2014-02-23','13:30:00',3.22),('8784','2014-02-23','13:35:00',2.88),('8784','2014-02-23','13:40:00',2.88),('8784','2014-02-23','13:45:00',2.45),('8784','2014-02-23','13:50:00',1.79),('8784','2014-02-23','14:00:00',1.14),('8784','2014-02-23','14:05:00',2.83),('8784','2014-02-23','14:10:00',3.17),('8784','2014-02-23','14:15:00',2.28),('8784','2014-02-23','14:20:00',1.89),('8784','2014-02-23','14:25:00',2.62),('8784','2014-02-23','14:30:00',3.39),('8784','2014-02-23','14:35:00',2.56),('8784','2014-02-23','14:40:00',1.57),('8784','2014-02-23','14:45:00',1.54),('8784','2014-02-23','14:50:00',1.66),('8784','2014-02-23','14:55:00',1.04),('8784','2014-02-23','15:00:00',1.12),('8784','2014-02-22','09:10:00',1.09),('8784','2014-02-22','09:50:00',1.03),('8784','2014-02-22','09:55:00',1.01),('8784','2014-02-22','10:00:00',1.79),('8784','2014-02-22','10:05:00',1.71),('8784','2014-02-22','10:10:00',2.81),('8784','2014-02-22','10:15:00',1.96),('8784','2014-02-22','10:20:00',1.43),('8784','2014-02-22','10:25:00',2.19),('8784','2014-02-22','10:30:00',2.33),('8784','2014-02-22','10:35:00',1.91),('8784','2014-02-22','10:40:00',1.6),('8784','2014-02-22','10:45:00',3.69),('8784','2014-02-22','10:50:00',3.41),('8784','2014-02-22','10:55:00',1.14),('8784','2014-02-22','12:05:00',1.51),('8784','2014-02-22','12:10:00',1.71),('8784','2014-02-22','12:15:00',1.97),('8784','2014-02-22','12:20:00',1.95),('8784','2014-02-22','12:25:00',1.73),('8784','2014-02-22','12:30:00',1.17),('8784','2014-02-22','12:35:00',1.29),('8784','2014-02-22','12:40:00',1.46),('8784','2014-02-22','12:45:00',3.41),('8784','2014-02-22','12:50:00',3.44),('8784','2014-02-22','12:55:00',1.55),('8784','2014-02-22','13:00:00',1.5),('8784','2014-02-22','13:05:00',2.6),('8784','2014-02-22','13:10:00',4.73),('8784','2014-02-22','13:15:00',2.68),('8784','2014-02-22','13:20:00',1.65),('8784','2014-02-22','13:30:00',1.28),('8784','2014-02-22','13:35:00',2.02),('8784','2014-02-22','13:40:00',1.99),('8784','2014-02-22','13:45:00',1.84),('8784','2014-02-22','13:50:00',1.89),('8784','2014-02-22','13:55:00',3.18),('8784','2014-02-22','14:00:00',3.16),('8784','2014-02-22','14:05:00',2.4),('8784','2014-02-22','14:10:00',2.84),('8784','2014-02-22','14:15:00',2.95),('8784','2014-02-22','14:20:00',2.71),('8784','2014-02-22','14:25:00',2.07),('8784','2014-02-22','14:30:00',1.75),('8784','2014-02-22','14:35:00',1.87),('8784','2014-02-22','14:40:00',2.29),('8784','2014-02-22','14:45:00',2.71),('8784','2014-02-22','14:50:00',2.17),('8784','2014-02-22','15:00:00',1.41),('8784','2014-02-22','15:05:00',2.35),('8784','2014-02-22','15:10:00',1.06),('8784','2014-02-22','15:15:00',1.04),('8784','2014-02-22','15:25:00',1.06),('8784','2014-02-22','15:30:00',1.9),('8784','2014-02-22','15:45:00',1.73),('8784','2014-02-22','15:50:00',1.53),('8784','2014-02-22','16:00:00',1.3),('8784','2014-02-22','16:10:00',1.18),('8784','2014-02-22','16:15:00',1.1),('8784','2014-02-22','16:20:00',1.01),('8784','2014-02-21','09:35:00',1.02),('8784','2014-02-21','09:40:00',1.09),('8784','2014-02-21','09:45:00',1.2),('8784','2014-02-21','09:50:00',1.25),('8784','2014-02-21','09:55:00',1.21),('8784','2014-02-21','10:00:00',1.28),('8784','2014-02-21','10:05:00',1.49),('8784','2014-02-21','10:10:00',1.38),('8784','2014-02-21','10:15:00',1.59),('8784','2014-02-21','10:20:00',2.15),('8784','2014-02-21','10:25:00',2.42),('8784','2014-02-21','10:30:00',2.7),('8784','2014-02-21','10:35:00',1.91),('8784','2014-02-21','10:40:00',1.83),('8784','2014-02-21','10:45:00',1.68),('8784','2014-02-21','10:50:00',1.72),('8784','2014-02-21','10:55:00',2.32),('8784','2014-02-21','11:00:00',1.7),('8784','2014-02-21','11:05:00',1.59),('8784','2014-02-21','11:10:00',1.57),('8784','2014-02-21','11:15:00',1.71),('8784','2014-02-21','11:20:00',1.56),('8784','2014-02-21','11:25:00',1.74),('8784','2014-02-21','11:30:00',1.91),('8784','2014-02-21','11:35:00',1.82),('8784','2014-02-21','11:40:00',1.91),('8784','2014-02-21','11:45:00',1.79),('8784','2014-02-21','11:50:00',1.6),('8784','2014-02-21','11:55:00',1.58),('8784','2014-02-21','12:00:00',1.98),('8784','2014-02-21','12:05:00',3.85),('8784','2014-02-21','12:10:00',4.19),('8784','2014-02-21','12:15:00',3.92),('8784','2014-02-21','12:20:00',3.32),('8784','2014-02-21','12:25:00',2.74),('8784','2014-02-21','12:30:00',1.74),('8784','2014-02-21','12:35:00',1.35),('8784','2014-02-21','12:40:00',1.12),('8784','2014-02-21','15:00:00',1.18),('8784','2014-02-21','15:05:00',1.1),('8784','2014-02-21','15:30:00',1.44),('8784','2014-02-21','15:35:00',1.6),('8784','2014-02-21','15:40:00',1.57),('8784','2014-02-21','15:45:00',1.51),('8784','2014-02-21','15:50:00',1.39),('8784','2014-02-21','15:55:00',1.3),('8784','2014-02-21','16:00:00',1.22),('8784','2014-02-21','16:05:00',1.16),('8784','2014-02-21','16:10:00',1.07),('8784','2014-02-20','11:20:00',1.14),('8784','2014-02-20','11:25:00',1.28),('8784','2014-02-20','11:30:00',1.28),('8784','2014-02-20','11:35:00',1.03),('8784','2014-02-20','12:25:00',1.13),('8784','2014-02-20','12:30:00',1.1),('8784','2014-02-20','12:35:00',1.15),('8784','2014-02-20','12:40:00',1.25),('8784','2014-02-20','12:45:00',1.09),('8784','2014-02-20','12:50:00',1.1),('8784','2014-02-20','12:55:00',1.3),('8784','2014-02-20','13:00:00',1.54),('8784','2014-02-20','13:15:00',1.29),('8784','2014-02-20','13:20:00',1.05),('8784','2014-02-20','13:30:00',1.3),('8784','2014-02-20','13:35:00',1.13),('8784','2014-02-19','09:25:00',1.06),('8784','2014-02-19','09:30:00',1.09),('8784','2014-02-19','09:35:00',1.23),('8784','2014-02-19','09:40:00',1.33),('8784','2014-02-19','09:45:00',1.57),('8784','2014-02-19','09:50:00',1.47),('8784','2014-02-19','09:55:00',1.37),('8784','2014-02-19','10:00:00',1.33),('8784','2014-02-19','10:05:00',1.34),('8784','2014-02-19','10:10:00',1.45),('8784','2014-02-19','10:15:00',1.52),('8784','2014-02-19','10:20:00',1.39),('8784','2014-02-19','10:25:00',1.42),('8784','2014-02-19','10:30:00',1.51),('8784','2014-02-19','10:35:00',1.59),('8784','2014-02-19','10:40:00',1.81),('8784','2014-02-19','10:45:00',1.96),('8784','2014-02-19','10:50:00',1.85),('8784','2014-02-19','10:55:00',1.66),('8784','2014-02-19','11:00:00',1.51),('8784','2014-02-19','11:05:00',1.54),('8784','2014-02-19','11:10:00',1.72),('8784','2014-02-19','11:15:00',1.72),('8784','2014-02-19','11:20:00',1.86),('8784','2014-02-19','11:25:00',1.7),('8784','2014-02-19','11:30:00',1.58),('8784','2014-02-19','11:35:00',1.62),('8784','2014-02-19','11:40:00',1.54),('8784','2014-02-19','11:45:00',1.46),('8784','2014-02-19','11:50:00',1.5),('8784','2014-02-19','11:55:00',1.32),('8784','2014-02-19','12:00:00',1.37),('8784','2014-02-19','12:05:00',1.49),('8784','2014-02-19','12:10:00',1.46),('8784','2014-02-19','12:15:00',1.41),('8784','2014-02-19','12:20:00',1.24),('8784','2014-02-19','12:25:00',1.45),('8784','2014-02-19','12:30:00',1.62),('8784','2014-02-19','12:35:00',1.34),('8784','2014-02-19','12:40:00',1.25),('8784','2014-02-19','12:45:00',1.28),('8784','2014-02-19','12:50:00',1.05),('8784','2014-02-19','13:00:00',1.04),('8784','2014-02-19','13:05:00',1.15),('8784','2014-02-19','13:10:00',1.12),('8784','2014-02-19','13:15:00',1.28),('8784','2014-02-19','13:20:00',1.25),('8784','2014-02-19','13:25:00',1.57),('8784','2014-02-19','13:30:00',1.56),('8784','2014-02-19','13:35:00',1.75),('8784','2014-02-19','13:40:00',1.61),('8784','2014-02-19','13:45:00',2.03),('8784','2014-02-19','13:50:00',2.1),('8784','2014-02-19','13:55:00',1.84),('8784','2014-02-19','14:00:00',1.65),('8784','2014-02-19','14:05:00',1.77),('8784','2014-02-19','14:10:00',1.44),('8784','2014-02-19','14:15:00',1.33),('8784','2014-02-19','14:20:00',2.04),('8784','2014-02-19','14:25:00',1.63),('8784','2014-02-19','14:30:00',1.56),('8784','2014-02-19','14:35:00',1.66),('8784','2014-02-19','14:40:00',1.37),('8784','2014-02-19','14:45:00',1.31),('8784','2014-02-19','14:50:00',1.69),('8784','2014-02-19','14:55:00',1.4),('8784','2014-02-19','15:00:00',1.07),('8784','2014-02-19','15:05:00',1.12),('8784','2014-02-19','15:10:00',1.15),('8784','2014-02-19','15:15:00',1.3),('8784','2014-02-19','15:25:00',1.14),('8784','2014-02-19','15:30:00',1.01),('8784','2014-02-19','15:50:00',1.18),('8784','2014-02-18','08:30:00',1.08),('8784','2014-02-18','08:35:00',1.16),('8784','2014-02-18','08:40:00',1.19),('8784','2014-02-18','08:45:00',1.25),('8784','2014-02-18','08:50:00',1.28),('8784','2014-02-18','08:55:00',1.4),('8784','2014-02-18','09:00:00',1.2),('8784','2014-02-18','09:05:00',1.32),('8784','2014-02-18','09:10:00',1.63),('8784','2014-02-18','09:15:00',1.7),('8784','2014-02-18','09:20:00',1.77),('8784','2014-02-18','09:25:00',1.83),('8784','2014-02-18','09:30:00',1.98),('8784','2014-02-18','09:35:00',2.02),('8784','2014-02-18','09:40:00',2.09),('8784','2014-02-18','09:45:00',2.16),('8784','2014-02-18','09:50:00',2.22),('8784','2014-02-18','09:55:00',2.29),('8784','2014-02-18','10:00:00',2.36),('8784','2014-02-18','10:05:00',2.39),('8784','2014-02-18','10:10:00',2.48),('8784','2014-02-18','10:15:00',2.49),('8784','2014-02-18','10:20:00',2.54),('8784','2014-02-18','10:25:00',2.61),('8784','2014-02-18','10:30:00',2.64),('8784','2014-02-18','10:35:00',2.67),('8784','2014-02-18','10:40:00',2.71),('8784','2014-02-18','10:45:00',2.76),('8784','2014-02-18','10:50:00',2.81),('8784','2014-02-18','10:55:00',2.84),('8784','2014-02-18','11:00:00',2.87),('8784','2014-02-18','11:05:00',2.45),('8784','2014-02-18','11:10:00',2.38),('8784','2014-02-18','11:15:00',2.32),('8784','2014-02-18','11:20:00',2.63),('8784','2014-02-18','11:25:00',2.93),('8784','2014-02-18','11:30:00',2.59),('8784','2014-02-18','11:35:00',2.54),('8784','2014-02-18','11:40:00',2.1),('8784','2014-02-18','11:45:00',2.05),('8784','2014-02-18','11:50:00',1.77),('8784','2014-02-18','11:55:00',1.57),('8784','2014-02-18','12:00:00',1.57),('8784','2014-02-18','12:05:00',1.59),('8784','2014-02-18','12:10:00',1.81),('8784','2014-02-18','12:15:00',1.93),('8784','2014-02-18','12:20:00',1.91),('8784','2014-02-18','12:25:00',2.21),('8784','2014-02-18','12:30:00',2.38),('8784','2014-02-18','12:35:00',1.84),('8784','2014-02-18','12:40:00',1.67),('8784','2014-02-18','12:45:00',1.63),('8784','2014-02-18','12:50:00',1.73),('8784','2014-02-18','12:55:00',1.82),('8784','2014-02-18','13:00:00',1.48),('8784','2014-02-18','13:05:00',1.41),('8784','2014-02-18','13:10:00',1.5),('8784','2014-02-18','13:15:00',1.93),('8784','2014-02-18','13:20:00',2.08),('8784','2014-02-18','13:25:00',2.5),('8784','2014-02-18','13:30:00',1.8),('8784','2014-02-18','13:35:00',1.5),('8784','2014-02-18','13:40:00',1.91),('8784','2014-02-18','13:45:00',2.14),('8784','2014-02-18','13:50:00',1.7),('8784','2014-02-18','13:55:00',1.67),('8784','2014-02-18','14:00:00',1.84),('8784','2014-02-18','14:05:00',2.6),('8784','2014-02-18','14:10:00',1.6),('8784','2014-02-18','14:15:00',1.27),('8784','2014-02-18','14:20:00',1.19),('8784','2014-02-18','14:25:00',1.21),('8784','2014-02-18','14:30:00',1.46),('8784','2014-02-18','14:35:00',1.4),('8784','2014-02-18','14:40:00',1.2),('8784','2014-02-18','14:45:00',1.1),('8784','2014-02-18','14:50:00',1.04),('8784','2014-02-18','15:35:00',1.07),('8784','2014-02-18','15:40:00',1.26),('8784','2014-02-18','15:45:00',1.32),('8784','2014-02-18','15:50:00',1.08),('8784','2014-02-18','16:05:00',1.06),('8784','2014-02-17','08:35:00',1.02),('8784','2014-02-17','08:40:00',1.04),('8784','2014-02-17','08:45:00',1.14),('8784','2014-02-17','08:50:00',1.2),('8784','2014-02-17','08:55:00',1.27),('8784','2014-02-17','09:10:00',1.23),('8784','2014-02-17','09:15:00',1.53),('8784','2014-02-17','09:20:00',1.62),('8784','2014-02-17','09:25:00',1.69),('8784','2014-02-17','09:30:00',1.8),('8784','2014-02-17','09:35:00',1.88),('8784','2014-02-17','09:40:00',1.95),('8784','2014-02-17','09:45:00',2.01),('8784','2014-02-17','09:50:00',2.05),('8784','2014-02-17','09:55:00',2.09),('8784','2014-02-17','10:00:00',2.17),('8784','2014-02-17','10:05:00',2.26),('8784','2014-02-17','10:10:00',2.28),('8784','2014-02-17','10:15:00',2.32),('8784','2014-02-17','10:20:00',2.31),('8784','2014-02-17','10:25:00',2.32),('8784','2014-02-17','10:30:00',2.36),('8784','2014-02-17','10:35:00',2.38),('8784','2014-02-17','10:40:00',2.38),('8784','2014-02-17','10:45:00',2.36),('8784','2014-02-17','10:50:00',2.38),('8784','2014-02-17','10:55:00',2.51),('8784','2014-02-17','11:00:00',2.57),('8784','2014-02-17','11:05:00',2.62),('8784','2014-02-17','11:10:00',2.65),('8784','2014-02-17','11:15:00',2.68),('8784','2014-02-17','11:20:00',2.73),('8784','2014-02-17','11:25:00',2.75),('8784','2014-02-17','11:30:00',2.84),('8784','2014-02-17','11:35:00',2.89),('8784','2014-02-17','11:40:00',2.91),('8784','2014-02-17','11:45:00',2.93),('8784','2014-02-17','11:50:00',2.94),('8784','2014-02-17','11:55:00',2.94),('8784','2014-02-17','12:00:00',2.95),('8784','2014-02-17','12:05:00',2.95),('8784','2014-02-17','12:10:00',2.94),('8784','2014-02-17','12:15:00',2.93),('8784','2014-02-17','12:20:00',2.92),('8784','2014-02-17','12:25:00',2.93),('8784','2014-02-17','12:30:00',2.91),('8784','2014-02-17','12:35:00',2.9),('8784','2014-02-17','12:40:00',2.86),('8784','2014-02-17','12:45:00',2.84),('8784','2014-02-17','12:50:00',2.79),('8784','2014-02-17','12:55:00',2.79),('8784','2014-02-17','13:00:00',2.78),('8784','2014-02-17','13:05:00',2.76),('8784','2014-02-17','13:10:00',2.73),('8784','2014-02-17','13:15:00',2.73),('8784','2014-02-17','13:20:00',2.71),('8784','2014-02-17','13:25:00',2.7),('8784','2014-02-17','13:30:00',2.69),('8784','2014-02-17','13:35:00',2.65),('8784','2014-02-17','13:40:00',2.6),('8784','2014-02-17','13:45:00',2.56),('8784','2014-02-17','13:50:00',2.53),('8784','2014-02-17','13:55:00',2.46),('8784','2014-02-17','14:00:00',2.43),('8784','2014-02-17','14:05:00',2.41),('8784','2014-02-17','14:10:00',2.3),('8784','2014-02-17','14:15:00',2.17),('8784','2014-02-17','14:20:00',2.02),('8784','2014-02-17','14:25:00',1.88),('8784','2014-02-17','14:30:00',2.06),('8784','2014-02-17','14:35:00',2.01),('8784','2014-02-17','14:40:00',1.81),('8784','2014-02-17','14:45:00',2.01),('8784','2014-02-17','14:50:00',1.91),('8784','2014-02-17','14:55:00',1.87),('8784','2014-02-17','15:00:00',1.76),('8784','2014-02-17','15:05:00',1.74),('8784','2014-02-17','15:10:00',1.7),('8784','2014-02-17','15:15:00',1.71),('8784','2014-02-17','15:20:00',1.66),('8784','2014-02-17','15:25:00',1.54),('8784','2014-02-17','15:30:00',1.49),('8784','2014-02-17','15:35:00',1.41),('8784','2014-02-17','15:40:00',1.31),('8784','2014-02-17','15:45:00',1.29),('8784','2014-02-17','15:50:00',1.21),('8784','2014-02-17','15:55:00',1.14),('8784','2014-02-17','16:00:00',1.02),('8784','2014-02-16','08:30:00',1.01),('8784','2014-02-16','08:35:00',1.1),('8784','2014-02-16','08:40:00',1.04),('8784','2014-02-16','08:45:00',1.16),('8784','2014-02-16','08:50:00',1.18),('8784','2014-02-16','08:55:00',1.36),('8784','2014-02-16','09:00:00',1.02),('8784','2014-02-16','09:10:00',1.09),('8784','2014-02-16','09:15:00',1.26),('8784','2014-02-16','09:20:00',1.69),('8784','2014-02-16','09:25:00',1.69),('8784','2014-02-16','09:30:00',1.76),('8784','2014-02-16','09:35:00',1.51),('8784','2014-02-16','09:40:00',1.97),('8784','2014-02-16','09:45:00',2.11),('8784','2014-02-16','09:50:00',2.22),('8784','2014-02-16','09:55:00',2.16),('8784','2014-02-16','10:00:00',2.13),('8784','2014-02-16','10:05:00',2.39),('8784','2014-02-16','10:10:00',2.45),('8784','2014-02-16','10:15:00',2.48),('8784','2014-02-16','10:20:00',2.58),('8784','2014-02-16','10:25:00',2.57),('8784','2014-02-16','10:30:00',2.7),('8784','2014-02-16','10:35:00',2.8),('8784','2014-02-16','10:40:00',2.87),('8784','2014-02-16','10:45:00',2.84),('8784','2014-02-16','10:50:00',2.45),('8784','2014-02-16','10:55:00',2.52),('8784','2014-02-16','11:00:00',2.89),('8784','2014-02-16','11:05:00',2.96),('8784','2014-02-16','11:10:00',2.82),('8784','2014-02-16','11:15:00',2.94),('8784','2014-02-16','11:20:00',2.82),('8784','2014-02-16','11:25:00',2.83),('8784','2014-02-16','11:30:00',2.85),('8784','2014-02-16','11:35:00',3.01),('8784','2014-02-16','11:40:00',2.96),('8784','2014-02-16','11:45:00',2.71),('8784','2014-02-16','11:50:00',2.99),('8784','2014-02-16','11:55:00',2.62),('8784','2014-02-16','12:00:00',3.06),('8784','2014-02-16','12:05:00',3.04),('8784','2014-02-16','12:10:00',3.01),('8784','2014-02-16','12:15:00',3.04),('8784','2014-02-16','12:20:00',3.04),('8784','2014-02-16','12:25:00',2.94),('8784','2014-02-16','12:30:00',2.96),('8784','2014-02-16','12:35:00',2.98),('8784','2014-02-16','12:40:00',2.97),('8784','2014-02-16','12:45:00',2.96),('8784','2014-02-16','12:50:00',2.94),('8784','2014-02-16','12:55:00',2.9),('8784','2014-02-16','13:00:00',2.89),('8784','2014-02-16','13:05:00',2.89),('8784','2014-02-16','13:10:00',2.78),('8784','2014-02-16','13:15:00',2.86),('8784','2014-02-16','13:20:00',2.83),('8784','2014-02-16','13:25:00',2.76),('8784','2014-02-16','13:30:00',2.77),('8784','2014-02-16','13:35:00',2.69),('8784','2014-02-16','13:40:00',2.7),('8784','2014-02-16','13:45:00',2.73),('8784','2014-02-16','13:50:00',2.67),('8784','2014-02-16','13:55:00',2.64),('8784','2014-02-16','14:00:00',2.62),('8784','2014-02-16','14:05:00',2.58),('8784','2014-02-16','14:10:00',2.5),('8784','2014-02-16','14:15:00',2.32),('8784','2014-02-16','14:20:00',2.21),('8784','2014-02-16','14:25:00',2.3),('8784','2014-02-16','14:30:00',2.28),('8784','2014-02-16','14:35:00',2.23),('8784','2014-02-16','14:40:00',2.15),('8784','2014-02-16','14:45:00',2.12),('8784','2014-02-16','14:50:00',2.04),('8784','2014-02-16','14:55:00',2.01),('8784','2014-02-16','15:00:00',1.93),('8784','2014-02-16','15:05:00',1.87),('8784','2014-02-16','15:10:00',1.8),('8784','2014-02-16','15:15:00',1.74),('8784','2014-02-16','15:20:00',1.65),('8784','2014-02-16','15:25:00',1.58),('8784','2014-02-16','15:30:00',1.5),('8784','2014-02-16','15:35:00',1.29),('8784','2014-02-16','15:40:00',1.18),('8784','2014-02-16','15:45:00',1.35),('8784','2014-02-16','15:50:00',1.07),('8784','2014-02-16','16:25:00',1.09),('8784','2014-02-16','16:30:00',1),('8784','2014-04-28','08:15:00',1.85),('8784','2014-04-28','08:20:00',1.97),('8784','2014-04-28','08:25:00',2.07),('8784','2014-04-28','08:30:00',1.34),('8784','2014-04-28','08:35:00',1.35),('8784','2014-04-28','08:40:00',1.38),('8784','2014-04-28','08:45:00',1.29),('8784','2014-04-28','08:50:00',1.35),('8784','2014-04-28','08:55:00',1.49),('8784','2014-04-28','09:00:00',1.1),('8784','2014-04-28','09:05:00',1.73),('8784','2014-04-28','09:10:00',2.93),('8784','2014-04-28','09:15:00',3.06),('8784','2014-04-28','09:20:00',2.28),('8784','2014-04-28','09:25:00',1.72),('8784','2014-04-28','09:30:00',2.85),('8784','2014-04-28','09:35:00',2.62),('8784','2014-04-28','09:40:00',2.04),('8784','2014-04-28','09:45:00',1.81),('8784','2014-04-28','09:50:00',1.78),('8784','2014-04-28','09:55:00',1.44),('8784','2014-04-28','10:00:00',2.46),('8784','2014-04-28','10:05:00',2.61),('8784','2014-04-28','10:10:00',2.53),('8784','2014-04-28','10:15:00',2.13),('8784','2014-04-28','10:20:00',1.73),('8784','2014-04-28','10:25:00',1.06),('8784','2014-04-28','10:40:00',1.19),('8784','2014-04-28','10:45:00',1.8),('8784','2014-04-28','10:50:00',2.18),('8784','2014-04-28','10:55:00',1.94),('8784','2014-04-28','11:00:00',2.13),('8784','2014-04-28','11:05:00',2.62),('8784','2014-04-28','11:10:00',2.95),('8784','2014-04-28','11:15:00',2.77),('8784','2014-04-28','11:20:00',2.41),('8784','2014-04-28','11:25:00',2.02),('8784','2014-04-28','11:30:00',2.07),('8784','2014-04-28','11:35:00',1.82),('8784','2014-04-28','11:40:00',1.67),('8784','2014-04-28','11:45:00',1.86),('8784','2014-04-28','11:50:00',2.17),('8784','2014-04-28','11:55:00',2.23),('8784','2014-04-28','12:00:00',1.95),('8784','2014-04-28','12:05:00',1.61),('8784','2014-04-28','12:10:00',2.29),('8784','2014-04-28','12:15:00',3.11),('8784','2014-04-28','12:20:00',3.1),('8784','2014-04-28','12:25:00',3.04),('8784','2014-04-28','12:30:00',3.02),('8784','2014-04-28','12:35:00',2.7),('8784','2014-04-28','12:40:00',2.31),('8784','2014-04-28','12:45:00',2.14),('8784','2014-04-28','12:50:00',2.43),('8784','2014-04-28','12:55:00',2.4),('8784','2014-04-28','13:00:00',2.5),('8784','2014-04-28','13:05:00',3.8),('8784','2014-04-28','13:10:00',3.25),('8784','2014-04-28','13:15:00',2.42),('8784','2014-04-28','13:20:00',2.76),('8784','2014-04-28','13:25:00',3.51),('8784','2014-04-28','13:30:00',5.32),('8784','2014-04-28','13:35:00',3.86),('8784','2014-04-28','13:40:00',2.93),('8784','2014-04-28','13:45:00',4.35),('8784','2014-04-28','13:50:00',4.74),('8784','2014-04-28','13:55:00',3.02),('8784','2014-04-28','14:00:00',2.25),('8784','2014-04-28','14:05:00',3.69),('8784','2014-04-28','14:10:00',3.92),('8784','2014-04-28','14:15:00',2.67),('8784','2014-04-28','14:20:00',4.4),('8784','2014-04-28','14:25:00',3.19),('8784','2014-04-28','14:30:00',3.39),('8784','2014-04-28','14:35:00',2.5),('8784','2014-04-28','14:40:00',4.22),('8784','2014-04-28','14:45:00',3.75),('8784','2014-04-28','14:50:00',3.54),('8784','2014-04-28','14:55:00',4.4),('8784','2014-04-28','15:00:00',3.53),('8784','2014-04-28','15:05:00',3.46),('8784','2014-04-28','15:10:00',2.15),('8784','2014-04-28','15:15:00',2.24),('8784','2014-04-28','15:20:00',2.07),('8784','2014-04-28','15:25:00',1.61),('8784','2014-04-28','15:30:00',2.12),('8784','2014-04-28','15:35:00',3.64),('8784','2014-04-28','15:40:00',2.53),('8784','2014-04-28','15:45:00',3.2),('8784','2014-04-28','15:50:00',2.54),('8784','2014-04-28','15:55:00',1.48),('8784','2014-04-28','16:00:00',2.77),('8784','2014-04-28','16:05:00',2.84),('8784','2014-04-28','16:10:00',4.05),('8784','2014-04-28','16:15:00',2.3),('8784','2014-04-28','16:20:00',2.15),('8784','2014-04-28','16:25:00',2.02),('8784','2014-04-28','16:30:00',2.94),('8784','2014-04-28','16:35:00',3.3),('8784','2014-04-28','16:50:00',1.17),('8784','2014-04-28','16:55:00',1.8),('8784','2014-04-28','17:25:00',1.05),('8784','2014-04-28','17:35:00',1.32),('8784','2014-04-28','17:40:00',1.44),('8784','2014-02-15','08:40:00',1.03),('8784','2014-02-15','08:45:00',1.1),('8784','2014-02-15','08:50:00',1.15),('8784','2014-02-15','08:55:00',1.19),('8784','2014-02-15','09:00:00',1),('8784','2014-02-15','09:05:00',1.21),('8784','2014-02-15','09:10:00',1.42),('8784','2014-02-15','09:15:00',1.51),('8784','2014-02-15','09:20:00',1.59),('8784','2014-02-15','09:25:00',1.65),('8784','2014-02-15','09:30:00',1.77),('8784','2014-02-15','09:35:00',1.87),('8784','2014-02-15','09:40:00',1.94),('8784','2014-02-15','09:45:00',1.97),('8784','2014-02-15','09:50:00',2.06),('8784','2014-02-15','09:55:00',2.1),('8784','2014-02-15','10:00:00',2.14),('8784','2014-02-15','10:05:00',2.23),('8784','2014-02-15','10:10:00',2.25),('8784','2014-02-15','10:15:00',2.31),('8784','2014-02-15','10:20:00',2.37),('8784','2014-02-15','10:25:00',2.38),('8784','2014-02-15','10:30:00',2.5),('8784','2014-02-15','10:35:00',2.53),('8784','2014-02-15','10:40:00',2.57),('8784','2014-02-15','10:45:00',2.64),('8784','2014-02-15','10:50:00',2.64),('8784','2014-02-15','10:55:00',2.62),('8784','2014-02-15','11:00:00',1.74),('8784','2014-02-15','11:05:00',2.83),('8784','2014-02-15','11:10:00',2.93),('8784','2014-02-15','11:15:00',2.98),('8784','2014-02-15','11:20:00',2.06),('8784','2014-02-15','11:25:00',3.03),('8784','2014-02-15','11:30:00',2.42),('8784','2014-02-15','11:35:00',2.54),('8784','2014-02-15','11:40:00',3.37),('8784','2014-02-15','11:45:00',3.41),('8784','2014-02-15','11:50:00',3.05),('8784','2014-02-15','11:55:00',2.08),('8784','2014-02-15','12:00:00',1.19),('8784','2014-02-15','12:05:00',1.61),('8784','2014-02-15','12:10:00',3.18),('8784','2014-02-15','12:15:00',3.54),('8784','2014-02-15','12:20:00',2.9),('8784','2014-02-15','12:25:00',1.43),('8784','2014-02-15','12:30:00',2.52),('8784','2014-02-15','12:35:00',3.37),('8784','2014-02-15','12:40:00',3.08),('8784','2014-02-15','12:45:00',3.42),('8784','2014-02-15','12:50:00',3.44),('8784','2014-02-15','12:55:00',2.11),('8784','2014-02-15','13:00:00',3.11),('8784','2014-02-15','13:05:00',3.31),('8784','2014-02-15','13:10:00',3.3),('8784','2014-02-15','13:15:00',3),('8784','2014-02-15','13:20:00',2.96),('8784','2014-02-15','13:25:00',2.87),('8784','2014-02-15','13:30:00',2.83),('8784','2014-02-15','13:35:00',2.73),('8784','2014-02-15','13:40:00',2.67),('8784','2014-02-15','13:45:00',2.61),('8784','2014-02-15','13:50:00',2.68),('8784','2014-02-15','13:55:00',2.59),('8784','2014-02-15','14:00:00',2.47),('8784','2014-02-15','14:05:00',2.49),('8784','2014-02-15','14:10:00',2.4),('8784','2014-02-15','14:15:00',2.24),('8784','2014-02-15','14:20:00',2),('8784','2014-02-15','14:25:00',2.12),('8784','2014-02-15','14:30:00',2.08),('8784','2014-02-15','14:35:00',2.14),('8784','2014-02-15','14:40:00',2.1),('8784','2014-02-15','14:45:00',2.02),('8784','2014-02-15','14:50:00',1.95),('8784','2014-02-15','14:55:00',1.85),('8784','2014-02-15','15:00:00',1.85),('8784','2014-02-15','15:05:00',1.8),('8784','2014-02-15','15:10:00',1.76),('8784','2014-02-15','15:15:00',1.68),('8784','2014-02-15','15:20:00',1.61),('8784','2014-02-15','15:25:00',1.56),('8784','2014-02-15','15:30:00',1.49),('8784','2014-02-15','15:35:00',1.43),('8784','2014-02-15','15:40:00',1.37),('8784','2014-02-15','15:45:00',1.29),('8784','2014-02-15','15:50:00',1.22),('8784','2014-02-15','15:55:00',1.16),('8784','2014-02-15','16:00:00',1.08),('8784','2014-02-14','08:50:00',1.17),('8784','2014-02-14','08:55:00',1.23),('8784','2014-02-14','09:05:00',1.06),('8784','2014-02-14','09:10:00',1.07),('8784','2014-02-14','09:20:00',1.21),('8784','2014-02-14','09:25:00',1.03),('8784','2014-02-14','09:30:00',1.73),('8784','2014-02-14','09:35:00',1.34),('8784','2014-02-14','09:45:00',1.03),('8784','2014-02-14','09:50:00',2.43),('8784','2014-02-14','09:55:00',2.18),('8784','2014-02-14','10:00:00',2.3),('8784','2014-02-14','10:05:00',2.52),('8784','2014-02-14','10:10:00',2.48),('8784','2014-02-14','10:15:00',1.57),('8784','2014-02-14','10:20:00',2.76),('8784','2014-02-14','10:25:00',2.67),('8784','2014-02-14','10:30:00',2.69),('8784','2014-02-14','10:35:00',2.56),('8784','2014-02-14','10:40:00',2.72),('8784','2014-02-14','10:45:00',2.83),('8784','2014-02-14','10:50:00',2.87),('8784','2014-02-14','10:55:00',2.86),('8784','2014-02-14','11:00:00',2.91),('8784','2014-02-14','11:05:00',2.94),('8784','2014-02-14','11:10:00',2.95),('8784','2014-02-14','11:15:00',2.98),('8784','2014-02-14','11:20:00',3.02),('8784','2014-02-14','11:25:00',3.05),('8784','2014-02-14','11:30:00',3.07),('8784','2014-02-14','11:35:00',3.09),('8784','2014-02-14','11:40:00',3.09),('8784','2014-02-14','11:45:00',3.12),('8784','2014-02-14','11:50:00',3.04),('8784','2014-02-14','11:55:00',3.14),('8784','2014-02-14','12:00:00',2.74),('8784','2014-02-14','12:05:00',3.09),('8784','2014-02-14','12:10:00',3.16),('8784','2014-02-14','12:15:00',3.11),('8784','2014-02-14','12:20:00',3.11),('8784','2014-02-14','12:25:00',3.12),('8784','2014-02-14','12:30:00',3.09),('8784','2014-02-14','12:35:00',3.03),('8784','2014-02-14','12:40:00',3.06),('8784','2014-02-14','12:45:00',3.05),('8784','2014-02-14','12:50:00',3.03),('8784','2014-02-14','12:55:00',2.97),('8784','2014-02-14','13:00:00',2.87),('8784','2014-02-14','13:05:00',2.91),('8784','2014-02-14','13:10:00',2.98),('8784','2014-02-14','13:15:00',2.97),('8784','2014-02-14','13:20:00',2.92),('8784','2014-02-14','13:25:00',2.86),('8784','2014-02-14','13:30:00',2.78),('8784','2014-02-14','13:35:00',2.76),('8784','2014-02-14','13:40:00',2.76),('8784','2014-02-14','13:45:00',2.74),('8784','2014-02-14','13:50:00',2.7),('8784','2014-02-14','13:55:00',2.66),('8784','2014-02-14','14:00:00',2.61),('8784','2014-02-14','14:05:00',2.55),('8784','2014-02-14','14:10:00',2.46),('8784','2014-02-14','14:15:00',2.22),('8784','2014-02-14','14:20:00',2.09),('8784','2014-02-14','14:25:00',2.28),('8784','2014-02-14','14:30:00',2.26),('8784','2014-02-14','14:35:00',2.21),('8784','2014-02-14','14:40:00',2.16),('8784','2014-02-14','14:45:00',2.08),('8784','2014-02-14','14:50:00',2.02),('8784','2014-02-14','14:55:00',1.96),('8784','2014-02-14','15:00:00',1.89),('8784','2014-02-14','15:05:00',1.85),('8784','2014-02-14','15:10:00',1.77),('8784','2014-02-14','15:15:00',1.69),('8784','2014-02-14','15:20:00',1.65),('8784','2014-02-14','15:25:00',1.57),('8784','2014-02-14','15:30:00',1.48),('8784','2014-02-14','15:35:00',1.4),('8784','2014-02-14','15:40:00',1.35),('8784','2014-02-14','15:45:00',1.26),('8784','2014-02-14','15:50:00',1.19),('8784','2014-02-14','15:55:00',1.12),('8784','2014-02-14','16:00:00',1.06),('8784','2014-02-13','08:45:00',1.04),('8784','2014-02-13','08:50:00',1.13),('8784','2014-02-13','08:55:00',1.19),('8784','2014-02-13','09:00:00',1.08),('8784','2014-02-13','09:05:00',1.19),('8784','2014-02-13','09:10:00',1.46),('8784','2014-02-13','09:15:00',1.49),('8784','2014-02-13','09:20:00',1.57),('8784','2014-02-13','09:25:00',1.66),('8784','2014-02-13','09:30:00',1.73),('8784','2014-02-13','09:35:00',1.87),('8784','2014-02-13','09:40:00',1.92),('8784','2014-02-13','09:45:00',1.99),('8784','2014-02-13','09:50:00',2.08),('8784','2014-02-13','09:55:00',2.13),('8784','2014-02-13','10:00:00',2.22),('8784','2014-02-13','10:05:00',2.26),('8784','2014-02-13','10:10:00',2.32),('8784','2014-02-13','10:15:00',2.34),('8784','2014-02-13','10:20:00',2.41),('8784','2014-02-13','10:25:00',2.5),('8784','2014-02-13','10:30:00',2.54),('8784','2014-02-13','10:35:00',2.61),('8784','2014-02-13','10:40:00',2.61),('8784','2014-02-13','10:45:00',2.65),('8784','2014-02-13','10:50:00',2.7),('8784','2014-02-13','10:55:00',2.72),('8784','2014-02-13','11:00:00',2.77),('8784','2014-02-13','11:05:00',2.81),('8784','2014-02-13','11:10:00',2.85),('8784','2014-02-13','11:15:00',2.94),('8784','2014-02-13','11:20:00',3.12),('8784','2014-02-13','11:25:00',3.06),('8784','2014-02-13','11:30:00',2.79),('8784','2014-02-13','11:35:00',1.73),('8784','2014-02-13','11:40:00',2.28),('8784','2014-02-13','11:45:00',1.72),('8784','2014-02-13','11:50:00',2.05),('8784','2014-02-13','11:55:00',2.01),('8784','2014-02-13','12:00:00',1.98),('8784','2014-02-13','12:05:00',1.49),('8784','2014-02-13','12:10:00',2.09),('8784','2014-02-13','12:15:00',1.67),('8784','2014-02-13','12:20:00',1.81),('8784','2014-02-13','12:25:00',2.83),('8784','2014-02-13','12:30:00',3.7),('8784','2014-02-13','12:35:00',3.58),('8784','2014-02-13','12:40:00',2.56),('8784','2014-02-13','12:45:00',1.61),('8784','2014-02-13','12:50:00',2.56),('8784','2014-02-13','12:55:00',3.19),('8784','2014-02-13','13:00:00',3.02),('8784','2014-02-13','13:05:00',3.06),('8784','2014-02-13','13:10:00',3.03),('8784','2014-02-13','13:15:00',2.98),('8784','2014-02-13','13:20:00',2.96),('8784','2014-02-13','13:25:00',2.91),('8784','2014-02-13','13:30:00',2.89),('8784','2014-02-13','13:35:00',2.85),('8784','2014-02-13','13:40:00',2.8),('8784','2014-02-13','13:45:00',2.77),('8784','2014-02-13','13:50:00',2.74),('8784','2014-02-13','13:55:00',2.68),('8784','2014-02-13','14:00:00',2.63),('8784','2014-02-13','14:05:00',2.53),('8784','2014-02-13','14:10:00',2.45),('8784','2014-02-13','14:15:00',2.14),('8784','2014-02-13','14:20:00',2.29),('8784','2014-02-13','14:25:00',2.34),('8784','2014-02-13','14:30:00',2.32),('8784','2014-02-13','14:35:00',2.26),('8784','2014-02-13','14:40:00',1.37),('8784','2014-02-13','14:45:00',1.86),('8784','2014-02-13','14:50:00',2.08),('8784','2014-02-13','14:55:00',2.07),('8784','2014-02-13','15:00:00',1.42),('8784','2014-02-13','15:05:00',2.06),('8784','2014-02-13','15:10:00',2),('8784','2014-02-13','15:15:00',1.86),('8784','2014-02-13','15:20:00',1.81),('8784','2014-02-13','15:25:00',1.05),('8784','2014-02-13','15:30:00',1.03),('8784','2014-02-13','15:40:00',1.58),('8784','2014-02-13','15:45:00',1.41),('8784','2014-02-13','16:10:00',1.16),('8784','2014-02-12','09:10:00',1.07),('8784','2014-02-12','09:15:00',1.39),('8784','2014-02-12','09:20:00',1.14),('8784','2014-02-12','09:40:00',1.19),('8784','2014-02-12','09:45:00',1.42),('8784','2014-02-12','09:50:00',1.59),('8784','2014-02-12','09:55:00',1.06),('8784','2014-02-12','10:00:00',1.11),('8784','2014-02-12','10:05:00',1.56),('8784','2014-02-12','10:10:00',1.42),('8784','2014-02-12','10:15:00',1.18),('8784','2014-02-12','10:20:00',1.12),('8784','2014-02-12','10:25:00',1.18),('8784','2014-02-12','10:30:00',1.46),('8784','2014-02-12','10:35:00',1.56),('8784','2014-02-12','10:40:00',1.34),('8784','2014-02-12','10:45:00',1.9),('8784','2014-02-12','10:50:00',1.41),('8784','2014-02-12','10:55:00',1.44),('8784','2014-02-12','11:00:00',1.54),('8784','2014-02-12','11:05:00',2.27),('8784','2014-02-12','11:10:00',1.61),('8784','2014-02-12','11:15:00',1.5),('8784','2014-02-12','11:20:00',1.53),('8784','2014-02-12','11:25:00',1.63),('8784','2014-02-12','11:30:00',1.6),('8784','2014-02-12','11:35:00',2.06),('8784','2014-02-12','11:40:00',1.14),('8784','2014-02-12','12:10:00',1.26),('8784','2014-02-12','12:15:00',1.36),('8784','2014-02-12','12:20:00',1.39),('8784','2014-02-12','12:25:00',1.46),('8784','2014-02-12','12:30:00',1.54),('8784','2014-02-12','12:35:00',1.49),('8784','2014-02-12','12:40:00',1.47),('8784','2014-02-12','12:45:00',1.63),('8784','2014-02-12','12:50:00',1.78),('8784','2014-02-12','12:55:00',1.83),('8784','2014-02-12','13:00:00',2.07),('8784','2014-02-12','13:05:00',1.82),('8784','2014-02-12','13:10:00',1.77),('8784','2014-02-12','13:15:00',1.37),('8784','2014-02-12','13:20:00',1.34),('8784','2014-02-12','13:25:00',1.56),('8784','2014-02-12','13:30:00',2.75),('8784','2014-02-12','13:35:00',2.54),('8784','2014-02-12','13:40:00',3.05),('8784','2014-02-12','13:45:00',2.22),('8784','2014-02-12','13:50:00',2.21),('8784','2014-02-12','13:55:00',2.05),('8784','2014-02-12','14:00:00',2.96),('8784','2014-02-12','14:05:00',2.88),('8784','2014-02-12','14:10:00',2.73),('8784','2014-02-12','14:15:00',2.36),('8784','2014-02-12','14:20:00',2.13),('8784','2014-02-12','14:25:00',1.62),('8784','2014-02-12','14:30:00',1.61),('8784','2014-02-12','14:35:00',2.28),('8784','2014-02-12','14:40:00',1.46),('8784','2014-02-12','14:45:00',2.5),('8784','2014-02-12','14:50:00',2.35),('8784','2014-02-12','14:55:00',2),('8784','2014-02-12','15:00:00',1.45),('8784','2014-02-12','15:10:00',1.25),('8784','2014-02-12','15:15:00',1.4),('8784','2014-02-12','15:20:00',1.67),('8784','2014-02-12','15:25:00',1.02),('8784','2014-02-12','15:30:00',1.65),('8784','2014-02-12','15:35:00',1.66),('8784','2014-02-12','15:40:00',1.73),('8784','2014-02-12','15:45:00',1.04),('8784','2014-02-12','15:50:00',1.58),('8784','2014-02-11','09:20:00',1.02),('8784','2014-02-11','09:25:00',1.15),('8784','2014-02-11','09:30:00',1.2),('8784','2014-02-11','09:35:00',1.23),('8784','2014-02-11','09:40:00',1.2),('8784','2014-02-11','09:45:00',1.2),('8784','2014-02-11','09:50:00',1.23),('8784','2014-02-11','09:55:00',1.22),('8784','2014-02-11','10:00:00',1.12),('8784','2014-02-11','10:10:00',1.36),('8784','2014-02-11','10:15:00',1.57),('8784','2014-02-11','10:20:00',1.84),('8784','2014-02-11','10:25:00',1.9),('8784','2014-02-11','10:30:00',2.02),('8784','2014-02-11','10:35:00',2.25),('8784','2014-02-11','10:40:00',2.25),('8784','2014-02-11','10:45:00',2.17),('8784','2014-02-11','10:50:00',2.34),('8784','2014-02-11','10:55:00',2.04),('8784','2014-02-11','11:00:00',1.85),('8784','2014-02-11','11:05:00',2.15),('8784','2014-02-11','11:10:00',2.15),('8784','2014-02-11','11:15:00',1.99),('8784','2014-02-11','11:20:00',1.58),('8784','2014-02-11','11:25:00',1.58),('8784','2014-02-11','11:30:00',1.67),('8784','2014-02-11','11:35:00',1.61),('8784','2014-02-11','11:40:00',1.57),('8784','2014-02-11','11:45:00',2.11),('8784','2014-02-11','11:50:00',1.54),('8784','2014-02-11','11:55:00',1.3),('8784','2014-02-11','12:00:00',1.36),('8784','2014-02-11','12:05:00',1.63),('8784','2014-02-11','12:10:00',1.93),('8784','2014-02-11','12:15:00',1.65),('8784','2014-02-11','12:20:00',1.76),('8784','2014-02-11','12:25:00',2.33),('8784','2014-02-11','12:30:00',2.21),('8784','2014-02-11','12:35:00',1.99),('8784','2014-02-11','12:40:00',1.51),('8784','2014-02-11','12:45:00',1.76),('8784','2014-02-11','12:50:00',1.44),('8784','2014-02-11','12:55:00',1.74),('8784','2014-02-11','13:00:00',1.78),('8784','2014-02-11','13:05:00',2.16),('8784','2014-02-11','13:10:00',2.66),('8784','2014-02-11','13:15:00',2.51),('8784','2014-02-11','13:20:00',2.84),('8784','2014-02-11','13:25:00',2.56),('8784','2014-02-11','13:30:00',2.35),('8784','2014-02-11','13:35:00',2.23),('8784','2014-02-11','13:40:00',2.61),('8784','2014-02-11','13:45:00',1.96),('8784','2014-02-11','13:50:00',1.57),('8784','2014-02-11','13:55:00',1.38),('8784','2014-02-11','14:00:00',1.78),('8784','2014-02-11','14:05:00',2.03),('8784','2014-02-11','14:10:00',1.53),('8784','2014-02-11','14:15:00',2.01),('8784','2014-02-11','14:20:00',1.5),('8784','2014-02-11','14:25:00',1.4),('8784','2014-02-11','14:30:00',1.47),('8784','2014-02-11','14:35:00',1.39),('8784','2014-02-11','14:40:00',1.16),('8784','2014-02-11','14:45:00',1.17),('8784','2014-02-11','15:10:00',1),('8784','2014-02-11','15:15:00',1.3),('8784','2014-02-11','15:20:00',1.4),('8784','2014-02-11','15:25:00',1.1),('8784','2014-02-10','12:55:00',1.04),('8784','2014-02-10','13:00:00',1.36),('8784','2014-02-10','13:05:00',1.15),('8784','2014-02-10','13:55:00',1.01),('8784','2014-02-10','14:00:00',1.05),('8784','2014-02-10','14:30:00',1.05),('8784','2014-02-10','14:35:00',1.12),('8784','2014-02-10','14:40:00',1.17),('8784','2014-02-10','14:45:00',1.06),('8784','2014-02-09','11:25:00',1.07),('8784','2014-02-09','11:30:00',1.2),('8784','2014-02-09','11:35:00',1.5),('8784','2014-02-09','12:15:00',1.01),('8784','2014-02-09','12:25:00',1.47),('8784','2014-02-09','12:30:00',1.52),('8784','2014-02-09','12:45:00',1.95),('8784','2014-02-09','12:55:00',1.92),('8784','2014-02-09','13:00:00',1.61),('8784','2014-02-09','13:05:00',2.93),('8784','2014-02-09','13:10:00',1.97),('8784','2014-02-09','13:15:00',1.49),('8784','2014-02-09','13:25:00',1.07),('8784','2014-02-09','13:40:00',1.59),('8784','2014-02-09','13:45:00',2.61),('8784','2014-02-09','13:50:00',1.39),('8784','2014-02-09','13:55:00',1.99),('8784','2014-02-09','14:00:00',1.51),('8784','2014-02-09','14:05:00',2.2),('8784','2014-02-09','14:10:00',1.82),('8784','2014-02-09','14:15:00',1.19),('8784','2014-02-09','14:20:00',1.17),('8784','2014-02-09','14:25:00',1.57),('8784','2014-02-09','14:30:00',1.68),('8784','2014-02-09','14:35:00',1.57),('8784','2014-02-09','14:40:00',1.03),('8784','2014-02-09','14:50:00',1.82),('8784','2014-02-09','15:15:00',1.28),('8784','2014-02-09','15:20:00',1.47),('8784','2014-02-09','15:25:00',1.36),('8784','2014-02-09','15:45:00',1.03),('8784','2014-02-09','15:50:00',1.05),('8784','2014-02-08','09:50:00',1.66),('8784','2014-02-08','10:15:00',1.31),('8784','2014-02-08','10:20:00',1.09),('8784','2014-02-08','10:25:00',1.07),('8784','2014-02-08','10:30:00',2.06),('8784','2014-02-08','10:35:00',2.44),('8784','2014-02-08','10:40:00',1.09),('8784','2014-02-08','10:45:00',1.53),('8784','2014-02-08','10:50:00',1.95),('8784','2014-02-08','10:55:00',2.15),('8784','2014-02-08','11:00:00',1.82),('8784','2014-02-08','11:05:00',2.82),('8784','2014-02-08','11:10:00',1.97),('8784','2014-02-08','11:15:00',1.81),('8784','2014-02-08','11:20:00',1.14),('8784','2014-02-08','11:30:00',2.01),('8784','2014-02-08','11:35:00',3.47),('8784','2014-02-08','11:40:00',1.75),('8784','2014-02-08','11:50:00',1.77),('8784','2014-02-08','11:55:00',3.35),('8784','2014-02-08','12:10:00',2.18),('8784','2014-02-08','12:15:00',2.83),('8784','2014-02-08','12:25:00',2.75),('8784','2014-02-08','12:30:00',3.24),('8784','2014-02-08','12:35:00',2.33),('8784','2014-02-08','12:40:00',1.74),('8784','2014-02-08','12:45:00',3.24),('8784','2014-02-08','12:50:00',2.6),('8784','2014-02-08','12:55:00',2.93),('8784','2014-02-08','13:00:00',2.65),('8784','2014-02-08','13:10:00',2.18),('8784','2014-02-08','13:15:00',3.67),('8784','2014-02-08','13:20:00',3.31),('8784','2014-02-08','13:25:00',2.74),('8784','2014-02-08','13:30:00',1.89),('8784','2014-02-08','13:35:00',1.85),('8784','2014-02-08','13:40:00',2.37),('8784','2014-02-08','13:45:00',2.89),('8784','2014-02-08','13:50:00',2.44),('8784','2014-02-08','13:55:00',2.61),('8784','2014-02-08','14:00:00',2.57),('8784','2014-02-08','14:05:00',2.57),('8784','2014-02-08','14:10:00',2.44),('8784','2014-02-08','14:15:00',1.15),('8784','2014-02-08','14:20:00',2.17),('8784','2014-02-08','14:25:00',1.66),('8784','2014-02-08','14:30:00',2.4),('8784','2014-02-08','14:35:00',1.29),('8784','2014-02-08','14:40:00',1.45),('8784','2014-02-08','14:50:00',2.09),('8784','2014-02-08','14:55:00',1.96),('8784','2014-02-08','15:00:00',1.09),('8784','2014-02-08','15:15:00',1.08),('8784','2014-02-08','15:20:00',1.76),('8784','2014-02-08','15:40:00',1.5),('8784','2014-02-08','15:45:00',1.42),('8784','2014-02-08','15:50:00',1.18),('8784','2014-02-07','09:10:00',1.15),('8784','2014-02-07','09:15:00',1.29),('8784','2014-02-07','09:20:00',1.31),('8784','2014-02-07','09:25:00',1.35),('8784','2014-02-07','09:30:00',1.45),('8784','2014-02-07','09:35:00',1.54),('8784','2014-02-07','09:40:00',1.7),('8784','2014-02-07','09:45:00',1.75),('8784','2014-02-07','09:50:00',1.83),('8784','2014-02-07','09:55:00',1.88),('8784','2014-02-07','10:00:00',1.95),('8784','2014-02-07','10:05:00',1.97),('8784','2014-02-07','10:10:00',2.16),('8784','2014-02-07','10:15:00',2.33),('8784','2014-02-07','10:20:00',2.4),('8784','2014-02-07','10:25:00',2.22),('8784','2014-02-07','10:30:00',1.87),('8784','2014-02-07','10:35:00',2.61),('8784','2014-02-07','10:40:00',2.45),('8784','2014-02-07','10:45:00',2.77),('8784','2014-02-07','10:50:00',2.81),('8784','2014-02-07','10:55:00',2.9),('8784','2014-02-07','11:00:00',2.98),('8784','2014-02-07','11:05:00',3.04),('8784','2014-02-07','11:10:00',3.02),('8784','2014-02-07','11:15:00',3.11),('8784','2014-02-07','11:20:00',2.97),('8784','2014-02-07','11:25:00',2.58),('8784','2014-02-07','11:30:00',2.88),('8784','2014-02-07','11:35:00',2.7),('8784','2014-02-07','11:40:00',3.04),('8784','2014-02-07','11:45:00',2.04),('8784','2014-02-07','11:50:00',2.73),('8784','2014-02-07','11:55:00',2.73),('8784','2014-02-07','12:00:00',2.32),('8784','2014-02-07','12:05:00',2.31),('8784','2014-02-07','12:10:00',2),('8784','2014-02-07','12:15:00',3.46),('8784','2014-02-07','12:20:00',2.51),('8784','2014-02-07','12:25:00',1.63),('8784','2014-02-07','12:30:00',1.9),('8784','2014-02-07','12:35:00',1.11),('8784','2014-02-07','12:40:00',1.57),('8784','2014-02-07','12:45:00',1.64),('8784','2014-02-07','12:50:00',3.47),('8784','2014-02-07','12:55:00',2.55),('8784','2014-02-07','13:00:00',1.43),('8784','2014-02-07','13:05:00',2.36),('8784','2014-02-07','13:10:00',3.08),('8784','2014-02-07','13:15:00',1.38),('8784','2014-02-07','13:20:00',1.99),('8784','2014-02-07','13:25:00',1.31),('8784','2014-02-07','13:30:00',1.25),('8784','2014-02-07','13:35:00',1.83),('8784','2014-02-07','13:40:00',1.03),('8784','2014-02-07','13:45:00',2.65),('8784','2014-02-07','13:50:00',2.56),('8784','2014-02-07','13:55:00',2.8),('8784','2014-02-07','14:00:00',1.64),('8784','2014-02-07','14:05:00',2.31),('8784','2014-02-07','14:10:00',2.35),('8784','2014-02-07','14:15:00',2),('8784','2014-02-07','14:20:00',1.87),('8784','2014-02-07','14:25:00',1.45),('8784','2014-02-07','14:30:00',1.83),('8784','2014-02-07','14:35:00',2.56),('8784','2014-02-07','14:40:00',2.34),('8784','2014-02-07','14:45:00',2.07),('8784','2014-02-07','14:50:00',2.01),('8784','2014-02-07','14:55:00',1.9),('8784','2014-02-07','15:00:00',1.77),('8784','2014-02-07','15:05:00',1.69),('8784','2014-02-07','15:10:00',1.63),('8784','2014-02-07','15:15:00',1.58),('8784','2014-02-07','15:20:00',1.55),('8784','2014-02-07','15:25:00',1.44),('8784','2014-02-07','15:30:00',1.36),('8784','2014-02-07','15:35:00',1.29),('8784','2014-02-07','15:40:00',1.23),('8784','2014-02-07','15:45:00',1.16),('8784','2014-02-07','15:50:00',1.07),('8784','2014-02-06','09:00:00',1.04),('8784','2014-02-06','09:05:00',1.17),('8784','2014-02-06','09:10:00',1.25),('8784','2014-02-06','09:15:00',1.23),('8784','2014-02-06','09:40:00',1.21),('8784','2014-02-06','09:45:00',1.75),('8784','2014-02-06','09:50:00',1.85),('8784','2014-02-06','09:55:00',1.91),('8784','2014-02-06','10:00:00',1.97),('8784','2014-02-06','10:05:00',2.01),('8784','2014-02-06','10:10:00',2.13),('8784','2014-02-06','10:15:00',2.28),('8784','2014-02-06','10:20:00',2.32),('8784','2014-02-06','10:25:00',2.15),('8784','2014-02-06','10:30:00',2.39),('8784','2014-02-06','10:35:00',2.21),('8784','2014-02-06','10:40:00',2.19),('8784','2014-02-06','10:45:00',2.29),('8784','2014-02-06','10:50:00',1.98),('8784','2014-02-06','10:55:00',2.15),('8784','2014-02-06','11:00:00',1.89),('8784','2014-02-06','11:05:00',1.95),('8784','2014-02-06','11:10:00',1.36),('8784','2014-02-06','11:15:00',1.61),('8784','2014-02-06','11:20:00',2.79),('8784','2014-02-06','11:25:00',1.9),('8784','2014-02-06','11:30:00',3.22),('8784','2014-02-06','11:35:00',2.94),('8784','2014-02-06','11:40:00',2.85),('8784','2014-02-06','11:45:00',2.88),('8784','2014-02-06','11:50:00',2.92),('8784','2014-02-06','11:55:00',2.93),('8784','2014-02-06','12:00:00',2.93),('8784','2014-02-06','12:05:00',3.03),('8784','2014-02-06','12:10:00',2.98),('8784','2014-02-06','12:15:00',2.97),('8784','2014-02-06','12:20:00',2.95),('8784','2014-02-06','12:25:00',2.92),('8784','2014-02-06','12:30:00',2.91),('8784','2014-02-06','12:35:00',2.48),('8784','2014-02-06','12:40:00',2.99),('8784','2014-02-06','12:45:00',2.95),('8784','2014-02-06','12:50:00',2.87),('8784','2014-02-06','12:55:00',2.68),('8784','2014-02-06','13:00:00',2.79),('8784','2014-02-06','13:05:00',2.29),('8784','2014-02-06','13:10:00',2.9),('8784','2014-02-06','13:15:00',2.83),('8784','2014-02-06','13:20:00',2.83),('8784','2014-02-06','13:25:00',1.63),('8784','2014-02-06','13:30:00',2.46),('8784','2014-02-06','13:35:00',2.66),('8784','2014-02-06','13:40:00',2.66),('8784','2014-02-06','13:45:00',2.59),('8784','2014-02-06','13:50:00',2.6),('8784','2014-02-06','13:55:00',2.56),('8784','2014-02-06','14:00:00',2.4),('8784','2014-02-06','14:05:00',2.36),('8784','2014-02-06','14:10:00',1.89),('8784','2014-02-06','14:15:00',2.24),('8784','2014-02-06','14:20:00',2.24),('8784','2014-02-06','14:25:00',2.26),('8784','2014-02-06','14:30:00',2.23),('8784','2014-02-06','14:35:00',2.12),('8784','2014-02-06','14:40:00',2.1),('8784','2014-02-06','14:45:00',2.08),('8784','2014-02-06','14:50:00',2.04),('8784','2014-02-06','14:55:00',1.86),('8784','2014-02-06','15:00:00',1.79),('8784','2014-02-06','15:05:00',1.73),('8784','2014-02-06','15:10:00',1.59),('8784','2014-02-06','15:15:00',1.58),('8784','2014-02-06','15:20:00',1.57),('8784','2014-02-06','15:25:00',1.4),('8784','2014-02-06','15:30:00',1.31),('8784','2014-02-06','15:35:00',1.24),('8784','2014-02-06','15:40:00',1.18),('8784','2014-02-06','15:45:00',1.11),('8784','2014-02-06','15:50:00',1.04),('8784','2014-04-27','09:20:00',1.02),('8784','2014-04-27','10:00:00',1.24),('8784','2014-04-27','10:05:00',1.33),('8784','2014-04-27','10:10:00',1.27),('8784','2014-04-27','10:15:00',1.23),('8784','2014-04-27','10:20:00',1.24),('8784','2014-04-27','10:25:00',1.11),('8784','2014-04-27','11:00:00',1.13),('8784','2014-04-27','11:05:00',1.33),('8784','2014-04-27','11:10:00',1.31),('8784','2014-04-27','11:15:00',1.32),('8784','2014-04-27','11:35:00',1.52),('8784','2014-04-27','11:40:00',1.77),('8784','2014-04-27','11:45:00',3.96),('8784','2014-04-27','11:50:00',3.19),('8784','2014-04-27','11:55:00',2.89),('8784','2014-04-27','12:00:00',2.69),('8784','2014-04-27','12:05:00',3.07),('8784','2014-04-27','12:10:00',3.24),('8784','2014-04-27','12:15:00',3.42),('8784','2014-04-27','12:20:00',3.06),('8784','2014-04-27','12:25:00',3),('8784','2014-04-27','12:30:00',2.7),('8784','2014-04-27','12:35:00',2.85),('8784','2014-04-27','12:40:00',2.51),('8784','2014-04-27','12:45:00',2.84),('8784','2014-04-27','12:50:00',2.33),('8784','2014-04-27','12:55:00',2.16),('8784','2014-04-27','13:00:00',2.65),('8784','2014-04-27','13:05:00',2.35),('8784','2014-04-27','13:10:00',2.01),('8784','2014-04-27','13:15:00',2.1),('8784','2014-04-27','13:20:00',2.63),('8784','2014-04-27','13:25:00',2.37),('8784','2014-04-27','13:30:00',2.19),('8784','2014-04-27','13:35:00',1.95),('8784','2014-04-27','13:40:00',1.82),('8784','2014-04-27','13:45:00',1.85),('8784','2014-04-27','13:50:00',1.84),('8784','2014-04-27','13:55:00',1.7),('8784','2014-04-27','14:00:00',2.13),('8784','2014-04-27','14:05:00',2.39),('8784','2014-04-27','14:10:00',1.67),('8784','2014-04-27','14:15:00',1.59),('8784','2014-04-27','14:20:00',1.94),('8784','2014-04-27','14:25:00',2.43),('8784','2014-04-27','14:30:00',2.47),('8784','2014-04-27','14:35:00',2.51),('8784','2014-04-27','14:40:00',2.59),('8784','2014-04-27','14:45:00',2.21),('8784','2014-04-27','14:50:00',2.1),('8784','2014-04-27','14:55:00',2.24),('8784','2014-04-27','15:00:00',2.42),('8784','2014-04-27','15:05:00',3.46),('8784','2014-04-27','15:10:00',4.41),('8784','2014-04-27','15:15:00',2.97),('8784','2014-04-27','15:20:00',1.97),('8784','2014-04-27','15:25:00',1.22),('8784','2014-04-27','15:35:00',1.11),('8784','2014-04-27','15:40:00',1.16),('8784','2014-02-05','10:15:00',1.72),('8784','2014-02-05','10:20:00',2.85),('8784','2014-02-05','10:25:00',2.55),('8784','2014-02-05','10:35:00',1.08),('8784','2014-02-05','10:40:00',1.08),('8784','2014-02-05','10:55:00',1.05),('8784','2014-02-05','11:10:00',1.5),('8784','2014-02-05','11:15:00',2.53),('8784','2014-02-05','11:20:00',3.69),('8784','2014-02-05','11:25:00',1.84),('8784','2014-02-05','11:30:00',1.18),('8784','2014-02-05','12:55:00',1.37),('8784','2014-02-05','13:00:00',1.1),('8784','2014-02-05','13:05:00',1.23),('8784','2014-02-05','13:10:00',1.49),('8784','2014-02-05','13:15:00',1.21),('8784','2014-02-05','13:20:00',1.45),('8784','2014-02-05','13:25:00',1.67),('8784','2014-02-05','13:30:00',1.64),('8784','2014-02-05','13:35:00',1.99),('8784','2014-02-05','13:40:00',2.03),('8784','2014-02-05','13:45:00',1.99),('8784','2014-02-05','13:50:00',1.72),('8784','2014-02-05','13:55:00',1.25),('8784','2014-02-05','14:30:00',2.55),('8784','2014-02-05','14:35:00',1.73),('8784','2014-02-04','09:15:00',1),('8784','2014-02-04','09:20:00',1.22),('8784','2014-02-04','09:25:00',1.27),('8784','2014-02-04','09:30:00',1.39),('8784','2014-02-04','09:35:00',1.2),('8784','2014-02-04','09:45:00',1.25),('8784','2014-02-04','09:50:00',1.82),('8784','2014-02-04','09:55:00',1.29),('8784','2014-02-04','10:00:00',1.9),('8784','2014-02-04','10:05:00',2.21),('8784','2014-02-04','10:10:00',1.51),('8784','2014-02-04','10:15:00',1.57),('8784','2014-02-04','10:20:00',1.21),('8784','2014-02-04','10:40:00',1.12),('8784','2014-02-04','10:45:00',1.39),('8784','2014-02-04','10:50:00',1.95),('8784','2014-02-04','10:55:00',2.47),('8784','2014-02-04','11:00:00',3.01),('8784','2014-02-04','11:05:00',1.26),('8784','2014-02-04','11:10:00',1.05),('8784','2014-02-04','11:20:00',1.06),('8784','2014-02-04','11:50:00',1.53),('8784','2014-02-04','11:55:00',3.15),('8784','2014-02-04','12:00:00',2.46),('8784','2014-02-04','12:05:00',1.57),('8784','2014-02-04','12:10:00',1.94),('8784','2014-02-04','12:15:00',1.67),('8784','2014-02-04','12:20:00',1.65),('8784','2014-02-04','12:25:00',1.4),('8784','2014-02-04','12:30:00',1.05),('8784','2014-02-04','12:45:00',1.17),('8784','2014-02-04','12:50:00',1.17),('8784','2014-02-04','12:55:00',1.08),('8784','2014-02-04','13:00:00',1.33),('8784','2014-02-04','13:05:00',1.37),('8784','2014-02-04','13:10:00',1.21),('8784','2014-02-04','13:15:00',1.37),('8784','2014-02-04','13:20:00',1.66),('8784','2014-02-04','13:25:00',1.52),('8784','2014-02-04','13:30:00',1.19),('8784','2014-02-04','13:35:00',1.07),('8784','2014-02-04','13:40:00',1.03),('8784','2014-02-03','09:50:00',1.04),('8784','2014-02-03','10:15:00',1.14),('8784','2014-02-03','10:20:00',1.07),('8784','2014-02-03','10:25:00',1.09),('8784','2014-02-03','10:30:00',1.11),('8784','2014-02-03','10:35:00',1.11),('8784','2014-02-03','10:40:00',1.17),('8784','2014-02-03','10:45:00',1.18),('8784','2014-02-03','10:50:00',1.15),('8784','2014-02-03','10:55:00',1.16),('8784','2014-02-03','11:00:00',1.1),('8784','2014-02-03','11:05:00',1.07),('8784','2014-02-03','11:10:00',1.05),('8784','2014-02-03','11:15:00',1.05),('8784','2014-02-03','11:20:00',1.11),('8784','2014-02-03','11:25:00',1.22),('8784','2014-02-03','11:30:00',1.35),('8784','2014-02-03','11:35:00',1.39),('8784','2014-02-03','11:40:00',1.39),('8784','2014-02-03','11:45:00',1.4),('8784','2014-02-03','11:50:00',1.37),('8784','2014-02-03','11:55:00',1.24),('8784','2014-02-03','12:00:00',1.11),('8784','2014-02-03','12:05:00',1.04),('8784','2014-02-03','12:10:00',1.05),('8784','2014-02-03','12:15:00',1.13),('8784','2014-02-03','12:20:00',1.12),('8784','2014-02-03','12:25:00',1.01),('8784','2014-02-03','14:30:00',1.02),('8784','2014-02-03','14:35:00',1.02),('8784','2014-02-03','14:40:00',1.01),('8784','2014-02-02','12:00:00',1.08),('8784','2014-02-02','12:05:00',1.11),('8784','2014-02-02','12:10:00',1.08),('8784','2014-02-01','11:00:00',1.25),('8784','2014-02-01','11:05:00',1.12),('8784','2014-02-01','11:15:00',1.11),('8784','2014-02-01','11:20:00',1.83),('8784','2014-02-01','11:25:00',1.32),('8784','2014-02-01','11:30:00',1.69),('8784','2014-02-01','11:35:00',1.6),('8784','2014-02-01','11:55:00',1.59),('8784','2014-02-01','12:00:00',1.29),('8784','2014-02-01','12:05:00',1.27),('8784','2014-02-01','12:10:00',1.82),('8784','2014-02-01','12:15:00',1.39),('8784','2014-02-01','12:20:00',2.2),('8784','2014-02-01','12:25:00',1.7),('8784','2014-02-01','12:35:00',1.08),('8784','2014-02-01','12:40:00',1.34),('8784','2014-02-01','12:45:00',2.03),('8784','2014-02-01','12:50:00',2.02),('8784','2014-02-01','12:55:00',1.77),('8784','2014-02-01','13:00:00',1.66),('8784','2014-02-01','13:05:00',1.25),('8784','2014-01-30','09:50:00',1.15),('8784','2014-01-30','09:55:00',1.56),('8784','2014-01-30','10:00:00',1.59),('8784','2014-01-30','10:05:00',1.21),('8784','2014-01-30','10:10:00',1.54),('8784','2014-01-30','10:15:00',2.06),('8784','2014-01-30','10:20:00',1.8),('8784','2014-01-30','10:25:00',2.19),('8784','2014-01-30','10:30:00',2.33),('8784','2014-01-30','10:35:00',2.33),('8784','2014-01-30','10:40:00',2.37),('8784','2014-01-30','10:45:00',2.07),('8784','2014-01-30','10:50:00',2.54),('8784','2014-01-30','10:55:00',2.99),('8784','2014-01-30','11:00:00',2.98),('8784','2014-01-30','11:05:00',2.84),('8784','2014-01-30','11:10:00',2.48),('8784','2014-01-30','11:15:00',2.28),('8784','2014-01-30','11:20:00',1.56),('8784','2014-01-30','11:25:00',2.25),('8784','2014-01-30','11:30:00',2.15),('8784','2014-01-30','11:35:00',2.17),('8784','2014-01-30','11:40:00',1.96),('8784','2014-01-30','11:45:00',2.65),('8784','2014-01-30','11:50:00',2.66),('8784','2014-01-30','11:55:00',2.64),('8784','2014-01-30','12:00:00',2.05),('8784','2014-01-30','12:05:00',2.84),('8784','2014-01-30','12:10:00',2.72),('8784','2014-01-30','12:15:00',2.55),('8784','2014-01-30','12:20:00',2.99),('8784','2014-01-30','12:25:00',2.41),('8784','2014-01-30','12:30:00',2.18),('8784','2014-01-30','12:35:00',2.29),('8784','2014-01-30','12:40:00',2.19),('8784','2014-01-30','12:45:00',2.59),('8784','2014-01-30','12:50:00',2.64),('8784','2014-01-30','12:55:00',2.43),('8784','2014-01-30','13:00:00',2.56),('8784','2014-01-30','13:05:00',2.79),('8784','2014-01-30','13:10:00',2.27),('8784','2014-01-30','13:15:00',2.55),('8784','2014-01-30','13:20:00',2.21),('8784','2014-01-30','13:25:00',2.35),('8784','2014-01-30','13:30:00',1.93),('8784','2014-01-30','13:35:00',1.75),('8784','2014-01-30','13:40:00',2.22),('8784','2014-01-30','13:45:00',2.41),('8784','2014-01-30','13:50:00',2.17),('8784','2014-01-30','13:55:00',1.92),('8784','2014-01-30','14:00:00',1.91),('8784','2014-01-30','14:05:00',1.82),('8784','2014-01-30','14:10:00',1.82),('8784','2014-01-30','14:15:00',1.61),('8784','2014-01-30','14:20:00',1.47),('8784','2014-01-30','14:25:00',1.57),('8784','2014-01-30','14:30:00',1.65),('8784','2014-01-30','14:35:00',1.57),('8784','2014-01-30','14:40:00',1.78),('8784','2014-01-30','14:45:00',1.65),('8784','2014-01-30','14:50:00',1.73),('8784','2014-01-30','14:55:00',1.62),('8784','2014-01-30','15:00:00',1.52),('8784','2014-01-30','15:05:00',1.45),('8784','2014-01-30','15:10:00',1.41),('8784','2014-01-30','15:15:00',1.33),('8784','2014-01-30','15:20:00',1.36),('8784','2014-01-30','15:25:00',1.35),('8784','2014-01-30','15:30:00',1.2),('8784','2014-01-30','15:35:00',1.19),('8784','2014-01-30','15:40:00',1.1),('8784','2014-01-29','09:30:00',1.04),('8784','2014-01-29','09:35:00',1.3),('8784','2014-01-29','09:40:00',1.3),('8784','2014-01-29','09:45:00',1.52),('8784','2014-01-29','09:50:00',1.47),('8784','2014-01-29','09:55:00',1.53),('8784','2014-01-29','10:00:00',1.26),('8784','2014-01-29','10:05:00',1.29),('8784','2014-01-29','10:10:00',1.66),('8784','2014-01-29','10:15:00',1.64),('8784','2014-01-29','10:20:00',1.26),('8784','2014-01-29','10:25:00',2.46),('8784','2014-01-29','10:30:00',2.66),('8784','2014-01-29','10:35:00',2.24),('8784','2014-01-29','10:40:00',2.08),('8784','2014-01-29','10:45:00',1.99),('8784','2014-01-29','10:50:00',2.01),('8784','2014-01-29','10:55:00',1.79),('8784','2014-01-29','11:00:00',1.83),('8784','2014-01-29','11:05:00',2.03),('8784','2014-01-29','11:10:00',1.74),('8784','2014-01-29','11:15:00',1.79),('8784','2014-01-29','11:20:00',1.92),('8784','2014-01-29','11:25:00',1.97),('8784','2014-01-29','11:30:00',2.44),('8784','2014-01-29','11:35:00',2.24),('8784','2014-01-29','11:40:00',1.25),('8784','2014-01-29','11:45:00',1.22),('8784','2014-01-29','12:45:00',1.2),('8784','2014-01-29','12:50:00',2.48),('8784','2014-01-29','12:55:00',2.64),('8784','2014-01-29','13:00:00',1.53),('8784','2014-01-29','13:05:00',1.34),('8784','2014-01-29','13:35:00',1.69),('8784','2014-01-29','13:40:00',2.65),('8784','2014-01-29','13:45:00',2.01),('8784','2014-01-29','13:50:00',1.55),('8784','2014-01-29','13:55:00',2.12),('8784','2014-01-29','14:00:00',1.06),('8784','2014-01-29','15:10:00',1.05),('8784','2014-01-29','15:15:00',1.4),('8784','2014-01-29','15:20:00',1.03),('8784','2014-01-28','09:35:00',1.11),('8784','2014-01-28','09:40:00',1),('8784','2014-01-28','09:45:00',1.31),('8784','2014-01-28','09:50:00',1.51),('8784','2014-01-28','09:55:00',1.65),('8784','2014-01-28','10:00:00',1.63),('8784','2014-01-28','10:05:00',1.59),('8784','2014-01-28','10:10:00',1.63),('8784','2014-01-28','10:15:00',1.81),('8784','2014-01-28','10:20:00',1.96),('8784','2014-01-28','10:25:00',2.12),('8784','2014-01-28','10:30:00',2.11),('8784','2014-01-28','10:35:00',2.21),('8784','2014-01-28','10:40:00',2.28),('8784','2014-01-28','10:45:00',2.12),('8784','2014-01-28','10:50:00',2.26),('8784','2014-01-28','10:55:00',1.77),('8784','2014-01-28','11:00:00',2.71),('8784','2014-01-28','11:05:00',1.82),('8784','2014-01-28','11:10:00',1.62),('8784','2014-01-28','11:15:00',1.53),('8784','2014-01-28','11:25:00',1.95),('8784','2014-01-28','11:30:00',1.29),('8784','2014-01-28','11:35:00',1.96),('8784','2014-01-28','11:40:00',3),('8784','2014-01-28','11:45:00',2.4),('8784','2014-01-28','12:00:00',2.61),('8784','2014-01-28','12:05:00',2.71),('8784','2014-01-28','12:10:00',1.86),('8784','2014-01-28','12:15:00',2.44),('8784','2014-01-28','12:20:00',1.49),('8784','2014-01-28','12:25:00',1.18),('8784','2014-01-28','12:30:00',1.19),('8784','2014-01-28','12:35:00',1.52),('8784','2014-01-28','12:40:00',1.64),('8784','2014-01-28','12:45:00',2.22),('8784','2014-01-28','12:50:00',2.53),('8784','2014-01-28','12:55:00',2.84),('8784','2014-01-28','13:00:00',2.86),('8784','2014-01-28','13:05:00',3.01),('8784','2014-01-28','13:10:00',2.18),('8784','2014-01-28','13:15:00',2.41),('8784','2014-01-28','13:20:00',2.2),('8784','2014-01-28','13:25:00',2.52),('8784','2014-01-28','13:30:00',2.54),('8784','2014-01-28','13:35:00',2.65),('8784','2014-01-28','13:40:00',2.52),('8784','2014-01-28','13:45:00',2.39),('8784','2014-01-28','13:50:00',2.27),('8784','2014-01-28','13:55:00',2.23),('8784','2014-01-28','14:00:00',2.2),('8784','2014-01-28','14:05:00',2.14),('8784','2014-01-28','14:10:00',2.1),('8784','2014-01-28','14:15:00',2.08),('8784','2014-01-28','14:20:00',2.03),('8784','2014-01-28','14:25:00',2.04),('8784','2014-01-28','14:30:00',2.02),('8784','2014-01-28','14:35:00',1.86),('8784','2014-01-28','14:40:00',1.77),('8784','2014-01-28','14:45:00',1.74),('8784','2014-01-28','14:50:00',1.62),('8784','2014-01-28','14:55:00',1.57),('8784','2014-01-28','15:00:00',1.54),('8784','2014-01-28','15:05:00',1.46),('8784','2014-01-28','15:10:00',1.36),('8784','2014-01-28','15:15:00',1.28),('8784','2014-01-28','15:20:00',1.23),('8784','2014-01-28','15:25:00',1.17),('8784','2014-01-28','15:30:00',1.1),('8784','2014-01-28','15:35:00',1.02),('8784','2014-01-27','11:05:00',1.09),('8784','2014-01-27','11:20:00',1.11),('8784','2014-01-27','11:25:00',1.12),('8902','2014-05-04','07:40:00',1.16),('8902','2014-05-04','07:45:00',1.55),('8902','2014-05-04','07:50:00',1.72),('8902','2014-05-04','07:55:00',1.88),('8902','2014-05-04','08:00:00',2.07),('8902','2014-05-04','08:05:00',2.26),('8902','2014-05-04','08:10:00',2.45),('8902','2014-05-04','08:15:00',2.66),('8902','2014-05-04','08:20:00',2.84),('8902','2014-05-04','08:25:00',3.04),('8902','2014-05-04','08:30:00',3.24),('8902','2014-05-04','08:35:00',3.44),('8902','2014-05-04','08:40:00',3.64),('8902','2014-05-04','08:45:00',3.82),('8902','2014-05-04','08:50:00',3.98),('8902','2014-05-04','08:55:00',4.13),('8902','2014-05-04','09:00:00',4.26),('8902','2014-05-04','09:05:00',4.42),('8902','2014-05-04','09:10:00',4.58),('8902','2014-05-04','09:15:00',4.76),('8902','2014-05-04','09:20:00',4.9),('8902','2014-05-04','09:25:00',5.08),('8902','2014-05-04','09:30:00',5.25),('8902','2014-05-04','09:35:00',5.42),('8902','2014-05-04','09:40:00',5.61),('8902','2014-05-04','09:45:00',5.75),('8902','2014-05-04','09:50:00',5.93),('8902','2014-05-04','09:55:00',6.07),('8902','2014-05-04','10:00:00',6.2),('8902','2014-05-04','10:05:00',6.32),('8902','2014-05-04','10:10:00',6.45),('8902','2014-05-04','10:15:00',6.52),('8902','2014-05-04','10:20:00',6.57),('8902','2014-05-04','10:25:00',6.73),('8902','2014-05-04','10:30:00',6.83),('8902','2014-05-04','10:35:00',6.97),('8902','2014-05-04','10:40:00',7.02),('8902','2014-05-04','10:45:00',7.07),('8902','2014-05-04','10:50:00',7.2),('8902','2014-05-04','10:55:00',7.3),('8902','2014-05-04','11:00:00',7.39),('8902','2014-05-04','11:05:00',7.47),('8902','2014-05-04','11:10:00',7.56),('8902','2014-05-04','11:15:00',7.69),('8902','2014-05-04','11:20:00',7.71),('8902','2014-05-04','11:25:00',7.76),('8902','2014-05-04','11:30:00',7.76),('8902','2014-05-04','11:35:00',7.85),('8902','2014-05-04','11:40:00',7.99),('8902','2014-05-04','11:45:00',8.08),('8902','2014-05-04','11:50:00',8.16),('8902','2014-05-04','11:55:00',8.34),('8902','2014-05-04','12:00:00',6.24),('8902','2014-05-04','12:05:00',4.09),('8902','2014-05-04','12:10:00',5.11),('8902','2014-05-04','12:15:00',8.16),('8902','2014-05-04','12:20:00',4.47),('8902','2014-05-04','12:25:00',7.26),('8902','2014-05-04','12:30:00',6.46),('8902','2014-05-04','12:35:00',3.87),('8902','2014-05-04','12:40:00',4.81),('8902','2014-05-04','12:45:00',8.48),('8902','2014-05-04','12:50:00',7.15),('8902','2014-05-04','12:55:00',4.37),('8902','2014-05-04','13:00:00',8.2),('8902','2014-05-04','13:05:00',6.7),('8902','2014-05-04','13:10:00',9.07),('8902','2014-05-04','13:15:00',8.86),('8902','2014-05-04','13:20:00',8.6),('8902','2014-05-04','13:25:00',8.51),('8902','2014-05-04','13:30:00',7.9),('8902','2014-05-04','13:35:00',7.76),('8902','2014-05-04','13:40:00',8.63),('8902','2014-05-04','13:45:00',8.62),('8902','2014-05-04','13:50:00',8.65),('8902','2014-05-04','13:55:00',8.59),('8902','2014-05-04','14:00:00',8.67),('8902','2014-05-04','14:05:00',9),('8902','2014-05-04','14:10:00',9.1),('8902','2014-05-04','14:15:00',9.08),('8902','2014-05-04','14:20:00',7.54),('8902','2014-05-04','14:25:00',5.07),('8902','2014-05-04','14:30:00',5.3),('8902','2014-05-04','14:35:00',3.13),('8902','2014-05-04','14:40:00',3.22),('8902','2014-05-04','14:45:00',2.35),('8902','2014-05-04','14:50:00',2.37),('8902','2014-05-04','14:55:00',2.82),('8902','2014-05-04','15:00:00',2.9),('8902','2014-05-04','15:05:00',6.01),('8902','2014-05-04','15:10:00',3.28),('8902','2014-05-04','15:15:00',2.62),('8902','2014-05-04','15:20:00',3.15),('8902','2014-05-04','15:25:00',3.76),('8902','2014-05-04','15:30:00',8.8),('8902','2014-05-04','15:35:00',8.33),('8902','2014-05-04','15:40:00',7.7),('8902','2014-05-04','15:45:00',2.94),('8902','2014-05-04','15:50:00',2.87),('8902','2014-05-04','15:55:00',2.7),('8902','2014-05-04','16:00:00',2.16),('8902','2014-05-04','16:05:00',2.51),('8902','2014-05-04','16:10:00',2.9),('8902','2014-05-04','16:15:00',2.64),('8902','2014-05-04','16:20:00',2.62),('8902','2014-05-04','16:25:00',2.08),('8902','2014-05-04','16:30:00',1.98),('8902','2014-05-04','16:35:00',1.54),('8902','2014-05-04','16:40:00',2.89),('8902','2014-05-04','16:45:00',4.05),('8902','2014-05-04','16:50:00',3.24),('8902','2014-05-04','16:55:00',4.71),('8902','2014-05-04','17:00:00',5.26),('8902','2014-05-04','17:05:00',5.12),('8902','2014-05-04','17:10:00',5.05),('8902','2014-05-04','17:15:00',4.88),('8902','2014-05-04','17:20:00',4.73),('8902','2014-05-04','17:25:00',4.46),('8902','2014-05-04','17:30:00',4.11),('8902','2014-05-04','17:35:00',3.95),('8902','2014-05-04','17:40:00',3.73),('8902','2014-05-04','17:45:00',3.49),('8902','2014-05-04','17:50:00',3.33),('8902','2014-05-04','17:55:00',3.19),('8902','2014-05-04','18:00:00',2.91),('8902','2014-05-04','18:05:00',2.76),('8902','2014-05-04','18:10:00',2.61),('8902','2014-05-04','18:15:00',2.4),('8902','2014-05-04','18:20:00',2.18),('8902','2014-05-04','18:25:00',2),('8902','2014-05-04','18:30:00',1.82),('8902','2014-05-04','18:35:00',1.65),('8902','2014-05-04','18:40:00',1.48),('8902','2014-05-04','18:45:00',1.32),('8902','2014-05-04','18:50:00',1.16),('8902','2014-05-04','18:55:00',1),('8902','2014-04-25','08:00:00',1.05),('8902','2014-04-25','08:05:00',1.14),('8902','2014-04-25','08:10:00',1.24),('8902','2014-04-25','08:15:00',1.25),('8902','2014-04-25','08:20:00',1.32),('8902','2014-04-25','08:25:00',1.37),('8902','2014-04-25','08:30:00',1.28),('8902','2014-04-25','08:35:00',1.42),('8902','2014-04-25','08:40:00',1.56),('8902','2014-04-25','08:45:00',1.72),('8902','2014-04-25','08:50:00',1.77),('8902','2014-04-25','08:55:00',1.63),('8902','2014-04-25','09:00:00',1.72),('8902','2014-04-25','09:05:00',1.86),('8902','2014-04-25','09:10:00',1.59),('8902','2014-04-25','09:15:00',1.46),('8902','2014-04-25','09:20:00',1.52),('8902','2014-04-25','09:25:00',1.52),('8902','2014-04-25','09:30:00',1.58),('8902','2014-04-25','09:35:00',1.77),('8902','2014-04-25','09:40:00',1.84),('8902','2014-04-25','09:45:00',1.61),('8902','2014-04-25','09:50:00',2.12),('8902','2014-04-25','09:55:00',2.77),('8902','2014-04-25','10:00:00',2.66),('8902','2014-04-25','10:05:00',2.48),('8902','2014-04-25','10:10:00',2.45),('8902','2014-04-25','10:15:00',2.56),('8902','2014-04-25','10:20:00',2.75),('8902','2014-04-25','10:25:00',2.98),('8902','2014-04-25','10:30:00',3.47),('8902','2014-04-25','10:35:00',3.69),('8902','2014-04-25','10:40:00',3.76),('8902','2014-04-25','10:45:00',3.96),('8902','2014-04-25','10:50:00',4.94),('8902','2014-04-25','10:55:00',7.04),('8902','2014-04-25','11:00:00',6.91),('8902','2014-04-25','11:05:00',6.67),('8902','2014-04-25','11:10:00',6.04),('8902','2014-04-25','11:15:00',6.32),('8902','2014-04-25','11:20:00',5.68),('8902','2014-04-25','11:25:00',5.67),('8902','2014-04-25','11:30:00',5.51),('8902','2014-04-25','11:35:00',5.89),('8902','2014-04-25','11:40:00',5.62),('8902','2014-04-25','11:45:00',5.97),('8902','2014-04-25','11:50:00',5.94),('8902','2014-04-25','11:55:00',5.51),('8902','2014-04-25','12:00:00',6.03),('8902','2014-04-25','12:05:00',6.45),('8902','2014-04-25','12:10:00',6.45),('8902','2014-04-25','12:15:00',5.48),('8902','2014-04-25','12:20:00',5.74),('8902','2014-04-25','12:25:00',4.14),('8902','2014-04-25','12:30:00',5.34),('8902','2014-04-25','12:35:00',6.6),('8902','2014-04-25','12:40:00',7.04),('8902','2014-04-25','12:45:00',7.37),('8902','2014-04-25','12:50:00',7.49),('8902','2014-04-25','12:55:00',8.48),('8902','2014-04-25','13:00:00',7.59),('8902','2014-04-25','13:05:00',5.66),('8902','2014-04-25','13:10:00',7.11),('8902','2014-04-25','13:15:00',8.26),('8902','2014-04-25','13:20:00',7.81),('8902','2014-04-25','13:25:00',4.88),('8902','2014-04-25','13:30:00',2.57),('8902','2014-04-25','13:35:00',3.82),('8902','2014-04-25','13:40:00',7.37),('8902','2014-04-25','13:45:00',8.47),('8902','2014-04-25','13:50:00',8.42),('8902','2014-04-25','13:55:00',8.67),('8902','2014-04-25','14:00:00',7.76),('8902','2014-04-25','14:05:00',2.24),('8902','2014-04-25','14:10:00',5.73),('8902','2014-04-25','14:15:00',2.99),('8902','2014-04-25','14:20:00',1.05),('8902','2014-04-25','14:25:00',1.6),('8902','2014-04-25','14:30:00',1.64),('8902','2014-04-25','14:35:00',4.75),('8902','2014-04-25','14:40:00',5.56),('8902','2014-04-25','14:45:00',2.07),('8902','2014-04-25','14:50:00',1.05),('8902','2014-04-25','15:00:00',1.04),('8902','2014-04-25','15:15:00',1.91),('8902','2014-04-25','15:20:00',1.49),('8902','2014-04-25','17:35:00',1.02),('8902','2014-04-25','17:40:00',1.43),('8902','2014-04-25','17:45:00',1.78),('8902','2014-04-25','17:50:00',1.8),('8902','2014-04-25','17:55:00',1.66),('8902','2014-04-25','18:00:00',1.03),('8902','2014-04-25','18:30:00',1.15),('8902','2014-04-25','18:35:00',1.39),('8902','2014-04-25','18:40:00',1.69),('8902','2014-04-25','18:45:00',1.68),('8902','2014-04-25','18:50:00',1.35),('8902','2014-01-25','08:45:00',1.11),('8902','2014-01-25','08:50:00',1.12),('8902','2014-01-25','08:55:00',1.21),('8902','2014-01-25','09:00:00',1.71),('8902','2014-01-25','09:05:00',2.69),('8902','2014-01-25','09:10:00',1.55),('8902','2014-01-25','09:15:00',1.16),('8902','2014-01-25','09:20:00',1.07),('8902','2014-01-25','09:25:00',1.67),('8902','2014-01-25','09:30:00',3.17),('8902','2014-01-25','09:35:00',3.59),('8902','2014-01-25','09:40:00',1.62),('8902','2014-01-25','09:45:00',2.69),('8902','2014-01-25','09:50:00',3.06),('8902','2014-01-25','09:55:00',2.13),('8902','2014-01-25','10:00:00',1.58),('8902','2014-01-25','10:05:00',1.68),('8902','2014-01-25','10:10:00',4.1),('8902','2014-01-25','10:15:00',5.49),('8902','2014-01-25','10:20:00',2.48),('8902','2014-01-25','10:25:00',1.98),('8902','2014-01-25','10:30:00',1.81),('8902','2014-01-25','10:35:00',1.57),('8902','2014-01-25','10:40:00',1.33),('8902','2014-01-25','10:45:00',1.45),('8902','2014-01-25','10:50:00',1.53),('8902','2014-01-25','10:55:00',1.77),('8902','2014-01-25','11:00:00',1.58),('8902','2014-01-25','11:05:00',1.6),('8902','2014-01-25','11:10:00',1.39),('8902','2014-01-25','11:15:00',1.39),('8902','2014-01-25','11:20:00',1.38),('8902','2014-01-25','11:25:00',1.91),('8902','2014-01-25','11:30:00',1.64),('8902','2014-01-25','11:35:00',1.44),('8902','2014-01-25','11:40:00',1.45),('8902','2014-01-25','11:45:00',1.3),('8902','2014-01-25','11:50:00',1.1),('8902','2014-01-25','11:55:00',1.12),('8902','2014-01-25','12:00:00',1.11),('8902','2014-01-25','12:05:00',1.2),('8902','2014-01-25','12:10:00',1.53),('8902','2014-01-25','12:15:00',2.08),('8902','2014-01-25','12:20:00',2.32),('8902','2014-01-25','12:25:00',2.51),('8902','2014-01-25','12:30:00',4.83),('8902','2014-01-25','12:35:00',4.82),('8902','2014-01-25','12:40:00',2.55),('8902','2014-01-25','12:45:00',2.14),('8902','2014-01-25','12:50:00',1.88),('8902','2014-01-25','12:55:00',1.75),('8902','2014-01-25','13:00:00',1.88),('8902','2014-01-25','13:05:00',2.16),('8902','2014-01-25','13:10:00',2.41),('8902','2014-01-25','13:15:00',3.24),('8902','2014-01-25','13:20:00',3.28),('8902','2014-01-25','13:25:00',2.41),('8902','2014-01-25','13:30:00',1.78),('8902','2014-01-25','13:35:00',1.47),('8902','2014-01-25','13:40:00',1.28),('8902','2014-01-25','13:45:00',1.23),('8902','2014-01-25','13:50:00',1.68),('8902','2014-01-25','13:55:00',1.23),('8902','2014-01-25','14:05:00',1.03),('8902','2014-01-25','14:10:00',1.25),('8902','2014-01-25','14:15:00',1.25),('8902','2014-01-25','15:25:00',1.53),('8902','2014-01-25','15:45:00',2.87),('8902','2014-01-25','15:50:00',1.6),('8902','2014-01-24','09:00:00',2.15),('8902','2014-01-24','09:05:00',3.44),('8902','2014-01-24','09:10:00',2.1),('8902','2014-01-24','09:15:00',2.33),('8902','2014-01-24','09:20:00',3.22),('8902','2014-01-24','09:25:00',1.27),('8902','2014-01-24','09:40:00',1.35),('8902','2014-01-24','09:45:00',2.22),('8902','2014-01-24','09:50:00',3),('8902','2014-01-24','09:55:00',3.92),('8902','2014-01-24','10:00:00',3.26),('8902','2014-01-24','10:05:00',5.1),('8902','2014-01-24','10:10:00',5.64),('8902','2014-01-24','10:15:00',5.62),('8902','2014-01-24','10:20:00',5.6),('8902','2014-01-24','10:25:00',3.48),('8902','2014-01-24','10:30:00',3.91),('8902','2014-01-24','10:35:00',3.37),('8902','2014-01-24','10:40:00',3.53),('8902','2014-01-24','10:45:00',2.82),('8902','2014-01-24','10:50:00',3.07),('8902','2014-01-24','10:55:00',2.95),('8902','2014-01-24','11:00:00',2.4),('8902','2014-01-24','11:05:00',2.2),('8902','2014-01-24','11:10:00',1.92),('8902','2014-01-24','11:15:00',1.73),('8902','2014-01-24','11:20:00',1.98),('8902','2014-01-24','11:25:00',2.36),('8902','2014-01-24','11:30:00',5.46),('8902','2014-01-24','11:35:00',7.65),('8902','2014-01-24','11:40:00',3.73),('8902','2014-01-24','11:45:00',2.87),('8902','2014-01-24','11:50:00',3.07),('8902','2014-01-24','11:55:00',3.08),('8902','2014-01-24','12:00:00',3.08),('8902','2014-01-24','12:05:00',3.14),('8902','2014-01-24','12:10:00',3.59),('8902','2014-01-24','12:15:00',3.57),('8902','2014-01-24','12:20:00',3.68),('8902','2014-01-24','12:25:00',3.79),('8902','2014-01-24','12:30:00',3.93),('8902','2014-01-24','12:35:00',3.41),('8902','2014-01-24','12:40:00',3.58),('8902','2014-01-24','12:45:00',4.21),('8902','2014-01-24','12:50:00',4.62),('8902','2014-01-24','12:55:00',5.58),('8902','2014-01-24','13:00:00',5.62),('8902','2014-01-24','13:05:00',6.31),('8902','2014-01-24','13:10:00',6.5),('8902','2014-01-24','13:15:00',4.89),('8902','2014-01-24','13:20:00',2.43),('8902','2014-01-24','13:25:00',2.21),('8902','2014-01-24','13:30:00',3.9),('8902','2014-01-24','13:35:00',2.23),('8902','2014-01-24','13:40:00',2.33),('8902','2014-01-24','13:45:00',4.68),('8902','2014-01-24','13:50:00',2.88),('8902','2014-01-24','13:55:00',1.27),('8902','2014-01-24','14:00:00',3.78),('8902','2014-01-24','14:05:00',4.53),('8902','2014-01-24','14:10:00',4.9),('8902','2014-01-24','14:15:00',4.96),('8902','2014-01-24','14:20:00',5.65),('8902','2014-01-24','14:25:00',5.66),('8902','2014-01-24','14:30:00',6.16),('8902','2014-01-24','14:35:00',4.47),('8902','2014-01-24','14:40:00',5.89),('8902','2014-01-24','14:45:00',5.86),('8902','2014-01-24','14:50:00',5.67),('8902','2014-01-24','14:55:00',5.31),('8902','2014-01-24','15:00:00',4.86),('8902','2014-01-24','15:05:00',4.56),('8902','2014-01-24','15:10:00',4.33),('8902','2014-01-24','15:15:00',4.13),('8902','2014-01-24','15:20:00',3.91),('8902','2014-01-24','15:25:00',3.76),('8902','2014-01-24','15:30:00',3.58),('8902','2014-01-24','15:35:00',3.37),('8902','2014-01-24','15:40:00',3.17),('8902','2014-01-24','15:45:00',2.99),('8902','2014-01-24','15:50:00',2.76),('8902','2014-01-24','15:55:00',2.56),('8902','2014-01-24','16:00:00',2.42),('8902','2014-01-24','16:05:00',2.26),('8902','2014-01-24','16:10:00',2.03),('8902','2014-01-24','16:15:00',1.85),('8902','2014-01-24','16:20:00',1.64),('8902','2014-01-24','16:25:00',1.45),('8902','2014-01-24','16:30:00',1.26),('8902','2014-01-24','16:35:00',1.07),('8902','2014-01-23','10:05:00',1.83),('8902','2014-01-23','10:10:00',2.4),('8902','2014-01-23','10:15:00',3.01),('8902','2014-01-23','10:20:00',1.98),('8902','2014-01-23','10:25:00',1.26),('8902','2014-01-23','10:30:00',3.03),('8902','2014-01-23','10:35:00',2.41),('8902','2014-01-23','10:40:00',3.61),('8902','2014-01-23','10:45:00',3.53),('8902','2014-01-23','10:50:00',1.98),('8902','2014-01-23','10:55:00',1.85),('8902','2014-01-23','11:00:00',1.82),('8902','2014-01-23','11:05:00',1.52),('8902','2014-01-23','11:20:00',1.14),('8902','2014-01-23','11:25:00',1.93),('8902','2014-01-23','11:30:00',2.38),('8902','2014-01-23','11:35:00',2.63),('8902','2014-01-23','11:40:00',1.2),('8902','2014-01-23','11:45:00',2.39),('8902','2014-01-23','11:50:00',6.99),('8902','2014-01-23','11:55:00',7.05),('8902','2014-01-23','12:00:00',5.57),('8902','2014-01-23','12:05:00',3.83),('8902','2014-01-23','12:10:00',1.66),('8902','2014-01-23','12:20:00',1.75),('8902','2014-01-23','12:25:00',2.86),('8902','2014-01-23','12:30:00',2.28),('8902','2014-01-23','12:35:00',5.47),('8902','2014-01-23','12:40:00',4.99),('8902','2014-01-23','12:45:00',4.35),('8902','2014-01-23','12:50:00',2.71),('8902','2014-01-23','12:55:00',2.28),('8902','2014-01-23','13:00:00',3.57),('8902','2014-01-23','13:05:00',3.94),('8902','2014-01-23','13:10:00',3.18),('8902','2014-01-23','13:15:00',2.39),('8902','2014-01-23','13:20:00',2),('8902','2014-01-23','13:25:00',1.57),('8902','2014-01-23','13:30:00',3.02),('8902','2014-01-23','13:35:00',3.24),('8902','2014-01-23','13:40:00',3.32),('8902','2014-01-23','13:45:00',3.96),('8902','2014-01-23','13:50:00',5.26),('8902','2014-01-23','13:55:00',4.86),('8902','2014-01-23','14:00:00',5.39),('8902','2014-01-23','14:10:00',6.53),('8902','2014-01-23','14:15:00',5.94),('8902','2014-01-23','14:20:00',5.87),('8902','2014-01-23','14:25:00',5.33),('8902','2014-01-23','14:30:00',1.67),('8902','2014-01-23','14:35:00',1.06),('8902','2014-01-23','14:40:00',1.23),('8902','2014-01-23','14:45:00',1.62),('8902','2014-01-22','10:15:00',1.33),('8902','2014-01-22','10:20:00',1.38),('8902','2014-01-22','10:25:00',1.43),('8902','2014-01-22','10:30:00',1.16),('8902','2014-01-22','10:40:00',1.06),('8902','2014-01-22','10:45:00',1.1),('8902','2014-01-22','10:50:00',1.4),('8902','2014-01-22','10:55:00',1.65),('8902','2014-01-22','11:00:00',1.9),('8902','2014-01-22','11:05:00',1.91),('8902','2014-01-22','11:10:00',2.02),('8902','2014-01-22','11:15:00',2.07),('8902','2014-01-22','11:20:00',1.85),('8902','2014-01-22','11:25:00',1.67),('8902','2014-01-22','11:30:00',1.19),('8902','2014-01-22','12:10:00',1.52),('8902','2014-01-22','12:15:00',1.13),('8902','2014-01-22','12:25:00',1.25),('8902','2014-01-22','12:30:00',1.86),('8902','2014-01-22','12:35:00',1.66),('8902','2014-01-22','12:40:00',1.04),('8902','2014-01-22','14:05:00',1.2),('8902','2014-01-22','14:10:00',1.42),('8902','2014-01-22','14:15:00',1.5),('8902','2014-01-22','14:20:00',1.31),('8902','2014-01-22','14:25:00',1.09),('8902','2014-01-21','10:15:00',1.65),('8902','2014-01-21','10:20:00',1.54),('8902','2014-01-21','10:40:00',1.06),('8902','2014-01-21','10:45:00',1.39),('8902','2014-01-21','10:50:00',1.46),('8902','2014-01-21','10:55:00',1.43),('8902','2014-01-21','11:00:00',1.66),('8902','2014-01-21','11:05:00',1.88),('8902','2014-01-21','11:10:00',1.93),('8902','2014-01-21','11:15:00',1.73),('8902','2014-01-21','11:20:00',1.81),('8902','2014-01-21','11:25:00',1.78),('8902','2014-01-21','11:30:00',1.38),('8902','2014-01-21','11:35:00',1.12),('8902','2014-01-21','11:40:00',1.6),('8902','2014-01-21','11:45:00',1.68),('8902','2014-01-21','11:50:00',1.27),('8902','2014-01-21','11:55:00',1.41),('8902','2014-01-21','12:00:00',1.53),('8902','2014-01-21','12:05:00',1.56),('8902','2014-01-21','12:10:00',1.38),('8902','2014-01-21','12:35:00',1.07),('8902','2014-01-21','12:40:00',1.17),('8902','2014-01-21','12:45:00',1.31),('8902','2014-01-21','12:50:00',1.57),('8902','2014-01-21','12:55:00',1.87),('8902','2014-01-21','13:00:00',1.82),('8902','2014-01-21','13:05:00',1.65),('8902','2014-01-21','13:10:00',1.82),('8902','2014-01-21','13:15:00',2.23),('8902','2014-01-21','13:20:00',2.36),('8902','2014-01-21','13:25:00',1.46),('8902','2014-01-21','13:30:00',1.14),('8902','2014-01-21','13:40:00',1.1),('8902','2014-01-21','13:45:00',1.14),('8902','2014-01-21','13:50:00',1.08),('8902','2014-01-21','13:55:00',1.34),('8902','2014-01-21','14:00:00',1.31),('8902','2014-01-21','14:05:00',1.09),('8902','2014-01-21','14:10:00',1.27),('8902','2014-01-21','14:15:00',1.27),('8902','2014-01-21','14:20:00',1.14),('8902','2014-01-21','14:25:00',1.08),('8902','2014-01-21','14:30:00',1.05),('8902','2014-01-21','14:35:00',1.02),('8902','2014-01-21','15:00:00',1.05),('8902','2014-01-21','15:05:00',1.17),('8902','2014-01-21','15:10:00',1.07),('8902','2014-01-21','16:05:00',1.88),('8902','2014-01-21','16:10:00',2.02),('8902','2014-01-21','16:15:00',1.97),('8902','2014-01-21','16:20:00',1.24),('8902','2014-01-20','09:15:00',1.01),('8902','2014-01-20','09:35:00',1.26),('8902','2014-01-20','09:40:00',1.49),('8902','2014-01-20','09:50:00',1.14),('8902','2014-01-20','09:55:00',1.6),('8902','2014-01-20','10:00:00',2.06),('8902','2014-01-20','10:05:00',2.46),('8902','2014-01-20','10:35:00',1.23),('8902','2014-01-20','10:40:00',1.56),('8902','2014-01-20','10:45:00',1.11),('8902','2014-01-20','10:55:00',3.13),('8902','2014-01-20','11:00:00',4.19),('8902','2014-01-20','11:05:00',2.05),('8902','2014-01-20','11:20:00',1.66),('8902','2014-01-20','11:30:00',1.67),('8902','2014-01-20','11:35:00',1.07),('8902','2014-01-20','11:40:00',1.02),('8902','2014-01-20','11:45:00',1.02),('8902','2014-01-20','11:50:00',1.72),('8902','2014-01-20','11:55:00',2.26),('8902','2014-01-20','12:00:00',1.89),('8902','2014-01-20','12:05:00',2.69),('8902','2014-01-20','12:10:00',4.09),('8902','2014-01-20','12:15:00',2.98),('8902','2014-01-20','12:20:00',2.14),('8902','2014-01-20','12:25:00',2.46),('8902','2014-01-20','12:30:00',3.66),('8902','2014-01-20','12:35:00',2.57),('8902','2014-01-20','12:40:00',2.7),('8902','2014-01-20','12:45:00',2.66),('8902','2014-01-20','12:50:00',3.72),('8902','2014-01-20','12:55:00',2.13),('8902','2014-01-20','13:15:00',1.49),('8902','2014-01-20','13:20:00',2.34),('8902','2014-01-20','13:25:00',1.17),('8902','2014-01-20','13:55:00',1.03),('8902','2014-01-20','14:00:00',1.78),('8902','2014-01-20','14:05:00',2.74),('8902','2014-01-20','14:10:00',2.5),('8902','2014-01-20','14:15:00',2.02),('8902','2014-01-20','14:20:00',1.52),('8902','2014-01-20','14:25:00',1.01),('8902','2014-01-20','15:10:00',1.24),('8902','2014-01-20','15:15:00',1.21),('8902','2014-01-20','15:25:00',1.09),('8902','2014-01-20','15:30:00',1.2),('8902','2014-01-20','15:35:00',1.7),('8902','2014-01-20','15:40:00',2.42),('8902','2014-01-20','15:45:00',1.08),('8902','2014-01-19','10:50:00',1.05),('8902','2014-01-19','11:15:00',1.72),('8902','2014-01-19','11:20:00',3.04),('8902','2014-01-19','11:25:00',3.78),('8902','2014-01-19','11:30:00',3.88),('8902','2014-01-19','11:35:00',3.9),('8902','2014-01-19','11:40:00',6.25),('8902','2014-01-19','11:45:00',6.03),('8902','2014-01-19','11:50:00',3.8),('8902','2014-01-19','11:55:00',1.83),('8902','2014-01-19','12:00:00',1.4),('8902','2014-01-19','12:05:00',1.09),('8902','2014-01-19','12:15:00',1.11),('8902','2014-01-19','12:20:00',1.16),('8902','2014-01-19','12:25:00',2.36),('8902','2014-01-19','12:30:00',2.27),('8902','2014-01-19','12:35:00',1.57),('8902','2014-01-19','13:05:00',1.12),('8902','2014-01-19','13:10:00',1.22),('8902','2014-01-19','13:15:00',1.7),('8902','2014-01-19','13:20:00',7.74),('8902','2014-01-19','13:25:00',7.3),('8902','2014-01-19','13:30:00',6.44),('8902','2014-01-19','13:35:00',6.12),('8902','2014-01-19','13:40:00',5.68),('8902','2014-01-19','13:45:00',5.23),('8902','2014-01-19','13:50:00',2.58),('8902','2014-01-19','13:55:00',2.69),('8902','2014-01-19','14:00:00',5.42),('8902','2014-01-19','14:05:00',4.45),('8902','2014-01-19','14:10:00',2.8),('8902','2014-01-19','14:15:00',2.31),('8902','2014-01-19','14:20:00',2.53),('8902','2014-01-19','14:25:00',1.51),('8902','2014-01-18','10:20:00',1.06),('8902','2014-01-18','11:05:00',1.04),('8902','2014-01-18','11:45:00',1.29),('8902','2014-01-18','11:50:00',1.7),('8902','2014-01-18','11:55:00',1.74),('8902','2014-01-18','12:00:00',1.94),('8902','2014-01-18','12:05:00',2),('8902','2014-01-18','12:10:00',1.93),('8902','2014-01-18','12:15:00',1.61),('8902','2014-01-18','12:20:00',1.76),('8902','2014-01-18','12:25:00',1.75),('8902','2014-01-18','12:30:00',1.06),('8902','2014-01-18','12:55:00',1.09),('8902','2014-01-18','13:00:00',1.4),('8902','2014-01-18','13:05:00',1.9),('8902','2014-01-18','13:10:00',2.11),('8902','2014-01-18','13:15:00',1.85),('8902','2014-01-18','13:20:00',1.47),('8902','2014-01-18','13:25:00',1.3),('8902','2014-01-18','13:30:00',1.26),('8902','2014-01-18','13:35:00',1.18),('8902','2014-01-18','13:40:00',1.06),('8902','2014-01-18','13:45:00',1.04),('8902','2014-01-18','13:50:00',1.1),('8902','2014-01-18','13:55:00',1.42),('8902','2014-01-18','14:00:00',1.25),('8902','2014-01-18','14:05:00',1.03),('8902','2014-01-18','14:15:00',1.32),('8902','2014-01-18','14:20:00',2.53),('8902','2014-01-18','14:25:00',3.42),('8902','2014-01-18','14:30:00',3.8),('8902','2014-01-18','14:35:00',2.22),('8902','2014-01-18','14:40:00',1.85),('8902','2014-01-18','14:45:00',1.55),('8902','2014-01-18','14:50:00',1.02),('8902','2014-01-18','15:40:00',1.29),('8902','2014-01-17','09:10:00',1.05),('8902','2014-01-17','09:15:00',1.02),('8902','2014-01-17','09:25:00',1.06),('8902','2014-01-17','09:30:00',1.28),('8902','2014-01-17','09:35:00',1.59),('8902','2014-01-17','09:40:00',1.7),('8902','2014-01-17','09:45:00',1.75),('8902','2014-01-17','09:50:00',1.62),('8902','2014-01-17','09:55:00',1.82),('8902','2014-01-17','10:00:00',2.35),('8902','2014-01-17','10:05:00',3.22),('8902','2014-01-17','10:10:00',4.92),('8902','2014-01-17','10:15:00',5.14),('8902','2014-01-17','10:20:00',4.76),('8902','2014-01-17','10:25:00',3.17),('8902','2014-01-17','10:30:00',3.43),('8902','2014-01-17','10:35:00',2.2),('8902','2014-01-17','10:40:00',2.1),('8902','2014-01-17','10:45:00',2.42),('8902','2014-01-17','10:50:00',2.49),('8902','2014-01-17','10:55:00',2.34),('8902','2014-01-17','11:00:00',1.67),('8902','2014-01-17','11:05:00',2.52),('8902','2014-01-17','11:10:00',4.31),('8902','2014-01-17','11:15:00',5.77),('8902','2014-01-17','11:20:00',5.62),('8902','2014-01-17','11:25:00',5.32),('8902','2014-01-17','11:30:00',5.41),('8902','2014-01-17','11:35:00',5.51),('8902','2014-01-17','11:40:00',5.04),('8902','2014-01-17','11:45:00',6.33),('8902','2014-01-17','11:50:00',6.8),('8902','2014-01-17','11:55:00',6.76),('8902','2014-01-17','12:00:00',6.42),('8902','2014-01-17','12:05:00',5.06),('8902','2014-01-17','12:10:00',5.99),('8902','2014-01-17','12:15:00',5.73),('8902','2014-01-17','12:20:00',5.68),('8902','2014-01-17','12:25:00',5.85),('8902','2014-01-17','12:30:00',5.89),('8902','2014-01-17','12:35:00',5.9),('8902','2014-01-17','12:40:00',5.97),('8902','2014-01-17','12:45:00',5.93),('8902','2014-01-17','12:50:00',5.7),('8902','2014-01-17','12:55:00',6.28),('8902','2014-01-17','13:00:00',4.13),('8902','2014-01-17','13:05:00',3.85),('8902','2014-01-17','13:10:00',4.91),('8902','2014-01-17','13:15:00',6),('8902','2014-01-17','13:20:00',3.74),('8902','2014-01-17','13:25:00',3.03),('8902','2014-01-17','13:30:00',5.44),('8902','2014-01-17','13:35:00',2.95),('8902','2014-01-17','13:40:00',4.64),('8902','2014-01-17','13:45:00',5.72),('8902','2014-01-17','13:50:00',3.64),('8902','2014-01-17','13:55:00',5.49),('8902','2014-01-17','14:00:00',5.4),('8902','2014-01-17','14:05:00',5.05),('8902','2014-01-17','14:10:00',4.91),('8902','2014-01-17','14:15:00',4.67),('8902','2014-01-17','14:20:00',4.86),('8902','2014-01-17','14:25:00',4.65),('8902','2014-01-17','14:30:00',4.48),('8902','2014-01-17','14:35:00',4.41),('8902','2014-01-17','14:40:00',4.29),('8902','2014-01-17','14:45:00',4.18),('8902','2014-01-17','14:50:00',4.04),('8902','2014-01-17','14:55:00',2.89),('8902','2014-01-17','15:15:00',1.07),('8902','2014-01-17','15:20:00',1.19),('8902','2014-01-17','15:25:00',1.26),('8902','2014-01-17','15:30:00',1.14),('8902','2014-01-17','15:35:00',1.19),('8902','2014-01-17','15:40:00',1),('8902','2014-01-17','15:55:00',1.89),('8902','2014-01-17','16:00:00',1.22),('8902','2014-01-17','16:05:00',1.83),('8902','2014-01-17','16:10:00',1.24),('8902','2014-01-17','16:15:00',1.05),('8902','2014-01-16','08:30:00',1.01),('8902','2014-01-16','08:35:00',1.06),('8902','2014-01-16','08:40:00',1.15),('8902','2014-01-16','08:50:00',1.41),('8902','2014-01-16','08:55:00',1.7),('8902','2014-01-16','09:00:00',2.32),('8902','2014-01-16','09:05:00',2.36),('8902','2014-01-16','09:10:00',2.15),('8902','2014-01-16','09:15:00',1.61),('8902','2014-01-16','09:20:00',2.81),('8902','2014-01-16','09:25:00',3.12),('8902','2014-01-16','09:30:00',3.06),('8902','2014-01-16','09:35:00',3.22),('8902','2014-01-16','09:40:00',3.66),('8902','2014-01-16','09:45:00',3.65),('8902','2014-01-16','09:50:00',1.85),('8902','2014-01-16','10:10:00',1.02),('8902','2014-01-16','11:20:00',1.31),('8902','2014-01-16','11:25:00',2.45),('8902','2014-01-16','11:30:00',4.76),('8902','2014-01-16','11:35:00',3.75),('8902','2014-01-16','11:40:00',2.59),('8902','2014-01-16','11:45:00',1.32),('8902','2014-01-16','11:50:00',1.72),('8902','2014-01-16','11:55:00',2.64),('8902','2014-01-16','12:00:00',2.21),('8902','2014-01-16','12:05:00',3.94),('8902','2014-01-16','12:10:00',3.36),('8902','2014-01-16','12:15:00',1.75),('8902','2014-01-16','12:20:00',1.66),('8902','2014-01-16','12:25:00',1.62),('8902','2014-01-16','12:30:00',1.21),('8902','2014-01-16','12:35:00',1.45),('8902','2014-01-16','12:40:00',2.06),('8902','2014-01-16','12:45:00',2.05),('8902','2014-01-16','12:50:00',1.47),('8902','2014-01-16','12:55:00',1.21),('8902','2014-01-16','13:10:00',1.27),('8902','2014-01-16','13:15:00',1.23),('8902','2014-01-16','13:20:00',1.08),('8902','2014-04-24','07:45:00',1.11),('8902','2014-04-24','07:50:00',1.53),('8902','2014-04-24','07:55:00',2.01),('8902','2014-04-24','08:00:00',1.89),('8902','2014-04-24','08:05:00',1.88),('8902','2014-04-24','08:10:00',2.04),('8902','2014-04-24','08:15:00',2.18),('8902','2014-04-24','08:20:00',2.35),('8902','2014-04-24','08:25:00',2.5),('8902','2014-04-24','08:30:00',2.67),('8902','2014-04-24','08:35:00',2.86),('8902','2014-04-24','08:40:00',3.04),('8902','2014-04-24','08:45:00',3.19),('8902','2014-04-24','08:50:00',3.37),('8902','2014-04-24','08:55:00',3.61),('8902','2014-04-24','09:00:00',4.14),('8902','2014-04-24','09:05:00',4.31),('8902','2014-04-24','09:10:00',4.54),('8902','2014-04-24','09:15:00',4.86),('8902','2014-04-24','09:20:00',5.38),('8902','2014-04-24','09:25:00',5.32),('8902','2014-04-24','09:30:00',5.22),('8902','2014-04-24','09:35:00',3.13),('8902','2014-04-24','09:40:00',2.14),('8902','2014-04-24','09:45:00',2.31),('8902','2014-04-24','09:50:00',2.16),('8902','2014-04-24','09:55:00',2.33),('8902','2014-04-24','10:00:00',2.82),('8902','2014-04-24','10:05:00',2.5),('8902','2014-04-24','10:10:00',2.08),('8902','2014-04-24','10:15:00',2.14),('8902','2014-04-24','10:20:00',2.28),('8902','2014-04-24','10:25:00',2.42),('8902','2014-04-24','10:30:00',2.52),('8902','2014-04-24','10:35:00',2.82),('8902','2014-04-24','10:40:00',4.25),('8902','2014-04-24','10:45:00',6.27),('8902','2014-04-24','10:50:00',7.18),('8902','2014-04-24','10:55:00',6.85),('8902','2014-04-24','11:00:00',6.96),('8902','2014-04-24','11:05:00',6.69),('8902','2014-04-24','11:10:00',6.02),('8902','2014-04-24','11:15:00',5.46),('8902','2014-04-24','11:20:00',6.77),('8902','2014-04-24','11:25:00',2.75),('8902','2014-04-24','11:30:00',2.34),('8902','2014-04-24','11:35:00',3.05),('8902','2014-04-24','11:40:00',3.51),('8902','2014-04-24','11:45:00',3.16),('8902','2014-04-24','11:50:00',2.62),('8902','2014-04-24','11:55:00',2.53),('8902','2014-04-24','12:00:00',3.07),('8902','2014-04-24','12:05:00',4.38),('8902','2014-04-24','12:10:00',3.94),('8902','2014-04-24','12:15:00',2.34),('8902','2014-04-24','12:20:00',4.47),('8902','2014-04-24','12:25:00',7.81),('8902','2014-04-24','12:30:00',8.54),('8902','2014-04-24','12:35:00',8.19),('8902','2014-04-24','12:40:00',8.17),('8902','2014-04-24','12:45:00',8.87),('8902','2014-04-24','12:50:00',8.05),('8902','2014-04-24','12:55:00',2.82),('8902','2014-04-24','13:00:00',2.87),('8902','2014-04-24','13:05:00',5.92),('8902','2014-04-24','13:10:00',2.34),('8902','2014-04-24','13:15:00',6.57),('8902','2014-04-24','13:20:00',2.58),('8902','2014-04-24','13:25:00',3.22),('8902','2014-04-24','13:30:00',2.53),('8902','2014-04-24','13:35:00',2.35),('8902','2014-04-24','13:40:00',2.79),('8902','2014-04-24','13:45:00',3.73),('8902','2014-04-24','13:50:00',2.22),('8902','2014-04-24','13:55:00',2.52),('8902','2014-04-24','14:00:00',2.5),('8902','2014-04-24','14:05:00',3.02),('8902','2014-04-24','14:10:00',2.65),('8902','2014-04-24','14:15:00',2.17),('8902','2014-04-24','14:20:00',7.61),('8902','2014-04-24','14:25:00',9.89),('8902','2014-04-24','14:30:00',8.86),('8902','2014-04-24','14:35:00',8.24),('8902','2014-04-24','14:40:00',7.46),('8902','2014-04-24','14:45:00',8.13),('8902','2014-04-24','14:50:00',7.76),('8902','2014-04-24','14:55:00',7.86),('8902','2014-04-24','15:00:00',7.78),('8902','2014-04-24','15:05:00',7.56),('8902','2014-04-24','15:10:00',7.5),('8902','2014-04-24','15:15:00',7.37),('8902','2014-04-24','15:20:00',7.12),('8902','2014-04-24','15:25:00',7.11),('8902','2014-04-24','15:30:00',6.73),('8902','2014-04-24','15:35:00',7.1),('8902','2014-04-24','15:40:00',6.99),('8902','2014-04-24','15:45:00',6.79),('8902','2014-04-24','15:50:00',6.69),('8902','2014-04-24','15:55:00',6.64),('8902','2014-04-24','16:00:00',6.63),('8902','2014-04-24','16:05:00',6.44),('8902','2014-04-24','16:10:00',6.06),('8902','2014-04-24','16:15:00',5.94),('8902','2014-04-24','16:20:00',5.53),('8902','2014-04-24','16:25:00',5.46),('8902','2014-04-24','16:30:00',5.72),('8902','2014-04-24','16:35:00',5.63),('8902','2014-04-24','16:40:00',5.65),('8902','2014-04-24','16:45:00',5.44),('8902','2014-04-24','16:50:00',5.13),('8902','2014-04-24','16:55:00',4.4),('8902','2014-04-24','17:00:00',3.99),('8902','2014-04-24','17:05:00',4.48),('8902','2014-04-24','17:10:00',3.96),('8902','2014-04-24','17:15:00',4.06),('8902','2014-04-24','17:20:00',3.06),('8902','2014-04-24','17:25:00',2.13),('8902','2014-04-24','17:30:00',2.05),('8902','2014-04-24','17:35:00',2.11),('8902','2014-04-24','17:40:00',2.11),('8902','2014-04-24','17:45:00',1.79),('8902','2014-04-24','17:50:00',1.6),('8902','2014-04-24','17:55:00',1.45),('8902','2014-04-24','18:00:00',1.38),('8902','2014-04-24','18:05:00',1.36),('8902','2014-04-24','18:10:00',1.38),('8902','2014-04-24','18:15:00',1.2),('8902','2014-04-24','18:20:00',1.13),('8902','2014-04-24','18:25:00',1.15),('8902','2014-04-24','18:30:00',1.07),('8902','2014-04-24','18:35:00',1.04),('8902','2014-01-15','08:20:00',1.1),('8902','2014-01-15','08:25:00',1.22),('8902','2014-01-15','08:30:00',1.22),('8902','2014-01-15','08:35:00',1.33),('8902','2014-01-15','08:40:00',1.39),('8902','2014-01-15','08:45:00',1.34),('8902','2014-01-15','08:50:00',1.45),('8902','2014-01-15','08:55:00',1.45),('8902','2014-01-15','09:00:00',1.7),('8902','2014-01-15','09:05:00',1.74),('8902','2014-01-15','09:10:00',2.06),('8902','2014-01-15','09:15:00',2.06),('8902','2014-01-15','09:20:00',2.9),('8902','2014-01-15','09:25:00',3.43),('8902','2014-01-15','09:30:00',3.65),('8902','2014-01-15','09:35:00',3.71),('8902','2014-01-15','09:40:00',3.97),('8902','2014-01-15','09:45:00',3.61),('8902','2014-01-15','09:50:00',2.72),('8902','2014-01-15','09:55:00',2.13),('8902','2014-01-15','10:00:00',1.83),('8902','2014-01-15','10:05:00',1.91),('8902','2014-01-15','10:10:00',2.14),('8902','2014-01-15','10:15:00',2.4),('8902','2014-01-15','10:20:00',2.58),('8902','2014-01-15','10:25:00',2.75),('8902','2014-01-15','10:30:00',3.83),('8902','2014-01-15','10:35:00',5.06),('8902','2014-01-15','10:40:00',5.06),('8902','2014-01-15','10:45:00',3.58),('8902','2014-01-15','10:50:00',3.79),('8902','2014-01-15','10:55:00',4.29),('8902','2014-01-15','11:00:00',4.28),('8902','2014-01-15','11:05:00',4.32),('8902','2014-01-15','11:10:00',4.44),('8902','2014-01-15','11:15:00',4.57),('8902','2014-01-15','11:20:00',4.08),('8902','2014-01-15','11:25:00',4.17),('8902','2014-01-15','11:30:00',3.72),('8902','2014-01-15','11:35:00',3.64),('8902','2014-01-15','11:40:00',3.48),('8902','2014-01-15','11:45:00',3.43),('8902','2014-01-15','11:50:00',3.54),('8902','2014-01-15','11:55:00',3.08),('8902','2014-01-15','12:00:00',3.4),('8902','2014-01-15','12:05:00',2.75),('8902','2014-01-15','12:10:00',3.6),('8902','2014-01-15','12:15:00',2.9),('8902','2014-01-15','12:20:00',2.86),('8902','2014-01-15','12:25:00',2.94),('8902','2014-01-15','12:30:00',2.97),('8902','2014-01-15','12:35:00',3.65),('8902','2014-01-15','12:40:00',3.88),('8902','2014-01-15','12:45:00',4.02),('8902','2014-01-15','12:50:00',4.35),('8902','2014-01-15','12:55:00',4.56),('8902','2014-01-15','13:00:00',4.58),('8902','2014-01-15','13:05:00',4.93),('8902','2014-01-15','13:10:00',4.63),('8902','2014-01-15','13:15:00',4.52),('8902','2014-01-15','13:20:00',3.33),('8902','2014-01-15','13:25:00',4.68),('8902','2014-01-15','13:30:00',4.76),('8902','2014-01-15','13:35:00',4.51),('8902','2014-01-15','13:40:00',3.32),('8902','2014-01-15','13:45:00',2.82),('8902','2014-01-15','13:50:00',4.06),('8902','2014-01-15','13:55:00',3.56),('8902','2014-01-15','14:00:00',2.25),('8902','2014-01-15','14:05:00',2.08),('8902','2014-01-15','14:10:00',2.04),('8902','2014-01-15','14:15:00',1.73),('8902','2014-01-15','14:20:00',1.44),('8902','2014-01-15','14:25:00',1.68),('8902','2014-01-15','14:30:00',1.9),('8902','2014-01-15','14:35:00',1.79),('8902','2014-01-15','14:40:00',1.53),('8902','2014-01-15','14:45:00',1.43),('8902','2014-01-15','14:50:00',1.56),('8902','2014-01-15','14:55:00',1.79),('8902','2014-01-15','15:00:00',1.69),('8902','2014-01-15','15:05:00',1.99),('8902','2014-01-15','15:10:00',2.04),('8902','2014-01-15','15:15:00',1.36),('8902','2014-01-14','08:55:00',1.05),('8902','2014-01-14','09:00:00',1.08),('8902','2014-01-14','09:05:00',1.02),('8902','2014-01-14','09:35:00',1.01),('8902','2014-01-14','09:40:00',1.15),('8902','2014-01-14','09:45:00',1.18),('8902','2014-01-14','09:50:00',1.07),('8902','2014-01-14','09:55:00',1.17),('8902','2014-01-14','10:00:00',1.66),('8902','2014-01-14','10:05:00',1.63),('8902','2014-01-14','10:10:00',1.87),('8902','2014-01-14','10:15:00',2.89),('8902','2014-01-14','10:20:00',3.91),('8902','2014-01-14','10:25:00',4.38),('8902','2014-01-14','10:30:00',4.53),('8902','2014-01-14','10:35:00',2.68),('8902','2014-01-14','10:40:00',2.94),('8902','2014-01-14','10:45:00',4.08),('8902','2014-01-14','10:50:00',3.26),('8902','2014-01-14','10:55:00',2.87),('8902','2014-01-14','11:00:00',2.38),('8902','2014-01-14','11:05:00',2.84),('8902','2014-01-14','11:10:00',6.26),('8902','2014-01-14','11:15:00',5.15),('8902','2014-01-14','11:20:00',5.17),('8902','2014-01-14','11:25:00',5.14),('8902','2014-01-14','11:30:00',4.83),('8902','2014-01-14','11:35:00',5.96),('8902','2014-01-14','11:40:00',4.55),('8902','2014-01-14','11:45:00',4.75),('8902','2014-01-14','11:50:00',5.26),('8902','2014-01-14','11:55:00',4.25),('8902','2014-01-14','12:00:00',3.45),('8902','2014-01-14','12:05:00',3.38),('8902','2014-01-14','12:10:00',3.49),('8902','2014-01-14','12:15:00',4.4),('8902','2014-01-14','12:20:00',5.62),('8902','2014-01-14','12:25:00',5.02),('8902','2014-01-14','12:30:00',3.04),('8902','2014-01-14','12:35:00',3.2),('8902','2014-01-14','12:40:00',3.09),('8902','2014-01-14','12:45:00',2.74),('8902','2014-01-14','12:50:00',3.52),('8902','2014-01-14','12:55:00',3.29),('8902','2014-01-14','13:00:00',2.85),('8902','2014-01-14','13:05:00',3.15),('8902','2014-01-14','13:10:00',3.56),('8902','2014-01-14','13:15:00',5.95),('8902','2014-01-14','13:20:00',6.23),('8902','2014-01-14','13:25:00',6.24),('8902','2014-01-14','13:30:00',6.02),('8902','2014-01-14','13:35:00',5.83),('8902','2014-01-14','13:40:00',5.56),('8902','2014-01-14','13:45:00',5.42),('8902','2014-01-14','13:50:00',4.01),('8902','2014-01-14','14:00:00',2.5),('8902','2014-01-14','14:05:00',2.38),('8902','2014-01-14','14:10:00',4.94),('8902','2014-01-14','14:15:00',4.76),('8902','2014-01-14','14:20:00',4.61),('8902','2014-01-14','14:25:00',4.6),('8902','2014-01-14','14:30:00',4.53),('8902','2014-01-14','14:35:00',4.43),('8902','2014-01-14','14:40:00',4.44),('8902','2014-01-14','14:45:00',4.47),('8902','2014-01-14','14:50:00',4.41),('8902','2014-01-14','14:55:00',4.32),('8902','2014-01-14','15:00:00',4.26),('8902','2014-01-14','15:05:00',4.04),('8902','2014-01-14','15:10:00',3.9),('8902','2014-01-14','15:15:00',3.67),('8902','2014-01-14','15:20:00',3.38),('8902','2014-01-14','15:25:00',1.91),('8902','2014-01-14','15:30:00',2.06),('8902','2014-01-14','15:35:00',2.66),('8902','2014-01-14','15:40:00',2.67),('8902','2014-01-14','15:45:00',2.49),('8902','2014-01-14','15:50:00',2.09),('8902','2014-01-14','16:15:00',1.08),('8902','2014-01-13','10:15:00',1.07),('8902','2014-01-13','10:20:00',1.51),('8902','2014-01-13','10:25:00',2.51),('8902','2014-01-13','10:30:00',5.69),('8902','2014-01-13','10:35:00',6.13),('8902','2014-01-13','10:40:00',5.3),('8902','2014-01-13','10:45:00',4.96),('8902','2014-01-13','10:50:00',3.13),('8902','2014-01-13','10:55:00',2.31),('8902','2014-01-13','11:00:00',2.57),('8902','2014-01-13','11:05:00',2.08),('8902','2014-01-13','11:10:00',1.52),('8902','2014-01-13','11:15:00',1.64),('8902','2014-01-13','11:20:00',1.64),('8902','2014-01-13','11:25:00',1.47),('8902','2014-01-13','11:30:00',2.04),('8902','2014-01-13','11:35:00',2.4),('8902','2014-01-13','11:40:00',3.3),('8902','2014-01-13','11:45:00',1.79),('8902','2014-01-13','11:50:00',1.6),('8902','2014-01-13','11:55:00',1.54),('8902','2014-01-13','12:00:00',1.35),('8902','2014-01-12','08:55:00',1.08),('8902','2014-01-12','09:00:00',1.31),('8902','2014-01-12','09:05:00',1.19),('8902','2014-01-12','09:10:00',1.54),('8902','2014-01-12','09:15:00',1.98),('8902','2014-01-12','09:20:00',2.82),('8902','2014-01-12','09:25:00',2.89),('8902','2014-01-12','09:30:00',3),('8902','2014-01-12','09:35:00',3.15),('8902','2014-01-12','09:40:00',3.29),('8902','2014-01-12','09:45:00',3.4),('8902','2014-01-12','09:50:00',3.5),('8902','2014-01-12','09:55:00',3.62),('8902','2014-01-12','10:00:00',3.73),('8902','2014-01-12','10:05:00',3.81),('8902','2014-01-12','10:10:00',3.92),('8902','2014-01-12','10:15:00',3.99),('8902','2014-01-12','10:20:00',4.17),('8902','2014-01-12','10:25:00',4.26),('8902','2014-01-12','10:30:00',4.36),('8902','2014-01-12','10:35:00',4.41),('8902','2014-01-12','10:40:00',4.51),('8902','2014-01-12','10:45:00',4.61),('8902','2014-01-12','10:50:00',4.7),('8902','2014-01-12','10:55:00',4.81),('8902','2014-01-12','11:00:00',4.85),('8902','2014-01-12','11:05:00',4.88),('8902','2014-01-12','11:10:00',4.98),('8902','2014-01-12','11:15:00',5.06),('8902','2014-01-12','11:20:00',5.12),('8902','2014-01-12','11:25:00',5.17),('8902','2014-01-12','11:30:00',5.16),('8902','2014-01-12','11:35:00',5.19),('8902','2014-01-12','11:40:00',5.23),('8902','2014-01-12','11:45:00',5.24),('8902','2014-01-12','11:50:00',5.23),('8902','2014-01-12','11:55:00',5.28),('8902','2014-01-12','12:00:00',5.18),('8902','2014-01-12','12:05:00',5.11),('8902','2014-01-12','12:10:00',5.14),('8902','2014-01-12','12:15:00',5.28),('8902','2014-01-12','12:20:00',5.27),('8902','2014-01-12','12:25:00',5.27),('8902','2014-01-12','12:30:00',5.23),('8902','2014-01-12','12:35:00',5.19),('8902','2014-01-12','12:40:00',5.17),('8902','2014-01-12','12:45:00',5.18),('8902','2014-01-12','12:50:00',5.03),('8902','2014-01-12','12:55:00',4.81),('8902','2014-01-12','13:00:00',4.96),('8902','2014-01-12','13:05:00',4.93),('8902','2014-01-12','13:10:00',4.92),('8902','2014-01-12','13:15:00',4.82),('8902','2014-01-12','13:20:00',4.84),('8902','2014-01-12','13:25:00',4.66),('8902','2014-01-12','13:30:00',4.68),('8902','2014-01-12','13:35:00',4.78),('8902','2014-01-12','13:40:00',4.44),('8902','2014-01-12','13:45:00',4.37),('8902','2014-01-12','13:50:00',4.36),('8902','2014-01-12','13:55:00',4.35),('8902','2014-01-12','14:00:00',4.36),('8902','2014-01-12','14:05:00',4.35),('8902','2014-01-12','14:10:00',4.1),('8902','2014-01-12','14:15:00',4.11),('8902','2014-01-12','14:20:00',4.11),('8902','2014-01-12','14:25:00',4.01),('8902','2014-01-12','14:30:00',3.89),('8902','2014-01-12','14:35:00',3.81),('8902','2014-01-12','14:40:00',3.78),('8902','2014-01-12','14:45:00',3.68),('8902','2014-01-12','14:50:00',3.51),('8902','2014-01-12','14:55:00',3.34),('8902','2014-01-12','15:00:00',3.23),('8902','2014-01-12','15:05:00',3.15),('8902','2014-01-12','15:10:00',2.99),('8902','2014-01-12','15:15:00',2.83),('8902','2014-01-12','15:20:00',2.69),('8902','2014-01-12','15:25:00',2.54),('8902','2014-01-12','15:30:00',2.36),('8902','2014-01-12','15:35:00',2.18),('8902','2014-01-12','15:40:00',2.02),('8902','2014-01-12','15:45:00',1.83),('8902','2014-01-12','15:50:00',1.67),('8902','2014-01-12','15:55:00',1.49),('8902','2014-01-12','16:00:00',1.33),('8902','2014-01-12','16:05:00',1.16),('8902','2014-01-12','16:10:00',1.01),('8902','2014-01-11','09:20:00',1.09),('8902','2014-01-11','09:25:00',1.23),('8902','2014-01-11','09:30:00',1.32),('8902','2014-01-11','09:35:00',1.3),('8902','2014-01-11','09:40:00',1.53),('8902','2014-01-11','09:45:00',1.7),('8902','2014-01-11','09:50:00',1.92),('8902','2014-01-11','09:55:00',1.9),('8902','2014-01-11','10:00:00',1.81),('8902','2014-01-11','10:05:00',1.68),('8902','2014-01-11','10:10:00',1.68),('8902','2014-01-11','10:15:00',1.79),('8902','2014-01-11','10:20:00',2.03),('8902','2014-01-11','10:25:00',2.07),('8902','2014-01-11','10:30:00',2.02),('8902','2014-01-11','10:35:00',2.24),('8902','2014-01-11','10:40:00',2.65),('8902','2014-01-11','10:45:00',2.62),('8902','2014-01-11','10:50:00',2.76),('8902','2014-01-11','10:55:00',2.94),('8902','2014-01-11','11:00:00',3.02),('8902','2014-01-11','11:05:00',2.92),('8902','2014-01-11','11:10:00',3.68),('8902','2014-01-11','11:15:00',3.27),('8902','2014-01-11','11:20:00',3.04),('8902','2014-01-11','11:25:00',2.89),('8902','2014-01-11','11:30:00',3.18),('8902','2014-01-11','11:35:00',2.65),('8902','2014-01-11','11:40:00',3.28),('8902','2014-01-11','11:45:00',3.45),('8902','2014-01-11','11:50:00',3.75),('8902','2014-01-11','11:55:00',3.79),('8902','2014-01-11','12:00:00',2.8),('8902','2014-01-11','12:05:00',2.76),('8902','2014-01-11','12:10:00',2.5),('8902','2014-01-11','12:15:00',2.26),('8902','2014-01-11','12:20:00',2.29),('8902','2014-01-11','12:25:00',2.2),('8902','2014-01-11','12:30:00',2.32),('8902','2014-01-11','12:35:00',2.42),('8902','2014-01-11','12:40:00',2.64),('8902','2014-01-11','12:45:00',2.49),('8902','2014-01-11','12:50:00',2.58),('8902','2014-01-11','12:55:00',2.5),('8902','2014-01-11','13:00:00',2.54),('8902','2014-01-11','13:05:00',2.3),('8902','2014-01-11','13:10:00',2.19),('8902','2014-01-11','13:15:00',2.25),('8902','2014-01-11','13:20:00',2.33),('8902','2014-01-11','13:25:00',2.31),('8902','2014-01-11','13:30:00',2.88),('8902','2014-01-11','13:35:00',2.51),('8902','2014-01-11','13:40:00',2.32),('8902','2014-01-11','13:45:00',2),('8902','2014-01-11','13:50:00',1.82),('8902','2014-01-11','13:55:00',1.62),('8902','2014-01-11','14:00:00',1.56),('8902','2014-01-11','14:05:00',1.49),('8902','2014-01-11','14:10:00',1.38),('8902','2014-01-11','14:15:00',1.25),('8902','2014-01-11','14:20:00',1.13),('8902','2014-01-11','14:25:00',1.06),('8902','2014-01-10','08:55:00',1.01),('8902','2014-01-10','09:10:00',1.09),('8902','2014-01-10','09:15:00',1.18),('8902','2014-01-10','09:20:00',1.4),('8902','2014-01-10','09:25:00',1.75),('8902','2014-01-10','09:30:00',1.32),('8902','2014-01-10','09:35:00',1.13),('8902','2014-01-10','09:40:00',1.11),('8902','2014-01-10','09:45:00',1.26),('8902','2014-01-10','09:50:00',1.97),('8902','2014-01-10','09:55:00',2.87),('8902','2014-01-10','10:00:00',3.36),('8902','2014-01-10','10:05:00',2.62),('8902','2014-01-10','10:10:00',2.54),('8902','2014-01-10','10:15:00',2.88),('8902','2014-01-10','10:20:00',2.84),('8902','2014-01-10','10:25:00',3.58),('8902','2014-01-10','10:30:00',3.47),('8902','2014-01-10','10:35:00',3.66),('8902','2014-01-10','10:40:00',4.55),('8902','2014-01-10','10:45:00',4.85),('8902','2014-01-10','10:50:00',4.92),('8902','2014-01-10','10:55:00',4.94),('8902','2014-01-10','11:00:00',4.84),('8902','2014-01-10','11:05:00',4.61),('8902','2014-01-10','11:10:00',4.95),('8902','2014-01-10','11:15:00',4.58),('8902','2014-01-10','11:20:00',4.16),('8902','2014-01-10','11:25:00',4.22),('8902','2014-01-10','11:30:00',4.22),('8902','2014-01-10','11:35:00',3.77),('8902','2014-01-10','11:40:00',3.45),('8902','2014-01-10','11:45:00',3.51),('8902','2014-01-10','11:50:00',3.8),('8902','2014-01-10','11:55:00',3.87),('8902','2014-01-10','12:00:00',3.92),('8902','2014-01-10','12:05:00',4.55),('8902','2014-01-10','12:10:00',4.17),('8902','2014-01-10','12:15:00',4.2),('8902','2014-01-10','12:20:00',3.92),('8902','2014-01-10','12:25:00',3.78),('8902','2014-01-10','12:30:00',3.46),('8902','2014-01-10','12:35:00',3.03),('8902','2014-01-10','12:40:00',2.9),('8902','2014-01-10','12:45:00',3.23),('8902','2014-01-10','12:50:00',3.57),('8902','2014-01-10','12:55:00',4.46),('8902','2014-01-10','13:00:00',4.2),('8902','2014-01-10','13:05:00',4.06),('8902','2014-01-10','13:10:00',4.19),('8902','2014-01-10','13:15:00',4.72),('8902','2014-01-10','13:20:00',4.03),('8902','2014-01-10','13:25:00',3.22),('8902','2014-01-10','13:30:00',2.78),('8902','2014-01-10','13:35:00',2.7),('8902','2014-01-10','13:40:00',2.43),('8902','2014-01-10','13:45:00',2.66),('8902','2014-01-10','13:50:00',1.93),('8902','2014-01-10','13:55:00',2.05),('8902','2014-01-10','14:00:00',2.99),('8902','2014-01-10','14:05:00',3.17),('8902','2014-01-10','14:10:00',2.91),('8902','2014-01-10','14:15:00',1.73),('8902','2014-01-10','14:20:00',1.24),('8902','2014-01-10','14:25:00',1.08),('8902','2014-01-10','14:30:00',1.16),('8902','2014-01-10','14:35:00',1.34),('8902','2014-01-10','14:40:00',1.57),('8902','2014-01-10','14:45:00',1.64),('8902','2014-01-10','14:50:00',1.49),('8902','2014-01-10','14:55:00',1.26),('8902','2014-01-10','15:00:00',1.22),('8902','2014-01-10','15:05:00',1.14),('8902','2014-01-10','15:10:00',1.09),('8902','2014-01-10','15:15:00',1.09),('8902','2014-01-10','15:20:00',1.04),('8902','2014-01-09','09:35:00',1.04),('8902','2014-01-09','09:40:00',1.04),('8902','2014-01-09','09:50:00',1.01),('8902','2014-01-09','09:55:00',1.04),('8902','2014-01-09','10:00:00',1.06),('8902','2014-01-09','10:05:00',1.02),('8902','2014-01-09','10:10:00',1.03),('8902','2014-01-09','10:15:00',1.08),('8902','2014-01-09','10:20:00',1.11),('8902','2014-01-09','10:25:00',1.18),('8902','2014-01-09','10:30:00',1.15),('8902','2014-01-09','10:35:00',1.11),('8902','2014-01-09','10:40:00',1.05),('8902','2014-01-09','10:45:00',1.1),('8902','2014-01-09','10:50:00',1.18),('8902','2014-01-09','10:55:00',1.18),('8902','2014-01-09','11:00:00',1.22),('8902','2014-01-09','11:05:00',1.34),('8902','2014-01-09','11:10:00',1.35),('8902','2014-01-09','11:15:00',1.15),('8902','2014-01-09','11:20:00',1.05),('8902','2014-01-09','11:25:00',1.14),('8902','2014-01-09','11:30:00',1.29),('8902','2014-01-09','11:35:00',1.46),('8902','2014-01-09','11:40:00',1.5),('8902','2014-01-09','11:45:00',1.37),('8902','2014-01-09','11:50:00',1.44),('8902','2014-01-09','11:55:00',1.54),('8902','2014-01-09','12:00:00',1.2),('8902','2014-01-09','12:10:00',1.02),('8902','2014-01-09','12:15:00',1.18),('8902','2014-01-09','12:20:00',1.37),('8902','2014-01-09','12:25:00',1.4),('8902','2014-01-09','12:30:00',1.53),('8902','2014-01-09','12:35:00',1.46),('8902','2014-01-09','12:40:00',1.39),('8902','2014-01-09','12:45:00',1.45),('8902','2014-01-09','12:50:00',1.7),('8902','2014-01-09','12:55:00',1.69),('8902','2014-01-09','13:00:00',1.74),('8902','2014-01-09','13:05:00',1.79),('8902','2014-01-09','13:10:00',1.66),('8902','2014-01-09','13:15:00',1.42),('8902','2014-01-09','13:20:00',1.3),('8902','2014-01-09','13:25:00',1.28),('8902','2014-01-09','13:30:00',1.37),('8902','2014-01-09','13:35:00',1.37),('8902','2014-01-09','13:40:00',1.44),('8902','2014-01-09','13:45:00',1.31),('8902','2014-01-09','13:50:00',1.35),('8902','2014-01-09','13:55:00',1.26),('8902','2014-01-09','14:00:00',1.07),('8902','2014-01-09','14:05:00',1.04),('8902','2014-01-08','08:55:00',1.05),('8902','2014-01-08','09:00:00',1.18),('8902','2014-01-08','09:05:00',1.23),('8902','2014-01-08','09:10:00',1.87),('8902','2014-01-08','09:15:00',2.36),('8902','2014-01-08','09:20:00',2.28),('8902','2014-01-08','09:25:00',2.25),('8902','2014-01-08','09:30:00',2.76),('8902','2014-01-08','09:35:00',3.3),('8902','2014-01-08','09:40:00',3.32),('8902','2014-01-08','09:45:00',3.47),('8902','2014-01-08','09:50:00',3.53),('8902','2014-01-08','09:55:00',3.71),('8902','2014-01-08','10:00:00',3.75),('8902','2014-01-08','10:05:00',3.8),('8902','2014-01-08','10:10:00',2.89),('8902','2014-01-08','10:15:00',3.38),('8902','2014-01-08','10:20:00',3.44),('8902','2014-01-08','10:25:00',3.59),('8902','2014-01-08','10:30:00',3.7),('8902','2014-01-08','10:35:00',3.72),('8902','2014-01-08','10:40:00',3.7),('8902','2014-01-08','10:45:00',3.92),('8902','2014-01-08','10:50:00',4.14),('8902','2014-01-08','10:55:00',3.44),('8902','2014-01-08','11:00:00',2.15),('8902','2014-01-08','11:05:00',1.92),('8902','2014-01-08','11:10:00',2.17),('8902','2014-01-08','11:15:00',2.1),('8902','2014-01-08','11:20:00',2.25),('8902','2014-01-08','11:25:00',2.37),('8902','2014-01-08','11:30:00',2.25),('8902','2014-01-08','11:35:00',2.06),('8902','2014-01-08','11:40:00',2.52),('8902','2014-01-08','11:45:00',2.71),('8902','2014-01-08','11:50:00',2.31),('8902','2014-01-08','11:55:00',2.17),('8902','2014-01-08','12:00:00',1.79),('8902','2014-01-08','12:05:00',1.75),('8902','2014-01-08','12:10:00',1.53),('8902','2014-01-08','12:15:00',1.95),('8902','2014-01-08','12:20:00',1.62),('8902','2014-01-08','12:25:00',1.63),('8902','2014-01-08','12:30:00',1.63),('8902','2014-01-08','12:35:00',1.67),('8902','2014-01-08','12:40:00',1.7),('8902','2014-01-08','12:45:00',1.95),('8902','2014-01-08','12:50:00',1.83),('8902','2014-01-08','12:55:00',1.63),('8902','2014-01-08','13:00:00',1.45),('8902','2014-01-08','13:05:00',1.48),('8902','2014-01-08','13:10:00',1.56),('8902','2014-01-08','13:15:00',2.02),('8902','2014-01-08','13:20:00',1.94),('8902','2014-01-08','13:25:00',1.81),('8902','2014-01-08','13:30:00',1.85),('8902','2014-01-08','13:35:00',1.71),('8902','2014-01-08','13:40:00',1.51),('8902','2014-01-08','13:45:00',1.4),('8902','2014-01-08','13:50:00',1.45),('8902','2014-01-08','13:55:00',1.44),('8902','2014-01-08','14:00:00',1.3),('8902','2014-01-08','14:05:00',1.22),('8902','2014-01-08','14:10:00',1.24),('8902','2014-01-08','14:15:00',1.32),('8902','2014-01-08','14:20:00',1.23),('8902','2014-01-08','14:25:00',1.15),('8902','2014-01-08','14:30:00',1.1),('8902','2014-01-08','14:35:00',1.16),('8902','2014-01-08','14:40:00',1.11),('8902','2014-01-08','14:45:00',1.11),('8902','2014-01-08','14:50:00',1.03),('8902','2014-01-07','08:35:00',1.11),('8902','2014-01-07','08:40:00',1.22),('8902','2014-01-07','08:45:00',1.23),('8902','2014-01-07','08:50:00',1.32),('8902','2014-01-07','08:55:00',1.79),('8902','2014-01-07','09:00:00',2.02),('8902','2014-01-07','09:05:00',2.14),('8902','2014-01-07','09:10:00',2.32),('8902','2014-01-07','09:15:00',2.48),('8902','2014-01-07','09:20:00',2.62),('8902','2014-01-07','09:25:00',2.79),('8902','2014-01-07','09:30:00',2.83),('8902','2014-01-07','09:35:00',2.93),('8902','2014-01-07','09:40:00',3.19),('8902','2014-01-07','09:45:00',3.36),('8902','2014-01-07','09:50:00',3.41),('8902','2014-01-07','09:55:00',3.58),('8902','2014-01-07','10:00:00',3.62),('8902','2014-01-07','10:05:00',3.62),('8902','2014-01-07','10:10:00',3.79),('8902','2014-01-07','10:15:00',3.96),('8902','2014-01-07','10:20:00',4.16),('8902','2014-01-07','10:25:00',4.14),('8902','2014-01-07','10:30:00',4.33),('8902','2014-01-07','10:35:00',4.27),('8902','2014-01-07','10:40:00',4.16),('8902','2014-01-07','10:45:00',4.54),('8902','2014-01-07','10:50:00',4.72),('8902','2014-01-07','10:55:00',4.84),('8902','2014-01-07','11:00:00',4.93),('8902','2014-01-07','11:05:00',4.98),('8902','2014-01-07','11:10:00',5.05),('8902','2014-01-07','11:15:00',5.11),('8902','2014-01-07','11:20:00',5.17),('8902','2014-01-07','11:25:00',5.15),('8902','2014-01-07','11:30:00',5.12),('8902','2014-01-07','11:35:00',5.34),('8902','2014-01-07','11:40:00',5.43),('8902','2014-01-07','11:45:00',5.38),('8902','2014-01-07','11:50:00',5.34),('8902','2014-01-07','11:55:00',5.35),('8902','2014-01-07','12:00:00',5.29),('8902','2014-01-07','12:05:00',5.21),('8902','2014-01-07','12:10:00',5.27),('8902','2014-01-07','12:15:00',5.38),('8902','2014-01-07','12:20:00',5.39),('8902','2014-01-07','12:25:00',5.4),('8902','2014-01-07','12:30:00',5.41),('8902','2014-01-07','12:35:00',5.23),('8902','2014-01-07','12:40:00',5.19),('8902','2014-01-07','12:45:00',5.08),('8902','2014-01-07','12:50:00',4.98),('8902','2014-01-07','12:55:00',5.05),('8902','2014-01-07','13:00:00',5.02),('8902','2014-01-07','13:05:00',4.98),('8902','2014-01-07','13:10:00',5),('8902','2014-01-07','13:15:00',4.98),('8902','2014-01-07','13:20:00',4.94),('8902','2014-01-07','13:25:00',4.82),('8902','2014-01-07','13:30:00',4.75),('8902','2014-01-07','13:35:00',4.64),('8902','2014-01-07','13:40:00',4.6),('8902','2014-01-07','13:45:00',4.52),('8902','2014-01-07','13:50:00',4.46),('8902','2014-01-07','13:55:00',4.35),('8902','2014-01-07','14:00:00',4.29),('8902','2014-01-07','14:05:00',4.27),('8902','2014-01-07','14:10:00',4.21),('8902','2014-01-07','14:15:00',4.16),('8902','2014-01-07','14:20:00',4.15),('8902','2014-01-07','14:25:00',4.08),('8902','2014-01-07','14:30:00',4.13),('8902','2014-01-07','14:35:00',4.03),('8902','2014-01-07','14:40:00',3.73),('8902','2014-01-07','14:45:00',3.55),('8902','2014-01-07','14:50:00',3.45),('8902','2014-01-07','14:55:00',3.04),('8902','2014-01-07','15:00:00',2.67),('8902','2014-01-07','15:05:00',2.69),('8902','2014-01-07','15:10:00',2.22),('8902','2014-01-07','15:15:00',2.32),('8902','2014-01-07','15:20:00',2.43),('8902','2014-01-07','15:25:00',2.46),('8902','2014-01-07','15:30:00',2.24),('8902','2014-01-07','15:35:00',2.06),('8902','2014-01-07','15:40:00',1.96),('8902','2014-01-07','15:45:00',1.72),('8902','2014-01-07','15:50:00',1.48),('8902','2014-01-07','15:55:00',1.12),('8902','2014-01-07','16:00:00',1.01),('8902','2014-01-06','08:35:00',1.1),('8902','2014-01-06','08:40:00',1.28),('8902','2014-01-06','08:45:00',1.63),('8902','2014-01-06','08:50:00',1.85),('8902','2014-01-06','08:55:00',2.03),('8902','2014-01-06','09:00:00',2.18),('8902','2014-01-06','09:05:00',2.34),('8902','2014-01-06','09:10:00',2.5),('8902','2014-01-06','09:15:00',2.65),('8902','2014-01-06','09:20:00',2.85),('8902','2014-01-06','09:25:00',3.01),('8902','2014-01-06','09:30:00',3.17),('8902','2014-01-06','09:35:00',3.32),('8902','2014-01-06','09:40:00',3.45),('8902','2014-01-06','09:45:00',3.59),('8902','2014-01-06','09:50:00',3.72),('8902','2014-01-06','09:55:00',3.84),('8902','2014-01-06','10:00:00',3.95),('8902','2014-01-06','10:05:00',4.06),('8902','2014-01-06','10:10:00',4.16),('8902','2014-01-06','10:15:00',4.27),('8902','2014-01-06','10:20:00',4.35),('8902','2014-01-06','10:25:00',4.45),('8902','2014-01-06','10:30:00',4.52),('8902','2014-01-06','10:35:00',4.62),('8902','2014-01-06','10:40:00',4.72),('8902','2014-01-06','10:45:00',4.82),('8902','2014-01-06','10:50:00',4.91),('8902','2014-01-06','10:55:00',4.99),('8902','2014-01-06','11:00:00',5.04),('8902','2014-01-06','11:05:00',5.11),('8902','2014-01-06','11:10:00',5.17),('8902','2014-01-06','11:15:00',5.21),('8902','2014-01-06','11:20:00',5.27),('8902','2014-01-06','11:25:00',5.32),('8902','2014-01-06','11:30:00',5.38),('8902','2014-01-06','11:35:00',5.41),('8902','2014-01-06','11:40:00',5.43),('8902','2014-01-06','11:45:00',5.51),('8902','2014-01-06','11:50:00',5.54),('8902','2014-01-06','11:55:00',5.55),('8902','2014-01-06','12:00:00',5.51),('8902','2014-01-06','12:05:00',5.58),('8902','2014-01-06','12:10:00',5.59),('8902','2014-01-06','12:15:00',5.56),('8902','2014-01-06','12:20:00',5.58),('8902','2014-01-06','12:25:00',5.56),('8902','2014-01-06','12:30:00',5.48),('8902','2014-01-06','12:35:00',5.51),('8902','2014-01-06','12:40:00',5.33),('8902','2014-01-06','12:45:00',5.2),('8902','2014-01-06','12:50:00',5.42),('8902','2014-01-06','12:55:00',5.54),('8902','2014-01-06','13:00:00',5.21),('8902','2014-01-06','13:05:00',5),('8902','2014-01-06','13:10:00',5.11),('8902','2014-01-06','13:15:00',5.15),('8902','2014-01-06','13:20:00',4.93),('8902','2014-01-06','13:25:00',4.84),('8902','2014-01-06','13:30:00',4.77),('8902','2014-01-06','13:35:00',4.69),('8902','2014-01-06','13:40:00',4.74),('8902','2014-01-06','13:45:00',4.89),('8902','2014-01-06','13:50:00',4.85),('8902','2014-01-06','13:55:00',4.73),('8902','2014-01-06','14:00:00',4.79),('8902','2014-01-06','14:05:00',4.57),('8902','2014-01-06','14:10:00',4.45),('8902','2014-01-06','14:15:00',4.37),('8902','2014-01-06','14:20:00',4.39),('8902','2014-01-06','14:25:00',4.18),('8902','2014-01-06','14:30:00',4.06),('8902','2014-01-06','14:35:00',3.95),('8902','2014-01-06','14:40:00',3.97),('8902','2014-01-06','14:45:00',3.75),('8902','2014-01-06','14:50:00',3.72),('8902','2014-01-06','14:55:00',3.67),('8902','2014-01-06','15:00:00',3.51),('8902','2014-01-06','15:05:00',3.47),('8902','2014-01-06','15:10:00',3.34),('8902','2014-01-06','15:15:00',3.15),('8902','2014-01-06','15:20:00',2.97),('8902','2014-01-06','15:25:00',2.72),('8902','2014-01-06','15:30:00',2.45),('8902','2014-01-06','15:35:00',2.16),('8902','2014-01-06','15:40:00',1.72),('8902','2014-01-06','15:45:00',1.65),('8902','2014-01-06','15:50:00',1.59),('8902','2014-01-06','15:55:00',1.47),('8902','2014-01-06','16:00:00',1.19),('8902','2014-01-06','16:05:00',1.08),('8902','2014-01-06','16:10:00',1.21),('8902','2014-04-23','07:45:00',1.19),('8902','2014-04-23','07:50:00',1.44),('8902','2014-04-23','07:55:00',1.59),('8902','2014-04-23','08:00:00',1.73),('8902','2014-04-23','08:05:00',1.89),('8902','2014-04-23','08:10:00',2.03),('8902','2014-04-23','08:15:00',2.2),('8902','2014-04-23','08:20:00',2.39),('8902','2014-04-23','08:25:00',2.58),('8902','2014-04-23','08:30:00',2.75),('8902','2014-04-23','08:35:00',2.93),('8902','2014-04-23','08:40:00',3.11),('8902','2014-04-23','08:45:00',3.29),('8902','2014-04-23','08:50:00',3.45),('8902','2014-04-23','08:55:00',3.63),('8902','2014-04-23','09:00:00',3.8),('8902','2014-04-23','09:05:00',3.96),('8902','2014-04-23','09:10:00',4.1),('8902','2014-04-23','09:15:00',4.25),('8902','2014-04-23','09:20:00',4.42),('8902','2014-04-23','09:25:00',4.55),('8902','2014-04-23','09:30:00',4.7),('8902','2014-04-23','09:35:00',4.86),('8902','2014-04-23','09:40:00',4.99),('8902','2014-04-23','09:45:00',5.13),('8902','2014-04-23','09:50:00',5.29),('8902','2014-04-23','09:55:00',5.44),('8902','2014-04-23','10:00:00',5.57),('8902','2014-04-23','10:05:00',5.68),('8902','2014-04-23','10:10:00',5.75),('8902','2014-04-23','10:15:00',5.84),('8902','2014-04-23','10:20:00',5.96),('8902','2014-04-23','10:25:00',6.07),('8902','2014-04-23','10:30:00',6.19),('8902','2014-04-23','10:35:00',6.26),('8902','2014-04-23','10:40:00',6.44),('8902','2014-04-23','10:45:00',6.56),('8902','2014-04-23','10:50:00',6.7),('8902','2014-04-23','10:55:00',6.8),('8902','2014-04-23','11:00:00',6.85),('8902','2014-04-23','11:05:00',6.85),('8902','2014-04-23','11:10:00',6.9),('8902','2014-04-23','11:15:00',7.02),('8902','2014-04-23','11:20:00',7.08),('8902','2014-04-23','11:25:00',7.15),('8902','2014-04-23','11:30:00',7.15),('8902','2014-04-23','11:35:00',7.22),('8902','2014-04-23','11:40:00',7.35),('8902','2014-04-23','11:45:00',7.4),('8902','2014-04-23','11:50:00',7.23),('8902','2014-04-23','11:55:00',7.67),('8902','2014-04-23','12:00:00',7.45),('8902','2014-04-23','12:05:00',7.57),('8902','2014-04-23','12:10:00',7.92),('8902','2014-04-23','12:15:00',5.82),('8902','2014-04-23','12:20:00',6.83),('8902','2014-04-23','12:25:00',8.1),('8902','2014-04-23','12:30:00',7.7),('8902','2014-04-23','12:35:00',5.27),('8902','2014-04-23','12:40:00',8.23),('8902','2014-04-23','12:45:00',5.79),('8902','2014-04-23','12:50:00',8.41),('8902','2014-04-23','12:55:00',8.21),('8902','2014-04-23','13:00:00',8.05),('8902','2014-04-23','13:05:00',8.1),('8902','2014-04-23','13:10:00',6.46),('8902','2014-04-23','13:15:00',2.14),('8902','2014-04-23','13:20:00',8.63),('8902','2014-04-23','13:25:00',8.6),('8902','2014-04-23','13:30:00',8.51),('8902','2014-04-23','13:35:00',8.11),('8902','2014-04-23','13:40:00',5.74),('8902','2014-04-23','13:45:00',2.53),('8902','2014-04-23','13:50:00',8.39),('8902','2014-04-23','13:55:00',9.12),('8902','2014-04-23','14:00:00',7.17),('8902','2014-04-23','14:05:00',6.36),('8902','2014-04-23','14:10:00',7.67),('8902','2014-04-23','14:15:00',6.45),('8902','2014-04-23','14:20:00',6.25),('8902','2014-04-23','14:25:00',8.02),('8902','2014-04-23','14:30:00',8.88),('8902','2014-04-23','14:35:00',8.52),('8902','2014-04-23','14:40:00',6.31),('8902','2014-04-23','14:45:00',7.02),('8902','2014-04-23','14:50:00',3.47),('8902','2014-04-23','14:55:00',6.74),('8902','2014-04-23','15:00:00',9.28),('8902','2014-04-23','15:05:00',8.97),('8902','2014-04-23','15:10:00',8.39),('8902','2014-04-23','15:15:00',7.61),('8902','2014-04-23','15:20:00',5.65),('8902','2014-04-23','15:25:00',4.47),('8902','2014-04-23','15:30:00',4.73),('8902','2014-04-23','15:35:00',5.7),('8902','2014-04-23','15:40:00',4.37),('8902','2014-04-23','15:45:00',3.97),('8902','2014-04-23','15:50:00',4.98),('8902','2014-04-23','15:55:00',5.43),('8902','2014-04-23','16:00:00',7.49),('8902','2014-04-23','16:05:00',7.5),('8902','2014-04-23','16:10:00',6.35),('8902','2014-04-23','16:15:00',6.77),('8902','2014-04-23','16:20:00',6.19),('8902','2014-04-23','16:25:00',4.63),('8902','2014-04-23','16:30:00',6.03),('8902','2014-04-23','16:35:00',3.56),('8902','2014-04-23','16:40:00',4.23),('8902','2014-04-23','16:45:00',4.61),('8902','2014-04-23','16:50:00',3.01),('8902','2014-04-23','16:55:00',3.48),('8902','2014-04-23','17:00:00',2.65),('8902','2014-04-23','17:05:00',2.39),('8902','2014-04-23','17:10:00',2.22),('8902','2014-04-23','17:15:00',2.03),('8902','2014-04-23','17:20:00',2.05),('8902','2014-04-23','17:25:00',2.04),('8902','2014-04-23','17:30:00',1.96),('8902','2014-04-23','17:35:00',1.9),('8902','2014-04-23','17:40:00',1.7),('8902','2014-04-23','17:45:00',1.15),('8902','2014-01-05','11:00:00',1.01),('8902','2014-01-05','11:05:00',1.29),('8902','2014-01-05','11:10:00',1.5),('8902','2014-01-05','11:15:00',1.71),('8902','2014-01-05','11:20:00',1.78),('8902','2014-01-05','11:25:00',1.68),('8902','2014-01-05','11:30:00',1.5),('8902','2014-01-05','11:35:00',2.74),('8902','2014-01-05','11:40:00',5.49),('8902','2014-01-05','11:45:00',5.79),('8902','2014-01-05','11:50:00',4.92),('8902','2014-01-05','11:55:00',4.55),('8902','2014-01-05','12:00:00',2.33),('8902','2014-01-05','12:05:00',5.47),('8902','2014-01-05','12:10:00',5.71),('8902','2014-01-05','12:15:00',5.57),('8902','2014-01-05','12:20:00',5.59),('8902','2014-01-05','12:25:00',5.56),('8902','2014-01-05','12:30:00',5.5),('8902','2014-01-05','12:35:00',5.48),('8902','2014-01-05','12:40:00',5.49),('8902','2014-01-05','12:45:00',5.53),('8902','2014-01-05','12:50:00',5.51),('8902','2014-01-05','12:55:00',5.46),('8902','2014-01-05','13:00:00',5.44),('8902','2014-01-05','13:05:00',5.35),('8902','2014-01-05','13:10:00',5.38),('8902','2014-01-05','13:15:00',5.52),('8902','2014-01-05','13:20:00',5.49),('8902','2014-01-05','13:25:00',5.33),('8902','2014-01-05','13:30:00',5.03),('8902','2014-01-05','13:35:00',5.06),('8902','2014-01-05','13:40:00',5.03),('8902','2014-01-05','13:45:00',4.88),('8902','2014-01-05','13:50:00',4.8),('8902','2014-01-05','13:55:00',4.79),('8902','2014-01-05','14:00:00',3.24),('8902','2014-01-05','14:10:00',1),('8902','2014-01-05','14:15:00',1.13),('8902','2014-01-05','14:20:00',4.3),('8902','2014-01-05','14:25:00',1.97),('8902','2014-01-05','14:30:00',1.45),('8902','2014-01-05','14:35:00',1.93),('8902','2014-01-05','14:40:00',4.4),('8902','2014-01-05','14:45:00',4.69),('8902','2014-01-05','14:50:00',3.19),('8902','2014-01-05','14:55:00',1.4),('8902','2014-01-05','15:00:00',2.06),('8902','2014-01-05','15:05:00',3.09),('8902','2014-01-05','15:10:00',3.15),('8902','2014-01-05','15:15:00',2.99),('8902','2014-01-05','15:20:00',2.76),('8902','2014-01-05','15:25:00',2.42),('8902','2014-01-05','15:30:00',2.18),('8902','2014-01-05','15:35:00',2.27),('8902','2014-01-05','15:40:00',2.13),('8902','2014-01-05','15:45:00',1.7),('8902','2014-01-05','15:50:00',1.62),('8902','2014-01-05','15:55:00',1.35),('8902','2014-01-05','16:00:00',1.23),('8902','2014-01-05','16:05:00',1.15),('8902','2014-01-05','16:10:00',1.04),('8902','2014-01-04','12:40:00',1),('8902','2014-01-04','13:20:00',1.07),('8902','2014-01-04','13:25:00',1.02),('8902','2014-01-04','13:30:00',1.06),('8902','2014-01-04','15:10:00',1.18),('8902','2014-01-04','15:15:00',1.19),('8902','2014-01-03','14:55:00',1.06),('8902','2014-01-03','15:00:00',1.64),('8902','2014-01-03','15:05:00',1.07),('8902','2014-01-02','08:55:00',1.53),('8902','2014-01-02','09:10:00',1.28),('8902','2014-01-02','09:15:00',1.76),('8902','2014-01-02','09:20:00',2.27),('8902','2014-01-02','09:25:00',1.72),('8902','2014-01-02','09:30:00',2.43),('8902','2014-01-02','09:35:00',3.29),('8902','2014-01-02','09:40:00',3.84),('8902','2014-01-02','09:45:00',3.2),('8902','2014-01-02','09:50:00',1.69),('8902','2014-01-02','09:55:00',1.52),('8902','2014-01-02','10:00:00',1.66),('8902','2014-01-02','10:05:00',3.46),('8902','2014-01-02','10:10:00',3.34),('8902','2014-01-02','10:15:00',1.6),('8902','2014-01-02','10:20:00',4.97),('8902','2014-01-02','10:25:00',2.59),('8902','2014-01-02','10:30:00',2.3),('8902','2014-01-02','10:35:00',2.08),('8902','2014-01-02','10:40:00',2.5),('8902','2014-01-02','10:45:00',2.6),('8902','2014-01-02','10:50:00',2.73),('8902','2014-01-02','10:55:00',2.27),('8902','2014-01-02','11:00:00',1.94),('8902','2014-01-02','11:05:00',2.13),('8902','2014-01-02','11:10:00',1.77),('8902','2014-01-02','11:15:00',1.48),('8902','2014-01-02','11:20:00',1.68),('8902','2014-01-02','11:25:00',1.5),('8902','2014-01-02','11:30:00',1.48),('8902','2014-01-02','11:35:00',1.72),('8902','2014-01-02','11:40:00',1.8),('8902','2014-01-02','11:45:00',2.18),('8902','2014-01-02','11:50:00',2.14),('8902','2014-01-02','11:55:00',2.05),('8902','2014-01-02','12:00:00',2.19),('8902','2014-01-02','12:05:00',3.09),('8902','2014-01-02','12:10:00',3.44),('8902','2014-01-02','12:15:00',2.94),('8902','2014-01-02','12:20:00',1.92),('8902','2014-01-02','12:25:00',3.35),('8902','2014-01-02','12:30:00',2.48),('8902','2014-01-02','12:35:00',3.14),('8902','2014-01-02','12:40:00',3.21),('8902','2014-01-02','12:45:00',3.47),('8902','2014-01-02','12:50:00',3.1),('8902','2014-01-02','12:55:00',4.17),('8902','2014-01-02','13:00:00',2.48),('8902','2014-01-02','13:05:00',2.04),('8902','2014-01-02','13:10:00',2.54),('8902','2014-01-02','13:15:00',2.24),('8902','2014-01-02','13:20:00',1.73),('8902','2014-01-02','13:25:00',1.84),('8902','2014-01-02','13:30:00',2.49),('8902','2014-01-02','13:35:00',3.77),('8902','2014-01-02','13:40:00',2.34),('8902','2014-01-02','13:45:00',2.84),('8902','2014-01-02','13:50:00',1.85),('8902','2014-01-02','13:55:00',1.52),('8902','2014-01-02','14:00:00',1.29),('8902','2014-01-01','08:35:00',1.15),('8902','2014-01-01','08:40:00',1.38),('8902','2014-01-01','08:45:00',1.56),('8902','2014-01-01','08:50:00',1.79),('8902','2014-01-01','08:55:00',1.93),('8902','2014-01-01','09:00:00',2.11),('8902','2014-01-01','09:05:00',2.29),('8902','2014-01-01','09:10:00',2.41),('8902','2014-01-01','09:15:00',2.57),('8902','2014-01-01','09:20:00',2.74),('8902','2014-01-01','09:25:00',2.84),('8902','2014-01-01','09:30:00',2.97),('8902','2014-01-01','09:35:00',3.07),('8902','2014-01-01','09:40:00',3.24),('8902','2014-01-01','09:45:00',3.36),('8902','2014-01-01','09:50:00',3.47),('8902','2014-01-01','09:55:00',3.64),('8902','2014-01-01','10:00:00',3.83),('8902','2014-01-01','10:05:00',3.99),('8902','2014-01-01','10:10:00',4.05),('8902','2014-01-01','10:15:00',4.1),('8902','2014-01-01','10:20:00',4.17),('8902','2014-01-01','10:25:00',4.32),('8902','2014-01-01','10:30:00',4.42),('8902','2014-01-01','10:35:00',4.38),('8902','2014-01-01','10:40:00',4.45),('8902','2014-01-01','10:45:00',4.54),('8902','2014-01-01','10:50:00',4.67),('8902','2014-01-01','10:55:00',4.89),('8902','2014-01-01','11:00:00',4.54),('8902','2014-01-01','11:05:00',4.87),('8902','2014-01-01','11:10:00',3.45),('8902','2014-01-01','11:15:00',2.75),('8902','2014-01-01','11:20:00',2.37),('8902','2014-01-01','11:25:00',2.69),('8902','2014-01-01','11:30:00',3.1),('8902','2014-01-01','11:35:00',3.18),('8902','2014-01-01','11:40:00',3.52),('8902','2014-01-01','11:45:00',2.96),('8902','2014-01-01','11:50:00',2.66),('8902','2014-01-01','11:55:00',2.38),('8902','2014-01-01','12:00:00',2.22),('8902','2014-01-01','12:05:00',2.26),('8902','2014-01-01','12:10:00',2.46),('8902','2014-01-01','12:15:00',2.11),('8902','2014-01-01','12:20:00',1.96),('8902','2014-01-01','12:25:00',1.89),('8902','2014-01-01','12:30:00',1.77),('8902','2014-01-01','12:35:00',1.42),('8902','2014-01-01','12:40:00',1.44),('8902','2014-01-01','12:45:00',1.76),('8902','2014-01-01','12:50:00',2.59),('8902','2014-01-01','12:55:00',6.38),('8902','2014-01-01','13:00:00',4.59),('8902','2014-01-01','13:05:00',1.46),('8902','2014-01-01','13:10:00',1.12),('8902','2014-01-01','13:15:00',1.06),('8902','2014-01-01','13:30:00',1.48),('8902','2014-01-01','13:35:00',1.78),('8902','2014-01-01','13:40:00',2.45),('8902','2014-01-01','13:45:00',2.9),('8902','2014-01-01','13:50:00',1.54),('8902','2014-01-01','13:55:00',1.06),('8902','2014-01-01','14:20:00',1.2),('8902','2014-01-01','14:25:00',1.19),('8902','2014-01-01','14:30:00',1.07),('8902','2013-12-31','08:25:00',1.07),('8902','2013-12-31','08:30:00',1.23),('8902','2013-12-31','08:35:00',1.13),('8902','2013-12-31','08:40:00',1.21),('8902','2013-12-31','08:50:00',1.13),('8902','2013-12-31','08:55:00',2.22),('8902','2013-12-31','09:00:00',2.64),('8902','2013-12-31','09:05:00',2.59),('8902','2013-12-31','09:10:00',3.2),('8902','2013-12-31','09:15:00',2.07),('8902','2013-12-31','09:20:00',2.1),('8902','2013-12-31','09:25:00',2.19),('8902','2013-12-31','09:30:00',3.68),('8902','2013-12-31','09:35:00',2.53),('8902','2013-12-31','09:40:00',3.01),('8902','2013-12-31','09:45:00',2.94),('8902','2013-12-31','09:50:00',4.4),('8902','2013-12-31','09:55:00',3),('8902','2013-12-31','10:00:00',2.25),('8902','2013-12-31','10:05:00',2.06),('8902','2013-12-31','10:10:00',1.75),('8902','2013-12-31','10:15:00',1.55),('8902','2013-12-31','10:20:00',1.44),('8902','2013-12-31','10:25:00',1.41),('8902','2013-12-31','10:30:00',1.4),('8902','2013-12-31','10:35:00',1.36),('8902','2013-12-31','10:40:00',1.37),('8902','2013-12-31','10:45:00',1.44),('8902','2013-12-31','10:50:00',1.53),('8902','2013-12-31','10:55:00',1.68),('8902','2013-12-31','11:00:00',1.71),('8902','2013-12-31','11:05:00',1.64),('8902','2013-12-31','11:10:00',1.59),('8902','2013-12-31','11:15:00',1.66),('8902','2013-12-31','11:20:00',1.76),('8902','2013-12-31','11:25:00',1.8),('8902','2013-12-31','11:30:00',1.83),('8902','2013-12-31','11:35:00',1.77),('8902','2013-12-31','11:40:00',1.76),('8902','2013-12-31','11:45:00',1.76),('8902','2013-12-31','11:50:00',1.72),('8902','2013-12-31','11:55:00',1.79),('8902','2013-12-31','12:00:00',1.97),('8902','2013-12-31','12:05:00',2.08),('8902','2013-12-31','12:10:00',2.22),('8902','2013-12-31','12:15:00',2.32),('8902','2013-12-31','12:20:00',2.39),('8902','2013-12-31','12:25:00',2.41),('8902','2013-12-31','12:30:00',2.56),('8902','2013-12-31','12:35:00',2.88),('8902','2013-12-31','12:40:00',2.75),('8902','2013-12-31','12:45:00',2.4),('8902','2013-12-31','12:50:00',2.75),('8902','2013-12-31','12:55:00',2.42),('8902','2013-12-31','13:00:00',2.46),('8902','2013-12-31','13:05:00',2.06),('8902','2013-12-31','13:10:00',1.94),('8902','2013-12-31','13:15:00',1.92),('8902','2013-12-31','13:20:00',2.02),('8902','2013-12-31','13:25:00',2.2),('8902','2013-12-31','13:30:00',2.68),('8902','2013-12-31','13:35:00',4.53),('8902','2013-12-31','13:40:00',3.74),('8902','2013-12-31','13:45:00',2.7),('8902','2013-12-31','13:50:00',2.76),('8902','2013-12-31','13:55:00',3.69),('8902','2013-12-31','14:00:00',4.28),('8902','2013-12-31','14:05:00',2.24),('8902','2013-12-31','14:10:00',2.07),('8902','2013-12-31','14:15:00',2.23),('8902','2013-12-31','14:20:00',2.07),('8902','2013-12-31','14:25:00',1.77),('8902','2013-12-31','14:30:00',1.75),('8902','2013-12-31','14:35:00',1.6),('8902','2013-12-31','14:40:00',1.74),('8902','2013-12-31','14:45:00',1.79),('8902','2013-12-31','14:50:00',1.63),('8902','2013-12-31','14:55:00',1.98),('8902','2013-12-31','15:00:00',1.62),('8902','2013-12-31','15:05:00',3.33),('8902','2013-12-31','15:10:00',3.69),('8902','2013-12-31','15:15:00',3.09),('8902','2013-12-31','15:20:00',2.76),('8902','2013-12-31','15:25:00',2.51),('8902','2013-12-31','15:30:00',2.28),('8902','2013-12-31','15:35:00',2.12),('8902','2013-12-31','15:40:00',1.93),('8902','2013-12-31','15:45:00',1.71),('8902','2013-12-31','15:50:00',1.54),('8902','2013-12-31','15:55:00',1.37),('8902','2013-12-31','16:00:00',1.19),('8902','2013-12-31','16:05:00',1),('8902','2013-12-30','08:45:00',1.52),('8902','2013-12-30','08:50:00',1.47),('8902','2013-12-30','08:55:00',1.07),('8902','2013-12-30','09:00:00',2.36),('8902','2013-12-30','09:05:00',1.26),('8902','2013-12-30','09:10:00',1.1),('8902','2013-12-30','09:15:00',1.9),('8902','2013-12-30','09:20:00',2.97),('8902','2013-12-30','09:25:00',3.13),('8902','2013-12-30','09:30:00',3.43),('8902','2013-12-30','09:35:00',3.61),('8902','2013-12-30','09:40:00',3.84),('8902','2013-12-30','09:45:00',3.19),('8902','2013-12-30','09:50:00',3.37),('8902','2013-12-30','09:55:00',2.81),('8902','2013-12-30','10:00:00',3.27),('8902','2013-12-30','10:05:00',2.48),('8902','2013-12-30','10:10:00',2.05),('8902','2013-12-30','10:15:00',1.75),('8902','2013-12-30','10:20:00',1.54),('8902','2013-12-30','10:25:00',1.65),('8902','2013-12-30','10:30:00',1.95),('8902','2013-12-30','10:35:00',1.89),('8902','2013-12-30','10:40:00',1.81),('8902','2013-12-30','10:45:00',1.85),('8902','2013-12-30','10:50:00',2.35),('8902','2013-12-30','10:55:00',2.59),('8902','2013-12-30','11:00:00',2.61),('8902','2013-12-30','11:05:00',2.61),('8902','2013-12-30','11:10:00',2.67),('8902','2013-12-30','11:15:00',3.21),('8902','2013-12-30','11:20:00',3.11),('8902','2013-12-30','11:25:00',3.74),('8902','2013-12-30','11:30:00',4.64),('8902','2013-12-30','11:35:00',2.61),('8902','2013-12-30','11:40:00',3.61),('8902','2013-12-30','11:45:00',2.52),('8902','2013-12-30','11:50:00',4.87),('8902','2013-12-30','11:55:00',4.73),('8902','2013-12-30','12:00:00',5.98),('8902','2013-12-30','12:05:00',5.85),('8902','2013-12-30','12:10:00',5.81),('8902','2013-12-30','12:15:00',5.77),('8902','2013-12-30','12:20:00',5.74),('8902','2013-12-30','12:25:00',5.69),('8902','2013-12-30','12:30:00',5.56),('8902','2013-12-30','12:35:00',5.58),('8902','2013-12-30','12:40:00',5.58),('8902','2013-12-30','12:45:00',5.55),('8902','2013-12-30','12:50:00',5.51),('8902','2013-12-30','12:55:00',5.49),('8902','2013-12-30','13:00:00',5.48),('8902','2013-12-30','13:05:00',5.44),('8902','2013-12-30','13:10:00',5.4),('8902','2013-12-30','13:15:00',5.38),('8902','2013-12-30','13:20:00',5.32),('8902','2013-12-30','13:25:00',5.28),('8902','2013-12-30','13:30:00',5.23),('8902','2013-12-30','13:35:00',5.12),('8902','2013-12-30','13:40:00',5.02),('8902','2013-12-30','13:45:00',4.94),('8902','2013-12-30','13:50:00',4.84),('8902','2013-12-30','13:55:00',4.77),('8902','2013-12-30','14:00:00',4.69),('8902','2013-12-30','14:05:00',4.62),('8902','2013-12-30','14:10:00',4.5),('8902','2013-12-30','14:15:00',4.41),('8902','2013-12-30','14:20:00',4.32),('8902','2013-12-30','14:25:00',4.23),('8902','2013-12-30','14:30:00',4.1),('8902','2013-12-30','14:35:00',3.98),('8902','2013-12-30','14:40:00',3.86),('8902','2013-12-30','14:45:00',3.72),('8902','2013-12-30','14:50:00',3.57),('8902','2013-12-30','14:55:00',3.43),('8902','2013-12-30','15:00:00',3.29),('8902','2013-12-30','15:05:00',3.14),('8902','2013-12-30','15:10:00',2.96),('8902','2013-12-30','15:15:00',2.79),('8902','2013-12-30','15:20:00',2.64),('8902','2013-12-30','15:25:00',2.48),('8902','2013-12-30','15:30:00',2.31),('8902','2013-12-30','15:35:00',2.13),('8902','2013-12-30','15:40:00',1.94),('8902','2013-12-30','15:45:00',1.74),('8902','2013-12-30','15:50:00',1.59),('8902','2013-12-30','15:55:00',1.41),('8902','2013-12-30','16:00:00',1.25),('8902','2013-12-30','16:05:00',1.07),('8902','2013-12-29','09:10:00',1.1),('8902','2013-12-29','09:15:00',1.08),('8902','2013-12-29','09:20:00',1.16),('8902','2013-12-29','09:25:00',1.33),('8902','2013-12-29','09:30:00',1.3),('8902','2013-12-29','09:35:00',1.05),('8902','2013-12-29','09:40:00',1.01),('8902','2013-12-29','11:05:00',1.07),('8902','2013-12-29','11:10:00',1.25),('8902','2013-12-29','11:15:00',1.48),('8902','2013-12-29','11:20:00',1.77),('8902','2013-12-29','11:25:00',2),('8902','2013-12-29','11:30:00',2.01),('8902','2013-12-29','11:35:00',1.88),('8902','2013-12-29','11:40:00',1.75),('8902','2013-12-29','11:45:00',1.7),('8902','2013-12-29','11:50:00',1.66),('8902','2013-12-29','11:55:00',1.46),('8902','2013-12-29','12:00:00',1.29),('8902','2013-12-29','12:05:00',1.29),('8902','2013-12-29','12:10:00',1.35),('8902','2013-12-29','12:15:00',1.36),('8902','2013-12-29','12:20:00',1.31),('8902','2013-12-29','12:25:00',1.37),('8902','2013-12-29','12:30:00',1.37),('8902','2013-12-29','12:35:00',1.35),('8902','2013-12-29','12:40:00',1.39),('8902','2013-12-29','12:45:00',1.49),('8902','2013-12-29','12:50:00',1.49),('8902','2013-12-29','12:55:00',1.35),('8902','2013-12-29','13:00:00',1.21),('8902','2013-12-29','13:05:00',1.25),('8902','2013-12-29','13:10:00',1.36),('8902','2013-12-29','13:15:00',1.27),('8902','2013-12-29','13:20:00',1.22),('8902','2013-12-29','13:25:00',1.27),('8902','2013-12-29','13:30:00',1.29),('8902','2013-12-29','13:35:00',1.26),('8902','2013-12-29','13:40:00',1.19),('8902','2013-12-29','13:45:00',1.14),('8902','2013-12-29','13:50:00',1.03),('8902','2013-12-28','08:20:00',1.07),('8902','2013-12-28','08:25:00',1.07),('8902','2013-12-28','08:30:00',1.15),('8902','2013-12-28','08:35:00',1.67),('8902','2013-12-28','08:40:00',1.73),('8902','2013-12-28','08:45:00',1.63),('8902','2013-12-28','08:50:00',1.65),('8902','2013-12-28','09:05:00',1.81),('8902','2013-12-28','09:10:00',2.43),('8902','2013-12-28','09:15:00',2.64),('8902','2013-12-28','09:20:00',3.02),('8902','2013-12-28','09:25:00',3.08),('8902','2013-12-28','09:30:00',3.25),('8902','2013-12-28','09:35:00',3.36),('8902','2013-12-28','09:40:00',3.55),('8902','2013-12-28','09:45:00',3.65),('8902','2013-12-28','09:50:00',3.53),('8902','2013-12-28','09:55:00',3.08),('8902','2013-12-28','10:00:00',3.13),('8902','2013-12-28','10:05:00',3.46),('8902','2013-12-28','10:10:00',3.43),('8902','2013-12-28','10:15:00',4.27),('8902','2013-12-28','10:20:00',4.63),('8902','2013-12-28','10:25:00',3.9),('8902','2013-12-28','10:30:00',4.77),('8902','2013-12-28','10:35:00',3.53),('8902','2013-12-28','10:40:00',5.46),('8902','2013-12-28','10:45:00',2.3),('8902','2013-12-28','10:50:00',1.82),('8902','2013-12-28','10:55:00',2.5),('8902','2013-12-28','11:00:00',2.04),('8902','2013-12-28','11:05:00',1.93),('8902','2013-12-28','11:10:00',2.03),('8902','2013-12-28','11:15:00',1.42),('8902','2013-12-28','11:20:00',1.17),('8902','2013-12-28','11:35:00',1.18),('8902','2013-12-28','11:40:00',1.2),('8902','2013-12-28','11:55:00',1.27),('8902','2013-12-28','12:00:00',1.37),('8902','2013-12-28','12:05:00',1.33),('8902','2013-12-28','12:10:00',1.26),('8902','2013-12-28','12:15:00',1.13),('8902','2013-12-28','13:40:00',1.28),('8902','2013-12-27','08:30:00',1.02),('8902','2013-12-27','08:35:00',1.3),('8902','2013-12-27','08:40:00',1.55),('8902','2013-12-27','08:45:00',1.72),('8902','2013-12-27','08:50:00',1.91),('8902','2013-12-27','08:55:00',2.1),('8902','2013-12-27','09:00:00',2.25),('8902','2013-12-27','09:05:00',2.39),('8902','2013-12-27','09:10:00',2.52),('8902','2013-12-27','09:15:00',2.71),('8902','2013-12-27','09:20:00',2.9),('8902','2013-12-27','09:25:00',3.05),('8902','2013-12-27','09:30:00',3.21),('8902','2013-12-27','09:35:00',3.36),('8902','2013-12-27','09:40:00',3.47),('8902','2013-12-27','09:45:00',3.61),('8902','2013-12-27','09:50:00',3.76),('8902','2013-12-27','09:55:00',3.89),('8902','2013-12-27','10:00:00',4.01),('8902','2013-12-27','10:05:00',4.12),('8902','2013-12-27','10:10:00',4.24),('8902','2013-12-27','10:15:00',4.33),('8902','2013-12-27','10:20:00',4.41),('8902','2013-12-27','10:25:00',4.5),('8902','2013-12-27','10:30:00',4.61),('8902','2013-12-27','10:35:00',4.72),('8902','2013-12-27','10:40:00',4.79),('8902','2013-12-27','10:45:00',4.86),('8902','2013-12-27','10:50:00',4.91),('8902','2013-12-27','10:55:00',4.98),('8902','2013-12-27','11:00:00',5.06),('8902','2013-12-27','11:05:00',5.12),('8902','2013-12-27','11:10:00',5.16),('8902','2013-12-27','11:15:00',5.23),('8902','2013-12-27','11:20:00',5.28),('8902','2013-12-27','11:25:00',5.33),('8902','2013-12-27','11:30:00',5.36),('8902','2013-12-27','11:35:00',5.41),('8902','2013-12-27','11:40:00',5.46),('8902','2013-12-27','11:45:00',5.49),('8902','2013-12-27','11:50:00',5.51),('8902','2013-12-27','11:55:00',5.51),('8902','2013-12-27','12:00:00',5.53),('8902','2013-12-27','12:05:00',5.5),('8902','2013-12-27','12:10:00',5.47),('8902','2013-12-27','12:15:00',5.5),('8902','2013-12-27','12:20:00',5.48),('8902','2013-12-27','12:25:00',5.42),('8902','2013-12-27','12:30:00',5.39),('8902','2013-12-27','12:35:00',5.4),('8902','2013-12-27','12:40:00',5.42),('8902','2013-12-27','12:45:00',5.35),('8902','2013-12-27','12:50:00',5.31),('8902','2013-12-27','12:55:00',5.28),('8902','2013-12-27','13:00:00',5.25),('8902','2013-12-27','13:05:00',5.17),('8902','2013-12-27','13:10:00',5.09),('8902','2013-12-27','13:15:00',5.06),('8902','2013-12-27','13:20:00',5.01),('8902','2013-12-27','13:25:00',4.88),('8902','2013-12-27','13:30:00',4.72),('8902','2013-12-27','13:35:00',4.68),('8902','2013-12-27','13:40:00',4.66),('8902','2013-12-27','13:45:00',4.46),('8902','2013-12-27','13:50:00',4.41),('8902','2013-12-27','13:55:00',4.44),('8902','2013-12-27','14:00:00',4.31),('8902','2013-12-27','14:05:00',4.16),('8902','2013-12-27','14:10:00',4.05),('8902','2013-12-27','14:15:00',3.97),('8902','2013-12-27','14:20:00',3.77),('8902','2013-12-27','14:25:00',3.64),('8902','2013-12-27','14:30:00',3.61),('8902','2013-12-27','14:35:00',3.46),('8902','2013-12-27','14:40:00',3.3),('8902','2013-12-27','14:45:00',2.96),('8902','2013-12-27','14:50:00',2.66),('8902','2013-12-27','14:55:00',1.37),('8902','2013-12-27','15:00:00',2.08),('8902','2013-12-27','15:05:00',2.92),('8902','2013-12-27','15:10:00',2.66),('8902','2013-12-27','15:15:00',2.49),('8902','2013-12-27','15:20:00',2.33),('8902','2013-12-27','15:25:00',2.19),('8902','2013-12-27','15:30:00',1.92),('8902','2013-12-27','15:35:00',1.89),('8902','2013-12-27','15:40:00',1.71),('8902','2013-12-27','15:45:00',1.57),('8902','2013-12-27','15:50:00',1.46),('8902','2013-12-27','15:55:00',1.23),('8902','2014-04-22','11:15:00',1.03),('8902','2014-04-22','11:20:00',1.01),('8902','2014-04-22','11:30:00',1.01),('8902','2014-04-22','11:35:00',1.14),('8902','2014-04-22','11:40:00',1.24),('8902','2014-04-22','11:45:00',1.31),('8902','2014-04-22','11:50:00',1.04),('8902','2014-04-22','12:25:00',1.03),('8902','2014-04-22','12:30:00',1.04),('8902','2014-04-22','12:35:00',1.07),('8902','2014-04-22','12:40:00',1.01),('8902','2014-04-22','12:45:00',1.05),('8902','2014-04-22','12:50:00',1.12),('8902','2014-04-22','12:55:00',1.23),('8902','2014-04-22','13:00:00',1.42),('8902','2014-04-22','13:05:00',1.73),('8902','2014-04-22','13:10:00',2.14),('8902','2014-04-22','13:15:00',2.33),('8902','2014-04-22','13:20:00',2.46),('8902','2014-04-22','13:25:00',2.54),('8902','2014-04-22','13:30:00',2.73),('8902','2014-04-22','13:35:00',2.85),('8902','2014-04-22','13:40:00',3.01),('8902','2014-04-22','13:45:00',3.04),('8902','2014-04-22','13:50:00',2.98),('8902','2014-04-22','13:55:00',2.9),('8902','2014-04-22','14:00:00',2.74),('8902','2014-04-22','14:05:00',2.83),('8902','2014-04-22','14:10:00',2.58),('8902','2014-04-22','14:15:00',2.15),('8902','2014-04-22','14:20:00',1.93),('8902','2014-04-22','14:25:00',1.78),('8902','2014-04-22','14:30:00',1.71),('8902','2014-04-22','14:35:00',1.71),('8902','2014-04-22','14:40:00',1.92),('8902','2014-04-22','14:45:00',2.35),('8902','2014-04-22','14:50:00',2.84),('8902','2014-04-22','14:55:00',3.23),('8902','2014-04-22','15:00:00',3.42),('8902','2014-04-22','15:05:00',3.46),('8902','2014-04-22','15:10:00',3.53),('8902','2014-04-22','15:15:00',3.47),('8902','2014-04-22','15:20:00',2.85),('8902','2014-04-22','15:25:00',2.71),('8902','2014-04-22','15:30:00',2.66),('8902','2014-04-22','15:35:00',2.5),('8902','2014-04-22','15:40:00',2.43),('8902','2014-04-22','15:45:00',2.27),('8902','2014-04-22','15:50:00',1.97),('8902','2014-04-22','15:55:00',1.9),('8902','2014-04-22','16:00:00',1.67),('8902','2014-04-22','16:05:00',1.6),('8902','2014-04-22','16:10:00',1.39),('8902','2014-04-22','16:15:00',1.23),('8902','2014-04-22','16:20:00',1.05),('8902','2013-12-26','09:30:00',1.04),('8902','2013-12-26','10:20:00',1.09),('8902','2013-12-26','10:25:00',1.29),('8902','2013-12-26','10:30:00',1.42),('8902','2013-12-26','10:35:00',1.44),('8902','2013-12-26','10:40:00',1.44),('8902','2013-12-26','10:45:00',1.4),('8902','2013-12-26','10:50:00',1.29),('8902','2013-12-26','10:55:00',1.14),('8902','2013-12-26','11:25:00',1.19),('8902','2013-12-26','11:30:00',1.53),('8902','2013-12-26','11:35:00',1.86),('8902','2013-12-26','11:40:00',1.74),('8902','2013-12-26','11:45:00',1.57),('8902','2013-12-26','11:50:00',1.45),('8902','2013-12-26','11:55:00',1.29),('8902','2013-12-26','12:00:00',1.27),('8902','2013-12-26','12:05:00',1.79),('8902','2013-12-26','12:10:00',2.68),('8902','2013-12-26','12:15:00',4.4),('8902','2013-12-26','12:20:00',3.34),('8902','2013-12-26','12:25:00',3.37),('8902','2013-12-26','12:30:00',2.21),('8902','2013-12-26','12:35:00',2.34),('8902','2013-12-26','12:40:00',3.23),('8902','2013-12-26','12:45:00',4.26),('8902','2013-12-26','12:50:00',4.93),('8902','2013-12-26','12:55:00',5.19),('8902','2013-12-26','13:00:00',5.22),('8902','2013-12-26','13:05:00',4.72),('8902','2013-12-26','13:10:00',2.21),('8902','2013-12-26','13:15:00',2.85),('8902','2013-12-26','13:20:00',2.56),('8902','2013-12-26','13:25:00',2.59),('8902','2013-12-26','13:30:00',4.49),('8902','2013-12-26','13:35:00',5.35),('8902','2013-12-26','13:40:00',2.96),('8902','2013-12-26','13:45:00',2.7),('8902','2013-12-26','13:50:00',2.12),('8902','2013-12-26','13:55:00',1.77),('8902','2013-12-26','14:00:00',1.62),('8902','2013-12-26','14:05:00',1.62),('8902','2013-12-26','14:10:00',1.85),('8902','2013-12-26','14:15:00',2.06),('8902','2013-12-26','14:20:00',2.2),('8902','2013-12-26','14:25:00',2.04),('8902','2013-12-26','14:30:00',2.31),('8902','2013-12-26','14:35:00',2.51),('8902','2013-12-26','14:40:00',2.63),('8902','2013-12-26','14:45:00',2.23),('8902','2013-12-26','14:50:00',1.69),('8902','2013-12-26','14:55:00',1.06),('8902','2013-12-26','15:30:00',1.01),('8902','2013-12-26','15:35:00',1.04),('8902','2013-12-25','09:55:00',1.14),('8902','2013-12-25','11:05:00',1.19),('8902','2013-12-24','09:10:00',1.13),('8902','2013-12-24','09:15:00',1.18),('8902','2013-12-24','09:20:00',1.14),('8902','2013-12-24','09:25:00',1.32),('8902','2013-12-24','09:30:00',1.32),('8902','2013-12-24','09:35:00',1.24),('8902','2013-12-24','09:40:00',1.13),('8902','2013-12-24','10:25:00',1.54),('8902','2013-12-24','10:30:00',3.02),('8902','2013-12-24','10:35:00',3.21),('8902','2013-12-24','10:40:00',3.08),('8902','2013-12-24','10:45:00',2.52),('8902','2013-12-24','10:50:00',3.16),('8902','2013-12-24','10:55:00',1.74),('8902','2013-12-24','11:00:00',1.58),('8902','2013-12-24','11:05:00',1.58),('8902','2013-12-24','11:10:00',1.78),('8902','2013-12-24','11:15:00',2.03),('8902','2013-12-24','11:20:00',3.15),('8902','2013-12-24','11:25:00',2.7),('8902','2013-12-24','11:30:00',4.49),('8902','2013-12-24','11:35:00',3.18),('8902','2013-12-24','11:40:00',3.59),('8902','2013-12-24','11:45:00',4.71),('8902','2013-12-24','11:50:00',2.76),('8902','2013-12-24','11:55:00',4.95),('8902','2013-12-24','12:00:00',4.24),('8902','2013-12-24','12:05:00',1.84),('8902','2013-12-24','12:10:00',2.16),('8902','2013-12-24','12:15:00',3.69),('8902','2013-12-24','12:20:00',4.8),('8902','2013-12-24','12:25:00',2.28),('8902','2013-12-24','12:30:00',5.1),('8902','2013-12-24','12:35:00',3.98),('8902','2013-12-24','12:40:00',2.47),('8902','2013-12-24','12:45:00',1.48),('8902','2013-12-24','12:50:00',2.78),('8902','2013-12-24','12:55:00',1.34),('8902','2013-12-24','13:05:00',1.23),('8902','2013-12-24','13:10:00',1.49),('8902','2013-12-24','13:15:00',1.19),('8902','2013-12-24','13:25:00',2.38),('8902','2013-12-24','13:30:00',2.69),('8902','2013-12-24','13:35:00',1.85),('8902','2013-12-24','13:40:00',2.14),('8902','2013-12-24','13:45:00',2.29),('8902','2013-12-24','13:50:00',2.59),('8902','2013-12-24','13:55:00',2.54),('8902','2013-12-24','14:00:00',2.06),('8902','2013-12-24','14:05:00',1.62),('8902','2013-12-24','14:10:00',1.46),('8902','2013-12-24','14:15:00',1.41),('8902','2013-12-24','14:20:00',1.29),('8902','2013-12-24','14:25:00',1.19),('8902','2013-12-24','14:30:00',1.17),('8902','2013-12-24','14:35:00',1.22),('8902','2013-12-24','14:40:00',1.2),('8902','2013-12-24','14:45:00',1.19),('8902','2013-12-24','14:50:00',1.2),('8902','2013-12-24','14:55:00',1.12),('8902','2013-12-24','15:10:00',1.15),('8902','2013-12-24','15:15:00',1.76),('8902','2013-12-24','15:20:00',1.81),('8902','2013-12-24','15:25:00',1.37),('8902','2013-12-23','08:45:00',1.02),('8902','2013-12-23','08:50:00',1.34),('8902','2013-12-23','08:55:00',1.68),('8902','2013-12-23','09:00:00',1.97),('8902','2013-12-23','09:05:00',2.17),('8902','2013-12-23','09:10:00',2.29),('8902','2013-12-23','09:15:00',2.48),('8902','2013-12-23','09:20:00',2.61),('8902','2013-12-23','09:25:00',2.74),('8902','2013-12-23','09:30:00',2.84),('8902','2013-12-23','09:35:00',3),('8902','2013-12-23','09:40:00',3.14),('8902','2013-12-23','09:45:00',3.21),('8902','2013-12-23','09:50:00',3.17),('8902','2013-12-23','09:55:00',3.17),('8902','2013-12-23','10:00:00',3.44),('8902','2013-12-23','10:05:00',3.58),('8902','2013-12-23','10:10:00',3.64),('8902','2013-12-23','10:15:00',3.92),('8902','2013-12-23','10:20:00',3.99),('8902','2013-12-23','10:25:00',4.12),('8902','2013-12-23','10:30:00',4.15),('8902','2013-12-23','10:35:00',4.23),('8902','2013-12-23','10:40:00',4.35),('8902','2013-12-23','10:45:00',4.43),('8902','2013-12-23','10:50:00',4.45),('8902','2013-12-23','10:55:00',4.51),('8902','2013-12-23','11:00:00',4.62),('8902','2013-12-23','11:05:00',4.61),('8902','2013-12-23','11:10:00',4.65),('8902','2013-12-23','11:15:00',4.71),('8902','2013-12-23','11:20:00',4.8),('8902','2013-12-23','11:25:00',4.87),('8902','2013-12-23','11:30:00',4.91),('8902','2013-12-23','11:35:00',4.95),('8902','2013-12-23','11:40:00',4.94),('8902','2013-12-23','11:45:00',4.92),('8902','2013-12-23','11:50:00',4.96),('8902','2013-12-23','11:55:00',4.92),('8902','2013-12-23','12:00:00',4.9),('8902','2013-12-23','12:05:00',4.84),('8902','2013-12-23','12:10:00',4.88),('8902','2013-12-23','12:15:00',4.92),('8902','2013-12-23','12:20:00',4.84),('8902','2013-12-23','12:25:00',4.79),('8902','2013-12-23','12:30:00',4.79),('8902','2013-12-23','12:35:00',4.78),('8902','2013-12-23','12:40:00',4.66),('8902','2013-12-23','12:45:00',4.67),('8902','2013-12-23','12:50:00',4.66),('8902','2013-12-23','12:55:00',4.62),('8902','2013-12-23','13:00:00',4.53),('8902','2013-12-23','13:05:00',4.48),('8902','2013-12-23','13:10:00',4.41),('8902','2013-12-23','13:15:00',4.38),('8902','2013-12-23','13:20:00',4.36),('8902','2013-12-23','13:25:00',4.28),('8902','2013-12-23','13:30:00',4.09),('8902','2013-12-23','13:35:00',4.06),('8902','2013-12-23','13:40:00',3.83),('8902','2013-12-23','13:45:00',3.79),('8902','2013-12-23','13:50:00',3.75),('8902','2013-12-23','13:55:00',3.69),('8902','2013-12-23','14:00:00',3.56),('8902','2013-12-23','14:05:00',3.49),('8902','2013-12-23','14:10:00',3.43),('8902','2013-12-23','14:15:00',3.35),('8902','2013-12-23','14:20:00',3.28),('8902','2013-12-23','14:25:00',3.08),('8902','2013-12-23','14:30:00',2.89),('8902','2013-12-23','14:35:00',2.68),('8902','2013-12-23','14:40:00',2.5),('8902','2013-12-23','14:45:00',2.34),('8902','2013-12-23','14:50:00',2.23),('8902','2013-12-23','14:55:00',2.04),('8902','2013-12-23','15:00:00',1.78),('8902','2013-12-23','15:05:00',1.46),('8902','2013-12-23','15:10:00',1.09),('8902','2013-12-23','15:20:00',1.11),('8902','2013-12-23','15:25:00',1.04),('8902','2013-12-23','15:30:00',1.05),('8902','2013-12-23','15:35:00',1.03),('8902','2013-12-22','09:00:00',1.07),('8902','2013-12-22','09:05:00',1.14),('8902','2013-12-22','09:10:00',1.15),('8902','2013-12-22','09:15:00',1.19),('8902','2013-12-22','09:20:00',1.32),('8902','2013-12-22','09:25:00',1.55),('8902','2013-12-22','09:30:00',1.8),('8902','2013-12-22','09:35:00',1.93),('8902','2013-12-22','09:40:00',2.06),('8902','2013-12-22','09:45:00',2.07),('8902','2013-12-22','09:50:00',2.35),('8902','2013-12-22','09:55:00',3.15),('8902','2013-12-22','10:00:00',3.59),('8902','2013-12-22','10:05:00',3.84),('8902','2013-12-22','10:10:00',3.83),('8902','2013-12-22','10:15:00',3.7),('8902','2013-12-22','10:20:00',4.15),('8902','2013-12-22','10:25:00',4.1),('8902','2013-12-22','10:30:00',3.83),('8902','2013-12-22','10:35:00',3.89),('8902','2013-12-22','10:40:00',4.12),('8902','2013-12-22','10:45:00',4.31),('8902','2013-12-22','10:50:00',3.83),('8902','2013-12-22','10:55:00',4.4),('8902','2013-12-22','11:00:00',5.05),('8902','2013-12-22','11:05:00',5.21),('8902','2013-12-22','11:10:00',5.19),('8902','2013-12-22','11:15:00',5.15),('8902','2013-12-22','11:20:00',4.98),('8902','2013-12-22','11:25:00',5.12),('8902','2013-12-22','11:30:00',5.03),('8902','2013-12-22','11:35:00',5.19),('8902','2013-12-22','11:40:00',5.26),('8902','2013-12-22','11:45:00',4.71),('8902','2013-12-22','11:50:00',4.73),('8902','2013-12-22','11:55:00',4.75),('8902','2013-12-22','12:00:00',5.13),('8902','2013-12-22','12:05:00',5.12),('8902','2013-12-22','12:10:00',5.17),('8902','2013-12-22','12:15:00',5.02),('8902','2013-12-22','12:20:00',5.07),('8902','2013-12-22','12:25:00',5.15),('8902','2013-12-22','12:30:00',5.24),('8902','2013-12-22','12:35:00',5.3),('8902','2013-12-22','12:40:00',5.28),('8902','2013-12-22','12:45:00',5.22),('8902','2013-12-22','12:50:00',5.21),('8902','2013-12-22','12:55:00',5.24),('8902','2013-12-22','13:00:00',5.17),('8902','2013-12-22','13:05:00',5.11),('8902','2013-12-22','13:10:00',5.05),('8902','2013-12-22','13:15:00',4.54),('8902','2013-12-22','13:20:00',4.15),('8902','2013-12-22','13:25:00',4.1),('8902','2013-12-22','13:30:00',4.71),('8902','2013-12-22','13:35:00',2.15),('8902','2013-12-22','13:40:00',3.38),('8902','2013-12-22','13:45:00',3.48),('8902','2013-12-22','13:50:00',3.65),('8902','2013-12-22','13:55:00',3.86),('8902','2013-12-22','14:00:00',4.3),('8902','2013-12-22','14:05:00',4.17),('8902','2013-12-22','14:10:00',4.12),('8902','2013-12-22','14:15:00',3.92),('8902','2013-12-22','14:20:00',3.72),('8902','2013-12-22','14:25:00',3.63),('8902','2013-12-22','14:30:00',3.3),('8902','2013-12-22','14:35:00',3.3),('8902','2013-12-22','14:40:00',3.19),('8902','2013-12-22','14:45:00',3.1),('8902','2013-12-22','14:50:00',2.96),('8902','2013-12-22','14:55:00',2.8),('8902','2013-12-22','15:00:00',2.71),('8902','2013-12-22','15:05:00',2.57),('8902','2013-12-22','15:10:00',2.41),('8902','2013-12-22','15:15:00',2.23),('8902','2013-12-22','15:20:00',2.02),('8902','2013-12-22','15:25:00',1.84),('8902','2013-12-22','15:30:00',1.69),('8902','2013-12-22','15:35:00',1.55),('8902','2013-12-22','15:40:00',1.39),('8902','2013-12-22','15:45:00',1.22),('8902','2013-12-22','15:50:00',1.06),('8902','2013-12-21','08:40:00',1.15),('8902','2013-12-21','08:45:00',1.26),('8902','2013-12-21','08:50:00',1.29),('8902','2013-12-21','08:55:00',1.31),('8902','2013-12-21','09:00:00',1.65),('8902','2013-12-21','09:05:00',2.14),('8902','2013-12-21','09:10:00',2.11),('8902','2013-12-21','09:15:00',2.18),('8902','2013-12-21','09:20:00',2.48),('8902','2013-12-21','09:25:00',2.41),('8902','2013-12-21','09:30:00',2.48),('8902','2013-12-21','09:35:00',3.26),('8902','2013-12-21','09:40:00',4.06),('8902','2013-12-21','09:45:00',4.21),('8902','2013-12-21','09:50:00',4.5),('8902','2013-12-21','09:55:00',4.54),('8902','2013-12-21','10:00:00',4.54),('8902','2013-12-21','10:05:00',4.61),('8902','2013-12-21','10:10:00',4.69),('8902','2013-12-21','10:15:00',4.6),('8902','2013-12-21','10:20:00',4.48),('8902','2013-12-21','10:25:00',4.49),('8902','2013-12-21','10:30:00',4.73),('8902','2013-12-21','10:35:00',4.44),('8902','2013-12-21','10:40:00',4.16),('8902','2013-12-21','10:45:00',4.41),('8902','2013-12-21','10:50:00',4.37),('8902','2013-12-21','10:55:00',4.16),('8902','2013-12-21','11:00:00',3.67),('8902','2013-12-21','11:05:00',3.88),('8902','2013-12-21','11:10:00',5.07),('8902','2013-12-21','11:15:00',4.99),('8902','2013-12-21','11:20:00',4.5),('8902','2013-12-21','11:25:00',4.66),('8902','2013-12-21','11:30:00',4.43),('8902','2013-12-21','11:35:00',4.34),('8902','2013-12-21','11:40:00',4.68),('8902','2013-12-21','11:45:00',4.4),('8902','2013-12-21','11:50:00',3.23),('8902','2013-12-21','11:55:00',2.39),('8902','2013-12-21','12:00:00',1.89),('8902','2013-12-21','12:05:00',1.7),('8902','2013-12-21','12:10:00',1.74),('8902','2013-12-21','12:15:00',1.91),('8902','2013-12-21','12:20:00',2.38),('8902','2013-12-21','12:25:00',2.49),('8902','2013-12-21','12:30:00',3.07),('8902','2013-12-21','12:35:00',3.58),('8902','2013-12-21','12:40:00',3.33),('8902','2013-12-21','12:45:00',3.27),('8902','2013-12-21','12:50:00',3.97),('8902','2013-12-21','12:55:00',5.01),('8902','2013-12-21','13:00:00',4.98),('8902','2013-12-21','13:05:00',5.78),('8902','2013-12-21','13:10:00',5.75),('8902','2013-12-21','13:15:00',4.3),('8902','2013-12-21','13:20:00',4.22),('8902','2013-12-21','13:25:00',4.23),('8902','2013-12-21','13:30:00',4.08),('8902','2013-12-21','13:35:00',3.78),('8902','2013-12-21','13:40:00',2.96),('8902','2013-12-21','13:45:00',3.65),('8902','2013-12-21','13:50:00',3.31),('8902','2013-12-21','13:55:00',3.06),('8902','2013-12-21','14:00:00',2.6),('8902','2013-12-21','14:05:00',3.02),('8902','2013-12-21','14:10:00',3.42),('8902','2013-12-21','14:15:00',2.49),('8902','2013-12-21','14:20:00',2.57),('8902','2013-12-21','14:25:00',2.25),('8902','2013-12-21','14:30:00',2.19),('8902','2013-12-21','14:35:00',2.61),('8902','2013-12-21','14:40:00',2.86),('8902','2013-12-21','14:45:00',2.73),('8902','2013-12-21','14:50:00',1.62),('8902','2013-12-21','14:55:00',1.56),('8902','2013-12-21','15:00:00',1.77),('8902','2013-12-21','15:05:00',1.61),('8902','2013-12-21','15:10:00',1.9),('8902','2013-12-21','15:15:00',1.15),('8902','2013-12-21','15:20:00',1.1),('8902','2013-12-20','08:30:00',1.16),('8902','2013-12-20','08:35:00',1.34),('8902','2013-12-20','08:40:00',1.5),('8902','2013-12-20','08:45:00',1.65),('8902','2013-12-20','08:50:00',1.84),('8902','2013-12-20','08:55:00',2.02),('8902','2013-12-20','09:00:00',2.16),('8902','2013-12-20','09:05:00',2.28),('8902','2013-12-20','09:10:00',2.39),('8902','2013-12-20','09:15:00',2.54),('8902','2013-12-20','09:20:00',2.69),('8902','2013-12-20','09:25:00',2.82),('8902','2013-12-20','09:30:00',2.95),('8902','2013-12-20','09:35:00',3.11),('8902','2013-12-20','09:40:00',3.27),('8902','2013-12-20','09:45:00',3.39),('8902','2013-12-20','09:50:00',3.54),('8902','2013-12-20','09:55:00',3.67),('8902','2013-12-20','10:00:00',3.78),('8902','2013-12-20','10:05:00',3.9),('8902','2013-12-20','10:10:00',4),('8902','2013-12-20','10:15:00',4.11),('8902','2013-12-20','10:20:00',4.2),('8902','2013-12-20','10:25:00',4.29),('8902','2013-12-20','10:30:00',4.39),('8902','2013-12-20','10:35:00',4.49),('8902','2013-12-20','10:40:00',4.57),('8902','2013-12-20','10:45:00',4.64),('8902','2013-12-20','10:50:00',4.7),('8902','2013-12-20','10:55:00',4.78),('8902','2013-12-20','11:00:00',4.87),('8902','2013-12-20','11:05:00',4.95),('8902','2013-12-20','11:10:00',5),('8902','2013-12-20','11:15:00',5.08),('8902','2013-12-20','11:20:00',5.12),('8902','2013-12-20','11:25:00',5.19),('8902','2013-12-20','11:30:00',5.26),('8902','2013-12-20','11:35:00',5.29),('8902','2013-12-20','11:40:00',5.32),('8902','2013-12-20','11:45:00',5.35),('8902','2013-12-20','11:50:00',5.38),('8902','2013-12-20','11:55:00',5.42),('8902','2013-12-20','12:00:00',5.44),('8902','2013-12-20','12:05:00',5.44),('8902','2013-12-20','12:10:00',5.45),('8902','2013-12-20','12:15:00',5.44),('8902','2013-12-20','12:20:00',5.44),('8902','2013-12-20','12:25:00',5.43),('8902','2013-12-20','12:30:00',5.44),('8902','2013-12-20','12:35:00',5.42),('8902','2013-12-20','12:40:00',5.39),('8902','2013-12-20','12:45:00',5.33),('8902','2013-12-20','12:50:00',5.34),('8902','2013-12-20','12:55:00',5.31),('8902','2013-12-20','13:00:00',5.23),('8902','2013-12-20','13:05:00',5.21),('8902','2013-12-20','13:10:00',5.15),('8902','2013-12-20','13:15:00',5.08),('8902','2013-12-20','13:20:00',4.98),('8902','2013-12-20','13:25:00',4.96),('8902','2013-12-20','13:30:00',4.87),('8902','2013-12-20','13:35:00',4.8),('8902','2013-12-20','13:40:00',4.71),('8902','2013-12-20','13:45:00',4.66),('8902','2013-12-20','13:50:00',4.58),('8902','2013-12-20','13:55:00',4.51),('8902','2013-12-20','14:00:00',4.39),('8902','2013-12-20','14:05:00',4.26),('8902','2013-12-20','14:10:00',4.15),('8902','2013-12-20','14:15:00',4.11),('8902','2013-12-20','14:20:00',4.07),('8902','2013-12-20','14:25:00',3.93),('8902','2013-12-20','14:30:00',3.82),('8902','2013-12-20','14:35:00',3.69),('8902','2013-12-20','14:40:00',3.55),('8902','2013-12-20','14:45:00',3.39),('8902','2013-12-20','14:50:00',3.22),('8902','2013-12-20','14:55:00',3.08),('8902','2013-12-20','15:00:00',2.92),('8902','2013-12-20','15:05:00',2.74),('8902','2013-12-20','15:10:00',2.6),('8902','2013-12-20','15:15:00',2.46),('8902','2013-12-20','15:20:00',2.31),('8902','2013-12-20','15:25:00',2.14),('8902','2013-12-20','15:30:00',1.96),('8902','2013-12-20','15:35:00',1.77),('8902','2013-12-20','15:40:00',1.58),('8902','2013-12-20','15:45:00',1.41),('8902','2013-12-20','15:50:00',1.24),('8902','2013-12-20','15:55:00',1.06),('8902','2013-12-19','08:20:00',1.04),('8902','2013-12-19','08:25:00',1.11),('8902','2013-12-19','08:30:00',1.19),('8902','2013-12-19','08:35:00',1.29),('8902','2013-12-19','08:40:00',1.48),('8902','2013-12-19','08:45:00',1.63),('8902','2013-12-19','08:50:00',1.74),('8902','2013-12-19','08:55:00',1.84),('8902','2013-12-19','09:00:00',1.95),('8902','2013-12-19','09:05:00',2.15),('8902','2013-12-19','09:10:00',2.33),('8902','2013-12-19','09:15:00',2.48),('8902','2013-12-19','09:20:00',2.63),('8902','2013-12-19','09:25:00',2.79),('8902','2013-12-19','09:30:00',2.93),('8902','2013-12-19','09:35:00',3.06),('8902','2013-12-19','09:40:00',3.19),('8902','2013-12-19','09:45:00',3.31),('8902','2013-12-19','09:50:00',3.44),('8902','2013-12-19','09:55:00',3.52),('8902','2013-12-19','10:00:00',3.62),('8902','2013-12-19','10:05:00',3.78),('8902','2013-12-19','10:10:00',3.86),('8902','2013-12-19','10:15:00',3.92),('8902','2013-12-19','10:20:00',4.02),('8902','2013-12-19','10:25:00',4.14),('8902','2013-12-19','10:30:00',4.19),('8902','2013-12-19','10:35:00',4.26),('8902','2013-12-19','10:40:00',4.39),('8902','2013-12-19','10:45:00',4.48),('8902','2013-12-19','10:50:00',4.52),('8902','2013-12-19','10:55:00',4.61),('8902','2013-12-19','11:00:00',4.67),('8902','2013-12-19','11:05:00',4.73),('8902','2013-12-19','11:10:00',4.76),('8902','2013-12-19','11:15:00',4.82),('8902','2013-12-19','11:20:00',4.88),('8902','2013-12-19','11:25:00',4.94),('8902','2013-12-19','11:30:00',5.01),('8902','2013-12-19','11:35:00',5.01),('8902','2013-12-19','11:40:00',5.06),('8902','2013-12-19','11:45:00',5.09),('8902','2013-12-19','11:50:00',5.06),('8902','2013-12-19','11:55:00',5.14),('8902','2013-12-19','12:00:00',5.14),('8902','2013-12-19','12:05:00',5.09),('8902','2013-12-19','12:10:00',5.15),('8902','2013-12-19','12:15:00',5.13),('8902','2013-12-19','12:20:00',5.11),('8902','2013-12-19','12:25:00',5.07),('8902','2013-12-19','12:30:00',5.13),('8902','2013-12-19','12:35:00',5.07),('8902','2013-12-19','12:40:00',5),('8902','2013-12-19','12:45:00',4.99),('8902','2013-12-19','12:50:00',4.9),('8902','2013-12-19','12:55:00',4.85),('8902','2013-12-19','13:00:00',4.86),('8902','2013-12-19','13:05:00',4.85),('8902','2013-12-19','13:10:00',4.8),('8902','2013-12-19','13:15:00',4.71),('8902','2013-12-19','13:20:00',4.5),('8902','2013-12-19','13:25:00',4.46),('8902','2013-12-19','13:30:00',4.34),('8902','2013-12-19','13:35:00',4.37),('8902','2013-12-19','13:40:00',4.14),('8902','2013-12-19','13:45:00',4.08),('8902','2013-12-19','13:50:00',4.07),('8902','2013-12-19','13:55:00',3.82),('8902','2013-12-19','14:00:00',3.71),('8902','2013-12-19','14:05:00',1.7),('8902','2013-12-19','14:10:00',1.05),('8902','2013-12-19','14:30:00',1.07),('8902','2013-12-19','14:35:00',1.15),('8902','2013-12-19','14:40:00',1.3),('8902','2013-12-19','14:45:00',1.11),('8902','2013-12-19','14:50:00',1.15),('8902','2013-12-18','08:45:00',1.05),('8902','2013-12-18','08:50:00',1.79),('8902','2013-12-18','08:55:00',2.03),('8902','2013-12-18','09:00:00',2.35),('8902','2013-12-18','09:05:00',2.65),('8902','2013-12-18','09:10:00',2.61),('8902','2013-12-18','09:15:00',2.14),('8902','2013-12-18','09:20:00',2.98),('8902','2013-12-18','09:25:00',3.3),('8902','2013-12-18','09:30:00',3),('8902','2013-12-18','09:35:00',3.48),('8902','2013-12-18','09:40:00',2.51),('8902','2013-12-18','09:45:00',1.91),('8902','2013-12-18','09:50:00',3.14),('8902','2013-12-18','09:55:00',4.32),('8902','2013-12-18','10:00:00',4.04),('8902','2013-12-18','10:05:00',3.82),('8902','2013-12-18','10:10:00',4.01),('8902','2013-12-18','10:15:00',4.07),('8902','2013-12-18','10:20:00',2.71),('8902','2013-12-18','10:25:00',1.54),('8902','2013-12-18','10:30:00',2.1),('8902','2013-12-18','10:35:00',1.81),('8902','2013-12-18','10:40:00',2.24),('8902','2013-12-18','10:45:00',2.95),('8902','2013-12-18','10:50:00',5),('8902','2013-12-18','10:55:00',3.6),('8902','2013-12-18','11:00:00',1.33),('8902','2013-12-18','11:05:00',1.24),('8902','2013-12-18','11:10:00',1.38),('8902','2013-12-18','11:15:00',3.2),('8902','2013-12-18','11:20:00',2.44),('8902','2013-12-18','11:25:00',1.89),('8902','2013-12-18','11:30:00',1.34),('8902','2013-12-18','11:35:00',1.14),('8902','2013-12-18','12:30:00',1.01),('8902','2013-12-18','12:35:00',1.17),('8902','2013-12-18','12:40:00',1.38),('8902','2013-12-18','12:45:00',1.42),('8902','2013-12-18','12:50:00',1.26),('8902','2013-12-18','12:55:00',1.14),('8902','2013-12-18','13:00:00',1.13),('8902','2013-12-18','13:05:00',1.04),('8902','2013-12-18','13:45:00',1),('8902','2013-12-18','13:50:00',1.07),('8902','2013-12-18','13:55:00',1.18),('8902','2013-12-18','14:00:00',1.39),('8902','2013-12-18','14:05:00',1.47),('8902','2013-12-18','14:10:00',1.47),('8902','2013-12-18','14:15:00',1.34),('8902','2013-12-18','14:20:00',2.22),('8902','2013-12-18','14:25:00',2.68),('8902','2013-12-18','14:30:00',3.79),('8902','2013-12-18','14:35:00',3.36),('8902','2013-12-18','14:40:00',3.29),('8902','2013-12-18','14:45:00',3.1),('8902','2013-12-18','14:50:00',1.48),('8902','2013-12-18','14:55:00',1.07),('8902','2013-12-17','08:25:00',1),('8902','2013-12-17','08:30:00',1.2),('8902','2013-12-17','08:35:00',1.42),('8902','2013-12-17','08:40:00',1.59),('8902','2013-12-17','08:45:00',1.79),('8902','2013-12-17','08:50:00',1.93),('8902','2013-12-17','08:55:00',2.11),('8902','2013-12-17','09:00:00',2.25),('8902','2013-12-17','09:05:00',2.37),('8902','2013-12-17','09:10:00',2.56),('8902','2013-12-17','09:15:00',2.69),('8902','2013-12-17','09:20:00',2.83),('8902','2013-12-17','09:25:00',2.98),('8902','2013-12-17','09:30:00',3.12),('8902','2013-12-17','09:35:00',3.24),('8902','2013-12-17','09:40:00',3.39),('8902','2013-12-17','09:45:00',3.55),('8902','2013-12-17','09:50:00',3.67),('8902','2013-12-17','09:55:00',3.8),('8902','2013-12-17','10:00:00',3.91),('8902','2013-12-17','10:05:00',4.02),('8902','2013-12-17','10:10:00',4.14),('8902','2013-12-17','10:15:00',4.27),('8902','2013-12-17','10:20:00',4.37),('8902','2013-12-17','10:25:00',4.46),('8902','2013-12-17','10:30:00',4.56),('8902','2013-12-17','10:35:00',4.64),('8902','2013-12-17','10:40:00',4.71),('8902','2013-12-17','10:45:00',4.75),('8902','2013-12-17','10:50:00',4.81),('8902','2013-12-17','10:55:00',4.87),('8902','2013-12-17','11:00:00',4.94),('8902','2013-12-17','11:05:00',5.01),('8902','2013-12-17','11:10:00',5.07),('8902','2013-12-17','11:15:00',5.13),('8902','2013-12-17','11:20:00',5.12),('8902','2013-12-17','11:25:00',5.16),('8902','2013-12-17','11:30:00',5.15),('8902','2013-12-17','11:35:00',5.22),('8902','2013-12-17','11:40:00',5.26),('8902','2013-12-17','11:45:00',5.26),('8902','2013-12-17','11:50:00',5.27),('8902','2013-12-17','11:55:00',5.28),('8902','2013-12-17','12:00:00',5.28),('8902','2013-12-17','12:05:00',5.28),('8902','2013-12-17','12:10:00',5.29),('8902','2013-12-17','12:15:00',5.29),('8902','2013-12-17','12:20:00',5.34),('8902','2013-12-17','12:25:00',5.31),('8902','2013-12-17','12:30:00',5.32),('8902','2013-12-17','12:35:00',5.28),('8902','2013-12-17','12:40:00',5.24),('8902','2013-12-17','12:45:00',5.17),('8902','2013-12-17','12:50:00',5.15),('8902','2013-12-17','12:55:00',5.2),('8902','2013-12-17','13:00:00',5.15),('8902','2013-12-17','13:05:00',5.06),('8902','2013-12-17','13:10:00',4.92),('8902','2013-12-17','13:15:00',4.89),('8902','2013-12-17','13:20:00',4.81),('8902','2013-12-17','13:25:00',4.8),('8902','2013-12-17','13:30:00',4.71),('8902','2013-12-17','13:35:00',4.65),('8902','2013-12-17','13:40:00',4.55),('8902','2013-12-17','13:45:00',4.45),('8902','2013-12-17','13:50:00',4.31),('8902','2013-12-17','13:55:00',4.15),('8902','2013-12-17','14:00:00',4.14),('8902','2013-12-17','14:05:00',4.01),('8902','2013-12-17','14:10:00',3.86),('8902','2013-12-17','14:15:00',3.77),('8902','2013-12-17','14:20:00',3.78),('8902','2013-12-17','14:25:00',3.64),('8902','2013-12-17','14:30:00',3.58),('8902','2013-12-17','14:35:00',3.49),('8902','2013-12-17','14:40:00',3.36),('8902','2013-12-17','14:45:00',3.21),('8902','2013-12-17','14:50:00',3.06),('8902','2013-12-17','14:55:00',2.97),('8902','2013-12-17','15:00:00',2.83),('8902','2013-12-17','15:05:00',2.67),('8902','2013-12-17','15:10:00',2.52),('8902','2013-12-17','15:15:00',2.39),('8902','2013-12-17','15:20:00',2.25),('8902','2013-12-17','15:25:00',2.03),('8902','2013-12-17','15:30:00',1.89),('8902','2013-12-17','15:35:00',1.72),('8902','2013-12-17','15:40:00',1.52),('8902','2013-12-17','15:45:00',1.34),('8902','2013-12-17','15:50:00',1.04),('8902','2014-04-21','07:45:00',1.13),('8902','2014-04-21','07:50:00',1.38),('8902','2014-04-21','07:55:00',1.54),('8902','2014-04-21','08:00:00',1.68),('8902','2014-04-21','08:05:00',1.83),('8902','2014-04-21','08:10:00',2),('8902','2014-04-21','08:15:00',2.17),('8902','2014-04-21','08:20:00',2.35),('8902','2014-04-21','08:25:00',2.52),('8902','2014-04-21','08:30:00',2.74),('8902','2014-04-21','08:35:00',2.91),('8902','2014-04-21','08:40:00',3.13),('8902','2014-04-21','08:45:00',3.24),('8902','2014-04-21','08:50:00',3.45),('8902','2014-04-21','08:55:00',3.53),('8902','2014-04-21','09:00:00',3.66),('8902','2014-04-21','09:05:00',4.11),('8902','2014-04-21','09:10:00',3.99),('8902','2014-04-21','09:15:00',3.84),('8902','2014-04-21','09:20:00',4.31),('8902','2014-04-21','09:25:00',4.61),('8902','2014-04-21','09:30:00',4.79),('8902','2014-04-21','09:35:00',5.07),('8902','2014-04-21','09:40:00',4.95),('8902','2014-04-21','09:45:00',5.32),('8902','2014-04-21','09:50:00',4.67),('8902','2014-04-21','09:55:00',2.79),('8902','2014-04-21','10:00:00',2.58),('8902','2014-04-21','10:05:00',2.74),('8902','2014-04-21','10:10:00',3.48),('8902','2014-04-21','10:15:00',4.03),('8902','2014-04-21','10:20:00',5.81),('8902','2014-04-21','10:25:00',4.15),('8902','2014-04-21','10:30:00',6.46),('8902','2014-04-21','10:35:00',6.94),('8902','2014-04-21','10:40:00',6.4),('8902','2014-04-21','10:45:00',6.56),('8902','2014-04-21','10:50:00',7.02),('8902','2014-04-21','10:55:00',5.89),('8902','2014-04-21','11:00:00',3.73),('8902','2014-04-21','11:05:00',4.65),('8902','2014-04-21','11:10:00',3.19),('8902','2014-04-21','11:15:00',2.64),('8902','2014-04-21','11:20:00',2.28),('8902','2014-04-21','11:25:00',2.36),('8902','2014-04-21','11:30:00',2.1),('8902','2014-04-21','11:35:00',2.22),('8902','2014-04-21','11:40:00',2.05),('8902','2014-04-21','11:45:00',1.73),('8902','2014-04-21','11:50:00',1.7),('8902','2014-04-21','11:55:00',1.6),('8902','2014-04-21','12:00:00',1.78),('8902','2014-04-21','12:05:00',2.19),('8902','2014-04-21','12:10:00',2.29),('8902','2014-04-21','12:15:00',2.33),('8902','2014-04-21','12:20:00',2.46),('8902','2014-04-21','12:25:00',2.64),('8902','2014-04-21','12:30:00',3.07),('8902','2014-04-21','12:35:00',2.72),('8902','2014-04-21','12:40:00',2),('8902','2014-04-21','12:45:00',1.64),('8902','2014-04-21','12:50:00',1.41),('8902','2014-04-21','12:55:00',1.33),('8902','2014-04-21','13:00:00',1.31),('8902','2014-04-21','13:05:00',1.42),('8902','2014-04-21','13:10:00',1.69),('8902','2014-04-21','13:15:00',2.63),('8902','2014-04-21','13:20:00',4.48),('8902','2014-04-21','13:25:00',5.12),('8902','2014-04-21','13:30:00',5.75),('8902','2014-04-21','13:35:00',5.08),('8902','2014-04-21','13:40:00',6.48),('8902','2014-04-21','13:45:00',6.59),('8902','2014-04-21','13:50:00',5.59),('8902','2014-04-21','13:55:00',3.03),('8902','2014-04-21','14:00:00',2.6),('8902','2014-04-21','14:05:00',3.02),('8902','2014-04-21','14:10:00',6.58),('8902','2014-04-21','14:15:00',6.75),('8902','2014-04-21','14:20:00',7.57),('8902','2014-04-21','14:25:00',5.29),('8902','2014-04-21','14:30:00',3.92),('8902','2014-04-21','14:35:00',4.62),('8902','2014-04-21','14:40:00',6.24),('8902','2014-04-21','14:45:00',7.99),('8902','2014-04-21','14:50:00',6.25),('8902','2014-04-21','14:55:00',5.48),('8902','2014-04-21','15:00:00',2.55),('8902','2014-04-21','15:05:00',2.47),('8902','2014-04-21','15:10:00',2.23),('8902','2014-04-21','15:15:00',2.17),('8902','2014-04-21','15:20:00',2.42),('8902','2014-04-21','15:25:00',2.83),('8902','2014-04-21','15:30:00',3.4),('8902','2014-04-21','15:35:00',5.11),('8902','2014-04-21','15:40:00',4.6),('8902','2014-04-21','15:45:00',3.55),('8902','2014-04-21','15:50:00',4.29),('8902','2014-04-21','15:55:00',3.5),('8902','2014-04-21','16:00:00',4.14),('8902','2014-04-21','16:05:00',2.88),('8902','2014-04-21','16:10:00',2.71),('8902','2014-04-21','16:15:00',2.6),('8902','2014-04-21','16:20:00',3.19),('8902','2014-04-21','16:25:00',2.92),('8902','2014-04-21','16:30:00',2.44),('8902','2014-04-21','16:35:00',2.41),('8902','2014-04-21','16:40:00',3.37),('8902','2014-04-21','16:45:00',3.38),('8902','2014-04-21','16:50:00',2.54),('8902','2014-04-21','16:55:00',2.18),('8902','2014-04-21','17:00:00',2.33),('8902','2014-04-21','17:05:00',2.68),('8902','2014-04-21','17:10:00',2.14),('8902','2014-04-21','17:15:00',1.93),('8902','2014-04-21','17:20:00',1.45),('8902','2014-04-21','17:25:00',1.23),('8902','2014-04-21','17:30:00',1.15),('8902','2014-04-21','17:35:00',1.3),('8902','2014-04-21','17:40:00',1.29),('8902','2014-04-21','17:45:00',1.16),('8902','2014-04-21','17:50:00',1.09),('8902','2013-12-16','08:30:00',1.22),('8902','2013-12-16','08:35:00',1.51),('8902','2013-12-16','08:40:00',1.69),('8902','2013-12-16','08:45:00',1.9),('8902','2013-12-16','08:50:00',2.07),('8902','2013-12-16','08:55:00',2.25),('8902','2013-12-16','09:00:00',2.41),('8902','2013-12-16','09:05:00',2.59),('8902','2013-12-16','09:10:00',2.76),('8902','2013-12-16','09:15:00',2.91),('8902','2013-12-16','09:20:00',3.05),('8902','2013-12-16','09:25:00',3.18),('8902','2013-12-16','09:30:00',3.31),('8902','2013-12-16','09:35:00',3.46),('8902','2013-12-16','09:40:00',3.58),('8902','2013-12-16','09:45:00',3.72),('8902','2013-12-16','09:50:00',3.84),('8902','2013-12-16','09:55:00',3.98),('8902','2013-12-16','10:00:00',4.1),('8902','2013-12-16','10:05:00',4.21),('8902','2013-12-16','10:10:00',4.32),('8902','2013-12-16','10:15:00',4.42),('8902','2013-12-16','10:20:00',4.53),('8902','2013-12-16','10:25:00',4.66),('8902','2013-12-16','10:30:00',4.77),('8902','2013-12-16','10:35:00',4.82),('8902','2013-12-16','10:40:00',4.91),('8902','2013-12-16','10:45:00',5.01),('8902','2013-12-16','10:50:00',5.02),('8902','2013-12-16','10:55:00',5.1),('8902','2013-12-16','11:00:00',5.17),('8902','2013-12-16','11:05:00',5.22),('8902','2013-12-16','11:10:00',5.28),('8902','2013-12-16','11:15:00',5.32),('8902','2013-12-16','11:20:00',5.36),('8902','2013-12-16','11:25:00',5.39),('8902','2013-12-16','11:30:00',5.44),('8902','2013-12-16','11:35:00',5.47),('8902','2013-12-16','11:40:00',5.52),('8902','2013-12-16','11:45:00',5.57),('8902','2013-12-16','11:50:00',5.64),('8902','2013-12-16','11:55:00',5.59),('8902','2013-12-16','12:00:00',5.6),('8902','2013-12-16','12:05:00',5.62),('8902','2013-12-16','12:10:00',5.61),('8902','2013-12-16','12:15:00',5.58),('8902','2013-12-16','12:20:00',5.6),('8902','2013-12-16','12:25:00',5.57),('8902','2013-12-16','12:30:00',5.57),('8902','2013-12-16','12:35:00',5.54),('8902','2013-12-16','12:40:00',5.56),('8902','2013-12-16','12:45:00',5.51),('8902','2013-12-16','12:50:00',5.45),('8902','2013-12-16','12:55:00',5.42),('8902','2013-12-16','13:00:00',5.39),('8902','2013-12-16','13:05:00',5.32),('8902','2013-12-16','13:10:00',5.24),('8902','2013-12-16','13:15:00',5.17),('8902','2013-12-16','13:20:00',5.08),('8902','2013-12-16','13:25:00',5.02),('8902','2013-12-16','13:30:00',4.98),('8902','2013-12-16','13:35:00',4.96),('8902','2013-12-16','13:40:00',4.91),('8902','2013-12-16','13:45:00',4.8),('8902','2013-12-16','13:50:00',4.69),('8902','2013-12-16','13:55:00',4.62),('8902','2013-12-16','14:00:00',4.52),('8902','2013-12-16','14:05:00',4.39),('8902','2013-12-16','14:10:00',4.28),('8902','2013-12-16','14:15:00',4.15),('8902','2013-12-16','14:20:00',4.03),('8902','2013-12-16','14:25:00',3.91),('8902','2013-12-16','14:30:00',3.81),('8902','2013-12-16','14:35:00',3.72),('8902','2013-12-16','14:40:00',3.56),('8902','2013-12-16','14:45:00',3.38),('8902','2013-12-16','14:50:00',3.26),('8902','2013-12-16','14:55:00',3.22),('8902','2013-12-16','15:00:00',3.07),('8902','2013-12-16','15:05:00',2.91),('8902','2013-12-16','15:10:00',2.79),('8902','2013-12-16','15:15:00',2.62),('8902','2013-12-16','15:20:00',2.46),('8902','2013-12-16','15:25:00',2.31),('8902','2013-12-16','15:30:00',2.1),('8902','2013-12-16','15:35:00',1.91),('8902','2013-12-16','15:40:00',1.74),('8902','2013-12-16','15:45:00',1.56),('8902','2013-12-16','15:50:00',1.38),('8902','2013-12-16','15:55:00',1.21),('8902','2013-12-16','16:00:00',1.02),('8902','2013-12-15','08:25:00',1.06),('8902','2013-12-15','08:30:00',1.26),('8902','2013-12-15','08:35:00',1.58),('8902','2013-12-15','08:40:00',1.75),('8902','2013-12-15','08:45:00',1.92),('8902','2013-12-15','08:50:00',2.07),('8902','2013-12-15','08:55:00',2.21),('8902','2013-12-15','09:00:00',2.36),('8902','2013-12-15','09:05:00',2.55),('8902','2013-12-15','09:10:00',2.73),('8902','2013-12-15','09:15:00',2.87),('8902','2013-12-15','09:20:00',3),('8902','2013-12-15','09:25:00',3.16),('8902','2013-12-15','09:30:00',3.3),('8902','2013-12-15','09:35:00',3.45),('8902','2013-12-15','09:40:00',3.59),('8902','2013-12-15','09:45:00',3.73),('8902','2013-12-15','09:50:00',3.84),('8902','2013-12-15','09:55:00',3.95),('8902','2013-12-15','10:00:00',4.04),('8902','2013-12-15','10:05:00',4.16),('8902','2013-12-15','10:10:00',4.25),('8902','2013-12-15','10:15:00',4.35),('8902','2013-12-15','10:20:00',4.39),('8902','2013-12-15','10:25:00',4.45),('8902','2013-12-15','10:30:00',4.53),('8902','2013-12-15','10:35:00',4.6),('8902','2013-12-15','10:40:00',4.67),('8902','2013-12-15','10:45:00',4.76),('8902','2013-12-15','10:50:00',4.83),('8902','2013-12-15','10:55:00',4.92),('8902','2013-12-15','11:00:00',5),('8902','2013-12-15','11:05:00',5.06),('8902','2013-12-15','11:10:00',5.07),('8902','2013-12-15','11:15:00',5.1),('8902','2013-12-15','11:20:00',5.12),('8902','2013-12-15','11:25:00',5.17),('8902','2013-12-15','11:30:00',5.25),('8902','2013-12-15','11:35:00',5.28),('8902','2013-12-15','11:40:00',5.34),('8902','2013-12-15','11:45:00',5.33),('8902','2013-12-15','11:50:00',5.36),('8902','2013-12-15','11:55:00',5.42),('8902','2013-12-15','12:00:00',5.49),('8902','2013-12-15','12:05:00',5.51),('8902','2013-12-15','12:10:00',5.51),('8902','2013-12-15','12:15:00',5.54),('8902','2013-12-15','12:20:00',5.59),('8902','2013-12-15','12:25:00',5.56),('8902','2013-12-15','12:30:00',5.54),('8902','2013-12-15','12:35:00',5.49),('8902','2013-12-15','12:40:00',5.49),('8902','2013-12-15','12:45:00',5.46),('8902','2013-12-15','12:50:00',5.44),('8902','2013-12-15','12:55:00',5.41),('8902','2013-12-15','13:00:00',5.4),('8902','2013-12-15','13:05:00',5.34),('8902','2013-12-15','13:10:00',5.26),('8902','2013-12-15','13:15:00',5.16),('8902','2013-12-15','13:20:00',5.04),('8902','2013-12-15','13:25:00',4.96),('8902','2013-12-15','13:30:00',4.91),('8902','2013-12-15','13:35:00',4.81),('8902','2013-12-15','13:40:00',4.74),('8902','2013-12-15','13:45:00',4.7),('8902','2013-12-15','13:50:00',4.65),('8902','2013-12-15','13:55:00',4.56),('8902','2013-12-15','14:00:00',4.37),('8902','2013-12-15','14:05:00',4.31),('8902','2013-12-15','14:10:00',4.2),('8902','2013-12-15','14:15:00',4.09),('8902','2013-12-15','14:20:00',4),('8902','2013-12-15','14:25:00',3.89),('8902','2013-12-15','14:30:00',3.75),('8902','2013-12-15','14:35:00',3.65),('8902','2013-12-15','14:40:00',3.51),('8902','2013-12-15','14:45:00',3.36),('8902','2013-12-15','14:50:00',3.22),('8902','2013-12-15','14:55:00',3.08),('8902','2013-12-15','15:00:00',2.94),('8902','2013-12-15','15:05:00',2.72),('8902','2013-12-15','15:10:00',2.57),('8902','2013-12-15','15:15:00',2.46),('8902','2013-12-15','15:20:00',2.34),('8902','2013-12-15','15:25:00',2.19),('8902','2013-12-15','15:30:00',2),('8902','2013-12-15','15:35:00',1.79),('8902','2013-12-15','15:40:00',1.57),('8902','2013-12-15','15:45:00',1.41),('8902','2013-12-15','15:50:00',1.23),('8902','2013-12-15','15:55:00',1.05),('8902','2013-12-14','09:45:00',1.12),('8902','2013-12-14','09:50:00',1.3),('8902','2013-12-14','09:55:00',1.33),('8902','2013-12-14','10:00:00',1.33),('8902','2013-12-14','10:05:00',1.34),('8902','2013-12-14','10:10:00',1.4),('8902','2013-12-14','10:15:00',1.52),('8902','2013-12-14','10:20:00',2.62),('8902','2013-12-14','10:25:00',2.41),('8902','2013-12-14','10:30:00',2.12),('8902','2013-12-14','10:35:00',2.38),('8902','2013-12-14','10:40:00',2.38),('8902','2013-12-14','10:45:00',2.42),('8902','2013-12-14','10:50:00',1.91),('8902','2013-12-14','10:55:00',1.53),('8902','2013-12-14','11:00:00',1.51),('8902','2013-12-14','11:05:00',1.47),('8902','2013-12-14','11:10:00',1.43),('8902','2013-12-14','11:15:00',1.44),('8902','2013-12-14','11:20:00',1.62),('8902','2013-12-14','11:25:00',1.64),('8902','2013-12-14','11:30:00',1.61),('8902','2013-12-14','11:35:00',1.66),('8902','2013-12-14','11:40:00',1.72),('8902','2013-12-14','11:45:00',1.78),('8902','2013-12-14','11:50:00',1.73),('8902','2013-12-14','11:55:00',1.73),('8902','2013-12-14','12:00:00',1.75),('8902','2013-12-14','12:05:00',1.79),('8902','2013-12-14','12:10:00',1.65),('8902','2013-12-14','12:15:00',1.52),('8902','2013-12-14','12:20:00',1.66),('8902','2013-12-14','12:25:00',1.35),('8902','2013-12-14','12:40:00',1.09),('8902','2013-12-14','12:45:00',1.27),('8902','2013-12-14','12:50:00',1.31),('8902','2013-12-14','12:55:00',1.03),('8902','2013-12-13','08:25:00',1.01),('8902','2013-12-13','08:30:00',1.14),('8902','2013-12-13','08:35:00',1.43),('8902','2013-12-13','08:40:00',1.59),('8902','2013-12-13','08:45:00',1.75),('8902','2013-12-13','08:50:00',1.97),('8902','2013-12-13','08:55:00',2.16),('8902','2013-12-13','09:00:00',2.34),('8902','2013-12-13','09:05:00',2.51),('8902','2013-12-13','09:10:00',2.69),('8902','2013-12-13','09:15:00',2.85),('8902','2013-12-13','09:20:00',2.98),('8902','2013-12-13','09:25:00',3.12),('8902','2013-12-13','09:30:00',3.26),('8902','2013-12-13','09:35:00',3.36),('8902','2013-12-13','09:40:00',3.49),('8902','2013-12-13','09:45:00',3.6),('8902','2013-12-13','09:50:00',3.72),('8902','2013-12-13','09:55:00',3.83),('8902','2013-12-13','10:00:00',3.93),('8902','2013-12-13','10:05:00',4.03),('8902','2013-12-13','10:10:00',4.15),('8902','2013-12-13','10:15:00',4.25),('8902','2013-12-13','10:20:00',4.38),('8902','2013-12-13','10:25:00',4.44),('8902','2013-12-13','10:30:00',4.5),('8902','2013-12-13','10:35:00',4.59),('8902','2013-12-13','10:40:00',4.66),('8902','2013-12-13','10:45:00',4.71),('8902','2013-12-13','10:50:00',4.73),('8902','2013-12-13','10:55:00',4.77),('8902','2013-12-13','11:00:00',4.82),('8902','2013-12-13','11:05:00',4.9),('8902','2013-12-13','11:10:00',4.92),('8902','2013-12-13','11:15:00',5.05),('8902','2013-12-13','11:20:00',5.06),('8902','2013-12-13','11:25:00',5.16),('8902','2013-12-13','11:30:00',5.16),('8902','2013-12-13','11:35:00',5.13),('8902','2013-12-13','11:40:00',5.11),('8902','2013-12-13','11:45:00',5.11),('8902','2013-12-13','11:50:00',5.08),('8902','2013-12-13','11:55:00',5.11),('8902','2013-12-13','12:00:00',5.05),('8902','2013-12-13','12:05:00',5.05),('8902','2013-12-13','12:10:00',5.03),('8902','2013-12-13','12:15:00',5.1),('8902','2013-12-13','12:20:00',5.11),('8902','2013-12-13','12:25:00',5.03),('8902','2013-12-13','12:30:00',4.87),('8902','2013-12-13','12:35:00',5.01),('8902','2013-12-13','12:40:00',5.02),('8902','2013-12-13','12:45:00',4.96),('8902','2013-12-13','12:50:00',5.1),('8902','2013-12-13','12:55:00',5.01),('8902','2013-12-13','13:00:00',4.91),('8902','2013-12-13','13:05:00',4.87),('8902','2013-12-13','13:10:00',4.92),('8902','2013-12-13','13:15:00',4.86),('8902','2013-12-13','13:20:00',4.82),('8902','2013-12-13','13:25:00',4.84),('8902','2013-12-13','13:30:00',4.76),('8902','2013-12-13','13:35:00',4.66),('8902','2013-12-13','13:40:00',4.58),('8902','2013-12-13','13:45:00',4.65),('8902','2013-12-13','13:50:00',4.51),('8902','2013-12-13','13:55:00',4.39),('8902','2013-12-13','14:00:00',4.31),('8902','2013-12-13','14:05:00',4.22),('8902','2013-12-13','14:10:00',4.16),('8902','2013-12-13','14:15:00',4.04),('8902','2013-12-13','14:20:00',3.9),('8902','2013-12-13','14:25:00',3.78),('8902','2013-12-13','14:30:00',3.67),('8902','2013-12-13','14:35:00',3.55),('8902','2013-12-13','14:40:00',3.39),('8902','2013-12-13','14:45:00',3.26),('8902','2013-12-13','14:50:00',3.07),('8902','2013-12-13','14:55:00',2.83),('8902','2013-12-13','15:00:00',2.68),('8902','2013-12-13','15:05:00',2.58),('8902','2013-12-13','15:10:00',2.41),('8902','2013-12-13','15:15:00',2.32),('8902','2013-12-13','15:20:00',2.2),('8902','2013-12-13','15:25:00',2.06),('8902','2013-12-13','15:30:00',1.89),('8902','2013-12-13','15:35:00',1.73),('8902','2013-12-13','15:40:00',1.57),('8902','2013-12-13','15:45:00',1.37),('8902','2013-12-13','15:50:00',1.22),('8902','2013-12-13','15:55:00',1.04),('8902','2013-12-12','08:30:00',1.17),('8902','2013-12-12','08:35:00',1.36),('8902','2013-12-12','08:40:00',1.53),('8902','2013-12-12','08:45:00',1.68),('8902','2013-12-12','08:50:00',1.86),('8902','2013-12-12','08:55:00',2.03),('8902','2013-12-12','09:00:00',2.19),('8902','2013-12-12','09:05:00',2.29),('8902','2013-12-12','09:10:00',2.44),('8902','2013-12-12','09:15:00',2.6),('8902','2013-12-12','09:20:00',2.73),('8902','2013-12-12','09:25:00',2.84),('8902','2013-12-12','09:30:00',2.93),('8902','2013-12-12','09:35:00',3.02),('8902','2013-12-12','09:40:00',3.18),('8902','2013-12-12','09:45:00',3.32),('8902','2013-12-12','09:50:00',3.44),('8902','2013-12-12','09:55:00',3.55),('8902','2013-12-12','10:00:00',3.65),('8902','2013-12-12','10:05:00',3.76),('8902','2013-12-12','10:10:00',3.84),('8902','2013-12-12','10:15:00',3.94),('8902','2013-12-12','10:20:00',4.01),('8902','2013-12-12','10:25:00',4.07),('8902','2013-12-12','10:30:00',4.21),('8902','2013-12-12','10:35:00',4.29),('8902','2013-12-12','10:40:00',4.35),('8902','2013-12-12','10:45:00',4.44),('8902','2013-12-12','10:50:00',4.53),('8902','2013-12-12','10:55:00',4.62),('8902','2013-12-12','11:00:00',4.64),('8902','2013-12-12','11:05:00',4.72),('8902','2013-12-12','11:10:00',4.71),('8902','2013-12-12','11:15:00',4.85),('8902','2013-12-12','11:20:00',4.9),('8902','2013-12-12','11:25:00',4.9),('8902','2013-12-12','11:30:00',4.94),('8902','2013-12-12','11:35:00',4.96),('8902','2013-12-12','11:40:00',5.04),('8902','2013-12-12','11:45:00',4.98),('8902','2013-12-12','11:50:00',4.98),('8902','2013-12-12','11:55:00',5.04),('8902','2013-12-12','12:00:00',5.01),('8902','2013-12-12','12:05:00',5.02),('8902','2013-12-12','12:10:00',5.05),('8902','2013-12-12','12:15:00',4.95),('8902','2013-12-12','12:20:00',4.93),('8902','2013-12-12','12:25:00',4.99),('8902','2013-12-12','12:30:00',4.94),('8902','2013-12-12','12:35:00',5),('8902','2013-12-12','12:40:00',4.84),('8902','2013-12-12','12:45:00',5.07),('8902','2013-12-12','12:50:00',4.96),('8902','2013-12-12','12:55:00',4.87),('8902','2013-12-12','13:00:00',4.81),('8902','2013-12-12','13:05:00',4.81),('8902','2013-12-12','13:10:00',4.81),('8902','2013-12-12','13:15:00',4.85),('8902','2013-12-12','13:20:00',4.67),('8902','2013-12-12','13:25:00',4.7),('8902','2013-12-12','13:30:00',4.74),('8902','2013-12-12','13:35:00',4.68),('8902','2013-12-12','13:40:00',4.49),('8902','2013-12-12','13:45:00',4.46),('8902','2013-12-12','13:50:00',4.34),('8902','2013-12-12','13:55:00',4.26),('8902','2013-12-12','14:00:00',4.23),('8902','2013-12-12','14:05:00',4.16),('8902','2013-12-12','14:10:00',4.04),('8902','2013-12-12','14:15:00',4),('8902','2013-12-12','14:20:00',3.86),('8902','2013-12-12','14:25:00',3.75),('8902','2013-12-12','14:30:00',3.62),('8902','2013-12-12','14:35:00',3.58),('8902','2013-12-12','14:40:00',3.46),('8902','2013-12-12','14:45:00',3.31),('8902','2013-12-12','14:50:00',3.24),('8902','2013-12-12','14:55:00',3.11),('8902','2013-12-12','15:00:00',2.79),('8902','2013-12-12','15:05:00',2.6),('8902','2013-12-12','15:10:00',2.47),('8902','2013-12-12','15:15:00',2.27),('8902','2013-12-12','15:20:00',2.12),('8902','2013-12-12','15:25:00',1.99),('8902','2013-12-12','15:30:00',1.82),('8902','2013-12-12','15:35:00',1.64),('8902','2013-12-12','15:40:00',1.47),('8902','2013-12-12','15:45:00',1.31),('8902','2013-12-12','15:50:00',1.13),('8902','2013-12-11','08:25:00',1.04),('8902','2013-12-11','08:30:00',1.16),('8902','2013-12-11','08:35:00',1.39),('8902','2013-12-11','08:40:00',1.67),('8902','2013-12-11','08:45:00',1.84),('8902','2013-12-11','08:50:00',2),('8902','2013-12-11','08:55:00',2.16),('8902','2013-12-11','09:00:00',2.28),('8902','2013-12-11','09:05:00',2.42),('8902','2013-12-11','09:10:00',2.61),('8902','2013-12-11','09:15:00',2.74),('8902','2013-12-11','09:20:00',2.87),('8902','2013-12-11','09:25:00',3.03),('8902','2013-12-11','09:30:00',3.18),('8902','2013-12-11','09:35:00',3.33),('8902','2013-12-11','09:40:00',3.46),('8902','2013-12-11','09:45:00',3.57),('8902','2013-12-11','09:50:00',3.7),('8902','2013-12-11','09:55:00',3.81),('8902','2013-12-11','10:00:00',3.93),('8902','2013-12-11','10:05:00',4.04),('8902','2013-12-11','10:10:00',4.16),('8902','2013-12-11','10:15:00',4.26),('8902','2013-12-11','10:20:00',4.34),('8902','2013-12-11','10:25:00',4.42),('8902','2013-12-11','10:30:00',4.5),('8902','2013-12-11','10:35:00',4.58),('8902','2013-12-11','10:40:00',4.65),('8902','2013-12-11','10:45:00',4.72),('8902','2013-12-11','10:50:00',4.8),('8902','2013-12-11','10:55:00',4.83),('8902','2013-12-11','11:00:00',4.89),('8902','2013-12-11','11:05:00',4.89),('8902','2013-12-11','11:10:00',4.92),('8902','2013-12-11','11:15:00',4.97),('8902','2013-12-11','11:20:00',5.02),('8902','2013-12-11','11:25:00',5.05),('8902','2013-12-11','11:30:00',5.06),('8902','2013-12-11','11:35:00',5.11),('8902','2013-12-11','11:40:00',5.18),('8902','2013-12-11','11:45:00',5.18),('8902','2013-12-11','11:50:00',5.22),('8902','2013-12-11','11:55:00',5.19),('8902','2013-12-11','12:00:00',5.17),('8902','2013-12-11','12:05:00',5.21),('8902','2013-12-11','12:10:00',5.23),('8902','2013-12-11','12:15:00',5.25),('8902','2013-12-11','12:20:00',5.27),('8902','2013-12-11','12:25:00',5.22),('8902','2013-12-11','12:30:00',5.25),('8902','2013-12-11','12:35:00',5.22),('8902','2013-12-11','12:40:00',5.12),('8902','2013-12-11','12:45:00',5.06),('8902','2013-12-11','12:50:00',5.14),('8902','2013-12-11','12:55:00',5.06),('8902','2013-12-11','13:00:00',4.94),('8902','2013-12-11','13:05:00',4.82),('8902','2013-12-11','13:10:00',4.71),('8902','2013-12-11','13:15:00',4.78),('8902','2013-12-11','13:20:00',4.91),('8902','2013-12-11','13:25:00',4.8),('8902','2013-12-11','13:30:00',4.62),('8902','2013-12-11','13:35:00',4.66),('8902','2013-12-11','13:40:00',4.6),('8902','2013-12-11','13:45:00',4.45),('8902','2013-12-11','13:50:00',4.37),('8902','2013-12-11','13:55:00',4.3),('8902','2013-12-11','14:00:00',4.22),('8902','2013-12-11','14:05:00',4.11),('8902','2013-12-11','14:10:00',4.04),('8902','2013-12-11','14:15:00',3.89),('8902','2013-12-11','14:20:00',3.81),('8902','2013-12-11','14:25:00',3.63),('8902','2013-12-11','14:30:00',3.51),('8902','2013-12-11','14:35:00',3.31),('8902','2013-12-11','14:40:00',3.22),('8902','2013-12-11','14:45:00',3.12),('8902','2013-12-11','14:50:00',2.94),('8902','2013-12-11','14:55:00',2.83),('8902','2013-12-11','15:00:00',2.58),('8902','2013-12-11','15:05:00',2.43),('8902','2013-12-11','15:10:00',2.26),('8902','2013-12-11','15:15:00',2.15),('8902','2013-12-11','15:20:00',2),('8902','2013-12-11','15:25:00',1.83),('8902','2013-12-11','15:30:00',1.68),('8902','2013-12-11','15:35:00',1.5),('8902','2013-12-11','15:40:00',1.35),('8902','2013-12-11','15:45:00',1.17),('8902','2013-12-11','15:50:00',1.03),('8902','2013-12-10','08:25:00',1.04),('8902','2013-12-10','08:30:00',1.31),('8902','2013-12-10','08:35:00',1.5),('8902','2013-12-10','08:40:00',1.66),('8902','2013-12-10','08:45:00',1.82),('8902','2013-12-10','08:50:00',2.02),('8902','2013-12-10','08:55:00',2.2),('8902','2013-12-10','09:00:00',2.34),('8902','2013-12-10','09:05:00',2.48),('8902','2013-12-10','09:10:00',2.68),('8902','2013-12-10','09:15:00',2.83),('8902','2013-12-10','09:20:00',2.98),('8902','2013-12-10','09:25:00',3.13),('8902','2013-12-10','09:30:00',3.27),('8902','2013-12-10','09:35:00',3.39),('8902','2013-12-10','09:40:00',3.55),('8902','2013-12-10','09:45:00',3.71),('8902','2013-12-10','09:50:00',3.84),('8902','2013-12-10','09:55:00',3.93),('8902','2013-12-10','10:00:00',4.03),('8902','2013-12-10','10:05:00',4.17),('8902','2013-12-10','10:10:00',4.26),('8902','2013-12-10','10:15:00',4.38),('8902','2013-12-10','10:20:00',4.48),('8902','2013-12-10','10:25:00',4.57),('8902','2013-12-10','10:30:00',4.71),('8902','2013-12-10','10:35:00',4.85),('8902','2013-12-10','10:40:00',4.89),('8902','2013-12-10','10:45:00',4.88),('8902','2013-12-10','10:50:00',4.95),('8902','2013-12-10','10:55:00',4.98),('8902','2013-12-10','11:00:00',5.12),('8902','2013-12-10','11:05:00',5.2),('8902','2013-12-10','11:10:00',5.25),('8902','2013-12-10','11:15:00',5.25),('8902','2013-12-10','11:20:00',5.3),('8902','2013-12-10','11:25:00',5.24),('8902','2013-12-10','11:30:00',5.18),('8902','2013-12-10','11:35:00',5.31),('8902','2013-12-10','11:40:00',5.4),('8902','2013-12-10','11:45:00',5.43),('8902','2013-12-10','11:50:00',5.48),('8902','2013-12-10','11:55:00',5.48),('8902','2013-12-10','12:00:00',5.52),('8902','2013-12-10','12:05:00',5.53),('8902','2013-12-10','12:10:00',5.51),('8902','2013-12-10','12:15:00',5.51),('8902','2013-12-10','12:20:00',5.49),('8902','2013-12-10','12:25:00',5.35),('8902','2013-12-10','12:30:00',5.32),('8902','2013-12-10','12:35:00',5.32),('8902','2013-12-10','12:40:00',5.34),('8902','2013-12-10','12:45:00',5.36),('8902','2013-12-10','12:50:00',5.3),('8902','2013-12-10','12:55:00',5.33),('8902','2013-12-10','13:00:00',5.33),('8902','2013-12-10','13:05:00',5.24),('8902','2013-12-10','13:10:00',5.15),('8902','2013-12-10','13:15:00',5.07),('8902','2013-12-10','13:20:00',4.99),('8902','2013-12-10','13:25:00',5),('8902','2013-12-10','13:30:00',4.98),('8902','2013-12-10','13:35:00',4.88),('8902','2013-12-10','13:40:00',4.78),('8902','2013-12-10','13:45:00',4.66),('8902','2013-12-10','13:50:00',4.58),('8902','2013-12-10','13:55:00',4.5),('8902','2013-12-10','14:00:00',4.39),('8902','2013-12-10','14:05:00',4.37),('8902','2013-12-10','14:10:00',4.3),('8902','2013-12-10','14:15:00',4.19),('8902','2013-12-10','14:20:00',4.04),('8902','2013-12-10','14:25:00',3.94),('8902','2013-12-10','14:30:00',3.84),('8902','2013-12-10','14:35:00',3.69),('8902','2013-12-10','14:40:00',3.55),('8902','2013-12-10','14:45:00',3.38),('8902','2013-12-10','14:50:00',3.23),('8902','2013-12-10','14:55:00',3.1),('8902','2013-12-10','15:00:00',2.93),('8902','2013-12-10','15:05:00',2.75),('8902','2013-12-10','15:10:00',2.58),('8902','2013-12-10','15:15:00',2.39),('8902','2013-12-10','15:20:00',2.26),('8902','2013-12-10','15:25:00',2.07),('8902','2013-12-10','15:30:00',1.86),('8902','2013-12-10','15:35:00',1.68),('8902','2013-12-10','15:40:00',1.54),('8902','2013-12-10','15:45:00',1.37),('8902','2013-12-10','15:50:00',1.18),('8902','2013-12-10','15:55:00',1.02),('8902','2013-12-09','08:25:00',1.11),('8902','2013-12-09','08:30:00',1.31),('8902','2013-12-09','08:35:00',1.62),('8902','2013-12-09','08:40:00',1.82),('8902','2013-12-09','08:45:00',1.98),('8902','2013-12-09','08:50:00',2.16),('8902','2013-12-09','08:55:00',2.33),('8902','2013-12-09','09:00:00',2.52),('8902','2013-12-09','09:05:00',2.67),('8902','2013-12-09','09:10:00',2.82),('8902','2013-12-09','09:15:00',2.98),('8902','2013-12-09','09:20:00',3.13),('8902','2013-12-09','09:25:00',3.28),('8902','2013-12-09','09:30:00',3.35),('8902','2013-12-09','09:35:00',3.49),('8902','2013-12-09','09:40:00',3.64),('8902','2013-12-09','09:45:00',3.74),('8902','2013-12-09','09:50:00',3.9),('8902','2013-12-09','09:55:00',4.03),('8902','2013-12-09','10:00:00',4.17),('8902','2013-12-09','10:05:00',4.28),('8902','2013-12-09','10:10:00',4.4),('8902','2013-12-09','10:15:00',4.48),('8902','2013-12-09','10:20:00',4.56),('8902','2013-12-09','10:25:00',4.63),('8902','2013-12-09','10:30:00',4.72),('8902','2013-12-09','10:35:00',4.8),('8902','2013-12-09','10:40:00',4.84),('8902','2013-12-09','10:45:00',4.95),('8902','2013-12-09','10:50:00',5.05),('8902','2013-12-09','10:55:00',5.1),('8902','2013-12-09','11:00:00',5.17),('8902','2013-12-09','11:05:00',5.23),('8902','2013-12-09','11:10:00',5.28),('8902','2013-12-09','11:15:00',5.33),('8902','2013-12-09','11:20:00',5.4),('8902','2013-12-09','11:25:00',5.45),('8902','2013-12-09','11:30:00',5.5),('8902','2013-12-09','11:35:00',5.52),('8902','2013-12-09','11:40:00',5.55),('8902','2013-12-09','11:45:00',5.52),('8902','2013-12-09','11:50:00',5.54),('8902','2013-12-09','11:55:00',5.57),('8902','2013-12-09','12:00:00',5.58),('8902','2013-12-09','12:05:00',5.57),('8902','2013-12-09','12:10:00',5.53),('8902','2013-12-09','12:15:00',5.52),('8902','2013-12-09','12:20:00',5.52),('8902','2013-12-09','12:25:00',5.46),('8902','2013-12-09','12:30:00',5.43),('8902','2013-12-09','12:35:00',5.39),('8902','2013-12-09','12:40:00',5.34),('8902','2013-12-09','12:45:00',5.32),('8902','2013-12-09','12:50:00',5.26),('8902','2013-12-09','12:55:00',5.16),('8902','2013-12-09','13:00:00',5.11),('8902','2013-12-09','13:05:00',5.12),('8902','2013-12-09','13:10:00',4.99),('8902','2013-12-09','13:15:00',4.9),('8902','2013-12-09','13:20:00',4.97),('8902','2013-12-09','13:25:00',4.92),('8902','2013-12-09','13:30:00',4.9),('8902','2013-12-09','13:35:00',4.91),('8902','2013-12-09','13:40:00',4.88),('8902','2013-12-09','13:45:00',4.78),('8902','2013-12-09','13:50:00',4.69),('8902','2013-12-09','13:55:00',4.62),('8902','2013-12-09','14:00:00',4.52),('8902','2013-12-09','14:05:00',4.42),('8902','2013-12-09','14:10:00',4.33),('8902','2013-12-09','14:15:00',4.24),('8902','2013-12-09','14:20:00',4.14),('8902','2013-12-09','14:25:00',4.07),('8902','2013-12-09','14:30:00',3.96),('8902','2013-12-09','14:35:00',3.84),('8902','2013-12-09','14:40:00',3.7),('8902','2013-12-09','14:45:00',3.51),('8902','2013-12-09','14:50:00',3.45),('8902','2013-12-09','14:55:00',3.28),('8902','2013-12-09','15:00:00',3.08),('8902','2013-12-09','15:05:00',2.87),('8902','2013-12-09','15:10:00',2.73),('8902','2013-12-09','15:15:00',2.56),('8902','2013-12-09','15:20:00',2.38),('8902','2013-12-09','15:25:00',2.17),('8902','2013-12-09','15:30:00',2),('8902','2013-12-09','15:35:00',1.81),('8902','2013-12-09','15:40:00',1.64),('8902','2013-12-09','15:45:00',1.44),('8902','2013-12-09','15:50:00',1.26),('8902','2013-12-09','15:55:00',1.11),('8902','2013-12-08','09:30:00',1.07),('8902','2013-12-08','09:35:00',3.26),('8902','2013-12-08','09:40:00',3.58),('8902','2013-12-08','09:45:00',3.69),('8902','2013-12-08','09:50:00',3.79),('8902','2013-12-08','09:55:00',3.93),('8902','2013-12-08','10:00:00',4.06),('8902','2013-12-08','10:05:00',4.22),('8902','2013-12-08','10:10:00',4.97),('8902','2013-12-08','10:15:00',5.22),('8902','2013-12-08','10:20:00',5.71),('8902','2013-12-08','10:25:00',4.83),('8902','2013-12-08','10:30:00',1.63),('8902','2013-12-08','10:35:00',1.33),('8902','2013-12-08','10:40:00',1.15),('8902','2013-12-08','11:45:00',1.04),('8902','2013-12-08','11:50:00',1.08),('8902','2013-12-08','11:55:00',1.18),('8902','2013-12-08','12:00:00',1.26),('8902','2013-12-08','12:05:00',1.36),('8902','2013-12-08','12:10:00',1.35),('8902','2013-12-08','12:15:00',1.29),('8902','2013-12-08','12:20:00',1.38),('8902','2013-12-08','12:25:00',1.76),('8902','2013-12-08','12:30:00',3.96),('8902','2013-12-08','12:35:00',2.4),('8902','2013-12-08','12:40:00',2.25),('8902','2013-12-08','12:45:00',3.54),('8902','2013-12-08','12:50:00',3.44),('8902','2013-12-08','12:55:00',3.7),('8902','2013-12-08','13:00:00',4.79),('8902','2013-12-08','13:05:00',4.24),('8902','2013-12-08','13:10:00',3.52),('8902','2013-12-08','13:15:00',3.84),('8902','2013-12-08','13:20:00',3.59),('8902','2013-12-08','13:25:00',2.57),('8902','2013-12-08','13:30:00',1.47),('8902','2013-12-08','13:35:00',1.09),('8902','2013-12-08','13:40:00',1.35),('8902','2013-12-08','13:45:00',1.82),('8902','2013-12-08','13:50:00',2.15),('8902','2013-12-08','13:55:00',2.34),('8902','2013-12-08','14:00:00',1.94),('8902','2013-12-08','14:05:00',1.5),('8902','2013-12-08','14:10:00',1.27),('8902','2013-12-08','14:15:00',1.1),('8902','2013-12-08','14:40:00',1.04),('8902','2013-12-08','14:45:00',1.09),('8902','2013-12-08','14:50:00',1.03),('8902','2013-12-08','14:55:00',1.04),('8902','2013-12-08','15:00:00',1),('8902','2013-12-07','15:30:00',2.11),('8902','2013-12-07','15:35:00',1.61),('8902','2013-12-07','15:40:00',1.14),('8902','2014-04-20','08:20:00',1.06),('8902','2014-04-20','08:25:00',1.15),('8902','2014-04-20','08:30:00',1.55),('8902','2014-04-20','08:35:00',1.6),('8902','2014-04-20','08:40:00',1.6),('8902','2014-04-20','08:45:00',1.53),('8902','2014-04-20','08:50:00',1.46),('8902','2014-04-20','08:55:00',1.42),('8902','2014-04-20','09:00:00',1.63),('8902','2014-04-20','09:05:00',1.64),('8902','2014-04-20','09:10:00',1.71),('8902','2014-04-20','09:15:00',1.82),('8902','2014-04-20','09:20:00',2.39),('8902','2014-04-20','09:25:00',1.88),('8902','2014-04-20','09:40:00',1.36),('8902','2014-04-20','09:45:00',1.63),('8902','2014-04-20','09:50:00',1.75),('8902','2014-04-20','09:55:00',2.03),('8902','2014-04-20','10:00:00',2.88),('8902','2014-04-20','10:05:00',4.46),('8902','2014-04-20','10:10:00',6.53),('8902','2014-04-20','10:15:00',6.23),('8902','2014-04-20','10:20:00',6.08),('8902','2014-04-20','10:25:00',6.14),('8902','2014-04-20','10:30:00',6.17),('8902','2014-04-20','10:35:00',6.2),('8902','2014-04-20','10:40:00',6.34),('8902','2014-04-20','10:45:00',6.41),('8902','2014-04-20','10:50:00',6.5),('8902','2014-04-20','10:55:00',6.58),('8902','2014-04-20','11:00:00',6.66),('8902','2014-04-20','11:05:00',6.75),('8902','2014-04-20','11:10:00',6.85),('8902','2014-04-20','11:15:00',6.89),('8902','2014-04-20','11:20:00',6.97),('8902','2014-04-20','11:25:00',7.06),('8902','2014-04-20','11:30:00',7.11),('8902','2014-04-20','11:35:00',7.22),('8902','2014-04-20','11:40:00',7.31),('8902','2014-04-20','11:45:00',7.38),('8902','2014-04-20','11:50:00',7.42),('8902','2014-04-20','11:55:00',7.42),('8902','2014-04-20','12:00:00',7.51),('8902','2014-04-20','12:05:00',7.57),('8902','2014-04-20','12:10:00',7.65),('8902','2014-04-20','12:15:00',7.71),('8902','2014-04-20','12:20:00',7.77),('8902','2014-04-20','12:25:00',7.81),('8902','2014-04-20','12:30:00',7.86),('8902','2014-04-20','12:35:00',7.89),('8902','2014-04-20','12:40:00',7.9),('8902','2014-04-20','12:45:00',7.96),('8902','2014-04-20','12:50:00',7.97),('8902','2014-04-20','12:55:00',7.98),('8902','2014-04-20','13:00:00',7.97),('8902','2014-04-20','13:05:00',8),('8902','2014-04-20','13:10:00',8.08),('8902','2014-04-20','13:15:00',8.03),('8902','2014-04-20','13:20:00',8.05),('8902','2014-04-20','13:25:00',8.03),('8902','2014-04-20','13:30:00',8.06),('8902','2014-04-20','13:35:00',8.04),('8902','2014-04-20','13:40:00',8.01),('8902','2014-04-20','13:45:00',8.09),('8902','2014-04-20','13:50:00',8.14),('8902','2014-04-20','13:55:00',8.16),('8902','2014-04-20','14:00:00',8.12),('8902','2014-04-20','14:05:00',8.2),('8902','2014-04-20','14:10:00',8.15),('8902','2014-04-20','14:15:00',8.1),('8902','2014-04-20','14:20:00',8.04),('8902','2014-04-20','14:25:00',8.01),('8902','2014-04-20','14:30:00',7.97),('8902','2014-04-20','14:35:00',7.94),('8902','2014-04-20','14:40:00',7.83),('8902','2014-04-20','14:45:00',7.75),('8902','2014-04-20','14:50:00',7.71),('8902','2014-04-20','14:55:00',7.71),('8902','2014-04-20','15:00:00',7.67),('8902','2014-04-20','15:05:00',7.63),('8902','2014-04-20','15:10:00',7.47),('8902','2014-04-20','15:15:00',7.38),('8902','2014-04-20','15:20:00',7.28),('8902','2014-04-20','15:25:00',7.17),('8902','2014-04-20','15:30:00',7.09),('8902','2014-04-20','15:35:00',6.99),('8902','2014-04-20','15:40:00',6.86),('8902','2014-04-20','15:45:00',6.77),('8902','2014-04-20','15:50:00',6.67),('8902','2014-04-20','15:55:00',6.58),('8902','2014-04-20','16:00:00',6.53),('8902','2014-04-20','16:05:00',6.39),('8902','2014-04-20','16:10:00',6.13),('8902','2014-04-20','16:15:00',4.77),('8902','2014-04-20','16:20:00',6.21),('8902','2014-04-20','16:25:00',5.87),('8902','2014-04-20','16:30:00',5.62),('8902','2014-04-20','16:35:00',5.64),('8902','2014-04-20','16:40:00',5.55),('8902','2014-04-20','16:45:00',5.31),('8902','2014-04-20','16:50:00',5.21),('8902','2014-04-20','16:55:00',5.09),('8902','2014-04-20','17:00:00',4.91),('8902','2014-04-20','17:05:00',4.73),('8902','2014-04-20','17:10:00',4.58),('8902','2014-04-20','17:15:00',4.44),('8902','2014-04-20','17:20:00',4.3),('8902','2014-04-20','17:25:00',4.14),('8902','2014-04-20','17:30:00',3.96),('8902','2014-04-20','17:35:00',3.77),('8902','2014-04-20','17:40:00',3.41),('8902','2014-04-20','17:45:00',3.4),('8902','2014-04-20','17:50:00',3.24),('8902','2014-04-20','17:55:00',3.02),('8902','2014-04-20','18:00:00',2.85),('8902','2014-04-20','18:05:00',2.61),('8902','2014-04-20','18:10:00',2.42),('8902','2014-04-20','18:15:00',2.21),('8902','2014-04-20','18:20:00',1.98),('8902','2014-04-20','18:25:00',1.83),('8902','2014-04-20','18:30:00',1.64),('8902','2014-04-20','18:35:00',1.45),('8902','2014-04-20','18:40:00',1.26),('8902','2014-04-20','18:45:00',1.13),('8902','2013-12-03','08:15:00',1.07),('8902','2013-12-03','08:20:00',1.19),('8902','2013-12-03','08:25:00',1.41),('8902','2013-12-03','08:30:00',1.76),('8902','2013-12-03','08:35:00',1.97),('8902','2013-12-03','08:40:00',2.14),('8902','2013-12-03','08:45:00',2.31),('8902','2013-12-03','08:50:00',2.5),('8902','2013-12-03','08:55:00',2.69),('8902','2013-12-03','09:00:00',2.88),('8902','2013-12-03','09:05:00',3.06),('8902','2013-12-03','09:10:00',3.22),('8902','2013-12-03','09:15:00',3.37),('8902','2013-12-03','09:20:00',3.51),('8902','2013-12-03','09:25:00',3.64),('8902','2013-12-03','09:30:00',3.79),('8902','2013-12-03','09:35:00',3.92),('8902','2013-12-03','09:40:00',4.07),('8902','2013-12-03','09:45:00',4.2),('8902','2013-12-03','09:50:00',4.31),('8902','2013-12-03','09:55:00',4.43),('8902','2013-12-03','10:00:00',4.53),('8902','2013-12-03','10:05:00',4.63),('8902','2013-12-03','10:10:00',4.72),('8902','2013-12-03','10:15:00',4.81),('8902','2013-12-03','10:20:00',4.9),('8902','2013-12-03','10:25:00',5.01),('8902','2013-12-03','10:30:00',5.11),('8902','2013-12-03','10:35:00',5.18),('8902','2013-12-03','10:40:00',5.26),('8902','2013-12-03','10:45:00',5.33),('8902','2013-12-03','10:50:00',5.39),('8902','2013-12-03','10:55:00',5.44),('8902','2013-12-03','11:00:00',5.5),('8902','2013-12-03','11:05:00',5.53),('8902','2013-12-03','11:10:00',5.57),('8902','2013-12-03','11:15:00',5.6),('8902','2013-12-03','11:20:00',5.64),('8902','2013-12-03','11:25:00',5.67),('8902','2013-12-03','11:30:00',5.7),('8902','2013-12-03','11:35:00',5.73),('8902','2013-12-03','11:40:00',5.73),('8902','2013-12-03','11:45:00',5.77),('8902','2013-12-03','11:50:00',5.77),('8902','2013-12-03','11:55:00',5.78),('8902','2013-12-03','12:00:00',5.8),('8902','2013-12-03','12:05:00',5.78),('8902','2013-12-03','12:10:00',5.81),('8902','2013-12-03','12:15:00',5.77),('8902','2013-12-03','12:20:00',5.75),('8902','2013-12-03','12:25:00',5.74),('8902','2013-12-03','12:30:00',5.74),('8902','2013-12-03','12:35:00',5.69),('8902','2013-12-03','12:40:00',5.63),('8902','2013-12-03','12:45:00',5.66),('8902','2013-12-03','12:50:00',5.61),('8902','2013-12-03','12:55:00',5.58),('8902','2013-12-03','13:00:00',5.53),('8902','2013-12-03','13:05:00',5.49),('8902','2013-12-03','13:10:00',5.44),('8902','2013-12-03','13:15:00',5.37),('8902','2013-12-03','13:20:00',5.31),('8902','2013-12-03','13:25:00',5.22),('8902','2013-12-03','13:30:00',5.17),('8902','2013-12-03','13:35:00',5.11),('8902','2013-12-03','13:40:00',5.03),('8902','2013-12-03','13:45:00',4.95),('8902','2013-12-03','13:50:00',4.86),('8902','2013-12-03','13:55:00',4.76),('8902','2013-12-03','14:00:00',4.7),('8902','2013-12-03','14:05:00',4.59),('8902','2013-12-03','14:10:00',4.5),('8902','2013-12-03','14:15:00',4.39),('8902','2013-12-03','14:20:00',4.28),('8902','2013-12-03','14:25:00',4.13),('8902','2013-12-03','14:30:00',4.01),('8902','2013-12-03','14:35:00',3.9),('8902','2013-12-03','14:40:00',3.84),('8902','2013-12-03','14:45:00',3.71),('8902','2013-12-03','14:50:00',3.55),('8902','2013-12-03','14:55:00',3.38),('8902','2013-12-03','15:00:00',3.22),('8902','2013-12-03','15:05:00',3.01),('8902','2013-12-03','15:10:00',2.84),('8902','2013-12-03','15:15:00',2.68),('8902','2013-12-03','15:20:00',2.5),('8902','2013-12-03','15:25:00',2.32),('8902','2013-12-03','15:30:00',2.13),('8902','2013-12-03','15:35:00',1.95),('8902','2013-12-03','15:40:00',1.78),('8902','2013-12-03','15:45:00',1.59),('8902','2013-12-03','15:50:00',1.41),('8902','2013-12-03','15:55:00',1.23),('8902','2013-12-03','16:00:00',1.02),('8902','2013-12-02','09:10:00',1.31),('8902','2013-12-02','09:15:00',1.72),('8902','2013-12-02','09:20:00',1.89),('8902','2013-12-02','09:25:00',2.1),('8902','2013-12-02','09:30:00',2.52),('8902','2013-12-02','09:35:00',2.6),('8902','2013-12-02','09:40:00',3.15),('8902','2013-12-02','09:45:00',3.29),('8902','2013-12-02','09:50:00',3.53),('8902','2013-12-02','09:55:00',3.34),('8902','2013-12-02','10:00:00',4.53),('8902','2013-12-02','10:05:00',4.61),('8902','2013-12-02','10:10:00',4.71),('8902','2013-12-02','10:15:00',4.81),('8902','2013-12-02','10:20:00',4.86),('8902','2013-12-02','10:25:00',4.97),('8902','2013-12-02','10:30:00',5.05),('8902','2013-12-02','10:35:00',5.12),('8902','2013-12-02','10:40:00',5.19),('8902','2013-12-02','10:45:00',5.24),('8902','2013-12-02','10:50:00',5.33),('8902','2013-12-02','10:55:00',5.46),('8902','2013-12-02','11:00:00',5.55),('8902','2013-12-02','11:05:00',5.61),('8902','2013-12-02','11:10:00',5.67),('8902','2013-12-02','11:15:00',5.73),('8902','2013-12-02','11:20:00',5.75),('8902','2013-12-02','11:25:00',5.75),('8902','2013-12-02','11:30:00',5.76),('8902','2013-12-02','11:35:00',5.8),('8902','2013-12-02','11:40:00',5.82),('8902','2013-12-02','11:45:00',5.84),('8902','2013-12-02','11:50:00',5.89),('8902','2013-12-02','11:55:00',5.91),('8902','2013-12-02','12:00:00',5.93),('8902','2013-12-02','12:05:00',5.95),('8902','2013-12-02','12:10:00',5.97),('8902','2013-12-02','12:15:00',6.02),('8902','2013-12-02','12:20:00',6.04),('8902','2013-12-02','12:25:00',6.09),('8902','2013-12-02','12:30:00',6.14),('8902','2013-12-02','12:35:00',6.17),('8902','2013-12-02','12:40:00',6.24),('8902','2013-12-02','12:45:00',6.33),('8902','2013-12-02','12:50:00',6.51),('8902','2013-12-02','12:55:00',6.68),('8902','2013-12-02','13:00:00',6.79),('8902','2013-12-02','13:05:00',6.87),('8902','2013-12-02','13:10:00',6.87),('8902','2013-12-02','13:15:00',6.61),('8902','2013-12-02','13:20:00',6.52),('8902','2013-12-02','13:25:00',6.32),('8902','2013-12-02','13:30:00',5.85),('8902','2013-12-02','13:35:00',6),('8902','2013-12-02','13:40:00',5.8),('8902','2013-12-02','13:45:00',5.5),('8902','2013-12-02','13:50:00',5.28),('8902','2013-12-02','13:55:00',5.17),('8902','2013-12-02','14:00:00',5.03),('8902','2013-12-02','14:05:00',4.77),('8902','2013-12-02','14:10:00',4.62),('8902','2013-12-02','14:15:00',4.34),('8902','2013-12-02','14:20:00',3.74),('8902','2013-12-02','14:25:00',3.44),('8902','2013-12-02','14:30:00',3.8),('8902','2013-12-02','14:35:00',3.89),('8902','2013-12-02','14:40:00',3.77),('8902','2013-12-02','14:45:00',3.61),('8902','2013-12-02','14:50:00',3.45),('8902','2013-12-02','14:55:00',3.25),('8902','2013-12-02','15:00:00',3.09),('8902','2013-12-02','15:05:00',2.94),('8902','2013-12-02','15:10:00',2.78),('8902','2013-12-02','15:15:00',2.61),('8902','2013-12-02','15:20:00',2.45),('8902','2013-12-02','15:25:00',2.23),('8902','2013-12-02','15:30:00',2.05),('8902','2013-12-02','15:35:00',1.85),('8902','2013-12-02','15:40:00',1.66),('8902','2013-12-02','15:45:00',1.46),('8902','2013-12-02','15:50:00',1.28),('8902','2013-12-02','15:55:00',1.1),('8902','2013-12-01','13:40:00',1.12),('8902','2013-12-01','13:45:00',1.13),('8902','2013-12-01','13:50:00',1.11),('8902','2013-12-01','13:55:00',1.23),('8902','2013-12-01','14:00:00',1.2),('8902','2013-12-01','14:05:00',1.11),('8902','2013-11-30','11:00:00',1.01),('8902','2013-11-30','11:05:00',1.11),('8902','2013-11-30','11:10:00',1.07),('8902','2013-11-30','11:25:00',1.16),('8902','2013-11-30','11:30:00',1.57),('8902','2013-11-30','11:35:00',1.98),('8902','2013-11-30','11:40:00',1.93),('8902','2013-11-30','11:45:00',1.52),('8902','2013-11-30','11:50:00',1.57),('8902','2013-11-30','11:55:00',2.34),('8902','2013-11-30','12:00:00',2.07),('8902','2013-11-30','12:05:00',2.52),('8902','2013-11-30','12:10:00',3.09),('8902','2013-11-30','12:15:00',2.18),('8902','2013-11-30','12:20:00',1.14),('8902','2013-11-30','12:45:00',1.34),('8902','2013-11-30','12:50:00',1.38),('8902','2013-11-30','12:55:00',1.36),('8902','2013-11-30','13:00:00',1.38),('8902','2013-11-30','13:05:00',1.13),('8902','2013-11-30','14:05:00',1.09),('8902','2013-11-30','14:10:00',1.03),('8902','2013-11-29','08:50:00',1.06),('8902','2013-11-29','08:55:00',1.48),('8902','2013-11-29','09:00:00',1.48),('8902','2013-11-29','09:05:00',1.82),('8902','2013-11-29','09:10:00',2.91),('8902','2013-11-29','09:15:00',3.35),('8902','2013-11-29','09:20:00',3.64),('8902','2013-11-29','09:25:00',3.66),('8902','2013-11-29','09:30:00',3.71),('8902','2013-11-29','09:35:00',4.53),('8902','2013-11-29','09:40:00',4.26),('8902','2013-11-29','09:45:00',3.78),('8902','2013-11-29','09:50:00',2.82),('8902','2013-11-29','09:55:00',2.44),('8902','2013-11-29','10:00:00',2.39),('8902','2013-11-29','10:05:00',2.06),('8902','2013-11-29','10:10:00',1.94),('8902','2013-11-29','10:15:00',2.12),('8902','2013-11-29','10:20:00',2.3),('8902','2013-11-29','10:25:00',2.24),('8902','2013-11-29','10:30:00',2.34),('8902','2013-11-29','10:35:00',2.51),('8902','2013-11-29','10:40:00',2.74),('8902','2013-11-29','10:45:00',2.78),('8902','2013-11-29','10:50:00',2.83),('8902','2013-11-29','10:55:00',2.25),('8902','2013-11-29','11:00:00',2.12),('8902','2013-11-29','11:05:00',2.55),('8902','2013-11-29','11:10:00',2.69),('8902','2013-11-29','11:15:00',2.74),('8902','2013-11-29','11:20:00',2.38),('8902','2013-11-29','11:25:00',2.42),('8902','2013-11-29','11:30:00',2.19),('8902','2013-11-29','11:35:00',2.03),('8902','2013-11-29','11:40:00',1.92),('8902','2013-11-29','11:45:00',1.74),('8902','2013-11-29','11:50:00',1.66),('8902','2013-11-29','11:55:00',1.47),('8902','2013-11-29','12:00:00',1.38),('8902','2013-11-29','12:05:00',1.33),('8902','2013-11-29','12:10:00',1.24),('8902','2013-11-29','12:15:00',1.2),('8902','2013-11-29','12:20:00',1.2),('8902','2013-11-29','12:25:00',1.28),('8902','2013-11-29','12:30:00',1.21),('8902','2013-11-29','12:35:00',1.14),('8902','2013-11-29','12:40:00',1.04),('8902','2013-11-29','13:40:00',1.07),('8902','2013-11-29','13:45:00',1.19),('8902','2013-11-29','13:50:00',1.47),('8902','2013-11-29','13:55:00',1.43),('8902','2013-11-29','14:00:00',1.22),('8902','2013-11-28','08:15:00',1.1),('8902','2013-11-28','08:20:00',1.24),('8902','2013-11-28','08:25:00',1.61),('8902','2013-11-28','08:30:00',1.84),('8902','2013-11-28','08:35:00',2.02),('8902','2013-11-28','08:40:00',2.2),('8902','2013-11-28','08:45:00',2.37),('8902','2013-11-28','08:50:00',2.56),('8902','2013-11-28','08:55:00',2.73),('8902','2013-11-28','09:00:00',2.92),('8902','2013-11-28','09:05:00',3.09),('8902','2013-11-28','09:10:00',3.25),('8902','2013-11-28','09:15:00',3.4),('8902','2013-11-28','09:20:00',3.55),('8902','2013-11-28','09:25:00',3.7),('8902','2013-11-28','09:30:00',3.83),('8902','2013-11-28','09:35:00',3.97),('8902','2013-11-28','09:40:00',4.12),('8902','2013-11-28','09:45:00',4.25),('8902','2013-11-28','09:50:00',4.37),('8902','2013-11-28','09:55:00',4.5),('8902','2013-11-28','10:00:00',4.61),('8902','2013-11-28','10:05:00',4.71),('8902','2013-11-28','10:10:00',4.81),('8902','2013-11-28','10:15:00',4.9),('8902','2013-11-28','10:20:00',5),('8902','2013-11-28','10:25:00',5.08),('8902','2013-11-28','10:30:00',5.17),('8902','2013-11-28','10:35:00',5.25),('8902','2013-11-28','10:40:00',5.34),('8902','2013-11-28','10:45:00',5.4),('8902','2013-11-28','10:50:00',5.48),('8902','2013-11-28','10:55:00',5.55),('8902','2013-11-28','11:00:00',5.6),('8902','2013-11-28','11:05:00',5.66),('8902','2013-11-28','11:10:00',5.72),('8902','2013-11-28','11:15:00',5.78),('8902','2013-11-28','11:20:00',5.81),('8902','2013-11-28','11:25:00',5.86),('8902','2013-11-28','11:30:00',5.88),('8902','2013-11-28','11:35:00',5.91),('8902','2013-11-28','11:40:00',5.94),('8902','2013-11-28','11:45:00',5.95),('8902','2013-11-28','11:50:00',5.95),('8902','2013-11-28','11:55:00',5.99),('8902','2013-11-28','12:00:00',5.98),('8902','2013-11-28','12:05:00',5.97),('8902','2013-11-28','12:10:00',5.99),('8902','2013-11-28','12:15:00',5.97),('8902','2013-11-28','12:20:00',5.95),('8902','2013-11-28','12:25:00',5.93),('8902','2013-11-28','12:30:00',5.89),('8902','2013-11-28','12:35:00',5.89),('8902','2013-11-28','12:40:00',5.88),('8902','2013-11-28','12:45:00',5.84),('8902','2013-11-28','12:50:00',5.78),('8902','2013-11-28','12:55:00',5.76),('8902','2013-11-28','13:00:00',5.72),('8902','2013-11-28','13:05:00',5.64),('8902','2013-11-28','13:10:00',5.57),('8902','2013-11-28','13:15:00',5.52),('8902','2013-11-28','13:20:00',5.45),('8902','2013-11-28','13:25:00',5.35),('8902','2013-11-28','13:30:00',5.27),('8902','2013-11-28','13:35:00',5.22),('8902','2013-11-28','13:40:00',5.14),('8902','2013-11-28','13:45:00',5.04),('8902','2013-11-28','13:50:00',4.93),('8902','2013-11-28','13:55:00',4.84),('8902','2013-11-28','14:00:00',4.74),('8902','2013-11-28','14:05:00',4.64),('8902','2013-11-28','14:10:00',4.54),('8902','2013-11-28','14:15:00',4.43),('8902','2013-11-28','14:20:00',4.29),('8902','2013-11-28','14:25:00',4.16),('8902','2013-11-28','14:30:00',4.05),('8902','2013-11-28','14:35:00',3.91),('8902','2013-11-28','14:40:00',3.76),('8902','2013-11-28','14:45:00',3.62),('8902','2013-11-28','14:50:00',3.47),('8902','2013-11-28','14:55:00',3.28),('8902','2013-11-28','15:00:00',3.12),('8902','2013-11-28','15:05:00',2.96),('8902','2013-11-28','15:10:00',2.78),('8902','2013-11-28','15:15:00',2.64),('8902','2013-11-28','15:20:00',2.46),('8902','2013-11-28','15:25:00',2.28),('8902','2013-11-28','15:30:00',2.1),('8902','2013-11-28','15:35:00',1.91),('8902','2013-11-28','15:40:00',1.71),('8902','2013-11-28','15:45:00',1.51),('8902','2013-11-28','15:50:00',1.34),('8902','2013-11-28','15:55:00',1.15),('8902','2013-11-27','09:20:00',1.01),('8902','2013-11-27','09:25:00',1.16),('8902','2013-11-27','09:30:00',1.34),('8902','2013-11-27','09:35:00',1.48),('8902','2013-11-27','09:40:00',1.76),('8902','2013-11-27','09:45:00',1.88),('8902','2013-11-27','09:50:00',1.9),('8902','2013-11-27','09:55:00',1.81),('8902','2013-11-27','10:00:00',1.46),('8902','2013-11-27','10:05:00',1.21),('8902','2013-11-27','11:20:00',1.21),('8902','2013-11-27','11:25:00',1.27),('8902','2013-11-27','12:25:00',1.01),('8902','2013-11-27','12:30:00',1.09),('8902','2013-11-27','12:35:00',1.07),('8902','2013-11-27','12:40:00',1.21),('8902','2013-11-27','12:45:00',1.37),('8902','2013-11-27','12:50:00',1.65),('8902','2013-11-27','12:55:00',2.03),('8902','2013-11-27','13:00:00',1.68),('8902','2013-11-27','13:25:00',1.67),('8902','2013-11-27','13:30:00',1.59),('8902','2013-11-27','13:35:00',1.71),('8902','2013-11-27','13:40:00',1.65),('8902','2013-11-27','13:45:00',1.38),('8902','2013-11-27','13:50:00',1.43),('8902','2013-11-27','14:10:00',1.47),('8902','2013-11-27','14:15:00',1.17),('8902','2014-04-19','07:50:00',1.31),('8902','2014-04-19','07:55:00',1.57),('8902','2014-04-19','08:00:00',1.64),('8902','2014-04-19','08:05:00',1.71),('8902','2014-04-19','08:10:00',1.9),('8902','2014-04-19','08:15:00',2.15),('8902','2014-04-19','08:20:00',2.53),('8902','2014-04-19','08:25:00',3.41),('8902','2014-04-19','08:30:00',4.12),('8902','2014-04-19','08:35:00',3.91),('8902','2014-04-19','08:40:00',4),('8902','2014-04-19','08:45:00',3.08),('8902','2014-04-19','08:50:00',3.03),('8902','2014-04-19','08:55:00',1.6),('8902','2014-04-19','09:00:00',2.82),('8902','2014-04-19','09:05:00',1.39),('8902','2014-04-19','09:10:00',2.77),('8902','2014-04-19','09:15:00',4.47),('8902','2014-04-19','09:20:00',4.9),('8902','2014-04-19','09:25:00',5.17),('8902','2014-04-19','09:30:00',5.9),('8902','2014-04-19','09:35:00',4.8),('8902','2014-04-19','09:40:00',3.56),('8902','2014-04-19','09:45:00',2.67),('8902','2014-04-19','09:50:00',2.81),('8902','2014-04-19','09:55:00',3.43),('8902','2014-04-19','10:00:00',4.2),('8902','2014-04-19','10:05:00',5.31),('8902','2014-04-19','10:10:00',4.96),('8902','2014-04-19','10:15:00',5.96),('8902','2014-04-19','10:20:00',5.78),('8902','2014-04-19','10:25:00',4.95),('8902','2014-04-19','10:30:00',4.69),('8902','2014-04-19','10:35:00',5.05),('8902','2014-04-19','10:40:00',4.97),('8902','2014-04-19','10:45:00',4.97),('8902','2014-04-19','10:50:00',5.42),('8902','2014-04-19','10:55:00',5.54),('8902','2014-04-19','11:00:00',5.08),('8902','2014-04-19','11:05:00',6.43),('8902','2014-04-19','11:10:00',5.88),('8902','2014-04-19','11:15:00',6.53),('8902','2014-04-19','11:20:00',7.08),('8902','2014-04-19','11:25:00',7.1),('8902','2014-04-19','11:30:00',7.45),('8902','2014-04-19','11:35:00',7.57),('8902','2014-04-19','11:40:00',3.59),('8902','2014-04-19','11:45:00',6.68),('8902','2014-04-19','11:50:00',6.2),('8902','2014-04-19','11:55:00',4.22),('8902','2014-04-19','12:00:00',5.6),('8902','2014-04-19','12:05:00',8.65),('8902','2014-04-19','12:10:00',6.97),('8902','2014-04-19','12:15:00',6.21),('8902','2014-04-19','12:20:00',4.37),('8902','2014-04-19','12:25:00',9.26),('8902','2014-04-19','12:30:00',8.51),('8902','2014-04-19','12:35:00',8.23),('8902','2014-04-19','12:40:00',8.27),('8902','2014-04-19','12:45:00',8.44),('8902','2014-04-19','12:50:00',8.53),('8902','2014-04-19','12:55:00',8.58),('8902','2014-04-19','13:00:00',8.63),('8902','2014-04-19','13:05:00',8.67),('8902','2014-04-19','13:10:00',8.75),('8902','2014-04-19','13:15:00',8.77),('8902','2014-04-19','13:20:00',8.51),('8902','2014-04-19','13:25:00',8.56),('8902','2014-04-19','13:30:00',8.59),('8902','2014-04-19','13:35:00',8.57),('8902','2014-04-19','13:40:00',8.59),('8902','2014-04-19','13:45:00',8.57),('8902','2014-04-19','13:50:00',8.53),('8902','2014-04-19','13:55:00',8.49),('8902','2014-04-19','14:00:00',8.44),('8902','2014-04-19','14:05:00',8.48),('8902','2014-04-19','14:10:00',8.46),('8902','2014-04-19','14:15:00',8.7),('8902','2014-04-19','14:20:00',7.03),('8902','2014-04-19','14:25:00',6.38),('8902','2014-04-19','14:30:00',6.18),('8902','2014-04-19','14:35:00',4.87),('8902','2014-04-19','14:40:00',4.8),('8902','2014-04-19','14:45:00',5.17),('8902','2014-04-19','14:50:00',5),('8902','2014-04-19','14:55:00',5.63),('8902','2014-04-19','15:00:00',7.06),('8902','2014-04-19','15:05:00',7.5),('8902','2014-04-19','15:10:00',7.53),('8902','2014-04-19','15:15:00',7.8),('8902','2014-04-19','15:20:00',7.35),('8902','2014-04-19','15:25:00',7.49),('8902','2014-04-19','15:30:00',7.35),('8902','2014-04-19','15:35:00',7.19),('8902','2014-04-19','15:40:00',7.34),('8902','2014-04-19','15:45:00',6.43),('8902','2014-04-19','15:50:00',4.8),('8902','2014-04-19','15:55:00',7.12),('8902','2014-04-19','16:00:00',6.84),('8902','2014-04-19','16:05:00',6.75),('8902','2014-04-19','16:10:00',6.64),('8902','2014-04-19','16:15:00',6.58),('8902','2014-04-19','16:20:00',6.61),('8902','2014-04-19','16:25:00',5.3),('8902','2014-04-19','16:30:00',6.45),('8902','2014-04-19','16:35:00',5.99),('8902','2014-04-19','16:40:00',6.12),('8902','2014-04-19','16:45:00',5.13),('8902','2014-04-19','16:50:00',5.39),('8902','2014-04-19','16:55:00',5.56),('8902','2014-04-19','17:00:00',5.27),('8902','2014-04-19','17:05:00',4.99),('8902','2014-04-19','17:10:00',4.72),('8902','2014-04-19','17:15:00',4.51),('8902','2014-04-19','17:20:00',4.36),('8902','2014-04-19','17:25:00',4.18),('8902','2014-04-19','17:30:00',3.98),('8902','2014-04-19','17:35:00',3.79),('8902','2014-04-19','17:40:00',3.57),('8902','2014-04-19','17:45:00',3.39),('8902','2014-04-19','17:50:00',3.21),('8902','2014-04-19','17:55:00',2.99),('8902','2014-04-19','18:00:00',2.82),('8902','2014-04-19','18:05:00',2.59),('8902','2014-04-19','18:10:00',2.42),('8902','2014-04-19','18:15:00',2.13),('8902','2014-04-19','18:20:00',1.48),('8902','2014-04-19','18:25:00',1),('8902','2014-04-19','18:30:00',1.58),('8902','2014-04-19','18:35:00',1.55),('8902','2014-04-19','18:40:00',1.26),('8902','2013-11-26','08:40:00',1.01),('8902','2013-11-26','08:45:00',1.19),('8902','2013-11-26','08:50:00',1.43),('8902','2013-11-26','08:55:00',1.51),('8902','2013-11-26','09:00:00',1.37),('8902','2013-11-26','09:05:00',1.26),('8902','2013-11-26','09:10:00',1.19),('8902','2013-11-26','09:15:00',1.22),('8902','2013-11-26','09:20:00',1.91),('8902','2013-11-26','09:25:00',2.06),('8902','2013-11-26','09:30:00',1.87),('8902','2013-11-26','09:35:00',1.84),('8902','2013-11-26','09:40:00',2.29),('8902','2013-11-26','09:45:00',1.82),('8902','2013-11-26','09:50:00',1.96),('8902','2013-11-26','09:55:00',2.74),('8902','2013-11-26','10:00:00',2.36),('8902','2013-11-26','10:05:00',2.41),('8902','2013-11-26','10:10:00',2.34),('8902','2013-11-26','10:15:00',2.27),('8902','2013-11-26','10:20:00',2.21),('8902','2013-11-26','10:25:00',2.29),('8902','2013-11-26','10:30:00',2.08),('8902','2013-11-26','10:35:00',2.25),('8902','2013-11-26','10:40:00',2.56),('8902','2013-11-26','10:45:00',3.01),('8902','2013-11-26','10:50:00',2.76),('8902','2013-11-26','10:55:00',2.52),('8902','2013-11-26','11:00:00',2.74),('8902','2013-11-26','11:05:00',3.04),('8902','2013-11-26','11:10:00',4.42),('8902','2013-11-26','11:15:00',2.8),('8902','2013-11-26','11:20:00',2.67),('8902','2013-11-26','11:25:00',2.88),('8902','2013-11-26','11:30:00',5.05),('8902','2013-11-26','11:35:00',3.87),('8902','2013-11-26','11:40:00',3.37),('8902','2013-11-26','11:45:00',3.07),('8902','2013-11-26','11:50:00',4.37),('8902','2013-11-26','11:55:00',6.9),('8902','2013-11-26','12:00:00',6.64),('8902','2013-11-26','12:05:00',5.73),('8902','2013-11-26','12:10:00',2.79),('8902','2013-11-26','12:15:00',4.28),('8902','2013-11-26','12:20:00',4.43),('8902','2013-11-26','12:25:00',2.72),('8902','2013-11-26','12:30:00',5.68),('8902','2013-11-26','12:35:00',4.15),('8902','2013-11-26','12:40:00',2.42),('8902','2013-11-26','12:45:00',1.91),('8902','2013-11-26','12:50:00',1.89),('8902','2013-11-26','12:55:00',1.91),('8902','2013-11-26','13:00:00',1.98),('8902','2013-11-26','13:05:00',1.98),('8902','2013-11-26','13:10:00',1.97),('8902','2013-11-26','13:15:00',1.9),('8902','2013-11-26','13:20:00',1.82),('8902','2013-11-26','13:25:00',1.76),('8902','2013-11-26','13:30:00',1.83),('8902','2013-11-26','13:35:00',1.84),('8902','2013-11-26','13:40:00',2.06),('8902','2013-11-26','13:45:00',1.92),('8902','2013-11-26','13:50:00',1.48),('8902','2013-11-26','13:55:00',1.25),('8902','2013-11-26','14:00:00',1.31),('8902','2013-11-26','14:05:00',1.12),('8902','2013-11-25','08:05:00',1.18),('8902','2013-11-25','08:10:00',1.44),('8902','2013-11-25','08:15:00',1.41),('8902','2013-11-25','08:20:00',1.16),('8902','2013-11-25','08:45:00',1.44),('8902','2013-11-25','08:50:00',1.43),('8902','2013-11-25','08:55:00',1.61),('8902','2013-11-25','09:00:00',1.62),('8902','2013-11-25','09:05:00',2.02),('8902','2013-11-25','09:10:00',2.4),('8902','2013-11-25','09:15:00',2.85),('8902','2013-11-25','09:20:00',2.68),('8902','2013-11-25','09:25:00',2.6),('8902','2013-11-25','09:30:00',2.36),('8902','2013-11-25','09:35:00',2.64),('8902','2013-11-25','09:40:00',4.05),('8902','2013-11-25','09:45:00',2.92),('8902','2013-11-25','09:50:00',3.02),('8902','2013-11-25','09:55:00',3.95),('8902','2013-11-25','10:00:00',4.79),('8902','2013-11-25','10:05:00',4.58),('8902','2013-11-25','10:10:00',2.34),('8902','2013-11-25','10:15:00',1.75),('8902','2013-11-25','10:20:00',1.58),('8902','2013-11-25','10:25:00',3.75),('8902','2013-11-25','10:30:00',5.26),('8902','2013-11-25','10:35:00',5.82),('8902','2013-11-25','10:40:00',5.78),('8902','2013-11-25','10:45:00',5.9),('8902','2013-11-25','10:50:00',5.97),('8902','2013-11-25','10:55:00',6.09),('8902','2013-11-25','11:00:00',6.44),('8902','2013-11-25','11:05:00',5.76),('8902','2013-11-25','11:10:00',6.73),('8902','2013-11-25','11:15:00',7.2),('8902','2013-11-25','11:20:00',6.75),('8902','2013-11-25','11:25:00',6.86),('8902','2013-11-25','11:30:00',6.98),('8902','2013-11-25','11:35:00',7.28),('8902','2013-11-25','11:40:00',6.9),('8902','2013-11-25','11:45:00',6.7),('8902','2013-11-25','11:50:00',6.19),('8902','2013-11-25','11:55:00',3.25),('8902','2013-11-25','12:00:00',2.13),('8902','2013-11-25','12:05:00',3.28),('8902','2013-11-25','12:10:00',1.62),('8902','2013-11-25','12:15:00',2.35),('8902','2013-11-25','12:20:00',6.61),('8902','2013-11-25','12:25:00',6.51),('8902','2013-11-25','12:30:00',6.34),('8902','2013-11-25','12:35:00',6.33),('8902','2013-11-25','12:40:00',6.33),('8902','2013-11-25','12:45:00',6.25),('8902','2013-11-25','12:50:00',6.26),('8902','2013-11-25','12:55:00',6.23),('8902','2013-11-25','13:00:00',6.21),('8902','2013-11-25','13:05:00',6.17),('8902','2013-11-25','13:10:00',6.12),('8902','2013-11-25','13:15:00',6.08),('8902','2013-11-25','13:20:00',6),('8902','2013-11-25','13:25:00',5.91),('8902','2013-11-25','13:30:00',5.82),('8902','2013-11-25','13:35:00',5.75),('8902','2013-11-25','13:40:00',5.67),('8902','2013-11-25','13:45:00',5.62),('8902','2013-11-25','13:50:00',5.61),('8902','2013-11-25','13:55:00',5.54),('8902','2013-11-25','14:00:00',5.38),('8902','2013-11-25','14:05:00',3.79),('8902','2013-11-25','14:10:00',6.35),('8902','2013-11-25','14:15:00',6.54),('8902','2013-11-25','14:20:00',5.38),('8902','2013-11-25','14:25:00',3.53),('8902','2013-11-25','14:30:00',3.03),('8902','2013-11-25','14:35:00',3.99),('8902','2013-11-25','14:40:00',4.24),('8902','2013-11-25','14:45:00',4.37),('8902','2013-11-25','14:50:00',4.81),('8902','2013-11-25','14:55:00',4.91),('8902','2013-11-25','15:00:00',4.67),('8902','2013-11-25','15:05:00',4.21),('8902','2013-11-25','15:10:00',3.61),('8902','2013-11-25','15:15:00',3.32),('8902','2013-11-25','15:20:00',3.06),('8902','2013-11-25','15:25:00',2.84),('8902','2013-11-25','15:30:00',2.6),('8902','2013-11-25','15:35:00',2.4),('8902','2013-11-25','15:40:00',2.17),('8902','2013-11-25','15:45:00',1.97),('8902','2013-11-25','15:50:00',1.86),('8902','2013-11-25','15:55:00',1.6),('8902','2013-11-24','08:05:00',1.06),('8902','2013-11-24','08:10:00',1.19),('8902','2013-11-24','08:15:00',1.33),('8902','2013-11-24','08:20:00',1.76),('8902','2013-11-24','08:25:00',2.15),('8902','2013-11-24','08:30:00',2.31),('8902','2013-11-24','08:35:00',2.52),('8902','2013-11-24','08:40:00',2.68),('8902','2013-11-24','08:45:00',2.98),('8902','2013-11-24','08:50:00',3.27),('8902','2013-11-24','08:55:00',3.61),('8902','2013-11-24','09:00:00',4.02),('8902','2013-11-24','09:05:00',4.16),('8902','2013-11-24','09:10:00',4.26),('8902','2013-11-24','09:15:00',4.51),('8902','2013-11-24','09:20:00',4.6),('8902','2013-11-24','09:25:00',3.66),('8902','2013-11-24','09:30:00',3.76),('8902','2013-11-24','09:35:00',4.71),('8902','2013-11-24','09:40:00',5.06),('8902','2013-11-24','09:45:00',2.64),('8902','2013-11-24','09:50:00',3.32),('8902','2013-11-24','09:55:00',2.68),('8902','2013-11-24','10:00:00',3.57),('8902','2013-11-24','10:05:00',3.49),('8902','2013-11-24','10:10:00',3.76),('8902','2013-11-24','10:15:00',3.85),('8902','2013-11-24','10:20:00',3.33),('8902','2013-11-24','10:25:00',3.99),('8902','2013-11-24','10:30:00',4.13),('8902','2013-11-24','10:35:00',3.97),('8902','2013-11-24','10:40:00',6.9),('8902','2013-11-24','10:45:00',6.07),('8902','2013-11-24','10:50:00',6.03),('8902','2013-11-24','10:55:00',4.5),('8902','2013-11-24','11:00:00',5.98),('8902','2013-11-24','11:05:00',6.21),('8902','2013-11-24','11:10:00',7.03),('8902','2013-11-24','11:15:00',5.15),('8902','2013-11-24','11:20:00',3.67),('8902','2013-11-24','11:25:00',2.49),('8902','2013-11-24','11:30:00',2.81),('8902','2013-11-24','11:35:00',2.6),('8902','2013-11-24','11:40:00',2.34),('8902','2013-11-24','11:45:00',2.44),('8902','2013-11-24','11:50:00',2.74),('8902','2013-11-24','11:55:00',3.71),('8902','2013-11-24','12:00:00',3.31),('8902','2013-11-24','12:05:00',3.47),('8902','2013-11-24','12:10:00',3.62),('8902','2013-11-24','12:15:00',3.36),('8902','2013-11-24','12:20:00',3.05),('8902','2013-11-24','12:25:00',2.97),('8902','2013-11-24','12:30:00',2.65),('8902','2013-11-24','12:35:00',2.41),('8902','2013-11-24','12:40:00',5.61),('8902','2013-11-24','12:45:00',6.46),('8902','2013-11-24','12:50:00',5),('8902','2013-11-24','12:55:00',5.41),('8902','2013-11-24','13:00:00',7.05),('8902','2013-11-24','13:05:00',7.44),('8902','2013-11-24','13:10:00',5.37),('8902','2013-11-24','13:15:00',4.7),('8902','2013-11-24','13:20:00',5.17),('8902','2013-11-24','13:25:00',3.43),('8902','2013-11-24','13:30:00',2.37),('8902','2013-11-24','13:35:00',1.96),('8902','2013-11-24','13:40:00',1.81),('8902','2013-11-24','13:45:00',1.79),('8902','2013-11-24','13:50:00',1.63),('8902','2013-11-24','13:55:00',1.32),('8902','2013-11-24','14:00:00',1.06),('8902','2013-11-23','09:50:00',1.48),('8902','2013-11-23','09:55:00',2.12),('8902','2013-11-23','10:00:00',2.62),('8902','2013-11-23','10:05:00',2.83),('8902','2013-11-23','10:10:00',2.92),('8902','2013-11-23','10:15:00',2.49),('8902','2013-11-23','10:20:00',2.32),('8902','2013-11-23','10:25:00',3.28),('8902','2013-11-23','10:30:00',3.04),('8902','2013-11-23','10:35:00',2.63),('8902','2013-11-23','10:40:00',2.28),('8902','2013-11-23','10:45:00',2.04),('8902','2013-11-23','10:50:00',2.07),('8902','2013-11-23','10:55:00',2.2),('8902','2013-11-23','11:00:00',2.24),('8902','2013-11-23','11:05:00',2.31),('8902','2013-11-23','11:10:00',2.44),('8902','2013-11-23','11:15:00',2.51),('8902','2013-11-23','11:20:00',2.94),('8902','2013-11-23','11:25:00',2.95),('8902','2013-11-23','11:30:00',2.62),('8902','2013-11-23','11:35:00',2.33),('8902','2013-11-23','11:40:00',2.3),('8902','2013-11-23','11:45:00',2.18),('8902','2013-11-23','11:50:00',2.4),('8902','2013-11-23','11:55:00',2.02),('8902','2013-11-23','12:00:00',1.49),('8902','2013-11-23','12:05:00',1.14),('8902','2013-11-23','12:10:00',1.09),('8902','2013-11-23','12:15:00',1.39),('8902','2013-11-23','12:20:00',1.56),('8902','2013-11-23','12:25:00',1.67),('8902','2013-11-23','12:30:00',1.65),('8902','2013-11-23','12:35:00',1.71),('8902','2013-11-23','12:40:00',1.73),('8902','2013-11-23','12:45:00',1.71),('8902','2013-11-23','12:50:00',1.73),('8902','2013-11-23','12:55:00',1.85),('8902','2013-11-23','13:00:00',2.04),('8902','2013-11-23','13:05:00',2.39),('8902','2013-11-23','13:10:00',2.78),('8902','2013-11-23','13:15:00',2.93),('8902','2013-11-23','13:20:00',2.2),('8902','2013-11-23','13:25:00',1.75),('8902','2013-11-23','13:30:00',1.51),('8902','2013-11-23','13:35:00',1.47),('8902','2013-11-23','13:40:00',1.37),('8902','2013-11-23','13:45:00',1.25),('8902','2013-11-23','13:50:00',1.12),('8902','2013-11-23','13:55:00',1.05),('8902','2013-11-23','14:00:00',1.1),('8902','2013-11-23','14:05:00',1.14),('8902','2013-11-23','14:10:00',1.1),('8902','2013-11-23','14:15:00',1.09),('8902','2013-11-23','14:20:00',1.1),('8902','2013-11-23','14:25:00',1.11),('8902','2013-11-23','14:30:00',1.05),('8902','2013-11-22','08:20:00',1.11),('8902','2013-11-22','08:25:00',1.26),('8902','2013-11-22','08:35:00',1.05),('8902','2013-11-22','08:40:00',1.29),('8902','2013-11-22','08:45:00',1.1),('8902','2013-11-22','10:00:00',1.08),('8902','2013-11-22','10:05:00',1.25),('8902','2013-11-22','10:10:00',1.33),('8902','2013-11-22','10:15:00',2.26),('8902','2013-11-22','10:20:00',2.43),('8902','2013-11-22','10:25:00',2.43),('8902','2013-11-22','10:30:00',3.38),('8902','2013-11-22','10:35:00',1.98),('8902','2013-11-22','10:40:00',5.75),('8902','2013-11-22','10:45:00',1.34),('8902','2013-11-22','11:15:00',1.06),('8902','2013-11-22','11:20:00',1.19),('8902','2013-11-22','11:25:00',1.43),('8902','2013-11-22','11:30:00',1.32),('8902','2013-11-22','11:35:00',1.23),('8902','2013-11-22','11:40:00',1.42),('8902','2013-11-22','11:45:00',1.33),('8902','2013-11-22','13:15:00',1.01),('8902','2013-11-22','13:20:00',1.57),('8902','2013-11-22','13:25:00',3.05),('8902','2013-11-22','13:30:00',1.96),('8902','2013-11-22','13:35:00',2.48),('8902','2013-11-22','13:40:00',2.3),('8902','2013-11-22','13:45:00',1.82),('8902','2013-11-22','13:50:00',1.86),('8902','2013-11-22','13:55:00',1.85),('8902','2013-11-22','14:00:00',2.22),('8902','2013-11-22','14:05:00',2.9),('8902','2013-11-22','14:10:00',1.15),('8902','2013-11-22','14:50:00',1.37),('8902','2013-11-22','14:55:00',1.6),('8902','2013-11-22','15:00:00',1.34),('8902','2013-11-22','15:05:00',1.16),('8902','2013-11-22','15:15:00',1.05),('8902','2013-11-22','15:20:00',1.03),('8902','2013-11-21','09:20:00',1.11),('8902','2013-11-21','09:25:00',1.02),('8902','2013-11-21','10:00:00',1.11),('8902','2013-11-20','08:10:00',1.76),('8902','2013-11-20','08:15:00',2.12),('8902','2013-11-20','08:20:00',1.47),('8902','2013-11-20','09:05:00',1.06),('8902','2013-11-20','09:10:00',1.92),('8902','2013-11-20','09:15:00',2.07),('8902','2013-11-20','09:20:00',2.59),('8902','2013-11-20','09:25:00',2.16),('8902','2013-11-20','09:30:00',2.4),('8902','2013-11-20','09:35:00',1.88),('8902','2013-11-20','09:40:00',2.88),('8902','2013-11-20','09:45:00',4.61),('8902','2013-11-20','09:50:00',3.92),('8902','2013-11-20','09:55:00',3.52),('8902','2013-11-20','10:00:00',3.54),('8902','2013-11-20','10:05:00',5.37),('8902','2013-11-20','10:10:00',4.68),('8902','2013-11-20','10:15:00',5.21),('8902','2013-11-20','10:20:00',5.23),('8902','2013-11-20','10:25:00',3.62),('8902','2013-11-20','10:30:00',3.88),('8902','2013-11-20','10:35:00',4.94),('8902','2013-11-20','10:40:00',5.38),('8902','2013-11-20','10:45:00',4.98),('8902','2013-11-20','10:50:00',1.3),('8902','2013-11-20','10:55:00',1.14),('8902','2013-11-20','11:00:00',1.32),('8902','2013-11-20','11:05:00',1.34),('8902','2013-11-20','11:10:00',1.53),('8902','2013-11-20','11:15:00',1.92),('8902','2013-11-20','11:20:00',2.84),('8902','2013-11-20','11:25:00',3.08),('8902','2013-11-20','11:30:00',4.55),('8902','2013-11-20','11:35:00',5.29),('8902','2013-11-20','11:40:00',6.09),('8902','2013-11-20','11:45:00',2.41),('8902','2013-11-20','11:50:00',6.29),('8902','2013-11-20','11:55:00',5.72),('8902','2013-11-20','12:00:00',4.24),('8902','2013-11-20','12:05:00',4.86),('8902','2013-11-20','12:10:00',6.28),('8902','2013-11-20','12:15:00',6.22),('8902','2013-11-20','12:20:00',6.24),('8902','2013-11-20','12:25:00',6.32),('8902','2013-11-20','12:30:00',6.66),('8902','2013-11-20','12:35:00',6.68),('8902','2013-11-20','12:40:00',6.88),('8902','2013-11-20','12:45:00',6.89),('8902','2013-11-20','12:50:00',6.3),('8902','2013-11-20','12:55:00',6.85),('8902','2013-11-20','13:00:00',6.72),('8902','2013-11-20','13:05:00',6.79),('8902','2013-11-20','13:10:00',6.16),('8902','2013-11-20','13:15:00',6.27),('8902','2013-11-20','13:20:00',6.32),('8902','2013-11-20','13:25:00',5.7),('8902','2013-11-20','13:30:00',2.4),('8902','2013-11-20','13:35:00',2),('8902','2013-11-20','13:40:00',4.69),('8902','2013-11-20','13:45:00',5.82),('8902','2013-11-20','13:50:00',3.09),('8902','2013-11-20','13:55:00',2.99),('8902','2013-11-20','14:00:00',5.62),('8902','2013-11-20','14:05:00',4.16),('8902','2013-11-20','14:10:00',3.29),('8902','2013-11-20','14:15:00',1.58),('8902','2013-11-20','14:20:00',1.12),('8902','2013-11-20','14:25:00',2.43),('8902','2013-11-20','14:30:00',1.25),('8902','2013-11-20','14:40:00',2.51),('8902','2013-11-20','14:45:00',3.89),('8902','2013-11-20','14:50:00',3.76),('8902','2013-11-20','14:55:00',2.74),('8902','2013-11-20','15:00:00',3.38),('8902','2013-11-20','15:05:00',3.2),('8902','2013-11-20','15:10:00',3.03),('8902','2013-11-20','15:15:00',2.79),('8902','2013-11-20','15:20:00',2.41),('8902','2013-11-20','15:25:00',2.43),('8902','2013-11-20','15:30:00',1.38),('8902','2013-11-19','08:20:00',2.37),('8902','2013-11-19','08:55:00',1.81),('8902','2013-11-19','09:00:00',2.51),('8902','2013-11-19','09:15:00',3.48),('8902','2013-11-19','09:20:00',3.46),('8902','2013-11-19','09:25:00',4.07),('8902','2013-11-19','09:30:00',4.31),('8902','2013-11-19','09:35:00',2.72),('8902','2013-11-19','09:40:00',1.61),('8902','2013-11-19','09:55:00',1.12),('8902','2013-11-19','10:00:00',2.71),('8902','2013-11-19','10:05:00',2.08),('8902','2013-11-19','10:10:00',2.16),('8902','2013-11-19','10:15:00',3.68),('8902','2013-11-19','10:20:00',1.7),('8902','2013-11-19','10:25:00',1.4),('8902','2013-11-19','10:30:00',1.81),('8902','2013-11-19','10:35:00',1.48),('8902','2013-11-19','10:40:00',1.4),('8902','2013-11-19','10:45:00',1.05),('8902','2013-11-19','10:50:00',1.52),('8902','2013-11-19','10:55:00',1.64),('8902','2013-11-19','11:00:00',1.39),('8902','2013-11-19','11:05:00',1.37),('8902','2013-11-19','11:10:00',1.26),('8902','2013-11-19','11:15:00',1.17),('8902','2013-11-19','11:20:00',1.75),('8902','2013-11-19','11:25:00',2.24),('8902','2013-11-19','11:30:00',2.27),('8902','2013-11-19','11:35:00',1.91),('8902','2013-11-19','11:40:00',1.86),('8902','2013-11-19','11:45:00',6.02),('8902','2013-11-19','11:50:00',8.08),('8902','2013-11-19','11:55:00',4.4),('8902','2013-11-19','12:00:00',2.26),('8902','2013-11-19','12:15:00',1.75),('8902','2013-11-19','12:20:00',3.39),('8902','2013-11-19','12:25:00',2.09),('8902','2013-11-19','12:30:00',1.85),('8902','2013-11-19','12:35:00',1.27),('8902','2013-11-19','12:40:00',2.36),('8902','2013-11-19','12:45:00',2.35),('8902','2013-11-19','12:50:00',3.31),('8902','2013-11-19','12:55:00',4.78),('8902','2013-11-19','13:00:00',5.83),('8902','2013-11-19','13:05:00',4.38),('8902','2013-11-19','13:10:00',2.94),('8902','2013-11-19','13:15:00',1.35),('8902','2013-11-19','13:20:00',3.59),('8902','2013-11-19','13:25:00',2.83),('8902','2013-11-19','13:30:00',2.71),('8902','2013-11-19','13:35:00',1.13),('8902','2013-11-19','13:40:00',3.69),('8902','2013-11-19','13:45:00',2.25),('8902','2013-11-19','13:50:00',3.21),('8902','2013-11-19','13:55:00',2.9),('8902','2013-11-19','14:00:00',2.15),('8902','2013-11-19','14:05:00',1.92),('8902','2013-11-19','14:10:00',1.63),('8902','2013-11-19','14:15:00',1.36),('8902','2013-11-19','14:20:00',1.53),('8902','2013-11-19','14:25:00',2.29),('8902','2013-11-19','14:30:00',1.82),('8902','2013-11-19','14:35:00',1.54),('8902','2013-11-19','14:40:00',2.39),('8902','2013-11-19','14:45:00',3.47),('8902','2013-11-19','15:05:00',2.53),('8902','2013-11-19','15:10:00',3.26),('8902','2013-11-19','15:15:00',2.52),('8902','2013-11-19','15:20:00',2.22),('8902','2013-11-19','15:25:00',2.37),('8902','2013-11-19','15:30:00',1.1),('8902','2013-11-19','15:35:00',1.6),('8902','2013-11-18','08:30:00',1.02),('8902','2013-11-18','09:35:00',2.13),('8902','2013-11-18','09:40:00',4.28),('8902','2013-11-18','09:45:00',4.15),('8902','2013-11-18','09:50:00',2.8),('8902','2013-11-18','09:55:00',1.19),('8902','2013-11-18','10:00:00',2.51),('8902','2013-11-18','10:05:00',2.88),('8902','2013-11-18','10:10:00',1.05),('8902','2013-11-18','10:20:00',1.37),('8902','2013-11-18','10:25:00',1.22),('8902','2013-11-18','10:45:00',1.78),('8902','2013-11-18','10:50:00',3.24),('8902','2013-11-18','10:55:00',1.91),('8902','2013-11-18','11:00:00',1.08),('8902','2013-11-18','11:05:00',1.38),('8902','2013-11-18','11:10:00',1.81),('8902','2013-11-18','11:15:00',1.66),('8902','2013-11-18','11:20:00',5.49),('8902','2013-11-18','11:25:00',4.85),('8902','2013-11-18','11:30:00',6.09),('8902','2013-11-18','11:35:00',6.03),('8902','2013-11-18','11:40:00',4.93),('8902','2013-11-18','11:45:00',5.61),('8902','2013-11-18','11:50:00',5.64),('8902','2013-11-18','11:55:00',5.62),('8902','2013-11-18','12:00:00',5.1),('8902','2013-11-18','12:05:00',5.01),('8902','2013-11-18','12:10:00',5.49),('8902','2013-11-18','12:15:00',5.66),('8902','2013-11-18','12:20:00',3.33),('8902','2013-11-18','12:25:00',1.27),('8902','2013-11-18','12:30:00',3.12),('8902','2013-11-18','12:35:00',1.18),('8902','2013-11-18','12:40:00',1.17),('8902','2013-11-18','12:45:00',3.91),('8902','2013-11-18','12:50:00',3.01),('8902','2013-11-18','12:55:00',6.28),('8902','2013-11-18','13:00:00',6.05),('8902','2013-11-18','13:05:00',1.96),('8902','2013-11-18','13:10:00',3.42),('8902','2013-11-18','13:15:00',4.24),('8902','2013-11-18','13:20:00',5.11),('8902','2013-11-18','13:25:00',2.87),('8902','2013-11-18','13:30:00',1.42),('8902','2013-11-18','14:30:00',1.07),('8902','2013-11-18','14:35:00',1.03),('8902','2013-11-18','14:40:00',1.2),('8902','2013-11-18','14:45:00',1.27),('8902','2013-11-18','14:50:00',1.18),('8902','2013-11-18','14:55:00',1.3),('8902','2013-11-18','15:25:00',2.75),('8902','2013-11-18','15:30:00',3.49),('8902','2013-11-18','15:35:00',2.84),('8902','2013-11-18','15:40:00',2.43),('8902','2013-11-18','15:45:00',2.13),('8902','2013-11-18','15:50:00',1.77),('8902','2013-11-18','15:55:00',1.36),('8902','2013-11-18','16:00:00',1.06),('8902','2013-11-17','07:55:00',1.06),('8902','2013-11-17','08:00:00',1.4),('8902','2013-11-17','08:05:00',1.42),('8902','2013-11-17','08:10:00',1.48),('8902','2013-11-17','08:15:00',1.66),('8902','2013-11-17','08:20:00',1.78),('8902','2013-11-17','08:25:00',1.92),('8902','2013-11-17','08:30:00',2.2),('8902','2013-11-17','08:35:00',2.19),('8902','2013-11-17','08:40:00',2.14),('8902','2013-11-17','08:45:00',2.09),('8902','2013-11-17','08:50:00',1.89),('8902','2013-11-17','08:55:00',1.86),('8902','2013-11-17','09:00:00',1.86),('8902','2013-11-17','09:05:00',1.71),('8902','2013-11-17','09:10:00',1.62),('8902','2013-11-17','09:15:00',2.39),('8902','2013-11-17','09:20:00',3.22),('8902','2013-11-17','09:25:00',3.37),('8902','2013-11-17','09:30:00',3.07),('8902','2013-11-17','09:35:00',4.03),('8902','2013-11-17','09:40:00',3.23),('8902','2013-11-17','09:45:00',2.78),('8902','2013-11-17','09:50:00',2.12),('8902','2013-11-17','09:55:00',2.14),('8902','2013-11-17','10:00:00',2.41),('8902','2013-11-17','10:05:00',2.73),('8902','2013-11-17','10:10:00',2.93),('8902','2013-11-17','10:15:00',3.59),('8902','2013-11-17','10:20:00',2.98),('8902','2013-11-17','10:25:00',2.65),('8902','2013-11-17','10:30:00',2.45),('8902','2013-11-17','10:35:00',2.32),('8902','2013-11-17','10:40:00',2.42),('8902','2013-11-17','10:45:00',2.52),('8902','2013-11-17','10:50:00',2.39),('8902','2013-11-17','10:55:00',2.09),('8902','2013-11-17','11:00:00',1.87),('8902','2013-11-17','11:05:00',1.71),('8902','2013-11-17','11:10:00',1.57),('8902','2013-11-17','11:15:00',1.46),('8902','2013-11-17','11:20:00',1.55),('8902','2013-11-17','11:25:00',1.82),('8902','2013-11-17','11:30:00',2.07),('8902','2013-11-17','11:35:00',2.19),('8902','2013-11-17','11:40:00',2.28),('8902','2013-11-17','11:45:00',2.36),('8902','2013-11-17','11:50:00',2.46),('8902','2013-11-17','11:55:00',2.65),('8902','2013-11-17','12:00:00',2.8),('8902','2013-11-17','12:05:00',2.97),('8902','2013-11-17','12:10:00',2.97),('8902','2013-11-17','12:15:00',3.06),('8902','2013-11-17','12:20:00',3.23),('8902','2013-11-17','12:25:00',3.45),('8902','2013-11-17','12:30:00',2.92),('8902','2013-11-17','12:35:00',2.51),('8902','2013-11-17','12:40:00',2.18),('8902','2013-11-17','12:45:00',1.94),('8902','2013-11-17','12:50:00',1.8),('8902','2013-11-17','12:55:00',1.73),('8902','2013-11-17','13:00:00',1.72),('8902','2013-11-17','13:05:00',1.84),('8902','2013-11-17','13:10:00',2.17),('8902','2013-11-17','13:15:00',2.01),('8902','2013-11-17','13:20:00',1.87),('8902','2013-11-17','13:25:00',1.65),('8902','2013-11-17','13:30:00',1.84),('8902','2013-11-17','13:35:00',2.3),('8902','2013-11-17','13:40:00',2.36),('8902','2013-11-17','13:45:00',2.09),('8902','2013-11-17','13:50:00',2.04),('8902','2013-11-17','13:55:00',1.71),('8902','2013-11-17','14:00:00',1.43),('8902','2013-11-17','14:05:00',1.14),('8902','2014-04-18','07:35:00',1.15),('8902','2014-04-18','07:40:00',1.4),('8902','2014-04-18','07:45:00',1.13),('8902','2014-04-18','07:50:00',1.32),('8902','2014-04-18','07:55:00',2.54),('8902','2014-04-18','08:00:00',2.62),('8902','2014-04-18','08:05:00',1.91),('8902','2014-04-18','08:10:00',2.34),('8902','2014-04-18','08:15:00',1.9),('8902','2014-04-18','08:20:00',2.06),('8902','2014-04-18','08:25:00',2.63),('8902','2014-04-18','08:30:00',3.33),('8902','2014-04-18','08:35:00',4.16),('8902','2014-04-18','08:40:00',3.51),('8902','2014-04-18','08:45:00',3.64),('8902','2014-04-18','08:50:00',2.89),('8902','2014-04-18','08:55:00',2.04),('8902','2014-04-18','09:00:00',1.23),('8902','2014-04-18','09:05:00',1.06),('8902','2014-04-18','09:10:00',1.24),('8902','2014-04-18','09:15:00',1.59),('8902','2014-04-18','09:20:00',1.89),('8902','2014-04-18','09:25:00',2.51),('8902','2014-04-18','09:30:00',3.83),('8902','2014-04-18','09:35:00',3.98),('8902','2014-04-18','09:40:00',2.42),('8902','2014-04-18','09:45:00',1.8),('8902','2014-04-18','09:50:00',1.51),('8902','2014-04-18','09:55:00',1.38),('8902','2014-04-18','10:00:00',1.47),('8902','2014-04-18','10:05:00',1.25),('8902','2014-04-18','10:10:00',1.12),('8902','2014-04-18','10:15:00',1.25),('8902','2014-04-18','10:20:00',1.59),('8902','2014-04-18','10:25:00',1.49),('8902','2014-04-18','10:30:00',1.45),('8902','2014-04-18','10:35:00',1.69),('8902','2014-04-18','10:40:00',2.32),('8902','2014-04-18','10:45:00',2.24),('8902','2014-04-18','10:50:00',2.26),('8902','2014-04-18','10:55:00',2.83),('8902','2014-04-18','11:00:00',3.08),('8902','2014-04-18','11:05:00',2.51),('8902','2014-04-18','11:10:00',2.28),('8902','2014-04-18','11:15:00',3.28),('8902','2014-04-18','11:20:00',5.56),('8902','2014-04-18','11:25:00',4.89),('8902','2014-04-18','11:30:00',5.2),('8902','2014-04-18','11:35:00',4.6),('8902','2014-04-18','11:40:00',4.28),('8902','2014-04-18','11:45:00',4.54),('8902','2014-04-18','11:50:00',3.63),('8902','2014-04-18','11:55:00',2.1),('8902','2014-04-18','12:00:00',1.63),('8902','2014-04-18','12:05:00',1.35),('8902','2014-04-18','12:10:00',1.03),('8902','2014-04-18','13:15:00',2.73),('8902','2014-04-18','13:20:00',2.21),('8902','2014-04-18','13:35:00',1.27),('8902','2014-04-18','13:40:00',1.37),('8902','2014-04-18','13:45:00',1.04),('8902','2014-04-18','13:50:00',1.59),('8902','2014-04-18','13:55:00',1.3),('8902','2014-04-18','14:20:00',1.07),('8902','2014-04-18','14:25:00',1.19),('8902','2014-04-18','14:30:00',2.49),('8902','2014-04-18','14:35:00',2.96),('8902','2014-04-18','14:40:00',3.44),('8902','2014-04-18','14:45:00',3.66),('8902','2014-04-18','14:50:00',2.6),('8902','2014-04-18','14:55:00',2.05),('8902','2014-04-18','15:00:00',2.65),('8902','2014-04-18','15:05:00',2.42),('8902','2014-04-18','15:10:00',1.17),('8902','2014-04-18','15:20:00',1.25),('8902','2014-04-18','15:25:00',2.08),('8902','2014-04-18','15:30:00',2.23),('8902','2014-04-18','15:35:00',1.34),('8902','2014-04-18','15:45:00',1.69),('8902','2014-04-18','15:50:00',6.7),('8902','2014-04-18','15:55:00',6.72),('8902','2014-04-18','16:00:00',3.34),('8902','2014-04-18','16:05:00',3.08),('8902','2014-04-18','16:10:00',3.1),('8902','2014-04-18','16:15:00',3.19),('8902','2014-04-18','16:20:00',4.1),('8902','2014-04-18','16:25:00',4.06),('8902','2014-04-18','16:30:00',6.25),('8902','2014-04-18','16:35:00',3.19),('8902','2014-04-18','16:40:00',2.16),('8902','2014-04-18','16:45:00',1.78),('8902','2014-04-18','16:50:00',1.45),('8902','2014-04-18','17:00:00',1.02),('8902','2014-04-18','17:05:00',1.47),('8902','2014-04-18','17:10:00',1.79),('8902','2014-04-18','17:15:00',1.88),('8902','2014-04-18','17:20:00',3.21),('8902','2014-04-18','17:25:00',2.71),('8902','2014-04-18','17:30:00',2.28),('8902','2014-04-18','17:35:00',1.88),('8902','2014-04-18','17:40:00',1.16),('8902','2013-11-16','08:40:00',1.07),('8902','2013-11-16','08:45:00',2.76),('8902','2013-11-16','08:50:00',3.69),('8902','2013-11-16','08:55:00',4.02),('8902','2013-11-16','09:00:00',2.98),('8902','2013-11-16','09:05:00',3.51),('8902','2013-11-16','09:10:00',3.6),('8902','2013-11-16','09:15:00',3.82),('8902','2013-11-16','09:20:00',3.91),('8902','2013-11-16','09:25:00',3.99),('8902','2013-11-16','09:30:00',4.11),('8902','2013-11-16','09:35:00',4.16),('8902','2013-11-16','09:40:00',4.26),('8902','2013-11-16','09:45:00',4.36),('8902','2013-11-16','09:50:00',4.47),('8902','2013-11-16','09:55:00',4.57),('8902','2013-11-16','10:00:00',4.67),('8902','2013-11-16','10:05:00',4.78),('8902','2013-11-16','10:10:00',4.87),('8902','2013-11-16','10:15:00',4.97),('8902','2013-11-16','10:20:00',5.03),('8902','2013-11-16','10:25:00',5.09),('8902','2013-11-16','10:30:00',5.18),('8902','2013-11-16','10:35:00',5.22),('8902','2013-11-16','10:40:00',5.28),('8902','2013-11-16','10:45:00',5.37),('8902','2013-11-16','10:50:00',5.43),('8902','2013-11-16','10:55:00',5.47),('8902','2013-11-16','11:00:00',5.51),('8902','2013-11-16','11:05:00',5.55),('8902','2013-11-16','11:10:00',5.57),('8902','2013-11-16','11:15:00',5.61),('8902','2013-11-16','11:20:00',5.61),('8902','2013-11-16','11:25:00',5.68),('8902','2013-11-16','11:30:00',5.67),('8902','2013-11-16','11:35:00',5.69),('8902','2013-11-16','11:40:00',5.68),('8902','2013-11-16','11:45:00',5.75),('8902','2013-11-16','11:50:00',5.74),('8902','2013-11-16','11:55:00',5.71),('8902','2013-11-16','12:00:00',5.71),('8902','2013-11-16','12:05:00',5.71),('8902','2013-11-16','12:10:00',5.7),('8902','2013-11-16','12:15:00',5.71),('8902','2013-11-16','12:20:00',5.75),('8902','2013-11-16','12:25:00',5.73),('8902','2013-11-16','12:30:00',5.71),('8902','2013-11-16','12:35:00',5.71),('8902','2013-11-16','12:40:00',5.66),('8902','2013-11-16','12:45:00',5.6),('8902','2013-11-16','12:50:00',5.54),('8902','2013-11-16','12:55:00',5.48),('8902','2013-11-16','13:00:00',5.44),('8902','2013-11-16','13:05:00',5.39),('8902','2013-11-16','13:10:00',5.35),('8902','2013-11-16','13:15:00',5.32),('8902','2013-11-16','13:20:00',5.27),('8902','2013-11-16','13:25:00',5.27),('8902','2013-11-16','13:30:00',5.22),('8902','2013-11-16','13:35:00',3.63),('8902','2013-11-16','13:40:00',4.65),('8902','2013-11-16','13:45:00',2.85),('8902','2013-11-16','13:50:00',1.68),('8902','2013-11-16','13:55:00',3.46),('8902','2013-11-16','14:00:00',4.63),('8902','2013-11-16','14:05:00',4.48),('8902','2013-11-16','14:10:00',4.36),('8902','2013-11-16','14:15:00',4.31),('8902','2013-11-16','14:20:00',4.23),('8902','2013-11-16','14:25:00',4.04),('8902','2013-11-16','14:30:00',3.69),('8902','2013-11-16','14:35:00',3.62),('8902','2013-11-16','14:40:00',3.09),('8902','2013-11-16','14:45:00',1.19),('8902','2013-11-16','14:50:00',1.53),('8902','2013-11-16','15:30:00',2.25),('8902','2013-11-16','15:35:00',2.09),('8902','2013-11-16','15:40:00',1.88),('8902','2013-11-16','15:45:00',1.71),('8902','2013-11-16','15:50:00',1.53),('8902','2013-11-16','15:55:00',1.35),('8902','2013-11-16','16:00:00',1.17),('8902','2013-11-15','12:50:00',1.17),('8902','2013-11-15','12:55:00',1.27),('8902','2013-11-15','13:00:00',1.39),('8902','2013-11-15','13:05:00',1.7),('8902','2013-11-15','13:10:00',1.53),('8902','2013-11-15','13:15:00',1.24),('8902','2013-11-15','13:20:00',1.1),('8902','2013-11-15','13:25:00',1.11),('8902','2013-11-15','13:30:00',1.03),('8902','2013-11-15','13:50:00',1.02),('8902','2013-11-15','13:55:00',1.05),('8902','2013-11-14','08:10:00',1.17),('8902','2013-11-14','08:15:00',1.48),('8902','2013-11-14','08:20:00',1.54),('8902','2013-11-14','08:45:00',1.12),('8902','2013-11-14','08:50:00',1.23),('8902','2013-11-14','08:55:00',1.37),('8902','2013-11-14','09:00:00',1.51),('8902','2013-11-14','09:05:00',1.75),('8902','2013-11-14','09:10:00',2.05),('8902','2013-11-14','09:15:00',2.12),('8902','2013-11-14','09:20:00',1.67),('8902','2013-11-14','09:25:00',1.65),('8902','2013-11-14','09:30:00',2.11),('8902','2013-11-14','09:35:00',2.16),('8902','2013-11-14','09:40:00',1.81),('8902','2013-11-14','09:45:00',1.27),('8902','2013-11-14','10:00:00',1.12),('8902','2013-11-14','10:05:00',1.32),('8902','2013-11-14','10:10:00',1.82),('8902','2013-11-14','10:15:00',2.47),('8902','2013-11-14','10:20:00',2.41),('8902','2013-11-14','10:25:00',1.89),('8902','2013-11-14','10:30:00',1.67),('8902','2013-11-14','10:35:00',1.59),('8902','2013-11-14','10:40:00',1.42),('8902','2013-11-14','10:45:00',1.53),('8902','2013-11-14','10:50:00',2.75),('8902','2013-11-14','10:55:00',4.04),('8902','2013-11-14','11:00:00',2.8),('8902','2013-11-14','11:05:00',2.47),('8902','2013-11-14','11:10:00',2.35),('8902','2013-11-14','11:15:00',2.81),('8902','2013-11-14','11:20:00',3.69),('8902','2013-11-14','11:25:00',5.82),('8902','2013-11-14','11:30:00',3.26),('8902','2013-11-14','11:35:00',3.58),('8902','2013-11-14','11:40:00',3.87),('8902','2013-11-14','11:45:00',3.33),('8902','2013-11-14','11:50:00',2.72),('8902','2013-11-14','11:55:00',2.5),('8902','2013-11-14','12:00:00',2.75),('8902','2013-11-14','12:05:00',2.46),('8902','2013-11-14','12:10:00',2.52),('8902','2013-11-14','12:15:00',2.41),('8902','2013-11-14','12:20:00',2.93),('8902','2013-11-14','12:25:00',4.02),('8902','2013-11-14','12:30:00',3.2),('8902','2013-11-14','12:35:00',2.69),('8902','2013-11-14','12:40:00',2.44),('8902','2013-11-14','12:45:00',2.48),('8902','2013-11-14','12:50:00',3.4),('8902','2013-11-14','12:55:00',3.13),('8902','2013-11-14','13:00:00',2.89),('8902','2013-11-14','13:05:00',2.58),('8902','2013-11-14','13:10:00',2.63),('8902','2013-11-14','13:15:00',1.86),('8902','2013-11-14','13:20:00',1.77),('8902','2013-11-14','13:25:00',1.99),('8902','2013-11-14','13:30:00',2.29),('8902','2013-11-14','13:35:00',2.47),('8902','2013-11-14','13:40:00',2.65),('8902','2013-11-14','13:45:00',3.78),('8902','2013-11-14','13:50:00',3.95),('8902','2013-11-14','13:55:00',2.31),('8902','2013-11-14','14:00:00',2.58),('8902','2013-11-14','14:05:00',2.16),('8902','2013-11-14','14:10:00',1.71),('8902','2013-11-14','14:15:00',1.37),('8902','2013-11-13','08:15:00',1.34),('8902','2013-11-13','08:20:00',1.96),('8902','2013-11-13','08:25:00',2.09),('8902','2013-11-13','08:30:00',2.03),('8902','2013-11-13','08:35:00',2.18),('8902','2013-11-13','08:40:00',1.87),('8902','2013-11-13','08:45:00',1.03),('8902','2013-11-13','08:50:00',1.59),('8902','2013-11-13','08:55:00',2.22),('8902','2013-11-13','09:00:00',1.98),('8902','2013-11-13','09:05:00',3.53),('8902','2013-11-13','09:10:00',2.99),('8902','2013-11-13','09:15:00',3.58),('8902','2013-11-13','09:20:00',3.94),('8902','2013-11-13','09:25:00',3.97),('8902','2013-11-13','09:30:00',4.1),('8902','2013-11-13','09:35:00',4.18),('8902','2013-11-13','09:40:00',4.27),('8902','2013-11-13','09:45:00',4.08),('8902','2013-11-13','09:50:00',1.03),('8902','2013-11-13','09:55:00',1.27),('8902','2013-11-13','10:00:00',1.6),('8902','2013-11-13','10:05:00',3.5),('8902','2013-11-13','10:10:00',1.34),('8902','2013-11-13','10:15:00',5.09),('8902','2013-11-13','10:20:00',5.17),('8902','2013-11-13','10:25:00',5.16),('8902','2013-11-13','10:30:00',5.17),('8902','2013-11-13','10:35:00',5.16),('8902','2013-11-13','10:40:00',5.21),('8902','2013-11-13','10:45:00',5.32),('8902','2013-11-13','10:50:00',5.35),('8902','2013-11-13','10:55:00',5.4),('8902','2013-11-13','11:00:00',5.39),('8902','2013-11-13','11:05:00',5.59),('8902','2013-11-13','11:10:00',5.69),('8902','2013-11-13','11:15:00',5.87),('8902','2013-11-13','11:20:00',5.92),('8902','2013-11-13','11:25:00',6),('8902','2013-11-13','11:30:00',6.05),('8902','2013-11-13','11:35:00',5.97),('8902','2013-11-13','11:40:00',5.16),('8902','2013-11-13','11:45:00',3.39),('8902','2013-11-13','11:50:00',3.78),('8902','2013-11-13','11:55:00',2.95),('8902','2013-11-13','12:00:00',6.4),('8902','2013-11-13','12:05:00',3.72),('8902','2013-11-13','12:10:00',2.61),('8902','2013-11-13','12:15:00',2.86),('8902','2013-11-13','12:20:00',2.59),('8902','2013-11-13','12:25:00',2.28),('8902','2013-11-13','12:30:00',2.16),('8902','2013-11-13','12:35:00',2.24),('8902','2013-11-13','12:40:00',2.15),('8902','2013-11-13','12:45:00',2.2),('8902','2013-11-13','12:50:00',2.33),('8902','2013-11-13','12:55:00',2.24),('8902','2013-11-13','13:00:00',2.21),('8902','2013-11-13','13:05:00',1.98),('8902','2013-11-13','13:10:00',1.81),('8902','2013-11-13','13:15:00',1.84),('8902','2013-11-13','13:20:00',1.81),('8902','2013-11-13','13:25:00',1.69),('8902','2013-11-13','13:30:00',1.81),('8902','2013-11-13','13:35:00',1.7),('8902','2013-11-13','13:40:00',1.55),('8902','2013-11-13','13:45:00',1.46),('8902','2013-11-13','13:50:00',1.42),('8902','2013-11-13','13:55:00',1.48),('8902','2013-11-13','14:00:00',1.47),('8902','2013-11-13','14:05:00',1.66),('8902','2013-11-13','14:10:00',1.55),('8902','2013-11-13','14:15:00',1.42),('8902','2013-11-13','14:20:00',1.37),('8902','2013-11-13','14:25:00',1.31),('8902','2013-11-13','14:30:00',1.53),('8902','2013-11-13','14:35:00',1.13),('8902','2013-11-13','14:40:00',1.01),('8902','2013-11-12','08:20:00',1.39),('8902','2013-11-12','08:25:00',1.52),('8902','2013-11-12','08:30:00',1.72),('8902','2013-11-12','08:35:00',1.77),('8902','2013-11-12','09:55:00',1.08),('8902','2013-11-12','10:00:00',2.62),('8902','2013-11-12','10:05:00',1.96),('8902','2013-11-12','10:10:00',2),('8902','2013-11-12','10:15:00',1.91),('8902','2013-11-12','10:20:00',3.62),('8902','2013-11-12','10:25:00',3.29),('8902','2013-11-12','10:30:00',4.77),('8902','2013-11-12','10:35:00',7.23),('8902','2013-11-12','10:40:00',3.97),('8902','2013-11-12','10:45:00',5.73),('8902','2013-11-12','10:50:00',7.21),('8902','2013-11-12','10:55:00',7.08),('8902','2013-11-12','11:00:00',6.44),('8902','2013-11-12','11:05:00',2.08),('8902','2013-11-12','11:10:00',2.04),('8902','2013-11-12','11:15:00',2.14),('8902','2013-11-12','11:20:00',1.99),('8902','2013-11-12','11:25:00',2.17),('8902','2013-11-12','11:30:00',3.22),('8902','2013-11-12','11:35:00',2.96),('8902','2013-11-12','11:40:00',1.89),('8902','2013-11-12','11:45:00',2.22),('8902','2013-11-12','11:50:00',2.47),('8902','2013-11-12','11:55:00',2.14),('8902','2013-11-12','12:00:00',1.52),('8902','2013-11-12','12:05:00',1.44),('8902','2013-11-12','12:10:00',1.57),('8902','2013-11-12','12:15:00',1.71),('8902','2013-11-12','12:20:00',1.53),('8902','2013-11-12','12:25:00',1.41),('8902','2013-11-12','12:30:00',1.18),('8902','2013-11-12','12:35:00',1.29),('8902','2013-11-12','12:40:00',1.44),('8902','2013-11-12','12:45:00',1.29),('8902','2013-11-12','12:50:00',1.31),('8902','2013-11-12','12:55:00',1.9),('8902','2013-11-12','13:00:00',2.24),('8902','2013-11-12','13:05:00',2.8),('8902','2013-11-12','13:10:00',2.45),('8902','2013-11-12','13:15:00',2.3),('8902','2013-11-12','13:20:00',1.71),('8902','2013-11-12','13:25:00',1.45),('8902','2013-11-12','13:30:00',1.52),('8902','2013-11-12','13:35:00',1.72),('8902','2013-11-12','13:40:00',2.03),('8902','2013-11-12','13:45:00',1.88),('8902','2013-11-12','13:50:00',1.9),('8902','2013-11-12','13:55:00',3.91),('8902','2013-11-12','14:00:00',4.19),('8902','2013-11-12','14:05:00',4.15),('8902','2013-11-12','14:10:00',3.61),('8902','2013-11-12','14:15:00',3.92),('8902','2013-11-12','14:20:00',3.47),('8902','2013-11-12','14:25:00',3.63),('8902','2013-11-12','14:30:00',3.34),('8902','2013-11-12','14:35:00',2.43),('8902','2013-11-12','14:40:00',2),('8902','2013-11-12','14:45:00',1.81),('8902','2013-11-12','14:50:00',1.7),('8902','2013-11-12','15:00:00',1.47),('8902','2013-11-12','15:05:00',1.21),('8902','2013-11-11','10:00:00',1.54),('8902','2013-11-11','10:05:00',1.22),('8902','2013-11-11','10:45:00',1),('8902','2013-11-11','10:50:00',1.17),('8902','2013-11-11','10:55:00',1.3),('8902','2013-11-11','11:00:00',1.43),('8902','2013-11-11','11:05:00',1.32),('8902','2013-11-11','11:10:00',1.59),('8902','2013-11-11','11:15:00',1.6),('8902','2013-11-11','11:20:00',1.58),('8902','2013-11-11','11:25:00',2.94),('8902','2013-11-11','11:30:00',1.73),('8902','2013-11-11','11:35:00',2.36),('8902','2013-11-11','11:40:00',5.56),('8902','2013-11-11','11:45:00',3.35),('8902','2013-11-11','11:50:00',3.53),('8902','2013-11-11','11:55:00',2.09),('8902','2013-11-11','12:00:00',5.84),('8902','2013-11-11','12:05:00',2.56),('8902','2013-11-11','12:10:00',1.52),('8902','2013-11-11','12:15:00',1.54),('8902','2013-11-11','12:20:00',1.7),('8902','2013-11-11','12:25:00',2.2),('8902','2013-11-11','12:30:00',7.98),('8902','2013-11-11','12:35:00',6.63),('8902','2013-11-11','12:40:00',3.99),('8902','2013-11-11','12:45:00',3.83),('8902','2013-11-11','12:50:00',3.35),('8902','2013-11-11','12:55:00',3.82),('8902','2013-11-11','13:00:00',3.67),('8902','2013-11-11','13:05:00',4.36),('8902','2013-11-11','13:10:00',6.82),('8902','2013-11-11','13:15:00',7.78),('8902','2013-11-11','13:20:00',5.42),('8902','2013-11-11','13:25:00',4.7),('8902','2013-11-11','13:30:00',3.51),('8902','2013-11-11','13:35:00',4.13),('8902','2013-11-11','13:40:00',6.16),('8902','2013-11-11','13:45:00',3.99),('8902','2013-11-11','13:50:00',2.8),('8902','2013-11-11','13:55:00',2.86),('8902','2013-11-11','14:00:00',2.73),('8902','2013-11-11','14:05:00',2.23),('8902','2013-11-11','14:10:00',3.35),('8902','2013-11-11','14:15:00',6.14),('8902','2013-11-11','14:20:00',6),('8902','2013-11-11','14:25:00',5.81),('8902','2013-11-11','14:30:00',5.21),('8902','2013-11-11','14:35:00',2.45),('8902','2013-11-11','14:40:00',4.39),('8902','2013-11-11','14:45:00',3.66),('8902','2013-11-11','14:50:00',3.7),('8902','2013-11-11','14:55:00',2.54),('8902','2013-11-11','15:00:00',1.75),('8902','2013-11-11','15:05:00',1.1),('8902','2013-11-11','15:10:00',1.05),('8902','2013-11-11','15:15:00',2.14),('8902','2013-11-11','15:20:00',1.17),('8902','2013-11-10','09:45:00',1.39),('8902','2013-11-10','09:50:00',2.61),('8902','2013-11-10','09:55:00',2.46),('8902','2013-11-10','10:00:00',1.71),('8902','2013-11-10','10:05:00',1.71),('8902','2013-11-10','10:10:00',2.47),('8902','2013-11-10','10:15:00',4.43),('8902','2013-11-10','10:20:00',6.3),('8902','2013-11-10','10:25:00',2.59),('8902','2013-11-10','10:30:00',1.35),('8902','2013-11-10','10:35:00',1.75),('8902','2013-11-10','10:40:00',1.18),('8902','2013-11-10','10:55:00',1.08),('8902','2013-11-10','11:00:00',1.56),('8902','2013-11-10','11:05:00',2.52),('8902','2013-11-10','11:10:00',5.31),('8902','2013-11-10','11:15:00',3.98),('8902','2013-11-10','11:20:00',3.45),('8902','2013-11-10','11:25:00',5.96),('8902','2013-11-10','11:30:00',3.09),('8902','2013-11-10','11:35:00',6.85),('8902','2013-11-10','11:40:00',8.17),('8902','2013-11-10','11:45:00',7.44),('8902','2013-11-10','11:50:00',7.66),('8902','2013-11-10','11:55:00',7.05),('8902','2013-11-10','12:00:00',6.74),('8902','2013-11-10','12:05:00',6.57),('8902','2013-11-10','12:10:00',6.25),('8902','2013-11-10','12:15:00',6.34),('8902','2013-11-10','12:20:00',6.76),('8902','2013-11-10','12:25:00',5.78),('8902','2013-11-10','12:30:00',5.61),('8902','2013-11-10','12:35:00',2.68),('8902','2013-11-10','12:40:00',4.92),('8902','2013-11-10','12:45:00',2.27),('8902','2013-11-10','12:50:00',1.74),('8902','2013-11-10','12:55:00',1.65),('8902','2013-11-10','13:00:00',2.56),('8902','2013-11-10','13:05:00',3.24),('8902','2013-11-10','13:10:00',6.56),('8902','2013-11-10','13:15:00',2),('8902','2013-11-10','13:30:00',1.57),('8902','2013-11-10','13:35:00',3.49),('8902','2013-11-10','13:40:00',3.48),('8902','2013-11-10','13:45:00',2),('8902','2013-11-10','13:50:00',1.55),('8902','2013-11-10','13:55:00',1.75),('8902','2013-11-10','14:00:00',1.86),('8902','2013-11-10','14:05:00',1.51),('8902','2013-11-10','14:10:00',1.99),('8902','2013-11-10','14:15:00',3.34),('8902','2013-11-10','14:20:00',5.15),('8902','2013-11-10','14:25:00',5.08),('8902','2013-11-10','14:30:00',4.76),('8902','2013-11-10','14:35:00',4.62),('8902','2013-11-10','14:40:00',3.86),('8902','2013-11-10','14:45:00',2.1),('8902','2013-11-10','14:50:00',1.15),('8902','2013-11-10','14:55:00',1.25),('8902','2013-11-09','07:35:00',1.08),('8902','2013-11-09','07:40:00',1.24),('8902','2013-11-09','07:45:00',1.44),('8902','2013-11-09','07:50:00',1.76),('8902','2013-11-09','07:55:00',1.86),('8902','2013-11-09','08:00:00',1.99),('8902','2013-11-09','08:05:00',1.47),('8902','2013-11-09','08:10:00',1.24),('8902','2013-11-09','08:15:00',1.46),('8902','2013-11-09','08:20:00',1.62),('8902','2013-11-09','08:25:00',1.42),('8902','2013-11-09','08:30:00',1.86),('8902','2013-11-09','08:35:00',1.84),('8902','2013-11-09','08:40:00',2.42),('8902','2013-11-09','08:45:00',3.27),('8902','2013-11-09','08:50:00',3.11),('8902','2013-11-09','08:55:00',3.76),('8902','2013-11-09','09:00:00',3.06),('8902','2013-11-09','09:05:00',2.61),('8902','2013-11-09','09:10:00',1.97),('8902','2013-11-09','09:15:00',2.98),('8902','2013-11-09','09:20:00',3.82),('8902','2013-11-09','09:25:00',4.31),('8902','2013-11-09','09:30:00',3.81),('8902','2013-11-09','09:35:00',3.79),('8902','2013-11-09','09:40:00',4.11),('8902','2013-11-09','09:45:00',4.53),('8902','2013-11-09','09:50:00',4.71),('8902','2013-11-09','09:55:00',4.69),('8902','2013-11-09','10:00:00',4.35),('8902','2013-11-09','10:05:00',5.08),('8902','2013-11-09','10:10:00',5.54),('8902','2013-11-09','10:15:00',5.52),('8902','2013-11-09','10:20:00',5),('8902','2013-11-09','10:25:00',5.76),('8902','2013-11-09','10:30:00',6.35),('8902','2013-11-09','10:35:00',5.54),('8902','2013-11-09','10:40:00',3.97),('8902','2013-11-09','10:45:00',6.1),('8902','2013-11-09','10:50:00',5.62),('8902','2013-11-09','10:55:00',6.31),('8902','2013-11-09','11:00:00',4.98),('8902','2013-11-09','11:05:00',3.07),('8902','2013-11-09','11:10:00',2.1),('8902','2013-11-09','11:15:00',1.3),('8902','2013-11-09','11:20:00',1.58),('8902','2013-11-09','11:25:00',3.3),('8902','2013-11-09','11:30:00',1.84),('8902','2013-11-09','11:35:00',1.97),('8902','2013-11-09','11:40:00',4.1),('8902','2013-11-09','11:45:00',4.59),('8902','2013-11-09','11:50:00',3.05),('8902','2013-11-09','11:55:00',2.71),('8902','2013-11-09','12:00:00',2.4),('8902','2013-11-09','12:05:00',2.6),('8902','2013-11-09','12:10:00',3.12),('8902','2013-11-09','12:15:00',6.47),('8902','2013-11-09','12:20:00',5.29),('8902','2013-11-09','12:25:00',6.28),('8902','2013-11-09','12:30:00',4.43),('8902','2013-11-09','12:35:00',3.73),('8902','2013-11-09','12:40:00',6.59),('8902','2013-11-09','12:45:00',7.04),('8902','2013-11-09','12:50:00',7.15),('8902','2013-11-09','12:55:00',4.72),('8902','2013-11-09','13:00:00',3.02),('8902','2013-11-09','13:05:00',1.46),('8902','2013-11-09','13:10:00',1.63),('8902','2013-11-09','13:15:00',1.07),('8902','2013-11-09','13:35:00',1.71),('8902','2013-11-09','13:40:00',1.4),('8902','2013-11-09','13:45:00',2.63),('8902','2013-11-09','13:50:00',3.95),('8902','2013-11-09','13:55:00',4.46),('8902','2013-11-09','14:20:00',1.18),('8902','2013-11-09','14:25:00',1.2),('8902','2013-11-09','14:30:00',1.75),('8902','2013-11-09','14:35:00',1.28),('8902','2013-11-08','09:10:00',1.47),('8902','2013-11-08','09:15:00',1.67),('8902','2013-11-08','09:20:00',1.64),('8902','2013-11-08','09:30:00',1.54),('8902','2013-11-08','09:35:00',1.4),('8902','2013-11-08','09:40:00',3.92),('8902','2013-11-08','09:45:00',4.43),('8902','2013-11-08','09:50:00',2.98),('8902','2013-11-08','09:55:00',5.59),('8902','2013-11-08','10:00:00',5.41),('8902','2013-11-08','10:05:00',5.32),('8902','2013-11-08','10:10:00',5.01),('8902','2013-11-08','10:15:00',4.69),('8902','2013-11-08','10:20:00',5.1),('8902','2013-11-08','10:25:00',5.34),('8902','2013-11-08','10:30:00',2.17),('8902','2013-11-08','10:35:00',2.59),('8902','2013-11-08','10:40:00',2.58),('8902','2013-11-08','10:45:00',2.82),('8902','2013-11-08','10:50:00',2.96),('8902','2013-11-08','10:55:00',3.73),('8902','2013-11-08','11:00:00',5.07),('8902','2013-11-08','11:05:00',6.73),('8902','2013-11-08','11:10:00',6.02),('8902','2013-11-08','11:15:00',6.45),('8902','2013-11-08','11:20:00',4.94),('8902','2013-11-08','11:25:00',2.44),('8902','2013-11-08','11:30:00',6.15),('8902','2013-11-08','11:35:00',6.09),('8902','2013-11-08','11:40:00',3.16),('8902','2013-11-08','11:45:00',4.36),('8902','2013-11-08','11:50:00',2.48),('8902','2013-11-08','11:55:00',5.4),('8902','2013-11-08','12:00:00',5.29),('8902','2013-11-08','12:05:00',7.41),('8902','2013-11-08','12:10:00',2.52),('8902','2013-11-08','12:15:00',4.24),('8902','2013-11-08','12:20:00',2.38),('8902','2013-11-08','12:25:00',3.63),('8902','2013-11-08','12:30:00',4.37),('8902','2013-11-08','12:35:00',7.06),('8902','2013-11-08','12:40:00',3.8),('8902','2013-11-08','12:45:00',2.54),('8902','2013-11-08','12:50:00',4.4),('8902','2013-11-08','12:55:00',4.12),('8902','2013-11-08','13:00:00',6.59),('8902','2013-11-08','13:05:00',5.71),('8902','2013-11-08','13:10:00',6.59),('8902','2013-11-08','13:15:00',6.51),('8902','2013-11-08','13:20:00',4.48),('8902','2013-11-08','13:25:00',4.69),('8902','2013-11-08','13:30:00',5.78),('8902','2013-11-08','13:35:00',5.65),('8902','2013-11-08','13:40:00',5.37),('8902','2013-11-08','13:45:00',5.29),('8902','2013-11-08','13:50:00',5.33),('8902','2013-11-08','13:55:00',5.26),('8902','2013-11-08','14:00:00',5.14),('8902','2013-11-08','14:05:00',4.54),('8902','2013-11-08','14:10:00',3.23),('8902','2013-11-08','14:15:00',2.65),('8902','2013-11-08','14:20:00',4.94),('8902','2013-11-08','14:25:00',3.69),('8902','2013-11-08','14:30:00',1.08),('8902','2013-11-08','14:35:00',2.33),('8902','2013-11-08','14:40:00',3.27),('8902','2013-11-08','14:45:00',3.31),('8902','2013-11-08','14:50:00',3.56),('8902','2013-11-08','14:55:00',1.78),('8902','2013-11-08','15:30:00',1.67),('8902','2013-11-08','15:35:00',2.83),('8902','2013-11-08','15:40:00',1.17),('8902','2013-11-08','15:45:00',1.86),('8902','2013-11-08','15:50:00',1.62),('8902','2013-11-08','16:00:00',1.09),('8902','2013-11-07','09:00:00',1.1),('8902','2013-11-07','09:05:00',1.81),('8902','2013-11-07','09:10:00',2.61),('8902','2013-11-07','09:15:00',2.17),('8902','2013-11-07','09:20:00',1.82),('8902','2013-11-07','09:25:00',3.17),('8902','2013-11-07','09:30:00',3.21),('8902','2013-11-07','09:35:00',3.3),('8902','2013-11-07','09:40:00',3.54),('8902','2013-11-07','09:45:00',2.54),('8902','2013-11-07','09:50:00',4.41),('8902','2013-11-07','09:55:00',2.39),('8902','2013-11-07','10:00:00',2.65),('8902','2013-11-07','10:05:00',2.09),('8902','2013-11-07','10:10:00',4.7),('8902','2013-11-07','10:15:00',4.6),('8902','2013-11-07','10:25:00',1.06),('8902','2013-11-07','10:30:00',1.11),('8902','2013-11-07','10:45:00',2.06),('8902','2013-11-07','10:50:00',1.47),('8902','2013-11-07','10:55:00',4.4),('8902','2013-11-07','11:00:00',4.05),('8902','2013-11-07','11:05:00',2.34),('8902','2013-11-07','11:10:00',1.32),('8902','2013-11-07','11:15:00',1.26),('8902','2013-11-07','11:20:00',1.39),('8902','2013-11-07','11:25:00',1.35),('8902','2013-11-07','11:30:00',5.05),('8902','2013-11-07','11:35:00',5.45),('8902','2013-11-07','11:40:00',6.78),('8902','2013-11-07','11:45:00',6.66),('8902','2013-11-07','11:50:00',6.59),('8902','2013-11-07','11:55:00',6.76),('8902','2013-11-07','12:00:00',6.39),('8902','2013-11-07','12:05:00',4.08),('8902','2013-11-07','12:10:00',6.13),('8902','2013-11-07','12:15:00',5.09),('8902','2013-11-07','12:25:00',2.44),('8902','2013-11-07','12:30:00',1.12),('8902','2013-11-07','12:35:00',2.1),('8902','2013-11-07','12:40:00',6.59),('8902','2013-11-07','12:45:00',6.44),('8902','2013-11-07','12:50:00',5.07),('8902','2013-11-07','12:55:00',6.63),('8902','2013-11-07','13:00:00',6.25),('8902','2013-11-07','13:05:00',6.01),('8902','2013-11-07','13:10:00',6.11),('8902','2013-11-07','13:15:00',5.86),('8902','2013-11-07','13:20:00',1.92),('8902','2013-11-07','13:25:00',4),('8902','2013-11-07','13:30:00',2.3),('8902','2013-11-07','13:35:00',4.42),('8902','2013-11-07','13:40:00',5.68),('8902','2013-11-07','13:45:00',5.44),('8902','2013-11-07','13:50:00',4.63),('8902','2013-11-07','13:55:00',5.2),('8902','2013-11-07','14:00:00',5.07),('8902','2013-11-07','14:05:00',4.96),('8902','2013-11-07','14:10:00',4.86),('8902','2013-11-07','14:15:00',4.78),('8902','2013-11-07','14:20:00',4.56),('8902','2013-11-07','14:25:00',3.94),('8902','2013-11-07','14:30:00',4.47),('8902','2013-11-07','14:35:00',4.4),('8902','2013-11-07','14:40:00',4.16),('8902','2013-11-07','14:45:00',4.07),('8902','2013-11-07','14:50:00',3.94),('8902','2013-11-07','14:55:00',3.14),('8902','2013-11-07','15:00:00',2.98),('8902','2013-11-07','15:05:00',3.35),('8902','2013-11-07','15:10:00',3.29),('8902','2013-11-07','15:15:00',3.15),('8902','2013-11-07','15:20:00',2.72),('8902','2013-11-07','15:25:00',2.31),('8902','2013-11-07','15:30:00',2.06),('8902','2013-11-07','15:55:00',1.23),('8902','2013-11-07','16:05:00',1.09),('8902','2013-11-07','16:10:00',1.02),('8902','2014-04-17','08:00:00',1.51),('8902','2014-04-17','08:05:00',2.69),('8902','2014-04-17','08:10:00',2.49),('8902','2014-04-17','08:15:00',1.14),('8902','2014-04-17','08:30:00',1.11),('8902','2014-04-17','08:35:00',1.7),('8902','2014-04-17','08:40:00',2.5),('8902','2014-04-17','08:45:00',2.7),('8902','2014-04-17','08:50:00',2.02),('8902','2014-04-17','08:55:00',1.89),('8902','2014-04-17','09:00:00',2.28),('8902','2014-04-17','09:05:00',4.69),('8902','2014-04-17','09:10:00',5.76),('8902','2014-04-17','09:15:00',5.24),('8902','2014-04-17','09:20:00',4.88),('8902','2014-04-17','09:25:00',3.55),('8902','2014-04-17','09:30:00',5.65),('8902','2014-04-17','09:35:00',3.38),('8902','2014-04-17','09:40:00',2.71),('8902','2014-04-17','09:45:00',3.44),('8902','2014-04-17','09:50:00',5.46),('8902','2014-04-17','09:55:00',5.01),('8902','2014-04-17','10:00:00',4.93),('8902','2014-04-17','10:05:00',3.37),('8902','2014-04-17','10:10:00',2.99),('8902','2014-04-17','10:15:00',3.39),('8902','2014-04-17','10:20:00',2.8),('8902','2014-04-17','10:25:00',2.93),('8902','2014-04-17','10:30:00',2.48),('8902','2014-04-17','10:35:00',2.23),('8902','2014-04-17','10:40:00',2.66),('8902','2014-04-17','10:45:00',5.22),('8902','2014-04-17','10:50:00',5.29),('8902','2014-04-17','10:55:00',5.59),('8902','2014-04-17','11:00:00',3.38),('8902','2014-04-17','11:05:00',3.09),('8902','2014-04-17','11:10:00',4.26),('8902','2014-04-17','11:15:00',5.52),('8902','2014-04-17','11:20:00',3.59),('8902','2014-04-17','11:25:00',2.58),('8902','2014-04-17','11:30:00',3.18),('8902','2014-04-17','11:35:00',3.09),('8902','2014-04-17','11:40:00',3.24),('8902','2014-04-17','11:45:00',3.01),('8902','2014-04-17','11:50:00',3.63),('8902','2014-04-17','11:55:00',3.39),('8902','2014-04-17','12:00:00',3.39),('8902','2014-04-17','12:05:00',5.34),('8902','2014-04-17','12:10:00',5.79),('8902','2014-04-17','12:15:00',6.38),('8902','2014-04-17','12:20:00',7.82),('8902','2014-04-17','12:25:00',6.34),('8902','2014-04-17','12:30:00',8.76),('8902','2014-04-17','12:35:00',8.27),('8902','2014-04-17','12:40:00',8.79),('8902','2014-04-17','12:45:00',6.78),('8902','2014-04-17','12:50:00',7.44),('8902','2014-04-17','12:55:00',5.01),('8902','2014-04-17','13:00:00',9.1),('8902','2014-04-17','13:05:00',6.33),('8902','2014-04-17','13:10:00',4.81),('8902','2014-04-17','13:15:00',4.71),('8902','2014-04-17','13:20:00',4.25),('8902','2014-04-17','13:25:00',3.19),('8902','2014-04-17','13:30:00',2.76),('8902','2014-04-17','13:35:00',2.74),('8902','2014-04-17','13:40:00',2.37),('8902','2014-04-17','13:45:00',2.06),('8902','2014-04-17','13:50:00',2.57),('8902','2014-04-17','13:55:00',4.01),('8902','2014-04-17','14:00:00',3.7),('8902','2014-04-17','14:05:00',3.13),('8902','2014-04-17','14:10:00',2.77),('8902','2014-04-17','14:15:00',2.46),('8902','2014-04-17','14:20:00',2.95),('8902','2014-04-17','14:25:00',3.87),('8902','2014-04-17','14:30:00',4.33),('8902','2014-04-17','14:35:00',4.85),('8902','2014-04-17','14:40:00',4.45),('8902','2014-04-17','14:45:00',5.35),('8902','2014-04-17','14:50:00',6.27),('8902','2014-04-17','14:55:00',4.31),('8902','2014-04-17','15:00:00',6.6),('8902','2014-04-17','15:05:00',5.69),('8902','2014-04-17','15:10:00',4.39),('8902','2014-04-17','15:15:00',4.97),('8902','2014-04-17','15:20:00',3.86),('8902','2014-04-17','15:25:00',4.11),('8902','2014-04-17','15:30:00',5.94),('8902','2014-04-17','15:35:00',8.86),('8902','2014-04-17','15:40:00',3.55),('8902','2014-04-17','15:45:00',4.7),('8902','2014-04-17','15:50:00',5.98),('8902','2014-04-17','15:55:00',5),('8902','2014-04-17','16:00:00',4.33),('8902','2014-04-17','16:05:00',3.31),('8902','2014-04-17','16:10:00',2.75),('8902','2014-04-17','16:15:00',2.37),('8902','2014-04-17','16:20:00',2.42),('8902','2014-04-17','16:25:00',4.28),('8902','2014-04-17','16:30:00',4.18),('8902','2014-04-17','16:35:00',6.21),('8902','2014-04-17','16:40:00',6.04),('8902','2014-04-17','16:45:00',5.77),('8902','2014-04-17','16:50:00',4.84),('8902','2014-04-17','16:55:00',2.96),('8902','2014-04-17','17:00:00',4.03),('8902','2014-04-17','17:05:00',5.65),('8902','2014-04-17','17:10:00',3.74),('8902','2014-04-17','17:15:00',4.76),('8902','2014-04-17','17:20:00',4.35),('8902','2014-04-17','17:25:00',4.35),('8902','2014-04-17','17:30:00',3.95),('8902','2014-04-17','17:35:00',3.74),('8902','2014-04-17','17:40:00',3.57),('8902','2014-04-17','17:45:00',3.38),('8902','2014-04-17','17:50:00',3.24),('8902','2014-04-17','17:55:00',3.04),('8902','2014-04-17','18:00:00',2.85),('8902','2014-04-17','18:05:00',2.56),('8902','2014-04-17','18:10:00',2.34),('8902','2014-04-17','18:15:00',2.1),('8902','2014-04-17','18:20:00',1.47),('8902','2014-04-17','18:25:00',1.65),('8902','2014-04-17','18:30:00',1.17),('8902','2014-04-17','18:35:00',1.32),('8902','2014-04-17','18:40:00',1.12),('8902','2014-04-17','18:45:00',1.07),('8902','2013-11-06','07:50:00',1.08),('8902','2013-11-06','07:55:00',1.44),('8902','2013-11-06','08:00:00',1.64),('8902','2013-11-06','08:05:00',1.81),('8902','2013-11-06','08:10:00',1.97),('8902','2013-11-06','08:15:00',2.14),('8902','2013-11-06','08:20:00',2.28),('8902','2013-11-06','08:25:00',2.45),('8902','2013-11-06','08:30:00',2.62),('8902','2013-11-06','08:35:00',2.78),('8902','2013-11-06','08:40:00',2.97),('8902','2013-11-06','08:45:00',3.15),('8902','2013-11-06','08:50:00',3.31),('8902','2013-11-06','08:55:00',3.46),('8902','2013-11-06','09:00:00',3.6),('8902','2013-11-06','09:05:00',3.74),('8902','2013-11-06','09:10:00',3.86),('8902','2013-11-06','09:15:00',3.98),('8902','2013-11-06','09:20:00',4.09),('8902','2013-11-06','09:25:00',4.2),('8902','2013-11-06','09:30:00',4.31),('8902','2013-11-06','09:35:00',4.42),('8902','2013-11-06','09:40:00',4.54),('8902','2013-11-06','09:45:00',4.64),('8902','2013-11-06','09:50:00',4.74),('8902','2013-11-06','09:55:00',4.82),('8902','2013-11-06','10:00:00',4.89),('8902','2013-11-06','10:05:00',4.94),('8902','2013-11-06','10:10:00',5.02),('8902','2013-11-06','10:15:00',5.11),('8902','2013-11-06','10:20:00',5.13),('8902','2013-11-06','10:25:00',5.19),('8902','2013-11-06','10:30:00',5.27),('8902','2013-11-06','10:35:00',5.34),('8902','2013-11-06','10:40:00',5.41),('8902','2013-11-06','10:45:00',5.44),('8902','2013-11-06','10:50:00',5.47),('8902','2013-11-06','10:55:00',5.49),('8902','2013-11-06','11:00:00',5.53),('8902','2013-11-06','11:05:00',5.56),('8902','2013-11-06','11:10:00',5.61),('8902','2013-11-06','11:15:00',5.6),('8902','2013-11-06','11:20:00',5.61),('8902','2013-11-06','11:25:00',5.62),('8902','2013-11-06','11:30:00',5.57),('8902','2013-11-06','11:35:00',5.62),('8902','2013-11-06','11:40:00',5.66),('8902','2013-11-06','11:45:00',5.7),('8902','2013-11-06','11:50:00',5.63),('8902','2013-11-06','11:55:00',5.63),('8902','2013-11-06','12:00:00',5.65),('8902','2013-11-06','12:05:00',5.67),('8902','2013-11-06','12:10:00',5.65),('8902','2013-11-06','12:15:00',5.66),('8902','2013-11-06','12:20:00',5.65),('8902','2013-11-06','12:25:00',5.57),('8902','2013-11-06','12:30:00',5.51),('8902','2013-11-06','12:35:00',5.57),('8902','2013-11-06','12:40:00',5.5),('8902','2013-11-06','12:45:00',5.34),('8902','2013-11-06','12:50:00',5.44),('8902','2013-11-06','12:55:00',5.58),('8902','2013-11-06','13:00:00',5.51),('8902','2013-11-06','13:05:00',5.86),('8902','2013-11-06','13:10:00',5.38),('8902','2013-11-06','13:15:00',5.79),('8902','2013-11-06','13:20:00',4.53),('8902','2013-11-06','13:25:00',1.58),('8902','2013-11-06','13:30:00',1.79),('8902','2013-11-06','13:35:00',3.92),('8902','2013-11-06','13:40:00',5.61),('8902','2013-11-06','13:45:00',2.63),('8902','2013-11-06','13:50:00',4.86),('8902','2013-11-06','13:55:00',4.76),('8902','2013-11-06','14:00:00',2.31),('8902','2013-11-06','14:05:00',3.09),('8902','2013-11-06','14:10:00',2.97),('8902','2013-11-06','14:15:00',2.8),('8902','2013-11-06','14:20:00',2.41),('8902','2013-11-06','14:25:00',2.49),('8902','2013-11-06','14:30:00',3.05),('8902','2013-11-06','14:35:00',3.95),('8902','2013-11-06','14:40:00',4.42),('8902','2013-11-06','14:45:00',4.03),('8902','2013-11-06','14:50:00',3.84),('8902','2013-11-06','14:55:00',3.69),('8902','2013-11-06','15:00:00',3.55),('8902','2013-11-06','15:05:00',3.4),('8902','2013-11-06','15:10:00',3.3),('8902','2013-11-06','15:15:00',3.04),('8902','2013-11-06','15:20:00',2.85),('8902','2013-11-06','15:25:00',2.7),('8902','2013-11-06','15:30:00',2.56),('8902','2013-11-06','15:35:00',2.37),('8902','2013-11-06','15:40:00',2.18),('8902','2013-11-06','15:45:00',1.99),('8902','2013-11-06','15:50:00',1.8),('8902','2013-11-06','15:55:00',1.6),('8902','2013-11-06','16:00:00',1.42),('8902','2013-11-06','16:05:00',1.25),('8902','2013-11-06','16:10:00',1.08),('8902','2013-11-05','08:00:00',1.27),('8902','2013-11-05','08:05:00',1.4),('8902','2013-11-05','08:10:00',2.06),('8902','2013-11-05','08:15:00',2.45),('8902','2013-11-05','08:20:00',2.36),('8902','2013-11-05','08:25:00',1.1),('8902','2013-11-05','08:30:00',1.22),('8902','2013-11-05','08:35:00',2.98),('8902','2013-11-05','08:40:00',3.07),('8902','2013-11-05','08:45:00',3.24),('8902','2013-11-05','08:50:00',3.55),('8902','2013-11-05','08:55:00',3.42),('8902','2013-11-05','09:00:00',2.46),('8902','2013-11-05','09:05:00',2.66),('8902','2013-11-05','09:10:00',2.22),('8902','2013-11-05','09:15:00',3.36),('8902','2013-11-05','09:20:00',4),('8902','2013-11-05','09:25:00',4.22),('8902','2013-11-05','09:30:00',4.54),('8902','2013-11-05','09:35:00',4.63),('8902','2013-11-05','09:40:00',4.74),('8902','2013-11-05','09:45:00',4.82),('8902','2013-11-05','09:50:00',4.89),('8902','2013-11-05','09:55:00',4.96),('8902','2013-11-05','10:00:00',5.06),('8902','2013-11-05','10:05:00',5.14),('8902','2013-11-05','10:10:00',5.23),('8902','2013-11-05','10:15:00',5.29),('8902','2013-11-05','10:20:00',5.37),('8902','2013-11-05','10:25:00',5.46),('8902','2013-11-05','10:30:00',5.59),('8902','2013-11-05','10:35:00',5.65),('8902','2013-11-05','10:40:00',5.71),('8902','2013-11-05','10:45:00',5.74),('8902','2013-11-05','10:50:00',5.84),('8902','2013-11-05','10:55:00',5.89),('8902','2013-11-05','11:00:00',5.88),('8902','2013-11-05','11:05:00',5.91),('8902','2013-11-05','11:10:00',5.95),('8902','2013-11-05','11:15:00',5.95),('8902','2013-11-05','11:20:00',6.01),('8902','2013-11-05','11:25:00',6.06),('8902','2013-11-05','11:30:00',6.1),('8902','2013-11-05','11:35:00',6.07),('8902','2013-11-05','11:40:00',6.07),('8902','2013-11-05','11:45:00',6.12),('8902','2013-11-05','11:50:00',6.17),('8902','2013-11-05','11:55:00',6.15),('8902','2013-11-05','12:00:00',6.15),('8902','2013-11-05','12:05:00',6.16),('8902','2013-11-05','12:10:00',6.16),('8902','2013-11-05','12:15:00',6.16),('8902','2013-11-05','12:20:00',6.15),('8902','2013-11-05','12:25:00',6.14),('8902','2013-11-05','12:30:00',6.12),('8902','2013-11-05','12:35:00',6.08),('8902','2013-11-05','12:40:00',6.02),('8902','2013-11-05','12:45:00',5.99),('8902','2013-11-05','12:50:00',5.97),('8902','2013-11-05','12:55:00',5.93),('8902','2013-11-05','13:00:00',5.87),('8902','2013-11-05','13:05:00',5.83),('8902','2013-11-05','13:10:00',5.78),('8902','2013-11-05','13:15:00',5.7),('8902','2013-11-05','13:20:00',5.67),('8902','2013-11-05','13:25:00',5.59),('8902','2013-11-05','13:30:00',5.55),('8902','2013-11-05','13:35:00',5.49),('8902','2013-11-05','13:40:00',5.4),('8902','2013-11-05','13:45:00',5.29),('8902','2013-11-05','13:50:00',5.21),('8902','2013-11-05','13:55:00',5.19),('8902','2013-11-05','14:00:00',5.13),('8902','2013-11-05','14:05:00',5.03),('8902','2013-11-05','14:10:00',4.94),('8902','2013-11-05','14:15:00',4.84),('8902','2013-11-05','14:20:00',4.74),('8902','2013-11-05','14:25:00',4.64),('8902','2013-11-05','14:30:00',4.52),('8902','2013-11-05','14:35:00',4.4),('8902','2013-11-05','14:40:00',4.29),('8902','2013-11-05','14:45:00',4.15),('8902','2013-11-05','14:50:00',3.99),('8902','2013-11-05','14:55:00',3.77),('8902','2013-11-05','15:00:00',3.64),('8902','2013-11-05','15:05:00',3.5),('8902','2013-11-05','15:10:00',3.36),('8902','2013-11-05','15:15:00',3.22),('8902','2013-11-05','15:20:00',3.02),('8902','2013-11-05','15:25:00',2.85),('8902','2013-11-05','15:30:00',2.66),('8902','2013-11-05','15:35:00',2.47),('8902','2013-11-05','15:40:00',2.27),('8902','2013-11-05','15:45:00',2.06),('8902','2013-11-05','15:50:00',1.88),('8902','2013-11-05','15:55:00',1.69),('8902','2013-11-05','16:00:00',1.53),('8902','2013-11-05','16:05:00',1.35),('8902','2013-11-05','16:10:00',1.19),('8902','2013-11-05','16:15:00',1.02),('8902','2013-11-04','08:15:00',1.02),('8902','2013-11-04','08:20:00',1.3),('8902','2013-11-04','08:25:00',2.3),('8902','2013-11-04','08:30:00',3.08),('8902','2013-11-04','08:35:00',3.53),('8902','2013-11-04','08:40:00',3.64),('8902','2013-11-04','08:45:00',2.56),('8902','2013-11-04','08:50:00',1.25),('8902','2013-11-04','08:55:00',1.01),('8902','2013-11-04','09:50:00',1.09),('8902','2013-11-04','09:55:00',1.23),('8902','2013-11-04','10:00:00',1.43),('8902','2013-11-04','10:05:00',1.28),('8902','2013-11-04','10:10:00',1.22),('8902','2013-11-04','10:15:00',1.86),('8902','2013-11-04','10:20:00',3.38),('8902','2013-11-04','10:25:00',4.27),('8902','2013-11-04','10:30:00',3.84),('8902','2013-11-04','10:35:00',3.83),('8902','2013-11-04','10:40:00',3.45),('8902','2013-11-04','10:45:00',4.64),('8902','2013-11-04','10:50:00',3.08),('8902','2013-11-04','10:55:00',2.86),('8902','2013-11-04','11:00:00',2.23),('8902','2013-11-04','11:05:00',1.67),('8902','2013-11-04','11:10:00',1.32),('8902','2013-11-04','11:15:00',1.08),('8902','2013-11-04','11:20:00',1.18),('8902','2013-11-04','11:25:00',1.38),('8902','2013-11-04','11:30:00',1.58),('8902','2013-11-04','11:35:00',2.14),('8902','2013-11-04','11:40:00',2.85),('8902','2013-11-04','11:45:00',2.92),('8902','2013-11-04','11:50:00',2.6),('8902','2013-11-04','11:55:00',2.18),('8902','2013-11-04','12:00:00',2.04),('8902','2013-11-04','12:05:00',2.4),('8902','2013-11-04','12:10:00',3),('8902','2013-11-04','12:15:00',2.95),('8902','2013-11-04','12:20:00',3.63),('8902','2013-11-04','12:25:00',3.82),('8902','2013-11-04','12:30:00',2.24),('8902','2013-11-04','12:35:00',1.63),('8902','2013-11-04','12:40:00',1.35),('8902','2013-11-04','12:45:00',1.24),('8902','2013-11-04','12:50:00',1.15),('8902','2013-11-04','12:55:00',1.52),('8902','2013-11-04','13:00:00',1.79),('8902','2013-11-04','13:05:00',1.66),('8902','2013-11-04','13:10:00',1.63),('8902','2013-11-04','13:15:00',1.25),('8902','2013-11-04','13:20:00',1.05),('8902','2013-11-04','13:25:00',1.25),('8902','2013-11-04','13:30:00',2.07),('8902','2013-11-04','13:35:00',4.56),('8902','2013-11-04','13:40:00',4.93),('8902','2013-11-04','13:45:00',4.4),('8902','2013-11-04','13:50:00',3.48),('8902','2013-11-04','13:55:00',2.21),('8902','2013-11-04','14:00:00',2.45),('8902','2013-11-04','14:05:00',2.11),('8902','2013-11-04','14:10:00',5.27),('8902','2013-11-04','14:15:00',3.36),('8902','2013-11-04','14:20:00',1.52),('8902','2013-11-04','14:25:00',4.83),('8902','2013-11-04','14:30:00',4.45),('8902','2013-11-04','14:35:00',2.36),('8902','2013-11-04','14:40:00',1.52),('8902','2013-11-04','14:45:00',1.82),('8902','2013-11-04','14:50:00',1.6),('8902','2013-11-04','15:00:00',1.72),('8902','2013-11-04','15:05:00',1.73),('8902','2013-11-04','15:20:00',2.11),('8902','2013-11-04','15:30:00',1.85),('8902','2013-11-04','15:35:00',2.78),('8902','2013-11-04','16:05:00',1.9),('8902','2013-11-04','16:10:00',1.74),('8902','2013-11-03','07:55:00',1.41),('8902','2013-11-03','08:00:00',1.6),('8902','2013-11-03','08:05:00',1.78),('8902','2013-11-03','08:10:00',1.91),('8902','2013-11-03','08:15:00',2.04),('8902','2013-11-03','08:20:00',2.35),('8902','2013-11-03','08:25:00',2.5),('8902','2013-11-03','08:30:00',2.57),('8902','2013-11-03','08:35:00',2.17),('8902','2013-11-03','08:40:00',2.48),('8902','2013-11-03','08:45:00',1.47),('8902','2013-11-03','08:50:00',1.56),('8902','2013-11-03','09:10:00',2.75),('8902','2013-11-03','09:15:00',4.25),('8902','2013-11-03','09:20:00',4.99),('8902','2013-11-03','09:25:00',5.42),('8902','2013-11-03','09:30:00',3),('8902','2013-11-03','10:05:00',4.68),('8902','2013-11-03','10:10:00',5.49),('8902','2013-11-03','10:15:00',5.55),('8902','2013-11-03','10:20:00',5.69),('8902','2013-11-03','10:25:00',6.07),('8902','2013-11-03','10:30:00',4.98),('8902','2013-11-03','10:35:00',4.83),('8902','2013-11-03','10:40:00',6.52),('8902','2013-11-03','10:45:00',4.19),('8902','2013-11-03','10:50:00',2.98),('8902','2013-11-03','10:55:00',3.2),('8902','2013-11-03','11:00:00',5.54),('8902','2013-11-03','11:05:00',7.94),('8902','2013-11-03','11:10:00',6.82),('8902','2013-11-03','11:15:00',7.88),('8902','2013-11-03','11:20:00',6.18),('8902','2013-11-03','11:25:00',3.22),('8902','2013-11-03','11:30:00',4.14),('8902','2013-11-03','11:35:00',5.43),('8902','2013-11-03','11:40:00',4),('8902','2013-11-03','11:45:00',4.6),('8902','2013-11-03','11:50:00',7.67),('8902','2013-11-03','11:55:00',6.95),('8902','2013-11-03','12:00:00',7.03),('8902','2013-11-03','12:05:00',6.69),('8902','2013-11-03','12:10:00',6.16),('8902','2013-11-03','12:15:00',6.68),('8902','2013-11-03','12:20:00',6.63),('8902','2013-11-03','12:25:00',6.63),('8902','2013-11-03','12:30:00',6.42),('8902','2013-11-03','12:35:00',6),('8902','2013-11-03','12:40:00',4.91),('8902','2013-11-03','12:45:00',6.25),('8902','2013-11-03','12:50:00',6.3),('8902','2013-11-03','12:55:00',6.23),('8902','2013-11-03','13:00:00',6.22),('8902','2013-11-03','13:05:00',6.13),('8902','2013-11-03','13:10:00',5.78),('8902','2013-11-03','13:15:00',5.93),('8902','2013-11-03','13:20:00',6.04),('8902','2013-11-03','13:25:00',6.05),('8902','2013-11-03','13:30:00',5.9),('8902','2013-11-03','13:35:00',5.68),('8902','2013-11-03','13:40:00',5.97),('8902','2013-11-03','13:45:00',4.54),('8902','2013-11-03','13:50:00',5.8),('8902','2013-11-03','13:55:00',5.66),('8902','2013-11-03','14:00:00',3.97),('8902','2013-11-03','14:05:00',5.94),('8902','2013-11-03','14:10:00',3.51),('8902','2013-11-03','14:15:00',4.98),('8902','2013-11-03','14:20:00',4.86),('8902','2013-11-03','14:25:00',5.37),('8902','2013-11-03','14:30:00',4.92),('8902','2013-11-03','14:35:00',3.77),('8902','2013-11-03','14:40:00',4.61),('8902','2013-11-03','14:45:00',2.81),('8902','2013-11-03','14:50:00',3.42),('8902','2013-11-03','14:55:00',3.95),('8902','2013-11-03','15:00:00',4.01),('8902','2013-11-03','15:05:00',2.63),('8902','2013-11-03','15:10:00',2),('8902','2013-11-03','15:15:00',3.37),('8902','2013-11-03','15:20:00',2.87),('8902','2013-11-03','15:25:00',3.19),('8902','2013-11-03','15:30:00',2.99),('8902','2013-11-03','15:35:00',2.98),('8902','2013-11-03','15:40:00',2.86),('8902','2013-11-03','15:45:00',2.61),('8902','2013-11-03','15:50:00',2.05),('8902','2013-11-02','07:35:00',1.15),('8902','2013-11-02','07:40:00',1.16),('8902','2013-11-02','07:45:00',1.34),('8902','2013-11-02','07:50:00',1.28),('8902','2013-11-02','07:55:00',1.35),('8902','2013-11-02','08:00:00',1.56),('8902','2013-11-02','08:05:00',1.72),('8902','2013-11-02','08:10:00',1.06),('8902','2013-11-02','08:20:00',2.23),('8902','2013-11-02','08:25:00',1.79),('8902','2013-11-02','08:30:00',1.44),('8902','2013-11-02','08:35:00',2.29),('8902','2013-11-02','08:40:00',2.31),('8902','2013-11-02','08:45:00',2.26),('8902','2013-11-02','08:50:00',2.78),('8902','2013-11-02','08:55:00',2),('8902','2013-11-02','09:00:00',1.12),('8902','2013-11-02','09:05:00',1.14),('8902','2013-11-02','09:10:00',1.04),('8902','2013-11-02','09:35:00',1.43),('8902','2013-11-02','09:40:00',4.17),('8902','2013-11-02','09:45:00',4.03),('8902','2013-11-02','09:50:00',1.75),('8902','2013-11-02','09:55:00',1.13),('8902','2013-11-02','10:05:00',1.21),('8902','2013-11-02','10:10:00',3.74),('8902','2013-11-02','10:15:00',1.16),('8902','2013-11-02','10:20:00',2.62),('8902','2013-11-02','10:25:00',4.93),('8902','2013-11-02','10:30:00',3.18),('8902','2013-11-02','10:35:00',3.67),('8902','2013-11-02','11:10:00',1.16),('8902','2013-11-02','11:15:00',1.85),('8902','2013-11-02','11:20:00',3.21),('8902','2013-11-02','11:25:00',4),('8902','2013-11-02','11:30:00',3.88),('8902','2013-11-02','11:35:00',5.83),('8902','2013-11-02','11:40:00',6.33),('8902','2013-11-02','11:45:00',6.56),('8902','2013-11-02','11:50:00',6.69),('8902','2013-11-02','11:55:00',7.15),('8902','2013-11-02','12:00:00',4.82),('8902','2013-11-02','12:05:00',7.14),('8902','2013-11-02','12:10:00',7.94),('8902','2013-11-02','12:15:00',3.02),('8902','2013-11-02','12:20:00',3),('8902','2013-11-02','12:25:00',3.8),('8902','2013-11-02','12:30:00',3.8),('8902','2013-11-02','12:35:00',3.5),('8902','2013-11-02','12:40:00',2.44),('8902','2013-11-02','12:45:00',2.23),('8902','2013-11-02','12:50:00',1.93),('8902','2013-11-02','12:55:00',1.42),('8902','2013-11-02','13:05:00',1.11),('8902','2013-11-02','13:10:00',1.57),('8902','2013-11-02','13:15:00',1.56),('8902','2013-11-02','13:20:00',1.52),('8902','2013-11-02','13:25:00',1.86),('8902','2013-11-02','13:30:00',1.86),('8902','2013-11-02','13:35:00',1.53),('8902','2013-11-02','13:40:00',2.58),('8902','2013-11-02','13:45:00',3.35),('8902','2013-11-02','13:50:00',4.47),('8902','2013-11-02','13:55:00',1.67),('8902','2013-11-02','14:00:00',2.46),('8902','2013-11-02','14:05:00',4.02),('8902','2013-11-02','14:10:00',3.64),('8902','2013-11-02','14:15:00',2.05),('8902','2013-11-02','14:20:00',2.76),('8902','2013-11-02','14:25:00',3.39),('8902','2013-11-02','14:30:00',2.88),('8902','2013-11-02','14:35:00',1.54),('8902','2013-11-02','14:40:00',4.28),('8902','2013-11-02','14:45:00',2.34),('8902','2013-11-02','14:50:00',1.5),('8902','2013-11-02','14:55:00',1.38),('8902','2013-11-02','15:00:00',1.22),('8902','2013-11-02','15:05:00',1.19),('8902','2013-11-02','15:10:00',1.03),('8902','2013-11-02','15:15:00',1.03),('8902','2013-11-02','15:20:00',1.69),('8902','2013-11-01','07:55:00',1.34),('8902','2013-11-01','08:00:00',1.57),('8902','2013-11-01','08:05:00',1.71),('8902','2013-11-01','08:10:00',1.86),('8902','2013-11-01','08:15:00',2.03),('8902','2013-11-01','08:20:00',2.2),('8902','2013-11-01','08:25:00',2.34),('8902','2013-11-01','08:30:00',2.52),('8902','2013-11-01','08:35:00',2.72),('8902','2013-11-01','08:40:00',2.9),('8902','2013-11-01','08:45:00',3.06),('8902','2013-11-01','08:50:00',3.19),('8902','2013-11-01','08:55:00',3.34),('8902','2013-11-01','09:00:00',3.52),('8902','2013-11-01','09:05:00',3.81),('8902','2013-11-01','09:10:00',4.19),('8902','2013-11-01','09:15:00',2.83),('8902','2013-11-01','09:20:00',3.69),('8902','2013-11-01','09:25:00',3.97),('8902','2013-11-01','09:30:00',4.42),('8902','2013-11-01','09:35:00',4.41),('8902','2013-11-01','09:40:00',4.2),('8902','2013-11-01','09:45:00',3.81),('8902','2013-11-01','09:50:00',5.03),('8902','2013-11-01','09:55:00',5.07),('8902','2013-11-01','10:00:00',5.47),('8902','2013-11-01','10:05:00',6.18),('8902','2013-11-01','10:10:00',3.38),('8902','2013-11-01','10:15:00',2.42),('8902','2013-11-01','10:20:00',1.81),('8902','2013-11-01','10:25:00',1.33),('8902','2013-11-01','10:30:00',1.19),('8902','2013-11-01','10:35:00',1.44),('8902','2013-11-01','10:40:00',1.45),('8902','2013-11-01','10:45:00',1.5),('8902','2013-11-01','10:50:00',1.35),('8902','2013-11-01','10:55:00',1.51),('8902','2013-11-01','11:00:00',2.28),('8902','2013-11-01','11:05:00',2.59),('8902','2013-11-01','11:10:00',2.21),('8902','2013-11-01','11:15:00',1.57),('8902','2013-11-01','11:25:00',1.16),('8902','2013-11-01','11:30:00',1.38),('8902','2013-11-01','11:35:00',1.51),('8902','2013-11-01','11:40:00',1.83),('8902','2013-11-01','11:45:00',1.84),('8902','2013-11-01','11:50:00',2.15),('8902','2013-11-01','11:55:00',3.91),('8902','2013-11-01','12:00:00',6.16),('8902','2013-11-01','12:05:00',6.93),('8902','2013-11-01','12:10:00',6.27),('8902','2013-11-01','12:15:00',5.76),('8902','2013-11-01','12:20:00',7.5),('8902','2013-11-01','12:25:00',7.15),('8902','2013-11-01','12:30:00',7.37),('8902','2013-11-01','12:35:00',7.22),('8902','2013-11-01','12:40:00',6.41),('8902','2013-11-01','12:45:00',5.58),('8902','2013-11-01','12:50:00',5.78),('8902','2013-11-01','12:55:00',6.53),('8902','2013-11-01','13:00:00',6.22),('8902','2013-11-01','13:05:00',6.44),('8902','2013-11-01','13:10:00',6.8),('8902','2013-11-01','13:15:00',6.62),('8902','2013-11-01','13:20:00',1.92),('8902','2013-11-01','13:25:00',1.85),('8902','2013-11-01','13:30:00',4.14),('8902','2013-11-01','13:35:00',6.81),('8902','2013-11-01','13:40:00',6.62),('8902','2013-11-01','13:45:00',5.48),('8902','2013-11-01','13:50:00',6.79),('8902','2013-11-01','13:55:00',6.54),('8902','2013-11-01','14:00:00',6.06),('8902','2013-11-01','14:05:00',5.36),('8902','2013-11-01','14:10:00',5.09),('8902','2013-11-01','14:15:00',4.91),('8902','2013-11-01','14:20:00',4.74),('8902','2013-11-01','14:25:00',4.58),('8902','2013-11-01','14:30:00',4.49),('8902','2013-11-01','14:35:00',4.38),('8902','2013-11-01','14:40:00',4.27),('8902','2013-11-01','14:45:00',4.07),('8902','2013-11-01','14:50:00',3.97),('8902','2013-11-01','14:55:00',3.83),('8902','2013-11-01','15:00:00',3.59),('8902','2013-11-01','15:05:00',3.29),('8902','2013-11-01','15:10:00',3.21),('8902','2013-11-01','15:15:00',2.67),('8902','2013-11-01','15:35:00',1.44),('8902','2013-11-01','15:40:00',1.64),('8902','2013-11-01','15:45:00',2.38),('8902','2013-11-01','15:50:00',1.74),('8902','2013-11-01','15:55:00',1.33),('8902','2013-11-01','16:15:00',1.14),('8902','2013-10-31','07:45:00',1.04),('8902','2013-10-31','07:50:00',1.12),('8902','2013-10-31','07:55:00',1.26),('8902','2013-10-31','08:00:00',1.44),('8902','2013-10-31','08:05:00',1.37),('8902','2013-10-31','08:10:00',1.42),('8902','2013-10-31','08:15:00',1.59),('8902','2013-10-31','08:20:00',1.93),('8902','2013-10-31','08:25:00',2.04),('8902','2013-10-31','08:30:00',2.39),('8902','2013-10-31','08:35:00',2.62),('8902','2013-10-31','08:40:00',2.89),('8902','2013-10-31','08:45:00',3.01),('8902','2013-10-31','08:50:00',2.91),('8902','2013-10-31','08:55:00',3.05),('8902','2013-10-31','09:00:00',3.21),('8902','2013-10-31','09:05:00',3.59),('8902','2013-10-31','09:10:00',3.77),('8902','2013-10-31','09:15:00',3.87),('8902','2013-10-31','09:20:00',4),('8902','2013-10-31','09:25:00',4.13),('8902','2013-10-31','09:30:00',4.23),('8902','2013-10-31','09:35:00',4.34),('8902','2013-10-31','09:40:00',4.47),('8902','2013-10-31','09:45:00',4.59),('8902','2013-10-31','09:50:00',4.73),('8902','2013-10-31','09:55:00',4.82),('8902','2013-10-31','10:00:00',4.89),('8902','2013-10-31','10:05:00',5),('8902','2013-10-31','10:10:00',5.1),('8902','2013-10-31','10:15:00',5.14),('8902','2013-10-31','10:20:00',5.23),('8902','2013-10-31','10:25:00',5.33),('8902','2013-10-31','10:30:00',5.32),('8902','2013-10-31','10:35:00',5.32),('8902','2013-10-31','10:40:00',5.5),('8902','2013-10-31','10:45:00',5.38),('8902','2013-10-31','10:50:00',5.37),('8902','2013-10-31','10:55:00',5.4),('8902','2013-10-31','11:00:00',5.53),('8902','2013-10-31','11:05:00',5.36),('8902','2013-10-31','11:10:00',4.78),('8902','2013-10-31','11:15:00',5.09),('8902','2013-10-31','11:20:00',5.79),('8902','2013-10-31','11:25:00',6.13),('8902','2013-10-31','11:30:00',6.19),('8902','2013-10-31','11:35:00',6.03),('8902','2013-10-31','11:40:00',5.76),('8902','2013-10-31','11:45:00',5.12),('8902','2013-10-31','11:50:00',5.97),('8902','2013-10-31','11:55:00',6.25),('8902','2013-10-31','12:00:00',6.29),('8902','2013-10-31','12:05:00',6.17),('8902','2013-10-31','12:10:00',5.66),('8902','2013-10-31','12:15:00',5.77),('8902','2013-10-31','12:20:00',3.41),('8902','2013-10-31','12:25:00',2.15),('8902','2013-10-31','12:30:00',5.42),('8902','2013-10-31','12:35:00',4.24),('8902','2013-10-31','12:40:00',1.23),('8902','2013-10-31','12:45:00',1.01),('8902','2013-10-31','12:50:00',1.03),('8902','2013-10-31','12:55:00',1.04),('8902','2013-10-31','13:00:00',1.07),('8902','2013-10-31','13:05:00',1.29),('8902','2013-10-31','13:10:00',1.53),('8902','2013-10-31','13:15:00',1.93),('8902','2013-10-31','13:20:00',2.82),('8902','2013-10-31','13:25:00',2.63),('8902','2013-10-31','13:30:00',3.38),('8902','2013-10-31','13:35:00',2.72),('8902','2013-10-31','13:40:00',2.16),('8902','2013-10-31','13:45:00',2.53),('8902','2013-10-31','13:50:00',1.97),('8902','2013-10-31','13:55:00',1.96),('8902','2013-10-31','14:00:00',1.56),('8902','2013-10-31','14:05:00',1.52),('8902','2013-10-31','14:10:00',1.5),('8902','2013-10-31','14:15:00',1.5),('8902','2013-10-31','14:20:00',1.37),('8902','2013-10-31','14:25:00',1.1),('8902','2013-10-30','08:05:00',1.14),('8902','2013-10-30','08:10:00',1.3),('8902','2013-10-30','08:15:00',1.6),('8902','2013-10-30','08:20:00',1.8),('8902','2013-10-30','08:25:00',2.02),('8902','2013-10-30','08:30:00',2.49),('8902','2013-10-30','08:35:00',2.68),('8902','2013-10-30','08:40:00',3.11),('8902','2013-10-30','08:45:00',3.12),('8902','2013-10-30','08:50:00',2.98),('8902','2013-10-30','08:55:00',2.65),('8902','2013-10-30','09:00:00',3.29),('8902','2013-10-30','09:05:00',2.48),('8902','2013-10-30','09:10:00',1.49),('8902','2013-10-30','09:15:00',1.83),('8902','2013-10-30','09:20:00',1.71),('8902','2013-10-30','09:25:00',1.88),('8902','2013-10-30','09:30:00',2.8),('8902','2013-10-30','09:35:00',3.47),('8902','2013-10-30','09:40:00',3.16),('8902','2013-10-30','09:45:00',2.23),('8902','2013-10-30','09:50:00',3.17),('8902','2013-10-30','09:55:00',3.81),('8902','2013-10-30','10:00:00',3.62),('8902','2013-10-30','10:05:00',3.13),('8902','2013-10-30','10:10:00',2.58),('8902','2013-10-30','10:15:00',2.43),('8902','2013-10-30','10:20:00',3.53),('8902','2013-10-30','10:25:00',3.49),('8902','2013-10-30','10:30:00',3.36),('8902','2013-10-30','10:35:00',3.52),('8902','2013-10-30','10:40:00',3.55),('8902','2013-10-30','10:45:00',3.48),('8902','2013-10-30','10:50:00',3.68),('8902','2013-10-30','10:55:00',4.44),('8902','2013-10-30','11:00:00',5.49),('8902','2013-10-30','11:05:00',5.79),('8902','2013-10-30','11:10:00',5.61),('8902','2013-10-30','11:15:00',4.67),('8902','2013-10-30','11:20:00',5.17),('8902','2013-10-30','11:25:00',5.04),('8902','2013-10-30','11:30:00',5.25),('8902','2013-10-30','11:35:00',5.05),('8902','2013-10-30','11:40:00',5.38),('8902','2013-10-30','11:45:00',5.76),('8902','2013-10-30','11:50:00',5.81),('8902','2013-10-30','11:55:00',5.84),('8902','2013-10-30','12:00:00',5.77),('8902','2013-10-30','12:05:00',5.64),('8902','2013-10-30','12:10:00',5.58),('8902','2013-10-30','12:15:00',5.64),('8902','2013-10-30','12:20:00',5.6),('8902','2013-10-30','12:25:00',5.65),('8902','2013-10-30','12:30:00',5.49),('8902','2013-10-30','12:35:00',5.51),('8902','2013-10-30','12:40:00',5.56),('8902','2013-10-30','12:45:00',5.79),('8902','2013-10-30','12:50:00',5.83),('8902','2013-10-30','12:55:00',5.91),('8902','2013-10-30','13:00:00',5.72),('8902','2013-10-30','13:05:00',5.66),('8902','2013-10-30','13:10:00',5.62),('8902','2013-10-30','13:15:00',5.54),('8902','2013-10-30','13:20:00',5.53),('8902','2013-10-30','13:25:00',5.42),('8902','2013-10-30','13:30:00',5.33),('8902','2013-10-30','13:35:00',5.02),('8902','2013-10-30','13:40:00',4.25),('8902','2013-10-30','13:45:00',4.59),('8902','2013-10-30','13:50:00',3.38),('8902','2013-10-30','13:55:00',3.88),('8902','2013-10-30','14:00:00',4.85),('8902','2013-10-30','14:05:00',4.81),('8902','2013-10-30','14:10:00',4.51),('8902','2013-10-30','14:15:00',4.03),('8902','2013-10-30','14:20:00',2.72),('8902','2013-10-30','14:25:00',4.13),('8902','2013-10-30','14:30:00',2.68),('8902','2013-10-30','14:35:00',2.48),('8902','2013-10-30','14:40:00',2.98),('8902','2013-10-30','14:45:00',3.11),('8902','2013-10-30','14:50:00',2.94),('8902','2013-10-30','14:55:00',2.33),('8902','2013-10-30','15:00:00',2.55),('8902','2013-10-30','15:05:00',2.4),('8902','2013-10-30','15:10:00',2.33),('8902','2013-10-30','15:15:00',2.15),('8902','2013-10-30','15:20:00',2.01),('8902','2013-10-30','15:25:00',1.92),('8902','2013-10-30','15:30:00',1.76),('8902','2013-10-30','15:35:00',1.75),('8902','2013-10-30','15:40:00',1.74),('8902','2013-10-30','15:45:00',1.51),('8902','2013-10-30','15:50:00',1.38),('8902','2013-10-30','15:55:00',1.31),('8902','2013-10-30','16:00:00',1.12),('8902','2013-10-29','07:45:00',1.03),('8902','2013-10-29','07:50:00',1.15),('8902','2013-10-29','07:55:00',1.24),('8902','2013-10-29','08:00:00',1.32),('8902','2013-10-29','08:05:00',1.48),('8902','2013-10-29','08:10:00',1.84),('8902','2013-10-29','08:15:00',1.98),('8902','2013-10-29','08:20:00',2.12),('8902','2013-10-29','08:25:00',2.27),('8902','2013-10-29','08:30:00',2.41),('8902','2013-10-29','08:35:00',2.6),('8902','2013-10-29','08:40:00',2.81),('8902','2013-10-29','08:45:00',3),('8902','2013-10-29','08:50:00',3.06),('8902','2013-10-29','08:55:00',3.07),('8902','2013-10-29','09:00:00',3.2),('8902','2013-10-29','09:05:00',3.45),('8902','2013-10-29','09:10:00',3.73),('8902','2013-10-29','09:15:00',3.83),('8902','2013-10-29','09:20:00',3.95),('8902','2013-10-29','09:25:00',4.06),('8902','2013-10-29','09:30:00',4.15),('8902','2013-10-29','09:35:00',4.32),('8902','2013-10-29','09:40:00',4.43),('8902','2013-10-29','09:45:00',4.53),('8902','2013-10-29','09:50:00',4.64),('8902','2013-10-29','09:55:00',4.62),('8902','2013-10-29','10:00:00',4.41),('8902','2013-10-29','10:05:00',4.66),('8902','2013-10-29','10:10:00',4.57),('8902','2013-10-29','10:15:00',4.94),('8902','2013-10-29','10:20:00',4.83),('8902','2013-10-29','10:25:00',4.7),('8902','2013-10-29','10:30:00',4.99),('8902','2013-10-29','10:35:00',4.87),('8902','2013-10-29','10:40:00',4.33),('8902','2013-10-29','10:45:00',4.78),('8902','2013-10-29','10:50:00',2.32),('8902','2013-10-29','10:55:00',1.88),('8902','2013-10-29','11:00:00',2.69),('8902','2013-10-29','11:05:00',4.27),('8902','2013-10-29','11:10:00',4.65),('8902','2013-10-29','11:15:00',5.11),('8902','2013-10-29','11:20:00',5.46),('8902','2013-10-29','11:25:00',3.02),('8902','2013-10-29','11:30:00',2.45),('8902','2013-10-29','11:35:00',3.14),('8902','2013-10-29','11:40:00',2.55),('8902','2013-10-29','11:45:00',2.47),('8902','2013-10-29','11:50:00',3.86),('8902','2013-10-29','11:55:00',2.82),('8902','2013-10-29','12:00:00',1.76),('8902','2013-10-29','12:05:00',1.98),('8902','2013-10-29','12:10:00',2.09),('8902','2013-10-29','12:15:00',1.94),('8902','2013-10-29','12:20:00',2.07),('8902','2013-10-29','12:25:00',3.33),('8902','2013-10-29','12:30:00',5.16),('8902','2013-10-29','12:35:00',3.3),('8902','2013-10-29','12:40:00',2.62),('8902','2013-10-29','12:45:00',4.24),('8902','2013-10-29','12:50:00',4.9),('8902','2013-10-29','12:55:00',4.15),('8902','2013-10-29','13:00:00',4.65),('8902','2013-10-29','13:05:00',4.44),('8902','2013-10-29','13:10:00',3.41),('8902','2013-10-29','13:15:00',3.02),('8902','2013-10-29','13:20:00',4.51),('8902','2013-10-29','13:25:00',3.51),('8902','2013-10-29','13:30:00',3.55),('8902','2013-10-29','13:35:00',4.52),('8902','2013-10-29','13:40:00',4.72),('8902','2013-10-29','13:45:00',4.78),('8902','2013-10-29','13:50:00',4.97),('8902','2013-10-29','13:55:00',4.18),('8902','2013-10-29','14:00:00',3.27),('8902','2013-10-29','14:05:00',5.04),('8902','2013-10-29','14:10:00',5.37),('8902','2013-10-29','14:15:00',3.02),('8902','2013-10-29','14:20:00',1.67),('8902','2013-10-29','14:25:00',1.65),('8902','2013-10-29','14:30:00',1.4),('8902','2013-10-29','14:35:00',1.51),('8902','2013-10-29','14:40:00',3.18),('8902','2013-10-29','14:45:00',3.84),('8902','2013-10-29','14:50:00',3.66),('8902','2013-10-29','14:55:00',2.58),('8902','2013-10-29','15:20:00',2.12),('8902','2013-10-29','15:25:00',2.38),('8902','2013-10-29','15:30:00',1.7),('8902','2013-10-29','16:00:00',1.18),('8902','2013-10-28','08:00:00',1.02),('8902','2013-10-28','08:05:00',1.06),('8902','2013-10-28','08:10:00',1.19),('8902','2013-10-28','08:15:00',1.28),('8902','2013-10-28','08:20:00',1.44),('8902','2013-10-28','08:25:00',1.51),('8902','2013-10-28','08:30:00',1.92),('8902','2013-10-28','08:35:00',1.76),('8902','2013-10-28','08:40:00',2.39),('8902','2013-10-28','08:45:00',2.53),('8902','2013-10-28','08:50:00',3.23),('8902','2013-10-28','08:55:00',3.47),('8902','2013-10-28','09:00:00',3.57),('8902','2013-10-28','09:05:00',3.7),('8902','2013-10-28','09:10:00',3.78),('8902','2013-10-28','09:15:00',3.78),('8902','2013-10-28','09:20:00',4.05),('8902','2013-10-28','09:25:00',4.12),('8902','2013-10-28','09:30:00',4.29),('8902','2013-10-28','09:35:00',4.49),('8902','2013-10-28','09:40:00',4.71),('8902','2013-10-28','09:45:00',4.76),('8902','2013-10-28','09:50:00',4.89),('8902','2013-10-28','09:55:00',4.89),('8902','2013-10-28','10:00:00',4.23),('8902','2013-10-28','10:05:00',3.81),('8902','2013-10-28','10:10:00',4.37),('8902','2013-10-28','10:15:00',4.37),('8902','2013-10-28','10:20:00',4.95),('8902','2013-10-28','10:25:00',4.03),('8902','2013-10-28','10:30:00',4.58),('8902','2013-10-28','10:35:00',6.08),('8902','2013-10-28','10:40:00',5.99),('8902','2013-10-28','10:45:00',5.9),('8902','2013-10-28','10:50:00',6.02),('8902','2013-10-28','10:55:00',6.25),('8902','2013-10-28','11:00:00',6.26),('8902','2013-10-28','11:05:00',6.26),('8902','2013-10-28','11:10:00',5.3),('8902','2013-10-28','11:15:00',5.65),('8902','2013-10-28','11:20:00',3.59),('8902','2013-10-28','11:25:00',2.88),('8902','2013-10-28','11:30:00',4.06),('8902','2013-10-28','11:35:00',6.18),('8902','2013-10-28','11:40:00',5.97),('8902','2013-10-28','11:45:00',6.16),('8902','2013-10-28','11:50:00',6.04),('8902','2013-10-28','11:55:00',5.9),('8902','2013-10-28','12:00:00',5.7),('8902','2013-10-28','12:05:00',5.87),('8902','2013-10-28','12:10:00',5.86),('8902','2013-10-28','12:15:00',5.86),('8902','2013-10-28','12:20:00',5.85),('8902','2013-10-28','12:25:00',5.82),('8902','2013-10-28','12:30:00',5.75),('8902','2013-10-28','12:35:00',5.53),('8902','2013-10-28','12:40:00',5.6),('8902','2013-10-28','12:45:00',5.73),('8902','2013-10-28','12:50:00',5.75),('8902','2013-10-28','12:55:00',5.54),('8902','2013-10-28','13:00:00',5.5),('8902','2013-10-28','13:05:00',5.26),('8902','2013-10-28','13:10:00',5.32),('8902','2013-10-28','13:15:00',5.35),('8902','2013-10-28','13:20:00',5.25),('8902','2013-10-28','13:25:00',5.23),('8902','2013-10-28','13:30:00',5.1),('8902','2013-10-28','13:35:00',4.97),('8902','2013-10-28','13:40:00',5.12),('8902','2013-10-28','13:45:00',5.08),('8902','2013-10-28','13:50:00',4.97),('8902','2013-10-28','13:55:00',4.75),('8902','2013-10-28','14:00:00',4.64),('8902','2013-10-28','14:05:00',4.43),('8902','2013-10-28','14:10:00',4.59),('8902','2013-10-28','14:15:00',4.49),('8902','2013-10-28','14:20:00',4.39),('8902','2013-10-28','14:25:00',4.22),('8902','2013-10-28','14:30:00',4.08),('8902','2013-10-28','14:35:00',3.92),('8902','2013-10-28','14:40:00',3.79),('8902','2013-10-28','14:45:00',3.75),('8902','2013-10-28','14:50:00',3.58),('8902','2013-10-28','14:55:00',3.37),('8902','2013-10-28','15:00:00',3.17),('8902','2013-10-28','15:05:00',3.04),('8902','2013-10-28','15:10:00',2.95),('8902','2013-10-28','15:15:00',2.85),('8902','2013-10-28','15:20:00',2.66),('8902','2013-10-28','15:25:00',2.46),('8902','2013-10-28','15:30:00',2.33),('8902','2013-10-28','15:35:00',2.17),('8902','2013-10-28','15:40:00',1.99),('8902','2013-10-28','15:45:00',1.82),('8902','2013-10-28','15:50:00',1.63),('8902','2013-10-28','15:55:00',1.47),('8902','2013-10-28','16:00:00',1.32),('8902','2013-10-28','16:05:00',1.15),('8902','2013-10-28','16:10:00',1),('8902','2014-04-16','07:55:00',1.15),('8902','2014-04-16','08:00:00',1.6),('8902','2014-04-16','08:05:00',1.83),('8902','2014-04-16','08:10:00',2.04),('8902','2014-04-16','08:15:00',2.24),('8902','2014-04-16','08:20:00',2.31),('8902','2014-04-16','08:25:00',2.59),('8902','2014-04-16','08:30:00',2.77),('8902','2014-04-16','08:35:00',2.95),('8902','2014-04-16','08:40:00',3.14),('8902','2014-04-16','08:45:00',3.33),('8902','2014-04-16','08:50:00',3.54),('8902','2014-04-16','08:55:00',3.24),('8902','2014-04-16','09:00:00',3.14),('8902','2014-04-16','09:05:00',3.73),('8902','2014-04-16','09:10:00',4.23),('8902','2014-04-16','09:15:00',4.23),('8902','2014-04-16','09:20:00',4.56),('8902','2014-04-16','09:25:00',4.84),('8902','2014-04-16','09:30:00',5.02),('8902','2014-04-16','09:35:00',5.17),('8902','2014-04-16','09:40:00',5.35),('8902','2014-04-16','09:45:00',5.54),('8902','2014-04-16','09:50:00',5.7),('8902','2014-04-16','09:55:00',5.9),('8902','2014-04-16','10:00:00',6.16),('8902','2014-04-16','10:05:00',6.68),('8902','2014-04-16','10:10:00',6.4),('8902','2014-04-16','10:15:00',5.4),('8902','2014-04-16','10:20:00',6.5),('8902','2014-04-16','10:25:00',7.38),('8902','2014-04-16','10:30:00',7.81),('8902','2014-04-16','10:35:00',8.01),('8902','2014-04-16','10:40:00',7.65),('8902','2014-04-16','10:45:00',6.28),('8902','2014-04-16','10:50:00',4.94),('8902','2014-04-16','10:55:00',4.84),('8902','2014-04-16','11:00:00',4.82),('8902','2014-04-16','11:05:00',7.48),('8902','2014-04-16','11:10:00',6.49),('8902','2014-04-16','11:15:00',5.92),('8902','2014-04-16','11:20:00',6.22),('8902','2014-04-16','11:25:00',6.93),('8902','2014-04-16','11:30:00',4.85),('8902','2014-04-16','11:35:00',5.86),('8902','2014-04-16','11:40:00',5.27),('8902','2014-04-16','11:45:00',6.34),('8902','2014-04-16','11:50:00',4.79),('8902','2014-04-16','11:55:00',3.88),('8902','2014-04-16','12:00:00',4.06),('8902','2014-04-16','12:05:00',5.53),('8902','2014-04-16','12:10:00',5.47),('8902','2014-04-16','12:15:00',4.81),('8902','2014-04-16','12:20:00',4.62),('8902','2014-04-16','12:25:00',4.97),('8902','2014-04-16','12:30:00',6.15),('8902','2014-04-16','12:35:00',7.62),('8902','2014-04-16','12:40:00',8.74),('8902','2014-04-16','12:45:00',8.33),('8902','2014-04-16','12:50:00',8.62),('8902','2014-04-16','12:55:00',8.84),('8902','2014-04-16','13:00:00',8.87),('8902','2014-04-16','13:05:00',4.61),('8902','2014-04-16','13:10:00',1.87),('8902','2014-04-16','13:15:00',3.45),('8902','2014-04-16','13:20:00',3.87),('8902','2014-04-16','13:25:00',9.99),('8902','2014-04-16','13:30:00',8.38),('8902','2014-04-16','13:35:00',2.03),('8902','2014-04-16','13:40:00',1.82),('8902','2014-04-16','13:45:00',1.73),('8902','2014-04-16','13:50:00',1.95),('8902','2014-04-16','13:55:00',2.21),('8902','2014-04-16','14:00:00',2.17),('8902','2014-04-16','14:05:00',2.24),('8902','2014-04-16','14:10:00',4.3),('8902','2014-04-16','14:15:00',2.64),('8902','2014-04-16','14:20:00',2.63),('8902','2014-04-16','14:25:00',2.8),('8902','2014-04-16','14:30:00',2.99),('8902','2014-04-16','14:35:00',3.53),('8902','2014-04-16','14:40:00',5.94),('8902','2014-04-16','14:45:00',2.71),('8902','2014-04-16','14:50:00',1.78),('8902','2014-04-16','14:55:00',1.51),('8902','2014-04-16','15:00:00',1.65),('8902','2014-04-16','15:05:00',1.89),('8902','2014-04-16','15:10:00',1.85),('8902','2014-04-16','15:15:00',1.68),('8902','2014-04-16','15:20:00',1.67),('8902','2014-04-16','15:25:00',2.08),('8902','2014-04-16','15:30:00',3.35),('8902','2014-04-16','15:35:00',4.21),('8902','2014-04-16','15:40:00',3.27),('8902','2014-04-16','15:45:00',2.38),('8902','2014-04-16','15:50:00',2.21),('8902','2014-04-16','15:55:00',2.53),('8902','2014-04-16','16:00:00',2.29),('8902','2014-04-16','16:05:00',1.82),('8902','2014-04-16','16:10:00',2.02),('8902','2014-04-16','16:15:00',2.14),('8902','2014-04-16','16:20:00',2.09),('8902','2014-04-16','16:25:00',2.22),('8902','2014-04-16','16:30:00',2.35),('8902','2014-04-16','16:35:00',2.12),('8902','2014-04-16','16:40:00',2.38),('8902','2014-04-16','16:45:00',2.98),('8902','2014-04-16','16:50:00',3.03),('8902','2014-04-16','16:55:00',2.31),('8902','2014-04-16','17:00:00',1.93),('8902','2014-04-16','17:05:00',1.61),('8902','2014-04-16','17:10:00',1.59),('8902','2014-04-16','17:15:00',1.74),('8902','2014-04-16','17:20:00',2.1),('8902','2014-04-16','17:25:00',1.84),('8902','2014-04-16','17:30:00',1.85),('8902','2014-04-16','17:35:00',1.84),('8902','2014-04-16','17:40:00',1.79),('8902','2014-04-16','17:45:00',1.62),('8902','2014-04-16','17:50:00',1.34),('8902','2014-04-16','17:55:00',1.28),('8902','2014-04-16','18:00:00',1.06),('8902','2013-10-27','07:30:00',1.15),('8902','2013-10-27','07:35:00',1.36),('8902','2013-10-27','07:40:00',1.33),('8902','2013-10-27','08:10:00',1.31),('8902','2013-10-27','08:15:00',1.13),('8902','2013-10-27','08:20:00',1.23),('8902','2013-10-27','08:25:00',1.09),('8902','2013-10-27','08:30:00',1.12),('8902','2013-10-27','08:35:00',1.21),('8902','2013-10-27','08:40:00',1.23),('8902','2013-10-27','08:45:00',1.61),('8902','2013-10-27','08:50:00',2.51),('8902','2013-10-27','08:55:00',3.29),('8902','2013-10-27','09:00:00',3.71),('8902','2013-10-27','09:05:00',4.07),('8902','2013-10-27','09:10:00',4.41),('8902','2013-10-27','09:15:00',4.41),('8902','2013-10-27','09:20:00',4.16),('8902','2013-10-27','09:25:00',3.97),('8902','2013-10-27','09:30:00',4.69),('8902','2013-10-27','09:35:00',4.29),('8902','2013-10-27','09:40:00',2.53),('8902','2013-10-27','09:45:00',2.48),('8902','2013-10-27','09:50:00',4.73),('8902','2013-10-27','09:55:00',2.99),('8902','2013-10-27','10:00:00',1.99),('8902','2013-10-27','10:05:00',1.6),('8902','2013-10-27','10:10:00',1.63),('8902','2013-10-27','10:15:00',1.56),('8902','2013-10-27','10:20:00',1.68),('8902','2013-10-27','10:25:00',1.69),('8902','2013-10-27','10:30:00',1.71),('8902','2013-10-27','10:35:00',1.69),('8902','2013-10-27','10:40:00',1.35),('8902','2013-10-27','10:50:00',5.99),('8902','2013-10-27','10:55:00',5.91),('8902','2013-10-27','11:00:00',5.83),('8902','2013-10-27','11:05:00',5.99),('8902','2013-10-27','11:10:00',5.98),('8902','2013-10-27','11:15:00',6.02),('8902','2013-10-27','11:20:00',6.04),('8902','2013-10-27','11:25:00',6.08),('8902','2013-10-27','11:30:00',6.07),('8902','2013-10-27','11:35:00',6.05),('8902','2013-10-27','11:40:00',6.02),('8902','2013-10-27','11:45:00',6.03),('8902','2013-10-27','11:50:00',6.12),('8902','2013-10-27','11:55:00',5.79),('8902','2013-10-27','12:00:00',3.67),('8902','2013-10-27','12:05:00',5.55),('8902','2013-10-27','12:10:00',6.11),('8902','2013-10-27','12:15:00',6.44),('8902','2013-10-27','12:20:00',6.6),('8902','2013-10-27','12:25:00',5.32),('8902','2013-10-27','12:30:00',5.49),('8902','2013-10-27','12:35:00',7.1),('8902','2013-10-27','12:40:00',6.67),('8902','2013-10-27','12:45:00',6.59),('8902','2013-10-27','12:50:00',6.76),('8902','2013-10-27','12:55:00',6.49),('8902','2013-10-27','13:00:00',6.05),('8902','2013-10-27','13:05:00',5.96),('8902','2013-10-27','13:10:00',6.01),('8902','2013-10-27','13:15:00',5.68),('8902','2013-10-27','13:20:00',5.82),('8902','2013-10-27','13:25:00',4.92),('8902','2013-10-27','13:30:00',5.67),('8902','2013-10-27','13:35:00',5.57),('8902','2013-10-27','13:40:00',5.51),('8902','2013-10-27','13:45:00',5.52),('8902','2013-10-27','13:50:00',4.86),('8902','2013-10-27','13:55:00',5.16),('8902','2013-10-27','14:00:00',5.24),('8902','2013-10-27','14:05:00',5.27),('8902','2013-10-27','14:10:00',5.41),('8902','2013-10-27','14:15:00',5.14),('8902','2013-10-27','14:20:00',5.01),('8902','2013-10-27','14:25:00',5.18),('8902','2013-10-27','14:30:00',4.04),('8902','2013-10-27','14:35:00',3.98),('8902','2013-10-27','14:40:00',2.58),('8902','2013-10-27','14:45:00',3.08),('8902','2013-10-27','14:50:00',4.12),('8902','2013-10-27','14:55:00',3.81),('8902','2013-10-27','15:00:00',3.82),('8902','2013-10-27','15:05:00',3.66),('8902','2013-10-27','15:10:00',3.46),('8902','2013-10-27','15:15:00',2.74),('8902','2013-10-27','15:20:00',1.13),('8902','2013-10-27','15:25:00',2.5),('8902','2013-10-27','15:30:00',2.4),('8902','2013-10-27','15:40:00',1.4),('8902','2013-10-27','15:45:00',1.67),('8902','2013-10-27','15:50:00',2.36),('8902','2013-10-27','15:55:00',1.89),('8902','2013-10-27','16:00:00',1.63),('8902','2013-10-27','16:05:00',1.09),('8902','2013-10-27','16:15:00',1.01),('8902','2013-10-26','08:45:00',1.06),('8902','2013-10-26','08:50:00',1.09),('8902','2013-10-26','08:55:00',1.22),('8902','2013-10-26','09:00:00',1.38),('8902','2013-10-26','09:05:00',1.28),('8902','2013-10-26','09:10:00',1.03),('8902','2013-10-26','09:25:00',1.06),('8902','2013-10-26','09:30:00',1.18),('8902','2013-10-26','09:35:00',1.32),('8902','2013-10-26','09:40:00',1.45),('8902','2013-10-26','09:45:00',1.64),('8902','2013-10-26','09:50:00',1.76),('8902','2013-10-26','09:55:00',1.86),('8902','2013-10-26','10:00:00',2),('8902','2013-10-26','10:05:00',2.15),('8902','2013-10-26','10:10:00',2.26),('8902','2013-10-26','10:15:00',2.3),('8902','2013-10-26','10:20:00',2.56),('8902','2013-10-26','10:25:00',2.52),('8902','2013-10-26','10:30:00',2.5),('8902','2013-10-26','10:35:00',2.46),('8902','2013-10-26','10:40:00',2.4),('8902','2013-10-26','10:45:00',2.75),('8902','2013-10-26','10:50:00',2.73),('8902','2013-10-26','10:55:00',2.49),('8902','2013-10-26','11:00:00',2.33),('8902','2013-10-26','11:05:00',2.02),('8902','2013-10-26','11:10:00',1.62),('8902','2013-10-26','11:15:00',1.3),('8902','2013-10-26','11:20:00',1.19),('8902','2013-10-26','11:25:00',1.33),('8902','2013-10-26','11:30:00',1.74),('8902','2013-10-26','11:35:00',2.36),('8902','2013-10-26','11:40:00',3.27),('8902','2013-10-26','11:45:00',3.91),('8902','2013-10-26','11:50:00',5.24),('8902','2013-10-26','11:55:00',2.4),('8902','2013-10-26','12:00:00',2.13),('8902','2013-10-26','12:05:00',2.25),('8902','2013-10-26','12:10:00',2.51),('8902','2013-10-26','12:15:00',3.4),('8902','2013-10-26','12:20:00',4.56),('8902','2013-10-26','12:25:00',6.23),('8902','2013-10-26','12:30:00',4.38),('8902','2013-10-26','12:35:00',5.62),('8902','2013-10-26','12:40:00',5.74),('8902','2013-10-26','12:45:00',5.18),('8902','2013-10-26','12:50:00',5.33),('8902','2013-10-26','12:55:00',6.08),('8902','2013-10-26','13:00:00',5.53),('8902','2013-10-26','13:05:00',2.68),('8902','2013-10-26','13:10:00',3.55),('8902','2013-10-26','13:15:00',2.66),('8902','2013-10-26','13:20:00',2.13),('8902','2013-10-26','13:25:00',2.93),('8902','2013-10-26','13:30:00',5.03),('8902','2013-10-26','13:35:00',5.2),('8902','2013-10-26','13:40:00',3.11),('8902','2013-10-26','13:45:00',1.82),('8902','2013-10-26','13:50:00',1.4),('8902','2013-10-26','13:55:00',1.3),('8902','2013-10-26','14:00:00',1.71),('8902','2013-10-26','14:05:00',2.35),('8902','2013-10-26','14:10:00',2.18),('8902','2013-10-26','14:15:00',1.96),('8902','2013-10-26','14:20:00',2.04),('8902','2013-10-26','14:25:00',2.1),('8902','2013-10-26','14:30:00',1.77),('8902','2013-10-26','14:35:00',2.7),('8902','2013-10-26','14:40:00',4.26),('8902','2013-10-26','14:45:00',4.11),('8902','2013-10-26','14:50:00',3.57),('8902','2013-10-26','14:55:00',3.85),('8902','2013-10-26','15:00:00',3.8),('8902','2013-10-26','15:05:00',3.13),('8902','2013-10-26','15:10:00',2.99),('8902','2013-10-26','15:15:00',3.14),('8902','2013-10-26','15:20:00',3.06),('8902','2013-10-26','15:25:00',2.88),('8902','2013-10-26','15:30:00',2.56),('8902','2013-10-26','15:35:00',1.74),('8902','2013-10-26','15:50:00',1.77),('8902','2013-10-26','15:55:00',1.47),('8902','2013-10-26','16:00:00',1.38),('8902','2013-10-26','16:05:00',1.38),('8902','2013-10-26','16:10:00',1.19),('8902','2013-10-26','16:15:00',1.03),('8902','2013-10-25','08:40:00',1.04),('8902','2013-10-25','08:45:00',1.16),('8902','2013-10-25','08:50:00',1.29),('8902','2013-10-25','08:55:00',1.57),('8902','2013-10-25','09:00:00',1.75),('8902','2013-10-25','09:05:00',1.89),('8902','2013-10-25','09:10:00',2.04),('8902','2013-10-25','09:15:00',2.2),('8902','2013-10-25','09:20:00',2.36),('8902','2013-10-25','09:25:00',2.54),('8902','2013-10-25','09:30:00',2.72),('8902','2013-10-25','09:35:00',2.9),('8902','2013-10-25','09:40:00',3.05),('8902','2013-10-25','09:45:00',3.22),('8902','2013-10-25','09:50:00',3.38),('8902','2013-10-25','09:55:00',3.5),('8902','2013-10-25','10:00:00',3.63),('8902','2013-10-25','10:05:00',3.77),('8902','2013-10-25','10:10:00',3.9),('8902','2013-10-25','10:15:00',4.03),('8902','2013-10-25','10:20:00',4.13),('8902','2013-10-25','10:25:00',4.26),('8902','2013-10-25','10:30:00',4.36),('8902','2013-10-25','10:35:00',4.47),('8902','2013-10-25','10:40:00',4.58),('8902','2013-10-25','10:45:00',4.67),('8902','2013-10-25','10:50:00',4.8),('8902','2013-10-25','10:55:00',4.91),('8902','2013-10-25','11:00:00',5),('8902','2013-10-25','11:05:00',5.1),('8902','2013-10-25','11:10:00',5.15),('8902','2013-10-25','11:15:00',5.26),('8902','2013-10-25','11:20:00',5.33),('8902','2013-10-25','11:25:00',5.36),('8902','2013-10-25','11:30:00',5.45),('8902','2013-10-25','11:35:00',5.49),('8902','2013-10-25','11:40:00',5.56),('8902','2013-10-25','11:45:00',5.61),('8902','2013-10-25','11:50:00',5.65),('8902','2013-10-25','11:55:00',5.69),('8902','2013-10-25','12:00:00',5.76),('8902','2013-10-25','12:05:00',5.73),('8902','2013-10-25','12:10:00',5.72),('8902','2013-10-25','12:15:00',5.7),('8902','2013-10-25','12:20:00',5.88),('8902','2013-10-25','12:25:00',5.89),('8902','2013-10-25','12:30:00',5.96),('8902','2013-10-25','12:35:00',5.7),('8902','2013-10-25','12:40:00',5.86),('8902','2013-10-25','12:45:00',5.83),('8902','2013-10-25','12:50:00',5.98),('8902','2013-10-25','12:55:00',4.17),('8902','2013-10-25','13:00:00',5.59),('8902','2013-10-25','13:05:00',5.81),('8902','2013-10-25','13:10:00',5.96),('8902','2013-10-25','13:15:00',5.69),('8902','2013-10-25','13:20:00',5.57),('8902','2013-10-25','13:25:00',5.78),('8902','2013-10-25','13:30:00',4.65),('8902','2013-10-25','13:35:00',5.39),('8902','2013-10-25','13:40:00',5.82),('8902','2013-10-25','13:45:00',5.71),('8902','2013-10-25','13:50:00',5.7),('8902','2013-10-25','13:55:00',5.68),('8902','2013-10-25','14:00:00',5.45),('8902','2013-10-25','14:05:00',5.13),('8902','2013-10-25','14:10:00',5.35),('8902','2013-10-25','14:15:00',4.98),('8902','2013-10-25','14:20:00',2.99),('8902','2013-10-25','14:25:00',3.41),('8902','2013-10-25','14:30:00',3.34),('8902','2013-10-25','14:35:00',4.03),('8902','2013-10-25','14:40:00',4.92),('8902','2013-10-25','14:45:00',4.64),('8902','2013-10-25','14:50:00',4.69),('8902','2013-10-25','14:55:00',4.47),('8902','2013-10-25','15:00:00',4.55),('8902','2013-10-25','15:05:00',4.62),('8902','2013-10-25','15:10:00',4.48),('8902','2013-10-25','15:15:00',4.22),('8902','2013-10-25','15:20:00',4.17),('8902','2013-10-25','15:25:00',4.05),('8902','2013-10-25','15:30:00',3.84),('8902','2013-10-25','15:35:00',3.8),('8902','2013-10-25','15:40:00',3.83),('8902','2013-10-25','15:45:00',3.6),('8902','2013-10-25','15:50:00',3.7),('8902','2013-10-25','15:55:00',3.4),('8902','2013-10-25','16:00:00',2.88),('8902','2013-10-25','16:05:00',2.72),('8902','2013-10-25','16:10:00',2.86),('8902','2013-10-25','16:15:00',2.63),('8902','2013-10-25','16:20:00',2.62),('8902','2013-10-25','16:25:00',2.42),('8902','2013-10-25','16:30:00',2.3),('8902','2013-10-25','16:35:00',2.11),('8902','2013-10-25','16:40:00',2),('8902','2013-10-25','16:45:00',1.88),('8902','2013-10-25','16:50:00',1.67),('8902','2013-10-25','16:55:00',1.51),('8902','2013-10-25','17:00:00',1.34),('8902','2013-10-25','17:05:00',1.2),('8902','2013-10-25','17:10:00',1.06),('8902','2013-10-24','08:40:00',1.05),('8902','2013-10-24','08:45:00',1.31),('8902','2013-10-24','08:50:00',1.5),('8902','2013-10-24','08:55:00',1.66),('8902','2013-10-24','09:00:00',1.84),('8902','2013-10-24','09:05:00',2),('8902','2013-10-24','09:10:00',2.14),('8902','2013-10-24','09:15:00',2.28),('8902','2013-10-24','09:20:00',2.44),('8902','2013-10-24','09:25:00',2.61),('8902','2013-10-24','09:30:00',2.79),('8902','2013-10-24','09:35:00',2.95),('8902','2013-10-24','09:40:00',3.11),('8902','2013-10-24','09:45:00',3.27),('8902','2013-10-24','09:50:00',3.42),('8902','2013-10-24','09:55:00',3.56),('8902','2013-10-24','10:00:00',3.72),('8902','2013-10-24','10:05:00',3.85),('8902','2013-10-24','10:10:00',3.96),('8902','2013-10-24','10:15:00',4.1),('8902','2013-10-24','10:20:00',4.2),('8902','2013-10-24','10:25:00',4.34),('8902','2013-10-24','10:30:00',4.46),('8902','2013-10-24','10:35:00',4.59),('8902','2013-10-24','10:40:00',4.69),('8902','2013-10-24','10:45:00',4.79),('8902','2013-10-24','10:50:00',4.88),('8902','2013-10-24','10:55:00',4.93),('8902','2013-10-24','11:00:00',5.09),('8902','2013-10-24','11:05:00',5.12),('8902','2013-10-24','11:10:00',5.13),('8902','2013-10-24','11:15:00',5.29),('8902','2013-10-24','11:20:00',5.4),('8902','2013-10-24','11:25:00',5.51),('8902','2013-10-24','11:30:00',5.46),('8902','2013-10-24','11:35:00',5.45),('8902','2013-10-24','11:40:00',5.66),('8902','2013-10-24','11:45:00',5.68),('8902','2013-10-24','11:50:00',5.73),('8902','2013-10-24','11:55:00',5.8),('8902','2013-10-24','12:00:00',5.94),('8902','2013-10-24','12:05:00',6.01),('8902','2013-10-24','12:10:00',6),('8902','2013-10-24','12:15:00',6.01),('8902','2013-10-24','12:20:00',6.05),('8902','2013-10-24','12:25:00',6.11),('8902','2013-10-24','12:30:00',6.12),('8902','2013-10-24','12:35:00',6.13),('8902','2013-10-24','12:40:00',6.14),('8902','2013-10-24','12:45:00',6.13),('8902','2013-10-24','12:50:00',6.11),('8902','2013-10-24','12:55:00',6.07),('8902','2013-10-24','13:00:00',6.08),('8902','2013-10-24','13:05:00',6.07),('8902','2013-10-24','13:10:00',6.1),('8902','2013-10-24','13:15:00',6.07),('8902','2013-10-24','13:20:00',6.1),('8902','2013-10-24','13:25:00',6.07),('8902','2013-10-24','13:30:00',5.96),('8902','2013-10-24','13:35:00',5.9),('8902','2013-10-24','13:40:00',5.94),('8902','2013-10-24','13:45:00',5.93),('8902','2013-10-24','13:50:00',5.81),('8902','2013-10-24','13:55:00',5.84),('8902','2013-10-24','14:00:00',5.82),('8902','2013-10-24','14:05:00',5.72),('8902','2013-10-24','14:10:00',5.72),('8902','2013-10-24','14:15:00',5.7),('8902','2013-10-24','14:20:00',5.67),('8902','2013-10-24','14:25:00',5.6),('8902','2013-10-24','14:30:00',5.5),('8902','2013-10-24','14:35:00',5.46),('8902','2013-10-24','14:40:00',5.33),('8902','2013-10-24','14:45:00',5.27),('8902','2013-10-24','14:50:00',5.25),('8902','2013-10-24','14:55:00',5.17),('8902','2013-10-24','15:00:00',5.07),('8902','2013-10-24','15:05:00',4.99),('8902','2013-10-24','15:10:00',4.89),('8902','2013-10-24','15:15:00',4.79),('8902','2013-10-24','15:20:00',4.6),('8902','2013-10-24','15:25:00',4.51),('8902','2013-10-24','15:30:00',4.37),('8902','2013-10-24','15:35:00',4.22),('8902','2013-10-24','15:40:00',4.13),('8902','2013-10-24','15:45:00',3.96),('8902','2013-10-24','15:50:00',3.86),('8902','2013-10-24','15:55:00',3.68),('8902','2013-10-24','16:00:00',3.58),('8902','2013-10-24','16:05:00',3.47),('8902','2013-10-24','16:10:00',3.33),('8902','2013-10-24','16:15:00',3.21),('8902','2013-10-24','16:20:00',3.07),('8902','2013-10-24','16:25:00',2.93),('8902','2013-10-24','16:30:00',2.78),('8902','2013-10-24','16:35:00',2.6),('8902','2013-10-24','16:40:00',2.44),('8902','2013-10-24','16:45:00',2.29),('8902','2013-10-24','16:50:00',2.11),('8902','2013-10-24','16:55:00',1.94),('8902','2013-10-24','17:00:00',1.77),('8902','2013-10-24','17:05:00',1.59),('8902','2013-10-24','17:10:00',1.41),('8902','2013-10-24','17:15:00',1.22),('8902','2013-10-24','17:20:00',1.04),('8902','2013-10-23','08:30:00',1.23),('8902','2013-10-23','08:50:00',1.11),('8902','2013-10-23','08:55:00',1.46),('8902','2013-10-23','09:00:00',1.34),('8902','2013-10-23','09:05:00',1.36),('8902','2013-10-23','09:10:00',1.9),('8902','2013-10-23','09:15:00',2.63),('8902','2013-10-23','09:20:00',2.72),('8902','2013-10-23','09:25:00',1.71),('8902','2013-10-23','09:30:00',1.78),('8902','2013-10-23','09:35:00',1.97),('8902','2013-10-23','09:40:00',2.1),('8902','2013-10-23','09:45:00',2.16),('8902','2013-10-23','09:50:00',2.27),('8902','2013-10-23','09:55:00',2.14),('8902','2013-10-23','10:00:00',2.08),('8902','2013-10-23','10:05:00',2),('8902','2013-10-23','10:10:00',1.9),('8902','2013-10-23','10:15:00',1.76),('8902','2013-10-23','10:20:00',2.36),('8902','2013-10-23','10:25:00',1.78),('8902','2013-10-23','10:30:00',1.36),('8902','2013-10-23','10:35:00',2.76),('8902','2013-10-23','10:40:00',2.76),('8902','2013-10-23','10:45:00',4.16),('8902','2013-10-23','10:50:00',3.52),('8902','2013-10-23','10:55:00',4.42),('8902','2013-10-23','11:00:00',5.18),('8902','2013-10-23','11:05:00',6.07),('8902','2013-10-23','11:10:00',6.43),('8902','2013-10-23','11:15:00',4.83),('8902','2013-10-23','11:20:00',3.05),('8902','2013-10-23','11:25:00',4.14),('8902','2013-10-23','11:30:00',3.71),('8902','2013-10-23','11:35:00',2.32),('8902','2013-10-23','11:40:00',2.36),('8902','2013-10-23','11:45:00',2.32),('8902','2013-10-23','11:50:00',2.93),('8902','2013-10-23','11:55:00',5.31),('8902','2013-10-23','12:00:00',3.81),('8902','2013-10-23','12:05:00',2.74),('8902','2013-10-23','12:10:00',2.56),('8902','2013-10-23','12:15:00',2.53),('8902','2013-10-23','12:20:00',2.6),('8902','2013-10-23','12:25:00',2.85),('8902','2013-10-23','12:30:00',3.01),('8902','2013-10-23','12:35:00',3.24),('8902','2013-10-23','12:40:00',3.64),('8902','2013-10-23','12:45:00',4.66),('8902','2013-10-23','12:50:00',5.07),('8902','2013-10-23','12:55:00',4.78),('8902','2013-10-23','13:00:00',6.83),('8902','2013-10-23','13:05:00',7.41),('8902','2013-10-23','13:10:00',6.42),('8902','2013-10-23','13:15:00',4.78),('8902','2013-10-23','13:20:00',5.52),('8902','2013-10-23','13:25:00',4.02),('8902','2013-10-23','13:30:00',2.83),('8902','2013-10-23','13:35:00',2.59),('8902','2013-10-23','13:40:00',2.59),('8902','2013-10-23','13:45:00',2.69),('8902','2013-10-23','13:50:00',3.85),('8902','2013-10-23','13:55:00',3.7),('8902','2013-10-23','14:00:00',4.47),('8902','2013-10-23','14:05:00',4.07),('8902','2013-10-23','14:10:00',2.79),('8902','2013-10-23','14:15:00',2.81),('8902','2013-10-23','14:20:00',2.86),('8902','2013-10-23','14:25:00',2.95),('8902','2013-10-23','14:30:00',2.97),('8902','2013-10-23','14:35:00',3.37),('8902','2013-10-23','14:40:00',3.45),('8902','2013-10-23','14:45:00',3.42),('8902','2013-10-23','14:50:00',4.74),('8902','2013-10-23','14:55:00',2.01),('8902','2013-10-23','15:00:00',2.31),('8902','2013-10-23','15:05:00',2.3),('8902','2013-10-23','15:10:00',4.78),('8902','2013-10-23','15:15:00',3.39),('8902','2013-10-23','15:20:00',2.37),('8902','2013-10-23','15:25:00',2.76),('8902','2013-10-23','15:30:00',2.2),('8902','2013-10-23','15:35:00',5.45),('8902','2013-10-23','15:40:00',4.86),('8902','2013-10-23','15:45:00',3.47),('8902','2013-10-23','15:50:00',2.99),('8902','2013-10-23','15:55:00',1.57),('8902','2013-10-23','16:00:00',1.45),('8902','2013-10-23','16:05:00',1.4),('8902','2013-10-23','16:10:00',1.33),('8902','2013-10-23','16:15:00',1.31),('8902','2013-10-23','16:20:00',1.26),('8902','2013-10-23','16:25:00',1.09),('8902','2013-10-22','09:50:00',1.17),('8902','2013-10-22','09:55:00',1.11),('8902','2013-10-22','10:00:00',1.16),('8902','2013-10-22','10:05:00',1.34),('8902','2013-10-22','10:10:00',1.31),('8902','2013-10-22','10:15:00',1.42),('8902','2013-10-22','10:20:00',1.53),('8902','2013-10-22','10:25:00',2.02),('8902','2013-10-22','10:30:00',2.08),('8902','2013-10-22','10:35:00',1.91),('8902','2013-10-22','10:40:00',1.85),('8902','2013-10-22','10:45:00',2.3),('8902','2013-10-22','10:50:00',2.56),('8902','2013-10-22','10:55:00',3.1),('8902','2013-10-22','11:00:00',3.07),('8902','2013-10-22','11:05:00',4.61),('8902','2013-10-22','11:10:00',3.91),('8902','2013-10-22','11:15:00',3.97),('8902','2013-10-22','11:20:00',4),('8902','2013-10-22','11:25:00',5.78),('8902','2013-10-22','11:30:00',5.61),('8902','2013-10-22','11:35:00',5.3),('8902','2013-10-22','11:40:00',4.44),('8902','2013-10-22','11:45:00',5.8),('8902','2013-10-22','11:50:00',5.76),('8902','2013-10-22','11:55:00',5.6),('8902','2013-10-22','12:00:00',5.89),('8902','2013-10-22','12:05:00',5.85),('8902','2013-10-22','12:10:00',5.81),('8902','2013-10-22','12:15:00',5.85),('8902','2013-10-22','12:20:00',5.38),('8902','2013-10-22','12:25:00',5.73),('8902','2013-10-22','12:30:00',5.76),('8902','2013-10-22','12:35:00',5.76),('8902','2013-10-22','12:40:00',5.6),('8902','2013-10-22','12:45:00',5.75),('8902','2013-10-22','12:50:00',5.28),('8902','2013-10-22','12:55:00',3.97),('8902','2013-10-22','13:00:00',5.51),('8902','2013-10-22','13:05:00',5.44),('8902','2013-10-22','13:10:00',5.54),('8902','2013-10-22','13:15:00',5.54),('8902','2013-10-22','13:20:00',5.82),('8902','2013-10-22','13:25:00',5.78),('8902','2013-10-22','13:30:00',5.63),('8902','2013-10-22','13:35:00',5.59),('8902','2013-10-22','13:40:00',5.68),('8902','2013-10-22','13:45:00',5.71),('8902','2013-10-22','13:50:00',4.45),('8902','2013-10-22','13:55:00',4.12),('8902','2013-10-22','14:00:00',3.11),('8902','2013-10-22','14:05:00',4.4),('8902','2013-10-22','14:10:00',5.58),('8902','2013-10-22','14:15:00',5.23),('8902','2013-10-22','14:20:00',5.49),('8902','2013-10-22','14:25:00',5.34),('8902','2013-10-22','14:30:00',5.24),('8902','2013-10-22','14:35:00',4.89),('8902','2013-10-22','14:40:00',4.73),('8902','2013-10-22','14:45:00',4.8),('8902','2013-10-22','14:50:00',4.22),('8902','2013-10-22','14:55:00',5.12),('8902','2013-10-22','15:00:00',4.82),('8902','2013-10-22','15:05:00',4.83),('8902','2013-10-22','15:10:00',4.62),('8902','2013-10-22','15:15:00',4.7),('8902','2013-10-22','15:20:00',4.7),('8902','2013-10-22','15:25:00',4.7),('8902','2013-10-22','15:30:00',4.56),('8902','2013-10-22','15:35:00',4.26),('8902','2013-10-22','15:40:00',4.46),('8902','2013-10-22','15:45:00',4.37),('8902','2013-10-22','15:50:00',3.9),('8902','2013-10-22','15:55:00',2.93),('8902','2013-10-22','16:00:00',2.55),('8902','2013-10-22','16:05:00',2.21),('8902','2013-10-22','16:10:00',2.13),('8902','2013-10-22','16:15:00',2.34),('8902','2013-10-22','16:20:00',2.08),('8902','2013-10-22','16:25:00',1.96),('8902','2013-10-22','16:30:00',1.68),('8902','2013-10-22','16:35:00',2.22),('8902','2013-10-22','16:40:00',2.36),('8902','2013-10-22','16:45:00',1.97),('8902','2013-10-22','16:50:00',1.79),('8902','2013-10-22','16:55:00',1.58),('8902','2013-10-22','17:00:00',1.55),('8902','2013-10-22','17:05:00',1.26),('8902','2013-10-22','17:10:00',1.06),('8902','2013-10-21','08:40:00',1.12),('8902','2013-10-21','08:45:00',1.27),('8902','2013-10-21','08:50:00',1.48),('8902','2013-10-21','08:55:00',1.67),('8902','2013-10-21','09:00:00',1.81),('8902','2013-10-21','09:05:00',1.95),('8902','2013-10-21','09:10:00',2.12),('8902','2013-10-21','09:15:00',2.26),('8902','2013-10-21','09:20:00',2.43),('8902','2013-10-21','09:25:00',2.59),('8902','2013-10-21','09:30:00',2.78),('8902','2013-10-21','09:35:00',2.95),('8902','2013-10-21','09:40:00',3.12),('8902','2013-10-21','09:45:00',3.29),('8902','2013-10-21','09:50:00',3.43),('8902','2013-10-21','09:55:00',3.58),('8902','2013-10-21','10:00:00',3.71),('8902','2013-10-21','10:05:00',3.84),('8902','2013-10-21','10:10:00',3.94),('8902','2013-10-21','10:15:00',4.05),('8902','2013-10-21','10:20:00',4.19),('8902','2013-10-21','10:25:00',4.32),('8902','2013-10-21','10:30:00',4.44),('8902','2013-10-21','10:35:00',4.54),('8902','2013-10-21','10:40:00',4.62),('8902','2013-10-21','10:45:00',4.73),('8902','2013-10-21','10:50:00',4.84),('8902','2013-10-21','10:55:00',4.95),('8902','2013-10-21','11:00:00',5.02),('8902','2013-10-21','11:05:00',5.07),('8902','2013-10-21','11:10:00',5.14),('8902','2013-10-21','11:15:00',5.24),('8902','2013-10-21','11:20:00',5.26),('8902','2013-10-21','11:25:00',5.28),('8902','2013-10-21','11:30:00',5.37),('8902','2013-10-21','11:35:00',5.42),('8902','2013-10-21','11:40:00',5.47),('8902','2013-10-21','11:45:00',5.59),('8902','2013-10-21','11:50:00',5.65),('8902','2013-10-21','11:55:00',5.55),('8902','2013-10-21','12:00:00',5.63),('8902','2013-10-21','12:05:00',5.65),('8902','2013-10-21','12:10:00',5.68),('8902','2013-10-21','12:15:00',5.69),('8902','2013-10-21','12:20:00',5.7),('8902','2013-10-21','12:25:00',5.69),('8902','2013-10-21','12:30:00',5.64),('8902','2013-10-21','12:35:00',5.63),('8902','2013-10-21','12:40:00',5.17),('8902','2013-10-21','12:45:00',5.43),('8902','2013-10-21','12:50:00',5.86),('8902','2013-10-21','12:55:00',5.85),('8902','2013-10-21','13:00:00',5.81),('8902','2013-10-21','13:05:00',6),('8902','2013-10-21','13:10:00',5.9),('8902','2013-10-21','13:15:00',5.82),('8902','2013-10-21','13:20:00',5.47),('8902','2013-10-21','13:25:00',5.91),('8902','2013-10-21','13:30:00',5.5),('8902','2013-10-21','13:35:00',5.21),('8902','2013-10-21','13:40:00',5.63),('8902','2013-10-21','13:45:00',5.4),('8902','2013-10-21','13:50:00',5.84),('8902','2013-10-21','13:55:00',5.42),('8902','2013-10-21','14:00:00',5.3),('8902','2013-10-21','14:05:00',4.59),('8902','2013-10-21','14:10:00',1.9),('8902','2013-10-21','14:15:00',3.82),('8902','2013-10-21','14:20:00',5.64),('8902','2013-10-21','14:25:00',2.87),('8902','2013-10-21','14:30:00',3.14),('8902','2013-10-21','14:35:00',2.07),('8902','2013-10-21','14:40:00',3.6),('8902','2013-10-21','14:45:00',3.79),('8902','2013-10-21','14:50:00',4.59),('8902','2013-10-21','14:55:00',4.73),('8902','2013-10-21','15:00:00',4.69),('8902','2013-10-21','15:05:00',4.69),('8902','2013-10-21','15:10:00',4.64),('8902','2013-10-21','15:15:00',4.44),('8902','2013-10-21','15:20:00',4.25),('8902','2013-10-21','15:25:00',4.26),('8902','2013-10-21','15:30:00',4.12),('8902','2013-10-21','15:35:00',4.12),('8902','2013-10-21','15:40:00',4),('8902','2013-10-21','15:45:00',3.75),('8902','2013-10-21','15:50:00',3.15),('8902','2013-10-21','15:55:00',3.59),('8902','2013-10-21','16:00:00',3.36),('8902','2013-10-21','16:05:00',3.14),('8902','2013-10-21','16:10:00',3.07),('8902','2013-10-21','16:15:00',3),('8902','2013-10-21','16:20:00',2.78),('8902','2013-10-21','16:25:00',2.66),('8902','2013-10-21','16:30:00',2.6),('8902','2013-10-21','16:35:00',2.41),('8902','2013-10-21','16:40:00',2.25),('8902','2013-10-21','16:45:00',2.11),('8902','2013-10-21','16:50:00',1.95),('8902','2013-10-21','16:55:00',1.78),('8902','2013-10-21','17:00:00',1.62),('8902','2013-10-21','17:05:00',1.46),('8902','2013-10-21','17:10:00',1.27),('8902','2013-10-21','17:15:00',1.09),('8902','2013-10-20','08:40:00',1.08),('8902','2013-10-20','08:45:00',1.18),('8902','2013-10-20','08:50:00',1.09),('8902','2013-10-20','08:55:00',1.33),('8902','2013-10-20','09:00:00',1.13),('8902','2013-10-20','09:05:00',1.26),('8902','2013-10-20','09:10:00',1.64),('8902','2013-10-20','09:15:00',1.86),('8902','2013-10-20','09:20:00',2.35),('8902','2013-10-20','09:25:00',2.84),('8902','2013-10-20','09:30:00',2.74),('8902','2013-10-20','09:35:00',2.56),('8902','2013-10-20','09:40:00',3.16),('8902','2013-10-20','09:45:00',2.73),('8902','2013-10-20','09:50:00',3),('8902','2013-10-20','09:55:00',3.45),('8902','2013-10-20','10:00:00',3.45),('8902','2013-10-20','10:05:00',3.8),('8902','2013-10-20','10:10:00',4.15),('8902','2013-10-20','10:15:00',4.27),('8902','2013-10-20','10:20:00',4.3),('8902','2013-10-20','10:25:00',4.48),('8902','2013-10-20','10:30:00',4.45),('8902','2013-10-20','10:35:00',4.52),('8902','2013-10-20','10:40:00',4.42),('8902','2013-10-20','10:45:00',4.52),('8902','2013-10-20','10:50:00',4.81),('8902','2013-10-20','10:55:00',4.82),('8902','2013-10-20','11:00:00',5.17),('8902','2013-10-20','11:05:00',5.05),('8902','2013-10-20','11:10:00',4.33),('8902','2013-10-20','11:15:00',5.57),('8902','2013-10-20','11:20:00',5.43),('8902','2013-10-20','11:25:00',5.54),('8902','2013-10-20','11:30:00',5.67),('8902','2013-10-20','11:35:00',5.7),('8902','2013-10-20','11:40:00',5.64),('8902','2013-10-20','11:45:00',5.88),('8902','2013-10-20','11:50:00',5.89),('8902','2013-10-20','11:55:00',5.89),('8902','2013-10-20','12:00:00',5.98),('8902','2013-10-20','12:05:00',6.05),('8902','2013-10-20','12:10:00',6.13),('8902','2013-10-20','12:15:00',6.11),('8902','2013-10-20','12:20:00',6.09),('8902','2013-10-20','12:25:00',6.17),('8902','2013-10-20','12:30:00',5.94),('8902','2013-10-20','12:35:00',5.96),('8902','2013-10-20','12:40:00',6.18),('8902','2013-10-20','12:45:00',6.23),('8902','2013-10-20','12:50:00',6.21),('8902','2013-10-20','12:55:00',6.18),('8902','2013-10-20','13:00:00',6.15),('8902','2013-10-20','13:05:00',6.09),('8902','2013-10-20','13:10:00',5.77),('8902','2013-10-20','13:15:00',6.03),('8902','2013-10-20','13:20:00',6),('8902','2013-10-20','13:25:00',6.02),('8902','2013-10-20','13:30:00',6.19),('8902','2013-10-20','13:35:00',6.16),('8902','2013-10-20','13:40:00',6.1),('8902','2013-10-20','13:45:00',6.09),('8902','2013-10-20','13:50:00',6.02),('8902','2013-10-20','13:55:00',5.8),('8902','2013-10-20','14:00:00',5.67),('8902','2013-10-20','14:05:00',5.83),('8902','2013-10-20','14:10:00',5.78),('8902','2013-10-20','14:15:00',5.77),('8902','2013-10-20','14:20:00',5.71),('8902','2013-10-20','14:25:00',5.64),('8902','2013-10-20','14:30:00',5.47),('8902','2013-10-20','14:35:00',5.45),('8902','2013-10-20','14:40:00',5.14),('8902','2013-10-20','14:45:00',5.08),('8902','2013-10-20','14:50:00',4.93),('8902','2013-10-20','14:55:00',4.89),('8902','2013-10-20','15:00:00',5.03),('8902','2013-10-20','15:05:00',5.02),('8902','2013-10-20','15:10:00',4.84),('8902','2013-10-20','15:15:00',4.8),('8902','2013-10-20','15:20:00',4.75),('8902','2013-10-20','15:25:00',4.58),('8902','2013-10-20','15:30:00',4.43),('8902','2013-10-20','15:35:00',4.15),('8902','2013-10-20','15:40:00',4.23),('8902','2013-10-20','15:45:00',4.11),('8902','2013-10-20','15:50:00',3.92),('8902','2013-10-20','15:55:00',3.79),('8902','2013-10-20','16:00:00',3.71),('8902','2013-10-20','16:05:00',3.53),('8902','2013-10-20','16:10:00',3.45),('8902','2013-10-20','16:15:00',3.32),('8902','2013-10-20','16:20:00',3.1),('8902','2013-10-20','16:25:00',2.94),('8902','2013-10-20','16:30:00',2.81),('8902','2013-10-20','16:35:00',2.62),('8902','2013-10-20','16:40:00',2.45),('8902','2013-10-20','16:45:00',2.3),('8902','2013-10-20','16:50:00',2.11),('8902','2013-10-20','16:55:00',1.83),('8902','2013-10-20','17:00:00',1.68),('8902','2013-10-20','17:05:00',1.53),('8902','2013-10-20','17:10:00',1.52),('8902','2013-10-20','17:15:00',1.37),('8902','2013-10-20','17:20:00',1.1),('8902','2013-10-19','08:25:00',1.01),('8902','2013-10-19','08:30:00',1.18),('8902','2013-10-19','08:35:00',1.32),('8902','2013-10-19','08:40:00',1.43),('8902','2013-10-19','08:45:00',1.53),('8902','2013-10-19','08:50:00',1.71),('8902','2013-10-19','08:55:00',1.89),('8902','2013-10-19','09:00:00',2.05),('8902','2013-10-19','09:05:00',2.13),('8902','2013-10-19','09:10:00',2.34),('8902','2013-10-19','09:15:00',2.49),('8902','2013-10-19','09:20:00',2.72),('8902','2013-10-19','09:25:00',2.9),('8902','2013-10-19','09:30:00',3.03),('8902','2013-10-19','09:35:00',3.16),('8902','2013-10-19','09:40:00',3.35),('8902','2013-10-19','09:45:00',3.52),('8902','2013-10-19','09:50:00',3.64),('8902','2013-10-19','09:55:00',3.71),('8902','2013-10-19','10:00:00',3.93),('8902','2013-10-19','10:05:00',4.07),('8902','2013-10-19','10:10:00',4.23),('8902','2013-10-19','10:15:00',4.38),('8902','2013-10-19','10:20:00',4.5),('8902','2013-10-19','10:25:00',4.61),('8902','2013-10-19','10:30:00',4.72),('8902','2013-10-19','10:35:00',4.84),('8902','2013-10-19','10:40:00',4.96),('8902','2013-10-19','10:45:00',5.05),('8902','2013-10-19','10:50:00',5.13),('8902','2013-10-19','10:55:00',5.21),('8902','2013-10-19','11:00:00',5.3),('8902','2013-10-19','11:05:00',5.41),('8902','2013-10-19','11:10:00',5.5),('8902','2013-10-19','11:15:00',5.57),('8902','2013-10-19','11:20:00',5.68),('8902','2013-10-19','11:25:00',5.78),('8902','2013-10-19','11:30:00',5.78),('8902','2013-10-19','11:35:00',5.89),('8902','2013-10-19','11:40:00',5.97),('8902','2013-10-19','11:45:00',5.93),('8902','2013-10-19','11:50:00',6.01),('8902','2013-10-19','11:55:00',5.99),('8902','2013-10-19','12:00:00',6.05),('8902','2013-10-19','12:05:00',6.17),('8902','2013-10-19','12:10:00',6.24),('8902','2013-10-19','12:15:00',3.16),('8902','2013-10-19','12:20:00',1.89),('8902','2013-10-19','12:25:00',4.65),('8902','2013-10-19','12:30:00',2.82),('8902','2013-10-19','12:35:00',7.36),('8902','2013-10-19','12:40:00',5.71),('8902','2013-10-19','12:45:00',5.27),('8902','2013-10-19','12:50:00',5.19),('8902','2013-10-19','12:55:00',5.52),('8902','2013-10-19','13:00:00',4.92),('8902','2013-10-19','13:05:00',4.73),('8902','2013-10-19','13:10:00',6.91),('8902','2013-10-19','13:15:00',3.4),('8902','2013-10-19','13:20:00',2.51),('8902','2013-10-19','13:25:00',3.56),('8902','2013-10-19','13:30:00',5.57),('8902','2013-10-19','13:35:00',3.66),('8902','2013-10-19','13:40:00',3.61),('8902','2013-10-19','13:45:00',4.61),('8902','2013-10-19','13:50:00',2.36),('8902','2013-10-19','13:55:00',2.34),('8902','2013-10-19','14:00:00',3.3),('8902','2013-10-19','14:05:00',1.88),('8902','2013-10-19','14:10:00',2.63),('8902','2013-10-19','14:15:00',2.15),('8902','2013-10-19','14:20:00',1.37),('8902','2013-10-19','14:25:00',1.09),('8902','2013-10-19','14:40:00',1.2),('8902','2013-10-19','14:45:00',1.4),('8902','2013-10-19','14:50:00',1.43),('8902','2013-10-19','14:55:00',1.28),('8902','2013-10-19','15:00:00',1.18),('8902','2013-10-19','15:05:00',1.06),('8902','2013-10-19','15:10:00',1.04),('8902','2013-10-19','15:15:00',1.05),('8902','2013-10-19','16:35:00',1.17),('8902','2013-10-19','16:40:00',2.05),('8902','2013-10-19','16:45:00',1.98),('8902','2013-10-19','16:50:00',2.74),('8902','2013-10-19','16:55:00',2.72),('8902','2013-10-19','17:00:00',2.6),('8902','2013-10-19','17:05:00',2.48),('8902','2013-10-19','17:10:00',2.07),('8902','2013-10-19','17:15:00',1.74),('8902','2013-10-19','17:20:00',1.45),('8902','2013-10-19','17:25:00',1.17),('8902','2013-10-18','08:35:00',1.29),('8902','2013-10-18','08:40:00',1.57),('8902','2013-10-18','08:45:00',1.77),('8902','2013-10-18','08:50:00',2.01),('8902','2013-10-18','08:55:00',1.68),('8902','2013-10-18','09:00:00',1.46),('8902','2013-10-18','09:05:00',1.99),('8902','2013-10-18','09:10:00',2.54),('8902','2013-10-18','09:15:00',3.05),('8902','2013-10-18','09:20:00',3.23),('8902','2013-10-18','09:25:00',3.32),('8902','2013-10-18','09:30:00',3.45),('8902','2013-10-18','09:35:00',3.59),('8902','2013-10-18','09:40:00',3.79),('8902','2013-10-18','09:45:00',4),('8902','2013-10-18','09:50:00',4.16),('8902','2013-10-18','09:55:00',4.44),('8902','2013-10-18','10:00:00',4.23),('8902','2013-10-18','10:05:00',4.26),('8902','2013-10-18','10:10:00',4.69),('8902','2013-10-18','10:15:00',4.48),('8902','2013-10-18','10:20:00',4.89),('8902','2013-10-18','10:25:00',5.31),('8902','2013-10-18','10:30:00',5.41),('8902','2013-10-18','10:35:00',5.42),('8902','2013-10-18','10:40:00',5.47),('8902','2013-10-18','10:45:00',5.4),('8902','2013-10-18','10:50:00',5.55),('8902','2013-10-18','10:55:00',5.73),('8902','2013-10-18','11:00:00',5.88),('8902','2013-10-18','11:05:00',5.42),('8902','2013-10-18','11:10:00',3.01),('8902','2013-10-18','11:15:00',2.32),('8902','2013-10-18','11:20:00',4.43),('8902','2013-10-18','11:25:00',6.33),('8902','2013-10-18','11:30:00',6.46),('8902','2013-10-18','11:35:00',6.59),('8902','2013-10-18','11:40:00',6.26),('8902','2013-10-18','11:45:00',6.56),('8902','2013-10-18','11:50:00',6.49),('8902','2013-10-18','11:55:00',6.34),('8902','2013-10-18','12:00:00',6.7),('8902','2013-10-18','12:05:00',6.66),('8902','2013-10-18','12:10:00',6.57),('8902','2013-10-18','12:15:00',6.6),('8902','2013-10-18','12:20:00',6.72),('8902','2013-10-18','12:25:00',6.08),('8902','2013-10-18','12:30:00',6.57),('8902','2013-10-18','12:35:00',6.81),('8902','2013-10-18','12:40:00',7.04),('8902','2013-10-18','12:45:00',7.11),('8902','2013-10-18','12:50:00',7.29),('8902','2013-10-18','12:55:00',7.18),('8902','2013-10-18','13:00:00',7.79),('8902','2013-10-18','13:05:00',6.65),('8902','2013-10-18','13:10:00',6.19),('8902','2013-10-18','13:15:00',6.27),('8902','2013-10-18','13:20:00',6.53),('8902','2013-10-18','13:25:00',7.02),('8902','2013-10-18','13:30:00',7.65),('8902','2013-10-18','13:35:00',5.79),('8902','2013-10-18','13:40:00',4.65),('8902','2013-10-18','13:45:00',4.48),('8902','2013-10-18','13:50:00',5.31),('8902','2013-10-18','13:55:00',6.77),('8902','2013-10-18','14:00:00',6.06),('8902','2013-10-18','14:05:00',5.13),('8902','2013-10-18','14:10:00',3.8),('8902','2013-10-18','14:15:00',5.05),('8902','2013-10-18','14:20:00',4.7),('8902','2013-10-18','14:25:00',3.93),('8902','2013-10-18','14:30:00',4.32),('8902','2013-10-18','14:35:00',7.13),('8902','2013-10-18','14:40:00',5.41),('8902','2013-10-18','14:45:00',4.25),('8902','2013-10-18','14:50:00',6.34),('8902','2013-10-18','14:55:00',6.19),('8902','2013-10-18','15:00:00',6.05),('8902','2013-10-18','15:05:00',5.82),('8902','2013-10-18','15:10:00',5.77),('8902','2013-10-18','15:15:00',5.7),('8902','2013-10-18','15:20:00',5.29),('8902','2013-10-18','15:25:00',5.08),('8902','2013-10-18','15:30:00',4.88),('8902','2013-10-18','15:35:00',4.77),('8902','2013-10-18','15:40:00',4.52),('8902','2013-10-18','15:45:00',3.95),('8902','2013-10-18','15:50:00',3.95),('8902','2013-10-18','15:55:00',4.53),('8902','2013-10-18','16:00:00',3.8),('8902','2013-10-18','16:05:00',3.98),('8902','2013-10-18','16:10:00',3.89),('8902','2013-10-18','16:15:00',4.01),('8902','2013-10-18','16:20:00',3.97),('8902','2013-10-18','16:25:00',2.7),('8902','2013-10-18','16:30:00',3.5),('8902','2013-10-18','16:35:00',3.6),('8902','2013-10-18','16:40:00',3.45),('8902','2013-10-18','16:45:00',3.27),('8902','2013-10-18','16:50:00',3.06),('8902','2013-10-18','16:55:00',1.39),('8902','2013-10-18','17:00:00',1.11),('8902','2013-10-18','17:05:00',1.18),('8902','2013-10-18','17:10:00',1.42),('8902','2013-10-18','17:20:00',1.68),('8902','2013-10-18','17:25:00',1.16),('8902','2013-10-18','17:30:00',1.06),('8902','2014-05-03','07:40:00',1.33),('8902','2014-05-03','07:45:00',1.57),('8902','2014-05-03','07:50:00',1.79),('8902','2014-05-03','07:55:00',2.02),('8902','2014-05-03','08:00:00',2.2),('8902','2014-05-03','08:05:00',2.41),('8902','2014-05-03','08:10:00',2.54),('8902','2014-05-03','08:15:00',2.76),('8902','2014-05-03','08:20:00',2.99),('8902','2014-05-03','08:25:00',3.17),('8902','2014-05-03','08:30:00',3.6),('8902','2014-05-03','08:35:00',3.08),('8902','2014-05-03','08:40:00',2.74),('8902','2014-05-03','08:45:00',1.79),('8902','2014-05-03','08:50:00',2.56),('8902','2014-05-03','08:55:00',2.55),('8902','2014-05-03','09:00:00',2.71),('8902','2014-05-03','09:05:00',4.86),('8902','2014-05-03','09:10:00',4.36),('8902','2014-05-03','09:15:00',4.56),('8902','2014-05-03','09:20:00',6.82),('8902','2014-05-03','09:25:00',5.24),('8902','2014-05-03','09:30:00',2.4),('8902','2014-05-03','09:35:00',2.41),('8902','2014-05-03','09:40:00',2.88),('8902','2014-05-03','09:45:00',4.1),('8902','2014-05-03','09:50:00',4.86),('8902','2014-05-03','09:55:00',4.9),('8902','2014-05-03','10:00:00',6.98),('8902','2014-05-03','10:05:00',7.36),('8902','2014-05-03','10:10:00',6.47),('8902','2014-05-03','10:15:00',5.37),('8902','2014-05-03','10:20:00',3.79),('8902','2014-05-03','10:25:00',3.74),('8902','2014-05-03','10:30:00',3.88),('8902','2014-05-03','10:35:00',4.05),('8902','2014-05-03','10:40:00',4.35),('8902','2014-05-03','10:45:00',5.27),('8902','2014-05-03','10:50:00',4.92),('8902','2014-05-03','10:55:00',6.32),('8902','2014-05-03','11:00:00',5.87),('8902','2014-05-03','11:05:00',7.46),('8902','2014-05-03','11:10:00',7.24),('8902','2014-05-03','11:15:00',7.62),('8902','2014-05-03','11:20:00',8.36),('8902','2014-05-03','11:25:00',7.17),('8902','2014-05-03','11:30:00',7.91),('8902','2014-05-03','11:35:00',7.62),('8902','2014-05-03','11:40:00',5.83),('8902','2014-05-03','11:45:00',7.65),('8902','2014-05-03','11:50:00',6.41),('8902','2014-05-03','11:55:00',6.99),('8902','2014-05-03','12:00:00',6.67),('8902','2014-05-03','12:05:00',5.11),('8902','2014-05-03','12:10:00',3.63),('8902','2014-05-03','12:15:00',3.19),('8902','2014-05-03','12:20:00',3.64),('8902','2014-05-03','12:25:00',3.6),('8902','2014-05-03','12:30:00',9.54),('8902','2014-05-03','12:35:00',7.72),('8902','2014-05-03','12:40:00',7.5),('8902','2014-05-03','12:45:00',4.76),('8902','2014-05-03','12:50:00',6.59),('8902','2014-05-03','12:55:00',4.99),('8902','2014-05-03','13:00:00',3.97),('8902','2014-05-03','13:05:00',3.89),('8902','2014-05-03','13:10:00',3.93),('8902','2014-05-03','13:15:00',3.77),('8902','2014-05-03','13:20:00',3.55),('8902','2014-05-03','13:25:00',2.96),('8902','2014-05-03','13:30:00',3.13),('8902','2014-05-03','13:35:00',3.3),('8902','2014-05-03','13:40:00',3.14),('8902','2014-05-03','13:45:00',2.76),('8902','2014-05-03','13:50:00',2.63),('8902','2014-05-03','13:55:00',2.68),('8902','2014-05-03','14:00:00',2.63),('8902','2014-05-03','14:05:00',2.7),('8902','2014-05-03','14:10:00',2.72),('8902','2014-05-03','14:15:00',2.58),('8902','2014-05-03','14:20:00',2.1),('8902','2014-05-03','14:25:00',1.57),('8902','2014-05-03','14:30:00',1.34),('8902','2014-05-03','14:35:00',1.33),('8902','2014-05-03','14:40:00',1.46),('8902','2014-05-03','14:45:00',1.66),('8902','2014-05-03','14:50:00',2.18),('8902','2014-05-03','14:55:00',3.09),('8902','2014-05-03','15:00:00',3.55),('8902','2014-05-03','15:05:00',5.62),('8902','2014-05-03','15:10:00',8.06),('8902','2014-05-03','15:15:00',6.06),('8902','2014-05-03','15:20:00',3.14),('8902','2014-05-03','15:25:00',2.66),('8902','2014-05-03','15:30:00',1.96),('8902','2014-05-03','15:35:00',1.47),('8902','2014-05-03','15:40:00',1.43),('8902','2014-05-03','15:45:00',1.82),('8902','2014-05-03','15:50:00',2.37),('8902','2014-05-03','15:55:00',2.44),('8902','2014-05-03','16:00:00',1.95),('8902','2014-05-03','16:05:00',2.08),('8902','2014-05-03','16:10:00',2.65),('8902','2014-05-03','16:15:00',2.57),('8902','2014-05-03','16:20:00',2.14),('8902','2014-05-03','16:25:00',1.71),('8902','2014-05-03','16:30:00',1.3),('8902','2014-05-03','16:35:00',1.07),('8902','2014-05-03','16:55:00',1.02),('8902','2014-05-03','17:15:00',1.08),('8902','2014-05-03','17:20:00',1.29),('8902','2014-05-03','17:25:00',1.89),('8902','2014-05-03','17:30:00',1.82),('8902','2014-05-03','17:35:00',1.75),('8902','2014-05-03','17:40:00',1.72),('8902','2014-05-03','17:45:00',1.48),('8902','2014-05-03','17:50:00',1.2),('8902','2014-05-03','18:00:00',1.03),('8902','2014-05-03','18:05:00',1.31),('8902','2014-05-03','18:10:00',1.11),('8902','2014-04-15','07:50:00',1.18),('8902','2014-04-15','07:55:00',1.37),('8902','2014-04-15','08:00:00',1.55),('8902','2014-04-15','08:05:00',1.73),('8902','2014-04-15','08:10:00',1.93),('8902','2014-04-15','08:15:00',2.14),('8902','2014-04-15','08:20:00',2.37),('8902','2014-04-15','08:25:00',2.62),('8902','2014-04-15','08:30:00',2.05),('8902','2014-04-15','08:35:00',1.68),('8902','2014-04-15','08:40:00',1.9),('8902','2014-04-15','08:45:00',3.11),('8902','2014-04-15','08:50:00',3.52),('8902','2014-04-15','08:55:00',3.74),('8902','2014-04-15','09:00:00',3.92),('8902','2014-04-15','09:05:00',4.11),('8902','2014-04-15','09:10:00',4.28),('8902','2014-04-15','09:15:00',4.41),('8902','2014-04-15','09:20:00',4.6),('8902','2014-04-15','09:25:00',4.86),('8902','2014-04-15','09:30:00',4.65),('8902','2014-04-15','09:35:00',1.59),('8902','2014-04-15','09:40:00',1.52),('8902','2014-04-15','09:45:00',1.71),('8902','2014-04-15','09:50:00',4.26),('8902','2014-04-15','09:55:00',6.32),('8902','2014-04-15','10:00:00',6.13),('8902','2014-04-15','10:05:00',6.21),('8902','2014-04-15','10:10:00',6.37),('8902','2014-04-15','10:15:00',6.54),('8902','2014-04-15','10:20:00',6.69),('8902','2014-04-15','10:25:00',6.83),('8902','2014-04-15','10:30:00',6.94),('8902','2014-04-15','10:35:00',7.07),('8902','2014-04-15','10:40:00',7.18),('8902','2014-04-15','10:45:00',7.32),('8902','2014-04-15','10:50:00',7.61),('8902','2014-04-15','10:55:00',6.96),('8902','2014-04-15','11:00:00',7.35),('8902','2014-04-15','11:05:00',6.56),('8902','2014-04-15','11:10:00',2.99),('8902','2014-04-15','11:15:00',4.22),('8902','2014-04-15','11:20:00',8.33),('8902','2014-04-15','11:25:00',6.82),('8902','2014-04-15','11:30:00',7.45),('8902','2014-04-15','11:35:00',5.86),('8902','2014-04-15','11:40:00',7.26),('8902','2014-04-15','11:45:00',7.93),('8902','2014-04-15','11:50:00',9.02),('8902','2014-04-15','11:55:00',9.12),('8902','2014-04-15','12:00:00',9.39),('8902','2014-04-15','12:05:00',5.46),('8902','2014-04-15','12:10:00',6.65),('8902','2014-04-15','12:15:00',3.63),('8902','2014-04-15','12:20:00',8.55),('8902','2014-04-15','12:25:00',3.85),('8902','2014-04-15','12:30:00',4.78),('8902','2014-04-15','12:35:00',9.33),('8902','2014-04-15','12:40:00',9.49),('8902','2014-04-15','12:45:00',9.21),('8902','2014-04-15','12:50:00',8.61),('8902','2014-04-15','12:55:00',6.76),('8902','2014-04-15','13:00:00',5.5),('8902','2014-04-15','13:05:00',2.01),('8902','2014-04-15','13:10:00',1.42),('8902','2014-04-15','13:15:00',1.6),('8902','2014-04-15','13:20:00',2.95),('8902','2014-04-15','13:25:00',2.12),('8902','2014-04-15','13:30:00',1.73),('8902','2014-04-15','13:35:00',2.77),('8902','2014-04-15','13:40:00',4.52),('8902','2014-04-15','13:45:00',8.22),('8902','2014-04-15','13:50:00',7.94),('8902','2014-04-15','13:55:00',5.43),('8902','2014-04-15','14:00:00',3.48),('8902','2014-04-15','14:05:00',4.68),('8902','2014-04-15','14:10:00',9.47),('8902','2014-04-15','14:15:00',10),('8902','2014-04-15','14:20:00',9.32),('8902','2014-04-15','14:25:00',7.03),('8902','2014-04-15','14:30:00',7.29),('8902','2014-04-15','14:35:00',8.88),('8902','2014-04-15','14:40:00',8.64),('8902','2014-04-15','14:45:00',6.28),('8902','2014-04-15','14:50:00',7),('8902','2014-04-15','14:55:00',2.98),('8902','2014-04-15','15:00:00',4.26),('8902','2014-04-15','15:05:00',6.16),('8902','2014-04-15','15:10:00',9.82),('8902','2014-04-15','15:15:00',5.74),('8902','2014-04-15','15:20:00',1.15),('8902','2014-04-15','15:25:00',2.4),('8902','2014-04-15','15:30:00',6.41),('8902','2014-04-15','15:35:00',8.64),('8902','2014-04-15','15:40:00',8.32),('8902','2014-04-15','15:45:00',7.96),('8902','2014-04-15','15:50:00',7.7),('8902','2014-04-15','15:55:00',7.5),('8902','2014-04-15','16:00:00',7.28),('8902','2014-04-15','16:05:00',7.16),('8902','2014-04-15','16:10:00',6.95),('8902','2014-04-15','16:15:00',6.82),('8902','2014-04-15','16:20:00',6.6),('8902','2014-04-15','16:25:00',6.48),('8902','2014-04-15','16:30:00',6.4),('8902','2014-04-15','16:35:00',6.28),('8902','2014-04-15','16:40:00',6.16),('8902','2014-04-15','16:45:00',5.91),('8902','2014-04-15','16:50:00',5.72),('8902','2014-04-15','16:55:00',5.57),('8902','2014-04-15','17:00:00',5.41),('8902','2014-04-15','17:05:00',5.19),('8902','2014-04-15','17:10:00',5),('8902','2014-04-15','17:15:00',4.9),('8902','2014-04-15','17:20:00',4.65),('8902','2014-04-15','17:25:00',4.4),('8902','2014-04-15','17:30:00',4.2),('8902','2014-04-15','17:35:00',4.1),('8902','2014-04-15','17:40:00',3.83),('8902','2014-04-15','17:45:00',3.72),('8902','2014-04-15','17:50:00',3.72),('8902','2014-04-15','17:55:00',3.64),('8902','2014-04-15','18:00:00',3.31),('8902','2014-04-15','18:05:00',3.09),('8902','2014-04-15','18:10:00',2.85),('8902','2014-04-15','18:15:00',2.47),('8902','2014-04-15','18:20:00',2.36),('8902','2014-04-15','18:25:00',2.05),('8902','2014-04-15','18:30:00',1.68),('8902','2014-04-15','18:35:00',1.63),('8902','2014-04-15','18:40:00',1.59),('8902','2014-04-15','18:45:00',1.59),('8902','2014-04-15','18:50:00',1.5),('8902','2014-04-15','18:55:00',1.22),('8902','2013-10-17','08:25:00',1.01),('8902','2013-10-17','08:30:00',1.04),('8902','2013-10-17','08:35:00',1.23),('8902','2013-10-17','08:40:00',1.46),('8902','2013-10-17','08:45:00',1.68),('8902','2013-10-17','08:50:00',1.77),('8902','2013-10-17','08:55:00',1.89),('8902','2013-10-17','09:00:00',2.17),('8902','2013-10-17','09:05:00',2.46),('8902','2013-10-17','09:10:00',2.66),('8902','2013-10-17','09:15:00',2.75),('8902','2013-10-17','09:20:00',3.06),('8902','2013-10-17','09:25:00',3.18),('8902','2013-10-17','09:30:00',3.42),('8902','2013-10-17','09:35:00',3.62),('8902','2013-10-17','09:40:00',3.79),('8902','2013-10-17','09:45:00',3.97),('8902','2013-10-17','09:50:00',4.14),('8902','2013-10-17','09:55:00',4.29),('8902','2013-10-17','10:00:00',4.41),('8902','2013-10-17','10:05:00',4.58),('8902','2013-10-17','10:10:00',4.7),('8902','2013-10-17','10:15:00',4.8),('8902','2013-10-17','10:20:00',4.88),('8902','2013-10-17','10:25:00',5.07),('8902','2013-10-17','10:30:00',5.19),('8902','2013-10-17','10:35:00',5.31),('8902','2013-10-17','10:40:00',5.41),('8902','2013-10-17','10:45:00',5.51),('8902','2013-10-17','10:50:00',5.6),('8902','2013-10-17','10:55:00',5.69),('8902','2013-10-17','11:00:00',5.71),('8902','2013-10-17','11:05:00',5.65),('8902','2013-10-17','11:10:00',5.59),('8902','2013-10-17','11:15:00',5.52),('8902','2013-10-17','11:20:00',6.05),('8902','2013-10-17','11:25:00',5.77),('8902','2013-10-17','11:30:00',6.14),('8902','2013-10-17','11:35:00',6.24),('8902','2013-10-17','11:40:00',6.43),('8902','2013-10-17','11:45:00',5.34),('8902','2013-10-17','11:50:00',6.27),('8902','2013-10-17','11:55:00',6.54),('8902','2013-10-17','12:00:00',6.33),('8902','2013-10-17','12:05:00',6.53),('8902','2013-10-17','12:10:00',6.55),('8902','2013-10-17','12:15:00',6.46),('8902','2013-10-17','12:20:00',6.43),('8902','2013-10-17','12:25:00',6.55),('8902','2013-10-17','12:30:00',6.65),('8902','2013-10-17','12:35:00',6.52),('8902','2013-10-17','12:40:00',6.59),('8902','2013-10-17','12:45:00',6.43),('8902','2013-10-17','12:50:00',6.47),('8902','2013-10-17','12:55:00',6.66),('8902','2013-10-17','13:00:00',6.6),('8902','2013-10-17','13:05:00',6.41),('8902','2013-10-17','13:10:00',6.16),('8902','2013-10-17','13:15:00',6.47),('8902','2013-10-17','13:20:00',6.44),('8902','2013-10-17','13:25:00',6.68),('8902','2013-10-17','13:30:00',6.65),('8902','2013-10-17','13:35:00',6.59),('8902','2013-10-17','13:40:00',6.57),('8902','2013-10-17','13:45:00',6.44),('8902','2013-10-17','13:50:00',6.42),('8902','2013-10-17','13:55:00',6.42),('8902','2013-10-17','14:00:00',5.98),('8902','2013-10-17','14:05:00',6.09),('8902','2013-10-17','14:10:00',6.03),('8902','2013-10-17','14:15:00',6.16),('8902','2013-10-17','14:20:00',6.13),('8902','2013-10-17','14:25:00',6.08),('8902','2013-10-17','14:30:00',6.06),('8902','2013-10-17','14:35:00',5.84),('8902','2013-10-17','14:40:00',5.9),('8902','2013-10-17','14:45:00',5.75),('8902','2013-10-17','14:50:00',5.54),('8902','2013-10-17','14:55:00',5.65),('8902','2013-10-17','15:00:00',4.94),('8902','2013-10-17','15:05:00',4.49),('8902','2013-10-17','15:10:00',4.95),('8902','2013-10-17','15:15:00',4.99),('8902','2013-10-17','15:20:00',5.2),('8902','2013-10-17','15:25:00',4.95),('8902','2013-10-17','15:30:00',4.67),('8902','2013-10-17','15:35:00',4.69),('8902','2013-10-17','15:40:00',4.5),('8902','2013-10-17','15:45:00',4.16),('8902','2013-10-17','15:50:00',4.09),('8902','2013-10-17','15:55:00',3.72),('8902','2013-10-17','16:00:00',3.96),('8902','2013-10-17','16:05:00',3.74),('8902','2013-10-17','16:10:00',3.63),('8902','2013-10-17','16:15:00',3.28),('8902','2013-10-17','16:20:00',3.09),('8902','2013-10-17','16:25:00',2.74),('8902','2013-10-17','16:30:00',2.47),('8902','2013-10-17','16:35:00',2.38),('8902','2013-10-17','16:40:00',1.87),('8902','2013-10-17','16:45:00',1.77),('8902','2013-10-17','16:50:00',1.51),('8902','2013-10-17','16:55:00',1.92),('8902','2013-10-17','17:00:00',1.5),('8902','2013-10-17','17:05:00',1.35),('8902','2013-10-17','17:10:00',1.48),('8902','2013-10-17','17:15:00',1.25),('8902','2013-10-17','17:20:00',1.2),('8902','2013-10-16','08:30:00',1.28),('8902','2013-10-16','08:35:00',1.45),('8902','2013-10-16','08:40:00',1.63),('8902','2013-10-16','08:45:00',1.81),('8902','2013-10-16','08:50:00',1.98),('8902','2013-10-16','08:55:00',2.17),('8902','2013-10-16','09:00:00',2.36),('8902','2013-10-16','09:05:00',2.56),('8902','2013-10-16','09:10:00',2.71),('8902','2013-10-16','09:15:00',2.87),('8902','2013-10-16','09:20:00',3.05),('8902','2013-10-16','09:25:00',3.25),('8902','2013-10-16','09:30:00',3.42),('8902','2013-10-16','09:35:00',3.61),('8902','2013-10-16','09:40:00',3.77),('8902','2013-10-16','09:45:00',3.93),('8902','2013-10-16','09:50:00',4.11),('8902','2013-10-16','09:55:00',4.25),('8902','2013-10-16','10:00:00',4.38),('8902','2013-10-16','10:05:00',4.51),('8902','2013-10-16','10:10:00',4.66),('8902','2013-10-16','10:15:00',4.8),('8902','2013-10-16','10:20:00',4.94),('8902','2013-10-16','10:25:00',5.08),('8902','2013-10-16','10:30:00',5.21),('8902','2013-10-16','10:35:00',5.34),('8902','2013-10-16','10:40:00',5.46),('8902','2013-10-16','10:45:00',5.57),('8902','2013-10-16','10:50:00',5.64),('8902','2013-10-16','10:55:00',5.76),('8902','2013-10-16','11:00:00',5.89),('8902','2013-10-16','11:05:00',5.95),('8902','2013-10-16','11:10:00',6.03),('8902','2013-10-16','11:15:00',6.09),('8902','2013-10-16','11:20:00',6.17),('8902','2013-10-16','11:25:00',6.24),('8902','2013-10-16','11:30:00',6.31),('8902','2013-10-16','11:35:00',6.42),('8902','2013-10-16','11:40:00',6.47),('8902','2013-10-16','11:45:00',6.49),('8902','2013-10-16','11:50:00',6.52),('8902','2013-10-16','11:55:00',6.61),('8902','2013-10-16','12:00:00',6.61),('8902','2013-10-16','12:05:00',6.65),('8902','2013-10-16','12:10:00',6.73),('8902','2013-10-16','12:15:00',6.74),('8902','2013-10-16','12:20:00',6.79),('8902','2013-10-16','12:25:00',6.85),('8902','2013-10-16','12:30:00',6.81),('8902','2013-10-16','12:35:00',6.81),('8902','2013-10-16','12:40:00',6.86),('8902','2013-10-16','12:45:00',6.91),('8902','2013-10-16','12:50:00',6.92),('8902','2013-10-16','12:55:00',6.94),('8902','2013-10-16','13:00:00',6.97),('8902','2013-10-16','13:05:00',6.94),('8902','2013-10-16','13:10:00',6.91),('8902','2013-10-16','13:15:00',6.86),('8902','2013-10-16','13:20:00',6.9),('8902','2013-10-16','13:25:00',6.89),('8902','2013-10-16','13:30:00',6.84),('8902','2013-10-16','13:35:00',6.8),('8902','2013-10-16','13:40:00',6.76),('8902','2013-10-16','13:45:00',6.74),('8902','2013-10-16','13:50:00',6.72),('8902','2013-10-16','13:55:00',6.69),('8902','2013-10-16','14:00:00',6.67),('8902','2013-10-16','14:05:00',6.64),('8902','2013-10-16','14:10:00',6.57),('8902','2013-10-16','14:15:00',6.54),('8902','2013-10-16','14:20:00',6.48),('8902','2013-10-16','14:25:00',6.44),('8902','2013-10-16','14:30:00',6.35),('8902','2013-10-16','14:35:00',6.25),('8902','2013-10-16','14:40:00',6.17),('8902','2013-10-16','14:45:00',6.16),('8902','2013-10-16','14:50:00',6.08),('8902','2013-10-16','14:55:00',5.97),('8902','2013-10-16','15:00:00',5.88),('8902','2013-10-16','15:05:00',5.76),('8902','2013-10-16','15:10:00',5.71),('8902','2013-10-16','15:15:00',5.62),('8902','2013-10-16','15:20:00',5.51),('8902','2013-10-16','15:25:00',5.4),('8902','2013-10-16','15:30:00',5.3),('8902','2013-10-16','15:35:00',5.14),('8902','2013-10-16','15:40:00',5),('8902','2013-10-16','15:45:00',4.88),('8902','2013-10-16','15:50:00',4.75),('8902','2013-10-16','15:55:00',4.59),('8902','2013-10-16','16:00:00',4.42),('8902','2013-10-16','16:05:00',4.25),('8902','2013-10-16','16:10:00',4.14),('8902','2013-10-16','16:15:00',4.01),('8902','2013-10-16','16:20:00',3.87),('8902','2013-10-16','16:25:00',3.71),('8902','2013-10-16','16:30:00',3.55),('8902','2013-10-16','16:35:00',3.34),('8902','2013-10-16','16:40:00',3.19),('8902','2013-10-16','16:45:00',3.01),('8902','2013-10-16','16:50:00',2.84),('8902','2013-10-16','16:55:00',2.63),('8902','2013-10-16','17:00:00',2.43),('8902','2013-10-16','17:05:00',2.27),('8902','2013-10-16','17:10:00',2.11),('8902','2013-10-16','17:15:00',1.91),('8902','2013-10-16','17:20:00',1.71),('8902','2013-10-16','17:25:00',1.5),('8902','2013-10-16','17:30:00',1.26),('8902','2013-10-16','17:35:00',1.12),('8902','2013-10-15','09:40:00',1.25),('8902','2013-10-15','09:45:00',2.5),('8902','2013-10-15','09:50:00',3.86),('8902','2013-10-15','09:55:00',1.61),('8902','2013-10-15','10:00:00',1.57),('8902','2013-10-15','10:05:00',1.02),('8902','2013-10-15','11:05:00',1.37),('8902','2013-10-15','11:10:00',1.63),('8902','2013-10-15','11:15:00',2.65),('8902','2013-10-15','11:20:00',2.03),('8902','2013-10-15','11:25:00',1.22),('8902','2013-10-15','11:30:00',1.1),('8902','2013-10-15','11:55:00',2.17),('8902','2013-10-15','12:00:00',1.96),('8902','2013-10-15','12:10:00',1.65),('8902','2013-10-15','12:15:00',3.76),('8902','2013-10-15','12:20:00',7.15),('8902','2013-10-15','12:25:00',2.14),('8902','2013-10-15','12:30:00',2.79),('8902','2013-10-15','12:35:00',4.28),('8902','2013-10-15','12:40:00',6.92),('8902','2013-10-15','12:45:00',7.19),('8902','2013-10-15','12:50:00',5.96),('8902','2013-10-15','12:55:00',6.16),('8902','2013-10-15','13:00:00',6.12),('8902','2013-10-15','13:05:00',6.35),('8902','2013-10-15','13:10:00',5.92),('8902','2013-10-15','13:15:00',6.54),('8902','2013-10-15','13:20:00',6.36),('8902','2013-10-15','13:25:00',6.51),('8902','2013-10-15','13:30:00',7.4),('8902','2013-10-15','13:35:00',6.95),('8902','2013-10-15','13:40:00',6.88),('8902','2013-10-15','13:45:00',6.85),('8902','2013-10-15','13:50:00',6.79),('8902','2013-10-15','13:55:00',7.12),('8902','2013-10-15','14:00:00',6.1),('8902','2013-10-15','14:05:00',4.45),('8902','2013-10-15','14:10:00',7.42),('8902','2013-10-15','14:15:00',7.02),('8902','2013-10-15','14:20:00',5.6),('8902','2013-10-15','14:25:00',7.05),('8902','2013-10-15','14:30:00',6.81),('8902','2013-10-15','14:35:00',6.27),('8902','2013-10-15','14:40:00',5.28),('8902','2013-10-15','14:45:00',6.54),('8902','2013-10-15','14:50:00',5.38),('8902','2013-10-15','14:55:00',5.66),('8902','2013-10-15','15:00:00',5.52),('8902','2013-10-15','15:05:00',5.88),('8902','2013-10-15','15:10:00',5.49),('8902','2013-10-15','15:15:00',5.81),('8902','2013-10-15','15:20:00',5.47),('8902','2013-10-15','15:25:00',5.15),('8902','2013-10-15','15:30:00',1.5),('8902','2013-10-15','15:35:00',2.38),('8902','2013-10-15','15:40:00',5.48),('8902','2013-10-15','15:45:00',5.03),('8902','2013-10-15','15:50:00',4.75),('8902','2013-10-15','15:55:00',4.64),('8902','2013-10-15','16:00:00',4.45),('8902','2013-10-15','16:05:00',4.34),('8902','2013-10-15','16:10:00',3.68),('8902','2013-10-15','16:15:00',4.01),('8902','2013-10-15','16:20:00',3.84),('8902','2013-10-15','16:25:00',3.61),('8902','2013-10-15','16:30:00',3.42),('8902','2013-10-15','16:35:00',2.9),('8902','2013-10-15','16:40:00',3.19),('8902','2013-10-15','16:45:00',2.96),('8902','2013-10-15','16:50:00',2.82),('8902','2013-10-15','16:55:00',2.63),('8902','2013-10-15','17:00:00',2.4),('8902','2013-10-15','17:05:00',2.21),('8902','2013-10-15','17:10:00',2.02),('8902','2013-10-15','17:15:00',1.85),('8902','2013-10-15','17:20:00',1.68),('8902','2013-10-15','17:25:00',1.52),('8902','2013-10-15','17:30:00',1.31),('8902','2013-10-15','17:35:00',1.17),('8902','2013-10-15','17:40:00',1.39),('8902','2013-10-15','17:45:00',1.32),('8902','2013-10-14','08:30:00',1.05),('8902','2013-10-14','08:35:00',1.06),('8902','2013-10-14','08:40:00',1.05),('8902','2013-10-14','08:45:00',1.03),('8902','2013-10-14','08:55:00',1.08),('8902','2013-10-14','09:00:00',1.32),('8902','2013-10-14','09:05:00',1.64),('8902','2013-10-14','09:10:00',1.75),('8902','2013-10-14','09:15:00',1.71),('8902','2013-10-14','09:20:00',1.91),('8902','2013-10-14','09:25:00',2),('8902','2013-10-14','09:30:00',2.96),('8902','2013-10-14','09:35:00',1.85),('8902','2013-10-14','09:40:00',2.73),('8902','2013-10-14','09:45:00',3.51),('8902','2013-10-14','09:50:00',4.02),('8902','2013-10-14','09:55:00',4.24),('8902','2013-10-14','10:00:00',4.3),('8902','2013-10-14','10:05:00',4.67),('8902','2013-10-14','10:10:00',3.73),('8902','2013-10-14','10:15:00',2.33),('8902','2013-10-14','10:20:00',2.3),('8902','2013-10-14','10:25:00',2.55),('8902','2013-10-14','10:30:00',3.89),('8902','2013-10-14','10:35:00',3.22),('8902','2013-10-14','10:40:00',3.72),('8902','2013-10-14','10:45:00',4.31),('8902','2013-10-14','10:50:00',4.39),('8902','2013-10-14','10:55:00',3.68),('8902','2013-10-14','11:00:00',3.65),('8902','2013-10-14','11:05:00',3.8),('8902','2013-10-14','11:10:00',5.05),('8902','2013-10-14','11:15:00',5.55),('8902','2013-10-14','11:20:00',5.6),('8902','2013-10-14','11:25:00',5.28),('8902','2013-10-14','11:30:00',5.5),('8902','2013-10-14','11:35:00',4.74),('8902','2013-10-14','11:40:00',3.73),('8902','2013-10-14','11:45:00',2.94),('8902','2013-10-14','11:50:00',2.8),('8902','2013-10-14','11:55:00',2.76),('8902','2013-10-14','12:00:00',2.87),('8902','2013-10-14','12:05:00',2.9),('8902','2013-10-14','12:10:00',2.99),('8902','2013-10-14','12:15:00',2.95),('8902','2013-10-14','12:20:00',3.09),('8902','2013-10-14','12:25:00',2.86),('8902','2013-10-14','12:30:00',2.58),('8902','2013-10-14','12:35:00',2.51),('8902','2013-10-14','12:40:00',2.5),('8902','2013-10-14','12:45:00',2.66),('8902','2013-10-14','12:50:00',2.5),('8902','2013-10-14','12:55:00',2.26),('8902','2013-10-14','13:00:00',2.26),('8902','2013-10-14','13:05:00',2.96),('8902','2013-10-14','13:10:00',3.62),('8902','2013-10-14','13:15:00',3.61),('8902','2013-10-14','13:20:00',5.22),('8902','2013-10-14','13:25:00',6.24),('8902','2013-10-14','13:30:00',4.03),('8902','2013-10-14','13:35:00',3.34),('8902','2013-10-14','13:40:00',3.07),('8902','2013-10-14','13:45:00',3.14),('8902','2013-10-14','13:50:00',2.81),('8902','2013-10-14','13:55:00',2.5),('8902','2013-10-14','14:00:00',2.23),('8902','2013-10-14','14:05:00',2.2),('8902','2013-10-14','14:10:00',2.43),('8902','2013-10-14','14:15:00',3.35),('8902','2013-10-14','14:20:00',4),('8902','2013-10-14','14:25:00',4.36),('8902','2013-10-14','14:30:00',4.55),('8902','2013-10-14','14:35:00',2.83),('8902','2013-10-14','14:40:00',3.45),('8902','2013-10-14','14:45:00',3.82),('8902','2013-10-14','14:50:00',4.83),('8902','2013-10-14','14:55:00',4.29),('8902','2013-10-14','15:00:00',2.66),('8902','2013-10-14','15:05:00',2.62),('8902','2013-10-14','15:10:00',2.79),('8902','2013-10-14','15:15:00',2.54),('8902','2013-10-14','15:20:00',2.29),('8902','2013-10-14','15:25:00',1.99),('8902','2013-10-14','15:30:00',1.89),('8902','2013-10-14','15:35:00',1.97),('8902','2013-10-14','15:40:00',2.07),('8902','2013-10-14','15:45:00',2),('8902','2013-10-14','15:50:00',1.76),('8902','2013-10-14','15:55:00',1.53),('8902','2013-10-14','16:00:00',1.39),('8902','2013-10-14','16:05:00',1.4),('8902','2013-10-14','16:10:00',1.46),('8902','2013-10-14','16:15:00',1.38),('8902','2013-10-14','16:20:00',1.25),('8902','2013-10-14','16:25:00',1.68),('8902','2013-10-14','16:30:00',2.23),('8902','2013-10-14','16:35:00',2.37),('8902','2013-10-14','16:40:00',1.86),('8902','2013-10-14','16:45:00',1.68),('8902','2013-10-14','16:50:00',1.29),('8902','2013-10-14','16:55:00',1.27),('8902','2013-10-14','17:00:00',1.25),('8902','2013-10-14','17:05:00',1.14),('8902','2013-10-14','17:10:00',1.01),('8902','2013-10-13','08:25:00',1.17),('8902','2013-10-13','08:30:00',1.28),('8902','2013-10-13','08:35:00',1.43),('8902','2013-10-13','08:40:00',1.37),('8902','2013-10-13','08:45:00',1.68),('8902','2013-10-13','08:50:00',1.81),('8902','2013-10-13','08:55:00',2.13),('8902','2013-10-13','09:00:00',1.97),('8902','2013-10-13','09:05:00',2.03),('8902','2013-10-13','09:10:00',1.96),('8902','2013-10-13','09:15:00',1.45),('8902','2013-10-13','09:20:00',1.93),('8902','2013-10-13','09:25:00',2.96),('8902','2013-10-13','09:30:00',3.41),('8902','2013-10-13','09:35:00',3.51),('8902','2013-10-13','09:40:00',2.92),('8902','2013-10-13','09:45:00',2.64),('8902','2013-10-13','09:50:00',3.11),('8902','2013-10-13','09:55:00',3.79),('8902','2013-10-13','10:00:00',3.72),('8902','2013-10-13','10:05:00',4.13),('8902','2013-10-13','10:10:00',4.27),('8902','2013-10-13','10:15:00',4.63),('8902','2013-10-13','10:20:00',4.71),('8902','2013-10-13','10:25:00',4.81),('8902','2013-10-13','10:30:00',4.9),('8902','2013-10-13','10:35:00',4.96),('8902','2013-10-13','10:40:00',4.94),('8902','2013-10-13','10:45:00',5.07),('8902','2013-10-13','10:50:00',5.3),('8902','2013-10-13','10:55:00',5.41),('8902','2013-10-13','11:00:00',5.54),('8902','2013-10-13','11:05:00',5.53),('8902','2013-10-13','11:10:00',5.76),('8902','2013-10-13','11:15:00',5.78),('8902','2013-10-13','11:20:00',5.77),('8902','2013-10-13','11:25:00',5.89),('8902','2013-10-13','11:30:00',6.06),('8902','2013-10-13','11:35:00',5.9),('8902','2013-10-13','11:40:00',6),('8902','2013-10-13','11:45:00',6.03),('8902','2013-10-13','11:50:00',6.05),('8902','2013-10-13','11:55:00',6.1),('8902','2013-10-13','12:00:00',6.18),('8902','2013-10-13','12:05:00',6.2),('8902','2013-10-13','12:10:00',6.33),('8902','2013-10-13','12:15:00',6.31),('8902','2013-10-13','12:20:00',5.9),('8902','2013-10-13','12:25:00',6.15),('8902','2013-10-13','12:30:00',6.51),('8902','2013-10-13','12:35:00',6.44),('8902','2013-10-13','12:40:00',6.44),('8902','2013-10-13','12:45:00',6.47),('8902','2013-10-13','12:50:00',6.44),('8902','2013-10-13','12:55:00',6.49),('8902','2013-10-13','13:00:00',6.49),('8902','2013-10-13','13:05:00',6.5),('8902','2013-10-13','13:10:00',6.45),('8902','2013-10-13','13:15:00',6.44),('8902','2013-10-13','13:20:00',6.46),('8902','2013-10-13','13:25:00',6.41),('8902','2013-10-13','13:30:00',6.37),('8902','2013-10-13','13:35:00',6.35),('8902','2013-10-13','13:40:00',6.34),('8902','2013-10-13','13:45:00',6.3),('8902','2013-10-13','13:50:00',6.28),('8902','2013-10-13','13:55:00',6.26),('8902','2013-10-13','14:00:00',6.21),('8902','2013-10-13','14:05:00',6.17),('8902','2013-10-13','14:10:00',6.11),('8902','2013-10-13','14:15:00',6.08),('8902','2013-10-13','14:20:00',6.06),('8902','2013-10-13','14:25:00',6),('8902','2013-10-13','14:30:00',5.96),('8902','2013-10-13','14:35:00',5.89),('8902','2013-10-13','14:40:00',5.78),('8902','2013-10-13','14:45:00',5.71),('8902','2013-10-13','14:50:00',5.66),('8902','2013-10-13','14:55:00',5.59),('8902','2013-10-13','15:00:00',5.54),('8902','2013-10-13','15:05:00',5.45),('8902','2013-10-13','15:10:00',5.3),('8902','2013-10-13','15:15:00',5.16),('8902','2013-10-13','15:20:00',5.07),('8902','2013-10-13','15:25:00',4.96),('8902','2013-10-13','15:30:00',4.8),('8902','2013-10-13','15:35:00',4.62),('8902','2013-10-13','15:40:00',4.29),('8902','2013-10-13','15:45:00',3.66),('8902','2013-10-13','15:50:00',3.49),('8902','2013-10-13','15:55:00',2.52),('8902','2013-10-13','16:00:00',2.91),('8902','2013-10-13','16:05:00',2.34),('8902','2013-10-13','16:10:00',1.91),('8902','2013-10-13','16:15:00',1.94),('8902','2013-10-13','16:20:00',1.7),('8902','2013-10-13','16:25:00',2.29),('8902','2013-10-13','16:30:00',1.72),('8902','2013-10-13','16:35:00',1.11),('8902','2013-10-13','16:45:00',1.59),('8902','2013-10-13','16:50:00',1.47),('8902','2013-10-12','08:35:00',1.19),('8902','2013-10-12','08:40:00',1.22),('8902','2013-10-12','08:45:00',1.24),('8902','2013-10-12','08:50:00',1.37),('8902','2013-10-12','08:55:00',1.63),('8902','2013-10-12','09:00:00',1.87),('8902','2013-10-12','09:05:00',1.98),('8902','2013-10-12','09:10:00',1.87),('8902','2013-10-12','09:15:00',2.92),('8902','2013-10-12','09:20:00',3.23),('8902','2013-10-12','09:25:00',3.13),('8902','2013-10-12','09:30:00',2.27),('8902','2013-10-12','09:35:00',2.7),('8902','2013-10-12','09:40:00',3.98),('8902','2013-10-12','09:45:00',4.99),('8902','2013-10-12','09:50:00',4.94),('8902','2013-10-12','09:55:00',5.13),('8902','2013-10-12','10:00:00',4.11),('8902','2013-10-12','10:05:00',2.87),('8902','2013-10-12','10:10:00',3.78),('8902','2013-10-12','10:15:00',4.48),('8902','2013-10-12','10:20:00',3.72),('8902','2013-10-12','10:25:00',4.12),('8902','2013-10-12','10:30:00',5.08),('8902','2013-10-12','10:35:00',5.93),('8902','2013-10-12','10:40:00',6.18),('8902','2013-10-12','10:45:00',6.29),('8902','2013-10-12','10:50:00',5.19),('8902','2013-10-12','10:55:00',4.22),('8902','2013-10-12','11:00:00',5.47),('8902','2013-10-12','11:05:00',5.86),('8902','2013-10-12','11:10:00',5.68),('8902','2013-10-12','11:15:00',6.22),('8902','2013-10-12','11:20:00',5.98),('8902','2013-10-12','11:25:00',5.89),('8902','2013-10-12','11:30:00',6.06),('8902','2013-10-12','11:35:00',6.08),('8902','2013-10-12','11:40:00',6.11),('8902','2013-10-12','11:45:00',6.14),('8902','2013-10-12','11:50:00',6.23),('8902','2013-10-12','11:55:00',6.22),('8902','2013-10-12','12:00:00',6.3),('8902','2013-10-12','12:05:00',6.31),('8902','2013-10-12','12:10:00',6.33),('8902','2013-10-12','12:15:00',6.4),('8902','2013-10-12','12:20:00',6.27),('8902','2013-10-12','12:25:00',6.05),('8902','2013-10-12','12:30:00',6.46),('8902','2013-10-12','12:35:00',6.56),('8902','2013-10-12','12:40:00',6.56),('8902','2013-10-12','12:45:00',6.47),('8902','2013-10-12','12:50:00',6.41),('8902','2013-10-12','12:55:00',6.42),('8902','2013-10-12','13:00:00',6.5),('8902','2013-10-12','13:05:00',6.48),('8902','2013-10-12','13:10:00',6.51),('8902','2013-10-12','13:15:00',6.62),('8902','2013-10-12','13:20:00',6.67),('8902','2013-10-12','13:25:00',5.81),('8902','2013-10-12','13:30:00',4.84),('8902','2013-10-12','13:35:00',5.51),('8902','2013-10-12','13:40:00',3.63),('8902','2013-10-12','13:45:00',3.88),('8902','2013-10-12','13:50:00',4.35),('8902','2013-10-12','13:55:00',4.98),('8902','2013-10-12','14:00:00',6.49),('8902','2013-10-12','14:05:00',6.41),('8902','2013-10-12','14:10:00',6.26),('8902','2013-10-12','14:15:00',5.82),('8902','2013-10-12','14:20:00',6.35),('8902','2013-10-12','14:25:00',6.41),('8902','2013-10-12','14:30:00',5.81),('8902','2013-10-12','14:35:00',4.8),('8902','2013-10-12','14:40:00',5.65),('8902','2013-10-12','14:45:00',4.49),('8902','2013-10-12','14:50:00',3.55),('8902','2013-10-12','14:55:00',4.32),('8902','2013-10-12','15:00:00',5.12),('8902','2013-10-12','15:05:00',4.73),('8902','2013-10-12','15:10:00',3.18),('8902','2013-10-12','15:15:00',3.82),('8902','2013-10-12','15:20:00',4.33),('8902','2013-10-12','15:25:00',4.92),('8902','2013-10-12','15:30:00',3.53),('8902','2013-10-12','15:35:00',3.14),('8902','2013-10-12','15:40:00',2.99),('8902','2013-10-12','15:45:00',2.99),('8902','2013-10-12','15:50:00',2.68),('8902','2013-10-12','15:55:00',2.53),('8902','2013-10-12','16:00:00',2.59),('8902','2013-10-12','16:05:00',3.63),('8902','2013-10-12','16:10:00',3.19),('8902','2013-10-12','16:15:00',2.59),('8902','2013-10-12','16:20:00',3),('8902','2013-10-12','16:25:00',3.84),('8902','2013-10-12','16:30:00',3.82),('8902','2013-10-12','16:35:00',3.28),('8902','2013-10-12','16:40:00',2.53),('8902','2013-10-12','16:45:00',1.9),('8902','2013-10-12','16:50:00',2.14),('8902','2013-10-12','16:55:00',1.74),('8902','2013-10-12','17:00:00',1.19),('8902','2013-10-12','17:05:00',1.11),('8902','2013-10-12','17:20:00',1.33),('8902','2013-10-12','17:25:00',1.86),('8902','2013-10-12','17:30:00',1.2),('8902','2013-10-12','17:35:00',1.39),('8902','2013-10-12','17:40:00',1.1),('8902','2013-10-11','10:50:00',1.08),('8902','2013-10-11','10:55:00',1.18),('8902','2013-10-11','11:00:00',1.33),('8902','2013-10-11','11:05:00',1.44),('8902','2013-10-11','11:10:00',1.52),('8902','2013-10-11','11:15:00',1.71),('8902','2013-10-11','11:20:00',1.99),('8902','2013-10-11','11:25:00',2.19),('8902','2013-10-11','11:30:00',2.55),('8902','2013-10-11','11:35:00',3.26),('8902','2013-10-11','11:40:00',5.74),('8902','2013-10-11','11:45:00',3.29),('8902','2013-10-11','11:50:00',2.81),('8902','2013-10-11','11:55:00',2.46),('8902','2013-10-11','12:00:00',1.64),('8902','2013-10-11','12:05:00',1.16),('8902','2013-10-11','12:10:00',1.45),('8902','2013-10-11','12:15:00',2.12),('8902','2013-10-11','12:20:00',3.49),('8902','2013-10-11','12:25:00',7.31),('8902','2013-10-11','12:30:00',5.55),('8902','2013-10-11','12:35:00',6.41),('8902','2013-10-11','12:40:00',6.42),('8902','2013-10-11','12:45:00',5.99),('8902','2013-10-11','12:50:00',5.71),('8902','2013-10-11','12:55:00',4.85),('8902','2013-10-11','13:00:00',3.65),('8902','2013-10-11','13:05:00',2.96),('8902','2013-10-11','13:10:00',1.65),('8902','2013-10-11','13:15:00',2.12),('8902','2013-10-11','13:20:00',2.7),('8902','2013-10-11','13:25:00',2.86),('8902','2013-10-11','13:30:00',8.03),('8902','2013-10-11','13:35:00',3.48),('8902','2013-10-11','13:40:00',1.31),('8902','2013-10-11','14:00:00',1.29),('8902','2013-10-11','15:10:00',1.09),('8902','2013-10-11','15:15:00',1.17),('8902','2013-10-11','15:20:00',1.24),('8902','2013-10-11','15:25:00',1.44),('8902','2013-10-11','15:30:00',1.54),('8902','2013-10-11','15:35:00',1.44),('8902','2013-10-11','15:40:00',1.3),('8902','2013-10-11','15:45:00',1.23),('8902','2013-10-11','15:50:00',1.39),('8902','2013-10-11','15:55:00',1.83),('8902','2013-10-11','16:00:00',2.26),('8902','2013-10-11','16:05:00',2.12),('8902','2013-10-11','16:10:00',2.18),('8902','2013-10-11','16:15:00',3.27),('8902','2013-10-11','16:20:00',3.04),('8902','2013-10-11','16:25:00',1.77),('8902','2013-10-11','16:30:00',1.12),('8902','2013-10-11','16:55:00',1.04),('8902','2013-10-11','17:00:00',2.18),('8902','2013-10-11','17:05:00',1.1),('8902','2013-10-11','17:10:00',1.09),('8902','2013-10-11','17:20:00',1.05),('8902','2013-10-11','17:25:00',1.33),('8902','2013-10-10','09:15:00',1.14),('8902','2013-10-10','09:35:00',1.74),('8902','2013-10-10','09:45:00',4.12),('8902','2013-10-10','09:50:00',3.53),('8902','2013-10-10','09:55:00',3.73),('8902','2013-10-10','10:00:00',4.49),('8902','2013-10-10','10:05:00',4.63),('8902','2013-10-10','10:10:00',4.77),('8902','2013-10-10','10:15:00',3.63),('8902','2013-10-10','10:20:00',3.93),('8902','2013-10-10','10:25:00',2.51),('8902','2013-10-10','10:30:00',3.24),('8902','2013-10-10','10:35:00',4.73),('8902','2013-10-10','10:40:00',3.19),('8902','2013-10-10','10:45:00',1.38),('8902','2013-10-10','11:00:00',1.57),('8902','2013-10-10','11:05:00',5.28),('8902','2013-10-10','11:10:00',4.98),('8902','2013-10-10','11:15:00',2.23),('8902','2013-10-10','11:20:00',2.13),('8902','2013-10-10','11:25:00',2.17),('8902','2013-10-10','11:30:00',1.79),('8902','2013-10-10','11:35:00',2.4),('8902','2013-10-10','11:40:00',2.95),('8902','2013-10-10','11:45:00',3.14),('8902','2013-10-10','11:50:00',4.97),('8902','2013-10-10','11:55:00',3.48),('8902','2013-10-10','12:00:00',5.75),('8902','2013-10-10','12:05:00',8.4),('8902','2013-10-10','12:10:00',4.23),('8902','2013-10-10','12:15:00',2.12),('8902','2013-10-10','12:20:00',1.98),('8902','2013-10-10','12:25:00',1.98),('8902','2013-10-10','12:30:00',2.53),('8902','2013-10-10','12:35:00',1.26),('8902','2013-10-10','13:00:00',1.43),('8902','2013-10-10','13:05:00',4.88),('8902','2013-10-10','13:10:00',4.26),('8902','2013-10-10','13:15:00',3.25),('8902','2013-10-10','13:20:00',5.21),('8902','2013-10-10','13:25:00',8.58),('8902','2013-10-10','13:30:00',2.53),('8902','2013-10-10','13:35:00',1.1),('8902','2013-10-10','13:40:00',3.71),('8902','2013-10-10','13:45:00',6.79),('8902','2013-10-10','13:50:00',1.5),('8902','2013-10-10','15:10:00',1.48),('8902','2013-10-10','15:15:00',1.29),('8902','2013-10-10','15:25:00',1.28),('8902','2013-10-10','15:30:00',2.32),('8902','2013-10-10','15:35:00',2.09),('8902','2013-10-10','15:40:00',2.38),('8902','2013-10-10','15:45:00',1.99),('8902','2013-10-10','15:50:00',1.29),('8902','2013-10-10','15:55:00',1.55),('8902','2013-10-10','16:00:00',3.59),('8902','2013-10-10','16:05:00',2.17),('8902','2013-10-10','16:10:00',2.01),('8902','2013-10-10','16:15:00',1),('8902','2013-10-10','16:25:00',1.79),('8902','2013-10-10','16:30:00',1.59),('8902','2013-10-10','16:35:00',3.65),('8902','2013-10-10','16:40:00',1.38),('8902','2013-10-10','16:55:00',1.6),('8902','2013-10-10','17:00:00',1.02),('8902','2013-10-09','08:40:00',1.9),('8902','2013-10-09','08:45:00',1.8),('8902','2013-10-09','08:50:00',1.95),('8902','2013-10-09','08:55:00',2.59),('8902','2013-10-09','09:00:00',1.63),('8902','2013-10-09','09:10:00',1.54),('8902','2013-10-09','09:15:00',3.01),('8902','2013-10-09','09:20:00',3.17),('8902','2013-10-09','09:25:00',3.3),('8902','2013-10-09','09:30:00',3.42),('8902','2013-10-09','09:35:00',3.67),('8902','2013-10-09','09:40:00',3.22),('8902','2013-10-09','09:45:00',2.75),('8902','2013-10-09','09:50:00',1.04),('8902','2013-10-09','09:55:00',1.45),('8902','2013-10-09','10:00:00',1.35),('8902','2013-10-09','10:15:00',2.13),('8902','2013-10-09','10:20:00',5.1),('8902','2013-10-09','10:25:00',4.88),('8902','2013-10-09','10:30:00',4.4),('8902','2013-10-09','10:35:00',1.41),('8902','2013-10-09','10:45:00',4.72),('8902','2013-10-09','10:50:00',2.37),('8902','2013-10-09','10:55:00',1.56),('8902','2013-10-09','11:00:00',1.03),('8902','2013-10-09','11:05:00',1.57),('8902','2013-10-09','11:10:00',1.47),('8902','2013-10-09','11:15:00',3.61),('8902','2013-10-09','11:20:00',3.95),('8902','2013-10-09','11:25:00',7.63),('8902','2013-10-09','11:30:00',4.05),('8902','2013-10-09','11:35:00',1.41),('8902','2013-10-09','11:40:00',4.38),('8902','2013-10-09','11:45:00',6.43),('8902','2013-10-09','11:50:00',3.57),('8902','2013-10-09','11:55:00',6.95),('8902','2013-10-09','12:00:00',1.45),('8902','2013-10-09','12:05:00',2.3),('8902','2013-10-09','12:10:00',1.48),('8902','2013-10-09','12:15:00',1.14),('8902','2013-10-09','12:20:00',1.66),('8902','2013-10-09','12:25:00',4.95),('8902','2013-10-09','12:30:00',5.42),('8902','2013-10-09','12:35:00',8.44),('8902','2013-10-09','12:40:00',7.38),('8902','2013-10-09','12:45:00',7.29),('8902','2013-10-09','12:50:00',4.9),('8902','2013-10-09','12:55:00',2.47),('8902','2013-10-09','13:00:00',5.06),('8902','2013-10-09','13:05:00',7.36),('8902','2013-10-09','13:10:00',2.92),('8902','2013-10-09','13:15:00',2.24),('8902','2013-10-09','13:20:00',4.47),('8902','2013-10-09','13:25:00',3.56),('8902','2013-10-09','13:30:00',3.52),('8902','2013-10-09','13:35:00',3.29),('8902','2013-10-09','13:40:00',6.02),('8902','2013-10-09','13:45:00',5.88),('8902','2013-10-09','13:50:00',7.23),('8902','2013-10-09','13:55:00',7.35),('8902','2013-10-09','14:00:00',6.99),('8902','2013-10-09','14:05:00',3.72),('8902','2013-10-09','14:10:00',5.91),('8902','2013-10-09','14:15:00',4.9),('8902','2013-10-09','14:20:00',7.77),('8902','2013-10-09','14:25:00',5.23),('8902','2013-10-09','14:30:00',5.28),('8902','2013-10-09','14:35:00',5.33),('8902','2013-10-09','14:40:00',7.31),('8902','2013-10-09','14:45:00',5.16),('8902','2013-10-09','14:50:00',5.88),('8902','2013-10-09','14:55:00',6.8),('8902','2013-10-09','15:00:00',6.65),('8902','2013-10-09','15:05:00',6.74),('8902','2013-10-09','15:10:00',6.41),('8902','2013-10-09','15:15:00',5.01),('8902','2013-10-09','15:20:00',4.9),('8902','2013-10-09','15:25:00',2.47),('8902','2013-10-09','15:30:00',4.61),('8902','2013-10-09','15:35:00',2.69),('8902','2013-10-09','15:40:00',1.89),('8902','2013-10-09','15:45:00',2.35),('8902','2013-10-09','15:50:00',1.33),('8902','2013-10-09','15:55:00',1.46),('8902','2013-10-09','16:00:00',2.17),('8902','2013-10-09','16:05:00',1.43),('8902','2013-10-09','16:10:00',1.76),('8902','2013-10-09','16:15:00',5.04),('8902','2013-10-09','16:20:00',3.53),('8902','2013-10-09','16:25:00',3.86),('8902','2013-10-09','16:30:00',3.21),('8902','2013-10-09','16:40:00',2.43),('8902','2013-10-09','16:45:00',3.52),('8902','2013-10-09','16:50:00',3.35),('8902','2013-10-09','16:55:00',3.12),('8902','2013-10-09','17:00:00',2.9),('8902','2013-10-09','17:05:00',2.54),('8902','2013-10-09','17:15:00',1.3),('8902','2013-10-09','17:20:00',2.21),('8902','2013-10-09','17:25:00',1.22),('8902','2013-10-09','17:45:00',1.01),('8902','2013-10-08','08:25:00',1.21),('8902','2013-10-08','08:30:00',1.54),('8902','2013-10-08','08:35:00',1.53),('8902','2013-10-08','08:40:00',1.81),('8902','2013-10-08','08:45:00',2.02),('8902','2013-10-08','08:50:00',2.18),('8902','2013-10-08','08:55:00',2.35),('8902','2013-10-08','09:00:00',2.53),('8902','2013-10-08','09:05:00',2.74),('8902','2013-10-08','09:10:00',2.91),('8902','2013-10-08','09:15:00',2.92),('8902','2013-10-08','09:20:00',2.71),('8902','2013-10-08','09:25:00',3.46),('8902','2013-10-08','09:30:00',3.64),('8902','2013-10-08','09:35:00',3.79),('8902','2013-10-08','09:40:00',4.03),('8902','2013-10-08','09:45:00',4.27),('8902','2013-10-08','09:50:00',4.43),('8902','2013-10-08','09:55:00',4.64),('8902','2013-10-08','10:00:00',4.93),('8902','2013-10-08','10:05:00',5.32),('8902','2013-10-08','10:10:00',5.63),('8902','2013-10-08','10:15:00',3.79),('8902','2013-10-08','10:20:00',1.92),('8902','2013-10-08','10:25:00',2.44),('8902','2013-10-08','10:30:00',3.46),('8902','2013-10-08','10:35:00',3.16),('8902','2013-10-08','10:40:00',4.57),('8902','2013-10-08','10:45:00',4.79),('8902','2013-10-08','10:50:00',4.72),('8902','2013-10-08','10:55:00',3.97),('8902','2013-10-08','11:00:00',4.89),('8902','2013-10-08','11:05:00',6.91),('8902','2013-10-08','11:10:00',7.52),('8902','2013-10-08','11:15:00',7.47),('8902','2013-10-08','11:20:00',6.81),('8902','2013-10-08','11:25:00',6.43),('8902','2013-10-08','11:30:00',7.19),('8902','2013-10-08','11:35:00',7.71),('8902','2013-10-08','11:40:00',5.15),('8902','2013-10-08','11:45:00',5.63),('8902','2013-10-08','11:50:00',6.51),('8902','2013-10-08','11:55:00',6.5),('8902','2013-10-08','12:00:00',5.81),('8902','2013-10-08','12:05:00',3.11),('8902','2013-10-08','12:10:00',4.6),('8902','2013-10-08','12:15:00',2.86),('8902','2013-10-08','12:20:00',4.46),('8902','2013-10-08','12:25:00',7.11),('8902','2013-10-08','12:30:00',6.05),('8902','2013-10-08','12:35:00',4.86),('8902','2013-10-08','12:40:00',3.19),('8902','2013-10-08','12:45:00',2.36),('8902','2013-10-08','12:50:00',1.35),('8902','2013-10-08','12:55:00',2.2),('8902','2013-10-08','13:00:00',2.13),('8902','2013-10-08','13:05:00',1.67),('8902','2013-10-08','13:10:00',2.51),('8902','2013-10-08','13:15:00',4.06),('8902','2013-10-08','13:20:00',4.37),('8902','2013-10-08','13:25:00',4.56),('8902','2013-10-08','13:30:00',4.12),('8902','2013-10-08','13:35:00',3.38),('8902','2013-10-08','13:40:00',5.94),('8902','2013-10-08','13:45:00',6.38),('8902','2013-10-08','13:50:00',5.31),('8902','2013-10-08','13:55:00',8.58),('8902','2013-10-08','14:00:00',6.11),('8902','2013-10-08','14:05:00',2.09),('8902','2013-10-08','14:10:00',2.88),('8902','2013-10-08','14:15:00',1.44),('8902','2013-10-08','14:20:00',1.18),('8902','2013-10-08','14:25:00',1.24),('8902','2013-10-08','14:30:00',1.15),('8902','2013-10-08','14:50:00',1.53),('8902','2013-10-08','14:55:00',3.08),('8902','2013-10-08','15:00:00',3.39),('8902','2013-10-08','15:05:00',6.32),('8902','2013-10-08','15:10:00',6.4),('8902','2013-10-08','15:15:00',6.66),('8902','2013-10-08','15:20:00',5.77),('8902','2013-10-08','15:25:00',3.18),('8902','2013-10-08','15:30:00',4.96),('8902','2013-10-08','15:35:00',2.92),('8902','2013-10-08','15:40:00',5.61),('8902','2013-10-08','15:45:00',2.22),('8902','2013-10-08','15:50:00',4.73),('8902','2013-10-08','16:05:00',1.04),('8902','2013-10-08','16:10:00',1.62),('8902','2013-10-08','16:15:00',2.81),('8902','2013-10-08','16:20:00',3.34),('8902','2013-10-08','16:25:00',2.75),('8902','2013-10-08','16:30:00',3.03),('8902','2013-10-08','16:35:00',1.89),('8902','2013-10-08','16:40:00',4.35),('8902','2013-10-08','16:45:00',1.66),('8902','2013-10-08','17:20:00',1.06),('8902','2013-10-08','17:25:00',1.64),('8902','2013-10-08','17:30:00',1.7),('8902','2013-10-08','17:35:00',2.16),('8902','2013-10-08','17:40:00',1.46),('8902','2013-10-08','17:45:00',1.42),('8902','2013-10-08','17:50:00',1.08),('8902','2014-04-14','08:00:00',1.15),('8902','2014-04-14','08:05:00',1.09),('8902','2014-04-14','08:55:00',1.32),('8902','2014-04-14','09:00:00',2),('8902','2014-04-14','09:05:00',2.73),('8902','2014-04-14','09:10:00',3.2),('8902','2014-04-14','09:15:00',2.31),('8902','2014-04-14','09:20:00',2.77),('8902','2014-04-14','09:25:00',3.83),('8902','2014-04-14','09:30:00',3.08),('8902','2014-04-14','09:35:00',1.79),('8902','2014-04-14','09:40:00',1.18),('8902','2014-04-14','09:45:00',2.01),('8902','2014-04-14','09:50:00',4.93),('8902','2014-04-14','09:55:00',2.68),('8902','2014-04-14','10:00:00',3.31),('8902','2014-04-14','10:05:00',2.53),('8902','2014-04-14','10:10:00',2.68),('8902','2014-04-14','10:15:00',3.44),('8902','2014-04-14','10:20:00',2.76),('8902','2014-04-14','10:25:00',2.57),('8902','2014-04-14','10:30:00',6.29),('8902','2014-04-14','10:35:00',5.98),('8902','2014-04-14','10:40:00',4.44),('8902','2014-04-14','10:45:00',6.64),('8902','2014-04-14','10:50:00',5.27),('8902','2014-04-14','10:55:00',2.21),('8902','2014-04-14','11:00:00',3.55),('8902','2014-04-14','11:05:00',7.08),('8902','2014-04-14','11:10:00',5.98),('8902','2014-04-14','11:15:00',3.75),('8902','2014-04-14','11:20:00',2.37),('8902','2014-04-14','11:25:00',2.84),('8902','2014-04-14','11:30:00',2.09),('8902','2014-04-14','11:35:00',1.81),('8902','2014-04-14','11:40:00',1.25),('8902','2014-04-14','11:45:00',2.11),('8902','2014-04-14','11:50:00',2.77),('8902','2014-04-14','11:55:00',2.09),('8902','2014-04-14','12:00:00',1.4),('8902','2014-04-14','12:05:00',1.39),('8902','2014-04-14','12:10:00',2.08),('8902','2014-04-14','12:15:00',2.81),('8902','2014-04-14','12:20:00',4.3),('8902','2014-04-14','12:25:00',1.84),('8902','2014-04-14','12:30:00',1.2),('8902','2014-04-14','12:35:00',1.4),('8902','2014-04-14','12:40:00',1.23),('8902','2014-04-14','13:00:00',1.08),('8902','2014-04-14','13:05:00',1.9),('8902','2014-04-14','13:10:00',3.24),('8902','2014-04-14','13:15:00',3.21),('8902','2014-04-14','13:20:00',6.12),('8902','2014-04-14','13:25:00',3.79),('8902','2014-04-14','13:30:00',4.59),('8902','2014-04-14','13:35:00',5.01),('8902','2014-04-14','13:40:00',6.54),('8902','2014-04-14','13:45:00',2.9),('8902','2014-04-14','13:50:00',2.13),('8902','2014-04-14','13:55:00',1.99),('8902','2014-04-14','14:00:00',2.62),('8902','2014-04-14','14:05:00',7.2),('8902','2014-04-14','14:10:00',7.12),('8902','2014-04-14','14:15:00',7.71),('8902','2014-04-14','14:20:00',4.61),('8902','2014-04-14','14:25:00',8.08),('8902','2014-04-14','14:30:00',3.96),('8902','2014-04-14','14:35:00',4.92),('8902','2014-04-14','14:40:00',2.84),('8902','2014-04-14','14:45:00',2.12),('8902','2014-04-14','14:50:00',1.75),('8902','2014-04-14','14:55:00',1.58),('8902','2014-04-14','15:00:00',1.46),('8902','2014-04-14','15:05:00',1.32),('8902','2014-04-14','15:10:00',1.76),('8902','2014-04-14','15:15:00',2.51),('8902','2014-04-14','15:20:00',3.47),('8902','2014-04-14','15:25:00',3.59),('8902','2014-04-14','15:30:00',2.73),('8902','2014-04-14','15:35:00',2.6),('8902','2014-04-14','15:40:00',2.69),('8902','2014-04-14','15:45:00',2.57),('8902','2014-04-14','15:50:00',2.49),('8902','2014-04-14','15:55:00',2.67),('8902','2014-04-14','16:00:00',2.83),('8902','2014-04-14','16:05:00',2.7),('8902','2014-04-14','16:10:00',1.72),('8902','2014-04-14','16:15:00',1.28),('8902','2013-10-07','08:15:00',1.42),('8902','2013-10-07','08:20:00',1.6),('8902','2013-10-07','08:25:00',1.23),('8902','2013-10-07','08:30:00',1.27),('8902','2013-10-07','09:50:00',1.08),('8902','2013-10-07','09:55:00',1.36),('8902','2013-10-07','10:00:00',1.89),('8902','2013-10-07','10:05:00',1.84),('8902','2013-10-07','10:10:00',1.78),('8902','2013-10-07','10:15:00',1.41),('8902','2013-10-07','10:20:00',1.03),('8902','2013-10-07','10:55:00',1.38),('8902','2013-10-07','11:00:00',2.98),('8902','2013-10-07','11:05:00',3.05),('8902','2013-10-07','11:10:00',5.56),('8902','2013-10-07','11:15:00',8.23),('8902','2013-10-07','11:20:00',6.86),('8902','2013-10-07','11:25:00',4.06),('8902','2013-10-07','11:30:00',6),('8902','2013-10-07','11:35:00',5.05),('8902','2013-10-07','11:40:00',3.3),('8902','2013-10-07','11:45:00',2.84),('8902','2013-10-07','11:50:00',2.2),('8902','2013-10-07','11:55:00',1.86),('8902','2013-10-07','12:00:00',1.28),('8902','2013-10-07','12:05:00',1.45),('8902','2013-10-07','12:10:00',2.03),('8902','2013-10-07','12:15:00',2.11),('8902','2013-10-07','12:20:00',2.21),('8902','2013-10-07','12:25:00',2.71),('8902','2013-10-07','12:30:00',6.23),('8902','2013-10-07','12:35:00',3.66),('8902','2013-10-07','12:40:00',8.08),('8902','2013-10-07','12:45:00',6.56),('8902','2013-10-07','12:50:00',8.19),('8902','2013-10-07','12:55:00',7.87),('8902','2013-10-07','13:00:00',6.71),('8902','2013-10-07','13:05:00',7.78),('8902','2013-10-07','13:10:00',4.95),('8902','2013-10-07','13:15:00',6.63),('8902','2013-10-07','13:20:00',3.63),('8902','2013-10-07','13:25:00',8.23),('8902','2013-10-07','13:30:00',4.54),('8902','2013-10-07','13:35:00',2.27),('8902','2013-10-07','13:40:00',2.36),('8902','2013-10-07','13:45:00',1.63),('8902','2013-10-07','13:50:00',1.46),('8902','2013-10-07','13:55:00',1.92),('8902','2013-10-07','14:00:00',1.67),('8902','2013-10-07','14:05:00',2.89),('8902','2013-10-07','14:10:00',4.71),('8902','2013-10-07','14:15:00',5.03),('8902','2013-10-07','14:20:00',5.71),('8902','2013-10-07','14:25:00',5.72),('8902','2013-10-07','14:30:00',5.79),('8902','2013-10-07','14:35:00',2.22),('8902','2013-10-07','14:40:00',2.58),('8902','2013-10-07','14:45:00',6.45),('8902','2013-10-07','14:50:00',6.96),('8902','2013-10-07','14:55:00',6.57),('8902','2013-10-07','15:00:00',6.48),('8902','2013-10-07','15:05:00',6.69),('8902','2013-10-07','15:10:00',6.47),('8902','2013-10-07','15:15:00',6.28),('8902','2013-10-07','15:20:00',5.63),('8902','2013-10-07','15:25:00',4.19),('8902','2013-10-07','15:30:00',7.2),('8902','2013-10-07','15:35:00',6.45),('8902','2013-10-07','15:40:00',5.23),('8902','2013-10-07','15:45:00',3.72),('8902','2013-10-07','15:50:00',5.6),('8902','2013-10-07','15:55:00',2.82),('8902','2013-10-07','16:00:00',2.7),('8902','2013-10-07','16:05:00',3.87),('8902','2013-10-07','16:10:00',2.1),('8902','2013-10-07','16:15:00',1.53),('8902','2013-10-07','16:30:00',1.37),('8902','2013-10-07','16:35:00',1.26),('8902','2013-10-07','16:40:00',1.21),('8902','2013-10-07','16:45:00',1.52),('8902','2013-10-07','16:50:00',1.24),('8902','2013-10-06','08:25:00',1.34),('8902','2013-10-06','08:30:00',1.51),('8902','2013-10-06','08:35:00',1.97),('8902','2013-10-06','08:40:00',2.51),('8902','2013-10-06','08:45:00',1.33),('8902','2013-10-06','08:50:00',1.15),('8902','2013-10-06','08:55:00',2.07),('8902','2013-10-06','09:00:00',2.26),('8902','2013-10-06','09:05:00',2.85),('8902','2013-10-06','09:10:00',2.95),('8902','2013-10-06','09:15:00',3.12),('8902','2013-10-06','09:20:00',3.28),('8902','2013-10-06','09:25:00',3.44),('8902','2013-10-06','09:30:00',3.62),('8902','2013-10-06','09:35:00',3.8),('8902','2013-10-06','09:40:00',3.94),('8902','2013-10-06','09:45:00',4.12),('8902','2013-10-06','09:50:00',4.27),('8902','2013-10-06','09:55:00',4.39),('8902','2013-10-06','10:00:00',4.55),('8902','2013-10-06','10:05:00',4.7),('8902','2013-10-06','10:10:00',4.81),('8902','2013-10-06','10:15:00',4.95),('8902','2013-10-06','10:20:00',5.07),('8902','2013-10-06','10:25:00',5.26),('8902','2013-10-06','10:30:00',5.4),('8902','2013-10-06','10:35:00',5.59),('8902','2013-10-06','10:40:00',5.61),('8902','2013-10-06','10:45:00',5.61),('8902','2013-10-06','10:50:00',5.59),('8902','2013-10-06','10:55:00',5.72),('8902','2013-10-06','11:00:00',4.57),('8902','2013-10-06','11:05:00',6.06),('8902','2013-10-06','11:10:00',5.01),('8902','2013-10-06','11:15:00',5.87),('8902','2013-10-06','11:20:00',6.29),('8902','2013-10-06','11:25:00',6.37),('8902','2013-10-06','11:30:00',6.4),('8902','2013-10-06','11:35:00',6.46),('8902','2013-10-06','11:40:00',6.53),('8902','2013-10-06','11:45:00',6.58),('8902','2013-10-06','11:50:00',6.65),('8902','2013-10-06','11:55:00',6.79),('8902','2013-10-06','12:00:00',6.75),('8902','2013-10-06','12:05:00',7.04),('8902','2013-10-06','12:10:00',7.25),('8902','2013-10-06','12:15:00',7.73),('8902','2013-10-06','12:20:00',4.21),('8902','2013-10-06','12:25:00',7.94),('8902','2013-10-06','12:30:00',7.56),('8902','2013-10-06','12:35:00',6.82),('8902','2013-10-06','12:40:00',7.54),('8902','2013-10-06','12:45:00',7.53),('8902','2013-10-06','12:50:00',7.45),('8902','2013-10-06','12:55:00',7.59),('8902','2013-10-06','13:00:00',7.64),('8902','2013-10-06','13:05:00',7.48),('8902','2013-10-06','13:10:00',7.53),('8902','2013-10-06','13:15:00',7.47),('8902','2013-10-06','13:20:00',7.22),('8902','2013-10-06','13:25:00',4.71),('8902','2013-10-06','13:30:00',5.79),('8902','2013-10-06','13:35:00',7.17),('8902','2013-10-06','13:40:00',2.66),('8902','2013-10-06','13:45:00',2.78),('8902','2013-10-06','13:50:00',4.34),('8902','2013-10-06','13:55:00',8.83),('8902','2013-10-06','14:00:00',8.42),('8902','2013-10-06','14:05:00',2.33),('8902','2013-10-06','14:10:00',3.83),('8902','2013-10-06','14:15:00',2.06),('8902','2013-10-06','14:20:00',3.37),('8902','2013-10-06','14:25:00',7.39),('8902','2013-10-06','14:30:00',4.36),('8902','2013-10-06','14:35:00',3.54),('8902','2013-10-06','14:40:00',5.03),('8902','2013-10-06','14:45:00',7.54),('8902','2013-10-06','14:50:00',7.5),('8902','2013-10-06','14:55:00',7.33),('8902','2013-10-06','15:00:00',4.18),('8902','2013-10-06','15:05:00',2.54),('8902','2013-10-06','15:10:00',6.39),('8902','2013-10-06','15:15:00',1.69),('8902','2013-10-06','15:20:00',3.54),('8902','2013-10-06','15:25:00',2.26),('8902','2013-10-06','15:30:00',6.2),('8902','2013-10-06','15:35:00',6.84),('8902','2013-10-06','15:40:00',3.4),('8902','2013-10-06','15:45:00',3.59),('8902','2013-10-06','15:50:00',4.39),('8902','2013-10-06','15:55:00',5.03),('8902','2013-10-06','16:00:00',1.48),('8902','2013-10-06','16:05:00',1.12),('8902','2013-10-06','16:10:00',3.71),('8902','2013-10-06','16:15:00',4.97),('8902','2013-10-06','16:20:00',4.81),('8902','2013-10-06','16:25:00',4.63),('8902','2013-10-06','16:30:00',4.35),('8902','2013-10-06','16:35:00',4.22),('8902','2013-10-06','16:40:00',4.04),('8902','2013-10-06','16:45:00',3.91),('8902','2013-10-06','16:50:00',3.67),('8902','2013-10-06','16:55:00',3.37),('8902','2013-10-06','17:00:00',3.11),('8902','2013-10-06','17:05:00',2.81),('8902','2013-10-06','17:10:00',2.46),('8902','2013-10-06','17:15:00',2.39),('8902','2013-10-06','17:20:00',2.2),('8902','2013-10-06','17:25:00',2.05),('8902','2013-10-06','17:30:00',1.83),('8902','2013-10-06','17:35:00',1.65),('8902','2013-10-06','17:40:00',1.42),('8902','2013-10-06','17:45:00',1.27),('8902','2013-10-06','17:50:00',1.07),('8902','2013-10-05','09:00:00',1.11),('8902','2013-10-05','09:05:00',1.72),('8902','2013-10-05','09:10:00',1.56),('8902','2013-10-05','09:15:00',1.02),('8902','2013-10-05','09:25:00',1.17),('8902','2013-10-05','09:30:00',1.93),('8902','2013-10-05','09:35:00',2.66),('8902','2013-10-05','09:40:00',2.54),('8902','2013-10-05','09:45:00',2.04),('8902','2013-10-05','09:50:00',3.85),('8902','2013-10-05','09:55:00',4.61),('8902','2013-10-05','10:00:00',5.44),('8902','2013-10-05','10:05:00',5.6),('8902','2013-10-05','10:10:00',5.52),('8902','2013-10-05','10:15:00',5.09),('8902','2013-10-05','10:20:00',5.07),('8902','2013-10-05','10:25:00',5.71),('8902','2013-10-05','10:30:00',5.62),('8902','2013-10-05','10:35:00',5.64),('8902','2013-10-05','10:40:00',4.86),('8902','2013-10-05','10:45:00',4.03),('8902','2013-10-05','10:50:00',4.31),('8902','2013-10-05','10:55:00',4.9),('8902','2013-10-05','11:00:00',5.01),('8902','2013-10-05','11:05:00',5.35),('8902','2013-10-05','11:10:00',5.5),('8902','2013-10-05','11:15:00',5.07),('8902','2013-10-05','11:20:00',5.3),('8902','2013-10-05','11:25:00',5.8),('8902','2013-10-05','11:30:00',5.68),('8902','2013-10-05','11:35:00',5.58),('8902','2013-10-05','11:40:00',5.56),('8902','2013-10-05','11:45:00',4.15),('8902','2013-10-05','11:50:00',4.37),('8902','2013-10-05','11:55:00',5),('8902','2013-10-05','12:00:00',5.15),('8902','2013-10-05','12:05:00',5.2),('8902','2013-10-05','12:10:00',6.62),('8902','2013-10-05','12:15:00',6.38),('8902','2013-10-05','12:20:00',5.12),('8902','2013-10-05','12:25:00',5.26),('8902','2013-10-05','12:30:00',5.29),('8902','2013-10-05','12:35:00',5.44),('8902','2013-10-05','12:40:00',4.88),('8902','2013-10-05','12:45:00',4.99),('8902','2013-10-05','12:50:00',5.66),('8902','2013-10-05','12:55:00',6.5),('8902','2013-10-05','13:00:00',6.64),('8902','2013-10-05','13:05:00',6.48),('8902','2013-10-05','13:10:00',5.24),('8902','2013-10-05','13:15:00',4.37),('8902','2013-10-05','13:20:00',6.73),('8902','2013-10-05','13:25:00',2.3),('8902','2013-10-05','13:30:00',1.61),('8902','2013-10-05','13:35:00',1.1),('8902','2013-10-05','13:40:00',1.31),('8902','2013-10-05','13:45:00',3.27),('8902','2013-10-05','13:50:00',7.46),('8902','2013-10-05','13:55:00',4.5),('8902','2013-10-05','14:00:00',3.49),('8902','2013-10-05','14:05:00',3.71),('8902','2013-10-05','14:10:00',4.31),('8902','2013-10-05','14:15:00',4.11),('8902','2013-10-05','14:20:00',3.36),('8902','2013-10-05','14:25:00',3.21),('8902','2013-10-05','14:30:00',3.45),('8902','2013-10-05','14:35:00',3.81),('8902','2013-10-05','14:40:00',3.69),('8902','2013-10-05','14:45:00',3.53),('8902','2013-10-05','14:50:00',3.94),('8902','2013-10-05','14:55:00',4.85),('8902','2013-10-05','15:00:00',3.79),('8902','2013-10-05','15:05:00',2.84),('8902','2013-10-05','15:10:00',2.41),('8902','2013-10-05','15:15:00',2.13),('8902','2013-10-05','15:20:00',1.89),('8902','2013-10-05','15:25:00',1.48),('8902','2013-10-05','15:30:00',1.39),('8902','2013-10-05','15:35:00',1.39),('8902','2013-10-05','15:40:00',1.52),('8902','2013-10-05','15:45:00',1.7),('8902','2013-10-05','15:50:00',1.67),('8902','2013-10-05','15:55:00',2.28),('8902','2013-10-05','16:00:00',2.21),('8902','2013-10-05','16:05:00',1.57),('8902','2013-10-05','16:10:00',1.17),('8902','2013-10-05','16:20:00',1.11),('8902','2013-10-05','17:00:00',1.1),('8902','2013-10-05','17:05:00',1.26),('8902','2013-10-05','17:10:00',1.79),('8902','2013-10-05','17:15:00',2.06),('8902','2013-10-05','17:20:00',1.82),('8902','2013-10-05','17:25:00',1.21),('8902','2013-10-05','17:30:00',1.06),('8902','2013-10-05','17:35:00',1.06),('8902','2013-10-04','08:40:00',1.09),('8902','2013-10-04','14:45:00',1.04),('8902','2013-10-04','14:50:00',1.18),('8902','2013-10-04','14:55:00',1.22),('8902','2013-10-04','15:00:00',1.11),('8902','2013-10-04','15:05:00',1.15),('8902','2013-10-04','15:10:00',1.11),('8902','2013-10-04','15:15:00',1.07),('8902','2013-10-04','15:20:00',1.1),('8902','2013-10-04','15:25:00',1.14),('8902','2013-10-04','15:30:00',1.14),('8902','2013-10-04','15:35:00',1.22),('8902','2013-10-04','15:40:00',1.41),('8902','2013-10-04','15:45:00',1.47),('8902','2013-10-04','15:50:00',1.53),('8902','2013-10-04','15:55:00',1.68),('8902','2013-10-04','16:00:00',1.9),('8902','2013-10-04','16:05:00',2.38),('8902','2013-10-04','16:10:00',2.37),('8902','2013-10-04','16:15:00',2.08),('8902','2013-10-04','16:20:00',2.19),('8902','2013-10-04','16:25:00',2.25),('8902','2013-10-04','16:30:00',1.87),('8902','2013-10-04','16:35:00',1.73),('8902','2013-10-04','16:40:00',1.86),('8902','2013-10-04','16:45:00',1.85),('8902','2013-10-04','16:50:00',1.8),('8902','2013-10-04','16:55:00',1.68),('8902','2013-10-04','17:00:00',1.55),('8902','2013-10-04','17:05:00',1.55),('8902','2013-10-04','17:10:00',1.39),('8902','2013-10-04','17:15:00',1.45),('8902','2013-10-04','17:20:00',1.24),('8902','2013-10-03','08:30:00',1.14),('8902','2013-10-03','08:35:00',1.05),('8902','2013-10-03','08:40:00',1.04),('8902','2013-10-03','08:45:00',1.44),('8902','2013-10-03','08:50:00',1.32),('8902','2013-10-03','08:55:00',1.4),('8902','2013-10-03','09:00:00',1.31),('8902','2013-10-03','09:05:00',1.2),('8902','2013-10-03','09:10:00',1.3),('8902','2013-10-03','09:15:00',1.23),('8902','2013-10-03','09:20:00',1.37),('8902','2013-10-03','09:25:00',1.87),('8902','2013-10-03','09:30:00',2.1),('8902','2013-10-03','09:35:00',2.07),('8902','2013-10-03','09:40:00',2.13),('8902','2013-10-03','09:45:00',2.12),('8902','2013-10-03','09:50:00',2.54),('8902','2013-10-03','09:55:00',5.08),('8902','2013-10-03','10:00:00',3.94),('8902','2013-10-03','10:05:00',2.94),('8902','2013-10-03','10:10:00',2.86),('8902','2013-10-03','10:15:00',3.48),('8902','2013-10-03','10:20:00',2.91),('8902','2013-10-03','10:25:00',3.94),('8902','2013-10-03','10:30:00',3.88),('8902','2013-10-03','10:35:00',3.53),('8902','2013-10-03','10:40:00',5.14),('8902','2013-10-03','10:45:00',4.02),('8902','2013-10-03','10:50:00',3.32),('8902','2013-10-03','10:55:00',5.46),('8902','2013-10-03','11:00:00',4.61),('8902','2013-10-03','11:05:00',3.4),('8902','2013-10-03','11:10:00',3.29),('8902','2013-10-03','11:15:00',6.27),('8902','2013-10-03','11:20:00',5.69),('8902','2013-10-03','11:25:00',5.95),('8902','2013-10-03','11:30:00',7.42),('8902','2013-10-03','11:35:00',7.07),('8902','2013-10-03','11:40:00',7.14),('8902','2013-10-03','11:45:00',7.03),('8902','2013-10-03','11:50:00',6.97),('8902','2013-10-03','11:55:00',6.95),('8902','2013-10-03','12:00:00',7.01),('8902','2013-10-03','12:05:00',7.08),('8902','2013-10-03','12:10:00',7.15),('8902','2013-10-03','12:15:00',6.92),('8902','2013-10-03','12:20:00',6.67),('8902','2013-10-03','12:25:00',7.28),('8902','2013-10-03','12:30:00',7.26),('8902','2013-10-03','12:35:00',6.37),('8902','2013-10-03','12:40:00',7.2),('8902','2013-10-03','12:45:00',7.2),('8902','2013-10-03','12:50:00',6.91),('8902','2013-10-03','12:55:00',6.99),('8902','2013-10-03','13:00:00',7.08),('8902','2013-10-03','13:05:00',7.19),('8902','2013-10-03','13:10:00',7.19),('8902','2013-10-03','13:15:00',7.64),('8902','2013-10-03','13:20:00',7.44),('8902','2013-10-03','13:25:00',6.96),('8902','2013-10-03','13:30:00',7.39),('8902','2013-10-03','13:35:00',6.15),('8902','2013-10-03','13:40:00',7.15),('8902','2013-10-03','13:45:00',6.96),('8902','2013-10-03','13:50:00',6.9),('8902','2013-10-03','13:55:00',6.94),('8902','2013-10-03','14:00:00',6.92),('8902','2013-10-03','14:05:00',6.88),('8902','2013-10-03','14:10:00',6.34),('8902','2013-10-03','14:15:00',5.76),('8902','2013-10-03','14:20:00',6.09),('8902','2013-10-03','14:25:00',6.65),('8902','2013-10-03','14:30:00',5.91),('8902','2013-10-03','14:35:00',4.26),('8902','2013-10-03','14:40:00',3.37),('8902','2013-10-03','14:45:00',3.75),('8902','2013-10-03','14:50:00',5.04),('8902','2013-10-03','14:55:00',5.27),('8902','2013-10-03','15:00:00',4.51),('8902','2013-10-03','15:05:00',5.14),('8902','2013-10-03','15:10:00',4.47),('8902','2013-10-03','15:15:00',3.51),('8902','2013-10-03','15:20:00',3.02),('8902','2013-10-03','15:25:00',4.32),('8902','2013-10-03','15:30:00',5.71),('8902','2013-10-03','15:35:00',3.52),('8902','2013-10-03','15:40:00',1.75),('8902','2013-10-03','15:45:00',1.44),('8902','2013-10-03','15:50:00',1.36),('8902','2013-10-03','15:55:00',1.51),('8902','2013-10-03','16:00:00',1.85),('8902','2013-10-03','16:05:00',2.09),('8902','2013-10-03','16:10:00',2),('8902','2013-10-03','16:15:00',1.8),('8902','2013-10-03','16:20:00',1.53),('8902','2013-10-03','16:25:00',1.27),('8902','2013-10-03','16:30:00',1.17),('8902','2013-10-03','16:35:00',1.16),('8902','2013-10-03','16:40:00',1.11),('8902','2013-10-03','16:45:00',1.06),('8902','2013-10-03','16:50:00',1.05),('8902','2013-10-03','16:55:00',1.03),('8902','2013-10-02','08:15:00',1.11),('8902','2013-10-02','08:20:00',1.28),('8902','2013-10-02','08:25:00',1.45),('8902','2013-10-02','08:30:00',1.64),('8902','2013-10-02','08:35:00',1.82),('8902','2013-10-02','08:40:00',1.99),('8902','2013-10-02','08:45:00',2.2),('8902','2013-10-02','08:50:00',2.42),('8902','2013-10-02','08:55:00',2.61),('8902','2013-10-02','09:00:00',2.79),('8902','2013-10-02','09:05:00',2.97),('8902','2013-10-02','09:10:00',3.17),('8902','2013-10-02','09:15:00',3.38),('8902','2013-10-02','09:20:00',3.56),('8902','2013-10-02','09:25:00',3.76),('8902','2013-10-02','09:30:00',3.94),('8902','2013-10-02','09:35:00',4.13),('8902','2013-10-02','09:40:00',4.32),('8902','2013-10-02','09:45:00',4.51),('8902','2013-10-02','09:50:00',4.67),('8902','2013-10-02','09:55:00',4.83),('8902','2013-10-02','10:00:00',4.99),('8902','2013-10-02','10:05:00',5.15),('8902','2013-10-02','10:10:00',5.28),('8902','2013-10-02','10:15:00',5.44),('8902','2013-10-02','10:20:00',5.57),('8902','2013-10-02','10:25:00',5.7),('8902','2013-10-02','10:30:00',5.81),('8902','2013-10-02','10:35:00',5.93),('8902','2013-10-02','10:40:00',6.08),('8902','2013-10-02','10:45:00',6.2),('8902','2013-10-02','10:50:00',6.3),('8902','2013-10-02','10:55:00',6.4),('8902','2013-10-02','11:00:00',6.48),('8902','2013-10-02','11:05:00',6.55),('8902','2013-10-02','11:10:00',6.66),('8902','2013-10-02','11:15:00',6.76),('8902','2013-10-02','11:20:00',6.85),('8902','2013-10-02','11:25:00',6.92),('8902','2013-10-02','11:30:00',6.97),('8902','2013-10-02','11:35:00',7.09),('8902','2013-10-02','11:40:00',7.15),('8902','2013-10-02','11:45:00',7.2),('8902','2013-10-02','11:50:00',7.3),('8902','2013-10-02','11:55:00',7.36),('8902','2013-10-02','12:00:00',7.37),('8902','2013-10-02','12:05:00',7.42),('8902','2013-10-02','12:10:00',7.46),('8902','2013-10-02','12:15:00',7.43),('8902','2013-10-02','12:20:00',7.48),('8902','2013-10-02','12:25:00',7.52),('8902','2013-10-02','12:30:00',7.55),('8902','2013-10-02','12:35:00',7.57),('8902','2013-10-02','12:40:00',7.55),('8902','2013-10-02','12:45:00',7.58),('8902','2013-10-02','12:50:00',7.59),('8902','2013-10-02','12:55:00',7.59),('8902','2013-10-02','13:00:00',7.53),('8902','2013-10-02','13:05:00',7.42),('8902','2013-10-02','13:10:00',7.59),('8902','2013-10-02','13:15:00',7.58),('8902','2013-10-02','13:20:00',7.56),('8902','2013-10-02','13:25:00',7.53),('8902','2013-10-02','13:30:00',7.58),('8902','2013-10-02','13:35:00',7.58),('8902','2013-10-02','13:40:00',7.54),('8902','2013-10-02','13:45:00',7.45),('8902','2013-10-02','13:50:00',7.45),('8902','2013-10-02','13:55:00',7.48),('8902','2013-10-02','14:00:00',7.46),('8902','2013-10-02','14:05:00',7.43),('8902','2013-10-02','14:10:00',7.36),('8902','2013-10-02','14:15:00',7.29),('8902','2013-10-02','14:20:00',7.25),('8902','2013-10-02','14:25:00',7.19),('8902','2013-10-02','14:30:00',7.15),('8902','2013-10-02','14:35:00',7.1),('8902','2013-10-02','14:40:00',7.02),('8902','2013-10-02','14:45:00',6.94),('8902','2013-10-02','14:50:00',6.87),('8902','2013-10-02','14:55:00',6.79),('8902','2013-10-02','15:00:00',6.71),('8902','2013-10-02','15:05:00',6.59),('8902','2013-10-02','15:10:00',6.47),('8902','2013-10-02','15:15:00',6.39),('8902','2013-10-02','15:20:00',6.3),('8902','2013-10-02','15:25:00',6.18),('8902','2013-10-02','15:30:00',6.1),('8902','2013-10-02','15:35:00',5.97),('8902','2013-10-02','15:40:00',5.83),('8902','2013-10-02','15:45:00',5.71),('8902','2013-10-02','15:50:00',5.58),('8902','2013-10-02','15:55:00',5.46),('8902','2013-10-02','16:00:00',5.31),('8902','2013-10-02','16:05:00',5.11),('8902','2013-10-02','16:10:00',4.99),('8902','2013-10-02','16:15:00',4.83),('8902','2013-10-02','16:20:00',4.69),('8902','2013-10-02','16:25:00',4.51),('8902','2013-10-02','16:30:00',4.31),('8902','2013-10-02','16:35:00',4.17),('8902','2013-10-02','16:40:00',3.97),('8902','2013-10-02','16:45:00',3.8),('8902','2013-10-02','16:50:00',3.62),('8902','2013-10-02','16:55:00',3.44),('8902','2013-10-02','17:00:00',3.27),('8902','2013-10-02','17:05:00',3.09),('8902','2013-10-02','17:10:00',2.75),('8902','2013-10-02','17:15:00',2.61),('8902','2013-10-02','17:20:00',2.45),('8902','2013-10-02','17:25:00',2.27),('8902','2013-10-02','17:30:00',2.05),('8902','2013-10-02','17:35:00',1.82),('8902','2013-10-02','17:40:00',1.63),('8902','2013-10-02','17:45:00',1.44),('8902','2013-10-02','17:50:00',1.27),('8902','2013-10-02','17:55:00',1.09),('8902','2013-10-01','08:15:00',1.29),('8902','2013-10-01','08:20:00',1.58),('8902','2013-10-01','08:25:00',1.6),('8902','2013-10-01','08:30:00',1.42),('8902','2013-10-01','08:35:00',1.7),('8902','2013-10-01','08:40:00',1.87),('8902','2013-10-01','08:45:00',2.08),('8902','2013-10-01','08:50:00',2.28),('8902','2013-10-01','08:55:00',2.45),('8902','2013-10-01','09:00:00',2.63),('8902','2013-10-01','09:05:00',2.81),('8902','2013-10-01','09:10:00',3),('8902','2013-10-01','09:15:00',3.19),('8902','2013-10-01','09:20:00',3.37),('8902','2013-10-01','09:25:00',3.56),('8902','2013-10-01','09:30:00',3.73),('8902','2013-10-01','09:35:00',3.92),('8902','2013-10-01','09:40:00',4.09),('8902','2013-10-01','09:45:00',4.25),('8902','2013-10-01','09:50:00',4.41),('8902','2013-10-01','09:55:00',4.54),('8902','2013-10-01','10:00:00',4.67),('8902','2013-10-01','10:05:00',4.78),('8902','2013-10-01','10:10:00',4.92),('8902','2013-10-01','10:15:00',5.05),('8902','2013-10-01','10:20:00',5.2),('8902','2013-10-01','10:25:00',5.34),('8902','2013-10-01','10:30:00',5.47),('8902','2013-10-01','10:35:00',5.6),('8902','2013-10-01','10:40:00',5.75),('8902','2013-10-01','10:45:00',5.89),('8902','2013-10-01','10:50:00',6.01),('8902','2013-10-01','10:55:00',6.1),('8902','2013-10-01','11:00:00',6.21),('8902','2013-10-01','11:05:00',6.32),('8902','2013-10-01','11:10:00',6.39),('8902','2013-10-01','11:15:00',6.48),('8902','2013-10-01','11:20:00',6.55),('8902','2013-10-01','11:25:00',6.61),('8902','2013-10-01','11:30:00',6.7),('8902','2013-10-01','11:35:00',6.77),('8902','2013-10-01','11:40:00',6.83),('8902','2013-10-01','11:45:00',6.89),('8902','2013-10-01','11:50:00',6.95),('8902','2013-10-01','11:55:00',6.99),('8902','2013-10-01','12:00:00',7.02),('8902','2013-10-01','12:05:00',7.06),('8902','2013-10-01','12:10:00',7.12),('8902','2013-10-01','12:15:00',7.18),('8902','2013-10-01','12:20:00',7.19),('8902','2013-10-01','12:25:00',7.22),('8902','2013-10-01','12:30:00',7.24),('8902','2013-10-01','12:35:00',7.26),('8902','2013-10-01','12:40:00',7.3),('8902','2013-10-01','12:45:00',7.34),('8902','2013-10-01','12:50:00',7.39),('8902','2013-10-01','12:55:00',7.4),('8902','2013-10-01','13:00:00',7.41),('8902','2013-10-01','13:05:00',7.4),('8902','2013-10-01','13:10:00',7.39),('8902','2013-10-01','13:15:00',7.4),('8902','2013-10-01','13:20:00',7.43),('8902','2013-10-01','13:25:00',7.43),('8902','2013-10-01','13:30:00',7.41),('8902','2013-10-01','13:35:00',7.37),('8902','2013-10-01','13:40:00',7.3),('8902','2013-10-01','13:45:00',7.26),('8902','2013-10-01','13:50:00',7.25),('8902','2013-10-01','13:55:00',7.24),('8902','2013-10-01','14:00:00',7.22),('8902','2013-10-01','14:05:00',7.21),('8902','2013-10-01','14:10:00',7.13),('8902','2013-10-01','14:15:00',7.09),('8902','2013-10-01','14:20:00',7.04),('8902','2013-10-01','14:25:00',6.99),('8902','2013-10-01','14:30:00',6.95),('8902','2013-10-01','14:35:00',6.89),('8902','2013-10-01','14:40:00',6.79),('8902','2013-10-01','14:45:00',6.72),('8902','2013-10-01','14:50:00',6.68),('8902','2013-10-01','14:55:00',6.6),('8902','2013-10-01','15:00:00',6.53),('8902','2013-10-01','15:05:00',6.42),('8902','2013-10-01','15:10:00',6.32),('8902','2013-10-01','15:15:00',6.22),('8902','2013-10-01','15:20:00',6.12),('8902','2013-10-01','15:25:00',5.98),('8902','2013-10-01','15:30:00',5.87),('8902','2013-10-01','15:35:00',5.78),('8902','2013-10-01','15:40:00',5.68),('8902','2013-10-01','15:45:00',5.58),('8902','2013-10-01','15:50:00',5.44),('8902','2013-10-01','15:55:00',5.29),('8902','2013-10-01','16:00:00',5.19),('8902','2013-10-01','16:05:00',4.96),('8902','2013-10-01','16:10:00',4.82),('8902','2013-10-01','16:15:00',4.69),('8902','2013-10-01','16:20:00',4.53),('8902','2013-10-01','16:25:00',4.41),('8902','2013-10-01','16:30:00',4.22),('8902','2013-10-01','16:35:00',4.08),('8902','2013-10-01','16:40:00',3.87),('8902','2013-10-01','16:45:00',3.68),('8902','2013-10-01','16:50:00',3.51),('8902','2013-10-01','16:55:00',3.35),('8902','2013-10-01','17:00:00',3.18),('8902','2013-10-01','17:05:00',3),('8902','2013-10-01','17:10:00',2.73),('8902','2013-10-01','17:15:00',2.55),('8902','2013-10-01','17:20:00',2.38),('8902','2013-10-01','17:25:00',2.18),('8902','2013-10-01','17:30:00',1.92),('8902','2013-10-01','17:35:00',1.7),('8902','2013-10-01','17:40:00',1.44),('8902','2013-10-01','17:45:00',1.23),('8902','2013-10-01','17:50:00',1.2),('8902','2013-10-01','17:55:00',1.03),('8902','2013-09-30','08:25:00',1.14),('8902','2013-09-30','08:40:00',1.9),('8902','2013-09-30','08:45:00',2.16),('8902','2013-09-30','08:50:00',2.34),('8902','2013-09-30','08:55:00',2.53),('8902','2013-09-30','09:00:00',2.7),('8902','2013-09-30','09:05:00',2.89),('8902','2013-09-30','09:10:00',3.05),('8902','2013-09-30','09:15:00',3.23),('8902','2013-09-30','09:20:00',3.38),('8902','2013-09-30','09:25:00',3.56),('8902','2013-09-30','09:30:00',3.71),('8902','2013-09-30','09:35:00',3.85),('8902','2013-09-30','09:40:00',4.02),('8902','2013-09-30','09:45:00',4.2),('8902','2013-09-30','09:50:00',4.34),('8902','2013-09-30','09:55:00',4.47),('8902','2013-09-30','10:00:00',4.59),('8902','2013-09-30','10:05:00',4.74),('8902','2013-09-30','10:10:00',4.88),('8902','2013-09-30','10:15:00',5.03),('8902','2013-09-30','10:20:00',5.14),('8902','2013-09-30','10:25:00',5.26),('8902','2013-09-30','10:30:00',5.47),('8902','2013-09-30','10:35:00',5.54),('8902','2013-09-30','10:40:00',5.65),('8902','2013-09-30','10:45:00',5.76),('8902','2013-09-30','10:50:00',5.87),('8902','2013-09-30','10:55:00',5.98),('8902','2013-09-30','11:00:00',6.03),('8902','2013-09-30','11:05:00',6.32),('8902','2013-09-30','11:10:00',6.81),('8902','2013-09-30','11:15:00',5.51),('8902','2013-09-30','11:20:00',3.04),('8902','2013-09-30','11:25:00',1.85),('8902','2013-09-30','11:30:00',7.15),('8902','2013-09-30','11:35:00',5.16),('8902','2013-09-30','11:40:00',5.73),('8902','2013-09-30','11:45:00',7.24),('8902','2013-09-30','11:50:00',7.24),('8902','2013-09-30','11:55:00',7.29),('8902','2013-09-30','12:00:00',7.11),('8902','2013-09-30','12:05:00',7.06),('8902','2013-09-30','12:10:00',6.9),('8902','2013-09-30','12:15:00',7.08),('8902','2013-09-30','12:20:00',7.33),('8902','2013-09-30','12:25:00',7.56),('8902','2013-09-30','12:30:00',7.66),('8902','2013-09-30','12:35:00',7.72),('8902','2013-09-30','12:40:00',3.94),('8902','2013-09-30','12:45:00',5.97),('8902','2013-09-30','12:50:00',7.6),('8902','2013-09-30','12:55:00',7.52),('8902','2013-09-30','13:00:00',7.51),('8902','2013-09-30','13:05:00',7.51),('8902','2013-09-30','13:10:00',2.27),('8902','2013-09-30','13:15:00',1.29),('8902','2013-09-30','13:20:00',5.41),('8902','2013-09-30','13:25:00',8.13),('8902','2013-09-30','13:30:00',8.22),('8902','2013-09-30','13:35:00',7.61),('8902','2013-09-30','13:40:00',7.62),('8902','2013-09-30','13:45:00',4.86),('8902','2013-09-30','13:50:00',5.07),('8902','2013-09-30','13:55:00',5.96),('8902','2013-09-30','14:00:00',7.33),('8902','2013-09-30','14:05:00',7.12),('8902','2013-09-30','14:10:00',7.04),('8902','2013-09-30','14:15:00',6.94),('8902','2013-09-30','14:20:00',6.83),('8902','2013-09-30','14:25:00',6.77),('8902','2013-09-30','14:30:00',6.75),('8902','2013-09-30','14:35:00',6.64),('8902','2013-09-30','14:40:00',6.73),('8902','2013-09-30','14:45:00',6.31),('8902','2013-09-30','14:50:00',6.72),('8902','2013-09-30','14:55:00',6.63),('8902','2013-09-30','15:00:00',6.5),('8902','2013-09-30','15:05:00',6.32),('8902','2013-09-30','15:10:00',6.24),('8902','2013-09-30','15:15:00',6.11),('8902','2013-09-30','15:20:00',6.07),('8902','2013-09-30','15:25:00',5.99),('8902','2013-09-30','15:30:00',5.88),('8902','2013-09-30','15:35:00',5.76),('8902','2013-09-30','15:40:00',5.68),('8902','2013-09-30','15:45:00',5.53),('8902','2013-09-30','15:50:00',5.4),('8902','2013-09-30','15:55:00',5.29),('8902','2013-09-30','16:00:00',5.11),('8902','2013-09-30','16:05:00',4.97),('8902','2013-09-30','16:10:00',4.84),('8902','2013-09-30','16:15:00',4.7),('8902','2013-09-30','16:20:00',4.56),('8902','2013-09-30','16:25:00',4.39),('8902','2013-09-30','16:30:00',4.19),('8902','2013-09-30','16:35:00',4.04),('8902','2013-09-30','16:40:00',3.87),('8902','2013-09-30','16:45:00',3.64),('8902','2013-09-30','16:50:00',3.5),('8902','2013-09-30','16:55:00',3.37),('8902','2013-09-30','17:00:00',3.23),('8902','2013-09-30','17:05:00',3.04),('8902','2013-09-30','17:10:00',2.75),('8902','2013-09-30','17:15:00',2.43),('8902','2013-09-30','17:20:00',2.41),('8902','2013-09-30','17:25:00',2.27),('8902','2013-09-30','17:30:00',2.06),('8902','2013-09-30','17:35:00',1.85),('8902','2013-09-30','17:40:00',1.66),('8902','2013-09-30','17:45:00',1.43),('8902','2013-09-30','17:50:00',1.24),('8902','2013-09-30','17:55:00',1.1),('8902','2013-09-29','09:25:00',1.02),('8902','2013-09-29','09:35:00',1.22),('8902','2013-09-29','09:40:00',1.35),('8902','2013-09-29','09:45:00',1.75),('8902','2013-09-29','09:50:00',2.32),('8902','2013-09-29','09:55:00',2.01),('8902','2013-09-29','10:00:00',1.93),('8902','2013-09-29','10:05:00',1.86),('8902','2013-09-29','10:10:00',2.01),('8902','2013-09-29','10:15:00',2.05),('8902','2013-09-29','10:20:00',2.05),('8902','2013-09-29','10:25:00',2.39),('8902','2013-09-29','10:30:00',2.69),('8902','2013-09-29','10:35:00',3.12),('8902','2013-09-29','10:40:00',4.01),('8902','2013-09-29','10:45:00',6.09),('8902','2013-09-29','10:50:00',6.4),('8902','2013-09-29','10:55:00',5.87),('8902','2013-09-29','11:00:00',3.87),('8902','2013-09-29','11:05:00',5.76),('8902','2013-09-29','11:10:00',4.17),('8902','2013-09-29','11:15:00',5.93),('8902','2013-09-29','11:20:00',4.89),('8902','2013-09-29','11:25:00',5.34),('8902','2013-09-29','11:30:00',2.63),('8902','2013-09-29','11:35:00',3.53),('8902','2013-09-29','11:40:00',4.81),('8902','2013-09-29','11:45:00',4.15),('8902','2013-09-29','11:50:00',3.09),('8902','2013-09-29','11:55:00',3.59),('8902','2013-09-29','12:00:00',2.74),('8902','2013-09-29','12:05:00',3.53),('8902','2013-09-29','12:10:00',3.36),('8902','2013-09-29','12:15:00',7.39),('8902','2013-09-29','12:20:00',7.76),('8902','2013-09-29','12:25:00',7.73),('8902','2013-09-29','12:30:00',7.52),('8902','2013-09-29','12:35:00',7.54),('8902','2013-09-29','12:40:00',7.84),('8902','2013-09-29','12:45:00',5.97),('8902','2013-09-29','12:50:00',7.9),('8902','2013-09-29','12:55:00',7.68),('8902','2013-09-29','13:00:00',7.67),('8902','2013-09-29','13:05:00',7.83),('8902','2013-09-29','13:10:00',7.95),('8902','2013-09-29','13:15:00',7.81),('8902','2013-09-29','13:20:00',8.25),('8902','2013-09-29','13:25:00',8.51),('8902','2013-09-29','13:30:00',8.58),('8902','2013-09-29','13:35:00',7.17),('8902','2013-09-29','13:40:00',7.43),('8902','2013-09-29','13:45:00',7.34),('8902','2013-09-29','13:50:00',5.48),('8902','2013-09-29','13:55:00',4.13),('8902','2013-09-29','14:00:00',4.03),('8902','2013-09-29','14:05:00',2.76),('8902','2013-09-29','14:10:00',2.51),('8902','2013-09-29','14:15:00',2.4),('8902','2013-09-29','14:20:00',2.02),('8902','2013-09-29','14:25:00',2.25),('8902','2013-09-29','14:30:00',4.8),('8902','2013-09-29','14:35:00',5.52),('8902','2013-09-29','14:40:00',7.66),('8902','2013-09-29','14:45:00',7.3),('8902','2013-09-29','14:50:00',5.86),('8902','2013-09-29','14:55:00',5.77),('8902','2013-09-29','15:00:00',2.88),('8902','2013-09-29','15:05:00',3.61),('8902','2013-09-29','15:10:00',7.83),('8902','2013-09-29','15:15:00',5.78),('8902','2013-09-29','15:20:00',2.59),('8902','2013-09-29','15:25:00',4.95),('8902','2013-09-29','15:30:00',5.43),('8902','2013-09-29','15:35:00',5.02),('8902','2013-09-29','15:40:00',6.73),('8902','2013-09-29','15:45:00',5.1),('8902','2013-09-29','15:55:00',1.03),('8902','2013-09-29','16:00:00',1.03),('8902','2013-09-29','16:10:00',1.74),('8902','2013-09-29','16:15:00',3.25),('8902','2013-09-29','16:20:00',4.65),('8902','2013-09-29','16:25:00',2.05),('8902','2013-09-29','16:30:00',1.31),('8902','2013-09-29','16:35:00',1.12),('8902','2013-09-29','16:40:00',3.65),('8902','2013-09-29','16:45:00',3.84),('8902','2013-09-29','16:50:00',2.41),('8902','2013-09-29','16:55:00',1.14),('8902','2013-09-29','17:00:00',1.83),('8902','2013-09-29','17:05:00',1.55),('8902','2013-09-29','17:10:00',1.11),('8902','2013-09-29','17:15:00',1.7),('8902','2013-09-29','17:20:00',2.62),('8902','2013-09-29','17:25:00',1.62),('8902','2013-09-29','17:30:00',1.84),('8902','2013-09-28','08:40:00',1.3),('8902','2013-09-28','08:45:00',1.72),('8902','2013-09-28','08:50:00',2.15),('8902','2013-09-28','08:55:00',1.97),('8902','2013-09-28','09:00:00',1.79),('8902','2013-09-28','09:05:00',1.63),('8902','2013-09-28','09:10:00',1.76),('8902','2013-09-28','09:15:00',2.34),('8902','2013-09-28','09:20:00',1.65),('8902','2013-09-28','09:25:00',1.67),('8902','2013-09-28','09:30:00',1.63),('8902','2013-09-28','09:35:00',1.57),('8902','2013-09-28','09:40:00',1.53),('8902','2013-09-28','09:45:00',1.74),('8902','2013-09-28','09:50:00',1.9),('8902','2013-09-28','09:55:00',1.93),('8902','2013-09-28','10:00:00',2.23),('8902','2013-09-28','10:05:00',3.06),('8902','2013-09-28','10:10:00',3.63),('8902','2013-09-28','10:15:00',4.63),('8902','2013-09-28','10:20:00',4.22),('8902','2013-09-28','10:25:00',3.77),('8902','2013-09-28','10:30:00',4.21),('8902','2013-09-28','10:35:00',4.68),('8902','2013-09-28','10:40:00',4.95),('8902','2013-09-28','10:45:00',5.16),('8902','2013-09-28','10:50:00',5.4),('8902','2013-09-28','10:55:00',5.32),('8902','2013-09-28','11:00:00',5.41),('8902','2013-09-28','11:05:00',5.29),('8902','2013-09-28','11:10:00',5.27),('8902','2013-09-28','11:15:00',5.7),('8902','2013-09-28','11:20:00',5.72),('8902','2013-09-28','11:25:00',5.29),('8902','2013-09-28','11:30:00',5.77),('8902','2013-09-28','11:35:00',5.72),('8902','2013-09-28','11:40:00',5.9),('8902','2013-09-28','11:45:00',6.06),('8902','2013-09-28','11:50:00',6.39),('8902','2013-09-28','11:55:00',6.33),('8902','2013-09-28','12:00:00',6.24),('8902','2013-09-28','12:05:00',6.52),('8902','2013-09-28','12:10:00',6.19),('8902','2013-09-28','12:15:00',7.13),('8902','2013-09-28','12:20:00',5.97),('8902','2013-09-28','12:25:00',3.55),('8902','2013-09-28','12:30:00',3.76),('8902','2013-09-28','12:35:00',3.87),('8902','2013-09-28','12:40:00',3.17),('8902','2013-09-28','12:45:00',2.85),('8902','2013-09-28','12:50:00',2.91),('8902','2013-09-28','12:55:00',2.48),('8902','2013-09-28','13:00:00',2.65),('8902','2013-09-28','13:05:00',2.08),('8902','2013-09-28','13:10:00',2.19),('8902','2013-09-28','13:15:00',1.74),('8902','2013-09-28','13:20:00',1.75),('8902','2013-09-28','13:25:00',2.71),('8902','2013-09-28','13:30:00',4.61),('8902','2013-09-28','13:35:00',3.08),('8902','2013-09-28','13:40:00',3.05),('8902','2013-09-28','13:45:00',2.96),('8902','2013-09-28','13:50:00',3.09),('8902','2013-09-28','13:55:00',4.43),('8902','2013-09-28','14:00:00',4.33),('8902','2013-09-28','14:05:00',5.57),('8902','2013-09-28','14:10:00',2.88),('8902','2013-09-28','14:15:00',3.31),('8902','2013-09-28','14:20:00',4.08),('8902','2013-09-28','14:25:00',3.2),('8902','2013-09-28','14:30:00',2.42),('8902','2013-09-28','14:35:00',2.36),('8902','2013-09-28','14:40:00',2.22),('8902','2013-09-28','14:45:00',1.59),('8902','2013-09-28','14:50:00',1.83),('8902','2013-09-28','14:55:00',2.02),('8902','2013-09-28','15:00:00',2.71),('8902','2013-09-28','15:05:00',1.18),('8902','2013-09-28','15:15:00',1.17),('8902','2013-09-28','15:20:00',1.89),('8902','2013-09-28','15:25:00',1.56),('8902','2013-09-28','15:30:00',1.43),('8902','2013-09-28','15:35:00',1.29),('8902','2013-09-28','15:40:00',1.56),('8902','2013-09-28','15:45:00',1.27),('8902','2013-09-28','15:50:00',1.19),('8902','2013-09-28','15:55:00',1.71),('8902','2013-09-28','16:00:00',2.26),('8902','2013-09-28','16:05:00',1.8),('8902','2013-09-28','16:10:00',1.21),('8902','2013-09-28','16:20:00',1.15),('8902','2013-09-28','16:25:00',1.47),('8902','2013-09-28','16:30:00',2.03),('8902','2013-09-28','16:35:00',1.9),('8902','2013-09-28','16:40:00',1.65),('8902','2013-09-28','16:45:00',1.5),('8902','2013-09-28','17:05:00',1.21),('8902','2013-09-28','17:20:00',1.01),('8902','2014-04-13','07:55:00',1.29),('8902','2014-04-13','08:00:00',1.46),('8902','2014-04-13','08:05:00',1.63),('8902','2014-04-13','08:10:00',1.81),('8902','2014-04-13','08:15:00',1.99),('8902','2014-04-13','08:20:00',2.18),('8902','2014-04-13','08:25:00',2.37),('8902','2014-04-13','08:30:00',2.56),('8902','2014-04-13','08:35:00',2.74),('8902','2014-04-13','08:40:00',2.93),('8902','2014-04-13','08:45:00',3.12),('8902','2014-04-13','08:50:00',3.29),('8902','2014-04-13','08:55:00',3.46),('8902','2014-04-13','09:00:00',3.65),('8902','2014-04-13','09:05:00',3.83),('8902','2014-04-13','09:10:00',4.02),('8902','2014-04-13','09:15:00',4.18),('8902','2014-04-13','09:20:00',4.35),('8902','2014-04-13','09:25:00',4.49),('8902','2014-04-13','09:30:00',4.66),('8902','2014-04-13','09:35:00',4.8),('8902','2014-04-13','09:40:00',4.97),('8902','2014-04-13','09:45:00',5.1),('8902','2014-04-13','09:50:00',5.25),('8902','2014-04-13','09:55:00',5.39),('8902','2014-04-13','10:00:00',5.52),('8902','2014-04-13','10:05:00',5.71),('8902','2014-04-13','10:10:00',5.87),('8902','2014-04-13','10:15:00',6),('8902','2014-04-13','10:20:00',6.14),('8902','2014-04-13','10:25:00',6.24),('8902','2014-04-13','10:30:00',6.36),('8902','2014-04-13','10:35:00',6.47),('8902','2014-04-13','10:40:00',6.59),('8902','2014-04-13','10:45:00',6.69),('8902','2014-04-13','10:50:00',6.79),('8902','2014-04-13','10:55:00',6.91),('8902','2014-04-13','11:00:00',6.98),('8902','2014-04-13','11:05:00',7.08),('8902','2014-04-13','11:10:00',7.12),('8902','2014-04-13','11:15:00',7.21),('8902','2014-04-13','11:20:00',7.32),('8902','2014-04-13','11:25:00',7.36),('8902','2014-04-13','11:30:00',7.41),('8902','2014-04-13','11:35:00',7.53),('8902','2014-04-13','11:40:00',7.61),('8902','2014-04-13','11:45:00',7.63),('8902','2014-04-13','11:50:00',7.69),('8902','2014-04-13','11:55:00',7.73),('8902','2014-04-13','12:00:00',7.79),('8902','2014-04-13','12:05:00',7.83),('8902','2014-04-13','12:10:00',7.85),('8902','2014-04-13','12:15:00',7.94),('8902','2014-04-13','12:20:00',8.02),('8902','2014-04-13','12:25:00',8.02),('8902','2014-04-13','12:30:00',8.09),('8902','2014-04-13','12:35:00',8.09),('8902','2014-04-13','12:40:00',8.12),('8902','2014-04-13','12:45:00',8.2),('8902','2014-04-13','12:50:00',8.2),('8902','2014-04-13','12:55:00',8.21),('8902','2014-04-13','13:00:00',8.24),('8902','2014-04-13','13:05:00',8.28),('8902','2014-04-13','13:10:00',8.29),('8902','2014-04-13','13:15:00',8.21),('8902','2014-04-13','13:20:00',8.27),('8902','2014-04-13','13:25:00',8.27),('8902','2014-04-13','13:30:00',8.3),('8902','2014-04-13','13:35:00',8.31),('8902','2014-04-13','13:40:00',8.31),('8902','2014-04-13','13:45:00',8.28),('8902','2014-04-13','13:50:00',8.28),('8902','2014-04-13','13:55:00',8.27),('8902','2014-04-13','14:00:00',8.23),('8902','2014-04-13','14:05:00',8.22),('8902','2014-04-13','14:10:00',8.19),('8902','2014-04-13','14:15:00',8.19),('8902','2014-04-13','14:20:00',8.2),('8902','2014-04-13','14:25:00',8.19),('8902','2014-04-13','14:30:00',8.14),('8902','2014-04-13','14:35:00',8.05),('8902','2014-04-13','14:40:00',8),('8902','2014-04-13','14:45:00',7.95),('8902','2014-04-13','14:50:00',7.94),('8902','2014-04-13','14:55:00',7.89),('8902','2014-04-13','15:00:00',7.83),('8902','2014-04-13','15:05:00',7.77),('8902','2014-04-13','15:10:00',7.65),('8902','2014-04-13','15:15:00',7.58),('8902','2014-04-13','15:20:00',7.51),('8902','2014-04-13','15:25:00',7.43),('8902','2014-04-13','15:30:00',7.37),('8902','2014-04-13','15:35:00',7.26),('8902','2014-04-13','15:40:00',7.18),('8902','2014-04-13','15:45:00',7.09),('8902','2014-04-13','15:50:00',6.97),('8902','2014-04-13','15:55:00',6.87),('8902','2014-04-13','16:00:00',6.77),('8902','2014-04-13','16:05:00',6.64),('8902','2014-04-13','16:10:00',6.51),('8902','2014-04-13','16:15:00',6.38),('8902','2014-04-13','16:20:00',6.26),('8902','2014-04-13','16:25:00',6.06),('8902','2014-04-13','16:30:00',5.93),('8902','2014-04-13','16:35:00',5.8),('8902','2014-04-13','16:40:00',5.65),('8902','2014-04-13','16:45:00',5.43),('8902','2014-04-13','16:50:00',5.31),('8902','2014-04-13','16:55:00',5.18),('8902','2014-04-13','17:00:00',5),('8902','2014-04-13','17:05:00',4.8),('8902','2014-04-13','17:10:00',4.61),('8902','2014-04-13','17:15:00',4.45),('8902','2014-04-13','17:20:00',4.29),('8902','2014-04-13','17:25:00',4.12),('8902','2014-04-13','17:30:00',3.9),('8902','2014-04-13','17:35:00',3.68),('8902','2014-04-13','17:40:00',3.43),('8902','2014-04-13','17:45:00',3.26),('8902','2014-04-13','17:50:00',3.1),('8902','2014-04-13','17:55:00',2.87),('8902','2014-04-13','18:00:00',2.66),('8902','2014-04-13','18:05:00',2.42),('8902','2014-04-13','18:10:00',2.25),('8902','2014-04-13','18:15:00',2.04),('8902','2014-04-13','18:20:00',1.85),('8902','2014-04-13','18:25:00',1.68),('8902','2014-04-13','18:30:00',1.52),('8902','2014-04-13','18:35:00',1.33),('8902','2014-04-13','18:40:00',1.13),('8902','2013-09-27','08:10:00',1.02),('8902','2013-09-27','08:15:00',1.24),('8902','2013-09-27','08:20:00',1.22),('8902','2013-09-27','08:25:00',1.32),('8902','2013-09-27','08:30:00',1.63),('8902','2013-09-27','08:35:00',1.73),('8902','2013-09-27','08:40:00',1.87),('8902','2013-09-27','08:45:00',2.03),('8902','2013-09-27','08:50:00',2.18),('8902','2013-09-27','08:55:00',2.33),('8902','2013-09-27','09:00:00',2.48),('8902','2013-09-27','09:05:00',2.7),('8902','2013-09-27','09:10:00',2.88),('8902','2013-09-27','09:15:00',3.09),('8902','2013-09-27','09:20:00',3.27),('8902','2013-09-27','09:25:00',3.51),('8902','2013-09-27','09:30:00',3.64),('8902','2013-09-27','09:35:00',3.35),('8902','2013-09-27','09:40:00',3.97),('8902','2013-09-27','09:45:00',4.01),('8902','2013-09-27','09:50:00',3.56),('8902','2013-09-27','09:55:00',3.75),('8902','2013-09-27','10:00:00',4.91),('8902','2013-09-27','10:05:00',4.31),('8902','2013-09-27','10:10:00',3.69),('8902','2013-09-27','10:15:00',2.07),('8902','2013-09-27','10:20:00',2.16),('8902','2013-09-27','10:25:00',3.32),('8902','2013-09-27','10:30:00',2.18),('8902','2013-09-27','10:35:00',4.2),('8902','2013-09-27','10:40:00',5.55),('8902','2013-09-27','10:45:00',4.49),('8902','2013-09-27','10:50:00',4.55),('8902','2013-09-27','10:55:00',3.39),('8902','2013-09-27','11:00:00',6.94),('8902','2013-09-27','11:05:00',5.2),('8902','2013-09-27','11:10:00',4.23),('8902','2013-09-27','11:15:00',6.53),('8902','2013-09-27','11:20:00',2.8),('8902','2013-09-27','11:25:00',6.25),('8902','2013-09-27','11:30:00',6.87),('8902','2013-09-27','11:35:00',7.07),('8902','2013-09-27','11:40:00',6.94),('8902','2013-09-27','11:45:00',3.36),('8902','2013-09-27','11:50:00',3.09),('8902','2013-09-27','11:55:00',2.53),('8902','2013-09-27','12:00:00',5.72),('8902','2013-09-27','12:05:00',7.47),('8902','2013-09-27','12:10:00',6.2),('8902','2013-09-27','12:15:00',3.96),('8902','2013-09-27','12:20:00',5.65),('8902','2013-09-27','12:25:00',4.55),('8902','2013-09-27','12:30:00',1.78),('8902','2013-09-27','12:35:00',4.76),('8902','2013-09-27','12:40:00',3.31),('8902','2013-09-27','12:45:00',2.36),('8902','2013-09-27','12:50:00',6.9),('8902','2013-09-27','12:55:00',8.24),('8902','2013-09-27','13:00:00',8),('8902','2013-09-27','13:05:00',7.56),('8902','2013-09-27','13:10:00',4.08),('8902','2013-09-27','13:15:00',3),('8902','2013-09-27','13:20:00',3.12),('8902','2013-09-27','13:25:00',6.26),('8902','2013-09-27','13:30:00',7.33),('8902','2013-09-27','13:35:00',3.53),('8902','2013-09-27','13:40:00',3.52),('8902','2013-09-27','13:45:00',3.82),('8902','2013-09-27','13:50:00',4.3),('8902','2013-09-27','13:55:00',2.88),('8902','2013-09-27','14:00:00',4.36),('8902','2013-09-27','14:05:00',4.61),('8902','2013-09-27','14:10:00',3.33),('8902','2013-09-27','14:15:00',3.47),('8902','2013-09-27','14:20:00',6.06),('8902','2013-09-27','14:25:00',7.83),('8902','2013-09-27','14:30:00',7.17),('8902','2013-09-27','14:35:00',7.25),('8902','2013-09-27','14:40:00',7.49),('8902','2013-09-27','14:45:00',7.41),('8902','2013-09-27','14:50:00',6.96),('8902','2013-09-27','14:55:00',6.56),('8902','2013-09-27','15:00:00',6.91),('8902','2013-09-27','15:05:00',7.11),('8902','2013-09-27','15:10:00',6.72),('8902','2013-09-27','15:15:00',6.57),('8902','2013-09-27','15:20:00',6.77),('8902','2013-09-27','15:25:00',6.65),('8902','2013-09-27','15:30:00',6.42),('8902','2013-09-27','15:35:00',5.95),('8902','2013-09-27','15:40:00',6.03),('8902','2013-09-27','15:45:00',5.25),('8902','2013-09-27','15:50:00',3.57),('8902','2013-09-27','15:55:00',3.98),('8902','2013-09-27','16:00:00',5.33),('8902','2013-09-27','16:05:00',5.13),('8902','2013-09-27','16:10:00',5.29),('8902','2013-09-27','16:15:00',5.21),('8902','2013-09-27','16:20:00',4.78),('8902','2013-09-27','16:25:00',4.25),('8902','2013-09-27','16:30:00',3.92),('8902','2013-09-27','16:35:00',3.92),('8902','2013-09-27','16:40:00',3.81),('8902','2013-09-27','16:45:00',3.57),('8902','2013-09-27','16:50:00',3.4),('8902','2013-09-27','16:55:00',3.22),('8902','2013-09-27','17:00:00',3.07),('8902','2013-09-27','17:05:00',2.9),('8902','2013-09-27','17:10:00',2.69),('8902','2013-09-27','17:15:00',2.43),('8902','2013-09-27','17:20:00',2.33),('8902','2013-09-27','17:25:00',2.18),('8902','2013-09-27','17:30:00',2.02),('8902','2013-09-27','17:35:00',1.83),('8902','2013-09-27','17:40:00',1.65),('8902','2013-09-26','08:20:00',1.07),('8902','2013-09-26','08:25:00',1.65),('8902','2013-09-26','08:30:00',1.59),('8902','2013-09-26','08:35:00',1.84),('8902','2013-09-26','08:40:00',2.12),('8902','2013-09-26','08:45:00',1.87),('8902','2013-09-26','08:50:00',2),('8902','2013-09-26','08:55:00',2.64),('8902','2013-09-26','09:00:00',2.67),('8902','2013-09-26','09:05:00',2.42),('8902','2013-09-26','09:10:00',1.89),('8902','2013-09-26','09:15:00',1.86),('8902','2013-09-26','09:20:00',1.47),('8902','2013-09-26','09:25:00',1.81),('8902','2013-09-26','09:30:00',1.4),('8902','2013-09-26','09:35:00',1.46),('8902','2013-09-26','09:40:00',1.6),('8902','2013-09-26','09:45:00',1.54),('8902','2013-09-26','09:50:00',2.28),('8902','2013-09-26','09:55:00',4.59),('8902','2013-09-26','10:00:00',3.39),('8902','2013-09-26','10:05:00',4.24),('8902','2013-09-26','10:10:00',3.45),('8902','2013-09-26','10:15:00',3.53),('8902','2013-09-26','10:20:00',4.93),('8902','2013-09-26','10:25:00',3.94),('8902','2013-09-26','10:30:00',3.32),('8902','2013-09-26','10:35:00',3.2),('8902','2013-09-26','10:40:00',2.79),('8902','2013-09-26','10:45:00',3.16),('8902','2013-09-26','10:50:00',2.24),('8902','2013-09-26','10:55:00',4.26),('8902','2013-09-26','11:00:00',5.74),('8902','2013-09-26','11:05:00',5.06),('8902','2013-09-26','11:10:00',5.38),('8902','2013-09-26','11:15:00',3.35),('8902','2013-09-26','11:20:00',3.55),('8902','2013-09-26','11:25:00',2.94),('8902','2013-09-26','11:30:00',2.39),('8902','2013-09-26','11:35:00',2.01),('8902','2013-09-26','11:40:00',2.1),('8902','2013-09-26','11:45:00',2.79),('8902','2013-09-26','11:50:00',2.07),('8902','2013-09-26','11:55:00',2.01),('8902','2013-09-26','12:00:00',6.1),('8902','2013-09-26','12:05:00',5.52),('8902','2013-09-26','12:10:00',7.04),('8902','2013-09-26','12:15:00',5.69),('8902','2013-09-26','12:20:00',2.98),('8902','2013-09-26','12:25:00',2.35),('8902','2013-09-26','12:30:00',2.07),('8902','2013-09-26','12:35:00',2.15),('8902','2013-09-26','12:40:00',1.75),('8902','2013-09-26','12:45:00',1.88),('8902','2013-09-26','12:50:00',3.7),('8902','2013-09-26','12:55:00',7.2),('8902','2013-09-26','13:00:00',7.11),('8902','2013-09-26','13:05:00',7.01),('8902','2013-09-26','13:10:00',7.5),('8902','2013-09-26','13:15:00',6.3),('8902','2013-09-26','13:20:00',6.27),('8902','2013-09-26','13:25:00',5.22),('8902','2013-09-26','13:30:00',1.7),('8902','2013-09-26','13:35:00',1.72),('8902','2013-09-26','13:40:00',1.74),('8902','2013-09-26','13:45:00',2.55),('8902','2013-09-26','13:50:00',1.87),('8902','2013-09-26','13:55:00',1.97),('8902','2013-09-26','14:00:00',5.28),('8902','2013-09-26','14:05:00',3.59),('8902','2013-09-26','14:10:00',5.09),('8902','2013-09-26','14:15:00',7.27),('8902','2013-09-26','14:20:00',4.93),('8902','2013-09-26','14:25:00',7.03),('8902','2013-09-26','14:30:00',6.66),('8902','2013-09-26','14:35:00',6.6),('8902','2013-09-26','14:40:00',6.66),('8902','2013-09-26','14:45:00',6.61),('8902','2013-09-26','14:50:00',6.55),('8902','2013-09-26','14:55:00',5.39),('8902','2013-09-26','15:00:00',6.52),('8902','2013-09-26','15:05:00',5.33),('8902','2013-09-26','15:10:00',4.24),('8902','2013-09-26','15:15:00',6.18),('8902','2013-09-26','15:20:00',5.67),('8902','2013-09-26','15:25:00',5.72),('8902','2013-09-26','15:30:00',5.86),('8902','2013-09-26','15:35:00',5.71),('8902','2013-09-26','15:40:00',5.64),('8902','2013-09-26','15:45:00',5.19),('8902','2013-09-26','15:50:00',5.52),('8902','2013-09-26','15:55:00',5.35),('8902','2013-09-26','16:00:00',4.84),('8902','2013-09-26','16:05:00',4.29),('8902','2013-09-26','16:10:00',1.85),('8902','2013-09-26','16:15:00',4.4),('8902','2013-09-26','16:20:00',3.92),('8902','2013-09-26','16:25:00',4.37),('8902','2013-09-26','16:30:00',4.16),('8902','2013-09-26','16:35:00',3.8),('8902','2013-09-26','16:40:00',3.92),('8902','2013-09-26','16:45:00',3.76),('8902','2013-09-26','16:50:00',3.49),('8902','2013-09-26','16:55:00',2.32),('8902','2013-09-26','17:00:00',2),('8902','2013-09-26','17:05:00',1.31),('8902','2013-09-26','17:10:00',1.82),('8902','2013-09-26','17:15:00',2.79),('8902','2013-09-26','17:20:00',2.56),('8902','2013-09-26','17:25:00',2.39),('8902','2013-09-26','17:30:00',2.24),('8902','2013-09-26','17:35:00',1.97),('8902','2013-09-26','17:40:00',1.66),('8902','2013-09-26','17:45:00',1.49),('8902','2013-09-26','17:50:00',1.4),('8902','2013-09-26','17:55:00',1.23),('8902','2013-09-26','18:00:00',1.05),('8902','2013-09-25','08:10:00',1.12),('8902','2013-09-25','08:15:00',1.3),('8902','2013-09-25','08:25:00',1.54),('8902','2013-09-25','08:30:00',1.55),('8902','2013-09-25','08:35:00',1.41),('8902','2013-09-25','08:40:00',2.06),('8902','2013-09-25','08:45:00',2.17),('8902','2013-09-25','08:50:00',2.37),('8902','2013-09-25','08:55:00',2.53),('8902','2013-09-25','09:00:00',2.73),('8902','2013-09-25','09:05:00',2.87),('8902','2013-09-25','09:10:00',3.07),('8902','2013-09-25','09:15:00',3.26),('8902','2013-09-25','09:20:00',3.45),('8902','2013-09-25','09:25:00',3.6),('8902','2013-09-25','09:30:00',3.76),('8902','2013-09-25','09:35:00',3.91),('8902','2013-09-25','09:40:00',4.09),('8902','2013-09-25','09:45:00',4.27),('8902','2013-09-25','09:50:00',3.84),('8902','2013-09-25','09:55:00',4.48),('8902','2013-09-25','10:00:00',4.65),('8902','2013-09-25','10:05:00',4.8),('8902','2013-09-25','10:10:00',4.92),('8902','2013-09-25','10:15:00',4.98),('8902','2013-09-25','10:20:00',5.16),('8902','2013-09-25','10:25:00',5.1),('8902','2013-09-25','10:30:00',5.25),('8902','2013-09-25','10:35:00',5.35),('8902','2013-09-25','10:40:00',5.43),('8902','2013-09-25','10:45:00',5.75),('8902','2013-09-25','10:50:00',5.73),('8902','2013-09-25','10:55:00',5.82),('8902','2013-09-25','11:00:00',5.83),('8902','2013-09-25','11:05:00',5.85),('8902','2013-09-25','11:10:00',5.99),('8902','2013-09-25','11:15:00',5.56),('8902','2013-09-25','11:20:00',5.79),('8902','2013-09-25','11:25:00',6.29),('8902','2013-09-25','11:30:00',6.38),('8902','2013-09-25','11:35:00',6.53),('8902','2013-09-25','11:40:00',5.68),('8902','2013-09-25','11:45:00',6.4),('8902','2013-09-25','11:50:00',6.62),('8902','2013-09-25','11:55:00',5.39),('8902','2013-09-25','12:00:00',6.21),('8902','2013-09-25','12:05:00',5.6),('8902','2013-09-25','12:10:00',3.47),('8902','2013-09-25','12:15:00',2.72),('8902','2013-09-25','12:20:00',3.28),('8902','2013-09-25','12:25:00',2.79),('8902','2013-09-25','12:30:00',2.51),('8902','2013-09-25','12:35:00',2.49),('8902','2013-09-25','12:40:00',2.72),('8902','2013-09-25','12:45:00',3.24),('8902','2013-09-25','12:50:00',3.16),('8902','2013-09-25','12:55:00',4.12),('8902','2013-09-25','13:00:00',6.02),('8902','2013-09-25','13:05:00',5.36),('8902','2013-09-25','13:10:00',3.32),('8902','2013-09-25','13:15:00',5.15),('8902','2013-09-25','13:20:00',6.96),('8902','2013-09-25','13:25:00',8),('8902','2013-09-25','13:30:00',3.77),('8902','2013-09-25','13:35:00',3.57),('8902','2013-09-25','13:40:00',3.18),('8902','2013-09-25','13:45:00',2.63),('8902','2013-09-25','13:50:00',2.71),('8902','2013-09-25','13:55:00',4.37),('8902','2013-09-25','14:00:00',4.58),('8902','2013-09-25','14:05:00',5.55),('8902','2013-09-25','14:10:00',6.6),('8902','2013-09-25','14:15:00',7.3),('8902','2013-09-25','14:20:00',5.82),('8902','2013-09-25','14:25:00',1.84),('8902','2013-09-25','14:30:00',1.85),('8902','2013-09-25','14:35:00',5.31),('8902','2013-09-25','14:40:00',3.59),('8902','2013-09-25','14:45:00',5.1),('8902','2013-09-25','14:50:00',7.83),('8902','2013-09-25','14:55:00',7.13),('8902','2013-09-25','15:00:00',3.15),('8902','2013-09-25','15:05:00',3.33),('8902','2013-09-25','15:10:00',4.37),('8902','2013-09-25','15:15:00',2.7),('8902','2013-09-25','15:20:00',3.62),('8902','2013-09-25','15:25:00',6),('8902','2013-09-25','15:30:00',1.53),('8902','2013-09-25','15:35:00',3.15),('8902','2013-09-25','15:40:00',4.37),('8902','2013-09-25','15:45:00',3.18),('8902','2013-09-25','15:50:00',4.46),('8902','2013-09-25','15:55:00',5.63),('8902','2013-09-25','16:00:00',5.23),('8902','2013-09-25','16:05:00',5.05),('8902','2013-09-25','16:10:00',4.96),('8902','2013-09-25','16:15:00',4.77),('8902','2013-09-25','16:20:00',4.63),('8902','2013-09-25','16:25:00',4.39),('8902','2013-09-25','16:30:00',4.3),('8902','2013-09-25','16:35:00',4.1),('8902','2013-09-25','16:40:00',3.97),('8902','2013-09-25','16:45:00',3.74),('8902','2013-09-25','16:50:00',3.56),('8902','2013-09-25','16:55:00',3.41),('8902','2013-09-25','17:00:00',3.2),('8902','2013-09-25','17:05:00',3.16),('8902','2013-09-25','17:10:00',3.01),('8902','2013-09-25','17:15:00',2.71),('8902','2013-09-25','17:20:00',2.59),('8902','2013-09-25','17:25:00',2.43),('8902','2013-09-25','17:30:00',2.04),('8902','2013-09-25','17:35:00',2.01),('8902','2013-09-25','17:40:00',1.91),('8902','2013-09-25','17:45:00',1.71),('8902','2013-09-25','17:50:00',1.5),('8902','2013-09-25','17:55:00',1.22),('8902','2013-09-25','18:00:00',1.02),('8902','2013-09-24','08:10:00',1.04),('8902','2013-09-24','08:15:00',1.11),('8902','2013-09-24','08:20:00',1.05),('8902','2013-09-24','08:25:00',1.26),('8902','2013-09-24','08:30:00',1.27),('8902','2013-09-24','08:35:00',1.13),('8902','2013-09-24','08:45:00',2.32),('8902','2013-09-24','08:50:00',2.48),('8902','2013-09-24','08:55:00',1.25),('8902','2013-09-24','09:00:00',1.24),('8902','2013-09-24','09:05:00',1.56),('8902','2013-09-24','09:10:00',2.25),('8902','2013-09-24','09:15:00',2.42),('8902','2013-09-24','09:20:00',1.72),('8902','2013-09-24','09:25:00',2.44),('8902','2013-09-24','09:30:00',2.93),('8902','2013-09-24','09:35:00',3.67),('8902','2013-09-24','09:40:00',3.83),('8902','2013-09-24','09:45:00',3.35),('8902','2013-09-24','09:50:00',4.25),('8902','2013-09-24','09:55:00',4.14),('8902','2013-09-24','10:00:00',4.77),('8902','2013-09-24','10:05:00',3.52),('8902','2013-09-24','10:10:00',1.76),('8902','2013-09-24','10:15:00',1.45),('8902','2013-09-24','10:20:00',2.19),('8902','2013-09-24','10:25:00',2.43),('8902','2013-09-24','10:30:00',1.8),('8902','2013-09-24','10:35:00',1.39),('8902','2013-09-24','10:40:00',1.32),('8902','2013-09-24','10:45:00',2.99),('8902','2013-09-24','10:50:00',5.12),('8902','2013-09-24','10:55:00',7.06),('8902','2013-09-24','11:00:00',6.77),('8902','2013-09-24','11:05:00',6.5),('8902','2013-09-24','11:10:00',5.98),('8902','2013-09-24','11:15:00',2.65),('8902','2013-09-24','11:20:00',1.73),('8902','2013-09-24','11:25:00',3.04),('8902','2013-09-24','11:30:00',7.08),('8902','2013-09-24','11:35:00',6.98),('8902','2013-09-24','11:40:00',6.84),('8902','2013-09-24','11:45:00',6.83),('8902','2013-09-24','11:50:00',4.24),('8902','2013-09-24','11:55:00',2.17),('8902','2013-09-24','12:00:00',1.83),('8902','2013-09-24','12:05:00',1.6),('8902','2013-09-24','12:10:00',1.92),('8902','2013-09-24','12:15:00',2.18),('8902','2013-09-24','12:20:00',4.72),('8902','2013-09-24','12:25:00',3.14),('8902','2013-09-24','12:30:00',2.22),('8902','2013-09-24','12:35:00',3.7),('8902','2013-09-24','12:40:00',5.9),('8902','2013-09-24','12:45:00',3.71),('8902','2013-09-24','12:50:00',2.03),('8902','2013-09-24','12:55:00',1.49),('8902','2013-09-24','13:00:00',1.66),('8902','2013-09-24','13:05:00',1.82),('8902','2013-09-24','13:10:00',1.84),('8902','2013-09-24','13:15:00',1.77),('8902','2013-09-24','13:20:00',1.99),('8902','2013-09-24','13:25:00',2.01),('8902','2013-09-24','13:30:00',3),('8902','2013-09-24','13:35:00',4.11),('8902','2013-09-24','13:40:00',7.89),('8902','2013-09-24','13:45:00',8.27),('8902','2013-09-24','13:50:00',8.5),('8902','2013-09-24','13:55:00',8.39),('8902','2013-09-24','14:00:00',2.2),('8902','2013-09-24','14:05:00',1.79),('8902','2013-09-24','14:10:00',1.97),('8902','2013-09-24','14:15:00',2.58),('8902','2013-09-24','14:20:00',1.76),('8902','2013-09-24','14:25:00',1.8),('8902','2013-09-24','14:30:00',5.97),('8902','2013-09-24','14:35:00',8.04),('8902','2013-09-24','14:40:00',8.17),('8902','2013-09-24','14:45:00',4.49),('8902','2013-09-24','14:50:00',5.76),('8902','2013-09-24','14:55:00',7.87),('8902','2013-09-24','15:00:00',6.71),('8902','2013-09-24','15:05:00',6.38),('8902','2013-09-24','15:10:00',6.87),('8902','2013-09-24','15:15:00',6.8),('8902','2013-09-24','15:20:00',6.6),('8902','2013-09-24','15:25:00',5.97),('8902','2013-09-24','15:30:00',6.43),('8902','2013-09-24','15:35:00',5.98),('8902','2013-09-24','15:40:00',6.5),('8902','2013-09-24','15:45:00',5.79),('8902','2013-09-24','15:50:00',5.81),('8902','2013-09-24','15:55:00',5.79),('8902','2013-09-24','16:00:00',5.59),('8902','2013-09-24','16:05:00',5.43),('8902','2013-09-24','16:10:00',5.23),('8902','2013-09-24','16:15:00',4.9),('8902','2013-09-24','16:20:00',4.93),('8902','2013-09-24','16:25:00',4.65),('8902','2013-09-24','16:30:00',4.59),('8902','2013-09-24','16:35:00',4.39),('8902','2013-09-24','16:40:00',4.25),('8902','2013-09-24','16:45:00',4.07),('8902','2013-09-24','16:50:00',3.85),('8902','2013-09-24','16:55:00',3.66),('8902','2013-09-24','17:00:00',3.55),('8902','2013-09-24','17:05:00',3.38),('8902','2013-09-24','17:10:00',3.23),('8902','2013-09-24','17:15:00',2.97),('8902','2013-09-24','17:20:00',2.76),('8902','2013-09-24','17:25:00',2.59),('8902','2013-09-24','17:30:00',2.43),('8902','2013-09-24','17:35:00',2.22),('8902','2013-09-24','17:40:00',2),('8902','2013-09-24','17:45:00',1.82),('8902','2013-09-24','17:50:00',1.62),('8902','2013-09-24','17:55:00',1.44),('8902','2013-09-24','18:00:00',1.27),('8902','2013-09-24','18:05:00',1.09),('8902','2013-09-23','08:10:00',1.13),('8902','2013-09-23','08:15:00',1.3),('8902','2013-09-23','08:20:00',1.46),('8902','2013-09-23','08:25:00',1.6),('8902','2013-09-23','08:30:00',1.78),('8902','2013-09-23','08:35:00',1.96),('8902','2013-09-23','08:40:00',2.14),('8902','2013-09-23','08:45:00',2.34),('8902','2013-09-23','08:50:00',2.51),('8902','2013-09-23','08:55:00',2.67),('8902','2013-09-23','09:00:00',2.87),('8902','2013-09-23','09:05:00',3.07),('8902','2013-09-23','09:10:00',3.25),('8902','2013-09-23','09:15:00',3.43),('8902','2013-09-23','09:20:00',3.62),('8902','2013-09-23','09:25:00',3.79),('8902','2013-09-23','09:30:00',3.98),('8902','2013-09-23','09:35:00',4.16),('8902','2013-09-23','09:40:00',4.31),('8902','2013-09-23','09:45:00',4.44),('8902','2013-09-23','09:50:00',4.58),('8902','2013-09-23','09:55:00',4.72),('8902','2013-09-23','10:00:00',4.87),('8902','2013-09-23','10:05:00',4.95),('8902','2013-09-23','10:10:00',5.1),('8902','2013-09-23','10:15:00',5.26),('8902','2013-09-23','10:20:00',5.4),('8902','2013-09-23','10:25:00',5.52),('8902','2013-09-23','10:30:00',5.64),('8902','2013-09-23','10:35:00',5.73),('8902','2013-09-23','10:40:00',5.84),('8902','2013-09-23','10:45:00',5.94),('8902','2013-09-23','10:50:00',6.04),('8902','2013-09-23','10:55:00',6.14),('8902','2013-09-23','11:00:00',6.21),('8902','2013-09-23','11:05:00',6.29),('8902','2013-09-23','11:10:00',6.36),('8902','2013-09-23','11:15:00',6.4),('8902','2013-09-23','11:20:00',6.47),('8902','2013-09-23','11:25:00',6.57),('8902','2013-09-23','11:30:00',6.64),('8902','2013-09-23','11:35:00',6.69),('8902','2013-09-23','11:40:00',6.72),('8902','2013-09-23','11:45:00',6.8),('8902','2013-09-23','11:50:00',6.87),('8902','2013-09-23','11:55:00',6.94),('8902','2013-09-23','12:00:00',6.96),('8902','2013-09-23','12:05:00',6.97),('8902','2013-09-23','12:10:00',7.01),('8902','2013-09-23','12:15:00',7.05),('8902','2013-09-23','12:20:00',7.02),('8902','2013-09-23','12:25:00',7.05),('8902','2013-09-23','12:30:00',7.02),('8902','2013-09-23','12:35:00',6.97),('8902','2013-09-23','12:40:00',7.2),('8902','2013-09-23','12:45:00',7.21),('8902','2013-09-23','12:50:00',7.26),('8902','2013-09-23','12:55:00',7.29),('8902','2013-09-23','13:00:00',7.25),('8902','2013-09-23','13:05:00',7.26),('8902','2013-09-23','13:10:00',7.27),('8902','2013-09-23','13:15:00',7.26),('8902','2013-09-23','13:20:00',7.26),('8902','2013-09-23','13:25:00',7.24),('8902','2013-09-23','13:30:00',7.22),('8902','2013-09-23','13:35:00',7.16),('8902','2013-09-23','13:40:00',7.3),('8902','2013-09-23','13:45:00',7.3),('8902','2013-09-23','13:50:00',7.22),('8902','2013-09-23','13:55:00',7.19),('8902','2013-09-23','14:00:00',7.14),('8902','2013-09-23','14:05:00',7.11),('8902','2013-09-23','14:10:00',7.05),('8902','2013-09-23','14:15:00',7.01),('8902','2013-09-23','14:20:00',7),('8902','2013-09-23','14:25:00',6.99),('8902','2013-09-23','14:30:00',6.88),('8902','2013-09-23','14:35:00',6.77),('8902','2013-09-23','14:40:00',6.76),('8902','2013-09-23','14:45:00',6.69),('8902','2013-09-23','14:50:00',6.63),('8902','2013-09-23','14:55:00',6.63),('8902','2013-09-23','15:00:00',6.45),('8902','2013-09-23','15:05:00',6.44),('8902','2013-09-23','15:10:00',6.35),('8902','2013-09-23','15:15:00',6.21),('8902','2013-09-23','15:20:00',6.23),('8902','2013-09-23','15:25:00',6.2),('8902','2013-09-23','15:30:00',6.11),('8902','2013-09-23','15:35:00',6.01),('8902','2013-09-23','15:40:00',5.88),('8902','2013-09-23','15:45:00',5.8),('8902','2013-09-23','15:50:00',5.69),('8902','2013-09-23','15:55:00',5.56),('8902','2013-09-23','16:00:00',5.43),('8902','2013-09-23','16:05:00',5.31),('8902','2013-09-23','16:10:00',5.08),('8902','2013-09-23','16:15:00',4.99),('8902','2013-09-23','16:20:00',4.91),('8902','2013-09-23','16:25:00',4.7),('8902','2013-09-23','16:30:00',4.58),('8902','2013-09-23','16:35:00',4.35),('8902','2013-09-23','16:40:00',4.21),('8902','2013-09-23','16:45:00',4.08),('8902','2013-09-23','16:50:00',3.9),('8902','2013-09-23','16:55:00',3.81),('8902','2013-09-23','17:00:00',3.65),('8902','2013-09-23','17:05:00',3.46),('8902','2013-09-23','17:10:00',3.3),('8902','2013-09-23','17:15:00',3.03),('8902','2013-09-23','17:20:00',2.85),('8902','2013-09-23','17:25:00',2.67),('8902','2013-09-23','17:30:00',2.45),('8902','2013-09-23','17:35:00',2.2),('8902','2013-09-23','17:40:00',1.93),('8902','2013-09-23','17:45:00',1.79),('8902','2013-09-23','17:50:00',1.59),('8902','2013-09-23','17:55:00',1.4),('8902','2013-09-23','18:00:00',1.23),('8902','2013-09-23','18:05:00',1.09),('8902','2013-09-22','08:05:00',1.03),('8902','2013-09-22','08:10:00',1.19),('8902','2013-09-22','08:15:00',1.35),('8902','2013-09-22','08:20:00',1.52),('8902','2013-09-22','08:25:00',1.68),('8902','2013-09-22','08:30:00',1.84),('8902','2013-09-22','08:35:00',2.04),('8902','2013-09-22','08:40:00',2.23),('8902','2013-09-22','08:45:00',2.41),('8902','2013-09-22','08:50:00',2.61),('8902','2013-09-22','08:55:00',2.77),('8902','2013-09-22','09:00:00',2.95),('8902','2013-09-22','09:05:00',3.15),('8902','2013-09-22','09:10:00',3.35),('8902','2013-09-22','09:15:00',3.53),('8902','2013-09-22','09:20:00',3.72),('8902','2013-09-22','09:25:00',3.9),('8902','2013-09-22','09:30:00',4.08),('8902','2013-09-22','09:35:00',4.24),('8902','2013-09-22','09:40:00',4.4),('8902','2013-09-22','09:45:00',4.53),('8902','2013-09-22','09:50:00',4.67),('8902','2013-09-22','09:55:00',4.83),('8902','2013-09-22','10:00:00',4.96),('8902','2013-09-22','10:05:00',4.58),('8902','2013-09-22','10:10:00',5.22),('8902','2013-09-22','10:15:00',5.34),('8902','2013-09-22','10:20:00',5.46),('8902','2013-09-22','10:25:00',5.57),('8902','2013-09-22','10:30:00',5.68),('8902','2013-09-22','10:35:00',5.81),('8902','2013-09-22','10:40:00',5.91),('8902','2013-09-22','10:45:00',6.01),('8902','2013-09-22','10:50:00',6.11),('8902','2013-09-22','10:55:00',6.21),('8902','2013-09-22','11:00:00',6.31),('8902','2013-09-22','11:05:00',6.43),('8902','2013-09-22','11:10:00',6.53),('8902','2013-09-22','11:15:00',6.65),('8902','2013-09-22','11:20:00',6.7),('8902','2013-09-22','11:25:00',6.78),('8902','2013-09-22','11:30:00',6.87),('8902','2013-09-22','11:35:00',6.93),('8902','2013-09-22','11:40:00',7.02),('8902','2013-09-22','11:45:00',7.07),('8902','2013-09-22','11:50:00',7.08),('8902','2013-09-22','11:55:00',7.14),('8902','2013-09-22','12:00:00',7.24),('8902','2013-09-22','12:05:00',7.35),('8902','2013-09-22','12:10:00',7.43),('8902','2013-09-22','12:15:00',7.45),('8902','2013-09-22','12:20:00',7.44),('8902','2013-09-22','12:25:00',7.43),('8902','2013-09-22','12:30:00',7.38),('8902','2013-09-22','12:35:00',7.39),('8902','2013-09-22','12:40:00',7.43),('8902','2013-09-22','12:45:00',7.44),('8902','2013-09-22','12:50:00',7.43),('8902','2013-09-22','12:55:00',7.51),('8902','2013-09-22','13:00:00',7.51),('8902','2013-09-22','13:05:00',7.47),('8902','2013-09-22','13:10:00',7.45),('8902','2013-09-22','13:15:00',7.43),('8902','2013-09-22','13:20:00',7.38),('8902','2013-09-22','13:25:00',7.45),('8902','2013-09-22','13:30:00',7.46),('8902','2013-09-22','13:35:00',7.46),('8902','2013-09-22','13:40:00',7.46),('8902','2013-09-22','13:45:00',7.4),('8902','2013-09-22','13:50:00',7.36),('8902','2013-09-22','13:55:00',7.33),('8902','2013-09-22','14:00:00',7.22),('8902','2013-09-22','14:05:00',7.13),('8902','2013-09-22','14:10:00',7.16),('8902','2013-09-22','14:15:00',7.17),('8902','2013-09-22','14:20:00',7),('8902','2013-09-22','14:25:00',7.05),('8902','2013-09-22','14:30:00',7.25),('8902','2013-09-22','14:35:00',6.7),('8902','2013-09-22','14:40:00',6.96),('8902','2013-09-22','14:45:00',6.82),('8902','2013-09-22','14:50:00',6.76),('8902','2013-09-22','14:55:00',6.71),('8902','2013-09-22','15:00:00',6.47),('8902','2013-09-22','15:05:00',6.63),('8902','2013-09-22','15:10:00',5.86),('8902','2013-09-22','15:15:00',6.43),('8902','2013-09-22','15:20:00',6.24),('8902','2013-09-22','15:25:00',6.12),('8902','2013-09-22','15:30:00',6.05),('8902','2013-09-22','15:35:00',5.9),('8902','2013-09-22','15:40:00',5.79),('8902','2013-09-22','15:45:00',5.63),('8902','2013-09-22','15:50:00',5.64),('8902','2013-09-22','15:55:00',5.28),('8902','2013-09-22','16:00:00',4.71),('8902','2013-09-22','16:05:00',5.26),('8902','2013-09-22','16:10:00',1.65),('8902','2013-09-22','16:15:00',5.05),('8902','2013-09-22','16:20:00',3.21),('8902','2013-09-22','16:25:00',4.88),('8902','2013-09-22','16:30:00',2.61),('8902','2013-09-22','16:35:00',4.01),('8902','2013-09-22','16:40:00',4.15),('8902','2013-09-22','16:45:00',4.02),('8902','2013-09-22','16:50:00',3.73),('8902','2013-09-22','16:55:00',3.63),('8902','2013-09-22','17:00:00',3.5),('8902','2013-09-22','17:05:00',3.35),('8902','2013-09-22','17:10:00',3.19),('8902','2013-09-22','17:15:00',2.96),('8902','2013-09-22','17:20:00',2.77),('8902','2013-09-22','17:25:00',2.6),('8902','2013-09-22','17:30:00',2.44),('8902','2013-09-22','17:35:00',2.28),('8902','2013-09-22','17:40:00',2.05),('8902','2013-09-22','17:45:00',1.85),('8902','2013-09-22','17:50:00',1.6),('8902','2013-09-22','17:55:00',1.39),('8902','2013-09-22','18:00:00',1.24),('8902','2013-09-22','18:05:00',1.09),('8902','2013-09-21','08:05:00',1.13),('8902','2013-09-21','08:10:00',1.32),('8902','2013-09-21','08:15:00',1.15),('8902','2013-09-21','08:20:00',1.54),('8902','2013-09-21','08:25:00',1.73),('8902','2013-09-21','08:30:00',1.85),('8902','2013-09-21','08:35:00',2),('8902','2013-09-21','08:40:00',2.16),('8902','2013-09-21','08:45:00',2.35),('8902','2013-09-21','08:50:00',2.51),('8902','2013-09-21','08:55:00',2.71),('8902','2013-09-21','09:00:00',2.9),('8902','2013-09-21','09:05:00',3.07),('8902','2013-09-21','09:10:00',3.29),('8902','2013-09-21','09:15:00',3.48),('8902','2013-09-21','09:20:00',3.66),('8902','2013-09-21','09:25:00',3.86),('8902','2013-09-21','09:30:00',4.04),('8902','2013-09-21','09:35:00',4.21),('8902','2013-09-21','09:40:00',4.34),('8902','2013-09-21','09:45:00',4.51),('8902','2013-09-21','09:50:00',4.68),('8902','2013-09-21','09:55:00',4.83),('8902','2013-09-21','10:00:00',4.96),('8902','2013-09-21','10:05:00',5.11),('8902','2013-09-21','10:10:00',5.24),('8902','2013-09-21','10:15:00',5.38),('8902','2013-09-21','10:20:00',5.51),('8902','2013-09-21','10:25:00',5.64),('8902','2013-09-21','10:30:00',5.78),('8902','2013-09-21','10:35:00',5.9),('8902','2013-09-21','10:40:00',6.01),('8902','2013-09-21','10:45:00',6.11),('8902','2013-09-21','10:50:00',6.22),('8902','2013-09-21','10:55:00',6.29),('8902','2013-09-21','11:00:00',6.38),('8902','2013-09-21','11:05:00',6.48),('8902','2013-09-21','11:10:00',6.56),('8902','2013-09-21','11:15:00',6.67),('8902','2013-09-21','11:20:00',6.72),('8902','2013-09-21','11:25:00',6.79),('8902','2013-09-21','11:30:00',6.91),('8902','2013-09-21','11:35:00',7.03),('8902','2013-09-21','11:40:00',7.15),('8902','2013-09-21','11:45:00',7.22),('8902','2013-09-21','11:50:00',7.26),('8902','2013-09-21','11:55:00',7.36),('8902','2013-09-21','12:00:00',7.43),('8902','2013-09-21','12:05:00',7.47),('8902','2013-09-21','12:10:00',7.51),('8902','2013-09-21','12:15:00',7.52),('8902','2013-09-21','12:20:00',7.55),('8902','2013-09-21','12:25:00',7.61),('8902','2013-09-21','12:30:00',7.61),('8902','2013-09-21','12:35:00',7.63),('8902','2013-09-21','12:40:00',7.7),('8902','2013-09-21','12:45:00',7.62),('8902','2013-09-21','12:50:00',7.75),('8902','2013-09-21','12:55:00',7.84),('8902','2013-09-21','13:00:00',7.79),('8902','2013-09-21','13:05:00',7.76),('8902','2013-09-21','13:10:00',7.55),('8902','2013-09-21','13:15:00',7.17),('8902','2013-09-21','13:20:00',7.67),('8902','2013-09-21','13:25:00',7.63),('8902','2013-09-21','13:30:00',7.59),('8902','2013-09-21','13:35:00',7.61),('8902','2013-09-21','13:40:00',7.61),('8902','2013-09-21','13:45:00',7.59),('8902','2013-09-21','13:50:00',7.61),('8902','2013-09-21','13:55:00',7.4),('8902','2013-09-21','14:00:00',7.45),('8902','2013-09-21','14:05:00',7.53),('8902','2013-09-21','14:10:00',7.55),('8902','2013-09-21','14:15:00',7.52),('8902','2013-09-21','14:20:00',6.24),('8902','2013-09-21','14:25:00',7.3),('8902','2013-09-21','14:30:00',7.77),('8902','2013-09-21','14:35:00',7.3),('8902','2013-09-21','14:40:00',5.02),('8902','2013-09-21','14:45:00',6.66),('8902','2013-09-21','14:50:00',7.16),('8902','2013-09-21','14:55:00',7.09),('8902','2013-09-21','15:00:00',7.1),('8902','2013-09-21','15:05:00',7.22),('8902','2013-09-21','15:10:00',7.07),('8902','2013-09-21','15:15:00',7.23),('8902','2013-09-21','15:20:00',7.49),('8902','2013-09-21','15:25:00',4.67),('8902','2013-09-21','15:30:00',1.93),('8902','2013-09-21','15:35:00',1.95),('8902','2013-09-21','15:40:00',5.15),('8902','2013-09-21','15:45:00',6.32),('8902','2013-09-21','15:50:00',6.11),('8902','2013-09-21','15:55:00',6),('8902','2013-09-21','16:00:00',6.41),('8902','2013-09-21','16:05:00',6.4),('8902','2013-09-21','16:10:00',6.32),('8902','2013-09-21','16:15:00',6.23),('8902','2013-09-21','16:20:00',4.07),('8902','2013-09-21','16:25:00',3.01),('8902','2013-09-21','16:30:00',2.65),('8902','2013-09-21','16:35:00',1.85),('8902','2013-09-21','16:40:00',2.11),('8902','2013-09-21','16:45:00',4.1),('8902','2013-09-21','16:50:00',3.45),('8902','2013-09-21','16:55:00',3.39),('8902','2013-09-21','17:00:00',2.31),('8902','2013-09-21','17:05:00',3.8),('8902','2013-09-21','17:10:00',2.99),('8902','2013-09-21','17:15:00',2.48),('8902','2013-09-21','17:30:00',1.13),('8902','2013-09-21','17:35:00',1.94),('8902','2013-09-21','17:40:00',1.45),('8902','2013-09-21','18:00:00',1.12),('8902','2013-09-20','08:05:00',1.05),('8902','2013-09-20','08:10:00',1.21),('8902','2013-09-20','08:15:00',1.35),('8902','2013-09-20','08:20:00',1.51),('8902','2013-09-20','08:25:00',1.66),('8902','2013-09-20','08:30:00',1.83),('8902','2013-09-20','08:35:00',1.99),('8902','2013-09-20','08:40:00',2.18),('8902','2013-09-20','08:45:00',2.35),('8902','2013-09-20','08:50:00',2.52),('8902','2013-09-20','08:55:00',2.71),('8902','2013-09-20','09:00:00',2.89),('8902','2013-09-20','09:05:00',3.06),('8902','2013-09-20','09:10:00',3.23),('8902','2013-09-20','09:15:00',3.4),('8902','2013-09-20','09:20:00',3.57),('8902','2013-09-20','09:25:00',3.76),('8902','2013-09-20','09:30:00',3.93),('8902','2013-09-20','09:35:00',4.12),('8902','2013-09-20','09:40:00',4.28),('8902','2013-09-20','09:45:00',4.44),('8902','2013-09-20','09:50:00',4.59),('8902','2013-09-20','09:55:00',4.7),('8902','2013-09-20','10:00:00',4.85),('8902','2013-09-20','10:05:00',5),('8902','2013-09-20','10:10:00',5.15),('8902','2013-09-20','10:15:00',5.28),('8902','2013-09-20','10:20:00',5.4),('8902','2013-09-20','10:25:00',5.51),('8902','2013-09-20','10:30:00',5.6),('8902','2013-09-20','10:35:00',5.69),('8902','2013-09-20','10:40:00',5.82),('8902','2013-09-20','10:45:00',5.93),('8902','2013-09-20','10:50:00',6.03),('8902','2013-09-20','10:55:00',6.16),('8902','2013-09-20','11:00:00',6.26),('8902','2013-09-20','11:05:00',6.31),('8902','2013-09-20','11:10:00',6.42),('8902','2013-09-20','11:15:00',6.52),('8902','2013-09-20','11:20:00',6.62),('8902','2013-09-20','11:25:00',6.69),('8902','2013-09-20','11:30:00',6.77),('8902','2013-09-20','11:35:00',6.79),('8902','2013-09-20','11:40:00',6.86),('8902','2013-09-20','11:45:00',6.95),('8902','2013-09-20','11:50:00',7),('8902','2013-09-20','11:55:00',6.93),('8902','2013-09-20','12:00:00',7.07),('8902','2013-09-20','12:05:00',7.19),('8902','2013-09-20','12:10:00',7.21),('8902','2013-09-20','12:15:00',7.21),('8902','2013-09-20','12:20:00',7.26),('8902','2013-09-20','12:25:00',6.49),('8902','2013-09-20','12:30:00',7.49),('8902','2013-09-20','12:35:00',7.4),('8902','2013-09-20','12:40:00',6.88),('8902','2013-09-20','12:45:00',7.15),('8902','2013-09-20','12:50:00',7.32),('8902','2013-09-20','12:55:00',7.44),('8902','2013-09-20','13:00:00',7.45),('8902','2013-09-20','13:05:00',7.26),('8902','2013-09-20','13:10:00',7.47),('8902','2013-09-20','13:15:00',7.61),('8902','2013-09-20','13:20:00',6.35),('8902','2013-09-20','13:25:00',7.1),('8902','2013-09-20','13:30:00',7.22),('8902','2013-09-20','13:35:00',7.29),('8902','2013-09-20','13:40:00',6.47),('8902','2013-09-20','13:45:00',6.4),('8902','2013-09-20','13:50:00',6.69),('8902','2013-09-20','13:55:00',6.78),('8902','2013-09-20','14:00:00',6.84),('8902','2013-09-20','14:05:00',7.26),('8902','2013-09-20','14:10:00',6.93),('8902','2013-09-20','14:15:00',7.27),('8902','2013-09-20','14:20:00',7.25),('8902','2013-09-20','14:25:00',7.14),('8902','2013-09-20','14:30:00',7.06),('8902','2013-09-20','14:35:00',6.98),('8902','2013-09-20','14:40:00',6.91),('8902','2013-09-20','14:45:00',6.82),('8902','2013-09-20','14:50:00',6.77),('8902','2013-09-20','14:55:00',6.69),('8902','2013-09-20','15:00:00',6.61),('8902','2013-09-20','15:05:00',6.54),('8902','2013-09-20','15:10:00',6.36),('8902','2013-09-20','15:15:00',6.35),('8902','2013-09-20','15:20:00',6.32),('8902','2013-09-20','15:25:00',6.21),('8902','2013-09-20','15:30:00',6.1),('8902','2013-09-20','15:35:00',6),('8902','2013-09-20','15:40:00',5.56),('8902','2013-09-20','15:45:00',4.09),('8902','2013-09-20','15:50:00',5.44),('8902','2013-09-20','15:55:00',5.6),('8902','2013-09-20','16:00:00',4.39),('8902','2013-09-20','16:05:00',2.89),('8902','2013-09-20','16:10:00',3.39),('8902','2013-09-20','16:15:00',2.83),('8902','2013-09-20','16:20:00',3.71),('8902','2013-09-20','16:25:00',1.68),('8902','2013-09-20','16:30:00',2.33),('8902','2013-09-20','16:35:00',2.97),('8902','2013-09-20','16:40:00',2.17),('8902','2013-09-20','16:45:00',1.7),('8902','2013-09-20','16:50:00',1.76),('8902','2013-09-20','16:55:00',2.15),('8902','2013-09-20','17:00:00',1.78),('8902','2013-09-20','17:05:00',2.1),('8902','2013-09-20','17:10:00',2.01),('8902','2013-09-20','17:15:00',2.41),('8902','2013-09-20','17:20:00',1.46),('8902','2013-09-20','17:30:00',1.67),('8902','2013-09-20','17:35:00',2.23),('8902','2013-09-20','17:40:00',1.94),('8902','2013-09-20','17:45:00',2.09),('8902','2013-09-20','17:50:00',1.68),('8902','2013-09-20','17:55:00',1.53),('8902','2013-09-20','18:00:00',1.34),('8902','2013-09-20','18:05:00',1.14),('8902','2013-09-19','08:25:00',1.04),('8902','2013-09-19','08:30:00',1.16),('8902','2013-09-19','08:35:00',2.49),('8902','2013-09-19','08:40:00',2.83),('8902','2013-09-19','08:45:00',2.5),('8902','2013-09-19','08:50:00',1.79),('8902','2013-09-19','08:55:00',1.88),('8902','2013-09-19','09:00:00',2.1),('8902','2013-09-19','09:05:00',2.2),('8902','2013-09-19','09:10:00',2.12),('8902','2013-09-19','09:15:00',2.58),('8902','2013-09-19','09:20:00',2.56),('8902','2013-09-19','09:25:00',2.7),('8902','2013-09-19','09:30:00',2.4),('8902','2013-09-19','09:35:00',2.5),('8902','2013-09-19','09:40:00',2.31),('8902','2013-09-19','09:45:00',2.35),('8902','2013-09-19','09:50:00',2.46),('8902','2013-09-19','09:55:00',2.77),('8902','2013-09-19','10:00:00',3.1),('8902','2013-09-19','10:05:00',4.56),('8902','2013-09-19','10:10:00',4.25),('8902','2013-09-19','10:15:00',5.12),('8902','2013-09-19','10:20:00',6.56),('8902','2013-09-19','10:25:00',5.03),('8902','2013-09-19','10:30:00',5.07),('8902','2013-09-19','10:35:00',6.67),('8902','2013-09-19','10:40:00',6.31),('8902','2013-09-19','10:45:00',7.54),('8902','2013-09-19','10:50:00',6.49),('8902','2013-09-19','10:55:00',5.17),('8902','2013-09-19','11:00:00',3.71),('8902','2013-09-19','11:05:00',3.62),('8902','2013-09-19','11:10:00',3.74),('8902','2013-09-19','11:15:00',5.94),('8902','2013-09-19','11:20:00',4.68),('8902','2013-09-19','11:25:00',4.74),('8902','2013-09-19','11:30:00',4.14),('8902','2013-09-19','11:35:00',6.5),('8902','2013-09-19','11:40:00',5.16),('8902','2013-09-19','11:45:00',7.75),('8902','2013-09-19','11:50:00',7.67),('8902','2013-09-19','11:55:00',7.34),('8902','2013-09-19','12:00:00',7.27),('8902','2013-09-19','12:05:00',7.31),('8902','2013-09-19','12:10:00',7.39),('8902','2013-09-19','12:15:00',7.55),('8902','2013-09-19','12:20:00',7.76),('8902','2013-09-19','12:25:00',7.45),('8902','2013-09-19','12:30:00',8.1),('8902','2013-09-19','12:35:00',5.92),('8902','2013-09-19','12:40:00',6.47),('8902','2013-09-19','12:45:00',4.51),('8902','2013-09-19','12:50:00',6.31),('8902','2013-09-19','12:55:00',7.89),('8902','2013-09-19','13:00:00',7.34),('8902','2013-09-19','13:05:00',6.91),('8902','2013-09-19','13:10:00',7.58),('8902','2013-09-19','13:15:00',5.58),('8902','2013-09-19','13:20:00',4.75),('8902','2013-09-19','13:25:00',7.26),('8902','2013-09-19','13:30:00',7.97),('8902','2013-09-19','13:35:00',5.32),('8902','2013-09-19','13:40:00',7.02),('8902','2013-09-19','13:45:00',7.71),('8902','2013-09-19','13:50:00',7.44),('8902','2013-09-19','13:55:00',6.81),('8902','2013-09-19','14:00:00',7.38),('8902','2013-09-19','14:05:00',7.52),('8902','2013-09-19','14:10:00',7.2),('8902','2013-09-19','14:15:00',4.17),('8902','2013-09-19','14:20:00',2.45),('8902','2013-09-19','14:25:00',6.38),('8902','2013-09-19','14:30:00',7.86),('8902','2013-09-19','14:35:00',7.74),('8902','2013-09-19','14:40:00',7.5),('8902','2013-09-19','14:45:00',7.48),('8902','2013-09-19','14:50:00',7.54),('8902','2013-09-19','14:55:00',7.41),('8902','2013-09-19','15:00:00',5.3),('8902','2013-09-19','15:05:00',3.74),('8902','2013-09-19','15:10:00',6.09),('8902','2013-09-19','15:15:00',6.99),('8902','2013-09-19','15:20:00',5.56),('8902','2013-09-19','15:25:00',4.44),('8902','2013-09-19','15:30:00',6),('8902','2013-09-19','15:35:00',4.04),('8902','2013-09-19','15:40:00',5.08),('8902','2013-09-19','15:45:00',6.41),('8902','2013-09-19','15:50:00',6.23),('8902','2013-09-19','15:55:00',6.36),('8902','2013-09-19','16:00:00',3.94),('8902','2013-09-19','16:05:00',2.92),('8902','2013-09-19','16:10:00',4.13),('8902','2013-09-19','16:15:00',5.3),('8902','2013-09-19','16:20:00',2.88),('8902','2013-09-19','16:25:00',2.47),('8902','2013-09-19','16:30:00',1.55),('8902','2013-09-19','16:35:00',1.62),('8902','2013-09-19','16:40:00',1.85),('8902','2013-09-19','16:45:00',3.13),('8902','2013-09-19','16:50:00',4.63),('8902','2013-09-19','16:55:00',4.72),('8902','2013-09-19','17:00:00',4.3),('8902','2013-09-19','17:05:00',4.69),('8902','2013-09-19','17:10:00',4.57),('8902','2013-09-19','17:15:00',4.3),('8902','2013-09-19','17:20:00',4.06),('8902','2013-09-19','17:25:00',3.43),('8902','2013-09-19','17:30:00',3.01),('8902','2013-09-19','17:35:00',2.65),('8902','2013-09-19','17:40:00',2.34),('8902','2013-09-19','17:45:00',2.27),('8902','2013-09-19','17:50:00',1.99),('8902','2013-09-19','17:55:00',1.43),('8902','2013-09-19','18:00:00',1.83),('8902','2013-09-19','18:05:00',1.49),('8902','2013-09-19','18:10:00',1.69),('8902','2013-09-19','18:15:00',1.61),('8902','2013-09-19','18:20:00',1.14),('8902','2013-09-18','08:10:00',1.13),('8902','2013-09-18','08:15:00',1.49),('8902','2013-09-18','08:20:00',1.54),('8902','2013-09-18','08:25:00',1.51),('8902','2013-09-18','08:30:00',1.91),('8902','2013-09-18','08:35:00',2.18),('8902','2013-09-18','08:40:00',1.79),('8902','2013-09-18','08:45:00',2.25),('8902','2013-09-18','08:50:00',1.7),('8902','2013-09-18','08:55:00',2.2),('8902','2013-09-18','09:00:00',2.56),('8902','2013-09-18','09:05:00',1.86),('8902','2013-09-18','09:10:00',2.41),('8902','2013-09-18','09:15:00',2.86),('8902','2013-09-18','09:20:00',2.23),('8902','2013-09-18','09:25:00',2.11),('8902','2013-09-18','09:30:00',1.6),('8902','2013-09-18','09:35:00',1.65),('8902','2013-09-18','09:40:00',1.71),('8902','2013-09-18','09:45:00',1.44),('8902','2013-09-18','09:50:00',1.26),('8902','2013-09-18','09:55:00',1.3),('8902','2013-09-18','10:00:00',1.48),('8902','2013-09-18','10:05:00',3.2),('8902','2013-09-18','10:10:00',4.17),('8902','2013-09-18','10:15:00',4.09),('8902','2013-09-18','10:20:00',2),('8902','2013-09-18','10:25:00',2.26),('8902','2013-09-18','10:30:00',1.8),('8902','2013-09-18','10:35:00',4.5),('8902','2013-09-18','10:40:00',4.66),('8902','2013-09-18','10:45:00',5.59),('8902','2013-09-18','10:50:00',3.69),('8902','2013-09-18','10:55:00',4.96),('8902','2013-09-18','11:00:00',7.5),('8902','2013-09-18','11:05:00',7.98),('8902','2013-09-18','11:10:00',4.86),('8902','2013-09-18','11:15:00',3.43),('8902','2013-09-18','11:20:00',4.65),('8902','2013-09-18','11:25:00',3.63),('8902','2013-09-18','11:30:00',5.99),('8902','2013-09-18','11:35:00',4.14),('8902','2013-09-18','11:40:00',4.93),('8902','2013-09-18','11:45:00',5.34),('8902','2013-09-18','11:50:00',7.36),('8902','2013-09-18','11:55:00',7.85),('8902','2013-09-18','12:00:00',3.67),('8902','2013-09-18','12:05:00',2.88),('8902','2013-09-18','12:10:00',4.45),('8902','2013-09-18','12:15:00',4.89),('8902','2013-09-18','12:20:00',6.77),('8902','2013-09-18','12:25:00',8.69),('8902','2013-09-18','12:30:00',7.92),('8902','2013-09-18','12:35:00',7.84),('8902','2013-09-18','12:40:00',7.9),('8902','2013-09-18','12:45:00',6.26),('8902','2013-09-18','12:50:00',8.33),('8902','2013-09-18','12:55:00',8.12),('8902','2013-09-18','13:00:00',8.12),('8902','2013-09-18','13:05:00',8.09),('8902','2013-09-18','13:10:00',8.46),('8902','2013-09-18','13:15:00',8.55),('8902','2013-09-18','13:20:00',8.23),('8902','2013-09-18','13:25:00',6.06),('8902','2013-09-18','13:30:00',7.91),('8902','2013-09-18','13:35:00',8.2),('8902','2013-09-18','13:40:00',8.59),('8902','2013-09-18','13:45:00',8.82),('8902','2013-09-18','13:50:00',8.46),('8902','2013-09-18','13:55:00',4.2),('8902','2013-09-18','14:00:00',1.76),('8902','2013-09-18','14:05:00',5.5),('8902','2013-09-18','14:10:00',8.07),('8902','2013-09-18','14:15:00',7.69),('8902','2013-09-18','14:20:00',7.56),('8902','2013-09-18','14:25:00',7.43),('8902','2013-09-18','14:30:00',7.37),('8902','2013-09-18','14:35:00',7.3),('8902','2013-09-18','14:40:00',7.11),('8902','2013-09-18','14:45:00',6.99),('8902','2013-09-18','14:50:00',7.05),('8902','2013-09-18','14:55:00',6.86),('8902','2013-09-18','15:00:00',7.18),('8902','2013-09-18','15:05:00',6.61),('8902','2013-09-18','15:10:00',5.73),('8902','2013-09-18','15:15:00',6.44),('8902','2013-09-18','15:20:00',6.46),('8902','2013-09-18','15:25:00',6.45),('8902','2013-09-18','15:30:00',6.31),('8902','2013-09-18','15:35:00',4.27),('8902','2013-09-18','15:40:00',5.47),('8902','2013-09-18','15:45:00',6.52),('8902','2013-09-18','15:50:00',6.12),('8902','2013-09-18','15:55:00',5.54),('8902','2013-09-18','16:00:00',5.69),('8902','2013-09-18','16:05:00',5.61),('8902','2013-09-18','16:10:00',4.52),('8902','2013-09-18','16:15:00',4.95),('8902','2013-09-18','16:20:00',5.43),('8902','2013-09-18','16:25:00',5.3),('8902','2013-09-18','16:30:00',4.18),('8902','2013-09-18','16:35:00',3.7),('8902','2013-09-18','16:40:00',3.25),('8902','2013-09-18','16:45:00',2.47),('8902','2013-09-18','16:50:00',4.12),('8902','2013-09-18','16:55:00',4.29),('8902','2013-09-18','17:00:00',3.74),('8902','2013-09-18','17:05:00',3.51),('8902','2013-09-18','17:10:00',3.49),('8902','2013-09-18','17:15:00',3.24),('8902','2013-09-18','17:20:00',3.13),('8902','2013-09-18','17:25:00',2.55),('8902','2013-09-18','17:30:00',2.55),('8902','2013-09-18','17:35:00',2.18),('8902','2013-09-18','17:40:00',1.99),('8902','2013-09-18','17:45:00',1.79),('8902','2013-09-18','17:50:00',1.83),('8902','2013-09-18','17:55:00',1.71),('8902','2013-09-18','18:00:00',1.49),('8902','2013-09-18','18:05:00',1.37),('8902','2013-09-18','18:10:00',1.18),('8902','2013-09-18','18:15:00',1.13),('8902','2014-04-12','08:30:00',1.2),('8902','2014-04-12','08:35:00',1.2),('8902','2014-04-12','08:40:00',1.14),('8902','2014-04-12','08:45:00',1.24),('8902','2014-04-12','08:50:00',1.24),('8902','2014-04-12','08:55:00',1.37),('8902','2014-04-12','09:00:00',1.72),('8902','2014-04-12','09:05:00',2.21),('8902','2014-04-12','09:10:00',2.79),('8902','2014-04-12','09:15:00',2.48),('8902','2014-04-12','09:20:00',2.69),('8902','2014-04-12','09:25:00',3.15),('8902','2014-04-12','09:30:00',3.65),('8902','2014-04-12','09:35:00',2.71),('8902','2014-04-12','09:40:00',3.55),('8902','2014-04-12','09:45:00',3.31),('8902','2014-04-12','09:50:00',2.88),('8902','2014-04-12','09:55:00',2.9),('8902','2014-04-12','10:00:00',4.87),('8902','2014-04-12','10:05:00',6.81),('8902','2014-04-12','10:10:00',3.88),('8902','2014-04-12','10:15:00',4.23),('8902','2014-04-12','10:20:00',5.37),('8902','2014-04-12','10:25:00',3.43),('8902','2014-04-12','10:30:00',6.06),('8902','2014-04-12','10:35:00',6.7),('8902','2014-04-12','10:40:00',6.49),('8902','2014-04-12','10:45:00',6.82),('8902','2014-04-12','10:50:00',6.81),('8902','2014-04-12','10:55:00',6.91),('8902','2014-04-12','11:00:00',6.97),('8902','2014-04-12','11:05:00',7.08),('8902','2014-04-12','11:10:00',6.9),('8902','2014-04-12','11:15:00',6.14),('8902','2014-04-12','11:20:00',8.7),('8902','2014-04-12','11:25:00',5.36),('8902','2014-04-12','11:30:00',3.56),('8902','2014-04-12','11:35:00',4.8),('8902','2014-04-12','11:40:00',6.76),('8902','2014-04-12','11:45:00',6.43),('8902','2014-04-12','11:50:00',7.2),('8902','2014-04-12','11:55:00',5.62),('8902','2014-04-12','12:00:00',4.36),('8902','2014-04-12','12:05:00',3.26),('8902','2014-04-12','12:10:00',2.91),('8902','2014-04-12','12:15:00',2.68),('8902','2014-04-12','12:20:00',2.33),('8902','2014-04-12','12:25:00',1.72),('8902','2014-04-12','12:30:00',1.23),('8902','2014-04-12','12:45:00',1.06),('8902','2014-04-12','12:50:00',1.24),('8902','2014-04-12','12:55:00',1.4),('8902','2014-04-12','13:00:00',1.48),('8902','2014-04-12','13:05:00',2.44),('8902','2014-04-12','13:10:00',3.96),('8902','2014-04-12','13:15:00',3.65),('8902','2014-04-12','13:20:00',4.42),('8902','2014-04-12','13:25:00',5.8),('8902','2014-04-12','13:30:00',7.66),('8902','2014-04-12','13:35:00',7.97),('8902','2014-04-12','13:40:00',8.6),('8902','2014-04-12','13:45:00',4.37),('8902','2014-04-12','13:50:00',6.55),('8902','2014-04-12','13:55:00',6.32),('8902','2014-04-12','14:00:00',7.83),('8902','2014-04-12','14:05:00',6.27),('8902','2014-04-12','14:10:00',6.92),('8902','2014-04-12','14:15:00',7.4),('8902','2014-04-12','14:20:00',3.3),('8902','2014-04-12','14:25:00',3.02),('8902','2014-04-12','14:30:00',3.36),('8902','2014-04-12','14:35:00',3.11),('8902','2014-04-12','14:40:00',2.37),('8902','2014-04-12','14:45:00',3.68),('8902','2014-04-12','14:50:00',8.06),('8902','2014-04-12','14:55:00',3.08),('8902','2014-04-12','15:00:00',6.51),('8902','2014-04-12','15:05:00',7.43),('8902','2014-04-12','15:10:00',7.63),('8902','2014-04-12','15:15:00',6.94),('8902','2014-04-12','15:20:00',6.74),('8902','2014-04-12','15:25:00',7.03),('8902','2014-04-12','15:30:00',7.04),('8902','2014-04-12','15:35:00',4.64),('8902','2014-04-12','15:40:00',2.59),('8902','2014-04-12','15:45:00',2.59),('8902','2014-04-12','15:50:00',3.96),('8902','2014-04-12','15:55:00',4.35),('8902','2014-04-12','16:00:00',7.25),('8902','2014-04-12','16:05:00',5.95),('8902','2014-04-12','16:10:00',2.78),('8902','2014-04-12','16:15:00',2.66),('8902','2014-04-12','16:20:00',3.08),('8902','2014-04-12','16:25:00',3.37),('8902','2014-04-12','16:30:00',2.55),('8902','2014-04-12','16:35:00',3.36),('8902','2014-04-12','16:40:00',5.78),('8902','2014-04-12','16:45:00',6.5),('8902','2014-04-12','16:50:00',4.75),('8902','2014-04-12','16:55:00',5.19),('8902','2014-04-12','17:00:00',5.02),('8902','2014-04-12','17:05:00',3.58),('8902','2014-04-12','17:10:00',1.78),('8902','2014-04-12','17:15:00',1.85),('8902','2014-04-12','17:20:00',3.09),('8902','2014-04-12','17:25:00',2.34),('8902','2014-04-12','17:30:00',1.53),('8902','2014-04-12','17:35:00',1.28),('8902','2014-04-12','17:40:00',1.06),('8902','2014-04-12','17:45:00',1.43),('8902','2014-04-12','17:50:00',2.03),('8902','2014-04-12','17:55:00',2.07),('8902','2014-04-12','18:00:00',2.2),('8902','2014-04-12','18:05:00',1.45),('8902','2013-09-17','08:05:00',1.16),('8902','2013-09-17','08:10:00',1.32),('8902','2013-09-17','08:15:00',1.33),('8902','2013-09-17','08:25:00',1.46),('8902','2013-09-17','08:30:00',1.7),('8902','2013-09-17','08:35:00',1.53),('8902','2013-09-17','08:40:00',1.34),('8902','2013-09-17','08:45:00',2.76),('8902','2013-09-17','08:50:00',1.45),('8902','2013-09-17','08:55:00',1.55),('8902','2013-09-17','09:00:00',1.77),('8902','2013-09-17','09:05:00',2.5),('8902','2013-09-17','09:10:00',1.77),('8902','2013-09-17','09:15:00',1.76),('8902','2013-09-17','09:20:00',3.91),('8902','2013-09-17','09:25:00',2.87),('8902','2013-09-17','09:30:00',2.24),('8902','2013-09-17','09:35:00',3.88),('8902','2013-09-17','09:40:00',3.03),('8902','2013-09-17','09:45:00',2.44),('8902','2013-09-17','09:50:00',2.86),('8902','2013-09-17','09:55:00',4.45),('8902','2013-09-17','10:00:00',4.98),('8902','2013-09-17','10:05:00',5.86),('8902','2013-09-17','10:10:00',5.52),('8902','2013-09-17','10:15:00',5.44),('8902','2013-09-17','10:20:00',5.42),('8902','2013-09-17','10:25:00',5.52),('8902','2013-09-17','10:30:00',5.63),('8902','2013-09-17','10:35:00',5.7),('8902','2013-09-17','10:40:00',5.81),('8902','2013-09-17','10:45:00',5.91),('8902','2013-09-17','10:50:00',4.93),('8902','2013-09-17','10:55:00',5.66),('8902','2013-09-17','11:00:00',6.22),('8902','2013-09-17','11:05:00',5.67),('8902','2013-09-17','11:10:00',6.45),('8902','2013-09-17','11:15:00',4),('8902','2013-09-17','11:20:00',1.52),('8902','2013-09-17','11:25:00',4.55),('8902','2013-09-17','11:30:00',7.59),('8902','2013-09-17','11:35:00',7.2),('8902','2013-09-17','11:40:00',5.33),('8902','2013-09-17','11:45:00',5),('8902','2013-09-17','11:50:00',7.4),('8902','2013-09-17','11:55:00',7.43),('8902','2013-09-17','12:00:00',7.48),('8902','2013-09-17','12:05:00',7.61),('8902','2013-09-17','12:10:00',7.78),('8902','2013-09-17','12:15:00',7.76),('8902','2013-09-17','12:20:00',7.76),('8902','2013-09-17','12:25:00',7.95),('8902','2013-09-17','12:30:00',5.32),('8902','2013-09-17','12:35:00',6.53),('8902','2013-09-17','12:40:00',8.41),('8902','2013-09-17','12:45:00',5.85),('8902','2013-09-17','12:50:00',4.57),('8902','2013-09-17','12:55:00',7.95),('8902','2013-09-17','13:00:00',5.9),('8902','2013-09-17','13:05:00',6.16),('8902','2013-09-17','13:10:00',8.1),('8902','2013-09-17','13:15:00',8.09),('8902','2013-09-17','13:20:00',8.07),('8902','2013-09-17','13:25:00',7.65),('8902','2013-09-17','13:30:00',8.03),('8902','2013-09-17','13:35:00',7.86),('8902','2013-09-17','13:40:00',7.84),('8902','2013-09-17','13:45:00',7.89),('8902','2013-09-17','13:50:00',7.98),('8902','2013-09-17','13:55:00',7.26),('8902','2013-09-17','14:00:00',7.06),('8902','2013-09-17','14:05:00',7.26),('8902','2013-09-17','14:10:00',6.66),('8902','2013-09-17','14:15:00',7.64),('8902','2013-09-17','14:20:00',7.62),('8902','2013-09-17','14:25:00',7.48),('8902','2013-09-17','14:30:00',7.37),('8902','2013-09-17','14:35:00',7.33),('8902','2013-09-17','14:40:00',7.26),('8902','2013-09-17','14:45:00',7.16),('8902','2013-09-17','14:50:00',4.49),('8902','2013-09-17','14:55:00',7.09),('8902','2013-09-17','15:00:00',7.09),('8902','2013-09-17','15:05:00',7.12),('8902','2013-09-17','15:10:00',2.86),('8902','2013-09-17','15:15:00',4.18),('8902','2013-09-17','15:20:00',5.68),('8902','2013-09-17','15:25:00',4.9),('8902','2013-09-17','15:30:00',6.91),('8902','2013-09-17','15:35:00',6.68),('8902','2013-09-17','15:40:00',6.58),('8902','2013-09-17','15:45:00',6.2),('8902','2013-09-17','15:50:00',5.49),('8902','2013-09-17','15:55:00',3.84),('8902','2013-09-17','16:00:00',6.28),('8902','2013-09-17','16:05:00',6.28),('8902','2013-09-17','16:10:00',5.97),('8902','2013-09-17','16:15:00',5.53),('8902','2013-09-17','16:20:00',5.36),('8902','2013-09-17','16:25:00',4.73),('8902','2013-09-17','16:30:00',4.59),('8902','2013-09-17','16:35:00',4.25),('8902','2013-09-17','16:40:00',4.22),('8902','2013-09-17','16:45:00',4.33),('8902','2013-09-17','16:50:00',3.89),('8902','2013-09-17','16:55:00',3.64),('8902','2013-09-17','17:00:00',3.94),('8902','2013-09-17','17:05:00',3.47),('8902','2013-09-17','17:10:00',3.52),('8902','2013-09-17','17:15:00',3.35),('8902','2013-09-17','17:20:00',3.22),('8902','2013-09-17','17:25:00',2.53),('8902','2013-09-17','17:30:00',2.65),('8902','2013-09-17','17:35:00',2.66),('8902','2013-09-17','17:40:00',2.43),('8902','2013-09-17','17:45:00',2.18),('8902','2013-09-17','17:50:00',2.02),('8902','2013-09-17','17:55:00',1.82),('8902','2013-09-17','18:00:00',1.51),('8902','2013-09-17','18:05:00',1.24),('8902','2013-09-17','18:10:00',1.18),('8902','2013-09-17','18:15:00',1.03),('8902','2013-09-16','08:20:00',1),('8902','2013-09-16','08:40:00',1.25),('8902','2013-09-16','08:45:00',1.12),('8902','2013-09-16','08:50:00',1.22),('8902','2013-09-16','08:55:00',1.22),('8902','2013-09-16','09:00:00',1.35),('8902','2013-09-16','09:05:00',1.35),('8902','2013-09-16','09:10:00',1.33),('8902','2013-09-16','09:15:00',1.47),('8902','2013-09-16','09:20:00',2.33),('8902','2013-09-16','09:25:00',1.7),('8902','2013-09-16','09:30:00',2.11),('8902','2013-09-16','09:35:00',1.6),('8902','2013-09-16','09:40:00',2.41),('8902','2013-09-16','09:45:00',4.27),('8902','2013-09-16','09:50:00',2.91),('8902','2013-09-16','09:55:00',2.52),('8902','2013-09-16','10:00:00',4.29),('8902','2013-09-16','10:05:00',3.07),('8902','2013-09-16','10:10:00',3.5),('8902','2013-09-16','10:15:00',1.54),('8902','2013-09-16','10:20:00',1.46),('8902','2013-09-16','10:25:00',5.03),('8902','2013-09-16','10:30:00',6.53),('8902','2013-09-16','10:35:00',3.9),('8902','2013-09-16','10:40:00',4.04),('8902','2013-09-16','10:45:00',3.37),('8902','2013-09-16','10:50:00',7.26),('8902','2013-09-16','10:55:00',5.53),('8902','2013-09-16','11:00:00',4.27),('8902','2013-09-16','11:05:00',4.45),('8902','2013-09-16','11:10:00',6.23),('8902','2013-09-16','11:15:00',5.54),('8902','2013-09-16','11:20:00',4.64),('8902','2013-09-16','11:25:00',3.54),('8902','2013-09-16','11:30:00',3.52),('8902','2013-09-16','11:35:00',6.15),('8902','2013-09-16','11:40:00',6.91),('8902','2013-09-16','11:45:00',6.46),('8902','2013-09-16','11:50:00',6.27),('8902','2013-09-16','11:55:00',5.2),('8902','2013-09-16','12:00:00',7.27),('8902','2013-09-16','12:05:00',5.11),('8902','2013-09-16','12:10:00',3.6),('8902','2013-09-16','12:15:00',4.43),('8902','2013-09-16','12:20:00',3.74),('8902','2013-09-16','12:25:00',7.21),('8902','2013-09-16','12:30:00',6.48),('8902','2013-09-16','12:35:00',4.7),('8902','2013-09-16','12:40:00',6.18),('8902','2013-09-16','12:45:00',6.74),('8902','2013-09-16','12:50:00',6.47),('8902','2013-09-16','12:55:00',4.78),('8902','2013-09-16','13:00:00',4.88),('8902','2013-09-16','13:05:00',2.95),('8902','2013-09-16','13:10:00',4.8),('8902','2013-09-16','13:15:00',6.68),('8902','2013-09-16','13:20:00',4.7),('8902','2013-09-16','13:25:00',4.45),('8902','2013-09-16','13:30:00',3.76),('8902','2013-09-16','13:35:00',3.39),('8902','2013-09-16','13:40:00',4.75),('8902','2013-09-16','13:45:00',3.31),('8902','2013-09-16','13:50:00',1.84),('8902','2013-09-16','13:55:00',2.44),('8902','2013-09-16','14:00:00',4),('8902','2013-09-16','14:05:00',2.78),('8902','2013-09-16','14:10:00',1.89),('8902','2013-09-16','14:15:00',2.76),('8902','2013-09-16','14:20:00',1.88),('8902','2013-09-16','14:25:00',3.79),('8902','2013-09-16','14:30:00',2.29),('8902','2013-09-16','14:35:00',2.21),('8902','2013-09-16','14:40:00',1.76),('8902','2013-09-16','14:45:00',1.62),('8902','2013-09-16','14:50:00',2.39),('8902','2013-09-16','14:55:00',6.62),('8902','2013-09-16','15:00:00',7.05),('8902','2013-09-16','15:05:00',5.48),('8902','2013-09-16','15:10:00',5.42),('8902','2013-09-16','15:15:00',5.67),('8902','2013-09-16','15:20:00',6.13),('8902','2013-09-16','15:25:00',5.74),('8902','2013-09-16','15:30:00',5.1),('8902','2013-09-16','15:35:00',2.4),('8902','2013-09-16','15:40:00',1.75),('8902','2013-09-16','15:45:00',2.03),('8902','2013-09-16','15:50:00',3.73),('8902','2013-09-16','15:55:00',4.57),('8902','2013-09-16','16:00:00',2.44),('8902','2013-09-16','16:05:00',3.92),('8902','2013-09-16','16:10:00',3.23),('8902','2013-09-16','16:15:00',3.49),('8902','2013-09-16','16:20:00',2.22),('8902','2013-09-16','16:25:00',1.39),('8902','2013-09-16','16:35:00',1.34),('8902','2013-09-16','16:40:00',2.42),('8902','2013-09-16','16:45:00',2.85),('8902','2013-09-16','16:50:00',2.53),('8902','2013-09-16','16:55:00',1.87),('8902','2013-09-16','17:00:00',3.08),('8902','2013-09-16','17:05:00',3.46),('8902','2013-09-16','17:10:00',3.2),('8902','2013-09-16','17:15:00',3.37),('8902','2013-09-16','17:20:00',2.76),('8902','2013-09-16','17:25:00',2.46),('8902','2013-09-16','17:30:00',2.76),('8902','2013-09-16','17:35:00',1.91),('8902','2013-09-16','17:40:00',1.99),('8902','2013-09-16','17:45:00',1.35),('8902','2013-09-16','17:50:00',1.47),('8902','2013-09-16','17:55:00',1.48),('8902','2013-09-16','18:00:00',1.09),('8902','2013-09-16','18:05:00',1.29),('8902','2013-09-15','08:10:00',1.41),('8902','2013-09-15','08:15:00',1.62),('8902','2013-09-15','08:20:00',1.67),('8902','2013-09-15','08:25:00',1.79),('8902','2013-09-15','08:30:00',1.94),('8902','2013-09-15','08:35:00',2.15),('8902','2013-09-15','08:40:00',2.46),('8902','2013-09-15','08:45:00',2.33),('8902','2013-09-15','08:50:00',2.5),('8902','2013-09-15','08:55:00',1.54),('8902','2013-09-15','09:00:00',1.35),('8902','2013-09-15','09:05:00',2.65),('8902','2013-09-15','09:10:00',2.97),('8902','2013-09-15','09:15:00',3.89),('8902','2013-09-15','09:20:00',3.13),('8902','2013-09-15','09:25:00',3.87),('8902','2013-09-15','09:30:00',3.61),('8902','2013-09-15','09:35:00',3.56),('8902','2013-09-15','09:40:00',4.49),('8902','2013-09-15','09:45:00',4.61),('8902','2013-09-15','09:50:00',4.68),('8902','2013-09-15','09:55:00',4.95),('8902','2013-09-15','10:00:00',5.05),('8902','2013-09-15','10:05:00',5.26),('8902','2013-09-15','10:10:00',5.72),('8902','2013-09-15','10:15:00',2.34),('8902','2013-09-15','10:20:00',1.8),('8902','2013-09-15','10:25:00',3.81),('8902','2013-09-15','10:30:00',5.32),('8902','2013-09-15','10:35:00',6.53),('8902','2013-09-15','10:40:00',6.97),('8902','2013-09-15','10:45:00',7.4),('8902','2013-09-15','10:50:00',5.58),('8902','2013-09-15','10:55:00',1.27),('8902','2013-09-15','11:00:00',1.26),('8902','2013-09-15','11:05:00',3.36),('8902','2013-09-15','11:10:00',2.56),('8902','2013-09-15','11:15:00',1.56),('8902','2013-09-15','11:20:00',6.07),('8902','2013-09-15','11:25:00',4.81),('8902','2013-09-15','11:30:00',7.49),('8902','2013-09-15','11:35:00',7.35),('8902','2013-09-15','11:40:00',7.38),('8902','2013-09-15','11:45:00',6.87),('8902','2013-09-15','11:50:00',4.83),('8902','2013-09-15','11:55:00',7.81),('8902','2013-09-15','12:00:00',7.96),('8902','2013-09-15','12:05:00',8.22),('8902','2013-09-15','12:10:00',8.76),('8902','2013-09-15','12:15:00',7.66),('8902','2013-09-15','12:20:00',7.73),('8902','2013-09-15','12:25:00',7.68),('8902','2013-09-15','12:30:00',7.66),('8902','2013-09-15','12:35:00',7.75),('8902','2013-09-15','12:40:00',7.94),('8902','2013-09-15','12:45:00',8.42),('8902','2013-09-15','12:50:00',4.33),('8902','2013-09-15','12:55:00',7.05),('8902','2013-09-15','13:00:00',7.03),('8902','2013-09-15','13:05:00',6.62),('8902','2013-09-15','13:10:00',7.96),('8902','2013-09-15','13:15:00',7),('8902','2013-09-15','13:20:00',7.92),('8902','2013-09-15','13:25:00',7.83),('8902','2013-09-15','13:30:00',7.74),('8902','2013-09-15','13:35:00',7.79),('8902','2013-09-15','13:40:00',7.77),('8902','2013-09-15','13:45:00',7.72),('8902','2013-09-15','13:50:00',7.8),('8902','2013-09-15','13:55:00',7.99),('8902','2013-09-15','14:00:00',7.9),('8902','2013-09-15','14:05:00',7.41),('8902','2013-09-15','14:10:00',7.6),('8902','2013-09-15','14:15:00',7.51),('8902','2013-09-15','14:20:00',7.44),('8902','2013-09-15','14:25:00',7.36),('8902','2013-09-15','14:30:00',7.36),('8902','2013-09-15','14:35:00',7.29),('8902','2013-09-15','14:40:00',7.2),('8902','2013-09-15','14:45:00',7.15),('8902','2013-09-15','14:50:00',6.92),('8902','2013-09-15','14:55:00',6.82),('8902','2013-09-15','15:00:00',6.96),('8902','2013-09-15','15:05:00',6.96),('8902','2013-09-15','15:10:00',6.9),('8902','2013-09-15','15:15:00',6.82),('8902','2013-09-15','15:20:00',6.74),('8902','2013-09-15','15:25:00',6.66),('8902','2013-09-15','15:30:00',6.57),('8902','2013-09-15','15:35:00',6.44),('8902','2013-09-15','15:40:00',6.39),('8902','2013-09-15','15:45:00',6.3),('8902','2013-09-15','15:50:00',6.17),('8902','2013-09-15','15:55:00',6.04),('8902','2013-09-15','16:00:00',6.02),('8902','2013-09-15','16:05:00',4.88),('8902','2013-09-15','16:10:00',5.88),('8902','2013-09-15','16:15:00',5.54),('8902','2013-09-15','16:20:00',5.43),('8902','2013-09-15','16:25:00',5.26),('8902','2013-09-15','16:30:00',5.11),('8902','2013-09-15','16:35:00',4.93),('8902','2013-09-15','16:40:00',4.8),('8902','2013-09-15','16:45:00',4.66),('8902','2013-09-15','16:50:00',4.51),('8902','2013-09-15','16:55:00',4.25),('8902','2013-09-15','17:00:00',4.13),('8902','2013-09-15','17:05:00',3.97),('8902','2013-09-15','17:10:00',3.8),('8902','2013-09-15','17:15:00',3.6),('8902','2013-09-15','17:20:00',3.38),('8902','2013-09-15','17:25:00',3.19),('8902','2013-09-15','17:30:00',3.04),('8902','2013-09-15','17:35:00',2.74),('8902','2013-09-15','17:40:00',1.89),('8902','2013-09-15','17:45:00',2.12),('8902','2013-09-15','17:50:00',2.18),('8902','2013-09-15','17:55:00',1.9),('8902','2013-09-15','18:00:00',1.75),('8902','2013-09-15','18:05:00',1.58),('8902','2013-09-15','18:10:00',1.42),('8902','2013-09-15','18:15:00',1.23),('8902','2013-09-15','18:20:00',1.03),('8902','2013-09-14','08:00:00',1.06),('8902','2013-09-14','08:05:00',1.24),('8902','2013-09-14','08:10:00',1.42),('8902','2013-09-14','08:15:00',1.58),('8902','2013-09-14','08:20:00',1.74),('8902','2013-09-14','08:25:00',1.89),('8902','2013-09-14','08:30:00',2.05),('8902','2013-09-14','08:35:00',2.26),('8902','2013-09-14','08:40:00',2.48),('8902','2013-09-14','08:45:00',2.65),('8902','2013-09-14','08:50:00',2.73),('8902','2013-09-14','08:55:00',2.69),('8902','2013-09-14','09:00:00',2.93),('8902','2013-09-14','09:05:00',3.05),('8902','2013-09-14','09:10:00',3.35),('8902','2013-09-14','09:15:00',3.68),('8902','2013-09-14','09:20:00',3.65),('8902','2013-09-14','09:25:00',3.86),('8902','2013-09-14','09:30:00',3.98),('8902','2013-09-14','09:35:00',4.29),('8902','2013-09-14','09:40:00',4.42),('8902','2013-09-14','09:45:00',4.49),('8902','2013-09-14','09:50:00',4.67),('8902','2013-09-14','09:55:00',4.82),('8902','2013-09-14','10:00:00',5.05),('8902','2013-09-14','10:05:00',5.19),('8902','2013-09-14','10:10:00',5.24),('8902','2013-09-14','10:15:00',5.11),('8902','2013-09-14','10:20:00',5.27),('8902','2013-09-14','10:25:00',5.52),('8902','2013-09-14','10:30:00',5.21),('8902','2013-09-14','10:35:00',4.43),('8902','2013-09-14','10:40:00',2.68),('8902','2013-09-14','10:45:00',2.3),('8902','2013-09-14','10:50:00',1.85),('8902','2013-09-14','10:55:00',1.44),('8902','2013-09-14','11:00:00',3.5),('8902','2013-09-14','11:05:00',7.26),('8902','2013-09-14','11:10:00',7.19),('8902','2013-09-14','11:15:00',3.56),('8902','2013-09-14','11:20:00',2.78),('8902','2013-09-14','11:25:00',2.14),('8902','2013-09-14','11:30:00',2.1),('8902','2013-09-14','11:35:00',6.62),('8902','2013-09-14','11:40:00',3.74),('8902','2013-09-14','11:45:00',2.26),('8902','2013-09-14','11:50:00',4.14),('8902','2013-09-14','11:55:00',2.98),('8902','2013-09-14','12:00:00',2.46),('8902','2013-09-14','12:05:00',2.32),('8902','2013-09-14','12:10:00',2.18),('8902','2013-09-14','12:15:00',2.18),('8902','2013-09-14','12:20:00',2.54),('8902','2013-09-14','12:25:00',3.03),('8902','2013-09-14','12:30:00',3.24),('8902','2013-09-14','12:35:00',3.28),('8902','2013-09-14','12:40:00',3.26),('8902','2013-09-14','12:45:00',2.47),('8902','2013-09-14','12:50:00',2.46),('8902','2013-09-14','12:55:00',2.53),('8902','2013-09-14','13:00:00',2.39),('8902','2013-09-14','13:05:00',2.22),('8902','2013-09-14','13:10:00',1.74),('8902','2013-09-14','13:15:00',1.3),('8902','2013-09-14','13:20:00',1.22),('8902','2013-09-14','13:25:00',1.7),('8902','2013-09-14','13:30:00',1.87),('8902','2013-09-14','13:35:00',2.41),('8902','2013-09-14','13:40:00',2.73),('8902','2013-09-14','13:45:00',3.46),('8902','2013-09-14','13:50:00',3.8),('8902','2013-09-14','13:55:00',2.62),('8902','2013-09-14','14:00:00',3.48),('8902','2013-09-14','14:05:00',3.27),('8902','2013-09-14','14:10:00',2.84),('8902','2013-09-14','14:15:00',2.55),('8902','2013-09-14','14:20:00',2.37),('8902','2013-09-14','14:25:00',2.38),('8902','2013-09-14','14:30:00',2.4),('8902','2013-09-14','14:35:00',2.06),('8902','2013-09-14','14:40:00',2.07),('8902','2013-09-14','14:45:00',1.78),('8902','2013-09-14','14:50:00',1.84),('8902','2013-09-14','14:55:00',2.01),('8902','2013-09-14','15:00:00',2.06),('8902','2013-09-14','15:05:00',2.21),('8902','2013-09-14','15:10:00',2.53),('8902','2013-09-14','15:15:00',5.45),('8902','2013-09-14','15:20:00',4.39),('8902','2013-09-14','15:25:00',2.94),('8902','2013-09-14','15:30:00',2.17),('8902','2013-09-14','15:35:00',2.06),('8902','2013-09-14','15:40:00',1.91),('8902','2013-09-14','15:45:00',1.84),('8902','2013-09-14','15:50:00',1.85),('8902','2013-09-14','15:55:00',1.86),('8902','2013-09-14','16:00:00',1.58),('8902','2013-09-14','16:05:00',1.83),('8902','2013-09-14','16:10:00',1.51),('8902','2013-09-14','16:15:00',1.04),('8902','2013-09-14','16:25:00',1.02),('8902','2013-09-14','16:30:00',1.3),('8902','2013-09-14','16:35:00',1.28),('8902','2013-09-14','16:40:00',1.53),('8902','2013-09-14','16:45:00',1.31),('8902','2013-09-14','17:00:00',1.09),('8902','2013-09-14','17:05:00',1.11),('8902','2013-09-14','17:15:00',1.13),('8902','2013-09-14','17:20:00',1.46),('8902','2013-09-14','17:25:00',1.14),('8902','2013-09-14','17:30:00',1.1),('8902','2013-09-14','18:00:00',1.15),('8902','2013-09-13','08:00:00',1.01),('8902','2013-09-13','08:05:00',1.17),('8902','2013-09-13','08:10:00',1.35),('8902','2013-09-13','08:15:00',1.5),('8902','2013-09-13','08:20:00',1.67),('8902','2013-09-13','08:25:00',1.82),('8902','2013-09-13','08:30:00',1.98),('8902','2013-09-13','08:35:00',2.16),('8902','2013-09-13','08:40:00',2.34),('8902','2013-09-13','08:45:00',2.52),('8902','2013-09-13','08:50:00',2.67),('8902','2013-09-13','08:55:00',2.84),('8902','2013-09-13','09:00:00',3.03),('8902','2013-09-13','09:05:00',3.21),('8902','2013-09-13','09:10:00',3.39),('8902','2013-09-13','09:15:00',3.58),('8902','2013-09-13','09:20:00',3.74),('8902','2013-09-13','09:25:00',3.91),('8902','2013-09-13','09:30:00',4.12),('8902','2013-09-13','09:35:00',4.25),('8902','2013-09-13','09:40:00',4.39),('8902','2013-09-13','09:45:00',4.55),('8902','2013-09-13','09:50:00',4.53),('8902','2013-09-13','09:55:00',4.76),('8902','2013-09-13','10:00:00',4.85),('8902','2013-09-13','10:05:00',5.09),('8902','2013-09-13','10:10:00',4.78),('8902','2013-09-13','10:15:00',5.01),('8902','2013-09-13','10:20:00',5.36),('8902','2013-09-13','10:25:00',5.59),('8902','2013-09-13','10:30:00',5.58),('8902','2013-09-13','10:35:00',5.65),('8902','2013-09-13','10:40:00',6.14),('8902','2013-09-13','10:45:00',6.7),('8902','2013-09-13','10:50:00',6.41),('8902','2013-09-13','10:55:00',7.01),('8902','2013-09-13','11:00:00',7.27),('8902','2013-09-13','11:05:00',5.49),('8902','2013-09-13','11:10:00',3.09),('8902','2013-09-13','11:15:00',1.56),('8902','2013-09-13','11:20:00',1.19),('8902','2013-09-13','11:25:00',3.7),('8902','2013-09-13','11:30:00',7.34),('8902','2013-09-13','11:35:00',6.64),('8902','2013-09-13','11:40:00',4.23),('8902','2013-09-13','11:45:00',6.76),('8902','2013-09-13','11:50:00',6.48),('8902','2013-09-13','11:55:00',7.97),('8902','2013-09-13','12:00:00',7.02),('8902','2013-09-13','12:05:00',7.71),('8902','2013-09-13','12:10:00',4.74),('8902','2013-09-13','12:15:00',6.74),('8902','2013-09-13','12:20:00',2.37),('8902','2013-09-13','12:25:00',1.25),('8902','2013-09-13','12:30:00',1.4),('8902','2013-09-13','12:35:00',2.64),('8902','2013-09-13','12:40:00',7.46),('8902','2013-09-13','12:45:00',3.7),('8902','2013-09-13','12:50:00',1.98),('8902','2013-09-13','12:55:00',1.75),('8902','2013-09-13','13:00:00',1.95),('8902','2013-09-13','13:05:00',1.44),('8902','2013-09-13','13:10:00',1.52),('8902','2013-09-13','13:15:00',4.67),('8902','2013-09-13','13:20:00',8.35),('8902','2013-09-13','13:25:00',5.13),('8902','2013-09-13','13:30:00',8.8),('8902','2013-09-13','13:35:00',4.41),('8902','2013-09-13','13:40:00',2.74),('8902','2013-09-13','13:45:00',3.68),('8902','2013-09-13','13:50:00',4.57),('8902','2013-09-13','13:55:00',8.66),('8902','2013-09-13','14:00:00',8.61),('8902','2013-09-13','14:05:00',7.93),('8902','2013-09-13','14:10:00',7.82),('8902','2013-09-13','14:15:00',7.74),('8902','2013-09-13','14:20:00',7.2),('8902','2013-09-13','14:25:00',7.44),('8902','2013-09-13','14:30:00',7.65),('8902','2013-09-13','14:35:00',7.17),('8902','2013-09-13','14:40:00',7.38),('8902','2013-09-13','14:45:00',7.18),('8902','2013-09-13','14:50:00',7.24),('8902','2013-09-13','14:55:00',7.15),('8902','2013-09-13','15:00:00',7.08),('8902','2013-09-13','15:05:00',6.91),('8902','2013-09-13','15:10:00',6.81),('8902','2013-09-13','15:15:00',6.72),('8902','2013-09-13','15:20:00',6.69),('8902','2013-09-13','15:25:00',6.73),('8902','2013-09-13','15:30:00',5.69),('8902','2013-09-13','15:35:00',6.44),('8902','2013-09-13','15:40:00',6.31),('8902','2013-09-13','15:45:00',6.23),('8902','2013-09-13','15:50:00',6.12),('8902','2013-09-13','15:55:00',5.99),('8902','2013-09-13','16:00:00',5.86),('8902','2013-09-13','16:05:00',5.69),('8902','2013-09-13','16:10:00',5.57),('8902','2013-09-13','16:15:00',5.4),('8902','2013-09-13','16:20:00',5.31),('8902','2013-09-13','16:25:00',5.11),('8902','2013-09-13','16:30:00',5.08),('8902','2013-09-13','16:35:00',4.91),('8902','2013-09-13','16:40:00',4.7),('8902','2013-09-13','16:45:00',4.58),('8902','2013-09-13','16:50:00',4.42),('8902','2013-09-13','16:55:00',4.24),('8902','2013-09-13','17:00:00',3.8),('8902','2013-09-13','17:05:00',3.97),('8902','2013-09-13','17:10:00',3.61),('8902','2013-09-13','17:15:00',3.47),('8902','2013-09-13','17:20:00',3.26),('8902','2013-09-13','17:25:00',3.21),('8902','2013-09-13','17:30:00',2.95),('8902','2013-09-13','17:35:00',2.75),('8902','2013-09-13','17:40:00',2.45),('8902','2013-09-13','17:45:00',2.43),('8902','2013-09-13','17:50:00',2.25),('8902','2013-09-13','17:55:00',2.05),('8902','2013-09-13','18:00:00',1.56),('8902','2013-09-13','18:05:00',1.26),('8902','2013-09-13','18:10:00',1.47),('8902','2013-09-13','18:15:00',1.31),('8902','2013-09-13','18:20:00',1.11),('8902','2013-09-12','08:15:00',1.09),('8902','2013-09-12','08:20:00',1.33),('8902','2013-09-12','08:25:00',1.5),('8902','2013-09-12','08:30:00',1.73),('8902','2013-09-12','08:35:00',1.31),('8902','2013-09-12','08:40:00',1.35),('8902','2013-09-12','08:45:00',1.58),('8902','2013-09-12','08:50:00',1.77),('8902','2013-09-12','08:55:00',1.95),('8902','2013-09-12','09:00:00',1.87),('8902','2013-09-12','09:05:00',1.82),('8902','2013-09-12','09:10:00',1.81),('8902','2013-09-12','09:15:00',1.9),('8902','2013-09-12','09:20:00',1.93),('8902','2013-09-12','09:25:00',2.1),('8902','2013-09-12','09:30:00',2.28),('8902','2013-09-12','09:35:00',2.49),('8902','2013-09-12','09:40:00',2.71),('8902','2013-09-12','09:45:00',2.62),('8902','2013-09-12','09:50:00',2.71),('8902','2013-09-12','09:55:00',5.14),('8902','2013-09-12','10:00:00',5.02),('8902','2013-09-12','10:05:00',2.7),('8902','2013-09-12','10:10:00',2.92),('8902','2013-09-12','10:15:00',6.39),('8902','2013-09-12','10:20:00',6.79),('8902','2013-09-12','10:25:00',4.23),('8902','2013-09-12','10:30:00',3.53),('8902','2013-09-12','10:35:00',6.26),('8902','2013-09-12','10:40:00',6.1),('8902','2013-09-12','10:45:00',6.17),('8902','2013-09-12','10:50:00',6.25),('8902','2013-09-12','10:55:00',6.34),('8902','2013-09-12','11:00:00',6.45),('8902','2013-09-12','11:05:00',6.54),('8902','2013-09-12','11:10:00',6.6),('8902','2013-09-12','11:15:00',6.72),('8902','2013-09-12','11:20:00',6.81),('8902','2013-09-12','11:25:00',6.85),('8902','2013-09-12','11:30:00',6.94),('8902','2013-09-12','11:35:00',7),('8902','2013-09-12','11:40:00',7.06),('8902','2013-09-12','11:45:00',7.17),('8902','2013-09-12','11:50:00',7.23),('8902','2013-09-12','11:55:00',7.28),('8902','2013-09-12','12:00:00',7.31),('8902','2013-09-12','12:05:00',7.44),('8902','2013-09-12','12:10:00',7.51),('8902','2013-09-12','12:15:00',7.48),('8902','2013-09-12','12:20:00',7.55),('8902','2013-09-12','12:25:00',7.7),('8902','2013-09-12','12:30:00',7.82),('8902','2013-09-12','12:35:00',7.69),('8902','2013-09-12','12:40:00',7.75),('8902','2013-09-12','12:45:00',7.71),('8902','2013-09-12','12:50:00',7.79),('8902','2013-09-12','12:55:00',7.78),('8902','2013-09-12','13:00:00',7.71),('8902','2013-09-12','13:05:00',7.67),('8902','2013-09-12','13:10:00',7.66),('8902','2013-09-12','13:15:00',7.64),('8902','2013-09-12','13:20:00',7.62),('8902','2013-09-12','13:25:00',7.64),('8902','2013-09-12','13:30:00',7.64),('8902','2013-09-12','13:35:00',7.6),('8902','2013-09-12','13:40:00',7.6),('8902','2013-09-12','13:45:00',7.58),('8902','2013-09-12','13:50:00',7.56),('8902','2013-09-12','13:55:00',7.53),('8902','2013-09-12','14:00:00',7.52),('8902','2013-09-12','14:05:00',7.51),('8902','2013-09-12','14:10:00',7.43),('8902','2013-09-12','14:15:00',7.33),('8902','2013-09-12','14:20:00',7.27),('8902','2013-09-12','14:25:00',7.31),('8902','2013-09-12','14:30:00',7.34),('8902','2013-09-12','14:35:00',7.25),('8902','2013-09-12','14:40:00',7.22),('8902','2013-09-12','14:45:00',7.15),('8902','2013-09-12','14:50:00',7.26),('8902','2013-09-12','14:55:00',6.09),('8902','2013-09-12','15:00:00',6.89),('8902','2013-09-12','15:05:00',6.8),('8902','2013-09-12','15:10:00',6.83),('8902','2013-09-12','15:15:00',6.84),('8902','2013-09-12','15:20:00',6.71),('8902','2013-09-12','15:25:00',6.58),('8902','2013-09-12','15:30:00',6.54),('8902','2013-09-12','15:35:00',6.44),('8902','2013-09-12','15:40:00',6.35),('8902','2013-09-12','15:45:00',6.27),('8902','2013-09-12','15:50:00',6.15),('8902','2013-09-12','15:55:00',6.03),('8902','2013-09-12','16:00:00',5.91),('8902','2013-09-12','16:05:00',5.81),('8902','2013-09-12','16:10:00',5.7),('8902','2013-09-12','16:15:00',5.53),('8902','2013-09-12','16:20:00',5.4),('8902','2013-09-12','16:25:00',5.27),('8902','2013-09-12','16:30:00',5.12),('8902','2013-09-12','16:35:00',5.01),('8902','2013-09-12','16:40:00',4.75),('8902','2013-09-12','16:45:00',4.59),('8902','2013-09-12','16:50:00',4.47),('8902','2013-09-12','16:55:00',4.28),('8902','2013-09-12','17:00:00',4.07),('8902','2013-09-12','17:05:00',3.95),('8902','2013-09-12','17:10:00',3.78),('8902','2013-09-12','17:15:00',3.59),('8902','2013-09-12','17:20:00',3.37),('8902','2013-09-12','17:25:00',3.2),('8902','2013-09-12','17:30:00',2.97),('8902','2013-09-12','17:35:00',2.82),('8902','2013-09-12','17:40:00',2.64),('8902','2013-09-12','17:45:00',2.44),('8902','2013-09-12','17:50:00',2.23),('8902','2013-09-12','17:55:00',2.04),('8902','2013-09-12','18:00:00',1.86),('8902','2013-09-12','18:05:00',1.66),('8902','2013-09-12','18:10:00',1.47),('8902','2013-09-12','18:15:00',1.3),('8902','2013-09-12','18:20:00',1.13),('8902','2013-09-11','07:55:00',1.16),('8902','2013-09-11','08:00:00',1.54),('8902','2013-09-11','08:05:00',1.31),('8902','2013-09-11','08:10:00',1),('8902','2013-09-11','08:15:00',1.89),('8902','2013-09-11','08:20:00',1.96),('8902','2013-09-11','08:25:00',2.39),('8902','2013-09-11','08:30:00',2.73),('8902','2013-09-11','08:35:00',2.58),('8902','2013-09-11','08:40:00',1.99),('8902','2013-09-11','08:45:00',1.37),('8902','2013-09-11','08:50:00',1.21),('8902','2013-09-11','08:55:00',2.69),('8902','2013-09-11','09:00:00',3.08),('8902','2013-09-11','09:05:00',3.04),('8902','2013-09-11','09:10:00',2.55),('8902','2013-09-11','09:15:00',3.62),('8902','2013-09-11','09:20:00',3.66),('8902','2013-09-11','09:25:00',4.01),('8902','2013-09-11','09:30:00',4.36),('8902','2013-09-11','09:35:00',3.74),('8902','2013-09-11','09:40:00',3.58),('8902','2013-09-11','09:45:00',3.83),('8902','2013-09-11','09:50:00',4.73),('8902','2013-09-11','09:55:00',3.32),('8902','2013-09-11','10:00:00',2.14),('8902','2013-09-11','10:05:00',2.67),('8902','2013-09-11','10:10:00',3.2),('8902','2013-09-11','10:15:00',3.03),('8902','2013-09-11','10:20:00',2.41),('8902','2013-09-11','10:25:00',1.71),('8902','2013-09-11','10:30:00',2.78),('8902','2013-09-11','10:35:00',3.51),('8902','2013-09-11','10:40:00',1.63),('8902','2013-09-11','10:50:00',1.09),('8902','2013-09-11','10:55:00',3.79),('8902','2013-09-11','11:00:00',4.39),('8902','2013-09-11','11:05:00',4.94),('8902','2013-09-11','11:10:00',4.62),('8902','2013-09-11','11:15:00',5.36),('8902','2013-09-11','11:20:00',2.52),('8902','2013-09-11','11:40:00',1.83),('8902','2013-09-11','11:45:00',4.95),('8902','2013-09-11','11:50:00',3.12),('8902','2013-09-11','11:55:00',4.65),('8902','2013-09-11','12:00:00',6.39),('8902','2013-09-11','12:05:00',7.46),('8902','2013-09-11','12:10:00',6.36),('8902','2013-09-11','12:15:00',5.37),('8902','2013-09-11','12:20:00',2.81),('8902','2013-09-11','12:25:00',3.56),('8902','2013-09-11','12:30:00',3.04),('8902','2013-09-11','12:35:00',5.34),('8902','2013-09-11','12:40:00',7.14),('8902','2013-09-11','12:45:00',2.29),('8902','2013-09-11','12:50:00',3.83),('8902','2013-09-11','12:55:00',3.97),('8902','2013-09-11','13:00:00',8.15),('8902','2013-09-11','13:05:00',5.3),('8902','2013-09-11','13:10:00',6.53),('8902','2013-09-11','13:15:00',8.51),('8902','2013-09-11','13:20:00',8.96),('8902','2013-09-11','13:25:00',9.02),('8902','2013-09-11','13:30:00',7.3),('8902','2013-09-11','13:35:00',6.52),('8902','2013-09-11','13:40:00',5.28),('8902','2013-09-11','13:45:00',6.82),('8902','2013-09-11','13:50:00',8.07),('8902','2013-09-11','13:55:00',7.98),('8902','2013-09-11','14:00:00',8.08),('8902','2013-09-11','14:05:00',7.69),('8902','2013-09-11','14:10:00',6.3),('8902','2013-09-11','14:15:00',7.83),('8902','2013-09-11','14:20:00',7.71),('8902','2013-09-11','14:25:00',8.05),('8902','2013-09-11','14:30:00',7.79),('8902','2013-09-11','14:35:00',6.35),('8902','2013-09-11','14:40:00',5.39),('8902','2013-09-11','14:45:00',7.64),('8902','2013-09-11','14:50:00',7.44),('8902','2013-09-11','14:55:00',7.29),('8902','2013-09-11','15:00:00',7.28),('8902','2013-09-11','15:05:00',5.57),('8902','2013-09-11','15:10:00',6.42),('8902','2013-09-11','15:15:00',6.1),('8902','2013-09-11','15:20:00',6.89),('8902','2013-09-11','15:25:00',6.62),('8902','2013-09-11','15:30:00',6.75),('8902','2013-09-11','15:35:00',6.6),('8902','2013-09-11','15:40:00',6.51),('8902','2013-09-11','15:45:00',6.51),('8902','2013-09-11','15:50:00',6.37),('8902','2013-09-11','15:55:00',6.22),('8902','2013-09-11','16:00:00',6.23),('8902','2013-09-11','16:05:00',5.51),('8902','2013-09-11','16:10:00',4.97),('8902','2013-09-11','16:15:00',4.23),('8902','2013-09-11','16:20:00',4.33),('8902','2013-09-11','16:25:00',4.43),('8902','2013-09-11','16:30:00',3.03),('8902','2013-09-11','16:35:00',2.83),('8902','2013-09-11','16:40:00',3.79),('8902','2013-09-11','16:45:00',5.35),('8902','2013-09-11','16:50:00',1.88),('8902','2013-09-11','16:55:00',3.69),('8902','2013-09-11','17:00:00',2.47),('8902','2013-09-11','17:05:00',4.01),('8902','2013-09-11','17:10:00',3.02),('8902','2013-09-11','17:15:00',4.03),('8902','2013-09-11','17:20:00',2.49),('8902','2013-09-11','17:25:00',1.48),('8902','2013-09-11','17:30:00',2.99),('8902','2013-09-11','17:35:00',3.24),('8902','2013-09-11','17:40:00',2.91),('8902','2013-09-11','17:45:00',2.8),('8902','2013-09-11','17:50:00',2.4),('8902','2013-09-11','17:55:00',2.21),('8902','2013-09-11','18:00:00',1.7),('8902','2013-09-11','18:10:00',1.03),('8902','2013-09-11','18:15:00',1.48),('8902','2013-09-11','18:20:00',1.25),('8902','2013-09-10','08:05:00',1.62),('8902','2013-09-10','08:10:00',1.82),('8902','2013-09-10','08:15:00',1.8),('8902','2013-09-10','08:20:00',1.24),('8902','2013-09-10','08:25:00',1.08),('8902','2013-09-10','08:30:00',1.54),('8902','2013-09-10','08:35:00',1.38),('8902','2013-09-10','08:40:00',1.35),('8902','2013-09-10','08:45:00',1.21),('8902','2013-09-10','08:50:00',1.67),('8902','2013-09-10','08:55:00',1.8),('8902','2013-09-10','09:00:00',3.51),('8902','2013-09-10','09:05:00',3.18),('8902','2013-09-10','09:10:00',3.51),('8902','2013-09-10','09:15:00',3.65),('8902','2013-09-10','09:20:00',3.79),('8902','2013-09-10','09:25:00',3.92),('8902','2013-09-10','09:30:00',2.82),('8902','2013-09-10','09:35:00',3.39),('8902','2013-09-10','09:40:00',3.32),('8902','2013-09-10','09:45:00',1.46),('8902','2013-09-10','09:50:00',1.63),('8902','2013-09-10','09:55:00',1.64),('8902','2013-09-10','10:00:00',2.01),('8902','2013-09-10','10:05:00',5.39),('8902','2013-09-10','10:15:00',2.54),('8902','2013-09-10','10:20:00',5.8),('8902','2013-09-10','10:25:00',4.45),('8902','2013-09-10','10:30:00',4.29),('8902','2013-09-10','10:35:00',5.8),('8902','2013-09-10','10:40:00',6.9),('8902','2013-09-10','10:45:00',5.26),('8902','2013-09-10','10:50:00',5.88),('8902','2013-09-10','10:55:00',3.48),('8902','2013-09-10','11:00:00',2.92),('8902','2013-09-10','11:05:00',5.49),('8902','2013-09-10','11:10:00',7.53),('8902','2013-09-10','11:15:00',5.48),('8902','2013-09-10','11:20:00',7.58),('8902','2013-09-10','11:25:00',6.44),('8902','2013-09-10','11:30:00',1.27),('8902','2013-09-10','11:35:00',5.85),('8902','2013-09-10','11:40:00',4.55),('8902','2013-09-10','11:45:00',7.6),('8902','2013-09-10','11:50:00',7.6),('8902','2013-09-10','11:55:00',7.08),('8902','2013-09-10','12:00:00',5.72),('8902','2013-09-10','12:05:00',7.36),('8902','2013-09-10','12:10:00',4.13),('8902','2013-09-10','12:15:00',4.75),('8902','2013-09-10','12:20:00',5.24),('8902','2013-09-10','12:25:00',4.31),('8902','2013-09-10','12:30:00',8.08),('8902','2013-09-10','12:35:00',4.39),('8902','2013-09-10','12:40:00',3.33),('8902','2013-09-10','12:45:00',6),('8902','2013-09-10','12:50:00',7.99),('8902','2013-09-10','12:55:00',8.03),('8902','2013-09-10','13:00:00',7.22),('8902','2013-09-10','13:05:00',8.12),('8902','2013-09-10','13:10:00',8.08),('8902','2013-09-10','13:15:00',8.36),('8902','2013-09-10','13:20:00',8.54),('8902','2013-09-10','13:25:00',8.01),('8902','2013-09-10','13:30:00',7.35),('8902','2013-09-10','13:35:00',4.24),('8902','2013-09-10','13:40:00',7.65),('8902','2013-09-10','13:45:00',4.7),('8902','2013-09-10','13:50:00',8.66),('8902','2013-09-10','13:55:00',5.23),('8902','2013-09-10','14:00:00',6.74),('8902','2013-09-10','14:05:00',8.08),('8902','2013-09-10','14:10:00',4.56),('8902','2013-09-10','14:15:00',7.52),('8902','2013-09-10','14:20:00',6.08),('8902','2013-09-10','14:25:00',7.8),('8902','2013-09-10','14:30:00',7.75),('8902','2013-09-10','14:35:00',7.11),('8902','2013-09-10','14:40:00',3.95),('8902','2013-09-10','14:45:00',6.89),('8902','2013-09-10','14:50:00',6.56),('8902','2013-09-10','14:55:00',5.41),('8902','2013-09-10','15:00:00',6.68),('8902','2013-09-10','15:05:00',7.09),('8902','2013-09-10','15:10:00',5.37),('8902','2013-09-10','15:15:00',6.75),('8902','2013-09-10','15:20:00',7.82),('8902','2013-09-10','15:25:00',3.98),('8902','2013-09-10','15:30:00',5.23),('8902','2013-09-10','15:35:00',1.83),('8902','2013-09-10','15:40:00',2.39),('8902','2013-09-10','15:45:00',5.01),('8902','2013-09-10','15:50:00',6.04),('8902','2013-09-10','15:55:00',6.24),('8902','2013-09-10','16:00:00',6.07),('8902','2013-09-10','16:05:00',4.94),('8902','2013-09-10','16:10:00',6.13),('8902','2013-09-10','16:15:00',5.97),('8902','2013-09-10','16:20:00',5.51),('8902','2013-09-10','16:25:00',4.17),('8902','2013-09-10','16:30:00',5.07),('8902','2013-09-10','16:35:00',4.03),('8902','2013-09-10','16:40:00',3.11),('8902','2013-09-10','16:45:00',5.05),('8902','2013-09-10','16:50:00',4.2),('8902','2013-09-10','16:55:00',4.09),('8902','2013-09-10','17:00:00',3.14),('8902','2013-09-10','17:05:00',4.15),('8902','2013-09-10','17:10:00',3.95),('8902','2013-09-10','17:15:00',3.73),('8902','2013-09-10','17:20:00',3.54),('8902','2013-09-10','17:25:00',3.35),('8902','2013-09-10','17:30:00',3.11),('8902','2013-09-10','17:35:00',2.96),('8902','2013-09-10','17:40:00',2.8),('8902','2013-09-10','17:45:00',2.4),('8902','2013-09-10','17:50:00',2.44),('8902','2013-09-10','17:55:00',1.76),('8902','2013-09-10','18:00:00',2.12),('8902','2013-09-10','18:05:00',1.83),('8902','2013-09-10','18:10:00',1.59),('8902','2013-09-10','18:15:00',1.44),('8902','2013-09-10','18:20:00',1.01),('8902','2013-09-10','18:25:00',1.07),('8902','2013-09-09','07:55:00',1.16),('8902','2013-09-09','08:00:00',1.28),('8902','2013-09-09','08:05:00',1.11),('8902','2013-09-09','08:10:00',1.29),('8902','2013-09-09','08:15:00',1.52),('8902','2013-09-09','08:20:00',1.27),('8902','2013-09-09','08:25:00',1.05),('8902','2013-09-09','08:40:00',1.15),('8902','2013-09-09','08:45:00',1.42),('8902','2013-09-09','08:50:00',1.48),('8902','2013-09-09','08:55:00',2.79),('8902','2013-09-09','09:00:00',3.04),('8902','2013-09-09','09:05:00',3.53),('8902','2013-09-09','09:10:00',4.14),('8902','2013-09-09','09:15:00',3.58),('8902','2013-09-09','09:20:00',2.62),('8902','2013-09-09','09:25:00',2.74),('8902','2013-09-09','09:30:00',4.58),('8902','2013-09-09','09:35:00',5.33),('8902','2013-09-09','09:40:00',3.15),('8902','2013-09-09','09:45:00',2.59),('8902','2013-09-09','09:50:00',2.36),('8902','2013-09-09','09:55:00',2.19),('8902','2013-09-09','10:00:00',1.63),('8902','2013-09-09','10:05:00',1.44),('8902','2013-09-09','10:10:00',1.26),('8902','2013-09-09','10:15:00',1.19),('8902','2013-09-09','10:20:00',1.73),('8902','2013-09-09','10:25:00',1.88),('8902','2013-09-09','10:30:00',1.92),('8902','2013-09-09','10:35:00',2.2),('8902','2013-09-09','10:40:00',2.85),('8902','2013-09-09','10:45:00',3.78),('8902','2013-09-09','10:50:00',2.4),('8902','2013-09-09','10:55:00',2.46),('8902','2013-09-09','11:00:00',2.91),('8902','2013-09-09','11:05:00',2.42),('8902','2013-09-09','11:10:00',2.59),('8902','2013-09-09','11:15:00',2.29),('8902','2013-09-09','11:20:00',2.46),('8902','2013-09-09','11:25:00',2.85),('8902','2013-09-09','11:30:00',2.13),('8902','2013-09-09','11:35:00',1.49),('8902','2013-09-09','11:40:00',1.59),('8902','2013-09-09','11:45:00',2.41),('8902','2013-09-09','11:50:00',2.45),('8902','2013-09-09','11:55:00',3.11),('8902','2013-09-09','12:00:00',2.47),('8902','2013-09-09','12:05:00',2.03),('8902','2013-09-09','12:10:00',1.89),('8902','2013-09-09','12:15:00',1.9),('8902','2013-09-09','12:20:00',2.09),('8902','2013-09-09','12:25:00',2.06),('8902','2013-09-09','12:30:00',1.71),('8902','2013-09-09','12:35:00',1.66),('8902','2013-09-09','12:40:00',1.35),('8902','2013-09-09','12:45:00',1.21),('8902','2013-09-09','12:50:00',1.14),('8902','2013-09-09','12:55:00',1.04),('8902','2013-09-09','13:00:00',1.22),('8902','2013-09-09','13:05:00',1.12),('8902','2013-09-09','13:10:00',1.08),('8902','2013-09-09','13:15:00',1.59),('8902','2013-09-09','13:20:00',1.7),('8902','2013-09-09','13:25:00',2),('8902','2013-09-09','13:30:00',1.87),('8902','2013-09-09','13:35:00',1.99),('8902','2013-09-09','13:40:00',3.37),('8902','2013-09-09','13:45:00',5.48),('8902','2013-09-09','13:50:00',3.56),('8902','2013-09-09','13:55:00',2.93),('8902','2013-09-09','14:00:00',2.08),('8902','2013-09-09','14:05:00',2.23),('8902','2013-09-09','14:10:00',2.52),('8902','2013-09-09','14:15:00',3.07),('8902','2013-09-09','14:20:00',2.76),('8902','2013-09-09','14:25:00',4.18),('8902','2013-09-09','14:30:00',3.85),('8902','2013-09-09','14:35:00',2.87),('8902','2013-09-09','14:40:00',3.52),('8902','2013-09-09','14:45:00',3.61),('8902','2013-09-09','14:50:00',4.15),('8902','2013-09-09','14:55:00',3.85),('8902','2013-09-09','15:00:00',4.75),('8902','2013-09-09','15:05:00',4.58),('8902','2013-09-09','15:10:00',3.23),('8902','2013-09-09','15:15:00',3.13),('8902','2013-09-09','15:20:00',4),('8902','2013-09-09','15:25:00',3.51),('8902','2013-09-09','15:30:00',4.03),('8902','2013-09-09','15:35:00',3.63),('8902','2013-09-09','15:40:00',2.3),('8902','2013-09-09','15:45:00',2.02),('8902','2013-09-09','15:50:00',1.97),('8902','2013-09-09','15:55:00',1.92),('8902','2013-09-09','16:00:00',1.97),('8902','2013-09-09','16:05:00',2.24),('8902','2013-09-09','16:10:00',2.5),('8902','2013-09-09','16:15:00',2.83),('8902','2013-09-09','16:20:00',2.06),('8902','2013-09-09','16:25:00',1.87),('8902','2013-09-09','16:30:00',1.51),('8902','2013-09-09','16:45:00',1.08),('8902','2013-09-09','16:50:00',1.44),('8902','2013-09-09','16:55:00',1.47),('8902','2013-09-09','17:00:00',1.29),('8902','2013-09-09','17:05:00',1.18),('8902','2013-09-09','17:10:00',1.31),('8902','2013-09-09','17:15:00',1.53),('8902','2013-09-09','17:20:00',1.57),('8902','2013-09-09','17:25:00',1.51),('8902','2013-09-09','17:30:00',1.33),('8902','2013-09-09','17:35:00',1.09),('8902','2013-09-09','17:40:00',1.01),('8902','2013-09-09','17:45:00',1.27),('8902','2013-09-09','17:50:00',1.44),('8902','2013-09-09','17:55:00',1.22),('8902','2013-09-09','18:00:00',1.04),('8902','2013-09-08','07:35:00',1.08),('8902','2013-09-08','07:40:00',1.36),('8902','2013-09-08','07:45:00',1.54),('8902','2013-09-08','07:50:00',1.61),('8902','2013-09-08','07:55:00',1.55),('8902','2013-09-08','08:00:00',1.45),('8902','2013-09-08','08:05:00',1.13),('8902','2013-09-08','08:10:00',1.05),('8902','2013-09-08','08:15:00',1.02),('8902','2013-09-08','08:20:00',1.06),('8902','2013-09-08','08:25:00',1.12),('8902','2013-09-08','08:30:00',1.11),('8902','2013-09-08','08:35:00',1.07),('8902','2013-09-08','08:40:00',1.25),('8902','2013-09-08','08:45:00',1.62),('8902','2013-09-08','08:50:00',1.83),('8902','2013-09-08','08:55:00',2.11),('8902','2013-09-08','09:00:00',2.24),('8902','2013-09-08','09:05:00',2.08),('8902','2013-09-08','09:10:00',1.72),('8902','2013-09-08','09:15:00',1.15),('8902','2013-09-08','09:20:00',1.37),('8902','2013-09-08','09:25:00',1.31),('8902','2013-09-08','09:30:00',1.34),('8902','2013-09-08','09:35:00',1.97),('8902','2013-09-08','09:40:00',1.94),('8902','2013-09-08','09:45:00',1.56),('8902','2013-09-08','09:50:00',1.51),('8902','2013-09-08','09:55:00',1.55),('8902','2013-09-08','10:00:00',2.53),('8902','2013-09-08','10:05:00',2.94),('8902','2013-09-08','10:10:00',3.42),('8902','2013-09-08','10:15:00',3.37),('8902','2013-09-08','10:20:00',2.54),('8902','2013-09-08','10:25:00',2.31),('8902','2013-09-08','10:30:00',2.87),('8902','2013-09-08','10:35:00',3.31),('8902','2013-09-08','10:40:00',3.35),('8902','2013-09-08','10:45:00',3.59),('8902','2013-09-08','10:50:00',4.69),('8902','2013-09-08','10:55:00',4.64),('8902','2013-09-08','11:00:00',5.12),('8902','2013-09-08','11:05:00',4.15),('8902','2013-09-08','11:10:00',3.31),('8902','2013-09-08','11:15:00',3.66),('8902','2013-09-08','11:20:00',4.01),('8902','2013-09-08','11:25:00',5.18),('8902','2013-09-08','11:30:00',4.17),('8902','2013-09-08','11:35:00',3.87),('8902','2013-09-08','11:40:00',4.9),('8902','2013-09-08','11:45:00',6.67),('8902','2013-09-08','11:50:00',6.8),('8902','2013-09-08','11:55:00',4.9),('8902','2013-09-08','12:00:00',5.35),('8902','2013-09-08','12:05:00',6.36),('8902','2013-09-08','12:10:00',4.97),('8902','2013-09-08','12:15:00',3.54),('8902','2013-09-08','12:20:00',3.52),('8902','2013-09-08','12:25:00',2.69),('8902','2013-09-08','12:30:00',2.42),('8902','2013-09-08','12:35:00',2.18),('8902','2013-09-08','12:40:00',2.69),('8902','2013-09-08','12:45:00',3.62),('8902','2013-09-08','12:50:00',2.56),('8902','2013-09-08','12:55:00',3.01),('8902','2013-09-08','13:00:00',3.03),('8902','2013-09-08','13:05:00',4.55),('8902','2013-09-08','13:10:00',6.16),('8902','2013-09-08','13:15:00',6),('8902','2013-09-08','13:20:00',3.21),('8902','2013-09-08','13:25:00',4.38),('8902','2013-09-08','13:30:00',4.54),('8902','2013-09-08','13:35:00',7.77),('8902','2013-09-08','13:40:00',7.44),('8902','2013-09-08','13:45:00',7.51),('8902','2013-09-08','13:50:00',7.41),('8902','2013-09-08','13:55:00',7.82),('8902','2013-09-08','14:00:00',7.26),('8902','2013-09-08','14:05:00',6.78),('8902','2013-09-08','14:10:00',6.1),('8902','2013-09-08','14:15:00',5.25),('8902','2013-09-08','14:20:00',4.53),('8902','2013-09-08','14:25:00',3.44),('8902','2013-09-08','14:30:00',3.41),('8902','2013-09-08','14:35:00',7.42),('8902','2013-09-08','14:40:00',5.74),('8902','2013-09-08','14:45:00',3.51),('8902','2013-09-08','14:50:00',5.8),('8902','2013-09-08','14:55:00',6.4),('8902','2013-09-08','15:00:00',5.49),('8902','2013-09-08','15:05:00',4.94),('8902','2013-09-08','15:10:00',6.52),('8902','2013-09-08','15:15:00',3.4),('8902','2013-09-08','15:20:00',3.96),('8902','2013-09-08','15:25:00',2.3),('8902','2013-09-08','15:30:00',5.54),('8902','2013-09-08','15:35:00',4.63),('8902','2013-09-08','15:40:00',4.47),('8902','2013-09-08','15:45:00',2.19),('8902','2013-09-08','15:50:00',2.14),('8902','2013-09-08','15:55:00',2.54),('8902','2013-09-08','16:00:00',3.12),('8902','2013-09-08','16:05:00',2.47),('8902','2013-09-08','16:10:00',3.13),('8902','2013-09-08','16:15:00',4.44),('8902','2013-09-08','16:20:00',3.78),('8902','2013-09-08','16:25:00',2.01),('8902','2013-09-08','16:30:00',2.05),('8902','2013-09-08','16:35:00',2.22),('8902','2013-09-08','16:40:00',2.42),('8902','2013-09-08','16:45:00',4.37),('8902','2013-09-08','16:50:00',1.71),('8902','2013-09-08','16:55:00',1.32),('8902','2013-09-08','17:00:00',1.82),('8902','2013-09-08','17:05:00',1.65),('8902','2013-09-08','17:10:00',1.57),('8902','2013-09-08','17:15:00',1.11),('8902','2013-09-08','17:35:00',1.15),('8902','2013-09-08','17:40:00',1.22),('8902','2013-09-08','18:10:00',1.3),('8902','2013-09-08','18:15:00',1.77),('8902','2013-09-08','18:20:00',1.5),('8902','2013-09-08','18:25:00',1.1),('8902','2013-09-08','18:30:00',1.04),('8902','2014-04-11','08:10:00',1.2),('8902','2014-04-11','08:15:00',1.43),('8902','2014-04-11','08:20:00',1.45),('8902','2014-04-11','08:25:00',1.79),('8902','2014-04-11','08:30:00',1.35),('8902','2014-04-11','08:35:00',1.07),('8902','2014-04-11','08:40:00',1.15),('8902','2014-04-11','08:45:00',1.13),('8902','2014-04-11','08:50:00',1.22),('8902','2014-04-11','08:55:00',1.25),('8902','2014-04-11','09:00:00',1.26),('8902','2014-04-11','09:05:00',1.49),('8902','2014-04-11','09:10:00',1.88),('8902','2014-04-11','09:15:00',2.44),('8902','2014-04-11','09:20:00',2.91),('8902','2014-04-11','09:25:00',4.32),('8902','2014-04-11','09:30:00',2.83),('8902','2014-04-11','09:35:00',2.66),('8902','2014-04-11','09:40:00',2.28),('8902','2014-04-11','09:45:00',2.13),('8902','2014-04-11','09:50:00',2.01),('8902','2014-04-11','09:55:00',1.97),('8902','2014-04-11','10:00:00',1.99),('8902','2014-04-11','10:05:00',2.15),('8902','2014-04-11','10:10:00',2.36),('8902','2014-04-11','10:15:00',2.64),('8902','2014-04-11','10:20:00',2.9),('8902','2014-04-11','10:25:00',3.3),('8902','2014-04-11','10:30:00',3.75),('8902','2014-04-11','10:35:00',4.16),('8902','2014-04-11','10:40:00',4.84),('8902','2014-04-11','10:45:00',4.99),('8902','2014-04-11','10:50:00',4.73),('8902','2014-04-11','10:55:00',3.67),('8902','2014-04-11','11:00:00',5.21),('8902','2014-04-11','11:05:00',6.03),('8902','2014-04-11','11:10:00',7.41),('8902','2014-04-11','11:15:00',7.9),('8902','2014-04-11','11:20:00',7.51),('8902','2014-04-11','11:25:00',7.05),('8902','2014-04-11','11:30:00',6.15),('8902','2014-04-11','11:35:00',6.66),('8902','2014-04-11','11:40:00',7.2),('8902','2014-04-11','11:45:00',7.35),('8902','2014-04-11','11:50:00',6.19),('8902','2014-04-11','11:55:00',3.74),('8902','2014-04-11','12:00:00',3.72),('8902','2014-04-11','12:05:00',4.07),('8902','2014-04-11','12:10:00',3.2),('8902','2014-04-11','12:15:00',3.19),('8902','2014-04-11','12:20:00',3.23),('8902','2014-04-11','12:25:00',3.38),('8902','2014-04-11','12:30:00',5.16),('8902','2014-04-11','12:35:00',4.9),('8902','2014-04-11','12:40:00',5.53),('8902','2014-04-11','12:45:00',6.11),('8902','2014-04-11','12:50:00',6.16),('8902','2014-04-11','12:55:00',3.84),('8902','2014-04-11','13:00:00',2.57),('8902','2014-04-11','13:05:00',2.94),('8902','2014-04-11','13:10:00',5.32),('8902','2014-04-11','13:15:00',7.73),('8902','2014-04-11','13:20:00',8.39),('8902','2014-04-11','13:25:00',8.41),('8902','2014-04-11','13:30:00',6.62),('8902','2014-04-11','13:35:00',3.55),('8902','2014-04-11','13:40:00',3.5),('8902','2014-04-11','13:45:00',2.76),('8902','2014-04-11','13:50:00',3.22),('8902','2014-04-11','13:55:00',2.94),('8902','2014-04-11','14:00:00',2.66),('8902','2014-04-11','14:05:00',3.9),('8902','2014-04-11','14:10:00',6.08),('8902','2014-04-11','14:15:00',8.25),('8902','2014-04-11','14:20:00',5.77),('8902','2014-04-11','14:25:00',8.2),('8902','2014-04-11','14:30:00',6.75),('8902','2014-04-11','14:35:00',5.48),('8902','2014-04-11','14:40:00',5.35),('8902','2014-04-11','14:45:00',5.83),('8902','2014-04-11','14:50:00',7.76),('8902','2014-04-11','14:55:00',7.53),('8902','2014-04-11','15:00:00',6.96),('8902','2014-04-11','15:05:00',7.2),('8902','2014-04-11','15:10:00',7.23),('8902','2014-04-11','15:15:00',7.3),('8902','2014-04-11','15:20:00',6.18),('8902','2014-04-11','15:25:00',5.74),('8902','2014-04-11','15:30:00',4.04),('8902','2014-04-11','15:35:00',5.21),('8902','2014-04-11','15:40:00',6.04),('8902','2014-04-11','15:45:00',6.27),('8902','2014-04-11','15:50:00',7.16),('8902','2014-04-11','15:55:00',6.89),('8902','2014-04-11','16:00:00',6.86),('8902','2014-04-11','16:05:00',6.82),('8902','2014-04-11','16:10:00',6.75),('8902','2014-04-11','16:15:00',6.21),('8902','2014-04-11','16:20:00',6.67),('8902','2014-04-11','16:25:00',5.99),('8902','2014-04-11','16:30:00',5.8),('8902','2014-04-11','16:35:00',5.64),('8902','2014-04-11','16:40:00',3.83),('8902','2014-04-11','16:45:00',3.55),('8902','2014-04-11','16:50:00',2.7),('8902','2014-04-11','16:55:00',3.82),('8902','2014-04-11','17:00:00',4.94),('8902','2014-04-11','17:05:00',4.54),('8902','2014-04-11','17:10:00',4.43),('8902','2014-04-11','17:15:00',4.18),('8902','2014-04-11','17:20:00',3.45),('8902','2014-04-11','17:25:00',3.53),('8902','2014-04-11','17:30:00',2.38),('8902','2014-04-11','17:35:00',2.17),('8902','2014-04-11','17:40:00',2.14),('8902','2014-04-11','17:45:00',2.96),('8902','2014-04-11','17:50:00',3.39),('8902','2014-04-11','17:55:00',2.4),('8902','2014-04-11','18:00:00',2.91),('8902','2014-04-11','18:05:00',2.35),('8902','2014-04-11','18:10:00',1.02),('8902','2014-04-11','18:15:00',1.55),('8902','2014-04-11','18:20:00',1.18),('8902','2013-09-07','08:00:00',1.17),('8902','2013-09-07','08:20:00',1.04),('8902','2013-09-07','08:25:00',1.21),('8902','2013-09-07','08:30:00',1.31),('8902','2013-09-07','08:35:00',1.22),('8902','2013-09-07','08:40:00',1.47),('8902','2013-09-07','08:45:00',1.53),('8902','2013-09-07','08:50:00',1.71),('8902','2013-09-07','08:55:00',1.68),('8902','2013-09-07','09:00:00',1.95),('8902','2013-09-07','09:05:00',2.07),('8902','2013-09-07','09:10:00',2.06),('8902','2013-09-07','09:15:00',2.62),('8902','2013-09-07','09:20:00',2.09),('8902','2013-09-07','09:25:00',2.66),('8902','2013-09-07','09:30:00',3.24),('8902','2013-09-07','09:35:00',4.2),('8902','2013-09-07','09:40:00',3.24),('8902','2013-09-07','09:45:00',3.89),('8902','2013-09-07','09:50:00',4.36),('8902','2013-09-07','09:55:00',4.48),('8902','2013-09-07','10:00:00',4.65),('8902','2013-09-07','10:05:00',4.8),('8902','2013-09-07','10:10:00',4.77),('8902','2013-09-07','10:15:00',4.97),('8902','2013-09-07','10:20:00',5.09),('8902','2013-09-07','10:25:00',5.19),('8902','2013-09-07','10:30:00',5.19),('8902','2013-09-07','10:35:00',5.39),('8902','2013-09-07','10:40:00',5.54),('8902','2013-09-07','10:45:00',5.64),('8902','2013-09-07','10:50:00',5.8),('8902','2013-09-07','10:55:00',5.91),('8902','2013-09-07','11:00:00',6),('8902','2013-09-07','11:05:00',5.99),('8902','2013-09-07','11:10:00',5.95),('8902','2013-09-07','11:15:00',6.08),('8902','2013-09-07','11:20:00',5.3),('8902','2013-09-07','11:25:00',5.99),('8902','2013-09-07','11:30:00',6.32),('8902','2013-09-07','11:35:00',6.42),('8902','2013-09-07','11:40:00',6.44),('8902','2013-09-07','11:45:00',6.51),('8902','2013-09-07','11:50:00',6.45),('8902','2013-09-07','11:55:00',6.5),('8902','2013-09-07','12:00:00',6.4),('8902','2013-09-07','12:05:00',6.36),('8902','2013-09-07','12:10:00',6.42),('8902','2013-09-07','12:15:00',6.62),('8902','2013-09-07','12:20:00',6.67),('8902','2013-09-07','12:25:00',6.71),('8902','2013-09-07','12:30:00',6.74),('8902','2013-09-07','12:35:00',6.92),('8902','2013-09-07','12:40:00',6.53),('8902','2013-09-07','12:45:00',6.36),('8902','2013-09-07','12:50:00',6.74),('8902','2013-09-07','12:55:00',6.88),('8902','2013-09-07','13:00:00',6.87),('8902','2013-09-07','13:05:00',6.95),('8902','2013-09-07','13:10:00',6.95),('8902','2013-09-07','13:15:00',6.82),('8902','2013-09-07','13:20:00',6.75),('8902','2013-09-07','13:25:00',6.61),('8902','2013-09-07','13:30:00',6.25),('8902','2013-09-07','13:35:00',6.1),('8902','2013-09-07','13:40:00',4.83),('8902','2013-09-07','13:45:00',3.97),('8902','2013-09-07','13:50:00',4.93),('8902','2013-09-07','13:55:00',5.29),('8902','2013-09-07','14:00:00',6.35),('8902','2013-09-07','14:05:00',6.49),('8902','2013-09-07','14:10:00',6.95),('8902','2013-09-07','14:15:00',6.34),('8902','2013-09-07','14:20:00',6.43),('8902','2013-09-07','14:25:00',7.59),('8902','2013-09-07','14:30:00',6.7),('8902','2013-09-07','14:35:00',7.09),('8902','2013-09-07','14:40:00',6.89),('8902','2013-09-07','14:45:00',6.85),('8902','2013-09-07','14:50:00',6.82),('8902','2013-09-07','14:55:00',6.67),('8902','2013-09-07','15:00:00',6.7),('8902','2013-09-07','15:05:00',5.82),('8902','2013-09-07','15:10:00',3.64),('8902','2013-09-07','15:15:00',4.88),('8902','2013-09-07','15:20:00',6.35),('8902','2013-09-07','15:25:00',6.41),('8902','2013-09-07','15:30:00',6.55),('8902','2013-09-07','15:35:00',6.32),('8902','2013-09-07','15:40:00',5.9),('8902','2013-09-07','15:45:00',5.92),('8902','2013-09-07','15:50:00',6),('8902','2013-09-07','15:55:00',4.85),('8902','2013-09-07','16:00:00',4.95),('8902','2013-09-07','16:05:00',5.03),('8902','2013-09-07','16:10:00',4.79),('8902','2013-09-07','16:15:00',4.88),('8902','2013-09-07','16:20:00',4.76),('8902','2013-09-07','16:25:00',4.75),('8902','2013-09-07','16:30:00',4.48),('8902','2013-09-07','16:35:00',4.51),('8902','2013-09-07','16:40:00',3.9),('8902','2013-09-07','16:45:00',2.45),('8902','2013-09-07','16:50:00',2.59),('8902','2013-09-07','16:55:00',2.36),('8902','2013-09-07','17:00:00',2.57),('8902','2013-09-07','17:05:00',4.02),('8902','2013-09-07','17:10:00',3.93),('8902','2013-09-07','17:15:00',3.59),('8902','2013-09-07','17:20:00',3.11),('8902','2013-09-07','17:25:00',3.07),('8902','2013-09-07','17:30:00',2.82),('8902','2013-09-07','17:35:00',1.63),('8902','2013-09-07','17:40:00',1.48),('8902','2013-09-07','17:45:00',2.16),('8902','2013-09-07','17:50:00',2.14),('8902','2013-09-07','17:55:00',1.99),('8902','2013-09-07','18:00:00',1.76),('8902','2013-09-07','18:05:00',1.47),('8902','2013-09-07','18:10:00',1.29),('8902','2013-09-07','18:15:00',1.08),('8902','2013-09-06','08:00:00',1.07),('8902','2013-09-06','08:05:00',1.22),('8902','2013-09-06','08:10:00',1.38),('8902','2013-09-06','08:15:00',1.53),('8902','2013-09-06','08:20:00',1.68),('8902','2013-09-06','08:25:00',1.84),('8902','2013-09-06','08:30:00',2.01),('8902','2013-09-06','08:35:00',2.14),('8902','2013-09-06','08:40:00',2.08),('8902','2013-09-06','08:45:00',2.41),('8902','2013-09-06','08:50:00',2.58),('8902','2013-09-06','08:55:00',2.75),('8902','2013-09-06','09:00:00',2.9),('8902','2013-09-06','09:05:00',3.06),('8902','2013-09-06','09:10:00',3.26),('8902','2013-09-06','09:15:00',3.45),('8902','2013-09-06','09:20:00',3.59),('8902','2013-09-06','09:25:00',3.76),('8902','2013-09-06','09:30:00',3.95),('8902','2013-09-06','09:35:00',4.05),('8902','2013-09-06','09:40:00',4.19),('8902','2013-09-06','09:45:00',4.33),('8902','2013-09-06','09:50:00',4.49),('8902','2013-09-06','09:55:00',4.63),('8902','2013-09-06','10:00:00',4.76),('8902','2013-09-06','10:05:00',4.89),('8902','2013-09-06','10:10:00',5.01),('8902','2013-09-06','10:15:00',5.12),('8902','2013-09-06','10:20:00',5.24),('8902','2013-09-06','10:25:00',5.37),('8902','2013-09-06','10:30:00',5.51),('8902','2013-09-06','10:35:00',5.53),('8902','2013-09-06','10:40:00',5.55),('8902','2013-09-06','10:45:00',5.64),('8902','2013-09-06','10:50:00',5.77),('8902','2013-09-06','10:55:00',5.85),('8902','2013-09-06','11:00:00',5.99),('8902','2013-09-06','11:05:00',6.06),('8902','2013-09-06','11:10:00',6.12),('8902','2013-09-06','11:15:00',6.27),('8902','2013-09-06','11:20:00',6.38),('8902','2013-09-06','11:25:00',6.44),('8902','2013-09-06','11:30:00',6.48),('8902','2013-09-06','11:35:00',6.6),('8902','2013-09-06','11:40:00',6.7),('8902','2013-09-06','11:45:00',6.73),('8902','2013-09-06','11:50:00',6.78),('8902','2013-09-06','11:55:00',6.81),('8902','2013-09-06','12:00:00',6.87),('8902','2013-09-06','12:05:00',6.87),('8902','2013-09-06','12:10:00',6.91),('8902','2013-09-06','12:15:00',6.95),('8902','2013-09-06','12:20:00',6.99),('8902','2013-09-06','12:25:00',7.01),('8902','2013-09-06','12:30:00',7.02),('8902','2013-09-06','12:35:00',7.12),('8902','2013-09-06','12:40:00',7),('8902','2013-09-06','12:45:00',6.98),('8902','2013-09-06','12:50:00',7.12),('8902','2013-09-06','12:55:00',7.21),('8902','2013-09-06','13:00:00',7.2),('8902','2013-09-06','13:05:00',7.12),('8902','2013-09-06','13:10:00',7.14),('8902','2013-09-06','13:15:00',6.84),('8902','2013-09-06','13:20:00',7.09),('8902','2013-09-06','13:25:00',7.16),('8902','2013-09-06','13:30:00',7.26),('8902','2013-09-06','13:35:00',7.33),('8902','2013-09-06','13:40:00',7.37),('8902','2013-09-06','13:45:00',6.24),('8902','2013-09-06','13:50:00',3.17),('8902','2013-09-06','13:55:00',7.07),('8902','2013-09-06','14:00:00',7.39),('8902','2013-09-06','14:05:00',6.76),('8902','2013-09-06','14:10:00',7.26),('8902','2013-09-06','14:15:00',7.22),('8902','2013-09-06','14:20:00',7.17),('8902','2013-09-06','14:25:00',6.96),('8902','2013-09-06','14:30:00',6.72),('8902','2013-09-06','14:35:00',6.93),('8902','2013-09-06','14:40:00',6.91),('8902','2013-09-06','14:45:00',6.95),('8902','2013-09-06','14:50:00',6.88),('8902','2013-09-06','14:55:00',6.79),('8902','2013-09-06','15:00:00',6.78),('8902','2013-09-06','15:05:00',6.67),('8902','2013-09-06','15:10:00',6.56),('8902','2013-09-06','15:15:00',6.58),('8902','2013-09-06','15:20:00',6.42),('8902','2013-09-06','15:25:00',6.38),('8902','2013-09-06','15:30:00',6.31),('8902','2013-09-06','15:35:00',6.2),('8902','2013-09-06','15:40:00',6.05),('8902','2013-09-06','15:45:00',5.96),('8902','2013-09-06','15:50:00',5.87),('8902','2013-09-06','15:55:00',5.76),('8902','2013-09-06','16:00:00',5.65),('8902','2013-09-06','16:05:00',5.54),('8902','2013-09-06','16:10:00',5.4),('8902','2013-09-06','16:15:00',5.26),('8902','2013-09-06','16:20:00',5.07),('8902','2013-09-06','16:25:00',4.94),('8902','2013-09-06','16:30:00',4.79),('8902','2013-09-06','16:35:00',4.68),('8902','2013-09-06','16:40:00',4.52),('8902','2013-09-06','16:45:00',4.4),('8902','2013-09-06','16:50:00',4.24),('8902','2013-09-06','16:55:00',4.1),('8902','2013-09-06','17:00:00',3.91),('8902','2013-09-06','17:05:00',3.77),('8902','2013-09-06','17:10:00',3.6),('8902','2013-09-06','17:15:00',3.46),('8902','2013-09-06','17:20:00',3.29),('8902','2013-09-06','17:25:00',3.08),('8902','2013-09-06','17:30:00',2.88),('8902','2013-09-06','17:35:00',2.71),('8902','2013-09-06','17:40:00',2.59),('8902','2013-09-06','17:45:00',2.46),('8902','2013-09-06','17:50:00',2.24),('8902','2013-09-06','17:55:00',2.06),('8902','2013-09-06','18:00:00',1.88),('8902','2013-09-06','18:05:00',1.71),('8902','2013-09-06','18:10:00',1.48),('8902','2013-09-06','18:15:00',1.36),('8902','2013-09-06','18:20:00',1.22),('8902','2013-09-06','18:25:00',1.07),('8902','2013-09-05','08:00:00',1.08),('8902','2013-09-05','08:05:00',1.24),('8902','2013-09-05','08:10:00',1.4),('8902','2013-09-05','08:15:00',1.55),('8902','2013-09-05','08:20:00',1.72),('8902','2013-09-05','08:25:00',1.88),('8902','2013-09-05','08:30:00',2.05),('8902','2013-09-05','08:35:00',2.2),('8902','2013-09-05','08:40:00',2.36),('8902','2013-09-05','08:45:00',2.55),('8902','2013-09-05','08:50:00',2.69),('8902','2013-09-05','08:55:00',2.86),('8902','2013-09-05','09:00:00',3.02),('8902','2013-09-05','09:05:00',3.17),('8902','2013-09-05','09:10:00',3.35),('8902','2013-09-05','09:15:00',3.51),('8902','2013-09-05','09:20:00',3.69),('8902','2013-09-05','09:25:00',3.85),('8902','2013-09-05','09:30:00',3.98),('8902','2013-09-05','09:35:00',4.12),('8902','2013-09-05','09:40:00',4.28),('8902','2013-09-05','09:45:00',4.44),('8902','2013-09-05','09:50:00',4.57),('8902','2013-09-05','09:55:00',4.7),('8902','2013-09-05','10:00:00',4.84),('8902','2013-09-05','10:05:00',4.93),('8902','2013-09-05','10:10:00',5.03),('8902','2013-09-05','10:15:00',5.18),('8902','2013-09-05','10:20:00',5.27),('8902','2013-09-05','10:25:00',5.43),('8902','2013-09-05','10:30:00',5.58),('8902','2013-09-05','10:35:00',5.65),('8902','2013-09-05','10:40:00',5.79),('8902','2013-09-05','10:45:00',5.86),('8902','2013-09-05','10:50:00',5.93),('8902','2013-09-05','10:55:00',6.08),('8902','2013-09-05','11:00:00',6.14),('8902','2013-09-05','11:05:00',6.23),('8902','2013-09-05','11:10:00',6.31),('8902','2013-09-05','11:15:00',6.4),('8902','2013-09-05','11:20:00',6.52),('8902','2013-09-05','11:25:00',6.56),('8902','2013-09-05','11:30:00',6.62),('8902','2013-09-05','11:35:00',6.63),('8902','2013-09-05','11:40:00',6.71),('8902','2013-09-05','11:45:00',6.75),('8902','2013-09-05','11:50:00',6.8),('8902','2013-09-05','11:55:00',6.84),('8902','2013-09-05','12:00:00',6.9),('8902','2013-09-05','12:05:00',6.95),('8902','2013-09-05','12:10:00',6.99),('8902','2013-09-05','12:15:00',7.06),('8902','2013-09-05','12:20:00',7.22),('8902','2013-09-05','12:25:00',7.24),('8902','2013-09-05','12:30:00',7.26),('8902','2013-09-05','12:35:00',7.19),('8902','2013-09-05','12:40:00',7.11),('8902','2013-09-05','12:45:00',7.15),('8902','2013-09-05','12:50:00',7.17),('8902','2013-09-05','12:55:00',7.2),('8902','2013-09-05','13:00:00',7.27),('8902','2013-09-05','13:05:00',7.29),('8902','2013-09-05','13:10:00',7.28),('8902','2013-09-05','13:15:00',7.23),('8902','2013-09-05','13:20:00',7.26),('8902','2013-09-05','13:25:00',7.24),('8902','2013-09-05','13:30:00',7.11),('8902','2013-09-05','16:20:00',5.01),('8902','2013-09-05','16:25:00',4.98),('8902','2013-09-05','16:30:00',4.91),('8902','2013-09-05','16:35:00',4.79),('8902','2013-09-05','16:40:00',4.61),('8902','2013-09-05','16:45:00',4.41),('8902','2013-09-05','16:50:00',4.23),('8902','2013-09-05','16:55:00',4.14),('8902','2013-09-05','17:00:00',3.94),('8902','2013-09-05','17:05:00',3.74),('8902','2013-09-05','17:10:00',3.65),('8902','2013-09-05','17:15:00',3.48),('8902','2013-09-05','17:20:00',3.34),('8902','2013-09-05','17:25:00',3.08),('8902','2013-09-05','17:30:00',2.89),('8902','2013-09-05','17:35:00',2.73),('8902','2013-09-05','17:40:00',2.58),('8902','2013-09-05','17:45:00',2.39),('8902','2013-09-05','17:50:00',2.14),('8902','2013-09-05','17:55:00',2.03),('8902','2013-09-05','18:00:00',1.9),('8902','2013-09-05','18:05:00',1.76),('8902','2013-09-05','18:10:00',1.57),('8902','2013-09-05','18:15:00',1.33),('8902','2013-09-05','18:20:00',1.19),('8902','2013-09-05','18:25:00',1.05),('8902','2013-09-04','08:00:00',1.18),('8902','2013-09-04','08:05:00',1.35),('8902','2013-09-04','08:10:00',1.52),('8902','2013-09-04','08:15:00',1.7),('8902','2013-09-04','08:20:00',1.89),('8902','2013-09-04','08:25:00',2.07),('8902','2013-09-04','08:30:00',2.25),('8902','2013-09-04','08:35:00',2.41),('8902','2013-09-04','08:40:00',2.58),('8902','2013-09-04','08:45:00',2.7),('8902','2013-09-04','08:50:00',2.91),('8902','2013-09-04','08:55:00',3.09),('8902','2013-09-04','09:00:00',3.26),('8902','2013-09-04','09:05:00',3.42),('8902','2013-09-04','09:10:00',3.59),('8902','2013-09-04','09:15:00',3.76),('8902','2013-09-04','09:20:00',3.94),('8902','2013-09-04','09:25:00',4.12),('8902','2013-09-04','09:30:00',4.26),('8902','2013-09-04','09:35:00',4.4),('8902','2013-09-04','09:40:00',4.54),('8902','2013-09-04','09:45:00',4.68),('8902','2013-09-04','09:50:00',4.83),('8902','2013-09-04','09:55:00',4.97),('8902','2013-09-04','10:00:00',5.1),('8902','2013-09-04','10:05:00',5.22),('8902','2013-09-04','10:10:00',5.34),('8902','2013-09-04','10:15:00',5.44),('8902','2013-09-04','10:20:00',5.56),('8902','2013-09-04','10:25:00',5.65),('8902','2013-09-04','10:30:00',5.78),('8902','2013-09-04','10:35:00',5.86),('8902','2013-09-04','10:40:00',5.93),('8902','2013-09-04','10:45:00',6.03),('8902','2013-09-04','10:50:00',6.12),('8902','2013-09-04','10:55:00',6.22),('8902','2013-09-04','11:00:00',6.31),('8902','2013-09-04','11:05:00',6.42),('8902','2013-09-04','11:10:00',6.48),('8902','2013-09-04','11:15:00',6.56),('8902','2013-09-04','11:20:00',6.6),('8902','2013-09-04','11:25:00',6.69),('8902','2013-09-04','11:30:00',6.76),('8902','2013-09-04','11:35:00',6.77),('8902','2013-09-04','11:40:00',6.74),('8902','2013-09-04','11:45:00',6.76),('8902','2013-09-04','11:50:00',6.98),('8902','2013-09-04','11:55:00',7.05),('8902','2013-09-04','12:00:00',7.05),('8902','2013-09-04','12:05:00',7.13),('8902','2013-09-04','12:10:00',7.19),('8902','2013-09-04','12:15:00',7.26),('8902','2013-09-04','12:20:00',7.29),('8902','2013-09-04','12:25:00',7.28),('8902','2013-09-04','12:30:00',7.29),('8902','2013-09-04','12:35:00',7.32),('8902','2013-09-04','12:40:00',7.27),('8902','2013-09-04','12:45:00',7.31),('8902','2013-09-04','12:50:00',7.32),('8902','2013-09-04','12:55:00',7.36),('8902','2013-09-04','13:00:00',7.39),('8902','2013-09-04','13:05:00',7.4),('8902','2013-09-04','13:10:00',7.42),('8902','2013-09-04','13:15:00',7.39),('8902','2013-09-04','13:20:00',7.4),('8902','2013-09-04','13:25:00',7.44),('8902','2013-09-04','13:30:00',7.43),('8902','2013-09-04','13:35:00',7.43),('8902','2013-09-04','13:40:00',7.46),('8902','2013-09-04','13:45:00',7.43),('8902','2013-09-04','13:50:00',7.4),('8902','2013-09-04','13:55:00',7.33),('8902','2013-09-04','14:00:00',7.27),('8902','2013-09-04','14:05:00',7.28),('8902','2013-09-04','14:10:00',7.28),('8902','2013-09-04','14:15:00',7.16),('8902','2013-09-04','14:20:00',7.15),('8902','2013-09-04','14:25:00',7.1),('8902','2013-09-04','14:30:00',7.04),('8902','2013-09-04','14:35:00',6.94),('8902','2013-09-04','14:40:00',6.85),('8902','2013-09-04','14:45:00',6.79),('8902','2013-09-04','14:50:00',6.81),('8902','2013-09-04','14:55:00',6.79),('8902','2013-09-04','15:00:00',6.83),('8902','2013-09-04','15:05:00',6.8),('8902','2013-09-04','15:10:00',6.73),('8902','2013-09-04','15:15:00',6.6),('8902','2013-09-04','15:20:00',6.57),('8902','2013-09-04','15:25:00',6.49),('8902','2013-09-04','15:30:00',6.39),('8902','2013-09-04','15:35:00',6.29),('8902','2013-09-04','15:40:00',6.18),('8902','2013-09-04','15:45:00',6.06),('8902','2013-09-04','15:50:00',6),('8902','2013-09-04','15:55:00',5.97),('8902','2013-09-04','16:00:00',5.92),('8902','2013-09-04','16:05:00',5.78),('8902','2013-09-04','16:10:00',5.67),('8902','2013-09-04','16:15:00',5.61),('8902','2013-09-04','16:20:00',5.47),('8902','2013-09-04','16:25:00',5.3),('8902','2013-09-04','16:30:00',5.25),('8902','2013-09-04','16:35:00',5.21),('8902','2013-09-04','16:40:00',5.12),('8902','2013-09-04','16:45:00',4.99),('8902','2013-09-04','16:50:00',4.33),('8902','2013-09-04','16:55:00',3.45),('8902','2013-09-04','17:00:00',2.72),('8902','2013-09-04','17:05:00',2.93),('8902','2013-09-04','17:10:00',2.96),('8902','2013-09-04','17:15:00',2.63),('8902','2013-09-04','17:20:00',2.94),('8902','2013-09-04','17:25:00',2.88),('8902','2013-09-04','17:30:00',2.92),('8902','2013-09-04','17:35:00',2.92),('8902','2013-09-04','17:40:00',3.16),('8902','2013-09-04','17:45:00',2.86),('8902','2013-09-04','17:50:00',2.47),('8902','2013-09-04','17:55:00',2.12),('8902','2013-09-04','18:00:00',1.69),('8902','2013-09-04','18:05:00',1.4),('8902','2013-09-04','18:10:00',1.31),('8902','2013-09-04','18:15:00',1.18),('8902','2013-09-04','18:20:00',1.5),('8902','2013-09-04','18:25:00',1.23),('8902','2013-09-03','08:00:00',1.18),('8902','2013-09-03','08:05:00',1.35),('8902','2013-09-03','08:10:00',1.52),('8902','2013-09-03','08:15:00',1.7),('8902','2013-09-03','08:20:00',1.87),('8902','2013-09-03','08:25:00',2.06),('8902','2013-09-03','08:30:00',2.23),('8902','2013-09-03','08:35:00',2.41),('8902','2013-09-03','08:40:00',2.57),('8902','2013-09-03','08:45:00',2.75),('8902','2013-09-03','08:50:00',2.93),('8902','2013-09-03','08:55:00',3.07),('8902','2013-09-03','09:00:00',3.27),('8902','2013-09-03','09:05:00',3.42),('8902','2013-09-03','09:10:00',3.6),('8902','2013-09-03','09:15:00',3.81),('8902','2013-09-03','09:20:00',3.99),('8902','2013-09-03','09:25:00',4.18),('8902','2013-09-03','09:30:00',4.33),('8902','2013-09-03','09:35:00',4.49),('8902','2013-09-03','09:40:00',4.67),('8902','2013-09-03','09:45:00',4.83),('8902','2013-09-03','09:50:00',4.97),('8902','2013-09-03','09:55:00',5.11),('8902','2013-09-03','10:00:00',5.23),('8902','2013-09-03','10:05:00',5.35),('8902','2013-09-03','10:10:00',5.49),('8902','2013-09-03','10:15:00',5.59),('8902','2013-09-03','10:20:00',5.71),('8902','2013-09-03','10:25:00',5.82),('8902','2013-09-03','10:30:00',5.94),('8902','2013-09-03','10:35:00',6.04),('8902','2013-09-03','10:40:00',6.11),('8902','2013-09-03','10:45:00',6.22),('8902','2013-09-03','10:50:00',6.34),('8902','2013-09-03','10:55:00',6.44),('8902','2013-09-03','11:00:00',6.53),('8902','2013-09-03','11:05:00',6.64),('8902','2013-09-03','11:10:00',6.69),('8902','2013-09-03','11:15:00',6.76),('8902','2013-09-03','11:20:00',6.83),('8902','2013-09-03','11:25:00',6.9),('8902','2013-09-03','11:30:00',6.95),('8902','2013-09-03','11:35:00',7.05),('8902','2013-09-03','11:40:00',7.11),('8902','2013-09-03','11:45:00',7.19),('8902','2013-09-03','11:50:00',7.28),('8902','2013-09-03','11:55:00',7.37),('8902','2013-09-03','12:00:00',7.4),('8902','2013-09-03','12:05:00',7.41),('8902','2013-09-03','12:10:00',7.44),('8902','2013-09-03','12:15:00',7.47),('8902','2013-09-03','12:20:00',7.55),('8902','2013-09-03','12:25:00',7.55),('8902','2013-09-03','12:30:00',7.62),('8902','2013-09-03','12:35:00',7.68),('8902','2013-09-03','12:40:00',7.69),('8902','2013-09-03','12:45:00',7.7),('8902','2013-09-03','12:50:00',7.68),('8902','2013-09-03','12:55:00',7.73),('8902','2013-09-03','13:00:00',7.68),('8902','2013-09-03','13:05:00',7.7),('8902','2013-09-03','13:10:00',7.69),('8902','2013-09-03','13:15:00',7.67),('8902','2013-09-03','13:20:00',7.68),('8902','2013-09-03','13:25:00',7.71),('8902','2013-09-03','13:30:00',7.68),('8902','2013-09-03','13:35:00',7.72),('8902','2013-09-03','13:40:00',7.69),('8902','2013-09-03','13:45:00',7.65),('8902','2013-09-03','13:50:00',7.63),('8902','2013-09-03','13:55:00',7.58),('8902','2013-09-03','14:00:00',7.58),('8902','2013-09-03','14:05:00',7.57),('8902','2013-09-03','14:10:00',7.56),('8902','2013-09-03','14:15:00',7.52),('8902','2013-09-03','14:20:00',7.42),('8902','2013-09-03','14:25:00',7.43),('8902','2013-09-03','14:30:00',7.4),('8902','2013-09-03','14:35:00',7.34),('8902','2013-09-03','14:40:00',7.3),('8902','2013-09-03','14:45:00',7.28),('8902','2013-09-03','14:50:00',7.23),('8902','2013-09-03','14:55:00',7.14),('8902','2013-09-03','15:00:00',7.06),('8902','2013-09-03','15:05:00',7.01),('8902','2013-09-03','15:10:00',6.91),('8902','2013-09-03','15:15:00',6.87),('8902','2013-09-03','15:20:00',6.82),('8902','2013-09-03','15:25:00',6.71),('8902','2013-09-03','15:30:00',6.63),('8902','2013-09-03','15:35:00',6.49),('8902','2013-09-03','15:40:00',6.41),('8902','2013-09-03','15:45:00',6.32),('8902','2013-09-03','15:50:00',6.21),('8902','2013-09-03','15:55:00',6.09),('8902','2013-09-03','16:00:00',5.95),('8902','2013-09-03','16:05:00',5.83),('8902','2013-09-03','16:10:00',5.72),('8902','2013-09-03','16:15:00',5.63),('8902','2013-09-03','16:20:00',5.5),('8902','2013-09-03','16:25:00',5.33),('8902','2013-09-03','16:30:00',5.23),('8902','2013-09-03','16:35:00',5.09),('8902','2013-09-03','16:40:00',4.92),('8902','2013-09-03','16:45:00',4.77),('8902','2013-09-03','16:50:00',4.66),('8902','2013-09-03','16:55:00',4.51),('8902','2013-09-03','17:00:00',4.33),('8902','2013-09-03','17:05:00',4.15),('8902','2013-09-03','17:10:00',4.02),('8902','2013-09-03','17:15:00',3.86),('8902','2013-09-03','17:20:00',3.7),('8902','2013-09-03','17:25:00',3.51),('8902','2013-09-03','17:30:00',3.32),('8902','2013-09-03','17:35:00',3.13),('8902','2013-09-03','17:40:00',2.93),('8902','2013-09-03','17:45:00',2.76),('8902','2013-09-03','17:50:00',2.55),('8902','2013-09-03','17:55:00',2.37),('8902','2013-09-03','18:00:00',2.18),('8902','2013-09-03','18:05:00',1.99),('8902','2013-09-03','18:10:00',1.79),('8902','2013-09-03','18:15:00',1.54),('8902','2013-09-03','18:20:00',1.37),('8902','2013-09-03','18:25:00',1.19),('8902','2013-09-03','18:30:00',1.04),('8902','2013-09-02','08:00:00',1.15),('8902','2013-09-02','08:05:00',1.29),('8902','2013-09-02','08:10:00',1.44),('8902','2013-09-02','08:15:00',1.59),('8902','2013-09-02','08:20:00',1.75),('8902','2013-09-02','08:25:00',1.91),('8902','2013-09-02','08:30:00',2.08),('8902','2013-09-02','08:35:00',2.24),('8902','2013-09-02','08:40:00',2.38),('8902','2013-09-02','08:45:00',2.54),('8902','2013-09-02','08:50:00',2.72),('8902','2013-09-02','08:55:00',2.88),('8902','2013-09-02','09:00:00',3.05),('8902','2013-09-02','09:05:00',3.22),('8902','2013-09-02','09:10:00',3.39),('8902','2013-09-02','09:15:00',3.55),('8902','2013-09-02','09:20:00',3.74),('8902','2013-09-02','09:25:00',3.91),('8902','2013-09-02','09:30:00',4.06),('8902','2013-09-02','09:35:00',4.2),('8902','2013-09-02','09:40:00',4.33),('8902','2013-09-02','09:45:00',4.49),('8902','2013-09-02','09:50:00',4.62),('8902','2013-09-02','09:55:00',4.74),('8902','2013-09-02','10:00:00',4.84),('8902','2013-09-02','10:05:00',4.96),('8902','2013-09-02','10:10:00',5.09),('8902','2013-09-02','10:15:00',5.23),('8902','2013-09-02','10:20:00',5.38),('8902','2013-09-02','10:25:00',5.5),('8902','2013-09-02','10:30:00',5.6),('8902','2013-09-02','10:35:00',5.77),('8902','2013-09-02','10:40:00',5.94),('8902','2013-09-02','10:45:00',6.07),('8902','2013-09-02','10:50:00',6.14),('8902','2013-09-02','10:55:00',6.21),('8902','2013-09-02','11:00:00',6.29),('8902','2013-09-02','11:05:00',6.35),('8902','2013-09-02','11:10:00',6.43),('8902','2013-09-02','11:15:00',6.52),('8902','2013-09-02','11:20:00',6.58),('8902','2013-09-02','11:25:00',6.68),('8902','2013-09-02','11:30:00',6.72),('8902','2013-09-02','11:35:00',6.78),('8902','2013-09-02','11:40:00',6.84),('8902','2013-09-02','11:45:00',6.89),('8902','2013-09-02','11:50:00',6.95),('8902','2013-09-02','11:55:00',7.04),('8902','2013-09-02','12:00:00',7.09),('8902','2013-09-02','12:05:00',7.17),('8902','2013-09-02','12:10:00',7.25),('8902','2013-09-02','12:15:00',7.32),('8902','2013-09-02','12:20:00',7.35),('8902','2013-09-02','12:25:00',7.41),('8902','2013-09-02','12:30:00',7.43),('8902','2013-09-02','12:35:00',7.45),('8902','2013-09-02','12:40:00',7.5),('8902','2013-09-02','12:45:00',7.52),('8902','2013-09-02','12:50:00',7.51),('8902','2013-09-02','12:55:00',7.55),('8902','2013-09-02','13:00:00',7.52),('8902','2013-09-02','13:05:00',7.54),('8902','2013-09-02','13:10:00',7.51),('8902','2013-09-02','13:15:00',7.52),('8902','2013-09-02','13:20:00',7.53),('8902','2013-09-02','13:25:00',7.47),('8902','2013-09-02','13:30:00',7.53),('8902','2013-09-02','13:35:00',7.51),('8902','2013-09-02','13:40:00',7.45),('8902','2013-09-02','13:45:00',7.52),('8902','2013-09-02','13:50:00',7.55),('8902','2013-09-02','13:55:00',7.48),('8902','2013-09-02','14:00:00',7.31),('8902','2013-09-02','14:05:00',7.29),('8902','2013-09-02','14:10:00',7.28),('8902','2013-09-02','14:15:00',7.3),('8902','2013-09-02','14:20:00',7.26),('8902','2013-09-02','14:25:00',7.23),('8902','2013-09-02','14:30:00',7.22),('8902','2013-09-02','14:35:00',7.24),('8902','2013-09-02','14:40:00',7.21),('8902','2013-09-02','14:45:00',7.18),('8902','2013-09-02','14:50:00',7.16),('8902','2013-09-02','14:55:00',7.06),('8902','2013-09-02','15:00:00',6.94),('8902','2013-09-02','15:05:00',6.81),('8902','2013-09-02','15:10:00',6.79),('8902','2013-09-02','15:15:00',6.73),('8902','2013-09-02','15:20:00',6.6),('8902','2013-09-02','15:25:00',6.54),('8902','2013-09-02','15:30:00',6.39),('8902','2013-09-02','15:35:00',6.28),('8902','2013-09-02','15:40:00',6.21),('8902','2013-09-02','15:45:00',6.15),('8902','2013-09-02','15:50:00',6.1),('8902','2013-09-02','15:55:00',6.03),('8902','2013-09-02','16:00:00',5.92),('8902','2013-09-02','16:05:00',5.8),('8902','2013-09-02','16:10:00',5.67),('8902','2013-09-02','16:15:00',5.54),('8902','2013-09-02','16:20:00',5.45),('8902','2013-09-02','16:25:00',5.25),('8902','2013-09-02','16:30:00',5.16),('8902','2013-09-02','16:35:00',5.03),('8902','2013-09-02','16:40:00',4.88),('8902','2013-09-02','16:45:00',4.69),('8902','2013-09-02','16:50:00',4.6),('8902','2013-09-02','16:55:00',4.5),('8902','2013-09-02','17:00:00',4.34),('8902','2013-09-02','17:05:00',4.13),('8902','2013-09-02','17:10:00',4),('8902','2013-09-02','17:15:00',3.84),('8902','2013-09-02','17:20:00',3.71),('8902','2013-09-02','17:25:00',3.46),('8902','2013-09-02','17:30:00',3.32),('8902','2013-09-02','17:35:00',3.14),('8902','2013-09-02','17:40:00',2.95),('8902','2013-09-02','17:45:00',2.8),('8902','2013-09-02','17:50:00',2.64),('8902','2013-09-02','17:55:00',2.42),('8902','2013-09-02','18:00:00',2.24),('8902','2013-09-02','18:05:00',1.89),('8902','2013-09-02','18:10:00',1.62),('8902','2013-09-02','18:15:00',1.43),('8902','2013-09-02','18:20:00',1.31),('8902','2013-09-02','18:25:00',1.19),('8902','2013-09-02','18:30:00',1.04),('8902','2013-09-01','07:55:00',1.01),('8902','2013-09-01','08:00:00',1.18),('8902','2013-09-01','08:05:00',1.34),('8902','2013-09-01','08:10:00',1.49),('8902','2013-09-01','08:15:00',1.65),('8902','2013-09-01','08:20:00',1.81),('8902','2013-09-01','08:25:00',1.97),('8902','2013-09-01','08:30:00',2.12),('8902','2013-09-01','08:35:00',2.3),('8902','2013-09-01','08:40:00',2.49),('8902','2013-09-01','08:45:00',2.65),('8902','2013-09-01','08:50:00',2.81),('8902','2013-09-01','08:55:00',2.99),('8902','2013-09-01','09:00:00',3.17),('8902','2013-09-01','09:05:00',3.34),('8902','2013-09-01','09:10:00',3.51),('8902','2013-09-01','09:15:00',3.68),('8902','2013-09-01','09:20:00',3.85),('8902','2013-09-01','09:25:00',4.01),('8902','2013-09-01','09:30:00',4.16),('8902','2013-09-01','09:35:00',4.32),('8902','2013-09-01','09:40:00',4.45),('8902','2013-09-01','09:45:00',4.59),('8902','2013-09-01','09:50:00',4.73),('8902','2013-09-01','09:55:00',4.85),('8902','2013-09-01','10:00:00',5),('8902','2013-09-01','10:05:00',5.14),('8902','2013-09-01','10:10:00',5.27),('8902','2013-09-01','10:15:00',5.42),('8902','2013-09-01','10:20:00',5.54),('8902','2013-09-01','10:25:00',5.64),('8902','2013-09-01','10:30:00',5.74),('8902','2013-09-01','10:35:00',5.84),('8902','2013-09-01','10:40:00',5.93),('8902','2013-09-01','10:45:00',6.03),('8902','2013-09-01','10:50:00',6.09),('8902','2013-09-01','10:55:00',6.23),('8902','2013-09-01','11:00:00',6.32),('8902','2013-09-01','11:05:00',6.4),('8902','2013-09-01','11:10:00',6.46),('8902','2013-09-01','11:15:00',6.54),('8902','2013-09-01','11:20:00',6.63),('8902','2013-09-01','11:25:00',6.72),('8902','2013-09-01','11:30:00',6.77),('8902','2013-09-01','11:35:00',6.84),('8902','2013-09-01','11:40:00',6.89),('8902','2013-09-01','11:45:00',6.95),('8902','2013-09-01','11:50:00',7.07),('8902','2013-09-01','11:55:00',7.07),('8902','2013-09-01','12:00:00',7.09),('8902','2013-09-01','12:05:00',7.2),('8902','2013-09-01','12:10:00',7.23),('8902','2013-09-01','12:15:00',7.29),('8902','2013-09-01','12:20:00',7.31),('8902','2013-09-01','12:25:00',7.28),('8902','2013-09-01','12:30:00',7.27),('8902','2013-09-01','12:35:00',7.29),('8902','2013-09-01','12:40:00',7.34),('8902','2013-09-01','12:45:00',7.31),('8902','2013-09-01','12:50:00',7.35),('8902','2013-09-01','12:55:00',7.35),('8902','2013-09-01','13:00:00',7.44),('8902','2013-09-01','13:05:00',7.46),('8902','2013-09-01','13:10:00',7.43),('8902','2013-09-01','13:15:00',7.49),('8902','2013-09-01','13:20:00',7.53),('8902','2013-09-01','13:25:00',7.51),('8902','2013-09-01','13:30:00',7.48),('8902','2013-09-01','13:35:00',7.4),('8902','2013-09-01','13:40:00',7.37),('8902','2013-09-01','13:45:00',6.72),('8902','2013-09-01','13:50:00',1.16),('8902','2013-09-01','13:55:00',3.31),('8902','2013-09-01','14:00:00',7.98),('8902','2013-09-01','14:05:00',7.61),('8902','2013-09-01','14:10:00',6.94),('8902','2013-09-01','14:15:00',7.4),('8902','2013-09-01','14:20:00',7.34),('8902','2013-09-01','14:25:00',7.31),('8902','2013-09-01','14:30:00',7.42),('8902','2013-09-01','14:35:00',7.27),('8902','2013-09-01','14:40:00',7.27),('8902','2013-09-01','14:45:00',7.35),('8902','2013-09-01','14:50:00',7.38),('8902','2013-09-01','14:55:00',7.04),('8902','2013-09-01','15:00:00',6.23),('8902','2013-09-01','15:05:00',6.34),('8902','2013-09-01','15:10:00',4.81),('8902','2013-09-01','15:15:00',6.94),('8902','2013-09-01','15:20:00',6.69),('8902','2013-09-01','15:25:00',5.37),('8902','2013-09-01','15:30:00',3.37),('8902','2013-09-01','15:35:00',6.29),('8902','2013-09-01','15:40:00',6.49),('8902','2013-09-01','15:45:00',6.42),('8902','2013-09-01','15:50:00',6.25),('8902','2013-09-01','15:55:00',6.16),('8902','2013-09-01','16:00:00',5.97),('8902','2013-09-01','16:05:00',5.76),('8902','2013-09-01','16:10:00',5.7),('8902','2013-09-01','16:15:00',5.73),('8902','2013-09-01','16:20:00',5.65),('8902','2013-09-01','16:25:00',5.36),('8902','2013-09-01','16:30:00',5.22),('8902','2013-09-01','16:35:00',5.02),('8902','2013-09-01','16:40:00',4.77),('8902','2013-09-01','16:45:00',4.59),('8902','2013-09-01','16:50:00',4.46),('8902','2013-09-01','16:55:00',4.24),('8902','2013-09-01','17:00:00',4.06),('8902','2013-09-01','17:05:00',3.93),('8902','2013-09-01','17:10:00',3.81),('8902','2013-09-01','17:15:00',3.68),('8902','2013-09-01','17:20:00',3.5),('8902','2013-09-01','17:25:00',3.34),('8902','2013-09-01','17:30:00',3.18),('8902','2013-09-01','17:35:00',2.97),('8902','2013-09-01','17:40:00',2.78),('8902','2013-09-01','17:45:00',2.65),('8902','2013-09-01','17:50:00',2.49),('8902','2013-09-01','17:55:00',2.32),('8902','2013-09-01','18:00:00',2.16),('8902','2013-09-01','18:05:00',1.96),('8902','2013-09-01','18:10:00',1.77),('8902','2013-09-01','18:15:00',1.57),('8902','2013-09-01','18:20:00',1.41),('8902','2013-09-01','18:25:00',1.25),('8902','2013-09-01','18:30:00',1.1),('8902','2013-08-31','07:55:00',1.07),('8902','2013-08-31','08:00:00',1.26),('8902','2013-08-31','08:05:00',1.42),('8902','2013-08-31','08:10:00',1.59),('8902','2013-08-31','08:15:00',1.75),('8902','2013-08-31','08:20:00',1.91),('8902','2013-08-31','08:25:00',2.06),('8902','2013-08-31','08:30:00',2.09),('8902','2013-08-31','08:35:00',2.4),('8902','2013-08-31','08:40:00',2.59),('8902','2013-08-31','08:45:00',2.75),('8902','2013-08-31','08:50:00',2.88),('8902','2013-08-31','08:55:00',3.05),('8902','2013-08-31','09:00:00',3.23),('8902','2013-08-31','09:05:00',3.37),('8902','2013-08-31','09:10:00',3.56),('8902','2013-08-31','09:15:00',3.73),('8902','2013-08-31','09:20:00',3.9),('8902','2013-08-31','09:25:00',4.07),('8902','2013-08-31','09:30:00',4.25),('8902','2013-08-31','09:35:00',4.4),('8902','2013-08-31','09:40:00',4.55),('8902','2013-08-31','09:45:00',4.68),('8902','2013-08-31','09:50:00',4.82),('8902','2013-08-31','09:55:00',4.94),('8902','2013-08-31','10:00:00',5.08),('8902','2013-08-31','10:05:00',5.19),('8902','2013-08-31','10:10:00',5.32),('8902','2013-08-31','10:15:00',5.44),('8902','2013-08-31','10:20:00',5.54),('8902','2013-08-31','10:25:00',5.66),('8902','2013-08-31','10:30:00',5.78),('8902','2013-08-31','10:35:00',5.9),('8902','2013-08-31','10:40:00',6),('8902','2013-08-31','10:45:00',6.06),('8902','2013-08-31','10:50:00',6.12),('8902','2013-08-31','10:55:00',6.22),('8902','2013-08-31','11:00:00',6.37),('8902','2013-08-31','11:05:00',6.5),('8902','2013-08-31','11:10:00',6.56),('8902','2013-08-31','11:15:00',6.57),('8902','2013-08-31','11:20:00',6.61),('8902','2013-08-31','11:25:00',6.71),('8902','2013-08-31','11:30:00',6.76),('8902','2013-08-31','11:35:00',6.91),('8902','2013-08-31','11:40:00',7.02),('8902','2013-08-31','11:45:00',7.06),('8902','2013-08-31','11:50:00',7.09),('8902','2013-08-31','11:55:00',7.18),('8902','2013-08-31','12:00:00',7.18),('8902','2013-08-31','12:05:00',6.9),('8902','2013-08-31','12:10:00',7.21),('8902','2013-08-31','12:15:00',7.24),('8902','2013-08-31','12:20:00',7.37),('8902','2013-08-31','12:25:00',7.21),('8902','2013-08-31','12:30:00',7.37),('8902','2013-08-31','12:35:00',7.43),('8902','2013-08-31','12:40:00',7.45),('8902','2013-08-31','12:45:00',7.42),('8902','2013-08-31','12:50:00',7.47),('8902','2013-08-31','12:55:00',7.46),('8902','2013-08-31','13:00:00',7.55),('8902','2013-08-31','13:05:00',7.58),('8902','2013-08-31','13:10:00',7.62),('8902','2013-08-31','13:15:00',6.47),('8902','2013-08-31','13:20:00',7.66),('8902','2013-08-31','13:25:00',7.71),('8902','2013-08-31','13:30:00',7.65),('8902','2013-08-31','13:35:00',7.57),('8902','2013-08-31','13:40:00',7.56),('8902','2013-08-31','13:45:00',7.57),('8902','2013-08-31','13:50:00',6.68),('8902','2013-08-31','13:55:00',6.72),('8902','2013-08-31','14:00:00',6.1),('8902','2013-08-31','14:05:00',5.79),('8902','2013-08-31','14:10:00',6.84),('8902','2013-08-31','14:15:00',6.98),('8902','2013-08-31','14:20:00',6.59),('8902','2013-08-31','14:25:00',6.34),('8902','2013-08-31','14:30:00',6.62),('8902','2013-08-31','14:35:00',6.43),('8902','2013-08-31','14:40:00',6.46),('8902','2013-08-31','14:45:00',6.58),('8902','2013-08-31','14:50:00',6.64),('8902','2013-08-31','14:55:00',6.41),('8902','2013-08-31','15:00:00',6.4),('8902','2013-08-31','15:05:00',6.37),('8902','2013-08-31','15:10:00',6.17),('8902','2013-08-31','15:15:00',5.95),('8902','2013-08-31','15:20:00',5.73),('8902','2013-08-31','15:25:00',5.21),('8902','2013-08-31','15:30:00',4.16),('8902','2013-08-31','15:35:00',4.83),('8902','2013-08-31','15:40:00',5.57),('8902','2013-08-31','15:45:00',4.71),('8902','2013-08-31','15:50:00',3.63),('8902','2013-08-31','15:55:00',4.6),('8902','2013-08-31','16:00:00',4.89),('8902','2013-08-31','16:05:00',5.4),('8902','2013-08-31','16:10:00',5.79),('8902','2013-08-31','16:15:00',5.44),('8902','2013-08-31','16:20:00',5.24),('8902','2013-08-31','16:25:00',4.89),('8902','2013-08-31','16:30:00',5.54),('8902','2013-08-31','16:35:00',5.19),('8902','2013-08-31','16:40:00',5.07),('8902','2013-08-31','16:45:00',4.73),('8902','2013-08-31','16:50:00',4.42),('8902','2013-08-31','16:55:00',4.14),('8902','2013-08-31','17:00:00',3.4),('8902','2013-08-31','17:05:00',3.27),('8902','2013-08-31','17:10:00',3),('8902','2013-08-31','17:15:00',2.73),('8902','2013-08-31','17:20:00',3.01),('8902','2013-08-31','17:25:00',2.89),('8902','2013-08-31','17:30:00',2.66),('8902','2013-08-31','17:35:00',2.52),('8902','2013-08-31','17:40:00',2.59),('8902','2013-08-31','17:45:00',2.21),('8902','2013-08-31','17:50:00',2.01),('8902','2013-08-31','17:55:00',1.89),('8902','2013-08-31','18:00:00',1.85),('8902','2013-08-31','18:05:00',1.87),('8902','2013-08-31','18:10:00',1.91),('8902','2013-08-31','18:15:00',1.84),('8902','2013-08-31','18:20:00',1.55),('8902','2013-08-31','18:25:00',1.54),('8902','2013-08-31','18:30:00',1.43),('8902','2013-08-31','18:35:00',1.18),('8902','2013-08-31','18:40:00',1.24),('8902','2013-08-31','18:45:00',1.13),('8902','2013-08-30','08:15:00',1.05),('8902','2013-08-30','08:20:00',1.57),('8902','2013-08-30','08:25:00',1.88),('8902','2013-08-30','08:30:00',2.28),('8902','2013-08-30','08:35:00',2.43),('8902','2013-08-30','08:40:00',2.65),('8902','2013-08-30','08:45:00',2.88),('8902','2013-08-30','08:50:00',3.17),('8902','2013-08-30','08:55:00',3.46),('8902','2013-08-30','09:00:00',3.69),('8902','2013-08-30','09:05:00',3.38),('8902','2013-08-30','09:10:00',2.83),('8902','2013-08-30','09:15:00',3.39),('8902','2013-08-30','09:20:00',3.9),('8902','2013-08-30','09:25:00',4.33),('8902','2013-08-30','09:30:00',4.43),('8902','2013-08-30','09:35:00',4.65),('8902','2013-08-30','09:40:00',4.8),('8902','2013-08-30','09:45:00',4.53),('8902','2013-08-30','09:50:00',4.6),('8902','2013-08-30','09:55:00',4.93),('8902','2013-08-30','10:00:00',5.27),('8902','2013-08-30','10:05:00',5.29),('8902','2013-08-30','10:10:00',5.54),('8902','2013-08-30','10:15:00',5.56),('8902','2013-08-30','10:20:00',5.68),('8902','2013-08-30','10:25:00',5.75),('8902','2013-08-30','10:30:00',5.91),('8902','2013-08-30','10:35:00',6.1),('8902','2013-08-30','10:40:00',6.13),('8902','2013-08-30','10:45:00',6.27),('8902','2013-08-30','10:50:00',6.44),('8902','2013-08-30','10:55:00',6.52),('8902','2013-08-30','11:00:00',6.67),('8902','2013-08-30','11:05:00',6.74),('8902','2013-08-30','11:10:00',6.83),('8902','2013-08-30','11:15:00',6.92),('8902','2013-08-30','11:20:00',6.99),('8902','2013-08-30','11:25:00',7.05),('8902','2013-08-30','11:30:00',7.12),('8902','2013-08-30','11:35:00',7.22),('8902','2013-08-30','11:40:00',7.32),('8902','2013-08-30','11:45:00',7.42),('8902','2013-08-30','11:50:00',7.45),('8902','2013-08-30','11:55:00',7.46),('8902','2013-08-30','12:00:00',6.25),('8902','2013-08-30','12:05:00',5.22),('8902','2013-08-30','12:10:00',6.36),('8902','2013-08-30','12:15:00',7.53),('8902','2013-08-30','12:20:00',7.48),('8902','2013-08-30','12:25:00',7.48),('8902','2013-08-30','12:30:00',7.56),('8902','2013-08-30','12:35:00',7.53),('8902','2013-08-30','12:40:00',7.61),('8902','2013-08-30','12:45:00',7.53),('8902','2013-08-30','12:50:00',7.57),('8902','2013-08-30','12:55:00',7.64),('8902','2013-08-30','13:00:00',7.7),('8902','2013-08-30','13:05:00',7.73),('8902','2013-08-30','13:10:00',7.67),('8902','2013-08-30','13:15:00',7.68),('8902','2013-08-30','13:20:00',7.72),('8902','2013-08-30','13:25:00',7.68),('8902','2013-08-30','13:30:00',7.67),('8902','2013-08-30','13:35:00',7.62),('8902','2013-08-30','13:40:00',7.58),('8902','2013-08-30','13:45:00',7.55),('8902','2013-08-30','13:50:00',7.6),('8902','2013-08-30','13:55:00',7.53),('8902','2013-08-30','14:00:00',7.53),('8902','2013-08-30','14:05:00',7.49),('8902','2013-08-30','14:10:00',7.41),('8902','2013-08-30','14:15:00',7.37),('8902','2013-08-30','14:20:00',7.29),('8902','2013-08-30','14:25:00',7.22),('8902','2013-08-30','14:30:00',7.21),('8902','2013-08-30','14:35:00',6.9),('8902','2013-08-30','14:40:00',6.96),('8902','2013-08-30','14:45:00',6.96),('8902','2013-08-30','14:50:00',6.96),('8902','2013-08-30','14:55:00',6.8),('8902','2013-08-30','15:00:00',6.77),('8902','2013-08-30','15:05:00',6.79),('8902','2013-08-30','15:10:00',6.71),('8902','2013-08-30','15:15:00',6.6),('8902','2013-08-30','15:20:00',6.5),('8902','2013-08-30','15:25:00',6.38),('8902','2013-08-30','15:30:00',6.35),('8902','2013-08-30','15:35:00',6.19),('8902','2013-08-30','15:40:00',6.23),('8902','2013-08-30','15:45:00',6.12),('8902','2013-08-30','15:50:00',5.96),('8902','2013-08-30','15:55:00',5.87),('8902','2013-08-30','16:00:00',5.82),('8902','2013-08-30','16:05:00',5.67),('8902','2013-08-30','16:10:00',5.64),('8902','2013-08-30','16:15:00',5.52),('8902','2013-08-30','16:20:00',5.4),('8902','2013-08-30','16:25:00',5.18),('8902','2013-08-30','16:30:00',5),('8902','2013-08-30','16:35:00',5.04),('8902','2013-08-30','16:40:00',4.89),('8902','2013-08-30','16:45:00',4.59),('8902','2013-08-30','16:50:00',4.47),('8902','2013-08-30','16:55:00',4.37),('8902','2013-08-30','17:00:00',4.19),('8902','2013-08-30','17:05:00',4.14),('8902','2013-08-30','17:10:00',4.04),('8902','2013-08-30','17:15:00',3.84),('8902','2013-08-30','17:20:00',3.63),('8902','2013-08-30','17:25:00',3.43),('8902','2013-08-30','17:30:00',3.25),('8902','2013-08-30','17:35:00',2.97),('8902','2013-08-30','17:40:00',2.84),('8902','2013-08-30','17:45:00',2.64),('8902','2013-08-30','17:50:00',2.43),('8902','2013-08-30','17:55:00',2.17),('8902','2013-08-30','18:00:00',1.3),('8902','2013-08-30','18:05:00',1.45),('8902','2013-08-30','18:10:00',1.36),('8902','2013-08-30','18:15:00',1.23),('8902','2013-08-30','18:20:00',1.25),('8902','2013-08-30','18:25:00',1.08),('8902','2013-08-29','07:55:00',1.17),('8902','2013-08-29','08:00:00',1.39),('8902','2013-08-29','08:05:00',1.74),('8902','2013-08-29','08:10:00',1.99),('8902','2013-08-29','08:15:00',1.99),('8902','2013-08-29','08:20:00',2.17),('8902','2013-08-29','08:25:00',2.28),('8902','2013-08-29','08:30:00',2.41),('8902','2013-08-29','08:35:00',2.58),('8902','2013-08-29','08:40:00',2.68),('8902','2013-08-29','08:45:00',2.46),('8902','2013-08-29','08:50:00',2.26),('8902','2013-08-29','08:55:00',2.27),('8902','2013-08-29','09:00:00',2.61),('8902','2013-08-29','09:05:00',2.89),('8902','2013-08-29','09:10:00',2.6),('8902','2013-08-29','09:15:00',2.44),('8902','2013-08-29','09:20:00',2.2),('8902','2013-08-29','09:25:00',2.31),('8902','2013-08-29','09:30:00',2.97),('8902','2013-08-29','09:35:00',3.3),('8902','2013-08-29','09:40:00',3.24),('8902','2013-08-29','09:45:00',3.33),('8902','2013-08-29','09:50:00',3.35),('8902','2013-08-29','09:55:00',3.53),('8902','2013-08-29','10:00:00',3.55),('8902','2013-08-29','10:05:00',3.6),('8902','2013-08-29','10:10:00',3.59),('8902','2013-08-29','10:15:00',3.78),('8902','2013-08-29','10:20:00',4.04),('8902','2013-08-29','10:25:00',3.7),('8902','2013-08-29','10:30:00',4.12),('8902','2013-08-29','10:35:00',3.94),('8902','2013-08-29','10:40:00',3.76),('8902','2013-08-29','10:45:00',3.65),('8902','2013-08-29','10:50:00',3.87),('8902','2013-08-29','10:55:00',3.7),('8902','2013-08-29','11:00:00',3.87),('8902','2013-08-29','11:05:00',4.12),('8902','2013-08-29','11:10:00',4.3),('8902','2013-08-29','11:15:00',4.4),('8902','2013-08-29','11:20:00',4.37),('8902','2013-08-29','11:25:00',4.53),('8902','2013-08-29','11:30:00',4.83),('8902','2013-08-29','11:35:00',4.61),('8902','2013-08-29','11:40:00',4.99),('8902','2013-08-29','11:45:00',4.88),('8902','2013-08-29','11:50:00',5.7),('8902','2013-08-29','11:55:00',5.02),('8902','2013-08-29','12:00:00',4.53),('8902','2013-08-29','12:05:00',3.84),('8902','2013-08-29','12:10:00',4.18),('8902','2013-08-29','12:15:00',4.59),('8902','2013-08-29','12:20:00',4.97),('8902','2013-08-29','12:25:00',5.6),('8902','2013-08-29','12:30:00',6.16),('8902','2013-08-29','12:35:00',5.98),('8902','2013-08-29','12:40:00',5.79),('8902','2013-08-29','12:45:00',6.01),('8902','2013-08-29','12:50:00',5.93),('8902','2013-08-29','12:55:00',5.55),('8902','2013-08-29','13:00:00',5.37),('8902','2013-08-29','13:05:00',5.33),('8902','2013-08-29','13:10:00',5.41),('8902','2013-08-29','13:15:00',5.18),('8902','2013-08-29','13:20:00',6.13),('8902','2013-08-29','13:25:00',7.06),('8902','2013-08-29','13:30:00',7.56),('8902','2013-08-29','13:35:00',7.04),('8902','2013-08-29','13:40:00',7.49),('8902','2013-08-29','13:45:00',6.75),('8902','2013-08-29','13:50:00',6.77),('8902','2013-08-29','13:55:00',7.41),('8902','2013-08-29','14:00:00',7.69),('8902','2013-08-29','14:05:00',7.43),('8902','2013-08-29','14:10:00',7.49),('8902','2013-08-29','14:15:00',7.51),('8902','2013-08-29','14:20:00',7.37),('8902','2013-08-29','14:25:00',7.52),('8902','2013-08-29','14:30:00',7.39),('8902','2013-08-29','14:35:00',7.49),('8902','2013-08-29','14:40:00',7.28),('8902','2013-08-29','14:45:00',5.91),('8902','2013-08-29','14:50:00',4.84),('8902','2013-08-29','14:55:00',5.63),('8902','2013-08-29','15:00:00',4.93),('8902','2013-08-29','15:05:00',4.5),('8902','2013-08-29','15:10:00',4.5),('8902','2013-08-29','15:15:00',5.51),('8902','2013-08-29','15:20:00',4.81),('8902','2013-08-29','15:25:00',4.24),('8902','2013-08-29','15:30:00',4.1),('8902','2013-08-29','15:35:00',3.39),('8902','2013-08-29','15:40:00',3.6),('8902','2013-08-29','15:45:00',4.21),('8902','2013-08-29','15:50:00',4.63),('8902','2013-08-29','15:55:00',4.65),('8902','2013-08-29','16:00:00',4.36),('8902','2013-08-29','16:05:00',3.84),('8902','2013-08-29','16:11:00',3.17),('8902','2013-08-29','16:15:00',2.78),('8902','2013-08-29','16:20:00',3.16),('8902','2013-08-29','16:25:00',3.23),('8902','2013-08-29','16:30:00',3.29),('8902','2013-08-29','16:35:00',3.3),('8902','2013-08-29','16:40:00',4.84),('8902','2013-08-29','16:45:00',4.88),('8902','2013-08-29','16:50:00',4.58),('8902','2013-08-29','16:55:00',3.12),('8902','2013-08-29','17:00:00',3.51),('8902','2013-08-29','17:05:00',2.65),('8902','2013-08-29','17:10:00',3.11),('8902','2013-08-29','17:15:00',2.83),('8902','2013-08-29','17:20:00',2.44),('8902','2013-08-29','17:25:00',2.36),('8902','2013-08-29','17:30:00',2.59),('8902','2013-08-29','17:35:00',2.87),('8902','2013-08-29','17:40:00',3.01),('8902','2013-08-29','17:45:00',2.81),('8902','2013-08-29','17:50:00',2.17),('8902','2013-08-29','17:55:00',2.77),('8902','2013-08-29','18:00:00',2.12),('8902','2013-08-29','18:05:00',1.23),('8902','2014-04-10','07:50:00',1.19),('8902','2014-04-10','07:55:00',1.39),('8902','2014-04-10','08:00:00',1.09),('8902','2014-04-10','08:30:00',2.07),('8902','2014-04-10','08:35:00',2.71),('8902','2014-04-10','08:40:00',2.91),('8902','2014-04-10','08:45:00',3.15),('8902','2014-04-10','08:50:00',3.24),('8902','2014-04-10','08:55:00',3.38),('8902','2014-04-10','09:00:00',3.51),('8902','2014-04-10','09:05:00',3.64),('8902','2014-04-10','09:10:00',3.79),('8902','2014-04-10','09:15:00',3.94),('8902','2014-04-10','09:20:00',4.13),('8902','2014-04-10','09:25:00',4.34),('8902','2014-04-10','09:30:00',4.5),('8902','2014-04-10','09:35:00',4.66),('8902','2014-04-10','09:40:00',4.83),('8902','2014-04-10','09:45:00',4.96),('8902','2014-04-10','09:50:00',5.11),('8902','2014-04-10','09:55:00',5.23),('8902','2014-04-10','10:00:00',5.39),('8902','2014-04-10','10:05:00',5.53),('8902','2014-04-10','10:10:00',5.75),('8902','2014-04-10','10:15:00',5.93),('8902','2014-04-10','10:20:00',6),('8902','2014-04-10','10:25:00',6.12),('8902','2014-04-10','10:30:00',6.23),('8902','2014-04-10','10:35:00',6.34),('8902','2014-04-10','10:40:00',6.44),('8902','2014-04-10','10:45:00',6.55),('8902','2014-04-10','10:50:00',6.76),('8902','2014-04-10','10:55:00',6.9),('8902','2014-04-10','11:00:00',7.02),('8902','2014-04-10','11:05:00',7.1),('8902','2014-04-10','11:10:00',7.22),('8902','2014-04-10','11:15:00',7.23),('8902','2014-04-10','11:20:00',7.24),('8902','2014-04-10','11:25:00',7.52),('8902','2014-04-10','11:30:00',7.58),('8902','2014-04-10','11:35:00',7.66),('8902','2014-04-10','11:40:00',7.47),('8902','2014-04-10','11:45:00',7.78),('8902','2014-04-10','11:50:00',7.86),('8902','2014-04-10','11:55:00',8.08),('8902','2014-04-10','12:00:00',8.31),('8902','2014-04-10','12:05:00',7.95),('8902','2014-04-10','12:10:00',8.46),('8902','2014-04-10','12:15:00',8.33),('8902','2014-04-10','12:20:00',7.98),('8902','2014-04-10','12:25:00',5.77),('8902','2014-04-10','12:30:00',8.39),('8902','2014-04-10','12:35:00',8.47),('8902','2014-04-10','12:40:00',8.67),('8902','2014-04-10','12:45:00',9.05),('8902','2014-04-10','12:50:00',7.87),('8902','2014-04-10','12:55:00',8.62),('8902','2014-04-10','13:00:00',8.61),('8902','2014-04-10','13:05:00',5.76),('8902','2014-04-10','13:10:00',8.63),('8902','2014-04-10','13:15:00',7.45),('8902','2014-04-10','13:20:00',4.78),('8902','2014-04-10','13:25:00',7.27),('8902','2014-04-10','13:30:00',8.09),('8902','2014-04-10','13:35:00',4.53),('8902','2014-04-10','13:40:00',6.82),('8902','2014-04-10','13:45:00',6.05),('8902','2014-04-10','13:50:00',8.13),('8902','2014-04-10','13:55:00',6.64),('8902','2014-04-10','14:00:00',7.39),('8902','2014-04-10','14:05:00',6.41),('8902','2014-04-10','14:10:00',5.91),('8902','2014-04-10','14:15:00',5.84),('8902','2014-04-10','14:20:00',3.78),('8902','2014-04-10','14:25:00',5.6),('8902','2014-04-10','14:30:00',8.63),('8902','2014-04-10','14:35:00',8.97),('8902','2014-04-10','14:40:00',8.9),('8902','2014-04-10','14:45:00',7.67),('8902','2014-04-10','14:50:00',7.56),('8902','2014-04-10','14:55:00',5.53),('8902','2014-04-10','15:00:00',4.35),('8902','2014-04-10','15:05:00',4.97),('8902','2014-04-10','15:10:00',6.83),('8902','2014-04-10','15:15:00',7.78),('8902','2014-04-10','15:20:00',7.14),('8902','2014-04-10','15:25:00',6.87),('8902','2014-04-10','15:30:00',7.39),('8902','2014-04-10','15:35:00',7.29),('8902','2014-04-10','15:40:00',7.11),('8902','2014-04-10','15:45:00',6.93),('8902','2014-04-10','15:50:00',6.85),('8902','2014-04-10','15:55:00',5.88),('8902','2014-04-10','16:00:00',6.68),('8902','2014-04-10','16:05:00',6.53),('8902','2014-04-10','16:10:00',6.41),('8902','2014-04-10','16:15:00',6.21),('8902','2014-04-10','16:20:00',6.03),('8902','2014-04-10','16:25:00',5.82),('8902','2014-04-10','16:30:00',5.76),('8902','2014-04-10','16:35:00',5.58),('8902','2014-04-10','16:40:00',4.96),('8902','2014-04-10','16:45:00',5.34),('8902','2014-04-10','16:50:00',5.33),('8902','2014-04-10','16:55:00',3.2),('8902','2014-04-10','17:00:00',4.91),('8902','2014-04-10','17:05:00',3.37),('8902','2014-04-10','17:10:00',4.53),('8902','2014-04-10','17:15:00',3.06),('8902','2014-04-10','17:20:00',3.19),('8902','2014-04-10','17:25:00',3.98),('8902','2014-04-10','17:30:00',3.95),('8902','2014-04-10','17:35:00',3.86),('8902','2014-04-10','17:40:00',3.61),('8902','2014-04-10','17:45:00',3.28),('8902','2014-04-10','17:50:00',3.04),('8902','2014-04-10','17:55:00',2.8),('8902','2014-04-10','18:00:00',2.55),('8902','2014-04-10','18:05:00',2.23),('8902','2014-04-10','18:10:00',2.12),('8902','2014-04-10','18:15:00',2.01),('8902','2014-04-10','18:20:00',1.88),('8902','2014-04-10','18:25:00',1.71),('8902','2014-04-10','18:30:00',1.7),('8902','2014-04-10','18:35:00',1.58),('8902','2014-04-10','18:40:00',1.38),('8902','2014-04-10','18:45:00',1.15),('8902','2014-04-10','18:50:00',1.01),('8902','2013-08-28','07:55:00',1.19),('8902','2013-08-28','08:00:00',1.38),('8902','2013-08-28','08:05:00',1.54),('8902','2013-08-28','08:10:00',1.75),('8902','2013-08-28','08:15:00',1.98),('8902','2013-08-28','08:20:00',2.28),('8902','2013-08-28','08:25:00',2.65),('8902','2013-08-28','08:30:00',3.08),('8902','2013-08-28','08:35:00',3.11),('8902','2013-08-28','08:40:00',2.51),('8902','2013-08-28','08:45:00',1.98),('8902','2013-08-28','08:50:00',2.26),('8902','2013-08-28','08:55:00',2.98),('8902','2013-08-28','09:00:00',2.94),('8902','2013-08-28','09:05:00',2.89),('8902','2013-08-28','09:10:00',2.85),('8902','2013-08-28','09:15:00',3.04),('8902','2013-08-28','09:20:00',3.03),('8902','2013-08-28','09:25:00',2.8),('8902','2013-08-28','09:30:00',2.88),('8902','2013-08-28','09:35:00',3.14),('8902','2013-08-28','09:40:00',3.2),('8902','2013-08-28','09:45:00',2.85),('8902','2013-08-28','09:50:00',2.76),('8902','2013-08-28','09:55:00',2.88),('8902','2013-08-28','10:00:00',3.07),('8902','2013-08-28','10:05:00',2.91),('8902','2013-08-28','10:10:00',2.85),('8902','2013-08-28','10:15:00',2.83),('8902','2013-08-28','10:20:00',2.87),('8902','2013-08-28','10:25:00',2.89),('8902','2013-08-28','10:30:00',2.96),('8902','2013-08-28','10:35:00',2.79),('8902','2013-08-28','10:40:00',2.6),('8902','2013-08-28','10:45:00',2.41),('8902','2013-08-28','10:50:00',2.37),('8902','2013-08-28','10:55:00',2.6),('8902','2013-08-28','11:00:00',2.79),('8902','2013-08-28','11:05:00',2.8),('8902','2013-08-28','11:10:00',4.08),('8902','2013-08-28','11:15:00',5.24),('8902','2013-08-28','11:20:00',4.82),('8902','2013-08-28','11:25:00',3.52),('8902','2013-08-28','11:30:00',3.03),('8902','2013-08-28','11:35:00',2.66),('8902','2013-08-28','11:40:00',2.94),('8902','2013-08-28','11:45:00',3.48),('8902','2013-08-28','11:50:00',3.65),('8902','2013-08-28','11:55:00',3.52),('8902','2013-08-28','12:00:00',3.5),('8902','2013-08-28','12:05:00',4.04),('8902','2013-08-28','12:10:00',4.77),('8902','2013-08-28','12:15:00',5.9),('8902','2013-08-28','12:20:00',4.97),('8902','2013-08-28','12:25:00',5.2),('8902','2013-08-28','12:30:00',5.2),('8902','2013-08-28','12:35:00',6.37),('8902','2013-08-28','12:40:00',8.41),('8902','2013-08-28','12:45:00',8.66),('8902','2013-08-28','12:50:00',5.51),('8902','2013-08-28','12:55:00',7.37),('8902','2013-08-28','13:00:00',5.47),('8902','2013-08-28','13:05:00',4.73),('8902','2013-08-28','13:10:00',4.75),('8902','2013-08-28','13:15:00',4.61),('8902','2013-08-28','13:20:00',4.55),('8902','2013-08-28','13:25:00',3.91),('8902','2013-08-28','13:30:00',3.52),('8902','2013-08-28','13:35:00',3.28),('8902','2013-08-28','13:40:00',3.1),('8902','2013-08-28','13:45:00',2.93),('8902','2013-08-28','13:50:00',2.88),('8902','2013-08-28','13:55:00',3.28),('8902','2013-08-28','14:00:00',4.48),('8902','2013-08-28','14:05:00',3.35),('8902','2013-08-28','14:10:00',2.98),('8902','2013-08-28','14:15:00',2.52),('8902','2013-08-28','14:20:00',2.01),('8902','2013-08-28','14:25:00',1.77),('8902','2013-08-28','14:30:00',1.63),('8902','2013-08-28','14:35:00',1.64),('8902','2013-08-28','14:40:00',1.67),('8902','2013-08-28','14:45:00',1.84),('8902','2013-08-28','14:50:00',2.15),('8902','2013-08-28','14:55:00',2.55),('8902','2013-08-28','15:00:00',2.86),('8902','2013-08-28','15:05:00',3.25),('8902','2013-08-28','15:10:00',2.71),('8902','2013-08-28','15:15:00',2.25),('8902','2013-08-28','15:20:00',2.39),('8902','2013-08-28','15:25:00',2.76),('8902','2013-08-28','15:30:00',4.3),('8902','2013-08-28','15:35:00',4.88),('8902','2013-08-28','15:40:00',4.13),('8902','2013-08-28','15:45:00',4.98),('8902','2013-08-28','15:50:00',5.89),('8902','2013-08-28','15:55:00',6.05),('8902','2013-08-28','16:00:00',6.93),('8902','2013-08-28','16:05:00',6.65),('8902','2013-08-28','16:10:00',6.64),('8902','2013-08-28','16:15:00',6.14),('8902','2013-08-28','16:20:00',5.86),('8902','2013-08-28','16:25:00',5.58),('8902','2013-08-28','16:30:00',5.41),('8902','2013-08-28','16:35:00',5.32),('8902','2013-08-28','16:40:00',5.18),('8902','2013-08-28','16:45:00',4.97),('8902','2013-08-28','16:50:00',4.87),('8902','2013-08-28','16:55:00',4.69),('8902','2013-08-28','17:00:00',4.58),('8902','2013-08-28','17:05:00',4.4),('8902','2013-08-28','17:10:00',4.23),('8902','2013-08-28','17:15:00',4.06),('8902','2013-08-28','17:20:00',3.9),('8902','2013-08-28','17:25:00',3.74),('8902','2013-08-28','17:30:00',3.52),('8902','2013-08-28','17:35:00',3.34),('8902','2013-08-28','17:40:00',3.13),('8902','2013-08-28','17:45:00',2.94),('8902','2013-08-28','17:50:00',2.77),('8902','2013-08-28','17:55:00',2.58),('8902','2013-08-28','18:00:00',2.4),('8902','2013-08-28','18:05:00',2.21),('8902','2013-08-28','18:10:00',2.03),('8902','2013-08-28','18:15:00',1.87),('8902','2013-08-28','18:20:00',1.7),('8902','2013-08-28','18:25:00',1.53),('8902','2013-08-28','18:30:00',1.36),('8902','2013-08-28','18:35:00',1.19),('8902','2013-08-28','18:40:00',1.03),('8902','2013-08-27','07:50:00',1.07),('8902','2013-08-27','07:55:00',1.24),('8902','2013-08-27','08:00:00',1.41),('8902','2013-08-27','08:05:00',1.52),('8902','2013-08-27','08:10:00',1.66),('8902','2013-08-27','08:15:00',1.84),('8902','2013-08-27','08:20:00',1.99),('8902','2013-08-27','08:25:00',2.12),('8902','2013-08-27','08:30:00',2.26),('8902','2013-08-27','08:35:00',2.59),('8902','2013-08-27','08:40:00',1.79),('8902','2013-08-27','08:45:00',2.3),('8902','2013-08-27','08:50:00',2.57),('8902','2013-08-27','08:55:00',1.65),('8902','2013-08-27','09:00:00',3.25),('8902','2013-08-27','09:05:00',2.78),('8902','2013-08-27','09:10:00',2.18),('8902','2013-08-27','09:15:00',2.94),('8902','2013-08-27','09:20:00',2.32),('8902','2013-08-27','09:25:00',1.46),('8902','2013-08-27','09:30:00',1.61),('8902','2013-08-27','09:35:00',3.99),('8902','2013-08-27','09:40:00',4.53),('8902','2013-08-27','09:45:00',4.84),('8902','2013-08-27','09:50:00',4.97),('8902','2013-08-27','09:55:00',5.02),('8902','2013-08-27','10:00:00',5.1),('8902','2013-08-27','10:05:00',5.26),('8902','2013-08-27','10:10:00',5.54),('8902','2013-08-27','10:15:00',4.78),('8902','2013-08-27','10:20:00',5.49),('8902','2013-08-27','10:25:00',5.81),('8902','2013-08-27','10:30:00',2.7),('8902','2013-08-27','10:35:00',2.36),('8902','2013-08-27','10:40:00',4.17),('8902','2013-08-27','10:45:00',3.74),('8902','2013-08-27','10:50:00',6.72),('8902','2013-08-27','10:55:00',6.87),('8902','2013-08-27','11:00:00',4.92),('8902','2013-08-27','11:05:00',3.75),('8902','2013-08-27','11:10:00',7.06),('8902','2013-08-27','11:15:00',4.39),('8902','2013-08-27','11:20:00',7.57),('8902','2013-08-27','11:25:00',7.32),('8902','2013-08-27','11:30:00',7.39),('8902','2013-08-27','11:35:00',7.48),('8902','2013-08-27','11:40:00',7.81),('8902','2013-08-27','11:45:00',7.52),('8902','2013-08-27','11:50:00',4.98),('8902','2013-08-27','11:55:00',6.55),('8902','2013-08-27','12:00:00',2.17),('8902','2013-08-27','12:05:00',8.02),('8902','2013-08-27','12:10:00',8.11),('8902','2013-08-27','12:15:00',4.09),('8902','2013-08-27','12:20:00',8.08),('8902','2013-08-27','12:25:00',7.98),('8902','2013-08-27','12:30:00',7.92),('8902','2013-08-27','12:35:00',7.83),('8902','2013-08-27','12:40:00',7.89),('8902','2013-08-27','12:45:00',8.18),('8902','2013-08-27','12:50:00',8.1),('8902','2013-08-27','12:55:00',8.05),('8902','2013-08-27','13:00:00',8.15),('8902','2013-08-27','13:05:00',7.7),('8902','2013-08-27','13:10:00',8.31),('8902','2013-08-27','13:15:00',8.33),('8902','2013-08-27','13:20:00',8.1),('8902','2013-08-27','13:25:00',8.1),('8902','2013-08-27','13:30:00',7.61),('8902','2013-08-27','13:35:00',8.13),('8902','2013-08-27','13:40:00',8.26),('8902','2013-08-27','13:45:00',8.22),('8902','2013-08-27','13:50:00',8.2),('8902','2013-08-27','13:55:00',7.37),('8902','2013-08-27','14:00:00',7.35),('8902','2013-08-27','14:05:00',8.06),('8902','2013-08-27','14:10:00',7),('8902','2013-08-27','14:15:00',8.12),('8902','2013-08-27','14:20:00',7.9),('8902','2013-08-27','14:25:00',7.61),('8902','2013-08-27','14:30:00',7.11),('8902','2013-08-27','14:35:00',6.62),('8902','2013-08-27','14:40:00',8.08),('8902','2013-08-27','14:45:00',7.79),('8902','2013-08-27','14:50:00',7.62),('8902','2013-08-27','14:55:00',7.57),('8902','2013-08-27','15:00:00',7.53),('8902','2013-08-27','15:05:00',6.89),('8902','2013-08-27','15:10:00',6.82),('8902','2013-08-27','15:15:00',7.53),('8902','2013-08-27','15:20:00',7.4),('8902','2013-08-27','15:25:00',7.26),('8902','2013-08-27','15:30:00',4.86),('8902','2013-08-27','15:35:00',7.63),('8902','2013-08-27','15:40:00',5.09),('8902','2013-08-27','15:45:00',2.03),('8902','2013-08-27','15:50:00',3.49),('8902','2013-08-27','15:55:00',3.78),('8902','2013-08-27','16:00:00',6.88),('8902','2013-08-27','16:05:00',6.04),('8902','2013-08-27','16:10:00',6.26),('8902','2013-08-27','16:15:00',5.78),('8902','2013-08-27','16:20:00',2.67),('8902','2013-08-27','16:25:00',6.39),('8902','2013-08-27','16:30:00',5.86),('8902','2013-08-27','16:35:00',5.74),('8902','2013-08-27','16:40:00',5.62),('8902','2013-08-27','16:45:00',5.32),('8902','2013-08-27','16:50:00',5.05),('8902','2013-08-27','16:55:00',4.49),('8902','2013-08-27','17:00:00',4.85),('8902','2013-08-27','17:05:00',4.57),('8902','2013-08-27','17:10:00',3.89),('8902','2013-08-27','17:15:00',3.75),('8902','2013-08-27','17:20:00',2.78),('8902','2013-08-27','17:25:00',3.36),('8902','2013-08-27','17:30:00',2.66),('8902','2013-08-27','17:35:00',3.02),('8902','2013-08-27','17:40:00',3.15),('8902','2013-08-27','17:45:00',2.65),('8902','2013-08-27','17:55:00',1.1),('8902','2013-08-27','18:00:00',1.39),('8902','2013-08-27','18:05:00',1.02),('8902','2013-08-27','18:10:00',1.07),('8902','2013-08-27','18:15:00',2.13),('8902','2013-08-27','18:20:00',1.14),('8902','2013-08-27','18:25:00',1.57),('8902','2013-08-26','08:05:00',1.01),('8902','2013-08-26','08:10:00',1.21),('8902','2013-08-26','08:15:00',1.47),('8902','2013-08-26','08:20:00',1.98),('8902','2013-08-26','08:25:00',2.57),('8902','2013-08-26','08:30:00',2.62),('8902','2013-08-26','08:35:00',1.89),('8902','2013-08-26','08:40:00',1.72),('8902','2013-08-26','08:45:00',2.12),('8902','2013-08-26','08:50:00',1.56),('8902','2013-08-26','08:55:00',1.42),('8902','2013-08-26','09:00:00',1.67),('8902','2013-08-26','09:05:00',1.76),('8902','2013-08-26','09:10:00',2.33),('8902','2013-08-26','09:15:00',2.35),('8902','2013-08-26','09:20:00',2.67),('8902','2013-08-26','09:25:00',3.56),('8902','2013-08-26','09:30:00',3.96),('8902','2013-08-26','09:35:00',2.47),('8902','2013-08-26','09:40:00',1.87),('8902','2013-08-26','09:45:00',1.91),('8902','2013-08-26','09:50:00',1.99),('8902','2013-08-26','09:55:00',2.55),('8902','2013-08-26','10:00:00',3.41),('8902','2013-08-26','10:05:00',4.28),('8902','2013-08-26','10:10:00',5.2),('8902','2013-08-26','10:15:00',5.41),('8902','2013-08-26','10:20:00',5.63),('8902','2013-08-26','10:25:00',5.65),('8902','2013-08-26','10:30:00',5.77),('8902','2013-08-26','10:35:00',5.87),('8902','2013-08-26','10:40:00',5.77),('8902','2013-08-26','10:45:00',6.02),('8902','2013-08-26','10:50:00',6.01),('8902','2013-08-26','10:55:00',6.29),('8902','2013-08-26','11:00:00',6.25),('8902','2013-08-26','11:05:00',6.37),('8902','2013-08-26','11:10:00',6.47),('8902','2013-08-26','11:15:00',6.44),('8902','2013-08-26','11:20:00',6.38),('8902','2013-08-26','11:25:00',6.34),('8902','2013-08-26','11:30:00',6.57),('8902','2013-08-26','11:35:00',6.76),('8902','2013-08-26','11:40:00',6.43),('8902','2013-08-26','11:45:00',7.94),('8902','2013-08-26','11:50:00',6.18),('8902','2013-08-26','11:55:00',7.08),('8902','2013-08-26','12:00:00',7.62),('8902','2013-08-26','12:05:00',7.16),('8902','2013-08-26','12:10:00',6.64),('8902','2013-08-26','12:15:00',6.53),('8902','2013-08-26','12:20:00',7.19),('8902','2013-08-26','12:25:00',5.43),('8902','2013-08-26','12:30:00',6.86),('8902','2013-08-26','12:35:00',5.36),('8902','2013-08-26','12:40:00',8.11),('8902','2013-08-26','12:45:00',6.06),('8902','2013-08-26','12:50:00',4.55),('8902','2013-08-26','12:55:00',4.61),('8902','2013-08-26','13:00:00',2.8),('8902','2013-08-26','13:05:00',3.53),('8902','2013-08-26','13:10:00',4.93),('8902','2013-08-26','13:15:00',5.06),('8902','2013-08-26','13:20:00',4.13),('8902','2013-08-26','13:25:00',3.45),('8902','2013-08-26','13:30:00',3.73),('8902','2013-08-26','13:35:00',3.54),('8902','2013-08-26','13:40:00',4.33),('8902','2013-08-26','13:45:00',5.34),('8902','2013-08-26','13:50:00',7.93),('8902','2013-08-26','13:55:00',6.3),('8902','2013-08-26','14:00:00',8.45),('8902','2013-08-26','14:05:00',5.77),('8902','2013-08-26','14:10:00',3.45),('8902','2013-08-26','14:15:00',4.73),('8902','2013-08-26','14:20:00',5.23),('8902','2013-08-26','14:25:00',2.81),('8902','2013-08-26','14:30:00',1.96),('8902','2013-08-26','14:35:00',2.16),('8902','2013-08-26','14:40:00',2.3),('8902','2013-08-26','14:45:00',2.42),('8902','2013-08-26','14:50:00',1.89),('8902','2013-08-26','14:55:00',1.41),('8902','2013-08-26','15:00:00',1.45),('8902','2013-08-26','15:05:00',1.34),('8902','2013-08-26','15:10:00',1.15),('8902','2013-08-26','15:15:00',1.22),('8902','2013-08-26','15:20:00',1.25),('8902','2013-08-26','15:25:00',1.06),('8902','2013-08-26','15:30:00',1.08),('8902','2013-08-26','15:35:00',1.1),('8902','2013-08-26','15:55:00',1.91),('8902','2013-08-26','16:00:00',2.6),('8902','2013-08-26','16:05:00',2.64),('8902','2013-08-26','16:10:00',5.93),('8902','2013-08-26','16:15:00',6.22),('8902','2013-08-26','16:20:00',3.82),('8902','2013-08-26','16:25:00',3.5),('8902','2013-08-26','16:30:00',2.35),('8902','2013-08-26','16:35:00',2.15),('8902','2013-08-26','16:40:00',1.96),('8902','2013-08-26','16:45:00',1.78),('8902','2013-08-26','16:50:00',2.27),('8902','2013-08-26','16:55:00',2),('8902','2013-08-26','17:00:00',1.27),('8902','2013-08-26','17:05:00',1.96),('8902','2013-08-26','17:10:00',4.9),('8902','2013-08-26','17:15:00',2.64),('8902','2013-08-26','17:20:00',1.74),('8902','2013-08-26','17:25:00',1.62),('8902','2013-08-26','17:30:00',1.3),('8902','2013-08-26','17:35:00',1.61),('8902','2013-08-26','17:40:00',1.69),('8902','2013-08-26','17:45:00',2.41),('8902','2013-08-26','17:50:00',2.59),('8902','2013-08-26','17:55:00',2.62),('8902','2013-08-26','18:00:00',2.23),('8902','2013-08-26','18:05:00',1.75),('8902','2013-08-25','07:55:00',1.3),('8902','2013-08-25','08:00:00',1.14),('8902','2013-08-25','08:05:00',2.05),('8902','2013-08-25','08:10:00',2.2),('8902','2013-08-25','08:15:00',1.42),('8902','2013-08-25','08:20:00',2.31),('8902','2013-08-25','08:25:00',2.15),('8902','2013-08-25','08:30:00',2.57),('8902','2013-08-25','08:35:00',1.95),('8902','2013-08-25','08:40:00',2.64),('8902','2013-08-25','08:45:00',2.82),('8902','2013-08-25','08:50:00',2.96),('8902','2013-08-25','08:55:00',3.14),('8902','2013-08-25','09:00:00',3.35),('8902','2013-08-25','09:05:00',3.47),('8902','2013-08-25','09:10:00',3.59),('8902','2013-08-25','09:15:00',3.74),('8902','2013-08-25','09:20:00',3.88),('8902','2013-08-25','09:25:00',3.55),('8902','2013-08-25','09:30:00',4.16),('8902','2013-08-25','09:35:00',4.31),('8902','2013-08-25','09:40:00',4.51),('8902','2013-08-25','09:45:00',4.65),('8902','2013-08-25','09:50:00',4.76),('8902','2013-08-25','09:55:00',4.95),('8902','2013-08-25','10:00:00',5.01),('8902','2013-08-25','10:05:00',5.13),('8902','2013-08-25','10:10:00',5.27),('8902','2013-08-25','10:15:00',5.39),('8902','2013-08-25','10:20:00',5.48),('8902','2013-08-25','10:25:00',5.61),('8902','2013-08-25','10:30:00',5.76),('8902','2013-08-25','10:35:00',5.81),('8902','2013-08-25','10:40:00',5.88),('8902','2013-08-25','10:45:00',6.08),('8902','2013-08-25','10:50:00',6.16),('8902','2013-08-25','10:55:00',5.66),('8902','2013-08-25','11:00:00',6.11),('8902','2013-08-25','11:05:00',6.44),('8902','2013-08-25','11:10:00',6.46),('8902','2013-08-25','11:15:00',6.59),('8902','2013-08-25','11:20:00',6.65),('8902','2013-08-25','11:25:00',6.68),('8902','2013-08-25','11:30:00',6.73),('8902','2013-08-25','11:35:00',6.95),('8902','2013-08-25','11:40:00',6.95),('8902','2013-08-25','11:45:00',6.97),('8902','2013-08-25','11:50:00',7.04),('8902','2013-08-25','11:55:00',7.13),('8902','2013-08-25','12:00:00',7.14),('8902','2013-08-25','12:05:00',7.18),('8902','2013-08-25','12:10:00',7.26),('8902','2013-08-25','12:15:00',7.28),('8902','2013-08-25','12:20:00',7.27),('8902','2013-08-25','12:25:00',7.3),('8902','2013-08-25','12:30:00',7.28),('8902','2013-08-25','12:35:00',7.31),('8902','2013-08-25','12:40:00',7.41),('8902','2013-08-25','12:45:00',7.49),('8902','2013-08-25','12:50:00',7.52),('8902','2013-08-25','12:55:00',7.53),('8902','2013-08-25','13:00:00',7.83),('8902','2013-08-25','13:05:00',8.29),('8902','2013-08-25','13:10:00',8.14),('8902','2013-08-25','13:15:00',4.18),('8902','2013-08-25','13:20:00',4.9),('8902','2013-08-25','13:25:00',5.84),('8902','2013-08-25','13:30:00',5.41),('8902','2013-08-25','13:35:00',7.86),('8902','2013-08-25','13:40:00',7.67),('8902','2013-08-25','13:45:00',7.7),('8902','2013-08-25','13:50:00',7.83),('8902','2013-08-25','13:55:00',6.24),('8902','2013-08-25','14:00:00',5.03),('8902','2013-08-25','14:05:00',6.99),('8902','2013-08-25','14:10:00',5.11),('8902','2013-08-25','14:15:00',7.51),('8902','2013-08-25','14:20:00',7.45),('8902','2013-08-25','14:25:00',7.34),('8902','2013-08-25','14:30:00',7.42),('8902','2013-08-25','14:35:00',7.06),('8902','2013-08-25','14:40:00',6.41),('8902','2013-08-25','14:45:00',5.02),('8902','2013-08-25','14:50:00',4.36),('8902','2013-08-25','14:55:00',3.95),('8902','2013-08-25','15:00:00',3.78),('8902','2013-08-25','15:05:00',2.76),('8902','2013-08-25','15:10:00',2.08),('8902','2013-08-25','15:15:00',1.8),('8902','2013-08-25','15:20:00',1.49),('8902','2013-08-25','15:25:00',1.37),('8902','2013-08-25','15:30:00',1.48),('8902','2013-08-25','15:35:00',1.88),('8902','2013-08-25','15:40:00',3.06),('8902','2013-08-25','15:45:00',3.34),('8902','2013-08-25','15:50:00',3.24),('8902','2013-08-25','15:55:00',3.04),('8902','2013-08-25','16:00:00',4.91),('8902','2013-08-25','16:05:00',6.62),('8902','2013-08-25','16:10:00',5.92),('8902','2013-08-25','16:15:00',5.59),('8902','2013-08-25','16:20:00',5.51),('8902','2013-08-25','16:25:00',5.3),('8902','2013-08-25','16:30:00',5.12),('8902','2013-08-25','16:35:00',5.04),('8902','2013-08-25','16:40:00',4.93),('8902','2013-08-25','16:45:00',4.83),('8902','2013-08-25','16:50:00',4.46),('8902','2013-08-25','16:55:00',4.35),('8902','2013-08-25','17:00:00',4.33),('8902','2013-08-25','17:05:00',3.92),('8902','2013-08-25','17:10:00',3.95),('8902','2013-08-25','17:15:00',3.79),('8902','2013-08-25','17:20:00',2.83),('8902','2013-08-25','17:25:00',1.17),('8902','2013-08-25','17:30:00',2.5),('8902','2013-08-25','17:35:00',2.11),('8902','2013-08-25','17:40:00',2.04),('8902','2013-08-25','17:45:00',2.51),('8902','2013-08-25','17:50:00',2.71),('8902','2013-08-25','17:55:00',2.77),('8902','2013-08-25','18:00:00',2.41),('8902','2013-08-25','18:05:00',2.11),('8902','2013-08-25','18:10:00',1.91),('8902','2013-08-25','18:15:00',1.7),('8902','2013-08-25','18:20:00',1.5),('8902','2013-08-25','18:25:00',1.38),('8902','2013-08-25','18:30:00',1.21),('8902','2013-08-25','18:35:00',1.09),('8902','2013-08-24','07:55:00',1.24),('8902','2013-08-24','08:00:00',1.4),('8902','2013-08-24','08:05:00',1.6),('8902','2013-08-24','08:10:00',1.91),('8902','2013-08-24','08:15:00',1.88),('8902','2013-08-24','08:20:00',1.88),('8902','2013-08-24','08:25:00',1.96),('8902','2013-08-24','08:30:00',1.56),('8902','2013-08-24','08:35:00',1.44),('8902','2013-08-24','08:40:00',2),('8902','2013-08-24','08:45:00',2.83),('8902','2013-08-24','08:50:00',1.28),('8902','2013-08-24','08:55:00',1.94),('8902','2013-08-24','09:05:00',1.18),('8902','2013-08-24','09:10:00',2.01),('8902','2013-08-24','09:15:00',1.96),('8902','2013-08-24','09:20:00',3.66),('8902','2013-08-24','09:25:00',3.8),('8902','2013-08-24','09:30:00',3.24),('8902','2013-08-24','09:35:00',4.08),('8902','2013-08-24','09:40:00',5.44),('8902','2013-08-24','09:45:00',5.77),('8902','2013-08-24','09:50:00',5.38),('8902','2013-08-24','09:55:00',5.86),('8902','2013-08-24','10:00:00',4.63),('8902','2013-08-24','10:05:00',3.25),('8902','2013-08-24','10:10:00',1.87),('8902','2013-08-24','10:15:00',1.37),('8902','2013-08-24','10:20:00',1.38),('8902','2013-08-24','10:25:00',1.05),('8902','2013-08-24','15:00:00',1.32),('8902','2013-08-24','15:05:00',1.68),('8902','2013-08-24','15:10:00',1.85),('8902','2013-08-24','15:15:00',2.18),('8902','2013-08-24','15:20:00',2.65),('8902','2013-08-24','15:25:00',2.95),('8902','2013-08-24','15:30:00',4.12),('8902','2013-08-24','15:35:00',6.08),('8902','2013-08-24','15:40:00',6.83),('8902','2013-08-24','15:45:00',7.47),('8902','2013-08-24','15:50:00',5.63),('8902','2013-08-24','15:55:00',4.82),('8902','2013-08-24','16:00:00',6.82),('8902','2013-08-24','16:05:00',6.5),('8902','2013-08-24','16:10:00',6.23),('8902','2013-08-24','16:15:00',6.07),('8902','2013-08-24','16:20:00',5.88),('8902','2013-08-24','16:25:00',5.72),('8902','2013-08-24','16:30:00',5.59),('8902','2013-08-24','16:35:00',4.69),('8902','2013-08-24','16:40:00',4.18),('8902','2013-08-24','16:45:00',2.72),('8902','2013-08-24','16:50:00',3.83),('8902','2013-08-24','16:55:00',5.46),('8902','2013-08-24','17:00:00',5.02),('8902','2013-08-24','17:05:00',4.72),('8902','2013-08-24','17:10:00',4.45),('8902','2013-08-24','17:15:00',4.11),('8902','2013-08-24','17:20:00',3.94),('8902','2013-08-24','17:25:00',3.73),('8902','2013-08-24','17:30:00',3.49),('8902','2013-08-24','17:35:00',3.09),('8902','2013-08-24','17:40:00',2.57),('8902','2013-08-24','17:45:00',3.05),('8902','2013-08-24','17:50:00',2.74),('8902','2013-08-24','17:55:00',2.38),('8902','2013-08-24','18:00:00',1.76),('8902','2013-08-24','18:05:00',1.65),('8902','2013-08-24','18:10:00',1.85),('8902','2013-08-24','18:15:00',1.97),('8902','2013-08-24','18:20:00',1.81),('8902','2013-08-24','18:25:00',1.63),('8902','2013-08-24','18:30:00',1.24),('8902','2013-08-24','18:35:00',1.02),('8902','2013-08-23','08:05:00',1.29),('8902','2013-08-23','08:10:00',1.19),('8902','2013-08-23','08:15:00',1.23),('8902','2013-08-23','08:25:00',1.87),('8902','2013-08-23','08:30:00',2.22),('8902','2013-08-23','08:35:00',2.31),('8902','2013-08-23','08:40:00',2.54),('8902','2013-08-23','08:45:00',2.71),('8902','2013-08-23','08:50:00',2.64),('8902','2013-08-23','08:55:00',3.06),('8902','2013-08-23','09:00:00',3.26),('8902','2013-08-23','09:05:00',3.43),('8902','2013-08-23','09:10:00',3.22),('8902','2013-08-23','09:15:00',3.19),('8902','2013-08-23','09:20:00',4.15),('8902','2013-08-23','09:25:00',3.78),('8902','2013-08-23','09:30:00',3.54),('8902','2013-08-23','09:35:00',4.59),('8902','2013-08-23','09:40:00',4.73),('8902','2013-08-23','09:45:00',4.76),('8902','2013-08-23','09:50:00',4.87),('8902','2013-08-23','09:55:00',2.08),('8902','2013-08-23','10:00:00',1.82),('8902','2013-08-23','10:05:00',3.35),('8902','2013-08-23','10:10:00',5.21),('8902','2013-08-23','10:15:00',5.46),('8902','2013-08-23','10:20:00',5.56),('8902','2013-08-23','10:25:00',5.66),('8902','2013-08-23','10:30:00',5.75),('8902','2013-08-23','10:35:00',5.87),('8902','2013-08-23','10:40:00',5.99),('8902','2013-08-23','10:45:00',6.06),('8902','2013-08-23','10:50:00',5.99),('8902','2013-08-23','10:55:00',6.35),('8902','2013-08-23','11:00:00',6.31),('8902','2013-08-23','11:05:00',6.24),('8902','2013-08-23','11:10:00',6.6),('8902','2013-08-23','11:15:00',6.61),('8902','2013-08-23','11:20:00',6.59),('8902','2013-08-23','11:25:00',6.71),('8902','2013-08-23','11:30:00',6.73),('8902','2013-08-23','11:35:00',6.89),('8902','2013-08-23','11:40:00',6.92),('8902','2013-08-23','11:45:00',6.97),('8902','2013-08-23','11:50:00',7.03),('8902','2013-08-23','11:55:00',6.97),('8902','2013-08-23','12:00:00',7.14),('8902','2013-08-23','12:05:00',7.23),('8902','2013-08-23','12:10:00',7.32),('8902','2013-08-23','12:15:00',7.38),('8902','2013-08-23','12:20:00',7.33),('8902','2013-08-23','12:25:00',7.43),('8902','2013-08-23','12:30:00',7.33),('8902','2013-08-23','12:35:00',7.4),('8902','2013-08-23','12:40:00',7.41),('8902','2013-08-23','12:45:00',7.34),('8902','2013-08-23','12:50:00',7.39),('8902','2013-08-23','12:55:00',7.46),('8902','2013-08-23','13:00:00',7.4),('8902','2013-08-23','13:05:00',7.45),('8902','2013-08-23','13:10:00',7.49),('8902','2013-08-23','13:15:00',7.54),('8902','2013-08-23','13:20:00',7.62),('8902','2013-08-23','13:25:00',7.64),('8902','2013-08-23','13:30:00',7.65),('8902','2013-08-23','13:35:00',7.67),('8902','2013-08-23','13:40:00',7.66),('8902','2013-08-23','13:45:00',7.63),('8902','2013-08-23','13:50:00',7.6),('8902','2013-08-23','13:55:00',7.49),('8902','2013-08-23','14:00:00',7.49),('8902','2013-08-23','14:05:00',7.51),('8902','2013-08-23','14:10:00',7.5),('8902','2013-08-23','14:15:00',7.41),('8902','2013-08-23','14:20:00',7.4),('8902','2013-08-23','14:25:00',7.33),('8902','2013-08-23','14:30:00',7.3),('8902','2013-08-23','14:35:00',7.35),('8902','2013-08-23','14:40:00',7.28),('8902','2013-08-23','14:45:00',7.2),('8902','2013-08-23','14:50:00',7.13),('8902','2013-08-23','14:55:00',7.09),('8902','2013-08-23','15:00:00',7.02),('8902','2013-08-23','15:05:00',6.95),('8902','2013-08-23','15:10:00',6.83),('8902','2013-08-23','15:15:00',6.74),('8902','2013-08-23','15:20:00',6.67),('8902','2013-08-23','15:25:00',6.64),('8902','2013-08-23','15:30:00',6.58),('8902','2013-08-23','15:35:00',6.46),('8902','2013-08-23','15:40:00',6.38),('8902','2013-08-23','15:45:00',6.24),('8902','2013-08-23','15:50:00',6.19),('8902','2013-08-23','15:55:00',6.1),('8902','2013-08-23','16:00:00',5.99),('8902','2013-08-23','16:05:00',5.92),('8902','2013-08-23','16:10:00',5.81),('8902','2013-08-23','16:15:00',5.69),('8902','2013-08-23','16:20:00',5.59),('8902','2013-08-23','16:25:00',5.46),('8902','2013-08-23','16:30:00',5.3),('8902','2013-08-23','16:35:00',5.16),('8902','2013-08-23','16:40:00',5.02),('8902','2013-08-23','16:45:00',4.86),('8902','2013-08-23','16:50:00',4.69),('8902','2013-08-23','16:55:00',4.59),('8902','2013-08-23','17:00:00',4.49),('8902','2013-08-23','17:05:00',4.34),('8902','2013-08-23','17:10:00',4.17),('8902','2013-08-23','17:15:00',4.04),('8902','2013-08-23','17:20:00',3.9),('8902','2013-08-23','17:25:00',3.74),('8902','2013-08-23','17:30:00',3.52),('8902','2013-08-23','17:35:00',3.38),('8902','2013-08-23','17:40:00',3.18),('8902','2013-08-23','17:45:00',3),('8902','2013-08-23','17:50:00',2.86),('8902','2013-08-23','17:55:00',2.68),('8902','2013-08-23','18:00:00',2.48),('8902','2013-08-23','18:05:00',2.28),('8902','2013-08-23','18:10:00',2.13),('8902','2013-08-23','18:15:00',1.96),('8902','2013-08-23','18:20:00',1.76),('8902','2013-08-23','18:25:00',1.6),('8902','2013-08-23','18:30:00',1.43),('8902','2013-08-23','18:35:00',1.27),('8902','2013-08-23','18:40:00',1.1),('8902','2013-08-22','07:55:00',1.14),('8902','2013-08-22','08:00:00',1.26),('8902','2013-08-22','08:05:00',1.39),('8902','2013-08-22','08:10:00',1.52),('8902','2013-08-22','08:15:00',1.65),('8902','2013-08-22','08:20:00',1.81),('8902','2013-08-22','08:25:00',1.97),('8902','2013-08-22','08:30:00',2.15),('8902','2013-08-22','08:35:00',2.27),('8902','2013-08-22','08:40:00',2.37),('8902','2013-08-22','08:45:00',2.54),('8902','2013-08-22','08:50:00',2.69),('8902','2013-08-22','08:55:00',2.82),('8902','2013-08-22','09:00:00',2.88),('8902','2013-08-22','09:05:00',3.03),('8902','2013-08-22','09:10:00',3.25),('8902','2013-08-22','09:15:00',3.4),('8902','2013-08-22','09:20:00',3.58),('8902','2013-08-22','09:25:00',3.71),('8902','2013-08-22','09:30:00',3.83),('8902','2013-08-22','09:35:00',3.95),('8902','2013-08-22','09:40:00',4.04),('8902','2013-08-22','09:45:00',4.18),('8902','2013-08-22','09:50:00',4.3),('8902','2013-08-22','09:55:00',4.47),('8902','2013-08-22','10:00:00',4.59),('8902','2013-08-22','10:05:00',4.68),('8902','2013-08-22','10:10:00',4.82),('8902','2013-08-22','10:15:00',4.92),('8902','2013-08-22','10:20:00',5.03),('8902','2013-08-22','10:25:00',5.15),('8902','2013-08-22','10:30:00',5.21),('8902','2013-08-22','10:35:00',5.24),('8902','2013-08-22','10:40:00',5.21),('8902','2013-08-22','10:45:00',5.52),('8902','2013-08-22','10:50:00',5.62),('8902','2013-08-22','10:55:00',5.54),('8902','2013-08-22','11:00:00',5.75),('8902','2013-08-22','11:05:00',5.98),('8902','2013-08-22','11:10:00',5.93),('8902','2013-08-22','11:15:00',5.77),('8902','2013-08-22','11:20:00',5.04),('8902','2013-08-22','11:25:00',6.41),('8902','2013-08-22','11:30:00',4.14),('8902','2013-08-22','11:35:00',4.9),('8902','2013-08-22','11:40:00',5.98),('8902','2013-08-22','11:45:00',4.31),('8902','2013-08-22','11:50:00',7.08),('8902','2013-08-22','11:55:00',6.99),('8902','2013-08-22','12:00:00',7.25),('8902','2013-08-22','12:05:00',6.09),('8902','2013-08-22','12:10:00',2.77),('8902','2013-08-22','12:15:00',3.44),('8902','2013-08-22','12:20:00',2.13),('8902','2013-08-22','12:25:00',1.83),('8902','2013-08-22','12:30:00',1.66),('8902','2013-08-22','12:35:00',1.81),('8902','2013-08-22','12:40:00',2.55),('8902','2013-08-22','12:45:00',1.87),('8902','2013-08-22','12:50:00',1.7),('8902','2013-08-22','12:55:00',1.54),('8902','2013-08-22','13:00:00',1.65),('8902','2013-08-22','13:05:00',2.02),('8902','2013-08-22','13:10:00',2.94),('8902','2013-08-22','13:15:00',5.95),('8902','2013-08-22','13:20:00',3.33),('8902','2013-08-22','13:25:00',6.56),('8902','2013-08-22','13:30:00',7.93),('8902','2013-08-22','13:35:00',7.93),('8902','2013-08-22','13:40:00',7.89),('8902','2013-08-22','13:45:00',7.71),('8902','2013-08-22','13:50:00',7.71),('8902','2013-08-22','13:55:00',7.35),('8902','2013-08-22','14:00:00',5.11),('8902','2013-08-22','14:05:00',7.52),('8902','2013-08-22','14:10:00',7.89),('8902','2013-08-22','14:15:00',7.74),('8902','2013-08-22','14:20:00',6.8),('8902','2013-08-22','14:25:00',7.07),('8902','2013-08-22','14:30:00',7.43),('8902','2013-08-22','14:35:00',7.3),('8902','2013-08-22','14:40:00',7.23),('8902','2013-08-22','14:45:00',7.15),('8902','2013-08-22','14:50:00',7.06),('8902','2013-08-22','14:55:00',6.98),('8902','2013-08-22','15:00:00',6.83),('8902','2013-08-22','15:05:00',6.45),('8902','2013-08-22','15:10:00',6.74),('8902','2013-08-22','15:15:00',6.62),('8902','2013-08-22','15:20:00',6.58),('8902','2013-08-22','15:25:00',6.58),('8902','2013-08-22','15:30:00',6.74),('8902','2013-08-22','15:35:00',6.32),('8902','2013-08-22','15:40:00',6.23),('8902','2013-08-22','15:45:00',6.29),('8902','2013-08-22','15:50:00',5.81),('8902','2013-08-22','15:55:00',6.09),('8902','2013-08-22','16:00:00',5.84),('8902','2013-08-22','16:05:00',5.53),('8902','2013-08-22','16:10:00',5.13),('8902','2013-08-22','16:15:00',5.05),('8902','2013-08-22','16:20:00',5.78),('8902','2013-08-22','16:25:00',5.58),('8902','2013-08-22','16:30:00',5.37),('8902','2013-08-22','16:35:00',5.33),('8902','2013-08-22','16:40:00',5.22),('8902','2013-08-22','16:45:00',5.07),('8902','2013-08-22','16:50:00',4.82),('8902','2013-08-22','16:55:00',4.7),('8902','2013-08-22','17:00:00',4.49),('8902','2013-08-22','17:05:00',4.32),('8902','2013-08-22','17:10:00',4.1),('8902','2013-08-22','17:15:00',3.92),('8902','2013-08-22','17:20:00',3.76),('8902','2013-08-22','17:25:00',3.65),('8902','2013-08-22','17:30:00',3.39),('8902','2013-08-22','17:35:00',3.23),('8902','2013-08-22','17:40:00',3.03),('8902','2013-08-22','17:45:00',2.82),('8902','2013-08-22','17:50:00',2.69),('8902','2013-08-22','17:55:00',2.58),('8902','2013-08-22','18:00:00',2.39),('8902','2013-08-22','18:05:00',2.2),('8902','2013-08-22','18:10:00',1.86),('8902','2013-08-22','18:15:00',1.61),('8902','2013-08-22','18:20:00',1.72),('8902','2013-08-22','18:25:00',1.63),('8902','2013-08-22','18:30:00',1.49),('8902','2013-08-22','18:35:00',1.33),('8902','2013-08-22','18:40:00',1.16),('8902','2013-08-22','18:45:00',1),('8902','2013-08-21','07:50:00',1.01),('8902','2013-08-21','07:55:00',1.21),('8902','2013-08-21','08:00:00',1.33),('8902','2013-08-21','08:05:00',1.45),('8902','2013-08-21','08:10:00',1.61),('8902','2013-08-21','08:15:00',1.73),('8902','2013-08-21','08:20:00',1.89),('8902','2013-08-21','08:25:00',2.02),('8902','2013-08-21','08:30:00',2.19),('8902','2013-08-21','08:35:00',2.37),('8902','2013-08-21','08:40:00',2.48),('8902','2013-08-21','08:45:00',2.69),('8902','2013-08-21','08:50:00',2.85),('8902','2013-08-21','08:55:00',3.04),('8902','2013-08-21','09:00:00',3.17),('8902','2013-08-21','09:05:00',3.51),('8902','2013-08-21','09:10:00',3.73),('8902','2013-08-21','09:15:00',3.95),('8902','2013-08-21','09:20:00',4.2),('8902','2013-08-21','09:25:00',4.1),('8902','2013-08-21','09:30:00',3.07),('8902','2013-08-21','09:35:00',2.32),('8902','2013-08-21','09:40:00',2.46),('8902','2013-08-21','09:45:00',3.62),('8902','2013-08-21','09:50:00',3.9),('8902','2013-08-21','09:55:00',4.85),('8902','2013-08-21','10:00:00',5.29),('8902','2013-08-21','10:05:00',5.3),('8902','2013-08-21','10:10:00',5.35),('8902','2013-08-21','10:15:00',5.33),('8902','2013-08-21','10:20:00',5.36),('8902','2013-08-21','10:25:00',5.47),('8902','2013-08-21','10:30:00',5.6),('8902','2013-08-21','10:35:00',5.66),('8902','2013-08-21','10:40:00',5.76),('8902','2013-08-21','10:45:00',5.85),('8902','2013-08-21','10:50:00',5.93),('8902','2013-08-21','10:55:00',6.03),('8902','2013-08-21','11:00:00',6.13),('8902','2013-08-21','11:05:00',6.21),('8902','2013-08-21','11:10:00',6.23),('8902','2013-08-21','11:15:00',6.31),('8902','2013-08-21','11:20:00',6.36),('8902','2013-08-21','11:25:00',6.42),('8902','2013-08-21','11:30:00',6.55),('8902','2013-08-21','11:35:00',6.61),('8902','2013-08-21','11:40:00',6.66),('8902','2013-08-21','11:45:00',6.71),('8902','2013-08-21','11:50:00',6.78),('8902','2013-08-21','11:55:00',6.82),('8902','2013-08-21','12:00:00',6.9),('8902','2013-08-21','12:05:00',6.96),('8902','2013-08-21','12:10:00',7),('8902','2013-08-21','12:15:00',7.01),('8902','2013-08-21','12:20:00',7.03),('8902','2013-08-21','12:25:00',7.05),('8902','2013-08-21','12:30:00',7.1),('8902','2013-08-21','12:35:00',7.14),('8902','2013-08-21','12:40:00',7.14),('8902','2013-08-21','12:45:00',7.17),('8902','2013-08-21','12:50:00',7.19),('8902','2013-08-21','12:55:00',7.2),('8902','2013-08-21','13:00:00',7.18),('8902','2013-08-21','13:05:00',6.95),('8902','2013-08-21','13:10:00',6.97),('8902','2013-08-21','13:15:00',7.04),('8902','2013-08-21','13:20:00',7.14),('8902','2013-08-21','13:25:00',6.99),('8902','2013-08-21','13:30:00',7.1),('8902','2013-08-21','13:35:00',7.09),('8902','2013-08-21','13:40:00',7.12),('8902','2013-08-21','13:45:00',7.22),('8902','2013-08-21','13:50:00',7.18),('8902','2013-08-21','13:55:00',7.12),('8902','2013-08-21','14:00:00',7.07),('8902','2013-08-21','14:05:00',7.05),('8902','2013-08-21','14:10:00',7.05),('8902','2013-08-21','14:15:00',7.06),('8902','2013-08-21','14:20:00',7.04),('8902','2013-08-21','14:25:00',7.12),('8902','2013-08-21','14:30:00',7.14),('8902','2013-08-21','14:35:00',7.04),('8902','2013-08-21','14:40:00',6.97),('8902','2013-08-21','14:45:00',6.83),('8902','2013-08-21','14:50:00',6.77),('8902','2013-08-21','14:55:00',4.46),('8902','2013-08-21','15:00:00',6.81),('8902','2013-08-21','15:05:00',6.8),('8902','2013-08-21','15:10:00',6.65),('8902','2013-08-21','15:15:00',6.62),('8902','2013-08-21','15:20:00',6.51),('8902','2013-08-21','15:25:00',6.4),('8902','2013-08-21','15:30:00',6.33),('8902','2013-08-21','15:35:00',6.25),('8902','2013-08-21','15:40:00',6.19),('8902','2013-08-21','15:45:00',6.1),('8902','2013-08-21','15:50:00',6.02),('8902','2013-08-21','15:55:00',5.92),('8902','2013-08-21','16:00:00',5.79),('8902','2013-08-21','16:05:00',5.62),('8902','2013-08-21','16:10:00',5.51),('8902','2013-08-21','16:15:00',5.44),('8902','2013-08-21','16:20:00',5.33),('8902','2013-08-21','16:25:00',5.22),('8902','2013-08-21','16:30:00',5.06),('8902','2013-08-21','16:35:00',4.94),('8902','2013-08-21','16:40:00',4.79),('8902','2013-08-21','16:45:00',4.61),('8902','2013-08-21','16:50:00',4.39),('8902','2013-08-21','16:55:00',4.37),('8902','2013-08-21','17:00:00',4.17),('8902','2013-08-21','17:05:00',4.07),('8902','2013-08-21','17:10:00',3.86),('8902','2013-08-21','17:15:00',3.69),('8902','2013-08-21','17:20:00',3.57),('8902','2013-08-21','17:25:00',3.43),('8902','2013-08-21','17:30:00',3.26),('8902','2013-08-21','17:35:00',3.11),('8902','2013-08-21','17:40:00',2.92),('8902','2013-08-21','17:45:00',2.72),('8902','2013-08-21','17:50:00',2.55),('8902','2013-08-21','17:55:00',2.45),('8902','2013-08-21','18:00:00',2.29),('8902','2013-08-21','18:05:00',2.13),('8902','2013-08-21','18:10:00',2),('8902','2013-08-21','18:15:00',2),('8902','2013-08-21','18:20:00',1.69),('8902','2013-08-21','18:25:00',1.2),('8902','2013-08-21','18:30:00',1.05),('8902','2013-08-20','08:15:00',1.03),('8902','2013-08-20','08:20:00',1.21),('8902','2013-08-20','08:25:00',1.47),('8902','2013-08-20','08:30:00',1.55),('8902','2013-08-20','08:35:00',1.57),('8902','2013-08-20','08:40:00',1.52),('8902','2013-08-20','08:45:00',1.43),('8902','2013-08-20','08:50:00',1.32),('8902','2013-08-20','08:55:00',1.42),('8902','2013-08-20','09:00:00',1.73),('8902','2013-08-20','09:05:00',2.57),('8902','2013-08-20','09:10:00',2.49),('8902','2013-08-20','09:15:00',4.45),('8902','2013-08-20','09:20:00',4.31),('8902','2013-08-20','09:25:00',2.28),('8902','2013-08-20','09:30:00',1.48),('8902','2013-08-20','09:35:00',1.88),('8902','2013-08-20','09:40:00',2.15),('8902','2013-08-20','09:45:00',2.45),('8902','2013-08-20','09:50:00',5.82),('8902','2013-08-20','09:55:00',6.31),('8902','2013-08-20','10:00:00',5.88),('8902','2013-08-20','10:05:00',4.98),('8902','2013-08-20','10:10:00',3.87),('8902','2013-08-20','10:15:00',3.93),('8902','2013-08-20','10:20:00',3.25),('8902','2013-08-20','10:25:00',3.06),('8902','2013-08-20','10:30:00',3.96),('8902','2013-08-20','10:35:00',6.22),('8902','2013-08-20','10:40:00',5.28),('8902','2013-08-20','10:45:00',4.42),('8902','2013-08-20','10:50:00',3.93),('8902','2013-08-20','10:55:00',3.24),('8902','2013-08-20','11:00:00',4.08),('8902','2013-08-20','11:05:00',3.52),('8902','2013-08-20','11:10:00',3.28),('8902','2013-08-20','11:15:00',4.39),('8902','2013-08-20','11:20:00',7.52),('8902','2013-08-20','11:25:00',4.74),('8902','2013-08-20','11:30:00',5.18),('8902','2013-08-20','11:35:00',7.44),('8902','2013-08-20','11:40:00',7.51),('8902','2013-08-20','11:45:00',7.4),('8902','2013-08-20','11:50:00',5.72),('8902','2013-08-20','11:55:00',7.18),('8902','2013-08-20','12:00:00',7.58),('8902','2013-08-20','12:05:00',7.55),('8902','2013-08-20','12:10:00',7.59),('8902','2013-08-20','12:15:00',7.62),('8902','2013-08-20','12:20:00',6.97),('8902','2013-08-20','12:25:00',5.62),('8902','2013-08-20','12:30:00',6.83),('8902','2013-08-20','12:35:00',6.2),('8902','2013-08-20','12:40:00',6.73),('8902','2013-08-20','12:45:00',7.31),('8902','2013-08-20','12:50:00',7.17),('8902','2013-08-20','12:55:00',6.85),('8902','2013-08-20','13:00:00',7.18),('8902','2013-08-20','13:05:00',7.37),('8902','2013-08-20','13:10:00',7.49),('8902','2013-08-20','13:15:00',7.6),('8902','2013-08-20','13:20:00',7.57),('8902','2013-08-20','13:25:00',7.61),('8902','2013-08-20','13:30:00',7.63),('8902','2013-08-20','13:35:00',7.49),('8902','2013-08-20','13:40:00',7.32),('8902','2013-08-20','13:45:00',7),('8902','2013-08-20','13:50:00',7.11),('8902','2013-08-20','13:55:00',7.08),('8902','2013-08-20','14:00:00',7.06),('8902','2013-08-20','14:05:00',7.36),('8902','2013-08-20','14:10:00',7.37),('8902','2013-08-20','14:15:00',7.42),('8902','2013-08-20','14:20:00',6.33),('8902','2013-08-20','14:25:00',5.64),('8902','2013-08-20','14:30:00',6.66),('8902','2013-08-20','14:35:00',6.5),('8902','2013-08-20','14:40:00',6.67),('8902','2013-08-20','14:45:00',6.69),('8902','2013-08-20','14:50:00',6.31),('8902','2013-08-20','14:55:00',6.37),('8902','2013-08-20','15:00:00',6.62),('8902','2013-08-20','15:05:00',6.67),('8902','2013-08-20','15:10:00',6.43),('8902','2013-08-20','15:15:00',6.39),('8902','2013-08-20','15:20:00',6.2),('8902','2013-08-20','15:25:00',6.18),('8902','2013-08-20','15:30:00',6),('8902','2013-08-20','15:35:00',5.79),('8902','2013-08-20','15:40:00',5.55),('8902','2013-08-20','15:45:00',5.56),('8902','2013-08-20','15:50:00',5.68),('8902','2013-08-20','15:55:00',5.4),('8902','2013-08-20','16:00:00',5),('8902','2013-08-20','16:05:00',4.82),('8902','2013-08-20','16:10:00',4.79),('8902','2013-08-20','16:15:00',4.9),('8902','2013-08-20','16:20:00',5.28),('8902','2013-08-20','16:25:00',5.02),('8902','2013-08-20','16:30:00',5.18),('8902','2013-08-20','16:35:00',5.16),('8902','2013-08-20','16:40:00',4.99),('8902','2013-08-20','16:45:00',4.81),('8902','2013-08-20','16:50:00',4.64),('8902','2013-08-20','16:55:00',4.57),('8902','2013-08-20','17:00:00',4.46),('8902','2013-08-20','17:05:00',4.38),('8902','2013-08-20','17:10:00',4.26),('8902','2013-08-20','17:15:00',4.18),('8902','2013-08-20','17:20:00',4.12),('8902','2013-08-20','17:25:00',4),('8902','2013-08-20','17:30:00',3.74),('8902','2013-08-20','17:35:00',3.6),('8902','2013-08-20','17:40:00',3.46),('8902','2013-08-20','17:45:00',3.31),('8902','2013-08-20','17:50:00',3.21),('8902','2013-08-20','17:55:00',3.07),('8902','2013-08-20','18:00:00',2.9),('8902','2013-08-20','18:05:00',2.73),('8902','2013-08-20','18:10:00',2.5),('8902','2013-08-20','18:15:00',2.3),('8902','2013-08-20','18:20:00',2.09),('8902','2013-08-20','18:25:00',1.83),('8902','2013-08-20','18:30:00',1.63),('8902','2013-08-20','18:35:00',1.33),('8902','2013-08-20','18:40:00',1.16),('8902','2013-08-20','18:45:00',1.06),('8902','2013-08-19','07:40:00',1.15),('8902','2013-08-19','07:45:00',1.19),('8902','2013-08-19','07:50:00',1.39),('8902','2013-08-19','07:55:00',1.68),('8902','2013-08-19','08:00:00',1.61),('8902','2013-08-19','08:05:00',1.45),('8902','2013-08-19','08:10:00',1.2),('8902','2013-08-19','08:15:00',1.22),('8902','2013-08-19','08:20:00',1.3),('8902','2013-08-19','08:25:00',1.36),('8902','2013-08-19','08:30:00',1.29),('8902','2013-08-19','08:35:00',1.24),('8902','2013-08-19','08:40:00',1.32),('8902','2013-08-19','08:45:00',1.5),('8902','2013-08-19','08:50:00',1.77),('8902','2013-08-19','08:55:00',1.98),('8902','2013-08-19','09:00:00',1.95),('8902','2013-08-19','09:05:00',2.23),('8902','2013-08-19','09:10:00',2.13),('8902','2013-08-19','09:15:00',1.92),('8902','2013-08-19','09:20:00',1.86),('8902','2013-08-19','09:25:00',2.81),('8902','2013-08-19','09:30:00',4.09),('8902','2013-08-19','09:35:00',3.98),('8902','2013-08-19','09:40:00',5.01),('8902','2013-08-19','09:45:00',5.3),('8902','2013-08-19','09:50:00',4.33),('8902','2013-08-19','09:55:00',4.49),('8902','2013-08-19','10:00:00',3.33),('8902','2013-08-19','10:05:00',2.39),('8902','2013-08-19','10:10:00',5.72),('8902','2013-08-19','10:15:00',3.44),('8902','2013-08-19','10:20:00',3.87),('8902','2013-08-19','10:25:00',3.17),('8902','2013-08-19','10:30:00',1.9),('8902','2013-08-19','10:35:00',1.79),('8902','2013-08-19','10:40:00',1.76),('8902','2013-08-19','10:45:00',1.66),('8902','2013-08-19','10:50:00',4.94),('8902','2013-08-19','10:55:00',5.18),('8902','2013-08-19','11:00:00',1.72),('8902','2013-08-19','11:05:00',1.09),('8902','2013-08-19','11:10:00',1.33),('8902','2013-08-19','11:15:00',1.86),('8902','2013-08-19','11:20:00',7.62),('8902','2013-08-19','11:25:00',7.13),('8902','2013-08-19','11:30:00',1.73),('8902','2013-08-19','11:35:00',2.08),('8902','2013-08-19','11:40:00',7.83),('8902','2013-08-19','11:45:00',7.46),('8902','2013-08-19','11:50:00',8.65),('8902','2013-08-19','11:55:00',8.22),('8902','2013-08-19','12:00:00',2.98),('8902','2013-08-19','12:05:00',2.63),('8902','2013-08-19','12:10:00',2.35),('8902','2013-08-19','12:15:00',1.69),('8902','2013-08-19','12:20:00',1.83),('8902','2013-08-19','12:25:00',2.08),('8902','2013-08-19','12:30:00',2.33),('8902','2013-08-19','12:35:00',2.56),('8902','2013-08-19','12:40:00',3.2),('8902','2013-08-19','12:45:00',3.26),('8902','2013-08-19','12:50:00',3.35),('8902','2013-08-19','12:55:00',3.52),('8902','2013-08-19','13:00:00',3.36),('8902','2013-08-19','13:05:00',3.13),('8902','2013-08-19','13:10:00',3.03),('8902','2013-08-19','13:15:00',3.18),('8902','2013-08-19','13:20:00',3.27),('8902','2013-08-19','13:25:00',3.43),('8902','2013-08-19','13:30:00',3.69),('8902','2013-08-19','13:35:00',4.63),('8902','2013-08-19','13:40:00',7.7),('8902','2013-08-19','13:45:00',8.44),('8902','2013-08-19','13:50:00',8.26),('8902','2013-08-19','13:55:00',7.99),('8902','2013-08-19','14:00:00',7.79),('8902','2013-08-19','14:05:00',7.8),('8902','2013-08-19','14:10:00',7.88),('8902','2013-08-19','14:15:00',7.77),('8902','2013-08-19','14:20:00',7.64),('8902','2013-08-19','14:25:00',7.4),('8902','2013-08-19','14:30:00',5.64),('8902','2013-08-19','14:35:00',8.19),('8902','2013-08-19','14:40:00',8.16),('8902','2013-08-19','14:45:00',7.58),('8902','2013-08-19','14:50:00',7.66),('8902','2013-08-19','14:55:00',5.82),('8902','2013-08-19','15:00:00',6.08),('8902','2013-08-19','15:05:00',7.16),('8902','2013-08-19','15:10:00',7.67),('8902','2013-08-19','15:15:00',7.52),('8902','2013-08-19','15:20:00',7.3),('8902','2013-08-19','15:25:00',7.09),('8902','2013-08-19','15:30:00',7.27),('8902','2013-08-19','15:35:00',7.26),('8902','2013-08-19','15:40:00',7.3),('8902','2013-08-19','15:45:00',7.63),('8902','2013-08-19','15:50:00',6.58),('8902','2013-08-19','15:55:00',7.8),('8902','2013-08-19','16:00:00',6.7),('8902','2013-08-19','16:05:00',6.93),('8902','2013-08-19','16:10:00',7.24),('8902','2013-08-19','16:15:00',7.12),('8902','2013-08-19','16:20:00',6.99),('8902','2013-08-19','16:25:00',6.66),('8902','2013-08-19','16:30:00',6.05),('8902','2013-08-19','16:35:00',6.26),('8902','2013-08-19','16:40:00',6.42),('8902','2013-08-19','16:45:00',6.13),('8902','2013-08-19','16:50:00',5.5),('8902','2013-08-19','16:55:00',5.29),('8902','2013-08-19','17:00:00',4.96),('8902','2013-08-19','17:05:00',4.72),('8902','2013-08-19','17:10:00',4.47),('8902','2013-08-19','17:15:00',4.21),('8902','2013-08-19','17:20:00',4.15),('8902','2013-08-19','17:25:00',4),('8902','2013-08-19','17:30:00',3.79),('8902','2013-08-19','17:35:00',3.65),('8902','2013-08-19','17:40:00',3.32),('8902','2013-08-19','17:45:00',3.31),('8902','2013-08-19','17:50:00',3.05),('8902','2013-08-19','17:55:00',2.85),('8902','2013-08-19','18:00:00',2),('8902','2013-08-19','18:05:00',2.6),('8902','2013-08-19','18:10:00',2.55),('8902','2013-08-19','18:15:00',2.51),('8902','2013-08-19','18:20:00',2.4),('8902','2013-08-19','18:25:00',2.2),('8902','2013-08-19','18:30:00',2.16),('8902','2013-08-19','18:35:00',1.99),('8902','2013-08-19','18:40:00',1.79),('8902','2013-08-19','18:45:00',1.69),('8902','2013-08-19','18:50:00',1.48),('8902','2013-08-19','18:55:00',1.43),('8902','2013-08-19','19:00:00',1.3),('8902','2013-08-19','19:05:00',1.02),('8902','2014-04-09','07:55:00',1.08),('8902','2014-04-09','08:00:00',1.3),('8902','2014-04-09','08:05:00',1.5),('8902','2014-04-09','08:10:00',1.7),('8902','2014-04-09','08:15:00',1.89),('8902','2014-04-09','08:20:00',2.08),('8902','2014-04-09','08:25:00',2.29),('8902','2014-04-09','08:30:00',2.49),('8902','2014-04-09','08:35:00',2.69),('8902','2014-04-09','08:40:00',2.9),('8902','2014-04-09','08:45:00',3.08),('8902','2014-04-09','08:50:00',3.27),('8902','2014-04-09','08:55:00',3.44),('8902','2014-04-09','09:00:00',3.58),('8902','2014-04-09','09:05:00',3.82),('8902','2014-04-09','09:10:00',3.99),('8902','2014-04-09','09:15:00',4.11),('8902','2014-04-09','09:20:00',4.15),('8902','2014-04-09','09:25:00',4.53),('8902','2014-04-09','09:30:00',4.72),('8902','2014-04-09','09:35:00',4.9),('8902','2014-04-09','09:40:00',5.03),('8902','2014-04-09','09:45:00',5.15),('8902','2014-04-09','09:50:00',5.34),('8902','2014-04-09','09:55:00',5.49),('8902','2014-04-09','10:00:00',5.63),('8902','2014-04-09','10:05:00',5.76),('8902','2014-04-09','10:10:00',5.93),('8902','2014-04-09','10:15:00',5.94),('8902','2014-04-09','10:20:00',6.11),('8902','2014-04-09','10:25:00',6.22),('8902','2014-04-09','10:30:00',6.29),('8902','2014-04-09','10:35:00',6.54),('8902','2014-04-09','10:40:00',6.64),('8902','2014-04-09','10:45:00',6.71),('8902','2014-04-09','10:50:00',6.64),('8902','2014-04-09','10:55:00',6.78),('8902','2014-04-09','11:00:00',6.9),('8902','2014-04-09','11:05:00',7.13),('8902','2014-04-09','11:10:00',6.99),('8902','2014-04-09','11:15:00',7.27),('8902','2014-04-09','11:20:00',7.47),('8902','2014-04-09','11:25:00',7.6),('8902','2014-04-09','11:30:00',7.63),('8902','2014-04-09','11:35:00',7.75),('8902','2014-04-09','11:40:00',7.55),('8902','2014-04-09','11:45:00',7.77),('8902','2014-04-09','11:50:00',7.49),('8902','2014-04-09','11:55:00',7.88),('8902','2014-04-09','12:00:00',7.79),('8902','2014-04-09','12:05:00',7.38),('8902','2014-04-09','12:10:00',7.68),('8902','2014-04-09','12:15:00',7.76),('8902','2014-04-09','12:20:00',7.83),('8902','2014-04-09','12:25:00',7.69),('8902','2014-04-09','12:30:00',7.83),('8902','2014-04-09','12:35:00',8.14),('8902','2014-04-09','12:40:00',8.1),('8902','2014-04-09','12:45:00',8.11),('8902','2014-04-09','12:50:00',7.99),('8902','2014-04-09','12:55:00',7.88),('8902','2014-04-09','13:00:00',7.89),('8902','2014-04-09','13:05:00',7.56),('8902','2014-04-09','13:10:00',7.67),('8902','2014-04-09','13:15:00',7.9),('8902','2014-04-09','13:20:00',7.78),('8902','2014-04-09','13:25:00',8.4),('8902','2014-04-09','13:30:00',8.13),('8902','2014-04-09','13:35:00',8.34),('8902','2014-04-09','13:40:00',8.06),('8902','2014-04-09','13:45:00',8.36),('8902','2014-04-09','13:50:00',8.28),('8902','2014-04-09','13:55:00',8.2),('8902','2014-04-09','14:00:00',8.16),('8902','2014-04-09','14:05:00',8.14),('8902','2014-04-09','14:10:00',8.13),('8902','2014-04-09','14:15:00',8.08),('8902','2014-04-09','14:20:00',8.08),('8902','2014-04-09','14:25:00',8.07),('8902','2014-04-09','14:30:00',8.03),('8902','2014-04-09','14:35:00',8.03),('8902','2014-04-09','14:40:00',7.97),('8902','2014-04-09','14:45:00',7.25),('8902','2014-04-09','14:50:00',7.98),('8902','2014-04-09','14:55:00',7.8),('8902','2014-04-09','15:00:00',7.7),('8902','2014-04-09','15:05:00',7.6),('8902','2014-04-09','15:10:00',7.49),('8902','2014-04-09','15:15:00',7.49),('8902','2014-04-09','15:20:00',7.43),('8902','2014-04-09','15:25:00',7.3),('8902','2014-04-09','15:30:00',6.68),('8902','2014-04-09','15:35:00',6.57),('8902','2014-04-09','15:40:00',6.8),('8902','2014-04-09','15:45:00',6.6),('8902','2014-04-09','15:50:00',6.69),('8902','2014-04-09','15:55:00',6.54),('8902','2014-04-09','16:00:00',6.3),('8902','2014-04-09','16:05:00',6.43),('8902','2014-04-09','16:10:00',6.37),('8902','2014-04-09','16:15:00',6.57),('8902','2014-04-09','16:20:00',6.18),('8902','2014-04-09','16:25:00',6.25),('8902','2014-04-09','16:30:00',5.96),('8902','2014-04-09','16:35:00',5.97),('8902','2014-04-09','16:40:00',5.84),('8902','2014-04-09','16:45:00',5.75),('8902','2014-04-09','16:50:00',5.43),('8902','2014-04-09','16:55:00',5.31),('8902','2014-04-09','17:00:00',5.09),('8902','2014-04-09','17:05:00',4.91),('8902','2014-04-09','17:10:00',4.63),('8902','2014-04-09','17:15:00',4.42),('8902','2014-04-09','17:20:00',4.37),('8902','2014-04-09','17:25:00',4.13),('8902','2014-04-09','17:30:00',3.89),('8902','2014-04-09','17:35:00',3.68),('8902','2014-04-09','17:40:00',3.42),('8902','2014-04-09','17:45:00',3.24),('8902','2014-04-09','17:50:00',3.07),('8902','2014-04-09','17:55:00',2.81),('8902','2014-04-09','18:00:00',2.62),('8902','2014-04-09','18:05:00',2.42),('8902','2014-04-09','18:10:00',2.22),('8902','2014-04-09','18:15:00',2.01),('8902','2014-04-09','18:20:00',1.83),('8902','2014-04-09','18:25:00',1.63),('8902','2014-04-09','18:30:00',1.44),('8902','2014-04-09','18:35:00',1.22),('8902','2014-04-09','18:40:00',1.06),('8902','2013-08-18','07:40:00',1.04),('8902','2013-08-18','07:50:00',1.06),('8902','2013-08-18','07:55:00',1.26),('8902','2013-08-18','08:00:00',1.41),('8902','2013-08-18','08:05:00',1.56),('8902','2013-08-18','08:10:00',1.71),('8902','2013-08-18','08:15:00',1.85),('8902','2013-08-18','08:20:00',2),('8902','2013-08-18','08:25:00',2.18),('8902','2013-08-18','08:30:00',2.33),('8902','2013-08-18','08:35:00',2.48),('8902','2013-08-18','08:40:00',2.58),('8902','2013-08-18','08:45:00',2.8),('8902','2013-08-18','08:50:00',2.99),('8902','2013-08-18','08:55:00',3.17),('8902','2013-08-18','09:00:00',3.34),('8902','2013-08-18','09:05:00',3.48),('8902','2013-08-18','09:10:00',3.64),('8902','2013-08-18','09:15:00',3.79),('8902','2013-08-18','09:20:00',3.96),('8902','2013-08-18','09:25:00',4.07),('8902','2013-08-18','09:30:00',4.21),('8902','2013-08-18','09:35:00',4.36),('8902','2013-08-18','09:40:00',4.5),('8902','2013-08-18','09:45:00',4.64),('8902','2013-08-18','09:50:00',4.75),('8902','2013-08-18','09:55:00',4.9),('8902','2013-08-18','10:00:00',5.04),('8902','2013-08-18','10:05:00',5.14),('8902','2013-08-18','10:10:00',5.28),('8902','2013-08-18','10:15:00',5.4),('8902','2013-08-18','10:20:00',5.5),('8902','2013-08-18','10:25:00',5.6),('8902','2013-08-18','10:30:00',5.69),('8902','2013-08-18','10:35:00',5.81),('8902','2013-08-18','10:40:00',5.91),('8902','2013-08-18','10:45:00',5.99),('8902','2013-08-18','10:50:00',6.06),('8902','2013-08-18','10:55:00',6.16),('8902','2013-08-18','11:00:00',6.28),('8902','2013-08-18','11:05:00',6.32),('8902','2013-08-18','11:10:00',6.33),('8902','2013-08-18','11:15:00',6.4),('8902','2013-08-18','11:20:00',6.5),('8902','2013-08-18','11:25:00',6.5),('8902','2013-08-18','11:30:00',6.63),('8902','2013-08-18','11:35:00',6.55),('8902','2013-08-18','11:40:00',6.75),('8902','2013-08-18','11:45:00',6.86),('8902','2013-08-18','11:50:00',6.87),('8902','2013-08-18','11:55:00',6.91),('8902','2013-08-18','12:00:00',6.96),('8902','2013-08-18','12:05:00',6.93),('8902','2013-08-18','12:10:00',7.06),('8902','2013-08-18','12:15:00',7.1),('8902','2013-08-18','12:20:00',7.21),('8902','2013-08-18','12:25:00',7.21),('8902','2013-08-18','12:30:00',7.15),('8902','2013-08-18','12:35:00',7.28),('8902','2013-08-18','12:40:00',7.29),('8902','2013-08-18','12:45:00',7.29),('8902','2013-08-18','12:50:00',7.44),('8902','2013-08-18','12:55:00',7.41),('8902','2013-08-18','13:00:00',7.42),('8902','2013-08-18','13:05:00',7.49),('8902','2013-08-18','13:10:00',7.53),('8902','2013-08-18','13:15:00',7.53),('8902','2013-08-18','13:20:00',7.58),('8902','2013-08-18','13:25:00',7.55),('8902','2013-08-18','13:30:00',7.56),('8902','2013-08-18','13:35:00',7.56),('8902','2013-08-18','13:40:00',7.56),('8902','2013-08-18','13:45:00',7.55),('8902','2013-08-18','13:50:00',7.52),('8902','2013-08-18','13:55:00',7.56),('8902','2013-08-18','14:00:00',7.55),('8902','2013-08-18','14:05:00',7.47),('8902','2013-08-18','14:10:00',7.5),('8902','2013-08-18','14:15:00',7.46),('8902','2013-08-18','14:20:00',7.47),('8902','2013-08-18','14:25:00',7.44),('8902','2013-08-18','14:30:00',7.38),('8902','2013-08-18','14:35:00',7.4),('8902','2013-08-18','14:40:00',7.38),('8902','2013-08-18','14:45:00',7.35),('8902','2013-08-18','14:50:00',7.28),('8902','2013-08-18','14:55:00',7.23),('8902','2013-08-18','15:00:00',7.12),('8902','2013-08-18','15:05:00',7.06),('8902','2013-08-18','15:10:00',6.97),('8902','2013-08-18','15:15:00',6.95),('8902','2013-08-18','15:20:00',6.91),('8902','2013-08-18','15:25:00',6.89),('8902','2013-08-18','15:30:00',6.77),('8902','2013-08-18','15:35:00',6.67),('8902','2013-08-18','15:40:00',6.61),('8902','2013-08-18','15:45:00',6.51),('8902','2013-08-18','15:50:00',6.41),('8902','2013-08-18','15:55:00',6.32),('8902','2013-08-18','16:00:00',6.19),('8902','2013-08-18','16:05:00',6.1),('8902','2013-08-18','16:10:00',6.05),('8902','2013-08-18','16:15:00',5.92),('8902','2013-08-18','16:20:00',5.78),('8902','2013-08-18','16:25:00',5.6),('8902','2013-08-18','16:30:00',5.45),('8902','2013-08-18','16:35:00',5.4),('8902','2013-08-18','16:40:00',5.29),('8902','2013-08-18','16:45:00',5.16),('8902','2013-08-18','16:50:00',4.98),('8902','2013-08-18','16:55:00',4.87),('8902','2013-08-18','17:00:00',4.71),('8902','2013-08-18','17:05:00',4.57),('8902','2013-08-18','17:10:00',4.41),('8902','2013-08-18','17:15:00',4.23),('8902','2013-08-18','17:20:00',4.09),('8902','2013-08-18','17:25:00',3.93),('8902','2013-08-18','17:30:00',3.79),('8902','2013-08-18','17:35:00',3.61),('8902','2013-08-18','17:40:00',3.45),('8902','2013-08-18','17:45:00',3.25),('8902','2013-08-18','17:50:00',3.09),('8902','2013-08-18','17:55:00',2.94),('8902','2013-08-18','18:00:00',2.74),('8902','2013-08-18','18:05:00',2.59),('8902','2013-08-18','18:10:00',2.39),('8902','2013-08-18','18:15:00',2.19),('8902','2013-08-18','18:20:00',2.03),('8902','2013-08-18','18:25:00',1.81),('8902','2013-08-18','18:30:00',1.65),('8902','2013-08-18','18:35:00',1.5),('8902','2013-08-18','18:40:00',1.35),('8902','2013-08-18','18:45:00',1.18),('8902','2013-08-18','18:50:00',1.03),('8902','2013-08-17','07:50:00',1.05),('8902','2013-08-17','07:55:00',1.28),('8902','2013-08-17','08:00:00',1.43),('8902','2013-08-17','08:05:00',1.59),('8902','2013-08-17','08:10:00',1.76),('8902','2013-08-17','08:15:00',1.93),('8902','2013-08-17','08:20:00',2.09),('8902','2013-08-17','08:25:00',2.26),('8902','2013-08-17','08:30:00',2.43),('8902','2013-08-17','08:35:00',2.59),('8902','2013-08-17','08:40:00',2.76),('8902','2013-08-17','08:45:00',2.93),('8902','2013-08-17','08:50:00',3.08),('8902','2013-08-17','08:55:00',3.22),('8902','2013-08-17','09:00:00',3.38),('8902','2013-08-17','09:05:00',3.54),('8902','2013-08-17','09:10:00',3.72),('8902','2013-08-17','09:15:00',3.89),('8902','2013-08-17','09:20:00',4.03),('8902','2013-08-17','09:25:00',4.18),('8902','2013-08-17','09:30:00',4.34),('8902','2013-08-17','09:35:00',4.47),('8902','2013-08-17','09:40:00',4.7),('8902','2013-08-17','09:45:00',4.57),('8902','2013-08-17','09:50:00',4.76),('8902','2013-08-17','09:55:00',3.7),('8902','2013-08-17','10:00:00',5.16),('8902','2013-08-17','10:05:00',4.58),('8902','2013-08-17','10:10:00',4.78),('8902','2013-08-17','10:15:00',5.48),('8902','2013-08-17','10:20:00',5.54),('8902','2013-08-17','10:25:00',5.64),('8902','2013-08-17','10:30:00',5.7),('8902','2013-08-17','10:35:00',5.78),('8902','2013-08-17','10:40:00',5.87),('8902','2013-08-17','10:45:00',5.93),('8902','2013-08-17','10:50:00',5.98),('8902','2013-08-17','10:55:00',6.09),('8902','2013-08-17','11:00:00',6.19),('8902','2013-08-17','11:05:00',6.25),('8902','2013-08-17','11:10:00',6.29),('8902','2013-08-17','11:15:00',6.34),('8902','2013-08-17','11:20:00',6.48),('8902','2013-08-17','11:25:00',6.53),('8902','2013-08-17','11:30:00',6.54),('8902','2013-08-17','11:35:00',6.69),('8902','2013-08-17','11:40:00',6.83),('8902','2013-08-17','11:45:00',6.86),('8902','2013-08-17','11:50:00',6.88),('8902','2013-08-17','11:55:00',6.95),('8902','2013-08-17','12:00:00',7),('8902','2013-08-17','12:05:00',7.16),('8902','2013-08-17','12:10:00',7.2),('8902','2013-08-17','12:15:00',7.01),('8902','2013-08-17','12:20:00',7.26),('8902','2013-08-17','12:25:00',7.41),('8902','2013-08-17','12:30:00',7.57),('8902','2013-08-17','12:35:00',6.99),('8902','2013-08-17','12:40:00',2.54),('8902','2013-08-17','12:45:00',2.47),('8902','2013-08-17','12:50:00',2.23),('8902','2013-08-17','12:55:00',2.39),('8902','2013-08-17','13:00:00',4.13),('8902','2013-08-17','13:05:00',7.41),('8902','2013-08-17','13:10:00',6.9),('8902','2013-08-17','13:15:00',6.92),('8902','2013-08-17','13:20:00',7.52),('8902','2013-08-17','13:25:00',7.52),('8902','2013-08-17','13:30:00',7.6),('8902','2013-08-17','13:35:00',7.61),('8902','2013-08-17','13:40:00',7.65),('8902','2013-08-17','13:45:00',7.56),('8902','2013-08-17','13:50:00',7.55),('8902','2013-08-17','13:55:00',7.47),('8902','2013-08-17','14:00:00',7.49),('8902','2013-08-17','14:05:00',7.58),('8902','2013-08-17','14:10:00',7.42),('8902','2013-08-17','14:15:00',7.37),('8902','2013-08-17','14:20:00',7.39),('8902','2013-08-17','14:25:00',7.37),('8902','2013-08-17','14:30:00',7.4),('8902','2013-08-17','14:35:00',7.39),('8902','2013-08-17','14:40:00',7.31),('8902','2013-08-17','14:45:00',7.28),('8902','2013-08-17','14:50:00',7.22),('8902','2013-08-17','14:55:00',7.16),('8902','2013-08-17','15:00:00',7.09),('8902','2013-08-17','15:05:00',7),('8902','2013-08-17','15:10:00',6.94),('8902','2013-08-17','15:15:00',6.94),('8902','2013-08-17','15:20:00',6.85),('8902','2013-08-17','15:25:00',6.75),('8902','2013-08-17','15:30:00',6.68),('8902','2013-08-17','15:35:00',6.63),('8902','2013-08-17','15:40:00',6.55),('8902','2013-08-17','15:45:00',6.49),('8902','2013-08-17','15:50:00',6.38),('8902','2013-08-17','15:55:00',6.29),('8902','2013-08-17','16:00:00',6.18),('8902','2013-08-17','16:05:00',6.08),('8902','2013-08-17','16:10:00',5.99),('8902','2013-08-17','16:15:00',5.89),('8902','2013-08-17','16:20:00',5.76),('8902','2013-08-17','16:25:00',5.64),('8902','2013-08-17','16:30:00',5.47),('8902','2013-08-17','16:35:00',5.4),('8902','2013-08-17','16:40:00',5.25),('8902','2013-08-17','16:45:00',5.12),('8902','2013-08-17','16:50:00',4.94),('8902','2013-08-17','16:55:00',4.78),('8902','2013-08-17','17:00:00',4.7),('8902','2013-08-17','17:05:00',4.59),('8902','2013-08-17','17:10:00',4.42),('8902','2013-08-17','17:15:00',4.24),('8902','2013-08-17','17:20:00',4.13),('8902','2013-08-17','17:25:00',4),('8902','2013-08-17','17:30:00',3.84),('8902','2013-08-17','17:35:00',3.62),('8902','2013-08-17','17:40:00',3.47),('8902','2013-08-17','17:45:00',3.26),('8902','2013-08-17','17:50:00',3.08),('8902','2013-08-17','17:55:00',2.93),('8902','2013-08-17','18:00:00',2.74),('8902','2013-08-17','18:05:00',2.58),('8902','2013-08-17','18:10:00',2.39),('8902','2013-08-17','18:15:00',2.24),('8902','2013-08-17','18:20:00',2.05),('8902','2013-08-17','18:25:00',1.83),('8902','2013-08-17','18:30:00',1.68),('8902','2013-08-17','18:35:00',1.52),('8902','2013-08-17','18:40:00',1.37),('8902','2013-08-17','18:45:00',1.19),('8902','2013-08-17','18:50:00',1.07),('8902','2013-08-16','07:50:00',1.06),('8902','2013-08-16','07:55:00',1.28),('8902','2013-08-16','08:00:00',1.41),('8902','2013-08-16','08:05:00',1.55),('8902','2013-08-16','08:10:00',1.71),('8902','2013-08-16','08:15:00',1.86),('8902','2013-08-16','08:20:00',2.02),('8902','2013-08-16','08:25:00',2.17),('8902','2013-08-16','08:30:00',2.33),('8902','2013-08-16','08:35:00',2.5),('8902','2013-08-16','08:40:00',2.69),('8902','2013-08-16','08:45:00',2.86),('8902','2013-08-16','08:50:00',3.03),('8902','2013-08-16','08:55:00',3.19),('8902','2013-08-16','09:00:00',3.36),('8902','2013-08-16','09:05:00',3.52),('8902','2013-08-16','09:10:00',3.68),('8902','2013-08-16','09:15:00',3.82),('8902','2013-08-16','09:20:00',3.97),('8902','2013-08-16','09:25:00',4.14),('8902','2013-08-16','09:30:00',4.29),('8902','2013-08-16','09:35:00',4.45),('8902','2013-08-16','09:40:00',4.58),('8902','2013-08-16','09:45:00',4.71),('8902','2013-08-16','09:50:00',4.85),('8902','2013-08-16','09:55:00',4.98),('8902','2013-08-16','10:00:00',5.08),('8902','2013-08-16','10:05:00',5.19),('8902','2013-08-16','10:10:00',5.31),('8902','2013-08-16','10:15:00',5.44),('8902','2013-08-16','10:20:00',5.55),('8902','2013-08-16','10:25:00',5.63),('8902','2013-08-16','10:30:00',5.7),('8902','2013-08-16','10:35:00',5.87),('8902','2013-08-16','10:40:00',5.94),('8902','2013-08-16','10:45:00',6.02),('8902','2013-08-16','10:50:00',6.1),('8902','2013-08-16','10:55:00',6.23),('8902','2013-08-16','11:00:00',6.29),('8902','2013-08-16','11:05:00',6.35),('8902','2013-08-16','11:10:00',6.44),('8902','2013-08-16','11:15:00',6.53),('8902','2013-08-16','11:20:00',6.58),('8902','2013-08-16','11:25:00',6.62),('8902','2013-08-16','11:30:00',6.68),('8902','2013-08-16','11:35:00',6.75),('8902','2013-08-16','11:40:00',6.77),('8902','2013-08-16','11:45:00',6.87),('8902','2013-08-16','11:50:00',7.01),('8902','2013-08-16','11:55:00',7.11),('8902','2013-08-16','12:00:00',6.97),('8902','2013-08-16','12:05:00',7),('8902','2013-08-16','12:10:00',6.98),('8902','2013-08-16','12:15:00',7.16),('8902','2013-08-16','12:20:00',7.32),('8902','2013-08-16','12:25:00',6.18),('8902','2013-08-16','12:30:00',5.97),('8902','2013-08-16','12:35:00',3.7),('8902','2013-08-16','12:40:00',7.37),('8902','2013-08-16','12:45:00',7.47),('8902','2013-08-16','12:50:00',7.45),('8902','2013-08-16','12:55:00',7.51),('8902','2013-08-16','13:00:00',7.61),('8902','2013-08-16','13:05:00',7.5),('8902','2013-08-16','13:10:00',7.57),('8902','2013-08-16','13:15:00',7.66),('8902','2013-08-16','13:20:00',7.66),('8902','2013-08-16','13:25:00',7.74),('8902','2013-08-16','13:30:00',7.79),('8902','2013-08-16','13:35:00',7.61),('8902','2013-08-16','13:40:00',5.39),('8902','2013-08-16','13:45:00',1.85),('8902','2013-08-16','13:50:00',7.58),('8902','2013-08-16','13:55:00',2.68),('8902','2013-08-16','14:00:00',2.67),('8902','2013-08-16','14:05:00',7.47),('8902','2013-08-16','14:10:00',7.68),('8902','2013-08-16','14:15:00',2.36),('8902','2013-08-16','14:20:00',6.4),('8902','2013-08-16','14:25:00',7.79),('8902','2013-08-16','14:30:00',7.56),('8902','2013-08-16','14:35:00',7.35),('8902','2013-08-16','14:40:00',7.4),('8902','2013-08-16','14:45:00',7.25),('8902','2013-08-16','14:50:00',7.19),('8902','2013-08-16','14:55:00',7.09),('8902','2013-08-16','15:00:00',7.13),('8902','2013-08-16','15:05:00',7.02),('8902','2013-08-16','15:10:00',6.97),('8902','2013-08-16','15:15:00',6.87),('8902','2013-08-16','15:20:00',6.84),('8902','2013-08-16','15:25:00',6.78),('8902','2013-08-16','15:30:00',6.69),('8902','2013-08-16','15:35:00',6.61),('8902','2013-08-16','15:40:00',6.55),('8902','2013-08-16','15:45:00',6.48),('8902','2013-08-16','15:50:00',6.4),('8902','2013-08-16','15:55:00',6.32),('8902','2013-08-16','16:00:00',6.21),('8902','2013-08-16','16:05:00',6.1),('8902','2013-08-16','16:10:00',6.05),('8902','2013-08-16','16:15:00',5.99),('8902','2013-08-16','16:20:00',5.82),('8902','2013-08-16','16:25:00',5.74),('8902','2013-08-16','16:30:00',5.45),('8902','2013-08-16','16:35:00',5.43),('8902','2013-08-16','16:40:00',5.4),('8902','2013-08-16','16:45:00',5.26),('8902','2013-08-16','16:50:00',4.92),('8902','2013-08-16','16:55:00',4.86),('8902','2013-08-16','17:00:00',4.83),('8902','2013-08-16','17:05:00',4.61),('8902','2013-08-16','17:10:00',4.49),('8902','2013-08-16','17:15:00',3.79),('8902','2013-08-16','17:20:00',4.09),('8902','2013-08-16','17:25:00',4.04),('8902','2013-08-16','17:30:00',4.03),('8902','2013-08-16','17:35:00',3.86),('8902','2013-08-16','17:40:00',3.7),('8902','2013-08-16','17:45:00',3.5),('8902','2013-08-16','17:50:00',3.27),('8902','2013-08-16','17:55:00',3.13),('8902','2013-08-16','18:00:00',2.93),('8902','2013-08-16','18:05:00',2.73),('8902','2013-08-16','18:10:00',2.49),('8902','2013-08-16','18:15:00',2.37),('8902','2013-08-16','18:20:00',2.16),('8902','2013-08-16','18:25:00',1.93),('8902','2013-08-16','18:30:00',1.77),('8902','2013-08-16','18:35:00',1.6),('8902','2013-08-16','18:40:00',1.44),('8902','2013-08-16','18:45:00',1.26),('8902','2013-08-16','18:50:00',1.12),('8902','2013-08-15','07:50:00',1.06),('8902','2013-08-15','07:55:00',1.29),('8902','2013-08-15','08:00:00',1.44),('8902','2013-08-15','08:05:00',1.59),('8902','2013-08-15','08:10:00',1.75),('8902','2013-08-15','08:15:00',1.92),('8902','2013-08-15','08:20:00',2.09),('8902','2013-08-15','08:25:00',2.26),('8902','2013-08-15','08:30:00',2.43),('8902','2013-08-15','08:35:00',2.6),('8902','2013-08-15','08:40:00',2.76),('8902','2013-08-15','08:45:00',2.93),('8902','2013-08-15','08:50:00',3.1),('8902','2013-08-15','08:55:00',3.27),('8902','2013-08-15','09:00:00',3.44),('8902','2013-08-15','09:05:00',3.61),('8902','2013-08-15','09:10:00',3.78),('8902','2013-08-15','09:15:00',3.94),('8902','2013-08-15','09:20:00',4.11),('8902','2013-08-15','09:25:00',4.26),('8902','2013-08-15','09:30:00',4.41),('8902','2013-08-15','09:35:00',4.56),('8902','2013-08-15','09:40:00',4.71),('8902','2013-08-15','09:45:00',4.85),('8902','2013-08-15','09:50:00',4.99),('8902','2013-08-15','09:55:00',5.13),('8902','2013-08-15','10:00:00',5.26),('8902','2013-08-15','10:05:00',5.4),('8902','2013-08-15','10:10:00',5.51),('8902','2013-08-15','10:15:00',5.62),('8902','2013-08-15','10:20:00',5.72),('8902','2013-08-15','10:25:00',5.83),('8902','2013-08-15','10:30:00',5.94),('8902','2013-08-15','10:35:00',6.05),('8902','2013-08-15','10:40:00',6.14),('8902','2013-08-15','10:45:00',6.23),('8902','2013-08-15','10:50:00',6.32),('8902','2013-08-15','10:55:00',6.41),('8902','2013-08-15','11:00:00',6.48),('8902','2013-08-15','11:05:00',6.56),('8902','2013-08-15','11:10:00',6.64),('8902','2013-08-15','11:15:00',6.72),('8902','2013-08-15','11:20:00',6.76),('8902','2013-08-15','11:25:00',6.8),('8902','2013-08-15','11:30:00',6.89),('8902','2013-08-15','11:35:00',6.99),('8902','2013-08-15','11:40:00',7.07),('8902','2013-08-15','11:45:00',7.08),('8902','2013-08-15','11:50:00',7.1),('8902','2013-08-15','11:55:00',7.16),('8902','2013-08-15','12:00:00',7.22),('8902','2013-08-15','12:05:00',7.22),('8902','2013-08-15','12:10:00',7.27),('8902','2013-08-15','12:15:00',7.3),('8902','2013-08-15','12:20:00',7.36),('8902','2013-08-15','12:25:00',7.42),('8902','2013-08-15','12:30:00',7.45),('8902','2013-08-15','12:35:00',7.45),('8902','2013-08-15','12:40:00',7.47),('8902','2013-08-15','12:45:00',7.5),('8902','2013-08-15','12:50:00',7.52),('8902','2013-08-15','12:55:00',7.54),('8902','2013-08-15','13:00:00',7.53),('8902','2013-08-15','13:05:00',7.53),('8902','2013-08-15','13:10:00',7.61),('8902','2013-08-15','13:15:00',7.59),('8902','2013-08-15','13:20:00',7.57),('8902','2013-08-15','13:25:00',7.53),('8902','2013-08-15','13:30:00',7.48),('8902','2013-08-15','13:35:00',7.48),('8902','2013-08-15','13:40:00',7.48),('8902','2013-08-15','13:45:00',7.46),('8902','2013-08-15','13:50:00',7.5),('8902','2013-08-15','13:55:00',7.44),('8902','2013-08-15','14:00:00',7.42),('8902','2013-08-15','14:05:00',7.42),('8902','2013-08-15','14:10:00',7.38),('8902','2013-08-15','14:15:00',7.35),('8902','2013-08-15','14:20:00',7.36),('8902','2013-08-15','14:25:00',7.32),('8902','2013-08-15','14:30:00',7.28),('8902','2013-08-15','14:35:00',7.29),('8902','2013-08-15','14:40:00',7.19),('8902','2013-08-15','14:45:00',7.12),('8902','2013-08-15','14:50:00',7.05),('8902','2013-08-15','14:55:00',7),('8902','2013-08-15','15:00:00',6.93),('8902','2013-08-15','15:05:00',6.84),('8902','2013-08-15','15:10:00',6.83),('8902','2013-08-15','15:15:00',6.85),('8902','2013-08-15','15:20:00',6.72),('8902','2013-08-15','15:25:00',6.72),('8902','2013-08-15','15:30:00',6.66),('8902','2013-08-15','15:35:00',6.57),('8902','2013-08-15','15:40:00',6.51),('8902','2013-08-15','15:45:00',6.42),('8902','2013-08-15','15:50:00',6.38),('8902','2013-08-15','15:55:00',6.3),('8902','2013-08-15','16:00:00',6.19),('8902','2013-08-15','16:05:00',6.1),('8902','2013-08-15','16:10:00',5.99),('8902','2013-08-15','16:15:00',5.91),('8902','2013-08-15','16:20:00',5.8),('8902','2013-08-15','16:25:00',5.72),('8902','2013-08-15','16:30:00',5.58),('8902','2013-08-15','16:35:00',5.37),('8902','2013-08-15','16:40:00',5.33),('8902','2013-08-15','16:45:00',5.21),('8902','2013-08-15','16:50:00',5),('8902','2013-08-15','16:55:00',4.82),('8902','2013-08-15','17:00:00',4.73),('8902','2013-08-15','17:05:00',4.64),('8902','2013-08-15','17:10:00',4.48),('8902','2013-08-15','17:15:00',4.26),('8902','2013-08-15','17:20:00',4.12),('8902','2013-08-15','17:25:00',3.96),('8902','2013-08-15','17:30:00',3.82),('8902','2013-08-15','17:35:00',3.62),('8902','2013-08-15','17:40:00',3.46),('8902','2013-08-15','17:45:00',3.27),('8902','2013-08-15','17:50:00',3.09),('8902','2013-08-15','17:55:00',2.93),('8902','2013-08-15','18:00:00',2.76),('8902','2013-08-15','18:05:00',2.58),('8902','2013-08-15','18:10:00',2.39),('8902','2013-08-15','18:15:00',2.26),('8902','2013-08-15','18:20:00',2.08),('8902','2013-08-15','18:25:00',1.86),('8902','2013-08-15','18:30:00',1.67),('8902','2013-08-15','18:35:00',1.15),('8902','2013-08-14','07:50:00',1.1),('8902','2013-08-14','07:55:00',1.19),('8902','2013-08-14','08:00:00',1.91),('8902','2013-08-14','08:05:00',1.94),('8902','2013-08-14','08:10:00',1.98),('8902','2013-08-14','08:15:00',1.94),('8902','2013-08-14','08:20:00',2.18),('8902','2013-08-14','08:25:00',2.32),('8902','2013-08-14','08:30:00',2.47),('8902','2013-08-14','08:35:00',2.63),('8902','2013-08-14','08:40:00',2.8),('8902','2013-08-14','08:45:00',2.99),('8902','2013-08-14','08:50:00',3.2),('8902','2013-08-14','08:55:00',3.33),('8902','2013-08-14','09:00:00',3.43),('8902','2013-08-14','09:05:00',3.3),('8902','2013-08-14','09:10:00',2.01),('8902','2013-08-14','09:15:00',2.93),('8902','2013-08-14','09:20:00',4.37),('8902','2013-08-14','09:25:00',4.31),('8902','2013-08-14','09:30:00',4.41),('8902','2013-08-14','09:35:00',4.55),('8902','2013-08-14','09:40:00',4.7),('8902','2013-08-14','09:45:00',4.84),('8902','2013-08-14','09:50:00',5),('8902','2013-08-14','09:55:00',5.15),('8902','2013-08-14','10:00:00',5.28),('8902','2013-08-14','10:05:00',5.39),('8902','2013-08-14','10:10:00',5.5),('8902','2013-08-14','10:15:00',5.65),('8902','2013-08-14','10:20:00',5.77),('8902','2013-08-14','10:25:00',5.9),('8902','2013-08-14','10:30:00',6.03),('8902','2013-08-14','10:35:00',6.09),('8902','2013-08-14','10:40:00',6.2),('8902','2013-08-14','10:45:00',6.18),('8902','2013-08-14','10:50:00',6.07),('8902','2013-08-14','10:55:00',6.01),('8902','2013-08-14','11:00:00',5.52),('8902','2013-08-14','11:05:00',4.6),('8902','2013-08-14','11:10:00',4.83),('8902','2013-08-14','11:15:00',5.38),('8902','2013-08-14','11:20:00',5.89),('8902','2013-08-14','11:25:00',6.52),('8902','2013-08-14','11:30:00',6.95),('8902','2013-08-14','11:35:00',7.23),('8902','2013-08-14','11:40:00',7.43),('8902','2013-08-14','11:45:00',7.7),('8902','2013-08-14','11:50:00',7.79),('8902','2013-08-14','11:55:00',7.73),('8902','2013-08-14','12:00:00',7.8),('8902','2013-08-14','12:05:00',7.77),('8902','2013-08-14','12:10:00',7.69),('8902','2013-08-14','12:15:00',7.73),('8902','2013-08-14','12:20:00',7.73),('8902','2013-08-14','12:25:00',7.74),('8902','2013-08-14','12:30:00',7.69),('8902','2013-08-14','12:35:00',7.76),('8902','2013-08-14','12:40:00',7.73),('8902','2013-08-14','12:45:00',7.78),('8902','2013-08-14','12:50:00',7.65),('8902','2013-08-14','12:55:00',7.42),('8902','2013-08-14','13:00:00',7.6),('8902','2013-08-14','13:05:00',7.36),('8902','2013-08-14','13:10:00',7.35),('8902','2013-08-14','13:15:00',7.2),('8902','2013-08-14','13:20:00',7.57),('8902','2013-08-14','13:25:00',7.74),('8902','2013-08-14','13:30:00',7.77),('8902','2013-08-14','13:35:00',7.77),('8902','2013-08-14','13:40:00',7.68),('8902','2013-08-14','13:45:00',7.61),('8902','2013-08-14','13:50:00',7.55),('8902','2013-08-14','13:55:00',7.62),('8902','2013-08-14','14:00:00',7.67),('8902','2013-08-14','14:05:00',7.6),('8902','2013-08-14','14:10:00',7.53),('8902','2013-08-14','14:15:00',7.57),('8902','2013-08-14','14:20:00',7.47),('8902','2013-08-14','14:25:00',7.19),('8902','2013-08-14','14:30:00',7.19),('8902','2013-08-14','14:35:00',7.35),('8902','2013-08-14','14:40:00',7.23),('8902','2013-08-14','14:45:00',7.15),('8902','2013-08-14','14:50:00',7.13),('8902','2013-08-14','14:55:00',7.12),('8902','2013-08-14','15:00:00',7.03),('8902','2013-08-14','15:05:00',6.92),('8902','2013-08-14','15:10:00',6.85),('8902','2013-08-14','15:15:00',6.76),('8902','2013-08-14','15:20:00',6.69),('8902','2013-08-14','15:25:00',6.57),('8902','2013-08-14','15:30:00',6.54),('8902','2013-08-14','15:35:00',6.53),('8902','2013-08-14','15:40:00',6.41),('8902','2013-08-14','15:45:00',6.27),('8902','2013-08-14','15:50:00',6.17),('8902','2013-08-14','15:55:00',6.18),('8902','2013-08-14','16:00:00',6.03),('8902','2013-08-14','16:05:00',5.9),('8902','2013-08-14','16:10:00',5.76),('8902','2013-08-14','16:15:00',5.7),('8902','2013-08-14','16:20:00',5.66),('8902','2013-08-14','16:25:00',5.44),('8902','2013-08-14','16:30:00',5.11),('8902','2013-08-14','16:35:00',5.07),('8902','2013-08-14','16:40:00',5.1),('8902','2013-08-14','16:45:00',4.94),('8902','2013-08-14','16:50:00',4.79),('8902','2013-08-14','16:55:00',4.56),('8902','2013-08-14','17:00:00',4.54),('8902','2013-08-14','17:05:00',4.39),('8902','2013-08-14','17:10:00',4.23),('8902','2013-08-14','17:15:00',4.19),('8902','2013-08-14','17:20:00',3.99),('8902','2013-08-14','17:25:00',3.77),('8902','2013-08-14','17:30:00',3.72),('8902','2013-08-14','17:35:00',3.5),('8902','2013-08-14','17:40:00',3.38),('8902','2013-08-14','17:45:00',3.21),('8902','2013-08-14','17:50:00',3.02),('8902','2013-08-14','17:55:00',2.85),('8902','2013-08-14','18:00:00',2.71),('8902','2013-08-14','18:05:00',2.54),('8902','2013-08-14','18:10:00',2.31),('8902','2013-08-14','18:15:00',2.18),('8902','2013-08-14','18:20:00',2.04),('8902','2013-08-14','18:25:00',1.83),('8902','2013-08-14','18:30:00',1.65),('8902','2013-08-14','18:35:00',1.56),('8902','2013-08-14','18:40:00',1.44),('8902','2013-08-14','18:45:00',1.17),('8902','2013-08-13','07:50:00',1.11),('8902','2013-08-13','07:55:00',1.33),('8902','2013-08-13','08:00:00',1.47),('8902','2013-08-13','08:05:00',1.6),('8902','2013-08-13','08:10:00',1.76),('8902','2013-08-13','08:15:00',1.92),('8902','2013-08-13','08:20:00',2.04),('8902','2013-08-13','08:25:00',2.19),('8902','2013-08-13','08:30:00',2.38),('8902','2013-08-13','08:35:00',2.55),('8902','2013-08-13','08:40:00',2.8),('8902','2013-08-13','08:45:00',2.91),('8902','2013-08-13','08:50:00',2.74),('8902','2013-08-13','08:55:00',3.24),('8902','2013-08-13','09:00:00',3.41),('8902','2013-08-13','09:05:00',3.61),('8902','2013-08-13','09:10:00',3.8),('8902','2013-08-13','09:15:00',3.94),('8902','2013-08-13','09:20:00',4.16),('8902','2013-08-13','09:25:00',4.02),('8902','2013-08-13','09:30:00',4.49),('8902','2013-08-13','09:35:00',4.53),('8902','2013-08-13','09:40:00',3.64),('8902','2013-08-13','09:45:00',3.23),('8902','2013-08-13','09:50:00',1.84),('8902','2013-08-13','09:55:00',2.68),('8902','2013-08-13','10:00:00',2.27),('8902','2013-08-13','10:05:00',4.2),('8902','2013-08-13','10:10:00',5.2),('8902','2013-08-13','10:15:00',4.3),('8902','2013-08-13','10:20:00',2.46),('8902','2013-08-13','10:25:00',1.98),('8902','2013-08-13','10:30:00',4.71),('8902','2013-08-13','10:35:00',6.51),('8902','2013-08-13','10:40:00',6.67),('8902','2013-08-13','10:45:00',6.42),('8902','2013-08-13','10:50:00',5.31),('8902','2013-08-13','10:55:00',5.64),('8902','2013-08-13','11:00:00',6.28),('8902','2013-08-13','11:05:00',6.86),('8902','2013-08-13','11:10:00',5.58),('8902','2013-08-13','11:15:00',6.6),('8902','2013-08-13','11:20:00',6.14),('8902','2013-08-13','11:25:00',4.51),('8902','2013-08-13','11:30:00',6.86),('8902','2013-08-13','11:35:00',7.08),('8902','2013-08-13','11:40:00',7.1),('8902','2013-08-13','11:45:00',6.64),('8902','2013-08-13','11:50:00',6.89),('8902','2013-08-13','11:55:00',3.67),('8902','2013-08-13','12:00:00',3.08),('8902','2013-08-13','12:05:00',5.04),('8902','2013-08-13','12:10:00',6.95),('8902','2013-08-13','12:15:00',6.21),('8902','2013-08-13','12:20:00',2.22),('8902','2013-08-13','12:25:00',2.19),('8902','2013-08-13','12:30:00',2.11),('8902','2013-08-13','12:35:00',2.52),('8902','2013-08-13','12:40:00',2.39),('8902','2013-08-13','12:45:00',3.46),('8902','2013-08-13','12:50:00',3.21),('8902','2013-08-13','12:55:00',4.28),('8902','2013-08-13','13:00:00',3.29),('8902','2013-08-13','13:05:00',2.08),('8902','2013-08-13','13:10:00',1.95),('8902','2013-08-13','13:15:00',1.63),('8902','2013-08-13','13:20:00',1.57),('8902','2013-08-13','13:25:00',3.26),('8902','2013-08-13','13:30:00',5.61),('8902','2013-08-13','13:35:00',4),('8902','2013-08-13','13:40:00',4.91),('8902','2013-08-13','13:45:00',8.64),('8902','2013-08-13','13:50:00',7.29),('8902','2013-08-13','13:55:00',7.71),('8902','2013-08-13','14:00:00',3.85),('8902','2013-08-13','14:05:00',8.75),('8902','2013-08-13','14:10:00',8.13),('8902','2013-08-13','14:15:00',7.89),('8902','2013-08-13','14:20:00',7.82),('8902','2013-08-13','14:25:00',7.91),('8902','2013-08-13','14:30:00',7.35),('8902','2013-08-13','14:35:00',7.75),('8902','2013-08-13','14:40:00',7.57),('8902','2013-08-13','14:45:00',7.44),('8902','2013-08-13','14:50:00',7.28),('8902','2013-08-13','14:55:00',7.27),('8902','2013-08-13','15:00:00',7.28),('8902','2013-08-13','15:05:00',7.17),('8902','2013-08-13','15:10:00',7.16),('8902','2013-08-13','15:15:00',7.27),('8902','2013-08-13','15:20:00',7.12),('8902','2013-08-13','15:25:00',6.88),('8902','2013-08-13','15:30:00',6.77),('8902','2013-08-13','15:35:00',6.67),('8902','2013-08-13','15:40:00',6.66),('8902','2013-08-13','15:45:00',6.58),('8902','2013-08-13','15:50:00',6.51),('8902','2013-08-13','15:55:00',6.36),('8902','2013-08-13','16:00:00',6.23),('8902','2013-08-13','16:05:00',6.18),('8902','2013-08-13','16:10:00',6.17),('8902','2013-08-13','16:15:00',6.05),('8902','2013-08-13','16:20:00',6.04),('8902','2013-08-13','16:25:00',5.8),('8902','2013-08-13','16:30:00',5.71),('8902','2013-08-13','16:35:00',5.49),('8902','2013-08-13','16:40:00',5.44),('8902','2013-08-13','16:45:00',5.28),('8902','2013-08-13','16:50:00',5.15),('8902','2013-08-13','16:55:00',4.95),('8902','2013-08-13','17:00:00',4.86),('8902','2013-08-13','17:05:00',4.7),('8902','2013-08-13','17:10:00',4.56),('8902','2013-08-13','17:15:00',4.38),('8902','2013-08-13','17:20:00',4.22),('8902','2013-08-13','17:25:00',4.06),('8902','2013-08-13','17:30:00',3.93),('8902','2013-08-13','17:35:00',3.72),('8902','2013-08-13','17:40:00',3.59),('8902','2013-08-13','17:45:00',3.39),('8902','2013-08-13','17:50:00',3.15),('8902','2013-08-13','17:55:00',3.04),('8902','2013-08-13','18:00:00',2.9),('8902','2013-08-13','18:05:00',2.66),('8902','2013-08-13','18:10:00',2.43),('8902','2013-08-13','18:15:00',2.32),('8902','2013-08-13','18:20:00',2.24),('8902','2013-08-13','18:25:00',2.16),('8902','2013-08-13','18:30:00',1.9),('8902','2013-08-13','18:35:00',1.7),('8902','2013-08-13','18:40:00',1.57),('8902','2013-08-13','18:45:00',1.56),('8902','2013-08-13','18:50:00',1.44),('8902','2013-08-13','18:55:00',1.35),('8902','2013-08-13','19:00:00',1.21),('8902','2013-08-12','07:50:00',1.17),('8902','2013-08-12','07:55:00',1.36),('8902','2013-08-12','08:00:00',1.5),('8902','2013-08-12','08:05:00',1.7),('8902','2013-08-12','08:10:00',1.81),('8902','2013-08-12','08:15:00',1.94),('8902','2013-08-12','08:20:00',2.09),('8902','2013-08-12','08:25:00',2.28),('8902','2013-08-12','08:30:00',2.47),('8902','2013-08-12','08:35:00',2.64),('8902','2013-08-12','08:40:00',2.8),('8902','2013-08-12','08:45:00',2.94),('8902','2013-08-12','08:50:00',3.11),('8902','2013-08-12','08:55:00',3.3),('8902','2013-08-12','09:00:00',3.48),('8902','2013-08-12','09:05:00',3.62),('8902','2013-08-12','09:10:00',3.76),('8902','2013-08-12','09:15:00',3.88),('8902','2013-08-12','09:20:00',4.01),('8902','2013-08-12','09:25:00',4.26),('8902','2013-08-12','09:30:00',4.42),('8902','2013-08-12','09:35:00',4.4),('8902','2013-08-12','09:40:00',4.42),('8902','2013-08-12','09:45:00',4.67),('8902','2013-08-12','09:50:00',4.85),('8902','2013-08-12','09:55:00',4.96),('8902','2013-08-12','10:00:00',5.07),('8902','2013-08-12','10:05:00',5.18),('8902','2013-08-12','10:10:00',4.6),('8902','2013-08-12','10:15:00',5.29),('8902','2013-08-12','10:20:00',5.57),('8902','2013-08-12','10:25:00',5.69),('8902','2013-08-12','10:30:00',5.72),('8902','2013-08-12','10:35:00',5.77),('8902','2013-08-12','10:40:00',6.04),('8902','2013-08-12','10:45:00',6.14),('8902','2013-08-12','10:50:00',6.19),('8902','2013-08-12','10:55:00',6.32),('8902','2013-08-12','11:00:00',6.39),('8902','2013-08-12','11:05:00',6.48),('8902','2013-08-12','11:10:00',6.56),('8902','2013-08-12','11:15:00',6.51),('8902','2013-08-12','11:20:00',6.59),('8902','2013-08-12','11:25:00',6.74),('8902','2013-08-12','11:30:00',6.79),('8902','2013-08-12','11:35:00',6.76),('8902','2013-08-12','11:40:00',6.88),('8902','2013-08-12','11:45:00',6.84),('8902','2013-08-12','11:50:00',7.02),('8902','2013-08-12','11:55:00',7.24),('8902','2013-08-12','12:00:00',7.19),('8902','2013-08-12','12:05:00',7.33),('8902','2013-08-12','12:10:00',7.52),('8902','2013-08-12','12:15:00',7.34),('8902','2013-08-12','12:20:00',7.4),('8902','2013-08-12','12:25:00',7.84),('8902','2013-08-12','12:30:00',7.81),('8902','2013-08-12','12:35:00',7.72),('8902','2013-08-12','12:40:00',7.95),('8902','2013-08-12','12:45:00',6.26),('8902','2013-08-12','12:50:00',3),('8902','2013-08-12','12:55:00',6.76),('8902','2013-08-12','13:00:00',6.17),('8902','2013-08-12','13:05:00',2.51),('8902','2013-08-12','13:10:00',2.18),('8902','2013-08-12','13:15:00',4.77),('8902','2013-08-12','13:20:00',8.9),('8902','2013-08-12','13:25:00',8.57),('8902','2013-08-12','13:30:00',8.17),('8902','2013-08-12','13:35:00',8.13),('8902','2013-08-12','13:40:00',6.14),('8902','2013-08-12','13:45:00',2.98),('8902','2013-08-12','13:50:00',4.29),('8902','2013-08-12','13:55:00',7.79),('8902','2013-08-12','14:00:00',7.05),('8902','2013-08-12','14:05:00',4.54),('8902','2013-08-12','14:10:00',8.64),('8902','2013-08-12','14:15:00',8.59),('8902','2013-08-12','14:20:00',7.97),('8902','2013-08-12','14:25:00',4.18),('8902','2013-08-12','14:30:00',3.51),('8902','2013-08-12','14:35:00',8.42),('8902','2013-08-12','14:40:00',3.16),('8902','2013-08-12','14:45:00',2.65),('8902','2013-08-12','14:50:00',7.17),('8902','2013-08-12','14:55:00',8.4),('8902','2013-08-12','15:00:00',7.44),('8902','2013-08-12','15:05:00',6.83),('8902','2013-08-12','15:10:00',6.59),('8902','2013-08-12','15:15:00',5.72),('8902','2013-08-12','15:20:00',7.28),('8902','2013-08-12','15:25:00',7.11),('8902','2013-08-12','15:30:00',6.71),('8902','2013-08-12','15:35:00',6.91),('8902','2013-08-12','15:40:00',6.98),('8902','2013-08-12','15:45:00',6.66),('8902','2013-08-12','15:50:00',6.52),('8902','2013-08-12','15:55:00',6.37),('8902','2013-08-12','16:00:00',6.26),('8902','2013-08-12','16:05:00',6.2),('8902','2013-08-12','16:10:00',6.09),('8902','2013-08-12','16:15:00',6),('8902','2013-08-12','16:20:00',5.9),('8902','2013-08-12','16:25:00',5.76),('8902','2013-08-12','16:30:00',5.64),('8902','2013-08-12','16:35:00',5.48),('8902','2013-08-12','16:40:00',5.38),('8902','2013-08-12','16:45:00',5.25),('8902','2013-08-12','16:50:00',5.08),('8902','2013-08-12','16:55:00',4.93),('8902','2013-08-12','17:00:00',4.83),('8902','2013-08-12','17:05:00',4.71),('8902','2013-08-12','17:10:00',4.58),('8902','2013-08-12','17:15:00',4.39),('8902','2013-08-12','17:20:00',4.24),('8902','2013-08-12','17:25:00',4.11),('8902','2013-08-12','17:30:00',3.95),('8902','2013-08-12','17:35:00',3.73),('8902','2013-08-12','17:40:00',3.58),('8902','2013-08-12','17:45:00',3.41),('8902','2013-08-12','17:50:00',3.2),('8902','2013-08-12','17:55:00',3.04),('8902','2013-08-12','18:00:00',2.88),('8902','2013-08-12','18:05:00',2.68),('8902','2013-08-12','18:10:00',2.5),('8902','2013-08-12','18:15:00',2.34),('8902','2013-08-12','18:20:00',2.18),('8902','2013-08-12','18:25:00',1.98),('8902','2013-08-12','18:30:00',1.8),('8902','2013-08-12','18:35:00',1.63),('8902','2013-08-12','18:40:00',1.47),('8902','2013-08-12','18:45:00',1.31),('8902','2013-08-12','18:50:00',1.14),('8902','2013-08-12','18:55:00',1.02),('8902','2013-08-11','07:50:00',1.18),('8902','2013-08-11','07:55:00',1.35),('8902','2013-08-11','08:00:00',1.49),('8902','2013-08-11','08:05:00',1.64),('8902','2013-08-11','08:10:00',1.8),('8902','2013-08-11','08:15:00',1.96),('8902','2013-08-11','08:20:00',2.11),('8902','2013-08-11','08:25:00',2.28),('8902','2013-08-11','08:30:00',2.44),('8902','2013-08-11','08:35:00',2.6),('8902','2013-08-11','08:40:00',2.76),('8902','2013-08-11','08:45:00',2.91),('8902','2013-08-11','08:50:00',3.07),('8902','2013-08-11','08:55:00',3.24),('8902','2013-08-11','09:00:00',3.39),('8902','2013-08-11','09:05:00',3.54),('8902','2013-08-11','09:10:00',3.7),('8902','2013-08-11','09:15:00',3.86),('8902','2013-08-11','09:20:00',4.02),('8902','2013-08-11','09:25:00',4.17),('8902','2013-08-11','09:30:00',4.29),('8902','2013-08-11','09:35:00',4.42),('8902','2013-08-11','09:40:00',4.56),('8902','2013-08-11','09:45:00',4.69),('8902','2013-08-11','09:50:00',4.81),('8902','2013-08-11','09:55:00',4.94),('8902','2013-08-11','10:00:00',5.07),('8902','2013-08-11','10:05:00',5.17),('8902','2013-08-11','10:10:00',5.28),('8902','2013-08-11','10:15:00',5.41),('8902','2013-08-11','10:20:00',5.52),('8902','2013-08-11','10:25:00',5.62),('8902','2013-08-11','10:30:00',5.74),('8902','2013-08-11','10:35:00',5.87),('8902','2013-08-11','10:40:00',5.96),('8902','2013-08-11','10:45:00',6.05),('8902','2013-08-11','10:50:00',6.1),('8902','2013-08-11','10:55:00',6.19),('8902','2013-08-11','11:00:00',6.24),('8902','2013-08-11','11:05:00',6.31),('8902','2013-08-11','11:10:00',6.39),('8902','2013-08-11','11:15:00',6.54),('8902','2013-08-11','11:20:00',6.48),('8902','2013-08-11','11:25:00',6.51),('8902','2013-08-11','11:30:00',6.5),('8902','2013-08-11','11:35:00',6.75),('8902','2013-08-11','11:40:00',6.92),('8902','2013-08-11','11:45:00',6.94),('8902','2013-08-11','11:50:00',7.06),('8902','2013-08-11','11:55:00',6.99),('8902','2013-08-11','12:00:00',7.32),('8902','2013-08-11','12:05:00',7.38),('8902','2013-08-11','12:10:00',7.47),('8902','2013-08-11','12:15:00',7.09),('8902','2013-08-11','12:20:00',6.28),('8902','2013-08-11','12:25:00',4.44),('8902','2013-08-11','12:30:00',1.66),('8902','2013-08-11','12:35:00',1.71),('8902','2013-08-11','12:40:00',2.1),('8902','2013-08-11','12:45:00',2.96),('8902','2013-08-11','12:50:00',5.46),('8902','2013-08-11','12:55:00',3.95),('8902','2013-08-11','13:00:00',2.53),('8902','2013-08-11','13:05:00',1.74),('8902','2013-08-11','13:10:00',1.4),('8902','2013-08-11','13:15:00',1.4),('8902','2013-08-11','13:20:00',1.69),('8902','2013-08-11','13:25:00',2.75),('8902','2013-08-11','13:30:00',2.29),('8902','2013-08-11','13:35:00',2.48),('8902','2013-08-11','13:40:00',2.05),('8902','2013-08-11','13:45:00',1.84),('8902','2013-08-11','13:50:00',5.36),('8902','2013-08-11','13:55:00',4.94),('8902','2013-08-11','14:00:00',2.43),('8902','2013-08-11','14:05:00',1.7),('8902','2013-08-11','14:10:00',4.12),('8902','2013-08-11','14:15:00',3.43),('8902','2013-08-11','14:20:00',2.14),('8902','2013-08-11','14:25:00',1.64),('8902','2013-08-11','14:30:00',1.61),('8902','2013-08-11','14:35:00',2.04),('8902','2013-08-11','14:40:00',2.61),('8902','2013-08-11','14:45:00',2.65),('8902','2013-08-11','14:50:00',4.33),('8902','2013-08-11','14:55:00',8.51),('8902','2013-08-11','15:00:00',8.1),('8902','2013-08-11','15:05:00',7.78),('8902','2013-08-11','15:10:00',7.56),('8902','2013-08-11','15:15:00',7.32),('8902','2013-08-11','15:20:00',7.03),('8902','2013-08-11','15:25:00',7.17),('8902','2013-08-11','15:30:00',6.94),('8902','2013-08-11','15:35:00',6.76),('8902','2013-08-11','15:40:00',6.76),('8902','2013-08-11','15:45:00',6.56),('8902','2013-08-11','15:50:00',6.57),('8902','2013-08-11','15:55:00',6.48),('8902','2013-08-11','16:00:00',6.33),('8902','2013-08-11','16:05:00',6.24),('8902','2013-08-11','16:10:00',6.16),('8902','2013-08-11','16:15:00',6.03),('8902','2013-08-11','16:20:00',5.81),('8902','2013-08-11','16:25:00',5.7),('8902','2013-08-11','16:30:00',5.6),('8902','2013-08-11','16:35:00',5.4),('8902','2013-08-11','16:40:00',5.34),('8902','2013-08-11','16:45:00',5.16),('8902','2013-08-11','16:50:00',5.07),('8902','2013-08-11','16:55:00',4.67),('8902','2013-08-11','17:00:00',4.71),('8902','2013-08-11','17:05:00',4.63),('8902','2013-08-11','17:10:00',4.49),('8902','2013-08-11','17:15:00',4.29),('8902','2013-08-11','17:20:00',4.1),('8902','2013-08-11','17:25:00',3.99),('8902','2013-08-11','17:30:00',3.89),('8902','2013-08-11','17:35:00',3.69),('8902','2013-08-11','17:40:00',3.56),('8902','2013-08-11','17:45:00',3.35),('8902','2013-08-11','17:50:00',3.14),('8902','2013-08-11','17:55:00',2.98),('8902','2013-08-11','18:00:00',2.85),('8902','2013-08-11','18:05:00',2.68),('8902','2013-08-11','18:10:00',2.5),('8902','2013-08-11','18:15:00',2.33),('8902','2013-08-11','18:20:00',2.19),('8902','2013-08-11','18:25:00',2.05),('8902','2013-08-11','18:30:00',1.82),('8902','2013-08-11','18:35:00',1.7),('8902','2013-08-11','18:40:00',1.54),('8902','2013-08-11','18:45:00',1.41),('8902','2013-08-11','18:50:00',1.23),('8902','2013-08-11','18:55:00',1.11),('8902','2013-08-10','07:50:00',1.22),('8902','2013-08-10','07:55:00',1.4),('8902','2013-08-10','08:00:00',1.55),('8902','2013-08-10','08:05:00',1.7),('8902','2013-08-10','08:10:00',1.85),('8902','2013-08-10','08:15:00',2.02),('8902','2013-08-10','08:20:00',2.19),('8902','2013-08-10','08:25:00',2.33),('8902','2013-08-10','08:30:00',2.5),('8902','2013-08-10','08:35:00',2.65),('8902','2013-08-10','08:40:00',2.82),('8902','2013-08-10','08:45:00',3),('8902','2013-08-10','08:50:00',3.16),('8902','2013-08-10','08:55:00',3.31),('8902','2013-08-10','09:00:00',3.49),('8902','2013-08-10','09:05:00',3.64),('8902','2013-08-10','09:10:00',3.78),('8902','2013-08-10','09:15:00',3.93),('8902','2013-08-10','09:20:00',4.09),('8902','2013-08-10','09:25:00',4.25),('8902','2013-08-10','09:30:00',4.4),('8902','2013-08-10','09:35:00',4.54),('8902','2013-08-10','09:40:00',4.69),('8902','2013-08-10','09:45:00',4.83),('8902','2013-08-10','09:50:00',4.96),('8902','2013-08-10','09:55:00',5.1),('8902','2013-08-10','10:00:00',5.23),('8902','2013-08-10','10:05:00',5.37),('8902','2013-08-10','10:10:00',5.51),('8902','2013-08-10','10:15:00',5.66),('8902','2013-08-10','10:20:00',5.76),('8902','2013-08-10','10:25:00',5.86),('8902','2013-08-10','10:30:00',5.99),('8902','2013-08-10','10:35:00',6.06),('8902','2013-08-10','10:40:00',6.16),('8902','2013-08-10','10:45:00',6.25),('8902','2013-08-10','10:50:00',6.34),('8902','2013-08-10','10:55:00',6.41),('8902','2013-08-10','11:00:00',6.5),('8902','2013-08-10','11:05:00',6.59),('8902','2013-08-10','11:10:00',6.71),('8902','2013-08-10','11:15:00',6.74),('8902','2013-08-10','11:20:00',6.85),('8902','2013-08-10','11:25:00',6.92),('8902','2013-08-10','11:30:00',6.95),('8902','2013-08-10','11:35:00',7.02),('8902','2013-08-10','11:40:00',7.09),('8902','2013-08-10','11:45:00',7.11),('8902','2013-08-10','11:50:00',7.21),('8902','2013-08-10','11:55:00',7.22),('8902','2013-08-10','12:00:00',7.25),('8902','2013-08-10','12:05:00',7.32),('8902','2013-08-10','12:10:00',7.37),('8902','2013-08-10','12:15:00',7.35),('8902','2013-08-10','12:20:00',7.34),('8902','2013-08-10','12:25:00',7.43),('8902','2013-08-10','12:30:00',7.46),('8902','2013-08-10','12:35:00',7.51),('8902','2013-08-10','12:40:00',7.48),('8902','2013-08-10','12:45:00',7.45),('8902','2013-08-10','12:50:00',7.49),('8902','2013-08-10','12:55:00',7.57),('8902','2013-08-10','13:00:00',7.62),('8902','2013-08-10','13:05:00',7.57),('8902','2013-08-10','13:10:00',7.55),('8902','2013-08-10','13:15:00',7.6),('8902','2013-08-10','13:20:00',7.58),('8902','2013-08-10','13:25:00',7.66),('8902','2013-08-10','13:30:00',7.67),('8902','2013-08-10','13:35:00',7.58),('8902','2013-08-10','13:40:00',7.53),('8902','2013-08-10','13:45:00',7.55),('8902','2013-08-10','13:50:00',7.53),('8902','2013-08-10','13:55:00',7.52),('8902','2013-08-10','14:00:00',7.52),('8902','2013-08-10','14:05:00',7.51),('8902','2013-08-10','14:10:00',7.49),('8902','2013-08-10','14:15:00',7.27),('8902','2013-08-10','14:20:00',7.23),('8902','2013-08-10','14:25:00',7.23),('8902','2013-08-10','14:30:00',7.25),('8902','2013-08-10','14:35:00',7.27),('8902','2013-08-10','14:40:00',7.3),('8902','2013-08-10','14:45:00',7.23),('8902','2013-08-10','14:50:00',7.08),('8902','2013-08-10','14:55:00',7),('8902','2013-08-10','15:00:00',7.14),('8902','2013-08-10','15:05:00',7.07),('8902','2013-08-10','15:10:00',6.97),('8902','2013-08-10','15:15:00',6.81),('8902','2013-08-10','15:20:00',6.79),('8902','2013-08-10','15:25:00',6.73),('8902','2013-08-10','15:30:00',6.67),('8902','2013-08-10','15:35:00',6.47),('8902','2013-08-10','15:40:00',6.51),('8902','2013-08-10','15:45:00',6.4),('8902','2013-08-10','15:50:00',6.4),('8902','2013-08-10','15:55:00',6.33),('8902','2013-08-10','16:00:00',6.23),('8902','2013-08-10','16:05:00',6.13),('8902','2013-08-10','16:10:00',6.01),('8902','2013-08-10','16:15:00',5.9),('8902','2013-08-10','16:20:00',5.78),('8902','2013-08-10','16:25:00',5.65),('8902','2013-08-10','16:30:00',5.55),('8902','2013-08-10','16:35:00',5.37),('8902','2013-08-10','16:40:00',5.23),('8902','2013-08-10','16:45:00',5.15),('8902','2013-08-10','16:50:00',4.99),('8902','2013-08-10','16:55:00',4.77),('8902','2013-08-10','17:00:00',4.74),('8902','2013-08-10','17:05:00',4.61),('8902','2013-08-10','17:10:00',4.46),('8902','2013-08-10','17:15:00',4.3),('8902','2013-08-10','17:20:00',4.14),('8902','2013-08-10','17:25:00',4.01),('8902','2013-08-10','17:30:00',3.88),('8902','2013-08-10','17:35:00',3.71),('8902','2013-08-10','17:40:00',3.54),('8902','2013-08-10','17:45:00',3.38),('8902','2013-08-10','17:50:00',3.15),('8902','2013-08-10','17:55:00',3),('8902','2013-08-10','18:00:00',2.84),('8902','2013-08-10','18:05:00',2.67),('8902','2013-08-10','18:10:00',2.44),('8902','2013-08-10','18:15:00',2.22),('8902','2013-08-10','18:20:00',2.15),('8902','2013-08-10','18:25:00',2),('8902','2013-08-10','18:30:00',1.82),('8902','2013-08-10','18:35:00',1.64),('8902','2013-08-10','18:40:00',1.49),('8902','2013-08-10','18:45:00',1.33),('8902','2013-08-10','18:50:00',1.15),('8902','2013-08-10','18:55:00',1.03),('8902','2013-08-09','07:50:00',1.2),('8902','2013-08-09','07:55:00',1.37),('8902','2013-08-09','08:00:00',1.53),('8902','2013-08-09','08:05:00',1.69),('8902','2013-08-09','08:10:00',1.84),('8902','2013-08-09','08:15:00',2.03),('8902','2013-08-09','08:20:00',2.21),('8902','2013-08-09','08:25:00',2.39),('8902','2013-08-09','08:30:00',2.56),('8902','2013-08-09','08:35:00',2.73),('8902','2013-08-09','08:40:00',2.89),('8902','2013-08-09','08:45:00',3.05),('8902','2013-08-09','08:50:00',3.22),('8902','2013-08-09','08:55:00',3.38),('8902','2013-08-09','09:00:00',3.54),('8902','2013-08-09','09:05:00',3.69),('8902','2013-08-09','09:10:00',3.85),('8902','2013-08-09','09:15:00',4.03),('8902','2013-08-09','09:20:00',4.17),('8902','2013-08-09','09:25:00',4.34),('8902','2013-08-09','09:30:00',3.76),('8902','2013-08-09','09:35:00',4.61),('8902','2013-08-09','09:40:00',4.75),('8902','2013-08-09','09:45:00',4.89),('8902','2013-08-09','09:50:00',4.33),('8902','2013-08-09','09:55:00',5.1),('8902','2013-08-09','10:00:00',5.23),('8902','2013-08-09','10:05:00',5.35),('8902','2013-08-09','10:10:00',5.47),('8902','2013-08-09','10:15:00',5.6),('8902','2013-08-09','10:20:00',5.72),('8902','2013-08-09','10:25:00',5.82),('8902','2013-08-09','10:30:00',5.91),('8902','2013-08-09','10:35:00',6.02),('8902','2013-08-09','10:40:00',6.13),('8902','2013-08-09','10:45:00',6.21),('8902','2013-08-09','10:50:00',6.31),('8902','2013-08-09','10:55:00',6.43),('8902','2013-08-09','11:00:00',6.6),('8902','2013-08-09','11:05:00',6.67),('8902','2013-08-09','11:10:00',6.84),('8902','2013-08-09','11:15:00',4.12),('8902','2013-08-09','11:20:00',6.03),('8902','2013-08-09','11:25:00',3.81),('8902','2013-08-09','11:30:00',5.65),('8902','2013-08-09','11:35:00',7.25),('8902','2013-08-09','11:40:00',7.17),('8902','2013-08-09','11:45:00',7.17),('8902','2013-08-09','11:50:00',7.22),('8902','2013-08-09','11:55:00',7.23),('8902','2013-08-09','12:00:00',7.31),('8902','2013-08-09','12:05:00',7.31),('8902','2013-08-09','12:10:00',7.36),('8902','2013-08-09','12:15:00',7.36),('8902','2013-08-09','12:20:00',7.43),('8902','2013-08-09','12:25:00',7.54),('8902','2013-08-09','12:30:00',7.54),('8902','2013-08-09','12:35:00',7.57),('8902','2013-08-09','12:40:00',7.64),('8902','2013-08-09','12:45:00',7.74),('8902','2013-08-09','12:50:00',7.88),('8902','2013-08-09','12:55:00',7.86),('8902','2013-08-09','13:00:00',7.82),('8902','2013-08-09','13:05:00',7.77),('8902','2013-08-09','13:10:00',7.85),('8902','2013-08-09','13:15:00',7.96),('8902','2013-08-09','13:20:00',8.05),('8902','2013-08-09','13:25:00',8.04),('8902','2013-08-09','13:30:00',7.56),('8902','2013-08-09','13:35:00',7.67),('8902','2013-08-09','13:40:00',2.12),('8902','2013-08-09','13:45:00',1.69),('8902','2013-08-09','13:50:00',8.45),('8902','2013-08-09','13:55:00',8.15),('8902','2013-08-09','14:00:00',6.29),('8902','2013-08-09','14:05:00',4.8),('8902','2013-08-09','14:10:00',8.92),('8902','2013-08-09','14:15:00',7.8),('8902','2013-08-09','14:20:00',3.69),('8902','2013-08-09','14:25:00',2.43),('8902','2013-08-09','14:30:00',2.49),('8902','2013-08-09','14:35:00',2.16),('8902','2013-08-09','14:40:00',1.99),('8902','2013-08-09','14:45:00',1.85),('8902','2013-08-09','14:50:00',1.7),('8902','2013-08-09','14:55:00',1.62),('8902','2013-08-09','15:00:00',1.8),('8902','2013-08-09','15:05:00',1.99),('8902','2013-08-09','15:10:00',2.12),('8902','2013-08-09','15:15:00',2.45),('8902','2013-08-09','15:20:00',2.49),('8902','2013-08-09','15:25:00',2.25),('8902','2013-08-09','15:30:00',2.15),('8902','2013-08-09','15:35:00',2.65),('8902','2013-08-09','15:40:00',2.57),('8902','2013-08-09','15:45:00',2.7),('8902','2013-08-09','15:50:00',3.16),('8902','2013-08-09','15:55:00',3.75),('8902','2013-08-09','16:00:00',3.7),('8902','2013-08-09','16:05:00',6.98),('8902','2013-08-09','16:10:00',3.81),('8902','2013-08-09','16:15:00',3.69),('8902','2013-08-09','16:20:00',4.53),('8902','2013-08-09','16:25:00',2.67),('8902','2013-08-09','16:30:00',3.71),('8902','2013-08-09','16:35:00',6.54),('8902','2013-08-09','16:40:00',5.95),('8902','2013-08-09','16:45:00',5.83),('8902','2013-08-09','16:50:00',5.51),('8902','2013-08-09','16:55:00',5.04),('8902','2013-08-09','17:00:00',4.87),('8902','2013-08-09','17:05:00',3.48),('8902','2013-08-09','17:10:00',1.74),('8902','2013-08-09','17:15:00',2.23),('8902','2013-08-09','17:20:00',1.95),('8902','2013-08-09','17:25:00',2.17),('8902','2013-08-09','17:30:00',1.31),('8902','2013-08-09','17:45:00',1.01),('8902','2013-08-09','17:50:00',1.64),('8902','2013-08-09','17:55:00',2.22),('8902','2013-08-09','18:00:00',1.46),('8902','2014-04-08','08:00:00',1.32),('8902','2014-04-08','08:05:00',1.67),('8902','2014-04-08','08:10:00',1.66),('8902','2014-04-08','08:15:00',1.33),('8902','2014-04-08','08:20:00',1.92),('8902','2014-04-08','08:25:00',1.44),('8902','2014-04-08','08:30:00',1.43),('8902','2014-04-08','08:35:00',1.02),('8902','2014-04-08','08:55:00',1.41),('8902','2014-04-08','09:00:00',1.62),('8902','2014-04-08','09:05:00',1.6),('8902','2014-04-08','09:10:00',1.53),('8902','2014-04-08','09:15:00',1.5),('8902','2014-04-08','09:20:00',1.55),('8902','2014-04-08','09:25:00',1.73),('8902','2014-04-08','09:30:00',1.87),('8902','2014-04-08','09:35:00',1.71),('8902','2014-04-08','09:40:00',1.74),('8902','2014-04-08','09:45:00',2.06),('8902','2014-04-08','09:50:00',3.01),('8902','2014-04-08','09:55:00',5.39),('8902','2014-04-08','10:00:00',5.38),('8902','2014-04-08','10:05:00',5.45),('8902','2014-04-08','10:10:00',5.66),('8902','2014-04-08','10:15:00',5.94),('8902','2014-04-08','10:20:00',6.02),('8902','2014-04-08','10:25:00',6.33),('8902','2014-04-08','10:30:00',6.6),('8902','2014-04-08','10:35:00',7.23),('8902','2014-04-08','10:40:00',4.3),('8902','2014-04-08','10:45:00',2.63),('8902','2014-04-08','10:50:00',1.91),('8902','2014-04-08','10:55:00',2.54),('8902','2014-04-08','11:00:00',6.93),('8902','2014-04-08','11:05:00',7.74),('8902','2014-04-08','11:10:00',7.83),('8902','2014-04-08','11:15:00',8.16),('8902','2014-04-08','11:20:00',7.65),('8902','2014-04-08','11:25:00',3.75),('8902','2014-04-08','11:30:00',2.15),('8902','2014-04-08','11:35:00',2.74),('8902','2014-04-08','11:40:00',6.47),('8902','2014-04-08','11:45:00',9),('8902','2014-04-08','11:50:00',8.64),('8902','2014-04-08','11:55:00',8.92),('8902','2014-04-08','12:00:00',8.89),('8902','2014-04-08','12:05:00',8.56),('8902','2014-04-08','12:10:00',3.61),('8902','2014-04-08','12:15:00',3.67),('8902','2014-04-08','12:20:00',2.96),('8902','2014-04-08','12:25:00',1.97),('8902','2014-04-08','12:30:00',1.55),('8902','2014-04-08','12:35:00',1.37),('8902','2014-04-08','12:40:00',1.26),('8902','2014-04-08','12:45:00',1.09),('8902','2014-04-08','12:50:00',1.04),('8902','2014-04-08','12:55:00',1.22),('8902','2014-04-08','13:00:00',1.2),('8902','2014-04-08','13:05:00',1.18),('8902','2014-04-08','13:10:00',1.28),('8902','2014-04-08','13:15:00',1.57),('8902','2014-04-08','13:20:00',2.33),('8902','2014-04-08','13:25:00',3.01),('8902','2014-04-08','13:30:00',2.63),('8902','2014-04-08','13:35:00',2.41),('8902','2014-04-08','13:40:00',2.32),('8902','2014-04-08','13:45:00',2.18),('8902','2014-04-08','13:50:00',1.84),('8902','2014-04-08','13:55:00',1.47),('8902','2014-04-08','14:00:00',1.64),('8902','2014-04-08','14:05:00',2.44),('8902','2014-04-08','14:10:00',5.45),('8902','2014-04-08','14:15:00',3.32),('8902','2014-04-08','14:20:00',4.96),('8902','2014-04-08','14:25:00',3.18),('8902','2014-04-08','14:30:00',3.87),('8902','2014-04-08','14:35:00',8.36),('8902','2014-04-08','14:40:00',5.22),('8902','2014-04-08','14:45:00',3.29),('8902','2014-04-08','14:50:00',3.83),('8902','2014-04-08','14:55:00',4.73),('8902','2014-04-08','15:00:00',4.37),('8902','2014-04-08','15:05:00',8.03),('8902','2014-04-08','15:10:00',7.37),('8902','2014-04-08','15:15:00',7.02),('8902','2014-04-08','15:20:00',6.38),('8902','2014-04-08','15:25:00',4.74),('8902','2014-04-08','15:30:00',7.49),('8902','2014-04-08','15:35:00',5.05),('8902','2014-04-08','15:40:00',3.11),('8902','2014-04-08','15:45:00',4.28),('8902','2014-04-08','15:50:00',4.61),('8902','2014-04-08','15:55:00',2.72),('8902','2014-04-08','16:00:00',3.01),('8902','2014-04-08','16:05:00',3.82),('8902','2014-04-08','16:10:00',3.57),('8902','2014-04-08','16:15:00',6.45),('8902','2014-04-08','16:20:00',6.51),('8902','2014-04-08','16:25:00',6.08),('8902','2014-04-08','16:30:00',5.17),('8902','2014-04-08','16:35:00',3.41),('8902','2014-04-08','16:40:00',2.65),('8902','2014-04-08','16:45:00',3.2),('8902','2014-04-08','16:50:00',4.47),('8902','2014-04-08','16:55:00',3.33),('8902','2014-04-08','17:00:00',3.49),('8902','2014-04-08','17:05:00',5.04),('8902','2014-04-08','17:10:00',4.81),('8902','2014-04-08','17:15:00',4.17),('8902','2014-04-08','17:20:00',4.16),('8902','2014-04-08','17:25:00',4.22),('8902','2014-04-08','17:30:00',2.68),('8902','2014-04-08','17:35:00',1.27),('8902','2014-04-08','17:40:00',1.38),('8902','2014-04-08','17:45:00',2.11),('8902','2014-04-08','17:50:00',2.16),('8902','2014-04-08','17:55:00',2.26),('8902','2014-04-08','18:00:00',1.93),('8902','2014-04-08','18:05:00',1.35),('8902','2014-04-08','18:10:00',1.27),('8902','2014-04-08','18:15:00',1.1),('8902','2013-08-08','07:40:00',1.01),('8902','2013-08-08','08:00:00',1.24),('8902','2013-08-08','08:05:00',1.98),('8902','2013-08-08','08:10:00',1.63),('8902','2013-08-08','08:15:00',1.51),('8902','2013-08-08','08:20:00',1.42),('8902','2013-08-08','08:25:00',1.35),('8902','2013-08-08','08:30:00',1.63),('8902','2013-08-08','08:35:00',1.84),('8902','2013-08-08','08:40:00',2.21),('8902','2013-08-08','08:45:00',2.69),('8902','2013-08-08','08:50:00',2.95),('8902','2013-08-08','08:55:00',2.65),('8902','2013-08-08','09:00:00',3.03),('8902','2013-08-08','09:05:00',3.48),('8902','2013-08-08','09:10:00',3.84),('8902','2013-08-08','09:15:00',3.44),('8902','2013-08-08','09:20:00',3.22),('8902','2013-08-08','09:25:00',2.52),('8902','2013-08-08','09:30:00',4.34),('8902','2013-08-08','09:35:00',4.51),('8902','2013-08-08','09:40:00',3.13),('8902','2013-08-08','09:45:00',3.98),('8902','2013-08-08','09:50:00',4.69),('8902','2013-08-08','09:55:00',3.63),('8902','2013-08-08','10:00:00',3.76),('8902','2013-08-08','10:05:00',4.05),('8902','2013-08-08','10:10:00',4.82),('8902','2013-08-08','10:15:00',4.91),('8902','2013-08-08','10:20:00',5),('8902','2013-08-08','10:25:00',4.52),('8902','2013-08-08','10:30:00',5.04),('8902','2013-08-08','10:35:00',5.53),('8902','2013-08-08','10:40:00',5.64),('8902','2013-08-08','10:45:00',5.51),('8902','2013-08-08','10:50:00',5.64),('8902','2013-08-08','10:55:00',5.84),('8902','2013-08-08','11:00:00',5.93),('8902','2013-08-08','11:05:00',5.99),('8902','2013-08-08','11:10:00',6.09),('8902','2013-08-08','11:15:00',6.17),('8902','2013-08-08','11:20:00',6.2),('8902','2013-08-08','11:25:00',6.26),('8902','2013-08-08','11:30:00',6.41),('8902','2013-08-08','11:35:00',6.44),('8902','2013-08-08','11:40:00',6.42),('8902','2013-08-08','11:45:00',6.48),('8902','2013-08-08','11:50:00',6.55),('8902','2013-08-08','11:55:00',6.67),('8902','2013-08-08','12:00:00',6.67),('8902','2013-08-08','12:05:00',6.64),('8902','2013-08-08','12:10:00',6.74),('8902','2013-08-08','12:15:00',6.86),('8902','2013-08-08','12:20:00',7.11),('8902','2013-08-08','12:25:00',6.86),('8902','2013-08-08','12:30:00',4.7),('8902','2013-08-08','12:35:00',6.34),('8902','2013-08-08','12:40:00',7.27),('8902','2013-08-08','12:45:00',5.41),('8902','2013-08-08','12:50:00',4.85),('8902','2013-08-08','12:55:00',5.44),('8902','2013-08-08','13:00:00',2.62),('8902','2013-08-08','13:05:00',1.72),('8902','2013-08-08','13:10:00',1.61),('8902','2013-08-08','13:15:00',1.88),('8902','2013-08-08','13:20:00',2.6),('8902','2013-08-08','13:25:00',4.29),('8902','2013-08-08','13:30:00',3.51),('8902','2013-08-08','13:35:00',2.9),('8902','2013-08-08','13:40:00',2.88),('8902','2013-08-08','13:45:00',2.69),('8902','2013-08-08','13:50:00',2.78),('8902','2013-08-08','13:55:00',2.42),('8902','2013-08-08','14:00:00',2.23),('8902','2013-08-08','14:05:00',2.66),('8902','2013-08-08','14:10:00',2.64),('8902','2013-08-08','14:15:00',1.85),('8902','2013-08-08','14:20:00',1.73),('8902','2013-08-08','14:25:00',2.08),('8902','2013-08-08','14:30:00',2.03),('8902','2013-08-08','14:35:00',1.53),('8902','2013-08-08','14:40:00',1.09),('8902','2013-08-08','15:00:00',1.04),('8902','2013-08-08','15:05:00',2.82),('8902','2013-08-08','15:10:00',5.5),('8902','2013-08-08','15:15:00',4.87),('8902','2013-08-08','15:20:00',2.98),('8902','2013-08-08','15:25:00',2.38),('8902','2013-08-08','15:30:00',2.21),('8902','2013-08-08','15:35:00',4.15),('8902','2013-08-08','15:40:00',2.99),('8902','2013-08-08','15:45:00',6.46),('8902','2013-08-08','15:50:00',4.32),('8902','2013-08-08','15:55:00',4.52),('8902','2013-08-08','16:00:00',2.27),('8902','2013-08-08','16:05:00',1.41),('8902','2013-08-08','16:10:00',1.23),('8902','2013-08-08','16:15:00',1.42),('8902','2013-08-08','16:20:00',1.43),('8902','2013-08-08','16:25:00',1.57),('8902','2013-08-08','16:30:00',1.12),('8902','2013-08-08','16:35:00',1.16),('8902','2013-08-08','16:40:00',1.28),('8902','2013-08-08','16:45:00',1.61),('8902','2013-08-08','16:50:00',2.39),('8902','2013-08-08','16:55:00',3.71),('8902','2013-08-08','17:00:00',3),('8902','2013-08-08','17:05:00',3.73),('8902','2013-08-08','17:10:00',1.94),('8902','2013-08-08','17:15:00',1.41),('8902','2013-08-08','17:20:00',1.24),('8902','2013-08-08','17:25:00',1.4),('8902','2013-08-08','17:30:00',1.66),('8902','2013-08-08','17:35:00',1.67),('8902','2013-08-08','17:40:00',1.58),('8902','2013-08-08','17:45:00',1.5),('8902','2013-08-08','17:50:00',1.13),('8902','2013-08-08','19:00:00',1.04),('8902','2013-08-08','19:05:00',1.5),('8902','2013-08-08','19:10:00',1.58),('8902','2013-08-08','19:15:00',1.68),('8902','2013-08-08','19:20:00',1.98),('8902','2013-08-08','19:25:00',1.81),('8902','2013-08-07','07:50:00',1.15),('8902','2013-08-07','07:55:00',1.28),('8902','2013-08-07','08:00:00',1.42),('8902','2013-08-07','08:05:00',1.55),('8902','2013-08-07','08:10:00',1.7),('8902','2013-08-07','08:15:00',1.83),('8902','2013-08-07','08:20:00',1.96),('8902','2013-08-07','08:25:00',2.12),('8902','2013-08-07','08:30:00',2.28),('8902','2013-08-07','08:35:00',2.43),('8902','2013-08-07','08:40:00',2.57),('8902','2013-08-07','08:45:00',2.69),('8902','2013-08-07','08:50:00',2.82),('8902','2013-08-07','08:55:00',2.98),('8902','2013-08-07','09:00:00',3.13),('8902','2013-08-07','09:05:00',3.29),('8902','2013-08-07','09:10:00',3.42),('8902','2013-08-07','09:15:00',3.56),('8902','2013-08-07','09:20:00',3.76),('8902','2013-08-07','09:25:00',3.92),('8902','2013-08-07','09:30:00',4.05),('8902','2013-08-07','09:35:00',4.19),('8902','2013-08-07','09:40:00',4.3),('8902','2013-08-07','09:45:00',4.45),('8902','2013-08-07','09:50:00',4.6),('8902','2013-08-07','09:55:00',4.71),('8902','2013-08-07','10:00:00',4.81),('8902','2013-08-07','10:05:00',4.93),('8902','2013-08-07','10:10:00',5.03),('8902','2013-08-07','10:15:00',5.14),('8902','2013-08-07','10:20:00',5.22),('8902','2013-08-07','10:25:00',5.32),('8902','2013-08-07','10:30:00',5.44),('8902','2013-08-07','10:35:00',5.54),('8902','2013-08-07','10:40:00',5.63),('8902','2013-08-07','10:45:00',5.71),('8902','2013-08-07','10:50:00',5.78),('8902','2013-08-07','10:55:00',5.87),('8902','2013-08-07','11:00:00',5.96),('8902','2013-08-07','11:05:00',6.03),('8902','2013-08-07','11:10:00',6.09),('8902','2013-08-07','11:15:00',6.18),('8902','2013-08-07','11:20:00',6.24),('8902','2013-08-07','11:25:00',6.24),('8902','2013-08-07','11:30:00',6.32),('8902','2013-08-07','11:35:00',6.34),('8902','2013-08-07','11:40:00',6.41),('8902','2013-08-07','11:45:00',6.51),('8902','2013-08-07','11:50:00',6.53),('8902','2013-08-07','11:55:00',6.55),('8902','2013-08-07','12:00:00',6.64),('8902','2013-08-07','12:05:00',6.65),('8902','2013-08-07','12:10:00',6.69),('8902','2013-08-07','12:15:00',6.7),('8902','2013-08-07','12:20:00',6.8),('8902','2013-08-07','12:25:00',6.84),('8902','2013-08-07','12:30:00',6.88),('8902','2013-08-07','12:35:00',6.8),('8902','2013-08-07','12:40:00',6.93),('8902','2013-08-07','12:45:00',6.98),('8902','2013-08-07','12:50:00',7.07),('8902','2013-08-07','12:55:00',7.1),('8902','2013-08-07','13:00:00',7.08),('8902','2013-08-07','13:05:00',6.94),('8902','2013-08-07','13:10:00',7.09),('8902','2013-08-07','13:15:00',7.14),('8902','2013-08-07','13:20:00',7.08),('8902','2013-08-07','13:25:00',7.18),('8902','2013-08-07','13:30:00',7.19),('8902','2013-08-07','13:35:00',7.1),('8902','2013-08-07','13:40:00',7.07),('8902','2013-08-07','13:45:00',7.13),('8902','2013-08-07','13:50:00',7.13),('8902','2013-08-07','13:55:00',7.05),('8902','2013-08-07','14:00:00',7.06),('8902','2013-08-07','14:05:00',7.09),('8902','2013-08-07','14:10:00',7.06),('8902','2013-08-07','14:15:00',7.03),('8902','2013-08-07','14:20:00',6.88),('8902','2013-08-07','14:25:00',6.86),('8902','2013-08-07','14:30:00',6.87),('8902','2013-08-07','14:35:00',6.82),('8902','2013-08-07','14:40:00',6.76),('8902','2013-08-07','14:45:00',6.72),('8902','2013-08-07','14:50:00',6.7),('8902','2013-08-07','14:55:00',6.56),('8902','2013-08-07','15:00:00',6.51),('8902','2013-08-07','15:05:00',6.47),('8902','2013-08-07','15:10:00',6.4),('8902','2013-08-07','15:15:00',6.3),('8902','2013-08-07','15:20:00',6.3),('8902','2013-08-07','15:25:00',6.23),('8902','2013-08-07','15:30:00',6.15),('8902','2013-08-07','15:35:00',6.08),('8902','2013-08-07','15:40:00',6.04),('8902','2013-08-07','15:45:00',6),('8902','2013-08-07','15:50:00',5.9),('8902','2013-08-07','15:55:00',5.8),('8902','2013-08-07','16:00:00',5.74),('8902','2013-08-07','16:05:00',5.7),('8902','2013-08-07','16:10:00',5.63),('8902','2013-08-07','16:15:00',5.54),('8902','2013-08-07','16:20:00',5.52),('8902','2013-08-07','16:25:00',5.41),('8902','2013-08-07','16:30:00',5.28),('8902','2013-08-07','16:35:00',5.1),('8902','2013-08-07','16:40:00',5.02),('8902','2013-08-07','16:45:00',4.89),('8902','2013-08-07','16:50:00',4.77),('8902','2013-08-07','16:55:00',4.52),('8902','2013-08-07','17:00:00',4.46),('8902','2013-08-07','17:05:00',4.33),('8902','2013-08-07','17:10:00',4.18),('8902','2013-08-07','17:15:00',4.05),('8902','2013-08-07','17:20:00',3.83),('8902','2013-08-07','17:25:00',3.73),('8902','2013-08-07','17:30:00',3.62),('8902','2013-08-07','17:35:00',3.45),('8902','2013-08-07','17:40:00',3.27),('8902','2013-08-07','17:45:00',3.16),('8902','2013-08-07','17:50:00',2.96),('8902','2013-08-07','17:55:00',2.82),('8902','2013-08-07','18:00:00',2.69),('8902','2013-08-07','18:05:00',2.52),('8902','2013-08-07','18:10:00',2.36),('8902','2013-08-07','18:15:00',2.2),('8902','2013-08-07','18:20:00',2.05),('8902','2013-08-07','18:25:00',1.88),('8902','2013-08-07','18:30:00',1.69),('8902','2013-08-07','18:35:00',1.55),('8902','2013-08-07','18:40:00',1.4),('8902','2013-08-07','18:45:00',1.26),('8902','2013-08-07','18:50:00',1.1),('8902','2013-08-06','07:50:00',1.19),('8902','2013-08-06','07:55:00',1.34),('8902','2013-08-06','08:00:00',1.47),('8902','2013-08-06','08:05:00',1.61),('8902','2013-08-06','08:10:00',1.76),('8902','2013-08-06','08:15:00',1.9),('8902','2013-08-06','08:20:00',2.05),('8902','2013-08-06','08:25:00',2.21),('8902','2013-08-06','08:30:00',2.36),('8902','2013-08-06','08:35:00',2.5),('8902','2013-08-06','08:40:00',2.67),('8902','2013-08-06','08:45:00',2.82),('8902','2013-08-06','08:50:00',2.98),('8902','2013-08-06','08:55:00',3.14),('8902','2013-08-06','09:00:00',3.29),('8902','2013-08-06','09:05:00',3.43),('8902','2013-08-06','09:10:00',3.56),('8902','2013-08-06','09:15:00',3.67),('8902','2013-08-06','09:20:00',3.85),('8902','2013-08-06','09:25:00',4),('8902','2013-08-06','09:30:00',4.14),('8902','2013-08-06','09:35:00',4.31),('8902','2013-08-06','09:40:00',4.43),('8902','2013-08-06','09:45:00',4.53),('8902','2013-08-06','09:50:00',4.59),('8902','2013-08-06','09:55:00',4.74),('8902','2013-08-06','10:00:00',4.83),('8902','2013-08-06','10:05:00',4.99),('8902','2013-08-06','10:10:00',5.12),('8902','2013-08-06','10:15:00',5.23),('8902','2013-08-06','10:20:00',5.27),('8902','2013-08-06','10:25:00',5.4),('8902','2013-08-06','10:30:00',5.55),('8902','2013-08-06','10:35:00',5.62),('8902','2013-08-06','10:40:00',5.69),('8902','2013-08-06','10:45:00',5.77),('8902','2013-08-06','10:50:00',5.9),('8902','2013-08-06','10:55:00',5.98),('8902','2013-08-06','11:00:00',6.06),('8902','2013-08-06','11:05:00',6.1),('8902','2013-08-06','11:10:00',6.19),('8902','2013-08-06','11:15:00',6.25),('8902','2013-08-06','11:20:00',6.3),('8902','2013-08-06','11:25:00',6.36),('8902','2013-08-06','11:30:00',6.43),('8902','2013-08-06','11:35:00',6.47),('8902','2013-08-06','11:40:00',6.5),('8902','2013-08-06','11:45:00',6.57),('8902','2013-08-06','11:50:00',6.61),('8902','2013-08-06','11:55:00',6.61),('8902','2013-08-06','12:00:00',6.66),('8902','2013-08-06','12:05:00',6.74),('8902','2013-08-06','12:10:00',6.8),('8902','2013-08-06','12:15:00',6.89),('8902','2013-08-06','12:20:00',6.82),('8902','2013-08-06','12:25:00',6.88),('8902','2013-08-06','12:30:00',6.88),('8902','2013-08-06','12:35:00',6.93),('8902','2013-08-06','12:40:00',6.83),('8902','2013-08-06','12:45:00',6.83),('8902','2013-08-06','12:50:00',6.97),('8902','2013-08-06','12:55:00',7.03),('8902','2013-08-06','13:00:00',7),('8902','2013-08-06','13:05:00',6.92),('8902','2013-08-06','13:10:00',6.95),('8902','2013-08-06','13:15:00',6.9),('8902','2013-08-06','13:20:00',7.1),('8902','2013-08-06','13:25:00',6.98),('8902','2013-08-06','13:30:00',7.14),('8902','2013-08-06','13:35:00',7.12),('8902','2013-08-06','13:40:00',7.11),('8902','2013-08-06','13:45:00',7.22),('8902','2013-08-06','13:50:00',7.1),('8902','2013-08-06','13:55:00',7.18),('8902','2013-08-06','14:00:00',7.15),('8902','2013-08-06','14:05:00',7.07),('8902','2013-08-06','14:10:00',7.04),('8902','2013-08-06','14:15:00',6.96),('8902','2013-08-06','14:20:00',6.84),('8902','2013-08-06','14:25:00',6.86),('8902','2013-08-06','14:30:00',6.75),('8902','2013-08-06','14:35:00',6.69),('8902','2013-08-06','14:40:00',6.61),('8902','2013-08-06','14:45:00',6.8),('8902','2013-08-06','14:50:00',6.78),('8902','2013-08-06','14:55:00',6.71),('8902','2013-08-06','15:00:00',6.6),('8902','2013-08-06','15:05:00',6.58),('8902','2013-08-06','15:10:00',6.51),('8902','2013-08-06','15:15:00',6.47),('8902','2013-08-06','15:20:00',6.43),('8902','2013-08-06','15:25:00',6.42),('8902','2013-08-06','15:30:00',6.2),('8902','2013-08-06','15:35:00',6.21),('8902','2013-08-06','15:40:00',6.16),('8902','2013-08-06','15:45:00',6.12),('8902','2013-08-06','15:50:00',6),('8902','2013-08-06','15:55:00',5.92),('8902','2013-08-06','16:00:00',5.85),('8902','2013-08-06','16:05:00',5.74),('8902','2013-08-06','16:10:00',5.56),('8902','2013-08-06','16:15:00',5.46),('8902','2013-08-06','16:20:00',5.42),('8902','2013-08-06','16:25:00',5.36),('8902','2013-08-06','16:30:00',5.25),('8902','2013-08-06','16:35:00',5.11),('8902','2013-08-06','16:40:00',4.99),('8902','2013-08-06','16:45:00',4.95),('8902','2013-08-06','16:50:00',4.84),('8902','2013-08-06','16:55:00',4.63),('8902','2013-08-06','17:00:00',4.56),('8902','2013-08-06','17:05:00',4.45),('8902','2013-08-06','17:10:00',4.32),('8902','2013-08-06','17:15:00',4.16),('8902','2013-08-06','17:20:00',4.01),('8902','2013-08-06','17:25:00',3.91),('8902','2013-08-06','17:30:00',3.72),('8902','2013-08-06','17:35:00',3.51),('8902','2013-08-06','17:40:00',3.32),('8902','2013-08-06','17:45:00',3.19),('8902','2013-08-06','17:50:00',3.02),('8902','2013-08-06','17:55:00',2.87),('8902','2013-08-06','18:00:00',2.71),('8902','2013-08-06','18:05:00',2.57),('8902','2013-08-06','18:10:00',2.37),('8902','2013-08-06','18:15:00',2.19),('8902','2013-08-06','18:20:00',2.02),('8902','2013-08-06','18:25:00',1.89),('8902','2013-08-06','18:30:00',1.75),('8902','2013-08-06','18:35:00',1.62),('8902','2013-08-06','18:40:00',1.47),('8902','2013-08-06','18:45:00',1.34),('8902','2013-08-06','18:50:00',1.19),('8902','2013-08-06','18:55:00',1.05),('8902','2013-08-05','07:45:00',1.01),('8902','2013-08-05','07:50:00',1.18),('8902','2013-08-05','07:55:00',1.31),('8902','2013-08-05','08:00:00',1.44),('8902','2013-08-05','08:05:00',1.58),('8902','2013-08-05','08:10:00',1.73),('8902','2013-08-05','08:15:00',1.88),('8902','2013-08-05','08:20:00',2.02),('8902','2013-08-05','08:25:00',2.17),('8902','2013-08-05','08:30:00',2.32),('8902','2013-08-05','08:35:00',2.47),('8902','2013-08-05','08:40:00',2.61),('8902','2013-08-05','08:45:00',2.77),('8902','2013-08-05','08:50:00',2.93),('8902','2013-08-05','08:55:00',3.08),('8902','2013-08-05','09:00:00',3.21),('8902','2013-08-05','09:05:00',3.35),('8902','2013-08-05','09:10:00',3.48),('8902','2013-08-05','09:15:00',3.65),('8902','2013-08-05','09:20:00',3.8),('8902','2013-08-05','09:25:00',3.92),('8902','2013-08-05','09:30:00',4.04),('8902','2013-08-05','09:35:00',4.2),('8902','2013-08-05','09:40:00',4.32),('8902','2013-08-05','09:45:00',4.42),('8902','2013-08-05','09:50:00',4.57),('8902','2013-08-05','09:55:00',4.73),('8902','2013-08-05','10:00:00',4.83),('8902','2013-08-05','10:05:00',4.94),('8902','2013-08-05','10:10:00',5.05),('8902','2013-08-05','10:15:00',5.17),('8902','2013-08-05','10:20:00',5.27),('8902','2013-08-05','10:25:00',5.39),('8902','2013-08-05','10:30:00',5.52),('8902','2013-08-05','10:35:00',5.58),('8902','2013-08-05','10:40:00',5.64),('8902','2013-08-05','10:45:00',5.72),('8902','2013-08-05','10:50:00',5.78),('8902','2013-08-05','10:55:00',5.85),('8902','2013-08-05','11:00:00',6),('8902','2013-08-05','11:05:00',6.04),('8902','2013-08-05','11:10:00',6.11),('8902','2013-08-05','11:15:00',6.22),('8902','2013-08-05','11:20:00',6.3),('8902','2013-08-05','11:25:00',6.3),('8902','2013-08-05','11:30:00',6.36),('8902','2013-08-05','11:35:00',6.49),('8902','2013-08-05','11:40:00',6.56),('8902','2013-08-05','11:45:00',6.53),('8902','2013-08-05','11:50:00',6.53),('8902','2013-08-05','11:55:00',6.58),('8902','2013-08-05','12:00:00',6.68),('8902','2013-08-05','12:05:00',6.7),('8902','2013-08-05','12:10:00',6.79),('8902','2013-08-05','12:15:00',6.76),('8902','2013-08-05','12:20:00',6.79),('8902','2013-08-05','12:25:00',6.83),('8902','2013-08-05','12:30:00',6.83),('8902','2013-08-05','12:35:00',6.88),('8902','2013-08-05','12:40:00',6.91),('8902','2013-08-05','12:45:00',6.86),('8902','2013-08-05','12:50:00',6.96),('8902','2013-08-05','12:55:00',7),('8902','2013-08-05','13:00:00',6.99),('8902','2013-08-05','13:05:00',7),('8902','2013-08-05','13:10:00',7.01),('8902','2013-08-05','13:15:00',7.07),('8902','2013-08-05','13:20:00',7.09),('8902','2013-08-05','13:25:00',7.17),('8902','2013-08-05','13:30:00',7.19),('8902','2013-08-05','13:35:00',7.23),('8902','2013-08-05','13:40:00',7.25),('8902','2013-08-05','13:45:00',7.24),('8902','2013-08-05','13:50:00',7.3),('8902','2013-08-05','13:55:00',7.33),('8902','2013-08-05','14:00:00',7.33),('8902','2013-08-05','14:05:00',7.32),('8902','2013-08-05','14:10:00',7.3),('8902','2013-08-05','14:15:00',7.31),('8902','2013-08-05','14:20:00',7.27),('8902','2013-08-05','14:25:00',7.21),('8902','2013-08-05','14:30:00',7.18),('8902','2013-08-05','14:35:00',7.14),('8902','2013-08-05','14:40:00',7.11),('8902','2013-08-05','14:45:00',7.06),('8902','2013-08-05','14:50:00',7.06),('8902','2013-08-05','14:55:00',7.01),('8902','2013-08-05','15:00:00',6.96),('8902','2013-08-05','15:05:00',6.9),('8902','2013-08-05','15:10:00',6.88),('8902','2013-08-05','15:15:00',6.78),('8902','2013-08-05','15:20:00',6.76),('8902','2013-08-05','15:25:00',6.73),('8902','2013-08-05','15:30:00',6.64),('8902','2013-08-05','15:35:00',6.57),('8902','2013-08-05','15:40:00',6.46),('8902','2013-08-05','15:45:00',6.38),('8902','2013-08-05','15:50:00',6.3),('8902','2013-08-05','15:55:00',6.17),('8902','2013-08-05','16:00:00',6.1),('8902','2013-08-05','16:05:00',6.01),('8902','2013-08-05','16:10:00',5.89),('8902','2013-08-05','16:15:00',5.78),('8902','2013-08-05','16:20:00',5.7),('8902','2013-08-05','16:25:00',5.56),('8902','2013-08-05','16:30:00',5.45),('8902','2013-08-05','16:35:00',5.27),('8902','2013-08-05','16:40:00',5.13),('8902','2013-08-05','16:45:00',5.07),('8902','2013-08-05','16:50:00',4.93),('8902','2013-08-05','16:55:00',4.72),('8902','2013-08-05','17:00:00',4.65),('8902','2013-08-05','17:05:00',4.57),('8902','2013-08-05','17:10:00',4.41),('8902','2013-08-05','17:15:00',4.25),('8902','2013-08-05','17:20:00',4.07),('8902','2013-08-05','17:25:00',3.95),('8902','2013-08-05','17:30:00',3.82),('8902','2013-08-05','17:35:00',3.67),('8902','2013-08-05','17:40:00',3.46),('8902','2013-08-05','17:45:00',3.33),('8902','2013-08-05','17:50:00',3.12),('8902','2013-08-05','17:55:00',2.94),('8902','2013-08-05','18:00:00',2.81),('8902','2013-08-05','18:05:00',2.66),('8902','2013-08-05','18:10:00',2.49),('8902','2013-08-05','18:15:00',2.33),('8902','2013-08-05','18:20:00',2.17),('8902','2013-08-05','18:25:00',2.01),('8902','2013-08-05','18:30:00',1.86),('8902','2013-08-05','18:35:00',1.7),('8902','2013-08-05','18:40:00',1.51),('8902','2013-08-05','18:45:00',1.36),('8902','2013-08-05','18:50:00',1.19),('8902','2013-08-05','18:55:00',1.05),('8902','2013-08-04','07:45:00',1.08),('8902','2013-08-04','07:50:00',1.27),('8902','2013-08-04','07:55:00',1.4),('8902','2013-08-04','08:00:00',1.54),('8902','2013-08-04','08:05:00',1.69),('8902','2013-08-04','08:10:00',1.84),('8902','2013-08-04','08:15:00',1.98),('8902','2013-08-04','08:20:00',2.12),('8902','2013-08-04','08:25:00',2.27),('8902','2013-08-04','08:30:00',2.42),('8902','2013-08-04','08:35:00',2.57),('8902','2013-08-04','08:40:00',2.72),('8902','2013-08-04','08:45:00',2.88),('8902','2013-08-04','08:50:00',3.03),('8902','2013-08-04','08:55:00',3.18),('8902','2013-08-04','09:00:00',3.33),('8902','2013-08-04','09:05:00',3.47),('8902','2013-08-04','09:10:00',3.61),('8902','2013-08-04','09:15:00',3.74),('8902','2013-08-04','09:20:00',3.86),('8902','2013-08-04','09:25:00',3.99),('8902','2013-08-04','09:30:00',4.11),('8902','2013-08-04','09:35:00',4.25),('8902','2013-08-04','09:40:00',4.38),('8902','2013-08-04','09:45:00',4.51),('8902','2013-08-04','09:50:00',4.61),('8902','2013-08-04','09:55:00',4.73),('8902','2013-08-04','10:00:00',4.85),('8902','2013-08-04','10:05:00',4.99),('8902','2013-08-04','10:10:00',5.12),('8902','2013-08-04','10:15:00',5.24),('8902','2013-08-04','10:20:00',5.33),('8902','2013-08-04','10:25:00',5.45),('8902','2013-08-04','10:30:00',5.56),('8902','2013-08-04','10:35:00',5.62),('8902','2013-08-04','10:40:00',5.74),('8902','2013-08-04','10:45:00',5.83),('8902','2013-08-04','10:50:00',5.91),('8902','2013-08-04','10:55:00',5.97),('8902','2013-08-04','11:00:00',6.12),('8902','2013-08-04','11:05:00',6.17),('8902','2013-08-04','11:10:00',6.31),('8902','2013-08-04','11:15:00',6.32),('8902','2013-08-04','11:20:00',6.44),('8902','2013-08-04','11:25:00',6.53),('8902','2013-08-04','11:30:00',6.55),('8902','2013-08-04','11:35:00',6.59),('8902','2013-08-04','11:40:00',6.67),('8902','2013-08-04','11:45:00',6.71),('8902','2013-08-04','11:50:00',6.8),('8902','2013-08-04','11:55:00',6.79),('8902','2013-08-04','12:00:00',6.82),('8902','2013-08-04','12:05:00',6.86),('8902','2013-08-04','12:10:00',6.89),('8902','2013-08-04','12:15:00',7.01),('8902','2013-08-04','12:20:00',7.03),('8902','2013-08-04','12:25:00',7.06),('8902','2013-08-04','12:30:00',7.06),('8902','2013-08-04','12:35:00',7.09),('8902','2013-08-04','12:40:00',7.14),('8902','2013-08-04','12:45:00',7.13),('8902','2013-08-04','12:50:00',7.15),('8902','2013-08-04','12:55:00',7.12),('8902','2013-08-04','13:00:00',7.14),('8902','2013-08-04','13:05:00',7.18),('8902','2013-08-04','13:10:00',7.21),('8902','2013-08-04','13:15:00',7.25),('8902','2013-08-04','13:20:00',7.22),('8902','2013-08-04','13:25:00',7.22),('8902','2013-08-04','13:30:00',7.22),('8902','2013-08-04','13:35:00',7.25),('8902','2013-08-04','13:40:00',7.22),('8902','2013-08-04','13:45:00',7.2),('8902','2013-08-04','13:50:00',7.06),('8902','2013-08-04','13:55:00',7.07),('8902','2013-08-04','14:00:00',7.12),('8902','2013-08-04','14:05:00',7.14),('8902','2013-08-04','14:10:00',7.09),('8902','2013-08-04','14:15:00',7.05),('8902','2013-08-04','14:20:00',7.03),('8902','2013-08-04','14:25:00',6.97),('8902','2013-08-04','14:30:00',6.93),('8902','2013-08-04','14:35:00',6.95),('8902','2013-08-04','14:40:00',6.93),('8902','2013-08-04','14:45:00',6.89),('8902','2013-08-04','14:50:00',6.84),('8902','2013-08-04','14:55:00',6.78),('8902','2013-08-04','15:00:00',6.73),('8902','2013-08-04','15:05:00',6.73),('8902','2013-08-04','15:10:00',6.7),('8902','2013-08-04','15:15:00',6.67),('8902','2013-08-04','15:20:00',6.57),('8902','2013-08-04','15:25:00',6.52),('8902','2013-08-04','15:30:00',6.49),('8902','2013-08-04','15:35:00',6.44),('8902','2013-08-04','15:40:00',6.37),('8902','2013-08-04','15:45:00',6.28),('8902','2013-08-04','15:50:00',6.21),('8902','2013-08-04','15:55:00',6.13),('8902','2013-08-04','16:00:00',6.11),('8902','2013-08-04','16:05:00',6.01),('8902','2013-08-04','16:10:00',5.89),('8902','2013-08-04','16:15:00',5.79),('8902','2013-08-04','16:20:00',5.64),('8902','2013-08-04','16:25:00',5.53),('8902','2013-08-04','16:30:00',5.45),('8902','2013-08-04','16:35:00',5.28),('8902','2013-08-04','16:40:00',5.15),('8902','2013-08-04','16:45:00',5.03),('8902','2013-08-04','16:50:00',4.91),('8902','2013-08-04','16:55:00',4.73),('8902','2013-08-04','17:00:00',4.64),('8902','2013-08-04','17:05:00',4.52),('8902','2013-08-04','17:10:00',4.37),('8902','2013-08-04','17:15:00',4.23),('8902','2013-08-04','17:20:00',4.02),('8902','2013-08-04','17:25:00',3.88),('8902','2013-08-04','17:30:00',3.75),('8902','2013-08-04','17:35:00',3.6),('8902','2013-08-04','17:40:00',3.44),('8902','2013-08-04','17:45:00',3.3),('8902','2013-08-04','17:50:00',3.09),('8902','2013-08-04','17:55:00',2.92),('8902','2013-08-04','18:00:00',2.77),('8902','2013-08-04','18:05:00',2.59),('8902','2013-08-04','18:10:00',2.41),('8902','2013-08-04','18:15:00',2.25),('8902','2013-08-04','18:20:00',2.1),('8902','2013-08-04','18:25:00',1.95),('8902','2013-08-04','18:30:00',1.76),('8902','2013-08-04','18:35:00',1.64),('8902','2013-08-04','18:40:00',1.49),('8902','2013-08-04','18:45:00',1.34),('8902','2013-08-04','18:50:00',1.2),('8902','2013-08-04','18:55:00',1.06),('8902','2013-08-03','07:45:00',1.07),('8902','2013-08-03','07:50:00',1.26),('8902','2013-08-03','07:55:00',1.42),('8902','2013-08-03','08:00:00',1.57),('8902','2013-08-03','08:05:00',1.72),('8902','2013-08-03','08:10:00',1.88),('8902','2013-08-03','08:15:00',2.05),('8902','2013-08-03','08:20:00',2.23),('8902','2013-08-03','08:25:00',2.39),('8902','2013-08-03','08:30:00',2.54),('8902','2013-08-03','08:35:00',2.71),('8902','2013-08-03','08:40:00',2.87),('8902','2013-08-03','08:45:00',3.03),('8902','2013-08-03','08:50:00',3.19),('8902','2013-08-03','08:55:00',3.34),('8902','2013-08-03','09:00:00',3.51),('8902','2013-08-03','09:05:00',3.66),('8902','2013-08-03','09:10:00',3.8),('8902','2013-08-03','09:15:00',3.93),('8902','2013-08-03','09:20:00',4.07),('8902','2013-08-03','09:25:00',4.22),('8902','2013-08-03','09:30:00',4.36),('8902','2013-08-03','09:35:00',4.51),('8902','2013-08-03','09:40:00',4.64),('8902','2013-08-03','09:45:00',4.76),('8902','2013-08-03','09:50:00',4.9),('8902','2013-08-03','09:55:00',5.02),('8902','2013-08-03','10:00:00',5.13),('8902','2013-08-03','10:05:00',5.24),('8902','2013-08-03','10:10:00',5.34),('8902','2013-08-03','10:15:00',5.46),('8902','2013-08-03','10:20:00',5.57),('8902','2013-08-03','10:25:00',5.69),('8902','2013-08-03','10:30:00',5.78),('8902','2013-08-03','10:35:00',5.9),('8902','2013-08-03','10:40:00',5.99),('8902','2013-08-03','10:45:00',6.05),('8902','2013-08-03','10:50:00',5.44),('8902','2013-08-03','10:55:00',6.23),('8902','2013-08-03','11:00:00',6.29),('8902','2013-08-03','11:05:00',6.35),('8902','2013-08-03','11:10:00',6.4),('8902','2013-08-03','11:15:00',6.45),('8902','2013-08-03','11:20:00',6.51),('8902','2013-08-03','11:25:00',6.59),('8902','2013-08-03','11:30:00',6.71),('8902','2013-08-03','11:35:00',6.79),('8902','2013-08-03','11:40:00',6.86),('8902','2013-08-03','11:45:00',6.9),('8902','2013-08-03','11:50:00',6.92),('8902','2013-08-03','11:55:00',7.03),('8902','2013-08-03','12:00:00',7.07),('8902','2013-08-03','12:05:00',7.11),('8902','2013-08-03','12:10:00',7.11),('8902','2013-08-03','12:15:00',7.15),('8902','2013-08-03','12:20:00',7.24),('8902','2013-08-03','12:25:00',7.2),('8902','2013-08-03','12:30:00',7.16),('8902','2013-08-03','12:35:00',7.19),('8902','2013-08-03','12:40:00',7.27),('8902','2013-08-03','12:45:00',7.33),('8902','2013-08-03','12:50:00',7.38),('8902','2013-08-03','12:55:00',7.37),('8902','2013-08-03','13:00:00',7.36),('8902','2013-08-03','13:05:00',7.34),('8902','2013-08-03','13:10:00',7.25),('8902','2013-08-03','13:15:00',7.31),('8902','2013-08-03','13:20:00',7.33),('8902','2013-08-03','13:25:00',7.3),('8902','2013-08-03','13:30:00',7.36),('8902','2013-08-03','13:35:00',7.41),('8902','2013-08-03','13:40:00',7.52),('8902','2013-08-03','13:45:00',7.5),('8902','2013-08-03','13:50:00',7.49),('8902','2013-08-03','13:55:00',7.54),('8902','2013-08-03','14:00:00',7.54),('8902','2013-08-03','14:05:00',7.54),('8902','2013-08-03','14:10:00',7.46),('8902','2013-08-03','14:15:00',7.47),('8902','2013-08-03','14:20:00',7.35),('8902','2013-08-03','14:25:00',7.35),('8902','2013-08-03','14:30:00',7.36),('8902','2013-08-03','14:35:00',7.3),('8902','2013-08-03','14:40:00',7.21),('8902','2013-08-03','14:45:00',7.23),('8902','2013-08-03','14:50:00',7.17),('8902','2013-08-03','14:55:00',6.05),('8902','2013-08-03','15:00:00',7.01),('8902','2013-08-03','15:05:00',7),('8902','2013-08-03','15:10:00',6.95),('8902','2013-08-03','15:15:00',6.9),('8902','2013-08-03','15:20:00',6.82),('8902','2013-08-03','15:25:00',6.73),('8902','2013-08-03','15:30:00',6.59),('8902','2013-08-03','15:35:00',6.68),('8902','2013-08-03','15:40:00',6.54),('8902','2013-08-03','15:45:00',6.46),('8902','2013-08-03','15:50:00',6.31),('8902','2013-08-03','15:55:00',6.25),('8902','2013-08-03','16:00:00',6.2),('8902','2013-08-03','16:05:00',6.09),('8902','2013-08-03','16:10:00',6.01),('8902','2013-08-03','16:15:00',5.97),('8902','2013-08-03','16:20:00',5.88),('8902','2013-08-03','16:25:00',5.75),('8902','2013-08-03','16:30:00',5.64),('8902','2013-08-03','16:35:00',5.44),('8902','2013-08-03','16:40:00',5.28),('8902','2013-08-03','16:45:00',5.25),('8902','2013-08-03','16:50:00',5.1),('8902','2013-08-03','16:55:00',4.9),('8902','2013-08-03','17:00:00',4.74),('8902','2013-08-03','17:05:00',4.7),('8902','2013-08-03','17:10:00',4.58),('8902','2013-08-03','17:15:00',4.42),('8902','2013-08-03','17:20:00',4.24),('8902','2013-08-03','17:25:00',4.07),('8902','2013-08-03','17:30:00',3.92),('8902','2013-08-03','17:35:00',3.77),('8902','2013-08-03','17:40:00',3.57),('8902','2013-08-03','17:45:00',3.43),('8902','2013-08-03','17:50:00',3.26),('8902','2013-08-03','17:55:00',3.05),('8902','2013-08-03','18:00:00',2.91),('8902','2013-08-03','18:05:00',2.72),('8902','2013-08-03','18:10:00',2.51),('8902','2013-08-03','18:15:00',2.38),('8902','2013-08-03','18:20:00',2.24),('8902','2013-08-03','18:25:00',2.07),('8902','2013-08-03','18:30:00',1.87),('8902','2013-08-03','18:35:00',1.69),('8902','2013-08-03','18:40:00',1.53),('8902','2013-08-03','18:45:00',1.31),('8902','2013-08-03','18:50:00',1.22),('8902','2013-08-03','18:55:00',1.08),('8902','2013-08-02','07:45:00',1.1),('8902','2013-08-02','07:50:00',1.27),('8902','2013-08-02','07:55:00',1.42),('8902','2013-08-02','08:00:00',1.57),('8902','2013-08-02','08:05:00',1.73),('8902','2013-08-02','08:10:00',1.88),('8902','2013-08-02','08:15:00',2.04),('8902','2013-08-02','08:20:00',2.21),('8902','2013-08-02','08:25:00',2.37),('8902','2013-08-02','08:30:00',2.51),('8902','2013-08-02','08:35:00',2.68),('8902','2013-08-02','08:40:00',2.83),('8902','2013-08-02','08:45:00',3),('8902','2013-08-02','08:50:00',3.16),('8902','2013-08-02','08:55:00',3.32),('8902','2013-08-02','09:00:00',3.47),('8902','2013-08-02','09:05:00',3.61),('8902','2013-08-02','09:10:00',3.76),('8902','2013-08-02','09:15:00',3.91),('8902','2013-08-02','09:20:00',4.06),('8902','2013-08-02','09:25:00',4.22),('8902','2013-08-02','09:30:00',4.37),('8902','2013-08-02','09:35:00',4.51),('8902','2013-08-02','09:40:00',4.63),('8902','2013-08-02','09:45:00',4.74),('8902','2013-08-02','09:50:00',4.88),('8902','2013-08-02','09:55:00',5),('8902','2013-08-02','10:00:00',5.09),('8902','2013-08-02','10:05:00',5.22),('8902','2013-08-02','10:10:00',5.33),('8902','2013-08-02','10:15:00',5.45),('8902','2013-08-02','10:20:00',5.54),('8902','2013-08-02','10:25:00',5.67),('8902','2013-08-02','10:30:00',5.78),('8902','2013-08-02','10:35:00',5.88),('8902','2013-08-02','10:40:00',5.95),('8902','2013-08-02','10:45:00',6.03),('8902','2013-08-02','10:50:00',6.11),('8902','2013-08-02','10:55:00',6.19),('8902','2013-08-02','11:00:00',6.31),('8902','2013-08-02','11:05:00',6.4),('8902','2013-08-02','11:10:00',6.39),('8902','2013-08-02','11:15:00',6.45),('8902','2013-08-02','11:20:00',6.54),('8902','2013-08-02','11:25:00',6.56),('8902','2013-08-02','11:30:00',6.57),('8902','2013-08-02','11:35:00',6.74),('8902','2013-08-02','11:40:00',6.82),('8902','2013-08-02','11:45:00',6.85),('8902','2013-08-02','11:50:00',6.92),('8902','2013-08-02','11:55:00',7.03),('8902','2013-08-02','12:00:00',7.02),('8902','2013-08-02','12:05:00',7.02),('8902','2013-08-02','12:10:00',7.09),('8902','2013-08-02','12:15:00',7.15),('8902','2013-08-02','12:20:00',7.17),('8902','2013-08-02','12:25:00',7.15),('8902','2013-08-02','12:30:00',7.24),('8902','2013-08-02','12:35:00',7.22),('8902','2013-08-02','12:40:00',7.19),('8902','2013-08-02','12:45:00',7.28),('8902','2013-08-02','12:50:00',7.25),('8902','2013-08-02','12:55:00',7.2),('8902','2013-08-02','13:00:00',7.27),('8902','2013-08-02','13:05:00',7.16),('8902','2013-08-02','13:10:00',7.18),('8902','2013-08-02','13:15:00',7.24),('8902','2013-08-02','13:20:00',7.15),('8902','2013-08-02','13:25:00',7.15),('8902','2013-08-02','13:30:00',7.08),('8902','2013-08-02','13:35:00',7),('8902','2013-08-02','13:40:00',7.14),('8902','2013-08-02','13:45:00',7.27),('8902','2013-08-02','13:50:00',7.28),('8902','2013-08-02','13:55:00',7.28),('8902','2013-08-02','14:00:00',7.24),('8902','2013-08-02','14:05:00',7.21),('8902','2013-08-02','14:10:00',7),('8902','2013-08-02','14:15:00',6.94),('8902','2013-08-02','14:20:00',7.05),('8902','2013-08-02','14:25:00',6.97),('8902','2013-08-02','14:30:00',6.99),('8902','2013-08-02','14:35:00',7.12),('8902','2013-08-02','14:40:00',7.05),('8902','2013-08-02','14:45:00',7.13),('8902','2013-08-02','14:50:00',7.05),('8902','2013-08-02','14:55:00',7.05),('8902','2013-08-02','15:00:00',7),('8902','2013-08-02','15:05:00',6.88),('8902','2013-08-02','15:10:00',6.85),('8902','2013-08-02','15:15:00',6.75),('8902','2013-08-02','15:20:00',6.73),('8902','2013-08-02','15:25:00',6.71),('8902','2013-08-02','15:30:00',6.67),('8902','2013-08-02','15:35:00',6.58),('8902','2013-08-02','15:40:00',6.51),('8902','2013-08-02','15:45:00',6.44),('8902','2013-08-02','15:50:00',6.36),('8902','2013-08-02','15:55:00',6.28),('8902','2013-08-02','16:00:00',6.14),('8902','2013-08-02','16:05:00',6.04),('8902','2013-08-02','16:10:00',5.91),('8902','2013-08-02','16:15:00',5.8),('8902','2013-08-02','16:20:00',5.68),('8902','2013-08-02','16:25:00',5.57),('8902','2013-08-02','16:30:00',5.49),('8902','2013-08-02','16:35:00',5.34),('8902','2013-08-02','16:40:00',5.25),('8902','2013-08-02','16:45:00',5.14),('8902','2013-08-02','16:50:00',5.05),('8902','2013-08-02','16:55:00',4.88),('8902','2013-08-02','17:00:00',4.59),('8902','2013-08-02','17:05:00',4.59),('8902','2013-08-02','17:10:00',4.47),('8902','2013-08-02','17:15:00',4.32),('8902','2013-08-02','17:20:00',4.16),('8902','2013-08-02','17:25:00',4.01),('8902','2013-08-02','17:30:00',3.9),('8902','2013-08-02','17:35:00',3.77),('8902','2013-08-02','17:40:00',3.55),('8902','2013-08-02','17:45:00',3.42),('8902','2013-08-02','17:50:00',3.23),('8902','2013-08-02','17:55:00',3.03),('8902','2013-08-02','18:00:00',2.91),('8902','2013-08-02','18:05:00',2.77),('8902','2013-08-02','18:10:00',2.57),('8902','2013-08-02','18:15:00',2.43),('8902','2013-08-02','18:20:00',2.27),('8902','2013-08-02','18:25:00',2.12),('8902','2013-08-02','18:30:00',1.95),('8902','2013-08-02','18:35:00',1.79),('8902','2013-08-02','18:40:00',1.64),('8902','2013-08-02','18:45:00',1.48),('8902','2013-08-02','18:50:00',1.32),('8902','2013-08-02','18:55:00',1.18),('8902','2013-08-02','19:00:00',1.04),('8902','2013-08-01','07:45:00',1.17),('8902','2013-08-01','07:50:00',1.33),('8902','2013-08-01','07:55:00',1.49),('8902','2013-08-01','08:00:00',1.66),('8902','2013-08-01','08:05:00',1.82),('8902','2013-08-01','08:10:00',1.98),('8902','2013-08-01','08:15:00',2.15),('8902','2013-08-01','08:20:00',2.32),('8902','2013-08-01','08:25:00',2.49),('8902','2013-08-01','08:30:00',2.66),('8902','2013-08-01','08:35:00',2.82),('8902','2013-08-01','08:40:00',2.98),('8902','2013-08-01','08:45:00',3.13),('8902','2013-08-01','08:50:00',3.29),('8902','2013-08-01','08:55:00',3.43),('8902','2013-08-01','09:00:00',3.6),('8902','2013-08-01','09:05:00',3.75),('8902','2013-08-01','09:10:00',3.9),('8902','2013-08-01','09:15:00',4.05),('8902','2013-08-01','09:20:00',4.19),('8902','2013-08-01','09:25:00',4.35),('8902','2013-08-01','09:30:00',4.49),('8902','2013-08-01','09:35:00',4.62),('8902','2013-08-01','09:40:00',4.74),('8902','2013-08-01','09:45:00',4.86),('8902','2013-08-01','09:50:00',4.99),('8902','2013-08-01','09:55:00',5.11),('8902','2013-08-01','10:00:00',5.2),('8902','2013-08-01','10:05:00',5.31),('8902','2013-08-01','10:10:00',5.43),('8902','2013-08-01','10:15:00',5.56),('8902','2013-08-01','10:20:00',5.66),('8902','2013-08-01','10:25:00',5.74),('8902','2013-08-01','10:30:00',5.86),('8902','2013-08-01','10:35:00',5.96),('8902','2013-08-01','10:40:00',6.04),('8902','2013-08-01','10:45:00',6.14),('8902','2013-08-01','10:50:00',6.2),('8902','2013-08-01','10:55:00',6.31),('8902','2013-08-01','11:00:00',6.39),('8902','2013-08-01','11:05:00',6.48),('8902','2013-08-01','11:10:00',6.52),('8902','2013-08-01','11:15:00',6.63),('8902','2013-08-01','11:20:00',6.72),('8902','2013-08-01','11:25:00',6.81),('8902','2013-08-01','11:30:00',6.83),('8902','2013-08-01','11:35:00',6.86),('8902','2013-08-01','11:40:00',6.9),('8902','2013-08-01','11:45:00',6.95),('8902','2013-08-01','11:50:00',7.01),('8902','2013-08-01','11:55:00',7.07),('8902','2013-08-01','12:00:00',7.16),('8902','2013-08-01','12:05:00',7.18),('8902','2013-08-01','12:10:00',7.23),('8902','2013-08-01','12:15:00',7.27),('8902','2013-08-01','12:20:00',7.28),('8902','2013-08-01','12:25:00',7.3),('8902','2013-08-01','12:30:00',7.31),('8902','2013-08-01','12:35:00',7.36),('8902','2013-08-01','12:40:00',7.36),('8902','2013-08-01','12:45:00',7.37),('8902','2013-08-01','12:50:00',7.34),('8902','2013-08-01','12:55:00',7.38),('8902','2013-08-01','13:00:00',7.37),('8902','2013-08-01','13:05:00',7.48),('8902','2013-08-01','13:10:00',7.55),('8902','2013-08-01','13:15:00',7.57),('8902','2013-08-01','13:20:00',7.43),('8902','2013-08-01','13:25:00',7.52),('8902','2013-08-01','13:30:00',7.51),('8902','2013-08-01','13:35:00',7.52),('8902','2013-08-01','13:40:00',7.49),('8902','2013-08-01','13:45:00',7.51),('8902','2013-08-01','13:50:00',7.49),('8902','2013-08-01','13:55:00',7.45),('8902','2013-08-01','14:00:00',7.47),('8902','2013-08-01','14:05:00',7.45),('8902','2013-08-01','14:10:00',7.39),('8902','2013-08-01','14:15:00',7.28),('8902','2013-08-01','14:20:00',7.23),('8902','2013-08-01','14:25:00',7.12),('8902','2013-08-01','14:30:00',7.17),('8902','2013-08-01','14:35:00',7.23),('8902','2013-08-01','14:40:00',7.27),('8902','2013-08-01','14:45:00',7.2),('8902','2013-08-01','14:50:00',7.2),('8902','2013-08-01','14:55:00',7.17),('8902','2013-08-01','15:00:00',7.14),('8902','2013-08-01','15:05:00',7.11),('8902','2013-08-01','15:10:00',6.99),('8902','2013-08-01','15:15:00',6.88),('8902','2013-08-01','15:20:00',6.95),('8902','2013-08-01','15:25:00',6.94),('8902','2013-08-01','15:30:00',6.84),('8902','2013-08-01','15:35:00',6.75),('8902','2013-08-01','15:40:00',6.69),('8902','2013-08-01','15:45:00',6.6),('8902','2013-08-01','15:50:00',6.49),('8902','2013-08-01','15:55:00',6.37),('8902','2013-08-01','16:00:00',6.32),('8902','2013-08-01','16:05:00',6.25),('8902','2013-08-01','16:10:00',6.17),('8902','2013-08-01','16:15:00',6.04),('8902','2013-08-01','16:20:00',5.91),('8902','2013-08-01','16:25:00',4.87),('8902','2013-08-01','16:30:00',5.69),('8902','2013-08-01','16:35:00',5.54),('8902','2013-08-01','16:40:00',5.32),('8902','2013-08-01','16:45:00',5.34),('8902','2013-08-01','16:50:00',5.25),('8902','2013-08-01','16:55:00',5.04),('8902','2013-08-01','17:00:00',4.93),('8902','2013-08-01','17:05:00',4.74),('8902','2013-08-01','17:10:00',4.59),('8902','2013-08-01','17:15:00',4.49),('8902','2013-08-01','17:20:00',4.35),('8902','2013-08-01','17:25:00',4.24),('8902','2013-08-01','17:30:00',4.07),('8902','2013-08-01','17:35:00',3.89),('8902','2013-08-01','17:40:00',3.68),('8902','2013-08-01','17:45:00',3.54),('8902','2013-08-01','17:50:00',3.33),('8902','2013-08-01','17:55:00',3.15),('8902','2013-08-01','18:00:00',3.03),('8902','2013-08-01','18:05:00',2.89),('8902','2013-08-01','18:10:00',2.69),('8902','2013-08-01','18:15:00',2.53),('8902','2013-08-01','18:20:00',2.37),('8902','2013-08-01','18:25:00',2.21),('8902','2013-08-01','18:30:00',2.02),('8902','2013-08-01','18:35:00',1.85),('8902','2013-08-01','18:40:00',1.7),('8902','2013-08-01','18:45:00',1.52),('8902','2013-08-01','18:50:00',1.36),('8902','2013-08-01','18:55:00',1.2),('8902','2013-08-01','19:00:00',1.09),('8902','2013-07-31','07:45:00',1.19),('8902','2013-07-31','07:50:00',1.35),('8902','2013-07-31','07:55:00',1.5),('8902','2013-07-31','08:00:00',1.66),('8902','2013-07-31','08:05:00',1.83),('8902','2013-07-31','08:10:00',1.99),('8902','2013-07-31','08:15:00',2.15),('8902','2013-07-31','08:20:00',2.33),('8902','2013-07-31','08:25:00',2.51),('8902','2013-07-31','08:30:00',2.68),('8902','2013-07-31','08:35:00',2.85),('8902','2013-07-31','08:40:00',3.03),('8902','2013-07-31','08:45:00',3.19),('8902','2013-07-31','08:50:00',3.36),('8902','2013-07-31','08:55:00',3.51),('8902','2013-07-31','09:00:00',3.66),('8902','2013-07-31','09:05:00',3.83),('8902','2013-07-31','09:10:00',3.99),('8902','2013-07-31','09:15:00',4.17),('8902','2013-07-31','09:20:00',4.32),('8902','2013-07-31','09:25:00',4.46),('8902','2013-07-31','09:30:00',4.6),('8902','2013-07-31','09:35:00',4.76),('8902','2013-07-31','09:40:00',4.89),('8902','2013-07-31','09:45:00',5.04),('8902','2013-07-31','09:50:00',5.19),('8902','2013-07-31','09:55:00',5.29),('8902','2013-07-31','10:00:00',5.39),('8902','2013-07-31','10:05:00',5.53),('8902','2013-07-31','10:10:00',5.67),('8902','2013-07-31','10:15:00',5.78),('8902','2013-07-31','10:20:00',5.88),('8902','2013-07-31','10:25:00',5.99),('8902','2013-07-31','10:30:00',6.1),('8902','2013-07-31','10:35:00',6.17),('8902','2013-07-31','10:40:00',6.27),('8902','2013-07-31','10:45:00',6.37),('8902','2013-07-31','10:50:00',6.45),('8902','2013-07-31','10:55:00',6.55),('8902','2013-07-31','11:00:00',6.65),('8902','2013-07-31','11:05:00',6.75),('8902','2013-07-31','11:10:00',6.85),('8902','2013-07-31','11:15:00',6.98),('8902','2013-07-31','11:20:00',7.05),('8902','2013-07-31','11:25:00',7.12),('8902','2013-07-31','11:30:00',7.17),('8902','2013-07-31','11:35:00',7.25),('8902','2013-07-31','11:40:00',7.34),('8902','2013-07-31','11:45:00',7.45),('8902','2013-07-31','11:50:00',7.5),('8902','2013-07-31','11:55:00',7.54),('8902','2013-07-31','12:00:00',7.58),('8902','2013-07-31','12:05:00',7.58),('8902','2013-07-31','12:10:00',7.59),('8902','2013-07-31','12:15:00',7.62),('8902','2013-07-31','12:20:00',7.64),('8902','2013-07-31','12:25:00',7.7),('8902','2013-07-31','12:30:00',7.74),('8902','2013-07-31','12:35:00',7.84),('8902','2013-07-31','12:40:00',7.89),('8902','2013-07-31','12:45:00',7.83),('8902','2013-07-31','12:50:00',7.92),('8902','2013-07-31','12:55:00',7.89),('8902','2013-07-31','13:00:00',7.88),('8902','2013-07-31','13:05:00',7.93),('8902','2013-07-31','13:10:00',7.93),('8902','2013-07-31','13:15:00',7.55),('8902','2013-07-31','13:20:00',8),('8902','2013-07-31','13:25:00',7.99),('8902','2013-07-31','13:30:00',8),('8902','2013-07-31','13:35:00',7.68),('8902','2013-07-31','13:40:00',8.01),('8902','2013-07-31','13:45:00',7.59),('8902','2013-07-31','13:50:00',8.07),('8902','2013-07-31','13:55:00',7.84),('8902','2013-07-31','14:00:00',7.66),('8902','2013-07-31','14:05:00',7.85),('8902','2013-07-31','14:10:00',7.55),('8902','2013-07-31','14:15:00',7.19),('8902','2013-07-31','14:20:00',7.54),('8902','2013-07-31','14:25:00',7.52),('8902','2013-07-31','14:30:00',7.57),('8902','2013-07-31','14:35:00',6),('8902','2013-07-31','14:40:00',7.62),('8902','2013-07-31','14:45:00',7.57),('8902','2013-07-31','14:50:00',7.43),('8902','2013-07-31','14:55:00',7.34),('8902','2013-07-31','15:00:00',7.22),('8902','2013-07-31','15:05:00',7.16),('8902','2013-07-31','15:10:00',7.33),('8902','2013-07-31','15:15:00',5.8),('8902','2013-07-31','15:20:00',4.7),('8902','2013-07-31','15:25:00',7.25),('8902','2013-07-31','15:30:00',7.03),('8902','2013-07-31','15:35:00',7.06),('8902','2013-07-31','15:40:00',4.23),('8902','2013-07-31','15:45:00',6.79),('8902','2013-07-31','15:50:00',6.68),('8902','2013-07-31','15:55:00',6.68),('8902','2013-07-31','16:00:00',6.63),('8902','2013-07-31','16:05:00',6.44),('8902','2013-07-31','16:10:00',6.29),('8902','2013-07-31','16:15:00',6.22),('8902','2013-07-31','16:20:00',6.14),('8902','2013-07-31','16:25:00',6.01),('8902','2013-07-31','16:30:00',5.87),('8902','2013-07-31','16:35:00',5.72),('8902','2013-07-31','16:40:00',5.58),('8902','2013-07-31','16:45:00',5.47),('8902','2013-07-31','16:50:00',5.35),('8902','2013-07-31','16:55:00',5.16),('8902','2013-07-31','17:00:00',4.91),('8902','2013-07-31','17:05:00',4.89),('8902','2013-07-31','17:10:00',4.76),('8902','2013-07-31','17:15:00',4.64),('8902','2013-07-31','17:20:00',4.43),('8902','2013-07-31','17:25:00',4.29),('8902','2013-07-31','17:30:00',4.16),('8902','2013-07-31','17:35:00',4.03),('8902','2013-07-31','17:40:00',3.8),('8902','2013-07-31','17:45:00',3.68),('8902','2013-07-31','17:50:00',3.51),('8902','2013-07-31','17:55:00',3.3),('8902','2013-07-31','18:00:00',3.17),('8902','2013-07-31','18:05:00',3.01),('8902','2013-07-31','18:10:00',2.77),('8902','2013-07-31','18:15:00',2.66),('8902','2013-07-31','18:20:00',2.5),('8902','2013-07-31','18:25:00',2.32),('8902','2013-07-31','18:30:00',2.14),('8902','2013-07-31','18:35:00',1.96),('8902','2013-07-31','18:40:00',1.79),('8902','2013-07-31','18:45:00',1.63),('8902','2013-07-31','18:50:00',1.46),('8902','2013-07-31','18:55:00',1.27),('8902','2013-07-31','19:00:00',1.15),('8902','2013-07-31','19:05:00',1.01),('8902','2013-07-30','07:40:00',1.09),('8902','2013-07-30','07:45:00',1.24),('8902','2013-07-30','07:50:00',1.39),('8902','2013-07-30','07:55:00',1.54),('8902','2013-07-30','08:00:00',1.7),('8902','2013-07-30','08:05:00',1.87),('8902','2013-07-30','08:10:00',2.04),('8902','2013-07-30','08:15:00',2.21),('8902','2013-07-30','08:20:00',2.39),('8902','2013-07-30','08:25:00',2.56),('8902','2013-07-30','08:30:00',2.73),('8902','2013-07-30','08:35:00',2.9),('8902','2013-07-30','08:40:00',3.07),('8902','2013-07-30','08:45:00',3.22),('8902','2013-07-30','08:50:00',3.39),('8902','2013-07-30','08:55:00',3.57),('8902','2013-07-30','09:00:00',3.73),('8902','2013-07-30','09:05:00',3.89),('8902','2013-07-30','09:10:00',4.05),('8902','2013-07-30','09:15:00',4.19),('8902','2013-07-30','09:20:00',4.35),('8902','2013-07-30','09:25:00',4.49),('8902','2013-07-30','09:30:00',4.64),('8902','2013-07-30','09:35:00',4.77),('8902','2013-07-30','09:40:00',4.9),('8902','2013-07-30','09:45:00',5.06),('8902','2013-07-30','09:50:00',5.19),('8902','2013-07-30','09:55:00',5.32),('8902','2013-07-30','10:00:00',5.48),('8902','2013-07-30','10:05:00',5.6),('8902','2013-07-30','10:10:00',5.65),('8902','2013-07-30','10:15:00',5.75),('8902','2013-07-30','10:20:00',5.89),('8902','2013-07-30','10:25:00',6.02),('8902','2013-07-30','10:30:00',6.15),('8902','2013-07-30','10:35:00',6.26),('8902','2013-07-30','10:40:00',6.37),('8902','2013-07-30','10:45:00',6.48),('8902','2013-07-30','10:50:00',6.6),('8902','2013-07-30','10:55:00',6.69),('8902','2013-07-30','11:00:00',6.8),('8902','2013-07-30','11:05:00',6.87),('8902','2013-07-30','11:10:00',6.95),('8902','2013-07-30','11:15:00',7.02),('8902','2013-07-30','11:20:00',7.06),('8902','2013-07-30','11:25:00',7.12),('8902','2013-07-30','11:30:00',7.18),('8902','2013-07-30','11:35:00',7.26),('8902','2013-07-30','11:40:00',7.32),('8902','2013-07-30','11:45:00',7.43),('8902','2013-07-30','11:50:00',7.47),('8902','2013-07-30','11:55:00',7.55),('8902','2013-07-30','12:00:00',7.58),('8902','2013-07-30','12:05:00',7.57),('8902','2013-07-30','12:10:00',7.63),('8902','2013-07-30','12:15:00',7.74),('8902','2013-07-30','12:20:00',7.78),('8902','2013-07-30','12:25:00',7.85),('8902','2013-07-30','12:30:00',7.8),('8902','2013-07-30','12:35:00',7.78),('8902','2013-07-30','12:40:00',7.85),('8902','2013-07-30','12:45:00',7.36),('8902','2013-07-30','12:50:00',6.6),('8902','2013-07-30','12:55:00',8.05),('8902','2013-07-30','13:00:00',2.61),('8902','2013-07-30','13:05:00',8.45),('8902','2013-07-30','13:10:00',8.13),('8902','2013-07-30','13:15:00',8.05),('8902','2013-07-30','13:20:00',7.65),('8902','2013-07-30','13:25:00',6.93),('8902','2013-07-30','13:30:00',7.13),('8902','2013-07-30','13:35:00',7.67),('8902','2013-07-30','13:40:00',7.51),('8902','2013-07-30','13:45:00',7.95),('8902','2013-07-30','13:50:00',6.64),('8902','2013-07-30','13:55:00',5.11),('8902','2013-07-30','14:00:00',5.88),('8902','2013-07-30','14:05:00',8.32),('8902','2013-07-30','14:10:00',8.17),('8902','2013-07-30','14:15:00',8.14),('8902','2013-07-30','14:20:00',8.16),('8902','2013-07-30','14:25:00',7.95),('8902','2013-07-30','14:30:00',7.8),('8902','2013-07-30','14:35:00',7.69),('8902','2013-07-30','14:40:00',7.76),('8902','2013-07-30','14:45:00',7.72),('8902','2013-07-30','14:50:00',4.48),('8902','2013-07-30','14:55:00',2.75),('8902','2013-07-30','15:00:00',3.46),('8902','2013-07-30','15:05:00',7.94),('8902','2013-07-30','15:10:00',7.66),('8902','2013-07-30','15:15:00',5.79),('8902','2013-07-30','15:20:00',7.66),('8902','2013-07-30','15:25:00',6.7),('8902','2013-07-30','15:30:00',7.28),('8902','2013-07-30','15:35:00',6.73),('8902','2013-07-30','15:40:00',4.81),('8902','2013-07-30','15:45:00',6.95),('8902','2013-07-30','15:50:00',6.79),('8902','2013-07-30','15:55:00',6.65),('8902','2013-07-30','16:00:00',6.52),('8902','2013-07-30','16:05:00',6.51),('8902','2013-07-30','16:10:00',6.44),('8902','2013-07-30','16:15:00',6.35),('8902','2013-07-30','16:20:00',6.33),('8902','2013-07-30','16:25:00',5.47),('8902','2013-07-30','16:30:00',4.34),('8902','2013-07-30','16:35:00',2.15),('8902','2013-07-30','16:40:00',5.68),('8902','2013-07-30','16:45:00',5.5),('8902','2013-07-30','16:50:00',5.42),('8902','2013-07-30','16:55:00',5.18),('8902','2013-07-30','17:00:00',5.08),('8902','2013-07-30','17:05:00',4.95),('8902','2013-07-30','17:10:00',4.69),('8902','2013-07-30','17:15:00',3.61),('8902','2013-07-30','17:20:00',4.41),('8902','2013-07-30','17:25:00',4.3),('8902','2013-07-30','17:30:00',4.12),('8902','2013-07-30','17:35:00',3.92),('8902','2013-07-30','17:40:00',3.79),('8902','2013-07-30','17:45:00',3.56),('8902','2013-07-30','17:50:00',3.5),('8902','2013-07-30','17:55:00',3.26),('8902','2013-07-30','18:00:00',3.14),('8902','2013-07-30','18:05:00',3.02),('8902','2013-07-30','18:10:00',2.77),('8902','2013-07-30','18:15:00',2.69),('8902','2013-07-30','18:20:00',2.52),('8902','2013-07-30','18:25:00',2.37),('8902','2013-07-30','18:30:00',2.2),('8902','2013-07-30','18:35:00',2.03),('8902','2013-07-30','18:40:00',1.85),('8902','2013-07-30','18:45:00',1.69),('8902','2013-07-30','18:50:00',1.53),('8902','2013-07-30','18:55:00',1.33),('8902','2013-07-30','19:00:00',1.2),('8902','2013-07-30','19:05:00',1.07),('8902','2014-04-07','07:50:00',1.1),('8902','2014-04-07','07:55:00',1.08),('8902','2014-04-07','08:00:00',1.16),('8902','2014-04-07','08:05:00',1.12),('8902','2014-04-07','08:10:00',1.29),('8902','2014-04-07','08:15:00',2.05),('8902','2014-04-07','08:20:00',2.07),('8902','2014-04-07','08:25:00',1.81),('8902','2014-04-07','08:30:00',1.86),('8902','2014-04-07','08:35:00',2.24),('8902','2014-04-07','08:40:00',2.42),('8902','2014-04-07','08:45:00',2.53),('8902','2014-04-07','08:50:00',2.78),('8902','2014-04-07','08:55:00',2.99),('8902','2014-04-07','09:00:00',3.13),('8902','2014-04-07','09:05:00',3.32),('8902','2014-04-07','09:10:00',3.48),('8902','2014-04-07','09:15:00',3.67),('8902','2014-04-07','09:20:00',3.85),('8902','2014-04-07','09:25:00',4.05),('8902','2014-04-07','09:30:00',4.24),('8902','2014-04-07','09:35:00',4.37),('8902','2014-04-07','09:40:00',4.48),('8902','2014-04-07','09:45:00',4.62),('8902','2014-04-07','09:50:00',4.77),('8902','2014-04-07','09:55:00',4.82),('8902','2014-04-07','10:00:00',4.95),('8902','2014-04-07','10:05:00',5.02),('8902','2014-04-07','10:10:00',5.1),('8902','2014-04-07','10:15:00',5.45),('8902','2014-04-07','10:20:00',5.6),('8902','2014-04-07','10:25:00',5.69),('8902','2014-04-07','10:30:00',5.72),('8902','2014-04-07','10:35:00',5.85),('8902','2014-04-07','10:40:00',6.06),('8902','2014-04-07','10:45:00',6.19),('8902','2014-04-07','10:50:00',6.3),('8902','2014-04-07','10:55:00',6.45),('8902','2014-04-07','11:00:00',6.48),('8902','2014-04-07','11:05:00',6.6),('8902','2014-04-07','11:10:00',6.62),('8902','2014-04-07','11:15:00',6.7),('8902','2014-04-07','11:20:00',6.83),('8902','2014-04-07','11:25:00',6.15),('8902','2014-04-07','11:30:00',6.84),('8902','2014-04-07','11:35:00',6.73),('8902','2014-04-07','11:40:00',6.92),('8902','2014-04-07','11:45:00',7.09),('8902','2014-04-07','11:50:00',7.08),('8902','2014-04-07','11:55:00',7.04),('8902','2014-04-07','12:00:00',7.39),('8902','2014-04-07','12:05:00',7.12),('8902','2014-04-07','12:10:00',6.96),('8902','2014-04-07','12:15:00',6.8),('8902','2014-04-07','12:20:00',6.82),('8902','2014-04-07','12:25:00',6.83),('8902','2014-04-07','12:30:00',7.33),('8902','2014-04-07','12:35:00',7.97),('8902','2014-04-07','12:40:00',6.96),('8902','2014-04-07','12:45:00',6.36),('8902','2014-04-07','12:50:00',7.15),('8902','2014-04-07','12:55:00',7.73),('8902','2014-04-07','13:00:00',7.45),('8902','2014-04-07','13:05:00',7.84),('8902','2014-04-07','13:10:00',8.04),('8902','2014-04-07','13:15:00',8.12),('8902','2014-04-07','13:20:00',8.04),('8902','2014-04-07','13:25:00',7.96),('8902','2014-04-07','13:30:00',8.09),('8902','2014-04-07','13:35:00',8.07),('8902','2014-04-07','13:40:00',8.06),('8902','2014-04-07','13:45:00',7.96),('8902','2014-04-07','13:50:00',8.01),('8902','2014-04-07','13:55:00',8.01),('8902','2014-04-07','14:00:00',8.03),('8902','2014-04-07','14:05:00',8),('8902','2014-04-07','14:10:00',7.96),('8902','2014-04-07','14:15:00',7.97),('8902','2014-04-07','14:20:00',7.6),('8902','2014-04-07','14:25:00',7.75),('8902','2014-04-07','14:30:00',7.85),('8902','2014-04-07','14:35:00',7.43),('8902','2014-04-07','14:40:00',7.04),('8902','2014-04-07','14:45:00',6.48),('8902','2014-04-07','14:50:00',7.55),('8902','2014-04-07','14:55:00',7.63),('8902','2014-04-07','15:00:00',7.5),('8902','2014-04-07','15:05:00',7.28),('8902','2014-04-07','15:10:00',7.28),('8902','2014-04-07','15:15:00',7.23),('8902','2014-04-07','15:20:00',7.08),('8902','2014-04-07','15:25:00',7.04),('8902','2014-04-07','15:30:00',6.93),('8902','2014-04-07','15:35:00',6.78),('8902','2014-04-07','15:40:00',6.74),('8902','2014-04-07','15:45:00',6.32),('8902','2014-04-07','15:50:00',6.43),('8902','2014-04-07','15:55:00',6.38),('8902','2014-04-07','16:00:00',6.18),('8902','2014-04-07','16:05:00',6.06),('8902','2014-04-07','16:10:00',5.82),('8902','2014-04-07','16:15:00',5.46),('8902','2014-04-07','16:20:00',5.08),('8902','2014-04-07','16:25:00',5.42),('8902','2014-04-07','16:30:00',5.53),('8902','2014-04-07','16:35:00',5.55),('8902','2014-04-07','16:40:00',5.16),('8902','2014-04-07','16:45:00',4.78),('8902','2014-04-07','16:50:00',4.94),('8902','2014-04-07','16:55:00',4.56),('8902','2014-04-07','17:00:00',4.18),('8902','2014-04-07','17:05:00',4.37),('8902','2014-04-07','17:10:00',4.13),('8902','2014-04-07','17:15:00',4.05),('8902','2014-04-07','17:20:00',3.91),('8902','2014-04-07','17:25:00',3.61),('8902','2014-04-07','17:30:00',3.37),('8902','2014-04-07','17:35:00',2.9),('8902','2014-04-07','17:40:00',2.91),('8902','2014-04-07','17:45:00',2.74),('8902','2014-04-07','17:50:00',2.64),('8902','2014-04-07','17:55:00',2.32),('8902','2014-04-07','18:00:00',2.24),('8902','2014-04-07','18:05:00',2.15),('8902','2014-04-07','18:10:00',1.9),('8902','2014-04-07','18:15:00',1.81),('8902','2014-04-07','18:20:00',1.56),('8902','2014-04-07','18:25:00',1.27),('8902','2013-07-29','07:30:00',1.21),('8902','2013-07-29','07:35:00',1.2),('8902','2013-07-29','07:40:00',1.19),('8902','2013-07-29','07:55:00',1.4),('8902','2013-07-29','08:00:00',1.73),('8902','2013-07-29','08:05:00',1.94),('8902','2013-07-29','08:10:00',2.08),('8902','2013-07-29','08:15:00',2.25),('8902','2013-07-29','08:20:00',2.57),('8902','2013-07-29','08:25:00',2.76),('8902','2013-07-29','08:30:00',2.79),('8902','2013-07-29','08:35:00',2.87),('8902','2013-07-29','08:40:00',3.01),('8902','2013-07-29','08:45:00',3.16),('8902','2013-07-29','08:50:00',3.32),('8902','2013-07-29','08:55:00',3.47),('8902','2013-07-29','09:00:00',3.74),('8902','2013-07-29','09:05:00',3.93),('8902','2013-07-29','09:10:00',3.92),('8902','2013-07-29','09:15:00',4.12),('8902','2013-07-29','09:20:00',4.48),('8902','2013-07-29','09:25:00',4.71),('8902','2013-07-29','09:30:00',4.82),('8902','2013-07-29','09:35:00',5.08),('8902','2013-07-29','09:40:00',5.31),('8902','2013-07-29','09:45:00',5.42),('8902','2013-07-29','09:50:00',5.58),('8902','2013-07-29','09:55:00',5.63),('8902','2013-07-29','10:00:00',5.63),('8902','2013-07-29','10:05:00',5.75),('8902','2013-07-29','10:10:00',5.93),('8902','2013-07-29','10:15:00',5.95),('8902','2013-07-29','10:20:00',6.12),('8902','2013-07-29','10:25:00',6.06),('8902','2013-07-29','10:30:00',6.13),('8902','2013-07-29','10:35:00',5.12),('8902','2013-07-29','10:40:00',6.26),('8902','2013-07-29','10:45:00',6.45),('8902','2013-07-29','10:50:00',6.48),('8902','2013-07-29','10:55:00',6.48),('8902','2013-07-29','11:00:00',6.64),('8902','2013-07-29','11:05:00',6.81),('8902','2013-07-29','11:10:00',7.02),('8902','2013-07-29','11:15:00',7.12),('8902','2013-07-29','11:20:00',6.48),('8902','2013-07-29','11:25:00',2.09),('8902','2013-07-29','11:30:00',1.63),('8902','2013-07-29','11:35:00',2.64),('8902','2013-07-29','11:40:00',7.54),('8902','2013-07-29','11:45:00',7.48),('8902','2013-07-29','11:50:00',7.37),('8902','2013-07-29','11:55:00',7.28),('8902','2013-07-29','12:00:00',7.41),('8902','2013-07-29','12:05:00',7.44),('8902','2013-07-29','12:10:00',7.45),('8902','2013-07-29','12:15:00',7.45),('8902','2013-07-29','12:20:00',7.32),('8902','2013-07-29','12:25:00',7.36),('8902','2013-07-29','12:30:00',7.61),('8902','2013-07-29','12:35:00',7.76),('8902','2013-07-29','12:40:00',7.8),('8902','2013-07-29','12:45:00',3.02),('8902','2013-07-29','12:50:00',8.07),('8902','2013-07-29','12:55:00',8.27),('8902','2013-07-29','13:00:00',8.22),('8902','2013-07-29','13:05:00',5.19),('8902','2013-07-29','13:10:00',5.34),('8902','2013-07-29','13:15:00',5.25),('8902','2013-07-29','13:20:00',8.22),('8902','2013-07-29','13:25:00',8.19),('8902','2013-07-29','13:30:00',8.25),('8902','2013-07-29','13:35:00',7.91),('8902','2013-07-29','13:40:00',7.13),('8902','2013-07-29','13:45:00',8.02),('8902','2013-07-29','13:50:00',8.11),('8902','2013-07-29','13:55:00',8.33),('8902','2013-07-29','14:00:00',8.06),('8902','2013-07-29','14:05:00',8.19),('8902','2013-07-29','14:10:00',6.92),('8902','2013-07-29','14:15:00',8.16),('8902','2013-07-29','14:20:00',7.69),('8902','2013-07-29','14:25:00',7.7),('8902','2013-07-29','14:30:00',7.74),('8902','2013-07-29','14:35:00',7.64),('8902','2013-07-29','14:40:00',7.41),('8902','2013-07-29','14:45:00',7.41),('8902','2013-07-29','14:50:00',7.49),('8902','2013-07-29','14:55:00',7.45),('8902','2013-07-29','15:00:00',7.24),('8902','2013-07-29','15:05:00',7.07),('8902','2013-07-29','15:10:00',7.04),('8902','2013-07-29','15:15:00',7.05),('8902','2013-07-29','15:20:00',6.82),('8902','2013-07-29','15:25:00',6.67),('8902','2013-07-29','15:30:00',6.76),('8902','2013-07-29','15:35:00',6.72),('8902','2013-07-29','15:40:00',6.65),('8902','2013-07-29','15:45:00',6.56),('8902','2013-07-29','15:50:00',6.51),('8902','2013-07-29','15:55:00',6.42),('8902','2013-07-29','16:00:00',6.31),('8902','2013-07-29','16:05:00',6.18),('8902','2013-07-29','16:10:00',6.09),('8902','2013-07-29','16:15:00',5.99),('8902','2013-07-29','16:20:00',5.97),('8902','2013-07-29','16:25:00',5.83),('8902','2013-07-29','16:30:00',5.68),('8902','2013-07-29','16:35:00',5.58),('8902','2013-07-29','16:40:00',5.45),('8902','2013-07-29','16:45:00',5.34),('8902','2013-07-29','16:50:00',5.24),('8902','2013-07-29','16:55:00',5.03),('8902','2013-07-29','17:00:00',4.91),('8902','2013-07-29','17:05:00',4.81),('8902','2013-07-29','17:10:00',4.63),('8902','2013-07-29','17:15:00',4.49),('8902','2013-07-29','17:20:00',4.36),('8902','2013-07-29','17:25:00',4.22),('8902','2013-07-29','17:30:00',4.05),('8902','2013-07-29','17:35:00',3.93),('8902','2013-07-29','17:40:00',3.75),('8902','2013-07-29','17:45:00',3.59),('8902','2013-07-29','17:50:00',3.39),('8902','2013-07-29','17:55:00',3.13),('8902','2013-07-29','18:00:00',3.02),('8902','2013-07-29','18:05:00',2.86),('8902','2013-07-29','18:10:00',2.69),('8902','2013-07-29','18:15:00',2.53),('8902','2013-07-29','18:20:00',2.4),('8902','2013-07-29','18:25:00',2.24),('8902','2013-07-29','18:30:00',2.03),('8902','2013-07-29','18:35:00',1.82),('8902','2013-07-29','18:40:00',1.71),('8902','2013-07-29','18:45:00',1.56),('8902','2013-07-29','18:50:00',1.39),('8902','2013-07-29','18:55:00',1.21),('8902','2013-07-29','19:00:00',1.11),('8902','2013-07-28','07:40:00',1.02),('8902','2013-07-28','07:45:00',1.23),('8902','2013-07-28','07:50:00',1.36),('8902','2013-07-28','07:55:00',1.5),('8902','2013-07-28','08:00:00',1.64),('8902','2013-07-28','08:05:00',1.79),('8902','2013-07-28','08:10:00',1.92),('8902','2013-07-28','08:15:00',2.05),('8902','2013-07-28','08:20:00',2.19),('8902','2013-07-28','08:25:00',2.34),('8902','2013-07-28','08:30:00',2.46),('8902','2013-07-28','08:35:00',2.59),('8902','2013-07-28','08:40:00',2.74),('8902','2013-07-28','08:45:00',2.87),('8902','2013-07-28','08:50:00',3.01),('8902','2013-07-28','08:55:00',3.17),('8902','2013-07-28','09:00:00',3.3),('8902','2013-07-28','09:05:00',3.48),('8902','2013-07-28','09:10:00',3.63),('8902','2013-07-28','09:15:00',3.75),('8902','2013-07-28','09:20:00',3.91),('8902','2013-07-28','09:25:00',4.02),('8902','2013-07-28','09:30:00',4.16),('8902','2013-07-28','09:35:00',4.33),('8902','2013-07-28','09:40:00',4.5),('8902','2013-07-28','09:45:00',4.63),('8902','2013-07-28','09:50:00',4.72),('8902','2013-07-28','09:55:00',4.88),('8902','2013-07-28','10:00:00',5),('8902','2013-07-28','10:05:00',5.14),('8902','2013-07-28','10:10:00',5.26),('8902','2013-07-28','10:15:00',5.33),('8902','2013-07-28','10:20:00',5.5),('8902','2013-07-28','10:25:00',5.6),('8902','2013-07-28','10:30:00',5.7),('8902','2013-07-28','10:35:00',5.83),('8902','2013-07-28','10:40:00',5.95),('8902','2013-07-28','10:45:00',6.03),('8902','2013-07-28','10:50:00',6.04),('8902','2013-07-28','10:55:00',6.2),('8902','2013-07-28','11:00:00',6.3),('8902','2013-07-28','11:05:00',6.27),('8902','2013-07-28','11:10:00',6.23),('8902','2013-07-28','11:15:00',6.37),('8902','2013-07-28','11:20:00',6.54),('8902','2013-07-28','11:25:00',6.57),('8902','2013-07-28','11:30:00',6.61),('8902','2013-07-28','11:35:00',6.7),('8902','2013-07-28','11:40:00',6.72),('8902','2013-07-28','11:45:00',6.77),('8902','2013-07-28','11:50:00',6.85),('8902','2013-07-28','11:55:00',6.88),('8902','2013-07-28','12:00:00',6.92),('8902','2013-07-28','12:05:00',6.91),('8902','2013-07-28','12:10:00',6.93),('8902','2013-07-28','12:15:00',7),('8902','2013-07-28','12:20:00',7.1),('8902','2013-07-28','12:25:00',7.06),('8902','2013-07-28','12:30:00',7.14),('8902','2013-07-28','12:35:00',7.22),('8902','2013-07-28','12:40:00',7.24),('8902','2013-07-28','12:45:00',7.25),('8902','2013-07-28','12:50:00',7.25),('8902','2013-07-28','12:55:00',7.19),('8902','2013-07-28','13:00:00',7.14),('8902','2013-07-28','13:05:00',7.29),('8902','2013-07-28','13:10:00',7.32),('8902','2013-07-28','13:15:00',7.34),('8902','2013-07-28','13:20:00',7.4),('8902','2013-07-28','13:25:00',7.51),('8902','2013-07-28','13:30:00',7.59),('8902','2013-07-28','13:35:00',7.59),('8902','2013-07-28','13:40:00',7.58),('8902','2013-07-28','13:45:00',7.62),('8902','2013-07-28','13:50:00',7.63),('8902','2013-07-28','13:55:00',7.62),('8902','2013-07-28','14:00:00',7.56),('8902','2013-07-28','14:05:00',7.55),('8902','2013-07-28','14:10:00',7.52),('8902','2013-07-28','14:15:00',7.52),('8902','2013-07-28','14:20:00',7.52),('8902','2013-07-28','14:25:00',7.42),('8902','2013-07-28','14:30:00',7.38),('8902','2013-07-28','14:35:00',7.37),('8902','2013-07-28','14:40:00',7.33),('8902','2013-07-28','14:45:00',7.28),('8902','2013-07-28','14:50:00',7.22),('8902','2013-07-28','14:55:00',7.18),('8902','2013-07-28','15:00:00',7.16),('8902','2013-07-28','15:05:00',7.1),('8902','2013-07-28','15:10:00',7.04),('8902','2013-07-28','15:15:00',7),('8902','2013-07-28','15:20:00',6.85),('8902','2013-07-28','15:25:00',6.81),('8902','2013-07-28','15:30:00',6.77),('8902','2013-07-28','15:35:00',6.69),('8902','2013-07-28','15:40:00',6.72),('8902','2013-07-28','15:45:00',6.82),('8902','2013-07-28','15:50:00',5.84),('8902','2013-07-28','15:55:00',3.93),('8902','2013-07-28','16:00:00',3.31),('8902','2013-07-28','16:05:00',5.25),('8902','2013-07-28','16:10:00',5.7),('8902','2013-07-28','16:15:00',4.92),('8902','2013-07-28','16:20:00',5.07),('8902','2013-07-28','16:25:00',4.44),('8902','2013-07-28','16:30:00',6.13),('8902','2013-07-28','16:35:00',5.54),('8902','2013-07-28','16:40:00',4.12),('8902','2013-07-28','16:45:00',5.83),('8902','2013-07-28','16:50:00',5.48),('8902','2013-07-28','16:55:00',3.58),('8902','2013-07-28','17:00:00',2.62),('8902','2013-07-28','17:05:00',3.41),('8902','2013-07-28','17:10:00',2.87),('8902','2013-07-28','17:15:00',1.8),('8902','2013-07-28','17:20:00',3.95),('8902','2013-07-28','17:25:00',4.22),('8902','2013-07-28','17:30:00',2.73),('8902','2013-07-28','17:35:00',1.67),('8902','2013-07-28','17:40:00',2.2),('8902','2013-07-28','17:45:00',3.71),('8902','2013-07-28','17:50:00',3.45),('8902','2013-07-28','17:55:00',3.06),('8902','2013-07-28','18:00:00',2.44),('8902','2013-07-28','18:05:00',1.65),('8902','2013-07-28','18:10:00',2.23),('8902','2013-07-28','18:15:00',2.03),('8902','2013-07-28','18:20:00',2.42),('8902','2013-07-28','18:25:00',2.19),('8902','2013-07-28','18:30:00',2.09),('8902','2013-07-28','18:35:00',1.78),('8902','2013-07-28','18:40:00',1.31),('8902','2013-07-28','18:55:00',1.02),('8902','2013-07-28','19:00:00',1.34),('8902','2013-07-28','19:05:00',1.3),('8902','2013-07-28','19:10:00',1.06),('8902','2013-07-27','07:40:00',1.01),('8902','2013-07-27','07:45:00',1.2),('8902','2013-07-27','07:50:00',1.33),('8902','2013-07-27','07:55:00',1.46),('8902','2013-07-27','08:00:00',1.6),('8902','2013-07-27','08:05:00',1.75),('8902','2013-07-27','08:10:00',1.91),('8902','2013-07-27','08:15:00',2.05),('8902','2013-07-27','08:20:00',2.21),('8902','2013-07-27','08:25:00',2.35),('8902','2013-07-27','08:30:00',2.53),('8902','2013-07-27','08:35:00',2.68),('8902','2013-07-27','08:40:00',2.83),('8902','2013-07-27','08:45:00',2.98),('8902','2013-07-27','08:50:00',3.11),('8902','2013-07-27','08:55:00',3.28),('8902','2013-07-27','09:00:00',3.43),('8902','2013-07-27','09:05:00',3.6),('8902','2013-07-27','09:10:00',3.74),('8902','2013-07-27','09:15:00',3.88),('8902','2013-07-27','09:20:00',4.02),('8902','2013-07-27','09:25:00',4.15),('8902','2013-07-27','09:30:00',4.33),('8902','2013-07-27','09:35:00',4.48),('8902','2013-07-27','09:40:00',4.5),('8902','2013-07-27','09:45:00',4.65),('8902','2013-07-27','09:50:00',4.75),('8902','2013-07-27','09:55:00',4.91),('8902','2013-07-27','10:00:00',5.04),('8902','2013-07-27','10:05:00',5.12),('8902','2013-07-27','10:10:00',5.29),('8902','2013-07-27','10:15:00',5.34),('8902','2013-07-27','10:20:00',5.43),('8902','2013-07-27','10:25:00',5.5),('8902','2013-07-27','10:30:00',5.59),('8902','2013-07-27','10:35:00',5.78),('8902','2013-07-27','10:40:00',5.87),('8902','2013-07-27','10:45:00',5.96),('8902','2013-07-27','10:50:00',6.03),('8902','2013-07-27','10:55:00',6.16),('8902','2013-07-27','11:00:00',6.3),('8902','2013-07-27','11:05:00',6.35),('8902','2013-07-27','11:10:00',6.41),('8902','2013-07-27','11:15:00',6.43),('8902','2013-07-27','11:20:00',6.46),('8902','2013-07-27','11:25:00',6.53),('8902','2013-07-27','11:30:00',6.6),('8902','2013-07-27','11:35:00',6.6),('8902','2013-07-27','11:40:00',6.69),('8902','2013-07-27','11:45:00',6.75),('8902','2013-07-27','11:50:00',6.74),('8902','2013-07-27','11:55:00',6.87),('8902','2013-07-27','12:00:00',6.95),('8902','2013-07-27','12:05:00',7.08),('8902','2013-07-27','12:10:00',7.04),('8902','2013-07-27','12:15:00',6.96),('8902','2013-07-27','12:20:00',7),('8902','2013-07-27','12:25:00',7.03),('8902','2013-07-27','12:30:00',7.13),('8902','2013-07-27','12:35:00',7.33),('8902','2013-07-27','12:40:00',7.36),('8902','2013-07-27','12:45:00',7.34),('8902','2013-07-27','12:50:00',7.19),('8902','2013-07-27','12:55:00',7.17),('8902','2013-07-27','13:00:00',7.25),('8902','2013-07-27','13:05:00',7.11),('8902','2013-07-27','13:10:00',7.23),('8902','2013-07-27','13:15:00',7.54),('8902','2013-07-27','13:20:00',7.59),('8902','2013-07-27','13:25:00',7.41),('8902','2013-07-27','13:30:00',7.47),('8902','2013-07-27','13:35:00',7.6),('8902','2013-07-27','13:40:00',7.59),('8902','2013-07-27','13:45:00',7.49),('8902','2013-07-27','13:50:00',7.56),('8902','2013-07-27','13:55:00',7.48),('8902','2013-07-27','14:00:00',7.43),('8902','2013-07-27','14:05:00',7.42),('8902','2013-07-27','14:10:00',7.38),('8902','2013-07-27','14:15:00',7.37),('8902','2013-07-27','14:20:00',7.35),('8902','2013-07-27','14:25:00',7.3),('8902','2013-07-27','14:30:00',7.25),('8902','2013-07-27','14:35:00',7.2),('8902','2013-07-27','14:40:00',7.2),('8902','2013-07-27','14:45:00',7.16),('8902','2013-07-27','14:50:00',7.1),('8902','2013-07-27','14:55:00',7.04),('8902','2013-07-27','15:00:00',6.91),('8902','2013-07-27','15:05:00',6.87),('8902','2013-07-27','15:10:00',6.88),('8902','2013-07-27','15:15:00',6.85),('8902','2013-07-27','15:20:00',6.7),('8902','2013-07-27','15:25:00',6.63),('8902','2013-07-27','15:30:00',6.59),('8902','2013-07-27','15:35:00',6.46),('8902','2013-07-27','15:40:00',6.42),('8902','2013-07-27','15:45:00',6.43),('8902','2013-07-27','15:50:00',6.33),('8902','2013-07-27','15:55:00',6.22),('8902','2013-07-27','16:00:00',6.19),('8902','2013-07-27','16:05:00',6.15),('8902','2013-07-27','16:10:00',6.09),('8902','2013-07-27','16:15:00',6),('8902','2013-07-27','16:20:00',5.92),('8902','2013-07-27','16:25:00',5.83),('8902','2013-07-27','16:30:00',5.73),('8902','2013-07-27','16:35:00',5.59),('8902','2013-07-27','16:40:00',5.38),('8902','2013-07-27','16:45:00',5.33),('8902','2013-07-27','16:50:00',5.24),('8902','2013-07-27','16:55:00',5.05),('8902','2013-07-27','17:00:00',4.88),('8902','2013-07-27','17:05:00',4.83),('8902','2013-07-27','17:10:00',4.69),('8902','2013-07-27','17:15:00',4.58),('8902','2013-07-27','17:20:00',4.42),('8902','2013-07-27','17:25:00',4.25),('8902','2013-07-27','17:30:00',4.1),('8902','2013-07-27','17:35:00',3.95),('8902','2013-07-27','17:40:00',3.77),('8902','2013-07-27','17:45:00',3.65),('8902','2013-07-27','17:50:00',3.49),('8902','2013-07-27','17:55:00',3.27),('8902','2013-07-27','18:00:00',3.12),('8902','2013-07-27','18:05:00',2.96),('8902','2013-07-27','18:10:00',2.75),('8902','2013-07-27','18:15:00',2.61),('8902','2013-07-27','18:20:00',2.44),('8902','2013-07-27','18:25:00',2.28),('8902','2013-07-27','18:30:00',2.11),('8902','2013-07-27','18:35:00',1.88),('8902','2013-07-27','18:40:00',1.75),('8902','2013-07-27','18:45:00',1.59),('8902','2013-07-27','18:50:00',1.44),('8902','2013-07-27','18:55:00',1.28),('8902','2013-07-27','19:00:00',1.14),('8902','2013-07-27','19:05:00',1.01),('8902','2013-07-26','07:40:00',1.1),('8902','2013-07-26','07:45:00',1.24),('8902','2013-07-26','07:50:00',1.38),('8902','2013-07-26','07:55:00',1.53),('8902','2013-07-26','08:00:00',1.67),('8902','2013-07-26','08:05:00',1.82),('8902','2013-07-26','08:10:00',1.98),('8902','2013-07-26','08:15:00',2.14),('8902','2013-07-26','08:20:00',2.28),('8902','2013-07-26','08:25:00',2.46),('8902','2013-07-26','08:30:00',2.61),('8902','2013-07-26','08:35:00',2.76),('8902','2013-07-26','08:40:00',2.9),('8902','2013-07-26','08:45:00',3.03),('8902','2013-07-26','08:50:00',3.19),('8902','2013-07-26','08:55:00',3.34),('8902','2013-07-26','09:00:00',3.5),('8902','2013-07-26','09:05:00',3.65),('8902','2013-07-26','09:10:00',3.83),('8902','2013-07-26','09:15:00',3.99),('8902','2013-07-26','09:20:00',4.1),('8902','2013-07-26','09:25:00',4.27),('8902','2013-07-26','09:30:00',4.41),('8902','2013-07-26','09:35:00',4.54),('8902','2013-07-26','09:40:00',4.66),('8902','2013-07-26','09:45:00',4.78),('8902','2013-07-26','09:50:00',4.92),('8902','2013-07-26','09:55:00',5.09),('8902','2013-07-26','10:00:00',5.22),('8902','2013-07-26','10:05:00',5.32),('8902','2013-07-26','10:10:00',5.41),('8902','2013-07-26','10:15:00',5.51),('8902','2013-07-26','10:20:00',5.63),('8902','2013-07-26','10:25:00',5.72),('8902','2013-07-26','10:30:00',5.82),('8902','2013-07-26','10:35:00',5.9),('8902','2013-07-26','10:40:00',6.02),('8902','2013-07-26','10:45:00',6.1),('8902','2013-07-26','10:50:00',6.19),('8902','2013-07-26','10:55:00',6.24),('8902','2013-07-26','11:00:00',6.31),('8902','2013-07-26','11:05:00',6.36),('8902','2013-07-26','11:10:00',6.41),('8902','2013-07-26','11:15:00',6.46),('8902','2013-07-26','11:20:00',6.64),('8902','2013-07-26','11:25:00',6.75),('8902','2013-07-26','11:30:00',6.82),('8902','2013-07-26','11:35:00',6.86),('8902','2013-07-26','11:40:00',6.88),('8902','2013-07-26','11:45:00',6.92),('8902','2013-07-26','11:50:00',6.99),('8902','2013-07-26','11:55:00',7.02),('8902','2013-07-26','12:00:00',7.09),('8902','2013-07-26','12:05:00',7.16),('8902','2013-07-26','12:10:00',7.2),('8902','2013-07-26','12:15:00',7.28),('8902','2013-07-26','12:20:00',7.32),('8902','2013-07-26','12:25:00',7.25),('8902','2013-07-26','12:30:00',7.11),('8902','2013-07-26','12:35:00',7.09),('8902','2013-07-26','12:40:00',7.13),('8902','2013-07-26','12:45:00',7.24),('8902','2013-07-26','12:50:00',7.13),('8902','2013-07-26','12:55:00',7.31),('8902','2013-07-26','13:00:00',7.44),('8902','2013-07-26','13:05:00',7.53),('8902','2013-07-26','13:10:00',7.62),('8902','2013-07-26','13:15:00',7.52),('8902','2013-07-26','13:20:00',7.36),('8902','2013-07-26','13:25:00',7.63),('8902','2013-07-26','13:30:00',7.53),('8902','2013-07-26','13:35:00',7.44),('8902','2013-07-26','13:40:00',7.71),('8902','2013-07-26','13:45:00',7.84),('8902','2013-07-26','13:50:00',7.75),('8902','2013-07-26','13:55:00',7.65),('8902','2013-07-26','14:00:00',6.95),('8902','2013-07-26','14:05:00',7.51),('8902','2013-07-26','14:10:00',7.65),('8902','2013-07-26','14:15:00',7.27),('8902','2013-07-26','14:20:00',7.46),('8902','2013-07-26','14:25:00',7.32),('8902','2013-07-26','14:30:00',7.26),('8902','2013-07-26','14:35:00',7.27),('8902','2013-07-26','14:40:00',7.36),('8902','2013-07-26','14:45:00',7.28),('8902','2013-07-26','14:50:00',7.19),('8902','2013-07-26','14:55:00',7.13),('8902','2013-07-26','15:00:00',7.04),('8902','2013-07-26','15:05:00',6.97),('8902','2013-07-26','15:10:00',6.97),('8902','2013-07-26','15:15:00',6.89),('8902','2013-07-26','15:20:00',6.89),('8902','2013-07-26','15:25:00',6.78),('8902','2013-07-26','15:30:00',6.75),('8902','2013-07-26','15:35:00',6.71),('8902','2013-07-26','15:40:00',6.65),('8902','2013-07-26','15:45:00',6.56),('8902','2013-07-26','15:50:00',6.47),('8902','2013-07-26','15:55:00',6.37),('8902','2013-07-26','16:00:00',6.24),('8902','2013-07-26','16:05:00',6.18),('8902','2013-07-26','16:10:00',6.11),('8902','2013-07-26','16:15:00',6.01),('8902','2013-07-26','16:20:00',5.91),('8902','2013-07-26','16:25:00',5.83),('8902','2013-07-26','16:30:00',5.74),('8902','2013-07-26','16:35:00',5.63),('8902','2013-07-26','16:40:00',5.48),('8902','2013-07-26','16:45:00',5.41),('8902','2013-07-26','16:50:00',5.26),('8902','2013-07-26','16:55:00',5.07),('8902','2013-07-26','17:00:00',4.89),('8902','2013-07-26','17:05:00',4.76),('8902','2013-07-26','17:10:00',4.65),('8902','2013-07-26','17:15:00',4.51),('8902','2013-07-26','17:20:00',4.4),('8902','2013-07-26','17:25:00',4.24),('8902','2013-07-26','17:30:00',4.1),('8902','2013-07-26','17:35:00',3.95),('8902','2013-07-26','17:40:00',3.73),('8902','2013-07-26','17:45:00',3.59),('8902','2013-07-26','17:50:00',3.46),('8902','2013-07-26','17:55:00',3.26),('8902','2013-07-26','18:00:00',3.14),('8902','2013-07-26','18:05:00',3.01),('8902','2013-07-26','18:10:00',2.79),('8902','2013-07-26','18:15:00',2.64),('8902','2013-07-26','18:20:00',2.48),('8902','2013-07-26','18:25:00',2.31),('8902','2013-07-26','18:30:00',2.17),('8902','2013-07-26','18:35:00',1.99),('8902','2013-07-26','18:40:00',1.83),('8902','2013-07-26','18:45:00',1.67),('8902','2013-07-26','18:50:00',1.53),('8902','2013-07-26','18:55:00',1.33),('8902','2013-07-26','19:00:00',1.21),('8902','2013-07-26','19:05:00',1.08),('8902','2013-07-25','07:40:00',1.14),('8902','2013-07-25','07:45:00',1.3),('8902','2013-07-25','07:50:00',1.45),('8902','2013-07-25','07:55:00',1.51),('8902','2013-07-25','08:00:00',1.62),('8902','2013-07-25','08:05:00',1.79),('8902','2013-07-25','08:10:00',1.96),('8902','2013-07-25','08:15:00',2.11),('8902','2013-07-25','08:20:00',2.24),('8902','2013-07-25','08:25:00',2.37),('8902','2013-07-25','08:30:00',2.55),('8902','2013-07-25','08:35:00',2.7),('8902','2013-07-25','08:40:00',2.85),('8902','2013-07-25','08:45:00',3),('8902','2013-07-25','08:50:00',3.15),('8902','2013-07-25','08:55:00',3.29),('8902','2013-07-25','09:00:00',3.46),('8902','2013-07-25','09:05:00',3.61),('8902','2013-07-25','09:10:00',3.75),('8902','2013-07-25','09:15:00',3.91),('8902','2013-07-25','09:20:00',3.98),('8902','2013-07-25','09:25:00',4.19),('8902','2013-07-25','09:30:00',4.36),('8902','2013-07-25','09:35:00',4.49),('8902','2013-07-25','09:40:00',4.59),('8902','2013-07-25','09:45:00',4.73),('8902','2013-07-25','09:50:00',4.85),('8902','2013-07-25','09:55:00',4.84),('8902','2013-07-25','10:00:00',5.04),('8902','2013-07-25','10:05:00',5.21),('8902','2013-07-25','10:10:00',5.23),('8902','2013-07-25','10:15:00',5.24),('8902','2013-07-25','10:20:00',5.47),('8902','2013-07-25','10:25:00',5.54),('8902','2013-07-25','10:30:00',5.72),('8902','2013-07-25','10:35:00',5.82),('8902','2013-07-25','10:40:00',5.94),('8902','2013-07-25','10:45:00',6.1),('8902','2013-07-25','10:50:00',6.12),('8902','2013-07-25','10:55:00',6.25),('8902','2013-07-25','11:00:00',6.28),('8902','2013-07-25','11:05:00',6.16),('8902','2013-07-25','11:10:00',5.74),('8902','2013-07-25','11:15:00',6.42),('8902','2013-07-25','11:20:00',6.52),('8902','2013-07-25','11:25:00',6.68),('8902','2013-07-25','11:30:00',6.76),('8902','2013-07-25','11:35:00',6.62),('8902','2013-07-25','11:40:00',4.66),('8902','2013-07-25','11:45:00',6.58),('8902','2013-07-25','11:50:00',7.07),('8902','2013-07-25','11:55:00',7.22),('8902','2013-07-25','12:00:00',7.07),('8902','2013-07-25','12:05:00',5.97),('8902','2013-07-25','12:10:00',3.34),('8902','2013-07-25','12:15:00',6.88),('8902','2013-07-25','12:20:00',3.19),('8902','2013-07-25','12:25:00',7.45),('8902','2013-07-25','12:30:00',6.67),('8902','2013-07-25','12:35:00',3.78),('8902','2013-07-25','12:40:00',7.88),('8902','2013-07-25','12:45:00',4.48),('8902','2013-07-25','12:50:00',4.98),('8902','2013-07-25','12:55:00',8.14),('8902','2013-07-25','13:00:00',4.64),('8902','2013-07-25','13:05:00',2.15),('8902','2013-07-25','13:10:00',2.08),('8902','2013-07-25','13:15:00',2.17),('8902','2013-07-25','13:20:00',3.57),('8902','2013-07-25','13:25:00',7.92),('8902','2013-07-25','13:30:00',8.34),('8902','2013-07-25','13:35:00',7.78),('8902','2013-07-25','13:40:00',7.66),('8902','2013-07-25','13:45:00',7.99),('8902','2013-07-25','13:50:00',7.81),('8902','2013-07-25','13:55:00',6.87),('8902','2013-07-25','14:00:00',7.8),('8902','2013-07-25','14:05:00',7.71),('8902','2013-07-25','14:10:00',7.71),('8902','2013-07-25','14:15:00',7.92),('8902','2013-07-25','14:20:00',7.82),('8902','2013-07-25','14:25:00',7.76),('8902','2013-07-25','14:30:00',7.46),('8902','2013-07-25','14:35:00',7.43),('8902','2013-07-25','14:40:00',7.54),('8902','2013-07-25','14:45:00',7.33),('8902','2013-07-25','14:50:00',7.34),('8902','2013-07-25','14:55:00',7.17),('8902','2013-07-25','15:00:00',7.22),('8902','2013-07-25','15:05:00',7.14),('8902','2013-07-25','15:10:00',7.07),('8902','2013-07-25','15:15:00',7.05),('8902','2013-07-25','15:20:00',6.91),('8902','2013-07-25','15:25:00',6.76),('8902','2013-07-25','15:30:00',6.74),('8902','2013-07-25','15:35:00',6.75),('8902','2013-07-25','15:40:00',6.71),('8902','2013-07-25','15:45:00',6.69),('8902','2013-07-25','15:50:00',6.6),('8902','2013-07-25','15:55:00',6.44),('8902','2013-07-25','16:00:00',6.37),('8902','2013-07-25','16:05:00',6.28),('8902','2013-07-25','16:10:00',6.15),('8902','2013-07-25','16:15:00',6.03),('8902','2013-07-25','16:20:00',5.98),('8902','2013-07-25','16:25:00',5.9),('8902','2013-07-25','16:30:00',5.79),('8902','2013-07-25','16:35:00',5.62),('8902','2013-07-25','16:40:00',5.41),('8902','2013-07-25','16:45:00',5.4),('8902','2013-07-25','16:50:00',5.22),('8902','2013-07-25','16:55:00',5.02),('8902','2013-07-25','17:00:00',4.83),('8902','2013-07-25','17:05:00',4.8),('8902','2013-07-25','17:10:00',4.68),('8902','2013-07-25','17:15:00',4.49),('8902','2013-07-25','17:20:00',4.33),('8902','2013-07-25','17:25:00',4.21),('8902','2013-07-25','17:30:00',3.97),('8902','2013-07-25','17:35:00',3.87),('8902','2013-07-25','17:40:00',3.72),('8902','2013-07-25','17:45:00',3.55),('8902','2013-07-25','17:50:00',3.34),('8902','2013-07-25','17:55:00',3.11),('8902','2013-07-25','18:00:00',2.94),('8902','2013-07-25','18:05:00',2.83),('8902','2013-07-25','18:10:00',2.68),('8902','2013-07-25','18:15:00',2.55),('8902','2013-07-25','18:20:00',2.3),('8902','2013-07-25','18:25:00',2.19),('8902','2013-07-25','18:30:00',2.06),('8902','2013-07-25','18:35:00',1.83),('8902','2013-07-25','18:40:00',1.71),('8902','2013-07-25','18:45:00',1.55),('8902','2013-07-25','18:50:00',1.44),('8902','2013-07-25','18:55:00',1.27),('8902','2013-07-25','19:00:00',1.14),('8902','2013-07-25','19:05:00',1.01),('8902','2013-07-24','07:40:00',1.12),('8902','2013-07-24','07:45:00',1.28),('8902','2013-07-24','07:50:00',1.42),('8902','2013-07-24','07:55:00',1.56),('8902','2013-07-24','08:00:00',1.7),('8902','2013-07-24','08:05:00',1.82),('8902','2013-07-24','08:10:00',1.96),('8902','2013-07-24','08:15:00',2.12),('8902','2013-07-24','08:20:00',2.24),('8902','2013-07-24','08:25:00',2.4),('8902','2013-07-24','08:30:00',2.59),('8902','2013-07-24','08:35:00',2.73),('8902','2013-07-24','08:40:00',2.89),('8902','2013-07-24','08:45:00',3.05),('8902','2013-07-24','08:50:00',3.16),('8902','2013-07-24','08:55:00',3.27),('8902','2013-07-24','09:00:00',3.48),('8902','2013-07-24','09:05:00',3.73),('8902','2013-07-24','09:10:00',3.87),('8902','2013-07-24','09:15:00',4.1),('8902','2013-07-24','09:20:00',4.38),('8902','2013-07-24','09:25:00',3.2),('8902','2013-07-24','09:30:00',2.64),('8902','2013-07-24','09:35:00',2.72),('8902','2013-07-24','09:40:00',4.38),('8902','2013-07-24','09:45:00',5.59),('8902','2013-07-24','09:50:00',3.76),('8902','2013-07-24','09:55:00',1.94),('8902','2013-07-24','10:00:00',1.61),('8902','2013-07-24','10:05:00',1.53),('8902','2013-07-24','10:10:00',1.79),('8902','2013-07-24','10:15:00',2.29),('8902','2013-07-24','10:20:00',6.13),('8902','2013-07-24','10:25:00',6.26),('8902','2013-07-24','10:30:00',6.32),('8902','2013-07-24','10:35:00',6.15),('8902','2013-07-24','10:40:00',5.41),('8902','2013-07-24','10:45:00',5.8),('8902','2013-07-24','10:50:00',4.35),('8902','2013-07-24','10:55:00',5.11),('8902','2013-07-24','11:00:00',3.91),('8902','2013-07-24','11:05:00',3.35),('8902','2013-07-24','11:10:00',4.61),('8902','2013-07-24','11:15:00',7.05),('8902','2013-07-24','11:20:00',6.94),('8902','2013-07-24','11:25:00',7.04),('8902','2013-07-24','11:30:00',6.76),('8902','2013-07-24','11:35:00',6.91),('8902','2013-07-24','11:40:00',6.89),('8902','2013-07-24','11:45:00',6.83),('8902','2013-07-24','11:50:00',6.39),('8902','2013-07-24','11:55:00',2.97),('8902','2013-07-24','12:00:00',6.46),('8902','2013-07-24','12:05:00',7.66),('8902','2013-07-24','12:10:00',3.02),('8902','2013-07-24','12:15:00',4.83),('8902','2013-07-24','12:20:00',4.73),('8902','2013-07-24','12:25:00',3.83),('8902','2013-07-24','12:30:00',2.57),('8902','2013-07-24','12:35:00',5.73),('8902','2013-07-24','12:40:00',2.7),('8902','2013-07-24','12:45:00',2.15),('8902','2013-07-24','12:50:00',2.42),('8902','2013-07-24','12:55:00',2.68),('8902','2013-07-24','13:00:00',2.28),('8902','2013-07-24','13:05:00',5.94),('8902','2013-07-24','13:10:00',5.18),('8902','2013-07-24','13:15:00',5.99),('8902','2013-07-24','13:20:00',8.05),('8902','2013-07-24','13:25:00',8.02),('8902','2013-07-24','13:30:00',8.16),('8902','2013-07-24','13:35:00',7.91),('8902','2013-07-24','13:40:00',7.83),('8902','2013-07-24','13:45:00',7.72),('8902','2013-07-24','13:50:00',7.82),('8902','2013-07-24','13:55:00',7.74),('8902','2013-07-24','14:00:00',7.72),('8902','2013-07-24','14:05:00',7.73),('8902','2013-07-24','14:10:00',7.84),('8902','2013-07-24','14:15:00',7.85),('8902','2013-07-24','14:20:00',7.87),('8902','2013-07-24','14:25:00',7.85),('8902','2013-07-24','14:30:00',7.76),('8902','2013-07-24','14:35:00',7.72),('8902','2013-07-24','14:40:00',7.63),('8902','2013-07-24','14:45:00',7.62),('8902','2013-07-24','14:50:00',7.6),('8902','2013-07-24','14:55:00',7.6),('8902','2013-07-24','15:00:00',7.52),('8902','2013-07-24','15:05:00',7.46),('8902','2013-07-24','15:10:00',7.36),('8902','2013-07-24','15:15:00',7.24),('8902','2013-07-24','15:20:00',7.18),('8902','2013-07-24','15:25:00',7.13),('8902','2013-07-24','15:30:00',7.1),('8902','2013-07-24','15:35:00',7.02),('8902','2013-07-24','15:40:00',6.96),('8902','2013-07-24','15:45:00',6.92),('8902','2013-07-24','15:50:00',6.78),('8902','2013-07-24','15:55:00',6.65),('8902','2013-07-24','16:00:00',6.61),('8902','2013-07-24','16:05:00',6.54),('8902','2013-07-24','16:10:00',6.43),('8902','2013-07-24','16:15:00',6.33),('8902','2013-07-24','16:20:00',6.22),('8902','2013-07-24','16:25:00',6.09),('8902','2013-07-24','16:30:00',5.96),('8902','2013-07-24','16:35:00',5.77),('8902','2013-07-24','16:40:00',5.62),('8902','2013-07-24','16:45:00',5.61),('8902','2013-07-24','16:50:00',5.49),('8902','2013-07-24','16:55:00',5.3),('8902','2013-07-24','17:00:00',5.1),('8902','2013-07-24','17:05:00',5.08),('8902','2013-07-24','17:10:00',4.87),('8902','2013-07-24','17:15:00',4.78),('8902','2013-07-24','17:20:00',4.62),('8902','2013-07-24','17:25:00',4.41),('8902','2013-07-24','17:30:00',4.33),('8902','2013-07-24','17:35:00',4.19),('8902','2013-07-24','17:40:00',3.99),('8902','2013-07-24','17:45:00',3.86),('8902','2013-07-24','17:50:00',3.64),('8902','2013-07-24','17:55:00',3.42),('8902','2013-07-24','18:00:00',3.29),('8902','2013-07-24','18:05:00',3.16),('8902','2013-07-24','18:10:00',2.96),('8902','2013-07-24','18:15:00',2.72),('8902','2013-07-24','18:20:00',2.55),('8902','2013-07-24','18:25:00',2.38),('8902','2013-07-24','18:30:00',2.22),('8902','2013-07-24','18:35:00',1.98),('8902','2013-07-24','18:40:00',1.89),('8902','2013-07-24','18:45:00',1.7),('8902','2013-07-24','18:50:00',1.55),('8902','2013-07-24','18:55:00',1.34),('8902','2013-07-24','19:00:00',1.23),('8902','2013-07-24','19:05:00',1.04),('8902','2013-07-23','07:45:00',1.07),('8902','2013-07-23','07:50:00',1.31),('8902','2013-07-23','07:55:00',1.64),('8902','2013-07-23','08:00:00',1.68),('8902','2013-07-23','08:05:00',1.57),('8902','2013-07-23','08:10:00',1.6),('8902','2013-07-23','08:15:00',1.46),('8902','2013-07-23','08:20:00',2.4),('8902','2013-07-23','08:25:00',2.24),('8902','2013-07-23','08:30:00',3.09),('8902','2013-07-23','08:35:00',1.92),('8902','2013-07-23','08:40:00',2.2),('8902','2013-07-23','08:45:00',2.59),('8902','2013-07-23','08:50:00',3.2),('8902','2013-07-23','08:55:00',2.98),('8902','2013-07-23','09:00:00',2.62),('8902','2013-07-23','09:30:00',2.29),('8902','2013-07-23','09:35:00',4.7),('8902','2013-07-23','09:40:00',4.22),('8902','2013-07-23','09:45:00',3.56),('8902','2013-07-23','09:50:00',2.73),('8902','2013-07-23','09:55:00',2.4),('8902','2013-07-23','10:00:00',2.11),('8902','2013-07-23','10:05:00',2.67),('8902','2013-07-23','10:10:00',2.1),('8902','2013-07-23','10:15:00',2.27),('8902','2013-07-23','10:20:00',2.05),('8902','2013-07-23','10:25:00',3.51),('8902','2013-07-23','10:30:00',5.87),('8902','2013-07-23','10:35:00',6.11),('8902','2013-07-23','10:40:00',6.66),('8902','2013-07-23','10:45:00',7.07),('8902','2013-07-23','10:50:00',3.29),('8902','2013-07-23','10:55:00',4.91),('8902','2013-07-23','11:00:00',5.64),('8902','2013-07-23','11:05:00',4.26),('8902','2013-07-23','11:10:00',7.04),('8902','2013-07-23','11:15:00',6.11),('8902','2013-07-23','11:20:00',4.56),('8902','2013-07-23','11:25:00',6.51),('8902','2013-07-23','11:30:00',7.28),('8902','2013-07-23','11:35:00',7.41),('8902','2013-07-23','11:40:00',7.29),('8902','2013-07-23','11:45:00',7.22),('8902','2013-07-23','11:50:00',7.11),('8902','2013-07-23','11:55:00',7.37),('8902','2013-07-23','12:00:00',7.65),('8902','2013-07-23','12:05:00',6.58),('8902','2013-07-23','12:10:00',3.11),('8902','2013-07-23','12:15:00',4.11),('8902','2013-07-23','12:20:00',6.66),('8902','2013-07-23','12:25:00',4.47),('8902','2013-07-23','12:30:00',2.35),('8902','2013-07-23','12:35:00',1.99),('8902','2013-07-23','12:40:00',2.08),('8902','2013-07-23','12:45:00',3.88),('8902','2013-07-23','12:50:00',4.48),('8902','2013-07-23','12:55:00',2.39),('8902','2013-07-23','13:00:00',3.8),('8902','2013-07-23','13:05:00',8.67),('8902','2013-07-23','13:10:00',8.34),('8902','2013-07-23','13:15:00',8.05),('8902','2013-07-23','13:20:00',4.41),('8902','2013-07-23','13:25:00',1.54),('8902','2013-07-23','13:30:00',1.42),('8902','2013-07-23','13:35:00',5.11),('8902','2013-07-23','13:40:00',2.25),('8902','2013-07-23','13:45:00',2.3),('8902','2013-07-23','13:50:00',2.34),('8902','2013-07-23','13:55:00',8.01),('8902','2013-07-23','14:00:00',4.54),('8902','2013-07-23','14:05:00',8.09),('8902','2013-07-23','14:10:00',4.72),('8902','2013-07-23','14:15:00',8.55),('8902','2013-07-23','14:20:00',7.44),('8902','2013-07-23','14:25:00',6.52),('8902','2013-07-23','14:30:00',7.27),('8902','2013-07-23','14:35:00',5.9),('8902','2013-07-23','14:40:00',7.87),('8902','2013-07-23','14:45:00',8.1),('8902','2013-07-23','14:50:00',8),('8902','2013-07-23','14:55:00',7.87),('8902','2013-07-23','15:00:00',7.71),('8902','2013-07-23','15:05:00',7.69),('8902','2013-07-23','15:10:00',7.51),('8902','2013-07-23','15:15:00',7.48),('8902','2013-07-23','15:20:00',7.45),('8902','2013-07-23','15:25:00',7.38),('8902','2013-07-23','15:30:00',6.94),('8902','2013-07-23','15:35:00',6.75),('8902','2013-07-23','15:40:00',7.04),('8902','2013-07-23','15:45:00',6.83),('8902','2013-07-23','15:50:00',6.67),('8902','2013-07-23','15:55:00',6.65),('8902','2013-07-23','16:00:00',6.66),('8902','2013-07-23','16:05:00',6.49),('8902','2013-07-23','16:10:00',6.3),('8902','2013-07-23','16:15:00',6.36),('8902','2013-07-23','16:20:00',6.47),('8902','2013-07-23','16:25:00',6.35),('8902','2013-07-23','16:30:00',6.21),('8902','2013-07-23','16:35:00',6.03),('8902','2013-07-23','16:40:00',5.8),('8902','2013-07-23','16:45:00',5.71),('8902','2013-07-23','16:50:00',5.53),('8902','2013-07-23','16:55:00',5.67),('8902','2013-07-23','17:00:00',5.56),('8902','2013-07-23','17:05:00',5.21),('8902','2013-07-23','17:10:00',3.54),('8902','2013-07-23','17:15:00',4.61),('8902','2013-07-23','17:20:00',4.83),('8902','2013-07-23','17:25:00',4.55),('8902','2013-07-23','17:30:00',4.39),('8902','2013-07-23','17:35:00',4.2),('8902','2013-07-23','17:40:00',3.97),('8902','2013-07-23','17:45:00',3.81),('8902','2013-07-23','17:50:00',3.59),('8902','2013-07-23','17:55:00',3.39),('8902','2013-07-23','18:00:00',3.2),('8902','2013-07-23','18:05:00',3.01),('8902','2013-07-23','18:10:00',2.83),('8902','2013-07-23','18:15:00',2.65),('8902','2013-07-23','18:20:00',2.34),('8902','2013-07-23','18:25:00',2.36),('8902','2013-07-23','18:30:00',2.26),('8902','2013-07-23','18:35:00',2.06),('8902','2013-07-23','18:40:00',1.91),('8902','2013-07-23','18:45:00',1.72),('8902','2013-07-23','18:50:00',1.48),('8902','2013-07-23','18:55:00',1.25),('8902','2013-07-23','19:05:00',1.06),('8902','2013-07-22','07:40:00',1.22),('8902','2013-07-22','07:45:00',1.33),('8902','2013-07-22','07:50:00',1.46),('8902','2013-07-22','07:55:00',1.69),('8902','2013-07-22','08:00:00',1.85),('8902','2013-07-22','08:05:00',2.03),('8902','2013-07-22','08:10:00',2.18),('8902','2013-07-22','08:15:00',2.34),('8902','2013-07-22','08:20:00',2.49),('8902','2013-07-22','08:25:00',2.65),('8902','2013-07-22','08:30:00',2.8),('8902','2013-07-22','08:35:00',2.95),('8902','2013-07-22','08:40:00',3.12),('8902','2013-07-22','08:45:00',3.3),('8902','2013-07-22','08:50:00',3.46),('8902','2013-07-22','08:55:00',3.62),('8902','2013-07-22','09:00:00',3.77),('8902','2013-07-22','09:05:00',3.96),('8902','2013-07-22','09:10:00',4.08),('8902','2013-07-22','09:15:00',4.21),('8902','2013-07-22','09:20:00',4.31),('8902','2013-07-22','09:25:00',4.42),('8902','2013-07-22','09:30:00',4.53),('8902','2013-07-22','09:35:00',4.68),('8902','2013-07-22','09:40:00',4.77),('8902','2013-07-22','09:45:00',4.88),('8902','2013-07-22','09:50:00',5.01),('8902','2013-07-22','09:55:00',5.08),('8902','2013-07-22','10:00:00',5.25),('8902','2013-07-22','10:05:00',5.39),('8902','2013-07-22','10:10:00',5.48),('8902','2013-07-22','10:15:00',5.6),('8902','2013-07-22','10:20:00',5.66),('8902','2013-07-22','10:25:00',5.84),('8902','2013-07-22','10:30:00',6.13),('8902','2013-07-22','10:35:00',6.18),('8902','2013-07-22','10:40:00',6.33),('8902','2013-07-22','10:45:00',6.32),('8902','2013-07-22','10:50:00',6.38),('8902','2013-07-22','10:55:00',6.49),('8902','2013-07-22','11:00:00',6.61),('8902','2013-07-22','11:05:00',6.67),('8902','2013-07-22','11:10:00',6.78),('8902','2013-07-22','11:15:00',6.9),('8902','2013-07-22','11:20:00',6.99),('8902','2013-07-22','11:25:00',6.99),('8902','2013-07-22','11:30:00',7.06),('8902','2013-07-22','11:35:00',7.1),('8902','2013-07-22','11:40:00',7.13),('8902','2013-07-22','11:45:00',7.12),('8902','2013-07-22','11:50:00',7.2),('8902','2013-07-22','11:55:00',7.29),('8902','2013-07-22','12:00:00',7.4),('8902','2013-07-22','12:05:00',7.4),('8902','2013-07-22','12:10:00',7.51),('8902','2013-07-22','12:15:00',7.58),('8902','2013-07-22','12:20:00',7.59),('8902','2013-07-22','12:25:00',7.66),('8902','2013-07-22','12:30:00',7.74),('8902','2013-07-22','12:35:00',7.63),('8902','2013-07-22','12:40:00',7.66),('8902','2013-07-22','12:45:00',7.73),('8902','2013-07-22','12:50:00',5.49),('8902','2013-07-22','12:55:00',5.79),('8902','2013-07-22','13:00:00',5.91),('8902','2013-07-22','13:05:00',2.59),('8902','2013-07-22','13:10:00',3.98),('8902','2013-07-22','13:15:00',3.68),('8902','2013-07-22','13:20:00',2.28),('8902','2013-07-22','13:25:00',1.9),('8902','2013-07-22','13:30:00',5.51),('8902','2013-07-22','13:35:00',8.41),('8902','2013-07-22','13:40:00',8.01),('8902','2013-07-22','13:45:00',7.55),('8902','2013-07-22','13:50:00',7.69),('8902','2013-07-22','13:55:00',6.67),('8902','2013-07-22','14:00:00',8.37),('8902','2013-07-22','14:05:00',4.57),('8902','2013-07-22','14:10:00',1.13),('8902','2013-07-22','14:35:00',1.49),('8902','2013-07-22','14:40:00',6.32),('8902','2013-07-22','14:45:00',6.51),('8902','2013-07-22','14:50:00',6.75),('8902','2013-07-22','14:55:00',7.33),('8902','2013-07-22','15:00:00',8.6),('8902','2013-07-22','15:05:00',8.46),('8902','2013-07-22','15:10:00',7.63),('8902','2013-07-22','15:15:00',6.95),('8902','2013-07-22','15:20:00',7.48),('8902','2013-07-22','15:25:00',7.11),('8902','2013-07-22','15:30:00',7.03),('8902','2013-07-22','15:35:00',6.86),('8902','2013-07-22','15:40:00',7.04),('8902','2013-07-22','15:45:00',6.81),('8902','2013-07-22','15:50:00',6.78),('8902','2013-07-22','15:55:00',6.74),('8902','2013-07-22','16:00:00',6.54),('8902','2013-07-22','16:05:00',6.38),('8902','2013-07-22','16:10:00',6.34),('8902','2013-07-22','16:15:00',6.17),('8902','2013-07-22','16:20:00',6.17),('8902','2013-07-22','16:25:00',6.09),('8902','2013-07-22','16:30:00',5.96),('8902','2013-07-22','16:35:00',5.76),('8902','2013-07-22','16:40:00',5.56),('8902','2013-07-22','16:45:00',5.46),('8902','2013-07-22','16:50:00',5.33),('8902','2013-07-22','16:55:00',5.15),('8902','2013-07-22','17:00:00',5.01),('8902','2013-07-22','17:05:00',4.92),('8902','2013-07-22','17:10:00',4.86),('8902','2013-07-22','17:15:00',4.74),('8902','2013-07-22','17:20:00',4.62),('8902','2013-07-22','17:25:00',4.47),('8902','2013-07-22','17:30:00',4.33),('8902','2013-07-22','17:35:00',4.19),('8902','2013-07-22','17:40:00',4.01),('8902','2013-07-22','17:45:00',3.84),('8902','2013-07-22','17:50:00',3.72),('8902','2013-07-22','17:55:00',3.53),('8902','2013-07-22','18:00:00',3.37),('8902','2013-07-22','18:05:00',3.2),('8902','2013-07-22','18:10:00',3.04),('8902','2013-07-22','18:15:00',2.9),('8902','2013-07-22','18:20:00',2.73),('8902','2013-07-22','18:25:00',2.52),('8902','2013-07-22','18:30:00',2.37),('8902','2013-07-22','18:35:00',2.05),('8902','2013-07-22','18:40:00',1.6),('8902','2013-07-22','18:45:00',1.43),('8902','2013-07-22','18:50:00',1.19),('8902','2013-07-22','18:55:00',1.33),('8902','2013-07-22','19:00:00',1.26),('8902','2013-07-22','19:05:00',1.1),('8902','2013-07-21','07:35:00',1.05),('8902','2013-07-21','07:40:00',1.25),('8902','2013-07-21','07:45:00',1.39),('8902','2013-07-21','07:50:00',1.53),('8902','2013-07-21','07:55:00',1.68),('8902','2013-07-21','08:00:00',1.83),('8902','2013-07-21','08:05:00',1.99),('8902','2013-07-21','08:10:00',2.14),('8902','2013-07-21','08:15:00',2.3),('8902','2013-07-21','08:20:00',2.47),('8902','2013-07-21','08:25:00',2.62),('8902','2013-07-21','08:30:00',2.78),('8902','2013-07-21','08:35:00',2.94),('8902','2013-07-21','08:40:00',3.11),('8902','2013-07-21','08:45:00',3.28),('8902','2013-07-21','08:50:00',3.43),('8902','2013-07-21','08:55:00',3.59),('8902','2013-07-21','09:00:00',3.76),('8902','2013-07-21','09:05:00',3.9),('8902','2013-07-21','09:10:00',4.05),('8902','2013-07-21','09:15:00',4.18),('8902','2013-07-21','09:20:00',4.34),('8902','2013-07-21','09:25:00',4.45),('8902','2013-07-21','09:30:00',4.58),('8902','2013-07-21','09:35:00',4.72),('8902','2013-07-21','09:40:00',4.86),('8902','2013-07-21','09:45:00',5.02),('8902','2013-07-21','09:50:00',5.15),('8902','2013-07-21','09:55:00',5.29),('8902','2013-07-21','10:00:00',5.39),('8902','2013-07-21','10:05:00',5.5),('8902','2013-07-21','10:10:00',5.62),('8902','2013-07-21','10:15:00',5.73),('8902','2013-07-21','10:20:00',5.84),('8902','2013-07-21','10:25:00',5.92),('8902','2013-07-21','10:30:00',6.02),('8902','2013-07-21','10:35:00',6.12),('8902','2013-07-21','10:40:00',6.21),('8902','2013-07-21','10:45:00',6.28),('8902','2013-07-21','10:50:00',6.36),('8902','2013-07-21','10:55:00',6.48),('8902','2013-07-21','11:00:00',6.58),('8902','2013-07-21','11:05:00',6.65),('8902','2013-07-21','11:10:00',6.73),('8902','2013-07-21','11:15:00',6.71),('8902','2013-07-21','11:20:00',6.74),('8902','2013-07-21','11:25:00',6.86),('8902','2013-07-21','11:30:00',6.96),('8902','2013-07-21','11:35:00',7.01),('8902','2013-07-21','11:40:00',7.09),('8902','2013-07-21','11:45:00',7.13),('8902','2013-07-21','11:50:00',7.18),('8902','2013-07-21','11:55:00',7.17),('8902','2013-07-21','12:00:00',7.25),('8902','2013-07-21','12:05:00',7.28),('8902','2013-07-21','12:10:00',7.35),('8902','2013-07-21','12:15:00',7.38),('8902','2013-07-21','12:20:00',7.39),('8902','2013-07-21','12:25:00',7.43),('8902','2013-07-21','12:30:00',7.52),('8902','2013-07-21','12:35:00',7.56),('8902','2013-07-21','12:40:00',7.51),('8902','2013-07-21','12:45:00',7.53),('8902','2013-07-21','12:50:00',7.61),('8902','2013-07-21','12:55:00',7.7),('8902','2013-07-21','13:00:00',7.71),('8902','2013-07-21','13:05:00',7.75),('8902','2013-07-21','13:10:00',7.72),('8902','2013-07-21','13:15:00',7.66),('8902','2013-07-21','13:20:00',7.71),('8902','2013-07-21','13:25:00',7.65),('8902','2013-07-21','13:30:00',7.62),('8902','2013-07-21','13:35:00',7.59),('8902','2013-07-21','13:40:00',7.78),('8902','2013-07-21','13:45:00',7.7),('8902','2013-07-21','13:50:00',7.68),('8902','2013-07-21','13:55:00',7.6),('8902','2013-07-21','14:00:00',7.57),('8902','2013-07-21','14:05:00',7.6),('8902','2013-07-21','14:10:00',7.53),('8902','2013-07-21','14:15:00',7.56),('8902','2013-07-21','14:20:00',7.55),('8902','2013-07-21','14:25:00',7.5),('8902','2013-07-21','14:30:00',7.49),('8902','2013-07-21','14:35:00',7.5),('8902','2013-07-21','14:45:00',7.35),('8902','2013-07-21','14:50:00',7.31),('8902','2013-07-21','14:55:00',7.23),('8902','2013-07-21','15:00:00',6.55),('8902','2013-07-21','15:05:00',7.28),('8902','2013-07-21','15:10:00',7.18),('8902','2013-07-21','15:15:00',7.12),('8902','2013-07-21','15:20:00',6.91),('8902','2013-07-21','15:25:00',7.04),('8902','2013-07-21','15:30:00',6.99),('8902','2013-07-21','15:35:00',4.52),('8902','2013-07-21','15:40:00',5.77),('8902','2013-07-21','15:45:00',7.09),('8902','2013-07-21','15:50:00',6.96),('8902','2013-07-21','15:55:00',6.61),('8902','2013-07-21','16:00:00',5.69),('8902','2013-07-21','16:05:00',4.25),('8902','2013-07-21','16:10:00',3.53),('8902','2013-07-21','16:15:00',2.34),('8902','2013-07-21','16:20:00',6.19),('8902','2013-07-21','16:25:00',6.71),('8902','2013-07-21','16:30:00',6.24),('8902','2013-07-21','16:35:00',5.88),('8902','2013-07-21','16:40:00',5.5),('8902','2013-07-21','16:45:00',5.46),('8902','2013-07-21','16:50:00',5.32),('8902','2013-07-21','16:55:00',5.21),('8902','2013-07-21','17:00:00',4.97),('8902','2013-07-21','17:05:00',4.98),('8902','2013-07-21','17:10:00',4.85),('8902','2013-07-21','17:15:00',4.71),('8902','2013-07-21','17:20:00',4.52),('8902','2013-07-21','17:25:00',4.19),('8902','2013-07-21','17:30:00',4.12),('8902','2013-07-21','17:35:00',4.14),('8902','2013-07-21','17:40:00',3.73),('8902','2013-07-21','17:45:00',3.46),('8902','2013-07-21','17:50:00',3.44),('8902','2013-07-21','17:55:00',3.26),('8902','2013-07-21','18:00:00',3.19),('8902','2013-07-21','18:05:00',3),('8902','2013-07-21','18:10:00',2.76),('8902','2013-07-21','18:15:00',2.56),('8902','2013-07-21','18:20:00',2.45),('8902','2013-07-21','18:25:00',2.25),('8902','2013-07-21','18:30:00',2.14),('8902','2013-07-21','18:35:00',1.92),('8902','2013-07-21','18:40:00',1.73),('8902','2013-07-21','18:45:00',1.63),('8902','2013-07-21','18:50:00',1.48),('8902','2013-07-21','18:55:00',1.28),('8902','2013-07-21','19:05:00',1.08),('8902','2013-07-20','07:35:00',1.09),('8902','2013-07-20','07:40:00',1.24),('8902','2013-07-20','07:45:00',1.42),('8902','2013-07-20','07:50:00',1.51),('8902','2013-07-20','07:55:00',1.58),('8902','2013-07-20','08:00:00',1.73),('8902','2013-07-20','08:05:00',1.84),('8902','2013-07-20','08:10:00',2.04),('8902','2013-07-20','08:15:00',2.2),('8902','2013-07-20','08:20:00',2.33),('8902','2013-07-20','08:25:00',2.5),('8902','2013-07-20','08:30:00',2.67),('8902','2013-07-20','08:35:00',2.82),('8902','2013-07-20','08:40:00',2.95),('8902','2013-07-20','08:45:00',3.08),('8902','2013-07-20','08:50:00',3.23),('8902','2013-07-20','08:55:00',3.41),('8902','2013-07-20','09:00:00',3.59),('8902','2013-07-20','09:05:00',3.72),('8902','2013-07-20','09:10:00',3.88),('8902','2013-07-20','09:15:00',4.03),('8902','2013-07-20','09:20:00',4.16),('8902','2013-07-20','09:25:00',4.29),('8902','2013-07-20','09:30:00',4.41),('8902','2013-07-20','09:35:00',4.55),('8902','2013-07-20','09:40:00',4.69),('8902','2013-07-20','09:45:00',4.8),('8902','2013-07-20','09:50:00',4.92),('8902','2013-07-20','09:55:00',5.04),('8902','2013-07-20','10:00:00',5.19),('8902','2013-07-20','10:05:00',5.33),('8902','2013-07-20','10:10:00',5.42),('8902','2013-07-20','10:15:00',5.51),('8902','2013-07-20','10:20:00',5.6),('8902','2013-07-20','10:25:00',5.7),('8902','2013-07-20','10:30:00',5.79),('8902','2013-07-20','10:35:00',5.93),('8902','2013-07-20','10:40:00',6.06),('8902','2013-07-20','10:45:00',6.14),('8902','2013-07-20','10:50:00',6.24),('8902','2013-07-20','10:55:00',6.33),('8902','2013-07-20','11:00:00',6.42),('8902','2013-07-20','11:05:00',6.47),('8902','2013-07-20','11:10:00',6.51),('8902','2013-07-20','11:15:00',6.63),('8902','2013-07-20','11:20:00',6.69),('8902','2013-07-20','11:25:00',6.76),('8902','2013-07-20','11:30:00',6.91),('8902','2013-07-20','11:35:00',6.96),('8902','2013-07-20','11:40:00',7.25),('8902','2013-07-20','11:45:00',7.28),('8902','2013-07-20','11:50:00',7.11),('8902','2013-07-20','11:55:00',7.15),('8902','2013-07-20','12:00:00',7.21),('8902','2013-07-20','12:05:00',7.29),('8902','2013-07-20','12:10:00',7.45),('8902','2013-07-20','12:15:00',7.7),('8902','2013-07-20','12:20:00',7.92),('8902','2013-07-20','12:25:00',8.02),('8902','2013-07-20','12:30:00',8.27),('8902','2013-07-20','12:35:00',8.55),('8902','2013-07-20','12:40:00',8.78),('8902','2013-07-20','12:45:00',7.62),('8902','2013-07-20','12:50:00',7.34),('8902','2013-07-20','12:55:00',7.42),('8902','2013-07-20','13:00:00',8.04),('8902','2013-07-20','13:05:00',8.28),('8902','2013-07-20','13:10:00',8.96),('8902','2013-07-20','13:15:00',8.8),('8902','2013-07-20','13:20:00',7.9),('8902','2013-07-20','13:25:00',8.41),('8902','2013-07-20','13:30:00',8.04),('8902','2013-07-20','13:35:00',6.7),('8902','2013-07-20','13:40:00',5.55),('8902','2013-07-20','13:45:00',1.85),('8902','2013-07-20','13:50:00',1.72),('8902','2013-07-20','13:55:00',1.51),('8902','2013-07-20','14:00:00',1.57),('8902','2013-07-20','14:05:00',1.64),('8902','2013-07-20','14:10:00',1.51),('8902','2013-07-20','14:15:00',1.54),('8902','2013-07-20','14:20:00',2.02),('8902','2013-07-20','14:25:00',2.21),('8902','2013-07-20','14:30:00',2.17),('8902','2013-07-20','14:35:00',2.43),('8902','2013-07-20','14:40:00',2.42),('8902','2013-07-20','14:45:00',4.34),('8902','2013-07-20','14:50:00',5.96),('8902','2013-07-20','14:55:00',3.02),('8902','2013-07-20','15:00:00',3.55),('8902','2013-07-20','15:05:00',3.13),('8902','2013-07-20','15:10:00',2.96),('8902','2013-07-20','15:15:00',8.4),('8902','2013-07-20','15:20:00',9.33),('8902','2013-07-20','15:25:00',3.35),('8902','2013-07-20','15:30:00',2.66),('8902','2013-07-20','15:35:00',3.02),('8902','2013-07-20','15:40:00',6.97),('8902','2013-07-20','15:45:00',5.94),('8902','2013-07-20','15:50:00',5.87),('8902','2013-07-20','15:55:00',4.17),('8902','2013-07-20','16:00:00',2.64),('8902','2013-07-20','16:05:00',2.05),('8902','2013-07-20','16:10:00',1.74),('8902','2013-07-20','16:15:00',1.52),('8902','2013-07-20','16:20:00',1.41),('8902','2013-07-20','16:25:00',1.46),('8902','2013-07-20','16:30:00',1.52),('8902','2013-07-20','16:35:00',1.62),('8902','2013-07-20','16:40:00',1.66),('8902','2013-07-20','16:45:00',1.65),('8902','2013-07-20','16:50:00',1.72),('8902','2013-07-20','16:55:00',1.95),('8902','2013-07-20','17:00:00',2.22),('8902','2013-07-20','17:05:00',2.44),('8902','2013-07-20','17:10:00',2.44),('8902','2013-07-20','17:15:00',2.05),('8902','2013-07-20','17:20:00',1.86),('8902','2013-07-20','17:25:00',1.73),('8902','2013-07-20','17:30:00',1.61),('8902','2013-07-20','17:35:00',1.54),('8902','2013-07-20','17:40:00',1.52),('8902','2013-07-20','17:45:00',1.5),('8902','2013-07-20','17:50:00',1.54),('8902','2013-07-20','17:55:00',1.58),('8902','2013-07-20','18:00:00',1.58),('8902','2013-07-20','18:05:00',1.49),('8902','2013-07-20','18:10:00',1.28),('8902','2013-07-20','18:15:00',1.1),('8902','2014-04-06','08:10:00',1.22),('8902','2014-04-06','08:15:00',1.46),('8902','2014-04-06','08:20:00',1.81),('8902','2014-04-06','08:25:00',1.81),('8902','2014-04-06','08:30:00',1.99),('8902','2014-04-06','08:35:00',2.67),('8902','2014-04-06','08:40:00',3),('8902','2014-04-06','08:45:00',3.11),('8902','2014-04-06','08:50:00',2.58),('8902','2014-04-06','08:55:00',2.28),('8902','2014-04-06','09:00:00',2.21),('8902','2014-04-06','09:05:00',2.3),('8902','2014-04-06','09:10:00',2.54),('8902','2014-04-06','09:15:00',2.79),('8902','2014-04-06','09:20:00',2.59),('8902','2014-04-06','09:25:00',2.42),('8902','2014-04-06','09:30:00',2.39),('8902','2014-04-06','09:35:00',2.19),('8902','2014-04-06','09:40:00',2.24),('8902','2014-04-06','09:45:00',2.35),('8902','2014-04-06','09:50:00',2.47),('8902','2014-04-06','09:55:00',2.81),('8902','2014-04-06','10:00:00',2.64),('8902','2014-04-06','10:05:00',2.6),('8902','2014-04-06','10:10:00',2.76),('8902','2014-04-06','10:15:00',2.54),('8902','2014-04-06','10:20:00',2.51),('8902','2014-04-06','10:25:00',2.57),('8902','2014-04-06','10:30:00',2.65),('8902','2014-04-06','10:35:00',2.84),('8902','2014-04-06','10:40:00',2.92),('8902','2014-04-06','10:45:00',3.02),('8902','2014-04-06','10:50:00',3.1),('8902','2014-04-06','10:55:00',3.26),('8902','2014-04-06','11:00:00',3.46),('8902','2014-04-06','11:05:00',3.65),('8902','2014-04-06','11:10:00',4.2),('8902','2014-04-06','11:15:00',4.61),('8902','2014-04-06','11:20:00',4.14),('8902','2014-04-06','11:25:00',4.02),('8902','2014-04-06','11:30:00',4.01),('8902','2014-04-06','11:35:00',3.91),('8902','2014-04-06','11:40:00',3.77),('8902','2014-04-06','11:45:00',3.57),('8902','2014-04-06','11:50:00',3.47),('8902','2014-04-06','11:55:00',3.44),('8902','2014-04-06','12:00:00',3.69),('8902','2014-04-06','12:05:00',4.51),('8902','2014-04-06','12:10:00',5.17),('8902','2014-04-06','12:15:00',6.7),('8902','2014-04-06','12:20:00',8.29),('8902','2014-04-06','12:25:00',7.95),('8902','2014-04-06','12:30:00',5.11),('8902','2014-04-06','12:35:00',4.68),('8902','2014-04-06','12:40:00',5.66),('8902','2014-04-06','12:45:00',7.77),('8902','2014-04-06','12:50:00',7.88),('8902','2014-04-06','12:55:00',7.8),('8902','2014-04-06','13:00:00',7.83),('8902','2014-04-06','13:05:00',7.77),('8902','2014-04-06','13:10:00',7.75),('8902','2014-04-06','13:15:00',7.78),('8902','2014-04-06','13:20:00',7.82),('8902','2014-04-06','13:25:00',7.77),('8902','2014-04-06','13:30:00',7.71),('8902','2014-04-06','13:35:00',7.71),('8902','2014-04-06','13:40:00',7.73),('8902','2014-04-06','13:45:00',7.8),('8902','2014-04-06','13:50:00',7.74),('8902','2014-04-06','13:55:00',7.7),('8902','2014-04-06','14:00:00',7.63),('8902','2014-04-06','14:05:00',7.63),('8902','2014-04-06','14:10:00',7.56),('8902','2014-04-06','14:15:00',7.54),('8902','2014-04-06','14:20:00',7.51),('8902','2014-04-06','14:25:00',7.81),('8902','2014-04-06','14:30:00',7.75),('8902','2014-04-06','14:35:00',7.53),('8902','2014-04-06','14:40:00',7.5),('8902','2014-04-06','14:45:00',7.33),('8902','2014-04-06','14:50:00',7.02),('8902','2014-04-06','14:55:00',6.06),('8902','2014-04-06','15:00:00',7.26),('8902','2014-04-06','15:05:00',7.41),('8902','2014-04-06','15:10:00',7.25),('8902','2014-04-06','15:15:00',4.91),('8902','2014-04-06','15:20:00',7.3),('8902','2014-04-06','15:25:00',7.23),('8902','2014-04-06','15:30:00',6.89),('8902','2014-04-06','15:35:00',7.07),('8902','2014-04-06','15:40:00',6.91),('8902','2014-04-06','15:45:00',7.06),('8902','2014-04-06','15:50:00',7.35),('8902','2014-04-06','15:55:00',6.79),('8902','2014-04-06','16:00:00',4.34),('8902','2014-04-06','16:05:00',3.41),('8902','2014-04-06','16:10:00',6.41),('8902','2014-04-06','16:15:00',6.01),('8902','2014-04-06','16:20:00',5.57),('8902','2014-04-06','16:25:00',5.4),('8902','2014-04-06','16:30:00',5.26),('8902','2014-04-06','16:35:00',4.35),('8902','2014-04-06','16:40:00',2.3),('8902','2014-04-06','16:45:00',4.27),('8902','2014-04-06','16:50:00',4.23),('8902','2014-04-06','16:55:00',5.12),('8902','2014-04-06','17:00:00',5.15),('8902','2014-04-06','17:05:00',4.45),('8902','2014-04-06','17:10:00',2.63),('8902','2014-04-06','17:15:00',3.74),('8902','2014-04-06','17:20:00',1.61),('8902','2014-04-06','17:25:00',1.35),('8902','2014-04-06','17:30:00',1.39),('8902','2014-04-06','17:35:00',1.03),('8902','2014-04-06','17:50:00',1.09),('8902','2014-04-06','17:55:00',2.27),('8902','2014-04-06','18:00:00',2.11),('8902','2014-04-06','18:05:00',1.94),('8902','2014-04-06','18:10:00',1.92),('8902','2014-04-06','18:15:00',1.77),('8902','2014-04-06','18:20:00',1.44),('8902','2014-04-06','18:25:00',1.27),('8902','2014-04-06','18:30:00',1.16),('8902','2013-07-19','07:35:00',1.02),('8902','2013-07-19','07:40:00',1.25),('8902','2013-07-19','07:45:00',1.39),('8902','2013-07-19','07:50:00',1.5),('8902','2013-07-19','07:55:00',1.66),('8902','2013-07-19','08:00:00',1.8),('8902','2013-07-19','08:05:00',1.96),('8902','2013-07-19','08:10:00',2.12),('8902','2013-07-19','08:15:00',2.27),('8902','2013-07-19','08:20:00',2.45),('8902','2013-07-19','08:25:00',2.61),('8902','2013-07-19','08:30:00',2.76),('8902','2013-07-19','08:35:00',2.94),('8902','2013-07-19','08:40:00',3.11),('8902','2013-07-19','08:45:00',3.31),('8902','2013-07-19','08:50:00',3.48),('8902','2013-07-19','08:55:00',3.64),('8902','2013-07-19','09:00:00',3.82),('8902','2013-07-19','09:05:00',4.01),('8902','2013-07-19','09:10:00',4.24),('8902','2013-07-19','09:15:00',4.42),('8902','2013-07-19','09:20:00',4.53),('8902','2013-07-19','09:25:00',4.48),('8902','2013-07-19','09:30:00',4.48),('8902','2013-07-19','09:35:00',4.58),('8902','2013-07-19','09:40:00',4.53),('8902','2013-07-19','09:45:00',5.01),('8902','2013-07-19','09:50:00',4.94),('8902','2013-07-19','09:55:00',5.03),('8902','2013-07-19','10:00:00',5.3),('8902','2013-07-19','10:05:00',5.34),('8902','2013-07-19','10:10:00',5.5),('8902','2013-07-19','10:15:00',5.62),('8902','2013-07-19','10:20:00',5.74),('8902','2013-07-19','10:25:00',5.85),('8902','2013-07-19','10:30:00',5.99),('8902','2013-07-19','10:35:00',6.08),('8902','2013-07-19','10:40:00',6.15),('8902','2013-07-19','10:45:00',6.25),('8902','2013-07-19','10:50:00',6.36),('8902','2013-07-19','10:55:00',6.44),('8902','2013-07-19','11:00:00',6.53),('8902','2013-07-19','11:05:00',6.54),('8902','2013-07-19','11:10:00',6.76),('8902','2013-07-19','11:15:00',6.78),('8902','2013-07-19','11:20:00',6.8),('8902','2013-07-19','11:25:00',6.79),('8902','2013-07-19','11:30:00',6.78),('8902','2013-07-19','11:35:00',6.96),('8902','2013-07-19','11:40:00',7.13),('8902','2013-07-19','11:45:00',7.14),('8902','2013-07-19','11:50:00',7.29),('8902','2013-07-19','11:55:00',7.37),('8902','2013-07-19','12:00:00',7.27),('8902','2013-07-19','12:05:00',7.36),('8902','2013-07-19','12:10:00',7.49),('8902','2013-07-19','12:15:00',7.59),('8902','2013-07-19','12:20:00',7.33),('8902','2013-07-19','12:25:00',2.94),('8902','2013-07-19','12:30:00',6.79),('8902','2013-07-19','12:35:00',7.72),('8902','2013-07-19','12:40:00',7.76),('8902','2013-07-19','12:45:00',7.83),('8902','2013-07-19','12:50:00',7.76),('8902','2013-07-19','12:55:00',7.94),('8902','2013-07-19','13:00:00',8.08),('8902','2013-07-19','13:05:00',8.07),('8902','2013-07-19','13:10:00',8.01),('8902','2013-07-19','13:15:00',8.08),('8902','2013-07-19','13:20:00',3.51),('8902','2013-07-19','13:25:00',3.98),('8902','2013-07-19','13:30:00',8.39),('8902','2013-07-19','13:35:00',8.24),('8902','2013-07-19','13:40:00',8.29),('8902','2013-07-19','13:45:00',8.17),('8902','2013-07-19','13:50:00',8.12),('8902','2013-07-19','13:55:00',2.76),('8902','2013-07-19','14:00:00',1.93),('8902','2013-07-19','14:05:00',7.96),('8902','2013-07-19','14:10:00',8.31),('8902','2013-07-19','14:15:00',5.63),('8902','2013-07-19','14:20:00',5.98),('8902','2013-07-19','14:25:00',8.13),('8902','2013-07-19','14:30:00',7.94),('8902','2013-07-19','14:35:00',7.24),('8902','2013-07-19','14:40:00',7.67),('8902','2013-07-19','14:45:00',2.87),('8902','2013-07-19','14:50:00',6.79),('8902','2013-07-19','14:55:00',4.28),('8902','2013-07-19','15:00:00',2.41),('8902','2013-07-19','15:05:00',6.6),('8902','2013-07-19','15:10:00',7.86),('8902','2013-07-19','15:15:00',7.5),('8902','2013-07-19','15:20:00',7.35),('8902','2013-07-19','15:25:00',7.15),('8902','2013-07-19','15:30:00',7.05),('8902','2013-07-19','15:35:00',6.92),('8902','2013-07-19','15:40:00',6.8),('8902','2013-07-19','15:45:00',6.73),('8902','2013-07-19','15:50:00',6.62),('8902','2013-07-19','15:55:00',6.55),('8902','2013-07-19','16:00:00',6.48),('8902','2013-07-19','16:05:00',6.29),('8902','2013-07-19','16:10:00',6.27),('8902','2013-07-19','16:15:00',6.22),('8902','2013-07-19','16:20:00',6.18),('8902','2013-07-19','16:25:00',6.06),('8902','2013-07-19','16:30:00',5.96),('8902','2013-07-19','16:35:00',5.77),('8902','2013-07-19','16:40:00',5.53),('8902','2013-07-19','16:45:00',5.43),('8902','2013-07-19','16:50:00',5.28),('8902','2013-07-19','16:55:00',5.13),('8902','2013-07-19','17:00:00',4.92),('8902','2013-07-19','17:05:00',4.92),('8902','2013-07-19','17:10:00',4.77),('8902','2013-07-19','17:15:00',4.64),('8902','2013-07-19','17:20:00',4.54),('8902','2013-07-19','17:25:00',4.36),('8902','2013-07-19','17:30:00',4.24),('8902','2013-07-19','17:35:00',4.11),('8902','2013-07-19','17:40:00',3.97),('8902','2013-07-19','17:45:00',3.79),('8902','2013-07-19','17:50:00',3.62),('8902','2013-07-19','17:55:00',3.41),('8902','2013-07-19','18:00:00',3.21),('8902','2013-07-19','18:05:00',3.1),('8902','2013-07-19','18:10:00',2.91),('8902','2013-07-19','18:15:00',2.76),('8902','2013-07-19','18:20:00',2.61),('8902','2013-07-19','18:25:00',2.41),('8902','2013-07-19','18:30:00',2.28),('8902','2013-07-19','18:35:00',2.05),('8902','2013-07-19','18:40:00',1.9),('8902','2013-07-19','18:45:00',1.74),('8902','2013-07-19','18:50:00',1.58),('8902','2013-07-19','18:55:00',1.41),('8902','2013-07-19','19:00:00',1.25),('8902','2013-07-19','19:05:00',1.1),('8902','2013-07-18','07:35:00',1.07),('8902','2013-07-18','07:40:00',1.27),('8902','2013-07-18','07:45:00',1.4),('8902','2013-07-18','07:50:00',1.53),('8902','2013-07-18','07:55:00',1.65),('8902','2013-07-18','08:00:00',1.8),('8902','2013-07-18','08:05:00',1.95),('8902','2013-07-18','08:10:00',2.09),('8902','2013-07-18','08:15:00',2.24),('8902','2013-07-18','08:20:00',2.39),('8902','2013-07-18','08:25:00',2.53),('8902','2013-07-18','08:30:00',2.66),('8902','2013-07-18','08:35:00',2.83),('8902','2013-07-18','08:40:00',3),('8902','2013-07-18','08:45:00',3.17),('8902','2013-07-18','08:50:00',3.32),('8902','2013-07-18','08:55:00',3.48),('8902','2013-07-18','09:00:00',3.6),('8902','2013-07-18','09:05:00',3.74),('8902','2013-07-18','09:10:00',3.89),('8902','2013-07-18','09:15:00',4.03),('8902','2013-07-18','09:20:00',4.15),('8902','2013-07-18','09:25:00',4.26),('8902','2013-07-18','09:30:00',4.4),('8902','2013-07-18','09:35:00',4.58),('8902','2013-07-18','09:40:00',4.65),('8902','2013-07-18','09:45:00',4.7),('8902','2013-07-18','09:50:00',4.87),('8902','2013-07-18','09:55:00',5.01),('8902','2013-07-18','10:00:00',5.12),('8902','2013-07-18','10:05:00',5.19),('8902','2013-07-18','10:10:00',5.27),('8902','2013-07-18','10:15:00',5.39),('8902','2013-07-18','10:20:00',5.45),('8902','2013-07-18','10:25:00',5.64),('8902','2013-07-18','10:30:00',5.66),('8902','2013-07-18','10:35:00',5.84),('8902','2013-07-18','10:40:00',5.9),('8902','2013-07-18','10:45:00',6.01),('8902','2013-07-18','10:50:00',6.06),('8902','2013-07-18','10:55:00',6.19),('8902','2013-07-18','11:00:00',6.36),('8902','2013-07-18','11:05:00',6.36),('8902','2013-07-18','11:10:00',6.39),('8902','2013-07-18','11:15:00',6.41),('8902','2013-07-18','11:20:00',6.58),('8902','2013-07-18','11:25:00',6.61),('8902','2013-07-18','11:30:00',6.6),('8902','2013-07-18','11:35:00',6.64),('8902','2013-07-18','11:40:00',6.75),('8902','2013-07-18','11:45:00',6.97),('8902','2013-07-18','11:50:00',7.17),('8902','2013-07-18','11:55:00',7.14),('8902','2013-07-18','12:00:00',5.84),('8902','2013-07-18','12:05:00',3.86),('8902','2013-07-18','12:10:00',7.11),('8902','2013-07-18','12:15:00',7.45),('8902','2013-07-18','12:20:00',7.48),('8902','2013-07-18','12:25:00',6.1),('8902','2013-07-18','12:30:00',6.86),('8902','2013-07-18','12:35:00',7.2),('8902','2013-07-18','12:40:00',6.68),('8902','2013-07-18','12:45:00',7.46),('8902','2013-07-18','12:50:00',7.55),('8902','2013-07-18','12:55:00',5.13),('8902','2013-07-18','13:00:00',4.59),('8902','2013-07-18','13:05:00',6.74),('8902','2013-07-18','13:10:00',7.71),('8902','2013-07-18','13:15:00',5.72),('8902','2013-07-18','13:20:00',2.81),('8902','2013-07-18','13:25:00',5.01),('8902','2013-07-18','13:30:00',8.58),('8902','2013-07-18','13:35:00',8.19),('8902','2013-07-18','13:40:00',8.11),('8902','2013-07-18','13:45:00',8.11),('8902','2013-07-18','13:50:00',7.9),('8902','2013-07-18','13:55:00',7.4),('8902','2013-07-18','14:00:00',6.32),('8902','2013-07-18','14:05:00',8.21),('8902','2013-07-18','14:10:00',6.27),('8902','2013-07-18','14:15:00',7.8),('8902','2013-07-18','14:20:00',8.21),('8902','2013-07-18','14:25:00',7.84),('8902','2013-07-18','14:30:00',8.18),('8902','2013-07-18','14:35:00',8.17),('8902','2013-07-18','14:40:00',6.82),('8902','2013-07-18','14:45:00',6.27),('8902','2013-07-18','14:50:00',7.7),('8902','2013-07-18','14:55:00',6.46),('8902','2013-07-18','15:00:00',7.85),('8902','2013-07-18','15:05:00',7.59),('8902','2013-07-18','15:10:00',7.62),('8902','2013-07-18','15:15:00',4.17),('8902','2013-07-18','15:20:00',6.5),('8902','2013-07-18','15:25:00',5.44),('8902','2013-07-18','15:30:00',7.52),('8902','2013-07-18','15:35:00',6.98),('8902','2013-07-18','15:40:00',7.36),('8902','2013-07-18','15:45:00',7.17),('8902','2013-07-18','15:50:00',6.97),('8902','2013-07-18','15:55:00',6.86),('8902','2013-07-18','16:00:00',6.76),('8902','2013-07-18','16:05:00',6.67),('8902','2013-07-18','16:10:00',6.62),('8902','2013-07-18','16:15:00',6.53),('8902','2013-07-18','16:20:00',6.43),('8902','2013-07-18','16:25:00',6.29),('8902','2013-07-18','16:30:00',6.19),('8902','2013-07-18','16:35:00',6.1),('8902','2013-07-18','16:40:00',5.94),('8902','2013-07-18','16:45:00',5.88),('8902','2013-07-18','16:50:00',5.75),('8902','2013-07-18','16:55:00',5.75),('8902','2013-07-18','17:00:00',4.74),('8902','2013-07-18','17:05:00',4.93),('8902','2013-07-18','17:10:00',5.36),('8902','2013-07-18','17:15:00',4.87),('8902','2013-07-18','17:20:00',4.35),('8902','2013-07-18','17:25:00',3.83),('8902','2013-07-18','17:30:00',4.14),('8902','2013-07-18','17:35:00',3.99),('8902','2013-07-18','17:40:00',3.3),('8902','2013-07-18','17:45:00',2.59),('8902','2013-07-18','17:50:00',1.82),('8902','2013-07-18','17:55:00',1.61),('8902','2013-07-18','18:00:00',1.47),('8902','2013-07-18','18:05:00',1.28),('8902','2013-07-18','18:10:00',1.08),('8902','2013-07-18','18:40:00',1.01),('8902','2013-07-18','18:45:00',1.01),('8902','2013-07-17','07:35:00',1.11),('8902','2013-07-17','07:40:00',1.29),('8902','2013-07-17','07:45:00',1.44),('8902','2013-07-17','07:50:00',1.59),('8902','2013-07-17','07:55:00',1.74),('8902','2013-07-17','08:00:00',1.89),('8902','2013-07-17','08:05:00',2.05),('8902','2013-07-17','08:10:00',2.21),('8902','2013-07-17','08:15:00',2.37),('8902','2013-07-17','08:20:00',2.53),('8902','2013-07-17','08:25:00',2.67),('8902','2013-07-17','08:30:00',2.83),('8902','2013-07-17','08:35:00',3),('8902','2013-07-17','08:40:00',3.16),('8902','2013-07-17','08:45:00',3.32),('8902','2013-07-17','08:50:00',3.46),('8902','2013-07-17','08:55:00',3.61),('8902','2013-07-17','09:00:00',3.76),('8902','2013-07-17','09:05:00',3.91),('8902','2013-07-17','09:10:00',4.05),('8902','2013-07-17','09:15:00',4.18),('8902','2013-07-17','09:20:00',4.32),('8902','2013-07-17','09:25:00',4.46),('8902','2013-07-17','09:30:00',4.61),('8902','2013-07-17','09:35:00',4.75),('8902','2013-07-17','09:40:00',4.87),('8902','2013-07-17','09:45:00',4.97),('8902','2013-07-17','09:50:00',5.09),('8902','2013-07-17','09:55:00',5.19),('8902','2013-07-17','10:00:00',5.32),('8902','2013-07-17','10:05:00',5.4),('8902','2013-07-17','10:10:00',5.58),('8902','2013-07-17','10:15:00',5.69),('8902','2013-07-17','10:20:00',5.78),('8902','2013-07-17','10:25:00',5.87),('8902','2013-07-17','10:30:00',6.03),('8902','2013-07-17','10:35:00',6.14),('8902','2013-07-17','10:40:00',6.24),('8902','2013-07-17','10:45:00',6.27),('8902','2013-07-17','10:50:00',6.37),('8902','2013-07-17','10:55:00',6.45),('8902','2013-07-17','11:00:00',6.5),('8902','2013-07-17','11:05:00',6.58),('8902','2013-07-17','11:10:00',6.68),('8902','2013-07-17','11:15:00',6.72),('8902','2013-07-17','11:20:00',6.84),('8902','2013-07-17','11:25:00',6.9),('8902','2013-07-17','11:30:00',6.94),('8902','2013-07-17','11:35:00',7),('8902','2013-07-17','11:40:00',7.02),('8902','2013-07-17','11:45:00',7.06),('8902','2013-07-17','11:50:00',7.11),('8902','2013-07-17','11:55:00',7.19),('8902','2013-07-17','12:00:00',7.26),('8902','2013-07-17','12:05:00',7.26),('8902','2013-07-17','12:10:00',7.27),('8902','2013-07-17','12:15:00',7.29),('8902','2013-07-17','12:20:00',7.4),('8902','2013-07-17','12:25:00',7.21),('8902','2013-07-17','12:30:00',4.06),('8902','2013-07-17','12:35:00',5.09),('8902','2013-07-17','12:40:00',6.69),('8902','2013-07-17','12:45:00',6.88),('8902','2013-07-17','12:50:00',3.84),('8902','2013-07-17','12:55:00',6.08),('8902','2013-07-17','13:00:00',8.14),('8902','2013-07-17','13:05:00',7.92),('8902','2013-07-17','13:10:00',7.8),('8902','2013-07-17','13:15:00',7.64),('8902','2013-07-17','13:20:00',6.84),('8902','2013-07-17','13:25:00',7.13),('8902','2013-07-17','13:30:00',8.14),('8902','2013-07-17','13:35:00',7.71),('8902','2013-07-17','13:40:00',7.77),('8902','2013-07-17','13:45:00',8.12),('8902','2013-07-17','13:50:00',8.01),('8902','2013-07-17','13:55:00',7.74),('8902','2013-07-17','14:00:00',7.79),('8902','2013-07-17','14:05:00',7.83),('8902','2013-07-17','14:10:00',7.66),('8902','2013-07-17','14:15:00',7.68),('8902','2013-07-17','14:20:00',7.85),('8902','2013-07-17','14:25:00',7.66),('8902','2013-07-17','14:30:00',7.54),('8902','2013-07-17','14:35:00',7.68),('8902','2013-07-17','14:40:00',7.68),('8902','2013-07-17','14:45:00',7.47),('8902','2013-07-17','14:50:00',7.42),('8902','2013-07-17','14:55:00',7.31),('8902','2013-07-17','15:00:00',7.28),('8902','2013-07-17','15:05:00',7.36),('8902','2013-07-17','15:10:00',7.32),('8902','2013-07-17','15:15:00',7.19),('8902','2013-07-17','15:20:00',7.18),('8902','2013-07-17','15:25:00',7.18),('8902','2013-07-17','15:30:00',7.09),('8902','2013-07-17','15:35:00',6.96),('8902','2013-07-17','15:40:00',6.92),('8902','2013-07-17','15:45:00',6.83),('8902','2013-07-17','15:50:00',6.74),('8902','2013-07-17','15:55:00',6.63),('8902','2013-07-17','16:00:00',6.53),('8902','2013-07-17','16:05:00',6.4),('8902','2013-07-17','16:10:00',6.28),('8902','2013-07-17','16:15:00',6.21),('8902','2013-07-17','16:20:00',6.11),('8902','2013-07-17','16:25:00',6.03),('8902','2013-07-17','16:30:00',5.9),('8902','2013-07-17','16:35:00',5.75),('8902','2013-07-17','16:40:00',5.52),('8902','2013-07-17','16:45:00',5.44),('8902','2013-07-17','16:50:00',5.33),('8902','2013-07-17','16:55:00',5.16),('8902','2013-07-17','17:00:00',4.95),('8902','2013-07-17','17:05:00',4.89),('8902','2013-07-17','17:10:00',4.74),('8902','2013-07-17','17:15:00',4.54),('8902','2013-07-17','17:20:00',4.41),('8902','2013-07-17','17:35:00',3.9),('8902','2013-07-17','17:40:00',3.74),('8902','2013-07-17','17:50:00',3.32),('8902','2013-07-17','17:55:00',3.22),('8902','2013-07-17','18:00:00',2.88),('8902','2013-07-17','18:05:00',2.85),('8902','2013-07-17','18:10:00',2.66),('8902','2013-07-17','18:15:00',2.59),('8902','2013-07-17','18:20:00',2.34),('8902','2013-07-17','18:25:00',2.21),('8902','2013-07-17','18:30:00',1.32),('8902','2013-07-17','19:00:00',1.13),('8902','2013-07-16','07:35:00',1.14),('8902','2013-07-16','07:40:00',1.3),('8902','2013-07-16','07:45:00',1.46),('8902','2013-07-16','07:50:00',1.61),('8902','2013-07-16','07:55:00',1.77),('8902','2013-07-16','08:00:00',1.92),('8902','2013-07-16','08:05:00',2.12),('8902','2013-07-16','08:10:00',2.3),('8902','2013-07-16','08:15:00',2.45),('8902','2013-07-16','08:20:00',2.63),('8902','2013-07-16','08:25:00',2.79),('8902','2013-07-16','08:30:00',2.93),('8902','2013-07-16','08:35:00',3.12),('8902','2013-07-16','08:40:00',3.3),('8902','2013-07-16','08:45:00',3.45),('8902','2013-07-16','08:50:00',3.61),('8902','2013-07-16','08:55:00',3.76),('8902','2013-07-16','09:00:00',3.92),('8902','2013-07-16','09:05:00',4.1),('8902','2013-07-16','09:10:00',4.27),('8902','2013-07-16','09:15:00',4.42),('8902','2013-07-16','09:20:00',4.58),('8902','2013-07-16','09:25:00',4.74),('8902','2013-07-16','09:30:00',4.85),('8902','2013-07-16','09:35:00',4.95),('8902','2013-07-16','09:40:00',5.11),('8902','2013-07-16','09:45:00',5.26),('8902','2013-07-16','09:50:00',5.38),('8902','2013-07-16','09:55:00',5.46),('8902','2013-07-16','10:00:00',5.58),('8902','2013-07-16','10:05:00',5.7),('8902','2013-07-16','10:10:00',5.81),('8902','2013-07-16','10:15:00',5.92),('8902','2013-07-16','10:20:00',6.03),('8902','2013-07-16','10:25:00',6.16),('8902','2013-07-16','10:30:00',6.26),('8902','2013-07-16','10:35:00',6.31),('8902','2013-07-16','10:40:00',6.37),('8902','2013-07-16','10:45:00',6.53),('8902','2013-07-16','10:50:00',6.63),('8902','2013-07-16','10:55:00',6.69),('8902','2013-07-16','11:00:00',6.78),('8902','2013-07-16','11:05:00',6.85),('8902','2013-07-16','11:10:00',6.94),('8902','2013-07-16','11:15:00',6.99),('8902','2013-07-16','11:20:00',7.09),('8902','2013-07-16','11:25:00',7.16),('8902','2013-07-16','11:30:00',7.21),('8902','2013-07-16','11:35:00',7.31),('8902','2013-07-16','11:40:00',7.3),('8902','2013-07-16','11:45:00',7.35),('8902','2013-07-16','11:50:00',7.41),('8902','2013-07-16','11:55:00',7.51),('8902','2013-07-16','12:00:00',7.56),('8902','2013-07-16','12:05:00',7.59),('8902','2013-07-16','12:10:00',7.64),('8902','2013-07-16','12:15:00',7.63),('8902','2013-07-16','12:20:00',7.72),('8902','2013-07-16','12:25:00',7.81),('8902','2013-07-16','12:30:00',7.82),('8902','2013-07-16','12:35:00',7.83),('8902','2013-07-16','12:40:00',7.82),('8902','2013-07-16','12:45:00',7.85),('8902','2013-07-16','12:50:00',7.89),('8902','2013-07-16','12:55:00',7.93),('8902','2013-07-16','13:00:00',7.87),('8902','2013-07-16','13:05:00',7.85),('8902','2013-07-16','13:10:00',7.93),('8902','2013-07-16','13:15:00',7.88),('8902','2013-07-16','13:20:00',7.81),('8902','2013-07-16','13:25:00',7.75),('8902','2013-07-16','13:30:00',7.81),('8902','2013-07-16','13:35:00',7.73),('8902','2013-07-16','13:40:00',7.74),('8902','2013-07-16','13:45:00',7.81),('8902','2013-07-16','13:50:00',7.85),('8902','2013-07-16','13:55:00',7.85),('8902','2013-07-16','14:00:00',7.87),('8902','2013-07-16','14:05:00',7.82),('8902','2013-07-16','14:10:00',7.74),('8902','2013-07-16','14:15:00',7.72),('8902','2013-07-16','14:20:00',7.68),('8902','2013-07-16','14:25:00',7.54),('8902','2013-07-16','14:30:00',7.54),('8902','2013-07-16','14:35:00',7.53),('8902','2013-07-16','14:40:00',7.9),('8902','2013-07-16','14:45:00',7.84),('8902','2013-07-16','14:50:00',7.57),('8902','2013-07-16','14:55:00',7.41),('8902','2013-07-16','15:00:00',7.32),('8902','2013-07-16','15:05:00',7.39),('8902','2013-07-16','15:10:00',7.46),('8902','2013-07-16','15:15:00',7.34),('8902','2013-07-16','15:20:00',7.36),('8902','2013-07-16','15:25:00',7.16),('8902','2013-07-16','15:30:00',7.1),('8902','2013-07-16','15:35:00',7.03),('8902','2013-07-16','15:40:00',6.04),('8902','2013-07-16','15:45:00',6.89),('8902','2013-07-16','15:50:00',6.76),('8902','2013-07-16','15:55:00',6.83),('8902','2013-07-16','16:00:00',6.7),('8902','2013-07-16','16:05:00',6.6),('8902','2013-07-16','16:10:00',6.53),('8902','2013-07-16','16:15:00',6.41),('8902','2013-07-16','16:20:00',6.26),('8902','2013-07-16','16:25:00',6.07),('8902','2013-07-16','16:30:00',5.99),('8902','2013-07-16','16:35:00',5.77),('8902','2013-07-16','16:40:00',5.72),('8902','2013-07-16','16:45:00',5.64),('8902','2013-07-16','16:50:00',5.36),('8902','2013-07-16','16:55:00',5.1),('8902','2013-07-16','17:00:00',5.11),('8902','2013-07-16','17:05:00',5.2),('8902','2013-07-16','17:10:00',5.11),('8902','2013-07-16','17:15:00',4.81),('8902','2013-07-16','17:20:00',4.66),('8902','2013-07-16','17:25:00',4.3),('8902','2013-07-16','17:30:00',4.29),('8902','2013-07-16','17:35:00',4.1),('8902','2013-07-16','17:40:00',3.93),('8902','2013-07-16','17:45:00',3.8),('8902','2013-07-16','17:50:00',3.72),('8902','2013-07-16','17:55:00',3.45),('8902','2013-07-16','18:00:00',3.21),('8902','2013-07-16','18:05:00',3.02),('8902','2013-07-16','18:10:00',3.01),('8902','2013-07-16','18:15:00',2.84),('8902','2013-07-16','18:20:00',2.66),('8902','2013-07-16','18:25:00',2.46),('8902','2013-07-16','18:30:00',2.3),('8902','2013-07-16','18:35:00',2.12),('8902','2013-07-16','18:40:00',1.96),('8902','2013-07-16','18:45:00',1.79),('8902','2013-07-16','18:50:00',1.62),('8902','2013-07-16','18:55:00',1.43),('8902','2013-07-16','19:00:00',1.29),('8902','2013-07-16','19:05:00',1.16),('8902','2013-07-16','19:10:00',1.01),('8902','2013-07-15','07:35:00',1.2),('8902','2013-07-15','07:40:00',1.36),('8902','2013-07-15','07:45:00',1.51),('8902','2013-07-15','07:50:00',1.65),('8902','2013-07-15','07:55:00',1.78),('8902','2013-07-15','08:00:00',1.92),('8902','2013-07-15','08:05:00',2.07),('8902','2013-07-15','08:10:00',2.23),('8902','2013-07-15','08:15:00',2.4),('8902','2013-07-15','08:20:00',2.55),('8902','2013-07-15','08:25:00',2.71),('8902','2013-07-15','08:30:00',2.88),('8902','2013-07-15','08:35:00',3.04),('8902','2013-07-15','08:40:00',3.16),('8902','2013-07-15','08:45:00',3.3),('8902','2013-07-15','08:50:00',3.47),('8902','2013-07-15','08:55:00',3.65),('8902','2013-07-15','09:00:00',3.79),('8902','2013-07-15','09:05:00',3.91),('8902','2013-07-15','09:10:00',4.05),('8902','2013-07-15','09:15:00',4.19),('8902','2013-07-15','09:20:00',4.32),('8902','2013-07-15','09:25:00',4.48),('8902','2013-07-15','09:30:00',4.61),('8902','2013-07-15','09:35:00',4.74),('8902','2013-07-15','09:40:00',4.89),('8902','2013-07-15','09:45:00',5.04),('8902','2013-07-15','09:50:00',5.2),('8902','2013-07-15','09:55:00',5.32),('8902','2013-07-15','10:00:00',5.44),('8902','2013-07-15','10:05:00',5.6),('8902','2013-07-15','10:10:00',5.73),('8902','2013-07-15','10:15:00',5.83),('8902','2013-07-15','10:20:00',5.9),('8902','2013-07-15','10:25:00',6.01),('8902','2013-07-15','10:30:00',6.15),('8902','2013-07-15','10:35:00',5.36),('8902','2013-07-15','10:40:00',6.33),('8902','2013-07-15','10:45:00',6.4),('8902','2013-07-15','10:50:00',6.51),('8902','2013-07-15','10:55:00',6.59),('8902','2013-07-15','11:00:00',6.67),('8902','2013-07-15','11:05:00',6.75),('8902','2013-07-15','11:10:00',6.87),('8902','2013-07-15','11:15:00',6.92),('8902','2013-07-15','11:20:00',6.97),('8902','2013-07-15','11:25:00',7.06),('8902','2013-07-15','11:30:00',7.16),('8902','2013-07-15','11:35:00',7.19),('8902','2013-07-15','11:40:00',7.27),('8902','2013-07-15','11:45:00',7.36),('8902','2013-07-15','11:50:00',7.47),('8902','2013-07-15','11:55:00',7.55),('8902','2013-07-15','12:00:00',7.56),('8902','2013-07-15','12:05:00',7.58),('8902','2013-07-15','12:10:00',7.6),('8902','2013-07-15','12:15:00',7.65),('8902','2013-07-15','12:20:00',7.7),('8902','2013-07-15','12:25:00',7.73),('8902','2013-07-15','12:30:00',7.73),('8902','2013-07-15','12:35:00',7.74),('8902','2013-07-15','12:40:00',7.71),('8902','2013-07-15','12:45:00',7.68),('8902','2013-07-15','12:50:00',7.69),('8902','2013-07-15','12:55:00',7.66),('8902','2013-07-15','13:00:00',7.6),('8902','2013-07-15','13:05:00',7.7),('8902','2013-07-15','13:10:00',7.75),('8902','2013-07-15','13:15:00',7.79),('8902','2013-07-15','13:20:00',7.73),('8902','2013-07-15','13:25:00',7.7),('8902','2013-07-15','13:30:00',7.69),('8902','2013-07-15','13:35:00',7.72),('8902','2013-07-15','13:40:00',7.75),('8902','2013-07-15','13:45:00',7.89),('8902','2013-07-15','13:50:00',8.06),('8902','2013-07-15','13:55:00',7.9),('8902','2013-07-15','14:00:00',7.67),('8902','2013-07-15','14:05:00',7.66),('8902','2013-07-15','14:10:00',7.74),('8902','2013-07-15','14:15:00',7.54),('8902','2013-07-15','14:20:00',2.18),('8902','2013-07-15','14:25:00',6.84),('8902','2013-07-15','14:30:00',7.94),('8902','2013-07-15','14:35:00',7.8),('8902','2013-07-15','14:40:00',7.75),('8902','2013-07-15','14:45:00',7.65),('8902','2013-07-15','14:50:00',7.67),('8902','2013-07-15','14:55:00',7.64),('8902','2013-07-15','15:00:00',7.59),('8902','2013-07-15','15:05:00',7.43),('8902','2013-07-15','15:10:00',7.31),('8902','2013-07-15','15:15:00',7.23),('8902','2013-07-15','15:20:00',7.23),('8902','2013-07-15','15:25:00',7.11),('8902','2013-07-15','15:30:00',7.13),('8902','2013-07-15','15:35:00',7.17),('8902','2013-07-15','15:40:00',7.04),('8902','2013-07-15','15:45:00',4.66),('8902','2013-07-15','15:50:00',6.75),('8902','2013-07-15','15:55:00',4.74),('8902','2013-07-15','16:00:00',4.95),('8902','2013-07-15','16:05:00',1.45),('8902','2013-07-15','16:10:00',6.17),('8902','2013-07-15','16:15:00',5.99),('8902','2013-07-15','16:20:00',4.63),('8902','2013-07-15','16:25:00',4.35),('8902','2013-07-15','16:30:00',2.72),('8902','2013-07-15','16:35:00',1.6),('8902','2013-07-15','16:40:00',1.53),('8902','2013-07-15','16:45:00',2.62),('8902','2013-07-15','16:50:00',2.03),('8902','2013-07-15','16:55:00',2.53),('8902','2013-07-15','17:00:00',5.13),('8902','2013-07-15','17:05:00',5.39),('8902','2013-07-15','17:10:00',5.43),('8902','2013-07-15','17:15:00',5.23),('8902','2013-07-15','17:20:00',4.09),('8902','2013-07-15','17:25:00',2.78),('8902','2013-07-15','17:30:00',2.9),('8902','2013-07-15','17:35:00',2.22),('8902','2013-07-15','17:40:00',3.41),('8902','2013-07-15','17:45:00',4.07),('8902','2013-07-15','17:50:00',3.86),('8902','2013-07-15','17:55:00',3.33),('8902','2013-07-15','18:00:00',2.95),('8902','2013-07-15','18:05:00',1.89),('8902','2013-07-15','18:10:00',2.24),('8902','2013-07-15','18:15:00',2.77),('8902','2013-07-15','18:20:00',2.53),('8902','2013-07-15','18:25:00',2.42),('8902','2013-07-15','18:30:00',2.26),('8902','2013-07-15','18:35:00',2.02),('8902','2013-07-15','18:40:00',1.8),('8902','2013-07-15','18:45:00',1.68),('8902','2013-07-15','18:50:00',1.53),('8902','2013-07-15','18:55:00',1.35),('8902','2013-07-15','19:00:00',1.18),('8902','2013-07-15','19:05:00',1.05),('8902','2013-07-14','07:35:00',1.22),('8902','2013-07-14','07:40:00',1.37),('8902','2013-07-14','07:45:00',1.52),('8902','2013-07-14','07:50:00',1.67),('8902','2013-07-14','07:55:00',1.82),('8902','2013-07-14','08:00:00',1.99),('8902','2013-07-14','08:05:00',2.14),('8902','2013-07-14','08:10:00',2.31),('8902','2013-07-14','08:15:00',2.48),('8902','2013-07-14','08:20:00',2.65),('8902','2013-07-14','08:25:00',2.81),('8902','2013-07-14','08:30:00',2.97),('8902','2013-07-14','08:35:00',3.14),('8902','2013-07-14','08:40:00',3.31),('8902','2013-07-14','08:45:00',3.46),('8902','2013-07-14','08:50:00',3.62),('8902','2013-07-14','08:55:00',3.79),('8902','2013-07-14','09:00:00',3.94),('8902','2013-07-14','09:05:00',4.08),('8902','2013-07-14','09:10:00',4.24),('8902','2013-07-14','09:15:00',4.39),('8902','2013-07-14','09:20:00',4.53),('8902','2013-07-14','09:25:00',4.68),('8902','2013-07-14','09:30:00',4.82),('8902','2013-07-14','09:35:00',4.94),('8902','2013-07-14','09:40:00',5.08),('8902','2013-07-14','09:45:00',5.2),('8902','2013-07-14','09:50:00',5.34),('8902','2013-07-14','09:55:00',5.44),('8902','2013-07-14','10:00:00',5.53),('8902','2013-07-14','10:05:00',5.63),('8902','2013-07-14','10:10:00',5.75),('8902','2013-07-14','10:15:00',5.86),('8902','2013-07-14','10:20:00',5.95),('8902','2013-07-14','10:25:00',6.06),('8902','2013-07-14','10:30:00',6.15),('8902','2013-07-14','10:35:00',6.21),('8902','2013-07-14','10:40:00',6.3),('8902','2013-07-14','10:45:00',6.38),('8902','2013-07-14','10:50:00',6.51),('8902','2013-07-14','10:55:00',6.58),('8902','2013-07-14','11:00:00',6.68),('8902','2013-07-14','11:05:00',6.78),('8902','2013-07-14','11:10:00',6.85),('8902','2013-07-14','11:15:00',6.91),('8902','2013-07-14','11:20:00',7),('8902','2013-07-14','11:25:00',7.06),('8902','2013-07-14','11:30:00',7.08),('8902','2013-07-14','11:35:00',7.13),('8902','2013-07-14','11:40:00',7.17),('8902','2013-07-14','11:45:00',7.17),('8902','2013-07-14','11:50:00',7.27),('8902','2013-07-14','11:55:00',7.34),('8902','2013-07-14','12:00:00',7.49),('8902','2013-07-14','12:05:00',7.47),('8902','2013-07-14','12:10:00',7.49),('8902','2013-07-14','12:15:00',7.57),('8902','2013-07-14','12:20:00',7.63),('8902','2013-07-14','12:25:00',7.63),('8902','2013-07-14','12:30:00',7.7),('8902','2013-07-14','12:35:00',7.66),('8902','2013-07-14','12:40:00',7.69),('8902','2013-07-14','12:45:00',7.66),('8902','2013-07-14','12:50:00',7.73),('8902','2013-07-14','12:55:00',7.77),('8902','2013-07-14','13:00:00',7.81),('8902','2013-07-14','13:05:00',7.24),('8902','2013-07-14','13:10:00',7.98),('8902','2013-07-14','13:15:00',7.84),('8902','2013-07-14','13:20:00',7.83),('8902','2013-07-14','13:25:00',8.11),('8902','2013-07-14','13:30:00',8.28),('8902','2013-07-14','13:35:00',6.71),('8902','2013-07-14','13:40:00',2.18),('8902','2013-07-14','13:45:00',3.34),('8902','2013-07-14','13:50:00',8.82),('8902','2013-07-14','13:55:00',8.6),('8902','2013-07-14','14:00:00',8.52),('8902','2013-07-14','14:05:00',5.19),('8902','2013-07-14','14:10:00',1.91),('8902','2013-07-14','14:15:00',3.11),('8902','2013-07-14','14:20:00',5.83),('8902','2013-07-14','14:25:00',8.36),('8902','2013-07-14','14:30:00',5.46),('8902','2013-07-14','14:35:00',6.34),('8902','2013-07-14','14:40:00',8.08),('8902','2013-07-14','14:45:00',7.96),('8902','2013-07-14','14:50:00',7.94),('8902','2013-07-14','14:55:00',7.92),('8902','2013-07-14','15:00:00',7.78),('8902','2013-07-14','15:05:00',7.65),('8902','2013-07-14','15:10:00',7.58),('8902','2013-07-14','15:15:00',6.61),('8902','2013-07-14','15:20:00',6.93),('8902','2013-07-14','15:25:00',6.84),('8902','2013-07-14','15:30:00',6.36),('8902','2013-07-14','15:35:00',4.29),('8902','2013-07-14','15:40:00',7.29),('8902','2013-07-14','15:45:00',6.94),('8902','2013-07-14','15:50:00',6.99),('8902','2013-07-14','15:55:00',6.78),('8902','2013-07-14','16:00:00',6.62),('8902','2013-07-14','16:05:00',6.56),('8902','2013-07-14','16:10:00',6.39),('8902','2013-07-14','16:15:00',6.3),('8902','2013-07-14','16:20:00',6.08),('8902','2013-07-14','16:25:00',5.93),('8902','2013-07-14','16:30:00',5.82),('8902','2013-07-14','16:35:00',5.8),('8902','2013-07-14','16:40:00',5.53),('8902','2013-07-14','16:45:00',5.5),('8902','2013-07-14','16:50:00',5.38),('8902','2013-07-14','16:55:00',5.25),('8902','2013-07-14','17:00:00',5.04),('8902','2013-07-14','17:05:00',5.01),('8902','2013-07-14','17:10:00',4.83),('8902','2013-07-14','17:15:00',4.72),('8902','2013-07-14','17:20:00',4.59),('8902','2013-07-14','17:25:00',4.4),('8902','2013-07-14','17:30:00',4.25),('8902','2013-07-14','17:35:00',4.13),('8902','2013-07-14','17:40:00',3.93),('8902','2013-07-14','17:45:00',3.72),('8902','2013-07-14','17:50:00',3.59),('8902','2013-07-14','17:55:00',3.39),('8902','2013-07-14','18:00:00',3.18),('8902','2013-07-14','18:05:00',3.04),('8902','2013-07-14','18:10:00',2.89),('8902','2013-07-14','18:15:00',2.72),('8902','2013-07-14','18:20:00',2.56),('8902','2013-07-14','18:25:00',2.38),('8902','2013-07-14','18:30:00',2.22),('8902','2013-07-14','18:35:00',2.01),('8902','2013-07-14','18:40:00',1.9),('8902','2013-07-14','18:45:00',1.75),('8902','2013-07-14','18:50:00',1.6),('8902','2013-07-14','18:55:00',1.44),('8902','2013-07-14','19:00:00',1.3),('8902','2013-07-14','19:05:00',1.17),('8902','2013-07-14','19:10:00',1.03),('8902','2013-07-13','07:40:00',1.15),('8902','2013-07-13','07:45:00',1.36),('8902','2013-07-13','07:50:00',1.73),('8902','2013-07-13','07:55:00',2.05),('8902','2013-07-13','08:00:00',1.86),('8902','2013-07-13','08:05:00',2.84),('8902','2013-07-13','08:10:00',2.97),('8902','2013-07-13','08:15:00',2.83),('8902','2013-07-13','08:20:00',3.52),('8902','2013-07-13','08:25:00',2.73),('8902','2013-07-13','08:30:00',1.73),('8902','2013-07-13','08:35:00',2.08),('8902','2013-07-13','08:40:00',2.13),('8902','2013-07-13','08:45:00',1.77),('8902','2013-07-13','08:50:00',2.02),('8902','2013-07-13','08:55:00',2.26),('8902','2013-07-13','09:00:00',1.94),('8902','2013-07-13','09:05:00',2.14),('8902','2013-07-13','09:10:00',2.25),('8902','2013-07-13','09:15:00',3.04),('8902','2013-07-13','09:20:00',3.17),('8902','2013-07-13','09:25:00',3.89),('8902','2013-07-13','09:30:00',3.99),('8902','2013-07-13','09:35:00',3.49),('8902','2013-07-13','09:40:00',3.16),('8902','2013-07-13','09:45:00',3.19),('8902','2013-07-13','09:50:00',3.04),('8902','2013-07-13','09:55:00',3.19),('8902','2013-07-13','10:00:00',3.16),('8902','2013-07-13','10:05:00',3.33),('8902','2013-07-13','10:10:00',3.33),('8902','2013-07-13','10:15:00',3.61),('8902','2013-07-13','10:20:00',4.4),('8902','2013-07-13','10:25:00',4.75),('8902','2013-07-13','10:30:00',4.85),('8902','2013-07-13','10:35:00',6.68),('8902','2013-07-13','10:40:00',6.99),('8902','2013-07-13','10:45:00',5.75),('8902','2013-07-13','10:50:00',7.15),('8902','2013-07-13','10:55:00',6.53),('8902','2013-07-13','11:00:00',7.24),('8902','2013-07-13','11:05:00',5.47),('8902','2013-07-13','11:10:00',6.53),('8902','2013-07-13','11:15:00',6.84),('8902','2013-07-13','11:20:00',8.05),('8902','2013-07-13','11:25:00',7.58),('8902','2013-07-13','11:30:00',8.03),('8902','2013-07-13','11:35:00',7.92),('8902','2013-07-13','11:40:00',7.69),('8902','2013-07-13','11:45:00',6.49),('8902','2013-07-13','11:50:00',3.62),('8902','2013-07-13','11:55:00',2.86),('8902','2013-07-13','12:00:00',2.91),('8902','2013-07-13','12:05:00',3.21),('8902','2013-07-13','12:10:00',4.33),('8902','2013-07-13','12:15:00',7.39),('8902','2013-07-13','12:20:00',8.4),('8902','2013-07-13','12:25:00',5.75),('8902','2013-07-13','12:30:00',3.18),('8902','2013-07-13','12:35:00',6.18),('8902','2013-07-13','12:40:00',8.33),('8902','2013-07-13','12:45:00',8.45),('8902','2013-07-13','12:50:00',8.27),('8902','2013-07-13','12:55:00',2.99),('8902','2013-07-13','13:00:00',3.66),('8902','2013-07-13','13:05:00',8.88),('8902','2013-07-13','13:10:00',8.55),('8902','2013-07-13','13:15:00',8.3),('8902','2013-07-13','13:20:00',5.1),('8902','2013-07-13','13:25:00',8.64),('8902','2013-07-13','13:30:00',7.88),('8902','2013-07-13','13:35:00',8.21),('8902','2013-07-13','13:40:00',8.23),('8902','2013-07-13','13:45:00',8.15),('8902','2013-07-13','13:50:00',8.19),('8902','2013-07-13','13:55:00',8.14),('8902','2013-07-13','14:00:00',8.15),('8902','2013-07-13','14:05:00',8.25),('8902','2013-07-13','14:10:00',8.18),('8902','2013-07-13','14:15:00',8.1),('8902','2013-07-13','14:20:00',8.01),('8902','2013-07-13','14:25:00',8.01),('8902','2013-07-13','14:30:00',7.98),('8902','2013-07-13','14:35:00',7.86),('8902','2013-07-13','14:40:00',7.81),('8902','2013-07-13','14:45:00',7.67),('8902','2013-07-13','14:50:00',7.64),('8902','2013-07-13','14:55:00',7.7),('8902','2013-07-13','15:00:00',7.54),('8902','2013-07-13','15:05:00',7.52),('8902','2013-07-13','15:10:00',7.41),('8902','2013-07-13','15:15:00',7.33),('8902','2013-07-13','15:20:00',7.3),('8902','2013-07-13','15:25:00',7.2),('8902','2013-07-13','15:30:00',7.12),('8902','2013-07-13','15:35:00',7.02),('8902','2013-07-13','15:40:00',6.97),('8902','2013-07-13','15:45:00',6.87),('8902','2013-07-13','15:50:00',6.42),('8902','2013-07-13','15:55:00',6.81),('8902','2013-07-13','16:00:00',6.57),('8902','2013-07-13','16:05:00',6.62),('8902','2013-07-13','16:10:00',6.54),('8902','2013-07-13','16:15:00',6.44),('8902','2013-07-13','16:20:00',6.35),('8902','2013-07-13','16:25:00',5.69),('8902','2013-07-13','16:30:00',4.6),('8902','2013-07-13','16:35:00',5.95),('8902','2013-07-13','16:40:00',5.87),('8902','2013-07-13','16:45:00',5.57),('8902','2013-07-13','16:50:00',5.71),('8902','2013-07-13','16:55:00',5.18),('8902','2013-07-13','17:00:00',3.91),('8902','2013-07-13','17:05:00',4.66),('8902','2013-07-13','17:10:00',3.61),('8902','2013-07-13','17:15:00',4.85),('8902','2013-07-13','17:20:00',2.47),('8902','2013-07-13','17:25:00',4.15),('8902','2013-07-13','17:30:00',4.91),('8902','2013-07-13','17:35:00',4.29),('8902','2013-07-13','17:40:00',2.31),('8902','2013-07-13','17:45:00',1.94),('8902','2013-07-13','17:50:00',2.33),('8902','2013-07-13','17:55:00',3.04),('8902','2013-07-13','18:00:00',2.15),('8902','2013-07-13','18:05:00',1.42),('8902','2013-07-13','18:10:00',1.6),('8902','2013-07-13','18:40:00',1.21),('8902','2013-07-13','18:45:00',1.43),('8902','2013-07-13','18:50:00',1.36),('8902','2013-07-13','18:55:00',1.12),('8902','2013-07-13','19:10:00',1.21),('8902','2013-07-13','19:15:00',1.42),('8902','2013-07-13','19:20:00',1.47),('8902','2013-07-13','19:25:00',1.06),('8902','2013-07-12','07:25:00',1.09),('8902','2013-07-12','07:30:00',1.3),('8902','2013-07-12','07:35:00',1.29),('8902','2013-07-12','07:40:00',1.36),('8902','2013-07-12','07:45:00',1.47),('8902','2013-07-12','07:50:00',1.59),('8902','2013-07-12','07:55:00',1.74),('8902','2013-07-12','08:00:00',1.86),('8902','2013-07-12','08:05:00',2.02),('8902','2013-07-12','08:10:00',2.18),('8902','2013-07-12','08:15:00',2.35),('8902','2013-07-12','08:20:00',2.48),('8902','2013-07-12','08:25:00',2.64),('8902','2013-07-12','08:30:00',2.8),('8902','2013-07-12','08:35:00',2.94),('8902','2013-07-12','08:40:00',3.08),('8902','2013-07-12','08:45:00',3.23),('8902','2013-07-12','08:50:00',3.43),('8902','2013-07-12','08:55:00',3.59),('8902','2013-07-12','09:00:00',3.74),('8902','2013-07-12','09:05:00',3.89),('8902','2013-07-12','09:10:00',4),('8902','2013-07-12','09:15:00',4.15),('8902','2013-07-12','09:20:00',4.29),('8902','2013-07-12','09:25:00',4.52),('8902','2013-07-12','09:30:00',4.62),('8902','2013-07-12','09:35:00',4.69),('8902','2013-07-12','09:40:00',4.87),('8902','2013-07-12','09:45:00',4.8),('8902','2013-07-12','09:50:00',5.04),('8902','2013-07-12','09:55:00',5.21),('8902','2013-07-12','10:00:00',5.41),('8902','2013-07-12','10:05:00',5.56),('8902','2013-07-12','10:10:00',5.6),('8902','2013-07-12','10:15:00',5.77),('8902','2013-07-12','10:20:00',5.91),('8902','2013-07-12','10:25:00',6.1),('8902','2013-07-12','10:30:00',6.13),('8902','2013-07-12','10:35:00',5.98),('8902','2013-07-12','10:40:00',5.93),('8902','2013-07-12','10:45:00',5.05),('8902','2013-07-12','10:50:00',2.35),('8902','2013-07-12','10:55:00',5.32),('8902','2013-07-12','11:00:00',7.12),('8902','2013-07-12','11:05:00',7.12),('8902','2013-07-12','11:10:00',5.94),('8902','2013-07-12','11:15:00',7.48),('8902','2013-07-12','11:20:00',6.12),('8902','2013-07-12','11:25:00',4.07),('8902','2013-07-12','11:30:00',7.46),('8902','2013-07-12','11:35:00',7.45),('8902','2013-07-12','11:40:00',7.32),('8902','2013-07-12','11:45:00',4.79),('8902','2013-07-12','11:50:00',2.61),('8902','2013-07-12','11:55:00',5.88),('8902','2013-07-12','12:00:00',7.43),('8902','2013-07-12','12:05:00',2.47),('8902','2013-07-12','12:10:00',6.65),('8902','2013-07-12','12:15:00',7.4),('8902','2013-07-12','12:20:00',2.58),('8902','2013-07-12','12:25:00',7.36),('8902','2013-07-12','12:30:00',6.97),('8902','2013-07-12','12:35:00',6.4),('8902','2013-07-12','12:40:00',8.07),('8902','2013-07-12','12:45:00',8.3),('8902','2013-07-12','12:50:00',7.89),('8902','2013-07-12','12:55:00',7.84),('8902','2013-07-12','13:00:00',2.92),('8902','2013-07-12','13:05:00',7.66),('8902','2013-07-12','13:10:00',8.56),('8902','2013-07-12','13:15:00',6.81),('8902','2013-07-12','13:20:00',8.32),('8902','2013-07-12','13:25:00',8.16),('8902','2013-07-12','13:30:00',7.91),('8902','2013-07-12','13:35:00',8.07),('8902','2013-07-12','13:40:00',8.07),('8902','2013-07-12','13:45:00',7.99),('8902','2013-07-12','13:50:00',8.02),('8902','2013-07-12','13:55:00',7.99),('8902','2013-07-12','14:00:00',8),('8902','2013-07-12','14:05:00',8.02),('8902','2013-07-12','14:10:00',7.99),('8902','2013-07-12','14:15:00',7.96),('8902','2013-07-12','14:20:00',7.91),('8902','2013-07-12','14:25:00',7.87),('8902','2013-07-12','14:30:00',7.85),('8902','2013-07-12','14:35:00',7.8),('8902','2013-07-12','14:40:00',7.77),('8902','2013-07-12','14:45:00',7.78),('8902','2013-07-12','14:50:00',7.78),('8902','2013-07-12','14:55:00',7.67),('8902','2013-07-12','15:00:00',7.65),('8902','2013-07-12','15:05:00',7.67),('8902','2013-07-12','15:10:00',7.59),('8902','2013-07-12','15:15:00',7.54),('8902','2013-07-12','15:20:00',7.21),('8902','2013-07-12','15:25:00',7.43),('8902','2013-07-12','15:30:00',7.28),('8902','2013-07-12','15:35:00',7.39),('8902','2013-07-12','15:40:00',7.27),('8902','2013-07-12','15:45:00',7.16),('8902','2013-07-12','15:50:00',7.05),('8902','2013-07-12','15:55:00',6.98),('8902','2013-07-12','16:00:00',6.9),('8902','2013-07-12','16:05:00',6.76),('8902','2013-07-12','16:10:00',6.65),('8902','2013-07-12','16:15:00',6.5),('8902','2013-07-12','16:20:00',6.37),('8902','2013-07-12','16:25:00',6.39),('8902','2013-07-12','16:30:00',6.27),('8902','2013-07-12','16:35:00',6.1),('8902','2013-07-12','16:40:00',5.86),('8902','2013-07-12','16:45:00',5.78),('8902','2013-07-12','16:50:00',5.65),('8902','2013-07-12','16:55:00',5.51),('8902','2013-07-12','17:00:00',5.26),('8902','2013-07-12','17:05:00',5.12),('8902','2013-07-12','17:10:00',5.11),('8902','2013-07-12','17:15:00',4.91),('8902','2013-07-12','17:20:00',4.65),('8902','2013-07-12','17:25:00',4.64),('8902','2013-07-12','17:30:00',4.42),('8902','2013-07-12','17:35:00',4.24),('8902','2013-07-12','17:40:00',4.16),('8902','2013-07-12','17:45:00',3.98),('8902','2013-07-12','17:50:00',3.82),('8902','2013-07-12','17:55:00',3.74),('8902','2013-07-12','18:00:00',3.42),('8902','2013-07-12','18:05:00',3.19),('8902','2013-07-12','18:10:00',3.13),('8902','2013-07-12','18:15:00',2.95),('8902','2013-07-12','18:20:00',2.85),('8902','2013-07-12','18:25:00',2.66),('8902','2013-07-12','18:30:00',2.41),('8902','2013-07-12','18:35:00',2.22),('8902','2013-07-12','18:40:00',1.5),('8902','2013-07-12','18:45:00',1.01),('8902','2013-07-12','18:50:00',1.46),('8902','2013-07-12','18:55:00',1.66),('8902','2013-07-12','19:00:00',1.53),('8902','2013-07-12','19:05:00',1.35),('8902','2013-07-12','19:10:00',1.14),('8902','2013-07-11','07:20:00',1.02),('8902','2013-07-11','07:25:00',1.15),('8902','2013-07-11','07:30:00',1.22),('8902','2013-07-11','07:35:00',1.28),('8902','2013-07-11','07:40:00',1.06),('8902','2013-07-11','07:45:00',1.19),('8902','2013-07-11','07:50:00',1.35),('8902','2013-07-11','07:55:00',1.04),('8902','2013-07-11','08:05:00',1.21),('8902','2013-07-11','08:10:00',2.02),('8902','2013-07-11','08:15:00',2.64),('8902','2013-07-11','08:20:00',3.18),('8902','2013-07-11','08:25:00',1.71),('8902','2013-07-11','08:30:00',1.31),('8902','2013-07-11','08:35:00',1.7),('8902','2013-07-11','08:40:00',2.14),('8902','2013-07-11','08:45:00',2.44),('8902','2013-07-11','08:50:00',1.89),('8902','2013-07-11','08:55:00',1.43),('8902','2013-07-11','09:00:00',1.39),('8902','2013-07-11','09:05:00',1.7),('8902','2013-07-11','09:10:00',2.24),('8902','2013-07-11','09:15:00',2.87),('8902','2013-07-11','09:20:00',3.24),('8902','2013-07-11','09:25:00',4.57),('8902','2013-07-11','09:30:00',2.98),('8902','2013-07-11','09:35:00',3.74),('8902','2013-07-11','09:40:00',3.51),('8902','2013-07-11','09:45:00',4.8),('8902','2013-07-11','09:50:00',5.12),('8902','2013-07-11','09:55:00',5.13),('8902','2013-07-11','10:00:00',4.48),('8902','2013-07-11','10:05:00',5.26),('8902','2013-07-11','10:10:00',5.46),('8902','2013-07-11','10:15:00',4.7),('8902','2013-07-11','10:20:00',2.15),('8902','2013-07-11','10:25:00',3.81),('8902','2013-07-11','10:30:00',3.97),('8902','2013-07-11','10:35:00',4.88),('8902','2013-07-11','10:40:00',2.16),('8902','2013-07-11','10:45:00',1.65),('8902','2013-07-11','10:50:00',2.17),('8902','2013-07-11','10:55:00',5.47),('8902','2013-07-11','11:00:00',7.77),('8902','2013-07-11','11:05:00',3.97),('8902','2013-07-11','11:10:00',2.26),('8902','2013-07-11','11:15:00',6.24),('8902','2013-07-11','11:20:00',2.99),('8902','2013-07-11','11:25:00',5.95),('8902','2013-07-11','11:30:00',7.35),('8902','2013-07-11','11:35:00',6.97),('8902','2013-07-11','11:40:00',2.53),('8902','2013-07-11','11:45:00',4.22),('8902','2013-07-11','11:50:00',3.31),('8902','2013-07-11','11:55:00',8.17),('8902','2013-07-11','12:00:00',8.09),('8902','2013-07-11','12:05:00',8.16),('8902','2013-07-11','12:10:00',5.16),('8902','2013-07-11','12:15:00',4.62),('8902','2013-07-11','12:20:00',8.33),('8902','2013-07-11','12:25:00',8.54),('8902','2013-07-11','12:30:00',6.36),('8902','2013-07-11','12:35:00',8.89),('8902','2013-07-11','12:40:00',3.8),('8902','2013-07-11','12:45:00',8.29),('8902','2013-07-11','12:50:00',4.54),('8902','2013-07-11','12:55:00',8.08),('8902','2013-07-11','13:00:00',7.93),('8902','2013-07-11','13:05:00',8.34),('8902','2013-07-11','13:10:00',8.18),('8902','2013-07-11','13:15:00',7.75),('8902','2013-07-11','13:20:00',8.18),('8902','2013-07-11','13:25:00',8.14),('8902','2013-07-11','13:30:00',8.17),('8902','2013-07-11','13:35:00',8.14),('8902','2013-07-11','13:40:00',8.12),('8902','2013-07-11','13:45:00',8.06),('8902','2013-07-11','13:50:00',4.97),('8902','2013-07-11','13:55:00',8.35),('8902','2013-07-11','14:00:00',8.38),('8902','2013-07-11','14:05:00',7.93),('8902','2013-07-11','14:10:00',6.58),('8902','2013-07-11','14:15:00',5.83),('8902','2013-07-11','14:20:00',8.73),('8902','2013-07-11','14:25:00',8.23),('8902','2013-07-11','14:30:00',7.97),('8902','2013-07-11','14:35:00',7.53),('8902','2013-07-11','14:40:00',7.64),('8902','2013-07-11','14:45:00',7.54),('8902','2013-07-11','14:50:00',7.54),('8902','2013-07-11','14:55:00',7.6),('8902','2013-07-11','15:00:00',7.46),('8902','2013-07-11','15:05:00',7.41),('8902','2013-07-11','15:10:00',7.48),('8902','2013-07-11','15:15:00',7.36),('8902','2013-07-11','15:20:00',7.26),('8902','2013-07-11','15:25:00',7.2),('8902','2013-07-11','15:30:00',7.11),('8902','2013-07-11','15:35:00',7.04),('8902','2013-07-11','15:40:00',7.1),('8902','2013-07-11','15:45:00',6.92),('8902','2013-07-11','15:50:00',6.81),('8902','2013-07-11','15:55:00',6.6),('8902','2013-07-11','16:00:00',6.61),('8902','2013-07-11','16:05:00',6.47),('8902','2013-07-11','16:10:00',6.39),('8902','2013-07-11','16:15:00',6.29),('8902','2013-07-11','16:20:00',6.17),('8902','2013-07-11','16:25:00',6.11),('8902','2013-07-11','16:30:00',5.96),('8902','2013-07-11','16:35:00',5.87),('8902','2013-07-11','16:40:00',5.7),('8902','2013-07-11','16:45:00',5.67),('8902','2013-07-11','16:50:00',5.51),('8902','2013-07-11','16:55:00',5.26),('8902','2013-07-11','17:00:00',5.04),('8902','2013-07-11','17:05:00',5.04),('8902','2013-07-11','17:10:00',4.9),('8902','2013-07-11','17:15:00',4.78),('8902','2013-07-11','17:20:00',4.6),('8902','2013-07-11','17:25:00',4.36),('8902','2013-07-11','17:30:00',4.27),('8902','2013-07-11','17:35:00',4.11),('8902','2013-07-11','17:40:00',3.99),('8902','2013-07-11','17:45:00',3.75),('8902','2013-07-11','17:50:00',3.6),('8902','2013-07-11','17:55:00',3.48),('8902','2013-07-11','18:00:00',3.26),('8902','2013-07-11','18:05:00',3.16),('8902','2013-07-11','18:10:00',2.97),('8902','2013-07-11','18:15:00',2.77),('8902','2013-07-11','18:20:00',2.61),('8902','2013-07-11','18:25:00',2.46),('8902','2013-07-11','18:30:00',2.29),('8902','2013-07-11','18:35:00',2.11),('8902','2013-07-11','18:40:00',1.93),('8902','2013-07-11','18:45:00',1.75),('8902','2013-07-11','18:50:00',1.58),('8902','2013-07-11','18:55:00',1.44),('8902','2013-07-11','19:00:00',1.3),('8902','2013-07-11','19:05:00',1.18),('8902','2013-07-11','19:10:00',1.04),('8902','2013-07-10','07:30:00',1.08),('8902','2013-07-10','07:35:00',1.27),('8902','2013-07-10','07:40:00',1.41),('8902','2013-07-10','07:45:00',1.51),('8902','2013-07-10','07:50:00',1.64),('8902','2013-07-10','07:55:00',1.8),('8902','2013-07-10','08:00:00',1.94),('8902','2013-07-10','08:05:00',2.09),('8902','2013-07-10','08:10:00',2.22),('8902','2013-07-10','08:15:00',2.37),('8902','2013-07-10','08:20:00',2.56),('8902','2013-07-10','08:25:00',2.72),('8902','2013-07-10','08:30:00',2.85),('8902','2013-07-10','08:35:00',3),('8902','2013-07-10','08:40:00',3.09),('8902','2013-07-10','08:45:00',3.34),('8902','2013-07-10','08:50:00',3.46),('8902','2013-07-10','08:55:00',3.54),('8902','2013-07-10','09:00:00',3.8),('8902','2013-07-10','09:05:00',3.95),('8902','2013-07-10','09:10:00',4.05),('8902','2013-07-10','09:15:00',4.27),('8902','2013-07-10','09:20:00',4.6),('8902','2013-07-10','09:25:00',4.6),('8902','2013-07-10','09:30:00',4.42),('8902','2013-07-10','09:35:00',2.93),('8902','2013-07-10','09:40:00',5.15),('8902','2013-07-10','09:45:00',5.28),('8902','2013-07-10','09:50:00',3.83),('8902','2013-07-10','09:55:00',2.7),('8902','2013-07-10','10:00:00',2.72),('8902','2013-07-10','10:05:00',4.58),('8902','2013-07-10','10:10:00',4.58),('8902','2013-07-10','10:15:00',5.97),('8902','2013-07-10','10:20:00',6.14),('8902','2013-07-10','10:25:00',5.95),('8902','2013-07-10','10:30:00',5.48),('8902','2013-07-10','10:35:00',2.58),('8902','2013-07-10','10:40:00',2.05),('8902','2013-07-10','10:45:00',3.14),('8902','2013-07-10','10:50:00',5.91),('8902','2013-07-10','10:55:00',7.18),('8902','2013-07-10','11:00:00',6.71),('8902','2013-07-10','11:05:00',2.7),('8902','2013-07-10','11:10:00',6.7),('8902','2013-07-10','11:15:00',6.56),('8902','2013-07-10','11:20:00',6.14),('8902','2013-07-10','11:25:00',6.66),('8902','2013-07-10','11:30:00',7.68),('8902','2013-07-10','11:35:00',7.33),('8902','2013-07-10','11:40:00',6.23),('8902','2013-07-10','11:45:00',6.88),('8902','2013-07-10','11:50:00',6.73),('8902','2013-07-10','11:55:00',6.06),('8902','2013-07-10','12:00:00',3.58),('8902','2013-07-10','12:05:00',5.67),('8902','2013-07-10','12:10:00',2.38),('8902','2013-07-10','12:15:00',3.87),('8902','2013-07-10','12:20:00',8.54),('8902','2013-07-10','12:25:00',8.26),('8902','2013-07-10','12:30:00',8.27),('8902','2013-07-10','12:35:00',8.6),('8902','2013-07-10','12:40:00',8.42),('8902','2013-07-10','12:45:00',8.14),('8902','2013-07-10','12:50:00',6.17),('8902','2013-07-10','12:55:00',8.2),('8902','2013-07-10','13:00:00',6.79),('8902','2013-07-10','13:05:00',2.92),('8902','2013-07-10','13:10:00',6.8),('8902','2013-07-10','13:15:00',8.68),('8902','2013-07-10','13:20:00',8.4),('8902','2013-07-10','13:25:00',8.34),('8902','2013-07-10','13:30:00',8.44),('8902','2013-07-10','13:35:00',8.65),('8902','2013-07-10','13:40:00',8.33),('8902','2013-07-10','13:45:00',8.38),('8902','2013-07-10','13:50:00',5.55),('8902','2013-07-10','13:55:00',2.7),('8902','2013-07-10','14:00:00',5.44),('8902','2013-07-10','14:05:00',8.05),('8902','2013-07-10','14:10:00',7.77),('8902','2013-07-10','14:15:00',8.45),('8902','2013-07-10','14:20:00',7.6),('8902','2013-07-10','14:25:00',8.1),('8902','2013-07-10','14:30:00',6.63),('8902','2013-07-10','14:35:00',8.08),('8902','2013-07-10','14:40:00',7.92),('8902','2013-07-10','14:45:00',8.06),('8902','2013-07-10','14:50:00',7.84),('8902','2013-07-10','14:55:00',4.55),('8902','2013-07-10','15:00:00',7.45),('8902','2013-07-10','15:05:00',6.57),('8902','2013-07-10','15:10:00',4.59),('8902','2013-07-10','15:15:00',5.37),('8902','2013-07-10','15:20:00',5.49),('8902','2013-07-10','15:25:00',4.89),('8902','2013-07-10','15:30:00',5.96),('8902','2013-07-10','15:35:00',7.34),('8902','2013-07-10','15:40:00',5.59),('8902','2013-07-10','15:45:00',4.82),('8902','2013-07-10','15:50:00',5.86),('8902','2013-07-10','15:55:00',3.49),('8902','2013-07-10','16:00:00',4.89),('8902','2013-07-10','16:05:00',5.65),('8902','2013-07-10','16:10:00',6.51),('8902','2013-07-10','16:15:00',6.11),('8902','2013-07-10','16:20:00',6.97),('8902','2013-07-10','16:25:00',6.28),('8902','2013-07-10','16:30:00',6.87),('8902','2013-07-10','16:35:00',5.37),('8902','2013-07-10','16:40:00',6.24),('8902','2013-07-10','16:45:00',5.06),('8902','2013-07-10','16:50:00',6.22),('8902','2013-07-10','16:55:00',5.07),('8902','2013-07-10','17:00:00',4.72),('8902','2013-07-10','17:05:00',5.61),('8902','2013-07-10','17:10:00',5.42),('8902','2013-07-10','17:15:00',4.49),('8902','2013-07-10','17:20:00',4.78),('8902','2013-07-10','17:25:00',2.63),('8902','2013-07-10','17:30:00',4.36),('8902','2013-07-10','17:35:00',4.48),('8902','2013-07-10','17:40:00',3.46),('8902','2013-07-10','17:45:00',4.19),('8902','2013-07-10','17:50:00',2.86),('8902','2013-07-10','17:55:00',3.67),('8902','2013-07-10','18:00:00',2.74),('8902','2013-07-10','18:05:00',2.95),('8902','2013-07-10','18:10:00',2.96),('8902','2013-07-10','18:15:00',3.08),('8902','2013-07-10','18:20:00',2.38),('8902','2013-07-10','18:25:00',2.51),('8902','2013-07-10','18:30:00',2.57),('8902','2013-07-10','18:35:00',2.17),('8902','2013-07-10','18:40:00',1.26),('8902','2013-07-10','18:45:00',1.34),('8902','2013-07-10','18:50:00',1.02),('8902','2013-07-10','19:05:00',1.01),('8902','2014-05-02','07:35:00',1.18),('8902','2014-05-02','07:40:00',1.38),('8902','2014-05-02','07:45:00',1.58),('8902','2014-05-02','07:50:00',1.78),('8902','2014-05-02','07:55:00',2.01),('8902','2014-05-02','08:00:00',1.99),('8902','2014-05-02','08:05:00',2.54),('8902','2014-05-02','08:10:00',2.72),('8902','2014-05-02','08:15:00',2.82),('8902','2014-05-02','08:20:00',2.22),('8902','2014-05-02','08:25:00',1.84),('8902','2014-05-02','08:30:00',1.87),('8902','2014-05-02','08:35:00',1.84),('8902','2014-05-02','08:40:00',2.49),('8902','2014-05-02','08:45:00',3.82),('8902','2014-05-02','08:50:00',4.33),('8902','2014-05-02','08:55:00',4.56),('8902','2014-05-02','09:00:00',5.19),('8902','2014-05-02','09:05:00',5.25),('8902','2014-05-02','09:10:00',2.98),('8902','2014-05-02','09:15:00',2.94),('8902','2014-05-02','09:20:00',5.25),('8902','2014-05-02','09:25:00',5.74),('8902','2014-05-02','09:30:00',5.32),('8902','2014-05-02','09:35:00',4.13),('8902','2014-05-02','09:40:00',2.9),('8902','2014-05-02','09:45:00',4.51),('8902','2014-05-02','09:50:00',3.35),('8902','2014-05-02','09:55:00',6.61),('8902','2014-05-02','10:00:00',6.58),('8902','2014-05-02','10:05:00',6.64),('8902','2014-05-02','10:10:00',6.88),('8902','2014-05-02','10:15:00',6.88),('8902','2014-05-02','10:20:00',5.97),('8902','2014-05-02','10:25:00',4.02),('8902','2014-05-02','10:30:00',3.54),('8902','2014-05-02','10:35:00',1.86),('8902','2014-05-02','10:40:00',2.53),('8902','2014-05-02','10:45:00',4.72),('8902','2014-05-02','10:50:00',2.86),('8902','2014-05-02','10:55:00',4.77),('8902','2014-05-02','11:00:00',3.71),('8902','2014-05-02','11:05:00',6.77),('8902','2014-05-02','11:10:00',8.53),('8902','2014-05-02','11:15:00',3.37),('8902','2014-05-02','11:20:00',5.2),('8902','2014-05-02','11:25:00',7.05),('8902','2014-05-02','11:30:00',8.22),('8902','2014-05-02','11:35:00',4.95),('8902','2014-05-02','11:40:00',5.54),('8902','2014-05-02','11:45:00',4.41),('8902','2014-05-02','11:50:00',4.2),('8902','2014-05-02','11:55:00',4.49),('8902','2014-05-02','12:00:00',3.76),('8902','2014-05-02','12:05:00',3.31),('8902','2014-05-02','12:10:00',3.07),('8902','2014-05-02','12:15:00',2.67),('8902','2014-05-02','12:20:00',2.38),('8902','2014-05-02','12:25:00',2.56),('8902','2014-05-02','12:30:00',3.48),('8902','2014-05-02','12:35:00',4.11),('8902','2014-05-02','12:40:00',3.65),('8902','2014-05-02','12:45:00',3.77),('8902','2014-05-02','12:50:00',3.8),('8902','2014-05-02','12:55:00',3.89),('8902','2014-05-02','13:00:00',3.89),('8902','2014-05-02','13:05:00',3.78),('8902','2014-05-02','13:10:00',5.84),('8902','2014-05-02','13:15:00',4.93),('8902','2014-05-02','13:20:00',5.46),('8902','2014-05-02','13:25:00',5.77),('8902','2014-05-02','13:30:00',5.76),('8902','2014-05-02','13:35:00',3.96),('8902','2014-05-02','13:40:00',3.44),('8902','2014-05-02','13:45:00',3.43),('8902','2014-05-02','13:50:00',3.48),('8902','2014-05-02','13:55:00',3.53),('8902','2014-05-02','14:00:00',3.45),('8902','2014-05-02','14:05:00',3.47),('8902','2014-05-02','14:10:00',3.81),('8902','2014-05-02','14:15:00',4.49),('8902','2014-05-02','14:20:00',5.4),('8902','2014-05-02','14:25:00',7.4),('8902','2014-05-02','14:30:00',3.74),('8902','2014-05-02','14:35:00',3.25),('8902','2014-05-02','14:40:00',2.73),('8902','2014-05-02','14:45:00',1.56),('8902','2014-05-02','14:50:00',1.26),('8902','2014-05-02','14:55:00',2.52),('8902','2014-05-02','15:00:00',2.24),('8902','2014-05-02','15:05:00',2.3),('8902','2014-05-02','15:10:00',1.77),('8902','2014-05-02','15:15:00',1.29),('8902','2014-05-02','15:20:00',1.07),('8902','2014-05-02','15:25:00',1.06),('8902','2014-05-02','15:30:00',1.07),('8902','2014-05-02','15:35:00',1.07),('8902','2014-05-02','15:40:00',1.06),('8902','2014-05-02','16:25:00',1.19),('8902','2014-05-02','16:30:00',1.37),('8902','2014-05-02','16:35:00',1.53),('8902','2014-05-02','16:40:00',1.69),('8902','2014-05-02','16:45:00',1.82),('8902','2014-05-02','16:50:00',1.88),('8902','2014-05-02','16:55:00',1.89),('8902','2014-05-02','17:00:00',1.9),('8902','2014-05-02','17:05:00',1.88),('8902','2014-05-02','17:10:00',1.87),('8902','2014-05-02','17:15:00',1.84),('8902','2014-05-02','17:20:00',1.8),('8902','2014-05-02','17:25:00',1.81),('8902','2014-05-02','17:30:00',1.76),('8902','2014-05-02','17:35:00',1.66),('8902','2014-05-02','17:40:00',1.68),('8902','2014-05-02','17:45:00',1.8),('8902','2014-05-02','17:50:00',2.08),('8902','2014-05-02','17:55:00',2.03),('8902','2014-05-02','18:00:00',1.77),('8902','2014-05-02','18:05:00',1.5),('8902','2014-05-02','18:10:00',1.71),('8902','2014-05-02','18:15:00',1.11),('8902','2014-05-02','18:45:00',1.15),('8902','2014-04-05','08:15:00',1.68),('8902','2014-04-05','08:20:00',1.86),('8902','2014-04-05','08:25:00',2.09),('8902','2014-04-05','08:30:00',2.25),('8902','2014-04-05','08:35:00',2.48),('8902','2014-04-05','08:40:00',2.69),('8902','2014-04-05','08:45:00',2.75),('8902','2014-04-05','08:50:00',2.67),('8902','2014-04-05','08:55:00',1.97),('8902','2014-04-05','09:00:00',3.24),('8902','2014-04-05','09:05:00',3.67),('8902','2014-04-05','09:10:00',3.81),('8902','2014-04-05','09:15:00',4.09),('8902','2014-04-05','09:20:00',3.53),('8902','2014-04-05','09:25:00',3.63),('8902','2014-04-05','09:30:00',3.22),('8902','2014-04-05','09:35:00',4.34),('8902','2014-04-05','09:40:00',4.74),('8902','2014-04-05','09:45:00',6.3),('8902','2014-04-05','09:50:00',6.57),('8902','2014-04-05','09:55:00',6.28),('8902','2014-04-05','10:00:00',6.24),('8902','2014-04-05','10:05:00',5.33),('8902','2014-04-05','10:10:00',5.83),('8902','2014-04-05','10:15:00',4.94),('8902','2014-04-05','10:20:00',3.4),('8902','2014-04-05','10:25:00',2.35),('8902','2014-04-05','10:30:00',2.6),('8902','2014-04-05','10:35:00',2.89),('8902','2014-04-05','10:40:00',3.08),('8902','2014-04-05','10:45:00',6.25),('8902','2014-04-05','10:50:00',6.01),('8902','2014-04-05','10:55:00',2.87),('8902','2014-04-05','11:00:00',4.69),('8902','2014-04-05','11:05:00',3.76),('8902','2014-04-05','11:10:00',6.24),('8902','2014-04-05','11:15:00',6.37),('8902','2014-04-05','11:20:00',7.81),('8902','2014-04-05','11:25:00',7.75),('8902','2014-04-05','11:30:00',8),('8902','2014-04-05','11:35:00',8.45),('8902','2014-04-05','11:40:00',8.3),('8902','2014-04-05','11:45:00',8.15),('8902','2014-04-05','11:50:00',8.29),('8902','2014-04-05','11:55:00',8.54),('8902','2014-04-05','12:00:00',8.17),('8902','2014-04-05','12:05:00',8.13),('8902','2014-04-05','12:10:00',8.14),('8902','2014-04-05','12:15:00',8.42),('8902','2014-04-05','12:20:00',6.76),('8902','2014-04-05','12:25:00',7.57),('8902','2014-04-05','12:30:00',6.63),('8902','2014-04-05','12:35:00',6.95),('8902','2014-04-05','12:40:00',7.09),('8902','2014-04-05','12:45:00',5.97),('8902','2014-04-05','12:50:00',2.7),('8902','2014-04-05','12:55:00',7.16),('8902','2014-04-05','13:00:00',8.8),('8902','2014-04-05','13:05:00',7.35),('8902','2014-04-05','13:10:00',9.49),('8902','2014-04-05','13:15:00',8.11),('8902','2014-04-05','13:20:00',3.53),('8902','2014-04-05','13:25:00',3.09),('8902','2014-04-05','13:30:00',8.2),('8902','2014-04-05','13:35:00',3.24),('8902','2014-04-05','13:40:00',6.51),('8902','2014-04-05','13:45:00',9.18),('8902','2014-04-05','13:50:00',8.12),('8902','2014-04-05','13:55:00',8.57),('8902','2014-04-05','14:00:00',8.39),('8902','2014-04-05','14:05:00',8.36),('8902','2014-04-05','14:10:00',8.43),('8902','2014-04-05','14:15:00',8.56),('8902','2014-04-05','14:20:00',7.62),('8902','2014-04-05','14:25:00',5.09),('8902','2014-04-05','14:30:00',2.13),('8902','2014-04-05','14:35:00',5.93),('8902','2014-04-05','14:40:00',7.69),('8902','2014-04-05','14:45:00',9.29),('8902','2014-04-05','14:50:00',7.09),('8902','2014-04-05','14:55:00',4.56),('8902','2014-04-05','15:00:00',5.1),('8902','2014-04-05','15:05:00',2.75),('8902','2014-04-05','15:10:00',6.15),('8902','2014-04-05','15:15:00',5.95),('8902','2014-04-05','15:20:00',2.87),('8902','2014-04-05','15:25:00',2.01),('8902','2014-04-05','15:30:00',1.53),('8902','2014-04-05','15:35:00',1.33),('8902','2014-04-05','15:40:00',1.43),('8902','2014-04-05','15:45:00',1.89),('8902','2014-04-05','15:50:00',3.38),('8902','2014-04-05','15:55:00',8.35),('8902','2014-04-05','16:00:00',5.74),('8902','2014-04-05','16:05:00',1.95),('8902','2014-04-05','16:10:00',2.98),('8902','2014-04-05','16:15:00',1.21),('8902','2014-04-05','16:20:00',1.06),('8902','2014-04-05','16:25:00',1.61),('8902','2014-04-05','16:30:00',1.79),('8902','2014-04-05','16:35:00',4.57),('8902','2014-04-05','16:40:00',4.17),('8902','2014-04-05','16:45:00',6.36),('8902','2014-04-05','16:50:00',6),('8902','2014-04-05','16:55:00',3.15),('8902','2014-04-05','17:00:00',1.68),('8902','2014-04-05','17:05:00',1.52),('8902','2014-04-05','17:10:00',1.27),('8902','2014-04-05','17:15:00',1.08),('8902','2014-04-05','17:20:00',1.89),('8902','2014-04-05','17:25:00',4.16),('8902','2014-04-05','17:30:00',3.73),('8902','2014-04-05','17:35:00',3.43),('8902','2014-04-05','17:40:00',2.5),('8902','2014-04-05','17:45:00',3.08),('8902','2014-04-05','17:50:00',3.15),('8902','2014-04-05','17:55:00',2.86),('8902','2014-04-05','18:00:00',2.6),('8902','2014-04-05','18:05:00',2.39),('8902','2014-04-05','18:10:00',2.22),('8902','2014-04-05','18:15:00',2.1),('8902','2014-04-05','18:20:00',2.03),('8902','2014-04-05','18:25:00',1.65),('8902','2013-07-09','07:20:00',1.1),('8902','2013-07-09','07:25:00',1.41),('8902','2013-07-09','07:30:00',1.71),('8902','2013-07-09','07:35:00',2.04),('8902','2013-07-09','07:40:00',2.33),('8902','2013-07-09','07:45:00',2.54),('8902','2013-07-09','07:50:00',2.77),('8902','2013-07-09','07:55:00',3.03),('8902','2013-07-09','08:00:00',3.29),('8902','2013-07-09','08:05:00',2.6),('8902','2013-07-09','08:10:00',2.72),('8902','2013-07-09','08:15:00',3.01),('8902','2013-07-09','08:20:00',3.04),('8902','2013-07-09','08:25:00',3.96),('8902','2013-07-09','08:30:00',3.92),('8902','2013-07-09','08:35:00',4.43),('8902','2013-07-09','08:40:00',3.99),('8902','2013-07-09','08:45:00',3.93),('8902','2013-07-09','08:50:00',3.97),('8902','2013-07-09','08:55:00',3.91),('8902','2013-07-09','09:00:00',3.99),('8902','2013-07-09','09:05:00',4.22),('8902','2013-07-09','09:10:00',4.43),('8902','2013-07-09','09:15:00',4.62),('8902','2013-07-09','09:20:00',4.7),('8902','2013-07-09','09:25:00',4.77),('8902','2013-07-09','09:30:00',4.86),('8902','2013-07-09','09:35:00',4.9),('8902','2013-07-09','09:40:00',5.01),('8902','2013-07-09','09:45:00',5.13),('8902','2013-07-09','09:50:00',5.21),('8902','2013-07-09','09:55:00',5.18),('8902','2013-07-09','10:00:00',5.14),('8902','2013-07-09','10:05:00',5.53),('8902','2013-07-09','10:10:00',5.66),('8902','2013-07-09','10:15:00',5.77),('8902','2013-07-09','10:20:00',5.91),('8902','2013-07-09','10:25:00',5.95),('8902','2013-07-09','10:30:00',6.04),('8902','2013-07-09','10:35:00',6.17),('8902','2013-07-09','10:40:00',6.36),('8902','2013-07-09','10:45:00',6.42),('8902','2013-07-09','10:50:00',6.56),('8902','2013-07-09','10:55:00',6.59),('8902','2013-07-09','11:00:00',6.63),('8902','2013-07-09','11:05:00',6.68),('8902','2013-07-09','11:10:00',6.76),('8902','2013-07-09','11:15:00',6.86),('8902','2013-07-09','11:20:00',6.86),('8902','2013-07-09','11:25:00',6.8),('8902','2013-07-09','11:30:00',6.98),('8902','2013-07-09','11:35:00',7.02),('8902','2013-07-09','11:40:00',7.1),('8902','2013-07-09','11:45:00',7.18),('8902','2013-07-09','11:50:00',7.22),('8902','2013-07-09','11:55:00',7.31),('8902','2013-07-09','12:00:00',7.39),('8902','2013-07-09','12:05:00',7.52),('8902','2013-07-09','12:10:00',7.52),('8902','2013-07-09','12:15:00',7.46),('8902','2013-07-09','12:20:00',7.56),('8902','2013-07-09','12:25:00',7.6),('8902','2013-07-09','12:30:00',7.67),('8902','2013-07-09','12:35:00',7.84),('8902','2013-07-09','12:40:00',7.76),('8902','2013-07-09','12:45:00',7.74),('8902','2013-07-09','12:50:00',7.78),('8902','2013-07-09','12:55:00',7.75),('8902','2013-07-09','13:00:00',7.77),('8902','2013-07-09','13:05:00',7.83),('8902','2013-07-09','13:10:00',7.92),('8902','2013-07-09','13:15:00',7.94),('8902','2013-07-09','13:20:00',7.87),('8902','2013-07-09','13:25:00',7.91),('8902','2013-07-09','13:30:00',7.97),('8902','2013-07-09','13:35:00',7.94),('8902','2013-07-09','13:40:00',7.96),('8902','2013-07-09','13:45:00',8.03),('8902','2013-07-09','13:50:00',8.06),('8902','2013-07-09','13:55:00',8.01),('8902','2013-07-09','14:00:00',8.08),('8902','2013-07-09','14:05:00',8.08),('8902','2013-07-09','14:10:00',8.05),('8902','2013-07-09','14:15:00',8.01),('8902','2013-07-09','14:20:00',7.93),('8902','2013-07-09','14:25:00',7.91),('8902','2013-07-09','14:30:00',7.89),('8902','2013-07-09','14:35:00',7.84),('8902','2013-07-09','14:40:00',7.81),('8902','2013-07-09','14:45:00',7.76),('8902','2013-07-09','14:50:00',7.69),('8902','2013-07-09','14:55:00',7.67),('8902','2013-07-09','15:00:00',7.66),('8902','2013-07-09','15:05:00',7.59),('8902','2013-07-09','15:10:00',7.5),('8902','2013-07-09','15:15:00',7.45),('8902','2013-07-09','15:20:00',7.37),('8902','2013-07-09','15:25:00',7.29),('8902','2013-07-09','15:30:00',7.27),('8902','2013-07-09','15:35:00',7.23),('8902','2013-07-09','15:40:00',7.09),('8902','2013-07-09','15:45:00',6.99),('8902','2013-07-09','15:50:00',6.9),('8902','2013-07-09','15:55:00',6.85),('8902','2013-07-09','16:00:00',6.77),('8902','2013-07-09','16:05:00',6.64),('8902','2013-07-09','16:10:00',6.54),('8902','2013-07-09','16:15:00',6.45),('8902','2013-07-09','16:20:00',6.32),('8902','2013-07-09','16:25:00',6.21),('8902','2013-07-09','16:30:00',6.05),('8902','2013-07-09','16:35:00',5.92),('8902','2013-07-09','16:40:00',5.71),('8902','2013-07-09','16:45:00',5.67),('8902','2013-07-09','16:50:00',5.55),('8902','2013-07-09','16:55:00',5.48),('8902','2013-07-09','17:00:00',5.39),('8902','2013-07-09','17:05:00',5.11),('8902','2013-07-09','17:10:00',4.8),('8902','2013-07-09','17:15:00',2.82),('8902','2013-07-09','17:20:00',3.01),('8902','2013-07-09','17:25:00',2.31),('8902','2013-07-09','17:30:00',1.71),('8902','2013-07-09','17:35:00',4.65),('8902','2013-07-09','17:40:00',3.78),('8902','2013-07-09','17:45:00',3.98),('8902','2013-07-09','17:50:00',3.72),('8902','2013-07-09','17:55:00',3.48),('8902','2013-07-09','18:00:00',2.94),('8902','2013-07-09','18:05:00',1.82),('8902','2013-07-09','18:10:00',2.77),('8902','2013-07-09','18:15:00',1.22),('8902','2013-07-09','18:20:00',1.38),('8902','2013-07-09','18:25:00',2.19),('8902','2013-07-09','18:30:00',1.06),('8902','2013-07-09','19:05:00',1.12),('8902','2013-07-09','19:10:00',1.15),('8902','2013-07-09','19:15:00',1.03),('8902','2013-07-08','07:35:00',1.32),('8902','2013-07-08','07:40:00',1.46),('8902','2013-07-08','07:45:00',1.58),('8902','2013-07-08','07:50:00',1.72),('8902','2013-07-08','07:55:00',1.88),('8902','2013-07-08','08:00:00',2.01),('8902','2013-07-08','08:05:00',2.16),('8902','2013-07-08','08:10:00',2.32),('8902','2013-07-08','08:15:00',2.49),('8902','2013-07-08','08:20:00',2.63),('8902','2013-07-08','08:25:00',2.79),('8902','2013-07-08','08:30:00',2.95),('8902','2013-07-08','08:35:00',3.11),('8902','2013-07-08','08:40:00',3.25),('8902','2013-07-08','08:45:00',3.4),('8902','2013-07-08','08:50:00',3.54),('8902','2013-07-08','08:55:00',3.7),('8902','2013-07-08','09:00:00',3.85),('8902','2013-07-08','09:05:00',4),('8902','2013-07-08','09:10:00',4.14),('8902','2013-07-08','09:15:00',4.29),('8902','2013-07-08','09:20:00',4.42),('8902','2013-07-08','09:25:00',4.56),('8902','2013-07-08','09:30:00',4.7),('8902','2013-07-08','09:35:00',4.87),('8902','2013-07-08','09:40:00',4.98),('8902','2013-07-08','09:45:00',5.13),('8902','2013-07-08','09:50:00',5.26),('8902','2013-07-08','09:55:00',5.35),('8902','2013-07-08','10:00:00',5.42),('8902','2013-07-08','10:05:00',5.54),('8902','2013-07-08','10:10:00',5.63),('8902','2013-07-08','10:15:00',5.74),('8902','2013-07-08','10:20:00',5.87),('8902','2013-07-08','10:25:00',5.98),('8902','2013-07-08','10:30:00',6.05),('8902','2013-07-08','10:35:00',6.16),('8902','2013-07-08','10:40:00',6.22),('8902','2013-07-08','10:45:00',6.33),('8902','2013-07-08','10:50:00',6.47),('8902','2013-07-08','10:55:00',6.62),('8902','2013-07-08','11:00:00',6.69),('8902','2013-07-08','11:05:00',6.52),('8902','2013-07-08','11:10:00',5.96),('8902','2013-07-08','11:15:00',6.13),('8902','2013-07-08','11:20:00',6),('8902','2013-07-08','11:25:00',5.57),('8902','2013-07-08','11:30:00',3.32),('8902','2013-07-08','11:35:00',4.15),('8902','2013-07-08','11:40:00',5.87),('8902','2013-07-08','11:45:00',7.14),('8902','2013-07-08','11:50:00',8.22),('8902','2013-07-08','11:55:00',8.23),('8902','2013-07-08','12:00:00',8.24),('8902','2013-07-08','12:05:00',8.1),('8902','2013-07-08','12:10:00',7.9),('8902','2013-07-08','12:15:00',7.49),('8902','2013-07-08','12:20:00',7.46),('8902','2013-07-08','12:25:00',7.46),('8902','2013-07-08','12:30:00',7.51),('8902','2013-07-08','12:35:00',7.55),('8902','2013-07-08','12:40:00',7.65),('8902','2013-07-08','12:45:00',7.69),('8902','2013-07-08','12:50:00',7.84),('8902','2013-07-08','12:55:00',7.83),('8902','2013-07-08','13:00:00',7.8),('8902','2013-07-08','13:05:00',7.86),('8902','2013-07-08','13:10:00',8.06),('8902','2013-07-08','13:15:00',8.18),('8902','2013-07-08','13:20:00',8.15),('8902','2013-07-08','13:25:00',8.03),('8902','2013-07-08','13:30:00',8.2),('8902','2013-07-08','13:35:00',7.64),('8902','2013-07-08','13:40:00',7.44),('8902','2013-07-08','13:45:00',6.4),('8902','2013-07-08','13:50:00',5.89),('8902','2013-07-08','13:55:00',5.68),('8902','2013-07-08','14:00:00',5.89),('8902','2013-07-08','14:05:00',5.71),('8902','2013-07-08','14:10:00',6.46),('8902','2013-07-08','14:15:00',6.75),('8902','2013-07-08','14:20:00',5.68),('8902','2013-07-08','14:25:00',4.3),('8902','2013-07-08','14:30:00',2.71),('8902','2013-07-08','14:35:00',2),('8902','2013-07-08','14:40:00',1.85),('8902','2013-07-08','14:45:00',1.51),('8902','2013-07-08','17:25:00',1.03),('8902','2013-07-08','17:30:00',1.11),('8902','2013-07-08','17:35:00',1.15),('8902','2013-07-08','17:40:00',1.1),('8902','2013-07-07','07:35:00',1.35),('8902','2013-07-07','07:40:00',1.99),('8902','2013-07-07','07:45:00',1.85),('8902','2013-07-07','07:50:00',1.52),('8902','2013-07-07','07:55:00',1.62),('8902','2013-07-07','08:00:00',1.75),('8902','2013-07-07','08:05:00',1.85),('8902','2013-07-07','08:10:00',2.14),('8902','2013-07-07','08:15:00',2.44),('8902','2013-07-07','08:20:00',2.64),('8902','2013-07-07','08:25:00',2.81),('8902','2013-07-07','08:30:00',2.99),('8902','2013-07-07','08:35:00',3.13),('8902','2013-07-07','08:40:00',3.28),('8902','2013-07-07','08:45:00',3.41),('8902','2013-07-07','08:50:00',3.57),('8902','2013-07-07','08:55:00',3.69),('8902','2013-07-07','09:00:00',3.84),('8902','2013-07-07','09:05:00',3.97),('8902','2013-07-07','09:10:00',4.08),('8902','2013-07-07','09:15:00',4.17),('8902','2013-07-07','09:20:00',4.26),('8902','2013-07-07','09:25:00',4.33),('8902','2013-07-07','09:30:00',4.57),('8902','2013-07-07','09:35:00',4.88),('8902','2013-07-07','09:40:00',5),('8902','2013-07-07','09:45:00',5.1),('8902','2013-07-07','09:50:00',5.11),('8902','2013-07-07','09:55:00',5.32),('8902','2013-07-07','10:00:00',5.48),('8902','2013-07-07','10:05:00',5.59),('8902','2013-07-07','10:10:00',5.64),('8902','2013-07-07','10:15:00',5.8),('8902','2013-07-07','10:20:00',5.89),('8902','2013-07-07','10:25:00',6),('8902','2013-07-07','10:30:00',6.13),('8902','2013-07-07','10:35:00',6.2),('8902','2013-07-07','10:40:00',6.27),('8902','2013-07-07','10:45:00',6.33),('8902','2013-07-07','10:50:00',6.4),('8902','2013-07-07','10:55:00',6.47),('8902','2013-07-07','11:00:00',6.55),('8902','2013-07-07','11:05:00',6.69),('8902','2013-07-07','11:10:00',6.8),('8902','2013-07-07','11:15:00',6.92),('8902','2013-07-07','11:20:00',7.04),('8902','2013-07-07','11:25:00',7.11),('8902','2013-07-07','11:30:00',7.24),('8902','2013-07-07','11:35:00',7.33),('8902','2013-07-07','11:40:00',6.92),('8902','2013-07-07','11:45:00',7.38),('8902','2013-07-07','11:50:00',7.45),('8902','2013-07-07','11:55:00',7.31),('8902','2013-07-07','12:00:00',7.47),('8902','2013-07-07','12:05:00',7.66),('8902','2013-07-07','12:10:00',7.76),('8902','2013-07-07','12:15:00',7.88),('8902','2013-07-07','12:20:00',8.12),('8902','2013-07-07','12:25:00',7.93),('8902','2013-07-07','12:30:00',7.42),('8902','2013-07-07','12:35:00',7.96),('8902','2013-07-07','12:40:00',7.82),('8902','2013-07-07','12:45:00',7.82),('8902','2013-07-07','12:50:00',7.86),('8902','2013-07-07','12:55:00',8.01),('8902','2013-07-07','13:00:00',8.21),('8902','2013-07-07','13:05:00',8.3),('8902','2013-07-07','13:10:00',8.67),('8902','2013-07-07','13:15:00',8.58),('8902','2013-07-07','13:20:00',6.08),('8902','2013-07-07','13:25:00',2.5),('8902','2013-07-07','13:30:00',1.34),('8902','2013-07-07','14:00:00',1.17),('8902','2013-07-07','14:05:00',1.42),('8902','2013-07-07','14:10:00',1.49),('8902','2013-07-07','14:15:00',1.5),('8902','2013-07-07','14:20:00',1.52),('8902','2013-07-07','14:25:00',1.63),('8902','2013-07-07','14:30:00',1.82),('8902','2013-07-07','14:35:00',2.09),('8902','2013-07-07','14:40:00',2.13),('8902','2013-07-07','14:45:00',2.02),('8902','2013-07-07','14:50:00',1.95),('8902','2013-07-07','14:55:00',1.91),('8902','2013-07-07','15:00:00',1.77),('8902','2013-07-07','15:05:00',1.6),('8902','2013-07-07','15:10:00',1.46),('8902','2013-07-07','15:15:00',1.31),('8902','2013-07-07','15:20:00',1),('8902','2013-07-07','17:20:00',1.26),('8902','2013-07-07','17:25:00',1.55),('8902','2013-07-07','17:30:00',1.79),('8902','2013-07-07','17:35:00',1.93),('8902','2013-07-07','17:40:00',1.99),('8902','2013-07-07','17:45:00',2),('8902','2013-07-07','17:50:00',2.01),('8902','2013-07-07','17:55:00',1.92),('8902','2013-07-07','18:00:00',1.8),('8902','2013-07-07','18:05:00',1.59),('8902','2013-07-07','18:10:00',1.51),('8902','2013-07-07','18:15:00',1.61),('8902','2013-07-07','18:20:00',1.69),('8902','2013-07-07','18:25:00',1.52),('8902','2013-07-07','18:30:00',1.53),('8902','2013-07-07','18:35:00',1.86),('8902','2013-07-07','18:40:00',2.29),('8902','2013-07-07','18:45:00',2.06),('8902','2013-07-07','18:50:00',1.79),('8902','2013-07-07','18:55:00',1.58),('8902','2013-07-07','19:00:00',1.41),('8902','2013-07-07','19:05:00',1.1),('8902','2013-07-06','07:30:00',1.09),('8902','2013-07-06','07:35:00',1.3),('8902','2013-07-06','07:40:00',1.46),('8902','2013-07-06','07:45:00',1.61),('8902','2013-07-06','07:50:00',1.77),('8902','2013-07-06','07:55:00',1.93),('8902','2013-07-06','08:00:00',2.11),('8902','2013-07-06','08:05:00',2.27),('8902','2013-07-06','08:10:00',2.44),('8902','2013-07-06','08:15:00',2.25),('8902','2013-07-06','08:20:00',2.06),('8902','2013-07-06','08:25:00',2.29),('8902','2013-07-06','08:30:00',2.93),('8902','2013-07-06','08:35:00',3.41),('8902','2013-07-06','08:40:00',2.2),('8902','2013-07-06','08:45:00',1.51),('8902','2013-07-06','08:50:00',3.3),('8902','2013-07-06','08:55:00',3.88),('8902','2013-07-06','09:00:00',3.95),('8902','2013-07-06','09:05:00',3.81),('8902','2013-07-06','09:10:00',3.91),('8902','2013-07-06','09:15:00',3.86),('8902','2013-07-06','09:20:00',2.59),('8902','2013-07-06','09:25:00',3.98),('8902','2013-07-06','09:30:00',4.87),('8902','2013-07-06','09:35:00',5.02),('8902','2013-07-06','09:40:00',4.66),('8902','2013-07-06','09:45:00',5.62),('8902','2013-07-06','09:50:00',5.59),('8902','2013-07-06','09:55:00',5.66),('8902','2013-07-06','10:00:00',5.7),('8902','2013-07-06','10:05:00',5.47),('8902','2013-07-06','10:10:00',5.79),('8902','2013-07-06','10:15:00',5.57),('8902','2013-07-06','10:20:00',5.66),('8902','2013-07-06','10:25:00',5.23),('8902','2013-07-06','10:30:00',5.75),('8902','2013-07-06','10:35:00',6.64),('8902','2013-07-06','10:40:00',5.96),('8902','2013-07-06','10:45:00',6.49),('8902','2013-07-06','10:50:00',6.68),('8902','2013-07-06','10:55:00',6.68),('8902','2013-07-06','11:00:00',6.78),('8902','2013-07-06','11:05:00',6.91),('8902','2013-07-06','11:10:00',7),('8902','2013-07-06','11:15:00',6.94),('8902','2013-07-06','11:20:00',6.58),('8902','2013-07-06','11:25:00',5.91),('8902','2013-07-06','11:30:00',6.28),('8902','2013-07-06','11:35:00',6.14),('8902','2013-07-06','11:40:00',6.4),('8902','2013-07-06','11:45:00',4.83),('8902','2013-07-06','11:50:00',5.19),('8902','2013-07-06','11:55:00',3.55),('8902','2013-07-06','12:00:00',5.31),('8902','2013-07-06','12:05:00',7.3),('8902','2013-07-06','12:10:00',7.51),('8902','2013-07-06','12:15:00',8),('8902','2013-07-06','12:20:00',7.73),('8902','2013-07-06','12:25:00',7.23),('8902','2013-07-06','12:30:00',7.3),('8902','2013-07-06','12:35:00',7.8),('8902','2013-07-06','12:40:00',7.96),('8902','2013-07-06','12:45:00',7.99),('8902','2013-07-06','12:50:00',7.78),('8902','2013-07-06','12:55:00',8.14),('8902','2013-07-06','13:00:00',7.87),('8902','2013-07-06','13:05:00',8.01),('8902','2013-07-06','13:10:00',8.08),('8902','2013-07-06','13:15:00',7.88),('8902','2013-07-06','13:20:00',7.89),('8902','2013-07-06','13:25:00',5.18),('8902','2013-07-06','13:30:00',7.78),('8902','2013-07-06','13:35:00',8.22),('8902','2013-07-06','13:40:00',8.26),('8902','2013-07-06','13:45:00',8.51),('8902','2013-07-06','13:50:00',8.27),('8902','2013-07-06','13:55:00',4.67),('8902','2013-07-06','14:00:00',6.69),('8902','2013-07-06','14:05:00',7.8),('8902','2013-07-06','14:10:00',3.68),('8902','2013-07-06','14:15:00',4.23),('8902','2013-07-06','14:20:00',2.03),('8902','2013-07-06','14:25:00',1.81),('8902','2013-07-06','14:30:00',1.67),('8902','2013-07-06','14:35:00',1.58),('8902','2013-07-06','14:40:00',1.47),('8902','2013-07-06','14:45:00',1.37),('8902','2013-07-06','14:50:00',1.33),('8902','2013-07-06','14:55:00',1.48),('8902','2013-07-06','15:00:00',1.79),('8902','2013-07-06','15:05:00',2.05),('8902','2013-07-06','15:10:00',1.76),('8902','2013-07-06','15:15:00',1.26),('8902','2013-07-06','15:20:00',1.32),('8902','2013-07-06','15:25:00',1.16),('8902','2013-07-06','16:40:00',1),('8902','2013-07-06','16:45:00',1.12),('8902','2013-07-06','16:50:00',1.33),('8902','2013-07-06','16:55:00',1.56),('8902','2013-07-06','17:00:00',1.73),('8902','2013-07-06','17:05:00',1.83),('8902','2013-07-06','17:10:00',1.91),('8902','2013-07-06','17:15:00',1.95),('8902','2013-07-06','17:20:00',1.96),('8902','2013-07-06','17:25:00',1.92),('8902','2013-07-06','17:30:00',1.84),('8902','2013-07-06','17:35:00',1.73),('8902','2013-07-06','17:40:00',1.66),('8902','2013-07-06','17:45:00',1.63),('8902','2013-07-06','17:50:00',1.6),('8902','2013-07-06','17:55:00',1.55),('8902','2013-07-06','18:00:00',1.5),('8902','2013-07-06','18:05:00',1.49),('8902','2013-07-06','18:10:00',1.46),('8902','2013-07-06','18:15:00',1.46),('8902','2013-07-06','18:20:00',1.47),('8902','2013-07-06','18:25:00',1.42),('8902','2013-07-06','18:30:00',1.34),('8902','2013-07-06','18:35:00',1.24),('8902','2013-07-06','18:40:00',1.14),('8902','2013-07-06','18:45:00',1.07),('8902','2013-07-06','18:50:00',1.04),('8902','2013-07-06','18:55:00',1.03),('8902','2013-07-05','07:30:00',1.1),('8902','2013-07-05','07:35:00',1.28),('8902','2013-07-05','07:40:00',1.42),('8902','2013-07-05','07:45:00',1.58),('8902','2013-07-05','07:50:00',1.73),('8902','2013-07-05','07:55:00',1.89),('8902','2013-07-05','08:00:00',2.05),('8902','2013-07-05','08:05:00',2.21),('8902','2013-07-05','08:10:00',2.38),('8902','2013-07-05','08:15:00',2.53),('8902','2013-07-05','08:20:00',2.69),('8902','2013-07-05','08:25:00',2.85),('8902','2013-07-05','08:30:00',3),('8902','2013-07-05','08:35:00',3.16),('8902','2013-07-05','08:40:00',3.33),('8902','2013-07-05','08:45:00',3.47),('8902','2013-07-05','08:50:00',3.61),('8902','2013-07-05','08:55:00',3.76),('8902','2013-07-05','09:00:00',3.91),('8902','2013-07-05','09:05:00',4.09),('8902','2013-07-05','09:10:00',4.23),('8902','2013-07-05','09:15:00',4.37),('8902','2013-07-05','09:20:00',4.53),('8902','2013-07-05','09:25:00',4.65),('8902','2013-07-05','09:30:00',4.75),('8902','2013-07-05','09:35:00',4.87),('8902','2013-07-05','09:40:00',4.99),('8902','2013-07-05','09:45:00',5.13),('8902','2013-07-05','09:50:00',5.28),('8902','2013-07-05','09:55:00',5.39),('8902','2013-07-05','10:00:00',5.53),('8902','2013-07-05','10:05:00',5.68),('8902','2013-07-05','10:10:00',5.83),('8902','2013-07-05','10:15:00',5.95),('8902','2013-07-05','10:20:00',6.05),('8902','2013-07-05','10:25:00',6.15),('8902','2013-07-05','10:30:00',6.23),('8902','2013-07-05','10:35:00',6.33),('8902','2013-07-05','10:40:00',6.4),('8902','2013-07-05','10:45:00',6.51),('8902','2013-07-05','10:50:00',6.65),('8902','2013-07-05','10:55:00',6.76),('8902','2013-07-05','11:00:00',6.83),('8902','2013-07-05','11:05:00',6.91),('8902','2013-07-05','11:10:00',6.95),('8902','2013-07-05','11:15:00',6.98),('8902','2013-07-05','11:20:00',7.08),('8902','2013-07-05','11:25:00',7.18),('8902','2013-07-05','11:30:00',7.14),('8902','2013-07-05','11:35:00',7.21),('8902','2013-07-05','11:40:00',7.28),('8902','2013-07-05','11:45:00',7.37),('8902','2013-07-05','11:50:00',7.42),('8902','2013-07-05','11:55:00',7.49),('8902','2013-07-05','12:00:00',7.52),('8902','2013-07-05','12:05:00',7.63),('8902','2013-07-05','12:10:00',7.73),('8902','2013-07-05','12:15:00',7.71),('8902','2013-07-05','12:20:00',7.8),('8902','2013-07-05','12:25:00',7.85),('8902','2013-07-05','12:30:00',7.92),('8902','2013-07-05','12:35:00',7.87),('8902','2013-07-05','12:40:00',7.88),('8902','2013-07-05','12:45:00',7.94),('8902','2013-07-05','12:50:00',7.94),('8902','2013-07-05','12:55:00',7.99),('8902','2013-07-05','13:00:00',8.02),('8902','2013-07-05','13:05:00',8.07),('8902','2013-07-05','13:10:00',8.11),('8902','2013-07-05','13:15:00',8.11),('8902','2013-07-05','13:20:00',8.08),('8902','2013-07-05','13:25:00',8.04),('8902','2013-07-05','13:30:00',8.13),('8902','2013-07-05','13:35:00',8.02),('8902','2013-07-05','13:40:00',8.07),('8902','2013-07-05','13:45:00',8.04),('8902','2013-07-05','13:50:00',7.97),('8902','2013-07-05','13:55:00',7.99),('8902','2013-07-05','14:00:00',8.02),('8902','2013-07-05','14:05:00',8.04),('8902','2013-07-05','14:10:00',7.99),('8902','2013-07-05','14:15:00',5.6),('8902','2013-07-05','14:20:00',7.31),('8902','2013-07-05','14:25:00',8.08),('8902','2013-07-05','14:30:00',7.86),('8902','2013-07-05','14:35:00',7.87),('8902','2013-07-05','14:40:00',7.8),('8902','2013-07-05','14:45:00',7.76),('8902','2013-07-05','14:50:00',7.51),('8902','2013-07-05','14:55:00',7.94),('8902','2013-07-05','15:00:00',7.32),('8902','2013-07-05','15:05:00',5.84),('8902','2013-07-05','15:10:00',7.87),('8902','2013-07-05','15:15:00',7.59),('8902','2013-07-05','15:20:00',7.48),('8902','2013-07-05','15:25:00',7.54),('8902','2013-07-05','15:30:00',7.49),('8902','2013-07-05','15:35:00',3.96),('8902','2013-07-05','15:40:00',1.6),('8902','2013-07-05','15:45:00',1.17),('8902','2013-07-05','16:45:00',1.23),('8902','2013-07-05','16:50:00',1.83),('8902','2013-07-05','16:55:00',2.27),('8902','2013-07-05','17:00:00',1.75),('8902','2013-07-05','17:05:00',1.97),('8902','2013-07-05','17:10:00',1.69),('8902','2013-07-05','17:15:00',1.96),('8902','2013-07-05','17:20:00',1.79),('8902','2013-07-05','17:25:00',2.02),('8902','2013-07-05','17:30:00',2.12),('8902','2013-07-05','17:35:00',2.07),('8902','2013-07-05','17:40:00',1.77),('8902','2013-07-05','17:45:00',1.63),('8902','2013-07-05','17:50:00',1.43),('8902','2013-07-05','17:55:00',1.39),('8902','2013-07-05','18:00:00',1.31),('8902','2013-07-05','18:05:00',1.23),('8902','2013-07-05','18:10:00',1.18),('8902','2013-07-05','18:15:00',1.05),('8902','2013-07-04','07:30:00',1.22),('8902','2013-07-04','07:35:00',1.36),('8902','2013-07-04','07:40:00',1.49),('8902','2013-07-04','07:45:00',1.62),('8902','2013-07-04','07:50:00',1.75),('8902','2013-07-04','07:55:00',1.9),('8902','2013-07-04','08:00:00',2.08),('8902','2013-07-04','08:05:00',2.24),('8902','2013-07-04','08:10:00',2.38),('8902','2013-07-04','08:15:00',2.53),('8902','2013-07-04','08:20:00',2.66),('8902','2013-07-04','08:25:00',2.81),('8902','2013-07-04','08:30:00',2.97),('8902','2013-07-04','08:35:00',3.13),('8902','2013-07-04','08:40:00',3.26),('8902','2013-07-04','08:45:00',3.41),('8902','2013-07-04','08:50:00',3.57),('8902','2013-07-04','08:55:00',3.69),('8902','2013-07-04','09:00:00',3.84),('8902','2013-07-04','09:05:00',3.99),('8902','2013-07-04','09:10:00',4.12),('8902','2013-07-04','09:15:00',4.28),('8902','2013-07-04','09:20:00',4.41),('8902','2013-07-04','09:25:00',4.57),('8902','2013-07-04','09:30:00',4.71),('8902','2013-07-04','09:35:00',4.83),('8902','2013-07-04','09:40:00',4.88),('8902','2013-07-04','09:45:00',5.09),('8902','2013-07-04','09:50:00',5.17),('8902','2013-07-04','09:55:00',5.2),('8902','2013-07-04','10:00:00',5.33),('8902','2013-07-04','10:05:00',5.46),('8902','2013-07-04','10:10:00',5.62),('8902','2013-07-04','10:15:00',5.67),('8902','2013-07-04','10:20:00',5.76),('8902','2013-07-04','10:25:00',5.85),('8902','2013-07-04','10:30:00',6),('8902','2013-07-04','10:35:00',5.97),('8902','2013-07-04','10:40:00',6),('8902','2013-07-04','10:45:00',6.1),('8902','2013-07-04','10:50:00',6.21),('8902','2013-07-04','10:55:00',6.39),('8902','2013-07-04','11:00:00',6.45),('8902','2013-07-04','11:05:00',6.44),('8902','2013-07-04','11:10:00',6.46),('8902','2013-07-04','11:15:00',6.58),('8902','2013-07-04','11:20:00',6.62),('8902','2013-07-04','11:25:00',6.79),('8902','2013-07-04','11:30:00',6.9),('8902','2013-07-04','11:35:00',6.96),('8902','2013-07-04','11:40:00',7.04),('8902','2013-07-04','11:45:00',7.09),('8902','2013-07-04','11:50:00',7.15),('8902','2013-07-04','11:55:00',6.95),('8902','2013-07-04','12:00:00',7.08),('8902','2013-07-04','12:05:00',7.3),('8902','2013-07-04','12:10:00',7.27),('8902','2013-07-04','12:15:00',7.33),('8902','2013-07-04','12:20:00',7.51),('8902','2013-07-04','12:25:00',3.69),('8902','2013-07-04','12:30:00',7.65),('8902','2013-07-04','12:35:00',7.19),('8902','2013-07-04','12:40:00',4.97),('8902','2013-07-04','12:45:00',4.95),('8902','2013-07-04','12:50:00',5.13),('8902','2013-07-04','12:55:00',1.99),('8902','2013-07-04','13:00:00',5.7),('8902','2013-07-04','13:05:00',3.65),('8902','2013-07-04','13:10:00',8.04),('8902','2013-07-04','13:15:00',7.92),('8902','2013-07-04','13:20:00',7.25),('8902','2013-07-04','13:25:00',6.59),('8902','2013-07-04','13:30:00',7.99),('8902','2013-07-04','13:35:00',8.09),('8902','2013-07-04','13:40:00',7.94),('8902','2013-07-04','13:45:00',8.16),('8902','2013-07-04','13:50:00',8),('8902','2013-07-04','13:55:00',8.1),('8902','2013-07-04','14:00:00',8.2),('8902','2013-07-04','14:05:00',8.09),('8902','2013-07-04','14:10:00',7.93),('8902','2013-07-04','14:15:00',7.92),('8902','2013-07-04','14:20:00',7.81),('8902','2013-07-04','14:25:00',7.98),('8902','2013-07-04','14:30:00',7.52),('8902','2013-07-04','14:35:00',7.83),('8902','2013-07-04','14:40:00',7.81),('8902','2013-07-04','14:45:00',6.1),('8902','2013-07-04','14:50:00',7.82),('8902','2013-07-04','14:55:00',7.57),('8902','2013-07-04','15:00:00',6.39),('8902','2013-07-04','15:05:00',5.9),('8902','2013-07-04','15:10:00',7.8),('8902','2013-07-04','15:15:00',6.58),('8902','2013-07-04','15:20:00',7.13),('8902','2013-07-04','15:25:00',4.64),('8902','2013-07-04','15:30:00',6.06),('8902','2013-07-04','15:35:00',7.41),('8902','2013-07-04','15:40:00',7.21),('8902','2013-07-04','15:45:00',7.26),('8902','2013-07-04','15:50:00',7.11),('8902','2013-07-04','15:55:00',6.87),('8902','2013-07-04','16:00:00',6.74),('8902','2013-07-04','16:05:00',6.7),('8902','2013-07-04','16:10:00',6.48),('8902','2013-07-04','16:15:00',6.43),('8902','2013-07-04','16:20:00',6.37),('8902','2013-07-04','16:25:00',6.24),('8902','2013-07-04','16:30:00',6.16),('8902','2013-07-04','16:35:00',6.05),('8902','2013-07-04','16:40:00',5.78),('8902','2013-07-04','16:45:00',5.8),('8902','2013-07-04','16:50:00',5.57),('8902','2013-07-04','16:55:00',5.25),('8902','2013-07-04','17:00:00',4.63),('8902','2013-07-04','17:05:00',5.12),('8902','2013-07-04','17:10:00',5.12),('8902','2013-07-04','17:15:00',5.07),('8902','2013-07-04','17:20:00',4.97),('8902','2013-07-04','17:25:00',4.72),('8902','2013-07-04','17:30:00',4.4),('8902','2013-07-04','17:35:00',4.24),('8902','2013-07-04','17:40:00',3.97),('8902','2013-07-04','17:45:00',3.76),('8902','2013-07-04','17:50:00',3.67),('8902','2013-07-04','17:55:00',3.59),('8902','2013-07-04','18:00:00',3.36),('8902','2013-07-04','18:05:00',3.29),('8902','2013-07-04','18:10:00',2.52),('8902','2013-07-04','18:20:00',1.66),('8902','2013-07-04','18:35:00',1.91),('8902','2013-07-04','18:40:00',1.89),('8902','2013-07-04','18:45:00',1.82),('8902','2013-07-04','18:50:00',1.66),('8902','2013-07-04','18:55:00',1.5),('8902','2013-07-04','19:00:00',1.32),('8902','2013-07-04','19:05:00',1.19),('8902','2013-07-04','19:10:00',1.05),('8902','2013-07-03','08:45:00',1.05),('8902','2013-07-03','08:50:00',1.38),('8902','2013-07-03','08:55:00',1.73),('8902','2013-07-03','09:00:00',1.71),('8902','2013-07-03','09:05:00',1.41),('8902','2013-07-03','09:10:00',1.25),('8902','2013-07-03','09:15:00',1.29),('8902','2013-07-03','09:20:00',1.25),('8902','2013-07-03','09:25:00',1.34),('8902','2013-07-03','09:30:00',1.42),('8902','2013-07-03','09:35:00',1.4),('8902','2013-07-03','09:40:00',1.18),('8902','2013-07-03','10:15:00',1.16),('8902','2013-07-03','10:20:00',1.3),('8902','2013-07-03','10:25:00',1.34),('8902','2013-07-03','10:30:00',1.35),('8902','2013-07-03','10:35:00',1.4),('8902','2013-07-03','10:40:00',1.37),('8902','2013-07-03','10:45:00',1.19),('8902','2013-07-03','10:50:00',1.06),('8902','2013-07-03','10:55:00',1.13),('8902','2013-07-03','11:00:00',1.34),('8902','2013-07-03','11:05:00',1.56),('8902','2013-07-03','11:10:00',1.9),('8902','2013-07-03','11:15:00',2.06),('8902','2013-07-03','11:20:00',1.95),('8902','2013-07-03','11:25:00',2.01);
INSERT INTO `solarlogmod` VALUES ('8902','2013-07-03','11:30:00',2.14),('8902','2013-07-03','11:35:00',2.44),('8902','2013-07-03','11:40:00',2.76),('8902','2013-07-03','11:45:00',3.05),('8902','2013-07-03','11:50:00',3.18),('8902','2013-07-03','11:55:00',2.88),('8902','2013-07-03','12:00:00',2.61),('8902','2013-07-03','12:05:00',2.83),('8902','2013-07-03','12:10:00',3.8),('8902','2013-07-03','12:15:00',4.8),('8902','2013-07-03','12:20:00',4.88),('8902','2013-07-03','12:25:00',7.35),('8902','2013-07-03','12:30:00',5.56),('8902','2013-07-03','12:35:00',5.17),('8902','2013-07-03','12:40:00',3.32),('8902','2013-07-03','12:45:00',2.65),('8902','2013-07-03','12:50:00',2.08),('8902','2013-07-03','12:55:00',1.87),('8902','2013-07-03','13:00:00',1.93),('8902','2013-07-03','13:05:00',2.19),('8902','2013-07-03','13:10:00',2.71),('8902','2013-07-03','13:15:00',3.17),('8902','2013-07-03','13:20:00',3.59),('8902','2013-07-03','13:25:00',5.04),('8902','2013-07-03','13:30:00',3.91),('8902','2013-07-03','13:35:00',3.96),('8902','2013-07-03','13:40:00',5.95),('8902','2013-07-03','13:45:00',4.15),('8902','2013-07-03','13:50:00',6.92),('8902','2013-07-03','13:55:00',5.52),('8902','2013-07-03','14:00:00',4.11),('8902','2013-07-03','14:05:00',3.93),('8902','2013-07-03','14:10:00',3.92),('8902','2013-07-03','14:15:00',3.94),('8902','2013-07-03','14:20:00',4.63),('8902','2013-07-03','14:25:00',3.53),('8902','2013-07-03','14:30:00',3.48),('8902','2013-07-03','14:35:00',3.77),('8902','2013-07-03','14:40:00',5.96),('8902','2013-07-03','14:45:00',8.33),('8902','2013-07-03','14:50:00',5.83),('8902','2013-07-03','14:55:00',5.21),('8902','2013-07-03','15:00:00',8.09),('8902','2013-07-03','15:05:00',6.96),('8902','2013-07-03','15:10:00',6.45),('8902','2013-07-03','15:15:00',8.34),('8902','2013-07-03','15:20:00',7.97),('8902','2013-07-03','15:25:00',7.78),('8902','2013-07-03','15:30:00',4.93),('8902','2013-07-03','15:35:00',5.52),('8902','2013-07-03','15:40:00',5.13),('8902','2013-07-03','15:45:00',5.85),('8902','2013-07-03','15:50:00',4.89),('8902','2013-07-03','15:55:00',4.17),('8902','2013-07-03','16:00:00',4.29),('8902','2013-07-03','16:05:00',4.31),('8902','2013-07-03','16:10:00',3.8),('8902','2013-07-03','16:15:00',3.14),('8902','2013-07-03','16:20:00',3.45),('8902','2013-07-03','16:25:00',3.62),('8902','2013-07-03','16:30:00',3.8),('8902','2013-07-03','16:35:00',3.98),('8902','2013-07-03','16:40:00',3.11),('8902','2013-07-03','16:45:00',2.83),('8902','2013-07-03','16:50:00',2.87),('8902','2013-07-03','16:55:00',2.81),('8902','2013-07-03','17:00:00',2.47),('8902','2013-07-03','17:05:00',2.32),('8902','2013-07-03','17:10:00',3.06),('8902','2013-07-03','17:15:00',4.93),('8902','2013-07-03','17:20:00',4.78),('8902','2013-07-03','17:25:00',4.63),('8902','2013-07-03','17:30:00',4.1),('8902','2013-07-03','17:35:00',4.47),('8902','2013-07-03','17:40:00',4.51),('8902','2013-07-03','17:45:00',4.2),('8902','2013-07-03','17:50:00',4.13),('8902','2013-07-03','17:55:00',4.01),('8902','2013-07-03','18:00:00',3.78),('8902','2013-07-03','18:05:00',3.74),('8902','2013-07-03','18:10:00',3.62),('8902','2013-07-03','18:15:00',3.33),('8902','2013-07-03','18:20:00',2.74),('8902','2013-07-03','18:25:00',2.73),('8902','2013-07-03','18:30:00',1.84),('8902','2013-07-03','18:35:00',1.27),('8902','2013-07-02','07:25:00',1.04),('8902','2013-07-02','07:30:00',1.18),('8902','2013-07-02','07:35:00',1.33),('8902','2013-07-02','07:40:00',1.48),('8902','2013-07-02','07:45:00',1.64),('8902','2013-07-02','07:50:00',1.8),('8902','2013-07-02','07:55:00',1.95),('8902','2013-07-02','08:00:00',2.12),('8902','2013-07-02','08:05:00',2.29),('8902','2013-07-02','08:10:00',2.45),('8902','2013-07-02','08:15:00',2.61),('8902','2013-07-02','08:20:00',2.76),('8902','2013-07-02','08:25:00',2.92),('8902','2013-07-02','08:30:00',3.08),('8902','2013-07-02','08:35:00',3.25),('8902','2013-07-02','08:40:00',3.41),('8902','2013-07-02','08:45:00',3.56),('8902','2013-07-02','08:50:00',3.69),('8902','2013-07-02','08:55:00',3.81),('8902','2013-07-02','09:00:00',3.96),('8902','2013-07-02','09:05:00',4.11),('8902','2013-07-02','09:10:00',4.24),('8902','2013-07-02','09:15:00',4.38),('8902','2013-07-02','09:20:00',4.56),('8902','2013-07-02','09:25:00',4.66),('8902','2013-07-02','09:30:00',4.72),('8902','2013-07-02','09:35:00',4.87),('8902','2013-07-02','09:40:00',5.06),('8902','2013-07-02','09:45:00',5.14),('8902','2013-07-02','09:50:00',5.22),('8902','2013-07-02','09:55:00',5.36),('8902','2013-07-02','10:00:00',5.5),('8902','2013-07-02','10:05:00',5.55),('8902','2013-07-02','10:10:00',5.63),('8902','2013-07-02','10:15:00',5.71),('8902','2013-07-02','10:20:00',5.83),('8902','2013-07-02','10:25:00',6.01),('8902','2013-07-02','10:30:00',6.08),('8902','2013-07-02','10:35:00',6.08),('8902','2013-07-02','10:40:00',6.22),('8902','2013-07-02','10:45:00',6.32),('8902','2013-07-02','10:50:00',6.41),('8902','2013-07-02','10:55:00',6.44),('8902','2013-07-02','11:00:00',6.55),('8902','2013-07-02','11:05:00',6.62),('8902','2013-07-02','11:10:00',6.62),('8902','2013-07-02','11:15:00',6.83),('8902','2013-07-02','11:20:00',6.98),('8902','2013-07-02','11:25:00',7.05),('8902','2013-07-02','11:30:00',7.08),('8902','2013-07-02','11:35:00',7.03),('8902','2013-07-02','11:45:00',7.11),('8902','2013-07-02','11:50:00',7.4),('8902','2013-07-02','11:55:00',7.28),('8902','2013-07-02','12:00:00',7.34),('8902','2013-07-02','12:05:00',7.48),('8902','2013-07-02','12:10:00',7.55),('8902','2013-07-02','12:15:00',7.62),('8902','2013-07-02','12:20:00',7.58),('8902','2013-07-02','12:25:00',7.6),('8902','2013-07-02','12:30:00',7.6),('8902','2013-07-02','12:35:00',7.71),('8902','2013-07-02','12:40:00',7.75),('8902','2013-07-02','12:45:00',7.8),('8902','2013-07-02','12:50:00',7.82),('8902','2013-07-02','12:55:00',7.87),('8902','2013-07-02','13:00:00',7.9),('8902','2013-07-02','13:05:00',7.95),('8902','2013-07-02','13:10:00',7.95),('8902','2013-07-02','13:15:00',7.99),('8902','2013-07-02','13:20:00',7.97),('8902','2013-07-02','13:25:00',7.88),('8902','2013-07-02','13:30:00',7.92),('8902','2013-07-02','13:35:00',7.93),('8902','2013-07-02','13:40:00',7.94),('8902','2013-07-02','13:45:00',7.93),('8902','2013-07-02','13:50:00',7.92),('8902','2013-07-02','13:55:00',7.86),('8902','2013-07-02','14:00:00',7.87),('8902','2013-07-02','14:05:00',7.89),('8902','2013-07-02','14:10:00',7.89),('8902','2013-07-02','14:15:00',7.87),('8902','2013-07-02','14:20:00',7.85),('8902','2013-07-02','14:25:00',7.86),('8902','2013-07-02','14:30:00',7.87),('8902','2013-07-02','14:35:00',7.79),('8902','2013-07-02','14:40:00',7.79),('8902','2013-07-02','14:45:00',7.74),('8902','2013-07-02','14:50:00',7.68),('8902','2013-07-02','14:55:00',7.63),('8902','2013-07-02','15:00:00',7.61),('8902','2013-07-02','15:05:00',7.53),('8902','2013-07-02','15:10:00',7.47),('8902','2013-07-02','15:15:00',7.43),('8902','2013-07-02','15:20:00',7.4),('8902','2013-07-02','15:25:00',7.29),('8902','2013-07-02','15:30:00',7.23),('8902','2013-07-02','15:35:00',7.14),('8902','2013-07-02','15:40:00',7.08),('8902','2013-07-02','15:45:00',6.94),('8902','2013-07-02','15:50:00',6.89),('8902','2013-07-02','15:55:00',6.83),('8902','2013-07-02','16:00:00',6.71),('8902','2013-07-02','16:05:00',6.64),('8902','2013-07-02','16:10:00',6.57),('8902','2013-07-02','16:15:00',6.46),('8902','2013-07-02','16:20:00',6.34),('8902','2013-07-02','16:25:00',6.24),('8902','2013-07-02','16:30:00',6.14),('8902','2013-07-02','16:35:00',6.07),('8902','2013-07-02','16:40:00',5.81),('8902','2013-07-02','16:45:00',5.73),('8902','2013-07-02','16:50:00',5.62),('8902','2013-07-02','16:55:00',5.44),('8902','2013-07-02','17:00:00',5.29),('8902','2013-07-02','17:05:00',5.24),('8902','2013-07-02','17:10:00',5.08),('8902','2013-07-02','17:15:00',4.95),('8902','2013-07-02','17:20:00',4.84),('8902','2013-07-02','17:25:00',4.66),('8902','2013-07-02','17:30:00',4.51),('8902','2013-07-02','17:35:00',4.39),('8902','2013-07-02','17:40:00',4.22),('8902','2013-07-02','17:45:00',4.06),('8902','2013-07-02','17:50:00',3.92),('8902','2013-07-02','17:55:00',3.71),('8902','2013-07-02','18:00:00',3.44),('8902','2013-07-02','18:05:00',3.35),('8902','2013-07-02','18:10:00',3.13),('8902','2013-07-02','18:15:00',3.04),('8902','2013-07-02','18:20:00',2.89),('8902','2013-07-02','18:25:00',2.69),('8902','2013-07-02','18:30:00',2.51),('8902','2013-07-02','18:35:00',2.33),('8902','2013-07-02','18:40:00',2.15),('8902','2013-07-02','18:45:00',1.97),('8902','2013-07-02','18:50:00',1.8),('8902','2013-07-02','18:55:00',1.63),('8902','2013-07-02','19:00:00',1.48),('8902','2013-07-02','19:05:00',1.31),('8902','2013-07-02','19:10:00',1.13),('8902','2013-07-01','07:25:00',1.05),('8902','2013-07-01','07:30:00',1.18),('8902','2013-07-01','07:35:00',1.32),('8902','2013-07-01','07:40:00',1.47),('8902','2013-07-01','07:45:00',1.62),('8902','2013-07-01','07:50:00',1.77),('8902','2013-07-01','07:55:00',1.92),('8902','2013-07-01','08:00:00',2.08),('8902','2013-07-01','08:05:00',2.24),('8902','2013-07-01','08:10:00',2.41),('8902','2013-07-01','08:15:00',2.57),('8902','2013-07-01','08:20:00',2.74),('8902','2013-07-01','08:25:00',2.89),('8902','2013-07-01','08:30:00',3.04),('8902','2013-07-01','08:35:00',3.21),('8902','2013-07-01','08:40:00',3.37),('8902','2013-07-01','08:45:00',3.53),('8902','2013-07-01','08:50:00',3.68),('8902','2013-07-01','08:55:00',3.79),('8902','2013-07-01','09:00:00',3.92),('8902','2013-07-01','09:05:00',4.09),('8902','2013-07-01','09:10:00',4.26),('8902','2013-07-01','09:15:00',4.37),('8902','2013-07-01','09:20:00',4.51),('8902','2013-07-01','09:25:00',4.65),('8902','2013-07-01','09:30:00',4.75),('8902','2013-07-01','09:35:00',4.88),('8902','2013-07-01','09:40:00',5.02),('8902','2013-07-01','09:45:00',5.14),('8902','2013-07-01','09:50:00',5.24),('8902','2013-07-01','09:55:00',5.36),('8902','2013-07-01','10:00:00',5.5),('8902','2013-07-01','10:05:00',5.57),('8902','2013-07-01','10:10:00',5.65),('8902','2013-07-01','10:15:00',5.75),('8902','2013-07-01','10:20:00',5.82),('8902','2013-07-01','10:25:00',5.95),('8902','2013-07-01','10:30:00',6.06),('8902','2013-07-01','10:35:00',6.16),('8902','2013-07-01','10:40:00',6.21),('8902','2013-07-01','10:45:00',6.28),('8902','2013-07-01','10:50:00',6.35),('8902','2013-07-01','10:55:00',6.43),('8902','2013-07-01','11:00:00',6.44),('8902','2013-07-01','11:05:00',6.48),('8902','2013-07-01','11:10:00',6.61),('8902','2013-07-01','11:15:00',6.65),('8902','2013-07-01','11:20:00',6.69),('8902','2013-07-01','11:25:00',6.79),('8902','2013-07-01','11:30:00',6.94),('8902','2013-07-01','11:35:00',7.07),('8902','2013-07-01','11:40:00',7.02),('8902','2013-07-01','11:45:00',7.05),('8902','2013-07-01','11:50:00',7.15),('8902','2013-07-01','11:55:00',7.24),('8902','2013-07-01','12:00:00',7.15),('8902','2013-07-01','12:05:00',7.11),('8902','2013-07-01','12:10:00',7.22),('8902','2013-07-01','12:15:00',7.31),('8902','2013-07-01','12:20:00',7.29),('8902','2013-07-01','12:25:00',7.34),('8902','2013-07-01','12:30:00',7.42),('8902','2013-07-01','12:35:00',7.53),('8902','2013-07-01','12:40:00',7.68),('8902','2013-07-01','12:45:00',7.89),('8902','2013-07-01','12:50:00',7.95),('8902','2013-07-01','12:55:00',6.41),('8902','2013-07-01','13:00:00',4.57),('8902','2013-07-01','13:05:00',7.14),('8902','2013-07-01','13:10:00',5.95),('8902','2013-07-01','13:15:00',7.93),('8902','2013-07-01','13:20:00',8.16),('8902','2013-07-01','13:25:00',8.17),('8902','2013-07-01','13:30:00',8.01),('8902','2013-07-01','13:35:00',7.76),('8902','2013-07-01','13:40:00',8.05),('8902','2013-07-01','13:45:00',7.78),('8902','2013-07-01','13:50:00',7.38),('8902','2013-07-01','13:55:00',7.51),('8902','2013-07-01','14:00:00',7.66),('8902','2013-07-01','14:05:00',7.62),('8902','2013-07-01','14:10:00',7.65),('8902','2013-07-01','14:15:00',7.57),('8902','2013-07-01','14:20:00',7.59),('8902','2013-07-01','14:25:00',7.59),('8902','2013-07-01','14:30:00',7.57),('8902','2013-07-01','14:35:00',7.51),('8902','2013-07-01','14:40:00',7.45),('8902','2013-07-01','14:45:00',7.41),('8902','2013-07-01','14:50:00',7.43),('8902','2013-07-01','14:55:00',7.36),('8902','2013-07-01','15:00:00',7.29),('8902','2013-07-01','15:05:00',7.32),('8902','2013-07-01','15:10:00',7.3),('8902','2013-07-01','15:15:00',7.21),('8902','2013-07-01','15:20:00',7.17),('8902','2013-07-01','15:25:00',7.12),('8902','2013-07-01','15:30:00',7.01),('8902','2013-07-01','15:35:00',7),('8902','2013-07-01','15:40:00',6.95),('8902','2013-07-01','15:45:00',6.82),('8902','2013-07-01','15:50:00',6.73),('8902','2013-07-01','15:55:00',6.66),('8902','2013-07-01','16:00:00',6.57),('8902','2013-07-01','16:05:00',6.51),('8902','2013-07-01','16:10:00',6.41),('8902','2013-07-01','16:15:00',6.32),('8902','2013-07-01','16:20:00',6.19),('8902','2013-07-01','16:25:00',6.08),('8902','2013-07-01','16:30:00',5.95),('8902','2013-07-01','16:35:00',5.83),('8902','2013-07-01','16:40:00',5.61),('8902','2013-07-01','16:45:00',5.52),('8902','2013-07-01','16:50:00',5.41),('8902','2013-07-01','16:55:00',5.21),('8902','2013-07-01','17:00:00',5.1),('8902','2013-07-01','17:05:00',5.06),('8902','2013-07-01','17:10:00',4.89),('8902','2013-07-01','17:15:00',4.79),('8902','2013-07-01','17:20:00',4.64),('8902','2013-07-01','17:25:00',4.46),('8902','2013-07-01','17:30:00',4.26),('8902','2013-07-01','17:35:00',4.18),('8902','2013-07-01','17:40:00',4.01),('8902','2013-07-01','17:45:00',3.85),('8902','2013-07-01','17:50:00',3.7),('8902','2013-07-01','17:55:00',3.51),('8902','2013-07-01','18:00:00',3.25),('8902','2013-07-01','18:05:00',3.18),('8902','2013-07-01','18:10:00',3.04),('8902','2013-07-01','18:15:00',2.89),('8902','2013-07-01','18:20:00',2.75),('8902','2013-07-01','18:25:00',2.54),('8902','2013-07-01','18:30:00',2.35),('8902','2013-07-01','18:35:00',2.17),('8902','2013-07-01','18:40:00',2.01),('8902','2013-07-01','18:45:00',1.84),('8902','2013-07-01','18:50:00',1.68),('8902','2013-07-01','18:55:00',1.54),('8902','2013-07-01','19:00:00',1.38),('8902','2013-07-01','19:05:00',1.23),('8902','2013-07-01','19:10:00',1.07),('8902','2013-06-30','07:25:00',1.1),('8902','2013-06-30','07:30:00',1.24),('8902','2013-06-30','07:35:00',1.38),('8902','2013-06-30','07:40:00',1.51),('8902','2013-06-30','07:45:00',1.66),('8902','2013-06-30','07:50:00',1.82),('8902','2013-06-30','07:55:00',1.97),('8902','2013-06-30','08:00:00',2.14),('8902','2013-06-30','08:05:00',2.32),('8902','2013-06-30','08:10:00',2.48),('8902','2013-06-30','08:15:00',2.64),('8902','2013-06-30','08:20:00',2.8),('8902','2013-06-30','08:25:00',2.96),('8902','2013-06-30','08:30:00',3.13),('8902','2013-06-30','08:35:00',3.28),('8902','2013-06-30','08:40:00',3.44),('8902','2013-06-30','08:45:00',3.6),('8902','2013-06-30','08:50:00',3.75),('8902','2013-06-30','08:55:00',3.91),('8902','2013-06-30','09:00:00',4.05),('8902','2013-06-30','09:05:00',4.18),('8902','2013-06-30','09:10:00',4.34),('8902','2013-06-30','09:15:00',4.51),('8902','2013-06-30','09:20:00',4.65),('8902','2013-06-30','09:25:00',4.77),('8902','2013-06-30','09:30:00',4.93),('8902','2013-06-30','09:35:00',5.08),('8902','2013-06-30','09:40:00',5.17),('8902','2013-06-30','09:45:00',5.29),('8902','2013-06-30','09:50:00',5.42),('8902','2013-06-30','09:55:00',5.51),('8902','2013-06-30','10:00:00',5.6),('8902','2013-06-30','10:05:00',5.68),('8902','2013-06-30','10:10:00',5.82),('8902','2013-06-30','10:15:00',5.92),('8902','2013-06-30','10:20:00',6.05),('8902','2013-06-30','10:25:00',6.17),('8902','2013-06-30','10:30:00',6.26),('8902','2013-06-30','10:35:00',6.38),('8902','2013-06-30','10:40:00',6.52),('8902','2013-06-30','10:45:00',6.62),('8902','2013-06-30','10:50:00',6.63),('8902','2013-06-30','10:55:00',6.7),('8902','2013-06-30','11:00:00',6.77),('8902','2013-06-30','11:05:00',6.93),('8902','2013-06-30','11:10:00',7.02),('8902','2013-06-30','11:15:00',7.12),('8902','2013-06-30','11:20:00',7.1),('8902','2013-06-30','11:25:00',7.18),('8902','2013-06-30','11:30:00',7.29),('8902','2013-06-30','11:35:00',7.37),('8902','2013-06-30','11:40:00',7.41),('8902','2013-06-30','11:45:00',7.44),('8902','2013-06-30','11:50:00',7.48),('8902','2013-06-30','11:55:00',7.51),('8902','2013-06-30','12:00:00',7.57),('8902','2013-06-30','12:05:00',7.58),('8902','2013-06-30','12:10:00',7.54),('8902','2013-06-30','12:15:00',7.55),('8902','2013-06-30','12:20:00',7.63),('8902','2013-06-30','12:25:00',7.68),('8902','2013-06-30','12:30:00',7.68),('8902','2013-06-30','12:35:00',7.75),('8902','2013-06-30','12:40:00',7.73),('8902','2013-06-30','12:45:00',7.76),('8902','2013-06-30','12:50:00',7.76),('8902','2013-06-30','12:55:00',7.79),('8902','2013-06-30','13:00:00',7.83),('8902','2013-06-30','13:05:00',7.85),('8902','2013-06-30','13:10:00',7.9),('8902','2013-06-30','13:15:00',7.86),('8902','2013-06-30','13:20:00',7.85),('8902','2013-06-30','13:25:00',7.92),('8902','2013-06-30','13:30:00',7.91),('8902','2013-06-30','13:35:00',7.86),('8902','2013-06-30','13:40:00',7.85),('8902','2013-06-30','13:45:00',7.73),('8902','2013-06-30','13:50:00',7.69),('8902','2013-06-30','13:55:00',7.78),('8902','2013-06-30','14:00:00',7.76),('8902','2013-06-30','14:05:00',7.84),('8902','2013-06-30','14:10:00',7.8),('8902','2013-06-30','14:15:00',7.85),('8902','2013-06-30','14:20:00',7.75),('8902','2013-06-30','14:25:00',7.68),('8902','2013-06-30','14:30:00',7.58),('8902','2013-06-30','14:35:00',7.63),('8902','2013-06-30','14:40:00',7.6),('8902','2013-06-30','14:45:00',7.55),('8902','2013-06-30','14:50:00',7.42),('8902','2013-06-30','14:55:00',7.39),('8902','2013-06-30','15:00:00',7.38),('8902','2013-06-30','15:05:00',7.26),('8902','2013-06-30','15:10:00',7.25),('8902','2013-06-30','15:15:00',7.19),('8902','2013-06-30','15:20:00',7.14),('8902','2013-06-30','15:25:00',7.08),('8902','2013-06-30','15:30:00',7),('8902','2013-06-30','15:35:00',6.84),('8902','2013-06-30','15:40:00',6.75),('8902','2013-06-30','15:45:00',6.78),('8902','2013-06-30','15:50:00',6.67),('8902','2013-06-30','15:55:00',6.6),('8902','2013-06-30','16:00:00',6.48),('8902','2013-06-30','16:05:00',6.4),('8902','2013-06-30','16:10:00',6.31),('8902','2013-06-30','16:15:00',6.16),('8902','2013-06-30','16:20:00',6.02),('8902','2013-06-30','16:25:00',5.9),('8902','2013-06-30','16:30:00',5.8),('8902','2013-06-30','16:35:00',5.7),('8902','2013-06-30','16:40:00',5.54),('8902','2013-06-30','16:45:00',5.46),('8902','2013-06-30','16:50:00',5.41),('8902','2013-06-30','16:55:00',5.23),('8902','2013-06-30','17:00:00',5.14),('8902','2013-06-30','17:05:00',5.03),('8902','2013-06-30','17:10:00',4.91),('8902','2013-06-30','17:15:00',4.77),('8902','2013-06-30','17:20:00',4.6),('8902','2013-06-30','17:25:00',4.4),('8902','2013-06-30','17:30:00',4.24),('8902','2013-06-30','17:35:00',4.1),('8902','2013-06-30','17:40:00',3.95),('8902','2013-06-30','17:45:00',3.83),('8902','2013-06-30','17:50:00',3.7),('8902','2013-06-30','17:55:00',3.51),('8902','2013-06-30','18:00:00',3.03),('8902','2013-06-30','18:05:00',3.12),('8902','2013-06-30','18:10:00',3),('8902','2013-06-30','18:15:00',2.43),('8902','2013-06-30','18:20:00',2.43),('8902','2013-06-30','18:25:00',2.61),('8902','2013-06-30','18:30:00',2.42),('8902','2013-06-30','18:35:00',2.21),('8902','2013-06-30','18:40:00',1.95),('8902','2013-06-30','18:45:00',1.82),('8902','2013-06-30','18:50:00',1.64),('8902','2013-06-30','18:55:00',1.42),('8902','2013-06-30','19:00:00',1.31),('8902','2013-06-30','19:05:00',1.2),('8902','2013-06-30','19:10:00',1.05),('8902','2014-04-04','08:35:00',1.16),('8902','2014-04-04','08:40:00',1.07),('8902','2014-04-04','09:00:00',1.25),('8902','2014-04-04','09:05:00',1.64),('8902','2014-04-04','09:10:00',1.74),('8902','2014-04-04','09:15:00',2.35),('8902','2014-04-04','09:20:00',3.14),('8902','2014-04-04','09:25:00',4.85),('8902','2014-04-04','09:30:00',6.17),('8902','2014-04-04','09:35:00',5.93),('8902','2014-04-04','09:40:00',5.77),('8902','2014-04-04','09:45:00',3.55),('8902','2014-04-04','09:50:00',2.72),('8902','2014-04-04','09:55:00',4.29),('8902','2014-04-04','10:00:00',4.38),('8902','2014-04-04','10:05:00',4.67),('8902','2014-04-04','10:10:00',3.96),('8902','2014-04-04','10:15:00',3.11),('8902','2014-04-04','10:20:00',4.2),('8902','2014-04-04','10:25:00',4.98),('8902','2014-04-04','10:30:00',5.04),('8902','2014-04-04','10:35:00',6.04),('8902','2014-04-04','10:40:00',6.26),('8902','2014-04-04','10:45:00',5.49),('8902','2014-04-04','10:50:00',4.65),('8902','2014-04-04','10:55:00',5.76),('8902','2014-04-04','11:00:00',6.77),('8902','2014-04-04','11:05:00',7.32),('8902','2014-04-04','11:10:00',7.49),('8902','2014-04-04','11:15:00',7.94),('8902','2014-04-04','11:20:00',7.69),('8902','2014-04-04','11:25:00',4.7),('8902','2014-04-04','11:30:00',3.94),('8902','2014-04-04','11:35:00',5.71),('8902','2014-04-04','11:40:00',7.3),('8902','2014-04-04','11:45:00',8.07),('8902','2014-04-04','11:50:00',8.54),('8902','2014-04-04','11:55:00',7.69),('8902','2014-04-04','12:00:00',5.61),('8902','2014-04-04','12:05:00',5.87),('8902','2014-04-04','12:10:00',6.59),('8902','2014-04-04','12:15:00',6.93),('8902','2014-04-04','12:20:00',6.42),('8902','2014-04-04','12:25:00',4.9),('8902','2014-04-04','12:30:00',5.4),('8902','2014-04-04','12:35:00',5.82),('8902','2014-04-04','12:40:00',8.73),('8902','2014-04-04','12:45:00',9.68),('8902','2014-04-04','12:50:00',9.18),('8902','2014-04-04','12:55:00',7.04),('8902','2014-04-04','13:00:00',7.84),('8902','2014-04-04','13:05:00',7.22),('8902','2014-04-04','13:10:00',7.79),('8902','2014-04-04','13:15:00',4.1),('8902','2014-04-04','13:20:00',7.89),('8902','2014-04-04','13:25:00',7.77),('8902','2014-04-04','13:30:00',7.98),('8902','2014-04-04','13:35:00',9.44),('8902','2014-04-04','13:40:00',6.9),('8902','2014-04-04','13:45:00',4.42),('8902','2014-04-04','13:50:00',7.13),('8902','2014-04-04','13:55:00',8.11),('8902','2014-04-04','14:00:00',6.42),('8902','2014-04-04','14:05:00',9.91),('8902','2014-04-04','14:10:00',4.32),('8902','2014-04-04','14:15:00',1.72),('8902','2014-04-04','14:20:00',1.97),('8902','2014-04-04','14:25:00',5.3),('8902','2014-04-04','14:30:00',3.07),('8902','2014-04-04','14:35:00',1.86),('8902','2014-04-04','14:40:00',1.65),('8902','2014-04-04','14:45:00',1.44),('8902','2014-04-04','14:50:00',3.18),('8902','2014-04-04','14:55:00',8.42),('8902','2014-04-04','15:00:00',5),('8902','2014-04-04','15:05:00',7.58),('8902','2014-04-04','15:10:00',3.26),('8902','2014-04-04','15:15:00',5.51),('8902','2014-04-04','15:20:00',8.7),('8902','2014-04-04','15:25:00',5.76),('8902','2014-04-04','15:30:00',2.8),('8902','2014-04-04','15:35:00',3.03),('8902','2014-04-04','15:40:00',6.76),('8902','2014-04-04','15:45:00',2.95),('8902','2014-04-04','15:50:00',3.26),('8902','2014-04-04','15:55:00',2.44),('8902','2014-04-04','16:00:00',2.54),('8902','2014-04-04','16:05:00',2.97),('8902','2014-04-04','16:10:00',2.52),('8902','2014-04-04','16:15:00',6.22),('8902','2014-04-04','16:20:00',6.65),('8902','2014-04-04','16:25:00',6.25),('8902','2014-04-04','16:30:00',4.21),('8902','2014-04-04','16:35:00',5.62),('8902','2014-04-04','16:40:00',3.06),('8902','2014-04-04','16:45:00',4.41),('8902','2014-04-04','16:50:00',3.39),('8902','2014-04-04','16:55:00',3.85),('8902','2014-04-04','17:00:00',4.51),('8902','2014-04-04','17:05:00',4.3),('8902','2014-04-04','17:10:00',3.73),('8902','2014-04-04','17:15:00',2.92),('8902','2014-04-04','17:20:00',3.06),('8902','2014-04-04','17:25:00',2.9),('8902','2014-04-04','17:30:00',2.72),('8902','2014-04-04','17:35:00',2.42),('8902','2014-04-04','17:40:00',2.3),('8902','2014-04-04','17:45:00',1.85),('8902','2014-04-04','17:50:00',2.56),('8902','2014-04-04','17:55:00',2.61),('8902','2014-04-04','18:00:00',2.51),('8902','2014-04-04','18:05:00',2.28),('8902','2014-04-04','18:10:00',2.17),('8902','2014-04-04','18:15:00',2.2),('8902','2014-04-04','18:20:00',2.03),('8902','2014-04-04','18:25:00',1.52),('8902','2013-06-29','07:20:00',1.03),('8902','2013-06-29','07:25:00',1.16),('8902','2013-06-29','07:30:00',1.31),('8902','2013-06-29','07:35:00',1.46),('8902','2013-06-29','07:40:00',1.6),('8902','2013-06-29','07:45:00',1.75),('8902','2013-06-29','07:50:00',1.91),('8902','2013-06-29','07:55:00',2.07),('8902','2013-06-29','08:00:00',2.23),('8902','2013-06-29','08:05:00',2.39),('8902','2013-06-29','08:10:00',2.56),('8902','2013-06-29','08:15:00',2.73),('8902','2013-06-29','08:20:00',2.9),('8902','2013-06-29','08:25:00',3.07),('8902','2013-06-29','08:30:00',3.24),('8902','2013-06-29','08:35:00',3.4),('8902','2013-06-29','08:40:00',3.56),('8902','2013-06-29','08:45:00',3.72),('8902','2013-06-29','08:50:00',3.88),('8902','2013-06-29','08:55:00',4.03),('8902','2013-06-29','09:00:00',4.18),('8902','2013-06-29','09:05:00',4.34),('8902','2013-06-29','09:10:00',4.48),('8902','2013-06-29','09:15:00',4.62),('8902','2013-06-29','09:20:00',4.76),('8902','2013-06-29','09:25:00',4.88),('8902','2013-06-29','09:30:00',5.03),('8902','2013-06-29','09:35:00',5.16),('8902','2013-06-29','09:40:00',5.28),('8902','2013-06-29','09:45:00',5.42),('8902','2013-06-29','09:50:00',5.56),('8902','2013-06-29','09:55:00',5.66),('8902','2013-06-29','10:00:00',5.76),('8902','2013-06-29','10:05:00',5.89),('8902','2013-06-29','10:10:00',6),('8902','2013-06-29','10:15:00',6.09),('8902','2013-06-29','10:20:00',6.21),('8902','2013-06-29','10:25:00',6.31),('8902','2013-06-29','10:30:00',6.39),('8902','2013-06-29','10:35:00',6.51),('8902','2013-06-29','10:40:00',6.6),('8902','2013-06-29','10:45:00',6.71),('8902','2013-06-29','10:50:00',6.76),('8902','2013-06-29','10:55:00',6.85),('8902','2013-06-29','11:00:00',6.97),('8902','2013-06-29','11:05:00',7.02),('8902','2013-06-29','11:10:00',7.07),('8902','2013-06-29','11:15:00',7.09),('8902','2013-06-29','11:20:00',7.12),('8902','2013-06-29','11:25:00',7.21),('8902','2013-06-29','11:30:00',7.31),('8902','2013-06-29','11:35:00',7.36),('8902','2013-06-29','11:40:00',7.39),('8902','2013-06-29','11:45:00',7.42),('8902','2013-06-29','11:50:00',7.51),('8902','2013-06-29','11:55:00',7.57),('8902','2013-06-29','12:00:00',7.6),('8902','2013-06-29','12:05:00',7.63),('8902','2013-06-29','12:10:00',7.66),('8902','2013-06-29','12:15:00',7.71),('8902','2013-06-29','12:20:00',7.75),('8902','2013-06-29','12:25:00',7.79),('8902','2013-06-29','12:30:00',7.83),('8902','2013-06-29','12:35:00',7.8),('8902','2013-06-29','12:40:00',7.87),('8902','2013-06-29','12:45:00',7.99),('8902','2013-06-29','12:50:00',8.06),('8902','2013-06-29','12:55:00',8.05),('8902','2013-06-29','13:00:00',7.98),('8902','2013-06-29','13:05:00',8.05),('8902','2013-06-29','13:10:00',8.1),('8902','2013-06-29','13:15:00',8.03),('8902','2013-06-29','13:20:00',8.02),('8902','2013-06-29','13:25:00',8.1),('8902','2013-06-29','13:30:00',8.09),('8902','2013-06-29','13:35:00',7.96),('8902','2013-06-29','13:40:00',8.03),('8902','2013-06-29','13:45:00',8.08),('8902','2013-06-29','13:50:00',8.11),('8902','2013-06-29','13:55:00',7.92),('8902','2013-06-29','14:00:00',7.9),('8902','2013-06-29','14:05:00',8.01),('8902','2013-06-29','14:10:00',7.94),('8902','2013-06-29','14:15:00',7.81),('8902','2013-06-29','14:20:00',7.78),('8902','2013-06-29','14:25:00',7.74),('8902','2013-06-29','14:30:00',7.69),('8902','2013-06-29','14:35:00',7.68),('8902','2013-06-29','14:40:00',7.69),('8902','2013-06-29','14:45:00',7.66),('8902','2013-06-29','14:50:00',7.63),('8902','2013-06-29','14:55:00',7.61),('8902','2013-06-29','15:00:00',7.54),('8902','2013-06-29','15:05:00',7.41),('8902','2013-06-29','15:10:00',7.44),('8902','2013-06-29','15:15:00',7.39),('8902','2013-06-29','15:20:00',7.36),('8902','2013-06-29','15:25:00',7.24),('8902','2013-06-29','15:30:00',7.17),('8902','2013-06-29','15:35:00',7.17),('8902','2013-06-29','15:40:00',7.12),('8902','2013-06-29','15:45:00',7.03),('8902','2013-06-29','15:50:00',6.96),('8902','2013-06-29','15:55:00',6.84),('8902','2013-06-29','16:00:00',6.76),('8902','2013-06-29','16:05:00',6.64),('8902','2013-06-29','16:10:00',6.63),('8902','2013-06-29','16:15:00',6.57),('8902','2013-06-29','16:20:00',6.59),('8902','2013-06-29','16:25:00',6.69),('8902','2013-06-29','16:30:00',6.7),('8902','2013-06-29','16:35:00',5.78),('8902','2013-06-29','16:40:00',5.74),('8902','2013-06-29','16:45:00',5.72),('8902','2013-06-29','16:50:00',5.61),('8902','2013-06-29','16:55:00',5.33),('8902','2013-06-29','17:00:00',5.15),('8902','2013-06-29','17:05:00',5.11),('8902','2013-06-29','17:10:00',5.02),('8902','2013-06-29','17:15:00',4.86),('8902','2013-06-29','17:20:00',4.7),('8902','2013-06-29','17:25:00',4.46),('8902','2013-06-29','17:30:00',4.26),('8902','2013-06-29','17:35:00',4.1),('8902','2013-06-29','17:40:00',3.99),('8902','2013-06-29','17:45:00',3.8),('8902','2013-06-29','17:50:00',3.71),('8902','2013-06-29','17:55:00',3.5),('8902','2013-06-29','18:00:00',3.27),('8902','2013-06-29','18:05:00',3.13),('8902','2013-06-29','18:10:00',3.01),('8902','2013-06-29','18:15:00',2.87),('8902','2013-06-29','18:20:00',2.75),('8902','2013-06-29','18:25:00',2.53),('8902','2013-06-29','18:30:00',2.35),('8902','2013-06-29','18:35:00',2.14),('8902','2013-06-29','18:40:00',2.01),('8902','2013-06-29','18:45:00',1.84),('8902','2013-06-29','18:50:00',1.67),('8902','2013-06-29','18:55:00',1.56),('8902','2013-06-29','19:00:00',1.4),('8902','2013-06-29','19:05:00',1.26),('8902','2013-06-29','19:10:00',1.11),('8902','2013-06-28','07:25:00',1.12),('8902','2013-06-28','07:30:00',1.66),('8902','2013-06-28','07:35:00',2.07),('8902','2013-06-28','07:40:00',2.19),('8902','2013-06-28','07:45:00',2.21),('8902','2013-06-28','07:50:00',2.34),('8902','2013-06-28','07:55:00',2.53),('8902','2013-06-28','08:00:00',3.03),('8902','2013-06-28','08:05:00',3.32),('8902','2013-06-28','08:10:00',3.48),('8902','2013-06-28','08:15:00',3.17),('8902','2013-06-28','08:20:00',2.09),('8902','2013-06-28','08:25:00',3.2),('8902','2013-06-28','08:30:00',3.45),('8902','2013-06-28','08:35:00',3.57),('8902','2013-06-28','08:40:00',2.52),('8902','2013-06-28','08:45:00',3.16),('8902','2013-06-28','08:50:00',3.91),('8902','2013-06-28','08:55:00',4.02),('8902','2013-06-28','09:00:00',4.11),('8902','2013-06-28','09:05:00',4.25),('8902','2013-06-28','09:10:00',4.4),('8902','2013-06-28','09:15:00',4.55),('8902','2013-06-28','09:20:00',4.68),('8902','2013-06-28','09:25:00',4.8),('8902','2013-06-28','09:30:00',4.86),('8902','2013-06-28','09:35:00',5.08),('8902','2013-06-28','09:40:00',5.22),('8902','2013-06-28','09:45:00',5.31),('8902','2013-06-28','09:50:00',5.47),('8902','2013-06-28','09:55:00',5.59),('8902','2013-06-28','10:00:00',5.7),('8902','2013-06-28','10:05:00',5.82),('8902','2013-06-28','10:10:00',5.92),('8902','2013-06-28','10:15:00',6.03),('8902','2013-06-28','10:20:00',6.11),('8902','2013-06-28','10:25:00',6.27),('8902','2013-06-28','10:30:00',6.38),('8902','2013-06-28','10:35:00',6.47),('8902','2013-06-28','10:40:00',6.56),('8902','2013-06-28','10:45:00',6.72),('8902','2013-06-28','10:50:00',6.81),('8902','2013-06-28','10:55:00',6.85),('8902','2013-06-28','11:00:00',6.99),('8902','2013-06-28','11:05:00',7.14),('8902','2013-06-28','11:10:00',7.31),('8902','2013-06-28','11:15:00',7.45),('8902','2013-06-28','11:20:00',5.47),('8902','2013-06-28','11:25:00',7.27),('8902','2013-06-28','11:30:00',8.05),('8902','2013-06-28','11:35:00',7.93),('8902','2013-06-28','11:40:00',8.33),('8902','2013-06-28','11:45:00',3.36),('8902','2013-06-28','11:50:00',3.29),('8902','2013-06-28','11:55:00',8.86),('8902','2013-06-28','12:00:00',6.72),('8902','2013-06-28','12:05:00',8.1),('8902','2013-06-28','12:10:00',8.22),('8902','2013-06-28','12:15:00',8.38),('8902','2013-06-28','12:20:00',2.88),('8902','2013-06-28','12:25:00',7.51),('8902','2013-06-28','12:30:00',8.51),('8902','2013-06-28','12:35:00',8.45),('8902','2013-06-28','12:40:00',8.44),('8902','2013-06-28','12:45:00',8.78),('8902','2013-06-28','12:50:00',6.12),('8902','2013-06-28','12:55:00',4.68),('8902','2013-06-28','13:00:00',6.37),('8902','2013-06-28','13:05:00',4.91),('8902','2013-06-28','13:10:00',8.01),('8902','2013-06-28','13:15:00',9.26),('8902','2013-06-28','13:20:00',6.02),('8902','2013-06-28','13:25:00',9.37),('8902','2013-06-28','13:30:00',4.52),('8902','2013-06-28','13:35:00',1.66),('8902','2013-06-28','13:40:00',1.66),('8902','2013-06-28','13:45:00',4.16),('8902','2013-06-28','13:50:00',8.09),('8902','2013-06-28','13:55:00',4.67),('8902','2013-06-28','14:00:00',8.85),('8902','2013-06-28','14:05:00',6.71),('8902','2013-06-28','14:10:00',7.53),('8902','2013-06-28','14:15:00',9.26),('8902','2013-06-28','14:20:00',9.35),('8902','2013-06-28','14:25:00',5.31),('8902','2013-06-28','14:30:00',9.37),('8902','2013-06-28','14:35:00',8.69),('8902','2013-06-28','14:40:00',8.66),('8902','2013-06-28','14:45:00',8.82),('8902','2013-06-28','14:50:00',8.25),('8902','2013-06-28','14:55:00',2.21),('8902','2013-06-28','15:00:00',4.27),('8902','2013-06-28','15:05:00',5.42),('8902','2013-06-28','15:10:00',2.89),('8902','2013-06-28','15:15:00',3.01),('8902','2013-06-28','15:20:00',1.71),('8902','2013-06-28','15:25:00',1.18),('8902','2013-06-28','15:30:00',1.02),('8902','2013-06-28','15:35:00',1.03),('8902','2013-06-28','15:40:00',1.04),('8902','2013-06-28','16:30:00',1.11),('8902','2013-06-28','16:35:00',1.55),('8902','2013-06-28','16:40:00',2.22),('8902','2013-06-28','16:45:00',3.07),('8902','2013-06-28','16:50:00',4.83),('8902','2013-06-28','16:55:00',3.18),('8902','2013-06-28','17:00:00',1.99),('8902','2013-06-28','17:05:00',2.33),('8902','2013-06-28','17:10:00',2.2),('8902','2013-06-28','17:15:00',1.93),('8902','2013-06-28','17:20:00',2.21),('8902','2013-06-28','17:25:00',2.7),('8902','2013-06-28','17:30:00',5.12),('8902','2013-06-28','17:35:00',4.97),('8902','2013-06-28','17:40:00',1.74),('8902','2013-06-28','17:45:00',3.78),('8902','2013-06-28','17:50:00',3.99),('8902','2013-06-28','17:55:00',3.71),('8902','2013-06-28','18:00:00',3.38),('8902','2013-06-28','18:05:00',3.34),('8902','2013-06-28','18:10:00',3.14),('8902','2013-06-28','18:15:00',2.96),('8902','2013-06-28','18:20:00',2.76),('8902','2013-06-28','18:25:00',2.51),('8902','2013-06-28','18:30:00',2.35),('8902','2013-06-28','18:35:00',2.43),('8902','2013-06-28','18:40:00',2.27),('8902','2013-06-28','18:45:00',1.59),('8902','2013-06-28','19:05:00',1.02),('8902','2013-06-28','19:10:00',1.14),('8902','2013-06-27','07:10:00',1.02),('8902','2013-06-27','07:15:00',1),('8902','2013-06-27','07:20:00',1.1),('8902','2013-06-27','07:25:00',1.22),('8902','2013-06-27','07:30:00',1.41),('8902','2013-06-27','07:35:00',1.52),('8902','2013-06-27','07:40:00',1.58),('8902','2013-06-27','07:45:00',1.86),('8902','2013-06-27','07:50:00',1.97),('8902','2013-06-27','07:55:00',2.13),('8902','2013-06-27','08:00:00',2.26),('8902','2013-06-27','08:05:00',2.27),('8902','2013-06-27','08:10:00',2.36),('8902','2013-06-27','08:15:00',2.66),('8902','2013-06-27','08:20:00',2.83),('8902','2013-06-27','08:25:00',2.81),('8902','2013-06-27','08:30:00',3.08),('8902','2013-06-27','08:35:00',3.32),('8902','2013-06-27','08:40:00',3.49),('8902','2013-06-27','08:45:00',3.59),('8902','2013-06-27','08:50:00',3.77),('8902','2013-06-27','08:55:00',3.9),('8902','2013-06-27','09:00:00',4.02),('8902','2013-06-27','09:05:00',4.25),('8902','2013-06-27','09:10:00',4.64),('8902','2013-06-27','09:15:00',3.31),('8902','2013-06-27','09:20:00',2.21),('8902','2013-06-27','09:25:00',1.68),('8902','2013-06-27','09:30:00',3.5),('8902','2013-06-27','09:35:00',5.45),('8902','2013-06-27','09:40:00',4.79),('8902','2013-06-27','09:45:00',3.81),('8902','2013-06-27','09:50:00',1.92),('8902','2013-06-27','09:55:00',6.34),('8902','2013-06-27','10:00:00',6.29),('8902','2013-06-27','10:05:00',5.97),('8902','2013-06-27','10:10:00',5.13),('8902','2013-06-27','10:15:00',6.06),('8902','2013-06-27','10:20:00',7.29),('8902','2013-06-27','10:25:00',2.87),('8902','2013-06-27','10:30:00',2.43),('8902','2013-06-27','10:35:00',6.31),('8902','2013-06-27','10:40:00',7.36),('8902','2013-06-27','10:45:00',3.51),('8902','2013-06-27','10:50:00',8.05),('8902','2013-06-27','10:55:00',3.57),('8902','2013-06-27','11:00:00',3.55),('8902','2013-06-27','11:05:00',7.36),('8902','2013-06-27','11:10:00',5.49),('8902','2013-06-27','11:15:00',3.46),('8902','2013-06-27','11:20:00',2.27),('8902','2013-06-27','11:25:00',5.38),('8902','2013-06-27','11:30:00',6.16),('8902','2013-06-27','11:35:00',6.69),('8902','2013-06-27','11:40:00',4.09),('8902','2013-06-27','11:45:00',7.02),('8902','2013-06-27','11:50:00',8.2),('8902','2013-06-27','11:55:00',8.36),('8902','2013-06-27','12:00:00',7.06),('8902','2013-06-27','12:05:00',8.49),('8902','2013-06-27','12:10:00',7.18),('8902','2013-06-27','12:15:00',8.75),('8902','2013-06-27','12:20:00',8.31),('8902','2013-06-27','12:25:00',8.01),('8902','2013-06-27','12:30:00',7.12),('8902','2013-06-27','12:35:00',7.88),('8902','2013-06-27','12:40:00',8.78),('8902','2013-06-27','12:45:00',8.3),('8902','2013-06-27','12:50:00',5.56),('8902','2013-06-27','12:55:00',8.48),('8902','2013-06-27','13:00:00',5.13),('8902','2013-06-27','13:05:00',7.5),('8902','2013-06-27','13:10:00',8.12),('8902','2013-06-27','13:15:00',8.63),('8902','2013-06-27','13:20:00',8.37),('8902','2013-06-27','13:25:00',8.34),('8902','2013-06-27','13:30:00',6.67),('8902','2013-06-27','13:35:00',7.29),('8902','2013-06-27','13:40:00',7.88),('8902','2013-06-27','13:45:00',7.66),('8902','2013-06-27','13:50:00',7.55),('8902','2013-06-27','13:55:00',8.6),('8902','2013-06-27','14:00:00',7.64),('8902','2013-06-27','14:05:00',7.62),('8902','2013-06-27','14:10:00',7.69),('8902','2013-06-27','14:15:00',7.96),('8902','2013-06-27','14:20:00',7.6),('8902','2013-06-27','14:25:00',9.04),('8902','2013-06-27','14:30:00',7.9),('8902','2013-06-27','14:35:00',7.39),('8902','2013-06-27','14:40:00',6.38),('8902','2013-06-27','14:45:00',5.77),('8902','2013-06-27','14:50:00',8.2),('8902','2013-06-27','14:55:00',7.23),('8902','2013-06-27','15:00:00',6.91),('8902','2013-06-27','15:05:00',7.95),('8902','2013-06-27','15:10:00',5.1),('8902','2013-06-27','15:15:00',4.03),('8902','2013-06-27','15:20:00',2.23),('8902','2013-06-27','15:25:00',6.02),('8902','2013-06-27','15:30:00',6.74),('8902','2013-06-27','15:35:00',8.38),('8902','2013-06-27','15:40:00',5.96),('8902','2013-06-27','15:45:00',4.1),('8902','2013-06-27','15:50:00',7),('8902','2013-06-27','15:55:00',4.84),('8902','2013-06-27','16:00:00',6.01),('8902','2013-06-27','16:05:00',6.7),('8902','2013-06-27','16:10:00',6.34),('8902','2013-06-27','16:15:00',6.34),('8902','2013-06-27','16:20:00',3.62),('8902','2013-06-27','16:25:00',3.41),('8902','2013-06-27','16:30:00',2.59),('8902','2013-06-27','16:35:00',4.79),('8902','2013-06-27','16:40:00',3.59),('8902','2013-06-27','16:45:00',1.53),('8902','2013-06-27','16:50:00',1.97),('8902','2013-06-27','16:55:00',3.52),('8902','2013-06-27','17:00:00',5.24),('8902','2013-06-27','17:05:00',5.38),('8902','2013-06-27','17:10:00',5.2),('8902','2013-06-27','17:15:00',4.67),('8902','2013-06-27','17:20:00',4.75),('8902','2013-06-27','17:25:00',4.67),('8902','2013-06-27','17:30:00',4.08),('8902','2013-06-27','17:35:00',4.33),('8902','2013-06-27','17:40:00',4.1),('8902','2013-06-27','17:45:00',4.01),('8902','2013-06-27','17:50:00',3.9),('8902','2013-06-27','17:55:00',3.63),('8902','2013-06-27','18:00:00',3.39),('8902','2013-06-27','18:05:00',3.33),('8902','2013-06-27','18:10:00',3.14),('8902','2013-06-27','18:15:00',3.09),('8902','2013-06-27','18:20:00',2.97),('8902','2013-06-27','18:25:00',2.76),('8902','2013-06-27','18:30:00',2.52),('8902','2013-06-27','18:35:00',2.26),('8902','2013-06-27','18:40:00',2.13),('8902','2013-06-27','18:45:00',1.98),('8902','2013-06-27','18:50:00',1.77),('8902','2013-06-27','18:55:00',1.59),('8902','2013-06-27','19:00:00',1.42),('8902','2013-06-27','19:05:00',1.29),('8902','2013-06-27','19:10:00',1.12),('8902','2013-06-26','07:30:00',1.28),('8902','2013-06-26','07:35:00',1.43),('8902','2013-06-26','07:40:00',1.57),('8902','2013-06-26','07:45:00',1.73),('8902','2013-06-26','07:50:00',1.92),('8902','2013-06-26','07:55:00',2.08),('8902','2013-06-26','08:00:00',2.24),('8902','2013-06-26','08:05:00',2.4),('8902','2013-06-26','08:10:00',2.6),('8902','2013-06-26','08:15:00',2.73),('8902','2013-06-26','08:20:00',2.88),('8902','2013-06-26','08:25:00',3.03),('8902','2013-06-26','08:30:00',3.17),('8902','2013-06-26','08:35:00',3.3),('8902','2013-06-26','08:40:00',3.44),('8902','2013-06-26','08:45:00',3.63),('8902','2013-06-26','08:50:00',3.76),('8902','2013-06-26','08:55:00',3.95),('8902','2013-06-26','09:00:00',4.15),('8902','2013-06-26','09:05:00',4.27),('8902','2013-06-26','09:10:00',4.41),('8902','2013-06-26','09:15:00',4.58),('8902','2013-06-26','09:20:00',4.75),('8902','2013-06-26','09:25:00',4.85),('8902','2013-06-26','09:30:00',5.02),('8902','2013-06-26','09:35:00',5.18),('8902','2013-06-26','09:40:00',5.26),('8902','2013-06-26','09:45:00',5.39),('8902','2013-06-26','09:50:00',5.56),('8902','2013-06-26','09:55:00',5.71),('8902','2013-06-26','10:00:00',5.88),('8902','2013-06-26','10:05:00',6.18),('8902','2013-06-26','10:10:00',6.06),('8902','2013-06-26','10:15:00',6.4),('8902','2013-06-26','10:20:00',6.23),('8902','2013-06-26','10:25:00',6.27),('8902','2013-06-26','10:30:00',6.47),('8902','2013-06-26','10:35:00',6.68),('8902','2013-06-26','10:40:00',6.95),('8902','2013-06-26','10:45:00',7.16),('8902','2013-06-26','10:50:00',7.12),('8902','2013-06-26','10:55:00',7.14),('8902','2013-06-26','11:00:00',7.08),('8902','2013-06-26','11:05:00',6.62),('8902','2013-06-26','11:10:00',4.91),('8902','2013-06-26','11:15:00',7.58),('8902','2013-06-26','11:20:00',7.53),('8902','2013-06-26','11:25:00',7.47),('8902','2013-06-26','11:30:00',7.61),('8902','2013-06-26','11:35:00',7.23),('8902','2013-06-26','11:40:00',7.37),('8902','2013-06-26','11:45:00',5.6),('8902','2013-06-26','11:50:00',2.38),('8902','2013-06-26','11:55:00',2.73),('8902','2013-06-26','12:00:00',3.64),('8902','2013-06-26','12:05:00',2.54),('8902','2013-06-26','12:10:00',3.1),('8902','2013-06-26','12:15:00',3.02),('8902','2013-06-26','12:20:00',2.31),('8902','2013-06-26','12:25:00',3.13),('8902','2013-06-26','12:30:00',2.73),('8902','2013-06-26','12:35:00',3.41),('8902','2013-06-26','12:40:00',4.28),('8902','2013-06-26','12:45:00',3.36),('8902','2013-06-26','12:50:00',3.5),('8902','2013-06-26','12:55:00',2.61),('8902','2013-06-26','13:00:00',1.82),('8902','2013-06-26','13:05:00',1.95),('8902','2013-06-26','13:10:00',2.47),('8902','2013-06-26','13:15:00',2.8),('8902','2013-06-26','13:20:00',2.83),('8902','2013-06-26','13:25:00',3.04),('8902','2013-06-26','13:30:00',2.7),('8902','2013-06-26','13:35:00',2.72),('8902','2013-06-26','13:40:00',2.32),('8902','2013-06-26','13:45:00',2.12),('8902','2013-06-26','13:50:00',2.23),('8902','2013-06-26','13:55:00',2.25),('8902','2013-06-26','14:00:00',2.5),('8902','2013-06-26','14:05:00',2.51),('8902','2013-06-26','14:10:00',2.84),('8902','2013-06-26','14:15:00',3.13),('8902','2013-06-26','14:20:00',7.04),('8902','2013-06-26','14:25:00',7.88),('8902','2013-06-26','14:30:00',6.61),('8902','2013-06-26','14:35:00',6.51),('8902','2013-06-26','14:40:00',6),('8902','2013-06-26','14:45:00',3.21),('8902','2013-06-26','14:50:00',4.68),('8902','2013-06-26','14:55:00',7.88),('8902','2013-06-26','15:00:00',7.57),('8902','2013-06-26','15:05:00',7.38),('8902','2013-06-26','15:10:00',7.26),('8902','2013-06-26','15:15:00',7.25),('8902','2013-06-26','15:20:00',7.18),('8902','2013-06-26','15:25:00',7.23),('8902','2013-06-26','15:30:00',7.11),('8902','2013-06-26','15:35:00',6.99),('8902','2013-06-26','15:40:00',6.92),('8902','2013-06-26','15:45:00',6.87),('8902','2013-06-26','15:50:00',6.79),('8902','2013-06-26','15:55:00',6.7),('8902','2013-06-26','16:00:00',6.49),('8902','2013-06-26','16:05:00',6.35),('8902','2013-06-26','16:10:00',6.27),('8902','2013-06-26','16:15:00',6.21),('8902','2013-06-26','16:20:00',6.14),('8902','2013-06-26','16:25:00',6.08),('8902','2013-06-26','16:30:00',5.99),('8902','2013-06-26','16:35:00',5.53),('8902','2013-06-26','16:40:00',5.46),('8902','2013-06-26','16:45:00',5.53),('8902','2013-06-26','16:50:00',5.4),('8902','2013-06-26','16:55:00',5.2),('8902','2013-06-26','17:00:00',5.11),('8902','2013-06-26','17:05:00',4.98),('8902','2013-06-26','17:10:00',4.75),('8902','2013-06-26','17:15:00',4.54),('8902','2013-06-26','17:20:00',4.64),('8902','2013-06-26','17:25:00',4.51),('8902','2013-06-26','17:30:00',4.38),('8902','2013-06-26','17:35:00',4.24),('8902','2013-06-26','17:40:00',3.16),('8902','2013-06-26','17:45:00',1.72),('8902','2013-06-26','17:50:00',3.52),('8902','2013-06-26','17:55:00',3.47),('8902','2013-06-26','18:00:00',3.2),('8902','2013-06-26','18:05:00',3.13),('8902','2013-06-26','18:10:00',2.91),('8902','2013-06-26','18:15:00',2.72),('8902','2013-06-26','18:20:00',2.59),('8902','2013-06-26','18:25:00',2.53),('8902','2013-06-26','18:30:00',2.34),('8902','2013-06-26','18:35:00',2.14),('8902','2013-06-26','18:40:00',1.85),('8902','2013-06-26','18:45:00',1.72),('8902','2013-06-26','18:50:00',1.62),('8902','2013-06-26','18:55:00',1.5),('8902','2013-06-26','19:00:00',1.33),('8902','2013-06-26','19:05:00',1.19),('8902','2013-06-26','19:10:00',1.04),('8902','2013-06-25','07:20:00',1.03),('8902','2013-06-25','07:25:00',1.16),('8902','2013-06-25','07:30:00',1.31),('8902','2013-06-25','07:35:00',1.47),('8902','2013-06-25','07:40:00',1.62),('8902','2013-06-25','07:45:00',1.79),('8902','2013-06-25','07:50:00',1.96),('8902','2013-06-25','07:55:00',2.1),('8902','2013-06-25','08:00:00',2.23),('8902','2013-06-25','08:05:00',2.39),('8902','2013-06-25','08:10:00',2.58),('8902','2013-06-25','08:15:00',2.73),('8902','2013-06-25','08:20:00',2.87),('8902','2013-06-25','08:25:00',3.02),('8902','2013-06-25','08:30:00',3.17),('8902','2013-06-25','08:35:00',3.33),('8902','2013-06-25','08:40:00',3.45),('8902','2013-06-25','08:45:00',3.61),('8902','2013-06-25','08:50:00',3.76),('8902','2013-06-25','08:55:00',3.88),('8902','2013-06-25','09:00:00',4.01),('8902','2013-06-25','09:05:00',4.18),('8902','2013-06-25','09:10:00',4.31),('8902','2013-06-25','09:15:00',4.46),('8902','2013-06-25','09:20:00',4.58),('8902','2013-06-25','09:25:00',4.76),('8902','2013-06-25','09:30:00',4.89),('8902','2013-06-25','09:35:00',5.03),('8902','2013-06-25','09:40:00',5.16),('8902','2013-06-25','09:45:00',5.23),('8902','2013-06-25','09:50:00',5.33),('8902','2013-06-25','09:55:00',5.43),('8902','2013-06-25','10:00:00',5.58),('8902','2013-06-25','10:05:00',5.71),('8902','2013-06-25','10:10:00',5.77),('8902','2013-06-25','10:15:00',5.93),('8902','2013-06-25','10:20:00',6.02),('8902','2013-06-25','10:25:00',6.07),('8902','2013-06-25','10:30:00',6.17),('8902','2013-06-25','10:35:00',6.32),('8902','2013-06-25','10:40:00',6.42),('8902','2013-06-25','10:45:00',6.53),('8902','2013-06-25','10:50:00',6.62),('8902','2013-06-25','10:55:00',6.66),('8902','2013-06-25','11:00:00',6.75),('8902','2013-06-25','11:05:00',6.85),('8902','2013-06-25','11:10:00',6.94),('8902','2013-06-25','11:15:00',6.96),('8902','2013-06-25','11:20:00',6.99),('8902','2013-06-25','11:25:00',7.01),('8902','2013-06-25','11:30:00',7.06),('8902','2013-06-25','11:35:00',7.17),('8902','2013-06-25','11:40:00',7.3),('8902','2013-06-25','11:45:00',7.4),('8902','2013-06-25','11:50:00',7.41),('8902','2013-06-25','11:55:00',7.5),('8902','2013-06-25','12:00:00',7.38),('8902','2013-06-25','12:30:00',7.34),('8902','2013-06-25','12:40:00',7.72),('8902','2013-06-25','12:45:00',7.77),('8902','2013-06-25','12:50:00',7.77),('8902','2013-06-25','12:55:00',5.29),('8902','2013-06-25','13:00:00',1.87),('8902','2013-06-25','13:05:00',3.54),('8902','2013-06-25','13:10:00',7.52),('8902','2013-06-25','13:15:00',8.71),('8902','2013-06-25','13:20:00',8.48),('8902','2013-06-25','13:25:00',6.56),('8902','2013-06-25','13:30:00',2.1),('8902','2013-06-25','13:35:00',1.82),('8902','2013-06-25','13:40:00',1.83),('8902','2013-06-25','13:45:00',2.06),('8902','2013-06-25','13:50:00',2.37),('8902','2013-06-25','13:55:00',2.72),('8902','2013-06-25','14:00:00',5.65),('8902','2013-06-25','14:05:00',4.87),('8902','2013-06-25','14:10:00',2.96),('8902','2013-06-25','14:15:00',5.38),('8902','2013-06-25','14:20:00',7.81),('8902','2013-06-25','14:25:00',4.24),('8902','2013-06-25','14:30:00',4.44),('8902','2013-06-25','14:35:00',2.03),('8902','2013-06-25','14:40:00',1.95),('8902','2013-06-25','14:45:00',6.12),('8902','2013-06-25','14:50:00',3.72),('8902','2013-06-25','14:55:00',5.55),('8902','2013-06-25','15:00:00',7.98),('8902','2013-06-25','15:05:00',7.7),('8902','2013-06-25','15:10:00',7.49),('8902','2013-06-25','15:15:00',7.35),('8902','2013-06-25','15:20:00',7.22),('8902','2013-06-25','15:25:00',7.16),('8902','2013-06-25','15:30:00',7.09),('8902','2013-06-25','15:35:00',7.16),('8902','2013-06-25','15:40:00',6.97),('8902','2013-06-25','15:45:00',6.88),('8902','2013-06-25','15:50:00',5.24),('8902','2013-06-25','15:55:00',5.64),('8902','2013-06-25','16:00:00',6.75),('8902','2013-06-25','16:05:00',6.56),('8902','2013-06-25','16:10:00',6.49),('8902','2013-06-25','16:15:00',6.46),('8902','2013-06-25','16:20:00',6.3),('8902','2013-06-25','16:25:00',6.18),('8902','2013-06-25','16:30:00',6.13),('8902','2013-06-25','16:35:00',5.9),('8902','2013-06-25','16:40:00',5.61),('8902','2013-06-25','16:45:00',5.6),('8902','2013-06-25','16:50:00',5.49),('8902','2013-06-25','16:55:00',5.31),('8902','2013-06-25','17:00:00',5.25),('8902','2013-06-25','17:05:00',5.15),('8902','2013-06-25','17:10:00',4.99),('8902','2013-06-25','17:15:00',4.77),('8902','2013-06-25','17:20:00',4.62),('8902','2013-06-25','17:25:00',4.4),('8902','2013-06-25','17:30:00',4.31),('8902','2013-06-25','17:35:00',4.21),('8902','2013-06-25','17:40:00',4.02),('8902','2013-06-25','17:45:00',3.85),('8902','2013-06-25','17:50:00',3.71),('8902','2013-06-25','17:55:00',3.5),('8902','2013-06-25','18:00:00',3.34),('8902','2013-06-25','18:05:00',3.5),('8902','2013-06-25','18:10:00',3.31),('8902','2013-06-25','18:15:00',1.52),('8902','2013-06-25','18:20:00',1.6),('8902','2013-06-25','18:25:00',1.29),('8902','2013-06-25','19:00:00',1.05),('8902','2013-06-25','19:15:00',1.06),('8902','2013-06-25','19:20:00',1.08),('8902','2013-06-24','07:20:00',1.07),('8902','2013-06-24','07:25:00',1.07),('8902','2013-06-24','07:30:00',1.35),('8902','2013-06-24','07:35:00',1.5),('8902','2013-06-24','07:45:00',1.85),('8902','2013-06-24','07:50:00',2.09),('8902','2013-06-24','07:55:00',2.27),('8902','2013-06-24','08:00:00',2.32),('8902','2013-06-24','08:05:00',3),('8902','2013-06-24','08:10:00',2.77),('8902','2013-06-24','08:15:00',2.03),('8902','2013-06-24','08:20:00',2.01),('8902','2013-06-24','08:25:00',2.2),('8902','2013-06-24','08:30:00',3.28),('8902','2013-06-24','08:35:00',3.4),('8902','2013-06-24','08:40:00',3.54),('8902','2013-06-24','08:45:00',3.72),('8902','2013-06-24','08:50:00',3.8),('8902','2013-06-24','08:55:00',3.97),('8902','2013-06-24','09:00:00',4.16),('8902','2013-06-24','09:05:00',4.31),('8902','2013-06-24','09:10:00',4.45),('8902','2013-06-24','09:15:00',4.61),('8902','2013-06-24','09:20:00',4.7),('8902','2013-06-24','09:25:00',4.95),('8902','2013-06-24','09:30:00',5.08),('8902','2013-06-24','09:35:00',4.64),('8902','2013-06-24','09:40:00',2.59),('8902','2013-06-24','09:45:00',2.29),('8902','2013-06-24','09:50:00',6.33),('8902','2013-06-24','09:55:00',6.45),('8902','2013-06-24','10:00:00',6.48),('8902','2013-06-24','10:05:00',2.54),('8902','2013-06-24','10:10:00',4.28),('8902','2013-06-24','10:15:00',6.98),('8902','2013-06-24','10:20:00',4.84),('8902','2013-06-24','10:25:00',3.43),('8902','2013-06-24','10:30:00',6.78),('8902','2013-06-24','10:35:00',2.98),('8902','2013-06-24','10:40:00',6.67),('8902','2013-06-24','10:45:00',7.33),('8902','2013-06-24','10:50:00',7.26),('8902','2013-06-24','10:55:00',7.37),('8902','2013-06-24','11:00:00',7.32),('8902','2013-06-24','11:05:00',7.7),('8902','2013-06-24','11:10:00',7.9),('8902','2013-06-24','11:15:00',7.36),('8902','2013-06-24','11:20:00',8.04),('8902','2013-06-24','11:25:00',4.81),('8902','2013-06-24','11:30:00',5.53),('8902','2013-06-24','11:35:00',7.74),('8902','2013-06-24','11:40:00',8.48),('8902','2013-06-24','11:45:00',8.4),('8902','2013-06-24','11:50:00',8.29),('8902','2013-06-24','11:55:00',7.61),('8902','2013-06-24','12:00:00',6.2),('8902','2013-06-24','12:05:00',5.28),('8902','2013-06-24','12:10:00',2.98),('8902','2013-06-24','12:15:00',2.66),('8902','2013-06-24','12:20:00',2.24),('8902','2013-06-24','12:25:00',1.95),('8902','2013-06-24','12:30:00',1.79),('8902','2013-06-24','12:35:00',1.94),('8902','2013-06-24','12:40:00',2.54),('8902','2013-06-24','12:45:00',2.48),('8902','2013-06-24','12:50:00',2.46),('8902','2013-06-24','12:55:00',3.75),('8902','2013-06-24','13:00:00',7.84),('8902','2013-06-24','13:05:00',8.98),('8902','2013-06-24','13:10:00',6.27),('8902','2013-06-24','13:15:00',6.4),('8902','2013-06-24','13:20:00',8.68),('8902','2013-06-24','13:25:00',8.51),('8902','2013-06-24','13:30:00',7.43),('8902','2013-06-24','13:35:00',6.34),('8902','2013-06-24','13:40:00',7.68),('8902','2013-06-24','13:45:00',8.52),('8902','2013-06-24','13:50:00',6.38),('8902','2013-06-24','13:55:00',6.51),('8902','2013-06-24','14:00:00',6.43),('8902','2013-06-24','14:05:00',8.61),('8902','2013-06-24','14:10:00',6.21),('8902','2013-06-24','14:15:00',4.85),('8902','2013-06-24','14:20:00',8.62),('8902','2013-06-24','14:25:00',8.15),('8902','2013-06-24','14:30:00',7.92),('8902','2013-06-24','14:35:00',7.86),('8902','2013-06-24','14:40:00',6.59),('8902','2013-06-24','14:45:00',7.95),('8902','2013-06-24','14:50:00',7.84),('8902','2013-06-24','14:55:00',7.72),('8902','2013-06-24','15:00:00',7.61),('8902','2013-06-24','15:05:00',7.53),('8902','2013-06-24','15:10:00',7.48),('8902','2013-06-24','15:15:00',7.5),('8902','2013-06-24','15:20:00',7.33),('8902','2013-06-24','15:25:00',7.21),('8902','2013-06-24','15:30:00',7.11),('8902','2013-06-24','15:35:00',6.99),('8902','2013-06-24','15:40:00',6.9),('8902','2013-06-24','15:45:00',6.83),('8902','2013-06-24','15:50:00',6.75),('8902','2013-06-24','15:55:00',6.64),('8902','2013-06-24','16:00:00',6.58),('8902','2013-06-24','16:05:00',6.5),('8902','2013-06-24','16:10:00',6.42),('8902','2013-06-24','16:15:00',6.33),('8902','2013-06-24','16:20:00',6.2),('8902','2013-06-24','16:25:00',6.1),('8902','2013-06-24','16:30:00',5.99),('8902','2013-06-24','16:35:00',5.83),('8902','2013-06-24','16:40:00',5.61),('8902','2013-06-24','16:45:00',5.59),('8902','2013-06-24','16:50:00',5.49),('8902','2013-06-24','16:55:00',5.25),('8902','2013-06-24','17:00:00',5.18),('8902','2013-06-24','17:05:00',5.06),('8902','2013-06-24','17:10:00',4.9),('8902','2013-06-24','17:15:00',4.79),('8902','2013-06-24','17:20:00',4.65),('8902','2013-06-24','17:25:00',4.45),('8902','2013-06-24','17:30:00',4.33),('8902','2013-06-24','17:35:00',4.18),('8902','2013-06-24','17:40:00',4),('8902','2013-06-24','17:45:00',3.84),('8902','2013-06-24','17:50:00',3.7),('8902','2013-06-24','17:55:00',3.51),('8902','2013-06-24','18:00:00',3.3),('8902','2013-06-24','18:05:00',3.21),('8902','2013-06-24','18:10:00',3),('8902','2013-06-24','18:15:00',2.83),('8902','2013-06-24','18:20:00',2.69),('8902','2013-06-24','18:25:00',2.47),('8902','2013-06-24','18:30:00',2.34),('8902','2013-06-24','18:35:00',2.16),('8902','2013-06-24','18:40:00',1.99),('8902','2013-06-24','18:45:00',1.82),('8902','2013-06-24','18:50:00',1.66),('8902','2013-06-24','18:55:00',1.49),('8902','2013-06-24','19:00:00',1.38),('8902','2013-06-24','19:05:00',1.22),('8902','2013-06-24','19:10:00',1.07),('8902','2013-06-23','07:10:00',1.23),('8902','2013-06-23','07:25:00',1.32),('8902','2013-06-23','07:30:00',1.13),('8902','2013-06-23','07:50:00',1.37),('8902','2013-06-23','07:55:00',1.29),('8902','2013-06-23','08:35:00',1.58),('8902','2013-06-23','08:40:00',1.66),('8902','2013-06-23','08:45:00',3.92),('8902','2013-06-23','08:50:00',4.08),('8902','2013-06-23','08:55:00',4.32),('8902','2013-06-23','09:00:00',4.62),('8902','2013-06-23','09:05:00',5.02),('8902','2013-06-23','09:10:00',3.16),('8902','2013-06-23','09:15:00',4.8),('8902','2013-06-23','09:20:00',5.28),('8902','2013-06-23','09:25:00',4.88),('8902','2013-06-23','09:30:00',6.16),('8902','2013-06-23','09:35:00',4.15),('8902','2013-06-23','09:40:00',2.49),('8902','2013-06-23','09:45:00',3.9),('8902','2013-06-23','09:50:00',6.14),('8902','2013-06-23','09:55:00',5.87),('8902','2013-06-23','10:00:00',6.02),('8902','2013-06-23','10:05:00',6.12),('8902','2013-06-23','10:10:00',6.37),('8902','2013-06-23','10:15:00',5.57),('8902','2013-06-23','10:20:00',5.88),('8902','2013-06-23','10:25:00',7.18),('8902','2013-06-23','10:30:00',5.39),('8902','2013-06-23','10:35:00',7.45),('8902','2013-06-23','10:40:00',4.28),('8902','2013-06-23','10:45:00',2.95),('8902','2013-06-23','10:50:00',6.41),('8902','2013-06-23','10:55:00',4.54),('8902','2013-06-23','11:00:00',7.71),('8902','2013-06-23','11:05:00',8.11),('8902','2013-06-23','11:10:00',4.11),('8902','2013-06-23','11:15:00',3.44),('8902','2013-06-23','11:20:00',8.92),('8902','2013-06-23','11:25:00',2.7),('8902','2013-06-23','11:30:00',4.52),('8902','2013-06-23','11:35:00',2.81),('8902','2013-06-23','11:40:00',2.54),('8902','2013-06-23','11:45:00',3.22),('8902','2013-06-23','11:50:00',6.7),('8902','2013-06-23','11:55:00',3.99),('8902','2013-06-23','12:00:00',7.14),('8902','2013-06-23','12:05:00',7.77),('8902','2013-06-23','12:10:00',5.98),('8902','2013-06-23','12:15:00',6.82),('8902','2013-06-23','12:20:00',7.31),('8902','2013-06-23','12:25:00',9.02),('8902','2013-06-23','12:30:00',5.99),('8902','2013-06-23','12:35:00',8.65),('8902','2013-06-23','12:40:00',9),('8902','2013-06-23','12:45:00',4.74),('8902','2013-06-23','12:50:00',7.44),('8902','2013-06-23','12:55:00',9.34),('8902','2013-06-23','13:00:00',6.2),('8902','2013-06-23','13:05:00',8.05),('8902','2013-06-23','13:10:00',8.49),('8902','2013-06-23','13:15:00',6.23),('8902','2013-06-23','13:20:00',4.68),('8902','2013-06-23','13:25:00',7.38),('8902','2013-06-23','13:30:00',9.63),('8902','2013-06-23','13:35:00',7.65),('8902','2013-06-23','13:40:00',7.67),('8902','2013-06-23','13:45:00',8.06),('8902','2013-06-23','13:50:00',8.54),('8902','2013-06-23','13:55:00',8.43),('8902','2013-06-23','14:00:00',8.23),('8902','2013-06-23','14:05:00',8.39),('8902','2013-06-23','14:10:00',8.38),('8902','2013-06-23','14:15:00',8.3),('8902','2013-06-23','14:20:00',8.27),('8902','2013-06-23','14:25:00',8.26),('8902','2013-06-23','14:30:00',8.02),('8902','2013-06-23','14:35:00',8.23),('8902','2013-06-23','14:40:00',8.17),('8902','2013-06-23','14:45:00',8.35),('8902','2013-06-23','14:50:00',6.23),('8902','2013-06-23','14:55:00',7.64),('8902','2013-06-23','15:00:00',6.44),('8902','2013-06-23','15:05:00',5.99),('8902','2013-06-23','15:10:00',7),('8902','2013-06-23','15:15:00',8.73),('8902','2013-06-23','15:20:00',6.64),('8902','2013-06-23','15:25:00',5.84),('8902','2013-06-23','15:30:00',5.72),('8902','2013-06-23','15:35:00',6.83),('8902','2013-06-23','15:40:00',3.46),('8902','2013-06-23','15:45:00',7.8),('8902','2013-06-23','15:50:00',5.89),('8902','2013-06-23','15:55:00',6.75),('8902','2013-06-23','16:00:00',8.04),('8902','2013-06-23','16:05:00',7.21),('8902','2013-06-23','16:10:00',6.73),('8902','2013-06-23','16:15:00',7.45),('8902','2013-06-23','16:20:00',4.39),('8902','2013-06-23','16:25:00',5.08),('8902','2013-06-23','16:30:00',4.34),('8902','2013-06-23','16:35:00',6),('8902','2013-06-23','16:40:00',4.12),('8902','2013-06-23','16:45:00',3.82),('8902','2013-06-23','16:50:00',3.07),('8902','2013-06-23','16:55:00',2.53),('8902','2013-06-23','17:00:00',2.1),('8902','2013-06-23','17:05:00',4.17),('8902','2013-06-23','17:10:00',3.05),('8902','2013-06-23','17:15:00',5.79),('8902','2013-06-23','17:20:00',3.7),('8902','2013-06-23','17:25:00',4.19),('8902','2013-06-23','17:30:00',3.79),('8902','2013-06-23','17:35:00',1.88),('8902','2013-06-23','17:40:00',1.59),('8902','2013-06-23','17:45:00',1.6),('8902','2013-06-23','17:50:00',2.48),('8902','2013-06-23','17:55:00',1.72),('8902','2013-06-23','18:00:00',3.87),('8902','2013-06-23','18:05:00',3.84),('8902','2013-06-23','18:10:00',3.15),('8902','2013-06-23','18:15:00',2.87),('8902','2013-06-23','18:20:00',2.96),('8902','2013-06-23','18:25:00',2.5),('8902','2013-06-23','18:30:00',2.22),('8902','2013-06-23','18:35:00',2.37),('8902','2013-06-23','18:40:00',1.65),('8902','2013-06-23','18:45:00',1.87),('8902','2013-06-23','18:50:00',1.82),('8902','2013-06-23','18:55:00',1.55),('8902','2013-06-23','19:00:00',1.49),('8902','2013-06-23','19:05:00',1.35),('8902','2013-06-23','19:10:00',1.23),('8902','2013-06-23','19:15:00',1.03),('8902','2013-06-22','08:35:00',1.16),('8902','2013-06-22','08:40:00',1.36),('8902','2013-06-22','08:45:00',1.78),('8902','2013-06-22','08:50:00',2.64),('8902','2013-06-22','08:55:00',1.79),('8902','2013-06-22','09:00:00',2.87),('8902','2013-06-22','09:05:00',2.95),('8902','2013-06-22','09:10:00',1.03),('8902','2013-06-22','09:15:00',1.24),('8902','2013-06-22','09:20:00',2.79),('8902','2013-06-22','09:25:00',4.29),('8902','2013-06-22','09:30:00',4.92),('8902','2013-06-22','09:35:00',5.2),('8902','2013-06-22','09:40:00',5.76),('8902','2013-06-22','09:45:00',4.32),('8902','2013-06-22','09:50:00',2.27),('8902','2013-06-22','09:55:00',2.96),('8902','2013-06-22','10:00:00',6.27),('8902','2013-06-22','10:05:00',6.27),('8902','2013-06-22','10:10:00',6.71),('8902','2013-06-22','10:15:00',6.14),('8902','2013-06-22','10:20:00',4.15),('8902','2013-06-22','10:25:00',5.93),('8902','2013-06-22','10:30:00',3.01),('8902','2013-06-22','10:35:00',3.58),('8902','2013-06-22','10:40:00',6.94),('8902','2013-06-22','10:45:00',6.65),('8902','2013-06-22','10:50:00',6.6),('8902','2013-06-22','10:55:00',6.54),('8902','2013-06-22','11:00:00',6.68),('8902','2013-06-22','11:05:00',6.82),('8902','2013-06-22','11:10:00',6.91),('8902','2013-06-22','11:15:00',6.88),('8902','2013-06-22','11:20:00',7.03),('8902','2013-06-22','11:25:00',7.14),('8902','2013-06-22','11:30:00',7.12),('8902','2013-06-22','11:35:00',7.01),('8902','2013-06-22','11:40:00',7.03),('8902','2013-06-22','11:45:00',7.13),('8902','2013-06-22','11:50:00',7.35),('8902','2013-06-22','11:55:00',7.39),('8902','2013-06-22','12:00:00',6.56),('8902','2013-06-22','12:05:00',7.78),('8902','2013-06-22','12:10:00',7.75),('8902','2013-06-22','12:15:00',7.59),('8902','2013-06-22','12:20:00',7.73),('8902','2013-06-22','12:25:00',7.86),('8902','2013-06-22','12:30:00',7.8),('8902','2013-06-22','12:35:00',7.8),('8902','2013-06-22','12:40:00',7.8),('8902','2013-06-22','12:45:00',7.87),('8902','2013-06-22','12:50:00',7.85),('8902','2013-06-22','12:55:00',7.9),('8902','2013-06-22','13:00:00',7.9),('8902','2013-06-22','13:05:00',7.9),('8902','2013-06-22','13:10:00',7.93),('8902','2013-06-22','13:15:00',7.97),('8902','2013-06-22','13:20:00',7.95),('8902','2013-06-22','13:25:00',7.97),('8902','2013-06-22','13:30:00',7.95),('8902','2013-06-22','13:35:00',7.99),('8902','2013-06-22','13:40:00',8.01),('8902','2013-06-22','13:45:00',8.01),('8902','2013-06-22','13:50:00',7.99),('8902','2013-06-22','13:55:00',8.01),('8902','2013-06-22','14:00:00',8),('8902','2013-06-22','14:05:00',7.92),('8902','2013-06-22','14:10:00',7.94),('8902','2013-06-22','14:15:00',7.95),('8902','2013-06-22','14:20:00',7.91),('8902','2013-06-22','14:25:00',7.89),('8902','2013-06-22','14:30:00',7.91),('8902','2013-06-22','14:35:00',7.83),('8902','2013-06-22','14:40:00',7.85),('8902','2013-06-22','14:45:00',7.78),('8902','2013-06-22','14:50:00',7.73),('8902','2013-06-22','14:55:00',7.67),('8902','2013-06-22','15:00:00',7.67),('8902','2013-06-22','15:05:00',7.59),('8902','2013-06-22','15:10:00',7.5),('8902','2013-06-22','15:15:00',7.43),('8902','2013-06-22','15:20:00',7.32),('8902','2013-06-22','15:25:00',7.34),('8902','2013-06-22','15:30:00',7.24),('8902','2013-06-22','15:35:00',7.18),('8902','2013-06-22','15:40:00',7.08),('8902','2013-06-22','15:45:00',7),('8902','2013-06-22','15:50:00',6.9),('8902','2013-06-22','15:55:00',6.82),('8902','2013-06-22','16:00:00',6.71),('8902','2013-06-22','16:05:00',6.58),('8902','2013-06-22','16:10:00',6.48),('8902','2013-06-22','16:15:00',6.35),('8902','2013-06-22','16:20:00',6.28),('8902','2013-06-22','16:25:00',6.17),('8902','2013-06-22','16:30:00',6.08),('8902','2013-06-22','16:35:00',5.93),('8902','2013-06-22','16:40:00',5.73),('8902','2013-06-22','16:45:00',5.7),('8902','2013-06-22','16:50:00',5.58),('8902','2013-06-22','16:55:00',5.29),('8902','2013-06-22','17:00:00',5.27),('8902','2013-06-22','17:05:00',5.17),('8902','2013-06-22','17:10:00',5.02),('8902','2013-06-22','17:15:00',4.92),('8902','2013-06-22','17:20:00',4.69),('8902','2013-06-22','17:25:00',4.6),('8902','2013-06-22','17:30:00',4.44),('8902','2013-06-22','17:35:00',4.31),('8902','2013-06-22','17:40:00',4.09),('8902','2013-06-22','17:45:00',4.04),('8902','2013-06-22','17:50:00',3.86),('8902','2013-06-22','17:55:00',3.61),('8902','2013-06-22','18:00:00',3.4),('8902','2013-06-22','18:05:00',3.32),('8902','2013-06-22','18:10:00',3.13),('8902','2013-06-22','18:15:00',2.92),('8902','2013-06-22','18:20:00',2.79),('8902','2013-06-22','18:25:00',2.56),('8902','2013-06-22','18:30:00',2.42),('8902','2013-06-22','18:35:00',2.18),('8902','2013-06-22','18:40:00',1.76),('8902','2013-06-22','18:45:00',1.89),('8902','2013-06-22','18:50:00',1.78),('8902','2013-06-22','18:55:00',1.58),('8902','2013-06-22','19:00:00',1.4),('8902','2013-06-22','19:05:00',1.1),('8902','2013-06-22','19:10:00',1.11),('8902','2013-06-21','07:25:00',1.11),('8902','2013-06-21','07:30:00',1.23),('8902','2013-06-21','07:35:00',1.36),('8902','2013-06-21','07:40:00',1.49),('8902','2013-06-21','07:45:00',1.61),('8902','2013-06-21','07:50:00',1.76),('8902','2013-06-21','07:55:00',1.91),('8902','2013-06-21','08:00:00',2.06),('8902','2013-06-21','08:05:00',2.19),('8902','2013-06-21','08:10:00',2.32),('8902','2013-06-21','08:15:00',2.45),('8902','2013-06-21','08:20:00',2.63),('8902','2013-06-21','08:25:00',2.78),('8902','2013-06-21','08:30:00',2.97),('8902','2013-06-21','08:35:00',3.11),('8902','2013-06-21','08:40:00',3.27),('8902','2013-06-21','08:45:00',3.46),('8902','2013-06-21','08:50:00',3.61),('8902','2013-06-21','08:55:00',3.73),('8902','2013-06-21','09:00:00',3.85),('8902','2013-06-21','09:05:00',3.95),('8902','2013-06-21','09:10:00',4.08),('8902','2013-06-21','09:15:00',4.21),('8902','2013-06-21','09:20:00',4.35),('8902','2013-06-21','09:25:00',4.46),('8902','2013-06-21','09:30:00',4.57),('8902','2013-06-21','09:35:00',4.73),('8902','2013-06-21','09:40:00',4.87),('8902','2013-06-21','09:45:00',4.98),('8902','2013-06-21','09:50:00',5.08),('8902','2013-06-21','09:55:00',5.21),('8902','2013-06-21','10:00:00',5.27),('8902','2013-06-21','10:05:00',5.46),('8902','2013-06-21','10:10:00',5.59),('8902','2013-06-21','10:15:00',5.67),('8902','2013-06-21','10:20:00',5.79),('8902','2013-06-21','10:25:00',5.93),('8902','2013-06-21','10:30:00',5.95),('8902','2013-06-21','10:35:00',6.04),('8902','2013-06-21','10:40:00',6.15),('8902','2013-06-21','10:45:00',6.27),('8902','2013-06-21','10:50:00',6.36),('8902','2013-06-21','10:55:00',6.48),('8902','2013-06-21','11:00:00',6.54),('8902','2013-06-21','11:05:00',6.62),('8902','2013-06-21','11:10:00',6.68),('8902','2013-06-21','11:15:00',6.75),('8902','2013-06-21','11:20:00',6.82),('8902','2013-06-21','11:25:00',6.88),('8902','2013-06-21','11:30:00',6.9),('8902','2013-06-21','11:35:00',7),('8902','2013-06-21','11:40:00',7.09),('8902','2013-06-21','11:45:00',7.13),('8902','2013-06-21','11:50:00',7.19),('8902','2013-06-21','11:55:00',7.23),('8902','2013-06-21','12:00:00',7.27),('8902','2013-06-21','12:05:00',7.2),('8902','2013-06-21','12:10:00',7.06),('8902','2013-06-21','12:15:00',7.37),('8902','2013-06-21','12:20:00',7.4),('8902','2013-06-21','12:25:00',7.3),('8902','2013-06-21','12:30:00',7.46),('8902','2013-06-21','12:35:00',7.52),('8902','2013-06-21','12:40:00',7.59),('8902','2013-06-21','12:45:00',7.51),('8902','2013-06-21','12:50:00',7.41),('8902','2013-06-21','12:55:00',7.38),('8902','2013-06-21','13:00:00',7.33),('8902','2013-06-21','13:05:00',7.35),('8902','2013-06-21','13:10:00',7.22),('8902','2013-06-21','13:15:00',7.13),('8902','2013-06-21','13:20:00',6.97),('8902','2013-06-21','13:25:00',7.07),('8902','2013-06-21','13:30:00',7.84),('8902','2013-06-21','13:35:00',7.98),('8902','2013-06-21','13:40:00',7.43),('8902','2013-06-21','13:45:00',7.35),('8902','2013-06-21','13:50:00',7.84),('8902','2013-06-21','13:55:00',6.72),('8902','2013-06-21','14:00:00',4.18),('8902','2013-06-21','14:05:00',8.57),('8902','2013-06-21','14:10:00',8.13),('8902','2013-06-21','14:15:00',8.05),('8902','2013-06-21','14:20:00',6.65),('8902','2013-06-21','14:25:00',7.99),('8902','2013-06-21','14:30:00',6.16),('8902','2013-06-21','14:35:00',4.35),('8902','2013-06-21','14:40:00',3.34),('8902','2013-06-21','14:45:00',3.57),('8902','2013-06-21','14:50:00',6.61),('8902','2013-06-21','14:55:00',6.94),('8902','2013-06-21','15:00:00',7.19),('8902','2013-06-21','15:05:00',6.34),('8902','2013-06-21','15:10:00',6.88),('8902','2013-06-21','15:15:00',7.68),('8902','2013-06-21','15:20:00',7.1),('8902','2013-06-21','15:25:00',6.58),('8902','2013-06-21','15:30:00',4.36),('8902','2013-06-21','15:35:00',3.92),('8902','2013-06-21','15:40:00',3.42),('8902','2013-06-21','15:45:00',4.69),('8902','2013-06-21','15:50:00',4.93),('8902','2013-06-21','15:55:00',4.58),('8902','2013-06-21','16:00:00',3.9),('8902','2013-06-21','16:05:00',2.4),('8902','2013-06-21','16:10:00',2.27),('8902','2013-06-21','16:15:00',2.92),('8902','2013-06-21','16:20:00',3.62),('8902','2013-06-21','16:25:00',2.52),('8902','2013-06-21','16:30:00',1.9),('8902','2013-06-21','16:35:00',1.6),('8902','2013-06-21','16:40:00',1.45),('8902','2013-06-21','16:45:00',1.39),('8902','2013-06-21','16:50:00',1.51),('8902','2013-06-21','16:55:00',2.07),('8902','2013-06-21','17:00:00',2.77),('8902','2013-06-21','17:05:00',2.63),('8902','2013-06-21','17:10:00',3.52),('8902','2013-06-21','17:15:00',5.39),('8902','2013-06-21','17:20:00',5.19),('8902','2013-06-21','17:25:00',5.17),('8902','2013-06-21','17:30:00',4.08),('8902','2013-06-21','17:35:00',3.72),('8902','2013-06-21','17:40:00',4.1),('8902','2013-06-21','17:45:00',4.03),('8902','2013-06-21','17:50:00',3.75),('8902','2013-06-21','17:55:00',3.57),('8902','2013-06-21','18:00:00',3.27),('8902','2013-06-21','18:05:00',2.73),('8902','2013-06-21','18:10:00',1.9),('8902','2013-06-21','18:15:00',1.77),('8902','2013-06-21','18:20:00',1.83),('8902','2013-06-21','18:25:00',1.16),('8902','2013-06-21','18:35:00',1.01),('8902','2013-06-21','18:40:00',1.06),('8902','2013-06-20','07:20:00',1.01),('8902','2013-06-20','07:25:00',1.12),('8902','2013-06-20','07:30:00',1.24),('8902','2013-06-20','07:35:00',1.37),('8902','2013-06-20','07:40:00',1.5),('8902','2013-06-20','07:45:00',1.63),('8902','2013-06-20','07:50:00',1.78),('8902','2013-06-20','07:55:00',1.93),('8902','2013-06-20','08:00:00',2.07),('8902','2013-06-20','08:05:00',2.21),('8902','2013-06-20','08:10:00',2.35),('8902','2013-06-20','08:15:00',2.49),('8902','2013-06-20','08:20:00',2.63),('8902','2013-06-20','08:25:00',2.77),('8902','2013-06-20','08:30:00',2.92),('8902','2013-06-20','08:35:00',3.07),('8902','2013-06-20','08:40:00',3.21),('8902','2013-06-20','08:45:00',3.35),('8902','2013-06-20','08:50:00',3.5),('8902','2013-06-20','08:55:00',3.61),('8902','2013-06-20','09:00:00',3.73),('8902','2013-06-20','09:05:00',3.86),('8902','2013-06-20','09:10:00',3.98),('8902','2013-06-20','09:15:00',4.09),('8902','2013-06-20','09:20:00',4.23),('8902','2013-06-20','09:25:00',4.3),('8902','2013-06-20','09:30:00',4.42),('8902','2013-06-20','09:35:00',4.55),('8902','2013-06-20','09:40:00',4.65),('8902','2013-06-20','09:45:00',4.76),('8902','2013-06-20','09:50:00',4.83),('8902','2013-06-20','09:55:00',4.94),('8902','2013-06-20','10:00:00',5.1),('8902','2013-06-20','10:05:00',5.21),('8902','2013-06-20','10:10:00',5.29),('8902','2013-06-20','10:15:00',5.3),('8902','2013-06-20','10:20:00',5.38),('8902','2013-06-20','10:25:00',5.47),('8902','2013-06-20','10:30:00',5.64),('8902','2013-06-20','10:35:00',5.72),('8902','2013-06-20','10:40:00',5.79),('8902','2013-06-20','10:45:00',5.88),('8902','2013-06-20','10:50:00',5.98),('8902','2013-06-20','10:55:00',6.05),('8902','2013-06-20','11:00:00',6.15),('8902','2013-06-20','11:05:00',6.2),('8902','2013-06-20','11:10:00',6.19),('8902','2013-06-20','11:15:00',6.29),('8902','2013-06-20','11:20:00',6.46),('8902','2013-06-20','11:25:00',6.58),('8902','2013-06-20','11:30:00',6.67),('8902','2013-06-20','11:35:00',6.65),('8902','2013-06-20','11:40:00',6.66),('8902','2013-06-20','11:45:00',6.72),('8902','2013-06-20','11:50:00',6.89),('8902','2013-06-20','11:55:00',6.92),('8902','2013-06-20','12:00:00',6.86),('8902','2013-06-20','12:05:00',6.98),('8902','2013-06-20','12:10:00',6.99),('8902','2013-06-20','12:15:00',6.97),('8902','2013-06-20','12:20:00',6.96),('8902','2013-06-20','12:25:00',6.97),('8902','2013-06-20','12:30:00',7.1),('8902','2013-06-20','12:35:00',7.1),('8902','2013-06-20','12:40:00',7.13),('8902','2013-06-20','12:45:00',7.07),('8902','2013-06-20','12:50:00',7.05),('8902','2013-06-20','12:55:00',7.01),('8902','2013-06-20','13:00:00',7.05),('8902','2013-06-20','13:05:00',7.13),('8902','2013-06-20','13:10:00',7.07),('8902','2013-06-20','13:15:00',7.17),('8902','2013-06-20','13:20:00',7.23),('8902','2013-06-20','13:25:00',7.18),('8902','2013-06-20','13:30:00',7.28),('8902','2013-06-20','13:35:00',7.43),('8902','2013-06-20','13:40:00',7.34),('8902','2013-06-20','13:45:00',7.36),('8902','2013-06-20','13:50:00',7.39),('8902','2013-06-20','13:55:00',7.32),('8902','2013-06-20','14:00:00',7.36),('8902','2013-06-20','14:05:00',7.37),('8902','2013-06-20','14:10:00',7.38),('8902','2013-06-20','14:15:00',7.3),('8902','2013-06-20','14:20:00',7.29),('8902','2013-06-20','14:25:00',7.31),('8902','2013-06-20','14:30:00',7.29),('8902','2013-06-20','14:35:00',7.31),('8902','2013-06-20','14:40:00',7.22),('8902','2013-06-20','14:45:00',7.19),('8902','2013-06-20','14:50:00',7.14),('8902','2013-06-20','14:55:00',7.14),('8902','2013-06-20','15:00:00',7.1),('8902','2013-06-20','15:05:00',7.06),('8902','2013-06-20','15:10:00',6.95),('8902','2013-06-20','15:15:00',6.91),('8902','2013-06-20','15:20:00',6.88),('8902','2013-06-20','15:25:00',6.81),('8902','2013-06-20','15:30:00',6.74),('8902','2013-06-20','15:35:00',6.71),('8902','2013-06-20','15:40:00',6.65),('8902','2013-06-20','15:45:00',6.57),('8902','2013-06-20','15:50:00',6.47),('8902','2013-06-20','15:55:00',6.38),('8902','2013-06-20','16:00:00',6.34),('8902','2013-06-20','16:05:00',6.25),('8902','2013-06-20','16:10:00',6.15),('8902','2013-06-20','16:15:00',6.04),('8902','2013-06-20','16:20:00',5.95),('8902','2013-06-20','16:25:00',5.84),('8902','2013-06-20','16:30:00',5.75),('8902','2013-06-20','16:35:00',5.62),('8902','2013-06-20','16:40:00',5.42),('8902','2013-06-20','16:45:00',5.38),('8902','2013-06-20','16:50:00',5.25),('8902','2013-06-20','16:55:00',5.01),('8902','2013-06-20','17:00:00',4.99),('8902','2013-06-20','17:05:00',4.87),('8902','2013-06-20','17:10:00',4.75),('8902','2013-06-20','17:15:00',4.64),('8902','2013-06-20','17:20:00',4.48),('8902','2013-06-20','17:25:00',4.26),('8902','2013-06-20','17:30:00',4.18),('8902','2013-06-20','17:35:00',4.04),('8902','2013-06-20','17:40:00',3.86),('8902','2013-06-20','17:45:00',3.74),('8902','2013-06-20','17:50:00',3.56),('8902','2013-06-20','17:55:00',3.33),('8902','2013-06-20','18:00:00',3.17),('8902','2013-06-20','18:05:00',3.08),('8902','2013-06-20','18:10:00',2.9),('8902','2013-06-20','18:15:00',2.76),('8902','2013-06-20','18:20:00',2.55),('8902','2013-06-20','18:25:00',2.39),('8902','2013-06-20','18:30:00',2.24),('8902','2013-06-20','18:35:00',2.04),('8902','2013-06-20','18:40:00',1.86),('8902','2013-06-20','18:45:00',1.71),('8902','2013-06-20','18:50:00',1.57),('8902','2013-06-20','18:55:00',1.39),('8902','2013-06-20','19:00:00',1.27),('8902','2013-06-20','19:05:00',1.11),('8902','2014-04-03','08:35:00',1.03),('8902','2014-04-03','08:40:00',1.39),('8902','2014-04-03','08:45:00',1.43),('8902','2014-04-03','08:50:00',1.54),('8902','2014-04-03','08:55:00',1.54),('8902','2014-04-03','09:00:00',1.54),('8902','2014-04-03','09:05:00',2.14),('8902','2014-04-03','09:10:00',2.87),('8902','2014-04-03','09:15:00',2.62),('8902','2014-04-03','09:20:00',2.01),('8902','2014-04-03','09:25:00',1.74),('8902','2014-04-03','09:30:00',1.66),('8902','2014-04-03','09:35:00',1.7),('8902','2014-04-03','09:40:00',1.63),('8902','2014-04-03','09:45:00',1.65),('8902','2014-04-03','09:50:00',1.5),('8902','2014-04-03','09:55:00',1.04),('8902','2014-04-03','11:15:00',1.03),('8902','2014-04-03','11:20:00',1.13),('8902','2014-04-03','12:45:00',1.04),('8902','2014-04-03','12:50:00',1.26),('8902','2014-04-03','12:55:00',1.28),('8902','2014-04-03','13:00:00',1.44),('8902','2014-04-03','13:05:00',1.16),('8902','2014-04-03','13:10:00',1.31),('8902','2014-04-03','13:15:00',1.41),('8902','2014-04-03','13:20:00',2.87),('8902','2014-04-03','13:25:00',5.82),('8902','2014-04-03','13:30:00',4.49),('8902','2014-04-03','13:35:00',6.65),('8902','2014-04-03','13:40:00',7.91),('8902','2014-04-03','13:45:00',7.02),('8902','2014-04-03','13:50:00',6.76),('8902','2014-04-03','13:55:00',5.12),('8902','2014-04-03','14:00:00',4.03),('8902','2014-04-03','14:05:00',8.14),('8902','2014-04-03','14:10:00',4.58),('8902','2014-04-03','14:15:00',8.46),('8902','2014-04-03','14:20:00',6.05),('8902','2014-04-03','14:25:00',6.38),('8902','2014-04-03','14:30:00',3.07),('8902','2014-04-03','14:35:00',6.46),('8902','2014-04-03','14:40:00',3.53),('8902','2014-04-03','14:45:00',6.94),('8902','2014-04-03','14:50:00',6.88),('8902','2014-04-03','14:55:00',6.88),('8902','2014-04-03','15:00:00',8.12),('8902','2014-04-03','15:05:00',8.07),('8902','2014-04-03','15:10:00',8.13),('8902','2014-04-03','15:15:00',6.82),('8902','2014-04-03','15:20:00',4.37),('8902','2014-04-03','15:25:00',3.76),('8902','2014-04-03','15:30:00',3.59),('8902','2014-04-03','15:35:00',3.54),('8902','2014-04-03','15:40:00',5.28),('8902','2014-04-03','15:45:00',4.45),('8902','2014-04-03','15:50:00',3.88),('8902','2014-04-03','15:55:00',5.89),('8902','2014-04-03','16:00:00',5.54),('8902','2014-04-03','16:05:00',3.12),('8902','2014-04-03','16:10:00',3.59),('8902','2014-04-03','16:15:00',3.23),('8902','2014-04-03','16:20:00',2.02),('8902','2014-04-03','16:25:00',1.82),('8902','2014-04-03','16:30:00',4.45),('8902','2014-04-03','16:35:00',3.52),('8902','2014-04-03','16:40:00',2.63),('8902','2014-04-03','16:45:00',5.68),('8902','2014-04-03','16:50:00',6.34),('8902','2014-04-03','16:55:00',4.37),('8902','2014-04-03','17:00:00',3.81),('8902','2014-04-03','17:05:00',4.24),('8902','2014-04-03','17:10:00',4.37),('8902','2014-04-03','17:15:00',4.71),('8902','2014-04-03','17:20:00',4.24),('8902','2014-04-03','17:25:00',3.59),('8902','2014-04-03','17:30:00',4.23),('8902','2014-04-03','17:35:00',2.74),('8902','2014-04-03','17:40:00',3.13),('8902','2014-04-03','17:45:00',3.4),('8902','2014-04-03','17:50:00',3.05),('8902','2014-04-03','17:55:00',2.91),('8902','2014-04-03','18:00:00',2.58),('8902','2014-04-03','18:05:00',2.36),('8902','2014-04-03','18:10:00',2.14),('8902','2014-04-03','18:15:00',1.89),('8902','2014-04-03','18:20:00',1.66),('8902','2014-04-03','18:25:00',1.45),('8902','2014-04-03','18:30:00',1.25),('8902','2014-04-03','18:35:00',1.17),('8902','2013-06-19','07:25:00',1.03),('8902','2013-06-19','07:30:00',1.14),('8902','2013-06-19','07:35:00',1.19),('8902','2013-06-19','07:40:00',1.3),('8902','2013-06-19','07:45:00',1.46),('8902','2013-06-19','07:50:00',1.67),('8902','2013-06-19','07:55:00',1.82),('8902','2013-06-19','08:00:00',2.02),('8902','2013-06-19','08:05:00',2.17),('8902','2013-06-19','08:10:00',2.34),('8902','2013-06-19','08:15:00',2.49),('8902','2013-06-19','08:20:00',2.65),('8902','2013-06-19','08:25:00',2.8),('8902','2013-06-19','08:30:00',2.95),('8902','2013-06-19','08:35:00',3.09),('8902','2013-06-19','08:40:00',3.25),('8902','2013-06-19','08:45:00',3.39),('8902','2013-06-19','08:50:00',3.54),('8902','2013-06-19','08:55:00',3.67),('8902','2013-06-19','09:00:00',3.8),('8902','2013-06-19','09:05:00',3.94),('8902','2013-06-19','09:10:00',4.08),('8902','2013-06-19','09:15:00',4.18),('8902','2013-06-19','09:20:00',4.33),('8902','2013-06-19','09:25:00',4.44),('8902','2013-06-19','09:30:00',4.55),('8902','2013-06-19','09:35:00',4.65),('8902','2013-06-19','09:40:00',4.81),('8902','2013-06-19','09:45:00',4.9),('8902','2013-06-19','09:50:00',5.04),('8902','2013-06-19','09:55:00',5.14),('8902','2013-06-19','10:00:00',5.25),('8902','2013-06-19','10:05:00',5.35),('8902','2013-06-19','10:10:00',5.44),('8902','2013-06-19','10:15:00',5.56),('8902','2013-06-19','10:20:00',5.67),('8902','2013-06-19','10:25:00',5.78),('8902','2013-06-19','10:30:00',5.88),('8902','2013-06-19','10:35:00',5.95),('8902','2013-06-19','10:40:00',6.04),('8902','2013-06-19','10:45:00',6.07),('8902','2013-06-19','10:50:00',6.11),('8902','2013-06-19','10:55:00',6.17),('8902','2013-06-19','11:00:00',6.34),('8902','2013-06-19','11:05:00',6.35),('8902','2013-06-19','11:10:00',6.46),('8902','2013-06-19','11:15:00',6.52),('8902','2013-06-19','11:20:00',6.38),('8902','2013-06-19','11:25:00',6.38),('8902','2013-06-19','11:30:00',6.57),('8902','2013-06-19','11:35:00',6.7),('8902','2013-06-19','11:40:00',6.79),('8902','2013-06-19','11:45:00',6.87),('8902','2013-06-19','11:50:00',6.93),('8902','2013-06-19','11:55:00',6.82),('8902','2013-06-19','12:00:00',6.81),('8902','2013-06-19','12:05:00',6.82),('8902','2013-06-19','12:10:00',6.84),('8902','2013-06-19','12:15:00',6.68),('8902','2013-06-19','12:20:00',6.63),('8902','2013-06-19','12:25:00',6.83),('8902','2013-06-19','12:30:00',6.85),('8902','2013-06-19','12:35:00',7.3),('8902','2013-06-19','12:40:00',5.36),('8902','2013-06-19','12:45:00',5.92),('8902','2013-06-19','12:50:00',7.22),('8902','2013-06-19','12:55:00',4.53),('8902','2013-06-19','13:00:00',5.99),('8902','2013-06-19','13:05:00',7.19),('8902','2013-06-19','13:10:00',7.53),('8902','2013-06-19','13:15:00',7.46),('8902','2013-06-19','13:20:00',7.33),('8902','2013-06-19','13:25:00',5.84),('8902','2013-06-19','13:30:00',6.92),('8902','2013-06-19','13:35:00',7.28),('8902','2013-06-19','13:40:00',7.34),('8902','2013-06-19','13:45:00',7.37),('8902','2013-06-19','13:50:00',7.44),('8902','2013-06-19','13:55:00',7.31),('8902','2013-06-19','14:00:00',7.37),('8902','2013-06-19','14:05:00',7.54),('8902','2013-06-19','14:10:00',7.49),('8902','2013-06-19','14:15:00',7.48),('8902','2013-06-19','14:20:00',7.51),('8902','2013-06-19','14:25:00',7.45),('8902','2013-06-19','14:30:00',7.42),('8902','2013-06-19','14:35:00',7.48),('8902','2013-06-19','14:40:00',7.48),('8902','2013-06-19','14:45:00',7.45),('8902','2013-06-19','14:50:00',7.47),('8902','2013-06-19','14:55:00',7.44),('8902','2013-06-19','15:00:00',7.38),('8902','2013-06-19','15:05:00',7.27),('8902','2013-06-19','15:10:00',7.2),('8902','2013-06-19','15:15:00',7.16),('8902','2013-06-19','15:20:00',7.07),('8902','2013-06-19','15:25:00',6.95),('8902','2013-06-19','15:30:00',6.88),('8902','2013-06-19','15:35:00',6.8),('8902','2013-06-19','15:40:00',6.78),('8902','2013-06-19','15:45:00',6.69),('8902','2013-06-19','15:50:00',6.57),('8902','2013-06-19','15:55:00',6.5),('8902','2013-06-19','16:00:00',6.4),('8902','2013-06-19','16:05:00',6.32),('8902','2013-06-19','16:10:00',6.26),('8902','2013-06-19','16:15:00',6.17),('8902','2013-06-19','16:20:00',6.06),('8902','2013-06-19','16:25:00',5.93),('8902','2013-06-19','16:30:00',5.86),('8902','2013-06-19','16:35:00',5.69),('8902','2013-06-19','16:40:00',5.47),('8902','2013-06-19','16:45:00',5.44),('8902','2013-06-19','16:50:00',5.3),('8902','2013-06-19','16:55:00',5.08),('8902','2013-06-19','17:00:00',5.02),('8902','2013-06-19','17:05:00',4.87),('8902','2013-06-19','17:10:00',4.76),('8902','2013-06-19','17:15:00',4.63),('8902','2013-06-19','17:20:00',4.51),('8902','2013-06-19','17:25:00',4.3),('8902','2013-06-19','17:30:00',4.2),('8902','2013-06-19','17:35:00',4.07),('8902','2013-06-19','17:40:00',3.9),('8902','2013-06-19','17:45:00',3.78),('8902','2013-06-19','17:50:00',3.64),('8902','2013-06-19','17:55:00',3.38),('8902','2013-06-19','18:00:00',3.25),('8902','2013-06-19','18:05:00',3.16),('8902','2013-06-19','18:10:00',2.95),('8902','2013-06-19','18:15:00',2.83),('8902','2013-06-19','18:20:00',2.64),('8902','2013-06-19','18:25:00',2.42),('8902','2013-06-19','18:30:00',2.3),('8902','2013-06-19','18:35:00',2.09),('8902','2013-06-19','18:40:00',1.92),('8902','2013-06-19','18:45:00',1.75),('8902','2013-06-19','18:50:00',1.59),('8902','2013-06-19','18:55:00',1.4),('8902','2013-06-19','19:00:00',1.27),('8902','2013-06-19','19:05:00',1.09),('8902','2013-06-18','07:25:00',1.08),('8902','2013-06-18','07:30:00',1.2),('8902','2013-06-18','07:35:00',1.31),('8902','2013-06-18','07:40:00',1.44),('8902','2013-06-18','07:45:00',1.57),('8902','2013-06-18','07:50:00',1.7),('8902','2013-06-18','07:55:00',1.85),('8902','2013-06-18','08:00:00',2.01),('8902','2013-06-18','08:05:00',2.17),('8902','2013-06-18','08:10:00',2.32),('8902','2013-06-18','08:15:00',2.44),('8902','2013-06-18','08:20:00',2.59),('8902','2013-06-18','08:25:00',2.72),('8902','2013-06-18','08:30:00',2.86),('8902','2013-06-18','08:35:00',3.01),('8902','2013-06-18','08:40:00',3.16),('8902','2013-06-18','08:45:00',3.31),('8902','2013-06-18','08:50:00',3.46),('8902','2013-06-18','08:55:00',3.59),('8902','2013-06-18','09:00:00',3.73),('8902','2013-06-18','09:05:00',3.87),('8902','2013-06-18','09:10:00',4.01),('8902','2013-06-18','09:15:00',4.15),('8902','2013-06-18','09:20:00',4.26),('8902','2013-06-18','09:25:00',4.38),('8902','2013-06-18','09:30:00',4.5),('8902','2013-06-18','09:35:00',4.61),('8902','2013-06-18','09:40:00',4.72),('8902','2013-06-18','09:45:00',4.82),('8902','2013-06-18','09:50:00',4.95),('8902','2013-06-18','09:55:00',5.08),('8902','2013-06-18','10:00:00',5.18),('8902','2013-06-18','10:05:00',5.23),('8902','2013-06-18','10:10:00',5.34),('8902','2013-06-18','10:15:00',5.44),('8902','2013-06-18','10:20:00',5.48),('8902','2013-06-18','10:25:00',5.55),('8902','2013-06-18','10:30:00',5.68),('8902','2013-06-18','10:35:00',5.74),('8902','2013-06-18','10:40:00',5.8),('8902','2013-06-18','10:45:00',5.93),('8902','2013-06-18','10:50:00',6.01),('8902','2013-06-18','10:55:00',6.06),('8902','2013-06-18','11:00:00',6.14),('8902','2013-06-18','11:05:00',6.16),('8902','2013-06-18','11:10:00',6.22),('8902','2013-06-18','11:15:00',6.32),('8902','2013-06-18','11:20:00',6.35),('8902','2013-06-18','11:25:00',6.43),('8902','2013-06-18','11:30:00',6.52),('8902','2013-06-18','11:35:00',6.53),('8902','2013-06-18','11:40:00',6.52),('8902','2013-06-18','11:45:00',6.48),('8902','2013-06-18','11:50:00',6.65),('8902','2013-06-18','11:55:00',6.63),('8902','2013-06-18','12:00:00',6.75),('8902','2013-06-18','12:05:00',6.72),('8902','2013-06-18','12:10:00',6.82),('8902','2013-06-18','12:15:00',6.78),('8902','2013-06-18','12:20:00',6.71),('8902','2013-06-18','12:25:00',6.67),('8902','2013-06-18','12:30:00',6.61),('8902','2013-06-18','12:35:00',7.1),('8902','2013-06-18','12:40:00',7.19),('8902','2013-06-18','12:45:00',7.21),('8902','2013-06-18','12:50:00',7.12),('8902','2013-06-18','12:55:00',7.22),('8902','2013-06-18','13:00:00',7.2),('8902','2013-06-18','13:05:00',7.22),('8902','2013-06-18','13:10:00',7.18),('8902','2013-06-18','13:15:00',7.26),('8902','2013-06-18','13:20:00',7.23),('8902','2013-06-18','13:25:00',7.31),('8902','2013-06-18','13:30:00',7.38),('8902','2013-06-18','13:35:00',7.29),('8902','2013-06-18','13:40:00',7.34),('8902','2013-06-18','13:45:00',7.36),('8902','2013-06-18','13:50:00',7.32),('8902','2013-06-18','13:55:00',7.42),('8902','2013-06-18','14:00:00',7.41),('8902','2013-06-18','14:05:00',7.43),('8902','2013-06-18','14:10:00',7.35),('8902','2013-06-18','14:15:00',7.3),('8902','2013-06-18','14:20:00',7.28),('8902','2013-06-18','14:25:00',7.3),('8902','2013-06-18','14:30:00',7.22),('8902','2013-06-18','14:35:00',7.2),('8902','2013-06-18','14:40:00',7.09),('8902','2013-06-18','14:45:00',7.04),('8902','2013-06-18','14:50:00',6.99),('8902','2013-06-18','14:55:00',6.95),('8902','2013-06-18','15:00:00',6.95),('8902','2013-06-18','15:05:00',6.91),('8902','2013-06-18','15:10:00',6.82),('8902','2013-06-18','15:15:00',6.75),('8902','2013-06-18','15:20:00',6.69),('8902','2013-06-18','15:25:00',6.64),('8902','2013-06-18','15:30:00',6.58),('8902','2013-06-18','15:35:00',6.48),('8902','2013-06-18','15:40:00',6.42),('8902','2013-06-18','15:45:00',6.32),('8902','2013-06-18','15:50:00',6.23),('8902','2013-06-18','15:55:00',6.12),('8902','2013-06-18','16:00:00',6.03),('8902','2013-06-18','16:05:00',5.95),('8902','2013-06-18','16:10:00',5.86),('8902','2013-06-18','16:15:00',5.78),('8902','2013-06-18','16:20:00',5.67),('8902','2013-06-18','16:25:00',5.57),('8902','2013-06-18','16:30:00',5.47),('8902','2013-06-18','16:35:00',5.35),('8902','2013-06-18','16:40:00',5.14),('8902','2013-06-18','16:45:00',5.13),('8902','2013-06-18','16:50:00',4.98),('8902','2013-06-18','16:55:00',4.81),('8902','2013-06-18','17:00:00',4.78),('8902','2013-06-18','17:05:00',4.64),('8902','2013-06-18','17:10:00',4.55),('8902','2013-06-18','17:15:00',4.44),('8902','2013-06-18','17:20:00',4.38),('8902','2013-06-18','17:25:00',4.18),('8902','2013-06-18','17:30:00',4.09),('8902','2013-06-18','17:35:00',3.94),('8902','2013-06-18','17:40:00',3.79),('8902','2013-06-18','17:45:00',3.65),('8902','2013-06-18','17:50:00',3.48),('8902','2013-06-18','17:55:00',3.24),('8902','2013-06-18','18:00:00',3.12),('8902','2013-06-18','18:05:00',3),('8902','2013-06-18','18:10:00',2.77),('8902','2013-06-18','18:15:00',2.63),('8902','2013-06-18','18:20:00',2.46),('8902','2013-06-18','18:25:00',2.31),('8902','2013-06-18','18:30:00',2.13),('8902','2013-06-18','18:35:00',1.85),('8902','2013-06-18','18:40:00',1.65),('8902','2013-06-18','18:45:00',1.5),('8902','2013-06-18','18:50:00',1.41),('8902','2013-06-18','18:55:00',1.28),('8902','2013-06-18','19:00:00',1.2),('8902','2013-06-18','19:05:00',1.05),('8902','2013-06-17','07:25:00',1.07),('8902','2013-06-17','07:30:00',1.2),('8902','2013-06-17','07:35:00',1.33),('8902','2013-06-17','07:40:00',1.45),('8902','2013-06-17','07:45:00',1.58),('8902','2013-06-17','07:50:00',1.71),('8902','2013-06-17','07:55:00',1.85),('8902','2013-06-17','08:00:00',1.98),('8902','2013-06-17','08:05:00',2.13),('8902','2013-06-17','08:10:00',2.28),('8902','2013-06-17','08:15:00',2.41),('8902','2013-06-17','08:20:00',2.57),('8902','2013-06-17','08:25:00',2.72),('8902','2013-06-17','08:30:00',2.86),('8902','2013-06-17','08:35:00',3),('8902','2013-06-17','08:40:00',3.14),('8902','2013-06-17','08:45:00',3.27),('8902','2013-06-17','08:50:00',3.4),('8902','2013-06-17','08:55:00',3.53),('8902','2013-06-17','09:00:00',3.67),('8902','2013-06-17','09:05:00',3.81),('8902','2013-06-17','09:10:00',3.93),('8902','2013-06-17','09:15:00',4.04),('8902','2013-06-17','09:20:00',4.18),('8902','2013-06-17','09:25:00',4.33),('8902','2013-06-17','09:30:00',4.42),('8902','2013-06-17','09:35:00',4.57),('8902','2013-06-17','09:40:00',4.69),('8902','2013-06-17','09:45:00',4.8),('8902','2013-06-17','09:50:00',4.91),('8902','2013-06-17','09:55:00',4.96),('8902','2013-06-17','10:00:00',5.05),('8902','2013-06-17','10:05:00',5.07),('8902','2013-06-17','10:10:00',5.27),('8902','2013-06-17','10:15:00',5.37),('8902','2013-06-17','10:20:00',5.49),('8902','2013-06-17','10:25:00',5.58),('8902','2013-06-17','10:30:00',5.65),('8902','2013-06-17','10:35:00',5.75),('8902','2013-06-17','10:40:00',5.82),('8902','2013-06-17','10:45:00',5.85),('8902','2013-06-17','10:50:00',5.9),('8902','2013-06-17','10:55:00',6),('8902','2013-06-17','11:00:00',6.07),('8902','2013-06-17','11:05:00',6.2),('8902','2013-06-17','11:10:00',6.36),('8902','2013-06-17','11:15:00',6.4),('8902','2013-06-17','11:20:00',6.43),('8902','2013-06-17','11:25:00',6.44),('8902','2013-06-17','11:30:00',6.46),('8902','2013-06-17','11:35:00',6.48),('8902','2013-06-17','11:40:00',6.51),('8902','2013-06-17','11:45:00',6.57),('8902','2013-06-17','11:50:00',6.57),('8902','2013-06-17','11:55:00',6.53),('8902','2013-06-17','12:00:00',6.52),('8902','2013-06-17','12:05:00',6.71),('8902','2013-06-17','12:10:00',6.69),('8902','2013-06-17','12:15:00',6.6),('8902','2013-06-17','12:20:00',6.61),('8902','2013-06-17','12:25:00',6.79),('8902','2013-06-17','12:30:00',6.78),('8902','2013-06-17','12:35:00',6.42),('8902','2013-06-17','12:40:00',5.85),('8902','2013-06-17','12:45:00',5.36),('8902','2013-06-17','12:50:00',6.24),('8902','2013-06-17','12:55:00',7.23),('8902','2013-06-17','13:00:00',7.04),('8902','2013-06-17','13:05:00',6.4),('8902','2013-06-17','13:10:00',7.56),('8902','2013-06-17','13:15:00',7.27),('8902','2013-06-17','13:20:00',7.68),('8902','2013-06-17','13:25:00',7.09),('8902','2013-06-17','13:30:00',7.61),('8902','2013-06-17','13:35:00',7.31),('8902','2013-06-17','13:40:00',7.12),('8902','2013-06-17','13:45:00',7.28),('8902','2013-06-17','13:50:00',7.35),('8902','2013-06-17','13:55:00',7.58),('8902','2013-06-17','14:00:00',7.58),('8902','2013-06-17','14:05:00',7.6),('8902','2013-06-17','14:10:00',7.55),('8902','2013-06-17','14:15:00',7.42),('8902','2013-06-17','14:20:00',7.29),('8902','2013-06-17','14:25:00',7.38),('8902','2013-06-17','14:30:00',7.28),('8902','2013-06-17','14:35:00',7.33),('8902','2013-06-17','14:40:00',7.31),('8902','2013-06-17','14:45:00',7.2),('8902','2013-06-17','14:50:00',7.1),('8902','2013-06-17','14:55:00',7.06),('8902','2013-06-17','15:00:00',7.05),('8902','2013-06-17','15:05:00',6.96),('8902','2013-06-17','15:10:00',6.92),('8902','2013-06-17','15:15:00',6.83),('8902','2013-06-17','15:20:00',6.73),('8902','2013-06-17','15:25:00',6.7),('8902','2013-06-17','15:30:00',6.59),('8902','2013-06-17','15:35:00',6.59),('8902','2013-06-17','15:40:00',6.56),('8902','2013-06-17','15:45:00',6.49),('8902','2013-06-17','15:50:00',6.47),('8902','2013-06-17','15:55:00',6.39),('8902','2013-06-17','16:00:00',6.37),('8902','2013-06-17','16:05:00',6.32),('8902','2013-06-17','16:10:00',6.24),('8902','2013-06-17','16:15:00',6.18),('8902','2013-06-17','16:20:00',6.12),('8902','2013-06-17','16:25:00',5.78),('8902','2013-06-17','16:30:00',5.66),('8902','2013-06-17','16:35:00',5.35),('8902','2013-06-17','16:40:00',5.35),('8902','2013-06-17','16:45:00',5.21),('8902','2013-06-17','16:50:00',5.11),('8902','2013-06-17','16:55:00',4.9),('8902','2013-06-17','17:00:00',4.83),('8902','2013-06-17','17:05:00',4.73),('8902','2013-06-17','17:10:00',4.62),('8902','2013-06-17','17:15:00',4.51),('8902','2013-06-17','17:20:00',4.38),('8902','2013-06-17','17:25:00',4.2),('8902','2013-06-17','17:30:00',4.07),('8902','2013-06-17','17:35:00',3.94),('8902','2013-06-17','17:40:00',3.73),('8902','2013-06-17','17:45:00',3.62),('8902','2013-06-17','17:50:00',3.47),('8902','2013-06-17','17:55:00',3.24),('8902','2013-06-17','18:00:00',3.08),('8902','2013-06-17','18:05:00',3),('8902','2013-06-17','18:10:00',2.82),('8902','2013-06-17','18:15:00',2.72),('8902','2013-06-17','18:20:00',2.55),('8902','2013-06-17','18:25:00',2.37),('8902','2013-06-17','18:30:00',2.22),('8902','2013-06-17','18:35:00',1.99),('8902','2013-06-17','18:40:00',1.85),('8902','2013-06-17','18:45:00',1.7),('8902','2013-06-17','18:50:00',1.55),('8902','2013-06-17','18:55:00',1.37),('8902','2013-06-17','19:00:00',1.26),('8902','2013-06-17','19:05:00',1.1),('8902','2013-06-16','07:25:00',1.11),('8902','2013-06-16','07:30:00',1.24),('8902','2013-06-16','07:35:00',1.37),('8902','2013-06-16','07:40:00',1.51),('8902','2013-06-16','07:45:00',1.65),('8902','2013-06-16','07:50:00',1.79),('8902','2013-06-16','07:55:00',1.94),('8902','2013-06-16','08:00:00',2.1),('8902','2013-06-16','08:05:00',2.25),('8902','2013-06-16','08:10:00',2.4),('8902','2013-06-16','08:15:00',2.55),('8902','2013-06-16','08:20:00',2.7),('8902','2013-06-16','08:25:00',2.85),('8902','2013-06-16','08:30:00',3),('8902','2013-06-16','08:35:00',3.15),('8902','2013-06-16','08:40:00',3.31),('8902','2013-06-16','08:45:00',3.45),('8902','2013-06-16','08:50:00',3.59),('8902','2013-06-16','08:55:00',3.74),('8902','2013-06-16','09:00:00',3.89),('8902','2013-06-16','09:05:00',4.02),('8902','2013-06-16','09:10:00',4.17),('8902','2013-06-16','09:15:00',4.28),('8902','2013-06-16','09:20:00',4.42),('8902','2013-06-16','09:25:00',4.55),('8902','2013-06-16','09:30:00',4.67),('8902','2013-06-16','09:35:00',4.78),('8902','2013-06-16','09:40:00',4.9),('8902','2013-06-16','09:45:00',5.02),('8902','2013-06-16','09:50:00',5.12),('8902','2013-06-16','09:55:00',5.22),('8902','2013-06-16','10:00:00',5.3),('8902','2013-06-16','10:05:00',5.42),('8902','2013-06-16','10:10:00',5.53),('8902','2013-06-16','10:15:00',5.59),('8902','2013-06-16','10:20:00',5.68),('8902','2013-06-16','10:25:00',5.77),('8902','2013-06-16','10:30:00',5.89),('8902','2013-06-16','10:35:00',5.99),('8902','2013-06-16','10:40:00',6.06),('8902','2013-06-16','10:45:00',6.13),('8902','2013-06-16','10:50:00',6.18),('8902','2013-06-16','10:55:00',6.27),('8902','2013-06-16','11:00:00',6.37),('8902','2013-06-16','11:05:00',6.39),('8902','2013-06-16','11:10:00',6.42),('8902','2013-06-16','11:15:00',6.46),('8902','2013-06-16','11:20:00',6.54),('8902','2013-06-16','11:25:00',6.59),('8902','2013-06-16','11:30:00',6.61),('8902','2013-06-16','11:35:00',6.65),('8902','2013-06-16','11:40:00',6.61),('8902','2013-06-16','11:45:00',6.72),('8902','2013-06-16','11:50:00',6.79),('8902','2013-06-16','11:55:00',6.83),('8902','2013-06-16','12:00:00',6.84),('8902','2013-06-16','12:05:00',6.86),('8902','2013-06-16','12:10:00',6.97),('8902','2013-06-16','12:15:00',7.07),('8902','2013-06-16','12:20:00',7.1),('8902','2013-06-16','12:25:00',7.05),('8902','2013-06-16','12:30:00',7.03),('8902','2013-06-16','12:35:00',7.06),('8902','2013-06-16','12:40:00',7.08),('8902','2013-06-16','12:45:00',7.09),('8902','2013-06-16','12:50:00',7.14),('8902','2013-06-16','12:55:00',7.21),('8902','2013-06-16','13:00:00',7.28),('8902','2013-06-16','13:05:00',7.32),('8902','2013-06-16','13:10:00',7.36),('8902','2013-06-16','13:15:00',7.43),('8902','2013-06-16','13:20:00',7.4),('8902','2013-06-16','13:25:00',7.37),('8902','2013-06-16','13:30:00',7.39),('8902','2013-06-16','13:35:00',7.35),('8902','2013-06-16','13:40:00',7.33),('8902','2013-06-16','13:45:00',7.39),('8902','2013-06-16','13:50:00',7.34),('8902','2013-06-16','13:55:00',7.34),('8902','2013-06-16','14:00:00',7.34),('8902','2013-06-16','14:05:00',7.34),('8902','2013-06-16','14:10:00',7.3),('8902','2013-06-16','14:15:00',7.29),('8902','2013-06-16','14:20:00',7.22),('8902','2013-06-16','14:25:00',7.2),('8902','2013-06-16','14:30:00',7.16),('8902','2013-06-16','14:35:00',7.15),('8902','2013-06-16','14:40:00',7.15),('8902','2013-06-16','14:45:00',7.12),('8902','2013-06-16','14:50:00',7.05),('8902','2013-06-16','14:55:00',7.05),('8902','2013-06-16','15:00:00',6.98),('8902','2013-06-16','15:05:00',6.94),('8902','2013-06-16','15:10:00',6.84),('8902','2013-06-16','15:15:00',6.76),('8902','2013-06-16','15:20:00',6.72),('8902','2013-06-16','15:25:00',6.68),('8902','2013-06-16','15:30:00',6.6),('8902','2013-06-16','15:35:00',6.55),('8902','2013-06-16','15:40:00',6.47),('8902','2013-06-16','15:45:00',6.4),('8902','2013-06-16','15:50:00',6.29),('8902','2013-06-16','15:55:00',6.21),('8902','2013-06-16','16:00:00',6.16),('8902','2013-06-16','16:05:00',6.06),('8902','2013-06-16','16:10:00',5.98),('8902','2013-06-16','16:15:00',5.9),('8902','2013-06-16','16:20:00',5.82),('8902','2013-06-16','16:25:00',5.73),('8902','2013-06-16','16:30:00',5.57),('8902','2013-06-16','16:35:00',5.41),('8902','2013-06-16','16:40:00',5.29),('8902','2013-06-16','16:45:00',5.21),('8902','2013-06-16','16:50:00',5.11),('8902','2013-06-16','16:55:00',4.91),('8902','2013-06-16','17:00:00',4.9),('8902','2013-06-16','17:05:00',4.79),('8902','2013-06-16','17:10:00',4.65),('8902','2013-06-16','17:15:00',4.52),('8902','2013-06-16','17:20:00',4.4),('8902','2013-06-16','17:25:00',4.24),('8902','2013-06-16','17:30:00',4.18),('8902','2013-06-16','17:35:00',4.04),('8902','2013-06-16','17:40:00',3.85),('8902','2013-06-16','17:45:00',3.72),('8902','2013-06-16','17:50:00',3.58),('8902','2013-06-16','17:55:00',3.37),('8902','2013-06-16','18:00:00',3.24),('8902','2013-06-16','18:05:00',3.1),('8902','2013-06-16','18:10:00',2.92),('8902','2013-06-16','18:15:00',2.8),('8902','2013-06-16','18:20:00',2.6),('8902','2013-06-16','18:25:00',2.29),('8902','2013-06-16','18:30:00',2.3),('8902','2013-06-16','18:35:00',1.96),('8902','2013-06-16','18:40:00',1.92),('8902','2013-06-16','18:45:00',1.82),('8902','2013-06-16','18:50:00',1.74),('8902','2013-06-16','18:55:00',1.59),('8902','2013-06-16','19:00:00',1.47),('8902','2013-06-16','19:05:00',1.28),('8902','2013-06-16','19:10:00',1.11),('8902','2013-06-15','07:20:00',1.01),('8902','2013-06-15','07:25:00',1.13),('8902','2013-06-15','07:30:00',1.26),('8902','2013-06-15','07:35:00',1.4),('8902','2013-06-15','07:40:00',1.54),('8902','2013-06-15','07:45:00',1.68),('8902','2013-06-15','07:50:00',1.83),('8902','2013-06-15','07:55:00',1.98),('8902','2013-06-15','08:00:00',2.13),('8902','2013-06-15','08:05:00',2.27),('8902','2013-06-15','08:10:00',2.43),('8902','2013-06-15','08:15:00',2.6),('8902','2013-06-15','08:20:00',2.75),('8902','2013-06-15','08:25:00',2.91),('8902','2013-06-15','08:30:00',3.05),('8902','2013-06-15','08:35:00',3.22),('8902','2013-06-15','08:40:00',3.33),('8902','2013-06-15','08:45:00',3.49),('8902','2013-06-15','08:50:00',3.62),('8902','2013-06-15','08:55:00',3.8),('8902','2013-06-15','09:00:00',3.96),('8902','2013-06-15','09:05:00',4.1),('8902','2013-06-15','09:10:00',4.26),('8902','2013-06-15','09:15:00',4.42),('8902','2013-06-15','09:20:00',4.53),('8902','2013-06-15','09:25:00',4.63),('8902','2013-06-15','09:30:00',4.73),('8902','2013-06-15','09:35:00',4.83),('8902','2013-06-15','09:40:00',4.96),('8902','2013-06-15','09:45:00',5.07),('8902','2013-06-15','09:50:00',5.19),('8902','2013-06-15','09:55:00',5.28),('8902','2013-06-15','10:00:00',5.38),('8902','2013-06-15','10:05:00',5.49),('8902','2013-06-15','10:10:00',5.56),('8902','2013-06-15','10:15:00',5.63),('8902','2013-06-15','10:20:00',5.73),('8902','2013-06-15','10:25:00',5.93),('8902','2013-06-15','10:30:00',6.02),('8902','2013-06-15','10:35:00',6.15),('8902','2013-06-15','10:40:00',6.2),('8902','2013-06-15','10:45:00',6.26),('8902','2013-06-15','10:50:00',6.3),('8902','2013-06-15','10:55:00',6.39),('8902','2013-06-15','11:00:00',6.5),('8902','2013-06-15','11:05:00',6.48),('8902','2013-06-15','11:10:00',6.59),('8902','2013-06-15','11:15:00',6.7),('8902','2013-06-15','11:20:00',6.77),('8902','2013-06-15','11:25:00',6.85),('8902','2013-06-15','11:30:00',6.88),('8902','2013-06-15','11:35:00',6.95),('8902','2013-06-15','11:40:00',7.03),('8902','2013-06-15','11:45:00',6.99),('8902','2013-06-15','11:50:00',7.05),('8902','2013-06-15','11:55:00',7.12),('8902','2013-06-15','12:00:00',7.14),('8902','2013-06-15','12:05:00',7.24),('8902','2013-06-15','12:10:00',7.27),('8902','2013-06-15','12:15:00',7.3),('8902','2013-06-15','12:20:00',7.41),('8902','2013-06-15','12:25:00',7.44),('8902','2013-06-15','12:30:00',7.46),('8902','2013-06-15','12:35:00',7.48),('8902','2013-06-15','12:40:00',7.44),('8902','2013-06-15','12:45:00',7.46),('8902','2013-06-15','12:50:00',7.46),('8902','2013-06-15','12:55:00',7.41),('8902','2013-06-15','13:00:00',7.44),('8902','2013-06-15','13:05:00',7.48),('8902','2013-06-15','13:10:00',7.63),('8902','2013-06-15','13:15:00',7.66),('8902','2013-06-15','13:20:00',7.67),('8902','2013-06-15','13:25:00',7.7),('8902','2013-06-15','13:30:00',7.67),('8902','2013-06-15','13:35:00',7.74),('8902','2013-06-15','13:40:00',7.75),('8902','2013-06-15','13:45:00',7.71),('8902','2013-06-15','13:50:00',7.68),('8902','2013-06-15','13:55:00',7.68),('8902','2013-06-15','14:00:00',7.64),('8902','2013-06-15','14:05:00',7.56),('8902','2013-06-15','14:10:00',7.57),('8902','2013-06-15','14:15:00',7.59),('8902','2013-06-15','14:20:00',7.57),('8902','2013-06-15','14:25:00',7.52),('8902','2013-06-15','14:30:00',7.48),('8902','2013-06-15','14:35:00',7.45),('8902','2013-06-15','14:40:00',7.37),('8902','2013-06-15','14:45:00',7.29),('8902','2013-06-15','14:50:00',7.24),('8902','2013-06-15','14:55:00',7.2),('8902','2013-06-15','15:00:00',7.17),('8902','2013-06-15','15:05:00',7.14),('8902','2013-06-15','15:10:00',7.11),('8902','2013-06-15','15:15:00',7.09),('8902','2013-06-15','15:20:00',7.02),('8902','2013-06-15','15:25:00',6.95),('8902','2013-06-15','15:30:00',6.88),('8902','2013-06-15','15:35:00',6.77),('8902','2013-06-15','15:40:00',6.71),('8902','2013-06-15','15:45:00',6.63),('8902','2013-06-15','15:50:00',6.58),('8902','2013-06-15','15:55:00',6.48),('8902','2013-06-15','16:00:00',6.38),('8902','2013-06-15','16:05:00',6.29),('8902','2013-06-15','16:10:00',6.2),('8902','2013-06-15','16:15:00',6.13),('8902','2013-06-15','16:20:00',5.99),('8902','2013-06-15','16:25:00',5.88),('8902','2013-06-15','16:30:00',5.77),('8902','2013-06-15','16:35:00',5.61),('8902','2013-06-15','16:40:00',5.46),('8902','2013-06-15','16:45:00',5.4),('8902','2013-06-15','16:50:00',5.26),('8902','2013-06-15','16:55:00',5.09),('8902','2013-06-15','17:00:00',4.99),('8902','2013-06-15','17:05:00',4.85),('8902','2013-06-15','17:10:00',4.71),('8902','2013-06-15','17:15:00',4.58),('8902','2013-06-15','17:20:00',4.44),('8902','2013-06-15','17:25:00',4.23),('8902','2013-06-15','17:30:00',4.14),('8902','2013-06-15','17:35:00',4),('8902','2013-06-15','17:40:00',3.81),('8902','2013-06-15','17:45:00',3.68),('8902','2013-06-15','17:50:00',3.52),('8902','2013-06-15','17:55:00',3.24),('8902','2013-06-15','18:00:00',3.16),('8902','2013-06-15','18:05:00',3.04),('8902','2013-06-15','18:10:00',2.84),('8902','2013-06-15','18:15:00',2.71),('8902','2013-06-15','18:20:00',2.51),('8902','2013-06-15','18:25:00',2.34),('8902','2013-06-15','18:30:00',2.2),('8902','2013-06-15','18:35:00',1.96),('8902','2013-06-15','18:40:00',1.85),('8902','2013-06-15','18:45:00',1.7),('8902','2013-06-15','18:50:00',1.58),('8902','2013-06-15','18:55:00',1.39),('8902','2013-06-15','19:00:00',1.26),('8902','2013-06-15','19:05:00',1.1),('8902','2013-06-14','07:20:00',1.02),('8902','2013-06-14','07:25:00',1.13),('8902','2013-06-14','07:30:00',1.25),('8902','2013-06-14','07:35:00',1.38),('8902','2013-06-14','07:40:00',1.52),('8902','2013-06-14','07:45:00',1.67),('8902','2013-06-14','07:50:00',1.81),('8902','2013-06-14','07:55:00',1.95),('8902','2013-06-14','08:00:00',2.09),('8902','2013-06-14','08:05:00',2.25),('8902','2013-06-14','08:10:00',2.4),('8902','2013-06-14','08:15:00',2.56),('8902','2013-06-14','08:20:00',2.75),('8902','2013-06-14','08:25:00',2.85),('8902','2013-06-14','08:30:00',3),('8902','2013-06-14','08:35:00',3.03),('8902','2013-06-14','08:40:00',3.25),('8902','2013-06-14','08:45:00',3.45),('8902','2013-06-14','08:50:00',3.21),('8902','2013-06-14','08:55:00',3.7),('8902','2013-06-14','09:00:00',3.74),('8902','2013-06-14','09:05:00',3.34),('8902','2013-06-14','09:10:00',4.24),('8902','2013-06-14','09:15:00',4.32),('8902','2013-06-14','09:20:00',4.47),('8902','2013-06-14','09:25:00',4.48),('8902','2013-06-14','09:30:00',4.77),('8902','2013-06-14','09:35:00',4.92),('8902','2013-06-14','09:40:00',4.12),('8902','2013-06-14','09:45:00',5),('8902','2013-06-14','09:50:00',4.96),('8902','2013-06-14','09:55:00',5.28),('8902','2013-06-14','10:00:00',5.54),('8902','2013-06-14','10:05:00',5.7),('8902','2013-06-14','10:10:00',5.74),('8902','2013-06-14','10:15:00',2.66),('8902','2013-06-14','10:20:00',3.97),('8902','2013-06-14','10:25:00',3.91),('8902','2013-06-14','10:30:00',4.51),('8902','2013-06-14','10:35:00',6.5),('8902','2013-06-14','10:40:00',4.27),('8902','2013-06-14','10:45:00',5.4),('8902','2013-06-14','10:50:00',5.58),('8902','2013-06-14','10:55:00',5.4),('8902','2013-06-14','11:00:00',5.69),('8902','2013-06-14','11:05:00',4.72),('8902','2013-06-14','11:10:00',5.26),('8902','2013-06-14','11:15:00',7.4),('8902','2013-06-14','11:20:00',7.36),('8902','2013-06-14','11:25:00',5.32),('8902','2013-06-14','11:30:00',4.98),('8902','2013-06-14','11:35:00',7.68),('8902','2013-06-14','11:40:00',7.24),('8902','2013-06-14','11:45:00',7.64),('8902','2013-06-14','11:50:00',4),('8902','2013-06-14','11:55:00',7.74),('8902','2013-06-14','12:00:00',7.67),('8902','2013-06-14','12:05:00',7.65),('8902','2013-06-14','12:10:00',7.21),('8902','2013-06-14','12:15:00',7.84),('8902','2013-06-14','12:20:00',7.76),('8902','2013-06-14','12:25:00',7.58),('8902','2013-06-14','12:30:00',7.65),('8902','2013-06-14','12:35:00',7.69),('8902','2013-06-14','12:40:00',7.58),('8902','2013-06-14','12:45:00',7.65),('8902','2013-06-14','12:50:00',7.65),('8902','2013-06-14','12:55:00',7.68),('8902','2013-06-14','13:00:00',7.68),('8902','2013-06-14','13:05:00',7.64),('8902','2013-06-14','13:10:00',7.77),('8902','2013-06-14','13:15:00',7.75),('8902','2013-06-14','13:20:00',7.7),('8902','2013-06-14','13:25:00',7.71),('8902','2013-06-14','13:30:00',7.73),('8902','2013-06-14','13:35:00',7.59),('8902','2013-06-14','13:40:00',7.66),('8902','2013-06-14','13:45:00',7.66),('8902','2013-06-14','13:50:00',7.64),('8902','2013-06-14','13:55:00',7.57),('8902','2013-06-14','14:00:00',7.58),('8902','2013-06-14','14:05:00',7.56),('8902','2013-06-14','14:10:00',7.56),('8902','2013-06-14','14:15:00',7.5),('8902','2013-06-14','14:20:00',7.48),('8902','2013-06-14','14:25:00',7.53),('8902','2013-06-14','14:30:00',7.46),('8902','2013-06-14','14:35:00',7.45),('8902','2013-06-14','14:40:00',7.44),('8902','2013-06-14','14:45:00',7.35),('8902','2013-06-14','14:50:00',7.31),('8902','2013-06-14','14:55:00',7.32),('8902','2013-06-14','15:00:00',7.14),('8902','2013-06-14','15:05:00',7.12),('8902','2013-06-14','15:10:00',7.06),('8902','2013-06-14','15:15:00',7.01),('8902','2013-06-14','15:20:00',7.05),('8902','2013-06-14','15:25:00',7.02),('8902','2013-06-14','15:30:00',6.93),('8902','2013-06-14','15:35:00',6.81),('8902','2013-06-14','15:40:00',6.71),('8902','2013-06-14','15:45:00',6.67),('8902','2013-06-14','15:50:00',6.56),('8902','2013-06-14','15:55:00',6.49),('8902','2013-06-14','16:00:00',6.41),('8902','2013-06-14','16:05:00',6.29),('8902','2013-06-14','16:10:00',6.17),('8902','2013-06-14','16:15:00',6.11),('8902','2013-06-14','16:20:00',5.98),('8902','2013-06-14','16:25:00',5.85),('8902','2013-06-14','16:30:00',5.77),('8902','2013-06-14','16:35:00',5.55),('8902','2013-06-14','16:40:00',5.47),('8902','2013-06-14','16:45:00',5.38),('8902','2013-06-14','16:50:00',5.21),('8902','2013-06-14','16:55:00',4.97),('8902','2013-06-14','17:00:00',4.98),('8902','2013-06-14','17:05:00',4.83),('8902','2013-06-14','17:10:00',4.72),('8902','2013-06-14','17:15:00',4.59),('8902','2013-06-14','17:20:00',4.44),('8902','2013-06-14','17:25:00',4.21),('8902','2013-06-14','17:30:00',4.11),('8902','2013-06-14','17:35:00',3.97),('8902','2013-06-14','17:40:00',3.81),('8902','2013-06-14','17:45:00',3.64),('8902','2013-06-14','17:50:00',3.46),('8902','2013-06-14','17:55:00',3.18),('8902','2013-06-14','18:00:00',3.07),('8902','2013-06-14','18:05:00',2.95),('8902','2013-06-14','18:10:00',2.76),('8902','2013-06-14','18:15:00',2.67),('8902','2013-06-14','18:20:00',2.44),('8902','2013-06-14','18:25:00',2.32),('8902','2013-06-14','18:30:00',2.14),('8902','2013-06-14','18:35:00',1.92),('8902','2013-06-14','18:40:00',1.81),('8902','2013-06-14','18:45:00',1.64),('8902','2013-06-14','18:50:00',1.51),('8902','2013-06-14','18:55:00',1.34),('8902','2013-06-14','19:00:00',1.22),('8902','2013-06-14','19:05:00',1.08),('8902','2013-06-13','07:20:00',1.02),('8902','2013-06-13','07:25:00',1.17),('8902','2013-06-13','07:30:00',1.31),('8902','2013-06-13','07:35:00',1.46),('8902','2013-06-13','07:40:00',1.62),('8902','2013-06-13','07:45:00',1.78),('8902','2013-06-13','07:50:00',1.94),('8902','2013-06-13','07:55:00',2.1),('8902','2013-06-13','08:00:00',2.26),('8902','2013-06-13','08:05:00',2.42),('8902','2013-06-13','08:10:00',2.58),('8902','2013-06-13','08:15:00',2.75),('8902','2013-06-13','08:20:00',2.91),('8902','2013-06-13','08:25:00',3.07),('8902','2013-06-13','08:30:00',3.23),('8902','2013-06-13','08:35:00',3.39),('8902','2013-06-13','08:40:00',3.54),('8902','2013-06-13','08:45:00',3.71),('8902','2013-06-13','08:50:00',3.86),('8902','2013-06-13','08:55:00',4),('8902','2013-06-13','09:00:00',4.15),('8902','2013-06-13','09:05:00',4.29),('8902','2013-06-13','09:10:00',4.43),('8902','2013-06-13','09:15:00',4.56),('8902','2013-06-13','09:20:00',4.68),('8902','2013-06-13','09:25:00',4.78),('8902','2013-06-13','09:30:00',4.87),('8902','2013-06-13','09:35:00',5.07),('8902','2013-06-13','09:40:00',5.21),('8902','2013-06-13','09:45:00',5.33),('8902','2013-06-13','09:50:00',5.45),('8902','2013-06-13','09:55:00',5.57),('8902','2013-06-13','10:00:00',5.68),('8902','2013-06-13','10:05:00',5.77),('8902','2013-06-13','10:10:00',5.82),('8902','2013-06-13','10:15:00',5.91),('8902','2013-06-13','10:20:00',6.04),('8902','2013-06-13','10:25:00',6.04),('8902','2013-06-13','10:30:00',6.21),('8902','2013-06-13','10:35:00',6.44),('8902','2013-06-13','10:40:00',6.53),('8902','2013-06-13','10:45:00',6.57),('8902','2013-06-13','10:50:00',6.55),('8902','2013-06-13','10:55:00',6.56),('8902','2013-06-13','11:00:00',6.54),('8902','2013-06-13','11:05:00',6.63),('8902','2013-06-13','11:10:00',6.81),('8902','2013-06-13','11:15:00',6.88),('8902','2013-06-13','11:20:00',6.89),('8902','2013-06-13','11:25:00',6.77),('8902','2013-06-13','11:30:00',7.17),('8902','2013-06-13','11:35:00',7.22),('8902','2013-06-13','11:40:00',7.2),('8902','2013-06-13','11:45:00',7.23),('8902','2013-06-13','11:50:00',7.3),('8902','2013-06-13','11:55:00',7.32),('8902','2013-06-13','12:00:00',7.35),('8902','2013-06-13','12:05:00',7.36),('8902','2013-06-13','12:10:00',7.38),('8902','2013-06-13','12:15:00',7.36),('8902','2013-06-13','12:20:00',7.43),('8902','2013-06-13','12:25:00',7.49),('8902','2013-06-13','12:30:00',7.48),('8902','2013-06-13','12:35:00',7.5),('8902','2013-06-13','12:40:00',7.52),('8902','2013-06-13','12:45:00',7.62),('8902','2013-06-13','12:50:00',7.57),('8902','2013-06-13','12:55:00',7.55),('8902','2013-06-13','13:00:00',7.55),('8902','2013-06-13','13:05:00',7.65),('8902','2013-06-13','13:10:00',7.66),('8902','2013-06-13','13:15:00',4.78),('8902','2013-06-13','13:20:00',7.88),('8902','2013-06-13','13:25:00',8.09),('8902','2013-06-13','13:30:00',7.92),('8902','2013-06-13','13:35:00',7.75),('8902','2013-06-13','13:40:00',7.76),('8902','2013-06-13','13:45:00',7.9),('8902','2013-06-13','13:50:00',7.94),('8902','2013-06-13','13:55:00',7.91),('8902','2013-06-13','14:00:00',7.86),('8902','2013-06-13','14:05:00',7.87),('8902','2013-06-13','14:10:00',7.92),('8902','2013-06-13','14:15:00',7.82),('8902','2013-06-13','14:20:00',7.75),('8902','2013-06-13','14:25:00',7.74),('8902','2013-06-13','14:30:00',7.8),('8902','2013-06-13','14:35:00',7.66),('8902','2013-06-13','14:40:00',7.59),('8902','2013-06-13','14:45:00',7.55),('8902','2013-06-13','14:50:00',7.4),('8902','2013-06-13','14:55:00',7.4),('8902','2013-06-13','15:00:00',7.36),('8902','2013-06-13','15:05:00',7.32),('8902','2013-06-13','15:10:00',7.25),('8902','2013-06-13','15:15:00',7.18),('8902','2013-06-13','15:20:00',7.15),('8902','2013-06-13','15:25:00',7.06),('8902','2013-06-13','15:30:00',7),('8902','2013-06-13','15:35:00',6.92),('8902','2013-06-13','15:40:00',6.84),('8902','2013-06-13','15:45:00',6.76),('8902','2013-06-13','15:50:00',6.69),('8902','2013-06-13','15:55:00',6.6),('8902','2013-06-13','16:00:00',6.54),('8902','2013-06-13','16:05:00',6.45),('8902','2013-06-13','16:10:00',6.33),('8902','2013-06-13','16:15:00',6.19),('8902','2013-06-13','16:20:00',6.11),('8902','2013-06-13','16:25:00',6.01),('8902','2013-06-13','16:30:00',5.83),('8902','2013-06-13','16:35:00',5.64),('8902','2013-06-13','16:40:00',5.47),('8902','2013-06-13','16:45:00',5.44),('8902','2013-06-13','16:50:00',5.31),('8902','2013-06-13','16:55:00',5.07),('8902','2013-06-13','17:00:00',5.07),('8902','2013-06-13','17:05:00',4.79),('8902','2013-06-13','17:10:00',4.71),('8902','2013-06-13','17:15:00',4.68),('8902','2013-06-13','17:20:00',4.47),('8902','2013-06-13','17:25:00',4.3),('8902','2013-06-13','17:30:00',4.11),('8902','2013-06-13','17:35:00',4.03),('8902','2013-06-13','17:40:00',3.91),('8902','2013-06-13','17:45:00',3.77),('8902','2013-06-13','17:50:00',3.61),('8902','2013-06-13','17:55:00',3.33),('8902','2013-06-13','18:00:00',3.26),('8902','2013-06-13','18:05:00',3.15),('8902','2013-06-13','18:10:00',2.93),('8902','2013-06-13','18:15:00',2.82),('8902','2013-06-13','18:20:00',2.61),('8902','2013-06-13','18:25:00',2.46),('8902','2013-06-13','18:30:00',2.29),('8902','2013-06-13','18:35:00',2.09),('8902','2013-06-13','18:40:00',1.94),('8902','2013-06-13','18:45:00',1.79),('8902','2013-06-13','18:50:00',1.64),('8902','2013-06-13','18:55:00',1.43),('8902','2013-06-13','19:00:00',1.31),('8902','2013-06-13','19:05:00',1.15),('8902','2013-06-12','07:20:00',1.05),('8902','2013-06-12','07:25:00',1.19),('8902','2013-06-12','07:30:00',1.34),('8902','2013-06-12','07:35:00',1.5),('8902','2013-06-12','07:40:00',1.65),('8902','2013-06-12','07:45:00',1.81),('8902','2013-06-12','07:50:00',1.97),('8902','2013-06-12','07:55:00',2.13),('8902','2013-06-12','08:00:00',2.29),('8902','2013-06-12','08:05:00',2.47),('8902','2013-06-12','08:10:00',2.63),('8902','2013-06-12','08:15:00',2.78),('8902','2013-06-12','08:20:00',2.93),('8902','2013-06-12','08:25:00',3.08),('8902','2013-06-12','08:30:00',3.25),('8902','2013-06-12','08:35:00',3.42),('8902','2013-06-12','08:40:00',3.57),('8902','2013-06-12','08:45:00',3.74),('8902','2013-06-12','08:50:00',3.89),('8902','2013-06-12','08:55:00',4.04),('8902','2013-06-12','09:00:00',4.17),('8902','2013-06-12','09:05:00',4.34),('8902','2013-06-12','09:10:00',4.48),('8902','2013-06-12','09:15:00',4.65),('8902','2013-06-12','09:20:00',4.79),('8902','2013-06-12','09:25:00',4.95),('8902','2013-06-12','09:30:00',5.09),('8902','2013-06-12','09:35:00',5.2),('8902','2013-06-12','09:40:00',5.32),('8902','2013-06-12','09:45:00',5.44),('8902','2013-06-12','09:50:00',5.55),('8902','2013-06-12','09:55:00',5.68),('8902','2013-06-12','10:00:00',5.82),('8902','2013-06-12','10:05:00',5.95),('8902','2013-06-12','10:10:00',6.02),('8902','2013-06-12','10:15:00',6.11),('8902','2013-06-12','10:20:00',6.2),('8902','2013-06-12','10:25:00',6.3),('8902','2013-06-12','10:30:00',6.43),('8902','2013-06-12','10:35:00',6.5),('8902','2013-06-12','10:40:00',6.58),('8902','2013-06-12','10:45:00',6.71),('8902','2013-06-12','10:50:00',6.8),('8902','2013-06-12','10:55:00',6.87),('8902','2013-06-12','11:00:00',6.93),('8902','2013-06-12','11:05:00',7.03),('8902','2013-06-12','11:10:00',7.12),('8902','2013-06-12','11:15:00',7.16),('8902','2013-06-12','11:20:00',7.23),('8902','2013-06-12','11:25:00',7.28),('8902','2013-06-12','11:30:00',7.33),('8902','2013-06-12','11:35:00',7.45),('8902','2013-06-12','11:40:00',7.51),('8902','2013-06-12','11:45:00',7.58),('8902','2013-06-12','11:50:00',7.6),('8902','2013-06-12','11:55:00',7.64),('8902','2013-06-12','12:00:00',7.71),('8902','2013-06-12','12:05:00',7.8),('8902','2013-06-12','12:10:00',7.77),('8902','2013-06-12','12:15:00',7.78),('8902','2013-06-12','12:20:00',7.82),('8902','2013-06-12','12:25:00',7.91),('8902','2013-06-12','12:30:00',7.94),('8902','2013-06-12','12:35:00',7.93),('8902','2013-06-12','12:40:00',7.97),('8902','2013-06-12','12:45:00',7.98),('8902','2013-06-12','12:50:00',7.99),('8902','2013-06-12','12:55:00',7.99),('8902','2013-06-12','13:00:00',8.01),('8902','2013-06-12','13:05:00',8.02),('8902','2013-06-12','13:10:00',7.97),('8902','2013-06-12','13:15:00',8),('8902','2013-06-12','13:20:00',7.61),('8902','2013-06-12','13:25:00',7.98),('8902','2013-06-12','13:30:00',7.95),('8902','2013-06-12','13:35:00',7.97),('8902','2013-06-12','13:40:00',8),('8902','2013-06-12','13:45:00',7.99),('8902','2013-06-12','13:50:00',7.95),('8902','2013-06-12','13:55:00',7.92),('8902','2013-06-12','14:00:00',7.89),('8902','2013-06-12','14:05:00',7.89),('8902','2013-06-12','14:10:00',7.84),('8902','2013-06-12','14:15:00',7.85),('8902','2013-06-12','14:20:00',7.76),('8902','2013-06-12','14:25:00',7.86),('8902','2013-06-12','14:30:00',6.3),('8902','2013-06-12','14:35:00',6.78),('8902','2013-06-12','14:40:00',7.81),('8902','2013-06-12','14:45:00',7.67),('8902','2013-06-12','14:50:00',7.48),('8902','2013-06-12','14:55:00',7.41),('8902','2013-06-12','15:00:00',7.38),('8902','2013-06-12','15:05:00',7.31),('8902','2013-06-12','15:10:00',7.25),('8902','2013-06-12','15:15:00',7.16),('8902','2013-06-12','15:20:00',7.09),('8902','2013-06-12','15:25:00',7.02),('8902','2013-06-12','15:30:00',6.94),('8902','2013-06-12','15:35:00',6.92),('8902','2013-06-12','15:40:00',6.88),('8902','2013-06-12','15:45:00',6.79),('8902','2013-06-12','15:50:00',6.69),('8902','2013-06-12','15:55:00',6.62),('8902','2013-06-12','16:00:00',6.5),('8902','2013-06-12','16:05:00',6.39),('8902','2013-06-12','16:10:00',6.28),('8902','2013-06-12','16:15:00',6.22),('8902','2013-06-12','16:20:00',6.08),('8902','2013-06-12','16:25:00',5.95),('8902','2013-06-12','16:30:00',5.83),('8902','2013-06-12','16:35:00',5.63),('8902','2013-06-12','16:40:00',5.48),('8902','2013-06-12','16:45:00',5.45),('8902','2013-06-12','16:50:00',5.24),('8902','2013-06-12','16:55:00',4.99),('8902','2013-06-12','17:00:00',5),('8902','2013-06-12','17:05:00',4.86),('8902','2013-06-12','17:10:00',4.74),('8902','2013-06-12','17:15:00',4.64),('8902','2013-06-12','17:20:00',4.48),('8902','2013-06-12','17:25:00',4.31),('8902','2013-06-12','17:30:00',4.22),('8902','2013-06-12','17:35:00',4.07),('8902','2013-06-12','17:40:00',3.85),('8902','2013-06-12','17:45:00',3.76),('8902','2013-06-12','17:50:00',3.61),('8902','2013-06-12','17:55:00',3.32),('8902','2013-06-12','18:00:00',3.22),('8902','2013-06-12','18:05:00',3.07),('8902','2013-06-12','18:10:00',2.85),('8902','2013-06-12','18:15:00',2.76),('8902','2013-06-12','18:20:00',2.58),('8902','2013-06-12','18:25:00',2.44),('8902','2013-06-12','18:30:00',2.26),('8902','2013-06-12','18:35:00',2.06),('8902','2013-06-12','18:40:00',1.87),('8902','2013-06-12','18:45:00',1.72),('8902','2013-06-12','18:50:00',1.59),('8902','2013-06-12','18:55:00',1.4),('8902','2013-06-12','19:00:00',1.26),('8902','2013-06-12','19:05:00',1.1),('8902','2013-06-11','07:20:00',1.11),('8902','2013-06-11','07:25:00',1.26),('8902','2013-06-11','07:30:00',1.4),('8902','2013-06-11','07:35:00',1.54),('8902','2013-06-11','07:40:00',1.69),('8902','2013-06-11','07:45:00',1.84),('8902','2013-06-11','07:50:00',1.99),('8902','2013-06-11','07:55:00',2.16),('8902','2013-06-11','08:00:00',2.34),('8902','2013-06-11','08:05:00',2.51),('8902','2013-06-11','08:10:00',2.68),('8902','2013-06-11','08:15:00',2.84),('8902','2013-06-11','08:20:00',3),('8902','2013-06-11','08:25:00',3.17),('8902','2013-06-11','08:30:00',3.33),('8902','2013-06-11','08:35:00',3.5),('8902','2013-06-11','08:40:00',3.66),('8902','2013-06-11','08:45:00',3.83),('8902','2013-06-11','08:50:00',3.98),('8902','2013-06-11','08:55:00',4.13),('8902','2013-06-11','09:00:00',4.27),('8902','2013-06-11','09:05:00',4.44),('8902','2013-06-11','09:10:00',4.59),('8902','2013-06-11','09:15:00',4.73),('8902','2013-06-11','09:20:00',4.88),('8902','2013-06-11','09:25:00',5.01),('8902','2013-06-11','09:30:00',5.13),('8902','2013-06-11','09:35:00',5.26),('8902','2013-06-11','09:40:00',5.39),('8902','2013-06-11','09:45:00',5.52),('8902','2013-06-11','09:50:00',5.65),('8902','2013-06-11','09:55:00',5.77),('8902','2013-06-11','10:00:00',5.84),('8902','2013-06-11','10:05:00',5.95),('8902','2013-06-11','10:10:00',6.06),('8902','2013-06-11','10:15:00',6.15),('8902','2013-06-11','10:20:00',6.28),('8902','2013-06-11','10:25:00',6.38),('8902','2013-06-11','10:30:00',6.44),('8902','2013-06-11','10:35:00',6.47),('8902','2013-06-11','10:40:00',6.59),('8902','2013-06-11','10:45:00',6.72),('8902','2013-06-11','10:50:00',6.84),('8902','2013-06-11','10:55:00',6.97),('8902','2013-06-11','11:00:00',7.12),('8902','2013-06-11','11:05:00',7.15),('8902','2013-06-11','11:10:00',7.23),('8902','2013-06-11','11:15:00',7.31),('8902','2013-06-11','11:20:00',7.35),('8902','2013-06-11','11:25:00',7.4),('8902','2013-06-11','11:30:00',7.46),('8902','2013-06-11','11:35:00',7.49),('8902','2013-06-11','11:40:00',7.58),('8902','2013-06-11','11:45:00',7.57),('8902','2013-06-11','11:50:00',7.63),('8902','2013-06-11','11:55:00',7.8),('8902','2013-06-11','12:00:00',7.78),('8902','2013-06-11','12:05:00',7.9),('8902','2013-06-11','12:10:00',7.83),('8902','2013-06-11','12:15:00',7.91),('8902','2013-06-11','12:20:00',7.98),('8902','2013-06-11','12:25:00',7.8),('8902','2013-06-11','12:30:00',8.53),('8902','2013-06-11','12:35:00',8.43),('8902','2013-06-11','12:40:00',2.77),('8902','2013-06-11','12:45:00',6.08),('8902','2013-06-11','12:50:00',8.71),('8902','2013-06-11','12:55:00',8.25),('8902','2013-06-11','13:00:00',7.72),('8902','2013-06-11','13:05:00',7.47),('8902','2013-06-11','13:10:00',8.21),('8902','2013-06-11','13:15:00',8.07),('8902','2013-06-11','13:20:00',7.98),('8902','2013-06-11','13:25:00',7.96),('8902','2013-06-11','13:30:00',8.01),('8902','2013-06-11','13:35:00',8.06),('8902','2013-06-11','13:40:00',8.07),('8902','2013-06-11','13:45:00',8.17),('8902','2013-06-11','13:50:00',8.13),('8902','2013-06-11','13:55:00',8.23),('8902','2013-06-11','14:00:00',8.32),('8902','2013-06-11','14:05:00',6.26),('8902','2013-06-11','14:10:00',7.69),('8902','2013-06-11','14:15:00',7.77),('8902','2013-06-11','14:20:00',4.36),('8902','2013-06-11','14:25:00',2.13),('8902','2013-06-11','14:30:00',8.67),('8902','2013-06-11','14:35:00',8.21),('8902','2013-06-11','14:40:00',7.78),('8902','2013-06-11','14:45:00',8),('8902','2013-06-11','14:50:00',8.15),('8902','2013-06-11','14:55:00',8.29),('8902','2013-06-11','15:00:00',8.22),('8902','2013-06-11','15:05:00',7.89),('8902','2013-06-11','15:10:00',7.83),('8902','2013-06-11','15:15:00',6.84),('8902','2013-06-11','15:20:00',7.67),('8902','2013-06-11','15:25:00',7.32),('8902','2013-06-11','15:30:00',7.32),('8902','2013-06-11','15:35:00',7.25),('8902','2013-06-11','15:40:00',7.17),('8902','2013-06-11','15:45:00',7.13),('8902','2013-06-11','15:50:00',6.94),('8902','2013-06-11','15:55:00',6.95),('8902','2013-06-11','16:00:00',6.72),('8902','2013-06-11','16:05:00',6.11),('8902','2013-06-11','16:10:00',6.61),('8902','2013-06-11','16:15:00',6.47),('8902','2013-06-11','16:20:00',6.26),('8902','2013-06-11','16:25:00',6.2),('8902','2013-06-11','16:30:00',6.07),('8902','2013-06-11','16:35:00',5.87),('8902','2013-06-11','16:40:00',5.72),('8902','2013-06-11','16:45:00',4.91),('8902','2013-06-11','16:50:00',5.5),('8902','2013-06-11','16:55:00',5.29),('8902','2013-06-11','17:00:00',5.15),('8902','2013-06-11','17:05:00',5.08),('8902','2013-06-11','17:10:00',4.98),('8902','2013-06-11','17:15:00',4.85),('8902','2013-06-11','17:20:00',4.65),('8902','2013-06-11','17:25:00',4.42),('8902','2013-06-11','17:30:00',4.33),('8902','2013-06-11','17:35:00',4.23),('8902','2013-06-11','17:40:00',4.09),('8902','2013-06-11','17:45:00',3.89),('8902','2013-06-11','17:50:00',2.46),('8902','2013-06-11','17:55:00',1.2),('8902','2013-06-11','18:00:00',1.54),('8902','2013-06-11','18:05:00',3.33),('8902','2013-06-11','18:10:00',3.05),('8902','2013-06-11','18:15:00',2.92),('8902','2013-06-11','18:20:00',2.7),('8902','2013-06-11','18:25:00',2.42),('8902','2013-06-11','18:30:00',2.26),('8902','2013-06-11','18:35:00',2.09),('8902','2013-06-11','18:40:00',1.92),('8902','2013-06-11','18:45:00',1.75),('8902','2013-06-11','18:50:00',1.61),('8902','2013-06-11','18:55:00',1.45),('8902','2013-06-11','19:00:00',1.33),('8902','2013-06-11','19:05:00',1.17),('8902','2013-06-10','07:20:00',1.21),('8902','2013-06-10','07:25:00',1.52),('8902','2013-06-10','07:30:00',1.34),('8902','2013-06-10','07:35:00',1.53),('8902','2013-06-10','07:40:00',1.67),('8902','2013-06-10','07:45:00',1.64),('8902','2013-06-10','07:50:00',1.73),('8902','2013-06-10','07:55:00',1.12),('8902','2013-06-10','08:00:00',1.73),('8902','2013-06-10','08:05:00',2.84),('8902','2013-06-10','08:10:00',3.03),('8902','2013-06-10','08:15:00',3.36),('8902','2013-06-10','08:20:00',1.66),('8902','2013-06-10','08:25:00',1.28),('8902','2013-06-10','08:30:00',2.28),('8902','2013-06-10','08:40:00',2.44),('8902','2013-06-10','08:45:00',3.49),('8902','2013-06-10','08:50:00',4.42),('8902','2013-06-10','08:55:00',4.7),('8902','2013-06-10','09:00:00',3.37),('8902','2013-06-10','09:05:00',2.59),('8902','2013-06-10','09:10:00',2.78),('8902','2013-06-10','09:15:00',4.2),('8902','2013-06-10','09:20:00',5.18),('8902','2013-06-10','09:25:00',5.65),('8902','2013-06-10','09:30:00',5.05),('8902','2013-06-10','09:35:00',5.67),('8902','2013-06-10','09:40:00',1.86),('8902','2013-06-10','09:45:00',1.36),('8902','2013-06-10','09:50:00',3.25),('8902','2013-06-10','09:55:00',6.34),('8902','2013-06-10','10:00:00',6.4),('8902','2013-06-10','10:05:00',5.59),('8902','2013-06-10','10:10:00',6.07),('8902','2013-06-10','10:15:00',6.35),('8902','2013-06-10','10:20:00',6.6),('8902','2013-06-10','10:25:00',6.7),('8902','2013-06-10','10:30:00',5.41),('8902','2013-06-10','10:35:00',6.83),('8902','2013-06-10','10:40:00',6.94),('8902','2013-06-10','10:45:00',6.32),('8902','2013-06-10','10:50:00',7.11),('8902','2013-06-10','10:55:00',5),('8902','2013-06-10','11:00:00',4.09),('8902','2013-06-10','11:05:00',7.8),('8902','2013-06-10','11:10:00',3.74),('8902','2013-06-10','11:15:00',5.22),('8902','2013-06-10','11:20:00',7.67),('8902','2013-06-10','11:25:00',7.66),('8902','2013-06-10','11:30:00',7.76),('8902','2013-06-10','11:35:00',7.6),('8902','2013-06-10','11:40:00',7.68),('8902','2013-06-10','11:45:00',7.73),('8902','2013-06-10','11:50:00',7.87),('8902','2013-06-10','11:55:00',7.93),('8902','2013-06-10','12:00:00',8.06),('8902','2013-06-10','12:05:00',8.26),('8902','2013-06-10','12:10:00',8.11),('8902','2013-06-10','12:15:00',8.02),('8902','2013-06-10','12:20:00',8.1),('8902','2013-06-10','12:25:00',8.12),('8902','2013-06-10','12:30:00',8.13),('8902','2013-06-10','12:35:00',8.11),('8902','2013-06-10','12:40:00',8.2),('8902','2013-06-10','12:45:00',8.24),('8902','2013-06-10','12:50:00',8.31),('8902','2013-06-10','12:55:00',8.38),('8902','2013-06-10','13:00:00',8.32),('8902','2013-06-10','13:05:00',8.35),('8902','2013-06-10','13:10:00',8.35),('8902','2013-06-10','13:15:00',7.84),('8902','2013-06-10','13:20:00',8.39),('8902','2013-06-10','13:25:00',8.35),('8902','2013-06-10','13:30:00',8.37),('8902','2013-06-10','13:35:00',8.41),('8902','2013-06-10','13:40:00',8.47),('8902','2013-06-10','13:45:00',8.43),('8902','2013-06-10','13:50:00',6.18),('8902','2013-06-10','13:55:00',8.13),('8902','2013-06-10','14:00:00',8.49),('8902','2013-06-10','14:05:00',8.38),('8902','2013-06-10','14:10:00',8.24),('8902','2013-06-10','14:15:00',8.17),('8902','2013-06-10','14:20:00',8.11),('8902','2013-06-10','14:25:00',8.13),('8902','2013-06-10','14:30:00',8.12),('8902','2013-06-10','14:35:00',8.07),('8902','2013-06-10','14:40:00',7.98),('8902','2013-06-10','14:45:00',7.93),('8902','2013-06-10','14:50:00',7.82),('8902','2013-06-10','14:55:00',7.77),('8902','2013-06-10','15:00:00',7.77),('8902','2013-06-10','15:05:00',7.72),('8902','2013-06-10','15:10:00',7.65),('8902','2013-06-10','15:15:00',7.55),('8902','2013-06-10','15:20:00',7.54),('8902','2013-06-10','15:25:00',7.4),('8902','2013-06-10','15:30:00',7.35),('8902','2013-06-10','15:35:00',7.38),('8902','2013-06-10','15:40:00',7.31),('8902','2013-06-10','15:45:00',7.2),('8902','2013-06-10','15:50:00',7.06),('8902','2013-06-10','15:55:00',6.88),('8902','2013-06-10','16:00:00',6.94),('8902','2013-06-10','16:05:00',6.83),('8902','2013-06-10','16:10:00',6.72),('8902','2013-06-10','16:15:00',6.59),('8902','2013-06-10','16:20:00',6.45),('8902','2013-06-10','16:25:00',6.29),('8902','2013-06-10','16:30:00',6.19),('8902','2013-06-10','16:35:00',6.01),('8902','2013-06-10','16:40:00',6.1),('8902','2013-06-10','16:45:00',6.33),('8902','2013-06-10','16:50:00',6.36),('8902','2013-06-10','16:55:00',6.03),('8902','2013-06-10','17:00:00',5.72),('8902','2013-06-10','17:05:00',4.32),('8902','2013-06-10','17:10:00',1.86),('8902','2013-06-10','17:15:00',1.25),('8902','2013-06-10','19:30:00',1.06),('8902','2014-04-02','08:10:00',1.02),('8902','2014-04-02','08:15:00',1.07),('8902','2014-04-02','08:20:00',1.13),('8902','2014-04-02','08:25:00',1.19),('8902','2014-04-02','08:30:00',1.28),('8902','2014-04-02','08:35:00',1.36),('8902','2014-04-02','08:40:00',1.49),('8902','2014-04-02','08:45:00',1.72),('8902','2014-04-02','08:50:00',1.78),('8902','2014-04-02','08:55:00',2.02),('8902','2014-04-02','09:00:00',2.23),('8902','2014-04-02','09:05:00',2.44),('8902','2014-04-02','09:10:00',2.39),('8902','2014-04-02','09:15:00',2.21),('8902','2014-04-02','09:20:00',2.22),('8902','2014-04-02','09:25:00',2.38),('8902','2014-04-02','09:30:00',2.74),('8902','2014-04-02','09:35:00',3.31),('8902','2014-04-02','09:40:00',3.56),('8902','2014-04-02','09:45:00',3.48),('8902','2014-04-02','09:50:00',3.32),('8902','2014-04-02','09:55:00',3.41),('8902','2014-04-02','10:00:00',4.06),('8902','2014-04-02','10:05:00',4.77),('8902','2014-04-02','10:10:00',5.11),('8902','2014-04-02','10:15:00',5.78),('8902','2014-04-02','10:20:00',6),('8902','2014-04-02','10:25:00',5.34),('8902','2014-04-02','10:30:00',4.94),('8902','2014-04-02','10:35:00',5.42),('8902','2014-04-02','10:40:00',4.39),('8902','2014-04-02','10:45:00',4.6),('8902','2014-04-02','10:50:00',3.89),('8902','2014-04-02','10:55:00',4.09),('8902','2014-04-02','11:00:00',3.9),('8902','2014-04-02','11:05:00',3.21),('8902','2014-04-02','11:10:00',3.03),('8902','2014-04-02','11:15:00',2.81),('8902','2014-04-02','11:20:00',2.68),('8902','2014-04-02','11:25:00',2.5),('8902','2014-04-02','11:30:00',2.49),('8902','2014-04-02','11:35:00',2.66),('8902','2014-04-02','11:40:00',2.94),('8902','2014-04-02','11:45:00',3.38),('8902','2014-04-02','11:50:00',4.16),('8902','2014-04-02','11:55:00',4.66),('8902','2014-04-02','12:00:00',4.39),('8902','2014-04-02','12:05:00',4.39),('8902','2014-04-02','12:10:00',4.24),('8902','2014-04-02','12:15:00',4.14),('8902','2014-04-02','12:20:00',4.6),('8902','2014-04-02','12:25:00',5.46),('8902','2014-04-02','12:30:00',7.53),('8902','2014-04-02','12:35:00',7.16),('8902','2014-04-02','12:40:00',8.15),('8902','2014-04-02','12:45:00',4.67),('8902','2014-04-02','12:50:00',5.16),('8902','2014-04-02','12:55:00',5.21),('8902','2014-04-02','13:00:00',5.06),('8902','2014-04-02','13:05:00',6.72),('8902','2014-04-02','13:10:00',4.47),('8902','2014-04-02','13:15:00',9.03),('8902','2014-04-02','13:20:00',6.07),('8902','2014-04-02','13:25:00',5.46),('8902','2014-04-02','13:30:00',5.5),('8902','2014-04-02','13:35:00',8.69),('8902','2014-04-02','13:40:00',8.03),('8902','2014-04-02','13:45:00',4.62),('8902','2014-04-02','13:50:00',4.03),('8902','2014-04-02','13:55:00',5.03),('8902','2014-04-02','14:00:00',7.42),('8902','2014-04-02','14:05:00',7.04),('8902','2014-04-02','14:10:00',5.29),('8902','2014-04-02','14:15:00',7.02),('8902','2014-04-02','14:20:00',7.58),('8902','2014-04-02','14:25:00',7.64),('8902','2014-04-02','14:30:00',7.71),('8902','2014-04-02','14:35:00',7.92),('8902','2014-04-02','14:40:00',7.72),('8902','2014-04-02','14:45:00',7.51),('8902','2014-04-02','14:50:00',7.36),('8902','2014-04-02','14:55:00',7.24),('8902','2014-04-02','15:00:00',7.18),('8902','2014-04-02','15:05:00',7.09),('8902','2014-04-02','15:10:00',7.08),('8902','2014-04-02','15:15:00',7.05),('8902','2014-04-02','15:20:00',7.04),('8902','2014-04-02','15:25:00',7.02),('8902','2014-04-02','15:30:00',6.93),('8902','2014-04-02','15:35:00',6.81),('8902','2014-04-02','15:40:00',6.72),('8902','2014-04-02','15:45:00',6.72),('8902','2014-04-02','15:50:00',6.63),('8902','2014-04-02','15:55:00',6.58),('8902','2014-04-02','16:00:00',6.52),('8902','2014-04-02','16:05:00',6.39),('8902','2014-04-02','16:10:00',6.37),('8902','2014-04-02','16:15:00',6.15),('8902','2014-04-02','16:20:00',6.07),('8902','2014-04-02','16:25:00',5.81),('8902','2014-04-02','16:30:00',5.71),('8902','2014-04-02','16:35:00',5.6),('8902','2014-04-02','16:40:00',5.46),('8902','2014-04-02','16:45:00',5.11),('8902','2014-04-02','16:50:00',3.96),('8902','2014-04-02','16:55:00',3.23),('8902','2014-04-02','17:00:00',2.27),('8902','2014-04-02','17:05:00',2.11),('8902','2014-04-02','17:10:00',1.85),('8902','2014-04-02','17:15:00',1.72),('8902','2014-04-02','17:20:00',1.74),('8902','2014-04-02','17:25:00',1.88),('8902','2014-04-02','17:30:00',1.91),('8902','2014-04-02','17:35:00',1.17),('8902','2014-04-02','17:45:00',1.95),('8902','2014-04-02','17:50:00',3.04),('8902','2014-04-02','17:55:00',2.64),('8902','2014-04-02','18:00:00',2.42),('8902','2014-04-02','18:05:00',2.18),('8902','2014-04-02','18:10:00',1.98),('8902','2014-04-02','18:15:00',1.76),('8902','2014-04-02','18:20:00',1.54),('8902','2014-04-02','18:25:00',1.2),('8902','2013-06-09','07:10:00',1.06),('8902','2013-06-09','07:20:00',1.17),('8902','2013-06-09','07:25:00',1.17),('8902','2013-06-09','07:30:00',1.66),('8902','2013-06-09','07:35:00',2.41),('8902','2013-06-09','07:40:00',1.87),('8902','2013-06-09','07:45:00',1.37),('8902','2013-06-09','07:50:00',1.36),('8902','2013-06-09','07:55:00',1.29),('8902','2013-06-09','08:00:00',1.96),('8902','2013-06-09','08:05:00',2.37),('8902','2013-06-09','08:10:00',3.25),('8902','2013-06-09','08:15:00',2.99),('8902','2013-06-09','08:20:00',3.54),('8902','2013-06-09','08:25:00',2.44),('8902','2013-06-09','08:30:00',2.26),('8902','2013-06-09','08:35:00',1.95),('8902','2013-06-09','08:40:00',1.73),('8902','2013-06-09','08:45:00',1.79),('8902','2013-06-09','08:50:00',2.07),('8902','2013-06-09','08:55:00',1.85),('8902','2013-06-09','09:00:00',2.31),('8902','2013-06-09','09:05:00',2.15),('8902','2013-06-09','09:10:00',3.49),('8902','2013-06-09','09:15:00',1.77),('8902','2013-06-09','09:20:00',3.15),('8902','2013-06-09','09:25:00',2.78),('8902','2013-06-09','09:30:00',2.15),('8902','2013-06-09','09:35:00',6.07),('8902','2013-06-09','09:40:00',4.1),('8902','2013-06-09','09:45:00',6.04),('8902','2013-06-09','09:50:00',4.19),('8902','2013-06-09','09:55:00',3.44),('8902','2013-06-09','10:00:00',4.54),('8902','2013-06-09','10:05:00',5.3),('8902','2013-06-09','10:10:00',5.84),('8902','2013-06-09','10:15:00',6.21),('8902','2013-06-09','10:20:00',5.51),('8902','2013-06-09','10:25:00',5.74),('8902','2013-06-09','10:30:00',3.35),('8902','2013-06-09','10:35:00',3.34),('8902','2013-06-09','10:40:00',2.82),('8902','2013-06-09','10:45:00',2.39),('8902','2013-06-09','10:50:00',3.55),('8902','2013-06-09','10:55:00',4.59),('8902','2013-06-09','11:00:00',5.42),('8902','2013-06-09','11:05:00',3.53),('8902','2013-06-09','11:10:00',4.09),('8902','2013-06-09','11:15:00',7.3),('8902','2013-06-09','11:20:00',5.29),('8902','2013-06-09','11:25:00',8.11),('8902','2013-06-09','11:30:00',7.98),('8902','2013-06-09','11:35:00',8.66),('8902','2013-06-09','11:40:00',6.01),('8902','2013-06-09','11:45:00',7.55),('8902','2013-06-09','11:50:00',4.11),('8902','2013-06-09','11:55:00',4.48),('8902','2013-06-09','12:00:00',9.05),('8902','2013-06-09','12:05:00',5.06),('8902','2013-06-09','12:10:00',8.15),('8902','2013-06-09','12:15:00',8.51),('8902','2013-06-09','12:20:00',8.22),('8902','2013-06-09','12:25:00',8.23),('8902','2013-06-09','12:30:00',7.83),('8902','2013-06-09','12:35:00',6.56),('8902','2013-06-09','12:40:00',6.05),('8902','2013-06-09','12:45:00',6.85),('8902','2013-06-09','12:50:00',6.31),('8902','2013-06-09','12:55:00',3.93),('8902','2013-06-09','13:00:00',4.54),('8902','2013-06-09','13:05:00',9.14),('8902','2013-06-09','13:10:00',6.1),('8902','2013-06-09','13:15:00',5.68),('8902','2013-06-09','13:20:00',6.49),('8902','2013-06-09','13:25:00',4.99),('8902','2013-06-09','13:30:00',5.47),('8902','2013-06-09','13:35:00',8.18),('8902','2013-06-09','13:40:00',6.9),('8902','2013-06-09','13:45:00',5.36),('8902','2013-06-09','13:50:00',4.87),('8902','2013-06-09','13:55:00',6.16),('8902','2013-06-09','14:00:00',9.07),('8902','2013-06-09','14:05:00',8.51),('8902','2013-06-09','14:10:00',8.52),('8902','2013-06-09','14:15:00',8.2),('8902','2013-06-09','14:20:00',8.16),('8902','2013-06-09','14:25:00',8.27),('8902','2013-06-09','14:30:00',8.12),('8902','2013-06-09','14:35:00',8.11),('8902','2013-06-09','14:40:00',7.01),('8902','2013-06-09','14:45:00',8.2),('8902','2013-06-09','14:50:00',7.97),('8902','2013-06-09','14:55:00',7.89),('8902','2013-06-09','15:00:00',7.81),('8902','2013-06-09','15:05:00',7.73),('8902','2013-06-09','15:10:00',7.63),('8902','2013-06-09','15:15:00',7.6),('8902','2013-06-09','15:20:00',7.58),('8902','2013-06-09','15:25:00',7.49),('8902','2013-06-09','15:30:00',7.47),('8902','2013-06-09','15:35:00',7.41),('8902','2013-06-09','15:40:00',7.35),('8902','2013-06-09','15:45:00',7.26),('8902','2013-06-09','15:50:00',7.13),('8902','2013-06-09','15:55:00',7.05),('8902','2013-06-09','16:00:00',6.92),('8902','2013-06-09','16:05:00',6.82),('8902','2013-06-09','16:10:00',6.73),('8902','2013-06-09','16:15:00',6.63),('8902','2013-06-09','16:20:00',6.48),('8902','2013-06-09','16:25:00',6.38),('8902','2013-06-09','16:30:00',6.26),('8902','2013-06-09','16:35:00',6.07),('8902','2013-06-09','16:40:00',5.96),('8902','2013-06-09','16:45:00',5.89),('8902','2013-06-09','16:50:00',5.69),('8902','2013-06-09','16:55:00',5.54),('8902','2013-06-09','17:00:00',5.45),('8902','2013-06-09','17:05:00',5.33),('8902','2013-06-09','17:10:00',5.2),('8902','2013-06-09','17:15:00',5.07),('8902','2013-06-09','17:20:00',4.89),('8902','2013-06-09','17:25:00',4.7),('8902','2013-06-09','17:30:00',4.56),('8902','2013-06-09','17:35:00',4.43),('8902','2013-06-09','17:40:00',4.23),('8902','2013-06-09','17:45:00',4.08),('8902','2013-06-09','17:50:00',3.87),('8902','2013-06-09','17:55:00',3.6),('8902','2013-06-09','18:00:00',3.56),('8902','2013-06-09','18:05:00',3.35),('8902','2013-06-09','18:10:00',3.13),('8902','2013-06-09','18:15:00',3),('8902','2013-06-09','18:20:00',2.82),('8902','2013-06-09','18:25:00',2.63),('8902','2013-06-09','18:30:00',2.43),('8902','2013-06-09','18:35:00',2.24),('8902','2013-06-09','18:40:00',2.05),('8902','2013-06-09','18:45:00',1.87),('8902','2013-06-09','18:50:00',1.71),('8902','2013-06-09','18:55:00',1.52),('8902','2013-06-09','19:00:00',1.38),('8902','2013-06-09','19:05:00',1.2),('8902','2013-06-09','19:10:00',1.01),('8902','2013-06-08','07:10:00',1.09),('8902','2013-06-08','07:25:00',1.21),('8902','2013-06-08','07:30:00',1.35),('8902','2013-06-08','07:35:00',2.3),('8902','2013-06-08','07:40:00',1.9),('8902','2013-06-08','07:50:00',1.31),('8902','2013-06-08','07:55:00',2.16),('8902','2013-06-08','08:00:00',2.23),('8902','2013-06-08','08:05:00',2.46),('8902','2013-06-08','08:10:00',2.68),('8902','2013-06-08','08:15:00',2.97),('8902','2013-06-08','08:20:00',2.93),('8902','2013-06-08','08:25:00',3),('8902','2013-06-08','08:30:00',3.14),('8902','2013-06-08','08:35:00',3.26),('8902','2013-06-08','08:40:00',3.45),('8902','2013-06-08','08:45:00',3.55),('8902','2013-06-08','08:50:00',3.72),('8902','2013-06-08','08:55:00',3.91),('8902','2013-06-08','09:00:00',4.06),('8902','2013-06-08','09:05:00',4.18),('8902','2013-06-08','09:10:00',4.39),('8902','2013-06-08','09:15:00',4.52),('8902','2013-06-08','09:20:00',4.59),('8902','2013-06-08','09:25:00',4.75),('8902','2013-06-08','09:30:00',4.83),('8902','2013-06-08','09:35:00',5),('8902','2013-06-08','09:40:00',5.16),('8902','2013-06-08','09:45:00',5.26),('8902','2013-06-08','09:50:00',5.38),('8902','2013-06-08','09:55:00',5.52),('8902','2013-06-08','10:00:00',5.64),('8902','2013-06-08','10:05:00',5.73),('8902','2013-06-08','10:10:00',5.85),('8902','2013-06-08','10:15:00',5.94),('8902','2013-06-08','10:20:00',5.98),('8902','2013-06-08','10:25:00',6.05),('8902','2013-06-08','10:30:00',6.23),('8902','2013-06-08','10:35:00',6.34),('8902','2013-06-08','10:40:00',6.39),('8902','2013-06-08','10:45:00',6.46),('8902','2013-06-08','10:50:00',6.55),('8902','2013-06-08','10:55:00',6.66),('8902','2013-06-08','11:00:00',6.73),('8902','2013-06-08','11:05:00',6.77),('8902','2013-06-08','11:10:00',6.74),('8902','2013-06-08','11:15:00',6.85),('8902','2013-06-08','11:20:00',7.03),('8902','2013-06-08','11:25:00',6.99),('8902','2013-06-08','11:30:00',7.06),('8902','2013-06-08','11:35:00',7.06),('8902','2013-06-08','11:40:00',7.1),('8902','2013-06-08','11:45:00',7.28),('8902','2013-06-08','11:50:00',7.39),('8902','2013-06-08','11:55:00',7.36),('8902','2013-06-08','12:00:00',7.38),('8902','2013-06-08','12:05:00',7.46),('8902','2013-06-08','12:10:00',7.24),('8902','2013-06-08','12:15:00',7.22),('8902','2013-06-08','12:20:00',7.52),('8902','2013-06-08','12:25:00',7.48),('8902','2013-06-08','12:30:00',7.5),('8902','2013-06-08','12:35:00',7.55),('8902','2013-06-08','12:40:00',7.7),('8902','2013-06-08','12:45:00',7.66),('8902','2013-06-08','12:50:00',7.87),('8902','2013-06-08','12:55:00',7.53),('8902','2013-06-08','13:00:00',7.3),('8902','2013-06-08','13:05:00',8.24),('8902','2013-06-08','13:10:00',5.96),('8902','2013-06-08','13:15:00',4.22),('8902','2013-06-08','13:20:00',7.96),('8902','2013-06-08','13:25:00',7.6),('8902','2013-06-08','13:30:00',8.01),('8902','2013-06-08','13:35:00',8.05),('8902','2013-06-08','13:40:00',8.26),('8902','2013-06-08','13:45:00',8.34),('8902','2013-06-08','13:50:00',8.68),('8902','2013-06-08','13:55:00',8.97),('8902','2013-06-08','14:00:00',5.76),('8902','2013-06-08','14:05:00',8.47),('8902','2013-06-08','14:10:00',8.48),('8902','2013-06-08','14:15:00',5.7),('8902','2013-06-08','14:20:00',3.92),('8902','2013-06-08','14:25:00',2.25),('8902','2013-06-08','14:30:00',2.76),('8902','2013-06-08','14:35:00',6.96),('8902','2013-06-08','14:40:00',6.25),('8902','2013-06-08','14:45:00',7.59),('8902','2013-06-08','14:50:00',7.51),('8902','2013-06-08','14:55:00',7.63),('8902','2013-06-08','15:00:00',7.58),('8902','2013-06-08','15:05:00',7.24),('8902','2013-06-08','15:10:00',7.31),('8902','2013-06-08','15:15:00',7.01),('8902','2013-06-08','15:20:00',7.08),('8902','2013-06-08','15:25:00',7.16),('8902','2013-06-08','15:30:00',6.61),('8902','2013-06-08','15:35:00',6.88),('8902','2013-06-08','15:40:00',5.65),('8902','2013-06-08','15:45:00',5.83),('8902','2013-06-08','15:50:00',6.27),('8902','2013-06-08','15:55:00',6.98),('8902','2013-06-08','16:00:00',5.04),('8902','2013-06-08','16:05:00',6.27),('8902','2013-06-08','16:10:00',5.98),('8902','2013-06-08','16:15:00',3.71),('8902','2013-06-08','16:20:00',2.8),('8902','2013-06-08','16:25:00',4.1),('8902','2013-06-08','16:30:00',2.7),('8902','2013-06-08','16:35:00',1.84),('8902','2013-06-08','16:40:00',1.73),('8902','2013-06-08','16:45:00',1.71),('8902','2013-06-08','16:50:00',1.68),('8902','2013-06-08','16:55:00',1.55),('8902','2013-06-08','17:00:00',1.63),('8902','2013-06-08','17:05:00',1.88),('8902','2013-06-08','17:10:00',1.81),('8902','2013-06-08','17:15:00',1.46),('8902','2013-06-08','17:20:00',1.62),('8902','2013-06-08','17:25:00',1.24),('8902','2013-06-08','17:30:00',1.02),('8902','2013-06-08','17:35:00',1.17),('8902','2013-06-08','17:40:00',1.39),('8902','2013-06-08','17:45:00',1.26),('8902','2013-06-08','17:55:00',1.02),('8902','2013-06-08','18:00:00',1.78),('8902','2013-06-08','18:05:00',1.56),('8902','2013-06-08','18:10:00',1.91),('8902','2013-06-08','18:15:00',1.93),('8902','2013-06-08','18:20:00',2.07),('8902','2013-06-08','18:30:00',1.73),('8902','2013-06-08','18:35:00',1.13),('8902','2013-06-08','18:45:00',1.01),('8902','2013-06-08','18:50:00',1.16),('8902','2013-06-07','07:20:00',1.07),('8902','2013-06-07','07:25:00',1.2),('8902','2013-06-07','07:30:00',1.34),('8902','2013-06-07','07:35:00',1.48),('8902','2013-06-07','07:40:00',1.63),('8902','2013-06-07','07:45:00',1.78),('8902','2013-06-07','07:50:00',1.93),('8902','2013-06-07','07:55:00',2.08),('8902','2013-06-07','08:00:00',2.23),('8902','2013-06-07','08:05:00',2.38),('8902','2013-06-07','08:10:00',2.54),('8902','2013-06-07','08:15:00',2.7),('8902','2013-06-07','08:20:00',2.86),('8902','2013-06-07','08:25:00',3.03),('8902','2013-06-07','08:30:00',3.19),('8902','2013-06-07','08:35:00',3.33),('8902','2013-06-07','08:40:00',3.5),('8902','2013-06-07','08:45:00',3.65),('8902','2013-06-07','08:50:00',3.81),('8902','2013-06-07','08:55:00',3.95),('8902','2013-06-07','09:00:00',4.12),('8902','2013-06-07','09:05:00',4.25),('8902','2013-06-07','09:10:00',4.34),('8902','2013-06-07','09:15:00',4.45),('8902','2013-06-07','09:20:00',4.65),('8902','2013-06-07','09:25:00',4.85),('8902','2013-06-07','09:30:00',4.96),('8902','2013-06-07','09:35:00',5.02),('8902','2013-06-07','09:40:00',5.11),('8902','2013-06-07','09:45:00',5.24),('8902','2013-06-07','09:50:00',5.23),('8902','2013-06-07','09:55:00',5.44),('8902','2013-06-07','10:00:00',5.7),('8902','2013-06-07','10:05:00',5.78),('8902','2013-06-07','10:10:00',4.21),('8902','2013-06-07','10:15:00',5.55),('8902','2013-06-07','10:20:00',6.07),('8902','2013-06-07','10:25:00',6.23),('8902','2013-06-07','10:30:00',6.44),('8902','2013-06-07','10:35:00',6.43),('8902','2013-06-07','10:40:00',6.58),('8902','2013-06-07','10:45:00',6.7),('8902','2013-06-07','10:50:00',6.7),('8902','2013-06-07','10:55:00',2.94),('8902','2013-06-07','11:00:00',3.91),('8902','2013-06-07','11:05:00',2.73),('8902','2013-06-07','11:10:00',7.66),('8902','2013-06-07','11:15:00',6.59),('8902','2013-06-07','11:20:00',7.84),('8902','2013-06-07','11:25:00',7.94),('8902','2013-06-07','11:30:00',7.83),('8902','2013-06-07','11:35:00',7.41),('8902','2013-06-07','11:40:00',7.89),('8902','2013-06-07','11:45:00',7.55),('8902','2013-06-07','11:50:00',7.82),('8902','2013-06-07','11:55:00',8),('8902','2013-06-07','12:00:00',5.07),('8902','2013-06-07','12:05:00',4.17),('8902','2013-06-07','12:10:00',1.78),('8902','2013-06-07','12:15:00',4.63),('8902','2013-06-07','12:20:00',8.17),('8902','2013-06-07','12:25:00',1.85),('8902','2013-06-07','12:30:00',2.75),('8902','2013-06-07','12:35:00',5.72),('8902','2013-06-07','12:40:00',8.37),('8902','2013-06-07','12:45:00',8.32),('8902','2013-06-07','12:50:00',2.32),('8902','2013-06-07','12:55:00',6.54),('8902','2013-06-07','13:00:00',8.54),('8902','2013-06-07','13:05:00',8.47),('8902','2013-06-07','13:10:00',7.91),('8902','2013-06-07','13:15:00',8.47),('8902','2013-06-07','13:20:00',5.62),('8902','2013-06-07','13:25:00',8.51),('8902','2013-06-07','13:30:00',8.54),('8902','2013-06-07','13:35:00',8.38),('8902','2013-06-07','13:40:00',8.3),('8902','2013-06-07','13:45:00',8.22),('8902','2013-06-07','13:50:00',8.15),('8902','2013-06-07','13:55:00',8.15),('8902','2013-06-07','14:00:00',8.04),('8902','2013-06-07','14:05:00',8.04),('8902','2013-06-07','14:10:00',8.05),('8902','2013-06-07','14:15:00',8.06),('8902','2013-06-07','14:20:00',7.97),('8902','2013-06-07','14:25:00',7.93),('8902','2013-06-07','14:30:00',7.9),('8902','2013-06-07','14:35:00',7.82),('8902','2013-06-07','14:40:00',7.84),('8902','2013-06-07','14:45:00',7.83),('8902','2013-06-07','14:50:00',7.82),('8902','2013-06-07','14:55:00',7.76),('8902','2013-06-07','15:00:00',7.73),('8902','2013-06-07','15:05:00',7.42),('8902','2013-06-07','15:10:00',7.01),('8902','2013-06-07','15:15:00',7.19),('8902','2013-06-07','15:20:00',7.53),('8902','2013-06-07','15:25:00',7.1),('8902','2013-06-07','15:30:00',7.1),('8902','2013-06-07','15:35:00',7.53),('8902','2013-06-07','15:40:00',7.29),('8902','2013-06-07','15:45:00',7.48),('8902','2013-06-07','15:50:00',7.36),('8902','2013-06-07','15:55:00',6.94),('8902','2013-06-07','16:00:00',6.93),('8902','2013-06-07','16:05:00',6.83),('8902','2013-06-07','16:10:00',6.68),('8902','2013-06-07','16:15:00',6.74),('8902','2013-06-07','16:20:00',6.63),('8902','2013-06-07','16:25:00',6.33),('8902','2013-06-07','16:30:00',6.01),('8902','2013-06-07','16:35:00',5.81),('8902','2013-06-07','16:40:00',5.76),('8902','2013-06-07','16:45:00',5.66),('8902','2013-06-07','16:50:00',4.8),('8902','2013-06-07','16:55:00',4.77),('8902','2013-06-07','17:00:00',5.24),('8902','2013-06-07','17:05:00',4.41),('8902','2013-06-07','17:10:00',5.38),('8902','2013-06-07','17:15:00',5.36),('8902','2013-06-07','17:20:00',4.96),('8902','2013-06-07','17:25:00',4.62),('8902','2013-06-07','17:30:00',3.34),('8902','2013-06-07','17:35:00',2.31),('8902','2013-06-07','17:40:00',3.58),('8902','2013-06-07','17:45:00',4.09),('8902','2013-06-07','17:50:00',3.57),('8902','2013-06-07','17:55:00',3.68),('8902','2013-06-07','18:00:00',2.99),('8902','2013-06-07','18:05:00',2.81),('8902','2013-06-07','18:10:00',2.22),('8902','2013-06-07','18:15:00',2.21),('8902','2013-06-07','18:20:00',2.21),('8902','2013-06-07','18:25:00',1.79),('8902','2013-06-07','18:30:00',1.23),('8902','2013-06-07','18:35:00',1.07),('8902','2013-06-06','07:20:00',1.04),('8902','2013-06-06','07:25:00',1.19),('8902','2013-06-06','07:30:00',1.34),('8902','2013-06-06','07:35:00',1.5),('8902','2013-06-06','07:40:00',1.66),('8902','2013-06-06','07:45:00',1.83),('8902','2013-06-06','07:50:00',1.99),('8902','2013-06-06','07:55:00',2.16),('8902','2013-06-06','08:00:00',2.33),('8902','2013-06-06','08:05:00',2.51),('8902','2013-06-06','08:10:00',2.68),('8902','2013-06-06','08:15:00',2.84),('8902','2013-06-06','08:20:00',3.02),('8902','2013-06-06','08:25:00',3.2),('8902','2013-06-06','08:30:00',3.36),('8902','2013-06-06','08:35:00',3.53),('8902','2013-06-06','08:40:00',3.7),('8902','2013-06-06','08:45:00',3.88),('8902','2013-06-06','08:50:00',4.03),('8902','2013-06-06','08:55:00',4.2),('8902','2013-06-06','09:00:00',4.35),('8902','2013-06-06','09:05:00',4.49),('8902','2013-06-06','09:10:00',4.63),('8902','2013-06-06','09:15:00',4.79),('8902','2013-06-06','09:20:00',4.94),('8902','2013-06-06','09:25:00',5.09),('8902','2013-06-06','09:30:00',5.24),('8902','2013-06-06','09:35:00',5.36),('8902','2013-06-06','09:40:00',5.51),('8902','2013-06-06','09:45:00',5.68),('8902','2013-06-06','09:50:00',5.79),('8902','2013-06-06','09:55:00',5.9),('8902','2013-06-06','10:00:00',6.01),('8902','2013-06-06','10:05:00',6.11),('8902','2013-06-06','10:10:00',6.21),('8902','2013-06-06','10:15:00',6.33),('8902','2013-06-06','10:20:00',6.44),('8902','2013-06-06','10:25:00',6.55),('8902','2013-06-06','10:30:00',6.64),('8902','2013-06-06','10:35:00',6.72),('8902','2013-06-06','10:40:00',6.84),('8902','2013-06-06','10:45:00',6.92),('8902','2013-06-06','10:50:00',6.99),('8902','2013-06-06','10:55:00',7.05),('8902','2013-06-06','11:00:00',7.13),('8902','2013-06-06','11:05:00',7.23),('8902','2013-06-06','11:10:00',7.33),('8902','2013-06-06','11:15:00',7.36),('8902','2013-06-06','11:20:00',7.39),('8902','2013-06-06','11:25:00',7.45),('8902','2013-06-06','11:30:00',7.56),('8902','2013-06-06','11:35:00',7.62),('8902','2013-06-06','11:40:00',7.67),('8902','2013-06-06','11:45:00',7.69),('8902','2013-06-06','11:50:00',7.75),('8902','2013-06-06','11:55:00',7.8),('8902','2013-06-06','12:00:00',7.83),('8902','2013-06-06','12:05:00',7.87),('8902','2013-06-06','12:10:00',7.94),('8902','2013-06-06','12:15:00',8),('8902','2013-06-06','12:20:00',8.02),('8902','2013-06-06','12:25:00',7.99),('8902','2013-06-06','12:30:00',7.99),('8902','2013-06-06','12:35:00',7.95),('8902','2013-06-06','12:40:00',8.02),('8902','2013-06-06','12:45:00',8.07),('8902','2013-06-06','12:50:00',8.08),('8902','2013-06-06','12:55:00',8.13),('8902','2013-06-06','13:00:00',8.19),('8902','2013-06-06','13:05:00',8.14),('8902','2013-06-06','13:10:00',8.14),('8902','2013-06-06','13:15:00',8.16),('8902','2013-06-06','13:20:00',8.12),('8902','2013-06-06','13:25:00',8.13),('8902','2013-06-06','13:30:00',8.1),('8902','2013-06-06','13:35:00',8.05),('8902','2013-06-06','13:40:00',8.03),('8902','2013-06-06','13:45:00',7.96),('8902','2013-06-06','13:50:00',7.95),('8902','2013-06-06','13:55:00',7.95),('8902','2013-06-06','14:00:00',7.88),('8902','2013-06-06','14:05:00',7.85),('8902','2013-06-06','14:10:00',7.81),('8902','2013-06-06','14:15:00',7.8),('8902','2013-06-06','14:20:00',7.71),('8902','2013-06-06','14:25:00',7.63),('8902','2013-06-06','14:30:00',7.59),('8902','2013-06-06','14:35:00',7.56),('8902','2013-06-06','14:40:00',7.56),('8902','2013-06-06','14:45:00',7.53),('8902','2013-06-06','14:50:00',7.52),('8902','2013-06-06','14:55:00',7.48),('8902','2013-06-06','15:00:00',7.46),('8902','2013-06-06','15:05:00',7.46),('8902','2013-06-06','15:10:00',7.44),('8902','2013-06-06','15:15:00',7.31),('8902','2013-06-06','15:20:00',7.21),('8902','2013-06-06','15:25:00',7.25),('8902','2013-06-06','15:30:00',7.24),('8902','2013-06-06','15:35:00',7.12),('8902','2013-06-06','15:40:00',7.01),('8902','2013-06-06','15:45:00',6.92),('8902','2013-06-06','15:50:00',6.82),('8902','2013-06-06','15:55:00',6.72),('8902','2013-06-06','16:00:00',6.69),('8902','2013-06-06','16:05:00',6.54),('8902','2013-06-06','16:10:00',6.3),('8902','2013-06-06','16:15:00',5.97),('8902','2013-06-06','16:20:00',5.96),('8902','2013-06-06','16:25:00',5.99),('8902','2013-06-06','16:30:00',5.99),('8902','2013-06-06','16:35:00',5.73),('8902','2013-06-06','16:40:00',5.72),('8902','2013-06-06','16:45:00',5.62),('8902','2013-06-06','16:50:00',5.43),('8902','2013-06-06','16:55:00',5.35),('8902','2013-06-06','17:00:00',5.23),('8902','2013-06-06','17:05:00',5.05),('8902','2013-06-06','17:10:00',4.88),('8902','2013-06-06','17:15:00',4.71),('8902','2013-06-06','17:20:00',4.41),('8902','2013-06-06','17:25:00',4.36),('8902','2013-06-06','17:30:00',4.21),('8902','2013-06-06','17:35:00',4.08),('8902','2013-06-06','17:40:00',3.96),('8902','2013-06-06','17:45:00',3.95),('8902','2013-06-06','17:50:00',3.75),('8902','2013-06-06','17:55:00',3.4),('8902','2013-06-06','18:00:00',3.32),('8902','2013-06-06','18:05:00',3.19),('8902','2013-06-06','18:10:00',3.01),('8902','2013-06-06','18:15:00',2.81),('8902','2013-06-06','18:20:00',2.57),('8902','2013-06-06','18:25:00',2.34),('8902','2013-06-06','18:30:00',2.14),('8902','2013-06-06','18:35:00',1.96),('8902','2013-06-06','18:40:00',1.82),('8902','2013-06-06','18:45:00',1.64),('8902','2013-06-06','18:50:00',1.49),('8902','2013-06-06','18:55:00',1.37),('8902','2013-06-06','19:00:00',1.22),('8902','2013-06-05','07:00:00',1.27),('8902','2013-06-05','07:05:00',1.48),('8902','2013-06-05','07:10:00',1.43),('8902','2013-06-05','07:15:00',1.59),('8902','2013-06-05','07:20:00',1.16),('8902','2013-06-05','07:25:00',1.18),('8902','2013-06-05','07:30:00',1.07),('8902','2013-06-05','07:40:00',1.09),('8902','2013-06-05','07:45:00',1.15),('8902','2013-06-05','07:50:00',1.75),('8902','2013-06-05','07:55:00',2.42),('8902','2013-06-05','08:00:00',2.68),('8902','2013-06-05','08:05:00',2.03),('8902','2013-06-05','08:10:00',2.58),('8902','2013-06-05','08:15:00',2.34),('8902','2013-06-05','08:20:00',2.56),('8902','2013-06-05','08:25:00',3.21),('8902','2013-06-05','08:30:00',3.34),('8902','2013-06-05','08:35:00',3.51),('8902','2013-06-05','08:40:00',3.64),('8902','2013-06-05','08:45:00',3.77),('8902','2013-06-05','08:50:00',3.96),('8902','2013-06-05','08:55:00',4.14),('8902','2013-06-05','09:00:00',4.29),('8902','2013-06-05','09:05:00',4.4),('8902','2013-06-05','09:10:00',4.54),('8902','2013-06-05','09:15:00',4.72),('8902','2013-06-05','09:20:00',4.87),('8902','2013-06-05','09:25:00',4.93),('8902','2013-06-05','09:30:00',5.07),('8902','2013-06-05','09:35:00',5.21),('8902','2013-06-05','09:40:00',4.11),('8902','2013-06-05','09:45:00',5.4),('8902','2013-06-05','09:50:00',5.63),('8902','2013-06-05','09:55:00',5.82),('8902','2013-06-05','10:00:00',5.82),('8902','2013-06-05','10:05:00',5.95),('8902','2013-06-05','10:10:00',6.08),('8902','2013-06-05','10:15:00',6.18),('8902','2013-06-05','10:20:00',6.3),('8902','2013-06-05','10:25:00',6.43),('8902','2013-06-05','10:30:00',6.47),('8902','2013-06-05','10:35:00',6.43),('8902','2013-06-05','10:40:00',6.63),('8902','2013-06-05','10:45:00',6.77),('8902','2013-06-05','10:50:00',6.87),('8902','2013-06-05','10:55:00',6.98),('8902','2013-06-05','11:00:00',7.09),('8902','2013-06-05','11:05:00',7.15),('8902','2013-06-05','11:10:00',7.15),('8902','2013-06-05','11:15:00',7.25),('8902','2013-06-05','11:20:00',7.24),('8902','2013-06-05','11:25:00',7.35),('8902','2013-06-05','11:30:00',7.46),('8902','2013-06-05','11:35:00',7.45),('8902','2013-06-05','11:40:00',7.56),('8902','2013-06-05','11:45:00',7.46),('8902','2013-06-05','11:50:00',7.45),('8902','2013-06-05','11:55:00',7.32),('8902','2013-06-05','12:00:00',7.55),('8902','2013-06-05','12:05:00',6.2),('8902','2013-06-05','12:10:00',7.67),('8902','2013-06-05','12:15:00',7.77),('8902','2013-06-05','12:20:00',7.66),('8902','2013-06-05','12:25:00',7.84),('8902','2013-06-05','12:30:00',7.82),('8902','2013-06-05','12:35:00',7.78),('8902','2013-06-05','12:40:00',7.73),('8902','2013-06-05','12:45:00',7.7),('8902','2013-06-05','12:50:00',7.71),('8902','2013-06-05','12:55:00',7.98),('8902','2013-06-05','13:00:00',8.1),('8902','2013-06-05','13:05:00',7.93),('8902','2013-06-05','13:10:00',8.09),('8902','2013-06-05','13:15:00',8.16),('8902','2013-06-05','13:20:00',8.27),('8902','2013-06-05','13:25:00',8.23),('8902','2013-06-05','13:30:00',8.17),('8902','2013-06-05','13:35:00',8.1),('8902','2013-06-05','13:40:00',8.1),('8902','2013-06-05','13:45:00',7.38),('8902','2013-06-05','13:50:00',8.14),('8902','2013-06-05','13:55:00',8.07),('8902','2013-06-05','14:00:00',8.03),('8902','2013-06-05','14:05:00',8),('8902','2013-06-05','14:10:00',7.7),('8902','2013-06-05','14:15:00',8.07),('8902','2013-06-05','14:20:00',6.81),('8902','2013-06-05','14:25:00',3.66),('8902','2013-06-05','14:30:00',8.07),('8902','2013-06-05','14:35:00',3.97),('8902','2013-06-05','14:40:00',5.27),('8902','2013-06-05','14:45:00',6.2),('8902','2013-06-05','14:50:00',6.13),('8902','2013-06-05','14:55:00',7.98),('8902','2013-06-05','15:00:00',7.73),('8902','2013-06-05','15:05:00',7.82),('8902','2013-06-05','15:10:00',6.9),('8902','2013-06-05','15:15:00',7.7),('8902','2013-06-05','15:20:00',7.64),('8902','2013-06-05','15:25:00',7.31),('8902','2013-06-05','15:30:00',6.76),('8902','2013-06-05','15:35:00',7.13),('8902','2013-06-05','15:40:00',7.08),('8902','2013-06-05','15:45:00',7.08),('8902','2013-06-05','15:50:00',6.65),('8902','2013-06-05','15:55:00',6.62),('8902','2013-06-05','16:00:00',5.89),('8902','2013-06-05','16:05:00',5.15),('8902','2013-06-05','16:10:00',6.29),('8902','2013-06-05','16:15:00',6.17),('8902','2013-06-05','16:20:00',5.96),('8902','2013-06-05','16:25:00',5.98),('8902','2013-06-05','16:30:00',5.99),('8902','2013-06-05','16:35:00',5.86),('8902','2013-06-05','16:40:00',5.74),('8902','2013-06-05','16:45:00',5.39),('8902','2013-06-05','16:50:00',5.19),('8902','2013-06-05','16:55:00',5.19),('8902','2013-06-05','17:00:00',4.99),('8902','2013-06-05','17:05:00',4.86),('8902','2013-06-05','17:10:00',4.74),('8902','2013-06-05','17:15:00',4.65),('8902','2013-06-05','17:20:00',4.41),('8902','2013-06-05','17:25:00',4.27),('8902','2013-06-05','17:30:00',4.17),('8902','2013-06-05','17:35:00',3.97),('8902','2013-06-05','17:40:00',3.82),('8902','2013-06-05','17:45:00',3.67),('8902','2013-06-05','17:50:00',3.45),('8902','2013-06-05','17:55:00',3.17),('8902','2013-06-05','18:00:00',3.17),('8902','2013-06-05','18:05:00',3),('8902','2013-06-05','18:10:00',2.81),('8902','2013-06-05','18:15:00',2.63),('8902','2013-06-05','18:20:00',2.44),('8902','2013-06-05','18:25:00',2.26),('8902','2013-06-05','18:30:00',2.05),('8902','2013-06-05','18:35:00',1.92),('8902','2013-06-05','18:40:00',1.81),('8902','2013-06-05','18:45:00',1.63),('8902','2013-06-05','18:50:00',1.47),('8902','2013-06-05','18:55:00',1.34),('8902','2013-06-05','19:00:00',1.16),('8902','2013-06-05','19:05:00',1.02),('8902','2013-06-04','06:55:00',1.07),('8902','2013-06-04','07:00:00',1.08),('8902','2013-06-04','07:05:00',1.02),('8902','2013-06-04','07:20:00',1.06),('8902','2013-06-04','07:35:00',1.28),('8902','2013-06-04','07:40:00',1.06),('8902','2013-06-04','07:50:00',1.29),('8902','2013-06-04','07:55:00',2.55),('8902','2013-06-04','08:00:00',2.35),('8902','2013-06-04','08:05:00',1.63),('8902','2013-06-04','08:10:00',2.4),('8902','2013-06-04','08:15:00',2.68),('8902','2013-06-04','08:20:00',2.91),('8902','2013-06-04','08:25:00',3.16),('8902','2013-06-04','08:30:00',3.32),('8902','2013-06-04','08:35:00',3.49),('8902','2013-06-04','08:40:00',3.61),('8902','2013-06-04','08:45:00',3.82),('8902','2013-06-04','08:50:00',3.95),('8902','2013-06-04','08:55:00',4.1),('8902','2013-06-04','09:00:00',4.28),('8902','2013-06-04','09:05:00',4.52),('8902','2013-06-04','09:10:00',4.79),('8902','2013-06-04','09:15:00',4.89),('8902','2013-06-04','09:20:00',5.14),('8902','2013-06-04','09:25:00',5.48),('8902','2013-06-04','09:30:00',5.53),('8902','2013-06-04','09:35:00',6.11),('8902','2013-06-04','09:40:00',6.49),('8902','2013-06-04','09:45:00',6.52),('8902','2013-06-04','09:50:00',3.55),('8902','2013-06-04','09:55:00',3.77),('8902','2013-06-04','10:00:00',3.89),('8902','2013-06-04','10:05:00',7.12),('8902','2013-06-04','10:10:00',7.14),('8902','2013-06-04','10:15:00',7.1),('8902','2013-06-04','10:20:00',3.83),('8902','2013-06-04','10:25:00',2.38),('8902','2013-06-04','10:30:00',2.35),('8902','2013-06-04','10:35:00',2.31),('8902','2013-06-04','10:40:00',2.37),('8902','2013-06-04','10:45:00',7.06),('8902','2013-06-04','10:50:00',2.33),('8902','2013-06-04','10:55:00',3.76),('8902','2013-06-04','11:00:00',7.8),('8902','2013-06-04','11:05:00',4.38),('8902','2013-06-04','11:10:00',3.44),('8902','2013-06-04','11:15:00',3.32),('8902','2013-06-04','11:20:00',2.52),('8902','2013-06-04','11:25:00',2),('8902','2013-06-04','11:30:00',1.99),('8902','2013-06-04','11:35:00',2.21),('8902','2013-06-04','11:40:00',4.87),('8902','2013-06-04','11:45:00',4.75),('8902','2013-06-04','11:50:00',4.69),('8902','2013-06-04','11:55:00',7.98),('8902','2013-06-04','12:00:00',8.57),('8902','2013-06-04','12:05:00',6.81),('8902','2013-06-04','12:10:00',8.86),('8902','2013-06-04','12:15:00',8.96),('8902','2013-06-04','12:20:00',9.31),('8902','2013-06-04','12:25:00',9.08),('8902','2013-06-04','12:30:00',7.47),('8902','2013-06-04','12:35:00',5.16),('8902','2013-06-04','12:40:00',7.05),('8902','2013-06-04','12:45:00',9.42),('8902','2013-06-04','12:50:00',6.49),('8902','2013-06-04','12:55:00',3.15),('8902','2013-06-04','13:00:00',6.05),('8902','2013-06-04','13:05:00',9.76),('8902','2013-06-04','13:10:00',5.9),('8902','2013-06-04','13:15:00',3.77),('8902','2013-06-04','13:20:00',4.51),('8902','2013-06-04','13:25:00',7.36),('8902','2013-06-04','13:30:00',8.31),('8902','2013-06-04','13:35:00',9.69),('8902','2013-06-04','13:40:00',9.16),('8902','2013-06-04','13:45:00',9.05),('8902','2013-06-04','13:50:00',8.68),('8902','2013-06-04','13:55:00',8.6),('8902','2013-06-04','14:00:00',8.45),('8902','2013-06-04','14:05:00',8.17),('8902','2013-06-04','14:10:00',8.22),('8902','2013-06-04','14:15:00',8.21),('8902','2013-06-04','14:20:00',8.23),('8902','2013-06-04','14:25:00',8.03),('8902','2013-06-04','14:30:00',8.07),('8902','2013-06-04','14:35:00',8.07),('8902','2013-06-04','14:40:00',8.02),('8902','2013-06-04','14:45:00',8.05),('8902','2013-06-04','14:50:00',8.04),('8902','2013-06-04','14:55:00',7.97),('8902','2013-06-04','15:00:00',7.8),('8902','2013-06-04','15:05:00',7.64),('8902','2013-06-04','15:10:00',7.6),('8902','2013-06-04','15:15:00',7.59),('8902','2013-06-04','15:20:00',7.57),('8902','2013-06-04','15:25:00',7.5),('8902','2013-06-04','15:30:00',7.51),('8902','2013-06-04','15:35:00',7.61),('8902','2013-06-04','15:40:00',7.52),('8902','2013-06-04','15:45:00',7.06),('8902','2013-06-04','15:50:00',7.15),('8902','2013-06-04','15:55:00',7.05),('8902','2013-06-04','16:00:00',7),('8902','2013-06-04','16:05:00',6.9),('8902','2013-06-04','16:10:00',6.7),('8902','2013-06-04','16:15:00',6.64),('8902','2013-06-04','16:20:00',6.53),('8902','2013-06-04','16:25:00',6.37),('8902','2013-06-04','16:30:00',6.26),('8902','2013-06-04','16:35:00',5.95),('8902','2013-06-04','16:40:00',5.93),('8902','2013-06-04','16:45:00',5.8),('8902','2013-06-04','16:50:00',5.61),('8902','2013-06-04','16:55:00',5.49),('8902','2013-06-04','17:00:00',5.37),('8902','2013-06-04','17:05:00',4.47),('8902','2013-06-04','17:10:00',5.23),('8902','2013-06-04','17:15:00',3.29),('8902','2013-06-04','17:20:00',3.3),('8902','2013-06-04','17:25:00',3.52),('8902','2013-06-04','17:30:00',4.2),('8902','2013-06-04','17:35:00',4.37),('8902','2013-06-04','17:40:00',3.28),('8902','2013-06-04','17:45:00',3.86),('8902','2013-06-04','17:50:00',3.62),('8902','2013-06-04','17:55:00',3.33),('8902','2013-06-04','18:00:00',3.24),('8902','2013-06-04','18:05:00',3.11),('8902','2013-06-04','18:10:00',1.78),('8902','2013-06-04','18:15:00',1.73),('8902','2013-06-04','18:20:00',1.9),('8902','2013-06-04','18:25:00',1.72),('8902','2013-06-04','18:30:00',1.88),('8902','2013-06-04','18:35:00',1.73),('8902','2013-06-04','18:40:00',1.38),('8902','2013-06-04','18:45:00',1.03),('8902','2013-06-04','18:55:00',1.2),('8902','2013-06-03','07:15:00',1.11),('8902','2013-06-03','07:20:00',1.23),('8902','2013-06-03','07:25:00',1.34),('8902','2013-06-03','07:30:00',1.47),('8902','2013-06-03','07:35:00',1.65),('8902','2013-06-03','07:40:00',1.88),('8902','2013-06-03','07:45:00',2.23),('8902','2013-06-03','07:50:00',2.5),('8902','2013-06-03','07:55:00',2.73),('8902','2013-06-03','08:00:00',3.09),('8902','2013-06-03','08:05:00',3.39),('8902','2013-06-03','08:10:00',3.53),('8902','2013-06-03','08:15:00',3.63),('8902','2013-06-03','08:20:00',3.73),('8902','2013-06-03','08:25:00',3.74),('8902','2013-06-03','08:30:00',3.3),('8902','2013-06-03','08:35:00',4.47),('8902','2013-06-03','08:40:00',3.67),('8902','2013-06-03','08:45:00',3.64),('8902','2013-06-03','08:50:00',2.56),('8902','2013-06-03','08:55:00',2.5),('8902','2013-06-03','09:00:00',2.93),('8902','2013-06-03','09:05:00',3.08),('8902','2013-06-03','09:10:00',4),('8902','2013-06-03','09:15:00',4.61),('8902','2013-06-03','09:20:00',5.81),('8902','2013-06-03','09:25:00',5.7),('8902','2013-06-03','09:30:00',5.27),('8902','2013-06-03','09:35:00',4.7),('8902','2013-06-03','09:40:00',3.12),('8902','2013-06-03','09:45:00',3.14),('8902','2013-06-03','09:50:00',3.23),('8902','2013-06-03','09:55:00',3.27),('8902','2013-06-03','10:00:00',3.56),('8902','2013-06-03','10:05:00',4.47),('8902','2013-06-03','10:10:00',5.09),('8902','2013-06-03','10:15:00',5.15),('8902','2013-06-03','10:20:00',3.52),('8902','2013-06-03','10:25:00',3.38),('8902','2013-06-03','10:30:00',3.13),('8902','2013-06-03','10:35:00',3.18),('8902','2013-06-03','10:40:00',3.37),('8902','2013-06-03','10:45:00',3.82),('8902','2013-06-03','10:50:00',5.11),('8902','2013-06-03','10:55:00',6.26),('8902','2013-06-03','11:00:00',4.17),('8902','2013-06-03','11:05:00',4.85),('8902','2013-06-03','11:10:00',5.77),('8902','2013-06-03','11:15:00',6.09),('8902','2013-06-03','11:20:00',4.01),('8902','2013-06-03','11:25:00',5.07),('8902','2013-06-03','11:30:00',6.43),('8902','2013-06-03','11:35:00',5.65),('8902','2013-06-03','11:40:00',5.41),('8902','2013-06-03','11:45:00',7.24),('8902','2013-06-03','11:50:00',8.58),('8902','2013-06-03','11:55:00',8.24),('8902','2013-06-03','12:00:00',7.19),('8902','2013-06-03','12:05:00',6.38),('8902','2013-06-03','12:10:00',4.85),('8902','2013-06-03','12:15:00',5.19),('8902','2013-06-03','12:20:00',4.22),('8902','2013-06-03','12:25:00',3.97),('8902','2013-06-03','12:30:00',4.26),('8902','2013-06-03','12:35:00',7.52),('8902','2013-06-03','12:40:00',4.69),('8902','2013-06-03','12:45:00',5.67),('8902','2013-06-03','12:50:00',6.01),('8902','2013-06-03','12:55:00',3.88),('8902','2013-06-03','13:00:00',4.38),('8902','2013-06-03','13:05:00',4.31),('8902','2013-06-03','13:10:00',2.47),('8902','2013-06-03','13:15:00',2.62),('8902','2013-06-03','13:20:00',2.09),('8902','2013-06-03','13:25:00',2.31),('8902','2013-06-03','13:30:00',3.09),('8902','2013-06-03','13:35:00',6.41),('8902','2013-06-03','13:40:00',5.59),('8902','2013-06-03','13:45:00',6.91),('8902','2013-06-03','13:50:00',9.52),('8902','2013-06-03','13:55:00',6.88),('8902','2013-06-03','14:00:00',3.13),('8902','2013-06-03','14:05:00',5.66),('8902','2013-06-03','14:10:00',9.64),('8902','2013-06-03','14:15:00',8.74),('8902','2013-06-03','14:20:00',6.88),('8902','2013-06-03','14:25:00',5.28),('8902','2013-06-03','14:30:00',2.76),('8902','2013-06-03','14:35:00',3.18),('8902','2013-06-03','14:40:00',5.22),('8902','2013-06-03','14:45:00',2.28),('8902','2013-06-03','14:50:00',1.89),('8902','2013-06-03','14:55:00',5.79),('8902','2013-06-03','15:00:00',9.97),('8902','2013-06-03','15:05:00',9.63),('8902','2013-06-03','15:10:00',4.03),('8902','2013-06-03','15:15:00',2.1),('8902','2013-06-03','15:20:00',1.9),('8902','2013-06-03','15:25:00',1.5),('8902','2013-06-03','17:15:00',1.49),('8902','2013-06-03','17:20:00',1.55),('8902','2013-06-03','17:25:00',1.29),('8902','2013-06-03','17:40:00',1.62),('8902','2013-06-03','17:45:00',1.04),('8902','2013-06-03','17:50:00',1.1),('8902','2013-06-03','17:55:00',1.26),('8902','2013-06-03','18:00:00',1.45),('8902','2013-06-03','18:05:00',1.66),('8902','2013-06-03','18:10:00',1.78),('8902','2013-06-03','18:15:00',1.59),('8902','2013-06-03','18:20:00',1.42),('8902','2013-06-03','18:25:00',1.33),('8902','2013-06-03','18:30:00',1.08),('8902','2013-06-03','18:40:00',1.1),('8902','2013-06-03','18:45:00',1.38),('8902','2013-06-03','18:50:00',1.37),('8902','2013-06-03','18:55:00',1.11),('8902','2013-06-02','07:25:00',1.15),('8902','2013-06-02','07:40:00',1.47),('8902','2013-06-02','07:45:00',1.89),('8902','2013-06-02','07:50:00',1.98),('8902','2013-06-02','07:55:00',2.25),('8902','2013-06-02','08:00:00',2.42),('8902','2013-06-02','08:05:00',2.54),('8902','2013-06-02','08:10:00',2.68),('8902','2013-06-02','08:15:00',2.84),('8902','2013-06-02','08:20:00',3.02),('8902','2013-06-02','08:25:00',3.21),('8902','2013-06-02','08:30:00',3.34),('8902','2013-06-02','08:35:00',3.53),('8902','2013-06-02','08:40:00',3.7),('8902','2013-06-02','08:45:00',3.81),('8902','2013-06-02','08:50:00',4.01),('8902','2013-06-02','08:55:00',4.14),('8902','2013-06-02','09:00:00',4.28),('8902','2013-06-02','09:05:00',4.28),('8902','2013-06-02','09:10:00',4.6),('8902','2013-06-02','09:15:00',5.22),('8902','2013-06-02','09:20:00',4.87),('8902','2013-06-02','09:25:00',4.57),('8902','2013-06-02','09:30:00',3.97),('8902','2013-06-02','09:35:00',3.3),('8902','2013-06-02','09:40:00',4.28),('8902','2013-06-02','09:45:00',4.88),('8902','2013-06-02','09:50:00',5.68),('8902','2013-06-02','09:55:00',5.79),('8902','2013-06-02','10:00:00',6.36),('8902','2013-06-02','10:05:00',7.37),('8902','2013-06-02','10:10:00',5.35),('8902','2013-06-02','10:15:00',3.94),('8902','2013-06-02','10:20:00',5.34),('8902','2013-06-02','10:25:00',3.84),('8902','2013-06-02','10:30:00',2.33),('8902','2013-06-02','10:35:00',2.36),('8902','2013-06-02','10:40:00',2.79),('8902','2013-06-02','10:45:00',2.95),('8902','2013-06-02','10:50:00',3.51),('8902','2013-06-02','10:55:00',3.72),('8902','2013-06-02','11:00:00',3.59),('8902','2013-06-02','11:05:00',3.83),('8902','2013-06-02','11:10:00',2.38),('8902','2013-06-02','11:15:00',2.48),('8902','2013-06-02','11:20:00',3.18),('8902','2013-06-02','11:25:00',3.23),('8902','2013-06-02','11:30:00',2.83),('8902','2013-06-02','11:35:00',2.78),('8902','2013-06-02','11:40:00',3.22),('8902','2013-06-02','11:45:00',3.38),('8902','2013-06-02','11:50:00',2.97),('8902','2013-06-02','11:55:00',4.07),('8902','2013-06-02','12:00:00',4.99),('8902','2013-06-02','12:05:00',6.47),('8902','2013-06-02','12:10:00',3.54),('8902','2013-06-02','12:15:00',2.65),('8902','2013-06-02','12:20:00',2.83),('8902','2013-06-02','12:25:00',2.8),('8902','2013-06-02','12:30:00',3.74),('8902','2013-06-02','12:35:00',7.99),('8902','2013-06-02','12:40:00',6.43),('8902','2013-06-02','12:45:00',4.41),('8902','2013-06-02','12:50:00',4.3),('8902','2013-06-02','12:55:00',5.12),('8902','2013-06-02','13:00:00',3.75),('8902','2013-06-02','13:05:00',3.5),('8902','2013-06-02','13:10:00',3.8),('8902','2013-06-02','13:15:00',7.45),('8902','2013-06-02','13:20:00',9.52),('8902','2013-06-02','13:25:00',6.01),('8902','2013-06-02','13:30:00',7.83),('8902','2013-06-02','13:35:00',9.11),('8902','2013-06-02','13:40:00',6.88),('8902','2013-06-02','13:45:00',4.43),('8902','2013-06-02','13:50:00',7.42),('8902','2013-06-02','13:55:00',6.01),('8902','2013-06-02','14:00:00',8.75),('8902','2013-06-02','14:05:00',5.92),('8902','2013-06-02','14:10:00',4.08),('8902','2013-06-02','14:15:00',5.78),('8902','2013-06-02','14:20:00',3.74),('8902','2013-06-02','14:25:00',7.29),('8902','2013-06-02','14:30:00',9.12),('8902','2013-06-02','14:35:00',9.09),('8902','2013-06-02','14:40:00',5.77),('8902','2013-06-02','14:45:00',6.64),('8902','2013-06-02','14:50:00',5.68),('8902','2013-06-02','14:55:00',7.93),('8902','2013-06-02','15:00:00',7.26),('8902','2013-06-02','15:05:00',5.95),('8902','2013-06-02','15:10:00',8.04),('8902','2013-06-02','15:15:00',6.92),('8902','2013-06-02','15:20:00',6.34),('8902','2013-06-02','15:25:00',7.86),('8902','2013-06-02','15:30:00',7.7),('8902','2013-06-02','15:35:00',7.53),('8902','2013-06-02','15:40:00',7.39),('8902','2013-06-02','15:45:00',7.31),('8902','2013-06-02','15:50:00',7.28),('8902','2013-06-02','15:55:00',7.13),('8902','2013-06-02','16:00:00',6.98),('8902','2013-06-02','16:05:00',6.94),('8902','2013-06-02','16:10:00',6.89),('8902','2013-06-02','16:15:00',6.73),('8902','2013-06-02','16:20:00',6.38),('8902','2013-06-02','16:25:00',6.57),('8902','2013-06-02','16:30:00',6.6),('8902','2013-06-02','16:35:00',6.03),('8902','2013-06-02','16:40:00',6.18),('8902','2013-06-02','16:45:00',5.34),('8902','2013-06-02','16:50:00',4.08),('8902','2013-06-02','16:55:00',3.51),('8902','2013-06-02','17:00:00',4.08),('8902','2013-06-02','17:05:00',5.14),('8902','2013-06-02','17:10:00',4.91),('8902','2013-06-02','17:15:00',4.94),('8902','2013-06-02','17:20:00',4.25),('8902','2013-06-02','17:25:00',2.65),('8902','2013-06-02','17:30:00',1.55),('8902','2013-06-02','17:35:00',1.19),('8902','2013-06-02','17:40:00',1.2),('8902','2013-06-02','17:45:00',1.09),('8902','2013-06-02','17:50:00',1.31),('8902','2013-06-02','17:55:00',1.29),('8902','2013-06-02','18:00:00',1.09),('8902','2013-06-01','06:55:00',1.3),('8902','2013-06-01','07:00:00',1.38),('8902','2013-06-01','07:05:00',1.05),('8902','2013-06-01','08:25:00',1.44),('8902','2013-06-01','08:30:00',1.53),('8902','2013-06-01','08:35:00',1.63),('8902','2013-06-01','08:40:00',1.63),('8902','2013-06-01','08:45:00',1.8),('8902','2013-06-01','08:50:00',2),('8902','2013-06-01','08:55:00',1.78),('8902','2013-06-01','09:00:00',1.74),('8902','2013-06-01','09:05:00',1.87),('8902','2013-06-01','09:10:00',2.08),('8902','2013-06-01','09:15:00',2.14),('8902','2013-06-01','09:20:00',3.04),('8902','2013-06-01','09:25:00',5.93),('8902','2013-06-01','09:30:00',5.68),('8902','2013-06-01','09:35:00',5.65),('8902','2013-06-01','09:40:00',5.65),('8902','2013-06-01','09:45:00',5.73),('8902','2013-06-01','09:50:00',5.86),('8902','2013-06-01','09:55:00',5.94),('8902','2013-06-01','10:00:00',6.08),('8902','2013-06-01','10:05:00',6.18),('8902','2013-06-01','10:10:00',6.32),('8902','2013-06-01','10:15:00',6.44),('8902','2013-06-01','10:20:00',6.54),('8902','2013-06-01','10:25:00',6.62),('8902','2013-06-01','10:30:00',6.88),('8902','2013-06-01','10:35:00',7.34),('8902','2013-06-01','10:40:00',7.45),('8902','2013-06-01','10:45:00',6.81),('8902','2013-06-01','10:50:00',6.85),('8902','2013-06-01','10:55:00',4.93),('8902','2013-06-01','11:00:00',7.92),('8902','2013-06-01','11:05:00',7.78),('8902','2013-06-01','11:10:00',8.45),('8902','2013-06-01','11:15:00',4.48),('8902','2013-06-01','11:20:00',8.36),('8902','2013-06-01','11:25:00',5.55),('8902','2013-06-01','11:30:00',6.01),('8902','2013-06-01','11:35:00',3.98),('8902','2013-06-01','11:40:00',3.07),('8902','2013-06-01','11:45:00',2.51),('8902','2013-06-01','11:50:00',3.46),('8902','2013-06-01','11:55:00',6.17),('8902','2013-06-01','12:00:00',8.63),('8902','2013-06-01','12:05:00',4.49),('8902','2013-06-01','12:10:00',4.24),('8902','2013-06-01','12:15:00',8.63),('8902','2013-06-01','12:20:00',4.9),('8902','2013-06-01','12:25:00',3.02),('8902','2013-06-01','12:30:00',3.88),('8902','2013-06-01','12:35:00',5.5),('8902','2013-06-01','12:40:00',8.55),('8902','2013-06-01','12:45:00',7.07),('8902','2013-06-01','12:50:00',4.38),('8902','2013-06-01','12:55:00',4.3),('8902','2013-06-01','13:00:00',5.26),('8902','2013-06-01','13:05:00',2.86),('8902','2013-06-01','13:10:00',2.55),('8902','2013-06-01','13:15:00',8.58),('8902','2013-06-01','13:20:00',9.08),('8902','2013-06-01','13:25:00',8.68),('8902','2013-06-01','13:30:00',8.51),('8902','2013-06-01','13:35:00',8.52),('8902','2013-06-01','13:40:00',8.42),('8902','2013-06-01','13:45:00',8.32),('8902','2013-06-01','13:50:00',8.32),('8902','2013-06-01','13:55:00',8.29),('8902','2013-06-01','14:00:00',8.25),('8902','2013-06-01','14:05:00',8.16),('8902','2013-06-01','14:10:00',8.3),('8902','2013-06-01','14:15:00',8.1),('8902','2013-06-01','14:20:00',8.21),('8902','2013-06-01','14:25:00',8.21),('8902','2013-06-01','14:30:00',8.13),('8902','2013-06-01','14:35:00',8.02),('8902','2013-06-01','14:40:00',7.96),('8902','2013-06-01','14:45:00',7.89),('8902','2013-06-01','14:50:00',7.87),('8902','2013-06-01','14:55:00',7.87),('8902','2013-06-01','15:00:00',7.81),('8902','2013-06-01','15:05:00',7.76),('8902','2013-06-01','15:10:00',7.58),('8902','2013-06-01','15:15:00',7.61),('8902','2013-06-01','15:20:00',7.55),('8902','2013-06-01','15:25:00',6.7),('8902','2013-06-01','15:30:00',7.61),('8902','2013-06-01','15:35:00',5.89),('8902','2013-06-01','15:40:00',5.47),('8902','2013-06-01','15:45:00',6.82),('8902','2013-06-01','15:50:00',7.23),('8902','2013-06-01','15:55:00',5.34),('8902','2013-06-01','16:00:00',7.33),('8902','2013-06-01','16:05:00',6.97),('8902','2013-06-01','16:10:00',6.25),('8902','2013-06-01','16:15:00',5.77),('8902','2013-06-01','16:20:00',6.67),('8902','2013-06-01','16:25:00',6.29),('8902','2013-06-01','16:30:00',6.28),('8902','2013-06-01','16:35:00',5.84),('8902','2013-06-01','16:40:00',6.04),('8902','2013-06-01','16:45:00',6.16),('8902','2013-06-01','16:50:00',5.45),('8902','2013-06-01','16:55:00',5.65),('8902','2013-06-01','17:00:00',5.54),('8902','2013-06-01','17:05:00',5.2),('8902','2013-06-01','17:10:00',5.1),('8902','2013-06-01','17:15:00',4.98),('8902','2013-06-01','17:20:00',4.74),('8902','2013-06-01','17:25:00',4.63),('8902','2013-06-01','17:30:00',3.12),('8902','2013-06-01','17:35:00',3.82),('8902','2013-06-01','17:40:00',1.96),('8902','2013-06-01','17:45:00',2.09),('8902','2013-06-01','17:50:00',3.39),('8902','2013-06-01','17:55:00',1.33),('8902','2013-06-01','18:00:00',2.46),('8902','2013-06-01','18:05:00',1.57),('8902','2013-06-01','18:10:00',1.22),('8902','2013-06-01','18:15:00',1.29),('8902','2013-06-01','18:20:00',1.29),('8902','2013-06-01','18:25:00',1.12),('8902','2013-06-01','18:30:00',1.15),('8902','2013-06-01','18:35:00',1.16),('8902','2013-06-01','18:40:00',1.06),('8902','2013-06-01','18:45:00',1.05),('8902','2013-06-01','18:50:00',1.04),('8902','2013-05-31','07:20:00',1.14),('8902','2013-05-31','07:25:00',1.28),('8902','2013-05-31','07:30:00',1.44),('8902','2013-05-31','07:35:00',1.63),('8902','2013-05-31','07:40:00',1.82),('8902','2013-05-31','07:45:00',2.25),('8902','2013-05-31','07:50:00',1.69),('8902','2013-05-31','07:55:00',2.28),('8902','2013-05-31','08:00:00',1.26),('8902','2013-05-31','08:05:00',1.11),('8902','2013-05-31','08:10:00',1.2),('8902','2013-05-31','08:15:00',2.32),('8902','2013-05-31','08:20:00',2.43),('8902','2013-05-31','08:25:00',1.56),('8902','2013-05-31','08:30:00',2.17),('8902','2013-05-31','08:35:00',3.2),('8902','2013-05-31','08:40:00',1.6),('8902','2013-05-31','08:45:00',1.08),('8902','2013-05-31','08:50:00',1.25),('8902','2013-05-31','08:55:00',1.3),('8902','2013-05-31','09:00:00',1.38),('8902','2013-05-31','09:05:00',1.06),('8902','2013-05-31','09:40:00',1.1),('8902','2013-05-31','09:45:00',1.64),('8902','2013-05-31','09:50:00',1.95),('8902','2013-05-31','09:55:00',1.43),('8902','2013-05-31','10:00:00',1.31),('8902','2013-05-31','10:05:00',1.49),('8902','2013-05-31','10:10:00',1.45),('8902','2013-05-31','10:15:00',1.25),('8902','2013-05-31','10:20:00',1.02),('8902','2013-05-31','10:30:00',1.06),('8902','2013-05-31','10:35:00',2.09),('8902','2013-05-31','10:40:00',2.23),('8902','2013-05-31','10:45:00',1.41),('8902','2013-05-31','10:50:00',2.54),('8902','2013-05-31','10:55:00',5.25),('8902','2013-05-31','11:00:00',1.28),('8902','2013-05-31','11:30:00',1.06),('8902','2013-05-31','11:45:00',1.32),('8902','2013-05-31','11:50:00',2.74),('8902','2013-05-31','11:55:00',3.65),('8902','2013-05-31','12:00:00',4.74),('8902','2013-05-31','12:05:00',6.81),('8902','2013-05-31','12:10:00',6.69),('8902','2013-05-31','12:15:00',3.1),('8902','2013-05-31','12:20:00',2.21),('8902','2013-05-31','12:25:00',2.32),('8902','2013-05-31','12:30:00',2.31),('8902','2013-05-31','12:35:00',1.78),('8902','2013-05-31','12:40:00',1.95),('8902','2013-05-31','12:45:00',3.16),('8902','2013-05-31','12:50:00',3.47),('8902','2013-05-31','12:55:00',3.34),('8902','2013-05-31','13:00:00',4.21),('8902','2013-05-31','13:05:00',4.52),('8902','2013-05-31','13:10:00',4.66),('8902','2013-05-31','13:15:00',5.36),('8902','2013-05-31','13:20:00',4.43),('8902','2013-05-31','13:25:00',3.37),('8902','2013-05-31','13:30:00',2.95),('8902','2013-05-31','13:35:00',2.34),('8902','2013-05-31','13:40:00',2.1),('8902','2013-05-31','13:45:00',2.4),('8902','2013-05-31','13:50:00',2.58),('8902','2013-05-31','13:55:00',2.9),('8902','2013-05-31','14:00:00',3.71),('8902','2013-05-31','14:05:00',4.66),('8902','2013-05-31','14:10:00',4.54),('8902','2013-05-31','14:15:00',4.74),('8902','2013-05-31','14:20:00',4.92),('8902','2013-05-31','14:25:00',3.11),('8902','2013-05-31','14:30:00',2.47),('8902','2013-05-31','14:35:00',2.56),('8902','2013-05-31','14:40:00',2.48),('8902','2013-05-31','14:45:00',2.4),('8902','2013-05-31','14:50:00',2.14),('8902','2013-05-31','14:55:00',1.71),('8902','2013-05-31','15:00:00',1.65),('8902','2013-05-31','15:05:00',1.67),('8902','2013-05-31','15:10:00',1.27),('8902','2013-05-31','15:15:00',1.21),('8902','2013-05-31','15:20:00',1.05),('8902','2013-05-31','16:05:00',1.13),('8902','2013-05-31','16:10:00',1.09),('8902','2013-05-31','16:15:00',1.2),('8902','2013-05-31','16:20:00',1.38),('8902','2013-05-31','16:25:00',1.08),('8902','2013-05-31','16:30:00',1.24),('8902','2013-05-31','16:35:00',1.39),('8902','2013-05-31','16:40:00',1.57),('8902','2013-05-31','16:45:00',1.36),('8902','2013-05-31','16:50:00',1.28),('8902','2013-05-31','16:55:00',1.28),('8902','2013-05-31','18:30:00',1.67),('8902','2013-05-31','18:35:00',2.05),('8902','2013-05-31','18:40:00',1.52),('8902','2013-05-31','18:45:00',1.14),('8902','2013-05-31','18:50:00',1.01),('8902','2013-05-31','18:55:00',1.1),('8902','2013-05-31','19:00:00',2.06),('8902','2013-05-31','19:05:00',1.84),('8902','2013-05-31','19:10:00',1.02),('8902','2014-04-01','08:00:00',1.42),('8902','2014-04-01','08:05:00',1.74),('8902','2014-04-01','08:10:00',1.67),('8902','2014-04-01','08:15:00',1.31),('8902','2014-04-01','08:20:00',1.89),('8902','2014-04-01','08:25:00',1.55),('8902','2014-04-01','08:35:00',1.02),('8902','2014-04-01','08:40:00',1.41),('8902','2014-04-01','08:45:00',1.56),('8902','2014-04-01','08:50:00',1.84),('8902','2014-04-01','08:55:00',3.42),('8902','2014-04-01','09:00:00',2.35),('8902','2014-04-01','09:05:00',1.86),('8902','2014-04-01','09:10:00',1.7),('8902','2014-04-01','09:15:00',1.7),('8902','2014-04-01','09:20:00',1.75),('8902','2014-04-01','09:25:00',1.56),('8902','2014-04-01','09:30:00',1.2),('8902','2014-04-01','09:35:00',1.42),('8902','2014-04-01','09:40:00',1.79),('8902','2014-04-01','09:45:00',1.63),('8902','2014-04-01','09:50:00',1.25),('8902','2014-04-01','09:55:00',1.38),('8902','2014-04-01','10:00:00',3.63),('8902','2014-04-01','10:05:00',3.51),('8902','2014-04-01','10:10:00',3.38),('8902','2014-04-01','10:15:00',2.38),('8902','2014-04-01','10:20:00',3.12),('8902','2014-04-01','10:25:00',6.37),('8902','2014-04-01','10:30:00',6.09),('8902','2014-04-01','10:35:00',1.66),('8902','2014-04-01','10:40:00',1.6),('8902','2014-04-01','10:45:00',1.65),('8902','2014-04-01','10:50:00',1.84),('8902','2014-04-01','10:55:00',5.65),('8902','2014-04-01','11:00:00',6.99),('8902','2014-04-01','11:05:00',6.78),('8902','2014-04-01','11:10:00',5.62),('8902','2014-04-01','11:15:00',2.45),('8902','2014-04-01','11:20:00',6.83),('8902','2014-04-01','11:25:00',7.85),('8902','2014-04-01','11:30:00',7.9),('8902','2014-04-01','11:35:00',6.27),('8902','2014-04-01','11:40:00',5.84),('8902','2014-04-01','11:45:00',4.02),('8902','2014-04-01','11:50:00',6.12),('8902','2014-04-01','11:55:00',4.36),('8902','2014-04-01','12:00:00',6.9),('8902','2014-04-01','12:05:00',9.06),('8902','2014-04-01','12:10:00',3.33),('8902','2014-04-01','12:15:00',2.54),('8902','2014-04-01','12:20:00',4.9),('8902','2014-04-01','12:25:00',8.83),('8902','2014-04-01','12:30:00',2.51),('8902','2014-04-01','12:35:00',6.92),('8902','2014-04-01','12:40:00',8.94),('8902','2014-04-01','12:45:00',8.87),('8902','2014-04-01','12:50:00',8.31),('8902','2014-04-01','12:55:00',9.05),('8902','2014-04-01','13:00:00',6.22),('8902','2014-04-01','13:05:00',3.78),('8902','2014-04-01','13:10:00',6.71),('8902','2014-04-01','13:15:00',7.92),('8902','2014-04-01','13:20:00',6.36),('8902','2014-04-01','13:25:00',8.59),('8902','2014-04-01','13:30:00',8.67),('8902','2014-04-01','13:35:00',8.73),('8902','2014-04-01','13:40:00',9.08),('8902','2014-04-01','13:45:00',8.69),('8902','2014-04-01','13:50:00',8.35),('8902','2014-04-01','13:55:00',8.29),('8902','2014-04-01','14:00:00',8.29),('8902','2014-04-01','14:05:00',8.11),('8902','2014-04-01','14:10:00',8.25),('8902','2014-04-01','14:15:00',8.18),('8902','2014-04-01','14:20:00',8.05),('8902','2014-04-01','14:25:00',8.04),('8902','2014-04-01','14:30:00',8.01),('8902','2014-04-01','14:35:00',7.86),('8902','2014-04-01','14:40:00',7.94),('8902','2014-04-01','14:45:00',7.97),('8902','2014-04-01','14:50:00',4.61),('8902','2014-04-01','14:55:00',6.97),('8902','2014-04-01','15:00:00',6.93),('8902','2014-04-01','15:05:00',7.6),('8902','2014-04-01','15:10:00',7.03),('8902','2014-04-01','15:15:00',7.06),('8902','2014-04-01','15:20:00',7.07),('8902','2014-04-01','15:25:00',6.94),('8902','2014-04-01','15:30:00',6.58),('8902','2014-04-01','15:35:00',6.39),('8902','2014-04-01','15:40:00',6.72),('8902','2014-04-01','15:45:00',6.81),('8902','2014-04-01','15:50:00',6.73),('8902','2014-04-01','15:55:00',5.95),('8902','2014-04-01','16:00:00',6.15),('8902','2014-04-01','16:05:00',6.17),('8902','2014-04-01','16:10:00',6.03),('8902','2014-04-01','16:15:00',5.93),('8902','2014-04-01','16:20:00',5.73),('8902','2014-04-01','16:25:00',5.6),('8902','2014-04-01','16:30:00',5.59),('8902','2014-04-01','16:35:00',5.38),('8902','2014-04-01','16:40:00',5.27),('8902','2014-04-01','16:45:00',5.03),('8902','2014-04-01','16:50:00',4.56),('8902','2014-04-01','16:55:00',4.57),('8902','2014-04-01','17:00:00',4.77),('8902','2014-04-01','17:05:00',4.23),('8902','2014-04-01','17:10:00',4.07),('8902','2014-04-01','17:15:00',3.69),('8902','2014-04-01','17:20:00',3.68),('8902','2014-04-01','17:25:00',3.49),('8902','2014-04-01','17:30:00',3.17),('8902','2014-04-01','17:35:00',3.05),('8902','2014-04-01','17:40:00',2.27),('8902','2014-04-01','17:45:00',2.32),('8902','2014-04-01','17:50:00',2.8),('8902','2014-04-01','17:55:00',2.34),('8902','2014-04-01','18:00:00',2.17),('8902','2014-04-01','18:05:00',1.38),('8902','2014-04-01','18:10:00',1.19),('8902','2014-04-01','18:15:00',1.15),('8902','2014-04-01','18:20:00',1.17),('8902','2014-04-01','18:25:00',1.05),('8902','2013-05-30','07:15:00',1.02),('8902','2013-05-30','07:20:00',1.17),('8902','2013-05-30','07:25:00',1.32),('8902','2013-05-30','07:30:00',1.49),('8902','2013-05-30','07:35:00',1.64),('8902','2013-05-30','07:40:00',1.8),('8902','2013-05-30','07:45:00',1.95),('8902','2013-05-30','07:50:00',2.11),('8902','2013-05-30','07:55:00',2.34),('8902','2013-05-30','08:00:00',2.55),('8902','2013-05-30','08:05:00',2.68),('8902','2013-05-30','08:10:00',2.84),('8902','2013-05-30','08:15:00',2.99),('8902','2013-05-30','08:20:00',3.16),('8902','2013-05-30','08:25:00',3.37),('8902','2013-05-30','08:30:00',3.76),('8902','2013-05-30','08:35:00',3.35),('8902','2013-05-30','08:40:00',4.45),('8902','2013-05-30','08:45:00',2.26),('8902','2013-05-30','08:50:00',4.35),('8902','2013-05-30','08:55:00',3.09),('8902','2013-05-30','09:00:00',1.95),('8902','2013-05-30','09:05:00',1.15),('8902','2013-05-30','09:10:00',2.12),('8902','2013-05-30','09:15:00',1.97),('8902','2013-05-30','09:20:00',1.52),('8902','2013-05-30','09:25:00',1.62),('8902','2013-05-30','09:30:00',3.03),('8902','2013-05-30','09:35:00',4.97),('8902','2013-05-30','09:40:00',4.72),('8902','2013-05-30','09:45:00',5.92),('8902','2013-05-30','09:50:00',6.28),('8902','2013-05-30','09:55:00',6.68),('8902','2013-05-30','10:00:00',6.79),('8902','2013-05-30','10:05:00',3.85),('8902','2013-05-30','10:10:00',3.82),('8902','2013-05-30','10:15:00',5.12),('8902','2013-05-30','10:20:00',6.58),('8902','2013-05-30','10:25:00',2.75),('8902','2013-05-30','10:30:00',4.09),('8902','2013-05-30','10:35:00',5.53),('8902','2013-05-30','10:40:00',5.93),('8902','2013-05-30','10:45:00',6.94),('8902','2013-05-30','10:50:00',5.53),('8902','2013-05-30','10:55:00',7.62),('8902','2013-05-30','11:00:00',2.74),('8902','2013-05-30','11:05:00',2.47),('8902','2013-05-30','11:10:00',9.58),('8902','2013-05-30','11:15:00',8.49),('8902','2013-05-30','11:20:00',3.16),('8902','2013-05-30','11:25:00',3.52),('8902','2013-05-30','11:30:00',6.97),('8902','2013-05-30','11:35:00',4.91),('8902','2013-05-30','11:40:00',1.91),('8902','2013-05-30','11:45:00',6.12),('8902','2013-05-30','11:50:00',8.33),('8902','2013-05-30','11:55:00',4.54),('8902','2013-05-30','12:00:00',5.27),('8902','2013-05-30','12:05:00',8.38),('8902','2013-05-30','12:10:00',8.17),('8902','2013-05-30','12:15:00',3.25),('8902','2013-05-30','12:20:00',2.82),('8902','2013-05-30','12:25:00',6.5),('8902','2013-05-30','12:30:00',3.25),('8902','2013-05-30','12:35:00',2.81),('8902','2013-05-30','12:40:00',7.18),('8902','2013-05-30','12:45:00',5.21),('8902','2013-05-30','12:50:00',1.67),('8902','2013-05-30','12:55:00',2.51),('8902','2013-05-30','13:00:00',7.26),('8902','2013-05-30','13:05:00',4.38),('8902','2013-05-30','13:10:00',1.34),('8902','2013-05-30','13:15:00',1.2),('8902','2013-05-30','13:20:00',1.97),('8902','2013-05-30','13:25:00',3.37),('8902','2013-05-30','13:30:00',6.45),('8902','2013-05-30','13:35:00',9.44),('8902','2013-05-30','13:40:00',3.81),('8902','2013-05-30','13:45:00',2.56),('8902','2013-05-30','13:50:00',1.36),('8902','2013-05-30','13:55:00',1.51),('8902','2013-05-30','14:00:00',4.21),('8902','2013-05-30','14:05:00',1.63),('8902','2013-05-30','14:10:00',1.2),('8902','2013-05-30','14:20:00',1.37),('8902','2013-05-30','14:25:00',1.5),('8902','2013-05-30','14:45:00',1.09),('8902','2013-05-30','14:50:00',1.55),('8902','2013-05-30','14:55:00',1.27),('8902','2013-05-30','15:00:00',1.48),('8902','2013-05-30','15:05:00',2.8),('8902','2013-05-30','15:10:00',3.46),('8902','2013-05-30','15:15:00',4.55),('8902','2013-05-30','15:20:00',9.88),('8902','2013-05-30','15:25:00',6.65),('8902','2013-05-30','15:30:00',5.51),('8902','2013-05-30','15:35:00',4.06),('8902','2013-05-30','15:40:00',3.41),('8902','2013-05-30','15:45:00',3),('8902','2013-05-30','15:50:00',4.34),('8902','2013-05-30','15:55:00',4.15),('8902','2013-05-30','16:00:00',3.18),('8902','2013-05-30','16:05:00',2.46),('8902','2013-05-30','16:10:00',1.91),('8902','2013-05-30','16:15:00',1.68),('8902','2013-05-30','16:20:00',1.91),('8902','2013-05-30','16:25:00',2.49),('8902','2013-05-30','16:30:00',2.37),('8902','2013-05-30','16:35:00',1.99),('8902','2013-05-30','16:40:00',2.2),('8902','2013-05-30','16:45:00',2.32),('8902','2013-05-30','16:50:00',1.63),('8902','2013-05-30','16:55:00',1.2),('8902','2013-05-30','17:00:00',1.13),('8902','2013-05-30','17:05:00',1.14),('8902','2013-05-30','17:10:00',1.09),('8902','2013-05-30','17:15:00',1.14),('8902','2013-05-30','17:20:00',1.28),('8902','2013-05-30','17:25:00',1.39),('8902','2013-05-30','17:30:00',1.37),('8902','2013-05-30','17:35:00',1.17),('8902','2013-05-30','17:40:00',1),('8902','2013-05-30','17:45:00',1.06),('8902','2013-05-30','17:50:00',1),('8902','2013-05-29','07:40:00',1.15),('8902','2013-05-29','07:45:00',1.39),('8902','2013-05-29','07:50:00',1.74),('8902','2013-05-29','07:55:00',1.46),('8902','2013-05-29','08:00:00',1.27),('8902','2013-05-29','08:10:00',1.12),('8902','2013-05-29','08:15:00',1.33),('8902','2013-05-29','08:20:00',1.51),('8902','2013-05-29','08:25:00',2.39),('8902','2013-05-29','08:30:00',1.85),('8902','2013-05-29','08:35:00',1.27),('8902','2013-05-29','08:40:00',3.95),('8902','2013-05-29','08:45:00',4.14),('8902','2013-05-29','08:50:00',4.28),('8902','2013-05-29','08:55:00',4.43),('8902','2013-05-29','09:00:00',4.58),('8902','2013-05-29','09:05:00',4.48),('8902','2013-05-29','09:10:00',4.38),('8902','2013-05-29','09:15:00',5.1),('8902','2013-05-29','09:20:00',5.26),('8902','2013-05-29','09:25:00',5.29),('8902','2013-05-29','09:30:00',5.15),('8902','2013-05-29','09:35:00',5.49),('8902','2013-05-29','09:40:00',5.9),('8902','2013-05-29','09:45:00',5.97),('8902','2013-05-29','09:50:00',5.69),('8902','2013-05-29','09:55:00',5.18),('8902','2013-05-29','10:00:00',2.69),('8902','2013-05-29','10:05:00',2.11),('8902','2013-05-29','10:10:00',6.38),('8902','2013-05-29','10:15:00',3.69),('8902','2013-05-29','10:20:00',7.73),('8902','2013-05-29','10:25:00',2.72),('8902','2013-05-29','10:30:00',2.14),('8902','2013-05-29','10:35:00',2.6),('8902','2013-05-29','10:40:00',6.14),('8902','2013-05-29','10:45:00',6.02),('8902','2013-05-29','10:50:00',7.77),('8902','2013-05-29','10:55:00',6.51),('8902','2013-05-29','11:00:00',8.02),('8902','2013-05-29','11:05:00',8.87),('8902','2013-05-29','11:10:00',4.67),('8902','2013-05-29','11:15:00',3.23),('8902','2013-05-29','11:20:00',7.87),('8902','2013-05-29','11:25:00',4.21),('8902','2013-05-29','11:30:00',6.4),('8902','2013-05-29','11:35:00',9.51),('8902','2013-05-29','11:40:00',9.3),('8902','2013-05-29','11:45:00',7.7),('8902','2013-05-29','11:50:00',9.21),('8902','2013-05-29','11:55:00',2.58),('8902','2013-05-29','12:00:00',7.2),('8902','2013-05-29','12:05:00',9.65),('8902','2013-05-29','12:10:00',5.25),('8902','2013-05-29','12:15:00',6.86),('8902','2013-05-29','12:20:00',8.9),('8902','2013-05-29','12:25:00',6.28),('8902','2013-05-29','12:30:00',7.4),('8902','2013-05-29','12:35:00',5.66),('8902','2013-05-29','12:40:00',8.03),('8902','2013-05-29','12:45:00',3.68),('8902','2013-05-29','12:50:00',9.4),('8902','2013-05-29','13:15:00',5.1),('8902','2013-05-29','13:20:00',3.3),('8902','2013-05-29','13:25:00',3.96),('8902','2013-05-29','13:30:00',5.35),('8902','2013-05-29','13:35:00',3.26),('8902','2013-05-29','13:40:00',8.59),('8902','2013-05-29','13:45:00',7.69),('8902','2013-05-29','13:50:00',3.79),('8902','2013-05-29','13:55:00',3.78),('8902','2013-05-29','14:00:00',7),('8902','2013-05-29','14:05:00',9.48),('8902','2013-05-29','14:10:00',6.3),('8902','2013-05-29','14:15:00',9.23),('8902','2013-05-29','14:20:00',7.23),('8902','2013-05-29','14:25:00',7.1),('8902','2013-05-29','14:30:00',8.66),('8902','2013-05-29','14:35:00',7.24),('8902','2013-05-29','14:40:00',9.01),('8902','2013-05-29','14:45:00',8.91),('8902','2013-05-29','14:50:00',8.92),('8902','2013-05-29','14:55:00',8.49),('8902','2013-05-29','15:00:00',8.33),('8902','2013-05-29','15:05:00',7.81),('8902','2013-05-29','15:10:00',3.7),('8902','2013-05-29','15:15:00',8.73),('8902','2013-05-29','15:20:00',8.64),('8902','2013-05-29','15:25:00',8.38),('8902','2013-05-29','15:30:00',7.71),('8902','2013-05-29','15:35:00',6.49),('8902','2013-05-29','15:40:00',8.83),('8902','2013-05-29','15:45:00',8.67),('8902','2013-05-29','15:50:00',4.85),('8902','2013-05-29','15:55:00',5.92),('8902','2013-05-29','16:00:00',8.49),('8902','2013-05-29','16:05:00',7.27),('8902','2013-05-29','16:10:00',7.78),('8902','2013-05-29','16:15:00',7.36),('8902','2013-05-29','16:20:00',6.77),('8902','2013-05-29','16:25:00',4.79),('8902','2013-05-29','16:30:00',4.21),('8902','2013-05-29','16:35:00',4.23),('8902','2013-05-29','16:40:00',2.87),('8902','2013-05-29','16:45:00',4.72),('8902','2013-05-29','16:50:00',5.12),('8902','2013-05-29','16:55:00',4.89),('8902','2013-05-29','17:00:00',4.08),('8902','2013-05-29','17:05:00',3.9),('8902','2013-05-29','17:10:00',1.5),('8902','2013-05-29','17:15:00',1.83),('8902','2013-05-29','17:20:00',2),('8902','2013-05-29','17:25:00',2.07),('8902','2013-05-29','17:30:00',1.96),('8902','2013-05-29','17:35:00',1.29),('8902','2013-05-29','17:55:00',1.02),('8902','2013-05-29','18:00:00',1.68),('8902','2013-05-29','18:05:00',1.93),('8902','2013-05-29','18:10:00',1.77),('8902','2013-05-29','18:15:00',1.4),('8902','2013-05-29','18:20:00',1.26),('8902','2013-05-29','18:25:00',1.37),('8902','2013-05-29','18:30:00',1.54),('8902','2013-05-29','18:35:00',2.2),('8902','2013-05-29','18:40:00',2.27),('8902','2013-05-29','18:45:00',2.37),('8902','2013-05-29','18:50:00',2.41),('8902','2013-05-29','18:55:00',1.22),('8902','2013-05-29','19:00:00',1.07),('8902','2013-05-28','07:20:00',1.04),('8902','2013-05-28','07:25:00',1.19),('8902','2013-05-28','07:30:00',1.34),('8902','2013-05-28','07:35:00',1.52),('8902','2013-05-28','07:40:00',1.68),('8902','2013-05-28','07:45:00',1.84),('8902','2013-05-28','07:50:00',2.01),('8902','2013-05-28','07:55:00',2.18),('8902','2013-05-28','08:00:00',2.36),('8902','2013-05-28','08:05:00',2.53),('8902','2013-05-28','08:10:00',2.72),('8902','2013-05-28','08:15:00',2.9),('8902','2013-05-28','08:20:00',3.05),('8902','2013-05-28','08:25:00',3.22),('8902','2013-05-28','08:30:00',3.4),('8902','2013-05-28','08:35:00',3.58),('8902','2013-05-28','08:40:00',3.76),('8902','2013-05-28','08:45:00',3.93),('8902','2013-05-28','08:50:00',4.09),('8902','2013-05-28','08:55:00',4.26),('8902','2013-05-28','09:00:00',4.43),('8902','2013-05-28','09:05:00',4.58),('8902','2013-05-28','09:10:00',4.74),('8902','2013-05-28','09:15:00',4.88),('8902','2013-05-28','09:20:00',5.01),('8902','2013-05-28','09:25:00',5.15),('8902','2013-05-28','09:30:00',5.28),('8902','2013-05-28','09:35:00',5.41),('8902','2013-05-28','09:40:00',5.61),('8902','2013-05-28','09:45:00',5.75),('8902','2013-05-28','09:50:00',5.9),('8902','2013-05-28','09:55:00',6.03),('8902','2013-05-28','10:00:00',6.12),('8902','2013-05-28','10:05:00',6.25),('8902','2013-05-28','10:10:00',6.35),('8902','2013-05-28','10:15:00',6.47),('8902','2013-05-28','10:20:00',6.61),('8902','2013-05-28','10:25:00',6.73),('8902','2013-05-28','10:30:00',6.85),('8902','2013-05-28','10:35:00',6.98),('8902','2013-05-28','10:40:00',7.1),('8902','2013-05-28','10:45:00',7.19),('8902','2013-05-28','10:50:00',7.3),('8902','2013-05-28','10:55:00',7.39),('8902','2013-05-28','11:00:00',7.5),('8902','2013-05-28','11:05:00',6.69),('8902','2013-05-28','11:10:00',7.82),('8902','2013-05-28','11:15:00',5.29),('8902','2013-05-28','11:20:00',8.25),('8902','2013-05-28','11:25:00',8.73),('8902','2013-05-28','11:30:00',7.45),('8902','2013-05-28','11:35:00',8.76),('8902','2013-05-28','11:40:00',8.1),('8902','2013-05-28','11:45:00',7.54),('8902','2013-05-28','11:50:00',5.6),('8902','2013-05-28','11:55:00',7.34),('8902','2013-05-28','12:00:00',7.33),('8902','2013-05-28','12:05:00',5.19),('8902','2013-05-28','12:10:00',6.59),('8902','2013-05-28','12:15:00',7.72),('8902','2013-05-28','12:20:00',6.46),('8902','2013-05-28','12:25:00',8.89),('8902','2013-05-28','12:30:00',8.73),('8902','2013-05-28','12:35:00',8.53),('8902','2013-05-28','12:40:00',8.71),('8902','2013-05-28','12:45:00',7.55),('8902','2013-05-28','12:50:00',8.15),('8902','2013-05-28','12:55:00',8.41),('8902','2013-05-28','13:00:00',8.72),('8902','2013-05-28','13:05:00',8.24),('8902','2013-05-28','13:10:00',7.75),('8902','2013-05-28','13:15:00',8.28),('8902','2013-05-28','13:20:00',7.38),('8902','2013-05-28','13:25:00',9.3),('8902','2013-05-28','13:30:00',9.1),('8902','2013-05-28','13:35:00',8.45),('8902','2013-05-28','13:40:00',9.33),('8902','2013-05-28','13:45:00',8.27),('8902','2013-05-28','13:50:00',7.38),('8902','2013-05-28','13:55:00',7.4),('8902','2013-05-28','14:00:00',8.66),('8902','2013-05-28','14:05:00',8.62),('8902','2013-05-28','14:10:00',8.3),('8902','2013-05-28','14:15:00',8.61),('8902','2013-05-28','14:20:00',8.61),('8902','2013-05-28','14:25:00',8.5),('8902','2013-05-28','14:30:00',8.63),('8902','2013-05-28','14:35:00',5.53),('8902','2013-05-28','14:40:00',7.89),('8902','2013-05-28','14:45:00',8.74),('8902','2013-05-28','14:50:00',8.79),('8902','2013-05-28','14:55:00',8.4),('8902','2013-05-28','15:00:00',7.29),('8902','2013-05-28','15:05:00',8.63),('8902','2013-05-28','15:10:00',7.52),('8902','2013-05-28','15:15:00',4.45),('8902','2013-05-28','15:20:00',5.91),('8902','2013-05-28','15:25:00',5.93),('8902','2013-05-28','15:30:00',5.32),('8902','2013-05-28','15:35:00',5.68),('8902','2013-05-28','15:40:00',4.92),('8902','2013-05-28','15:45:00',6),('8902','2013-05-28','15:50:00',6.01),('8902','2013-05-28','15:55:00',5.81),('8902','2013-05-28','16:00:00',5.01),('8902','2013-05-28','16:05:00',5.18),('8902','2013-05-28','16:10:00',4.26),('8902','2013-05-28','16:15:00',3.95),('8902','2013-05-28','16:20:00',3.92),('8902','2013-05-28','16:25:00',3.8),('8902','2013-05-28','16:30:00',3.6),('8902','2013-05-28','16:35:00',3.44),('8902','2013-05-28','16:40:00',3.83),('8902','2013-05-28','16:45:00',3.56),('8902','2013-05-28','16:50:00',2.77),('8902','2013-05-28','16:55:00',2.73),('8902','2013-05-28','17:00:00',2.63),('8902','2013-05-28','17:05:00',1.31),('8902','2013-05-28','17:25:00',1.09),('8902','2013-05-28','17:30:00',1.31),('8902','2013-05-28','17:35:00',1.94),('8902','2013-05-28','17:40:00',2.76),('8902','2013-05-28','17:45:00',2.12),('8902','2013-05-28','17:50:00',1.6),('8902','2013-05-28','17:55:00',1.25),('8902','2013-05-28','18:00:00',1.5),('8902','2013-05-28','18:05:00',1.75),('8902','2013-05-28','18:10:00',1.91),('8902','2013-05-28','18:15:00',3.26),('8902','2013-05-28','18:20:00',2.91),('8902','2013-05-28','19:05:00',1.04),('8902','2013-05-28','19:10:00',1.05),('8902','2013-05-28','19:15:00',1.09),('8902','2013-05-27','07:10:00',1.01),('8902','2013-05-27','07:15:00',1.34),('8902','2013-05-27','07:20:00',1.61),('8902','2013-05-27','07:25:00',1.71),('8902','2013-05-27','07:30:00',1.47),('8902','2013-05-27','07:35:00',1.41),('8902','2013-05-27','07:40:00',1.74),('8902','2013-05-27','07:45:00',1.92),('8902','2013-05-27','07:50:00',1.9),('8902','2013-05-27','07:55:00',1.98),('8902','2013-05-27','08:00:00',2.01),('8902','2013-05-27','08:05:00',2.15),('8902','2013-05-27','08:10:00',2.44),('8902','2013-05-27','08:15:00',2.81),('8902','2013-05-27','08:20:00',3.1),('8902','2013-05-27','08:25:00',2.89),('8902','2013-05-27','08:30:00',3.1),('8902','2013-05-27','08:35:00',2.96),('8902','2013-05-27','08:40:00',2.68),('8902','2013-05-27','08:45:00',2.52),('8902','2013-05-27','08:50:00',2.85),('8902','2013-05-27','08:55:00',2.76),('8902','2013-05-27','09:00:00',3.11),('8902','2013-05-27','09:05:00',3.24),('8902','2013-05-27','09:10:00',3.01),('8902','2013-05-27','09:15:00',2.84),('8902','2013-05-27','09:20:00',3.29),('8902','2013-05-27','09:25:00',3.83),('8902','2013-05-27','09:30:00',4.09),('8902','2013-05-27','09:35:00',4.27),('8902','2013-05-27','09:40:00',4.1),('8902','2013-05-27','09:45:00',3.76),('8902','2013-05-27','09:50:00',3.84),('8902','2013-05-27','09:55:00',4.26),('8902','2013-05-27','10:00:00',3.94),('8902','2013-05-27','10:05:00',4.17),('8902','2013-05-27','10:10:00',4.64),('8902','2013-05-27','10:15:00',4.79),('8902','2013-05-27','10:20:00',5.12),('8902','2013-05-27','10:25:00',4.94),('8902','2013-05-27','10:30:00',5.51),('8902','2013-05-27','10:35:00',5.63),('8902','2013-05-27','10:40:00',5.01),('8902','2013-05-27','10:45:00',4.84),('8902','2013-05-27','10:50:00',5.29),('8902','2013-05-27','10:55:00',4.48),('8902','2013-05-27','11:00:00',4.47),('8902','2013-05-27','11:05:00',4.4),('8902','2013-05-27','11:10:00',4.93),('8902','2013-05-27','11:15:00',3.62),('8902','2013-05-27','11:20:00',4.38),('8902','2013-05-27','11:25:00',3.6),('8902','2013-05-27','11:30:00',6.65),('8902','2013-05-27','11:35:00',5.45),('8902','2013-05-27','11:40:00',7.29),('8902','2013-05-27','11:45:00',6.82),('8902','2013-05-27','11:50:00',2.19),('8902','2013-05-27','11:55:00',2.84),('8902','2013-05-27','12:00:00',2.99),('8902','2013-05-27','12:05:00',3.46),('8902','2013-05-27','12:10:00',5.72),('8902','2013-05-27','12:15:00',5.3),('8902','2013-05-27','12:20:00',4.39),('8902','2013-05-27','12:25:00',4.53),('8902','2013-05-27','12:30:00',5.09),('8902','2013-05-27','12:35:00',4.88),('8902','2013-05-27','12:40:00',4.96),('8902','2013-05-27','12:45:00',5.68),('8902','2013-05-27','12:50:00',5.06),('8902','2013-05-27','12:55:00',5.03),('8902','2013-05-27','13:00:00',5.22),('8902','2013-05-27','13:05:00',5.53),('8902','2013-05-27','13:10:00',5.77),('8902','2013-05-27','13:15:00',5.56),('8902','2013-05-27','13:20:00',6.44),('8902','2013-05-27','13:25:00',3.59),('8902','2013-05-27','13:30:00',4.09),('8902','2013-05-27','13:35:00',3.41),('8902','2013-05-27','13:40:00',3.69),('8902','2013-05-27','13:45:00',3.63),('8902','2013-05-27','13:50:00',5.61),('8902','2013-05-27','13:55:00',5.55),('8902','2013-05-27','14:00:00',4.96),('8902','2013-05-27','14:05:00',5.21),('8902','2013-05-27','14:10:00',7.3),('8902','2013-05-27','14:15:00',7.55),('8902','2013-05-27','14:20:00',4.87),('8902','2013-05-27','14:25:00',5.5),('8902','2013-05-27','14:30:00',6.38),('8902','2013-05-27','14:35:00',5.94),('8902','2013-05-27','14:40:00',6.52),('8902','2013-05-27','14:45:00',7.27),('8902','2013-05-27','14:50:00',5.3),('8902','2013-05-27','14:55:00',4.6),('8902','2013-05-27','15:00:00',4.35),('8902','2013-05-27','15:05:00',7.42),('8902','2013-05-27','15:10:00',3.21),('8902','2013-05-27','15:15:00',5.39),('8902','2013-05-27','15:20:00',6.25),('8902','2013-05-27','15:25:00',3.96),('8902','2013-05-27','15:30:00',2.9),('8902','2013-05-27','15:35:00',2.96),('8902','2013-05-27','15:40:00',5.38),('8902','2013-05-27','15:45:00',7.38),('8902','2013-05-27','15:50:00',6.05),('8902','2013-05-27','15:55:00',4.63),('8902','2013-05-27','16:00:00',3.41),('8902','2013-05-27','16:05:00',2.59),('8902','2013-05-27','16:10:00',2.91),('8902','2013-05-27','16:15:00',2.82),('8902','2013-05-27','16:20:00',4.36),('8902','2013-05-27','16:25:00',4.47),('8902','2013-05-27','16:30:00',4.71),('8902','2013-05-27','16:35:00',6.01),('8902','2013-05-27','16:40:00',5.62),('8902','2013-05-27','16:45:00',5.37),('8902','2013-05-27','16:50:00',5.11),('8902','2013-05-27','16:55:00',5.07),('8902','2013-05-27','17:00:00',5.01),('8902','2013-05-27','17:05:00',4.89),('8902','2013-05-27','17:10:00',4.71),('8902','2013-05-27','17:15:00',4.57),('8902','2013-05-27','17:20:00',4.4),('8902','2013-05-27','17:25:00',4.21),('8902','2013-05-27','17:30:00',4.08),('8902','2013-05-27','17:35:00',3.86),('8902','2013-05-27','17:40:00',2.86),('8902','2013-05-27','17:45:00',3.54),('8902','2013-05-27','17:50:00',3.33),('8902','2013-05-27','17:55:00',3.18),('8902','2013-05-27','18:00:00',3.2),('8902','2013-05-27','18:05:00',2.91),('8902','2013-05-27','18:10:00',2.79),('8902','2013-05-27','18:15:00',1.29),('8902','2013-05-27','18:30:00',1.2),('8902','2013-05-27','18:35:00',1.9),('8902','2013-05-27','18:40:00',1.75),('8902','2013-05-27','18:45:00',1.58),('8902','2013-05-27','18:50:00',1.4),('8902','2013-05-27','18:55:00',1.28),('8902','2013-05-27','19:00:00',1.12),('8902','2013-05-26','07:25:00',1.26),('8902','2013-05-26','07:30:00',1.42),('8902','2013-05-26','07:35:00',1.63),('8902','2013-05-26','07:40:00',1.8),('8902','2013-05-26','07:45:00',1.85),('8902','2013-05-26','07:50:00',1.97),('8902','2013-05-26','07:55:00',1.33),('8902','2013-05-26','08:00:00',1.96),('8902','2013-05-26','08:05:00',2.5),('8902','2013-05-26','08:10:00',3.07),('8902','2013-05-26','08:15:00',2.74),('8902','2013-05-26','08:20:00',2.87),('8902','2013-05-26','08:25:00',2.7),('8902','2013-05-26','08:30:00',3.53),('8902','2013-05-26','08:35:00',3.69),('8902','2013-05-26','08:40:00',3.88),('8902','2013-05-26','08:45:00',4.1),('8902','2013-05-26','08:50:00',4.84),('8902','2013-05-26','08:55:00',4.89),('8902','2013-05-26','09:00:00',5.02),('8902','2013-05-26','09:05:00',5.34),('8902','2013-05-26','09:10:00',4.86),('8902','2013-05-26','09:15:00',4.44),('8902','2013-05-26','09:20:00',5.29),('8902','2013-05-26','09:25:00',2.14),('8902','2013-05-26','09:30:00',5.47),('8902','2013-05-26','09:35:00',5.77),('8902','2013-05-26','09:40:00',5.88),('8902','2013-05-26','09:45:00',6.03),('8902','2013-05-26','09:50:00',5.89),('8902','2013-05-26','09:55:00',6.62),('8902','2013-05-26','10:00:00',6.66),('8902','2013-05-26','10:05:00',6.68),('8902','2013-05-26','10:10:00',6.75),('8902','2013-05-26','10:15:00',6.93),('8902','2013-05-26','10:20:00',6.5),('8902','2013-05-26','10:25:00',3.41),('8902','2013-05-26','10:30:00',6.52),('8902','2013-05-26','10:35:00',3.27),('8902','2013-05-26','10:40:00',2.92),('8902','2013-05-26','10:45:00',5.45),('8902','2013-05-26','10:50:00',5.32),('8902','2013-05-26','10:55:00',4.08),('8902','2013-05-26','11:00:00',5.23),('8902','2013-05-26','11:05:00',8.97),('8902','2013-05-26','11:10:00',7.79),('8902','2013-05-26','11:15:00',5.3),('8902','2013-05-26','11:20:00',4.81),('8902','2013-05-26','11:25:00',9.59),('8902','2013-05-26','11:30:00',4),('8902','2013-05-26','11:35:00',5.51),('8902','2013-05-26','11:40:00',5.34),('8902','2013-05-26','11:45:00',6.98),('8902','2013-05-26','11:50:00',4.47),('8902','2013-05-26','11:55:00',5.11),('8902','2013-05-26','12:00:00',8.12),('8902','2013-05-26','12:05:00',6.36),('8902','2013-05-26','12:10:00',6.66),('8902','2013-05-26','12:15:00',8.82),('8902','2013-05-26','12:20:00',8.08),('8902','2013-05-26','12:25:00',9.43),('8902','2013-05-26','12:30:00',8.79),('8902','2013-05-26','12:35:00',7.29),('8902','2013-05-26','12:40:00',7.87),('8902','2013-05-26','12:45:00',9.7),('8902','2013-05-26','12:50:00',9.18),('8902','2013-05-26','12:55:00',9.28),('8902','2013-05-26','13:00:00',9.35),('8902','2013-05-26','13:05:00',3.04),('8902','2013-05-26','13:10:00',6.98),('8902','2013-05-26','13:15:00',6.22),('8902','2013-05-26','13:20:00',5.43),('8902','2013-05-26','13:25:00',9.18),('8902','2013-05-26','13:30:00',8.96),('8902','2013-05-26','13:35:00',7.34),('8902','2013-05-26','13:40:00',9.12),('8902','2013-05-26','13:45:00',9.26),('8902','2013-05-26','13:50:00',6.75),('8902','2013-05-26','13:55:00',6.32),('8902','2013-05-26','14:00:00',8.59),('8902','2013-05-26','14:05:00',8.8),('8902','2013-05-26','14:10:00',8),('8902','2013-05-26','14:15:00',7.38),('8902','2013-05-26','14:20:00',6.1),('8902','2013-05-26','14:25:00',8.23),('8902','2013-05-26','14:30:00',5.8),('8902','2013-05-26','14:35:00',8.41),('8902','2013-05-26','14:40:00',3.32),('8902','2013-05-26','14:45:00',8.38),('8902','2013-05-26','14:50:00',8.91),('8902','2013-05-26','14:55:00',7.35),('8902','2013-05-26','15:00:00',5.62),('8902','2013-05-26','15:05:00',4.95),('8902','2013-05-26','15:10:00',8.3),('8902','2013-05-26','15:15:00',5.75),('8902','2013-05-26','15:20:00',6.91),('8902','2013-05-26','15:25:00',6.52),('8902','2013-05-26','15:30:00',6.96),('8902','2013-05-26','15:35:00',8.08),('8902','2013-05-26','15:40:00',6.59),('8902','2013-05-26','15:45:00',5.94),('8902','2013-05-26','15:50:00',7.55),('8902','2013-05-26','15:55:00',4.96),('8902','2013-05-26','16:00:00',5.92),('8902','2013-05-26','16:05:00',4.34),('8902','2013-05-26','16:10:00',5.22),('8902','2013-05-26','16:15:00',4.52),('8902','2013-05-26','16:20:00',7.36),('8902','2013-05-26','16:25:00',7.16),('8902','2013-05-26','16:30:00',6.43),('8902','2013-05-26','16:35:00',5.94),('8902','2013-05-26','16:40:00',2.71),('8902','2013-05-26','16:45:00',2.37),('8902','2013-05-26','16:50:00',2.4),('8902','2013-05-26','16:55:00',2.57),('8902','2013-05-26','17:00:00',2.69),('8902','2013-05-26','17:05:00',2.73),('8902','2013-05-26','17:10:00',3.36),('8902','2013-05-26','17:15:00',2.8),('8902','2013-05-26','17:20:00',2.39),('8902','2013-05-26','17:25:00',2.18),('8902','2013-05-26','17:30:00',2.13),('8902','2013-05-26','17:35:00',1.99),('8902','2013-05-26','17:40:00',1.84),('8902','2013-05-26','17:45:00',1.73),('8902','2013-05-26','17:50:00',1.66),('8902','2013-05-26','17:55:00',1.69),('8902','2013-05-26','18:00:00',1.69),('8902','2013-05-26','18:05:00',1.52),('8902','2013-05-26','18:10:00',1.56),('8902','2013-05-26','18:15:00',1.74),('8902','2013-05-26','18:20:00',2.19),('8902','2013-05-26','18:25:00',2.98),('8902','2013-05-26','18:30:00',2.41),('8902','2013-05-26','18:35:00',1.76),('8902','2013-05-26','18:40:00',1.1),('8902','2013-05-26','18:45:00',1.51),('8902','2013-05-26','18:50:00',1.23),('8902','2013-05-26','18:55:00',1.63),('8902','2013-05-26','19:00:00',1.72),('8902','2013-05-26','19:05:00',1.62),('8902','2013-05-26','19:10:00',1.36),('8902','2013-05-26','19:15:00',1.03),('8902','2013-05-25','07:20:00',1.55),('8902','2013-05-25','07:25:00',1.19),('8902','2013-05-25','07:35:00',1.49),('8902','2013-05-25','07:40:00',1.82),('8902','2013-05-25','07:45:00',2.12),('8902','2013-05-25','07:50:00',3.2),('8902','2013-05-25','07:55:00',1.52),('8902','2013-05-25','08:05:00',3.31),('8902','2013-05-25','08:10:00',3.3),('8902','2013-05-25','08:15:00',1.33),('8902','2013-05-25','08:20:00',1.57),('8902','2013-05-25','08:25:00',1.92),('8902','2013-05-25','08:30:00',3.81),('8902','2013-05-25','08:35:00',3.26),('8902','2013-05-25','08:40:00',3.69),('8902','2013-05-25','08:45:00',4.32),('8902','2013-05-25','08:50:00',5.14),('8902','2013-05-25','08:55:00',1.95),('8902','2013-05-25','09:00:00',3.32),('8902','2013-05-25','09:05:00',1.54),('8902','2013-05-25','09:10:00',3.5),('8902','2013-05-25','09:15:00',3.49),('8902','2013-05-25','09:20:00',1.53),('8902','2013-05-25','09:25:00',2.72),('8902','2013-05-25','09:30:00',1.55),('8902','2013-05-25','09:35:00',1.35),('8902','2013-05-25','09:40:00',1.69),('8902','2013-05-25','09:45:00',4.32),('8902','2013-05-25','09:50:00',1.37),('8902','2013-05-25','09:55:00',1.81),('8902','2013-05-25','10:00:00',3.17),('8902','2013-05-25','10:05:00',4.76),('8902','2013-05-25','10:10:00',7.34),('8902','2013-05-25','10:15:00',5.34),('8902','2013-05-25','10:20:00',5.49),('8902','2013-05-25','10:25:00',5.02),('8902','2013-05-25','10:30:00',6.77),('8902','2013-05-25','10:35:00',6.96),('8902','2013-05-25','10:40:00',7.44),('8902','2013-05-25','10:45:00',7.57),('8902','2013-05-25','10:50:00',7.72),('8902','2013-05-25','10:55:00',7.44),('8902','2013-05-25','11:00:00',7.7),('8902','2013-05-25','11:05:00',7.98),('8902','2013-05-25','11:10:00',8.04),('8902','2013-05-25','11:15:00',8.07),('8902','2013-05-25','11:20:00',8.15),('8902','2013-05-25','11:25:00',8.24),('8902','2013-05-25','11:30:00',8.32),('8902','2013-05-25','11:35:00',8.21),('8902','2013-05-25','11:40:00',8.31),('8902','2013-05-25','11:45:00',8.71),('8902','2013-05-25','11:50:00',8.53),('8902','2013-05-25','11:55:00',8.88),('8902','2013-05-25','12:00:00',8.65),('8902','2013-05-25','12:05:00',8.74),('8902','2013-05-25','12:10:00',8.09),('8902','2013-05-25','12:15:00',7.86),('8902','2013-05-25','12:20:00',6.17),('8902','2013-05-25','12:25:00',8.15),('8902','2013-05-25','12:30:00',9.26),('8902','2013-05-25','12:35:00',9.15),('8902','2013-05-25','12:40:00',8.56),('8902','2013-05-25','12:45:00',6.98),('8902','2013-05-25','12:50:00',9.2),('8902','2013-05-25','12:55:00',9.1),('8902','2013-05-25','13:00:00',8.93),('8902','2013-05-25','13:05:00',8.05),('8902','2013-05-25','13:10:00',9.03),('8902','2013-05-25','13:15:00',8.89),('8902','2013-05-25','13:20:00',9.37),('8902','2013-05-25','13:25:00',9.12),('8902','2013-05-25','13:30:00',9.23),('8902','2013-05-25','13:35:00',9.2),('8902','2013-05-25','13:40:00',9.01),('8902','2013-05-25','13:45:00',9.08),('8902','2013-05-25','13:50:00',8.94),('8902','2013-05-25','13:55:00',8.76),('8902','2013-05-25','14:00:00',8.89),('8902','2013-05-25','14:05:00',8.87),('8902','2013-05-25','14:10:00',8.77),('8902','2013-05-25','14:15:00',8.73),('8902','2013-05-25','14:20:00',8.74),('8902','2013-05-25','14:25:00',8.64),('8902','2013-05-25','14:30:00',8.66),('8902','2013-05-25','14:35:00',8.57),('8902','2013-05-25','14:40:00',8.51),('8902','2013-05-25','14:45:00',8.44),('8902','2013-05-25','14:50:00',8.39),('8902','2013-05-25','14:55:00',8.31),('8902','2013-05-25','15:00:00',8.24),('8902','2013-05-25','15:05:00',8.26),('8902','2013-05-25','15:10:00',8.17),('8902','2013-05-25','15:15:00',8.13),('8902','2013-05-25','15:20:00',8.04),('8902','2013-05-25','15:25:00',7.95),('8902','2013-05-25','15:30:00',7.9),('8902','2013-05-25','15:35:00',7.8),('8902','2013-05-25','15:40:00',7.72),('8902','2013-05-25','15:45:00',7.58),('8902','2013-05-25','15:50:00',7.46),('8902','2013-05-25','15:55:00',7.36),('8902','2013-05-25','16:00:00',7.28),('8902','2013-05-25','16:05:00',7.16),('8902','2013-05-25','16:10:00',7.07),('8902','2013-05-25','16:15:00',6.93),('8902','2013-05-25','16:20:00',6.8),('8902','2013-05-25','16:25:00',6.68),('8902','2013-05-25','16:30:00',6.45),('8902','2013-05-25','16:35:00',6.36),('8902','2013-05-25','16:40:00',6.22),('8902','2013-05-25','16:45:00',6.1),('8902','2013-05-25','16:50:00',5.87),('8902','2013-05-25','16:55:00',5.8),('8902','2013-05-25','17:00:00',5.65),('8902','2013-05-25','17:05:00',5.51),('8902','2013-05-25','17:10:00',5.32),('8902','2013-05-25','17:15:00',5.1),('8902','2013-05-25','17:20:00',4.96),('8902','2013-05-25','17:25:00',4.81),('8902','2013-05-25','17:30:00',4.65),('8902','2013-05-25','17:35:00',4.4),('8902','2013-05-25','17:40:00',4.28),('8902','2013-05-25','17:45:00',4.1),('8902','2013-05-25','17:50:00',3.78),('8902','2013-05-25','17:55:00',3.52),('8902','2013-05-25','18:00:00',3.53),('8902','2013-05-25','18:05:00',3.31),('8902','2013-05-25','18:10:00',3.15),('8902','2013-05-25','18:15:00',2.95),('8902','2013-05-25','18:20:00',2.77),('8902','2013-05-25','18:25:00',2.55),('8902','2013-05-25','18:30:00',2.37),('8902','2013-05-25','18:35:00',2.18),('8902','2013-05-25','18:40:00',1.95),('8902','2013-05-25','18:45:00',1.75),('8902','2013-05-25','18:50:00',1.59),('8902','2013-05-25','18:55:00',1.44),('8902','2013-05-25','19:00:00',1.27),('8902','2013-05-25','19:05:00',1.08),('8902','2013-05-24','07:15:00',1.5),('8902','2013-05-24','07:20:00',1.46),('8902','2013-05-24','07:30:00',1.5),('8902','2013-05-24','07:35:00',2.31),('8902','2013-05-24','07:40:00',2.28),('8902','2013-05-24','07:45:00',1.07),('8902','2013-05-24','07:50:00',1.06),('8902','2013-05-24','07:55:00',2.46),('8902','2013-05-24','08:00:00',3.13),('8902','2013-05-24','08:05:00',3.61),('8902','2013-05-24','08:10:00',2.86),('8902','2013-05-24','08:15:00',1.23),('8902','2013-05-24','08:20:00',2.3),('8902','2013-05-24','08:25:00',3.9),('8902','2013-05-24','08:30:00',4.87),('8902','2013-05-24','08:35:00',2.86),('8902','2013-05-24','08:40:00',3.08),('8902','2013-05-24','08:45:00',2.45),('8902','2013-05-24','08:50:00',3.22),('8902','2013-05-24','08:55:00',3.27),('8902','2013-05-24','09:00:00',2.49),('8902','2013-05-24','09:05:00',5.71),('8902','2013-05-24','09:10:00',5.43),('8902','2013-05-24','09:15:00',6.53),('8902','2013-05-24','09:20:00',3.35),('8902','2013-05-24','09:25:00',2.98),('8902','2013-05-24','09:30:00',2.03),('8902','2013-05-24','09:35:00',4.24),('8902','2013-05-24','09:40:00',7.17),('8902','2013-05-24','09:45:00',5.19),('8902','2013-05-24','09:50:00',6.15),('8902','2013-05-24','09:55:00',4.61),('8902','2013-05-24','10:00:00',1.93),('8902','2013-05-24','10:05:00',1.35),('8902','2013-05-24','10:10:00',1.89),('8902','2013-05-24','10:15:00',2.1),('8902','2013-05-24','10:25:00',1.64),('8902','2013-05-24','10:30:00',1.92),('8902','2013-05-24','10:35:00',1.63),('8902','2013-05-24','10:40:00',2.74),('8902','2013-05-24','10:45:00',2.8),('8902','2013-05-24','10:50:00',2.68),('8902','2013-05-24','10:55:00',1.8),('8902','2013-05-24','11:00:00',2.03),('8902','2013-05-24','11:05:00',4.04),('8902','2013-05-24','11:10:00',8.37),('8902','2013-05-24','11:15:00',7.35),('8902','2013-05-24','11:20:00',5.49),('8902','2013-05-24','11:25:00',1.95),('8902','2013-05-24','11:35:00',1.84),('8902','2013-05-24','11:40:00',3.27),('8902','2013-05-24','11:45:00',4.4),('8902','2013-05-24','11:50:00',3.4),('8902','2013-05-24','11:55:00',3.49),('8902','2013-05-24','12:00:00',2.37),('8902','2013-05-24','12:05:00',2.28),('8902','2013-05-24','12:10:00',3.08),('8902','2013-05-24','12:15:00',1.98),('8902','2013-05-24','12:20:00',2.33),('8902','2013-05-24','12:25:00',3.46),('8902','2013-05-24','12:30:00',3.08),('8902','2013-05-24','12:35:00',2.29),('8902','2013-05-24','12:40:00',3.01),('8902','2013-05-24','12:45:00',3.67),('8902','2013-05-24','12:50:00',2.74),('8902','2013-05-24','12:55:00',4.04),('8902','2013-05-24','13:00:00',2.19),('8902','2013-05-24','13:05:00',2.84),('8902','2013-05-24','13:10:00',2.83),('8902','2013-05-24','13:15:00',3.25),('8902','2013-05-24','13:20:00',3.95),('8902','2013-05-24','13:25:00',5.09),('8902','2013-05-24','13:30:00',4.06),('8902','2013-05-24','13:35:00',2.46),('8902','2013-05-24','13:40:00',3.8),('8902','2013-05-24','13:45:00',3.6),('8902','2013-05-24','13:50:00',4.84),('8902','2013-05-24','13:55:00',5.59),('8902','2013-05-24','14:00:00',8.13),('8902','2013-05-24','14:05:00',9.28),('8902','2013-05-24','14:10:00',8.89),('8902','2013-05-24','14:15:00',8.77),('8902','2013-05-24','14:20:00',6.72),('8902','2013-05-24','14:25:00',7.61),('8902','2013-05-24','14:30:00',7.18),('8902','2013-05-24','14:35:00',4.08),('8902','2013-05-24','14:40:00',2.8),('8902','2013-05-24','14:45:00',3.62),('8902','2013-05-24','14:50:00',3.7),('8902','2013-05-24','14:55:00',3.47),('8902','2013-05-24','15:00:00',5.79),('8902','2013-05-24','15:05:00',5.9),('8902','2013-05-24','15:10:00',3.62),('8902','2013-05-24','15:15:00',5.68),('8902','2013-05-24','15:20:00',2.48),('8902','2013-05-24','15:25:00',4.97),('8902','2013-05-24','15:30:00',5.31),('8902','2013-05-24','15:35:00',8.55),('8902','2013-05-24','15:40:00',7.36),('8902','2013-05-24','15:45:00',7.28),('8902','2013-05-24','15:50:00',8.31),('8902','2013-05-24','15:55:00',8.47),('8902','2013-05-24','16:00:00',6.16),('8902','2013-05-24','16:05:00',2.88),('8902','2013-05-24','16:10:00',5.65),('8902','2013-05-24','16:15:00',3.96),('8902','2013-05-24','16:20:00',3.05),('8902','2013-05-24','16:25:00',3.33),('8902','2013-05-24','16:30:00',4.89),('8902','2013-05-24','16:35:00',4.93),('8902','2013-05-24','16:40:00',5.47),('8902','2013-05-24','16:45:00',5.79),('8902','2013-05-24','16:50:00',4.55),('8902','2013-05-24','16:55:00',2.13),('8902','2013-05-24','17:00:00',2.39),('8902','2013-05-24','17:05:00',2.28),('8902','2013-05-24','17:10:00',5.95),('8902','2013-05-24','17:15:00',3.7),('8902','2013-05-24','17:20:00',3.49),('8902','2013-05-24','17:25:00',3.97),('8902','2013-05-24','17:30:00',1.17),('8902','2013-05-24','17:35:00',2.9),('8902','2013-05-24','17:40:00',1.91),('8902','2013-05-24','17:45:00',2.43),('8902','2013-05-24','17:50:00',3.22),('8902','2013-05-24','17:55:00',1.34),('8902','2013-05-24','18:00:00',1.63),('8902','2013-05-24','18:05:00',1.59),('8902','2013-05-24','18:10:00',1.72),('8902','2013-05-24','18:15:00',1.39),('8902','2013-05-24','18:20:00',1.63),('8902','2013-05-23','07:00:00',1.06),('8902','2013-05-23','07:05:00',1.1),('8902','2013-05-23','07:40:00',1.09),('8902','2013-05-23','07:50:00',1.01),('8902','2013-05-23','08:00:00',1.31),('8902','2013-05-23','08:05:00',2.81),('8902','2013-05-23','08:10:00',3.39),('8902','2013-05-23','08:15:00',3.23),('8902','2013-05-23','08:20:00',1.82),('8902','2013-05-23','08:25:00',1.41),('8902','2013-05-23','08:30:00',3.48),('8902','2013-05-23','08:35:00',2.76),('8902','2013-05-23','08:40:00',1.01),('8902','2013-05-23','08:45:00',3.15),('8902','2013-05-23','08:50:00',3.84),('8902','2013-05-23','08:55:00',4.45),('8902','2013-05-23','09:00:00',4.79),('8902','2013-05-23','09:05:00',5.54),('8902','2013-05-23','09:10:00',2.35),('8902','2013-05-23','09:15:00',1.18),('8902','2013-05-23','09:20:00',4.15),('8902','2013-05-23','09:25:00',3.25),('8902','2013-05-23','09:30:00',3.33),('8902','2013-05-23','09:35:00',1.42),('8902','2013-05-23','09:40:00',2.73),('8902','2013-05-23','09:45:00',2.19),('8902','2013-05-23','09:50:00',2.88),('8902','2013-05-23','09:55:00',4.4),('8902','2013-05-23','10:00:00',4.96),('8902','2013-05-23','10:05:00',1.57),('8902','2013-05-23','10:10:00',1.28),('8902','2013-05-23','10:20:00',1.74),('8902','2013-05-23','10:25:00',4.2),('8902','2013-05-23','10:30:00',7.73),('8902','2013-05-23','10:35:00',7.24),('8902','2013-05-23','10:40:00',6.07),('8902','2013-05-23','10:45:00',6.68),('8902','2013-05-23','10:50:00',5.01),('8902','2013-05-23','10:55:00',8.17),('8902','2013-05-23','11:00:00',5.88),('8902','2013-05-23','11:05:00',5.87),('8902','2013-05-23','11:10:00',7.58),('8902','2013-05-23','11:15:00',7.03),('8902','2013-05-23','11:20:00',7.97),('8902','2013-05-23','11:25:00',7.79),('8902','2013-05-23','11:30:00',6.02),('8902','2013-05-23','11:35:00',2.41),('8902','2013-05-23','11:40:00',2.18),('8902','2013-05-23','11:45:00',3.03),('8902','2013-05-23','11:50:00',9.43),('8902','2013-05-23','11:55:00',6.22),('8902','2013-05-23','12:00:00',3.43),('8902','2013-05-23','12:05:00',6),('8902','2013-05-23','12:10:00',6.69),('8902','2013-05-23','12:15:00',4.31),('8902','2013-05-23','12:20:00',4),('8902','2013-05-23','12:25:00',5.54),('8902','2013-05-23','12:30:00',7.78),('8902','2013-05-23','12:35:00',3.97),('8902','2013-05-23','12:40:00',5.21),('8902','2013-05-23','12:45:00',7.25),('8902','2013-05-23','12:50:00',5.7),('8902','2013-05-23','12:55:00',4.51),('8902','2013-05-23','13:00:00',4.31),('8902','2013-05-23','13:05:00',3.87),('8902','2013-05-23','13:10:00',4.91),('8902','2013-05-23','13:15:00',5.61),('8902','2013-05-23','13:20:00',6.65),('8902','2013-05-23','13:25:00',5.09),('8902','2013-05-23','13:30:00',3.88),('8902','2013-05-23','13:35:00',5.58),('8902','2013-05-23','13:40:00',5.25),('8902','2013-05-23','13:45:00',2.68),('8902','2013-05-23','13:50:00',2.4),('8902','2013-05-23','13:55:00',7.05),('8902','2013-05-23','14:00:00',4.7),('8902','2013-05-23','14:05:00',4.5),('8902','2013-05-23','14:10:00',2.24),('8902','2013-05-23','14:15:00',6.93),('8902','2013-05-23','14:20:00',6.67),('8902','2013-05-23','14:25:00',7.46),('8902','2013-05-23','14:30:00',5.64),('8902','2013-05-23','14:35:00',6.03),('8902','2013-05-23','14:40:00',5.08),('8902','2013-05-23','14:45:00',5.31),('8902','2013-05-23','14:50:00',2.62),('8902','2013-05-23','14:55:00',3.19),('8902','2013-05-23','15:00:00',4.31),('8902','2013-05-23','15:05:00',7.63),('8902','2013-05-23','15:10:00',5.98),('8902','2013-05-23','15:15:00',6.34),('8902','2013-05-23','15:20:00',7.96),('8902','2013-05-23','15:25:00',6.78),('8902','2013-05-23','15:30:00',6.3),('8902','2013-05-23','15:35:00',5.33),('8902','2013-05-23','15:40:00',5.4),('8902','2013-05-23','15:45:00',7.5),('8902','2013-05-23','15:50:00',7.69),('8902','2013-05-23','15:55:00',9.24),('8902','2013-05-23','16:00:00',4.58),('8902','2013-05-23','16:05:00',3.85),('8902','2013-05-23','16:10:00',3.99),('8902','2013-05-23','16:15:00',5.16),('8902','2013-05-23','16:20:00',3.66),('8902','2013-05-23','16:25:00',4.74),('8902','2013-05-23','16:30:00',6.35),('8902','2013-05-23','16:35:00',2.58),('8902','2013-05-23','16:40:00',1.42),('8902','2013-05-23','16:50:00',2.49),('8902','2013-05-23','16:55:00',4.16),('8902','2013-05-23','17:00:00',2.55),('8902','2013-05-23','17:05:00',1.7),('8902','2013-05-23','17:10:00',1.36),('8902','2013-05-23','17:15:00',1.38),('8902','2013-05-23','17:20:00',1.8),('8902','2013-05-23','17:25:00',1.95),('8902','2013-05-23','17:30:00',2.1),('8902','2013-05-23','17:35:00',2.12),('8902','2013-05-23','17:40:00',1.76),('8902','2013-05-23','17:45:00',1.43),('8902','2013-05-23','17:50:00',1.06),('8902','2013-05-23','18:05:00',1.07),('8902','2013-05-23','18:10:00',1.11),('8902','2013-05-22','07:10:00',1.56),('8902','2013-05-22','07:15:00',1.29),('8902','2013-05-22','07:45:00',1.18),('8902','2013-05-22','07:50:00',1.52),('8902','2013-05-22','07:55:00',1.73),('8902','2013-05-22','08:00:00',2.06),('8902','2013-05-22','08:05:00',2.76),('8902','2013-05-22','08:10:00',2.31),('8902','2013-05-22','08:25:00',1.25),('8902','2013-05-22','08:30:00',2.43),('8902','2013-05-22','08:35:00',4.08),('8902','2013-05-22','08:40:00',3.6),('8902','2013-05-22','08:45:00',3.25),('8902','2013-05-22','08:50:00',2.69),('8902','2013-05-22','08:55:00',1.01),('8902','2013-05-22','09:00:00',4.44),('8902','2013-05-22','09:05:00',3.32),('8902','2013-05-22','09:15:00',1.42),('8902','2013-05-22','09:20:00',2.63),('8902','2013-05-22','09:25:00',5.81),('8902','2013-05-22','09:30:00',6.52),('8902','2013-05-22','09:35:00',4.89),('8902','2013-05-22','09:40:00',4.67),('8902','2013-05-22','09:45:00',4.03),('8902','2013-05-22','09:50:00',6.21),('8902','2013-05-22','09:55:00',3.6),('8902','2013-05-22','10:00:00',2.75),('8902','2013-05-22','10:05:00',5.12),('8902','2013-05-22','10:10:00',6.82),('8902','2013-05-22','10:15:00',5.93),('8902','2013-05-22','10:20:00',5.09),('8902','2013-05-22','10:25:00',6.81),('8902','2013-05-22','10:30:00',7.27),('8902','2013-05-22','10:35:00',6.27),('8902','2013-05-22','10:40:00',6.98),('8902','2013-05-22','10:45:00',7.85),('8902','2013-05-22','10:50:00',7.55),('8902','2013-05-22','10:55:00',8.21),('8902','2013-05-22','11:00:00',6.87),('8902','2013-05-22','11:05:00',6.25),('8902','2013-05-22','11:10:00',4.51),('8902','2013-05-22','11:15:00',3.36),('8902','2013-05-22','11:20:00',3.66),('8902','2013-05-22','11:25:00',4.34),('8902','2013-05-22','11:30:00',6.72),('8902','2013-05-22','11:35:00',7.34),('8902','2013-05-22','11:40:00',8.12),('8902','2013-05-22','11:45:00',3.97),('8902','2013-05-22','11:50:00',8.69),('8902','2013-05-22','11:55:00',9.71),('8902','2013-05-22','12:00:00',8.26),('8902','2013-05-22','12:05:00',8.9),('8902','2013-05-22','12:10:00',9),('8902','2013-05-22','12:15:00',7.94),('8902','2013-05-22','12:20:00',5.42),('8902','2013-05-22','12:25:00',7.91),('8902','2013-05-22','12:30:00',6.24),('8902','2013-05-22','12:35:00',2.92),('8902','2013-05-22','12:40:00',7.11),('8902','2013-05-22','12:45:00',8.09),('8902','2013-05-22','12:50:00',5.97),('8902','2013-05-22','12:55:00',8.23),('8902','2013-05-22','13:00:00',9.61),('8902','2013-05-22','13:05:00',5.35),('8902','2013-05-22','13:10:00',7.73),('8902','2013-05-22','13:15:00',7.2),('8902','2013-05-22','13:20:00',6.93),('8902','2013-05-22','13:25:00',4.15),('8902','2013-05-22','13:30:00',5.13),('8902','2013-05-22','13:35:00',3.95),('8902','2013-05-22','13:40:00',3.55),('8902','2013-05-22','13:45:00',8.41),('8902','2013-05-22','13:50:00',5.31),('8902','2013-05-22','13:55:00',7.27),('8902','2013-05-22','14:00:00',8.34),('8902','2013-05-22','14:05:00',8.49),('8902','2013-05-22','14:10:00',9.8),('8902','2013-05-22','14:15:00',5.62),('8902','2013-05-22','14:20:00',9.51),('8902','2013-05-22','14:25:00',8.83),('8902','2013-05-22','14:30:00',2.89),('8902','2013-05-22','14:35:00',9.25),('8902','2013-05-22','14:40:00',8.12),('8902','2013-05-22','14:45:00',4.82),('8902','2013-05-22','14:50:00',4.59),('8902','2013-05-22','14:55:00',6.01),('8902','2013-05-22','15:00:00',6.61),('8902','2013-05-22','15:05:00',5.22),('8902','2013-05-22','15:10:00',2.78),('8902','2013-05-22','15:15:00',2.62),('8902','2013-05-22','15:20:00',6.45),('8902','2013-05-22','15:25:00',2.55),('8902','2013-05-22','15:30:00',5.09),('8902','2013-05-22','15:35:00',6.12),('8902','2013-05-22','15:40:00',3.9),('8902','2013-05-22','15:45:00',4.94),('8902','2013-05-22','15:50:00',2.31),('8902','2013-05-22','15:55:00',2.61),('8902','2013-05-22','16:00:00',7.3),('8902','2013-05-22','16:05:00',6.88),('8902','2013-05-22','16:10:00',5.28),('8902','2013-05-22','16:15:00',4.76),('8902','2013-05-22','16:20:00',6.4),('8902','2013-05-22','16:25:00',5.82),('8902','2013-05-22','16:30:00',6.48),('8902','2013-05-22','16:35:00',3.75),('8902','2013-05-22','16:40:00',3.55),('8902','2013-05-22','16:45:00',3.11),('8902','2013-05-22','16:50:00',3.4),('8902','2013-05-22','16:55:00',1.37),('8902','2013-05-22','17:05:00',1.64),('8902','2013-05-22','17:10:00',4.43),('8902','2013-05-22','17:15:00',3.61),('8902','2013-05-22','17:20:00',2.77),('8902','2013-05-22','17:25:00',2.01),('8902','2013-05-22','17:30:00',1.98),('8902','2013-05-22','17:35:00',2.42),('8902','2013-05-22','17:40:00',2.09),('8902','2013-05-22','17:45:00',1.94),('8902','2013-05-22','17:50:00',1.66),('8902','2013-05-22','17:55:00',2.12),('8902','2013-05-22','18:00:00',2.47),('8902','2013-05-22','18:05:00',3.92),('8902','2013-05-22','18:10:00',2.2),('8902','2013-05-22','18:45:00',1.54),('8902','2013-05-22','18:50:00',2.04),('8902','2013-05-22','18:55:00',1.69),('8902','2013-05-22','19:00:00',1.29),('8902','2013-05-21','07:25:00',1.15),('8902','2013-05-21','07:30:00',1.13),('8902','2013-05-21','07:35:00',1.08),('8902','2013-05-21','07:40:00',1.25),('8902','2013-05-21','07:45:00',1.37),('8902','2013-05-21','07:50:00',1.66),('8902','2013-05-21','07:55:00',1.85),('8902','2013-05-21','08:00:00',2.11),('8902','2013-05-21','08:05:00',2.58),('8902','2013-05-21','08:10:00',2),('8902','2013-05-21','08:15:00',3.45),('8902','2013-05-21','08:20:00',3.42),('8902','2013-05-21','08:25:00',3.31),('8902','2013-05-21','08:30:00',3.74),('8902','2013-05-21','08:35:00',4.45),('8902','2013-05-21','08:40:00',2.69),('8902','2013-05-21','08:45:00',3.22),('8902','2013-05-21','08:50:00',2.19),('8902','2013-05-21','09:10:00',1.24),('8902','2013-05-21','09:15:00',1.67),('8902','2013-05-21','09:20:00',1.62),('8902','2013-05-21','09:25:00',1.86),('8902','2013-05-21','09:30:00',4.94),('8902','2013-05-21','09:35:00',5.3),('8902','2013-05-21','09:40:00',5.28),('8902','2013-05-21','09:45:00',5.33),('8902','2013-05-21','09:50:00',5.45),('8902','2013-05-21','09:55:00',5.56),('8902','2013-05-21','10:00:00',5.69),('8902','2013-05-21','10:05:00',5.82),('8902','2013-05-21','10:10:00',5.94),('8902','2013-05-21','10:15:00',6.04),('8902','2013-05-21','10:20:00',6.04),('8902','2013-05-21','10:25:00',6.43),('8902','2013-05-21','10:30:00',6.41),('8902','2013-05-21','10:35:00',6.52),('8902','2013-05-21','10:40:00',6.73),('8902','2013-05-21','10:45:00',6.75),('8902','2013-05-21','10:50:00',6.71),('8902','2013-05-21','10:55:00',6.78),('8902','2013-05-21','11:00:00',6.98),('8902','2013-05-21','11:05:00',7.21),('8902','2013-05-21','11:10:00',6.8),('8902','2013-05-21','11:15:00',6.73),('8902','2013-05-21','11:20:00',7.4),('8902','2013-05-21','11:25:00',7.61),('8902','2013-05-21','11:30:00',6.49),('8902','2013-05-21','11:35:00',6.31),('8902','2013-05-21','11:40:00',6.74),('8902','2013-05-21','11:45:00',7.59),('8902','2013-05-21','11:50:00',4.61),('8902','2013-05-21','11:55:00',3.98),('8902','2013-05-21','12:00:00',5.67),('8902','2013-05-21','12:05:00',4.4),('8902','2013-05-21','12:10:00',4.19),('8902','2013-05-21','12:15:00',6.1),('8902','2013-05-21','12:20:00',8.74),('8902','2013-05-21','12:25:00',5.53),('8902','2013-05-21','12:30:00',4.26),('8902','2013-05-21','12:35:00',4.55),('8902','2013-05-21','12:40:00',3.04),('8902','2013-05-21','12:45:00',1.29),('8902','2013-05-21','13:00:00',2.4),('8902','2013-05-21','13:05:00',9.49),('8902','2013-05-21','13:10:00',4.3),('8902','2013-05-21','13:15:00',4.38),('8902','2013-05-21','13:20:00',4.18),('8902','2013-05-21','13:25:00',2.22),('8902','2013-05-21','13:30:00',3.48),('8902','2013-05-21','13:35:00',6.35),('8902','2013-05-21','13:40:00',6.03),('8902','2013-05-21','13:45:00',4.93),('8902','2013-05-21','13:50:00',4.95),('8902','2013-05-21','13:55:00',4.58),('8902','2013-05-21','14:00:00',5.17),('8902','2013-05-21','14:05:00',7.17),('8902','2013-05-21','14:10:00',7.46),('8902','2013-05-21','14:15:00',8.21),('8902','2013-05-21','14:20:00',7.99),('8902','2013-05-21','14:25:00',7.89),('8902','2013-05-21','14:30:00',7.83),('8902','2013-05-21','14:35:00',7.79),('8902','2013-05-21','14:40:00',7.7),('8902','2013-05-21','14:45:00',7.64),('8902','2013-05-21','14:50:00',7.59),('8902','2013-05-21','14:55:00',7.46),('8902','2013-05-21','15:00:00',7.43),('8902','2013-05-21','15:05:00',7.38),('8902','2013-05-21','15:10:00',7.3),('8902','2013-05-21','15:15:00',7.27),('8902','2013-05-21','15:20:00',7.1),('8902','2013-05-21','15:25:00',3.76),('8902','2013-05-21','15:30:00',3.93),('8902','2013-05-21','15:35:00',4.13),('8902','2013-05-21','15:40:00',3.49),('8902','2013-05-21','15:45:00',5.24),('8902','2013-05-21','15:50:00',6.81),('8902','2013-05-21','15:55:00',6.6),('8902','2013-05-21','16:00:00',6.47),('8902','2013-05-21','16:05:00',6.31),('8902','2013-05-21','16:10:00',6.11),('8902','2013-05-21','16:15:00',5.98),('8902','2013-05-21','16:20:00',5.98),('8902','2013-05-21','16:25:00',5.82),('8902','2013-05-21','16:30:00',5.54),('8902','2013-05-21','16:35:00',5.46),('8902','2013-05-21','16:40:00',5.34),('8902','2013-05-21','16:45:00',4.47),('8902','2013-05-21','16:50:00',3.77),('8902','2013-05-21','17:00:00',1.46),('8902','2013-05-21','17:05:00',1.56),('8902','2013-05-21','17:10:00',1.31),('8902','2013-05-21','17:15:00',2.02),('8902','2013-05-21','17:20:00',2.48),('8902','2013-05-21','17:25:00',3.96),('8902','2013-05-21','17:30:00',2.38),('8902','2013-05-21','17:35:00',2.71),('8902','2013-05-21','17:40:00',1.45),('8902','2013-05-21','17:50:00',1.17),('8902','2013-05-21','17:55:00',2.42),('8902','2013-05-21','18:00:00',2.49),('8902','2013-05-21','18:05:00',1.6),('8902','2013-05-21','18:25:00',1.18),('8902','2014-03-31','08:05:00',1.07),('8902','2014-03-31','08:10:00',1.27),('8902','2014-03-31','08:15:00',1.46),('8902','2014-03-31','08:20:00',1.63),('8902','2014-03-31','08:25:00',1.82),('8902','2014-03-31','08:30:00',1.99),('8902','2014-03-31','08:35:00',2.14),('8902','2014-03-31','08:40:00',2.26),('8902','2014-03-31','08:45:00',2.44),('8902','2014-03-31','08:50:00',2.62),('8902','2014-03-31','08:55:00',2.8),('8902','2014-03-31','09:00:00',2.98),('8902','2014-03-31','09:05:00',3.18),('8902','2014-03-31','09:10:00',3.39),('8902','2014-03-31','09:15:00',3.58),('8902','2014-03-31','09:20:00',3.74),('8902','2014-03-31','09:25:00',3.9),('8902','2014-03-31','09:30:00',4.11),('8902','2014-03-31','09:35:00',4.3),('8902','2014-03-31','09:40:00',4.38),('8902','2014-03-31','09:45:00',4.65),('8902','2014-03-31','09:50:00',4.87),('8902','2014-03-31','09:55:00',5.01),('8902','2014-03-31','10:00:00',4.34),('8902','2014-03-31','10:05:00',4.58),('8902','2014-03-31','10:10:00',5.43),('8902','2014-03-31','10:15:00',5.41),('8902','2014-03-31','10:20:00',5.79),('8902','2014-03-31','10:25:00',6.08),('8902','2014-03-31','10:30:00',6.39),('8902','2014-03-31','10:35:00',6.34),('8902','2014-03-31','10:40:00',6.21),('8902','2014-03-31','10:45:00',6.7),('8902','2014-03-31','10:50:00',6.46),('8902','2014-03-31','10:55:00',6.73),('8902','2014-03-31','11:00:00',6.69),('8902','2014-03-31','11:05:00',6.84),('8902','2014-03-31','11:10:00',6.88),('8902','2014-03-31','11:15:00',6.96),('8902','2014-03-31','11:20:00',7.04),('8902','2014-03-31','11:25:00',7.07),('8902','2014-03-31','11:30:00',7.24),('8902','2014-03-31','11:35:00',7.37),('8902','2014-03-31','11:40:00',7.5),('8902','2014-03-31','11:45:00',7.54),('8902','2014-03-31','11:50:00',7.63),('8902','2014-03-31','11:55:00',7.65),('8902','2014-03-31','12:00:00',7.58),('8902','2014-03-31','12:05:00',7.86),('8902','2014-03-31','12:10:00',7.91),('8902','2014-03-31','12:15:00',7.99),('8902','2014-03-31','12:20:00',8.05),('8902','2014-03-31','12:25:00',8.14),('8902','2014-03-31','12:30:00',8.18),('8902','2014-03-31','12:35:00',8.25),('8902','2014-03-31','12:40:00',8.29),('8902','2014-03-31','12:45:00',8.33),('8902','2014-03-31','12:50:00',8.43),('8902','2014-03-31','12:55:00',8.27),('8902','2014-03-31','13:00:00',8.45),('8902','2014-03-31','13:05:00',8.49),('8902','2014-03-31','13:10:00',6.96),('8902','2014-03-31','13:15:00',8.61),('8902','2014-03-31','13:20:00',7.45),('8902','2014-03-31','13:25:00',8.44),('8902','2014-03-31','13:30:00',8.42),('8902','2014-03-31','13:35:00',8.44),('8902','2014-03-31','13:40:00',8.55),('8902','2014-03-31','13:45:00',8.53),('8902','2014-03-31','13:50:00',8.39),('8902','2014-03-31','13:55:00',8.41),('8902','2014-03-31','14:00:00',8.31),('8902','2014-03-31','14:05:00',8.37),('8902','2014-03-31','14:10:00',8.32),('8902','2014-03-31','14:15:00',5.64),('8902','2014-03-31','14:20:00',8.32),('8902','2014-03-31','14:25:00',8.21),('8902','2014-03-31','14:30:00',6.51),('8902','2014-03-31','14:35:00',8.44),('8902','2014-03-31','14:40:00',6.69),('8902','2014-03-31','14:45:00',8.24),('8902','2014-03-31','14:50:00',8.48),('8902','2014-03-31','14:55:00',6.86),('8902','2014-03-31','15:00:00',8.25),('8902','2014-03-31','15:05:00',7.62),('8902','2014-03-31','15:10:00',6.7),('8902','2014-03-31','15:15:00',8.23),('8902','2014-03-31','15:20:00',7.85),('8902','2014-03-31','15:25:00',6.56),('8902','2014-03-31','15:30:00',6.46),('8902','2014-03-31','15:35:00',6.21),('8902','2014-03-31','15:40:00',6.11),('8902','2014-03-31','15:45:00',5.34),('8902','2014-03-31','15:50:00',7.55),('8902','2014-03-31','15:55:00',6.44),('8902','2014-03-31','16:00:00',4.45),('8902','2014-03-31','16:05:00',5.58),('8902','2014-03-31','16:10:00',5.56),('8902','2014-03-31','16:15:00',5.33),('8902','2014-03-31','16:20:00',3.45),('8902','2014-03-31','16:25:00',4.49),('8902','2014-03-31','16:30:00',5.07),('8902','2014-03-31','16:35:00',6.01),('8902','2014-03-31','16:40:00',5.87),('8902','2014-03-31','16:45:00',4.17),('8902','2014-03-31','16:50:00',2.03),('8902','2014-03-31','16:55:00',4.47),('8902','2014-03-31','17:00:00',4.86),('8902','2014-03-31','17:05:00',4.38),('8902','2014-03-31','17:10:00',3.87),('8902','2014-03-31','17:15:00',4.37),('8902','2014-03-31','17:20:00',4.08),('8902','2014-03-31','17:25:00',3.95),('8902','2014-03-31','17:30:00',3.68),('8902','2014-03-31','17:35:00',3.38),('8902','2014-03-31','17:40:00',3.22),('8902','2014-03-31','17:45:00',3.07),('8902','2014-03-31','17:50:00',2.87),('8902','2014-03-31','17:55:00',2.55),('8902','2014-03-31','18:00:00',2.34),('8902','2014-03-31','18:05:00',2.17),('8902','2014-03-31','18:10:00',1.92),('8902','2014-03-31','18:15:00',1.71),('8902','2014-03-31','18:20:00',1.43),('8902','2014-03-31','18:25:00',1.29),('8902','2013-05-20','07:20:00',1.09),('8902','2013-05-20','07:25:00',1.27),('8902','2013-05-20','07:30:00',1.55),('8902','2013-05-20','07:35:00',2),('8902','2013-05-20','07:40:00',2.34),('8902','2013-05-20','07:45:00',2.1),('8902','2013-05-20','07:50:00',1.77),('8902','2013-05-20','07:55:00',1.62),('8902','2013-05-20','08:00:00',2.09),('8902','2013-05-20','08:05:00',1.54),('8902','2013-05-20','08:10:00',2.22),('8902','2013-05-20','08:15:00',3.21),('8902','2013-05-20','08:20:00',2.7),('8902','2013-05-20','08:25:00',3.36),('8902','2013-05-20','08:30:00',2.54),('8902','2013-05-20','08:35:00',2.3),('8902','2013-05-20','08:40:00',2.72),('8902','2013-05-20','08:45:00',2.36),('8902','2013-05-20','08:50:00',2.53),('8902','2013-05-20','08:55:00',3.32),('8902','2013-05-20','09:00:00',2.93),('8902','2013-05-20','09:05:00',2.53),('8902','2013-05-20','09:10:00',2.71),('8902','2013-05-20','09:15:00',2.96),('8902','2013-05-20','09:20:00',4.05),('8902','2013-05-20','09:25:00',4.57),('8902','2013-05-20','09:30:00',3.59),('8902','2013-05-20','09:35:00',3.83),('8902','2013-05-20','09:40:00',3.68),('8902','2013-05-20','09:45:00',3.2),('8902','2013-05-20','09:50:00',3.04),('8902','2013-05-20','09:55:00',3.47),('8902','2013-05-20','10:00:00',3.68),('8902','2013-05-20','10:05:00',4.19),('8902','2013-05-20','10:10:00',4.47),('8902','2013-05-20','10:15:00',4.15),('8902','2013-05-20','10:20:00',4.01),('8902','2013-05-20','10:25:00',3.54),('8902','2013-05-20','10:30:00',3.35),('8902','2013-05-20','10:35:00',3.52),('8902','2013-05-20','10:40:00',3.99),('8902','2013-05-20','10:45:00',5.68),('8902','2013-05-20','10:50:00',3.97),('8902','2013-05-20','10:55:00',3.07),('8902','2013-05-20','11:00:00',3.73),('8902','2013-05-20','11:05:00',3.42),('8902','2013-05-20','11:10:00',5.76),('8902','2013-05-20','11:15:00',7.48),('8902','2013-05-20','11:20:00',5.52),('8902','2013-05-20','11:25:00',6.87),('8902','2013-05-20','11:30:00',4.99),('8902','2013-05-20','11:35:00',5.92),('8902','2013-05-20','11:40:00',5.4),('8902','2013-05-20','11:45:00',6.4),('8902','2013-05-20','11:50:00',4.51),('8902','2013-05-20','11:55:00',6.83),('8902','2013-05-20','12:00:00',6.34),('8902','2013-05-20','12:05:00',6.6),('8902','2013-05-20','12:10:00',5.28),('8902','2013-05-20','12:15:00',6.47),('8902','2013-05-20','12:20:00',4.47),('8902','2013-05-20','12:25:00',5.93),('8902','2013-05-20','12:30:00',7.51),('8902','2013-05-20','12:35:00',4.74),('8902','2013-05-20','12:40:00',7.64),('8902','2013-05-20','12:45:00',7.61),('8902','2013-05-20','12:50:00',4.8),('8902','2013-05-20','12:55:00',7.79),('8902','2013-05-20','13:00:00',7.65),('8902','2013-05-20','13:05:00',8.21),('8902','2013-05-20','13:10:00',5.1),('8902','2013-05-20','13:15:00',7.79),('8902','2013-05-20','13:20:00',6.39),('8902','2013-05-20','13:25:00',6.23),('8902','2013-05-20','13:30:00',6.01),('8902','2013-05-20','13:35:00',2.83),('8902','2013-05-20','13:40:00',1.69),('8902','2013-05-20','13:45:00',1.14),('8902','2013-05-20','14:00:00',1.24),('8902','2013-05-20','14:05:00',2.11),('8902','2013-05-20','14:10:00',3.23),('8902','2013-05-20','14:15:00',3.77),('8902','2013-05-20','14:20:00',3.39),('8902','2013-05-20','14:25:00',4.91),('8902','2013-05-20','14:30:00',4.15),('8902','2013-05-20','14:35:00',3.71),('8902','2013-05-20','14:40:00',3.62),('8902','2013-05-20','14:45:00',2.99),('8902','2013-05-20','14:50:00',1.92),('8902','2013-05-20','14:55:00',1.48),('8902','2013-05-20','15:05:00',1.06),('8902','2013-05-20','15:10:00',1.22),('8902','2013-05-20','15:15:00',2.01),('8902','2013-05-20','15:20:00',2.8),('8902','2013-05-20','15:25:00',2.93),('8902','2013-05-20','15:30:00',4.13),('8902','2013-05-20','15:35:00',3.12),('8902','2013-05-20','15:40:00',2.44),('8902','2013-05-20','15:45:00',2.55),('8902','2013-05-20','15:50:00',2.32),('8902','2013-05-20','15:55:00',2.32),('8902','2013-05-20','16:00:00',2.32),('8902','2013-05-20','16:05:00',2.26),('8902','2013-05-20','16:10:00',2.46),('8902','2013-05-20','16:15:00',2.18),('8902','2013-05-20','16:20:00',1.8),('8902','2013-05-20','16:25:00',2.42),('8902','2013-05-20','16:30:00',3.27),('8902','2013-05-20','16:35:00',3.55),('8902','2013-05-20','16:40:00',3.94),('8902','2013-05-20','16:45:00',3.49),('8902','2013-05-20','16:50:00',2.14),('8902','2013-05-20','16:55:00',1.13),('8902','2013-05-20','17:00:00',1.29),('8902','2013-05-20','17:05:00',1.42),('8902','2013-05-20','17:10:00',1.18),('8902','2013-05-19','07:20:00',1.07),('8902','2013-05-19','07:25:00',1.13),('8902','2013-05-19','07:30:00',1.38),('8902','2013-05-19','07:35:00',1.56),('8902','2013-05-19','07:40:00',1.71),('8902','2013-05-19','07:45:00',1.86),('8902','2013-05-19','07:50:00',2),('8902','2013-05-19','07:55:00',2.17),('8902','2013-05-19','08:00:00',2.46),('8902','2013-05-19','08:05:00',1.85),('8902','2013-05-19','08:10:00',2.03),('8902','2013-05-19','08:15:00',1.91),('8902','2013-05-19','08:20:00',1.91),('8902','2013-05-19','08:25:00',1.91),('8902','2013-05-19','08:30:00',1.63),('8902','2013-05-19','08:35:00',1.3),('8902','2013-05-19','08:40:00',1.15),('8902','2013-05-19','08:45:00',2.17),('8902','2013-05-19','08:50:00',3.73),('8902','2013-05-19','08:55:00',4.69),('8902','2013-05-19','09:00:00',5.19),('8902','2013-05-19','09:05:00',5.42),('8902','2013-05-19','09:10:00',5.74),('8902','2013-05-19','09:15:00',4.17),('8902','2013-05-19','09:20:00',4.84),('8902','2013-05-19','09:25:00',2.82),('8902','2013-05-19','09:30:00',1.44),('8902','2013-05-19','09:35:00',3.96),('8902','2013-05-19','09:40:00',1.65),('8902','2013-05-19','09:45:00',1.11),('8902','2013-05-19','09:50:00',4.2),('8902','2013-05-19','09:55:00',1.68),('8902','2013-05-19','10:00:00',1.53),('8902','2013-05-19','10:05:00',2.61),('8902','2013-05-19','10:10:00',2.88),('8902','2013-05-19','10:15:00',2.66),('8902','2013-05-19','10:20:00',1.47),('8902','2013-05-19','10:25:00',1.51),('8902','2013-05-19','10:30:00',3.45),('8902','2013-05-19','10:35:00',3.72),('8902','2013-05-19','10:40:00',2.13),('8902','2013-05-19','10:45:00',2.35),('8902','2013-05-19','10:50:00',4.47),('8902','2013-05-19','10:55:00',5.53),('8902','2013-05-19','11:00:00',5.06),('8902','2013-05-19','11:05:00',7.38),('8902','2013-05-19','11:10:00',9.01),('8902','2013-05-19','11:15:00',8.85),('8902','2013-05-19','11:20:00',7.78),('8902','2013-05-19','11:25:00',7.01),('8902','2013-05-19','11:30:00',4.47),('8902','2013-05-19','11:35:00',6.21),('8902','2013-05-19','11:40:00',1.82),('8902','2013-05-19','11:45:00',3.36),('8902','2013-05-19','11:50:00',1.83),('8902','2013-05-19','11:55:00',5.7),('8902','2013-05-19','12:00:00',5.54),('8902','2013-05-19','12:05:00',4.55),('8902','2013-05-19','12:10:00',9.15),('8902','2013-05-19','12:15:00',4.45),('8902','2013-05-19','12:20:00',5.33),('8902','2013-05-19','12:25:00',5.58),('8902','2013-05-19','12:30:00',5.61),('8902','2013-05-19','12:35:00',2.77),('8902','2013-05-19','12:40:00',9.23),('8902','2013-05-19','12:45:00',9.97),('8902','2013-05-19','12:50:00',4.15),('8902','2013-05-19','12:55:00',2.86),('8902','2013-05-19','13:00:00',4.93),('8902','2013-05-19','13:05:00',6.74),('8902','2013-05-19','13:10:00',3.3),('8902','2013-05-19','13:15:00',1.98),('8902','2013-05-19','13:20:00',4.73),('8902','2013-05-19','13:25:00',6.14),('8902','2013-05-19','13:30:00',6.43),('8902','2013-05-19','13:35:00',4.95),('8902','2013-05-19','13:40:00',6.31),('8902','2013-05-19','13:45:00',3.06),('8902','2013-05-19','13:50:00',9.84),('8902','2013-05-19','13:55:00',5.51),('8902','2013-05-19','14:00:00',9.47),('8902','2013-05-19','14:05:00',4.98),('8902','2013-05-19','14:10:00',2.13),('8902','2013-05-19','14:15:00',9.54),('8902','2013-05-19','14:20:00',5.7),('8902','2013-05-19','14:25:00',4.15),('8902','2013-05-19','14:30:00',5.8),('8902','2013-05-19','14:35:00',2.91),('8902','2013-05-19','14:40:00',3.22),('8902','2013-05-19','14:45:00',3.33),('8902','2013-05-19','14:50:00',9.32),('8902','2013-05-19','14:55:00',4.67),('8902','2013-05-19','15:00:00',7.08),('8902','2013-05-19','15:05:00',2.32),('8902','2013-05-19','15:10:00',7.72),('8902','2013-05-19','15:15:00',6.67),('8902','2013-05-19','15:20:00',4.51),('8902','2013-05-19','15:25:00',6.4),('8902','2013-05-19','15:30:00',3.46),('8902','2013-05-19','15:35:00',7.23),('8902','2013-05-19','15:40:00',5.76),('8902','2013-05-19','15:45:00',3.45),('8902','2013-05-19','15:50:00',6.55),('8902','2013-05-19','15:55:00',2.31),('8902','2013-05-19','16:00:00',5.39),('8902','2013-05-19','16:05:00',5.76),('8902','2013-05-19','16:10:00',4.66),('8902','2013-05-19','16:15:00',5.89),('8902','2013-05-19','16:20:00',7.16),('8902','2013-05-19','16:25:00',6.84),('8902','2013-05-19','16:30:00',6.46),('8902','2013-05-19','16:35:00',6.25),('8902','2013-05-19','16:40:00',6.21),('8902','2013-05-19','16:45:00',5.74),('8902','2013-05-19','16:50:00',5.54),('8902','2013-05-19','16:55:00',5.46),('8902','2013-05-19','17:00:00',5.3),('8902','2013-05-19','17:05:00',5.45),('8902','2013-05-19','17:10:00',3.66),('8902','2013-05-19','17:15:00',2.5),('8902','2013-05-19','17:20:00',3.79),('8902','2013-05-19','17:25:00',5.01),('8902','2013-05-19','17:30:00',5.16),('8902','2013-05-19','17:35:00',4.28),('8902','2013-05-19','17:40:00',3.95),('8902','2013-05-19','17:45:00',3.73),('8902','2013-05-19','17:50:00',3.55),('8902','2013-05-19','17:55:00',3.41),('8902','2013-05-19','18:00:00',3.27),('8902','2013-05-19','18:05:00',3.41),('8902','2013-05-19','18:10:00',2.52),('8902','2013-05-19','18:15:00',3.09),('8902','2013-05-19','18:20:00',2.61),('8902','2013-05-19','18:25:00',2.27),('8902','2013-05-19','18:30:00',2.1),('8902','2013-05-19','18:35:00',1.93),('8902','2013-05-19','18:40:00',1.69),('8902','2013-05-19','18:45:00',1.57),('8902','2013-05-19','18:50:00',1.37),('8902','2013-05-19','18:55:00',1.23),('8902','2013-05-19','19:00:00',1.07),('8902','2013-05-18','08:00:00',1.02),('8902','2013-05-18','08:05:00',1.03),('8902','2013-05-18','08:10:00',1.05),('8902','2013-05-18','08:15:00',1.29),('8902','2013-05-18','08:20:00',1.29),('8902','2013-05-18','08:25:00',1.14),('8902','2013-05-18','08:30:00',1.64),('8902','2013-05-18','08:35:00',2.2),('8902','2013-05-18','08:40:00',1.83),('8902','2013-05-18','08:45:00',1.87),('8902','2013-05-18','08:50:00',2.14),('8902','2013-05-18','08:55:00',3.25),('8902','2013-05-18','09:00:00',2.96),('8902','2013-05-18','09:05:00',2.12),('8902','2013-05-18','09:10:00',2.32),('8902','2013-05-18','09:15:00',2.56),('8902','2013-05-18','09:20:00',2.11),('8902','2013-05-18','09:25:00',1.14),('8902','2013-05-18','09:30:00',1.19),('8902','2013-05-18','09:35:00',1.41),('8902','2013-05-18','09:40:00',1.83),('8902','2013-05-18','09:45:00',2.29),('8902','2013-05-18','09:50:00',1.62),('8902','2013-05-18','09:55:00',1.69),('8902','2013-05-18','10:00:00',2.89),('8902','2013-05-18','10:05:00',3.08),('8902','2013-05-18','10:10:00',3.67),('8902','2013-05-18','10:15:00',6.17),('8902','2013-05-18','10:20:00',4.55),('8902','2013-05-18','10:25:00',4.93),('8902','2013-05-18','10:30:00',5.39),('8902','2013-05-18','10:35:00',3.49),('8902','2013-05-18','10:40:00',3.75),('8902','2013-05-18','10:45:00',4.11),('8902','2013-05-18','10:50:00',3.13),('8902','2013-05-18','10:55:00',3.43),('8902','2013-05-18','11:00:00',3.56),('8902','2013-05-18','11:05:00',6.45),('8902','2013-05-18','11:10:00',5.26),('8902','2013-05-18','11:15:00',5.92),('8902','2013-05-18','11:20:00',8.16),('8902','2013-05-18','11:25:00',8.33),('8902','2013-05-18','11:30:00',8.19),('8902','2013-05-18','11:35:00',8.21),('8902','2013-05-18','11:40:00',8.54),('8902','2013-05-18','11:45:00',8.61),('8902','2013-05-18','11:50:00',8.55),('8902','2013-05-18','11:55:00',8.58),('8902','2013-05-18','12:00:00',8.6),('8902','2013-05-18','12:05:00',8.61),('8902','2013-05-18','12:10:00',8.64),('8902','2013-05-18','12:15:00',8.68),('8902','2013-05-18','12:20:00',9.12),('8902','2013-05-18','12:25:00',9.93),('8902','2013-05-18','12:30:00',8.74),('8902','2013-05-18','12:35:00',9.65),('8902','2013-05-18','12:40:00',9.58),('8902','2013-05-18','12:45:00',9.23),('8902','2013-05-18','12:50:00',6.79),('8902','2013-05-18','12:55:00',5.46),('8902','2013-05-18','13:00:00',7.83),('8902','2013-05-18','13:05:00',7.94),('8902','2013-05-18','13:10:00',6.94),('8902','2013-05-18','13:15:00',7.35),('8902','2013-05-18','13:20:00',7.96),('8902','2013-05-18','13:25:00',8.2),('8902','2013-05-18','13:30:00',8.78),('8902','2013-05-18','13:35:00',8.68),('8902','2013-05-18','13:40:00',8.57),('8902','2013-05-18','13:45:00',8.62),('8902','2013-05-18','13:50:00',8.64),('8902','2013-05-18','13:55:00',8.63),('8902','2013-05-18','14:00:00',8.59),('8902','2013-05-18','14:05:00',8.52),('8902','2013-05-18','14:10:00',8.48),('8902','2013-05-18','14:15:00',8.49),('8902','2013-05-18','14:20:00',8.45),('8902','2013-05-18','14:25:00',8.46),('8902','2013-05-18','14:30:00',8.42),('8902','2013-05-18','14:35:00',8.34),('8902','2013-05-18','14:40:00',8.31),('8902','2013-05-18','14:45:00',8.24),('8902','2013-05-18','14:50:00',8.21),('8902','2013-05-18','14:55:00',8.16),('8902','2013-05-18','15:00:00',8.16),('8902','2013-05-18','15:05:00',8.1),('8902','2013-05-18','15:10:00',7.98),('8902','2013-05-18','15:15:00',7.87),('8902','2013-05-18','15:20:00',7.77),('8902','2013-05-18','15:25:00',7.75),('8902','2013-05-18','15:30:00',7.67),('8902','2013-05-18','15:35:00',7.59),('8902','2013-05-18','15:40:00',7.39),('8902','2013-05-18','15:45:00',7.28),('8902','2013-05-18','15:50:00',7.22),('8902','2013-05-18','15:55:00',7.19),('8902','2013-05-18','16:00:00',7.04),('8902','2013-05-18','16:05:00',6.98),('8902','2013-05-18','16:10:00',6.84),('8902','2013-05-18','16:15:00',6.76),('8902','2013-05-18','16:20:00',6.65),('8902','2013-05-18','16:25:00',6.56),('8902','2013-05-18','16:30:00',6.2),('8902','2013-05-18','16:35:00',6.2),('8902','2013-05-18','16:40:00',6.11),('8902','2013-05-18','16:45:00',5.94),('8902','2013-05-18','16:50:00',5.72),('8902','2013-05-18','16:55:00',5.66),('8902','2013-05-18','17:00:00',5.52),('8902','2013-05-18','17:05:00',5.41),('8902','2013-05-18','17:10:00',5.22),('8902','2013-05-18','17:15:00',5.01),('8902','2013-05-18','17:20:00',4.9),('8902','2013-05-18','17:25:00',4.7),('8902','2013-05-18','17:30:00',4.52),('8902','2013-05-18','17:35:00',4.38),('8902','2013-05-18','17:40:00',4.2),('8902','2013-05-18','17:45:00',3.95),('8902','2013-05-18','17:50:00',3.8),('8902','2013-05-18','17:55:00',3.62),('8902','2013-05-18','18:00:00',3.41),('8902','2013-05-18','18:05:00',3.22),('8902','2013-05-18','18:10:00',3.06),('8902','2013-05-18','18:15:00',2.85),('8902','2013-05-18','18:20:00',2.67),('8902','2013-05-18','18:25:00',2.47),('8902','2013-05-18','18:30:00',2.28),('8902','2013-05-18','18:35:00',2.1),('8902','2013-05-18','18:40:00',1.93),('8902','2013-05-18','18:45:00',1.71),('8902','2013-05-18','18:50:00',1.54),('8902','2013-05-18','18:55:00',1.33),('8902','2013-05-18','19:00:00',1.15),('8902','2013-05-17','07:20:00',1.01),('8902','2013-05-17','07:25:00',1.16),('8902','2013-05-17','07:30:00',1.32),('8902','2013-05-17','07:35:00',1.48),('8902','2013-05-17','07:40:00',1.73),('8902','2013-05-17','07:45:00',1.99),('8902','2013-05-17','07:50:00',1.93),('8902','2013-05-17','07:55:00',2.92),('8902','2013-05-17','08:00:00',3.24),('8902','2013-05-17','08:05:00',3.32),('8902','2013-05-17','08:10:00',1.82),('8902','2013-05-17','08:15:00',1.76),('8902','2013-05-17','08:20:00',2.06),('8902','2013-05-17','08:25:00',4.27),('8902','2013-05-17','08:30:00',3.83),('8902','2013-05-17','08:35:00',3.19),('8902','2013-05-17','08:40:00',3.77),('8902','2013-05-17','08:45:00',3.8),('8902','2013-05-17','08:50:00',3.96),('8902','2013-05-17','08:55:00',4.13),('8902','2013-05-17','09:00:00',4.3),('8902','2013-05-17','09:05:00',4.4),('8902','2013-05-17','09:10:00',4.65),('8902','2013-05-17','09:15:00',4.79),('8902','2013-05-17','09:20:00',4.88),('8902','2013-05-17','09:25:00',5.01),('8902','2013-05-17','09:30:00',5.17),('8902','2013-05-17','09:35:00',5.3),('8902','2013-05-17','09:40:00',5.4),('8902','2013-05-17','09:45:00',5.53),('8902','2013-05-17','09:50:00',5.65),('8902','2013-05-17','09:55:00',5.8),('8902','2013-05-17','10:00:00',5.91),('8902','2013-05-17','10:05:00',6.01),('8902','2013-05-17','10:10:00',6.16),('8902','2013-05-17','10:15:00',6.24),('8902','2013-05-17','10:20:00',6.33),('8902','2013-05-17','10:25:00',6.41),('8902','2013-05-17','10:30:00',6.51),('8902','2013-05-17','10:35:00',6.56),('8902','2013-05-17','10:40:00',6.66),('8902','2013-05-17','10:45:00',6.79),('8902','2013-05-17','10:50:00',6.88),('8902','2013-05-17','10:55:00',7.1),('8902','2013-05-17','11:00:00',7.42),('8902','2013-05-17','11:05:00',7.55),('8902','2013-05-17','11:10:00',6.03),('8902','2013-05-17','11:15:00',7.66),('8902','2013-05-17','11:20:00',7.73),('8902','2013-05-17','11:25:00',7.35),('8902','2013-05-17','11:30:00',7.73),('8902','2013-05-17','11:35:00',7.18),('8902','2013-05-17','11:40:00',7.5),('8902','2013-05-17','11:45:00',7.43),('8902','2013-05-17','11:50:00',7.32),('8902','2013-05-17','11:55:00',7.42),('8902','2013-05-17','12:00:00',7.98),('8902','2013-05-17','12:05:00',7.5),('8902','2013-05-17','12:10:00',7.59),('8902','2013-05-17','12:15:00',7.63),('8902','2013-05-17','12:20:00',7.68),('8902','2013-05-17','12:25:00',7.76),('8902','2013-05-17','12:30:00',6.09),('8902','2013-05-17','12:35:00',7.93),('8902','2013-05-17','12:40:00',7.83),('8902','2013-05-17','12:45:00',7.56),('8902','2013-05-17','12:50:00',7.82),('8902','2013-05-17','12:55:00',7.76),('8902','2013-05-17','13:00:00',7.72),('8902','2013-05-17','13:05:00',7.76),('8902','2013-05-17','13:10:00',7.84),('8902','2013-05-17','13:15:00',7.82),('8902','2013-05-17','13:20:00',7.83),('8902','2013-05-17','13:25:00',7.82),('8902','2013-05-17','13:30:00',7.94),('8902','2013-05-17','13:35:00',7.4),('8902','2013-05-17','13:40:00',8.18),('8902','2013-05-17','13:45:00',8.4),('8902','2013-05-17','13:50:00',7),('8902','2013-05-17','13:55:00',6.61),('8902','2013-05-17','14:00:00',7.02),('8902','2013-05-17','14:05:00',6.4),('8902','2013-05-17','14:10:00',8.29),('8902','2013-05-17','14:15:00',8.16),('8902','2013-05-17','14:20:00',7.94),('8902','2013-05-17','14:25:00',7.71),('8902','2013-05-17','14:30:00',7.91),('8902','2013-05-17','14:35:00',7.09),('8902','2013-05-17','14:40:00',8.1),('8902','2013-05-17','14:45:00',7.66),('8902','2013-05-17','14:50:00',6.25),('8902','2013-05-17','14:55:00',6.63),('8902','2013-05-17','15:00:00',6.83),('8902','2013-05-17','15:05:00',6.99),('8902','2013-05-17','15:10:00',6.85),('8902','2013-05-17','15:15:00',6.76),('8902','2013-05-17','15:20:00',6.65),('8902','2013-05-17','15:25:00',6.56),('8902','2013-05-17','15:30:00',6.53),('8902','2013-05-17','15:35:00',6.44),('8902','2013-05-17','15:40:00',6.32),('8902','2013-05-17','15:45:00',6.19),('8902','2013-05-17','15:50:00',6.07),('8902','2013-05-17','15:55:00',5.97),('8902','2013-05-17','16:00:00',5.89),('8902','2013-05-17','16:05:00',5.81),('8902','2013-05-17','16:10:00',5.68),('8902','2013-05-17','16:15:00',5.55),('8902','2013-05-17','16:20:00',5.45),('8902','2013-05-17','16:25:00',5.28),('8902','2013-05-17','16:30:00',5.14),('8902','2013-05-17','16:35:00',5.06),('8902','2013-05-17','16:40:00',4.97),('8902','2013-05-17','16:45:00',4.77),('8902','2013-05-17','16:50:00',4.63),('8902','2013-05-17','16:55:00',4.54),('8902','2013-05-17','17:00:00',4.45),('8902','2013-05-17','17:05:00',4.3),('8902','2013-05-17','17:10:00',4.18),('8902','2013-05-17','17:15:00',4.01),('8902','2013-05-17','17:20:00',3.9),('8902','2013-05-17','17:25:00',3.73),('8902','2013-05-17','17:30:00',3.54),('8902','2013-05-17','17:35:00',3.36),('8902','2013-05-17','17:40:00',3.26),('8902','2013-05-17','17:45:00',3.07),('8902','2013-05-17','17:50:00',2.93),('8902','2013-05-17','17:55:00',2.82),('8902','2013-05-17','18:00:00',2.63),('8902','2013-05-17','18:05:00',2.46),('8902','2013-05-17','18:10:00',2.33),('8902','2013-05-17','18:15:00',2.15),('8902','2013-05-17','18:20:00',1.99),('8902','2013-05-17','18:25:00',1.8),('8902','2013-05-17','18:30:00',1.63),('8902','2013-05-17','18:35:00',1.5),('8902','2013-05-17','18:40:00',1.38),('8902','2013-05-17','18:45:00',1.26),('8902','2013-05-17','18:50:00',1.14),('8902','2013-05-17','18:55:00',1.03),('8902','2013-05-16','07:10:00',1.11),('8902','2013-05-16','07:20:00',1.29),('8902','2013-05-16','07:25:00',1.38),('8902','2013-05-16','07:30:00',1.16),('8902','2013-05-16','07:40:00',1.59),('8902','2013-05-16','07:45:00',1.64),('8902','2013-05-16','07:50:00',1.42),('8902','2013-05-16','07:55:00',1.59),('8902','2013-05-16','08:00:00',2.29),('8902','2013-05-16','08:05:00',1.64),('8902','2013-05-16','08:10:00',1.44),('8902','2013-05-16','08:15:00',2.49),('8902','2013-05-16','08:20:00',3.73),('8902','2013-05-16','08:25:00',2.82),('8902','2013-05-16','08:30:00',1.96),('8902','2013-05-16','08:35:00',1.13),('8902','2013-05-16','09:05:00',1.21),('8902','2013-05-16','09:10:00',1.4),('8902','2013-05-16','09:15:00',1.2),('8902','2013-05-16','09:20:00',1.47),('8902','2013-05-16','09:25:00',2.2),('8902','2013-05-16','10:15:00',1.31),('8902','2013-05-16','10:20:00',1.7),('8902','2013-05-16','10:25:00',2.42),('8902','2013-05-16','10:30:00',3.01),('8902','2013-05-16','10:35:00',2.48),('8902','2013-05-16','10:40:00',2.72),('8902','2013-05-16','10:45:00',2.93),('8902','2013-05-16','10:50:00',4.74),('8902','2013-05-16','10:55:00',5.73),('8902','2013-05-16','11:00:00',4.21),('8902','2013-05-16','11:05:00',4.13),('8902','2013-05-16','11:10:00',2.73),('8902','2013-05-16','11:15:00',3.58),('8902','2013-05-16','11:20:00',3.77),('8902','2013-05-16','11:25:00',3.23),('8902','2013-05-16','11:30:00',4.5),('8902','2013-05-16','11:35:00',6.94),('8902','2013-05-16','11:40:00',3.31),('8902','2013-05-16','11:45:00',3.07),('8902','2013-05-16','11:50:00',3.51),('8902','2013-05-16','11:55:00',3.94),('8902','2013-05-16','12:00:00',3.47),('8902','2013-05-16','12:05:00',5.24),('8902','2013-05-16','12:10:00',4.23),('8902','2013-05-16','12:15:00',5.89),('8902','2013-05-16','12:20:00',3.75),('8902','2013-05-16','12:25:00',6.25),('8902','2013-05-16','12:30:00',5.2),('8902','2013-05-16','12:35:00',5.29),('8902','2013-05-16','12:40:00',9.08),('8902','2013-05-16','12:45:00',7.44),('8902','2013-05-16','12:50:00',8.55),('8902','2013-05-16','12:55:00',9.01),('8902','2013-05-16','13:00:00',7.01),('8902','2013-05-16','13:05:00',6.88),('8902','2013-05-16','13:10:00',5.58),('8902','2013-05-16','13:15:00',8.35),('8902','2013-05-16','13:20:00',8.55),('8902','2013-05-16','13:25:00',8.51),('8902','2013-05-16','13:30:00',5.59),('8902','2013-05-16','13:35:00',7.91),('8902','2013-05-16','13:40:00',7.11),('8902','2013-05-16','13:45:00',8.58),('8902','2013-05-16','13:50:00',8.79),('8902','2013-05-16','13:55:00',8.23),('8902','2013-05-16','14:00:00',7.7),('8902','2013-05-16','14:05:00',5.14),('8902','2013-05-16','14:10:00',7.52),('8902','2013-05-16','14:15:00',8.21),('8902','2013-05-16','14:20:00',9.13),('8902','2013-05-16','14:25:00',7.27),('8902','2013-05-16','14:30:00',7.5),('8902','2013-05-16','14:35:00',7.45),('8902','2013-05-16','14:40:00',4.84),('8902','2013-05-16','14:45:00',8.35),('8902','2013-05-16','14:50:00',4.9),('8902','2013-05-16','14:55:00',6.74),('8902','2013-05-16','15:00:00',7.02),('8902','2013-05-16','15:05:00',5.59),('8902','2013-05-16','15:10:00',3.66),('8902','2013-05-16','15:15:00',5.79),('8902','2013-05-16','15:20:00',4.92),('8902','2013-05-16','15:25:00',7.11),('8902','2013-05-16','15:30:00',5.91),('8902','2013-05-16','15:35:00',7.14),('8902','2013-05-16','15:40:00',6.99),('8902','2013-05-16','15:45:00',3.59),('8902','2013-05-16','15:50:00',4.91),('8902','2013-05-16','15:55:00',5.81),('8902','2013-05-16','16:00:00',3.29),('8902','2013-05-16','16:05:00',3.26),('8902','2013-05-16','16:10:00',3.44),('8902','2013-05-16','16:15:00',6.65),('8902','2013-05-16','16:20:00',6.71),('8902','2013-05-16','16:25:00',6.52),('8902','2013-05-16','16:30:00',6.03),('8902','2013-05-16','16:35:00',6.09),('8902','2013-05-16','16:40:00',6.76),('8902','2013-05-16','16:45:00',6.04),('8902','2013-05-16','16:50:00',5.75),('8902','2013-05-16','16:55:00',5.48),('8902','2013-05-16','17:00:00',5.34),('8902','2013-05-16','17:05:00',5.19),('8902','2013-05-16','17:10:00',5.05),('8902','2013-05-16','17:15:00',4.86),('8902','2013-05-16','17:20:00',4.73),('8902','2013-05-16','17:25:00',4.54),('8902','2013-05-16','17:30:00',4.36),('8902','2013-05-16','17:35:00',4.2),('8902','2013-05-16','17:40:00',4.05),('8902','2013-05-16','17:45:00',3.8),('8902','2013-05-16','17:50:00',3.67),('8902','2013-05-16','17:55:00',3.52),('8902','2013-05-16','18:00:00',3.34),('8902','2013-05-16','18:05:00',3.15),('8902','2013-05-16','18:10:00',2.94),('8902','2013-05-16','18:15:00',2.71),('8902','2013-05-16','18:20:00',2.55),('8902','2013-05-16','18:25:00',2.31),('8902','2013-05-16','18:30:00',2.16),('8902','2013-05-16','18:35:00',2),('8902','2013-05-16','18:40:00',1.81),('8902','2013-05-16','18:45:00',1.59),('8902','2013-05-16','18:50:00',1.46),('8902','2013-05-16','18:55:00',1.28),('8902','2013-05-15','09:15:00',1.73),('8902','2013-05-15','09:20:00',2.15),('8902','2013-05-15','09:25:00',3.04),('8902','2013-05-15','09:30:00',2.9),('8902','2013-05-15','09:35:00',3.35),('8902','2013-05-15','09:40:00',3.79),('8902','2013-05-15','09:45:00',4.62),('8902','2013-05-15','09:50:00',2.32),('8902','2013-05-15','09:55:00',2.22),('8902','2013-05-15','10:00:00',2.96),('8902','2013-05-15','10:05:00',2.46),('8902','2013-05-15','10:10:00',2.26),('8902','2013-05-15','10:15:00',2.96),('8902','2013-05-15','10:20:00',4.11),('8902','2013-05-15','10:25:00',4.92),('8902','2013-05-15','10:30:00',3.63),('8902','2013-05-15','10:35:00',2.69),('8902','2013-05-15','10:40:00',2.7),('8902','2013-05-15','10:45:00',2.48),('8902','2013-05-15','10:50:00',2.93),('8902','2013-05-15','10:55:00',3.58),('8902','2013-05-15','11:00:00',7.53),('8902','2013-05-15','11:05:00',6.42),('8902','2013-05-15','11:10:00',5.07),('8902','2013-05-15','11:15:00',3.08),('8902','2013-05-15','11:20:00',2.08),('8902','2013-05-15','11:25:00',2.42),('8902','2013-05-15','11:30:00',2.87),('8902','2013-05-15','11:35:00',4.58),('8902','2013-05-15','11:40:00',7.7),('8902','2013-05-15','11:45:00',7.4),('8902','2013-05-15','11:50:00',6.61),('8902','2013-05-15','11:55:00',4.19),('8902','2013-05-15','12:00:00',3.32),('8902','2013-05-15','12:05:00',3.11),('8902','2013-05-15','12:10:00',3.3),('8902','2013-05-15','12:15:00',5.44),('8902','2013-05-15','12:20:00',3.72),('8902','2013-05-15','12:25:00',4.43),('8902','2013-05-15','12:30:00',6.2),('8902','2013-05-15','12:35:00',6.54),('8902','2013-05-15','12:40:00',6.22),('8902','2013-05-15','12:45:00',6.14),('8902','2013-05-15','12:50:00',5.22),('8902','2013-05-15','12:55:00',8.52),('8902','2013-05-15','13:00:00',7.85),('8902','2013-05-15','13:05:00',6.99),('8902','2013-05-15','13:10:00',7.88),('8902','2013-05-15','13:15:00',7.51),('8902','2013-05-15','13:20:00',8.07),('8902','2013-05-15','13:25:00',7.84),('8902','2013-05-15','13:30:00',7.73),('8902','2013-05-15','13:35:00',7.71),('8902','2013-05-15','13:40:00',7.61),('8902','2013-05-15','13:45:00',7.6),('8902','2013-05-15','13:50:00',7.52),('8902','2013-05-15','13:55:00',7.6),('8902','2013-05-15','14:00:00',7.54),('8902','2013-05-15','14:05:00',7.52),('8902','2013-05-15','14:10:00',7.45),('8902','2013-05-15','14:15:00',7.34),('8902','2013-05-15','14:20:00',7.39),('8902','2013-05-15','14:25:00',7.2),('8902','2013-05-15','14:30:00',7.2),('8902','2013-05-15','14:35:00',7.09),('8902','2013-05-15','14:40:00',7.04),('8902','2013-05-15','14:45:00',7.01),('8902','2013-05-15','14:50:00',6.75),('8902','2013-05-15','14:55:00',6.16),('8902','2013-05-15','15:00:00',6.79),('8902','2013-05-15','15:05:00',6.84),('8902','2013-05-15','15:10:00',6.82),('8902','2013-05-15','15:15:00',6.09),('8902','2013-05-15','15:20:00',6.56),('8902','2013-05-15','15:25:00',6.52),('8902','2013-05-15','15:30:00',6.36),('8902','2013-05-15','15:35:00',6.14),('8902','2013-05-15','15:40:00',6.31),('8902','2013-05-15','15:45:00',6.1),('8902','2013-05-15','15:50:00',6.07),('8902','2013-05-15','15:55:00',6.03),('8902','2013-05-15','16:00:00',5.96),('8902','2013-05-15','16:05:00',5.72),('8902','2013-05-15','16:10:00',5.68),('8902','2013-05-15','16:15:00',5.32),('8902','2013-05-15','16:20:00',5.55),('8902','2013-05-15','16:25:00',5.29),('8902','2013-05-15','16:30:00',5.17),('8902','2013-05-15','16:35:00',5.03),('8902','2013-05-15','16:40:00',2.92),('8902','2013-05-15','16:45:00',2.68),('8902','2013-05-15','16:50:00',4.03),('8902','2013-05-15','16:55:00',2.84),('8902','2013-05-15','17:00:00',2.76),('8902','2013-05-15','17:05:00',1.71),('8902','2013-05-15','17:10:00',1.59),('8902','2013-05-15','17:15:00',2.18),('8902','2013-05-15','17:20:00',2.64),('8902','2013-05-15','17:25:00',2.48),('8902','2013-05-15','17:30:00',3.35),('8902','2013-05-15','17:35:00',3.59),('8902','2013-05-15','17:40:00',2.83),('8902','2013-05-15','17:45:00',1.9),('8902','2013-05-15','17:50:00',1.2),('8902','2013-05-15','18:25:00',1.06),('8902','2013-05-15','18:30:00',1.24),('8902','2013-05-15','18:35:00',1.38),('8902','2013-05-15','18:40:00',1.39),('8902','2013-05-15','18:45:00',1.57),('8902','2013-05-15','18:50:00',1.7),('8902','2013-05-15','18:55:00',1.75),('8902','2013-05-15','19:00:00',1.85),('8902','2013-05-15','19:05:00',1.79),('8902','2013-05-15','19:10:00',1.48),('8902','2013-05-15','19:15:00',1.24),('8902','2013-05-15','19:20:00',1.05),('8902','2013-05-14','07:25:00',1.12),('8902','2013-05-14','07:30:00',1.32),('8902','2013-05-14','07:35:00',1.49),('8902','2013-05-14','07:40:00',1.7),('8902','2013-05-14','07:45:00',1.99),('8902','2013-05-14','07:50:00',2.12),('8902','2013-05-14','07:55:00',2.04),('8902','2013-05-14','08:00:00',2.16),('8902','2013-05-14','08:05:00',2.1),('8902','2013-05-14','08:10:00',2.5),('8902','2013-05-14','08:15:00',2.74),('8902','2013-05-14','08:20:00',2.85),('8902','2013-05-14','08:25:00',2.96),('8902','2013-05-14','08:30:00',3.05),('8902','2013-05-14','08:35:00',3.34),('8902','2013-05-14','08:40:00',3.56),('8902','2013-05-14','08:45:00',3.73),('8902','2013-05-14','08:50:00',3.92),('8902','2013-05-14','08:55:00',4.08),('8902','2013-05-14','09:00:00',3.97),('8902','2013-05-14','09:05:00',4.33),('8902','2013-05-14','09:10:00',4.31),('8902','2013-05-14','09:15:00',4.49),('8902','2013-05-14','09:20:00',4.52),('8902','2013-05-14','09:25:00',4.03),('8902','2013-05-14','09:30:00',4.98),('8902','2013-05-14','09:35:00',5.14),('8902','2013-05-14','09:40:00',5.14),('8902','2013-05-14','09:45:00',5.3),('8902','2013-05-14','09:50:00',5.49),('8902','2013-05-14','09:55:00',5.54),('8902','2013-05-14','10:00:00',5.68),('8902','2013-05-14','10:05:00',5.83),('8902','2013-05-14','10:10:00',5.99),('8902','2013-05-14','10:15:00',5.85),('8902','2013-05-14','10:20:00',6.14),('8902','2013-05-14','10:25:00',6.34),('8902','2013-05-14','10:30:00',6.17),('8902','2013-05-14','10:35:00',6.33),('8902','2013-05-14','10:40:00',6.56),('8902','2013-05-14','10:45:00',6.67),('8902','2013-05-14','10:50:00',6.71),('8902','2013-05-14','10:55:00',6.55),('8902','2013-05-14','11:00:00',6.61),('8902','2013-05-14','11:05:00',6.98),('8902','2013-05-14','11:10:00',6.96),('8902','2013-05-14','11:15:00',7.12),('8902','2013-05-14','11:20:00',6.77),('8902','2013-05-14','11:25:00',7.08),('8902','2013-05-14','11:30:00',7.56),('8902','2013-05-14','11:35:00',7.04),('8902','2013-05-14','11:40:00',6.19),('8902','2013-05-14','11:45:00',5.49),('8902','2013-05-14','11:50:00',5.14),('8902','2013-05-14','11:55:00',3.62),('8902','2013-05-14','12:00:00',3.91),('8902','2013-05-14','12:05:00',6.57),('8902','2013-05-14','12:10:00',8.62),('8902','2013-05-14','12:15:00',8.38),('8902','2013-05-14','12:20:00',5.07),('8902','2013-05-14','12:25:00',6.41),('8902','2013-05-14','12:30:00',5.36),('8902','2013-05-14','12:35:00',5.19),('8902','2013-05-14','12:40:00',8.95),('8902','2013-05-14','12:45:00',4.71),('8902','2013-05-14','12:50:00',4.66),('8902','2013-05-14','12:55:00',5.29),('8902','2013-05-14','13:00:00',5.44),('8902','2013-05-14','13:05:00',5.97),('8902','2013-05-14','13:10:00',5.88),('8902','2013-05-14','13:15:00',4.36),('8902','2013-05-14','13:20:00',5.33),('8902','2013-05-14','13:25:00',5.04),('8902','2013-05-14','13:30:00',5.32),('8902','2013-05-14','13:35:00',4.67),('8902','2013-05-14','13:40:00',4.84),('8902','2013-05-14','13:45:00',4.85),('8902','2013-05-14','13:50:00',4.05),('8902','2013-05-14','13:55:00',3.89),('8902','2013-05-14','14:00:00',3.39),('8902','2013-05-14','14:05:00',2.98),('8902','2013-05-14','14:10:00',3.06),('8902','2013-05-14','14:15:00',3.07),('8902','2013-05-14','14:20:00',3.16),('8902','2013-05-14','14:25:00',3.07),('8902','2013-05-14','14:30:00',2.72),('8902','2013-05-14','14:35:00',2.66),('8902','2013-05-14','14:40:00',2.89),('8902','2013-05-14','14:45:00',2.74),('8902','2013-05-14','14:50:00',2.76),('8902','2013-05-14','14:55:00',2.77),('8902','2013-05-14','15:00:00',2.7),('8902','2013-05-14','15:05:00',2.12),('8902','2013-05-14','15:10:00',1.65),('8902','2013-05-14','15:15:00',1.58),('8902','2013-05-14','15:20:00',1.5),('8902','2013-05-14','15:25:00',1.36),('8902','2013-05-14','15:30:00',1.45),('8902','2013-05-14','15:35:00',1.44),('8902','2013-05-14','15:40:00',1.56),('8902','2013-05-14','15:45:00',2.01),('8902','2013-05-14','15:50:00',2.76),('8902','2013-05-14','15:55:00',3.58),('8902','2013-05-14','16:00:00',3.59),('8902','2013-05-14','16:05:00',3.34),('8902','2013-05-14','16:10:00',3.01),('8902','2013-05-14','16:15:00',2.65),('8902','2013-05-14','16:20:00',2.91),('8902','2013-05-14','16:25:00',3.02),('8902','2013-05-14','16:30:00',2.74),('8902','2013-05-14','16:35:00',2.5),('8902','2013-05-14','16:40:00',2.3),('8902','2013-05-14','16:45:00',2.21),('8902','2013-05-14','16:50:00',2.21),('8902','2013-05-14','16:55:00',2.55),('8902','2013-05-14','17:00:00',3.03),('8902','2013-05-14','17:05:00',3.71),('8902','2013-05-14','17:10:00',3.49),('8902','2013-05-14','17:15:00',5.02),('8902','2013-05-14','17:20:00',4.28),('8902','2013-05-14','17:25:00',1.68),('8902','2013-05-14','17:30:00',1.78),('8902','2013-05-14','17:35:00',1.6),('8902','2013-05-14','17:40:00',1.45),('8902','2013-05-14','17:45:00',1.54),('8902','2013-05-14','17:50:00',1.6),('8902','2013-05-14','17:55:00',1.57),('8902','2013-05-14','18:00:00',1.43),('8902','2013-05-14','18:05:00',1.15),('8902','2013-05-13','07:25:00',1.07),('8902','2013-05-13','07:30:00',1.25),('8902','2013-05-13','07:35:00',1.41),('8902','2013-05-13','07:40:00',1.59),('8902','2013-05-13','07:45:00',1.76),('8902','2013-05-13','07:50:00',1.94),('8902','2013-05-13','07:55:00',2.13),('8902','2013-05-13','08:00:00',2.32),('8902','2013-05-13','08:05:00',2.49),('8902','2013-05-13','08:10:00',2.68),('8902','2013-05-13','08:15:00',2.86),('8902','2013-05-13','08:20:00',3.04),('8902','2013-05-13','08:25:00',3.22),('8902','2013-05-13','08:30:00',3.4),('8902','2013-05-13','08:35:00',3.59),('8902','2013-05-13','08:40:00',3.76),('8902','2013-05-13','08:45:00',3.92),('8902','2013-05-13','08:50:00',4.09),('8902','2013-05-13','08:55:00',4.25),('8902','2013-05-13','09:00:00',4.4),('8902','2013-05-13','09:05:00',4.57),('8902','2013-05-13','09:10:00',4.72),('8902','2013-05-13','09:15:00',4.86),('8902','2013-05-13','09:20:00',5.02),('8902','2013-05-13','09:25:00',5.15),('8902','2013-05-13','09:30:00',5.29),('8902','2013-05-13','09:35:00',5.41),('8902','2013-05-13','09:40:00',5.54),('8902','2013-05-13','09:45:00',5.67),('8902','2013-05-13','09:50:00',5.82),('8902','2013-05-13','09:55:00',5.96),('8902','2013-05-13','10:00:00',6.04),('8902','2013-05-13','10:05:00',6.2),('8902','2013-05-13','10:10:00',6.27),('8902','2013-05-13','10:15:00',6.37),('8902','2013-05-13','10:20:00',6.53),('8902','2013-05-13','10:25:00',6.58),('8902','2013-05-13','10:30:00',6.68),('8902','2013-05-13','10:35:00',6.76),('8902','2013-05-13','10:40:00',6.85),('8902','2013-05-13','10:45:00',6.93),('8902','2013-05-13','10:50:00',7.06),('8902','2013-05-13','10:55:00',7.14),('8902','2013-05-13','11:00:00',7.2),('8902','2013-05-13','11:05:00',7.27),('8902','2013-05-13','11:10:00',7.35),('8902','2013-05-13','11:15:00',7.36),('8902','2013-05-13','11:20:00',7.37),('8902','2013-05-13','11:25:00',7.42),('8902','2013-05-13','11:30:00',7.56),('8902','2013-05-13','11:35:00',7.61),('8902','2013-05-13','11:40:00',7.61),('8902','2013-05-13','11:45:00',7.7),('8902','2013-05-13','11:50:00',7.79),('8902','2013-05-13','11:55:00',7.82),('8902','2013-05-13','12:00:00',7.85),('8902','2013-05-13','12:05:00',7.84),('8902','2013-05-13','12:10:00',7.86),('8902','2013-05-13','12:15:00',7.89),('8902','2013-05-13','12:20:00',7.94),('8902','2013-05-13','12:25:00',8.1),('8902','2013-05-13','12:30:00',8.18),('8902','2013-05-13','12:35:00',8.17),('8902','2013-05-13','12:40:00',8.13),('8902','2013-05-13','12:45:00',8.15),('8902','2013-05-13','12:50:00',8.18),('8902','2013-05-13','12:55:00',8.2),('8902','2013-05-13','13:00:00',8.17),('8902','2013-05-13','13:05:00',8.13),('8902','2013-05-13','13:10:00',8.26),('8902','2013-05-13','13:15:00',8.24),('8902','2013-05-13','13:20:00',8.17),('8902','2013-05-13','13:25:00',8.09),('8902','2013-05-13','13:30:00',8.08),('8902','2013-05-13','13:35:00',8.06),('8902','2013-05-13','13:40:00',8.08),('8902','2013-05-13','13:45:00',8.03),('8902','2013-05-13','13:50:00',7.98),('8902','2013-05-13','13:55:00',7.95),('8902','2013-05-13','14:00:00',7.98),('8902','2013-05-13','14:05:00',7.96),('8902','2013-05-13','14:10:00',7.94),('8902','2013-05-13','14:15:00',7.91),('8902','2013-05-13','14:20:00',7.81),('8902','2013-05-13','14:25:00',7.78),('8902','2013-05-13','14:30:00',7.77),('8902','2013-05-13','14:35:00',7.74),('8902','2013-05-13','14:40:00',7.72),('8902','2013-05-13','14:45:00',7.72),('8902','2013-05-13','14:50:00',7.76),('8902','2013-05-13','14:55:00',7.73),('8902','2013-05-13','15:00:00',7.73),('8902','2013-05-13','15:05:00',7.7),('8902','2013-05-13','15:10:00',7.65),('8902','2013-05-13','15:15:00',7.6),('8902','2013-05-13','15:20:00',7.54),('8902','2013-05-13','15:25:00',7.49),('8902','2013-05-13','15:30:00',7.4),('8902','2013-05-13','15:35:00',7.25),('8902','2013-05-13','15:40:00',7.18),('8902','2013-05-13','15:45:00',7.1),('8902','2013-05-13','15:50:00',7),('8902','2013-05-13','15:55:00',6.88),('8902','2013-05-13','16:00:00',6.76),('8902','2013-05-13','16:05:00',6.67),('8902','2013-05-13','16:10:00',6.59),('8902','2013-05-13','16:15:00',6.47),('8902','2013-05-13','16:20:00',6.34),('8902','2013-05-13','16:25:00',6.18),('8902','2013-05-13','16:30:00',5.99),('8902','2013-05-13','16:35:00',5.91),('8902','2013-05-13','16:40:00',5.8),('8902','2013-05-13','16:45:00',5.6),('8902','2013-05-13','16:50:00',5.42),('8902','2013-05-13','16:55:00',5.35),('8902','2013-05-13','17:00:00',5.21),('8902','2013-05-13','17:05:00',5.04),('8902','2013-05-13','17:10:00',4.85),('8902','2013-05-13','17:15:00',4.7),('8902','2013-05-13','17:20:00',4.56),('8902','2013-05-13','17:25:00',4.38),('8902','2013-05-13','17:30:00',4.19),('8902','2013-05-13','17:35:00',4.03),('8902','2013-05-13','17:40:00',3.86),('8902','2013-05-13','17:45:00',3.58),('8902','2013-05-13','17:50:00',3.49),('8902','2013-05-13','17:55:00',3.3),('8902','2013-05-13','18:00:00',3.11),('8902','2013-05-13','18:05:00',2.95),('8902','2013-05-13','18:10:00',2.74),('8902','2013-05-13','18:15:00',2.56),('8902','2013-05-13','18:20:00',2.37),('8902','2013-05-13','18:25:00',2.13),('8902','2013-05-13','18:30:00',2.02),('8902','2013-05-13','18:35:00',1.86),('8902','2013-05-13','18:40:00',1.7),('8902','2013-05-13','18:45:00',1.49),('8902','2013-05-13','18:50:00',1.32),('8902','2013-05-13','18:55:00',1.15),('8902','2013-05-12','07:30:00',1.2),('8902','2013-05-12','07:35:00',1.36),('8902','2013-05-12','07:40:00',1.5),('8902','2013-05-12','07:45:00',1.62),('8902','2013-05-12','07:50:00',1.67),('8902','2013-05-12','07:55:00',1.3),('8902','2013-05-12','08:00:00',1.93),('8902','2013-05-12','08:05:00',2.27),('8902','2013-05-12','08:10:00',2.48),('8902','2013-05-12','08:15:00',2.66),('8902','2013-05-12','08:20:00',2.84),('8902','2013-05-12','08:25:00',2.96),('8902','2013-05-12','08:30:00',3.1),('8902','2013-05-12','08:35:00',3.28),('8902','2013-05-12','08:40:00',3.47),('8902','2013-05-12','08:45:00',3.61),('8902','2013-05-12','08:50:00',3.8),('8902','2013-05-12','08:55:00',3.95),('8902','2013-05-12','09:00:00',4.1),('8902','2013-05-12','09:05:00',4.22),('8902','2013-05-12','09:10:00',4.42),('8902','2013-05-12','09:15:00',4.55),('8902','2013-05-12','09:20:00',4.76),('8902','2013-05-12','09:25:00',4.87),('8902','2013-05-12','09:30:00',5.06),('8902','2013-05-12','09:35:00',5.16),('8902','2013-05-12','09:40:00',5.33),('8902','2013-05-12','09:45:00',5.42),('8902','2013-05-12','09:50:00',5.73),('8902','2013-05-12','09:55:00',5.94),('8902','2013-05-12','10:00:00',6.06),('8902','2013-05-12','10:05:00',6.14),('8902','2013-05-12','10:10:00',6.28),('8902','2013-05-12','10:15:00',6.65),('8902','2013-05-12','10:20:00',6.78),('8902','2013-05-12','10:25:00',5.03),('8902','2013-05-12','10:30:00',6.85),('8902','2013-05-12','10:35:00',2.61),('8902','2013-05-12','10:40:00',1.95),('8902','2013-05-12','10:45:00',6.48),('8902','2013-05-12','10:50:00',6.48),('8902','2013-05-12','10:55:00',3.88),('8902','2013-05-12','11:00:00',5.79),('8902','2013-05-12','11:05:00',4.49),('8902','2013-05-12','11:10:00',3.18),('8902','2013-05-12','11:15:00',5.18),('8902','2013-05-12','11:20:00',2.96),('8902','2013-05-12','11:25:00',3.94),('8902','2013-05-12','11:30:00',5.64),('8902','2013-05-12','11:35:00',4.76),('8902','2013-05-12','11:40:00',4.11),('8902','2013-05-12','11:45:00',5.1),('8902','2013-05-12','11:50:00',3.09),('8902','2013-05-12','11:55:00',3.47),('8902','2013-05-12','12:00:00',3.09),('8902','2013-05-12','12:05:00',3.01),('8902','2013-05-12','12:10:00',5.3),('8902','2013-05-12','12:15:00',5.84),('8902','2013-05-12','12:20:00',2.78),('8902','2013-05-12','12:25:00',3.57),('8902','2013-05-12','12:30:00',6.23),('8902','2013-05-12','12:35:00',7.02),('8902','2013-05-12','12:40:00',4.27),('8902','2013-05-12','12:45:00',5.12),('8902','2013-05-12','12:50:00',5.21),('8902','2013-05-12','12:55:00',9.33),('8902','2013-05-12','13:00:00',9.24),('8902','2013-05-12','13:05:00',5.44),('8902','2013-05-12','13:10:00',8.04),('8902','2013-05-12','13:15:00',9.19),('8902','2013-05-12','13:20:00',7.55),('8902','2013-05-12','13:25:00',9.22),('8902','2013-05-12','13:30:00',9.19),('8902','2013-05-12','13:35:00',7.58),('8902','2013-05-12','13:40:00',5.3),('8902','2013-05-12','13:45:00',2.77),('8902','2013-05-12','13:50:00',2.48),('8902','2013-05-12','13:55:00',2.18),('8902','2013-05-12','14:00:00',2.15),('8902','2013-05-12','14:05:00',5.06),('8902','2013-05-12','14:10:00',9.54),('8902','2013-05-12','14:15:00',9.01),('8902','2013-05-12','14:20:00',8.35),('8902','2013-05-12','14:25:00',3.98),('8902','2013-05-12','14:30:00',1.5),('8902','2013-05-12','14:35:00',7.59),('8902','2013-05-12','14:40:00',8.78),('8902','2013-05-12','14:45:00',6.04),('8902','2013-05-12','14:50:00',2.01),('8902','2013-05-12','14:55:00',8.91),('8902','2013-05-12','15:00:00',8.45),('8902','2013-05-12','15:05:00',4.81),('8902','2013-05-12','15:10:00',2.16),('8902','2013-05-12','15:15:00',1.82),('8902','2013-05-12','15:20:00',2.17),('8902','2013-05-12','15:25:00',1.7),('8902','2013-05-12','15:30:00',1.59),('8902','2013-05-12','15:35:00',1.14),('8902','2013-05-12','15:40:00',1.35),('8902','2013-05-12','15:45:00',1.33),('8902','2013-05-12','15:50:00',1.3),('8902','2013-05-12','15:55:00',1.22),('8902','2013-05-12','16:00:00',2.09),('8902','2013-05-12','16:05:00',2.05),('8902','2013-05-12','16:10:00',4.01),('8902','2013-05-12','16:15:00',2.18),('8902','2013-05-12','16:20:00',3.14),('8902','2013-05-12','16:25:00',2.83),('8902','2013-05-12','16:30:00',3.49),('8902','2013-05-12','16:35:00',2.67),('8902','2013-05-12','16:40:00',3.81),('8902','2013-05-12','16:45:00',5.19),('8902','2013-05-12','16:50:00',6.83),('8902','2013-05-12','16:55:00',6.28),('8902','2013-05-12','17:00:00',5.84),('8902','2013-05-12','17:05:00',5.1),('8902','2013-05-12','17:10:00',4.18),('8902','2013-05-12','17:15:00',5.64),('8902','2013-05-12','17:20:00',5.91),('8902','2013-05-12','17:25:00',5.36),('8902','2013-05-12','17:30:00',4.13),('8902','2013-05-12','17:35:00',4.64),('8902','2013-05-12','17:40:00',4.23),('8902','2013-05-12','17:45:00',3.69),('8902','2013-05-12','17:50:00',3.37),('8902','2013-05-12','17:55:00',2.13),('8902','2013-05-12','18:00:00',1.32),('8902','2013-05-12','18:05:00',1.18),('8902','2013-05-12','18:10:00',1.17),('8902','2013-05-12','18:15:00',1.16),('8902','2013-05-11','07:55:00',1.16),('8902','2013-05-11','08:00:00',1.35),('8902','2013-05-11','08:05:00',1.86),('8902','2013-05-11','08:10:00',3.12),('8902','2013-05-11','08:15:00',2.42),('8902','2013-05-11','08:20:00',2.3),('8902','2013-05-11','08:25:00',2.07),('8902','2013-05-11','08:30:00',1.62),('8902','2013-05-11','08:35:00',1.52),('8902','2013-05-11','08:40:00',1.67),('8902','2013-05-11','08:45:00',2.03),('8902','2013-05-11','08:50:00',2.6),('8902','2013-05-11','08:55:00',1.92),('8902','2013-05-11','09:00:00',2.2),('8902','2013-05-11','09:05:00',2.54),('8902','2013-05-11','09:10:00',2.04),('8902','2013-05-11','09:15:00',2.33),('8902','2013-05-11','09:20:00',2.35),('8902','2013-05-11','09:25:00',4.12),('8902','2013-05-11','09:30:00',5.65),('8902','2013-05-11','09:35:00',2.29),('8902','2013-05-11','09:40:00',3.99),('8902','2013-05-11','09:45:00',6.83),('8902','2013-05-11','09:50:00',6.38),('8902','2013-05-11','09:55:00',6.38),('8902','2013-05-11','10:00:00',5.97),('8902','2013-05-11','10:05:00',3.93),('8902','2013-05-11','10:10:00',3.18),('8902','2013-05-11','10:15:00',2.29),('8902','2013-05-11','10:20:00',1.59),('8902','2013-05-11','10:25:00',1.79),('8902','2013-05-11','10:30:00',2.39),('8902','2013-05-11','10:35:00',2.22),('8902','2013-05-11','10:40:00',1.77),('8902','2013-05-11','10:45:00',1.83),('8902','2013-05-11','10:50:00',3.23),('8902','2013-05-11','10:55:00',8.46),('8902','2013-05-11','11:00:00',3.9),('8902','2013-05-11','11:05:00',1.64),('8902','2013-05-11','11:10:00',2.02),('8902','2013-05-11','11:15:00',3.88),('8902','2013-05-11','11:20:00',4.51),('8902','2013-05-11','11:25:00',5.09),('8902','2013-05-11','11:30:00',8.79),('8902','2013-05-11','11:35:00',6.72),('8902','2013-05-11','11:40:00',8.5),('8902','2013-05-11','11:45:00',8.77),('8902','2013-05-11','11:50:00',8.16),('8902','2013-05-11','11:55:00',6.19),('8902','2013-05-11','12:00:00',4.13),('8902','2013-05-11','12:05:00',5.52),('8902','2013-05-11','12:10:00',9.6),('8902','2013-05-11','12:15:00',5.23),('8902','2013-05-11','12:20:00',2.16),('8902','2013-05-11','12:25:00',1.91),('8902','2013-05-11','12:30:00',1.92),('8902','2013-05-11','12:35:00',2.62),('8902','2013-05-11','12:40:00',3.2),('8902','2013-05-11','12:45:00',5.1),('8902','2013-05-11','12:50:00',9.76),('8902','2013-05-11','12:55:00',3.66),('8902','2013-05-11','13:00:00',2.68),('8902','2013-05-11','13:05:00',2.71),('8902','2013-05-11','13:10:00',4.47),('8902','2013-05-11','13:15:00',4.89),('8902','2013-05-11','13:20:00',3.26),('8902','2013-05-11','13:25:00',4.53),('8902','2013-05-11','13:30:00',8.2),('8902','2013-05-11','13:35:00',8.51),('8902','2013-05-11','13:40:00',7.04),('8902','2013-05-11','13:45:00',9.69),('8902','2013-05-11','13:50:00',5.4),('8902','2013-05-11','13:55:00',7.5),('8902','2013-05-11','14:00:00',4.64),('8902','2013-05-11','14:05:00',9.7),('8902','2013-05-11','14:10:00',5.76),('8902','2013-05-11','14:15:00',8.41),('8902','2013-05-11','14:20:00',8.8),('8902','2013-05-11','14:25:00',8.76),('8902','2013-05-11','14:30:00',8.58),('8902','2013-05-11','14:35:00',8.12),('8902','2013-05-11','14:40:00',7.32),('8902','2013-05-11','14:45:00',8.31),('8902','2013-05-11','14:50:00',7.72),('8902','2013-05-11','14:55:00',8.19),('8902','2013-05-11','15:00:00',8.12),('8902','2013-05-11','15:05:00',8.07),('8902','2013-05-11','15:10:00',8.11),('8902','2013-05-11','15:15:00',8.06),('8902','2013-05-11','15:20:00',6.75),('8902','2013-05-11','15:25:00',6.15),('8902','2013-05-11','15:30:00',6.47),('8902','2013-05-11','15:35:00',7.36),('8902','2013-05-11','15:40:00',7.21),('8902','2013-05-11','15:45:00',7.07),('8902','2013-05-11','15:50:00',6.94),('8902','2013-05-11','15:55:00',6.84),('8902','2013-05-11','16:00:00',6.71),('8902','2013-05-11','16:05:00',6.59),('8902','2013-05-11','16:10:00',6.48),('8902','2013-05-11','16:15:00',6.38),('8902','2013-05-11','16:20:00',6.3),('8902','2013-05-11','16:25:00',6.06),('8902','2013-05-11','16:30:00',5.95),('8902','2013-05-11','16:35:00',5.89),('8902','2013-05-11','16:40:00',5.91),('8902','2013-05-11','16:45:00',6.09),('8902','2013-05-11','16:50:00',5.79),('8902','2013-05-11','16:55:00',6.32),('8902','2013-05-11','17:00:00',6.57),('8902','2013-05-11','17:05:00',5.77),('8902','2013-05-11','17:10:00',5.88),('8902','2013-05-11','17:15:00',5.75),('8902','2013-05-11','17:20:00',5.53),('8902','2013-05-11','17:25:00',4.38),('8902','2013-05-11','17:30:00',4.27),('8902','2013-05-11','17:35:00',2.87),('8902','2013-05-11','17:40:00',3.99),('8902','2013-05-11','17:45:00',1.98),('8902','2013-05-11','17:50:00',2.02),('8902','2013-05-11','17:55:00',1.88),('8902','2013-05-11','18:00:00',2.07),('8902','2013-05-11','18:05:00',2.99),('8902','2013-05-11','18:10:00',3.07),('8902','2013-05-11','18:15:00',2.76),('8902','2013-05-11','18:20:00',1.94),('8902','2013-05-11','18:25:00',2.45),('8902','2013-05-11','18:30:00',2.02),('8902','2013-05-11','18:35:00',2.28),('8902','2013-05-11','18:40:00',1.9),('8902','2013-05-11','18:45:00',1.31),('8902','2013-05-11','18:50:00',1.17),('8902','2013-05-11','18:55:00',1.36),('8902','2013-05-11','19:00:00',1.42),('8902','2013-05-11','19:05:00',1.26),('8902','2013-05-11','19:10:00',1.08),('8902','2013-05-11','19:15:00',1.13),('8902','2013-05-11','19:20:00',1.06),('8902','2014-03-30','08:05:00',1.08),('8902','2014-03-30','08:10:00',1.29),('8902','2014-03-30','08:15:00',1.47),('8902','2014-03-30','08:20:00',1.64),('8902','2014-03-30','08:25:00',1.81),('8902','2014-03-30','08:30:00',1.98),('8902','2014-03-30','08:35:00',2.15),('8902','2014-03-30','08:40:00',2.27),('8902','2014-03-30','08:45:00',2.45),('8902','2014-03-30','08:50:00',2.63),('8902','2014-03-30','08:55:00',2.83),('8902','2014-03-30','09:00:00',3.02),('8902','2014-03-30','09:05:00',3.22),('8902','2014-03-30','09:10:00',3.4),('8902','2014-03-30','09:15:00',3.6),('8902','2014-03-30','09:20:00',3.77),('8902','2014-03-30','09:25:00',3.97),('8902','2014-03-30','09:30:00',4.17),('8902','2014-03-30','09:35:00',4.35),('8902','2014-03-30','09:40:00',4.48),('8902','2014-03-30','09:45:00',4.63),('8902','2014-03-30','09:50:00',4.76),('8902','2014-03-30','09:55:00',4.91),('8902','2014-03-30','10:00:00',5.04),('8902','2014-03-30','10:05:00',5.19),('8902','2014-03-30','10:10:00',5.34),('8902','2014-03-30','10:15:00',5.48),('8902','2014-03-30','10:20:00',5.58),('8902','2014-03-30','10:25:00',5.7),('8902','2014-03-30','10:30:00',5.79),('8902','2014-03-30','10:35:00',5.9),('8902','2014-03-30','10:40:00',6.02),('8902','2014-03-30','10:45:00',6.17),('8902','2014-03-30','10:50:00',6.28),('8902','2014-03-30','10:55:00',6.44),('8902','2014-03-30','11:00:00',6.52),('8902','2014-03-30','11:05:00',6.62),('8902','2014-03-30','11:10:00',6.71),('8902','2014-03-30','11:15:00',6.82),('8902','2014-03-30','11:20:00',6.91),('8902','2014-03-30','11:25:00',6.96),('8902','2014-03-30','11:30:00',6.97),('8902','2014-03-30','11:35:00',7.04),('8902','2014-03-30','11:40:00',7.15),('8902','2014-03-30','11:45:00',7.16),('8902','2014-03-30','11:50:00',7.23),('8902','2014-03-30','11:55:00',7.33),('8902','2014-03-30','12:00:00',7.51),('8902','2014-03-30','12:05:00',7.49),('8902','2014-03-30','12:10:00',7.46),('8902','2014-03-30','12:15:00',7.49),('8902','2014-03-30','12:20:00',7.58),('8902','2014-03-30','12:25:00',7.63),('8902','2014-03-30','12:30:00',7.68),('8902','2014-03-30','12:35:00',7.75),('8902','2014-03-30','12:40:00',7.84),('8902','2014-03-30','12:45:00',7.85),('8902','2014-03-30','12:50:00',7.79),('8902','2014-03-30','12:55:00',7.74),('8902','2014-03-30','13:00:00',7.8),('8902','2014-03-30','13:05:00',7.9),('8902','2014-03-30','13:10:00',7.9),('8902','2014-03-30','13:15:00',7.88),('8902','2014-03-30','13:20:00',7.92),('8902','2014-03-30','13:25:00',7.91),('8902','2014-03-30','13:30:00',7.96),('8902','2014-03-30','13:35:00',8.01),('8902','2014-03-30','13:40:00',7.98),('8902','2014-03-30','13:45:00',7.98),('8902','2014-03-30','13:50:00',7.96),('8902','2014-03-30','13:55:00',7.94),('8902','2014-03-30','14:00:00',7.92),('8902','2014-03-30','14:05:00',7.91),('8902','2014-03-30','14:10:00',7.86),('8902','2014-03-30','14:15:00',7.84),('8902','2014-03-30','14:20:00',7.83),('8902','2014-03-30','14:25:00',7.8),('8902','2014-03-30','14:30:00',7.8),('8902','2014-03-30','14:35:00',7.73),('8902','2014-03-30','14:40:00',7.67),('8902','2014-03-30','14:45:00',7.67),('8902','2014-03-30','14:50:00',7.61),('8902','2014-03-30','14:55:00',7.51),('8902','2014-03-30','15:00:00',7.49),('8902','2014-03-30','15:05:00',7.43),('8902','2014-03-30','15:10:00',7.4),('8902','2014-03-30','15:15:00',7.32),('8902','2014-03-30','15:20:00',7.2),('8902','2014-03-30','15:25:00',7.06),('8902','2014-03-30','15:30:00',6.97),('8902','2014-03-30','15:35:00',6.87),('8902','2014-03-30','15:40:00',6.8),('8902','2014-03-30','15:45:00',6.71),('8902','2014-03-30','15:50:00',6.57),('8902','2014-03-30','15:55:00',6.42),('8902','2014-03-30','16:00:00',6.29),('8902','2014-03-30','16:05:00',6.17),('8902','2014-03-30','16:10:00',6.04),('8902','2014-03-30','16:15:00',5.93),('8902','2014-03-30','16:20:00',5.79),('8902','2014-03-30','16:25:00',5.57),('8902','2014-03-30','16:30:00',5.46),('8902','2014-03-30','16:35:00',5.3),('8902','2014-03-30','16:40:00',5.17),('8902','2014-03-30','16:45:00',5),('8902','2014-03-30','16:50:00',4.86),('8902','2014-03-30','16:55:00',4.68),('8902','2014-03-30','17:00:00',4.54),('8902','2014-03-30','17:05:00',4.32),('8902','2014-03-30','17:10:00',4.19),('8902','2014-03-30','17:15:00',4.01),('8902','2014-03-30','17:20:00',3.81),('8902','2014-03-30','17:25:00',3.61),('8902','2014-03-30','17:30:00',3.4),('8902','2014-03-30','17:35:00',3.21),('8902','2014-03-30','17:40:00',2.98),('8902','2014-03-30','17:45:00',2.86),('8902','2014-03-30','17:50:00',2.66),('8902','2014-03-30','17:55:00',2.42),('8902','2014-03-30','18:00:00',2.24),('8902','2014-03-30','18:05:00',2),('8902','2014-03-30','18:10:00',1.78),('8902','2014-03-30','18:15:00',1.61),('8902','2014-03-30','18:20:00',1.42),('8902','2014-03-30','18:25:00',1.25),('8902','2014-03-30','18:30:00',1.08),('8902','2013-05-10','07:25:00',1.05),('8902','2013-05-10','07:30:00',1.18),('8902','2013-05-10','07:35:00',1.23),('8902','2013-05-10','07:40:00',1.32),('8902','2013-05-10','07:45:00',1.62),('8902','2013-05-10','07:50:00',1.94),('8902','2013-05-10','07:55:00',2.24),('8902','2013-05-10','08:00:00',2.25),('8902','2013-05-10','08:05:00',2.01),('8902','2013-05-10','08:10:00',1.25),('8902','2013-05-10','08:15:00',2.63),('8902','2013-05-10','08:20:00',2.21),('8902','2013-05-10','08:25:00',1.61),('8902','2013-05-10','08:30:00',1.67),('8902','2013-05-10','08:35:00',2.22),('8902','2013-05-10','08:40:00',1.36),('8902','2013-05-10','08:55:00',1.09),('8902','2013-05-10','09:00:00',1.19),('8902','2013-05-10','09:05:00',1.71),('8902','2013-05-10','09:10:00',1.69),('8902','2013-05-10','09:15:00',1.92),('8902','2013-05-10','09:20:00',2.66),('8902','2013-05-10','09:25:00',2.78),('8902','2013-05-10','09:30:00',3.18),('8902','2013-05-10','09:35:00',5.63),('8902','2013-05-10','09:40:00',4.27),('8902','2013-05-10','09:45:00',5.27),('8902','2013-05-10','09:50:00',2.49),('8902','2013-05-10','09:55:00',2.27),('8902','2013-05-10','10:00:00',2.65),('8902','2013-05-10','10:05:00',2.64),('8902','2013-05-10','10:10:00',1.97),('8902','2013-05-10','10:15:00',1.5),('8902','2013-05-10','10:20:00',1.88),('8902','2013-05-10','10:25:00',1.86),('8902','2013-05-10','10:30:00',2.1),('8902','2013-05-10','10:35:00',2.32),('8902','2013-05-10','10:40:00',1.91),('8902','2013-05-10','10:45:00',1.55),('8902','2013-05-10','10:50:00',1.84),('8902','2013-05-10','10:55:00',6.55),('8902','2013-05-10','11:00:00',4.8),('8902','2013-05-10','11:05:00',5.01),('8902','2013-05-10','11:10:00',2.36),('8902','2013-05-10','11:15:00',1.8),('8902','2013-05-10','11:20:00',1.51),('8902','2013-05-10','11:25:00',1.63),('8902','2013-05-10','11:30:00',2.49),('8902','2013-05-10','11:35:00',5.16),('8902','2013-05-10','11:40:00',4.2),('8902','2013-05-10','11:45:00',7.38),('8902','2013-05-10','11:50:00',5.1),('8902','2013-05-10','11:55:00',2.03),('8902','2013-05-10','12:00:00',2.27),('8902','2013-05-10','12:05:00',3.5),('8902','2013-05-10','12:10:00',2.81),('8902','2013-05-10','12:15:00',2.73),('8902','2013-05-10','12:20:00',3.07),('8902','2013-05-10','12:25:00',8.26),('8902','2013-05-10','12:30:00',6.45),('8902','2013-05-10','12:35:00',3.17),('8902','2013-05-10','12:40:00',3.72),('8902','2013-05-10','12:45:00',4.24),('8902','2013-05-10','12:50:00',4.43),('8902','2013-05-10','12:55:00',3.18),('8902','2013-05-10','13:00:00',2.98),('8902','2013-05-10','13:05:00',3.24),('8902','2013-05-10','13:10:00',2.4),('8902','2013-05-10','13:15:00',1.44),('8902','2013-05-10','13:20:00',1.55),('8902','2013-05-10','13:25:00',1.93),('8902','2013-05-10','13:30:00',2.13),('8902','2013-05-10','13:35:00',1.97),('8902','2013-05-10','13:40:00',1.58),('8902','2013-05-10','13:50:00',1.25),('8902','2013-05-10','13:55:00',1.46),('8902','2013-05-10','14:00:00',3.27),('8902','2013-05-10','14:05:00',4.97),('8902','2013-05-10','14:10:00',6.4),('8902','2013-05-10','14:15:00',5.69),('8902','2013-05-10','14:20:00',8.88),('8902','2013-05-10','14:25:00',9),('8902','2013-05-10','14:30:00',6.45),('8902','2013-05-10','14:35:00',5.56),('8902','2013-05-10','14:40:00',9.15),('8902','2013-05-10','14:45:00',8.02),('8902','2013-05-10','14:50:00',8.65),('8902','2013-05-10','14:55:00',8.34),('8902','2013-05-10','15:00:00',8.08),('8902','2013-05-10','15:05:00',7.91),('8902','2013-05-10','15:10:00',7.2),('8902','2013-05-10','15:15:00',7.95),('8902','2013-05-10','15:20:00',7.02),('8902','2013-05-10','15:25:00',7.68),('8902','2013-05-10','15:30:00',7.58),('8902','2013-05-10','15:35:00',7.48),('8902','2013-05-10','15:40:00',7.44),('8902','2013-05-10','15:45:00',7.15),('8902','2013-05-10','15:50:00',7.61),('8902','2013-05-10','15:55:00',7.22),('8902','2013-05-10','16:00:00',4.32),('8902','2013-05-10','16:05:00',6.32),('8902','2013-05-10','16:10:00',6.29),('8902','2013-05-10','16:15:00',5.93),('8902','2013-05-10','16:20:00',5.62),('8902','2013-05-10','16:25:00',6.41),('8902','2013-05-10','16:30:00',6.31),('8902','2013-05-10','16:35:00',6.25),('8902','2013-05-10','16:40:00',5.51),('8902','2013-05-10','16:45:00',5.72),('8902','2013-05-10','16:50:00',5.32),('8902','2013-05-10','16:55:00',5.19),('8902','2013-05-10','17:00:00',4.91),('8902','2013-05-10','17:05:00',5.27),('8902','2013-05-10','17:10:00',4.94),('8902','2013-05-10','17:15:00',3.67),('8902','2013-05-10','17:20:00',4.64),('8902','2013-05-10','17:25:00',3.45),('8902','2013-05-10','17:30:00',3.33),('8902','2013-05-10','17:35:00',4.21),('8902','2013-05-10','17:40:00',3.44),('8902','2013-05-10','17:45:00',4.25),('8902','2013-05-10','17:50:00',2.55),('8902','2013-05-10','17:55:00',3.57),('8902','2013-05-10','18:00:00',1.34),('8902','2013-05-10','18:05:00',2.3),('8902','2013-05-10','18:10:00',3.58),('8902','2013-05-10','18:15:00',2.91),('8902','2013-05-10','18:20:00',1.4),('8902','2013-05-10','18:25:00',2.26),('8902','2013-05-10','18:30:00',1.69),('8902','2013-05-10','18:35:00',1.62),('8902','2013-05-10','18:40:00',1.28),('8902','2013-05-10','18:45:00',1.61),('8902','2013-05-10','18:50:00',1.27),('8902','2013-05-10','18:55:00',1.44),('8902','2013-05-10','19:00:00',1.13),('8902','2013-05-09','07:15:00',1.11),('8902','2013-05-09','07:20:00',1.03),('8902','2013-05-09','07:30:00',1.19),('8902','2013-05-09','07:35:00',1.22),('8902','2013-05-09','07:40:00',1.34),('8902','2013-05-09','07:45:00',1.59),('8902','2013-05-09','07:50:00',1.39),('8902','2013-05-09','07:55:00',1.59),('8902','2013-05-09','08:00:00',2.23),('8902','2013-05-09','08:05:00',2.82),('8902','2013-05-09','08:10:00',3.13),('8902','2013-05-09','08:15:00',3.58),('8902','2013-05-09','08:20:00',3.4),('8902','2013-05-09','08:25:00',3.29),('8902','2013-05-09','08:30:00',3.13),('8902','2013-05-09','08:35:00',3.43),('8902','2013-05-09','08:40:00',1.99),('8902','2013-05-09','08:45:00',1.17),('8902','2013-05-09','08:50:00',1.11),('8902','2013-05-09','08:55:00',1.07),('8902','2013-05-09','09:00:00',2.36),('8902','2013-05-09','09:05:00',3.84),('8902','2013-05-09','09:10:00',4.61),('8902','2013-05-09','09:15:00',4.79),('8902','2013-05-09','09:20:00',4.62),('8902','2013-05-09','09:25:00',4.38),('8902','2013-05-09','09:30:00',4.01),('8902','2013-05-09','09:35:00',5.06),('8902','2013-05-09','09:40:00',4.78),('8902','2013-05-09','09:45:00',4.66),('8902','2013-05-09','09:50:00',5.78),('8902','2013-05-09','09:55:00',5.83),('8902','2013-05-09','10:00:00',5.09),('8902','2013-05-09','10:05:00',6.16),('8902','2013-05-09','10:10:00',4.87),('8902','2013-05-09','10:15:00',4.6),('8902','2013-05-09','10:20:00',6.56),('8902','2013-05-09','10:25:00',3.01),('8902','2013-05-09','10:30:00',3.7),('8902','2013-05-09','10:35:00',5.76),('8902','2013-05-09','10:40:00',7.13),('8902','2013-05-09','10:45:00',7.14),('8902','2013-05-09','10:50:00',7.36),('8902','2013-05-09','10:55:00',7.27),('8902','2013-05-09','11:00:00',7.45),('8902','2013-05-09','11:05:00',7.38),('8902','2013-05-09','11:10:00',7.21),('8902','2013-05-09','11:15:00',6.83),('8902','2013-05-09','11:20:00',7.94),('8902','2013-05-09','11:25:00',7.1),('8902','2013-05-09','11:30:00',6.15),('8902','2013-05-09','11:35:00',7.42),('8902','2013-05-09','11:40:00',5.81),('8902','2013-05-09','11:45:00',3.98),('8902','2013-05-09','11:50:00',5.43),('8902','2013-05-09','11:55:00',7),('8902','2013-05-09','12:00:00',7.91),('8902','2013-05-09','12:05:00',6.44),('8902','2013-05-09','12:10:00',5.5),('8902','2013-05-09','12:15:00',4.47),('8902','2013-05-09','12:20:00',5.33),('8902','2013-05-09','12:25:00',4.24),('8902','2013-05-09','12:30:00',3.9),('8902','2013-05-09','12:35:00',3.93),('8902','2013-05-09','12:40:00',6.91),('8902','2013-05-09','12:45:00',8.69),('8902','2013-05-09','12:50:00',6.79),('8902','2013-05-09','12:55:00',5.6),('8902','2013-05-09','13:00:00',7.85),('8902','2013-05-09','13:05:00',6.74),('8902','2013-05-09','13:10:00',7.41),('8902','2013-05-09','13:15:00',9.03),('8902','2013-05-09','13:20:00',6.26),('8902','2013-05-09','13:25:00',5.73),('8902','2013-05-09','13:30:00',6.25),('8902','2013-05-09','13:35:00',8.38),('8902','2013-05-09','13:40:00',8.12),('8902','2013-05-09','13:45:00',7.46),('8902','2013-05-09','13:50:00',4.76),('8902','2013-05-09','13:55:00',4.03),('8902','2013-05-09','14:00:00',3.68),('8902','2013-05-09','14:05:00',3.74),('8902','2013-05-09','14:10:00',4.41),('8902','2013-05-09','14:15:00',4.88),('8902','2013-05-09','14:20:00',4.9),('8902','2013-05-09','14:25:00',4.77),('8902','2013-05-09','14:30:00',4.85),('8902','2013-05-09','14:35:00',5.99),('8902','2013-05-09','14:40:00',5.4),('8902','2013-05-09','14:45:00',4.11),('8902','2013-05-09','14:50:00',2.89),('8902','2013-05-09','14:55:00',2.44),('8902','2013-05-09','15:00:00',2.28),('8902','2013-05-09','15:05:00',2.4),('8902','2013-05-09','15:10:00',3.21),('8902','2013-05-09','15:15:00',5.16),('8902','2013-05-09','15:20:00',5.78),('8902','2013-05-09','15:25:00',3.93),('8902','2013-05-09','15:30:00',3.58),('8902','2013-05-09','15:35:00',3.75),('8902','2013-05-09','15:40:00',3.91),('8902','2013-05-09','15:45:00',3.79),('8902','2013-05-09','15:50:00',3.46),('8902','2013-05-09','15:55:00',3.22),('8902','2013-05-09','16:00:00',3.07),('8902','2013-05-09','16:05:00',2.98),('8902','2013-05-09','16:10:00',2.92),('8902','2013-05-09','16:15:00',2.76),('8902','2013-05-09','16:20:00',2.47),('8902','2013-05-09','16:25:00',2.42),('8902','2013-05-09','16:30:00',2.53),('8902','2013-05-09','16:35:00',2.68),('8902','2013-05-09','16:40:00',2.59),('8902','2013-05-09','16:45:00',2.55),('8902','2013-05-09','16:50:00',2.63),('8902','2013-05-09','16:55:00',2.24),('8902','2013-05-09','17:00:00',1.77),('8902','2013-05-09','17:05:00',1.68),('8902','2013-05-09','17:10:00',2.12),('8902','2013-05-09','17:15:00',2.55),('8902','2013-05-09','17:20:00',3.92),('8902','2013-05-09','17:25:00',3.96),('8902','2013-05-09','17:30:00',3.32),('8902','2013-05-09','17:35:00',4.22),('8902','2013-05-09','17:40:00',2.71),('8902','2013-05-09','17:45:00',2.48),('8902','2013-05-09','17:50:00',2.12),('8902','2013-05-09','17:55:00',1.88),('8902','2013-05-09','18:00:00',1.75),('8902','2013-05-09','18:05:00',1.72),('8902','2013-05-09','18:10:00',1.55),('8902','2013-05-09','18:15:00',1.31),('8902','2013-05-09','18:20:00',1.33),('8902','2013-05-09','18:25:00',1.26),('8902','2013-05-09','18:30:00',1),('8902','2013-05-08','07:30:00',1.14),('8902','2013-05-08','07:35:00',1.3),('8902','2013-05-08','07:40:00',1.46),('8902','2013-05-08','07:45:00',1.63),('8902','2013-05-08','07:50:00',1.78),('8902','2013-05-08','07:55:00',1.94),('8902','2013-05-08','08:00:00',2.11),('8902','2013-05-08','08:05:00',2.29),('8902','2013-05-08','08:10:00',2.45),('8902','2013-05-08','08:15:00',2.63),('8902','2013-05-08','08:20:00',2.79),('8902','2013-05-08','08:25:00',2.97),('8902','2013-05-08','08:30:00',3.14),('8902','2013-05-08','08:35:00',3.31),('8902','2013-05-08','08:40:00',3.49),('8902','2013-05-08','08:45:00',3.67),('8902','2013-05-08','08:50:00',3.82),('8902','2013-05-08','08:55:00',3.98),('8902','2013-05-08','09:00:00',4.15),('8902','2013-05-08','09:05:00',4.3),('8902','2013-05-08','09:10:00',4.47),('8902','2013-05-08','09:15:00',4.64),('8902','2013-05-08','09:20:00',4.77),('8902','2013-05-08','09:25:00',4.94),('8902','2013-05-08','09:30:00',5.1),('8902','2013-05-08','09:35:00',5.24),('8902','2013-05-08','09:40:00',5.37),('8902','2013-05-08','09:45:00',5.49),('8902','2013-05-08','09:50:00',5.63),('8902','2013-05-08','09:55:00',5.76),('8902','2013-05-08','10:00:00',5.88),('8902','2013-05-08','10:05:00',5.98),('8902','2013-05-08','10:10:00',6.08),('8902','2013-05-08','10:15:00',6.22),('8902','2013-05-08','10:20:00',6.33),('8902','2013-05-08','10:25:00',6.44),('8902','2013-05-08','10:30:00',6.52),('8902','2013-05-08','10:35:00',6.61),('8902','2013-05-08','10:40:00',6.71),('8902','2013-05-08','10:45:00',6.75),('8902','2013-05-08','10:50:00',6.85),('8902','2013-05-08','10:55:00',6.95),('8902','2013-05-08','11:00:00',7),('8902','2013-05-08','11:05:00',7.11),('8902','2013-05-08','11:10:00',7.22),('8902','2013-05-08','11:15:00',7.28),('8902','2013-05-08','11:20:00',7.34),('8902','2013-05-08','11:25:00',7.37),('8902','2013-05-08','11:30:00',7.38),('8902','2013-05-08','11:35:00',7.41),('8902','2013-05-08','11:40:00',7.51),('8902','2013-05-08','11:45:00',7.55),('8902','2013-05-08','11:50:00',7.58),('8902','2013-05-08','11:55:00',7.62),('8902','2013-05-08','12:00:00',7.71),('8902','2013-05-08','12:05:00',7.82),('8902','2013-05-08','12:10:00',7.84),('8902','2013-05-08','12:15:00',7.91),('8902','2013-05-08','12:20:00',7.82),('8902','2013-05-08','12:25:00',5),('8902','2013-05-08','12:30:00',7.18),('8902','2013-05-08','12:35:00',8.1),('8902','2013-05-08','12:40:00',5.91),('8902','2013-05-08','12:45:00',4.77),('8902','2013-05-08','12:50:00',7.73),('8902','2013-05-08','12:55:00',8.22),('8902','2013-05-08','13:00:00',8.1),('8902','2013-05-08','13:05:00',8.05),('8902','2013-05-08','13:10:00',8.13),('8902','2013-05-08','13:15:00',8.08),('8902','2013-05-08','13:20:00',8.15),('8902','2013-05-08','13:25:00',8.12),('8902','2013-05-08','13:30:00',8.17),('8902','2013-05-08','13:35:00',8.13),('8902','2013-05-08','13:40:00',8.2),('8902','2013-05-08','13:45:00',8.23),('8902','2013-05-08','13:50:00',8.1),('8902','2013-05-08','13:55:00',7.82),('8902','2013-05-08','14:00:00',8.03),('8902','2013-05-08','14:05:00',8.11),('8902','2013-05-08','14:10:00',6.6),('8902','2013-05-08','14:15:00',6.09),('8902','2013-05-08','14:20:00',7.92),('8902','2013-05-08','14:25:00',6.77),('8902','2013-05-08','14:30:00',7.42),('8902','2013-05-08','14:35:00',7.87),('8902','2013-05-08','14:40:00',7.89),('8902','2013-05-08','14:45:00',7.81),('8902','2013-05-08','14:50:00',7.73),('8902','2013-05-08','14:55:00',7.77),('8902','2013-05-08','15:00:00',7.68),('8902','2013-05-08','15:05:00',7.51),('8902','2013-05-08','15:10:00',7.43),('8902','2013-05-08','15:15:00',7.36),('8902','2013-05-08','15:20:00',7.24),('8902','2013-05-08','15:25:00',7.18),('8902','2013-05-08','15:30:00',7.22),('8902','2013-05-08','15:35:00',7.13),('8902','2013-05-08','15:40:00',7.04),('8902','2013-05-08','15:45:00',6.94),('8902','2013-05-08','15:50:00',6.88),('8902','2013-05-08','15:55:00',6.75),('8902','2013-05-08','16:00:00',6.61),('8902','2013-05-08','16:05:00',6.57),('8902','2013-05-08','16:10:00',6.42),('8902','2013-05-08','16:15:00',6.28),('8902','2013-05-08','16:20:00',6.17),('8902','2013-05-08','16:25:00',5.99),('8902','2013-05-08','16:30:00',5.81),('8902','2013-05-08','16:35:00',5.77),('8902','2013-05-08','16:40:00',5.59),('8902','2013-05-08','16:45:00',5.32),('8902','2013-05-08','16:50:00',5.16),('8902','2013-05-08','16:55:00',5.09),('8902','2013-05-08','17:00:00',4.97),('8902','2013-05-08','17:05:00',4.83),('8902','2013-05-08','17:10:00',4.64),('8902','2013-05-08','17:15:00',4.49),('8902','2013-05-08','17:20:00',4.35),('8902','2013-05-08','17:25:00',4.22),('8902','2013-05-08','17:30:00',4.02),('8902','2013-05-08','17:35:00',3.88),('8902','2013-05-08','17:40:00',3.68),('8902','2013-05-08','17:45:00',3.44),('8902','2013-05-08','17:50:00',3.32),('8902','2013-05-08','17:55:00',3.13),('8902','2013-05-08','18:00:00',2.94),('8902','2013-05-08','18:05:00',2.77),('8902','2013-05-08','18:10:00',2.56),('8902','2013-05-08','18:15:00',2.39),('8902','2013-05-08','18:20:00',2.21),('8902','2013-05-08','18:25:00',1.99),('8902','2013-05-08','18:30:00',1.86),('8902','2013-05-08','18:35:00',1.7),('8902','2013-05-08','18:40:00',1.49),('8902','2013-05-08','18:45:00',1.32),('8902','2013-05-08','18:50:00',1.19),('8902','2013-05-08','18:55:00',1.02),('8902','2013-05-07','07:55:00',1.35),('8902','2013-05-07','08:05:00',1.76),('8902','2013-05-07','08:10:00',2.72),('8902','2013-05-07','08:15:00',2.85),('8902','2013-05-07','08:20:00',2.9),('8902','2013-05-07','08:25:00',2.95),('8902','2013-05-07','08:30:00',3.16),('8902','2013-05-07','08:35:00',3.3),('8902','2013-05-07','08:40:00',3.51),('8902','2013-05-07','08:45:00',3.8),('8902','2013-05-07','08:50:00',4.54),('8902','2013-05-07','08:55:00',5.18),('8902','2013-05-07','09:00:00',5.46),('8902','2013-05-07','09:05:00',5.71),('8902','2013-05-07','09:10:00',5.22),('8902','2013-05-07','09:15:00',5.15),('8902','2013-05-07','09:20:00',3.26),('8902','2013-05-07','09:25:00',1.29),('8902','2013-05-07','09:30:00',1.15),('8902','2013-05-07','09:35:00',1.35),('8902','2013-05-07','09:40:00',1.83),('8902','2013-05-07','09:45:00',4.54),('8902','2013-05-07','09:50:00',2.03),('8902','2013-05-07','09:55:00',1.73),('8902','2013-05-07','10:00:00',3.47),('8902','2013-05-07','10:05:00',5.68),('8902','2013-05-07','10:10:00',5.49),('8902','2013-05-07','10:15:00',3.68),('8902','2013-05-07','10:20:00',3.79),('8902','2013-05-07','10:25:00',3.96),('8902','2013-05-07','10:30:00',3.88),('8902','2013-05-07','10:35:00',1.66),('8902','2013-05-07','10:40:00',1.63),('8902','2013-05-07','10:45:00',1.63),('8902','2013-05-07','10:50:00',1.56),('8902','2013-05-07','10:55:00',1.93),('8902','2013-05-07','11:00:00',2.72),('8902','2013-05-07','11:05:00',4.5),('8902','2013-05-07','11:10:00',7.07),('8902','2013-05-07','11:15:00',8.2),('8902','2013-05-07','11:20:00',7.74),('8902','2013-05-07','11:25:00',7.47),('8902','2013-05-07','11:30:00',8.12),('8902','2013-05-07','11:35:00',8.38),('8902','2013-05-07','11:40:00',8.47),('8902','2013-05-07','11:45:00',5.77),('8902','2013-05-07','11:50:00',4.02),('8902','2013-05-07','11:55:00',3.13),('8902','2013-05-07','12:00:00',7.86),('8902','2013-05-07','12:05:00',6.02),('8902','2013-05-07','12:10:00',1.4),('8902','2013-05-07','12:15:00',1.49),('8902','2013-05-07','12:20:00',1.82),('8902','2013-05-07','12:25:00',3),('8902','2013-05-07','12:30:00',3.01),('8902','2013-05-07','12:35:00',2.21),('8902','2013-05-07','12:40:00',2.55),('8902','2013-05-07','12:45:00',3.17),('8902','2013-05-07','12:50:00',6.69),('8902','2013-05-07','12:55:00',3.37),('8902','2013-05-07','13:00:00',8.69),('8902','2013-05-07','13:05:00',7.19),('8902','2013-05-07','13:10:00',6.73),('8902','2013-05-07','13:15:00',6.02),('8902','2013-05-07','13:20:00',2.17),('8902','2013-05-07','13:25:00',2.17),('8902','2013-05-07','13:30:00',1.81),('8902','2013-05-07','13:35:00',1.72),('8902','2013-05-07','13:40:00',1.91),('8902','2013-05-07','13:45:00',8.13),('8902','2013-05-07','13:50:00',8.5),('8902','2013-05-07','13:55:00',7.76),('8902','2013-05-07','14:00:00',8.16),('8902','2013-05-07','14:05:00',3.17),('8902','2013-05-07','14:10:00',3.59),('8902','2013-05-07','14:15:00',2.71),('8902','2013-05-07','14:20:00',5.38),('8902','2013-05-07','14:25:00',3.34),('8902','2013-05-07','14:30:00',5.97),('8902','2013-05-07','14:35:00',5.78),('8902','2013-05-07','14:40:00',3.77),('8902','2013-05-07','14:45:00',3.69),('8902','2013-05-07','14:50:00',4.85),('8902','2013-05-07','14:55:00',7.18),('8902','2013-05-07','15:00:00',7.5),('8902','2013-05-07','15:05:00',7.93),('8902','2013-05-07','15:10:00',6.29),('8902','2013-05-07','15:15:00',6.51),('8902','2013-05-07','15:20:00',7.72),('8902','2013-05-07','15:25:00',7.53),('8902','2013-05-07','15:30:00',7.42),('8902','2013-05-07','15:35:00',7.21),('8902','2013-05-07','15:40:00',7.1),('8902','2013-05-07','15:45:00',6.97),('8902','2013-05-07','15:50:00',6.91),('8902','2013-05-07','15:55:00',6.77),('8902','2013-05-07','16:00:00',6.74),('8902','2013-05-07','16:05:00',6.6),('8902','2013-05-07','16:10:00',6.54),('8902','2013-05-07','16:15:00',6.39),('8902','2013-05-07','16:20:00',6.23),('8902','2013-05-07','16:25:00',6.04),('8902','2013-05-07','16:30:00',6.09),('8902','2013-05-07','16:35:00',5.97),('8902','2013-05-07','16:40:00',5.82),('8902','2013-05-07','16:45:00',5.16),('8902','2013-05-07','16:50:00',5.74),('8902','2013-05-07','16:55:00',5.06),('8902','2013-05-07','17:00:00',4.92),('8902','2013-05-07','17:05:00',5.89),('8902','2013-05-07','17:10:00',5.46),('8902','2013-05-07','17:15:00',5),('8902','2013-05-07','17:20:00',4.79),('8902','2013-05-07','17:25:00',3.75),('8902','2013-05-07','17:30:00',4.69),('8902','2013-05-07','17:35:00',4.63),('8902','2013-05-07','17:40:00',4.46),('8902','2013-05-07','17:45:00',4.38),('8902','2013-05-07','17:50:00',4.4),('8902','2013-05-07','17:55:00',3.5),('8902','2013-05-07','18:00:00',1.61),('8902','2013-05-07','18:05:00',1.53),('8902','2013-05-07','18:10:00',1.9),('8902','2013-05-07','18:15:00',2.72),('8902','2013-05-07','18:20:00',2.58),('8902','2013-05-07','18:25:00',2.39),('8902','2013-05-07','18:30:00',2.05),('8902','2013-05-07','18:35:00',1.87),('8902','2013-05-07','18:40:00',1.23),('8902','2013-05-06','07:30:00',1.11),('8902','2013-05-06','07:35:00',1.29),('8902','2013-05-06','07:40:00',1.44),('8902','2013-05-06','07:45:00',1.59),('8902','2013-05-06','07:50:00',1.75),('8902','2013-05-06','07:55:00',1.91),('8902','2013-05-06','08:00:00',2.11),('8902','2013-05-06','08:05:00',2.26),('8902','2013-05-06','08:10:00',2.45),('8902','2013-05-06','08:15:00',2.63),('8902','2013-05-06','08:20:00',2.8),('8902','2013-05-06','08:25:00',2.97),('8902','2013-05-06','08:30:00',3.17),('8902','2013-05-06','08:35:00',3.33),('8902','2013-05-06','08:40:00',3.47),('8902','2013-05-06','08:45:00',3.75),('8902','2013-05-06','08:50:00',4.03),('8902','2013-05-06','08:55:00',4.3),('8902','2013-05-06','09:00:00',4.52),('8902','2013-05-06','09:05:00',5.06),('8902','2013-05-06','09:10:00',5.23),('8902','2013-05-06','09:15:00',5.71),('8902','2013-05-06','09:20:00',2.49),('8902','2013-05-06','09:25:00',1.47),('8902','2013-05-06','09:30:00',1.86),('8902','2013-05-06','09:35:00',5.86),('8902','2013-05-06','09:40:00',4.3),('8902','2013-05-06','09:45:00',2.33),('8902','2013-05-06','09:50:00',3.28),('8902','2013-05-06','09:55:00',4.01),('8902','2013-05-06','10:00:00',3.78),('8902','2013-05-06','10:05:00',1.82),('8902','2013-05-06','10:10:00',1.44),('8902','2013-05-06','10:15:00',1.31),('8902','2013-05-06','10:20:00',1.2),('8902','2013-05-06','10:25:00',1.21),('8902','2013-05-06','10:30:00',1.2),('8902','2013-05-06','10:35:00',1.06),('8902','2013-05-06','10:40:00',1.07),('8902','2013-05-06','10:50:00',1),('8902','2013-05-06','10:55:00',1.29),('8902','2013-05-06','11:00:00',1.7),('8902','2013-05-06','11:05:00',2.04),('8902','2013-05-06','11:10:00',2.23),('8902','2013-05-06','11:15:00',2.53),('8902','2013-05-06','11:20:00',4.16),('8902','2013-05-06','11:25:00',6.02),('8902','2013-05-06','11:30:00',1.96),('8902','2013-05-06','11:35:00',1.31),('8902','2013-05-06','11:55:00',1.14),('8902','2013-05-06','12:00:00',1.25),('8902','2013-05-06','12:05:00',1.37),('8902','2013-05-06','12:10:00',2.09),('8902','2013-05-06','12:15:00',3.04),('8902','2013-05-06','12:20:00',1.88),('8902','2013-05-06','12:25:00',3.26),('8902','2013-05-06','12:30:00',6.96),('8902','2013-05-06','12:35:00',2.17),('8902','2013-05-06','12:40:00',1.84),('8902','2013-05-06','12:45:00',1.34),('8902','2013-05-06','13:05:00',1.03),('8902','2013-05-06','13:10:00',1.28),('8902','2013-05-06','13:15:00',1.88),('8902','2013-05-06','13:20:00',2.59),('8902','2013-05-06','13:25:00',3.11),('8902','2013-05-06','13:30:00',5.8),('8902','2013-05-06','13:35:00',7.1),('8902','2013-05-06','13:40:00',7.45),('8902','2013-05-06','13:45:00',7.35),('8902','2013-05-06','13:50:00',9.34),('8902','2013-05-06','13:55:00',9.06),('8902','2013-05-06','14:00:00',8.13),('8902','2013-05-06','14:05:00',8.73),('8902','2013-05-06','14:10:00',8.75),('8902','2013-05-06','14:15:00',8.8),('8902','2013-05-06','14:20:00',8.76),('8902','2013-05-06','14:25:00',8.86),('8902','2013-05-06','14:30:00',8.51),('8902','2013-05-06','14:35:00',9.25),('8902','2013-05-06','14:40:00',8.13),('8902','2013-05-06','14:45:00',8.23),('8902','2013-05-06','14:50:00',7.89),('8902','2013-05-06','14:55:00',6.55),('8902','2013-05-06','15:00:00',9.29),('8902','2013-05-06','15:05:00',8.44),('8902','2013-05-06','15:10:00',7.08),('8902','2013-05-06','15:15:00',7.04),('8902','2013-05-06','15:20:00',7.24),('8902','2013-05-06','15:25:00',5.52),('8902','2013-05-06','15:30:00',6.02),('8902','2013-05-06','15:35:00',6.78),('8902','2013-05-06','15:40:00',3.34),('8902','2013-05-06','15:45:00',3.21),('8902','2013-05-06','15:50:00',2.59),('8902','2013-05-06','15:55:00',3.39),('8902','2013-05-06','16:00:00',6.35),('8902','2013-05-06','16:05:00',6.13),('8902','2013-05-06','16:10:00',2.32),('8902','2013-05-06','16:15:00',5.75),('8902','2013-05-06','16:20:00',8.08),('8902','2013-05-06','16:25:00',7.88),('8902','2013-05-06','16:30:00',7.42),('8902','2013-05-06','16:35:00',7.34),('8902','2013-05-06','16:40:00',7.4),('8902','2013-05-06','16:45:00',5.36),('8902','2013-05-06','16:50:00',6.47),('8902','2013-05-06','16:55:00',5.58),('8902','2013-05-06','17:00:00',5.79),('8902','2013-05-06','17:05:00',5.98),('8902','2013-05-06','17:10:00',4.27),('8902','2013-05-06','17:15:00',2.37),('8902','2013-05-06','17:20:00',2.18),('8902','2013-05-06','17:25:00',2.27),('8902','2013-05-06','17:30:00',1.97),('8902','2013-05-06','17:35:00',1.87),('8902','2013-05-06','17:40:00',1.78),('8902','2013-05-06','17:45:00',1.64),('8902','2013-05-06','17:50:00',1.42),('8902','2013-05-06','17:55:00',1.1),('8902','2013-05-06','18:40:00',1.1),('8902','2013-05-06','18:45:00',1.31),('8902','2013-05-06','18:50:00',1.2),('8902','2013-05-05','08:15:00',1.12),('8902','2013-05-05','08:20:00',1.25),('8902','2013-05-05','08:25:00',2.07),('8902','2013-05-05','08:30:00',2.37),('8902','2013-05-05','08:35:00',1.97),('8902','2013-05-05','08:40:00',1.61),('8902','2013-05-05','08:45:00',1.29),('8902','2013-05-05','08:50:00',1.82),('8902','2013-05-05','08:55:00',3.03),('8902','2013-05-05','09:00:00',3.34),('8902','2013-05-05','09:05:00',2.45),('8902','2013-05-05','09:10:00',2.88),('8902','2013-05-05','09:15:00',2.27),('8902','2013-05-05','09:20:00',2.18),('8902','2013-05-05','09:25:00',1.97),('8902','2013-05-05','09:30:00',1.81),('8902','2013-05-05','09:35:00',1.27),('8902','2013-05-05','09:55:00',1.9),('8902','2013-05-05','10:00:00',3.15),('8902','2013-05-05','10:05:00',2.38),('8902','2013-05-05','10:10:00',2.22),('8902','2013-05-05','10:15:00',2.83),('8902','2013-05-05','10:20:00',3.39),('8902','2013-05-05','10:25:00',2.99),('8902','2013-05-05','10:30:00',3.48),('8902','2013-05-05','10:35:00',3.18),('8902','2013-05-05','10:40:00',3.22),('8902','2013-05-05','10:45:00',5.44),('8902','2013-05-05','10:50:00',4.52),('8902','2013-05-05','10:55:00',3.82),('8902','2013-05-05','11:00:00',3.95),('8902','2013-05-05','11:05:00',3.82),('8902','2013-05-05','11:10:00',3.64),('8902','2013-05-05','11:15:00',3.41),('8902','2013-05-05','11:20:00',4.06),('8902','2013-05-05','11:25:00',4.06),('8902','2013-05-05','11:30:00',4.2),('8902','2013-05-05','11:35:00',2.81),('8902','2013-05-05','11:40:00',7.31),('8902','2013-05-05','11:45:00',7.03),('8902','2013-05-05','11:50:00',5.36),('8902','2013-05-05','11:55:00',2.85),('8902','2013-05-05','12:00:00',4.14),('8902','2013-05-05','12:05:00',3.7),('8902','2013-05-05','12:10:00',6.94),('8902','2013-05-05','12:15:00',4.43),('8902','2013-05-05','12:20:00',4.73),('8902','2013-05-05','12:25:00',6.24),('8902','2013-05-05','12:30:00',7.9),('8902','2013-05-05','12:35:00',6.9),('8902','2013-05-05','12:40:00',6.86),('8902','2013-05-05','12:45:00',4.32),('8902','2013-05-05','12:50:00',5.37),('8902','2013-05-05','12:55:00',7.7),('8902','2013-05-05','13:00:00',3.78),('8902','2013-05-05','13:05:00',4.68),('8902','2013-05-05','13:10:00',8.55),('8902','2013-05-05','13:15:00',7.68),('8902','2013-05-05','13:20:00',8.46),('8902','2013-05-05','13:25:00',6.2),('8902','2013-05-05','13:30:00',7.11),('8902','2013-05-05','13:35:00',4.46),('8902','2013-05-05','13:40:00',9.86),('8902','2013-05-05','13:45:00',6.53),('8902','2013-05-05','13:50:00',8.22),('8902','2013-05-05','13:55:00',8.79),('8902','2013-05-05','14:00:00',9.24),('8902','2013-05-05','14:05:00',8.02),('8902','2013-05-05','14:10:00',5.58),('8902','2013-05-05','14:15:00',6.39),('8902','2013-05-05','14:20:00',8.04),('8902','2013-05-05','14:25:00',6.38),('8902','2013-05-05','14:30:00',6.23),('8902','2013-05-05','14:35:00',9.3),('8902','2013-05-05','14:40:00',8.63),('8902','2013-05-05','14:45:00',5.82),('8902','2013-05-05','14:50:00',6.58),('8902','2013-05-05','14:55:00',8.31),('8902','2013-05-05','15:00:00',5.16),('8902','2013-05-05','15:05:00',3.96),('8902','2013-05-05','15:10:00',4.78),('8902','2013-05-05','15:15:00',4.67),('8902','2013-05-05','15:20:00',5.86),('8902','2013-05-05','15:25:00',2.84),('8902','2013-05-05','15:30:00',6.06),('8902','2013-05-05','15:35:00',4.01),('8902','2013-05-05','15:40:00',5.94),('8902','2013-05-05','15:45:00',2.94),('8902','2013-05-05','15:50:00',2.92),('8902','2013-05-05','15:55:00',4.6),('8902','2013-05-05','16:00:00',3.16),('8902','2013-05-05','16:05:00',3.02),('8902','2013-05-05','16:10:00',2.42),('8902','2013-05-05','16:15:00',2.4),('8902','2013-05-05','16:20:00',3.44),('8902','2013-05-05','16:25:00',5.09),('8902','2013-05-05','16:30:00',5.84),('8902','2013-05-05','16:35:00',3.78),('8902','2013-05-05','16:40:00',5.89),('8902','2013-05-05','16:45:00',5.02),('8902','2013-05-05','16:50:00',4.16),('8902','2013-05-05','16:55:00',4.83),('8902','2013-05-05','17:00:00',2.69),('8902','2013-05-05','17:05:00',1.25),('8902','2013-05-05','17:10:00',1.06),('8902','2013-05-05','17:15:00',2.36),('8902','2013-05-05','17:20:00',2.04),('8902','2013-05-05','17:25:00',1.28),('8902','2013-05-05','17:30:00',1.23),('8902','2013-05-05','17:35:00',3.69),('8902','2013-05-05','17:40:00',3.24),('8902','2013-05-05','17:45:00',2.16),('8902','2013-05-05','17:50:00',2.05),('8902','2013-05-05','17:55:00',1.5),('8902','2013-05-05','18:00:00',2.29),('8902','2013-05-05','18:05:00',2.88),('8902','2013-05-05','18:10:00',2.28),('8902','2013-05-05','18:20:00',2.3),('8902','2013-05-05','18:25:00',2.39),('8902','2013-05-05','18:30:00',2.13),('8902','2013-05-05','18:35:00',1.52),('8902','2013-05-04','07:40:00',1.1),('8902','2013-05-04','07:45:00',1.53),('8902','2013-05-04','07:50:00',1.64),('8902','2013-05-04','07:55:00',1.72),('8902','2013-05-04','08:00:00',1.87),('8902','2013-05-04','08:05:00',2.09),('8902','2013-05-04','08:10:00',2.3),('8902','2013-05-04','08:15:00',2.51),('8902','2013-05-04','08:20:00',2.95),('8902','2013-05-04','08:25:00',3.69),('8902','2013-05-04','08:30:00',3.73),('8902','2013-05-04','08:35:00',3.58),('8902','2013-05-04','08:40:00',3.66),('8902','2013-05-04','08:45:00',2.88),('8902','2013-05-04','08:50:00',2.47),('8902','2013-05-04','08:55:00',2.3),('8902','2013-05-04','09:00:00',2.48),('8902','2013-05-04','09:05:00',2.86),('8902','2013-05-04','09:10:00',2.97),('8902','2013-05-04','09:15:00',3.61),('8902','2013-05-04','09:20:00',3.1),('8902','2013-05-04','09:25:00',3.75),('8902','2013-05-04','09:30:00',3.28),('8902','2013-05-04','09:35:00',2.88),('8902','2013-05-04','09:40:00',4.47),('8902','2013-05-04','09:45:00',4.61),('8902','2013-05-04','09:50:00',3.43),('8902','2013-05-04','09:55:00',6.12),('8902','2013-05-04','10:00:00',4.08),('8902','2013-05-04','10:05:00',3.82),('8902','2013-05-04','10:10:00',4.01),('8902','2013-05-04','10:15:00',3.29),('8902','2013-05-04','10:20:00',4.65),('8902','2013-05-04','10:25:00',4.39),('8902','2013-05-04','10:30:00',4.71),('8902','2013-05-04','10:35:00',4.47),('8902','2013-05-04','10:40:00',4.64),('8902','2013-05-04','10:45:00',4.7),('8902','2013-05-04','10:50:00',3.79),('8902','2013-05-04','10:55:00',3.2),('8902','2013-05-04','11:00:00',2.95),('8902','2013-05-04','11:05:00',3.72),('8902','2013-05-04','11:10:00',3.4),('8902','2013-05-04','11:15:00',3.28),('8902','2013-05-04','11:20:00',4.4),('8902','2013-05-04','11:25:00',6.16),('8902','2013-05-04','11:30:00',5.41),('8902','2013-05-04','11:35:00',7.01),('8902','2013-05-04','11:40:00',6.73),('8902','2013-05-04','11:45:00',5.89),('8902','2013-05-04','11:50:00',5.25),('8902','2013-05-04','11:55:00',5.65),('8902','2013-05-04','12:00:00',4.49),('8902','2013-05-04','12:05:00',4.97),('8902','2013-05-04','12:10:00',5.08),('8902','2013-05-04','12:15:00',5.04),('8902','2013-05-04','12:20:00',6.12),('8902','2013-05-04','12:25:00',6.68),('8902','2013-05-04','12:30:00',6.8),('8902','2013-05-04','12:35:00',8.32),('8902','2013-05-04','12:40:00',6.63),('8902','2013-05-04','12:45:00',6.47),('8902','2013-05-04','12:50:00',6.29),('8902','2013-05-04','12:55:00',7.77),('8902','2013-05-04','13:00:00',6.86),('8902','2013-05-04','13:05:00',8.04),('8902','2013-05-04','13:10:00',7.18),('8902','2013-05-04','13:15:00',8.63),('8902','2013-05-04','13:20:00',7.05),('8902','2013-05-04','13:25:00',4.42),('8902','2013-05-04','13:30:00',3.07),('8902','2013-05-04','13:35:00',6.3),('8902','2013-05-04','13:40:00',8.64),('8902','2013-05-04','13:45:00',8.26),('8902','2013-05-04','13:50:00',8.23),('8902','2013-05-04','13:55:00',8.24),('8902','2013-05-04','14:00:00',8.38),('8902','2013-05-04','14:05:00',8.61),('8902','2013-05-04','14:10:00',6.51),('8902','2013-05-04','14:15:00',6.07),('8902','2013-05-04','14:20:00',7.48),('8902','2013-05-04','14:25:00',7.67),('8902','2013-05-04','14:30:00',7.42),('8902','2013-05-04','14:35:00',7.35),('8902','2013-05-04','14:40:00',7.29),('8902','2013-05-04','14:45:00',7.28),('8902','2013-05-04','14:50:00',7.21),('8902','2013-05-04','14:55:00',7.13),('8902','2013-05-04','15:00:00',7.08),('8902','2013-05-04','15:05:00',7.04),('8902','2013-05-04','15:10:00',6.98),('8902','2013-05-04','15:15:00',6.92),('8902','2013-05-04','15:20:00',6.81),('8902','2013-05-04','15:25:00',6.78),('8902','2013-05-04','15:30:00',6.78),('8902','2013-05-04','15:35:00',6.69),('8902','2013-05-04','15:40:00',6.61),('8902','2013-05-04','15:45:00',6.52),('8902','2013-05-04','15:50:00',6.45),('8902','2013-05-04','15:55:00',6.37),('8902','2013-05-04','16:00:00',6.26),('8902','2013-05-04','16:05:00',6.16),('8902','2013-05-04','16:10:00',6.06),('8902','2013-05-04','16:15:00',5.98),('8902','2013-05-04','16:20:00',5.85),('8902','2013-05-04','16:25:00',5.64),('8902','2013-05-04','16:30:00',5.5),('8902','2013-05-04','16:35:00',5.42),('8902','2013-05-04','16:40:00',5.31),('8902','2013-05-04','16:45:00',5.08),('8902','2013-05-04','16:50:00',5),('8902','2013-05-04','16:55:00',4.84),('8902','2013-05-04','17:00:00',4.68),('8902','2013-05-04','17:05:00',4.51),('8902','2013-05-04','17:10:00',4.34),('8902','2013-05-04','17:15:00',4.24),('8902','2013-05-04','17:20:00',4.07),('8902','2013-05-04','17:25:00',3.9),('8902','2013-05-04','17:30:00',3.69),('8902','2013-05-04','17:35:00',3.54),('8902','2013-05-04','17:40:00',3.37),('8902','2013-05-04','17:45:00',3.19),('8902','2013-05-04','17:50:00',3.02),('8902','2013-05-04','17:55:00',2.84),('8902','2013-05-04','18:00:00',2.64),('8902','2013-05-04','18:05:00',2.47),('8902','2013-05-04','18:10:00',2.3),('8902','2013-05-04','18:15:00',2.14),('8902','2013-05-04','18:20:00',1.96),('8902','2013-05-04','18:25:00',1.77),('8902','2013-05-04','18:30:00',1.63),('8902','2013-05-04','18:35:00',1.5),('8902','2013-05-04','18:40:00',1.35),('8902','2013-05-04','18:45:00',1.17),('8902','2013-05-04','18:50:00',1.03),('8902','2013-05-03','07:40:00',1.29),('8902','2013-05-03','07:45:00',1.36),('8902','2013-05-03','07:50:00',1.5),('8902','2013-05-03','07:55:00',1.77),('8902','2013-05-03','08:00:00',1.95),('8902','2013-05-03','08:05:00',2.09),('8902','2013-05-03','08:10:00',2.22),('8902','2013-05-03','08:15:00',2.35),('8902','2013-05-03','08:20:00',2.5),('8902','2013-05-03','08:25:00',2.63),('8902','2013-05-03','08:30:00',2.79),('8902','2013-05-03','08:35:00',2.93),('8902','2013-05-03','08:40:00',3.09),('8902','2013-05-03','08:45:00',3.28),('8902','2013-05-03','08:50:00',3.44),('8902','2013-05-03','08:55:00',3.57),('8902','2013-05-03','09:00:00',3.71),('8902','2013-05-03','09:05:00',3.89),('8902','2013-05-03','09:10:00',4.06),('8902','2013-05-03','09:15:00',4.14),('8902','2013-05-03','09:20:00',4.38),('8902','2013-05-03','09:25:00',4.45),('8902','2013-05-03','09:30:00',4.55),('8902','2013-05-03','09:35:00',4.73),('8902','2013-05-03','09:40:00',4.91),('8902','2013-05-03','09:45:00',5.05),('8902','2013-05-03','09:50:00',5.19),('8902','2013-05-03','09:55:00',5.33),('8902','2013-05-03','10:00:00',5.48),('8902','2013-05-03','10:05:00',5.57),('8902','2013-05-03','10:10:00',5.75),('8902','2013-05-03','10:15:00',5.84),('8902','2013-05-03','10:20:00',5.93),('8902','2013-05-03','10:25:00',6.06),('8902','2013-05-03','10:30:00',6.17),('8902','2013-05-03','10:35:00',6.28),('8902','2013-05-03','10:40:00',6.26),('8902','2013-05-03','10:45:00',6.28),('8902','2013-05-03','10:50:00',6.28),('8902','2013-05-03','10:55:00',6.18),('8902','2013-05-03','11:00:00',6.26),('8902','2013-05-03','11:05:00',6.31),('8902','2013-05-03','11:10:00',6.07),('8902','2013-05-03','11:15:00',5.82),('8902','2013-05-03','11:20:00',6.23),('8902','2013-05-03','11:25:00',6.45),('8902','2013-05-03','11:30:00',6.17),('8902','2013-05-03','11:35:00',6.37),('8902','2013-05-03','11:40:00',6.15),('8902','2013-05-03','11:45:00',6.38),('8902','2013-05-03','11:50:00',6.39),('8902','2013-05-03','11:55:00',6.42),('8902','2013-05-03','12:00:00',6.21),('8902','2013-05-03','12:05:00',6.47),('8902','2013-05-03','12:10:00',6.63),('8902','2013-05-03','12:15:00',6.77),('8902','2013-05-03','12:20:00',6.98),('8902','2013-05-03','12:25:00',7.08),('8902','2013-05-03','12:30:00',7.07),('8902','2013-05-03','12:35:00',7.2),('8902','2013-05-03','12:40:00',7.17),('8902','2013-05-03','12:45:00',7.24),('8902','2013-05-03','12:50:00',7.02),('8902','2013-05-03','12:55:00',6.82),('8902','2013-05-03','13:00:00',6.73),('8902','2013-05-03','13:05:00',6.11),('8902','2013-05-03','13:10:00',6.65),('8902','2013-05-03','13:15:00',7.54),('8902','2013-05-03','13:20:00',7.65),('8902','2013-05-03','13:25:00',7.16),('8902','2013-05-03','13:30:00',7.29),('8902','2013-05-03','13:35:00',7.11),('8902','2013-05-03','13:40:00',7.15),('8902','2013-05-03','13:45:00',7.08),('8902','2013-05-03','13:50:00',6.28),('8902','2013-05-03','13:55:00',6.78),('8902','2013-05-03','14:00:00',6.64),('8902','2013-05-03','14:05:00',7),('8902','2013-05-03','14:10:00',6.64),('8902','2013-05-03','14:15:00',6.82),('8902','2013-05-03','14:20:00',6.93),('8902','2013-05-03','14:25:00',6.38),('8902','2013-05-03','14:30:00',6.66),('8902','2013-05-03','14:35:00',6.3),('8902','2013-05-03','14:40:00',6.57),('8902','2013-05-03','14:45:00',6.47),('8902','2013-05-03','14:50:00',6.14),('8902','2013-05-03','14:55:00',6.35),('8902','2013-05-03','15:00:00',6.45),('8902','2013-05-03','15:05:00',6.59),('8902','2013-05-03','15:10:00',6.16),('8902','2013-05-03','15:15:00',6.31),('8902','2013-05-03','15:20:00',6.48),('8902','2013-05-03','15:25:00',6.59),('8902','2013-05-03','15:30:00',6.48),('8902','2013-05-03','15:35:00',6.21),('8902','2013-05-03','15:40:00',6.11),('8902','2013-05-03','15:45:00',6.17),('8902','2013-05-03','15:50:00',6.14),('8902','2013-05-03','15:55:00',6.05),('8902','2013-05-03','16:00:00',5.88),('8902','2013-05-03','16:05:00',5.8),('8902','2013-05-03','16:10:00',5.73),('8902','2013-05-03','16:15:00',5.59),('8902','2013-05-03','16:20:00',5.48),('8902','2013-05-03','16:25:00',5.34),('8902','2013-05-03','16:30:00',5.22),('8902','2013-05-03','16:35:00',5.11),('8902','2013-05-03','16:40:00',4.98),('8902','2013-05-03','16:45:00',4.73),('8902','2013-05-03','16:50:00',4.59),('8902','2013-05-03','16:55:00',4.5),('8902','2013-05-03','17:00:00',4.39),('8902','2013-05-03','17:05:00',4.11),('8902','2013-05-03','17:10:00',3.27),('8902','2013-05-03','17:15:00',3.74),('8902','2013-05-03','17:20:00',3.87),('8902','2013-05-03','17:25:00',3.69),('8902','2013-05-03','17:30:00',3.45),('8902','2013-05-03','17:35:00',3.22),('8902','2013-05-03','17:40:00',2.98),('8902','2013-05-03','17:45:00',2.9),('8902','2013-05-03','17:50:00',2.88),('8902','2013-05-03','17:55:00',2.77),('8902','2013-05-03','18:00:00',2.59),('8902','2013-05-03','18:05:00',2.45),('8902','2013-05-03','18:10:00',2.13),('8902','2013-05-03','18:15:00',1.63),('8902','2013-05-03','18:20:00',1.39),('8902','2013-05-03','18:25:00',1.15),('8902','2013-05-02','07:50:00',1.07),('8902','2013-05-02','07:55:00',1.21),('8902','2013-05-02','08:00:00',1.47),('8902','2013-05-02','08:05:00',2.01),('8902','2013-05-02','08:10:00',2.48),('8902','2013-05-02','08:15:00',2.82),('8902','2013-05-02','08:20:00',2.8),('8902','2013-05-02','08:25:00',3.02),('8902','2013-05-02','08:30:00',3.16),('8902','2013-05-02','08:35:00',3.28),('8902','2013-05-02','08:40:00',3.39),('8902','2013-05-02','08:45:00',3.53),('8902','2013-05-02','08:50:00',3.5),('8902','2013-05-02','08:55:00',3.57),('8902','2013-05-02','09:00:00',3.8),('8902','2013-05-02','09:05:00',4.08),('8902','2013-05-02','09:10:00',4.16),('8902','2013-05-02','09:15:00',4.28),('8902','2013-05-02','09:20:00',4.41),('8902','2013-05-02','09:25:00',4.6),('8902','2013-05-02','09:30:00',4.71),('8902','2013-05-02','09:35:00',4.87),('8902','2013-05-02','09:40:00',5.04),('8902','2013-05-02','09:45:00',5.18),('8902','2013-05-02','09:50:00',5.29),('8902','2013-05-02','09:55:00',5.43),('8902','2013-05-02','10:00:00',5.56),('8902','2013-05-02','10:05:00',5.68),('8902','2013-05-02','10:10:00',5.81),('8902','2013-05-02','10:15:00',5.92),('8902','2013-05-02','10:20:00',6.03),('8902','2013-05-02','10:25:00',6.13),('8902','2013-05-02','10:30:00',6.25),('8902','2013-05-02','10:35:00',6.3),('8902','2013-05-02','10:40:00',6.37),('8902','2013-05-02','10:45:00',6.42),('8902','2013-05-02','10:50:00',6.48),('8902','2013-05-02','10:55:00',6.6),('8902','2013-05-02','11:00:00',6.68),('8902','2013-05-02','11:05:00',6.76),('8902','2013-05-02','11:10:00',6.82),('8902','2013-05-02','11:15:00',6.87),('8902','2013-05-02','11:20:00',6.94),('8902','2013-05-02','11:25:00',7.12),('8902','2013-05-02','11:30:00',7.2),('8902','2013-05-02','11:35:00',7.21),('8902','2013-05-02','11:40:00',7.25),('8902','2013-05-02','11:45:00',7.25),('8902','2013-05-02','11:50:00',7.3),('8902','2013-05-02','11:55:00',7.37),('8902','2013-05-02','12:00:00',7.42),('8902','2013-05-02','12:05:00',7.45),('8902','2013-05-02','12:10:00',7.52),('8902','2013-05-02','12:15:00',7.55),('8902','2013-05-02','12:20:00',7.55),('8902','2013-05-02','12:25:00',7.56),('8902','2013-05-02','12:30:00',7.61),('8902','2013-05-02','12:35:00',7.57),('8902','2013-05-02','12:40:00',7.63),('8902','2013-05-02','12:45:00',7.63),('8902','2013-05-02','12:50:00',7.79),('8902','2013-05-02','12:55:00',7.75),('8902','2013-05-02','13:00:00',7.67),('8902','2013-05-02','13:05:00',7.66),('8902','2013-05-02','13:10:00',7.69),('8902','2013-05-02','13:15:00',7.71),('8902','2013-05-02','13:20:00',7.67),('8902','2013-05-02','13:25:00',7.72),('8902','2013-05-02','13:30:00',7.61),('8902','2013-05-02','13:35:00',7.49),('8902','2013-05-02','13:40:00',7.29),('8902','2013-05-02','13:45:00',7.25),('8902','2013-05-02','13:50:00',7.32),('8902','2013-05-02','13:55:00',7.37),('8902','2013-05-02','14:00:00',7.35),('8902','2013-05-02','14:05:00',7.09),('8902','2013-05-02','14:10:00',7.23),('8902','2013-05-02','14:15:00',6.97),('8902','2013-05-02','14:20:00',7.14),('8902','2013-05-02','14:25:00',7.19),('8902','2013-05-02','14:30:00',7.06),('8902','2013-05-02','14:35:00',7.19),('8902','2013-05-02','14:40:00',7.09),('8902','2013-05-02','14:45:00',7.02),('8902','2013-05-02','14:50:00',6.99),('8902','2013-05-02','14:55:00',7.03),('8902','2013-05-02','15:00:00',7.04),('8902','2013-05-02','15:05:00',6.98),('8902','2013-05-02','15:10:00',7.01),('8902','2013-05-02','15:15:00',6.88),('8902','2013-05-02','15:20:00',6.85),('8902','2013-05-02','15:25:00',6.78),('8902','2013-05-02','15:30:00',6.71),('8902','2013-05-02','15:35:00',6.65),('8902','2013-05-02','15:40:00',6.57),('8902','2013-05-02','15:45:00',6.49),('8902','2013-05-02','15:50:00',6.31),('8902','2013-05-02','15:55:00',6.24),('8902','2013-05-02','16:00:00',6.24),('8902','2013-05-02','16:05:00',6.16),('8902','2013-05-02','16:10:00',5.99),('8902','2013-05-02','16:15:00',5.87),('8902','2013-05-02','16:20:00',5.65),('8902','2013-05-02','16:25:00',5.43),('8902','2013-05-02','16:30:00',5.41),('8902','2013-05-02','16:35:00',5.38),('8902','2013-05-02','16:40:00',5.22),('8902','2013-05-02','16:45:00',4.96),('8902','2013-05-02','16:50:00',4.87),('8902','2013-05-02','16:55:00',4.74),('8902','2013-05-02','17:00:00',4.6),('8902','2013-05-02','17:05:00',4.42),('8902','2013-05-02','17:10:00',4.23),('8902','2013-05-02','17:15:00',4.05),('8902','2013-05-02','17:20:00',3.86),('8902','2013-05-02','17:25:00',3.65),('8902','2013-05-02','17:30:00',3.45),('8902','2013-05-02','17:35:00',3.3),('8902','2013-05-02','17:40:00',3.03),('8902','2013-05-02','17:45:00',2.85),('8902','2013-05-02','17:50:00',2.74),('8902','2013-05-02','17:55:00',2.59),('8902','2013-05-02','18:00:00',2.49),('8902','2013-05-02','18:05:00',2.32),('8902','2013-05-02','18:10:00',2.18),('8902','2013-05-02','18:15:00',2.02),('8902','2013-05-02','18:20:00',1.82),('8902','2013-05-02','18:25:00',1.67),('8902','2013-05-02','18:30:00',1.51),('8902','2013-05-02','18:35:00',1.36),('8902','2013-05-02','18:40:00',1.22),('8902','2013-05-02','18:45:00',1.08),('8902','2013-05-01','08:35:00',1.04),('8902','2013-05-01','08:40:00',1.49),('8902','2013-05-01','08:45:00',1.39),('8902','2013-05-01','08:50:00',1.47),('8902','2013-05-01','08:55:00',2.18),('8902','2013-05-01','09:00:00',3.45),('8902','2013-05-01','09:05:00',3.14),('8902','2013-05-01','09:10:00',1.72),('8902','2013-05-01','09:15:00',1.56),('8902','2013-05-01','09:20:00',1.78),('8902','2013-05-01','09:25:00',2.72),('8902','2013-05-01','09:30:00',3.01),('8902','2013-05-01','09:35:00',4.14),('8902','2013-05-01','09:40:00',2.67),('8902','2013-05-01','09:45:00',4.46),('8902','2013-05-01','09:50:00',2.4),('8902','2013-05-01','09:55:00',1.83),('8902','2013-05-01','10:00:00',1.98),('8902','2013-05-01','10:05:00',2.85),('8902','2013-05-01','10:10:00',2.74),('8902','2013-05-01','10:15:00',2.8),('8902','2013-05-01','10:20:00',2.85),('8902','2013-05-01','10:25:00',3.84),('8902','2013-05-01','10:30:00',6.16),('8902','2013-05-01','10:35:00',4.61),('8902','2013-05-01','10:40:00',6.68),('8902','2013-05-01','10:45:00',4.95),('8902','2013-05-01','10:50:00',5.96),('8902','2013-05-01','10:55:00',7.07),('8902','2013-05-01','11:00:00',7.3),('8902','2013-05-01','11:05:00',7.24),('8902','2013-05-01','11:10:00',5.31),('8902','2013-05-01','11:15:00',5.45),('8902','2013-05-01','11:20:00',5.2),('8902','2013-05-01','11:25:00',7.22),('8902','2013-05-01','11:30:00',7.28),('8902','2013-05-01','11:35:00',7.21),('8902','2013-05-01','11:40:00',7.12),('8902','2013-05-01','11:45:00',7.15),('8902','2013-05-01','11:50:00',7.16),('8902','2013-05-01','11:55:00',7.18),('8902','2013-05-01','12:00:00',7.22),('8902','2013-05-01','12:05:00',7.21),('8902','2013-05-01','12:10:00',7.2),('8902','2013-05-01','12:15:00',7.29),('8902','2013-05-01','12:20:00',7.31),('8902','2013-05-01','12:25:00',7.38),('8902','2013-05-01','12:30:00',7.5),('8902','2013-05-01','12:35:00',7.6),('8902','2013-05-01','12:40:00',7.73),('8902','2013-05-01','12:45:00',7.74),('8902','2013-05-01','12:50:00',7.78),('8902','2013-05-01','12:55:00',7.85),('8902','2013-05-01','13:00:00',7.91),('8902','2013-05-01','13:05:00',7.95),('8902','2013-05-01','13:10:00',8.03),('8902','2013-05-01','13:15:00',8.07),('8902','2013-05-01','13:20:00',8.07),('8902','2013-05-01','13:25:00',8.06),('8902','2013-05-01','13:30:00',8.07),('8902','2013-05-01','13:35:00',8.03),('8902','2013-05-01','13:40:00',8),('8902','2013-05-01','13:45:00',8.04),('8902','2013-05-01','13:50:00',8.05),('8902','2013-05-01','13:55:00',8.03),('8902','2013-05-01','14:00:00',7.94),('8902','2013-05-01','14:05:00',7.85),('8902','2013-05-01','14:10:00',7.81),('8902','2013-05-01','14:15:00',7.83),('8902','2013-05-01','14:20:00',7.72),('8902','2013-05-01','14:25:00',7.64),('8902','2013-05-01','14:30:00',7.6),('8902','2013-05-01','14:35:00',7.59),('8902','2013-05-01','14:40:00',7.57),('8902','2013-05-01','14:45:00',7.48),('8902','2013-05-01','14:50:00',7.4),('8902','2013-05-01','14:55:00',7.35),('8902','2013-05-01','15:00:00',7.3),('8902','2013-05-01','15:05:00',7.22),('8902','2013-05-01','15:10:00',6.31),('8902','2013-05-01','15:15:00',7.09),('8902','2013-05-01','15:20:00',7.03),('8902','2013-05-01','15:25:00',6.93),('8902','2013-05-01','15:30:00',6.77),('8902','2013-05-01','15:35:00',6.6),('8902','2013-05-01','15:40:00',6.52),('8902','2013-05-01','15:45:00',6.43),('8902','2013-05-01','15:50:00',6.37),('8902','2013-05-01','15:55:00',6.23),('8902','2013-05-01','16:00:00',6.07),('8902','2013-05-01','16:05:00',6.06),('8902','2013-05-01','16:10:00',5.99),('8902','2013-05-01','16:15:00',5.84),('8902','2013-05-01','16:20:00',5.72),('8902','2013-05-01','16:25:00',5.57),('8902','2013-05-01','16:30:00',5.4),('8902','2013-05-01','16:35:00',5.28),('8902','2013-05-01','16:40:00',5.15),('8902','2013-05-01','16:45:00',4.95),('8902','2013-05-01','16:50:00',4.86),('8902','2013-05-01','16:55:00',4.73),('8902','2013-05-01','17:00:00',4.58),('8902','2013-05-01','17:05:00',4.46),('8902','2013-05-01','17:10:00',4.27),('8902','2013-05-01','17:15:00',4.17),('8902','2013-05-01','17:20:00',4.02),('8902','2013-05-01','17:25:00',3.87),('8902','2013-05-01','17:30:00',3.68),('8902','2013-05-01','17:35:00',3.53),('8902','2013-05-01','17:40:00',3.34),('8902','2013-05-01','17:45:00',3.15),('8902','2013-05-01','17:50:00',3.01),('8902','2013-05-01','17:55:00',2.82),('8902','2013-05-01','18:00:00',2.65),('8902','2013-05-01','18:05:00',2.48),('8902','2013-05-01','18:10:00',2.32),('8902','2013-05-01','18:15:00',2.14),('8902','2013-05-01','18:20:00',1.94),('8902','2013-05-01','18:25:00',1.76),('8902','2013-05-01','18:30:00',1.62),('8902','2013-05-01','18:35:00',1.47),('8902','2013-05-01','18:40:00',1.31),('8902','2013-05-01','18:45:00',1.16),('8902','2013-05-01','18:50:00',1.01),('8902','2014-03-29','08:00:00',1.05),('8902','2014-03-29','08:05:00',1.18),('8902','2014-03-29','08:10:00',1.37),('8902','2014-03-29','08:15:00',1.55),('8902','2014-03-29','08:20:00',1.79),('8902','2014-03-29','08:25:00',2),('8902','2014-03-29','08:30:00',2.14),('8902','2014-03-29','08:35:00',2.28),('8902','2014-03-29','08:40:00',2.26),('8902','2014-03-29','08:45:00',2.2),('8902','2014-03-29','08:50:00',2.32),('8902','2014-03-29','08:55:00',2.46),('8902','2014-03-29','09:00:00',2.56),('8902','2014-03-29','09:05:00',2.62),('8902','2014-03-29','09:10:00',2.62),('8902','2014-03-29','09:15:00',2.52),('8902','2014-03-29','09:20:00',2.82),('8902','2014-03-29','09:25:00',3.05),('8902','2014-03-29','09:30:00',3.51),('8902','2014-03-29','09:35:00',3.99),('8902','2014-03-29','09:40:00',4.16),('8902','2014-03-29','09:45:00',4.3),('8902','2014-03-29','09:50:00',4.36),('8902','2014-03-29','09:55:00',4.3),('8902','2014-03-29','10:00:00',4.34),('8902','2014-03-29','10:05:00',5.01),('8902','2014-03-29','10:10:00',5.13),('8902','2014-03-29','10:15:00',5.03),('8902','2014-03-29','10:20:00',5.23),('8902','2014-03-29','10:25:00',5.37),('8902','2014-03-29','10:30:00',5.57),('8902','2014-03-29','10:35:00',5.73),('8902','2014-03-29','10:40:00',5.89),('8902','2014-03-29','10:45:00',5.9),('8902','2014-03-29','10:50:00',5.98),('8902','2014-03-29','10:55:00',6.12),('8902','2014-03-29','11:00:00',6.14),('8902','2014-03-29','11:05:00',5.85),('8902','2014-03-29','11:10:00',6.06),('8902','2014-03-29','11:15:00',6.02),('8902','2014-03-29','11:20:00',6.03),('8902','2014-03-29','11:25:00',6.19),('8902','2014-03-29','11:30:00',6.63),('8902','2014-03-29','11:35:00',6.53),('8902','2014-03-29','11:40:00',6.82),('8902','2014-03-29','11:45:00',7.05),('8902','2014-03-29','11:50:00',7.2),('8902','2014-03-29','11:55:00',7.38),('8902','2014-03-29','12:00:00',7.43),('8902','2014-03-29','12:05:00',7.67),('8902','2014-03-29','12:10:00',7.88),('8902','2014-03-29','12:15:00',7.88),('8902','2014-03-29','12:20:00',7.82),('8902','2014-03-29','12:25:00',7.85),('8902','2014-03-29','12:30:00',7.28),('8902','2014-03-29','12:35:00',7.28),('8902','2014-03-29','12:40:00',7.83),('8902','2014-03-29','12:45:00',7.58),('8902','2014-03-29','12:50:00',7.77),('8902','2014-03-29','12:55:00',7.83),('8902','2014-03-29','13:00:00',8.05),('8902','2014-03-29','13:05:00',8.06),('8902','2014-03-29','13:10:00',8.07),('8902','2014-03-29','13:15:00',8.07),('8902','2014-03-29','13:20:00',8.08),('8902','2014-03-29','13:25:00',8.1),('8902','2014-03-29','13:30:00',8.09),('8902','2014-03-29','13:35:00',8.17),('8902','2014-03-29','13:40:00',8.14),('8902','2014-03-29','13:45:00',8.16),('8902','2014-03-29','13:50:00',8.15),('8902','2014-03-29','13:55:00',7.96),('8902','2014-03-29','14:00:00',7.95),('8902','2014-03-29','14:05:00',8.03),('8902','2014-03-29','14:10:00',7.85),('8902','2014-03-29','14:15:00',7.84),('8902','2014-03-29','14:20:00',7.95),('8902','2014-03-29','14:25:00',8.06),('8902','2014-03-29','14:30:00',8.18),('8902','2014-03-29','14:35:00',8.05),('8902','2014-03-29','14:40:00',7.63),('8902','2014-03-29','14:45:00',7.04),('8902','2014-03-29','14:50:00',6.35),('8902','2014-03-29','14:55:00',5.33),('8902','2014-03-29','15:00:00',4.3),('8902','2014-03-29','15:05:00',3.44),('8902','2014-03-29','15:10:00',2.6),('8902','2014-03-29','15:15:00',2.31),('8902','2014-03-29','15:20:00',3.85),('8902','2014-03-29','15:25:00',6.22),('8902','2014-03-29','15:30:00',6.61),('8902','2014-03-29','15:35:00',6.52),('8902','2014-03-29','15:40:00',6.64),('8902','2014-03-29','15:45:00',6.55),('8902','2014-03-29','15:50:00',6.56),('8902','2014-03-29','15:55:00',6.39),('8902','2014-03-29','16:00:00',6.16),('8902','2014-03-29','16:05:00',5.65),('8902','2014-03-29','16:10:00',5.62),('8902','2014-03-29','16:15:00',5.46),('8902','2014-03-29','16:20:00',5.84),('8902','2014-03-29','16:25:00',5.75),('8902','2014-03-29','16:30:00',5.64),('8902','2014-03-29','16:35:00',5.65),('8902','2014-03-29','16:40:00',5.37),('8902','2014-03-29','16:45:00',4.74),('8902','2014-03-29','16:50:00',4.37),('8902','2014-03-29','16:55:00',3.6),('8902','2014-03-29','17:00:00',3.68),('8902','2014-03-29','17:05:00',4.11),('8902','2014-03-29','17:10:00',4.33),('8902','2014-03-29','17:15:00',4.38),('8902','2014-03-29','17:20:00',4.21),('8902','2014-03-29','17:25:00',3.79),('8902','2014-03-29','17:30:00',3.64),('8902','2014-03-29','17:35:00',3.47),('8902','2014-03-29','17:40:00',3.05),('8902','2014-03-29','17:45:00',3.07),('8902','2014-03-29','17:50:00',2.54),('8902','2014-03-29','17:55:00',2.02),('8902','2014-03-29','18:00:00',1.59),('8902','2014-03-29','18:05:00',1.49),('8902','2014-03-29','18:10:00',1.75),('8902','2014-03-29','18:15:00',1.33),('8902','2014-03-29','18:20:00',1.05),('8902','2013-04-30','07:35:00',1.08),('8902','2013-04-30','07:40:00',1.2),('8902','2013-04-30','07:45:00',1.33),('8902','2013-04-30','07:50:00',1.47),('8902','2013-04-30','07:55:00',1.59),('8902','2013-04-30','08:00:00',1.72),('8902','2013-04-30','08:05:00',1.84),('8902','2013-04-30','08:10:00',1.94),('8902','2013-04-30','08:15:00',2.1),('8902','2013-04-30','08:20:00',2.28),('8902','2013-04-30','08:25:00',2.46),('8902','2013-04-30','08:30:00',2.63),('8902','2013-04-30','08:35:00',2.79),('8902','2013-04-30','08:40:00',2.94),('8902','2013-04-30','08:45:00',3.07),('8902','2013-04-30','08:50:00',3.27),('8902','2013-04-30','08:55:00',3.43),('8902','2013-04-30','09:00:00',3.62),('8902','2013-04-30','09:05:00',3.76),('8902','2013-04-30','09:10:00',3.88),('8902','2013-04-30','09:15:00',4.01),('8902','2013-04-30','09:20:00',4.12),('8902','2013-04-30','09:25:00',4.22),('8902','2013-04-30','09:30:00',4.33),('8902','2013-04-30','09:35:00',4.4),('8902','2013-04-30','09:40:00',4.58),('8902','2013-04-30','09:45:00',4.7),('8902','2013-04-30','09:50:00',4.82),('8902','2013-04-30','09:55:00',4.94),('8902','2013-04-30','10:00:00',5.06),('8902','2013-04-30','10:05:00',5.12),('8902','2013-04-30','10:10:00',5.29),('8902','2013-04-30','10:15:00',5.46),('8902','2013-04-30','10:20:00',5.55),('8902','2013-04-30','10:25:00',5.65),('8902','2013-04-30','10:30:00',5.74),('8902','2013-04-30','10:35:00',5.8),('8902','2013-04-30','10:40:00',6.04),('8902','2013-04-30','10:45:00',6.36),('8902','2013-04-30','10:50:00',6.42),('8902','2013-04-30','10:55:00',6.5),('8902','2013-04-30','11:00:00',6.57),('8902','2013-04-30','11:05:00',6.63),('8902','2013-04-30','11:10:00',6.71),('8902','2013-04-30','11:15:00',6.35),('8902','2013-04-30','11:20:00',6.04),('8902','2013-04-30','11:25:00',5.96),('8902','2013-04-30','11:30:00',5.85),('8902','2013-04-30','11:35:00',6.2),('8902','2013-04-30','11:40:00',5.55),('8902','2013-04-30','11:45:00',5.28),('8902','2013-04-30','11:50:00',6.06),('8902','2013-04-30','11:55:00',7.26),('8902','2013-04-30','12:00:00',7.16),('8902','2013-04-30','12:05:00',7.09),('8902','2013-04-30','12:10:00',7.09),('8902','2013-04-30','12:15:00',7.11),('8902','2013-04-30','12:20:00',7.21),('8902','2013-04-30','12:25:00',7.25),('8902','2013-04-30','12:30:00',7.36),('8902','2013-04-30','12:35:00',7.49),('8902','2013-04-30','12:40:00',7.64),('8902','2013-04-30','12:45:00',6.86),('8902','2013-04-30','12:50:00',6.8),('8902','2013-04-30','12:55:00',2.79),('8902','2013-04-30','13:00:00',3.66),('8902','2013-04-30','13:05:00',3.35),('8902','2013-04-30','13:10:00',4.63),('8902','2013-04-30','13:15:00',8.38),('8902','2013-04-30','13:20:00',8.58),('8902','2013-04-30','13:25:00',7.27),('8902','2013-04-30','13:30:00',4.98),('8902','2013-04-30','13:35:00',5.52),('8902','2013-04-30','13:40:00',8.21),('8902','2013-04-30','13:45:00',8.2),('8902','2013-04-30','13:50:00',7.85),('8902','2013-04-30','13:55:00',7.66),('8902','2013-04-30','14:00:00',7.49),('8902','2013-04-30','14:05:00',7.25),('8902','2013-04-30','14:10:00',7.21),('8902','2013-04-30','14:15:00',6.16),('8902','2013-04-30','14:20:00',7.56),('8902','2013-04-30','14:25:00',7.6),('8902','2013-04-30','14:30:00',7.67),('8902','2013-04-30','14:35:00',7.45),('8902','2013-04-30','14:40:00',6.61),('8902','2013-04-30','14:45:00',7.05),('8902','2013-04-30','14:50:00',5.8),('8902','2013-04-30','14:55:00',5.49),('8902','2013-04-30','15:00:00',5.99),('8902','2013-04-30','15:05:00',6.46),('8902','2013-04-30','15:10:00',6.66),('8902','2013-04-30','15:15:00',6.49),('8902','2013-04-30','15:20:00',6.19),('8902','2013-04-30','15:25:00',6.54),('8902','2013-04-30','15:30:00',5.38),('8902','2013-04-30','15:35:00',4.62),('8902','2013-04-30','15:40:00',4.57),('8902','2013-04-30','15:45:00',4.5),('8902','2013-04-30','15:50:00',3.37),('8902','2013-04-30','15:55:00',3.18),('8902','2013-04-30','16:00:00',3.93),('8902','2013-04-30','16:05:00',3.83),('8902','2013-04-30','16:10:00',3.39),('8902','2013-04-30','16:15:00',3.08),('8902','2013-04-30','16:20:00',2.66),('8902','2013-04-30','16:25:00',2.09),('8902','2013-04-30','16:30:00',1.96),('8902','2013-04-30','16:35:00',2.06),('8902','2013-04-30','16:40:00',2.22),('8902','2013-04-30','16:45:00',2.07),('8902','2013-04-30','16:50:00',1.8),('8902','2013-04-30','16:55:00',1.64),('8902','2013-04-30','17:00:00',1.66),('8902','2013-04-30','17:05:00',1.68),('8902','2013-04-30','17:10:00',1.7),('8902','2013-04-30','17:15:00',1.69),('8902','2013-04-30','17:20:00',1.53),('8902','2013-04-30','17:25:00',1.29),('8902','2013-04-30','17:30:00',1.09),('8902','2013-04-30','17:35:00',1.01),('8902','2013-04-29','08:20:00',1.01),('8902','2013-04-29','08:25:00',1.11),('8902','2013-04-29','08:30:00',1.41),('8902','2013-04-29','08:35:00',1.63),('8902','2013-04-29','08:40:00',1.56),('8902','2013-04-29','08:45:00',1.62),('8902','2013-04-29','08:50:00',1.93),('8902','2013-04-29','08:55:00',2.62),('8902','2013-04-29','09:00:00',3.03),('8902','2013-04-29','09:05:00',2.74),('8902','2013-04-29','09:10:00',3.9),('8902','2013-04-29','09:15:00',4.49),('8902','2013-04-29','09:20:00',4.51),('8902','2013-04-29','09:25:00',4.82),('8902','2013-04-29','09:30:00',4.78),('8902','2013-04-29','09:35:00',3.98),('8902','2013-04-29','09:40:00',2.87),('8902','2013-04-29','09:45:00',3.53),('8902','2013-04-29','09:50:00',4.58),('8902','2013-04-29','09:55:00',5.05),('8902','2013-04-29','10:00:00',5.91),('8902','2013-04-29','10:05:00',5.86),('8902','2013-04-29','10:10:00',5.05),('8902','2013-04-29','10:15:00',4.6),('8902','2013-04-29','10:20:00',4.35),('8902','2013-04-29','10:25:00',4.1),('8902','2013-04-29','10:30:00',3.7),('8902','2013-04-29','10:35:00',3.59),('8902','2013-04-29','10:40:00',2.99),('8902','2013-04-29','10:45:00',2.42),('8902','2013-04-29','10:50:00',2.65),('8902','2013-04-29','10:55:00',2.8),('8902','2013-04-29','11:00:00',2.86),('8902','2013-04-29','11:05:00',3.21),('8902','2013-04-29','11:10:00',3.29),('8902','2013-04-29','11:15:00',3.46),('8902','2013-04-29','11:20:00',3.92),('8902','2013-04-29','11:25:00',3.63),('8902','2013-04-29','11:30:00',3.52),('8902','2013-04-29','11:35:00',3.67),('8902','2013-04-29','11:40:00',3.59),('8902','2013-04-29','11:45:00',3.13),('8902','2013-04-29','11:50:00',3.24),('8902','2013-04-29','11:55:00',3.31),('8902','2013-04-29','12:00:00',3.27),('8902','2013-04-29','12:05:00',3.3),('8902','2013-04-29','12:10:00',3.24),('8902','2013-04-29','12:15:00',3.01),('8902','2013-04-29','12:20:00',2.65),('8902','2013-04-29','12:25:00',2.44),('8902','2013-04-29','12:30:00',2.49),('8902','2013-04-29','12:35:00',4.41),('8902','2013-04-29','12:40:00',7.82),('8902','2013-04-29','12:45:00',8.49),('8902','2013-04-29','12:50:00',8.15),('8902','2013-04-29','12:55:00',7.06),('8902','2013-04-29','13:00:00',7.61),('8902','2013-04-29','13:05:00',7.51),('8902','2013-04-29','13:10:00',7.69),('8902','2013-04-29','13:15:00',7.62),('8902','2013-04-29','13:20:00',7.54),('8902','2013-04-29','13:25:00',7.53),('8902','2013-04-29','13:30:00',7.46),('8902','2013-04-29','13:35:00',7.47),('8902','2013-04-29','13:40:00',7.41),('8902','2013-04-29','13:45:00',7.36),('8902','2013-04-29','13:50:00',7.31),('8902','2013-04-29','13:55:00',7.27),('8902','2013-04-29','14:00:00',7.23),('8902','2013-04-29','14:05:00',7.17),('8902','2013-04-29','14:10:00',7.17),('8902','2013-04-29','14:15:00',7.15),('8902','2013-04-29','14:20:00',7.16),('8902','2013-04-29','14:25:00',7.13),('8902','2013-04-29','14:30:00',7.09),('8902','2013-04-29','14:35:00',7),('8902','2013-04-29','14:40:00',6.91),('8902','2013-04-29','14:45:00',6.8),('8902','2013-04-29','14:50:00',6.71),('8902','2013-04-29','14:55:00',6.61),('8902','2013-04-29','15:00:00',6.56),('8902','2013-04-29','15:05:00',6.5),('8902','2013-04-29','15:10:00',6.43),('8902','2013-04-29','15:15:00',6.35),('8902','2013-04-29','15:20:00',6.25),('8902','2013-04-29','15:25:00',6.16),('8902','2013-04-29','15:30:00',6.05),('8902','2013-04-29','15:35:00',6.02),('8902','2013-04-29','15:40:00',5.92),('8902','2013-04-29','15:45:00',5.81),('8902','2013-04-29','15:50:00',5.7),('8902','2013-04-29','15:55:00',5.56),('8902','2013-04-29','16:00:00',5.46),('8902','2013-04-29','16:05:00',5.35),('8902','2013-04-29','16:10:00',5.25),('8902','2013-04-29','16:15:00',5.17),('8902','2013-04-29','16:20:00',5.08),('8902','2013-04-29','16:25:00',4.91),('8902','2013-04-29','16:30:00',4.81),('8902','2013-04-29','16:35:00',4.59),('8902','2013-04-29','16:40:00',3.77),('8902','2013-04-29','16:45:00',3.96),('8902','2013-04-29','16:50:00',3.59),('8902','2013-04-29','16:55:00',4.07),('8902','2013-04-29','17:00:00',3.76),('8902','2013-04-29','17:05:00',3.76),('8902','2013-04-29','17:10:00',3.27),('8902','2013-04-29','17:15:00',1.71),('8902','2013-04-29','17:20:00',2.51),('8902','2013-04-29','17:25:00',3.07),('8902','2013-04-29','17:30:00',2.97),('8902','2013-04-29','17:35:00',2.89),('8902','2013-04-29','17:40:00',2.72),('8902','2013-04-29','17:45:00',2.55),('8902','2013-04-29','17:50:00',2.39),('8902','2013-04-29','17:55:00',2.2),('8902','2013-04-29','18:00:00',2.06),('8902','2013-04-29','18:05:00',1.91),('8902','2013-04-29','18:10:00',1.78),('8902','2013-04-29','18:15:00',1.63),('8902','2013-04-29','18:20:00',1.48),('8902','2013-04-29','18:25:00',1.34),('8902','2013-04-29','18:30:00',1.22),('8902','2013-04-29','18:35:00',1.1),('8902','2013-04-28','07:20:00',1.13),('8902','2013-04-28','07:25:00',1.27),('8902','2013-04-28','07:30:00',1.32),('8902','2013-04-28','07:35:00',1.3),('8902','2013-04-28','07:40:00',1.23),('8902','2013-04-28','07:45:00',1.37),('8902','2013-04-28','07:50:00',1.49),('8902','2013-04-28','07:55:00',1.72),('8902','2013-04-28','08:00:00',1.98),('8902','2013-04-28','08:05:00',2.11),('8902','2013-04-28','08:10:00',2.05),('8902','2013-04-28','08:15:00',2.13),('8902','2013-04-28','08:20:00',2.3),('8902','2013-04-28','08:25:00',2.61),('8902','2013-04-28','08:30:00',2.98),('8902','2013-04-28','08:35:00',3.36),('8902','2013-04-28','08:40:00',3.44),('8902','2013-04-28','08:45:00',3.34),('8902','2013-04-28','08:50:00',3.61),('8902','2013-04-28','08:55:00',3.66),('8902','2013-04-28','09:00:00',2.83),('8902','2013-04-28','09:05:00',3.91),('8902','2013-04-28','09:10:00',4.33),('8902','2013-04-28','09:15:00',4.59),('8902','2013-04-28','09:20:00',4.35),('8902','2013-04-28','09:25:00',4.27),('8902','2013-04-28','09:30:00',4.23),('8902','2013-04-28','09:35:00',4.56),('8902','2013-04-28','09:40:00',4.64),('8902','2013-04-28','09:45:00',4.84),('8902','2013-04-28','09:50:00',5.18),('8902','2013-04-28','09:55:00',4.83),('8902','2013-04-28','10:00:00',5.03),('8902','2013-04-28','10:05:00',4.96),('8902','2013-04-28','10:10:00',4.92),('8902','2013-04-28','10:15:00',4.25),('8902','2013-04-28','10:20:00',4.02),('8902','2013-04-28','10:25:00',4.95),('8902','2013-04-28','10:30:00',4.88),('8902','2013-04-28','10:35:00',5.89),('8902','2013-04-28','10:40:00',5.97),('8902','2013-04-28','10:45:00',6.1),('8902','2013-04-28','10:50:00',5.84),('8902','2013-04-28','10:55:00',5.47),('8902','2013-04-28','11:00:00',6.11),('8902','2013-04-28','11:05:00',5.91),('8902','2013-04-28','11:10:00',5.85),('8902','2013-04-28','11:15:00',5.39),('8902','2013-04-28','11:20:00',6.19),('8902','2013-04-28','11:25:00',6.46),('8902','2013-04-28','11:30:00',6.81),('8902','2013-04-28','11:35:00',6.52),('8902','2013-04-28','11:40:00',6.57),('8902','2013-04-28','11:45:00',6.49),('8902','2013-04-28','11:50:00',7.09),('8902','2013-04-28','11:55:00',7.02),('8902','2013-04-28','12:00:00',7.36),('8902','2013-04-28','12:05:00',7.36),('8902','2013-04-28','12:10:00',7.05),('8902','2013-04-28','12:15:00',7.07),('8902','2013-04-28','12:20:00',7.17),('8902','2013-04-28','12:25:00',7.14),('8902','2013-04-28','12:30:00',7.28),('8902','2013-04-28','12:35:00',7.4),('8902','2013-04-28','12:40:00',7.57),('8902','2013-04-28','12:45:00',7.62),('8902','2013-04-28','12:50:00',7.6),('8902','2013-04-28','12:55:00',7.34),('8902','2013-04-28','13:00:00',7.51),('8902','2013-04-28','13:05:00',7.44),('8902','2013-04-28','13:10:00',7.39),('8902','2013-04-28','13:15:00',6.91),('8902','2013-04-28','13:20:00',7.37),('8902','2013-04-28','13:25:00',7.81),('8902','2013-04-28','13:30:00',7.66),('8902','2013-04-28','13:35:00',7.63),('8902','2013-04-28','13:40:00',7.55),('8902','2013-04-28','13:45:00',7.46),('8902','2013-04-28','13:50:00',7.3),('8902','2013-04-28','13:55:00',7.7),('8902','2013-04-28','14:00:00',7.23),('8902','2013-04-28','14:05:00',7.43),('8902','2013-04-28','14:10:00',7.38),('8902','2013-04-28','14:15:00',7.54),('8902','2013-04-28','14:20:00',7.52),('8902','2013-04-28','14:25:00',7.37),('8902','2013-04-28','14:30:00',7.04),('8902','2013-04-28','14:35:00',6.84),('8902','2013-04-28','14:40:00',6.49),('8902','2013-04-28','14:45:00',7.05),('8902','2013-04-28','14:50:00',6.81),('8902','2013-04-28','14:55:00',7.05),('8902','2013-04-28','15:00:00',6.77),('8902','2013-04-28','15:05:00',7.15),('8902','2013-04-28','15:10:00',6.75),('8902','2013-04-28','15:15:00',6.2),('8902','2013-04-28','15:20:00',6.5),('8902','2013-04-28','15:25:00',6.83),('8902','2013-04-28','15:30:00',6.69),('8902','2013-04-28','15:35:00',5.96),('8902','2013-04-28','15:40:00',5.4),('8902','2013-04-28','15:45:00',5.17),('8902','2013-04-28','15:50:00',5.32),('8902','2013-04-28','15:55:00',5.68),('8902','2013-04-28','16:00:00',5.51),('8902','2013-04-28','16:05:00',5.94),('8902','2013-04-28','16:10:00',5.48),('8902','2013-04-28','16:15:00',6.46),('8902','2013-04-28','16:20:00',6.35),('8902','2013-04-28','16:25:00',4.84),('8902','2013-04-28','16:30:00',5.02),('8902','2013-04-28','16:35:00',5.11),('8902','2013-04-28','16:40:00',5.39),('8902','2013-04-28','16:45:00',5.19),('8902','2013-04-28','16:50:00',5.36),('8902','2013-04-28','16:55:00',5.63),('8902','2013-04-28','17:00:00',5.18),('8902','2013-04-28','17:05:00',4.47),('8902','2013-04-28','17:10:00',4.57),('8902','2013-04-28','17:15:00',4.07),('8902','2013-04-28','17:20:00',3.36),('8902','2013-04-28','17:25:00',3.22),('8902','2013-04-28','17:30:00',3.01),('8902','2013-04-28','17:35:00',2.63),('8902','2013-04-28','17:40:00',2.14),('8902','2013-04-28','17:45:00',2.07),('8902','2013-04-28','17:50:00',2.5),('8902','2013-04-28','17:55:00',2.83),('8902','2013-04-28','18:00:00',2.77),('8902','2013-04-28','18:05:00',3.04),('8902','2013-04-28','18:10:00',2.74),('8902','2013-04-28','18:15:00',2.61),('8902','2013-04-28','18:20:00',2.13),('8902','2013-04-28','18:25:00',2.02),('8902','2013-04-28','18:30:00',1.91),('8902','2013-04-28','18:35:00',1.38),('8902','2013-04-28','18:40:00',1.19),('8902','2013-04-27','07:35:00',1.04),('8902','2013-04-27','07:40:00',1.22),('8902','2013-04-27','07:45:00',1.38),('8902','2013-04-27','07:50:00',1.53),('8902','2013-04-27','07:55:00',1.67),('8902','2013-04-27','08:00:00',1.8),('8902','2013-04-27','08:05:00',1.99),('8902','2013-04-27','08:10:00',2.18),('8902','2013-04-27','08:15:00',2.35),('8902','2013-04-27','08:20:00',2.53),('8902','2013-04-27','08:25:00',2.72),('8902','2013-04-27','08:30:00',2.85),('8902','2013-04-27','08:35:00',3),('8902','2013-04-27','08:40:00',3.17),('8902','2013-04-27','08:45:00',3.34),('8902','2013-04-27','08:50:00',3.5),('8902','2013-04-27','08:55:00',3.64),('8902','2013-04-27','09:00:00',3.79),('8902','2013-04-27','09:05:00',3.95),('8902','2013-04-27','09:10:00',4.12),('8902','2013-04-27','09:15:00',4.28),('8902','2013-04-27','09:20:00',4.46),('8902','2013-04-27','09:25:00',4.59),('8902','2013-04-27','09:30:00',4.74),('8902','2013-04-27','09:35:00',4.9),('8902','2013-04-27','09:40:00',5.04),('8902','2013-04-27','09:45:00',5.2),('8902','2013-04-27','09:50:00',5.33),('8902','2013-04-27','09:55:00',5.46),('8902','2013-04-27','10:00:00',5.59),('8902','2013-04-27','10:05:00',5.64),('8902','2013-04-27','10:10:00',5.76),('8902','2013-04-27','10:15:00',5.73),('8902','2013-04-27','10:20:00',5.95),('8902','2013-04-27','10:25:00',6.2),('8902','2013-04-27','10:30:00',6.13),('8902','2013-04-27','10:35:00',6.31),('8902','2013-04-27','10:40:00',5.78),('8902','2013-04-27','10:45:00',6.57),('8902','2013-04-27','10:50:00',6.61),('8902','2013-04-27','10:55:00',6.66),('8902','2013-04-27','11:00:00',6.75),('8902','2013-04-27','11:05:00',6.84),('8902','2013-04-27','11:10:00',6.99),('8902','2013-04-27','11:15:00',7.02),('8902','2013-04-27','11:20:00',7.02),('8902','2013-04-27','11:25:00',7.15),('8902','2013-04-27','11:30:00',7.23),('8902','2013-04-27','11:35:00',7.04),('8902','2013-04-27','11:40:00',7.16),('8902','2013-04-27','11:45:00',6.84),('8902','2013-04-27','11:50:00',7),('8902','2013-04-27','11:55:00',7.25),('8902','2013-04-27','12:00:00',6.47),('8902','2013-04-27','12:05:00',6.41),('8902','2013-04-27','12:10:00',7.09),('8902','2013-04-27','12:15:00',7.29),('8902','2013-04-27','12:20:00',7.15),('8902','2013-04-27','12:25:00',6.46),('8902','2013-04-27','12:30:00',6.12),('8902','2013-04-27','12:35:00',5.32),('8902','2013-04-27','12:40:00',5.59),('8902','2013-04-27','12:45:00',7.33),('8902','2013-04-27','12:50:00',7.61),('8902','2013-04-27','12:55:00',7),('8902','2013-04-27','13:00:00',7.25),('8902','2013-04-27','13:05:00',7.89),('8902','2013-04-27','13:10:00',7.67),('8902','2013-04-27','13:15:00',6.98),('8902','2013-04-27','13:20:00',7.27),('8902','2013-04-27','13:25:00',7.09),('8902','2013-04-27','13:30:00',7.56),('8902','2013-04-27','13:35:00',7.59),('8902','2013-04-27','13:40:00',8.1),('8902','2013-04-27','13:45:00',6.52),('8902','2013-04-27','13:50:00',7.09),('8902','2013-04-27','13:55:00',7.9),('8902','2013-04-27','14:00:00',7.74),('8902','2013-04-27','14:05:00',7.64),('8902','2013-04-27','14:10:00',7.36),('8902','2013-04-27','14:15:00',7.31),('8902','2013-04-27','14:20:00',7.61),('8902','2013-04-27','14:25:00',7.46),('8902','2013-04-27','14:30:00',7.36),('8902','2013-04-27','14:35:00',7.4),('8902','2013-04-27','14:40:00',7.34),('8902','2013-04-27','14:45:00',7.24),('8902','2013-04-27','14:50:00',7.18),('8902','2013-04-27','14:55:00',7.11),('8902','2013-04-27','15:00:00',7.02),('8902','2013-04-27','15:05:00',6.99),('8902','2013-04-27','15:10:00',6.98),('8902','2013-04-27','15:15:00',6.92),('8902','2013-04-27','15:20:00',6.79),('8902','2013-04-27','15:25:00',6.69),('8902','2013-04-27','15:30:00',6.6),('8902','2013-04-27','15:35:00',6.53),('8902','2013-04-27','15:40:00',6.5),('8902','2013-04-27','15:45:00',6.41),('8902','2013-04-27','15:50:00',6.32),('8902','2013-04-27','15:55:00',6.19),('8902','2013-04-27','16:00:00',6.09),('8902','2013-04-27','16:05:00',6.01),('8902','2013-04-27','16:10:00',5.87),('8902','2013-04-27','16:15:00',5.74),('8902','2013-04-27','16:20:00',5.64),('8902','2013-04-27','16:25:00',5.47),('8902','2013-04-27','16:30:00',5.36),('8902','2013-04-27','16:35:00',5.24),('8902','2013-04-27','16:40:00',5.1),('8902','2013-04-27','16:45:00',4.9),('8902','2013-04-27','16:50:00',4.82),('8902','2013-04-27','16:55:00',4.66),('8902','2013-04-27','17:00:00',4.53),('8902','2013-04-27','17:05:00',4.22),('8902','2013-04-27','17:10:00',3.94),('8902','2013-04-27','17:15:00',4.13),('8902','2013-04-27','17:20:00',3.94),('8902','2013-04-27','17:25:00',3.82),('8902','2013-04-27','17:30:00',3.27),('8902','2013-04-27','17:35:00',3.23),('8902','2013-04-27','17:40:00',2.95),('8902','2013-04-27','17:45:00',3.03),('8902','2013-04-27','17:50:00',2.9),('8902','2013-04-27','17:55:00',2.5),('8902','2013-04-27','18:00:00',2.46),('8902','2013-04-27','18:05:00',2.29),('8902','2013-04-27','18:10:00',1.59),('8902','2013-04-27','18:15:00',1.51),('8902','2013-04-27','18:20:00',1.79),('8902','2013-04-27','18:25:00',1.7),('8902','2013-04-27','18:30:00',1.4),('8902','2013-04-27','18:35:00',1.25),('8902','2013-04-27','18:40:00',1.15),('8902','2013-04-26','11:50:00',1.12),('8902','2013-04-26','11:55:00',1.18),('8902','2013-04-26','12:00:00',1.27),('8902','2013-04-26','12:05:00',1.25),('8902','2013-04-26','12:10:00',1.17),('8902','2013-04-26','12:15:00',1.1),('8902','2013-04-26','12:20:00',1),('8902','2013-04-26','12:30:00',1.08),('8902','2013-04-26','12:35:00',1.2),('8902','2013-04-26','12:40:00',1.5),('8902','2013-04-26','12:45:00',1.63),('8902','2013-04-26','12:50:00',1.85),('8902','2013-04-26','12:55:00',2.43),('8902','2013-04-26','13:00:00',2.67),('8902','2013-04-26','13:05:00',2.05),('8902','2013-04-26','13:10:00',2.06),('8902','2013-04-26','13:15:00',2.6),('8902','2013-04-26','13:20:00',2.64),('8902','2013-04-26','13:25:00',2.1),('8902','2013-04-26','13:30:00',2.22),('8902','2013-04-26','13:35:00',2.7),('8902','2013-04-26','13:40:00',3.59),('8902','2013-04-26','13:45:00',2.18),('8902','2013-04-26','13:50:00',2),('8902','2013-04-26','13:55:00',1.59),('8902','2013-04-26','14:00:00',1.23),('8902','2013-04-26','14:05:00',1.48),('8902','2013-04-26','14:10:00',1.08),('8902','2013-04-26','14:15:00',1.01),('8902','2013-04-26','14:20:00',1.22),('8902','2013-04-26','14:25:00',2.54),('8902','2013-04-26','14:30:00',4.12),('8902','2013-04-26','14:35:00',3.44),('8902','2013-04-26','14:40:00',2.37),('8902','2013-04-26','14:45:00',2.36),('8902','2013-04-26','14:50:00',1.42),('8902','2013-04-26','14:55:00',1.72),('8902','2013-04-26','15:00:00',2.13),('8902','2013-04-26','15:05:00',3.49),('8902','2013-04-26','15:10:00',2.63),('8902','2013-04-26','15:15:00',2.31),('8902','2013-04-26','15:20:00',1.33),('8902','2013-04-26','15:25:00',1.24),('8902','2013-04-26','15:50:00',1.33),('8902','2013-04-26','16:30:00',1.01),('8902','2013-04-26','16:35:00',1.21),('8902','2013-04-26','16:40:00',1.64),('8902','2013-04-26','16:45:00',2.35),('8902','2013-04-26','16:50:00',3.2),('8902','2013-04-26','16:55:00',4.39),('8902','2013-04-26','17:00:00',5.4),('8902','2013-04-26','17:05:00',3.17),('8902','2013-04-26','17:10:00',1.46),('8902','2013-04-26','17:20:00',1.83),('8902','2013-04-26','17:25:00',1.27),('8902','2013-04-26','17:35:00',1.28),('8902','2013-04-26','17:40:00',2.2),('8902','2013-04-26','17:45:00',2.01),('8902','2013-04-26','17:50:00',1.19),('8902','2013-04-26','18:00:00',1.01),('8902','2013-04-26','18:05:00',1.17),('8902','2013-04-26','18:15:00',1.05),('8902','2013-04-25','07:30:00',1),('8902','2013-04-25','07:50:00',1.06),('8902','2013-04-25','07:55:00',1.2),('8902','2013-04-25','08:00:00',1.32),('8902','2013-04-25','08:05:00',1.51),('8902','2013-04-25','08:10:00',1.94),('8902','2013-04-25','08:15:00',2.14),('8902','2013-04-25','08:20:00',2.26),('8902','2013-04-25','08:25:00',2.38),('8902','2013-04-25','08:30:00',2.5),('8902','2013-04-25','08:35:00',2.7),('8902','2013-04-25','08:40:00',2.85),('8902','2013-04-25','08:45:00',3.03),('8902','2013-04-25','08:50:00',3.16),('8902','2013-04-25','08:55:00',2.52),('8902','2013-04-25','09:00:00',2.49),('8902','2013-04-25','09:05:00',3.49),('8902','2013-04-25','09:10:00',3.32),('8902','2013-04-25','09:15:00',2.08),('8902','2013-04-25','09:20:00',2.05),('8902','2013-04-25','09:25:00',2.28),('8902','2013-04-25','09:30:00',2.69),('8902','2013-04-25','09:35:00',3.39),('8902','2013-04-25','09:40:00',3.89),('8902','2013-04-25','09:45:00',4.86),('8902','2013-04-25','09:50:00',4.54),('8902','2013-04-25','09:55:00',3.21),('8902','2013-04-25','10:00:00',3.06),('8902','2013-04-25','10:05:00',4.48),('8902','2013-04-25','10:10:00',5.46),('8902','2013-04-25','10:15:00',5.5),('8902','2013-04-25','10:20:00',5.55),('8902','2013-04-25','10:25:00',4.39),('8902','2013-04-25','10:30:00',6.1),('8902','2013-04-25','10:35:00',6.3),('8902','2013-04-25','10:40:00',5.89),('8902','2013-04-25','10:45:00',5.24),('8902','2013-04-25','10:50:00',3.62),('8902','2013-04-25','10:55:00',5.02),('8902','2013-04-25','11:00:00',5.43),('8902','2013-04-25','11:05:00',6.35),('8902','2013-04-25','11:10:00',5.55),('8902','2013-04-25','11:15:00',6.8),('8902','2013-04-25','11:20:00',5.18),('8902','2013-04-25','11:25:00',5.74),('8902','2013-04-25','11:30:00',5.75),('8902','2013-04-25','11:35:00',6.44),('8902','2013-04-25','11:40:00',6.25),('8902','2013-04-25','11:45:00',6.11),('8902','2013-04-25','11:50:00',5.01),('8902','2013-04-25','11:55:00',4.63),('8902','2013-04-25','12:00:00',5.54),('8902','2013-04-25','12:05:00',4.61),('8902','2013-04-25','12:10:00',4.24),('8902','2013-04-25','12:15:00',5.01),('8902','2013-04-25','12:20:00',4.6),('8902','2013-04-25','12:25:00',3.61),('8902','2013-04-25','12:30:00',3.31),('8902','2013-04-25','12:35:00',4.58),('8902','2013-04-25','12:40:00',6.11),('8902','2013-04-25','12:45:00',6.72),('8902','2013-04-25','12:50:00',3.91),('8902','2013-04-25','12:55:00',3.65),('8902','2013-04-25','13:00:00',2.66),('8902','2013-04-25','13:05:00',2.53),('8902','2013-04-25','13:10:00',3.05),('8902','2013-04-25','13:15:00',4.13),('8902','2013-04-25','13:20:00',3.09),('8902','2013-04-25','13:25:00',3.74),('8902','2013-04-25','13:30:00',4.84),('8902','2013-04-25','13:35:00',4.22),('8902','2013-04-25','13:40:00',5.24),('8902','2013-04-25','13:45:00',4.34),('8902','2013-04-25','13:50:00',5.16),('8902','2013-04-25','13:55:00',5.14),('8902','2013-04-25','14:00:00',5.5),('8902','2013-04-25','14:05:00',6.46),('8902','2013-04-25','14:10:00',7.37),('8902','2013-04-25','14:15:00',6.73),('8902','2013-04-25','14:20:00',6.5),('8902','2013-04-25','14:25:00',6.11),('8902','2013-04-25','14:30:00',7.57),('8902','2013-04-25','14:35:00',5.82),('8902','2013-04-25','14:40:00',3.33),('8902','2013-04-25','14:45:00',3.64),('8902','2013-04-25','14:50:00',7.33),('8902','2013-04-25','14:55:00',7.86),('8902','2013-04-25','15:00:00',7.43),('8902','2013-04-25','15:05:00',5.43),('8902','2013-04-25','15:10:00',2.48),('8902','2013-04-25','15:15:00',3.01),('8902','2013-04-25','15:20:00',2.74),('8902','2013-04-25','15:25:00',2.97),('8902','2013-04-25','15:30:00',3.89),('8902','2013-04-25','15:35:00',3.55),('8902','2013-04-25','15:40:00',3.71),('8902','2013-04-25','15:45:00',3.81),('8902','2013-04-25','15:50:00',3.52),('8902','2013-04-25','15:55:00',2.09),('8902','2013-04-25','16:00:00',1.07),('8902','2013-04-25','16:35:00',1.09),('8902','2013-04-25','16:40:00',1.06),('8902','2013-04-24','07:40:00',1.06),('8902','2013-04-24','07:45:00',1.21),('8902','2013-04-24','07:50:00',1.25),('8902','2013-04-24','07:55:00',1.26),('8902','2013-04-24','08:00:00',1.42),('8902','2013-04-24','08:05:00',1.74),('8902','2013-04-24','08:10:00',1.88),('8902','2013-04-24','08:15:00',2.3),('8902','2013-04-24','08:20:00',2),('8902','2013-04-24','08:25:00',1.71),('8902','2013-04-24','08:30:00',1.77),('8902','2013-04-24','08:35:00',1.86),('8902','2013-04-24','08:40:00',1.96),('8902','2013-04-24','08:45:00',2.31),('8902','2013-04-24','08:50:00',3.51),('8902','2013-04-24','08:55:00',4.12),('8902','2013-04-24','09:00:00',3.59),('8902','2013-04-24','09:05:00',2.64),('8902','2013-04-24','09:10:00',2.39),('8902','2013-04-24','09:15:00',2.26),('8902','2013-04-24','09:20:00',2.29),('8902','2013-04-24','09:25:00',2.79),('8902','2013-04-24','09:30:00',2.5),('8902','2013-04-24','09:35:00',2.74),('8902','2013-04-24','09:40:00',3.76),('8902','2013-04-24','09:45:00',4.62),('8902','2013-04-24','09:50:00',5.43),('8902','2013-04-24','09:55:00',5.46),('8902','2013-04-24','10:00:00',5.56),('8902','2013-04-24','10:05:00',5.35),('8902','2013-04-24','10:10:00',4.83),('8902','2013-04-24','10:15:00',4.92),('8902','2013-04-24','10:20:00',5.75),('8902','2013-04-24','10:25:00',5.92),('8902','2013-04-24','10:30:00',6.19),('8902','2013-04-24','10:35:00',6.26),('8902','2013-04-24','10:40:00',6.3),('8902','2013-04-24','10:45:00',6.06),('8902','2013-04-24','10:50:00',6.12),('8902','2013-04-24','10:55:00',6.59),('8902','2013-04-24','11:00:00',6.68),('8902','2013-04-24','11:05:00',6.76),('8902','2013-04-24','11:10:00',6.82),('8902','2013-04-24','11:15:00',6.89),('8902','2013-04-24','11:20:00',6.96),('8902','2013-04-24','11:25:00',7.06),('8902','2013-04-24','11:30:00',7.14),('8902','2013-04-24','11:35:00',7.24),('8902','2013-04-24','11:40:00',7.31),('8902','2013-04-24','11:45:00',7.39),('8902','2013-04-24','11:50:00',7.45),('8902','2013-04-24','11:55:00',7.33),('8902','2013-04-24','12:00:00',7.24),('8902','2013-04-24','12:05:00',7.25),('8902','2013-04-24','12:10:00',7.39),('8902','2013-04-24','12:15:00',7.5),('8902','2013-04-24','12:20:00',7.52),('8902','2013-04-24','12:25:00',7.54),('8902','2013-04-24','12:30:00',7.58),('8902','2013-04-24','12:35:00',7.63),('8902','2013-04-24','12:40:00',7.61),('8902','2013-04-24','12:45:00',7.65),('8902','2013-04-24','12:50:00',7.62),('8902','2013-04-24','12:55:00',7.73),('8902','2013-04-24','13:00:00',7.81),('8902','2013-04-24','13:05:00',7.95),('8902','2013-04-24','13:10:00',7.92),('8902','2013-04-24','13:15:00',7.16),('8902','2013-04-24','13:20:00',6.84),('8902','2013-04-24','13:25:00',6.5),('8902','2013-04-24','13:30:00',5.34),('8902','2013-04-24','13:35:00',5.38),('8902','2013-04-24','13:40:00',4.47),('8902','2013-04-24','13:45:00',4.1),('8902','2013-04-24','13:50:00',3.82),('8902','2013-04-24','13:55:00',4.04),('8902','2013-04-24','14:00:00',4.26),('8902','2013-04-24','14:05:00',3.9),('8902','2013-04-24','14:10:00',4.32),('8902','2013-04-24','14:15:00',4.44),('8902','2013-04-24','14:20:00',4.55),('8902','2013-04-24','14:25:00',4.59),('8902','2013-04-24','14:30:00',5.43),('8902','2013-04-24','14:35:00',6.47),('8902','2013-04-24','14:40:00',6.64),('8902','2013-04-24','14:45:00',6.52),('8902','2013-04-24','14:50:00',6.03),('8902','2013-04-24','14:55:00',6.15),('8902','2013-04-24','15:00:00',6.08),('8902','2013-04-24','15:05:00',5.5),('8902','2013-04-24','15:10:00',5.49),('8902','2013-04-24','15:15:00',6.14),('8902','2013-04-24','15:20:00',6.44),('8902','2013-04-24','15:25:00',6.79),('8902','2013-04-24','15:30:00',6.67),('8902','2013-04-24','15:35:00',6.25),('8902','2013-04-24','15:40:00',5.95),('8902','2013-04-24','15:45:00',5.44),('8902','2013-04-24','15:50:00',5.16),('8902','2013-04-24','15:55:00',5.04),('8902','2013-04-24','16:00:00',5.13),('8902','2013-04-24','16:05:00',4.16),('8902','2013-04-24','16:10:00',4.41),('8902','2013-04-24','16:15:00',4.15),('8902','2013-04-24','16:20:00',4.24),('8902','2013-04-24','16:25:00',3.79),('8902','2013-04-24','16:30:00',3.54),('8902','2013-04-24','16:35:00',4.5),('8902','2013-04-24','16:40:00',3.97),('8902','2013-04-24','16:45:00',3.74),('8902','2013-04-24','16:50:00',3.33),('8902','2013-04-24','16:55:00',3.69),('8902','2013-04-24','17:00:00',3.36),('8902','2013-04-24','17:05:00',4.24),('8902','2013-04-24','17:10:00',4.53),('8902','2013-04-24','17:15:00',4.2),('8902','2013-04-24','17:20:00',4.05),('8902','2013-04-24','17:25:00',3.45),('8902','2013-04-24','17:30:00',2.63),('8902','2013-04-24','17:35:00',2.51),('8902','2013-04-24','17:40:00',2.64),('8902','2013-04-24','17:45:00',2.13),('8902','2013-04-24','17:50:00',1.82),('8902','2013-04-24','17:55:00',1.57),('8902','2013-04-24','18:00:00',1.52),('8902','2013-04-24','18:05:00',1.42),('8902','2013-04-24','18:10:00',1.32),('8902','2013-04-24','18:15:00',1.2),('8902','2013-04-24','18:20:00',1.08),('8902','2013-04-23','07:45:00',1.18),('8902','2013-04-23','07:50:00',1.35),('8902','2013-04-23','07:55:00',1.51),('8902','2013-04-23','08:00:00',1.64),('8902','2013-04-23','08:05:00',1.74),('8902','2013-04-23','08:10:00',2),('8902','2013-04-23','08:15:00',2.31),('8902','2013-04-23','08:20:00',2.47),('8902','2013-04-23','08:25:00',2.7),('8902','2013-04-23','08:30:00',2.74),('8902','2013-04-23','08:35:00',2.65),('8902','2013-04-23','08:40:00',2.8),('8902','2013-04-23','08:45:00',2.91),('8902','2013-04-23','08:50:00',3.08),('8902','2013-04-23','08:55:00',3.24),('8902','2013-04-23','09:00:00',3.63),('8902','2013-04-23','09:05:00',4),('8902','2013-04-23','09:10:00',3.79),('8902','2013-04-23','09:15:00',4.05),('8902','2013-04-23','09:20:00',3.66),('8902','2013-04-23','09:25:00',4.37),('8902','2013-04-23','09:30:00',5.35),('8902','2013-04-23','09:35:00',4.89),('8902','2013-04-23','09:40:00',4.62),('8902','2013-04-23','09:45:00',4.46),('8902','2013-04-23','09:50:00',4.78),('8902','2013-04-23','09:55:00',5.47),('8902','2013-04-23','10:00:00',5.72),('8902','2013-04-23','10:05:00',5.88),('8902','2013-04-23','10:10:00',5.97),('8902','2013-04-23','10:15:00',5.99),('8902','2013-04-23','10:20:00',5.91),('8902','2013-04-23','10:25:00',5.86),('8902','2013-04-23','10:30:00',5.83),('8902','2013-04-23','10:35:00',5.86),('8902','2013-04-23','10:40:00',6.47),('8902','2013-04-23','10:45:00',6.63),('8902','2013-04-23','10:50:00',6.69),('8902','2013-04-23','10:55:00',6.9),('8902','2013-04-23','11:00:00',6.98),('8902','2013-04-23','11:05:00',6.79),('8902','2013-04-23','11:10:00',7.28),('8902','2013-04-23','11:15:00',7.48),('8902','2013-04-23','11:20:00',7.63),('8902','2013-04-23','11:25:00',7.66),('8902','2013-04-23','11:30:00',7.49),('8902','2013-04-23','11:35:00',6.6),('8902','2013-04-23','11:40:00',4.73),('8902','2013-04-23','11:45:00',5.57),('8902','2013-04-23','11:50:00',3.86),('8902','2013-04-23','11:55:00',5.44),('8902','2013-04-23','12:00:00',6.77),('8902','2013-04-23','12:05:00',4.3),('8902','2013-04-23','12:10:00',4.99),('8902','2013-04-23','12:15:00',7.32),('8902','2013-04-23','12:20:00',8.53),('8902','2013-04-23','12:25:00',7.46),('8902','2013-04-23','12:30:00',7.22),('8902','2013-04-23','12:35:00',7.39),('8902','2013-04-23','12:40:00',6.96),('8902','2013-04-23','12:45:00',7.17),('8902','2013-04-23','12:50:00',7.73),('8902','2013-04-23','12:55:00',7.51),('8902','2013-04-23','13:00:00',7.36),('8902','2013-04-23','13:05:00',6.35),('8902','2013-04-23','13:10:00',8.29),('8902','2013-04-23','13:15:00',7.69),('8902','2013-04-23','13:20:00',7.37),('8902','2013-04-23','13:25:00',7.52),('8902','2013-04-23','13:30:00',7.2),('8902','2013-04-23','13:35:00',7.29),('8902','2013-04-23','13:40:00',8.13),('8902','2013-04-23','13:45:00',7.19),('8902','2013-04-23','13:50:00',4.88),('8902','2013-04-23','13:55:00',7.8),('8902','2013-04-23','14:00:00',7.9),('8902','2013-04-23','14:05:00',5.52),('8902','2013-04-23','14:10:00',5.27),('8902','2013-04-23','14:15:00',7.91),('8902','2013-04-23','14:20:00',7.1),('8902','2013-04-23','14:25:00',7.36),('8902','2013-04-23','14:30:00',6.97),('8902','2013-04-23','14:35:00',6.12),('8902','2013-04-23','14:40:00',5.91),('8902','2013-04-23','14:45:00',5.68),('8902','2013-04-23','14:50:00',5.1),('8902','2013-04-23','14:55:00',4.5),('8902','2013-04-23','15:00:00',4.96),('8902','2013-04-23','15:05:00',4.51),('8902','2013-04-23','15:10:00',4.26),('8902','2013-04-23','15:15:00',4.5),('8902','2013-04-23','15:20:00',4.7),('8902','2013-04-23','15:25:00',4.04),('8902','2013-04-23','15:30:00',3.36),('8902','2013-04-23','15:35:00',3.27),('8902','2013-04-23','15:40:00',3.2),('8902','2013-04-23','15:45:00',3.23),('8902','2013-04-23','15:50:00',3.29),('8902','2013-04-23','15:55:00',4.04),('8902','2013-04-23','16:00:00',5.26),('8902','2013-04-23','16:05:00',5.41),('8902','2013-04-23','16:10:00',5.39),('8902','2013-04-23','16:15:00',4.93),('8902','2013-04-23','16:20:00',6.43),('8902','2013-04-23','16:25:00',4.94),('8902','2013-04-23','16:30:00',4.25),('8902','2013-04-23','16:35:00',3.46),('8902','2013-04-23','16:40:00',4.87),('8902','2013-04-23','16:45:00',4.97),('8902','2013-04-23','16:50:00',4.34),('8902','2013-04-23','16:55:00',5.29),('8902','2013-04-23','17:00:00',5.41),('8902','2013-04-23','17:05:00',5.02),('8902','2013-04-23','17:10:00',4.79),('8902','2013-04-23','17:15:00',3.7),('8902','2013-04-23','17:20:00',3.2),('8902','2013-04-23','17:25:00',3.24),('8902','2013-04-23','17:30:00',1.83),('8902','2013-04-23','17:35:00',1.66),('8902','2013-04-23','17:40:00',1.3),('8902','2013-04-23','17:45:00',1.68),('8902','2013-04-23','17:50:00',2.03),('8902','2013-04-23','17:55:00',2.7),('8902','2013-04-23','18:00:00',2.16),('8902','2013-04-23','18:05:00',2.09),('8902','2013-04-23','18:10:00',1.88),('8902','2013-04-23','18:15:00',1.17),('8902','2013-04-23','18:20:00',1.71),('8902','2013-04-23','18:25:00',1.53),('8902','2013-04-23','18:30:00',1.09),('8902','2013-04-22','07:40:00',1.12),('8902','2013-04-22','07:45:00',1.31),('8902','2013-04-22','07:50:00',1.48),('8902','2013-04-22','07:55:00',1.66),('8902','2013-04-22','08:00:00',1.83),('8902','2013-04-22','08:05:00',2.01),('8902','2013-04-22','08:10:00',2.19),('8902','2013-04-22','08:15:00',2.38),('8902','2013-04-22','08:20:00',2.57),('8902','2013-04-22','08:25:00',2.74),('8902','2013-04-22','08:30:00',2.92),('8902','2013-04-22','08:35:00',3.11),('8902','2013-04-22','08:40:00',3.28),('8902','2013-04-22','08:45:00',3.44),('8902','2013-04-22','08:50:00',3.63),('8902','2013-04-22','08:55:00',3.8),('8902','2013-04-22','09:00:00',3.97),('8902','2013-04-22','09:05:00',4.15),('8902','2013-04-22','09:10:00',4.34),('8902','2013-04-22','09:15:00',4.52),('8902','2013-04-22','09:20:00',4.68),('8902','2013-04-22','09:25:00',4.83),('8902','2013-04-22','09:30:00',4.97),('8902','2013-04-22','09:35:00',5.15),('8902','2013-04-22','09:40:00',4.85),('8902','2013-04-22','09:45:00',4.73),('8902','2013-04-22','09:50:00',5.72),('8902','2013-04-22','09:55:00',5.79),('8902','2013-04-22','10:00:00',5.85),('8902','2013-04-22','10:05:00',5.94),('8902','2013-04-22','10:10:00',6.07),('8902','2013-04-22','10:15:00',6.19),('8902','2013-04-22','10:20:00',6.34),('8902','2013-04-22','10:25:00',6.41),('8902','2013-04-22','10:30:00',6.52),('8902','2013-04-22','10:35:00',6.64),('8902','2013-04-22','10:40:00',6.76),('8902','2013-04-22','10:45:00',6.71),('8902','2013-04-22','10:50:00',6.78),('8902','2013-04-22','10:55:00',6.98),('8902','2013-04-22','11:00:00',7.08),('8902','2013-04-22','11:05:00',7.13),('8902','2013-04-22','11:10:00',7.19),('8902','2013-04-22','11:15:00',7.23),('8902','2013-04-22','11:20:00',7.33),('8902','2013-04-22','11:25:00',7.44),('8902','2013-04-22','11:30:00',7.52),('8902','2013-04-22','11:35:00',7.52),('8902','2013-04-22','11:40:00',7.56),('8902','2013-04-22','11:45:00',7.63),('8902','2013-04-22','11:50:00',7.68),('8902','2013-04-22','11:55:00',7.72),('8902','2013-04-22','12:00:00',7.72),('8902','2013-04-22','12:05:00',7.63),('8902','2013-04-22','12:10:00',7.79),('8902','2013-04-22','12:15:00',7.78),('8902','2013-04-22','12:20:00',7.83),('8902','2013-04-22','12:25:00',7.78),('8902','2013-04-22','12:30:00',3.35),('8902','2013-04-22','12:35:00',6.79),('8902','2013-04-22','12:40:00',4.5),('8902','2013-04-22','12:45:00',3.7),('8902','2013-04-22','12:50:00',6.59),('8902','2013-04-22','12:55:00',3.6),('8902','2013-04-22','13:00:00',7.08),('8902','2013-04-22','13:05:00',4.53),('8902','2013-04-22','13:10:00',2.78),('8902','2013-04-22','13:15:00',8.74),('8902','2013-04-22','13:20:00',8.13),('8902','2013-04-22','13:25:00',8.74),('8902','2013-04-22','13:30:00',8.33),('8902','2013-04-22','13:35:00',8.51),('8902','2013-04-22','13:40:00',8.4),('8902','2013-04-22','13:45:00',5.92),('8902','2013-04-22','13:50:00',7.45),('8902','2013-04-22','13:55:00',7.77),('8902','2013-04-22','14:00:00',4.04),('8902','2013-04-22','14:05:00',8.89),('8902','2013-04-22','14:10:00',5.81),('8902','2013-04-22','14:15:00',7.63),('8902','2013-04-22','14:20:00',7.51),('8902','2013-04-22','14:25:00',6.95),('8902','2013-04-22','14:30:00',7.95),('8902','2013-04-22','14:35:00',8.02),('8902','2013-04-22','14:40:00',7.93),('8902','2013-04-22','14:45:00',6.38),('8902','2013-04-22','14:50:00',4.03),('8902','2013-04-22','14:55:00',4.5),('8902','2013-04-22','15:00:00',4.33),('8902','2013-04-22','15:05:00',4.7),('8902','2013-04-22','15:10:00',5.65),('8902','2013-04-22','15:15:00',5.76),('8902','2013-04-22','15:20:00',5.24),('8902','2013-04-22','15:25:00',4.84),('8902','2013-04-22','15:30:00',4.69),('8902','2013-04-22','15:35:00',4.56),('8902','2013-04-22','15:40:00',4.06),('8902','2013-04-22','15:45:00',4.19),('8902','2013-04-22','15:50:00',3.55),('8902','2013-04-22','15:55:00',3.05),('8902','2013-04-22','16:00:00',3.28),('8902','2013-04-22','16:05:00',3.24),('8902','2013-04-22','16:10:00',3.09),('8902','2013-04-22','16:15:00',2.86),('8902','2013-04-22','16:20:00',2.34),('8902','2013-04-22','16:25:00',2.33),('8902','2013-04-22','16:30:00',2.1),('8902','2013-04-22','16:35:00',2.32),('8902','2013-04-22','16:40:00',2.28),('8902','2013-04-22','16:45:00',2.37),('8902','2013-04-22','16:50:00',1.99),('8902','2013-04-22','16:55:00',2.17),('8902','2013-04-22','17:00:00',2),('8902','2013-04-22','17:05:00',2.11),('8902','2013-04-22','17:10:00',2.66),('8902','2013-04-22','17:15:00',4.29),('8902','2013-04-22','17:20:00',4.29),('8902','2013-04-22','17:25:00',3.58),('8902','2013-04-22','17:30:00',2.95),('8902','2013-04-22','17:35:00',2.66),('8902','2013-04-22','17:40:00',2.74),('8902','2013-04-22','17:45:00',2.93),('8902','2013-04-22','17:50:00',2.34),('8902','2013-04-22','17:55:00',1.43),('8902','2013-04-22','18:00:00',1.67),('8902','2013-04-22','18:05:00',1.43),('8902','2013-04-22','18:10:00',1.01),('8902','2013-04-21','08:45:00',1.08),('8902','2013-04-21','09:00:00',1.2),('8902','2013-04-21','09:05:00',1.24),('8902','2013-04-21','09:10:00',1.33),('8902','2013-04-21','09:15:00',1.25),('8902','2013-04-21','09:20:00',1.26),('8902','2013-04-21','09:25:00',1.46),('8902','2013-04-21','09:30:00',2.05),('8902','2013-04-21','09:35:00',1.9),('8902','2013-04-21','09:40:00',1.45),('8902','2013-04-21','09:45:00',1.06),('8902','2013-04-21','10:35:00',4.07),('8902','2013-04-21','10:40:00',7.07),('8902','2013-04-21','10:45:00',8.97),('8902','2013-04-21','10:50:00',4.31),('8902','2013-04-21','10:55:00',4.1),('8902','2013-04-21','11:00:00',3.76),('8902','2013-04-21','11:05:00',3.58),('8902','2013-04-21','11:10:00',4.23),('8902','2013-04-21','11:15:00',2.72),('8902','2013-04-21','11:20:00',2.72),('8902','2013-04-21','11:25:00',3.51),('8902','2013-04-21','11:30:00',5.68),('8902','2013-04-21','11:35:00',6.69),('8902','2013-04-21','11:40:00',7.04),('8902','2013-04-21','11:45:00',3.4),('8902','2013-04-21','11:50:00',3.32),('8902','2013-04-21','11:55:00',7.94),('8902','2013-04-21','12:00:00',5.48),('8902','2013-04-21','12:05:00',6.13),('8902','2013-04-21','12:10:00',8.95),('8902','2013-04-21','12:15:00',6.64),('8902','2013-04-21','12:20:00',7.74),('8902','2013-04-21','12:25:00',4.48),('8902','2013-04-21','12:30:00',5.47),('8902','2013-04-21','12:35:00',5.75),('8902','2013-04-21','12:40:00',8.5),('8902','2013-04-21','12:45:00',8.2),('8902','2013-04-21','12:50:00',8.68),('8902','2013-04-21','12:55:00',8.75),('8902','2013-04-21','13:00:00',8.74),('8902','2013-04-21','13:05:00',8.97),('8902','2013-04-21','13:10:00',9.27),('8902','2013-04-21','13:15:00',8.75),('8902','2013-04-21','13:20:00',7.89),('8902','2013-04-21','13:25:00',4.52),('8902','2013-04-21','13:30:00',5.78),('8902','2013-04-21','13:35:00',5.02),('8902','2013-04-21','13:40:00',5.44),('8902','2013-04-21','13:45:00',8.44),('8902','2013-04-21','13:50:00',2.13),('8902','2013-04-21','13:55:00',3.34),('8902','2013-04-21','14:00:00',2.33),('8902','2013-04-21','14:05:00',2.62),('8902','2013-04-21','14:10:00',2.37),('8902','2013-04-21','14:15:00',2.08),('8902','2013-04-21','14:20:00',8.57),('8902','2013-04-21','14:25:00',7.92),('8902','2013-04-21','14:30:00',9.26),('8902','2013-04-21','14:35:00',7.08),('8902','2013-04-21','14:40:00',9.03),('8902','2013-04-21','14:45:00',8.77),('8902','2013-04-21','14:50:00',8.88),('8902','2013-04-21','14:55:00',7.9),('8902','2013-04-21','15:00:00',6.5),('8902','2013-04-21','15:05:00',8.96),('8902','2013-04-21','15:10:00',4.07),('8902','2013-04-21','15:15:00',1.64),('8902','2013-04-21','15:20:00',1.78),('8902','2013-04-21','15:25:00',3.7),('8902','2013-04-21','15:30:00',4.31),('8902','2013-04-21','15:35:00',2.04),('8902','2013-04-21','15:40:00',4.45),('8902','2013-04-21','15:45:00',6.6),('8902','2013-04-21','15:50:00',4.95),('8902','2013-04-21','15:55:00',2.48),('8902','2013-04-21','16:00:00',1.56),('8902','2013-04-21','16:05:00',1.44),('8902','2013-04-21','16:10:00',1.38),('8902','2013-04-21','16:15:00',1.43),('8902','2013-04-21','16:20:00',1.29),('8902','2013-04-21','16:35:00',1.28),('8902','2013-04-21','16:40:00',1.95),('8902','2013-04-21','16:45:00',2.97),('8902','2013-04-21','16:50:00',1.52),('8902','2013-04-21','17:25:00',1.03),('8902','2013-04-21','17:30:00',1.61),('8902','2013-04-21','17:35:00',1.78),('8902','2013-04-21','17:40:00',1.28),('8902','2013-04-21','18:10:00',1.24),('8902','2013-04-21','18:20:00',1.18),('8902','2013-04-21','18:25:00',1.22),('8902','2013-04-21','18:50:00',1.09),('8902','2014-03-28','07:10:00',1.14),('8902','2014-03-28','07:15:00',1.33),('8902','2014-03-28','07:20:00',1.49),('8902','2014-03-28','07:25:00',1.65),('8902','2014-03-28','07:30:00',1.82),('8902','2014-03-28','07:35:00',1.98),('8902','2014-03-28','07:40:00',2.15),('8902','2014-03-28','07:45:00',2.35),('8902','2014-03-28','07:50:00',2.54),('8902','2014-03-28','07:55:00',2.7),('8902','2014-03-28','08:00:00',2.89),('8902','2014-03-28','08:05:00',3.08),('8902','2014-03-28','08:10:00',3.29),('8902','2014-03-28','08:15:00',3.45),('8902','2014-03-28','08:20:00',3.65),('8902','2014-03-28','08:25:00',3.84),('8902','2014-03-28','08:30:00',4),('8902','2014-03-28','08:35:00',4.19),('8902','2014-03-28','08:40:00',4.34),('8902','2014-03-28','08:45:00',4.52),('8902','2014-03-28','08:50:00',4.66),('8902','2014-03-28','08:55:00',4.74),('8902','2014-03-28','09:00:00',4.91),('8902','2014-03-28','09:05:00',5.06),('8902','2014-03-28','09:10:00',5.22),('8902','2014-03-28','09:15:00',5.37),('8902','2014-03-28','09:20:00',5.52),('8902','2014-03-28','09:25:00',5.66),('8902','2014-03-28','09:30:00',5.76),('8902','2014-03-28','09:35:00',5.92),('8902','2014-03-28','09:40:00',6.06),('8902','2014-03-28','09:45:00',6.18),('8902','2014-03-28','09:50:00',6.33),('8902','2014-03-28','09:55:00',6.52),('8902','2014-03-28','10:00:00',6.62),('8902','2014-03-28','10:05:00',6.72),('8902','2014-03-28','10:10:00',6.83),('8902','2014-03-28','10:15:00',6.92),('8902','2014-03-28','10:20:00',7.04),('8902','2014-03-28','10:25:00',7.11),('8902','2014-03-28','10:30:00',7.14),('8902','2014-03-28','10:35:00',7.24),('8902','2014-03-28','10:40:00',7.26),('8902','2014-03-28','10:45:00',7.38),('8902','2014-03-28','10:50:00',7.47),('8902','2014-03-28','10:55:00',7.57),('8902','2014-03-28','11:00:00',7.61),('8902','2014-03-28','11:05:00',7.64),('8902','2014-03-28','11:10:00',7.71),('8902','2014-03-28','11:15:00',7.79),('8902','2014-03-28','11:20:00',7.78),('8902','2014-03-28','11:25:00',7.8),('8902','2014-03-28','11:30:00',7.77),('8902','2014-03-28','11:35:00',7.8),('8902','2014-03-28','11:40:00',7.68),('8902','2014-03-28','11:45:00',7.99),('8902','2014-03-28','11:50:00',7.92),('8902','2014-03-28','11:55:00',7.88),('8902','2014-03-28','12:00:00',7.89),('8902','2014-03-28','12:05:00',7.9),('8902','2014-03-28','12:10:00',7.93),('8902','2014-03-28','12:15:00',7.99),('8902','2014-03-28','12:20:00',8.07),('8902','2014-03-28','12:25:00',8.07),('8902','2014-03-28','12:30:00',8.1),('8902','2014-03-28','12:35:00',8.06),('8902','2014-03-28','12:40:00',7.96),('8902','2014-03-28','12:45:00',8.01),('8902','2014-03-28','12:50:00',7.99),('8902','2014-03-28','12:55:00',8.01),('8902','2014-03-28','13:00:00',8),('8902','2014-03-28','13:05:00',7.96),('8902','2014-03-28','13:10:00',7.91),('8902','2014-03-28','13:15:00',7.83),('8902','2014-03-28','13:20:00',7.82),('8902','2014-03-28','13:25:00',7.67),('8902','2014-03-28','13:30:00',7.6),('8902','2014-03-28','13:35:00',7.53),('8902','2014-03-28','13:40:00',7.4),('8902','2014-03-28','13:45:00',7.29),('8902','2014-03-28','13:50:00',7.3),('8902','2014-03-28','13:55:00',7.23),('8902','2014-03-28','14:00:00',7.16),('8902','2014-03-28','14:05:00',7.14),('8902','2014-03-28','14:10:00',7.08),('8902','2014-03-28','14:15:00',6.94),('8902','2014-03-28','14:20:00',6.43),('8902','2014-03-28','14:25:00',6.83),('8902','2014-03-28','14:30:00',6.6),('8902','2014-03-28','14:35:00',6.42),('8902','2014-03-28','14:40:00',6.44),('8902','2014-03-28','14:45:00',6.27),('8902','2014-03-28','14:50:00',6.19),('8902','2014-03-28','14:55:00',6.33),('8902','2014-03-28','15:00:00',6.15),('8902','2014-03-28','15:05:00',6.01),('8902','2014-03-28','15:10:00',5.63),('8902','2014-03-28','15:15:00',5.72),('8902','2014-03-28','15:20:00',5.66),('8902','2014-03-28','15:25:00',5.42),('8902','2014-03-28','15:30:00',5.17),('8902','2014-03-28','15:35:00',4.95),('8902','2014-03-28','15:40:00',4.9),('8902','2014-03-28','15:45:00',4.76),('8902','2014-03-28','15:50:00',4.55),('8902','2014-03-28','15:55:00',4.49),('8902','2014-03-28','16:00:00',4.33),('8902','2014-03-28','16:05:00',4.1),('8902','2014-03-28','16:10:00',3.93),('8902','2014-03-28','16:15:00',3.8),('8902','2014-03-28','16:20:00',3.46),('8902','2014-03-28','16:25:00',3.38),('8902','2014-03-28','16:30:00',3.21),('8902','2014-03-28','16:35:00',2.88),('8902','2014-03-28','16:40:00',2.51),('8902','2014-03-28','16:45:00',1.99),('8902','2014-03-28','16:50:00',2.19),('8902','2014-03-28','16:55:00',2.24),('8902','2014-03-28','17:00:00',2.08),('8902','2014-03-28','17:05:00',1.87),('8902','2014-03-28','17:10:00',1.71),('8902','2014-03-28','17:15:00',1.52),('8902','2014-03-28','17:20:00',1.31),('8902','2014-03-28','17:25:00',1.13),('8902','2013-04-20','07:55:00',1.3),('8902','2013-04-20','08:00:00',1.39),('8902','2013-04-20','08:05:00',1.62),('8902','2013-04-20','08:10:00',1.65),('8902','2013-04-20','08:15:00',2.02),('8902','2013-04-20','08:20:00',1.76),('8902','2013-04-20','08:25:00',1.96),('8902','2013-04-20','08:30:00',1.73),('8902','2013-04-20','08:35:00',2.2),('8902','2013-04-20','08:40:00',2.35),('8902','2013-04-20','08:45:00',2.68),('8902','2013-04-20','08:50:00',2.93),('8902','2013-04-20','08:55:00',3.29),('8902','2013-04-20','09:00:00',2.5),('8902','2013-04-20','09:05:00',2.89),('8902','2013-04-20','09:10:00',4.25),('8902','2013-04-20','09:15:00',4.61),('8902','2013-04-20','09:20:00',2.97),('8902','2013-04-20','09:25:00',2.97),('8902','2013-04-20','09:30:00',5.26),('8902','2013-04-20','09:35:00',5.42),('8902','2013-04-20','09:40:00',5.38),('8902','2013-04-20','09:45:00',5.86),('8902','2013-04-20','09:50:00',6.46),('8902','2013-04-20','09:55:00',5.63),('8902','2013-04-20','10:00:00',5.45),('8902','2013-04-20','10:05:00',4.8),('8902','2013-04-20','10:10:00',3.67),('8902','2013-04-20','10:15:00',3.33),('8902','2013-04-20','10:20:00',5.13),('8902','2013-04-20','10:25:00',6.12),('8902','2013-04-20','10:30:00',5.79),('8902','2013-04-20','10:35:00',4.57),('8902','2013-04-20','10:40:00',6),('8902','2013-04-20','10:45:00',5.32),('8902','2013-04-20','10:50:00',6.98),('8902','2013-04-20','10:55:00',6.48),('8902','2013-04-20','11:00:00',7.02),('8902','2013-04-20','11:05:00',6.87),('8902','2013-04-20','11:10:00',8.24),('8902','2013-04-20','11:15:00',5.66),('8902','2013-04-20','11:20:00',6.02),('8902','2013-04-20','11:25:00',6.17),('8902','2013-04-20','11:30:00',5.57),('8902','2013-04-20','11:35:00',6.03),('8902','2013-04-20','11:40:00',7.2),('8902','2013-04-20','11:45:00',7.12),('8902','2013-04-20','11:50:00',6.5),('8902','2013-04-20','11:55:00',6.17),('8902','2013-04-20','12:00:00',4.72),('8902','2013-04-20','12:05:00',4.6),('8902','2013-04-20','12:10:00',4.47),('8902','2013-04-20','12:15:00',4.19),('8902','2013-04-20','12:20:00',3.88),('8902','2013-04-20','12:25:00',3.72),('8902','2013-04-20','12:30:00',4.08),('8902','2013-04-20','12:35:00',4.16),('8902','2013-04-20','12:40:00',4.23),('8902','2013-04-20','12:45:00',4.23),('8902','2013-04-20','12:50:00',3.91),('8902','2013-04-20','12:55:00',3.86),('8902','2013-04-20','13:00:00',4.39),('8902','2013-04-20','13:05:00',5.06),('8902','2013-04-20','13:10:00',5.15),('8902','2013-04-20','13:15:00',4.91),('8902','2013-04-20','13:20:00',4.56),('8902','2013-04-20','13:25:00',4.32),('8902','2013-04-20','13:30:00',6.7),('8902','2013-04-20','13:35:00',7.31),('8902','2013-04-20','13:40:00',5.71),('8902','2013-04-20','13:45:00',5.87),('8902','2013-04-20','13:50:00',4.67),('8902','2013-04-20','13:55:00',8.64),('8902','2013-04-20','14:00:00',8.86),('8902','2013-04-20','14:05:00',7.87),('8902','2013-04-20','14:10:00',8.45),('8902','2013-04-20','14:15:00',7.47),('8902','2013-04-20','14:20:00',9.39),('8902','2013-04-20','14:25:00',7.92),('8902','2013-04-20','14:30:00',7.62),('8902','2013-04-20','14:35:00',7.51),('8902','2013-04-20','14:40:00',8.69),('8902','2013-04-20','14:45:00',7.38),('8902','2013-04-20','14:50:00',4.41),('8902','2013-04-20','14:55:00',4.33),('8902','2013-04-20','15:00:00',6.38),('8902','2013-04-20','15:05:00',8.64),('8902','2013-04-20','15:10:00',8.34),('8902','2013-04-20','15:15:00',6.73),('8902','2013-04-20','15:20:00',4.63),('8902','2013-04-20','15:25:00',3.75),('8902','2013-04-20','15:30:00',3.25),('8902','2013-04-20','15:35:00',2.71),('8902','2013-04-20','15:40:00',2.83),('8902','2013-04-20','15:45:00',2.36),('8902','2013-04-20','15:50:00',2.03),('8902','2013-04-20','15:55:00',1.85),('8902','2013-04-20','16:00:00',1.64),('8902','2013-04-20','16:05:00',1.45),('8902','2013-04-20','16:10:00',1.37),('8902','2013-04-20','16:15:00',1.44),('8902','2013-04-20','16:20:00',1.18),('8902','2013-04-20','16:35:00',1.14),('8902','2013-04-20','16:40:00',1.12),('8902','2013-04-20','16:55:00',1.38),('8902','2013-04-20','17:00:00',1.71),('8902','2013-04-20','17:05:00',1.74),('8902','2013-04-20','17:10:00',1.47),('8902','2013-04-20','17:15:00',1.44),('8902','2013-04-20','17:20:00',1.26),('8902','2013-04-20','17:25:00',1.12),('8902','2013-04-20','17:45:00',1.09),('8902','2013-04-19','10:15:00',1),('8902','2013-04-19','10:20:00',1.04),('8902','2013-04-19','10:25:00',1.04),('8902','2013-04-19','10:30:00',1.15),('8902','2013-04-19','10:35:00',1.45),('8902','2013-04-19','10:40:00',2.35),('8902','2013-04-19','10:45:00',3.43),('8902','2013-04-19','10:50:00',4.5),('8902','2013-04-19','10:55:00',4.04),('8902','2013-04-19','11:00:00',4.67),('8902','2013-04-19','11:05:00',2.39),('8902','2013-04-19','11:10:00',4.29),('8902','2013-04-19','11:15:00',8.52),('8902','2013-04-19','11:20:00',4.46),('8902','2013-04-19','11:25:00',5.47),('8902','2013-04-19','11:30:00',8.35),('8902','2013-04-19','11:35:00',6.13),('8902','2013-04-19','11:40:00',4.59),('8902','2013-04-19','11:45:00',5.14),('8902','2013-04-19','11:50:00',2.95),('8902','2013-04-19','11:55:00',7.96),('8902','2013-04-19','12:00:00',8.31),('8902','2013-04-19','12:05:00',2.69),('8902','2013-04-19','12:10:00',7.62),('8902','2013-04-19','14:40:00',7.81),('8902','2013-04-19','14:45:00',7.87),('8902','2013-04-19','14:50:00',7.9),('8902','2013-04-19','14:55:00',7.89),('8902','2013-04-19','15:00:00',7.8),('8902','2013-04-19','15:05:00',7.65),('8902','2013-04-19','15:10:00',4.51),('8902','2013-04-19','15:15:00',5.88),('8902','2013-04-19','15:20:00',5.38),('8902','2013-04-19','15:25:00',6.83),('8902','2013-04-19','15:30:00',4.34),('8902','2013-04-19','15:35:00',1.83),('8902','2013-04-19','15:40:00',1.56),('8902','2013-04-19','15:45:00',1.56),('8902','2013-04-19','15:50:00',1.5),('8902','2013-04-19','15:55:00',1.42),('8902','2013-04-19','16:00:00',1.54),('8902','2013-04-19','16:05:00',1.94),('8902','2013-04-19','16:10:00',2.67),('8902','2013-04-19','16:15:00',4.12),('8902','2013-04-19','16:20:00',4.13),('8902','2013-04-19','16:25:00',5.1),('8902','2013-04-19','16:30:00',5.76),('8902','2013-04-19','16:35:00',5.37),('8902','2013-04-19','16:40:00',5.89),('8902','2013-04-19','16:45:00',6.01),('8902','2013-04-19','16:50:00',5.42),('8902','2013-04-19','16:55:00',5.27),('8902','2013-04-19','17:00:00',4.99),('8902','2013-04-19','17:05:00',4.77),('8902','2013-04-19','17:10:00',4.64),('8902','2013-04-19','17:15:00',4.28),('8902','2013-04-19','17:20:00',3.93),('8902','2013-04-19','17:25:00',3.79),('8902','2013-04-19','17:30:00',3.96),('8902','2013-04-19','17:35:00',4.2),('8902','2013-04-19','17:40:00',3.82),('8902','2013-04-19','17:45:00',1.65),('8902','2013-04-19','17:50:00',1.79),('8902','2013-04-19','17:55:00',3.39),('8902','2013-04-19','18:00:00',2.8),('8902','2013-04-19','18:05:00',2.79),('8902','2013-04-19','18:10:00',2.8),('8902','2013-04-19','18:15:00',2.31),('8902','2013-04-19','18:20:00',1.64),('8902','2013-04-18','14:25:00',7.27),('8902','2013-04-18','14:30:00',7.35),('8902','2013-04-18','14:35:00',7.1),('8902','2013-04-18','14:40:00',7.11),('8902','2013-04-18','14:45:00',7.13),('8902','2013-04-18','14:50:00',7.15),('8902','2013-04-18','14:55:00',7.06),('8902','2013-04-18','15:00:00',7.05),('8902','2013-04-18','15:05:00',6.91),('8902','2013-04-18','15:10:00',6.78),('8902','2013-04-18','15:15:00',6.79),('8902','2013-04-18','15:20:00',6.66),('8902','2013-04-18','15:25:00',6.62),('8902','2013-04-18','15:30:00',6.56),('8902','2013-04-18','15:35:00',6.49),('8902','2013-04-18','15:40:00',6.41),('8902','2013-04-18','15:45:00',6.34),('8902','2013-04-18','15:50:00',6.31),('8902','2013-04-18','15:55:00',6.2),('8902','2013-04-18','16:00:00',6.09),('8902','2013-04-18','16:05:00',6.01),('8902','2013-04-18','16:10:00',5.84),('8902','2013-04-18','16:15:00',5.72),('8902','2013-04-18','16:20:00',5.6),('8902','2013-04-18','16:25:00',5.41),('8902','2013-04-18','16:30:00',5.31),('8902','2013-04-18','16:35:00',5.17),('8902','2013-04-18','16:40:00',5.03),('8902','2013-04-18','16:45:00',4.77),('8902','2013-04-18','16:50:00',4.69),('8902','2013-04-18','16:55:00',4.56),('8902','2013-04-18','17:00:00',4.38),('8902','2013-04-18','17:05:00',4.18),('8902','2013-04-18','17:10:00',3.98),('8902','2013-04-18','17:15:00',3.83),('8902','2013-04-18','17:20:00',3.68),('8902','2013-04-18','17:25:00',3.5),('8902','2013-04-18','17:30:00',3.33),('8902','2013-04-18','17:35:00',3.15),('8902','2013-04-18','17:40:00',2.95),('8902','2013-04-18','17:45:00',2.79),('8902','2013-04-18','17:50:00',2.56),('8902','2013-04-18','17:55:00',2.4),('8902','2013-04-18','18:00:00',2.28),('8902','2013-04-18','18:05:00',2.08),('8902','2013-04-18','18:10:00',1.91),('8902','2013-04-18','18:15:00',1.74),('8902','2013-04-18','18:20:00',1.57),('8902','2013-04-18','18:25:00',1.45),('8902','2013-04-18','18:30:00',1.3),('8902','2013-04-18','18:35:00',1.17),('8902','2013-04-18','18:40:00',1.01),('8902','2013-04-17','09:45:00',4.65),('8902','2013-04-17','09:50:00',4.2),('8902','2013-04-17','09:55:00',4.4),('8902','2013-04-17','10:00:00',5.25),('8902','2013-04-17','10:05:00',5.63),('8902','2013-04-17','10:10:00',5.88),('8902','2013-04-17','10:15:00',6.04),('8902','2013-04-17','10:20:00',6.14),('8902','2013-04-17','10:25:00',6.06),('8902','2013-04-17','10:30:00',6.26),('8902','2013-04-17','10:35:00',6.36),('8902','2013-04-17','10:40:00',6.47),('8902','2013-04-17','10:45:00',6.57),('8902','2013-04-17','10:50:00',6.66),('8902','2013-04-17','10:55:00',6.73),('8902','2013-04-17','11:00:00',6.84),('8902','2013-04-17','11:05:00',6.93),('8902','2013-04-17','11:10:00',6.95),('8902','2013-04-17','11:15:00',7.08),('8902','2013-04-17','11:20:00',7.15),('8902','2013-04-17','11:25:00',7.18),('8902','2013-04-17','11:30:00',7.26),('8902','2013-04-17','11:35:00',7.33),('8902','2013-04-17','11:40:00',7.33),('8902','2013-04-17','11:45:00',7.33),('8902','2013-04-17','11:50:00',7.35),('8902','2013-04-17','11:55:00',7.49),('8902','2013-04-17','12:00:00',7.46),('8902','2013-04-17','12:05:00',7.61),('8902','2013-04-17','12:10:00',7.67),('8902','2013-04-17','12:15:00',7.73),('8902','2013-04-17','12:20:00',7.81),('8902','2013-04-17','12:25:00',7.86),('8902','2013-04-17','12:30:00',7.85),('8902','2013-04-17','12:35:00',7.92),('8902','2013-04-17','12:40:00',7.91),('8902','2013-04-17','12:45:00',7.93),('8902','2013-04-17','12:50:00',7.99),('8902','2013-04-17','12:55:00',7.96),('8902','2013-04-17','13:00:00',7.97),('8902','2013-04-17','13:05:00',8),('8902','2013-04-17','13:10:00',8.02),('8902','2013-04-17','13:15:00',8.02),('8902','2013-04-17','13:20:00',7.98),('8902','2013-04-17','13:25:00',8.02),('8902','2013-04-17','13:30:00',8.06),('8902','2013-04-17','13:35:00',8.02),('8902','2013-04-17','13:40:00',8.02),('8902','2013-04-17','13:45:00',8),('8902','2013-04-17','13:50:00',7.98),('8902','2013-04-17','13:55:00',8.01),('8902','2013-04-17','14:00:00',7.97),('8902','2013-04-17','14:05:00',7.9),('8902','2013-04-17','14:10:00',7.92),('8902','2013-04-17','14:15:00',7.91),('8902','2013-04-17','14:20:00',7.89),('8902','2013-04-17','14:25:00',7.83),('8902','2013-04-17','14:30:00',7.78),('8902','2013-04-17','14:35:00',7.77),('8902','2013-04-17','14:40:00',7.71),('8902','2013-04-17','14:45:00',7.61),('8902','2013-04-17','14:50:00',7.53),('8902','2013-04-17','14:55:00',7.5),('8902','2013-04-17','15:00:00',7.47),('8902','2013-04-17','15:05:00',7.42),('8902','2013-04-17','15:10:00',7.29),('8902','2013-04-17','15:15:00',7.22),('8902','2013-04-17','15:20:00',7.13),('8902','2013-04-17','15:25:00',7.02),('8902','2013-04-17','15:30:00',6.91),('8902','2013-04-17','15:35:00',6.88),('8902','2013-04-17','15:40:00',6.81),('8902','2013-04-17','15:45:00',6.73),('8902','2013-04-17','15:50:00',6.65),('8902','2013-04-17','15:55:00',6.54),('8902','2013-04-17','16:00:00',6.39),('8902','2013-04-17','16:05:00',6.29),('8902','2013-04-17','16:10:00',6.13),('8902','2013-04-17','16:15:00',6.01),('8902','2013-04-17','16:20:00',5.86),('8902','2013-04-17','16:25:00',5.61),('8902','2013-04-17','16:30:00',5.54),('8902','2013-04-17','16:35:00',5.42),('8902','2013-04-17','16:40:00',5.24),('8902','2013-04-17','16:45:00',5.09),('8902','2013-04-17','16:50:00',5),('8902','2013-04-17','16:55:00',4.87),('8902','2013-04-17','17:00:00',4.67),('8902','2013-04-17','17:05:00',4.43),('8902','2013-04-17','17:10:00',4.28),('8902','2013-04-17','17:15:00',4.18),('8902','2013-04-17','17:20:00',4.01),('8902','2013-04-17','17:25:00',3.82),('8902','2013-04-17','17:30:00',3.64),('8902','2013-04-17','17:35:00',3.46),('8902','2013-04-17','17:40:00',3.22),('8902','2013-04-17','17:45:00',3.08),('8902','2013-04-17','17:50:00',2.93),('8902','2013-04-17','17:55:00',2.73),('8902','2013-04-17','18:00:00',2.55),('8902','2013-04-17','18:05:00',2.25),('8902','2013-04-17','18:10:00',2.13),('8902','2013-04-17','18:15:00',1.94),('8902','2013-04-17','18:20:00',1.72),('8902','2013-04-17','18:25:00',1.54),('8902','2013-04-17','18:30:00',1.35),('8902','2013-04-17','18:35:00',1.18),('8902','2013-04-17','18:40:00',1.01),('8902','2013-04-16','07:50:00',1.19),('8902','2013-04-16','07:55:00',1.37),('8902','2013-04-16','08:00:00',1.55),('8902','2013-04-16','08:05:00',1.73),('8902','2013-04-16','08:10:00',1.92),('8902','2013-04-16','08:15:00',2.1),('8902','2013-04-16','08:20:00',2.29),('8902','2013-04-16','08:25:00',2.48),('8902','2013-04-16','08:30:00',2.66),('8902','2013-04-16','08:35:00',2.84),('8902','2013-04-16','08:40:00',3.03),('8902','2013-04-16','08:45:00',3.21),('8902','2013-04-16','08:50:00',3.38),('8902','2013-04-16','08:55:00',3.55),('8902','2013-04-16','09:00:00',3.73),('8902','2013-04-16','09:05:00',3.9),('8902','2013-04-16','09:10:00',4.08),('8902','2013-04-16','09:15:00',4.26),('8902','2013-04-16','09:20:00',4.43),('8902','2013-04-16','09:25:00',4.6),('8902','2013-04-16','09:30:00',4.72),('8902','2013-04-16','09:35:00',4.9),('8902','2013-04-16','09:40:00',5.07),('8902','2013-04-16','09:45:00',5.22),('8902','2013-04-16','09:50:00',5.35),('8902','2013-04-16','09:55:00',5.48),('8902','2013-04-16','10:00:00',5.62),('8902','2013-04-16','10:05:00',5.76),('8902','2013-04-16','10:10:00',5.88),('8902','2013-04-16','10:15:00',5.99),('8902','2013-04-16','10:20:00',6.1),('8902','2013-04-16','10:25:00',6.23),('8902','2013-04-16','10:30:00',6.32),('8902','2013-04-16','10:35:00',6.43),('8902','2013-04-16','10:40:00',6.55),('8902','2013-04-16','10:45:00',6.65),('8902','2013-04-16','10:50:00',6.74),('8902','2013-04-16','10:55:00',6.81),('8902','2013-04-16','11:00:00',6.9),('8902','2013-04-16','11:05:00',7.01),('8902','2013-04-16','11:10:00',7.09),('8902','2013-04-16','11:15:00',7.17),('8902','2013-04-16','11:20:00',7.22),('8902','2013-04-16','11:25:00',7.33),('8902','2013-04-16','11:30:00',7.38),('8902','2013-04-16','11:35:00',7.37),('8902','2013-04-16','11:40:00',7.4),('8902','2013-04-16','11:50:00',7.55),('8902','2013-04-16','11:55:00',7.65),('8902','2013-04-16','12:00:00',7.66),('8902','2013-04-16','12:05:00',7.68),('8902','2013-04-16','12:10:00',7.72),('8902','2013-04-16','12:15:00',7.82),('8902','2013-04-16','12:20:00',7.85),('8902','2013-04-16','12:25:00',7.89),('8902','2013-04-16','12:30:00',7.98),('8902','2013-04-16','12:35:00',7.97),('8902','2013-04-16','12:40:00',7.97),('8902','2013-04-16','12:45:00',7.97),('8902','2013-04-16','12:50:00',7.99),('8902','2013-04-16','12:55:00',8.02),('8902','2013-04-16','13:00:00',8.04),('8902','2013-04-16','13:05:00',7.99),('8902','2013-04-16','13:10:00',7.98),('8902','2013-04-16','13:15:00',8.09),('8902','2013-04-16','13:20:00',8.08),('8902','2013-04-16','13:25:00',8.1),('8902','2013-04-16','13:30:00',8.12),('8902','2013-04-16','13:35:00',7.97),('8902','2013-04-16','13:40:00',8.13),('8902','2013-04-16','13:45:00',7.59),('8902','2013-04-16','13:50:00',7.62),('8902','2013-04-16','13:55:00',8.29),('8902','2013-04-16','14:00:00',7.98),('8902','2013-04-16','14:05:00',8.54),('8902','2013-04-16','14:10:00',8.42),('8902','2013-04-16','14:15:00',7.4),('8902','2013-04-16','14:20:00',7.18),('8902','2013-04-16','14:25:00',7.43),('8902','2013-04-16','14:30:00',6.99),('8902','2013-04-16','14:35:00',8.27),('8902','2013-04-16','14:40:00',8.01),('8902','2013-04-16','14:45:00',6.79),('8902','2013-04-16','14:50:00',7.96),('8902','2013-04-16','14:55:00',8.3),('8902','2013-04-16','15:00:00',8.16),('8902','2013-04-16','15:05:00',8.32),('8902','2013-04-16','15:10:00',8.58),('8902','2013-04-16','15:15:00',7.64),('8902','2013-04-16','15:20:00',4.16),('8902','2013-04-16','15:25:00',4.57),('8902','2013-04-16','15:30:00',7),('8902','2013-04-16','15:35:00',7.44),('8902','2013-04-16','15:40:00',7.37),('8902','2013-04-16','15:45:00',7.33),('8902','2013-04-16','15:50:00',7.3),('8902','2013-04-16','15:55:00',7.32),('8902','2013-04-16','16:00:00',7.17),('8902','2013-04-16','16:05:00',5.33),('8902','2013-04-16','16:10:00',6.75),('8902','2013-04-16','16:15:00',6.54),('8902','2013-04-16','16:20:00',6.3),('8902','2013-04-16','16:25:00',6.02),('8902','2013-04-16','16:30:00',5.92),('8902','2013-04-16','16:35:00',5.91),('8902','2013-04-16','16:40:00',5.5),('8902','2013-04-16','16:45:00',5.54),('8902','2013-04-16','16:50:00',5.22),('8902','2013-04-16','16:55:00',5.05),('8902','2013-04-16','17:00:00',4.86),('8902','2013-04-16','17:05:00',4.63),('8902','2013-04-16','17:10:00',4.44),('8902','2013-04-16','17:15:00',4.29),('8902','2013-04-16','17:20:00',4.12),('8902','2013-04-16','17:25:00',3.93),('8902','2013-04-16','17:30:00',3.72),('8902','2013-04-16','17:35:00',3.52),('8902','2013-04-16','17:40:00',3.3),('8902','2013-04-16','17:45:00',3.14),('8902','2013-04-16','17:50:00',2.97),('8902','2013-04-16','17:55:00',2.74),('8902','2013-04-16','18:00:00',2.59),('8902','2013-04-16','18:05:00',2.38),('8902','2013-04-16','18:10:00',2.2),('8902','2013-04-16','18:15:00',2),('8902','2013-04-16','18:20:00',1.79),('8902','2013-04-16','18:25:00',1.61),('8902','2013-04-16','18:30:00',1.45),('8902','2013-04-16','18:35:00',1.29),('8902','2013-04-16','18:40:00',1.1),('8902','2013-04-15','07:50:00',1.05),('8902','2013-04-15','07:55:00',1.2),('8902','2013-04-15','08:00:00',1.15),('8902','2013-04-15','08:05:00',1.52),('8902','2013-04-15','08:10:00',1.71),('8902','2013-04-15','08:15:00',1.29),('8902','2013-04-15','08:20:00',1.21),('8902','2013-04-15','08:25:00',1.43),('8902','2013-04-15','08:30:00',1.58),('8902','2013-04-15','08:35:00',1.5),('8902','2013-04-15','08:40:00',1.61),('8902','2013-04-15','08:45:00',1.65),('8902','2013-04-15','08:50:00',1.79),('8902','2013-04-15','08:55:00',1.87),('8902','2013-04-15','09:00:00',2.07),('8902','2013-04-15','09:05:00',1.45),('8902','2013-04-15','09:10:00',2.07),('8902','2013-04-15','09:15:00',2.79),('8902','2013-04-15','09:20:00',2.25),('8902','2013-04-15','09:25:00',2.64),('8902','2013-04-15','09:30:00',3.06),('8902','2013-04-15','09:35:00',2.63),('8902','2013-04-15','09:40:00',2.44),('8902','2013-04-15','09:45:00',2.52),('8902','2013-04-15','09:50:00',2.51),('8902','2013-04-15','09:55:00',2.52),('8902','2013-04-15','10:00:00',2.45),('8902','2013-04-15','10:05:00',2.39),('8902','2013-04-15','10:10:00',2.53),('8902','2013-04-15','10:15:00',2.76),('8902','2013-04-15','10:20:00',2.93),('8902','2013-04-15','10:25:00',3.01),('8902','2013-04-15','10:30:00',3.18),('8902','2013-04-15','10:35:00',3.2),('8902','2013-04-15','10:40:00',3.07),('8902','2013-04-15','10:45:00',2.91),('8902','2013-04-15','10:50:00',2.93),('8902','2013-04-15','10:55:00',3.12),('8902','2013-04-15','11:00:00',3.38),('8902','2013-04-15','11:05:00',3.48),('8902','2013-04-15','11:10:00',3.49),('8902','2013-04-15','11:15:00',3.61),('8902','2013-04-15','11:20:00',3.69),('8902','2013-04-15','11:25:00',3.63),('8902','2013-04-15','11:30:00',3.59),('8902','2013-04-15','11:35:00',3.51),('8902','2013-04-15','11:40:00',3.88),('8902','2013-04-15','11:45:00',4.73),('8902','2013-04-15','11:50:00',5.04),('8902','2013-04-15','11:55:00',5.26),('8902','2013-04-15','12:00:00',5.91),('8902','2013-04-15','12:05:00',8.09),('8902','2013-04-15','12:10:00',7.99),('8902','2013-04-15','12:15:00',9.29),('8902','2013-04-15','12:20:00',7.68),('8902','2013-04-15','12:25:00',6.46),('8902','2013-04-15','12:30:00',7.12),('8902','2013-04-15','12:35:00',8.14),('8902','2013-04-15','12:40:00',8.77),('8902','2013-04-15','12:45:00',7.07),('8902','2013-04-15','12:50:00',6.37),('8902','2013-04-15','12:55:00',7.71),('8902','2013-04-15','13:00:00',8.07),('8902','2013-04-15','13:05:00',7.72),('8902','2013-04-15','13:10:00',7.84),('8902','2013-04-15','13:15:00',7.87),('8902','2013-04-15','13:20:00',7.98),('8902','2013-04-15','13:25:00',8.01),('8902','2013-04-15','13:30:00',7.93),('8902','2013-04-15','13:35:00',7.93),('8902','2013-04-15','13:40:00',7.84),('8902','2013-04-15','13:45:00',7.72),('8902','2013-04-15','13:50:00',7.72),('8902','2013-04-15','13:55:00',7.58),('8902','2013-04-15','14:00:00',7.58),('8902','2013-04-15','14:05:00',7.78),('8902','2013-04-15','14:10:00',7.83),('8902','2013-04-15','14:15:00',7.62),('8902','2013-04-15','14:20:00',7.62),('8902','2013-04-15','14:25:00',5.97),('8902','2013-04-15','14:30:00',6.48),('8902','2013-04-15','14:35:00',6.3),('8902','2013-04-15','14:40:00',7.39),('8902','2013-04-15','14:45:00',7.49),('8902','2013-04-15','14:50:00',7.3),('8902','2013-04-15','14:55:00',7.15),('8902','2013-04-15','15:00:00',7.33),('8902','2013-04-15','15:05:00',7.26),('8902','2013-04-15','15:10:00',7.23),('8902','2013-04-15','15:15:00',7.17),('8902','2013-04-15','15:20:00',7.12),('8902','2013-04-15','15:25:00',6.85),('8902','2013-04-15','15:30:00',6.68),('8902','2013-04-15','15:35:00',6.71),('8902','2013-04-15','15:40:00',6.7),('8902','2013-04-15','15:45:00',6.6),('8902','2013-04-15','15:50:00',6.57),('8902','2013-04-15','15:55:00',6.42),('8902','2013-04-15','16:00:00',6.1),('8902','2013-04-15','16:05:00',6.16),('8902','2013-04-15','16:10:00',6.03),('8902','2013-04-15','16:15:00',5.72),('8902','2013-04-15','16:20:00',5.85),('8902','2013-04-15','16:25:00',5.64),('8902','2013-04-15','16:30:00',5.6),('8902','2013-04-15','16:35:00',5.48),('8902','2013-04-15','16:40:00',5.72),('8902','2013-04-15','16:45:00',4.86),('8902','2013-04-15','16:50:00',4.99),('8902','2013-04-15','16:55:00',4.62),('8902','2013-04-15','17:00:00',4.71),('8902','2013-04-15','17:05:00',4.75),('8902','2013-04-15','17:10:00',4.72),('8902','2013-04-15','17:15:00',4.56),('8902','2013-04-15','17:20:00',4.41),('8902','2013-04-15','17:25:00',4.3),('8902','2013-04-15','17:30:00',3.89),('8902','2013-04-15','17:35:00',4.11),('8902','2013-04-15','17:40:00',3.83),('8902','2013-04-15','17:45:00',3.49),('8902','2013-04-15','17:50:00',3.24),('8902','2013-04-15','17:55:00',2.76),('8902','2013-04-15','18:00:00',1.65),('8902','2013-04-15','18:05:00',1.54),('8902','2013-04-15','18:10:00',1.43),('8902','2013-04-15','18:15:00',1.75),('8902','2013-04-15','18:20:00',1.43),('8902','2013-04-15','18:25:00',1.28),('8902','2013-04-15','18:30:00',1.19),('8902','2013-04-15','18:35:00',1.09),('8902','2013-04-14','07:50:00',1.11),('8902','2013-04-14','07:55:00',1.28),('8902','2013-04-14','08:00:00',1.45),('8902','2013-04-14','08:05:00',1.62),('8902','2013-04-14','08:10:00',1.79),('8902','2013-04-14','08:15:00',1.95),('8902','2013-04-14','08:20:00',2.12),('8902','2013-04-14','08:25:00',2.3),('8902','2013-04-14','08:30:00',2.49),('8902','2013-04-14','08:35:00',2.65),('8902','2013-04-14','08:40:00',2.82),('8902','2013-04-14','08:45:00',2.98),('8902','2013-04-14','08:50:00',3.17),('8902','2013-04-14','08:55:00',3.36),('8902','2013-04-14','09:00:00',3.52),('8902','2013-04-14','09:05:00',3.68),('8902','2013-04-14','09:10:00',3.86),('8902','2013-04-14','09:15:00',4.02),('8902','2013-04-14','09:20:00',4.17),('8902','2013-04-14','09:25:00',4.33),('8902','2013-04-14','09:30:00',4.48),('8902','2013-04-14','09:35:00',4.62),('8902','2013-04-14','09:40:00',4.75),('8902','2013-04-14','09:45:00',4.89),('8902','2013-04-14','09:50:00',5.03),('8902','2013-04-14','09:55:00',5.17),('8902','2013-04-14','10:00:00',5.3),('8902','2013-04-14','10:05:00',5.45),('8902','2013-04-14','10:10:00',5.58),('8902','2013-04-14','10:15:00',5.71),('8902','2013-04-14','10:20:00',5.82),('8902','2013-04-14','10:25:00',5.94),('8902','2013-04-14','10:30:00',6.02),('8902','2013-04-14','10:35:00',6.11),('8902','2013-04-14','10:40:00',6.23),('8902','2013-04-14','10:45:00',6.34),('8902','2013-04-14','10:50:00',6.44),('8902','2013-04-14','10:55:00',6.53),('8902','2013-04-14','11:00:00',6.62),('8902','2013-04-14','11:05:00',6.7),('8902','2013-04-14','11:10:00',6.78),('8902','2013-04-14','11:15:00',6.85),('8902','2013-04-14','11:20:00',6.93),('8902','2013-04-14','11:25:00',7.01),('8902','2013-04-14','11:30:00',7.08),('8902','2013-04-14','11:35:00',7.1),('8902','2013-04-14','11:40:00',7.15),('8902','2013-04-14','11:45:00',7.24),('8902','2013-04-14','11:50:00',7.31),('8902','2013-04-14','11:55:00',7.38),('8902','2013-04-14','12:00:00',7.38),('8902','2013-04-14','12:05:00',7.46),('8902','2013-04-14','12:10:00',7.46),('8902','2013-04-14','12:15:00',7.51),('8902','2013-04-14','12:20:00',7.55),('8902','2013-04-14','12:25:00',7.54),('8902','2013-04-14','12:30:00',7.55),('8902','2013-04-14','12:35:00',7.61),('8902','2013-04-14','12:40:00',7.64),('8902','2013-04-14','12:45:00',7.65),('8902','2013-04-14','12:50:00',7.66),('8902','2013-04-14','12:55:00',7.63),('8902','2013-04-14','13:00:00',7.64),('8902','2013-04-14','13:05:00',7.65),('8902','2013-04-14','13:10:00',7.69),('8902','2013-04-14','13:15:00',7.82),('8902','2013-04-14','13:20:00',7.82),('8902','2013-04-14','13:25:00',7.75),('8902','2013-04-14','13:30:00',7.71),('8902','2013-04-14','13:35:00',7.66),('8902','2013-04-14','13:40:00',7.71),('8902','2013-04-14','13:45:00',7.66),('8902','2013-04-14','13:50:00',7.58),('8902','2013-04-14','13:55:00',7.68),('8902','2013-04-14','14:00:00',7.73),('8902','2013-04-14','14:05:00',7.71),('8902','2013-04-14','14:10:00',7.69),('8902','2013-04-14','14:15:00',7.7),('8902','2013-04-14','14:20:00',7.71),('8902','2013-04-14','14:25:00',7.67),('8902','2013-04-14','14:30:00',7.57),('8902','2013-04-14','14:35:00',7.57),('8902','2013-04-14','14:40:00',7.52),('8902','2013-04-14','14:45:00',7.46),('8902','2013-04-14','14:50:00',7.39),('8902','2013-04-14','14:55:00',7.35),('8902','2013-04-14','15:00:00',7.3),('8902','2013-04-14','15:05:00',7.24),('8902','2013-04-14','15:10:00',7.15),('8902','2013-04-14','15:15:00',7.05),('8902','2013-04-14','15:20:00',6.97),('8902','2013-04-14','15:25:00',6.9),('8902','2013-04-14','15:30:00',6.81),('8902','2013-04-14','15:35:00',6.71),('8902','2013-04-14','15:40:00',6.59),('8902','2013-04-14','15:45:00',6.49),('8902','2013-04-14','15:50:00',6.41),('8902','2013-04-14','15:55:00',6.34),('8902','2013-04-14','16:00:00',6.22),('8902','2013-04-14','16:05:00',6.09),('8902','2013-04-14','16:10:00',5.99),('8902','2013-04-14','16:15:00',5.85),('8902','2013-04-14','16:20:00',5.7),('8902','2013-04-14','16:25:00',5.49),('8902','2013-04-14','16:30:00',5.37),('8902','2013-04-14','16:35:00',5.25),('8902','2013-04-14','16:40:00',5.13),('8902','2013-04-14','16:45:00',4.91),('8902','2013-04-14','16:50:00',4.76),('8902','2013-04-14','16:55:00',4.59),('8902','2013-04-14','17:00:00',4.45),('8902','2013-04-14','17:05:00',4.31),('8902','2013-04-14','17:10:00',4.13),('8902','2013-04-14','17:15:00',3.98),('8902','2013-04-14','17:20:00',3.83),('8902','2013-04-14','17:25:00',3.66),('8902','2013-04-14','17:30:00',3.47),('8902','2013-04-14','17:35:00',3.3),('8902','2013-04-14','17:40:00',3.09),('8902','2013-04-14','17:45:00',2.92),('8902','2013-04-14','17:50:00',2.76),('8902','2013-04-14','17:55:00',2.59),('8902','2013-04-14','18:00:00',2.4),('8902','2013-04-14','18:05:00',2.2),('8902','2013-04-14','18:10:00',2.04),('8902','2013-04-14','18:15:00',1.85),('8902','2013-04-14','18:20:00',1.68),('8902','2013-04-14','18:25:00',1.51),('8902','2013-04-14','18:30:00',1.36),('8902','2013-04-14','18:35:00',1.19),('8902','2013-04-14','18:40:00',1.02),('8902','2013-04-13','07:50:00',1.14),('8902','2013-04-13','07:55:00',1.34),('8902','2013-04-13','08:00:00',1.49),('8902','2013-04-13','08:05:00',1.5),('8902','2013-04-13','08:10:00',1.73),('8902','2013-04-13','08:15:00',1.92),('8902','2013-04-13','08:20:00',2.03),('8902','2013-04-13','08:25:00',2.17),('8902','2013-04-13','08:30:00',2.35),('8902','2013-04-13','08:35:00',2.51),('8902','2013-04-13','08:40:00',2.67),('8902','2013-04-13','08:45:00',2.81),('8902','2013-04-13','08:50:00',3),('8902','2013-04-13','08:55:00',3.15),('8902','2013-04-13','09:00:00',3.32),('8902','2013-04-13','09:05:00',3.48),('8902','2013-04-13','09:10:00',3.69),('8902','2013-04-13','09:15:00',3.84),('8902','2013-04-13','09:20:00',3.99),('8902','2013-04-13','09:25:00',4.11),('8902','2013-04-13','09:30:00',4.29),('8902','2013-04-13','09:35:00',4.43),('8902','2013-04-13','09:40:00',4.54),('8902','2013-04-13','09:45:00',4.7),('8902','2013-04-13','09:50:00',4.84),('8902','2013-04-13','09:55:00',4.98),('8902','2013-04-13','10:00:00',5.14),('8902','2013-04-13','10:05:00',5.26),('8902','2013-04-13','10:10:00',5.39),('8902','2013-04-13','10:15:00',5.51),('8902','2013-04-13','10:20:00',5.62),('8902','2013-04-13','10:25:00',5.72),('8902','2013-04-13','10:30:00',5.86),('8902','2013-04-13','10:35:00',5.96),('8902','2013-04-13','10:40:00',6.1),('8902','2013-04-13','10:45:00',6.16),('8902','2013-04-13','10:50:00',6.29),('8902','2013-04-13','10:55:00',6.39),('8902','2013-04-13','11:00:00',6.49),('8902','2013-04-13','11:05:00',6.57),('8902','2013-04-13','11:10:00',6.68),('8902','2013-04-13','11:15:00',6.78),('8902','2013-04-13','11:20:00',6.81),('8902','2013-04-13','11:25:00',6.85),('8902','2013-04-13','11:30:00',6.9),('8902','2013-04-13','11:35:00',6.98),('8902','2013-04-13','11:40:00',7.07),('8902','2013-04-13','11:45:00',7.15),('8902','2013-04-13','11:50:00',7.17),('8902','2013-04-13','11:55:00',7.24),('8902','2013-04-13','12:00:00',7.28),('8902','2013-04-13','12:05:00',7.3),('8902','2013-04-13','12:10:00',7.34),('8902','2013-04-13','12:15:00',7.36),('8902','2013-04-13','12:20:00',7.42),('8902','2013-04-13','12:25:00',7.45),('8902','2013-04-13','12:30:00',7.46),('8902','2013-04-13','12:35:00',7.57),('8902','2013-04-13','12:40:00',7.49),('8902','2013-04-13','12:45:00',7.78),('8902','2013-04-13','12:50:00',7.46),('8902','2013-04-13','12:55:00',5.66),('8902','2013-04-13','13:00:00',3.2),('8902','2013-04-13','13:05:00',2.6),('8902','2013-04-13','13:10:00',3.86),('8902','2013-04-13','13:15:00',8.45),('8902','2013-04-13','13:20:00',8.17),('8902','2013-04-13','13:25:00',7.9),('8902','2013-04-13','13:30:00',7.78),('8902','2013-04-13','13:35:00',7.75),('8902','2013-04-13','13:40:00',7.68),('8902','2013-04-13','13:45:00',7.67),('8902','2013-04-13','13:50:00',7.6),('8902','2013-04-13','13:55:00',7.53),('8902','2013-04-13','14:00:00',7.49),('8902','2013-04-13','14:05:00',7.5),('8902','2013-04-13','14:10:00',7.51),('8902','2013-04-13','14:15:00',7.55),('8902','2013-04-13','14:20:00',7.53),('8902','2013-04-13','14:25:00',7.4),('8902','2013-04-13','14:30:00',7.44),('8902','2013-04-13','14:35:00',7.55),('8902','2013-04-13','14:40:00',7.58),('8902','2013-04-13','14:45:00',7.64),('8902','2013-04-13','14:50:00',7.64),('8902','2013-04-13','14:55:00',7.38),('8902','2013-04-13','15:00:00',7.28),('8902','2013-04-13','15:05:00',7.23),('8902','2013-04-13','15:10:00',5.23),('8902','2013-04-13','15:15:00',5.47),('8902','2013-04-13','15:20:00',6.62),('8902','2013-04-13','15:25:00',5.31),('8902','2013-04-13','15:30:00',6.05),('8902','2013-04-13','15:35:00',6.86),('8902','2013-04-13','15:40:00',6.49),('8902','2013-04-13','15:45:00',6.8),('8902','2013-04-13','15:50:00',6.5),('8902','2013-04-13','15:55:00',4.27),('8902','2013-04-13','16:00:00',6.02),('8902','2013-04-13','16:05:00',5.82),('8902','2013-04-13','16:10:00',5.84),('8902','2013-04-13','16:15:00',5.51),('8902','2013-04-13','16:20:00',5.44),('8902','2013-04-13','16:25:00',5.4),('8902','2013-04-13','16:30:00',5.24),('8902','2013-04-13','16:35:00',5.04),('8902','2013-04-13','16:40:00',4.85),('8902','2013-04-13','16:45:00',4.68),('8902','2013-04-13','16:50:00',4.59),('8902','2013-04-13','16:55:00',4.43),('8902','2013-04-13','17:00:00',4.26),('8902','2013-04-13','17:05:00',4.11),('8902','2013-04-13','17:10:00',3.98),('8902','2013-04-13','17:15:00',3.8),('8902','2013-04-13','17:20:00',3.61),('8902','2013-04-13','17:25:00',3.42),('8902','2013-04-13','17:30:00',3.29),('8902','2013-04-13','17:35:00',3.13),('8902','2013-04-13','17:40:00',2.93),('8902','2013-04-13','17:45:00',2.8),('8902','2013-04-13','17:50:00',2.63),('8902','2013-04-13','17:55:00',2.41),('8902','2013-04-13','18:00:00',2.23),('8902','2013-04-13','18:05:00',2.09),('8902','2013-04-13','18:10:00',1.92),('8902','2013-04-13','18:15:00',1.76),('8902','2013-04-13','18:20:00',1.59),('8902','2013-04-13','18:25:00',1.42),('8902','2013-04-13','18:30:00',1.26),('8902','2013-04-13','18:35:00',1.1),('8902','2013-04-12','07:50:00',1.01),('8902','2013-04-12','07:55:00',1.18),('8902','2013-04-12','08:00:00',1.36),('8902','2013-04-12','08:05:00',1.48),('8902','2013-04-12','08:10:00',1.62),('8902','2013-04-12','08:15:00',1.52),('8902','2013-04-12','08:20:00',1.31),('8902','2013-04-12','08:25:00',1.1),('8902','2013-04-12','08:30:00',1.11),('8902','2013-04-12','08:35:00',1.08),('8902','2013-04-12','08:40:00',1.1),('8902','2013-04-12','08:45:00',1.27),('8902','2013-04-12','08:50:00',1.42),('8902','2013-04-12','08:55:00',1.92),('8902','2013-04-12','09:00:00',1.91),('8902','2013-04-12','09:05:00',3.32),('8902','2013-04-12','09:10:00',2.17),('8902','2013-04-12','09:15:00',2.51),('8902','2013-04-12','09:20:00',2.7),('8902','2013-04-12','09:25:00',3.18),('8902','2013-04-12','09:30:00',4.37),('8902','2013-04-12','09:35:00',4.36),('8902','2013-04-12','09:40:00',4),('8902','2013-04-12','09:45:00',4.74),('8902','2013-04-12','09:50:00',4.88),('8902','2013-04-12','09:55:00',5.06),('8902','2013-04-12','10:00:00',5.22),('8902','2013-04-12','10:05:00',5.34),('8902','2013-04-12','10:10:00',5.76),('8902','2013-04-12','10:15:00',5.94),('8902','2013-04-12','10:20:00',4.37),('8902','2013-04-12','10:25:00',4.36),('8902','2013-04-12','10:30:00',6.35),('8902','2013-04-12','10:35:00',4.29),('8902','2013-04-12','10:40:00',5.04),('8902','2013-04-12','10:45:00',6.52),('8902','2013-04-12','10:50:00',4.07),('8902','2013-04-12','10:55:00',4.7),('8902','2013-04-12','11:00:00',3.72),('8902','2013-04-12','11:05:00',4),('8902','2013-04-12','11:10:00',6.35),('8902','2013-04-12','11:15:00',4.71),('8902','2013-04-12','11:20:00',7.56),('8902','2013-04-12','11:25:00',6.94),('8902','2013-04-12','11:30:00',3.64),('8902','2013-04-12','11:35:00',7.9),('8902','2013-04-12','11:40:00',7.72),('8902','2013-04-12','11:45:00',7.08),('8902','2013-04-12','11:50:00',7.67),('8902','2013-04-12','11:55:00',7.94),('8902','2013-04-12','12:00:00',7.9),('8902','2013-04-12','12:05:00',6.26),('8902','2013-04-12','12:10:00',6.9),('8902','2013-04-12','12:15:00',8.06),('8902','2013-04-12','12:20:00',7.73),('8902','2013-04-12','12:25:00',5.67),('8902','2013-04-12','12:30:00',7.72),('8902','2013-04-12','12:35:00',7.99),('8902','2013-04-12','12:40:00',8.08),('8902','2013-04-12','12:45:00',7.96),('8902','2013-04-12','12:50:00',7.77),('8902','2013-04-12','12:55:00',7.92),('8902','2013-04-12','13:00:00',7.8),('8902','2013-04-12','13:05:00',8.01),('8902','2013-04-12','13:10:00',8.21),('8902','2013-04-12','13:15:00',8.03),('8902','2013-04-12','13:20:00',7.54),('8902','2013-04-12','13:25:00',8.1),('8902','2013-04-12','13:30:00',5.73),('8902','2013-04-12','13:35:00',3.11),('8902','2013-04-12','13:40:00',3.23),('8902','2013-04-12','13:45:00',4.71),('8902','2013-04-12','13:50:00',4.16),('8902','2013-04-12','13:55:00',3.02),('8902','2013-04-12','14:00:00',3.09),('8902','2013-04-12','14:05:00',4.99),('8902','2013-04-12','14:10:00',2.96),('8902','2013-04-12','14:15:00',3.46),('8902','2013-04-12','14:20:00',5.58),('8902','2013-04-12','14:25:00',4.76),('8902','2013-04-12','14:30:00',7.07),('8902','2013-04-12','14:35:00',7.44),('8902','2013-04-12','14:40:00',7.1),('8902','2013-04-12','14:45:00',7.18),('8902','2013-04-12','14:50:00',6.84),('8902','2013-04-12','14:55:00',6.91),('8902','2013-04-12','15:00:00',6.35),('8902','2013-04-12','15:05:00',6.19),('8902','2013-04-12','15:10:00',6.07),('8902','2013-04-12','15:15:00',5.67),('8902','2013-04-12','15:20:00',5.47),('8902','2013-04-12','15:25:00',5.12),('8902','2013-04-12','15:30:00',5.24),('8902','2013-04-12','15:35:00',5.06),('8902','2013-04-12','15:40:00',5.27),('8902','2013-04-12','15:45:00',5.35),('8902','2013-04-12','15:50:00',5.17),('8902','2013-04-12','15:55:00',5.23),('8902','2013-04-12','16:00:00',5.11),('8902','2013-04-12','16:05:00',4.89),('8902','2013-04-12','16:10:00',4.57),('8902','2013-04-12','16:15:00',4.74),('8902','2013-04-12','16:20:00',4.5),('8902','2013-04-12','16:25:00',4.19),('8902','2013-04-12','16:30:00',4),('8902','2013-04-12','16:35:00',3.75),('8902','2013-04-12','16:40:00',3.57),('8902','2013-04-12','16:45:00',3.36),('8902','2013-04-12','16:50:00',3.43),('8902','2013-04-12','16:55:00',2.87),('8902','2013-04-12','17:00:00',2.41),('8902','2013-04-12','17:05:00',2.25),('8902','2013-04-12','17:10:00',3.32),('8902','2013-04-12','17:15:00',3.91),('8902','2013-04-12','17:20:00',3.26),('8902','2013-04-12','17:25:00',3.69),('8902','2013-04-12','17:30:00',3.16),('8902','2013-04-12','17:35:00',3.24),('8902','2013-04-12','17:40:00',3.06),('8902','2013-04-12','17:45:00',2.75),('8902','2013-04-12','17:50:00',2.44),('8902','2013-04-12','17:55:00',2.6),('8902','2013-04-12','18:00:00',2.02),('8902','2013-04-12','18:05:00',1.98),('8902','2013-04-12','18:10:00',1.8),('8902','2013-04-12','18:15:00',1.79),('8902','2013-04-12','18:20:00',1.67),('8902','2013-04-12','18:25:00',1.53),('8902','2013-04-12','18:30:00',1.4),('8902','2013-04-12','18:35:00',1.21),('8902','2013-04-12','18:40:00',1.01),('8902','2013-04-11','14:05:00',7.98),('8902','2013-04-11','14:10:00',7.93),('8902','2013-04-11','14:15:00',7.86),('8902','2013-04-11','14:20:00',7.83),('8902','2013-04-11','14:25:00',7.8),('8902','2013-04-11','14:30:00',7.7),('8902','2013-04-11','14:35:00',7.64),('8902','2013-04-11','14:40:00',7.6),('8902','2013-04-11','14:45:00',7.54),('8902','2013-04-11','14:50:00',7.48),('8902','2013-04-11','14:55:00',7.44),('8902','2013-04-11','15:00:00',7.37),('8902','2013-04-11','15:05:00',7.3),('8902','2013-04-11','15:10:00',7.18),('8902','2013-04-11','15:15:00',7.1),('8902','2013-04-11','15:20:00',6.99),('8902','2013-04-11','15:25:00',6.89),('8902','2013-04-11','15:30:00',6.8),('8902','2013-04-11','15:35:00',6.72),('8902','2013-04-11','15:40:00',6.62),('8902','2013-04-11','15:45:00',6.5),('8902','2013-04-11','15:50:00',6.4),('8902','2013-04-11','15:55:00',6.25),('8902','2013-04-11','16:00:00',6.15),('8902','2013-04-11','16:05:00',6.11),('8902','2013-04-11','16:10:00',5.99),('8902','2013-04-11','16:15:00',5.46),('8902','2013-04-11','16:20:00',5.66),('8902','2013-04-11','16:25:00',5.53),('8902','2013-04-11','16:30:00',3.67),('8902','2013-04-11','16:35:00',2.4),('8902','2013-04-11','16:40:00',3.36),('8902','2013-04-11','16:45:00',5.12),('8902','2013-04-11','16:50:00',4.76),('8902','2013-04-11','16:55:00',4.62),('8902','2013-04-11','17:00:00',4.46),('8902','2013-04-11','17:05:00',4.29),('8902','2013-04-11','17:10:00',4.12),('8902','2013-04-11','17:15:00',3.92),('8902','2013-04-11','17:20:00',3.76),('8902','2013-04-11','17:25:00',3.59),('8902','2013-04-11','17:30:00',3.42),('8902','2013-04-11','17:35:00',3.26),('8902','2013-04-11','17:40:00',3.06),('8902','2013-04-11','17:45:00',2.87),('8902','2013-04-11','17:50:00',2.69),('8902','2013-04-11','17:55:00',2.48),('8902','2013-04-11','18:00:00',2.28),('8902','2013-04-11','18:05:00',2.1),('8902','2013-04-11','18:10:00',1.86),('8902','2013-04-11','18:15:00',1.68),('8902','2013-04-11','18:20:00',1.53),('8902','2013-04-11','18:25:00',1.37),('8902','2014-03-27','07:10:00',1.23),('8902','2014-03-27','07:15:00',1.4),('8902','2014-03-27','07:20:00',1.54),('8902','2014-03-27','07:25:00',1.64),('8902','2014-03-27','07:30:00',1.7),('8902','2014-03-27','07:35:00',2.02),('8902','2014-03-27','07:40:00',2.11),('8902','2014-03-27','07:45:00',2.41),('8902','2014-03-27','07:50:00',2.61),('8902','2014-03-27','07:55:00',2.78),('8902','2014-03-27','08:00:00',2.94),('8902','2014-03-27','08:05:00',3.14),('8902','2014-03-27','08:10:00',3.35),('8902','2014-03-27','08:15:00',3.57),('8902','2014-03-27','08:20:00',3.76),('8902','2014-03-27','08:25:00',3.95),('8902','2014-03-27','08:30:00',4.12),('8902','2014-03-27','08:35:00',4.33),('8902','2014-03-27','08:40:00',4.54),('8902','2014-03-27','08:45:00',4.68),('8902','2014-03-27','08:50:00',4.85),('8902','2014-03-27','08:55:00',5.07),('8902','2014-03-27','09:00:00',5.14),('8902','2014-03-27','09:05:00',5.44),('8902','2014-03-27','09:10:00',5.81),('8902','2014-03-27','09:15:00',5.83),('8902','2014-03-27','09:20:00',5.05),('8902','2014-03-27','09:25:00',6.01),('8902','2014-03-27','09:30:00',6.48),('8902','2014-03-27','09:35:00',5.97),('8902','2014-03-27','09:40:00',4.05),('8902','2014-03-27','09:45:00',3.44),('8902','2014-03-27','09:50:00',4.04),('8902','2014-03-27','09:55:00',6.22),('8902','2014-03-27','10:00:00',7.21),('8902','2014-03-27','10:05:00',6.95),('8902','2014-03-27','10:10:00',5.58),('8902','2014-03-27','10:15:00',5.45),('8902','2014-03-27','10:20:00',5.15),('8902','2014-03-27','10:25:00',6.83),('8902','2014-03-27','10:30:00',7.26),('8902','2014-03-27','10:35:00',6.59),('8902','2014-03-27','10:40:00',6.85),('8902','2014-03-27','10:45:00',5.51),('8902','2014-03-27','10:50:00',7.23),('8902','2014-03-27','10:55:00',7.81),('8902','2014-03-27','11:00:00',7.9),('8902','2014-03-27','11:05:00',7.84),('8902','2014-03-27','11:10:00',6.13),('8902','2014-03-27','11:15:00',8.08),('8902','2014-03-27','11:20:00',8),('8902','2014-03-27','11:25:00',5.69),('8902','2014-03-27','11:30:00',5.32),('8902','2014-03-27','11:35:00',9.21),('8902','2014-03-27','11:40:00',4.16),('8902','2014-03-27','11:45:00',2.69),('8902','2014-03-27','11:50:00',2.44),('8902','2014-03-27','11:55:00',2.43),('8902','2014-03-27','12:00:00',1.67),('8902','2014-03-27','12:05:00',3.5),('8902','2014-03-27','12:10:00',9.3),('8902','2014-03-27','12:15:00',9.43),('8902','2014-03-27','12:20:00',8.87),('8902','2014-03-27','12:25:00',3.68),('8902','2014-03-27','12:30:00',4.48),('8902','2014-03-27','12:35:00',7.36),('8902','2014-03-27','12:40:00',6.64),('8902','2014-03-27','12:45:00',8.7),('8902','2014-03-27','12:50:00',8.56),('8902','2014-03-27','12:55:00',9.01),('8902','2014-03-27','13:00:00',7.51),('8902','2014-03-27','13:05:00',5.45),('8902','2014-03-27','13:10:00',2.65),('8902','2014-03-27','13:15:00',3.04),('8902','2014-03-27','13:20:00',9.12),('8902','2014-03-27','13:25:00',5.7),('8902','2014-03-27','13:30:00',2.81),('8902','2014-03-27','13:35:00',8.52),('8902','2014-03-27','13:40:00',7.65),('8902','2014-03-27','13:45:00',8.12),('8902','2014-03-27','13:50:00',7.94),('8902','2014-03-27','13:55:00',7.6),('8902','2014-03-27','14:00:00',7.77),('8902','2014-03-27','14:05:00',7.64),('8902','2014-03-27','14:10:00',7.39),('8902','2014-03-27','14:15:00',7.44),('8902','2014-03-27','14:20:00',7.4),('8902','2014-03-27','14:25:00',7.29),('8902','2014-03-27','14:30:00',7.17),('8902','2014-03-27','14:35:00',7.12),('8902','2014-03-27','14:40:00',7.04),('8902','2014-03-27','14:45:00',6.94),('8902','2014-03-27','14:50:00',6.85),('8902','2014-03-27','14:55:00',6.71),('8902','2014-03-27','15:00:00',6.69),('8902','2014-03-27','15:05:00',6.54),('8902','2014-03-27','15:10:00',6.38),('8902','2014-03-27','15:15:00',6.23),('8902','2014-03-27','15:20:00',6.08),('8902','2014-03-27','15:25:00',5.87),('8902','2014-03-27','15:30:00',5.77),('8902','2014-03-27','15:35:00',5.62),('8902','2014-03-27','15:40:00',5.5),('8902','2014-03-27','15:45:00',5.46),('8902','2014-03-27','15:50:00',5.31),('8902','2014-03-27','15:55:00',5.19),('8902','2014-03-27','16:00:00',5.25),('8902','2014-03-27','16:05:00',5.29),('8902','2014-03-27','16:10:00',5.14),('8902','2014-03-27','16:15:00',5.04),('8902','2014-03-27','16:20:00',4.45),('8902','2014-03-27','16:25:00',3.92),('8902','2014-03-27','16:30:00',3.27),('8902','2014-03-27','16:35:00',2.37),('8902','2014-03-27','16:40:00',3.16),('8902','2014-03-27','16:45:00',2.79),('8902','2014-03-27','16:50:00',2.71),('8902','2014-03-27','17:00:00',1.48),('8902','2014-03-27','17:05:00',1.87),('8902','2014-03-27','17:10:00',1.87),('8902','2014-03-27','17:15:00',1.88),('8902','2014-03-27','17:20:00',1.94),('8902','2014-03-27','17:25:00',1.09),('8902','2013-04-06','08:15:00',1.04),('8902','2013-04-06','08:20:00',1.25),('8902','2013-04-06','08:25:00',1.52),('8902','2013-04-06','08:30:00',1.68),('8902','2013-04-06','08:35:00',1.89),('8902','2013-04-06','08:40:00',2.04),('8902','2013-04-06','08:45:00',2.13),('8902','2013-04-06','08:50:00',2.2),('8902','2013-04-06','08:55:00',2.28),('8902','2013-04-06','09:00:00',2.24),('8902','2013-04-06','09:05:00',2.39),('8902','2013-04-06','09:10:00',2.53),('8902','2013-04-06','09:15:00',2.57),('8902','2013-04-06','09:20:00',2.71),('8902','2013-04-06','09:25:00',2.67),('8902','2013-04-06','09:30:00',2.64),('8902','2013-04-06','09:35:00',2.5),('8902','2013-04-06','09:40:00',2.61),('8902','2013-04-06','09:45:00',3.37),('8902','2013-04-06','09:50:00',3.64),('8902','2013-04-06','09:55:00',4.1),('8902','2013-04-06','10:00:00',4.72),('8902','2013-04-06','10:05:00',4.89),('8902','2013-04-06','10:10:00',4.91),('8902','2013-04-06','10:15:00',5.08),('8902','2013-04-06','10:20:00',5.13),('8902','2013-04-06','10:25:00',5),('8902','2013-04-06','10:30:00',4.48),('8902','2013-04-06','10:35:00',5.06),('8902','2013-04-06','10:40:00',4.95),('8902','2013-04-06','10:45:00',4.89),('8902','2013-04-06','10:50:00',4.62),('8902','2013-04-06','10:55:00',4.1),('8902','2013-04-06','11:00:00',3.78),('8902','2013-04-06','11:05:00',3.34),('8902','2013-04-06','11:10:00',4.15),('8902','2013-04-06','11:15:00',5.76),('8902','2013-04-06','11:20:00',6.41),('8902','2013-04-06','11:25:00',6.95),('8902','2013-04-06','11:30:00',6.56),('8902','2013-04-06','11:35:00',6.2),('8902','2013-04-06','11:40:00',5.37),('8902','2013-04-06','11:45:00',4.43),('8902','2013-04-06','11:50:00',4.31),('8902','2013-04-06','11:55:00',4.45),('8902','2013-04-06','12:00:00',4.7),('8902','2013-04-06','12:05:00',4.53),('8902','2013-04-06','12:10:00',4.97),('8902','2013-04-06','12:15:00',4.75),('8902','2013-04-06','12:20:00',5.38),('8902','2013-04-06','12:25:00',5.76),('8902','2013-04-06','12:30:00',4.88),('8902','2013-04-06','12:35:00',5.46),('8902','2013-04-06','12:40:00',5.09),('8902','2013-04-06','12:45:00',4.5),('8902','2013-04-06','12:50:00',4.92),('8902','2013-04-06','12:55:00',5.28),('8902','2013-04-06','13:00:00',6.24),('8902','2013-04-06','13:05:00',6.63),('8902','2013-04-06','13:10:00',6.32),('8902','2013-04-06','13:15:00',5.7),('8902','2013-04-06','13:20:00',5.45),('8902','2013-04-06','13:25:00',6.3),('8902','2013-04-06','13:30:00',6.29),('8902','2013-04-06','13:35:00',5.69),('8902','2013-04-06','13:40:00',6.41),('8902','2013-04-06','13:45:00',6.7),('8902','2013-04-06','13:50:00',6.2),('8902','2013-04-06','13:55:00',6.04),('8902','2013-04-06','14:00:00',7.11),('8902','2013-04-06','14:05:00',5.9),('8902','2013-04-06','14:10:00',4.91),('8902','2013-04-06','14:15:00',4.48),('8902','2013-04-06','14:20:00',4.17),('8902','2013-04-06','14:25:00',4.28),('8902','2013-04-06','14:30:00',4.96),('8902','2013-04-06','14:35:00',4.77),('8902','2013-04-06','14:40:00',4.07),('8902','2013-04-06','14:45:00',3.86),('8902','2013-04-06','14:50:00',4.15),('8902','2013-04-06','14:55:00',3.87),('8902','2013-04-06','15:00:00',3.5),('8902','2013-04-06','15:05:00',5.98),('8902','2013-04-06','15:10:00',5.85),('8902','2013-04-06','15:15:00',5.38),('8902','2013-04-06','15:20:00',5.79),('8902','2013-04-06','15:25:00',6.06),('8902','2013-04-06','15:30:00',6.01),('8902','2013-04-06','15:35:00',5.07),('8902','2013-04-06','15:40:00',5.69),('8902','2013-04-06','15:45:00',5.27),('8902','2013-04-06','15:50:00',4.98),('8902','2013-04-06','15:55:00',5.11),('8902','2013-04-06','16:00:00',4.86),('8902','2013-04-06','16:05:00',4.25),('8902','2013-04-06','16:10:00',3.58),('8902','2013-04-06','16:15:00',3.13),('8902','2013-04-06','16:20:00',2.99),('8902','2013-04-06','16:25:00',2.66),('8902','2013-04-06','16:30:00',2.66),('8902','2013-04-06','16:35:00',3.11),('8902','2013-04-06','16:40:00',3.25),('8902','2013-04-06','16:45:00',4.23),('8902','2013-04-06','16:50:00',4.48),('8902','2013-04-06','16:55:00',4.37),('8902','2013-04-06','17:00:00',3.96),('8902','2013-04-06','17:05:00',3.33),('8902','2013-04-06','17:10:00',1.81),('8902','2013-04-06','17:15:00',1.68),('8902','2013-04-06','17:20:00',3.32),('8902','2013-04-06','17:25:00',3.79),('8902','2013-04-06','17:30:00',3.63),('8902','2013-04-06','17:35:00',3.43),('8902','2013-04-06','17:40:00',3.34),('8902','2013-04-06','17:45:00',3.08),('8902','2013-04-06','17:50:00',2.95),('8902','2013-04-06','17:55:00',2.51),('8902','2013-04-06','18:00:00',1.76),('8902','2013-04-06','18:05:00',1.32),('8902','2013-04-06','18:10:00',1.28),('8902','2013-04-05','08:00:00',1.17),('8902','2013-04-05','08:05:00',1.36),('8902','2013-04-05','08:10:00',1.53),('8902','2013-04-05','08:15:00',1.7),('8902','2013-04-05','08:20:00',1.85),('8902','2013-04-05','08:25:00',2),('8902','2013-04-05','08:30:00',2.16),('8902','2013-04-05','08:35:00',2.31),('8902','2013-04-05','08:40:00',2.49),('8902','2013-04-05','08:45:00',2.65),('8902','2013-04-05','08:50:00',2.83),('8902','2013-04-05','08:55:00',3.01),('8902','2013-04-05','09:00:00',3.21),('8902','2013-04-05','09:05:00',3.4),('8902','2013-04-05','09:10:00',3.56),('8902','2013-04-05','09:15:00',3.73),('8902','2013-04-05','09:20:00',3.89),('8902','2013-04-05','09:25:00',4.06),('8902','2013-04-05','09:30:00',4.23),('8902','2013-04-05','09:35:00',4.29),('8902','2013-04-05','09:40:00',4.49),('8902','2013-04-05','09:45:00',4.61),('8902','2013-04-05','09:50:00',4.79),('8902','2013-04-05','09:55:00',4.92),('8902','2013-04-05','10:00:00',5.06),('8902','2013-04-05','10:05:00',5.24),('8902','2013-04-05','10:10:00',5.31),('8902','2013-04-05','10:15:00',5.48),('8902','2013-04-05','10:20:00',5.72),('8902','2013-04-05','10:25:00',5.78),('8902','2013-04-05','10:30:00',5.84),('8902','2013-04-05','10:35:00',5.98),('8902','2013-04-05','10:40:00',6.1),('8902','2013-04-05','10:45:00',6.2),('8902','2013-04-05','10:50:00',6.28),('8902','2013-04-05','10:55:00',6.4),('8902','2013-04-05','11:00:00',6.48),('8902','2013-04-05','11:05:00',6.65),('8902','2013-04-05','11:10:00',6.67),('8902','2013-04-05','11:15:00',6.71),('8902','2013-04-05','11:20:00',6.84),('8902','2013-04-05','11:25:00',6.98),('8902','2013-04-05','11:30:00',7.02),('8902','2013-04-05','11:35:00',7.04),('8902','2013-04-05','11:40:00',7.16),('8902','2013-04-05','11:45:00',7.26),('8902','2013-04-05','11:50:00',7.31),('8902','2013-04-05','11:55:00',7.41),('8902','2013-04-05','12:00:00',7.37),('8902','2013-04-05','12:05:00',7.43),('8902','2013-04-05','12:10:00',7.45),('8902','2013-04-05','12:15:00',7.47),('8902','2013-04-05','12:20:00',7.55),('8902','2013-04-05','12:25:00',4.8),('8902','2013-04-05','12:30:00',7.46),('8902','2013-04-05','12:35:00',7.83),('8902','2013-04-05','12:40:00',7.8),('8902','2013-04-05','12:45:00',7.91),('8902','2013-04-05','12:50:00',7.93),('8902','2013-04-05','12:55:00',7.99),('8902','2013-04-05','13:00:00',7.95),('8902','2013-04-05','13:05:00',7.96),('8902','2013-04-05','13:10:00',4.94),('8902','2013-04-05','13:15:00',3.6),('8902','2013-04-05','13:20:00',2.4),('8902','2013-04-05','13:25:00',2.2),('8902','2013-04-05','13:30:00',2.96),('8902','2013-04-05','13:35:00',3.58),('8902','2013-04-05','13:40:00',7.71),('8902','2013-04-05','13:45:00',9.13),('8902','2013-04-05','13:50:00',8.49),('8902','2013-04-05','13:55:00',8.47),('8902','2013-04-05','14:00:00',7.66),('8902','2013-04-05','14:05:00',7.55),('8902','2013-04-05','14:10:00',8.27),('8902','2013-04-05','14:15:00',4.83),('8902','2013-04-05','14:20:00',2.26),('8902','2013-04-05','14:25:00',3.44),('8902','2013-04-05','14:30:00',5.48),('8902','2013-04-05','14:35:00',6.35),('8902','2013-04-05','14:40:00',3.71),('8902','2013-04-05','14:45:00',6.37),('8902','2013-04-05','14:50:00',7.71),('8902','2013-04-05','14:55:00',7.76),('8902','2013-04-05','15:00:00',7.6),('8902','2013-04-05','15:05:00',7.4),('8902','2013-04-05','15:10:00',7.02),('8902','2013-04-05','15:15:00',6.89),('8902','2013-04-05','15:20:00',6.82),('8902','2013-04-05','15:25:00',6.8),('8902','2013-04-05','15:30:00',6.47),('8902','2013-04-05','15:35:00',6.31),('8902','2013-04-05','15:40:00',6.37),('8902','2013-04-05','15:45:00',5.92),('8902','2013-04-05','15:50:00',5.53),('8902','2013-04-05','15:55:00',6.09),('8902','2013-04-05','16:00:00',5.71),('8902','2013-04-05','16:05:00',5.91),('8902','2013-04-05','16:10:00',6.04),('8902','2013-04-05','16:15:00',5.37),('8902','2013-04-05','16:20:00',4.64),('8902','2013-04-05','16:25:00',3.96),('8902','2013-04-05','16:30:00',4.82),('8902','2013-04-05','16:35:00',4.45),('8902','2013-04-05','16:40:00',3.53),('8902','2013-04-05','16:45:00',4.69),('8902','2013-04-05','16:50:00',4.44),('8902','2013-04-05','16:55:00',3.88),('8902','2013-04-05','17:00:00',3.83),('8902','2013-04-05','17:05:00',3.4),('8902','2013-04-05','17:10:00',3.05),('8902','2013-04-05','17:15:00',2.39),('8902','2013-04-05','17:20:00',1.82),('8902','2013-04-05','17:25:00',1.95),('8902','2013-04-05','17:30:00',1.86),('8902','2013-04-05','17:35:00',1.53),('8902','2013-04-05','17:40:00',1.49),('8902','2013-04-05','17:45:00',1.39),('8902','2013-04-05','17:50:00',1.36),('8902','2013-04-05','17:55:00',1.25),('8902','2013-04-05','18:00:00',1.1),('8902','2013-04-04','08:05:00',1.17),('8902','2013-04-04','08:10:00',1.29),('8902','2013-04-04','08:15:00',2.12),('8902','2013-04-04','08:20:00',2.41),('8902','2013-04-04','08:25:00',1.58),('8902','2013-04-04','08:30:00',1.1),('8902','2013-04-04','08:40:00',1.27),('8902','2013-04-04','08:45:00',1.6),('8902','2013-04-04','08:50:00',1.12),('8902','2013-04-04','08:55:00',3.29),('8902','2013-04-04','09:00:00',2.1),('8902','2013-04-04','09:05:00',4.21),('8902','2013-04-04','09:10:00',3.08),('8902','2013-04-04','09:15:00',4.12),('8902','2013-04-04','09:20:00',3.75),('8902','2013-04-04','09:25:00',1.94),('8902','2013-04-04','09:30:00',1.42),('8902','2013-04-04','09:35:00',1.95),('8902','2013-04-04','09:40:00',3.1),('8902','2013-04-04','09:45:00',3.96),('8902','2013-04-04','09:50:00',2.13),('8902','2013-04-04','09:55:00',2),('8902','2013-04-04','10:00:00',2.74),('8902','2013-04-04','10:05:00',1.6),('8902','2013-04-04','10:10:00',5.05),('8902','2013-04-04','10:15:00',4.83),('8902','2013-04-04','10:20:00',2.41),('8902','2013-04-04','10:25:00',3.69),('8902','2013-04-04','10:30:00',3.73),('8902','2013-04-04','10:35:00',2.66),('8902','2013-04-04','10:40:00',5.31),('8902','2013-04-04','10:45:00',3.73),('8902','2013-04-04','10:50:00',4.41),('8902','2013-04-04','10:55:00',4.1),('8902','2013-04-04','11:00:00',2.92),('8902','2013-04-04','11:05:00',4.72),('8902','2013-04-04','11:10:00',6.87),('8902','2013-04-04','11:15:00',7.04),('8902','2013-04-04','11:20:00',6.04),('8902','2013-04-04','11:25:00',7.59),('8902','2013-04-04','11:30:00',7.51),('8902','2013-04-04','11:35:00',7.38),('8902','2013-04-04','11:40:00',7.54),('8902','2013-04-04','11:45:00',7.75),('8902','2013-04-04','11:50:00',8.11),('8902','2013-04-04','11:55:00',7.99),('8902','2013-04-04','12:00:00',8.87),('8902','2013-04-04','12:05:00',6.23),('8902','2013-04-04','12:10:00',4),('8902','2013-04-04','12:15:00',5.8),('8902','2013-04-04','12:20:00',2.76),('8902','2013-04-04','12:25:00',4.29),('8902','2013-04-04','12:30:00',2.43),('8902','2013-04-04','12:35:00',2.52),('8902','2013-04-04','12:40:00',3.07),('8902','2013-04-04','12:45:00',6.35),('8902','2013-04-04','12:50:00',8.55),('8902','2013-04-04','12:55:00',8.25),('8902','2013-04-04','13:00:00',5.62),('8902','2013-04-04','13:05:00',7.03),('8902','2013-04-04','13:10:00',6.05),('8902','2013-04-04','13:15:00',8.48),('8902','2013-04-04','13:20:00',7.21),('8902','2013-04-04','13:25:00',8.67),('8902','2013-04-04','13:30:00',6.19),('8902','2013-04-04','13:35:00',7.91),('8902','2013-04-04','13:40:00',7.21),('8902','2013-04-04','13:45:00',5.56),('8902','2013-04-04','13:50:00',9.1),('8902','2013-04-04','13:55:00',8.87),('8902','2013-04-04','14:00:00',5.46),('8902','2013-04-04','14:05:00',9.22),('8902','2013-04-04','14:10:00',8.45),('8902','2013-04-04','14:15:00',7.76),('8902','2013-04-04','14:20:00',7.76),('8902','2013-04-04','14:25:00',7.7),('8902','2013-04-04','14:30:00',8.37),('8902','2013-04-04','14:35:00',6.68),('8902','2013-04-04','14:40:00',6.91),('8902','2013-04-04','14:45:00',7.71),('8902','2013-04-04','14:50:00',4.53),('8902','2013-04-04','14:55:00',9.19),('8902','2013-04-04','15:00:00',8.85),('8902','2013-04-04','15:05:00',7.21),('8902','2013-04-04','15:10:00',6.74),('8902','2013-04-04','15:15:00',3.22),('8902','2013-04-04','15:20:00',3.22),('8902','2013-04-04','15:25:00',5.1),('8902','2013-04-04','15:30:00',4.17),('8902','2013-04-04','15:35:00',2.87),('8902','2013-04-04','15:40:00',2.34),('8902','2013-04-04','15:45:00',2.89),('8902','2013-04-04','15:50:00',4.13),('8902','2013-04-04','15:55:00',3.24),('8902','2013-04-04','16:00:00',3.44),('8902','2013-04-04','16:05:00',3.13),('8902','2013-04-04','16:10:00',3.07),('8902','2013-04-04','16:15:00',4.33),('8902','2013-04-04','16:20:00',4.94),('8902','2013-04-04','16:25:00',4.24),('8902','2013-04-04','16:30:00',3.1),('8902','2013-04-04','16:35:00',4.84),('8902','2013-04-04','16:40:00',3.06),('8902','2013-04-04','16:45:00',3.36),('8902','2013-04-04','16:50:00',5.85),('8902','2013-04-04','16:55:00',3.77),('8902','2013-04-04','17:00:00',2.84),('8902','2013-04-04','17:05:00',2.07),('8902','2013-04-04','17:10:00',3.72),('8902','2013-04-04','17:15:00',4.8),('8902','2013-04-04','17:20:00',4.75),('8902','2013-04-04','17:25:00',4.26),('8902','2013-04-04','17:30:00',3.95),('8902','2013-04-04','17:35:00',2.66),('8902','2013-04-04','17:40:00',3.29),('8902','2013-04-04','17:45:00',1.52),('8902','2013-04-04','17:50:00',1.47),('8902','2013-04-04','17:55:00',3.13),('8902','2013-04-04','18:00:00',2.49),('8902','2013-04-04','18:15:00',1.09),('8902','2013-04-04','18:20:00',1.45),('8902','2013-04-04','18:25:00',1.48),('8902','2013-04-04','18:30:00',1.21),('8902','2013-04-04','18:35:00',1.03),('8902','2013-04-03','08:00:00',1.02),('8902','2013-04-03','08:05:00',1.2),('8902','2013-04-03','08:10:00',1.05),('8902','2013-04-03','08:15:00',1.1),('8902','2013-04-03','08:20:00',1.12),('8902','2013-04-03','08:25:00',1.21),('8902','2013-04-03','08:30:00',1.26),('8902','2013-04-03','08:35:00',1.64),('8902','2013-04-03','08:40:00',1.53),('8902','2013-04-03','08:45:00',1.45),('8902','2013-04-03','08:50:00',1.45),('8902','2013-04-03','08:55:00',2.38),('8902','2013-04-03','09:00:00',3.46),('8902','2013-04-03','09:05:00',2.68),('8902','2013-04-03','09:10:00',2.38),('8902','2013-04-03','09:15:00',2.44),('8902','2013-04-03','09:20:00',2.46),('8902','2013-04-03','09:25:00',1.85),('8902','2013-04-03','09:30:00',2.63),('8902','2013-04-03','09:35:00',4.45),('8902','2013-04-03','09:40:00',4.42),('8902','2013-04-03','09:45:00',3.86),('8902','2013-04-03','09:50:00',2.11),('8902','2013-04-03','09:55:00',2.25),('8902','2013-04-03','10:00:00',3.34),('8902','2013-04-03','10:05:00',4.43),('8902','2013-04-03','10:10:00',4.03),('8902','2013-04-03','10:15:00',2.86),('8902','2013-04-03','10:20:00',3.2),('8902','2013-04-03','10:25:00',6.06),('8902','2013-04-03','10:30:00',5.78),('8902','2013-04-03','10:35:00',3.53),('8902','2013-04-03','10:40:00',7.01),('8902','2013-04-03','10:45:00',4.06),('8902','2013-04-03','10:50:00',4.08),('8902','2013-04-03','10:55:00',6.79),('8902','2013-04-03','11:00:00',4.42),('8902','2013-04-03','11:05:00',2.33),('8902','2013-04-03','11:10:00',1.97),('8902','2013-04-03','11:15:00',2.6),('8902','2013-04-03','11:20:00',2.6),('8902','2013-04-03','11:25:00',1.96),('8902','2013-04-03','11:30:00',2.16),('8902','2013-04-03','11:35:00',3.1),('8902','2013-04-03','11:40:00',5.31),('8902','2013-04-03','11:45:00',6.42),('8902','2013-04-03','11:50:00',7.22),('8902','2013-04-03','11:55:00',7.48),('8902','2013-04-03','12:00:00',7.55),('8902','2013-04-03','12:05:00',7.28),('8902','2013-04-03','12:10:00',7.45),('8902','2013-04-03','12:15:00',7.31),('8902','2013-04-03','12:20:00',6.24),('8902','2013-04-03','12:25:00',5.15),('8902','2013-04-03','12:30:00',6.53),('8902','2013-04-03','12:35:00',7.68),('8902','2013-04-03','12:40:00',5.72),('8902','2013-04-03','12:45:00',6.1),('8902','2013-04-03','12:50:00',7.95),('8902','2013-04-03','12:55:00',7.33),('8902','2013-04-03','13:00:00',7.18),('8902','2013-04-03','13:05:00',7.29),('8902','2013-04-03','13:10:00',7.44),('8902','2013-04-03','13:15:00',7.92),('8902','2013-04-03','13:20:00',7.67),('8902','2013-04-03','13:25:00',7.85),('8902','2013-04-03','13:30:00',7.7),('8902','2013-04-03','13:35:00',6.97),('8902','2013-04-03','13:40:00',5.93),('8902','2013-04-03','13:45:00',6.26),('8902','2013-04-03','13:50:00',6.2),('8902','2013-04-03','13:55:00',4.74),('8902','2013-04-03','14:00:00',4.91),('8902','2013-04-03','14:05:00',6.49),('8902','2013-04-03','14:10:00',7.41),('8902','2013-04-03','14:15:00',7.42),('8902','2013-04-03','14:20:00',7.32),('8902','2013-04-03','14:25:00',7.08),('8902','2013-04-03','14:30:00',7.14),('8902','2013-04-03','14:35:00',7.12),('8902','2013-04-03','14:40:00',7.17),('8902','2013-04-03','14:45:00',7.01),('8902','2013-04-03','14:50:00',6.92),('8902','2013-04-03','14:55:00',6.97),('8902','2013-04-03','15:00:00',6.86),('8902','2013-04-03','15:05:00',6.71),('8902','2013-04-03','15:10:00',6.34),('8902','2013-04-03','15:15:00',6.3),('8902','2013-04-03','15:20:00',6.39),('8902','2013-04-03','15:25:00',6.53),('8902','2013-04-03','15:30:00',6.37),('8902','2013-04-03','15:35:00',6.26),('8902','2013-04-03','15:40:00',6.1),('8902','2013-04-03','15:45:00',6.01),('8902','2013-04-03','15:50:00',5.77),('8902','2013-04-03','15:55:00',5.78),('8902','2013-04-03','16:00:00',5.67),('8902','2013-04-03','16:05:00',5.48),('8902','2013-04-03','16:10:00',5.22),('8902','2013-04-03','16:15:00',4.9),('8902','2013-04-03','16:20:00',4.52),('8902','2013-04-03','16:25:00',4.15),('8902','2013-04-03','16:30:00',3.72),('8902','2013-04-03','16:35:00',3.69),('8902','2013-04-03','16:40:00',3.67),('8902','2013-04-03','16:45:00',3.67),('8902','2013-04-03','16:50:00',2.98),('8902','2013-04-03','16:55:00',3.6),('8902','2013-04-03','17:00:00',3.31),('8902','2013-04-03','17:05:00',3.44),('8902','2013-04-03','17:10:00',3.08),('8902','2013-04-03','17:15:00',2.79),('8902','2013-04-03','17:20:00',2.04),('8902','2013-04-03','17:25:00',1.97),('8902','2013-04-03','17:30:00',1.47),('8902','2013-04-03','17:35:00',1.27),('8902','2013-04-03','17:40:00',1.51),('8902','2013-04-03','17:45:00',1.44),('8902','2013-04-03','17:50:00',1.75),('8902','2013-04-03','17:55:00',2.05),('8902','2013-04-03','18:00:00',1.66),('8902','2013-04-03','18:05:00',1.46),('8902','2013-04-02','08:00:00',1.01),('8902','2013-04-02','08:05:00',1.24),('8902','2013-04-02','08:10:00',1.43),('8902','2013-04-02','08:15:00',1.66),('8902','2013-04-02','08:20:00',1.9),('8902','2013-04-02','08:25:00',1.82),('8902','2013-04-02','08:30:00',2.28),('8902','2013-04-02','08:35:00',2.63),('8902','2013-04-02','08:40:00',2.04),('8902','2013-04-02','08:45:00',2.31),('8902','2013-04-02','08:50:00',1.36),('8902','2013-04-02','08:55:00',2.73),('8902','2013-04-02','09:00:00',3.42),('8902','2013-04-02','09:05:00',3.22),('8902','2013-04-02','09:10:00',3.62),('8902','2013-04-02','09:15:00',4.16),('8902','2013-04-02','09:20:00',4.49),('8902','2013-04-02','09:25:00',2.66),('8902','2013-04-02','09:30:00',2.41),('8902','2013-04-02','09:35:00',5.37),('8902','2013-04-02','09:40:00',5.38),('8902','2013-04-02','09:45:00',3.85),('8902','2013-04-02','09:50:00',4.36),('8902','2013-04-02','09:55:00',5.1),('8902','2013-04-02','10:00:00',5.42),('8902','2013-04-02','10:05:00',2.42),('8902','2013-04-02','10:10:00',2.02),('8902','2013-04-02','10:15:00',2.6),('8902','2013-04-02','10:20:00',5.56),('8902','2013-04-02','10:25:00',6.64),('8902','2013-04-02','10:30:00',5.74),('8902','2013-04-02','10:35:00',3.79),('8902','2013-04-02','10:40:00',3.42),('8902','2013-04-02','10:45:00',2.55),('8902','2013-04-02','10:50:00',3.92),('8902','2013-04-02','10:55:00',2.63),('8902','2013-04-02','11:00:00',5.43),('8902','2013-04-02','11:05:00',5.96),('8902','2013-04-02','11:10:00',6.64),('8902','2013-04-02','11:15:00',4.54),('8902','2013-04-02','11:20:00',6.32),('8902','2013-04-02','11:25:00',4.63),('8902','2013-04-02','11:30:00',3.18),('8902','2013-04-02','11:35:00',3.36),('8902','2013-04-02','11:40:00',4.5),('8902','2013-04-02','11:45:00',2.66),('8902','2013-04-02','11:50:00',5.71),('8902','2013-04-02','11:55:00',6.3),('8902','2013-04-02','12:00:00',4.97),('8902','2013-04-02','12:05:00',8.23),('8902','2013-04-02','12:10:00',7.91),('8902','2013-04-02','12:15:00',2.81),('8902','2013-04-02','12:20:00',6.9),('8902','2013-04-02','12:25:00',8.14),('8902','2013-04-02','12:30:00',8.53),('8902','2013-04-02','12:35:00',5.99),('8902','2013-04-02','12:40:00',8.66),('8902','2013-04-02','12:45:00',9.3),('8902','2013-04-02','12:50:00',7.93),('8902','2013-04-02','12:55:00',8.61),('8902','2013-04-02','13:00:00',7.95),('8902','2013-04-02','13:05:00',6.81),('8902','2013-04-02','13:10:00',6.03),('8902','2013-04-02','13:15:00',8.92),('8902','2013-04-02','13:20:00',7.59),('8902','2013-04-02','13:25:00',6.65),('8902','2013-04-02','13:30:00',5.09),('8902','2013-04-02','13:35:00',6.83),('8902','2013-04-02','13:40:00',6.3),('8902','2013-04-02','13:45:00',7.16),('8902','2013-04-02','13:50:00',6.93),('8902','2013-04-02','13:55:00',5.2),('8902','2013-04-02','14:00:00',7.64),('8902','2013-04-02','14:05:00',8.37),('8902','2013-04-02','14:10:00',7.78),('8902','2013-04-02','14:15:00',7.37),('8902','2013-04-02','14:20:00',6.43),('8902','2013-04-02','14:25:00',5.63),('8902','2013-04-02','14:30:00',7.13),('8902','2013-04-02','14:35:00',7.29),('8902','2013-04-02','14:40:00',6.75),('8902','2013-04-02','14:45:00',5.75),('8902','2013-04-02','14:50:00',4.68),('8902','2013-04-02','14:55:00',4.71),('8902','2013-04-02','15:00:00',7.31),('8902','2013-04-02','15:05:00',6.45),('8902','2013-04-02','15:10:00',6.97),('8902','2013-04-02','15:15:00',8.75),('8902','2013-04-02','15:20:00',7.19),('8902','2013-04-02','15:25:00',7.64),('8902','2013-04-02','15:30:00',5.47),('8902','2013-04-02','15:35:00',4.45),('8902','2013-04-02','15:40:00',6.83),('8902','2013-04-02','15:45:00',6.69),('8902','2013-04-02','15:50:00',7.59),('8902','2013-04-02','15:55:00',7.31),('8902','2013-04-02','16:00:00',7.11),('8902','2013-04-02','16:05:00',6.85),('8902','2013-04-02','16:10:00',6.75),('8902','2013-04-02','16:15:00',6.44),('8902','2013-04-02','16:20:00',6.3),('8902','2013-04-02','16:25:00',6.07),('8902','2013-04-02','16:30:00',5.97),('8902','2013-04-02','16:35:00',5.96),('8902','2013-04-02','16:40:00',5.59),('8902','2013-04-02','16:45:00',5.37),('8902','2013-04-02','16:50:00',5.24),('8902','2013-04-02','16:55:00',5.08),('8902','2013-04-02','17:00:00',4.91),('8902','2013-04-02','17:05:00',4.65),('8902','2013-04-02','17:10:00',4.53),('8902','2013-04-02','17:15:00',4.36),('8902','2013-04-02','17:20:00',4.15),('8902','2013-04-02','17:25:00',3.77),('8902','2013-04-02','17:30:00',3.71),('8902','2013-04-02','17:35:00',3.54),('8902','2013-04-02','17:40:00',3.28),('8902','2013-04-02','17:45:00',3.12),('8902','2013-04-02','17:50:00',2.94),('8902','2013-04-02','17:55:00',2.7),('8902','2013-04-02','18:00:00',2.52),('8902','2013-04-02','18:05:00',2.31),('8902','2013-04-02','18:10:00',2.06),('8902','2013-04-02','18:15:00',1.85),('8902','2013-04-02','18:20:00',1.64),('8902','2013-04-02','18:25:00',1.45),('8902','2013-04-02','18:30:00',1.3),('8902','2013-04-02','18:35:00',1.11),('8902','2013-04-01','08:35:00',1.16),('8902','2013-04-01','08:40:00',2.61),('8902','2013-04-01','08:45:00',3.08),('8902','2013-04-01','08:50:00',2.36),('8902','2013-04-01','08:55:00',1.87),('8902','2013-04-01','09:00:00',3.16),('8902','2013-04-01','09:05:00',3.36),('8902','2013-04-01','09:10:00',3.67),('8902','2013-04-01','09:15:00',3.7),('8902','2013-04-01','09:20:00',2.65),('8902','2013-04-01','09:25:00',2.01),('8902','2013-04-01','09:30:00',4.85),('8902','2013-04-01','09:35:00',4.2),('8902','2013-04-01','09:40:00',4.4),('8902','2013-04-01','09:45:00',4.78),('8902','2013-04-01','09:50:00',3.03),('8902','2013-04-01','09:55:00',2.99),('8902','2013-04-01','10:00:00',2.99),('8902','2013-04-01','10:05:00',5.02),('8902','2013-04-01','10:10:00',3.19),('8902','2013-04-01','10:15:00',3),('8902','2013-04-01','10:20:00',4.13),('8902','2013-04-01','10:25:00',3.26),('8902','2013-04-01','10:30:00',1.26),('8902','2013-04-01','10:35:00',2.31),('8902','2013-04-01','10:40:00',2.16),('8902','2013-04-01','10:45:00',5.8),('8902','2013-04-01','10:50:00',7.29),('8902','2013-04-01','10:55:00',4.13),('8902','2013-04-01','11:00:00',1.78),('8902','2013-04-01','11:05:00',4.67),('8902','2013-04-01','11:10:00',4.69),('8902','2013-04-01','11:15:00',2.29),('8902','2013-04-01','11:20:00',1.39),('8902','2013-04-01','11:25:00',2.19),('8902','2013-04-01','11:30:00',1.89),('8902','2013-04-01','11:35:00',3.18),('8902','2013-04-01','11:40:00',1.2),('8902','2013-04-01','11:45:00',2.85),('8902','2013-04-01','11:50:00',4.1),('8902','2013-04-01','11:55:00',2.78),('8902','2013-04-01','12:00:00',2.11),('8902','2013-04-01','12:05:00',4.17),('8902','2013-04-01','12:10:00',6.65),('8902','2013-04-01','12:15:00',4.99),('8902','2013-04-01','12:30:00',1.49),('8902','2013-04-01','12:35:00',3.14),('8902','2013-04-01','12:40:00',4.92),('8902','2013-04-01','12:45:00',4.73),('8902','2013-04-01','12:50:00',4.22),('8902','2013-04-01','12:55:00',4.18),('8902','2013-04-01','13:00:00',3.87),('8902','2013-04-01','13:05:00',4.69),('8902','2013-04-01','13:10:00',6.57),('8902','2013-04-01','13:15:00',4.24),('8902','2013-04-01','13:20:00',3.46),('8902','2013-04-01','13:25:00',6.25),('8902','2013-04-01','13:30:00',5.15),('8902','2013-04-01','13:35:00',3.54),('8902','2013-04-01','13:40:00',4.44),('8902','2013-04-01','13:45:00',4.8),('8902','2013-04-01','13:50:00',3.8),('8902','2013-04-01','13:55:00',3.26),('8902','2013-04-01','14:00:00',4.78),('8902','2013-04-01','14:05:00',4.83),('8902','2013-04-01','14:10:00',6.88),('8902','2013-04-01','14:15:00',4.98),('8902','2013-04-01','14:20:00',7.53),('8902','2013-04-01','14:25:00',9.38),('8902','2013-04-01','14:30:00',7.42),('8902','2013-04-01','14:35:00',3.58),('8902','2013-04-01','14:40:00',4.33),('8902','2013-04-01','14:45:00',4.28),('8902','2013-04-01','14:50:00',4.04),('8902','2013-04-01','14:55:00',3.1),('8902','2013-04-01','15:00:00',3.14),('8902','2013-04-01','15:05:00',1.47),('8902','2013-04-01','15:15:00',1.02),('8902','2013-04-01','15:20:00',1.6),('8902','2013-04-01','15:25:00',1.04),('8902','2013-04-01','15:30:00',1),('8902','2013-04-01','15:35:00',1.32),('8902','2013-04-01','15:40:00',1.6),('8902','2013-04-01','15:45:00',2.23),('8902','2013-04-01','15:50:00',1.04),('8902','2013-04-01','16:00:00',1.75),('8902','2013-04-01','16:05:00',2.16),('8902','2013-04-01','16:10:00',1.68),('8902','2013-04-01','16:15:00',1.92),('8902','2013-04-01','16:20:00',2.06),('8902','2013-04-01','16:25:00',1.72),('8902','2013-04-01','16:30:00',1.7),('8902','2013-04-01','16:35:00',1.93),('8902','2013-04-01','16:40:00',1.65),('8902','2013-04-01','16:45:00',1.6),('8902','2013-04-01','16:50:00',1.11),('8902','2013-04-01','16:55:00',1.29),('8902','2013-04-01','17:00:00',1.43),('8902','2013-04-01','17:05:00',1.37),('8902','2013-04-01','17:35:00',1.06),('8902','2013-04-01','17:40:00',2.14),('8902','2013-04-01','17:45:00',2.37),('8902','2014-05-01','07:15:00',1.09),('8902','2014-05-01','07:30:00',1.23),('8902','2014-05-01','07:35:00',1.21),('8902','2014-05-01','07:40:00',1.38),('8902','2014-05-01','07:45:00',1.56),('8902','2014-05-01','07:50:00',1.55),('8902','2014-05-01','08:00:00',1.45),('8902','2014-05-01','08:05:00',2.22),('8902','2014-05-01','08:10:00',1.55),('8902','2014-05-01','08:15:00',2.39),('8902','2014-05-01','08:20:00',3.33),('8902','2014-05-01','08:25:00',2.81),('8902','2014-05-01','08:30:00',2.43),('8902','2014-05-01','08:40:00',1.12),('8902','2014-05-01','08:45:00',1.84),('8902','2014-05-01','08:50:00',2.25),('8902','2014-05-01','08:55:00',1.35),('8902','2014-05-01','09:10:00',1.22),('8902','2014-05-01','09:15:00',1.88),('8902','2014-05-01','09:20:00',2.38),('8902','2014-05-01','09:25:00',2.63),('8902','2014-05-01','09:30:00',2.97),('8902','2014-05-01','09:35:00',3),('8902','2014-05-01','09:40:00',2.45),('8902','2014-05-01','09:45:00',2.6),('8902','2014-05-01','09:50:00',2.72),('8902','2014-05-01','09:55:00',2.7),('8902','2014-05-01','10:00:00',3.22),('8902','2014-05-01','10:05:00',3.11),('8902','2014-05-01','10:10:00',3.68),('8902','2014-05-01','10:15:00',3.44),('8902','2014-05-01','10:20:00',3.12),('8902','2014-05-01','10:25:00',2.16),('8902','2014-05-01','10:30:00',1.71),('8902','2014-05-01','10:35:00',1.62),('8902','2014-05-01','10:40:00',1.75),('8902','2014-05-01','10:45:00',2.13),('8902','2014-05-01','10:50:00',2.06),('8902','2014-05-01','10:55:00',1.68),('8902','2014-05-01','11:00:00',1.09),('8902','2014-05-01','11:25:00',1),('8902','2014-05-01','12:25:00',1.54),('8902','2014-05-01','12:30:00',1.95),('8902','2014-05-01','12:35:00',2.26),('8902','2014-05-01','12:40:00',1.96),('8902','2014-05-01','12:45:00',2.06),('8902','2014-05-01','12:50:00',3.13),('8902','2014-05-01','12:55:00',3.21),('8902','2014-05-01','13:00:00',2.94),('8902','2014-05-01','13:05:00',3.62),('8902','2014-05-01','13:10:00',3.92),('8902','2014-05-01','13:15:00',4.16),('8902','2014-05-01','13:20:00',6.18),('8902','2014-05-01','13:25:00',5.7),('8902','2014-05-01','13:30:00',4.95),('8902','2014-05-01','13:35:00',4.33),('8902','2014-05-01','13:40:00',4.47),('8902','2014-05-01','13:45:00',4.4),('8902','2014-05-01','13:50:00',2.72),('8902','2014-05-01','13:55:00',2.6),('8902','2014-05-01','14:00:00',2.58),('8902','2014-05-01','14:05:00',3.29),('8902','2014-05-01','14:10:00',2.73),('8902','2014-05-01','14:15:00',1.28),('8902','2014-05-01','14:25:00',1.39),('8902','2014-05-01','14:30:00',2.59),('8902','2014-05-01','14:35:00',3.71),('8902','2014-05-01','14:40:00',5.07),('8902','2014-05-01','14:45:00',4.51),('8902','2014-05-01','14:50:00',2.92),('8902','2014-05-01','14:55:00',3.65),('8902','2014-05-01','15:00:00',6.44),('8902','2014-05-01','15:05:00',4.73),('8902','2014-05-01','15:10:00',5.97),('8902','2014-05-01','15:15:00',7.98),('8902','2014-05-01','15:20:00',3.2),('8902','2014-05-01','15:25:00',2.42),('8902','2014-05-01','15:30:00',2.34),('8902','2014-05-01','15:35:00',4.93),('8902','2014-05-01','15:40:00',8.05),('8902','2014-05-01','15:45:00',3.19),('8902','2014-05-01','15:50:00',1.45),('8902','2014-05-01','15:55:00',1.57),('8902','2014-05-01','16:00:00',2.08),('8902','2014-05-01','16:05:00',3.39),('8902','2014-05-01','16:10:00',2.44),('8902','2014-05-01','16:15:00',1.42),('8902','2014-05-01','16:20:00',5.29),('8902','2014-05-01','16:25:00',1.37),('8902','2014-05-01','17:05:00',1.47),('8902','2014-05-01','17:10:00',1.33),('8902','2014-05-01','17:15:00',1.68),('8902','2014-05-01','17:20:00',2.07),('8902','2014-05-01','17:25:00',2.44),('8902','2014-05-01','17:30:00',1.88),('8902','2014-05-01','17:35:00',1.4),('8902','2014-05-01','17:40:00',1.18),('8902','2014-03-26','07:40:00',1.12),('8902','2014-03-26','07:45:00',1.37),('8902','2014-03-26','07:50:00',1.52),('8902','2014-03-26','07:55:00',2.1),('8902','2014-03-26','08:00:00',2.58),('8902','2014-03-26','08:05:00',2.6),('8902','2014-03-26','08:10:00',1.29),('8902','2014-03-26','09:10:00',1.26),('8902','2014-03-26','09:15:00',1.6),('8902','2014-03-26','09:20:00',1.57),('8902','2014-03-26','09:25:00',1.47),('8902','2014-03-26','09:30:00',1.25),('8902','2014-03-26','09:50:00',1.08),('8902','2014-03-26','09:55:00',1.55),('8902','2014-03-26','10:00:00',1.79),('8902','2014-03-26','10:05:00',1.9),('8902','2014-03-26','10:10:00',2.6),('8902','2014-03-26','10:15:00',2.02),('8902','2014-03-26','10:20:00',2.9),('8902','2014-03-26','10:25:00',3.48),('8902','2014-03-26','10:30:00',4.3),('8902','2014-03-26','10:35:00',3.76),('8902','2014-03-26','10:40:00',4.74),('8902','2014-03-26','10:45:00',2.8),('8902','2014-03-26','10:50:00',1.42),('8902','2014-03-26','10:55:00',1.32),('8902','2014-03-26','11:00:00',1.61),('8902','2014-03-26','11:05:00',1.2),('8902','2014-03-26','11:10:00',4.86),('8902','2014-03-26','11:15:00',9.05),('8902','2014-03-26','11:20:00',4.53),('8902','2014-03-26','11:25:00',1.63),('8902','2014-03-26','11:30:00',1.36),('8902','2014-03-26','11:50:00',1.68),('8902','2014-03-26','11:55:00',2.7),('8902','2014-03-26','12:00:00',2.89),('8902','2014-03-26','12:05:00',1.8),('8902','2014-03-26','12:10:00',3.2),('8902','2014-03-26','12:15:00',2.37),('8902','2014-03-26','12:20:00',2.06),('8902','2014-03-26','12:25:00',1.1),('8902','2014-03-26','12:50:00',1.31),('8902','2014-03-26','12:55:00',1.67),('8902','2014-03-26','13:00:00',1.78),('8902','2014-03-26','13:05:00',1.91),('8902','2014-03-26','13:10:00',2.81),('8902','2014-03-26','13:15:00',3.88),('8902','2014-03-26','13:20:00',4.31),('8902','2014-03-26','13:25:00',4.7),('8902','2014-03-26','13:30:00',4.06),('8902','2014-03-26','13:35:00',3.77),('8902','2014-03-26','13:40:00',3.54),('8902','2014-03-26','13:45:00',3.3),('8902','2014-03-26','13:50:00',4.11),('8902','2014-03-26','13:55:00',5.33),('8902','2014-03-26','14:00:00',5.14),('8902','2014-03-26','14:05:00',2.35),('8902','2014-03-26','14:10:00',1.74),('8902','2014-03-26','14:15:00',4.23),('8902','2014-03-26','14:20:00',6.66),('8902','2014-03-26','14:25:00',7.33),('8902','2014-03-26','14:30:00',6.33),('8902','2014-03-26','14:35:00',5.23),('8902','2014-03-26','14:40:00',3.37),('8902','2014-03-26','14:45:00',3.19),('8902','2014-03-26','14:50:00',4.07),('8902','2014-03-26','14:55:00',5.42),('8902','2014-03-26','15:00:00',3.67),('8902','2014-03-26','15:05:00',3.47),('8902','2014-03-26','15:10:00',1.09),('8902','2014-03-26','15:20:00',2.09),('8902','2014-03-26','15:25:00',4.61),('8902','2014-03-26','15:30:00',4.9),('8902','2014-03-26','15:35:00',2.45),('8902','2014-03-26','15:40:00',1.6),('8902','2014-03-26','15:45:00',1.21),('8902','2014-03-26','15:50:00',1.94),('8902','2014-03-26','15:55:00',1.91),('8902','2014-03-26','16:00:00',1.55),('8902','2014-03-26','16:05:00',1.87),('8902','2014-03-26','16:10:00',2.47),('8902','2014-03-26','16:15:00',2.5),('8902','2014-03-26','16:20:00',1.78),('8902','2014-03-26','16:25:00',2.09),('8902','2014-03-26','16:30:00',2.22),('8902','2014-03-26','16:35:00',1.68),('8902','2014-03-26','16:40:00',1.87),('8902','2014-03-26','16:45:00',1.88),('8902','2014-03-26','16:50:00',1.14),('8902','2014-03-26','16:55:00',1.29),('8902','2014-03-26','17:00:00',1.46),('8902','2014-03-26','17:05:00',1.36),('8902','2014-03-26','17:10:00',1.07),('8902','2014-03-26','17:15:00',1.08),('8902','2013-03-31','08:20:00',1.36),('8902','2013-03-31','08:25:00',1.9),('8902','2013-03-31','08:30:00',2),('8902','2013-03-31','08:35:00',2.28),('8902','2013-03-31','08:40:00',2.99),('8902','2013-03-31','08:45:00',2.05),('8902','2013-03-31','08:50:00',2.99),('8902','2013-03-31','08:55:00',3.26),('8902','2013-03-31','09:00:00',3.2),('8902','2013-03-31','09:05:00',3.42),('8902','2013-03-31','09:10:00',3.76),('8902','2013-03-31','09:15:00',4.04),('8902','2013-03-31','09:20:00',3.87),('8902','2013-03-31','09:25:00',4.18),('8902','2013-03-31','09:30:00',4.6),('8902','2013-03-31','09:35:00',2.24),('8902','2013-03-31','09:40:00',4.57),('8902','2013-03-31','09:45:00',5.09),('8902','2013-03-31','09:50:00',5),('8902','2013-03-31','09:55:00',4.7),('8902','2013-03-31','10:00:00',5.22),('8902','2013-03-31','10:05:00',5.46),('8902','2013-03-31','10:10:00',5.17),('8902','2013-03-31','10:15:00',5.17),('8902','2013-03-31','10:20:00',6.14),('8902','2013-03-31','10:25:00',5.35),('8902','2013-03-31','10:30:00',5.1),('8902','2013-03-31','10:35:00',2.34),('8902','2013-03-31','10:40:00',4.24),('8902','2013-03-31','10:45:00',6.93),('8902','2013-03-31','10:50:00',1.98),('8902','2013-03-31','10:55:00',1.74),('8902','2013-03-31','11:00:00',2.07),('8902','2013-03-31','11:05:00',2.52),('8902','2013-03-31','11:10:00',4.43),('8902','2013-03-31','11:15:00',4.47),('8902','2013-03-31','11:20:00',5.37),('8902','2013-03-31','11:25:00',6.06),('8902','2013-03-31','11:30:00',4.38),('8902','2013-03-31','11:35:00',3.52),('8902','2013-03-31','11:40:00',6.02),('8902','2013-03-31','11:45:00',6.07),('8902','2013-03-31','11:50:00',4.96),('8902','2013-03-31','11:55:00',4.15),('8902','2013-03-31','12:00:00',5.63),('8902','2013-03-31','12:05:00',3.82),('8902','2013-03-31','12:10:00',4.51),('8902','2013-03-31','12:15:00',3.82),('8902','2013-03-31','12:20:00',3.34),('8902','2013-03-31','12:25:00',3.5),('8902','2013-03-31','12:30:00',4.77),('8902','2013-03-31','12:35:00',4.55),('8902','2013-03-31','12:40:00',4.4),('8902','2013-03-31','12:45:00',5.03),('8902','2013-03-31','12:50:00',5.33),('8902','2013-03-31','12:55:00',5.91),('8902','2013-03-31','13:00:00',5.55),('8902','2013-03-31','13:05:00',6.14),('8902','2013-03-31','13:10:00',5.41),('8902','2013-03-31','13:15:00',5.61),('8902','2013-03-31','13:20:00',5.39),('8902','2013-03-31','13:25:00',5.07),('8902','2013-03-31','13:30:00',5.82),('8902','2013-03-31','13:35:00',5.06),('8902','2013-03-31','13:40:00',6.45),('8902','2013-03-31','13:45:00',7.15),('8902','2013-03-31','13:50:00',8.06),('8902','2013-03-31','13:55:00',7.81),('8902','2013-03-31','14:00:00',4.63),('8902','2013-03-31','14:05:00',3.43),('8902','2013-03-31','14:10:00',4.37),('8902','2013-03-31','14:15:00',4.95),('8902','2013-03-31','14:20:00',5.06),('8902','2013-03-31','14:25:00',8.23),('8902','2013-03-31','14:30:00',5.35),('8902','2013-03-31','14:35:00',4.25),('8902','2013-03-31','14:40:00',3.81),('8902','2013-03-31','14:45:00',3.6),('8902','2013-03-31','14:50:00',3.92),('8902','2013-03-31','14:55:00',4.29),('8902','2013-03-31','15:00:00',3.77),('8902','2013-03-31','15:05:00',3.76),('8902','2013-03-31','15:10:00',3.81),('8902','2013-03-31','15:15:00',4.11),('8902','2013-03-31','15:20:00',4.31),('8902','2013-03-31','15:25:00',4.35),('8902','2013-03-31','15:30:00',3.85),('8902','2013-03-31','15:35:00',5.07),('8902','2013-03-31','15:40:00',4.73),('8902','2013-03-31','15:45:00',4.83),('8902','2013-03-31','15:50:00',5.53),('8902','2013-03-31','15:55:00',4.2),('8902','2013-03-31','16:00:00',3.77),('8902','2013-03-31','16:05:00',3.03),('8902','2013-03-31','16:10:00',2.49),('8902','2013-03-31','16:15:00',2.01),('8902','2013-03-31','16:20:00',1.87),('8902','2013-03-31','16:25:00',1.71),('8902','2013-03-31','16:30:00',1.46),('8902','2013-03-31','16:35:00',1.51),('8902','2013-03-31','16:40:00',1.41),('8902','2013-03-31','16:45:00',1.19),('8902','2013-03-30','08:20:00',1.49),('8902','2013-03-30','08:25:00',1.16),('8902','2013-03-30','08:30:00',1.69),('8902','2013-03-30','08:35:00',2.07),('8902','2013-03-30','08:40:00',1.87),('8902','2013-03-30','08:45:00',2.16),('8902','2013-03-30','08:50:00',1.77),('8902','2013-03-30','08:55:00',1.9),('8902','2013-03-30','09:00:00',2.21),('8902','2013-03-30','09:05:00',2),('8902','2013-03-30','09:10:00',2.07),('8902','2013-03-30','09:15:00',2.02),('8902','2013-03-30','09:20:00',3.94),('8902','2013-03-30','09:25:00',4.94),('8902','2013-03-30','09:30:00',3.82),('8902','2013-03-30','09:35:00',3.35),('8902','2013-03-30','09:40:00',2.19),('8902','2013-03-30','09:45:00',4.62),('8902','2013-03-30','09:50:00',2.51),('8902','2013-03-30','09:55:00',3.44),('8902','2013-03-30','10:00:00',4.33),('8902','2013-03-30','10:05:00',1.46),('8902','2013-03-30','10:15:00',1.63),('8902','2013-03-30','10:20:00',3.53),('8902','2013-03-30','10:25:00',4.8),('8902','2013-03-30','10:30:00',5.49),('8902','2013-03-30','10:35:00',5.5),('8902','2013-03-30','10:40:00',1.42),('8902','2013-03-30','10:45:00',2.02),('8902','2013-03-30','10:50:00',3.57),('8902','2013-03-30','10:55:00',2.17),('8902','2013-03-30','11:00:00',1.37),('8902','2013-03-30','11:05:00',1.36),('8902','2013-03-30','11:10:00',2.74),('8902','2013-03-30','11:15:00',2.66),('8902','2013-03-30','11:20:00',2.2),('8902','2013-03-30','11:25:00',2.64),('8902','2013-03-30','11:30:00',1.88),('8902','2013-03-30','11:35:00',2.49),('8902','2013-03-30','11:40:00',3.05),('8902','2013-03-30','11:45:00',2.38),('8902','2013-03-30','11:50:00',2.66),('8902','2013-03-30','11:55:00',3.1),('8902','2013-03-30','12:00:00',2.8),('8902','2013-03-30','12:05:00',2.59),('8902','2013-03-30','12:10:00',2.48),('8902','2013-03-30','12:15:00',2.55),('8902','2013-03-30','12:20:00',2.49),('8902','2013-03-30','12:25:00',2.79),('8902','2013-03-30','12:30:00',3.33),('8902','2013-03-30','12:35:00',5.73),('8902','2013-03-30','12:40:00',4.59),('8902','2013-03-30','12:45:00',2.85),('8902','2013-03-30','12:50:00',2.94),('8902','2013-03-30','12:55:00',3.66),('8902','2013-03-30','13:00:00',4.49),('8902','2013-03-30','13:05:00',4.52),('8902','2013-03-30','13:10:00',5.19),('8902','2013-03-30','13:15:00',4.07),('8902','2013-03-30','13:20:00',6.51),('8902','2013-03-30','13:25:00',6.07),('8902','2013-03-30','13:30:00',1.53),('8902','2013-03-30','13:35:00',1.47),('8902','2013-03-30','13:40:00',2.54),('8902','2013-03-30','13:45:00',3.57),('8902','2013-03-30','13:50:00',3.91),('8902','2013-03-30','13:55:00',4),('8902','2013-03-30','14:00:00',3.11),('8902','2013-03-30','14:05:00',6.29),('8902','2013-03-30','14:10:00',3.88),('8902','2013-03-30','14:15:00',7.09),('8902','2013-03-30','14:20:00',2.96),('8902','2013-03-30','14:25:00',3.1),('8902','2013-03-30','14:30:00',6.8),('8902','2013-03-30','14:35:00',8.59),('8902','2013-03-30','14:40:00',8.95),('8902','2013-03-30','14:45:00',6.29),('8902','2013-03-30','14:50:00',7.01),('8902','2013-03-30','14:55:00',5.99),('8902','2013-03-30','15:00:00',5.07),('8902','2013-03-30','15:05:00',3.67),('8902','2013-03-30','15:10:00',5.84),('8902','2013-03-30','15:15:00',5.3),('8902','2013-03-30','15:20:00',8.65),('8902','2013-03-30','15:25:00',5.35),('8902','2013-03-30','15:30:00',4.35),('8902','2013-03-30','15:35:00',6.53),('8902','2013-03-30','15:40:00',8.16),('8902','2013-03-30','15:45:00',5.8),('8902','2013-03-30','15:50:00',2.07),('8902','2013-03-30','15:55:00',1.45),('8902','2013-03-30','16:00:00',5.36),('8902','2013-03-30','16:05:00',2.81),('8902','2013-03-30','16:10:00',2.59),('8902','2013-03-30','16:15:00',3.52),('8902','2013-03-30','16:20:00',3.36),('8902','2013-03-30','16:25:00',2.45),('8902','2013-03-30','16:30:00',1.96),('8902','2013-03-30','16:35:00',2.06),('8902','2013-03-30','16:40:00',2.23),('8902','2013-03-30','16:45:00',1.86),('8902','2013-03-30','16:50:00',1.71),('8902','2013-03-30','16:55:00',1.48),('8902','2013-03-30','17:00:00',2.36),('8902','2013-03-30','17:05:00',4.67),('8902','2013-03-30','17:10:00',3.74),('8902','2013-03-30','17:15:00',2.26),('8902','2013-03-30','17:20:00',2.06),('8902','2013-03-30','17:25:00',2.3),('8902','2013-03-30','17:30:00',2.45),('8902','2013-03-30','17:35:00',2.38),('8902','2013-03-30','17:40:00',1.6),('8902','2013-03-30','17:45:00',1.58),('8902','2013-03-30','17:50:00',1.71),('8902','2013-03-30','17:55:00',2.71),('8902','2013-03-30','18:00:00',1.65),('8902','2013-03-30','18:15:00',2.24),('8902','2013-03-30','18:20:00',1.51),('8902','2013-03-29','07:30:00',1.04),('8902','2013-03-29','07:50:00',1.23),('8902','2013-03-29','07:55:00',1.7),('8902','2013-03-29','08:00:00',1.35),('8902','2013-03-29','08:05:00',1.17),('8902','2013-03-29','08:10:00',1.19),('8902','2013-03-29','08:15:00',1.56),('8902','2013-03-29','08:20:00',1.57),('8902','2013-03-29','08:25:00',1.63),('8902','2013-03-29','08:30:00',1.66),('8902','2013-03-29','08:35:00',2.02),('8902','2013-03-29','08:40:00',2.03),('8902','2013-03-29','08:45:00',1.71),('8902','2013-03-29','08:50:00',1.67),('8902','2013-03-29','08:55:00',1.43),('8902','2013-03-29','09:00:00',1.49),('8902','2013-03-29','09:05:00',3.23),('8902','2013-03-29','09:10:00',3.01),('8902','2013-03-29','09:15:00',3.34),('8902','2013-03-29','09:20:00',7.19),('8902','2013-03-29','09:25:00',5.39),('8902','2013-03-29','09:30:00',2.48),('8902','2013-03-29','09:35:00',2.97),('8902','2013-03-29','09:40:00',2.55),('8902','2013-03-29','09:45:00',2.28),('8902','2013-03-29','09:50:00',1.8),('8902','2013-03-29','09:55:00',2.23),('8902','2013-03-29','10:00:00',2.89),('8902','2013-03-29','10:05:00',3.09),('8902','2013-03-29','10:10:00',3.43),('8902','2013-03-29','10:15:00',3.19),('8902','2013-03-29','10:20:00',2.72),('8902','2013-03-29','10:25:00',2.62),('8902','2013-03-29','10:30:00',3.03),('8902','2013-03-29','10:35:00',3.66),('8902','2013-03-29','10:40:00',4.75),('8902','2013-03-29','10:45:00',5.99),('8902','2013-03-29','10:50:00',6.84),('8902','2013-03-29','10:55:00',4.28),('8902','2013-03-29','11:00:00',5.51),('8902','2013-03-29','11:05:00',7.19),('8902','2013-03-29','11:10:00',8.96),('8902','2013-03-29','11:15:00',5.51),('8902','2013-03-29','11:20:00',9.34),('8902','2013-03-29','11:25:00',9.4),('8902','2013-03-29','11:30:00',6.43),('8902','2013-03-29','11:35:00',5.77),('8902','2013-03-29','11:40:00',4.13),('8902','2013-03-29','11:45:00',6.67),('8902','2013-03-29','11:50:00',7.43),('8902','2013-03-29','11:55:00',6.2),('8902','2013-03-29','12:00:00',8.77),('8902','2013-03-29','12:05:00',4.84),('8902','2013-03-29','12:10:00',3.72),('8902','2013-03-29','12:15:00',3.64),('8902','2013-03-29','12:20:00',3.56),('8902','2013-03-29','12:25:00',2.32),('8902','2013-03-29','12:30:00',2.18),('8902','2013-03-29','12:35:00',1.96),('8902','2013-03-29','12:40:00',1.12),('8902','2013-03-29','12:45:00',1.57),('8902','2013-03-29','12:50:00',1.74),('8902','2013-03-29','13:05:00',1.19),('8902','2013-03-29','13:10:00',1.77),('8902','2013-03-29','13:15:00',4.3),('8902','2013-03-29','13:20:00',4.37),('8902','2013-03-29','13:25:00',2.66),('8902','2013-03-29','13:30:00',1.54),('8902','2013-03-29','13:35:00',1.24),('8902','2013-03-29','13:40:00',1.22),('8902','2013-03-29','13:45:00',2.05),('8902','2013-03-29','13:50:00',4.04),('8902','2013-03-29','13:55:00',6.41),('8902','2013-03-29','14:00:00',4.64),('8902','2013-03-29','14:05:00',4.93),('8902','2013-03-29','14:10:00',2.25),('8902','2013-03-29','14:15:00',2.96),('8902','2013-03-29','14:20:00',3.95),('8902','2013-03-29','14:25:00',2.69),('8902','2013-03-29','14:30:00',2.8),('8902','2013-03-29','14:35:00',3.24),('8902','2013-03-29','14:40:00',2.13),('8902','2013-03-29','14:45:00',2.27),('8902','2013-03-29','14:50:00',3.04),('8902','2013-03-29','14:55:00',1.94),('8902','2013-03-29','15:00:00',1.65),('8902','2013-03-29','15:05:00',1.31),('8902','2013-03-29','15:10:00',1.22),('8902','2013-03-29','15:15:00',1.26),('8902','2013-03-29','15:20:00',1.66),('8902','2013-03-29','15:25:00',1.66),('8902','2013-03-29','15:30:00',1.3),('8902','2013-03-29','15:35:00',1.15),('8902','2013-03-29','15:40:00',1.52),('8902','2013-03-29','15:45:00',1.32),('8902','2013-03-29','15:50:00',1.34),('8902','2013-03-29','15:55:00',1.16),('8902','2013-03-28','07:10:00',1.14),('8902','2013-03-28','07:15:00',1.32),('8902','2013-03-28','07:20:00',1.51),('8902','2013-03-28','07:25:00',1.75),('8902','2013-03-28','07:30:00',2),('8902','2013-03-28','07:35:00',1.76),('8902','2013-03-28','07:40:00',2.2),('8902','2013-03-28','07:45:00',2.38),('8902','2013-03-28','07:50:00',2.83),('8902','2013-03-28','07:55:00',1.88),('8902','2013-03-28','08:00:00',2.55),('8902','2013-03-28','08:05:00',2.93),('8902','2013-03-28','08:10:00',3.51),('8902','2013-03-28','08:15:00',3.51),('8902','2013-03-28','08:20:00',3.68),('8902','2013-03-28','08:25:00',3.87),('8902','2013-03-28','08:30:00',4.08),('8902','2013-03-28','08:35:00',4.23),('8902','2013-03-28','08:40:00',4.37),('8902','2013-03-28','08:45:00',4.4),('8902','2013-03-28','08:50:00',4.24),('8902','2013-03-28','08:55:00',4.36),('8902','2013-03-28','09:00:00',4.31),('8902','2013-03-28','09:05:00',4.72),('8902','2013-03-28','09:10:00',4.92),('8902','2013-03-28','09:15:00',5.47),('8902','2013-03-28','09:20:00',5.86),('8902','2013-03-28','09:25:00',5.46),('8902','2013-03-28','09:30:00',6.07),('8902','2013-03-28','09:35:00',6.23),('8902','2013-03-28','09:40:00',6),('8902','2013-03-28','09:45:00',5.72),('8902','2013-03-28','09:50:00',5.98),('8902','2013-03-28','09:55:00',6.14),('8902','2013-03-28','10:00:00',6.28),('8902','2013-03-28','10:05:00',5.69),('8902','2013-03-28','10:10:00',5.05),('8902','2013-03-28','10:15:00',6.28),('8902','2013-03-28','10:20:00',5.86),('8902','2013-03-28','10:25:00',5.75),('8902','2013-03-28','10:30:00',5.89),('8902','2013-03-28','10:35:00',6.49),('8902','2013-03-28','10:40:00',5.46),('8902','2013-03-28','10:45:00',4.58),('8902','2013-03-28','10:50:00',6.52),('8902','2013-03-28','10:55:00',6.71),('8902','2013-03-28','11:00:00',7.73),('8902','2013-03-28','11:05:00',7.54),('8902','2013-03-28','11:10:00',8.28),('8902','2013-03-28','11:15:00',7.98),('8902','2013-03-28','11:20:00',4.87),('8902','2013-03-28','11:26:00',4.11),('8902','2013-03-28','11:30:00',7.65),('8902','2013-03-28','11:35:00',6.49),('8902','2013-03-28','11:40:00',8.2),('8902','2013-03-28','11:45:00',8.15),('8902','2013-03-28','11:50:00',8.18),('8902','2013-03-28','11:55:00',8.21),('8902','2013-03-28','12:00:00',8.26),('8902','2013-03-28','12:05:00',8.4),('8902','2013-03-28','12:10:00',8.34),('8902','2013-03-28','12:15:00',7.71),('8902','2013-03-28','12:20:00',8.26),('8902','2013-03-28','12:25:00',8.05),('8902','2013-03-28','12:30:00',7.43),('8902','2013-03-28','12:35:00',7.76),('8902','2013-03-28','12:40:00',7.74),('8902','2013-03-28','12:45:00',6.34),('8902','2013-03-28','12:50:00',6.52),('8902','2013-03-28','12:55:00',6.01),('8902','2013-03-28','13:00:00',6.15),('8902','2013-03-28','13:05:00',4.87),('8902','2013-03-28','13:10:00',7.77),('8902','2013-03-28','13:15:00',6.65),('8902','2013-03-28','13:20:00',6.6),('8902','2013-03-28','13:25:00',8.3),('8902','2013-03-28','13:30:00',7.44),('8902','2013-03-28','13:35:00',6.34),('8902','2013-03-28','13:40:00',6.41),('8902','2013-03-28','13:45:00',6.77),('8902','2013-03-28','13:50:00',6.5),('8902','2013-03-28','13:55:00',6.68),('8902','2013-03-28','14:00:00',6.52),('8902','2013-03-28','14:05:00',5.93),('8902','2013-03-28','14:10:00',4.45),('8902','2013-03-28','14:15:00',4.71),('8902','2013-03-28','14:20:00',4.78),('8902','2013-03-28','14:25:00',4.85),('8902','2013-03-28','14:30:00',4.1),('8902','2013-03-28','14:35:00',4.09),('8902','2013-03-28','14:40:00',3.86),('8902','2013-03-28','14:45:00',3.59),('8902','2013-03-28','14:50:00',3.4),('8902','2013-03-28','14:55:00',3.29),('8902','2013-03-28','15:00:00',2.92),('8902','2013-03-28','15:05:00',2.99),('8902','2013-03-28','15:10:00',2.83),('8902','2013-03-28','15:15:00',2.74),('8902','2013-03-28','15:20:00',2.63),('8902','2013-03-28','15:25:00',2.34),('8902','2013-03-28','15:30:00',2.14),('8902','2013-03-28','15:35:00',2.04),('8902','2013-03-28','15:40:00',1.96),('8902','2013-03-28','15:45:00',1.9),('8902','2013-03-28','15:50:00',2.01),('8902','2013-03-28','15:55:00',2.34),('8902','2013-03-28','16:00:00',3.1),('8902','2013-03-28','16:05:00',2.84),('8902','2013-03-28','16:10:00',2.25),('8902','2013-03-28','16:15:00',1.86),('8902','2013-03-28','16:20:00',1.7),('8902','2013-03-28','16:25:00',1.86),('8902','2013-03-28','16:30:00',2.2),('8902','2013-03-28','16:35:00',1.96),('8902','2013-03-28','16:40:00',3.95),('8902','2013-03-28','16:45:00',3.27),('8902','2013-03-28','16:50:00',2.38),('8902','2013-03-28','16:55:00',1.8),('8902','2013-03-28','17:00:00',2.13),('8902','2013-03-28','17:05:00',1.77),('8902','2013-03-28','17:10:00',1.04),('8902','2013-03-28','17:15:00',1.04),('8902','2013-03-28','17:20:00',1.58),('8902','2013-03-28','17:25:00',1.63),('8902','2013-03-28','17:30:00',1.42),('8902','2013-03-28','17:35:00',1.14),('8902','2013-03-27','07:40:00',1.03),('8902','2013-03-27','07:45:00',1.05),('8902','2013-03-27','08:45:00',1.01),('8902','2013-03-27','08:50:00',1.11),('8902','2013-03-27','08:55:00',1.32),('8902','2013-03-27','09:00:00',1.42),('8902','2013-03-27','09:05:00',1.97),('8902','2013-03-27','09:10:00',3.18),('8902','2013-03-27','09:15:00',6.25),('8902','2013-03-27','09:20:00',2.96),('8902','2013-03-27','09:25:00',2.83),('8902','2013-03-27','09:30:00',2.09),('8902','2013-03-27','09:35:00',1.82),('8902','2013-03-27','09:40:00',1.54),('8902','2013-03-27','09:45:00',1.81),('8902','2013-03-27','09:50:00',1.95),('8902','2013-03-27','09:55:00',2.06),('8902','2013-03-27','10:00:00',2.22),('8902','2013-03-27','10:05:00',1.65),('8902','2013-03-27','10:10:00',1.16),('8902','2013-03-27','10:15:00',1.2),('8902','2013-03-27','10:25:00',1.02),('8902','2013-03-27','10:30:00',1.07),('8902','2013-03-27','10:35:00',1.02),('8902','2013-03-27','10:55:00',1.4),('8902','2013-03-27','11:00:00',2.08),('8902','2013-03-27','11:05:00',1.58),('8902','2013-03-27','11:10:00',1.12),('8902','2013-03-27','11:20:00',1.07),('8902','2013-03-27','11:25:00',1.37),('8902','2013-03-27','11:30:00',1.7),('8902','2013-03-27','11:35:00',2.63),('8902','2013-03-27','11:40:00',3.5),('8902','2013-03-27','11:45:00',2.53),('8902','2013-03-27','11:50:00',2.49),('8902','2013-03-27','11:55:00',4.11),('8902','2013-03-27','12:00:00',3.41),('8902','2013-03-27','12:05:00',2.39),('8902','2013-03-27','12:10:00',2.36),('8902','2013-03-27','12:15:00',2.32),('8902','2013-03-27','12:20:00',2.4),('8902','2013-03-27','12:25:00',2.19),('8902','2013-03-27','12:30:00',2.03),('8902','2013-03-27','12:35:00',1.75),('8902','2013-03-27','12:40:00',2.36),('8902','2013-03-27','12:45:00',3.1),('8902','2013-03-27','12:50:00',6.03),('8902','2013-03-27','12:55:00',6.22),('8902','2013-03-27','13:00:00',6.15),('8902','2013-03-27','13:05:00',6.86),('8902','2013-03-27','13:10:00',6.79),('8902','2013-03-27','13:15:00',7.54),('8902','2013-03-27','13:20:00',7.11),('8902','2013-03-27','13:25:00',7.17),('8902','2013-03-27','13:30:00',6.25),('8902','2013-03-27','13:35:00',5.29),('8902','2013-03-27','13:40:00',4.6),('8902','2013-03-27','13:45:00',3.68),('8902','2013-03-27','13:50:00',5.56),('8902','2013-03-27','13:55:00',3.56),('8902','2013-03-27','14:00:00',3.75),('8902','2013-03-27','14:05:00',4.32),('8902','2013-03-27','14:10:00',3.22),('8902','2013-03-27','14:15:00',2.93),('8902','2013-03-27','14:20:00',2.83),('8902','2013-03-27','14:25:00',3.7),('8902','2013-03-27','14:30:00',3.79),('8902','2013-03-27','14:35:00',3.32),('8902','2013-03-27','14:40:00',2.52),('8902','2013-03-27','14:45:00',2.42),('8902','2013-03-27','14:50:00',2.14),('8902','2013-03-27','14:55:00',1.71),('8902','2013-03-27','15:00:00',2.2),('8902','2013-03-27','15:05:00',2.51),('8902','2013-03-27','15:10:00',4.04),('8902','2013-03-27','15:15:00',4.03),('8902','2013-03-27','15:20:00',4.42),('8902','2013-03-27','15:25:00',4.23),('8902','2013-03-27','15:30:00',2.89),('8902','2013-03-27','15:35:00',4.98),('8902','2013-03-27','15:40:00',3.66),('8902','2013-03-27','15:45:00',3.85),('8902','2013-03-27','15:50:00',2.56),('8902','2013-03-27','15:55:00',5.03),('8902','2013-03-27','16:00:00',2.98),('8902','2013-03-27','16:05:00',1.58),('8902','2013-03-27','16:10:00',3.88),('8902','2013-03-27','16:15:00',1.57),('8902','2013-03-27','16:25:00',1.29),('8902','2013-03-27','16:30:00',1.57),('8902','2013-03-27','16:35:00',3.34),('8902','2013-03-27','16:40:00',1.86),('8902','2013-03-27','16:45:00',2.25),('8902','2013-03-27','16:50:00',1.21),('8902','2013-03-27','16:55:00',1.26),('8902','2013-03-27','17:00:00',2.76),('8902','2013-03-27','17:05:00',2.44),('8902','2013-03-27','17:10:00',2.06),('8902','2013-03-27','17:15:00',1.75),('8902','2013-03-27','17:20:00',1.45),('8902','2013-03-27','17:25:00',1.18),('8902','2013-03-26','07:10:00',1.11),('8902','2013-03-26','07:15:00',1.27),('8902','2013-03-26','07:20:00',1.46),('8902','2013-03-26','07:25:00',1.62),('8902','2013-03-26','07:30:00',1.78),('8902','2013-03-26','07:35:00',1.87),('8902','2013-03-26','07:40:00',1.99),('8902','2013-03-26','07:45:00',1.26),('8902','2013-03-26','07:50:00',1.15),('8902','2013-03-26','07:55:00',2.23),('8902','2013-03-26','08:00:00',2.34),('8902','2013-03-26','08:05:00',2.74),('8902','2013-03-26','08:10:00',2.37),('8902','2013-03-26','08:15:00',2.66),('8902','2013-03-26','08:20:00',2.36),('8902','2013-03-26','08:25:00',2.6),('8902','2013-03-26','08:30:00',3.58),('8902','2013-03-26','08:35:00',3.21),('8902','2013-03-26','08:40:00',2.51),('8902','2013-03-26','08:45:00',2.3),('8902','2013-03-26','08:50:00',2.47),('8902','2013-03-26','08:55:00',2.62),('8902','2013-03-26','09:00:00',2.5),('8902','2013-03-26','09:05:00',2.17),('8902','2013-03-26','09:10:00',1.71),('8902','2013-03-26','09:15:00',3.49),('8902','2013-03-26','09:20:00',4.02),('8902','2013-03-26','09:25:00',2.75),('8902','2013-03-26','09:30:00',2.04),('8902','2013-03-26','09:35:00',1.64),('8902','2013-03-26','09:40:00',1.88),('8902','2013-03-26','09:45:00',3.36),('8902','2013-03-26','09:50:00',5.05),('8902','2013-03-26','09:55:00',3.38),('8902','2013-03-26','10:00:00',3.43),('8902','2013-03-26','10:05:00',2.25),('8902','2013-03-26','10:10:00',2.85),('8902','2013-03-26','10:15:00',3.37),('8902','2013-03-26','10:20:00',3.03),('8902','2013-03-26','10:25:00',3.45),('8902','2013-03-26','10:30:00',4.01),('8902','2013-03-26','10:35:00',3.05),('8902','2013-03-26','10:40:00',3.31),('8902','2013-03-26','10:45:00',4.04),('8902','2013-03-26','10:50:00',3.52),('8902','2013-03-26','10:55:00',3.61),('8902','2013-03-26','11:00:00',2.87),('8902','2013-03-26','11:05:00',3),('8902','2013-03-26','11:10:00',3.31),('8902','2013-03-26','11:15:00',3.46),('8902','2013-03-26','11:20:00',3.56),('8902','2013-03-26','11:25:00',3.32),('8902','2013-03-26','11:30:00',3.72),('8902','2013-03-26','11:35:00',3.52),('8902','2013-03-26','11:40:00',3.46),('8902','2013-03-26','11:45:00',3.35),('8902','2013-03-26','11:50:00',3.28),('8902','2013-03-26','11:55:00',4.81),('8902','2013-03-26','12:00:00',5.82),('8902','2013-03-26','12:05:00',5.76),('8902','2013-03-26','12:10:00',5.26),('8902','2013-03-26','12:15:00',3.62),('8902','2013-03-26','12:20:00',3.91),('8902','2013-03-26','12:25:00',3.17),('8902','2013-03-26','12:30:00',5.64),('8902','2013-03-26','12:35:00',8.21),('8902','2013-03-26','12:40:00',9.2),('8902','2013-03-26','12:45:00',8.57),('8902','2013-03-26','12:50:00',6.54),('8902','2013-03-26','12:55:00',5.25),('8902','2013-03-26','13:00:00',3.01),('8902','2013-03-26','13:05:00',5.19),('8902','2013-03-26','13:10:00',5.24),('8902','2013-03-26','13:15:00',3.64),('8902','2013-03-26','13:20:00',2.82),('8902','2013-03-26','13:25:00',2.64),('8902','2013-03-26','13:30:00',4.33),('8902','2013-03-26','13:35:00',4.62),('8902','2013-03-26','13:40:00',3.79),('8902','2013-03-26','13:45:00',4.42),('8902','2013-03-26','13:50:00',5.3),('8902','2013-03-26','13:55:00',5.08),('8902','2013-03-26','14:00:00',3.66),('8902','2013-03-26','14:05:00',2.91),('8902','2013-03-26','14:10:00',3.09),('8902','2013-03-26','14:15:00',3.49),('8902','2013-03-26','14:20:00',4.06),('8902','2013-03-26','14:25:00',3.5),('8902','2013-03-26','14:30:00',2.87),('8902','2013-03-26','14:35:00',3.13),('8902','2013-03-26','14:40:00',4.46),('8902','2013-03-26','14:45:00',4.59),('8902','2013-03-26','14:50:00',3.05),('8902','2013-03-26','14:55:00',2.51),('8902','2013-03-26','15:00:00',2.15),('8902','2013-03-26','15:05:00',2.66),('8902','2013-03-26','15:10:00',3.05),('8902','2013-03-26','15:15:00',2.01),('8902','2013-03-26','15:20:00',1.97),('8902','2013-03-26','15:25:00',2.04),('8902','2013-03-26','15:30:00',1.48),('8902','2013-03-26','15:35:00',1.34),('8902','2013-03-26','15:40:00',1.09),('8902','2013-03-26','15:55:00',1.13),('8902','2013-03-26','16:00:00',1.16),('8902','2013-03-26','16:05:00',1.25),('8902','2013-03-26','16:10:00',1.43),('8902','2013-03-26','16:15:00',1.46),('8902','2013-03-26','16:20:00',1.37),('8902','2013-03-26','16:25:00',1.46),('8902','2013-03-26','16:30:00',1.49),('8902','2013-03-26','16:35:00',1.5),('8902','2013-03-26','16:40:00',1.77),('8902','2013-03-26','16:45:00',2.12),('8902','2013-03-26','16:50:00',1.87),('8902','2013-03-26','16:55:00',2.16),('8902','2013-03-26','17:00:00',2.19),('8902','2013-03-26','17:05:00',2.57),('8902','2013-03-26','17:10:00',2.31),('8902','2013-03-26','17:15:00',1.39),('8902','2013-03-25','07:15:00',1.02),('8902','2013-03-25','07:20:00',1.04),('8902','2013-03-25','07:35:00',1.05),('8902','2013-03-25','07:40:00',1.32),('8902','2013-03-25','07:45:00',1.8),('8902','2013-03-25','07:50:00',3.1),('8902','2013-03-25','07:55:00',3.41),('8902','2013-03-25','08:00:00',1.25),('8902','2013-03-25','08:05:00',1.03),('8902','2013-03-25','08:10:00',1.23),('8902','2013-03-25','08:15:00',1.22),('8902','2013-03-25','08:20:00',1.18),('8902','2013-03-25','08:25:00',1.25),('8902','2013-03-25','08:30:00',1.61),('8902','2013-03-25','08:35:00',2.49),('8902','2013-03-25','08:40:00',2.75),('8902','2013-03-25','08:45:00',1.65),('8902','2013-03-25','08:50:00',1.09),('8902','2013-03-25','08:55:00',1.05),('8902','2013-03-25','09:05:00',1.26),('8902','2013-03-25','09:10:00',1.83),('8902','2013-03-25','09:15:00',2.96),('8902','2013-03-25','09:20:00',2.05),('8902','2013-03-25','09:25:00',1.16),('8902','2013-03-25','09:50:00',1.32),('8902','2013-03-25','09:55:00',4.31),('8902','2013-03-25','10:00:00',2.66),('8902','2013-03-25','10:05:00',1.01),('8902','2013-03-25','10:10:00',1.33),('8902','2013-03-25','10:25:00',1.28),('8902','2013-03-25','10:40:00',1.09),('8902','2013-03-25','10:45:00',1.07),('8902','2013-03-25','10:50:00',1.62),('8902','2013-03-25','10:55:00',1.56),('8902','2013-03-25','11:00:00',1.97),('8902','2013-03-25','11:05:00',2.05),('8902','2013-03-25','11:10:00',4.39),('8902','2013-03-25','11:15:00',4.26),('8902','2013-03-25','11:20:00',3.65),('8902','2013-03-25','11:25:00',1.97),('8902','2013-03-25','11:30:00',1.4),('8902','2013-03-25','11:45:00',1.51),('8902','2013-03-25','11:50:00',3.43),('8902','2013-03-25','11:55:00',1.99),('8902','2013-03-25','12:00:00',1.81),('8902','2013-03-25','12:05:00',2.18),('8902','2013-03-25','12:10:00',2.35),('8902','2013-03-25','12:15:00',2.61),('8902','2013-03-25','12:20:00',2.75),('8902','2013-03-25','12:25:00',4.06),('8902','2013-03-25','12:30:00',3.59),('8902','2013-03-25','12:35:00',5.68),('8902','2013-03-25','12:40:00',4.21),('8902','2013-03-25','12:45:00',5.17),('8902','2013-03-25','12:50:00',3.7),('8902','2013-03-25','12:55:00',2.01),('8902','2013-03-25','13:00:00',2.87),('8902','2013-03-25','13:05:00',4.62),('8902','2013-03-25','13:10:00',4.82),('8902','2013-03-25','13:15:00',3.78),('8902','2013-03-25','13:20:00',2.53),('8902','2013-03-25','13:25:00',3.91),('8902','2013-03-25','13:30:00',3.17),('8902','2013-03-25','13:35:00',3.29),('8902','2013-03-25','13:40:00',4.06),('8902','2013-03-25','13:45:00',3.65),('8902','2013-03-25','13:50:00',3.21),('8902','2013-03-25','13:55:00',3.01),('8902','2013-03-25','14:00:00',2.91),('8902','2013-03-25','14:05:00',2.74),('8902','2013-03-25','14:10:00',2.77),('8902','2013-03-25','14:15:00',2.57),('8902','2013-03-25','14:20:00',2.26),('8902','2013-03-25','14:25:00',1.96),('8902','2013-03-25','14:30:00',1.68),('8902','2013-03-25','14:35:00',1.53),('8902','2013-03-25','14:40:00',1.61),('8902','2013-03-25','14:45:00',1.68),('8902','2013-03-25','14:50:00',1.5),('8902','2013-03-25','14:55:00',1.49),('8902','2013-03-25','15:00:00',1.46),('8902','2013-03-25','15:05:00',1.53),('8902','2013-03-25','15:10:00',1.53),('8902','2013-03-25','15:15:00',1.34),('8902','2013-03-25','15:20:00',1.47),('8902','2013-03-25','15:25:00',1.46),('8902','2013-03-25','15:30:00',1.59),('8902','2013-03-25','15:35:00',1.75),('8902','2013-03-25','15:40:00',1.54),('8902','2013-03-25','15:45:00',1.03),('8902','2013-03-25','15:50:00',1.07),('8902','2013-03-24','08:10:00',1.02),('8902','2013-03-24','08:15:00',1.59),('8902','2013-03-24','08:20:00',2.67),('8902','2013-03-24','08:25:00',2.85),('8902','2013-03-24','08:30:00',2.86),('8902','2013-03-24','08:35:00',1.03),('8902','2013-03-24','08:40:00',1.16),('8902','2013-03-24','08:45:00',1.9),('8902','2013-03-24','08:50:00',1.67),('8902','2013-03-24','08:55:00',2.03),('8902','2013-03-24','09:00:00',2.12),('8902','2013-03-24','09:05:00',2.01),('8902','2013-03-24','09:10:00',1.98),('8902','2013-03-24','09:15:00',1.92),('8902','2013-03-24','09:20:00',4.62),('8902','2013-03-24','09:25:00',5.84),('8902','2013-03-24','09:30:00',2.56),('8902','2013-03-24','09:35:00',1.75),('8902','2013-03-24','09:40:00',1.26),('8902','2013-03-24','09:45:00',1.38),('8902','2013-03-24','09:50:00',5.47),('8902','2013-03-24','09:55:00',6.6),('8902','2013-03-24','10:00:00',7.19),('8902','2013-03-24','10:05:00',3.55),('8902','2013-03-24','10:10:00',1.64),('8902','2013-03-24','10:15:00',1.87),('8902','2013-03-24','10:20:00',2.91),('8902','2013-03-24','10:25:00',4.45),('8902','2013-03-24','10:30:00',4.49),('8902','2013-03-24','10:35:00',2.91),('8902','2013-03-24','10:40:00',3.11),('8902','2013-03-24','10:45:00',4.45),('8902','2013-03-24','10:50:00',4.59),('8902','2013-03-24','10:55:00',4.16),('8902','2013-03-24','11:00:00',4.19),('8902','2013-03-24','11:05:00',3.41),('8902','2013-03-24','11:10:00',3.89),('8902','2013-03-24','11:15:00',5.32),('8902','2013-03-24','11:20:00',8.23),('8902','2013-03-24','11:25:00',6.76),('8902','2013-03-24','11:30:00',5.34),('8902','2013-03-24','11:35:00',6.62),('8902','2013-03-24','11:40:00',3.09),('8902','2013-03-24','11:45:00',3.26),('8902','2013-03-24','11:50:00',4),('8902','2013-03-24','11:55:00',6.42),('8902','2013-03-24','12:00:00',7.15),('8902','2013-03-24','12:05:00',6.16),('8902','2013-03-24','12:10:00',9.97),('8902','2013-03-24','12:15:00',7.22),('8902','2013-03-24','12:20:00',4.61),('8902','2013-03-24','12:25:00',6.69),('8902','2013-03-24','12:30:00',8.06),('8902','2013-03-24','12:35:00',6),('8902','2013-03-24','12:40:00',4.77),('8902','2013-03-24','12:45:00',4.88),('8902','2013-03-24','12:50:00',6.16),('8902','2013-03-24','12:55:00',4.8),('8902','2013-03-24','13:00:00',4.68),('8902','2013-03-24','13:05:00',9.1),('8902','2013-03-24','13:10:00',8.69),('8902','2013-03-24','13:15:00',5.36),('8902','2013-03-24','13:20:00',8.43),('8902','2013-03-24','13:25:00',4.28),('8902','2013-03-24','13:30:00',5.46),('8902','2013-03-24','13:35:00',2.31),('8902','2013-03-24','13:40:00',2.28),('8902','2013-03-24','13:45:00',3.19),('8902','2013-03-24','13:50:00',4.28),('8902','2013-03-24','13:55:00',3.71),('8902','2013-03-24','14:00:00',2.08),('8902','2013-03-24','14:05:00',2.01),('8902','2013-03-24','14:10:00',4.15),('8902','2013-03-24','14:15:00',4.01),('8902','2013-03-24','14:20:00',4.55),('8902','2013-03-24','14:25:00',9.24),('8902','2013-03-24','14:30:00',6.62),('8902','2013-03-24','14:35:00',4.79),('8902','2013-03-24','14:40:00',3.2),('8902','2013-03-24','14:45:00',3.18),('8902','2013-03-24','14:50:00',3.09),('8902','2013-03-24','14:55:00',4.34),('8902','2013-03-24','15:00:00',4.34),('8902','2013-03-24','15:05:00',4.82),('8902','2013-03-24','15:10:00',5.23),('8902','2013-03-24','15:15:00',4.73),('8902','2013-03-24','15:20:00',3.91),('8902','2013-03-24','15:25:00',5.93),('8902','2013-03-24','15:30:00',4.25),('8902','2013-03-24','15:35:00',4.81),('8902','2013-03-24','15:40:00',6.39),('8902','2013-03-24','15:45:00',4.63),('8902','2013-03-24','15:50:00',2.38),('8902','2013-03-24','15:55:00',1.91),('8902','2013-03-24','16:00:00',4.6),('8902','2013-03-24','16:05:00',2.47),('8902','2013-03-24','16:10:00',2.33),('8902','2013-03-24','16:15:00',2.56),('8902','2013-03-24','16:20:00',1.54),('8902','2013-03-24','16:25:00',1.12),('8902','2013-03-24','16:30:00',1.94),('8902','2013-03-24','16:35:00',3.47),('8902','2013-03-24','16:40:00',3.95),('8902','2013-03-24','16:45:00',2.22),('8902','2013-03-24','16:50:00',1.34),('8902','2013-03-24','16:55:00',1.08),('8902','2013-03-23','07:20:00',1.27),('8902','2013-03-23','07:25:00',1.35),('8902','2013-03-23','07:30:00',1.34),('8902','2013-03-23','07:35:00',1.49),('8902','2013-03-23','07:40:00',1.57),('8902','2013-03-23','07:45:00',1.74),('8902','2013-03-23','07:50:00',2),('8902','2013-03-23','07:55:00',2.32),('8902','2013-03-23','08:00:00',2.74),('8902','2013-03-23','08:05:00',2.92),('8902','2013-03-23','08:10:00',3.04),('8902','2013-03-23','08:15:00',3.28),('8902','2013-03-23','08:20:00',3.47),('8902','2013-03-23','08:25:00',3.66),('8902','2013-03-23','08:30:00',3.82),('8902','2013-03-23','08:35:00',3.95),('8902','2013-03-23','08:40:00',4.11),('8902','2013-03-23','08:45:00',4.25),('8902','2013-03-23','08:50:00',4.34),('8902','2013-03-23','08:55:00',4.48),('8902','2013-03-23','09:00:00',4.62),('8902','2013-03-23','09:05:00',4.81),('8902','2013-03-23','09:10:00',4.96),('8902','2013-03-23','09:15:00',5.06),('8902','2013-03-23','09:20:00',5.19),('8902','2013-03-23','09:25:00',5.34),('8902','2013-03-23','09:30:00',5.44),('8902','2013-03-23','09:35:00',5.56),('8902','2013-03-23','09:40:00',5.63),('8902','2013-03-23','09:45:00',5.76),('8902','2013-03-23','09:50:00',5.92),('8902','2013-03-23','09:55:00',6.02),('8902','2013-03-23','10:00:00',6.14),('8902','2013-03-23','10:05:00',6.28),('8902','2013-03-23','10:10:00',6.4),('8902','2013-03-23','10:15:00',6.49),('8902','2013-03-23','10:20:00',6.54),('8902','2013-03-23','10:25:00',6.61),('8902','2013-03-23','10:30:00',6.68),('8902','2013-03-23','10:35:00',6.73),('8902','2013-03-23','10:40:00',6.81),('8902','2013-03-23','10:45:00',6.86),('8902','2013-03-23','10:50:00',6.89),('8902','2013-03-23','10:55:00',6.95),('8902','2013-03-23','11:00:00',6.98),('8902','2013-03-23','11:05:00',7.05),('8902','2013-03-23','11:10:00',7.11),('8902','2013-03-23','11:15:00',7.15),('8902','2013-03-23','11:20:00',7.15),('8902','2013-03-23','11:25:00',7.19),('8902','2013-03-23','11:30:00',7.22),('8902','2013-03-23','11:35:00',7.24),('8902','2013-03-23','11:40:00',7.29),('8902','2013-03-23','11:45:00',7.35),('8902','2013-03-23','11:50:00',7.39),('8902','2013-03-23','11:55:00',7.44),('8902','2013-03-23','12:00:00',7.49),('8902','2013-03-23','12:05:00',7.48),('8902','2013-03-23','12:10:00',7.59),('8902','2013-03-23','12:15:00',7.7),('8902','2013-03-23','12:20:00',7.85),('8902','2013-03-23','12:25:00',7.92),('8902','2013-03-23','12:30:00',7.92),('8902','2013-03-23','12:35:00',8.01),('8902','2013-03-23','12:40:00',7.97),('8902','2013-03-23','12:45:00',7.96),('8902','2013-03-23','12:50:00',7.98),('8902','2013-03-23','12:55:00',7.86),('8902','2013-03-23','13:00:00',7.82),('8902','2013-03-23','13:05:00',7.86),('8902','2013-03-23','13:10:00',7.83),('8902','2013-03-23','13:15:00',7.82),('8902','2013-03-23','13:20:00',7.78),('8902','2013-03-23','13:25:00',7.62),('8902','2013-03-23','13:30:00',7.53),('8902','2013-03-23','13:35:00',7.55),('8902','2013-03-23','13:40:00',7.55),('8902','2013-03-23','13:45:00',7.52),('8902','2013-03-23','13:50:00',7.46),('8902','2013-03-23','13:55:00',7.36),('8902','2013-03-23','14:00:00',7.28),('8902','2013-03-23','14:05:00',7.2),('8902','2013-03-23','14:10:00',7.07),('8902','2013-03-23','14:15:00',7),('8902','2013-03-23','14:20:00',6.9),('8902','2013-03-23','14:25:00',6.79),('8902','2013-03-23','14:30:00',6.62),('8902','2013-03-23','14:35:00',6.39),('8902','2013-03-23','14:40:00',6.32),('8902','2013-03-23','14:45:00',6.27),('8902','2013-03-23','14:50:00',6.01),('8902','2013-03-23','14:55:00',5.91),('8902','2013-03-23','15:00:00',5.78),('8902','2013-03-23','15:05:00',5.68),('8902','2013-03-23','15:10:00',5.42),('8902','2013-03-23','15:15:00',5.78),('8902','2013-03-23','15:20:00',5.6),('8902','2013-03-23','15:25:00',5.2),('8902','2013-03-23','15:30:00',4.64),('8902','2013-03-23','15:35:00',4.68),('8902','2013-03-23','15:40:00',4.65),('8902','2013-03-23','15:45:00',3.78),('8902','2013-03-23','15:50:00',2.76),('8902','2013-03-23','15:55:00',2.57),('8902','2013-03-23','16:00:00',2.42),('8902','2013-03-23','16:05:00',2.89),('8902','2013-03-23','16:10:00',2.02),('8902','2013-03-23','16:15:00',2.81),('8902','2013-03-23','16:20:00',2.19),('8902','2013-03-23','16:25:00',2.04),('8902','2013-03-23','16:30:00',2.27),('8902','2013-03-23','16:35:00',2.06),('8902','2013-03-23','16:40:00',1.6),('8902','2013-03-23','16:45:00',1.5),('8902','2013-03-23','16:50:00',1.23),('8902','2013-03-22','07:15:00',1.17),('8902','2013-03-22','07:20:00',1.34),('8902','2013-03-22','07:25:00',1.43),('8902','2013-03-22','07:30:00',1.52),('8902','2013-03-22','07:35:00',1.62),('8902','2013-03-22','07:40:00',1.85),('8902','2013-03-22','07:45:00',1.89),('8902','2013-03-22','07:50:00',2.09),('8902','2013-03-22','07:55:00',2.38),('8902','2013-03-22','08:00:00',2.65),('8902','2013-03-22','08:05:00',2.94),('8902','2013-03-22','08:10:00',3.11),('8902','2013-03-22','08:15:00',3.29),('8902','2013-03-22','08:20:00',3.48),('8902','2013-03-22','08:25:00',3.64),('8902','2013-03-22','08:30:00',3.75),('8902','2013-03-22','08:35:00',3.93),('8902','2013-03-22','08:40:00',4.13),('8902','2013-03-22','08:45:00',4.33),('8902','2013-03-22','08:50:00',4.49),('8902','2013-03-22','08:55:00',4.75),('8902','2013-03-22','09:00:00',4.87),('8902','2013-03-22','09:05:00',5.06),('8902','2013-03-22','09:10:00',5.13),('8902','2013-03-22','09:15:00',5.26),('8902','2013-03-22','09:20:00',5.4),('8902','2013-03-22','09:25:00',5.6),('8902','2013-03-22','09:30:00',5.67),('8902','2013-03-22','09:35:00',5.73),('8902','2013-03-22','09:40:00',5.65),('8902','2013-03-22','09:45:00',5.88),('8902','2013-03-22','09:50:00',5.84),('8902','2013-03-22','09:55:00',6.04),('8902','2013-03-22','10:00:00',5.97),('8902','2013-03-22','10:05:00',6.22),('8902','2013-03-22','10:10:00',6.6),('8902','2013-03-22','10:15:00',6.6),('8902','2013-03-22','10:20:00',6.47),('8902','2013-03-22','10:25:00',6.49),('8902','2013-03-22','10:30:00',6.91),('8902','2013-03-22','10:35:00',6.9),('8902','2013-03-22','10:40:00',6.94),('8902','2013-03-22','10:45:00',6.93),('8902','2013-03-22','10:50:00',7),('8902','2013-03-22','10:55:00',6.75),('8902','2013-03-22','11:00:00',6.62),('8902','2013-03-22','11:05:00',6.53),('8902','2013-03-22','11:10:00',5.24),('8902','2013-03-22','11:15:00',5.52),('8902','2013-03-22','11:20:00',7.12),('8902','2013-03-22','11:25:00',7),('8902','2013-03-22','11:30:00',6.95),('8902','2013-03-22','11:35:00',7.34),('8902','2013-03-22','11:40:00',7.46),('8902','2013-03-22','11:45:00',7.42),('8902','2013-03-22','11:50:00',7.19),('8902','2013-03-22','11:55:00',7.53),('8902','2013-03-22','12:00:00',7.57),('8902','2013-03-22','12:05:00',7.53),('8902','2013-03-22','12:10:00',7.46),('8902','2013-03-22','12:15:00',7.62),('8902','2013-03-22','12:20:00',7.71),('8902','2013-03-22','12:25:00',7.6),('8902','2013-03-22','12:30:00',7.8),('8902','2013-03-22','12:35:00',7.83),('8902','2013-03-22','12:40:00',7.48),('8902','2013-03-22','12:45:00',7.55),('8902','2013-03-22','12:50:00',7.74),('8902','2013-03-22','12:55:00',7.62),('8902','2013-03-22','13:00:00',6.01),('8902','2013-03-22','13:05:00',7.68),('8902','2013-03-22','13:10:00',7.64),('8902','2013-03-22','13:15:00',7.28),('8902','2013-03-22','13:20:00',7.37),('8902','2013-03-22','13:25:00',7.46),('8902','2013-03-22','13:30:00',7.11),('8902','2013-03-22','13:35:00',5.99),('8902','2013-03-22','13:40:00',6.05),('8902','2013-03-22','13:45:00',7.17),('8902','2013-03-22','13:50:00',7.06),('8902','2013-03-22','13:55:00',7.1),('8902','2013-03-22','14:00:00',6.96),('8902','2013-03-22','14:05:00',7.04),('8902','2013-03-22','14:10:00',6.82),('8902','2013-03-22','14:15:00',6.63),('8902','2013-03-22','14:20:00',6.81),('8902','2013-03-22','14:25:00',6.74),('8902','2013-03-22','14:30:00',6.74),('8902','2013-03-22','14:35:00',6.56),('8902','2013-03-22','14:40:00',6.41),('8902','2013-03-22','14:45:00',6.02),('8902','2013-03-22','14:50:00',5.94),('8902','2013-03-22','14:55:00',6),('8902','2013-03-22','15:00:00',5.78),('8902','2013-03-22','15:05:00',5.43),('8902','2013-03-22','15:10:00',5.7),('8902','2013-03-22','15:15:00',5.32),('8902','2013-03-22','15:20:00',5.35),('8902','2013-03-22','15:25:00',5.31),('8902','2013-03-22','15:30:00',4.86),('8902','2013-03-22','15:35:00',4.84),('8902','2013-03-22','15:40:00',4.49),('8902','2013-03-22','15:45:00',4.21),('8902','2013-03-22','15:50:00',3.92),('8902','2013-03-22','15:55:00',3.86),('8902','2013-03-22','16:00:00',3.6),('8902','2013-03-22','16:05:00',3.12),('8902','2013-03-22','16:10:00',4.07),('8902','2013-03-22','16:15:00',3.65),('8902','2013-03-22','16:20:00',3.13),('8902','2013-03-22','16:25:00',3.21),('8902','2013-03-22','16:30:00',2.41),('8902','2013-03-22','16:35:00',2.58),('8902','2013-03-22','16:40:00',2.25),('8902','2013-03-22','16:45:00',2.28),('8902','2013-03-22','16:50:00',1.88),('8902','2013-03-22','16:55:00',1.84),('8902','2013-03-22','17:00:00',2.11),('8902','2013-03-22','17:05:00',2.19),('8902','2013-03-22','17:10:00',1.85),('8902','2013-03-22','17:15:00',1.48),('8902','2013-03-22','17:20:00',1.31),('8902','2013-03-22','17:25:00',1.18),('8902','2014-03-25','07:10:00',1.04),('8902','2014-03-25','07:15:00',1.24),('8902','2014-03-25','07:20:00',1.42),('8902','2014-03-25','07:25:00',1.63),('8902','2014-03-25','07:30:00',1.8),('8902','2014-03-25','07:35:00',1.98),('8902','2014-03-25','07:40:00',2.16),('8902','2014-03-25','07:45:00',2.31),('8902','2014-03-25','07:50:00',2.5),('8902','2014-03-25','07:55:00',2.66),('8902','2014-03-25','08:00:00',2.88),('8902','2014-03-25','08:05:00',3.09),('8902','2014-03-25','08:10:00',3.37),('8902','2014-03-25','08:15:00',3.77),('8902','2014-03-25','08:20:00',4.12),('8902','2014-03-25','08:25:00',2.4),('8902','2014-03-25','08:30:00',2.13),('8902','2014-03-25','08:35:00',1.76),('8902','2014-03-25','08:40:00',2.02),('8902','2014-03-25','08:45:00',2.27),('8902','2014-03-25','08:50:00',2.71),('8902','2014-03-25','08:55:00',2.45),('8902','2014-03-25','09:00:00',2.61),('8902','2014-03-25','09:05:00',2.57),('8902','2014-03-25','09:10:00',2.98),('8902','2014-03-25','09:15:00',2.5),('8902','2014-03-25','09:20:00',2.15),('8902','2014-03-25','09:25:00',2.54),('8902','2014-03-25','09:30:00',6.4),('8902','2014-03-25','09:35:00',6.23),('8902','2014-03-25','09:40:00',6.28),('8902','2014-03-25','09:45:00',6.38),('8902','2014-03-25','09:50:00',6.51),('8902','2014-03-25','09:55:00',6.74),('8902','2014-03-25','10:00:00',5.88),('8902','2014-03-25','10:05:00',6.78),('8902','2014-03-25','10:10:00',7.01),('8902','2014-03-25','10:15:00',7.57),('8902','2014-03-25','10:20:00',7.8),('8902','2014-03-25','10:25:00',7.79),('8902','2014-03-25','10:30:00',7.18),('8902','2014-03-25','10:35:00',6.52),('8902','2014-03-25','10:40:00',2.24),('8902','2014-03-25','10:45:00',6.21),('8902','2014-03-25','10:50:00',6.19),('8902','2014-03-25','10:55:00',6.43),('8902','2014-03-25','11:00:00',8.32),('8902','2014-03-25','11:05:00',7.72),('8902','2014-03-25','11:10:00',8.75),('8902','2014-03-25','11:15:00',9.05),('8902','2014-03-25','11:20:00',5.09),('8902','2014-03-25','11:25:00',2.43),('8902','2014-03-25','11:30:00',3.09),('8902','2014-03-25','11:35:00',3.7),('8902','2014-03-25','11:40:00',3.62),('8902','2014-03-25','11:45:00',4.57),('8902','2014-03-25','11:50:00',6.53),('8902','2014-03-25','11:55:00',7.19),('8902','2014-03-25','12:00:00',9.58),('8902','2014-03-25','12:05:00',8.47),('8902','2014-03-25','12:10:00',6.65),('8902','2014-03-25','12:15:00',2.95),('8902','2014-03-25','12:20:00',3.46),('8902','2014-03-25','12:25:00',3.44),('8902','2014-03-25','12:30:00',3.34),('8902','2014-03-25','12:35:00',3.31),('8902','2014-03-25','12:40:00',3.5),('8902','2014-03-25','12:45:00',4.21),('8902','2014-03-25','12:50:00',2.97),('8902','2014-03-25','12:55:00',2.51),('8902','2014-03-25','13:00:00',2.33),('8902','2014-03-25','13:05:00',2.38),('8902','2014-03-25','13:10:00',1.93),('8902','2014-03-25','13:15:00',1.41),('8902','2014-03-25','13:20:00',1.9),('8902','2014-03-25','13:25:00',8.45),('8902','2014-03-25','13:30:00',8.5),('8902','2014-03-25','13:35:00',5.1),('8902','2014-03-25','13:40:00',4.68),('8902','2014-03-25','13:45:00',1.67),('8902','2014-03-25','13:50:00',1.51),('8902','2014-03-25','13:55:00',3.35),('8902','2014-03-25','14:00:00',3.96),('8902','2014-03-25','14:05:00',7.18),('8902','2014-03-25','14:10:00',7.57),('8902','2014-03-25','14:15:00',2.75),('8902','2014-03-25','14:20:00',2),('8902','2014-03-25','14:25:00',1.54),('8902','2014-03-25','14:30:00',1.33),('8902','2014-03-25','14:35:00',1.2),('8902','2014-03-25','14:40:00',1.22),('8902','2014-03-25','14:45:00',3.42),('8902','2014-03-25','14:50:00',6.81),('8902','2014-03-25','14:55:00',7.15),('8902','2014-03-25','15:00:00',6.07),('8902','2014-03-25','15:05:00',6.58),('8902','2014-03-25','15:10:00',6.74),('8902','2014-03-25','15:15:00',6.99),('8902','2014-03-25','15:20:00',6.48),('8902','2014-03-25','15:25:00',6.66),('8902','2014-03-25','15:30:00',6.65),('8902','2014-03-25','15:35:00',6.51),('8902','2014-03-25','15:40:00',4.86),('8902','2014-03-25','15:45:00',5.32),('8902','2014-03-25','15:50:00',3.97),('8902','2014-03-25','15:55:00',3.97),('8902','2014-03-25','16:00:00',2.66),('8902','2014-03-25','16:05:00',2.26),('8902','2014-03-25','16:10:00',2.36),('8902','2014-03-25','16:15:00',2.23),('8902','2014-03-25','16:20:00',1.99),('8902','2014-03-25','16:25:00',1.44),('8902','2014-03-25','16:30:00',1.15),('8902','2014-03-25','16:35:00',1.15),('8902','2013-03-21','07:20:00',1.24),('8902','2013-03-21','07:25:00',1.41),('8902','2013-03-21','07:30:00',1.58),('8902','2013-03-21','07:35:00',1.77),('8902','2013-03-21','07:40:00',1.94),('8902','2013-03-21','07:45:00',2.11),('8902','2013-03-21','07:50:00',2.28),('8902','2013-03-21','07:55:00',2.48),('8902','2013-03-21','08:00:00',2.66),('8902','2013-03-21','08:05:00',2.87),('8902','2013-03-21','08:10:00',3.06),('8902','2013-03-21','08:15:00',3.25),('8902','2013-03-21','08:20:00',3.46),('8902','2013-03-21','08:25:00',3.64),('8902','2013-03-21','08:30:00',3.84),('8902','2013-03-21','08:35:00',4.02),('8902','2013-03-21','08:40:00',4.17),('8902','2013-03-21','08:45:00',4.34),('8902','2013-03-21','08:50:00',4.5),('8902','2013-03-21','08:55:00',4.66),('8902','2013-03-21','09:00:00',4.79),('8902','2013-03-21','09:05:00',4.92),('8902','2013-03-21','09:10:00',5.08),('8902','2013-03-21','09:15:00',5.25),('8902','2013-03-21','09:20:00',5.35),('8902','2013-03-21','09:25:00',5.52),('8902','2013-03-21','09:30:00',5.64),('8902','2013-03-21','09:35:00',5.78),('8902','2013-03-21','09:40:00',5.89),('8902','2013-03-21','09:45:00',6.01),('8902','2013-03-21','09:50:00',6.17),('8902','2013-03-21','09:55:00',6.21),('8902','2013-03-21','10:00:00',6.32),('8902','2013-03-21','10:05:00',6.42),('8902','2013-03-21','10:10:00',6.53),('8902','2013-03-21','10:15:00',6.58),('8902','2013-03-21','10:20:00',6.68),('8902','2013-03-21','10:25:00',6.87),('8902','2013-03-21','10:30:00',7.05),('8902','2013-03-21','10:35:00',7.2),('8902','2013-03-21','10:40:00',7.21),('8902','2013-03-21','10:45:00',7.28),('8902','2013-03-21','10:50:00',6.62),('8902','2013-03-21','10:55:00',7.43),('8902','2013-03-21','11:00:00',7.46),('8902','2013-03-21','11:05:00',7.47),('8902','2013-03-21','11:10:00',7.5),('8902','2013-03-21','11:15:00',7.66),('8902','2013-03-21','11:20:00',7.66),('8902','2013-03-21','11:25:00',7.71),('8902','2013-03-21','11:30:00',7.82),('8902','2013-03-21','11:35:00',7.89),('8902','2013-03-21','11:40:00',7.88),('8902','2013-03-21','11:45:00',7.99),('8902','2013-03-21','11:50:00',8),('8902','2013-03-21','11:55:00',8),('8902','2013-03-21','12:00:00',8.07),('8902','2013-03-21','12:05:00',8.07),('8902','2013-03-21','12:10:00',8.1),('8902','2013-03-21','12:15:00',8.12),('8902','2013-03-21','12:20:00',8.08),('8902','2013-03-21','12:25:00',8.1),('8902','2013-03-21','12:30:00',8.11),('8902','2013-03-21','12:35:00',8.13),('8902','2013-03-21','12:40:00',8.14),('8902','2013-03-21','12:45:00',8.09),('8902','2013-03-21','12:50:00',7.93),('8902','2013-03-21','12:55:00',7.53),('8902','2013-03-21','13:00:00',8.1),('8902','2013-03-21','13:05:00',7.8),('8902','2013-03-21','13:10:00',8.05),('8902','2013-03-21','13:15:00',8.06),('8902','2013-03-21','13:20:00',8),('8902','2013-03-21','13:25:00',7.59),('8902','2013-03-21','13:30:00',7.47),('8902','2013-03-21','13:35:00',7.71),('8902','2013-03-21','13:40:00',6.54),('8902','2013-03-21','13:45:00',6.64),('8902','2013-03-21','13:50:00',7.86),('8902','2013-03-21','13:55:00',7.67),('8902','2013-03-21','14:00:00',7.52),('8902','2013-03-21','14:05:00',7.47),('8902','2013-03-21','14:10:00',7.42),('8902','2013-03-21','14:15:00',7.29),('8902','2013-03-21','14:20:00',7.18),('8902','2013-03-21','14:25:00',7.12),('8902','2013-03-21','14:30:00',7.06),('8902','2013-03-21','14:35:00',6.92),('8902','2013-03-21','14:40:00',6.78),('8902','2013-03-21','14:45:00',6.68),('8902','2013-03-21','14:50:00',6.66),('8902','2013-03-21','14:55:00',6.51),('8902','2013-03-21','15:00:00',6.42),('8902','2013-03-21','15:05:00',6.3),('8902','2013-03-21','15:10:00',5.69),('8902','2013-03-21','15:15:00',4.73),('8902','2013-03-21','15:20:00',4.64),('8902','2013-03-21','15:25:00',4.88),('8902','2013-03-21','15:30:00',4.5),('8902','2013-03-21','15:35:00',5.07),('8902','2013-03-21','15:40:00',4.85),('8902','2013-03-21','15:45:00',4.27),('8902','2013-03-21','15:50:00',4.53),('8902','2013-03-21','15:55:00',4.1),('8902','2013-03-21','16:00:00',2.94),('8902','2013-03-21','16:05:00',2.91),('8902','2013-03-21','16:10:00',3.41),('8902','2013-03-21','16:15:00',4.07),('8902','2013-03-21','16:20:00',3.33),('8902','2013-03-21','16:25:00',3.27),('8902','2013-03-21','16:30:00',3.53),('8902','2013-03-21','16:35:00',3.5),('8902','2013-03-21','16:40:00',3.36),('8902','2013-03-21','16:45:00',3.19),('8902','2013-03-21','16:50:00',2.97),('8902','2013-03-21','16:55:00',2.72),('8902','2013-03-21','17:00:00',2.42),('8902','2013-03-21','17:05:00',2.16),('8902','2013-03-21','17:10:00',1.9),('8902','2013-03-21','17:15:00',1.7),('8902','2013-03-21','17:20:00',1.54),('8902','2013-03-21','17:25:00',1.14),('8902','2013-03-20','07:30:00',1.01),('8902','2013-03-20','07:35:00',1.1),('8902','2013-03-20','07:40:00',1.3),('8902','2013-03-20','07:45:00',1.87),('8902','2013-03-20','07:50:00',2.52),('8902','2013-03-20','07:55:00',1.67),('8902','2013-03-20','08:00:00',1.01),('8902','2013-03-20','08:10:00',2.13),('8902','2013-03-20','08:15:00',3.53),('8902','2013-03-20','08:20:00',3.68),('8902','2013-03-20','08:25:00',3.82),('8902','2013-03-20','08:30:00',3.98),('8902','2013-03-20','08:35:00',4.16),('8902','2013-03-20','08:40:00',4.54),('8902','2013-03-20','08:45:00',4.62),('8902','2013-03-20','08:50:00',4.66),('8902','2013-03-20','08:55:00',3.89),('8902','2013-03-20','09:00:00',5.12),('8902','2013-03-20','09:05:00',5.43),('8902','2013-03-20','09:10:00',6.13),('8902','2013-03-20','09:15:00',5.13),('8902','2013-03-20','09:20:00',5.89),('8902','2013-03-20','09:25:00',5.91),('8902','2013-03-20','09:30:00',6.16),('8902','2013-03-20','09:35:00',6.12),('8902','2013-03-20','09:40:00',5.96),('8902','2013-03-20','09:45:00',6.35),('8902','2013-03-20','09:50:00',5.99),('8902','2013-03-20','09:55:00',6.73),('8902','2013-03-20','10:00:00',6.84),('8902','2013-03-20','10:05:00',6.9),('8902','2013-03-20','10:10:00',6.98),('8902','2013-03-20','10:15:00',7.06),('8902','2013-03-20','10:20:00',7.13),('8902','2013-03-20','10:25:00',7.18),('8902','2013-03-20','10:30:00',7.25),('8902','2013-03-20','10:35:00',7.35),('8902','2013-03-20','10:40:00',7.44),('8902','2013-03-20','10:45:00',7.48),('8902','2013-03-20','10:50:00',7.48),('8902','2013-03-20','10:55:00',4.82),('8902','2013-03-20','11:00:00',7.82),('8902','2013-03-20','11:05:00',7.81),('8902','2013-03-20','11:10:00',7.88),('8902','2013-03-20','11:15:00',8),('8902','2013-03-20','11:20:00',8.08),('8902','2013-03-20','11:25:00',8.16),('8902','2013-03-20','11:30:00',8.19),('8902','2013-03-20','11:35:00',8.27),('8902','2013-03-20','11:40:00',8.28),('8902','2013-03-20','11:45:00',8.34),('8902','2013-03-20','11:50:00',8.39),('8902','2013-03-20','11:55:00',8.42),('8902','2013-03-20','12:00:00',8.4),('8902','2013-03-20','12:05:00',8.44),('8902','2013-03-20','12:10:00',8.43),('8902','2013-03-20','12:15:00',8.43),('8902','2013-03-20','12:20:00',8.44),('8902','2013-03-20','12:25:00',8.44),('8902','2013-03-20','12:30:00',8.47),('8902','2013-03-20','12:35:00',8.47),('8902','2013-03-20','12:40:00',8.43),('8902','2013-03-20','12:45:00',8.41),('8902','2013-03-20','12:50:00',8.4),('8902','2013-03-20','12:55:00',8.4),('8902','2013-03-20','13:00:00',8.37),('8902','2013-03-20','13:05:00',8.32),('8902','2013-03-20','13:10:00',8.29),('8902','2013-03-20','13:15:00',8.26),('8902','2013-03-20','13:20:00',8.23),('8902','2013-03-20','13:25:00',8.17),('8902','2013-03-20','13:30:00',8.1),('8902','2013-03-20','13:35:00',8.05),('8902','2013-03-20','13:40:00',8.02),('8902','2013-03-20','13:45:00',7.95),('8902','2013-03-20','13:50:00',7.84),('8902','2013-03-20','13:55:00',7.78),('8902','2013-03-20','14:00:00',7.7),('8902','2013-03-20','14:05:00',7.55),('8902','2013-03-20','14:10:00',7.46),('8902','2013-03-20','14:15:00',7.4),('8902','2013-03-20','14:20:00',7.3),('8902','2013-03-20','14:25:00',7.24),('8902','2013-03-20','14:30:00',7.12),('8902','2013-03-20','14:35:00',6.98),('8902','2013-03-20','14:40:00',6.88),('8902','2013-03-20','14:45:00',6.8),('8902','2013-03-20','14:50:00',6.7),('8902','2013-03-20','14:55:00',6.58),('8902','2013-03-20','15:00:00',6.45),('8902','2013-03-20','15:05:00',6.35),('8902','2013-03-20','15:10:00',6.22),('8902','2013-03-20','15:15:00',6.08),('8902','2013-03-20','15:20:00',5.95),('8902','2013-03-20','15:25:00',5.81),('8902','2013-03-20','15:30:00',5.61),('8902','2013-03-20','15:35:00',5.51),('8902','2013-03-20','15:40:00',5.34),('8902','2013-03-20','15:45:00',5.16),('8902','2013-03-20','15:50:00',4.88),('8902','2013-03-20','15:55:00',4.8),('8902','2013-03-20','16:00:00',4.63),('8902','2013-03-20','16:05:00',4.43),('8902','2013-03-20','16:10:00',4.25),('8902','2013-03-20','16:15:00',4.07),('8902','2013-03-20','16:20:00',3.9),('8902','2013-03-20','16:25:00',3.69),('8902','2013-03-20','16:30:00',3.42),('8902','2013-03-20','16:35:00',3.16),('8902','2013-03-20','16:40:00',2.95),('8902','2013-03-20','16:45:00',2.83),('8902','2013-03-20','16:50:00',2.63),('8902','2013-03-20','16:55:00',2.4),('8902','2013-03-20','17:00:00',2.18),('8902','2013-03-20','17:05:00',1.97),('8902','2013-03-20','17:10:00',1.74),('8902','2013-03-20','17:15:00',1.57),('8902','2013-03-20','17:20:00',1.39),('8902','2013-03-20','17:25:00',1.19),('8902','2013-03-19','07:20:00',1.2),('8902','2013-03-19','07:25:00',1.39),('8902','2013-03-19','07:30:00',1.62),('8902','2013-03-19','07:35:00',1.89),('8902','2013-03-19','07:40:00',2.01),('8902','2013-03-19','07:45:00',2.08),('8902','2013-03-19','07:50:00',2.17),('8902','2013-03-19','07:55:00',2.63),('8902','2013-03-19','08:00:00',2.43),('8902','2013-03-19','08:05:00',2.45),('8902','2013-03-19','08:10:00',2.97),('8902','2013-03-19','08:15:00',3.2),('8902','2013-03-19','08:20:00',3.39),('8902','2013-03-19','08:25:00',3.6),('8902','2013-03-19','08:30:00',3.84),('8902','2013-03-19','08:35:00',3.83),('8902','2013-03-19','08:40:00',3.93),('8902','2013-03-19','08:45:00',4.1),('8902','2013-03-19','08:50:00',4.35),('8902','2013-03-19','08:55:00',4.31),('8902','2013-03-19','09:00:00',4.67),('8902','2013-03-19','09:05:00',5.74),('8902','2013-03-19','09:10:00',5.29),('8902','2013-03-19','09:15:00',4.98),('8902','2013-03-19','09:20:00',5.23),('8902','2013-03-19','09:25:00',5.56),('8902','2013-03-19','09:30:00',5.62),('8902','2013-03-19','09:35:00',5.48),('8902','2013-03-19','09:40:00',5.8),('8902','2013-03-19','09:45:00',6.03),('8902','2013-03-19','09:50:00',6.08),('8902','2013-03-19','09:55:00',6.11),('8902','2013-03-19','10:00:00',6.35),('8902','2013-03-19','10:05:00',6.16),('8902','2013-03-19','10:10:00',5.79),('8902','2013-03-19','10:15:00',4.81),('8902','2013-03-19','10:20:00',5.63),('8902','2013-03-19','10:25:00',4.82),('8902','2013-03-19','10:30:00',5.78),('8902','2013-03-19','10:35:00',6.64),('8902','2013-03-19','10:40:00',6.16),('8902','2013-03-19','10:45:00',4.46),('8902','2013-03-19','10:50:00',6),('8902','2013-03-19','10:55:00',5.5),('8902','2013-03-19','11:00:00',5.52),('8902','2013-03-19','11:05:00',6.26),('8902','2013-03-19','11:10:00',5.23),('8902','2013-03-19','11:15:00',4.57),('8902','2013-03-19','11:20:00',5.21),('8902','2013-03-19','11:25:00',5.02),('8902','2013-03-19','11:30:00',4.59),('8902','2013-03-19','11:35:00',5.11),('8902','2013-03-19','11:40:00',4.21),('8902','2013-03-19','11:45:00',3.97),('8902','2013-03-19','11:50:00',3.75),('8902','2013-03-19','11:55:00',4.27),('8902','2013-03-19','12:00:00',4.08),('8902','2013-03-19','12:05:00',4.55),('8902','2013-03-19','12:10:00',3.68),('8902','2013-03-19','12:15:00',3.19),('8902','2013-03-19','12:20:00',2.96),('8902','2013-03-19','12:25:00',2.47),('8902','2013-03-19','12:30:00',1.99),('8902','2013-03-19','12:35:00',2.51),('8902','2013-03-19','12:40:00',1.82),('8902','2013-03-19','12:45:00',1.92),('8902','2013-03-19','12:50:00',2.76),('8902','2013-03-19','12:55:00',3.2),('8902','2013-03-19','13:00:00',3.51),('8902','2013-03-19','13:05:00',2.7),('8902','2013-03-19','13:10:00',2.77),('8902','2013-03-19','13:15:00',2.2),('8902','2013-03-19','13:20:00',2.38),('8902','2013-03-19','13:25:00',2.52),('8902','2013-03-19','13:30:00',2.74),('8902','2013-03-19','13:35:00',2.59),('8902','2013-03-19','13:40:00',3.28),('8902','2013-03-19','13:45:00',3.88),('8902','2013-03-19','13:50:00',3.23),('8902','2013-03-19','13:55:00',3.01),('8902','2013-03-19','14:00:00',2.98),('8902','2013-03-19','14:05:00',2.54),('8902','2013-03-19','14:10:00',2.4),('8902','2013-03-19','14:15:00',3.16),('8902','2013-03-19','14:20:00',4.07),('8902','2013-03-19','14:25:00',3.68),('8902','2013-03-19','14:30:00',3.13),('8902','2013-03-19','14:35:00',2.58),('8902','2013-03-19','14:40:00',2.05),('8902','2013-03-19','14:45:00',2.01),('8902','2013-03-19','14:50:00',1.63),('8902','2013-03-19','14:55:00',1.32),('8902','2013-03-19','15:00:00',1.48),('8902','2013-03-19','15:05:00',1.29),('8902','2013-03-19','15:10:00',1.16),('8902','2013-03-19','15:15:00',1),('8902','2013-03-19','15:30:00',1.08),('8902','2013-03-19','15:35:00',1),('8902','2013-03-18','07:05:00',1.08),('8902','2013-03-18','07:10:00',1.26),('8902','2013-03-18','07:15:00',1.3),('8902','2013-03-18','07:20:00',1.11),('8902','2013-03-18','07:25:00',1.29),('8902','2013-03-18','07:30:00',1.45),('8902','2013-03-18','07:35:00',1.61),('8902','2013-03-18','07:40:00',1.78),('8902','2013-03-18','07:45:00',1.99),('8902','2013-03-18','07:50:00',2.21),('8902','2013-03-18','07:55:00',2.27),('8902','2013-03-18','08:00:00',1.47),('8902','2013-03-18','08:05:00',2.24),('8902','2013-03-18','08:10:00',2.83),('8902','2013-03-18','08:15:00',3.18),('8902','2013-03-18','08:20:00',3.32),('8902','2013-03-18','08:25:00',3.48),('8902','2013-03-18','08:30:00',3.72),('8902','2013-03-18','08:35:00',3.8),('8902','2013-03-18','08:40:00',3.54),('8902','2013-03-18','08:45:00',4.13),('8902','2013-03-18','08:50:00',4.48),('8902','2013-03-18','08:55:00',4.62),('8902','2013-03-18','09:00:00',4.76),('8902','2013-03-18','09:05:00',4.96),('8902','2013-03-18','09:10:00',5.11),('8902','2013-03-18','09:15:00',5.01),('8902','2013-03-18','09:20:00',4.61),('8902','2013-03-18','09:25:00',4.25),('8902','2013-03-18','09:30:00',5.55),('8902','2013-03-18','09:35:00',5.93),('8902','2013-03-18','09:40:00',6.09),('8902','2013-03-18','09:45:00',6.37),('8902','2013-03-18','09:50:00',5.67),('8902','2013-03-18','09:55:00',5.41),('8902','2013-03-18','10:00:00',5.52),('8902','2013-03-18','10:05:00',5.63),('8902','2013-03-18','10:10:00',6.54),('8902','2013-03-18','10:15:00',6.92),('8902','2013-03-18','10:20:00',7.03),('8902','2013-03-18','10:25:00',6.89),('8902','2013-03-18','10:30:00',7.25),('8902','2013-03-18','10:35:00',7.34),('8902','2013-03-18','10:40:00',7.39),('8902','2013-03-18','10:45:00',7.53),('8902','2013-03-18','10:50:00',7.48),('8902','2013-03-18','10:55:00',7.79),('8902','2013-03-18','11:00:00',7.85),('8902','2013-03-18','11:05:00',7.81),('8902','2013-03-18','11:10:00',7.68),('8902','2013-03-18','11:15:00',7.95),('8902','2013-03-18','11:20:00',8.03),('8902','2013-03-18','11:25:00',7.95),('8902','2013-03-18','11:30:00',7.98),('8902','2013-03-18','11:35:00',5.01),('8902','2013-03-18','11:40:00',7.2),('8902','2013-03-18','11:45:00',7.62),('8902','2013-03-18','11:50:00',8.23),('8902','2013-03-18','11:55:00',8.38),('8902','2013-03-18','12:00:00',8.25),('8902','2013-03-18','12:05:00',8.2),('8902','2013-03-18','12:10:00',8.22),('8902','2013-03-18','12:15:00',7.83),('8902','2013-03-18','12:20:00',8.31),('8902','2013-03-18','12:25:00',8.2),('8902','2013-03-18','12:30:00',8.11),('8902','2013-03-18','12:35:00',8.21),('8902','2013-03-18','12:40:00',8.24),('8902','2013-03-18','12:45:00',8.29),('8902','2013-03-18','12:50:00',8.24),('8902','2013-03-18','12:55:00',8.14),('8902','2013-03-18','13:00:00',8.2),('8902','2013-03-18','13:05:00',8.14),('8902','2013-03-18','13:10:00',8.05),('8902','2013-03-18','13:15:00',8.01),('8902','2013-03-18','13:20:00',7.99),('8902','2013-03-18','13:25:00',8.01),('8902','2013-03-18','13:30:00',7.91),('8902','2013-03-18','13:35:00',7.84),('8902','2013-03-18','13:40:00',7.67),('8902','2013-03-18','13:45:00',7.68),('8902','2013-03-18','13:50:00',7.71),('8902','2013-03-18','13:55:00',7.61),('8902','2013-03-18','14:00:00',7.54),('8902','2013-03-18','14:05:00',7.45),('8902','2013-03-18','14:10:00',7.37),('8902','2013-03-18','14:15:00',7.29),('8902','2013-03-18','14:20:00',7.19),('8902','2013-03-18','14:25:00',7.14),('8902','2013-03-18','14:30:00',7.06),('8902','2013-03-18','14:35:00',6.91),('8902','2013-03-18','14:40:00',6.81),('8902','2013-03-18','14:45:00',6.68),('8902','2013-03-18','14:50:00',6.58),('8902','2013-03-18','14:55:00',6.47),('8902','2013-03-18','15:00:00',6.38),('8902','2013-03-18','15:05:00',6.24),('8902','2013-03-18','15:10:00',6.09),('8902','2013-03-18','15:15:00',5.97),('8902','2013-03-18','15:20:00',5.86),('8902','2013-03-18','15:25:00',5.65),('8902','2013-03-18','15:30:00',5.47),('8902','2013-03-18','15:35:00',5.4),('8902','2013-03-18','15:40:00',5.25),('8902','2013-03-18','15:45:00',5.07),('8902','2013-03-18','15:50:00',4.83),('8902','2013-03-18','15:55:00',4.73),('8902','2013-03-18','16:00:00',4.56),('8902','2013-03-18','16:05:00',4.31),('8902','2013-03-18','16:10:00',4.17),('8902','2013-03-18','16:15:00',3.97),('8902','2013-03-18','16:20:00',3.77),('8902','2013-03-18','16:25:00',3.61),('8902','2013-03-18','16:30:00',3.4),('8902','2013-03-18','16:35:00',3.19),('8902','2013-03-18','16:40:00',3.03),('8902','2013-03-18','16:45:00',2.46),('8902','2013-03-18','16:50:00',1.9),('8902','2013-03-18','16:55:00',2.01),('8902','2013-03-18','17:00:00',1.64),('8902','2013-03-18','17:05:00',1.46),('8902','2013-03-18','17:10:00',1.42),('8902','2013-03-18','17:15:00',1.69),('8902','2013-03-18','17:20:00',1.48),('8902','2013-03-18','17:25:00',1.2),('8902','2013-03-17','08:25:00',1.19),('8902','2013-03-17','08:30:00',1.39),('8902','2013-03-17','08:35:00',1.27),('8902','2013-03-17','08:40:00',1.21),('8902','2013-03-17','08:45:00',1.7),('8902','2013-03-17','08:50:00',1.49),('8902','2013-03-17','08:55:00',1.3),('8902','2013-03-17','09:35:00',1.05),('8902','2013-03-17','09:40:00',1.18),('8902','2013-03-17','09:45:00',1.27),('8902','2013-03-17','09:50:00',1.31),('8902','2013-03-17','09:55:00',1.79),('8902','2013-03-17','10:00:00',2.05),('8902','2013-03-17','10:05:00',2.85),('8902','2013-03-17','10:10:00',2.79),('8902','2013-03-17','10:15:00',2.43),('8902','2013-03-17','10:20:00',3.02),('8902','2013-03-17','10:25:00',4.03),('8902','2013-03-17','10:30:00',3.77),('8902','2013-03-17','10:35:00',2.93),('8902','2013-03-17','10:40:00',2.66),('8902','2013-03-17','10:45:00',2.71),('8902','2013-03-17','10:50:00',2.66),('8902','2013-03-17','10:55:00',2.22),('8902','2013-03-17','11:00:00',2.38),('8902','2013-03-17','11:05:00',2.61),('8902','2013-03-17','11:10:00',3),('8902','2013-03-17','11:15:00',3.26),('8902','2013-03-17','11:20:00',3.37),('8902','2013-03-17','11:25:00',3.58),('8902','2013-03-17','11:30:00',4.33),('8902','2013-03-17','11:35:00',3.7),('8902','2013-03-17','11:40:00',3.43),('8902','2013-03-17','11:45:00',2.88),('8902','2013-03-17','11:50:00',2.35),('8902','2013-03-17','11:55:00',2.76),('8902','2013-03-17','12:00:00',2.94),('8902','2013-03-17','12:05:00',4.95),('8902','2013-03-17','12:10:00',4.61),('8902','2013-03-17','12:15:00',5.33),('8902','2013-03-17','12:20:00',4.99),('8902','2013-03-17','12:25:00',3.55),('8902','2013-03-17','12:30:00',6.76),('8902','2013-03-17','12:35:00',6.8),('8902','2013-03-17','12:40:00',6.19),('8902','2013-03-17','12:45:00',5.02),('8902','2013-03-17','12:50:00',7.2),('8902','2013-03-17','12:55:00',7.93),('8902','2013-03-17','13:00:00',6.16),('8902','2013-03-17','13:05:00',3.27),('8902','2013-03-17','13:10:00',2.21),('8902','2013-03-17','13:15:00',1.68),('8902','2013-03-17','13:20:00',1.9),('8902','2013-03-17','13:25:00',3.48),('8902','2013-03-17','13:30:00',2.7),('8902','2013-03-17','13:35:00',2.22),('8902','2013-03-17','13:40:00',3.68),('8902','2013-03-17','13:45:00',3.39),('8902','2013-03-17','13:50:00',3.17),('8902','2013-03-17','13:55:00',2.99),('8902','2013-03-17','14:00:00',3.22),('8902','2013-03-17','14:05:00',5.26),('8902','2013-03-17','14:10:00',4.93),('8902','2013-03-17','14:15:00',2.44),('8902','2013-03-17','14:20:00',2.33),('8902','2013-03-17','14:25:00',3.48),('8902','2013-03-17','14:30:00',1.58),('8902','2013-03-17','14:35:00',2.09),('8902','2013-03-17','14:40:00',2.38),('8902','2013-03-17','14:45:00',2.25),('8902','2013-03-17','14:50:00',1.27),('8902','2013-03-17','14:55:00',1.75),('8902','2013-03-17','15:00:00',2.07),('8902','2013-03-17','15:05:00',1.73),('8902','2013-03-17','15:10:00',1.27),('8902','2013-03-17','15:15:00',1.65),('8902','2013-03-17','15:20:00',1.3),('8902','2013-03-17','15:25:00',1.14),('8902','2013-03-17','15:30:00',1.08),('8902','2013-03-16','07:50:00',1.12),('8902','2013-03-16','07:55:00',1.19),('8902','2013-03-16','08:00:00',1.3),('8902','2013-03-16','08:05:00',1.45),('8902','2013-03-16','08:10:00',1.72),('8902','2013-03-16','08:15:00',2.04),('8902','2013-03-16','08:20:00',2.36),('8902','2013-03-16','08:25:00',2.76),('8902','2013-03-16','08:30:00',2.53),('8902','2013-03-16','08:35:00',2.18),('8902','2013-03-16','08:40:00',2.23),('8902','2013-03-16','08:45:00',2.66),('8902','2013-03-16','08:50:00',2.63),('8902','2013-03-16','08:55:00',2.49),('8902','2013-03-16','09:00:00',2.44),('8902','2013-03-16','09:05:00',2.8),('8902','2013-03-16','09:10:00',3.18),('8902','2013-03-16','09:15:00',3.48),('8902','2013-03-16','09:20:00',2.92),('8902','2013-03-16','09:25:00',2.44),('8902','2013-03-16','09:30:00',2.65),('8902','2013-03-16','09:35:00',3.05),('8902','2013-03-16','09:40:00',2.87),('8902','2013-03-16','09:45:00',2.92),('8902','2013-03-16','09:50:00',3.27),('8902','2013-03-16','09:55:00',3.56),('8902','2013-03-16','10:00:00',3.91),('8902','2013-03-16','10:05:00',3.29),('8902','2013-03-16','10:10:00',3.19),('8902','2013-03-16','10:15:00',3.5),('8902','2013-03-16','10:20:00',3.55),('8902','2013-03-16','10:25:00',3.71),('8902','2013-03-16','10:30:00',3.61),('8902','2013-03-16','10:35:00',3.44),('8902','2013-03-16','10:40:00',3.25),('8902','2013-03-16','10:45:00',3.43),('8902','2013-03-16','10:50:00',3.38),('8902','2013-03-16','10:55:00',3.07),('8902','2013-03-16','11:00:00',3.11),('8902','2013-03-16','11:05:00',2.68),('8902','2013-03-16','11:10:00',2.53),('8902','2013-03-16','11:15:00',2.65),('8902','2013-03-16','11:20:00',3.05),('8902','2013-03-16','11:25:00',3.23),('8902','2013-03-16','11:30:00',2.9),('8902','2013-03-16','11:35:00',2.84),('8902','2013-03-16','11:40:00',2.65),('8902','2013-03-16','11:45:00',2.5),('8902','2013-03-16','11:50:00',2.3),('8902','2013-03-16','11:55:00',2.06),('8902','2013-03-16','12:00:00',2.04),('8902','2013-03-16','12:05:00',2.1),('8902','2013-03-16','12:10:00',2.65),('8902','2013-03-16','12:15:00',3.58),('8902','2013-03-16','12:20:00',4.39),('8902','2013-03-16','12:25:00',6.61),('8902','2013-03-16','12:30:00',7.15),('8902','2013-03-16','12:35:00',5),('8902','2013-03-16','12:40:00',5.36),('8902','2013-03-16','12:45:00',4.76),('8902','2013-03-16','12:50:00',4.18),('8902','2013-03-16','12:55:00',3.26),('8902','2013-03-16','13:00:00',3.89),('8902','2013-03-16','13:05:00',4.36),('8902','2013-03-16','13:10:00',4.79),('8902','2013-03-16','13:15:00',4.81),('8902','2013-03-16','13:20:00',3.95),('8902','2013-03-16','13:25:00',3.41),('8902','2013-03-16','13:30:00',5.18),('8902','2013-03-16','13:35:00',6.09),('8902','2013-03-16','13:40:00',3.93),('8902','2013-03-16','13:45:00',3.55),('8902','2013-03-16','13:50:00',2.72),('8902','2013-03-16','13:55:00',4.09),('8902','2013-03-16','14:00:00',4.23),('8902','2013-03-16','14:05:00',4.04),('8902','2013-03-16','14:10:00',4.81),('8902','2013-03-16','14:15:00',5.4),('8902','2013-03-16','14:20:00',5.13),('8902','2013-03-16','14:25:00',4.92),('8902','2013-03-16','14:30:00',4.63),('8902','2013-03-16','14:35:00',3.7),('8902','2013-03-16','14:40:00',2.91),('8902','2013-03-16','14:45:00',2.53),('8902','2013-03-16','14:50:00',2.19),('8902','2013-03-16','14:55:00',2.24),('8902','2013-03-16','15:00:00',2.94),('8902','2013-03-16','15:05:00',3.24),('8902','2013-03-16','15:10:00',4.18),('8902','2013-03-16','15:15:00',3.97),('8902','2013-03-16','15:20:00',4.59),('8902','2013-03-16','15:25:00',3.35),('8902','2013-03-16','15:30:00',2.46),('8902','2013-03-16','15:35:00',2.64),('8902','2013-03-16','15:40:00',2.68),('8902','2013-03-16','15:45:00',2.64),('8902','2013-03-16','15:50:00',1.81),('8902','2013-03-16','15:55:00',1.7),('8902','2013-03-16','16:00:00',1.18),('8902','2013-03-16','16:20:00',1.06),('8902','2013-03-16','16:40:00',1.38),('8902','2013-03-16','16:45:00',2.19),('8902','2013-03-15','07:45:00',1.14),('8902','2013-03-15','07:50:00',1.63),('8902','2013-03-15','07:55:00',1.36),('8902','2013-03-15','08:00:00',1.7),('8902','2013-03-15','08:05:00',1.82),('8902','2013-03-15','08:10:00',1.87),('8902','2013-03-15','08:15:00',3.21),('8902','2013-03-15','08:20:00',3.88),('8902','2013-03-15','08:25:00',3.89),('8902','2013-03-15','08:30:00',3.84),('8902','2013-03-15','08:35:00',4.03),('8902','2013-03-15','08:40:00',4.26),('8902','2013-03-15','08:45:00',4.2),('8902','2013-03-15','08:50:00',4.66),('8902','2013-03-15','08:55:00',4.99),('8902','2013-03-15','09:00:00',4.92),('8902','2013-03-15','09:05:00',3.55),('8902','2013-03-15','09:15:00',5.62),('8902','2013-03-15','09:20:00',5.52),('8902','2013-03-15','09:29:00',5.71),('8902','2013-03-15','09:30:00',6.05),('8902','2013-03-15','09:35:00',6.27),('8902','2013-03-15','09:43:00',6.56),('8902','2013-03-15','09:46:00',6.06),('8902','2013-03-15','09:55:00',6.47),('8902','2013-03-15','10:00:00',4.99),('8902','2013-03-15','10:08:00',4.13),('8902','2013-03-15','10:10:00',5.01),('8902','2013-03-15','10:21:00',4.56),('8902','2013-03-15','10:25:00',4.69),('8902','2013-03-15','10:33:00',5.85),('8902','2013-03-15','10:35:00',5.3),('8902','2013-03-15','10:43:00',6.14),('8902','2013-03-15','10:45:00',7.61),('8902','2013-03-15','10:56:00',7.62),('8902','2013-03-15','11:00:00',7.69),('8902','2013-03-15','11:05:00',7.68),('8902','2013-03-15','11:10:00',7.77),('8902','2013-03-15','11:16:00',7.85),('8902','2013-03-15','11:20:00',7.84),('8902','2013-03-15','11:25:00',7.89),('8902','2013-03-15','11:30:00',7.94),('8902','2013-03-15','11:35:00',7.96),('8902','2013-03-15','11:40:00',7.98),('8902','2013-03-15','11:45:00',7.96),('8902','2013-03-15','11:50:00',8.03),('8902','2013-03-15','11:55:00',8.06),('8902','2013-03-15','12:00:00',8.05),('8902','2013-03-15','12:05:00',8.04),('8902','2013-03-15','12:10:00',8.12),('8902','2013-03-15','12:15:00',8.11),('8902','2013-03-15','12:20:00',8.13),('8902','2013-03-15','12:25:00',8.11),('8902','2013-03-15','12:30:00',8.11),('8902','2013-03-15','12:35:00',8.09),('8902','2013-03-15','12:40:00',8.08),('8902','2013-03-15','12:45:00',8.06),('8902','2013-03-15','12:50:00',8.02),('8902','2013-03-15','12:55:00',8),('8902','2013-03-15','13:00:00',7.94),('8902','2013-03-15','13:05:00',7.86),('8902','2013-03-15','13:10:00',7.81),('8902','2013-03-15','13:15:00',7.84),('8902','2013-03-15','13:20:00',6.72),('8902','2013-03-15','13:25:00',2.94),('8902','2013-03-15','13:30:00',3.45),('8902','2013-03-15','13:35:00',6.79),('8902','2013-03-15','13:40:00',8.04),('8902','2013-03-15','13:45:00',7.9),('8902','2013-03-15','13:50:00',6.75),('8902','2013-03-15','13:55:00',2.74),('8902','2013-03-15','14:00:00',7.19),('8902','2013-03-15','14:05:00',7.85),('8902','2013-03-15','14:10:00',6.69),('8902','2013-03-15','14:15:00',4.42),('8902','2013-03-15','14:20:00',5.31),('8902','2013-03-15','14:25:00',1.96),('8902','2013-03-15','14:30:00',2.12),('8902','2013-03-15','14:35:00',7.55),('8902','2013-03-15','14:40:00',3.54),('8902','2013-03-15','14:45:00',3.97),('8902','2013-03-15','14:50:00',1.44),('8902','2013-03-15','14:55:00',1.26),('8902','2013-03-15','15:00:00',1.2),('8902','2013-03-15','15:05:00',1.17),('8902','2013-03-15','15:10:00',1.08),('8902','2013-03-15','15:15:00',1.04),('8902','2013-03-15','15:20:00',1.04),('8902','2013-03-15','15:25:00',1.16),('8902','2013-03-15','15:30:00',1.09),('8902','2013-03-15','15:35:00',1.25),('8902','2013-03-15','15:40:00',1.48),('8902','2013-03-15','15:45:00',2.27),('8902','2013-03-15','15:50:00',1.09),('8902','2013-03-15','16:00:00',1.04),('8902','2013-03-15','16:05:00',2.25),('8902','2013-03-15','16:10:00',3.25),('8902','2013-03-15','16:15:00',2.98),('8902','2013-03-15','16:20:00',1.86),('8902','2013-03-15','16:25:00',1.11),('8902','2013-03-15','16:30:00',1.19),('8902','2013-03-15','16:35:00',1.14),('8902','2013-03-15','16:40:00',1.01),('8902','2013-03-15','16:55:00',1.78),('8902','2013-03-15','17:00:00',2.05),('8902','2013-03-15','17:05:00',1.9),('8902','2013-03-15','17:10:00',1.67),('8902','2013-03-15','17:15:00',1.51),('8902','2013-03-15','17:20:00',1.38),('8902','2013-03-15','17:25:00',1.16),('8902','2013-03-14','10:00:00',1.09),('8902','2013-03-14','10:05:00',1.05),('8902','2013-03-14','10:10:00',1.13),('8902','2013-03-14','10:15:00',1.28),('8902','2013-03-14','10:20:00',1.15),('8902','2013-03-14','10:25:00',1.25),('8902','2013-03-14','10:30:00',1.61),('8902','2013-03-14','10:35:00',1.83),('8902','2013-03-14','10:40:00',2.16),('8902','2013-03-14','10:45:00',2.59),('8902','2013-03-14','10:50:00',2.54),('8902','2013-03-14','10:55:00',2.75),('8902','2013-03-14','11:00:00',2.68),('8902','2013-03-14','11:05:00',2.45),('8902','2013-03-14','11:10:00',2.28),('8902','2013-03-14','11:15:00',2.02),('8902','2013-03-14','11:20:00',2.41),('8902','2013-03-14','11:25:00',2.86),('8902','2013-03-14','11:30:00',3.17),('8902','2013-03-14','11:35:00',3.77),('8902','2013-03-14','11:40:00',4.53),('8902','2013-03-14','11:45:00',4.4),('8902','2013-03-14','11:50:00',3.76),('8902','2013-03-14','11:55:00',3.86),('8902','2013-03-14','12:00:00',3.46),('8902','2013-03-14','12:05:00',3.42),('8902','2013-03-14','12:10:00',3.52),('8902','2013-03-14','12:15:00',3.13),('8902','2013-03-14','12:20:00',3.18),('8902','2013-03-14','12:25:00',3.19),('8902','2013-03-14','12:30:00',3.32),('8902','2013-03-14','12:35:00',3.74),('8902','2013-03-14','12:40:00',3.42),('8902','2013-03-14','12:45:00',3),('8902','2013-03-14','12:50:00',2.82),('8902','2013-03-14','12:55:00',2.63),('8902','2013-03-14','13:00:00',2.43),('8902','2013-03-14','13:05:00',2.28),('8902','2013-03-14','13:10:00',2.31),('8902','2013-03-14','13:15:00',2.49),('8902','2013-03-14','13:20:00',2.65),('8902','2013-03-14','13:25:00',2.9),('8902','2013-03-14','13:30:00',2.87),('8902','2013-03-14','13:35:00',2.64),('8902','2013-03-14','13:40:00',2.76),('8902','2013-03-14','13:45:00',2.99),('8902','2013-03-14','13:50:00',2.51),('8902','2013-03-14','13:55:00',2.17),('8902','2013-03-14','14:00:00',1.95),('8902','2013-03-14','14:05:00',1.75),('8902','2013-03-14','14:10:00',1.47),('8902','2013-03-14','14:15:00',1.26),('8902','2013-03-14','14:20:00',1.11),('8902','2013-03-14','14:40:00',1.02),('8902','2013-03-14','14:45:00',1.27),('8902','2013-03-14','14:50:00',1.75),('8902','2013-03-14','14:55:00',2.08),('8902','2013-03-14','15:00:00',2.22),('8902','2013-03-14','15:05:00',2.18),('8902','2013-03-14','15:10:00',2.16),('8902','2013-03-14','15:15:00',2.35),('8902','2013-03-14','15:20:00',2.36),('8902','2013-03-14','15:25:00',2.54),('8902','2013-03-14','15:30:00',2.37),('8902','2013-03-14','15:35:00',2),('8902','2013-03-14','15:40:00',1.64),('8902','2013-03-14','15:45:00',1.65),('8902','2013-03-14','15:50:00',1.63),('8902','2013-03-14','15:55:00',1.54),('8902','2013-03-14','16:00:00',1.78),('8902','2013-03-14','16:05:00',1.49),('8902','2013-03-14','16:10:00',1.29),('8902','2013-03-14','16:15:00',1.32),('8902','2013-03-14','16:20:00',1.15),('8902','2013-03-14','17:15:00',1.4),('8902','2013-03-14','17:20:00',1.35),('8902','2013-03-14','17:25:00',1.08),('8902','2013-03-13','08:20:00',1.42),('8902','2013-03-13','08:25:00',1.56),('8902','2013-03-13','08:30:00',1.37),('8902','2013-03-13','10:20:00',1.13),('8902','2013-03-13','10:25:00',1.22),('8902','2013-03-13','10:30:00',1.25),('8902','2013-03-13','10:35:00',1.28),('8902','2013-03-13','10:40:00',1.18),('8902','2013-03-13','11:25:00',1.13),('8902','2013-03-13','11:30:00',1.45),('8902','2013-03-13','11:35:00',1.65),('8902','2013-03-13','11:40:00',1.66),('8902','2013-03-13','11:45:00',1.68),('8902','2013-03-13','11:50:00',1.61),('8902','2013-03-13','11:55:00',1.47),('8902','2013-03-13','12:00:00',1.33),('8902','2013-03-13','12:05:00',1.17),('8902','2013-03-13','12:10:00',1.07),('8902','2013-03-13','12:15:00',1.11),('8902','2013-03-13','12:20:00',1.18),('8902','2013-03-13','12:25:00',1.25),('8902','2013-03-13','12:30:00',1.33),('8902','2013-03-13','12:35:00',1.3),('8902','2013-03-13','12:40:00',1.21),('8902','2013-03-13','12:45:00',1.36),('8902','2013-03-13','12:50:00',1.62),('8902','2013-03-13','12:55:00',1.95),('8902','2013-03-13','13:00:00',1.96),('8902','2013-03-13','13:05:00',2.07),('8902','2013-03-13','13:10:00',1.97),('8902','2013-03-13','13:15:00',1.99),('8902','2013-03-13','13:20:00',2.24),('8902','2013-03-13','13:25:00',2.25),('8902','2013-03-13','13:30:00',2.18),('8902','2013-03-13','13:35:00',2.12),('8902','2013-03-13','13:40:00',2.13),('8902','2013-03-13','13:45:00',2.9),('8902','2013-03-13','13:50:00',3.52),('8902','2013-03-13','13:55:00',4.47),('8902','2013-03-13','14:00:00',3.79),('8902','2013-03-13','14:05:00',3.6),('8902','2013-03-13','14:10:00',2.9),('8902','2013-03-13','14:15:00',2.36),('8902','2013-03-13','14:20:00',2.05),('8902','2013-03-13','14:25:00',2.02),('8902','2013-03-13','14:30:00',2.01),('8902','2013-03-13','14:35:00',1.63),('8902','2013-03-13','14:40:00',1.25),('8902','2013-03-13','14:45:00',1.06),('8902','2013-03-13','14:50:00',1.06),('8902','2013-03-13','14:55:00',1.14),('8902','2013-03-13','15:00:00',1.22),('8902','2013-03-13','15:05:00',1.68),('8902','2013-03-13','15:10:00',2.43),('8902','2013-03-13','15:15:00',2.54),('8902','2013-03-13','15:20:00',2.32),('8902','2013-03-13','15:25:00',2.35),('8902','2013-03-13','15:30:00',2.29),('8902','2013-03-13','15:35:00',1.91),('8902','2013-03-13','15:40:00',1.44),('8902','2013-03-13','15:45:00',1.21),('8902','2013-03-13','16:30:00',1.03),('8902','2013-03-12','07:20:00',1.17),('8902','2013-03-12','07:25:00',1.06),('8902','2013-03-12','07:40:00',1.11),('8902','2013-03-12','08:10:00',1.12),('8902','2013-03-12','08:25:00',1.24),('8902','2013-03-12','08:40:00',1.29),('8902','2013-03-12','08:45:00',1.54),('8902','2013-03-12','08:50:00',2.18),('8902','2013-03-12','08:55:00',2.17),('8902','2013-03-12','09:00:00',1.56),('8902','2013-03-12','09:05:00',1.46),('8902','2013-03-12','09:10:00',2.34),('8902','2013-03-12','09:15:00',2.09),('8902','2013-03-12','09:20:00',2.1),('8902','2013-03-12','09:25:00',1.71),('8902','2013-03-12','09:30:00',1.56),('8902','2013-03-12','09:35:00',1.37),('8902','2013-03-12','09:40:00',1.3),('8902','2013-03-12','09:45:00',1.98),('8902','2013-03-12','09:50:00',1.4),('8902','2013-03-12','10:00:00',1.18),('8902','2013-03-12','10:05:00',1.98),('8902','2013-03-12','10:10:00',2.5),('8902','2013-03-12','10:15:00',4.77),('8902','2013-03-12','10:20:00',3.81),('8902','2013-03-12','10:25:00',3.38),('8902','2013-03-12','10:30:00',6.62),('8902','2013-03-12','10:35:00',6.8),('8902','2013-03-12','10:40:00',5.11),('8902','2013-03-12','10:45:00',2.55),('8902','2013-03-12','10:50:00',2.42),('8902','2013-03-12','10:55:00',2.35),('8902','2013-03-12','11:00:00',2.22),('8902','2013-03-12','11:05:00',1.47),('8902','2013-03-12','11:10:00',1.7),('8902','2013-03-12','11:15:00',1.82),('8902','2013-03-12','11:20:00',1.64),('8902','2013-03-12','11:25:00',1.49),('8902','2013-03-12','11:30:00',2.32),('8902','2013-03-12','11:35:00',2.27),('8902','2013-03-12','11:40:00',2.18),('8902','2013-03-12','11:45:00',2.34),('8902','2013-03-12','11:50:00',2.18),('8902','2013-03-12','11:55:00',1.77),('8902','2013-03-12','12:00:00',1.14),('8902','2013-03-12','12:30:00',1.28),('8902','2013-03-12','12:35:00',1.49),('8902','2013-03-12','12:40:00',1.58),('8902','2013-03-12','12:45:00',2.06),('8902','2013-03-12','12:50:00',2.5),('8902','2013-03-12','12:55:00',2.2),('8902','2013-03-12','13:00:00',2.11),('8902','2013-03-12','13:05:00',2.06),('8902','2013-03-12','13:10:00',1.87),('8902','2013-03-12','13:15:00',1.64),('8902','2013-03-12','13:20:00',1.38),('8902','2013-03-12','13:25:00',1.25),('8902','2013-03-12','13:30:00',1.41),('8902','2013-03-12','13:35:00',1.85),('8902','2013-03-12','13:40:00',1.62),('8902','2013-03-12','13:45:00',1.43),('8902','2013-03-12','13:50:00',1.35),('8902','2013-03-12','13:55:00',1.26),('8902','2013-03-12','14:00:00',1.07),('8902','2013-03-12','14:05:00',1.08),('8902','2013-03-12','14:10:00',1.02),('8902','2013-03-12','14:25:00',1.12),('8902','2013-03-12','14:30:00',1.23),('8902','2013-03-12','14:35:00',1.13),('8902','2013-03-12','14:40:00',1.12),('8902','2013-03-12','14:45:00',1.37),('8902','2013-03-12','14:50:00',1.5),('8902','2013-03-12','14:55:00',1.26),('8902','2013-03-12','15:00:00',1.34),('8902','2013-03-12','15:05:00',1.54),('8902','2013-03-12','15:10:00',1.6),('8902','2013-03-12','15:15:00',1.17),('8902','2014-03-24','07:10:00',1.22),('8902','2014-03-24','07:15:00',1.68),('8902','2014-03-24','07:20:00',2.07),('8902','2014-03-24','07:25:00',2.34),('8902','2014-03-24','07:30:00',2.49),('8902','2014-03-24','07:35:00',2.03),('8902','2014-03-24','07:40:00',1.84),('8902','2014-03-24','07:45:00',2),('8902','2014-03-24','07:50:00',2.18),('8902','2014-03-24','07:55:00',2.24),('8902','2014-03-24','08:00:00',2.2),('8902','2014-03-24','08:05:00',2.29),('8902','2014-03-24','08:10:00',2.46),('8902','2014-03-24','08:15:00',2.63),('8902','2014-03-24','08:20:00',2.46),('8902','2014-03-24','08:25:00',2.25),('8902','2014-03-24','08:30:00',2.05),('8902','2014-03-24','08:35:00',2.08),('8902','2014-03-24','08:40:00',2.46),('8902','2014-03-24','08:45:00',3.4),('8902','2014-03-24','08:50:00',3.59),('8902','2014-03-24','08:55:00',3.79),('8902','2014-03-24','09:00:00',3.46),('8902','2014-03-24','09:05:00',3.36),('8902','2014-03-24','09:10:00',3.4),('8902','2014-03-24','09:15:00',4.4),('8902','2014-03-24','09:20:00',4.81),('8902','2014-03-24','09:25:00',4.24),('8902','2014-03-24','09:30:00',3.79),('8902','2014-03-24','09:35:00',3.5),('8902','2014-03-24','09:40:00',3.57),('8902','2014-03-24','09:45:00',3.34),('8902','2014-03-24','09:50:00',3.45),('8902','2014-03-24','09:55:00',3.91),('8902','2014-03-24','10:00:00',4.58),('8902','2014-03-24','10:05:00',4.86),('8902','2014-03-24','10:10:00',5.21),('8902','2014-03-24','10:15:00',5.65),('8902','2014-03-24','10:20:00',5.73),('8902','2014-03-24','10:25:00',5.35),('8902','2014-03-24','10:30:00',5.89),('8902','2014-03-24','10:35:00',4.94),('8902','2014-03-24','10:40:00',4.08),('8902','2014-03-24','10:45:00',3.72),('8902','2014-03-24','10:50:00',3.62),('8902','2014-03-24','10:55:00',3.62),('8902','2014-03-24','11:00:00',3.88),('8902','2014-03-24','11:05:00',4.43),('8902','2014-03-24','11:10:00',4.98),('8902','2014-03-24','11:15:00',5.74),('8902','2014-03-24','11:20:00',6.02),('8902','2014-03-24','11:25:00',5.89),('8902','2014-03-24','11:30:00',4.26),('8902','2014-03-24','11:35:00',6.09),('8902','2014-03-24','11:40:00',4.3),('8902','2014-03-24','11:45:00',4.35),('8902','2014-03-24','11:50:00',3.74),('8902','2014-03-24','11:55:00',3.52),('8902','2014-03-24','12:00:00',2.48),('8902','2014-03-24','12:05:00',1.58),('8902','2014-03-24','12:10:00',1.56),('8902','2014-03-24','12:15:00',1.79),('8902','2014-03-24','12:20:00',2.39),('8902','2014-03-24','12:25:00',2.65),('8902','2014-03-24','12:30:00',1.93),('8902','2014-03-24','12:35:00',1.34),('8902','2014-03-24','12:40:00',1.2),('8902','2014-03-24','13:30:00',1.4),('8902','2014-03-24','13:35:00',1.9),('8902','2014-03-24','13:40:00',1.81),('8902','2014-03-24','13:45:00',1.59),('8902','2014-03-24','13:50:00',1.57),('8902','2014-03-24','13:55:00',1.52),('8902','2014-03-24','14:00:00',1.29),('8902','2014-03-24','14:05:00',1.38),('8902','2014-03-24','14:10:00',1.67),('8902','2014-03-24','14:15:00',1.8),('8902','2014-03-24','14:20:00',1.35),('8902','2014-03-24','14:25:00',1.04),('8902','2014-03-24','14:30:00',1.04),('8902','2014-03-24','14:35:00',1.23),('8902','2014-03-24','14:40:00',1.13),('8902','2014-03-24','14:45:00',1.18),('8902','2014-03-24','15:15:00',1.15),('8902','2014-03-24','15:20:00',1.12),('8902','2013-03-11','08:20:00',2.87),('8902','2013-03-11','08:25:00',3.22),('8902','2013-03-11','08:30:00',3.36),('8902','2013-03-11','08:35:00',3.25),('8902','2013-03-11','08:40:00',3.26),('8902','2013-03-11','08:45:00',4.31),('8902','2013-03-11','08:50:00',3.14),('8902','2013-03-11','08:55:00',1.15),('8902','2013-03-11','09:00:00',1.99),('8902','2013-03-11','09:05:00',4.65),('8902','2013-03-11','09:10:00',4.77),('8902','2013-03-11','09:15:00',4.89),('8902','2013-03-11','09:20:00',5.02),('8902','2013-03-11','09:25:00',5.19),('8902','2013-03-11','09:30:00',4.99),('8902','2013-03-11','09:35:00',5.49),('8902','2013-03-11','09:40:00',5.61),('8902','2013-03-11','09:45:00',6),('8902','2013-03-11','09:50:00',2.32),('8902','2013-03-11','09:55:00',6.49),('8902','2013-03-11','10:00:00',5.95),('8902','2013-03-11','10:05:00',6.47),('8902','2013-03-11','10:10:00',5.67),('8902','2013-03-11','10:15:00',5.61),('8902','2013-03-11','10:20:00',3.57),('8902','2013-03-11','10:25:00',5.13),('8902','2013-03-11','10:30:00',3.46),('8902','2013-03-11','10:35:00',4.71),('8902','2013-03-11','10:40:00',4.04),('8902','2013-03-11','10:45:00',3.53),('8902','2013-03-11','10:50:00',5.56),('8902','2013-03-11','10:55:00',6.35),('8902','2013-03-11','11:00:00',7.95),('8902','2013-03-11','11:05:00',8.32),('8902','2013-03-11','11:10:00',6.37),('8902','2013-03-11','11:15:00',6.98),('8902','2013-03-11','11:20:00',7.17),('8902','2013-03-11','11:25:00',3.27),('8902','2013-03-11','11:30:00',2.84),('8902','2013-03-11','11:35:00',3.6),('8902','2013-03-11','11:40:00',4.18),('8902','2013-03-11','11:45:00',4.15),('8902','2013-03-11','11:50:00',4.8),('8902','2013-03-11','11:55:00',6.47),('8902','2013-03-11','12:00:00',1.75),('8902','2013-03-11','12:05:00',1.19),('8902','2013-03-11','12:10:00',5.51),('8902','2013-03-11','12:15:00',5.45),('8902','2013-03-11','12:20:00',4.3),('8902','2013-03-11','12:25:00',3.88),('8902','2013-03-11','12:30:00',8.29),('8902','2013-03-11','12:35:00',5.41),('8902','2013-03-11','12:40:00',7.92),('8902','2013-03-11','12:45:00',2.24),('8902','2013-03-11','12:50:00',3.17),('8902','2013-03-11','12:55:00',6.35),('8902','2013-03-11','13:00:00',6.22),('8902','2013-03-11','13:05:00',8.22),('8902','2013-03-11','13:10:00',5.14),('8902','2013-03-11','13:15:00',3.68),('8902','2013-03-11','13:20:00',5.65),('8902','2013-03-11','13:25:00',4.28),('8902','2013-03-11','13:30:00',2.65),('8902','2013-03-11','13:35:00',3.1),('8902','2013-03-11','13:40:00',2.31),('8902','2013-03-11','13:45:00',1.65),('8902','2013-03-11','13:50:00',1.71),('8902','2013-03-11','13:55:00',2.82),('8902','2013-03-11','14:00:00',3.23),('8902','2013-03-11','14:05:00',7.21),('8902','2013-03-11','14:10:00',4.75),('8902','2013-03-11','14:15:00',1.9),('8902','2013-03-11','14:20:00',2.37),('8902','2013-03-11','14:35:00',1.44),('8902','2013-03-11','15:00:00',1.17),('8902','2013-03-11','15:10:00',1.43),('8902','2013-03-11','15:15:00',1.15),('8902','2013-03-11','15:20:00',1.45),('8902','2013-03-11','15:25:00',1.36),('8902','2013-03-11','15:30:00',1.11),('8902','2013-03-10','07:40:00',1.26),('8902','2013-03-10','07:45:00',1.03),('8902','2013-03-10','08:10:00',2.24),('8902','2013-03-10','08:15:00',2.65),('8902','2013-03-10','08:20:00',2.85),('8902','2013-03-10','08:25:00',3.06),('8902','2013-03-10','08:30:00',3.26),('8902','2013-03-10','08:35:00',3.47),('8902','2013-03-10','08:40:00',3.63),('8902','2013-03-10','08:45:00',3.79),('8902','2013-03-10','08:50:00',3.99),('8902','2013-03-10','08:55:00',4.14),('8902','2013-03-10','09:00:00',4.27),('8902','2013-03-10','09:05:00',4.47),('8902','2013-03-10','09:10:00',4.59),('8902','2013-03-10','09:15:00',4.84),('8902','2013-03-10','09:20:00',4.58),('8902','2013-03-10','09:25:00',2.86),('8902','2013-03-10','09:30:00',2.19),('8902','2013-03-10','09:35:00',5.62),('8902','2013-03-10','09:40:00',6.33),('8902','2013-03-10','09:45:00',5.04),('8902','2013-03-10','09:50:00',3.09),('8902','2013-03-10','09:55:00',1.67),('8902','2013-03-10','10:00:00',1.5),('8902','2013-03-10','10:05:00',1.65),('8902','2013-03-10','10:10:00',1.99),('8902','2013-03-10','10:15:00',2.07),('8902','2013-03-10','10:20:00',2.3),('8902','2013-03-10','10:25:00',2.67),('8902','2013-03-10','10:30:00',2.47),('8902','2013-03-10','10:35:00',2.86),('8902','2013-03-10','10:40:00',5.11),('8902','2013-03-10','10:45:00',5.23),('8902','2013-03-10','10:50:00',5.92),('8902','2013-03-10','10:55:00',3.5),('8902','2013-03-10','11:00:00',2.88),('8902','2013-03-10','11:05:00',2.49),('8902','2013-03-10','11:10:00',2.95),('8902','2013-03-10','11:15:00',2.98),('8902','2013-03-10','11:20:00',2.54),('8902','2013-03-10','11:25:00',2.41),('8902','2013-03-10','11:30:00',3.51),('8902','2013-03-10','11:35:00',8.6),('8902','2013-03-10','11:40:00',4.83),('8902','2013-03-10','11:45:00',6.77),('8902','2013-03-10','11:50:00',4.7),('8902','2013-03-10','11:55:00',3.59),('8902','2013-03-10','12:00:00',3.25),('8902','2013-03-10','12:05:00',3.08),('8902','2013-03-10','12:10:00',2.67),('8902','2013-03-10','12:15:00',1.29),('8902','2013-03-10','12:20:00',1.58),('8902','2013-03-10','12:25:00',1.73),('8902','2013-03-10','12:30:00',1.88),('8902','2013-03-10','12:35:00',2.25),('8902','2013-03-10','12:40:00',2.36),('8902','2013-03-10','12:45:00',2.41),('8902','2013-03-10','12:50:00',4.9),('8902','2013-03-10','12:55:00',8.84),('8902','2013-03-10','13:00:00',4.92),('8902','2013-03-10','13:05:00',4.08),('8902','2013-03-10','13:10:00',7.39),('8902','2013-03-10','13:15:00',6.42),('8902','2013-03-10','13:20:00',6.58),('8902','2013-03-10','13:25:00',7.34),('8902','2013-03-10','13:30:00',7.24),('8902','2013-03-10','13:35:00',6.96),('8902','2013-03-10','13:40:00',5.74),('8902','2013-03-10','13:45:00',4.28),('8902','2013-03-10','13:50:00',8.07),('8902','2013-03-10','13:55:00',4.49),('8902','2013-03-10','14:00:00',1.93),('8902','2013-03-10','14:05:00',1.72),('8902','2013-03-10','14:10:00',1.5),('8902','2013-03-10','14:15:00',1.09),('8902','2013-03-10','14:20:00',1.01),('8902','2013-03-10','14:25:00',2.89),('8902','2013-03-10','14:30:00',2.24),('8902','2013-03-10','14:35:00',1.86),('8902','2013-03-10','14:40:00',2.12),('8902','2013-03-10','14:45:00',1.86),('8902','2013-03-10','14:50:00',1.15),('8902','2013-03-10','14:55:00',1.07),('8902','2013-03-10','15:00:00',1.02),('8902','2013-03-10','15:05:00',1.04),('8902','2013-03-10','15:15:00',1.05),('8902','2013-03-10','15:20:00',1.06),('8902','2013-03-10','15:25:00',1.17),('8902','2013-03-10','15:30:00',1.41),('8902','2013-03-10','15:35:00',1.74),('8902','2013-03-10','15:40:00',1.94),('8902','2013-03-10','15:45:00',4.76),('8902','2013-03-10','15:50:00',4.88),('8902','2013-03-10','15:55:00',4.56),('8902','2013-03-10','16:00:00',4.44),('8902','2013-03-10','16:05:00',2.78),('8902','2013-03-10','16:10:00',3.41),('8902','2013-03-10','16:15:00',2.53),('8902','2013-03-10','16:20:00',3.25),('8902','2013-03-10','16:25:00',3.23),('8902','2013-03-10','16:30:00',3.17),('8902','2013-03-10','16:35:00',2.59),('8902','2013-03-10','16:40:00',1.53),('8902','2013-03-10','16:45:00',2.95),('8902','2013-03-10','16:50:00',2.36),('8902','2013-03-10','17:05:00',1.06),('8902','2013-03-10','17:15:00',1.01),('8902','2013-03-10','17:20:00',1.07),('8902','2013-03-09','07:35:00',1.16),('8902','2013-03-09','07:40:00',1.08),('8902','2013-03-09','07:45:00',1.48),('8902','2013-03-09','07:50:00',1.66),('8902','2013-03-09','07:55:00',1.94),('8902','2013-03-09','08:00:00',2.09),('8902','2013-03-09','08:05:00',2.3),('8902','2013-03-09','08:10:00',2.43),('8902','2013-03-09','08:15:00',2.6),('8902','2013-03-09','08:20:00',2.87),('8902','2013-03-09','08:25:00',3.07),('8902','2013-03-09','08:30:00',3.24),('8902','2013-03-09','08:35:00',3.43),('8902','2013-03-09','08:40:00',3.62),('8902','2013-03-09','08:45:00',3.8),('8902','2013-03-09','08:50:00',3.95),('8902','2013-03-09','08:55:00',4.15),('8902','2013-03-09','09:00:00',4.32),('8902','2013-03-09','09:05:00',4.48),('8902','2013-03-09','09:10:00',4.61),('8902','2013-03-09','09:15:00',4.79),('8902','2013-03-09','09:20:00',4.91),('8902','2013-03-09','09:25:00',5.06),('8902','2013-03-09','09:30:00',5.22),('8902','2013-03-09','09:35:00',5.38),('8902','2013-03-09','09:40:00',5.64),('8902','2013-03-09','09:45:00',6.02),('8902','2013-03-09','09:50:00',5.49),('8902','2013-03-09','09:55:00',6.61),('8902','2013-03-09','10:00:00',6.62),('8902','2013-03-09','10:05:00',2.92),('8902','2013-03-09','10:10:00',3.56),('8902','2013-03-09','10:15:00',2.68),('8902','2013-03-09','10:20:00',6.77),('8902','2013-03-09','10:25:00',1.51),('8902','2013-03-09','10:30:00',5.41),('8902','2013-03-09','10:35:00',5.96),('8902','2013-03-09','10:40:00',6.59),('8902','2013-03-09','10:45:00',5.77),('8902','2013-03-09','10:50:00',4.84),('8902','2013-03-09','10:55:00',4.32),('8902','2013-03-09','11:00:00',6.31),('8902','2013-03-09','11:05:00',5.68),('8902','2013-03-09','11:10:00',7.05),('8902','2013-03-09','11:15:00',3.65),('8902','2013-03-09','11:20:00',4.77),('8902','2013-03-09','11:25:00',7.46),('8902','2013-03-09','11:30:00',3.45),('8902','2013-03-09','11:35:00',5.75),('8902','2013-03-09','11:40:00',3.72),('8902','2013-03-09','11:45:00',4.49),('8902','2013-03-09','11:50:00',6.84),('8902','2013-03-09','11:55:00',8),('8902','2013-03-09','12:00:00',7.89),('8902','2013-03-09','12:05:00',7.35),('8902','2013-03-09','12:10:00',6.02),('8902','2013-03-09','12:15:00',7.53),('8902','2013-03-09','12:20:00',4.57),('8902','2013-03-09','12:25:00',8.22),('8902','2013-03-09','12:30:00',2.79),('8902','2013-03-09','12:35:00',2.43),('8902','2013-03-09','12:40:00',5.99),('8902','2013-03-09','12:45:00',8.71),('8902','2013-03-09','12:50:00',5.82),('8902','2013-03-09','12:55:00',8.21),('8902','2013-03-09','13:00:00',7.75),('8902','2013-03-09','13:05:00',7.65),('8902','2013-03-09','13:10:00',7.37),('8902','2013-03-09','13:15:00',7.6),('8902','2013-03-09','13:20:00',7.45),('8902','2013-03-09','13:25:00',6.85),('8902','2013-03-09','13:30:00',6.85),('8902','2013-03-09','13:35:00',6.82),('8902','2013-03-09','13:40:00',3.92),('8902','2013-03-09','13:45:00',4.41),('8902','2013-03-09','13:50:00',3.49),('8902','2013-03-09','13:55:00',3.31),('8902','2013-03-09','14:00:00',2.91),('8902','2013-03-09','14:05:00',3.63),('8902','2013-03-09','14:10:00',4.24),('8902','2013-03-09','14:15:00',5.05),('8902','2013-03-09','14:20:00',5.38),('8902','2013-03-09','14:25:00',3.35),('8902','2013-03-09','14:30:00',4.35),('8902','2013-03-09','14:35:00',6.99),('8902','2013-03-09','14:40:00',5.79),('8902','2013-03-09','14:45:00',3.1),('8902','2013-03-09','14:50:00',3.38),('8902','2013-03-09','14:55:00',3.17),('8902','2013-03-09','15:00:00',2.39),('8902','2013-03-09','15:05:00',2.61),('8902','2013-03-09','15:10:00',2.62),('8902','2013-03-09','15:15:00',1.69),('8902','2013-03-09','15:20:00',1.7),('8902','2013-03-09','15:25:00',1.08),('8902','2013-03-09','15:35:00',1.05),('8902','2013-03-09','15:40:00',1.1),('8902','2013-03-09','15:45:00',1.08),('8902','2013-03-09','15:50:00',1.7),('8902','2013-03-09','15:55:00',1.37),('8902','2013-03-08','07:55:00',1.08),('8902','2013-03-08','08:00:00',1.51),('8902','2013-03-08','08:05:00',2.57),('8902','2013-03-08','08:10:00',2.48),('8902','2013-03-08','08:15:00',2.57),('8902','2013-03-08','08:20:00',2.13),('8902','2013-03-08','08:25:00',2.98),('8902','2013-03-08','08:30:00',3.17),('8902','2013-03-08','08:35:00',3.02),('8902','2013-03-08','08:40:00',2.95),('8902','2013-03-08','08:45:00',1.43),('8902','2013-03-08','08:50:00',1.77),('8902','2013-03-08','08:55:00',2.14),('8902','2013-03-08','09:00:00',2.1),('8902','2013-03-08','09:05:00',1.59),('8902','2013-03-08','09:10:00',1.18),('8902','2013-03-08','09:15:00',1.71),('8902','2013-03-08','09:20:00',1.31),('8902','2013-03-08','09:25:00',1.46),('8902','2013-03-08','09:30:00',3.87),('8902','2013-03-08','09:35:00',3),('8902','2013-03-08','09:40:00',5.56),('8902','2013-03-08','09:45:00',5.79),('8902','2013-03-08','09:50:00',5.04),('8902','2013-03-08','09:55:00',6),('8902','2013-03-08','10:00:00',3.6),('8902','2013-03-08','10:05:00',2.27),('8902','2013-03-08','10:10:00',2.51),('8902','2013-03-08','10:15:00',2.23),('8902','2013-03-08','10:20:00',3.9),('8902','2013-03-08','10:25:00',2.42),('8902','2013-03-08','10:30:00',2.87),('8902','2013-03-08','10:35:00',2.11),('8902','2013-03-08','10:40:00',4.03),('8902','2013-03-08','10:45:00',2.69),('8902','2013-03-08','10:50:00',5.56),('8902','2013-03-08','10:55:00',4.7),('8902','2013-03-08','11:00:00',4.48),('8902','2013-03-08','11:05:00',4.19),('8902','2013-03-08','11:10:00',5.19),('8902','2013-03-08','11:15:00',7.97),('8902','2013-03-08','11:20:00',7.68),('8902','2013-03-08','11:25:00',5.97),('8902','2013-03-08','11:30:00',3.57),('8902','2013-03-08','11:35:00',7.56),('8902','2013-03-08','11:40:00',6.25),('8902','2013-03-08','11:45:00',3.74),('8902','2013-03-08','11:50:00',7.99),('8902','2013-03-08','11:55:00',8),('8902','2013-03-08','12:00:00',6.13),('8902','2013-03-08','12:05:00',4.04),('8902','2013-03-08','12:10:00',3.89),('8902','2013-03-08','12:15:00',2.48),('8902','2013-03-08','12:20:00',2.47),('8902','2013-03-08','12:25:00',3.83),('8902','2013-03-08','12:30:00',2.62),('8902','2013-03-08','12:35:00',3.31),('8902','2013-03-08','12:40:00',2.72),('8902','2013-03-08','12:45:00',3.8),('8902','2013-03-08','12:50:00',4.64),('8902','2013-03-08','12:55:00',5.23),('8902','2013-03-08','13:00:00',7.95),('8902','2013-03-08','13:05:00',7.38),('8902','2013-03-08','13:10:00',7.17),('8902','2013-03-08','13:15:00',8.5),('8902','2013-03-08','13:20:00',7.51),('8902','2013-03-08','13:25:00',3.83),('8902','2013-03-08','13:30:00',7.25),('8902','2013-03-08','13:35:00',3.78),('8902','2013-03-08','13:40:00',2.77),('8902','2013-03-08','13:45:00',4.52),('8902','2013-03-08','13:50:00',5.93),('8902','2013-03-08','13:55:00',1.77),('8902','2013-03-08','14:00:00',2.45),('8902','2013-03-08','14:05:00',7.78),('8902','2013-03-08','14:10:00',7.65),('8902','2013-03-08','14:15:00',7.07),('8902','2013-03-08','14:20:00',6.82),('8902','2013-03-08','14:25:00',6.66),('8902','2013-03-08','14:30:00',6.59),('8902','2013-03-08','14:35:00',6.47),('8902','2013-03-08','14:40:00',6.37),('8902','2013-03-08','14:45:00',6.26),('8902','2013-03-08','14:50:00',6.14),('8902','2013-03-08','14:55:00',6.04),('8902','2013-03-08','15:00:00',5.94),('8902','2013-03-08','15:05:00',5.82),('8902','2013-03-08','15:10:00',5.7),('8902','2013-03-08','15:15:00',5.55),('8902','2013-03-08','15:20:00',5.42),('8902','2013-03-08','15:25:00',5.2),('8902','2013-03-08','15:30:00',5.09),('8902','2013-03-08','15:35:00',4.91),('8902','2013-03-08','15:40:00',4.88),('8902','2013-03-08','15:45:00',4.71),('8902','2013-03-08','15:50:00',4.42),('8902','2013-03-08','15:55:00',4.12),('8902','2013-03-08','16:00:00',3.71),('8902','2013-03-08','16:05:00',3.8),('8902','2013-03-08','16:10:00',3.16),('8902','2013-03-08','16:15:00',3.51),('8902','2013-03-08','16:20:00',2.91),('8902','2013-03-08','16:25:00',3.34),('8902','2013-03-08','16:30:00',2.91),('8902','2013-03-08','16:35:00',2.38),('8902','2013-03-08','16:40:00',2.13),('8902','2013-03-08','16:45:00',1.57),('8902','2013-03-08','16:50:00',1.42),('8902','2013-03-07','08:10:00',2.1),('8902','2013-03-07','08:15:00',1.91),('8902','2013-03-07','08:20:00',1.04),('8902','2013-03-07','08:25:00',1.24),('8902','2013-03-07','08:30:00',2.23),('8902','2013-03-07','08:35:00',2.92),('8902','2013-03-07','08:40:00',1.62),('8902','2013-03-07','08:45:00',1.23),('8902','2013-03-07','08:50:00',2.14),('8902','2013-03-07','08:55:00',2),('8902','2013-03-07','09:00:00',1.2),('8902','2013-03-07','09:05:00',1.02),('8902','2013-03-07','09:10:00',1.27),('8902','2013-03-07','09:15:00',1.73),('8902','2013-03-07','09:20:00',1.68),('8902','2013-03-07','09:25:00',1.61),('8902','2013-03-07','09:30:00',2.67),('8902','2013-03-07','09:35:00',3.8),('8902','2013-03-07','09:40:00',2.59),('8902','2013-03-07','09:45:00',4.02),('8902','2013-03-07','09:50:00',5.39),('8902','2013-03-07','09:55:00',3.71),('8902','2013-03-07','10:00:00',1.89),('8902','2013-03-07','10:05:00',2.34),('8902','2013-03-07','10:10:00',2.88),('8902','2013-03-07','10:15:00',2.6),('8902','2013-03-07','10:20:00',3.7),('8902','2013-03-07','10:25:00',3.31),('8902','2013-03-07','10:30:00',2.84),('8902','2013-03-07','10:35:00',5.44),('8902','2013-03-07','10:40:00',4.08),('8902','2013-03-07','10:45:00',2.24),('8902','2013-03-07','10:50:00',2.58),('8902','2013-03-07','10:55:00',2.34),('8902','2013-03-07','11:00:00',2.18),('8902','2013-03-07','11:05:00',1.71),('8902','2013-03-07','11:10:00',1.06),('8902','2013-03-07','11:25:00',1),('8902','2013-03-07','11:30:00',1.29),('8902','2013-03-07','11:35:00',3.42),('8902','2013-03-07','11:40:00',4.63),('8902','2013-03-07','11:45:00',3.65),('8902','2013-03-07','11:50:00',3.16),('8902','2013-03-07','11:55:00',3.37),('8902','2013-03-07','12:00:00',3.79),('8902','2013-03-07','12:05:00',2.27),('8902','2013-03-07','12:10:00',1.71),('8902','2013-03-07','12:15:00',1.57),('8902','2013-03-07','12:20:00',2.71),('8902','2013-03-07','12:25:00',2.19),('8902','2013-03-07','12:30:00',1.99),('8902','2013-03-07','12:35:00',2.9),('8902','2013-03-07','12:40:00',4.3),('8902','2013-03-07','12:45:00',4.87),('8902','2013-03-07','12:50:00',4.74),('8902','2013-03-07','12:55:00',3.85),('8902','2013-03-07','13:00:00',4.31),('8902','2013-03-07','13:05:00',4.61),('8902','2013-03-07','13:10:00',2.85),('8902','2013-03-07','13:15:00',2.31),('8902','2013-03-07','13:20:00',2.18),('8902','2013-03-07','13:25:00',2.79),('8902','2013-03-07','13:30:00',3.48),('8902','2013-03-07','13:35:00',2.54),('8902','2013-03-07','13:40:00',2.29),('8902','2013-03-07','13:45:00',1.41),('8902','2013-03-07','13:50:00',1.17),('8902','2013-03-07','13:55:00',1.78),('8902','2013-03-07','14:00:00',1.18),('8902','2013-03-07','16:55:00',1.18),('8902','2013-03-07','17:00:00',1.05),('8902','2013-03-07','17:05:00',1.02),('8902','2013-03-07','17:10:00',2.13),('8902','2013-03-07','17:15:00',2.33),('8902','2013-03-07','17:20:00',1.26),('8902','2013-03-06','08:35:00',1.1),('8902','2013-03-06','08:40:00',1.57),('8902','2013-03-06','08:45:00',1.55),('8902','2013-03-06','08:50:00',1.86),('8902','2013-03-06','08:55:00',1.54),('8902','2013-03-06','09:00:00',1.47),('8902','2013-03-06','09:05:00',1.52),('8902','2013-03-06','09:10:00',1.25),('8902','2013-03-06','09:15:00',1.28),('8902','2013-03-06','09:20:00',1.92),('8902','2013-03-06','09:55:00',1),('8902','2013-03-06','10:25:00',1.02),('8902','2013-03-06','10:30:00',1.78),('8902','2013-03-06','10:35:00',1.05),('8902','2013-03-06','10:50:00',1.75),('8902','2013-03-06','10:55:00',2.31),('8902','2013-03-06','11:00:00',1.98),('8902','2013-03-06','11:05:00',2.84),('8902','2013-03-06','11:10:00',2.16),('8902','2013-03-06','11:15:00',1.26),('8902','2013-03-06','11:25:00',1.34),('8902','2013-03-06','11:30:00',2.72),('8902','2013-03-06','11:35:00',3.32),('8902','2013-03-06','11:40:00',3.01),('8902','2013-03-06','11:45:00',3.23),('8902','2013-03-06','11:50:00',3.24),('8902','2013-03-06','11:55:00',2.69),('8902','2013-03-06','12:00:00',2.09),('8902','2013-03-06','12:05:00',1.87),('8902','2013-03-06','12:10:00',1.08),('8902','2013-03-06','12:25:00',1.53),('8902','2013-03-06','12:30:00',1.93),('8902','2013-03-06','12:35:00',1.78),('8902','2013-03-06','12:40:00',2.82),('8902','2013-03-06','12:45:00',3.92),('8902','2013-03-06','12:50:00',3.27),('8902','2013-03-06','12:55:00',2.94),('8902','2013-03-06','13:00:00',3.1),('8902','2013-03-06','13:05:00',2.93),('8902','2013-03-06','13:10:00',2.39),('8902','2013-03-06','13:15:00',3.01),('8902','2013-03-06','13:20:00',3.94),('8902','2013-03-06','13:25:00',3.4),('8902','2013-03-06','13:30:00',2.98),('8902','2013-03-06','13:35:00',2.63),('8902','2013-03-06','13:40:00',1.57),('8902','2013-03-06','13:45:00',1.23),('8902','2013-03-06','13:50:00',1.24),('8902','2013-03-06','13:55:00',1.44),('8902','2013-03-06','14:00:00',1.12),('8902','2013-03-06','14:05:00',1.68),('8902','2013-03-06','14:10:00',1.84),('8902','2013-03-06','14:15:00',1.38),('8902','2013-03-06','14:20:00',1.34),('8902','2013-03-06','14:25:00',1.38),('8902','2013-03-06','14:30:00',1.3),('8902','2013-03-06','14:45:00',1.15),('8902','2013-03-06','14:50:00',1.25),('8902','2013-03-06','14:55:00',1.06),('8902','2013-03-06','15:20:00',1.05),('8902','2013-03-06','15:25:00',1.37),('8902','2013-03-06','15:35:00',1.07),('8902','2013-03-06','15:40:00',1.3),('8902','2013-03-06','15:45:00',1.08),('8902','2013-03-06','16:05:00',1.31),('8902','2013-03-06','16:10:00',1.29),('8902','2013-03-06','16:15:00',1.16),('8902','2013-03-06','16:20:00',1.12),('8902','2013-03-06','16:25:00',1.01),('8902','2013-03-06','16:35:00',1.1),('8902','2013-03-06','16:40:00',2.04),('8902','2013-03-06','16:45:00',1.41),('8902','2013-03-05','09:10:00',1.05),('8902','2013-03-05','09:25:00',1.03),('8902','2013-03-05','16:00:00',1.03),('8902','2013-03-05','16:05:00',1.03),('8902','2013-03-04','08:00:00',1.05),('8902','2013-03-04','08:05:00',1.35),('8902','2013-03-04','08:10:00',1.63),('8902','2013-03-04','08:15:00',2.23),('8902','2013-03-04','08:20:00',1.96),('8902','2013-03-04','08:25:00',2.33),('8902','2013-03-04','08:30:00',3.56),('8902','2013-03-04','08:35:00',3.04),('8902','2013-03-04','08:40:00',3.26),('8902','2013-03-04','08:45:00',2.7),('8902','2013-03-04','08:50:00',2.87),('8902','2013-03-04','08:55:00',2.74),('8902','2013-03-04','09:00:00',3.13),('8902','2013-03-04','09:05:00',3.08),('8902','2013-03-04','09:10:00',2.92),('8902','2013-03-04','09:15:00',2.76),('8902','2013-03-04','09:20:00',2.76),('8902','2013-03-04','09:25:00',2.7),('8902','2013-03-04','09:30:00',2.85),('8902','2013-03-04','09:35:00',3.1),('8902','2013-03-04','09:40:00',3.28),('8902','2013-03-04','09:45:00',3.33),('8902','2013-03-04','09:50:00',3.39),('8902','2013-03-04','09:55:00',3.16),('8902','2013-03-04','10:00:00',3.02),('8902','2013-03-04','10:05:00',3.36),('8902','2013-03-04','10:10:00',3.59),('8902','2013-03-04','10:15:00',3.63),('8902','2013-03-04','10:20:00',3.98),('8902','2013-03-04','10:25:00',3.74),('8902','2013-03-04','10:30:00',3.54),('8902','2013-03-04','10:35:00',4.26),('8902','2013-03-04','10:40:00',4.43),('8902','2013-03-04','10:45:00',4.59),('8902','2013-03-04','10:50:00',4.91),('8902','2013-03-04','10:55:00',5.05),('8902','2013-03-04','11:00:00',4.77),('8902','2013-03-04','11:05:00',5.03),('8902','2013-03-04','11:10:00',5.24),('8902','2013-03-04','11:15:00',5.15),('8902','2013-03-04','11:20:00',5.01),('8902','2013-03-04','11:25:00',4.8),('8902','2013-03-04','11:30:00',4.88),('8902','2013-03-04','11:35:00',5.32),('8902','2013-03-04','11:40:00',5.92),('8902','2013-03-04','11:45:00',5.73),('8902','2013-03-04','11:50:00',5.82),('8902','2013-03-04','11:55:00',5.94),('8902','2013-03-04','12:00:00',6.14),('8902','2013-03-04','12:05:00',6.34),('8902','2013-03-04','12:10:00',6.58),('8902','2013-03-04','12:15:00',5.39),('8902','2013-03-04','12:20:00',6.02),('8902','2013-03-04','12:25:00',6.14),('8902','2013-03-04','12:30:00',5.2),('8902','2013-03-04','12:35:00',5.38),('8902','2013-03-04','12:40:00',4.89),('8902','2013-03-04','12:45:00',5.12),('8902','2013-03-04','12:50:00',4.44),('8902','2013-03-04','12:55:00',4.02),('8902','2013-03-04','13:00:00',3.24),('8902','2013-03-04','13:05:00',3.07),('8902','2013-03-04','13:10:00',3.29),('8902','2013-03-04','13:15:00',3.52),('8902','2013-03-04','13:20:00',3.41),('8902','2013-03-04','13:25:00',3.03),('8902','2013-03-04','13:30:00',2.77),('8902','2013-03-04','13:35:00',2.59),('8902','2013-03-04','13:40:00',2.46),('8902','2013-03-04','13:45:00',2.23),('8902','2013-03-04','13:50:00',2.03),('8902','2013-03-04','13:55:00',1.9),('8902','2013-03-04','14:00:00',1.88),('8902','2013-03-04','14:05:00',1.92),('8902','2013-03-04','14:10:00',2.01),('8902','2013-03-04','14:15:00',1.89),('8902','2013-03-04','14:20:00',1.76),('8902','2013-03-04','14:25:00',1.79),('8902','2013-03-04','14:30:00',1.74),('8902','2013-03-04','14:35:00',1.75),('8902','2013-03-04','14:40:00',1.82),('8902','2013-03-04','14:45:00',1.86),('8902','2013-03-04','14:50:00',1.81),('8902','2013-03-04','14:55:00',1.64),('8902','2013-03-04','15:00:00',1.47),('8902','2013-03-04','15:05:00',1.37),('8902','2013-03-04','15:10:00',1.15),('8902','2013-03-04','15:20:00',1.09),('8902','2013-03-04','15:25:00',1.29),('8902','2013-03-04','15:30:00',1.53),('8902','2013-03-04','15:35:00',1.62),('8902','2013-03-04','15:40:00',1.68),('8902','2013-03-04','15:45:00',2.13),('8902','2013-03-04','15:50:00',2.18),('8902','2013-03-04','15:55:00',1.8),('8902','2013-03-04','16:00:00',1.57),('8902','2013-03-04','16:05:00',1.36),('8902','2013-03-04','16:10:00',1.1),('8902','2013-03-03','07:45:00',1.14),('8902','2013-03-03','07:50:00',1.39),('8902','2013-03-03','07:55:00',1.58),('8902','2013-03-03','08:00:00',1.78),('8902','2013-03-03','08:05:00',1.97),('8902','2013-03-03','08:10:00',2.16),('8902','2013-03-03','08:15:00',2.36),('8902','2013-03-03','08:20:00',2.54),('8902','2013-03-03','08:25:00',2.69),('8902','2013-03-03','08:30:00',2.86),('8902','2013-03-03','08:35:00',3.03),('8902','2013-03-03','08:40:00',3.22),('8902','2013-03-03','08:45:00',3.43),('8902','2013-03-03','08:50:00',3.6),('8902','2013-03-03','08:55:00',3.79),('8902','2013-03-03','09:00:00',3.95),('8902','2013-03-03','09:05:00',4.1),('8902','2013-03-03','09:10:00',4.25),('8902','2013-03-03','09:15:00',4.42),('8902','2013-03-03','09:20:00',4.57),('8902','2013-03-03','09:25:00',4.7),('8902','2013-03-03','09:30:00',4.86),('8902','2013-03-03','09:35:00',4.97),('8902','2013-03-03','09:40:00',5.13),('8902','2013-03-03','09:45:00',5.26),('8902','2013-03-03','09:50:00',5.38),('8902','2013-03-03','09:55:00',5.52),('8902','2013-03-03','10:00:00',5.62),('8902','2013-03-03','10:05:00',5.77),('8902','2013-03-03','10:10:00',5.87),('8902','2013-03-03','10:15:00',5.98),('8902','2013-03-03','10:20:00',6.09),('8902','2013-03-03','10:25:00',6.17),('8902','2013-03-03','10:30:00',6.28),('8902','2013-03-03','10:35:00',6.35),('8902','2013-03-03','10:40:00',6.4),('8902','2013-03-03','10:45:00',6.49),('8902','2013-03-03','10:50:00',6.58),('8902','2013-03-03','10:55:00',6.57),('8902','2013-03-03','11:00:00',6.58),('8902','2013-03-03','11:05:00',6.64),('8902','2013-03-03','11:10:00',6.65),('8902','2013-03-03','11:15:00',6.87),('8902','2013-03-03','11:20:00',6.97),('8902','2013-03-03','11:25:00',6.95),('8902','2013-03-03','11:30:00',6.96),('8902','2013-03-03','11:35:00',6.99),('8902','2013-03-03','11:40:00',6.97),('8902','2013-03-03','11:45:00',7.13),('8902','2013-03-03','11:50:00',7.17),('8902','2013-03-03','11:55:00',7.1),('8902','2013-03-03','12:00:00',7.16),('8902','2013-03-03','12:05:00',7.08),('8902','2013-03-03','12:10:00',7.1),('8902','2013-03-03','12:15:00',7.24),('8902','2013-03-03','12:20:00',7.28),('8902','2013-03-03','12:25:00',7.29),('8902','2013-03-03','12:30:00',7.28),('8902','2013-03-03','12:35:00',7.25),('8902','2013-03-03','12:40:00',7.23),('8902','2013-03-03','12:45:00',7.22),('8902','2013-03-03','12:50:00',7.15),('8902','2013-03-03','12:55:00',7.16),('8902','2013-03-03','13:00:00',6.96),('8902','2013-03-03','13:05:00',6.93),('8902','2013-03-03','13:10:00',6.97),('8902','2013-03-03','13:15:00',7.03),('8902','2013-03-03','13:20:00',6.95),('8902','2013-03-03','13:25:00',6.83),('8902','2013-03-03','13:30:00',6.48),('8902','2013-03-03','13:35:00',6.93),('8902','2013-03-03','13:40:00',6.57),('8902','2013-03-03','13:45:00',6.07),('8902','2013-03-03','13:50:00',6.59),('8902','2013-03-03','13:55:00',6.55),('8902','2013-03-03','14:00:00',6.56),('8902','2013-03-03','14:05:00',6.43),('8902','2013-03-03','14:10:00',6.32),('8902','2013-03-03','14:15:00',6.21),('8902','2013-03-03','14:20:00',6.05),('8902','2013-03-03','14:25:00',5.41),('8902','2013-03-03','14:30:00',3.84),('8902','2013-03-03','14:35:00',5.15),('8902','2013-03-03','14:40:00',5.68),('8902','2013-03-03','14:45:00',5.61),('8902','2013-03-03','14:50:00',5.44),('8902','2013-03-03','14:55:00',5.53),('8902','2013-03-03','15:00:00',5.31),('8902','2013-03-03','15:05:00',5.12),('8902','2013-03-03','15:10:00',4.99),('8902','2013-03-03','15:15:00',4.86),('8902','2013-03-03','15:20:00',4.69),('8902','2013-03-03','15:25:00',4.51),('8902','2013-03-03','15:30:00',4.45),('8902','2013-03-03','15:35:00',4.34),('8902','2013-03-03','15:40:00',4.13),('8902','2013-03-03','15:45:00',4),('8902','2013-03-03','15:50:00',3.74),('8902','2013-03-03','15:55:00',3.59),('8902','2013-03-03','16:00:00',3.51),('8902','2013-03-03','16:05:00',3.35),('8902','2013-03-03','16:10:00',3.16),('8902','2013-03-03','16:15:00',3),('8902','2013-03-03','16:20:00',2.85),('8902','2013-03-03','16:25:00',2.73),('8902','2013-03-03','16:30:00',2.5),('8902','2013-03-03','16:35:00',2.2),('8902','2013-03-03','16:40:00',2.16),('8902','2013-03-03','16:45:00',1.98),('8902','2013-03-03','16:50:00',1.8),('8902','2013-03-03','16:55:00',1.6),('8902','2013-03-03','17:00:00',1.39),('8902','2013-03-03','17:05:00',1.18),('8902','2013-03-03','17:10:00',1.03),('8902','2013-03-02','07:40:00',1),('8902','2013-03-02','07:45:00',1.21),('8902','2013-03-02','07:50:00',1.37),('8902','2013-03-02','07:55:00',1.57),('8902','2013-03-02','08:00:00',1.77),('8902','2013-03-02','08:05:00',1.97),('8902','2013-03-02','08:10:00',2.16),('8902','2013-03-02','08:15:00',2.42),('8902','2013-03-02','08:20:00',2.63),('8902','2013-03-02','08:25:00',2.83),('8902','2013-03-02','08:30:00',3.01),('8902','2013-03-02','08:35:00',3.23),('8902','2013-03-02','08:40:00',3.43),('8902','2013-03-02','08:45:00',3.61),('8902','2013-03-02','08:50:00',3.8),('8902','2013-03-02','08:55:00',3.97),('8902','2013-03-02','09:00:00',4.12),('8902','2013-03-02','09:05:00',4.29),('8902','2013-03-02','09:10:00',4.44),('8902','2013-03-02','09:15:00',4.61),('8902','2013-03-02','09:20:00',4.76),('8902','2013-03-02','09:25:00',4.91),('8902','2013-03-02','09:30:00',5.08),('8902','2013-03-02','09:35:00',5.22),('8902','2013-03-02','09:40:00',5.35),('8902','2013-03-02','09:45:00',5.54),('8902','2013-03-02','09:50:00',5.72),('8902','2013-03-02','09:55:00',5.86),('8902','2013-03-02','10:00:00',5.98),('8902','2013-03-02','10:05:00',6.11),('8902','2013-03-02','10:10:00',6.21),('8902','2013-03-02','10:15:00',6.31),('8902','2013-03-02','10:20:00',6.42),('8902','2013-03-02','10:25:00',6.54),('8902','2013-03-02','10:30:00',6.62),('8902','2013-03-02','10:35:00',6.72),('8902','2013-03-02','10:40:00',6.78),('8902','2013-03-02','10:45:00',6.84),('8902','2013-03-02','10:50:00',6.92),('8902','2013-03-02','10:55:00',6.97),('8902','2013-03-02','11:00:00',7),('8902','2013-03-02','11:05:00',7.05),('8902','2013-03-02','11:10:00',7.07),('8902','2013-03-02','11:15:00',7.12),('8902','2013-03-02','11:20:00',7.19),('8902','2013-03-02','11:25:00',7.23),('8902','2013-03-02','11:30:00',7.26),('8902','2013-03-02','11:35:00',7.28),('8902','2013-03-02','11:40:00',7.36),('8902','2013-03-02','11:45:00',7.41),('8902','2013-03-02','11:50:00',7.42),('8902','2013-03-02','11:55:00',7.42),('8902','2013-03-02','12:00:00',7.44),('8902','2013-03-02','12:05:00',7.46),('8902','2013-03-02','12:10:00',7.49),('8902','2013-03-02','12:15:00',7.48),('8902','2013-03-02','12:20:00',7.5),('8902','2013-03-02','12:25:00',7.49),('8902','2013-03-02','12:30:00',7.52),('8902','2013-03-02','12:35:00',7.51),('8902','2013-03-02','12:40:00',7.49),('8902','2013-03-02','12:45:00',7.48),('8902','2013-03-02','12:50:00',7.46),('8902','2013-03-02','12:55:00',7.45),('8902','2013-03-02','13:00:00',7.42),('8902','2013-03-02','13:05:00',7.4),('8902','2013-03-02','13:10:00',7.4),('8902','2013-03-02','13:15:00',7.39),('8902','2013-03-02','13:20:00',7.31),('8902','2013-03-02','13:25:00',7.27),('8902','2013-03-02','13:30:00',7.24),('8902','2013-03-02','13:35:00',7.17),('8902','2013-03-02','13:40:00',7.1),('8902','2013-03-02','13:45:00',7.05),('8902','2013-03-02','13:50:00',6.94),('8902','2013-03-02','13:55:00',6.9),('8902','2013-03-02','14:00:00',6.85),('8902','2013-03-02','14:05:00',6.75),('8902','2013-03-02','14:10:00',6.72),('8902','2013-03-02','14:15:00',6.66),('8902','2013-03-02','14:20:00',6.61),('8902','2013-03-02','14:25:00',6.49),('8902','2013-03-02','14:30:00',6.38),('8902','2013-03-02','14:35:00',6.28),('8902','2013-03-02','14:40:00',6.2),('8902','2013-03-02','14:45:00',6.06),('8902','2013-03-02','14:50:00',5.98),('8902','2013-03-02','14:55:00',5.84),('8902','2013-03-02','15:00:00',5.71),('8902','2013-03-02','15:05:00',5.6),('8902','2013-03-02','15:10:00',5.43),('8902','2013-03-02','15:15:00',5.36),('8902','2013-03-02','15:20:00',5.26),('8902','2013-03-02','15:25:00',5.1),('8902','2013-03-02','15:30:00',4.93),('8902','2013-03-02','15:35:00',4.81),('8902','2013-03-02','15:40:00',4.62),('8902','2013-03-02','15:45:00',4.48),('8902','2013-03-02','15:50:00',4.27),('8902','2013-03-02','15:55:00',4.12),('8902','2013-03-02','16:00:00',3.94),('8902','2013-03-02','16:05:00',3.75),('8902','2013-03-02','16:10:00',3.62),('8902','2013-03-02','16:15:00',3.39),('8902','2013-03-02','16:23:00',3.23),('8902','2013-03-02','16:25:00',2.94),('8902','2013-03-02','16:33:00',2.81),('8902','2013-03-02','16:35:00',2.53),('8902','2013-03-02','16:46:00',2.42),('8902','2013-03-02','16:50:00',1.99),('8902','2013-03-02','16:58:00',1.8),('8902','2013-03-02','17:00:00',1.48),('8902','2013-03-02','17:08:00',1.37),('8902','2013-03-02','17:10:00',1.1),('8902','2014-03-23','07:35:00',1.11),('8902','2014-03-23','07:45:00',2.05),('8902','2014-03-23','07:50:00',1.57),('8902','2014-03-23','07:55:00',1.52),('8902','2014-03-23','08:30:00',1.02),('8902','2014-03-23','08:35:00',1.57),('8902','2014-03-23','08:40:00',1.69),('8902','2014-03-23','08:45:00',1.38),('8902','2014-03-23','08:50:00',1.45),('8902','2014-03-23','08:55:00',2.93),('8902','2014-03-23','09:00:00',3.31),('8902','2014-03-23','09:05:00',2.92),('8902','2014-03-23','09:10:00',1.3),('8902','2014-03-23','09:15:00',1.32),('8902','2014-03-23','09:20:00',4.02),('8902','2014-03-23','09:25:00',1.58),('8902','2014-03-23','09:30:00',2.89),('8902','2014-03-23','09:35:00',1.65),('8902','2014-03-23','09:40:00',2.87),('8902','2014-03-23','09:45:00',2.33),('8902','2014-03-23','09:50:00',2),('8902','2014-03-23','09:55:00',1.25),('8902','2014-03-23','10:00:00',3.53),('8902','2014-03-23','10:05:00',4.31),('8902','2014-03-23','10:10:00',6.55),('8902','2014-03-23','10:15:00',5.94),('8902','2014-03-23','10:20:00',1.79),('8902','2014-03-23','10:25:00',1.5),('8902','2014-03-23','10:30:00',1.42),('8902','2014-03-23','10:35:00',2.57),('8902','2014-03-23','10:40:00',2.33),('8902','2014-03-23','10:45:00',3.01),('8902','2014-03-23','10:50:00',9.11),('8902','2014-03-23','10:55:00',7.96),('8902','2014-03-23','11:00:00',2.95),('8902','2014-03-23','11:05:00',5.21),('8902','2014-03-23','11:10:00',5.18),('8902','2014-03-23','11:15:00',5.79),('8902','2014-03-23','11:20:00',4.1),('8902','2014-03-23','11:25:00',5.06),('8902','2014-03-23','11:30:00',6.58),('8902','2014-03-23','11:35:00',3.82),('8902','2014-03-23','11:40:00',1.5),('8902','2014-03-23','11:45:00',1.18),('8902','2014-03-23','11:50:00',1.15),('8902','2014-03-23','11:55:00',1.46),('8902','2014-03-23','12:00:00',1.37),('8902','2014-03-23','12:20:00',1.17),('8902','2014-03-23','12:25:00',1.34),('8902','2014-03-23','12:30:00',2.07),('8902','2014-03-23','12:35:00',3.54),('8902','2014-03-23','12:40:00',3.89),('8902','2014-03-23','12:45:00',3.44),('8902','2014-03-23','12:50:00',2.86),('8902','2014-03-23','12:55:00',2.66),('8902','2014-03-23','13:00:00',2.71),('8902','2014-03-23','13:05:00',2.71),('8902','2014-03-23','13:10:00',2.43),('8902','2014-03-23','13:15:00',1.93),('8902','2014-03-23','13:20:00',1.84),('8902','2014-03-23','13:25:00',2.29),('8902','2014-03-23','13:30:00',2.71),('8902','2014-03-23','13:35:00',2.46),('8902','2014-03-23','13:40:00',1.33),('8902','2014-03-23','13:45:00',1.55),('8902','2014-03-23','13:50:00',2.6),('8902','2014-03-23','13:55:00',2.52),('8902','2014-03-23','14:00:00',2.35),('8902','2014-03-23','14:05:00',2.03),('8902','2014-03-23','14:10:00',2.37),('8902','2014-03-23','14:15:00',3.09),('8902','2014-03-23','14:20:00',4.11),('8902','2014-03-23','14:25:00',4.04),('8902','2014-03-23','14:30:00',3.51),('8902','2014-03-23','14:35:00',4.52),('8902','2014-03-23','14:40:00',5.85),('8902','2014-03-23','14:45:00',6.86),('8902','2014-03-23','14:50:00',7.27),('8902','2014-03-23','14:55:00',6.4),('8902','2014-03-23','15:00:00',5.7),('8902','2014-03-23','15:05:00',5.08),('8902','2014-03-23','15:10:00',4.47),('8902','2014-03-23','15:15:00',2.79),('8902','2014-03-23','15:20:00',3.34),('8902','2014-03-23','15:25:00',2.71),('8902','2014-03-23','15:30:00',3.68),('8902','2014-03-23','15:35:00',2.86),('8902','2014-03-23','15:40:00',2.49),('8902','2014-03-23','15:45:00',2.21),('8902','2014-03-23','15:50:00',2.75),('8902','2014-03-23','15:55:00',2.96),('8902','2014-03-23','16:00:00',5.95),('8902','2014-03-23','16:05:00',2.78),('8902','2014-03-23','16:10:00',2.22),('8902','2014-03-23','16:15:00',1.73),('8902','2014-03-23','16:20:00',1.12),('8902','2013-03-01','09:00:00',1.03),('8902','2013-03-01','09:40:00',1.1),('8902','2013-03-01','09:45:00',1.22),('8902','2013-03-01','09:50:00',1.28),('8902','2013-03-01','09:55:00',1.11),('8902','2013-03-01','10:00:00',1.11),('8902','2013-03-01','10:05:00',1.11),('8902','2013-03-01','10:10:00',1.01),('8902','2013-03-01','10:15:00',1.1),('8902','2013-03-01','10:20:00',1.28),('8902','2013-03-01','10:25:00',1.31),('8902','2013-03-01','10:30:00',1.39),('8902','2013-03-01','10:35:00',1.57),('8902','2013-03-01','10:40:00',1.71),('8902','2013-03-01','10:45:00',1.71),('8902','2013-03-01','10:50:00',1.89),('8902','2013-03-01','10:55:00',1.99),('8902','2013-03-01','11:00:00',2.09),('8902','2013-03-01','11:05:00',2.07),('8902','2013-03-01','11:10:00',2.3),('8902','2013-03-01','11:15:00',2.55),('8902','2013-03-01','11:20:00',2.29),('8902','2013-03-01','11:25:00',1.99),('8902','2013-03-01','11:30:00',1.88),('8902','2013-03-01','11:35:00',1.98),('8902','2013-03-01','11:40:00',2.2),('8902','2013-03-01','11:45:00',1.99),('8902','2013-03-01','11:50:00',2.01),('8902','2013-03-01','11:55:00',1.86),('8902','2013-03-01','12:00:00',1.85),('8902','2013-03-01','12:05:00',2.15),('8902','2013-03-01','12:10:00',2.2),('8902','2013-03-01','12:15:00',2.21),('8902','2013-03-01','12:20:00',2.05),('8902','2013-03-01','12:25:00',2.22),('8902','2013-03-01','12:30:00',2.25),('8902','2013-03-01','12:35:00',2.51),('8902','2013-03-01','12:40:00',2.58),('8902','2013-03-01','12:45:00',2.4),('8902','2013-03-01','12:50:00',2.33),('8902','2013-03-01','12:55:00',2.69),('8902','2013-03-01','13:00:00',2.68),('8902','2013-03-01','13:05:00',2.38),('8902','2013-03-01','13:10:00',1.99),('8902','2013-03-01','13:15:00',1.73),('8902','2013-03-01','13:20:00',1.63),('8902','2013-03-01','13:25:00',1.6),('8902','2013-03-01','13:30:00',1.72),('8902','2013-03-01','13:35:00',1.72),('8902','2013-03-01','13:40:00',1.86),('8902','2013-03-01','13:45:00',2.07),('8902','2013-03-01','13:50:00',2),('8902','2013-03-01','13:55:00',2.15),('8902','2013-03-01','14:00:00',2.5),('8902','2013-03-01','14:05:00',2.49),('8902','2013-03-01','14:10:00',2.1),('8902','2013-03-01','14:15:00',1.83),('8902','2013-03-01','14:20:00',1.74),('8902','2013-03-01','14:25:00',1.48),('8902','2013-03-01','14:30:00',1.02),('8902','2013-03-01','14:50:00',1.19),('8902','2013-03-01','14:55:00',1.29),('8902','2013-03-01','15:00:00',1.33),('8902','2013-03-01','15:05:00',1.49),('8902','2013-03-01','15:10:00',1.44),('8902','2013-03-01','15:15:00',1.45),('8902','2013-03-01','15:20:00',1.38),('8902','2013-03-01','15:25:00',1.33),('8902','2013-03-01','15:30:00',1.5),('8902','2013-03-01','15:35:00',1.46),('8902','2013-03-01','15:40:00',1.45),('8902','2013-03-01','15:45:00',1.57),('8902','2013-03-01','15:50:00',1.34),('8902','2013-03-01','15:55:00',1.28),('8902','2013-03-01','16:00:00',1.15),('8902','2013-03-01','16:05:00',1.02),('8902','2013-02-28','07:45:00',1.03),('8902','2013-02-28','07:50:00',1.17),('8902','2013-02-28','07:55:00',1.46),('8902','2013-02-28','08:00:00',1.64),('8902','2013-02-28','08:05:00',1.74),('8902','2013-02-28','08:10:00',1.8),('8902','2013-02-28','08:15:00',1.92),('8902','2013-02-28','08:20:00',2.06),('8902','2013-02-28','08:25:00',2.08),('8902','2013-02-28','08:30:00',2.24),('8902','2013-02-28','08:35:00',2.41),('8902','2013-02-28','08:40:00',2.61),('8902','2013-02-28','08:45:00',2.8),('8902','2013-02-28','08:50:00',2.92),('8902','2013-02-28','08:55:00',3.16),('8902','2013-02-28','09:00:00',3.35),('8902','2013-02-28','09:05:00',3.71),('8902','2013-02-28','09:10:00',3.73),('8902','2013-02-28','09:15:00',3.76),('8902','2013-02-28','09:20:00',3.91),('8902','2013-02-28','09:25:00',3.83),('8902','2013-02-28','09:30:00',4.28),('8902','2013-02-28','09:35:00',4.18),('8902','2013-02-28','09:40:00',4.51),('8902','2013-02-28','09:45:00',4.77),('8902','2013-02-28','09:50:00',4.81),('8902','2013-02-28','09:55:00',4.75),('8902','2013-02-28','10:00:00',4.96),('8902','2013-02-28','10:05:00',5.01),('8902','2013-02-28','10:10:00',4.95),('8902','2013-02-28','10:15:00',4.23),('8902','2013-02-28','10:20:00',4.09),('8902','2013-02-28','10:25:00',4.35),('8902','2013-02-28','10:30:00',4.78),('8902','2013-02-28','10:35:00',5.16),('8902','2013-02-28','10:40:00',4.65),('8902','2013-02-28','10:45:00',4.38),('8902','2013-02-28','10:50:00',4.12),('8902','2013-02-28','10:55:00',3.87),('8902','2013-02-28','11:00:00',3.39),('8902','2013-02-28','11:05:00',2.94),('8902','2013-02-28','11:10:00',2.81),('8902','2013-02-28','11:15:00',3.13),('8902','2013-02-28','11:20:00',3.32),('8902','2013-02-28','11:25:00',3.31),('8902','2013-02-28','11:30:00',3.36),('8902','2013-02-28','11:35:00',3.41),('8902','2013-02-28','11:40:00',3.22),('8902','2013-02-28','11:45:00',3.07),('8902','2013-02-28','11:50:00',3.04),('8902','2013-02-28','11:55:00',2.89),('8902','2013-02-28','12:00:00',2.76),('8902','2013-02-28','12:05:00',2.63),('8902','2013-02-28','12:10:00',2.45),('8902','2013-02-28','12:15:00',2.22),('8902','2013-02-28','12:20:00',2.09),('8902','2013-02-28','12:25:00',2.06),('8902','2013-02-28','12:30:00',2.13),('8902','2013-02-28','12:35:00',2.12),('8902','2013-02-28','12:40:00',2.05),('8902','2013-02-28','12:45:00',2.05),('8902','2013-02-28','12:50:00',2.09),('8902','2013-02-28','12:55:00',2.21),('8902','2013-02-28','13:00:00',2.35),('8902','2013-02-28','13:05:00',2.39),('8902','2013-02-28','13:10:00',2.47),('8902','2013-02-28','13:15:00',2.65),('8902','2013-02-28','13:20:00',2.86),('8902','2013-02-28','13:25:00',3.14),('8902','2013-02-28','13:30:00',3.08),('8902','2013-02-28','13:35:00',2.85),('8902','2013-02-28','13:40:00',2.7),('8902','2013-02-28','13:45:00',2.68),('8902','2013-02-28','13:50:00',2.68),('8902','2013-02-28','13:55:00',2.56),('8902','2013-02-28','14:00:00',2.48),('8902','2013-02-28','14:05:00',2.37),('8902','2013-02-28','14:10:00',2.22),('8902','2013-02-28','14:15:00',2.1),('8902','2013-02-28','14:20:00',2.02),('8902','2013-02-28','14:25:00',2.03),('8902','2013-02-28','14:30:00',2.09),('8902','2013-02-28','14:35:00',2.1),('8902','2013-02-28','14:40:00',2),('8902','2013-02-28','14:45:00',1.87),('8902','2013-02-28','14:50:00',1.77),('8902','2013-02-28','14:55:00',1.75),('8902','2013-02-28','15:00:00',1.75),('8902','2013-02-28','15:05:00',1.69),('8902','2013-02-28','15:10:00',1.55),('8902','2013-02-28','15:15:00',1.42),('8902','2013-02-28','15:20:00',1.33),('8902','2013-02-28','15:25:00',1.18),('8902','2013-02-28','15:30:00',1.06),('8902','2013-02-28','15:35:00',1.07),('8902','2013-02-28','15:40:00',1.19),('8902','2013-02-28','15:45:00',1.18),('8902','2013-02-28','15:50:00',1.11),('8902','2013-02-28','15:55:00',1.08),('8902','2013-02-28','16:00:00',1.1),('8902','2013-02-28','16:05:00',1.09),('8902','2013-02-28','16:10:00',1.04),('8902','2013-02-27','07:50:00',1.06),('8902','2013-02-27','07:55:00',1.32),('8902','2013-02-27','08:00:00',1.49),('8902','2013-02-27','08:05:00',1.65),('8902','2013-02-27','08:10:00',1.82),('8902','2013-02-27','08:15:00',2.01),('8902','2013-02-27','08:20:00',2.22),('8902','2013-02-27','08:25:00',2.39),('8902','2013-02-27','08:30:00',2.55),('8902','2013-02-27','08:35:00',2.73),('8902','2013-02-27','08:40:00',2.94),('8902','2013-02-27','08:45:00',3.12),('8902','2013-02-27','08:50:00',3.35),('8902','2013-02-27','08:55:00',3.53),('8902','2013-02-27','09:00:00',3.68),('8902','2013-02-27','09:05:00',3.83),('8902','2013-02-27','09:10:00',3.97),('8902','2013-02-27','09:15:00',4.05),('8902','2013-02-27','09:20:00',4.3),('8902','2013-02-27','09:25:00',4.43),('8902','2013-02-27','09:30:00',4.6),('8902','2013-02-27','09:35:00',4.73),('8902','2013-02-27','09:40:00',4.88),('8902','2013-02-27','09:45:00',5.01),('8902','2013-02-27','09:50:00',4.76),('8902','2013-02-27','09:55:00',5.21),('8902','2013-02-27','10:00:00',5.31),('8902','2013-02-27','10:05:00',5.44),('8902','2013-02-27','10:10:00',5.51),('8902','2013-02-27','10:15:00',5.57),('8902','2013-02-27','10:20:00',5.68),('8902','2013-02-27','10:25:00',5.74),('8902','2013-02-27','10:30:00',5.84),('8902','2013-02-27','10:35:00',6.02),('8902','2013-02-27','10:40:00',6.14),('8902','2013-02-27','10:45:00',6.15),('8902','2013-02-27','10:50:00',6.2),('8902','2013-02-27','10:55:00',6.28),('8902','2013-02-27','11:00:00',6.42),('8902','2013-02-27','11:05:00',6.51),('8902','2013-02-27','11:10:00',6.53),('8902','2013-02-27','11:15:00',6.63),('8902','2013-02-27','11:20:00',6.74),('8902','2013-02-27','11:25:00',6.84),('8902','2013-02-27','11:30:00',6.86),('8902','2013-02-27','11:35:00',6.88),('8902','2013-02-27','11:40:00',6.92),('8902','2013-02-27','11:45:00',6.94),('8902','2013-02-27','11:50:00',6.92),('8902','2013-02-27','11:55:00',6.71),('8902','2013-02-27','12:00:00',6.59),('8902','2013-02-27','12:05:00',6.94),('8902','2013-02-27','12:10:00',7.09),('8902','2013-02-27','12:15:00',7.05),('8902','2013-02-27','12:20:00',6.97),('8902','2013-02-27','12:25:00',6.82),('8902','2013-02-27','12:30:00',6.85),('8902','2013-02-27','12:35:00',6.84),('8902','2013-02-27','12:40:00',7.01),('8902','2013-02-27','12:45:00',6.93),('8902','2013-02-27','12:50:00',6.92),('8902','2013-02-27','12:55:00',7.1),('8902','2013-02-27','13:00:00',6.81),('8902','2013-02-27','13:05:00',6.92),('8902','2013-02-27','13:10:00',6.92),('8902','2013-02-27','13:15:00',6.97),('8902','2013-02-27','13:20:00',7),('8902','2013-02-27','13:25:00',6.96),('8902','2013-02-27','13:30:00',6.87),('8902','2013-02-27','13:35:00',6.77),('8902','2013-02-27','13:40:00',6.79),('8902','2013-02-27','13:45:00',6.88),('8902','2013-02-27','13:50:00',6.91),('8902','2013-02-27','13:55:00',6.86),('8902','2013-02-27','14:00:00',6.83),('8902','2013-02-27','14:05:00',6.75),('8902','2013-02-27','14:10:00',6.72),('8902','2013-02-27','14:15:00',6.44),('8902','2013-02-27','14:20:00',5.73),('8902','2013-02-27','14:25:00',5.53),('8902','2013-02-27','14:30:00',5.69),('8902','2013-02-27','14:35:00',5.47),('8902','2013-02-27','14:40:00',5.62),('8902','2013-02-27','14:45:00',5.58),('8902','2013-02-27','14:50:00',5.43),('8902','2013-02-27','14:55:00',5.28),('8902','2013-02-27','15:00:00',5.19),('8902','2013-02-27','15:05:00',4.9),('8902','2013-02-27','15:10:00',4.81),('8902','2013-02-27','15:15:00',4.73),('8902','2013-02-27','15:20:00',4.62),('8902','2013-02-27','15:25:00',4.26),('8902','2013-02-27','15:30:00',4.01),('8902','2013-02-27','15:35:00',3.87),('8902','2013-02-27','15:40:00',3.76),('8902','2013-02-27','15:45:00',3.66),('8902','2013-02-27','15:50:00',3.54),('8902','2013-02-27','15:55:00',3.4),('8902','2013-02-27','16:00:00',3.21),('8902','2013-02-27','16:05:00',3),('8902','2013-02-27','16:10:00',2.84),('8902','2013-02-27','16:15:00',2.68),('8902','2013-02-27','16:20:00',2.49),('8902','2013-02-27','16:25:00',2.32),('8902','2013-02-27','16:30:00',2.05),('8902','2013-02-27','16:35:00',2.02),('8902','2013-02-27','16:40:00',1.88),('8902','2013-02-27','16:45:00',1.74),('8902','2013-02-27','16:50:00',1.59),('8902','2013-02-27','16:55:00',1.39),('8902','2013-02-27','17:00:00',1.2),('8902','2013-02-26','07:50:00',1.04),('8902','2013-02-26','07:55:00',1.25),('8902','2013-02-26','08:00:00',1.43),('8902','2013-02-26','08:05:00',1.6),('8902','2013-02-26','08:10:00',1.76),('8902','2013-02-26','08:15:00',1.94),('8902','2013-02-26','08:20:00',2.13),('8902','2013-02-26','08:25:00',2.31),('8902','2013-02-26','08:30:00',2.48),('8902','2013-02-26','08:35:00',2.66),('8902','2013-02-26','08:40:00',2.81),('8902','2013-02-26','08:45:00',2.99),('8902','2013-02-26','08:50:00',3.17),('8902','2013-02-26','08:55:00',3.36),('8902','2013-02-26','09:00:00',3.53),('8902','2013-02-26','09:05:00',3.72),('8902','2013-02-26','09:10:00',3.89),('8902','2013-02-26','09:15:00',4.03),('8902','2013-02-26','09:20:00',4.17),('8902','2013-02-26','09:25:00',4.3),('8902','2013-02-26','09:30:00',4.44),('8902','2013-02-26','09:35:00',4.58),('8902','2013-02-26','09:40:00',4.76),('8902','2013-02-26','09:45:00',4.86),('8902','2013-02-26','09:50:00',5),('8902','2013-02-26','09:55:00',5.1),('8902','2013-02-26','10:00:00',5.24),('8902','2013-02-26','10:05:00',5.36),('8902','2013-02-26','10:10:00',5.45),('8902','2013-02-26','10:15:00',5.59),('8902','2013-02-26','10:20:00',5.64),('8902','2013-02-26','10:25:00',5.69),('8902','2013-02-26','10:30:00',5.86),('8902','2013-02-26','10:35:00',6.01),('8902','2013-02-26','10:40:00',6.02),('8902','2013-02-26','10:45:00',6.09),('8902','2013-02-26','10:50:00',6.18),('8902','2013-02-26','10:55:00',6.31),('8902','2013-02-26','11:00:00',6.32),('8902','2013-02-26','11:05:00',6.31),('8902','2013-02-26','11:10:00',6.46),('8902','2013-02-26','11:15:00',6.55),('8902','2013-02-26','11:20:00',6.51),('8902','2013-02-26','11:25:00',6.77),('8902','2013-02-26','11:30:00',7.05),('8902','2013-02-26','11:35:00',6.05),('8902','2013-02-26','11:40:00',3.72),('8902','2013-02-26','11:45:00',3.02),('8902','2013-02-26','11:50:00',6.3),('8902','2013-02-26','11:55:00',3.53),('8902','2013-02-26','12:00:00',6.37),('8902','2013-02-26','12:05:00',7.43),('8902','2013-02-26','12:10:00',7.34),('8902','2013-02-26','12:15:00',7.34),('8902','2013-02-26','12:20:00',7.57),('8902','2013-02-26','12:25:00',7.49),('8902','2013-02-26','12:30:00',7.14),('8902','2013-02-26','12:35:00',7.17),('8902','2013-02-26','12:40:00',7.27),('8902','2013-02-26','12:45:00',7.25),('8902','2013-02-26','12:50:00',7.15),('8902','2013-02-26','12:55:00',7.03),('8902','2013-02-26','13:00:00',7.09),('8902','2013-02-26','13:05:00',7.26),('8902','2013-02-26','13:10:00',7.22),('8902','2013-02-26','13:15:00',6.92),('8902','2013-02-26','13:20:00',4.61),('8902','2013-02-26','13:25:00',2.26),('8902','2013-02-26','13:30:00',4.14),('8902','2013-02-26','13:35:00',7.24),('8902','2013-02-26','13:40:00',7.17),('8902','2013-02-26','13:45:00',7.14),('8902','2013-02-26','13:50:00',6.23),('8902','2013-02-26','13:55:00',5.66),('8902','2013-02-26','14:00:00',5.95),('8902','2013-02-26','14:05:00',5.97),('8902','2013-02-26','14:10:00',6.31),('8902','2013-02-26','14:15:00',4.98),('8902','2013-02-26','14:20:00',4.22),('8902','2013-02-26','14:25:00',5.45),('8902','2013-02-26','14:30:00',5.7),('8902','2013-02-26','14:35:00',5.86),('8902','2013-02-26','14:40:00',5.72),('8902','2013-02-26','14:45:00',5.82),('8902','2013-02-26','14:50:00',5.72),('8902','2013-02-26','14:55:00',5.1),('8902','2013-02-26','15:00:00',5.38),('8902','2013-02-26','15:05:00',5.28),('8902','2013-02-26','15:10:00',5.18),('8902','2013-02-26','15:15:00',4.9),('8902','2013-02-26','15:20:00',4.69),('8902','2013-02-26','15:25:00',4.58),('8902','2013-02-26','15:30:00',4.53),('8902','2013-02-26','15:35:00',4.32),('8902','2013-02-26','15:40:00',4.14),('8902','2013-02-26','15:45:00',4.01),('8902','2013-02-26','15:50:00',3.84),('8902','2013-02-26','15:55:00',3.68),('8902','2013-02-26','16:00:00',3.55),('8902','2013-02-26','16:05:00',3.37),('8902','2013-02-26','16:10:00',3.19),('8902','2013-02-26','16:15:00',2.98),('8902','2013-02-26','16:20:00',2.84),('8902','2013-02-26','16:25:00',2.66),('8902','2013-02-26','16:30:00',2.38),('8902','2013-02-26','16:35:00',2.21),('8902','2013-02-26','16:40:00',2.05),('8902','2013-02-26','16:45:00',1.85),('8902','2013-02-26','16:50:00',1.65),('8902','2013-02-26','16:55:00',1.45),('8902','2013-02-26','17:00:00',1.22),('8902','2013-02-26','17:05:00',1.02),('8902','2013-02-25','08:50:00',1.13),('8902','2013-02-25','08:55:00',1.3),('8902','2013-02-25','09:00:00',1.43),('8902','2013-02-25','09:05:00',1.53),('8902','2013-02-25','09:10:00',1.66),('8902','2013-02-25','09:15:00',1.77),('8902','2013-02-25','09:20:00',1.91),('8902','2013-02-25','09:25:00',2.11),('8902','2013-02-25','09:30:00',2.58),('8902','2013-02-25','09:35:00',3.15),('8902','2013-02-25','09:40:00',3.43),('8902','2013-02-25','09:45:00',3.39),('8902','2013-02-25','09:50:00',3.55),('8902','2013-02-25','09:55:00',3.87),('8902','2013-02-25','10:00:00',3.66),('8902','2013-02-25','10:05:00',3.66),('8902','2013-02-25','10:10:00',4.43),('8902','2013-02-25','10:15:00',5.16),('8902','2013-02-25','10:20:00',6),('8902','2013-02-25','10:25:00',6.53),('8902','2013-02-25','10:30:00',6.33),('8902','2013-02-25','10:35:00',5.85),('8902','2013-02-25','10:40:00',3.35),('8902','2013-02-25','10:45:00',2.69),('8902','2013-02-25','10:50:00',3.15),('8902','2013-02-25','10:55:00',3.22),('8902','2013-02-25','11:00:00',3.56),('8902','2013-02-25','11:05:00',4.53),('8902','2013-02-25','11:10:00',3.67),('8902','2013-02-25','11:15:00',3.32),('8902','2013-02-25','11:20:00',3.15),('8902','2013-02-25','11:25:00',2.97),('8902','2013-02-25','11:30:00',2.85),('8902','2013-02-25','11:35:00',2.78),('8902','2013-02-25','11:40:00',3.01),('8902','2013-02-25','11:45:00',2.92),('8902','2013-02-25','11:50:00',3.2),('8902','2013-02-25','11:55:00',3.23),('8902','2013-02-25','12:00:00',3.14),('8902','2013-02-25','12:05:00',3.02),('8902','2013-02-25','12:10:00',3.1),('8902','2013-02-25','12:15:00',2.75),('8902','2013-02-25','12:20:00',2.72),('8902','2013-02-25','12:25:00',2.47),('8902','2013-02-25','12:30:00',2.45),('8902','2013-02-25','12:35:00',2.25),('8902','2013-02-25','12:40:00',2.08),('8902','2013-02-25','12:45:00',1.85),('8902','2013-02-25','12:50:00',1.71),('8902','2013-02-25','12:55:00',1.85),('8902','2013-02-25','13:00:00',1.81),('8902','2013-02-25','13:05:00',1.57),('8902','2013-02-25','13:10:00',1.45),('8902','2013-02-25','13:15:00',1.62),('8902','2013-02-25','13:20:00',1.76),('8902','2013-02-25','13:25:00',1.84),('8902','2013-02-25','13:30:00',1.93),('8902','2013-02-25','13:35:00',1.92),('8902','2013-02-25','13:40:00',1.86),('8902','2013-02-25','13:45:00',1.62),('8902','2013-02-25','13:50:00',1.57),('8902','2013-02-25','13:55:00',1.55),('8902','2013-02-25','14:00:00',1.38),('8902','2013-02-25','14:05:00',1.27),('8902','2013-02-25','14:10:00',1.3),('8902','2013-02-25','14:15:00',1.29),('8902','2013-02-24','08:35:00',1.21),('8902','2013-02-24','08:40:00',2.07),('8902','2013-02-24','08:45:00',1.93),('8902','2013-02-24','08:50:00',2.26),('8902','2013-02-24','08:55:00',1.72),('8902','2013-02-24','09:00:00',2.49),('8902','2013-02-24','09:05:00',1.53),('8902','2013-02-24','09:10:00',1.6),('8902','2013-02-24','09:15:00',1.65),('8902','2013-02-24','09:20:00',1.83),('8902','2013-02-24','09:25:00',2.51),('8902','2013-02-24','09:30:00',2.73),('8902','2013-02-24','09:35:00',2.69),('8902','2013-02-24','09:40:00',2.1),('8902','2013-02-24','09:45:00',1.44),('8902','2013-02-24','09:50:00',1.26),('8902','2013-02-24','10:40:00',1.53),('8902','2013-02-24','10:45:00',3.21),('8902','2013-02-24','10:50:00',5.69),('8902','2013-02-24','10:55:00',8.41),('8902','2013-02-24','11:00:00',8.48),('8902','2013-02-24','11:05:00',5.15),('8902','2013-02-24','11:10:00',3.86),('8902','2013-02-24','11:15:00',3.18),('8902','2013-02-24','11:20:00',2.04),('8902','2013-02-24','11:25:00',1.94),('8902','2013-02-24','11:30:00',2.6),('8902','2013-02-24','11:35:00',2.24),('8902','2013-02-24','11:40:00',2.45),('8902','2013-02-24','11:45:00',3.18),('8902','2013-02-24','11:50:00',4.91),('8902','2013-02-24','11:55:00',8.78),('8902','2013-02-24','12:00:00',4.07),('8902','2013-02-24','12:05:00',4.08),('8902','2013-02-24','12:10:00',3.67),('8902','2013-02-24','12:15:00',5.64),('8902','2013-02-24','12:20:00',8.69),('8902','2013-02-24','12:25:00',7.73),('8902','2013-02-24','12:30:00',7),('8902','2013-02-24','12:35:00',6.55),('8902','2013-02-24','12:40:00',7.81),('8902','2013-02-24','12:45:00',7.56),('8902','2013-02-24','12:50:00',7.38),('8902','2013-02-24','12:55:00',7.32),('8902','2013-02-24','13:00:00',7.69),('8902','2013-02-24','13:05:00',5.36),('8902','2013-02-24','13:10:00',5.54),('8902','2013-02-24','13:15:00',5.85),('8902','2013-02-24','13:20:00',4.54),('8902','2013-02-24','13:25:00',3.09),('8902','2013-02-24','13:30:00',3.15),('8902','2013-02-24','13:35:00',2.2),('8902','2013-02-24','13:40:00',1.85),('8902','2013-02-24','13:45:00',1.69),('8902','2013-02-24','13:50:00',1.82),('8902','2013-02-24','13:55:00',1.51),('8902','2013-02-24','14:00:00',1.23),('8902','2013-02-24','14:30:00',1.11),('8902','2013-02-24','14:35:00',1.53),('8902','2013-02-24','14:40:00',1.72),('8902','2013-02-24','14:45:00',1.55),('8902','2013-02-24','14:50:00',1.48),('8902','2013-02-24','14:55:00',1.46),('8902','2013-02-24','15:00:00',1.44),('8902','2013-02-24','15:05:00',1.46),('8902','2013-02-24','15:10:00',1.38),('8902','2013-02-24','15:15:00',1.31),('8902','2013-02-24','15:20:00',1.2),('8902','2013-02-24','15:50:00',1.02),('8902','2013-02-24','15:55:00',1.2),('8902','2013-02-24','16:00:00',1.23),('8902','2013-02-24','16:05:00',1.14),('8902','2013-02-24','16:30:00',1.08),('8902','2013-02-24','16:35:00',1.37),('8902','2013-02-24','16:40:00',1.26),('8902','2013-02-24','16:45:00',1.19),('8902','2013-02-24','16:50:00',1.07),('8902','2013-02-24','16:55:00',1.58),('8902','2013-02-24','17:00:00',1.39),('8902','2013-02-24','17:05:00',1.13),('8902','2013-02-23','08:00:00',1.38),('8902','2013-02-23','08:05:00',1.46),('8902','2013-02-23','08:20:00',1.04),('8902','2013-02-23','08:25:00',1.21),('8902','2013-02-23','08:45:00',1.22),('8902','2013-02-23','08:50:00',1.33),('8902','2013-02-23','08:55:00',1.47),('8902','2013-02-23','09:00:00',1.09),('8902','2013-02-23','10:00:00',1.02),('8902','2013-02-23','10:30:00',1.07),('8902','2013-02-23','10:35:00',1.21),('8902','2013-02-23','10:40:00',1.47),('8902','2013-02-23','10:45:00',1.71),('8902','2013-02-23','10:50:00',2.36),('8902','2013-02-23','10:55:00',2.22),('8902','2013-02-23','11:00:00',1.72),('8902','2013-02-23','11:05:00',1.71),('8902','2013-02-23','11:10:00',1.52),('8902','2013-02-23','11:15:00',1.57),('8902','2013-02-23','11:20:00',1.57),('8902','2013-02-23','11:25:00',1.6),('8902','2013-02-23','11:30:00',1.82),('8902','2013-02-23','11:35:00',1.42),('8902','2013-02-23','11:40:00',1.55),('8902','2013-02-23','11:45:00',1.67),('8902','2013-02-23','11:50:00',1.7),('8902','2013-02-23','11:55:00',1.68),('8902','2013-02-23','12:00:00',1.48),('8902','2013-02-23','12:05:00',1.44),('8902','2013-02-23','12:10:00',1.23),('8902','2013-02-23','12:30:00',1.07),('8902','2013-02-23','12:35:00',1.7),('8902','2013-02-23','12:40:00',2.09),('8902','2013-02-23','12:45:00',2.48),('8902','2013-02-23','12:50:00',2.35),('8902','2013-02-23','12:55:00',1.91),('8902','2013-02-23','13:00:00',2.07),('8902','2013-02-23','13:05:00',3.26),('8902','2013-02-23','13:10:00',3.13),('8902','2013-02-23','13:15:00',2.69),('8902','2013-02-23','13:20:00',2.8),('8902','2013-02-23','13:25:00',2.19),('8902','2013-02-23','13:30:00',1.68),('8902','2013-02-23','13:35:00',2.28),('8902','2013-02-23','13:40:00',2.84),('8902','2013-02-23','13:45:00',3.13),('8902','2013-02-23','13:50:00',2.22),('8902','2013-02-23','13:55:00',1.82),('8902','2013-02-23','14:00:00',2.07),('8902','2013-02-23','14:05:00',3.4),('8902','2013-02-23','14:10:00',3.83),('8902','2013-02-23','14:15:00',2.14),('8902','2013-02-23','14:20:00',2.01),('8902','2013-02-23','14:25:00',1.74),('8902','2013-02-23','14:30:00',2.16),('8902','2013-02-23','14:35:00',2.36),('8902','2013-02-23','14:40:00',1.55),('8902','2013-02-23','14:45:00',1.61),('8902','2013-02-23','14:50:00',1.32),('8902','2013-02-23','14:55:00',1.19),('8902','2013-02-23','15:00:00',1.16),('8902','2013-02-23','15:05:00',1.63),('8902','2013-02-23','15:10:00',4.44),('8902','2013-02-23','15:15:00',3.74),('8902','2013-02-23','15:20:00',1.8),('8902','2013-02-23','15:25:00',4.35),('8902','2013-02-23','15:30:00',2.08),('8902','2013-02-23','15:35:00',3.7),('8902','2013-02-23','15:40:00',2.99),('8902','2013-02-23','15:45:00',2.83),('8902','2013-02-23','15:50:00',2.88),('8902','2013-02-23','15:55:00',2.38),('8902','2013-02-23','16:00:00',4.26),('8902','2013-02-23','16:05:00',2.93),('8902','2013-02-23','16:10:00',1.43),('8902','2013-02-23','16:20:00',1.4),('8902','2013-02-23','16:25:00',1.1),('8902','2013-02-23','16:40:00',1.88),('8902','2013-02-23','16:45:00',1.58),('8902','2013-02-22','07:55:00',1.17),('8902','2013-02-22','08:00:00',1.33),('8902','2013-02-22','08:05:00',1.57),('8902','2013-02-22','08:10:00',2.09),('8902','2013-02-22','08:15:00',2.67),('8902','2013-02-22','08:20:00',1.9),('8902','2013-02-22','08:25:00',1.26),('8902','2013-02-22','08:30:00',1.18),('8902','2013-02-22','08:35:00',1.08),('8902','2013-02-22','08:45:00',1.14),('8902','2013-02-22','08:50:00',1.59),('8902','2013-02-22','08:55:00',1.96),('8902','2013-02-22','09:00:00',2.33),('8902','2013-02-22','09:05:00',2.56),('8902','2013-02-22','09:10:00',1.81),('8902','2013-02-22','09:15:00',1.47),('8902','2013-02-22','09:20:00',1.07),('8902','2013-02-22','09:30:00',1.13),('8902','2013-02-22','09:35:00',1.38),('8902','2013-02-22','09:40:00',1.82),('8902','2013-02-22','09:45:00',2.54),('8902','2013-02-22','09:50:00',2.58),('8902','2013-02-22','09:55:00',2.5),('8902','2013-02-22','10:00:00',2.02),('8902','2013-02-22','10:05:00',1.91),('8902','2013-02-22','10:10:00',1.67),('8902','2013-02-22','10:15:00',1.27),('8902','2013-02-22','10:20:00',1.33),('8902','2013-02-22','10:25:00',1.91),('8902','2013-02-22','10:30:00',1.67),('8902','2013-02-22','10:35:00',1.64),('8902','2013-02-22','10:40:00',1.5),('8902','2013-02-22','10:45:00',1.57),('8902','2013-02-22','10:50:00',1.5),('8902','2013-02-22','10:55:00',1.21),('8902','2013-02-22','11:05:00',1.1),('8902','2013-02-22','11:20:00',1.29),('8902','2013-02-22','11:25:00',1.13),('8902','2013-02-22','11:30:00',1.18),('8902','2013-02-22','11:35:00',1.65),('8902','2013-02-22','11:40:00',1.69),('8902','2013-02-22','11:45:00',1.51),('8902','2013-02-22','11:50:00',1.21),('8902','2013-02-22','11:55:00',1.08),('8902','2013-02-22','12:05:00',1.37),('8902','2013-02-22','12:10:00',1.35),('8902','2013-02-22','12:15:00',1.19),('8902','2013-02-22','12:20:00',1.24),('8902','2013-02-22','12:25:00',1.07),('8902','2013-02-22','12:30:00',1.15),('8902','2013-02-22','13:10:00',1),('8902','2013-02-22','13:15:00',1.03),('8902','2013-02-22','13:50:00',1.01),('8902','2013-02-22','13:55:00',1.8),('8902','2013-02-22','14:00:00',1.93),('8902','2013-02-22','14:05:00',3.41),('8902','2013-02-22','14:10:00',3),('8902','2013-02-22','14:45:00',1.36),('8902','2013-02-22','14:50:00',1.43),('8902','2013-02-22','15:05:00',1.02),('8902','2013-02-22','15:10:00',1.2),('8902','2013-02-21','09:35:00',1.64),('8902','2013-02-21','09:40:00',1.85),('8902','2013-02-21','09:45:00',1.25),('8902','2013-02-21','09:50:00',1.28),('8902','2013-02-21','09:55:00',1.09),('8902','2013-02-21','10:05:00',1.01),('8902','2013-02-21','10:15:00',1.34),('8902','2013-02-21','10:20:00',1.26),('8902','2013-02-21','11:30:00',1.01),('8902','2013-02-21','11:35:00',1.14),('8902','2013-02-21','11:40:00',1.11),('8902','2013-02-21','11:55:00',1.04),('8902','2013-02-21','12:00:00',1.09),('8902','2013-02-21','12:45:00',1.05),('8902','2013-02-21','12:50:00',1.38),('8902','2013-02-21','12:55:00',1.57),('8902','2013-02-21','13:00:00',1.36),('8902','2013-02-21','14:10:00',1.17),('8902','2013-02-21','14:15:00',1.43),('8902','2013-02-21','14:20:00',1.65),('8902','2013-02-21','14:25:00',1.07),('8902','2013-02-21','14:30:00',1.72),('8902','2013-02-21','14:35:00',2.32),('8902','2013-02-21','14:40:00',2.43),('8902','2013-02-21','14:45:00',2.13),('8902','2013-02-21','14:50:00',1.63),('8902','2013-02-21','14:55:00',2.92),('8902','2013-02-21','15:00:00',1.6),('8902','2013-02-21','15:50:00',1.55),('8902','2013-02-21','15:55:00',1.15),('8902','2013-02-21','16:10:00',1.12),('8902','2013-02-21','16:20:00',2.3),('8902','2013-02-21','16:25:00',2.69),('8902','2013-02-21','16:30:00',2.51),('8902','2013-02-21','16:35:00',1.1),('8902','2013-02-20','09:40:00',1.07),('8902','2013-02-20','09:45:00',1.37),('8902','2013-02-20','09:50:00',1.51),('8902','2013-02-20','09:55:00',1.52),('8902','2013-02-20','10:00:00',1.45),('8902','2013-02-20','10:05:00',1.42),('8902','2013-02-20','10:10:00',1.45),('8902','2013-02-20','10:15:00',1.4),('8902','2013-02-20','10:20:00',1.4),('8902','2013-02-20','10:25:00',1.38),('8902','2013-02-20','10:30:00',1.39),('8902','2013-02-20','10:35:00',1.44),('8902','2013-02-20','10:40:00',1.49),('8902','2013-02-20','10:45:00',1.43),('8902','2013-02-20','10:50:00',1.4),('8902','2013-02-20','10:55:00',1.45),('8902','2013-02-20','11:00:00',1.3),('8902','2013-02-20','11:05:00',1.2),('8902','2013-02-20','11:10:00',1.16),('8902','2013-02-20','11:15:00',1.22),('8902','2013-02-20','11:20:00',1.43),('8902','2013-02-20','11:25:00',1.62),('8902','2013-02-20','11:30:00',1.74),('8902','2013-02-20','11:35:00',1.83),('8902','2013-02-20','11:40:00',1.82),('8902','2013-02-20','11:45:00',1.89),('8902','2013-02-20','11:50:00',2.1),('8902','2013-02-20','11:55:00',2.17),('8902','2013-02-20','12:00:00',2.15),('8902','2013-02-20','12:05:00',2.15),('8902','2013-02-20','12:10:00',2.25),('8902','2013-02-20','12:15:00',2.38),('8902','2013-02-20','12:20:00',2.57),('8902','2013-02-20','12:25:00',2.54),('8902','2013-02-20','12:30:00',2.37),('8902','2013-02-20','12:35:00',2.24),('8902','2013-02-20','12:40:00',2.16),('8902','2013-02-20','12:45:00',2.18),('8902','2013-02-20','12:50:00',2.2),('8902','2013-02-20','12:55:00',2.37),('8902','2013-02-20','13:00:00',2.43),('8902','2013-02-20','13:05:00',2.27),('8902','2013-02-20','13:10:00',2.12),('8902','2013-02-20','13:15:00',2.15),('8902','2013-02-20','13:20:00',2.23),('8902','2013-02-20','13:25:00',2.29),('8902','2013-02-20','13:30:00',2.32),('8902','2013-02-20','13:35:00',2.34),('8902','2013-02-20','13:40:00',2.29),('8902','2013-02-20','13:45:00',2.18),('8902','2013-02-20','13:50:00',2.2),('8902','2013-02-20','13:55:00',2.22),('8902','2013-02-20','14:00:00',2.24),('8902','2013-02-20','14:05:00',2.16),('8902','2013-02-20','14:10:00',2.01),('8902','2013-02-20','14:15:00',1.79),('8902','2013-02-20','14:20:00',1.57),('8902','2013-02-20','14:25:00',1.44),('8902','2013-02-20','14:30:00',1.47),('8902','2013-02-20','14:35:00',1.51),('8902','2013-02-20','14:40:00',1.47),('8902','2013-02-20','14:45:00',1.42),('8902','2013-02-20','14:50:00',1.37),('8902','2013-02-20','14:55:00',1.23),('8902','2013-02-20','15:00:00',1.07),('8902','2013-02-20','15:10:00',1),('8902','2013-02-20','15:40:00',1),('8902','2013-02-20','15:45:00',1.09),('8902','2013-02-20','15:50:00',1.25),('8902','2013-02-20','15:55:00',1.45),('8902','2013-02-20','16:00:00',1.75),('8902','2013-02-20','16:05:00',1.9),('8902','2013-02-20','16:10:00',1.61),('8902','2013-02-20','16:15:00',1.65),('8902','2013-02-20','16:20:00',2.66),('8902','2013-02-20','16:25:00',3.36),('8902','2013-02-20','16:30:00',3.03),('8902','2013-02-20','16:35:00',2.64),('8902','2013-02-20','16:40:00',2.22),('8902','2013-02-20','16:45:00',1.83),('8902','2013-02-20','16:50:00',1.52),('8902','2013-02-20','16:55:00',1.25),('8902','2013-02-20','17:00:00',1.08),('8902','2014-03-22','08:05:00',1.21),('8902','2014-03-22','08:10:00',1.31),('8902','2014-03-22','08:15:00',1.34),('8902','2014-03-22','08:20:00',1.46),('8902','2014-03-22','08:25:00',1.66),('8902','2014-03-22','08:30:00',1.89),('8902','2014-03-22','08:35:00',2.18),('8902','2014-03-22','08:40:00',1.52),('8902','2014-03-22','08:45:00',1.6),('8902','2014-03-22','08:50:00',2.2),('8902','2014-03-22','08:55:00',2.91),('8902','2014-03-22','09:00:00',1.83),('8902','2014-03-22','09:05:00',2.93),('8902','2014-03-22','09:10:00',4.81),('8902','2014-03-22','09:15:00',4.91),('8902','2014-03-22','09:20:00',3.52),('8902','2014-03-22','09:25:00',2.01),('8902','2014-03-22','09:30:00',2.62),('8902','2014-03-22','09:35:00',2.63),('8902','2014-03-22','09:40:00',2.34),('8902','2014-03-22','09:45:00',1.85),('8902','2014-03-22','09:50:00',1.59),('8902','2014-03-22','09:55:00',1.43),('8902','2014-03-22','10:00:00',1.32),('8902','2014-03-22','10:05:00',1.27),('8902','2014-03-22','10:10:00',1.55),('8902','2014-03-22','10:15:00',1.22),('8902','2014-03-22','10:20:00',1.43),('8902','2014-03-22','10:25:00',2.19),('8902','2014-03-22','10:30:00',1.9),('8902','2014-03-22','10:35:00',1.44),('8902','2014-03-22','10:40:00',2.22),('8902','2014-03-22','10:45:00',1.99),('8902','2014-03-22','10:50:00',2.13),('8902','2014-03-22','10:55:00',3.09),('8902','2014-03-22','11:00:00',2.47),('8902','2014-03-22','11:05:00',1.99),('8902','2014-03-22','11:10:00',2.57),('8902','2014-03-22','11:15:00',1.62),('8902','2014-03-22','11:20:00',1.41),('8902','2014-03-22','11:25:00',1.99),('8902','2014-03-22','11:30:00',1.65),('8902','2014-03-22','11:35:00',2.45),('8902','2014-03-22','11:40:00',5.49),('8902','2014-03-22','11:45:00',1.95),('8902','2014-03-22','11:55:00',1.75),('8902','2014-03-22','12:00:00',1.84),('8902','2014-03-22','12:05:00',1.04),('8902','2014-03-22','12:30:00',1.07),('8902','2014-03-22','12:35:00',1.34),('8902','2014-03-22','12:40:00',1.07),('8902','2014-03-22','13:40:00',1.56),('8902','2014-03-22','13:45:00',4.38),('8902','2014-03-22','13:50:00',3.92),('8902','2014-03-22','13:55:00',2.07),('8902','2014-03-22','14:00:00',1.97),('8902','2014-03-22','14:05:00',1.32),('8902','2014-03-22','14:50:00',1.88),('8902','2014-03-22','14:55:00',2.01),('8902','2014-03-22','15:00:00',1.15),('8902','2014-03-22','15:05:00',1.8),('8902','2014-03-22','15:10:00',2.62),('8902','2014-03-22','15:15:00',3.97),('8902','2014-03-22','15:20:00',3.07),('8902','2014-03-22','15:25:00',3.71),('8902','2014-03-22','15:30:00',1.73),('8902','2014-03-22','15:35:00',1.96),('8902','2014-03-22','15:40:00',1.72),('8902','2014-03-22','15:45:00',1.32),('8902','2013-02-19','08:15:00',1.17),('8902','2013-02-19','08:20:00',2.02),('8902','2013-02-19','08:25:00',2.21),('8902','2013-02-19','08:30:00',2.4),('8902','2013-02-19','08:35:00',2.62),('8902','2013-02-19','08:40:00',2.79),('8902','2013-02-19','08:45:00',3),('8902','2013-02-19','08:50:00',3.2),('8902','2013-02-19','08:55:00',3.38),('8902','2013-02-19','09:00:00',3.66),('8902','2013-02-19','09:05:00',2.27),('8902','2013-02-19','09:10:00',2.3),('8902','2013-02-19','09:15:00',2.85),('8902','2013-02-19','09:20:00',2.12),('8902','2013-02-19','09:25:00',2.64),('8902','2013-02-19','09:30:00',3.91),('8902','2013-02-19','09:35:00',2.92),('8902','2013-02-19','09:40:00',2.06),('8902','2013-02-19','09:45:00',2.75),('8902','2013-02-19','09:50:00',2.46),('8902','2013-02-19','09:55:00',3.23),('8902','2013-02-19','10:00:00',2.26),('8902','2013-02-19','10:05:00',3.15),('8902','2013-02-19','10:10:00',2.01),('8902','2013-02-19','10:15:00',2.73),('8902','2013-02-19','10:20:00',1.61),('8902','2013-02-19','10:25:00',1.43),('8902','2013-02-19','10:30:00',1.67),('8902','2013-02-19','10:35:00',1.3),('8902','2013-02-19','10:40:00',1.67),('8902','2013-02-19','10:45:00',2.18),('8902','2013-02-19','10:50:00',5.94),('8902','2013-02-19','10:55:00',6.52),('8902','2013-02-19','11:00:00',1.43),('8902','2013-02-19','11:05:00',4.22),('8902','2013-02-19','11:10:00',5.15),('8902','2013-02-19','11:15:00',7.11),('8902','2013-02-19','11:20:00',2.09),('8902','2013-02-19','11:25:00',7.36),('8902','2013-02-19','11:30:00',8.41),('8902','2013-02-19','11:35:00',8.02),('8902','2013-02-19','11:40:00',8.4),('8902','2013-02-19','11:45:00',8),('8902','2013-02-19','11:50:00',7.92),('8902','2013-02-19','11:55:00',7.52),('8902','2013-02-19','12:00:00',7.75),('8902','2013-02-19','12:05:00',8.14),('8902','2013-02-19','12:10:00',7.97),('8902','2013-02-19','12:15:00',2.88),('8902','2013-02-19','12:20:00',2.86),('8902','2013-02-19','12:25:00',6.17),('8902','2013-02-19','12:30:00',8.99),('8902','2013-02-19','12:35:00',7.23),('8902','2013-02-19','12:40:00',4.7),('8902','2013-02-19','12:45:00',2.72),('8902','2013-02-19','12:50:00',2.11),('8902','2013-02-19','12:55:00',2.77),('8902','2013-02-19','13:00:00',4.48),('8902','2013-02-19','13:05:00',8.16),('8902','2013-02-19','13:10:00',8.07),('8902','2013-02-19','13:15:00',4.78),('8902','2013-02-19','13:20:00',2.11),('8902','2013-02-19','13:25:00',2.73),('8902','2013-02-19','13:30:00',5.85),('8902','2013-02-19','13:35:00',3.15),('8902','2013-02-19','13:40:00',3.23),('8902','2013-02-19','13:45:00',2.43),('8902','2013-02-19','13:50:00',2.57),('8902','2013-02-19','13:55:00',2.18),('8902','2013-02-19','14:00:00',3.53),('8902','2013-02-19','14:05:00',2.14),('8902','2013-02-19','14:10:00',1.95),('8902','2013-02-19','14:15:00',1.84),('8902','2013-02-19','14:20:00',1.5),('8902','2013-02-19','14:25:00',1.22),('8902','2013-02-19','14:30:00',1.53),('8902','2013-02-19','14:35:00',1.75),('8902','2013-02-19','14:40:00',1.94),('8902','2013-02-19','14:45:00',1.86),('8902','2013-02-19','14:50:00',1.73),('8902','2013-02-19','14:55:00',1.73),('8902','2013-02-19','15:00:00',1.64),('8902','2013-02-19','15:05:00',1.83),('8902','2013-02-19','15:10:00',1.91),('8902','2013-02-19','15:15:00',3.08),('8902','2013-02-19','15:20:00',3.13),('8902','2013-02-19','15:25:00',4.83),('8902','2013-02-19','15:30:00',2.8),('8902','2013-02-19','15:35:00',1.49),('8902','2013-02-19','15:40:00',1.2),('8902','2013-02-19','15:45:00',1.28),('8902','2013-02-19','15:50:00',1.46),('8902','2013-02-19','15:55:00',1.74),('8902','2013-02-19','16:00:00',2.56),('8902','2013-02-19','16:05:00',4.05),('8902','2013-02-19','16:10:00',3.84),('8902','2013-02-19','16:15:00',3.56),('8902','2013-02-19','16:20:00',3.25),('8902','2013-02-19','16:25:00',2.75),('8902','2013-02-19','16:30:00',2.6),('8902','2013-02-19','16:35:00',1.99),('8902','2013-02-19','16:40:00',1.4),('8902','2013-02-19','16:45:00',1.35),('8902','2013-02-19','16:50:00',1.18),('8902','2013-02-19','16:55:00',1.08),('8902','2013-02-19','17:00:00',1.04),('8902','2013-02-18','08:00:00',1.03),('8902','2013-02-18','08:05:00',1.18),('8902','2013-02-18','08:10:00',1.39),('8902','2013-02-18','08:15:00',1.72),('8902','2013-02-18','08:20:00',1.92),('8902','2013-02-18','08:25:00',2.14),('8902','2013-02-18','08:30:00',2.34),('8902','2013-02-18','08:35:00',2.53),('8902','2013-02-18','08:40:00',2.69),('8902','2013-02-18','08:45:00',2.89),('8902','2013-02-18','08:50:00',3.09),('8902','2013-02-18','08:55:00',3.26),('8902','2013-02-18','09:00:00',3.43),('8902','2013-02-18','09:05:00',3.59),('8902','2013-02-18','09:10:00',3.75),('8902','2013-02-18','09:15:00',3.9),('8902','2013-02-18','09:20:00',4.08),('8902','2013-02-18','09:25:00',4.23),('8902','2013-02-18','09:30:00',4.37),('8902','2013-02-18','09:35:00',4.5),('8902','2013-02-18','09:40:00',4.61),('8902','2013-02-18','09:45:00',4.77),('8902','2013-02-18','09:50:00',4.9),('8902','2013-02-18','09:55:00',5.03),('8902','2013-02-18','10:00:00',5.15),('8902','2013-02-18','10:05:00',5.3),('8902','2013-02-18','10:10:00',5.44),('8902','2013-02-18','10:15:00',5.56),('8902','2013-02-18','10:20:00',5.69),('8902','2013-02-18','10:25:00',5.75),('8902','2013-02-18','10:30:00',5.85),('8902','2013-02-18','10:35:00',5.95),('8902','2013-02-18','10:40:00',6.05),('8902','2013-02-18','10:45:00',6.12),('8902','2013-02-18','10:50:00',6.16),('8902','2013-02-18','10:55:00',6.22),('8902','2013-02-18','11:00:00',6.34),('8902','2013-02-18','11:05:00',6.47),('8902','2013-02-18','11:10:00',6.53),('8902','2013-02-18','11:15:00',6.53),('8902','2013-02-18','11:20:00',6.63),('8902','2013-02-18','11:25:00',6.69),('8902','2013-02-18','11:30:00',6.74),('8902','2013-02-18','11:35:00',6.82),('8902','2013-02-18','11:40:00',6.87),('8902','2013-02-18','11:45:00',6.82),('8902','2013-02-18','11:50:00',6.88),('8902','2013-02-18','11:55:00',6.95),('8902','2013-02-18','12:00:00',6.96),('8902','2013-02-18','12:05:00',6.97),('8902','2013-02-18','12:10:00',6.9),('8902','2013-02-18','12:15:00',6.88),('8902','2013-02-18','12:20:00',6.84),('8902','2013-02-18','12:25:00',6.89),('8902','2013-02-18','12:30:00',6.84),('8902','2013-02-18','12:35:00',6.88),('8902','2013-02-18','12:40:00',6.91),('8902','2013-02-18','12:45:00',6.93),('8902','2013-02-18','12:50:00',6.98),('8902','2013-02-18','12:55:00',6.92),('8902','2013-02-18','13:00:00',6.9),('8902','2013-02-18','13:05:00',6.9),('8902','2013-02-18','13:10:00',6.93),('8902','2013-02-18','13:15:00',6.82),('8902','2013-02-18','13:20:00',6.74),('8902','2013-02-18','13:25:00',6.74),('8902','2013-02-18','13:30:00',6.75),('8902','2013-02-18','13:35:00',6.7),('8902','2013-02-18','13:40:00',6.67),('8902','2013-02-18','13:45:00',6.64),('8902','2013-02-18','13:50:00',6.57),('8902','2013-02-18','13:55:00',6.53),('8902','2013-02-18','14:00:00',6.33),('8902','2013-02-18','14:05:00',6.17),('8902','2013-02-18','14:10:00',6.15),('8902','2013-02-18','14:15:00',6.1),('8902','2013-02-18','14:20:00',5.75),('8902','2013-02-18','14:25:00',3.63),('8902','2013-02-18','14:30:00',2.25),('8902','2013-02-18','14:35:00',5.66),('8902','2013-02-18','14:40:00',5.45),('8902','2013-02-18','14:45:00',5.28),('8902','2013-02-18','14:50:00',5.37),('8902','2013-02-18','14:55:00',5.2),('8902','2013-02-18','15:00:00',5.09),('8902','2013-02-18','15:05:00',4.99),('8902','2013-02-18','15:10:00',4.93),('8902','2013-02-18','15:15:00',4.84),('8902','2013-02-18','15:20:00',4.6),('8902','2013-02-18','15:25:00',4.43),('8902','2013-02-18','15:30:00',4.21),('8902','2013-02-18','15:35:00',4.03),('8902','2013-02-18','15:40:00',3.93),('8902','2013-02-18','15:45:00',3.85),('8902','2013-02-18','15:50:00',3.6),('8902','2013-02-18','15:55:00',3.42),('8902','2013-02-18','16:00:00',3.27),('8902','2013-02-18','16:05:00',3.09),('8902','2013-02-18','16:10:00',2.95),('8902','2013-02-18','16:15:00',2.77),('8902','2013-02-18','16:20:00',2.54),('8902','2013-02-18','16:25:00',2.34),('8902','2013-02-18','16:30:00',2.16),('8902','2013-02-18','16:35:00',1.98),('8902','2013-02-18','16:40:00',1.75),('8902','2013-02-18','16:45:00',1.53),('8902','2013-02-18','16:50:00',1.4),('8902','2013-02-18','16:55:00',1.18),('8902','2013-02-18','17:00:00',1.01),('8902','2013-02-17','08:05:00',1.14),('8902','2013-02-17','08:10:00',1.31),('8902','2013-02-17','08:15:00',1.58),('8902','2013-02-17','08:20:00',1.81),('8902','2013-02-17','08:25:00',1.99),('8902','2013-02-17','08:30:00',2.18),('8902','2013-02-17','08:35:00',2.38),('8902','2013-02-17','08:40:00',2.57),('8902','2013-02-17','08:45:00',2.74),('8902','2013-02-17','08:50:00',2.86),('8902','2013-02-17','08:55:00',3.03),('8902','2013-02-17','09:00:00',3.22),('8902','2013-02-17','09:05:00',3.39),('8902','2013-02-17','09:10:00',3.58),('8902','2013-02-17','09:15:00',3.76),('8902','2013-02-17','09:20:00',4.06),('8902','2013-02-17','09:25:00',4.44),('8902','2013-02-17','09:30:00',4.68),('8902','2013-02-17','09:35:00',2.33),('8902','2013-02-17','09:40:00',1.82),('8902','2013-02-17','09:45:00',2.12),('8902','2013-02-17','09:50:00',3.25),('8902','2013-02-17','09:55:00',1.47),('8902','2013-02-17','10:00:00',1.5),('8902','2013-02-17','10:05:00',2.03),('8902','2013-02-17','10:10:00',3.37),('8902','2013-02-17','10:20:00',1.09),('8902','2013-02-17','10:25:00',1.01),('8902','2013-02-17','10:30:00',1.16),('8902','2013-02-17','10:35:00',1.34),('8902','2013-02-17','10:40:00',1.54),('8902','2013-02-17','10:45:00',1.51),('8902','2013-02-17','10:50:00',1.29),('8902','2013-02-17','10:55:00',1.81),('8902','2013-02-17','11:00:00',2.36),('8902','2013-02-17','11:05:00',2.39),('8902','2013-02-17','11:10:00',2.49),('8902','2013-02-17','11:15:00',2.28),('8902','2013-02-17','11:20:00',2.57),('8902','2013-02-17','11:25:00',3.01),('8902','2013-02-17','11:30:00',2.58),('8902','2013-02-17','11:35:00',2.63),('8902','2013-02-17','11:40:00',2.59),('8902','2013-02-17','11:45:00',2.45),('8902','2013-02-17','11:50:00',2.63),('8902','2013-02-17','11:55:00',3.05),('8902','2013-02-17','12:00:00',3.28),('8902','2013-02-17','12:05:00',2.95),('8902','2013-02-17','12:10:00',2.72),('8902','2013-02-17','12:15:00',2.65),('8902','2013-02-17','12:20:00',2.55),('8902','2013-02-17','12:25:00',2.62),('8902','2013-02-17','12:30:00',2.47),('8902','2013-02-17','12:35:00',2.31),('8902','2013-02-17','12:40:00',2.47),('8902','2013-02-17','12:45:00',2.97),('8902','2013-02-17','12:50:00',2.96),('8902','2013-02-17','12:55:00',2.73),('8902','2013-02-17','13:00:00',2.71),('8902','2013-02-17','13:05:00',2.76),('8902','2013-02-17','13:10:00',2.74),('8902','2013-02-17','13:15:00',3.34),('8902','2013-02-17','13:20:00',2.86),('8902','2013-02-17','13:25:00',3.3),('8902','2013-02-17','13:30:00',3.17),('8902','2013-02-17','13:35:00',2.67),('8902','2013-02-17','13:40:00',2.49),('8902','2013-02-17','13:45:00',2.23),('8902','2013-02-17','13:50:00',2.36),('8902','2013-02-17','13:55:00',2.94),('8902','2013-02-17','14:00:00',2.95),('8902','2013-02-17','14:05:00',2.55),('8902','2013-02-17','14:10:00',2.44),('8902','2013-02-17','14:15:00',2.01),('8902','2013-02-17','14:20:00',2.28),('8902','2013-02-17','14:25:00',1.53),('8902','2013-02-17','14:30:00',1.12),('8902','2013-02-17','14:35:00',1.03),('8902','2013-02-17','15:35:00',1.23),('8902','2013-02-17','15:40:00',1.21),('8902','2013-02-16','08:05:00',1.09),('8902','2013-02-16','08:10:00',1.22),('8902','2013-02-16','08:15:00',1.37),('8902','2013-02-16','08:20:00',1.53),('8902','2013-02-16','08:25:00',1.79),('8902','2013-02-16','08:30:00',2.19),('8902','2013-02-16','08:35:00',2.49),('8902','2013-02-16','08:40:00',2.75),('8902','2013-02-16','08:45:00',2.74),('8902','2013-02-16','08:50:00',2.4),('8902','2013-02-16','08:55:00',2.79),('8902','2013-02-16','09:00:00',3.13),('8902','2013-02-16','09:05:00',3.16),('8902','2013-02-16','09:10:00',3.44),('8902','2013-02-16','09:15:00',3.62),('8902','2013-02-16','09:20:00',3.85),('8902','2013-02-16','09:25:00',3.99),('8902','2013-02-16','09:30:00',4.08),('8902','2013-02-16','09:35:00',4.21),('8902','2013-02-16','09:40:00',4.33),('8902','2013-02-16','09:45:00',4.48),('8902','2013-02-16','09:50:00',4.65),('8902','2013-02-16','09:55:00',4.81),('8902','2013-02-16','10:00:00',4.94),('8902','2013-02-16','10:05:00',5.06),('8902','2013-02-16','10:10:00',5.17),('8902','2013-02-16','10:15:00',5.27),('8902','2013-02-16','10:20:00',5.37),('8902','2013-02-16','10:25:00',5.47),('8902','2013-02-16','10:30:00',5.59),('8902','2013-02-16','10:35:00',5.68),('8902','2013-02-16','10:40:00',5.77),('8902','2013-02-16','10:45:00',5.88),('8902','2013-02-16','10:50:00',5.95),('8902','2013-02-16','10:55:00',6.05),('8902','2013-02-16','11:00:00',6.12),('8902','2013-02-16','11:05:00',6.19),('8902','2013-02-16','11:10:00',6.1),('8902','2013-02-16','11:15:00',6.17),('8902','2013-02-16','11:20:00',6.3),('8902','2013-02-16','11:25:00',6.37),('8902','2013-02-16','11:30:00',6.42),('8902','2013-02-16','11:35:00',6.52),('8902','2013-02-16','11:40:00',6.59),('8902','2013-02-16','11:45:00',6.58),('8902','2013-02-16','11:50:00',6.63),('8902','2013-02-16','11:55:00',6.67),('8902','2013-02-16','12:00:00',6.69),('8902','2013-02-16','12:05:00',6.72),('8902','2013-02-16','12:10:00',6.78),('8902','2013-02-16','12:15:00',6.8),('8902','2013-02-16','12:20:00',6.82),('8902','2013-02-16','12:25:00',6.78),('8902','2013-02-16','12:30:00',6.76),('8902','2013-02-16','12:35:00',6.71),('8902','2013-02-16','12:40:00',6.66),('8902','2013-02-16','12:45:00',6.65),('8902','2013-02-16','12:50:00',6.6),('8902','2013-02-16','12:55:00',6.64),('8902','2013-02-16','13:00:00',6.6),('8902','2013-02-16','13:05:00',6.59),('8902','2013-02-16','13:10:00',6.42),('8902','2013-02-16','13:15:00',6.43),('8902','2013-02-16','13:20:00',6.34),('8902','2013-02-16','13:25:00',2.37),('8902','2013-02-16','13:30:00',3.22),('8902','2013-02-16','13:35:00',6.48),('8902','2013-02-16','13:40:00',6.29),('8902','2013-02-16','13:45:00',5.97),('8902','2013-02-16','13:50:00',5.56),('8902','2013-02-16','13:55:00',5.51),('8902','2013-02-16','14:00:00',1.44),('8902','2013-02-16','14:05:00',1.05),('8902','2013-02-16','14:10:00',2.69),('8902','2013-02-16','14:15:00',4.25),('8902','2013-02-16','14:20:00',2.32),('8902','2013-02-16','14:25:00',1.22),('8902','2013-02-16','14:30:00',2.99),('8902','2013-02-16','14:35:00',1.35),('8902','2013-02-16','14:40:00',1.46),('8902','2013-02-16','14:45:00',1.06),('8902','2013-02-16','14:50:00',1.4),('8902','2013-02-16','14:55:00',1.29),('8902','2013-02-16','15:00:00',1.72),('8902','2013-02-16','15:05:00',4.66),('8902','2013-02-16','15:10:00',3.77),('8902','2013-02-16','15:15:00',5.38),('8902','2013-02-16','15:20:00',5.31),('8902','2013-02-16','15:25:00',4.3),('8902','2013-02-16','15:30:00',4.11),('8902','2013-02-16','15:35:00',4.42),('8902','2013-02-16','15:40:00',4.41),('8902','2013-02-16','15:45:00',4.19),('8902','2013-02-16','15:50:00',3.9),('8902','2013-02-16','15:55:00',3.71),('8902','2013-02-16','16:00:00',3.42),('8902','2013-02-16','16:05:00',3.19),('8902','2013-02-16','16:10:00',1.52),('8902','2013-02-16','16:15:00',1.02),('8902','2013-02-16','16:20:00',2.28),('8902','2013-02-16','16:25:00',2.5),('8902','2013-02-16','16:30:00',2.57),('8902','2013-02-16','16:35:00',1.91),('8902','2013-02-16','16:40:00',1.1),('8902','2013-02-15','08:05:00',1.16),('8902','2013-02-15','08:10:00',1.31),('8902','2013-02-15','08:15:00',1.47),('8902','2013-02-15','08:20:00',1.63),('8902','2013-02-15','08:25:00',1.84),('8902','2013-02-15','08:30:00',2.04),('8902','2013-02-15','08:35:00',2.26),('8902','2013-02-15','08:40:00',2.45),('8902','2013-02-15','08:45:00',2.62),('8902','2013-02-15','08:50:00',1.4),('8902','2013-02-15','09:00:00',1.09),('8902','2013-02-15','09:05:00',1.08),('8902','2013-02-15','09:10:00',1.4),('8902','2013-02-15','09:15:00',3.85),('8902','2013-02-15','09:20:00',3.9),('8902','2013-02-15','09:25:00',4.12),('8902','2013-02-15','09:30:00',4.2),('8902','2013-02-15','09:35:00',4.34),('8902','2013-02-15','09:40:00',4.46),('8902','2013-02-15','09:45:00',4.59),('8902','2013-02-15','09:50:00',4.79),('8902','2013-02-15','09:55:00',4.85),('8902','2013-02-15','10:00:00',4.93),('8902','2013-02-15','10:05:00',5.02),('8902','2013-02-15','10:10:00',5.23),('8902','2013-02-15','10:15:00',5.32),('8902','2013-02-15','10:20:00',5.47),('8902','2013-02-15','10:25:00',5.59),('8902','2013-02-15','10:30:00',5.68),('8902','2013-02-15','10:35:00',5.84),('8902','2013-02-15','10:40:00',5.23),('8902','2013-02-15','10:45:00',6.19),('8902','2013-02-15','10:50:00',6.03),('8902','2013-02-15','10:55:00',5.53),('8902','2013-02-15','11:00:00',6.36),('8902','2013-02-15','11:05:00',6.19),('8902','2013-02-15','11:10:00',5.9),('8902','2013-02-15','11:15:00',6.35),('8902','2013-02-15','11:20:00',5.98),('8902','2013-02-15','11:25:00',6.56),('8902','2013-02-15','11:30:00',6.6),('8902','2013-02-15','11:35:00',6.7),('8902','2013-02-15','11:40:00',6.7),('8902','2013-02-15','11:45:00',6.79),('8902','2013-02-15','11:50:00',6.86),('8902','2013-02-15','11:55:00',6.87),('8902','2013-02-15','12:00:00',6.87),('8902','2013-02-15','12:05:00',6.84),('8902','2013-02-15','12:10:00',6.85),('8902','2013-02-15','12:15:00',6.9),('8902','2013-02-15','12:20:00',6.89),('8902','2013-02-15','12:25:00',6.9),('8902','2013-02-15','12:30:00',6.89),('8902','2013-02-15','12:35:00',6.91),('8902','2013-02-15','12:40:00',6.92),('8902','2013-02-15','12:45:00',6.99),('8902','2013-02-15','12:50:00',6.99),('8902','2013-02-15','12:55:00',6.89),('8902','2013-02-15','13:00:00',6.93),('8902','2013-02-15','13:05:00',6.9),('8902','2013-02-15','13:10:00',6.84),('8902','2013-02-15','13:15:00',6.85),('8902','2013-02-15','13:20:00',6.83),('8902','2013-02-15','13:25:00',6.76),('8902','2013-02-15','13:30:00',6.75),('8902','2013-02-15','13:35:00',6.7),('8902','2013-02-15','13:40:00',6.71),('8902','2013-02-15','13:45:00',6.74),('8902','2013-02-15','13:50:00',6.67),('8902','2013-02-15','13:55:00',6.52),('8902','2013-02-15','14:00:00',6.44),('8902','2013-02-15','14:05:00',6.39),('8902','2013-02-15','14:10:00',6.32),('8902','2013-02-15','14:15:00',6.28),('8902','2013-02-15','14:20:00',2.38),('8902','2013-02-15','14:25:00',1.89),('8902','2013-02-15','14:30:00',2.12),('8902','2013-02-15','14:35:00',1.87),('8902','2013-02-15','14:40:00',1.93),('8902','2013-02-15','14:45:00',2.06),('8902','2013-02-15','14:50:00',1.99),('8902','2013-02-15','14:55:00',1.77),('8902','2013-02-15','15:00:00',1.64),('8902','2013-02-15','15:05:00',1.65),('8902','2013-02-15','15:10:00',1.65),('8902','2013-02-15','15:15:00',1.9),('8902','2013-02-15','15:20:00',3),('8902','2013-02-15','15:25:00',2.12),('8902','2013-02-15','15:30:00',3.5),('8902','2013-02-15','15:35:00',3.17),('8902','2013-02-15','15:40:00',4.76),('8902','2013-02-15','15:45:00',4.88),('8902','2013-02-15','15:50:00',4.55),('8902','2013-02-15','15:55:00',2.96),('8902','2013-02-15','16:00:00',3.2),('8902','2013-02-15','16:05:00',3.52),('8902','2013-02-15','16:10:00',2.91),('8902','2013-02-15','16:15:00',1.75),('8902','2013-02-15','16:20:00',1.13),('8902','2013-02-15','16:25:00',1.75),('8902','2013-02-15','16:30:00',1.28),('8902','2013-02-14','08:00:00',1.17),('8902','2013-02-14','08:05:00',1.18),('8902','2013-02-14','08:10:00',1.18),('8902','2013-02-14','08:15:00',1.43),('8902','2013-02-14','08:20:00',1.15),('8902','2013-02-14','08:25:00',1.11),('8902','2013-02-14','08:50:00',1),('8902','2013-02-14','08:55:00',1.25),('8902','2013-02-14','09:00:00',1.15),('8902','2013-02-14','09:05:00',1.44),('8902','2013-02-14','09:10:00',1.24),('8902','2013-02-14','09:15:00',1.5),('8902','2013-02-14','09:20:00',1.8),('8902','2013-02-14','09:25:00',2.4),('8902','2013-02-14','09:30:00',2.05),('8902','2013-02-14','09:35:00',1.85),('8902','2013-02-14','09:40:00',1.94),('8902','2013-02-14','09:45:00',1.81),('8902','2013-02-14','09:50:00',1.96),('8902','2013-02-14','09:55:00',2.23),('8902','2013-02-14','10:00:00',3.02),('8902','2013-02-14','10:05:00',3.53),('8902','2013-02-14','10:10:00',2.73),('8902','2013-02-14','10:15:00',2.23),('8902','2013-02-14','10:20:00',2.96),('8902','2013-02-14','10:25:00',4.28),('8902','2013-02-14','10:30:00',3.49),('8902','2013-02-14','10:35:00',5.28),('8902','2013-02-14','10:40:00',5.76),('8902','2013-02-14','10:45:00',5.55),('8902','2013-02-14','10:50:00',5.14),('8902','2013-02-14','10:55:00',3.62),('8902','2013-02-14','11:00:00',3.43),('8902','2013-02-14','11:05:00',3.49),('8902','2013-02-14','11:10:00',3.92),('8902','2013-02-14','11:15:00',4.91),('8902','2013-02-14','11:20:00',6.71),('8902','2013-02-14','11:25:00',6.67),('8902','2013-02-14','11:30:00',6.66),('8902','2013-02-14','11:35:00',5.54),('8902','2013-02-14','11:40:00',3.89),('8902','2013-02-14','11:45:00',3.93),('8902','2013-02-14','11:50:00',6.85),('8902','2013-02-14','11:55:00',7.06),('8902','2013-02-14','12:00:00',5.61),('8902','2013-02-14','12:05:00',5.99),('8902','2013-02-14','12:10:00',5.24),('8902','2013-02-14','12:15:00',5.77),('8902','2013-02-14','12:20:00',7.7),('8902','2013-02-14','12:25:00',6.84),('8902','2013-02-14','12:30:00',6.94),('8902','2013-02-14','12:35:00',7.04),('8902','2013-02-14','12:40:00',6.92),('8902','2013-02-14','12:45:00',6.89),('8902','2013-02-14','12:50:00',6.92),('8902','2013-02-14','12:55:00',6.74),('8902','2013-02-14','13:00:00',6.93),('8902','2013-02-14','13:05:00',6.93),('8902','2013-02-14','13:10:00',6.84),('8902','2013-02-14','13:15:00',7.02),('8902','2013-02-14','13:20:00',6.62),('8902','2013-02-14','13:25:00',6.39),('8902','2013-02-14','13:30:00',4.88),('8902','2013-02-14','13:35:00',4.9),('8902','2013-02-14','13:40:00',6.28),('8902','2013-02-14','13:45:00',5.44),('8902','2013-02-14','13:50:00',4.98),('8902','2013-02-14','13:55:00',6.57),('8902','2013-02-14','14:00:00',4.18),('8902','2013-02-14','14:05:00',6.02),('8902','2013-02-14','14:10:00',7.46),('8902','2013-02-14','14:15:00',5.28),('8902','2013-02-14','14:20:00',5.38),('8902','2013-02-14','14:25:00',3.84),('8902','2013-02-14','14:30:00',4.02),('8902','2013-02-14','14:35:00',5.54),('8902','2013-02-14','14:40:00',5.84),('8902','2013-02-14','14:45:00',5.24),('8902','2013-02-14','14:50:00',2.9),('8902','2013-02-14','14:55:00',2.41),('8902','2013-02-14','15:00:00',3.55),('8902','2013-02-14','15:05:00',2.75),('8902','2013-02-14','15:10:00',2.7),('8902','2013-02-14','15:15:00',3.59),('8902','2013-02-14','15:20:00',2.83),('8902','2013-02-14','15:25:00',3.12),('8902','2013-02-14','15:30:00',3.59),('8902','2013-02-14','15:35:00',2.9),('8902','2013-02-14','15:40:00',2.65),('8902','2013-02-14','15:45:00',2.53),('8902','2013-02-14','15:50:00',1.7),('8902','2013-02-14','15:55:00',1.57),('8902','2013-02-14','16:00:00',1.39),('8902','2013-02-14','16:05:00',1.31),('8902','2013-02-14','16:10:00',1.2),('8902','2013-02-14','16:15:00',1.07),('8902','2013-02-14','16:45:00',1.02),('8902','2013-02-13','08:05:00',1.01),('8902','2013-02-13','08:10:00',1.25),('8902','2013-02-13','08:15:00',1.54),('8902','2013-02-13','08:20:00',1.67),('8902','2013-02-13','08:25:00',1.87),('8902','2013-02-13','08:30:00',2.07),('8902','2013-02-13','08:35:00',2.35),('8902','2013-02-13','08:40:00',2.57),('8902','2013-02-13','08:45:00',2.75),('8902','2013-02-13','08:50:00',2.93),('8902','2013-02-13','08:55:00',3.12),('8902','2013-02-13','09:00:00',3.31),('8902','2013-02-13','09:05:00',3.5),('8902','2013-02-13','09:10:00',3.68),('8902','2013-02-13','09:15:00',3.86),('8902','2013-02-13','09:20:00',4.02),('8902','2013-02-13','09:25:00',4.19),('8902','2013-02-13','09:30:00',4.33),('8902','2013-02-13','09:35:00',4.49),('8902','2013-02-13','09:40:00',4.65),('8902','2013-02-13','09:45:00',4.8),('8902','2013-02-13','09:50:00',4.95),('8902','2013-02-13','09:55:00',5.08),('8902','2013-02-13','10:00:00',5.21),('8902','2013-02-13','10:05:00',5.34),('8902','2013-02-13','10:10:00',5.47),('8902','2013-02-13','10:15:00',5.6),('8902','2013-02-13','10:20:00',5.72),('8902','2013-02-13','10:25:00',5.81),('8902','2013-02-13','10:30:00',5.9),('8902','2013-02-13','10:35:00',6),('8902','2013-02-13','10:40:00',6.1),('8902','2013-02-13','10:45:00',6.18),('8902','2013-02-13','10:50:00',6.29),('8902','2013-02-13','10:55:00',6.39),('8902','2013-02-13','11:00:00',6.46),('8902','2013-02-13','11:05:00',6.52),('8902','2013-02-13','11:10:00',6.58),('8902','2013-02-13','11:15:00',6.64),('8902','2013-02-13','11:20:00',6.72),('8902','2013-02-13','11:25:00',6.78),('8902','2013-02-13','11:30:00',6.82),('8902','2013-02-13','11:35:00',6.85),('8902','2013-02-13','11:40:00',6.9),('8902','2013-02-13','11:45:00',6.93),('8902','2013-02-13','11:50:00',6.95),('8902','2013-02-13','11:55:00',6.97),('8902','2013-02-13','12:00:00',7.02),('8902','2013-02-13','12:05:00',7.07),('8902','2013-02-13','12:10:00',7.08),('8902','2013-02-13','12:15:00',7.11),('8902','2013-02-13','12:20:00',7.09),('8902','2013-02-13','12:25:00',7.08),('8902','2013-02-13','12:30:00',7.05),('8902','2013-02-13','12:35:00',7.06),('8902','2013-02-13','12:40:00',7.08),('8902','2013-02-13','12:45:00',7.03),('8902','2013-02-13','12:50:00',7.04),('8902','2013-02-13','12:55:00',7.05),('8902','2013-02-13','13:00:00',6.98),('8902','2013-02-13','13:05:00',6.95),('8902','2013-02-13','13:10:00',6.96),('8902','2013-02-13','13:15:00',6.96),('8902','2013-02-13','13:20:00',6.9),('8902','2013-02-13','13:25:00',6.84),('8902','2013-02-13','13:30:00',6.78),('8902','2013-02-13','13:35:00',6.74),('8902','2013-02-13','13:40:00',6.71),('8902','2013-02-13','13:45:00',6.62),('8902','2013-02-13','13:50:00',6.56),('8902','2013-02-13','13:55:00',6.47),('8902','2013-02-13','14:00:00',6.42),('8902','2013-02-13','14:05:00',6.35),('8902','2013-02-13','14:10:00',6.25),('8902','2013-02-13','14:15:00',6.16),('8902','2013-02-13','14:20:00',6.1),('8902','2013-02-13','14:25:00',5.99),('8902','2013-02-13','14:30:00',5.88),('8902','2013-02-13','14:35:00',5.77),('8902','2013-02-13','14:40:00',5.67),('8902','2013-02-13','14:45:00',5.56),('8902','2013-02-13','14:50:00',5.45),('8902','2013-02-13','14:55:00',5.31),('8902','2013-02-13','15:00:00',5.21),('8902','2013-02-13','15:05:00',5.05),('8902','2013-02-13','15:10:00',4.91),('8902','2013-02-13','15:15:00',4.83),('8902','2013-02-13','15:20:00',4.64),('8902','2013-02-13','15:25:00',4.42),('8902','2013-02-13','15:30:00',4.3),('8902','2013-02-13','15:35:00',4.11),('8902','2013-02-13','15:40:00',3.93),('8902','2013-02-13','15:45:00',3.81),('8902','2013-02-13','15:50:00',3.6),('8902','2013-02-13','15:55:00',3.42),('8902','2013-02-13','16:00:00',3.23),('8902','2013-02-13','16:05:00',3.06),('8902','2013-02-13','16:10:00',2.88),('8902','2013-02-13','16:15:00',2.69),('8902','2013-02-13','16:20:00',2.44),('8902','2013-02-13','16:25:00',2.26),('8902','2013-02-13','16:30:00',2.06),('8902','2013-02-13','16:35:00',1.85),('8902','2013-02-13','16:40:00',1.66),('8902','2013-02-13','16:45:00',1.46),('8902','2013-02-13','16:50:00',1.25),('8902','2013-02-13','16:55:00',1.05),('8902','2013-02-12','08:35:00',1.02),('8902','2013-02-12','08:40:00',1.15),('8902','2013-02-12','08:45:00',1.28),('8902','2013-02-12','08:50:00',1.43),('8902','2013-02-12','08:55:00',1.68),('8902','2013-02-12','09:00:00',2),('8902','2013-02-12','09:05:00',2.32),('8902','2013-02-12','09:10:00',2.48),('8902','2013-02-12','09:15:00',2.52),('8902','2013-02-12','09:20:00',2.45),('8902','2013-02-12','09:25:00',2.48),('8902','2013-02-12','09:30:00',2.88),('8902','2013-02-12','09:35:00',3.17),('8902','2013-02-12','09:40:00',4.11),('8902','2013-02-12','09:45:00',4.5),('8902','2013-02-12','09:50:00',4.66),('8902','2013-02-12','09:55:00',4.58),('8902','2013-02-12','10:00:00',4.44),('8902','2013-02-12','10:05:00',4.85),('8902','2013-02-12','10:10:00',5.06),('8902','2013-02-12','10:15:00',5.39),('8902','2013-02-12','10:20:00',5.57),('8902','2013-02-12','10:25:00',5.81),('8902','2013-02-12','10:30:00',5.92),('8902','2013-02-12','10:35:00',6.1),('8902','2013-02-12','10:40:00',6.16),('8902','2013-02-12','10:45:00',6.5),('8902','2013-02-12','10:50:00',6.52),('8902','2013-02-12','10:55:00',6.5),('8902','2013-02-12','11:00:00',6.54),('8902','2013-02-12','11:05:00',6.18),('8902','2013-02-12','11:10:00',6.52),('8902','2013-02-12','11:15:00',6.61),('8902','2013-02-12','11:20:00',6.55),('8902','2013-02-12','11:25:00',5.73),('8902','2013-02-12','11:30:00',5.36),('8902','2013-02-12','11:35:00',4.99),('8902','2013-02-12','11:40:00',3.64),('8902','2013-02-12','11:45:00',3.06),('8902','2013-02-12','11:50:00',5.3),('8902','2013-02-12','11:55:00',2.96),('8902','2013-02-12','12:00:00',1.97),('8902','2013-02-12','12:05:00',2.41),('8902','2013-02-12','12:10:00',4.4),('8902','2013-02-12','12:15:00',4.95),('8902','2013-02-12','12:20:00',3.52),('8902','2013-02-12','12:25:00',2.66),('8902','2013-02-12','12:30:00',1.94),('8902','2013-02-12','12:35:00',2.23),('8902','2013-02-12','12:40:00',1.94),('8902','2013-02-12','12:45:00',3.06),('8902','2013-02-12','12:50:00',4.62),('8902','2013-02-12','12:55:00',5.73),('8902','2013-02-12','13:00:00',5.01),('8902','2013-02-12','13:05:00',5.72),('8902','2013-02-12','13:10:00',4.97),('8902','2013-02-12','13:15:00',2.86),('8902','2013-02-12','13:20:00',6.37),('8902','2013-02-12','13:25:00',6.83),('8902','2013-02-12','13:30:00',7.28),('8902','2013-02-12','13:35:00',7),('8902','2013-02-12','13:40:00',6.17),('8902','2013-02-12','13:45:00',5.67),('8902','2013-02-12','13:50:00',5.41),('8902','2013-02-12','13:55:00',5.54),('8902','2013-02-12','14:00:00',6.36),('8902','2013-02-12','14:05:00',6.6),('8902','2013-02-12','14:10:00',5.72),('8902','2013-02-12','14:15:00',5.84),('8902','2013-02-12','14:20:00',5.3),('8902','2013-02-12','14:25:00',5.43),('8902','2013-02-12','14:30:00',5.73),('8902','2013-02-12','14:35:00',5.93),('8902','2013-02-12','14:40:00',5.69),('8902','2013-02-12','14:45:00',5.43),('8902','2013-02-12','14:50:00',5.49),('8902','2013-02-12','14:55:00',5.35),('8902','2013-02-12','15:00:00',5.2),('8902','2013-02-12','15:05:00',5.04),('8902','2013-02-12','15:10:00',4.9),('8902','2013-02-12','15:15:00',4.71),('8902','2013-02-12','15:20:00',4.62),('8902','2013-02-12','15:25:00',4.46),('8902','2013-02-12','15:30:00',4.33),('8902','2013-02-12','15:35:00',4.2),('8902','2013-02-12','15:40:00',4.05),('8902','2013-02-12','15:45:00',3.91),('8902','2013-02-12','15:50:00',3.65),('8902','2013-02-12','15:55:00',3.45),('8902','2013-02-12','16:00:00',3.25),('8902','2013-02-12','16:05:00',3.14),('8902','2013-02-12','16:10:00',2.97),('8902','2013-02-12','16:15:00',2.82),('8902','2013-02-12','16:20:00',2.51),('8902','2013-02-12','16:25:00',2.21),('8902','2013-02-12','16:30:00',2.06),('8902','2013-02-12','16:35:00',1.91),('8902','2013-02-12','16:40:00',1.75),('8902','2013-02-12','16:45:00',1.56),('8902','2013-02-12','16:50:00',1.2),('8902','2013-02-11','12:10:00',1.06),('8902','2013-02-11','12:15:00',1.08),('8902','2013-02-11','12:20:00',1.07),('8902','2013-02-11','12:25:00',1.08),('8902','2013-02-11','12:30:00',1.08),('8902','2013-02-10','09:15:00',1.02),('8902','2013-02-10','09:30:00',1.23),('8902','2013-02-10','09:35:00',1.19),('8902','2013-02-10','09:40:00',1.06),('8902','2013-02-10','10:00:00',1.05),('8902','2013-02-10','10:05:00',1.07),('8902','2013-02-10','10:10:00',1.18),('8902','2013-02-10','10:15:00',1.44),('8902','2013-02-10','10:20:00',1.8),('8902','2013-02-10','10:25:00',1.88),('8902','2013-02-10','10:30:00',2.02),('8902','2013-02-10','10:35:00',2.37),('8902','2013-02-10','10:40:00',2.06),('8902','2013-02-10','10:45:00',1.55),('8902','2013-02-10','10:50:00',1.35),('8902','2013-02-10','10:55:00',1.3),('8902','2013-02-10','11:00:00',1.95),('8902','2013-02-10','11:05:00',2.52),('8902','2013-02-10','11:10:00',2.57),('8902','2013-02-10','11:15:00',2.63),('8902','2013-02-10','11:20:00',2.13),('8902','2013-02-10','11:25:00',1.54),('8902','2013-02-10','11:35:00',1.03),('8902','2013-02-10','11:40:00',1.27),('8902','2013-02-10','11:45:00',1.79),('8902','2013-02-10','11:50:00',1.28),('8902','2013-02-10','11:55:00',1.08),('8902','2013-02-10','12:40:00',1.33),('8902','2013-02-10','12:45:00',2.29),('8902','2013-02-10','12:50:00',1.27),('8902','2013-02-10','12:55:00',1.06),('8902','2013-02-10','13:55:00',1.54),('8902','2013-02-10','14:00:00',1.82),('8902','2013-02-10','14:05:00',1.96),('8902','2013-02-10','14:10:00',2.14),('8902','2013-02-10','14:15:00',1.78),('8902','2013-02-10','14:20:00',1.86),('8902','2013-02-10','14:25:00',2.79),('8902','2013-02-10','14:30:00',3.64),('8902','2013-02-10','14:35:00',1.95),('8902','2013-02-10','14:40:00',2.77),('8902','2013-02-10','14:45:00',2.34),('8902','2013-02-10','14:50:00',1.58),('8902','2013-02-10','14:55:00',1.32),('8902','2013-02-10','15:05:00',1.55),('8902','2013-02-10','15:10:00',2.23),('8902','2013-02-10','15:15:00',1.24),('8902','2013-02-10','15:20:00',1.25),('8902','2013-02-10','15:25:00',1.3),('8902','2013-02-10','15:30:00',1.14),('8902','2013-02-10','15:35:00',1.26),('8902','2013-02-10','15:40:00',1.34),('8902','2013-02-10','15:45:00',1.43),('8902','2013-02-10','15:50:00',1.25),('8902','2014-03-21','07:35:00',1.44),('8902','2014-03-21','07:40:00',2.13),('8902','2014-03-21','07:45:00',2.06),('8902','2014-03-21','07:50:00',1.97),('8902','2014-03-21','07:55:00',1.21),('8902','2014-03-21','08:05:00',1.04),('8902','2014-03-21','08:10:00',1.71),('8902','2014-03-21','08:15:00',2.43),('8902','2014-03-21','08:20:00',2.96),('8902','2014-03-21','08:25:00',2.96),('8902','2014-03-21','08:30:00',3.37),('8902','2014-03-21','08:35:00',1.7),('8902','2014-03-21','08:40:00',2.96),('8902','2014-03-21','08:45:00',4.3),('8902','2014-03-21','08:50:00',3.15),('8902','2014-03-21','08:55:00',3.11),('8902','2014-03-21','09:00:00',4.04),('8902','2014-03-21','09:05:00',2.36),('8902','2014-03-21','09:10:00',2.7),('8902','2014-03-21','09:15:00',2.33),('8902','2014-03-21','09:20:00',2.48),('8902','2014-03-21','09:25:00',2.92),('8902','2014-03-21','09:30:00',4.19),('8902','2014-03-21','09:35:00',3.22),('8902','2014-03-21','09:40:00',3.11),('8902','2014-03-21','09:45:00',5.71),('8902','2014-03-21','09:50:00',5.81),('8902','2014-03-21','09:55:00',5.99),('8902','2014-03-21','10:00:00',6.13),('8902','2014-03-21','10:05:00',6.33),('8902','2014-03-21','10:10:00',7.27),('8902','2014-03-21','10:15:00',3.9),('8902','2014-03-21','10:20:00',2.4),('8902','2014-03-21','10:25:00',2.11),('8902','2014-03-21','10:30:00',2.23),('8902','2014-03-21','10:35:00',3.12),('8902','2014-03-21','10:40:00',4.18),('8902','2014-03-21','10:45:00',5.37),('8902','2014-03-21','10:50:00',6.83),('8902','2014-03-21','10:55:00',3.53),('8902','2014-03-21','11:00:00',2.41),('8902','2014-03-21','11:05:00',2.57),('8902','2014-03-21','11:10:00',2.15),('8902','2014-03-21','11:15:00',2.94),('8902','2014-03-21','11:20:00',5.06),('8902','2014-03-21','11:25:00',7.71),('8902','2014-03-21','11:30:00',6.04),('8902','2014-03-21','11:35:00',3.01),('8902','2014-03-21','11:40:00',4.57),('8902','2014-03-21','11:45:00',4.25),('8902','2014-03-21','11:50:00',4.26),('8902','2014-03-21','11:55:00',5.95),('8902','2014-03-21','12:00:00',5.6),('8902','2014-03-21','12:05:00',3.88),('8902','2014-03-21','12:10:00',2.58),('8902','2014-03-21','12:15:00',5.73),('8902','2014-03-21','12:20:00',9.26),('8902','2014-03-21','12:25:00',6.95),('8902','2014-03-21','12:30:00',3.19),('8902','2014-03-21','12:35:00',5.27),('8902','2014-03-21','12:40:00',4.59),('8902','2014-03-21','12:45:00',5.89),('8902','2014-03-21','12:50:00',7.47),('8902','2014-03-21','12:55:00',4.76),('8902','2014-03-21','13:00:00',5.78),('8902','2014-03-21','13:05:00',3.67),('8902','2014-03-21','13:10:00',7.36),('8902','2014-03-21','13:15:00',6.82),('8902','2014-03-21','13:20:00',6.83),('8902','2014-03-21','13:25:00',5.54),('8902','2014-03-21','13:30:00',6.4),('8902','2014-03-21','13:35:00',6.57),('8902','2014-03-21','13:40:00',6.64),('8902','2014-03-21','13:45:00',7.14),('8902','2014-03-21','13:50:00',3.84),('8902','2014-03-21','13:55:00',3.2),('8902','2014-03-21','14:00:00',7.65),('8902','2014-03-21','14:05:00',5.75),('8902','2014-03-21','14:10:00',7.45),('8902','2014-03-21','14:15:00',6.89),('8902','2014-03-21','14:20:00',6.9),('8902','2014-03-21','14:25:00',6.7),('8902','2014-03-21','14:30:00',6.55),('8902','2014-03-21','14:35:00',6.5),('8902','2014-03-21','14:40:00',6.35),('8902','2014-03-21','14:45:00',6.27),('8902','2014-03-21','14:50:00',6.18),('8902','2014-03-21','14:55:00',6.03),('8902','2014-03-21','15:00:00',5.88),('8902','2014-03-21','15:05:00',5.82),('8902','2014-03-21','15:10:00',5.61),('8902','2014-03-21','15:15:00',5.37),('8902','2014-03-21','15:20:00',5.42),('8902','2014-03-21','15:25:00',4.55),('8902','2014-03-21','15:30:00',2.97),('8902','2014-03-21','15:35:00',3.24),('8902','2014-03-21','15:40:00',3.61),('8902','2014-03-21','15:45:00',3.36),('8902','2014-03-21','15:50:00',4.92),('8902','2014-03-21','15:55:00',5.39),('8902','2014-03-21','16:00:00',4.24),('8902','2014-03-21','16:05:00',4.22),('8902','2014-03-21','16:10:00',3.97),('8902','2014-03-21','16:15:00',3.23),('8902','2014-03-21','16:20:00',3.1),('8902','2014-03-21','16:25:00',1.78),('8902','2014-03-21','16:30:00',1.35),('8902','2014-03-21','16:35:00',1.05),('8902','2014-03-21','16:40:00',1.02),('8902','2014-03-21','16:55:00',1.12),('8902','2014-03-21','17:00:00',1.28),('8902','2014-03-21','17:05:00',1.04),('8902','2013-02-09','09:05:00',1.02),('8902','2013-02-09','09:10:00',1.09),('8902','2013-02-09','09:15:00',1.22),('8902','2013-02-09','09:20:00',1.09),('8902','2013-02-09','09:35:00',1.08),('8902','2013-02-09','09:40:00',1.78),('8902','2013-02-09','09:45:00',1.8),('8902','2013-02-09','09:50:00',3.4),('8902','2013-02-09','09:55:00',3.24),('8902','2013-02-09','10:00:00',3.86),('8902','2013-02-09','10:05:00',5.34),('8902','2013-02-09','10:10:00',5.16),('8902','2013-02-09','10:15:00',5.51),('8902','2013-02-09','10:20:00',5.6),('8902','2013-02-09','10:25:00',5.73),('8902','2013-02-09','10:30:00',5.85),('8902','2013-02-09','10:35:00',5.95),('8902','2013-02-09','10:40:00',6.03),('8902','2013-02-09','10:45:00',6.11),('8902','2013-02-09','10:50:00',6.2),('8902','2013-02-09','10:55:00',6.27),('8902','2013-02-09','11:00:00',6.36),('8902','2013-02-09','11:05:00',6.41),('8902','2013-02-09','11:10:00',6.47),('8902','2013-02-09','11:15:00',6.54),('8902','2013-02-09','11:20:00',6.58),('8902','2013-02-09','11:25:00',6.63),('8902','2013-02-09','11:30:00',6.7),('8902','2013-02-09','11:35:00',6.74),('8902','2013-02-09','11:40:00',6.81),('8902','2013-02-09','11:45:00',6.87),('8902','2013-02-09','11:50:00',6.89),('8902','2013-02-09','11:55:00',6.96),('8902','2013-02-09','12:00:00',7.01),('8902','2013-02-09','12:05:00',7),('8902','2013-02-09','12:10:00',7.05),('8902','2013-02-09','12:15:00',7.09),('8902','2013-02-09','12:20:00',7.1),('8902','2013-02-09','12:25:00',7.11),('8902','2013-02-09','12:30:00',7.07),('8902','2013-02-09','12:35:00',7.05),('8902','2013-02-09','12:40:00',7.03),('8902','2013-02-09','12:45:00',7),('8902','2013-02-09','12:50:00',7),('8902','2013-02-09','12:55:00',6.97),('8902','2013-02-09','13:00:00',6.9),('8902','2013-02-09','13:05:00',6.77),('8902','2013-02-09','13:10:00',6.78),('8902','2013-02-09','13:15:00',6.8),('8902','2013-02-09','13:20:00',6.73),('8902','2013-02-09','13:25:00',6.7),('8902','2013-02-09','13:30:00',6.7),('8902','2013-02-09','13:35:00',6.58),('8902','2013-02-09','13:40:00',6.45),('8902','2013-02-09','13:45:00',6.39),('8902','2013-02-09','13:50:00',6.33),('8902','2013-02-09','13:55:00',6.28),('8902','2013-02-09','14:00:00',6.16),('8902','2013-02-09','14:05:00',6.03),('8902','2013-02-09','14:10:00',5.93),('8902','2013-02-09','14:15:00',5.86),('8902','2013-02-09','14:20:00',5.8),('8902','2013-02-09','14:25:00',5.67),('8902','2013-02-09','14:30:00',5.59),('8902','2013-02-09','14:35:00',5.58),('8902','2013-02-09','14:40:00',5.05),('8902','2013-02-09','14:45:00',5.35),('8902','2013-02-09','14:50:00',5.25),('8902','2013-02-09','14:55:00',5.04),('8902','2013-02-09','15:00:00',4.08),('8902','2013-02-09','15:05:00',2.81),('8902','2013-02-09','15:10:00',2.68),('8902','2013-02-09','15:15:00',3.52),('8902','2013-02-09','15:20:00',1.07),('8902','2013-02-09','15:25:00',3.61),('8902','2013-02-09','15:30:00',3.28),('8902','2013-02-09','15:35:00',3.24),('8902','2013-02-09','15:40:00',2.26),('8902','2013-02-09','15:45:00',1.33),('8902','2013-02-09','16:20:00',1.06),('8902','2013-02-09','16:25:00',1.86),('8902','2013-02-09','16:30:00',1.75),('8902','2013-02-09','16:35:00',2.11),('8902','2013-02-09','16:40:00',1.68),('8902','2013-02-08','09:10:00',1.04),('8902','2013-02-08','09:15:00',1.13),('8902','2013-02-08','09:20:00',1.17),('8902','2013-02-08','09:25:00',1.35),('8902','2013-02-08','09:30:00',1.61),('8902','2013-02-08','09:35:00',1.72),('8902','2013-02-08','09:40:00',1.48),('8902','2013-02-08','09:45:00',1.3),('8902','2013-02-08','09:50:00',1.34),('8902','2013-02-08','09:55:00',1.31),('8902','2013-02-08','10:00:00',1.2),('8902','2013-02-08','10:05:00',1.12),('8902','2013-02-08','10:10:00',1.03),('8902','2013-02-08','10:30:00',1.01),('8902','2013-02-08','10:35:00',1.09),('8902','2013-02-08','10:40:00',1.23),('8902','2013-02-08','10:45:00',1.43),('8902','2013-02-08','10:50:00',1.62),('8902','2013-02-08','10:55:00',1.74),('8902','2013-02-08','11:00:00',1.86),('8902','2013-02-08','11:05:00',1.93),('8902','2013-02-08','11:10:00',1.99),('8902','2013-02-08','11:15:00',2.09),('8902','2013-02-08','11:20:00',2.15),('8902','2013-02-08','11:25:00',2.19),('8902','2013-02-08','11:30:00',2.23),('8902','2013-02-08','11:35:00',2.17),('8902','2013-02-08','11:40:00',2.11),('8902','2013-02-08','11:45:00',2.16),('8902','2013-02-08','11:50:00',2.15),('8902','2013-02-08','11:55:00',2.07),('8902','2013-02-08','12:00:00',2.1),('8902','2013-02-08','12:05:00',2.09),('8902','2013-02-08','12:10:00',2.07),('8902','2013-02-08','12:15:00',2.08),('8902','2013-02-08','12:20:00',2.12),('8902','2013-02-08','12:25:00',2.13),('8902','2013-02-08','12:30:00',2.17),('8902','2013-02-08','12:35:00',2.29),('8902','2013-02-08','12:40:00',2.35),('8902','2013-02-08','12:45:00',2.36),('8902','2013-02-08','12:50:00',2.41),('8902','2013-02-08','12:55:00',2.38),('8902','2013-02-08','13:00:00',2.51),('8902','2013-02-08','13:05:00',2.91),('8902','2013-02-08','13:10:00',3.24),('8902','2013-02-08','13:15:00',3.61),('8902','2013-02-08','13:20:00',3.97),('8902','2013-02-08','13:25:00',4.24),('8902','2013-02-08','13:30:00',5.06),('8902','2013-02-08','13:35:00',5.04),('8902','2013-02-08','13:40:00',5.4),('8902','2013-02-08','13:45:00',5.77),('8902','2013-02-08','13:50:00',6.38),('8902','2013-02-08','13:55:00',5.9),('8902','2013-02-08','14:00:00',6.43),('8902','2013-02-08','14:05:00',5.9),('8902','2013-02-08','14:10:00',4.82),('8902','2013-02-08','14:15:00',5.32),('8902','2013-02-08','14:20:00',6.73),('8902','2013-02-08','14:25:00',7.05),('8902','2013-02-08','14:30:00',6.48),('8902','2013-02-08','14:35:00',5.98),('8902','2013-02-08','14:40:00',5.47),('8902','2013-02-08','14:45:00',5.17),('8902','2013-02-08','14:50:00',5.01),('8902','2013-02-08','14:55:00',5.11),('8902','2013-02-08','15:00:00',4.95),('8902','2013-02-08','15:05:00',4.7),('8902','2013-02-08','15:10:00',4.59),('8902','2013-02-08','15:15:00',4.42),('8902','2013-02-08','15:20:00',4.18),('8902','2013-02-08','15:25:00',4.01),('8902','2013-02-08','15:30:00',3.62),('8902','2013-02-08','15:35:00',3.72),('8902','2013-02-08','15:40:00',2.93),('8902','2013-02-08','15:45:00',1.86),('8902','2013-02-08','15:50:00',3.17),('8902','2013-02-08','15:55:00',3.03),('8902','2013-02-08','16:25:00',1.68),('8902','2013-02-08','16:30:00',1.66),('8902','2013-02-08','16:35:00',1.5),('8902','2013-02-08','16:40:00',1.47),('8902','2013-02-08','16:45:00',1.14),('8902','2013-02-07','08:55:00',1.1),('8902','2013-02-07','09:00:00',1.07),('8902','2013-02-07','09:05:00',1.01),('8902','2013-02-07','09:20:00',1.13),('8902','2013-02-07','09:25:00',1.28),('8902','2013-02-07','09:30:00',1.52),('8902','2013-02-07','09:35:00',3.45),('8902','2013-02-07','09:40:00',5.45),('8902','2013-02-07','09:45:00',5.05),('8902','2013-02-07','09:50:00',5.58),('8902','2013-02-07','09:55:00',5.54),('8902','2013-02-07','10:00:00',5.84),('8902','2013-02-07','10:05:00',6.18),('8902','2013-02-07','10:10:00',6.15),('8902','2013-02-07','10:15:00',4.96),('8902','2013-02-07','10:20:00',4.97),('8902','2013-02-07','10:25:00',5.77),('8902','2013-02-07','10:30:00',6.85),('8902','2013-02-07','10:35:00',3.13),('8902','2013-02-07','10:40:00',4.57),('8902','2013-02-07','10:45:00',7),('8902','2013-02-07','10:50:00',6.85),('8902','2013-02-07','10:55:00',6.73),('8902','2013-02-07','11:00:00',6.58),('8902','2013-02-07','11:05:00',6.51),('8902','2013-02-07','11:10:00',6.56),('8902','2013-02-07','11:15:00',6.59),('8902','2013-02-07','11:20:00',6.64),('8902','2013-02-07','11:25:00',6.66),('8902','2013-02-07','11:30:00',6.67),('8902','2013-02-07','11:35:00',6.71),('8902','2013-02-07','11:40:00',6.75),('8902','2013-02-07','11:45:00',6.78),('8902','2013-02-07','11:50:00',6.83),('8902','2013-02-07','11:55:00',6.84),('8902','2013-02-07','12:00:00',6.87),('8902','2013-02-07','12:05:00',6.94),('8902','2013-02-07','12:10:00',6.94),('8902','2013-02-07','12:15:00',6.95),('8902','2013-02-07','12:20:00',6.98),('8902','2013-02-07','12:25:00',6.96),('8902','2013-02-07','12:30:00',7),('8902','2013-02-07','12:35:00',7.03),('8902','2013-02-07','12:40:00',7.17),('8902','2013-02-07','12:45:00',7.37),('8902','2013-02-07','12:50:00',5.82),('8902','2013-02-07','12:55:00',3.87),('8902','2013-02-07','13:00:00',3.81),('8902','2013-02-07','13:05:00',3.43),('8902','2013-02-07','13:10:00',3.82),('8902','2013-02-07','13:15:00',3.73),('8902','2013-02-07','13:20:00',3.74),('8902','2013-02-07','13:25:00',3.68),('8902','2013-02-07','13:30:00',3.54),('8902','2013-02-07','13:35:00',4.57),('8902','2013-02-07','13:40:00',3.93),('8902','2013-02-07','13:45:00',3.1),('8902','2013-02-07','13:50:00',3.18),('8902','2013-02-07','13:55:00',3.17),('8902','2013-02-07','14:00:00',2.96),('8902','2013-02-07','14:05:00',2.95),('8902','2013-02-07','14:10:00',2.64),('8902','2013-02-07','14:15:00',2.36),('8902','2013-02-07','14:20:00',2.33),('8902','2013-02-07','14:25:00',2.5),('8902','2013-02-07','14:30:00',3.48),('8902','2013-02-07','14:35:00',3.7),('8902','2013-02-07','14:40:00',6.91),('8902','2013-02-07','14:45:00',6.91),('8902','2013-02-07','14:50:00',4.09),('8902','2013-02-07','14:55:00',4.63),('8902','2013-02-07','15:00:00',4.52),('8902','2013-02-07','15:05:00',6.38),('8902','2013-02-07','15:10:00',6.29),('8902','2013-02-07','15:15:00',5.63),('8902','2013-02-07','15:20:00',4.67),('8902','2013-02-07','15:25:00',4.66),('8902','2013-02-07','15:30:00',4.32),('8902','2013-02-07','15:35:00',4.12),('8902','2013-02-07','15:40:00',3.93),('8902','2013-02-07','15:45:00',3.78),('8902','2013-02-07','15:50:00',3.56),('8902','2013-02-07','15:55:00',3.32),('8902','2013-02-07','16:00:00',3.12),('8902','2013-02-07','16:05:00',2.91),('8902','2013-02-07','16:10:00',2.75),('8902','2013-02-07','16:15:00',2.21),('8902','2013-02-06','09:15:00',1.01),('8902','2013-02-06','09:20:00',1.18),('8902','2013-02-06','09:30:00',1.01),('8902','2013-02-06','09:35:00',1),('8902','2013-02-06','09:40:00',1.03),('8902','2013-02-06','09:45:00',1.12),('8902','2013-02-06','09:50:00',1.2),('8902','2013-02-06','10:25:00',1.2),('8902','2013-02-06','10:30:00',1.28),('8902','2013-02-06','10:35:00',1.6),('8902','2013-02-06','10:40:00',2.04),('8902','2013-02-06','10:45:00',2.89),('8902','2013-02-06','10:50:00',1.41),('8902','2013-02-06','10:55:00',2.35),('8902','2013-02-06','11:00:00',2.84),('8902','2013-02-06','11:05:00',2.52),('8902','2013-02-06','11:10:00',1.68),('8902','2013-02-06','11:15:00',1.05),('8902','2013-02-06','11:30:00',1.03),('8902','2013-02-06','12:20:00',1.16),('8902','2013-02-06','12:25:00',5.77),('8902','2013-02-06','12:30:00',4.52),('8902','2013-02-06','12:35:00',1.99),('8902','2013-02-06','12:40:00',1.13),('8902','2013-02-06','12:45:00',1.28),('8902','2013-02-06','12:50:00',1.42),('8902','2013-02-06','12:55:00',1.1),('8902','2013-02-06','13:05:00',1.08),('8902','2013-02-06','13:10:00',1.38),('8902','2013-02-06','13:15:00',2.15),('8902','2013-02-06','13:20:00',2.66),('8902','2013-02-06','13:25:00',2.78),('8902','2013-02-06','13:30:00',2.06),('8902','2013-02-06','13:35:00',1.47),('8902','2013-02-06','13:40:00',1.67),('8902','2013-02-06','13:45:00',1.69),('8902','2013-02-06','13:50:00',1.73),('8902','2013-02-06','13:55:00',2.02),('8902','2013-02-06','14:00:00',2.5),('8902','2013-02-06','14:05:00',3.64),('8902','2013-02-06','14:10:00',5.97),('8902','2013-02-06','14:15:00',5.47),('8902','2013-02-06','14:20:00',4.29),('8902','2013-02-06','14:25:00',2.24),('8902','2013-02-06','14:30:00',1.69),('8902','2013-02-06','14:35:00',2.71),('8902','2013-02-06','14:40:00',2.89),('8902','2013-02-06','14:45:00',4.17),('8902','2013-02-06','14:50:00',3.18),('8902','2013-02-06','14:55:00',2.12),('8902','2013-02-06','15:00:00',3.89),('8902','2013-02-06','15:05:00',5.03),('8902','2013-02-06','15:10:00',5.37),('8902','2013-02-06','15:15:00',4.99),('8902','2013-02-06','15:20:00',2.47),('8902','2013-02-06','15:25:00',3.81),('8902','2013-02-06','15:30:00',2.21),('8902','2013-02-06','15:35:00',2.04),('8902','2013-02-06','15:40:00',1.4),('8902','2013-02-06','15:50:00',1.03),('8902','2013-02-06','15:55:00',1.05),('8902','2013-02-05','08:30:00',1.05),('8902','2013-02-05','08:35:00',1.3),('8902','2013-02-05','08:40:00',1.55),('8902','2013-02-05','08:45:00',1.94),('8902','2013-02-05','08:50:00',2.49),('8902','2013-02-05','08:55:00',1.93),('8902','2013-02-05','09:00:00',2.11),('8902','2013-02-05','09:05:00',2.29),('8902','2013-02-05','09:10:00',2.95),('8902','2013-02-05','09:15:00',1.87),('8902','2013-02-05','09:20:00',1.92),('8902','2013-02-05','09:25:00',2.12),('8902','2013-02-05','09:30:00',2.93),('8902','2013-02-05','09:35:00',2.19),('8902','2013-02-05','09:40:00',3.18),('8902','2013-02-05','09:45:00',2.28),('8902','2013-02-05','09:50:00',2.43),('8902','2013-02-05','09:55:00',3.08),('8902','2013-02-05','10:00:00',2.53),('8902','2013-02-05','10:05:00',3.45),('8902','2013-02-05','10:10:00',2.95),('8902','2013-02-05','10:15:00',2.59),('8902','2013-02-05','10:20:00',2.37),('8902','2013-02-05','10:25:00',3.32),('8902','2013-02-05','10:30:00',2.85),('8902','2013-02-05','10:35:00',3.71),('8902','2013-02-05','10:40:00',2.87),('8902','2013-02-05','10:45:00',2.06),('8902','2013-02-05','10:50:00',3.49),('8902','2013-02-05','10:55:00',4.42),('8902','2013-02-05','11:00:00',3.46),('8902','2013-02-05','11:05:00',2.61),('8902','2013-02-05','11:10:00',3.06),('8902','2013-02-05','11:15:00',2.68),('8902','2013-02-05','11:20:00',3.99),('8902','2013-02-05','11:25:00',5.84),('8902','2013-02-05','11:30:00',3.42),('8902','2013-02-05','11:35:00',2.82),('8902','2013-02-05','11:40:00',3.05),('8902','2013-02-05','11:45:00',3.12),('8902','2013-02-05','11:50:00',3.19),('8902','2013-02-05','11:55:00',2.9),('8902','2013-02-05','12:00:00',2.56),('8902','2013-02-05','12:05:00',2.15),('8902','2013-02-05','12:10:00',1.65),('8902','2013-02-05','12:15:00',1.91),('8902','2013-02-05','12:20:00',1.94),('8902','2013-02-05','12:25:00',1.87),('8902','2013-02-05','12:30:00',1.59),('8902','2013-02-05','12:35:00',1.4),('8902','2013-02-05','12:40:00',1.22),('8902','2013-02-05','12:45:00',1.17),('8902','2013-02-05','12:50:00',1.17),('8902','2013-02-05','12:55:00',1.17),('8902','2013-02-05','13:00:00',1.09),('8902','2013-02-05','13:05:00',1.05),('8902','2013-02-05','13:10:00',1.22),('8902','2013-02-05','13:15:00',1.46),('8902','2013-02-05','13:20:00',1.63),('8902','2013-02-05','13:25:00',1.8),('8902','2013-02-05','13:30:00',2.17),('8902','2013-02-05','13:35:00',2.36),('8902','2013-02-05','13:40:00',2.11),('8902','2013-02-05','13:45:00',1.79),('8902','2013-02-05','13:50:00',3.17),('8902','2013-02-05','13:55:00',2.53),('8902','2013-02-05','14:00:00',2.91),('8902','2013-02-05','14:05:00',2.46),('8902','2013-02-05','14:10:00',1.45),('8902','2013-02-05','14:30:00',3.11),('8902','2013-02-05','14:35:00',5.02),('8902','2013-02-05','14:40:00',2.89),('8902','2013-02-05','14:45:00',1.22),('8902','2013-02-05','15:15:00',1.02),('8902','2013-02-05','15:20:00',1.19),('8902','2013-02-05','15:25:00',1.85),('8902','2013-02-05','15:30:00',1.15),('8902','2013-02-05','15:45:00',1.12),('8902','2013-02-05','15:50:00',1.61),('8902','2013-02-04','08:15:00',1.06),('8902','2013-02-04','08:20:00',1.19),('8902','2013-02-04','08:25:00',1.47),('8902','2013-02-04','08:30:00',1.76),('8902','2013-02-04','08:35:00',1.98),('8902','2013-02-04','08:40:00',2.15),('8902','2013-02-04','08:45:00',2.33),('8902','2013-02-04','08:50:00',2.49),('8902','2013-02-04','08:55:00',2.65),('8902','2013-02-04','09:00:00',2.79),('8902','2013-02-04','09:05:00',2.95),('8902','2013-02-04','09:10:00',3.17),('8902','2013-02-04','09:15:00',3.34),('8902','2013-02-04','09:20:00',3.52),('8902','2013-02-04','09:25:00',3.7),('8902','2013-02-04','09:30:00',3.84),('8902','2013-02-04','09:35:00',3.95),('8902','2013-02-04','09:40:00',4.14),('8902','2013-02-04','09:45:00',4.27),('8902','2013-02-04','09:50:00',4.44),('8902','2013-02-04','09:55:00',4.58),('8902','2013-02-04','10:00:00',4.63),('8902','2013-02-04','10:05:00',4.77),('8902','2013-02-04','10:10:00',4.51),('8902','2013-02-04','10:15:00',4.59),('8902','2013-02-04','10:20:00',5.04),('8902','2013-02-04','10:25:00',5.21),('8902','2013-02-04','10:30:00',5.29),('8902','2013-02-04','10:35:00',5.37),('8902','2013-02-04','10:40:00',5.44),('8902','2013-02-04','10:45:00',5.48),('8902','2013-02-04','10:50:00',5.52),('8902','2013-02-04','10:55:00',5.6),('8902','2013-02-04','11:00:00',5.64),('8902','2013-02-04','11:05:00',5.72),('8902','2013-02-04','11:10:00',5.83),('8902','2013-02-04','11:15:00',5.88),('8902','2013-02-04','11:20:00',5.91),('8902','2013-02-04','11:25:00',5.89),('8902','2013-02-04','11:30:00',6.04),('8902','2013-02-04','11:35:00',5.73),('8902','2013-02-04','11:40:00',5.1),('8902','2013-02-04','11:45:00',4.02),('8902','2013-02-04','11:50:00',3.33),('8902','2013-02-04','11:55:00',2.8),('8902','2013-02-04','12:00:00',2.32),('8902','2013-02-04','12:05:00',1.99),('8902','2013-02-04','12:10:00',4.79),('8902','2013-02-04','12:15:00',2.98),('8902','2013-02-04','12:20:00',2.28),('8902','2013-02-04','12:25:00',2.15),('8902','2013-02-04','12:30:00',2.09),('8902','2013-02-04','12:35:00',2.37),('8902','2013-02-04','12:40:00',3.45),('8902','2013-02-04','12:45:00',3.52),('8902','2013-02-04','12:50:00',5.51),('8902','2013-02-04','12:55:00',1.85),('8902','2013-02-04','13:00:00',1.26),('8902','2013-02-04','13:05:00',1.44),('8902','2013-02-04','13:10:00',1.76),('8902','2013-02-04','13:15:00',2.38),('8902','2013-02-04','13:20:00',2.4),('8902','2013-02-04','13:25:00',2.21),('8902','2013-02-04','13:30:00',2.35),('8902','2013-02-04','13:35:00',1.79),('8902','2013-02-04','13:40:00',1.64),('8902','2013-02-04','13:45:00',2.26),('8902','2013-02-04','13:50:00',2.49),('8902','2013-02-04','13:55:00',2.14),('8902','2013-02-04','14:00:00',2),('8902','2013-02-04','14:05:00',2.16),('8902','2013-02-04','14:10:00',1.77),('8902','2013-02-04','14:15:00',1.87),('8902','2013-02-04','14:20:00',2.02),('8902','2013-02-04','14:25:00',2.93),('8902','2013-02-04','14:30:00',3.71),('8902','2013-02-04','14:35:00',2.7),('8902','2013-02-04','14:40:00',4.48),('8902','2013-02-04','14:45:00',3.79),('8902','2013-02-04','14:50:00',1.81),('8902','2013-02-04','14:55:00',1.92),('8902','2013-02-04','15:00:00',1.47),('8902','2013-02-04','15:05:00',2.06),('8902','2013-02-04','15:10:00',1.58),('8902','2013-02-04','15:15:00',1.18),('8902','2013-02-03','08:15:00',1.01),('8902','2013-02-03','08:20:00',1.16),('8902','2013-02-03','08:25:00',1.49),('8902','2013-02-03','08:30:00',1.79),('8902','2013-02-03','08:35:00',2),('8902','2013-02-03','08:40:00',2.19),('8902','2013-02-03','08:45:00',2.39),('8902','2013-02-03','08:50:00',2.57),('8902','2013-02-03','08:55:00',2.4),('8902','2013-02-03','09:00:00',3.01),('8902','2013-02-03','09:05:00',3.27),('8902','2013-02-03','09:10:00',3.5),('8902','2013-02-03','09:15:00',3.64),('8902','2013-02-03','09:20:00',3.67),('8902','2013-02-03','09:25:00',3.63),('8902','2013-02-03','09:30:00',3.98),('8902','2013-02-03','09:35:00',4.04),('8902','2013-02-03','09:40:00',4.18),('8902','2013-02-03','09:45:00',3.86),('8902','2013-02-03','09:50:00',4.41),('8902','2013-02-03','09:55:00',4.88),('8902','2013-02-03','10:00:00',5.01),('8902','2013-02-03','10:05:00',5.13),('8902','2013-02-03','10:10:00',5.34),('8902','2013-02-03','10:15:00',5.52),('8902','2013-02-03','10:20:00',5.31),('8902','2013-02-03','10:25:00',5.49),('8902','2013-02-03','10:30:00',5.31),('8902','2013-02-03','10:35:00',5.04),('8902','2013-02-03','10:40:00',5.35),('8902','2013-02-03','10:45:00',5.84),('8902','2013-02-03','10:50:00',5.94),('8902','2013-02-03','10:55:00',5.96),('8902','2013-02-03','11:00:00',6.03),('8902','2013-02-03','11:05:00',6.18),('8902','2013-02-03','11:10:00',6.23),('8902','2013-02-03','11:15:00',6.29),('8902','2013-02-03','11:20:00',6.31),('8902','2013-02-03','11:25:00',6.36),('8902','2013-02-03','11:30:00',6.4),('8902','2013-02-03','11:35:00',6.44),('8902','2013-02-03','11:40:00',6.47),('8902','2013-02-03','11:45:00',6.51),('8902','2013-02-03','11:50:00',6.54),('8902','2013-02-03','11:55:00',6.6),('8902','2013-02-03','12:00:00',6.61),('8902','2013-02-03','12:05:00',6.67),('8902','2013-02-03','12:10:00',6.71),('8902','2013-02-03','12:15:00',6.68),('8902','2013-02-03','12:20:00',6.71),('8902','2013-02-03','12:25:00',6.7),('8902','2013-02-03','12:30:00',6.69),('8902','2013-02-03','12:35:00',6.67),('8902','2013-02-03','12:40:00',6.68),('8902','2013-02-03','12:45:00',6.67),('8902','2013-02-03','12:50:00',6.62),('8902','2013-02-03','12:55:00',6.58),('8902','2013-02-03','13:00:00',6.6),('8902','2013-02-03','13:05:00',6.62),('8902','2013-02-03','13:10:00',6.59),('8902','2013-02-03','13:15:00',6.55),('8902','2013-02-03','13:20:00',6.49),('8902','2013-02-03','13:25:00',6.43),('8902','2013-02-03','13:30:00',6.39),('8902','2013-02-03','13:35:00',6.37),('8902','2013-02-03','13:40:00',6.31),('8902','2013-02-03','13:45:00',6.26),('8902','2013-02-03','13:50:00',6.22),('8902','2013-02-03','13:55:00',6.19),('8902','2013-02-03','14:00:00',6.09),('8902','2013-02-03','14:05:00',6.02),('8902','2013-02-03','14:10:00',5.94),('8902','2013-02-03','14:15:00',5.83),('8902','2013-02-03','14:20:00',5.76),('8902','2013-02-03','14:25:00',5.66),('8902','2013-02-03','14:30:00',5.57),('8902','2013-02-03','14:35:00',5.44),('8902','2013-02-03','14:40:00',5.33),('8902','2013-02-03','14:45:00',5.25),('8902','2013-02-03','14:50:00',5.14),('8902','2013-02-03','14:55:00',4.98),('8902','2013-02-03','15:00:00',4.87),('8902','2013-02-03','15:05:00',4.74),('8902','2013-02-03','15:10:00',4.59),('8902','2013-02-03','15:15:00',4.43),('8902','2013-02-03','15:20:00',4.28),('8902','2013-02-03','15:25:00',4.12),('8902','2013-02-03','15:30:00',3.98),('8902','2013-02-03','15:35:00',3.82),('8902','2013-02-03','15:40:00',3.65),('8902','2013-02-03','15:45:00',3.48),('8902','2013-02-03','15:50:00',3.27),('8902','2013-02-03','15:55:00',3.1),('8902','2013-02-03','16:00:00',2.92),('8902','2013-02-03','16:05:00',2.75),('8902','2013-02-03','16:10:00',2.57),('8902','2013-02-03','16:15:00',2.36),('8902','2013-02-03','16:20:00',2.17),('8902','2013-02-03','16:25:00',1.96),('8902','2013-02-03','16:30:00',1.76),('8902','2013-02-03','16:35:00',1.52),('8902','2013-02-03','16:40:00',1.31),('8902','2013-02-03','16:45:00',1.11),('8902','2013-02-02','08:05:00',1),('8902','2013-02-02','08:40:00',1.08),('8902','2013-02-02','08:45:00',1.21),('8902','2013-02-02','08:50:00',1.18),('8902','2013-02-02','09:00:00',1.18),('8902','2013-02-02','09:05:00',1.2),('8902','2013-02-02','09:10:00',1.04),('8902','2013-02-02','09:15:00',1.44),('8902','2013-02-02','09:20:00',1.82),('8902','2013-02-02','09:25:00',2.29),('8902','2013-02-02','09:30:00',1.83),('8902','2013-02-02','09:35:00',1.53),('8902','2013-02-02','09:40:00',2.78),('8902','2013-02-02','09:45:00',3.25),('8902','2013-02-02','09:50:00',3.72),('8902','2013-02-02','09:55:00',3.08),('8902','2013-02-02','10:00:00',4.18),('8902','2013-02-02','10:05:00',2.13),('8902','2013-02-02','10:10:00',1.01),('8902','2013-02-02','10:20:00',1.84),('8902','2013-02-02','10:25:00',1.07),('8902','2013-02-02','10:30:00',1.09),('8902','2013-02-02','10:40:00',1.1),('8902','2013-02-02','11:15:00',1.16),('8902','2013-02-02','11:20:00',2.45),('8902','2013-02-02','11:25:00',1.43),('8902','2013-02-02','11:45:00',1.29),('8902','2013-02-02','11:50:00',1.74),('8902','2013-02-02','11:55:00',1.93),('8902','2013-02-02','12:00:00',2.16),('8902','2013-02-02','12:05:00',2.12),('8902','2013-02-02','12:10:00',1.96),('8902','2013-02-02','12:15:00',1.57),('8902','2013-02-02','12:20:00',1.27),('8902','2013-02-01','10:10:00',1.19),('8902','2013-02-01','10:15:00',1.73),('8902','2013-02-01','10:20:00',2.08),('8902','2013-02-01','10:25:00',1.86),('8902','2013-02-01','10:30:00',2.1),('8902','2013-02-01','10:35:00',2.44),('8902','2013-02-01','10:40:00',2.68),('8902','2013-02-01','10:45:00',2.98),('8902','2013-02-01','10:50:00',2.59),('8902','2013-02-01','10:55:00',3.24),('8902','2013-02-01','11:00:00',3.95),('8902','2013-02-01','11:05:00',3.49),('8902','2013-02-01','11:10:00',3.7),('8902','2013-02-01','11:15:00',3.82),('8902','2013-02-01','11:20:00',3.73),('8902','2013-02-01','11:25:00',4.34),('8902','2013-02-01','11:30:00',4.05),('8902','2013-02-01','11:35:00',3.35),('8902','2013-02-01','11:40:00',3.35),('8902','2013-02-01','11:45:00',2.18),('8902','2013-02-01','11:50:00',1.92),('8902','2013-02-01','11:55:00',2.16),('8902','2013-02-01','12:00:00',1.65),('8902','2013-02-01','12:05:00',1.11),('8902','2013-02-01','12:50:00',1.41),('8902','2013-02-01','12:55:00',4.49),('8902','2013-02-01','13:00:00',3.21),('8902','2013-02-01','13:05:00',3.51),('8902','2013-02-01','13:10:00',3.08),('8902','2013-02-01','13:15:00',4),('8902','2013-02-01','13:20:00',3.9),('8902','2013-02-01','13:25:00',3.12),('8902','2013-02-01','13:30:00',2.35),('8902','2013-02-01','13:35:00',4.2),('8902','2013-02-01','13:40:00',5.28),('8902','2013-02-01','13:45:00',4.09),('8902','2013-02-01','13:50:00',3.96),('8902','2013-02-01','13:55:00',2.33),('8902','2013-02-01','14:00:00',1.16),('8902','2013-01-31','08:20:00',1.2),('8902','2013-01-31','08:25:00',1.49),('8902','2013-01-31','08:30:00',1.4),('8902','2013-01-31','08:35:00',1.57),('8902','2013-01-31','08:40:00',1.78),('8902','2013-01-31','08:45:00',2.05),('8902','2013-01-31','08:55:00',1.61),('8902','2013-01-31','09:00:00',2.18),('8902','2013-01-31','09:05:00',2.85),('8902','2013-01-31','09:10:00',2.97),('8902','2013-01-31','09:15:00',1.46),('8902','2013-01-31','09:25:00',3.08),('8902','2013-01-31','09:30:00',1.43),('8902','2013-01-31','09:35:00',2.2),('8902','2013-01-31','09:40:00',2.62),('8902','2013-01-31','09:45:00',1.71),('8902','2013-01-31','09:50:00',1.73),('8902','2013-01-31','09:55:00',1.52),('8902','2013-01-31','10:00:00',2.18),('8902','2013-01-31','10:05:00',1.47),('8902','2013-01-31','10:10:00',1.71),('8902','2013-01-31','10:15:00',1.81),('8902','2013-01-31','10:20:00',3.88),('8902','2013-01-31','10:25:00',3.8),('8902','2013-01-31','10:30:00',3.94),('8902','2013-01-31','10:35:00',3.91),('8902','2013-01-31','10:40:00',1.87),('8902','2013-01-31','10:45:00',2.16),('8902','2013-01-31','10:50:00',4.92),('8902','2013-01-31','10:55:00',3.35),('8902','2013-01-31','11:00:00',5.93),('8902','2013-01-31','11:05:00',4.28),('8902','2013-01-31','11:10:00',6.26),('8902','2013-01-31','11:15:00',5.37),('8902','2013-01-31','11:20:00',6.47),('8902','2013-01-31','11:25:00',5.33),('8902','2013-01-31','11:30:00',3.13),('8902','2013-01-31','11:35:00',4.26),('8902','2013-01-31','11:40:00',7.77),('8902','2013-01-31','11:45:00',4.53),('8902','2013-01-31','11:50:00',3.4),('8902','2013-01-31','11:55:00',2.39),('8902','2013-01-31','12:00:00',2.64),('8902','2013-01-31','12:05:00',3.27),('8902','2013-01-31','12:10:00',3.73),('8902','2013-01-31','12:15:00',4.05),('8902','2013-01-31','12:20:00',7.32),('8902','2013-01-31','12:25:00',6.59),('8902','2013-01-31','12:30:00',3.31),('8902','2013-01-31','12:35:00',3.83),('8902','2013-01-31','12:40:00',5.28),('8902','2013-01-31','12:45:00',1.81),('8902','2013-01-31','12:50:00',5.52),('8902','2013-01-31','12:55:00',4.5),('8902','2013-01-31','13:00:00',6.95),('8902','2013-01-31','13:05:00',6.66),('8902','2013-01-31','13:10:00',5.99),('8902','2013-01-31','13:15:00',6.18),('8902','2013-01-31','13:20:00',6.42),('8902','2013-01-31','13:25:00',3.72),('8902','2013-01-31','13:30:00',5.37),('8902','2013-01-31','13:35:00',4.17),('8902','2013-01-31','13:40:00',2.69),('8902','2013-01-31','13:45:00',5.03),('8902','2013-01-31','13:50:00',4.81),('8902','2013-01-31','13:55:00',2.18),('8902','2013-01-31','14:00:00',1.59),('8902','2013-01-31','14:05:00',1.57),('8902','2013-01-31','14:10:00',2.11),('8902','2013-01-31','14:15:00',4.71),('8902','2013-01-31','14:20:00',6),('8902','2013-01-31','14:25:00',5.37),('8902','2013-01-31','14:30:00',5.31),('8902','2013-01-31','14:35:00',5.19),('8902','2013-01-31','14:40:00',4.57),('8902','2013-01-31','14:45:00',2.77),('8902','2013-01-31','14:50:00',1.82),('8902','2013-01-31','14:55:00',2.61),('8902','2013-01-31','15:00:00',3.42),('8902','2013-01-31','15:05:00',4.94),('8902','2013-01-31','15:10:00',2.92),('8902','2013-01-31','15:15:00',3.57),('8902','2013-01-31','15:20:00',4.05),('8902','2013-01-31','15:25:00',3.7),('8902','2013-01-31','15:30:00',1.25),('8902','2013-01-31','15:35:00',3.02),('8902','2013-01-31','15:40:00',2.84),('8902','2013-01-31','15:45:00',2.63),('8902','2013-01-31','15:50:00',1.47),('8902','2013-01-31','15:55:00',2.75),('8902','2013-01-31','16:00:00',1.35),('8902','2014-03-20','07:20:00',1.11),('8902','2014-03-20','07:25:00',1.19),('8902','2014-03-20','07:30:00',1.15),('8902','2014-03-20','07:35:00',1.4),('8902','2014-03-20','07:40:00',1.58),('8902','2014-03-20','07:45:00',1.79),('8902','2014-03-20','07:50:00',1.99),('8902','2014-03-20','07:55:00',2.19),('8902','2014-03-20','08:00:00',2.35),('8902','2014-03-20','08:05:00',2.48),('8902','2014-03-20','08:10:00',2.64),('8902','2014-03-20','08:15:00',2.84),('8902','2014-03-20','08:20:00',2.97),('8902','2014-03-20','08:25:00',3.17),('8902','2014-03-20','08:30:00',3.38),('8902','2014-03-20','08:35:00',3.54),('8902','2014-03-20','08:40:00',3.73),('8902','2014-03-20','08:45:00',3.85),('8902','2014-03-20','08:50:00',4.06),('8902','2014-03-20','08:55:00',4.26),('8902','2014-03-20','09:00:00',4.42),('8902','2014-03-20','09:05:00',4.52),('8902','2014-03-20','09:10:00',4.73),('8902','2014-03-20','09:15:00',4.89),('8902','2014-03-20','09:20:00',5.09),('8902','2014-03-20','09:25:00',4.93),('8902','2014-03-20','09:30:00',5.25),('8902','2014-03-20','09:35:00',5.36),('8902','2014-03-20','09:40:00',5.49),('8902','2014-03-20','09:45:00',5.61),('8902','2014-03-20','09:50:00',5.75),('8902','2014-03-20','09:55:00',5.87),('8902','2014-03-20','10:00:00',5.88),('8902','2014-03-20','10:05:00',5.95),('8902','2014-03-20','10:10:00',6.07),('8902','2014-03-20','10:15:00',6.21),('8902','2014-03-20','10:20:00',6.25),('8902','2014-03-20','10:25:00',6.37),('8902','2014-03-20','10:30:00',6.58),('8902','2014-03-20','10:35:00',6.55),('8902','2014-03-20','10:40:00',6.72),('8902','2014-03-20','10:45:00',6.67),('8902','2014-03-20','10:50:00',6.65),('8902','2014-03-20','10:55:00',6.78),('8902','2014-03-20','11:00:00',6.91),('8902','2014-03-20','11:05:00',6.81),('8902','2014-03-20','11:10:00',6.75),('8902','2014-03-20','11:15:00',6.71),('8902','2014-03-20','11:20:00',6.67),('8902','2014-03-20','11:25:00',6.17),('8902','2014-03-20','11:30:00',3.98),('8902','2014-03-20','11:35:00',4.89),('8902','2014-03-20','11:40:00',3.54),('8902','2014-03-20','11:45:00',2.65),('8902','2014-03-20','11:50:00',6.02),('8902','2014-03-20','11:55:00',7.9),('8902','2014-03-20','12:00:00',5.33),('8902','2014-03-20','12:05:00',7.32),('8902','2014-03-20','12:10:00',7.47),('8902','2014-03-20','12:15:00',7.83),('8902','2014-03-20','12:20:00',7.73),('8902','2014-03-20','12:25:00',7.5),('8902','2014-03-20','12:30:00',7.39),('8902','2014-03-20','12:35:00',7.41),('8902','2014-03-20','12:40:00',7.49),('8902','2014-03-20','12:45:00',7.52),('8902','2014-03-20','12:50:00',7.46),('8902','2014-03-20','12:55:00',7.5),('8902','2014-03-20','13:00:00',7.44),('8902','2014-03-20','13:05:00',7.49),('8902','2014-03-20','13:10:00',7.44),('8902','2014-03-20','13:15:00',7.48),('8902','2014-03-20','13:20:00',7.45),('8902','2014-03-20','13:25:00',7.4),('8902','2014-03-20','13:30:00',7.34),('8902','2014-03-20','13:35:00',7.25),('8902','2014-03-20','13:40:00',7.25),('8902','2014-03-20','13:45:00',7.2),('8902','2014-03-20','13:50:00',7.19),('8902','2014-03-20','13:55:00',7.11),('8902','2014-03-20','14:00:00',7.1),('8902','2014-03-20','14:05:00',7.03),('8902','2014-03-20','14:10:00',6.97),('8902','2014-03-20','14:15:00',6.92),('8902','2014-03-20','14:20:00',6.81),('8902','2014-03-20','14:25:00',6.72),('8902','2014-03-20','14:30:00',6.52),('8902','2014-03-20','14:35:00',6.19),('8902','2014-03-20','14:40:00',6.25),('8902','2014-03-20','14:45:00',6.12),('8902','2014-03-20','14:50:00',4.94),('8902','2014-03-20','14:55:00',2.93),('8902','2014-03-20','15:00:00',1.43),('8902','2014-03-20','15:05:00',3.35),('8902','2014-03-20','15:10:00',6.34),('8902','2014-03-20','15:15:00',6.63),('8902','2014-03-20','15:20:00',6.24),('8902','2014-03-20','15:25:00',6.04),('8902','2014-03-20','15:30:00',6.1),('8902','2014-03-20','15:35:00',5.73),('8902','2014-03-20','15:40:00',5.73),('8902','2014-03-20','15:45:00',5.55),('8902','2014-03-20','15:50:00',5.35),('8902','2014-03-20','15:55:00',5.02),('8902','2014-03-20','16:00:00',4.87),('8902','2014-03-20','16:05:00',4.44),('8902','2014-03-20','16:10:00',4.23),('8902','2014-03-20','16:15:00',3.88),('8902','2014-03-20','16:20:00',3.62),('8902','2014-03-20','16:25:00',3.38),('8902','2014-03-20','16:30:00',3.11),('8902','2014-03-20','16:35:00',2.91),('8902','2014-03-20','16:40:00',2.74),('8902','2014-03-20','16:45:00',2.59),('8902','2014-03-20','16:50:00',2.41),('8902','2014-03-20','16:55:00',2.15),('8902','2014-03-20','17:00:00',1.8),('8902','2014-03-20','17:05:00',1.67),('8902','2014-03-20','17:10:00',1.45),('8902','2014-03-20','17:15:00',1.22),('8902','2014-03-20','17:20:00',1.05),('8902','2013-01-30','09:00:00',1.04),('8902','2013-01-30','09:05:00',1.65),('8902','2013-01-30','09:10:00',1.91),('8902','2013-01-30','09:15:00',1.05),('8902','2013-01-30','09:20:00',1.82),('8902','2013-01-30','09:25:00',3.21),('8902','2013-01-30','09:30:00',3.98),('8902','2013-01-30','09:35:00',3.65),('8902','2013-01-30','09:40:00',3.8),('8902','2013-01-30','09:45:00',3.73),('8902','2013-01-30','09:50:00',3.76),('8902','2013-01-30','09:55:00',4.31),('8902','2013-01-30','10:00:00',4.32),('8902','2013-01-30','10:05:00',4.4),('8902','2013-01-30','10:10:00',4.5),('8902','2013-01-30','10:15:00',4.68),('8902','2013-01-30','10:20:00',4.77),('8902','2013-01-30','10:25:00',4.92),('8902','2013-01-30','10:30:00',5.25),('8902','2013-01-30','10:35:00',3.44),('8902','2013-01-30','10:40:00',1.06),('8902','2013-01-30','10:45:00',2.59),('8902','2013-01-30','10:50:00',5.58),('8902','2013-01-30','10:55:00',5.5),('8902','2013-01-30','11:00:00',4.86),('8902','2013-01-30','11:05:00',5.69),('8902','2013-01-30','11:10:00',6.12),('8902','2013-01-30','11:15:00',6.14),('8902','2013-01-30','11:20:00',6.33),('8902','2013-01-30','11:25:00',6.08),('8902','2013-01-30','11:30:00',5.94),('8902','2013-01-30','11:35:00',4.65),('8902','2013-01-30','11:40:00',6.08),('8902','2013-01-30','11:45:00',6.06),('8902','2013-01-30','11:50:00',6.02),('8902','2013-01-30','11:55:00',5.98),('8902','2013-01-30','12:00:00',6.01),('8902','2013-01-30','12:05:00',6.08),('8902','2013-01-30','12:10:00',6.13),('8902','2013-01-30','12:15:00',6.09),('8902','2013-01-30','12:20:00',6.03),('8902','2013-01-30','12:25:00',6.07),('8902','2013-01-30','12:30:00',6.15),('8902','2013-01-30','12:35:00',6.15),('8902','2013-01-30','12:40:00',6.08),('8902','2013-01-30','12:45:00',6.09),('8902','2013-01-30','12:50:00',6.06),('8902','2013-01-30','12:55:00',6.01),('8902','2013-01-30','13:00:00',5.98),('8902','2013-01-30','13:05:00',5.98),('8902','2013-01-30','13:10:00',5.74),('8902','2013-01-30','13:15:00',5.86),('8902','2013-01-30','13:20:00',5.74),('8902','2013-01-30','13:25:00',5.71),('8902','2013-01-30','13:30:00',5.71),('8902','2013-01-30','13:35:00',5.58),('8902','2013-01-30','13:40:00',5.49),('8902','2013-01-30','13:45:00',5.47),('8902','2013-01-30','13:50:00',5.74),('8902','2013-01-30','13:55:00',5.58),('8902','2013-01-30','14:00:00',5.51),('8902','2013-01-30','14:05:00',5.29),('8902','2013-01-30','14:10:00',5.09),('8902','2013-01-30','14:15:00',4.96),('8902','2013-01-30','14:20:00',4.96),('8902','2013-01-30','14:25:00',4.92),('8902','2013-01-30','14:30:00',4.79),('8902','2013-01-30','14:35:00',4.75),('8902','2013-01-30','14:40:00',4.62),('8902','2013-01-30','14:45:00',4.51),('8902','2013-01-30','14:50:00',4.3),('8902','2013-01-30','14:55:00',4.07),('8902','2013-01-30','15:00:00',4.01),('8902','2013-01-30','15:05:00',4.01),('8902','2013-01-30','15:10:00',3.87),('8902','2013-01-30','15:15:00',3.85),('8902','2013-01-30','15:20:00',3.67),('8902','2013-01-30','15:25:00',3.49),('8902','2013-01-30','15:30:00',3.36),('8902','2013-01-30','15:35:00',3.29),('8902','2013-01-30','15:40:00',3.14),('8902','2013-01-30','15:45:00',2.85),('8902','2013-01-30','15:50:00',2.61),('8902','2013-01-30','15:55:00',2.48),('8902','2013-01-30','16:00:00',2.14),('8902','2013-01-30','16:05:00',1.72),('8902','2013-01-30','16:10:00',1.94),('8902','2013-01-30','16:15:00',1.73),('8902','2013-01-30','16:20:00',1.57),('8902','2013-01-30','16:25:00',1.3),('8902','2013-01-30','16:30:00',1.36),('8902','2013-01-30','16:35:00',1.15),('8902','2013-01-29','09:10:00',1),('8902','2013-01-29','09:15:00',1.44),('8902','2013-01-29','09:25:00',1.07),('8902','2013-01-29','09:30:00',1.41),('8902','2013-01-29','09:35:00',1.57),('8902','2013-01-29','09:40:00',1.39),('8902','2013-01-29','09:45:00',1.12),('8902','2013-01-29','10:00:00',1.62),('8902','2013-01-29','10:05:00',1.56),('8902','2013-01-29','10:10:00',3.04),('8902','2013-01-29','10:15:00',2.29),('8902','2013-01-29','10:20:00',3.46),('8902','2013-01-29','10:25:00',3.39),('8902','2013-01-29','10:30:00',2.93),('8902','2013-01-29','10:35:00',2.69),('8902','2013-01-29','10:40:00',2.53),('8902','2013-01-29','10:45:00',2.86),('8902','2013-01-29','10:50:00',5.38),('8902','2013-01-29','10:55:00',3.77),('8902','2013-01-29','11:00:00',5.47),('8902','2013-01-29','11:05:00',5.32),('8902','2013-01-29','11:10:00',5.29),('8902','2013-01-29','11:15:00',5.52),('8902','2013-01-29','11:20:00',5.58),('8902','2013-01-29','11:25:00',5.69),('8902','2013-01-29','11:30:00',5.7),('8902','2013-01-29','11:35:00',5.75),('8902','2013-01-29','11:40:00',5.46),('8902','2013-01-29','11:45:00',5.49),('8902','2013-01-29','11:50:00',5.44),('8902','2013-01-29','11:55:00',5.15),('8902','2013-01-29','12:00:00',3.18),('8902','2013-01-29','12:05:00',5.52),('8902','2013-01-29','12:10:00',5.21),('8902','2013-01-29','12:15:00',6.74),('8902','2013-01-29','12:20:00',3.36),('8902','2013-01-29','12:25:00',1.96),('8902','2013-01-29','12:30:00',1.56),('8902','2013-01-29','12:35:00',1.76),('8902','2013-01-29','12:40:00',3.71),('8902','2013-01-29','12:45:00',1.82),('8902','2013-01-29','12:50:00',6.25),('8902','2013-01-29','12:55:00',6.97),('8902','2013-01-29','13:00:00',6.56),('8902','2013-01-29','13:05:00',6.85),('8902','2013-01-29','13:10:00',5.68),('8902','2013-01-29','13:15:00',6.24),('8902','2013-01-29','13:20:00',6.57),('8902','2013-01-29','13:25:00',6.45),('8902','2013-01-29','13:30:00',6.09),('8902','2013-01-29','13:35:00',4.71),('8902','2013-01-29','13:40:00',4.8),('8902','2013-01-29','13:45:00',5.64),('8902','2013-01-29','13:50:00',6.03),('8902','2013-01-29','13:55:00',4.5),('8902','2013-01-29','14:00:00',5.15),('8902','2013-01-29','14:05:00',4.79),('8902','2013-01-29','14:10:00',4.72),('8902','2013-01-29','14:15:00',2.07),('8902','2013-01-29','14:20:00',2.04),('8902','2013-01-29','14:25:00',4),('8902','2013-01-29','14:30:00',3.41),('8902','2013-01-29','14:35:00',4.55),('8902','2013-01-29','14:40:00',4.96),('8902','2013-01-29','14:45:00',3.91),('8902','2013-01-29','14:50:00',2.06),('8902','2013-01-29','14:55:00',1.86),('8902','2013-01-29','15:00:00',2.98),('8902','2013-01-29','15:05:00',3),('8902','2013-01-29','15:10:00',1.84),('8902','2013-01-29','15:15:00',1.55),('8902','2013-01-29','15:20:00',1.35),('8902','2013-01-29','15:25:00',1.17),('8902','2013-01-29','15:30:00',1.16),('8902','2013-01-29','15:35:00',1.02),('8902','2013-01-28','08:25:00',1.17),('8902','2013-01-28','08:30:00',1.34),('8902','2013-01-28','08:35:00',1.61),('8902','2013-01-28','08:40:00',1.82),('8902','2013-01-28','08:45:00',2),('8902','2013-01-28','08:50:00',2.17),('8902','2013-01-28','08:55:00',2.37),('8902','2013-01-28','09:00:00',2.57),('8902','2013-01-28','09:05:00',2.75),('8902','2013-01-28','09:10:00',2.91),('8902','2013-01-28','09:15:00',3.05),('8902','2013-01-28','09:20:00',3.21),('8902','2013-01-28','09:25:00',3.35),('8902','2013-01-28','09:30:00',3.51),('8902','2013-01-28','09:35:00',3.64),('8902','2013-01-28','09:45:00',3.97),('8902','2013-01-28','09:50:00',4.12),('8902','2013-01-28','09:55:00',4.23),('8902','2013-01-28','10:00:00',4.38),('8902','2013-01-28','10:05:00',4.54),('8902','2013-01-28','10:10:00',4.68),('8902','2013-01-28','10:15:00',4.8),('8902','2013-01-28','10:20:00',4.95),('8902','2013-01-28','10:25:00',5.08),('8902','2013-01-28','10:30:00',5.18),('8902','2013-01-28','10:35:00',5.27),('8902','2013-01-28','10:40:00',5.37),('8902','2013-01-28','10:45:00',5.45),('8902','2013-01-28','10:50:00',5.55),('8902','2013-01-28','10:55:00',5.59),('8902','2013-01-28','11:00:00',5.62),('8902','2013-01-28','11:05:00',5.65),('8902','2013-01-28','11:10:00',5.69),('8902','2013-01-28','11:15:00',5.8),('8902','2013-01-28','11:20:00',5.86),('8902','2013-01-28','11:25:00',5.84),('8902','2013-01-28','11:30:00',5.81),('8902','2013-01-28','11:35:00',6.05),('8902','2013-01-28','11:40:00',6.17),('8902','2013-01-28','11:45:00',6.16),('8902','2013-01-28','11:50:00',6.18),('8902','2013-01-28','11:55:00',6.15),('8902','2013-01-28','12:00:00',6.14),('8902','2013-01-28','12:05:00',6.19),('8902','2013-01-28','12:10:00',6.3),('8902','2013-01-28','12:15:00',6.22),('8902','2013-01-28','12:20:00',6.2),('8902','2013-01-28','12:25:00',6.31),('8902','2013-01-28','12:30:00',6.22),('8902','2013-01-28','12:35:00',6.13),('8902','2013-01-28','12:40:00',6.19),('8902','2013-01-28','12:45:00',6.12),('8902','2013-01-28','12:50:00',6.1),('8902','2013-01-28','12:55:00',6.23),('8902','2013-01-28','13:00:00',6.15),('8902','2013-01-28','13:05:00',6.05),('8902','2013-01-28','13:10:00',6.07),('8902','2013-01-28','13:15:00',6.02),('8902','2013-01-28','13:20:00',6),('8902','2013-01-28','13:25:00',6.03),('8902','2013-01-28','13:30:00',5.94),('8902','2013-01-28','13:35:00',5.88),('8902','2013-01-28','13:40:00',5.81),('8902','2013-01-28','13:45:00',5.74),('8902','2013-01-28','13:50:00',5.63),('8902','2013-01-28','13:55:00',5.54),('8902','2013-01-28','14:00:00',5.48),('8902','2013-01-28','14:05:00',5.32),('8902','2013-01-28','14:10:00',5.15),('8902','2013-01-28','14:15:00',5.28),('8902','2013-01-28','14:20:00',5.29),('8902','2013-01-28','14:25:00',5.19),('8902','2013-01-28','14:30:00',5.05),('8902','2013-01-28','14:35:00',4.91),('8902','2013-01-28','14:40:00',4.82),('8902','2013-01-28','14:45:00',4.75),('8902','2013-01-28','14:50:00',4.63),('8902','2013-01-28','14:55:00',4.48),('8902','2013-01-28','15:00:00',4.31),('8902','2013-01-28','15:05:00',4.19),('8902','2013-01-28','15:10:00',4.03),('8902','2013-01-28','15:15:00',3.87),('8902','2013-01-28','15:20:00',3.7),('8902','2013-01-28','15:25:00',3.51),('8902','2013-01-28','15:30:00',3.34),('8902','2013-01-28','15:35:00',3.21),('8902','2013-01-28','15:40:00',3.07),('8902','2013-01-28','15:45:00',2.93),('8902','2013-01-28','15:50:00',2.66),('8902','2013-01-28','15:55:00',2.57),('8902','2013-01-28','16:00:00',2.46),('8902','2013-01-28','16:05:00',2.3),('8902','2013-01-28','16:10:00',2.19),('8902','2013-01-28','16:15:00',2.05),('8902','2013-01-28','16:20:00',1.87),('8902','2013-01-28','16:25:00',1.67),('8902','2013-01-28','16:30:00',1.49),('8902','2013-01-28','16:35:00',1.3),('8902','2013-01-28','16:40:00',1.09),('8902','2013-01-27','10:50:00',1.04),('8902','2013-01-27','10:55:00',1.17),('8902','2013-01-27','11:00:00',1.37),('8902','2013-01-27','11:05:00',1.54),('8902','2013-01-27','11:10:00',1.61),('8902','2013-01-27','11:15:00',1.37),('8902','2013-01-27','11:20:00',1.35),('8902','2013-01-27','11:25:00',1.29),('8902','2013-01-27','11:30:00',1.19),('8902','2013-01-27','11:35:00',1.12),('8902','2013-01-27','11:40:00',1.07),('8902','2013-01-27','11:45:00',1.06),('8902','2013-01-27','11:50:00',1.03),('8902','2013-01-27','12:25:00',1.01),('8902','2013-01-27','12:30:00',1.08),('8902','2013-01-27','12:35:00',1.25),('8902','2013-01-27','12:40:00',1.52),('8902','2013-01-27','12:45:00',1.93),('8902','2013-01-27','12:50:00',2.36),('8902','2013-01-27','12:55:00',2.24),('8902','2013-01-27','13:00:00',2.07),('8902','2013-01-27','13:05:00',2),('8902','2013-01-27','13:10:00',1.84),('8902','2013-01-27','13:15:00',1.75),('8902','2013-01-27','13:20:00',1.78),('8902','2013-01-27','13:25:00',1.81),('8902','2013-01-27','13:30:00',1.76),('8902','2013-01-27','13:35:00',1.6),('8902','2013-01-27','13:40:00',1.42),('8902','2013-01-27','13:45:00',1.31),('8902','2013-01-27','13:50:00',1.21),('8902','2013-01-27','13:55:00',1.18),('8902','2013-01-27','14:00:00',1.25),('8902','2013-01-27','14:05:00',1.32),('8902','2013-01-27','14:10:00',1.28),('8902','2013-01-27','14:15:00',1.18),('8902','2013-01-27','14:20:00',1.08),('8902','2013-01-26','08:25:00',1.15),('8902','2013-01-26','08:30:00',1.55),('8902','2013-01-26','08:35:00',1.86),('8902','2013-01-26','08:40:00',2.09),('8902','2013-01-26','08:45:00',2.17),('8902','2013-01-26','08:50:00',2.19),('8902','2013-01-26','08:55:00',2.32),('8902','2013-01-26','09:00:00',2.48),('8902','2013-01-26','09:05:00',2.64),('8902','2013-01-26','09:10:00',2.79),('8902','2013-01-26','09:15:00',2.96),('8902','2013-01-26','09:20:00',3.13),('8902','2013-01-26','09:25:00',3.3),('8902','2013-01-26','09:30:00',3.45),('8902','2013-01-26','09:35:00',3.6),('8902','2013-01-26','09:40:00',3.75),('8902','2013-01-26','09:45:00',3.9),('8902','2013-01-26','09:50:00',4.05),('8902','2013-01-26','09:55:00',4.19),('8902','2013-01-26','10:00:00',4.31),('8902','2013-01-26','10:05:00',4.43),('8902','2013-01-26','10:10:00',4.54),('8902','2013-01-26','10:15:00',4.68),('8902','2013-01-26','10:20:00',4.78),('8902','2013-01-26','10:25:00',4.88),('8902','2013-01-26','10:30:00',4.98),('8902','2013-01-26','10:35:00',5.09),('8902','2013-01-26','10:40:00',5.15),('8902','2013-01-26','10:45:00',5.24),('8902','2013-01-26','10:50:00',5.32),('8902','2013-01-26','10:55:00',5.44),('8902','2013-01-26','11:00:00',5.51),('8902','2013-01-26','11:05:00',5.58),('8902','2013-01-26','11:10:00',5.62),('8902','2013-01-26','11:15:00',5.68),('8902','2013-01-26','11:20:00',5.76),('8902','2013-01-26','11:25:00',5.8),('8902','2013-01-26','11:30:00',5.81),('8902','2013-01-26','11:35:00',5.88),('8902','2013-01-26','11:40:00',5.94),('8902','2013-01-26','11:45:00',5.99),('8902','2013-01-26','11:50:00',6.02),('8902','2013-01-26','11:55:00',6.02),('8902','2013-01-26','12:00:00',6.1),('8902','2013-01-26','12:05:00',6.11),('8902','2013-01-26','12:10:00',6.1),('8902','2013-01-26','12:15:00',6.17),('8902','2013-01-26','12:20:00',6.24),('8902','2013-01-26','12:25:00',6.15),('8902','2013-01-26','12:30:00',6.17),('8902','2013-01-26','12:35:00',6.11),('8902','2013-01-26','12:40:00',6.12),('8902','2013-01-26','12:45:00',6.15),('8902','2013-01-26','12:50:00',6.2),('8902','2013-01-26','12:55:00',6.15),('8902','2013-01-26','13:00:00',6.17),('8902','2013-01-26','13:05:00',6.22),('8902','2013-01-26','13:10:00',6.12),('8902','2013-01-26','13:15:00',6.03),('8902','2013-01-26','13:20:00',5.86),('8902','2013-01-26','13:25:00',5.87),('8902','2013-01-26','13:30:00',5.71),('8902','2013-01-26','13:35:00',5.69),('8902','2013-01-26','13:40:00',5.59),('8902','2013-01-26','13:45:00',5.52),('8902','2013-01-26','13:50:00',5.47),('8902','2013-01-26','13:55:00',5.41),('8902','2013-01-26','14:00:00',5.33),('8902','2013-01-26','14:05:00',5.23),('8902','2013-01-26','14:10:00',5.1),('8902','2013-01-26','14:15:00',5.02),('8902','2013-01-26','14:20:00',4.97),('8902','2013-01-26','14:25:00',4.84),('8902','2013-01-26','14:30:00',4.72),('8902','2013-01-26','14:35:00',4.55),('8902','2013-01-26','14:40:00',4.45),('8902','2013-01-26','14:45:00',4.39),('8902','2013-01-26','14:50:00',4.37),('8902','2013-01-26','14:55:00',4.3),('8902','2013-01-26','15:00:00',4.13),('8902','2013-01-26','15:05:00',3.98),('8902','2013-01-26','15:10:00',3.78),('8902','2013-01-26','15:15:00',3.63),('8902','2013-01-26','15:20:00',3.43),('8902','2013-01-26','15:25:00',3.3),('8902','2013-01-26','15:30:00',3.16),('8902','2013-01-26','15:35:00',2.98),('8902','2013-01-26','15:40:00',2.83),('8902','2013-01-26','15:45:00',2.67),('8902','2013-01-26','15:50:00',2.56),('8902','2013-01-26','15:55:00',2.39),('8902','2013-01-26','16:00:00',2.23),('8902','2013-01-26','16:05:00',2.14),('8902','2013-01-26','16:10:00',1.91),('8902','2013-01-26','16:15:00',1.65),('8902','2013-01-26','16:20:00',1.43),('8902','2013-01-26','16:25:00',1.25),('8902','2013-01-26','16:30:00',1.09),('8902','2013-01-25','08:50:00',1.03),('8902','2013-01-25','08:55:00',1.42),('8902','2013-01-25','09:00:00',2.16),('8902','2013-01-25','09:05:00',2.33),('8902','2013-01-25','09:10:00',2.13),('8902','2013-01-25','09:15:00',1.91),('8902','2013-01-25','09:20:00',2.14),('8902','2013-01-25','09:25:00',1.75),('8902','2013-01-25','09:30:00',1.43),('8902','2013-01-25','09:35:00',1.67),('8902','2013-01-25','09:40:00',1.31),('8902','2013-01-25','09:45:00',1.34),('8902','2013-01-25','09:50:00',2.01),('8902','2013-01-25','09:55:00',2.5),('8902','2013-01-25','10:00:00',1.8),('8902','2013-01-25','10:05:00',1.91),('8902','2013-01-25','10:10:00',1.66),('8902','2013-01-25','10:15:00',1.81),('8902','2013-01-25','10:20:00',2.47),('8902','2013-01-25','10:25:00',2.63),('8902','2013-01-25','10:30:00',1.6),('8902','2013-01-25','10:35:00',1.45),('8902','2013-01-25','10:40:00',1.67),('8902','2013-01-25','10:45:00',1.72),('8902','2013-01-25','10:50:00',2.09),('8902','2013-01-25','10:55:00',2.09),('8902','2013-01-25','11:00:00',1.67),('8902','2013-01-25','11:05:00',1.95),('8902','2013-01-25','11:10:00',1.76),('8902','2013-01-25','11:15:00',1.68),('8902','2013-01-25','11:20:00',1.6),('8902','2013-01-25','11:25:00',1.82),('8902','2013-01-25','11:30:00',1.8),('8902','2013-01-25','11:35:00',1.75),('8902','2013-01-25','11:40:00',1.74),('8902','2013-01-25','11:45:00',1.59),('8902','2013-01-25','11:50:00',1.63),('8902','2013-01-25','11:55:00',1.69),('8902','2013-01-25','12:00:00',1.45),('8902','2013-01-25','12:05:00',1.37),('8902','2013-01-25','12:10:00',1.36),('8902','2013-01-25','12:15:00',1.38),('8902','2013-01-25','12:20:00',1.39),('8902','2013-01-25','12:25:00',1.82),('8902','2013-01-25','12:30:00',1.76),('8902','2013-01-25','12:35:00',1.72),('8902','2013-01-25','12:40:00',1.6),('8902','2013-01-25','12:45:00',1.54),('8902','2013-01-25','12:50:00',1.66),('8902','2013-01-25','12:55:00',1.2),('8902','2013-01-25','13:05:00',1.18),('8902','2013-01-25','13:10:00',1.14),('8902','2013-01-25','13:35:00',1.2),('8902','2013-01-25','13:40:00',1.28),('8902','2013-01-25','13:45:00',1.21),('8902','2013-01-25','13:50:00',1.09),('8902','2013-01-25','13:55:00',1.07),('8902','2013-01-25','14:25:00',1.05),('8902','2013-01-25','14:30:00',1.06),('8902','2013-01-24','08:25:00',1.12),('8902','2013-01-24','08:30:00',1.23),('8902','2013-01-24','08:35:00',1.5),('8902','2013-01-24','08:40:00',1.89),('8902','2013-01-24','08:45:00',2.15),('8902','2013-01-24','08:50:00',2.21),('8902','2013-01-24','08:55:00',2.31),('8902','2013-01-24','09:00:00',2.77),('8902','2013-01-24','09:05:00',2.39),('8902','2013-01-24','09:10:00',2.49),('8902','2013-01-24','09:15:00',3.09),('8902','2013-01-24','09:20:00',3.39),('8902','2013-01-24','09:25:00',3.65),('8902','2013-01-24','09:30:00',3.88),('8902','2013-01-24','09:35:00',3.74),('8902','2013-01-24','09:40:00',3.68),('8902','2013-01-24','09:45:00',3.72),('8902','2013-01-24','09:50:00',4.6),('8902','2013-01-24','09:55:00',4.75),('8902','2013-01-24','10:00:00',4.84),('8902','2013-01-24','10:05:00',4.93),('8902','2013-01-24','10:10:00',4.98),('8902','2013-01-24','10:15:00',5.04),('8902','2013-01-24','10:20:00',5.13),('8902','2013-01-24','10:25:00',5.15),('8902','2013-01-24','10:30:00',5.1),('8902','2013-01-24','10:35:00',3.25),('8902','2013-01-24','10:40:00',4.32),('8902','2013-01-24','10:45:00',5.33),('8902','2013-01-24','10:50:00',4.23),('8902','2013-01-24','10:55:00',5.75),('8902','2013-01-24','11:00:00',3.72),('8902','2013-01-24','11:05:00',4.64),('8902','2013-01-24','11:10:00',5.47),('8902','2013-01-24','11:15:00',6.02),('8902','2013-01-24','11:20:00',5.98),('8902','2013-01-24','11:25:00',6),('8902','2013-01-24','11:30:00',6.03),('8902','2013-01-24','11:35:00',6.16),('8902','2013-01-24','11:40:00',6.16),('8902','2013-01-24','11:45:00',6.22),('8902','2013-01-24','11:50:00',6.3),('8902','2013-01-24','11:55:00',6.3),('8902','2013-01-24','12:00:00',6.25),('8902','2013-01-24','12:05:00',6.28),('8902','2013-01-24','12:10:00',6.39),('8902','2013-01-24','12:15:00',6.44),('8902','2013-01-24','12:20:00',6.49),('8902','2013-01-24','12:25:00',6.51),('8902','2013-01-24','12:30:00',6.48),('8902','2013-01-24','12:35:00',5.59),('8902','2013-01-24','12:40:00',5.74),('8902','2013-01-24','12:45:00',6.22),('8902','2013-01-24','12:50:00',6.32),('8902','2013-01-24','12:55:00',6.13),('8902','2013-01-24','13:00:00',6.23),('8902','2013-01-24','13:05:00',6.18),('8902','2013-01-24','13:10:00',6.07),('8902','2013-01-24','13:15:00',6.09),('8902','2013-01-24','13:20:00',6.07),('8902','2013-01-24','13:25:00',6.15),('8902','2013-01-24','13:30:00',6.3),('8902','2013-01-24','13:35:00',6.22),('8902','2013-01-24','13:40:00',6.1),('8902','2013-01-24','13:45:00',5.99),('8902','2013-01-24','13:50:00',5.8),('8902','2013-01-24','13:55:00',5.69),('8902','2013-01-24','14:00:00',5.49),('8902','2013-01-24','14:05:00',5.35),('8902','2013-01-24','14:10:00',4.88),('8902','2013-01-24','14:15:00',4.78),('8902','2013-01-24','14:20:00',4.28),('8902','2013-01-24','14:25:00',4.46),('8902','2013-01-24','14:30:00',4.16),('8902','2013-01-24','14:35:00',3.94),('8902','2013-01-24','14:40:00',3.84),('8902','2013-01-24','14:45:00',3.73),('8902','2013-01-24','14:50:00',3.81),('8902','2013-01-24','14:55:00',3.66),('8902','2013-01-24','15:00:00',3.34),('8902','2013-01-24','15:05:00',3.17),('8902','2013-01-24','15:10:00',3.18),('8902','2013-01-24','15:15:00',3.08),('8902','2013-01-24','15:20:00',2.97),('8902','2013-01-24','15:25:00',3),('8902','2013-01-24','15:30:00',2.99),('8902','2013-01-24','15:35:00',3.11),('8902','2013-01-24','15:40:00',2.95),('8902','2013-01-24','15:45:00',2.53),('8902','2013-01-24','15:50:00',2.83),('8902','2013-01-24','15:55:00',2.55),('8902','2013-01-24','16:00:00',1.77),('8902','2013-01-24','16:05:00',1.07),('8902','2013-01-24','16:15:00',1.26),('8902','2013-01-24','16:20:00',1.22),('8902','2013-01-23','08:50:00',1.13),('8902','2013-01-23','08:55:00',1.3),('8902','2013-01-23','09:00:00',1.59),('8902','2013-01-23','09:05:00',1.11),('8902','2013-01-23','09:10:00',1.08),('8902','2013-01-23','09:15:00',1.19),('8902','2013-01-23','09:20:00',1.54),('8902','2013-01-23','09:25:00',1.72),('8902','2013-01-23','09:30:00',1.63),('8902','2013-01-23','09:35:00',1.39),('8902','2013-01-23','09:40:00',1.45),('8902','2013-01-23','09:45:00',2.6),('8902','2013-01-23','09:50:00',1.73),('8902','2013-01-23','09:55:00',3.12),('8902','2013-01-23','10:00:00',4.4),('8902','2013-01-23','10:05:00',4.57),('8902','2013-01-23','10:10:00',5.03),('8902','2013-01-23','10:15:00',4.84),('8902','2013-01-23','10:20:00',5.13),('8902','2013-01-23','10:25:00',5.15),('8902','2013-01-23','10:30:00',5.22),('8902','2013-01-23','10:35:00',5.3),('8902','2013-01-23','10:40:00',5.42),('8902','2013-01-23','10:45:00',5.56),('8902','2013-01-23','10:50:00',5.54),('8902','2013-01-23','10:55:00',4.39),('8902','2013-01-23','11:00:00',2.88),('8902','2013-01-23','11:05:00',1.94),('8902','2013-01-23','11:10:00',1.23),('8902','2013-01-23','12:35:00',1.07),('8902','2013-01-23','12:40:00',1.3),('8902','2013-01-23','12:45:00',1.56),('8902','2013-01-23','12:50:00',1.71),('8902','2013-01-23','12:55:00',1.79),('8902','2013-01-23','13:00:00',1.78),('8902','2013-01-23','13:05:00',1.72),('8902','2013-01-23','13:10:00',1.58),('8902','2013-01-23','13:15:00',1.51),('8902','2013-01-23','13:20:00',1.51),('8902','2013-01-23','13:25:00',1.57),('8902','2013-01-23','13:30:00',1.63),('8902','2013-01-23','13:35:00',1.6),('8902','2013-01-23','13:40:00',1.6),('8902','2013-01-23','13:45:00',1.65),('8902','2013-01-23','13:50:00',1.7),('8902','2013-01-23','13:55:00',1.79),('8902','2013-01-23','14:00:00',2.37),('8902','2013-01-23','14:05:00',2.34),('8902','2013-01-23','14:10:00',2.22),('8902','2013-01-23','14:15:00',2.6),('8902','2013-01-23','14:20:00',3.72),('8902','2013-01-23','14:25:00',6.86),('8902','2013-01-23','14:30:00',6.16),('8902','2013-01-23','14:35:00',4.52),('8902','2013-01-23','14:40:00',2.82),('8902','2013-01-23','14:45:00',4.11),('8902','2013-01-23','14:50:00',4.5),('8902','2013-01-23','14:55:00',4.69),('8902','2013-01-23','15:00:00',3.66),('8902','2013-01-23','15:05:00',2.54),('8902','2013-01-23','15:10:00',1.61),('8902','2013-01-23','15:15:00',1.51),('8902','2013-01-23','15:20:00',3.04),('8902','2013-01-23','15:25:00',3.3),('8902','2013-01-23','15:30:00',3.35),('8902','2013-01-23','15:35:00',2.89),('8902','2013-01-23','15:40:00',1.45),('8902','2013-01-23','15:45:00',2.65),('8902','2013-01-23','15:50:00',2.8),('8902','2013-01-23','15:55:00',2.45),('8902','2013-01-23','16:00:00',2.28),('8902','2013-01-23','16:05:00',1.93),('8902','2013-01-23','16:10:00',1.48),('8902','2013-01-23','16:15:00',1.72),('8902','2013-01-23','16:20:00',1.53),('8902','2013-01-22','09:45:00',1.15),('8902','2013-01-22','09:50:00',1.49),('8902','2013-01-22','09:55:00',3.05),('8902','2013-01-22','10:00:00',2.08),('8902','2013-01-22','10:05:00',1.46),('8902','2013-01-22','10:10:00',1.01),('8902','2013-01-22','10:15:00',1.53),('8902','2013-01-22','10:20:00',1.51),('8902','2013-01-22','10:25:00',2.85),('8902','2013-01-22','10:30:00',4.88),('8902','2013-01-22','10:35:00',5.17),('8902','2013-01-22','10:40:00',2.48),('8902','2013-01-22','10:45:00',3.56),('8902','2013-01-22','10:50:00',4.84),('8902','2013-01-22','10:55:00',3.9),('8902','2013-01-22','11:00:00',1.39),('8902','2013-01-22','11:10:00',1.02),('8902','2013-01-21','08:05:00',1.04),('8902','2013-01-21','08:10:00',1.04),('8902','2013-01-21','08:25:00',1.02),('8902','2013-01-21','08:35:00',1.32),('8902','2013-01-21','08:45:00',1.79),('8902','2013-01-21','08:50:00',2.04),('8902','2013-01-21','08:55:00',1.27),('8902','2013-01-21','09:00:00',1.98),('8902','2013-01-21','09:05:00',2.76),('8902','2013-01-21','09:15:00',1.03),('8902','2013-01-21','09:25:00',1.38),('8902','2013-01-21','09:30:00',3.43),('8902','2013-01-21','09:35:00',3.93),('8902','2013-01-21','09:40:00',3.12),('8902','2013-01-21','09:45:00',4.92),('8902','2013-01-21','09:50:00',3.22),('8902','2013-01-21','09:55:00',3.61),('8902','2013-01-21','10:00:00',2.73),('8902','2013-01-21','10:05:00',4.61),('8902','2013-01-21','10:10:00',4.86),('8902','2013-01-21','10:15:00',4.51),('8902','2013-01-21','10:20:00',4.75),('8902','2013-01-21','10:25:00',4.92),('8902','2013-01-21','10:30:00',5.31),('8902','2013-01-21','10:35:00',5.53),('8902','2013-01-21','10:40:00',5.41),('8902','2013-01-21','10:45:00',5.48),('8902','2013-01-21','10:50:00',4.57),('8902','2013-01-21','10:55:00',2.75),('8902','2013-01-21','11:00:00',1.82),('8902','2013-01-21','11:05:00',1.28),('8902','2013-01-21','11:10:00',2.21),('8902','2013-01-21','11:15:00',3.57),('8902','2013-01-21','11:20:00',3.56),('8902','2013-01-21','11:25:00',2.64),('8902','2013-01-21','11:30:00',1.58),('8902','2013-01-21','11:35:00',1.34),('8902','2013-01-21','11:40:00',1.06),('8902','2013-01-21','11:45:00',2.61),('8902','2013-01-21','11:50:00',4.76),('8902','2013-01-21','11:55:00',2),('8902','2013-01-21','12:00:00',1.61),('8902','2013-01-21','12:05:00',1.83),('8902','2013-01-21','12:10:00',4.94),('8902','2013-01-21','12:15:00',5.83),('8902','2013-01-21','12:20:00',3.16),('8902','2013-01-21','12:25:00',4.98),('8902','2013-01-21','12:30:00',2.54),('8902','2013-01-21','12:35:00',1.89),('8902','2013-01-21','12:40:00',6.78),('8902','2013-01-21','12:45:00',2.42),('8902','2013-01-21','12:50:00',1.73),('8902','2013-01-21','12:55:00',2.45),('8902','2013-01-21','13:00:00',4.08),('8902','2013-01-21','13:05:00',6.93),('8902','2013-01-21','13:10:00',4.99),('8902','2013-01-21','13:15:00',2),('8902','2013-01-21','13:20:00',6.19),('8902','2013-01-21','13:25:00',1.53),('8902','2013-01-21','13:30:00',2.42),('8902','2013-01-21','13:35:00',1.04),('8902','2013-01-21','13:40:00',1.74),('8902','2013-01-21','13:45:00',1.95),('8902','2013-01-21','13:50:00',2.68),('8902','2013-01-21','13:55:00',1.09),('8902','2013-01-21','14:00:00',1.22),('8902','2013-01-21','14:05:00',1.41),('8902','2013-01-21','14:10:00',2.27),('8902','2013-01-21','14:15:00',2.54),('8902','2013-01-21','14:20:00',2.1),('8902','2013-01-21','14:25:00',4.32),('8902','2013-01-21','14:30:00',1.44),('8902','2013-01-21','14:35:00',3.27),('8902','2013-01-21','14:40:00',2.22),('8902','2013-01-21','14:45:00',3.78),('8902','2013-01-21','14:50:00',2.97),('8902','2013-01-21','14:55:00',1.04),('8902','2013-01-21','15:00:00',1.08),('8902','2013-01-21','15:05:00',1.53),('8902','2014-03-19','07:15:00',1.04),('8902','2014-03-19','07:20:00',1.22),('8902','2014-03-19','07:25:00',1.34),('8902','2014-03-19','07:30:00',1.36),('8902','2014-03-19','07:35:00',1.61),('8902','2014-03-19','07:40:00',1.8),('8902','2014-03-19','07:45:00',1.97),('8902','2014-03-19','07:50:00',2.11),('8902','2014-03-19','07:55:00',2.28),('8902','2014-03-19','08:00:00',2.46),('8902','2014-03-19','08:05:00',2.63),('8902','2014-03-19','08:10:00',2.74),('8902','2014-03-19','08:15:00',2.84),('8902','2014-03-19','08:20:00',2.95),('8902','2014-03-19','08:25:00',3.12),('8902','2014-03-19','08:30:00',3.32),('8902','2014-03-19','08:35:00',3.55),('8902','2014-03-19','08:40:00',3.79),('8902','2014-03-19','08:45:00',4.01),('8902','2014-03-19','08:50:00',4.2),('8902','2014-03-19','08:55:00',4.3),('8902','2014-03-19','09:00:00',4.4),('8902','2014-03-19','09:05:00',4.56),('8902','2014-03-19','09:10:00',4.81),('8902','2014-03-19','09:15:00',4.89),('8902','2014-03-19','09:20:00',5.05),('8902','2014-03-19','09:25:00',5.14),('8902','2014-03-19','09:30:00',5.22),('8902','2014-03-19','09:35:00',5.43),('8902','2014-03-19','09:40:00',5.43),('8902','2014-03-19','09:45:00',5.56),('8902','2014-03-19','09:50:00',5.54),('8902','2014-03-19','09:55:00',5.64),('8902','2014-03-19','10:00:00',5.92),('8902','2014-03-19','10:05:00',6.17),('8902','2014-03-19','10:10:00',6.29),('8902','2014-03-19','10:15:00',6.17),('8902','2014-03-19','10:20:00',6.33),('8902','2014-03-19','10:25:00',6.4),('8902','2014-03-19','10:30:00',6.46),('8902','2014-03-19','10:35:00',6.39),('8902','2014-03-19','10:40:00',6.25),('8902','2014-03-19','10:45:00',6.18),('8902','2014-03-19','10:50:00',6.65),('8902','2014-03-19','10:55:00',7.02),('8902','2014-03-19','11:00:00',7.11),('8902','2014-03-19','11:05:00',7.09),('8902','2014-03-19','11:10:00',7.03),('8902','2014-03-19','11:15:00',6.7),('8902','2014-03-19','11:20:00',6.96),('8902','2014-03-19','11:25:00',7.04),('8902','2014-03-19','11:30:00',7.25),('8902','2014-03-19','11:35:00',7.53),('8902','2014-03-19','11:40:00',7.35),('8902','2014-03-19','11:45:00',7.45),('8902','2014-03-19','11:50:00',7.36),('8902','2014-03-19','11:55:00',7.06),('8902','2014-03-19','12:00:00',6.54),('8902','2014-03-19','12:05:00',7.11),('8902','2014-03-19','12:10:00',7.41),('8902','2014-03-19','12:15:00',7.46),('8902','2014-03-19','12:20:00',7.24),('8902','2014-03-19','12:25:00',6.87),('8902','2014-03-19','12:30:00',7.2),('8902','2014-03-19','12:35:00',7.35),('8902','2014-03-19','12:40:00',7.34),('8902','2014-03-19','12:45:00',7.62),('8902','2014-03-19','12:50:00',7.53),('8902','2014-03-19','12:55:00',7.37),('8902','2014-03-19','13:00:00',7.4),('8902','2014-03-19','13:05:00',7.31),('8902','2014-03-19','13:10:00',7.19),('8902','2014-03-19','13:15:00',7.26),('8902','2014-03-19','13:20:00',7.3),('8902','2014-03-19','13:25:00',7.12),('8902','2014-03-19','13:30:00',7.23),('8902','2014-03-19','13:35:00',7.07),('8902','2014-03-19','13:40:00',6.57),('8902','2014-03-19','13:45:00',6.41),('8902','2014-03-19','13:50:00',6.25),('8902','2014-03-19','13:55:00',5.94),('8902','2014-03-19','14:00:00',5.91),('8902','2014-03-19','14:05:00',6.46),('8902','2014-03-19','14:10:00',6.24),('8902','2014-03-19','14:15:00',6.01),('8902','2014-03-19','14:20:00',5.99),('8902','2014-03-19','14:25:00',6.03),('8902','2014-03-19','14:30:00',5.19),('8902','2014-03-19','14:35:00',4.77),('8902','2014-03-19','14:40:00',5.33),('8902','2014-03-19','14:45:00',5.27),('8902','2014-03-19','14:50:00',5.02),('8902','2014-03-19','14:55:00',4.82),('8902','2014-03-19','15:00:00',4.4),('8902','2014-03-19','15:05:00',4.34),('8902','2014-03-19','15:10:00',4.45),('8902','2014-03-19','15:15:00',4.11),('8902','2014-03-19','15:20:00',4.37),('8902','2014-03-19','15:25:00',4.06),('8902','2014-03-19','15:30:00',3.81),('8902','2014-03-19','15:35:00',3.76),('8902','2014-03-19','15:40:00',3.41),('8902','2014-03-19','15:45:00',3.34),('8902','2014-03-19','15:50:00',3.05),('8902','2014-03-19','15:55:00',2.74),('8902','2014-03-19','16:00:00',2.29),('8902','2014-03-19','16:05:00',2.06),('8902','2014-03-19','16:10:00',2.23),('8902','2014-03-19','16:15:00',2.15),('8902','2014-03-19','16:20:00',2.27),('8902','2014-03-19','16:25:00',2.33),('8902','2014-03-19','16:30:00',2.06),('8902','2014-03-19','16:35:00',1.88),('8902','2014-03-19','16:40:00',1.76),('8902','2014-03-19','16:45:00',1.31),('8902','2014-03-19','16:50:00',1.07),('8902','2013-01-20','10:10:00',1.08),('8902','2013-01-20','10:15:00',1.26),('8902','2013-01-20','10:20:00',1.1),('8902','2013-01-20','10:25:00',1.09),('8902','2013-01-20','10:30:00',1.11),('8902','2013-01-20','10:55:00',1.05),('8902','2013-01-20','11:00:00',1.62),('8902','2013-01-20','11:05:00',1.47),('8902','2013-01-20','11:10:00',1.98),('8902','2013-01-20','11:15:00',2.22),('8902','2013-01-20','11:20:00',1.77),('8902','2013-01-20','11:25:00',1.74),('8902','2013-01-20','11:30:00',1.22),('8902','2013-01-20','11:40:00',1.35),('8902','2013-01-20','11:45:00',1.64),('8902','2013-01-20','11:50:00',1.89),('8902','2013-01-20','11:55:00',6.86),('8902','2013-01-20','12:00:00',6.07),('8902','2013-01-20','12:05:00',5.94),('8902','2013-01-20','12:10:00',5.73),('8902','2013-01-20','12:15:00',5.36),('8902','2013-01-20','12:20:00',1.92),('8902','2013-01-20','12:25:00',3.27),('8902','2013-01-20','12:30:00',1.3),('8902','2013-01-20','12:35:00',1.36),('8902','2013-01-20','12:40:00',2.23),('8902','2013-01-20','12:45:00',1.3),('8902','2013-01-20','12:50:00',2.18),('8902','2013-01-20','12:55:00',1.48),('8902','2013-01-20','13:00:00',1.66),('8902','2013-01-20','13:05:00',3.78),('8902','2013-01-20','13:10:00',2.85),('8902','2013-01-20','13:15:00',1.78),('8902','2013-01-20','13:20:00',1.69),('8902','2013-01-20','13:25:00',1.54),('8902','2013-01-20','13:30:00',5.98),('8902','2013-01-20','13:35:00',6.67),('8902','2013-01-20','13:40:00',6.11),('8902','2013-01-20','13:45:00',1.98),('8902','2013-01-20','13:50:00',4.11),('8902','2013-01-20','13:55:00',5.79),('8902','2013-01-20','14:00:00',5.58),('8902','2013-01-20','14:05:00',5.06),('8902','2013-01-20','14:10:00',5.38),('8902','2013-01-20','14:15:00',4.46),('8902','2013-01-20','14:20:00',4.17),('8902','2013-01-20','14:25:00',4.64),('8902','2013-01-20','14:30:00',2.67),('8902','2013-01-20','14:35:00',1.65),('8902','2013-01-20','14:40:00',1.15),('8902','2013-01-19','08:30:00',1.08),('8902','2013-01-19','08:35:00',1.21),('8902','2013-01-19','08:40:00',1.18),('8902','2013-01-19','10:00:00',1.03),('8902','2013-01-19','10:05:00',1.05),('8902','2013-01-19','10:25:00',1.14),('8902','2013-01-19','10:30:00',1.36),('8902','2013-01-19','10:35:00',1.11),('8902','2013-01-19','10:40:00',1.33),('8902','2013-01-19','10:45:00',1.55),('8902','2013-01-19','10:50:00',1.87),('8902','2013-01-19','10:55:00',2.1),('8902','2013-01-19','11:00:00',2.28),('8902','2013-01-19','11:05:00',2.24),('8902','2013-01-19','11:10:00',2.32),('8902','2013-01-19','11:15:00',3.23),('8902','2013-01-19','11:20:00',2.54),('8902','2013-01-19','11:25:00',3.48),('8902','2013-01-19','11:30:00',4.64),('8902','2013-01-19','11:35:00',3.48),('8902','2013-01-19','11:40:00',1.95),('8902','2013-01-19','11:45:00',1.85),('8902','2013-01-19','11:50:00',1.33),('8902','2013-01-19','12:00:00',1.12),('8902','2013-01-19','12:05:00',1.06),('8902','2013-01-19','12:10:00',1.23),('8902','2013-01-19','12:15:00',1.52),('8902','2013-01-19','12:20:00',1.72),('8902','2013-01-19','12:25:00',1.79),('8902','2013-01-19','12:30:00',1.65),('8902','2013-01-19','12:35:00',1.51),('8902','2013-01-19','12:40:00',1.41),('8902','2013-01-19','12:45:00',1.38),('8902','2013-01-19','12:50:00',1.34),('8902','2013-01-19','12:55:00',1.32),('8902','2013-01-19','13:00:00',1.26),('8902','2013-01-19','13:05:00',1.2),('8902','2013-01-19','13:10:00',1.21),('8902','2013-01-19','13:15:00',1.34),('8902','2013-01-19','13:20:00',1.36),('8902','2013-01-19','13:25:00',1.4),('8902','2013-01-19','13:30:00',1.28),('8902','2013-01-19','13:35:00',1.41),('8902','2013-01-19','13:40:00',1.68),('8902','2013-01-19','13:45:00',1.63),('8902','2013-01-19','13:50:00',1.56),('8902','2013-01-19','13:55:00',1.38),('8902','2013-01-19','14:00:00',1.19),('8902','2013-01-19','14:05:00',1.04),('8902','2013-01-19','14:15:00',1.03),('8902','2013-01-19','14:20:00',1.29),('8902','2013-01-19','14:25:00',1.11),('8902','2013-01-18','08:55:00',1.04),('8902','2013-01-18','09:00:00',1.13),('8902','2013-01-18','09:05:00',1.26),('8902','2013-01-18','09:10:00',1.65),('8902','2013-01-18','09:15:00',2.6),('8902','2013-01-18','09:20:00',2.51),('8902','2013-01-18','09:25:00',2.01),('8902','2013-01-18','09:30:00',1.35),('8902','2013-01-18','09:35:00',1.22),('8902','2013-01-18','09:40:00',1.08),('8902','2013-01-18','09:45:00',1.44),('8902','2013-01-18','09:50:00',1.99),('8902','2013-01-18','09:55:00',2.87),('8902','2013-01-18','10:00:00',2.57),('8902','2013-01-18','10:05:00',1.99),('8902','2013-01-18','10:10:00',1.36),('8902','2013-01-18','10:25:00',1.08),('8902','2013-01-18','10:30:00',1.03),('8902','2013-01-18','10:35:00',1.67),('8902','2013-01-18','10:40:00',2.1),('8902','2013-01-18','10:45:00',2.41),('8902','2013-01-18','10:50:00',2.69),('8902','2013-01-18','10:55:00',1.32),('8902','2013-01-18','11:00:00',1.39),('8902','2013-01-18','11:05:00',1.52),('8902','2013-01-18','11:10:00',1.61),('8902','2013-01-18','11:15:00',1.72),('8902','2013-01-18','11:20:00',2.09),('8902','2013-01-18','11:25:00',2.16),('8902','2013-01-18','11:30:00',1.78),('8902','2013-01-18','11:35:00',1.2),('8902','2013-01-18','11:40:00',1.08),('8902','2013-01-18','11:45:00',1.22),('8902','2013-01-18','11:50:00',1.38),('8902','2013-01-18','11:55:00',1.31),('8902','2013-01-18','12:00:00',1.1),('8902','2013-01-18','12:05:00',1.08),('8902','2013-01-18','12:10:00',1.19),('8902','2013-01-18','12:15:00',1.29),('8902','2013-01-18','12:20:00',1.18),('8902','2013-01-18','14:35:00',1.18),('8902','2013-01-17','08:45:00',1.2),('8902','2013-01-17','08:50:00',1.23),('8902','2013-01-17','08:55:00',1.33),('8902','2013-01-17','09:00:00',1.07),('8902','2013-01-17','09:55:00',1.03),('8902','2013-01-17','10:00:00',1.09),('8902','2013-01-17','10:05:00',1.12),('8902','2013-01-17','10:10:00',1.51),('8902','2013-01-17','10:15:00',4.44),('8902','2013-01-17','10:20:00',4.32),('8902','2013-01-17','10:25:00',3.12),('8902','2013-01-17','10:30:00',2.58),('8902','2013-01-17','10:35:00',1.97),('8902','2013-01-17','10:40:00',1.59),('8902','2013-01-17','10:45:00',1.45),('8902','2013-01-17','10:50:00',1.49),('8902','2013-01-17','10:55:00',1.5),('8902','2013-01-17','11:00:00',1.59),('8902','2013-01-17','11:05:00',1.68),('8902','2013-01-17','11:10:00',1.7),('8902','2013-01-17','11:15:00',1.63),('8902','2013-01-17','11:20:00',1.44),('8902','2013-01-17','11:25:00',1.46),('8902','2013-01-17','11:30:00',1.86),('8902','2013-01-17','11:35:00',2.25),('8902','2013-01-17','11:40:00',2.21),('8902','2013-01-17','11:45:00',1.82),('8902','2013-01-17','11:50:00',1.49),('8902','2013-01-17','11:55:00',1.52),('8902','2013-01-17','12:00:00',1.67),('8902','2013-01-17','12:05:00',1.66),('8902','2013-01-17','12:10:00',1.87),('8902','2013-01-17','12:15:00',1.9),('8902','2013-01-17','12:20:00',1.85),('8902','2013-01-17','12:25:00',1.92),('8902','2013-01-17','12:30:00',1.96),('8902','2013-01-17','12:35:00',2.33),('8902','2013-01-17','12:40:00',2.76),('8902','2013-01-17','12:45:00',2.86),('8902','2013-01-17','12:50:00',4.2),('8902','2013-01-17','12:55:00',3.85),('8902','2013-01-17','13:00:00',4.66),('8902','2013-01-17','13:05:00',4.24),('8902','2013-01-17','13:10:00',4.04),('8902','2013-01-17','13:15:00',4.5),('8902','2013-01-17','13:20:00',3.69),('8902','2013-01-17','13:25:00',2.99),('8902','2013-01-17','13:30:00',2.83),('8902','2013-01-17','13:35:00',3.27),('8902','2013-01-17','13:40:00',4.85),('8902','2013-01-17','13:45:00',4.54),('8902','2013-01-17','13:50:00',6.03),('8902','2013-01-17','13:55:00',4.57),('8902','2013-01-17','14:00:00',6.25),('8902','2013-01-17','14:05:00',4.03),('8902','2013-01-17','14:10:00',5.49),('8902','2013-01-17','14:15:00',3.81),('8902','2013-01-17','14:20:00',3.16),('8902','2013-01-17','14:25:00',2.56),('8902','2013-01-17','14:30:00',2.23),('8902','2013-01-17','14:35:00',1.88),('8902','2013-01-17','14:40:00',1.69),('8902','2013-01-17','14:45:00',1.87),('8902','2013-01-17','14:50:00',2.09),('8902','2013-01-17','14:55:00',1.76),('8902','2013-01-17','15:00:00',1.48),('8902','2013-01-17','15:05:00',1.6),('8902','2013-01-17','15:10:00',1.52),('8902','2013-01-17','15:15:00',1.76),('8902','2013-01-17','15:20:00',2.07),('8902','2013-01-17','15:25:00',2.57),('8902','2013-01-17','15:30:00',2.21),('8902','2013-01-17','15:35:00',1.55),('8902','2013-01-17','15:45:00',1.56),('8902','2013-01-17','15:50:00',2.03),('8902','2013-01-17','15:55:00',2.08),('8902','2013-01-17','16:00:00',1.88),('8902','2013-01-17','16:05:00',1.77),('8902','2013-01-17','16:10:00',1.65),('8902','2013-01-17','16:15:00',1.54),('8902','2013-01-17','16:20:00',1.3),('8902','2013-01-17','16:25:00',1.12),('8902','2013-01-16','09:10:00',1.28),('8902','2013-01-16','09:15:00',1.37),('8902','2013-01-16','09:20:00',1.32),('8902','2013-01-16','09:25:00',1.19),('8902','2013-01-16','09:30:00',1.3),('8902','2013-01-16','09:35:00',1.45),('8902','2013-01-16','09:40:00',1.58),('8902','2013-01-16','09:45:00',1.94),('8902','2013-01-16','09:50:00',2.45),('8902','2013-01-16','09:55:00',2.28),('8902','2013-01-16','10:00:00',1.64),('8902','2013-01-16','10:05:00',1.74),('8902','2013-01-16','10:10:00',2.08),('8902','2013-01-16','10:15:00',2.44),('8902','2013-01-16','10:20:00',2.45),('8902','2013-01-16','10:25:00',3.1),('8902','2013-01-16','10:30:00',3.3),('8902','2013-01-16','10:35:00',3.05),('8902','2013-01-16','10:40:00',2.86),('8902','2013-01-16','10:45:00',3.12),('8902','2013-01-16','10:50:00',2.93),('8902','2013-01-16','10:55:00',3.55),('8902','2013-01-16','11:00:00',3.15),('8902','2013-01-16','11:05:00',3.05),('8902','2013-01-16','11:10:00',3.66),('8902','2013-01-16','11:15:00',3.72),('8902','2013-01-16','11:20:00',3.48),('8902','2013-01-16','11:25:00',3.02),('8902','2013-01-16','11:30:00',2.66),('8902','2013-01-16','11:35:00',2.96),('8902','2013-01-16','11:40:00',3.15),('8902','2013-01-16','11:45:00',2.77),('8902','2013-01-16','11:50:00',2.97),('8902','2013-01-16','11:55:00',3.22),('8902','2013-01-16','12:00:00',3.64),('8902','2013-01-16','12:05:00',3.57),('8902','2013-01-16','12:10:00',3.69),('8902','2013-01-16','12:15:00',4.24),('8902','2013-01-16','12:20:00',3.56),('8902','2013-01-16','12:25:00',3.13),('8902','2013-01-16','12:30:00',2.43),('8902','2013-01-16','12:35:00',2.91),('8902','2013-01-16','12:40:00',3.02),('8902','2013-01-16','12:45:00',2.33),('8902','2013-01-16','12:50:00',1.58),('8902','2013-01-16','12:55:00',1.55),('8902','2013-01-16','13:00:00',3.38),('8902','2013-01-16','13:05:00',2.82),('8902','2013-01-16','13:10:00',2.14),('8902','2013-01-16','13:15:00',2.85),('8902','2013-01-16','13:20:00',3.16),('8902','2013-01-16','13:25:00',2.81),('8902','2013-01-16','13:30:00',2.44),('8902','2013-01-16','13:35:00',2.99),('8902','2013-01-16','13:40:00',4.21),('8902','2013-01-16','13:45:00',4.12),('8902','2013-01-16','13:50:00',3.08),('8902','2013-01-16','13:55:00',2.09),('8902','2013-01-16','14:00:00',1.84),('8902','2013-01-16','14:05:00',1.92),('8902','2013-01-16','14:10:00',1.7),('8902','2013-01-16','14:15:00',1.08),('8902','2013-01-16','14:20:00',1.17),('8902','2013-01-16','14:25:00',1.63),('8902','2013-01-16','14:30:00',2.18),('8902','2013-01-16','14:35:00',2.85),('8902','2013-01-16','14:40:00',1.93),('8902','2013-01-16','14:55:00',1.38),('8902','2013-01-16','15:00:00',1.5),('8902','2013-01-15','09:15:00',2.15),('8902','2013-01-15','09:20:00',1.92),('8902','2013-01-15','09:25:00',2.99),('8902','2013-01-15','09:30:00',3.36),('8902','2013-01-15','09:35:00',3.54),('8902','2013-01-15','09:40:00',3.85),('8902','2013-01-15','09:45:00',2.56),('8902','2013-01-15','09:50:00',1.44),('8902','2013-01-15','09:55:00',1.66),('8902','2013-01-15','10:00:00',1.96),('8902','2013-01-15','10:05:00',1.16),('8902','2013-01-15','10:25:00',1.07),('8902','2013-01-15','10:30:00',1.38),('8902','2013-01-15','10:35:00',3.39),('8902','2013-01-15','10:40:00',3.94),('8902','2013-01-15','10:45:00',4.72),('8902','2013-01-15','10:50:00',1.31),('8902','2013-01-15','10:55:00',3.73),('8902','2013-01-15','11:00:00',1.56),('8902','2013-01-15','11:05:00',1.35),('8902','2013-01-15','11:25:00',2.98),('8902','2013-01-15','12:00:00',2.61),('8902','2013-01-15','12:05:00',2.48),('8902','2013-01-15','12:10:00',2.77),('8902','2013-01-15','12:15:00',6.52),('8902','2013-01-15','12:20:00',6.67),('8902','2013-01-15','12:25:00',3.05),('8902','2013-01-15','13:00:00',1.1),('8902','2013-01-15','13:05:00',3.93),('8902','2013-01-15','13:10:00',7.78),('8902','2013-01-15','13:15:00',8.02),('8902','2013-01-15','13:20:00',6.02),('8902','2013-01-15','13:25:00',3.64),('8902','2013-01-15','13:30:00',1.36),('8902','2013-01-15','13:55:00',5.08),('8902','2013-01-15','14:00:00',3.55),('8902','2013-01-15','14:05:00',2.54),('8902','2013-01-15','14:10:00',1.29),('8902','2013-01-15','15:05:00',1.68),('8902','2013-01-15','15:10:00',1.73),('8902','2013-01-15','15:15:00',1.54),('8902','2013-01-15','16:05:00',1.75),('8902','2013-01-15','16:10:00',1.57),('8902','2013-01-15','16:15:00',1.37),('8902','2013-01-14','08:55:00',1.17),('8902','2013-01-14','09:00:00',1.18),('8902','2013-01-14','09:15:00',1.07),('8902','2013-01-14','09:50:00',1.2),('8902','2013-01-14','09:55:00',1.78),('8902','2013-01-14','10:00:00',1.9),('8902','2013-01-14','10:05:00',1.43),('8902','2013-01-14','10:10:00',1.82),('8902','2013-01-14','10:15:00',1.57),('8902','2013-01-14','10:20:00',1.84),('8902','2013-01-14','10:25:00',1.87),('8902','2013-01-14','10:30:00',1.39),('8902','2013-01-14','10:35:00',1.55),('8902','2013-01-14','10:40:00',1.75),('8902','2013-01-14','10:45:00',2.07),('8902','2013-01-14','10:50:00',2.61),('8902','2013-01-14','10:55:00',2.83),('8902','2013-01-14','11:00:00',2.6),('8902','2013-01-14','11:05:00',2.75),('8902','2013-01-14','11:10:00',2.96),('8902','2013-01-14','11:15:00',2.81),('8902','2013-01-14','11:20:00',2.99),('8902','2013-01-14','11:25:00',2.92),('8902','2013-01-14','11:30:00',2.77),('8902','2013-01-14','11:35:00',2.52),('8902','2013-01-14','11:40:00',2.35),('8902','2013-01-14','11:45:00',1.98),('8902','2013-01-14','11:50:00',1.83),('8902','2013-01-14','11:55:00',2.01),('8902','2013-01-14','12:00:00',1.94),('8902','2013-01-14','12:05:00',1.85),('8902','2013-01-14','12:10:00',1.78),('8902','2013-01-14','12:15:00',2.11),('8902','2013-01-14','12:20:00',2.44),('8902','2013-01-14','12:25:00',2.37),('8902','2013-01-14','12:30:00',2.15),('8902','2013-01-14','12:35:00',2.14),('8902','2013-01-14','12:40:00',2.41),('8902','2013-01-14','12:45:00',2.51),('8902','2013-01-14','12:50:00',2.33),('8902','2013-01-14','12:55:00',2.07),('8902','2013-01-14','13:00:00',1.71),('8902','2013-01-14','13:05:00',1.8),('8902','2013-01-14','13:10:00',1.79),('8902','2013-01-14','13:15:00',1.85),('8902','2013-01-14','13:20:00',1.88),('8902','2013-01-14','13:25:00',1.82),('8902','2013-01-14','13:30:00',2.02),('8902','2013-01-14','13:35:00',2.06),('8902','2013-01-14','13:40:00',2.35),('8902','2013-01-14','13:45:00',2.2),('8902','2013-01-14','13:50:00',2.16),('8902','2013-01-14','13:55:00',2.49),('8902','2013-01-14','14:00:00',4.45),('8902','2013-01-14','14:05:00',5.8),('8902','2013-01-14','14:10:00',5.47),('8902','2013-01-14','14:15:00',5.84),('8902','2013-01-14','14:20:00',5.99),('8902','2013-01-14','14:25:00',5.81),('8902','2013-01-14','14:30:00',4.2),('8902','2013-01-14','14:35:00',3.35),('8902','2013-01-14','14:40:00',4.43),('8902','2013-01-14','14:45:00',4.26),('8902','2013-01-14','14:50:00',3.82),('8902','2013-01-14','14:55:00',3.49),('8902','2013-01-14','15:00:00',4.13),('8902','2013-01-14','15:05:00',4.04),('8902','2013-01-14','15:10:00',3.75),('8902','2013-01-14','15:15:00',2.12),('8902','2013-01-14','15:20:00',1.41),('8902','2013-01-14','15:25:00',2.32),('8902','2013-01-14','15:30:00',2.19),('8902','2013-01-14','15:35:00',1.9),('8902','2013-01-14','15:40:00',1.59),('8902','2013-01-14','15:45:00',1.48),('8902','2013-01-14','15:50:00',1.44),('8902','2013-01-14','15:55:00',1.41),('8902','2013-01-14','16:00:00',1.74),('8902','2013-01-14','16:05:00',2.07),('8902','2013-01-14','16:10:00',1.91),('8902','2013-01-14','16:15:00',1.68),('8902','2013-01-14','16:20:00',1.43),('8902','2013-01-14','16:25:00',1.19),('8902','2013-01-13','09:45:00',1.01),('8902','2013-01-13','09:50:00',1.11),('8902','2013-01-13','10:25:00',1.01),('8902','2013-01-13','11:20:00',1.27),('8902','2013-01-13','11:25:00',1.3),('8902','2013-01-13','11:50:00',1.11),('8902','2013-01-13','12:20:00',1.13),('8902','2013-01-13','12:25:00',1.56),('8902','2013-01-13','12:30:00',1.62),('8902','2013-01-13','12:35:00',1.43),('8902','2013-01-13','12:40:00',1.65),('8902','2013-01-13','12:45:00',1.8),('8902','2013-01-13','12:50:00',2.26),('8902','2013-01-13','12:55:00',2.12),('8902','2013-01-13','13:00:00',2.21),('8902','2013-01-13','13:05:00',2.12),('8902','2013-01-13','13:10:00',1.98),('8902','2013-01-13','13:15:00',1.66),('8902','2013-01-13','13:20:00',1.18),('8902','2013-01-13','13:35:00',1.28),('8902','2013-01-13','13:40:00',1.1),('8902','2013-01-13','15:15:00',3.03),('8902','2013-01-13','15:20:00',1.73),('8902','2013-01-13','15:25:00',1.7),('8902','2013-01-13','15:30:00',1.14),('8902','2013-01-12','09:10:00',1.17),('8902','2013-01-12','09:15:00',3.2),('8902','2013-01-12','09:20:00',3.32),('8902','2013-01-12','09:25:00',3.24),('8902','2013-01-12','09:30:00',3.43),('8902','2013-01-12','09:35:00',3.59),('8902','2013-01-12','09:40:00',2.32),('8902','2013-01-12','09:45:00',1.37),('8902','2013-01-12','09:50:00',2.63),('8902','2013-01-12','09:55:00',3.47),('8902','2013-01-12','10:00:00',3.52),('8902','2013-01-12','10:05:00',3.68),('8902','2013-01-12','10:10:00',2.57),('8902','2013-01-12','10:15:00',1.49),('8902','2013-01-12','10:20:00',1.97),('8902','2013-01-12','10:25:00',3.29),('8902','2013-01-12','10:30:00',3.95),('8902','2013-01-12','10:35:00',1.8),('8902','2013-01-11','08:30:00',1.01),('8902','2013-01-11','08:35:00',1.13),('8902','2013-01-11','08:40:00',1.26),('8902','2013-01-11','08:45:00',1.59),('8902','2013-01-11','08:50:00',1.87),('8902','2013-01-11','08:55:00',2.02),('8902','2013-01-11','09:00:00',2.19),('8902','2013-01-11','09:05:00',2.36),('8902','2013-01-11','09:10:00',2.49),('8902','2013-01-11','09:15:00',2.6),('8902','2013-01-11','09:20:00',2.74),('8902','2013-01-11','09:25:00',2.9),('8902','2013-01-11','09:30:00',3.04),('8902','2013-01-11','09:35:00',3.16),('8902','2013-01-11','09:40:00',3.23),('8902','2013-01-11','09:45:00',3.38),('8902','2013-01-11','09:50:00',3.58),('8902','2013-01-11','09:55:00',3.73),('8902','2013-01-11','10:00:00',3.82),('8902','2013-01-11','10:05:00',3.96),('8902','2013-01-11','10:10:00',4.11),('8902','2013-01-11','10:15:00',4.23),('8902','2013-01-11','10:20:00',4.31),('8902','2013-01-11','10:25:00',4.41),('8902','2013-01-11','10:30:00',4.54),('8902','2013-01-11','10:35:00',4.6),('8902','2013-01-11','10:40:00',4.71),('8902','2013-01-11','10:45:00',4.8),('8902','2013-01-11','10:50:00',4.88),('8902','2013-01-11','10:55:00',4.91),('8902','2013-01-11','11:00:00',4.95),('8902','2013-01-11','11:05:00',4.95),('8902','2013-01-11','11:10:00',5.07),('8902','2013-01-11','11:15:00',5.11),('8902','2013-01-11','11:20:00',5.16),('8902','2013-01-11','11:25:00',5.15),('8902','2013-01-11','11:30:00',5.23),('8902','2013-01-11','11:35:00',5.29),('8902','2013-01-11','11:40:00',5.31),('8902','2013-01-11','11:45:00',5.38),('8902','2013-01-11','11:50:00',5.42),('8902','2013-01-11','11:55:00',5.44),('8902','2013-01-11','12:00:00',5.39),('8902','2013-01-11','12:05:00',5.39),('8902','2013-01-11','12:10:00',5.35),('8902','2013-01-11','12:15:00',5.42),('8902','2013-01-11','12:20:00',5.33),('8902','2013-01-11','12:25:00',5.3),('8902','2013-01-11','12:30:00',5.38),('8902','2013-01-11','12:35:00',5.13),('8902','2013-01-11','12:40:00',3.67),('8902','2013-01-11','12:50:00',3.21),('8902','2013-01-11','12:55:00',3.39),('8902','2013-01-11','13:00:00',5.5),('8902','2013-01-11','13:05:00',5.22),('8902','2013-01-11','13:10:00',4.6),('8902','2013-01-11','13:15:00',4.3),('8902','2013-01-11','13:20:00',2.69),('8902','2013-01-11','13:25:00',5.28),('8902','2013-01-11','13:30:00',4.53),('8902','2013-01-11','13:35:00',4.99),('8902','2013-01-11','13:40:00',2.04),('8902','2013-01-11','13:45:00',3.08),('8902','2013-01-11','13:50:00',4.5),('8902','2013-01-11','13:55:00',5.21),('8902','2013-01-11','14:00:00',3.54),('8902','2013-01-11','14:05:00',5.01),('8902','2013-01-11','14:10:00',5.04),('8902','2013-01-11','14:15:00',4.77),('8902','2013-01-11','14:20:00',4.44),('8902','2013-01-11','14:25:00',4.27),('8902','2013-01-11','14:30:00',4.04),('8902','2013-01-11','14:35:00',3.95),('8902','2013-01-11','14:40:00',3.85),('8902','2013-01-11','14:45:00',3.66),('8902','2013-01-11','14:50:00',3.56),('8902','2013-01-11','14:55:00',3.51),('8902','2013-01-11','15:00:00',3.36),('8902','2013-01-11','15:05:00',3.13),('8902','2013-01-11','15:10:00',2.88),('8902','2013-01-11','15:15:00',2.22),('8902','2013-01-11','15:20:00',2.5),('8902','2013-01-11','15:25:00',2.45),('8902','2013-01-11','15:30:00',1.32),('8902','2013-01-11','15:35:00',2.18),('8902','2013-01-11','15:40:00',1.79),('8902','2013-01-11','15:45:00',1.81),('8902','2013-01-11','15:50:00',1.73),('8902','2013-01-11','15:55:00',1.62),('8902','2013-01-11','16:00:00',1.47),('8902','2013-01-11','16:05:00',1.32),('8902','2013-01-11','16:10:00',1.16),('8902','2014-03-18','08:30:00',1.08),('8902','2014-03-18','08:35:00',1.23),('8902','2014-03-18','08:40:00',1.45),('8902','2014-03-18','08:45:00',1.51),('8902','2014-03-18','08:50:00',1.63),('8902','2014-03-18','08:55:00',1.82),('8902','2014-03-18','09:00:00',2.05),('8902','2014-03-18','09:05:00',2.28),('8902','2014-03-18','09:10:00',2.56),('8902','2014-03-18','09:15:00',2.9),('8902','2014-03-18','09:20:00',3.09),('8902','2014-03-18','09:25:00',4.29),('8902','2014-03-18','09:30:00',3.05),('8902','2014-03-18','09:35:00',4.77),('8902','2014-03-18','09:40:00',5.07),('8902','2014-03-18','09:45:00',5.58),('8902','2014-03-18','09:50:00',6.58),('8902','2014-03-18','09:55:00',5.56),('8902','2014-03-18','10:00:00',3.14),('8902','2014-03-18','10:05:00',2.39),('8902','2014-03-18','10:10:00',2.01),('8902','2014-03-18','10:15:00',1.63),('8902','2014-03-18','10:20:00',1.75),('8902','2014-03-18','10:25:00',1.87),('8902','2014-03-18','10:30:00',2.13),('8902','2014-03-18','10:35:00',2.99),('8902','2014-03-18','10:40:00',4.21),('8902','2014-03-18','10:45:00',5.94),('8902','2014-03-18','10:50:00',5.45),('8902','2014-03-18','10:55:00',2.87),('8902','2014-03-18','11:00:00',2.35),('8902','2014-03-18','11:05:00',4.25),('8902','2014-03-18','11:10:00',7.79),('8902','2014-03-18','11:15:00',4.06),('8902','2014-03-18','11:20:00',3.62),('8902','2014-03-18','11:25:00',4.02),('8902','2014-03-18','11:30:00',4.19),('8902','2014-03-18','11:35:00',4.99),('8902','2014-03-18','11:40:00',3.82),('8902','2014-03-18','11:45:00',3.84),('8902','2014-03-18','11:50:00',3.23),('8902','2014-03-18','11:55:00',2.98),('8902','2014-03-18','12:00:00',3.09),('8902','2014-03-18','12:05:00',6.87),('8902','2014-03-18','12:10:00',8.35),('8902','2014-03-18','12:15:00',8.44),('8902','2014-03-18','12:20:00',8.45),('8902','2014-03-18','12:25:00',8.04),('8902','2014-03-18','12:30:00',8.24),('8902','2014-03-18','12:35:00',8),('8902','2014-03-18','12:40:00',8.07),('8902','2014-03-18','12:45:00',7.81),('8902','2014-03-18','12:50:00',7.34),('8902','2014-03-18','12:55:00',5.43),('8902','2014-03-18','13:00:00',6.64),('8902','2014-03-18','13:05:00',6.82),('8902','2014-03-18','13:10:00',7.76),('8902','2014-03-18','13:15:00',7.57),('8902','2014-03-18','13:20:00',5.56),('8902','2014-03-18','13:25:00',5.07),('8902','2014-03-18','13:30:00',7.25),('8902','2014-03-18','13:35:00',7.37),('8902','2014-03-18','13:40:00',7.09),('8902','2014-03-18','13:45:00',7.34),('8902','2014-03-18','13:50:00',7.2),('8902','2014-03-18','13:55:00',7.06),('8902','2014-03-18','14:00:00',6.92),('8902','2014-03-18','14:05:00',6.93),('8902','2014-03-18','14:10:00',6.87),('8902','2014-03-18','14:15:00',6.66),('8902','2014-03-18','14:20:00',6.59),('8902','2014-03-18','14:25:00',6.54),('8902','2014-03-18','14:30:00',6.35),('8902','2014-03-18','14:35:00',6.41),('8902','2014-03-18','14:40:00',6.28),('8902','2014-03-18','14:45:00',6.17),('8902','2014-03-18','14:50:00',6.06),('8902','2014-03-18','14:55:00',5.93),('8902','2014-03-18','15:00:00',5.79),('8902','2014-03-18','15:05:00',5.66),('8902','2014-03-18','15:10:00',5.55),('8902','2014-03-18','15:15:00',5.54),('8902','2014-03-18','15:20:00',5.31),('8902','2014-03-18','15:25:00',5.21),('8902','2014-03-18','15:30:00',5.03),('8902','2014-03-18','15:35:00',4.79),('8902','2014-03-18','15:40:00',4.8),('8902','2014-03-18','15:45:00',4.65),('8902','2014-03-18','15:50:00',4.37),('8902','2014-03-18','15:55:00',4.31),('8902','2014-03-18','16:00:00',4.1),('8902','2014-03-18','16:05:00',3.9),('8902','2014-03-18','16:10:00',3.83),('8902','2014-03-18','16:15:00',3.62),('8902','2014-03-18','16:20:00',3.43),('8902','2014-03-18','16:25:00',3.13),('8902','2014-03-18','16:30:00',2.92),('8902','2014-03-18','16:35:00',2.59),('8902','2014-03-18','16:40:00',2.43),('8902','2014-03-18','16:45:00',2.35),('8902','2014-03-18','16:50:00',1.97),('8902','2014-03-18','16:55:00',1.8),('8902','2014-03-18','17:00:00',1.4),('8902','2014-03-18','17:05:00',1.16),('8902','2014-03-18','17:15:00',1.08),('8902','2013-01-10','09:35:00',1.01),('8902','2013-01-10','09:40:00',1.03),('8902','2013-01-10','09:45:00',1.7),('8902','2013-01-10','09:50:00',2.04),('8902','2013-01-10','09:55:00',1.25),('8902','2013-01-10','10:00:00',2.44),('8902','2013-01-10','10:05:00',2.37),('8902','2013-01-10','10:10:00',2.82),('8902','2013-01-10','10:15:00',2.68),('8902','2013-01-10','10:20:00',2.27),('8902','2013-01-10','10:25:00',4.14),('8902','2013-01-10','10:30:00',4.4),('8902','2013-01-10','10:35:00',4.51),('8902','2013-01-10','10:40:00',4.59),('8902','2013-01-10','10:45:00',4.68),('8902','2013-01-10','10:50:00',4.7),('8902','2013-01-10','10:55:00',4.83),('8902','2013-01-10','11:00:00',4.9),('8902','2013-01-10','11:05:00',4.95),('8902','2013-01-10','11:10:00',4.94),('8902','2013-01-10','11:15:00',4.95),('8902','2013-01-10','11:20:00',4.91),('8902','2013-01-10','11:25:00',3.75),('8902','2013-01-10','11:30:00',1.82),('8902','2013-01-10','11:35:00',3.27),('8902','2013-01-10','11:40:00',2.08),('8902','2013-01-10','11:45:00',3.01),('8902','2013-01-10','11:50:00',2.84),('8902','2013-01-10','11:55:00',2.15),('8902','2013-01-10','12:00:00',1.75),('8902','2013-01-10','12:05:00',1.35),('8902','2013-01-10','12:10:00',1.06),('8902','2013-01-10','12:15:00',1.2),('8902','2013-01-10','12:20:00',1.41),('8902','2013-01-10','12:25:00',1.06),('8902','2013-01-10','12:50:00',1.39),('8902','2013-01-10','12:55:00',3.64),('8902','2013-01-10','13:00:00',3.24),('8902','2013-01-10','13:05:00',2.57),('8902','2013-01-10','13:10:00',3.28),('8902','2013-01-10','13:15:00',2.71),('8902','2013-01-10','13:20:00',1.67),('8902','2013-01-10','13:25:00',1.18),('8902','2013-01-10','13:30:00',2.18),('8902','2013-01-10','13:35:00',4.86),('8902','2013-01-10','13:40:00',3.86),('8902','2013-01-10','13:45:00',3.34),('8902','2013-01-10','13:50:00',1.21),('8902','2013-01-10','14:20:00',2.64),('8902','2013-01-10','14:25:00',2.6),('8902','2013-01-10','14:30:00',1.51),('8902','2013-01-10','14:35:00',1.53),('8902','2013-01-10','14:40:00',1.32),('8902','2013-01-10','14:45:00',2.35),('8902','2013-01-10','14:50:00',3.75),('8902','2013-01-10','14:55:00',2.37),('8902','2013-01-10','15:00:00',3.28),('8902','2013-01-10','15:05:00',3.52),('8902','2013-01-10','15:10:00',1.96),('8902','2013-01-10','15:45:00',1.14),('8902','2013-01-09','10:05:00',1.01),('8902','2013-01-09','11:20:00',1.12),('8902','2013-01-09','11:25:00',1.46),('8902','2013-01-09','11:30:00',1.86),('8902','2013-01-09','11:35:00',1.49),('8902','2013-01-09','11:50:00',1.51),('8902','2013-01-09','11:55:00',2.25),('8902','2013-01-09','12:00:00',2.36),('8902','2013-01-09','12:05:00',2.28),('8902','2013-01-09','12:10:00',2.04),('8902','2013-01-09','12:15:00',1.62),('8902','2013-01-09','12:20:00',1.1),('8902','2013-01-09','13:15:00',1.03),('8902','2013-01-09','13:45:00',1.11),('8902','2013-01-09','13:50:00',1.06),('8902','2013-01-09','13:55:00',1.13),('8902','2013-01-09','14:00:00',1.26),('8902','2013-01-09','14:05:00',1.01),('8902','2013-01-08','09:35:00',1.31),('8902','2013-01-08','09:40:00',1.67),('8902','2013-01-08','09:45:00',1.2),('8902','2013-01-08','09:50:00',1.14),('8902','2013-01-08','09:55:00',1.08),('8902','2013-01-08','10:00:00',1.06),('8902','2013-01-08','10:05:00',1.11),('8902','2013-01-08','10:10:00',1.15),('8902','2013-01-08','10:15:00',1.26),('8902','2013-01-08','10:20:00',1.45),('8902','2013-01-08','10:25:00',1.36),('8902','2013-01-08','10:30:00',1.62),('8902','2013-01-08','10:35:00',1.69),('8902','2013-01-08','10:40:00',1.69),('8902','2013-01-08','10:45:00',2.44),('8902','2013-01-08','10:50:00',2.04),('8902','2013-01-08','10:55:00',3.32),('8902','2013-01-08','11:00:00',1.89),('8902','2013-01-08','11:05:00',1.98),('8902','2013-01-08','11:10:00',2.37),('8902','2013-01-08','11:15:00',5.18),('8902','2013-01-08','11:20:00',4.27),('8902','2013-01-08','11:25:00',2.25),('8902','2013-01-08','11:30:00',2.44),('8902','2013-01-08','11:35:00',2.89),('8902','2013-01-08','11:40:00',2.23),('8902','2013-01-08','11:45:00',2.05),('8902','2013-01-08','11:50:00',2.42),('8902','2013-01-08','11:55:00',3.04),('8902','2013-01-08','12:00:00',3.1),('8902','2013-01-08','12:05:00',2.28),('8902','2013-01-08','12:10:00',2.1),('8902','2013-01-08','12:15:00',2.06),('8902','2013-01-08','12:20:00',2.05),('8902','2013-01-08','12:25:00',1.92),('8902','2013-01-08','12:30:00',1.76),('8902','2013-01-08','12:35:00',1.89),('8902','2013-01-08','12:40:00',1.86),('8902','2013-01-08','12:45:00',1.77),('8902','2013-01-08','12:50:00',1.82),('8902','2013-01-08','12:55:00',2.06),('8902','2013-01-08','13:00:00',2.53),('8902','2013-01-08','13:05:00',3.1),('8902','2013-01-08','13:10:00',4.26),('8902','2013-01-08','13:15:00',2.34),('8902','2013-01-08','13:20:00',2.33),('8902','2013-01-08','13:25:00',1.84),('8902','2013-01-08','13:30:00',1.67),('8902','2013-01-08','13:35:00',1.64),('8902','2013-01-08','13:40:00',1.6),('8902','2013-01-08','13:45:00',1.63),('8902','2013-01-08','13:50:00',1.42),('8902','2013-01-08','13:55:00',1.32),('8902','2013-01-08','14:00:00',1.39),('8902','2013-01-08','14:05:00',1.29),('8902','2013-01-08','14:10:00',1.22),('8902','2013-01-08','14:15:00',1.11),('8902','2013-01-08','14:20:00',1.01),('8902','2013-01-07','08:30:00',1.17),('8902','2013-01-07','08:35:00',1.69),('8902','2013-01-07','08:40:00',1.8),('8902','2013-01-07','08:45:00',2.14),('8902','2013-01-07','08:50:00',2.39),('8902','2013-01-07','08:55:00',2.67),('8902','2013-01-07','09:00:00',2.84),('8902','2013-01-07','09:05:00',2.85),('8902','2013-01-07','09:10:00',1.86),('8902','2013-01-07','09:15:00',2.37),('8902','2013-01-07','09:20:00',2.94),('8902','2013-01-07','09:25:00',3.14),('8902','2013-01-07','09:30:00',2.9),('8902','2013-01-07','09:35:00',2.22),('8902','2013-01-07','09:40:00',3.4),('8902','2013-01-07','09:45:00',3.95),('8902','2013-01-07','09:50:00',4.17),('8902','2013-01-07','09:55:00',4.09),('8902','2013-01-07','10:00:00',3.75),('8902','2013-01-07','10:05:00',3.71),('8902','2013-01-07','10:10:00',3.81),('8902','2013-01-07','10:15:00',3.95),('8902','2013-01-07','10:20:00',3.71),('8902','2013-01-07','10:25:00',4.05),('8902','2013-01-07','10:30:00',4.05),('8902','2013-01-07','10:35:00',4.36),('8902','2013-01-07','10:40:00',4.68),('8902','2013-01-07','10:45:00',4.58),('8902','2013-01-07','10:50:00',4.75),('8902','2013-01-07','10:55:00',4.81),('8902','2013-01-07','11:00:00',4.75),('8902','2013-01-07','11:05:00',4.94),('8902','2013-01-07','11:10:00',5.01),('8902','2013-01-07','11:15:00',5.04),('8902','2013-01-07','11:20:00',5.07),('8902','2013-01-07','11:25:00',5.1),('8902','2013-01-07','11:30:00',5.19),('8902','2013-01-07','11:35:00',5.22),('8902','2013-01-07','11:40:00',5.07),('8902','2013-01-07','11:45:00',6.1),('8902','2013-01-07','11:50:00',4.74),('8902','2013-01-07','11:55:00',3.41),('8902','2013-01-07','12:00:00',3),('8902','2013-01-07','12:05:00',2.89),('8902','2013-01-07','12:10:00',3.03),('8902','2013-01-07','12:15:00',2.79),('8902','2013-01-07','12:20:00',2.48),('8902','2013-01-07','12:25:00',2.43),('8902','2013-01-07','12:30:00',2.34),('8902','2013-01-07','12:35:00',2.29),('8902','2013-01-07','12:40:00',2.91),('8902','2013-01-07','12:45:00',3.43),('8902','2013-01-07','12:50:00',4.57),('8902','2013-01-07','12:55:00',3.99),('8902','2013-01-07','13:00:00',1.74),('8902','2013-01-07','13:05:00',1.54),('8902','2013-01-07','13:10:00',1.7),('8902','2013-01-07','13:15:00',1.72),('8902','2013-01-07','13:20:00',2.81),('8902','2013-01-07','13:25:00',1.91),('8902','2013-01-07','13:30:00',1.62),('8902','2013-01-07','13:35:00',1.41),('8902','2013-01-07','13:40:00',1.77),('8902','2013-01-07','13:45:00',1.91),('8902','2013-01-07','13:50:00',2.49),('8902','2013-01-07','13:55:00',2.51),('8902','2013-01-07','14:00:00',2.02),('8902','2013-01-07','14:05:00',2.32),('8902','2013-01-07','14:10:00',1.52),('8902','2013-01-07','14:15:00',1.52),('8902','2013-01-07','14:20:00',1.44),('8902','2013-01-07','14:25:00',1.53),('8902','2013-01-07','14:30:00',1.68),('8902','2013-01-07','14:35:00',1.66),('8902','2013-01-07','14:40:00',1.86),('8902','2013-01-07','14:45:00',1.42),('8902','2013-01-07','14:50:00',1.13),('8902','2013-01-07','14:55:00',1.12),('8902','2013-01-07','15:05:00',1.07),('8902','2013-01-07','15:10:00',1.54),('8902','2013-01-07','15:15:00',1.74),('8902','2013-01-07','15:20:00',1.81),('8902','2013-01-07','15:25:00',1.09),('8902','2013-01-07','15:30:00',1.06),('8902','2013-01-07','15:35:00',1.23),('8902','2013-01-07','15:40:00',1.23),('8902','2013-01-07','15:45:00',1.41),('8902','2013-01-06','08:35:00',1.06),('8902','2013-01-06','08:40:00',1.18),('8902','2013-01-06','08:45:00',1.39),('8902','2013-01-06','08:50:00',1.73),('8902','2013-01-06','08:55:00',1.98),('8902','2013-01-06','09:00:00',2.06),('8902','2013-01-06','09:05:00',1.88),('8902','2013-01-06','09:10:00',2.12),('8902','2013-01-06','09:15:00',1.67),('8902','2013-01-06','09:20:00',2.55),('8902','2013-01-06','09:25:00',2.87),('8902','2013-01-06','09:30:00',2.95),('8902','2013-01-06','09:35:00',3.06),('8902','2013-01-06','09:40:00',3.2),('8902','2013-01-06','09:45:00',3.37),('8902','2013-01-06','09:50:00',3.55),('8902','2013-01-06','09:55:00',3.62),('8902','2013-01-06','10:00:00',3.71),('8902','2013-01-06','10:05:00',3.97),('8902','2013-01-06','10:10:00',4.11),('8902','2013-01-06','10:15:00',4.24),('8902','2013-01-06','10:20:00',4.27),('8902','2013-01-06','10:25:00',4.32),('8902','2013-01-06','10:30:00',4.42),('8902','2013-01-06','10:35:00',4.5),('8902','2013-01-06','10:40:00',4.57),('8902','2013-01-06','10:45:00',4.64),('8902','2013-01-06','10:50:00',4.66),('8902','2013-01-06','10:55:00',4.58),('8902','2013-01-06','11:00:00',4.65),('8902','2013-01-06','11:05:00',4.75),('8902','2013-01-06','11:10:00',4.81),('8902','2013-01-06','11:15:00',4.94),('8902','2013-01-06','11:20:00',5.02),('8902','2013-01-06','11:25:00',5.07),('8902','2013-01-06','11:30:00',5.13),('8902','2013-01-06','11:35:00',5.18),('8902','2013-01-06','11:40:00',5.19),('8902','2013-01-06','11:45:00',5.21),('8902','2013-01-06','11:50:00',5.26),('8902','2013-01-06','11:55:00',5.27),('8902','2013-01-06','12:00:00',5.32),('8902','2013-01-06','12:05:00',5.4),('8902','2013-01-06','12:10:00',5.37),('8902','2013-01-06','12:15:00',5.38),('8902','2013-01-06','12:20:00',5.38),('8902','2013-01-06','12:25:00',5.37),('8902','2013-01-06','12:30:00',5.37),('8902','2013-01-06','12:35:00',5.34),('8902','2013-01-06','12:40:00',5.27),('8902','2013-01-06','12:45:00',5.26),('8902','2013-01-06','12:50:00',5.25),('8902','2013-01-06','12:55:00',5.23),('8902','2013-01-06','13:00:00',5.21),('8902','2013-01-06','13:05:00',5.16),('8902','2013-01-06','13:10:00',5.08),('8902','2013-01-06','13:15:00',5.03),('8902','2013-01-06','13:20:00',4.96),('8902','2013-01-06','13:25:00',4.92),('8902','2013-01-06','13:30:00',4.92),('8902','2013-01-06','13:35:00',4.87),('8902','2013-01-06','13:40:00',4.77),('8902','2013-01-06','13:45:00',4.74),('8902','2013-01-06','13:50:00',4.63),('8902','2013-01-06','13:55:00',4.59),('8902','2013-01-06','14:00:00',4.53),('8902','2013-01-06','14:05:00',4.44),('8902','2013-01-06','14:10:00',4.37),('8902','2013-01-06','14:15:00',4.29),('8902','2013-01-06','14:20:00',4.25),('8902','2013-01-06','14:25:00',4.13),('8902','2013-01-06','14:30:00',3.98),('8902','2013-01-06','14:35:00',3.92),('8902','2013-01-06','14:40:00',3.82),('8902','2013-01-06','14:45:00',3.64),('8902','2013-01-06','14:50:00',3.56),('8902','2013-01-06','14:55:00',3.4),('8902','2013-01-06','15:00:00',3.2),('8902','2013-01-06','15:05:00',3.11),('8902','2013-01-06','15:10:00',2.92),('8902','2013-01-06','15:15:00',2.87),('8902','2013-01-06','15:20:00',2.86),('8902','2013-01-06','15:25:00',2.75),('8902','2013-01-06','15:30:00',2.64),('8902','2013-01-06','15:35:00',2.5),('8902','2013-01-06','15:40:00',2.31),('8902','2013-01-06','15:45:00',2.13),('8902','2013-01-06','15:50:00',1.94),('8902','2013-01-06','15:55:00',1.75),('8902','2013-01-06','16:00:00',1.58),('8902','2013-01-06','16:05:00',1.4),('8902','2013-01-06','16:10:00',1.22),('8902','2013-01-06','16:15:00',1.04),('8902','2013-01-05','08:35:00',1.17),('8902','2013-01-05','08:40:00',1.47),('8902','2013-01-05','08:45:00',1.67),('8902','2013-01-05','08:50:00',1.88),('8902','2013-01-05','08:55:00',2.06),('8902','2013-01-05','09:00:00',2.21),('8902','2013-01-05','09:05:00',2.36),('8902','2013-01-05','09:10:00',2.51),('8902','2013-01-05','09:15:00',2.64),('8902','2013-01-05','09:20:00',2.8),('8902','2013-01-05','09:25:00',2.95),('8902','2013-01-05','09:30:00',3.08),('8902','2013-01-05','09:35:00',3.21),('8902','2013-01-05','09:40:00',3.35),('8902','2013-01-05','09:45:00',3.47),('8902','2013-01-05','09:50:00',3.63),('8902','2013-01-05','09:55:00',3.73),('8902','2013-01-05','10:00:00',3.87),('8902','2013-01-05','10:05:00',3.99),('8902','2013-01-05','10:10:00',4.12),('8902','2013-01-05','10:15:00',4.23),('8902','2013-01-05','10:20:00',4.31),('8902','2013-01-05','10:25:00',4.45),('8902','2013-01-05','10:30:00',4.49),('8902','2013-01-05','10:35:00',4.59),('8902','2013-01-05','10:40:00',4.69),('8902','2013-01-05','10:45:00',4.76),('8902','2013-01-05','10:50:00',4.8),('8902','2013-01-05','10:55:00',4.89),('8902','2013-01-05','11:00:00',4.93),('8902','2013-01-05','11:05:00',4.98),('8902','2013-01-05','11:10:00',5.03),('8902','2013-01-05','11:15:00',5.09),('8902','2013-01-05','11:20:00',5.14),('8902','2013-01-05','11:25:00',5.18),('8902','2013-01-05','11:30:00',5.24),('8902','2013-01-05','11:35:00',5.25),('8902','2013-01-05','11:40:00',5.27),('8902','2013-01-05','11:45:00',5.3),('8902','2013-01-05','11:50:00',5.33),('8902','2013-01-05','11:55:00',5.36),('8902','2013-01-05','12:00:00',5.38),('8902','2013-01-05','12:05:00',5.4),('8902','2013-01-05','12:10:00',5.41),('8902','2013-01-05','12:15:00',5.39),('8902','2013-01-05','12:20:00',5.36),('8902','2013-01-05','12:25:00',5.27),('8902','2013-01-05','12:30:00',5.29),('8902','2013-01-05','12:35:00',5.3),('8902','2013-01-05','12:40:00',5.14),('8902','2013-01-05','12:45:00',5.28),('8902','2013-01-05','12:50:00',5.28),('8902','2013-01-05','12:55:00',5.32),('8902','2013-01-05','13:00:00',5.33),('8902','2013-01-05','13:05:00',5.27),('8902','2013-01-05','13:10:00',5.24),('8902','2013-01-05','13:15:00',5.2),('8902','2013-01-05','13:20:00',5.17),('8902','2013-01-05','13:25:00',5.1),('8902','2013-01-05','13:30:00',5.06),('8902','2013-01-05','13:35:00',5.05),('8902','2013-01-05','13:40:00',4.99),('8902','2013-01-05','13:45:00',4.94),('8902','2013-01-05','13:50:00',4.81),('8902','2013-01-05','13:55:00',4.72),('8902','2013-01-05','14:00:00',4.71),('8902','2013-01-05','14:05:00',4.22),('8902','2013-01-05','14:10:00',3.76),('8902','2013-01-05','14:15:00',3.16),('8902','2013-01-05','14:20:00',3.74),('8902','2013-01-05','14:25:00',3.93),('8902','2013-01-05','14:30:00',3.98),('8902','2013-01-05','14:35:00',3.87),('8902','2013-01-05','14:40:00',3.68),('8902','2013-01-05','14:45:00',3.53),('8902','2013-01-05','14:50:00',3.38),('8902','2013-01-05','14:55:00',3.24),('8902','2013-01-05','15:00:00',3.1),('8902','2013-01-05','15:05:00',2.91),('8902','2013-01-05','15:10:00',2.74),('8902','2013-01-05','15:15:00',2.68),('8902','2013-01-05','15:20:00',2.53),('8902','2013-01-05','15:25:00',2.39),('8902','2013-01-05','15:30:00',2.28),('8902','2013-01-05','15:35:00',2.1),('8902','2013-01-05','15:40:00',1.91),('8902','2013-01-05','15:45:00',1.77),('8902','2013-01-05','15:50:00',1.62),('8902','2013-01-05','15:55:00',1.47),('8902','2013-01-05','16:00:00',1.33),('8902','2013-01-05','16:05:00',1.16),('8902','2013-01-05','16:10:00',1.01),('8902','2013-01-04','08:45:00',1.06),('8902','2013-01-04','09:00:00',1),('8902','2013-01-04','09:05:00',1.15),('8902','2013-01-04','09:10:00',1.22),('8902','2013-01-04','09:15:00',1.19),('8902','2013-01-04','09:20:00',1.14),('8902','2013-01-04','09:25:00',1.24),('8902','2013-01-04','09:30:00',1.23),('8902','2013-01-04','09:35:00',1.35),('8902','2013-01-04','09:40:00',1.39),('8902','2013-01-04','09:45:00',1.37),('8902','2013-01-04','09:50:00',1.33),('8902','2013-01-04','09:55:00',1.4),('8902','2013-01-04','10:00:00',1.56),('8902','2013-01-04','10:05:00',1.85),('8902','2013-01-04','10:10:00',2.14),('8902','2013-01-04','10:15:00',2.23),('8902','2013-01-04','10:20:00',2.11),('8902','2013-01-04','10:25:00',1.74),('8902','2013-01-04','10:30:00',1.8),('8902','2013-01-04','10:35:00',2.05),('8902','2013-01-04','10:40:00',2.2),('8902','2013-01-04','10:45:00',2.15),('8902','2013-01-04','10:50:00',2.34),('8902','2013-01-04','10:55:00',3.94),('8902','2013-01-04','11:00:00',3.38),('8902','2013-01-04','11:05:00',3.89),('8902','2013-01-04','11:10:00',3.94),('8902','2013-01-04','11:15:00',3.15),('8902','2013-01-04','11:20:00',3.24),('8902','2013-01-04','11:25:00',3.28),('8902','2013-01-04','11:30:00',3.28),('8902','2013-01-04','11:35:00',3.08),('8902','2013-01-04','11:40:00',2.73),('8902','2013-01-04','11:45:00',2.76),('8902','2013-01-04','11:50:00',2.39),('8902','2013-01-04','11:55:00',2.17),('8902','2013-01-04','12:00:00',2.02),('8902','2013-01-04','12:05:00',1.97),('8902','2013-01-04','12:10:00',1.93),('8902','2013-01-04','12:15:00',1.99),('8902','2013-01-04','12:20:00',1.74),('8902','2013-01-04','12:25:00',1.46),('8902','2013-01-04','12:30:00',1.56),('8902','2013-01-04','12:35:00',2.18),('8902','2013-01-04','12:40:00',2.61),('8902','2013-01-04','12:45:00',3),('8902','2013-01-04','12:50:00',1.9),('8902','2013-01-04','12:55:00',2.15),('8902','2013-01-04','13:00:00',2.51),('8902','2013-01-04','13:05:00',2.27),('8902','2013-01-04','13:10:00',2.22),('8902','2013-01-04','13:15:00',2.07),('8902','2013-01-04','13:20:00',2.1),('8902','2013-01-04','13:25:00',2),('8902','2013-01-04','13:30:00',3.58),('8902','2013-01-04','13:35:00',3.38),('8902','2013-01-04','13:40:00',2.29),('8902','2013-01-04','13:45:00',1.84),('8902','2013-01-04','13:50:00',1.99),('8902','2013-01-04','13:55:00',2.26),('8902','2013-01-04','14:00:00',2.13),('8902','2013-01-04','14:05:00',3.29),('8902','2013-01-04','14:10:00',2.97),('8902','2013-01-04','14:15:00',2.32),('8902','2013-01-04','14:20:00',2.14),('8902','2013-01-04','14:25:00',1.46),('8902','2013-01-04','14:30:00',2.44),('8902','2013-01-04','14:35:00',2.39),('8902','2013-01-04','14:40:00',2.65),('8902','2013-01-04','14:45:00',2.74),('8902','2013-01-04','14:50:00',1.9),('8902','2013-01-04','14:55:00',1.25),('8902','2013-01-04','15:00:00',2.34),('8902','2013-01-04','15:05:00',1.94),('8902','2013-01-04','15:40:00',1.02),('8902','2013-01-03','08:40:00',1.15),('8902','2013-01-03','08:45:00',1.57),('8902','2013-01-03','08:50:00',1.92),('8902','2013-01-03','08:55:00',2),('8902','2013-01-03','09:00:00',2.08),('8902','2013-01-03','09:05:00',2.23),('8902','2013-01-03','09:10:00',2.4),('8902','2013-01-03','09:15:00',1.9),('8902','2013-01-03','09:20:00',2.46),('8902','2013-01-03','09:25:00',2.31),('8902','2013-01-03','09:30:00',2.24),('8902','2013-01-03','09:35:00',2.12),('8902','2013-01-03','09:40:00',2.28),('8902','2013-01-03','09:45:00',2.43),('8902','2013-01-03','09:50:00',2.55),('8902','2013-01-03','09:55:00',3.4),('8902','2013-01-03','10:00:00',4.07),('8902','2013-01-03','10:05:00',4.18),('8902','2013-01-03','10:10:00',3.58),('8902','2013-01-03','10:15:00',4.25),('8902','2013-01-03','10:20:00',3.54),('8902','2013-01-03','10:25:00',4.27),('8902','2013-01-03','10:30:00',4.53),('8902','2013-01-03','10:35:00',4.58),('8902','2013-01-03','10:40:00',4.74),('8902','2013-01-03','10:45:00',4.98),('8902','2013-01-03','10:50:00',5.2),('8902','2013-01-03','10:55:00',5.3),('8902','2013-01-03','11:00:00',4.69),('8902','2013-01-03','11:05:00',2.83),('8902','2013-01-03','11:10:00',1.76),('8902','2013-01-03','11:15:00',1.89),('8902','2013-01-03','11:20:00',2.47),('8902','2013-01-03','11:25:00',1.76),('8902','2013-01-03','11:30:00',1.89),('8902','2013-01-03','11:35:00',2.97),('8902','2013-01-03','11:40:00',2.26),('8902','2013-01-03','11:45:00',3.42),('8902','2013-01-03','11:50:00',5.17),('8902','2013-01-03','11:55:00',5.92),('8902','2013-01-03','12:00:00',6.05),('8902','2013-01-03','12:05:00',5.21),('8902','2013-01-03','12:10:00',4.22),('8902','2013-01-03','12:15:00',2.69),('8902','2013-01-03','12:20:00',2.24),('8902','2013-01-03','12:25:00',2.87),('8902','2013-01-03','12:30:00',3.8),('8902','2013-01-03','12:35:00',3.71),('8902','2013-01-03','12:40:00',5.11),('8902','2013-01-03','12:45:00',5.58),('8902','2013-01-03','12:50:00',5.61),('8902','2013-01-03','12:55:00',5.56),('8902','2013-01-03','13:00:00',5.41),('8902','2013-01-03','13:05:00',5.17),('8902','2013-01-03','13:10:00',5.14),('8902','2013-01-03','13:15:00',4.37),('8902','2013-01-03','13:20:00',5.01),('8902','2013-01-03','13:25:00',4.89),('8902','2013-01-03','13:30:00',4.84),('8902','2013-01-03','13:35:00',4.69),('8902','2013-01-03','13:40:00',4.61),('8902','2013-01-03','13:45:00',4.48),('8902','2013-01-03','13:50:00',4.39),('8902','2013-01-03','13:55:00',4.35),('8902','2013-01-03','14:00:00',4.21),('8902','2013-01-03','14:05:00',4.2),('8902','2013-01-03','14:10:00',4.1),('8902','2013-01-03','14:15:00',4),('8902','2013-01-03','14:20:00',3.91),('8902','2013-01-03','14:25:00',3.81),('8902','2013-01-03','14:30:00',3.73),('8902','2013-01-03','14:35:00',3.63),('8902','2013-01-03','14:40:00',3.57),('8902','2013-01-03','14:45:00',3.42),('8902','2013-01-03','14:50:00',3.16),('8902','2013-01-03','14:55:00',3.08),('8902','2013-01-03','15:00:00',3.01),('8902','2013-01-03','15:05:00',2.74),('8902','2013-01-03','15:10:00',2.47),('8902','2013-01-03','15:15:00',2.5),('8902','2013-01-03','15:20:00',2.37),('8902','2013-01-03','15:25:00',2.27),('8902','2013-01-03','15:30:00',2.1),('8902','2013-01-03','15:35:00',1.95),('8902','2013-01-03','15:40:00',1.83),('8902','2013-01-03','15:45:00',1.73),('8902','2013-01-02','08:35:00',1.08),('8902','2013-01-02','08:40:00',1.39),('8902','2013-01-02','08:45:00',1.6),('8902','2013-01-02','08:50:00',1.77),('8902','2013-01-02','08:55:00',1.93),('8902','2013-01-02','09:00:00',2.14),('8902','2013-01-02','09:05:00',2.32),('8902','2013-01-02','09:10:00',2.49),('8902','2013-01-02','09:15:00',2.65),('8902','2013-01-02','09:20:00',2.82),('8902','2013-01-02','09:25:00',2.97),('8902','2013-01-02','09:30:00',3.11),('8902','2013-01-02','09:35:00',3.26),('8902','2013-01-02','09:40:00',3.51),('8902','2013-01-02','09:45:00',3.79),('8902','2013-01-02','09:50:00',4.11),('8902','2013-01-02','09:55:00',4.41),('8902','2013-01-02','10:00:00',4.65),('8902','2013-01-02','10:05:00',4.59),('8902','2013-01-02','10:10:00',4.56),('8902','2013-01-02','10:15:00',4.98),('8902','2013-01-02','10:20:00',4.09),('8902','2013-01-02','10:25:00',4.49),('8902','2013-01-02','10:30:00',3.81),('8902','2013-01-02','10:35:00',3.64),('8902','2013-01-02','10:40:00',3.52),('8902','2013-01-02','10:45:00',3.13),('8902','2013-01-02','10:50:00',3.26),('8902','2013-01-02','10:55:00',2.94),('8902','2013-01-02','11:00:00',3.23),('8902','2013-01-02','11:05:00',3.1),('8902','2013-01-02','11:10:00',2.94),('8902','2013-01-02','11:15:00',2.76),('8902','2013-01-02','11:20:00',2.59),('8902','2013-01-02','11:25:00',2.55),('8902','2013-01-02','11:30:00',2.42),('8902','2013-01-02','11:35:00',2.98),('8902','2013-01-02','11:40:00',5.77),('8902','2013-01-02','11:45:00',5.66),('8902','2013-01-02','11:50:00',5.56),('8902','2013-01-02','11:55:00',5.48),('8902','2013-01-02','12:00:00',5.44),('8902','2013-01-02','12:05:00',5.43),('8902','2013-01-02','12:10:00',5.43),('8902','2013-01-02','12:15:00',5.43),('8902','2013-01-02','12:20:00',5.44),('8902','2013-01-02','12:25:00',5.43),('8902','2013-01-02','12:30:00',5.42),('8902','2013-01-02','12:35:00',5.44),('8902','2013-01-02','12:40:00',5.41),('8902','2013-01-02','12:45:00',5.39),('8902','2013-01-02','12:50:00',5.34),('8902','2013-01-02','12:55:00',5.3),('8902','2013-01-02','13:00:00',5.29),('8902','2013-01-02','13:05:00',5.24),('8902','2013-01-02','13:10:00',5.2),('8902','2013-01-02','13:15:00',5.13),('8902','2013-01-02','13:20:00',5.11),('8902','2013-01-02','13:25:00',5.06),('8902','2013-01-02','13:30:00',4.98),('8902','2013-01-02','13:35:00',4.96),('8902','2013-01-02','13:40:00',4.89),('8902','2013-01-02','13:45:00',4.8),('8902','2013-01-02','13:50:00',4.72),('8902','2013-01-02','13:55:00',4.67),('8902','2013-01-02','14:00:00',4.6),('8902','2013-01-02','14:05:00',4.51),('8902','2013-01-02','14:10:00',4.45),('8902','2013-01-02','14:15:00',4.37),('8902','2013-01-02','14:20:00',4.27),('8902','2013-01-02','14:25:00',4.18),('8902','2013-01-02','14:30:00',4.07),('8902','2013-01-02','14:35:00',3.96),('8902','2013-01-02','14:40:00',3.85),('8902','2013-01-02','14:45:00',3.72),('8902','2013-01-02','14:50:00',3.59),('8902','2013-01-02','14:55:00',3.46),('8902','2013-01-02','15:00:00',3.31),('8902','2013-01-02','15:05:00',3.11),('8902','2013-01-02','15:10:00',2.93),('8902','2013-01-02','15:15:00',2.73),('8902','2013-01-02','15:20:00',2.44),('8902','2013-01-02','15:25:00',2.41),('8902','2013-01-02','15:30:00',2.34),('8902','2013-01-02','15:35:00',2.18),('8902','2013-01-02','15:40:00',1.95),('8902','2013-01-02','15:45:00',1.87),('8902','2013-01-02','15:50:00',1.69),('8902','2013-01-02','15:55:00',1.52),('8902','2013-01-02','16:00:00',1.3),('8902','2013-01-02','16:05:00',1.15),('8902','2013-01-01','09:40:00',1.14),('8902','2013-01-01','09:45:00',1.26),('8902','2013-01-01','09:50:00',1.13),('8902','2013-01-01','09:55:00',1.08),('8902','2013-01-01','10:00:00',1.23),('8902','2013-01-01','10:05:00',1.19),('8902','2013-01-01','11:10:00',1.05),('8902','2013-01-01','13:40:00',1.53),('8902','2013-01-01','13:45:00',1.71),('8902','2013-01-01','13:50:00',1.74),('8902','2013-01-01','13:55:00',1.41),('8902','2013-01-01','14:00:00',1.24),('8902','2014-03-17','07:40:00',1.01),('8902','2014-03-17','07:45:00',1.14),('8902','2014-03-17','07:50:00',1.6),('8902','2014-03-17','07:55:00',2.43),('8902','2014-03-17','08:00:00',2.04),('8902','2014-03-17','08:05:00',1.73),('8902','2014-03-17','08:10:00',1.54),('8902','2014-03-17','08:15:00',1.69),('8902','2014-03-17','08:20:00',2.06),('8902','2014-03-17','08:25:00',1.84),('8902','2014-03-17','08:30:00',1.66),('8902','2014-03-17','08:35:00',1.5),('8902','2014-03-17','08:40:00',1.5),('8902','2014-03-17','08:45:00',1.61),('8902','2014-03-17','08:50:00',2.56),('8902','2014-03-17','08:55:00',4.35),('8902','2014-03-17','09:00:00',4.62),('8902','2014-03-17','09:05:00',2.54),('8902','2014-03-17','09:10:00',2.67),('8902','2014-03-17','09:15:00',4.43),('8902','2014-03-17','09:20:00',6.03),('8902','2014-03-17','09:25:00',5.85),('8902','2014-03-17','09:30:00',2.72),('8902','2014-03-17','09:35:00',2.48),('8902','2014-03-17','09:40:00',2.76),('8902','2014-03-17','09:45:00',2.79),('8902','2014-03-17','09:50:00',3.58),('8902','2014-03-17','09:55:00',4.01),('8902','2014-03-17','10:00:00',4.61),('8902','2014-03-17','10:05:00',5.62),('8902','2014-03-17','10:10:00',6.81),('8902','2014-03-17','10:15:00',6.48),('8902','2014-03-17','10:20:00',6.18),('8902','2014-03-17','10:25:00',8.1),('8902','2014-03-17','10:30:00',6.5),('8902','2014-03-17','10:35:00',6.46),('8902','2014-03-17','10:40:00',8.24),('8902','2014-03-17','10:45:00',5.75),('8902','2014-03-17','10:50:00',6.95),('8902','2014-03-17','10:55:00',4.14),('8902','2014-03-17','11:00:00',6.74),('8902','2014-03-17','11:05:00',5.85),('8902','2014-03-17','11:10:00',6.06),('8902','2014-03-17','11:15:00',3.27),('8902','2014-03-17','11:20:00',3.21),('8902','2014-03-17','11:25:00',3.3),('8902','2014-03-17','11:30:00',4.18),('8902','2014-03-17','11:35:00',7.45),('8902','2014-03-17','11:40:00',5.77),('8902','2014-03-17','11:45:00',4.62),('8902','2014-03-17','11:50:00',4.18),('8902','2014-03-17','11:55:00',3.51),('8902','2014-03-17','12:00:00',3.33),('8902','2014-03-17','12:05:00',3.08),('8902','2014-03-17','12:10:00',3.41),('8902','2014-03-17','12:15:00',3.64),('8902','2014-03-17','12:20:00',5.28),('8902','2014-03-17','12:25:00',4.85),('8902','2014-03-17','12:30:00',3.12),('8902','2014-03-17','12:35:00',6.51),('8902','2014-03-17','12:40:00',7.36),('8902','2014-03-17','12:45:00',5.16),('8902','2014-03-17','12:50:00',5.31),('8902','2014-03-17','12:55:00',5.78),('8902','2014-03-17','13:00:00',7.64),('8902','2014-03-17','13:05:00',8.07),('8902','2014-03-17','13:10:00',7.79),('8902','2014-03-17','13:15:00',7.69),('8902','2014-03-17','13:20:00',7.61),('8902','2014-03-17','13:25:00',7.38),('8902','2014-03-17','13:30:00',7.02),('8902','2014-03-17','13:35:00',7.17),('8902','2014-03-17','13:40:00',7.24),('8902','2014-03-17','13:45:00',7.26),('8902','2014-03-17','13:50:00',7.11),('8902','2014-03-17','13:55:00',7.07),('8902','2014-03-17','14:00:00',7.03),('8902','2014-03-17','14:05:00',6.9),('8902','2014-03-17','14:10:00',6.94),('8902','2014-03-17','14:15:00',6.85),('8902','2014-03-17','14:20:00',6.78),('8902','2014-03-17','14:25:00',6.71),('8902','2014-03-17','14:30:00',6.63),('8902','2014-03-17','14:35:00',6.53),('8902','2014-03-17','14:40:00',6.4),('8902','2014-03-17','14:45:00',6.27),('8902','2014-03-17','14:50:00',6.22),('8902','2014-03-17','14:55:00',6.14),('8902','2014-03-17','15:00:00',5.98),('8902','2014-03-17','15:05:00',5.78),('8902','2014-03-17','15:10:00',5.68),('8902','2014-03-17','15:15:00',5.58),('8902','2014-03-17','15:20:00',5.49),('8902','2014-03-17','15:25:00',5.3),('8902','2014-03-17','15:30:00',5.11),('8902','2014-03-17','15:35:00',4.99),('8902','2014-03-17','15:40:00',4.83),('8902','2014-03-17','15:45:00',4.62),('8902','2014-03-17','15:50:00',4.41),('8902','2014-03-17','15:55:00',4.24),('8902','2014-03-17','16:00:00',4.16),('8902','2014-03-17','16:05:00',3.99),('8902','2014-03-17','16:10:00',3.83),('8902','2014-03-17','16:15:00',3.67),('8902','2014-03-17','16:20:00',3.48),('8902','2014-03-17','16:25:00',3.26),('8902','2014-03-17','16:30:00',3.1),('8902','2014-03-17','16:35:00',2.88),('8902','2014-03-17','16:40:00',2.67),('8902','2014-03-17','16:45:00',2.47),('8902','2014-03-17','16:50:00',2.26),('8902','2014-03-17','16:55:00',2.02),('8902','2014-03-17','17:00:00',1.87),('8902','2014-03-17','17:05:00',1.71),('8902','2014-03-17','17:10:00',1.5),('8902','2014-03-17','17:15:00',1.28),('8902','2014-03-17','17:20:00',1.09),('8902','2012-12-31','08:35:00',1.1),('8902','2012-12-31','08:40:00',1.23),('8902','2012-12-31','08:45:00',1.51),('8902','2012-12-31','08:50:00',1.77),('8902','2012-12-31','08:55:00',1.93),('8902','2012-12-31','09:00:00',2.1),('8902','2012-12-31','09:05:00',2.27),('8902','2012-12-31','09:10:00',2.41),('8902','2012-12-31','09:15:00',2.55),('8902','2012-12-31','09:20:00',2.72),('8902','2012-12-31','09:25:00',2.84),('8902','2012-12-31','09:30:00',2.94),('8902','2012-12-31','09:35:00',3.06),('8902','2012-12-31','09:40:00',3.19),('8902','2012-12-31','09:45:00',3.34),('8902','2012-12-31','09:50:00',3.46),('8902','2012-12-31','09:55:00',3.55),('8902','2012-12-31','10:00:00',3.63),('8902','2012-12-31','10:05:00',3.75),('8902','2012-12-31','10:10:00',3.86),('8902','2012-12-31','10:15:00',3.95),('8902','2012-12-31','10:20:00',4.05),('8902','2012-12-31','10:25:00',4.15),('8902','2012-12-31','10:30:00',4.29),('8902','2012-12-31','10:35:00',4.36),('8902','2012-12-31','10:40:00',4.5),('8902','2012-12-31','10:45:00',4.37),('8902','2012-12-31','10:50:00',4.53),('8902','2012-12-31','10:55:00',3.31),('8902','2012-12-31','11:00:00',1.53),('8902','2012-12-31','11:05:00',4.45),('8902','2012-12-31','11:10:00',5.21),('8902','2012-12-31','11:15:00',4.81),('8902','2012-12-31','11:20:00',3.47),('8902','2012-12-31','11:25:00',4.75),('8902','2012-12-31','11:30:00',5.18),('8902','2012-12-31','11:35:00',2.79),('8902','2012-12-31','11:40:00',3.69),('8902','2012-12-31','11:45:00',4.86),('8902','2012-12-31','11:50:00',4.83),('8902','2012-12-31','11:55:00',3.89),('8902','2012-12-31','12:00:00',3.14),('8902','2012-12-31','12:05:00',2.28),('8902','2012-12-31','12:10:00',2.45),('8902','2012-12-31','12:15:00',2.67),('8902','2012-12-31','12:20:00',2.37),('8902','2012-12-31','12:25:00',2.28),('8902','2012-12-31','12:30:00',1.98),('8902','2012-12-31','12:35:00',2.01),('8902','2012-12-31','12:40:00',2.22),('8902','2012-12-31','12:45:00',2.49),('8902','2012-12-31','12:50:00',2.17),('8902','2012-12-31','12:55:00',2.3),('8902','2012-12-31','13:00:00',1.8),('8902','2012-12-31','13:05:00',1.91),('8902','2012-12-31','13:10:00',1.5),('8902','2012-12-31','13:15:00',1.39),('8902','2012-12-31','13:20:00',1.56),('8902','2012-12-31','13:25:00',1.37),('8902','2012-12-31','13:30:00',1.17),('8902','2012-12-30','08:25:00',1.03),('8902','2012-12-30','08:30:00',1.18),('8902','2012-12-30','08:35:00',1.3),('8902','2012-12-30','08:45:00',1.16),('8902','2012-12-30','08:50:00',1.21),('8902','2012-12-30','08:55:00',1.32),('8902','2012-12-30','09:00:00',1.51),('8902','2012-12-30','09:05:00',1.97),('8902','2012-12-30','09:10:00',1.91),('8902','2012-12-30','09:15:00',2.43),('8902','2012-12-30','09:20:00',2.9),('8902','2012-12-30','09:25:00',3.21),('8902','2012-12-30','09:30:00',3.18),('8902','2012-12-30','09:35:00',1.11),('8902','2012-12-30','09:40:00',1.2),('8902','2012-12-30','09:55:00',1.25),('8902','2012-12-30','10:00:00',2.42),('8902','2012-12-30','10:05:00',1.64),('8902','2012-12-30','10:10:00',3.13),('8902','2012-12-30','10:15:00',4.27),('8902','2012-12-30','10:20:00',4.62),('8902','2012-12-30','10:25:00',4.63),('8902','2012-12-30','10:30:00',4.69),('8902','2012-12-30','10:35:00',4.77),('8902','2012-12-30','10:40:00',4.85),('8902','2012-12-30','10:45:00',4.82),('8902','2012-12-30','10:50:00',4.8),('8902','2012-12-30','10:55:00',4.93),('8902','2012-12-30','11:00:00',4.98),('8902','2012-12-30','11:05:00',4.99),('8902','2012-12-30','11:10:00',4.85),('8902','2012-12-30','11:15:00',4.93),('8902','2012-12-30','11:20:00',5.15),('8902','2012-12-30','11:25:00',5.21),('8902','2012-12-30','11:30:00',5.31),('8902','2012-12-30','11:35:00',5.37),('8902','2012-12-30','11:40:00',5.41),('8902','2012-12-30','11:45:00',5.41),('8902','2012-12-30','11:50:00',5.43),('8902','2012-12-30','11:55:00',5.49),('8902','2012-12-30','12:00:00',5.55),('8902','2012-12-30','12:05:00',5.6),('8902','2012-12-30','12:10:00',5.61),('8902','2012-12-30','12:15:00',5.62),('8902','2012-12-30','12:20:00',5.63),('8902','2012-12-30','12:25:00',5.61),('8902','2012-12-30','12:30:00',5.57),('8902','2012-12-30','12:35:00',5.57),('8902','2012-12-30','12:40:00',5.54),('8902','2012-12-30','12:45:00',5.52),('8902','2012-12-30','12:50:00',5.49),('8902','2012-12-30','12:55:00',5.48),('8902','2012-12-30','13:00:00',5.44),('8902','2012-12-30','13:05:00',5.41),('8902','2012-12-30','13:10:00',5.37),('8902','2012-12-30','13:15:00',5.29),('8902','2012-12-30','13:20:00',5.25),('8902','2012-12-30','13:25:00',5.21),('8902','2012-12-30','13:30:00',5.15),('8902','2012-12-30','13:35:00',5.04),('8902','2012-12-30','13:40:00',4.98),('8902','2012-12-30','13:45:00',4.94),('8902','2012-12-30','13:50:00',4.83),('8902','2012-12-30','13:55:00',4.74),('8902','2012-12-30','14:00:00',4.59),('8902','2012-12-30','14:05:00',4.5),('8902','2012-12-30','14:10:00',4.46),('8902','2012-12-30','14:15:00',4.39),('8902','2012-12-30','14:20:00',4.26),('8902','2012-12-30','14:25:00',4.13),('8902','2012-12-30','14:30:00',4.02),('8902','2012-12-30','14:35:00',3.95),('8902','2012-12-30','14:40:00',3.83),('8902','2012-12-30','14:45:00',3.7),('8902','2012-12-30','14:50:00',3.56),('8902','2012-12-30','14:55:00',3.4),('8902','2012-12-30','15:00:00',3.26),('8902','2012-12-30','15:05:00',3.12),('8902','2012-12-30','15:10:00',2.87),('8902','2012-12-30','15:15:00',2.72),('8902','2012-12-30','15:20:00',2.61),('8902','2012-12-30','15:25:00',2.48),('8902','2012-12-30','15:30:00',2.33),('8902','2012-12-30','15:35:00',2.17),('8902','2012-12-30','15:40:00',2.03),('8902','2012-12-30','15:45:00',1.84),('8902','2012-12-30','15:50:00',1.62),('8902','2012-12-30','15:55:00',1.4),('8902','2012-12-30','16:00:00',1.22),('8902','2012-12-30','16:05:00',1.05),('8902','2012-12-29','08:30:00',1.06),('8902','2012-12-29','08:35:00',1.21),('8902','2012-12-29','08:40:00',1.56),('8902','2012-12-29','08:45:00',1.77),('8902','2012-12-29','08:50:00',1.92),('8902','2012-12-29','08:55:00',2.07),('8902','2012-12-29','09:00:00',2.23),('8902','2012-12-29','09:05:00',2.4),('8902','2012-12-29','09:10:00',2.56),('8902','2012-12-29','09:15:00',2.7),('8902','2012-12-29','09:20:00',2.83),('8902','2012-12-29','09:25:00',2.95),('8902','2012-12-29','09:30:00',3.1),('8902','2012-12-29','09:35:00',3.25),('8902','2012-12-29','09:40:00',3.4),('8902','2012-12-29','09:45:00',3.5),('8902','2012-12-29','09:50:00',3.61),('8902','2012-12-29','09:55:00',3.75),('8902','2012-12-29','10:00:00',3.89),('8902','2012-12-29','10:05:00',4.03),('8902','2012-12-29','10:10:00',4.16),('8902','2012-12-29','10:15:00',4.24),('8902','2012-12-29','10:20:00',4.33),('8902','2012-12-29','10:25:00',4.44),('8902','2012-12-29','10:30:00',4.53),('8902','2012-12-29','10:35:00',4.63),('8902','2012-12-29','10:40:00',4.69),('8902','2012-12-29','10:45:00',4.8),('8902','2012-12-29','10:50:00',4.87),('8902','2012-12-29','10:55:00',4.92),('8902','2012-12-29','11:00:00',4.98),('8902','2012-12-29','11:05:00',5.04),('8902','2012-12-29','11:10:00',5.08),('8902','2012-12-29','11:15:00',5.15),('8902','2012-12-29','11:20:00',5.16),('8902','2012-12-29','11:25:00',5.21),('8902','2012-12-29','11:30:00',5.29),('8902','2012-12-29','11:35:00',5.31),('8902','2012-12-29','11:40:00',5.34),('8902','2012-12-29','11:45:00',5.37),('8902','2012-12-29','11:50:00',5.39),('8902','2012-12-29','11:55:00',5.4),('8902','2012-12-29','12:00:00',5.43),('8902','2012-12-29','12:05:00',5.42),('8902','2012-12-29','12:10:00',5.42),('8902','2012-12-29','12:15:00',5.44),('8902','2012-12-29','12:20:00',5.42),('8902','2012-12-29','12:25:00',5.41),('8902','2012-12-29','12:30:00',5.43),('8902','2012-12-29','12:35:00',5.39),('8902','2012-12-29','12:40:00',5.33),('8902','2012-12-29','12:45:00',5.3),('8902','2012-12-29','12:50:00',5.23),('8902','2012-12-29','12:55:00',5.22),('8902','2012-12-29','13:00:00',5.29),('8902','2012-12-29','13:05:00',5.32),('8902','2012-12-29','13:10:00',5.27),('8902','2012-12-29','13:15:00',5.26),('8902','2012-12-29','13:20:00',5.2),('8902','2012-12-29','13:25:00',5.13),('8902','2012-12-29','13:30:00',5.1),('8902','2012-12-29','13:35:00',5.05),('8902','2012-12-29','13:40:00',5.01),('8902','2012-12-29','13:45:00',4.93),('8902','2012-12-29','13:50:00',4.87),('8902','2012-12-29','13:55:00',4.78),('8902','2012-12-29','14:00:00',4.72),('8902','2012-12-29','14:05:00',4.65),('8902','2012-12-29','14:10:00',4.52),('8902','2012-12-29','14:15:00',4.44),('8902','2012-12-29','14:20:00',4.34),('8902','2012-12-29','14:25:00',4.22),('8902','2012-12-29','14:30:00',4.1),('8902','2012-12-29','14:35:00',3.97),('8902','2012-12-29','14:40:00',3.86),('8902','2012-12-29','14:45:00',3.72),('8902','2012-12-29','14:50:00',3.58),('8902','2012-12-29','14:55:00',3.44),('8902','2012-12-29','15:00:00',3.28),('8902','2012-12-29','15:05:00',3.1),('8902','2012-12-29','15:10:00',2.91),('8902','2012-12-29','15:15:00',2.77),('8902','2012-12-29','15:20:00',2.61),('8902','2012-12-29','15:25:00',2.47),('8902','2012-12-29','15:30:00',2.32),('8902','2012-12-29','15:35:00',2.16),('8902','2012-12-29','15:40:00',1.96),('8902','2012-12-29','15:45:00',1.5),('8902','2012-12-29','15:50:00',1.6),('8902','2012-12-29','15:55:00',1.45),('8902','2012-12-29','16:00:00',1.29),('8902','2012-12-29','16:05:00',1.11),('8902','2012-12-28','08:30:00',1.02),('8902','2012-12-28','08:35:00',1.22),('8902','2012-12-28','08:40:00',1.57),('8902','2012-12-28','08:45:00',1.78),('8902','2012-12-28','08:50:00',1.95),('8902','2012-12-28','08:55:00',2.1),('8902','2012-12-28','09:00:00',2.21),('8902','2012-12-28','09:05:00',2.37),('8902','2012-12-28','09:10:00',2.55),('8902','2012-12-28','09:15:00',2.7),('8902','2012-12-28','09:20:00',2.88),('8902','2012-12-28','09:25:00',3),('8902','2012-12-28','09:30:00',3.13),('8902','2012-12-28','09:35:00',3.27),('8902','2012-12-28','09:40:00',3.42),('8902','2012-12-28','09:45:00',3.58),('8902','2012-12-28','09:50:00',3.74),('8902','2012-12-28','09:55:00',3.86),('8902','2012-12-28','10:00:00',3.98),('8902','2012-12-28','10:05:00',4.12),('8902','2012-12-28','10:10:00',4.23),('8902','2012-12-28','10:15:00',4.34),('8902','2012-12-28','10:20:00',4.43),('8902','2012-12-28','10:25:00',4.54),('8902','2012-12-28','10:30:00',4.63),('8902','2012-12-28','10:35:00',4.71),('8902','2012-12-28','10:40:00',4.81),('8902','2012-12-28','10:45:00',4.89),('8902','2012-12-28','10:50:00',5),('8902','2012-12-28','10:55:00',5.08),('8902','2012-12-28','11:00:00',5.11),('8902','2012-12-28','11:05:00',5.18),('8902','2012-12-28','11:10:00',5.22),('8902','2012-12-28','11:15:00',5.28),('8902','2012-12-28','11:20:00',5.36),('8902','2012-12-28','11:25:00',5.39),('8902','2012-12-28','11:30:00',5.42),('8902','2012-12-28','11:35:00',5.44),('8902','2012-12-28','11:40:00',5.45),('8902','2012-12-28','11:45:00',5.49),('8902','2012-12-28','11:50:00',5.54),('8902','2012-12-28','11:55:00',5.56),('8902','2012-12-28','12:00:00',5.56),('8902','2012-12-28','12:05:00',5.61),('8902','2012-12-28','12:10:00',5.65),('8902','2012-12-28','12:15:00',5.63),('8902','2012-12-28','12:20:00',5.58),('8902','2012-12-28','12:25:00',5.58),('8902','2012-12-28','12:30:00',5.59),('8902','2012-12-28','12:35:00',5.6),('8902','2012-12-28','12:40:00',5.58),('8902','2012-12-28','12:45:00',5.47),('8902','2012-12-28','12:50:00',5.42),('8902','2012-12-28','12:55:00',5.45),('8902','2012-12-28','13:00:00',5.44),('8902','2012-12-28','13:05:00',5.44),('8902','2012-12-28','13:10:00',5.41),('8902','2012-12-28','13:15:00',5.4),('8902','2012-12-28','13:20:00',5.35),('8902','2012-12-28','13:25:00',5.27),('8902','2012-12-28','13:30:00',5.2),('8902','2012-12-28','13:35:00',5.16),('8902','2012-12-28','13:40:00',5.1),('8902','2012-12-28','13:45:00',5.04),('8902','2012-12-28','13:50:00',4.97),('8902','2012-12-28','13:55:00',4.9),('8902','2012-12-28','14:00:00',4.83),('8902','2012-12-28','14:05:00',4.7),('8902','2012-12-28','14:10:00',4.62),('8902','2012-12-28','14:15:00',4.54),('8902','2012-12-28','14:20:00',4.44),('8902','2012-12-28','14:25:00',4.32),('8902','2012-12-28','14:30:00',4.2),('8902','2012-12-28','14:35:00',4.07),('8902','2012-12-28','14:40:00',3.95),('8902','2012-12-28','14:45:00',3.84),('8902','2012-12-28','14:50:00',3.72),('8902','2012-12-28','14:55:00',3.59),('8902','2012-12-28','15:00:00',3.45),('8902','2012-12-28','15:05:00',3.29),('8902','2012-12-28','15:10:00',3.08),('8902','2012-12-28','15:15:00',2.95),('8902','2012-12-28','15:20:00',2.78),('8902','2012-12-28','15:25:00',2.62),('8902','2012-12-28','15:30:00',2.45),('8902','2012-12-28','15:35:00',2.26),('8902','2012-12-28','15:40:00',2.07),('8902','2012-12-28','15:45:00',1.85),('8902','2012-12-28','15:50:00',1.7),('8902','2012-12-28','15:55:00',1.51),('8902','2012-12-28','16:00:00',1.34),('8902','2012-12-28','16:05:00',1.16),('8902','2012-12-27','08:40:00',1.22),('8902','2012-12-27','08:45:00',1.5),('8902','2012-12-27','08:50:00',1.68),('8902','2012-12-27','08:55:00',1.86),('8902','2012-12-27','09:00:00',2.05),('8902','2012-12-27','09:05:00',2.23),('8902','2012-12-27','09:10:00',2.38),('8902','2012-12-27','09:15:00',2.55),('8902','2012-12-27','09:20:00',2.65),('8902','2012-12-27','09:25:00',2.74),('8902','2012-12-27','09:30:00',2.88),('8902','2012-12-27','09:35:00',3.02),('8902','2012-12-27','09:40:00',3.13),('8902','2012-12-27','09:45:00',3.26),('8902','2012-12-27','09:50:00',3.29),('8902','2012-12-27','09:55:00',3.49),('8902','2012-12-27','10:00:00',3.57),('8902','2012-12-27','10:05:00',3.73),('8902','2012-12-27','10:10:00',3.89),('8902','2012-12-27','10:15:00',4.05),('8902','2012-12-27','10:20:00',4.14),('8902','2012-12-27','10:25:00',4.25),('8902','2012-12-27','10:30:00',4.33),('8902','2012-12-27','10:35:00',4.49),('8902','2012-12-27','10:40:00',4.51),('8902','2012-12-27','10:45:00',4.6),('8902','2012-12-27','10:50:00',4.66),('8902','2012-12-27','10:55:00',4.71),('8902','2012-12-27','11:00:00',4.67),('8902','2012-12-27','11:05:00',4.91),('8902','2012-12-27','11:10:00',5.02),('8902','2012-12-27','11:15:00',4.94),('8902','2012-12-27','11:20:00',5.1),('8902','2012-12-27','11:25:00',5.11),('8902','2012-12-27','11:30:00',5.17),('8902','2012-12-27','11:35:00',5.27),('8902','2012-12-27','11:40:00',5.3),('8902','2012-12-27','11:45:00',5.3),('8902','2012-12-27','11:50:00',5.37),('8902','2012-12-27','11:55:00',4.88),('8902','2012-12-27','12:00:00',4.76),('8902','2012-12-27','12:05:00',4.31),('8902','2012-12-27','12:10:00',4.99),('8902','2012-12-27','12:15:00',5.41),('8902','2012-12-27','12:20:00',5.35),('8902','2012-12-27','12:25:00',5.27),('8902','2012-12-27','12:30:00',5.16),('8902','2012-12-27','12:35:00',5.23),('8902','2012-12-27','12:40:00',4.91),('8902','2012-12-27','12:45:00',3.92),('8902','2012-12-27','12:50:00',5.33),('8902','2012-12-27','12:55:00',5.22),('8902','2012-12-27','13:00:00',5.15),('8902','2012-12-27','13:05:00',5.08),('8902','2012-12-27','13:10:00',5),('8902','2012-12-27','13:15:00',4.91),('8902','2012-12-27','13:20:00',4.95),('8902','2012-12-27','13:25:00',4.9),('8902','2012-12-27','13:30:00',4.83),('8902','2012-12-27','13:35:00',4.72),('8902','2012-12-27','13:40:00',4.66),('8902','2012-12-27','13:45:00',4.63),('8902','2012-12-27','13:50:00',4.58),('8902','2012-12-27','13:55:00',4.47),('8902','2012-12-27','14:00:00',4.38),('8902','2012-12-27','14:05:00',4.22),('8902','2012-12-27','14:10:00',3.98),('8902','2012-12-27','14:15:00',3.53),('8902','2012-12-27','14:20:00',3.75),('8902','2012-12-27','14:25:00',3.86),('8902','2012-12-27','14:30:00',3.7),('8902','2012-12-27','14:35:00',3.48),('8902','2012-12-27','14:40:00',1.83),('8902','2012-12-27','14:45:00',2.68),('8902','2012-12-27','14:50:00',3.21),('8902','2012-12-27','14:55:00',3.08),('8902','2012-12-27','15:00:00',2.96),('8902','2012-12-27','15:05:00',2.83),('8902','2012-12-27','15:10:00',2.64),('8902','2012-12-27','15:15:00',2.5),('8902','2012-12-27','15:20:00',2.34),('8902','2012-12-27','15:25:00',2.18),('8902','2012-12-27','15:30:00',2.06),('8902','2012-12-27','15:35:00',1.88),('8902','2012-12-27','15:40:00',1.7),('8902','2012-12-27','15:45:00',1.51),('8902','2012-12-27','15:50:00',1.31),('8902','2012-12-27','15:55:00',1.16),('8902','2012-12-27','16:00:00',1.04),('8902','2012-12-26','09:15:00',1.03),('8902','2012-12-26','09:20:00',1.51),('8902','2012-12-26','09:25:00',1.62),('8902','2012-12-26','09:30:00',2.23),('8902','2012-12-26','09:35:00',2.79),('8902','2012-12-26','09:40:00',3.14),('8902','2012-12-26','09:45:00',3.3),('8902','2012-12-26','09:50:00',3.45),('8902','2012-12-26','09:55:00',3.48),('8902','2012-12-26','10:00:00',2.93),('8902','2012-12-26','10:05:00',2.25),('8902','2012-12-26','10:10:00',2.92),('8902','2012-12-26','10:15:00',3.57),('8902','2012-12-26','10:20:00',3.96),('8902','2012-12-26','10:25:00',3.91),('8902','2012-12-26','10:30:00',3.94),('8902','2012-12-26','10:35:00',4.02),('8902','2012-12-26','10:40:00',4.14),('8902','2012-12-26','10:45:00',4.43),('8902','2012-12-26','10:50:00',4.15),('8902','2012-12-26','10:55:00',4.31),('8902','2012-12-26','11:00:00',4.48),('8902','2012-12-26','11:05:00',4.72),('8902','2012-12-26','11:10:00',4.95),('8902','2012-12-26','11:15:00',4.45),('8902','2012-12-26','11:20:00',1.43),('8902','2012-12-26','11:25:00',2.55),('8902','2012-12-26','11:50:00',1.02),('8902','2012-12-26','11:55:00',5.03),('8902','2012-12-26','12:00:00',5.17),('8902','2012-12-26','12:05:00',5.2),('8902','2012-12-26','12:10:00',5.52),('8902','2012-12-26','12:15:00',5.45),('8902','2012-12-26','12:20:00',2.77),('8902','2012-12-26','12:25:00',5.09),('8902','2012-12-26','12:30:00',4.92),('8902','2012-12-26','12:35:00',5.28),('8902','2012-12-26','12:40:00',5.13),('8902','2012-12-26','12:45:00',5.63),('8902','2012-12-26','12:50:00',5.53),('8902','2012-12-26','12:55:00',5.32),('8902','2012-12-26','13:00:00',5.25),('8902','2012-12-26','13:05:00',5.36),('8902','2012-12-26','13:10:00',4.78),('8902','2012-12-26','13:15:00',5.21),('8902','2012-12-26','13:20:00',4.91),('8902','2012-12-26','13:25:00',5.05),('8902','2012-12-26','13:30:00',4.98),('8902','2012-12-26','13:35:00',2.29),('8902','2012-12-26','13:40:00',1.1),('8902','2012-12-26','13:45:00',1.62),('8902','2012-12-26','14:00:00',1.84),('8902','2012-12-26','14:05:00',3.48),('8902','2012-12-26','14:10:00',3.94),('8902','2012-12-26','14:15:00',4.29),('8902','2012-12-26','14:20:00',4.02),('8902','2012-12-26','14:25:00',3.83),('8902','2012-12-26','14:30:00',3.79),('8902','2012-12-26','14:35:00',3.71),('8902','2012-12-26','14:40:00',3.55),('8902','2012-12-26','14:45:00',3.33),('8902','2012-12-26','14:50:00',1.55),('8902','2012-12-26','14:55:00',1.95),('8902','2012-12-26','15:00:00',3.17),('8902','2012-12-26','15:05:00',2.94),('8902','2012-12-26','15:10:00',1.37),('8902','2012-12-26','15:30:00',1.65),('8902','2012-12-26','15:35:00',1.36),('8902','2012-12-26','15:40:00',1.77),('8902','2012-12-26','15:45:00',1.59),('8902','2012-12-26','15:50:00',1.18),('8902','2012-12-26','15:55:00',1.09),('8902','2012-12-25','09:10:00',1.28),('8902','2012-12-25','09:15:00',2.05),('8902','2012-12-25','09:20:00',2.81),('8902','2012-12-25','09:25:00',2.9),('8902','2012-12-25','09:30:00',2.98),('8902','2012-12-25','09:35:00',3.05),('8902','2012-12-25','09:40:00',3.2),('8902','2012-12-25','09:45:00',3.31),('8902','2012-12-25','09:50:00',3.43),('8902','2012-12-25','09:55:00',3.56),('8902','2012-12-25','10:00:00',3.67),('8902','2012-12-25','10:05:00',3.76),('8902','2012-12-25','10:10:00',3.86),('8902','2012-12-25','10:15:00',3.97),('8902','2012-12-25','10:20:00',4.03),('8902','2012-12-25','10:25:00',4.09),('8902','2012-12-25','10:30:00',4.2),('8902','2012-12-25','10:35:00',4.29),('8902','2012-12-25','10:40:00',4.38),('8902','2012-12-25','10:45:00',4.4),('8902','2012-12-25','10:50:00',4.46),('8902','2012-12-25','10:55:00',4.52),('8902','2012-12-25','11:00:00',4.58),('8902','2012-12-25','11:05:00',4.63),('8902','2012-12-25','11:10:00',4.67),('8902','2012-12-25','11:15:00',4.73),('8902','2012-12-25','11:20:00',4.75),('8902','2012-12-25','11:25:00',4.79),('8902','2012-12-25','11:30:00',4.8),('8902','2012-12-25','11:35:00',4.83),('8902','2012-12-25','11:40:00',4.91),('8902','2012-12-25','11:45:00',4.94),('8902','2012-12-25','11:50:00',5.04),('8902','2012-12-25','11:55:00',5.13),('8902','2012-12-25','12:00:00',5.21),('8902','2012-12-25','12:05:00',5.24),('8902','2012-12-25','12:10:00',5.25),('8902','2012-12-25','12:15:00',5.29),('8902','2012-12-25','12:20:00',5.33),('8902','2012-12-25','12:25:00',5.34),('8902','2012-12-25','12:30:00',5.32),('8902','2012-12-25','12:35:00',5.35),('8902','2012-12-25','12:40:00',4.91),('8902','2012-12-25','12:45:00',5.32),('8902','2012-12-25','12:50:00',5),('8902','2012-12-25','12:55:00',5.22),('8902','2012-12-25','13:00:00',5.3),('8902','2012-12-25','13:05:00',5.23),('8902','2012-12-25','13:10:00',5.24),('8902','2012-12-25','13:15:00',5.25),('8902','2012-12-25','13:20:00',5.28),('8902','2012-12-25','13:25:00',5.4),('8902','2012-12-25','13:30:00',5.62),('8902','2012-12-25','13:35:00',5.6),('8902','2012-12-25','13:40:00',5.5),('8902','2012-12-25','13:45:00',5.55),('8902','2012-12-25','13:50:00',4.84),('8902','2012-12-25','13:55:00',5.32),('8902','2012-12-25','14:00:00',5.19),('8902','2012-12-25','14:05:00',4.49),('8902','2012-12-25','14:10:00',1.31),('8902','2012-12-25','14:15:00',1.54),('8902','2012-12-24','10:05:00',1.12),('8902','2012-12-24','10:10:00',1.26),('8902','2012-12-24','10:15:00',1.33),('8902','2012-12-24','10:20:00',1.38),('8902','2012-12-24','10:25:00',1.47),('8902','2012-12-24','10:30:00',1.41),('8902','2012-12-24','10:35:00',1.38),('8902','2012-12-24','10:40:00',1.35),('8902','2012-12-24','10:45:00',1.33),('8902','2012-12-24','10:50:00',1.31),('8902','2012-12-24','10:55:00',1.37),('8902','2012-12-24','11:00:00',1.37),('8902','2012-12-24','11:05:00',1.44),('8902','2012-12-24','11:10:00',1.46),('8902','2012-12-24','11:15:00',1.48),('8902','2012-12-24','11:20:00',1.59),('8902','2012-12-24','11:25:00',1.72),('8902','2012-12-24','11:30:00',1.64),('8902','2012-12-24','11:35:00',1.57),('8902','2012-12-24','11:40:00',1.44),('8902','2012-12-24','11:45:00',1.48),('8902','2012-12-24','11:50:00',1.61),('8902','2012-12-24','11:55:00',1.76),('8902','2012-12-24','12:00:00',1.72),('8902','2012-12-24','12:05:00',1.61),('8902','2012-12-24','12:10:00',1.57),('8902','2012-12-24','12:15:00',1.54),('8902','2012-12-24','12:20:00',1.52),('8902','2012-12-24','12:25:00',1.65),('8902','2012-12-24','12:30:00',1.44),('8902','2012-12-24','12:35:00',1.39),('8902','2012-12-24','12:40:00',1.35),('8902','2012-12-24','12:45:00',1.33),('8902','2012-12-24','12:50:00',1.38),('8902','2012-12-24','12:55:00',1.53),('8902','2012-12-24','13:00:00',1.46),('8902','2012-12-24','13:05:00',1.59),('8902','2012-12-24','13:10:00',1.58),('8902','2012-12-24','13:15:00',1.62),('8902','2012-12-24','13:20:00',1.62),('8902','2012-12-24','13:25:00',1.42),('8902','2012-12-24','13:30:00',1.26),('8902','2012-12-24','13:35:00',1.11),('8902','2012-12-24','13:40:00',1.19),('8902','2012-12-24','13:45:00',1.06),('8902','2012-12-24','13:50:00',1),('8902','2012-12-24','14:35:00',1.14),('8902','2012-12-24','14:40:00',2.1),('8902','2012-12-24','14:45:00',2.46),('8902','2012-12-24','14:50:00',2.25),('8902','2012-12-24','14:55:00',2.21),('8902','2012-12-24','15:00:00',2.17),('8902','2012-12-24','15:05:00',1.53),('8902','2012-12-24','15:10:00',1.77),('8902','2012-12-24','15:15:00',1.72),('8902','2012-12-24','15:20:00',1.51),('8902','2012-12-24','15:25:00',1.32),('8902','2012-12-24','15:30:00',1.09),('8902','2012-12-24','15:35:00',1.12),('8902','2012-12-24','15:40:00',1.15),('8902','2012-12-23','11:20:00',1.08),('8902','2012-12-23','11:30:00',1.14),('8902','2012-12-23','11:35:00',1.2),('8902','2012-12-23','11:40:00',1.18),('8902','2012-12-23','11:45:00',1.14),('8902','2012-12-23','11:50:00',1.09),('8902','2012-12-23','11:55:00',1.08),('8902','2012-12-23','12:00:00',1.19),('8902','2012-12-23','12:05:00',1.36),('8902','2012-12-23','12:10:00',1.51),('8902','2012-12-23','12:15:00',1.45),('8902','2012-12-23','12:20:00',1.38),('8902','2012-12-23','12:25:00',1.39),('8902','2012-12-23','12:30:00',1.36),('8902','2012-12-23','12:35:00',1.34),('8902','2012-12-23','12:40:00',1.35),('8902','2012-12-23','12:45:00',1.26),('8902','2012-12-23','12:50:00',1.16),('8902','2012-12-23','12:55:00',1.13),('8902','2012-12-23','13:00:00',1.11),('8902','2012-12-23','13:05:00',1.01),('8902','2012-12-22','08:30:00',1.06),('8902','2012-12-22','08:35:00',1.38),('8902','2012-12-22','08:40:00',1.59),('8902','2012-12-22','08:45:00',1.79),('8902','2012-12-22','08:50:00',1.98),('8902','2012-12-22','08:55:00',2.16),('8902','2012-12-22','09:00:00',2.31),('8902','2012-12-22','09:05:00',2.49),('8902','2012-12-22','09:10:00',2.66),('8902','2012-12-22','09:15:00',2.72),('8902','2012-12-22','09:20:00',2.84),('8902','2012-12-22','09:25:00',3.03),('8902','2012-12-22','09:30:00',3.1),('8902','2012-12-22','09:35:00',3.27),('8902','2012-12-22','09:40:00',3.38),('8902','2012-12-22','09:45:00',3.5),('8902','2012-12-22','09:50:00',3.6),('8902','2012-12-22','09:55:00',3.7),('8902','2012-12-22','10:00:00',3.78),('8902','2012-12-22','10:05:00',3.91),('8902','2012-12-22','10:10:00',3.98),('8902','2012-12-22','10:15:00',4.04),('8902','2012-12-22','10:20:00',4.18),('8902','2012-12-22','10:25:00',4.22),('8902','2012-12-22','10:30:00',4.24),('8902','2012-12-22','10:35:00',4.38),('8902','2012-12-22','10:40:00',4.47),('8902','2012-12-22','10:45:00',4.59),('8902','2012-12-22','10:50:00',4.59),('8902','2012-12-22','10:55:00',4.41),('8902','2012-12-22','11:00:00',4.74),('8902','2012-12-22','11:05:00',4.8),('8902','2012-12-22','11:10:00',4.84),('8902','2012-12-22','11:15:00',4.89),('8902','2012-12-22','11:20:00',5.04),('8902','2012-12-22','11:25:00',4.63),('8902','2012-12-22','11:30:00',4.92),('8902','2012-12-22','11:35:00',5.18),('8902','2012-12-22','11:40:00',5.18),('8902','2012-12-22','11:45:00',5.11),('8902','2012-12-22','11:50:00',5.22),('8902','2012-12-22','11:55:00',4.93),('8902','2012-12-22','12:00:00',4.58),('8902','2012-12-22','12:05:00',4.67),('8902','2012-12-22','12:10:00',4.69),('8902','2012-12-22','12:15:00',3.84),('8902','2012-12-22','12:20:00',3.73),('8902','2012-12-22','12:25:00',2.38),('8902','2012-12-22','12:30:00',2.59),('8902','2012-12-22','12:35:00',2.25),('8902','2012-12-22','12:40:00',2.43),('8902','2012-12-22','12:45:00',2.4),('8902','2012-12-22','12:50:00',3.09),('8902','2012-12-22','12:55:00',4.6),('8902','2012-12-22','13:00:00',4.95),('8902','2012-12-22','13:05:00',4.39),('8902','2012-12-22','13:10:00',4.69),('8902','2012-12-22','13:15:00',3.41),('8902','2012-12-22','13:20:00',2.56),('8902','2012-12-22','13:25:00',2.8),('8902','2012-12-22','13:30:00',2.27),('8902','2012-12-22','13:35:00',1.88),('8902','2012-12-22','13:40:00',3.35),('8902','2012-12-22','13:45:00',3.5),('8902','2012-12-22','13:50:00',3.2),('8902','2012-12-22','13:55:00',2.78),('8902','2012-12-22','14:00:00',4.15),('8902','2012-12-22','14:05:00',3.67),('8902','2012-12-22','14:10:00',3.48),('8902','2012-12-22','14:15:00',3.63),('8902','2012-12-22','14:20:00',2.96),('8902','2012-12-22','14:25:00',2.31),('8902','2012-12-22','14:30:00',2.31),('8902','2012-12-22','14:35:00',2.61),('8902','2012-12-22','14:40:00',3.11),('8902','2012-12-22','14:45:00',3.3),('8902','2012-12-22','14:50:00',2.4),('8902','2012-12-22','14:55:00',1.7),('8902','2012-12-22','15:00:00',1.35),('8902','2012-12-22','15:05:00',1.39),('8902','2012-12-22','15:10:00',1.56),('8902','2012-12-22','15:15:00',1.16),('8902','2014-04-30','07:40:00',1.06),('8902','2014-04-30','07:45:00',1.26),('8902','2014-04-30','07:50:00',1.62),('8902','2014-04-30','07:55:00',1.86),('8902','2014-04-30','08:00:00',2.08),('8902','2014-04-30','08:05:00',2.22),('8902','2014-04-30','08:10:00',2.35),('8902','2014-04-30','08:15:00',2.56),('8902','2014-04-30','08:20:00',2.74),('8902','2014-04-30','08:25:00',2.94),('8902','2014-04-30','08:30:00',3.12),('8902','2014-04-30','08:35:00',3.31),('8902','2014-04-30','08:40:00',3.47),('8902','2014-04-30','08:45:00',3.66),('8902','2014-04-30','08:50:00',3.94),('8902','2014-04-30','08:55:00',4.61),('8902','2014-04-30','09:00:00',2.87),('8902','2014-04-30','09:05:00',2.86),('8902','2014-04-30','09:10:00',2.75),('8902','2014-04-30','09:15:00',3.05),('8902','2014-04-30','09:20:00',2.29),('8902','2014-04-30','09:25:00',3.64),('8902','2014-04-30','09:30:00',5.27),('8902','2014-04-30','09:35:00',5.45),('8902','2014-04-30','09:40:00',5.14),('8902','2014-04-30','09:45:00',3.35),('8902','2014-04-30','09:50:00',3.38),('8902','2014-04-30','09:55:00',3.16),('8902','2014-04-30','10:00:00',3.4),('8902','2014-04-30','10:05:00',4.61),('8902','2014-04-30','10:10:00',8.18),('8902','2014-04-30','10:15:00',5.05),('8902','2014-04-30','10:20:00',5.18),('8902','2014-04-30','10:25:00',7),('8902','2014-04-30','10:30:00',6.47),('8902','2014-04-30','10:35:00',2.51),('8902','2014-04-30','10:40:00',3.86),('8902','2014-04-30','10:45:00',4.05),('8902','2014-04-30','10:50:00',8.02),('8902','2014-04-30','10:55:00',8.31),('8902','2014-04-30','11:00:00',8.78),('8902','2014-04-30','11:05:00',6.74),('8902','2014-04-30','11:10:00',4.6),('8902','2014-04-30','11:15:00',4.35),('8902','2014-04-30','11:20:00',6.82),('8902','2014-04-30','11:25:00',8.48),('8902','2014-04-30','11:30:00',5.9),('8902','2014-04-30','11:35:00',8.05),('8902','2014-04-30','11:40:00',8.88),('8902','2014-04-30','11:45:00',8.54),('8902','2014-04-30','11:50:00',7.26),('8902','2014-04-30','11:55:00',8.09),('8902','2014-04-30','12:00:00',8.94),('8902','2014-04-30','12:05:00',9.06),('8902','2014-04-30','12:10:00',8.88),('8902','2014-04-30','12:15:00',8.28),('8902','2014-04-30','12:20:00',6.93),('8902','2014-04-30','12:25:00',1.57),('8902','2014-04-30','12:30:00',4.57),('8902','2014-04-30','12:35:00',9.65),('8902','2014-04-30','12:40:00',9.45),('8902','2014-04-30','12:45:00',9.16),('8902','2014-04-30','12:50:00',7.34),('8902','2014-04-30','12:55:00',2.27),('8902','2014-04-30','13:00:00',9.39),('8902','2014-04-30','13:05:00',9.23),('8902','2014-04-30','13:10:00',9.23),('8902','2014-04-30','13:15:00',9.01),('8902','2014-04-30','13:20:00',9),('8902','2014-04-30','13:25:00',7.28),('8902','2014-04-30','13:30:00',5.01),('8902','2014-04-30','13:35:00',9.7),('8902','2014-04-30','13:40:00',8.3),('8902','2014-04-30','13:45:00',9.52),('8902','2014-04-30','13:50:00',9.72),('8902','2014-04-30','13:55:00',8.29),('8902','2014-04-30','14:00:00',4.06),('8902','2014-04-30','14:05:00',9.72),('8902','2014-04-30','14:10:00',9.18),('8902','2014-04-30','14:15:00',9.11),('8902','2014-04-30','14:20:00',8.8),('8902','2014-04-30','14:25:00',9.06),('8902','2014-04-30','14:30:00',8.5),('8902','2014-04-30','14:35:00',8.03),('8902','2014-04-30','14:40:00',8.67),('8902','2014-04-30','14:45:00',8.95),('8902','2014-04-30','14:50:00',8.81),('8902','2014-04-30','14:55:00',8.57),('8902','2014-04-30','15:00:00',8.83),('8902','2014-04-30','15:05:00',8.48),('8902','2014-04-30','15:10:00',4.69),('8902','2014-04-30','15:15:00',7.56),('8902','2014-04-30','15:20:00',8.04),('8902','2014-04-30','15:25:00',7.92),('8902','2014-04-30','15:30:00',7.66),('8902','2014-04-30','15:35:00',7.57),('8902','2014-04-30','15:40:00',7.46),('8902','2014-04-30','15:45:00',7.38),('8902','2014-04-30','15:50:00',7.17),('8902','2014-04-30','15:55:00',7.07),('8902','2014-04-30','16:00:00',6.99),('8902','2014-04-30','16:05:00',7.01),('8902','2014-04-30','16:10:00',6.66),('8902','2014-04-30','16:15:00',6.61),('8902','2014-04-30','16:20:00',6.41),('8902','2014-04-30','16:25:00',5.72),('8902','2014-04-30','16:30:00',5.95),('8902','2014-04-30','16:35:00',6.02),('8902','2014-04-30','16:40:00',5.74),('8902','2014-04-30','16:45:00',4.76),('8902','2014-04-30','16:50:00',4.64),('8902','2014-04-30','16:55:00',4.66),('8902','2014-04-30','17:00:00',4.75),('8902','2014-04-30','17:05:00',4.77),('8902','2014-04-30','17:10:00',5.05),('8902','2014-04-30','17:15:00',4.79),('8902','2014-04-30','17:20:00',4.63),('8902','2014-04-30','17:25:00',4.39),('8902','2014-04-30','17:30:00',4.17),('8902','2014-04-30','17:35:00',4.06),('8902','2014-04-30','17:40:00',3.81),('8902','2014-04-30','17:45:00',3.63),('8902','2014-04-30','17:50:00',3.48),('8902','2014-04-30','17:55:00',3.35),('8902','2014-04-30','18:00:00',3.33),('8902','2014-04-30','18:05:00',2.94),('8902','2014-04-30','18:10:00',2.69),('8902','2014-04-30','18:15:00',2.42),('8902','2014-04-30','18:20:00',2.27),('8902','2014-04-30','18:25:00',2.08),('8902','2014-04-30','18:30:00',1.91),('8902','2014-04-30','18:35:00',1.64),('8902','2014-04-30','18:40:00',1.46),('8902','2014-04-30','18:45:00',1.34),('8902','2014-04-30','18:50:00',1.16),('8902','2014-04-30','18:55:00',1),('8902','2014-03-16','08:30:00',1.11),('8902','2014-03-16','08:35:00',1.18),('8902','2014-03-16','08:40:00',1.32),('8902','2014-03-16','08:45:00',1.37),('8902','2014-03-16','08:50:00',1.39),('8902','2014-03-16','08:55:00',1.58),('8902','2014-03-16','09:00:00',1.57),('8902','2014-03-16','09:05:00',1.72),('8902','2014-03-16','09:10:00',1.81),('8902','2014-03-16','09:15:00',2.14),('8902','2014-03-16','09:20:00',2.41),('8902','2014-03-16','09:25:00',2.56),('8902','2014-03-16','09:30:00',3.2),('8902','2014-03-16','09:35:00',3.54),('8902','2014-03-16','09:40:00',2.66),('8902','2014-03-16','09:45:00',2.4),('8902','2014-03-16','09:50:00',3.15),('8902','2014-03-16','09:55:00',3.55),('8902','2014-03-16','10:00:00',3.72),('8902','2014-03-16','10:05:00',3.09),('8902','2014-03-16','10:10:00',3.64),('8902','2014-03-16','10:15:00',3.21),('8902','2014-03-16','10:20:00',4),('8902','2014-03-16','10:25:00',3.28),('8902','2014-03-16','10:30:00',2.59),('8902','2014-03-16','10:35:00',2.88),('8902','2014-03-16','10:40:00',2.74),('8902','2014-03-16','10:45:00',3.11),('8902','2014-03-16','10:50:00',2.78),('8902','2014-03-16','10:55:00',2.81),('8902','2014-03-16','11:00:00',2.81),('8902','2014-03-16','11:05:00',2.62),('8902','2014-03-16','11:10:00',3.29),('8902','2014-03-16','11:15:00',3.41),('8902','2014-03-16','11:20:00',2.52),('8902','2014-03-16','11:25:00',2.46),('8902','2014-03-16','11:30:00',3.08),('8902','2014-03-16','11:35:00',2.53),('8902','2014-03-16','11:40:00',2.34),('8902','2014-03-16','11:45:00',2.16),('8902','2014-03-16','11:50:00',3.73),('8902','2014-03-16','11:55:00',3.43),('8902','2014-03-16','12:00:00',3.32),('8902','2014-03-16','12:05:00',5.16),('8902','2014-03-16','12:10:00',3.26),('8902','2014-03-16','12:15:00',4.23),('8902','2014-03-16','12:20:00',3.04),('8902','2014-03-16','12:25:00',6.61),('8902','2014-03-16','12:30:00',3.85),('8902','2014-03-16','12:35:00',4.62),('8902','2014-03-16','12:40:00',4.33),('8902','2014-03-16','12:45:00',4.95),('8902','2014-03-16','12:50:00',3.31),('8902','2014-03-16','12:55:00',7.13),('8902','2014-03-16','13:00:00',8.04),('8902','2014-03-16','13:05:00',6.69),('8902','2014-03-16','13:10:00',6.16),('8902','2014-03-16','13:15:00',7.56),('8902','2014-03-16','13:20:00',7.66),('8902','2014-03-16','13:25:00',7.64),('8902','2014-03-16','13:30:00',5.07),('8902','2014-03-16','13:35:00',6.11),('8902','2014-03-16','13:40:00',7.4),('8902','2014-03-16','13:45:00',7.54),('8902','2014-03-16','13:50:00',6.25),('8902','2014-03-16','13:55:00',6.12),('8902','2014-03-16','14:00:00',5.82),('8902','2014-03-16','14:05:00',5.22),('8902','2014-03-16','14:10:00',4.67),('8902','2014-03-16','14:15:00',2.07),('8902','2014-03-16','14:20:00',4.3),('8902','2014-03-16','14:25:00',3.62),('8902','2014-03-16','14:30:00',5.67),('8902','2014-03-16','14:35:00',6.77),('8902','2014-03-16','14:40:00',5.7),('8902','2014-03-16','14:45:00',5.98),('8902','2014-03-16','14:50:00',6.3),('8902','2014-03-16','14:55:00',6.1),('8902','2014-03-16','15:00:00',5.96),('8902','2014-03-16','15:05:00',5.63),('8902','2014-03-16','15:10:00',5.56),('8902','2014-03-16','15:15:00',5.55),('8902','2014-03-16','15:20:00',3.1),('8902','2014-03-16','15:25:00',4.59),('8902','2014-03-16','15:30:00',4.97),('8902','2014-03-16','15:35:00',4.78),('8902','2014-03-16','15:40:00',4.49),('8902','2014-03-16','15:45:00',3.95),('8902','2014-03-16','15:50:00',4.23),('8902','2014-03-16','15:55:00',4.01),('8902','2014-03-16','16:00:00',3.99),('8902','2014-03-16','16:05:00',3.71),('8902','2014-03-16','16:10:00',3.23),('8902','2014-03-16','16:15:00',2.87),('8902','2014-03-16','16:20:00',3.37),('8902','2014-03-16','16:25:00',3.32),('8902','2014-03-16','16:30:00',2.78),('8902','2014-03-16','16:35:00',2.57),('8902','2014-03-16','16:40:00',2.41),('8902','2014-03-16','16:45:00',2.12),('8902','2014-03-16','16:50:00',1.91),('8902','2014-03-16','16:55:00',1.22),('8902','2014-03-16','17:00:00',1.02),('8902','2014-03-16','17:05:00',1.27),('8902','2014-03-16','17:10:00',1.08),('8902','2012-12-21','09:25:00',1.03),('8902','2012-12-21','09:30:00',1.3),('8902','2012-12-21','09:35:00',1.68),('8902','2012-12-21','09:40:00',1.36),('8902','2012-12-21','09:45:00',1.15),('8902','2012-12-21','09:50:00',1.2),('8902','2012-12-21','09:55:00',1.35),('8902','2012-12-21','10:00:00',1.34),('8902','2012-12-21','10:05:00',1.39),('8902','2012-12-21','10:10:00',1.49),('8902','2012-12-21','10:15:00',1.54),('8902','2012-12-21','10:20:00',2.1),('8902','2012-12-21','10:25:00',4.26),('8902','2012-12-21','10:30:00',5.14),('8902','2012-12-21','10:35:00',5.53),('8902','2012-12-21','10:40:00',5.43),('8902','2012-12-21','10:45:00',5.35),('8902','2012-12-21','10:50:00',5.33),('8902','2012-12-21','10:55:00',5.31),('8902','2012-12-21','11:00:00',3.23),('8902','2012-12-21','11:05:00',1.03),('8902','2012-12-21','11:20:00',1.15),('8902','2012-12-21','11:30:00',1.26),('8902','2012-12-21','11:35:00',1.58),('8902','2012-12-21','11:40:00',1.8),('8902','2012-12-21','11:45:00',3.1),('8902','2012-12-21','11:50:00',5.18),('8902','2012-12-21','11:55:00',2.66),('8902','2012-12-21','12:00:00',4.54),('8902','2012-12-21','12:05:00',3.47),('8902','2012-12-21','12:10:00',1.57),('8902','2012-12-21','12:15:00',1.52),('8902','2012-12-21','12:20:00',1.28),('8902','2012-12-21','12:25:00',1.24),('8902','2012-12-21','12:30:00',1.29),('8902','2012-12-21','12:35:00',1.37),('8902','2012-12-21','12:40:00',1.54),('8902','2012-12-21','12:45:00',2.86),('8902','2012-12-21','12:50:00',4.78),('8902','2012-12-21','12:55:00',4.41),('8902','2012-12-21','13:00:00',4.95),('8902','2012-12-21','13:05:00',5.78),('8902','2012-12-21','13:10:00',6.13),('8902','2012-12-21','13:15:00',6.21),('8902','2012-12-21','13:20:00',6.28),('8902','2012-12-21','13:25:00',6.18),('8902','2012-12-21','13:30:00',5.79),('8902','2012-12-21','13:35:00',5.27),('8902','2012-12-21','13:40:00',5.73),('8902','2012-12-21','13:45:00',1.65),('8902','2012-12-21','13:50:00',1.49),('8902','2012-12-21','13:55:00',2.02),('8902','2012-12-21','14:00:00',1.91),('8902','2012-12-21','14:05:00',3),('8902','2012-12-21','14:10:00',2.59),('8902','2012-12-21','14:15:00',3.33),('8902','2012-12-21','14:20:00',3.98),('8902','2012-12-21','14:55:00',1.23),('8902','2012-12-21','15:00:00',1.85),('8902','2012-12-21','15:55:00',1.18),('8902','2014-03-15','07:30:00',1.12),('8902','2014-03-15','07:35:00',1.22),('8902','2014-03-15','07:40:00',1.28),('8902','2014-03-15','07:45:00',1.43),('8902','2014-03-15','07:50:00',1.59),('8902','2014-03-15','07:55:00',1.84),('8902','2014-03-15','08:00:00',2.08),('8902','2014-03-15','08:05:00',2.23),('8902','2014-03-15','08:10:00',2.27),('8902','2014-03-15','08:15:00',2.36),('8902','2014-03-15','08:20:00',2.55),('8902','2014-03-15','08:25:00',2.71),('8902','2014-03-15','08:30:00',2.9),('8902','2014-03-15','08:35:00',3.05),('8902','2014-03-15','08:40:00',3.17),('8902','2014-03-15','08:45:00',3.38),('8902','2014-03-15','08:50:00',3.56),('8902','2014-03-15','08:55:00',3.64),('8902','2014-03-15','09:00:00',3.66),('8902','2014-03-15','09:05:00',3.84),('8902','2014-03-15','09:10:00',4.08),('8902','2014-03-15','09:15:00',4.43),('8902','2014-03-15','09:20:00',4.5),('8902','2014-03-15','09:25:00',4.5),('8902','2014-03-15','09:30:00',4.62),('8902','2014-03-15','09:35:00',4.63),('8902','2014-03-15','09:40:00',4.67),('8902','2014-03-15','09:45:00',4.99),('8902','2014-03-15','09:50:00',5.39),('8902','2014-03-15','09:55:00',5.44),('8902','2014-03-15','10:00:00',5.53),('8902','2014-03-15','10:05:00',5.54),('8902','2014-03-15','10:10:00',5.72),('8902','2014-03-15','10:15:00',5.85),('8902','2014-03-15','10:20:00',5.77),('8902','2014-03-15','10:25:00',5.78),('8902','2014-03-15','10:30:00',5.98),('8902','2014-03-15','10:35:00',6.14),('8902','2014-03-15','10:40:00',6.32),('8902','2014-03-15','10:45:00',6.39),('8902','2014-03-15','10:50:00',6.41),('8902','2014-03-15','10:55:00',6.43),('8902','2014-03-15','11:00:00',6.24),('8902','2014-03-15','11:05:00',6.12),('8902','2014-03-15','11:10:00',6.3),('8902','2014-03-15','11:15:00',6.47),('8902','2014-03-15','11:20:00',6.75),('8902','2014-03-15','11:25:00',6.88),('8902','2014-03-15','11:30:00',6.95),('8902','2014-03-15','11:35:00',7.06),('8902','2014-03-15','11:40:00',7.05),('8902','2014-03-15','11:45:00',7.01),('8902','2014-03-15','11:50:00',7.06),('8902','2014-03-15','11:55:00',6.98),('8902','2014-03-15','12:00:00',7.06),('8902','2014-03-15','12:05:00',6.94),('8902','2014-03-15','12:10:00',7.03),('8902','2014-03-15','12:15:00',6.95),('8902','2014-03-15','12:20:00',7.07),('8902','2014-03-15','12:25:00',6.96),('8902','2014-03-15','12:30:00',6.96),('8902','2014-03-15','12:35:00',7),('8902','2014-03-15','12:40:00',7.09),('8902','2014-03-15','12:45:00',7.11),('8902','2014-03-15','12:50:00',6.95),('8902','2014-03-15','12:55:00',6.84),('8902','2014-03-15','13:00:00',6.79),('8902','2014-03-15','13:05:00',6.89),('8902','2014-03-15','13:10:00',6.86),('8902','2014-03-15','13:15:00',6.86),('8902','2014-03-15','13:20:00',6.7),('8902','2014-03-15','13:25:00',6.78),('8902','2014-03-15','13:30:00',6.82),('8902','2014-03-15','13:35:00',6.63),('8902','2014-03-15','13:40:00',6.82),('8902','2014-03-15','13:45:00',6.67),('8902','2014-03-15','13:50:00',6.51),('8902','2014-03-15','13:55:00',6.63),('8902','2014-03-15','14:00:00',6.53),('8902','2014-03-15','14:05:00',6.42),('8902','2014-03-15','14:10:00',6.34),('8902','2014-03-15','14:15:00',6.2),('8902','2014-03-15','14:20:00',6.23),('8902','2014-03-15','14:25:00',6.15),('8902','2014-03-15','14:30:00',6.1),('8902','2014-03-15','14:35:00',5.92),('8902','2014-03-15','14:40:00',5.85),('8902','2014-03-15','14:45:00',5.66),('8902','2014-03-15','14:50:00',5.31),('8902','2014-03-15','14:55:00',5.28),('8902','2014-03-15','15:00:00',5.64),('8902','2014-03-15','15:05:00',5.29),('8902','2014-03-15','15:10:00',4.91),('8902','2014-03-15','15:15:00',4.5),('8902','2014-03-15','15:20:00',3.9),('8902','2014-03-15','15:25:00',4.28),('8902','2014-03-15','15:30:00',4.1),('8902','2014-03-15','15:35:00',3.71),('8902','2014-03-15','15:40:00',2.9),('8902','2014-03-15','15:45:00',2.94),('8902','2014-03-15','15:50:00',3.4),('8902','2014-03-15','15:55:00',3.23),('8902','2014-03-15','16:00:00',2.78),('8902','2014-03-15','16:05:00',3.22),('8902','2014-03-15','16:10:00',3.39),('8902','2014-03-15','16:15:00',3.3),('8902','2014-03-15','16:20:00',2.9),('8902','2014-03-15','16:25:00',3.01),('8902','2014-03-15','16:30:00',2.89),('8902','2014-03-15','16:35:00',2.59),('8902','2014-03-15','16:40:00',2.27),('8902','2014-03-15','16:45:00',2.05),('8902','2014-03-15','16:50:00',1.85),('8902','2014-03-15','16:55:00',1.53),('8902','2014-03-15','17:00:00',1.2),('8902','2014-03-15','17:05:00',1.14),('8902','2014-03-14','07:35:00',1.08),('8902','2014-03-14','07:40:00',1.19),('8902','2014-03-14','07:45:00',1.32),('8902','2014-03-14','07:50:00',1.42),('8902','2014-03-14','07:55:00',1.56),('8902','2014-03-14','08:00:00',1.71),('8902','2014-03-14','08:05:00',1.83),('8902','2014-03-14','08:10:00',1.92),('8902','2014-03-14','08:15:00',2.06),('8902','2014-03-14','08:20:00',2.18),('8902','2014-03-14','08:25:00',2.34),('8902','2014-03-14','08:30:00',2.74),('8902','2014-03-14','08:35:00',2.97),('8902','2014-03-14','08:40:00',3.14),('8902','2014-03-14','08:45:00',3.31),('8902','2014-03-14','08:50:00',3.48),('8902','2014-03-14','08:55:00',3.61),('8902','2014-03-14','09:00:00',3.73),('8902','2014-03-14','09:05:00',3.87),('8902','2014-03-14','09:10:00',4.06),('8902','2014-03-14','09:15:00',4.24),('8902','2014-03-14','09:20:00',4.4),('8902','2014-03-14','09:25:00',4.54),('8902','2014-03-14','09:30:00',4.64),('8902','2014-03-14','09:35:00',4.74),('8902','2014-03-14','09:40:00',4.88),('8902','2014-03-14','09:45:00',5),('8902','2014-03-14','09:50:00',5.06),('8902','2014-03-14','09:55:00',5.16),('8902','2014-03-14','10:00:00',5.3),('8902','2014-03-14','10:05:00',5.38),('8902','2014-03-14','10:10:00',5.45),('8902','2014-03-14','10:15:00',5.55),('8902','2014-03-14','10:20:00',5.57),('8902','2014-03-14','10:25:00',5.73),('8902','2014-03-14','10:30:00',5.86),('8902','2014-03-14','10:35:00',5.9),('8902','2014-03-14','10:40:00',5.97),('8902','2014-03-14','10:45:00',6.15),('8902','2014-03-14','10:50:00',6.32),('8902','2014-03-14','10:55:00',6.21),('8902','2014-03-14','11:00:00',6.22),('8902','2014-03-14','11:05:00',6.26),('8902','2014-03-14','11:10:00',6.38),('8902','2014-03-14','11:15:00',6.34),('8902','2014-03-14','11:20:00',6.54),('8902','2014-03-14','11:25:00',6.67),('8902','2014-03-14','11:30:00',6.85),('8902','2014-03-14','11:35:00',6.82),('8902','2014-03-14','11:40:00',6.9),('8902','2014-03-14','11:45:00',6.88),('8902','2014-03-14','11:50:00',6.96),('8902','2014-03-14','11:55:00',6.87),('8902','2014-03-14','12:00:00',6.96),('8902','2014-03-14','12:05:00',6.92),('8902','2014-03-14','12:10:00',6.87),('8902','2014-03-14','12:15:00',7.02),('8902','2014-03-14','12:20:00',7.09),('8902','2014-03-14','12:25:00',7.09),('8902','2014-03-14','12:30:00',7.13),('8902','2014-03-14','12:35:00',7.26),('8902','2014-03-14','12:40:00',7.23),('8902','2014-03-14','12:45:00',7.21),('8902','2014-03-14','12:50:00',7.22),('8902','2014-03-14','12:55:00',7.22),('8902','2014-03-14','13:00:00',7.09),('8902','2014-03-14','13:05:00',7.19),('8902','2014-03-14','13:10:00',7.19),('8902','2014-03-14','13:15:00',7.13),('8902','2014-03-14','13:20:00',7.09),('8902','2014-03-14','13:25:00',7.03),('8902','2014-03-14','13:30:00',6.99),('8902','2014-03-14','13:35:00',7.02),('8902','2014-03-14','13:40:00',6.99),('8902','2014-03-14','13:45:00',6.96),('8902','2014-03-14','13:50:00',6.89),('8902','2014-03-14','13:55:00',6.9),('8902','2014-03-14','14:00:00',6.85),('8902','2014-03-14','14:05:00',6.78),('8902','2014-03-14','14:10:00',6.72),('8902','2014-03-14','14:15:00',6.63),('8902','2014-03-14','14:20:00',6.53),('8902','2014-03-14','14:25:00',6.42),('8902','2014-03-14','14:30:00',6.32),('8902','2014-03-14','14:35:00',6.2),('8902','2014-03-14','14:40:00',6.08),('8902','2014-03-14','14:45:00',5.95),('8902','2014-03-14','14:50:00',5.81),('8902','2014-03-14','14:55:00',5.72),('8902','2014-03-14','15:00:00',5.64),('8902','2014-03-14','15:05:00',5.54),('8902','2014-03-14','15:10:00',5.4),('8902','2014-03-14','15:15:00',5.26),('8902','2014-03-14','15:20:00',5.09),('8902','2014-03-14','15:25:00',4.87),('8902','2014-03-14','15:30:00',4.74),('8902','2014-03-14','15:35:00',4.6),('8902','2014-03-14','15:40:00',4.4),('8902','2014-03-14','15:45:00',4.26),('8902','2014-03-14','15:50:00',4.01),('8902','2014-03-14','15:55:00',3.9),('8902','2014-03-14','16:00:00',3.73),('8902','2014-03-14','16:05:00',3.4),('8902','2014-03-14','16:10:00',3.31),('8902','2014-03-14','16:15:00',3.04),('8902','2014-03-14','16:20:00',2.89),('8902','2014-03-14','16:25:00',2.69),('8902','2014-03-14','16:30:00',2.48),('8902','2014-03-14','16:35:00',2.24),('8902','2014-03-14','16:40:00',2.04),('8902','2014-03-14','16:45:00',1.9),('8902','2014-03-14','16:50:00',1.7),('8902','2014-03-14','16:55:00',1.54),('8902','2014-03-14','17:00:00',1.41),('8902','2014-03-14','17:05:00',1.22),('8902','2014-03-14','17:10:00',1.07),('8902','2014-03-13','07:40:00',1.07),('8902','2014-03-13','07:45:00',1.17),('8902','2014-03-13','07:50:00',1.28),('8902','2014-03-13','07:55:00',1.38),('8902','2014-03-13','08:00:00',1.48),('8902','2014-03-13','08:05:00',1.58),('8902','2014-03-13','08:10:00',1.71),('8902','2014-03-13','08:15:00',1.92),('8902','2014-03-13','08:20:00',2.11),('8902','2014-03-13','08:25:00',2.2),('8902','2014-03-13','08:30:00',2.37),('8902','2014-03-13','08:35:00',2.41),('8902','2014-03-13','08:40:00',2.33),('8902','2014-03-13','08:45:00',2.03),('8902','2014-03-13','08:50:00',1.95),('8902','2014-03-13','08:55:00',2.04),('8902','2014-03-13','09:00:00',2.21),('8902','2014-03-13','09:05:00',2.51),('8902','2014-03-13','09:10:00',2.79),('8902','2014-03-13','09:15:00',2.81),('8902','2014-03-13','09:20:00',2.78),('8902','2014-03-13','09:25:00',2.99),('8902','2014-03-13','09:30:00',2.97),('8902','2014-03-13','09:35:00',3.56),('8902','2014-03-13','09:40:00',4.44),('8902','2014-03-13','09:45:00',5.14),('8902','2014-03-13','09:50:00',5.98),('8902','2014-03-13','09:55:00',6.19),('8902','2014-03-13','10:00:00',6.61),('8902','2014-03-13','10:05:00',6.55),('8902','2014-03-13','10:10:00',6.42),('8902','2014-03-13','10:15:00',6.29),('8902','2014-03-13','10:20:00',6.13),('8902','2014-03-13','10:25:00',6.09),('8902','2014-03-13','10:30:00',5.91),('8902','2014-03-13','10:35:00',6.27),('8902','2014-03-13','10:40:00',6.39),('8902','2014-03-13','10:45:00',5.83),('8902','2014-03-13','10:50:00',3.53),('8902','2014-03-13','10:55:00',5.16),('8902','2014-03-13','11:00:00',6.35),('8902','2014-03-13','11:05:00',6.59),('8902','2014-03-13','11:10:00',7.15),('8902','2014-03-13','11:15:00',7.22),('8902','2014-03-13','11:20:00',7.01),('8902','2014-03-13','11:25:00',6.89),('8902','2014-03-13','11:30:00',6.96),('8902','2014-03-13','11:35:00',7.09),('8902','2014-03-13','11:40:00',7.11),('8902','2014-03-13','11:45:00',7.25),('8902','2014-03-13','11:50:00',7.3),('8902','2014-03-13','11:55:00',7.31),('8902','2014-03-13','12:00:00',7.42),('8902','2014-03-13','12:05:00',7.44),('8902','2014-03-13','12:10:00',7.04),('8902','2014-03-13','12:15:00',6.64),('8902','2014-03-13','12:20:00',5.52),('8902','2014-03-13','12:25:00',4.71),('8902','2014-03-13','12:30:00',4.38),('8902','2014-03-13','12:35:00',3.8),('8902','2014-03-13','12:40:00',4.58),('8902','2014-03-13','12:45:00',5.1),('8902','2014-03-13','12:50:00',6.11),('8902','2014-03-13','12:55:00',5.95),('8902','2014-03-13','13:00:00',4.3),('8902','2014-03-13','13:05:00',3.85),('8902','2014-03-13','13:10:00',4.64),('8902','2014-03-13','13:15:00',5.56),('8902','2014-03-13','13:20:00',5.58),('8902','2014-03-13','13:25:00',5.19),('8902','2014-03-13','13:30:00',4.78),('8902','2014-03-13','13:35:00',4.34),('8902','2014-03-13','13:40:00',3.96),('8902','2014-03-13','13:45:00',4.08),('8902','2014-03-13','13:50:00',3.81),('8902','2014-03-13','13:55:00',4.04),('8902','2014-03-13','14:00:00',4.7),('8902','2014-03-13','14:05:00',5.25),('8902','2014-03-13','14:10:00',5.24),('8902','2014-03-13','14:15:00',5.48),('8902','2014-03-13','14:20:00',5.73),('8902','2014-03-13','14:25:00',5.64),('8902','2014-03-13','14:30:00',5.23),('8902','2014-03-13','14:35:00',4.83),('8902','2014-03-13','14:40:00',4.02),('8902','2014-03-13','14:45:00',3.25),('8902','2014-03-13','14:50:00',2.82),('8902','2014-03-13','14:55:00',2.6),('8902','2014-03-13','15:00:00',2.39),('8902','2014-03-13','15:05:00',2.37),('8902','2014-03-13','15:10:00',2.28),('8902','2014-03-13','15:15:00',2.35),('8902','2014-03-13','15:20:00',2.61),('8902','2014-03-13','15:25:00',2.7),('8902','2014-03-13','15:30:00',2.9),('8902','2014-03-13','15:35:00',3.07),('8902','2014-03-13','15:40:00',2.75),('8902','2014-03-13','15:45:00',2.38),('8902','2014-03-13','15:50:00',2.21),('8902','2014-03-13','15:55:00',2.25),('8902','2014-03-13','16:00:00',2.07),('8902','2014-03-13','16:05:00',2.01),('8902','2014-03-13','16:10:00',1.81),('8902','2014-03-13','16:15:00',1.48),('8902','2014-03-13','16:20:00',1.28),('8902','2014-03-13','16:25:00',1.18),('8902','2014-03-13','16:30:00',1.13),('8902','2014-03-13','16:35:00',1.05),('8902','2014-03-12','07:30:00',1.12),('8902','2014-03-12','07:35:00',1.31),('8902','2014-03-12','07:40:00',1.48),('8902','2014-03-12','07:45:00',1.65),('8902','2014-03-12','07:50:00',1.82),('8902','2014-03-12','07:55:00',2.03),('8902','2014-03-12','08:00:00',2.22),('8902','2014-03-12','08:05:00',2.41),('8902','2014-03-12','08:10:00',2.6),('8902','2014-03-12','08:15:00',2.78),('8902','2014-03-12','08:20:00',2.94),('8902','2014-03-12','08:25:00',3.13),('8902','2014-03-12','08:30:00',3.3),('8902','2014-03-12','08:35:00',3.49),('8902','2014-03-12','08:40:00',3.68),('8902','2014-03-12','08:45:00',3.87),('8902','2014-03-12','08:50:00',4.06),('8902','2014-03-12','08:55:00',4.23),('8902','2014-03-12','09:00:00',4.42),('8902','2014-03-12','09:05:00',4.56),('8902','2014-03-12','09:10:00',4.7),('8902','2014-03-12','09:15:00',4.86),('8902','2014-03-12','09:20:00',5),('8902','2014-03-12','09:25:00',5.15),('8902','2014-03-12','09:30:00',5.29),('8902','2014-03-12','09:35:00',5.44),('8902','2014-03-12','09:40:00',5.57),('8902','2014-03-12','09:45:00',5.71),('8902','2014-03-12','09:50:00',5.85),('8902','2014-03-12','09:55:00',5.96),('8902','2014-03-12','10:00:00',6.06),('8902','2014-03-12','10:05:00',6.17),('8902','2014-03-12','10:10:00',6.28),('8902','2014-03-12','10:15:00',6.39),('8902','2014-03-12','10:20:00',6.45),('8902','2014-03-12','10:25:00',6.54),('8902','2014-03-12','10:30:00',6.64),('8902','2014-03-12','10:35:00',6.69),('8902','2014-03-12','10:40:00',6.74),('8902','2014-03-12','10:45:00',6.82),('8902','2014-03-12','10:50:00',6.88),('8902','2014-03-12','10:55:00',6.95),('8902','2014-03-12','11:00:00',7),('8902','2014-03-12','11:05:00',7.04),('8902','2014-03-12','11:10:00',7.13),('8902','2014-03-12','11:15:00',7.16),('8902','2014-03-12','11:20:00',7.22),('8902','2014-03-12','11:25:00',7.25),('8902','2014-03-12','11:30:00',7.3),('8902','2014-03-12','11:35:00',7.34),('8902','2014-03-12','11:40:00',7.37),('8902','2014-03-12','11:45:00',7.46),('8902','2014-03-12','11:50:00',7.44),('8902','2014-03-12','11:55:00',7.51),('8902','2014-03-12','12:00:00',7.5),('8902','2014-03-12','12:05:00',7.45),('8902','2014-03-12','12:10:00',7.45),('8902','2014-03-12','12:15:00',7.43),('8902','2014-03-12','12:20:00',7.47),('8902','2014-03-12','12:25:00',7.5),('8902','2014-03-12','12:30:00',7.54),('8902','2014-03-12','12:35:00',7.52),('8902','2014-03-12','12:40:00',7.44),('8902','2014-03-12','12:45:00',7.43),('8902','2014-03-12','12:50:00',7.4),('8902','2014-03-12','12:55:00',7.37),('8902','2014-03-12','13:00:00',7.33),('8902','2014-03-12','13:05:00',7.3),('8902','2014-03-12','13:10:00',7.22),('8902','2014-03-12','13:15:00',7.08),('8902','2014-03-12','13:20:00',7.16),('8902','2014-03-12','13:25:00',7.18),('8902','2014-03-12','13:30:00',7.22),('8902','2014-03-12','13:35:00',7.19),('8902','2014-03-12','13:40:00',7.12),('8902','2014-03-12','13:45:00',6.99),('8902','2014-03-12','13:50:00',6.9),('8902','2014-03-12','13:55:00',6.8),('8902','2014-03-12','14:00:00',6.73),('8902','2014-03-12','14:05:00',6.67),('8902','2014-03-12','14:10:00',6.63),('8902','2014-03-12','14:15:00',6.6),('8902','2014-03-12','14:20:00',6.51),('8902','2014-03-12','14:25:00',6.39),('8902','2014-03-12','14:30:00',6.29),('8902','2014-03-12','14:35:00',6.21),('8902','2014-03-12','14:40:00',6.14),('8902','2014-03-12','14:45:00',6.01),('8902','2014-03-12','14:50:00',5.9),('8902','2014-03-12','14:55:00',5.78),('8902','2014-03-12','15:00:00',5.66),('8902','2014-03-12','15:05:00',5.56),('8902','2014-03-12','15:10:00',5.42),('8902','2014-03-12','15:15:00',5.3),('8902','2014-03-12','15:20:00',5.15),('8902','2014-03-12','15:25:00',4.97),('8902','2014-03-12','15:30:00',4.86),('8902','2014-03-12','15:35:00',4.71),('8902','2014-03-12','15:40:00',4.53),('8902','2014-03-12','15:45:00',4.4),('8902','2014-03-12','15:50:00',4.18),('8902','2014-03-12','15:55:00',4.04),('8902','2014-03-12','16:00:00',3.86),('8902','2014-03-12','16:05:00',3.64),('8902','2014-03-12','16:10:00',3.48),('8902','2014-03-12','16:15:00',3.28),('8902','2014-03-12','16:20:00',3.11),('8902','2014-03-12','16:25:00',2.99),('8902','2014-03-12','16:30:00',2.72),('8902','2014-03-12','16:35:00',2.44),('8902','2014-03-12','16:40:00',2.38),('8902','2014-03-12','16:45:00',2.17),('8902','2014-03-12','16:50:00',2),('8902','2014-03-12','16:55:00',1.83),('8902','2014-03-12','17:00:00',1.63),('8902','2014-03-12','17:05:00',1.42),('8902','2014-03-12','17:10:00',1.23),('8902','2014-03-12','17:15:00',1.04),('8902','2014-03-11','07:35:00',1.16),('8902','2014-03-11','07:40:00',1.32),('8902','2014-03-11','07:45:00',1.47),('8902','2014-03-11','07:50:00',1.67),('8902','2014-03-11','07:55:00',1.85),('8902','2014-03-11','08:00:00',2.04),('8902','2014-03-11','08:05:00',2.24),('8902','2014-03-11','08:10:00',2.45),('8902','2014-03-11','08:15:00',2.64),('8902','2014-03-11','08:20:00',2.82),('8902','2014-03-11','08:25:00',3.01),('8902','2014-03-11','08:30:00',3.2),('8902','2014-03-11','08:35:00',3.41),('8902','2014-03-11','08:40:00',3.59),('8902','2014-03-11','08:45:00',3.8),('8902','2014-03-11','08:50:00',3.98),('8902','2014-03-11','08:55:00',4.16),('8902','2014-03-11','09:00:00',4.34),('8902','2014-03-11','09:05:00',4.5),('8902','2014-03-11','09:10:00',4.67),('8902','2014-03-11','09:15:00',4.83),('8902','2014-03-11','09:20:00',4.98),('8902','2014-03-11','09:25:00',5.11),('8902','2014-03-11','09:30:00',5.25),('8902','2014-03-11','09:35:00',5.39),('8902','2014-03-11','09:40:00',5.52),('8902','2014-03-11','09:45:00',5.66),('8902','2014-03-11','09:50:00',5.79),('8902','2014-03-11','09:55:00',5.92),('8902','2014-03-11','10:00:00',6.06),('8902','2014-03-11','10:05:00',6.17),('8902','2014-03-11','10:10:00',6.27),('8902','2014-03-11','10:15:00',6.37),('8902','2014-03-11','10:20:00',6.44),('8902','2014-03-11','10:25:00',6.53),('8902','2014-03-11','10:30:00',6.62),('8902','2014-03-11','10:35:00',6.72),('8902','2014-03-11','10:40:00',6.83),('8902','2014-03-11','10:45:00',6.97),('8902','2014-03-11','10:50:00',7.06),('8902','2014-03-11','10:55:00',7.1),('8902','2014-03-11','11:00:00',7.17),('8902','2014-03-11','11:05:00',7.26),('8902','2014-03-11','11:10:00',7.31),('8902','2014-03-11','11:15:00',7.38),('8902','2014-03-11','11:20:00',7.46),('8902','2014-03-11','11:25:00',7.53),('8902','2014-03-11','11:30:00',7.56),('8902','2014-03-11','11:35:00',7.61),('8902','2014-03-11','11:40:00',7.67),('8902','2014-03-11','11:45:00',7.67),('8902','2014-03-11','11:50:00',7.7),('8902','2014-03-11','11:55:00',7.73),('8902','2014-03-11','12:00:00',7.71),('8902','2014-03-11','12:05:00',7.74),('8902','2014-03-11','12:10:00',7.75),('8902','2014-03-11','12:15:00',7.76),('8902','2014-03-11','12:20:00',7.72),('8902','2014-03-11','12:25:00',7.69),('8902','2014-03-11','12:30:00',7.68),('8902','2014-03-11','12:35:00',7.67),('8902','2014-03-11','12:40:00',7.62),('8902','2014-03-11','12:45:00',7.65),('8902','2014-03-11','12:50:00',7.63),('8902','2014-03-11','12:55:00',7.59),('8902','2014-03-11','13:00:00',7.6),('8902','2014-03-11','13:05:00',7.55),('8902','2014-03-11','13:10:00',7.48),('8902','2014-03-11','13:15:00',7.48),('8902','2014-03-11','13:20:00',7.43),('8902','2014-03-11','13:25:00',7.39),('8902','2014-03-11','13:30:00',7.3),('8902','2014-03-11','13:35:00',7.29),('8902','2014-03-11','13:40:00',7.22),('8902','2014-03-11','13:45:00',7.15),('8902','2014-03-11','13:50:00',7.14),('8902','2014-03-11','13:55:00',7.06),('8902','2014-03-11','14:00:00',7.02),('8902','2014-03-11','14:05:00',7.01),('8902','2014-03-11','14:10:00',6.84),('8902','2014-03-11','14:15:00',6.79),('8902','2014-03-11','14:20:00',6.66),('8902','2014-03-11','14:25:00',6.57),('8902','2014-03-11','14:30:00',6.49),('8902','2014-03-11','14:35:00',6.29),('8902','2014-03-11','14:40:00',6.15),('8902','2014-03-11','14:45:00',5.99),('8902','2014-03-11','14:50:00',5.89),('8902','2014-03-11','14:55:00',5.61),('8902','2014-03-11','15:00:00',5.58),('8902','2014-03-11','15:05:00',5.5),('8902','2014-03-11','15:10:00',5.36),('8902','2014-03-11','15:15:00',5.2),('8902','2014-03-11','15:20:00',5.13),('8902','2014-03-11','15:25:00',4.92),('8902','2014-03-11','15:30:00',4.73),('8902','2014-03-11','15:35:00',4.58),('8902','2014-03-11','15:40:00',4.46),('8902','2014-03-11','15:45:00',4.34),('8902','2014-03-11','15:50:00',4.15),('8902','2014-03-11','15:55:00',4.06),('8902','2014-03-11','16:00:00',3.95),('8902','2014-03-11','16:05:00',3.67),('8902','2014-03-11','16:10:00',3.49),('8902','2014-03-11','16:15:00',3.34),('8902','2014-03-11','16:20:00',3.19),('8902','2014-03-11','16:25:00',2.96),('8902','2014-03-11','16:30:00',2.69),('8902','2014-03-11','16:35:00',2.39),('8902','2014-03-11','16:40:00',2.37),('8902','2014-03-11','16:45:00',2.19),('8902','2014-03-11','16:50:00',1.97),('8902','2014-03-11','16:55:00',1.75),('8902','2014-03-11','17:00:00',1.54),('8902','2014-03-11','17:05:00',1.32),('8902','2014-03-11','17:10:00',1.15),('8902','2014-03-11','17:15:00',1),('8902','2014-03-10','07:45:00',1.05),('8902','2014-03-10','07:50:00',1.05),('8902','2014-03-10','07:55:00',1.09),('8902','2014-03-10','08:00:00',1.11),('8902','2014-03-10','10:10:00',1.09),('8902','2014-03-10','10:15:00',1.34),('8902','2014-03-10','10:20:00',1.63),('8902','2014-03-10','10:25:00',1.66),('8902','2014-03-10','10:30:00',1.71),('8902','2014-03-10','10:35:00',1.74),('8902','2014-03-10','10:40:00',1.7),('8902','2014-03-10','10:45:00',1.58),('8902','2014-03-10','10:50:00',1.41),('8902','2014-03-10','10:55:00',1.5),('8902','2014-03-10','11:00:00',1.74),('8902','2014-03-10','11:05:00',1.79),('8902','2014-03-10','11:10:00',1.84),('8902','2014-03-10','11:15:00',1.89),('8902','2014-03-10','11:20:00',1.69),('8902','2014-03-10','11:25:00',1.7),('8902','2014-03-10','11:30:00',1.71),('8902','2014-03-10','11:35:00',1.9),('8902','2014-03-10','11:40:00',2.02),('8902','2014-03-10','11:45:00',2.05),('8902','2014-03-10','11:50:00',1.77),('8902','2014-03-10','11:55:00',1.92),('8902','2014-03-10','12:00:00',2),('8902','2014-03-10','12:05:00',2.03),('8902','2014-03-10','12:10:00',2.14),('8902','2014-03-10','12:15:00',2.37),('8902','2014-03-10','12:20:00',2.53),('8902','2014-03-10','12:25:00',2.3),('8902','2014-03-10','12:30:00',2.2),('8902','2014-03-10','12:35:00',2.33),('8902','2014-03-10','12:40:00',2.52),('8902','2014-03-10','12:45:00',2.41),('8902','2014-03-10','12:50:00',2.37),('8902','2014-03-10','12:55:00',2.21),('8902','2014-03-10','13:00:00',1.99),('8902','2014-03-10','13:05:00',2.33),('8902','2014-03-10','13:10:00',2.42),('8902','2014-03-10','13:15:00',2.4),('8902','2014-03-10','13:20:00',2.42),('8902','2014-03-10','13:25:00',2.06),('8902','2014-03-10','13:30:00',2),('8902','2014-03-10','13:35:00',1.9),('8902','2014-03-10','13:40:00',1.99),('8902','2014-03-10','13:45:00',2.57),('8902','2014-03-10','13:50:00',3.09),('8902','2014-03-10','13:55:00',3.65),('8902','2014-03-10','14:00:00',3.72),('8902','2014-03-10','14:05:00',4.02),('8902','2014-03-10','14:10:00',5.26),('8902','2014-03-10','14:15:00',4.76),('8902','2014-03-10','14:20:00',3.97),('8902','2014-03-10','14:25:00',3.75),('8902','2014-03-10','14:30:00',2.57),('8902','2014-03-10','14:35:00',2.66),('8902','2014-03-10','14:40:00',2.63),('8902','2014-03-10','14:45:00',2.72),('8902','2014-03-10','14:50:00',2.5),('8902','2014-03-10','14:55:00',2.59),('8902','2014-03-10','15:00:00',3.05),('8902','2014-03-10','15:05:00',3.45),('8902','2014-03-10','15:10:00',3.69),('8902','2014-03-10','15:15:00',2.92),('8902','2014-03-10','15:20:00',2.73),('8902','2014-03-10','15:25:00',2.48),('8902','2014-03-10','15:30:00',2.41),('8902','2014-03-10','15:35:00',2.14),('8902','2014-03-10','15:40:00',2.13),('8902','2014-03-10','15:45:00',1.99),('8902','2014-03-10','15:50:00',1.99),('8902','2014-03-10','15:55:00',1.65),('8902','2014-03-10','16:00:00',1.51),('8902','2014-03-10','16:05:00',1.51),('8902','2014-03-10','16:10:00',1.55),('8902','2014-03-10','16:15:00',1.5),('8902','2014-03-10','16:20:00',1.48),('8902','2014-03-10','16:25:00',1.3),('8902','2014-03-10','16:30:00',1.18),('8902','2014-03-10','16:35:00',1.05),('8902','2014-03-09','08:15:00',1.07),('8902','2014-03-09','08:20:00',1.15),('8902','2014-03-09','08:25:00',1.25),('8902','2014-03-09','08:30:00',1.38),('8902','2014-03-09','08:35:00',1.59),('8902','2014-03-09','08:40:00',1.71),('8902','2014-03-09','08:45:00',1.69),('8902','2014-03-09','08:50:00',1.75),('8902','2014-03-09','08:55:00',1.76),('8902','2014-03-09','09:00:00',1.82),('8902','2014-03-09','09:05:00',1.97),('8902','2014-03-09','09:10:00',2.05),('8902','2014-03-09','09:15:00',1.93),('8902','2014-03-09','09:20:00',1.89),('8902','2014-03-09','09:25:00',1.87),('8902','2014-03-09','09:30:00',1.96),('8902','2014-03-09','09:35:00',1.87),('8902','2014-03-09','09:40:00',1.9),('8902','2014-03-09','09:45:00',1.73),('8902','2014-03-09','09:50:00',1.51),('8902','2014-03-09','09:55:00',1.43),('8902','2014-03-09','10:00:00',1.28),('8902','2014-03-09','10:05:00',1.42),('8902','2014-03-09','10:10:00',1.83),('8902','2014-03-09','10:15:00',2.14),('8902','2014-03-09','10:20:00',1.78),('8902','2014-03-09','10:25:00',1.75),('8902','2014-03-09','10:30:00',2.15),('8902','2014-03-09','10:35:00',2.36),('8902','2014-03-09','10:40:00',1.61),('8902','2014-03-09','10:45:00',1.02),('8902','2014-03-09','11:05:00',1.08),('8902','2014-03-09','11:10:00',1.41),('8902','2014-03-09','11:15:00',1.69),('8902','2014-03-09','11:20:00',1.87),('8902','2014-03-09','11:25:00',1.73),('8902','2014-03-09','11:30:00',1.51),('8902','2014-03-09','11:35:00',1.01),('8902','2014-03-09','12:15:00',1.01),('8902','2014-03-09','12:20:00',1.09),('8902','2014-03-09','12:25:00',1.17),('8902','2014-03-09','12:30:00',1.32),('8902','2014-03-09','12:35:00',1.51),('8902','2014-03-09','12:40:00',1.71),('8902','2014-03-09','12:45:00',1.96),('8902','2014-03-09','12:50:00',2.16),('8902','2014-03-09','12:55:00',2.32),('8902','2014-03-09','13:00:00',2.44),('8902','2014-03-09','13:05:00',2.52),('8902','2014-03-09','13:10:00',3),('8902','2014-03-09','13:15:00',3.41),('8902','2014-03-09','13:20:00',3.09),('8902','2014-03-09','13:25:00',2.77),('8902','2014-03-09','13:30:00',2.28),('8902','2014-03-09','13:35:00',1.92),('8902','2014-03-09','13:40:00',1.73),('8902','2014-03-09','13:45:00',1.64),('8902','2014-03-09','13:50:00',2.32),('8902','2014-03-09','13:55:00',1.99),('8902','2014-03-09','14:00:00',2.07),('8902','2014-03-09','14:05:00',2.93),('8902','2014-03-09','14:10:00',3.64),('8902','2014-03-09','14:15:00',5.25),('8902','2014-03-09','14:20:00',3.36),('8902','2014-03-09','14:25:00',3.06),('8902','2014-03-09','14:30:00',2.57),('8902','2014-03-09','14:35:00',4.88),('8902','2014-03-09','14:40:00',5.9),('8902','2014-03-09','14:45:00',3.73),('8902','2014-03-09','14:50:00',4.43),('8902','2014-03-09','14:55:00',3.14),('8902','2014-03-09','15:00:00',2.98),('8902','2014-03-09','15:05:00',2.24),('8902','2014-03-09','15:10:00',1.96),('8902','2014-03-09','15:15:00',2.26),('8902','2014-03-09','15:20:00',5.03),('8902','2014-03-09','15:25:00',4.45),('8902','2014-03-09','15:30:00',2.73),('8902','2014-03-09','15:35:00',2.37),('8902','2014-03-09','15:40:00',2.47),('8902','2014-03-09','15:45:00',2.01),('8902','2014-03-09','15:50:00',1.89),('8902','2014-03-09','15:55:00',1.81),('8902','2014-03-09','16:00:00',1.93),('8902','2014-03-09','16:05:00',2.13),('8902','2014-03-09','16:10:00',1.68),('8902','2014-03-09','16:15:00',1.53),('8902','2014-03-09','16:20:00',1.69),('8902','2014-03-09','16:25:00',2.21),('8902','2014-03-09','16:30:00',2.21),('8902','2014-03-09','16:35:00',1.15),('8902','2014-03-09','16:50:00',1.01),('8902','2014-03-09','16:55:00',1.52),('8902','2014-03-09','17:00:00',1.25),('8902','2014-03-08','07:50:00',1.49),('8902','2014-03-08','07:55:00',1.69),('8902','2014-03-08','08:00:00',1.86),('8902','2014-03-08','08:05:00',2.05),('8902','2014-03-08','08:10:00',2.2),('8902','2014-03-08','08:15:00',2.32),('8902','2014-03-08','08:20:00',2.08),('8902','2014-03-08','08:25:00',1.43),('8902','2014-03-08','08:30:00',1.92),('8902','2014-03-08','08:35:00',1.99),('8902','2014-03-08','08:40:00',2.31),('8902','2014-03-08','08:45:00',1.47),('8902','2014-03-08','08:50:00',2.29),('8902','2014-03-08','08:55:00',2.79),('8902','2014-03-08','09:00:00',3.45),('8902','2014-03-08','09:05:00',2.47),('8902','2014-03-08','09:15:00',2.55),('8902','2014-03-08','09:20:00',5.02),('8902','2014-03-08','09:25:00',5.29),('8902','2014-03-08','09:30:00',3.46),('8902','2014-03-08','09:35:00',4.31),('8902','2014-03-08','09:40:00',5.99),('8902','2014-03-08','09:45:00',6.08),('8902','2014-03-08','09:50:00',6.15),('8902','2014-03-08','09:55:00',6.15),('8902','2014-03-08','10:00:00',6.23),('8902','2014-03-08','10:05:00',6.35),('8902','2014-03-08','10:10:00',6.55),('8902','2014-03-08','10:15:00',6.56),('8902','2014-03-08','10:20:00',6.58),('8902','2014-03-08','10:25:00',6.11),('8902','2014-03-08','10:30:00',6.85),('8902','2014-03-08','10:35:00',6.93),('8902','2014-03-08','10:40:00',7.02),('8902','2014-03-08','10:45:00',7.08),('8902','2014-03-08','10:50:00',7.22),('8902','2014-03-08','10:55:00',7.5),('8902','2014-03-08','11:00:00',7.21),('8902','2014-03-08','11:05:00',8.14),('8902','2014-03-08','11:10:00',7.53),('8902','2014-03-08','11:15:00',8.69),('8902','2014-03-08','11:20:00',8.39),('8902','2014-03-08','11:25:00',8.03),('8902','2014-03-08','11:30:00',5.13),('8902','2014-03-08','11:35:00',7.71),('8902','2014-03-08','11:40:00',4.64),('8902','2014-03-08','11:45:00',4.69),('8902','2014-03-08','11:50:00',6.58),('8902','2014-03-08','11:55:00',8.79),('8902','2014-03-08','12:00:00',8.22),('8902','2014-03-08','12:05:00',9.1),('8902','2014-03-08','12:10:00',8.98),('8902','2014-03-08','12:15:00',8.82),('8902','2014-03-08','12:20:00',8.74),('8902','2014-03-08','12:25:00',8.62),('8902','2014-03-08','12:30:00',8.69),('8902','2014-03-08','12:35:00',8.87),('8902','2014-03-08','12:40:00',8.57),('8902','2014-03-08','12:45:00',8.46),('8902','2014-03-08','12:50:00',8.49),('8902','2014-03-08','12:55:00',8.5),('8902','2014-03-08','13:00:00',8.64),('8902','2014-03-08','13:05:00',8.64),('8902','2014-03-08','13:10:00',8.58),('8902','2014-03-08','13:15:00',8.04),('8902','2014-03-08','13:20:00',7.91),('8902','2014-03-08','13:25:00',8.03),('8902','2014-03-08','13:30:00',7.96),('8902','2014-03-08','13:35:00',5.46),('8902','2014-03-08','13:40:00',1.61),('8902','2014-03-08','13:45:00',2.72),('8902','2014-03-08','13:50:00',3.31),('8902','2014-03-08','13:55:00',7.39),('8902','2014-03-08','14:00:00',7.82),('8902','2014-03-08','14:05:00',7.47),('8902','2014-03-08','14:10:00',7.36),('8902','2014-03-08','14:15:00',6.74),('8902','2014-03-08','14:20:00',7.36),('8902','2014-03-08','14:25:00',3.12),('8902','2014-03-08','14:30:00',2.05),('8902','2014-03-08','14:35:00',2.87),('8902','2014-03-08','14:40:00',6.39),('8902','2014-03-08','14:45:00',7.01),('8902','2014-03-08','14:50:00',6.56),('8902','2014-03-08','14:55:00',6.38),('8902','2014-03-08','15:00:00',6.18),('8902','2014-03-08','15:05:00',4.22),('8902','2014-03-08','15:10:00',5.96),('8902','2014-03-08','15:15:00',5.72),('8902','2014-03-08','15:20:00',5.57),('8902','2014-03-08','15:25:00',5.48),('8902','2014-03-08','15:30:00',5.41),('8902','2014-03-08','15:35:00',5.11),('8902','2014-03-08','15:40:00',4.9),('8902','2014-03-08','15:45:00',3.22),('8902','2014-03-08','15:50:00',2.29),('8902','2014-03-08','15:55:00',4.46),('8902','2014-03-08','16:00:00',4.19),('8902','2014-03-08','16:05:00',3.81),('8902','2014-03-08','16:10:00',2.84),('8902','2014-03-08','16:15:00',1.9),('8902','2014-03-08','16:20:00',3.04),('8902','2014-03-08','16:25:00',2.99),('8902','2014-03-08','16:30:00',2.76),('8902','2014-03-08','16:35:00',2.65),('8902','2014-03-08','16:40:00',2.57),('8902','2014-03-08','16:45:00',2.27),('8902','2014-03-08','16:50:00',2.03),('8902','2014-03-08','16:55:00',1.8),('8902','2014-03-08','17:00:00',1.45),('8902','2014-03-08','17:10:00',1.14),('8902','2014-03-07','07:40:00',1.13),('8902','2014-03-07','07:45:00',1.31),('8902','2014-03-07','07:50:00',1.48),('8902','2014-03-07','07:55:00',1.65),('8902','2014-03-07','08:00:00',1.83),('8902','2014-03-07','08:05:00',2.03),('8902','2014-03-07','08:10:00',2.24),('8902','2014-03-07','08:15:00',2.44),('8902','2014-03-07','08:20:00',2.63),('8902','2014-03-07','08:25:00',2.83),('8902','2014-03-07','08:30:00',3.03),('8902','2014-03-07','08:35:00',3.2),('8902','2014-03-07','08:40:00',3.42),('8902','2014-03-07','08:45:00',3.59),('8902','2014-03-07','08:50:00',3.79),('8902','2014-03-07','08:55:00',3.99),('8902','2014-03-07','09:00:00',4.18),('8902','2014-03-07','09:05:00',4.36),('8902','2014-03-07','09:10:00',4.54),('8902','2014-03-07','09:15:00',4.7),('8902','2014-03-07','09:20:00',4.87),('8902','2014-03-07','09:25:00',5),('8902','2014-03-07','09:30:00',5.15),('8902','2014-03-07','09:35:00',5.32),('8902','2014-03-07','09:40:00',5.45),('8902','2014-03-07','09:45:00',5.57),('8902','2014-03-07','09:50:00',5.72),('8902','2014-03-07','09:55:00',5.83),('8902','2014-03-07','10:00:00',5.95),('8902','2014-03-07','10:05:00',6.07),('8902','2014-03-07','10:10:00',6.18),('8902','2014-03-07','10:15:00',6.29),('8902','2014-03-07','10:20:00',6.38),('8902','2014-03-07','10:25:00',6.52),('8902','2014-03-07','10:30:00',6.65),('8902','2014-03-07','10:35:00',6.79),('8902','2014-03-07','10:40:00',6.86),('8902','2014-03-07','10:45:00',6.92),('8902','2014-03-07','10:50:00',6.99),('8902','2014-03-07','10:55:00',7.06),('8902','2014-03-07','11:00:00',7.13),('8902','2014-03-07','11:05:00',7.17),('8902','2014-03-07','11:10:00',7.24),('8902','2014-03-07','11:15:00',7.36),('8902','2014-03-07','11:20:00',7.51),('8902','2014-03-07','11:25:00',7.77),('8902','2014-03-07','11:30:00',8.1),('8902','2014-03-07','11:35:00',5.35),('8902','2014-03-07','11:40:00',3.9),('8902','2014-03-07','11:45:00',2.91),('8902','2014-03-07','11:50:00',3.44),('8902','2014-03-07','11:55:00',7.04),('8902','2014-03-07','12:00:00',2.46),('8902','2014-03-07','12:05:00',2.04),('8902','2014-03-07','12:10:00',2.08),('8902','2014-03-07','12:15:00',2.26),('8902','2014-03-07','12:20:00',2.62),('8902','2014-03-07','12:25:00',2.86),('8902','2014-03-07','12:30:00',4.73),('8902','2014-03-07','12:35:00',7),('8902','2014-03-07','12:40:00',3.84),('8902','2014-03-07','12:45:00',4.03),('8902','2014-03-07','12:50:00',5.68),('8902','2014-03-07','12:55:00',8.03),('8902','2014-03-07','13:00:00',3.27),('8902','2014-03-07','13:05:00',3.06),('8902','2014-03-07','13:10:00',2.62),('8902','2014-03-07','13:15:00',2.05),('8902','2014-03-07','13:20:00',1.82),('8902','2014-03-07','13:25:00',2.18),('8902','2014-03-07','13:30:00',4.7),('8902','2014-03-07','13:35:00',3.31),('8902','2014-03-07','13:40:00',6.13),('8902','2014-03-07','13:45:00',5.56),('8902','2014-03-07','13:50:00',3.42),('8902','2014-03-07','13:55:00',2.51),('8902','2014-03-07','14:00:00',2.01),('8902','2014-03-07','14:05:00',1.9),('8902','2014-03-07','14:10:00',1.72),('8902','2014-03-07','14:15:00',1.45),('8902','2014-03-07','14:20:00',1.41),('8902','2014-03-07','14:25:00',1.38),('8902','2014-03-07','14:30:00',1.55),('8902','2014-03-07','14:35:00',1.83),('8902','2014-03-07','14:40:00',1.97),('8902','2014-03-07','14:45:00',1.81),('8902','2014-03-07','14:50:00',1.88),('8902','2014-03-07','14:55:00',1.95),('8902','2014-03-07','15:00:00',1.66),('8902','2014-03-07','15:05:00',1.51),('8902','2014-03-07','15:10:00',1.65),('8902','2014-03-07','15:15:00',2.21),('8902','2014-03-07','15:20:00',3.87),('8902','2014-03-07','15:25:00',4.32),('8902','2014-03-07','15:30:00',2.62),('8902','2014-03-07','15:35:00',1.31),('8902','2014-03-07','15:40:00',1.25),('8902','2014-03-07','15:45:00',1.3),('8902','2014-03-07','15:50:00',1.57),('8902','2014-03-07','15:55:00',1.77),('8902','2014-03-07','16:00:00',2.93),('8902','2014-03-07','16:05:00',2.61),('8902','2014-03-07','16:10:00',1.35),('8902','2014-03-07','16:15:00',1.38),('8902','2014-03-07','16:20:00',1.44),('8902','2014-03-07','16:25:00',1.39),('8902','2014-03-07','16:30:00',2.91),('8902','2014-03-07','16:35:00',2.95),('8902','2014-03-07','16:40:00',2.59),('8902','2014-03-07','16:45:00',2.37),('8902','2014-03-07','16:50:00',2.15),('8902','2014-03-07','16:55:00',1.81),('8902','2014-03-07','17:00:00',1.7),('8902','2014-03-07','17:05:00',1.48),('8902','2014-03-07','17:10:00',1.3),('8902','2014-03-07','17:15:00',1.14),('8902','2014-04-29','07:40:00',1.15),('8902','2014-04-29','07:45:00',1.47),('8902','2014-04-29','07:50:00',1.64),('8902','2014-04-29','07:55:00',1.81),('8902','2014-04-29','08:00:00',1.98),('8902','2014-04-29','08:05:00',2.1),('8902','2014-04-29','08:10:00',2.33),('8902','2014-04-29','08:15:00',2.5),('8902','2014-04-29','08:20:00',2.67),('8902','2014-04-29','08:25:00',2.84),('8902','2014-04-29','08:30:00',3.01),('8902','2014-04-29','08:35:00',3.19),('8902','2014-04-29','08:40:00',3.39),('8902','2014-04-29','08:45:00',3.54),('8902','2014-04-29','08:50:00',3.76),('8902','2014-04-29','08:55:00',3.98),('8902','2014-04-29','09:00:00',4.1),('8902','2014-04-29','09:05:00',4.36),('8902','2014-04-29','09:10:00',4.81),('8902','2014-04-29','09:15:00',5.43),('8902','2014-04-29','09:20:00',3.88),('8902','2014-04-29','09:25:00',2.96),('8902','2014-04-29','09:30:00',2.29),('8902','2014-04-29','09:35:00',3.4),('8902','2014-04-29','09:40:00',5.46),('8902','2014-04-29','09:45:00',5.34),('8902','2014-04-29','09:50:00',3.86),('8902','2014-04-29','09:55:00',4.73),('8902','2014-04-29','10:00:00',6.23),('8902','2014-04-29','10:05:00',6.54),('8902','2014-04-29','10:10:00',2.93),('8902','2014-04-29','10:15:00',5.55),('8902','2014-04-29','10:20:00',3.75),('8902','2014-04-29','10:25:00',3.58),('8902','2014-04-29','10:30:00',3.39),('8902','2014-04-29','10:35:00',4.08),('8902','2014-04-29','10:40:00',4.18),('8902','2014-04-29','10:45:00',3.46),('8902','2014-04-29','10:50:00',2.86),('8902','2014-04-29','10:55:00',6.47),('8902','2014-04-29','11:00:00',8.9),('8902','2014-04-29','11:05:00',6.33),('8902','2014-04-29','11:10:00',5.77),('8902','2014-04-29','11:15:00',5.13),('8902','2014-04-29','11:20:00',3.19),('8902','2014-04-29','11:25:00',4.43),('8902','2014-04-29','11:30:00',4.5),('8902','2014-04-29','11:35:00',3.92),('8902','2014-04-29','11:40:00',5.55),('8902','2014-04-29','11:45:00',3.5),('8902','2014-04-29','11:50:00',5.74),('8902','2014-04-29','11:55:00',4.85),('8902','2014-04-29','12:00:00',7.74),('8902','2014-04-29','12:05:00',3.1),('8902','2014-04-29','12:10:00',2.7),('8902','2014-04-29','12:15:00',3.64),('8902','2014-04-29','12:20:00',3.71),('8902','2014-04-29','12:25:00',3.14),('8902','2014-04-29','12:30:00',3.52),('8902','2014-04-29','12:35:00',3.01),('8902','2014-04-29','12:40:00',2.93),('8902','2014-04-29','12:45:00',3.1),('8902','2014-04-29','12:50:00',3.42),('8902','2014-04-29','12:55:00',7.58),('8902','2014-04-29','13:00:00',9.28),('8902','2014-04-29','13:05:00',6.55),('8902','2014-04-29','13:10:00',6.03),('8902','2014-04-29','13:15:00',5.23),('8902','2014-04-29','13:20:00',4.27),('8902','2014-04-29','13:25:00',4.75),('8902','2014-04-29','13:30:00',4.38),('8902','2014-04-29','13:35:00',3.82),('8902','2014-04-29','13:40:00',5.89),('8902','2014-04-29','13:45:00',6.17),('8902','2014-04-29','13:50:00',4.97),('8902','2014-04-29','13:55:00',8.75),('8902','2014-04-29','14:00:00',5.12),('8902','2014-04-29','14:05:00',4.63),('8902','2014-04-29','14:10:00',3.19),('8902','2014-04-29','14:15:00',3.53),('8902','2014-04-29','14:20:00',5.43),('8902','2014-04-29','14:25:00',6.66),('8902','2014-04-29','14:30:00',8.86),('8902','2014-04-29','14:35:00',8.27),('8902','2014-04-29','14:40:00',4.86),('8902','2014-04-29','14:45:00',3.01),('8902','2014-04-29','14:50:00',3.15),('8902','2014-04-29','14:55:00',3.53),('8902','2014-04-29','15:00:00',2.97),('8902','2014-04-29','15:05:00',2.88),('8902','2014-04-29','15:10:00',2.71),('8902','2014-04-29','15:15:00',2.56),('8902','2014-04-29','15:20:00',2.28),('8902','2014-04-29','15:25:00',2.39),('8902','2014-04-29','15:30:00',3.49),('8902','2014-04-29','15:35:00',5.12),('8902','2014-04-29','15:40:00',6.33),('8902','2014-04-29','15:45:00',8.13),('8902','2014-04-29','15:50:00',8.83),('8902','2014-04-29','15:55:00',6.48),('8902','2014-04-29','16:00:00',2.44),('8902','2014-04-29','16:05:00',4.87),('8902','2014-04-29','16:10:00',3.41),('8902','2014-04-29','16:15:00',5.85),('8902','2014-04-29','16:20:00',4.93),('8902','2014-04-29','16:25:00',3.32),('8902','2014-04-29','16:30:00',6.14),('8902','2014-04-29','16:35:00',3.05),('8902','2014-04-29','16:40:00',4.35),('8902','2014-04-29','16:45:00',3.21),('8902','2014-04-29','16:50:00',3.58),('8902','2014-04-29','16:55:00',4.94),('8902','2014-04-29','17:00:00',4.1),('8902','2014-04-29','17:05:00',5.73),('8902','2014-04-29','17:10:00',3.2),('8902','2014-04-29','17:15:00',4.54),('8902','2014-04-29','17:20:00',2.11),('8902','2014-04-29','17:25:00',1.25),('8902','2014-04-29','17:30:00',1.5),('8902','2014-04-29','17:35:00',2.01),('8902','2014-04-29','17:40:00',2.37),('8902','2014-04-29','17:45:00',1.62),('8902','2014-04-29','17:50:00',1.26),('8902','2014-04-29','17:55:00',1.28),('8902','2014-04-29','18:00:00',1.22),('8902','2014-04-29','18:10:00',1),('8902','2014-04-29','18:35:00',1.05),('8902','2014-04-29','18:45:00',1.08),('8902','2014-04-29','18:50:00',1),('8902','2014-03-06','09:25:00',1.04),('8902','2014-03-06','09:30:00',1.09),('8902','2014-03-06','09:35:00',1.32),('8902','2014-03-06','09:40:00',1.09),('8902','2014-03-06','09:50:00',1.03),('8902','2014-03-06','09:55:00',1.28),('8902','2014-03-06','10:00:00',1.1),('8902','2014-03-06','10:05:00',1.18),('8902','2014-03-06','10:10:00',1.21),('8902','2014-03-06','10:15:00',1.19),('8902','2014-03-06','10:20:00',1.27),('8902','2014-03-06','10:25:00',1.06),('8902','2014-03-06','10:30:00',1.34),('8902','2014-03-06','10:35:00',1.51),('8902','2014-03-06','10:40:00',1.27),('8902','2014-03-06','10:45:00',1.19),('8902','2014-03-06','10:50:00',1.23),('8902','2014-03-06','10:55:00',1.33),('8902','2014-03-06','11:00:00',1.5),('8902','2014-03-06','11:05:00',1.26),('8902','2014-03-06','11:10:00',1.11),('8902','2014-03-06','11:15:00',1.21),('8902','2014-03-06','11:20:00',1.5),('8902','2014-03-06','11:25:00',1.51),('8902','2014-03-06','11:30:00',1.8),('8902','2014-03-06','11:35:00',1.64),('8902','2014-03-06','11:40:00',1.61),('8902','2014-03-06','11:45:00',4.33),('8902','2014-03-06','11:50:00',6.13),('8902','2014-03-06','11:55:00',7.58),('8902','2014-03-06','12:00:00',9.22),('8902','2014-03-06','12:05:00',7.92),('8902','2014-03-06','12:10:00',8.88),('8902','2014-03-06','12:15:00',8.47),('8902','2014-03-06','12:20:00',8.63),('8902','2014-03-06','12:25:00',8.59),('8902','2014-03-06','12:30:00',8.73),('8902','2014-03-06','12:35:00',8.4),('8902','2014-03-06','12:40:00',6.86),('8902','2014-03-06','12:45:00',7.8),('8902','2014-03-06','12:50:00',4.29),('8902','2014-03-06','12:55:00',1.5),('8902','2014-03-06','13:00:00',2.04),('8902','2014-03-06','13:05:00',5.4),('8902','2014-03-06','13:10:00',2.15),('8902','2014-03-06','13:15:00',3.42),('8902','2014-03-06','13:20:00',5.76),('8902','2014-03-06','13:25:00',5.77),('8902','2014-03-06','13:30:00',3.7),('8902','2014-03-06','13:35:00',6.35),('8902','2014-03-06','13:40:00',6.45),('8902','2014-03-06','13:45:00',4.81),('8902','2014-03-06','13:50:00',2.7),('8902','2014-03-06','13:55:00',2.24),('8902','2014-03-06','14:00:00',2.17),('8902','2014-03-06','14:05:00',2.1),('8902','2014-03-06','14:10:00',2.11),('8902','2014-03-06','14:15:00',2.05),('8902','2014-03-06','14:20:00',1.93),('8902','2014-03-06','14:25:00',1.9),('8902','2014-03-06','14:30:00',2),('8902','2014-03-06','14:35:00',2.1),('8902','2014-03-06','14:40:00',2.17),('8902','2014-03-06','14:45:00',2.08),('8902','2014-03-06','14:50:00',2.7),('8902','2014-03-06','14:55:00',4.24),('8902','2014-03-06','15:00:00',5.47),('8902','2014-03-06','15:05:00',6.38),('8902','2014-03-06','15:10:00',6.45),('8902','2014-03-06','15:15:00',6.61),('8902','2014-03-06','15:20:00',6.92),('8902','2014-03-06','15:25:00',6.7),('8902','2014-03-06','15:30:00',6.4),('8902','2014-03-06','15:35:00',6.08),('8902','2014-03-06','15:40:00',5.74),('8902','2014-03-06','15:45:00',3.42),('8902','2014-03-06','15:50:00',1.58),('8902','2014-03-06','15:55:00',1.41),('8902','2014-03-06','16:00:00',3.29),('8902','2014-03-06','16:05:00',4.22),('8902','2014-03-06','16:10:00',4.15),('8902','2014-03-06','16:15:00',4.14),('8902','2014-03-06','16:20:00',3.84),('8902','2014-03-06','16:25:00',3.62),('8902','2014-03-06','16:30:00',3.21),('8902','2014-03-06','16:35:00',3.02),('8902','2014-03-06','16:40:00',3.03),('8902','2014-03-06','16:45:00',2.82),('8902','2014-03-06','16:50:00',2.62),('8902','2014-03-06','16:55:00',2.44),('8902','2014-03-06','17:00:00',2.22),('8902','2014-03-06','17:05:00',1.99),('8902','2014-03-06','17:10:00',1.72),('8902','2014-03-06','17:15:00',1.45),('8902','2014-03-06','17:20:00',1.17),('8902','2014-03-05','07:55:00',1.2),('8902','2014-03-05','08:00:00',1.62),('8902','2014-03-05','08:05:00',1.8),('8902','2014-03-05','08:10:00',2.84),('8902','2014-03-05','08:15:00',2.94),('8902','2014-03-05','08:20:00',2.59),('8902','2014-03-05','08:25:00',2.14),('8902','2014-03-05','08:30:00',1.24),('8902','2014-03-05','08:35:00',1.89),('8902','2014-03-05','08:40:00',1.81),('8902','2014-03-05','08:45:00',1.67),('8902','2014-03-05','08:50:00',1.97),('8902','2014-03-05','08:55:00',1.69),('8902','2014-03-05','09:00:00',1.69),('8902','2014-03-05','09:05:00',1.51),('8902','2014-03-05','09:10:00',1.48),('8902','2014-03-05','09:15:00',1.8),('8902','2014-03-05','09:20:00',1.94),('8902','2014-03-05','09:25:00',1.72),('8902','2014-03-05','09:30:00',2.01),('8902','2014-03-05','09:35:00',2.47),('8902','2014-03-05','09:40:00',3.07),('8902','2014-03-05','09:45:00',3.46),('8902','2014-03-05','09:50:00',3.55),('8902','2014-03-05','09:55:00',3.52),('8902','2014-03-05','10:00:00',3.37),('8902','2014-03-05','10:05:00',4.38),('8902','2014-03-05','10:10:00',5.95),('8902','2014-03-05','10:15:00',6.58),('8902','2014-03-05','10:20:00',5.53),('8902','2014-03-05','10:25:00',4.47),('8902','2014-03-05','10:30:00',2.68),('8902','2014-03-05','10:35:00',2.99),('8902','2014-03-05','10:40:00',3.37),('8902','2014-03-05','10:45:00',4.66),('8902','2014-03-05','10:50:00',2.42),('8902','2014-03-05','10:55:00',3.62),('8902','2014-03-05','11:00:00',3.73),('8902','2014-03-05','11:05:00',5.55),('8902','2014-03-05','11:10:00',3.2),('8902','2014-03-05','11:15:00',5.75),('8902','2014-03-05','11:20:00',2.63),('8902','2014-03-05','11:25:00',2.98),('8902','2014-03-05','11:30:00',3.94),('8902','2014-03-05','11:35:00',2.55),('8902','2014-03-05','11:40:00',3.82),('8902','2014-03-05','11:45:00',6.58),('8902','2014-03-05','11:50:00',6.52),('8902','2014-03-05','11:55:00',7.4),('8902','2014-03-05','12:00:00',3.08),('8902','2014-03-05','12:05:00',6.92),('8902','2014-03-05','12:10:00',9.22),('8902','2014-03-05','12:15:00',7.76),('8902','2014-03-05','12:20:00',5.95),('8902','2014-03-05','12:25:00',9.06),('8902','2014-03-05','12:30:00',9.1),('8902','2014-03-05','12:35:00',4.71),('8902','2014-03-05','12:40:00',2.97),('8902','2014-03-05','12:45:00',2.21),('8902','2014-03-05','12:50:00',2),('8902','2014-03-05','12:55:00',2.36),('8902','2014-03-05','13:00:00',2.5),('8902','2014-03-05','13:05:00',2.58),('8902','2014-03-05','13:10:00',2.46),('8902','2014-03-05','13:15:00',3.55),('8902','2014-03-05','13:20:00',2.4),('8902','2014-03-05','13:25:00',2.17),('8902','2014-03-05','13:30:00',2.34),('8902','2014-03-05','13:35:00',2.35),('8902','2014-03-05','13:40:00',2.5),('8902','2014-03-05','13:45:00',2.05),('8902','2014-03-05','13:50:00',1.87),('8902','2014-03-05','13:55:00',1.72),('8902','2014-03-05','14:00:00',1.76),('8902','2014-03-05','14:05:00',2.03),('8902','2014-03-05','14:10:00',2.02),('8902','2014-03-05','14:15:00',1.99),('8902','2014-03-05','14:20:00',2.27),('8902','2014-03-05','14:25:00',2.28),('8902','2014-03-05','14:30:00',2.3),('8902','2014-03-05','14:35:00',2.19),('8902','2014-03-05','14:40:00',1.93),('8902','2014-03-05','14:45:00',1.61),('8902','2014-03-05','14:50:00',1.83),('8902','2014-03-05','14:55:00',1.69),('8902','2014-03-05','15:00:00',1.72),('8902','2014-03-05','15:05:00',2.01),('8902','2014-03-05','15:10:00',2.23),('8902','2014-03-05','15:15:00',1.72),('8902','2014-03-05','15:20:00',1.12),('8902','2014-03-05','15:25:00',1.09),('8902','2014-03-05','15:30:00',1.19),('8902','2014-03-05','15:35:00',1.24),('8902','2014-03-05','15:40:00',1.06),('8902','2014-03-05','15:55:00',1.06),('8902','2014-03-05','16:00:00',1.32),('8902','2014-03-05','16:05:00',1.32),('8902','2014-03-05','16:10:00',1.23),('8902','2014-03-05','16:15:00',1.76),('8902','2014-03-05','16:20:00',2.32),('8902','2014-03-05','16:25:00',3.53),('8902','2014-03-05','16:30:00',1.48),('8902','2014-03-05','16:35:00',1.03),('8902','2014-03-05','16:45:00',1.01),('8902','2014-03-05','16:50:00',1.83),('8902','2014-03-05','16:55:00',2.05),('8902','2014-03-05','17:00:00',1.69),('8902','2014-03-05','17:05:00',1.31),('8902','2014-03-05','17:10:00',1.36),('8902','2014-03-05','17:15:00',1.29),('8902','2014-03-04','07:40:00',1.09),('8902','2014-03-04','07:45:00',1.42),('8902','2014-03-04','07:50:00',1.55),('8902','2014-03-04','07:55:00',1.66),('8902','2014-03-04','08:00:00',1.69),('8902','2014-03-04','08:05:00',1.78),('8902','2014-03-04','08:10:00',1.74),('8902','2014-03-04','08:15:00',1.9),('8902','2014-03-04','08:20:00',1.09),('8902','2014-03-04','08:25:00',1.47),('8902','2014-03-04','08:30:00',3.53),('8902','2014-03-04','08:35:00',3.55),('8902','2014-03-04','08:40:00',4.2),('8902','2014-03-04','08:45:00',3.45),('8902','2014-03-04','08:50:00',1.27),('8902','2014-03-04','08:55:00',2.14),('8902','2014-03-04','09:00:00',4.99),('8902','2014-03-04','09:05:00',1.97),('8902','2014-03-04','09:10:00',1.31),('8902','2014-03-04','09:15:00',3.77),('8902','2014-03-04','09:20:00',5.06),('8902','2014-03-04','09:25:00',5.16),('8902','2014-03-04','09:30:00',5.27),('8902','2014-03-04','09:35:00',5.43),('8902','2014-03-04','09:40:00',5.55),('8902','2014-03-04','09:45:00',5.66),('8902','2014-03-04','09:50:00',5.77),('8902','2014-03-04','09:55:00',5.91),('8902','2014-03-04','10:00:00',6.04),('8902','2014-03-04','10:05:00',6.17),('8902','2014-03-04','10:10:00',6.33),('8902','2014-03-04','10:15:00',6.38),('8902','2014-03-04','10:20:00',6.44),('8902','2014-03-04','10:25:00',6.54),('8902','2014-03-04','10:30:00',6.62),('8902','2014-03-04','10:35:00',6.71),('8902','2014-03-04','10:40:00',6.76),('8902','2014-03-04','10:45:00',6.85),('8902','2014-03-04','10:50:00',6.93),('8902','2014-03-04','10:55:00',7.02),('8902','2014-03-04','11:00:00',7.1),('8902','2014-03-04','11:05:00',7.26),('8902','2014-03-04','11:10:00',7.32),('8902','2014-03-04','11:15:00',7.4),('8902','2014-03-04','11:20:00',7.44),('8902','2014-03-04','11:25:00',7.51),('8902','2014-03-04','11:30:00',7.68),('8902','2014-03-04','11:35:00',8.02),('8902','2014-03-04','11:40:00',8.03),('8902','2014-03-04','11:45:00',7.84),('8902','2014-03-04','11:50:00',7.75),('8902','2014-03-04','11:55:00',6.63),('8902','2014-03-04','12:00:00',6.76),('8902','2014-03-04','12:05:00',6.36),('8902','2014-03-04','12:10:00',2.27),('8902','2014-03-04','12:15:00',2.8),('8902','2014-03-04','12:20:00',1.48),('8902','2014-03-04','12:25:00',1.71),('8902','2014-03-04','12:30:00',2.01),('8902','2014-03-04','12:35:00',3.79),('8902','2014-03-04','12:40:00',2.52),('8902','2014-03-04','12:45:00',2.54),('8902','2014-03-04','12:50:00',3.48),('8902','2014-03-04','12:55:00',3.46),('8902','2014-03-04','13:00:00',3.89),('8902','2014-03-04','13:05:00',5.26),('8902','2014-03-04','13:10:00',6.51),('8902','2014-03-04','13:15:00',5.99),('8902','2014-03-04','13:20:00',4.08),('8902','2014-03-04','13:25:00',2.94),('8902','2014-03-04','13:30:00',2.42),('8902','2014-03-04','13:35:00',2.68),('8902','2014-03-04','13:40:00',3.1),('8902','2014-03-04','13:45:00',2.85),('8902','2014-03-04','13:50:00',2.42),('8902','2014-03-04','13:55:00',2.18),('8902','2014-03-04','14:00:00',1.99),('8902','2014-03-04','14:05:00',1.97),('8902','2014-03-04','14:10:00',2.07),('8902','2014-03-04','14:15:00',2.36),('8902','2014-03-04','14:20:00',2.47),('8902','2014-03-04','14:25:00',2.68),('8902','2014-03-04','14:30:00',2.91),('8902','2014-03-04','14:35:00',2.47),('8902','2014-03-04','14:40:00',3.08),('8902','2014-03-04','14:45:00',3.01),('8902','2014-03-04','14:50:00',4.25),('8902','2014-03-04','14:55:00',2.73),('8902','2014-03-04','15:00:00',1.89),('8902','2014-03-04','15:05:00',1.65),('8902','2014-03-04','15:10:00',1.66),('8902','2014-03-04','15:15:00',1.61),('8902','2014-03-04','15:20:00',1.47),('8902','2014-03-04','15:25:00',1.53),('8902','2014-03-04','15:30:00',1.99),('8902','2014-03-04','15:35:00',2.37),('8902','2014-03-04','15:40:00',4.61),('8902','2014-03-04','15:45:00',3.86),('8902','2014-03-04','15:50:00',2.83),('8902','2014-03-04','15:55:00',4.98),('8902','2014-03-04','16:00:00',6.08),('8902','2014-03-04','16:05:00',5.51),('8902','2014-03-04','16:10:00',4.75),('8902','2014-03-04','16:15:00',3.09),('8902','2014-03-04','16:20:00',1.06),('8902','2014-03-03','08:50:00',1.2),('8902','2014-03-03','09:05:00',2.06),('8902','2014-03-03','09:10:00',1.97),('8902','2014-03-03','09:15:00',3.43),('8902','2014-03-03','09:20:00',5.46),('8902','2014-03-03','09:25:00',2.03),('8902','2014-03-03','09:30:00',1.98),('8902','2014-03-03','09:35:00',2.02),('8902','2014-03-03','09:40:00',3.4),('8902','2014-03-03','09:45:00',4.22),('8902','2014-03-03','09:50:00',1.36),('8902','2014-03-03','09:55:00',3.86),('8902','2014-03-03','10:00:00',3.45),('8902','2014-03-03','10:05:00',2.23),('8902','2014-03-03','10:10:00',1.14),('8902','2014-03-03','10:15:00',1.06),('8902','2014-03-03','10:20:00',1.7),('8902','2014-03-03','10:25:00',7.01),('8902','2014-03-03','10:30:00',5.88),('8902','2014-03-03','10:35:00',5.97),('8902','2014-03-03','10:40:00',7.91),('8902','2014-03-03','10:45:00',7.81),('8902','2014-03-03','10:50:00',2.83),('8902','2014-03-03','10:55:00',4.71),('8902','2014-03-03','11:00:00',4.94),('8902','2014-03-03','11:05:00',3.06),('8902','2014-03-03','11:10:00',5.77),('8902','2014-03-03','11:15:00',9.15),('8902','2014-03-03','11:20:00',7.04),('8902','2014-03-03','11:25:00',2.34),('8902','2014-03-03','11:30:00',1.84),('8902','2014-03-03','11:35:00',1.33),('8902','2014-03-03','11:40:00',1.71),('8902','2014-03-03','11:45:00',4.15),('8902','2014-03-03','11:50:00',9.69),('8902','2014-03-03','11:55:00',8.39),('8902','2014-03-03','12:00:00',8.04),('8902','2014-03-03','12:05:00',7.9),('8902','2014-03-03','12:10:00',7.9),('8902','2014-03-03','12:15:00',7.87),('8902','2014-03-03','12:20:00',7.89),('8902','2014-03-03','12:25:00',7.89),('8902','2014-03-03','12:30:00',7.79),('8902','2014-03-03','12:35:00',7.81),('8902','2014-03-03','12:40:00',7.85),('8902','2014-03-03','12:45:00',8.02),('8902','2014-03-03','12:50:00',6.1),('8902','2014-03-03','12:55:00',6.84),('8902','2014-03-03','13:00:00',6.81),('8902','2014-03-03','13:05:00',7.73),('8902','2014-03-03','13:10:00',8.56),('8902','2014-03-03','13:15:00',7.25),('8902','2014-03-03','13:20:00',2.6),('8902','2014-03-03','13:25:00',1.96),('8902','2014-03-03','13:30:00',2.05),('8902','2014-03-03','13:35:00',1.68),('8902','2014-03-03','13:40:00',1.07),('8902','2014-03-03','13:45:00',1.46),('8902','2014-03-03','13:50:00',2.27),('8902','2014-03-03','13:55:00',2.23),('8902','2014-03-03','14:00:00',1.44),('8902','2014-03-03','14:05:00',2.66),('8902','2014-03-03','14:10:00',6.17),('8902','2014-03-03','14:15:00',5.08),('8902','2014-03-03','14:20:00',4.48),('8902','2014-03-03','14:25:00',7.87),('8902','2014-03-03','14:30:00',7.11),('8902','2014-03-03','14:35:00',6.8),('8902','2014-03-03','14:40:00',6.7),('8902','2014-03-03','14:45:00',6.65),('8902','2014-03-03','14:50:00',6.45),('8902','2014-03-03','14:55:00',2.39),('8902','2014-03-03','15:00:00',3.67),('8902','2014-03-03','15:05:00',6.1),('8902','2014-03-03','15:10:00',5.99),('8902','2014-03-03','15:15:00',5.79),('8902','2014-03-03','15:20:00',3.68),('8902','2014-03-03','15:25:00',5.09),('8902','2014-03-03','15:30:00',2.89),('8902','2014-03-03','15:35:00',5.58),('8902','2014-03-03','15:40:00',5.48),('8902','2014-03-03','15:45:00',4.04),('8902','2014-03-03','15:50:00',3.96),('8902','2014-03-03','15:55:00',1.87),('8902','2014-03-03','16:00:00',1.36),('8902','2014-03-03','16:05:00',1.91),('8902','2014-03-03','16:10:00',2.02),('8902','2014-03-03','16:15:00',1.66),('8902','2014-03-03','16:20:00',2.07),('8902','2014-03-03','16:25:00',2.9),('8902','2014-03-03','16:30:00',2.19),('8902','2014-03-03','16:35:00',2),('8902','2014-03-03','16:40:00',2.33),('8902','2014-03-03','16:45:00',2.49),('8902','2014-03-03','16:50:00',2.31),('8902','2014-03-03','16:55:00',1.84),('8902','2014-03-03','17:00:00',1.38),('8902','2014-03-03','17:05:00',1.19),('8902','2014-03-02','07:45:00',1.24),('8902','2014-03-02','07:50:00',1.4),('8902','2014-03-02','07:55:00',1.32),('8902','2014-03-02','08:00:00',1.4),('8902','2014-03-02','08:05:00',1.51),('8902','2014-03-02','08:10:00',2.16),('8902','2014-03-02','08:15:00',2.47),('8902','2014-03-02','08:20:00',2.66),('8902','2014-03-02','08:25:00',2.8),('8902','2014-03-02','08:30:00',2.98),('8902','2014-03-02','08:35:00',3.14),('8902','2014-03-02','08:40:00',3.41),('8902','2014-03-02','08:45:00',3.57),('8902','2014-03-02','08:50:00',3.6),('8902','2014-03-02','08:55:00',4.07),('8902','2014-03-02','09:00:00',4.27),('8902','2014-03-02','09:05:00',4.37),('8902','2014-03-02','09:10:00',4.35),('8902','2014-03-02','09:15:00',4.33),('8902','2014-03-02','09:20:00',4.7),('8902','2014-03-02','09:25:00',4.96),('8902','2014-03-02','09:30:00',4.92),('8902','2014-03-02','09:35:00',4.5),('8902','2014-03-02','09:40:00',4.17),('8902','2014-03-02','09:45:00',4.17),('8902','2014-03-02','09:50:00',4.31),('8902','2014-03-02','09:55:00',5),('8902','2014-03-02','10:00:00',5.59),('8902','2014-03-02','10:05:00',5.95),('8902','2014-03-02','10:10:00',6.08),('8902','2014-03-02','10:15:00',6.14),('8902','2014-03-02','10:20:00',6.26),('8902','2014-03-02','10:25:00',6.39),('8902','2014-03-02','10:30:00',6.46),('8902','2014-03-02','10:35:00',6.55),('8902','2014-03-02','10:40:00',6.59),('8902','2014-03-02','10:45:00',6.65),('8902','2014-03-02','10:50:00',6.71),('8902','2014-03-02','10:55:00',6.8),('8902','2014-03-02','11:00:00',6.93),('8902','2014-03-02','11:05:00',6.97),('8902','2014-03-02','11:10:00',6.98),('8902','2014-03-02','11:15:00',7.06),('8902','2014-03-02','11:20:00',7.1),('8902','2014-03-02','11:25:00',7.22),('8902','2014-03-02','11:30:00',7.22),('8902','2014-03-02','11:35:00',6.11),('8902','2014-03-02','11:40:00',5.07),('8902','2014-03-02','11:45:00',7.69),('8902','2014-03-02','11:50:00',7.68),('8902','2014-03-02','11:55:00',7.75),('8902','2014-03-02','12:00:00',7.71),('8902','2014-03-02','12:05:00',7.74),('8902','2014-03-02','12:10:00',7.81),('8902','2014-03-02','12:15:00',7.78),('8902','2014-03-02','12:20:00',7.8),('8902','2014-03-02','12:25:00',7.82),('8902','2014-03-02','12:30:00',7.8),('8902','2014-03-02','12:35:00',7.82),('8902','2014-03-02','12:40:00',7.81),('8902','2014-03-02','12:45:00',7.75),('8902','2014-03-02','12:50:00',7.74),('8902','2014-03-02','12:55:00',7.7),('8902','2014-03-02','13:00:00',7.7),('8902','2014-03-02','13:05:00',7.66),('8902','2014-03-02','13:10:00',7.64),('8902','2014-03-02','13:15:00',7.55),('8902','2014-03-02','13:20:00',7.54),('8902','2014-03-02','13:25:00',7.53),('8902','2014-03-02','13:30:00',7.5),('8902','2014-03-02','13:35:00',7.49),('8902','2014-03-02','13:40:00',7.43),('8902','2014-03-02','13:45:00',7.38),('8902','2014-03-02','13:50:00',7.33),('8902','2014-03-02','13:55:00',7.28),('8902','2014-03-02','14:00:00',7.21),('8902','2014-03-02','14:05:00',7.14),('8902','2014-03-02','14:10:00',7.16),('8902','2014-03-02','14:15:00',7.18),('8902','2014-03-02','14:20:00',7.04),('8902','2014-03-02','14:25:00',6.54),('8902','2014-03-02','14:30:00',6.61),('8902','2014-03-02','14:35:00',6.75),('8902','2014-03-02','14:40:00',6.57),('8902','2014-03-02','14:45:00',6.46),('8902','2014-03-02','14:50:00',6.31),('8902','2014-03-02','14:55:00',6.18),('8902','2014-03-02','15:00:00',6.04),('8902','2014-03-02','15:05:00',5.89),('8902','2014-03-02','15:10:00',5.8),('8902','2014-03-02','15:15:00',5.68),('8902','2014-03-02','15:20:00',5.56),('8902','2014-03-02','15:25:00',5.43),('8902','2014-03-02','15:30:00',5.21),('8902','2014-03-02','15:35:00',5.06),('8902','2014-03-02','15:40:00',4.9),('8902','2014-03-02','15:45:00',4.75),('8902','2014-03-02','15:50:00',4.49),('8902','2014-03-02','15:55:00',4.3),('8902','2014-03-02','16:00:00',4.12),('8902','2014-03-02','16:05:00',3.94),('8902','2014-03-02','16:10:00',3.76),('8902','2014-03-02','16:15:00',3.62),('8902','2014-03-02','16:20:00',3.46),('8902','2014-03-02','16:25:00',3.22),('8902','2014-03-02','16:30:00',2.94),('8902','2014-03-02','16:35:00',2.74),('8902','2014-03-02','16:40:00',2.55),('8902','2014-03-02','16:45:00',2.43),('8902','2014-03-02','16:50:00',1.49),('8902','2014-03-02','16:55:00',1.61),('8902','2014-03-02','17:00:00',1.89),('8902','2014-03-02','17:05:00',1.66),('8902','2014-03-02','17:10:00',1.02),('8902','2014-03-01','08:00:00',1.5),('8902','2014-03-01','08:05:00',2.07),('8902','2014-03-01','08:10:00',2.69),('8902','2014-03-01','08:15:00',3.07),('8902','2014-03-01','08:20:00',3.18),('8902','2014-03-01','08:25:00',2.85),('8902','2014-03-01','08:30:00',2.84),('8902','2014-03-01','08:35:00',3.08),('8902','2014-03-01','08:40:00',3.33),('8902','2014-03-01','08:45:00',3.57),('8902','2014-03-01','08:50:00',3.78),('8902','2014-03-01','08:55:00',3.99),('8902','2014-03-01','09:00:00',4.17),('8902','2014-03-01','09:05:00',4.42),('8902','2014-03-01','09:10:00',4.68),('8902','2014-03-01','09:15:00',4.84),('8902','2014-03-01','09:20:00',3.98),('8902','2014-03-01','09:25:00',4.74),('8902','2014-03-01','09:30:00',5.6),('8902','2014-03-01','09:35:00',5.69),('8902','2014-03-01','09:40:00',5.52),('8902','2014-03-01','09:45:00',3.14),('8902','2014-03-01','09:50:00',1.27),('8902','2014-03-01','09:55:00',1.69),('8902','2014-03-01','10:00:00',4.09),('8902','2014-03-01','10:05:00',2.97),('8902','2014-03-01','10:10:00',3.08),('8902','2014-03-01','10:15:00',2.29),('8902','2014-03-01','10:20:00',2.28),('8902','2014-03-01','10:25:00',2.46),('8902','2014-03-01','10:30:00',2.72),('8902','2014-03-01','10:35:00',2.79),('8902','2014-03-01','10:40:00',4.58),('8902','2014-03-01','10:45:00',2.36),('8902','2014-03-01','10:50:00',2.25),('8902','2014-03-01','10:55:00',2.32),('8902','2014-03-01','11:00:00',4.17),('8902','2014-03-01','11:05:00',5.9),('8902','2014-03-01','11:10:00',2.97),('8902','2014-03-01','11:15:00',2.42),('8902','2014-03-01','11:20:00',2.8),('8902','2014-03-01','11:25:00',3.76),('8902','2014-03-01','11:30:00',3.78),('8902','2014-03-01','11:35:00',5.47),('8902','2014-03-01','11:40:00',7.65),('8902','2014-03-01','11:45:00',7.02),('8902','2014-03-01','11:50:00',9.32),('8902','2014-03-01','11:55:00',8.86),('8902','2014-03-01','12:00:00',5.16),('8902','2014-03-01','12:05:00',3.56),('8902','2014-03-01','12:10:00',4.01),('8902','2014-03-01','12:15:00',6.8),('8902','2014-03-01','12:20:00',5.05),('8902','2014-03-01','12:25:00',3.63),('8902','2014-03-01','12:30:00',2.73),('8902','2014-03-01','12:35:00',2.23),('8902','2014-03-01','12:40:00',1.94),('8902','2014-03-01','12:45:00',1.92),('8902','2014-03-01','12:50:00',2.12),('8902','2014-03-01','12:55:00',2.46),('8902','2014-03-01','13:00:00',2.82),('8902','2014-03-01','13:05:00',2.91),('8902','2014-03-01','13:10:00',2.93),('8902','2014-03-01','13:15:00',2.93),('8902','2014-03-01','13:20:00',2.78),('8902','2014-03-01','13:25:00',2.43),('8902','2014-03-01','13:30:00',2.13),('8902','2014-03-01','13:35:00',1.76),('8902','2014-03-01','13:40:00',1.62),('8902','2014-03-01','13:45:00',1.5),('8902','2014-03-01','13:50:00',1.58),('8902','2014-03-01','13:55:00',1.85),('8902','2014-03-01','14:00:00',2.38),('8902','2014-03-01','14:05:00',2.62),('8902','2014-03-01','14:10:00',2.54),('8902','2014-03-01','14:15:00',2.44),('8902','2014-03-01','14:20:00',2.32),('8902','2014-03-01','14:25:00',2.34),('8902','2014-03-01','14:30:00',2.47),('8902','2014-03-01','14:35:00',2.46),('8902','2014-03-01','14:40:00',2.52),('8902','2014-03-01','14:45:00',2.61),('8902','2014-03-01','14:50:00',2.57),('8902','2014-03-01','14:55:00',2.53),('8902','2014-03-01','15:00:00',2.66),('8902','2014-03-01','15:05:00',2.9),('8902','2014-03-01','15:10:00',2.86),('8902','2014-03-01','15:15:00',2.76),('8902','2014-03-01','15:20:00',2.93),('8902','2014-03-01','15:25:00',2.98),('8902','2014-03-01','15:30:00',2.77),('8902','2014-03-01','15:35:00',2.99),('8902','2014-03-01','15:40:00',2.72),('8902','2014-03-01','15:45:00',2.48),('8902','2014-03-01','15:50:00',2.22),('8902','2014-03-01','15:55:00',1.88),('8902','2014-03-01','16:00:00',1.66),('8902','2014-03-01','16:05:00',1.51),('8902','2014-03-01','16:10:00',1.31),('8902','2014-03-01','16:15:00',1.13),('8902','2014-03-01','16:20:00',1.06),('8902','2014-02-28','12:40:00',1.03),('8902','2014-02-28','14:40:00',1.04),('8902','2014-02-28','14:45:00',1.28),('8902','2014-02-28','14:50:00',1.32),('8902','2014-02-28','14:55:00',1.16),('8902','2014-02-28','15:00:00',1.07),('8902','2014-02-27','07:45:00',1.02),('8902','2014-02-27','07:50:00',1.24),('8902','2014-02-27','07:55:00',1.55),('8902','2014-02-27','08:00:00',2.08),('8902','2014-02-27','08:05:00',1.7),('8902','2014-02-27','08:10:00',1.54),('8902','2014-02-27','08:15:00',2.01),('8902','2014-02-27','08:20:00',3.13),('8902','2014-02-27','08:25:00',2.76),('8902','2014-02-27','08:30:00',1.11),('8902','2014-02-27','08:35:00',3.48),('8902','2014-02-27','08:40:00',1.99),('8902','2014-02-27','09:10:00',1.36),('8902','2014-02-27','09:15:00',2.23),('8902','2014-02-27','09:20:00',2.33),('8902','2014-02-27','09:25:00',2.53),('8902','2014-02-27','09:30:00',3.51),('8902','2014-02-27','09:35:00',2.35),('8902','2014-02-27','09:40:00',3.68),('8902','2014-02-27','09:45:00',5.84),('8902','2014-02-27','09:50:00',6.64),('8902','2014-02-27','09:55:00',6.29),('8902','2014-02-27','10:00:00',2.83),('8902','2014-02-27','10:05:00',2.22),('8902','2014-02-27','10:10:00',3.7),('8902','2014-02-27','10:15:00',2.47),('8902','2014-02-27','10:20:00',2.77),('8902','2014-02-27','10:25:00',7.13),('8902','2014-02-27','10:30:00',7.45),('8902','2014-02-27','10:35:00',5.94),('8902','2014-02-27','10:40:00',2.91),('8902','2014-02-27','10:45:00',1.54),('8902','2014-02-27','11:00:00',1.06),('8902','2014-02-27','11:05:00',1.34),('8902','2014-02-27','11:10:00',1.24),('8902','2014-02-27','11:15:00',1.62),('8902','2014-02-27','11:20:00',2.37),('8902','2014-02-27','11:25:00',2.45),('8902','2014-02-27','11:30:00',2.08),('8902','2014-02-27','11:35:00',1.54),('8902','2014-02-27','11:40:00',1.29),('8902','2014-02-27','11:45:00',1.64),('8902','2014-02-27','11:50:00',2.21),('8902','2014-02-27','11:55:00',2.27),('8902','2014-02-27','12:00:00',2.78),('8902','2014-02-27','12:05:00',3.97),('8902','2014-02-27','12:10:00',4.37),('8902','2014-02-27','12:15:00',2.59),('8902','2014-02-27','12:20:00',1.99),('8902','2014-02-27','12:25:00',2.43),('8902','2014-02-27','12:30:00',4.35),('8902','2014-02-27','12:35:00',5.27),('8902','2014-02-27','12:40:00',6.53),('8902','2014-02-27','12:45:00',2.25),('8902','2014-02-27','12:50:00',4.75),('8902','2014-02-27','12:55:00',3.67),('8902','2014-02-27','13:00:00',4.82),('8902','2014-02-27','13:05:00',3.82),('8902','2014-02-27','13:10:00',3.18),('8902','2014-02-27','13:15:00',2.18),('8902','2014-02-27','13:20:00',1.15),('8902','2014-02-27','13:45:00',1.62),('8902','2014-02-27','13:50:00',6.72),('8902','2014-02-27','13:55:00',8.78),('8902','2014-02-27','14:00:00',3.79),('8902','2014-02-27','14:05:00',2.16),('8902','2014-02-27','14:10:00',1.7),('8902','2014-02-27','14:15:00',2.51),('8902','2014-02-27','14:20:00',3.74),('8902','2014-02-27','14:25:00',4.3),('8902','2014-02-27','14:30:00',3.41),('8902','2014-02-27','14:35:00',2.85),('8902','2014-02-27','14:40:00',2.48),('8902','2014-02-27','14:45:00',2.49),('8902','2014-02-27','14:50:00',2.65),('8902','2014-02-27','14:55:00',2.93),('8902','2014-02-27','15:00:00',4.39),('8902','2014-02-27','15:05:00',2.36),('8902','2014-02-27','15:10:00',1.22),('8902','2014-02-27','15:20:00',1.05),('8902','2014-02-27','15:25:00',3.77),('8902','2014-02-27','15:30:00',4.58),('8902','2014-02-27','15:35:00',5.47),('8902','2014-02-27','15:40:00',4.59),('8902','2014-02-27','15:45:00',1.4),('8902','2014-02-27','16:10:00',1.86),('8902','2014-02-27','16:15:00',4.36),('8902','2014-02-27','16:20:00',4),('8902','2014-02-27','16:25:00',1.96),('8902','2014-02-27','16:30:00',1.28),('8902','2014-02-27','16:35:00',2.21),('8902','2014-02-27','16:40:00',2.68),('8902','2014-02-27','16:45:00',3.36),('8902','2014-02-27','16:50:00',2.84),('8902','2014-02-27','16:55:00',1.02),('8902','2014-02-26','10:25:00',1.04),('8902','2014-02-26','10:30:00',1.49),('8902','2014-02-26','10:35:00',1.87),('8902','2014-02-26','10:40:00',2.12),('8902','2014-02-26','10:45:00',2.34),('8902','2014-02-26','10:50:00',2.46),('8902','2014-02-26','10:55:00',2.66),('8902','2014-02-26','11:00:00',2.98),('8902','2014-02-26','11:05:00',3.36),('8902','2014-02-26','11:10:00',3.12),('8902','2014-02-26','11:15:00',3.03),('8902','2014-02-26','11:20:00',2.84),('8902','2014-02-26','11:25:00',3.03),('8902','2014-02-26','11:30:00',3.77),('8902','2014-02-26','11:35:00',3.62),('8902','2014-02-26','11:40:00',2.95),('8902','2014-02-26','11:45:00',2.57),('8902','2014-02-26','11:50:00',2.42),('8902','2014-02-26','11:55:00',2.45),('8902','2014-02-26','12:00:00',2.39),('8902','2014-02-26','12:05:00',2.41),('8902','2014-02-26','12:10:00',2.05),('8902','2014-02-26','12:15:00',2.23),('8902','2014-02-26','12:20:00',2.44),('8902','2014-02-26','12:25:00',2.51),('8902','2014-02-26','12:30:00',2.34),('8902','2014-02-26','12:35:00',2.27),('8902','2014-02-26','12:40:00',2.21),('8902','2014-02-26','12:45:00',2.16),('8902','2014-02-26','12:50:00',2.11),('8902','2014-02-26','12:55:00',2.15),('8902','2014-02-26','13:00:00',2.27),('8902','2014-02-26','13:05:00',2.08),('8902','2014-02-26','13:10:00',2.14),('8902','2014-02-26','13:15:00',2.43),('8902','2014-02-26','13:20:00',2.44),('8902','2014-02-26','13:25:00',2.6),('8902','2014-02-26','13:30:00',2.96),('8902','2014-02-26','13:35:00',3.25),('8902','2014-02-26','13:40:00',3.29),('8902','2014-02-26','13:45:00',3.3),('8902','2014-02-26','13:50:00',3.4),('8902','2014-02-26','13:55:00',3.95),('8902','2014-02-26','14:00:00',3.85),('8902','2014-02-26','14:05:00',3.47),('8902','2014-02-26','14:10:00',3.02),('8902','2014-02-26','14:15:00',2.75),('8902','2014-02-26','14:20:00',2.79),('8902','2014-02-26','14:25:00',2.85),('8902','2014-02-26','14:30:00',3.12),('8902','2014-02-26','14:35:00',3.05),('8902','2014-02-26','14:40:00',2.68),('8902','2014-02-26','14:45:00',2.65),('8902','2014-02-26','14:50:00',2.45),('8902','2014-02-26','14:55:00',2.25),('8902','2014-02-26','15:00:00',2.34),('8902','2014-02-26','15:05:00',2.14),('8902','2014-02-26','15:10:00',2.26),('8902','2014-02-26','15:15:00',2.7),('8902','2014-02-26','15:20:00',3.02),('8902','2014-02-26','15:25:00',2.67),('8902','2014-02-26','15:30:00',2.63),('8902','2014-02-26','15:35:00',2.77),('8902','2014-02-26','15:40:00',2.44),('8902','2014-02-26','15:45:00',1.77),('8902','2014-02-26','15:50:00',1.59),('8902','2014-02-26','15:55:00',1.3),('8902','2014-02-26','16:00:00',1.29),('8902','2014-02-26','16:05:00',1.31),('8902','2014-02-26','16:10:00',1.16),('8902','2014-02-26','16:30:00',1.01),('8902','2014-02-26','16:35:00',1.39),('8902','2014-02-26','16:40:00',2.26),('8902','2014-02-26','16:45:00',1.71),('8902','2014-02-26','16:50:00',2.14),('8902','2014-02-26','16:55:00',2.19),('8902','2014-02-26','17:00:00',1.93),('8902','2014-02-26','17:05:00',1.5),('8902','2014-02-26','17:10:00',1.08),('8902','2014-02-25','08:00:00',1.19),('8902','2014-02-25','08:05:00',1.33),('8902','2014-02-25','08:10:00',1.75),('8902','2014-02-25','08:15:00',2.17),('8902','2014-02-25','08:20:00',2.36),('8902','2014-02-25','08:25:00',2.55),('8902','2014-02-25','08:30:00',2.68),('8902','2014-02-25','08:35:00',2.94),('8902','2014-02-25','08:40:00',3.14),('8902','2014-02-25','08:45:00',3.55),('8902','2014-02-25','08:50:00',3.6),('8902','2014-02-25','08:55:00',3.6),('8902','2014-02-25','09:00:00',3.79),('8902','2014-02-25','09:05:00',3.89),('8902','2014-02-25','09:10:00',3.9),('8902','2014-02-25','09:15:00',4.35),('8902','2014-02-25','09:20:00',4.5),('8902','2014-02-25','09:25:00',4.81),('8902','2014-02-25','09:30:00',4.58),('8902','2014-02-25','09:35:00',4.78),('8902','2014-02-25','09:40:00',3.28),('8902','2014-02-25','09:45:00',4.75),('8902','2014-02-25','09:50:00',5.02),('8902','2014-02-25','09:55:00',2.68),('8902','2014-02-25','10:00:00',2.69),('8902','2014-02-25','10:05:00',2.22),('8902','2014-02-25','10:10:00',1.68),('8902','2014-02-25','10:15:00',1.57),('8902','2014-02-25','10:20:00',1.98),('8902','2014-02-25','10:25:00',2),('8902','2014-02-25','10:30:00',2.01),('8902','2014-02-25','10:35:00',1.84),('8902','2014-02-25','10:40:00',1.53),('8902','2014-02-25','10:45:00',1.29),('8902','2014-02-25','10:50:00',1.17),('8902','2014-02-25','10:55:00',1.43),('8902','2014-02-25','11:00:00',1.75),('8902','2014-02-25','11:05:00',2),('8902','2014-02-25','11:10:00',1.99),('8902','2014-02-25','11:15:00',1.96),('8902','2014-02-25','11:20:00',1.48),('8902','2014-02-25','11:25:00',1.12),('8902','2014-02-25','11:30:00',1.15),('8902','2014-02-25','11:35:00',1.34),('8902','2014-02-25','11:40:00',1.35),('8902','2014-02-25','11:45:00',1.25),('8902','2014-02-25','11:50:00',1.56),('8902','2014-02-25','11:55:00',1.67),('8902','2014-02-25','12:00:00',2.12),('8902','2014-02-25','12:05:00',3.18),('8902','2014-02-25','12:10:00',5.43),('8902','2014-02-25','12:15:00',2.54),('8902','2014-02-25','12:20:00',2.16),('8902','2014-02-25','12:25:00',2.25),('8902','2014-02-25','12:30:00',4.16),('8902','2014-02-25','12:35:00',3.42),('8902','2014-02-25','12:40:00',3.45),('8902','2014-02-25','12:45:00',5.54),('8902','2014-02-25','12:50:00',5.55),('8902','2014-02-25','12:55:00',3.77),('8902','2014-02-25','13:00:00',4.08),('8902','2014-02-25','13:05:00',6.72),('8902','2014-02-25','13:10:00',6.36),('8902','2014-02-25','13:15:00',6.14),('8902','2014-02-25','13:20:00',6.56),('8902','2014-02-25','13:25:00',6.44),('8902','2014-02-25','13:30:00',7.8),('8902','2014-02-25','13:35:00',7.39),('8902','2014-02-25','13:40:00',6.96),('8902','2014-02-25','13:45:00',7.1),('8902','2014-02-25','13:50:00',4.77),('8902','2014-02-25','13:55:00',2.76),('8902','2014-02-25','14:00:00',7.02),('8902','2014-02-25','14:05:00',7.33),('8902','2014-02-25','14:10:00',2.97),('8902','2014-02-25','14:15:00',4.71),('8902','2014-02-25','14:20:00',6.42),('8902','2014-02-25','14:25:00',7.27),('8902','2014-02-25','14:30:00',4.13),('8902','2014-02-25','14:35:00',2.92),('8902','2014-02-25','14:40:00',6.41),('8902','2014-02-25','14:45:00',6.59),('8902','2014-02-25','14:50:00',4.01),('8902','2014-02-25','14:55:00',5.96),('8902','2014-02-25','15:00:00',6.18),('8902','2014-02-25','15:05:00',5.65),('8902','2014-02-25','15:10:00',5.57),('8902','2014-02-25','15:15:00',4.78),('8902','2014-02-25','15:20:00',4.16),('8902','2014-02-25','15:25:00',2.5),('8902','2014-02-25','15:30:00',2.65),('8902','2014-02-25','15:35:00',3.73),('8902','2014-02-25','15:40:00',3.56),('8902','2014-02-25','15:45:00',2.98),('8902','2014-02-25','15:50:00',2.57),('8902','2014-02-25','15:55:00',3.39),('8902','2014-02-25','16:00:00',3.89),('8902','2014-02-25','16:05:00',3.7),('8902','2014-02-25','16:10:00',2.61),('8902','2014-02-25','16:15:00',1.56),('8902','2014-02-25','16:20:00',1.88),('8902','2014-02-25','16:25:00',1.35),('8902','2014-04-28','09:40:00',1.03),('8902','2014-04-28','09:45:00',1.42),('8902','2014-04-28','09:50:00',1.9),('8902','2014-04-28','09:55:00',2.12),('8902','2014-04-28','10:00:00',2.11),('8902','2014-04-28','10:05:00',3.24),('8902','2014-04-28','10:10:00',5.21),('8902','2014-04-28','10:15:00',5.85),('8902','2014-04-28','10:20:00',6.16),('8902','2014-04-28','10:25:00',6.45),('8902','2014-04-28','10:30:00',7.44),('8902','2014-04-28','10:35:00',7.3),('8902','2014-04-28','10:40:00',7.35),('8902','2014-04-28','10:45:00',7.41),('8902','2014-04-28','10:50:00',7.57),('8902','2014-04-28','10:55:00',7.33),('8902','2014-04-28','11:00:00',7.46),('8902','2014-04-28','11:05:00',7.47),('8902','2014-04-28','11:10:00',7.87),('8902','2014-04-28','11:15:00',7.13),('8902','2014-04-28','11:20:00',7.24),('8902','2014-04-28','11:25:00',6.23),('8902','2014-04-28','11:30:00',7.87),('8902','2014-04-28','11:35:00',7.33),('8902','2014-04-28','11:40:00',7.34),('8902','2014-04-28','11:45:00',7.67),('8902','2014-04-28','11:50:00',2.96),('8902','2014-04-28','11:55:00',2.42),('8902','2014-04-28','12:00:00',2.5),('8902','2014-04-28','12:05:00',4.02),('8902','2014-04-28','12:10:00',4.67),('8902','2014-04-28','12:15:00',8.59),('8902','2014-04-28','12:20:00',3.73),('8902','2014-04-28','12:25:00',5.57),('8902','2014-04-28','12:30:00',6.24),('8902','2014-04-28','12:35:00',5.6),('8902','2014-04-28','12:40:00',7.39),('8902','2014-04-28','12:45:00',5.96),('8902','2014-04-28','12:50:00',10),('8902','2014-04-28','12:55:00',6.29),('8902','2014-04-28','13:00:00',4.02),('8902','2014-04-28','13:05:00',3.51),('8902','2014-04-28','13:10:00',3.31),('8902','2014-04-28','13:15:00',4.15),('8902','2014-04-28','13:20:00',8.41),('8902','2014-04-28','13:25:00',8.23),('8902','2014-04-28','13:30:00',4.81),('8902','2014-04-28','13:35:00',4.29),('8902','2014-04-28','13:40:00',2.68),('8902','2014-04-28','13:45:00',2.65),('8902','2014-04-28','13:50:00',2.81),('8902','2014-04-28','13:55:00',2.83),('8902','2014-04-28','14:00:00',1.29),('8902','2014-04-28','14:25:00',1.19),('8902','2014-04-28','14:30:00',1.21),('8902','2014-04-28','14:35:00',1.32),('8902','2014-04-28','14:40:00',1.44),('8902','2014-04-28','14:45:00',1.23),('8902','2014-04-28','15:00:00',1.53),('8902','2014-04-28','15:05:00',2.4),('8902','2014-04-28','15:10:00',1.67),('8902','2014-04-28','15:30:00',1.16),('8902','2014-04-28','15:35:00',1.15),('8902','2014-04-28','16:05:00',1.13),('8902','2014-04-28','16:10:00',1.37),('8902','2014-04-28','16:15:00',1.75),('8902','2014-04-28','16:20:00',2.06),('8902','2014-04-28','16:25:00',2.36),('8902','2014-04-28','16:30:00',2.05),('8902','2014-04-28','16:35:00',1.71),('8902','2014-04-28','16:40:00',1.42),('8902','2014-04-28','16:45:00',1.29),('8902','2014-04-28','16:50:00',1.39),('8902','2014-04-28','16:55:00',1.6),('8902','2014-04-28','17:00:00',1.83),('8902','2014-04-28','17:05:00',2.35),('8902','2014-04-28','17:10:00',2.38),('8902','2014-04-28','17:15:00',1.82),('8902','2014-04-28','17:20:00',1.72),('8902','2014-04-28','17:25:00',3.51),('8902','2014-04-28','17:30:00',3.25),('8902','2014-04-28','17:35:00',3.77),('8902','2014-04-28','17:40:00',3.63),('8902','2014-04-28','17:45:00',3.83),('8902','2014-04-28','17:50:00',2.19),('8902','2014-04-28','18:00:00',1.19),('8902','2014-04-28','18:05:00',1.45),('8902','2014-04-28','18:10:00',1.05),('8902','2014-02-24','07:55:00',1.1),('8902','2014-02-24','08:00:00',1.42),('8902','2014-02-24','08:05:00',1.6),('8902','2014-02-24','08:10:00',1.79),('8902','2014-02-24','08:15:00',2.01),('8902','2014-02-24','08:20:00',2.2),('8902','2014-02-24','08:25:00',2.39),('8902','2014-02-24','08:30:00',2.6),('8902','2014-02-24','08:35:00',2.79),('8902','2014-02-24','08:40:00',2.95),('8902','2014-02-24','08:45:00',3.12),('8902','2014-02-24','08:50:00',3.31),('8902','2014-02-24','08:55:00',3.49),('8902','2014-02-24','09:00:00',3.68),('8902','2014-02-24','09:05:00',3.86),('8902','2014-02-24','09:10:00',4.04),('8902','2014-02-24','09:15:00',4.21),('8902','2014-02-24','09:20:00',4.37),('8902','2014-02-24','09:25:00',4.51),('8902','2014-02-24','09:30:00',4.65),('8902','2014-02-24','09:35:00',4.78),('8902','2014-02-24','09:40:00',4.93),('8902','2014-02-24','09:45:00',5.05),('8902','2014-02-24','09:50:00',5.19),('8902','2014-02-24','09:55:00',5.32),('8902','2014-02-24','10:00:00',5.41),('8902','2014-02-24','10:05:00',5.52),('8902','2014-02-24','10:10:00',5.64),('8902','2014-02-24','10:15:00',5.76),('8902','2014-02-24','10:20:00',5.89),('8902','2014-02-24','10:25:00',5.96),('8902','2014-02-24','10:30:00',6.04),('8902','2014-02-24','10:35:00',6.1),('8902','2014-02-24','10:40:00',6.22),('8902','2014-02-24','10:45:00',6.27),('8902','2014-02-24','10:50:00',6.32),('8902','2014-02-24','10:55:00',6.38),('8902','2014-02-24','11:00:00',6.47),('8902','2014-02-24','11:05:00',6.51),('8902','2014-02-24','11:10:00',6.59),('8902','2014-02-24','11:15:00',6.67),('8902','2014-02-24','11:20:00',6.75),('8902','2014-02-24','11:25:00',6.78),('8902','2014-02-24','11:30:00',6.78),('8902','2014-02-24','11:35:00',6.81),('8902','2014-02-24','11:40:00',6.92),('8902','2014-02-24','11:45:00',6.85),('8902','2014-02-24','11:50:00',6.96),('8902','2014-02-24','11:55:00',7.01),('8902','2014-02-24','12:00:00',7),('8902','2014-02-24','12:05:00',7.09),('8902','2014-02-24','12:10:00',7.09),('8902','2014-02-24','12:15:00',7.14),('8902','2014-02-24','12:20:00',7.09),('8902','2014-02-24','12:25:00',6.98),('8902','2014-02-24','12:30:00',6.94),('8902','2014-02-24','12:35:00',7.02),('8902','2014-02-24','12:40:00',7.07),('8902','2014-02-24','12:45:00',7.16),('8902','2014-02-24','12:50:00',7.31),('8902','2014-02-24','12:55:00',7.24),('8902','2014-02-24','13:00:00',7.01),('8902','2014-02-24','13:05:00',7.04),('8902','2014-02-24','13:10:00',7.15),('8902','2014-02-24','13:15:00',6.24),('8902','2014-02-24','13:20:00',3.8),('8902','2014-02-24','13:25:00',2.37),('8902','2014-02-24','13:30:00',1.72),('8902','2014-02-24','13:35:00',2.05),('8902','2014-02-24','13:40:00',3.01),('8902','2014-02-24','13:45:00',2.14),('8902','2014-02-24','13:50:00',1.96),('8902','2014-02-24','13:55:00',2.36),('8902','2014-02-24','14:00:00',2.61),('8902','2014-02-24','14:05:00',2.44),('8902','2014-02-24','14:10:00',1.99),('8902','2014-02-24','14:15:00',2.21),('8902','2014-02-24','14:20:00',2.32),('8902','2014-02-24','14:25:00',2.66),('8902','2014-02-24','14:30:00',2.92),('8902','2014-02-24','14:35:00',5.19),('8902','2014-02-24','14:40:00',5.51),('8902','2014-02-24','14:45:00',4.83),('8902','2014-02-24','14:50:00',6.08),('8902','2014-02-24','14:55:00',4.82),('8902','2014-02-24','15:00:00',5.4),('8902','2014-02-24','15:05:00',5.17),('8902','2014-02-24','15:10:00',5.21),('8902','2014-02-24','15:15:00',5.03),('8902','2014-02-24','15:20:00',4.87),('8902','2014-02-24','15:25:00',4.26),('8902','2014-02-24','15:30:00',3.78),('8902','2014-02-24','15:35:00',3.47),('8902','2014-02-24','15:40:00',3.89),('8902','2014-02-24','15:45:00',2.77),('8902','2014-02-24','15:50:00',2),('8902','2014-02-24','15:55:00',2.37),('8902','2014-02-24','16:00:00',2.11),('8902','2014-02-24','16:05:00',2.3),('8902','2014-02-24','16:10:00',2.21),('8902','2014-02-24','16:15:00',2.41),('8902','2014-02-24','16:20:00',2.6),('8902','2014-02-24','16:25:00',2.09),('8902','2014-02-24','16:30:00',1.09),('8902','2014-02-23','07:55:00',1.2),('8902','2014-02-23','08:00:00',1.46),('8902','2014-02-23','08:05:00',1.82),('8902','2014-02-23','08:10:00',2.15),('8902','2014-02-23','08:15:00',2.44),('8902','2014-02-23','08:20:00',2.66),('8902','2014-02-23','08:25:00',2.94),('8902','2014-02-23','08:30:00',3.22),('8902','2014-02-23','08:35:00',3.43),('8902','2014-02-23','08:40:00',3.68),('8902','2014-02-23','08:45:00',3.75),('8902','2014-02-23','08:50:00',3.62),('8902','2014-02-23','08:55:00',3.57),('8902','2014-02-23','09:00:00',3.65),('8902','2014-02-23','09:05:00',3.8),('8902','2014-02-23','09:10:00',4),('8902','2014-02-23','09:15:00',4.2),('8902','2014-02-23','09:20:00',4.35),('8902','2014-02-23','09:25:00',4.55),('8902','2014-02-23','09:30:00',4.7),('8902','2014-02-23','09:35:00',4.81),('8902','2014-02-23','09:40:00',4.96),('8902','2014-02-23','09:45:00',5.12),('8902','2014-02-23','09:50:00',5.25),('8902','2014-02-23','09:55:00',5.37),('8902','2014-02-23','10:00:00',5.49),('8902','2014-02-23','10:05:00',5.63),('8902','2014-02-23','10:10:00',5.74),('8902','2014-02-23','10:15:00',5.87),('8902','2014-02-23','10:20:00',5.97),('8902','2014-02-23','10:25:00',6.07),('8902','2014-02-23','10:30:00',6.18),('8902','2014-02-23','10:35:00',6.25),('8902','2014-02-23','10:40:00',6.34),('8902','2014-02-23','10:45:00',6.45),('8902','2014-02-23','10:50:00',6.53),('8902','2014-02-23','10:55:00',6.59),('8902','2014-02-23','11:00:00',6.65),('8902','2014-02-23','11:05:00',6.77),('8902','2014-02-23','11:10:00',6.86),('8902','2014-02-23','11:15:00',6.86),('8902','2014-02-23','11:20:00',6.91),('8902','2014-02-23','11:25:00',7.2),('8902','2014-02-23','11:30:00',7.71),('8902','2014-02-23','11:35:00',5.77),('8902','2014-02-23','11:40:00',7.53),('8902','2014-02-23','11:45:00',8.23),('8902','2014-02-23','11:50:00',6.29),('8902','2014-02-23','11:55:00',5.79),('8902','2014-02-23','12:00:00',6.45),('8902','2014-02-23','12:05:00',4.91),('8902','2014-02-23','12:10:00',6.62),('8902','2014-02-23','12:15:00',6.58),('8902','2014-02-23','12:20:00',6.54),('8902','2014-02-23','12:25:00',7.75),('8902','2014-02-23','12:30:00',7.15),('8902','2014-02-23','12:35:00',2.95),('8902','2014-02-23','12:40:00',6.4),('8902','2014-02-23','12:45:00',6.76),('8902','2014-02-23','12:50:00',7.77),('8902','2014-02-23','12:55:00',7.61),('8902','2014-02-23','13:00:00',7.61),('8902','2014-02-23','13:05:00',7.84),('8902','2014-02-23','13:10:00',8.16),('8902','2014-02-23','13:15:00',8.96),('8902','2014-02-23','13:20:00',3.75),('8902','2014-02-23','13:25:00',2.1),('8902','2014-02-23','13:30:00',1.89),('8902','2014-02-23','13:35:00',1.72),('8902','2014-02-23','13:40:00',1.62),('8902','2014-02-23','13:45:00',1.51),('8902','2014-02-23','13:50:00',1.44),('8902','2014-02-23','13:55:00',1.53),('8902','2014-02-23','14:00:00',1.66),('8902','2014-02-23','14:05:00',1.74),('8902','2014-02-23','14:10:00',1.84),('8902','2014-02-23','14:15:00',1.85),('8902','2014-02-23','14:20:00',1.82),('8902','2014-02-23','14:25:00',1.88),('8902','2014-02-23','14:30:00',2),('8902','2014-02-23','14:35:00',1.98),('8902','2014-02-23','14:40:00',2.01),('8902','2014-02-23','14:45:00',2.17),('8902','2014-02-23','14:50:00',1.97),('8902','2014-02-23','14:55:00',1.63),('8902','2014-02-23','15:00:00',1.57),('8902','2014-02-23','15:05:00',1.7),('8902','2014-02-23','15:10:00',1.86),('8902','2014-02-23','15:15:00',1.93),('8902','2014-02-23','15:20:00',2.27),('8902','2014-02-23','15:25:00',2.9),('8902','2014-02-23','15:30:00',3.41),('8902','2014-02-23','15:35:00',5.36),('8902','2014-02-23','15:40:00',5.73),('8902','2014-02-23','15:45:00',5.44),('8902','2014-02-23','15:50:00',5.09),('8902','2014-02-23','15:55:00',3.91),('8902','2014-02-23','16:00:00',4.5),('8902','2014-02-23','16:05:00',4.63),('8902','2014-02-23','16:10:00',4.27),('8902','2014-02-23','16:15:00',3.99),('8902','2014-02-23','16:20:00',3.42),('8902','2014-02-23','16:25:00',2.57),('8902','2014-02-23','16:30:00',1.48),('8902','2014-02-23','16:35:00',1.1),('8902','2014-02-23','16:45:00',1.63),('8902','2014-02-23','16:50:00',1.73),('8902','2014-02-23','16:55:00',1.51),('8902','2014-02-23','17:00:00',1.23),('8902','2014-02-23','17:05:00',1.1),('8902','2014-02-22','07:55:00',1.03),('8902','2014-02-22','08:00:00',1.29),('8902','2014-02-22','08:05:00',1.52),('8902','2014-02-22','08:10:00',1.72),('8902','2014-02-22','08:15:00',1.93),('8902','2014-02-22','08:20:00',2.12),('8902','2014-02-22','08:25:00',2.27),('8902','2014-02-22','08:30:00',2.49),('8902','2014-02-22','08:35:00',2.66),('8902','2014-02-22','08:40:00',2.83),('8902','2014-02-22','08:45:00',3.01),('8902','2014-02-22','08:50:00',3.19),('8902','2014-02-22','08:55:00',3.39),('8902','2014-02-22','09:00:00',3.59),('8902','2014-02-22','09:05:00',3.81),('8902','2014-02-22','09:10:00',4.02),('8902','2014-02-22','09:15:00',4.24),('8902','2014-02-22','09:20:00',4.42),('8902','2014-02-22','09:25:00',4.44),('8902','2014-02-22','09:30:00',4.2),('8902','2014-02-22','09:35:00',4.8),('8902','2014-02-22','09:40:00',4.92),('8902','2014-02-22','09:45:00',5.05),('8902','2014-02-22','09:50:00',5.13),('8902','2014-02-22','09:55:00',5.25),('8902','2014-02-22','10:00:00',5.33),('8902','2014-02-22','10:05:00',5.47),('8902','2014-02-22','10:10:00',5.56),('8902','2014-02-22','10:15:00',5.64),('8902','2014-02-22','10:20:00',5.81),('8902','2014-02-22','10:25:00',5.94),('8902','2014-02-22','10:30:00',6.04),('8902','2014-02-22','10:35:00',6.12),('8902','2014-02-22','10:40:00',6.26),('8902','2014-02-22','10:45:00',6.38),('8902','2014-02-22','10:50:00',6.38),('8902','2014-02-22','10:55:00',5.62),('8902','2014-02-22','11:00:00',6.14),('8902','2014-02-22','11:05:00',6.57),('8902','2014-02-22','11:10:00',6.83),('8902','2014-02-22','11:15:00',6.87),('8902','2014-02-22','11:20:00',6.84),('8902','2014-02-22','11:25:00',6.88),('8902','2014-02-22','11:30:00',7.21),('8902','2014-02-22','11:35:00',7.21),('8902','2014-02-22','11:40:00',7.39),('8902','2014-02-22','11:45:00',7.36),('8902','2014-02-22','11:50:00',6.83),('8902','2014-02-22','11:55:00',6.61),('8902','2014-02-22','12:00:00',6.07),('8902','2014-02-22','12:05:00',7.65),('8902','2014-02-22','12:10:00',6.78),('8902','2014-02-22','12:15:00',7.93),('8902','2014-02-22','12:20:00',7.52),('8902','2014-02-22','12:25:00',4.81),('8902','2014-02-22','12:30:00',5.19),('8902','2014-02-22','12:35:00',8.23),('8902','2014-02-22','12:40:00',4.99),('8902','2014-02-22','12:45:00',4.56),('8902','2014-02-22','12:50:00',3.55),('8902','2014-02-22','12:55:00',4.32),('8902','2014-02-22','13:00:00',4.72),('8902','2014-02-22','13:05:00',7.42),('8902','2014-02-22','13:10:00',7.52),('8902','2014-02-22','13:15:00',7.34),('8902','2014-02-22','13:20:00',7.3),('8902','2014-02-22','13:25:00',7.32),('8902','2014-02-22','13:30:00',7.14),('8902','2014-02-22','13:35:00',3.03),('8902','2014-02-22','13:40:00',6.86),('8902','2014-02-22','13:45:00',6.47),('8902','2014-02-22','13:50:00',5.85),('8902','2014-02-22','13:55:00',2.73),('8902','2014-02-22','14:00:00',6.24),('8902','2014-02-22','14:05:00',6.49),('8902','2014-02-22','14:10:00',6.99),('8902','2014-02-22','14:15:00',5.54),('8902','2014-02-22','14:20:00',3.71),('8902','2014-02-22','14:25:00',5.09),('8902','2014-02-22','14:30:00',6.04),('8902','2014-02-22','14:35:00',4.39),('8902','2014-02-22','14:40:00',2.39),('8902','2014-02-22','14:45:00',2.91),('8902','2014-02-22','14:50:00',1.95),('8902','2014-02-22','14:55:00',1.37),('8902','2014-02-22','15:00:00',1.2),('8902','2014-02-21','08:40:00',1.26),('8902','2014-02-21','08:45:00',1.01),('8902','2014-02-21','09:05:00',1.61),('8902','2014-02-21','09:10:00',2.16),('8902','2014-02-21','09:15:00',1.07),('8902','2014-02-21','09:20:00',1.16),('8902','2014-02-21','09:25:00',1.52),('8902','2014-02-21','09:30:00',1.48),('8902','2014-02-21','09:35:00',1.58),('8902','2014-02-21','09:40:00',1.64),('8902','2014-02-21','09:45:00',1.61),('8902','2014-02-21','09:50:00',1.84),('8902','2014-02-21','09:55:00',1.87),('8902','2014-02-21','10:00:00',2.58),('8902','2014-02-21','10:05:00',4.87),('8902','2014-02-21','10:10:00',3.65),('8902','2014-02-21','10:15:00',4.46),('8902','2014-02-21','10:20:00',2.52),('8902','2014-02-21','10:25:00',3.33),('8902','2014-02-21','10:30:00',6.05),('8902','2014-02-21','10:35:00',3.26),('8902','2014-02-21','10:40:00',3.19),('8902','2014-02-21','10:45:00',5.44),('8902','2014-02-21','10:50:00',7.35),('8902','2014-02-21','10:55:00',2.71),('8902','2014-02-21','11:00:00',1.54),('8902','2014-02-21','11:05:00',1.13),('8902','2014-02-21','11:10:00',1.62),('8902','2014-02-21','11:15:00',1.53),('8902','2014-02-21','11:20:00',1.02),('8902','2014-02-21','11:50:00',1.06),('8902','2014-02-21','11:55:00',1.48),('8902','2014-02-21','12:00:00',1.98),('8902','2014-02-21','12:05:00',2.32),('8902','2014-02-21','12:10:00',2.82),('8902','2014-02-21','12:15:00',4.45),('8902','2014-02-21','12:20:00',3.46),('8902','2014-02-21','12:25:00',3.74),('8902','2014-02-21','12:30:00',2.12),('8902','2014-02-21','12:35:00',2.14),('8902','2014-02-21','12:40:00',2.45),('8902','2014-02-21','12:45:00',7.13),('8902','2014-02-21','12:50:00',6.36),('8902','2014-02-21','12:55:00',2.96),('8902','2014-02-21','13:00:00',2.77),('8902','2014-02-21','13:05:00',3.36),('8902','2014-02-21','13:10:00',7.91),('8902','2014-02-21','13:15:00',5.52),('8902','2014-02-21','13:20:00',3.03),('8902','2014-02-21','13:25:00',2.16),('8902','2014-02-21','13:30:00',2.23),('8902','2014-02-21','13:35:00',2.85),('8902','2014-02-21','13:40:00',4.76),('8902','2014-02-21','13:45:00',3.29),('8902','2014-02-21','13:50:00',2.53),('8902','2014-02-21','13:55:00',6.87),('8902','2014-02-21','14:00:00',7.48),('8902','2014-02-21','14:05:00',5.81),('8902','2014-02-21','14:10:00',6.42),('8902','2014-02-21','14:15:00',5.08),('8902','2014-02-21','14:20:00',6.81),('8902','2014-02-21','14:25:00',6.12),('8902','2014-02-21','14:30:00',5.95),('8902','2014-02-21','14:35:00',2.05),('8902','2014-02-21','14:40:00',5.28),('8902','2014-02-21','14:45:00',6.57),('8902','2014-02-21','14:50:00',6.52),('8902','2014-02-21','14:55:00',1.75),('8902','2014-02-21','15:00:00',3.15),('8902','2014-02-21','15:05:00',4.17),('8902','2014-02-21','15:10:00',3.44),('8902','2014-02-21','15:15:00',2.65),('8902','2014-02-21','15:20:00',3.35),('8902','2014-02-21','15:25:00',3.48),('8902','2014-02-21','15:30:00',4.45),('8902','2014-02-21','15:35:00',4.99),('8902','2014-02-21','15:40:00',1.27),('8902','2014-02-21','15:45:00',3.99),('8902','2014-02-21','15:50:00',4.2),('8902','2014-02-21','15:55:00',3.68),('8902','2014-02-21','16:00:00',3.82),('8902','2014-02-21','16:05:00',2.53),('8902','2014-02-21','16:10:00',2.3),('8902','2014-02-21','16:15:00',3.23),('8902','2014-02-21','16:20:00',2.97),('8902','2014-02-21','16:25:00',2.72),('8902','2014-02-21','16:30:00',2.42),('8902','2014-02-21','16:35:00',2.27),('8902','2014-02-21','16:40:00',2.01),('8902','2014-02-21','16:45:00',1.9),('8902','2014-02-21','16:50:00',1.63),('8902','2014-02-21','16:55:00',1.15),('8902','2014-02-21','17:00:00',1.12),('8902','2014-02-20','08:30:00',1.09),('8902','2014-02-20','08:35:00',1.17),('8902','2014-02-20','08:40:00',1.26),('8902','2014-02-20','08:45:00',1.36),('8902','2014-02-20','08:50:00',1.4),('8902','2014-02-20','08:55:00',1.46),('8902','2014-02-20','09:00:00',1.41),('8902','2014-02-20','09:05:00',1.38),('8902','2014-02-20','09:10:00',1.44),('8902','2014-02-20','09:15:00',1.45),('8902','2014-02-20','09:20:00',1.6),('8902','2014-02-20','09:25:00',1.7),('8902','2014-02-20','09:30:00',1.71),('8902','2014-02-20','09:35:00',1.94),('8902','2014-02-20','09:40:00',1.95),('8902','2014-02-20','09:45:00',2.1),('8902','2014-02-20','09:50:00',2.38),('8902','2014-02-20','09:55:00',2.39),('8902','2014-02-20','10:00:00',2.38),('8902','2014-02-20','10:05:00',2.7),('8902','2014-02-20','10:10:00',2.71),('8902','2014-02-20','10:15:00',2.85),('8902','2014-02-20','10:20:00',3.8),('8902','2014-02-20','10:25:00',4.75),('8902','2014-02-20','10:30:00',5.51),('8902','2014-02-20','10:35:00',4.4),('8902','2014-02-20','10:40:00',3.7),('8902','2014-02-20','10:45:00',3.56),('8902','2014-02-20','10:50:00',2.89),('8902','2014-02-20','10:55:00',4.18),('8902','2014-02-20','11:00:00',3.73),('8902','2014-02-20','11:05:00',2.88),('8902','2014-02-20','11:10:00',2.84),('8902','2014-02-20','11:15:00',3.22),('8902','2014-02-20','11:20:00',3.27),('8902','2014-02-20','11:25:00',4.56),('8902','2014-02-20','11:30:00',7.58),('8902','2014-02-20','11:35:00',5.45),('8902','2014-02-20','11:40:00',5.79),('8902','2014-02-20','11:45:00',6.94),('8902','2014-02-20','11:50:00',3.44),('8902','2014-02-20','11:55:00',7.87),('8902','2014-02-20','12:00:00',8.51),('8902','2014-02-20','12:05:00',8.21),('8902','2014-02-20','12:10:00',6.66),('8902','2014-02-20','12:15:00',2.89),('8902','2014-02-20','12:20:00',2.59),('8902','2014-02-20','12:25:00',2.82),('8902','2014-02-20','12:30:00',2.71),('8902','2014-02-20','12:35:00',2.36),('8902','2014-02-20','12:40:00',2.07),('8902','2014-02-20','12:45:00',1.65),('8902','2014-02-20','12:50:00',1.57),('8902','2014-02-20','12:55:00',1.45),('8902','2014-02-20','13:00:00',1.13),('8902','2014-02-20','13:50:00',1.02),('8902','2014-02-20','13:55:00',1.04),('8902','2014-02-20','14:05:00',1.02),('8902','2014-02-20','14:10:00',1.12),('8902','2014-02-20','14:15:00',1.25),('8902','2014-02-20','14:20:00',1.37),('8902','2014-02-20','14:25:00',1.38),('8902','2014-02-20','14:30:00',1.37),('8902','2014-02-20','14:35:00',1.3),('8902','2014-02-20','14:40:00',1.43),('8902','2014-02-20','14:45:00',1.61),('8902','2014-02-20','14:50:00',1.56),('8902','2014-02-20','14:55:00',1.74),('8902','2014-02-20','15:00:00',1.77),('8902','2014-02-20','15:05:00',3.7),('8902','2014-02-20','15:10:00',1.56),('8902','2014-02-20','15:15:00',1.2),('8902','2014-02-20','15:20:00',1.93),('8902','2014-02-20','15:25:00',2.69),('8902','2014-02-20','15:30:00',4.63),('8902','2014-02-20','15:35:00',4.35),('8902','2014-02-20','15:40:00',4.11),('8902','2014-02-20','15:45:00',4.02),('8902','2014-02-20','15:50:00',3.76),('8902','2014-02-20','15:55:00',3.5),('8902','2014-02-20','16:00:00',3.34),('8902','2014-02-20','16:05:00',3.14),('8902','2014-02-20','16:10:00',2.94),('8902','2014-02-20','16:15:00',2.74),('8902','2014-02-20','16:20:00',2.55),('8902','2014-02-20','16:25:00',2.31),('8902','2014-02-20','16:30:00',2.11),('8902','2014-02-20','16:35:00',1.93),('8902','2014-02-20','16:40:00',1.74),('8902','2014-02-20','16:45:00',1.53),('8902','2014-02-20','16:50:00',1.36),('8902','2014-02-20','16:55:00',1.16),('8902','2014-02-20','17:00:00',1.03),('8902','2014-02-19','10:10:00',1.02),('8902','2014-02-19','10:45:00',1.05),('8902','2014-02-19','10:50:00',1.1),('8902','2014-02-19','10:55:00',1.33),('8902','2014-02-19','11:20:00',1.66),('8902','2014-02-19','11:25:00',2.04),('8902','2014-02-19','11:30:00',1.97),('8902','2014-02-19','11:35:00',1.65),('8902','2014-02-19','11:40:00',1.09),('8902','2014-02-19','11:45:00',1.2),('8902','2014-02-19','11:50:00',1.2),('8902','2014-02-19','11:55:00',1.46),('8902','2014-02-19','12:00:00',1.81),('8902','2014-02-19','12:05:00',1.26),('8902','2014-02-19','12:10:00',1.11),('8902','2014-02-19','12:15:00',1.02),('8902','2014-02-19','12:20:00',1.26),('8902','2014-02-19','12:25:00',1.65),('8902','2014-02-19','12:30:00',1.9),('8902','2014-02-19','12:35:00',1.84),('8902','2014-02-19','12:40:00',1.83),('8902','2014-02-19','12:45:00',1.57),('8902','2014-02-19','12:50:00',1.61),('8902','2014-02-19','12:55:00',2.14),('8902','2014-02-19','13:00:00',2.56),('8902','2014-02-19','13:05:00',1.55),('8902','2014-02-19','13:10:00',1.26),('8902','2014-02-19','13:15:00',2.33),('8902','2014-02-19','13:20:00',2.12),('8902','2014-02-19','13:25:00',1.61),('8902','2014-02-19','13:30:00',2.17),('8902','2014-02-19','13:35:00',2.03),('8902','2014-02-19','13:40:00',1.26),('8902','2014-02-19','13:45:00',1),('8902','2014-02-19','13:50:00',1.03),('8902','2014-02-19','13:55:00',1.13),('8902','2014-02-19','14:00:00',1.72),('8902','2014-02-19','14:05:00',1.19),('8902','2014-02-19','14:15:00',1.18),('8902','2014-02-19','14:20:00',1.06),('8902','2014-02-19','14:25:00',1.02),('8902','2014-02-19','14:30:00',1),('8902','2014-02-18','08:35:00',1.18),('8902','2014-02-18','08:40:00',1.27),('8902','2014-02-18','08:45:00',1.39),('8902','2014-02-18','08:50:00',1.27),('8902','2014-02-18','08:55:00',1.25),('8902','2014-02-18','09:00:00',1.35),('8902','2014-02-18','09:05:00',1.36),('8902','2014-02-18','09:10:00',1.31),('8902','2014-02-18','09:15:00',1.48),('8902','2014-02-18','09:20:00',1.69),('8902','2014-02-18','09:25:00',1.92),('8902','2014-02-18','09:30:00',1.99),('8902','2014-02-18','09:35:00',2.3),('8902','2014-02-18','09:40:00',2.44),('8902','2014-02-18','09:45:00',2.9),('8902','2014-02-18','09:50:00',2.74),('8902','2014-02-18','09:55:00',2.53),('8902','2014-02-18','10:00:00',2.45),('8902','2014-02-18','10:05:00',2.44),('8902','2014-02-18','10:10:00',2.62),('8902','2014-02-18','10:15:00',2.75),('8902','2014-02-18','10:20:00',2.48),('8902','2014-02-18','10:25:00',2.54),('8902','2014-02-18','10:30:00',2.78),('8902','2014-02-18','10:35:00',2.89),('8902','2014-02-18','10:40:00',3.38),('8902','2014-02-18','10:45:00',3.76),('8902','2014-02-18','10:50:00',3.39),('8902','2014-02-18','10:55:00',3.01),('8902','2014-02-18','11:00:00',2.74),('8902','2014-02-18','11:05:00',2.92),('8902','2014-02-18','11:10:00',3.41),('8902','2014-02-18','11:15:00',3.28),('8902','2014-02-18','11:20:00',3.54),('8902','2014-02-18','11:25:00',3.39),('8902','2014-02-18','11:30:00',3.29),('8902','2014-02-18','11:35:00',3.09),('8902','2014-02-18','11:40:00',2.87),('8902','2014-02-18','11:45:00',2.83),('8902','2014-02-18','11:50:00',2.67),('8902','2014-02-18','11:55:00',2.32),('8902','2014-02-18','12:00:00',2.62),('8902','2014-02-18','12:05:00',2.99),('8902','2014-02-18','12:10:00',2.94),('8902','2014-02-18','12:15:00',2.79),('8902','2014-02-18','12:20:00',2.35),('8902','2014-02-18','12:25:00',2.65),('8902','2014-02-18','12:30:00',3.27),('8902','2014-02-18','12:35:00',2.69),('8902','2014-02-18','12:40:00',2.67),('8902','2014-02-18','12:45:00',2.63),('8902','2014-02-18','12:50:00',2.02),('8902','2014-02-18','12:55:00',1.61),('8902','2014-02-18','13:00:00',1.92),('8902','2014-02-18','13:05:00',2.27),('8902','2014-02-18','13:10:00',2.09),('8902','2014-02-18','13:15:00',2.26),('8902','2014-02-18','13:20:00',2.56),('8902','2014-02-18','13:25:00',2.65),('8902','2014-02-18','13:30:00',2.66),('8902','2014-02-18','13:35:00',3.32),('8902','2014-02-18','13:40:00',3.14),('8902','2014-02-18','13:45:00',3.45),('8902','2014-02-18','13:50:00',3.84),('8902','2014-02-18','13:55:00',3.74),('8902','2014-02-18','14:00:00',3.36),('8902','2014-02-18','14:05:00',3.82),('8902','2014-02-18','14:10:00',3.17),('8902','2014-02-18','14:15:00',2.78),('8902','2014-02-18','14:20:00',4.29),('8902','2014-02-18','14:25:00',3.41),('8902','2014-02-18','14:30:00',3.13),('8902','2014-02-18','14:35:00',3.39),('8902','2014-02-18','14:40:00',2.79),('8902','2014-02-18','14:45:00',2.68),('8902','2014-02-18','14:50:00',3.36),('8902','2014-02-18','14:55:00',3.17),('8902','2014-02-18','15:00:00',2.54),('8902','2014-02-18','15:05:00',2.49),('8902','2014-02-18','15:10:00',2.26),('8902','2014-02-18','15:15:00',2.83),('8902','2014-02-18','15:20:00',2.13),('8902','2014-02-18','15:25:00',2.42),('8902','2014-02-18','15:30:00',2.06),('8902','2014-02-18','15:35:00',1.82),('8902','2014-02-18','15:40:00',1.89),('8902','2014-02-18','15:45:00',1.88),('8902','2014-02-18','15:50:00',2.35),('8902','2014-02-18','15:55:00',1.96),('8902','2014-02-18','16:00:00',1.72),('8902','2014-02-18','16:05:00',1.6),('8902','2014-02-18','16:10:00',1.46),('8902','2014-02-18','16:15:00',1.44),('8902','2014-02-18','16:20:00',1.11),('8902','2014-02-17','08:00:00',1.12),('8902','2014-02-17','08:05:00',1.34),('8902','2014-02-17','08:10:00',1.5),('8902','2014-02-17','08:15:00',1.68),('8902','2014-02-17','08:20:00',1.86),('8902','2014-02-17','08:25:00',2.05),('8902','2014-02-17','08:30:00',2.26),('8902','2014-02-17','08:35:00',2.43),('8902','2014-02-17','08:40:00',2.61),('8902','2014-02-17','08:45:00',2.77),('8902','2014-02-17','08:50:00',2.85),('8902','2014-02-17','08:55:00',3.15),('8902','2014-02-17','09:00:00',3.3),('8902','2014-02-17','09:05:00',3.46),('8902','2014-02-17','09:10:00',3.64),('8902','2014-02-17','09:15:00',3.8),('8902','2014-02-17','09:20:00',3.94),('8902','2014-02-17','09:25:00',4.1),('8902','2014-02-17','09:30:00',4.27),('8902','2014-02-17','09:35:00',4.39),('8902','2014-02-17','09:40:00',4.53),('8902','2014-02-17','09:45:00',4.65),('8902','2014-02-17','09:50:00',4.79),('8902','2014-02-17','09:55:00',4.94),('8902','2014-02-17','10:00:00',5.08),('8902','2014-02-17','10:05:00',5.18),('8902','2014-02-17','10:10:00',5.28),('8902','2014-02-17','10:15:00',5.38),('8902','2014-02-17','10:20:00',5.49),('8902','2014-02-17','10:25:00',5.57),('8902','2014-02-17','10:30:00',5.64),('8902','2014-02-17','10:35:00',5.7),('8902','2014-02-17','10:40:00',5.8),('8902','2014-02-17','10:45:00',5.89),('8902','2014-02-17','10:50:00',6),('8902','2014-02-17','10:55:00',6.11),('8902','2014-02-17','11:00:00',6.2),('8902','2014-02-17','11:05:00',5.32),('8902','2014-02-17','11:10:00',5.16),('8902','2014-02-17','11:15:00',4.95),('8902','2014-02-17','11:20:00',5.73),('8902','2014-02-17','11:25:00',6.43),('8902','2014-02-17','11:30:00',6),('8902','2014-02-17','11:35:00',5.4),('8902','2014-02-17','11:40:00',4.45),('8902','2014-02-17','11:45:00',4.49),('8902','2014-02-17','11:50:00',3.79),('8902','2014-02-17','11:55:00',3.06),('8902','2014-02-17','12:00:00',2.91),('8902','2014-02-17','12:05:00',2.95),('8902','2014-02-17','12:10:00',3.4),('8902','2014-02-17','12:15:00',3.69),('8902','2014-02-17','12:20:00',3.55),('8902','2014-02-17','12:25:00',4.16),('8902','2014-02-17','12:30:00',4.73),('8902','2014-02-17','12:35:00',3.56),('8902','2014-02-17','12:40:00',3.17),('8902','2014-02-17','12:45:00',3.06),('8902','2014-02-17','12:50:00',3.25),('8902','2014-02-17','12:55:00',3.62),('8902','2014-02-17','13:00:00',2.74),('8902','2014-02-17','13:05:00',2.58),('8902','2014-02-17','13:10:00',2.8),('8902','2014-02-17','13:15:00',3.73),('8902','2014-02-17','13:20:00',4.02),('8902','2014-02-17','13:25:00',4.8),('8902','2014-02-17','13:30:00',3.5),('8902','2014-02-17','13:35:00',2.86),('8902','2014-02-17','13:40:00',3.7),('8902','2014-02-17','13:45:00',4.46),('8902','2014-02-17','13:50:00',3.35),('8902','2014-02-17','13:55:00',3.39),('8902','2014-02-17','14:00:00',3.94),('8902','2014-02-17','14:05:00',5.67),('8902','2014-02-17','14:10:00',3.27),('8902','2014-02-17','14:15:00',2.48),('8902','2014-02-17','14:20:00',2.18),('8902','2014-02-17','14:25:00',2.25),('8902','2014-02-17','14:30:00',2.88),('8902','2014-02-17','14:35:00',2.74),('8902','2014-02-17','14:40:00',2.25),('8902','2014-02-17','14:45:00',2.09),('8902','2014-02-17','14:50:00',1.95),('8902','2014-02-17','14:55:00',1.85),('8902','2014-02-17','15:00:00',1.72),('8902','2014-02-17','15:05:00',1.64),('8902','2014-02-17','15:10:00',1.63),('8902','2014-02-17','15:15:00',1.52),('8902','2014-02-17','15:20:00',1.36),('8902','2014-02-17','15:25:00',1.42),('8902','2014-02-17','15:30:00',1.61),('8902','2014-02-17','15:35:00',2.1),('8902','2014-02-17','15:40:00',2.76),('8902','2014-02-17','15:45:00',2.93),('8902','2014-02-17','15:50:00',2.25),('8902','2014-02-17','15:55:00',2.06),('8902','2014-02-17','16:00:00',2.12),('8902','2014-02-17','16:05:00',2.43),('8902','2014-02-17','16:10:00',2.07),('8902','2014-02-17','16:15:00',1.41),('8902','2014-02-17','16:20:00',1.21),('8902','2014-02-17','16:30:00',1.28),('8902','2014-02-17','16:35:00',1.47),('8902','2014-02-17','16:40:00',1.21),('8902','2014-02-16','08:05:00',1.12),('8902','2014-02-16','08:10:00',1.26),('8902','2014-02-16','08:15:00',1.4),('8902','2014-02-16','08:20:00',1.53),('8902','2014-02-16','08:25:00',1.68),('8902','2014-02-16','08:30:00',1.99),('8902','2014-02-16','08:35:00',2.18),('8902','2014-02-16','08:40:00',2.34),('8902','2014-02-16','08:45:00',2.5),('8902','2014-02-16','08:50:00',2.62),('8902','2014-02-16','08:55:00',2.78),('8902','2014-02-16','09:00:00',2.94),('8902','2014-02-16','09:05:00',3.09),('8902','2014-02-16','09:10:00',3.32),('8902','2014-02-16','09:15:00',3.51),('8902','2014-02-16','09:20:00',3.67),('8902','2014-02-16','09:25:00',3.83),('8902','2014-02-16','09:30:00',4.01),('8902','2014-02-16','09:35:00',4.14),('8902','2014-02-16','09:40:00',4.26),('8902','2014-02-16','09:45:00',4.37),('8902','2014-02-16','09:50:00',4.46),('8902','2014-02-16','09:55:00',4.58),('8902','2014-02-16','10:00:00',4.7),('8902','2014-02-16','10:05:00',4.84),('8902','2014-02-16','10:10:00',4.94),('8902','2014-02-16','10:15:00',5.01),('8902','2014-02-16','10:20:00',5.05),('8902','2014-02-16','10:25:00',5.12),('8902','2014-02-16','10:30:00',5.21),('8902','2014-02-16','10:35:00',5.25),('8902','2014-02-16','10:40:00',5.29),('8902','2014-02-16','10:45:00',5.33),('8902','2014-02-16','10:50:00',5.38),('8902','2014-02-16','10:55:00',5.49),('8902','2014-02-16','11:00:00',5.52),('8902','2014-02-16','11:05:00',5.6),('8902','2014-02-16','11:10:00',5.69),('8902','2014-02-16','11:15:00',5.78),('8902','2014-02-16','11:20:00',5.9),('8902','2014-02-16','11:25:00',6.04),('8902','2014-02-16','11:30:00',6.19),('8902','2014-02-16','11:35:00',6.33),('8902','2014-02-16','11:40:00',6.41),('8902','2014-02-16','11:45:00',6.43),('8902','2014-02-16','11:50:00',6.48),('8902','2014-02-16','11:55:00',6.5),('8902','2014-02-16','12:00:00',6.51),('8902','2014-02-16','12:05:00',6.55),('8902','2014-02-16','12:10:00',6.55),('8902','2014-02-16','12:15:00',6.56),('8902','2014-02-16','12:20:00',6.55),('8902','2014-02-16','12:25:00',6.57),('8902','2014-02-16','12:30:00',6.54),('8902','2014-02-16','12:35:00',6.55),('8902','2014-02-16','12:40:00',6.54),('8902','2014-02-16','12:45:00',6.47),('8902','2014-02-16','12:50:00',6.45),('8902','2014-02-16','12:55:00',6.42),('8902','2014-02-16','13:00:00',6.43),('8902','2014-02-16','13:05:00',6.37),('8902','2014-02-16','13:10:00',6.35),('8902','2014-02-16','13:15:00',6.31),('8902','2014-02-16','13:20:00',6.27),('8902','2014-02-16','13:25:00',6.26),('8902','2014-02-16','13:30:00',6.26),('8902','2014-02-16','13:35:00',6.24),('8902','2014-02-16','13:40:00',6.19),('8902','2014-02-16','13:45:00',6.05),('8902','2014-02-16','13:50:00',6.05),('8902','2014-02-16','13:55:00',5.98),('8902','2014-02-16','14:00:00',5.86),('8902','2014-02-16','14:05:00',5.84),('8902','2014-02-16','14:10:00',5.6),('8902','2014-02-16','14:15:00',5.45),('8902','2014-02-16','14:20:00',5.62),('8902','2014-02-16','14:25:00',5.41),('8902','2014-02-16','14:30:00',5.29),('8902','2014-02-16','14:35:00',5.14),('8902','2014-02-16','14:40:00',4.72),('8902','2014-02-16','14:45:00',5.13),('8902','2014-02-16','14:50:00',4.82),('8902','2014-02-16','14:55:00',4.83),('8902','2014-02-16','15:00:00',4.54),('8902','2014-02-16','15:05:00',4.49),('8902','2014-02-16','15:10:00',4.38),('8902','2014-02-16','15:15:00',4.42),('8902','2014-02-16','15:20:00',4.34),('8902','2014-02-16','15:25:00',4),('8902','2014-02-16','15:30:00',3.95),('8902','2014-02-16','15:35:00',3.77),('8902','2014-02-16','15:40:00',3.51),('8902','2014-02-16','15:45:00',3.49),('8902','2014-02-16','15:50:00',3.26),('8902','2014-02-16','15:55:00',3.1),('8902','2014-02-16','16:00:00',2.84),('8902','2014-02-16','16:05:00',2.75),('8902','2014-02-16','16:10:00',2.57),('8902','2014-02-16','16:15:00',2.35),('8902','2014-02-16','16:20:00',2.14),('8902','2014-02-16','16:25:00',1.99),('8902','2014-02-16','16:30:00',1.76),('8902','2014-02-16','16:35:00',1.53),('8902','2014-02-16','16:40:00',1.37),('8902','2014-02-16','16:45:00',1.17),('8902','2014-02-16','16:50:00',1.01),('8902','2014-02-15','08:05:00',1.04),('8902','2014-02-15','08:10:00',1.19),('8902','2014-02-15','08:15:00',1.36),('8902','2014-02-15','08:20:00',1.51),('8902','2014-02-15','08:25:00',1.69),('8902','2014-02-15','08:30:00',2.21),('8902','2014-02-15','08:35:00',2.44),('8902','2014-02-15','08:40:00',2.46),('8902','2014-02-15','08:45:00',2.83),('8902','2014-02-15','08:50:00',2.68),('8902','2014-02-15','08:55:00',3.11),('8902','2014-02-15','09:00:00',3.38),('8902','2014-02-15','09:05:00',3.55),('8902','2014-02-15','09:10:00',3.47),('8902','2014-02-15','09:15:00',2.93),('8902','2014-02-15','09:20:00',3.74),('8902','2014-02-15','09:25:00',3.92),('8902','2014-02-15','09:30:00',4.09),('8902','2014-02-15','09:35:00',3.46),('8902','2014-02-15','09:40:00',4.32),('8902','2014-02-15','09:45:00',4.64),('8902','2014-02-15','09:50:00',4.79),('8902','2014-02-15','09:55:00',4.7),('8902','2014-02-15','10:00:00',4.59),('8902','2014-02-15','10:05:00',5.16),('8902','2014-02-15','10:10:00',5.32),('8902','2014-02-15','10:15:00',5.41),('8902','2014-02-15','10:20:00',5.53),('8902','2014-02-15','10:25:00',5.66),('8902','2014-02-15','10:30:00',5.75),('8902','2014-02-15','10:35:00',5.97),('8902','2014-02-15','10:40:00',6.14),('8902','2014-02-15','10:45:00',6.09),('8902','2014-02-15','10:50:00',5.54),('8902','2014-02-15','10:55:00',5.16),('8902','2014-02-15','11:00:00',6.16),('8902','2014-02-15','11:05:00',6.32),('8902','2014-02-15','11:10:00',6.08),('8902','2014-02-15','11:15:00',6.26),('8902','2014-02-15','11:20:00',6.17),('8902','2014-02-15','11:25:00',5.95),('8902','2014-02-15','11:30:00',6.17),('8902','2014-02-15','11:35:00',6.51),('8902','2014-02-15','11:40:00',6.54),('8902','2014-02-15','11:45:00',5.83),('8902','2014-02-15','11:50:00',6.59),('8902','2014-02-15','11:55:00',5.66),('8902','2014-02-15','12:00:00',6.72),('8902','2014-02-15','12:05:00',6.67),('8902','2014-02-15','12:10:00',6.7),('8902','2014-02-15','12:15:00',6.7),('8902','2014-02-15','12:20:00',6.73),('8902','2014-02-15','12:25:00',6.61),('8902','2014-02-15','12:30:00',6.72),('8902','2014-02-15','12:35:00',6.68),('8902','2014-02-15','12:40:00',6.64),('8902','2014-02-15','12:45:00',6.6),('8902','2014-02-15','12:50:00',6.64),('8902','2014-02-15','12:55:00',6.7),('8902','2014-02-15','13:00:00',6.63),('8902','2014-02-15','13:05:00',6.63),('8902','2014-02-15','13:10:00',6.45),('8902','2014-02-15','13:15:00',6.54),('8902','2014-02-15','13:20:00',6.59),('8902','2014-02-15','13:25:00',6.5),('8902','2014-02-15','13:30:00',6.35),('8902','2014-02-15','13:35:00',6.35),('8902','2014-02-15','13:40:00',6.27),('8902','2014-02-15','13:45:00',6.33),('8902','2014-02-15','13:50:00',6.25),('8902','2014-02-15','13:55:00',6.27),('8902','2014-02-15','14:00:00',6.28),('8902','2014-02-15','14:05:00',6.26),('8902','2014-02-15','14:10:00',6.2),('8902','2014-02-15','14:15:00',6.11),('8902','2014-02-15','14:20:00',6.06),('8902','2014-02-15','14:25:00',6.03),('8902','2014-02-15','14:30:00',5.91),('8902','2014-02-15','14:35:00',5.78),('8902','2014-02-15','14:40:00',5.6),('8902','2014-02-15','14:45:00',5.58),('8902','2014-02-15','14:50:00',5.46),('8902','2014-02-15','14:55:00',5.4),('8902','2014-02-15','15:00:00',5.21),('8902','2014-02-15','15:05:00',5.17),('8902','2014-02-15','15:10:00',4.97),('8902','2014-02-15','15:15:00',4.84),('8902','2014-02-15','15:20:00',4.67),('8902','2014-02-15','15:25:00',4.43),('8902','2014-02-15','15:30:00',4.33),('8902','2014-02-15','15:35:00',3.85),('8902','2014-02-15','15:40:00',3.4),('8902','2014-02-15','15:45:00',3.98),('8902','2014-02-15','15:50:00',3.29),('8902','2014-02-15','15:55:00',1.25),('8902','2014-02-15','16:10:00',1.43),('8902','2014-02-15','16:15:00',2.25),('8902','2014-02-15','16:20:00',2.41),('8902','2014-02-15','16:25:00',2.79),('8902','2014-02-15','16:30:00',2.85),('8902','2014-02-15','16:35:00',2.39),('8902','2014-02-15','16:40:00',1.74),('8902','2014-02-15','16:45:00',1.29),('8902','2014-04-27','07:40:00',1.02),('8902','2014-04-27','07:45:00',1.13),('8902','2014-04-27','07:50:00',1.17),('8902','2014-04-27','07:55:00',1.27),('8902','2014-04-27','08:00:00',1.42),('8902','2014-04-27','08:05:00',1.08),('8902','2014-04-27','08:15:00',2.39),('8902','2014-04-27','08:20:00',2.67),('8902','2014-04-27','08:25:00',2.68),('8902','2014-04-27','08:30:00',2.46),('8902','2014-04-27','08:35:00',2.28),('8902','2014-04-27','08:40:00',2.09),('8902','2014-04-27','08:45:00',2.11),('8902','2014-04-27','08:50:00',2.39),('8902','2014-04-27','08:55:00',2.52),('8902','2014-04-27','09:00:00',1.95),('8902','2014-04-27','09:05:00',1.58),('8902','2014-04-27','09:10:00',3.53),('8902','2014-04-27','09:15:00',5.27),('8902','2014-04-27','09:20:00',5.29),('8902','2014-04-27','09:25:00',4.42),('8902','2014-04-27','09:30:00',4.19),('8902','2014-04-27','09:35:00',3.5),('8902','2014-04-27','09:40:00',3.92),('8902','2014-04-27','09:45:00',3.72),('8902','2014-04-27','09:50:00',4.48),('8902','2014-04-27','09:55:00',2.98),('8902','2014-04-27','10:00:00',2.99),('8902','2014-04-27','10:05:00',4.2),('8902','2014-04-27','10:10:00',4.45),('8902','2014-04-27','10:15:00',4.3),('8902','2014-04-27','10:20:00',3.63),('8902','2014-04-27','10:25:00',2.91),('8902','2014-04-27','10:30:00',1.2),('8902','2014-04-27','10:40:00',1.47),('8902','2014-04-27','10:45:00',2.74),('8902','2014-04-27','10:50:00',3.84),('8902','2014-04-27','11:00:00',3.56),('8902','2014-04-27','11:05:00',4.38),('8902','2014-04-27','11:10:00',4.2),('8902','2014-04-27','11:15:00',4.72),('8902','2014-04-27','11:20:00',4.63),('8902','2014-04-27','11:25:00',3.55),('8902','2014-04-27','11:30:00',3.82),('8902','2014-04-27','11:35:00',3.7),('8902','2014-04-27','11:40:00',3.02),('8902','2014-04-27','11:45:00',3.08),('8902','2014-04-27','11:50:00',3.48),('8902','2014-04-27','11:55:00',3.83),('8902','2014-04-27','12:00:00',3.51),('8902','2014-04-27','12:05:00',2.56),('8902','2014-04-27','12:10:00',3.51),('8902','2014-04-27','12:15:00',5.17),('8902','2014-04-27','12:20:00',5.92),('8902','2014-04-27','12:25:00',5.45),('8902','2014-04-27','12:30:00',5.16),('8902','2014-04-27','12:35:00',4.78),('8902','2014-04-27','12:40:00',4.32),('8902','2014-04-27','12:45:00',3.72),('8902','2014-04-27','12:50:00',4.57),('8902','2014-04-27','12:55:00',4.28),('8902','2014-04-27','13:00:00',4.35),('8902','2014-04-27','13:05:00',4.93),('8902','2014-04-27','13:10:00',7.87),('8902','2014-04-27','13:15:00',4.67),('8902','2014-04-27','13:20:00',4.21),('8902','2014-04-27','13:25:00',4.78),('8902','2014-04-27','13:30:00',8.55),('8902','2014-04-27','13:35:00',7.55),('8902','2014-04-27','13:40:00',7.36),('8902','2014-04-27','13:45:00',4.07),('8902','2014-04-27','13:50:00',8.2),('8902','2014-04-27','13:55:00',7.04),('8902','2014-04-27','14:00:00',3.47),('8902','2014-04-27','14:05:00',4.6),('8902','2014-04-27','14:10:00',6.09),('8902','2014-04-27','14:15:00',7.43),('8902','2014-04-27','14:20:00',8.07),('8902','2014-04-27','14:25:00',5.41),('8902','2014-04-27','14:30:00',4.77),('8902','2014-04-27','14:35:00',8.32),('8902','2014-04-27','14:40:00',7.65),('8902','2014-04-27','14:45:00',5.76),('8902','2014-04-27','14:50:00',4.73),('8902','2014-04-27','14:55:00',7.65),('8902','2014-04-27','15:00:00',5.23),('8902','2014-04-27','15:05:00',6.05),('8902','2014-04-27','15:10:00',6.51),('8902','2014-04-27','15:15:00',5.33),('8902','2014-04-27','15:20:00',3.79),('8902','2014-04-27','15:25:00',4.39),('8902','2014-04-27','15:30:00',3.97),('8902','2014-04-27','15:35:00',5.96),('8902','2014-04-27','15:40:00',5.53),('8902','2014-04-27','15:45:00',3.62),('8902','2014-04-27','15:50:00',6.99),('8902','2014-04-27','15:55:00',2.78),('8902','2014-04-27','16:00:00',4.88),('8902','2014-04-27','16:05:00',7.19),('8902','2014-04-27','16:10:00',7.63),('8902','2014-04-27','16:15:00',6.14),('8902','2014-04-27','16:20:00',4.28),('8902','2014-04-27','16:25:00',3.13),('8902','2014-04-27','16:30:00',6.95),('8902','2014-04-27','16:35:00',6.67),('8902','2014-04-27','16:40:00',1.66),('8902','2014-04-27','16:45:00',1.28),('8902','2014-04-27','16:50:00',1.19),('8902','2014-04-27','16:55:00',2.35),('8902','2014-04-27','17:00:00',2.3),('8902','2014-04-27','17:05:00',1.08),('8902','2014-04-27','17:20:00',1.38),('8902','2014-04-27','17:25:00',1.91),('8902','2014-04-27','17:30:00',1.73),('8902','2014-04-27','17:35:00',1.78),('8902','2014-04-27','17:40:00',2.8),('8902','2014-04-27','17:45:00',1.88),('8902','2014-04-27','17:50:00',1.38),('8902','2014-04-27','17:55:00',1.36),('8902','2014-04-27','18:00:00',1.16),('8902','2014-04-27','18:10:00',1.01),('8902','2014-04-27','18:15:00',1.04),('8902','2014-02-14','08:05:00',1.01),('8902','2014-02-14','08:10:00',1.31),('8902','2014-02-14','08:15:00',1.53),('8902','2014-02-14','08:20:00',1.72),('8902','2014-02-14','08:25:00',1.88),('8902','2014-02-14','08:30:00',2.04),('8902','2014-02-14','08:35:00',2.22),('8902','2014-02-14','08:40:00',2.38),('8902','2014-02-14','08:45:00',2.5),('8902','2014-02-14','08:50:00',2.63),('8902','2014-02-14','08:55:00',2.79),('8902','2014-02-14','09:00:00',3.06),('8902','2014-02-14','09:05:00',3.24),('8902','2014-02-14','09:10:00',3.4),('8902','2014-02-14','09:15:00',3.56),('8902','2014-02-14','09:20:00',3.79),('8902','2014-02-14','09:25:00',3.94),('8902','2014-02-14','09:30:00',4.09),('8902','2014-02-14','09:35:00',4.26),('8902','2014-02-14','09:40:00',4.41),('8902','2014-02-14','09:45:00',4.53),('8902','2014-02-14','09:50:00',4.64),('8902','2014-02-14','09:55:00',4.79),('8902','2014-02-14','10:00:00',4.91),('8902','2014-02-14','10:05:00',5.02),('8902','2014-02-14','10:10:00',5.11),('8902','2014-02-14','10:15:00',5.22),('8902','2014-02-14','10:20:00',5.31),('8902','2014-02-14','10:25:00',5.39),('8902','2014-02-14','10:30:00',5.45),('8902','2014-02-14','10:35:00',5.53),('8902','2014-02-14','10:40:00',5.64),('8902','2014-02-14','10:45:00',5.68),('8902','2014-02-14','10:50:00',5.79),('8902','2014-02-14','10:55:00',5.97),('8902','2014-02-14','11:00:00',6.16),('8902','2014-02-14','11:05:00',6.37),('8902','2014-02-14','11:10:00',6.14),('8902','2014-02-14','11:15:00',6.1),('8902','2014-02-14','11:20:00',6.54),('8902','2014-02-14','11:25:00',3.24),('8902','2014-02-14','11:30:00',2.57),('8902','2014-02-14','11:35:00',6.59),('8902','2014-02-14','11:40:00',6),('8902','2014-02-14','11:45:00',7.06),('8902','2014-02-14','11:50:00',5.5),('8902','2014-02-14','11:55:00',6.95),('8902','2014-02-14','12:00:00',3.78),('8902','2014-02-14','12:05:00',5.95),('8902','2014-02-14','12:10:00',6),('8902','2014-02-14','12:15:00',7.23),('8902','2014-02-14','12:20:00',7.65),('8902','2014-02-14','12:25:00',7.37),('8902','2014-02-14','12:30:00',7.36),('8902','2014-02-14','12:35:00',7.08),('8902','2014-02-14','12:40:00',7.73),('8902','2014-02-14','12:45:00',8.01),('8902','2014-02-14','12:50:00',7.85),('8902','2014-02-14','12:55:00',6.62),('8902','2014-02-14','13:00:00',7.38),('8902','2014-02-14','13:05:00',7.3),('8902','2014-02-14','13:10:00',7.22),('8902','2014-02-14','13:15:00',7.1),('8902','2014-02-14','13:20:00',6.96),('8902','2014-02-14','13:25:00',6.69),('8902','2014-02-14','13:30:00',6.63),('8902','2014-02-14','13:35:00',6.58),('8902','2014-02-14','13:40:00',6.52),('8902','2014-02-14','13:45:00',6.44),('8902','2014-02-14','13:50:00',6.44),('8902','2014-02-14','13:55:00',6.27),('8902','2014-02-14','14:00:00',6.24),('8902','2014-02-14','14:05:00',6.19),('8902','2014-02-14','14:10:00',6.05),('8902','2014-02-14','14:15:00',6),('8902','2014-02-14','14:20:00',5.93),('8902','2014-02-14','14:25:00',5.78),('8902','2014-02-14','14:30:00',5.71),('8902','2014-02-14','14:35:00',5.64),('8902','2014-02-14','14:40:00',5.56),('8902','2014-02-14','14:45:00',5.42),('8902','2014-02-14','14:50:00',5.3),('8902','2014-02-14','14:55:00',5.15),('8902','2014-02-14','15:00:00',4.9),('8902','2014-02-14','15:05:00',4.82),('8902','2014-02-14','15:10:00',4.62),('8902','2014-02-14','15:15:00',4.62),('8902','2014-02-14','15:20:00',4.49),('8902','2014-02-14','15:25:00',4.32),('8902','2014-02-14','15:30:00',4.18),('8902','2014-02-14','15:35:00',4.08),('8902','2014-02-14','15:40:00',3.97),('8902','2014-02-14','15:45:00',3.83),('8902','2014-02-14','15:50:00',3.64),('8902','2014-02-14','15:55:00',3.45),('8902','2014-02-14','16:00:00',3.26),('8902','2014-02-14','16:05:00',3.08),('8902','2014-02-14','16:10:00',2.89),('8902','2014-02-14','16:15:00',2.72),('8902','2014-02-14','16:20:00',2.48),('8902','2014-02-14','16:25:00',2.26),('8902','2014-02-14','16:30:00',2.08),('8902','2014-02-14','16:35:00',1.89),('8902','2014-02-14','16:40:00',1.69),('8902','2014-02-14','16:45:00',1.47),('8902','2014-02-14','16:50:00',1.27),('8902','2014-02-14','16:55:00',1.07),('8902','2014-02-13','08:40:00',1.88),('8902','2014-02-13','08:45:00',1.83),('8902','2014-02-13','08:50:00',2.68),('8902','2014-02-13','08:55:00',2.85),('8902','2014-02-13','09:00:00',3.03),('8902','2014-02-13','09:05:00',3.27),('8902','2014-02-13','09:10:00',2.37),('8902','2014-02-13','09:15:00',2.19),('8902','2014-02-13','09:20:00',3.01),('8902','2014-02-13','09:25:00',3),('8902','2014-02-13','09:30:00',3.56),('8902','2014-02-13','09:35:00',3.48),('8902','2014-02-13','09:40:00',2.33),('8902','2014-02-13','09:45:00',2.98),('8902','2014-02-13','09:50:00',3.95),('8902','2014-02-13','09:55:00',5.09),('8902','2014-02-13','10:00:00',4.61),('8902','2014-02-13','10:05:00',5.28),('8902','2014-02-13','10:10:00',5.55),('8902','2014-02-13','10:15:00',4.19),('8902','2014-02-13','10:20:00',5.36),('8902','2014-02-13','10:25:00',5.22),('8902','2014-02-13','10:30:00',5.86),('8902','2014-02-13','10:35:00',5.77),('8902','2014-02-13','10:40:00',5.81),('8902','2014-02-13','10:45:00',6.07),('8902','2014-02-13','10:50:00',6.17),('8902','2014-02-13','10:55:00',6.28),('8902','2014-02-13','11:00:00',6.38),('8902','2014-02-13','11:05:00',6.44),('8902','2014-02-13','11:10:00',6.5),('8902','2014-02-13','11:15:00',6.54),('8902','2014-02-13','11:20:00',6.62),('8902','2014-02-13','11:25:00',6.7),('8902','2014-02-13','11:30:00',6.77),('8902','2014-02-13','11:35:00',6.87),('8902','2014-02-13','11:40:00',6.72),('8902','2014-02-13','11:45:00',6.89),('8902','2014-02-13','11:50:00',6.57),('8902','2014-02-13','11:55:00',6.89),('8902','2014-02-13','12:00:00',6.97),('8902','2014-02-13','12:05:00',6.95),('8902','2014-02-13','12:10:00',6.92),('8902','2014-02-13','12:15:00',7.01),('8902','2014-02-13','12:20:00',6.99),('8902','2014-02-13','12:25:00',7.04),('8902','2014-02-13','12:30:00',7.03),('8902','2014-02-13','12:35:00',7.02),('8902','2014-02-13','12:40:00',6.98),('8902','2014-02-13','12:45:00',6.93),('8902','2014-02-13','12:50:00',6.96),('8902','2014-02-13','12:55:00',6.97),('8902','2014-02-13','13:00:00',6.95),('8902','2014-02-13','13:05:00',6.91),('8902','2014-02-13','13:10:00',6.88),('8902','2014-02-13','13:15:00',6.85),('8902','2014-02-13','13:20:00',6.83),('8902','2014-02-13','13:25:00',6.73),('8902','2014-02-13','13:30:00',6.65),('8902','2014-02-13','13:35:00',6.62),('8902','2014-02-13','13:40:00',6.63),('8902','2014-02-13','13:45:00',6.51),('8902','2014-02-13','13:50:00',6.48),('8902','2014-02-13','13:55:00',6.42),('8902','2014-02-13','14:00:00',6.34),('8902','2014-02-13','14:05:00',6.26),('8902','2014-02-13','14:10:00',6.17),('8902','2014-02-13','14:15:00',6.04),('8902','2014-02-13','14:20:00',5.98),('8902','2014-02-13','14:25:00',5.93),('8902','2014-02-13','14:30:00',5.87),('8902','2014-02-13','14:35:00',5.75),('8902','2014-02-13','14:40:00',5.59),('8902','2014-02-13','14:45:00',5.45),('8902','2014-02-13','14:50:00',5.32),('8902','2014-02-13','14:55:00',5.2),('8902','2014-02-13','15:00:00',5.08),('8902','2014-02-13','15:05:00',4.98),('8902','2014-02-13','15:10:00',4.89),('8902','2014-02-13','15:15:00',4.75),('8902','2014-02-13','15:20:00',4.59),('8902','2014-02-13','15:25:00',4.4),('8902','2014-02-13','15:30:00',4.28),('8902','2014-02-13','15:35:00',4.12),('8902','2014-02-13','15:40:00',3.95),('8902','2014-02-13','15:45:00',3.78),('8902','2014-02-13','15:50:00',3.58),('8902','2014-02-13','15:55:00',3.38),('8902','2014-02-13','16:00:00',3.19),('8902','2014-02-13','16:05:00',3.04),('8902','2014-02-13','16:10:00',2.81),('8902','2014-02-13','16:15:00',2.58),('8902','2014-02-13','16:20:00',2.43),('8902','2014-02-13','16:25:00',2.22),('8902','2014-02-13','16:30:00',2),('8902','2014-02-13','16:35:00',1.76),('8902','2014-02-13','16:40:00',1.61),('8902','2014-02-13','16:45:00',1.44),('8902','2014-02-13','16:50:00',1.2),('8902','2014-02-12','08:10:00',1.14),('8902','2014-02-12','08:15:00',1.36),('8902','2014-02-12','08:20:00',1.67),('8902','2014-02-12','08:25:00',1.89),('8902','2014-02-12','08:30:00',2.11),('8902','2014-02-12','08:35:00',2.23),('8902','2014-02-12','08:40:00',2.34),('8902','2014-02-12','08:45:00',2.55),('8902','2014-02-12','08:50:00',2.76),('8902','2014-02-12','08:55:00',2.97),('8902','2014-02-12','09:00:00',3.17),('8902','2014-02-12','09:05:00',3.38),('8902','2014-02-12','09:10:00',3.58),('8902','2014-02-12','09:15:00',3.7),('8902','2014-02-12','09:20:00',3.89),('8902','2014-02-12','09:25:00',4.05),('8902','2014-02-12','09:30:00',4.2),('8902','2014-02-12','09:35:00',4.37),('8902','2014-02-12','09:40:00',4.49),('8902','2014-02-12','09:45:00',4.6),('8902','2014-02-12','09:50:00',4.73),('8902','2014-02-12','09:55:00',4.87),('8902','2014-02-12','10:00:00',5),('8902','2014-02-12','10:05:00',5.12),('8902','2014-02-12','10:10:00',5.22),('8902','2014-02-12','10:15:00',5.32),('8902','2014-02-12','10:20:00',5.4),('8902','2014-02-12','10:25:00',5.45),('8902','2014-02-12','10:30:00',5.6),('8902','2014-02-12','10:35:00',5.69),('8902','2014-02-12','10:40:00',5.74),('8902','2014-02-12','10:45:00',5.73),('8902','2014-02-12','10:50:00',5.83),('8902','2014-02-12','10:55:00',5.95),('8902','2014-02-12','11:00:00',6),('8902','2014-02-12','11:05:00',6.06),('8902','2014-02-12','11:10:00',6.29),('8902','2014-02-12','11:15:00',6.43),('8902','2014-02-12','11:20:00',6.43),('8902','2014-02-12','11:25:00',6.09),('8902','2014-02-12','11:30:00',5.73),('8902','2014-02-12','11:35:00',6.42),('8902','2014-02-12','11:40:00',4.71),('8902','2014-02-12','11:45:00',6.94),('8902','2014-02-12','11:50:00',3.44),('8902','2014-02-12','11:55:00',6.62),('8902','2014-02-12','12:00:00',4.07),('8902','2014-02-12','12:05:00',3.4),('8902','2014-02-12','12:10:00',5.85),('8902','2014-02-12','12:15:00',5.18),('8902','2014-02-12','12:20:00',4.8),('8902','2014-02-12','12:25:00',2.31),('8902','2014-02-12','12:30:00',7.74),('8902','2014-02-12','12:35:00',8.1),('8902','2014-02-12','12:40:00',7.79),('8902','2014-02-12','12:45:00',1.68),('8902','2014-02-12','12:50:00',2.13),('8902','2014-02-12','12:55:00',3.9),('8902','2014-02-12','13:00:00',3.59),('8902','2014-02-12','13:05:00',7.37),('8902','2014-02-12','13:10:00',7.19),('8902','2014-02-12','13:15:00',7.01),('8902','2014-02-12','13:20:00',6.97),('8902','2014-02-12','13:25:00',6.87),('8902','2014-02-12','13:30:00',6.86),('8902','2014-02-12','13:35:00',6.81),('8902','2014-02-12','13:40:00',6.73),('8902','2014-02-12','13:45:00',6.71),('8902','2014-02-12','13:50:00',6.62),('8902','2014-02-12','13:55:00',6.59),('8902','2014-02-12','14:00:00',6.49),('8902','2014-02-12','14:05:00',6.4),('8902','2014-02-12','14:10:00',6.32),('8902','2014-02-12','14:15:00',6.22),('8902','2014-02-12','14:20:00',6.11),('8902','2014-02-12','14:25:00',6.03),('8902','2014-02-12','14:30:00',5.93),('8902','2014-02-12','14:35:00',5.88),('8902','2014-02-12','14:40:00',5.73),('8902','2014-02-12','14:45:00',5.45),('8902','2014-02-12','14:50:00',3.01),('8902','2014-02-12','14:55:00',5.68),('8902','2014-02-12','15:00:00',5.74),('8902','2014-02-12','15:05:00',4.41),('8902','2014-02-12','15:10:00',5.3),('8902','2014-02-12','15:15:00',4.4),('8902','2014-02-12','15:20:00',4.96),('8902','2014-02-12','15:25:00',4.79),('8902','2014-02-12','15:30:00',1.98),('8902','2014-02-12','15:35:00',3.14),('8902','2014-02-12','15:40:00',3.89),('8902','2014-02-12','15:45:00',4.16),('8902','2014-02-12','15:50:00',2.26),('8902','2014-02-12','15:55:00',2.93),('8902','2014-02-12','16:05:00',1.98),('8902','2014-02-12','16:10:00',3.26),('8902','2014-02-12','16:15:00',2.07),('8902','2014-02-12','16:30:00',1.06),('8902','2014-02-12','16:35:00',1.03),('8902','2014-02-11','08:20:00',1.46),('8902','2014-02-11','08:45:00',2.22),('8902','2014-02-11','08:50:00',2.74),('8902','2014-02-11','08:55:00',2.98),('8902','2014-02-11','09:00:00',1.38),('8902','2014-02-11','09:10:00',1.68),('8902','2014-02-11','09:15:00',3.8),('8902','2014-02-11','09:20:00',3.75),('8902','2014-02-11','09:25:00',3.44),('8902','2014-02-11','09:30:00',1.73),('8902','2014-02-11','09:35:00',1.5),('8902','2014-02-11','09:40:00',2.55),('8902','2014-02-11','09:45:00',4.32),('8902','2014-02-11','09:50:00',3.74),('8902','2014-02-11','09:55:00',3.07),('8902','2014-02-11','10:00:00',1.91),('8902','2014-02-11','10:05:00',2.93),('8902','2014-02-11','10:10:00',2.71),('8902','2014-02-11','10:15:00',2.2),('8902','2014-02-11','10:20:00',2.05),('8902','2014-02-11','10:25:00',2.23),('8902','2014-02-11','10:30:00',2.87),('8902','2014-02-11','10:35:00',4.21),('8902','2014-02-11','10:40:00',2.87),('8902','2014-02-11','10:45:00',4.16),('8902','2014-02-11','10:50:00',2.95),('8902','2014-02-11','10:55:00',2.9),('8902','2014-02-11','11:00:00',2.98),('8902','2014-02-11','11:05:00',5.56),('8902','2014-02-11','11:10:00',3.35),('8902','2014-02-11','11:15:00',3.06),('8902','2014-02-11','11:20:00',3.75),('8902','2014-02-11','11:25:00',3.25),('8902','2014-02-11','11:30:00',4.06),('8902','2014-02-11','11:35:00',3.94),('8902','2014-02-11','11:40:00',2.66),('8902','2014-02-11','11:45:00',2.1),('8902','2014-02-11','11:50:00',1.85),('8902','2014-02-11','11:55:00',1.54),('8902','2014-02-11','12:00:00',1.49),('8902','2014-02-11','12:05:00',2),('8902','2014-02-11','12:10:00',2.36),('8902','2014-02-11','12:15:00',2.5),('8902','2014-02-11','12:20:00',2.49),('8902','2014-02-11','12:25:00',2.63),('8902','2014-02-11','12:30:00',2.81),('8902','2014-02-11','12:35:00',2.69),('8902','2014-02-11','12:40:00',2.61),('8902','2014-02-11','12:45:00',2.9),('8902','2014-02-11','12:50:00',3.46),('8902','2014-02-11','12:55:00',3.46),('8902','2014-02-11','13:00:00',3.66),('8902','2014-02-11','13:05:00',2.97),('8902','2014-02-11','13:10:00',3.08),('8902','2014-02-11','13:15:00',2.96),('8902','2014-02-11','13:20:00',2.67),('8902','2014-02-11','13:25:00',3.28),('8902','2014-02-11','13:30:00',4.59),('8902','2014-02-11','13:35:00',7.31),('8902','2014-02-11','13:40:00',6.81),('8902','2014-02-11','13:45:00',5.25),('8902','2014-02-11','13:50:00',6.05),('8902','2014-02-11','13:55:00',5.11),('8902','2014-02-11','14:00:00',6.89),('8902','2014-02-11','14:05:00',6.98),('8902','2014-02-11','14:10:00',6.66),('8902','2014-02-11','14:15:00',6.85),('8902','2014-02-11','14:20:00',6.14),('8902','2014-02-11','14:25:00',6.46),('8902','2014-02-11','14:30:00',3.54),('8902','2014-02-11','14:35:00',5.34),('8902','2014-02-11','14:40:00',4.26),('8902','2014-02-11','14:45:00',4.22),('8902','2014-02-11','14:50:00',6.21),('8902','2014-02-11','14:55:00',5.89),('8902','2014-02-11','15:00:00',3.71),('8902','2014-02-11','15:05:00',2.54),('8902','2014-02-11','15:10:00',2.47),('8902','2014-02-11','15:15:00',2.44),('8902','2014-02-11','15:20:00',4.01),('8902','2014-02-11','15:25:00',3.38),('8902','2014-02-11','15:30:00',1.96),('8902','2014-02-11','15:35:00',4.33),('8902','2014-02-11','15:40:00',4.29),('8902','2014-02-11','15:45:00',3.21),('8902','2014-02-11','15:50:00',3.99),('8902','2014-02-11','15:55:00',1.6),('8902','2014-02-11','16:00:00',1.39),('8902','2014-02-11','16:05:00',1.21),('8902','2014-02-10','09:00:00',1.2),('8902','2014-02-10','09:05:00',1.32),('8902','2014-02-10','09:10:00',1.28),('8902','2014-02-10','09:15:00',1.54),('8902','2014-02-10','09:20:00',2.23),('8902','2014-02-10','09:25:00',2.46),('8902','2014-02-10','09:30:00',2.42),('8902','2014-02-10','09:35:00',2.42),('8902','2014-02-10','09:40:00',2.41),('8902','2014-02-10','09:45:00',2.31),('8902','2014-02-10','09:50:00',2.54),('8902','2014-02-10','09:55:00',2.66),('8902','2014-02-10','10:00:00',2.29),('8902','2014-02-10','10:05:00',2.46),('8902','2014-02-10','10:10:00',2.77),('8902','2014-02-10','10:15:00',3.26),('8902','2014-02-10','10:20:00',3.69),('8902','2014-02-10','10:25:00',3.86),('8902','2014-02-10','10:30:00',4.19),('8902','2014-02-10','10:35:00',4.89),('8902','2014-02-10','10:40:00',5),('8902','2014-02-10','10:45:00',4.39),('8902','2014-02-10','10:50:00',4.55),('8902','2014-02-10','10:55:00',3.97),('8902','2014-02-10','11:00:00',4.41),('8902','2014-02-10','11:05:00',4.51),('8902','2014-02-10','11:10:00',3.87),('8902','2014-02-10','11:15:00',3.18),('8902','2014-02-10','11:20:00',3.38),('8902','2014-02-10','11:25:00',4.28),('8902','2014-02-10','11:30:00',5.08),('8902','2014-02-10','11:35:00',5.14),('8902','2014-02-10','11:40:00',3.63),('8902','2014-02-10','11:45:00',3.04),('8902','2014-02-10','11:50:00',4.4),('8902','2014-02-10','11:55:00',2.93),('8902','2014-02-10','12:00:00',2.63),('8902','2014-02-10','12:05:00',3.19),('8902','2014-02-10','12:10:00',3.17),('8902','2014-02-10','12:15:00',3.05),('8902','2014-02-10','12:20:00',3.45),('8902','2014-02-10','12:25:00',4.61),('8902','2014-02-10','12:30:00',4.45),('8902','2014-02-10','12:35:00',3.77),('8902','2014-02-10','12:40:00',2.86),('8902','2014-02-10','12:45:00',3.4),('8902','2014-02-10','12:50:00',2.68),('8902','2014-02-10','12:55:00',3.35),('8902','2014-02-10','13:00:00',3.58),('8902','2014-02-10','13:05:00',4.43),('8902','2014-02-10','13:10:00',5.44),('8902','2014-02-10','13:15:00',5.34),('8902','2014-02-10','13:20:00',6.5),('8902','2014-02-10','13:25:00',5.95),('8902','2014-02-10','13:30:00',5.28),('8902','2014-02-10','13:35:00',5.03),('8902','2014-02-10','13:40:00',6.07),('8902','2014-02-10','13:45:00',4.65),('8902','2014-02-10','13:50:00',3.39),('8902','2014-02-10','13:55:00',2.72),('8902','2014-02-10','14:00:00',3.83),('8902','2014-02-10','14:05:00',4.03),('8902','2014-02-10','14:10:00',3.5),('8902','2014-02-10','14:15:00',3.85),('8902','2014-02-10','14:20:00',2.7),('8902','2014-02-10','14:25:00',2.44),('8902','2014-02-10','14:30:00',3.1),('8902','2014-02-10','14:35:00',2.85),('8902','2014-02-10','14:40:00',2.18),('8902','2014-02-10','14:45:00',2.05),('8902','2014-02-10','14:50:00',1.7),('8902','2014-02-10','14:55:00',1.77),('8902','2014-02-10','15:00:00',1.73),('8902','2014-02-10','15:05:00',1.78),('8902','2014-02-10','15:10:00',1.91),('8902','2014-02-10','15:15:00',2.45),('8902','2014-02-10','15:20:00',3.15),('8902','2014-02-10','15:25:00',2.13),('8902','2014-02-10','15:30:00',1.75),('8902','2014-02-10','15:35:00',1.84),('8902','2014-02-10','15:40:00',1.68),('8902','2014-02-10','15:45:00',1.36),('8902','2014-02-10','15:50:00',1.22),('8902','2014-02-10','15:55:00',1.25),('8902','2014-02-10','16:00:00',1.47),('8902','2014-02-10','16:05:00',1.93),('8902','2014-02-10','16:10:00',1.72),('8902','2014-02-10','16:15:00',1.66),('8902','2014-02-10','16:20:00',1.68),('8902','2014-02-10','16:25:00',1.79),('8902','2014-02-10','16:30:00',1.68),('8902','2014-02-10','16:35:00',1.47),('8902','2014-02-10','16:40:00',1.29),('8902','2014-02-10','16:45:00',1.02),('8902','2014-02-09','10:25:00',1.09),('8902','2014-02-09','10:30:00',1.09),('8902','2014-02-09','10:35:00',1.02),('8902','2014-02-09','12:25:00',1.7),('8902','2014-02-09','12:30:00',1.42),('8902','2014-02-09','12:35:00',1.02),('8902','2014-02-09','12:50:00',1.2),('8902','2014-02-09','12:55:00',1.8),('8902','2014-02-09','13:00:00',2.41),('8902','2014-02-09','13:05:00',2.04),('8902','2014-02-09','13:10:00',1.5),('8902','2014-02-09','13:15:00',1.47),('8902','2014-02-09','13:20:00',1.38),('8902','2014-02-09','13:25:00',1.28),('8902','2014-02-09','13:30:00',1.47),('8902','2014-02-09','13:35:00',1.64),('8902','2014-02-09','13:40:00',1.63),('8902','2014-02-09','13:45:00',1.63),('8902','2014-02-09','13:50:00',1.55),('8902','2014-02-09','13:55:00',1.83),('8902','2014-02-09','14:00:00',1.9),('8902','2014-02-09','14:05:00',1.64),('8902','2014-02-09','14:10:00',1.57),('8902','2014-02-09','14:15:00',1.63),('8902','2014-02-09','14:20:00',1.67),('8902','2014-02-09','14:25:00',1.77),('8902','2014-02-09','14:30:00',1.95),('8902','2014-02-09','14:35:00',2.09),('8902','2014-02-09','14:40:00',2.16),('8902','2014-02-09','14:45:00',1.91),('8902','2014-02-09','14:50:00',1.57),('8902','2014-02-09','14:55:00',1.39),('8902','2014-02-09','15:00:00',1.36),('8902','2014-02-09','15:05:00',1.49),('8902','2014-02-09','15:10:00',1.42),('8902','2014-02-09','15:15:00',1.4),('8902','2014-02-09','15:20:00',1.43),('8902','2014-02-09','15:25:00',1.51),('8902','2014-02-09','15:30:00',1.4),('8902','2014-02-09','15:35:00',1.14),('8902','2014-02-08','11:00:00',1.4),('8902','2014-02-08','11:05:00',1.35),('8902','2014-02-08','11:10:00',1.09),('8902','2014-02-08','11:15:00',1.13),('8902','2014-02-08','11:20:00',1.14),('8902','2014-02-08','11:25:00',1.8),('8902','2014-02-08','11:30:00',2.19),('8902','2014-02-08','11:35:00',2.6),('8902','2014-02-08','11:40:00',1.61),('8902','2014-02-08','12:15:00',1.55),('8902','2014-02-08','12:20:00',1.39),('8902','2014-02-08','12:25:00',2.74),('8902','2014-02-08','12:30:00',3.2),('8902','2014-02-08','12:35:00',2.21),('8902','2014-02-08','12:40:00',1.41),('8902','2014-02-08','12:45:00',4.41),('8902','2014-02-08','12:50:00',1.45),('8902','2014-02-08','12:55:00',2.87),('8902','2014-02-08','13:00:00',5.58),('8902','2014-02-08','13:05:00',5.01),('8902','2014-02-08','13:10:00',5.09),('8902','2014-02-08','13:15:00',3.57),('8902','2014-02-08','13:20:00',1.47),('8902','2014-02-08','13:25:00',1.98),('8902','2014-02-08','13:30:00',1.61),('8902','2014-02-08','13:35:00',1.55),('8902','2014-02-08','13:40:00',3.52),('8902','2014-02-08','13:45:00',6.57),('8902','2014-02-08','13:50:00',3.79),('8902','2014-02-08','13:55:00',5.7),('8902','2014-02-08','14:00:00',3.94),('8902','2014-02-08','14:05:00',5.59),('8902','2014-02-08','14:10:00',4.9),('8902','2014-02-08','14:15:00',2.52),('8902','2014-02-08','14:20:00',2.73),('8902','2014-02-08','14:25:00',3.31),('8902','2014-02-08','14:30:00',5.37),('8902','2014-02-08','14:35:00',4.49),('8902','2014-02-08','14:40:00',2.98),('8902','2014-02-08','14:45:00',1.86),('8902','2014-02-08','14:50:00',4.04),('8902','2014-02-08','14:55:00',2.21),('8902','2014-02-08','15:00:00',2.33),('8902','2014-02-08','15:05:00',1.12),('8902','2014-02-08','15:10:00',3.43),('8902','2014-02-08','15:15:00',3.71),('8902','2014-02-08','15:20:00',4.2),('8902','2014-02-08','15:25:00',3.94),('8902','2014-02-08','15:30:00',2.66),('8902','2014-02-08','15:35:00',2.13),('8902','2014-02-08','15:40:00',3.08),('8902','2014-02-08','15:45:00',3.07),('8902','2014-02-08','15:50:00',3.17),('8902','2014-02-08','15:55:00',2.94),('8902','2014-02-08','16:00:00',2.57),('8902','2014-02-08','16:05:00',2.38),('8902','2014-02-08','16:10:00',2.36),('8902','2014-02-08','16:15:00',2.11),('8902','2014-02-08','16:20:00',1.75),('8902','2014-02-08','16:25:00',1.51),('8902','2014-02-08','16:40:00',1.13),('8902','2014-02-07','09:40:00',1.02),('8902','2014-02-07','09:45:00',1.56),('8902','2014-02-07','09:50:00',3.08),('8902','2014-02-07','09:55:00',2.98),('8902','2014-02-07','10:00:00',1.62),('8902','2014-02-07','10:05:00',1.59),('8902','2014-02-07','10:10:00',1.6),('8902','2014-02-07','10:15:00',2.82),('8902','2014-02-07','10:20:00',3.54),('8902','2014-02-07','10:25:00',2.33),('8902','2014-02-07','10:30:00',3.42),('8902','2014-02-07','10:35:00',5.45),('8902','2014-02-07','10:40:00',3.52),('8902','2014-02-07','10:45:00',2.7),('8902','2014-02-07','10:50:00',3.88),('8902','2014-02-07','10:55:00',6.21),('8902','2014-02-07','11:00:00',3.95),('8902','2014-02-07','11:05:00',6.52),('8902','2014-02-07','11:10:00',5.33),('8902','2014-02-07','11:15:00',3.27),('8902','2014-02-07','11:20:00',3.66),('8902','2014-02-07','11:25:00',2.45),('8902','2014-02-07','11:30:00',1.82),('8902','2014-02-07','11:35:00',7.01),('8902','2014-02-07','11:40:00',5.69),('8902','2014-02-07','11:45:00',1.33),('8902','2014-02-07','11:50:00',1.53),('8902','2014-02-07','11:55:00',7.53),('8902','2014-02-07','12:00:00',5.13),('8902','2014-02-07','12:05:00',2.05),('8902','2014-02-07','12:10:00',3.04),('8902','2014-02-07','12:15:00',7.94),('8902','2014-02-07','12:20:00',2.95),('8902','2014-02-07','12:25:00',2.29),('8902','2014-02-07','12:30:00',7.85),('8902','2014-02-07','12:35:00',4.9),('8902','2014-02-07','12:40:00',5.48),('8902','2014-02-07','12:45:00',5.1),('8902','2014-02-07','12:50:00',7.16),('8902','2014-02-07','12:55:00',7.12),('8902','2014-02-07','13:00:00',3.67),('8902','2014-02-07','13:05:00',3.08),('8902','2014-02-07','13:10:00',2.43),('8902','2014-02-07','13:15:00',8.21),('8902','2014-02-07','13:20:00',8.18),('8902','2014-02-07','13:25:00',6.94),('8902','2014-02-07','13:30:00',7.02),('8902','2014-02-07','13:35:00',3.87),('8902','2014-02-07','13:40:00',6.16),('8902','2014-02-07','13:45:00',7.21),('8902','2014-02-07','13:50:00',6.62),('8902','2014-02-07','13:55:00',6.31),('8902','2014-02-07','14:00:00',6.54),('8902','2014-02-07','14:05:00',6.51),('8902','2014-02-07','14:10:00',4.48),('8902','2014-02-07','14:15:00',3.44),('8902','2014-02-07','14:20:00',5.27),('8902','2014-02-07','14:25:00',3.66),('8902','2014-02-07','14:30:00',6.61),('8902','2014-02-07','14:35:00',4.04),('8902','2014-02-07','14:40:00',5.47),('8902','2014-02-07','14:45:00',1.97),('8902','2014-02-07','14:50:00',4.59),('8902','2014-02-07','14:55:00',5.54),('8902','2014-02-07','15:00:00',3.19),('8902','2014-02-07','15:05:00',1.93),('8902','2014-02-07','15:10:00',1.73),('8902','2014-02-07','15:15:00',1.65),('8902','2014-02-07','15:20:00',4.84),('8902','2014-02-07','15:25:00',2.41),('8902','2014-02-07','15:35:00',1.07),('8902','2014-02-07','15:40:00',3.45),('8902','2014-02-07','15:45:00',4.12),('8902','2014-02-07','15:50:00',3.64),('8902','2014-02-07','15:55:00',3.38),('8902','2014-02-07','16:00:00',1.55),('8902','2014-02-07','16:05:00',2.23),('8902','2014-02-07','16:10:00',2.66),('8902','2014-02-07','16:15:00',1.5),('8902','2014-02-07','16:20:00',1.17),('8902','2014-02-06','08:25:00',1.56),('8902','2014-02-06','08:30:00',1.55),('8902','2014-02-06','08:35:00',1.25),('8902','2014-02-06','08:40:00',2.16),('8902','2014-02-06','08:45:00',2.37),('8902','2014-02-06','08:50:00',2.52),('8902','2014-02-06','08:55:00',2.69),('8902','2014-02-06','09:00:00',2.86),('8902','2014-02-06','09:05:00',3.04),('8902','2014-02-06','09:10:00',3.23),('8902','2014-02-06','09:15:00',3.39),('8902','2014-02-06','09:20:00',3.55),('8902','2014-02-06','09:25:00',3.73),('8902','2014-02-06','09:30:00',3.87),('8902','2014-02-06','09:35:00',4.03),('8902','2014-02-06','09:40:00',4.18),('8902','2014-02-06','09:45:00',4.3),('8902','2014-02-06','09:50:00',4.43),('8902','2014-02-06','09:55:00',4.53),('8902','2014-02-06','10:00:00',4.65),('8902','2014-02-06','10:05:00',4.74),('8902','2014-02-06','10:10:00',4.84),('8902','2014-02-06','10:15:00',5.01),('8902','2014-02-06','10:20:00',5.16),('8902','2014-02-06','10:25:00',5.23),('8902','2014-02-06','10:30:00',5.44),('8902','2014-02-06','10:35:00',4.96),('8902','2014-02-06','10:40:00',5.72),('8902','2014-02-06','10:45:00',5.96),('8902','2014-02-06','10:50:00',4.97),('8902','2014-02-06','10:55:00',4.94),('8902','2014-02-06','11:00:00',5.55),('8902','2014-02-06','11:05:00',4.34),('8902','2014-02-06','11:10:00',4.44),('8902','2014-02-06','11:15:00',6.49),('8902','2014-02-06','11:20:00',6.82),('8902','2014-02-06','11:25:00',6.85),('8902','2014-02-06','11:30:00',6.6),('8902','2014-02-06','11:35:00',6.53),('8902','2014-02-06','11:40:00',6.71),('8902','2014-02-06','11:45:00',7.03),('8902','2014-02-06','11:50:00',7.13),('8902','2014-02-06','11:55:00',6.96),('8902','2014-02-06','12:00:00',7.67),('8902','2014-02-06','12:05:00',7.13),('8902','2014-02-06','12:10:00',7.32),('8902','2014-02-06','12:15:00',4.23),('8902','2014-02-06','12:20:00',3.23),('8902','2014-02-06','12:25:00',7.96),('8902','2014-02-06','12:30:00',5.74),('8902','2014-02-06','12:35:00',1.91),('8902','2014-02-06','12:40:00',3.48),('8902','2014-02-06','12:45:00',2.48),('8902','2014-02-06','12:50:00',4.01),('8902','2014-02-06','12:55:00',6.1),('8902','2014-02-06','13:00:00',4.93),('8902','2014-02-06','13:05:00',5.96),('8902','2014-02-06','13:10:00',8.21),('8902','2014-02-06','13:15:00',7.58),('8902','2014-02-06','13:20:00',2.57),('8902','2014-02-06','13:25:00',3.89),('8902','2014-02-06','13:30:00',4.91),('8902','2014-02-06','13:35:00',4.67),('8902','2014-02-06','13:40:00',2.62),('8902','2014-02-06','13:45:00',5.36),('8902','2014-02-06','13:50:00',5.92),('8902','2014-02-06','13:55:00',6.14),('8902','2014-02-06','14:00:00',6.12),('8902','2014-02-06','14:05:00',6.75),('8902','2014-02-06','14:10:00',5.64),('8902','2014-02-06','14:15:00',4.43),('8902','2014-02-06','14:20:00',2.59),('8902','2014-02-06','14:25:00',1.44),('8902','2014-02-06','14:30:00',3.15),('8902','2014-02-06','14:35:00',2.38),('8902','2014-02-06','14:40:00',4.37),('8902','2014-02-06','14:45:00',5.29),('8902','2014-02-06','14:50:00',5.31),('8902','2014-02-06','14:55:00',5.23),('8902','2014-02-06','15:00:00',5.04),('8902','2014-02-06','15:05:00',4.97),('8902','2014-02-06','15:10:00',4.87),('8902','2014-02-06','15:15:00',4.59),('8902','2014-02-06','15:20:00',3.45),('8902','2014-02-06','15:25:00',4.29),('8902','2014-02-06','15:30:00',4.13),('8902','2014-02-06','15:35:00',3.97),('8902','2014-02-06','15:40:00',3.81),('8902','2014-02-06','15:45:00',3.61),('8902','2014-02-06','15:50:00',3.4),('8902','2014-02-06','15:55:00',3.25),('8902','2014-02-06','16:00:00',3.05),('8902','2014-02-06','16:05:00',2.89),('8902','2014-02-06','16:10:00',2.72),('8902','2014-02-06','16:15:00',2.5),('8902','2014-02-06','16:20:00',2.21),('8902','2014-02-06','16:25:00',2.06),('8902','2014-02-06','16:30:00',1.86),('8902','2014-02-06','16:35:00',1.66),('8902','2014-02-06','16:40:00',1.45),('8902','2014-02-06','16:45:00',1.23),('8902','2014-02-06','16:50:00',1.02),('8902','2014-02-05','08:20:00',1.22),('8902','2014-02-05','08:25:00',1.39),('8902','2014-02-05','08:30:00',1.08),('8902','2014-02-05','08:35:00',1.02),('8902','2014-02-05','08:40:00',2.05),('8902','2014-02-05','08:45:00',2.23),('8902','2014-02-05','08:50:00',2.51),('8902','2014-02-05','08:55:00',2.88),('8902','2014-02-05','09:00:00',3.52),('8902','2014-02-05','09:05:00',3.95),('8902','2014-02-05','09:10:00',3.04),('8902','2014-02-05','09:15:00',3.05),('8902','2014-02-05','09:20:00',1.26),('8902','2014-02-05','09:25:00',1.21),('8902','2014-02-05','09:30:00',3.62),('8902','2014-02-05','09:35:00',4.16),('8902','2014-02-05','09:40:00',4.3),('8902','2014-02-05','09:45:00',4.4),('8902','2014-02-05','09:50:00',4.54),('8902','2014-02-05','09:55:00',4.62),('8902','2014-02-05','10:00:00',4.75),('8902','2014-02-05','10:05:00',4.88),('8902','2014-02-05','10:10:00',5.01),('8902','2014-02-05','10:15:00',5.12),('8902','2014-02-05','10:20:00',5.24),('8902','2014-02-05','10:25:00',5.34),('8902','2014-02-05','10:30:00',5.52),('8902','2014-02-05','10:35:00',5.85),('8902','2014-02-05','10:40:00',4.55),('8902','2014-02-05','10:45:00',5.21),('8902','2014-02-05','10:50:00',2.84),('8902','2014-02-05','10:55:00',3.85),('8902','2014-02-05','11:00:00',4.75),('8902','2014-02-05','11:05:00',2.48),('8902','2014-02-05','11:10:00',3.22),('8902','2014-02-05','11:15:00',2.61),('8902','2014-02-05','11:20:00',3.61),('8902','2014-02-05','11:25:00',6.86),('8902','2014-02-05','11:30:00',6.47),('8902','2014-02-05','11:35:00',6.68),('8902','2014-02-05','11:40:00',6.64),('8902','2014-02-05','11:45:00',6.69),('8902','2014-02-05','11:50:00',6.75),('8902','2014-02-05','11:55:00',6.73),('8902','2014-02-05','12:00:00',6.85),('8902','2014-02-05','12:05:00',7.03),('8902','2014-02-05','12:10:00',7.02),('8902','2014-02-05','12:15:00',6.82),('8902','2014-02-05','12:20:00',6.86),('8902','2014-02-05','12:25:00',6.86),('8902','2014-02-05','12:30:00',6.92),('8902','2014-02-05','12:35:00',6.29),('8902','2014-02-05','12:40:00',6.82),('8902','2014-02-05','12:45:00',6.4),('8902','2014-02-05','12:50:00',6.79),('8902','2014-02-05','12:55:00',6.81),('8902','2014-02-05','13:00:00',6.82),('8902','2014-02-05','13:05:00',5.15),('8902','2014-02-05','13:10:00',7.03),('8902','2014-02-05','13:15:00',7),('8902','2014-02-05','13:20:00',7.12),('8902','2014-02-05','13:25:00',6.5),('8902','2014-02-05','13:30:00',4.9),('8902','2014-02-05','13:35:00',6.46),('8902','2014-02-05','13:40:00',6.6),('8902','2014-02-05','13:45:00',6.5),('8902','2014-02-05','13:50:00',6.54),('8902','2014-02-05','13:55:00',5.65),('8902','2014-02-05','14:00:00',6.32),('8902','2014-02-05','14:05:00',5.9),('8902','2014-02-05','14:10:00',6.02),('8902','2014-02-05','14:15:00',6),('8902','2014-02-05','14:20:00',5.89),('8902','2014-02-05','14:25:00',5.86),('8902','2014-02-05','14:30:00',3.96),('8902','2014-02-05','14:35:00',2.16),('8902','2014-02-05','14:40:00',5.2),('8902','2014-02-05','14:45:00',4.11),('8902','2014-02-05','14:50:00',3.64),('8902','2014-02-05','14:55:00',5.34),('8902','2014-02-05','15:00:00',5.07),('8902','2014-02-05','15:05:00',4.86),('8902','2014-02-05','15:10:00',4.73),('8902','2014-02-05','15:15:00',4.67),('8902','2014-02-05','15:20:00',4.61),('8902','2014-02-05','15:25:00',4.19),('8902','2014-02-05','15:30:00',3.99),('8902','2014-02-05','15:35:00',3.83),('8902','2014-02-05','15:40:00',3.66),('8902','2014-02-05','15:45:00',3.51),('8902','2014-02-05','15:50:00',3.29),('8902','2014-02-05','15:55:00',3.08),('8902','2014-02-05','16:00:00',2.85),('8902','2014-02-05','16:05:00',2.71),('8902','2014-02-05','16:10:00',2.55),('8902','2014-02-05','16:15:00',2.34),('8902','2014-02-05','16:20:00',2.11),('8902','2014-02-05','16:25:00',1.93),('8902','2014-02-05','16:30:00',1.76),('8902','2014-02-05','16:35:00',1.57),('8902','2014-02-05','16:40:00',1.36),('8902','2014-02-05','16:45:00',1.15),('8902','2014-04-26','08:50:00',1.28),('8902','2014-04-26','08:55:00',1.73),('8902','2014-04-26','09:00:00',1.61),('8902','2014-04-26','09:15:00',1.25),('8902','2014-04-26','09:20:00',1.65),('8902','2014-04-26','09:25:00',1.63),('8902','2014-04-26','09:30:00',1.27),('8902','2014-04-26','09:35:00',1.02),('8902','2014-04-26','09:40:00',1.26),('8902','2014-04-26','09:45:00',1.74),('8902','2014-04-26','09:50:00',1.54),('8902','2014-04-26','09:55:00',1.46),('8902','2014-04-26','10:00:00',2.03),('8902','2014-04-26','10:05:00',1.99),('8902','2014-04-26','10:10:00',2.12),('8902','2014-04-26','10:15:00',1.73),('8902','2014-04-26','10:20:00',1.61),('8902','2014-04-26','10:25:00',1.3),('8902','2014-04-26','10:55:00',1.41),('8902','2014-04-26','11:00:00',2.21),('8902','2014-04-26','11:05:00',2.6),('8902','2014-04-26','11:10:00',3.3),('8902','2014-04-26','11:15:00',3.12),('8902','2014-04-26','11:20:00',2.4),('8902','2014-04-26','11:25:00',1.66),('8902','2014-04-26','11:30:00',1.93),('8902','2014-04-26','11:35:00',3.25),('8902','2014-04-26','11:40:00',3.58),('8902','2014-04-26','11:45:00',6.28),('8902','2014-04-26','11:50:00',5.17),('8902','2014-04-26','11:55:00',4.74),('8902','2014-04-26','12:00:00',4.94),('8902','2014-04-26','12:05:00',5.25),('8902','2014-04-26','12:10:00',6.3),('8902','2014-04-26','12:15:00',5.9),('8902','2014-04-26','12:20:00',5.03),('8902','2014-04-26','12:25:00',5.48),('8902','2014-04-26','12:30:00',5.03),('8902','2014-04-26','12:35:00',5.15),('8902','2014-04-26','12:40:00',4.59),('8902','2014-04-26','12:45:00',5.2),('8902','2014-04-26','12:50:00',4.2),('8902','2014-04-26','12:55:00',3.14),('8902','2014-04-26','13:00:00',3.84),('8902','2014-04-26','13:05:00',4.01),('8902','2014-04-26','13:10:00',3.32),('8902','2014-04-26','13:15:00',3.39),('8902','2014-04-26','13:20:00',4.74),('8902','2014-04-26','13:25:00',4.49),('8902','2014-04-26','13:30:00',4),('8902','2014-04-26','13:35:00',3.4),('8902','2014-04-26','13:40:00',3.25),('8902','2014-04-26','13:45:00',3.07),('8902','2014-04-26','13:50:00',2.97),('8902','2014-04-26','13:55:00',2.77),('8902','2014-04-26','14:00:00',3.53),('8902','2014-04-26','14:05:00',4.74),('8902','2014-04-26','14:10:00',3.34),('8902','2014-04-26','14:15:00',3.04),('8902','2014-04-26','14:20:00',3.49),('8902','2014-04-26','14:25:00',4.34),('8902','2014-04-26','14:30:00',4.63),('8902','2014-04-26','14:35:00',4.4),('8902','2014-04-26','14:40:00',4.46),('8902','2014-04-26','14:45:00',3.9),('8902','2014-04-26','14:50:00',3.67),('8902','2014-04-26','14:55:00',3.98),('8902','2014-04-26','15:00:00',4.21),('8902','2014-04-26','15:05:00',6.02),('8902','2014-04-26','15:10:00',8.42),('8902','2014-04-26','15:15:00',6.25),('8902','2014-04-26','15:20:00',3.8),('8902','2014-04-26','15:25:00',2.37),('8902','2014-04-26','15:30:00',1.83),('8902','2014-04-26','15:35:00',2),('8902','2014-04-26','15:40:00',2),('8902','2014-04-26','15:45:00',1.79),('8902','2014-04-26','15:50:00',1.72),('8902','2014-04-26','15:55:00',1.16),('8902','2014-02-04','10:10:00',1.56),('8902','2014-02-04','10:15:00',3.08),('8902','2014-02-04','10:20:00',5.57),('8902','2014-02-04','10:25:00',5.72),('8902','2014-02-04','10:30:00',1.91),('8902','2014-02-04','10:35:00',2.53),('8902','2014-02-04','10:40:00',1.88),('8902','2014-02-04','10:50:00',1.7),('8902','2014-02-04','10:55:00',1.74),('8902','2014-02-04','11:00:00',1.31),('8902','2014-02-04','11:10:00',1.73),('8902','2014-02-04','11:15:00',5.14),('8902','2014-02-04','11:20:00',6.08),('8902','2014-02-04','11:25:00',5.37),('8902','2014-02-04','11:30:00',2.59),('8902','2014-02-04','11:35:00',1.22),('8902','2014-02-04','12:55:00',2.3),('8902','2014-02-04','13:00:00',1.96),('8902','2014-02-04','13:05:00',1.91),('8902','2014-02-04','13:10:00',2.34),('8902','2014-02-04','13:15:00',2.03),('8902','2014-02-04','13:20:00',2.34),('8902','2014-02-04','13:25:00',3.56),('8902','2014-02-04','13:30:00',3.56),('8902','2014-02-04','13:35:00',4.21),('8902','2014-02-04','13:40:00',4.03),('8902','2014-02-04','13:45:00',4.19),('8902','2014-02-04','13:50:00',3.37),('8902','2014-02-04','13:55:00',2.38),('8902','2014-02-04','14:00:00',1.79),('8902','2014-02-04','14:05:00',1.23),('8902','2014-02-04','14:15:00',1.02),('8902','2014-02-04','14:30:00',2.56),('8902','2014-02-04','14:35:00',3.73),('8902','2014-02-04','14:40:00',1.53),('8902','2014-02-04','14:45:00',1.06),('8902','2014-02-04','14:50:00',1.06),('8902','2014-02-04','15:00:00',1),('8902','2014-02-04','15:05:00',1.01),('8902','2014-02-03','08:35:00',1.01),('8902','2014-02-03','08:40:00',1.05),('8902','2014-02-03','08:45:00',1.1),('8902','2014-02-03','08:50:00',1.13),('8902','2014-02-03','08:55:00',1.23),('8902','2014-02-03','09:00:00',1.32),('8902','2014-02-03','09:05:00',1.42),('8902','2014-02-03','09:10:00',1.57),('8902','2014-02-03','09:15:00',1.9),('8902','2014-02-03','09:20:00',2.43),('8902','2014-02-03','09:25:00',4.73),('8902','2014-02-03','09:30:00',4.53),('8902','2014-02-03','09:35:00',5.04),('8902','2014-02-03','09:40:00',4.55),('8902','2014-02-03','09:45:00',4.38),('8902','2014-02-03','09:50:00',3.68),('8902','2014-02-03','09:55:00',4.45),('8902','2014-02-03','10:00:00',5.02),('8902','2014-02-03','10:05:00',4.19),('8902','2014-02-03','10:10:00',3.03),('8902','2014-02-03','10:15:00',4.15),('8902','2014-02-03','10:20:00',2.4),('8902','2014-02-03','10:25:00',1.79),('8902','2014-02-03','10:30:00',1.33),('8902','2014-02-03','10:35:00',1.76),('8902','2014-02-03','10:40:00',2.64),('8902','2014-02-03','10:45:00',3.33),('8902','2014-02-03','10:50:00',4.77),('8902','2014-02-03','10:55:00',5.44),('8902','2014-02-03','11:00:00',2.77),('8902','2014-02-03','11:05:00',2.12),('8902','2014-02-03','11:10:00',2.11),('8902','2014-02-03','11:15:00',1.77),('8902','2014-02-03','11:20:00',1.61),('8902','2014-02-03','11:25:00',1.75),('8902','2014-02-03','11:30:00',1.97),('8902','2014-02-03','11:35:00',2.11),('8902','2014-02-03','11:40:00',2.52),('8902','2014-02-03','11:45:00',1.33),('8902','2014-02-03','11:50:00',2.54),('8902','2014-02-03','11:55:00',7.05),('8902','2014-02-03','12:00:00',7.74),('8902','2014-02-03','12:05:00',3.18),('8902','2014-02-03','12:10:00',3.17),('8902','2014-02-03','12:15:00',3.22),('8902','2014-02-03','12:20:00',2.88),('8902','2014-02-03','12:25:00',2.82),('8902','2014-02-03','12:30:00',2.54),('8902','2014-02-03','12:35:00',1.82),('8902','2014-02-03','12:40:00',1.64),('8902','2014-02-03','12:45:00',2.14),('8902','2014-02-03','12:50:00',2.68),('8902','2014-02-03','12:55:00',1.86),('8902','2014-02-03','13:00:00',2.24),('8902','2014-02-03','13:05:00',2.47),('8902','2014-02-03','13:10:00',1.96),('8902','2014-02-03','13:15:00',2.22),('8902','2014-02-03','13:20:00',2.61),('8902','2014-02-03','13:25:00',2.19),('8902','2014-02-03','13:30:00',1.61),('8902','2014-02-03','13:35:00',1.51),('8902','2014-02-03','13:40:00',1.48),('8902','2014-02-03','13:45:00',1.61),('8902','2014-02-03','13:50:00',1.96),('8902','2014-02-03','13:55:00',1.76),('8902','2014-02-03','14:00:00',1.32),('8902','2014-02-03','14:05:00',1.15),('8902','2014-02-03','14:10:00',1.44),('8902','2014-02-03','14:15:00',1.67),('8902','2014-02-03','14:20:00',1.66),('8902','2014-02-03','14:25:00',1.24),('8902','2014-02-03','15:10:00',1.02),('8902','2014-02-02','09:05:00',1.01),('8902','2014-02-02','09:20:00',1.06),('8902','2014-02-02','09:25:00',1.15),('8902','2014-02-02','09:30:00',1.2),('8902','2014-02-02','09:35:00',1.27),('8902','2014-02-02','09:40:00',1.42),('8902','2014-02-02','09:45:00',1.6),('8902','2014-02-02','09:50:00',1.83),('8902','2014-02-02','09:55:00',1.64),('8902','2014-02-02','10:00:00',1.49),('8902','2014-02-02','10:05:00',1.52),('8902','2014-02-02','10:10:00',1.79),('8902','2014-02-02','10:15:00',2.1),('8902','2014-02-02','10:20:00',2.03),('8902','2014-02-02','10:25:00',2.08),('8902','2014-02-02','10:30:00',2.12),('8902','2014-02-02','10:35:00',2.11),('8902','2014-02-02','10:40:00',2.2),('8902','2014-02-02','10:45:00',2.17),('8902','2014-02-02','10:50:00',2.2),('8902','2014-02-02','10:55:00',2.18),('8902','2014-02-02','11:00:00',2.03),('8902','2014-02-02','11:05:00',1.91),('8902','2014-02-02','11:10:00',1.98),('8902','2014-02-02','11:15:00',2.03),('8902','2014-02-02','11:20:00',2.13),('8902','2014-02-02','11:25:00',2.27),('8902','2014-02-02','11:30:00',2.49),('8902','2014-02-02','11:35:00',2.53),('8902','2014-02-02','11:40:00',2.47),('8902','2014-02-02','11:45:00',2.41),('8902','2014-02-02','11:50:00',2.34),('8902','2014-02-02','11:55:00',1.96),('8902','2014-02-02','12:00:00',1.67),('8902','2014-02-02','12:05:00',1.7),('8902','2014-02-02','12:10:00',1.78),('8902','2014-02-02','12:15:00',1.91),('8902','2014-02-02','12:20:00',1.77),('8902','2014-02-02','12:25:00',1.54),('8902','2014-02-02','12:30:00',1.19),('8902','2014-02-02','12:35:00',1.06),('8902','2014-02-02','12:40:00',1.19),('8902','2014-02-02','12:55:00',1.23),('8902','2014-02-02','13:00:00',1.32),('8902','2014-02-02','13:05:00',1.26),('8902','2014-02-02','13:10:00',1.35),('8902','2014-02-02','13:15:00',1.5),('8902','2014-02-02','13:20:00',1.55),('8902','2014-02-02','13:25:00',1.66),('8902','2014-02-02','13:30:00',1.73),('8902','2014-02-02','13:35:00',1.64),('8902','2014-02-02','13:40:00',1.5),('8902','2014-02-02','13:45:00',1.46),('8902','2014-02-02','13:50:00',1.54),('8902','2014-02-02','13:55:00',1.57),('8902','2014-02-02','14:00:00',1.67),('8902','2014-02-02','14:05:00',1.75),('8902','2014-02-02','14:10:00',1.78),('8902','2014-02-02','14:15:00',1.7),('8902','2014-02-02','14:20:00',1.55),('8902','2014-02-02','14:25:00',1.74),('8902','2014-02-02','14:30:00',1.86),('8902','2014-02-02','14:35:00',1.87),('8902','2014-02-02','14:40:00',1.86),('8902','2014-02-02','14:45:00',1.76),('8902','2014-02-02','14:50:00',1.59),('8902','2014-02-02','14:55:00',1.3),('8902','2014-02-02','15:20:00',1.02),('8902','2014-02-02','15:25:00',1.06),('8902','2014-02-01','11:20:00',1.05),('8902','2014-02-01','11:25:00',1.23),('8902','2014-02-01','11:30:00',1.35),('8902','2014-02-01','11:35:00',1.26),('8902','2014-02-01','11:40:00',1.31),('8902','2014-02-01','11:45:00',1.44),('8902','2014-02-01','11:50:00',1.57),('8902','2014-02-01','11:55:00',1.77),('8902','2014-02-01','12:00:00',1.95),('8902','2014-02-01','12:05:00',2.01),('8902','2014-02-01','12:10:00',1.92),('8902','2014-02-01','12:15:00',1.68),('8902','2014-02-01','12:20:00',1.45),('8902','2014-02-01','12:25:00',1.3),('8902','2014-02-01','12:30:00',1.3),('8902','2014-02-01','12:35:00',1.26),('8902','2014-02-01','12:40:00',1.15),('8902','2014-02-01','12:45:00',1),('8902','2014-02-01','13:15:00',1.17),('8902','2014-02-01','13:20:00',1.32),('8902','2014-02-01','13:25:00',1.28),('8902','2014-02-01','13:30:00',1.07),('8902','2014-02-01','13:55:00',1.05),('8902','2014-02-01','14:00:00',1.03),('8902','2014-02-01','14:05:00',1.05),('8902','2014-02-01','14:20:00',1.07),('8902','2014-02-01','14:25:00',1.08),('8902','2014-02-01','15:00:00',1.05),('8902','2014-02-01','15:05:00',1.09),('8902','2014-02-01','15:10:00',1.09),('8902','2014-02-01','15:15:00',1.02),('8902','2014-01-31','08:45:00',1.03),('8902','2014-01-31','08:50:00',1.18),('8902','2014-01-31','08:55:00',1.01),('8902','2014-01-31','09:05:00',1.01),('8902','2014-01-31','09:10:00',1.03),('8902','2014-01-31','09:15:00',1.2),('8902','2014-01-31','09:20:00',1.18),('8902','2014-01-31','09:25:00',1.22),('8902','2014-01-31','09:30:00',1.02),('8902','2014-01-31','09:55:00',1.04),('8902','2014-01-31','10:15:00',1.27),('8902','2014-01-31','10:20:00',1.46),('8902','2014-01-31','10:25:00',1.33),('8902','2014-01-31','10:30:00',1.26),('8902','2014-01-31','10:35:00',1.25),('8902','2014-01-31','10:40:00',1.33),('8902','2014-01-31','10:45:00',1.45),('8902','2014-01-31','10:50:00',1.55),('8902','2014-01-31','10:55:00',1.76),('8902','2014-01-31','11:00:00',2.39),('8902','2014-01-31','11:05:00',2.36),('8902','2014-01-31','11:10:00',1.77),('8902','2014-01-31','11:15:00',2.21),('8902','2014-01-31','11:20:00',3.73),('8902','2014-01-31','11:25:00',2.36),('8902','2014-01-31','11:30:00',4.51),('8902','2014-01-31','11:35:00',4.06),('8902','2014-01-31','11:40:00',2.68),('8902','2014-01-31','11:45:00',1.51),('8902','2014-01-31','11:50:00',1.66),('8902','2014-01-31','11:55:00',3.89),('8902','2014-01-31','12:00:00',3.43),('8902','2014-01-31','12:05:00',3.31),('8902','2014-01-31','12:10:00',4.21),('8902','2014-01-31','12:15:00',2.82),('8902','2014-01-31','12:20:00',4.67),('8902','2014-01-31','12:25:00',2.77),('8902','2014-01-31','12:30:00',1.47),('8902','2014-01-31','12:35:00',2.13),('8902','2014-01-31','12:40:00',3.94),('8902','2014-01-31','12:45:00',4.85),('8902','2014-01-31','12:50:00',4.15),('8902','2014-01-31','12:55:00',2.46),('8902','2014-01-31','13:00:00',2.53),('8902','2014-01-31','13:05:00',2.11),('8902','2014-01-31','13:10:00',1.51),('8902','2014-01-31','13:15:00',1.28),('8902','2014-01-31','13:20:00',1.18),('8902','2014-01-31','13:25:00',1.26),('8902','2014-01-31','13:30:00',1.34),('8902','2014-01-31','13:35:00',1.26),('8902','2014-01-31','13:40:00',1.19),('8902','2014-01-31','13:45:00',1.22),('8902','2014-01-31','13:50:00',1.2),('8902','2014-01-30','10:15:00',1.06),('8902','2014-01-30','10:20:00',1.2),('8902','2014-01-30','10:25:00',1.25),('8902','2014-01-30','10:30:00',1.56),('8902','2014-01-30','10:35:00',1.28),('8902','2014-01-30','11:35:00',1.16),('8902','2014-01-30','11:40:00',1.31),('8902','2014-01-30','11:45:00',1.38),('8902','2014-01-30','11:50:00',1.45),('8902','2014-01-30','11:55:00',1.28),('8902','2014-01-30','12:00:00',1.06),('8902','2014-01-30','12:05:00',1.04),('8902','2014-01-30','12:10:00',1.19),('8902','2014-01-30','12:15:00',1.33),('8902','2014-01-30','12:20:00',1.28),('8902','2014-01-30','12:25:00',1.36),('8902','2014-01-30','12:30:00',1.39),('8902','2014-01-30','12:35:00',1.54),('8902','2014-01-30','12:40:00',1.23),('8902','2014-01-30','13:40:00',1.04),('8902','2014-01-30','13:45:00',1.41),('8902','2014-01-30','13:50:00',1.73),('8902','2014-01-30','13:55:00',1.4),('8902','2014-01-30','14:00:00',1),('8902','2014-01-30','14:05:00',1.04),('8902','2014-01-30','14:10:00',1.14),('8902','2014-01-30','14:15:00',1.3),('8902','2014-01-30','14:20:00',1.25),('8902','2014-01-30','14:40:00',1.07),('8902','2014-01-30','14:45:00',1.47),('8902','2014-01-29','08:55:00',1.06),('8902','2014-01-29','09:00:00',1.16),('8902','2014-01-29','09:05:00',1.24),('8902','2014-01-29','09:10:00',1.33),('8902','2014-01-29','09:15:00',1.5),('8902','2014-01-29','09:20:00',1.65),('8902','2014-01-29','09:25:00',1.72),('8902','2014-01-29','09:30:00',1.62),('8902','2014-01-29','09:35:00',1.62),('8902','2014-01-29','09:40:00',2.08),('8902','2014-01-29','09:45:00',1.72),('8902','2014-01-29','09:50:00',2.59),('8902','2014-01-29','09:55:00',4.12),('8902','2014-01-29','10:00:00',3.89),('8902','2014-01-29','10:05:00',3.14),('8902','2014-01-29','10:10:00',3.77),('8902','2014-01-29','10:15:00',4.62),('8902','2014-01-29','10:20:00',4.09),('8902','2014-01-29','10:25:00',4.65),('8902','2014-01-29','10:30:00',4.99),('8902','2014-01-29','10:35:00',5.02),('8902','2014-01-29','10:40:00',5),('8902','2014-01-29','10:45:00',4.59),('8902','2014-01-29','10:50:00',5.58),('8902','2014-01-29','10:55:00',6.55),('8902','2014-01-29','11:00:00',6.34),('8902','2014-01-29','11:05:00',6.04),('8902','2014-01-29','11:10:00',5.97),('8902','2014-01-29','11:15:00',5.81),('8902','2014-01-29','11:20:00',5.38),('8902','2014-01-29','11:25:00',5.8),('8902','2014-01-29','11:30:00',4.98),('8902','2014-01-29','11:35:00',4.72),('8902','2014-01-29','11:40:00',3.03),('8902','2014-01-29','11:45:00',5.43),('8902','2014-01-29','11:50:00',3.3),('8902','2014-01-29','11:55:00',6.77),('8902','2014-01-29','12:00:00',3.54),('8902','2014-01-29','12:05:00',5.41),('8902','2014-01-29','12:10:00',3.64),('8902','2014-01-29','12:15:00',3.25),('8902','2014-01-29','12:20:00',5.88),('8902','2014-01-29','12:25:00',5.61),('8902','2014-01-29','12:30:00',4.23),('8902','2014-01-29','12:35:00',5.05),('8902','2014-01-29','12:40:00',4.53),('8902','2014-01-29','12:45:00',6.27),('8902','2014-01-29','12:50:00',5.22),('8902','2014-01-29','12:55:00',5.5),('8902','2014-01-29','13:00:00',2.56),('8902','2014-01-29','13:05:00',5.61),('8902','2014-01-29','13:10:00',3.99),('8902','2014-01-29','13:15:00',5.65),('8902','2014-01-29','13:20:00',4.55),('8902','2014-01-29','13:25:00',6.3),('8902','2014-01-29','13:30:00',5.32),('8902','2014-01-29','13:35:00',4.72),('8902','2014-01-29','13:40:00',5.44),('8902','2014-01-29','13:45:00',6.22),('8902','2014-01-29','13:50:00',5.71),('8902','2014-01-29','13:55:00',5.4),('8902','2014-01-29','14:00:00',5.28),('8902','2014-01-29','14:05:00',5.08),('8902','2014-01-29','14:10:00',4.98),('8902','2014-01-29','14:15:00',4.28),('8902','2014-01-29','14:20:00',3.8),('8902','2014-01-29','14:25:00',4.07),('8902','2014-01-29','14:30:00',4.37),('8902','2014-01-29','14:35:00',4.25),('8902','2014-01-29','14:40:00',4.81),('8902','2014-01-29','14:45:00',4.59),('8902','2014-01-29','14:50:00',4.77),('8902','2014-01-29','14:55:00',4.61),('8902','2014-01-29','15:00:00',4.52),('8902','2014-01-29','15:05:00',4.43),('8902','2014-01-29','15:10:00',4.23),('8902','2014-01-29','15:15:00',3.88),('8902','2014-01-29','15:20:00',4.05),('8902','2014-01-29','15:25:00',4.04),('8902','2014-01-29','15:30:00',3.69),('8902','2014-01-29','15:35:00',3.64),('8902','2014-01-29','15:40:00',3.29),('8902','2014-01-29','15:45:00',1.96),('8902','2014-01-29','15:50:00',1.51),('8902','2014-01-28','09:05:00',1.1),('8902','2014-01-28','09:10:00',1.38),('8902','2014-01-28','09:15:00',1.83),('8902','2014-01-28','09:20:00',2.92),('8902','2014-01-28','09:25:00',1.9),('8902','2014-01-28','09:30:00',2.55),('8902','2014-01-28','09:35:00',3.67),('8902','2014-01-28','09:40:00',3.49),('8902','2014-01-28','09:45:00',3.85),('8902','2014-01-28','09:50:00',3.35),('8902','2014-01-28','09:55:00',3.44),('8902','2014-01-28','10:00:00',2.76),('8902','2014-01-28','10:05:00',2.66),('8902','2014-01-28','10:10:00',3.08),('8902','2014-01-28','10:15:00',3.33),('8902','2014-01-28','10:20:00',2.48),('8902','2014-01-28','10:25:00',5.08),('8902','2014-01-28','10:30:00',5.36),('8902','2014-01-28','10:35:00',4.35),('8902','2014-01-28','10:40:00',3.98),('8902','2014-01-28','10:45:00',3.88),('8902','2014-01-28','10:50:00',3.66),('8902','2014-01-28','10:55:00',3.45),('8902','2014-01-28','11:00:00',3.54),('8902','2014-01-28','11:05:00',4.04),('8902','2014-01-28','11:10:00',3.65),('8902','2014-01-28','11:15:00',3.69),('8902','2014-01-28','11:20:00',3.86),('8902','2014-01-28','11:25:00',3.64),('8902','2014-01-28','11:30:00',5.31),('8902','2014-01-28','11:35:00',5.27),('8902','2014-01-28','11:40:00',4.97),('8902','2014-01-28','11:45:00',2.38),('8902','2014-01-28','11:50:00',2.08),('8902','2014-01-28','11:55:00',1.01),('8902','2014-01-28','12:45:00',1.8),('8902','2014-01-28','12:50:00',5.44),('8902','2014-01-28','12:55:00',6.85),('8902','2014-01-28','13:00:00',5.91),('8902','2014-01-28','13:05:00',1.99),('8902','2014-01-28','13:25:00',1.02),('8902','2014-01-28','13:30:00',1.72),('8902','2014-01-28','13:35:00',3.52),('8902','2014-01-28','13:40:00',4.69),('8902','2014-01-28','13:45:00',1.98),('8902','2014-01-28','13:50:00',4.16),('8902','2014-01-28','13:55:00',4.83),('8902','2014-01-28','14:00:00',1.92),('8902','2014-01-28','14:05:00',1.4),('8902','2014-01-28','14:10:00',1.12),('8902','2014-01-28','14:20:00',1),('8902','2014-01-28','14:25:00',1.03),('8902','2014-01-28','14:30:00',1.67),('8902','2014-01-28','14:35:00',1.53),('8902','2014-01-28','14:40:00',1.87),('8902','2014-01-28','14:45:00',1.43),('8902','2014-01-28','15:05:00',1.4),('8902','2014-01-28','15:10:00',2.43),('8902','2014-01-28','15:15:00',3.22),('8902','2014-01-28','15:20:00',2.31),('8902','2014-01-28','15:25:00',1.11),('8902','2014-01-27','09:00:00',1.24),('8902','2014-01-27','09:05:00',2.01),('8902','2014-01-27','09:10:00',2.46),('8902','2014-01-27','09:15:00',2.62),('8902','2014-01-27','09:20:00',2.48),('8902','2014-01-27','09:25:00',2.79),('8902','2014-01-27','09:30:00',2.7),('8902','2014-01-27','09:35:00',3.13),('8902','2014-01-27','09:40:00',2.75),('8902','2014-01-27','09:45:00',3.06),('8902','2014-01-27','09:50:00',3.8),('8902','2014-01-27','09:55:00',4.04),('8902','2014-01-27','10:00:00',4.42),('8902','2014-01-27','10:05:00',4.41),('8902','2014-01-27','10:10:00',4.39),('8902','2014-01-27','10:15:00',4.46),('8902','2014-01-27','10:20:00',4.62),('8902','2014-01-27','10:25:00',4.97),('8902','2014-01-27','10:30:00',5.02),('8902','2014-01-27','10:35:00',5.21),('8902','2014-01-27','10:40:00',5.34),('8902','2014-01-27','10:45:00',4.62),('8902','2014-01-27','10:50:00',5.4),('8902','2014-01-27','10:55:00',5.26),('8902','2014-01-27','11:00:00',4.99),('8902','2014-01-27','11:05:00',5.99),('8902','2014-01-27','11:10:00',2.78),('8902','2014-01-27','11:15:00',4.15),('8902','2014-01-27','11:20:00',1.94),('8902','2014-01-27','11:25:00',1.89),('8902','2014-01-27','11:30:00',4.5),('8902','2014-01-27','11:35:00',4.4),('8902','2014-01-27','11:40:00',6.58),('8902','2014-01-27','11:45:00',5.25),('8902','2014-01-27','11:50:00',2.31),('8902','2014-01-27','11:55:00',1.14),('8902','2014-01-27','12:00:00',2.94),('8902','2014-01-27','12:05:00',6.64),('8902','2014-01-27','12:10:00',4.73),('8902','2014-01-27','12:15:00',5.86),('8902','2014-01-27','12:20:00',4.15),('8902','2014-01-27','12:25:00',2.4),('8902','2014-01-27','12:30:00',2.27),('8902','2014-01-27','12:35:00',2.83),('8902','2014-01-27','12:40:00',3.74),('8902','2014-01-27','12:45:00',3.39),('8902','2014-01-27','12:50:00',6.34),('8902','2014-01-27','12:55:00',5.94),('8902','2014-01-27','13:00:00',6.19),('8902','2014-01-27','13:05:00',7.43),('8902','2014-01-27','13:10:00',5.12),('8902','2014-01-27','13:15:00',5.34),('8902','2014-01-27','13:20:00',5.56),('8902','2014-01-27','13:25:00',6.05),('8902','2014-01-27','13:30:00',6.1),('8902','2014-01-27','13:35:00',6.69),('8902','2014-01-27','13:40:00',6.46),('8902','2014-01-27','13:45:00',6.27),('8902','2014-01-27','13:50:00',6.12),('8902','2014-01-27','13:55:00',6.03),('8902','2014-01-27','14:00:00',5.97),('8902','2014-01-27','14:05:00',5.82),('8902','2014-01-27','14:10:00',5.74),('8902','2014-01-27','14:15:00',5.67),('8902','2014-01-27','14:20:00',5.54),('8902','2014-01-27','14:25:00',5.64),('8902','2014-01-27','14:30:00',5.41),('8902','2014-01-27','14:35:00',4.98),('8902','2014-01-27','14:40:00',4.79),('8902','2014-01-27','14:45:00',5.1),('8902','2014-01-27','14:50:00',4.08),('8902','2014-01-27','14:55:00',4.76),('8902','2014-01-27','15:00:00',4.64),('8902','2014-01-27','15:05:00',4.5),('8902','2014-01-27','15:10:00',4.33),('8902','2014-01-27','15:15:00',4.17),('8902','2014-01-27','15:20:00',3.97),('8902','2014-01-27','15:25:00',3.79),('8902','2014-01-27','15:30:00',3.62),('8902','2014-01-27','15:35:00',3.43),('8902','2014-01-27','15:40:00',3.25),('8902','2014-01-27','15:45:00',3.09),('8902','2014-01-27','15:50:00',2.88),('8902','2014-01-27','15:55:00',2.7),('8902','2014-01-27','16:00:00',2.51),('8902','2014-01-27','16:05:00',2.32),('8902','2014-01-27','16:10:00',2.03),('8902','2014-01-27','16:15:00',1.9),('8902','2014-01-27','16:20:00',1.71),('8902','2014-01-27','16:25:00',1.51),('8902','2014-01-26','09:40:00',1.23),('8902','2014-01-26','09:45:00',1.31),('8902','2014-01-26','09:50:00',1.43),('8902','2014-01-26','09:55:00',1.47),('8902','2014-01-26','10:00:00',1.49),('8902','2014-01-26','10:05:00',1.53),('8902','2014-01-26','10:10:00',1.45),('8902','2014-01-26','10:15:00',1.5),('8902','2014-01-26','10:20:00',1.47),('8902','2014-01-26','10:25:00',1.75),('8902','2014-01-26','10:30:00',1.74),('8902','2014-01-26','10:35:00',1.72),('8902','2014-01-26','10:40:00',1.54),('8902','2014-01-26','10:45:00',1.7),('8902','2014-01-26','10:50:00',1.71),('8902','2014-01-26','10:55:00',1.56),('8902','2014-01-26','11:00:00',1.7),('8902','2014-01-26','11:05:00',1.87),('8902','2014-01-26','11:10:00',1.6),('8902','2014-01-26','11:15:00',1.58),('8902','2014-01-26','11:20:00',1.99),('8902','2014-01-26','11:25:00',2),('8902','2014-01-26','11:30:00',1.72),('8902','2014-01-26','11:35:00',1.4),('8902','2014-01-26','11:40:00',1.51),('8902','2014-01-26','11:45:00',1.1),('8902','2014-01-26','11:50:00',1.09),('8902','2014-01-26','11:55:00',1.04),('8902','2014-01-26','12:00:00',1.2),('8902','2014-01-26','12:05:00',1.41),('8902','2014-01-26','12:10:00',1.32),('8902','2014-01-26','12:15:00',1.11),('8902','2014-01-26','12:35:00',1),('8902','2014-01-26','12:45:00',1.2),('8902','2014-01-26','12:50:00',1.6),('8902','2014-01-26','12:55:00',1.59),('8902','2014-01-26','13:00:00',1.43),('8902','2014-01-26','13:05:00',1.43),('8902','2014-01-26','13:10:00',1.46),('8902','2014-01-26','13:15:00',1.26),('8902','2014-01-26','13:20:00',1.18),('8902','2014-01-26','13:25:00',1.26),('8902','2014-01-26','13:30:00',1.47),('8902','2014-01-26','13:35:00',1.23),('8975','2014-05-04','06:35:00',1.09),('8975','2014-05-04','06:40:00',1.41),('8975','2014-05-04','06:45:00',1.59),('8975','2014-05-04','07:15:00',2.58),('8975','2014-05-04','07:20:00',2.54),('8975','2014-05-04','07:25:00',1.47),('8975','2014-05-04','07:30:00',2.48),('8975','2014-05-04','07:35:00',2.15),('8975','2014-05-04','07:40:00',3.21),('8975','2014-05-04','07:45:00',3.29),('8975','2014-05-04','07:50:00',3.38),('8975','2014-05-04','07:55:00',3.46),('8975','2014-05-04','08:00:00',3.6),('8975','2014-05-04','08:05:00',3.71),('8975','2014-05-04','08:10:00',3.83),('8975','2014-05-04','08:15:00',4.02),('8975','2014-05-04','08:20:00',4.13),('8975','2014-05-04','08:25:00',4.24),('8975','2014-05-04','08:30:00',4.38),('8975','2014-05-04','08:35:00',4.48),('8975','2014-05-04','08:40:00',4.57),('8975','2014-05-04','08:45:00',4.67),('8975','2014-05-04','08:50:00',4.74),('8975','2014-05-04','08:55:00',4.8),('8975','2014-05-04','09:00:00',4.9),('8975','2014-05-04','09:05:00',5.04),('8975','2014-05-04','09:10:00',5.16),('8975','2014-05-04','09:15:00',5.25),('8975','2014-05-04','09:20:00',5.36),('8975','2014-05-04','09:25:00',5.45),('8975','2014-05-04','09:30:00',5.53),('8975','2014-05-04','09:35:00',5.63),('8975','2014-05-04','09:40:00',5.73),('8975','2014-05-04','09:45:00',5.84),('8975','2014-05-04','09:50:00',5.93),('8975','2014-05-04','09:55:00',5.95),('8975','2014-05-04','10:00:00',6.07),('8975','2014-05-04','10:05:00',6.14),('8975','2014-05-04','10:10:00',6.18),('8975','2014-05-04','10:15:00',6.27),('8975','2014-05-04','10:20:00',6.27),('8975','2014-05-04','10:25:00',6.45),('8975','2014-05-04','10:30:00',6.4),('8975','2014-05-04','10:35:00',6.47),('8975','2014-05-04','10:40:00',6.55),('8975','2014-05-04','10:45:00',6.53),('8975','2014-05-04','10:50:00',6.59),('8975','2014-05-04','10:55:00',6.62),('8975','2014-05-04','11:00:00',6.73),('8975','2014-05-04','11:05:00',6.73),('8975','2014-05-04','11:10:00',6.77),('8975','2014-05-04','11:15:00',6.84),('8975','2014-05-04','11:20:00',6.86),('8975','2014-05-04','11:25:00',6.9),('8975','2014-05-04','11:30:00',6.89),('8975','2014-05-04','11:35:00',6.89),('8975','2014-05-04','11:40:00',6.95),('8975','2014-05-04','11:45:00',7.02),('8975','2014-05-04','11:50:00',7.14),('8975','2014-05-04','11:55:00',7.25),('8975','2014-05-04','12:00:00',7.11),('8975','2014-05-04','12:05:00',5.91),('8975','2014-05-04','12:10:00',2.88),('8975','2014-05-04','12:15:00',5.22),('8975','2014-05-04','12:20:00',4.86),('8975','2014-05-04','12:25:00',2.41),('8975','2014-05-04','12:30:00',4.96),('8975','2014-05-04','12:35:00',4.21),('8975','2014-05-04','12:40:00',6.2),('8975','2014-05-04','12:45:00',5.81),('8975','2014-05-04','12:50:00',6.47),('8975','2014-05-04','12:55:00',4.91),('8975','2014-05-04','13:00:00',2.29),('8975','2014-05-04','13:05:00',2.45),('8975','2014-05-04','13:10:00',1.78),('8975','2014-05-04','13:15:00',2.04),('8975','2014-05-04','13:20:00',7.53),('8975','2014-05-04','13:25:00',6.92),('8975','2014-05-04','13:30:00',6.79),('8975','2014-05-04','13:35:00',6.79),('8975','2014-05-04','13:40:00',5.29),('8975','2014-05-04','13:45:00',4.82),('8975','2014-05-04','13:50:00',1.15),('8975','2014-05-04','13:55:00',2.34),('8975','2014-05-04','14:00:00',7.12),('8975','2014-05-04','14:05:00',5.6),('8975','2014-05-04','14:10:00',4.91),('8975','2014-05-04','14:15:00',4.47),('8975','2014-05-04','14:20:00',3.51),('8975','2014-05-04','14:25:00',5.32),('8975','2014-05-04','14:30:00',4.3),('8975','2014-05-04','14:35:00',3.19),('8975','2014-05-04','14:40:00',2.43),('8975','2014-05-04','14:45:00',2.29),('8975','2014-05-04','14:50:00',2.06),('8975','2014-05-04','14:55:00',2.27),('8975','2014-05-04','15:00:00',2.37),('8975','2014-05-04','15:05:00',2.45),('8975','2014-05-04','15:10:00',4.82),('8975','2014-05-04','15:15:00',4.67),('8975','2014-05-04','15:20:00',3.8),('8975','2014-05-04','15:25:00',3.6),('8975','2014-05-04','15:30:00',1.9),('8975','2014-05-04','15:35:00',2.73),('8975','2014-05-04','15:40:00',1.63),('8975','2014-05-04','15:45:00',4.08),('8975','2014-05-04','15:50:00',5.33),('8975','2014-05-04','15:55:00',3.56),('8975','2014-05-04','16:00:00',1.92),('8975','2014-05-04','16:05:00',3.07),('8975','2014-05-04','16:10:00',4.63),('8975','2014-05-04','16:15:00',3.14),('8975','2014-05-04','16:20:00',3.77),('8975','2014-05-04','16:25:00',3.79),('8975','2014-05-04','16:30:00',4.57),('8975','2014-05-04','16:35:00',4.21),('8975','2014-05-04','16:40:00',3.79),('8975','2014-05-04','16:45:00',3.55),('8975','2014-05-04','16:50:00',3.27),('8975','2014-05-04','16:55:00',3.06),('8975','2014-05-04','17:00:00',2.93),('8975','2014-05-04','17:05:00',2.82),('8975','2014-05-04','17:10:00',2.65),('8975','2014-05-04','17:15:00',2.7),('8975','2014-05-04','17:20:00',2.5),('8975','2014-05-04','17:25:00',2.33),('8975','2014-05-04','17:30:00',2.18),('8975','2014-05-04','17:35:00',2.03),('8975','2014-05-04','17:40:00',1.91),('8975','2014-05-04','17:45:00',1.82),('8975','2014-05-04','17:50:00',1.74),('8975','2014-05-04','17:55:00',1.65),('8975','2014-05-04','18:00:00',1.57),('8975','2014-05-04','18:05:00',1.5),('8975','2014-05-04','18:10:00',1.45),('8975','2014-05-04','18:15:00',1.38),('8975','2014-05-04','18:20:00',1.34),('8975','2014-05-04','18:25:00',1.28),('8975','2014-05-04','18:30:00',1.22),('8975','2014-05-04','18:35:00',1.18),('8975','2014-05-04','18:40:00',1.1),('8975','2014-05-04','18:45:00',1.03),('8975','2014-04-25','08:05:00',1.02),('8975','2014-04-25','08:10:00',1.09),('8975','2014-04-25','08:15:00',1.05),('8975','2014-04-25','08:20:00',1.02),('8975','2014-04-25','08:25:00',1.06),('8975','2014-04-25','08:30:00',1.13),('8975','2014-04-25','08:35:00',1.18),('8975','2014-04-25','08:40:00',1.34),('8975','2014-04-25','08:45:00',1.39),('8975','2014-04-25','08:50:00',1.37),('8975','2014-04-25','08:55:00',1.37),('8975','2014-04-25','09:00:00',1.35),('8975','2014-04-25','09:05:00',1.36),('8975','2014-04-25','09:10:00',1.33),('8975','2014-04-25','09:15:00',1.19),('8975','2014-04-25','09:20:00',1.25),('8975','2014-04-25','09:25:00',1.27),('8975','2014-04-25','09:30:00',1.29),('8975','2014-04-25','09:35:00',1.36),('8975','2014-04-25','09:40:00',1.5),('8975','2014-04-25','09:45:00',1.36),('8975','2014-04-25','09:50:00',1.38),('8975','2014-04-25','09:55:00',1.88),('8975','2014-04-25','10:00:00',2.14),('8975','2014-04-25','10:05:00',2.05),('8975','2014-04-25','10:10:00',2.01),('8975','2014-04-25','10:15:00',2.05),('8975','2014-04-25','10:20:00',2.25),('8975','2014-04-25','10:25:00',2.58),('8975','2014-04-25','10:30:00',2.89),('8975','2014-04-25','10:35:00',3.87),('8975','2014-04-25','10:40:00',3.4),('8975','2014-04-25','10:45:00',4.9),('8975','2014-04-25','10:50:00',3.56),('8975','2014-04-25','10:55:00',5.4),('8975','2014-04-25','11:00:00',6.31),('8975','2014-04-25','11:05:00',5.44),('8975','2014-04-25','11:10:00',5.9),('8975','2014-04-25','11:15:00',5.5),('8975','2014-04-25','11:20:00',5.17),('8975','2014-04-25','11:25:00',4.9),('8975','2014-04-25','11:30:00',5.1),('8975','2014-04-25','11:35:00',5.16),('8975','2014-04-25','11:40:00',5.39),('8975','2014-04-25','11:45:00',5.14),('8975','2014-04-25','11:50:00',5.3),('8975','2014-04-25','11:55:00',5.26),('8975','2014-04-25','12:00:00',6.03),('8975','2014-04-25','12:05:00',5.4),('8975','2014-04-25','12:10:00',6.32),('8975','2014-04-25','12:15:00',4.48),('8975','2014-04-25','12:20:00',2.52),('8975','2014-04-25','12:25:00',4.82),('8975','2014-04-25','12:30:00',4.53),('8975','2014-04-25','12:35:00',4.79),('8975','2014-04-25','12:40:00',5.68),('8975','2014-04-25','12:45:00',6.55),('8975','2014-04-25','12:50:00',4.35),('8975','2014-04-25','12:55:00',2.78),('8975','2014-04-25','13:00:00',2.18),('8975','2014-04-25','13:05:00',5.5),('8975','2014-04-25','13:10:00',5.05),('8975','2014-04-25','13:15:00',4.39),('8975','2014-04-25','13:20:00',6.49),('8975','2014-04-25','13:25:00',6.86),('8975','2014-04-25','13:30:00',5.84),('8975','2014-04-25','13:35:00',2.15),('8975','2014-04-25','13:40:00',1.97),('8975','2014-04-25','13:45:00',4.81),('8975','2014-04-25','13:50:00',5.03),('8975','2014-04-25','13:55:00',5.44),('8975','2014-04-25','14:00:00',6.48),('8975','2014-04-25','14:05:00',3.87),('8975','2014-04-25','14:10:00',1.78),('8975','2014-04-25','14:15:00',3.56),('8975','2014-04-25','14:20:00',3.45),('8975','2014-04-25','14:35:00',1.44),('8975','2014-04-25','14:40:00',2.85),('8975','2014-04-25','14:45:00',3.03),('8975','2014-04-25','15:20:00',1.2),('8975','2014-04-25','17:40:00',1.01),('8975','2014-04-25','17:45:00',1.36),('8975','2014-04-25','17:50:00',1.43),('8975','2014-04-25','17:55:00',1.45),('8975','2014-04-25','18:00:00',1.01),('8975','2014-04-25','18:35:00',1.05),('8975','2014-04-25','18:40:00',1.15),('8975','2014-04-25','18:45:00',1.41),('8975','2014-04-25','18:50:00',1.2),('8975','2014-04-25','18:55:00',1.04),('8975','2014-01-25','08:10:00',1.18),('8975','2014-01-25','09:00:00',1.07),('8975','2014-01-25','09:05:00',1.93),('8975','2014-01-25','09:30:00',1.73),('8975','2014-01-25','09:35:00',1.68),('8975','2014-01-25','09:45:00',1.26),('8975','2014-01-25','09:50:00',1.72),('8975','2014-01-25','09:55:00',1.21),('8975','2014-01-25','10:10:00',1.89),('8975','2014-01-25','10:15:00',1.99),('8975','2014-01-25','10:20:00',1.39),('8975','2014-01-25','10:25:00',1.22),('8975','2014-01-25','10:30:00',1.13),('8975','2014-01-25','10:55:00',1.07),('8975','2014-01-25','11:05:00',1.02),('8975','2014-01-25','11:25:00',1.22),('8975','2014-01-25','11:30:00',1.06),('8975','2014-01-25','12:15:00',1.36),('8975','2014-01-25','12:20:00',1.41),('8975','2014-01-25','12:25:00',1.53),('8975','2014-01-25','12:30:00',2.28),('8975','2014-01-25','12:35:00',1.86);
INSERT INTO `solarlogmod` VALUES ('8975','2014-01-25','12:40:00',1.43),('8975','2014-01-25','12:45:00',1.28),('8975','2014-01-25','12:50:00',1.14),('8975','2014-01-25','12:55:00',1.07),('8975','2014-01-25','13:00:00',1.13),('8975','2014-01-25','13:05:00',1.29),('8975','2014-01-25','13:10:00',1.45),('8975','2014-01-25','13:15:00',1.47),('8975','2014-01-25','13:20:00',1.58),('8975','2014-01-25','13:25:00',1.36),('8975','2014-01-25','13:30:00',1.11),('8975','2014-01-25','15:45:00',1.07),('8975','2014-01-24','09:00:00',1.11),('8975','2014-01-24','09:05:00',1.9),('8975','2014-01-24','09:10:00',2.13),('8975','2014-01-24','09:15:00',1.32),('8975','2014-01-24','09:20:00',1.38),('8975','2014-01-24','09:25:00',1.46),('8975','2014-01-24','09:45:00',1.1),('8975','2014-01-24','09:50:00',1.64),('8975','2014-01-24','09:55:00',2.18),('8975','2014-01-24','10:00:00',2.53),('8975','2014-01-24','10:05:00',2.84),('8975','2014-01-24','10:10:00',2.73),('8975','2014-01-24','10:15:00',2.99),('8975','2014-01-24','10:20:00',2.88),('8975','2014-01-24','10:25:00',2.13),('8975','2014-01-24','10:30:00',2),('8975','2014-01-24','10:35:00',1.7),('8975','2014-01-24','10:40:00',2.06),('8975','2014-01-24','10:45:00',1.68),('8975','2014-01-24','10:50:00',1.68),('8975','2014-01-24','10:55:00',1.78),('8975','2014-01-24','11:00:00',1.58),('8975','2014-01-24','11:05:00',1.39),('8975','2014-01-24','11:10:00',1.41),('8975','2014-01-24','11:15:00',2.15),('8975','2014-01-24','11:20:00',1.9),('8975','2014-01-24','11:25:00',1.19),('8975','2014-01-24','11:30:00',2.61),('8975','2014-01-24','11:35:00',3.51),('8975','2014-01-24','11:40:00',2.69),('8975','2014-01-24','11:45:00',1.54),('8975','2014-01-24','11:50:00',2.09),('8975','2014-01-24','11:55:00',1.94),('8975','2014-01-24','12:00:00',1.84),('8975','2014-01-24','12:05:00',1.82),('8975','2014-01-24','12:10:00',1.98),('8975','2014-01-24','12:15:00',1.97),('8975','2014-01-24','12:20:00',2.05),('8975','2014-01-24','12:25:00',2.17),('8975','2014-01-24','12:30:00',2.25),('8975','2014-01-24','12:35:00',2.13),('8975','2014-01-24','12:40:00',2.18),('8975','2014-01-24','12:45:00',2.34),('8975','2014-01-24','12:50:00',2.41),('8975','2014-01-24','12:55:00',2.39),('8975','2014-01-24','13:00:00',2.29),('8975','2014-01-24','13:05:00',2.25),('8975','2014-01-24','13:10:00',2.27),('8975','2014-01-24','13:15:00',2.14),('8975','2014-01-24','13:20:00',1.35),('8975','2014-01-24','13:25:00',1.24),('8975','2014-01-24','13:30:00',1.33),('8975','2014-01-24','13:35:00',1.58),('8975','2014-01-24','13:40:00',1.06),('8975','2014-01-24','13:45:00',1.18),('8975','2014-01-24','13:50:00',1.36),('8975','2014-01-24','14:05:00',1.07),('8975','2014-01-24','14:10:00',1.72),('8975','2014-01-24','14:20:00',1.13),('8975','2014-01-24','14:25:00',1.58),('8975','2014-01-24','14:30:00',1.71),('8975','2014-01-24','14:35:00',1.88),('8975','2014-01-24','14:40:00',1.89),('8975','2014-01-24','14:45:00',1.93),('8975','2014-01-24','14:50:00',1.46),('8975','2014-01-24','14:55:00',1.59),('8975','2014-01-24','15:00:00',1.47),('8975','2014-01-24','15:05:00',1.37),('8975','2014-01-24','15:10:00',1.32),('8975','2014-01-24','15:15:00',1.26),('8975','2014-01-24','15:20:00',1.21),('8975','2014-01-24','15:25:00',1.17),('8975','2014-01-24','15:30:00',1.13),('8975','2014-01-24','15:35:00',1.09),('8975','2014-01-24','15:40:00',1.05),('8975','2014-01-24','15:45:00',1.01),('8975','2014-01-23','10:10:00',1.13),('8975','2014-01-23','10:15:00',1.13),('8975','2014-01-23','10:25:00',1.59),('8975','2014-01-23','10:30:00',1.21),('8975','2014-01-23','10:35:00',1.38),('8975','2014-01-23','10:40:00',2.06),('8975','2014-01-23','10:45:00',1.75),('8975','2014-01-23','10:50:00',1.4),('8975','2014-01-23','10:55:00',1.39),('8975','2014-01-23','11:00:00',1.12),('8975','2014-01-23','11:25:00',1.23),('8975','2014-01-23','11:30:00',1.46),('8975','2014-01-23','11:35:00',1.37),('8975','2014-01-23','11:45:00',1.92),('8975','2014-01-23','11:50:00',1.33),('8975','2014-01-23','11:55:00',2.86),('8975','2014-01-23','12:00:00',3.2),('8975','2014-01-23','12:05:00',2.15),('8975','2014-01-23','12:20:00',1.89),('8975','2014-01-23','12:25:00',1.8),('8975','2014-01-23','12:30:00',1.07),('8975','2014-01-23','12:35:00',2.14),('8975','2014-01-23','12:40:00',1.67),('8975','2014-01-23','12:45:00',1.37),('8975','2014-01-23','12:50:00',1.19),('8975','2014-01-23','12:55:00',1.29),('8975','2014-01-23','13:00:00',1.81),('8975','2014-01-23','13:05:00',1.81),('8975','2014-01-23','13:10:00',1.8),('8975','2014-01-23','13:15:00',2.12),('8975','2014-01-23','13:20:00',1.92),('8975','2014-01-23','13:25:00',1.32),('8975','2014-01-23','13:30:00',1.69),('8975','2014-01-23','13:35:00',1.69),('8975','2014-01-23','13:40:00',1.74),('8975','2014-01-23','13:45:00',1.88),('8975','2014-01-23','13:50:00',1.38),('8975','2014-01-23','13:55:00',1.22),('8975','2014-01-23','14:10:00',2.02),('8975','2014-01-23','14:15:00',1.31),('8975','2014-01-23','14:20:00',1.49),('8975','2014-01-23','14:25:00',1.41),('8975','2014-01-23','14:30:00',1.46),('8975','2014-01-23','14:35:00',1.63),('8975','2014-01-22','10:55:00',1.04),('8975','2014-01-22','11:00:00',1.15),('8975','2014-01-22','11:05:00',1.11),('8975','2014-01-22','11:10:00',1.15),('8975','2014-01-22','11:15:00',1.07),('8975','2014-01-22','12:20:00',1.02),('8975','2014-01-22','12:25:00',1.14),('8975','2014-01-22','12:30:00',1.05),('8975','2014-01-21','10:55:00',1.06),('8975','2014-01-21','11:00:00',1.24),('8975','2014-01-21','11:05:00',1.25),('8975','2014-01-21','11:10:00',1.15),('8975','2014-01-21','11:15:00',1.09),('8975','2014-01-21','12:55:00',1.02),('8975','2014-01-21','13:05:00',1.24),('8975','2014-01-21','13:10:00',2.41),('8975','2014-01-21','13:15:00',2.03),('8975','2014-01-21','13:20:00',1.34),('8975','2014-01-20','10:00:00',1.41),('8975','2014-01-20','10:05:00',1.76),('8975','2014-01-20','10:55:00',1.71),('8975','2014-01-20','11:00:00',1.83),('8975','2014-01-20','11:15:00',1.04),('8975','2014-01-20','11:25:00',1.25),('8975','2014-01-20','12:00:00',1.48),('8975','2014-01-20','12:05:00',1.69),('8975','2014-01-20','12:10:00',1.28),('8975','2014-01-20','12:15:00',1.14),('8975','2014-01-20','12:20:00',1.33),('8975','2014-01-20','12:25:00',1.62),('8975','2014-01-20','12:30:00',1.2),('8975','2014-01-20','12:35:00',1.12),('8975','2014-01-20','12:40:00',1.27),('8975','2014-01-20','12:45:00',1.61),('8975','2014-01-20','12:50:00',1.91),('8975','2014-01-20','14:00:00',1.28),('8975','2014-01-20','14:05:00',1.65),('8975','2014-01-20','14:10:00',1.47),('8975','2014-01-20','14:15:00',1.12),('8975','2014-01-19','11:15:00',1.33),('8975','2014-01-19','11:20:00',1.76),('8975','2014-01-19','11:25:00',2.05),('8975','2014-01-19','11:30:00',1.93),('8975','2014-01-19','11:35:00',2.33),('8975','2014-01-19','11:40:00',2.52),('8975','2014-01-19','11:45:00',2.12),('8975','2014-01-19','11:50:00',1.9),('8975','2014-01-19','11:55:00',2.07),('8975','2014-01-19','12:00:00',1.87),('8975','2014-01-19','12:20:00',1.17),('8975','2014-01-19','12:25:00',2),('8975','2014-01-19','12:30:00',1.55),('8975','2014-01-19','13:15:00',1.61),('8975','2014-01-19','13:20:00',2.56),('8975','2014-01-19','13:25:00',1.95),('8975','2014-01-19','13:30:00',2.19),('8975','2014-01-19','13:35:00',1.95),('8975','2014-01-19','13:40:00',1.82),('8975','2014-01-19','13:45:00',1.57),('8975','2014-01-19','13:55:00',1.67),('8975','2014-01-19','14:00:00',1.97),('8975','2014-01-19','14:05:00',1.84),('8975','2014-01-19','14:10:00',1.69),('8975','2014-01-18','11:50:00',1.01),('8975','2014-01-18','11:55:00',1.16),('8975','2014-01-18','12:00:00',1.19),('8975','2014-01-18','12:05:00',1.26),('8975','2014-01-18','12:10:00',1.18),('8975','2014-01-18','12:15:00',1),('8975','2014-01-18','12:20:00',1.09),('8975','2014-01-18','12:25:00',1.12),('8975','2014-01-18','13:05:00',1.19),('8975','2014-01-18','13:10:00',1.29),('8975','2014-01-18','13:15:00',1.12),('8975','2014-01-18','14:20:00',1.39),('8975','2014-01-18','14:25:00',1.51),('8975','2014-01-18','14:30:00',1.49),('8975','2014-01-18','14:35:00',1.18),('8975','2014-01-18','14:40:00',1.08),('8975','2014-01-17','09:40:00',1.01),('8975','2014-01-17','09:45:00',1.01),('8975','2014-01-17','09:55:00',1.08),('8975','2014-01-17','10:00:00',1.42),('8975','2014-01-17','10:05:00',1.93),('8975','2014-01-17','10:10:00',2.59),('8975','2014-01-17','10:15:00',2.58),('8975','2014-01-17','10:20:00',2.22),('8975','2014-01-17','10:25:00',1.51),('8975','2014-01-17','10:30:00',1.56),('8975','2014-01-17','10:35:00',1.19),('8975','2014-01-17','10:40:00',1.08),('8975','2014-01-17','10:45:00',1.2),('8975','2014-01-17','10:50:00',1.39),('8975','2014-01-17','10:55:00',1.29),('8975','2014-01-17','11:05:00',1.38),('8975','2014-01-17','11:10:00',2.44),('8975','2014-01-17','11:15:00',2.68),('8975','2014-01-17','11:20:00',2.5),('8975','2014-01-17','11:25:00',2.39),('8975','2014-01-17','11:30:00',2.44),('8975','2014-01-17','11:35:00',2.47),('8975','2014-01-17','11:40:00',2.53),('8975','2014-01-17','11:45:00',2.55),('8975','2014-01-17','11:50:00',2.28),('8975','2014-01-17','11:55:00',2.19),('8975','2014-01-17','12:00:00',2.68),('8975','2014-01-17','12:05:00',1.53),('8975','2014-01-17','12:10:00',2.31),('8975','2014-01-17','12:15:00',2.12),('8975','2014-01-17','12:20:00',2.09),('8975','2014-01-17','12:25:00',2.15),('8975','2014-01-17','12:30:00',2.11),('8975','2014-01-17','12:35:00',2.08),('8975','2014-01-17','12:40:00',2.07),('8975','2014-01-17','12:45:00',1.93),('8975','2014-01-17','12:50:00',1.97),('8975','2014-01-17','12:55:00',2),('8975','2014-01-17','13:00:00',1.26),('8975','2014-01-17','13:05:00',1.48),('8975','2014-01-17','13:10:00',1.94),('8975','2014-01-17','13:15:00',2),('8975','2014-01-17','13:20:00',1.3),('8975','2014-01-17','13:25:00',1.29),('8975','2014-01-17','13:30:00',1.56),('8975','2014-01-17','13:35:00',1.05),('8975','2014-01-17','13:40:00',1.62),('8975','2014-01-17','13:45:00',1.64),('8975','2014-01-17','13:50:00',1.14),('8975','2014-01-17','13:55:00',1.61),('8975','2014-01-17','14:00:00',1.59),('8975','2014-01-17','14:05:00',1.44),('8975','2014-01-17','14:10:00',1.35),('8975','2014-01-17','14:15:00',1.26),('8975','2014-01-17','14:20:00',1.33),('8975','2014-01-17','14:25:00',1.3),('8975','2014-01-17','14:30:00',1.24),('8975','2014-01-17','14:35:00',1.2),('8975','2014-01-17','14:40:00',1.14),('8975','2014-01-17','14:45:00',1.14),('8975','2014-01-17','14:50:00',1.12),('8975','2014-01-16','08:50:00',1.17),('8975','2014-01-16','08:55:00',1.1),('8975','2014-01-16','09:00:00',1.51),('8975','2014-01-16','09:05:00',1.35),('8975','2014-01-16','09:15:00',1.26),('8975','2014-01-16','09:20:00',1.33),('8975','2014-01-16','09:25:00',1.78),('8975','2014-01-16','09:30:00',1.79),('8975','2014-01-16','09:35:00',1.35),('8975','2014-01-16','09:40:00',1.49),('8975','2014-01-16','09:45:00',1.55),('8975','2014-01-16','11:20:00',1.13),('8975','2014-01-16','11:25:00',1.77),('8975','2014-01-16','11:30:00',1.61),('8975','2014-01-16','11:35:00',1.86),('8975','2014-01-16','11:40:00',1.36),('8975','2014-01-16','11:50:00',1.14),('8975','2014-01-16','11:55:00',1.22),('8975','2014-01-16','12:00:00',1.02),('8975','2014-01-16','12:05:00',1.19),('8975','2014-01-16','12:10:00',1.03),('8975','2014-04-24','07:00:00',1.06),('8975','2014-04-24','07:05:00',1.18),('8975','2014-04-24','07:10:00',1.39),('8975','2014-04-24','07:15:00',1.55),('8975','2014-04-24','07:20:00',1.66),('8975','2014-04-24','07:25:00',1.87),('8975','2014-04-24','07:30:00',2.04),('8975','2014-04-24','07:35:00',2.2),('8975','2014-04-24','07:40:00',2.35),('8975','2014-04-24','07:45:00',2.48),('8975','2014-04-24','07:50:00',2.58),('8975','2014-04-24','07:55:00',2.68),('8975','2014-04-24','08:00:00',2.84),('8975','2014-04-24','08:05:00',2.95),('8975','2014-04-24','08:10:00',3.02),('8975','2014-04-24','08:15:00',3.19),('8975','2014-04-24','08:20:00',3.36),('8975','2014-04-24','08:25:00',3.5),('8975','2014-04-24','08:30:00',3.55),('8975','2014-04-24','08:35:00',3.67),('8975','2014-04-24','08:40:00',3.75),('8975','2014-04-24','08:45:00',3.84),('8975','2014-04-24','08:50:00',3.86),('8975','2014-04-24','08:55:00',4.01),('8975','2014-04-24','09:00:00',4.18),('8975','2014-04-24','09:05:00',2.44),('8975','2014-04-24','09:10:00',4.44),('8975','2014-04-24','09:15:00',5.2),('8975','2014-04-24','09:20:00',3.86),('8975','2014-04-24','09:25:00',3.69),('8975','2014-04-24','09:30:00',5.02),('8975','2014-04-24','09:35:00',3.36),('8975','2014-04-24','09:40:00',4.33),('8975','2014-04-24','09:45:00',4.98),('8975','2014-04-24','09:50:00',3.64),('8975','2014-04-24','09:55:00',2.86),('8975','2014-04-24','10:00:00',2.55),('8975','2014-04-24','10:05:00',2.39),('8975','2014-04-24','10:10:00',2.31),('8975','2014-04-24','10:15:00',2.04),('8975','2014-04-24','10:20:00',2.56),('8975','2014-04-24','10:25:00',1.71),('8975','2014-04-24','10:30:00',1.67),('8975','2014-04-24','10:35:00',2.13),('8975','2014-04-24','10:40:00',3.44),('8975','2014-04-24','10:45:00',3.31),('8975','2014-04-24','10:50:00',3.65),('8975','2014-04-24','10:55:00',2.35),('8975','2014-04-24','11:00:00',2.25),('8975','2014-04-24','11:05:00',2.16),('8975','2014-04-24','11:10:00',1.8),('8975','2014-04-24','11:15:00',4.23),('8975','2014-04-24','11:20:00',6.61),('8975','2014-04-24','11:25:00',6.03),('8975','2014-04-24','11:30:00',3.67),('8975','2014-04-24','11:35:00',6.06),('8975','2014-04-24','11:40:00',5.37),('8975','2014-04-24','11:45:00',5.73),('8975','2014-04-24','11:50:00',3.75),('8975','2014-04-24','11:55:00',4.08),('8975','2014-04-24','12:00:00',4.76),('8975','2014-04-24','12:05:00',6.33),('8975','2014-04-24','12:10:00',7.49),('8975','2014-04-24','12:15:00',7.13),('8975','2014-04-24','12:20:00',6.69),('8975','2014-04-24','12:25:00',4.05),('8975','2014-04-24','12:30:00',2.47),('8975','2014-04-24','12:35:00',4.83),('8975','2014-04-24','12:40:00',4.99),('8975','2014-04-24','12:45:00',4.01),('8975','2014-04-24','12:50:00',4.33),('8975','2014-04-24','12:55:00',5.15),('8975','2014-04-24','13:00:00',2.59),('8975','2014-04-24','13:05:00',3.77),('8975','2014-04-24','13:10:00',4.19),('8975','2014-04-24','13:15:00',5.66),('8975','2014-04-24','13:20:00',2.12),('8975','2014-04-24','13:25:00',2.53),('8975','2014-04-24','13:30:00',3.74),('8975','2014-04-24','13:35:00',6.92),('8975','2014-04-24','13:40:00',5.31),('8975','2014-04-24','13:45:00',2.74),('8975','2014-04-24','13:50:00',2.33),('8975','2014-04-24','13:55:00',2.41),('8975','2014-04-24','14:00:00',5.48),('8975','2014-04-24','14:05:00',7.09),('8975','2014-04-24','14:10:00',6.98),('8975','2014-04-24','14:15:00',6.89),('8975','2014-04-24','14:20:00',5.94),('8975','2014-04-24','14:25:00',2.71),('8975','2014-04-24','14:30:00',5.9),('8975','2014-04-24','14:35:00',5.45),('8975','2014-04-24','14:40:00',5.28),('8975','2014-04-24','14:45:00',5.04),('8975','2014-04-24','14:50:00',5.04),('8975','2014-04-24','14:55:00',5.01),('8975','2014-04-24','15:00:00',4.92),('8975','2014-04-24','15:05:00',4.81),('8975','2014-04-24','15:10:00',4.78),('8975','2014-04-24','15:15:00',4.54),('8975','2014-04-24','15:20:00',4.55),('8975','2014-04-24','15:25:00',4.45),('8975','2014-04-24','15:30:00',4.38),('8975','2014-04-24','15:35:00',4.31),('8975','2014-04-24','15:40:00',4.05),('8975','2014-04-24','15:45:00',4.04),('8975','2014-04-24','15:50:00',3.97),('8975','2014-04-24','15:55:00',3.87),('8975','2014-04-24','16:00:00',3.82),('8975','2014-04-24','16:05:00',3.65),('8975','2014-04-24','16:10:00',3.32),('8975','2014-04-24','16:15:00',2.97),('8975','2014-04-24','16:20:00',3.05),('8975','2014-04-24','16:25:00',2.81),('8975','2014-04-24','16:30:00',2.79),('8975','2014-04-24','16:35:00',2.92),('8975','2014-04-24','16:40:00',2.8),('8975','2014-04-24','16:45:00',2.85),('8975','2014-04-24','16:50:00',2.27),('8975','2014-04-24','16:55:00',1.72),('8975','2014-04-24','17:00:00',1.85),('8975','2014-04-24','17:05:00',2.02),('8975','2014-04-24','17:10:00',2.09),('8975','2014-04-24','17:15:00',1.63),('8975','2014-04-24','17:20:00',1.13),('8975','2014-04-24','17:25:00',1.15),('8975','2014-04-24','17:30:00',1.36),('8975','2014-04-24','17:35:00',1.33),('8975','2014-04-24','17:40:00',1.21),('8975','2014-04-24','17:45:00',1.16),('8975','2014-04-24','17:50:00',1.09),('8975','2014-04-24','17:55:00',1.07),('8975','2014-04-24','18:00:00',1.07),('8975','2014-04-24','18:05:00',1.03),('8975','2014-01-15','08:20:00',1.15),('8975','2014-01-15','08:25:00',1.18),('8975','2014-01-15','08:30:00',1.01),('8975','2014-01-15','08:35:00',1.1),('8975','2014-01-15','08:40:00',1.11),('8975','2014-01-15','08:45:00',1.03),('8975','2014-01-15','09:00:00',1.13),('8975','2014-01-15','09:05:00',1.16),('8975','2014-01-15','09:10:00',1.26),('8975','2014-01-15','09:15:00',1.28),('8975','2014-01-15','09:20:00',1.83),('8975','2014-01-15','09:25:00',1.93),('8975','2014-01-15','09:30:00',1.97),('8975','2014-01-15','09:35:00',1.99),('8975','2014-01-15','09:40:00',2.16),('8975','2014-01-15','09:45:00',1.98),('8975','2014-01-15','09:50:00',1.52),('8975','2014-01-15','09:55:00',1.2),('8975','2014-01-15','10:00:00',1.08),('8975','2014-01-15','10:05:00',1.13),('8975','2014-01-15','10:10:00',1.26),('8975','2014-01-15','10:15:00',1.5),('8975','2014-01-15','10:20:00',1.52),('8975','2014-01-15','10:25:00',1.71),('8975','2014-01-15','10:30:00',2.32),('8975','2014-01-15','10:35:00',2.84),('8975','2014-01-15','10:40:00',2.47),('8975','2014-01-15','10:45:00',1.77),('8975','2014-01-15','10:50:00',1.95),('8975','2014-01-15','10:55:00',2.04),('8975','2014-01-15','11:00:00',2.11),('8975','2014-01-15','11:05:00',2.04),('8975','2014-01-15','11:10:00',2.11),('8975','2014-01-15','11:15:00',1.94),('8975','2014-01-15','11:20:00',1.78),('8975','2014-01-15','11:25:00',1.85),('8975','2014-01-15','11:30:00',1.72),('8975','2014-01-15','11:35:00',1.77),('8975','2014-01-15','11:40:00',1.49),('8975','2014-01-15','11:45:00',1.2),('8975','2014-01-15','11:50:00',1.41),('8975','2014-01-15','11:55:00',1.59),('8975','2014-01-15','12:00:00',1.17),('8975','2014-01-15','12:05:00',1.18),('8975','2014-01-15','12:10:00',1),('8975','2014-01-15','12:15:00',1.01),('8975','2014-01-15','12:20:00',1.11),('8975','2014-01-15','12:25:00',1.07),('8975','2014-01-15','12:30:00',1.16),('8975','2014-01-15','12:35:00',1.2),('8975','2014-01-15','12:40:00',1.5),('8975','2014-01-15','12:45:00',1.63),('8975','2014-01-15','12:50:00',1.81),('8975','2014-01-15','12:55:00',1.75),('8975','2014-01-15','13:00:00',1.95),('8975','2014-01-15','13:05:00',1.49),('8975','2014-01-15','13:10:00',1.61),('8975','2014-01-15','13:15:00',1.45),('8975','2014-01-15','13:20:00',1.55),('8975','2014-01-15','13:25:00',1.5),('8975','2014-01-15','13:30:00',1.66),('8975','2014-01-15','13:35:00',1.34),('8975','2014-01-15','13:40:00',1.27),('8975','2014-01-15','13:45:00',1.09),('8975','2014-01-15','13:50:00',1.12),('8975','2014-01-15','13:55:00',1.43),('8975','2014-01-15','14:00:00',1.09),('8975','2014-01-15','14:05:00',1.05),('8975','2014-01-15','14:10:00',1.03),('8975','2014-01-15','14:15:00',1.03),('8975','2014-01-15','14:25:00',1.01),('8975','2014-01-15','14:30:00',1.06),('8975','2014-01-14','10:10:00',1.06),('8975','2014-01-14','10:15:00',1.62),('8975','2014-01-14','10:20:00',1.83),('8975','2014-01-14','10:25:00',1.96),('8975','2014-01-14','10:30:00',2.14),('8975','2014-01-14','10:35:00',1.62),('8975','2014-01-14','10:40:00',1.8),('8975','2014-01-14','10:45:00',1.43),('8975','2014-01-14','10:50:00',1.05),('8975','2014-01-14','10:55:00',1.13),('8975','2014-01-14','11:00:00',1.37),('8975','2014-01-14','11:05:00',2.57),('8975','2014-01-14','11:10:00',2.56),('8975','2014-01-14','11:15:00',2.42),('8975','2014-01-14','11:20:00',2.04),('8975','2014-01-14','11:25:00',2.22),('8975','2014-01-14','11:30:00',2.31),('8975','2014-01-14','11:35:00',1.77),('8975','2014-01-14','11:40:00',1.82),('8975','2014-01-14','11:45:00',2.11),('8975','2014-01-14','11:50:00',1.9),('8975','2014-01-14','11:55:00',1.7),('8975','2014-01-14','12:00:00',1.5),('8975','2014-01-14','12:05:00',1.39),('8975','2014-01-14','12:10:00',1.45),('8975','2014-01-14','12:15:00',1.95),('8975','2014-01-14','12:20:00',2.2),('8975','2014-01-14','12:25:00',1.7),('8975','2014-01-14','12:30:00',1.22),('8975','2014-01-14','12:35:00',1.06),('8975','2014-01-14','12:40:00',1.21),('8975','2014-01-14','12:45:00',1.24),('8975','2014-01-14','12:50:00',1.4),('8975','2014-01-14','12:55:00',1.2),('8975','2014-01-14','13:00:00',1.27),('8975','2014-01-14','13:05:00',1.3),('8975','2014-01-14','13:10:00',1.58),('8975','2014-01-14','13:15:00',2.18),('8975','2014-01-14','13:20:00',1.99),('8975','2014-01-14','13:25:00',1.79),('8975','2014-01-14','13:30:00',1.78),('8975','2014-01-14','13:35:00',1.64),('8975','2014-01-14','13:40:00',1.48),('8975','2014-01-14','13:45:00',1.44),('8975','2014-01-14','13:50:00',1.08),('8975','2014-01-14','14:25:00',1.15),('8975','2014-01-14','14:30:00',1.16),('8975','2014-01-14','14:35:00',1.14),('8975','2014-01-14','14:40:00',1.1),('8975','2014-01-14','14:45:00',1.02),('8975','2014-01-14','14:55:00',1.13),('8975','2014-01-14','15:00:00',1.16),('8975','2014-01-14','15:05:00',1.14),('8975','2014-01-14','15:10:00',1.11),('8975','2014-01-13','10:20:00',1.23),('8975','2014-01-13','10:25:00',2.21),('8975','2014-01-13','10:30:00',2.78),('8975','2014-01-13','10:35:00',2.74),('8975','2014-01-13','10:40:00',2.52),('8975','2014-01-13','10:45:00',2.36),('8975','2014-01-13','10:50:00',1.52),('8975','2014-01-13','10:55:00',1.35),('8975','2014-01-13','11:00:00',1.44),('8975','2014-01-13','11:05:00',1.26),('8975','2014-01-13','11:15:00',1.14),('8975','2014-01-13','11:30:00',1.97),('8975','2014-01-13','11:35:00',2.2),('8975','2014-01-13','11:40:00',1.54),('8975','2014-01-13','11:45:00',1.21),('8975','2014-01-13','11:50:00',1.07),('8975','2014-01-12','08:55:00',1.11),('8975','2014-01-12','09:00:00',1.28),('8975','2014-01-12','09:05:00',1.63),('8975','2014-01-12','09:10:00',1.62),('8975','2014-01-12','09:15:00',1.6),('8975','2014-01-12','09:20:00',1.61),('8975','2014-01-12','09:25:00',1.61),('8975','2014-01-12','09:30:00',1.65),('8975','2014-01-12','09:35:00',1.7),('8975','2014-01-12','09:40:00',1.73),('8975','2014-01-12','09:45:00',1.78),('8975','2014-01-12','09:50:00',1.8),('8975','2014-01-12','09:55:00',1.84),('8975','2014-01-12','10:00:00',1.83),('8975','2014-01-12','10:05:00',1.85),('8975','2014-01-12','10:10:00',1.87),('8975','2014-01-12','10:15:00',1.91),('8975','2014-01-12','10:20:00',1.99),('8975','2014-01-12','10:25:00',1.94),('8975','2014-01-12','10:30:00',1.98),('8975','2014-01-12','10:35:00',2.04),('8975','2014-01-12','10:40:00',2.08),('8975','2014-01-12','10:45:00',2.09),('8975','2014-01-12','10:50:00',2.12),('8975','2014-01-12','10:55:00',2.12),('8975','2014-01-12','11:00:00',2.12),('8975','2014-01-12','11:05:00',2.12),('8975','2014-01-12','11:10:00',2.17),('8975','2014-01-12','11:15:00',2.17),('8975','2014-01-12','11:20:00',2.19),('8975','2014-01-12','11:25:00',2.21),('8975','2014-01-12','11:30:00',2.2),('8975','2014-01-12','11:35:00',2.17),('8975','2014-01-12','11:40:00',1.95),('8975','2014-01-12','11:45:00',2.01),('8975','2014-01-12','11:50:00',2.02),('8975','2014-01-12','11:55:00',2),('8975','2014-01-12','12:00:00',1.96),('8975','2014-01-12','12:05:00',1.89),('8975','2014-01-12','12:10:00',1.89),('8975','2014-01-12','12:15:00',1.81),('8975','2014-01-12','12:20:00',1.81),('8975','2014-01-12','12:25:00',1.79),('8975','2014-01-12','12:30:00',1.78),('8975','2014-01-12','12:35:00',1.75),('8975','2014-01-12','12:40:00',1.72),('8975','2014-01-12','12:45:00',1.66),('8975','2014-01-12','12:50:00',1.65),('8975','2014-01-12','12:55:00',1.62),('8975','2014-01-12','13:00:00',1.54),('8975','2014-01-12','13:05:00',1.57),('8975','2014-01-12','13:10:00',1.57),('8975','2014-01-12','13:15:00',1.5),('8975','2014-01-12','13:20:00',1.39),('8975','2014-01-12','13:25:00',1.43),('8975','2014-01-12','13:30:00',1.41),('8975','2014-01-12','13:35:00',1.31),('8975','2014-01-12','13:40:00',1.34),('8975','2014-01-12','13:45:00',1.38),('8975','2014-01-12','13:50:00',1.35),('8975','2014-01-12','13:55:00',1.31),('8975','2014-01-12','14:00:00',1.31),('8975','2014-01-12','14:05:00',1.26),('8975','2014-01-12','14:10:00',1.23),('8975','2014-01-12','14:15:00',1.17),('8975','2014-01-12','14:20:00',1.17),('8975','2014-01-12','14:25:00',1.12),('8975','2014-01-12','14:30:00',1.11),('8975','2014-01-12','14:35:00',1.09),('8975','2014-01-12','14:40:00',1.08),('8975','2014-01-12','14:45:00',1.06),('8975','2014-01-12','14:50:00',1.05),('8975','2014-01-12','14:55:00',1.06),('8975','2014-01-12','15:00:00',1.05),('8975','2014-01-12','15:05:00',1.02),('8975','2014-01-11','09:45:00',1),('8975','2014-01-11','09:50:00',1.12),('8975','2014-01-11','09:55:00',1.12),('8975','2014-01-11','10:00:00',1.08),('8975','2014-01-11','10:05:00',1.04),('8975','2014-01-11','10:10:00',1.06),('8975','2014-01-11','10:15:00',1.22),('8975','2014-01-11','10:20:00',1.36),('8975','2014-01-11','10:25:00',1.22),('8975','2014-01-11','10:30:00',1.29),('8975','2014-01-11','10:35:00',1.48),('8975','2014-01-11','10:40:00',1.63),('8975','2014-01-11','10:45:00',1.63),('8975','2014-01-11','10:50:00',1.82),('8975','2014-01-11','10:55:00',1.76),('8975','2014-01-11','11:00:00',1.72),('8975','2014-01-11','11:05:00',1.72),('8975','2014-01-11','11:10:00',1.89),('8975','2014-01-11','11:15:00',1.61),('8975','2014-01-11','11:20:00',1.5),('8975','2014-01-11','11:25:00',1.89),('8975','2014-01-11','11:30:00',1.51),('8975','2014-01-11','11:35:00',1.51),('8975','2014-01-11','11:40:00',1.6),('8975','2014-01-11','11:45:00',1.57),('8975','2014-01-11','11:50:00',2.03),('8975','2014-01-11','11:55:00',1.74),('8975','2014-01-11','12:00:00',1.55),('8975','2014-01-11','12:05:00',1.43),('8975','2014-01-11','12:10:00',1.31),('8975','2014-01-11','12:15:00',1.26),('8975','2014-01-11','12:20:00',1.26),('8975','2014-01-11','12:25:00',1.28),('8975','2014-01-11','12:30:00',1.33),('8975','2014-01-11','12:35:00',1.35),('8975','2014-01-11','12:40:00',1.38),('8975','2014-01-11','12:45:00',1.39),('8975','2014-01-11','12:50:00',1.41),('8975','2014-01-11','12:55:00',1.38),('8975','2014-01-11','13:00:00',1.36),('8975','2014-01-11','13:05:00',1.27),('8975','2014-01-11','13:10:00',1.24),('8975','2014-01-11','13:15:00',1.23),('8975','2014-01-11','13:20:00',1.19),('8975','2014-01-11','13:25:00',1.28),('8975','2014-01-11','13:30:00',1.31),('8975','2014-01-11','13:35:00',1.23),('8975','2014-01-11','13:40:00',1.14),('8975','2014-01-11','13:45:00',1.04),('8975','2014-01-10','09:55:00',1.53),('8975','2014-01-10','10:00:00',1.69),('8975','2014-01-10','10:05:00',1.36),('8975','2014-01-10','10:10:00',1.29),('8975','2014-01-10','10:15:00',1.37),('8975','2014-01-10','10:20:00',1.48),('8975','2014-01-10','10:25:00',1.61),('8975','2014-01-10','10:30:00',1.59),('8975','2014-01-10','10:35:00',1.68),('8975','2014-01-10','10:40:00',2.15),('8975','2014-01-10','10:45:00',2.24),('8975','2014-01-10','10:50:00',2.27),('8975','2014-01-10','10:55:00',2.24),('8975','2014-01-10','11:00:00',2.14),('8975','2014-01-10','11:05:00',2.07),('8975','2014-01-10','11:10:00',2.17),('8975','2014-01-10','11:15:00',1.97),('8975','2014-01-10','11:20:00',1.98),('8975','2014-01-10','11:25:00',1.98),('8975','2014-01-10','11:30:00',1.85),('8975','2014-01-10','11:35:00',1.52),('8975','2014-01-10','11:40:00',1.38),('8975','2014-01-10','11:45:00',1.49),('8975','2014-01-10','11:50:00',1.63),('8975','2014-01-10','11:55:00',1.72),('8975','2014-01-10','12:00:00',1.83),('8975','2014-01-10','12:05:00',2.03),('8975','2014-01-10','12:10:00',1.74),('8975','2014-01-10','12:15:00',1.57),('8975','2014-01-10','12:20:00',1.55),('8975','2014-01-10','12:25:00',1.39),('8975','2014-01-10','12:30:00',1.33),('8975','2014-01-10','12:35:00',1.25),('8975','2014-01-10','12:40:00',1.25),('8975','2014-01-10','12:45:00',1.28),('8975','2014-01-10','12:50:00',1.37),('8975','2014-01-10','12:55:00',1.48),('8975','2014-01-10','13:00:00',1.6),('8975','2014-01-10','13:05:00',1.29),('8975','2014-01-10','13:10:00',1.32),('8975','2014-01-10','13:15:00',1.68),('8975','2014-01-10','13:20:00',1.31),('8975','2014-01-10','13:25:00',1.16),('8975','2014-01-10','13:30:00',1.03),('8975','2014-01-10','13:35:00',1.02),('8975','2014-01-10','13:45:00',1.13),('8975','2014-01-10','13:55:00',1.04),('8975','2014-01-10','14:00:00',1.32),('8975','2014-01-10','14:05:00',1.33),('8975','2014-01-10','14:10:00',1.17),('8975','2014-01-09','13:00:00',1.01),('8975','2014-01-09','13:05:00',1.02),('8975','2014-01-08','09:05:00',1.09),('8975','2014-01-08','09:10:00',1.09),('8975','2014-01-08','09:15:00',1.05),('8975','2014-01-08','09:20:00',1.4),('8975','2014-01-08','09:25:00',1.59),('8975','2014-01-08','09:30:00',1.51),('8975','2014-01-08','09:35:00',1.86),('8975','2014-01-08','09:40:00',1.92),('8975','2014-01-08','09:45:00',1.92),('8975','2014-01-08','09:50:00',1.96),('8975','2014-01-08','09:55:00',1.96),('8975','2014-01-08','10:00:00',1.72),('8975','2014-01-08','10:05:00',1.9),('8975','2014-01-08','10:10:00',1.74),('8975','2014-01-08','10:15:00',1.71),('8975','2014-01-08','10:20:00',1.86),('8975','2014-01-08','10:25:00',1.86),('8975','2014-01-08','10:30:00',1.89),('8975','2014-01-08','10:35:00',1.96),('8975','2014-01-08','10:40:00',2.04),('8975','2014-01-08','10:45:00',1.99),('8975','2014-01-08','10:50:00',1.45),('8975','2014-01-08','10:55:00',1.33),('8975','2014-01-08','11:00:00',1.23),('8975','2014-01-08','11:05:00',1.24),('8975','2014-01-08','11:10:00',1.26),('8975','2014-01-08','11:15:00',1.33),('8975','2014-01-08','11:20:00',1.31),('8975','2014-01-08','11:25:00',1.26),('8975','2014-01-08','11:30:00',1.28),('8975','2014-01-08','11:35:00',1.8),('8975','2014-01-08','11:40:00',1.45),('8975','2014-01-08','11:45:00',1.27),('8975','2014-01-08','11:50:00',1.13),('8975','2014-01-08','11:55:00',1.06),('8975','2014-01-08','12:00:00',1.02),('8975','2014-01-08','12:10:00',1.12),('8975','2014-01-08','13:05:00',1.01),('8975','2014-01-08','13:10:00',1.09),('8975','2014-01-08','13:15:00',1.06),('8975','2014-01-08','13:20:00',1.02),('8975','2014-01-08','13:25:00',1.06),('8975','2014-01-07','08:35:00',1.02),('8975','2014-01-07','08:40:00',1.08),('8975','2014-01-07','08:45:00',1.04),('8975','2014-01-07','08:55:00',1.21),('8975','2014-01-07','09:00:00',1.29),('8975','2014-01-07','09:05:00',1.35),('8975','2014-01-07','09:10:00',1.43),('8975','2014-01-07','09:15:00',1.49),('8975','2014-01-07','09:20:00',1.5),('8975','2014-01-07','09:25:00',1.58),('8975','2014-01-07','09:30:00',1.6),('8975','2014-01-07','09:35:00',1.52),('8975','2014-01-07','09:40:00',1.7),('8975','2014-01-07','09:45:00',1.75),('8975','2014-01-07','09:50:00',1.79),('8975','2014-01-07','09:55:00',1.85),('8975','2014-01-07','10:00:00',1.84),('8975','2014-01-07','10:05:00',1.65),('8975','2014-01-07','10:10:00',1.81),('8975','2014-01-07','10:15:00',1.87),('8975','2014-01-07','10:20:00',1.96),('8975','2014-01-07','10:25:00',1.97),('8975','2014-01-07','10:30:00',2),('8975','2014-01-07','10:35:00',2),('8975','2014-01-07','10:40:00',1.95),('8975','2014-01-07','10:45:00',2.07),('8975','2014-01-07','10:50:00',2.12),('8975','2014-01-07','10:55:00',2.15),('8975','2014-01-07','11:00:00',2.14),('8975','2014-01-07','11:05:00',2.17),('8975','2014-01-07','11:10:00',2.19),('8975','2014-01-07','11:15:00',2.22),('8975','2014-01-07','11:20:00',2.22),('8975','2014-01-07','11:25:00',2.2),('8975','2014-01-07','11:30:00',2.15),('8975','2014-01-07','11:35:00',2.17),('8975','2014-01-07','11:40:00',2.24),('8975','2014-01-07','11:45:00',2.21),('8975','2014-01-07','11:50:00',2.1),('8975','2014-01-07','11:55:00',2.06),('8975','2014-01-07','12:00:00',1.96),('8975','2014-01-07','12:05:00',1.8),('8975','2014-01-07','12:10:00',1.8),('8975','2014-01-07','12:15:00',1.92),('8975','2014-01-07','12:20:00',1.86),('8975','2014-01-07','12:25:00',1.8),('8975','2014-01-07','12:30:00',1.83),('8975','2014-01-07','12:35:00',1.79),('8975','2014-01-07','12:40:00',1.72),('8975','2014-01-07','12:45:00',1.61),('8975','2014-01-07','12:50:00',1.6),('8975','2014-01-07','12:55:00',1.66),('8975','2014-01-07','13:00:00',1.66),('8975','2014-01-07','13:05:00',1.6),('8975','2014-01-07','13:10:00',1.51),('8975','2014-01-07','13:15:00',1.4),('8975','2014-01-07','13:20:00',1.47),('8975','2014-01-07','13:25:00',1.37),('8975','2014-01-07','13:30:00',1.3),('8975','2014-01-07','13:35:00',1.31),('8975','2014-01-07','13:40:00',1.24),('8975','2014-01-07','13:45:00',1.24),('8975','2014-01-07','13:50:00',1.26),('8975','2014-01-07','13:55:00',1.26),('8975','2014-01-07','14:00:00',1.18),('8975','2014-01-07','14:05:00',1.15),('8975','2014-01-07','14:10:00',1.19),('8975','2014-01-07','14:15:00',1.16),('8975','2014-01-07','14:20:00',1.18),('8975','2014-01-07','14:25:00',1.18),('8975','2014-01-07','14:30:00',1.19),('8975','2014-01-07','14:35:00',1.17),('8975','2014-01-07','14:40:00',1.07),('8975','2014-01-07','14:45:00',1.01),('8975','2014-01-07','14:50:00',1.05),('8975','2014-01-06','08:30:00',1.03),('8975','2014-01-06','08:35:00',1.12),('8975','2014-01-06','08:40:00',1.19),('8975','2014-01-06','08:45:00',1.25),('8975','2014-01-06','08:50:00',1.31),('8975','2014-01-06','08:55:00',1.36),('8975','2014-01-06','09:00:00',1.42),('8975','2014-01-06','09:05:00',1.47),('8975','2014-01-06','09:10:00',1.51),('8975','2014-01-06','09:15:00',1.56),('8975','2014-01-06','09:20:00',1.6),('8975','2014-01-06','09:25:00',1.65),('8975','2014-01-06','09:30:00',1.69),('8975','2014-01-06','09:35:00',1.72),('8975','2014-01-06','09:40:00',1.75),('8975','2014-01-06','09:45:00',1.81),('8975','2014-01-06','09:50:00',1.85),('8975','2014-01-06','09:55:00',1.88),('8975','2014-01-06','10:00:00',1.9),('8975','2014-01-06','10:05:00',1.93),('8975','2014-01-06','10:10:00',1.96),('8975','2014-01-06','10:15:00',1.96),('8975','2014-01-06','10:20:00',2),('8975','2014-01-06','10:25:00',2.01),('8975','2014-01-06','10:30:00',2.07),('8975','2014-01-06','10:35:00',2.1),('8975','2014-01-06','10:40:00',2.14),('8975','2014-01-06','10:45:00',2.16),('8975','2014-01-06','10:50:00',2.18),('8975','2014-01-06','10:55:00',2.21),('8975','2014-01-06','11:00:00',2.22),('8975','2014-01-06','11:05:00',2.22),('8975','2014-01-06','11:10:00',2.23),('8975','2014-01-06','11:15:00',2.23),('8975','2014-01-06','11:20:00',2.24),('8975','2014-01-06','11:25:00',2.24),('8975','2014-01-06','11:30:00',2.22),('8975','2014-01-06','11:35:00',2.12),('8975','2014-01-06','11:40:00',2.18),('8975','2014-01-06','11:45:00',2.15),('8975','2014-01-06','11:50:00',2.04),('8975','2014-01-06','11:55:00',2.02),('8975','2014-01-06','12:00:00',1.98),('8975','2014-01-06','12:05:00',1.8),('8975','2014-01-06','12:10:00',1.88),('8975','2014-01-06','12:15:00',1.9),('8975','2014-01-06','12:20:00',1.9),('8975','2014-01-06','12:25:00',1.85),('8975','2014-01-06','12:30:00',1.81),('8975','2014-01-06','12:35:00',1.79),('8975','2014-01-06','12:40:00',1.73),('8975','2014-01-06','12:45:00',1.65),('8975','2014-01-06','12:50:00',1.63),('8975','2014-01-06','12:55:00',1.68),('8975','2014-01-06','13:00:00',1.66),('8975','2014-01-06','13:05:00',1.56),('8975','2014-01-06','13:10:00',1.47),('8975','2014-01-06','13:15:00',1.45),('8975','2014-01-06','13:20:00',1.43),('8975','2014-01-06','13:25:00',1.3),('8975','2014-01-06','13:30:00',1.23),('8975','2014-01-06','13:35:00',1.24),('8975','2014-01-06','13:40:00',1.24),('8975','2014-01-06','13:45:00',1.3),('8975','2014-01-06','13:50:00',1.26),('8975','2014-01-06','13:55:00',1.23),('8975','2014-01-06','14:00:00',1.2),('8975','2014-01-06','14:05:00',1.15),('8975','2014-01-06','14:10:00',1.1),('8975','2014-01-06','14:15:00',1.12),('8975','2014-01-06','14:20:00',1.11),('8975','2014-01-06','14:25:00',1.06),('8975','2014-01-06','14:30:00',1.05),('8975','2014-01-06','14:35:00',1),('8975','2014-01-06','14:45:00',1.01),('8975','2014-01-06','14:50:00',1.07),('8975','2014-01-06','14:55:00',1.06),('8975','2014-01-06','15:00:00',1.05),('8975','2014-01-06','15:05:00',1.05),('8975','2014-01-06','15:10:00',1.01),('8975','2014-04-23','06:55:00',1.1),('8975','2014-04-23','07:00:00',1.29),('8975','2014-04-23','07:05:00',1.4),('8975','2014-04-23','07:10:00',1.56),('8975','2014-04-23','07:15:00',1.87),('8975','2014-04-23','07:20:00',1.83),('8975','2014-04-23','07:25:00',2.13),('8975','2014-04-23','07:30:00',2.28),('8975','2014-04-23','07:35:00',2.42),('8975','2014-04-23','07:40:00',2.56),('8975','2014-04-23','07:45:00',2.73),('8975','2014-04-23','07:50:00',2.87),('8975','2014-04-23','07:55:00',3),('8975','2014-04-23','08:00:00',3.1),('8975','2014-04-23','08:05:00',3.22),('8975','2014-04-23','08:10:00',3.32),('8975','2014-04-23','08:15:00',3.42),('8975','2014-04-23','08:20:00',3.52),('8975','2014-04-23','08:25:00',3.63),('8975','2014-04-23','08:30:00',3.72),('8975','2014-04-23','08:35:00',3.8),('8975','2014-04-23','08:40:00',3.91),('8975','2014-04-23','08:45:00',4.01),('8975','2014-04-23','08:50:00',4.1),('8975','2014-04-23','08:55:00',4.21),('8975','2014-04-23','09:00:00',4.31),('8975','2014-04-23','09:05:00',4.39),('8975','2014-04-23','09:10:00',4.48),('8975','2014-04-23','09:15:00',4.58),('8975','2014-04-23','09:20:00',4.66),('8975','2014-04-23','09:25:00',4.74),('8975','2014-04-23','09:30:00',4.84),('8975','2014-04-23','09:35:00',4.95),('8975','2014-04-23','09:40:00',5.04),('8975','2014-04-23','09:45:00',5.12),('8975','2014-04-23','09:50:00',5.2),('8975','2014-04-23','09:55:00',5.23),('8975','2014-04-23','10:00:00',5.33),('8975','2014-04-23','10:05:00',5.42),('8975','2014-04-23','10:10:00',5.4),('8975','2014-04-23','10:15:00',5.49),('8975','2014-04-23','10:20:00',5.52),('8975','2014-04-23','10:25:00',5.58),('8975','2014-04-23','10:30:00',5.66),('8975','2014-04-23','10:35:00',5.69),('8975','2014-04-23','10:40:00',5.7),('8975','2014-04-23','10:45:00',5.81),('8975','2014-04-23','10:50:00',5.78),('8975','2014-04-23','10:55:00',5.84),('8975','2014-04-23','11:00:00',5.86),('8975','2014-04-23','11:05:00',5.89),('8975','2014-04-23','11:10:00',5.95),('8975','2014-04-23','11:15:00',6.01),('8975','2014-04-23','11:20:00',6.08),('8975','2014-04-23','11:25:00',6.17),('8975','2014-04-23','11:30:00',6.16),('8975','2014-04-23','11:35:00',6.02),('8975','2014-04-23','11:40:00',6.17),('8975','2014-04-23','11:45:00',6.11),('8975','2014-04-23','11:50:00',6.06),('8975','2014-04-23','11:55:00',6.19),('8975','2014-04-23','12:00:00',6.2),('8975','2014-04-23','12:05:00',6.35),('8975','2014-04-23','12:10:00',4.77),('8975','2014-04-23','12:15:00',6.46),('8975','2014-04-23','12:20:00',6.4),('8975','2014-04-23','12:25:00',6.47),('8975','2014-04-23','12:30:00',6.61),('8975','2014-04-23','12:35:00',6.66),('8975','2014-04-23','12:40:00',6.61),('8975','2014-04-23','12:45:00',6.47),('8975','2014-04-23','12:50:00',6.51),('8975','2014-04-23','12:55:00',2.69),('8975','2014-04-23','13:00:00',1.15),('8975','2014-04-23','13:10:00',1.08),('8975','2014-04-23','13:15:00',5.54),('8975','2014-04-23','13:20:00',4.54),('8975','2014-04-23','13:25:00',2.63),('8975','2014-04-23','13:30:00',1.38),('8975','2014-04-23','13:35:00',1.25),('8975','2014-04-23','13:40:00',2.95),('8975','2014-04-23','13:45:00',7.24),('8975','2014-04-23','13:50:00',6.81),('8975','2014-04-23','13:55:00',6.32),('8975','2014-04-23','14:00:00',6.4),('8975','2014-04-23','14:05:00',6.46),('8975','2014-04-23','14:10:00',6.62),('8975','2014-04-23','14:15:00',6.58),('8975','2014-04-23','14:20:00',6.53),('8975','2014-04-23','14:25:00',6.2),('8975','2014-04-23','14:30:00',5.59),('8975','2014-04-23','14:35:00',5.17),('8975','2014-04-23','14:40:00',4.69),('8975','2014-04-23','14:45:00',4.63),('8975','2014-04-23','14:50:00',3.12),('8975','2014-04-23','14:55:00',6.42),('8975','2014-04-23','15:00:00',6),('8975','2014-04-23','15:05:00',5.72),('8975','2014-04-23','15:10:00',5.8),('8975','2014-04-23','15:15:00',5.51),('8975','2014-04-23','15:20:00',4.56),('8975','2014-04-23','15:25:00',3.51),('8975','2014-04-23','15:30:00',3.9),('8975','2014-04-23','15:35:00',5.25),('8975','2014-04-23','15:40:00',3.92),('8975','2014-04-23','15:45:00',3.89),('8975','2014-04-23','15:50:00',4.38),('8975','2014-04-23','15:55:00',3.81),('8975','2014-04-23','16:00:00',4.92),('8975','2014-04-23','16:05:00',4.35),('8975','2014-04-23','16:10:00',4.17),('8975','2014-04-23','16:15:00',4.41),('8975','2014-04-23','16:20:00',4.76),('8975','2014-04-23','16:25:00',3.66),('8975','2014-04-23','16:30:00',3.31),('8975','2014-04-23','16:35:00',2.82),('8975','2014-04-23','16:40:00',2.64),('8975','2014-04-23','16:45:00',2.66),('8975','2014-04-23','16:50:00',1.64),('8975','2014-04-23','16:55:00',1.78),('8975','2014-04-23','17:00:00',1.87),('8975','2014-04-23','17:05:00',1.79),('8975','2014-04-23','17:10:00',1.68),('8975','2014-04-23','17:15:00',1.55),('8975','2014-04-23','17:20:00',1.54),('8975','2014-04-23','17:25:00',1.56),('8975','2014-04-23','17:30:00',1.9),('8975','2014-04-23','17:35:00',1.49),('8975','2014-04-23','17:40:00',1.23),('8975','2014-01-05','11:10:00',1.04),('8975','2014-01-05','11:15:00',1.25),('8975','2014-01-05','11:20:00',1.29),('8975','2014-01-05','11:25:00',1.4),('8975','2014-01-05','11:30:00',1.04),('8975','2014-01-05','11:40:00',1.14),('8975','2014-01-05','11:45:00',1.88),('8975','2014-01-05','11:50:00',2.17),('8975','2014-01-05','11:55:00',2.29),('8975','2014-01-05','12:00:00',1.85),('8975','2014-01-05','12:05:00',1.05),('8975','2014-01-05','12:10:00',2.04),('8975','2014-01-05','12:15:00',1.97),('8975','2014-01-05','12:20:00',1.93),('8975','2014-01-05','12:25:00',1.86),('8975','2014-01-05','12:30:00',1.78),('8975','2014-01-05','12:35:00',1.75),('8975','2014-01-05','12:40:00',1.68),('8975','2014-01-05','12:45:00',1.67),('8975','2014-01-05','12:50:00',1.72),('8975','2014-01-05','12:55:00',1.7),('8975','2014-01-05','13:00:00',1.62),('8975','2014-01-05','13:05:00',1.61),('8975','2014-01-05','13:10:00',1.54),('8975','2014-01-05','13:15:00',1.54),('8975','2014-01-05','13:20:00',1.5),('8975','2014-01-05','13:25:00',1.32),('8975','2014-01-05','13:30:00',1.26),('8975','2014-01-05','13:35:00',1.19),('8975','2014-01-05','13:40:00',1.28),('8975','2014-01-05','13:45:00',1.27),('8975','2014-01-05','13:50:00',1.23),('8975','2014-01-05','13:55:00',1.2),('8975','2014-01-05','14:00:00',1.12),('8975','2014-01-05','14:10:00',1.14),('8975','2014-01-05','14:15:00',1.41),('8975','2014-01-05','14:30:00',1.27),('8975','2014-01-05','14:35:00',1.32),('8975','2014-01-05','14:40:00',1.2),('8975','2014-01-05','14:45:00',1.19),('8975','2014-01-05','14:50:00',1.14),('8975','2014-01-05','14:55:00',1.11),('8975','2014-01-05','15:05:00',1.04),('8975','2014-01-03','15:00:00',1.05),('8975','2014-01-02','08:50:00',1.04),('8975','2014-01-02','09:10:00',1.2),('8975','2014-01-02','09:15:00',1.53),('8975','2014-01-02','09:25:00',1.36),('8975','2014-01-02','09:30:00',2.37),('8975','2014-01-02','09:35:00',2.51),('8975','2014-01-02','09:40:00',1.07),('8975','2014-01-02','09:45:00',2.8),('8975','2014-01-02','09:50:00',1.65),('8975','2014-01-02','09:55:00',2.49),('8975','2014-01-02','10:00:00',2.62),('8975','2014-01-02','10:05:00',1.77),('8975','2014-01-02','10:10:00',1.34),('8975','2014-01-02','10:15:00',1.92),('8975','2014-01-02','10:20:00',1.52),('8975','2014-01-02','10:25:00',1.35),('8975','2014-01-02','10:30:00',1.4),('8975','2014-01-02','10:35:00',1.98),('8975','2014-01-02','10:40:00',1.9),('8975','2014-01-02','10:45:00',2.09),('8975','2014-01-02','10:50:00',1.91),('8975','2014-01-02','10:55:00',1.53),('8975','2014-01-02','11:00:00',1.4),('8975','2014-01-02','11:05:00',1.34),('8975','2014-01-02','11:10:00',1.19),('8975','2014-01-02','11:15:00',1.28),('8975','2014-01-02','11:20:00',1.5),('8975','2014-01-02','11:25:00',1.83),('8975','2014-01-02','11:30:00',1.75),('8975','2014-01-02','11:35:00',1.8),('8975','2014-01-02','11:40:00',2.05),('8975','2014-01-02','11:45:00',1.92),('8975','2014-01-02','11:50:00',1.91),('8975','2014-01-02','11:55:00',1.9),('8975','2014-01-02','12:00:00',2.18),('8975','2014-01-02','12:05:00',2.48),('8975','2014-01-02','12:10:00',2.12),('8975','2014-01-02','12:15:00',1.88),('8975','2014-01-02','12:20:00',1.47),('8975','2014-01-02','12:25:00',1.89),('8975','2014-01-02','12:30:00',2.16),('8975','2014-01-02','12:35:00',2.09),('8975','2014-01-02','12:40:00',1.84),('8975','2014-01-02','12:45:00',1.74),('8975','2014-01-02','12:50:00',1.63),('8975','2014-01-02','12:55:00',1.39),('8975','2014-01-02','13:00:00',1.52),('8975','2014-01-02','13:05:00',1.52),('8975','2014-01-02','13:10:00',1.59),('8975','2014-01-02','13:15:00',1.46),('8975','2014-01-02','13:20:00',1.39),('8975','2014-01-02','13:25:00',1.51),('8975','2014-01-02','13:30:00',1.8),('8975','2014-01-02','13:35:00',1.55),('8975','2014-01-02','13:40:00',1.31),('8975','2014-01-02','13:45:00',1.39),('8975','2014-01-02','13:50:00',1.19),('8975','2014-01-01','08:40:00',1.66),('8975','2014-01-01','08:45:00',1.75),('8975','2014-01-01','08:50:00',1.83),('8975','2014-01-01','08:55:00',1.89),('8975','2014-01-01','09:00:00',1.99),('8975','2014-01-01','09:05:00',2.06),('8975','2014-01-01','09:10:00',2.12),('8975','2014-01-01','09:15:00',2.18),('8975','2014-01-01','09:20:00',2.24),('8975','2014-01-01','09:25:00',2.29),('8975','2014-01-01','09:30:00',2.34),('8975','2014-01-01','09:35:00',2.4),('8975','2014-01-01','09:40:00',2.44),('8975','2014-01-01','09:45:00',2.47),('8975','2014-01-01','09:50:00',2.5),('8975','2014-01-01','09:55:00',2.55),('8975','2014-01-01','10:00:00',2.64),('8975','2014-01-01','10:05:00',2.67),('8975','2014-01-01','10:10:00',2.71),('8975','2014-01-01','10:15:00',2.72),('8975','2014-01-01','10:20:00',2.73),('8975','2014-01-01','10:25:00',2.69),('8975','2014-01-01','10:30:00',2.74),('8975','2014-01-01','10:35:00',2.76),('8975','2014-01-01','10:40:00',2.8),('8975','2014-01-01','10:45:00',2.82),('8975','2014-01-01','10:50:00',2.81),('8975','2014-01-01','10:55:00',2.68),('8975','2014-01-01','11:00:00',3.04),('8975','2014-01-01','11:05:00',1.97),('8975','2014-01-01','11:10:00',1.38),('8975','2014-01-01','11:15:00',1.32),('8975','2014-01-01','11:20:00',1.74),('8975','2014-01-01','11:25:00',2.2),('8975','2014-01-01','11:30:00',2.64),('8975','2014-01-01','11:35:00',2.38),('8975','2014-01-01','11:40:00',3.17),('8975','2014-01-01','11:45:00',2.24),('8975','2014-01-01','11:50:00',1.8),('8975','2014-01-01','11:55:00',1.88),('8975','2014-01-01','12:00:00',1.71),('8975','2014-01-01','12:05:00',1.63),('8975','2014-01-01','12:10:00',1.46),('8975','2014-01-01','12:15:00',1.5),('8975','2014-01-01','12:20:00',1.28),('8975','2014-01-01','12:25:00',1.26),('8975','2014-01-01','12:30:00',1.28),('8975','2014-01-01','12:35:00',1.21),('8975','2014-01-01','12:40:00',1.25),('8975','2014-01-01','12:45:00',1.54),('8975','2014-01-01','12:50:00',2.23),('8975','2014-01-01','12:55:00',1.98),('8975','2014-01-01','13:00:00',1.59),('8975','2014-01-01','13:05:00',1.45),('8975','2014-01-01','13:10:00',1.34),('8975','2014-01-01','13:15:00',1.49),('8975','2014-01-01','13:20:00',1.13),('8975','2014-01-01','13:30:00',1.5),('8975','2014-01-01','13:35:00',1.38),('8975','2014-01-01','13:40:00',1.4),('8975','2014-01-01','13:45:00',1.67),('8975','2014-01-01','13:50:00',1.09),('8975','2014-01-01','14:20:00',1.05),('8975','2014-01-01','14:25:00',1.05),('8975','2013-12-31','08:10:00',1),('8975','2013-12-31','08:15:00',1.1),('8975','2013-12-31','08:20:00',1.2),('8975','2013-12-31','08:25:00',1.41),('8975','2013-12-31','08:30:00',1.09),('8975','2013-12-31','08:50:00',1.93),('8975','2013-12-31','08:55:00',2.27),('8975','2013-12-31','09:00:00',2.45),('8975','2013-12-31','09:05:00',2.64),('8975','2013-12-31','09:10:00',2.37),('8975','2013-12-31','09:15:00',1.8),('8975','2013-12-31','09:20:00',1.33),('8975','2013-12-31','09:25:00',1.36),('8975','2013-12-31','09:30:00',2.14),('8975','2013-12-31','09:35:00',2.25),('8975','2013-12-31','09:40:00',2.09),('8975','2013-12-31','09:45:00',2.58),('8975','2013-12-31','09:50:00',2.94),('8975','2013-12-31','09:55:00',2.81),('8975','2013-12-31','10:00:00',2.15),('8975','2013-12-31','10:05:00',1.77),('8975','2013-12-31','10:10:00',1.47),('8975','2013-12-31','10:15:00',1.29),('8975','2013-12-31','10:20:00',1.18),('8975','2013-12-31','10:25:00',1.15),('8975','2013-12-31','10:30:00',1.15),('8975','2013-12-31','10:35:00',1.11),('8975','2013-12-31','10:40:00',1.12),('8975','2013-12-31','10:45:00',1.17),('8975','2013-12-31','10:50:00',1.27),('8975','2013-12-31','10:55:00',1.38),('8975','2013-12-31','11:00:00',1.41),('8975','2013-12-31','11:05:00',1.36),('8975','2013-12-31','11:10:00',1.32),('8975','2013-12-31','11:15:00',1.4),('8975','2013-12-31','11:20:00',1.46),('8975','2013-12-31','11:25:00',1.5),('8975','2013-12-31','11:30:00',1.51),('8975','2013-12-31','11:35:00',1.47),('8975','2013-12-31','11:40:00',1.44),('8975','2013-12-31','11:45:00',1.43),('8975','2013-12-31','11:50:00',1.42),('8975','2013-12-31','11:55:00',1.5),('8975','2013-12-31','12:00:00',1.63),('8975','2013-12-31','12:05:00',1.72),('8975','2013-12-31','12:10:00',1.79),('8975','2013-12-31','12:15:00',1.89),('8975','2013-12-31','12:20:00',1.87),('8975','2013-12-31','12:25:00',1.88),('8975','2013-12-31','12:30:00',1.91),('8975','2013-12-31','12:35:00',1.91),('8975','2013-12-31','12:40:00',1.87),('8975','2013-12-31','12:45:00',1.82),('8975','2013-12-31','12:50:00',1.8),('8975','2013-12-31','12:55:00',1.77),('8975','2013-12-31','13:00:00',1.77),('8975','2013-12-31','13:05:00',1.65),('8975','2013-12-31','13:10:00',1.62),('8975','2013-12-31','13:15:00',1.58),('8975','2013-12-31','13:20:00',1.66),('8975','2013-12-31','13:25:00',1.88),('8975','2013-12-31','13:30:00',2.07),('8975','2013-12-31','13:35:00',2.23),('8975','2013-12-31','13:40:00',1.94),('8975','2013-12-31','13:45:00',1.87),('8975','2013-12-31','13:50:00',1.51),('8975','2013-12-31','13:55:00',1.52),('8975','2013-12-31','14:00:00',1.76),('8975','2013-12-31','14:05:00',1.78),('8975','2013-12-31','14:10:00',1.64),('8975','2013-12-31','14:15:00',1.48),('8975','2013-12-31','14:20:00',1.26),('8975','2013-12-31','14:25:00',1.13),('8975','2013-12-31','14:30:00',1.13),('8975','2013-12-31','14:35:00',1.04),('8975','2013-12-31','14:40:00',1.05),('8975','2013-12-31','14:55:00',1.05),('8975','2013-12-31','15:00:00',1.04),('8975','2013-12-31','15:05:00',1.3),('8975','2013-12-31','15:10:00',1.42),('8975','2013-12-31','15:15:00',1.2),('8975','2013-12-31','15:20:00',1.08),('8975','2013-12-30','09:20:00',1.39),('8975','2013-12-30','09:25:00',2.5),('8975','2013-12-30','09:30:00',1.91),('8975','2013-12-30','09:35:00',2.21),('8975','2013-12-30','09:40:00',1.96),('8975','2013-12-30','09:45:00',2.84),('8975','2013-12-30','09:50:00',3.18),('8975','2013-12-30','09:55:00',3.49),('8975','2013-12-30','10:00:00',3.15),('8975','2013-12-30','10:05:00',2.35),('8975','2013-12-30','10:10:00',1.24),('8975','2013-12-30','10:15:00',1.29),('8975','2013-12-30','10:20:00',1.18),('8975','2013-12-30','10:25:00',1.23),('8975','2013-12-30','10:30:00',1.44),('8975','2013-12-30','10:35:00',1.43),('8975','2013-12-30','10:40:00',1.47),('8975','2013-12-30','10:45:00',1.64),('8975','2013-12-30','10:50:00',1.87),('8975','2013-12-30','10:55:00',1.97),('8975','2013-12-30','11:00:00',1.95),('8975','2013-12-30','11:05:00',1.81),('8975','2013-12-30','11:10:00',1.69),('8975','2013-12-30','11:15:00',1.5),('8975','2013-12-30','11:20:00',1.69),('8975','2013-12-30','11:25:00',1.14),('8975','2013-12-30','11:30:00',1.3),('8975','2013-12-30','11:35:00',1.74),('8975','2013-12-30','11:40:00',2.23),('8975','2013-12-30','11:45:00',1.51),('8975','2013-12-30','11:50:00',1.45),('8975','2013-12-30','11:55:00',1.84),('8975','2013-12-30','12:00:00',1.34),('8975','2013-12-30','12:05:00',1.75),('8975','2013-12-30','12:10:00',2.54),('8975','2013-12-30','12:15:00',2.64),('8975','2013-12-30','12:20:00',2.59),('8975','2013-12-30','12:25:00',2.54),('8975','2013-12-30','12:30:00',2.42),('8975','2013-12-30','12:35:00',2.32),('8975','2013-12-30','12:40:00',2.3),('8975','2013-12-30','12:45:00',2.27),('8975','2013-12-30','12:50:00',2.21),('8975','2013-12-30','12:55:00',2.16),('8975','2013-12-30','13:00:00',2.08),('8975','2013-12-30','13:05:00',2.01),('8975','2013-12-30','13:10:00',1.87),('8975','2013-12-30','13:15:00',1.87),('8975','2013-12-30','13:20:00',1.8),('8975','2013-12-30','13:25:00',1.71),('8975','2013-12-30','13:30:00',1.64),('8975','2013-12-30','13:35:00',1.52),('8975','2013-12-30','13:40:00',1.47),('8975','2013-12-30','13:45:00',1.46),('8975','2013-12-30','13:50:00',1.43),('8975','2013-12-30','13:55:00',1.38),('8975','2013-12-30','14:00:00',1.32),('8975','2013-12-30','14:05:00',1.28),('8975','2013-12-30','14:10:00',1.2),('8975','2013-12-30','14:15:00',1.15),('8975','2013-12-30','14:20:00',1.14),('8975','2013-12-30','14:25:00',1.13),('8975','2013-12-30','14:30:00',1.11),('8975','2013-12-30','14:35:00',1.1),('8975','2013-12-30','14:40:00',1.11),('8975','2013-12-30','14:45:00',1.15),('8975','2013-12-30','14:50:00',1.12),('8975','2013-12-30','14:55:00',1.08),('8975','2013-12-30','15:00:00',1.05),('8975','2013-12-30','15:05:00',1.03),('8975','2013-12-29','09:25:00',1.09),('8975','2013-12-29','09:30:00',1.03),('8975','2013-12-29','11:10:00',1.02),('8975','2013-12-29','11:15:00',1.28),('8975','2013-12-29','11:20:00',1.55),('8975','2013-12-29','11:25:00',1.66),('8975','2013-12-29','11:30:00',1.62),('8975','2013-12-29','11:35:00',1.55),('8975','2013-12-29','11:40:00',1.49),('8975','2013-12-29','11:45:00',1.47),('8975','2013-12-29','11:50:00',1.41),('8975','2013-12-29','11:55:00',1.27),('8975','2013-12-29','12:00:00',1.15),('8975','2013-12-29','12:05:00',1.13),('8975','2013-12-29','12:10:00',1.16),('8975','2013-12-29','12:15:00',1.15),('8975','2013-12-29','12:20:00',1.12),('8975','2013-12-29','12:25:00',1.17),('8975','2013-12-29','12:30:00',1.15),('8975','2013-12-29','12:35:00',1.17),('8975','2013-12-29','12:40:00',1.25),('8975','2013-12-29','12:45:00',1.29),('8975','2013-12-29','12:50:00',1.21),('8975','2013-12-29','12:55:00',1.09),('8975','2013-12-29','13:05:00',1.04),('8975','2013-12-29','13:10:00',1.1),('8975','2013-12-29','13:15:00',1.04),('8975','2013-12-29','13:20:00',1.02),('8975','2013-12-29','13:25:00',1.07),('8975','2013-12-29','13:30:00',1.08),('8975','2013-12-29','13:35:00',1.06),('8975','2013-12-28','08:20:00',1.23),('8975','2013-12-28','08:25:00',1.07),('8975','2013-12-28','08:40:00',1.02),('8975','2013-12-28','08:45:00',1.97),('8975','2013-12-28','09:00:00',1.49),('8975','2013-12-28','09:05:00',1.94),('8975','2013-12-28','09:10:00',2.09),('8975','2013-12-28','09:15:00',2.15),('8975','2013-12-28','09:20:00',2.33),('8975','2013-12-28','09:25:00',2.4),('8975','2013-12-28','09:30:00',2.45),('8975','2013-12-28','09:35:00',2.42),('8975','2013-12-28','09:40:00',2.4),('8975','2013-12-28','09:45:00',2.53),('8975','2013-12-28','09:50:00',2.25),('8975','2013-12-28','09:55:00',2.2),('8975','2013-12-28','10:00:00',2.14),('8975','2013-12-28','10:05:00',2.51),('8975','2013-12-28','10:10:00',2.33),('8975','2013-12-28','10:15:00',2.11),('8975','2013-12-28','10:20:00',1.25),('8975','2013-12-28','10:25:00',1.05),('8975','2013-12-28','10:30:00',1.13),('8975','2013-12-28','10:35:00',1.31),('8975','2013-12-28','10:40:00',1.55),('8975','2013-12-28','10:45:00',1.39),('8975','2013-12-28','10:50:00',2.19),('8975','2013-12-28','10:55:00',1.92),('8975','2013-12-28','11:00:00',1.54),('8975','2013-12-28','11:05:00',2.14),('8975','2013-12-28','11:10:00',1.33),('8975','2013-12-28','11:15:00',1.19),('8975','2013-12-28','11:20:00',1.07),('8975','2013-12-28','11:25:00',1.13),('8975','2013-12-28','11:30:00',1.18),('8975','2013-12-28','11:50:00',1.12),('8975','2013-12-28','11:55:00',1.3),('8975','2013-12-28','12:00:00',1.21),('8975','2013-12-28','12:05:00',1.08),('8975','2013-12-28','12:10:00',1.04),('8975','2013-12-28','13:40:00',1.06),('8975','2013-12-27','08:10:00',1.06),('8975','2013-12-27','08:15:00',1.19),('8975','2013-12-27','08:20:00',1.29),('8975','2013-12-27','08:25:00',1.41),('8975','2013-12-27','08:30:00',1.55),('8975','2013-12-27','08:35:00',1.66),('8975','2013-12-27','08:40:00',1.74),('8975','2013-12-27','08:45:00',1.83),('8975','2013-12-27','08:50:00',1.9),('8975','2013-12-27','08:55:00',1.97),('8975','2013-12-27','09:00:00',2.05),('8975','2013-12-27','09:05:00',2.12),('8975','2013-12-27','09:10:00',2.19),('8975','2013-12-27','09:15:00',2.25),('8975','2013-12-27','09:20:00',2.3),('8975','2013-12-27','09:25:00',2.35),('8975','2013-12-27','09:30:00',2.42),('8975','2013-12-27','09:35:00',2.48),('8975','2013-12-27','09:40:00',2.52),('8975','2013-12-27','09:45:00',2.56),('8975','2013-12-27','09:50:00',2.62),('8975','2013-12-27','09:55:00',2.65),('8975','2013-12-27','10:00:00',2.67),('8975','2013-12-27','10:05:00',2.7),('8975','2013-12-27','10:10:00',2.74),('8975','2013-12-27','10:15:00',2.79),('8975','2013-12-27','10:20:00',2.73),('8975','2013-12-27','10:25:00',2.76),('8975','2013-12-27','10:30:00',2.82),('8975','2013-12-27','10:35:00',2.86),('8975','2013-12-27','10:40:00',2.91),('8975','2013-12-27','10:45:00',2.87),('8975','2013-12-27','10:50:00',2.8),('8975','2013-12-27','10:55:00',2.91),('8975','2013-12-27','11:00:00',2.92),('8975','2013-12-27','11:05:00',2.92),('8975','2013-12-27','11:10:00',2.93),('8975','2013-12-27','11:15:00',2.96),('8975','2013-12-27','11:20:00',2.95),('8975','2013-12-27','11:25:00',2.94),('8975','2013-12-27','11:30:00',2.91),('8975','2013-12-27','11:35:00',2.88),('8975','2013-12-27','11:40:00',2.78),('8975','2013-12-27','11:45:00',2.72),('8975','2013-12-27','11:50:00',2.67),('8975','2013-12-27','11:55:00',2.58),('8975','2013-12-27','12:00:00',2.53),('8975','2013-12-27','12:05:00',2.45),('8975','2013-12-27','12:10:00',2.43),('8975','2013-12-27','12:15:00',2.4),('8975','2013-12-27','12:20:00',2.37),('8975','2013-12-27','12:25:00',2.34),('8975','2013-12-27','12:30:00',2.24),('8975','2013-12-27','12:35:00',2.15),('8975','2013-12-27','12:40:00',2.14),('8975','2013-12-27','12:45:00',2.12),('8975','2013-12-27','12:50:00',1.98),('8975','2013-12-27','12:55:00',1.97),('8975','2013-12-27','13:00:00',1.94),('8975','2013-12-27','13:05:00',1.77),('8975','2013-12-27','13:10:00',1.76),('8975','2013-12-27','13:15:00',1.61),('8975','2013-12-27','13:20:00',1.6),('8975','2013-12-27','13:25:00',1.55),('8975','2013-12-27','13:30:00',1.49),('8975','2013-12-27','13:35:00',1.37),('8975','2013-12-27','13:40:00',1.32),('8975','2013-12-27','13:45:00',1.33),('8975','2013-12-27','13:50:00',1.31),('8975','2013-12-27','13:55:00',1.25),('8975','2013-12-27','14:00:00',1.19),('8975','2013-12-27','14:05:00',1.17),('8975','2013-12-27','14:10:00',1.1),('8975','2013-12-27','14:15:00',1.07),('8975','2013-12-27','14:20:00',1.07),('8975','2013-12-27','14:25:00',1.09),('8975','2013-12-27','14:30:00',1.09),('8975','2013-12-27','14:35:00',1.09),('8975','2013-12-27','14:40:00',1.14),('8975','2013-12-27','14:45:00',1.05),('8975','2013-12-27','15:05:00',1.05),('8975','2014-04-22','11:40:00',1.1),('8975','2014-04-22','11:45:00',1.01),('8975','2014-04-22','13:00:00',1.13),('8975','2014-04-22','13:05:00',1.49),('8975','2014-04-22','13:10:00',1.92),('8975','2014-04-22','13:15:00',2.16),('8975','2014-04-22','13:20:00',2.35),('8975','2014-04-22','13:25:00',2.35),('8975','2014-04-22','13:30:00',2.49),('8975','2014-04-22','13:35:00',2.54),('8975','2014-04-22','13:40:00',2.56),('8975','2014-04-22','13:45:00',2.46),('8975','2014-04-22','13:50:00',2.45),('8975','2014-04-22','13:55:00',2.47),('8975','2014-04-22','14:00:00',2.4),('8975','2014-04-22','14:05:00',2.39),('8975','2014-04-22','14:10:00',2.17),('8975','2014-04-22','14:15:00',1.7),('8975','2014-04-22','14:20:00',1.49),('8975','2014-04-22','14:25:00',1.38),('8975','2014-04-22','14:30:00',1.33),('8975','2014-04-22','14:35:00',1.37),('8975','2014-04-22','14:40:00',1.56),('8975','2014-04-22','14:45:00',1.9),('8975','2014-04-22','14:50:00',2.23),('8975','2014-04-22','14:55:00',2.55),('8975','2014-04-22','15:00:00',2.7),('8975','2014-04-22','15:05:00',2.73),('8975','2014-04-22','15:10:00',2.72),('8975','2014-04-22','15:15:00',2.72),('8975','2014-04-22','15:20:00',2.44),('8975','2014-04-22','15:25:00',2.27),('8975','2014-04-22','15:30:00',2),('8975','2014-04-22','15:35:00',1.9),('8975','2014-04-22','15:40:00',1.8),('8975','2014-04-22','15:45:00',1.85),('8975','2014-04-22','15:50:00',1.73),('8975','2014-04-22','15:55:00',1.64),('8975','2014-04-22','16:00:00',1.44),('8975','2014-04-22','16:05:00',1.34),('8975','2014-04-22','16:10:00',1.2),('8975','2014-04-22','16:15:00',1.07),('8975','2013-12-26','10:30:00',1.17),('8975','2013-12-26','10:35:00',1.2),('8975','2013-12-26','10:40:00',1.18),('8975','2013-12-26','10:45:00',1.09),('8975','2013-12-26','11:30:00',1.07),('8975','2013-12-26','11:35:00',1.15),('8975','2013-12-26','11:40:00',1.26),('8975','2013-12-26','11:45:00',1.31),('8975','2013-12-26','11:50:00',1.31),('8975','2013-12-26','11:55:00',1.11),('8975','2013-12-26','12:00:00',1.02),('8975','2013-12-26','12:05:00',1.37),('8975','2013-12-26','12:10:00',2.17),('8975','2013-12-26','12:15:00',2.22),('8975','2013-12-26','12:20:00',2.24),('8975','2013-12-26','12:25:00',1.9),('8975','2013-12-26','12:30:00',1.56),('8975','2013-12-26','12:35:00',1.5),('8975','2013-12-26','12:40:00',1.45),('8975','2013-12-26','12:45:00',1.68),('8975','2013-12-26','12:50:00',2.08),('8975','2013-12-26','12:55:00',2.02),('8975','2013-12-26','13:00:00',1.84),('8975','2013-12-26','13:05:00',1.48),('8975','2013-12-26','13:10:00',1.42),('8975','2013-12-26','13:15:00',1.45),('8975','2013-12-26','13:20:00',1.62),('8975','2013-12-26','13:25:00',2.03),('8975','2013-12-26','13:30:00',1.97),('8975','2013-12-26','13:35:00',2.38),('8975','2013-12-26','13:40:00',1.81),('8975','2013-12-26','13:45:00',1.52),('8975','2013-12-26','13:50:00',1.36),('8975','2013-12-26','13:55:00',1.04),('8975','2013-12-26','14:05:00',1.35),('8975','2013-12-26','14:10:00',1.32),('8975','2013-12-26','14:15:00',1.28),('8975','2013-12-26','14:20:00',1.25),('8975','2013-12-26','14:25:00',1.26),('8975','2013-12-26','14:30:00',1.35),('8975','2013-12-26','14:35:00',1.42),('8975','2013-12-26','14:40:00',1.48),('8975','2013-12-26','14:45:00',1.13),('8975','2013-12-25','11:05:00',1.03),('8975','2013-12-24','09:10:00',1.28),('8975','2013-12-24','09:15:00',2.29),('8975','2013-12-24','09:20:00',2.72),('8975','2013-12-24','09:25:00',2.14),('8975','2013-12-24','09:30:00',1.34),('8975','2013-12-24','09:35:00',1.35),('8975','2013-12-24','09:40:00',1.15),('8975','2013-12-24','09:45:00',1.21),('8975','2013-12-24','10:25:00',1.69),('8975','2013-12-24','10:30:00',2.1),('8975','2013-12-24','10:35:00',1.93),('8975','2013-12-24','10:40:00',1.85),('8975','2013-12-24','10:45:00',2.01),('8975','2013-12-24','10:50:00',1.57),('8975','2013-12-24','10:55:00',1.25),('8975','2013-12-24','11:00:00',1.25),('8975','2013-12-24','11:05:00',1.42),('8975','2013-12-24','11:10:00',1.25),('8975','2013-12-24','11:15:00',1.61),('8975','2013-12-24','11:20:00',1.87),('8975','2013-12-24','11:25:00',2.39),('8975','2013-12-24','11:30:00',2.55),('8975','2013-12-24','11:35:00',2.14),('8975','2013-12-24','11:40:00',2.25),('8975','2013-12-24','11:45:00',2.45),('8975','2013-12-24','11:50:00',2.06),('8975','2013-12-24','11:55:00',1.53),('8975','2013-12-24','12:00:00',1.96),('8975','2013-12-24','12:05:00',2.28),('8975','2013-12-24','12:10:00',1.6),('8975','2013-12-24','12:15:00',2.05),('8975','2013-12-24','12:20:00',2.51),('8975','2013-12-24','12:25:00',2.05),('8975','2013-12-24','12:30:00',1.75),('8975','2013-12-24','12:35:00',1.52),('8975','2013-12-24','12:40:00',1.23),('8975','2013-12-24','12:45:00',1.33),('8975','2013-12-24','12:50:00',1.19),('8975','2013-12-24','13:05:00',1.17),('8975','2013-12-24','13:10:00',1.2),('8975','2013-12-24','13:25:00',1.33),('8975','2013-12-24','13:30:00',1.45),('8975','2013-12-24','13:35:00',1.41),('8975','2013-12-24','13:40:00',1.52),('8975','2013-12-24','13:45:00',1.52),('8975','2013-12-24','13:50:00',1.65),('8975','2013-12-24','13:55:00',1.54),('8975','2013-12-24','14:00:00',1.35),('8975','2013-12-24','14:05:00',1.19),('8975','2013-12-24','14:10:00',1.11),('8975','2013-12-24','14:15:00',1.05),('8975','2013-12-23','08:20:00',1.12),('8975','2013-12-23','08:50:00',1.13),('8975','2013-12-23','08:55:00',1.35),('8975','2013-12-23','09:00:00',1.53),('8975','2013-12-23','09:05:00',1.71),('8975','2013-12-23','09:10:00',1.88),('8975','2013-12-23','09:15:00',2.03),('8975','2013-12-23','09:20:00',2.12),('8975','2013-12-23','09:25:00',2.13),('8975','2013-12-23','09:30:00',2.08),('8975','2013-12-23','09:35:00',1.99),('8975','2013-12-23','09:40:00',1.93),('8975','2013-12-23','09:45:00',1.96),('8975','2013-12-23','09:50:00',2.27),('8975','2013-12-23','09:55:00',2.41),('8975','2013-12-23','10:00:00',2.51),('8975','2013-12-23','10:05:00',2.5),('8975','2013-12-23','10:10:00',2.55),('8975','2013-12-23','10:15:00',2.6),('8975','2013-12-23','10:20:00',2.54),('8975','2013-12-23','10:25:00',2.52),('8975','2013-12-23','10:30:00',2.63),('8975','2013-12-23','10:35:00',2.65),('8975','2013-12-23','10:40:00',2.68),('8975','2013-12-23','10:45:00',2.72),('8975','2013-12-23','10:50:00',2.73),('8975','2013-12-23','10:55:00',2.71),('8975','2013-12-23','11:00:00',2.73),('8975','2013-12-23','11:05:00',2.71),('8975','2013-12-23','11:10:00',2.71),('8975','2013-12-23','11:15:00',2.72),('8975','2013-12-23','11:20:00',2.7),('8975','2013-12-23','11:25:00',2.68),('8975','2013-12-23','11:30:00',2.5),('8975','2013-12-23','11:35:00',2.57),('8975','2013-12-23','11:40:00',2.48),('8975','2013-12-23','11:45:00',2.56),('8975','2013-12-23','11:50:00',2.52),('8975','2013-12-23','11:55:00',2.34),('8975','2013-12-23','12:00:00',2.29),('8975','2013-12-23','12:05:00',2.18),('8975','2013-12-23','12:10:00',2.15),('8975','2013-12-23','12:15:00',2.18),('8975','2013-12-23','12:20:00',2.16),('8975','2013-12-23','12:25:00',2.08),('8975','2013-12-23','12:30:00',2.06),('8975','2013-12-23','12:35:00',1.96),('8975','2013-12-23','12:40:00',1.92),('8975','2013-12-23','12:45:00',1.91),('8975','2013-12-23','12:50:00',1.81),('8975','2013-12-23','12:55:00',1.79),('8975','2013-12-23','13:00:00',1.8),('8975','2013-12-23','13:05:00',1.67),('8975','2013-12-23','13:10:00',1.63),('8975','2013-12-23','13:15:00',1.6),('8975','2013-12-23','13:20:00',1.56),('8975','2013-12-23','13:25:00',1.49),('8975','2013-12-23','13:30:00',1.37),('8975','2013-12-23','13:35:00',1.3),('8975','2013-12-23','13:40:00',1.27),('8975','2013-12-23','13:45:00',1.28),('8975','2013-12-23','13:50:00',1.21),('8975','2013-12-23','13:55:00',1.21),('8975','2013-12-23','14:00:00',1.17),('8975','2013-12-23','14:05:00',1.12),('8975','2013-12-23','14:10:00',1.04),('8975','2013-12-23','14:15:00',1.08),('8975','2013-12-23','14:20:00',1.05),('8975','2013-12-23','14:25:00',1.03),('8975','2013-12-23','14:30:00',1),('8975','2013-12-22','09:15:00',1.01),('8975','2013-12-22','09:20:00',1.14),('8975','2013-12-22','09:25:00',1.3),('8975','2013-12-22','09:30:00',1.42),('8975','2013-12-22','09:35:00',1.51),('8975','2013-12-22','09:40:00',1.56),('8975','2013-12-22','09:45:00',1.79),('8975','2013-12-22','09:50:00',2.21),('8975','2013-12-22','09:55:00',2.37),('8975','2013-12-22','10:00:00',2.54),('8975','2013-12-22','10:05:00',2.36),('8975','2013-12-22','10:10:00',2.53),('8975','2013-12-22','10:15:00',2.89),('8975','2013-12-22','10:20:00',2.67),('8975','2013-12-22','10:25:00',2.38),('8975','2013-12-22','10:30:00',2.45),('8975','2013-12-22','10:35:00',2.7),('8975','2013-12-22','10:40:00',2.8),('8975','2013-12-22','10:45:00',2.36),('8975','2013-12-22','10:50:00',2.78),('8975','2013-12-22','10:55:00',3.12),('8975','2013-12-22','11:00:00',3.09),('8975','2013-12-22','11:05:00',3.04),('8975','2013-12-22','11:10:00',3),('8975','2013-12-22','11:15:00',3.02),('8975','2013-12-22','11:20:00',3.06),('8975','2013-12-22','11:25:00',2.98),('8975','2013-12-22','11:30:00',2.72),('8975','2013-12-22','11:35:00',2.6),('8975','2013-12-22','11:40:00',2.53),('8975','2013-12-22','11:45:00',2.39),('8975','2013-12-22','11:50:00',2.31),('8975','2013-12-22','11:55:00',2.54),('8975','2013-12-22','12:00:00',2.38),('8975','2013-12-22','12:05:00',2.3),('8975','2013-12-22','12:10:00',2.37),('8975','2013-12-22','12:15:00',2.27),('8975','2013-12-22','12:20:00',2.24),('8975','2013-12-22','12:25:00',2.18),('8975','2013-12-22','12:30:00',2.11),('8975','2013-12-22','12:35:00',2.07),('8975','2013-12-22','12:40:00',2.07),('8975','2013-12-22','12:45:00',2),('8975','2013-12-22','12:50:00',1.91),('8975','2013-12-22','12:55:00',1.92),('8975','2013-12-22','13:00:00',1.86),('8975','2013-12-22','13:05:00',1.68),('8975','2013-12-22','13:10:00',1.62),('8975','2013-12-22','13:20:00',1.14),('8975','2013-12-22','13:25:00',1.53),('8975','2013-12-22','13:30:00',1.01),('8975','2013-12-22','13:40:00',1.22),('8975','2013-12-22','13:45:00',1.26),('8975','2013-12-22','13:50:00',1.2),('8975','2013-12-22','13:55:00',1.27),('8975','2013-12-22','14:00:00',1.25),('8975','2013-12-22','14:05:00',1.17),('8975','2013-12-22','14:10:00',1.12),('8975','2013-12-22','14:15:00',1.12),('8975','2013-12-22','14:20:00',1.11),('8975','2013-12-22','14:25:00',1.04),('8975','2013-12-22','14:30:00',1.07),('8975','2013-12-22','14:35:00',1.1),('8975','2013-12-22','14:40:00',1.1),('8975','2013-12-22','14:45:00',1.07),('8975','2013-12-22','14:50:00',1.04),('8975','2013-12-22','14:55:00',1),('8975','2013-12-21','08:30:00',1.07),('8975','2013-12-21','08:35:00',1.1),('8975','2013-12-21','08:40:00',1.19),('8975','2013-12-21','08:45:00',1.2),('8975','2013-12-21','08:50:00',1.29),('8975','2013-12-21','08:55:00',1.32),('8975','2013-12-21','09:00:00',1.71),('8975','2013-12-21','09:05:00',1.82),('8975','2013-12-21','09:10:00',1.67),('8975','2013-12-21','09:15:00',1.97),('8975','2013-12-21','09:20:00',2.19),('8975','2013-12-21','09:25:00',2.02),('8975','2013-12-21','09:30:00',2.4),('8975','2013-12-21','09:35:00',3.06),('8975','2013-12-21','09:40:00',3.07),('8975','2013-12-21','09:45:00',3.27),('8975','2013-12-21','09:50:00',3.3),('8975','2013-12-21','09:55:00',3.24),('8975','2013-12-21','10:00:00',3.16),('8975','2013-12-21','10:05:00',3.17),('8975','2013-12-21','10:10:00',3.15),('8975','2013-12-21','10:15:00',3),('8975','2013-12-21','10:20:00',2.88),('8975','2013-12-21','10:25:00',2.87),('8975','2013-12-21','10:30:00',2.82),('8975','2013-12-21','10:35:00',2.63),('8975','2013-12-21','10:40:00',2.44),('8975','2013-12-21','10:45:00',2.49),('8975','2013-12-21','10:50:00',2.45),('8975','2013-12-21','10:55:00',2.31),('8975','2013-12-21','11:00:00',2.71),('8975','2013-12-21','11:05:00',3.03),('8975','2013-12-21','11:10:00',3),('8975','2013-12-21','11:15:00',2.89),('8975','2013-12-21','11:20:00',2.58),('8975','2013-12-21','11:25:00',2.64),('8975','2013-12-21','11:30:00',2.34),('8975','2013-12-21','11:35:00',2.36),('8975','2013-12-21','11:40:00',2.49),('8975','2013-12-21','11:45:00',2.22),('8975','2013-12-21','11:50:00',1.51),('8975','2013-12-21','11:55:00',1.24),('8975','2013-12-21','12:00:00',1.07),('8975','2013-12-21','12:05:00',1.04),('8975','2013-12-21','12:10:00',1.13),('8975','2013-12-21','12:15:00',1.29),('8975','2013-12-21','12:20:00',1.58),('8975','2013-12-21','12:25:00',1.75),('8975','2013-12-21','12:30:00',2.06),('8975','2013-12-21','12:35:00',2.09),('8975','2013-12-21','12:40:00',2),('8975','2013-12-21','12:45:00',2.17),('8975','2013-12-21','12:50:00',2.47),('8975','2013-12-21','12:55:00',2.75),('8975','2013-12-21','13:00:00',2.64),('8975','2013-12-21','13:05:00',2.7),('8975','2013-12-21','13:10:00',2.46),('8975','2013-12-21','13:15:00',2.03),('8975','2013-12-21','13:20:00',1.79),('8975','2013-12-21','13:25:00',1.77),('8975','2013-12-21','13:30:00',1.71),('8975','2013-12-21','13:35:00',1.52),('8975','2013-12-21','13:40:00',1.3),('8975','2013-12-21','13:45:00',1.48),('8975','2013-12-21','13:50:00',1.22),('8975','2013-12-21','13:55:00',1.25),('8975','2013-12-21','14:00:00',1.02),('8975','2013-12-21','14:05:00',1.34),('8975','2013-12-21','14:10:00',1.3),('8975','2013-12-21','14:15:00',1.15),('8975','2013-12-21','14:20:00',1.14),('8975','2013-12-21','14:25:00',1.09),('8975','2013-12-21','14:30:00',1.08),('8975','2013-12-21','14:35:00',1.17),('8975','2013-12-21','14:40:00',1.25),('8975','2013-12-21','14:45:00',1.17),('8975','2013-12-20','08:15:00',1.03),('8975','2013-12-20','08:20:00',1.17),('8975','2013-12-20','08:25:00',1.29),('8975','2013-12-20','08:30:00',1.41),('8975','2013-12-20','08:35:00',1.52),('8975','2013-12-20','08:40:00',1.62),('8975','2013-12-20','08:45:00',1.71),('8975','2013-12-20','08:50:00',1.77),('8975','2013-12-20','08:55:00',1.84),('8975','2013-12-20','09:00:00',1.9),('8975','2013-12-20','09:05:00',1.94),('8975','2013-12-20','09:10:00',2.01),('8975','2013-12-20','09:15:00',2.08),('8975','2013-12-20','09:20:00',2.15),('8975','2013-12-20','09:25:00',2.21),('8975','2013-12-20','09:30:00',2.26),('8975','2013-12-20','09:35:00',2.3),('8975','2013-12-20','09:40:00',2.37),('8975','2013-12-20','09:45:00',2.43),('8975','2013-12-20','09:50:00',2.48),('8975','2013-12-20','09:55:00',2.52),('8975','2013-12-20','10:00:00',2.55),('8975','2013-12-20','10:05:00',2.58),('8975','2013-12-20','10:10:00',2.59),('8975','2013-12-20','10:15:00',2.6),('8975','2013-12-20','10:20:00',2.57),('8975','2013-12-20','10:25:00',2.62),('8975','2013-12-20','10:30:00',2.66),('8975','2013-12-20','10:35:00',2.69),('8975','2013-12-20','10:40:00',2.74),('8975','2013-12-20','10:45:00',2.77),('8975','2013-12-20','10:50:00',2.78),('8975','2013-12-20','10:55:00',2.8),('8975','2013-12-20','11:00:00',2.81),('8975','2013-12-20','11:05:00',2.81),('8975','2013-12-20','11:10:00',2.82),('8975','2013-12-20','11:15:00',2.85),('8975','2013-12-20','11:20:00',2.86),('8975','2013-12-20','11:25:00',2.8),('8975','2013-12-20','11:30:00',2.59),('8975','2013-12-20','11:35:00',2.65),('8975','2013-12-20','11:40:00',2.62),('8975','2013-12-20','11:45:00',2.57),('8975','2013-12-20','11:50:00',2.49),('8975','2013-12-20','11:55:00',2.49),('8975','2013-12-20','12:00:00',2.46),('8975','2013-12-20','12:05:00',2.42),('8975','2013-12-20','12:10:00',2.39),('8975','2013-12-20','12:15:00',2.36),('8975','2013-12-20','12:20:00',2.32),('8975','2013-12-20','12:25:00',2.25),('8975','2013-12-20','12:30:00',2.2),('8975','2013-12-20','12:35:00',2.13),('8975','2013-12-20','12:40:00',2.14),('8975','2013-12-20','12:45:00',2.07),('8975','2013-12-20','12:50:00',2.02),('8975','2013-12-20','12:55:00',1.98),('8975','2013-12-20','13:00:00',1.83),('8975','2013-12-20','13:05:00',1.76),('8975','2013-12-20','13:10:00',1.71),('8975','2013-12-20','13:15:00',1.68),('8975','2013-12-20','13:20:00',1.61),('8975','2013-12-20','13:25:00',1.51),('8975','2013-12-20','13:30:00',1.41),('8975','2013-12-20','13:35:00',1.38),('8975','2013-12-20','13:40:00',1.32),('8975','2013-12-20','13:45:00',1.33),('8975','2013-12-20','13:50:00',1.31),('8975','2013-12-20','13:55:00',1.25),('8975','2013-12-20','14:00:00',1.18),('8975','2013-12-20','14:05:00',1.09),('8975','2013-12-20','14:10:00',1.09),('8975','2013-12-20','14:15:00',1.07),('8975','2013-12-20','14:20:00',1.03),('8975','2013-12-20','14:25:00',1.05),('8975','2013-12-20','14:30:00',1.04),('8975','2013-12-20','14:35:00',1.07),('8975','2013-12-20','14:40:00',1.09),('8975','2013-12-20','14:45:00',1.06),('8975','2013-12-20','14:50:00',1.03),('8975','2013-12-20','14:55:00',1.01),('8975','2013-12-19','08:15:00',1.13),('8975','2013-12-19','08:20:00',1.32),('8975','2013-12-19','08:25:00',1.44),('8975','2013-12-19','08:30:00',1.45),('8975','2013-12-19','08:35:00',1.57),('8975','2013-12-19','08:40:00',1.59),('8975','2013-12-19','08:45:00',1.6),('8975','2013-12-19','08:50:00',1.63),('8975','2013-12-19','08:55:00',1.74),('8975','2013-12-19','09:00:00',1.81),('8975','2013-12-19','09:05:00',1.87),('8975','2013-12-19','09:10:00',1.89),('8975','2013-12-19','09:15:00',1.99),('8975','2013-12-19','09:20:00',2.06),('8975','2013-12-19','09:25:00',2.13),('8975','2013-12-19','09:30:00',2.2),('8975','2013-12-19','09:35:00',2.23),('8975','2013-12-19','09:40:00',2.29),('8975','2013-12-19','09:45:00',2.35),('8975','2013-12-19','09:50:00',2.38),('8975','2013-12-19','09:55:00',2.43),('8975','2013-12-19','10:00:00',2.48),('8975','2013-12-19','10:05:00',2.51),('8975','2013-12-19','10:10:00',2.49),('8975','2013-12-19','10:15:00',2.53),('8975','2013-12-19','10:20:00',2.46),('8975','2013-12-19','10:25:00',2.41),('8975','2013-12-19','10:30:00',2.56),('8975','2013-12-19','10:35:00',2.63),('8975','2013-12-19','10:40:00',2.63),('8975','2013-12-19','10:45:00',2.68),('8975','2013-12-19','10:50:00',2.69),('8975','2013-12-19','10:55:00',2.7),('8975','2013-12-19','11:00:00',2.73),('8975','2013-12-19','11:05:00',2.74),('8975','2013-12-19','11:10:00',2.73),('8975','2013-12-19','11:15:00',2.75),('8975','2013-12-19','11:20:00',2.76),('8975','2013-12-19','11:25:00',2.7),('8975','2013-12-19','11:30:00',2.63),('8975','2013-12-19','11:35:00',2.48),('8975','2013-12-19','11:40:00',2.52),('8975','2013-12-19','11:45:00',2.54),('8975','2013-12-19','11:50:00',2.5),('8975','2013-12-19','11:55:00',2.32),('8975','2013-12-19','12:00:00',2.33),('8975','2013-12-19','12:05:00',2.28),('8975','2013-12-19','12:10:00',2.17),('8975','2013-12-19','12:15:00',2.25),('8975','2013-12-19','12:20:00',2.22),('8975','2013-12-19','12:25:00',2.15),('8975','2013-12-19','12:30:00',2.1),('8975','2013-12-19','12:35:00',2.02),('8975','2013-12-19','12:40:00',2.04),('8975','2013-12-19','12:45:00',1.99),('8975','2013-12-19','12:50:00',1.91),('8975','2013-12-19','12:55:00',1.83),('8975','2013-12-19','13:00:00',1.76),('8975','2013-12-19','13:05:00',1.69),('8975','2013-12-19','13:10:00',1.58),('8975','2013-12-19','13:15:00',1.57),('8975','2013-12-19','13:20:00',1.54),('8975','2013-12-19','13:25:00',1.43),('8975','2013-12-19','13:30:00',1.38),('8975','2013-12-19','13:35:00',1.33),('8975','2013-12-19','13:40:00',1.33),('8975','2013-12-19','13:45:00',1.3),('8975','2013-12-19','13:50:00',1.1),('8975','2013-12-19','13:55:00',1.17),('8975','2013-12-19','14:00:00',1.19),('8975','2013-12-19','14:05:00',1.15),('8975','2013-12-19','14:10:00',1.04),('8975','2013-12-19','14:15:00',1.13),('8975','2013-12-19','14:20:00',1.11),('8975','2013-12-19','14:35:00',1.15),('8975','2013-12-19','14:40:00',1.23),('8975','2013-12-18','08:40:00',1),('8975','2013-12-18','08:45:00',1.27),('8975','2013-12-18','08:50:00',1.67),('8975','2013-12-18','08:55:00',1.82),('8975','2013-12-18','09:00:00',2.01),('8975','2013-12-18','09:05:00',2),('8975','2013-12-18','09:10:00',1.9),('8975','2013-12-18','09:15:00',2.51),('8975','2013-12-18','09:20:00',2.33),('8975','2013-12-18','09:25:00',1.94),('8975','2013-12-18','09:30:00',2.61),('8975','2013-12-18','09:35:00',2.23),('8975','2013-12-18','09:40:00',1.49),('8975','2013-12-18','09:45:00',2.49),('8975','2013-12-18','09:50:00',3.22),('8975','2013-12-18','09:55:00',3.02),('8975','2013-12-18','10:00:00',2.61),('8975','2013-12-18','10:05:00',2.58),('8975','2013-12-18','10:10:00',2.64),('8975','2013-12-18','10:15:00',2.2),('8975','2013-12-18','10:20:00',1.28),('8975','2013-12-18','10:25:00',1.49),('8975','2013-12-18','10:30:00',1.34),('8975','2013-12-18','10:35:00',1.55),('8975','2013-12-18','10:40:00',1.8),('8975','2013-12-18','10:45:00',2.83),('8975','2013-12-18','10:50:00',1.81),('8975','2013-12-18','10:55:00',1.01),('8975','2013-12-18','11:10:00',2.24),('8975','2013-12-18','11:15:00',1.47),('8975','2013-12-18','11:20:00',1.27),('8975','2013-12-18','12:20:00',1.26),('8975','2013-12-18','12:25:00',1.16),('8975','2013-12-18','12:30:00',1.05),('8975','2013-12-18','12:35:00',1.01),('8975','2013-12-18','12:40:00',1.03),('8975','2013-12-18','14:00:00',1.1),('8975','2013-12-18','14:05:00',1.09),('8975','2013-12-18','14:15:00',1.08),('8975','2013-12-18','14:20:00',1.27),('8975','2013-12-18','14:25:00',1.59),('8975','2013-12-18','14:30:00',1.22),('8975','2013-12-18','14:35:00',1.12),('8975','2013-12-18','14:40:00',1.06),('8975','2013-12-17','08:05:00',1),('8975','2013-12-17','08:10:00',1.12),('8975','2013-12-17','08:15:00',1.24),('8975','2013-12-17','08:20:00',1.37),('8975','2013-12-17','08:25:00',1.47),('8975','2013-12-17','08:30:00',1.55),('8975','2013-12-17','08:35:00',1.65),('8975','2013-12-17','08:40:00',1.73),('8975','2013-12-17','08:45:00',1.81),('8975','2013-12-17','08:50:00',1.88),('8975','2013-12-17','08:55:00',1.95),('8975','2013-12-17','09:00:00',2.01),('8975','2013-12-17','09:05:00',2.08),('8975','2013-12-17','09:10:00',2.14),('8975','2013-12-17','09:15:00',2.21),('8975','2013-12-17','09:20:00',2.25),('8975','2013-12-17','09:25:00',2.3),('8975','2013-12-17','09:30:00',2.34),('8975','2013-12-17','09:35:00',2.38),('8975','2013-12-17','09:40:00',2.42),('8975','2013-12-17','09:45:00',2.48),('8975','2013-12-17','09:50:00',2.53),('8975','2013-12-17','09:55:00',2.56),('8975','2013-12-17','10:00:00',2.59),('8975','2013-12-17','10:05:00',2.63),('8975','2013-12-17','10:10:00',2.64),('8975','2013-12-17','10:15:00',2.6),('8975','2013-12-17','10:20:00',2.65),('8975','2013-12-17','10:25:00',2.7),('8975','2013-12-17','10:30:00',2.76),('8975','2013-12-17','10:35:00',2.79),('8975','2013-12-17','10:40:00',2.77),('8975','2013-12-17','10:45:00',2.71),('8975','2013-12-17','10:50:00',2.85),('8975','2013-12-17','10:55:00',2.86),('8975','2013-12-17','11:00:00',2.85),('8975','2013-12-17','11:05:00',2.87),('8975','2013-12-17','11:10:00',2.88),('8975','2013-12-17','11:15:00',2.89),('8975','2013-12-17','11:20:00',2.88),('8975','2013-12-17','11:25:00',2.75),('8975','2013-12-17','11:30:00',2.64),('8975','2013-12-17','11:35:00',2.66),('8975','2013-12-17','11:40:00',2.59),('8975','2013-12-17','11:45:00',2.55),('8975','2013-12-17','11:50:00',2.51),('8975','2013-12-17','11:55:00',2.4),('8975','2013-12-17','12:00:00',2.31),('8975','2013-12-17','12:05:00',2.39),('8975','2013-12-17','12:10:00',2.34),('8975','2013-12-17','12:15:00',2.24),('8975','2013-12-17','12:20:00',2.26),('8975','2013-12-17','12:25:00',2.18),('8975','2013-12-17','12:30:00',2.08),('8975','2013-12-17','12:35:00',2.1),('8975','2013-12-17','12:40:00',2.08),('8975','2013-12-17','12:45:00',1.95),('8975','2013-12-17','12:50:00',1.98),('8975','2013-12-17','12:55:00',1.92),('8975','2013-12-17','13:00:00',1.76),('8975','2013-12-17','13:05:00',1.74),('8975','2013-12-17','13:10:00',1.67),('8975','2013-12-17','13:15:00',1.62),('8975','2013-12-17','13:20:00',1.56),('8975','2013-12-17','13:25:00',1.48),('8975','2013-12-17','13:30:00',1.36),('8975','2013-12-17','13:35:00',1.39),('8975','2013-12-17','13:40:00',1.36),('8975','2013-12-17','13:45:00',1.33),('8975','2013-12-17','13:50:00',1.28),('8975','2013-12-17','13:55:00',1.22),('8975','2013-12-17','14:00:00',1.14),('8975','2013-12-17','14:05:00',1.09),('8975','2013-12-17','14:10:00',1.09),('8975','2013-12-17','14:15:00',1.08),('8975','2013-12-17','14:20:00',1.06),('8975','2013-12-17','14:25:00',1.07),('8975','2013-12-17','14:30:00',1.07),('8975','2013-12-17','14:35:00',1.1),('8975','2013-12-17','14:40:00',1.09),('8975','2013-12-17','14:45:00',1.07),('8975','2013-12-17','14:50:00',1.05),('8975','2013-12-17','14:55:00',1.02),('8975','2014-04-21','07:05:00',1.07),('8975','2014-04-21','07:10:00',1.29),('8975','2014-04-21','07:15:00',1.48),('8975','2014-04-21','07:20:00',1.69),('8975','2014-04-21','07:25:00',1.84),('8975','2014-04-21','07:30:00',2.02),('8975','2014-04-21','07:35:00',2.2),('8975','2014-04-21','07:40:00',2.34),('8975','2014-04-21','07:45:00',2.46),('8975','2014-04-21','07:50:00',2.58),('8975','2014-04-21','07:55:00',2.71),('8975','2014-04-21','08:00:00',2.85),('8975','2014-04-21','08:05:00',2.97),('8975','2014-04-21','08:10:00',3.15),('8975','2014-04-21','08:15:00',3.26),('8975','2014-04-21','08:20:00',3.34),('8975','2014-04-21','08:25:00',3.44),('8975','2014-04-21','08:30:00',3.6),('8975','2014-04-21','08:35:00',3.69),('8975','2014-04-21','08:40:00',3.8),('8975','2014-04-21','08:45:00',3.8),('8975','2014-04-21','08:50:00',3.97),('8975','2014-04-21','08:55:00',3.96),('8975','2014-04-21','09:00:00',4.06),('8975','2014-04-21','09:05:00',4.45),('8975','2014-04-21','09:10:00',4.21),('8975','2014-04-21','09:15:00',4.04),('8975','2014-04-21','09:20:00',4.28),('8975','2014-04-21','09:25:00',4.94),('8975','2014-04-21','09:30:00',4.49),('8975','2014-04-21','09:35:00',4.79),('8975','2014-04-21','09:40:00',4.84),('8975','2014-04-21','09:45:00',5.15),('8975','2014-04-21','09:50:00',3.71),('8975','2014-04-21','09:55:00',2.28),('8975','2014-04-21','10:00:00',2.23),('8975','2014-04-21','10:05:00',2.32),('8975','2014-04-21','10:10:00',3.13),('8975','2014-04-21','10:15:00',4.63),('8975','2014-04-21','10:20:00',4.79),('8975','2014-04-21','10:25:00',3.24),('8975','2014-04-21','10:30:00',6.57),('8975','2014-04-21','10:35:00',6.27),('8975','2014-04-21','10:40:00',6.11),('8975','2014-04-21','10:45:00',5.6),('8975','2014-04-21','10:50:00',6.2),('8975','2014-04-21','10:55:00',3.89),('8975','2014-04-21','11:00:00',4.5),('8975','2014-04-21','11:05:00',3.96),('8975','2014-04-21','11:10:00',2.65),('8975','2014-04-21','11:15:00',2.26),('8975','2014-04-21','11:20:00',1.96),('8975','2014-04-21','11:25:00',2.13),('8975','2014-04-21','11:30:00',1.94),('8975','2014-04-21','11:35:00',1.95),('8975','2014-04-21','11:40:00',1.66),('8975','2014-04-21','11:45:00',1.44),('8975','2014-04-21','11:50:00',1.45),('8975','2014-04-21','11:55:00',1.34),('8975','2014-04-21','12:00:00',1.54),('8975','2014-04-21','12:05:00',1.81),('8975','2014-04-21','12:10:00',1.86),('8975','2014-04-21','12:15:00',1.65),('8975','2014-04-21','12:20:00',2.03),('8975','2014-04-21','12:25:00',1.86),('8975','2014-04-21','12:30:00',2.51),('8975','2014-04-21','12:35:00',1.93),('8975','2014-04-21','12:40:00',1.47),('8975','2014-04-21','12:45:00',1.25),('8975','2014-04-21','12:50:00',1.18),('8975','2014-04-21','13:00:00',1),('8975','2014-04-21','13:05:00',1.03),('8975','2014-04-21','13:10:00',1.24),('8975','2014-04-21','13:15:00',2.38),('8975','2014-04-21','13:20:00',3.48),('8975','2014-04-21','13:25:00',3.9),('8975','2014-04-21','13:30:00',4.22),('8975','2014-04-21','13:35:00',4.17),('8975','2014-04-21','13:40:00',5.1),('8975','2014-04-21','13:45:00',5.26),('8975','2014-04-21','13:50:00',3.7),('8975','2014-04-21','13:55:00',2.46),('8975','2014-04-21','14:00:00',2.17),('8975','2014-04-21','14:05:00',2.72),('8975','2014-04-21','14:10:00',4.8),('8975','2014-04-21','14:15:00',4.36),('8975','2014-04-21','14:20:00',6.07),('8975','2014-04-21','14:25:00',3.65),('8975','2014-04-21','14:30:00',3.7),('8975','2014-04-21','14:35:00',4.61),('8975','2014-04-21','14:40:00',5.35),('8975','2014-04-21','14:45:00',5.54),('8975','2014-04-21','14:50:00',3.77),('8975','2014-04-21','14:55:00',3.04),('8975','2014-04-21','15:00:00',2.01),('8975','2014-04-21','15:05:00',2),('8975','2014-04-21','15:10:00',1.78),('8975','2014-04-21','15:15:00',1.74),('8975','2014-04-21','15:20:00',1.89),('8975','2014-04-21','15:25:00',2.29),('8975','2014-04-21','15:30:00',2.94),('8975','2014-04-21','15:35:00',3.93),('8975','2014-04-21','15:40:00',2.98),('8975','2014-04-21','15:45:00',2.5),('8975','2014-04-21','15:50:00',3.03),('8975','2014-04-21','15:55:00',2.59),('8975','2014-04-21','16:00:00',2.89),('8975','2014-04-21','16:05:00',2.28),('8975','2014-04-21','16:10:00',2.12),('8975','2014-04-21','16:15:00',2.11),('8975','2014-04-21','16:20:00',2.38),('8975','2014-04-21','16:25:00',2.25),('8975','2014-04-21','16:30:00',1.92),('8975','2014-04-21','16:35:00',1.82),('8975','2014-04-21','16:40:00',2.15),('8975','2014-04-21','16:45:00',2.59),('8975','2014-04-21','16:50:00',1.98),('8975','2014-04-21','16:55:00',1.69),('8975','2014-04-21','17:00:00',1.85),('8975','2014-04-21','17:05:00',2.15),('8975','2014-04-21','17:10:00',1.67),('8975','2014-04-21','17:15:00',1.49),('8975','2014-04-21','17:20:00',1.15),('8975','2014-04-21','17:25:00',1),('8975','2014-04-21','17:35:00',1.03),('8975','2014-04-21','17:40:00',1.08),('8975','2014-04-21','17:45:00',1),('8975','2013-12-16','08:05:00',1.12),('8975','2013-12-16','08:10:00',1.23),('8975','2013-12-16','08:15:00',1.35),('8975','2013-12-16','08:20:00',1.47),('8975','2013-12-16','08:25:00',1.57),('8975','2013-12-16','08:30:00',1.67),('8975','2013-12-16','08:35:00',1.77),('8975','2013-12-16','08:40:00',1.86),('8975','2013-12-16','08:45:00',1.93),('8975','2013-12-16','08:50:00',2.02),('8975','2013-12-16','08:55:00',2.07),('8975','2013-12-16','09:00:00',2.13),('8975','2013-12-16','09:05:00',2.2),('8975','2013-12-16','09:10:00',2.24),('8975','2013-12-16','09:15:00',2.32),('8975','2013-12-16','09:20:00',2.38),('8975','2013-12-16','09:25:00',2.42),('8975','2013-12-16','09:30:00',2.44),('8975','2013-12-16','09:35:00',2.49),('8975','2013-12-16','09:40:00',2.55),('8975','2013-12-16','09:45:00',2.59),('8975','2013-12-16','09:50:00',2.64),('8975','2013-12-16','09:55:00',2.67),('8975','2013-12-16','10:00:00',2.68),('8975','2013-12-16','10:05:00',2.73),('8975','2013-12-16','10:10:00',2.74),('8975','2013-12-16','10:15:00',2.69),('8975','2013-12-16','10:20:00',2.76),('8975','2013-12-16','10:25:00',2.77),('8975','2013-12-16','10:30:00',2.81),('8975','2013-12-16','10:35:00',2.85),('8975','2013-12-16','10:40:00',2.83),('8975','2013-12-16','10:45:00',2.8),('8975','2013-12-16','10:50:00',2.92),('8975','2013-12-16','10:55:00',2.94),('8975','2013-12-16','11:00:00',2.92),('8975','2013-12-16','11:05:00',2.91),('8975','2013-12-16','11:10:00',2.92),('8975','2013-12-16','11:15:00',2.92),('8975','2013-12-16','11:20:00',2.91),('8975','2013-12-16','11:25:00',2.76),('8975','2013-12-16','11:30:00',2.76),('8975','2013-12-16','11:35:00',2.72),('8975','2013-12-16','11:40:00',2.63),('8975','2013-12-16','11:45:00',2.55),('8975','2013-12-16','11:50:00',2.55),('8975','2013-12-16','11:55:00',2.46),('8975','2013-12-16','12:00:00',2.46),('8975','2013-12-16','12:05:00',2.46),('8975','2013-12-16','12:10:00',2.43),('8975','2013-12-16','12:15:00',2.38),('8975','2013-12-16','12:20:00',2.36),('8975','2013-12-16','12:25:00',2.26),('8975','2013-12-16','12:30:00',2.2),('8975','2013-12-16','12:35:00',2.2),('8975','2013-12-16','12:40:00',2.16),('8975','2013-12-16','12:45:00',2.03),('8975','2013-12-16','12:50:00',2.07),('8975','2013-12-16','12:55:00',1.97),('8975','2013-12-16','13:00:00',1.8),('8975','2013-12-16','13:05:00',1.8),('8975','2013-12-16','13:10:00',1.73),('8975','2013-12-16','13:15:00',1.7),('8975','2013-12-16','13:20:00',1.62),('8975','2013-12-16','13:25:00',1.52),('8975','2013-12-16','13:30:00',1.43),('8975','2013-12-16','13:35:00',1.41),('8975','2013-12-16','13:40:00',1.37),('8975','2013-12-16','13:45:00',1.33),('8975','2013-12-16','13:50:00',1.3),('8975','2013-12-16','13:55:00',1.23),('8975','2013-12-16','14:00:00',1.17),('8975','2013-12-16','14:05:00',1.13),('8975','2013-12-16','14:10:00',1.11),('8975','2013-12-16','14:15:00',1.08),('8975','2013-12-16','14:20:00',1.08),('8975','2013-12-16','14:25:00',1.07),('8975','2013-12-16','14:30:00',1.07),('8975','2013-12-16','14:35:00',1.12),('8975','2013-12-16','14:40:00',1.1),('8975','2013-12-16','14:45:00',1.08),('8975','2013-12-16','14:50:00',1.07),('8975','2013-12-16','14:55:00',1.04),('8975','2013-12-16','15:00:00',1.02),('8975','2013-12-15','08:05:00',1.11),('8975','2013-12-15','08:10:00',1.22),('8975','2013-12-15','08:15:00',1.34),('8975','2013-12-15','08:20:00',1.46),('8975','2013-12-15','08:25:00',1.57),('8975','2013-12-15','08:30:00',1.67),('8975','2013-12-15','08:35:00',1.76),('8975','2013-12-15','08:40:00',1.84),('8975','2013-12-15','08:45:00',1.91),('8975','2013-12-15','08:50:00',1.97),('8975','2013-12-15','08:55:00',2.04),('8975','2013-12-15','09:00:00',2.11),('8975','2013-12-15','09:05:00',2.17),('8975','2013-12-15','09:10:00',2.22),('8975','2013-12-15','09:15:00',2.27),('8975','2013-12-15','09:20:00',2.31),('8975','2013-12-15','09:25:00',2.35),('8975','2013-12-15','09:30:00',2.38),('8975','2013-12-15','09:35:00',2.43),('8975','2013-12-15','09:40:00',2.49),('8975','2013-12-15','09:45:00',2.53),('8975','2013-12-15','09:50:00',2.55),('8975','2013-12-15','09:55:00',2.58),('8975','2013-12-15','10:00:00',2.6),('8975','2013-12-15','10:05:00',2.64),('8975','2013-12-15','10:10:00',2.66),('8975','2013-12-15','10:15:00',2.59),('8975','2013-12-15','10:20:00',2.68),('8975','2013-12-15','10:25:00',2.71),('8975','2013-12-15','10:30:00',2.74),('8975','2013-12-15','10:35:00',2.81),('8975','2013-12-15','10:40:00',2.76),('8975','2013-12-15','10:45:00',2.77),('8975','2013-12-15','10:50:00',2.88),('8975','2013-12-15','10:55:00',2.88),('8975','2013-12-15','11:00:00',2.89),('8975','2013-12-15','11:05:00',2.88),('8975','2013-12-15','11:10:00',2.9),('8975','2013-12-15','11:15:00',2.89),('8975','2013-12-15','11:20:00',2.87),('8975','2013-12-15','11:25:00',2.7),('8975','2013-12-15','11:30:00',2.75),('8975','2013-12-15','11:35:00',2.75),('8975','2013-12-15','11:40:00',2.67),('8975','2013-12-15','11:45:00',2.61),('8975','2013-12-15','11:50:00',2.59),('8975','2013-12-15','11:55:00',2.4),('8975','2013-12-15','12:00:00',2.39),('8975','2013-12-15','12:05:00',2.47),('8975','2013-12-15','12:10:00',2.43),('8975','2013-12-15','12:15:00',2.37),('8975','2013-12-15','12:20:00',2.34),('8975','2013-12-15','12:25:00',2.23),('8975','2013-12-15','12:30:00',2.18),('8975','2013-12-15','12:35:00',2.18),('8975','2013-12-15','12:40:00',2.14),('8975','2013-12-15','12:45:00',2),('8975','2013-12-15','12:50:00',2.03),('8975','2013-12-15','12:55:00',1.95),('8975','2013-12-15','13:00:00',1.78),('8975','2013-12-15','13:05:00',1.76),('8975','2013-12-15','13:10:00',1.73),('8975','2013-12-15','13:15:00',1.67),('8975','2013-12-15','13:20:00',1.63),('8975','2013-12-15','13:25:00',1.51),('8975','2013-12-15','13:30:00',1.42),('8975','2013-12-15','13:35:00',1.42),('8975','2013-12-15','13:40:00',1.39),('8975','2013-12-15','13:45:00',1.37),('8975','2013-12-15','13:50:00',1.31),('8975','2013-12-15','13:55:00',1.26),('8975','2013-12-15','14:00:00',1.21),('8975','2013-12-15','14:05:00',1.14),('8975','2013-12-15','14:10:00',1.12),('8975','2013-12-15','14:15:00',1.08),('8975','2013-12-15','14:20:00',1.09),('8975','2013-12-15','14:25:00',1.08),('8975','2013-12-15','14:30:00',1.09),('8975','2013-12-15','14:35:00',1.14),('8975','2013-12-15','14:40:00',1.11),('8975','2013-12-15','14:45:00',1.08),('8975','2013-12-15','14:50:00',1.04),('8975','2013-12-15','14:55:00',1),('8975','2013-12-14','09:50:00',1.07),('8975','2013-12-14','09:55:00',1.13),('8975','2013-12-14','10:00:00',1.13),('8975','2013-12-14','10:05:00',1.18),('8975','2013-12-14','10:10:00',1.28),('8975','2013-12-14','10:15:00',1.36),('8975','2013-12-14','10:20:00',1.7),('8975','2013-12-14','10:25:00',1.83),('8975','2013-12-14','10:30:00',1.56),('8975','2013-12-14','10:35:00',1.56),('8975','2013-12-14','10:40:00',1.59),('8975','2013-12-14','10:45:00',1.74),('8975','2013-12-14','10:50:00',1.62),('8975','2013-12-14','10:55:00',1.45),('8975','2013-12-14','11:00:00',1.36),('8975','2013-12-14','11:05:00',1.29),('8975','2013-12-14','11:10:00',1.18),('8975','2013-12-14','11:15:00',1.19),('8975','2013-12-14','11:20:00',1.3),('8975','2013-12-14','11:25:00',1.28),('8975','2013-12-14','11:30:00',1.28),('8975','2013-12-14','11:35:00',1.33),('8975','2013-12-14','11:40:00',1.36),('8975','2013-12-14','11:45:00',1.37),('8975','2013-12-14','11:50:00',1.43),('8975','2013-12-14','11:55:00',1.46),('8975','2013-12-14','12:00:00',1.37),('8975','2013-12-14','12:05:00',1.43),('8975','2013-12-14','12:10:00',1.37),('8975','2013-12-14','12:15:00',1.3),('8975','2013-12-14','12:20:00',1.33),('8975','2013-12-14','12:25:00',1.09),('8975','2013-12-14','12:45:00',1.05),('8975','2013-12-14','12:50:00',1.11),('8975','2013-12-13','08:10:00',1.08),('8975','2013-12-13','08:15:00',1.19),('8975','2013-12-13','08:20:00',1.31),('8975','2013-12-13','08:25:00',1.42),('8975','2013-12-13','08:30:00',1.52),('8975','2013-12-13','08:35:00',1.62),('8975','2013-12-13','08:40:00',1.72),('8975','2013-12-13','08:45:00',1.79),('8975','2013-12-13','08:50:00',1.85),('8975','2013-12-13','08:55:00',1.9),('8975','2013-12-13','09:00:00',1.99),('8975','2013-12-13','09:05:00',2.07),('8975','2013-12-13','09:10:00',2.15),('8975','2013-12-13','09:15:00',2.21),('8975','2013-12-13','09:20:00',2.29),('8975','2013-12-13','09:25:00',2.33),('8975','2013-12-13','09:30:00',2.38),('8975','2013-12-13','09:35:00',2.44),('8975','2013-12-13','09:40:00',2.5),('8975','2013-12-13','09:45:00',2.55),('8975','2013-12-13','09:50:00',2.56),('8975','2013-12-13','09:55:00',2.58),('8975','2013-12-13','10:00:00',2.61),('8975','2013-12-13','10:05:00',2.66),('8975','2013-12-13','10:10:00',2.71),('8975','2013-12-13','10:15:00',2.25),('8975','2013-12-13','10:20:00',2.73),('8975','2013-12-13','10:25:00',2.76),('8975','2013-12-13','10:30:00',2.81),('8975','2013-12-13','10:35:00',2.83),('8975','2013-12-13','10:40:00',2.77),('8975','2013-12-13','10:45:00',2.75),('8975','2013-12-13','10:50:00',2.84),('8975','2013-12-13','10:55:00',2.85),('8975','2013-12-13','11:00:00',2.85),('8975','2013-12-13','11:05:00',2.87),('8975','2013-12-13','11:10:00',2.88),('8975','2013-12-13','11:15:00',2.86),('8975','2013-12-13','11:20:00',2.88),('8975','2013-12-13','11:25:00',2.83),('8975','2013-12-13','11:30:00',2.73),('8975','2013-12-13','11:35:00',2.66),('8975','2013-12-13','11:40:00',2.61),('8975','2013-12-13','11:45:00',2.55),('8975','2013-12-13','11:50:00',2.46),('8975','2013-12-13','11:55:00',2.3),('8975','2013-12-13','12:00:00',2.31),('8975','2013-12-13','12:05:00',2.31),('8975','2013-12-13','12:10:00',2.31),('8975','2013-12-13','12:15:00',2.24),('8975','2013-12-13','12:20:00',2.24),('8975','2013-12-13','12:25:00',2.18),('8975','2013-12-13','12:30:00',2.17),('8975','2013-12-13','12:35:00',2.21),('8975','2013-12-13','12:40:00',2.15),('8975','2013-12-13','12:45:00',2.01),('8975','2013-12-13','12:50:00',2.02),('8975','2013-12-13','12:55:00',1.96),('8975','2013-12-13','13:00:00',1.78),('8975','2013-12-13','13:05:00',1.8),('8975','2013-12-13','13:10:00',1.65),('8975','2013-12-13','13:15:00',1.63),('8975','2013-12-13','13:20:00',1.62),('8975','2013-12-13','13:25:00',1.51),('8975','2013-12-13','13:30:00',1.42),('8975','2013-12-13','13:35:00',1.43),('8975','2013-12-13','13:40:00',1.4),('8975','2013-12-13','13:45:00',1.37),('8975','2013-12-13','13:50:00',1.3),('8975','2013-12-13','13:55:00',1.24),('8975','2013-12-13','14:00:00',1.18),('8975','2013-12-13','14:05:00',1.11),('8975','2013-12-13','14:20:00',1.12),('8975','2013-12-13','14:25:00',1.09),('8975','2013-12-13','14:30:00',1.07),('8975','2013-12-13','14:35:00',1.11),('8975','2013-12-13','14:40:00',1.09),('8975','2013-12-13','14:45:00',1.07),('8975','2013-12-13','14:50:00',1.05),('8975','2013-12-13','14:55:00',1.05),('8975','2013-12-13','15:00:00',1.02),('8975','2013-12-12','08:15:00',1.03),('8975','2013-12-12','08:20:00',1.14),('8975','2013-12-12','08:25:00',1.26),('8975','2013-12-12','08:30:00',1.36),('8975','2013-12-12','08:35:00',1.47),('8975','2013-12-12','08:40:00',1.57),('8975','2013-12-12','08:45:00',1.66),('8975','2013-12-12','08:50:00',1.73),('8975','2013-12-12','08:55:00',1.8),('8975','2013-12-12','09:00:00',1.86),('8975','2013-12-12','09:05:00',1.95),('8975','2013-12-12','09:10:00',2.03),('8975','2013-12-12','09:15:00',2.07),('8975','2013-12-12','09:20:00',2.12),('8975','2013-12-12','09:25:00',2.18),('8975','2013-12-12','09:30:00',2.22),('8975','2013-12-12','09:35:00',2.27),('8975','2013-12-12','09:40:00',2.34),('8975','2013-12-12','09:45:00',2.4),('8975','2013-12-12','09:50:00',2.43),('8975','2013-12-12','09:55:00',2.45),('8975','2013-12-12','10:00:00',2.49),('8975','2013-12-12','10:05:00',2.54),('8975','2013-12-12','10:10:00',2.54),('8975','2013-12-12','10:15:00',2.48),('8975','2013-12-12','10:20:00',2.51),('8975','2013-12-12','10:25:00',2.54),('8975','2013-12-12','10:30:00',2.58),('8975','2013-12-12','10:35:00',2.62),('8975','2013-12-12','10:40:00',2.62),('8975','2013-12-12','10:45:00',2.58),('8975','2013-12-12','10:50:00',2.66),('8975','2013-12-12','10:55:00',2.71),('8975','2013-12-12','11:00:00',2.7),('8975','2013-12-12','11:05:00',2.73),('8975','2013-12-12','11:10:00',2.73),('8975','2013-12-12','11:15:00',2.74),('8975','2013-12-12','11:20:00',2.71),('8975','2013-12-12','11:25:00',2.66),('8975','2013-12-12','11:30:00',2.64),('8975','2013-12-12','11:35:00',2.65),('8975','2013-12-12','11:40:00',2.61),('8975','2013-12-12','11:45:00',2.55),('8975','2013-12-12','11:50:00',2.5),('8975','2013-12-12','11:55:00',2.33),('8975','2013-12-12','12:00:00',2.32),('8975','2013-12-12','12:05:00',2.37),('8975','2013-12-12','12:10:00',2.27),('8975','2013-12-12','12:15:00',2.14),('8975','2013-12-12','12:20:00',2.29),('8975','2013-12-12','12:25:00',2.03),('8975','2013-12-12','12:30:00',1.96),('8975','2013-12-12','12:35:00',2.07),('8975','2013-12-12','12:40:00',2.09),('8975','2013-12-12','12:45:00',2.02),('8975','2013-12-12','12:50:00',2),('8975','2013-12-12','12:55:00',1.88),('8975','2013-12-12','13:00:00',1.79),('8975','2013-12-12','13:05:00',1.77),('8975','2013-12-12','13:10:00',1.71),('8975','2013-12-12','13:15:00',1.64),('8975','2013-12-12','13:20:00',1.64),('8975','2013-12-12','13:25:00',1.48),('8975','2013-12-12','13:30:00',1.42),('8975','2013-12-12','13:35:00',1.41),('8975','2013-12-12','13:40:00',1.4),('8975','2013-12-12','13:45:00',1.41),('8975','2013-12-12','13:50:00',1.35),('8975','2013-12-12','13:55:00',1.3),('8975','2013-12-12','14:00:00',1.22),('8975','2013-12-12','14:05:00',1.17),('8975','2013-12-12','14:10:00',1.04),('8975','2013-12-12','14:20:00',1.13),('8975','2013-12-12','14:25:00',1.12),('8975','2013-12-12','14:30:00',1.13),('8975','2013-12-12','14:35:00',1.17),('8975','2013-12-12','14:40:00',1.09),('8975','2013-12-12','14:45:00',1.04),('8975','2013-12-12','14:50:00',1.02),('8975','2013-12-11','08:10:00',1.06),('8975','2013-12-11','08:15:00',1.16),('8975','2013-12-11','08:20:00',1.3),('8975','2013-12-11','08:25:00',1.42),('8975','2013-12-11','08:30:00',1.51),('8975','2013-12-11','08:35:00',1.61),('8975','2013-12-11','08:40:00',1.7),('8975','2013-12-11','08:45:00',1.79),('8975','2013-12-11','08:50:00',1.88),('8975','2013-12-11','08:55:00',1.96),('8975','2013-12-11','09:00:00',2.02),('8975','2013-12-11','09:05:00',2.09),('8975','2013-12-11','09:10:00',2.15),('8975','2013-12-11','09:15:00',2.21),('8975','2013-12-11','09:20:00',2.26),('8975','2013-12-11','09:25:00',2.32),('8975','2013-12-11','09:30:00',2.35),('8975','2013-12-11','09:35:00',2.42),('8975','2013-12-11','09:40:00',2.5),('8975','2013-12-11','09:45:00',2.53),('8975','2013-12-11','09:50:00',2.57),('8975','2013-12-11','09:55:00',2.58),('8975','2013-12-11','10:00:00',2.61),('8975','2013-12-11','10:05:00',2.65),('8975','2013-12-11','10:10:00',2.66),('8975','2013-12-11','10:15:00',2.61),('8975','2013-12-11','10:20:00',2.72),('8975','2013-12-11','10:25:00',2.75),('8975','2013-12-11','10:30:00',2.8),('8975','2013-12-11','10:35:00',2.82),('8975','2013-12-11','10:40:00',2.78),('8975','2013-12-11','10:45:00',2.78),('8975','2013-12-11','10:50:00',2.84),('8975','2013-12-11','10:55:00',2.83),('8975','2013-12-11','11:00:00',2.85),('8975','2013-12-11','11:05:00',2.85),('8975','2013-12-11','11:10:00',2.84),('8975','2013-12-11','11:15:00',2.81),('8975','2013-12-11','11:20:00',2.78),('8975','2013-12-11','11:25:00',2.78),('8975','2013-12-11','11:30:00',2.75),('8975','2013-12-11','11:35:00',2.7),('8975','2013-12-11','11:40:00',2.62),('8975','2013-12-11','11:45:00',2.55),('8975','2013-12-11','11:50:00',2.5),('8975','2013-12-11','11:55:00',2.32),('8975','2013-12-11','12:00:00',2.31),('8975','2013-12-11','12:05:00',2.39),('8975','2013-12-11','12:10:00',2.37),('8975','2013-12-11','12:15:00',2.33),('8975','2013-12-11','12:20:00',2.3),('8975','2013-12-11','12:25:00',2.23),('8975','2013-12-11','12:30:00',2.13),('8975','2013-12-11','12:35:00',2.15),('8975','2013-12-11','12:40:00',2.08),('8975','2013-12-11','12:45:00',1.98),('8975','2013-12-11','12:50:00',1.96),('8975','2013-12-11','12:55:00',1.85),('8975','2013-12-11','13:00:00',1.71),('8975','2013-12-11','13:05:00',1.73),('8975','2013-12-11','13:10:00',1.62),('8975','2013-12-11','13:15:00',1.65),('8975','2013-12-11','13:20:00',1.59),('8975','2013-12-11','13:25:00',1.49),('8975','2013-12-11','13:30:00',1.39),('8975','2013-12-11','13:35:00',1.41),('8975','2013-12-11','13:40:00',1.38),('8975','2013-12-11','13:45:00',1.36),('8975','2013-12-11','13:50:00',1.29),('8975','2013-12-11','13:55:00',1.25),('8975','2013-12-11','14:00:00',1.2),('8975','2013-12-11','14:05:00',1.14),('8975','2013-12-11','14:10:00',1.05),('8975','2013-12-11','14:20:00',1.1),('8975','2013-12-11','14:25:00',1.08),('8975','2013-12-11','14:30:00',1.09),('8975','2013-12-11','14:35:00',1.11),('8975','2013-12-11','14:40:00',1.1),('8975','2013-12-11','14:45:00',1.07),('8975','2013-12-11','14:50:00',1.04),('8975','2013-12-11','14:55:00',1.01),('8975','2013-12-10','08:10:00',1.1),('8975','2013-12-10','08:15:00',1.09),('8975','2013-12-10','08:20:00',1.31),('8975','2013-12-10','08:25:00',1.44),('8975','2013-12-10','08:30:00',1.53),('8975','2013-12-10','08:35:00',1.65),('8975','2013-12-10','08:40:00',1.75),('8975','2013-12-10','08:45:00',1.8),('8975','2013-12-10','08:50:00',1.88),('8975','2013-12-10','08:55:00',1.91),('8975','2013-12-10','09:00:00',2.02),('8975','2013-12-10','09:05:00',2.12),('8975','2013-12-10','09:10:00',2.19),('8975','2013-12-10','09:15:00',2.23),('8975','2013-12-10','09:20:00',2.3),('8975','2013-12-10','09:25:00',2.37),('8975','2013-12-10','09:30:00',2.42),('8975','2013-12-10','09:35:00',2.48),('8975','2013-12-10','09:40:00',2.54),('8975','2013-12-10','09:45:00',2.59),('8975','2013-12-10','09:50:00',2.63),('8975','2013-12-10','09:55:00',2.62),('8975','2013-12-10','10:00:00',2.67),('8975','2013-12-10','10:05:00',2.68),('8975','2013-12-10','10:10:00',2.69),('8975','2013-12-10','10:15:00',2.67),('8975','2013-12-10','10:20:00',2.78),('8975','2013-12-10','10:25:00',2.8),('8975','2013-12-10','10:30:00',2.85),('8975','2013-12-10','10:35:00',2.84),('8975','2013-12-10','10:40:00',2.8),('8975','2013-12-10','10:45:00',2.84),('8975','2013-12-10','10:50:00',2.85),('8975','2013-12-10','10:55:00',2.86),('8975','2013-12-10','11:00:00',2.9),('8975','2013-12-10','11:05:00',2.89),('8975','2013-12-10','11:10:00',2.96),('8975','2013-12-10','11:15:00',2.94),('8975','2013-12-10','11:20:00',2.92),('8975','2013-12-10','11:25:00',2.84),('8975','2013-12-10','11:30:00',2.81),('8975','2013-12-10','11:35:00',2.74),('8975','2013-12-10','11:40:00',2.69),('8975','2013-12-10','11:45:00',2.64),('8975','2013-12-10','11:50:00',2.56),('8975','2013-12-10','11:55:00',2.47),('8975','2013-12-10','12:00:00',2.46),('8975','2013-12-10','12:05:00',2.42),('8975','2013-12-10','12:10:00',2.4),('8975','2013-12-10','12:15:00',2.37),('8975','2013-12-10','12:20:00',2.33),('8975','2013-12-10','12:25:00',2.25),('8975','2013-12-10','12:30:00',2.23),('8975','2013-12-10','12:35:00',2.2),('8975','2013-12-10','12:40:00',2.19),('8975','2013-12-10','12:45:00',2.09),('8975','2013-12-10','12:50:00',2.05),('8975','2013-12-10','12:55:00',1.93),('8975','2013-12-10','13:00:00',1.89),('8975','2013-12-10','13:05:00',1.82),('8975','2013-12-10','13:10:00',1.76),('8975','2013-12-10','13:15:00',1.69),('8975','2013-12-10','13:20:00',1.65),('8975','2013-12-10','13:25:00',1.53),('8975','2013-12-10','13:30:00',1.47),('8975','2013-12-10','13:35:00',1.42),('8975','2013-12-10','13:40:00',1.38),('8975','2013-12-10','13:45:00',1.36),('8975','2013-12-10','13:50:00',1.29),('8975','2013-12-10','13:55:00',1.24),('8975','2013-12-10','14:00:00',1.2),('8975','2013-12-10','14:05:00',1.15),('8975','2013-12-10','14:10:00',1.05),('8975','2013-12-10','14:20:00',1.1),('8975','2013-12-10','14:25:00',1.1),('8975','2013-12-10','14:30:00',1.1),('8975','2013-12-10','14:35:00',1.13),('8975','2013-12-10','14:40:00',1.1),('8975','2013-12-10','14:45:00',1.06),('8975','2013-12-10','14:50:00',1.06),('8975','2013-12-10','14:55:00',1.03),('8975','2013-12-09','08:05:00',1.11),('8975','2013-12-09','08:10:00',1.22),('8975','2013-12-09','08:15:00',1.34),('8975','2013-12-09','08:20:00',1.47),('8975','2013-12-09','08:25:00',1.58),('8975','2013-12-09','08:30:00',1.66),('8975','2013-12-09','08:35:00',1.75),('8975','2013-12-09','08:40:00',1.81),('8975','2013-12-09','08:45:00',1.89),('8975','2013-12-09','08:50:00',1.96),('8975','2013-12-09','08:55:00',2.04),('8975','2013-12-09','09:00:00',2.12),('8975','2013-12-09','09:05:00',2.19),('8975','2013-12-09','09:10:00',2.26),('8975','2013-12-09','09:15:00',2.32),('8975','2013-12-09','09:20:00',2.36),('8975','2013-12-09','09:25:00',2.39),('8975','2013-12-09','09:30:00',2.43),('8975','2013-12-09','09:35:00',2.47),('8975','2013-12-09','09:40:00',2.58),('8975','2013-12-09','09:45:00',2.61),('8975','2013-12-09','09:50:00',2.63),('8975','2013-12-09','09:55:00',2.66),('8975','2013-12-09','10:00:00',2.71),('8975','2013-12-09','10:05:00',2.75),('8975','2013-12-09','10:10:00',2.7),('8975','2013-12-09','10:15:00',2.71),('8975','2013-12-09','10:20:00',2.81),('8975','2013-12-09','10:25:00',2.87),('8975','2013-12-09','10:30:00',2.92),('8975','2013-12-09','10:35:00',2.92),('8975','2013-12-09','10:40:00',2.89),('8975','2013-12-09','10:45:00',2.93),('8975','2013-12-09','10:50:00',2.94),('8975','2013-12-09','10:55:00',2.97),('8975','2013-12-09','11:00:00',2.97),('8975','2013-12-09','11:05:00',2.98),('8975','2013-12-09','11:10:00',2.97),('8975','2013-12-09','11:15:00',2.96),('8975','2013-12-09','11:20:00',2.94),('8975','2013-12-09','11:25:00',2.89),('8975','2013-12-09','11:30:00',2.88),('8975','2013-12-09','11:35:00',2.69),('8975','2013-12-09','11:40:00',2.75),('8975','2013-12-09','11:45:00',2.71),('8975','2013-12-09','11:50:00',2.57),('8975','2013-12-09','11:55:00',2.43),('8975','2013-12-09','12:00:00',2.53),('8975','2013-12-09','12:05:00',2.54),('8975','2013-12-09','12:10:00',2.48),('8975','2013-12-09','12:15:00',2.44),('8975','2013-12-09','12:20:00',2.39),('8975','2013-12-09','12:25:00',2.26),('8975','2013-12-09','12:30:00',2.22),('8975','2013-12-09','12:35:00',2.19),('8975','2013-12-09','12:40:00',2.16),('8975','2013-12-09','12:45:00',2.08),('8975','2013-12-09','12:50:00',2.05),('8975','2013-12-09','12:55:00',1.91),('8975','2013-12-09','13:00:00',1.88),('8975','2013-12-09','13:05:00',1.74),('8975','2013-12-09','13:10:00',1.68),('8975','2013-12-09','13:15:00',1.65),('8975','2013-12-09','13:20:00',1.6),('8975','2013-12-09','13:25:00',1.43),('8975','2013-12-09','13:30:00',1.47),('8975','2013-12-09','13:35:00',1.42),('8975','2013-12-09','13:40:00',1.36),('8975','2013-12-09','13:45:00',1.37),('8975','2013-12-09','13:50:00',1.3),('8975','2013-12-09','13:55:00',1.26),('8975','2013-12-09','14:00:00',1.21),('8975','2013-12-09','14:05:00',1.17),('8975','2013-12-09','14:10:00',1.09),('8975','2013-12-09','14:15:00',1.04),('8975','2013-12-09','14:20:00',1.1),('8975','2013-12-09','14:25:00',1.09),('8975','2013-12-09','14:30:00',1.1),('8975','2013-12-09','14:35:00',1.15),('8975','2013-12-09','14:40:00',1.12),('8975','2013-12-09','14:45:00',1.08),('8975','2013-12-09','14:50:00',1.07),('8975','2013-12-09','14:55:00',1.05),('8975','2013-12-09','15:00:00',1.02),('8975','2013-12-09','15:05:00',1),('8975','2013-12-08','09:30:00',1.58),('8975','2013-12-08','09:35:00',2.45),('8975','2013-12-08','09:40:00',2.52),('8975','2013-12-08','09:45:00',2.57),('8975','2013-12-08','09:50:00',2.59),('8975','2013-12-08','09:55:00',2.65),('8975','2013-12-08','10:00:00',2.74),('8975','2013-12-08','10:05:00',2.84),('8975','2013-12-08','10:10:00',3.13),('8975','2013-12-08','10:15:00',3.5),('8975','2013-12-08','10:20:00',3.82),('8975','2013-12-08','10:25:00',2.73),('8975','2013-12-08','10:30:00',1.27),('8975','2013-12-08','10:35:00',1.09),('8975','2013-12-08','12:00:00',1.07),('8975','2013-12-08','12:05:00',1.04),('8975','2013-12-08','12:10:00',1.06),('8975','2013-12-08','12:15:00',1.09),('8975','2013-12-08','12:20:00',1.23),('8975','2013-12-08','12:25:00',1.65),('8975','2013-12-08','12:30:00',1.85),('8975','2013-12-08','12:35:00',1.39),('8975','2013-12-08','12:40:00',1.53),('8975','2013-12-08','12:45:00',1.89),('8975','2013-12-08','12:50:00',1.7),('8975','2013-12-08','12:55:00',2.06),('8975','2013-12-08','13:00:00',1.39),('8975','2013-12-08','13:05:00',1.4),('8975','2013-12-08','13:10:00',1.37),('8975','2013-12-08','13:15:00',1.92),('8975','2013-12-08','13:20:00',2.11),('8975','2013-12-08','13:25:00',1.81),('8975','2013-12-08','13:30:00',1.11),('8975','2013-12-08','13:40:00',1.01),('8975','2013-12-08','13:45:00',1.21),('8975','2013-12-08','13:50:00',1.45),('8975','2013-12-08','13:55:00',1.54),('8975','2013-12-08','14:00:00',1.38),('8975','2013-12-08','14:05:00',1.08),('8975','2013-12-07','09:15:00',1),('8975','2013-12-07','09:20:00',1.03),('8975','2013-12-07','09:25:00',1.02),('8975','2013-12-07','09:30:00',1.1),('8975','2013-12-07','09:35:00',1.28),('8975','2013-12-07','09:40:00',1.35),('8975','2013-12-07','09:45:00',1.41),('8975','2013-12-07','09:50:00',1.7),('8975','2013-12-07','09:55:00',1.59),('8975','2013-12-07','10:00:00',1.55),('8975','2013-12-07','10:05:00',1.57),('8975','2013-12-07','10:10:00',1.56),('8975','2013-12-07','10:15:00',1.6),('8975','2013-12-07','10:20:00',1.52),('8975','2013-12-07','10:25:00',1.58),('8975','2013-12-07','10:30:00',1.61),('8975','2013-12-07','10:35:00',1.78),('8975','2013-12-07','10:40:00',2.03),('8975','2013-12-07','10:45:00',1.95),('8975','2013-12-07','10:50:00',1.9),('8975','2013-12-07','10:55:00',2.35),('8975','2013-12-07','11:00:00',2.05),('8975','2013-12-07','11:05:00',2.1),('8975','2013-12-07','11:10:00',2.35),('8975','2013-12-07','11:15:00',3.25),('8975','2013-12-07','11:20:00',2.62),('8975','2013-12-07','11:25:00',1.78),('8975','2013-12-07','11:30:00',1.36),('8975','2013-12-07','11:35:00',1.2),('8975','2013-12-07','11:40:00',1.19),('8975','2013-12-07','11:45:00',1.17),('8975','2013-12-07','11:50:00',1.14),('8975','2013-12-07','11:55:00',1.11),('8975','2013-12-07','12:00:00',1.12),('8975','2013-12-07','12:05:00',1.08),('8975','2013-12-07','12:55:00',1.26),('8975','2013-12-07','13:00:00',1.39),('8975','2013-12-07','13:05:00',1.41),('8975','2013-12-07','13:10:00',1.31),('8975','2013-12-07','13:15:00',1.32),('8975','2013-12-07','13:20:00',1.15),('8975','2013-12-07','13:25:00',1.07),('8975','2013-12-07','15:25:00',1.04),('8975','2013-12-07','15:30:00',1.07),('8975','2014-04-20','08:25:00',1.01),('8975','2014-04-20','08:30:00',1.31),('8975','2014-04-20','08:35:00',1.31),('8975','2014-04-20','08:40:00',1.37),('8975','2014-04-20','08:45:00',1.3),('8975','2014-04-20','08:50:00',1.27),('8975','2014-04-20','08:55:00',1.24),('8975','2014-04-20','09:00:00',1.4),('8975','2014-04-20','09:05:00',1.45),('8975','2014-04-20','09:10:00',1.51),('8975','2014-04-20','09:15:00',1.53),('8975','2014-04-20','09:20:00',2.18),('8975','2014-04-20','09:25:00',1.44),('8975','2014-04-20','09:40:00',1.15),('8975','2014-04-20','09:45:00',1.34),('8975','2014-04-20','09:50:00',1.55),('8975','2014-04-20','09:55:00',1.93),('8975','2014-04-20','10:00:00',4.03),('8975','2014-04-20','10:05:00',6.35),('8975','2014-04-20','10:10:00',6.41),('8975','2014-04-20','10:15:00',5.69),('8975','2014-04-20','10:20:00',5.64),('8975','2014-04-20','10:25:00',5.66),('8975','2014-04-20','10:30:00',5.66),('8975','2014-04-20','10:35:00',5.65),('8975','2014-04-20','10:40:00',5.71),('8975','2014-04-20','10:45:00',5.77),('8975','2014-04-20','10:50:00',5.83),('8975','2014-04-20','10:55:00',5.86),('8975','2014-04-20','11:00:00',5.91),('8975','2014-04-20','11:05:00',5.94),('8975','2014-04-20','11:10:00',5.92),('8975','2014-04-20','11:15:00',6.01),('8975','2014-04-20','11:20:00',6.04),('8975','2014-04-20','11:25:00',6.05),('8975','2014-04-20','11:30:00',6.1),('8975','2014-04-20','11:35:00',6.11),('8975','2014-04-20','11:40:00',6.19),('8975','2014-04-20','11:45:00',6.2),('8975','2014-04-20','11:50:00',6.22),('8975','2014-04-20','11:55:00',6.21),('8975','2014-04-20','12:00:00',6.26),('8975','2014-04-20','12:05:00',6.29),('8975','2014-04-20','12:10:00',6.31),('8975','2014-04-20','12:15:00',6.32),('8975','2014-04-20','12:20:00',6.34),('8975','2014-04-20','12:25:00',6.34),('8975','2014-04-20','12:30:00',6.36),('8975','2014-04-20','12:35:00',6.34),('8975','2014-04-20','12:40:00',6.34),('8975','2014-04-20','12:45:00',6.32),('8975','2014-04-20','12:50:00',6.31),('8975','2014-04-20','12:55:00',6.28),('8975','2014-04-20','13:00:00',6.25),('8975','2014-04-20','13:05:00',6.25),('8975','2014-04-20','13:10:00',6.21),('8975','2014-04-20','13:15:00',6.19),('8975','2014-04-20','13:20:00',6.18),('8975','2014-04-20','13:25:00',6.12),('8975','2014-04-20','13:30:00',6.08),('8975','2014-04-20','13:35:00',6.07),('8975','2014-04-20','13:40:00',6.04),('8975','2014-04-20','13:45:00',6.01),('8975','2014-04-20','13:50:00',5.99),('8975','2014-04-20','13:55:00',5.96),('8975','2014-04-20','14:00:00',5.91),('8975','2014-04-20','14:05:00',5.85),('8975','2014-04-20','14:10:00',5.8),('8975','2014-04-20','14:15:00',5.72),('8975','2014-04-20','14:20:00',5.66),('8975','2014-04-20','14:25:00',5.59),('8975','2014-04-20','14:30:00',5.53),('8975','2014-04-20','14:35:00',5.48),('8975','2014-04-20','14:40:00',5.33),('8975','2014-04-20','14:45:00',5.28),('8975','2014-04-20','14:50:00',5.21),('8975','2014-04-20','14:55:00',5.12),('8975','2014-04-20','15:00:00',5.02),('8975','2014-04-20','15:05:00',4.93),('8975','2014-04-20','15:10:00',4.81),('8975','2014-04-20','15:15:00',4.73),('8975','2014-04-20','15:20:00',4.64),('8975','2014-04-20','15:25:00',4.54),('8975','2014-04-20','15:30:00',4.43),('8975','2014-04-20','15:35:00',4.22),('8975','2014-04-20','15:40:00',4.18),('8975','2014-04-20','15:45:00',4.1),('8975','2014-04-20','15:50:00',3.99),('8975','2014-04-20','15:55:00',3.9),('8975','2014-04-20','16:00:00',3.8),('8975','2014-04-20','16:05:00',3.7),('8975','2014-04-20','16:10:00',3.6),('8975','2014-04-20','16:15:00',3.71),('8975','2014-04-20','16:20:00',3.42),('8975','2014-04-20','16:25:00',3.24),('8975','2014-04-20','16:30:00',3.15),('8975','2014-04-20','16:35:00',3.03),('8975','2014-04-20','16:40:00',2.91),('8975','2014-04-20','16:45:00',2.81),('8975','2014-04-20','16:50:00',2.65),('8975','2014-04-20','16:55:00',2.26),('8975','2014-04-20','17:00:00',1.91),('8975','2014-04-20','17:05:00',1.76),('8975','2014-04-20','17:10:00',2.16),('8975','2014-04-20','17:15:00',1.93),('8975','2014-04-20','17:20:00',1.97),('8975','2014-04-20','17:25:00',1.79),('8975','2014-04-20','17:30:00',1.8),('8975','2014-04-20','17:35:00',1.44),('8975','2014-04-20','17:40:00',1.64),('8975','2014-04-20','17:45:00',1.48),('8975','2014-04-20','17:50:00',1.28),('8975','2014-04-20','17:55:00',1.34),('8975','2014-04-20','18:00:00',1.44),('8975','2014-04-20','18:05:00',1.31),('8975','2014-04-20','18:10:00',1.35),('8975','2014-04-20','18:15:00',1.3),('8975','2014-04-20','18:20:00',1.25),('8975','2014-04-20','18:25:00',1.2),('8975','2014-04-20','18:30:00',1.13),('8975','2014-04-20','18:35:00',1.06),('8975','2014-04-20','18:40:00',1),('8975','2013-12-06','08:00:00',1.08),('8975','2013-12-06','08:05:00',1.2),('8975','2013-12-06','08:10:00',1.31),('8975','2013-12-06','08:15:00',1.42),('8975','2013-12-06','08:20:00',1.54),('8975','2013-12-06','08:25:00',1.64),('8975','2013-12-06','08:30:00',1.74),('8975','2013-12-06','08:35:00',1.84),('8975','2013-12-06','08:40:00',1.89),('8975','2013-12-06','08:45:00',1.96),('8975','2013-12-06','08:50:00',2),('8975','2013-12-06','08:55:00',2.08),('8975','2013-12-06','09:00:00',2.17),('8975','2013-12-06','09:05:00',2.24),('8975','2013-12-06','09:10:00',2.31),('8975','2013-12-06','09:15:00',2.38),('8975','2013-12-06','09:20:00',2.41),('8975','2013-12-06','09:25:00',2.45),('8975','2013-12-06','09:30:00',2.49),('8975','2013-12-06','09:35:00',2.53),('8975','2013-12-06','09:40:00',2.59),('8975','2013-12-06','09:45:00',2.62),('8975','2013-12-06','09:50:00',2.65),('8975','2013-12-06','09:55:00',2.66),('8975','2013-12-06','10:00:00',2.69),('8975','2013-12-06','10:05:00',2.72),('8975','2013-12-06','10:10:00',2.71),('8975','2013-12-06','10:15:00',2.76),('8975','2013-12-06','10:20:00',2.8),('8975','2013-12-06','10:25:00',2.82),('8975','2013-12-06','10:30:00',2.86),('8975','2013-12-06','10:35:00',2.9),('8975','2013-12-06','10:40:00',2.87),('8975','2013-12-06','10:45:00',2.92),('8975','2013-12-06','10:50:00',2.95),('8975','2013-12-06','10:55:00',2.93),('8975','2013-12-06','11:00:00',2.94),('8975','2013-12-06','11:05:00',2.93),('8975','2013-12-06','11:10:00',2.92),('8975','2013-12-06','11:15:00',2.9),('8975','2013-12-06','11:20:00',2.84),('8975','2013-12-06','11:25:00',2.73),('8975','2013-12-06','11:30:00',2.78),('8975','2013-12-06','11:35:00',2.62),('8975','2013-12-06','11:40:00',2.52),('8975','2013-12-06','11:45:00',2.61),('8975','2013-12-06','11:50:00',2.45),('8975','2013-12-06','11:55:00',2.42),('8975','2013-12-06','12:00:00',2.48),('8975','2013-12-06','12:05:00',2.42),('8975','2013-12-06','12:10:00',2.39),('8975','2013-12-06','12:15:00',2.39),('8975','2013-12-06','12:20:00',2.31),('8975','2013-12-06','12:25:00',2.22),('8975','2013-12-06','12:30:00',2.2),('8975','2013-12-06','12:35:00',2.17),('8975','2013-12-06','12:40:00',2.14),('8975','2013-12-06','12:45:00',2.1),('8975','2013-12-06','12:50:00',2.02),('8975','2013-12-06','12:55:00',1.93),('8975','2013-12-06','13:00:00',1.9),('8975','2013-12-06','13:05:00',1.78),('8975','2013-12-06','13:10:00',1.74),('8975','2013-12-06','13:15:00',1.73),('8975','2013-12-06','13:20:00',1.62),('8975','2013-12-06','13:25:00',1.53),('8975','2013-12-06','13:30:00',1.53),('8975','2013-12-06','13:35:00',1.48),('8975','2013-12-06','13:40:00',1.43),('8975','2013-12-06','13:45:00',1.41),('8975','2013-12-06','13:50:00',1.33),('8975','2013-12-06','13:55:00',1.28),('8975','2013-12-06','14:00:00',1.24),('8975','2013-12-06','14:05:00',1.24),('8975','2013-12-06','14:10:00',1.2),('8975','2013-12-06','14:15:00',1.12),('8975','2013-12-06','14:30:00',1.13),('8975','2013-12-06','14:35:00',1.14),('8975','2013-12-06','14:40:00',1.11),('8975','2013-12-06','14:45:00',1.11),('8975','2013-12-06','14:50:00',1.06),('8975','2013-12-06','14:55:00',1.03),('8975','2013-12-06','15:00:00',1.01),('8975','2013-12-05','09:45:00',1.08),('8975','2013-12-05','09:50:00',1.04),('8975','2013-12-05','09:55:00',1.04),('8975','2013-12-05','10:00:00',1.14),('8975','2013-12-05','10:05:00',1.38),('8975','2013-12-05','10:10:00',1.53),('8975','2013-12-05','10:15:00',1.73),('8975','2013-12-05','10:20:00',1.41),('8975','2013-12-05','10:25:00',1.23),('8975','2013-12-05','10:30:00',1.09),('8975','2013-12-05','10:50:00',1.09),('8975','2013-12-05','10:55:00',1.11),('8975','2013-12-05','11:00:00',1.32),('8975','2013-12-05','11:05:00',1.4),('8975','2013-12-05','11:10:00',1.35),('8975','2013-12-05','11:15:00',1.3),('8975','2013-12-05','11:20:00',1.37),('8975','2013-12-05','11:25:00',1.47),('8975','2013-12-05','11:30:00',1.49),('8975','2013-12-05','11:35:00',1.71),('8975','2013-12-05','11:40:00',1.95),('8975','2013-12-05','11:45:00',2.16),('8975','2013-12-05','11:50:00',2.36),('8975','2013-12-05','11:55:00',2.29),('8975','2013-12-05','12:00:00',2.42),('8975','2013-12-05','12:05:00',2.2),('8975','2013-12-05','12:10:00',2.06),('8975','2013-12-05','12:15:00',2.32),('8975','2013-12-05','12:20:00',2.19),('8975','2013-12-05','12:25:00',2.07),('8975','2013-12-05','12:30:00',1.78),('8975','2013-12-05','12:35:00',1.76),('8975','2013-12-05','12:40:00',2.47),('8975','2013-12-05','12:45:00',2.48),('8975','2013-12-05','12:50:00',1.57),('8975','2013-12-05','12:55:00',1.34),('8975','2013-12-05','13:00:00',1.3),('8975','2013-12-05','13:05:00',1.19),('8975','2013-12-05','13:10:00',1.07),('8975','2013-12-05','13:25:00',1.11),('8975','2013-12-05','13:30:00',1.23),('8975','2013-12-05','13:35:00',1.31),('8975','2013-12-05','13:40:00',1.42),('8975','2013-12-05','13:45:00',1.39),('8975','2013-12-05','13:50:00',1.38),('8975','2013-12-05','13:55:00',1.27),('8975','2013-12-05','14:00:00',1.15),('8975','2013-12-05','14:05:00',1.05),('8975','2013-12-05','14:10:00',1.07),('8975','2013-12-05','14:15:00',1.04),('8975','2013-12-05','14:20:00',1.01),('8975','2013-12-05','14:25:00',1.12),('8975','2013-12-05','14:30:00',1.05),('8975','2013-12-05','14:35:00',1.04),('8975','2013-12-05','14:40:00',1.05),('8975','2013-12-05','14:45:00',1.06),('8975','2013-12-04','08:00:00',1.13),('8975','2013-12-04','08:05:00',1.26),('8975','2013-12-04','08:10:00',1.36),('8975','2013-12-04','08:15:00',1.48),('8975','2013-12-04','08:20:00',1.59),('8975','2013-12-04','08:25:00',1.68),('8975','2013-12-04','08:30:00',1.78),('8975','2013-12-04','08:35:00',1.88),('8975','2013-12-04','08:40:00',1.97),('8975','2013-12-04','08:45:00',2.05),('8975','2013-12-04','08:50:00',2.13),('8975','2013-12-04','08:55:00',2.21),('8975','2013-12-04','09:00:00',2.27),('8975','2013-12-04','09:05:00',2.32),('8975','2013-12-04','09:10:00',2.4),('8975','2013-12-04','09:15:00',2.44),('8975','2013-12-04','09:20:00',2.5),('8975','2013-12-04','09:25:00',2.56),('8975','2013-12-04','09:30:00',2.61),('8975','2013-12-04','09:35:00',2.65),('8975','2013-12-04','09:40:00',2.69),('8975','2013-12-04','09:45:00',2.71),('8975','2013-12-04','09:50:00',2.73),('8975','2013-12-04','09:55:00',2.8),('8975','2013-12-04','10:00:00',2.83),('8975','2013-12-04','10:05:00',2.87),('8975','2013-12-04','10:10:00',2.85),('8975','2013-12-04','10:15:00',2.9),('8975','2013-12-04','10:20:00',2.92),('8975','2013-12-04','10:25:00',3.01),('8975','2013-12-04','10:30:00',3),('8975','2013-12-04','10:35:00',3.05),('8975','2013-12-04','10:40:00',3.02),('8975','2013-12-04','10:45:00',3.04),('8975','2013-12-04','10:50:00',3.04),('8975','2013-12-04','10:55:00',3.03),('8975','2013-12-04','11:00:00',3.03),('8975','2013-12-04','11:05:00',3.05),('8975','2013-12-04','11:10:00',3),('8975','2013-12-04','11:15:00',3.07),('8975','2013-12-04','11:20:00',2.97),('8975','2013-12-04','11:25:00',2.98),('8975','2013-12-04','11:30:00',2.91),('8975','2013-12-04','11:35:00',2.76),('8975','2013-12-04','11:40:00',2.72),('8975','2013-12-04','11:45:00',2.64),('8975','2013-12-04','11:50:00',2.63),('8975','2013-12-04','11:55:00',2.56),('8975','2013-12-04','12:00:00',2.59),('8975','2013-12-04','12:05:00',2.53),('8975','2013-12-04','12:10:00',2.51),('8975','2013-12-04','12:15:00',2.49),('8975','2013-12-04','12:20:00',2.42),('8975','2013-12-04','12:25:00',2.31),('8975','2013-12-04','12:30:00',2.22),('8975','2013-12-04','12:35:00',1.31),('8975','2013-12-04','12:40:00',1.51),('8975','2013-12-04','12:45:00',1.91),('8975','2013-12-04','12:50:00',1.89),('8975','2013-12-04','12:55:00',2.04),('8975','2013-12-04','13:00:00',1.19),('8975','2013-12-04','13:05:00',1.07),('8975','2013-12-04','13:10:00',1.4),('8975','2013-12-04','13:25:00',1.34),('8975','2013-12-04','13:30:00',1.63),('8975','2013-12-04','13:35:00',1.53),('8975','2013-12-04','13:40:00',1.34),('8975','2013-12-04','13:45:00',1.45),('8975','2013-12-04','13:50:00',1.41),('8975','2013-12-04','13:55:00',1.33),('8975','2013-12-04','14:00:00',1.3),('8975','2013-12-04','14:05:00',1.27),('8975','2013-12-04','14:10:00',1.23),('8975','2013-12-04','14:15:00',1.21),('8975','2013-12-04','14:20:00',1.11),('8975','2013-12-04','14:25:00',1.06),('8975','2013-12-04','14:30:00',1.16),('8975','2013-12-04','14:35:00',1.13),('8975','2013-12-04','14:40:00',1.14),('8975','2013-12-04','14:45:00',1.13),('8975','2013-12-04','14:50:00',1.1),('8975','2013-12-04','14:55:00',1.07),('8975','2013-12-04','15:00:00',1.03),('8975','2013-12-03','08:00:00',1.39),('8975','2013-12-03','08:05:00',1.5),('8975','2013-12-03','08:10:00',1.59),('8975','2013-12-03','08:15:00',1.69),('8975','2013-12-03','08:20:00',1.8),('8975','2013-12-03','08:25:00',1.89),('8975','2013-12-03','08:30:00',1.98),('8975','2013-12-03','08:35:00',2.06),('8975','2013-12-03','08:40:00',2.14),('8975','2013-12-03','08:45:00',2.21),('8975','2013-12-03','08:50:00',2.27),('8975','2013-12-03','08:55:00',2.34),('8975','2013-12-03','09:00:00',2.4),('8975','2013-12-03','09:05:00',2.46),('8975','2013-12-03','09:10:00',2.52),('8975','2013-12-03','09:15:00',2.58),('8975','2013-12-03','09:20:00',2.63),('8975','2013-12-03','09:25:00',2.71),('8975','2013-12-03','09:30:00',2.77),('8975','2013-12-03','09:35:00',2.8),('8975','2013-12-03','09:40:00',2.82),('8975','2013-12-03','09:45:00',2.84),('8975','2013-12-03','09:50:00',2.87),('8975','2013-12-03','09:55:00',2.9),('8975','2013-12-03','10:00:00',2.92),('8975','2013-12-03','10:05:00',2.97),('8975','2013-12-03','10:10:00',3),('8975','2013-12-03','10:15:00',3.05),('8975','2013-12-03','10:20:00',3.11),('8975','2013-12-03','10:25:00',3.14),('8975','2013-12-03','10:30:00',3.14),('8975','2013-12-03','10:35:00',3.15),('8975','2013-12-03','10:40:00',3.16),('8975','2013-12-03','10:45:00',3.2),('8975','2013-12-03','10:50:00',3.18),('8975','2013-12-03','10:55:00',3.16),('8975','2013-12-03','11:00:00',3.17),('8975','2013-12-03','11:05:00',3.19),('8975','2013-12-03','11:10:00',3.18),('8975','2013-12-03','11:15:00',3.17),('8975','2013-12-03','11:20:00',3.1),('8975','2013-12-03','11:25:00',3.11),('8975','2013-12-03','11:30:00',3.03),('8975','2013-12-03','11:35:00',2.88),('8975','2013-12-03','11:40:00',2.96),('8975','2013-12-03','11:45:00',2.9),('8975','2013-12-03','11:50:00',2.79),('8975','2013-12-03','11:55:00',2.81),('8975','2013-12-03','12:00:00',2.75),('8975','2013-12-03','12:05:00',2.68),('8975','2013-12-03','12:10:00',2.69),('8975','2013-12-03','12:15:00',2.66),('8975','2013-12-03','12:20:00',2.54),('8975','2013-12-03','12:25:00',2.51),('8975','2013-12-03','12:30:00',2.41),('8975','2013-12-03','12:35:00',2.45),('8975','2013-12-03','12:40:00',2.43),('8975','2013-12-03','12:45:00',2.32),('8975','2013-12-03','12:50:00',2.21),('8975','2013-12-03','12:55:00',2.19),('8975','2013-12-03','13:00:00',2.13),('8975','2013-12-03','13:05:00',2.06),('8975','2013-12-03','13:10:00',1.99),('8975','2013-12-03','13:15:00',1.92),('8975','2013-12-03','13:20:00',1.82),('8975','2013-12-03','13:25:00',1.72),('8975','2013-12-03','13:30:00',1.7),('8975','2013-12-03','13:35:00',1.65),('8975','2013-12-03','13:40:00',1.6),('8975','2013-12-03','13:45:00',1.56),('8975','2013-12-03','13:50:00',1.49),('8975','2013-12-03','13:55:00',1.46),('8975','2013-12-03','14:00:00',1.4),('8975','2013-12-03','14:05:00',1.32),('8975','2013-12-03','14:10:00',1.24),('8975','2013-12-03','14:15:00',1.18),('8975','2013-12-03','14:20:00',1.11),('8975','2013-12-03','14:25:00',1.14),('8975','2013-12-03','14:30:00',1.17),('8975','2013-12-03','14:35:00',1.2),('8975','2013-12-03','14:40:00',1.19),('8975','2013-12-03','14:45:00',1.17),('8975','2013-12-03','14:50:00',1.14),('8975','2013-12-03','14:55:00',1.11),('8975','2013-12-03','15:00:00',1.08),('8975','2013-12-03','15:05:00',1.05),('8975','2013-12-03','15:10:00',1.01),('8975','2013-12-02','09:25:00',1.33),('8975','2013-12-02','09:30:00',1.36),('8975','2013-12-02','09:35:00',1.36),('8975','2013-12-02','09:45:00',1.61),('8975','2013-12-02','09:50:00',1.7),('8975','2013-12-02','09:55:00',1.77),('8975','2013-12-02','10:00:00',2),('8975','2013-12-02','10:05:00',2.1),('8975','2013-12-02','10:10:00',2.11),('8975','2013-12-02','10:15:00',2.15),('8975','2013-12-02','10:20:00',2.2),('8975','2013-12-02','10:25:00',2.23),('8975','2013-12-02','10:30:00',2.27),('8975','2013-12-02','10:35:00',2.3),('8975','2013-12-02','10:40:00',2.31),('8975','2013-12-02','10:45:00',2.33),('8975','2013-12-02','10:50:00',2.35),('8975','2013-12-02','10:55:00',2.37),('8975','2013-12-02','11:00:00',2.38),('8975','2013-12-02','11:05:00',2.4),('8975','2013-12-02','11:10:00',2.42),('8975','2013-12-02','11:15:00',2.43),('8975','2013-12-02','11:20:00',2.36),('8975','2013-12-02','11:25:00',2.34),('8975','2013-12-02','11:30:00',2.27),('8975','2013-12-02','11:35:00',2.27),('8975','2013-12-02','11:40:00',2.26),('8975','2013-12-02','11:45:00',2.2),('8975','2013-12-02','11:50:00',2.21),('8975','2013-12-02','11:55:00',2.18),('8975','2013-12-02','12:00:00',2.15),('8975','2013-12-02','12:05:00',2.13),('8975','2013-12-02','12:10:00',2.16),('8975','2013-12-02','12:15:00',2.16),('8975','2013-12-02','12:20:00',2.13),('8975','2013-12-02','12:25:00',2.1),('8975','2013-12-02','12:30:00',2.08),('8975','2013-12-02','12:35:00',2.17),('8975','2013-12-02','12:40:00',2.21),('8975','2013-12-02','12:45:00',2.24),('8975','2013-12-02','12:50:00',2.31),('8975','2013-12-02','12:55:00',2.29),('8975','2013-12-02','13:00:00',2.21),('8975','2013-12-02','13:05:00',2.26),('8975','2013-12-02','13:10:00',2.22),('8975','2013-12-02','13:15:00',2.16),('8975','2013-12-02','13:20:00',2.13),('8975','2013-12-02','13:25:00',2.03),('8975','2013-12-02','13:30:00',1.94),('8975','2013-12-02','13:35:00',1.89),('8975','2013-12-02','13:40:00',1.73),('8975','2013-12-02','13:45:00',1.58),('8975','2013-12-02','13:50:00',1.51),('8975','2013-12-02','13:55:00',1.46),('8975','2013-12-02','14:00:00',1.37),('8975','2013-12-02','14:05:00',1.26),('8975','2013-12-02','14:10:00',1.2),('8975','2013-12-02','14:15:00',1.14),('8975','2013-12-02','14:20:00',1.08),('8975','2013-12-02','14:30:00',1.02),('8975','2013-12-02','14:35:00',1.13),('8975','2013-12-02','14:40:00',1.11),('8975','2013-12-02','14:45:00',1.09),('8975','2013-12-02','14:50:00',1.05),('8975','2013-12-02','14:55:00',1.03),('8975','2013-12-01','13:45:00',1.04),('8975','2013-12-01','13:50:00',1.08),('8975','2013-12-01','13:55:00',1.14),('8975','2013-12-01','14:00:00',1.13),('8975','2013-12-01','14:05:00',1.04),('8975','2013-11-30','11:25:00',1.28),('8975','2013-11-30','11:30:00',1.61),('8975','2013-11-30','11:35:00',1.87),('8975','2013-11-30','11:40:00',1.64),('8975','2013-11-30','11:45:00',1.27),('8975','2013-11-30','11:50:00',1.37),('8975','2013-11-30','11:55:00',1.86),('8975','2013-11-30','12:00:00',1.57),('8975','2013-11-30','12:05:00',1.92),('8975','2013-11-30','12:10:00',2.12),('8975','2013-11-30','12:15:00',1.54),('8975','2013-11-30','12:45:00',1.32),('8975','2013-11-30','12:50:00',1.14),('8975','2013-11-30','12:55:00',1.11),('8975','2013-11-30','13:00:00',1.12),('8975','2013-11-29','08:55:00',1.39),('8975','2013-11-29','09:00:00',1.56),('8975','2013-11-29','09:05:00',1.61),('8975','2013-11-29','09:10:00',2.44),('8975','2013-11-29','09:15:00',2.74),('8975','2013-11-29','09:20:00',2.74),('8975','2013-11-29','09:25:00',2.76),('8975','2013-11-29','09:30:00',2.23),('8975','2013-11-29','09:35:00',3.04),('8975','2013-11-29','09:40:00',2.78),('8975','2013-11-29','09:45:00',2.44),('8975','2013-11-29','09:50:00',2.07),('8975','2013-11-29','09:55:00',1.88),('8975','2013-11-29','10:00:00',1.78),('8975','2013-11-29','10:05:00',1.59),('8975','2013-11-29','10:10:00',1.57),('8975','2013-11-29','10:15:00',1.74),('8975','2013-11-29','10:20:00',1.85),('8975','2013-11-29','10:25:00',1.8),('8975','2013-11-29','10:30:00',1.88),('8975','2013-11-29','10:35:00',1.99),('8975','2013-11-29','10:40:00',2.06),('8975','2013-11-29','10:45:00',2.02),('8975','2013-11-29','10:50:00',1.95),('8975','2013-11-29','10:55:00',1.82),('8975','2013-11-29','11:00:00',1.76),('8975','2013-11-29','11:05:00',2.1),('8975','2013-11-29','11:10:00',2.06),('8975','2013-11-29','11:15:00',1.98),('8975','2013-11-29','11:20:00',1.88),('8975','2013-11-29','11:25:00',1.83),('8975','2013-11-29','11:30:00',1.66),('8975','2013-11-29','11:35:00',1.63),('8975','2013-11-29','11:40:00',1.53),('8975','2013-11-29','11:45:00',1.4),('8975','2013-11-29','11:50:00',1.37),('8975','2013-11-29','11:55:00',1.2),('8975','2013-11-29','12:00:00',1.15),('8975','2013-11-29','12:05:00',1.13),('8975','2013-11-29','12:10:00',1.05),('8975','2013-11-29','12:15:00',1),('8975','2013-11-29','12:20:00',1.01),('8975','2013-11-29','12:25:00',1.09),('8975','2013-11-29','12:30:00',1),('8975','2013-11-29','13:45:00',1.04),('8975','2013-11-29','13:50:00',1.24),('8975','2013-11-29','13:55:00',1.11),('8975','2013-11-28','07:45:00',1.01),('8975','2013-11-28','07:50:00',1.13),('8975','2013-11-28','07:55:00',1.27),('8975','2013-11-28','08:00:00',1.4),('8975','2013-11-28','08:05:00',1.51),('8975','2013-11-28','08:10:00',1.62),('8975','2013-11-28','08:15:00',1.73),('8975','2013-11-28','08:20:00',1.83),('8975','2013-11-28','08:25:00',1.92),('8975','2013-11-28','08:30:00',2.02),('8975','2013-11-28','08:35:00',2.1),('8975','2013-11-28','08:40:00',2.17),('8975','2013-11-28','08:45:00',2.25),('8975','2013-11-28','08:50:00',2.3),('8975','2013-11-28','08:55:00',2.38),('8975','2013-11-28','09:00:00',2.44),('8975','2013-11-28','09:05:00',2.5),('8975','2013-11-28','09:10:00',2.56),('8975','2013-11-28','09:15:00',2.62),('8975','2013-11-28','09:20:00',2.7),('8975','2013-11-28','09:25:00',2.77),('8975','2013-11-28','09:30:00',2.8),('8975','2013-11-28','09:35:00',2.83),('8975','2013-11-28','09:40:00',2.88),('8975','2013-11-28','09:45:00',2.9),('8975','2013-11-28','09:50:00',2.95),('8975','2013-11-28','09:55:00',3.03),('8975','2013-11-28','10:00:00',3.06),('8975','2013-11-28','10:05:00',3.03),('8975','2013-11-28','10:10:00',3.11),('8975','2013-11-28','10:15:00',3.16),('8975','2013-11-28','10:20:00',3.2),('8975','2013-11-28','10:25:00',3.22),('8975','2013-11-28','10:30:00',3.25),('8975','2013-11-28','10:35:00',3.26),('8975','2013-11-28','10:40:00',3.28),('8975','2013-11-28','10:45:00',3.3),('8975','2013-11-28','10:50:00',3.29),('8975','2013-11-28','10:55:00',3.32),('8975','2013-11-28','11:00:00',3.3),('8975','2013-11-28','11:05:00',3.29),('8975','2013-11-28','11:10:00',3.29),('8975','2013-11-28','11:15:00',3.22),('8975','2013-11-28','11:20:00',3.14),('8975','2013-11-28','11:25:00',3.19),('8975','2013-11-28','11:30:00',3.1),('8975','2013-11-28','11:35:00',3.06),('8975','2013-11-28','11:40:00',3.06),('8975','2013-11-28','11:45:00',2.99),('8975','2013-11-28','11:50:00',2.93),('8975','2013-11-28','11:55:00',2.86),('8975','2013-11-28','12:00:00',2.82),('8975','2013-11-28','12:05:00',2.84),('8975','2013-11-28','12:10:00',2.79),('8975','2013-11-28','12:15:00',2.76),('8975','2013-11-28','12:20:00',2.67),('8975','2013-11-28','12:25:00',2.5),('8975','2013-11-28','12:30:00',2.53),('8975','2013-11-28','12:35:00',2.53),('8975','2013-11-28','12:40:00',2.47),('8975','2013-11-28','12:45:00',2.46),('8975','2013-11-28','12:50:00',2.4),('8975','2013-11-28','12:55:00',2.29),('8975','2013-11-28','13:00:00',2.16),('8975','2013-11-28','13:05:00',2.15),('8975','2013-11-28','13:10:00',2.09),('8975','2013-11-28','13:15:00',1.95),('8975','2013-11-28','13:20:00',1.91),('8975','2013-11-28','13:25:00',1.73),('8975','2013-11-28','13:30:00',1.7),('8975','2013-11-28','13:35:00',1.7),('8975','2013-11-28','13:40:00',1.69),('8975','2013-11-28','13:45:00',1.65),('8975','2013-11-28','13:50:00',1.57),('8975','2013-11-28','13:55:00',1.5),('8975','2013-11-28','14:00:00',1.44),('8975','2013-11-28','14:05:00',1.35),('8975','2013-11-28','14:10:00',1.28),('8975','2013-11-28','14:15:00',1.23),('8975','2013-11-28','14:20:00',1.22),('8975','2013-11-28','14:25:00',1.21),('8975','2013-11-28','14:30:00',1.21),('8975','2013-11-28','14:35:00',1.23),('8975','2013-11-28','14:40:00',1.21),('8975','2013-11-28','14:45:00',1.17),('8975','2013-11-28','14:50:00',1.14),('8975','2013-11-28','14:55:00',1.12),('8975','2013-11-28','15:00:00',1.09),('8975','2013-11-28','15:05:00',1.04),('8975','2013-11-28','15:10:00',1.01),('8975','2013-11-27','09:30:00',1.11),('8975','2013-11-27','09:35:00',1.18),('8975','2013-11-27','09:40:00',1.32),('8975','2013-11-27','09:45:00',1.38),('8975','2013-11-27','09:50:00',1.36),('8975','2013-11-27','09:55:00',1.3),('8975','2013-11-27','10:00:00',1.25),('8975','2013-11-27','11:20:00',1.01),('8975','2013-11-27','11:25:00',1.02),('8975','2013-11-27','12:40:00',1.01),('8975','2013-11-27','12:45:00',1.1),('8975','2013-11-27','12:50:00',1.49),('8975','2013-11-27','12:55:00',1.79),('8975','2013-11-27','13:00:00',1.23),('8975','2013-11-27','13:25:00',1.36),('8975','2013-11-27','13:35:00',1.31),('8975','2013-11-27','13:40:00',1.19),('8975','2013-11-27','13:45:00',1.15),('8975','2013-11-27','14:10:00',1.34),('8975','2014-04-19','07:40:00',2.3),('8975','2014-04-19','07:45:00',2.6),('8975','2014-04-19','07:50:00',2.64),('8975','2014-04-19','07:55:00',2.66),('8975','2014-04-19','08:00:00',3),('8975','2014-04-19','08:05:00',3.06),('8975','2014-04-19','08:10:00',3.26),('8975','2014-04-19','08:15:00',3.45),('8975','2014-04-19','08:20:00',4.18),('8975','2014-04-19','08:25:00',3.71),('8975','2014-04-19','08:30:00',3.82),('8975','2014-04-19','08:35:00',4.39),('8975','2014-04-19','08:40:00',3.51),('8975','2014-04-19','08:45:00',4.69),('8975','2014-04-19','08:50:00',2.42),('8975','2014-04-19','08:55:00',2.65),('8975','2014-04-19','09:00:00',1.03),('8975','2014-04-19','09:05:00',2.08),('8975','2014-04-19','09:10:00',5.22),('8975','2014-04-19','09:15:00',5.03),('8975','2014-04-19','09:20:00',5.31),('8975','2014-04-19','09:25:00',4.54),('8975','2014-04-19','09:30:00',4.28),('8975','2014-04-19','09:35:00',4.67),('8975','2014-04-19','09:40:00',2.72),('8975','2014-04-19','09:45:00',3.23),('8975','2014-04-19','09:50:00',2.82),('8975','2014-04-19','09:55:00',3.43),('8975','2014-04-19','10:00:00',4.05),('8975','2014-04-19','10:05:00',5.2),('8975','2014-04-19','10:10:00',4.25),('8975','2014-04-19','10:15:00',5.52),('8975','2014-04-19','10:20:00',5.13),('8975','2014-04-19','10:25:00',4.29),('8975','2014-04-19','10:30:00',4.89),('8975','2014-04-19','10:35:00',4.65),('8975','2014-04-19','10:40:00',4.33),('8975','2014-04-19','10:45:00',5.12),('8975','2014-04-19','10:50:00',4.72),('8975','2014-04-19','10:55:00',4.92),('8975','2014-04-19','11:00:00',5.58),('8975','2014-04-19','11:05:00',5.01),('8975','2014-04-19','11:10:00',5.55),('8975','2014-04-19','11:15:00',5.79),('8975','2014-04-19','11:20:00',6.31),('8975','2014-04-19','11:25:00',2.9),('8975','2014-04-19','11:30:00',7.01),('8975','2014-04-19','11:35:00',7.36),('8975','2014-04-19','11:40:00',7.33),('8975','2014-04-19','11:45:00',6.11),('8975','2014-04-19','11:50:00',7.14),('8975','2014-04-19','11:55:00',6.54),('8975','2014-04-19','12:00:00',6.12),('8975','2014-04-19','12:05:00',5.05),('8975','2014-04-19','12:10:00',3.57),('8975','2014-04-19','12:15:00',5.06),('8975','2014-04-19','12:20:00',7.72),('8975','2014-04-19','12:25:00',7.2),('8975','2014-04-19','12:30:00',6.83),('8975','2014-04-19','12:35:00',6.8),('8975','2014-04-19','12:40:00',6.7),('8975','2014-04-19','12:45:00',6.66),('8975','2014-04-19','12:50:00',6.69),('8975','2014-04-19','12:55:00',6.67),('8975','2014-04-19','13:00:00',6.66),('8975','2014-04-19','13:05:00',6.49),('8975','2014-04-19','13:10:00',5.85),('8975','2014-04-19','13:15:00',4.93),('8975','2014-04-19','13:20:00',6.49),('8975','2014-04-19','13:25:00',6.47),('8975','2014-04-19','13:30:00',6.43),('8975','2014-04-19','13:35:00',6.39),('8975','2014-04-19','13:40:00',6.34),('8975','2014-04-19','13:45:00',6.27),('8975','2014-04-19','13:50:00',6.21),('8975','2014-04-19','13:55:00',6.14),('8975','2014-04-19','14:00:00',6.05),('8975','2014-04-19','14:05:00',6.01),('8975','2014-04-19','14:10:00',5.96),('8975','2014-04-19','14:15:00',6.07),('8975','2014-04-19','14:20:00',4.4),('8975','2014-04-19','14:25:00',4.58),('8975','2014-04-19','14:30:00',3.97),('8975','2014-04-19','14:35:00',3.93),('8975','2014-04-19','14:40:00',4.02),('8975','2014-04-19','14:45:00',4.01),('8975','2014-04-19','14:50:00',4.13),('8975','2014-04-19','14:55:00',4.57),('8975','2014-04-19','15:00:00',6.2),('8975','2014-04-19','15:05:00',5.2),('8975','2014-04-19','15:10:00',5.43),('8975','2014-04-19','15:15:00',4.88),('8975','2014-04-19','15:20:00',4.82),('8975','2014-04-19','15:25:00',4.66),('8975','2014-04-19','15:30:00',4.53),('8975','2014-04-19','15:35:00',4.14),('8975','2014-04-19','15:40:00',4.3),('8975','2014-04-19','15:45:00',2.16),('8975','2014-04-19','15:50:00',3.87),('8975','2014-04-19','15:55:00',4.11),('8975','2014-04-19','16:00:00',3.89),('8975','2014-04-19','16:05:00',3.76),('8975','2014-04-19','16:10:00',3.66),('8975','2014-04-19','16:15:00',3.59),('8975','2014-04-19','16:20:00',3.2),('8975','2014-04-19','16:25:00',3.35),('8975','2014-04-19','16:30:00',3.18),('8975','2014-04-19','16:35:00',2.91),('8975','2014-04-19','16:40:00',2.91),('8975','2014-04-19','16:45:00',2.23),('8975','2014-04-19','16:50:00',2.72),('8975','2014-04-19','16:55:00',2.77),('8975','2014-04-19','17:00:00',2.59),('8975','2014-04-19','17:05:00',2.42),('8975','2014-04-19','17:10:00',2.26),('8975','2014-04-19','17:15:00',2.13),('8975','2014-04-19','17:20:00',1.99),('8975','2014-04-19','17:25:00',1.91),('8975','2014-04-19','17:30:00',1.8),('8975','2014-04-19','17:35:00',1.72),('8975','2014-04-19','17:40:00',1.65),('8975','2014-04-19','17:45:00',1.57),('8975','2014-04-19','17:50:00',1.52),('8975','2014-04-19','17:55:00',1.46),('8975','2014-04-19','18:00:00',1.43),('8975','2014-04-19','18:05:00',1.38),('8975','2014-04-19','18:10:00',1.33),('8975','2014-04-19','18:15:00',1.17),('8975','2014-04-19','18:30:00',1.06),('8975','2013-11-26','08:45:00',1.04),('8975','2013-11-26','08:50:00',1.09),('8975','2013-11-26','08:55:00',1.08),('8975','2013-11-26','09:00:00',1.07),('8975','2013-11-26','09:15:00',1.17),('8975','2013-11-26','09:20:00',1.34),('8975','2013-11-26','09:25:00',1.72),('8975','2013-11-26','09:30:00',1.49),('8975','2013-11-26','09:35:00',1.97),('8975','2013-11-26','09:40:00',1.63),('8975','2013-11-26','09:45:00',1.51),('8975','2013-11-26','09:50:00',1.76),('8975','2013-11-26','09:55:00',1.92),('8975','2013-11-26','10:00:00',1.98),('8975','2013-11-26','10:05:00',1.92),('8975','2013-11-26','10:10:00',1.83),('8975','2013-11-26','10:15:00',1.73),('8975','2013-11-26','10:20:00',1.65),('8975','2013-11-26','10:25:00',1.61),('8975','2013-11-26','10:30:00',1.69),('8975','2013-11-26','10:35:00',1.87),('8975','2013-11-26','10:40:00',2.24),('8975','2013-11-26','10:45:00',2.12),('8975','2013-11-26','10:50:00',1.94),('8975','2013-11-26','10:55:00',1.97),('8975','2013-11-26','11:00:00',2.15),('8975','2013-11-26','11:05:00',2.44),('8975','2013-11-26','11:10:00',2.3),('8975','2013-11-26','11:15:00',2.1),('8975','2013-11-26','11:20:00',2.05),('8975','2013-11-26','11:25:00',2.52),('8975','2013-11-26','11:30:00',3.7),('8975','2013-11-26','11:35:00',2.74),('8975','2013-11-26','11:40:00',2.43),('8975','2013-11-26','11:45:00',2.27),('8975','2013-11-26','11:50:00',2.89),('8975','2013-11-26','11:55:00',2.71),('8975','2013-11-26','12:00:00',3.34),('8975','2013-11-26','12:05:00',3.4),('8975','2013-11-26','12:10:00',2.05),('8975','2013-11-26','12:15:00',2.49),('8975','2013-11-26','12:20:00',1.92),('8975','2013-11-26','12:25:00',1.86),('8975','2013-11-26','12:30:00',2.43),('8975','2013-11-26','12:35:00',1.96),('8975','2013-11-26','12:40:00',1.48),('8975','2013-11-26','12:45:00',1.46),('8975','2013-11-26','12:50:00',1.53),('8975','2013-11-26','12:55:00',1.52),('8975','2013-11-26','13:00:00',1.48),('8975','2013-11-26','13:05:00',1.52),('8975','2013-11-26','13:10:00',1.49),('8975','2013-11-26','13:15:00',1.5),('8975','2013-11-26','13:20:00',1.45),('8975','2013-11-26','13:25:00',1.41),('8975','2013-11-26','13:30:00',1.42),('8975','2013-11-26','13:35:00',1.45),('8975','2013-11-26','13:40:00',1.55),('8975','2013-11-26','13:45:00',1.37),('8975','2013-11-26','13:50:00',1.14),('8975','2013-11-26','13:55:00',1.06),('8975','2013-11-26','14:00:00',1.05),('8975','2013-11-25','08:00:00',1.67),('8975','2013-11-25','08:05:00',1.97),('8975','2013-11-25','08:10:00',2.07),('8975','2013-11-25','08:15:00',2.14),('8975','2013-11-25','08:20:00',1.48),('8975','2013-11-25','08:45:00',1.37),('8975','2013-11-25','08:50:00',1.34),('8975','2013-11-25','08:55:00',1.11),('8975','2013-11-25','09:00:00',1.35),('8975','2013-11-25','09:05:00',1.63),('8975','2013-11-25','09:10:00',2.05),('8975','2013-11-25','09:15:00',2.02),('8975','2013-11-25','09:20:00',1.94),('8975','2013-11-25','09:25:00',1.75),('8975','2013-11-25','09:30:00',1.76),('8975','2013-11-25','09:35:00',1.95),('8975','2013-11-25','09:40:00',2.76),('8975','2013-11-25','09:45:00',1.59),('8975','2013-11-25','09:50:00',1.9),('8975','2013-11-25','09:55:00',2.48),('8975','2013-11-25','10:00:00',3.57),('8975','2013-11-25','10:05:00',2.52),('8975','2013-11-25','10:10:00',2.71),('8975','2013-11-25','10:15:00',1.42),('8975','2013-11-25','10:20:00',1.8),('8975','2013-11-25','10:25:00',2.26),('8975','2013-11-25','10:30:00',2.1),('8975','2013-11-25','10:35:00',3.13),('8975','2013-11-25','10:40:00',3.59),('8975','2013-11-25','10:45:00',3.62),('8975','2013-11-25','10:50:00',3.62),('8975','2013-11-25','10:55:00',3.65),('8975','2013-11-25','11:00:00',3.69),('8975','2013-11-25','11:05:00',4.01),('8975','2013-11-25','11:10:00',3.95),('8975','2013-11-25','11:15:00',4.04),('8975','2013-11-25','11:20:00',3.98),('8975','2013-11-25','11:25:00',3.51),('8975','2013-11-25','11:30:00',3.72),('8975','2013-11-25','11:35:00',3.69),('8975','2013-11-25','11:40:00',2.05),('8975','2013-11-25','11:45:00',3.82),('8975','2013-11-25','11:50:00',3.77),('8975','2013-11-25','11:55:00',3.52),('8975','2013-11-25','12:00:00',2.36),('8975','2013-11-25','12:05:00',2.03),('8975','2013-11-25','12:10:00',1.09),('8975','2013-11-25','12:20:00',2.6),('8975','2013-11-25','12:25:00',2.88),('8975','2013-11-25','12:30:00',2.67),('8975','2013-11-25','12:35:00',2.81),('8975','2013-11-25','12:40:00',2.78),('8975','2013-11-25','12:45:00',2.67),('8975','2013-11-25','12:50:00',2.66),('8975','2013-11-25','12:55:00',2.51),('8975','2013-11-25','13:00:00',2.43),('8975','2013-11-25','13:05:00',2.36),('8975','2013-11-25','13:10:00',2.28),('8975','2013-11-25','13:15:00',2.17),('8975','2013-11-25','13:20:00',2.07),('8975','2013-11-25','13:25:00',1.99),('8975','2013-11-25','13:30:00',1.95),('8975','2013-11-25','13:35:00',1.93),('8975','2013-11-25','13:40:00',1.89),('8975','2013-11-25','13:45:00',1.86),('8975','2013-11-25','13:50:00',1.87),('8975','2013-11-25','13:55:00',1.8),('8975','2013-11-25','14:00:00',2.09),('8975','2013-11-25','14:05:00',2.49),('8975','2013-11-25','14:10:00',2.09),('8975','2013-11-25','14:15:00',2.52),('8975','2013-11-25','14:20:00',2.27),('8975','2013-11-25','14:25:00',1.6),('8975','2013-11-25','14:30:00',1.08),('8975','2013-11-25','14:35:00',1.45),('8975','2013-11-25','14:40:00',1.54),('8975','2013-11-25','14:45:00',1.68),('8975','2013-11-25','14:50:00',1.79),('8975','2013-11-25','14:55:00',2.05),('8975','2013-11-25','15:00:00',1.9),('8975','2013-11-25','15:05:00',1.68),('8975','2013-11-25','15:10:00',1.44),('8975','2013-11-25','15:15:00',1.3),('8975','2013-11-25','15:20:00',1.22),('8975','2013-11-25','15:25:00',1.16),('8975','2013-11-25','15:30:00',1.07),('8975','2013-11-25','15:35:00',1.01),('8975','2013-11-24','07:45:00',1.25),('8975','2013-11-24','07:50:00',1.37),('8975','2013-11-24','07:55:00',1.51),('8975','2013-11-24','08:00:00',1.62),('8975','2013-11-24','08:05:00',1.75),('8975','2013-11-24','08:10:00',1.84),('8975','2013-11-24','08:15:00',1.96),('8975','2013-11-24','08:20:00',2.1),('8975','2013-11-24','08:25:00',2.22),('8975','2013-11-24','08:30:00',2.29),('8975','2013-11-24','08:35:00',2.42),('8975','2013-11-24','08:40:00',2.57),('8975','2013-11-24','08:45:00',2.65),('8975','2013-11-24','08:50:00',2.76),('8975','2013-11-24','08:55:00',2.95),('8975','2013-11-24','09:00:00',3.19),('8975','2013-11-24','09:05:00',3.28),('8975','2013-11-24','09:10:00',3.41),('8975','2013-11-24','09:15:00',3.53),('8975','2013-11-24','09:20:00',3.9),('8975','2013-11-24','09:25:00',2.95),('8975','2013-11-24','09:30:00',2.25),('8975','2013-11-24','09:35:00',3.91),('8975','2013-11-24','09:40:00',3.12),('8975','2013-11-24','09:45:00',1.87),('8975','2013-11-24','09:50:00',2.06),('8975','2013-11-24','09:55:00',2.79),('8975','2013-11-24','10:00:00',2.51),('8975','2013-11-24','10:05:00',3.38),('8975','2013-11-24','10:10:00',2.55),('8975','2013-11-24','10:15:00',1.28),('8975','2013-11-24','10:20:00',2.57),('8975','2013-11-24','10:25:00',3.62),('8975','2013-11-24','10:30:00',4.29),('8975','2013-11-24','10:35:00',3.83),('8975','2013-11-24','10:40:00',3.42),('8975','2013-11-24','10:45:00',2.9),('8975','2013-11-24','10:50:00',1.87),('8975','2013-11-24','10:55:00',2.79),('8975','2013-11-24','11:00:00',3.66),('8975','2013-11-24','11:05:00',3.63),('8975','2013-11-24','11:10:00',4.1),('8975','2013-11-24','11:15:00',4.57),('8975','2013-11-24','11:20:00',2.44),('8975','2013-11-24','11:25:00',2.05),('8975','2013-11-24','11:30:00',2.56),('8975','2013-11-24','11:35:00',3.48),('8975','2013-11-24','11:40:00',3.69),('8975','2013-11-24','11:45:00',3.56),('8975','2013-11-24','11:50:00',3.14),('8975','2013-11-24','11:55:00',2.6),('8975','2013-11-24','12:00:00',2.7),('8975','2013-11-24','12:05:00',2.04),('8975','2013-11-24','12:10:00',1.86),('8975','2013-11-24','12:15:00',2.03),('8975','2013-11-24','12:20:00',1.94),('8975','2013-11-24','12:25:00',2.07),('8975','2013-11-24','12:30:00',1.82),('8975','2013-11-24','12:35:00',1.5),('8975','2013-11-24','12:40:00',1.92),('8975','2013-11-24','12:45:00',2.59),('8975','2013-11-24','12:50:00',2.74),('8975','2013-11-24','12:55:00',2.46),('8975','2013-11-24','13:00:00',2.79),('8975','2013-11-24','13:05:00',3.01),('8975','2013-11-24','13:10:00',3.11),('8975','2013-11-24','13:15:00',3.26),('8975','2013-11-24','13:20:00',3.04),('8975','2013-11-24','13:25:00',3.15),('8975','2013-11-24','13:30:00',2.93),('8975','2013-11-24','13:35:00',2.09),('8975','2013-11-24','13:40:00',1.47),('8975','2013-11-24','13:45:00',1.41),('8975','2013-11-24','13:50:00',1.36),('8975','2013-11-24','13:55:00',1.17),('8975','2013-11-24','14:00:00',1.04),('8975','2013-11-23','09:50:00',1.46),('8975','2013-11-23','09:55:00',1.98),('8975','2013-11-23','10:00:00',2.18),('8975','2013-11-23','10:05:00',2.18),('8975','2013-11-23','10:10:00',2.25),('8975','2013-11-23','10:15:00',2.03),('8975','2013-11-23','10:20:00',2.08),('8975','2013-11-23','10:25:00',2.3),('8975','2013-11-23','10:30:00',1.87),('8975','2013-11-23','10:35:00',1.47),('8975','2013-11-23','10:40:00',1.41),('8975','2013-11-23','10:45:00',1.44),('8975','2013-11-23','10:50:00',1.57),('8975','2013-11-23','10:55:00',1.72),('8975','2013-11-23','11:00:00',1.75),('8975','2013-11-23','11:05:00',1.82),('8975','2013-11-23','11:10:00',1.87),('8975','2013-11-23','11:15:00',1.9),('8975','2013-11-23','11:20:00',2.01),('8975','2013-11-23','11:25:00',2.12),('8975','2013-11-23','11:30:00',2.2),('8975','2013-11-23','11:35:00',1.92),('8975','2013-11-23','11:40:00',2.21),('8975','2013-11-23','11:45:00',2.08),('8975','2013-11-23','11:50:00',2.07),('8975','2013-11-23','11:55:00',1.77),('8975','2013-11-23','12:00:00',1.46),('8975','2013-11-23','12:05:00',1.19),('8975','2013-11-23','12:10:00',1.21),('8975','2013-11-23','12:15:00',1.41),('8975','2013-11-23','12:20:00',1.51),('8975','2013-11-23','12:25:00',1.54),('8975','2013-11-23','12:30:00',1.48),('8975','2013-11-23','12:35:00',1.48),('8975','2013-11-23','12:40:00',1.52),('8975','2013-11-23','12:45:00',1.5),('8975','2013-11-23','12:50:00',1.54),('8975','2013-11-23','12:55:00',1.58),('8975','2013-11-23','13:00:00',1.92),('8975','2013-11-23','13:05:00',2.07),('8975','2013-11-23','13:10:00',2.01),('8975','2013-11-23','13:15:00',1.93),('8975','2013-11-23','13:20:00',1.85),('8975','2013-11-23','13:25:00',1.59),('8975','2013-11-23','13:30:00',1.38),('8975','2013-11-23','13:35:00',1.35),('8975','2013-11-23','13:40:00',1.28),('8975','2013-11-23','13:45:00',1.11),('8975','2013-11-23','13:50:00',1.05),('8975','2013-11-22','08:40:00',1.08),('8975','2013-11-22','10:10:00',1.18),('8975','2013-11-22','10:15:00',1.79),('8975','2013-11-22','10:20:00',1.75),('8975','2013-11-22','10:25:00',2.16),('8975','2013-11-22','10:30:00',3.07),('8975','2013-11-22','10:35:00',2.58),('8975','2013-11-22','10:40:00',3.23),('8975','2013-11-22','11:20:00',1.03),('8975','2013-11-22','11:25:00',1.15),('8975','2013-11-22','11:30:00',1.06),('8975','2013-11-22','11:35:00',1.03),('8975','2013-11-22','11:40:00',1.17),('8975','2013-11-22','11:45:00',1.05),('8975','2013-11-22','13:20:00',1.26),('8975','2013-11-22','13:25:00',1.82),('8975','2013-11-22','13:30:00',1.84),('8975','2013-11-22','13:35:00',2.17),('8975','2013-11-22','13:40:00',1.89),('8975','2013-11-22','13:45:00',1.69),('8975','2013-11-22','13:50:00',1.65),('8975','2013-11-22','13:55:00',1.45),('8975','2013-11-22','14:00:00',1.88),('8975','2013-11-22','14:05:00',1.8),('8975','2013-11-22','14:55:00',1.04),('8975','2013-11-20','08:05:00',1.26),('8975','2013-11-20','08:10:00',2.16),('8975','2013-11-20','08:15:00',2.28),('8975','2013-11-20','08:20:00',1.12),('8975','2013-11-20','09:10:00',1.31),('8975','2013-11-20','09:15:00',1.84),('8975','2013-11-20','09:20:00',1.41),('8975','2013-11-20','09:25:00',1.71),('8975','2013-11-20','09:30:00',1.99),('8975','2013-11-20','09:35:00',1.48),('8975','2013-11-20','09:40:00',2.16),('8975','2013-11-20','09:45:00',3.36),('8975','2013-11-20','09:50:00',2.21),('8975','2013-11-20','09:55:00',3.38),('8975','2013-11-20','10:00:00',3.54),('8975','2013-11-20','10:05:00',3.57),('8975','2013-11-20','10:10:00',2.4),('8975','2013-11-20','10:15:00',3.17),('8975','2013-11-20','10:20:00',2.81),('8975','2013-11-20','10:25:00',3.05),('8975','2013-11-20','10:30:00',3.12),('8975','2013-11-20','10:35:00',3.38),('8975','2013-11-20','10:40:00',3.53),('8975','2013-11-20','10:45:00',3.43),('8975','2013-11-20','10:50:00',1.12),('8975','2013-11-20','11:00:00',1.24),('8975','2013-11-20','11:05:00',1.19),('8975','2013-11-20','11:10:00',1.57),('8975','2013-11-20','11:15:00',1.38),('8975','2013-11-20','11:20:00',1.15),('8975','2013-11-20','11:25:00',2.51),('8975','2013-11-20','11:30:00',2.9),('8975','2013-11-20','11:35:00',2.67),('8975','2013-11-20','11:40:00',3.34),('8975','2013-11-20','11:45:00',1.4),('8975','2013-11-20','11:50:00',2.79),('8975','2013-11-20','11:55:00',2.6),('8975','2013-11-20','12:00:00',2.76),('8975','2013-11-20','12:05:00',2.43),('8975','2013-11-20','12:10:00',2.98),('8975','2013-11-20','12:15:00',2.94),('8975','2013-11-20','12:20:00',2.84),('8975','2013-11-20','12:25:00',2.82),('8975','2013-11-20','12:30:00',2.96),('8975','2013-11-20','12:35:00',2.8),('8975','2013-11-20','12:40:00',3.01),('8975','2013-11-20','12:45:00',2.93),('8975','2013-11-20','12:50:00',2.41),('8975','2013-11-20','12:55:00',2.97),('8975','2013-11-20','13:00:00',2.66),('8975','2013-11-20','13:05:00',2.17),('8975','2013-11-20','13:10:00',1.99),('8975','2013-11-20','13:15:00',2.25),('8975','2013-11-20','13:20:00',2.34),('8975','2013-11-20','13:25:00',2.27),('8975','2013-11-20','13:30:00',2.06),('8975','2013-11-20','13:35:00',1.02),('8975','2013-11-20','13:40:00',1.31),('8975','2013-11-20','13:45:00',1.24),('8975','2013-11-20','13:50:00',1.1),('8975','2013-11-20','13:55:00',1.12),('8975','2013-11-20','14:00:00',1.55),('8975','2013-11-20','14:05:00',1.81),('8975','2013-11-20','14:10:00',1.93),('8975','2013-11-20','14:15:00',1.69),('8975','2013-11-20','14:25:00',1.16),('8975','2013-11-20','14:45:00',1.27),('8975','2013-11-20','14:55:00',1.23),('8975','2013-11-20','15:00:00',1.21),('8975','2013-11-20','15:05:00',1.14),('8975','2013-11-20','15:10:00',1.08),('8975','2013-11-19','08:15:00',1.49),('8975','2013-11-19','09:15:00',2.53),('8975','2013-11-19','09:20:00',2.62),('8975','2013-11-19','09:25:00',2.54),('8975','2013-11-19','09:30:00',3.79),('8975','2013-11-19','09:35:00',2.46),('8975','2013-11-19','10:00:00',2.08),('8975','2013-11-19','10:05:00',1.74),('8975','2013-11-19','10:10:00',3.5),('8975','2013-11-19','10:15:00',3.83),('8975','2013-11-19','10:25:00',1.51),('8975','2013-11-19','10:30:00',1.61),('8975','2013-11-19','10:35:00',1.48),('8975','2013-11-19','10:40:00',1.22),('8975','2013-11-19','10:50:00',1.12),('8975','2013-11-19','10:55:00',1.2),('8975','2013-11-19','11:00:00',1.89),('8975','2013-11-19','11:05:00',1.11),('8975','2013-11-19','11:10:00',1.09),('8975','2013-11-19','11:15:00',1.01),('8975','2013-11-19','11:20:00',1.3),('8975','2013-11-19','11:25:00',1.32),('8975','2013-11-19','11:30:00',1.21),('8975','2013-11-19','11:35:00',1.04),('8975','2013-11-19','11:40:00',1.47),('8975','2013-11-19','11:45:00',3.8),('8975','2013-11-19','11:50:00',2.84),('8975','2013-11-19','11:55:00',2.75),('8975','2013-11-19','12:00:00',1.62),('8975','2013-11-19','12:10:00',1.14),('8975','2013-11-19','12:15:00',1.82),('8975','2013-11-19','12:20:00',2.01),('8975','2013-11-19','12:25:00',1.29),('8975','2013-11-19','12:30:00',1.02),('8975','2013-11-19','12:35:00',1.52),('8975','2013-11-19','12:40:00',2.31),('8975','2013-11-19','12:45:00',2.79),('8975','2013-11-19','12:50:00',3.58),('8975','2013-11-19','12:55:00',3.03),('8975','2013-11-19','13:00:00',2.08),('8975','2013-11-19','13:05:00',1.68),('8975','2013-11-19','13:10:00',1.07),('8975','2013-11-19','13:15:00',1.07),('8975','2013-11-19','13:20:00',1.57),('8975','2013-11-19','13:25:00',1.42),('8975','2013-11-19','13:30:00',1.36),('8975','2013-11-19','13:40:00',1.27),('8975','2013-11-19','13:45:00',1.94),('8975','2013-11-19','13:50:00',1.56),('8975','2013-11-19','13:55:00',1.1),('8975','2013-11-19','14:00:00',1.19),('8975','2013-11-19','14:05:00',1.18),('8975','2013-11-19','14:10:00',1.14),('8975','2013-11-19','14:15:00',1.1),('8975','2013-11-19','14:20:00',1.2),('8975','2013-11-19','14:25:00',1.23),('8975','2013-11-19','14:30:00',1.92),('8975','2013-11-19','14:35:00',1.39),('8975','2013-11-19','14:40:00',1.54),('8975','2013-11-19','14:45:00',1.19),('8975','2013-11-19','15:05:00',1.07),('8975','2013-11-19','15:10:00',1.51),('8975','2013-11-18','09:35:00',2.16),('8975','2013-11-18','09:40:00',3.16),('8975','2013-11-18','09:45:00',2.75),('8975','2013-11-18','09:50:00',1.68),('8975','2013-11-18','09:55:00',2.3),('8975','2013-11-18','10:00:00',1.81),('8975','2013-11-18','10:05:00',1.84),('8975','2013-11-18','10:45:00',1.8),('8975','2013-11-18','10:50:00',2.33),('8975','2013-11-18','10:55:00',1.31),('8975','2013-11-18','11:05:00',1.21),('8975','2013-11-18','11:10:00',1.2),('8975','2013-11-18','11:15:00',2.01),('8975','2013-11-18','11:20:00',2.23),('8975','2013-11-18','11:25:00',2.55),('8975','2013-11-18','11:30:00',2.68),('8975','2013-11-18','11:35:00',2.84),('8975','2013-11-18','11:40:00',2.73),('8975','2013-11-18','11:45:00',3.01),('8975','2013-11-18','11:50:00',2.78),('8975','2013-11-18','11:55:00',2.52),('8975','2013-11-18','12:00:00',2.54),('8975','2013-11-18','12:05:00',2.89),('8975','2013-11-18','12:10:00',2.39),('8975','2013-11-18','12:15:00',2.72),('8975','2013-11-18','12:25:00',1.76),('8975','2013-11-18','12:30:00',1.61),('8975','2013-11-18','12:40:00',1.63),('8975','2013-11-18','12:45:00',1.52),('8975','2013-11-18','12:50:00',2.05),('8975','2013-11-18','12:55:00',2.4),('8975','2013-11-18','13:00:00',1.5),('8975','2013-11-18','13:05:00',1.12),('8975','2013-11-18','13:10:00',2.16),('8975','2013-11-18','13:15:00',2.35),('8975','2013-11-18','13:20:00',1.58),('8975','2013-11-18','13:30:00',1.02),('8975','2013-11-18','14:45:00',1.04),('8975','2013-11-18','14:50:00',1.08),('8975','2013-11-18','15:25:00',1.94),('8975','2013-11-18','15:30:00',1.91),('8975','2013-11-18','15:35:00',1.47),('8975','2013-11-18','15:40:00',1.22),('8975','2013-11-18','15:45:00',1.06),('8975','2013-11-17','07:55:00',1.36),('8975','2013-11-17','08:00:00',1.62),('8975','2013-11-17','08:05:00',2.14),('8975','2013-11-17','08:10:00',1.85),('8975','2013-11-17','08:15:00',1.73),('8975','2013-11-17','08:20:00',1.65),('8975','2013-11-17','08:25:00',2.05),('8975','2013-11-17','08:30:00',2.04),('8975','2013-11-17','08:35:00',1.92),('8975','2013-11-17','08:40:00',1.64),('8975','2013-11-17','08:45:00',1.4),('8975','2013-11-17','08:50:00',1.19),('8975','2013-11-17','08:55:00',1.31),('8975','2013-11-17','09:00:00',1.28),('8975','2013-11-17','09:05:00',1.16),('8975','2013-11-17','09:10:00',1.33),('8975','2013-11-17','09:15:00',2.25),('8975','2013-11-17','09:20:00',2.63),('8975','2013-11-17','09:25:00',2.71),('8975','2013-11-17','09:30:00',2.41),('8975','2013-11-17','09:35:00',2.9),('8975','2013-11-17','09:40:00',2.26),('8975','2013-11-17','09:45:00',1.86),('8975','2013-11-17','09:50:00',1.63),('8975','2013-11-17','09:55:00',1.8),('8975','2013-11-17','10:00:00',2.16),('8975','2013-11-17','10:05:00',2.14),('8975','2013-11-17','10:10:00',2.47),('8975','2013-11-17','10:15:00',2.67),('8975','2013-11-17','10:20:00',1.97),('8975','2013-11-17','10:25:00',1.99),('8975','2013-11-17','10:30:00',1.82),('8975','2013-11-17','10:35:00',1.89),('8975','2013-11-17','10:40:00',1.99),('8975','2013-11-17','10:45:00',2),('8975','2013-11-17','10:50:00',1.88),('8975','2013-11-17','10:55:00',1.69),('8975','2013-11-17','11:00:00',1.55),('8975','2013-11-17','11:05:00',1.43),('8975','2013-11-17','11:10:00',1.3),('8975','2013-11-17','11:15:00',1.21),('8975','2013-11-17','11:20:00',1.33),('8975','2013-11-17','11:25:00',1.54),('8975','2013-11-17','11:30:00',1.69),('8975','2013-11-17','11:35:00',1.76),('8975','2013-11-17','11:40:00',1.81),('8975','2013-11-17','11:45:00',1.86),('8975','2013-11-17','11:50:00',1.93),('8975','2013-11-17','11:55:00',2.05),('8975','2013-11-17','12:00:00',2.13),('8975','2013-11-17','12:05:00',2.18),('8975','2013-11-17','12:10:00',2.16),('8975','2013-11-17','12:15:00',2.18),('8975','2013-11-17','12:20:00',2.31),('8975','2013-11-17','12:25:00',2.26),('8975','2013-11-17','12:30:00',2.03),('8975','2013-11-17','12:35:00',1.84),('8975','2013-11-17','12:40:00',1.65),('8975','2013-11-17','12:45:00',1.52),('8975','2013-11-17','12:50:00',1.44),('8975','2013-11-17','12:55:00',1.4),('8975','2013-11-17','13:00:00',1.39),('8975','2013-11-17','13:05:00',1.49),('8975','2013-11-17','13:10:00',1.58),('8975','2013-11-17','13:15:00',1.57),('8975','2013-11-17','13:20:00',1.49),('8975','2013-11-17','13:25:00',1.39),('8975','2013-11-17','13:30:00',1.52),('8975','2013-11-17','13:35:00',1.69),('8975','2013-11-17','13:40:00',1.7),('8975','2013-11-17','13:45:00',1.57),('8975','2013-11-17','13:50:00',1.52),('8975','2013-11-17','13:55:00',1.33),('8975','2013-11-17','14:00:00',1.16),('8975','2014-04-18','07:15:00',1.61),('8975','2014-04-18','07:20:00',1.99),('8975','2014-04-18','07:25:00',2.15),('8975','2014-04-18','07:30:00',2.53),('8975','2014-04-18','07:35:00',2.82),('8975','2014-04-18','07:40:00',3.18),('8975','2014-04-18','07:45:00',1.47),('8975','2014-04-18','07:50:00',1.76),('8975','2014-04-18','07:55:00',3.61),('8975','2014-04-18','08:00:00',2.99),('8975','2014-04-18','08:05:00',2.09),('8975','2014-04-18','08:10:00',2.23),('8975','2014-04-18','08:15:00',1.91),('8975','2014-04-18','08:20:00',2.26),('8975','2014-04-18','08:25:00',3.79),('8975','2014-04-18','08:30:00',4.54),('8975','2014-04-18','08:35:00',4.22),('8975','2014-04-18','08:40:00',4.87),('8975','2014-04-18','08:45:00',3.29),('8975','2014-04-18','08:50:00',2.45),('8975','2014-04-18','08:55:00',1.66),('8975','2014-04-18','09:00:00',1.13),('8975','2014-04-18','09:05:00',1.04),('8975','2014-04-18','09:10:00',1.17),('8975','2014-04-18','09:15:00',1.28),('8975','2014-04-18','09:20:00',1.76),('8975','2014-04-18','09:25:00',2.51),('8975','2014-04-18','09:30:00',3.07),('8975','2014-04-18','09:35:00',2.75),('8975','2014-04-18','09:40:00',1.8),('8975','2014-04-18','09:45:00',1.4),('8975','2014-04-18','09:50:00',1.42),('8975','2014-04-18','09:55:00',1.39),('8975','2014-04-18','10:00:00',1.33),('8975','2014-04-18','10:05:00',1.01),('8975','2014-04-18','10:15:00',1.18),('8975','2014-04-18','10:20:00',1.39),('8975','2014-04-18','10:25:00',1.13),('8975','2014-04-18','10:30:00',1.2),('8975','2014-04-18','10:35:00',1.59),('8975','2014-04-18','10:40:00',1.96),('8975','2014-04-18','10:45:00',1.79),('8975','2014-04-18','10:50:00',1.85),('8975','2014-04-18','10:55:00',2.34),('8975','2014-04-18','11:00:00',2.51),('8975','2014-04-18','11:05:00',2.04),('8975','2014-04-18','11:10:00',2.06),('8975','2014-04-18','11:15:00',3.29),('8975','2014-04-18','11:20:00',4.09),('8975','2014-04-18','11:25:00',3.18),('8975','2014-04-18','11:30:00',4.23),('8975','2014-04-18','11:35:00',3.53),('8975','2014-04-18','11:40:00',3.01),('8975','2014-04-18','11:45:00',3.49),('8975','2014-04-18','11:50:00',2.66),('8975','2014-04-18','11:55:00',1.62),('8975','2014-04-18','12:00:00',1.29),('8975','2014-04-18','12:05:00',1.05),('8975','2014-04-18','13:10:00',1.17),('8975','2014-04-18','13:15:00',1.97),('8975','2014-04-18','13:45:00',1.02),('8975','2014-04-18','13:50:00',1.26),('8975','2014-04-18','14:25:00',1.07),('8975','2014-04-18','14:30:00',1.78),('8975','2014-04-18','14:35:00',2.6),('8975','2014-04-18','14:40:00',3.43),('8975','2014-04-18','14:45:00',3.43),('8975','2014-04-18','14:50:00',2.3),('8975','2014-04-18','14:55:00',2.42),('8975','2014-04-18','15:00:00',2.68),('8975','2014-04-18','15:05:00',1.61),('8975','2014-04-18','15:20:00',1.43),('8975','2014-04-18','15:25:00',1.85),('8975','2014-04-18','15:30:00',1.74),('8975','2014-04-18','15:35:00',1.16),('8975','2014-04-18','15:45:00',2.09),('8975','2014-04-18','15:50:00',5.91),('8975','2014-04-18','15:55:00',3.38),('8975','2014-04-18','16:00:00',2.81),('8975','2014-04-18','16:05:00',2.54),('8975','2014-04-18','16:10:00',2.31),('8975','2014-04-18','16:15:00',3.16),('8975','2014-04-18','16:20:00',3.4),('8975','2014-04-18','16:25:00',3.34),('8975','2014-04-18','16:30:00',3.22),('8975','2014-04-18','16:35:00',2.17),('8975','2014-04-18','16:40:00',1.62),('8975','2014-04-18','16:45:00',1.47),('8975','2014-04-18','16:50:00',1.25),('8975','2014-04-18','17:00:00',1.01),('8975','2014-04-18','17:05:00',1.62),('8975','2014-04-18','17:10:00',1.55),('8975','2014-04-18','17:15:00',1.79),('8975','2014-04-18','17:20:00',2.74),('8975','2014-04-18','17:25:00',1.95),('8975','2014-04-18','17:30:00',1.56),('8975','2014-04-18','17:35:00',1.42),('8975','2013-11-16','08:35:00',1.16),('8975','2013-11-16','08:40:00',2.45),('8975','2013-11-16','08:45:00',2.57),('8975','2013-11-16','08:50:00',3.41),('8975','2013-11-16','08:55:00',1.8),('8975','2013-11-16','09:00:00',2.78),('8975','2013-11-16','09:05:00',2.85),('8975','2013-11-16','09:10:00',3.05),('8975','2013-11-16','09:15:00',3.21),('8975','2013-11-16','09:20:00',3.17),('8975','2013-11-16','09:25:00',2.76),('8975','2013-11-16','09:30:00',2.65),('8975','2013-11-16','09:35:00',3.05),('8975','2013-11-16','09:40:00',3.13),('8975','2013-11-16','09:45:00',3.13),('8975','2013-11-16','09:50:00',3.17),('8975','2013-11-16','09:55:00',3.16),('8975','2013-11-16','10:00:00',3.2),('8975','2013-11-16','10:05:00',3.24),('8975','2013-11-16','10:10:00',3.26),('8975','2013-11-16','10:15:00',3.29),('8975','2013-11-16','10:20:00',3.32),('8975','2013-11-16','10:25:00',3.33),('8975','2013-11-16','10:30:00',3.36),('8975','2013-11-16','10:35:00',3.35),('8975','2013-11-16','10:40:00',3.36),('8975','2013-11-16','10:45:00',3.37),('8975','2013-11-16','10:50:00',3.37),('8975','2013-11-16','10:55:00',3.37),('8975','2013-11-16','11:00:00',3.36),('8975','2013-11-16','11:05:00',3.38),('8975','2013-11-16','11:10:00',3.37),('8975','2013-11-16','11:15:00',3.27),('8975','2013-11-16','11:20:00',3.2),('8975','2013-11-16','11:25:00',3.23),('8975','2013-11-16','11:30:00',3.03),('8975','2013-11-16','11:35:00',2.85),('8975','2013-11-16','11:40:00',3.05),('8975','2013-11-16','11:45:00',3.06),('8975','2013-11-16','11:50:00',3.02),('8975','2013-11-16','11:55:00',3),('8975','2013-11-16','12:00:00',2.99),('8975','2013-11-16','12:05:00',2.9),('8975','2013-11-16','12:10:00',2.9),('8975','2013-11-16','12:15:00',2.86),('8975','2013-11-16','12:20:00',2.8),('8975','2013-11-16','12:25:00',2.73),('8975','2013-11-16','12:30:00',2.68),('8975','2013-11-16','12:35:00',2.64),('8975','2013-11-16','12:40:00',2.63),('8975','2013-11-16','12:45:00',2.59),('8975','2013-11-16','12:50:00',2.49),('8975','2013-11-16','12:55:00',2.47),('8975','2013-11-16','13:00:00',2.32),('8975','2013-11-16','13:05:00',2.12),('8975','2013-11-16','13:10:00',2.16),('8975','2013-11-16','13:15:00',2.02),('8975','2013-11-16','13:20:00',2.08),('8975','2013-11-16','13:25:00',2.02),('8975','2013-11-16','13:30:00',1.51),('8975','2013-11-16','13:40:00',1.28),('8975','2013-11-16','13:45:00',1.1),('8975','2013-11-16','13:50:00',1.07),('8975','2013-11-16','13:55:00',1.02),('8975','2013-11-16','14:15:00',1.32),('8975','2013-11-16','14:20:00',1.2),('8975','2013-11-16','14:25:00',1.16),('8975','2013-11-16','14:30:00',1.13),('8975','2013-11-15','12:45:00',1),('8975','2013-11-15','12:50:00',1.15),('8975','2013-11-15','12:55:00',1.17),('8975','2013-11-15','13:00:00',1.32),('8975','2013-11-15','13:05:00',1.56),('8975','2013-11-15','13:10:00',1.29),('8975','2013-11-15','13:15:00',1.04),('8975','2013-11-14','08:00:00',1.23),('8975','2013-11-14','08:05:00',1.23),('8975','2013-11-14','08:10:00',1.65),('8975','2013-11-14','08:15:00',1.69),('8975','2013-11-14','08:20:00',1.1),('8975','2013-11-14','08:50:00',1.05),('8975','2013-11-14','08:55:00',1.16),('8975','2013-11-14','09:00:00',1.27),('8975','2013-11-14','09:05:00',1.5),('8975','2013-11-14','09:10:00',1.79),('8975','2013-11-14','09:15:00',1.75),('8975','2013-11-14','09:20:00',1.43),('8975','2013-11-14','09:25:00',1.73),('8975','2013-11-14','09:30:00',1.94),('8975','2013-11-14','09:35:00',1.71),('8975','2013-11-14','09:40:00',1.29),('8975','2013-11-14','10:05:00',1.36),('8975','2013-11-14','10:10:00',1.86),('8975','2013-11-14','10:15:00',2.04),('8975','2013-11-14','10:20:00',1.79),('8975','2013-11-14','10:25:00',1.49),('8975','2013-11-14','10:30:00',1.36),('8975','2013-11-14','10:35:00',1.28),('8975','2013-11-14','10:40:00',1.43),('8975','2013-11-14','10:45:00',2.08),('8975','2013-11-14','10:50:00',2.04),('8975','2013-11-14','10:55:00',2.06),('8975','2013-11-14','11:00:00',1.91),('8975','2013-11-14','11:05:00',1.84),('8975','2013-11-14','11:10:00',1.91),('8975','2013-11-14','11:15:00',2.12),('8975','2013-11-14','11:20:00',2.34),('8975','2013-11-14','11:25:00',2.34),('8975','2013-11-14','11:30:00',2.45),('8975','2013-11-14','11:35:00',2.33),('8975','2013-11-14','11:40:00',2.45),('8975','2013-11-14','11:45:00',2.26),('8975','2013-11-14','11:50:00',1.97),('8975','2013-11-14','11:55:00',1.78),('8975','2013-11-14','12:00:00',1.79),('8975','2013-11-14','12:05:00',1.82),('8975','2013-11-14','12:10:00',1.72),('8975','2013-11-14','12:15:00',1.78),('8975','2013-11-14','12:20:00',2.22),('8975','2013-11-14','12:25:00',1.95),('8975','2013-11-14','12:30:00',1.78),('8975','2013-11-14','12:35:00',1.67),('8975','2013-11-14','12:40:00',1.63),('8975','2013-11-14','12:45:00',1.64),('8975','2013-11-14','12:50:00',1.67),('8975','2013-11-14','12:55:00',1.71),('8975','2013-11-14','13:00:00',1.66),('8975','2013-11-14','13:05:00',1.44),('8975','2013-11-14','13:10:00',1.38),('8975','2013-11-14','13:15:00',1.22),('8975','2013-11-14','13:20:00',1.26),('8975','2013-11-14','13:25:00',1.43),('8975','2013-11-14','13:30:00',1.56),('8975','2013-11-14','13:35:00',1.67),('8975','2013-11-14','13:40:00',1.93),('8975','2013-11-14','13:45:00',1.67),('8975','2013-11-14','13:50:00',1.97),('8975','2013-11-14','13:55:00',1.65),('8975','2013-11-14','14:00:00',1.57),('8975','2013-11-14','14:05:00',1.27),('8975','2013-11-14','14:10:00',1.02),('8975','2013-11-13','08:10:00',1.1),('8975','2013-11-13','08:15:00',1.35),('8975','2013-11-13','08:20:00',1.65),('8975','2013-11-13','08:25:00',1.02),('8975','2013-11-13','08:30:00',1.48),('8975','2013-11-13','08:40:00',1.98),('8975','2013-11-13','08:45:00',1.45),('8975','2013-11-13','08:50:00',1.62),('8975','2013-11-13','08:55:00',2.87),('8975','2013-11-13','09:00:00',2.94),('8975','2013-11-13','09:05:00',3.23),('8975','2013-11-13','09:10:00',3.13),('8975','2013-11-13','09:15:00',2.95),('8975','2013-11-13','09:20:00',3.02),('8975','2013-11-13','09:25:00',3),('8975','2013-11-13','09:30:00',3.05),('8975','2013-11-13','09:35:00',3.11),('8975','2013-11-13','09:40:00',3.17),('8975','2013-11-13','09:45:00',3.23),('8975','2013-11-13','09:50:00',2.79),('8975','2013-11-13','09:55:00',2.42),('8975','2013-11-13','10:00:00',1.26),('8975','2013-11-13','10:15:00',1.63),('8975','2013-11-13','10:20:00',3.11),('8975','2013-11-13','10:25:00',3.32),('8975','2013-11-13','10:30:00',3.45),('8975','2013-11-13','10:35:00',3.45),('8975','2013-11-13','10:40:00',3.45),('8975','2013-11-13','10:45:00',3.37),('8975','2013-11-13','10:50:00',3.38),('8975','2013-11-13','10:55:00',3.4),('8975','2013-11-13','11:00:00',3.48),('8975','2013-11-13','11:05:00',3.43),('8975','2013-11-13','11:10:00',3.41),('8975','2013-11-13','11:15:00',3.32),('8975','2013-11-13','11:20:00',3.21),('8975','2013-11-13','11:25:00',3.44),('8975','2013-11-13','11:30:00',3.46),('8975','2013-11-13','11:35:00',3.2),('8975','2013-11-13','11:40:00',3.02),('8975','2013-11-13','11:45:00',1.16),('8975','2013-11-13','11:50:00',1.62),('8975','2013-11-13','11:55:00',1.15),('8975','2013-11-13','12:00:00',1.55),('8975','2013-11-13','12:05:00',2.14),('8975','2013-11-13','12:10:00',1.98),('8975','2013-11-13','12:15:00',2.03),('8975','2013-11-13','12:20:00',2.02),('8975','2013-11-13','12:25:00',1.86),('8975','2013-11-13','12:30:00',1.77),('8975','2013-11-13','12:35:00',1.77),('8975','2013-11-13','12:40:00',1.73),('8975','2013-11-13','12:45:00',1.77),('8975','2013-11-13','12:50:00',1.75),('8975','2013-11-13','12:55:00',1.67),('8975','2013-11-13','13:00:00',1.61),('8975','2013-11-13','13:05:00',1.41),('8975','2013-11-13','13:10:00',1.25),('8975','2013-11-13','13:15:00',1.28),('8975','2013-11-13','13:20:00',1.32),('8975','2013-11-13','13:25:00',1.31),('8975','2013-11-13','13:30:00',1.39),('8975','2013-11-13','13:35:00',1.38),('8975','2013-11-13','13:40:00',1.32),('8975','2013-11-13','13:45:00',1.29),('8975','2013-11-13','13:50:00',1.38),('8975','2013-11-13','13:55:00',1.25),('8975','2013-11-13','14:00:00',1.48),('8975','2013-11-13','14:05:00',1.55),('8975','2013-11-13','14:10:00',1.24),('8975','2013-11-13','14:15:00',1.13),('8975','2013-11-13','14:20:00',1.12),('8975','2013-11-13','14:25:00',1.04),('8975','2013-11-12','08:15:00',1.11),('8975','2013-11-12','09:55:00',1),('8975','2013-11-12','10:00:00',1.53),('8975','2013-11-12','10:05:00',1.83),('8975','2013-11-12','10:10:00',1.75),('8975','2013-11-12','10:15:00',3.18),('8975','2013-11-12','10:20:00',3.4),('8975','2013-11-12','10:25:00',3.75),('8975','2013-11-12','10:30:00',4.6),('8975','2013-11-12','10:35:00',4.61),('8975','2013-11-12','10:40:00',4.9),('8975','2013-11-12','10:45:00',4.54),('8975','2013-11-12','10:50:00',4.41),('8975','2013-11-12','10:55:00',2.92),('8975','2013-11-12','11:00:00',1.37),('8975','2013-11-12','11:05:00',1.38),('8975','2013-11-12','11:10:00',1.36),('8975','2013-11-12','11:15:00',1.44),('8975','2013-11-12','11:20:00',1.47),('8975','2013-11-12','11:25:00',1.52),('8975','2013-11-12','11:30:00',1.64),('8975','2013-11-12','11:35:00',1.53),('8975','2013-11-12','11:40:00',1.43),('8975','2013-11-12','11:45:00',1.62),('8975','2013-11-12','11:50:00',1.7),('8975','2013-11-12','11:55:00',1.52),('8975','2013-11-12','12:00:00',1.18),('8975','2013-11-12','12:05:00',1.09),('8975','2013-11-12','12:10:00',1.21),('8975','2013-11-12','12:15:00',1.28),('8975','2013-11-12','12:20:00',1.19),('8975','2013-11-12','12:25:00',1.18),('8975','2013-11-12','12:30:00',1),('8975','2013-11-12','12:35:00',1.04),('8975','2013-11-12','12:40:00',1.17),('8975','2013-11-12','12:45:00',1.09),('8975','2013-11-12','12:50:00',1.15),('8975','2013-11-12','12:55:00',1.55),('8975','2013-11-12','13:00:00',1.75),('8975','2013-11-12','13:05:00',1.87),('8975','2013-11-12','13:10:00',1.73),('8975','2013-11-12','13:15:00',1.68),('8975','2013-11-12','13:20:00',1.36),('8975','2013-11-12','13:25:00',1.21),('8975','2013-11-12','13:30:00',1.27),('8975','2013-11-12','13:35:00',1.34),('8975','2013-11-12','13:40:00',1.41),('8975','2013-11-12','13:45:00',1.22),('8975','2013-11-12','13:50:00',1.13),('8975','2013-11-12','13:55:00',1.34),('8975','2013-11-12','14:00:00',1.65),('8975','2013-11-12','14:05:00',1.72),('8975','2013-11-12','14:10:00',1.74),('8975','2013-11-12','14:15:00',1.75),('8975','2013-11-12','14:20:00',1.67),('8975','2013-11-12','14:25:00',1.76),('8975','2013-11-12','14:30:00',1.62),('8975','2013-11-12','14:35:00',1.33),('8975','2013-11-12','14:40:00',1.15),('8975','2013-11-12','14:45:00',1.01),('8975','2013-11-11','10:00:00',1.2),('8975','2013-11-11','10:55:00',1.09),('8975','2013-11-11','11:00:00',1.16),('8975','2013-11-11','11:10:00',1.26),('8975','2013-11-11','11:15:00',1.29),('8975','2013-11-11','11:20:00',1.31),('8975','2013-11-11','11:25:00',2.22),('8975','2013-11-11','11:30:00',1.43),('8975','2013-11-11','11:35:00',1.64),('8975','2013-11-11','11:40:00',2.08),('8975','2013-11-11','11:45:00',1.71),('8975','2013-11-11','11:50:00',1.87),('8975','2013-11-11','11:55:00',1.59),('8975','2013-11-11','12:00:00',3.09),('8975','2013-11-11','12:05:00',2.09),('8975','2013-11-11','12:10:00',1.27),('8975','2013-11-11','12:15:00',1.31),('8975','2013-11-11','12:20:00',1.37),('8975','2013-11-11','12:25:00',1.82),('8975','2013-11-11','12:30:00',2.86),('8975','2013-11-11','12:35:00',4.26),('8975','2013-11-11','12:40:00',3.07),('8975','2013-11-11','12:45:00',3.02),('8975','2013-11-11','12:50:00',2.79),('8975','2013-11-11','12:55:00',2.99),('8975','2013-11-11','13:00:00',2.7),('8975','2013-11-11','13:05:00',2.43),('8975','2013-11-11','13:10:00',2),('8975','2013-11-11','13:15:00',2.23),('8975','2013-11-11','13:20:00',2.52),('8975','2013-11-11','13:25:00',2.38),('8975','2013-11-11','13:30:00',2.59),('8975','2013-11-11','13:35:00',2.84),('8975','2013-11-11','13:40:00',2.93),('8975','2013-11-11','13:45:00',2.42),('8975','2013-11-11','13:50:00',1.93),('8975','2013-11-11','13:55:00',2.52),('8975','2013-11-11','14:00:00',1.86),('8975','2013-11-11','14:05:00',1.53),('8975','2013-11-11','14:10:00',2.25),('8975','2013-11-11','14:15:00',2.43),('8975','2013-11-11','14:20:00',2.38),('8975','2013-11-11','14:25:00',2.11),('8975','2013-11-11','14:30:00',1.45),('8975','2013-11-11','14:35:00',1.85),('8975','2013-11-11','14:40:00',1.17),('8975','2013-11-11','14:55:00',1.19),('8975','2013-11-11','15:00:00',1.06),('8975','2013-11-10','09:45:00',1.56),('8975','2013-11-10','09:50:00',1.78),('8975','2013-11-10','09:55:00',1.57),('8975','2013-11-10','10:00:00',1.14),('8975','2013-11-10','10:05:00',1.56),('8975','2013-11-10','10:10:00',2.51),('8975','2013-11-10','10:15:00',3.01),('8975','2013-11-10','10:20:00',2.35),('8975','2013-11-10','10:25:00',1.25),('8975','2013-11-10','10:30:00',1.05),('8975','2013-11-10','10:35:00',1.1),('8975','2013-11-10','11:00:00',2.31),('8975','2013-11-10','11:05:00',4.3),('8975','2013-11-10','11:10:00',4.43),('8975','2013-11-10','11:15:00',4.2),('8975','2013-11-10','11:20:00',1.67),('8975','2013-11-10','11:25:00',2.15),('8975','2013-11-10','11:30:00',4.71),('8975','2013-11-10','11:35:00',3.45),('8975','2013-11-10','11:40:00',3.71),('8975','2013-11-10','11:45:00',2.47),('8975','2013-11-10','11:50:00',3.59),('8975','2013-11-10','11:55:00',2.34),('8975','2013-11-10','12:00:00',2.49),('8975','2013-11-10','12:05:00',2.62),('8975','2013-11-10','12:10:00',3.45),('8975','2013-11-10','12:15:00',3.27),('8975','2013-11-10','12:20:00',3.03),('8975','2013-11-10','12:25:00',1.73),('8975','2013-11-10','12:30:00',1.2),('8975','2013-11-10','12:35:00',1.27),('8975','2013-11-10','12:40:00',2.74),('8975','2013-11-10','12:45:00',1.88),('8975','2013-11-10','12:50:00',3.12),('8975','2013-11-10','12:55:00',2.44),('8975','2013-11-10','13:00:00',2.32),('8975','2013-11-10','13:05:00',2.14),('8975','2013-11-10','13:10:00',2.08),('8975','2013-11-10','13:15:00',2.1),('8975','2013-11-10','13:30:00',1.23),('8975','2013-11-10','13:35:00',1.14),('8975','2013-11-10','13:40:00',1.29),('8975','2013-11-10','13:55:00',1.22),('8975','2013-11-10','14:00:00',2.32),('8975','2013-11-10','14:05:00',1.43),('8975','2013-11-10','14:10:00',1.4),('8975','2013-11-10','14:15:00',1.23),('8975','2013-11-10','14:20:00',1.08),('8975','2013-11-10','14:25:00',1.16),('8975','2013-11-10','14:30:00',1.49),('8975','2013-11-10','14:35:00',1.51),('8975','2013-11-10','14:40:00',1.1),('8975','2013-11-09','07:35:00',1.46),('8975','2013-11-09','07:40:00',1.6),('8975','2013-11-09','07:45:00',2.17),('8975','2013-11-09','07:50:00',2.18),('8975','2013-11-09','07:55:00',2.06),('8975','2013-11-09','08:00:00',2.41),('8975','2013-11-09','08:05:00',1.23),('8975','2013-11-09','08:10:00',1.04),('8975','2013-11-09','08:15:00',1.23),('8975','2013-11-09','08:20:00',1.35),('8975','2013-11-09','08:25:00',1.3),('8975','2013-11-09','08:30:00',2.04),('8975','2013-11-09','08:35:00',1.57),('8975','2013-11-09','08:40:00',1.64),('8975','2013-11-09','08:45:00',2.93),('8975','2013-11-09','08:50:00',2.95),('8975','2013-11-09','08:55:00',2.37),('8975','2013-11-09','09:00:00',2.37),('8975','2013-11-09','09:05:00',1.89),('8975','2013-11-09','09:10:00',1.62),('8975','2013-11-09','09:15:00',2.34),('8975','2013-11-09','09:20:00',2.92),('8975','2013-11-09','09:25:00',3.35),('8975','2013-11-09','09:30:00',2.71),('8975','2013-11-09','09:35:00',2.7),('8975','2013-11-09','09:40:00',3.14),('8975','2013-11-09','09:45:00',3.24),('8975','2013-11-09','09:50:00',2.89),('8975','2013-11-09','09:55:00',3.52),('8975','2013-11-09','10:00:00',3.4),('8975','2013-11-09','10:05:00',3.09),('8975','2013-11-09','10:10:00',2.33),('8975','2013-11-09','10:15:00',3.27),('8975','2013-11-09','10:20:00',1.94),('8975','2013-11-09','10:25:00',1.98),('8975','2013-11-09','10:30:00',3.14),('8975','2013-11-09','10:35:00',2.07),('8975','2013-11-09','10:40:00',2.31),('8975','2013-11-09','10:45:00',4.02),('8975','2013-11-09','10:50:00',3.75),('8975','2013-11-09','10:55:00',3.87),('8975','2013-11-09','11:00:00',1.69),('8975','2013-11-09','11:05:00',1.44),('8975','2013-11-09','11:10:00',1.44),('8975','2013-11-09','11:15:00',1.18),('8975','2013-11-09','11:20:00',1.52),('8975','2013-11-09','11:25:00',2.34),('8975','2013-11-09','11:30:00',1.57),('8975','2013-11-09','11:35:00',1.67),('8975','2013-11-09','11:40:00',2.99),('8975','2013-11-09','11:45:00',2.83),('8975','2013-11-09','11:50:00',1.82),('8975','2013-11-09','11:55:00',1.46),('8975','2013-11-09','12:00:00',1.28),('8975','2013-11-09','12:05:00',1.39),('8975','2013-11-09','12:15:00',2.28),('8975','2013-11-09','12:20:00',3.28),('8975','2013-11-09','12:25:00',3.27),('8975','2013-11-09','12:30:00',3.37),('8975','2013-11-09','12:35:00',1.11),('8975','2013-11-09','12:40:00',2.63),('8975','2013-11-09','12:45:00',3.27),('8975','2013-11-09','12:50:00',3.48),('8975','2013-11-09','12:55:00',2.91),('8975','2013-11-09','13:00:00',1.69),('8975','2013-11-09','13:05:00',1.09),('8975','2013-11-09','13:10:00',1.15),('8975','2013-11-09','13:35:00',1.12),('8975','2013-11-09','13:40:00',1.13),('8975','2013-11-09','13:45:00',1.3),('8975','2013-11-09','13:50:00',1.62),('8975','2013-11-09','13:55:00',1.5),('8975','2013-11-09','14:20:00',1.17),('8975','2013-11-09','14:25:00',1.03),('8975','2013-11-09','14:30:00',1.39),('8975','2013-11-08','09:10:00',1.31),('8975','2013-11-08','09:15:00',1.36),('8975','2013-11-08','09:20:00',1.02),('8975','2013-11-08','09:30:00',1.01),('8975','2013-11-08','09:40:00',2.09),('8975','2013-11-08','09:45:00',2.99),('8975','2013-11-08','09:50:00',4.43),('8975','2013-11-08','09:55:00',3.84),('8975','2013-11-08','10:00:00',3.95),('8975','2013-11-08','10:05:00',4.13),('8975','2013-11-08','10:10:00',3.28),('8975','2013-11-08','10:15:00',3.1),('8975','2013-11-08','10:20:00',2.8),('8975','2013-11-08','10:25:00',1.57),('8975','2013-11-08','10:30:00',1.78),('8975','2013-11-08','10:35:00',2.31),('8975','2013-11-08','10:40:00',2.23),('8975','2013-11-08','10:45:00',2.63),('8975','2013-11-08','10:50:00',2.6),('8975','2013-11-08','10:55:00',2.73),('8975','2013-11-08','11:00:00',3.77),('8975','2013-11-08','11:05:00',3.01),('8975','2013-11-08','11:10:00',3.74),('8975','2013-11-08','11:15:00',4.27),('8975','2013-11-08','11:20:00',4.34),('8975','2013-11-08','11:25:00',2.76),('8975','2013-11-08','11:30:00',3.43),('8975','2013-11-08','11:35:00',2.83),('8975','2013-11-08','11:40:00',2.11),('8975','2013-11-08','11:45:00',3.92),('8975','2013-11-08','11:50:00',2.52),('8975','2013-11-08','11:55:00',3.07),('8975','2013-11-08','12:00:00',4.2),('8975','2013-11-08','12:05:00',3.26),('8975','2013-11-08','12:10:00',2.23),('8975','2013-11-08','12:15:00',1.8),('8975','2013-11-08','12:20:00',2.1),('8975','2013-11-08','12:25:00',2.9),('8975','2013-11-08','12:30:00',3.74),('8975','2013-11-08','12:35:00',3.93),('8975','2013-11-08','12:40:00',2.54),('8975','2013-11-08','12:45:00',1.25),('8975','2013-11-08','12:50:00',1.68),('8975','2013-11-08','12:55:00',2.68),('8975','2013-11-08','13:00:00',2.42),('8975','2013-11-08','13:05:00',3.15),('8975','2013-11-08','13:10:00',2.38),('8975','2013-11-08','13:15:00',1.87),('8975','2013-11-08','13:20:00',2.27),('8975','2013-11-08','13:25:00',2.17),('8975','2013-11-08','13:30:00',2.12),('8975','2013-11-08','13:35:00',2.02),('8975','2013-11-08','13:40:00',1.9),('8975','2013-11-08','13:45:00',2.04),('8975','2013-11-08','13:50:00',2.06),('8975','2013-11-08','13:55:00',2.07),('8975','2013-11-08','14:00:00',1.85),('8975','2013-11-08','14:05:00',1.27),('8975','2013-11-08','14:15:00',1.28),('8975','2013-11-08','14:20:00',1.69),('8975','2013-11-08','14:25:00',1.24),('8975','2013-11-08','14:35:00',1),('8975','2013-11-08','14:40:00',1.49),('8975','2013-11-08','14:45:00',1.18),('8975','2013-11-08','14:50:00',1.11),('8975','2013-11-08','15:30:00',1.18),('8975','2013-11-08','15:35:00',1.15),('8975','2013-11-07','08:35:00',1.06),('8975','2013-11-07','08:40:00',2.13),('8975','2013-11-07','08:45:00',2.59),('8975','2013-11-07','08:50:00',1.25),('8975','2013-11-07','09:00:00',1.36),('8975','2013-11-07','09:05:00',2.06),('8975','2013-11-07','09:10:00',2.41),('8975','2013-11-07','09:15:00',1.18),('8975','2013-11-07','09:20:00',1.16),('8975','2013-11-07','09:30:00',1.29),('8975','2013-11-07','09:35:00',1.97),('8975','2013-11-07','09:40:00',4.15),('8975','2013-11-07','09:45:00',3.59),('8975','2013-11-07','09:50:00',3.33),('8975','2013-11-07','09:55:00',3.51),('8975','2013-11-07','10:00:00',3.82),('8975','2013-11-07','10:05:00',3.16),('8975','2013-11-07','10:10:00',2.13),('8975','2013-11-07','10:15:00',2.73),('8975','2013-11-07','10:20:00',2.96),('8975','2013-11-07','10:25:00',3.32),('8975','2013-11-07','10:30:00',1.6),('8975','2013-11-07','10:55:00',1.16),('8975','2013-11-07','11:00:00',1.78),('8975','2013-11-07','11:05:00',1.52),('8975','2013-11-07','11:10:00',1.9),('8975','2013-11-07','11:50:00',2.09),('8975','2013-11-07','11:55:00',1.02),('8975','2013-11-07','12:05:00',2.08),('8975','2013-11-07','12:10:00',3.41),('8975','2013-11-07','12:15:00',3.53),('8975','2013-11-07','12:20:00',3.54),('8975','2013-11-07','12:25:00',3.74),('8975','2013-11-07','12:30:00',3.69),('8975','2013-11-07','12:35:00',3.57),('8975','2013-11-07','12:40:00',3.37),('8975','2013-11-07','12:45:00',3.27),('8975','2013-11-07','12:50:00',3.18),('8975','2013-11-07','12:55:00',2.98),('8975','2013-11-07','13:00:00',1.41),('8975','2013-11-07','13:10:00',2.05),('8975','2013-11-07','13:15:00',2.59),('8975','2013-11-07','13:20:00',2.18),('8975','2013-11-07','13:25:00',1.73),('8975','2013-11-07','13:30:00',1.72),('8975','2013-11-07','13:35:00',1.02),('8975','2013-11-07','13:40:00',1.16),('8975','2013-11-07','13:45:00',1.08),('8975','2013-11-07','13:50:00',2.06),('8975','2013-11-07','13:55:00',1.92),('8975','2013-11-07','14:00:00',1.82),('8975','2013-11-07','14:05:00',1.71),('8975','2013-11-07','14:10:00',1.72),('8975','2013-11-07','14:15:00',1.66),('8975','2013-11-07','14:20:00',1.56),('8975','2013-11-07','14:25:00',1.45),('8975','2013-11-07','14:35:00',1.19),('8975','2013-11-07','14:40:00',1.41),('8975','2013-11-07','14:45:00',1.41),('8975','2013-11-07','15:20:00',1.11),('8975','2014-04-17','07:55:00',1.07),('8975','2014-04-17','08:00:00',1.83),('8975','2014-04-17','08:05:00',3.79),('8975','2014-04-17','08:10:00',3.98),('8975','2014-04-17','08:15:00',1.53),('8975','2014-04-17','08:20:00',1.13),('8975','2014-04-17','08:25:00',1.1),('8975','2014-04-17','08:30:00',1.16),('8975','2014-04-17','08:35:00',2.06),('8975','2014-04-17','08:40:00',2.3),('8975','2014-04-17','08:45:00',3.21),('8975','2014-04-17','08:50:00',2.16),('8975','2014-04-17','08:55:00',1.75),('8975','2014-04-17','09:00:00',1.9),('8975','2014-04-17','09:05:00',4.12),('8975','2014-04-17','09:10:00',6.07),('8975','2014-04-17','09:15:00',5.57),('8975','2014-04-17','09:20:00',5.44),('8975','2014-04-17','09:25:00',3.14),('8975','2014-04-17','09:30:00',5.8),('8975','2014-04-17','09:35:00',4.29),('8975','2014-04-17','09:40:00',2.29),('8975','2014-04-17','09:45:00',3.18),('8975','2014-04-17','09:50:00',4.65),('8975','2014-04-17','09:55:00',5.04),('8975','2014-04-17','10:00:00',4.72),('8975','2014-04-17','10:05:00',3.4),('8975','2014-04-17','10:10:00',2.63),('8975','2014-04-17','10:15:00',3.08),('8975','2014-04-17','10:20:00',2.45),('8975','2014-04-17','10:25:00',2.4),('8975','2014-04-17','10:30:00',2.13),('8975','2014-04-17','10:35:00',1.89),('8975','2014-04-17','10:40:00',2.05),('8975','2014-04-17','10:45:00',3.35),('8975','2014-04-17','10:50:00',3.42),('8975','2014-04-17','10:55:00',3.2),('8975','2014-04-17','11:00:00',3),('8975','2014-04-17','11:05:00',2.66),('8975','2014-04-17','11:10:00',2.84),('8975','2014-04-17','11:15:00',5.28),('8975','2014-04-17','11:20:00',3.47),('8975','2014-04-17','11:25:00',2.37),('8975','2014-04-17','11:30:00',2.64),('8975','2014-04-17','11:35:00',2.78),('8975','2014-04-17','11:40:00',2.71),('8975','2014-04-17','11:45:00',2.55),('8975','2014-04-17','11:50:00',2.95),('8975','2014-04-17','11:55:00',2.71),('8975','2014-04-17','12:00:00',2.92),('8975','2014-04-17','12:05:00',5.17),('8975','2014-04-17','12:10:00',7.25),('8975','2014-04-17','12:15:00',6.61),('8975','2014-04-17','12:20:00',4.46),('8975','2014-04-17','12:25:00',5.84),('8975','2014-04-17','12:30:00',6.73),('8975','2014-04-17','12:35:00',6.69),('8975','2014-04-17','12:40:00',7.15),('8975','2014-04-17','12:45:00',5.83),('8975','2014-04-17','12:50:00',6.68),('8975','2014-04-17','12:55:00',4.91),('8975','2014-04-17','13:00:00',4.64),('8975','2014-04-17','13:05:00',3.42),('8975','2014-04-17','13:10:00',3.47),('8975','2014-04-17','13:15:00',3.61),('8975','2014-04-17','13:20:00',3.27),('8975','2014-04-17','13:25:00',2.78),('8975','2014-04-17','13:30:00',2.28),('8975','2014-04-17','13:35:00',2.41),('8975','2014-04-17','13:40:00',2.25),('8975','2014-04-17','13:45:00',1.86),('8975','2014-04-17','13:50:00',1.92),('8975','2014-04-17','13:55:00',3.06),('8975','2014-04-17','14:00:00',3),('8975','2014-04-17','14:05:00',2.93),('8975','2014-04-17','14:10:00',2.46),('8975','2014-04-17','14:15:00',2.14),('8975','2014-04-17','14:20:00',2.44),('8975','2014-04-17','14:25:00',3.1),('8975','2014-04-17','14:30:00',3.42),('8975','2014-04-17','14:35:00',3.62),('8975','2014-04-17','14:40:00',3.14),('8975','2014-04-17','14:45:00',3.57),('8975','2014-04-17','14:50:00',4.21),('8975','2014-04-17','14:55:00',3.82),('8975','2014-04-17','15:00:00',5.01),('8975','2014-04-17','15:05:00',4.53),('8975','2014-04-17','15:10:00',2.89),('8975','2014-04-17','15:15:00',3.17),('8975','2014-04-17','15:20:00',2.76),('8975','2014-04-17','15:25:00',3.54),('8975','2014-04-17','15:30:00',5.53),('8975','2014-04-17','15:35:00',5.03),('8975','2014-04-17','15:40:00',4.61),('8975','2014-04-17','15:45:00',2.18),('8975','2014-04-17','15:50:00',3.13),('8975','2014-04-17','15:55:00',3.15),('8975','2014-04-17','16:00:00',3.18),('8975','2014-04-17','16:05:00',2.68),('8975','2014-04-17','16:10:00',2.33),('8975','2014-04-17','16:15:00',2.08),('8975','2014-04-17','16:20:00',1.98),('8975','2014-04-17','16:25:00',3.37),('8975','2014-04-17','16:30:00',3.36),('8975','2014-04-17','16:35:00',4.09),('8975','2014-04-17','16:40:00',3.37),('8975','2014-04-17','16:45:00',2.22),('8975','2014-04-17','16:50:00',2.44),('8975','2014-04-17','16:55:00',2.54),('8975','2014-04-17','17:00:00',2.31),('8975','2014-04-17','17:05:00',3.19),('8975','2014-04-17','17:10:00',2.51),('8975','2014-04-17','17:15:00',2.23),('8975','2014-04-17','17:20:00',1.97),('8975','2014-04-17','17:25:00',2.02),('8975','2014-04-17','17:30:00',1.83),('8975','2014-04-17','17:35:00',1.77),('8975','2014-04-17','17:40:00',1.7),('8975','2014-04-17','17:45:00',1.62),('8975','2014-04-17','17:50:00',1.57),('8975','2014-04-17','17:55:00',1.52),('8975','2014-04-17','18:00:00',1.47),('8975','2014-04-17','18:05:00',1.41),('8975','2014-04-17','18:10:00',1.36),('8975','2014-04-17','18:15:00',1.3),('8975','2014-04-17','18:20:00',1.22),('8975','2014-04-17','18:25:00',1.11),('8975','2013-11-06','07:20:00',1.04),('8975','2013-11-06','07:25:00',1.24),('8975','2013-11-06','07:30:00',1.41),('8975','2013-11-06','07:35:00',1.59),('8975','2013-11-06','07:40:00',1.74),('8975','2013-11-06','07:45:00',1.85),('8975','2013-11-06','07:50:00',1.95),('8975','2013-11-06','07:55:00',2.05),('8975','2013-11-06','08:00:00',2.14),('8975','2013-11-06','08:05:00',2.24),('8975','2013-11-06','08:10:00',2.32),('8975','2013-11-06','08:15:00',2.4),('8975','2013-11-06','08:20:00',2.46),('8975','2013-11-06','08:25:00',2.53),('8975','2013-11-06','08:30:00',2.59),('8975','2013-11-06','08:35:00',2.65),('8975','2013-11-06','08:40:00',2.72),('8975','2013-11-06','08:45:00',2.8),('8975','2013-11-06','08:50:00',2.85),('8975','2013-11-06','08:55:00',2.92),('8975','2013-11-06','09:00:00',2.99),('8975','2013-11-06','09:05:00',3.04),('8975','2013-11-06','09:10:00',3.06),('8975','2013-11-06','09:15:00',3.09),('8975','2013-11-06','09:20:00',3.11),('8975','2013-11-06','09:25:00',3.18),('8975','2013-11-06','09:30:00',3.25),('8975','2013-11-06','09:35:00',3.3),('8975','2013-11-06','09:40:00',3.37),('8975','2013-11-06','09:45:00',3.42),('8975','2013-11-06','09:50:00',3.33),('8975','2013-11-06','09:55:00',3.41),('8975','2013-11-06','10:00:00',3.43),('8975','2013-11-06','10:05:00',3.41),('8975','2013-11-06','10:10:00',3.44),('8975','2013-11-06','10:15:00',3.43),('8975','2013-11-06','10:20:00',3.44),('8975','2013-11-06','10:25:00',3.5),('8975','2013-11-06','10:30:00',3.53),('8975','2013-11-06','10:35:00',3.5),('8975','2013-11-06','10:40:00',3.54),('8975','2013-11-06','10:45:00',3.51),('8975','2013-11-06','10:50:00',3.48),('8975','2013-11-06','10:55:00',3.47),('8975','2013-11-06','11:00:00',3.48),('8975','2013-11-06','11:05:00',3.48),('8975','2013-11-06','11:10:00',3.46),('8975','2013-11-06','11:15:00',3.24),('8975','2013-11-06','11:20:00',3.07),('8975','2013-11-06','11:25:00',3.3),('8975','2013-11-06','11:30:00',3.24),('8975','2013-11-06','11:35:00',3.17),('8975','2013-11-06','11:40:00',3.25),('8975','2013-11-06','11:45:00',3.2),('8975','2013-11-06','11:50:00',3.14),('8975','2013-11-06','11:55:00',3.08),('8975','2013-11-06','12:00:00',3.1),('8975','2013-11-06','12:05:00',3.06),('8975','2013-11-06','12:10:00',2.99),('8975','2013-11-06','12:15:00',2.96),('8975','2013-11-06','12:20:00',2.89),('8975','2013-11-06','12:25:00',2.8),('8975','2013-11-06','12:30:00',2.71),('8975','2013-11-06','12:35:00',2.75),('8975','2013-11-06','12:40:00',2.47),('8975','2013-11-06','12:45:00',2.79),('8975','2013-11-06','12:50:00',2.63),('8975','2013-11-06','12:55:00',2.7),('8975','2013-11-06','13:00:00',2.17),('8975','2013-11-06','13:05:00',2.98),('8975','2013-11-06','13:10:00',2.64),('8975','2013-11-06','13:15:00',2.14),('8975','2013-11-06','13:20:00',2.77),('8975','2013-11-06','13:25:00',3.16),('8975','2013-11-06','13:30:00',3.09),('8975','2013-11-06','13:35:00',2.61),('8975','2013-11-06','13:40:00',2.54),('8975','2013-11-06','13:45:00',2.14),('8975','2013-11-06','13:50:00',1.63),('8975','2013-11-06','13:55:00',1.66),('8975','2013-11-06','14:00:00',2.08),('8975','2013-11-06','14:05:00',1.55),('8975','2013-11-06','14:10:00',1.21),('8975','2013-11-06','14:15:00',1.22),('8975','2013-11-06','14:20:00',1.27),('8975','2013-11-06','14:25:00',1.56),('8975','2013-11-06','14:30:00',1.87),('8975','2013-11-06','14:35:00',1.63),('8975','2013-11-06','14:40:00',1.36),('8975','2013-11-06','14:45:00',1.34),('8975','2013-11-06','14:50:00',1.3),('8975','2013-11-06','14:55:00',1.25),('8975','2013-11-06','15:00:00',1.2),('8975','2013-11-06','15:05:00',1.18),('8975','2013-11-06','15:10:00',1.12),('8975','2013-11-06','15:15:00',1.09),('8975','2013-11-06','15:20:00',1.08),('8975','2013-11-06','15:25:00',1.02),('8975','2013-11-05','08:00:00',1.64),('8975','2013-11-05','08:05:00',1.89),('8975','2013-11-05','08:10:00',2.39),('8975','2013-11-05','08:15:00',2.69),('8975','2013-11-05','08:20:00',2.25),('8975','2013-11-05','08:25:00',1.16),('8975','2013-11-05','08:35:00',2.82),('8975','2013-11-05','08:40:00',2.87),('8975','2013-11-05','08:45:00',2.93),('8975','2013-11-05','08:50:00',3.1),('8975','2013-11-05','08:55:00',3.06),('8975','2013-11-05','09:00:00',1.92),('8975','2013-11-05','09:05:00',1.94),('8975','2013-11-05','09:10:00',2.05),('8975','2013-11-05','09:15:00',2.64),('8975','2013-11-05','09:20:00',2.73),('8975','2013-11-05','09:25:00',3.3),('8975','2013-11-05','09:30:00',3.42),('8975','2013-11-05','09:35:00',3.47),('8975','2013-11-05','09:40:00',3.53),('8975','2013-11-05','09:45:00',3.52),('8975','2013-11-05','09:50:00',3.5),('8975','2013-11-05','09:55:00',3.57),('8975','2013-11-05','10:00:00',3.6),('8975','2013-11-05','10:05:00',3.64),('8975','2013-11-05','10:10:00',3.68),('8975','2013-11-05','10:15:00',3.71),('8975','2013-11-05','10:20:00',3.74),('8975','2013-11-05','10:25:00',3.79),('8975','2013-11-05','10:30:00',3.79),('8975','2013-11-05','10:35:00',3.79),('8975','2013-11-05','10:40:00',3.78),('8975','2013-11-05','10:45:00',3.78),('8975','2013-11-05','10:50:00',3.78),('8975','2013-11-05','10:55:00',3.79),('8975','2013-11-05','11:00:00',3.79),('8975','2013-11-05','11:05:00',3.74),('8975','2013-11-05','11:10:00',3.72),('8975','2013-11-05','11:15:00',3.44),('8975','2013-11-05','11:20:00',3.31),('8975','2013-11-05','11:25:00',3.59),('8975','2013-11-05','11:30:00',3.49),('8975','2013-11-05','11:35:00',3.44),('8975','2013-11-05','11:40:00',3.51),('8975','2013-11-05','11:45:00',3.49),('8975','2013-11-05','11:50:00',3.43),('8975','2013-11-05','11:55:00',3.37),('8975','2013-11-05','12:00:00',3.37),('8975','2013-11-05','12:05:00',3.31),('8975','2013-11-05','12:10:00',3.31),('8975','2013-11-05','12:15:00',3.2),('8975','2013-11-05','12:20:00',3.18),('8975','2013-11-05','12:25:00',3.02),('8975','2013-11-05','12:30:00',2.87),('8975','2013-11-05','12:35:00',2.98),('8975','2013-11-05','12:40:00',2.98),('8975','2013-11-05','12:45:00',2.95),('8975','2013-11-05','12:50:00',2.87),('8975','2013-11-05','12:55:00',2.81),('8975','2013-11-05','13:00:00',2.75),('8975','2013-11-05','13:05:00',2.57),('8975','2013-11-05','13:10:00',2.5),('8975','2013-11-05','13:15:00',2.42),('8975','2013-11-05','13:20:00',2.36),('8975','2013-11-05','13:25:00',2.33),('8975','2013-11-05','13:30:00',2.15),('8975','2013-11-05','13:35:00',2.05),('8975','2013-11-05','13:40:00',2.08),('8975','2013-11-05','13:45:00',2.02),('8975','2013-11-05','13:50:00',1.92),('8975','2013-11-05','13:55:00',1.91),('8975','2013-11-05','14:00:00',1.84),('8975','2013-11-05','14:05:00',1.76),('8975','2013-11-05','14:10:00',1.67),('8975','2013-11-05','14:15:00',1.61),('8975','2013-11-05','14:20:00',1.54),('8975','2013-11-05','14:25:00',1.48),('8975','2013-11-05','14:30:00',1.43),('8975','2013-11-05','14:35:00',1.36),('8975','2013-11-05','14:40:00',1.31),('8975','2013-11-05','14:45:00',1.29),('8975','2013-11-05','14:50:00',1.26),('8975','2013-11-05','14:55:00',1.24),('8975','2013-11-05','15:00:00',1.2),('8975','2013-11-05','15:05:00',1.18),('8975','2013-11-05','15:10:00',1.16),('8975','2013-11-05','15:15:00',1.13),('8975','2013-11-05','15:20:00',1.09),('8975','2013-11-05','15:25:00',1.05),('8975','2013-11-05','15:30:00',1.01),('8975','2013-11-04','08:15:00',1.17),('8975','2013-11-04','08:20:00',1.02),('8975','2013-11-04','08:25:00',2.56),('8975','2013-11-04','08:30:00',2.81),('8975','2013-11-04','08:35:00',3.28),('8975','2013-11-04','08:40:00',3.33),('8975','2013-11-04','08:45:00',1.93),('8975','2013-11-04','08:50:00',1.13),('8975','2013-11-04','09:55:00',1.13),('8975','2013-11-04','10:00:00',1.24),('8975','2013-11-04','10:05:00',1.02),('8975','2013-11-04','10:10:00',1.04),('8975','2013-11-04','10:15:00',2.06),('8975','2013-11-04','10:20:00',3.69),('8975','2013-11-04','10:25:00',3.76),('8975','2013-11-04','10:30:00',2.4),('8975','2013-11-04','10:35:00',2.5),('8975','2013-11-04','10:40:00',2.11),('8975','2013-11-04','10:45:00',2.29),('8975','2013-11-04','10:50:00',2.06),('8975','2013-11-04','10:55:00',1.89),('8975','2013-11-04','11:00:00',1.6),('8975','2013-11-04','11:05:00',1.24),('8975','2013-11-04','11:20:00',1.02),('8975','2013-11-04','11:25:00',1.19),('8975','2013-11-04','11:30:00',1.38),('8975','2013-11-04','11:35:00',1.88),('8975','2013-11-04','11:40:00',2.28),('8975','2013-11-04','11:45:00',2.15),('8975','2013-11-04','11:50:00',2),('8975','2013-11-04','11:55:00',1.86),('8975','2013-11-04','12:00:00',2),('8975','2013-11-04','12:05:00',2.33),('8975','2013-11-04','12:10:00',2.41),('8975','2013-11-04','12:15:00',2.16),('8975','2013-11-04','12:20:00',2.08),('8975','2013-11-04','12:25:00',2.09),('8975','2013-11-04','12:30:00',1.94),('8975','2013-11-04','12:35:00',1.67),('8975','2013-11-04','12:40:00',1.46),('8975','2013-11-04','12:45:00',1.17),('8975','2013-11-04','12:50:00',1.15),('8975','2013-11-04','12:55:00',1.39),('8975','2013-11-04','13:00:00',1.38),('8975','2013-11-04','13:05:00',1.32),('8975','2013-11-04','13:10:00',1.31),('8975','2013-11-04','13:25:00',1.28),('8975','2013-11-04','13:30:00',1.95),('8975','2013-11-04','13:35:00',2.61),('8975','2013-11-04','13:40:00',2.48),('8975','2013-11-04','13:45:00',2.25),('8975','2013-11-04','13:50:00',2.28),('8975','2013-11-04','13:55:00',3.19),('8975','2013-11-04','14:00:00',2.51),('8975','2013-11-04','14:05:00',1.81),('8975','2013-11-04','14:10:00',1.06),('8975','2013-11-04','14:25:00',1.55),('8975','2013-11-04','14:30:00',2.16),('8975','2013-11-04','14:35:00',1.91),('8975','2013-11-04','14:40:00',1.75),('8975','2013-11-04','14:45:00',1.48),('8975','2013-11-04','15:00:00',1.05),('8975','2013-11-03','07:50:00',1.87),('8975','2013-11-03','07:55:00',2.02),('8975','2013-11-03','08:00:00',2.1),('8975','2013-11-03','08:05:00',2.16),('8975','2013-11-03','08:10:00',2.24),('8975','2013-11-03','08:15:00',2.35),('8975','2013-11-03','08:20:00',2.44),('8975','2013-11-03','08:25:00',2.52),('8975','2013-11-03','08:30:00',2.53),('8975','2013-11-03','08:35:00',2.36),('8975','2013-11-03','08:40:00',2.35),('8975','2013-11-03','08:45:00',1.66),('8975','2013-11-03','08:50:00',1.26),('8975','2013-11-03','09:10:00',1.43),('8975','2013-11-03','09:15:00',1.26),('8975','2013-11-03','09:20:00',3.74),('8975','2013-11-03','09:25:00',3.14),('8975','2013-11-03','10:00:00',2.15),('8975','2013-11-03','10:05:00',3.53),('8975','2013-11-03','10:10:00',3.59),('8975','2013-11-03','10:15:00',3.88),('8975','2013-11-03','10:20:00',3.97),('8975','2013-11-03','10:25:00',3.39),('8975','2013-11-03','10:30:00',2.72),('8975','2013-11-03','10:35:00',2.89),('8975','2013-11-03','10:40:00',2.4),('8975','2013-11-03','10:45:00',1.73),('8975','2013-11-03','10:50:00',2.04),('8975','2013-11-03','10:55:00',3.12),('8975','2013-11-03','11:00:00',4.02),('8975','2013-11-03','11:05:00',4.47),('8975','2013-11-03','11:10:00',4.86),('8975','2013-11-03','11:15:00',3.76),('8975','2013-11-03','11:20:00',2.55),('8975','2013-11-03','11:25:00',2.89),('8975','2013-11-03','11:30:00',2.54),('8975','2013-11-03','11:35:00',2.51),('8975','2013-11-03','11:40:00',2.68),('8975','2013-11-03','11:45:00',2.48),('8975','2013-11-03','11:50:00',4.01),('8975','2013-11-03','11:55:00',3.84),('8975','2013-11-03','12:00:00',3.85),('8975','2013-11-03','12:05:00',3.53),('8975','2013-11-03','12:10:00',3.33),('8975','2013-11-03','12:15:00',3.49),('8975','2013-11-03','12:20:00',3.45),('8975','2013-11-03','12:25:00',3.29),('8975','2013-11-03','12:30:00',3.33),('8975','2013-11-03','12:35:00',2.95),('8975','2013-11-03','12:40:00',3.22),('8975','2013-11-03','12:45:00',2.81),('8975','2013-11-03','12:50:00',3.1),('8975','2013-11-03','12:55:00',2.98),('8975','2013-11-03','13:00:00',2.9),('8975','2013-11-03','13:05:00',2.74),('8975','2013-11-03','13:10:00',2.53),('8975','2013-11-03','13:15:00',2.66),('8975','2013-11-03','13:20:00',2.46),('8975','2013-11-03','13:25:00',2.27),('8975','2013-11-03','13:30:00',1.94),('8975','2013-11-03','13:35:00',2.05),('8975','2013-11-03','13:40:00',1.58),('8975','2013-11-03','13:45:00',2.21),('8975','2013-11-03','13:50:00',2.17),('8975','2013-11-03','13:55:00',1.62),('8975','2013-11-03','14:00:00',1.9),('8975','2013-11-03','14:05:00',2.03),('8975','2013-11-03','14:10:00',1.75),('8975','2013-11-03','14:15:00',2),('8975','2013-11-03','14:20:00',2.1),('8975','2013-11-03','14:25:00',1.61),('8975','2013-11-03','14:30:00',1.29),('8975','2013-11-03','14:35:00',1.49),('8975','2013-11-03','14:40:00',1.42),('8975','2013-11-03','14:45:00',1.55),('8975','2013-11-03','14:50:00',1.02),('8975','2013-11-03','14:55:00',1.58),('8975','2013-11-03','15:00:00',1.33),('8975','2013-11-03','15:10:00',1.31),('8975','2013-11-03','15:15:00',1.05),('8975','2013-11-03','15:20:00',1.16),('8975','2013-11-03','15:25:00',1.44),('8975','2013-11-03','15:30:00',1.4),('8975','2013-11-03','15:35:00',1.11),('8975','2013-11-03','15:40:00',1.41),('8975','2013-11-03','15:45:00',1.34),('8975','2013-11-02','07:30:00',1.62),('8975','2013-11-02','07:35:00',1.63),('8975','2013-11-02','07:40:00',1.57),('8975','2013-11-02','07:45:00',2.07),('8975','2013-11-02','07:50:00',1.34),('8975','2013-11-02','07:55:00',1.47),('8975','2013-11-02','08:00:00',1.8),('8975','2013-11-02','08:05:00',1.68),('8975','2013-11-02','08:10:00',1.48),('8975','2013-11-02','08:15:00',1.57),('8975','2013-11-02','08:20:00',2.25),('8975','2013-11-02','08:25:00',1.95),('8975','2013-11-02','08:30:00',1.73),('8975','2013-11-02','08:35:00',2.16),('8975','2013-11-02','08:40:00',2.46),('8975','2013-11-02','08:45:00',2.46),('8975','2013-11-02','08:50:00',1.65),('8975','2013-11-02','08:55:00',2.03),('8975','2013-11-02','09:00:00',2.12),('8975','2013-11-02','09:05:00',2.95),('8975','2013-11-02','09:10:00',1.2),('8975','2013-11-02','09:35:00',1.42),('8975','2013-11-02','09:40:00',3.61),('8975','2013-11-02','09:45:00',3.32),('8975','2013-11-02','09:50:00',1.25),('8975','2013-11-02','10:05:00',2.72),('8975','2013-11-02','10:10:00',2.53),('8975','2013-11-02','10:15:00',1.43),('8975','2013-11-02','10:20:00',3.22),('8975','2013-11-02','10:25:00',2.99),('8975','2013-11-02','10:30:00',2.48),('8975','2013-11-02','11:10:00',1.11),('8975','2013-11-02','11:15:00',1.3),('8975','2013-11-02','11:20:00',2.04),('8975','2013-11-02','11:25:00',1.2),('8975','2013-11-02','11:30:00',2.18),('8975','2013-11-02','11:35:00',2.68),('8975','2013-11-02','11:40:00',3.49),('8975','2013-11-02','11:45:00',3.64),('8975','2013-11-02','11:50:00',3.87),('8975','2013-11-02','11:55:00',4.35),('8975','2013-11-02','12:00:00',4.29),('8975','2013-11-02','12:05:00',4.06),('8975','2013-11-02','12:10:00',4.13),('8975','2013-11-02','12:15:00',3.85),('8975','2013-11-02','12:20:00',4.14),('8975','2013-11-02','12:25:00',3.91),('8975','2013-11-02','12:30:00',3.68),('8975','2013-11-02','12:35:00',2.57),('8975','2013-11-02','12:40:00',1.72),('8975','2013-11-02','12:45:00',1.44),('8975','2013-11-02','12:50:00',1.26),('8975','2013-11-02','13:10:00',1.13),('8975','2013-11-02','13:15:00',1.21),('8975','2013-11-02','13:20:00',1.29),('8975','2013-11-02','13:25:00',1.62),('8975','2013-11-02','13:30:00',1.55),('8975','2013-11-02','13:35:00',1.23),('8975','2013-11-02','13:40:00',1.39),('8975','2013-11-02','13:45:00',1.65),('8975','2013-11-02','13:50:00',1.9),('8975','2013-11-02','13:55:00',2.07),('8975','2013-11-02','14:00:00',1.88),('8975','2013-11-02','14:05:00',2.01),('8975','2013-11-02','14:10:00',1.54),('8975','2013-11-02','14:15:00',1.4),('8975','2013-11-02','14:20:00',1.5),('8975','2013-11-02','14:25:00',1.29),('8975','2013-11-02','14:30:00',1.29),('8975','2013-11-02','14:35:00',1.02),('8975','2013-11-02','14:40:00',1.1),('8975','2013-11-02','15:10:00',1.01),('8975','2013-11-02','15:15:00',1.31),('8975','2013-11-01','07:50:00',1.78),('8975','2013-11-01','07:55:00',1.91),('8975','2013-11-01','08:00:00',2.08),('8975','2013-11-01','08:05:00',2.14),('8975','2013-11-01','08:10:00',2.21),('8975','2013-11-01','08:15:00',2.28),('8975','2013-11-01','08:20:00',2.35),('8975','2013-11-01','08:25:00',2.45),('8975','2013-11-01','08:30:00',2.53),('8975','2013-11-01','08:35:00',2.59),('8975','2013-11-01','08:40:00',2.67),('8975','2013-11-01','08:45:00',2.77),('8975','2013-11-01','08:50:00',2.83),('8975','2013-11-01','08:55:00',2.92),('8975','2013-11-01','09:00:00',3.02),('8975','2013-11-01','09:05:00',3.32),('8975','2013-11-01','09:10:00',3.42),('8975','2013-11-01','09:15:00',2.79),('8975','2013-11-01','09:20:00',1.19),('8975','2013-11-01','09:25:00',1.27),('8975','2013-11-01','09:30:00',2.45),('8975','2013-11-01','09:35:00',2.24),('8975','2013-11-01','09:40:00',3.03),('8975','2013-11-01','09:45:00',2.58),('8975','2013-11-01','09:50:00',1.38),('8975','2013-11-01','09:55:00',3),('8975','2013-11-01','10:00:00',3.78),('8975','2013-11-01','10:05:00',4.19),('8975','2013-11-01','10:10:00',2.57),('8975','2013-11-01','10:15:00',1.99),('8975','2013-11-01','10:20:00',1.37),('8975','2013-11-01','10:25:00',1.11),('8975','2013-11-01','10:30:00',1.28),('8975','2013-11-01','10:35:00',1.62),('8975','2013-11-01','10:40:00',1.24),('8975','2013-11-01','10:50:00',1.34),('8975','2013-11-01','10:55:00',1.99),('8975','2013-11-01','11:00:00',2.23),('8975','2013-11-01','11:05:00',1.87),('8975','2013-11-01','11:10:00',1.22),('8975','2013-11-01','11:30:00',1.13),('8975','2013-11-01','11:35:00',1.34),('8975','2013-11-01','11:40:00',1.49),('8975','2013-11-01','11:45:00',1.51),('8975','2013-11-01','11:50:00',2.94),('8975','2013-11-01','11:55:00',3.5),('8975','2013-11-01','12:00:00',4.25),('8975','2013-11-01','12:05:00',2.38),('8975','2013-11-01','12:10:00',2.57),('8975','2013-11-01','12:15:00',3.69),('8975','2013-11-01','12:20:00',3.46),('8975','2013-11-01','12:25:00',3.23),('8975','2013-11-01','12:30:00',3.44),('8975','2013-11-01','12:35:00',3.28),('8975','2013-11-01','12:40:00',3.31),('8975','2013-11-01','12:45:00',3.37),('8975','2013-11-01','12:50:00',2.86),('8975','2013-11-01','12:55:00',3.21),('8975','2013-11-01','13:00:00',3.14),('8975','2013-11-01','13:05:00',3.25),('8975','2013-11-01','13:10:00',2.96),('8975','2013-11-01','13:15:00',1.91),('8975','2013-11-01','13:20:00',1.65),('8975','2013-11-01','13:25:00',2.51),('8975','2013-11-01','13:30:00',2.5),('8975','2013-11-01','13:35:00',2.16),('8975','2013-11-01','13:40:00',2.76),('8975','2013-11-01','13:45:00',2.6),('8975','2013-11-01','13:50:00',2.65),('8975','2013-11-01','13:55:00',2.71),('8975','2013-11-01','14:00:00',2.28),('8975','2013-11-01','14:05:00',2.04),('8975','2013-11-01','14:10:00',1.93),('8975','2013-11-01','14:15:00',1.82),('8975','2013-11-01','14:20:00',1.71),('8975','2013-11-01','14:25:00',1.62),('8975','2013-11-01','14:30:00',1.54),('8975','2013-11-01','14:35:00',1.48),('8975','2013-11-01','14:40:00',1.42),('8975','2013-11-01','14:45:00',1.42),('8975','2013-11-01','14:50:00',1.4),('8975','2013-11-01','14:55:00',1.35),('8975','2013-11-01','15:00:00',1.29),('8975','2013-11-01','15:05:00',1.29),('8975','2013-11-01','15:10:00',1.21),('8975','2013-11-01','15:30:00',1.1),('8975','2013-11-01','15:40:00',1.07),('8975','2013-11-01','15:45:00',1.1),('8975','2013-11-01','15:50:00',1.13),('8975','2013-10-31','07:20:00',1.04),('8975','2013-10-31','07:25:00',1.19),('8975','2013-10-31','07:30:00',1.36),('8975','2013-10-31','07:35:00',1.48),('8975','2013-10-31','07:40:00',1.54),('8975','2013-10-31','07:45:00',1.7),('8975','2013-10-31','07:50:00',1.64),('8975','2013-10-31','07:55:00',1.46),('8975','2013-10-31','08:00:00',1.61),('8975','2013-10-31','08:05:00',1.59),('8975','2013-10-31','08:10:00',1.46),('8975','2013-10-31','08:15:00',1.92),('8975','2013-10-31','08:20:00',2.14),('8975','2013-10-31','08:25:00',2.26),('8975','2013-10-31','08:30:00',2.45),('8975','2013-10-31','08:35:00',2.58),('8975','2013-10-31','08:40:00',2.73),('8975','2013-10-31','08:45:00',2.75),('8975','2013-10-31','08:50:00',2.8),('8975','2013-10-31','08:55:00',2.72),('8975','2013-10-31','09:00:00',2.82),('8975','2013-10-31','09:05:00',3.04),('8975','2013-10-31','09:10:00',3.08),('8975','2013-10-31','09:15:00',3.12),('8975','2013-10-31','09:20:00',3.18),('8975','2013-10-31','09:25:00',3.25),('8975','2013-10-31','09:30:00',3.32),('8975','2013-10-31','09:35:00',3.4),('8975','2013-10-31','09:40:00',3.45),('8975','2013-10-31','09:45:00',3.38),('8975','2013-10-31','09:50:00',3.49),('8975','2013-10-31','09:55:00',3.51),('8975','2013-10-31','10:00:00',3.57),('8975','2013-10-31','10:05:00',3.61),('8975','2013-10-31','10:10:00',3.65),('8975','2013-10-31','10:15:00',3.62),('8975','2013-10-31','10:20:00',3.65),('8975','2013-10-31','10:25:00',3.71),('8975','2013-10-31','10:30:00',3.62),('8975','2013-10-31','10:35:00',3.69),('8975','2013-10-31','10:40:00',3.42),('8975','2013-10-31','10:45:00',3.61),('8975','2013-10-31','10:50:00',3.67),('8975','2013-10-31','10:55:00',3.72),('8975','2013-10-31','11:00:00',3.41),('8975','2013-10-31','11:05:00',2.97),('8975','2013-10-31','11:10:00',3.4),('8975','2013-10-31','11:15:00',3.51),('8975','2013-10-31','11:20:00',3.75),('8975','2013-10-31','11:25:00',3.85),('8975','2013-10-31','11:30:00',3.66),('8975','2013-10-31','11:35:00',3.51),('8975','2013-10-31','11:40:00',3.16),('8975','2013-10-31','11:45:00',3.26),('8975','2013-10-31','11:50:00',3.54),('8975','2013-10-31','11:55:00',3.62),('8975','2013-10-31','12:00:00',3.62),('8975','2013-10-31','12:05:00',3.48),('8975','2013-10-31','12:10:00',3.34),('8975','2013-10-31','12:15:00',1.36),('8975','2013-10-31','12:20:00',1.16),('8975','2013-10-31','12:25:00',1.28),('8975','2013-10-31','12:30:00',1.18),('8975','2013-10-31','13:05:00',1.02),('8975','2013-10-31','13:10:00',1.29),('8975','2013-10-31','13:15:00',1.64),('8975','2013-10-31','13:20:00',1.8),('8975','2013-10-31','13:25:00',1.37),('8975','2013-10-31','13:30:00',1.52),('8975','2013-10-31','13:35:00',1.41),('8975','2013-10-31','13:40:00',1.44),('8975','2013-10-31','13:45:00',1.31),('8975','2013-10-31','13:50:00',1.27),('8975','2013-10-31','13:55:00',1.21),('8975','2013-10-31','14:00:00',1.18),('8975','2013-10-31','14:05:00',1.16),('8975','2013-10-31','14:10:00',1.07),('8975','2013-10-31','14:15:00',1.05),('8975','2013-10-30','08:10:00',1.05),('8975','2013-10-30','08:15:00',1.68),('8975','2013-10-30','08:20:00',2.08),('8975','2013-10-30','08:25:00',2.35),('8975','2013-10-30','08:30:00',2.38),('8975','2013-10-30','08:35:00',2.42),('8975','2013-10-30','08:40:00',2.63),('8975','2013-10-30','08:45:00',1.79),('8975','2013-10-30','08:50:00',1.78),('8975','2013-10-30','08:55:00',2.2),('8975','2013-10-30','09:00:00',1.77),('8975','2013-10-30','09:05:00',1.88),('8975','2013-10-30','09:10:00',1.5),('8975','2013-10-30','09:15:00',2.47),('8975','2013-10-30','09:20:00',2.64),('8975','2013-10-30','09:25:00',2.87),('8975','2013-10-30','09:30:00',2.22),('8975','2013-10-30','09:35:00',2.08),('8975','2013-10-30','09:40:00',1.76),('8975','2013-10-30','09:45:00',2.11),('8975','2013-10-30','09:50:00',2.61),('8975','2013-10-30','09:55:00',2.74),('8975','2013-10-30','10:00:00',2.76),('8975','2013-10-30','10:05:00',2.58),('8975','2013-10-30','10:10:00',2.48),('8975','2013-10-30','10:15:00',2.3),('8975','2013-10-30','10:20:00',2.31),('8975','2013-10-30','10:25:00',2.39),('8975','2013-10-30','10:30:00',2.67),('8975','2013-10-30','10:35:00',2.74),('8975','2013-10-30','10:40:00',2.55),('8975','2013-10-30','10:45:00',2.48),('8975','2013-10-30','10:50:00',2.61),('8975','2013-10-30','10:55:00',2.92),('8975','2013-10-30','11:00:00',3.8),('8975','2013-10-30','11:05:00',3.73),('8975','2013-10-30','11:10:00',2.96),('8975','2013-10-30','11:15:00',3.81),('8975','2013-10-30','11:20:00',3.37),('8975','2013-10-30','11:25:00',3.34),('8975','2013-10-30','11:30:00',3.15),('8975','2013-10-30','11:35:00',3.31),('8975','2013-10-30','11:40:00',3.59),('8975','2013-10-30','11:45:00',3.58),('8975','2013-10-30','11:50:00',3.53),('8975','2013-10-30','11:55:00',3.48),('8975','2013-10-30','12:00:00',3.46),('8975','2013-10-30','12:05:00',3.4),('8975','2013-10-30','12:10:00',3.27),('8975','2013-10-30','12:15:00',3.31),('8975','2013-10-30','12:20:00',3.24),('8975','2013-10-30','12:25:00',3.19),('8975','2013-10-30','12:30:00',2.98),('8975','2013-10-30','12:35:00',2.99),('8975','2013-10-30','12:40:00',3.01),('8975','2013-10-30','12:45:00',3.05),('8975','2013-10-30','12:50:00',3.24),('8975','2013-10-30','12:55:00',3.15),('8975','2013-10-30','13:00:00',3.06),('8975','2013-10-30','13:05:00',3),('8975','2013-10-30','13:10:00',2.73),('8975','2013-10-30','13:15:00',2.71),('8975','2013-10-30','13:20:00',2.48),('8975','2013-10-30','13:25:00',2.47),('8975','2013-10-30','13:30:00',2.34),('8975','2013-10-30','13:35:00',2.15),('8975','2013-10-30','13:40:00',1.91),('8975','2013-10-30','13:45:00',1.3),('8975','2013-10-30','13:50:00',1.36),('8975','2013-10-30','13:55:00',1.93),('8975','2013-10-30','14:00:00',1.99),('8975','2013-10-30','14:05:00',1.41),('8975','2013-10-30','14:55:00',1.2),('8975','2013-10-30','15:00:00',1.09),('8975','2013-10-30','15:05:00',1.06),('8975','2013-10-29','07:35:00',1.11),('8975','2013-10-29','07:40:00',1.3),('8975','2013-10-29','07:45:00',1.47),('8975','2013-10-29','07:50:00',1.6),('8975','2013-10-29','07:55:00',1.63),('8975','2013-10-29','08:00:00',1.7),('8975','2013-10-29','08:05:00',1.85),('8975','2013-10-29','08:10:00',1.96),('8975','2013-10-29','08:15:00',2),('8975','2013-10-29','08:20:00',2.1),('8975','2013-10-29','08:25:00',2.22),('8975','2013-10-29','08:30:00',2.31),('8975','2013-10-29','08:35:00',2.44),('8975','2013-10-29','08:40:00',2.55),('8975','2013-10-29','08:45:00',2.64),('8975','2013-10-29','08:50:00',2.68),('8975','2013-10-29','08:55:00',2.7),('8975','2013-10-29','09:00:00',2.81),('8975','2013-10-29','09:05:00',3.02),('8975','2013-10-29','09:10:00',3.08),('8975','2013-10-29','09:15:00',3.1),('8975','2013-10-29','09:20:00',3.2),('8975','2013-10-29','09:25:00',3.27),('8975','2013-10-29','09:30:00',3.27),('8975','2013-10-29','09:35:00',3.28),('8975','2013-10-29','09:40:00',3.36),('8975','2013-10-29','09:45:00',3.31),('8975','2013-10-29','09:50:00',3.26),('8975','2013-10-29','09:55:00',3.19),('8975','2013-10-29','10:00:00',3.31),('8975','2013-10-29','10:05:00',3.15),('8975','2013-10-29','10:10:00',3.35),('8975','2013-10-29','10:15:00',3.01),('8975','2013-10-29','10:20:00',3.43),('8975','2013-10-29','10:25:00',3.17),('8975','2013-10-29','10:30:00',2.68),('8975','2013-10-29','10:35:00',1.43),('8975','2013-10-29','10:40:00',1.67),('8975','2013-10-29','10:45:00',1.18),('8975','2013-10-29','10:50:00',2.94),('8975','2013-10-29','10:55:00',2.16),('8975','2013-10-29','11:00:00',2.12),('8975','2013-10-29','11:05:00',3.83),('8975','2013-10-29','11:10:00',3.88),('8975','2013-10-29','11:15:00',3.8),('8975','2013-10-29','11:20:00',3.08),('8975','2013-10-29','11:25:00',2.55),('8975','2013-10-29','11:30:00',1.78),('8975','2013-10-29','11:35:00',1.56),('8975','2013-10-29','11:40:00',2.34),('8975','2013-10-29','11:45:00',1.86),('8975','2013-10-29','11:50:00',1.28),('8975','2013-10-29','11:55:00',1.51),('8975','2013-10-29','12:00:00',1.72),('8975','2013-10-29','12:05:00',1.61),('8975','2013-10-29','12:10:00',1.82),('8975','2013-10-29','12:15:00',2.95),('8975','2013-10-29','12:20:00',1.59),('8975','2013-10-29','12:25:00',1.74),('8975','2013-10-29','12:30:00',1.32),('8975','2013-10-29','12:35:00',1.24),('8975','2013-10-29','12:40:00',1.35),('8975','2013-10-29','12:45:00',1.17),('8975','2013-10-29','12:50:00',1.23),('8975','2013-10-29','12:55:00',1.86),('8975','2013-10-29','13:00:00',2.97),('8975','2013-10-29','13:05:00',3.24),('8975','2013-10-29','13:10:00',2.87),('8975','2013-10-29','13:15:00',2.86),('8975','2013-10-29','13:20:00',2.71),('8975','2013-10-29','13:25:00',2.09),('8975','2013-10-29','13:30:00',2.51),('8975','2013-10-29','13:35:00',2.89),('8975','2013-10-29','13:40:00',2.37),('8975','2013-10-29','13:45:00',2.27),('8975','2013-10-29','13:50:00',1.28),('8975','2013-10-29','13:55:00',2),('8975','2013-10-29','14:00:00',2.4),('8975','2013-10-29','14:05:00',1.35),('8975','2013-10-29','14:20:00',1.95),('8975','2013-10-29','14:25:00',1.92),('8975','2013-10-29','14:55:00',1.03),('8975','2013-10-29','15:00:00',1.13),('8975','2013-10-29','15:05:00',1.11),('8975','2013-10-29','15:10:00',1.06),('8975','2013-10-29','15:15:00',1.23),('8975','2013-10-29','15:20:00',1.14),('8975','2013-10-28','08:10:00',1.25),('8975','2013-10-28','08:15:00',1.18),('8975','2013-10-28','08:20:00',1.37),('8975','2013-10-28','08:25:00',1.54),('8975','2013-10-28','08:30:00',1.93),('8975','2013-10-28','08:35:00',2.66),('8975','2013-10-28','08:40:00',2.14),('8975','2013-10-28','08:45:00',2.99),('8975','2013-10-28','08:50:00',2.99),('8975','2013-10-28','08:55:00',3.04),('8975','2013-10-28','09:00:00',3.1),('8975','2013-10-28','09:05:00',3.11),('8975','2013-10-28','09:10:00',3.11),('8975','2013-10-28','09:15:00',3.18),('8975','2013-10-28','09:20:00',3.24),('8975','2013-10-28','09:25:00',3.3),('8975','2013-10-28','09:30:00',3.5),('8975','2013-10-28','09:35:00',3.37),('8975','2013-10-28','09:40:00',3.13),('8975','2013-10-28','09:45:00',3.71),('8975','2013-10-28','09:50:00',3.72),('8975','2013-10-28','09:55:00',2.89),('8975','2013-10-28','10:00:00',2.73),('8975','2013-10-28','10:05:00',3.85),('8975','2013-10-28','10:10:00',3.45),('8975','2013-10-28','10:15:00',3.5),('8975','2013-10-28','10:20:00',3.63),('8975','2013-10-28','10:25:00',2.94),('8975','2013-10-28','10:30:00',3.68),('8975','2013-10-28','10:35:00',4.27),('8975','2013-10-28','10:40:00',4.41),('8975','2013-10-28','10:45:00',3.93),('8975','2013-10-28','10:50:00',3.85),('8975','2013-10-28','10:55:00',3.03),('8975','2013-10-28','11:00:00',3.97),('8975','2013-10-28','11:05:00',4.01),('8975','2013-10-28','11:10:00',4.01),('8975','2013-10-28','11:15:00',3.96),('8975','2013-10-28','11:20:00',3.84),('8975','2013-10-28','11:25:00',3.3),('8975','2013-10-28','11:30:00',3.37),('8975','2013-10-28','11:35:00',2.73),('8975','2013-10-28','11:40:00',2.83),('8975','2013-10-28','11:45:00',3.34),('8975','2013-10-28','11:50:00',3.34),('8975','2013-10-28','11:55:00',3.46),('8975','2013-10-28','12:00:00',3.52),('8975','2013-10-28','12:05:00',3.46),('8975','2013-10-28','12:10:00',3.39),('8975','2013-10-28','12:15:00',3.32),('8975','2013-10-28','12:20:00',3.26),('8975','2013-10-28','12:25:00',3.26),('8975','2013-10-28','12:30:00',3.2),('8975','2013-10-28','12:35:00',3.21),('8975','2013-10-28','12:40:00',2.97),('8975','2013-10-28','12:45:00',2.93),('8975','2013-10-28','12:50:00',2.87),('8975','2013-10-28','12:55:00',2.94),('8975','2013-10-28','13:00:00',2.85),('8975','2013-10-28','13:05:00',2.85),('8975','2013-10-28','13:10:00',2.72),('8975','2013-10-28','13:15:00',2.51),('8975','2013-10-28','13:20:00',2.52),('8975','2013-10-28','13:25:00',2.53),('8975','2013-10-28','13:30:00',2.37),('8975','2013-10-28','13:35:00',2.2),('8975','2013-10-28','13:40:00',2.26),('8975','2013-10-28','13:45:00',2.18),('8975','2013-10-28','13:50:00',2.14),('8975','2013-10-28','13:55:00',2.13),('8975','2013-10-28','14:00:00',1.97),('8975','2013-10-28','14:05:00',1.91),('8975','2013-10-28','14:10:00',1.78),('8975','2013-10-28','14:15:00',1.51),('8975','2013-10-28','14:20:00',1.48),('8975','2013-10-28','14:25:00',1.35),('8975','2013-10-28','14:30:00',1.41),('8975','2013-10-28','14:35:00',1.5),('8975','2013-10-28','14:40:00',1.31),('8975','2013-10-28','14:45:00',1.27),('8975','2013-10-28','14:50:00',1.16),('8975','2013-10-28','14:55:00',1.28),('8975','2013-10-28','15:00:00',1.27),('8975','2013-10-28','15:05:00',1),('8975','2013-10-28','15:15:00',1.17),('8975','2013-10-28','15:20:00',1.12),('8975','2013-10-28','15:25:00',1.07),('8975','2013-10-28','15:30:00',1.02),('8975','2014-04-16','07:55:00',2.39),('8975','2014-04-16','08:00:00',3.16),('8975','2014-04-16','08:05:00',3.47),('8975','2014-04-16','08:10:00',3.59),('8975','2014-04-16','08:15:00',3.69),('8975','2014-04-16','08:20:00',3.7),('8975','2014-04-16','08:25:00',3.82),('8975','2014-04-16','08:30:00',3.95),('8975','2014-04-16','08:35:00',4.03),('8975','2014-04-16','08:40:00',4.14),('8975','2014-04-16','08:45:00',4.25),('8975','2014-04-16','08:50:00',4.35),('8975','2014-04-16','08:55:00',4.25),('8975','2014-04-16','09:00:00',3.71),('8975','2014-04-16','09:05:00',4.37),('8975','2014-04-16','09:10:00',4.8),('8975','2014-04-16','09:15:00',4.78),('8975','2014-04-16','09:20:00',5.02),('8975','2014-04-16','09:25:00',5.1),('8975','2014-04-16','09:30:00',5.18),('8975','2014-04-16','09:35:00',5.25),('8975','2014-04-16','09:40:00',5.37),('8975','2014-04-16','09:45:00',5.52),('8975','2014-04-16','09:50:00',5.59),('8975','2014-04-16','09:55:00',5.76),('8975','2014-04-16','10:00:00',5.95),('8975','2014-04-16','10:05:00',6.34),('8975','2014-04-16','10:10:00',6.42),('8975','2014-04-16','10:15:00',4.61),('8975','2014-04-16','10:20:00',4.96),('8975','2014-04-16','10:25:00',6.68),('8975','2014-04-16','10:30:00',7.02),('8975','2014-04-16','10:35:00',7.32),('8975','2014-04-16','10:40:00',6.96),('8975','2014-04-16','10:45:00',6.8),('8975','2014-04-16','10:50:00',4.77),('8975','2014-04-16','10:55:00',4.31),('8975','2014-04-16','11:00:00',4.49),('8975','2014-04-16','11:05:00',5.15),('8975','2014-04-16','11:10:00',5.52),('8975','2014-04-16','11:15:00',3.79),('8975','2014-04-16','11:20:00',3.97),('8975','2014-04-16','11:25:00',7.13),('8975','2014-04-16','11:30:00',4.51),('8975','2014-04-16','11:35:00',3.58),('8975','2014-04-16','11:40:00',3.18),('8975','2014-04-16','11:45:00',6.69),('8975','2014-04-16','11:50:00',5.58),('8975','2014-04-16','11:55:00',4.2),('8975','2014-04-16','12:00:00',3.97),('8975','2014-04-16','12:05:00',4.85),('8975','2014-04-16','12:10:00',4.14),('8975','2014-04-16','12:15:00',3.69),('8975','2014-04-16','12:20:00',3.84),('8975','2014-04-16','12:25:00',4.25),('8975','2014-04-16','12:30:00',4.77),('8975','2014-04-16','12:35:00',4.88),('8975','2014-04-16','12:40:00',6.15),('8975','2014-04-16','12:45:00',6.38),('8975','2014-04-16','12:50:00',6.48),('8975','2014-04-16','12:55:00',6.3),('8975','2014-04-16','13:00:00',2.27),('8975','2014-04-16','13:05:00',5.28),('8975','2014-04-16','13:10:00',7.15),('8975','2014-04-16','13:15:00',7.3),('8975','2014-04-16','13:20:00',6.01),('8975','2014-04-16','13:25:00',1.8),('8975','2014-04-16','13:30:00',2.65),('8975','2014-04-16','13:35:00',6.85),('8975','2014-04-16','13:40:00',4.79),('8975','2014-04-16','13:45:00',1.71),('8975','2014-04-16','13:50:00',1.48),('8975','2014-04-16','13:55:00',1.7),('8975','2014-04-16','14:00:00',2.11),('8975','2014-04-16','14:05:00',1.77),('8975','2014-04-16','14:10:00',1.73),('8975','2014-04-16','14:15:00',2.13),('8975','2014-04-16','14:20:00',3.82),('8975','2014-04-16','14:25:00',2.23),('8975','2014-04-16','14:30:00',2.92),('8975','2014-04-16','14:35:00',2.75),('8975','2014-04-16','14:40:00',2.75),('8975','2014-04-16','14:45:00',2.86),('8975','2014-04-16','14:50:00',1.71),('8975','2014-04-16','14:55:00',1.3),('8975','2014-04-16','15:00:00',1.18),('8975','2014-04-16','15:05:00',1.29),('8975','2014-04-16','15:10:00',1.32),('8975','2014-04-16','15:15:00',1.2),('8975','2014-04-16','15:20:00',1.12),('8975','2014-04-16','15:25:00',1.35),('8975','2014-04-16','15:30:00',2.08),('8975','2014-04-16','15:35:00',2.83),('8975','2014-04-16','15:40:00',3.48),('8975','2014-04-16','15:45:00',2.63),('8975','2014-04-16','15:50:00',1.95),('8975','2014-04-16','15:55:00',1.96),('8975','2014-04-16','16:00:00',1.87),('8975','2014-04-16','16:05:00',1.54),('8975','2014-04-16','16:10:00',1.64),('8975','2014-04-16','16:15:00',1.74),('8975','2014-04-16','16:20:00',1.71),('8975','2014-04-16','16:25:00',1.73),('8975','2014-04-16','16:30:00',1.85),('8975','2014-04-16','16:35:00',1.75),('8975','2014-04-16','16:40:00',1.84),('8975','2014-04-16','16:45:00',2.8),('8975','2014-04-16','16:50:00',2.96),('8975','2014-04-16','16:55:00',2),('8975','2014-04-16','17:00:00',1.57),('8975','2014-04-16','17:05:00',1.35),('8975','2014-04-16','17:10:00',1.26),('8975','2014-04-16','17:15:00',1.42),('8975','2014-04-16','17:20:00',1.61),('8975','2014-04-16','17:25:00',1.47),('8975','2014-04-16','17:30:00',1.45),('8975','2014-04-16','17:35:00',1.47),('8975','2014-04-16','17:40:00',1.46),('8975','2014-04-16','17:45:00',1.35),('8975','2014-04-16','17:50:00',1.09),('8975','2014-04-16','17:55:00',1.06),('8975','2013-10-27','07:25:00',1.23),('8975','2013-10-27','07:30:00',1.45),('8975','2013-10-27','07:35:00',1.75),('8975','2013-10-27','07:40:00',1.31),('8975','2013-10-27','07:45:00',1.41),('8975','2013-10-27','08:10:00',1.24),('8975','2013-10-27','08:15:00',1.55),('8975','2013-10-27','08:20:00',1.21),('8975','2013-10-27','08:25:00',1.17),('8975','2013-10-27','08:30:00',1.13),('8975','2013-10-27','08:35:00',1.19),('8975','2013-10-27','08:40:00',1.2),('8975','2013-10-27','08:45:00',1.28),('8975','2013-10-27','08:50:00',2.99),('8975','2013-10-27','08:55:00',2.79),('8975','2013-10-27','09:00:00',3.16),('8975','2013-10-27','09:05:00',3.2),('8975','2013-10-27','09:10:00',3.14),('8975','2013-10-27','09:15:00',3.28),('8975','2013-10-27','09:20:00',3.3),('8975','2013-10-27','09:25:00',3.28),('8975','2013-10-27','09:30:00',3.3),('8975','2013-10-27','09:35:00',3.38),('8975','2013-10-27','09:40:00',3.51),('8975','2013-10-27','09:45:00',3.76),('8975','2013-10-27','09:50:00',4.01),('8975','2013-10-27','09:55:00',1.86),('8975','2013-10-27','10:00:00',1.5),('8975','2013-10-27','10:05:00',1.39),('8975','2013-10-27','10:10:00',1.36),('8975','2013-10-27','10:15:00',1.38),('8975','2013-10-27','10:20:00',1.4),('8975','2013-10-27','10:25:00',1.44),('8975','2013-10-27','10:30:00',1.46),('8975','2013-10-27','10:35:00',1.5),('8975','2013-10-27','10:40:00',1.46),('8975','2013-10-27','10:50:00',2.68),('8975','2013-10-27','10:55:00',4.07),('8975','2013-10-27','11:00:00',4.01),('8975','2013-10-27','11:05:00',3.99),('8975','2013-10-27','11:10:00',3.95),('8975','2013-10-27','11:15:00',3.84),('8975','2013-10-27','11:20:00',3.85),('8975','2013-10-27','11:25:00',3.66),('8975','2013-10-27','11:30:00',3.63),('8975','2013-10-27','11:35:00',3.75),('8975','2013-10-27','11:40:00',3.71),('8975','2013-10-27','11:45:00',3.67),('8975','2013-10-27','11:50:00',3.69),('8975','2013-10-27','11:55:00',3.75),('8975','2013-10-27','12:00:00',3.64),('8975','2013-10-27','12:05:00',3.26),('8975','2013-10-27','12:10:00',2.47),('8975','2013-10-27','12:15:00',2.38),('8975','2013-10-27','12:20:00',2.31),('8975','2013-10-27','12:25:00',3.61),('8975','2013-10-27','12:30:00',2.63),('8975','2013-10-27','12:35:00',1.65),('8975','2013-10-27','12:40:00',2.09),('8975','2013-10-27','12:45:00',2.72),('8975','2013-10-27','12:50:00',3.45),('8975','2013-10-27','12:55:00',3.29),('8975','2013-10-27','13:00:00',3.15),('8975','2013-10-27','13:05:00',3.03),('8975','2013-10-27','13:10:00',2.88),('8975','2013-10-27','13:15:00',2.7),('8975','2013-10-27','13:20:00',2.56),('8975','2013-10-27','13:25:00',2.44),('8975','2013-10-27','13:30:00',2.28),('8975','2013-10-27','13:35:00',1.4),('8975','2013-10-27','13:40:00',2.36),('8975','2013-10-27','13:45:00',1.72),('8975','2013-10-27','13:50:00',1.17),('8975','2013-10-27','13:55:00',2.22),('8975','2013-10-27','14:00:00',1.82),('8975','2013-10-27','14:05:00',2.15),('8975','2013-10-27','14:10:00',1.78),('8975','2013-10-27','14:15:00',1.54),('8975','2013-10-27','14:20:00',1.65),('8975','2013-10-27','14:25:00',1.8),('8975','2013-10-27','14:30:00',1.54),('8975','2013-10-27','14:35:00',1.41),('8975','2013-10-27','14:40:00',1.69),('8975','2013-10-27','14:45:00',1.25),('8975','2013-10-27','14:50:00',1.06),('8975','2013-10-27','15:00:00',1.31),('8975','2013-10-27','15:10:00',1.37),('8975','2013-10-27','15:15:00',1.33),('8975','2013-10-27','15:20:00',1.23),('8975','2013-10-27','15:25:00',1.28),('8975','2013-10-26','09:00:00',1.04),('8975','2013-10-26','09:05:00',1.17),('8975','2013-10-26','09:10:00',1.05),('8975','2013-10-26','09:30:00',1.06),('8975','2013-10-26','09:35:00',1.08),('8975','2013-10-26','09:40:00',1.2),('8975','2013-10-26','09:45:00',1.3),('8975','2013-10-26','09:50:00',1.48),('8975','2013-10-26','09:55:00',1.68),('8975','2013-10-26','10:00:00',1.69),('8975','2013-10-26','10:05:00',1.9),('8975','2013-10-26','10:10:00',2.49),('8975','2013-10-26','10:15:00',2.76),('8975','2013-10-26','10:20:00',2.55),('8975','2013-10-26','10:25:00',2.51),('8975','2013-10-26','10:30:00',2.38),('8975','2013-10-26','10:35:00',2.22),('8975','2013-10-26','10:40:00',2.09),('8975','2013-10-26','10:45:00',2),('8975','2013-10-26','10:50:00',1.8),('8975','2013-10-26','10:55:00',1.7),('8975','2013-10-26','11:00:00',1.52),('8975','2013-10-26','11:05:00',1.2),('8975','2013-10-26','11:30:00',1.61),('8975','2013-10-26','11:35:00',2.19),('8975','2013-10-26','11:40:00',3.27),('8975','2013-10-26','11:45:00',2.68),('8975','2013-10-26','11:50:00',2.43),('8975','2013-10-26','11:55:00',1.52),('8975','2013-10-26','12:00:00',1.54),('8975','2013-10-26','12:05:00',2.59),('8975','2013-10-26','12:10:00',2.5),('8975','2013-10-26','12:15:00',3.14),('8975','2013-10-26','12:20:00',3.29),('8975','2013-10-26','12:25:00',2.88),('8975','2013-10-26','12:30:00',3.64),('8975','2013-10-26','12:35:00',2.26),('8975','2013-10-26','12:40:00',2.78),('8975','2013-10-26','12:45:00',2.02),('8975','2013-10-26','12:50:00',1.89),('8975','2013-10-26','12:55:00',2.55),('8975','2013-10-26','13:00:00',1.6),('8975','2013-10-26','13:05:00',1.67),('8975','2013-10-26','13:10:00',1.4),('8975','2013-10-26','13:15:00',2),('8975','2013-10-26','13:20:00',1.5),('8975','2013-10-26','13:25:00',1.44),('8975','2013-10-26','13:30:00',1.16),('8975','2013-10-26','13:35:00',1.11),('8975','2013-10-26','13:50:00',1.07),('8975','2013-10-26','13:55:00',1.32),('8975','2013-10-26','14:00:00',1.69),('8975','2013-10-26','14:05:00',2.05),('8975','2013-10-26','14:10:00',1.92),('8975','2013-10-26','14:15:00',1.75),('8975','2013-10-26','14:20:00',1.83),('8975','2013-10-26','14:25:00',2.03),('8975','2013-10-26','14:30:00',1.86),('8975','2013-10-26','14:35:00',1.69),('8975','2013-10-26','14:40:00',1.38),('8975','2013-10-26','14:45:00',1.39),('8975','2013-10-26','14:50:00',1.27),('8975','2013-10-26','14:55:00',1.36),('8975','2013-10-26','15:00:00',1.56),('8975','2013-10-26','15:05:00',1.43),('8975','2013-10-26','15:10:00',1.36),('8975','2013-10-26','15:15:00',1.3),('8975','2013-10-26','15:20:00',1.23),('8975','2013-10-25','08:15:00',1),('8975','2013-10-25','08:20:00',1.15),('8975','2013-10-25','08:25:00',1.32),('8975','2013-10-25','08:30:00',1.48),('8975','2013-10-25','08:35:00',1.6),('8975','2013-10-25','08:40:00',1.73),('8975','2013-10-25','08:45:00',1.86),('8975','2013-10-25','08:50:00',1.96),('8975','2013-10-25','08:55:00',2.06),('8975','2013-10-25','09:00:00',2.16),('8975','2013-10-25','09:05:00',2.24),('8975','2013-10-25','09:10:00',2.34),('8975','2013-10-25','09:15:00',2.4),('8975','2013-10-25','09:20:00',2.53),('8975','2013-10-25','09:25:00',2.64),('8975','2013-10-25','09:30:00',2.72),('8975','2013-10-25','09:35:00',2.78),('8975','2013-10-25','09:40:00',2.82),('8975','2013-10-25','09:45:00',2.93),('8975','2013-10-25','09:50:00',3.01),('8975','2013-10-25','09:55:00',3.07),('8975','2013-10-25','10:00:00',3.13),('8975','2013-10-25','10:05:00',3.16),('8975','2013-10-25','10:10:00',3.21),('8975','2013-10-25','10:15:00',3.29),('8975','2013-10-25','10:20:00',3.37),('8975','2013-10-25','10:25:00',3.45),('8975','2013-10-25','10:30:00',3.5),('8975','2013-10-25','10:35:00',3.55),('8975','2013-10-25','10:40:00',3.56),('8975','2013-10-25','10:45:00',3.59),('8975','2013-10-25','10:50:00',3.65),('8975','2013-10-25','10:55:00',3.68),('8975','2013-10-25','11:00:00',3.7),('8975','2013-10-25','11:05:00',3.77),('8975','2013-10-25','11:10:00',3.78),('8975','2013-10-25','11:15:00',3.82),('8975','2013-10-25','11:20:00',3.84),('8975','2013-10-25','11:25:00',3.86),('8975','2013-10-25','11:30:00',3.9),('8975','2013-10-25','11:35:00',3.89),('8975','2013-10-25','11:40:00',3.87),('8975','2013-10-25','11:45:00',3.89),('8975','2013-10-25','11:50:00',3.88),('8975','2013-10-25','11:55:00',3.83),('8975','2013-10-25','12:00:00',3.81),('8975','2013-10-25','12:05:00',3.85),('8975','2013-10-25','12:10:00',3.85),('8975','2013-10-25','12:15:00',3.77),('8975','2013-10-25','12:20:00',3.73),('8975','2013-10-25','12:25:00',3.71),('8975','2013-10-25','12:30:00',3.73),('8975','2013-10-25','12:35:00',3.54),('8975','2013-10-25','12:40:00',3.59),('8975','2013-10-25','12:45:00',3.62),('8975','2013-10-25','12:50:00',3.62),('8975','2013-10-25','12:55:00',3.56),('8975','2013-10-25','13:00:00',3.36),('8975','2013-10-25','13:05:00',2.78),('8975','2013-10-25','13:10:00',3.16),('8975','2013-10-25','13:15:00',3.35),('8975','2013-10-25','13:20:00',3.3),('8975','2013-10-25','13:25:00',2.95),('8975','2013-10-25','13:30:00',3.18),('8975','2013-10-25','13:35:00',3.02),('8975','2013-10-25','13:40:00',2.98),('8975','2013-10-25','13:45:00',2.95),('8975','2013-10-25','13:50:00',2.85),('8975','2013-10-25','13:55:00',1.29),('8975','2013-10-25','14:00:00',2.53),('8975','2013-10-25','14:05:00',2.21),('8975','2013-10-25','14:10:00',2.28),('8975','2013-10-25','14:15:00',2.82),('8975','2013-10-25','14:20:00',2.87),('8975','2013-10-25','14:25:00',2.51),('8975','2013-10-25','14:30:00',1.92),('8975','2013-10-25','14:35:00',1.94),('8975','2013-10-25','14:40:00',2.32),('8975','2013-10-25','14:45:00',2.34),('8975','2013-10-25','14:50:00',2.19),('8975','2013-10-25','14:55:00',1.13),('8975','2013-10-25','15:10:00',1.34),('8975','2013-10-25','15:15:00',2.06),('8975','2013-10-25','15:20:00',1.96),('8975','2013-10-25','15:25:00',1.88),('8975','2013-10-25','15:30:00',1.89),('8975','2013-10-25','15:35:00',1.75),('8975','2013-10-25','15:40:00',1.7),('8975','2013-10-25','15:45:00',1.62),('8975','2013-10-25','15:50:00',1.55),('8975','2013-10-25','15:55:00',1.46),('8975','2013-10-25','16:00:00',1.47),('8975','2013-10-25','16:05:00',1.41),('8975','2013-10-25','16:10:00',1.29),('8975','2013-10-25','16:15:00',1.21),('8975','2013-10-25','16:20:00',1.16),('8975','2013-10-25','16:25:00',1.07),('8975','2013-10-25','16:30:00',1.05),('8975','2013-10-24','08:15:00',1.09),('8975','2013-10-24','08:20:00',1.26),('8975','2013-10-24','08:25:00',1.42),('8975','2013-10-24','08:30:00',1.56),('8975','2013-10-24','08:35:00',1.7),('8975','2013-10-24','08:40:00',1.8),('8975','2013-10-24','08:45:00',1.91),('8975','2013-10-24','08:50:00',2.02),('8975','2013-10-24','08:55:00',2.12),('8975','2013-10-24','09:00:00',2.24),('8975','2013-10-24','09:05:00',2.31),('8975','2013-10-24','09:10:00',2.42),('8975','2013-10-24','09:15:00',2.51),('8975','2013-10-24','09:20:00',2.59),('8975','2013-10-24','09:25:00',2.65),('8975','2013-10-24','09:30:00',2.75),('8975','2013-10-24','09:35:00',2.82),('8975','2013-10-24','09:40:00',2.9),('8975','2013-10-24','09:45:00',2.95),('8975','2013-10-24','09:50:00',3.01),('8975','2013-10-24','09:55:00',3.02),('8975','2013-10-24','10:00:00',3.1),('8975','2013-10-24','10:05:00',3.13),('8975','2013-10-24','10:10:00',3.19),('8975','2013-10-24','10:15:00',3.29),('8975','2013-10-24','10:20:00',3.39),('8975','2013-10-24','10:25:00',3.51),('8975','2013-10-24','10:30:00',3.58),('8975','2013-10-24','10:35:00',3.67),('8975','2013-10-24','10:40:00',3.66),('8975','2013-10-24','10:45:00',3.72),('8975','2013-10-24','10:50:00',3.78),('8975','2013-10-24','10:55:00',3.7),('8975','2013-10-24','11:00:00',3.75),('8975','2013-10-24','11:05:00',3.78),('8975','2013-10-24','11:10:00',3.82),('8975','2013-10-24','11:15:00',3.84),('8975','2013-10-24','11:20:00',3.83),('8975','2013-10-24','11:25:00',3.86),('8975','2013-10-24','11:30:00',3.85),('8975','2013-10-24','11:35:00',3.93),('8975','2013-10-24','11:40:00',3.97),('8975','2013-10-24','11:45:00',3.97),('8975','2013-10-24','11:50:00',4.04),('8975','2013-10-24','11:55:00',4.03),('8975','2013-10-24','12:00:00',4.05),('8975','2013-10-24','12:05:00',4.05),('8975','2013-10-24','12:10:00',4.08),('8975','2013-10-24','12:15:00',3.97),('8975','2013-10-24','12:20:00',3.98),('8975','2013-10-24','12:25:00',3.96),('8975','2013-10-24','12:30:00',3.73),('8975','2013-10-24','12:35:00',3.46),('8975','2013-10-24','12:40:00',3.6),('8975','2013-10-24','12:45:00',3.85),('8975','2013-10-24','12:50:00',3.79),('8975','2013-10-24','12:55:00',3.72),('8975','2013-10-24','13:00:00',3.7),('8975','2013-10-24','13:05:00',3.67),('8975','2013-10-24','13:10:00',3.6),('8975','2013-10-24','13:15:00',3.56),('8975','2013-10-24','13:20:00',3.52),('8975','2013-10-24','13:25:00',3.43),('8975','2013-10-24','13:30:00',3.29),('8975','2013-10-24','13:35:00',3.1),('8975','2013-10-24','13:40:00',3.11),('8975','2013-10-24','13:45:00',3.15),('8975','2013-10-24','13:50:00',3.12),('8975','2013-10-24','13:55:00',3.11),('8975','2013-10-24','14:00:00',3.06),('8975','2013-10-24','14:05:00',3),('8975','2013-10-24','14:10:00',2.91),('8975','2013-10-24','14:15:00',2.71),('8975','2013-10-24','14:20:00',2.56),('8975','2013-10-24','14:25:00',2.52),('8975','2013-10-24','14:30:00',2.55),('8975','2013-10-24','14:35:00',2.51),('8975','2013-10-24','14:40:00',2.45),('8975','2013-10-24','14:45:00',2.35),('8975','2013-10-24','14:50:00',2.21),('8975','2013-10-24','14:55:00',2.15),('8975','2013-10-24','15:00:00',2.12),('8975','2013-10-24','15:05:00',1.98),('8975','2013-10-24','15:10:00',1.98),('8975','2013-10-24','15:15:00',1.93),('8975','2013-10-24','15:20:00',1.88),('8975','2013-10-24','15:25:00',1.8),('8975','2013-10-24','15:30:00',1.72),('8975','2013-10-24','15:35:00',1.61),('8975','2013-10-24','15:40:00',1.53),('8975','2013-10-24','15:45:00',1.48),('8975','2013-10-24','15:50:00',1.45),('8975','2013-10-24','15:55:00',1.4),('8975','2013-10-24','16:00:00',1.35),('8975','2013-10-24','16:05:00',1.31),('8975','2013-10-24','16:10:00',1.26),('8975','2013-10-24','16:15:00',1.22),('8975','2013-10-24','16:20:00',1.19),('8975','2013-10-24','16:25:00',1.16),('8975','2013-10-24','16:30:00',1.12),('8975','2013-10-24','16:35:00',1.07),('8975','2013-10-24','16:40:00',1.02),('8975','2013-10-23','08:20:00',1.03),('8975','2013-10-23','08:25:00',1.6),('8975','2013-10-23','08:30:00',1.55),('8975','2013-10-23','08:50:00',1.06),('8975','2013-10-23','08:55:00',1.41),('8975','2013-10-23','09:00:00',1.77),('8975','2013-10-23','09:05:00',2.34),('8975','2013-10-23','09:10:00',2.49),('8975','2013-10-23','09:15:00',2.68),('8975','2013-10-23','09:20:00',2.53),('8975','2013-10-23','09:25:00',1.52),('8975','2013-10-23','09:30:00',1.56),('8975','2013-10-23','09:35:00',1.68),('8975','2013-10-23','09:40:00',1.83),('8975','2013-10-23','09:45:00',1.96),('8975','2013-10-23','09:50:00',1.94),('8975','2013-10-23','09:55:00',1.91),('8975','2013-10-23','10:00:00',1.84),('8975','2013-10-23','10:05:00',1.74),('8975','2013-10-23','10:10:00',1.65),('8975','2013-10-23','10:15:00',1.86),('8975','2013-10-23','10:20:00',1.98),('8975','2013-10-23','10:25:00',1.25),('8975','2013-10-23','10:30:00',1.27),('8975','2013-10-23','10:35:00',1.59),('8975','2013-10-23','10:40:00',1.51),('8975','2013-10-23','10:45:00',2.3),('8975','2013-10-23','10:50:00',2.14),('8975','2013-10-23','10:55:00',2.47),('8975','2013-10-23','11:00:00',3.44),('8975','2013-10-23','11:05:00',2.61),('8975','2013-10-23','11:10:00',2.57),('8975','2013-10-23','11:15:00',3.5),('8975','2013-10-23','11:20:00',3.1),('8975','2013-10-23','11:25:00',1.92),('8975','2013-10-23','11:30:00',1.92),('8975','2013-10-23','11:35:00',2.02),('8975','2013-10-23','11:40:00',1.72),('8975','2013-10-23','11:45:00',1.8),('8975','2013-10-23','11:50:00',2.15),('8975','2013-10-23','11:55:00',2.73),('8975','2013-10-23','12:00:00',2.75),('8975','2013-10-23','12:05:00',2.17),('8975','2013-10-23','12:10:00',2.06),('8975','2013-10-23','12:15:00',2.01),('8975','2013-10-23','12:20:00',2.06),('8975','2013-10-23','12:25:00',2.19),('8975','2013-10-23','12:30:00',2.31),('8975','2013-10-23','12:35:00',2.5),('8975','2013-10-23','12:40:00',2.68),('8975','2013-10-23','12:45:00',3.07),('8975','2013-10-23','12:50:00',4.17),('8975','2013-10-23','12:55:00',4.1),('8975','2013-10-23','13:00:00',4.26),('8975','2013-10-23','13:05:00',4.39),('8975','2013-10-23','13:10:00',3.16),('8975','2013-10-23','13:15:00',3.05),('8975','2013-10-23','13:20:00',2.81),('8975','2013-10-23','13:25:00',2.34),('8975','2013-10-23','13:30:00',2.17),('8975','2013-10-23','13:35:00',2.1),('8975','2013-10-23','13:40:00',2.09),('8975','2013-10-23','13:45:00',2.3),('8975','2013-10-23','13:50:00',2.5),('8975','2013-10-23','13:55:00',3.33),('8975','2013-10-23','14:00:00',4.08),('8975','2013-10-23','14:05:00',2.34),('8975','2013-10-23','14:10:00',1.99),('8975','2013-10-23','14:15:00',2.08),('8975','2013-10-23','14:20:00',2.08),('8975','2013-10-23','14:25:00',2.05),('8975','2013-10-23','14:30:00',2.14),('8975','2013-10-23','14:35:00',2.17),('8975','2013-10-23','14:40:00',2.67),('8975','2013-10-23','14:45:00',2.44),('8975','2013-10-23','14:50:00',1.61),('8975','2013-10-23','14:55:00',1.06),('8975','2013-10-23','15:05:00',1.23),('8975','2013-10-23','15:10:00',1.81),('8975','2013-10-23','15:15:00',1.55),('8975','2013-10-23','15:20:00',1.49),('8975','2013-10-23','15:25:00',1.26),('8975','2013-10-23','15:30:00',1.34),('8975','2013-10-23','15:35:00',1.98),('8975','2013-10-23','15:40:00',1.76),('8975','2013-10-23','15:45:00',2.07),('8975','2013-10-23','15:50:00',1.52),('8975','2013-10-23','16:10:00',1),('8975','2013-10-22','09:50:00',1.11),('8975','2013-10-22','09:55:00',1.09),('8975','2013-10-22','10:00:00',1.32),('8975','2013-10-22','10:05:00',1.52),('8975','2013-10-22','10:10:00',1.24),('8975','2013-10-22','10:15:00',1.52),('8975','2013-10-22','10:20:00',1.77),('8975','2013-10-22','10:25:00',1.6),('8975','2013-10-22','10:30:00',2.49),('8975','2013-10-22','10:35:00',2.12),('8975','2013-10-22','10:40:00',2.36),('8975','2013-10-22','10:45:00',2.56),('8975','2013-10-22','10:50:00',3.74),('8975','2013-10-22','10:55:00',3.25),('8975','2013-10-22','11:00:00',2.46),('8975','2013-10-22','11:05:00',3.47),('8975','2013-10-22','11:10:00',3.44),('8975','2013-10-22','11:15:00',3.89),('8975','2013-10-22','11:20:00',3.92),('8975','2013-10-22','11:25:00',3.78),('8975','2013-10-22','11:30:00',4.05),('8975','2013-10-22','11:35:00',4.02),('8975','2013-10-22','11:40:00',4.05),('8975','2013-10-22','11:45:00',3.82),('8975','2013-10-22','11:50:00',3.97),('8975','2013-10-22','11:55:00',4.01),('8975','2013-10-22','12:00:00',3.81),('8975','2013-10-22','12:05:00',3.6),('8975','2013-10-22','12:10:00',3.85),('8975','2013-10-22','12:15:00',3.84),('8975','2013-10-22','12:20:00',3.67),('8975','2013-10-22','12:25:00',3.76),('8975','2013-10-22','12:30:00',3.66),('8975','2013-10-22','12:35:00',3.56),('8975','2013-10-22','12:40:00',3.53),('8975','2013-10-22','12:45:00',3.35),('8975','2013-10-22','12:50:00',2.96),('8975','2013-10-22','12:55:00',1.62),('8975','2013-10-22','13:00:00',2.06),('8975','2013-10-22','13:05:00',3.03),('8975','2013-10-22','13:10:00',3.45),('8975','2013-10-22','13:15:00',3.49),('8975','2013-10-22','13:20:00',3.47),('8975','2013-10-22','13:25:00',3.3),('8975','2013-10-22','13:30:00',3.33),('8975','2013-10-22','13:35:00',3.28),('8975','2013-10-22','13:40:00',3.15),('8975','2013-10-22','13:45:00',2.69),('8975','2013-10-22','13:50:00',2.82),('8975','2013-10-22','13:55:00',3.09),('8975','2013-10-22','14:00:00',3.01),('8975','2013-10-22','14:05:00',2.92),('8975','2013-10-22','14:10:00',2.8),('8975','2013-10-22','14:15:00',2.79),('8975','2013-10-22','14:20:00',2.06),('8975','2013-10-22','14:25:00',2.65),('8975','2013-10-22','14:30:00',2.49),('8975','2013-10-22','14:35:00',2),('8975','2013-10-22','14:40:00',2.47),('8975','2013-10-22','14:45:00',2.45),('8975','2013-10-22','14:50:00',2.4),('8975','2013-10-22','14:55:00',2.29),('8975','2013-10-22','15:00:00',2.18),('8975','2013-10-22','15:05:00',2.17),('8975','2013-10-22','15:10:00',2.01),('8975','2013-10-22','15:15:00',1.92),('8975','2013-10-22','15:20:00',1.93),('8975','2013-10-22','15:25:00',1.93),('8975','2013-10-22','15:30:00',1.72),('8975','2013-10-22','15:35:00',1.54),('8975','2013-10-22','15:40:00',1.65),('8975','2013-10-22','15:45:00',1.7),('8975','2013-10-22','15:50:00',1.59),('8975','2013-10-22','15:55:00',1.42),('8975','2013-10-22','16:00:00',1.07),('8975','2013-10-22','16:25:00',1.12),('8975','2013-10-22','16:30:00',1.05),('8975','2013-10-22','16:35:00',1.13),('8975','2013-10-22','16:40:00',1.17),('8975','2013-10-22','16:45:00',1.05),('8975','2013-10-21','08:15:00',1.05),('8975','2013-10-21','08:20:00',1.22),('8975','2013-10-21','08:25:00',1.36),('8975','2013-10-21','08:30:00',1.48),('8975','2013-10-21','08:35:00',1.61),('8975','2013-10-21','08:40:00',1.74),('8975','2013-10-21','08:45:00',1.86),('8975','2013-10-21','08:50:00',1.97),('8975','2013-10-21','08:55:00',2.08),('8975','2013-10-21','09:00:00',2.19),('8975','2013-10-21','09:05:00',2.27),('8975','2013-10-21','09:10:00',2.38),('8975','2013-10-21','09:15:00',2.49),('8975','2013-10-21','09:20:00',2.58),('8975','2013-10-21','09:25:00',2.67),('8975','2013-10-21','09:30:00',2.76),('8975','2013-10-21','09:35:00',2.86),('8975','2013-10-21','09:40:00',2.92),('8975','2013-10-21','09:45:00',3),('8975','2013-10-21','09:50:00',3.07),('8975','2013-10-21','09:55:00',3.15),('8975','2013-10-21','10:00:00',3.18),('8975','2013-10-21','10:05:00',3.19),('8975','2013-10-21','10:10:00',3.31),('8975','2013-10-21','10:15:00',3.39),('8975','2013-10-21','10:20:00',3.47),('8975','2013-10-21','10:25:00',3.54),('8975','2013-10-21','10:30:00',3.58),('8975','2013-10-21','10:35:00',3.62),('8975','2013-10-21','10:40:00',3.55),('8975','2013-10-21','10:45:00',3.43),('8975','2013-10-21','10:50:00',3.44),('8975','2013-10-21','10:55:00',3.35),('8975','2013-10-21','11:00:00',3.53),('8975','2013-10-21','11:05:00',3.13),('8975','2013-10-21','11:10:00',3.55),('8975','2013-10-21','11:15:00',3.72),('8975','2013-10-21','11:20:00',3.56),('8975','2013-10-21','11:25:00',3.74),('8975','2013-10-21','11:30:00',3.62),('8975','2013-10-21','11:35:00',3.48),('8975','2013-10-21','11:40:00',3.9),('8975','2013-10-21','11:45:00',3.59),('8975','2013-10-21','11:50:00',3.73),('8975','2013-10-21','11:55:00',3.96),('8975','2013-10-21','12:00:00',3.94),('8975','2013-10-21','12:05:00',3.88),('8975','2013-10-21','12:10:00',3.84),('8975','2013-10-21','12:15:00',3.92),('8975','2013-10-21','12:20:00',3.9),('8975','2013-10-21','12:25:00',3.86),('8975','2013-10-21','12:30:00',3.82),('8975','2013-10-21','12:35:00',3.67),('8975','2013-10-21','12:40:00',3.65),('8975','2013-10-21','12:45:00',3.66),('8975','2013-10-21','12:50:00',3.69),('8975','2013-10-21','12:55:00',3.69),('8975','2013-10-21','13:00:00',3.51),('8975','2013-10-21','13:05:00',3.33),('8975','2013-10-21','13:10:00',3.47),('8975','2013-10-21','13:15:00',3.04),('8975','2013-10-21','13:20:00',3.4),('8975','2013-10-21','13:25:00',3.37),('8975','2013-10-21','13:30:00',2.85),('8975','2013-10-21','13:35:00',3),('8975','2013-10-21','13:40:00',3.06),('8975','2013-10-21','13:45:00',3.07),('8975','2013-10-21','13:50:00',3.19),('8975','2013-10-21','13:55:00',3.26),('8975','2013-10-21','14:00:00',3.12),('8975','2013-10-21','14:05:00',3.09),('8975','2013-10-21','14:10:00',2.9),('8975','2013-10-21','14:15:00',3.02),('8975','2013-10-21','14:20:00',2.84),('8975','2013-10-21','14:25:00',2.77),('8975','2013-10-21','14:30:00',2.67),('8975','2013-10-21','14:35:00',2.78),('8975','2013-10-21','14:40:00',2.71),('8975','2013-10-21','14:45:00',2.49),('8975','2013-10-21','14:50:00',2.36),('8975','2013-10-21','14:55:00',2.28),('8975','2013-10-21','15:00:00',2.25),('8975','2013-10-21','15:05:00',2.13),('8975','2013-10-21','15:10:00',2.15),('8975','2013-10-21','15:15:00',2.1),('8975','2013-10-21','15:20:00',1.97),('8975','2013-10-21','15:25:00',1.79),('8975','2013-10-21','15:30:00',1.69),('8975','2013-10-21','15:35:00',1.24),('8975','2013-10-21','15:40:00',1.57),('8975','2013-10-21','15:45:00',1.37),('8975','2013-10-21','15:50:00',1.33),('8975','2013-10-21','15:55:00',1.13),('8975','2013-10-21','16:00:00',1.13),('8975','2013-10-21','16:05:00',1.42),('8975','2013-10-21','16:10:00',1.34),('8975','2013-10-21','16:15:00',1.24),('8975','2013-10-21','16:20:00',1.25),('8975','2013-10-21','16:25:00',1.21),('8975','2013-10-21','16:30:00',1.17),('8975','2013-10-21','16:35:00',1.11),('8975','2013-10-21','16:40:00',1.04),('8975','2013-10-20','08:05:00',1.04),('8975','2013-10-20','08:10:00',1.22),('8975','2013-10-20','08:15:00',1.23),('8975','2013-10-20','08:20:00',1.59),('8975','2013-10-20','08:25:00',1.4),('8975','2013-10-20','08:30:00',1.82),('8975','2013-10-20','08:35:00',1.66),('8975','2013-10-20','08:40:00',1.91),('8975','2013-10-20','08:45:00',1.88),('8975','2013-10-20','08:50:00',1.85),('8975','2013-10-20','08:55:00',1.75),('8975','2013-10-20','09:00:00',1.47),('8975','2013-10-20','09:05:00',1.69),('8975','2013-10-20','09:10:00',2.04),('8975','2013-10-20','09:15:00',2.35),('8975','2013-10-20','09:20:00',2.74),('8975','2013-10-20','09:25:00',2.94),('8975','2013-10-20','09:30:00',2.58),('8975','2013-10-20','09:35:00',2.42),('8975','2013-10-20','09:40:00',2.86),('8975','2013-10-20','09:45:00',2.4),('8975','2013-10-20','09:50:00',2.7),('8975','2013-10-20','09:55:00',3.09),('8975','2013-10-20','10:00:00',3.26),('8975','2013-10-20','10:05:00',3.61),('8975','2013-10-20','10:10:00',3.25),('8975','2013-10-20','10:15:00',3.41),('8975','2013-10-20','10:20:00',3.43),('8975','2013-10-20','10:25:00',3.7),('8975','2013-10-20','10:30:00',3.63),('8975','2013-10-20','10:35:00',3.52),('8975','2013-10-20','10:40:00',3.36),('8975','2013-10-20','10:45:00',3.6),('8975','2013-10-20','10:50:00',3.83),('8975','2013-10-20','10:55:00',3.75),('8975','2013-10-20','11:00:00',3.96),('8975','2013-10-20','11:05:00',3.79),('8975','2013-10-20','11:10:00',3.88),('8975','2013-10-20','11:15:00',4.1),('8975','2013-10-20','11:20:00',4.06),('8975','2013-10-20','11:25:00',3.88),('8975','2013-10-20','11:30:00',4.05),('8975','2013-10-20','11:35:00',3.9),('8975','2013-10-20','11:40:00',4.1),('8975','2013-10-20','11:45:00',4.12),('8975','2013-10-20','11:50:00',4.16),('8975','2013-10-20','11:55:00',4.15),('8975','2013-10-20','12:00:00',4.12),('8975','2013-10-20','12:05:00',4.12),('8975','2013-10-20','12:10:00',4.2),('8975','2013-10-20','12:15:00',4.05),('8975','2013-10-20','12:20:00',4.02),('8975','2013-10-20','12:25:00',3.89),('8975','2013-10-20','12:30:00',3.86),('8975','2013-10-20','12:35:00',3.93),('8975','2013-10-20','12:40:00',3.74),('8975','2013-10-20','12:45:00',3.89),('8975','2013-10-20','12:50:00',3.95),('8975','2013-10-20','12:55:00',3.9),('8975','2013-10-20','13:00:00',3.85),('8975','2013-10-20','13:05:00',3.77),('8975','2013-10-20','13:10:00',3.73),('8975','2013-10-20','13:15:00',3.77),('8975','2013-10-20','13:20:00',3.69),('8975','2013-10-20','13:25:00',3.65),('8975','2013-10-20','13:30:00',3.58),('8975','2013-10-20','13:35:00',3.49),('8975','2013-10-20','13:40:00',3.33),('8975','2013-10-20','13:45:00',3.34),('8975','2013-10-20','13:50:00',3.28),('8975','2013-10-20','13:55:00',2.89),('8975','2013-10-20','14:00:00',3.19),('8975','2013-10-20','14:05:00',3.22),('8975','2013-10-20','14:10:00',3.09),('8975','2013-10-20','14:15:00',3.07),('8975','2013-10-20','14:20:00',2.84),('8975','2013-10-20','14:25:00',2.74),('8975','2013-10-20','14:30:00',2.57),('8975','2013-10-20','14:35:00',2.57),('8975','2013-10-20','14:40:00',2.41),('8975','2013-10-20','14:45:00',2.37),('8975','2013-10-20','14:50:00',2.17),('8975','2013-10-20','14:55:00',2.23),('8975','2013-10-20','15:00:00',2.27),('8975','2013-10-20','15:05:00',2.22),('8975','2013-10-20','15:10:00',2.15),('8975','2013-10-20','15:15:00',2.11),('8975','2013-10-20','15:20:00',1.95),('8975','2013-10-20','15:25:00',1.88),('8975','2013-10-20','15:30:00',1.85),('8975','2013-10-20','15:35:00',1.77),('8975','2013-10-20','15:40:00',1.68),('8975','2013-10-20','15:45:00',1.61),('8975','2013-10-20','15:50:00',1.55),('8975','2013-10-20','15:55:00',1.48),('8975','2013-10-20','16:00:00',1.45),('8975','2013-10-20','16:05:00',1.41),('8975','2013-10-20','16:10:00',1.36),('8975','2013-10-20','16:15:00',1.29),('8975','2013-10-20','16:20:00',1.25),('8975','2013-10-20','16:25:00',1.22),('8975','2013-10-20','16:30:00',1.18),('8975','2013-10-20','16:35:00',1.14),('8975','2013-10-20','16:40:00',1.08),('8975','2013-10-20','16:45:00',1.03),('8975','2013-10-20','16:50:00',1),('8975','2013-10-19','08:15:00',1.41),('8975','2013-10-19','08:20:00',1.6),('8975','2013-10-19','08:25:00',1.77),('8975','2013-10-19','08:30:00',1.92),('8975','2013-10-19','08:35:00',2),('8975','2013-10-19','08:40:00',2.08),('8975','2013-10-19','08:45:00',2.21),('8975','2013-10-19','08:50:00',2.32),('8975','2013-10-19','08:55:00',2.31),('8975','2013-10-19','09:00:00',2.42),('8975','2013-10-19','09:05:00',2.53),('8975','2013-10-19','09:10:00',2.65),('8975','2013-10-19','09:15:00',2.73),('8975','2013-10-19','09:20:00',2.85),('8975','2013-10-19','09:25:00',2.92),('8975','2013-10-19','09:30:00',3),('8975','2013-10-19','09:35:00',3.06),('8975','2013-10-19','09:40:00',3.16),('8975','2013-10-19','09:45:00',3.23),('8975','2013-10-19','09:50:00',3.28),('8975','2013-10-19','09:55:00',3.32),('8975','2013-10-19','10:00:00',3.36),('8975','2013-10-19','10:05:00',3.47),('8975','2013-10-19','10:10:00',3.57),('8975','2013-10-19','10:15:00',3.64),('8975','2013-10-19','10:20:00',3.71),('8975','2013-10-19','10:25:00',3.78),('8975','2013-10-19','10:30:00',3.84),('8975','2013-10-19','10:35:00',3.89),('8975','2013-10-19','10:40:00',3.8),('8975','2013-10-19','10:45:00',3.77),('8975','2013-10-19','10:50:00',3.9),('8975','2013-10-19','10:55:00',4.02),('8975','2013-10-19','11:00:00',4.07),('8975','2013-10-19','11:05:00',4.12),('8975','2013-10-19','11:10:00',4.13),('8975','2013-10-19','11:15:00',4.19),('8975','2013-10-19','11:20:00',4.21),('8975','2013-10-19','11:25:00',4.23),('8975','2013-10-19','11:30:00',4.23),('8975','2013-10-19','11:35:00',4.23),('8975','2013-10-19','11:40:00',4.26),('8975','2013-10-19','11:45:00',4.23),('8975','2013-10-19','11:50:00',4.18),('8975','2013-10-19','11:55:00',4.24),('8975','2013-10-19','12:00:00',4.26),('8975','2013-10-19','12:05:00',3.9),('8975','2013-10-19','12:10:00',4.48),('8975','2013-10-19','12:15:00',3.19),('8975','2013-10-19','12:20:00',1.34),('8975','2013-10-19','12:25:00',3.86),('8975','2013-10-19','12:30:00',2.57),('8975','2013-10-19','12:35:00',2.49),('8975','2013-10-19','12:40:00',3.32),('8975','2013-10-19','12:45:00',3.01),('8975','2013-10-19','12:50:00',3.08),('8975','2013-10-19','12:55:00',2.63),('8975','2013-10-19','13:00:00',2.32),('8975','2013-10-19','13:05:00',2.38),('8975','2013-10-19','13:10:00',1.83),('8975','2013-10-19','13:15:00',3.37),('8975','2013-10-19','13:20:00',2.75),('8975','2013-10-19','13:25:00',3.23),('8975','2013-10-19','13:30:00',1.83),('8975','2013-10-19','13:35:00',2.31),('8975','2013-10-19','13:40:00',3.5),('8975','2013-10-19','13:45:00',2.66),('8975','2013-10-19','13:50:00',2.34),('8975','2013-10-19','13:55:00',2.06),('8975','2013-10-19','14:00:00',1.87),('8975','2013-10-19','14:05:00',1.58),('8975','2013-10-19','14:10:00',1.51),('8975','2013-10-19','14:15:00',1.31),('8975','2013-10-19','14:20:00',1.09),('8975','2013-10-19','14:25:00',1.35),('8975','2013-10-19','14:30:00',1.09),('8975','2013-10-19','14:35:00',1.15),('8975','2013-10-19','14:40:00',1.77),('8975','2013-10-19','14:45:00',1.32),('8975','2013-10-19','14:50:00',1.29),('8975','2013-10-19','14:55:00',1.24),('8975','2013-10-19','15:00:00',1.35),('8975','2013-10-19','15:05:00',1.09),('8975','2013-10-19','15:10:00',1),('8975','2013-10-19','15:15:00',1.09),('8975','2013-10-19','16:25:00',1.18),('8975','2013-10-19','16:30:00',1.49),('8975','2013-10-19','16:35:00',1.5),('8975','2013-10-19','16:40:00',1.59),('8975','2013-10-19','16:45:00',1.7),('8975','2013-10-19','16:50:00',1.7),('8975','2013-10-19','16:55:00',1.47),('8975','2013-10-19','17:00:00',1.18),('8975','2013-10-19','17:05:00',1.04),('8975','2013-10-18','08:20:00',1.63),('8975','2013-10-18','08:25:00',1.61),('8975','2013-10-18','08:30:00',1.84),('8975','2013-10-18','08:35:00',2.17),('8975','2013-10-18','08:40:00',2.17),('8975','2013-10-18','08:45:00',2.34),('8975','2013-10-18','08:50:00',2.86),('8975','2013-10-18','08:55:00',1.16),('8975','2013-10-18','09:00:00',1.83),('8975','2013-10-18','09:05:00',2.7),('8975','2013-10-18','09:10:00',2.47),('8975','2013-10-18','09:15:00',3.37),('8975','2013-10-18','09:20:00',3.4),('8975','2013-10-18','09:25:00',3.38),('8975','2013-10-18','09:30:00',3.44),('8975','2013-10-18','09:35:00',3.53),('8975','2013-10-18','09:40:00',3.61),('8975','2013-10-18','09:45:00',3.69),('8975','2013-10-18','09:50:00',3.77),('8975','2013-10-18','09:55:00',3.88),('8975','2013-10-18','10:00:00',3.72),('8975','2013-10-18','10:05:00',3.9),('8975','2013-10-18','10:10:00',3.29),('8975','2013-10-18','10:15:00',3.57),('8975','2013-10-18','10:20:00',3.29),('8975','2013-10-18','10:25:00',4.42),('8975','2013-10-18','10:30:00',4.46),('8975','2013-10-18','10:35:00',4.39),('8975','2013-10-18','10:40:00',4.28),('8975','2013-10-18','10:45:00',4.24),('8975','2013-10-18','10:50:00',4.37),('8975','2013-10-18','10:55:00',3.95),('8975','2013-10-18','11:00:00',4.18),('8975','2013-10-18','11:05:00',2.98),('8975','2013-10-18','11:10:00',2.83),('8975','2013-10-18','11:15:00',2.85),('8975','2013-10-18','11:20:00',3.92),('8975','2013-10-18','11:25:00',3.71),('8975','2013-10-18','11:30:00',4.82),('8975','2013-10-18','11:35:00',4.81),('8975','2013-10-18','11:40:00',4.81),('8975','2013-10-18','11:45:00',4.79),('8975','2013-10-18','11:50:00',4.57),('8975','2013-10-18','11:55:00',4.82),('8975','2013-10-18','12:00:00',4.77),('8975','2013-10-18','12:05:00',4.73),('8975','2013-10-18','12:10:00',4.62),('8975','2013-10-18','12:15:00',4.56),('8975','2013-10-18','12:20:00',4.25),('8975','2013-10-18','12:25:00',4.33),('8975','2013-10-18','12:30:00',4.4),('8975','2013-10-18','12:35:00',4.39),('8975','2013-10-18','12:40:00',4.57),('8975','2013-10-18','12:45:00',4.64),('8975','2013-10-18','12:50:00',4.49),('8975','2013-10-18','12:55:00',4.71),('8975','2013-10-18','13:00:00',5.08),('8975','2013-10-18','13:05:00',4.87),('8975','2013-10-18','13:10:00',4.27),('8975','2013-10-18','13:15:00',3.94),('8975','2013-10-18','13:20:00',4.6),('8975','2013-10-18','13:25:00',4.8),('8975','2013-10-18','13:30:00',4.62),('8975','2013-10-18','13:35:00',2.87),('8975','2013-10-18','13:40:00',2.37),('8975','2013-10-18','13:45:00',1.7),('8975','2013-10-18','13:50:00',1.97),('8975','2013-10-18','13:55:00',3.39),('8975','2013-10-18','14:00:00',3.7),('8975','2013-10-18','14:05:00',2.75),('8975','2013-10-18','14:10:00',2.03),('8975','2013-10-18','14:15:00',3.38),('8975','2013-10-18','14:20:00',2.78),('8975','2013-10-18','14:25:00',1.69),('8975','2013-10-18','14:30:00',2.53),('8975','2013-10-18','14:35:00',3.4),('8975','2013-10-18','14:40:00',2.55),('8975','2013-10-18','14:45:00',2.33),('8975','2013-10-18','14:50:00',3),('8975','2013-10-18','14:55:00',2.93),('8975','2013-10-18','15:00:00',2.79),('8975','2013-10-18','15:05:00',2.67),('8975','2013-10-18','15:10:00',2.6),('8975','2013-10-18','15:15:00',2.5),('8975','2013-10-18','15:20:00',2.24),('8975','2013-10-18','15:25:00',2.17),('8975','2013-10-18','15:30:00',2.03),('8975','2013-10-18','15:35:00',2),('8975','2013-10-18','15:40:00',1.83),('8975','2013-10-18','15:45:00',1.67),('8975','2013-10-18','15:50:00',1.6),('8975','2013-10-18','15:55:00',1.74),('8975','2013-10-18','16:00:00',1.52),('8975','2013-10-18','16:05:00',1.58),('8975','2013-10-18','16:10:00',1.57),('8975','2013-10-18','16:15:00',1.5),('8975','2013-10-18','16:20:00',1.5),('8975','2013-10-18','16:25:00',1.21),('8975','2013-10-18','16:30:00',1.44),('8975','2013-10-18','16:35:00',1.44),('8975','2013-10-18','16:40:00',1.44),('8975','2013-10-18','16:45:00',1.42),('8975','2013-10-18','16:50:00',1.21),('8975','2014-05-03','06:40:00',1.08),('8975','2014-05-03','07:10:00',1.64),('8975','2014-05-03','07:15:00',2.41),('8975','2014-05-03','07:20:00',2.78),('8975','2014-05-03','07:25:00',2.79),('8975','2014-05-03','07:35:00',1.44),('8975','2014-05-03','07:40:00',1.21),('8975','2014-05-03','07:45:00',2.28),('8975','2014-05-03','07:50:00',3.63),('8975','2014-05-03','07:55:00',3.69),('8975','2014-05-03','08:00:00',3.79),('8975','2014-05-03','08:05:00',3.94),('8975','2014-05-03','08:10:00',3.98),('8975','2014-05-03','08:15:00',4.04),('8975','2014-05-03','08:20:00',4.23),('8975','2014-05-03','08:25:00',4.32),('8975','2014-05-03','08:30:00',4.39),('8975','2014-05-03','08:35:00',4.61),('8975','2014-05-03','08:40:00',5.29),('8975','2014-05-03','08:45:00',4.5),('8975','2014-05-03','08:50:00',2.27),('8975','2014-05-03','08:55:00',5.36),('8975','2014-05-03','09:00:00',2.88),('8975','2014-05-03','09:05:00',3.63),('8975','2014-05-03','09:10:00',4.03),('8975','2014-05-03','09:15:00',3.5),('8975','2014-05-03','09:20:00',3.18),('8975','2014-05-03','09:25:00',6.67),('8975','2014-05-03','09:30:00',5.85),('8975','2014-05-03','09:35:00',3.17),('8975','2014-05-03','09:40:00',2.54),('8975','2014-05-03','09:45:00',2.8),('8975','2014-05-03','09:50:00',4.26),('8975','2014-05-03','09:55:00',5.29),('8975','2014-05-03','10:00:00',6.23),('8975','2014-05-03','10:05:00',6.96),('8975','2014-05-03','10:10:00',7.25),('8975','2014-05-03','10:15:00',6.03),('8975','2014-05-03','10:20:00',4.03),('8975','2014-05-03','10:25:00',4.3),('8975','2014-05-03','10:30:00',3.91),('8975','2014-05-03','10:35:00',3.71),('8975','2014-05-03','10:40:00',3.71),('8975','2014-05-03','10:45:00',4.02),('8975','2014-05-03','10:50:00',3.78),('8975','2014-05-03','10:55:00',4.12),('8975','2014-05-03','11:00:00',5.01),('8975','2014-05-03','11:05:00',5.5),('8975','2014-05-03','11:10:00',6.03),('8975','2014-05-03','11:15:00',6.15),('8975','2014-05-03','11:20:00',7.56),('8975','2014-05-03','11:25:00',7.12),('8975','2014-05-03','11:30:00',6.21),('8975','2014-05-03','11:35:00',7.78),('8975','2014-05-03','11:40:00',7.45),('8975','2014-05-03','11:45:00',6.04),('8975','2014-05-03','11:50:00',6.26),('8975','2014-05-03','11:55:00',7.48),('8975','2014-05-03','12:00:00',8.72),('8975','2014-05-03','12:05:00',8.4),('8975','2014-05-03','12:10:00',3.89),('8975','2014-05-03','12:15:00',3.6),('8975','2014-05-03','12:20:00',2.55),('8975','2014-05-03','12:25:00',2.55),('8975','2014-05-03','12:30:00',2.52),('8975','2014-05-03','12:35:00',2.14),('8975','2014-05-03','12:40:00',2.68),('8975','2014-05-03','12:45:00',2.31),('8975','2014-05-03','12:50:00',2.29),('8975','2014-05-03','12:55:00',2.43),('8975','2014-05-03','13:00:00',2.37),('8975','2014-05-03','13:05:00',2.2),('8975','2014-05-03','13:10:00',2.16),('8975','2014-05-03','13:15:00',2.35),('8975','2014-05-03','13:20:00',2.31),('8975','2014-05-03','13:25:00',2.27),('8975','2014-05-03','13:30:00',2.13),('8975','2014-05-03','13:35:00',2.33),('8975','2014-05-03','13:40:00',2.44),('8975','2014-05-03','13:45:00',2.34),('8975','2014-05-03','13:50:00',2.08),('8975','2014-05-03','13:55:00',2.12),('8975','2014-05-03','14:00:00',2.03),('8975','2014-05-03','14:05:00',1.97),('8975','2014-05-03','14:10:00',2.05),('8975','2014-05-03','14:15:00',2.13),('8975','2014-05-03','14:20:00',1.93),('8975','2014-05-03','14:25:00',1.51),('8975','2014-05-03','14:30:00',1.15),('8975','2014-05-03','14:35:00',1.04),('8975','2014-05-03','14:40:00',1.06),('8975','2014-05-03','14:45:00',1.14),('8975','2014-05-03','14:50:00',1.47),('8975','2014-05-03','14:55:00',2.08),('8975','2014-05-03','15:00:00',2.62),('8975','2014-05-03','15:05:00',3.09),('8975','2014-05-03','15:10:00',4.84),('8975','2014-05-03','15:15:00',6.57),('8975','2014-05-03','15:20:00',3.29),('8975','2014-05-03','15:25:00',4.09),('8975','2014-05-03','15:30:00',2.45),('8975','2014-05-03','15:35:00',1.52),('8975','2014-05-03','15:40:00',1.27),('8975','2014-05-03','15:45:00',1.38),('8975','2014-05-03','15:50:00',1.77),('8975','2014-05-03','15:55:00',2.07),('8975','2014-05-03','16:00:00',2.15),('8975','2014-05-03','16:05:00',2.3),('8975','2014-05-03','16:10:00',2.53),('8975','2014-05-03','16:15:00',2.25),('8975','2014-05-03','16:20:00',2.07),('8975','2014-05-03','16:25:00',1.76),('8975','2014-05-03','16:30:00',1.36),('8975','2014-05-03','16:35:00',1.08),('8975','2014-05-03','16:50:00',1.14),('8975','2014-05-03','16:55:00',1.22),('8975','2014-05-03','17:25:00',1.25),('8975','2014-05-03','17:30:00',1.26),('8975','2014-05-03','17:35:00',1.29),('8975','2014-05-03','17:40:00',1.33),('8975','2014-05-03','17:45:00',1.12),('8975','2014-04-15','07:15:00',1.68),('8975','2014-04-15','07:20:00',1.95),('8975','2014-04-15','07:25:00',2.14),('8975','2014-04-15','07:30:00',2.19),('8975','2014-04-15','07:35:00',2.41),('8975','2014-04-15','07:40:00',2.44),('8975','2014-04-15','07:45:00',2.87),('8975','2014-04-15','07:50:00',3.09),('8975','2014-04-15','07:55:00',3.12),('8975','2014-04-15','08:00:00',3.22),('8975','2014-04-15','08:05:00',3.32),('8975','2014-04-15','08:10:00',3.46),('8975','2014-04-15','08:15:00',3.62),('8975','2014-04-15','08:20:00',3.73),('8975','2014-04-15','08:25:00',3.89),('8975','2014-04-15','08:30:00',3.55),('8975','2014-04-15','08:35:00',2.35),('8975','2014-04-15','08:40:00',2.53),('8975','2014-04-15','08:45:00',3.67),('8975','2014-04-15','08:50:00',4.12),('8975','2014-04-15','08:55:00',4.49),('8975','2014-04-15','09:00:00',4.55),('8975','2014-04-15','09:05:00',4.61),('8975','2014-04-15','09:10:00',4.73),('8975','2014-04-15','09:15:00',4.81),('8975','2014-04-15','09:20:00',4.91),('8975','2014-04-15','09:25:00',5.16),('8975','2014-04-15','09:30:00',4.87),('8975','2014-04-15','09:35:00',3.01),('8975','2014-04-15','09:40:00',1.45),('8975','2014-04-15','09:45:00',1.38),('8975','2014-04-15','09:50:00',1.65),('8975','2014-04-15','09:55:00',4.04),('8975','2014-04-15','10:00:00',6.05),('8975','2014-04-15','10:05:00',5.99),('8975','2014-04-15','10:10:00',6.06),('8975','2014-04-15','10:15:00',6.14),('8975','2014-04-15','10:20:00',6.2),('8975','2014-04-15','10:25:00',6.28),('8975','2014-04-15','10:30:00',6.36),('8975','2014-04-15','10:35:00',6.41),('8975','2014-04-15','10:40:00',6.44),('8975','2014-04-15','10:45:00',6.54),('8975','2014-04-15','10:50:00',6.71),('8975','2014-04-15','10:55:00',6.42),('8975','2014-04-15','11:00:00',4.74),('8975','2014-04-15','11:05:00',4.56),('8975','2014-04-15','11:10:00',3.06),('8975','2014-04-15','11:15:00',3.71),('8975','2014-04-15','11:20:00',4.43),('8975','2014-04-15','11:25:00',8.11),('8975','2014-04-15','11:30:00',5.66),('8975','2014-04-15','11:35:00',5.7),('8975','2014-04-15','11:40:00',5.26),('8975','2014-04-15','11:45:00',6.95),('8975','2014-04-15','11:50:00',7.86),('8975','2014-04-15','11:55:00',7.16),('8975','2014-04-15','12:00:00',7.73),('8975','2014-04-15','12:05:00',7.41),('8975','2014-04-15','12:10:00',2.15),('8975','2014-04-15','12:15:00',6.09),('8975','2014-04-15','12:20:00',2.72),('8975','2014-04-15','12:25:00',2.28),('8975','2014-04-15','12:30:00',1.71),('8975','2014-04-15','12:35:00',4.62),('8975','2014-04-15','12:40:00',7.81),('8975','2014-04-15','12:45:00',7.37),('8975','2014-04-15','12:50:00',5.97),('8975','2014-04-15','12:55:00',2.15),('8975','2014-04-15','13:00:00',2.28),('8975','2014-04-15','13:05:00',2.42),('8975','2014-04-15','13:10:00',1.2),('8975','2014-04-15','13:15:00',1.27),('8975','2014-04-15','13:20:00',2.49),('8975','2014-04-15','13:25:00',1.76),('8975','2014-04-15','13:30:00',1.39),('8975','2014-04-15','13:35:00',1.84),('8975','2014-04-15','13:40:00',3.3),('8975','2014-04-15','13:45:00',7.21),('8975','2014-04-15','13:50:00',5.41),('8975','2014-04-15','13:55:00',7.46),('8975','2014-04-15','14:00:00',3.49),('8975','2014-04-15','14:05:00',2.95),('8975','2014-04-15','14:10:00',3.81),('8975','2014-04-15','14:15:00',4.79),('8975','2014-04-15','14:20:00',6.77),('8975','2014-04-15','14:25:00',5.65),('8975','2014-04-15','14:30:00',6.49),('8975','2014-04-15','14:35:00',6.19),('8975','2014-04-15','14:40:00',5.86),('8975','2014-04-15','14:45:00',6.04),('8975','2014-04-15','14:50:00',6.13),('8975','2014-04-15','14:55:00',4.53),('8975','2014-04-15','15:00:00',2.13),('8975','2014-04-15','15:05:00',3.15),('8975','2014-04-15','15:10:00',6),('8975','2014-04-15','15:15:00',6.39),('8975','2014-04-15','15:20:00',1.19),('8975','2014-04-15','15:25:00',1.4),('8975','2014-04-15','15:30:00',2.11),('8975','2014-04-15','15:35:00',4.86),('8975','2014-04-15','15:40:00',5.17),('8975','2014-04-15','15:45:00',4.72),('8975','2014-04-15','15:50:00',4.19),('8975','2014-04-15','15:55:00',3.65),('8975','2014-04-15','16:00:00',4.09),('8975','2014-04-15','16:05:00',3.89),('8975','2014-04-15','16:10:00',3.75),('8975','2014-04-15','16:15:00',3.64),('8975','2014-04-15','16:20:00',3.67),('8975','2014-04-15','16:25:00',3.45),('8975','2014-04-15','16:30:00',3.32),('8975','2014-04-15','16:35:00',3.22),('8975','2014-04-15','16:40:00',3.11),('8975','2014-04-15','16:45:00',2.98),('8975','2014-04-15','16:50:00',2.83),('8975','2014-04-15','16:55:00',2.67),('8975','2014-04-15','17:00:00',2.56),('8975','2014-04-15','17:05:00',2.42),('8975','2014-04-15','17:10:00',2.3),('8975','2014-04-15','17:15:00',2.23),('8975','2014-04-15','17:20:00',2.09),('8975','2014-04-15','17:25:00',1.97),('8975','2014-04-15','17:30:00',1.89),('8975','2014-04-15','17:35:00',1.83),('8975','2014-04-15','17:40:00',1.77),('8975','2014-04-15','17:45:00',1.78),('8975','2014-04-15','17:50:00',1.93),('8975','2014-04-15','17:55:00',2.06),('8975','2014-04-15','18:00:00',1.84),('8975','2014-04-15','18:05:00',1.81),('8975','2014-04-15','18:10:00',1.75),('8975','2014-04-15','18:15:00',1.5),('8975','2014-04-15','18:20:00',1.55),('8975','2014-04-15','18:25:00',1.44),('8975','2014-04-15','18:30:00',1.29),('8975','2014-04-15','18:35:00',1.31),('8975','2014-04-15','18:40:00',1.11),('8975','2014-04-15','18:45:00',1.33),('8975','2014-04-15','18:50:00',1.36),('8975','2014-04-15','18:55:00',1.24),('8975','2013-10-17','07:55:00',1.13),('8975','2013-10-17','08:00:00',1.51),('8975','2013-10-17','08:05:00',1.68),('8975','2013-10-17','08:10:00',1.88),('8975','2013-10-17','08:15:00',1.83),('8975','2013-10-17','08:20:00',1.92),('8975','2013-10-17','08:25:00',2.03),('8975','2013-10-17','08:30:00',2.05),('8975','2013-10-17','08:35:00',2.28),('8975','2013-10-17','08:40:00',2.42),('8975','2013-10-17','08:45:00',2.55),('8975','2013-10-17','08:50:00',2.54),('8975','2013-10-17','08:55:00',2.57),('8975','2013-10-17','09:00:00',2.69),('8975','2013-10-17','09:05:00',2.92),('8975','2013-10-17','09:10:00',2.99),('8975','2013-10-17','09:15:00',3.03),('8975','2013-10-17','09:20:00',3.24),('8975','2013-10-17','09:25:00',3.33),('8975','2013-10-17','09:30:00',3.37),('8975','2013-10-17','09:35:00',3.48),('8975','2013-10-17','09:40:00',3.57),('8975','2013-10-17','09:45:00',3.63),('8975','2013-10-17','09:50:00',3.7),('8975','2013-10-17','09:55:00',3.75),('8975','2013-10-17','10:00:00',3.82),('8975','2013-10-17','10:05:00',3.89),('8975','2013-10-17','10:10:00',3.91),('8975','2013-10-17','10:15:00',3.99),('8975','2013-10-17','10:20:00',4.03),('8975','2013-10-17','10:25:00',4.13),('8975','2013-10-17','10:30:00',4.22),('8975','2013-10-17','10:35:00',4.26),('8975','2013-10-17','10:40:00',4.23),('8975','2013-10-17','10:45:00',4.31),('8975','2013-10-17','10:50:00',4.26),('8975','2013-10-17','10:55:00',4.2),('8975','2013-10-17','11:00:00',4.37),('8975','2013-10-17','11:05:00',4.4),('8975','2013-10-17','11:10:00',4.35),('8975','2013-10-17','11:15:00',4.29),('8975','2013-10-17','11:20:00',4.52),('8975','2013-10-17','11:25:00',4.52),('8975','2013-10-17','11:30:00',4.49),('8975','2013-10-17','11:35:00',4.56),('8975','2013-10-17','11:40:00',4.64),('8975','2013-10-17','11:45:00',3.1),('8975','2013-10-17','11:50:00',3.85),('8975','2013-10-17','11:55:00',4.53),('8975','2013-10-17','12:00:00',4.48),('8975','2013-10-17','12:05:00',3.06),('8975','2013-10-17','12:10:00',3.92),('8975','2013-10-17','12:15:00',4.24),('8975','2013-10-17','12:20:00',4.21),('8975','2013-10-17','12:25:00',3.9),('8975','2013-10-17','12:30:00',3.81),('8975','2013-10-17','12:35:00',4),('8975','2013-10-17','12:40:00',3.84),('8975','2013-10-17','12:45:00',3.68),('8975','2013-10-17','12:50:00',3.64),('8975','2013-10-17','12:55:00',4.14),('8975','2013-10-17','13:00:00',4.1),('8975','2013-10-17','13:05:00',3.95),('8975','2013-10-17','13:10:00',3.79),('8975','2013-10-17','13:15:00',3.77),('8975','2013-10-17','13:20:00',3.94),('8975','2013-10-17','13:25:00',3.95),('8975','2013-10-17','13:30:00',3.96),('8975','2013-10-17','13:35:00',3.74),('8975','2013-10-17','13:40:00',3.63),('8975','2013-10-17','13:45:00',3.45),('8975','2013-10-17','13:50:00',3.44),('8975','2013-10-17','13:55:00',3.49),('8975','2013-10-17','14:00:00',3.34),('8975','2013-10-17','14:05:00',3.21),('8975','2013-10-17','14:10:00',3.16),('8975','2013-10-17','14:15:00',3.22),('8975','2013-10-17','14:20:00',3.06),('8975','2013-10-17','14:25:00',2.93),('8975','2013-10-17','14:30:00',2.94),('8975','2013-10-17','14:35:00',2.79),('8975','2013-10-17','14:40:00',2.8),('8975','2013-10-17','14:45:00',2.59),('8975','2013-10-17','14:50:00',2.5),('8975','2013-10-17','14:55:00',2.4),('8975','2013-10-17','15:00:00',2.27),('8975','2013-10-17','15:05:00',2.08),('8975','2013-10-17','15:10:00',2.18),('8975','2013-10-17','15:15:00',2.17),('8975','2013-10-17','15:20:00',2.19),('8975','2013-10-17','15:25:00',2.03),('8975','2013-10-17','15:30:00',1.83),('8975','2013-10-17','15:35:00',1.83),('8975','2013-10-17','15:40:00',1.7),('8975','2013-10-17','15:45:00',1.58),('8975','2013-10-17','15:50:00',1.43),('8975','2013-10-17','15:55:00',1.4),('8975','2013-10-17','16:00:00',1.46),('8975','2013-10-17','16:05:00',1.4),('8975','2013-10-17','16:10:00',1.42),('8975','2013-10-17','16:15:00',1.25),('8975','2013-10-17','16:20:00',1.23),('8975','2013-10-17','16:25:00',1.11),('8975','2013-10-17','16:30:00',1.07),('8975','2013-10-17','16:35:00',1.03),('8975','2013-10-16','08:00:00',1.35),('8975','2013-10-16','08:05:00',1.49),('8975','2013-10-16','08:10:00',1.65),('8975','2013-10-16','08:15:00',1.82),('8975','2013-10-16','08:20:00',1.99),('8975','2013-10-16','08:25:00',2.13),('8975','2013-10-16','08:30:00',2.25),('8975','2013-10-16','08:35:00',2.37),('8975','2013-10-16','08:40:00',2.48),('8975','2013-10-16','08:45:00',2.58),('8975','2013-10-16','08:50:00',2.69),('8975','2013-10-16','08:55:00',2.78),('8975','2013-10-16','09:00:00',2.85),('8975','2013-10-16','09:05:00',2.95),('8975','2013-10-16','09:10:00',3.03),('8975','2013-10-16','09:15:00',3.12),('8975','2013-10-16','09:20:00',3.2),('8975','2013-10-16','09:25:00',3.3),('8975','2013-10-16','09:30:00',3.38),('8975','2013-10-16','09:35:00',3.47),('8975','2013-10-16','09:40:00',3.56),('8975','2013-10-16','09:45:00',3.64),('8975','2013-10-16','09:50:00',3.69),('8975','2013-10-16','09:55:00',3.73),('8975','2013-10-16','10:00:00',3.77),('8975','2013-10-16','10:05:00',3.86),('8975','2013-10-16','10:10:00',3.93),('8975','2013-10-16','10:15:00',4.02),('8975','2013-10-16','10:20:00',4.1),('8975','2013-10-16','10:25:00',4.16),('8975','2013-10-16','10:30:00',4.22),('8975','2013-10-16','10:35:00',4.23),('8975','2013-10-16','10:40:00',4.24),('8975','2013-10-16','10:45:00',4.36),('8975','2013-10-16','10:50:00',4.4),('8975','2013-10-16','10:55:00',4.44),('8975','2013-10-16','11:00:00',4.44),('8975','2013-10-16','11:05:00',4.53),('8975','2013-10-16','11:10:00',4.57),('8975','2013-10-16','11:15:00',4.6),('8975','2013-10-16','11:20:00',4.63),('8975','2013-10-16','11:25:00',4.64),('8975','2013-10-16','11:30:00',4.66),('8975','2013-10-16','11:35:00',4.69),('8975','2013-10-16','11:40:00',4.7),('8975','2013-10-16','11:45:00',4.71),('8975','2013-10-16','11:50:00',4.72),('8975','2013-10-16','11:55:00',4.73),('8975','2013-10-16','12:00:00',4.68),('8975','2013-10-16','12:05:00',4.73),('8975','2013-10-16','12:10:00',4.73),('8975','2013-10-16','12:15:00',4.69),('8975','2013-10-16','12:20:00',4.66),('8975','2013-10-16','12:25:00',4.63),('8975','2013-10-16','12:30:00',4.58),('8975','2013-10-16','12:35:00',4.51),('8975','2013-10-16','12:40:00',4.49),('8975','2013-10-16','12:45:00',4.49),('8975','2013-10-16','12:50:00',4.5),('8975','2013-10-16','12:55:00',4.45),('8975','2013-10-16','13:00:00',4.4),('8975','2013-10-16','13:05:00',4.4),('8975','2013-10-16','13:10:00',4.34),('8975','2013-10-16','13:15:00',4.28),('8975','2013-10-16','13:20:00',4.24),('8975','2013-10-16','13:25:00',4.19),('8975','2013-10-16','13:30:00',4.12),('8975','2013-10-16','13:35:00',3.92),('8975','2013-10-16','13:40:00',3.58),('8975','2013-10-16','13:45:00',3.68),('8975','2013-10-16','13:50:00',3.26),('8975','2013-10-16','13:55:00',3.36),('8975','2013-10-16','14:00:00',3.37),('8975','2013-10-16','14:05:00',3.12),('8975','2013-10-16','14:10:00',3.49),('8975','2013-10-16','14:15:00',3.11),('8975','2013-10-16','14:20:00',2.88),('8975','2013-10-16','14:25:00',3.01),('8975','2013-10-16','14:30:00',3.02),('8975','2013-10-16','14:35:00',2.74),('8975','2013-10-16','14:40:00',2.72),('8975','2013-10-16','14:45:00',2.86),('8975','2013-10-16','14:50:00',2.69),('8975','2013-10-16','14:55:00',2.48),('8975','2013-10-16','15:00:00',2.57),('8975','2013-10-16','15:05:00',2.53),('8975','2013-10-16','15:10:00',2.43),('8975','2013-10-16','15:15:00',2.37),('8975','2013-10-16','15:20:00',2.31),('8975','2013-10-16','15:25:00',2.2),('8975','2013-10-16','15:30:00',2.11),('8975','2013-10-16','15:35:00',2.03),('8975','2013-10-16','15:40:00',1.93),('8975','2013-10-16','15:45:00',1.83),('8975','2013-10-16','15:50:00',1.75),('8975','2013-10-16','15:55:00',1.68),('8975','2013-10-16','16:00:00',1.61),('8975','2013-10-16','16:05:00',1.54),('8975','2013-10-16','16:10:00',1.49),('8975','2013-10-16','16:15:00',1.44),('8975','2013-10-16','16:20:00',1.4),('8975','2013-10-16','16:25:00',1.34),('8975','2013-10-16','16:30:00',1.32),('8975','2013-10-16','16:35:00',1.29),('8975','2013-10-16','16:40:00',1.25),('8975','2013-10-16','16:45:00',1.21),('8975','2013-10-16','16:50:00',1.17),('8975','2013-10-16','16:55:00',1.13),('8975','2013-10-16','17:00:00',1.08),('8975','2013-10-16','17:05:00',1.03),('8975','2013-10-15','08:30:00',1.7),('8975','2013-10-15','09:45:00',2.79),('8975','2013-10-15','09:50:00',4.66),('8975','2013-10-15','09:55:00',2.28),('8975','2013-10-15','10:00:00',1.35),('8975','2013-10-15','11:05:00',1.63),('8975','2013-10-15','11:10:00',1.82),('8975','2013-10-15','11:15:00',1.49),('8975','2013-10-15','11:20:00',2.18),('8975','2013-10-15','11:25:00',1.3),('8975','2013-10-15','11:55:00',1.37),('8975','2013-10-15','12:00:00',1.8),('8975','2013-10-15','12:10:00',1.25),('8975','2013-10-15','12:15:00',1.97),('8975','2013-10-15','12:20:00',1.58),('8975','2013-10-15','12:25:00',1.53),('8975','2013-10-15','12:30:00',2.48),('8975','2013-10-15','12:35:00',4.24),('8975','2013-10-15','12:40:00',3.16),('8975','2013-10-15','12:45:00',4.45),('8975','2013-10-15','12:50:00',3.2),('8975','2013-10-15','12:55:00',4.28),('8975','2013-10-15','13:00:00',4.04),('8975','2013-10-15','13:05:00',2.9),('8975','2013-10-15','13:10:00',2.19),('8975','2013-10-15','13:15:00',4.36),('8975','2013-10-15','13:20:00',3.27),('8975','2013-10-15','13:25:00',3.88),('8975','2013-10-15','13:30:00',3.23),('8975','2013-10-15','13:35:00',3.91),('8975','2013-10-15','13:40:00',2.69),('8975','2013-10-15','13:45:00',3.66),('8975','2013-10-15','13:50:00',3.4),('8975','2013-10-15','13:55:00',3.67),('8975','2013-10-15','14:00:00',3.45),('8975','2013-10-15','14:05:00',3.1),('8975','2013-10-15','14:10:00',2.82),('8975','2013-10-15','14:15:00',2.95),('8975','2013-10-15','14:20:00',3.57),('8975','2013-10-15','14:25:00',2.82),('8975','2013-10-15','14:30:00',3.32),('8975','2013-10-15','14:35:00',3.39),('8975','2013-10-15','14:40:00',3.19),('8975','2013-10-15','14:45:00',3.04),('8975','2013-10-15','14:50:00',2.98),('8975','2013-10-15','14:55:00',2.16),('8975','2013-10-15','15:00:00',2.71),('8975','2013-10-15','15:05:00',2.64),('8975','2013-10-15','15:10:00',3.07),('8975','2013-10-15','15:15:00',2.58),('8975','2013-10-15','15:20:00',2.44),('8975','2013-10-15','15:25:00',2.1),('8975','2013-10-15','15:30:00',2.44),('8975','2013-10-15','15:35:00',2.95),('8975','2013-10-15','15:40:00',2.3),('8975','2013-10-15','15:45:00',1.94),('8975','2013-10-15','15:50:00',1.79),('8975','2013-10-15','15:55:00',1.71),('8975','2013-10-15','16:00:00',1.68),('8975','2013-10-15','16:05:00',1.63),('8975','2013-10-15','16:10:00',1.58),('8975','2013-10-15','16:15:00',1.54),('8975','2013-10-15','16:20:00',1.47),('8975','2013-10-15','16:25:00',1.42),('8975','2013-10-15','16:30:00',1.4),('8975','2013-10-15','16:35:00',1.38),('8975','2013-10-15','16:40:00',1.35),('8975','2013-10-15','16:45:00',1.26),('8975','2013-10-15','16:50:00',1.25),('8975','2013-10-15','16:55:00',1.21),('8975','2013-10-15','17:00:00',1.14),('8975','2013-10-15','17:05:00',1.09),('8975','2013-10-15','17:10:00',1.05),('8975','2013-10-14','08:30:00',1.03),('8975','2013-10-14','08:35:00',1.06),('8975','2013-10-14','08:40:00',1.03),('8975','2013-10-14','08:55:00',1.13),('8975','2013-10-14','09:00:00',1.55),('8975','2013-10-14','09:05:00',1.72),('8975','2013-10-14','09:10:00',1.76),('8975','2013-10-14','09:15:00',1.52),('8975','2013-10-14','09:20:00',1.94),('8975','2013-10-14','09:25:00',1.8),('8975','2013-10-14','09:30:00',2.72),('8975','2013-10-14','09:35:00',1.97),('8975','2013-10-14','09:40:00',2.41),('8975','2013-10-14','09:45:00',3.1),('8975','2013-10-14','09:50:00',3.4),('8975','2013-10-14','09:55:00',3.49),('8975','2013-10-14','10:00:00',3.5),('8975','2013-10-14','10:05:00',4.17),('8975','2013-10-14','10:10:00',3.18),('8975','2013-10-14','10:15:00',1.75),('8975','2013-10-14','10:20:00',1.7),('8975','2013-10-14','10:25:00',2.34),('8975','2013-10-14','10:30:00',3.69),('8975','2013-10-14','10:35:00',2.27),('8975','2013-10-14','10:40:00',2.58),('8975','2013-10-14','10:45:00',3.38),('8975','2013-10-14','10:50:00',3.71),('8975','2013-10-14','10:55:00',3.03),('8975','2013-10-14','11:00:00',3.01),('8975','2013-10-14','11:05:00',3.09),('8975','2013-10-14','11:10:00',3.66),('8975','2013-10-14','11:15:00',4.46),('8975','2013-10-14','11:20:00',4.31),('8975','2013-10-14','11:25:00',3.99),('8975','2013-10-14','11:30:00',4.08),('8975','2013-10-14','11:35:00',3.47),('8975','2013-10-14','11:40:00',2.82),('8975','2013-10-14','11:45:00',2.35),('8975','2013-10-14','11:50:00',2.24),('8975','2013-10-14','11:55:00',2.25),('8975','2013-10-14','12:00:00',2.33),('8975','2013-10-14','12:05:00',2.35),('8975','2013-10-14','12:10:00',2.31),('8975','2013-10-14','12:15:00',2.36),('8975','2013-10-14','12:20:00',2.42),('8975','2013-10-14','12:25:00',2.34),('8975','2013-10-14','12:30:00',2.19),('8975','2013-10-14','12:35:00',2.12),('8975','2013-10-14','12:40:00',2.17),('8975','2013-10-14','12:45:00',2.31),('8975','2013-10-14','12:50:00',2.16),('8975','2013-10-14','12:55:00',1.96),('8975','2013-10-14','13:00:00',1.94),('8975','2013-10-14','13:05:00',2.41),('8975','2013-10-14','13:10:00',2.69),('8975','2013-10-14','13:15:00',2.62),('8975','2013-10-14','13:20:00',3.42),('8975','2013-10-14','13:25:00',3.83),('8975','2013-10-14','13:30:00',2.71),('8975','2013-10-14','13:35:00',2.33),('8975','2013-10-14','13:40:00',2.37),('8975','2013-10-14','13:45:00',2.45),('8975','2013-10-14','13:50:00',2.27),('8975','2013-10-14','13:55:00',2.04),('8975','2013-10-14','14:00:00',1.84),('8975','2013-10-14','14:05:00',1.79),('8975','2013-10-14','14:10:00',1.98),('8975','2013-10-14','14:15:00',2.57),('8975','2013-10-14','14:20:00',2.7),('8975','2013-10-14','14:25:00',2.48),('8975','2013-10-14','14:30:00',2.74),('8975','2013-10-14','14:35:00',1.78),('8975','2013-10-14','14:40:00',2.42),('8975','2013-10-14','14:45:00',3.01),('8975','2013-10-14','14:50:00',2.44),('8975','2013-10-14','14:55:00',1.64),('8975','2013-10-14','15:00:00',1.51),('8975','2013-10-14','15:05:00',1.81),('8975','2013-10-14','15:10:00',1.61),('8975','2013-10-14','15:15:00',1.66),('8975','2013-10-14','15:20:00',1.66),('8975','2013-10-14','15:25:00',1.42),('8975','2013-10-14','15:30:00',1.48),('8975','2013-10-14','15:35:00',1.5),('8975','2013-10-14','15:40:00',1.56),('8975','2013-10-14','15:45:00',1.54),('8975','2013-10-14','15:50:00',1.4),('8975','2013-10-14','15:55:00',1.12),('8975','2013-10-14','16:00:00',1.11),('8975','2013-10-14','16:05:00',1.11),('8975','2013-10-14','16:10:00',1.18),('8975','2013-10-14','16:15:00',1.1),('8975','2013-10-14','16:25:00',1.2),('8975','2013-10-14','16:30:00',1.54),('8975','2013-10-14','16:35:00',1.57),('8975','2013-10-14','16:40:00',1.29),('8975','2013-10-14','16:45:00',1.03),('8975','2013-10-13','08:00:00',1.16),('8975','2013-10-13','08:05:00',1.45),('8975','2013-10-13','08:10:00',1.58),('8975','2013-10-13','08:15:00',1.45),('8975','2013-10-13','08:20:00',1.76),('8975','2013-10-13','08:25:00',2.15),('8975','2013-10-13','08:30:00',2.18),('8975','2013-10-13','08:35:00',2.3),('8975','2013-10-13','08:40:00',2.03),('8975','2013-10-13','08:45:00',2.49),('8975','2013-10-13','08:50:00',2.41),('8975','2013-10-13','08:55:00',2.41),('8975','2013-10-13','09:00:00',2.17),('8975','2013-10-13','09:05:00',2.28),('8975','2013-10-13','09:10:00',2.04),('8975','2013-10-13','09:15:00',1.55),('8975','2013-10-13','09:20:00',2.08),('8975','2013-10-13','09:25:00',2.85),('8975','2013-10-13','09:30:00',3.26),('8975','2013-10-13','09:35:00',3.25),('8975','2013-10-13','09:40:00',2.33),('8975','2013-10-13','09:45:00',2.3),('8975','2013-10-13','09:50:00',2.71),('8975','2013-10-13','09:55:00',3.15),('8975','2013-10-13','10:00:00',3),('8975','2013-10-13','10:05:00',3.44),('8975','2013-10-13','10:10:00',3.57),('8975','2013-10-13','10:15:00',3.93),('8975','2013-10-13','10:20:00',3.97),('8975','2013-10-13','10:25:00',4.01),('8975','2013-10-13','10:30:00',4.03),('8975','2013-10-13','10:35:00',3.99),('8975','2013-10-13','10:40:00',3.98),('8975','2013-10-13','10:45:00',4.07),('8975','2013-10-13','10:50:00',4.19),('8975','2013-10-13','10:55:00',4.27),('8975','2013-10-13','11:00:00',4.29),('8975','2013-10-13','11:05:00',4.34),('8975','2013-10-13','11:10:00',4.46),('8975','2013-10-13','11:15:00',4.36),('8975','2013-10-13','11:20:00',4.4),('8975','2013-10-13','11:25:00',4.48),('8975','2013-10-13','11:30:00',4.54),('8975','2013-10-13','11:35:00',4.38),('8975','2013-10-13','11:40:00',4.46),('8975','2013-10-13','11:45:00',4.45),('8975','2013-10-13','11:50:00',4.41),('8975','2013-10-13','11:55:00',4.43),('8975','2013-10-13','12:00:00',4.44),('8975','2013-10-13','12:05:00',4.47),('8975','2013-10-13','12:10:00',4.54),('8975','2013-10-13','12:15:00',4.4),('8975','2013-10-13','12:20:00',4.17),('8975','2013-10-13','12:25:00',4.39),('8975','2013-10-13','12:30:00',4.49),('8975','2013-10-13','12:35:00',4.3),('8975','2013-10-13','12:40:00',4.23),('8975','2013-10-13','12:45:00',4.28),('8975','2013-10-13','12:50:00',4.3),('8975','2013-10-13','12:55:00',4.25),('8975','2013-10-13','13:00:00',4.21),('8975','2013-10-13','13:05:00',4.15),('8975','2013-10-13','13:10:00',4.1),('8975','2013-10-13','13:15:00',4.03),('8975','2013-10-13','13:20:00',4),('8975','2013-10-13','13:25:00',3.97),('8975','2013-10-13','13:30:00',3.92),('8975','2013-10-13','13:35:00',3.82),('8975','2013-10-13','13:40:00',3.63),('8975','2013-10-13','13:45:00',3.55),('8975','2013-10-13','13:50:00',3.63),('8975','2013-10-13','13:55:00',3.48),('8975','2013-10-13','14:00:00',3.23),('8975','2013-10-13','14:05:00',3.07),('8975','2013-10-13','14:10:00',2.96),('8975','2013-10-13','14:15:00',3.32),('8975','2013-10-13','14:20:00',2.94),('8975','2013-10-13','14:25:00',3.02),('8975','2013-10-13','14:30:00',3.04),('8975','2013-10-13','14:35:00',2.8),('8975','2013-10-13','14:40:00',2.92),('8975','2013-10-13','14:45:00',2.82),('8975','2013-10-13','14:50:00',2.71),('8975','2013-10-13','14:55:00',2.5),('8975','2013-10-13','15:00:00',2.27),('8975','2013-10-13','15:05:00',2.51),('8975','2013-10-13','15:10:00',2.42),('8975','2013-10-13','15:15:00',2.34),('8975','2013-10-13','15:20:00',2.28),('8975','2013-10-13','15:25:00',2.19),('8975','2013-10-13','15:30:00',2.11),('8975','2013-10-13','15:35:00',2),('8975','2013-10-13','15:40:00',1.86),('8975','2013-10-13','15:45:00',1.39),('8975','2013-10-13','15:50:00',1.6),('8975','2013-10-13','15:55:00',1.46),('8975','2013-10-13','16:00:00',1.02),('8975','2013-10-13','16:05:00',1.48),('8975','2013-10-13','16:10:00',1.19),('8975','2013-10-13','16:15:00',1.25),('8975','2013-10-13','16:25:00',1.14),('8975','2013-10-13','16:30:00',1.04),('8975','2013-10-12','08:15:00',1.09),('8975','2013-10-12','08:20:00',1.23),('8975','2013-10-12','08:25:00',1.22),('8975','2013-10-12','08:30:00',1.56),('8975','2013-10-12','08:35:00',1.81),('8975','2013-10-12','08:40:00',1.85),('8975','2013-10-12','08:45:00',1.58),('8975','2013-10-12','08:50:00',1.67),('8975','2013-10-12','08:55:00',1.95),('8975','2013-10-12','09:00:00',2.16),('8975','2013-10-12','09:05:00',2.17),('8975','2013-10-12','09:10:00',2.35),('8975','2013-10-12','09:15:00',3.18),('8975','2013-10-12','09:20:00',3.31),('8975','2013-10-12','09:25:00',3.08),('8975','2013-10-12','09:30:00',2.44),('8975','2013-10-12','09:35:00',2.89),('8975','2013-10-12','09:40:00',3.99),('8975','2013-10-12','09:45:00',4.44),('8975','2013-10-12','09:50:00',4.47),('8975','2013-10-12','09:55:00',4.52),('8975','2013-10-12','10:00:00',3.1),('8975','2013-10-12','10:05:00',2.53),('8975','2013-10-12','10:10:00',3.78),('8975','2013-10-12','10:15:00',3.76),('8975','2013-10-12','10:20:00',3.46),('8975','2013-10-12','10:25:00',4.33),('8975','2013-10-12','10:30:00',4.52),('8975','2013-10-12','10:35:00',4.79),('8975','2013-10-12','10:40:00',4.72),('8975','2013-10-12','10:45:00',5.04),('8975','2013-10-12','10:50:00',3.54),('8975','2013-10-12','10:55:00',4.34),('8975','2013-10-12','11:00:00',4.54),('8975','2013-10-12','11:05:00',5.19),('8975','2013-10-12','11:10:00',5.24),('8975','2013-10-12','11:15:00',4.71),('8975','2013-10-12','11:20:00',4.59),('8975','2013-10-12','11:25:00',4.53),('8975','2013-10-12','11:30:00',4.6),('8975','2013-10-12','11:35:00',4.54),('8975','2013-10-12','11:40:00',4.54),('8975','2013-10-12','11:45:00',4.55),('8975','2013-10-12','11:50:00',4.59),('8975','2013-10-12','11:55:00',4.59),('8975','2013-10-12','12:00:00',4.57),('8975','2013-10-12','12:05:00',4.58),('8975','2013-10-12','12:10:00',4.57),('8975','2013-10-12','12:15:00',4.56),('8975','2013-10-12','12:20:00',4.39),('8975','2013-10-12','12:25:00',4.27),('8975','2013-10-12','12:30:00',4.51),('8975','2013-10-12','12:35:00',4.43),('8975','2013-10-12','12:40:00',4.41),('8975','2013-10-12','12:45:00',4.39),('8975','2013-10-12','12:50:00',4.3),('8975','2013-10-12','12:55:00',4.22),('8975','2013-10-12','13:00:00',4.25),('8975','2013-10-12','13:05:00',4.24),('8975','2013-10-12','13:10:00',4.19),('8975','2013-10-12','13:15:00',4.22),('8975','2013-10-12','13:20:00',3.98),('8975','2013-10-12','13:25:00',3.84),('8975','2013-10-12','13:30:00',3.35),('8975','2013-10-12','13:35:00',3.15),('8975','2013-10-12','13:40:00',2.63),('8975','2013-10-12','13:45:00',2.4),('8975','2013-10-12','13:50:00',2.94),('8975','2013-10-12','13:55:00',3.82),('8975','2013-10-12','14:00:00',4.08),('8975','2013-10-12','14:05:00',3.88),('8975','2013-10-12','14:10:00',3.63),('8975','2013-10-12','14:15:00',3.17),('8975','2013-10-12','14:20:00',3.66),('8975','2013-10-12','14:25:00',3.68),('8975','2013-10-12','14:30:00',2.71),('8975','2013-10-12','14:35:00',3.11),('8975','2013-10-12','14:40:00',3.07),('8975','2013-10-12','14:45:00',1.95),('8975','2013-10-12','14:50:00',2.52),('8975','2013-10-12','14:55:00',2.49),('8975','2013-10-12','15:00:00',2.9),('8975','2013-10-12','15:05:00',2.18),('8975','2013-10-12','15:10:00',2.33),('8975','2013-10-12','15:15:00',2.58),('8975','2013-10-12','15:20:00',2.69),('8975','2013-10-12','15:25:00',2.73),('8975','2013-10-12','15:30:00',2.06),('8975','2013-10-12','15:35:00',1.74),('8975','2013-10-12','15:40:00',1.96),('8975','2013-10-12','15:45:00',1.93),('8975','2013-10-12','15:50:00',1.8),('8975','2013-10-12','15:55:00',1.74),('8975','2013-10-12','16:00:00',1.72),('8975','2013-10-12','16:05:00',1.89),('8975','2013-10-12','16:10:00',1.95),('8975','2013-10-12','16:15:00',1.88),('8975','2013-10-12','16:20:00',1.86),('8975','2013-10-12','16:25:00',1.94),('8975','2013-10-12','16:30:00',1.7),('8975','2013-10-12','16:35:00',1.53),('8975','2013-10-12','16:40:00',1.32),('8975','2013-10-12','16:45:00',1.24),('8975','2013-10-12','16:50:00',1.11),('8975','2013-10-12','16:55:00',1),('8975','2013-10-12','17:25:00',1.15),('8975','2013-10-11','11:00:00',1.11),('8975','2013-10-11','11:05:00',1.19),('8975','2013-10-11','11:10:00',1.26),('8975','2013-10-11','11:15:00',1.44),('8975','2013-10-11','11:20:00',1.66),('8975','2013-10-11','11:25:00',1.81),('8975','2013-10-11','11:30:00',2.1),('8975','2013-10-11','11:35:00',2.85),('8975','2013-10-11','11:40:00',4.41),('8975','2013-10-11','11:45:00',2.55),('8975','2013-10-11','11:50:00',2.47),('8975','2013-10-11','11:55:00',2.09),('8975','2013-10-11','12:00:00',1.38),('8975','2013-10-11','12:10:00',1.26),('8975','2013-10-11','12:15:00',1.79),('8975','2013-10-11','12:20:00',3.83),('8975','2013-10-11','12:25:00',5.38),('8975','2013-10-11','12:30:00',4.44),('8975','2013-10-11','12:35:00',4.7),('8975','2013-10-11','12:40:00',4.32),('8975','2013-10-11','12:45:00',2.85),('8975','2013-10-11','12:50:00',2.74),('8975','2013-10-11','12:55:00',2.36),('8975','2013-10-11','13:00:00',2.13),('8975','2013-10-11','13:05:00',1.72),('8975','2013-10-11','13:10:00',1.49),('8975','2013-10-11','13:15:00',2.05),('8975','2013-10-11','13:20:00',1.97),('8975','2013-10-11','13:25:00',2.73),('8975','2013-10-11','13:30:00',5.14),('8975','2013-10-11','13:35:00',2.41),('8975','2013-10-11','13:40:00',1.27),('8975','2013-10-11','13:55:00',1),('8975','2013-10-11','14:00:00',1.1),('8975','2013-10-11','15:20:00',1.03),('8975','2013-10-11','15:25:00',1.22),('8975','2013-10-11','15:30:00',1.29),('8975','2013-10-11','15:35:00',1.22),('8975','2013-10-11','15:40:00',1.1),('8975','2013-10-11','15:45:00',1.04),('8975','2013-10-11','15:50:00',1.16),('8975','2013-10-11','15:55:00',1.47),('8975','2013-10-11','16:00:00',1.65),('8975','2013-10-11','16:05:00',1.59),('8975','2013-10-11','16:10:00',1.68),('8975','2013-10-11','16:15:00',2.11),('8975','2013-10-11','16:20:00',2.43),('8975','2013-10-11','16:25:00',1.51),('8975','2013-10-10','08:15:00',1.35),('8975','2013-10-10','08:35:00',1.52),('8975','2013-10-10','09:30:00',1.47),('8975','2013-10-10','09:40:00',3.33),('8975','2013-10-10','09:45:00',3.89),('8975','2013-10-10','09:50:00',3.49),('8975','2013-10-10','09:55:00',3.91),('8975','2013-10-10','10:00:00',4.02),('8975','2013-10-10','10:05:00',3.97),('8975','2013-10-10','10:10:00',2.87),('8975','2013-10-10','10:15:00',1.25),('8975','2013-10-10','10:20:00',2.58),('8975','2013-10-10','10:25:00',3.29),('8975','2013-10-10','10:30:00',2.73),('8975','2013-10-10','10:35:00',3.03),('8975','2013-10-10','10:40:00',1.34),('8975','2013-10-10','10:45:00',1),('8975','2013-10-10','10:55:00',1.09),('8975','2013-10-10','11:00:00',1.95),('8975','2013-10-10','11:05:00',3.24),('8975','2013-10-10','11:10:00',3.26),('8975','2013-10-10','11:15:00',2.05),('8975','2013-10-10','11:20:00',2.07),('8975','2013-10-10','11:25:00',1.81),('8975','2013-10-10','11:30:00',1.64),('8975','2013-10-10','11:35:00',1.81),('8975','2013-10-10','11:40:00',2.33),('8975','2013-10-10','11:45:00',2.66),('8975','2013-10-10','11:50:00',2.96),('8975','2013-10-10','11:55:00',2.7),('8975','2013-10-10','12:00:00',6.35),('8975','2013-10-10','12:05:00',3.85),('8975','2013-10-10','12:10:00',1.52),('8975','2013-10-10','12:15:00',1.45),('8975','2013-10-10','12:20:00',1.8),('8975','2013-10-10','12:25:00',2),('8975','2013-10-10','12:30:00',1.48),('8975','2013-10-10','12:35:00',1.21),('8975','2013-10-10','12:55:00',1.54),('8975','2013-10-10','13:00:00',2.11),('8975','2013-10-10','13:05:00',4.91),('8975','2013-10-10','13:10:00',5.09),('8975','2013-10-10','13:15:00',4.16),('8975','2013-10-10','13:20:00',6.05),('8975','2013-10-10','13:25:00',4.01),('8975','2013-10-10','13:30:00',1.32),('8975','2013-10-10','13:35:00',1.14),('8975','2013-10-10','13:40:00',3.92),('8975','2013-10-10','13:45:00',2.19),('8975','2013-10-10','14:55:00',1.26),('8975','2013-10-10','15:10:00',1.64),('8975','2013-10-10','15:25:00',1.4),('8975','2013-10-10','15:30:00',1.78),('8975','2013-10-10','15:35:00',1.61),('8975','2013-10-10','15:40:00',1.51),('8975','2013-10-10','15:45:00',1.11),('8975','2013-10-10','15:50:00',1.3),('8975','2013-10-10','15:55:00',2.24),('8975','2013-10-10','16:00:00',1.93),('8975','2013-10-10','16:05:00',1.81),('8975','2013-10-10','16:10:00',1.29),('8975','2013-10-10','16:25:00',1.12),('8975','2013-10-09','07:50:00',1.21),('8975','2013-10-09','07:55:00',1.4),('8975','2013-10-09','08:05:00',1.42),('8975','2013-10-09','08:35:00',1.11),('8975','2013-10-09','08:40:00',2.87),('8975','2013-10-09','08:45:00',2.91),('8975','2013-10-09','08:50:00',2.91),('8975','2013-10-09','08:55:00',1.72),('8975','2013-10-09','09:00:00',2.39),('8975','2013-10-09','09:05:00',3.33),('8975','2013-10-09','09:10:00',2.73),('8975','2013-10-09','09:15:00',3.33),('8975','2013-10-09','09:20:00',3.37),('8975','2013-10-09','09:25:00',3.44),('8975','2013-10-09','09:30:00',3.49),('8975','2013-10-09','09:35:00',3.7),('8975','2013-10-09','09:40:00',1.37),('8975','2013-10-09','09:50:00',1.04),('8975','2013-10-09','10:05:00',1.34),('8975','2013-10-09','10:10:00',4.08),('8975','2013-10-09','10:15:00',4.27),('8975','2013-10-09','10:20:00',1.82),('8975','2013-10-09','10:35:00',1.9),('8975','2013-10-09','10:40:00',1.84),('8975','2013-10-09','10:45:00',3.13),('8975','2013-10-09','10:50:00',1.02),('8975','2013-10-09','10:55:00',1.38),('8975','2013-10-09','11:00:00',1.91),('8975','2013-10-09','11:05:00',4.84),('8975','2013-10-09','11:10:00',3.14),('8975','2013-10-09','11:15:00',5.18),('8975','2013-10-09','11:20:00',4.19),('8975','2013-10-09','11:25:00',1.8),('8975','2013-10-09','11:30:00',1.66),('8975','2013-10-09','11:35:00',4.83),('8975','2013-10-09','11:40:00',2.55),('8975','2013-10-09','11:45:00',4.07),('8975','2013-10-09','11:50:00',2.06),('8975','2013-10-09','12:00:00',1.32),('8975','2013-10-09','12:05:00',4.12),('8975','2013-10-09','12:15:00',2.93),('8975','2013-10-09','12:20:00',5.7),('8975','2013-10-09','12:25:00',3.84),('8975','2013-10-09','12:30:00',5.07),('8975','2013-10-09','12:35:00',5.64),('8975','2013-10-09','12:40:00',5.27),('8975','2013-10-09','12:45:00',1.97),('8975','2013-10-09','12:50:00',4.74),('8975','2013-10-09','12:55:00',2.37),('8975','2013-10-09','13:00:00',4.5),('8975','2013-10-09','13:05:00',3.03),('8975','2013-10-09','13:10:00',2.98),('8975','2013-10-09','13:15:00',4.35),('8975','2013-10-09','13:20:00',4.69),('8975','2013-10-09','13:25:00',3.81),('8975','2013-10-09','13:30:00',1.8),('8975','2013-10-09','13:35:00',3.29),('8975','2013-10-09','13:40:00',5.26),('8975','2013-10-09','13:45:00',4.43),('8975','2013-10-09','13:50:00',4.35),('8975','2013-10-09','13:55:00',4),('8975','2013-10-09','14:00:00',4.24),('8975','2013-10-09','14:05:00',3.67),('8975','2013-10-09','14:10:00',3.52),('8975','2013-10-09','14:15:00',4.37),('8975','2013-10-09','14:20:00',3.75),('8975','2013-10-09','14:25:00',4.51),('8975','2013-10-09','14:30:00',4.11),('8975','2013-10-09','14:35:00',4.12),('8975','2013-10-09','14:40:00',3.32),('8975','2013-10-09','14:45:00',3.58),('8975','2013-10-09','14:50:00',3.35),('8975','2013-10-09','14:55:00',2.92),('8975','2013-10-09','15:00:00',2.27),('8975','2013-10-09','15:05:00',2.75),('8975','2013-10-09','15:10:00',2.38),('8975','2013-10-09','15:15:00',1.92),('8975','2013-10-09','15:20:00',1.58),('8975','2013-10-09','15:25:00',1.99),('8975','2013-10-09','15:30:00',2.17),('8975','2013-10-09','15:35:00',1.8),('8975','2013-10-09','15:40:00',1.62),('8975','2013-10-09','15:45:00',1.22),('8975','2013-10-09','15:50:00',1.21),('8975','2013-10-09','15:55:00',1.58),('8975','2013-10-09','16:00:00',1.45),('8975','2013-10-09','16:05:00',1.27),('8975','2013-10-09','16:10:00',1.58),('8975','2013-10-09','16:15:00',1.5),('8975','2013-10-09','16:20:00',1.27),('8975','2013-10-09','16:25:00',1.29),('8975','2013-10-09','16:40:00',1.5),('8975','2013-10-09','16:45:00',1.4),('8975','2013-10-09','16:50:00',1.28),('8975','2013-10-09','16:55:00',1.26),('8975','2013-10-09','17:20:00',1.07),('8975','2013-10-08','08:00:00',1.31),('8975','2013-10-08','08:05:00',1.06),('8975','2013-10-08','08:10:00',1.17),('8975','2013-10-08','08:25:00',1.71),('8975','2013-10-08','08:30:00',2.52),('8975','2013-10-08','08:35:00',2.69),('8975','2013-10-08','08:40:00',2.44),('8975','2013-10-08','08:45:00',2.85),('8975','2013-10-08','08:50:00',2.95),('8975','2013-10-08','08:55:00',2.99),('8975','2013-10-08','09:00:00',3.11),('8975','2013-10-08','09:05:00',3.22),('8975','2013-10-08','09:10:00',3.32),('8975','2013-10-08','09:15:00',2.89),('8975','2013-10-08','09:20:00',3.2),('8975','2013-10-08','09:25:00',3.55),('8975','2013-10-08','09:30:00',3.6),('8975','2013-10-08','09:35:00',3.65),('8975','2013-10-08','09:40:00',3.75),('8975','2013-10-08','09:45:00',3.86),('8975','2013-10-08','09:50:00',4.03),('8975','2013-10-08','09:55:00',4.16),('8975','2013-10-08','10:00:00',4.41),('8975','2013-10-08','10:05:00',4.85),('8975','2013-10-08','10:10:00',5.46),('8975','2013-10-08','10:15:00',4.06),('8975','2013-10-08','10:20:00',2.55),('8975','2013-10-08','10:25:00',3.93),('8975','2013-10-08','10:30:00',4.01),('8975','2013-10-08','10:35:00',2.4),('8975','2013-10-08','10:40:00',3.83),('8975','2013-10-08','10:45:00',3.6),('8975','2013-10-08','10:50:00',4.51),('8975','2013-10-08','10:55:00',4.28),('8975','2013-10-08','11:00:00',2.83),('8975','2013-10-08','11:05:00',4.92),('8975','2013-10-08','11:10:00',5.6),('8975','2013-10-08','11:15:00',5.51),('8975','2013-10-08','11:20:00',4.67),('8975','2013-10-08','11:25:00',5.4),('8975','2013-10-08','11:30:00',5.18),('8975','2013-10-08','11:35:00',5.9),('8975','2013-10-08','11:40:00',4.32),('8975','2013-10-08','11:45:00',3.84),('8975','2013-10-08','11:50:00',4.15),('8975','2013-10-08','11:55:00',4.81),('8975','2013-10-08','12:00:00',3.02),('8975','2013-10-08','12:05:00',5.13),('8975','2013-10-08','12:10:00',3.15),('8975','2013-10-08','12:15:00',2.46),('8975','2013-10-08','12:20:00',6.11),('8975','2013-10-08','12:25:00',6.5),('8975','2013-10-08','12:30:00',4.69),('8975','2013-10-08','12:35:00',3.1),('8975','2013-10-08','12:40:00',2.17),('8975','2013-10-08','12:45:00',1.7),('8975','2013-10-08','12:50:00',1.87),('8975','2013-10-08','12:55:00',2.21),('8975','2013-10-08','13:00:00',1.94),('8975','2013-10-08','13:05:00',1.77),('8975','2013-10-08','13:10:00',2.32),('8975','2013-10-08','13:15:00',4.01),('8975','2013-10-08','13:20:00',6.04),('8975','2013-10-08','13:25:00',4.23),('8975','2013-10-08','13:30:00',2.5),('8975','2013-10-08','13:35:00',4.06),('8975','2013-10-08','13:40:00',2.23),('8975','2013-10-08','13:45:00',2.81),('8975','2013-10-08','13:50:00',3.13),('8975','2013-10-08','13:55:00',2.33),('8975','2013-10-08','14:00:00',1.51),('8975','2013-10-08','14:05:00',2.24),('8975','2013-10-08','14:10:00',1.29),('8975','2013-10-08','14:15:00',1.05),('8975','2013-10-08','14:20:00',1.11),('8975','2013-10-08','14:25:00',1.17),('8975','2013-10-08','14:30:00',1.03),('8975','2013-10-08','14:50:00',1.29),('8975','2013-10-08','14:55:00',2.19),('8975','2013-10-08','15:00:00',4.04),('8975','2013-10-08','15:05:00',3.44),('8975','2013-10-08','15:10:00',3.14),('8975','2013-10-08','15:15:00',3.04),('8975','2013-10-08','15:20:00',2.8),('8975','2013-10-08','15:25:00',2.83),('8975','2013-10-08','15:30:00',2.23),('8975','2013-10-08','15:35:00',3.02),('8975','2013-10-08','15:40:00',2.25),('8975','2013-10-08','16:05:00',1.57),('8975','2013-10-08','16:10:00',1.34),('8975','2013-10-08','16:15:00',1.66),('8975','2013-10-08','16:20:00',2.1),('8975','2013-10-08','16:25:00',2.22),('8975','2013-10-08','16:30:00',1.54),('8975','2013-10-08','16:35:00',1.73),('8975','2013-10-08','16:40:00',1.17),('8975','2013-10-08','17:25:00',1.1),('8975','2013-10-08','17:30:00',1.44),('8975','2013-10-08','17:35:00',1.15),('8975','2013-10-08','17:40:00',1.17),('8975','2013-10-08','17:45:00',1.07),('8975','2014-04-14','08:00:00',1.27),('8975','2014-04-14','08:05:00',1.94),('8975','2014-04-14','08:50:00',1.3),('8975','2014-04-14','08:55:00',1.94),('8975','2014-04-14','09:00:00',3.25),('8975','2014-04-14','09:05:00',3.73),('8975','2014-04-14','09:10:00',4.16),('8975','2014-04-14','09:15:00',4.06),('8975','2014-04-14','09:20:00',4.17),('8975','2014-04-14','09:25:00',4.02),('8975','2014-04-14','09:30:00',1.46),('8975','2014-04-14','09:35:00',2.1),('8975','2014-04-14','09:40:00',1.81),('8975','2014-04-14','09:45:00',2.33),('8975','2014-04-14','09:50:00',3.04),('8975','2014-04-14','09:55:00',2.61),('8975','2014-04-14','10:00:00',2.82),('8975','2014-04-14','10:05:00',4.59),('8975','2014-04-14','10:10:00',2.91),('8975','2014-04-14','10:15:00',3.28),('8975','2014-04-14','10:20:00',3.69),('8975','2014-04-14','10:25:00',5.88),('8975','2014-04-14','10:30:00',5.48),('8975','2014-04-14','10:35:00',4.72),('8975','2014-04-14','10:40:00',6.57),('8975','2014-04-14','10:45:00',5.15),('8975','2014-04-14','10:50:00',2.68),('8975','2014-04-14','10:55:00',4.34),('8975','2014-04-14','11:00:00',7.35),('8975','2014-04-14','11:05:00',7.54),('8975','2014-04-14','11:10:00',5.41),('8975','2014-04-14','11:15:00',3.09),('8975','2014-04-14','11:20:00',5.91),('8975','2014-04-14','11:25:00',2.56),('8975','2014-04-14','11:30:00',1.78),('8975','2014-04-14','11:35:00',1.25),('8975','2014-04-14','11:40:00',2.09),('8975','2014-04-14','11:45:00',2.49),('8975','2014-04-14','11:50:00',2.13),('8975','2014-04-14','11:55:00',1.53),('8975','2014-04-14','12:00:00',1),('8975','2014-04-14','12:05:00',1.2),('8975','2014-04-14','12:10:00',1.36),('8975','2014-04-14','12:15:00',1.82),('8975','2014-04-14','12:20:00',1.74),('8975','2014-04-14','12:35:00',1.09),('8975','2014-04-14','13:00:00',1.38),('8975','2014-04-14','13:05:00',2.13),('8975','2014-04-14','13:10:00',2.61),('8975','2014-04-14','13:15:00',3.56),('8975','2014-04-14','13:20:00',2.94),('8975','2014-04-14','13:25:00',3.97),('8975','2014-04-14','13:30:00',2.35),('8975','2014-04-14','13:35:00',3.27),('8975','2014-04-14','13:40:00',3.01),('8975','2014-04-14','13:45:00',3.22),('8975','2014-04-14','13:50:00',4.26),('8975','2014-04-14','13:55:00',4.77),('8975','2014-04-14','14:00:00',3),('8975','2014-04-14','14:05:00',3.36),('8975','2014-04-14','14:10:00',4.61),('8975','2014-04-14','14:15:00',3.88),('8975','2014-04-14','14:20:00',4.59),('8975','2014-04-14','14:25:00',2.45),('8975','2014-04-14','14:30:00',2.34),('8975','2014-04-14','14:35:00',1.96),('8975','2014-04-14','14:40:00',1.62),('8975','2014-04-14','14:45:00',1.29),('8975','2014-04-14','15:10:00',1.12),('8975','2014-04-14','15:15:00',1.82),('8975','2014-04-14','15:20:00',2.45),('8975','2014-04-14','15:25:00',1.53),('8975','2014-04-14','15:30:00',1.44),('8975','2014-04-14','15:35:00',1.65),('8975','2014-04-14','15:40:00',1.97),('8975','2014-04-14','15:45:00',1.75),('8975','2014-04-14','15:50:00',1.84),('8975','2014-04-14','15:55:00',2.35),('8975','2014-04-14','16:00:00',2.46),('8975','2014-04-14','16:05:00',2.02),('8975','2014-04-14','16:10:00',1.55),('8975','2014-04-14','16:15:00',1.26),('8975','2013-10-07','07:50:00',1.15),('8975','2013-10-07','07:55:00',1.21),('8975','2013-10-07','08:00:00',1.58),('8975','2013-10-07','08:05:00',2.11),('8975','2013-10-07','08:10:00',2.42),('8975','2013-10-07','08:15:00',2.77),('8975','2013-10-07','08:20:00',1.87),('8975','2013-10-07','08:25:00',1.24),('8975','2013-10-07','08:30:00',1.27),('8975','2013-10-07','09:55:00',1.12),('8975','2013-10-07','10:00:00',1.47),('8975','2013-10-07','10:05:00',1.53),('8975','2013-10-07','10:10:00',1.56),('8975','2013-10-07','10:15:00',1.09),('8975','2013-10-07','10:55:00',1.73),('8975','2013-10-07','11:00:00',2.23),('8975','2013-10-07','11:05:00',2.3),('8975','2013-10-07','11:10:00',4.78),('8975','2013-10-07','11:15:00',6.62),('8975','2013-10-07','11:20:00',4.11),('8975','2013-10-07','11:25:00',3.48),('8975','2013-10-07','11:30:00',4.88),('8975','2013-10-07','11:35:00',2.86),('8975','2013-10-07','11:40:00',2.62),('8975','2013-10-07','11:45:00',1.99),('8975','2013-10-07','11:50:00',1.65),('8975','2013-10-07','11:55:00',1.34),('8975','2013-10-07','12:00:00',1.2),('8975','2013-10-07','12:05:00',1.57),('8975','2013-10-07','12:10:00',1.51),('8975','2013-10-07','12:15:00',1.74),('8975','2013-10-07','12:20:00',1.64),('8975','2013-10-07','12:25:00',2.8),('8975','2013-10-07','12:30:00',2.92),('8975','2013-10-07','12:35:00',4.09),('8975','2013-10-07','12:40:00',4.02),('8975','2013-10-07','12:45:00',3.57),('8975','2013-10-07','12:50:00',6.02),('8975','2013-10-07','12:55:00',2.82),('8975','2013-10-07','13:00:00',4.16),('8975','2013-10-07','13:05:00',3.87),('8975','2013-10-07','13:10:00',2.85),('8975','2013-10-07','13:15:00',2.57),('8975','2013-10-07','13:20:00',4.85),('8975','2013-10-07','13:25:00',4.58),('8975','2013-10-07','13:30:00',2.03),('8975','2013-10-07','13:35:00',1.87),('8975','2013-10-07','13:40:00',1.73),('8975','2013-10-07','13:45:00',1.29),('8975','2013-10-07','13:50:00',1.34),('8975','2013-10-07','13:55:00',1.51),('8975','2013-10-07','14:00:00',1.4),('8975','2013-10-07','14:05:00',3.1),('8975','2013-10-07','14:10:00',3.16),('8975','2013-10-07','14:15:00',3.39),('8975','2013-10-07','14:20:00',3.06),('8975','2013-10-07','14:25:00',3.98),('8975','2013-10-07','14:30:00',2.52),('8975','2013-10-07','14:35:00',1.62),('8975','2013-10-07','14:40:00',2.25),('8975','2013-10-07','14:45:00',3.99),('8975','2013-10-07','14:50:00',3.59),('8975','2013-10-07','14:55:00',3.2),('8975','2013-10-07','15:00:00',3.18),('8975','2013-10-07','15:05:00',3.07),('8975','2013-10-07','15:10:00',2.8),('8975','2013-10-07','15:15:00',2.8),('8975','2013-10-07','15:20:00',2.95),('8975','2013-10-07','15:25:00',3.08),('8975','2013-10-07','15:30:00',3.11),('8975','2013-10-07','15:35:00',2.79),('8975','2013-10-07','15:40:00',2.54),('8975','2013-10-07','15:45:00',2.28),('8975','2013-10-07','15:50:00',2.46),('8975','2013-10-07','15:55:00',1.3),('8975','2013-10-07','16:00:00',1.56),('8975','2013-10-07','16:10:00',1.25),('8975','2013-10-07','16:30:00',1.15),('8975','2013-10-07','16:35:00',1.04),('8975','2013-10-07','16:40:00',1.05),('8975','2013-10-07','16:45:00',1.07),('8975','2013-10-06','07:45:00',1.02),('8975','2013-10-06','07:50:00',1.36),('8975','2013-10-06','07:55:00',1.66),('8975','2013-10-06','08:00:00',1.84),('8975','2013-10-06','08:05:00',1.98),('8975','2013-10-06','08:10:00',2.07),('8975','2013-10-06','08:15:00',2.02),('8975','2013-10-06','08:20:00',2.04),('8975','2013-10-06','08:25:00',1.46),('8975','2013-10-06','08:30:00',2.29),('8975','2013-10-06','08:35:00',3.36),('8975','2013-10-06','08:40:00',1.86),('8975','2013-10-06','08:45:00',2.14),('8975','2013-10-06','08:50:00',2.16),('8975','2013-10-06','08:55:00',2.95),('8975','2013-10-06','09:00:00',3.35),('8975','2013-10-06','09:05:00',3.28),('8975','2013-10-06','09:10:00',3.31),('8975','2013-10-06','09:15:00',3.29),('8975','2013-10-06','09:20:00',3.48),('8975','2013-10-06','09:25:00',3.56),('8975','2013-10-06','09:30:00',3.65),('8975','2013-10-06','09:35:00',3.7),('8975','2013-10-06','09:40:00',3.75),('8975','2013-10-06','09:45:00',3.85),('8975','2013-10-06','09:50:00',3.88),('8975','2013-10-06','09:55:00',4.01),('8975','2013-10-06','10:00:00',4.06),('8975','2013-10-06','10:05:00',4.17),('8975','2013-10-06','10:10:00',4.19),('8975','2013-10-06','10:15:00',4.29),('8975','2013-10-06','10:20:00',4.39),('8975','2013-10-06','10:25:00',4.35),('8975','2013-10-06','10:30:00',4.71),('8975','2013-10-06','10:35:00',4.52),('8975','2013-10-06','10:40:00',4.64),('8975','2013-10-06','10:45:00',4.75),('8975','2013-10-06','10:50:00',4.53),('8975','2013-10-06','10:55:00',3.87),('8975','2013-10-06','11:00:00',5.22),('8975','2013-10-06','11:05:00',4.08),('8975','2013-10-06','11:10:00',4.76),('8975','2013-10-06','11:15:00',5.38),('8975','2013-10-06','11:20:00',5.01),('8975','2013-10-06','11:25:00',4.9),('8975','2013-10-06','11:30:00',4.95),('8975','2013-10-06','11:35:00',4.99),('8975','2013-10-06','11:40:00',5.02),('8975','2013-10-06','11:45:00',5.04),('8975','2013-10-06','11:50:00',5.04),('8975','2013-10-06','11:55:00',5.04),('8975','2013-10-06','12:00:00',5.27),('8975','2013-10-06','12:05:00',5),('8975','2013-10-06','12:10:00',2.15),('8975','2013-10-06','12:15:00',5.91),('8975','2013-10-06','12:20:00',5.58),('8975','2013-10-06','12:25:00',5.49),('8975','2013-10-06','12:30:00',5.22),('8975','2013-10-06','12:35:00',5.14),('8975','2013-10-06','12:40:00',4.93),('8975','2013-10-06','12:45:00',5.2),('8975','2013-10-06','12:50:00',5.23),('8975','2013-10-06','12:55:00',5.12),('8975','2013-10-06','13:00:00',5.25),('8975','2013-10-06','13:05:00',5.19),('8975','2013-10-06','13:10:00',5.06),('8975','2013-10-06','13:15:00',2.97),('8975','2013-10-06','13:20:00',3.3),('8975','2013-10-06','13:25:00',5.41),('8975','2013-10-06','13:30:00',4.2),('8975','2013-10-06','13:35:00',3.21),('8975','2013-10-06','13:40:00',1.78),('8975','2013-10-06','13:45:00',3.2),('8975','2013-10-06','13:50:00',2.05),('8975','2013-10-06','13:55:00',2.5),('8975','2013-10-06','14:00:00',1.34),('8975','2013-10-06','14:05:00',2.99),('8975','2013-10-06','14:10:00',3.17),('8975','2013-10-06','14:15:00',1.17),('8975','2013-10-06','14:20:00',2.14),('8975','2013-10-06','14:25:00',2.95),('8975','2013-10-06','14:30:00',2.01),('8975','2013-10-06','14:35:00',3.92),('8975','2013-10-06','14:40:00',4.26),('8975','2013-10-06','14:45:00',4.05),('8975','2013-10-06','14:50:00',2.76),('8975','2013-10-06','14:55:00',3.39),('8975','2013-10-06','15:00:00',3.54),('8975','2013-10-06','15:05:00',2.1),('8975','2013-10-06','15:10:00',3.24),('8975','2013-10-06','15:20:00',1.25),('8975','2013-10-06','15:25:00',3.38),('8975','2013-10-06','15:30:00',3.49),('8975','2013-10-06','15:35:00',2.14),('8975','2013-10-06','15:40:00',3.05),('8975','2013-10-06','15:45:00',3.02),('8975','2013-10-06','15:50:00',2.55),('8975','2013-10-06','15:55:00',1.39),('8975','2013-10-06','16:00:00',1.77),('8975','2013-10-06','16:05:00',1.73),('8975','2013-10-06','16:10:00',1.79),('8975','2013-10-06','16:15:00',1.89),('8975','2013-10-06','16:20:00',1.27),('8975','2013-10-06','16:25:00',1.64),('8975','2013-10-06','16:30:00',1.77),('8975','2013-10-06','16:35:00',1.85),('8975','2013-10-06','16:40:00',1.47),('8975','2013-10-06','16:45:00',1.67),('8975','2013-10-06','16:50:00',1.66),('8975','2013-10-06','16:55:00',1.54),('8975','2013-10-06','17:00:00',1.47),('8975','2013-10-06','17:15:00',1.12),('8975','2013-10-06','17:25:00',1.17),('8975','2013-10-06','17:30:00',1.15),('8975','2013-10-05','09:00:00',1.03),('8975','2013-10-05','09:05:00',1.85),('8975','2013-10-05','09:25:00',1.07),('8975','2013-10-05','09:30:00',1.87),('8975','2013-10-05','09:35:00',2.28),('8975','2013-10-05','09:40:00',2.14),('8975','2013-10-05','09:45:00',1.87),('8975','2013-10-05','09:50:00',3.64),('8975','2013-10-05','09:55:00',3.96),('8975','2013-10-05','10:00:00',4.88),('8975','2013-10-05','10:05:00',5.01),('8975','2013-10-05','10:10:00',4.94),('8975','2013-10-05','10:15:00',4.37),('8975','2013-10-05','10:20:00',4.4),('8975','2013-10-05','10:25:00',4.95),('8975','2013-10-05','10:30:00',4.83),('8975','2013-10-05','10:35:00',4.63),('8975','2013-10-05','10:40:00',3.65),('8975','2013-10-05','10:45:00',3.35),('8975','2013-10-05','10:50:00',3.71),('8975','2013-10-05','10:55:00',3.93),('8975','2013-10-05','11:00:00',4.23),('8975','2013-10-05','11:05:00',4.28),('8975','2013-10-05','11:10:00',4.37),('8975','2013-10-05','11:15:00',3.53),('8975','2013-10-05','11:20:00',4.22),('8975','2013-10-05','11:25:00',4.33),('8975','2013-10-05','11:30:00',4.42),('8975','2013-10-05','11:35:00',3.93),('8975','2013-10-05','11:40:00',3.31),('8975','2013-10-05','11:45:00',3.05),('8975','2013-10-05','11:50:00',3.26),('8975','2013-10-05','11:55:00',3.99),('8975','2013-10-05','12:00:00',3.83),('8975','2013-10-05','12:05:00',4),('8975','2013-10-05','12:10:00',4.82),('8975','2013-10-05','12:15:00',4),('8975','2013-10-05','12:20:00',4.64),('8975','2013-10-05','12:25:00',3.94),('8975','2013-10-05','12:30:00',3.7),('8975','2013-10-05','12:35:00',3.58),('8975','2013-10-05','12:40:00',3.11),('8975','2013-10-05','12:45:00',3.57),('8975','2013-10-05','12:50:00',4.01),('8975','2013-10-05','12:55:00',4.51),('8975','2013-10-05','13:00:00',4.56),('8975','2013-10-05','13:05:00',4.52),('8975','2013-10-05','13:10:00',3.97),('8975','2013-10-05','13:15:00',4.54),('8975','2013-10-05','13:20:00',5.08),('8975','2013-10-05','13:25:00',1.72),('8975','2013-10-05','13:30:00',1.15),('8975','2013-10-05','13:35:00',1.15),('8975','2013-10-05','13:40:00',3.26),('8975','2013-10-05','13:45:00',4.62),('8975','2013-10-05','13:50:00',4.36),('8975','2013-10-05','13:55:00',4.15),('8975','2013-10-05','14:00:00',3.55),('8975','2013-10-05','14:05:00',3.3),('8975','2013-10-05','14:10:00',2.2),('8975','2013-10-05','14:15:00',1.86),('8975','2013-10-05','14:20:00',1.65),('8975','2013-10-05','14:25:00',1.98),('8975','2013-10-05','14:30:00',2.83),('8975','2013-10-05','14:35:00',2.71),('8975','2013-10-05','14:40:00',2.41),('8975','2013-10-05','14:45:00',3.01),('8975','2013-10-05','14:50:00',2.78),('8975','2013-10-05','14:55:00',2.58),('8975','2013-10-05','15:00:00',2.12),('8975','2013-10-05','15:05:00',2.1),('8975','2013-10-05','15:10:00',1.78),('8975','2013-10-05','15:15:00',1.64),('8975','2013-10-05','15:20:00',1.42),('8975','2013-10-05','15:25:00',1.2),('8975','2013-10-05','15:30:00',1.21),('8975','2013-10-05','15:35:00',1.25),('8975','2013-10-05','15:40:00',1.3),('8975','2013-10-05','15:45:00',1.41),('8975','2013-10-05','15:50:00',1.46),('8975','2013-10-05','15:55:00',1.4),('8975','2013-10-05','16:00:00',1.37),('8975','2013-10-05','16:05:00',1.09),('8975','2013-10-05','17:00:00',1.03),('8975','2013-10-05','17:05:00',1.1),('8975','2013-10-05','17:10:00',1.03),('8975','2013-10-04','15:35:00',1.03),('8975','2013-10-04','15:40:00',1.21),('8975','2013-10-04','15:45:00',1.28),('8975','2013-10-04','15:50:00',1.32),('8975','2013-10-04','15:55:00',1.39),('8975','2013-10-04','16:00:00',1.53),('8975','2013-10-04','16:05:00',1.76),('8975','2013-10-04','16:10:00',1.7),('8975','2013-10-04','16:15:00',1.61),('8975','2013-10-04','16:20:00',1.54),('8975','2013-10-04','16:25:00',1.47),('8975','2013-10-04','16:30:00',1.41),('8975','2013-10-04','16:35:00',1.32),('8975','2013-10-04','16:40:00',1.41),('8975','2013-10-04','16:45:00',1.36),('8975','2013-10-04','16:50:00',1.16),('8975','2013-10-04','16:55:00',1.18),('8975','2013-10-04','17:00:00',1.22),('8975','2013-10-04','17:05:00',1.09),('8975','2013-10-03','07:40:00',1),('8975','2013-10-03','07:45:00',1.1),('8975','2013-10-03','08:15:00',1.02),('8975','2013-10-03','08:30:00',1.01),('8975','2013-10-03','08:35:00',1.12),('8975','2013-10-03','08:40:00',1.38),('8975','2013-10-03','08:45:00',2.16),('8975','2013-10-03','08:50:00',1.22),('8975','2013-10-03','08:55:00',1.12),('8975','2013-10-03','09:00:00',1.2),('8975','2013-10-03','09:05:00',1.01),('8975','2013-10-03','09:10:00',1.38),('8975','2013-10-03','09:15:00',1.18),('8975','2013-10-03','09:20:00',1.27),('8975','2013-10-03','09:25:00',1.83),('8975','2013-10-03','09:30:00',2.07),('8975','2013-10-03','09:35:00',2.17),('8975','2013-10-03','09:40:00',2.08),('8975','2013-10-03','09:45:00',2.02),('8975','2013-10-03','09:50:00',2.32),('8975','2013-10-03','09:55:00',3.56),('8975','2013-10-03','10:00:00',3.45),('8975','2013-10-03','10:05:00',2.42),('8975','2013-10-03','10:10:00',2.36),('8975','2013-10-03','10:15:00',2.67),('8975','2013-10-03','10:20:00',2.63),('8975','2013-10-03','10:25:00',3.31),('8975','2013-10-03','10:30:00',3.6),('8975','2013-10-03','10:35:00',3.75),('8975','2013-10-03','10:40:00',3.85),('8975','2013-10-03','10:45:00',5.22),('8975','2013-10-03','10:50:00',3.89),('8975','2013-10-03','10:55:00',2.7),('8975','2013-10-03','11:00:00',3.74),('8975','2013-10-03','11:05:00',3.03),('8975','2013-10-03','11:10:00',2.5),('8975','2013-10-03','11:15:00',4.75),('8975','2013-10-03','11:20:00',4.62),('8975','2013-10-03','11:25:00',4.01),('8975','2013-10-03','11:30:00',5.58),('8975','2013-10-03','11:35:00',4.53),('8975','2013-10-03','11:40:00',4.29),('8975','2013-10-03','11:45:00',5.13),('8975','2013-10-03','11:50:00',5.44),('8975','2013-10-03','11:55:00',5.35),('8975','2013-10-03','12:00:00',5.32),('8975','2013-10-03','12:05:00',5.35),('8975','2013-10-03','12:10:00',5.32),('8975','2013-10-03','12:15:00',4.56),('8975','2013-10-03','12:20:00',4.41),('8975','2013-10-03','12:25:00',5.27),('8975','2013-10-03','12:30:00',5.5),('8975','2013-10-03','12:35:00',5.31),('8975','2013-10-03','12:40:00',5.13),('8975','2013-10-03','12:45:00',5.1),('8975','2013-10-03','12:50:00',5.02),('8975','2013-10-03','12:55:00',4.83),('8975','2013-10-03','13:00:00',4.93),('8975','2013-10-03','13:05:00',4.98),('8975','2013-10-03','13:10:00',4.92),('8975','2013-10-03','13:15:00',5.13),('8975','2013-10-03','13:20:00',4.93),('8975','2013-10-03','13:25:00',4.63),('8975','2013-10-03','13:30:00',4.87),('8975','2013-10-03','13:35:00',4.93),('8975','2013-10-03','13:40:00',4.59),('8975','2013-10-03','13:45:00',4.23),('8975','2013-10-03','13:50:00',4.36),('8975','2013-10-03','13:55:00',4.06),('8975','2013-10-03','14:00:00',4.15),('8975','2013-10-03','14:05:00',4.11),('8975','2013-10-03','14:10:00',3.65),('8975','2013-10-03','14:15:00',3.32),('8975','2013-10-03','14:20:00',3.74),('8975','2013-10-03','14:25:00',3.74),('8975','2013-10-03','14:30:00',3.28),('8975','2013-10-03','14:35:00',2.5),('8975','2013-10-03','14:40:00',2.1),('8975','2013-10-03','14:45:00',2.5),('8975','2013-10-03','14:50:00',3),('8975','2013-10-03','14:55:00',3.13),('8975','2013-10-03','15:00:00',2.4),('8975','2013-10-03','15:05:00',2.79),('8975','2013-10-03','15:10:00',2.26),('8975','2013-10-03','15:15:00',2.22),('8975','2013-10-03','15:20:00',1.71),('8975','2013-10-03','15:25:00',2.45),('8975','2013-10-03','15:30:00',1.74),('8975','2013-10-03','15:35:00',1.44),('8975','2013-10-03','15:40:00',1.17),('8975','2013-10-03','15:45:00',1.03),('8975','2013-10-03','15:50:00',1.09),('8975','2013-10-03','15:55:00',1.23),('8975','2013-10-03','16:00:00',1.51),('8975','2013-10-03','16:05:00',1.68),('8975','2013-10-03','16:10:00',1.44),('8975','2013-10-03','16:15:00',1.25),('8975','2013-10-03','16:20:00',1.02),('8975','2013-10-02','07:40:00',1.15),('8975','2013-10-02','07:45:00',1.37),('8975','2013-10-02','07:50:00',1.57),('8975','2013-10-02','07:55:00',1.72),('8975','2013-10-02','08:00:00',1.96),('8975','2013-10-02','08:05:00',2.11),('8975','2013-10-02','08:10:00',2.29),('8975','2013-10-02','08:15:00',2.47),('8975','2013-10-02','08:20:00',2.61),('8975','2013-10-02','08:25:00',2.75),('8975','2013-10-02','08:30:00',2.85),('8975','2013-10-02','08:35:00',2.95),('8975','2013-10-02','08:40:00',3.07),('8975','2013-10-02','08:45:00',3.18),('8975','2013-10-02','08:50:00',3.27),('8975','2013-10-02','08:55:00',3.36),('8975','2013-10-02','09:00:00',3.46),('8975','2013-10-02','09:05:00',3.55),('8975','2013-10-02','09:10:00',3.65),('8975','2013-10-02','09:15:00',3.76),('8975','2013-10-02','09:20:00',3.83),('8975','2013-10-02','09:25:00',3.93),('8975','2013-10-02','09:30:00',4.04),('8975','2013-10-02','09:35:00',4.13),('8975','2013-10-02','09:40:00',4.19),('8975','2013-10-02','09:45:00',4.28),('8975','2013-10-02','09:50:00',4.39),('8975','2013-10-02','09:55:00',4.47),('8975','2013-10-02','10:00:00',4.56),('8975','2013-10-02','10:05:00',4.64),('8975','2013-10-02','10:10:00',4.69),('8975','2013-10-02','10:15:00',4.78),('8975','2013-10-02','10:20:00',4.87),('8975','2013-10-02','10:25:00',4.94),('8975','2013-10-02','10:30:00',5),('8975','2013-10-02','10:35:00',5.02),('8975','2013-10-02','10:40:00',4.98),('8975','2013-10-02','10:45:00',5.11),('8975','2013-10-02','10:50:00',5.21),('8975','2013-10-02','10:55:00',5.26),('8975','2013-10-02','11:00:00',5.32),('8975','2013-10-02','11:05:00',5.37),('8975','2013-10-02','11:10:00',5.41),('8975','2013-10-02','11:15:00',5.44),('8975','2013-10-02','11:20:00',5.5),('8975','2013-10-02','11:25:00',5.53),('8975','2013-10-02','11:30:00',5.53),('8975','2013-10-02','11:35:00',5.52),('8975','2013-10-02','11:40:00',5.47),('8975','2013-10-02','11:45:00',5.41),('8975','2013-10-02','11:50:00',5.51),('8975','2013-10-02','11:55:00',5.54),('8975','2013-10-02','12:00:00',5.56),('8975','2013-10-02','12:05:00',5.58),('8975','2013-10-02','12:10:00',5.58),('8975','2013-10-02','12:15:00',5.52),('8975','2013-10-02','12:20:00',5.48),('8975','2013-10-02','12:25:00',5.43),('8975','2013-10-02','12:30:00',5.44),('8975','2013-10-02','12:35:00',5.41),('8975','2013-10-02','12:40:00',5.38),('8975','2013-10-02','12:45:00',5.35),('8975','2013-10-02','12:50:00',5.32),('8975','2013-10-02','12:55:00',5.27),('8975','2013-10-02','13:00:00',5.22),('8975','2013-10-02','13:05:00',5.13),('8975','2013-10-02','13:10:00',5.11),('8975','2013-10-02','13:15:00',5.09),('8975','2013-10-02','13:20:00',5.05),('8975','2013-10-02','13:25:00',4.99),('8975','2013-10-02','13:30:00',4.95),('8975','2013-10-02','13:35:00',4.9),('8975','2013-10-02','13:40:00',4.85),('8975','2013-10-02','13:45:00',4.68),('8975','2013-10-02','13:50:00',4.62),('8975','2013-10-02','13:55:00',4.42),('8975','2013-10-02','14:00:00',4.3),('8975','2013-10-02','14:05:00',4.41),('8975','2013-10-02','14:10:00',4.31),('8975','2013-10-02','14:15:00',4.22),('8975','2013-10-02','14:20:00',4.16),('8975','2013-10-02','14:25:00',4.08),('8975','2013-10-02','14:30:00',3.98),('8975','2013-10-02','14:35:00',3.83),('8975','2013-10-02','14:40:00',3.55),('8975','2013-10-02','14:45:00',3.58),('8975','2013-10-02','14:50:00',3.53),('8975','2013-10-02','14:55:00',3.36),('8975','2013-10-02','15:00:00',3.36),('8975','2013-10-02','15:05:00',3.25),('8975','2013-10-02','15:10:00',3.12),('8975','2013-10-02','15:15:00',2.97),('8975','2013-10-02','15:20:00',2.88),('8975','2013-10-02','15:25:00',2.83),('8975','2013-10-02','15:30:00',2.75),('8975','2013-10-02','15:35:00',2.65),('8975','2013-10-02','15:40:00',2.53),('8975','2013-10-02','15:45:00',2.43),('8975','2013-10-02','15:50:00',2.33),('8975','2013-10-02','15:55:00',2.24),('8975','2013-10-02','16:00:00',2.12),('8975','2013-10-02','16:05:00',2.02),('8975','2013-10-02','16:10:00',1.93),('8975','2013-10-02','16:15:00',1.82),('8975','2013-10-02','16:20:00',1.75),('8975','2013-10-02','16:25:00',1.66),('8975','2013-10-02','16:30:00',1.58),('8975','2013-10-02','16:35:00',1.53),('8975','2013-10-02','16:40:00',1.49),('8975','2013-10-02','16:45:00',1.43),('8975','2013-10-02','16:50:00',1.38),('8975','2013-10-02','16:55:00',1.35),('8975','2013-10-02','17:00:00',1.31),('8975','2013-10-02','17:05:00',1.26),('8975','2013-10-02','17:10:00',1.23),('8975','2013-10-02','17:15:00',1.16),('8975','2013-10-02','17:20:00',1.13),('8975','2013-10-02','17:25:00',1.08),('8975','2013-10-02','17:30:00',1.03),('8975','2013-10-01','07:50:00',1.17),('8975','2013-10-01','07:55:00',1.25),('8975','2013-10-01','08:00:00',1.04),('8975','2013-10-01','08:10:00',1.42),('8975','2013-10-01','08:15:00',1.19),('8975','2013-10-01','08:20:00',2.22),('8975','2013-10-01','08:25:00',2.63),('8975','2013-10-01','08:30:00',2.66),('8975','2013-10-01','08:35:00',2.68),('8975','2013-10-01','08:40:00',2.85),('8975','2013-10-01','08:45:00',2.96),('8975','2013-10-01','08:50:00',3.06),('8975','2013-10-01','08:55:00',3.17),('8975','2013-10-01','09:00:00',3.22),('8975','2013-10-01','09:05:00',3.34),('8975','2013-10-01','09:10:00',3.43),('8975','2013-10-01','09:15:00',3.51),('8975','2013-10-01','09:20:00',3.59),('8975','2013-10-01','09:25:00',3.67),('8975','2013-10-01','09:30:00',3.77),('8975','2013-10-01','09:35:00',3.87),('8975','2013-10-01','09:40:00',3.93),('8975','2013-10-01','09:45:00',4),('8975','2013-10-01','09:50:00',4.08),('8975','2013-10-01','09:55:00',4.16),('8975','2013-10-01','10:00:00',4.22),('8975','2013-10-01','10:05:00',4.31),('8975','2013-10-01','10:10:00',4.36),('8975','2013-10-01','10:15:00',4.41),('8975','2013-10-01','10:20:00',4.5),('8975','2013-10-01','10:25:00',4.55),('8975','2013-10-01','10:30:00',4.62),('8975','2013-10-01','10:35:00',4.71),('8975','2013-10-01','10:40:00',4.78),('8975','2013-10-01','10:45:00',4.87),('8975','2013-10-01','10:50:00',4.97),('8975','2013-10-01','10:55:00',5.02),('8975','2013-10-01','11:00:00',5.04),('8975','2013-10-01','11:05:00',5.12),('8975','2013-10-01','11:10:00',5.2),('8975','2013-10-01','11:15:00',5.23),('8975','2013-10-01','11:20:00',5.25),('8975','2013-10-01','11:25:00',5.29),('8975','2013-10-01','11:30:00',5.3),('8975','2013-10-01','11:35:00',5.34),('8975','2013-10-01','11:40:00',5.36),('8975','2013-10-01','11:45:00',5.37),('8975','2013-10-01','11:50:00',5.36),('8975','2013-10-01','11:55:00',5.37),('8975','2013-10-01','12:00:00',5.35),('8975','2013-10-01','12:05:00',5.36),('8975','2013-10-01','12:10:00',5.18),('8975','2013-10-01','12:15:00',5.29),('8975','2013-10-01','12:20:00',5.27),('8975','2013-10-01','12:25:00',5.16),('8975','2013-10-01','12:30:00',4.83),('8975','2013-10-01','12:35:00',4.61),('8975','2013-10-01','12:40:00',5.01),('8975','2013-10-01','12:45:00',5.14),('8975','2013-10-01','12:50:00',4.61),('8975','2013-10-01','12:55:00',4.72),('8975','2013-10-01','13:00:00',4.75),('8975','2013-10-01','13:05:00',4.39),('8975','2013-10-01','13:10:00',4.87),('8975','2013-10-01','13:15:00',4.97),('8975','2013-10-01','13:20:00',4.94),('8975','2013-10-01','13:25:00',4.91),('8975','2013-10-01','13:30:00',4.87),('8975','2013-10-01','13:35:00',4.82),('8975','2013-10-01','13:40:00',4.78),('8975','2013-10-01','13:45:00',4.65),('8975','2013-10-01','13:50:00',4.33),('8975','2013-10-01','13:55:00',4.22),('8975','2013-10-01','14:00:00',4.24),('8975','2013-10-01','14:05:00',4.33),('8975','2013-10-01','14:10:00',4.26),('8975','2013-10-01','14:15:00',4.19),('8975','2013-10-01','14:20:00',4.11),('8975','2013-10-01','14:25:00',4.03),('8975','2013-10-01','14:30:00',3.95),('8975','2013-10-01','14:35:00',3.86),('8975','2013-10-01','14:40:00',3.57),('8975','2013-10-01','14:45:00',3.58),('8975','2013-10-01','14:50:00',3.45),('8975','2013-10-01','14:55:00',3.39),('8975','2013-10-01','15:00:00',3.34),('8975','2013-10-01','15:05:00',3.23),('8975','2013-10-01','15:10:00',3.09),('8975','2013-10-01','15:15:00',2.93),('8975','2013-10-01','15:20:00',2.83),('8975','2013-10-01','15:25:00',2.77),('8975','2013-10-01','15:30:00',2.71),('8975','2013-10-01','15:35:00',2.61),('8975','2013-10-01','15:40:00',2.53),('8975','2013-10-01','15:45:00',2.42),('8975','2013-10-01','15:50:00',2.32),('8975','2013-10-01','15:55:00',2.23),('8975','2013-10-01','16:00:00',2.14),('8975','2013-10-01','16:05:00',2.05),('8975','2013-10-01','16:10:00',1.94),('8975','2013-10-01','16:15:00',1.83),('8975','2013-10-01','16:20:00',1.76),('8975','2013-10-01','16:25:00',1.67),('8975','2013-10-01','16:30:00',1.6),('8975','2013-10-01','16:35:00',1.53),('8975','2013-10-01','16:40:00',1.48),('8975','2013-10-01','16:45:00',1.43),('8975','2013-10-01','16:50:00',1.38),('8975','2013-10-01','16:55:00',1.33),('8975','2013-10-01','17:00:00',1.3),('8975','2013-10-01','17:05:00',1.26),('8975','2013-10-01','17:10:00',1.22),('8975','2013-10-01','17:15:00',1.16),('8975','2013-10-01','17:20:00',1.12),('8975','2013-10-01','17:25:00',1.08),('8975','2013-10-01','17:30:00',1.03),('8975','2013-09-30','08:05:00',1.34),('8975','2013-09-30','08:10:00',2.05),('8975','2013-09-30','08:15:00',2.3),('8975','2013-09-30','08:20:00',2.46),('8975','2013-09-30','08:25:00',2.56),('8975','2013-09-30','08:30:00',2.7),('8975','2013-09-30','08:35:00',2.82),('8975','2013-09-30','08:40:00',2.93),('8975','2013-09-30','08:45:00',3.03),('8975','2013-09-30','08:50:00',3.11),('8975','2013-09-30','08:55:00',3.19),('8975','2013-09-30','09:00:00',3.26),('8975','2013-09-30','09:05:00',3.34),('8975','2013-09-30','09:10:00',3.43),('8975','2013-09-30','09:15:00',3.5),('8975','2013-09-30','09:20:00',3.61),('8975','2013-09-30','09:25:00',3.67),('8975','2013-09-30','09:30:00',3.72),('8975','2013-09-30','09:35:00',3.83),('8975','2013-09-30','09:40:00',3.9),('8975','2013-09-30','09:45:00',3.96),('8975','2013-09-30','09:50:00',4.08),('8975','2013-09-30','09:55:00',4.14),('8975','2013-09-30','10:00:00',4.21),('8975','2013-09-30','10:05:00',4.27),('8975','2013-09-30','10:10:00',4.31),('8975','2013-09-30','10:15:00',4.31),('8975','2013-09-30','10:20:00',4.29),('8975','2013-09-30','10:25:00',4.46),('8975','2013-09-30','10:30:00',4.75),('8975','2013-09-30','10:35:00',4.68),('8975','2013-09-30','10:40:00',4.75),('8975','2013-09-30','10:45:00',4.83),('8975','2013-09-30','10:50:00',4.89),('8975','2013-09-30','10:55:00',4.87),('8975','2013-09-30','11:00:00',5.06),('8975','2013-09-30','11:05:00',3.63),('8975','2013-09-30','11:10:00',5.51),('8975','2013-09-30','11:15:00',5.89),('8975','2013-09-30','11:20:00',3.21),('8975','2013-09-30','11:25:00',1.22),('8975','2013-09-30','11:30:00',1.04),('8975','2013-09-30','11:35:00',1.05),('8975','2013-09-30','11:40:00',3.18),('8975','2013-09-30','11:45:00',5.63),('8975','2013-09-30','11:50:00',5.7),('8975','2013-09-30','11:55:00',5.69),('8975','2013-09-30','12:00:00',3.88),('8975','2013-09-30','12:05:00',2.03),('8975','2013-09-30','12:10:00',1.15),('8975','2013-09-30','12:15:00',5.38),('8975','2013-09-30','12:20:00',5.81),('8975','2013-09-30','12:25:00',5.64),('8975','2013-09-30','12:30:00',5.69),('8975','2013-09-30','12:35:00',5.85),('8975','2013-09-30','12:40:00',5.97),('8975','2013-09-30','12:45:00',5.94),('8975','2013-09-30','12:50:00',5.94),('8975','2013-09-30','12:55:00',5.68),('8975','2013-09-30','13:00:00',5.44),('8975','2013-09-30','13:05:00',1.69),('8975','2013-09-30','13:10:00',2.81),('8975','2013-09-30','13:15:00',5.89),('8975','2013-09-30','13:20:00',5.1),('8975','2013-09-30','13:25:00',5.19),('8975','2013-09-30','13:30:00',1.46),('8975','2013-09-30','13:35:00',4.6),('8975','2013-09-30','13:40:00',4.92),('8975','2013-09-30','13:45:00',4.87),('8975','2013-09-30','13:50:00',3.8),('8975','2013-09-30','13:55:00',4.57),('8975','2013-09-30','14:00:00',4.27),('8975','2013-09-30','14:05:00',4.32),('8975','2013-09-30','14:10:00',4.24),('8975','2013-09-30','14:15:00',4.15),('8975','2013-09-30','14:20:00',4.04),('8975','2013-09-30','14:25:00',3.92),('8975','2013-09-30','14:30:00',3.86),('8975','2013-09-30','14:35:00',3.76),('8975','2013-09-30','14:40:00',3.68),('8975','2013-09-30','14:45:00',3.4),('8975','2013-09-30','14:50:00',3.54),('8975','2013-09-30','14:55:00',3.45),('8975','2013-09-30','15:00:00',3.39),('8975','2013-09-30','15:05:00',3.29),('8975','2013-09-30','15:10:00',3.11),('8975','2013-09-30','15:15:00',3),('8975','2013-09-30','15:20:00',2.94),('8975','2013-09-30','15:25:00',2.84),('8975','2013-09-30','15:30:00',2.73),('8975','2013-09-30','15:35:00',2.67),('8975','2013-09-30','15:40:00',2.6),('8975','2013-09-30','15:45:00',2.48),('8975','2013-09-30','15:50:00',2.36),('8975','2013-09-30','15:55:00',2.27),('8975','2013-09-30','16:00:00',2.15),('8975','2013-09-30','16:05:00',2.05),('8975','2013-09-30','16:10:00',1.96),('8975','2013-09-30','16:15:00',1.86),('8975','2013-09-30','16:20:00',1.77),('8975','2013-09-30','16:25:00',1.69),('8975','2013-09-30','16:30:00',1.62),('8975','2013-09-30','16:35:00',1.55),('8975','2013-09-30','16:40:00',1.49),('8975','2013-09-30','16:45:00',1.44),('8975','2013-09-30','16:50:00',1.4),('8975','2013-09-30','16:55:00',1.36),('8975','2013-09-30','17:00:00',1.32),('8975','2013-09-30','17:05:00',1.28),('8975','2013-09-30','17:10:00',1.24),('8975','2013-09-30','17:15:00',1.2),('8975','2013-09-30','17:20:00',1.15),('8975','2013-09-30','17:25:00',1.12),('8975','2013-09-30','17:30:00',1.06),('8975','2013-09-29','09:35:00',1.04),('8975','2013-09-29','09:40:00',1.17),('8975','2013-09-29','09:45:00',1.54),('8975','2013-09-29','09:50:00',1.83),('8975','2013-09-29','09:55:00',1.64),('8975','2013-09-29','10:00:00',1.58),('8975','2013-09-29','10:05:00',1.59),('8975','2013-09-29','10:10:00',1.74),('8975','2013-09-29','10:15:00',1.75),('8975','2013-09-29','10:20:00',1.82),('8975','2013-09-29','10:25:00',2.04),('8975','2013-09-29','10:30:00',2.38),('8975','2013-09-29','10:35:00',2.69),('8975','2013-09-29','10:40:00',3.83),('8975','2013-09-29','10:45:00',5.31),('8975','2013-09-29','10:50:00',5.46),('8975','2013-09-29','10:55:00',4.69),('8975','2013-09-29','11:00:00',4.24),('8975','2013-09-29','11:05:00',3.36),('8975','2013-09-29','11:10:00',4.79),('8975','2013-09-29','11:15:00',4.93),('8975','2013-09-29','11:20:00',4.66),('8975','2013-09-29','11:25:00',3.86),('8975','2013-09-29','11:30:00',4.16),('8975','2013-09-29','11:35:00',2.27),('8975','2013-09-29','11:40:00',6.3),('8975','2013-09-29','11:45:00',6.56),('8975','2013-09-29','11:50:00',3.66),('8975','2013-09-29','11:55:00',4.19),('8975','2013-09-29','12:00:00',2.51),('8975','2013-09-29','12:15:00',5.5),('8975','2013-09-29','12:20:00',5.64),('8975','2013-09-29','12:25:00',4.45),('8975','2013-09-29','12:30:00',4.61),('8975','2013-09-29','12:35:00',3.57),('8975','2013-09-29','12:40:00',4.32),('8975','2013-09-29','12:45:00',4.82),('8975','2013-09-29','12:50:00',4.28),('8975','2013-09-29','12:55:00',3.05),('8975','2013-09-29','13:00:00',4.81),('8975','2013-09-29','13:05:00',5.56),('8975','2013-09-29','13:10:00',4.92),('8975','2013-09-29','13:15:00',4.74),('8975','2013-09-29','13:20:00',4.93),('8975','2013-09-29','13:25:00',3.56),('8975','2013-09-29','13:30:00',5.47),('8975','2013-09-29','13:35:00',5.16),('8975','2013-09-29','13:40:00',4.86),('8975','2013-09-29','13:45:00',3.88),('8975','2013-09-29','13:50:00',2.73),('8975','2013-09-29','13:55:00',1.63),('8975','2013-09-29','14:00:00',2.91),('8975','2013-09-29','14:05:00',2.56),('8975','2013-09-29','14:10:00',2),('8975','2013-09-29','14:15:00',1.99),('8975','2013-09-29','14:20:00',1.68),('8975','2013-09-29','14:25:00',1.89),('8975','2013-09-29','14:30:00',4.37),('8975','2013-09-29','14:35:00',3.9),('8975','2013-09-29','14:40:00',4.73),('8975','2013-09-29','14:45:00',3.34),('8975','2013-09-29','14:50:00',2.93),('8975','2013-09-29','14:55:00',4.08),('8975','2013-09-29','15:00:00',2.35),('8975','2013-09-29','15:05:00',1.4),('8975','2013-09-29','15:10:00',1.69),('8975','2013-09-29','15:15:00',2.8),('8975','2013-09-29','15:20:00',2.3),('8975','2013-09-29','15:25:00',3.52),('8975','2013-09-29','15:30:00',3.24),('8975','2013-09-29','15:35:00',3.32),('8975','2013-09-29','15:40:00',3.06),('8975','2013-09-29','15:45:00',2.2),('8975','2013-09-29','16:15:00',1.07),('8975','2013-09-29','16:20:00',1.46),('8975','2013-09-29','16:25:00',1.96),('8975','2013-09-29','16:30:00',2.76),('8975','2013-09-29','16:35:00',2.41),('8975','2013-09-29','16:40:00',2.44),('8975','2013-09-29','16:45:00',1.98),('8975','2013-09-29','16:50:00',1.63),('8975','2013-09-29','16:55:00',1.03),('8975','2013-09-29','17:00:00',1.19),('8975','2013-09-29','17:05:00',1.24),('8975','2013-09-29','17:10:00',1.03),('8975','2013-09-29','17:15:00',1.57),('8975','2013-09-29','17:20:00',1.11),('8975','2013-09-28','08:35:00',1.01),('8975','2013-09-28','08:40:00',1.3),('8975','2013-09-28','08:45:00',1.58),('8975','2013-09-28','08:50:00',2.12),('8975','2013-09-28','08:55:00',1.67),('8975','2013-09-28','09:00:00',1.83),('8975','2013-09-28','09:05:00',1.47),('8975','2013-09-28','09:10:00',2.24),('8975','2013-09-28','09:15:00',1.87),('8975','2013-09-28','09:20:00',1.44),('8975','2013-09-28','09:25:00',1.47),('8975','2013-09-28','09:30:00',1.43),('8975','2013-09-28','09:35:00',1.39),('8975','2013-09-28','09:40:00',1.37),('8975','2013-09-28','09:45:00',1.56),('8975','2013-09-28','09:50:00',1.62),('8975','2013-09-28','09:55:00',1.58),('8975','2013-09-28','10:00:00',1.76),('8975','2013-09-28','10:05:00',2.29),('8975','2013-09-28','10:10:00',2.97),('8975','2013-09-28','10:15:00',3.36),('8975','2013-09-28','10:20:00',3.42),('8975','2013-09-28','10:25:00',3.35),('8975','2013-09-28','10:30:00',3.67),('8975','2013-09-28','10:35:00',3.04),('8975','2013-09-28','10:40:00',2.02),('8975','2013-09-28','10:45:00',3.46),('8975','2013-09-28','10:50:00',3.73),('8975','2013-09-28','10:55:00',3.54),('8975','2013-09-28','11:00:00',4.3),('8975','2013-09-28','11:05:00',4),('8975','2013-09-28','11:10:00',4.35),('8975','2013-09-28','11:15:00',4.58),('8975','2013-09-28','11:20:00',3.91),('8975','2013-09-28','11:25:00',4.28),('8975','2013-09-28','11:30:00',4.62),('8975','2013-09-28','11:35:00',4.49),('8975','2013-09-28','11:40:00',4.64),('8975','2013-09-28','11:45:00',4.64),('8975','2013-09-28','11:50:00',4.65),('8975','2013-09-28','11:55:00',4.63),('8975','2013-09-28','12:00:00',5),('8975','2013-09-28','12:05:00',4.1),('8975','2013-09-28','12:10:00',4.15),('8975','2013-09-28','12:15:00',4.13),('8975','2013-09-28','12:20:00',2.52),('8975','2013-09-28','12:25:00',2.53),('8975','2013-09-28','12:30:00',2.96),('8975','2013-09-28','12:35:00',2.87),('8975','2013-09-28','12:40:00',2.94),('8975','2013-09-28','12:45:00',2.44),('8975','2013-09-28','12:50:00',2.4),('8975','2013-09-28','12:55:00',2.15),('8975','2013-09-28','13:00:00',2.23),('8975','2013-09-28','13:05:00',1.8),('8975','2013-09-28','13:10:00',1.74),('8975','2013-09-28','13:15:00',1.47),('8975','2013-09-28','13:20:00',1.49),('8975','2013-09-28','13:25:00',2.18),('8975','2013-09-28','13:30:00',2.26),('8975','2013-09-28','13:35:00',2.59),('8975','2013-09-28','13:40:00',2.34),('8975','2013-09-28','13:45:00',2.09),('8975','2013-09-28','13:50:00',2.62),('8975','2013-09-28','13:55:00',3.23),('8975','2013-09-28','14:00:00',2.36),('8975','2013-09-28','14:05:00',2.91),('8975','2013-09-28','14:10:00',1.76),('8975','2013-09-28','14:15:00',2.91),('8975','2013-09-28','14:20:00',3.22),('8975','2013-09-28','14:25:00',2.7),('8975','2013-09-28','14:30:00',2.83),('8975','2013-09-28','14:35:00',2.18),('8975','2013-09-28','14:40:00',1.97),('8975','2013-09-28','14:45:00',1.23),('8975','2013-09-28','14:50:00',1.36),('8975','2013-09-28','14:55:00',1.44),('8975','2013-09-28','15:00:00',1.39),('8975','2013-09-28','15:15:00',1.53),('8975','2013-09-28','15:20:00',1.68),('8975','2013-09-28','15:25:00',1.3),('8975','2013-09-28','15:30:00',1.32),('8975','2013-09-28','15:35:00',1.27),('8975','2013-09-28','15:40:00',1.53),('8975','2013-09-28','15:45:00',1.14),('8975','2013-09-28','15:55:00',1.39),('8975','2013-09-28','16:00:00',1.86),('8975','2013-09-28','16:05:00',1.64),('8975','2013-09-28','16:10:00',1.29),('8975','2013-09-28','16:15:00',1.13),('8975','2013-09-28','16:20:00',1.23),('8975','2013-09-28','16:25:00',1.3),('8975','2013-09-28','16:30:00',1.62),('8975','2013-09-28','16:35:00',1.57),('8975','2013-09-28','16:40:00',1.32),('8975','2013-09-28','16:45:00',1.43),('8975','2014-04-13','07:05:00',1.03),('8975','2014-04-13','07:10:00',1.26),('8975','2014-04-13','07:15:00',1.52),('8975','2014-04-13','07:20:00',1.54),('8975','2014-04-13','07:25:00',1.71),('8975','2014-04-13','07:30:00',1.92),('8975','2014-04-13','07:35:00',2.19),('8975','2014-04-13','07:40:00',2.33),('8975','2014-04-13','07:45:00',2.57),('8975','2014-04-13','07:50:00',2.7),('8975','2014-04-13','07:55:00',2.83),('8975','2014-04-13','08:00:00',2.95),('8975','2014-04-13','08:05:00',3.09),('8975','2014-04-13','08:10:00',3.19),('8975','2014-04-13','08:15:00',3.31),('8975','2014-04-13','08:20:00',3.43),('8975','2014-04-13','08:25:00',3.54),('8975','2014-04-13','08:30:00',3.64),('8975','2014-04-13','08:35:00',3.75),('8975','2014-04-13','08:40:00',3.84),('8975','2014-04-13','08:45:00',3.94),('8975','2014-04-13','08:50:00',4.02),('8975','2014-04-13','08:55:00',4.12),('8975','2014-04-13','09:00:00',4.22),('8975','2014-04-13','09:05:00',4.31),('8975','2014-04-13','09:10:00',4.42),('8975','2014-04-13','09:15:00',4.54),('8975','2014-04-13','09:20:00',4.62),('8975','2014-04-13','09:25:00',4.73),('8975','2014-04-13','09:30:00',4.81),('8975','2014-04-13','09:35:00',4.89),('8975','2014-04-13','09:40:00',4.97),('8975','2014-04-13','09:45:00',5.04),('8975','2014-04-13','09:50:00',5.15),('8975','2014-04-13','09:55:00',5.24),('8975','2014-04-13','10:00:00',5.3),('8975','2014-04-13','10:05:00',5.38),('8975','2014-04-13','10:10:00',5.47),('8975','2014-04-13','10:15:00',5.56),('8975','2014-04-13','10:20:00',5.65),('8975','2014-04-13','10:25:00',5.71),('8975','2014-04-13','10:30:00',5.76),('8975','2014-04-13','10:35:00',5.81),('8975','2014-04-13','10:40:00',5.88),('8975','2014-04-13','10:45:00',5.91),('8975','2014-04-13','10:50:00',5.96),('8975','2014-04-13','10:55:00',5.98),('8975','2014-04-13','11:00:00',5.98),('8975','2014-04-13','11:05:00',6.03),('8975','2014-04-13','11:10:00',6.13),('8975','2014-04-13','11:15:00',6.19),('8975','2014-04-13','11:20:00',6.2),('8975','2014-04-13','11:25:00',6.26),('8975','2014-04-13','11:30:00',6.3),('8975','2014-04-13','11:35:00',6.34),('8975','2014-04-13','11:40:00',6.36),('8975','2014-04-13','11:45:00',6.38),('8975','2014-04-13','11:50:00',6.39),('8975','2014-04-13','11:55:00',6.42),('8975','2014-04-13','12:00:00',6.42),('8975','2014-04-13','12:05:00',6.39),('8975','2014-04-13','12:10:00',6.4),('8975','2014-04-13','12:15:00',6.43),('8975','2014-04-13','12:20:00',6.44),('8975','2014-04-13','12:25:00',6.42),('8975','2014-04-13','12:30:00',6.44),('8975','2014-04-13','12:35:00',6.43),('8975','2014-04-13','12:40:00',6.39),('8975','2014-04-13','12:45:00',6.37),('8975','2014-04-13','12:50:00',6.38),('8975','2014-04-13','12:55:00',6.33),('8975','2014-04-13','13:00:00',6.35),('8975','2014-04-13','13:05:00',6.26),('8975','2014-04-13','13:10:00',6.34),('8975','2014-04-13','13:15:00',6.3),('8975','2014-04-13','13:20:00',6.26),('8975','2014-04-13','13:25:00',6.24),('8975','2014-04-13','13:30:00',6.2),('8975','2014-04-13','13:35:00',6.19),('8975','2014-04-13','13:40:00',6.13),('8975','2014-04-13','13:45:00',6.1),('8975','2014-04-13','13:50:00',6.07),('8975','2014-04-13','13:55:00',6.01),('8975','2014-04-13','14:00:00',5.96),('8975','2014-04-13','14:05:00',5.9),('8975','2014-04-13','14:10:00',5.85),('8975','2014-04-13','14:15:00',5.78),('8975','2014-04-13','14:20:00',5.73),('8975','2014-04-13','14:25:00',5.64),('8975','2014-04-13','14:30:00',5.57),('8975','2014-04-13','14:35:00',5.51),('8975','2014-04-13','14:40:00',5.41),('8975','2014-04-13','14:45:00',5.33),('8975','2014-04-13','14:50:00',5.23),('8975','2014-04-13','14:55:00',5.15),('8975','2014-04-13','15:00:00',5.05),('8975','2014-04-13','15:05:00',4.96),('8975','2014-04-13','15:10:00',4.86),('8975','2014-04-13','15:15:00',4.75),('8975','2014-04-13','15:20:00',4.61),('8975','2014-04-13','15:25:00',4.45),('8975','2014-04-13','15:30:00',4.32),('8975','2014-04-13','15:35:00',4.29),('8975','2014-04-13','15:40:00',4.2),('8975','2014-04-13','15:45:00',4.09),('8975','2014-04-13','15:50:00',3.96),('8975','2014-04-13','15:55:00',3.85),('8975','2014-04-13','16:00:00',3.71),('8975','2014-04-13','16:05:00',3.59),('8975','2014-04-13','16:10:00',3.47),('8975','2014-04-13','16:15:00',3.35),('8975','2014-04-13','16:20:00',3.26),('8975','2014-04-13','16:25:00',3.13),('8975','2014-04-13','16:30:00',3.03),('8975','2014-04-13','16:35:00',2.93),('8975','2014-04-13','16:40:00',2.79),('8975','2014-04-13','16:45:00',2.67),('8975','2014-04-13','16:50:00',2.57),('8975','2014-04-13','16:55:00',2.45),('8975','2014-04-13','17:00:00',2.33),('8975','2014-04-13','17:05:00',2.22),('8975','2014-04-13','17:10:00',2.1),('8975','2014-04-13','17:15:00',2),('8975','2014-04-13','17:20:00',1.9),('8975','2014-04-13','17:25:00',1.81),('8975','2014-04-13','17:30:00',1.73),('8975','2014-04-13','17:35:00',1.64),('8975','2014-04-13','17:40:00',1.58),('8975','2014-04-13','17:45:00',1.53),('8975','2014-04-13','17:50:00',1.49),('8975','2014-04-13','17:55:00',1.44),('8975','2014-04-13','18:00:00',1.4),('8975','2014-04-13','18:05:00',1.34),('8975','2014-04-13','18:10:00',1.29),('8975','2014-04-13','18:15:00',1.25),('8975','2014-04-13','18:20:00',1.18),('8975','2014-04-13','18:25:00',1.13),('8975','2014-04-13','18:30:00',1.08),('8975','2014-04-13','18:35:00',1.01),('8975','2013-09-27','07:50:00',1.1),('8975','2013-09-27','07:55:00',1.3),('8975','2013-09-27','08:00:00',1.49),('8975','2013-09-27','08:05:00',1.65),('8975','2013-09-27','08:10:00',1.85),('8975','2013-09-27','08:15:00',2.14),('8975','2013-09-27','08:20:00',2.28),('8975','2013-09-27','08:25:00',2.27),('8975','2013-09-27','08:30:00',2.36),('8975','2013-09-27','08:35:00',2.51),('8975','2013-09-27','08:40:00',2.66),('8975','2013-09-27','08:45:00',2.76),('8975','2013-09-27','08:50:00',2.76),('8975','2013-09-27','08:55:00',2.83),('8975','2013-09-27','09:00:00',2.92),('8975','2013-09-27','09:05:00',3.07),('8975','2013-09-27','09:10:00',3.1),('8975','2013-09-27','09:15:00',3.32),('8975','2013-09-27','09:20:00',3.47),('8975','2013-09-27','09:25:00',3.47),('8975','2013-09-27','09:30:00',3.65),('8975','2013-09-27','09:35:00',3.72),('8975','2013-09-27','09:40:00',3.81),('8975','2013-09-27','09:45:00',4),('8975','2013-09-27','09:50:00',3.51),('8975','2013-09-27','09:55:00',3.87),('8975','2013-09-27','10:00:00',3.64),('8975','2013-09-27','10:05:00',1.54),('8975','2013-09-27','10:10:00',2.89),('8975','2013-09-27','10:15:00',2.47),('8975','2013-09-27','10:20:00',3.43),('8975','2013-09-27','10:25:00',1.96),('8975','2013-09-27','10:30:00',4.04),('8975','2013-09-27','10:35:00',1.72),('8975','2013-09-27','10:40:00',1.34),('8975','2013-09-27','10:45:00',4.05),('8975','2013-09-27','10:50:00',2.15),('8975','2013-09-27','10:55:00',1.66),('8975','2013-09-27','11:00:00',1.85),('8975','2013-09-27','11:05:00',1.53),('8975','2013-09-27','11:10:00',1.82),('8975','2013-09-27','11:15:00',4.18),('8975','2013-09-27','11:20:00',4.17),('8975','2013-09-27','11:25:00',4.39),('8975','2013-09-27','11:30:00',3.58),('8975','2013-09-27','11:35:00',5.69),('8975','2013-09-27','11:40:00',5.96),('8975','2013-09-27','11:45:00',5.73),('8975','2013-09-27','11:50:00',5.56),('8975','2013-09-27','11:55:00',5.52),('8975','2013-09-27','12:00:00',5.46),('8975','2013-09-27','12:05:00',5.26),('8975','2013-09-27','12:10:00',5.45),('8975','2013-09-27','12:15:00',5.53),('8975','2013-09-27','12:20:00',4.72),('8975','2013-09-27','12:25:00',5.08),('8975','2013-09-27','12:30:00',5.52),('8975','2013-09-27','12:35:00',2.04),('8975','2013-09-27','12:40:00',2.12),('8975','2013-09-27','12:45:00',2.98),('8975','2013-09-27','12:50:00',5.45),('8975','2013-09-27','12:55:00',4.87),('8975','2013-09-27','13:00:00',5.08),('8975','2013-09-27','13:05:00',4.4),('8975','2013-09-27','13:10:00',4.7),('8975','2013-09-27','13:15:00',4.9),('8975','2013-09-27','13:20:00',4.02),('8975','2013-09-27','13:25:00',4.91),('8975','2013-09-27','13:30:00',5.15),('8975','2013-09-27','13:35:00',4.27),('8975','2013-09-27','13:40:00',4.71),('8975','2013-09-27','13:45:00',5.14),('8975','2013-09-27','13:50:00',4.83),('8975','2013-09-27','13:55:00',3.75),('8975','2013-09-27','14:00:00',2.96),('8975','2013-09-27','14:05:00',3.99),('8975','2013-09-27','14:10:00',4.57),('8975','2013-09-27','14:15:00',4.25),('8975','2013-09-27','14:20:00',2.92),('8975','2013-09-27','14:25:00',3.99),('8975','2013-09-27','14:30:00',3.5),('8975','2013-09-27','14:35:00',1.51),('8975','2013-09-27','14:40:00',1.6),('8975','2013-09-27','14:45:00',3.01),('8975','2013-09-27','14:50:00',3.72),('8975','2013-09-27','14:55:00',3.13),('8975','2013-09-27','15:00:00',3.46),('8975','2013-09-27','15:05:00',3.17),('8975','2013-09-27','15:10:00',3.62),('8975','2013-09-27','15:15:00',3.48),('8975','2013-09-27','15:20:00',3.44),('8975','2013-09-27','15:25:00',3.11),('8975','2013-09-27','15:30:00',2.95),('8975','2013-09-27','15:35:00',2.26),('8975','2013-09-27','15:40:00',2.01),('8975','2013-09-27','15:45:00',2.82),('8975','2013-09-27','15:50:00',2.82),('8975','2013-09-27','15:55:00',3.14),('8975','2013-09-27','16:00:00',2.28),('8975','2013-09-27','16:05:00',2.6),('8975','2013-09-27','16:10:00',2.45),('8975','2013-09-27','16:15:00',2.22),('8975','2013-09-27','16:20:00',1.89),('8975','2013-09-27','16:25:00',1.8),('8975','2013-09-27','16:30:00',1.73),('8975','2013-09-27','16:35:00',1.67),('8975','2013-09-27','16:40:00',1.57),('8975','2013-09-27','16:45:00',1.49),('8975','2013-09-27','16:50:00',1.43),('8975','2013-09-27','16:55:00',1.38),('8975','2013-09-27','17:00:00',1.33),('8975','2013-09-27','17:05:00',1.28),('8975','2013-09-27','17:10:00',1.24),('8975','2013-09-27','17:15:00',1.2),('8975','2013-09-27','17:20:00',1.15),('8975','2013-09-27','17:25:00',1.1),('8975','2013-09-27','17:30:00',1.04),('8975','2013-09-26','08:05:00',1.14),('8975','2013-09-26','08:10:00',1.39),('8975','2013-09-26','08:15:00',1.54),('8975','2013-09-26','08:20:00',1.95),('8975','2013-09-26','08:25:00',1.86),('8975','2013-09-26','08:30:00',2.28),('8975','2013-09-26','08:35:00',2.56),('8975','2013-09-26','08:40:00',1.89),('8975','2013-09-26','08:45:00',1.3),('8975','2013-09-26','08:50:00',1.55),('8975','2013-09-26','08:55:00',2.4),('8975','2013-09-26','09:00:00',3.31),('8975','2013-09-26','09:05:00',3.37),('8975','2013-09-26','09:10:00',2.42),('8975','2013-09-26','09:15:00',1.84),('8975','2013-09-26','09:20:00',1.78),('8975','2013-09-26','09:25:00',1.26),('8975','2013-09-26','09:30:00',1.16),('8975','2013-09-26','09:35:00',1.6),('8975','2013-09-26','09:40:00',1.9),('8975','2013-09-26','09:45:00',1.59),('8975','2013-09-26','09:50:00',2.55),('8975','2013-09-26','09:55:00',3.74),('8975','2013-09-26','10:00:00',4.19),('8975','2013-09-26','10:05:00',4.01),('8975','2013-09-26','10:10:00',2.58),('8975','2013-09-26','10:15:00',2.32),('8975','2013-09-26','10:20:00',3.86),('8975','2013-09-26','10:25:00',2.23),('8975','2013-09-26','10:30:00',3.86),('8975','2013-09-26','10:35:00',3.14),('8975','2013-09-26','10:40:00',3.25),('8975','2013-09-26','10:45:00',3.36),('8975','2013-09-26','10:50:00',4.21),('8975','2013-09-26','10:55:00',3.03),('8975','2013-09-26','11:00:00',3.58),('8975','2013-09-26','11:05:00',4.52),('8975','2013-09-26','11:10:00',4.7),('8975','2013-09-26','11:15:00',3.41),('8975','2013-09-26','11:20:00',1.32),('8975','2013-09-26','11:25:00',1.28),('8975','2013-09-26','11:30:00',1.85),('8975','2013-09-26','11:35:00',1.61),('8975','2013-09-26','11:40:00',2.04),('8975','2013-09-26','11:45:00',1.35),('8975','2013-09-26','11:50:00',1.31),('8975','2013-09-26','11:55:00',1.6),('8975','2013-09-26','12:00:00',2.18),('8975','2013-09-26','12:05:00',1.78),('8975','2013-09-26','12:10:00',1.52),('8975','2013-09-26','12:15:00',3.72),('8975','2013-09-26','12:20:00',3.38),('8975','2013-09-26','12:25:00',3.13),('8975','2013-09-26','12:30:00',1.97),('8975','2013-09-26','12:35:00',1.32),('8975','2013-09-26','12:40:00',1.05),('8975','2013-09-26','12:55:00',1.76),('8975','2013-09-26','13:00:00',1.71),('8975','2013-09-26','13:05:00',2.58),('8975','2013-09-26','13:10:00',3.53),('8975','2013-09-26','13:15:00',2.83),('8975','2013-09-26','13:20:00',1.84),('8975','2013-09-26','13:25:00',1.5),('8975','2013-09-26','13:30:00',1.93),('8975','2013-09-26','13:35:00',1.48),('8975','2013-09-26','13:40:00',1.26),('8975','2013-09-26','13:45:00',1.37),('8975','2013-09-26','13:50:00',4.5),('8975','2013-09-26','13:55:00',4.36),('8975','2013-09-26','14:00:00',2.23),('8975','2013-09-26','14:05:00',2.45),('8975','2013-09-26','14:10:00',4.88),('8975','2013-09-26','14:15:00',4.26),('8975','2013-09-26','14:20:00',3.77),('8975','2013-09-26','14:25:00',4.34),('8975','2013-09-26','14:30:00',4.18),('8975','2013-09-26','14:35:00',4.17),('8975','2013-09-26','14:40:00',4.05),('8975','2013-09-26','14:45:00',3.74),('8975','2013-09-26','14:50:00',3.52),('8975','2013-09-26','14:55:00',3.58),('8975','2013-09-26','15:00:00',3.49),('8975','2013-09-26','15:05:00',3.5),('8975','2013-09-26','15:10:00',3.27),('8975','2013-09-26','15:15:00',3.2),('8975','2013-09-26','15:20:00',1.54),('8975','2013-09-26','15:25:00',2.61),('8975','2013-09-26','15:30:00',2.24),('8975','2013-09-26','15:35:00',2.88),('8975','2013-09-26','15:45:00',1.92),('8975','2013-09-26','15:50:00',2.72),('8975','2013-09-26','15:55:00',2.02),('8975','2013-09-26','16:00:00',1.27),('8975','2013-09-26','16:05:00',2.28),('8975','2013-09-26','16:10:00',2.21),('8975','2013-09-26','16:15:00',2.14),('8975','2013-09-26','16:20:00',1.5),('8975','2013-09-26','16:25:00',1.93),('8975','2013-09-26','16:30:00',1.63),('8975','2013-09-26','16:35:00',1.05),('8975','2013-09-26','16:40:00',1.32),('8975','2013-09-26','16:45:00',1.65),('8975','2013-09-26','16:50:00',1.57),('8975','2013-09-26','16:55:00',1.45),('8975','2013-09-26','17:00:00',1.41),('8975','2013-09-26','17:05:00',1.33),('8975','2013-09-26','17:10:00',1.3),('8975','2013-09-26','17:15:00',1.09),('8975','2013-09-26','17:25:00',1.15),('8975','2013-09-26','17:30:00',1.08),('8975','2013-09-26','17:35:00',1.03),('8975','2013-09-26','17:40:00',1.05),('8975','2013-09-26','17:45:00',1.06),('8975','2013-09-25','07:40:00',1.27),('8975','2013-09-25','07:45:00',1.22),('8975','2013-09-25','07:55:00',1.42),('8975','2013-09-25','08:00:00',1.57),('8975','2013-09-25','08:05:00',2.09),('8975','2013-09-25','08:10:00',2.25),('8975','2013-09-25','08:15:00',2.32),('8975','2013-09-25','08:20:00',2.27),('8975','2013-09-25','08:25:00',1.62),('8975','2013-09-25','08:30:00',2.22),('8975','2013-09-25','08:35:00',2.65),('8975','2013-09-25','08:40:00',2.93),('8975','2013-09-25','08:45:00',3),('8975','2013-09-25','08:50:00',3.1),('8975','2013-09-25','08:55:00',3.18),('8975','2013-09-25','09:00:00',3.25),('8975','2013-09-25','09:05:00',3.36),('8975','2013-09-25','09:10:00',3.46),('8975','2013-09-25','09:15:00',3.56),('8975','2013-09-25','09:20:00',3.6),('8975','2013-09-25','09:25:00',3.71),('8975','2013-09-25','09:30:00',3.76),('8975','2013-09-25','09:35:00',3.89),('8975','2013-09-25','09:40:00',3.97),('8975','2013-09-25','09:45:00',4.02),('8975','2013-09-25','09:50:00',4.05),('8975','2013-09-25','09:55:00',4.14),('8975','2013-09-25','10:00:00',4.21),('8975','2013-09-25','10:05:00',4.27),('8975','2013-09-25','10:10:00',4.25),('8975','2013-09-25','10:15:00',4.33),('8975','2013-09-25','10:20:00',4.41),('8975','2013-09-25','10:25:00',4.47),('8975','2013-09-25','10:30:00',4.54),('8975','2013-09-25','10:35:00',4.66),('8975','2013-09-25','10:40:00',4.67),('8975','2013-09-25','10:45:00',4.62),('8975','2013-09-25','10:50:00',4.71),('8975','2013-09-25','10:55:00',4.65),('8975','2013-09-25','11:00:00',3.94),('8975','2013-09-25','11:05:00',3.98),('8975','2013-09-25','11:10:00',2.73),('8975','2013-09-25','11:15:00',2.62),('8975','2013-09-25','11:20:00',5.22),('8975','2013-09-25','11:25:00',5.16),('8975','2013-09-25','11:30:00',4.63),('8975','2013-09-25','11:35:00',4.8),('8975','2013-09-25','11:40:00',4.28),('8975','2013-09-25','11:45:00',4.1),('8975','2013-09-25','11:50:00',2.32),('8975','2013-09-25','11:55:00',2.1),('8975','2013-09-25','12:00:00',2.7),('8975','2013-09-25','12:05:00',1.7),('8975','2013-09-25','12:10:00',2.64),('8975','2013-09-25','12:15:00',2.52),('8975','2013-09-25','12:20:00',2.71),('8975','2013-09-25','12:25:00',2.1),('8975','2013-09-25','12:30:00',1.91),('8975','2013-09-25','12:35:00',2.15),('8975','2013-09-25','12:40:00',2.32),('8975','2013-09-25','12:45:00',2.64),('8975','2013-09-25','12:50:00',2.49),('8975','2013-09-25','12:55:00',2.34),('8975','2013-09-25','13:00:00',2.13),('8975','2013-09-25','13:05:00',2.1),('8975','2013-09-25','13:10:00',3.17),('8975','2013-09-25','13:15:00',2.98),('8975','2013-09-25','13:20:00',2.7),('8975','2013-09-25','13:25:00',5.43),('8975','2013-09-25','13:30:00',4.11),('8975','2013-09-25','13:35:00',4.27),('8975','2013-09-25','13:40:00',4.03),('8975','2013-09-25','13:45:00',3.47),('8975','2013-09-25','13:50:00',5.12),('8975','2013-09-25','13:55:00',5.01),('8975','2013-09-25','14:00:00',2.36),('8975','2013-09-25','14:05:00',4.16),('8975','2013-09-25','14:10:00',2),('8975','2013-09-25','14:15:00',1.66),('8975','2013-09-25','14:20:00',1.3),('8975','2013-09-25','14:25:00',1.58),('8975','2013-09-25','14:30:00',3.93),('8975','2013-09-25','14:35:00',3.66),('8975','2013-09-25','14:40:00',1.88),('8975','2013-09-25','14:45:00',3.19),('8975','2013-09-25','14:50:00',3.23),('8975','2013-09-25','14:55:00',4.27),('8975','2013-09-25','15:00:00',3.25),('8975','2013-09-25','15:05:00',3.29),('8975','2013-09-25','15:10:00',2.21),('8975','2013-09-25','15:15:00',1.53),('8975','2013-09-25','15:20:00',1.31),('8975','2013-09-25','15:25:00',1.6),('8975','2013-09-25','15:30:00',2.83),('8975','2013-09-25','15:35:00',1.48),('8975','2013-09-25','15:40:00',1.84),('8975','2013-09-25','15:45:00',2.05),('8975','2013-09-25','15:50:00',2.78),('8975','2013-09-25','15:55:00',1.39),('8975','2013-09-25','16:00:00',1.26),('8975','2013-09-25','16:05:00',1.22),('8975','2013-09-25','16:10:00',1.83),('8975','2013-09-25','16:15:00',1.4),('8975','2013-09-25','16:20:00',1.98),('8975','2013-09-25','16:25:00',1.87),('8975','2013-09-25','16:30:00',1.78),('8975','2013-09-25','16:35:00',1.67),('8975','2013-09-25','16:40:00',1.62),('8975','2013-09-25','16:45:00',1.54),('8975','2013-09-25','16:50:00',1.47),('8975','2013-09-25','16:55:00',1.4),('8975','2013-09-25','17:00:00',1.37),('8975','2013-09-25','17:05:00',1.35),('8975','2013-09-25','17:10:00',1.31),('8975','2013-09-25','17:15:00',1.25),('8975','2013-09-25','17:20:00',1.22),('8975','2013-09-25','17:25:00',1.13),('8975','2013-09-25','17:30:00',1.08),('8975','2013-09-25','17:35:00',1.08),('8975','2013-09-25','17:40:00',1.07),('8975','2013-09-24','08:00:00',1.27),('8975','2013-09-24','08:05:00',1.9),('8975','2013-09-24','08:10:00',1.83),('8975','2013-09-24','08:30:00',1.51),('8975','2013-09-24','08:35:00',2.46),('8975','2013-09-24','08:40:00',3.17),('8975','2013-09-24','08:45:00',3.26),('8975','2013-09-24','08:50:00',3.42),('8975','2013-09-24','08:55:00',2.07),('8975','2013-09-24','09:00:00',1.15),('8975','2013-09-24','09:05:00',1.08),('8975','2013-09-24','09:10:00',1.7),('8975','2013-09-24','09:15:00',2.23),('8975','2013-09-24','09:20:00',1.86),('8975','2013-09-24','09:25:00',1.71),('8975','2013-09-24','09:30:00',1.61),('8975','2013-09-24','09:35:00',3.4),('8975','2013-09-24','09:40:00',4.88),('8975','2013-09-24','09:45:00',4.94),('8975','2013-09-24','09:50:00',4.99),('8975','2013-09-24','09:55:00',2.03),('8975','2013-09-24','10:00:00',1.04),('8975','2013-09-24','10:35:00',1),('8975','2013-09-24','10:40:00',3.76),('8975','2013-09-24','10:45:00',4.83),('8975','2013-09-24','10:50:00',1.76),('8975','2013-09-24','10:55:00',1.77),('8975','2013-09-24','11:00:00',1.86),('8975','2013-09-24','11:05:00',1.52),('8975','2013-09-24','11:10:00',2.46),('8975','2013-09-24','11:15:00',2.37),('8975','2013-09-24','11:20:00',4.86),('8975','2013-09-24','11:25:00',4.91),('8975','2013-09-24','11:30:00',5.12),('8975','2013-09-24','11:35:00',5.78),('8975','2013-09-24','11:40:00',4.34),('8975','2013-09-24','11:45:00',3.56),('8975','2013-09-24','11:50:00',1.5),('8975','2013-09-24','11:55:00',1.41),('8975','2013-09-24','12:00:00',2.03),('8975','2013-09-24','12:05:00',2.15),('8975','2013-09-24','12:10:00',5.05),('8975','2013-09-24','12:15:00',1.42),('8975','2013-09-24','12:20:00',1.11),('8975','2013-09-24','12:25:00',1.26),('8975','2013-09-24','12:30:00',1.94),('8975','2013-09-24','12:35:00',6.26),('8975','2013-09-24','12:40:00',6.41),('8975','2013-09-24','12:45:00',2.96),('8975','2013-09-24','12:50:00',1.4),('8975','2013-09-24','12:55:00',1.47),('8975','2013-09-24','13:00:00',4.38),('8975','2013-09-24','13:05:00',1.95),('8975','2013-09-24','13:10:00',3.64),('8975','2013-09-24','13:15:00',6.3),('8975','2013-09-24','13:20:00',4.74),('8975','2013-09-24','13:25:00',3.36),('8975','2013-09-24','13:30:00',3.31),('8975','2013-09-24','13:35:00',1.39),('8975','2013-09-24','13:40:00',1.36),('8975','2013-09-24','13:45:00',1.61),('8975','2013-09-24','13:50:00',1.33),('8975','2013-09-24','13:55:00',1.25),('8975','2013-09-24','14:00:00',1.31),('8975','2013-09-24','14:05:00',1.41),('8975','2013-09-24','14:10:00',1.6),('8975','2013-09-24','14:15:00',3.77),('8975','2013-09-24','14:20:00',5.58),('8975','2013-09-24','14:25:00',4.91),('8975','2013-09-24','14:30:00',2.95),('8975','2013-09-24','14:35:00',1.66),('8975','2013-09-24','14:40:00',1.38),('8975','2013-09-24','14:45:00',1.91),('8975','2013-09-24','14:50:00',2.84),('8975','2013-09-24','14:55:00',1.99),('8975','2013-09-24','15:00:00',3.29),('8975','2013-09-24','15:05:00',3.36),('8975','2013-09-24','15:10:00',3.62),('8975','2013-09-24','15:15:00',2.44),('8975','2013-09-24','15:20:00',2.4),('8975','2013-09-24','15:25:00',2.14),('8975','2013-09-24','15:30:00',3.42),('8975','2013-09-24','15:35:00',2.79),('8975','2013-09-24','15:40:00',3.11),('8975','2013-09-24','15:45:00',2.93),('8975','2013-09-24','15:50:00',2.87),('8975','2013-09-24','15:55:00',2.31),('8975','2013-09-24','16:00:00',1.61),('8975','2013-09-24','16:05:00',2.37),('8975','2013-09-24','16:10:00',2.31),('8975','2013-09-24','16:15:00',1.96),('8975','2013-09-24','16:20:00',2.04),('8975','2013-09-24','16:25:00',1.95),('8975','2013-09-24','16:30:00',1.89),('8975','2013-09-24','16:35:00',1.53),('8975','2013-09-24','16:40:00',1.69),('8975','2013-09-24','16:45:00',1.59),('8975','2013-09-24','16:50:00',1.43),('8975','2013-09-24','16:55:00',1.5),('8975','2013-09-24','17:00:00',1.46),('8975','2013-09-24','17:05:00',1.41),('8975','2013-09-24','17:10:00',1.36),('8975','2013-09-24','17:15:00',1.32),('8975','2013-09-24','17:20:00',1.28),('8975','2013-09-24','17:25:00',1.22),('8975','2013-09-24','17:30:00',1.16),('8975','2013-09-24','17:35:00',1.11),('8975','2013-09-24','17:40:00',1.07),('8975','2013-09-24','17:45:00',1.02),('8975','2013-09-23','07:35:00',1.21),('8975','2013-09-23','07:40:00',1.39),('8975','2013-09-23','07:45:00',1.53),('8975','2013-09-23','07:50:00',1.73),('8975','2013-09-23','07:55:00',1.97),('8975','2013-09-23','08:00:00',2.12),('8975','2013-09-23','08:05:00',2.27),('8975','2013-09-23','08:10:00',2.43),('8975','2013-09-23','08:15:00',2.56),('8975','2013-09-23','08:20:00',2.68),('8975','2013-09-23','08:25:00',2.81),('8975','2013-09-23','08:30:00',2.94),('8975','2013-09-23','08:35:00',3.04),('8975','2013-09-23','08:40:00',3.15),('8975','2013-09-23','08:45:00',3.24),('8975','2013-09-23','08:50:00',3.34),('8975','2013-09-23','08:55:00',3.43),('8975','2013-09-23','09:00:00',3.51),('8975','2013-09-23','09:05:00',3.61),('8975','2013-09-23','09:10:00',3.69),('8975','2013-09-23','09:15:00',3.78),('8975','2013-09-23','09:20:00',3.86),('8975','2013-09-23','09:25:00',3.98),('8975','2013-09-23','09:30:00',4.06),('8975','2013-09-23','09:35:00',4.13),('8975','2013-09-23','09:40:00',4.2),('8975','2013-09-23','09:45:00',4.25),('8975','2013-09-23','09:50:00',4.32),('8975','2013-09-23','09:55:00',4.37),('8975','2013-09-23','10:00:00',4.46),('8975','2013-09-23','10:05:00',4.53),('8975','2013-09-23','10:10:00',4.59),('8975','2013-09-23','10:15:00',4.69),('8975','2013-09-23','10:20:00',4.78),('8975','2013-09-23','10:25:00',4.82),('8975','2013-09-23','10:30:00',4.86),('8975','2013-09-23','10:35:00',4.9),('8975','2013-09-23','10:40:00',4.98),('8975','2013-09-23','10:45:00',5.05),('8975','2013-09-23','10:50:00',5.11),('8975','2013-09-23','10:55:00',5.11),('8975','2013-09-23','11:00:00',5.17),('8975','2013-09-23','11:05:00',5.17),('8975','2013-09-23','11:10:00',5.2),('8975','2013-09-23','11:15:00',5.24),('8975','2013-09-23','11:20:00',5.28),('8975','2013-09-23','11:25:00',5.28),('8975','2013-09-23','11:30:00',5.34),('8975','2013-09-23','11:35:00',5.34),('8975','2013-09-23','11:40:00',5.37),('8975','2013-09-23','11:45:00',5.39),('8975','2013-09-23','11:50:00',5.41),('8975','2013-09-23','11:55:00',5.4),('8975','2013-09-23','12:00:00',5.36),('8975','2013-09-23','12:05:00',5.39),('8975','2013-09-23','12:10:00',5.39),('8975','2013-09-23','12:15:00',5.33),('8975','2013-09-23','12:20:00',5.34),('8975','2013-09-23','12:25:00',5.34),('8975','2013-09-23','12:30:00',5.35),('8975','2013-09-23','12:35:00',5.33),('8975','2013-09-23','12:40:00',5.35),('8975','2013-09-23','12:45:00',5.32),('8975','2013-09-23','12:50:00',5.25),('8975','2013-09-23','12:55:00',5.23),('8975','2013-09-23','13:00:00',5.27),('8975','2013-09-23','13:05:00',5.23),('8975','2013-09-23','13:10:00',5.19),('8975','2013-09-23','13:15:00',5.12),('8975','2013-09-23','13:20:00',5.07),('8975','2013-09-23','13:25:00',5.06),('8975','2013-09-23','13:30:00',5.07),('8975','2013-09-23','13:35:00',4.95),('8975','2013-09-23','13:40:00',4.91),('8975','2013-09-23','13:45:00',4.9),('8975','2013-09-23','13:50:00',4.84),('8975','2013-09-23','13:55:00',4.8),('8975','2013-09-23','14:00:00',4.72),('8975','2013-09-23','14:05:00',4.56),('8975','2013-09-23','14:10:00',4.53),('8975','2013-09-23','14:15:00',4.44),('8975','2013-09-23','14:20:00',4.39),('8975','2013-09-23','14:25:00',4.27),('8975','2013-09-23','14:30:00',4.16),('8975','2013-09-23','14:35:00',4.07),('8975','2013-09-23','14:40:00',4.02),('8975','2013-09-23','14:45:00',3.96),('8975','2013-09-23','14:50:00',3.83),('8975','2013-09-23','14:55:00',3.59),('8975','2013-09-23','15:00:00',3.36),('8975','2013-09-23','15:05:00',3.42),('8975','2013-09-23','15:10:00',3.41),('8975','2013-09-23','15:15:00',3.36),('8975','2013-09-23','15:20:00',3.21),('8975','2013-09-23','15:25:00',2.96),('8975','2013-09-23','15:30:00',2.89),('8975','2013-09-23','15:35:00',2.95),('8975','2013-09-23','15:40:00',2.88),('8975','2013-09-23','15:45:00',2.77),('8975','2013-09-23','15:50:00',2.65),('8975','2013-09-23','15:55:00',2.57),('8975','2013-09-23','16:00:00',2.46),('8975','2013-09-23','16:05:00',2.35),('8975','2013-09-23','16:10:00',2.26),('8975','2013-09-23','16:15:00',2.11),('8975','2013-09-23','16:20:00',2),('8975','2013-09-23','16:25:00',1.92),('8975','2013-09-23','16:30:00',1.84),('8975','2013-09-23','16:35:00',1.77),('8975','2013-09-23','16:40:00',1.7),('8975','2013-09-23','16:45:00',1.64),('8975','2013-09-23','16:50:00',1.56),('8975','2013-09-23','16:55:00',1.5),('8975','2013-09-23','17:00:00',1.45),('8975','2013-09-23','17:05:00',1.4),('8975','2013-09-23','17:10:00',1.36),('8975','2013-09-23','17:15:00',1.32),('8975','2013-09-23','17:20:00',1.27),('8975','2013-09-23','17:25:00',1.22),('8975','2013-09-23','17:30:00',1.16),('8975','2013-09-23','17:35:00',1.09),('8975','2013-09-23','17:40:00',1.05),('8975','2013-09-22','07:30:00',1.09),('8975','2013-09-22','07:35:00',1.29),('8975','2013-09-22','07:40:00',1.39),('8975','2013-09-22','07:45:00',1.48),('8975','2013-09-22','07:50:00',1.9),('8975','2013-09-22','07:55:00',2.02),('8975','2013-09-22','08:00:00',2.11),('8975','2013-09-22','08:05:00',2.39),('8975','2013-09-22','08:10:00',2.56),('8975','2013-09-22','08:15:00',2.68),('8975','2013-09-22','08:20:00',2.79),('8975','2013-09-22','08:25:00',2.92),('8975','2013-09-22','08:30:00',3.02),('8975','2013-09-22','08:35:00',3.12),('8975','2013-09-22','08:40:00',3.22),('8975','2013-09-22','08:45:00',3.31),('8975','2013-09-22','08:50:00',3.39),('8975','2013-09-22','08:55:00',3.48),('8975','2013-09-22','09:00:00',3.57),('8975','2013-09-22','09:05:00',3.65),('8975','2013-09-22','09:10:00',3.74),('8975','2013-09-22','09:15:00',3.83),('8975','2013-09-22','09:20:00',3.88),('8975','2013-09-22','09:25:00',4.01),('8975','2013-09-22','09:30:00',4.09),('8975','2013-09-22','09:35:00',4.19),('8975','2013-09-22','09:40:00',4.28),('8975','2013-09-22','09:45:00',4.35),('8975','2013-09-22','09:50:00',4.43),('8975','2013-09-22','09:55:00',4.51),('8975','2013-09-22','10:00:00',4.58),('8975','2013-09-22','10:05:00',4.65),('8975','2013-09-22','10:10:00',4.72),('8975','2013-09-22','10:15:00',4.76),('8975','2013-09-22','10:20:00',4.82),('8975','2013-09-22','10:25:00',4.95),('8975','2013-09-22','10:30:00',5.03),('8975','2013-09-22','10:35:00',5.08),('8975','2013-09-22','10:40:00',5.14),('8975','2013-09-22','10:45:00',5.16),('8975','2013-09-22','10:50:00',5.24),('8975','2013-09-22','10:55:00',5.31),('8975','2013-09-22','11:00:00',5.31),('8975','2013-09-22','11:05:00',5.35),('8975','2013-09-22','11:10:00',5.38),('8975','2013-09-22','11:15:00',5.41),('8975','2013-09-22','11:20:00',5.47),('8975','2013-09-22','11:25:00',5.53),('8975','2013-09-22','11:30:00',5.6),('8975','2013-09-22','11:35:00',5.66),('8975','2013-09-22','11:40:00',5.68),('8975','2013-09-22','11:45:00',5.68),('8975','2013-09-22','11:50:00',5.69),('8975','2013-09-22','11:55:00',5.67),('8975','2013-09-22','12:00:00',5.67),('8975','2013-09-22','12:05:00',5.67),('8975','2013-09-22','12:10:00',5.67),('8975','2013-09-22','12:15:00',5.66),('8975','2013-09-22','12:20:00',5.68),('8975','2013-09-22','12:25:00',5.67),('8975','2013-09-22','12:30:00',5.67),('8975','2013-09-22','12:35:00',5.67),('8975','2013-09-22','12:40:00',5.62),('8975','2013-09-22','12:45:00',5.59),('8975','2013-09-22','12:50:00',5.54),('8975','2013-09-22','12:55:00',5.48),('8975','2013-09-22','13:00:00',5.43),('8975','2013-09-22','13:05:00',5.44),('8975','2013-09-22','13:10:00',5.4),('8975','2013-09-22','13:15:00',5.34),('8975','2013-09-22','13:20:00',5.27),('8975','2013-09-22','13:25:00',5.18),('8975','2013-09-22','13:30:00',5.2),('8975','2013-09-22','13:35:00',5.12),('8975','2013-09-22','13:40:00',5.09),('8975','2013-09-22','13:45:00',5.03),('8975','2013-09-22','13:50:00',4.97),('8975','2013-09-22','13:55:00',4.9),('8975','2013-09-22','14:00:00',4.84),('8975','2013-09-22','14:05:00',4.71),('8975','2013-09-22','14:10:00',4.37),('8975','2013-09-22','14:15:00',4.44),('8975','2013-09-22','14:20:00',4.38),('8975','2013-09-22','14:25:00',4.38),('8975','2013-09-22','14:30:00',4.33),('8975','2013-09-22','14:35:00',4.18),('8975','2013-09-22','14:40:00',3.81),('8975','2013-09-22','14:45:00',2.23),('8975','2013-09-22','14:50:00',3.67),('8975','2013-09-22','14:55:00',3.62),('8975','2013-09-22','15:00:00',3.52),('8975','2013-09-22','15:05:00',3.04),('8975','2013-09-22','15:10:00',1.96),('8975','2013-09-22','15:15:00',3.24),('8975','2013-09-22','15:20:00',3.06),('8975','2013-09-22','15:25:00',2.66),('8975','2013-09-22','15:30:00',3.14),('8975','2013-09-22','15:35:00',2.99),('8975','2013-09-22','15:40:00',2.95),('8975','2013-09-22','15:45:00',2.77),('8975','2013-09-22','15:50:00',2.64),('8975','2013-09-22','15:55:00',2.62),('8975','2013-09-22','16:00:00',2.47),('8975','2013-09-22','16:05:00',2.35),('8975','2013-09-22','16:10:00',2.3),('8975','2013-09-22','16:15:00',2.16),('8975','2013-09-22','16:20:00',1.35),('8975','2013-09-22','16:25:00',1.47),('8975','2013-09-22','16:30:00',1.13),('8975','2013-09-22','16:35:00',1.63),('8975','2013-09-22','16:40:00',1.67),('8975','2013-09-22','16:45:00',1.57),('8975','2013-09-22','16:50:00',1.51),('8975','2013-09-22','16:55:00',1.48),('8975','2013-09-22','17:00:00',1.43),('8975','2013-09-22','17:05:00',1.39),('8975','2013-09-22','17:10:00',1.35),('8975','2013-09-22','17:15:00',1.31),('8975','2013-09-22','17:20:00',1.27),('8975','2013-09-22','17:25:00',1.23),('8975','2013-09-22','17:30:00',1.19),('8975','2013-09-22','17:35:00',1.13),('8975','2013-09-22','17:40:00',1.08),('8975','2013-09-22','17:45:00',1.02),('8975','2013-09-21','07:35:00',1.35),('8975','2013-09-21','07:40:00',1.55),('8975','2013-09-21','07:45:00',1.61),('8975','2013-09-21','07:50:00',1.73),('8975','2013-09-21','07:55:00',2.05),('8975','2013-09-21','08:00:00',2.16),('8975','2013-09-21','08:05:00',2.39),('8975','2013-09-21','08:10:00',2.64),('8975','2013-09-21','08:15:00',2.84),('8975','2013-09-21','08:20:00',2.96),('8975','2013-09-21','08:25:00',2.96),('8975','2013-09-21','08:30:00',3.01),('8975','2013-09-21','08:35:00',2.83),('8975','2013-09-21','08:40:00',3.13),('8975','2013-09-21','08:45:00',3.14),('8975','2013-09-21','08:50:00',3.36),('8975','2013-09-21','08:55:00',3.47),('8975','2013-09-21','09:00:00',3.58),('8975','2013-09-21','09:05:00',3.66),('8975','2013-09-21','09:10:00',3.77),('8975','2013-09-21','09:15:00',3.87),('8975','2013-09-21','09:20:00',3.98),('8975','2013-09-21','09:25:00',4.07),('8975','2013-09-21','09:30:00',4.17),('8975','2013-09-21','09:35:00',4.25),('8975','2013-09-21','09:40:00',4.33),('8975','2013-09-21','09:45:00',4.41),('8975','2013-09-21','09:50:00',4.52),('8975','2013-09-21','09:55:00',4.61),('8975','2013-09-21','10:00:00',4.68),('8975','2013-09-21','10:05:00',4.76),('8975','2013-09-21','10:10:00',4.84),('8975','2013-09-21','10:15:00',4.9),('8975','2013-09-21','10:20:00',4.99),('8975','2013-09-21','10:25:00',5.06),('8975','2013-09-21','10:30:00',5.14),('8975','2013-09-21','10:35:00',5.2),('8975','2013-09-21','10:40:00',5.25),('8975','2013-09-21','10:45:00',5.3),('8975','2013-09-21','10:50:00',5.37),('8975','2013-09-21','10:55:00',5.41),('8975','2013-09-21','11:00:00',5.45),('8975','2013-09-21','11:05:00',5.49),('8975','2013-09-21','11:10:00',5.53),('8975','2013-09-21','11:15:00',5.55),('8975','2013-09-21','11:20:00',5.61),('8975','2013-09-21','11:25:00',5.64),('8975','2013-09-21','11:30:00',5.65),('8975','2013-09-21','11:35:00',5.65),('8975','2013-09-21','11:40:00',5.64),('8975','2013-09-21','11:45:00',5.68),('8975','2013-09-21','11:50:00',5.72),('8975','2013-09-21','11:55:00',5.73),('8975','2013-09-21','12:00:00',5.73),('8975','2013-09-21','12:05:00',5.74),('8975','2013-09-21','12:10:00',5.78),('8975','2013-09-21','12:15:00',5.78),('8975','2013-09-21','12:20:00',5.74),('8975','2013-09-21','12:25:00',5.41),('8975','2013-09-21','12:30:00',5.71),('8975','2013-09-21','12:35:00',5.64),('8975','2013-09-21','12:40:00',5.67),('8975','2013-09-21','12:45:00',5.68),('8975','2013-09-21','12:50:00',5.33),('8975','2013-09-21','12:55:00',5.75),('8975','2013-09-21','13:00:00',5.66),('8975','2013-09-21','13:05:00',5.58),('8975','2013-09-21','13:10:00',5.58),('8975','2013-09-21','13:15:00',5.49),('8975','2013-09-21','13:20:00',5.36),('8975','2013-09-21','13:25:00',5.32),('8975','2013-09-21','13:30:00',5.33),('8975','2013-09-21','13:35:00',5.26),('8975','2013-09-21','13:40:00',5.2),('8975','2013-09-21','13:45:00',5.13),('8975','2013-09-21','13:50:00',5.09),('8975','2013-09-21','13:55:00',5.09),('8975','2013-09-21','14:00:00',5.01),('8975','2013-09-21','14:05:00',4.85),('8975','2013-09-21','14:10:00',4.76),('8975','2013-09-21','14:15:00',4.84),('8975','2013-09-21','14:20:00',5.2),('8975','2013-09-21','14:25:00',5.12),('8975','2013-09-21','14:30:00',3.79),('8975','2013-09-21','14:35:00',2.45),('8975','2013-09-21','14:40:00',4.28),('8975','2013-09-21','14:45:00',3.68),('8975','2013-09-21','14:50:00',4.13),('8975','2013-09-21','14:55:00',3.98),('8975','2013-09-21','15:00:00',3.79),('8975','2013-09-21','15:05:00',3.7),('8975','2013-09-21','15:10:00',3.82),('8975','2013-09-21','15:15:00',3.87),('8975','2013-09-21','15:20:00',3.43),('8975','2013-09-21','15:25:00',4.16),('8975','2013-09-21','15:30:00',3.65),('8975','2013-09-21','15:35:00',2.43),('8975','2013-09-21','15:40:00',2.44),('8975','2013-09-21','15:45:00',3.21),('8975','2013-09-21','15:50:00',2.89),('8975','2013-09-21','15:55:00',2.83),('8975','2013-09-21','16:00:00',2.94),('8975','2013-09-21','16:05:00',3.33),('8975','2013-09-21','16:10:00',3.41),('8975','2013-09-21','16:15:00',2.98),('8975','2013-09-21','16:20:00',2.69),('8975','2013-09-21','16:25:00',2.12),('8975','2013-09-21','16:30:00',1.47),('8975','2013-09-21','16:35:00',1.59),('8975','2013-09-21','16:40:00',1.51),('8975','2013-09-21','16:45:00',1.53),('8975','2013-09-21','16:50:00',2.12),('8975','2013-09-21','16:55:00',1.66),('8975','2013-09-21','17:00:00',1.9),('8975','2013-09-21','17:05:00',1.82),('8975','2013-09-21','17:10:00',1.79),('8975','2013-09-21','17:15:00',1.6),('8975','2013-09-21','17:35:00',1.23),('8975','2013-09-21','17:40:00',1.14),('8975','2013-09-20','07:30:00',1.12),('8975','2013-09-20','07:35:00',1.21),('8975','2013-09-20','07:40:00',1.35),('8975','2013-09-20','07:45:00',1.55),('8975','2013-09-20','07:50:00',1.6),('8975','2013-09-20','07:55:00',1.87),('8975','2013-09-20','08:00:00',2.11),('8975','2013-09-20','08:05:00',2.28),('8975','2013-09-20','08:10:00',2.45),('8975','2013-09-20','08:15:00',2.6),('8975','2013-09-20','08:20:00',2.73),('8975','2013-09-20','08:25:00',2.83),('8975','2013-09-20','08:30:00',2.92),('8975','2013-09-20','08:35:00',3.03),('8975','2013-09-20','08:40:00',3.12),('8975','2013-09-20','08:45:00',3.2),('8975','2013-09-20','08:50:00',3.29),('8975','2013-09-20','08:55:00',3.36),('8975','2013-09-20','09:00:00',3.44),('8975','2013-09-20','09:05:00',3.54),('8975','2013-09-20','09:10:00',3.64),('8975','2013-09-20','09:15:00',3.72),('8975','2013-09-20','09:20:00',3.84),('8975','2013-09-20','09:25:00',3.94),('8975','2013-09-20','09:30:00',4.03),('8975','2013-09-20','09:35:00',4.11),('8975','2013-09-20','09:40:00',4.08),('8975','2013-09-20','09:45:00',4.22),('8975','2013-09-20','09:50:00',4.38),('8975','2013-09-20','09:55:00',4.46),('8975','2013-09-20','10:00:00',4.54),('8975','2013-09-20','10:05:00',4.61),('8975','2013-09-20','10:10:00',4.67),('8975','2013-09-20','10:15:00',4.73),('8975','2013-09-20','10:20:00',4.8),('8975','2013-09-20','10:25:00',4.83),('8975','2013-09-20','10:30:00',4.84),('8975','2013-09-20','10:35:00',4.91),('8975','2013-09-20','10:40:00',4.98),('8975','2013-09-20','10:45:00',5.04),('8975','2013-09-20','10:50:00',5.09),('8975','2013-09-20','10:55:00',5.16),('8975','2013-09-20','11:00:00',5.19),('8975','2013-09-20','11:05:00',5.2),('8975','2013-09-20','11:10:00',5.27),('8975','2013-09-20','11:15:00',5.32),('8975','2013-09-20','11:20:00',5.32),('8975','2013-09-20','11:25:00',5.34),('8975','2013-09-20','11:30:00',5.36),('8975','2013-09-20','11:35:00',5.42),('8975','2013-09-20','11:40:00',5.41),('8975','2013-09-20','11:45:00',5.46),('8975','2013-09-20','11:50:00',5.57),('8975','2013-09-20','11:55:00',5.57),('8975','2013-09-20','12:00:00',5.57),('8975','2013-09-20','12:05:00',5.56),('8975','2013-09-20','12:10:00',5.28),('8975','2013-09-20','12:15:00',5.67),('8975','2013-09-20','12:20:00',5.09),('8975','2013-09-20','12:25:00',5.56),('8975','2013-09-20','12:30:00',5.61),('8975','2013-09-20','12:35:00',4.95),('8975','2013-09-20','12:40:00',3.74),('8975','2013-09-20','12:45:00',4.75),('8975','2013-09-20','12:50:00',4.77),('8975','2013-09-20','12:55:00',5.37),('8975','2013-09-20','13:00:00',5.24),('8975','2013-09-20','13:05:00',5.09),('8975','2013-09-20','13:10:00',5.1),('8975','2013-09-20','13:15:00',5.25),('8975','2013-09-20','13:20:00',4.87),('8975','2013-09-20','13:25:00',5.19),('8975','2013-09-20','13:30:00',4.89),('8975','2013-09-20','13:35:00',4.86),('8975','2013-09-20','13:40:00',4.99),('8975','2013-09-20','13:45:00',4.62),('8975','2013-09-20','13:50:00',4.64),('8975','2013-09-20','13:55:00',4.39),('8975','2013-09-20','14:00:00',4.78),('8975','2013-09-20','14:05:00',4.6),('8975','2013-09-20','14:10:00',4.62),('8975','2013-09-20','14:15:00',4.49),('8975','2013-09-20','14:20:00',4.56),('8975','2013-09-20','14:25:00',4.49),('8975','2013-09-20','14:30:00',4.39),('8975','2013-09-20','14:35:00',4.32),('8975','2013-09-20','14:40:00',4.22),('8975','2013-09-20','14:45:00',4.1),('8975','2013-09-20','14:50:00',3.99),('8975','2013-09-20','14:55:00',3.8),('8975','2013-09-20','15:00:00',3.7),('8975','2013-09-20','15:05:00',3.65),('8975','2013-09-20','15:10:00',3.57),('8975','2013-09-20','15:15:00',3.4),('8975','2013-09-20','15:20:00',3.37),('8975','2013-09-20','15:25:00',3.09),('8975','2013-09-20','15:30:00',3.02),('8975','2013-09-20','15:35:00',3.03),('8975','2013-09-20','15:40:00',2.95),('8975','2013-09-20','15:45:00',2.76),('8975','2013-09-20','15:50:00',2.3),('8975','2013-09-20','15:55:00',2.69),('8975','2013-09-20','16:00:00',1.75),('8975','2013-09-20','16:05:00',1.36),('8975','2013-09-20','16:10:00',1.44),('8975','2013-09-20','16:15:00',1.3),('8975','2013-09-20','16:20:00',1.7),('8975','2013-09-20','16:25:00',1.05),('8975','2013-09-20','16:30:00',1.09),('8975','2013-09-20','16:35:00',1.47),('8975','2013-09-20','16:40:00',1.2),('8975','2013-09-20','16:45:00',1.03),('8975','2013-09-20','16:50:00',1),('8975','2013-09-20','16:55:00',1.43),('8975','2013-09-20','17:05:00',1.1),('8975','2013-09-20','17:10:00',1.26),('8975','2013-09-20','17:15:00',1.17),('8975','2013-09-20','17:35:00',1.2),('8975','2013-09-20','17:40:00',1.03),('8975','2013-09-20','17:45:00',1.1),('8975','2013-09-19','08:25:00',1.13),('8975','2013-09-19','08:30:00',1.72),('8975','2013-09-19','08:35:00',1.98),('8975','2013-09-19','08:40:00',2.51),('8975','2013-09-19','08:45:00',1.91),('8975','2013-09-19','08:50:00',2.09),('8975','2013-09-19','08:55:00',1.96),('8975','2013-09-19','09:00:00',2.4),('8975','2013-09-19','09:05:00',3.45),('8975','2013-09-19','09:10:00',2.41),('8975','2013-09-19','09:15:00',1.92),('8975','2013-09-19','09:20:00',1.92),('8975','2013-09-19','09:25:00',1.9),('8975','2013-09-19','09:30:00',1.98),('8975','2013-09-19','09:35:00',2.04),('8975','2013-09-19','09:40:00',2.06),('8975','2013-09-19','09:45:00',1.99),('8975','2013-09-19','09:50:00',2.11),('8975','2013-09-19','09:55:00',2.34),('8975','2013-09-19','10:00:00',2.62),('8975','2013-09-19','10:05:00',3.01),('8975','2013-09-19','10:10:00',3.7),('8975','2013-09-19','10:15:00',3.78),('8975','2013-09-19','10:20:00',3.56),('8975','2013-09-19','10:25:00',3.54),('8975','2013-09-19','10:30:00',3.79),('8975','2013-09-19','10:35:00',5.13),('8975','2013-09-19','10:40:00',5.41),('8975','2013-09-19','10:45:00',5.17),('8975','2013-09-19','10:50:00',4.74),('8975','2013-09-19','10:55:00',4.61),('8975','2013-09-19','11:00:00',3.01),('8975','2013-09-19','11:05:00',3.42),('8975','2013-09-19','11:10:00',4.85),('8975','2013-09-19','11:15:00',3.9),('8975','2013-09-19','11:20:00',4.29),('8975','2013-09-19','11:25:00',5.01),('8975','2013-09-19','11:30:00',4.57),('8975','2013-09-19','11:35:00',6.85),('8975','2013-09-19','11:40:00',5.38),('8975','2013-09-19','11:45:00',6.06),('8975','2013-09-19','11:50:00',5.83),('8975','2013-09-19','11:55:00',5.75),('8975','2013-09-19','12:00:00',5.7),('8975','2013-09-19','12:05:00',5.69),('8975','2013-09-19','12:10:00',5.85),('8975','2013-09-19','12:15:00',5.67),('8975','2013-09-19','12:20:00',4.87),('8975','2013-09-19','12:25:00',3.76),('8975','2013-09-19','12:30:00',3.75),('8975','2013-09-19','12:35:00',5.22),('8975','2013-09-19','12:40:00',5.71),('8975','2013-09-19','12:45:00',5.33),('8975','2013-09-19','12:50:00',4.07),('8975','2013-09-19','12:55:00',5.75),('8975','2013-09-19','13:00:00',5.65),('8975','2013-09-19','13:05:00',5.54),('8975','2013-09-19','13:10:00',5.44),('8975','2013-09-19','13:15:00',3.72),('8975','2013-09-19','13:20:00',4.8),('8975','2013-09-19','13:25:00',5.79),('8975','2013-09-19','13:30:00',5.33),('8975','2013-09-19','13:35:00',5.54),('8975','2013-09-19','13:40:00',5.3),('8975','2013-09-19','13:45:00',3.2),('8975','2013-09-19','13:55:00',2.54),('8975','2013-09-19','14:00:00',4.4),('8975','2013-09-19','14:05:00',5.15),('8975','2013-09-19','14:10:00',5.26),('8975','2013-09-19','14:15:00',4.19),('8975','2013-09-19','14:20:00',1.61),('8975','2013-09-19','14:25:00',1.43),('8975','2013-09-19','14:30:00',1.43),('8975','2013-09-19','14:35:00',1.35),('8975','2013-09-19','14:40:00',3.27),('8975','2013-09-19','14:45:00',4.54),('8975','2013-09-19','14:50:00',4.5),('8975','2013-09-19','14:55:00',3.53),('8975','2013-09-19','15:00:00',1.84),('8975','2013-09-19','15:05:00',3.66),('8975','2013-09-19','15:10:00',4.07),('8975','2013-09-19','15:15:00',3.11),('8975','2013-09-19','15:20:00',2.18),('8975','2013-09-19','15:25:00',1.34),('8975','2013-09-19','15:30:00',1.64),('8975','2013-09-19','15:35:00',2.82),('8975','2013-09-19','15:40:00',3.26),('8975','2013-09-19','15:45:00',3.25),('8975','2013-09-19','15:50:00',3.11),('8975','2013-09-19','15:55:00',3.21),('8975','2013-09-19','16:00:00',2.31),('8975','2013-09-19','16:05:00',1.91),('8975','2013-09-19','16:10:00',1.56),('8975','2013-09-19','16:15:00',1.51),('8975','2013-09-19','16:20:00',1.8),('8975','2013-09-19','16:25:00',1.62),('8975','2013-09-19','16:30:00',1.84),('8975','2013-09-19','16:35:00',2.15),('8975','2013-09-19','16:40:00',2.29),('8975','2013-09-19','16:45:00',2.58),('8975','2013-09-19','16:50:00',1.74),('8975','2013-09-19','16:55:00',1.64),('8975','2013-09-19','17:00:00',1.73),('8975','2013-09-19','17:05:00',2.1),('8975','2013-09-19','17:10:00',1.72),('8975','2013-09-19','17:15:00',2.08),('8975','2013-09-19','17:20:00',2.05),('8975','2013-09-19','17:25:00',1.29),('8975','2013-09-19','17:30:00',1.09),('8975','2013-09-19','17:35:00',1.04),('8975','2013-09-19','17:40:00',1.38),('8975','2013-09-19','17:45:00',1.34),('8975','2013-09-19','17:50:00',1.36),('8975','2013-09-19','17:55:00',1.24),('8975','2013-09-19','18:00:00',1.31),('8975','2013-09-19','18:05:00',1.4),('8975','2013-09-19','18:10:00',1.29),('8975','2013-09-19','18:15:00',1.29),('8975','2013-09-19','18:20:00',1.09),('8975','2013-09-18','07:35:00',1.17),('8975','2013-09-18','07:40:00',1.12),('8975','2013-09-18','07:45:00',1.24),('8975','2013-09-18','08:10:00',1.98),('8975','2013-09-18','08:15:00',1.06),('8975','2013-09-18','08:20:00',1.65),('8975','2013-09-18','08:25:00',2.35),('8975','2013-09-18','08:30:00',2.79),('8975','2013-09-18','08:35:00',2.77),('8975','2013-09-18','08:40:00',2.29),('8975','2013-09-18','08:45:00',2.06),('8975','2013-09-18','08:50:00',2.09),('8975','2013-09-18','08:55:00',2.94),('8975','2013-09-18','09:00:00',2.82),('8975','2013-09-18','09:05:00',2.93),('8975','2013-09-18','09:10:00',2.66),('8975','2013-09-18','09:15:00',2.57),('8975','2013-09-18','09:20:00',3.41),('8975','2013-09-18','09:25:00',1.75),('8975','2013-09-18','09:30:00',1.23),('8975','2013-09-18','09:35:00',1.04),('8975','2013-09-18','09:40:00',1.72),('8975','2013-09-18','09:45:00',1.4),('8975','2013-09-18','09:50:00',1.44),('8975','2013-09-18','09:55:00',2.13),('8975','2013-09-18','10:00:00',1.59),('8975','2013-09-18','10:05:00',2.43),('8975','2013-09-18','10:10:00',3.18),('8975','2013-09-18','10:15:00',1.48),('8975','2013-09-18','10:20:00',2.34),('8975','2013-09-18','10:25:00',1.58),('8975','2013-09-18','10:30:00',1.67),('8975','2013-09-18','10:35:00',2.83),('8975','2013-09-18','10:40:00',2.79),('8975','2013-09-18','10:45:00',6.5),('8975','2013-09-18','10:50:00',4.29),('8975','2013-09-18','10:55:00',4.39),('8975','2013-09-18','11:00:00',5.08),('8975','2013-09-18','11:05:00',5.08),('8975','2013-09-18','11:10:00',3.67),('8975','2013-09-18','11:15:00',4.1),('8975','2013-09-18','11:20:00',5.09),('8975','2013-09-18','11:25:00',2.21),('8975','2013-09-18','11:30:00',5.23),('8975','2013-09-18','11:35:00',5.61),('8975','2013-09-18','11:40:00',5.64),('8975','2013-09-18','11:45:00',4.46),('8975','2013-09-18','11:50:00',4.73),('8975','2013-09-18','11:55:00',3.21),('8975','2013-09-18','12:00:00',2.79),('8975','2013-09-18','12:05:00',2.88),('8975','2013-09-18','12:10:00',1.98),('8975','2013-09-18','12:15:00',5.66),('8975','2013-09-18','12:20:00',2.37),('8975','2013-09-18','12:25:00',5.39),('8975','2013-09-18','12:30:00',6.19),('8975','2013-09-18','12:35:00',5.88),('8975','2013-09-18','12:40:00',4.44),('8975','2013-09-18','12:45:00',1.7),('8975','2013-09-18','12:50:00',2.72),('8975','2013-09-18','12:55:00',3.06),('8975','2013-09-18','13:00:00',3.22),('8975','2013-09-18','13:05:00',5.16),('8975','2013-09-18','13:10:00',3.48),('8975','2013-09-18','13:15:00',4.08),('8975','2013-09-18','13:20:00',4.06),('8975','2013-09-18','13:25:00',5.84),('8975','2013-09-18','13:30:00',4.69),('8975','2013-09-18','13:35:00',3.35),('8975','2013-09-18','13:40:00',5.8),('8975','2013-09-18','13:45:00',2.28),('8975','2013-09-18','13:50:00',5.39),('8975','2013-09-18','13:55:00',6),('8975','2013-09-18','14:00:00',5.23),('8975','2013-09-18','14:05:00',4.81),('8975','2013-09-18','14:10:00',4.04),('8975','2013-09-18','14:15:00',4.86),('8975','2013-09-18','14:20:00',4.56),('8975','2013-09-18','14:25:00',4.14),('8975','2013-09-18','14:30:00',4.51),('8975','2013-09-18','14:35:00',4.26),('8975','2013-09-18','14:40:00',4.34),('8975','2013-09-18','14:45:00',3.72),('8975','2013-09-18','14:50:00',3.6),('8975','2013-09-18','14:55:00',1.44),('8975','2013-09-18','15:00:00',3.39),('8975','2013-09-18','15:05:00',3.62),('8975','2013-09-18','15:10:00',3.27),('8975','2013-09-18','15:15:00',4.15),('8975','2013-09-18','15:20:00',3.86),('8975','2013-09-18','15:25:00',2.69),('8975','2013-09-18','15:30:00',2.33),('8975','2013-09-18','15:35:00',2.44),('8975','2013-09-18','15:40:00',2.54),('8975','2013-09-18','15:45:00',3.32),('8975','2013-09-18','15:50:00',3.05),('8975','2013-09-18','15:55:00',2.9),('8975','2013-09-18','16:00:00',2.39),('8975','2013-09-18','16:05:00',2.7),('8975','2013-09-18','16:10:00',2.31),('8975','2013-09-18','16:15:00',2.29),('8975','2013-09-18','16:20:00',2.39),('8975','2013-09-18','16:25:00',2.29),('8975','2013-09-18','16:30:00',2.11),('8975','2013-09-18','16:35:00',1.74),('8975','2013-09-18','16:40:00',1.91),('8975','2013-09-18','16:45:00',1.84),('8975','2013-09-18','16:50:00',1.67),('8975','2013-09-18','16:55:00',1.7),('8975','2013-09-18','17:00:00',1.37),('8975','2013-09-18','17:05:00',1.01),('8975','2013-09-18','17:10:00',1.48),('8975','2013-09-18','17:15:00',1.41),('8975','2013-09-18','17:20:00',1.38),('8975','2013-09-18','17:25:00',1.31),('8975','2013-09-18','17:30:00',1.31),('8975','2013-09-18','17:35:00',1.29),('8975','2013-09-18','17:40:00',1.16),('8975','2013-09-18','17:45:00',1.01),('8975','2013-09-18','17:50:00',1.1),('8975','2013-09-18','17:55:00',1.03),('8975','2014-04-12','08:35:00',1.08),('8975','2014-04-12','08:40:00',1.07),('8975','2014-04-12','08:45:00',1.03),('8975','2014-04-12','09:00:00',1.45),('8975','2014-04-12','09:05:00',1.87),('8975','2014-04-12','09:10:00',2.74),('8975','2014-04-12','09:15:00',2.46),('8975','2014-04-12','09:20:00',2.08),('8975','2014-04-12','09:25:00',2.28),('8975','2014-04-12','09:30:00',2.31),('8975','2014-04-12','09:35:00',3),('8975','2014-04-12','09:40:00',3.62),('8975','2014-04-12','09:45:00',3.83),('8975','2014-04-12','09:50:00',2.56),('8975','2014-04-12','09:55:00',2.45),('8975','2014-04-12','10:00:00',2.89),('8975','2014-04-12','10:05:00',4),('8975','2014-04-12','10:10:00',5.11),('8975','2014-04-12','10:15:00',3.62),('8975','2014-04-12','10:20:00',3.84),('8975','2014-04-12','10:25:00',3.16),('8975','2014-04-12','10:30:00',3.83),('8975','2014-04-12','10:35:00',6.25),('8975','2014-04-12','10:40:00',4.93),('8975','2014-04-12','10:45:00',6.14),('8975','2014-04-12','10:50:00',6.17),('8975','2014-04-12','10:55:00',6),('8975','2014-04-12','11:00:00',6.09),('8975','2014-04-12','11:05:00',6.25),('8975','2014-04-12','11:10:00',6.04),('8975','2014-04-12','11:15:00',6.23),('8975','2014-04-12','11:20:00',7.23),('8975','2014-04-12','11:25:00',6.68),('8975','2014-04-12','11:30:00',5.31),('8975','2014-04-12','11:35:00',4.67),('8975','2014-04-12','11:40:00',6.2),('8975','2014-04-12','11:45:00',5.95),('8975','2014-04-12','11:50:00',4.61),('8975','2014-04-12','11:55:00',3.54),('8975','2014-04-12','12:00:00',2.99),('8975','2014-04-12','12:05:00',2.82),('8975','2014-04-12','12:10:00',2.4),('8975','2014-04-12','12:15:00',2.45),('8975','2014-04-12','12:20:00',2.6),('8975','2014-04-12','12:25:00',1.97),('8975','2014-04-12','12:30:00',1.38),('8975','2014-04-12','12:50:00',1.09),('8975','2014-04-12','12:55:00',1.28),('8975','2014-04-12','13:00:00',1.41),('8975','2014-04-12','13:05:00',1.7),('8975','2014-04-12','13:10:00',2.69),('8975','2014-04-12','13:15:00',3.27),('8975','2014-04-12','13:20:00',3.32),('8975','2014-04-12','13:25:00',4.73),('8975','2014-04-12','13:30:00',6.74),('8975','2014-04-12','13:35:00',5.96),('8975','2014-04-12','13:40:00',6.56),('8975','2014-04-12','13:45:00',3.85),('8975','2014-04-12','13:50:00',4.48),('8975','2014-04-12','13:55:00',4.21),('8975','2014-04-12','14:00:00',5.25),('8975','2014-04-12','14:05:00',5.83),('8975','2014-04-12','14:10:00',6.17),('8975','2014-04-12','14:15:00',4.67),('8975','2014-04-12','14:20:00',3.62),('8975','2014-04-12','14:25:00',2.71),('8975','2014-04-12','14:30:00',3.49),('8975','2014-04-12','14:35:00',2.5),('8975','2014-04-12','14:40:00',1.92),('8975','2014-04-12','14:45:00',2.54),('8975','2014-04-12','14:50:00',4.97),('8975','2014-04-12','14:55:00',4.56),('8975','2014-04-12','15:00:00',2.49),('8975','2014-04-12','15:05:00',5.09),('8975','2014-04-12','15:10:00',5.18),('8975','2014-04-12','15:15:00',4.44),('8975','2014-04-12','15:20:00',4.04),('8975','2014-04-12','15:25:00',4.19),('8975','2014-04-12','15:30:00',4.16),('8975','2014-04-12','15:35:00',3),('8975','2014-04-12','15:40:00',2.36),('8975','2014-04-12','15:45:00',2.16),('8975','2014-04-12','15:50:00',2.41),('8975','2014-04-12','15:55:00',2.74),('8975','2014-04-12','16:00:00',3.78),('8975','2014-04-12','16:05:00',3.24),('8975','2014-04-12','16:10:00',1.86),('8975','2014-04-12','16:15:00',1.31),('8975','2014-04-12','16:20:00',1.61),('8975','2014-04-12','16:25:00',2.44),('8975','2014-04-12','16:30:00',2.56),('8975','2014-04-12','16:35:00',2.17),('8975','2014-04-12','16:40:00',2.15),('8975','2014-04-12','16:45:00',3.69),('8975','2014-04-12','16:50:00',3.57),('8975','2014-04-12','16:55:00',3.25),('8975','2014-04-12','17:00:00',3.22),('8975','2014-04-12','17:05:00',2.46),('8975','2014-04-12','17:10:00',1.61),('8975','2014-04-12','17:15:00',1.33),('8975','2014-04-12','17:20:00',1.73),('8975','2014-04-12','17:25:00',1.82),('8975','2014-04-12','17:30:00',1.52),('8975','2014-04-12','17:35:00',1.31),('8975','2014-04-12','17:40:00',1.06),('8975','2014-04-12','17:45:00',1.08),('8975','2014-04-12','17:50:00',1.16),('8975','2014-04-12','17:55:00',1.12),('8975','2014-04-12','18:00:00',1.44),('8975','2014-04-12','18:05:00',1.47),('8975','2014-04-12','18:10:00',1.13),('8975','2013-09-17','07:35:00',1.04),('8975','2013-09-17','07:40:00',1.2),('8975','2013-09-17','07:45:00',1.44),('8975','2013-09-17','07:50:00',1.66),('8975','2013-09-17','07:55:00',1.84),('8975','2013-09-17','08:00:00',2.04),('8975','2013-09-17','08:05:00',2.2),('8975','2013-09-17','08:10:00',1.68),('8975','2013-09-17','08:15:00',1.19),('8975','2013-09-17','08:20:00',1.3),('8975','2013-09-17','08:25:00',2.08),('8975','2013-09-17','08:30:00',2.48),('8975','2013-09-17','08:35:00',2.38),('8975','2013-09-17','08:40:00',1.9),('8975','2013-09-17','08:45:00',2.75),('8975','2013-09-17','08:50:00',2.82),('8975','2013-09-17','08:55:00',2.75),('8975','2013-09-17','09:00:00',2.07),('8975','2013-09-17','09:05:00',2.62),('8975','2013-09-17','09:10:00',3.3),('8975','2013-09-17','09:15:00',1.1),('8975','2013-09-17','09:20:00',1.23),('8975','2013-09-17','09:25:00',2.29),('8975','2013-09-17','09:30:00',4.79),('8975','2013-09-17','09:35:00',2.97),('8975','2013-09-17','09:40:00',4.94),('8975','2013-09-17','09:45:00',3.78),('8975','2013-09-17','09:50:00',5.02),('8975','2013-09-17','09:55:00',4.46),('8975','2013-09-17','10:00:00',4.57),('8975','2013-09-17','10:05:00',4.73),('8975','2013-09-17','10:10:00',4.75),('8975','2013-09-17','10:15:00',4.79),('8975','2013-09-17','10:20:00',4.89),('8975','2013-09-17','10:25:00',4.9),('8975','2013-09-17','10:30:00',4.97),('8975','2013-09-17','10:35:00',5),('8975','2013-09-17','10:40:00',5.03),('8975','2013-09-17','10:45:00',5.05),('8975','2013-09-17','10:50:00',5.29),('8975','2013-09-17','10:55:00',5.31),('8975','2013-09-17','11:00:00',5.28),('8975','2013-09-17','11:05:00',4.15),('8975','2013-09-17','11:10:00',1.09),('8975','2013-09-17','11:15:00',1.14),('8975','2013-09-17','11:20:00',4.44),('8975','2013-09-17','11:25:00',6.25),('8975','2013-09-17','11:30:00',5.33),('8975','2013-09-17','11:35:00',2.83),('8975','2013-09-17','11:40:00',2.04),('8975','2013-09-17','11:45:00',6.06),('8975','2013-09-17','11:50:00',5.96),('8975','2013-09-17','11:55:00',5.88),('8975','2013-09-17','12:00:00',5.7),('8975','2013-09-17','12:05:00',5.98),('8975','2013-09-17','12:10:00',5.18),('8975','2013-09-17','12:15:00',2.53),('8975','2013-09-17','12:20:00',5.62),('8975','2013-09-17','12:25:00',5.9),('8975','2013-09-17','12:30:00',6.06),('8975','2013-09-17','12:35:00',4),('8975','2013-09-17','12:40:00',3.07),('8975','2013-09-17','12:45:00',1.51),('8975','2013-09-17','12:50:00',3.7),('8975','2013-09-17','12:55:00',1.84),('8975','2013-09-17','13:00:00',2.04),('8975','2013-09-17','13:05:00',4.3),('8975','2013-09-17','13:10:00',5.99),('8975','2013-09-17','13:15:00',4.12),('8975','2013-09-17','13:20:00',5.75),('8975','2013-09-17','13:25:00',1.66),('8975','2013-09-17','13:30:00',2.73),('8975','2013-09-17','13:35:00',2.3),('8975','2013-09-17','13:40:00',2.8),('8975','2013-09-17','13:45:00',4.37),('8975','2013-09-17','13:50:00',3.69),('8975','2013-09-17','13:55:00',4.79),('8975','2013-09-17','14:00:00',5.59),('8975','2013-09-17','14:05:00',5.5),('8975','2013-09-17','14:10:00',3.41),('8975','2013-09-17','14:15:00',4.61),('8975','2013-09-17','14:20:00',4.99),('8975','2013-09-17','14:25:00',4.7),('8975','2013-09-17','14:30:00',4.69),('8975','2013-09-17','14:35:00',4.65),('8975','2013-09-17','14:40:00',4.41),('8975','2013-09-17','14:45:00',4.56),('8975','2013-09-17','14:50:00',3.91),('8975','2013-09-17','14:55:00',4.27),('8975','2013-09-17','15:00:00',3.06),('8975','2013-09-17','15:05:00',3.16),('8975','2013-09-17','15:10:00',3.4),('8975','2013-09-17','15:15:00',3.96),('8975','2013-09-17','15:20:00',1.64),('8975','2013-09-17','15:25:00',2.95),('8975','2013-09-17','15:30:00',3.65),('8975','2013-09-17','15:35:00',3.28),('8975','2013-09-17','15:40:00',3.12),('8975','2013-09-17','15:45:00',3),('8975','2013-09-17','15:50:00',3.1),('8975','2013-09-17','15:55:00',2.91),('8975','2013-09-17','16:00:00',3),('8975','2013-09-17','16:05:00',2.85),('8975','2013-09-17','16:10:00',2.62),('8975','2013-09-17','16:15:00',2.51),('8975','2013-09-17','16:20:00',2.34),('8975','2013-09-17','16:25:00',2.1),('8975','2013-09-17','16:30:00',2.07),('8975','2013-09-17','16:35:00',1.77),('8975','2013-09-17','16:40:00',1.79),('8975','2013-09-17','16:45:00',1.85),('8975','2013-09-17','16:50:00',1.72),('8975','2013-09-17','16:55:00',1.57),('8975','2013-09-17','17:00:00',1.56),('8975','2013-09-17','17:05:00',1.57),('8975','2013-09-17','17:10:00',1.54),('8975','2013-09-17','17:15:00',1.54),('8975','2013-09-17','17:20:00',1.48),('8975','2013-09-17','17:25:00',1.44),('8975','2013-09-17','17:30:00',1.37),('8975','2013-09-17','17:35:00',1.29),('8975','2013-09-17','17:40:00',1.23),('8975','2013-09-17','17:45:00',1.18),('8975','2013-09-17','17:50:00',1.12),('8975','2013-09-17','17:55:00',1.03),('8975','2013-09-16','08:40:00',1.08),('8975','2013-09-16','08:45:00',1.12),('8975','2013-09-16','08:50:00',1.11),('8975','2013-09-16','08:55:00',1.17),('8975','2013-09-16','09:00:00',1.01),('8975','2013-09-16','09:10:00',1),('8975','2013-09-16','09:15:00',1.7),('8975','2013-09-16','09:20:00',3.07),('8975','2013-09-16','09:25:00',1.85),('8975','2013-09-16','09:30:00',2.14),('8975','2013-09-16','09:35:00',1.52),('8975','2013-09-16','09:40:00',1.62),('8975','2013-09-16','09:45:00',2.6),('8975','2013-09-16','09:50:00',1.36),('8975','2013-09-16','09:55:00',3.13),('8975','2013-09-16','10:00:00',4.31),('8975','2013-09-16','10:05:00',2.21),('8975','2013-09-16','10:10:00',3.08),('8975','2013-09-16','10:15:00',1.59),('8975','2013-09-16','10:20:00',4.35),('8975','2013-09-16','10:25:00',4.67),('8975','2013-09-16','10:30:00',3.43),('8975','2013-09-16','10:35:00',2.05),('8975','2013-09-16','10:40:00',1.62),('8975','2013-09-16','10:45:00',2.86),('8975','2013-09-16','10:50:00',5.47),('8975','2013-09-16','10:55:00',4.71),('8975','2013-09-16','11:00:00',4.41),('8975','2013-09-16','11:05:00',3.62),('8975','2013-09-16','11:10:00',5.79),('8975','2013-09-16','11:15:00',3.93),('8975','2013-09-16','11:20:00',4.08),('8975','2013-09-16','11:25:00',2.6),('8975','2013-09-16','11:30:00',3.23),('8975','2013-09-16','11:35:00',4.52),('8975','2013-09-16','11:40:00',3.99),('8975','2013-09-16','11:45:00',3.14),('8975','2013-09-16','11:50:00',5.18),('8975','2013-09-16','11:55:00',3.83),('8975','2013-09-16','12:00:00',4.06),('8975','2013-09-16','12:05:00',5.9),('8975','2013-09-16','12:10:00',3.12),('8975','2013-09-16','12:15:00',2.99),('8975','2013-09-16','12:20:00',3.25),('8975','2013-09-16','12:25:00',6.04),('8975','2013-09-16','12:30:00',6.3),('8975','2013-09-16','12:35:00',4.91),('8975','2013-09-16','12:40:00',5.27),('8975','2013-09-16','12:45:00',6.02),('8975','2013-09-16','12:50:00',5.37),('8975','2013-09-16','12:55:00',4.13),('8975','2013-09-16','13:00:00',2.16),('8975','2013-09-16','13:05:00',1.8),('8975','2013-09-16','13:10:00',4.62),('8975','2013-09-16','13:15:00',3.84),('8975','2013-09-16','13:20:00',3.27),('8975','2013-09-16','13:25:00',2.9),('8975','2013-09-16','13:30:00',2.45),('8975','2013-09-16','13:35:00',4),('8975','2013-09-16','13:40:00',3.17),('8975','2013-09-16','13:45:00',2.42),('8975','2013-09-16','13:50:00',2.29),('8975','2013-09-16','13:55:00',3.56),('8975','2013-09-16','14:00:00',3.16),('8975','2013-09-16','14:05:00',2.27),('8975','2013-09-16','14:10:00',1.43),('8975','2013-09-16','14:15:00',1.75),('8975','2013-09-16','14:20:00',1.67),('8975','2013-09-16','14:25:00',3.01),('8975','2013-09-16','14:30:00',1.78),('8975','2013-09-16','14:35:00',1.63),('8975','2013-09-16','14:40:00',1.21),('8975','2013-09-16','14:45:00',1.5),('8975','2013-09-16','14:50:00',3.2),('8975','2013-09-16','14:55:00',5.02),('8975','2013-09-16','15:00:00',3.83),('8975','2013-09-16','15:05:00',3.73),('8975','2013-09-16','15:10:00',3.07),('8975','2013-09-16','15:15:00',2.1),('8975','2013-09-16','15:20:00',3.48),('8975','2013-09-16','15:25:00',2.72),('8975','2013-09-16','15:30:00',2.21),('8975','2013-09-16','15:35:00',2.57),('8975','2013-09-16','15:40:00',1.44),('8975','2013-09-16','15:45:00',1.5),('8975','2013-09-16','15:50:00',2),('8975','2013-09-16','15:55:00',2.06),('8975','2013-09-16','16:00:00',1.66),('8975','2013-09-16','16:05:00',2.37),('8975','2013-09-16','16:10:00',2.21),('8975','2013-09-16','16:15:00',2.64),('8975','2013-09-16','16:20:00',1.33),('8975','2013-09-16','16:35:00',1.11),('8975','2013-09-16','16:40:00',1.8),('8975','2013-09-16','16:45:00',1.87),('8975','2013-09-16','16:50:00',1.71),('8975','2013-09-16','16:55:00',1.46),('8975','2013-09-16','17:00:00',1.93),('8975','2013-09-16','17:05:00',2.1),('8975','2013-09-16','17:10:00',1.97),('8975','2013-09-16','17:15:00',1.89),('8975','2013-09-16','17:20:00',1.89),('8975','2013-09-16','17:25:00',1.95),('8975','2013-09-16','17:30:00',1.89),('8975','2013-09-16','17:35:00',1.85),('8975','2013-09-16','17:40:00',1.33),('8975','2013-09-16','17:55:00',1.18),('8975','2013-09-15','08:05:00',2.02),('8975','2013-09-15','08:10:00',2.78),('8975','2013-09-15','08:15:00',2.8),('8975','2013-09-15','08:20:00',2.78),('8975','2013-09-15','08:25:00',2.92),('8975','2013-09-15','08:30:00',3.08),('8975','2013-09-15','08:35:00',3.28),('8975','2013-09-15','08:40:00',3.58),('8975','2013-09-15','08:45:00',2.66),('8975','2013-09-15','08:50:00',3.59),('8975','2013-09-15','08:55:00',3.68),('8975','2013-09-15','09:00:00',3.56),('8975','2013-09-15','09:05:00',2.58),('8975','2013-09-15','09:10:00',3.93),('8975','2013-09-15','09:15:00',3.84),('8975','2013-09-15','09:20:00',3.95),('8975','2013-09-15','09:25:00',3.84),('8975','2013-09-15','09:30:00',4.27),('8975','2013-09-15','09:35:00',3.01),('8975','2013-09-15','09:40:00',4.22),('8975','2013-09-15','09:45:00',2.97),('8975','2013-09-15','09:50:00',4.34),('8975','2013-09-15','09:55:00',4.68),('8975','2013-09-15','10:00:00',4.71),('8975','2013-09-15','10:05:00',4.02),('8975','2013-09-15','10:10:00',5.09),('8975','2013-09-15','10:15:00',1.64),('8975','2013-09-15','10:30:00',2.79),('8975','2013-09-15','10:35:00',5.79),('8975','2013-09-15','10:40:00',4.29),('8975','2013-09-15','10:45:00',2.73),('8975','2013-09-15','10:50:00',6.66),('8975','2013-09-15','10:55:00',6.1),('8975','2013-09-15','11:00:00',4.89),('8975','2013-09-15','11:05:00',6.78),('8975','2013-09-15','11:10:00',6.53),('8975','2013-09-15','11:15:00',2.82),('8975','2013-09-15','11:20:00',2.16),('8975','2013-09-15','11:25:00',1.03),('8975','2013-09-15','11:35:00',4.89),('8975','2013-09-15','11:40:00',6.13),('8975','2013-09-15','11:45:00',4.16),('8975','2013-09-15','11:50:00',6.18),('8975','2013-09-15','11:55:00',3.51),('8975','2013-09-15','12:00:00',2.02),('8975','2013-09-15','12:05:00',5.69),('8975','2013-09-15','12:10:00',6.55),('8975','2013-09-15','12:15:00',6.32),('8975','2013-09-15','12:20:00',6.05),('8975','2013-09-15','12:25:00',6.04),('8975','2013-09-15','12:30:00',5.9),('8975','2013-09-15','12:35:00',5.97),('8975','2013-09-15','12:40:00',6.11),('8975','2013-09-15','12:45:00',4.01),('8975','2013-09-15','12:50:00',1.48),('8975','2013-09-15','12:55:00',2.85),('8975','2013-09-15','13:00:00',1.85),('8975','2013-09-15','13:05:00',4.69),('8975','2013-09-15','13:10:00',5.84),('8975','2013-09-15','13:15:00',5.95),('8975','2013-09-15','13:20:00',5.66),('8975','2013-09-15','13:25:00',5.58),('8975','2013-09-15','13:30:00',5.54),('8975','2013-09-15','13:35:00',5.48),('8975','2013-09-15','13:40:00',5.47),('8975','2013-09-15','13:45:00',5.26),('8975','2013-09-15','13:50:00',5.43),('8975','2013-09-15','13:55:00',3.35),('8975','2013-09-15','14:00:00',5.37),('8975','2013-09-15','14:05:00',5.2),('8975','2013-09-15','14:10:00',5.04),('8975','2013-09-15','14:15:00',4.86),('8975','2013-09-15','14:20:00',4.86),('8975','2013-09-15','14:25:00',4.78),('8975','2013-09-15','14:30:00',4.7),('8975','2013-09-15','14:35:00',4.6),('8975','2013-09-15','14:40:00',4.48),('8975','2013-09-15','14:45:00',4.36),('8975','2013-09-15','14:50:00',3.91),('8975','2013-09-15','14:55:00',3.35),('8975','2013-09-15','15:00:00',4.16),('8975','2013-09-15','15:05:00',3.97),('8975','2013-09-15','15:10:00',3.87),('8975','2013-09-15','15:15:00',3.86),('8975','2013-09-15','15:20:00',3.74),('8975','2013-09-15','15:25:00',3.61),('8975','2013-09-15','15:30:00',3.46),('8975','2013-09-15','15:35:00',3.3),('8975','2013-09-15','15:40:00',3.07),('8975','2013-09-15','15:45:00',3.09),('8975','2013-09-15','15:50:00',3.03),('8975','2013-09-15','15:55:00',2.95),('8975','2013-09-15','16:00:00',2.93),('8975','2013-09-15','16:05:00',2.43),('8975','2013-09-15','16:10:00',2.67),('8975','2013-09-15','16:15:00',2.52),('8975','2013-09-15','16:20:00',2.42),('8975','2013-09-15','16:25:00',2.31),('8975','2013-09-15','16:30:00',2.2),('8975','2013-09-15','16:35:00',2.08),('8975','2013-09-15','16:40:00',2),('8975','2013-09-15','16:45:00',1.9),('8975','2013-09-15','16:50:00',1.81),('8975','2013-09-15','16:55:00',1.74),('8975','2013-09-15','17:00:00',1.66),('8975','2013-09-15','17:05:00',1.6),('8975','2013-09-15','17:10:00',1.53),('8975','2013-09-15','17:15:00',1.48),('8975','2013-09-15','17:20:00',1.4),('8975','2013-09-15','17:30:00',1.46),('8975','2013-09-15','17:35:00',1.38),('8975','2013-09-15','17:40:00',1.35),('8975','2013-09-15','17:45:00',1.27),('8975','2013-09-15','17:50:00',1.12),('8975','2013-09-15','17:55:00',1.12),('8975','2013-09-15','18:00:00',1.06),('8975','2013-09-15','18:05:00',1.01),('8975','2013-09-14','07:25:00',1.16),('8975','2013-09-14','07:35:00',1.68),('8975','2013-09-14','07:40:00',1.72),('8975','2013-09-14','07:45:00',1.84),('8975','2013-09-14','07:50:00',2.03),('8975','2013-09-14','07:55:00',2.26),('8975','2013-09-14','08:00:00',2.42),('8975','2013-09-14','08:05:00',2.56),('8975','2013-09-14','08:10:00',2.7),('8975','2013-09-14','08:15:00',2.85),('8975','2013-09-14','08:20:00',2.96),('8975','2013-09-14','08:25:00',3.08),('8975','2013-09-14','08:30:00',3.18),('8975','2013-09-14','08:35:00',3.31),('8975','2013-09-14','08:40:00',3.44),('8975','2013-09-14','08:45:00',3.55),('8975','2013-09-14','08:50:00',3.5),('8975','2013-09-14','08:55:00',3.25),('8975','2013-09-14','09:00:00',3.48),('8975','2013-09-14','09:05:00',3.49),('8975','2013-09-14','09:10:00',3.8),('8975','2013-09-14','09:15:00',4.07),('8975','2013-09-14','09:20:00',3.96),('8975','2013-09-14','09:25:00',4.16),('8975','2013-09-14','09:30:00',4.08),('8975','2013-09-14','09:35:00',4.36),('8975','2013-09-14','09:40:00',4.45),('8975','2013-09-14','09:45:00',4.45),('8975','2013-09-14','09:50:00',4.39),('8975','2013-09-14','09:55:00',4.7),('8975','2013-09-14','10:00:00',4.74),('8975','2013-09-14','10:05:00',4.81),('8975','2013-09-14','10:10:00',4.84),('8975','2013-09-14','10:15:00',4.89),('8975','2013-09-14','10:20:00',4.89),('8975','2013-09-14','10:25:00',5.06),('8975','2013-09-14','10:30:00',4.99),('8975','2013-09-14','10:35:00',2.13),('8975','2013-09-14','10:40:00',1.61),('8975','2013-09-14','10:45:00',1.53),('8975','2013-09-14','10:50:00',1.02),('8975','2013-09-14','10:55:00',3.9),('8975','2013-09-14','11:00:00',2.62),('8975','2013-09-14','11:05:00',2.11),('8975','2013-09-14','11:10:00',4.16),('8975','2013-09-14','11:15:00',1.74),('8975','2013-09-14','11:20:00',1.38),('8975','2013-09-14','11:25:00',1.36),('8975','2013-09-14','11:30:00',4.08),('8975','2013-09-14','11:35:00',2.31),('8975','2013-09-14','11:40:00',2.04),('8975','2013-09-14','11:45:00',3.46),('8975','2013-09-14','11:50:00',3.87),('8975','2013-09-14','11:55:00',2.99),('8975','2013-09-14','12:00:00',2.34),('8975','2013-09-14','12:05:00',2.02),('8975','2013-09-14','12:10:00',2.09),('8975','2013-09-14','12:15:00',2.35),('8975','2013-09-14','12:20:00',2.61),('8975','2013-09-14','12:25:00',2.69),('8975','2013-09-14','12:30:00',2.85),('8975','2013-09-14','12:35:00',3.44),('8975','2013-09-14','12:40:00',2.99),('8975','2013-09-14','12:45:00',2.83),('8975','2013-09-14','12:50:00',2.02),('8975','2013-09-14','12:55:00',1.9),('8975','2013-09-14','13:00:00',1.76),('8975','2013-09-14','13:05:00',1.37),('8975','2013-09-14','13:10:00',1.01),('8975','2013-09-14','13:20:00',1.35),('8975','2013-09-14','13:25:00',2.36),('8975','2013-09-14','13:30:00',2.01),('8975','2013-09-14','13:35:00',2.02),('8975','2013-09-14','13:40:00',2.01),('8975','2013-09-14','13:45:00',2.84),('8975','2013-09-14','13:50:00',3.18),('8975','2013-09-14','13:55:00',2.28),('8975','2013-09-14','14:00:00',3.04),('8975','2013-09-14','14:05:00',2.62),('8975','2013-09-14','14:10:00',2.17),('8975','2013-09-14','14:15:00',2.41),('8975','2013-09-14','14:20:00',2.32),('8975','2013-09-14','14:25:00',2.17),('8975','2013-09-14','14:30:00',1.99),('8975','2013-09-14','14:35:00',1.63),('8975','2013-09-14','14:40:00',1.53),('8975','2013-09-14','14:45:00',1.62),('8975','2013-09-14','14:50:00',1.67),('8975','2013-09-14','14:55:00',1.69),('8975','2013-09-14','15:00:00',1.73),('8975','2013-09-14','15:05:00',1.85),('8975','2013-09-14','15:10:00',2.07),('8975','2013-09-14','15:15:00',3.76),('8975','2013-09-14','15:20:00',3.16),('8975','2013-09-14','15:25:00',2.41),('8975','2013-09-14','15:30:00',1.87),('8975','2013-09-14','15:35:00',1.79),('8975','2013-09-14','15:40:00',1.62),('8975','2013-09-14','15:45:00',1.59),('8975','2013-09-14','15:50:00',1.59),('8975','2013-09-14','15:55:00',1.6),('8975','2013-09-14','16:00:00',1.43),('8975','2013-09-14','16:05:00',1.57),('8975','2013-09-14','16:10:00',1.21),('8975','2013-09-14','16:35:00',1.06),('8975','2013-09-14','16:40:00',1.26),('8975','2013-09-14','17:15:00',1.09),('8975','2013-09-14','17:20:00',1.29),('8975','2013-09-14','18:00:00',1.14),('8975','2013-09-13','07:25:00',1.08),('8975','2013-09-13','07:30:00',1.19),('8975','2013-09-13','07:35:00',1.41),('8975','2013-09-13','07:40:00',1.58),('8975','2013-09-13','07:45:00',1.66),('8975','2013-09-13','07:50:00',1.84),('8975','2013-09-13','07:55:00',2.1),('8975','2013-09-13','08:00:00',2.31),('8975','2013-09-13','08:05:00',2.42),('8975','2013-09-13','08:10:00',2.57),('8975','2013-09-13','08:15:00',2.71),('8975','2013-09-13','08:20:00',2.82),('8975','2013-09-13','08:25:00',2.94),('8975','2013-09-13','08:30:00',3.06),('8975','2013-09-13','08:35:00',3.16),('8975','2013-09-13','08:40:00',3.27),('8975','2013-09-13','08:45:00',3.36),('8975','2013-09-13','08:50:00',3.46),('8975','2013-09-13','08:55:00',3.55),('8975','2013-09-13','09:00:00',3.66),('8975','2013-09-13','09:05:00',3.75),('8975','2013-09-13','09:10:00',3.83),('8975','2013-09-13','09:15:00',3.93),('8975','2013-09-13','09:20:00',4.03),('8975','2013-09-13','09:25:00',4.13),('8975','2013-09-13','09:30:00',4.16),('8975','2013-09-13','09:35:00',4.27),('8975','2013-09-13','09:40:00',4.32),('8975','2013-09-13','09:45:00',4.36),('8975','2013-09-13','09:50:00',4.49),('8975','2013-09-13','09:55:00',4.49),('8975','2013-09-13','10:00:00',4.57),('8975','2013-09-13','10:05:00',4.55),('8975','2013-09-13','10:10:00',4.02),('8975','2013-09-13','10:15:00',4.57),('8975','2013-09-13','10:20:00',4.35),('8975','2013-09-13','10:25:00',4.88),('8975','2013-09-13','10:30:00',4.85),('8975','2013-09-13','10:35:00',5.32),('8975','2013-09-13','10:40:00',4.42),('8975','2013-09-13','10:45:00',3.9),('8975','2013-09-13','10:50:00',6.32),('8975','2013-09-13','10:55:00',6.31),('8975','2013-09-13','11:00:00',5.97),('8975','2013-09-13','11:05:00',6.02),('8975','2013-09-13','11:10:00',3),('8975','2013-09-13','11:20:00',1.03),('8975','2013-09-13','11:35:00',1.52),('8975','2013-09-13','11:40:00',2.07),('8975','2013-09-13','11:45:00',1.59),('8975','2013-09-13','11:50:00',2.79),('8975','2013-09-13','11:55:00',7.07),('8975','2013-09-13','12:00:00',6.97),('8975','2013-09-13','12:05:00',6.36),('8975','2013-09-13','12:10:00',5.86),('8975','2013-09-13','12:15:00',3.16),('8975','2013-09-13','12:20:00',4.1),('8975','2013-09-13','12:25:00',1.03),('8975','2013-09-13','12:30:00',1.98),('8975','2013-09-13','12:35:00',4.56),('8975','2013-09-13','12:40:00',1.75),('8975','2013-09-13','12:45:00',3.61),('8975','2013-09-13','12:50:00',1.33),('8975','2013-09-13','12:55:00',1.33),('8975','2013-09-13','13:00:00',1.16),('8975','2013-09-13','13:05:00',1.21),('8975','2013-09-13','13:10:00',1.72),('8975','2013-09-13','13:15:00',2.27),('8975','2013-09-13','13:20:00',5.33),('8975','2013-09-13','13:25:00',3.21),('8975','2013-09-13','13:30:00',2.41),('8975','2013-09-13','13:35:00',4.06),('8975','2013-09-13','13:40:00',4.11),('8975','2013-09-13','13:45:00',3.89),('8975','2013-09-13','13:50:00',6.94),('8975','2013-09-13','13:55:00',6.21),('8975','2013-09-13','14:00:00',5.68),('8975','2013-09-13','14:05:00',5),('8975','2013-09-13','14:10:00',5.27),('8975','2013-09-13','14:15:00',5.08),('8975','2013-09-13','14:20:00',5.12),('8975','2013-09-13','14:25:00',4.12),('8975','2013-09-13','14:30:00',1.38),('8975','2013-09-13','14:35:00',4.15),('8975','2013-09-13','14:40:00',4.86),('8975','2013-09-13','14:45:00',4.69),('8975','2013-09-13','14:50:00',4.57),('8975','2013-09-13','14:55:00',4.4),('8975','2013-09-13','15:00:00',4.16),('8975','2013-09-13','15:05:00',4),('8975','2013-09-13','15:10:00',3.93),('8975','2013-09-13','15:15:00',3.84),('8975','2013-09-13','15:20:00',3.76),('8975','2013-09-13','15:25:00',3.92),('8975','2013-09-13','15:30:00',3.7),('8975','2013-09-13','15:35:00',3.44),('8975','2013-09-13','15:40:00',3.27),('8975','2013-09-13','15:45:00',3.26),('8975','2013-09-13','15:50:00',3.13),('8975','2013-09-13','15:55:00',3.03),('8975','2013-09-13','16:00:00',2.91),('8975','2013-09-13','16:05:00',2.81),('8975','2013-09-13','16:10:00',2.67),('8975','2013-09-13','16:15:00',2.58),('8975','2013-09-13','16:20:00',2.25),('8975','2013-09-13','16:25:00',2.27),('8975','2013-09-13','16:30:00',2.29),('8975','2013-09-13','16:35:00',2.14),('8975','2013-09-13','16:40:00',2.05),('8975','2013-09-13','16:45:00',1.99),('8975','2013-09-13','16:50:00',1.66),('8975','2013-09-13','16:55:00',1.86),('8975','2013-09-13','17:00:00',1.73),('8975','2013-09-13','17:05:00',1.33),('8975','2013-09-13','17:10:00',1.5),('8975','2013-09-13','17:15:00',1.43),('8975','2013-09-13','17:20:00',1.34),('8975','2013-09-13','17:25:00',1.14),('8975','2013-09-13','17:30:00',1.39),('8975','2013-09-13','17:35:00',1.29),('8975','2013-09-13','17:40:00',1.29),('8975','2013-09-13','17:50:00',1.15),('8975','2013-09-13','17:55:00',1.1),('8975','2013-09-13','18:00:00',1.07),('8975','2013-09-12','08:15:00',1.23),('8975','2013-09-12','08:20:00',1.28),('8975','2013-09-12','08:25:00',1.62),('8975','2013-09-12','08:30:00',1.58),('8975','2013-09-12','08:35:00',1.29),('8975','2013-09-12','08:40:00',1.32),('8975','2013-09-12','08:45:00',1.5),('8975','2013-09-12','08:50:00',1.59),('8975','2013-09-12','08:55:00',1.72),('8975','2013-09-12','09:00:00',1.86),('8975','2013-09-12','09:05:00',1.89),('8975','2013-09-12','09:10:00',1.85),('8975','2013-09-12','09:15:00',1.96),('8975','2013-09-12','09:20:00',1.87),('8975','2013-09-12','09:25:00',2.1),('8975','2013-09-12','09:30:00',2.19),('8975','2013-09-12','09:35:00',2.29),('8975','2013-09-12','09:40:00',2.86),('8975','2013-09-12','09:45:00',3.4),('8975','2013-09-12','09:50:00',3.45),('8975','2013-09-12','09:55:00',4.67),('8975','2013-09-12','10:00:00',4.39),('8975','2013-09-12','10:05:00',3.81),('8975','2013-09-12','10:10:00',5.8),('8975','2013-09-12','10:15:00',6.05),('8975','2013-09-12','10:20:00',5.76),('8975','2013-09-12','10:25:00',4.87),('8975','2013-09-12','10:30:00',5.05),('8975','2013-09-12','10:35:00',5.07),('8975','2013-09-12','10:40:00',5.29),('8975','2013-09-12','10:45:00',5.28),('8975','2013-09-12','10:50:00',5.4),('8975','2013-09-12','10:55:00',5.4),('8975','2013-09-12','11:00:00',5.48),('8975','2013-09-12','11:05:00',5.52),('8975','2013-09-12','11:10:00',5.57),('8975','2013-09-12','11:15:00',5.57),('8975','2013-09-12','11:20:00',5.62),('8975','2013-09-12','11:25:00',5.71),('8975','2013-09-12','11:30:00',5.73),('8975','2013-09-12','11:35:00',5.79),('8975','2013-09-12','11:40:00',5.71),('8975','2013-09-12','11:45:00',5.76),('8975','2013-09-12','11:50:00',5.88),('8975','2013-09-12','11:55:00',5.81),('8975','2013-09-12','12:00:00',5.82),('8975','2013-09-12','12:05:00',5.86),('8975','2013-09-12','12:10:00',5.87),('8975','2013-09-12','12:15:00',5.91),('8975','2013-09-12','12:20:00',5.97),('8975','2013-09-12','12:25:00',6),('8975','2013-09-12','12:30:00',6.03),('8975','2013-09-12','12:35:00',6.09),('8975','2013-09-12','12:40:00',3.43),('8975','2013-09-12','12:45:00',5.34),('8975','2013-09-12','12:50:00',6.01),('8975','2013-09-12','12:55:00',5.88),('8975','2013-09-12','13:00:00',5.85),('8975','2013-09-12','13:05:00',5.75),('8975','2013-09-12','13:10:00',5.69),('8975','2013-09-12','13:15:00',5.67),('8975','2013-09-12','13:20:00',5.33),('8975','2013-09-12','13:25:00',5.56),('8975','2013-09-12','13:30:00',5.54),('8975','2013-09-12','13:35:00',5.47),('8975','2013-09-12','13:40:00',5.43),('8975','2013-09-12','13:45:00',5.31),('8975','2013-09-12','13:50:00',5.17),('8975','2013-09-12','13:55:00',5.22),('8975','2013-09-12','14:00:00',5.16),('8975','2013-09-12','14:05:00',5.11),('8975','2013-09-12','14:10:00',5.04),('8975','2013-09-12','14:15:00',4.7),('8975','2013-09-12','14:20:00',4.43),('8975','2013-09-12','14:25:00',4.47),('8975','2013-09-12','14:30:00',4.67),('8975','2013-09-12','14:35:00',4.46),('8975','2013-09-12','14:40:00',4.54),('8975','2013-09-12','14:45:00',4.57),('8975','2013-09-12','14:50:00',4.38),('8975','2013-09-12','14:55:00',4.48),('8975','2013-09-12','15:00:00',3.85),('8975','2013-09-12','15:05:00',3.46),('8975','2013-09-12','15:10:00',3.87),('8975','2013-09-12','15:15:00',3.88),('8975','2013-09-12','15:20:00',3.81),('8975','2013-09-12','15:25:00',3.74),('8975','2013-09-12','15:30:00',3.65),('8975','2013-09-12','15:35:00',3.51),('8975','2013-09-12','15:40:00',3.26),('8975','2013-09-12','15:45:00',3.26),('8975','2013-09-12','15:50:00',3.16),('8975','2013-09-12','15:55:00',3.06),('8975','2013-09-12','16:00:00',2.98),('8975','2013-09-12','16:05:00',2.89),('8975','2013-09-12','16:10:00',2.74),('8975','2013-09-12','16:15:00',2.63),('8975','2013-09-12','16:20:00',2.56),('8975','2013-09-12','16:25:00',2.45),('8975','2013-09-12','16:30:00',2.34),('8975','2013-09-12','16:35:00',2.22),('8975','2013-09-12','16:40:00',2.11),('8975','2013-09-12','16:45:00',2.01),('8975','2013-09-12','16:50:00',1.91),('8975','2013-09-12','16:55:00',1.83),('8975','2013-09-12','17:00:00',1.75),('8975','2013-09-12','17:05:00',1.67),('8975','2013-09-12','17:10:00',1.59),('8975','2013-09-12','17:15:00',1.52),('8975','2013-09-12','17:20:00',1.47),('8975','2013-09-12','17:25:00',1.43),('8975','2013-09-12','17:30:00',1.39),('8975','2013-09-12','17:35:00',1.35),('8975','2013-09-12','17:40:00',1.3),('8975','2013-09-12','17:45:00',1.25),('8975','2013-09-12','17:50:00',1.21),('8975','2013-09-12','17:55:00',1.16),('8975','2013-09-12','18:00:00',1.1),('8975','2013-09-12','18:05:00',1.04),('8975','2013-09-11','07:25:00',1.02),('8975','2013-09-11','07:30:00',1.35),('8975','2013-09-11','07:35:00',1.34),('8975','2013-09-11','07:40:00',1.42),('8975','2013-09-11','07:45:00',1.12),('8975','2013-09-11','07:50:00',1.28),('8975','2013-09-11','07:55:00',1.72),('8975','2013-09-11','08:00:00',1.5),('8975','2013-09-11','08:05:00',1.01),('8975','2013-09-11','08:10:00',2.14),('8975','2013-09-11','08:15:00',2.85),('8975','2013-09-11','08:20:00',2.88),('8975','2013-09-11','08:25:00',3.24),('8975','2013-09-11','08:30:00',3.5),('8975','2013-09-11','08:35:00',3.58),('8975','2013-09-11','08:40:00',2.38),('8975','2013-09-11','08:45:00',2.04),('8975','2013-09-11','08:50:00',2.85),('8975','2013-09-11','08:55:00',3.32),('8975','2013-09-11','09:00:00',3.62),('8975','2013-09-11','09:05:00',3.11),('8975','2013-09-11','09:10:00',2.09),('8975','2013-09-11','09:15:00',3.1),('8975','2013-09-11','09:20:00',3.74),('8975','2013-09-11','09:25:00',3.06),('8975','2013-09-11','09:30:00',3.21),('8975','2013-09-11','09:35:00',2.6),('8975','2013-09-11','09:40:00',2.36),('8975','2013-09-11','09:45:00',2.32),('8975','2013-09-11','09:50:00',3.32),('8975','2013-09-11','09:55:00',2.5),('8975','2013-09-11','10:00:00',1.73),('8975','2013-09-11','10:05:00',3.16),('8975','2013-09-11','10:10:00',3.3),('8975','2013-09-11','10:15:00',2.14),('8975','2013-09-11','10:20:00',2.1),('8975','2013-09-11','10:25:00',2.12),('8975','2013-09-11','10:30:00',3.29),('8975','2013-09-11','10:35:00',2.33),('8975','2013-09-11','10:40:00',1.25),('8975','2013-09-11','10:45:00',1.98),('8975','2013-09-11','10:50:00',1.98),('8975','2013-09-11','10:55:00',2.82),('8975','2013-09-11','11:00:00',3.32),('8975','2013-09-11','11:05:00',5.78),('8975','2013-09-11','11:10:00',3.92),('8975','2013-09-11','11:15:00',6.96),('8975','2013-09-11','11:20:00',2.99),('8975','2013-09-11','11:40:00',1.5),('8975','2013-09-11','11:45:00',3.11),('8975','2013-09-11','11:50:00',2.81),('8975','2013-09-11','11:55:00',2.1),('8975','2013-09-11','12:00:00',2.79),('8975','2013-09-11','12:05:00',5.84),('8975','2013-09-11','12:10:00',5.61),('8975','2013-09-11','12:15:00',3.34),('8975','2013-09-11','12:20:00',2.63),('8975','2013-09-11','12:25:00',2.57),('8975','2013-09-11','12:30:00',2.15),('8975','2013-09-11','12:35:00',4.22),('8975','2013-09-11','12:40:00',2.45),('8975','2013-09-11','12:45:00',1.66),('8975','2013-09-11','12:50:00',2.12),('8975','2013-09-11','12:55:00',6.3),('8975','2013-09-11','13:00:00',5.1),('8975','2013-09-11','13:05:00',4.66),('8975','2013-09-11','13:10:00',3.99),('8975','2013-09-11','13:15:00',2.06),('8975','2013-09-11','13:20:00',4.92),('8975','2013-09-11','13:25:00',4.89),('8975','2013-09-11','13:30:00',3.46),('8975','2013-09-11','13:35:00',4.13),('8975','2013-09-11','13:40:00',3.1),('8975','2013-09-11','13:45:00',5.35),('8975','2013-09-11','13:50:00',4.73),('8975','2013-09-11','13:55:00',4.44),('8975','2013-09-11','14:00:00',3.37),('8975','2013-09-11','14:05:00',3.81),('8975','2013-09-11','14:10:00',5.2),('8975','2013-09-11','14:15:00',5.42),('8975','2013-09-11','14:20:00',3.28),('8975','2013-09-11','14:25:00',3.38),('8975','2013-09-11','14:30:00',4.45),('8975','2013-09-11','14:35:00',3.02),('8975','2013-09-11','14:40:00',4.43),('8975','2013-09-11','14:45:00',4.79),('8975','2013-09-11','14:50:00',3.99),('8975','2013-09-11','14:55:00',4.26),('8975','2013-09-11','15:00:00',4.5),('8975','2013-09-11','15:05:00',4.48),('8975','2013-09-11','15:10:00',4.1),('8975','2013-09-11','15:15:00',4.05),('8975','2013-09-11','15:20:00',3.86),('8975','2013-09-11','15:25:00',3.61),('8975','2013-09-11','15:30:00',3.73),('8975','2013-09-11','15:35:00',3.64),('8975','2013-09-11','15:40:00',3.5),('8975','2013-09-11','15:45:00',3.41),('8975','2013-09-11','15:50:00',3.27),('8975','2013-09-11','15:55:00',3.14),('8975','2013-09-11','16:00:00',3.11),('8975','2013-09-11','16:05:00',3.18),('8975','2013-09-11','16:10:00',1.76),('8975','2013-09-11','16:15:00',3.08),('8975','2013-09-11','16:20:00',2.88),('8975','2013-09-11','16:25:00',2.71),('8975','2013-09-11','16:30:00',2.3),('8975','2013-09-11','16:35:00',2.18),('8975','2013-09-11','16:40:00',1.39),('8975','2013-09-11','16:45:00',1.57),('8975','2013-09-11','16:50:00',1.8),('8975','2013-09-11','16:55:00',1.85),('8975','2013-09-11','17:00:00',2.15),('8975','2013-09-11','17:05:00',1.89),('8975','2013-09-11','17:10:00',1.82),('8975','2013-09-11','17:15:00',1.72),('8975','2013-09-11','17:20:00',1.51),('8975','2013-09-11','17:25:00',1.68),('8975','2013-09-11','17:30:00',1.75),('8975','2013-09-11','17:35:00',1.38),('8975','2013-09-11','17:40:00',1.3),('8975','2013-09-11','17:45:00',1.4),('8975','2013-09-11','17:50:00',1.24),('8975','2013-09-10','07:55:00',1.31),('8975','2013-09-10','08:00:00',1.48),('8975','2013-09-10','08:05:00',2.88),('8975','2013-09-10','08:10:00',3.05),('8975','2013-09-10','08:15:00',1.94),('8975','2013-09-10','08:25:00',1.17),('8975','2013-09-10','08:30:00',1.22),('8975','2013-09-10','08:35:00',1.19),('8975','2013-09-10','08:40:00',1.69),('8975','2013-09-10','08:45:00',1.46),('8975','2013-09-10','08:50:00',2.66),('8975','2013-09-10','08:55:00',2.06),('8975','2013-09-10','09:00:00',3.84),('8975','2013-09-10','09:05:00',2.63),('8975','2013-09-10','09:10:00',3.68),('8975','2013-09-10','09:15:00',4.43),('8975','2013-09-10','09:20:00',3.7),('8975','2013-09-10','09:25:00',4.53),('8975','2013-09-10','09:30:00',4.06),('8975','2013-09-10','09:35:00',4.36),('8975','2013-09-10','09:40:00',2.26),('8975','2013-09-10','09:45:00',1.36),('8975','2013-09-10','09:50:00',1.7),('8975','2013-09-10','09:55:00',1.25),('8975','2013-09-10','10:00:00',1.69),('8975','2013-09-10','10:15:00',2.47),('8975','2013-09-10','10:20:00',3.08),('8975','2013-09-10','10:25:00',5.24),('8975','2013-09-10','10:30:00',5.39),('8975','2013-09-10','10:35:00',5.47),('8975','2013-09-10','10:40:00',5.42),('8975','2013-09-10','10:45:00',4.52),('8975','2013-09-10','10:50:00',6.04),('8975','2013-09-10','10:55:00',6.6),('8975','2013-09-10','11:00:00',6.11),('8975','2013-09-10','11:05:00',4.58),('8975','2013-09-10','11:10:00',2.82),('8975','2013-09-10','11:15:00',1.63),('8975','2013-09-10','11:20:00',6.42),('8975','2013-09-10','11:25:00',5.27),('8975','2013-09-10','11:30:00',5.57),('8975','2013-09-10','11:35:00',5.7),('8975','2013-09-10','11:40:00',6.13),('8975','2013-09-10','11:45:00',6.01),('8975','2013-09-10','11:50:00',6.03),('8975','2013-09-10','11:55:00',6.11),('8975','2013-09-10','12:00:00',6.15),('8975','2013-09-10','12:05:00',4.96),('8975','2013-09-10','12:10:00',5.65),('8975','2013-09-10','12:15:00',5.62),('8975','2013-09-10','12:20:00',4.07),('8975','2013-09-10','12:25:00',6.3),('8975','2013-09-10','12:30:00',6.42),('8975','2013-09-10','12:35:00',6.38),('8975','2013-09-10','12:40:00',6.36),('8975','2013-09-10','12:45:00',4.18),('8975','2013-09-10','12:50:00',5.3),('8975','2013-09-10','12:55:00',4.96),('8975','2013-09-10','13:00:00',4.24),('8975','2013-09-10','13:05:00',5.77),('8975','2013-09-10','13:10:00',5.95),('8975','2013-09-10','13:15:00',5.96),('8975','2013-09-10','13:20:00',6.12),('8975','2013-09-10','13:25:00',5.99),('8975','2013-09-10','13:30:00',6.04),('8975','2013-09-10','13:35:00',6.04),('8975','2013-09-10','13:40:00',6.35),('8975','2013-09-10','13:45:00',4.9),('8975','2013-09-10','13:50:00',6.08),('8975','2013-09-10','13:55:00',5.97),('8975','2013-09-10','14:00:00',5.69),('8975','2013-09-10','14:05:00',5.43),('8975','2013-09-10','14:10:00',5.46),('8975','2013-09-10','14:15:00',5.34),('8975','2013-09-10','14:20:00',5.39),('8975','2013-09-10','14:25:00',2.14),('8975','2013-09-10','14:30:00',1.99),('8975','2013-09-10','14:35:00',4.49),('8975','2013-09-10','14:40:00',3.68),('8975','2013-09-10','14:45:00',3.98),('8975','2013-09-10','14:50:00',5.24),('8975','2013-09-10','14:55:00',2.75),('8975','2013-09-10','15:00:00',4.59),('8975','2013-09-10','15:05:00',4.83),('8975','2013-09-10','15:10:00',4.53),('8975','2013-09-10','15:15:00',4.24),('8975','2013-09-10','15:20:00',3.73),('8975','2013-09-10','15:25:00',3.75),('8975','2013-09-10','15:30:00',1.87),('8975','2013-09-10','15:35:00',4.15),('8975','2013-09-10','15:40:00',3.07),('8975','2013-09-10','15:45:00',3.52),('8975','2013-09-10','15:50:00',2.77),('8975','2013-09-10','15:55:00',3.29),('8975','2013-09-10','16:00:00',2.39),('8975','2013-09-10','16:05:00',2.39),('8975','2013-09-10','16:10:00',1.91),('8975','2013-09-10','16:15:00',2.99),('8975','2013-09-10','16:20:00',2.52),('8975','2013-09-10','16:25:00',1.95),('8975','2013-09-10','16:30:00',2.06),('8975','2013-09-10','16:35:00',2.39),('8975','2013-09-10','16:40:00',2.32),('8975','2013-09-10','16:45:00',1.82),('8975','2013-09-10','16:50:00',1.92),('8975','2013-09-10','16:55:00',1.85),('8975','2013-09-10','17:00:00',1.64),('8975','2013-09-10','17:05:00',1.39),('8975','2013-09-10','17:10:00',1.44),('8975','2013-09-10','17:15:00',1.47),('8975','2013-09-10','17:20:00',1.5),('8975','2013-09-10','17:25:00',1.44),('8975','2013-09-10','17:30:00',1.41),('8975','2013-09-10','17:50:00',1.31),('8975','2013-09-10','17:55:00',1.29),('8975','2013-09-10','18:00:00',1.28),('8975','2013-09-10','18:05:00',1.19),('8975','2013-09-10','18:10:00',1.21),('8975','2013-09-09','07:50:00',1.29),('8975','2013-09-09','07:55:00',1.63),('8975','2013-09-09','08:00:00',1.82),('8975','2013-09-09','08:05:00',1.25),('8975','2013-09-09','08:10:00',1.42),('8975','2013-09-09','08:15:00',1.37),('8975','2013-09-09','08:20:00',1.08),('8975','2013-09-09','08:40:00',1),('8975','2013-09-09','08:45:00',1.3),('8975','2013-09-09','08:50:00',1.44),('8975','2013-09-09','08:55:00',2.84),('8975','2013-09-09','09:00:00',3.6),('8975','2013-09-09','09:05:00',4.06),('8975','2013-09-09','09:10:00',4.35),('8975','2013-09-09','09:15:00',3.94),('8975','2013-09-09','09:20:00',2.75),('8975','2013-09-09','09:25:00',2.79),('8975','2013-09-09','09:30:00',4.8),('8975','2013-09-09','09:35:00',4.65),('8975','2013-09-09','09:40:00',2.9),('8975','2013-09-09','09:45:00',2.29),('8975','2013-09-09','09:50:00',2.02),('8975','2013-09-09','09:55:00',1.76),('8975','2013-09-09','10:00:00',1.57),('8975','2013-09-09','10:05:00',1.39),('8975','2013-09-09','10:10:00',1.04),('8975','2013-09-09','10:20:00',1.18),('8975','2013-09-09','10:25:00',1.54),('8975','2013-09-09','10:30:00',1.6),('8975','2013-09-09','10:35:00',1.97),('8975','2013-09-09','10:40:00',2.49),('8975','2013-09-09','10:45:00',2.98),('8975','2013-09-09','10:50:00',1.79),('8975','2013-09-09','10:55:00',2.17),('8975','2013-09-09','11:00:00',2.47),('8975','2013-09-09','11:05:00',2.18),('8975','2013-09-09','11:10:00',2.24),('8975','2013-09-09','11:15:00',1.72),('8975','2013-09-09','11:20:00',1.89),('8975','2013-09-09','11:25:00',2.02),('8975','2013-09-09','11:30:00',1.53),('8975','2013-09-09','11:35:00',1.12),('8975','2013-09-09','11:40:00',1.1),('8975','2013-09-09','11:45:00',1.5),('8975','2013-09-09','11:50:00',1.67),('8975','2013-09-09','11:55:00',1.69),('8975','2013-09-09','12:00:00',2.13),('8975','2013-09-09','12:05:00',1.46),('8975','2013-09-09','12:10:00',1.55),('8975','2013-09-09','12:15:00',1.72),('8975','2013-09-09','12:20:00',2.05),('8975','2013-09-09','12:25:00',1.72),('8975','2013-09-09','12:30:00',1.51),('8975','2013-09-09','12:35:00',1.67),('8975','2013-09-09','12:40:00',1.38),('8975','2013-09-09','12:45:00',1.42),('8975','2013-09-09','12:50:00',1.54),('8975','2013-09-09','12:55:00',1.27),('8975','2013-09-09','13:00:00',1.37),('8975','2013-09-09','13:05:00',1.08),('8975','2013-09-09','13:15:00',1.27),('8975','2013-09-09','13:20:00',1.38),('8975','2013-09-09','13:25:00',1.6),('8975','2013-09-09','13:30:00',1.51),('8975','2013-09-09','13:35:00',1.7),('8975','2013-09-09','13:40:00',2.96),('8975','2013-09-09','13:45:00',3.94),('8975','2013-09-09','13:50:00',2.48),('8975','2013-09-09','13:55:00',2.19),('8975','2013-09-09','14:00:00',1.64),('8975','2013-09-09','14:05:00',2.01),('8975','2013-09-09','14:10:00',2.09),('8975','2013-09-09','14:15:00',2.41),('8975','2013-09-09','14:20:00',2.45),('8975','2013-09-09','14:25:00',3.33),('8975','2013-09-09','14:30:00',3.03),('8975','2013-09-09','14:35:00',2.45),('8975','2013-09-09','14:40:00',2.94),('8975','2013-09-09','14:45:00',2.97),('8975','2013-09-09','14:50:00',3.16),('8975','2013-09-09','14:55:00',2.97),('8975','2013-09-09','15:00:00',3.16),('8975','2013-09-09','15:05:00',2.27),('8975','2013-09-09','15:10:00',2.14),('8975','2013-09-09','15:15:00',2.03),('8975','2013-09-09','15:20:00',2.37),('8975','2013-09-09','15:25:00',2.43),('8975','2013-09-09','15:30:00',2.85),('8975','2013-09-09','15:35:00',2.01),('8975','2013-09-09','15:40:00',1.57),('8975','2013-09-09','15:45:00',1.55),('8975','2013-09-09','15:50:00',1.67),('8975','2013-09-09','15:55:00',1.56),('8975','2013-09-09','16:00:00',1.66),('8975','2013-09-09','16:05:00',1.78),('8975','2013-09-09','16:10:00',1.73),('8975','2013-09-09','16:15:00',2.01),('8975','2013-09-09','16:20:00',1.58),('8975','2013-09-09','16:25:00',1.48),('8975','2013-09-09','16:30:00',1.24),('8975','2013-09-09','16:50:00',1.06),('8975','2013-09-09','16:55:00',1.16),('8975','2013-09-09','17:00:00',1.03),('8975','2013-09-09','17:05:00',1.02),('8975','2013-09-09','17:10:00',1.1),('8975','2013-09-09','17:15:00',1.22),('8975','2013-09-09','17:20:00',1.27),('8975','2013-09-09','17:25:00',1.21),('8975','2013-09-09','17:30:00',1.03),('8975','2013-09-09','17:45:00',1.02),('8975','2013-09-09','17:50:00',1.1),('8975','2013-09-08','07:30:00',1.16),('8975','2013-09-08','07:35:00',1.54),('8975','2013-09-08','07:40:00',1.89),('8975','2013-09-08','07:45:00',1.91),('8975','2013-09-08','07:50:00',2.23),('8975','2013-09-08','07:55:00',1.85),('8975','2013-09-08','08:00:00',1.47),('8975','2013-09-08','08:05:00',1.06),('8975','2013-09-08','08:25:00',1.02),('8975','2013-09-08','08:30:00',1.05),('8975','2013-09-08','08:40:00',1.09),('8975','2013-09-08','08:45:00',1.43),('8975','2013-09-08','08:50:00',1.67),('8975','2013-09-08','08:55:00',2.06),('8975','2013-09-08','09:00:00',1.85),('8975','2013-09-08','09:05:00',1.78),('8975','2013-09-08','09:10:00',1.58),('8975','2013-09-08','09:15:00',1.49),('8975','2013-09-08','09:20:00',1.84),('8975','2013-09-08','09:25:00',1.36),('8975','2013-09-08','09:30:00',1.62),('8975','2013-09-08','09:35:00',2.07),('8975','2013-09-08','09:40:00',1.25),('8975','2013-09-08','09:45:00',1.15),('8975','2013-09-08','09:50:00',1.25),('8975','2013-09-08','09:55:00',2.07),('8975','2013-09-08','10:00:00',3.01),('8975','2013-09-08','10:05:00',3.15),('8975','2013-09-08','10:10:00',2.97),('8975','2013-09-08','10:15:00',3.02),('8975','2013-09-08','10:20:00',3),('8975','2013-09-08','10:25:00',3.01),('8975','2013-09-08','10:30:00',2.79),('8975','2013-09-08','10:35:00',2.84),('8975','2013-09-08','10:40:00',2.93),('8975','2013-09-08','10:45:00',3.22),('8975','2013-09-08','10:50:00',3.38),('8975','2013-09-08','10:55:00',3.75),('8975','2013-09-08','11:00:00',4.27),('8975','2013-09-08','11:05:00',3.29),('8975','2013-09-08','11:10:00',3.2),('8975','2013-09-08','11:15:00',3.64),('8975','2013-09-08','11:20:00',3.83),('8975','2013-09-08','11:25:00',4.22),('8975','2013-09-08','11:30:00',3.44),('8975','2013-09-08','11:35:00',4.14),('8975','2013-09-08','11:40:00',4.97),('8975','2013-09-08','11:45:00',5.51),('8975','2013-09-08','11:50:00',5.42),('8975','2013-09-08','11:55:00',5.15),('8975','2013-09-08','12:00:00',4.68),('8975','2013-09-08','12:05:00',4.3),('8975','2013-09-08','12:10:00',4.08),('8975','2013-09-08','12:15:00',4.09),('8975','2013-09-08','12:20:00',2.92),('8975','2013-09-08','12:25:00',2.33),('8975','2013-09-08','12:30:00',2.33),('8975','2013-09-08','12:35:00',2.49),('8975','2013-09-08','12:40:00',4.03),('8975','2013-09-08','12:45:00',3.7),('8975','2013-09-08','12:50:00',2.92),('8975','2013-09-08','12:55:00',3.49),('8975','2013-09-08','13:00:00',3.3),('8975','2013-09-08','13:05:00',3.91),('8975','2013-09-08','13:10:00',4.22),('8975','2013-09-08','13:15:00',4.97),('8975','2013-09-08','13:20:00',3.71),('8975','2013-09-08','13:25:00',3.31),('8975','2013-09-08','13:30:00',5.45),('8975','2013-09-08','13:35:00',5.52),('8975','2013-09-08','13:40:00',4.99),('8975','2013-09-08','13:45:00',5.59),('8975','2013-09-08','13:50:00',5.42),('8975','2013-09-08','13:55:00',5.2),('8975','2013-09-08','14:00:00',4.79),('8975','2013-09-08','14:05:00',3.12),('8975','2013-09-08','14:10:00',4.34),('8975','2013-09-08','14:15:00',3.07),('8975','2013-09-08','14:20:00',4.43),('8975','2013-09-08','14:25:00',4.28),('8975','2013-09-08','14:30:00',5.19),('8975','2013-09-08','14:35:00',5.14),('8975','2013-09-08','14:40:00',3.92),('8975','2013-09-08','14:45:00',3.54),('8975','2013-09-08','14:50:00',4.28),('8975','2013-09-08','14:55:00',3.76),('8975','2013-09-08','15:00:00',2.12),('8975','2013-09-08','15:05:00',4.27),('8975','2013-09-08','15:10:00',3.01),('8975','2013-09-08','15:15:00',3.26),('8975','2013-09-08','15:20:00',4.03),('8975','2013-09-08','15:25:00',2.21),('8975','2013-09-08','15:30:00',3.45),('8975','2013-09-08','15:35:00',2.79),('8975','2013-09-08','15:40:00',3.2),('8975','2013-09-08','15:45:00',1.92),('8975','2013-09-08','15:50:00',2.42),('8975','2013-09-08','15:55:00',2.91),('8975','2013-09-08','16:00:00',2.75),('8975','2013-09-08','16:05:00',1.98),('8975','2013-09-08','16:10:00',2.65),('8975','2013-09-08','16:15:00',3.02),('8975','2013-09-08','16:20:00',2.52),('8975','2013-09-08','16:25:00',1.67),('8975','2013-09-08','16:30:00',1.44),('8975','2013-09-08','16:35:00',1.86),('8975','2013-09-08','16:40:00',1.81),('8975','2013-09-08','16:45:00',2.23),('8975','2013-09-08','16:50:00',1.06),('8975','2013-09-08','16:55:00',1.07),('8975','2013-09-08','17:00:00',1.2),('8975','2013-09-08','17:05:00',1.12),('8975','2013-09-08','17:10:00',1.04),('8975','2013-09-08','17:35:00',1.03),('8975','2013-09-08','18:15:00',1.2),('8975','2013-09-08','18:20:00',1.18),('8975','2014-04-11','08:10:00',1.19),('8975','2014-04-11','08:15:00',1.24),('8975','2014-04-11','08:20:00',1.49),('8975','2014-04-11','08:25:00',2.06),('8975','2014-04-11','08:30:00',1.3),('8975','2014-04-11','08:35:00',1.15),('8975','2014-04-11','08:40:00',1.12),('8975','2014-04-11','08:45:00',1.17),('8975','2014-04-11','08:50:00',1.32),('8975','2014-04-11','08:55:00',1.54),('8975','2014-04-11','09:00:00',1.47),('8975','2014-04-11','09:05:00',1.72),('8975','2014-04-11','09:10:00',2.28),('8975','2014-04-11','09:15:00',3.37),('8975','2014-04-11','09:20:00',2.9),('8975','2014-04-11','09:25:00',2.2),('8975','2014-04-11','09:30:00',1.71),('8975','2014-04-11','09:35:00',1.3),('8975','2014-04-11','09:40:00',1.06),('8975','2014-04-11','09:45:00',1.1),('8975','2014-04-11','09:50:00',1.22),('8975','2014-04-11','09:55:00',1.24),('8975','2014-04-11','10:00:00',1.38),('8975','2014-04-11','10:05:00',1.7),('8975','2014-04-11','10:10:00',2.21),('8975','2014-04-11','10:15:00',2.59),('8975','2014-04-11','10:20:00',2.79),('8975','2014-04-11','10:25:00',2.88),('8975','2014-04-11','10:30:00',3.3),('8975','2014-04-11','10:35:00',3.91),('8975','2014-04-11','10:40:00',3.75),('8975','2014-04-11','10:45:00',3.43),('8975','2014-04-11','10:50:00',3.79),('8975','2014-04-11','10:55:00',3.96),('8975','2014-04-11','11:00:00',4.13),('8975','2014-04-11','11:05:00',4.65),('8975','2014-04-11','11:10:00',5.84),('8975','2014-04-11','11:15:00',5.39),('8975','2014-04-11','11:20:00',4.16),('8975','2014-04-11','11:25:00',5.66),('8975','2014-04-11','11:30:00',6.07),('8975','2014-04-11','11:35:00',5.93),('8975','2014-04-11','11:40:00',5.85),('8975','2014-04-11','11:45:00',6.39),('8975','2014-04-11','11:50:00',5.99),('8975','2014-04-11','11:55:00',3.19),('8975','2014-04-11','12:00:00',2.27),('8975','2014-04-11','12:05:00',1.98),('8975','2014-04-11','12:10:00',1.81),('8975','2014-04-11','12:15:00',1.84),('8975','2014-04-11','12:20:00',1.94),('8975','2014-04-11','12:25:00',2.02),('8975','2014-04-11','12:30:00',3.28),('8975','2014-04-11','12:35:00',3.89),('8975','2014-04-11','12:40:00',4.22),('8975','2014-04-11','12:45:00',5.09),('8975','2014-04-11','12:50:00',5.56),('8975','2014-04-11','12:55:00',2.85),('8975','2014-04-11','13:00:00',1.87),('8975','2014-04-11','13:05:00',2.94),('8975','2014-04-11','13:10:00',3.8),('8975','2014-04-11','13:15:00',2.91),('8975','2014-04-11','13:20:00',6.39),('8975','2014-04-11','13:25:00',4.01),('8975','2014-04-11','13:30:00',3.52),('8975','2014-04-11','13:35:00',3.63),('8975','2014-04-11','13:40:00',6.39),('8975','2014-04-11','13:45:00',6.51),('8975','2014-04-11','13:50:00',5.99),('8975','2014-04-11','13:55:00',5.38),('8975','2014-04-11','14:00:00',4.13),('8975','2014-04-11','14:05:00',2.05),('8975','2014-04-11','14:10:00',3.26),('8975','2014-04-11','14:15:00',4.29),('8975','2014-04-11','14:20:00',4.81),('8975','2014-04-11','14:25:00',4.12),('8975','2014-04-11','14:30:00',4.81),('8975','2014-04-11','14:35:00',3.63),('8975','2014-04-11','14:40:00',3.83),('8975','2014-04-11','14:45:00',4.81),('8975','2014-04-11','14:50:00',5.05),('8975','2014-04-11','14:55:00',3.91),('8975','2014-04-11','15:00:00',4.43),('8975','2014-04-11','15:05:00',4.65),('8975','2014-04-11','15:10:00',4.79),('8975','2014-04-11','15:15:00',4.46),('8975','2014-04-11','15:20:00',3.65),('8975','2014-04-11','15:25:00',3.77),('8975','2014-04-11','15:30:00',3.74),('8975','2014-04-11','15:35:00',3.69),('8975','2014-04-11','15:40:00',3.02),('8975','2014-04-11','15:45:00',3.05),('8975','2014-04-11','15:50:00',3.85),('8975','2014-04-11','15:55:00',3.95),('8975','2014-04-11','16:00:00',3.83),('8975','2014-04-11','16:05:00',3.68),('8975','2014-04-11','16:10:00',3.52),('8975','2014-04-11','16:15:00',3.67),('8975','2014-04-11','16:20:00',3.68),('8975','2014-04-11','16:25:00',3.36),('8975','2014-04-11','16:30:00',3.01),('8975','2014-04-11','16:35:00',2.39),('8975','2014-04-11','16:40:00',2.32),('8975','2014-04-11','16:45:00',1.98),('8975','2014-04-11','16:50:00',1.97),('8975','2014-04-11','16:55:00',2.64),('8975','2014-04-11','17:00:00',2.49),('8975','2014-04-11','17:05:00',2.25),('8975','2014-04-11','17:10:00',2.11),('8975','2014-04-11','17:15:00',2.06),('8975','2014-04-11','17:20:00',1.96),('8975','2014-04-11','17:25:00',1.72),('8975','2014-04-11','17:30:00',1.98),('8975','2014-04-11','17:35:00',1.99),('8975','2014-04-11','17:40:00',2.02),('8975','2014-04-11','17:45:00',1.98),('8975','2014-04-11','17:50:00',1.8),('8975','2014-04-11','17:55:00',1.42),('8975','2014-04-11','18:00:00',1.37),('8975','2014-04-11','18:05:00',1.19),('8975','2014-04-11','18:15:00',1.03),('8975','2014-04-11','18:20:00',1.17),('8975','2014-04-11','18:25:00',1.01),('8975','2014-04-11','18:30:00',1.07),('8975','2013-09-07','07:30:00',1.01),('8975','2013-09-07','07:35:00',1.11),('8975','2013-09-07','07:40:00',1.22),('8975','2013-09-07','07:45:00',1.41),('8975','2013-09-07','07:50:00',1.8),('8975','2013-09-07','07:55:00',1.67),('8975','2013-09-07','08:15:00',1.08),('8975','2013-09-07','08:20:00',1.11),('8975','2013-09-07','08:25:00',1.07),('8975','2013-09-07','08:30:00',1.64),('8975','2013-09-07','08:35:00',1.32),('8975','2013-09-07','08:40:00',1.33),('8975','2013-09-07','08:45:00',1.5),('8975','2013-09-07','08:50:00',1.86),('8975','2013-09-07','08:55:00',2.4),('8975','2013-09-07','09:00:00',1.92),('8975','2013-09-07','09:05:00',2.86),('8975','2013-09-07','09:10:00',2.98),('8975','2013-09-07','09:15:00',3.11),('8975','2013-09-07','09:20:00',2.95),('8975','2013-09-07','09:25:00',2.74),('8975','2013-09-07','09:30:00',2.96),('8975','2013-09-07','09:35:00',3.42),('8975','2013-09-07','09:40:00',3.98),('8975','2013-09-07','09:45:00',3.95),('8975','2013-09-07','09:50:00',4.24),('8975','2013-09-07','09:55:00',4.32),('8975','2013-09-07','10:00:00',4.41),('8975','2013-09-07','10:05:00',4.52),('8975','2013-09-07','10:10:00',4.58),('8975','2013-09-07','10:15:00',4.57),('8975','2013-09-07','10:20:00',4.68),('8975','2013-09-07','10:25:00',4.72),('8975','2013-09-07','10:30:00',4.83),('8975','2013-09-07','10:35:00',4.76),('8975','2013-09-07','10:40:00',4.74),('8975','2013-09-07','10:45:00',4.99),('8975','2013-09-07','10:50:00',5.07),('8975','2013-09-07','10:55:00',5.04),('8975','2013-09-07','11:00:00',5.08),('8975','2013-09-07','11:05:00',5.12),('8975','2013-09-07','11:10:00',5.18),('8975','2013-09-07','11:15:00',5.15),('8975','2013-09-07','11:20:00',5.16),('8975','2013-09-07','11:25:00',5.17),('8975','2013-09-07','11:30:00',5.12),('8975','2013-09-07','11:35:00',5.22),('8975','2013-09-07','11:40:00',5.11),('8975','2013-09-07','11:45:00',4.87),('8975','2013-09-07','11:50:00',4.89),('8975','2013-09-07','11:55:00',4.95),('8975','2013-09-07','12:00:00',4.3),('8975','2013-09-07','12:05:00',4.56),('8975','2013-09-07','12:10:00',4.78),('8975','2013-09-07','12:15:00',5),('8975','2013-09-07','12:20:00',4.96),('8975','2013-09-07','12:25:00',4.78),('8975','2013-09-07','12:30:00',4.6),('8975','2013-09-07','12:35:00',5.41),('8975','2013-09-07','12:40:00',5.21),('8975','2013-09-07','12:45:00',5.25),('8975','2013-09-07','12:50:00',5.08),('8975','2013-09-07','12:55:00',4.99),('8975','2013-09-07','13:00:00',5.06),('8975','2013-09-07','13:05:00',5.3),('8975','2013-09-07','13:10:00',5.28),('8975','2013-09-07','13:15:00',5.02),('8975','2013-09-07','13:20:00',4.74),('8975','2013-09-07','13:25:00',4.51),('8975','2013-09-07','13:30:00',4.71),('8975','2013-09-07','13:35:00',4.01),('8975','2013-09-07','13:40:00',3.08),('8975','2013-09-07','13:45:00',2.85),('8975','2013-09-07','13:50:00',4.19),('8975','2013-09-07','13:55:00',4.25),('8975','2013-09-07','14:00:00',4.76),('8975','2013-09-07','14:05:00',4.52),('8975','2013-09-07','14:10:00',5.22),('8975','2013-09-07','14:15:00',5.01),('8975','2013-09-07','14:20:00',5.54),('8975','2013-09-07','14:25:00',5.4),('8975','2013-09-07','14:30:00',4.76),('8975','2013-09-07','14:35:00',4.79),('8975','2013-09-07','14:40:00',4.64),('8975','2013-09-07','14:45:00',4.48),('8975','2013-09-07','14:50:00',4.38),('8975','2013-09-07','14:55:00',4.31),('8975','2013-09-07','15:00:00',4.23),('8975','2013-09-07','15:05:00',3.4),('8975','2013-09-07','15:10:00',1.93),('8975','2013-09-07','15:15:00',3.38),('8975','2013-09-07','15:20:00',3.96),('8975','2013-09-07','15:25:00',3.95),('8975','2013-09-07','15:30:00',3.86),('8975','2013-09-07','15:35:00',3.63),('8975','2013-09-07','15:40:00',3.35),('8975','2013-09-07','15:45:00',3.36),('8975','2013-09-07','15:50:00',3.1),('8975','2013-09-07','15:55:00',2.77),('8975','2013-09-07','16:00:00',2.69),('8975','2013-09-07','16:05:00',2.67),('8975','2013-09-07','16:10:00',2.35),('8975','2013-09-07','16:15:00',2.78),('8975','2013-09-07','16:20:00',2.34),('8975','2013-09-07','16:25:00',2.3),('8975','2013-09-07','16:30:00',2.32),('8975','2013-09-07','16:35:00',2.14),('8975','2013-09-07','16:40:00',1.88),('8975','2013-09-07','16:45:00',1.37),('8975','2013-09-07','16:50:00',1.25),('8975','2013-09-07','16:55:00',1.29),('8975','2013-09-07','17:00:00',1.98),('8975','2013-09-07','17:05:00',2.07),('8975','2013-09-07','17:10:00',1.93),('8975','2013-09-07','17:15:00',1.75),('8975','2013-09-07','17:20:00',1.46),('8975','2013-09-07','17:25:00',1.49),('8975','2013-09-07','17:30:00',1.34),('8975','2013-09-07','17:45:00',1.16),('8975','2013-09-07','17:50:00',1.18),('8975','2013-09-07','17:55:00',1.18),('8975','2013-09-07','18:00:00',1.06),('8975','2013-09-06','07:25:00',1.11),('8975','2013-09-06','07:30:00',1.24),('8975','2013-09-06','07:35:00',1.52),('8975','2013-09-06','07:40:00',1.61),('8975','2013-09-06','07:45:00',1.69),('8975','2013-09-06','07:50:00',2.01),('8975','2013-09-06','07:55:00',2.19),('8975','2013-09-06','08:00:00',2.32),('8975','2013-09-06','08:05:00',2.45),('8975','2013-09-06','08:10:00',2.57),('8975','2013-09-06','08:15:00',2.69),('8975','2013-09-06','08:20:00',2.8),('8975','2013-09-06','08:25:00',2.91),('8975','2013-09-06','08:30:00',2.99),('8975','2013-09-06','08:35:00',3.07),('8975','2013-09-06','08:40:00',3.19),('8975','2013-09-06','08:45:00',3.29),('8975','2013-09-06','08:50:00',3.36),('8975','2013-09-06','08:55:00',3.45),('8975','2013-09-06','09:00:00',3.55),('8975','2013-09-06','09:05:00',3.65),('8975','2013-09-06','09:10:00',3.76),('8975','2013-09-06','09:15:00',3.85),('8975','2013-09-06','09:20:00',3.95),('8975','2013-09-06','09:25:00',4.06),('8975','2013-09-06','09:30:00',4.14),('8975','2013-09-06','09:35:00',4.2),('8975','2013-09-06','09:40:00',4.29),('8975','2013-09-06','09:45:00',4.36),('8975','2013-09-06','09:50:00',4.41),('8975','2013-09-06','09:55:00',4.47),('8975','2013-09-06','10:00:00',4.54),('8975','2013-09-06','10:05:00',4.53),('8975','2013-09-06','10:10:00',4.61),('8975','2013-09-06','10:15:00',4.71),('8975','2013-09-06','10:20:00',4.8),('8975','2013-09-06','10:25:00',4.87),('8975','2013-09-06','10:30:00',4.96),('8975','2013-09-06','10:35:00',4.94),('8975','2013-09-06','10:40:00',5.02),('8975','2013-09-06','10:45:00',5.07),('8975','2013-09-06','10:50:00',5.13),('8975','2013-09-06','10:55:00',5.22),('8975','2013-09-06','11:00:00',5.25),('8975','2013-09-06','11:05:00',5.26),('8975','2013-09-06','11:10:00',5.3),('8975','2013-09-06','11:15:00',5.34),('8975','2013-09-06','11:20:00',5.35),('8975','2013-09-06','11:25:00',5.42),('8975','2013-09-06','11:30:00',5.45),('8975','2013-09-06','11:35:00',5.41),('8975','2013-09-06','11:40:00',5.48),('8975','2013-09-06','11:45:00',5.5),('8975','2013-09-06','11:50:00',5.45),('8975','2013-09-06','11:55:00',5.51),('8975','2013-09-06','12:00:00',5.48),('8975','2013-09-06','12:05:00',5.52),('8975','2013-09-06','12:10:00',5.48),('8975','2013-09-06','12:15:00',5.51),('8975','2013-09-06','12:20:00',5.55),('8975','2013-09-06','12:25:00',5.54),('8975','2013-09-06','12:30:00',5.49),('8975','2013-09-06','12:35:00',5.53),('8975','2013-09-06','12:40:00',5.57),('8975','2013-09-06','12:45:00',5.52),('8975','2013-09-06','12:50:00',5.51),('8975','2013-09-06','12:55:00',5.45),('8975','2013-09-06','13:00:00',5.43),('8975','2013-09-06','13:05:00',5.46),('8975','2013-09-06','13:10:00',5.42),('8975','2013-09-06','13:15:00',5.4),('8975','2013-09-06','13:20:00',5.2),('8975','2013-09-06','13:25:00',5.22),('8975','2013-09-06','13:30:00',5.3),('8975','2013-09-06','13:35:00',5.38),('8975','2013-09-06','13:40:00',5.31),('8975','2013-09-06','13:45:00',5.12),('8975','2013-09-06','13:50:00',5.3),('8975','2013-09-06','13:55:00',5.21),('8975','2013-09-06','14:00:00',5.12),('8975','2013-09-06','14:05:00',4.99),('8975','2013-09-06','14:10:00',4.98),('8975','2013-09-06','14:15:00',4.85),('8975','2013-09-06','14:20:00',4.84),('8975','2013-09-06','14:25:00',4.81),('8975','2013-09-06','14:30:00',4.78),('8975','2013-09-06','14:35:00',4.68),('8975','2013-09-06','14:40:00',4.55),('8975','2013-09-06','14:45:00',4.44),('8975','2013-09-06','14:50:00',4.41),('8975','2013-09-06','14:55:00',4.34),('8975','2013-09-06','15:00:00',4.23),('8975','2013-09-06','15:05:00',4.11),('8975','2013-09-06','15:10:00',3.88),('8975','2013-09-06','15:15:00',3.77),('8975','2013-09-06','15:20:00',3.79),('8975','2013-09-06','15:25:00',3.71),('8975','2013-09-06','15:30:00',3.6),('8975','2013-09-06','15:35:00',3.51),('8975','2013-09-06','15:40:00',3.39),('8975','2013-09-06','15:45:00',3.24),('8975','2013-09-06','15:50:00',3.12),('8975','2013-09-06','15:55:00',3.06),('8975','2013-09-06','16:00:00',2.98),('8975','2013-09-06','16:05:00',2.87),('8975','2013-09-06','16:10:00',2.76),('8975','2013-09-06','16:15:00',2.65),('8975','2013-09-06','16:20:00',2.51),('8975','2013-09-06','16:25:00',2.42),('8975','2013-09-06','16:30:00',2.32),('8975','2013-09-06','16:35:00',2.22),('8975','2013-09-06','16:40:00',2.13),('8975','2013-09-06','16:45:00',2.05),('8975','2013-09-06','16:50:00',1.95),('8975','2013-09-06','16:55:00',1.85),('8975','2013-09-06','17:00:00',1.78),('8975','2013-09-06','17:05:00',1.71),('8975','2013-09-06','17:10:00',1.64),('8975','2013-09-06','17:15:00',1.57),('8975','2013-09-06','17:20:00',1.5),('8975','2013-09-06','17:25:00',1.42),('8975','2013-09-06','17:30:00',1.36),('8975','2013-09-06','17:35:00',1.31),('8975','2013-09-06','17:40:00',1.29),('8975','2013-09-06','17:45:00',1.23),('8975','2013-09-06','17:50:00',1.17),('8975','2013-09-06','17:55:00',1.12),('8975','2013-09-06','18:00:00',1.07),('8975','2013-09-06','18:05:00',1.01),('8975','2013-09-05','07:20:00',1.12),('8975','2013-09-05','07:25:00',1.3),('8975','2013-09-05','07:30:00',1.39),('8975','2013-09-05','07:35:00',1.48),('8975','2013-09-05','07:40:00',1.69),('8975','2013-09-05','07:45:00',1.83),('8975','2013-09-05','07:50:00',2.12),('8975','2013-09-05','07:55:00',2.29),('8975','2013-09-05','08:00:00',2.43),('8975','2013-09-05','08:05:00',2.54),('8975','2013-09-05','08:10:00',2.69),('8975','2013-09-05','08:15:00',2.81),('8975','2013-09-05','08:20:00',2.93),('8975','2013-09-05','08:25:00',3.04),('8975','2013-09-05','08:30:00',3.12),('8975','2013-09-05','08:35:00',3.22),('8975','2013-09-05','08:40:00',3.31),('8975','2013-09-05','08:45:00',3.4),('8975','2013-09-05','08:50:00',3.46),('8975','2013-09-05','08:55:00',3.56),('8975','2013-09-05','09:00:00',3.65),('8975','2013-09-05','09:05:00',3.73),('8975','2013-09-05','09:10:00',3.83),('8975','2013-09-05','09:15:00',3.91),('8975','2013-09-05','09:20:00',3.99),('8975','2013-09-05','09:25:00',4.07),('8975','2013-09-05','09:30:00',4.13),('8975','2013-09-05','09:35:00',4.21),('8975','2013-09-05','09:40:00',4.29),('8975','2013-09-05','09:45:00',4.37),('8975','2013-09-05','09:50:00',4.44),('8975','2013-09-05','09:55:00',4.56),('8975','2013-09-05','10:00:00',4.6),('8975','2013-09-05','10:05:00',4.69),('8975','2013-09-05','10:10:00',4.74),('8975','2013-09-05','10:15:00',4.73),('8975','2013-09-05','10:20:00',4.8),('8975','2013-09-05','10:25:00',4.94),('8975','2013-09-05','10:30:00',5.07),('8975','2013-09-05','10:35:00',5.13),('8975','2013-09-05','10:40:00',5.16),('8975','2013-09-05','10:45:00',5.17),('8975','2013-09-05','10:50:00',5.21),('8975','2013-09-05','10:55:00',5.28),('8975','2013-09-05','11:00:00',5.39),('8975','2013-09-05','11:05:00',5.41),('8975','2013-09-05','11:10:00',5.4),('8975','2013-09-05','11:15:00',5.4),('8975','2013-09-05','11:20:00',5.39),('8975','2013-09-05','11:25:00',5.48),('8975','2013-09-05','11:30:00',5.5),('8975','2013-09-05','11:35:00',5.51),('8975','2013-09-05','11:40:00',5.54),('8975','2013-09-05','11:45:00',5.58),('8975','2013-09-05','11:50:00',5.6),('8975','2013-09-05','11:55:00',5.61),('8975','2013-09-05','12:00:00',5.65),('8975','2013-09-05','12:05:00',5.64),('8975','2013-09-05','12:10:00',5.7),('8975','2013-09-05','12:15:00',5.7),('8975','2013-09-05','12:20:00',5.63),('8975','2013-09-05','12:25:00',5.59),('8975','2013-09-05','12:30:00',5.65),('8975','2013-09-05','12:35:00',5.68),('8975','2013-09-05','12:40:00',5.58),('8975','2013-09-05','12:45:00',5.53),('8975','2013-09-05','12:50:00',5.54),('8975','2013-09-05','12:55:00',5.53),('8975','2013-09-05','13:00:00',5.45),('8975','2013-09-05','13:05:00',5.45),('8975','2013-09-05','13:10:00',5.42),('8975','2013-09-05','13:15:00',5.39),('8975','2013-09-05','13:20:00',5.37),('8975','2013-09-05','13:25:00',5.3),('8975','2013-09-05','13:30:00',5.29),('8975','2013-09-05','13:35:00',5.27),('8975','2013-09-05','13:40:00',5.28),('8975','2013-09-05','13:45:00',5.25),('8975','2013-09-05','13:50:00',5.22),('8975','2013-09-05','13:55:00',5.13),('8975','2013-09-05','14:00:00',5.06),('8975','2013-09-05','14:05:00',5.05),('8975','2013-09-05','14:10:00',5.01),('8975','2013-09-05','14:15:00',4.87),('8975','2013-09-05','14:20:00',4.74),('8975','2013-09-05','14:25:00',4.81),('8975','2013-09-05','14:30:00',4.64),('8975','2013-09-05','14:35:00',4.63),('8975','2013-09-05','14:40:00',4.55),('8975','2013-09-05','14:45:00',4.46),('8975','2013-09-05','14:50:00',4.58),('8975','2013-09-05','14:55:00',4.43),('8975','2013-09-05','15:00:00',4.29),('8975','2013-09-05','15:05:00',4.08),('8975','2013-09-05','15:10:00',3.95),('8975','2013-09-05','15:15:00',3.75),('8975','2013-09-05','15:20:00',3.72),('8975','2013-09-05','15:25:00',3.68),('8975','2013-09-05','15:30:00',3.6),('8975','2013-09-05','15:35:00',3.5),('8975','2013-09-05','15:40:00',3.42),('8975','2013-09-05','15:45:00',3.27),('8975','2013-09-05','15:50:00',3.11),('8975','2013-09-05','15:55:00',3.08),('8975','2013-09-05','16:00:00',2.99),('8975','2013-09-05','16:05:00',2.89),('8975','2013-09-05','16:10:00',2.83),('8975','2013-09-05','16:15:00',2.73),('8975','2013-09-05','16:20:00',2.61),('8975','2013-09-05','16:25:00',2.52),('8975','2013-09-05','16:30:00',2.4),('8975','2013-09-05','16:35:00',2.31),('8975','2013-09-05','16:40:00',2.22),('8975','2013-09-05','16:45:00',2.14),('8975','2013-09-05','16:50:00',2.03),('8975','2013-09-05','16:55:00',1.92),('8975','2013-09-05','17:00:00',1.85),('8975','2013-09-05','17:05:00',1.78),('8975','2013-09-05','17:10:00',1.7),('8975','2013-09-05','17:15:00',1.61),('8975','2013-09-05','17:20:00',1.54),('8975','2013-09-05','17:25:00',1.47),('8975','2013-09-05','17:30:00',1.42),('8975','2013-09-05','17:35:00',1.36),('8975','2013-09-05','17:40:00',1.32),('8975','2013-09-05','17:45:00',1.24),('8975','2013-09-05','17:50:00',1.18),('8975','2013-09-05','17:55:00',1.15),('8975','2013-09-05','18:00:00',1.11),('8975','2013-09-05','18:05:00',1.08),('8975','2013-09-05','18:10:00',1.02),('8975','2013-09-04','07:15:00',1.3),('8975','2013-09-04','07:20:00',1.46),('8975','2013-09-04','07:25:00',1.64),('8975','2013-09-04','07:30:00',1.77),('8975','2013-09-04','07:35:00',1.93),('8975','2013-09-04','07:40:00',1.89),('8975','2013-09-04','07:45:00',2.14),('8975','2013-09-04','07:50:00',2.47),('8975','2013-09-04','07:55:00',2.52),('8975','2013-09-04','08:00:00',2.53),('8975','2013-09-04','08:05:00',2.34),('8975','2013-09-04','08:10:00',2.8),('8975','2013-09-04','08:15:00',2.9),('8975','2013-09-04','08:20:00',2.98),('8975','2013-09-04','08:25:00',3.04),('8975','2013-09-04','08:30:00',3.24),('8975','2013-09-04','08:35:00',3.47),('8975','2013-09-04','08:40:00',3.2),('8975','2013-09-04','08:45:00',3.3),('8975','2013-09-04','08:50:00',3.58),('8975','2013-09-04','08:55:00',3.16),('8975','2013-09-04','09:00:00',3.61),('8975','2013-09-04','09:05:00',3.97),('8975','2013-09-04','09:10:00',4.05),('8975','2013-09-04','09:15:00',4.16),('8975','2013-09-04','09:20:00',4.25),('8975','2013-09-04','09:25:00',4.34),('8975','2013-09-04','09:30:00',4.39),('8975','2013-09-04','09:35:00',4.49),('8975','2013-09-04','09:40:00',4.57),('8975','2013-09-04','09:45:00',4.63),('8975','2013-09-04','09:50:00',4.74),('8975','2013-09-04','09:55:00',4.81),('8975','2013-09-04','10:00:00',4.86),('8975','2013-09-04','10:05:00',4.93),('8975','2013-09-04','10:10:00',4.98),('8975','2013-09-04','10:15:00',5.07),('8975','2013-09-04','10:20:00',5.13),('8975','2013-09-04','10:25:00',5.17),('8975','2013-09-04','10:30:00',5.21),('8975','2013-09-04','10:35:00',5.26),('8975','2013-09-04','10:40:00',5.31),('8975','2013-09-04','10:45:00',5.35),('8975','2013-09-04','10:50:00',5.38),('8975','2013-09-04','10:55:00',5.44),('8975','2013-09-04','11:00:00',5.49),('8975','2013-09-04','11:05:00',5.52),('8975','2013-09-04','11:10:00',5.56),('8975','2013-09-04','11:15:00',5.58),('8975','2013-09-04','11:20:00',5.63),('8975','2013-09-04','11:25:00',5.64),('8975','2013-09-04','11:30:00',5.66),('8975','2013-09-04','11:35:00',5.7),('8975','2013-09-04','11:40:00',5.57),('8975','2013-09-04','11:45:00',5.68),('8975','2013-09-04','11:50:00',5.74),('8975','2013-09-04','11:55:00',5.73),('8975','2013-09-04','12:00:00',5.68),('8975','2013-09-04','12:05:00',5.71),('8975','2013-09-04','12:10:00',5.72),('8975','2013-09-04','12:15:00',5.71),('8975','2013-09-04','12:20:00',5.72),('8975','2013-09-04','12:25:00',5.72),('8975','2013-09-04','12:30:00',5.73),('8975','2013-09-04','12:35:00',5.73),('8975','2013-09-04','12:40:00',5.68),('8975','2013-09-04','12:45:00',5.66),('8975','2013-09-04','12:50:00',5.67),('8975','2013-09-04','12:55:00',5.67),('8975','2013-09-04','13:00:00',5.6),('8975','2013-09-04','13:05:00',5.64),('8975','2013-09-04','13:10:00',5.59),('8975','2013-09-04','13:15:00',5.57),('8975','2013-09-04','13:20:00',5.53),('8975','2013-09-04','13:25:00',5.49),('8975','2013-09-04','13:30:00',5.47),('8975','2013-09-04','13:35:00',5.44),('8975','2013-09-04','13:40:00',5.43),('8975','2013-09-04','13:45:00',5.38),('8975','2013-09-04','13:50:00',5.29),('8975','2013-09-04','13:55:00',5.22),('8975','2013-09-04','14:00:00',5.14),('8975','2013-09-04','14:05:00',5.1),('8975','2013-09-04','14:10:00',5.03),('8975','2013-09-04','14:15:00',4.91),('8975','2013-09-04','14:20:00',4.86),('8975','2013-09-04','14:25:00',4.85),('8975','2013-09-04','14:30:00',4.77),('8975','2013-09-04','14:35:00',4.66),('8975','2013-09-04','14:40:00',4.61),('8975','2013-09-04','14:45:00',4.51),('8975','2013-09-04','14:50:00',4.42),('8975','2013-09-04','14:55:00',4.37),('8975','2013-09-04','15:00:00',4.32),('8975','2013-09-04','15:05:00',4.25),('8975','2013-09-04','15:10:00',4.06),('8975','2013-09-04','15:15:00',3.89),('8975','2013-09-04','15:20:00',3.81),('8975','2013-09-04','15:25:00',3.64),('8975','2013-09-04','15:30:00',3.56),('8975','2013-09-04','15:35:00',3.54),('8975','2013-09-04','15:40:00',3.48),('8975','2013-09-04','15:45:00',3.35),('8975','2013-09-04','15:50:00',3.25),('8975','2013-09-04','15:55:00',3.15),('8975','2013-09-04','16:00:00',3.07),('8975','2013-09-04','16:05:00',3.01),('8975','2013-09-04','16:10:00',2.9),('8975','2013-09-04','16:15:00',2.78),('8975','2013-09-04','16:20:00',2.7),('8975','2013-09-04','16:25:00',2.61),('8975','2013-09-04','16:30:00',2.53),('8975','2013-09-04','16:35:00',2.44),('8975','2013-09-04','16:40:00',2.37),('8975','2013-09-04','16:45:00',2.22),('8975','2013-09-04','16:50:00',1.78),('8975','2013-09-04','16:55:00',1.36),('8975','2013-09-04','17:00:00',1.34),('8975','2013-09-04','17:05:00',1.5),('8975','2013-09-04','17:10:00',1.4),('8975','2013-09-04','17:15:00',1.42),('8975','2013-09-04','17:20:00',1.47),('8975','2013-09-04','17:25:00',1.52),('8975','2013-09-04','17:30:00',1.57),('8975','2013-09-04','17:35:00',1.7),('8975','2013-09-04','17:40:00',1.73),('8975','2013-09-04','17:45:00',1.46),('8975','2013-09-04','17:50:00',1.38),('8975','2013-09-04','17:55:00',1.16),('8975','2013-09-04','18:00:00',1),('8975','2013-09-04','18:15:00',1.04),('8975','2013-09-04','18:20:00',1.04),('8975','2013-09-03','07:15:00',1.27),('8975','2013-09-03','07:20:00',1.4),('8975','2013-09-03','07:25:00',1.61),('8975','2013-09-03','07:30:00',1.71),('8975','2013-09-03','07:35:00',1.75),('8975','2013-09-03','07:40:00',2.09),('8975','2013-09-03','07:45:00',2.34),('8975','2013-09-03','07:50:00',2.51),('8975','2013-09-03','07:55:00',2.66),('8975','2013-09-03','08:00:00',2.79),('8975','2013-09-03','08:05:00',2.92),('8975','2013-09-03','08:10:00',3.03),('8975','2013-09-03','08:15:00',3.14),('8975','2013-09-03','08:20:00',3.23),('8975','2013-09-03','08:25:00',3.33),('8975','2013-09-03','08:30:00',3.42),('8975','2013-09-03','08:35:00',3.52),('8975','2013-09-03','08:40:00',3.61),('8975','2013-09-03','08:45:00',3.71),('8975','2013-09-03','08:50:00',3.8),('8975','2013-09-03','08:55:00',3.9),('8975','2013-09-03','09:00:00',4),('8975','2013-09-03','09:05:00',4.12),('8975','2013-09-03','09:10:00',4.22),('8975','2013-09-03','09:15:00',4.34),('8975','2013-09-03','09:20:00',4.43),('8975','2013-09-03','09:25:00',4.53),('8975','2013-09-03','09:30:00',4.63),('8975','2013-09-03','09:35:00',4.72),('8975','2013-09-03','09:40:00',4.8),('8975','2013-09-03','09:45:00',4.9),('8975','2013-09-03','09:50:00',4.99),('8975','2013-09-03','09:55:00',5.09),('8975','2013-09-03','10:00:00',5.14),('8975','2013-09-03','10:05:00',5.25),('8975','2013-09-03','10:10:00',5.29),('8975','2013-09-03','10:15:00',5.36),('8975','2013-09-03','10:20:00',5.43),('8975','2013-09-03','10:25:00',5.47),('8975','2013-09-03','10:30:00',5.52),('8975','2013-09-03','10:35:00',5.56),('8975','2013-09-03','10:40:00',5.64),('8975','2013-09-03','10:45:00',5.7),('8975','2013-09-03','10:50:00',5.74),('8975','2013-09-03','10:55:00',5.78),('8975','2013-09-03','11:00:00',5.82),('8975','2013-09-03','11:05:00',5.86),('8975','2013-09-03','11:10:00',5.88),('8975','2013-09-03','11:15:00',5.93),('8975','2013-09-03','11:20:00',5.98),('8975','2013-09-03','11:25:00',5.98),('8975','2013-09-03','11:30:00',6.03),('8975','2013-09-03','11:35:00',6.04),('8975','2013-09-03','11:40:00',6.02),('8975','2013-09-03','11:45:00',5.96),('8975','2013-09-03','11:50:00',6.02),('8975','2013-09-03','11:55:00',6.1),('8975','2013-09-03','12:00:00',6.09),('8975','2013-09-03','12:05:00',6.12),('8975','2013-09-03','12:10:00',6.11),('8975','2013-09-03','12:15:00',6.06),('8975','2013-09-03','12:20:00',6.05),('8975','2013-09-03','12:25:00',6.07),('8975','2013-09-03','12:30:00',6.07),('8975','2013-09-03','12:35:00',6.05),('8975','2013-09-03','12:40:00',6.06),('8975','2013-09-03','12:45:00',6.06),('8975','2013-09-03','12:50:00',6.03),('8975','2013-09-03','12:55:00',6),('8975','2013-09-03','13:00:00',5.97),('8975','2013-09-03','13:05:00',5.94),('8975','2013-09-03','13:10:00',5.92),('8975','2013-09-03','13:15:00',5.88),('8975','2013-09-03','13:20:00',5.85),('8975','2013-09-03','13:25:00',5.8),('8975','2013-09-03','13:30:00',5.75),('8975','2013-09-03','13:35:00',5.69),('8975','2013-09-03','13:40:00',5.64),('8975','2013-09-03','13:45:00',5.6),('8975','2013-09-03','13:50:00',5.56),('8975','2013-09-03','13:55:00',5.52),('8975','2013-09-03','14:00:00',5.45),('8975','2013-09-03','14:05:00',5.42),('8975','2013-09-03','14:10:00',5.32),('8975','2013-09-03','14:15:00',5.25),('8975','2013-09-03','14:20:00',5.13),('8975','2013-09-03','14:25:00',5.07),('8975','2013-09-03','14:30:00',4.98),('8975','2013-09-03','14:35:00',4.93),('8975','2013-09-03','14:40:00',4.88),('8975','2013-09-03','14:45:00',4.77),('8975','2013-09-03','14:50:00',4.71),('8975','2013-09-03','14:55:00',4.62),('8975','2013-09-03','15:00:00',4.49),('8975','2013-09-03','15:05:00',4.42),('8975','2013-09-03','15:10:00',4.27),('8975','2013-09-03','15:15:00',4.06),('8975','2013-09-03','15:20:00',3.96),('8975','2013-09-03','15:25:00',3.9),('8975','2013-09-03','15:30:00',3.84),('8975','2013-09-03','15:35:00',3.72),('8975','2013-09-03','15:40:00',3.61),('8975','2013-09-03','15:45:00',3.49),('8975','2013-09-03','15:50:00',3.37),('8975','2013-09-03','15:55:00',3.22),('8975','2013-09-03','16:00:00',3.09),('8975','2013-09-03','16:05:00',2.99),('8975','2013-09-03','16:10:00',2.92),('8975','2013-09-03','16:15:00',2.8),('8975','2013-09-03','16:20:00',2.7),('8975','2013-09-03','16:25:00',2.61),('8975','2013-09-03','16:30:00',2.48),('8975','2013-09-03','16:35:00',2.36),('8975','2013-09-03','16:40:00',2.27),('8975','2013-09-03','16:45:00',2.16),('8975','2013-09-03','16:50:00',2.03),('8975','2013-09-03','16:55:00',1.95),('8975','2013-09-03','17:00:00',1.85),('8975','2013-09-03','17:05:00',1.77),('8975','2013-09-03','17:10:00',1.69),('8975','2013-09-03','17:15:00',1.62),('8975','2013-09-03','17:20:00',1.54),('8975','2013-09-03','17:25:00',1.47),('8975','2013-09-03','17:30:00',1.41),('8975','2013-09-03','17:35:00',1.35),('8975','2013-09-03','17:40:00',1.3),('8975','2013-09-03','17:45:00',1.26),('8975','2013-09-03','17:50:00',1.22),('8975','2013-09-03','17:55:00',1.17),('8975','2013-09-03','18:00:00',1.12),('8975','2013-09-03','18:05:00',1.08),('8975','2013-09-03','18:10:00',1.03),('8975','2013-09-02','07:25:00',1.08),('8975','2013-09-02','07:30:00',1.25),('8975','2013-09-02','07:35:00',1.46),('8975','2013-09-02','07:40:00',1.65),('8975','2013-09-02','07:45:00',1.78),('8975','2013-09-02','07:50:00',2.03),('8975','2013-09-02','07:55:00',2.18),('8975','2013-09-02','08:00:00',2.29),('8975','2013-09-02','08:05:00',2.4),('8975','2013-09-02','08:10:00',2.53),('8975','2013-09-02','08:15:00',2.66),('8975','2013-09-02','08:20:00',2.79),('8975','2013-09-02','08:25:00',2.88),('8975','2013-09-02','08:30:00',2.97),('8975','2013-09-02','08:35:00',3.12),('8975','2013-09-02','08:40:00',3.2),('8975','2013-09-02','08:45:00',3.26),('8975','2013-09-02','08:50:00',3.41),('8975','2013-09-02','08:55:00',3.51),('8975','2013-09-02','09:00:00',3.63),('8975','2013-09-02','09:05:00',3.74),('8975','2013-09-02','09:10:00',3.85),('8975','2013-09-02','09:15:00',3.95),('8975','2013-09-02','09:20:00',4.07),('8975','2013-09-02','09:25:00',4.17),('8975','2013-09-02','09:30:00',4.25),('8975','2013-09-02','09:35:00',4.35),('8975','2013-09-02','09:40:00',4.42),('8975','2013-09-02','09:45:00',4.55),('8975','2013-09-02','09:50:00',4.61),('8975','2013-09-02','09:55:00',4.66),('8975','2013-09-02','10:00:00',4.72),('8975','2013-09-02','10:05:00',4.77),('8975','2013-09-02','10:10:00',4.84),('8975','2013-09-02','10:15:00',4.94),('8975','2013-09-02','10:20:00',5),('8975','2013-09-02','10:25:00',5.07),('8975','2013-09-02','10:30:00',5.11),('8975','2013-09-02','10:35:00',5.2),('8975','2013-09-02','10:40:00',5.26),('8975','2013-09-02','10:45:00',5.28),('8975','2013-09-02','10:50:00',5.4),('8975','2013-09-02','10:55:00',5.48),('8975','2013-09-02','11:00:00',5.54),('8975','2013-09-02','11:05:00',5.6),('8975','2013-09-02','11:10:00',5.62),('8975','2013-09-02','11:15:00',5.63),('8975','2013-09-02','11:20:00',5.69),('8975','2013-09-02','11:25:00',5.68),('8975','2013-09-02','11:30:00',5.72),('8975','2013-09-02','11:35:00',5.72),('8975','2013-09-02','11:40:00',5.72),('8975','2013-09-02','11:45:00',5.7),('8975','2013-09-02','11:50:00',5.82),('8975','2013-09-02','11:55:00',5.87),('8975','2013-09-02','12:00:00',5.88),('8975','2013-09-02','12:05:00',5.91),('8975','2013-09-02','12:10:00',5.94),('8975','2013-09-02','12:15:00',5.99),('8975','2013-09-02','12:20:00',5.95),('8975','2013-09-02','12:25:00',5.96),('8975','2013-09-02','12:30:00',5.96),('8975','2013-09-02','12:35:00',5.93),('8975','2013-09-02','12:40:00',5.9),('8975','2013-09-02','12:45:00',5.92),('8975','2013-09-02','12:50:00',5.89),('8975','2013-09-02','12:55:00',5.82),('8975','2013-09-02','13:00:00',5.78),('8975','2013-09-02','13:05:00',5.76),('8975','2013-09-02','13:10:00',5.8),('8975','2013-09-02','13:15:00',5.79),('8975','2013-09-02','13:20:00',5.74),('8975','2013-09-02','13:25:00',5.65),('8975','2013-09-02','13:30:00',5.62),('8975','2013-09-02','13:35:00',5.59),('8975','2013-09-02','13:40:00',5.51),('8975','2013-09-02','13:45:00',5.44),('8975','2013-09-02','13:50:00',5.4),('8975','2013-09-02','13:55:00',5.36),('8975','2013-09-02','14:00:00',5.29),('8975','2013-09-02','14:05:00',5.18),('8975','2013-09-02','14:10:00',5.14),('8975','2013-09-02','14:15:00',5.03),('8975','2013-09-02','14:20:00',4.88),('8975','2013-09-02','14:25:00',4.96),('8975','2013-09-02','14:30:00',4.88),('8975','2013-09-02','14:35:00',4.83),('8975','2013-09-02','14:40:00',4.78),('8975','2013-09-02','14:45:00',4.68),('8975','2013-09-02','14:50:00',4.61),('8975','2013-09-02','14:55:00',4.53),('8975','2013-09-02','15:00:00',4.44),('8975','2013-09-02','15:05:00',4.34),('8975','2013-09-02','15:10:00',4.23),('8975','2013-09-02','15:15:00',3.97),('8975','2013-09-02','15:20:00',3.81),('8975','2013-09-02','15:25:00',3.67),('8975','2013-09-02','15:30:00',3.8),('8975','2013-09-02','15:35:00',3.69),('8975','2013-09-02','15:40:00',3.58),('8975','2013-09-02','15:45:00',3.46),('8975','2013-09-02','15:50:00',3.32),('8975','2013-09-02','15:55:00',3.22),('8975','2013-09-02','16:00:00',3.1),('8975','2013-09-02','16:05:00',2.99),('8975','2013-09-02','16:10:00',2.93),('8975','2013-09-02','16:15:00',2.83),('8975','2013-09-02','16:20:00',2.71),('8975','2013-09-02','16:25:00',2.61),('8975','2013-09-02','16:30:00',2.49),('8975','2013-09-02','16:35:00',2.39),('8975','2013-09-02','16:40:00',2.29),('8975','2013-09-02','16:45:00',2.17),('8975','2013-09-02','16:50:00',2.06),('8975','2013-09-02','16:55:00',1.96),('8975','2013-09-02','17:00:00',1.88),('8975','2013-09-02','17:05:00',1.79),('8975','2013-09-02','17:10:00',1.71),('8975','2013-09-02','17:15:00',1.63),('8975','2013-09-02','17:20:00',1.55),('8975','2013-09-02','17:25:00',1.48),('8975','2013-09-02','17:30:00',1.42),('8975','2013-09-02','17:35:00',1.36),('8975','2013-09-02','17:40:00',1.32),('8975','2013-09-02','17:45:00',1.28),('8975','2013-09-02','17:50:00',1.23),('8975','2013-09-02','17:55:00',1.1),('8975','2013-09-02','18:00:00',1.01),('8975','2013-09-01','07:20:00',1.05),('8975','2013-09-01','07:25:00',1.14),('8975','2013-09-01','07:30:00',1.39),('8975','2013-09-01','07:35:00',1.55),('8975','2013-09-01','07:40:00',1.6),('8975','2013-09-01','07:45:00',1.91),('8975','2013-09-01','07:50:00',2.11),('8975','2013-09-01','07:55:00',2.23),('8975','2013-09-01','08:00:00',2.36),('8975','2013-09-01','08:05:00',2.51),('8975','2013-09-01','08:10:00',2.62),('8975','2013-09-01','08:15:00',2.75),('8975','2013-09-01','08:20:00',2.89),('8975','2013-09-01','08:25:00',3),('8975','2013-09-01','08:30:00',3.09),('8975','2013-09-01','08:35:00',3.22),('8975','2013-09-01','08:40:00',3.34),('8975','2013-09-01','08:45:00',3.41),('8975','2013-09-01','08:50:00',3.53),('8975','2013-09-01','08:55:00',3.64),('8975','2013-09-01','09:00:00',3.73),('8975','2013-09-01','09:05:00',3.86),('8975','2013-09-01','09:10:00',3.97),('8975','2013-09-01','09:15:00',4.07),('8975','2013-09-01','09:20:00',4.16),('8975','2013-09-01','09:25:00',4.24),('8975','2013-09-01','09:30:00',4.34),('8975','2013-09-01','09:35:00',4.43),('8975','2013-09-01','09:40:00',4.52),('8975','2013-09-01','09:45:00',4.63),('8975','2013-09-01','09:50:00',4.73),('8975','2013-09-01','09:55:00',4.79),('8975','2013-09-01','10:00:00',4.85),('8975','2013-09-01','10:05:00',4.95),('8975','2013-09-01','10:10:00',5.04),('8975','2013-09-01','10:15:00',5.09),('8975','2013-09-01','10:20:00',5.17),('8975','2013-09-01','10:25:00',5.21),('8975','2013-09-01','10:30:00',5.3),('8975','2013-09-01','10:35:00',5.35),('8975','2013-09-01','10:40:00',5.39),('8975','2013-09-01','10:45:00',5.45),('8975','2013-09-01','10:50:00',5.47),('8975','2013-09-01','10:55:00',5.52),('8975','2013-09-01','11:00:00',5.52),('8975','2013-09-01','11:05:00',5.56),('8975','2013-09-01','11:10:00',5.61),('8975','2013-09-01','11:15:00',5.65),('8975','2013-09-01','11:20:00',5.7),('8975','2013-09-01','11:25:00',5.71),('8975','2013-09-01','11:30:00',5.73),('8975','2013-09-01','11:35:00',5.73),('8975','2013-09-01','11:40:00',5.74),('8975','2013-09-01','11:45:00',5.7),('8975','2013-09-01','11:50:00',5.74),('8975','2013-09-01','11:55:00',5.8),('8975','2013-09-01','12:00:00',5.84),('8975','2013-09-01','12:05:00',5.82),('8975','2013-09-01','12:10:00',5.82),('8975','2013-09-01','12:15:00',5.78),('8975','2013-09-01','12:20:00',5.84),('8975','2013-09-01','12:25:00',5.84),('8975','2013-09-01','12:30:00',5.84),('8975','2013-09-01','12:35:00',5.86),('8975','2013-09-01','12:40:00',5.82),('8975','2013-09-01','12:45:00',5.76),('8975','2013-09-01','12:50:00',5.75),('8975','2013-09-01','12:55:00',5.73),('8975','2013-09-01','13:00:00',5.68),('8975','2013-09-01','13:05:00',5.64),('8975','2013-09-01','13:10:00',5.61),('8975','2013-09-01','13:15:00',5.58),('8975','2013-09-01','13:20:00',5.5),('8975','2013-09-01','13:25:00',5.57),('8975','2013-09-01','13:30:00',5.59),('8975','2013-09-01','13:35:00',5.54),('8975','2013-09-01','13:40:00',5.44),('8975','2013-09-01','13:45:00',5.41),('8975','2013-09-01','13:50:00',5.61),('8975','2013-09-01','13:55:00',5.51),('8975','2013-09-01','14:00:00',3.9),('8975','2013-09-01','14:10:00',2.59),('8975','2013-09-01','14:15:00',5.39),('8975','2013-09-01','14:20:00',5.33),('8975','2013-09-01','14:25:00',5.08),('8975','2013-09-01','14:30:00',2.67),('8975','2013-09-01','14:35:00',1.97),('8975','2013-09-01','14:40:00',4.09),('8975','2013-09-01','14:45:00',5.05),('8975','2013-09-01','14:50:00',4.94),('8975','2013-09-01','14:55:00',4.99),('8975','2013-09-01','15:00:00',4.69),('8975','2013-09-01','15:05:00',4.65),('8975','2013-09-01','15:10:00',4.48),('8975','2013-09-01','15:15:00',4.01),('8975','2013-09-01','15:20:00',4.24),('8975','2013-09-01','15:25:00',3.25),('8975','2013-09-01','15:30:00',3.91),('8975','2013-09-01','15:35:00',3.95),('8975','2013-09-01','15:40:00',3.78),('8975','2013-09-01','15:45:00',3.74),('8975','2013-09-01','15:50:00',3.59),('8975','2013-09-01','15:55:00',3.48),('8975','2013-09-01','16:00:00',3.36),('8975','2013-09-01','16:05:00',3.25),('8975','2013-09-01','16:10:00',3.09),('8975','2013-09-01','16:15:00',2.99),('8975','2013-09-01','16:20:00',2.93),('8975','2013-09-01','16:25:00',2.76),('8975','2013-09-01','16:30:00',2.66),('8975','2013-09-01','16:35:00',2.58),('8975','2013-09-01','16:40:00',2.43),('8975','2013-09-01','16:45:00',2.28),('8975','2013-09-01','16:50:00',2.18),('8975','2013-09-01','16:55:00',2.04),('8975','2013-09-01','17:00:00',1.92),('8975','2013-09-01','17:05:00',1.84),('8975','2013-09-01','17:10:00',1.76),('8975','2013-09-01','17:15:00',1.68),('8975','2013-09-01','17:20:00',1.62),('8975','2013-09-01','17:25:00',1.55),('8975','2013-09-01','17:30:00',1.48),('8975','2013-09-01','17:35:00',1.4),('8975','2013-09-01','17:40:00',1.33),('8975','2013-09-01','17:45:00',1.3),('8975','2013-09-01','17:50:00',1.27),('8975','2013-09-01','17:55:00',1.22),('8975','2013-09-01','18:00:00',1.16),('8975','2013-09-01','18:05:00',1.11),('8975','2013-09-01','18:10:00',1.06),('8975','2013-09-01','18:15:00',1),('8975','2013-08-31','07:15:00',1.08),('8975','2013-08-31','07:20:00',1.28),('8975','2013-08-31','07:25:00',1.44),('8975','2013-08-31','07:30:00',1.63),('8975','2013-08-31','07:35:00',1.66),('8975','2013-08-31','07:40:00',1.86),('8975','2013-08-31','07:45:00',2.15),('8975','2013-08-31','07:50:00',2.34),('8975','2013-08-31','07:55:00',2.49),('8975','2013-08-31','08:00:00',2.63),('8975','2013-08-31','08:05:00',2.74),('8975','2013-08-31','08:10:00',2.87),('8975','2013-08-31','08:15:00',2.95),('8975','2013-08-31','08:20:00',3.03),('8975','2013-08-31','08:25:00',2.59),('8975','2013-08-31','08:30:00',2.87),('8975','2013-08-31','08:35:00',3.37),('8975','2013-08-31','08:40:00',3.47),('8975','2013-08-31','08:45:00',3.56),('8975','2013-08-31','08:50:00',3.65),('8975','2013-08-31','08:55:00',3.7),('8975','2013-08-31','09:00:00',3.78),('8975','2013-08-31','09:05:00',3.93),('8975','2013-08-31','09:10:00',4.08),('8975','2013-08-31','09:15:00',4.17),('8975','2013-08-31','09:20:00',4.26),('8975','2013-08-31','09:25:00',4.37),('8975','2013-08-31','09:30:00',4.43),('8975','2013-08-31','09:35:00',4.52),('8975','2013-08-31','09:40:00',4.55),('8975','2013-08-31','09:45:00',4.65),('8975','2013-08-31','09:50:00',4.74),('8975','2013-08-31','09:55:00',4.8),('8975','2013-08-31','10:00:00',4.85),('8975','2013-08-31','10:05:00',4.94),('8975','2013-08-31','10:10:00',5.02),('8975','2013-08-31','10:15:00',5.05),('8975','2013-08-31','10:20:00',5.12),('8975','2013-08-31','10:25:00',5.24),('8975','2013-08-31','10:30:00',5.32),('8975','2013-08-31','10:35:00',5.38),('8975','2013-08-31','10:40:00',5.43),('8975','2013-08-31','10:45:00',5.47),('8975','2013-08-31','10:50:00',5.5),('8975','2013-08-31','10:55:00',5.56),('8975','2013-08-31','11:00:00',5.59),('8975','2013-08-31','11:05:00',5.62),('8975','2013-08-31','11:10:00',5.65),('8975','2013-08-31','11:15:00',5.66),('8975','2013-08-31','11:20:00',5.67),('8975','2013-08-31','11:25:00',5.73),('8975','2013-08-31','11:30:00',5.76),('8975','2013-08-31','11:35:00',5.85),('8975','2013-08-31','11:40:00',5.85),('8975','2013-08-31','11:45:00',5.89),('8975','2013-08-31','11:50:00',5.89),('8975','2013-08-31','11:55:00',5.86),('8975','2013-08-31','12:00:00',5.73),('8975','2013-08-31','12:05:00',5.59),('8975','2013-08-31','12:10:00',5.73),('8975','2013-08-31','12:15:00',5.83),('8975','2013-08-31','12:20:00',5.8),('8975','2013-08-31','12:25:00',5.71),('8975','2013-08-31','12:30:00',5.8),('8975','2013-08-31','12:35:00',5.81),('8975','2013-08-31','12:40:00',5.22),('8975','2013-08-31','12:45:00',5.67),('8975','2013-08-31','12:50:00',5.81),('8975','2013-08-31','12:55:00',5.79),('8975','2013-08-31','13:00:00',5.8),('8975','2013-08-31','13:05:00',5.87),('8975','2013-08-31','13:10:00',5.44),('8975','2013-08-31','13:15:00',4.59),('8975','2013-08-31','13:20:00',5.95),('8975','2013-08-31','13:25:00',5.82),('8975','2013-08-31','13:30:00',5.76),('8975','2013-08-31','13:35:00',5.62),('8975','2013-08-31','13:40:00',5.66),('8975','2013-08-31','13:45:00',5.51),('8975','2013-08-31','13:50:00',5.07),('8975','2013-08-31','13:55:00',4.42),('8975','2013-08-31','14:00:00',4.11),('8975','2013-08-31','14:05:00',4.09),('8975','2013-08-31','14:10:00',4.99),('8975','2013-08-31','14:15:00',4.75),('8975','2013-08-31','14:20:00',4.65),('8975','2013-08-31','14:25:00',4.5),('8975','2013-08-31','14:30:00',4.62),('8975','2013-08-31','14:35:00',4.62),('8975','2013-08-31','14:40:00',4.47),('8975','2013-08-31','14:45:00',4.47),('8975','2013-08-31','14:50:00',4.38),('8975','2013-08-31','14:55:00',4.35),('8975','2013-08-31','15:00:00',4.28),('8975','2013-08-31','15:05:00',4.15),('8975','2013-08-31','15:10:00',3.97),('8975','2013-08-31','15:15:00',3.79),('8975','2013-08-31','15:20:00',3.21),('8975','2013-08-31','15:25:00',2.89),('8975','2013-08-31','15:30:00',2.68),('8975','2013-08-31','15:35:00',2.96),('8975','2013-08-31','15:40:00',3.17),('8975','2013-08-31','15:45:00',2.83),('8975','2013-08-31','15:50:00',2.88),('8975','2013-08-31','15:55:00',3.22),('8975','2013-08-31','16:00:00',3.39),('8975','2013-08-31','16:05:00',3.45),('8975','2013-08-31','16:10:00',3.27),('8975','2013-08-31','16:15:00',3.21),('8975','2013-08-31','16:20:00',2.78),('8975','2013-08-31','16:25:00',3.09),('8975','2013-08-31','16:30:00',3.03),('8975','2013-08-31','16:35:00',2.87),('8975','2013-08-31','16:40:00',2.74),('8975','2013-08-31','16:45:00',2.51),('8975','2013-08-31','16:50:00',2.38),('8975','2013-08-31','16:55:00',2.23),('8975','2013-08-31','17:00:00',2.09),('8975','2013-08-31','17:05:00',2.04),('8975','2013-08-31','17:10:00',1.77),('8975','2013-08-31','17:15:00',1.67),('8975','2013-08-31','17:20:00',1.76),('8975','2013-08-31','17:25:00',1.68),('8975','2013-08-31','17:30:00',1.65),('8975','2013-08-31','17:35:00',1.58),('8975','2013-08-31','17:40:00',1.45),('8975','2013-08-31','17:45:00',1.31),('8975','2013-08-31','17:50:00',1.18),('8975','2013-08-31','17:55:00',1.22),('8975','2013-08-31','18:00:00',1.23),('8975','2013-08-31','18:05:00',1.19),('8975','2013-08-31','18:10:00',1.34),('8975','2013-08-31','18:15:00',1.35),('8975','2013-08-31','18:20:00',1.25),('8975','2013-08-31','18:25:00',1.09),('8975','2013-08-31','18:30:00',1.07),('8975','2013-08-31','18:40:00',1.06),('8975','2013-08-30','07:15:00',1.24),('8975','2013-08-30','07:20:00',1.49),('8975','2013-08-30','07:25:00',1.6),('8975','2013-08-30','07:30:00',1.41),('8975','2013-08-30','07:35:00',1.05),('8975','2013-08-30','07:45:00',1.04),('8975','2013-08-30','07:50:00',1.43),('8975','2013-08-30','07:55:00',1.46),('8975','2013-08-30','08:00:00',1.39),('8975','2013-08-30','08:05:00',1.42),('8975','2013-08-30','08:10:00',1.08),('8975','2013-08-30','08:15:00',1.48),('8975','2013-08-30','08:20:00',2.31),('8975','2013-08-30','08:25:00',2.82),('8975','2013-08-30','08:30:00',3.35),('8975','2013-08-30','08:35:00',3.43),('8975','2013-08-30','08:40:00',3.6),('8975','2013-08-30','08:45:00',3.75),('8975','2013-08-30','08:50:00',3.95),('8975','2013-08-30','08:55:00',4.2),('8975','2013-08-30','09:00:00',4.33),('8975','2013-08-30','09:05:00',3.96),('8975','2013-08-30','09:10:00',3.56),('8975','2013-08-30','09:15:00',3.72),('8975','2013-08-30','09:20:00',3.95),('8975','2013-08-30','09:25:00',4.64),('8975','2013-08-30','09:30:00',4.67),('8975','2013-08-30','09:35:00',4.86),('8975','2013-08-30','09:40:00',4.88),('8975','2013-08-30','09:45:00',4.67),('8975','2013-08-30','09:50:00',4.75),('8975','2013-08-30','09:55:00',4.89),('8975','2013-08-30','10:00:00',5.26),('8975','2013-08-30','10:05:00',5.03),('8975','2013-08-30','10:10:00',5.17),('8975','2013-08-30','10:15:00',5.26),('8975','2013-08-30','10:20:00',5.31),('8975','2013-08-30','10:25:00',5.33),('8975','2013-08-30','10:30:00',5.43),('8975','2013-08-30','10:35:00',5.63),('8975','2013-08-30','10:40:00',5.68),('8975','2013-08-30','10:45:00',5.69),('8975','2013-08-30','10:50:00',5.85),('8975','2013-08-30','10:55:00',5.87),('8975','2013-08-30','11:00:00',6),('8975','2013-08-30','11:05:00',6.06),('8975','2013-08-30','11:10:00',6.09),('8975','2013-08-30','11:15:00',6.11),('8975','2013-08-30','11:20:00',5.75),('8975','2013-08-30','11:25:00',4.93),('8975','2013-08-30','11:30:00',5.82),('8975','2013-08-30','11:35:00',5.68),('8975','2013-08-30','11:40:00',6.19),('8975','2013-08-30','11:45:00',5.83),('8975','2013-08-30','11:50:00',5.98),('8975','2013-08-30','11:55:00',5.36),('8975','2013-08-30','12:00:00',5.38),('8975','2013-08-30','12:05:00',5.53),('8975','2013-08-30','12:10:00',5.89),('8975','2013-08-30','12:15:00',5.72),('8975','2013-08-30','12:20:00',6.13),('8975','2013-08-30','12:25:00',6.09),('8975','2013-08-30','12:30:00',6.03),('8975','2013-08-30','12:35:00',5.91),('8975','2013-08-30','12:40:00',5.94),('8975','2013-08-30','12:45:00',6.02),('8975','2013-08-30','12:50:00',5.99),('8975','2013-08-30','12:55:00',6),('8975','2013-08-30','13:00:00',5.98),('8975','2013-08-30','13:05:00',6.02),('8975','2013-08-30','13:10:00',5.92),('8975','2013-08-30','13:15:00',5.9),('8975','2013-08-30','13:20:00',5.86),('8975','2013-08-30','13:25:00',5.83),('8975','2013-08-30','13:30:00',5.8),('8975','2013-08-30','13:35:00',5.64),('8975','2013-08-30','13:40:00',5.63),('8975','2013-08-30','13:45:00',5.55),('8975','2013-08-30','13:50:00',5.56),('8975','2013-08-30','13:55:00',5.51),('8975','2013-08-30','14:00:00',5.46),('8975','2013-08-30','14:05:00',5.43),('8975','2013-08-30','14:10:00',5.33),('8975','2013-08-30','14:15:00',5.27),('8975','2013-08-30','14:20:00',5.21),('8975','2013-08-30','14:25:00',5.14),('8975','2013-08-30','14:30:00',5.04),('8975','2013-08-30','14:35:00',4.8),('8975','2013-08-30','14:40:00',4.8),('8975','2013-08-30','14:45:00',4.75),('8975','2013-08-30','14:50:00',4.69),('8975','2013-08-30','14:55:00',4.54),('8975','2013-08-30','15:00:00',4.54),('8975','2013-08-30','15:05:00',4.43),('8975','2013-08-30','15:10:00',4.27),('8975','2013-08-30','15:15:00',4.17),('8975','2013-08-30','15:20:00',3.99),('8975','2013-08-30','15:25:00',3.9),('8975','2013-08-30','15:30:00',3.67),('8975','2013-08-30','15:35:00',3.6),('8975','2013-08-30','15:40:00',3.7),('8975','2013-08-30','15:45:00',3.59),('8975','2013-08-30','15:50:00',3.47),('8975','2013-08-30','15:55:00',3.3),('8975','2013-08-30','16:00:00',3.17),('8975','2013-08-30','16:05:00',3.11),('8975','2013-08-30','16:10:00',2.99),('8975','2013-08-30','16:15:00',2.91),('8975','2013-08-30','16:20:00',2.85),('8975','2013-08-30','16:25:00',2.71),('8975','2013-08-30','16:30:00',2.61),('8975','2013-08-30','16:35:00',2.55),('8975','2013-08-30','16:40:00',2.45),('8975','2013-08-30','16:45:00',2.3),('8975','2013-08-30','16:50:00',2.14),('8975','2013-08-30','16:55:00',2.05),('8975','2013-08-30','17:00:00',1.91),('8975','2013-08-30','17:05:00',1.87),('8975','2013-08-30','17:10:00',1.83),('8975','2013-08-30','17:15:00',1.73),('8975','2013-08-30','17:20:00',1.67),('8975','2013-08-30','17:25:00',1.6),('8975','2013-08-30','17:30:00',1.53),('8975','2013-08-30','17:35:00',1.43),('8975','2013-08-30','17:40:00',1.38),('8975','2013-08-30','17:45:00',1.36),('8975','2013-08-30','17:50:00',1.25),('8975','2013-08-30','17:55:00',1.15),('8975','2013-08-30','18:10:00',1.12),('8975','2013-08-29','07:15:00',1.07),('8975','2013-08-29','07:20:00',1.43),('8975','2013-08-29','07:25:00',1.47),('8975','2013-08-29','07:30:00',1.71),('8975','2013-08-29','07:35:00',2),('8975','2013-08-29','07:40:00',2.09),('8975','2013-08-29','07:45:00',2.22),('8975','2013-08-29','07:50:00',2.26),('8975','2013-08-29','07:55:00',2.28),('8975','2013-08-29','08:00:00',2.47),('8975','2013-08-29','08:05:00',2.9),('8975','2013-08-29','08:10:00',3.12),('8975','2013-08-29','08:15:00',2.9),('8975','2013-08-29','08:20:00',2.97),('8975','2013-08-29','08:25:00',2.85),('8975','2013-08-29','08:30:00',2.94),('8975','2013-08-29','08:35:00',2.85),('8975','2013-08-29','08:40:00',3.03),('8975','2013-08-29','08:45:00',2.68),('8975','2013-08-29','08:50:00',2.38),('8975','2013-08-29','08:55:00',2.29),('8975','2013-08-29','09:00:00',2.57),('8975','2013-08-29','09:05:00',2.92),('8975','2013-08-29','09:10:00',2.54),('8975','2013-08-29','09:15:00',2.36),('8975','2013-08-29','09:20:00',2.08),('8975','2013-08-29','09:25:00',2.15),('8975','2013-08-29','09:30:00',2.74),('8975','2013-08-29','09:35:00',3.03),('8975','2013-08-29','09:40:00',2.89),('8975','2013-08-29','09:45:00',3.13),('8975','2013-08-29','09:50:00',3.06),('8975','2013-08-29','09:55:00',3.31),('8975','2013-08-29','10:00:00',3.25),('8975','2013-08-29','10:05:00',3.32),('8975','2013-08-29','10:10:00',3.18),('8975','2013-08-29','10:15:00',3.36),('8975','2013-08-29','10:20:00',3.67),('8975','2013-08-29','10:25:00',3.33),('8975','2013-08-29','10:30:00',3.6),('8975','2013-08-29','10:35:00',3.49),('8975','2013-08-29','10:40:00',3.23),('8975','2013-08-29','10:45:00',3.17),('8975','2013-08-29','10:50:00',3.33),('8975','2013-08-29','10:55:00',3.18),('8975','2013-08-29','11:00:00',3.37),('8975','2013-08-29','11:05:00',3.54),('8975','2013-08-29','11:10:00',3.7),('8975','2013-08-29','11:15:00',3.65),('8975','2013-08-29','11:20:00',3.71),('8975','2013-08-29','11:25:00',3.77),('8975','2013-08-29','11:30:00',4.09),('8975','2013-08-29','11:35:00',3.8),('8975','2013-08-29','11:40:00',4.14),('8975','2013-08-29','11:45:00',4.26),('8975','2013-08-29','11:50:00',4.56),('8975','2013-08-29','11:55:00',4.2),('8975','2013-08-29','12:00:00',3.81),('8975','2013-08-29','12:05:00',3.27),('8975','2013-08-29','12:10:00',3.42),('8975','2013-08-29','12:15:00',3.87),('8975','2013-08-29','12:20:00',4.21),('8975','2013-08-29','12:25:00',4.57),('8975','2013-08-29','12:30:00',5.12),('8975','2013-08-29','12:35:00',4.43),('8975','2013-08-29','12:40:00',4.52),('8975','2013-08-29','12:45:00',4.74),('8975','2013-08-29','12:50:00',4.75),('8975','2013-08-29','12:55:00',4.47),('8975','2013-08-29','13:00:00',4.35),('8975','2013-08-29','13:05:00',4.36),('8975','2013-08-29','13:10:00',4.18),('8975','2013-08-29','13:15:00',4),('8975','2013-08-29','13:20:00',4.85),('8975','2013-08-29','13:25:00',5.83),('8975','2013-08-29','13:30:00',5.79),('8975','2013-08-29','13:35:00',5.39),('8975','2013-08-29','13:40:00',5.62),('8975','2013-08-29','13:45:00',4.84),('8975','2013-08-29','13:50:00',4.95),('8975','2013-08-29','13:55:00',5.59),('8975','2013-08-29','14:00:00',5.56),('8975','2013-08-29','14:05:00',5.42),('8975','2013-08-29','14:10:00',5.46),('8975','2013-08-29','14:15:00',5.37),('8975','2013-08-29','14:20:00',5.3),('8975','2013-08-29','14:25:00',5.31),('8975','2013-08-29','14:30:00',5.15),('8975','2013-08-29','14:35:00',5.19),('8975','2013-08-29','14:40:00',4.96),('8975','2013-08-29','14:45:00',3.63),('8975','2013-08-29','14:50:00',3.16),('8975','2013-08-29','14:55:00',3.71),('8975','2013-08-29','15:00:00',3.33),('8975','2013-08-29','15:05:00',3.25),('8975','2013-08-29','15:10:00',3.24),('8975','2013-08-29','15:15:00',3.81),('8975','2013-08-29','15:20:00',3.22),('8975','2013-08-29','15:25:00',2.89),('8975','2013-08-29','15:30:00',2.98),('8975','2013-08-29','15:35:00',2.48),('8975','2013-08-29','15:40:00',2.58),('8975','2013-08-29','15:45:00',2.8),('8975','2013-08-29','15:50:00',3.11),('8975','2013-08-29','15:55:00',3.16),('8975','2013-08-29','16:00:00',2.91),('8975','2013-08-29','16:05:00',2.61),('8975','2013-08-29','16:10:00',2.29),('8975','2013-08-29','16:15:00',2.05),('8975','2013-08-29','16:20:00',2.02),('8975','2013-08-29','16:25:00',1.8),('8975','2013-08-29','16:30:00',1.92),('8975','2013-08-29','16:35:00',2.46),('8975','2013-08-29','16:40:00',2.66),('8975','2013-08-29','16:45:00',2.62),('8975','2013-08-29','16:50:00',2.54),('8975','2013-08-29','16:55:00',2.44),('8975','2013-08-29','17:00:00',2.52),('8975','2013-08-29','17:05:00',2.63),('8975','2013-08-29','17:10:00',1.93),('8975','2013-08-29','17:15:00',1.5),('8975','2013-08-29','17:20:00',1.39),('8975','2013-08-29','17:25:00',1.38),('8975','2013-08-29','17:30:00',1.57),('8975','2013-08-29','17:35:00',1.73),('8975','2013-08-29','17:40:00',1.96),('8975','2013-08-29','17:45:00',1.7),('8975','2013-08-29','17:50:00',1.67),('8975','2013-08-29','17:55:00',1.47),('8975','2014-04-10','07:40:00',1.33),('8975','2014-04-10','07:45:00',2.17),('8975','2014-04-10','07:50:00',2.47),('8975','2014-04-10','07:55:00',2.66),('8975','2014-04-10','08:00:00',1.32),('8975','2014-04-10','08:15:00',1.03),('8975','2014-04-10','08:25:00',1.12),('8975','2014-04-10','08:30:00',1.03),('8975','2014-04-10','08:35:00',3.84),('8975','2014-04-10','08:40:00',3.97),('8975','2014-04-10','08:45:00',4.13),('8975','2014-04-10','08:50:00',4.05),('8975','2014-04-10','08:55:00',3.99),('8975','2014-04-10','09:00:00',3.71),('8975','2014-04-10','09:05:00',4.04),('8975','2014-04-10','09:10:00',4.23),('8975','2014-04-10','09:15:00',4.33),('8975','2014-04-10','09:20:00',4.36),('8975','2014-04-10','09:25:00',4.46),('8975','2014-04-10','09:30:00',4.53),('8975','2014-04-10','09:35:00',4.69),('8975','2014-04-10','09:40:00',4.73),('8975','2014-04-10','09:45:00',4.86),('8975','2014-04-10','09:50:00',4.91),('8975','2014-04-10','09:55:00',4.86),('8975','2014-04-10','10:00:00',5.18),('8975','2014-04-10','10:05:00',5.29),('8975','2014-04-10','10:10:00',5.36),('8975','2014-04-10','10:15:00',5.4),('8975','2014-04-10','10:20:00',5.51),('8975','2014-04-10','10:25:00',5.58),('8975','2014-04-10','10:30:00',5.69),('8975','2014-04-10','10:35:00',5.69),('8975','2014-04-10','10:40:00',5.71),('8975','2014-04-10','10:45:00',5.89),('8975','2014-04-10','10:50:00',4.26),('8975','2014-04-10','10:55:00',6.06),('8975','2014-04-10','11:00:00',6.06),('8975','2014-04-10','11:05:00',6.05),('8975','2014-04-10','11:10:00',6.09),('8975','2014-04-10','11:15:00',5.49),('8975','2014-04-10','11:20:00',6.24),('8975','2014-04-10','11:25:00',6.3),('8975','2014-04-10','11:30:00',6.39),('8975','2014-04-10','11:35:00',6.41),('8975','2014-04-10','11:40:00',6.39),('8975','2014-04-10','11:45:00',6.31),('8975','2014-04-10','11:50:00',6.89),('8975','2014-04-10','11:55:00',6.77),('8975','2014-04-10','12:00:00',6.71),('8975','2014-04-10','12:05:00',2.9),('8975','2014-04-10','12:10:00',6.56),('8975','2014-04-10','12:15:00',5.78),('8975','2014-04-10','12:20:00',6.6),('8975','2014-04-10','12:25:00',5.92),('8975','2014-04-10','12:30:00',3.81),('8975','2014-04-10','12:35:00',6.32),('8975','2014-04-10','12:40:00',6.87),('8975','2014-04-10','12:45:00',7.4),('8975','2014-04-10','12:50:00',6.46),('8975','2014-04-10','12:55:00',3.96),('8975','2014-04-10','13:00:00',6.84),('8975','2014-04-10','13:05:00',5.63),('8975','2014-04-10','13:10:00',6.24),('8975','2014-04-10','13:15:00',6.49),('8975','2014-04-10','13:20:00',6.5),('8975','2014-04-10','13:25:00',4.97),('8975','2014-04-10','13:30:00',5.29),('8975','2014-04-10','13:35:00',5.26),('8975','2014-04-10','13:40:00',5.15),('8975','2014-04-10','13:45:00',3.63),('8975','2014-04-10','13:50:00',3.35),('8975','2014-04-10','13:55:00',5.42),('8975','2014-04-10','14:00:00',5.83),('8975','2014-04-10','14:05:00',4.78),('8975','2014-04-10','14:10:00',6.43),('8975','2014-04-10','14:15:00',6),('8975','2014-04-10','14:20:00',4.93),('8975','2014-04-10','14:25:00',5.82),('8975','2014-04-10','14:30:00',5.13),('8975','2014-04-10','14:35:00',4.64),('8975','2014-04-10','14:40:00',2.36),('8975','2014-04-10','14:45:00',2.43),('8975','2014-04-10','14:50:00',5.42),('8975','2014-04-10','14:55:00',5.87),('8975','2014-04-10','15:00:00',5.77),('8975','2014-04-10','15:05:00',5.36),('8975','2014-04-10','15:10:00',5.14),('8975','2014-04-10','15:15:00',4.76),('8975','2014-04-10','15:20:00',4.59),('8975','2014-04-10','15:25:00',4.44),('8975','2014-04-10','15:30:00',2.2),('8975','2014-04-10','15:35:00',3.05),('8975','2014-04-10','15:40:00',2.74),('8975','2014-04-10','15:45:00',3.22),('8975','2014-04-10','15:50:00',3.45),('8975','2014-04-10','15:55:00',2.22),('8975','2014-04-10','16:00:00',3.81),('8975','2014-04-10','16:05:00',3.58),('8975','2014-04-10','16:10:00',3.11),('8975','2014-04-10','16:15:00',3.01),('8975','2014-04-10','16:20:00',2.94),('8975','2014-04-10','16:25:00',2.85),('8975','2014-04-10','16:30:00',1.8),('8975','2014-04-10','16:35:00',2.51),('8975','2014-04-10','16:40:00',1.68),('8975','2014-04-10','16:45:00',2.22),('8975','2014-04-10','16:50:00',2.31),('8975','2014-04-10','16:55:00',1.92),('8975','2014-04-10','17:00:00',2.06),('8975','2014-04-10','17:05:00',1.96),('8975','2014-04-10','17:10:00',1.11),('8975','2014-04-10','17:15:00',1.9),('8975','2014-04-10','17:20:00',1.87),('8975','2014-04-10','17:25:00',1.88),('8975','2014-04-10','17:30:00',1.87),('8975','2014-04-10','17:35:00',1.87),('8975','2014-04-10','17:40:00',1.82),('8975','2014-04-10','17:45:00',1.69),('8975','2014-04-10','17:50:00',1.56),('8975','2014-04-10','17:55:00',1.49),('8975','2014-04-10','18:00:00',1.42),('8975','2014-04-10','18:05:00',1.35),('8975','2014-04-10','18:10:00',1.34),('8975','2014-04-10','18:15:00',1.42),('8975','2014-04-10','18:20:00',1.42),('8975','2014-04-10','18:25:00',1.36),('8975','2014-04-10','18:30:00',1.35),('8975','2014-04-10','18:35:00',1.28),('8975','2014-04-10','18:40:00',1.1),('8975','2013-08-28','07:10:00',1.07),('8975','2013-08-28','07:15:00',1.15),('8975','2013-08-28','07:20:00',1.25),('8975','2013-08-28','07:25:00',1.51),('8975','2013-08-28','07:30:00',1.77),('8975','2013-08-28','07:35:00',2.06),('8975','2013-08-28','07:40:00',2.28),('8975','2013-08-28','07:45:00',2.43),('8975','2013-08-28','07:50:00',2.54),('8975','2013-08-28','07:55:00',2.73),('8975','2013-08-28','08:00:00',2.87),('8975','2013-08-28','08:05:00',2.94),('8975','2013-08-28','08:10:00',3.21),('8975','2013-08-28','08:15:00',3.38),('8975','2013-08-28','08:20:00',3.55),('8975','2013-08-28','08:25:00',3.81),('8975','2013-08-28','08:30:00',3.92),('8975','2013-08-28','08:35:00',3.66),('8975','2013-08-28','08:40:00',2.41),('8975','2013-08-28','08:45:00',2.03),('8975','2013-08-28','08:50:00',2.53),('8975','2013-08-28','08:55:00',3.18),('8975','2013-08-28','09:00:00',3.2),('8975','2013-08-28','09:05:00',3.14),('8975','2013-08-28','09:10:00',3.01),('8975','2013-08-28','09:15:00',2.98),('8975','2013-08-28','09:20:00',2.76),('8975','2013-08-28','09:25:00',2.56),('8975','2013-08-28','09:30:00',2.69),('8975','2013-08-28','09:35:00',2.9),('8975','2013-08-28','09:40:00',2.71),('8975','2013-08-28','09:45:00',2.58),('8975','2013-08-28','09:50:00',2.46),('8975','2013-08-28','09:55:00',2.58),('8975','2013-08-28','10:00:00',2.67),('8975','2013-08-28','10:05:00',2.53),('8975','2013-08-28','10:10:00',2.48),('8975','2013-08-28','10:15:00',2.45),('8975','2013-08-28','10:20:00',2.48),('8975','2013-08-28','10:25:00',2.55),('8975','2013-08-28','10:30:00',2.59),('8975','2013-08-28','10:35:00',2.43),('8975','2013-08-28','10:40:00',2.28),('8975','2013-08-28','10:45:00',2.1),('8975','2013-08-28','10:50:00',2.05),('8975','2013-08-28','10:55:00',2.27),('8975','2013-08-28','11:00:00',2.41),('8975','2013-08-28','11:05:00',2.44),('8975','2013-08-28','11:10:00',3.58),('8975','2013-08-28','11:15:00',4.51),('8975','2013-08-28','11:20:00',3.97),('8975','2013-08-28','11:25:00',3.04),('8975','2013-08-28','11:30:00',2.6),('8975','2013-08-28','11:35:00',2.29),('8975','2013-08-28','11:40:00',2.51),('8975','2013-08-28','11:45:00',3.03),('8975','2013-08-28','11:50:00',3.15),('8975','2013-08-28','11:55:00',3.19),('8975','2013-08-28','12:00:00',3.25),('8975','2013-08-28','12:05:00',4.05),('8975','2013-08-28','12:10:00',4.01),('8975','2013-08-28','12:15:00',4.46),('8975','2013-08-28','12:20:00',4.33),('8975','2013-08-28','12:25:00',4.86),('8975','2013-08-28','12:30:00',4.97),('8975','2013-08-28','12:35:00',5.77),('8975','2013-08-28','12:40:00',7.26),('8975','2013-08-28','12:45:00',7.08),('8975','2013-08-28','12:50:00',6.33),('8975','2013-08-28','12:55:00',5.7),('8975','2013-08-28','13:00:00',3.98),('8975','2013-08-28','13:05:00',3.93),('8975','2013-08-28','13:10:00',3.87),('8975','2013-08-28','13:15:00',3.69),('8975','2013-08-28','13:20:00',3.53),('8975','2013-08-28','13:25:00',3.13),('8975','2013-08-28','13:30:00',2.95),('8975','2013-08-28','13:35:00',2.67),('8975','2013-08-28','13:40:00',2.56),('8975','2013-08-28','13:45:00',2.47),('8975','2013-08-28','13:50:00',2.47),('8975','2013-08-28','13:55:00',2.82),('8975','2013-08-28','14:00:00',3.31),('8975','2013-08-28','14:05:00',2.72),('8975','2013-08-28','14:10:00',2.55),('8975','2013-08-28','14:15:00',2.14),('8975','2013-08-28','14:20:00',1.7),('8975','2013-08-28','14:25:00',1.5),('8975','2013-08-28','14:30:00',1.34),('8975','2013-08-28','14:35:00',1.31),('8975','2013-08-28','14:40:00',1.32),('8975','2013-08-28','14:45:00',1.45),('8975','2013-08-28','14:50:00',1.74),('8975','2013-08-28','14:55:00',2.12),('8975','2013-08-28','15:00:00',2.36),('8975','2013-08-28','15:05:00',2.6),('8975','2013-08-28','15:10:00',2.06),('8975','2013-08-28','15:15:00',1.83),('8975','2013-08-28','15:20:00',1.96),('8975','2013-08-28','15:25:00',2.15),('8975','2013-08-28','15:30:00',3.25),('8975','2013-08-28','15:35:00',2.97),('8975','2013-08-28','15:40:00',2.91),('8975','2013-08-28','15:45:00',3.6),('8975','2013-08-28','15:50:00',4.6),('8975','2013-08-28','15:55:00',4.66),('8975','2013-08-28','16:00:00',3.4),('8975','2013-08-28','16:05:00',3.68),('8975','2013-08-28','16:10:00',3.71),('8975','2013-08-28','16:15:00',3.38),('8975','2013-08-28','16:20:00',3.22),('8975','2013-08-28','16:25:00',3.01),('8975','2013-08-28','16:30:00',2.88),('8975','2013-08-28','16:35:00',2.77),('8975','2013-08-28','16:40:00',2.62),('8975','2013-08-28','16:45:00',2.49),('8975','2013-08-28','16:50:00',2.37),('8975','2013-08-28','16:55:00',2.26),('8975','2013-08-28','17:00:00',2.15),('8975','2013-08-28','17:05:00',2.06),('8975','2013-08-28','17:10:00',1.96),('8975','2013-08-28','17:15:00',1.84),('8975','2013-08-28','17:20:00',1.75),('8975','2013-08-28','17:25:00',1.65),('8975','2013-08-28','17:30:00',1.57),('8975','2013-08-28','17:35:00',1.5),('8975','2013-08-28','17:40:00',1.44),('8975','2013-08-28','17:45:00',1.4),('8975','2013-08-28','17:50:00',1.35),('8975','2013-08-28','17:55:00',1.31),('8975','2013-08-28','18:00:00',1.27),('8975','2013-08-28','18:05:00',1.22),('8975','2013-08-28','18:10:00',1.18),('8975','2013-08-28','18:15:00',1.14),('8975','2013-08-28','18:20:00',1.06),('8975','2013-08-27','07:30:00',1.21),('8975','2013-08-27','07:35:00',1.79),('8975','2013-08-27','07:40:00',2.13),('8975','2013-08-27','07:45:00',2.22),('8975','2013-08-27','07:50:00',2.37),('8975','2013-08-27','07:55:00',2.55),('8975','2013-08-27','08:00:00',1.8),('8975','2013-08-27','08:05:00',2.8),('8975','2013-08-27','08:10:00',2.95),('8975','2013-08-27','08:15:00',3.1),('8975','2013-08-27','08:20:00',3.13),('8975','2013-08-27','08:25:00',2.29),('8975','2013-08-27','08:30:00',3.4),('8975','2013-08-27','08:35:00',3.54),('8975','2013-08-27','08:40:00',2.82),('8975','2013-08-27','08:45:00',2.92),('8975','2013-08-27','08:50:00',3.34),('8975','2013-08-27','08:55:00',2.6),('8975','2013-08-27','09:00:00',4.09),('8975','2013-08-27','09:05:00',2.71),('8975','2013-08-27','09:10:00',3.71),('8975','2013-08-27','09:15:00',3.12),('8975','2013-08-27','09:20:00',1.93),('8975','2013-08-27','09:25:00',1.44),('8975','2013-08-27','09:30:00',1.66),('8975','2013-08-27','09:35:00',1.26),('8975','2013-08-27','09:40:00',3),('8975','2013-08-27','09:45:00',4.43),('8975','2013-08-27','09:50:00',4.46),('8975','2013-08-27','09:55:00',5.07),('8975','2013-08-27','10:00:00',5.06),('8975','2013-08-27','10:05:00',5.11),('8975','2013-08-27','10:10:00',5.21),('8975','2013-08-27','10:15:00',4.29),('8975','2013-08-27','10:20:00',5.71),('8975','2013-08-27','10:25:00',5.4),('8975','2013-08-27','10:30:00',3.67),('8975','2013-08-27','10:35:00',1.42),('8975','2013-08-27','10:40:00',3.52),('8975','2013-08-27','10:45:00',1.77),('8975','2013-08-27','10:50:00',2.58),('8975','2013-08-27','10:55:00',3.53),('8975','2013-08-27','11:00:00',6.65),('8975','2013-08-27','11:05:00',6.19),('8975','2013-08-27','11:10:00',1.75),('8975','2013-08-27','11:15:00',6.54),('8975','2013-08-27','11:20:00',6.5),('8975','2013-08-27','11:25:00',4.74),('8975','2013-08-27','11:30:00',4.94),('8975','2013-08-27','11:35:00',4.55),('8975','2013-08-27','11:40:00',6.61),('8975','2013-08-27','11:45:00',6.58),('8975','2013-08-27','11:50:00',2.85),('8975','2013-08-27','11:55:00',3.05),('8975','2013-08-27','12:00:00',5.56),('8975','2013-08-27','12:05:00',6.56),('8975','2013-08-27','12:10:00',1.97),('8975','2013-08-27','12:15:00',6.69),('8975','2013-08-27','12:20:00',6.65),('8975','2013-08-27','12:25:00',6.47),('8975','2013-08-27','12:30:00',6.44),('8975','2013-08-27','12:35:00',6.31),('8975','2013-08-27','12:40:00',6.27),('8975','2013-08-27','12:45:00',6.35),('8975','2013-08-27','12:50:00',6.25),('8975','2013-08-27','12:55:00',6.27),('8975','2013-08-27','13:00:00',6.44),('8975','2013-08-27','13:05:00',4.9),('8975','2013-08-27','13:10:00',5.85),('8975','2013-08-27','13:15:00',6.27),('8975','2013-08-27','13:20:00',6.23),('8975','2013-08-27','13:25:00',6.44),('8975','2013-08-27','13:30:00',6.21),('8975','2013-08-27','13:35:00',6.1),('8975','2013-08-27','13:40:00',3.02),('8975','2013-08-27','13:45:00',3.55),('8975','2013-08-27','13:50:00',6.16),('8975','2013-08-27','13:55:00',6.01),('8975','2013-08-27','14:00:00',4.83),('8975','2013-08-27','14:05:00',5.9),('8975','2013-08-27','14:10:00',5.78),('8975','2013-08-27','14:15:00',5.67),('8975','2013-08-27','14:20:00',5.59),('8975','2013-08-27','14:25:00',5.56),('8975','2013-08-27','14:30:00',5.49),('8975','2013-08-27','14:35:00',5.49),('8975','2013-08-27','14:40:00',5.34),('8975','2013-08-27','14:45:00',5.19),('8975','2013-08-27','14:50:00',5.13),('8975','2013-08-27','14:55:00',5.01),('8975','2013-08-27','15:00:00',4.94),('8975','2013-08-27','15:05:00',4.9),('8975','2013-08-27','15:10:00',4.9),('8975','2013-08-27','15:15:00',4.67),('8975','2013-08-27','15:20:00',4.73),('8975','2013-08-27','15:25:00',4.31),('8975','2013-08-27','15:30:00',3.36),('8975','2013-08-27','15:35:00',4.61),('8975','2013-08-27','15:40:00',3.77),('8975','2013-08-27','15:45:00',2.37),('8975','2013-08-27','15:50:00',4.56),('8975','2013-08-27','15:55:00',2.48),('8975','2013-08-27','16:00:00',2.87),('8975','2013-08-27','16:05:00',4),('8975','2013-08-27','16:10:00',2.89),('8975','2013-08-27','16:15:00',3.17),('8975','2013-08-27','16:20:00',3.23),('8975','2013-08-27','16:25:00',3.22),('8975','2013-08-27','16:30:00',2.89),('8975','2013-08-27','16:35:00',2.93),('8975','2013-08-27','16:40:00',2.75),('8975','2013-08-27','16:45:00',2.64),('8975','2013-08-27','16:50:00',2.51),('8975','2013-08-27','16:55:00',2.38),('8975','2013-08-27','17:00:00',2.25),('8975','2013-08-27','17:05:00',2.16),('8975','2013-08-27','17:10:00',1.36),('8975','2013-08-27','17:15:00',1.91),('8975','2013-08-27','17:20:00',1.43),('8975','2013-08-27','17:25:00',1.81),('8975','2013-08-27','17:30:00',1.85),('8975','2013-08-27','17:35:00',1.66),('8975','2013-08-27','17:40:00',1.64),('8975','2013-08-27','17:50:00',1.37),('8975','2013-08-27','17:55:00',1.59),('8975','2013-08-27','18:00:00',1.5),('8975','2013-08-27','18:05:00',1.01),('8975','2013-08-27','18:10:00',1.06),('8975','2013-08-26','08:10:00',1.13),('8975','2013-08-26','08:15:00',1.51),('8975','2013-08-26','08:20:00',2.4),('8975','2013-08-26','08:25:00',3.25),('8975','2013-08-26','08:30:00',3.19),('8975','2013-08-26','08:35:00',2.13),('8975','2013-08-26','08:40:00',2.06),('8975','2013-08-26','08:45:00',2.45),('8975','2013-08-26','08:50:00',1.66),('8975','2013-08-26','08:55:00',1.56),('8975','2013-08-26','09:00:00',1.72),('8975','2013-08-26','09:05:00',1.95),('8975','2013-08-26','09:10:00',2.31),('8975','2013-08-26','09:15:00',2.28),('8975','2013-08-26','09:20:00',2.9),('8975','2013-08-26','09:25:00',3.78),('8975','2013-08-26','09:30:00',3.64),('8975','2013-08-26','09:35:00',2.08),('8975','2013-08-26','09:40:00',1.67),('8975','2013-08-26','09:45:00',1.74),('8975','2013-08-26','09:50:00',1.78),('8975','2013-08-26','09:55:00',2.35),('8975','2013-08-26','10:00:00',3.34),('8975','2013-08-26','10:05:00',4.53),('8975','2013-08-26','10:10:00',5.12),('8975','2013-08-26','10:15:00',5.23),('8975','2013-08-26','10:20:00',5.29),('8975','2013-08-26','10:25:00',5.31),('8975','2013-08-26','10:30:00',5.34),('8975','2013-08-26','10:35:00',5.35),('8975','2013-08-26','10:40:00',5.28),('8975','2013-08-26','10:45:00',5.44),('8975','2013-08-26','10:50:00',5.56),('8975','2013-08-26','10:55:00',5.51),('8975','2013-08-26','11:00:00',5.5),('8975','2013-08-26','11:05:00',5.6),('8975','2013-08-26','11:10:00',5.55),('8975','2013-08-26','11:15:00',5.5),('8975','2013-08-26','11:20:00',5.68),('8975','2013-08-26','11:25:00',5.63),('8975','2013-08-26','11:30:00',5.53),('8975','2013-08-26','11:35:00',4.56),('8975','2013-08-26','11:40:00',5.13),('8975','2013-08-26','11:45:00',5.85),('8975','2013-08-26','11:50:00',4.14),('8975','2013-08-26','11:55:00',5.88),('8975','2013-08-26','12:00:00',5.44),('8975','2013-08-26','12:05:00',5.42),('8975','2013-08-26','12:10:00',2.75),('8975','2013-08-26','12:15:00',1.99),('8975','2013-08-26','12:20:00',2),('8975','2013-08-26','12:25:00',1.82),('8975','2013-08-26','12:30:00',2.11),('8975','2013-08-26','12:35:00',2.14),('8975','2013-08-26','12:40:00',2.44),('8975','2013-08-26','12:45:00',3.15),('8975','2013-08-26','12:50:00',3.86),('8975','2013-08-26','12:55:00',3.3),('8975','2013-08-26','13:00:00',2.13),('8975','2013-08-26','13:05:00',3.1),('8975','2013-08-26','13:10:00',4.7),('8975','2013-08-26','13:15:00',3.8),('8975','2013-08-26','13:20:00',2.81),('8975','2013-08-26','13:25:00',2.68),('8975','2013-08-26','13:30:00',3.57),('8975','2013-08-26','13:35:00',3.94),('8975','2013-08-26','13:40:00',4.22),('8975','2013-08-26','13:45:00',5.11),('8975','2013-08-26','13:50:00',4.58),('8975','2013-08-26','13:55:00',4.52),('8975','2013-08-26','14:00:00',6.38),('8975','2013-08-26','14:05:00',4.44),('8975','2013-08-26','14:10:00',4.55),('8975','2013-08-26','14:15:00',3.1),('8975','2013-08-26','14:20:00',2.51),('8975','2013-08-26','14:25:00',2.19),('8975','2013-08-26','14:30:00',1.85),('8975','2013-08-26','14:35:00',1.74),('8975','2013-08-26','14:40:00',1.85),('8975','2013-08-26','14:45:00',1.8),('8975','2013-08-26','14:50:00',1.49),('8975','2013-08-26','14:55:00',1.12),('8975','2013-08-26','15:05:00',1.12),('8975','2013-08-26','15:10:00',1.32),('8975','2013-08-26','15:15:00',1.34),('8975','2013-08-26','15:20:00',1.16),('8975','2013-08-26','15:30:00',1.02),('8975','2013-08-26','15:35:00',1.06),('8975','2013-08-26','15:55:00',1.96),('8975','2013-08-26','16:00:00',1.76),('8975','2013-08-26','16:05:00',2.7),('8975','2013-08-26','16:10:00',4.8),('8975','2013-08-26','16:15:00',3.68),('8975','2013-08-26','16:20:00',3.13),('8975','2013-08-26','16:25:00',2.57),('8975','2013-08-26','16:30:00',1.81),('8975','2013-08-26','16:35:00',2.56),('8975','2013-08-26','16:40:00',2.09),('8975','2013-08-26','16:45:00',1.47),('8975','2013-08-26','16:50:00',3.05),('8975','2013-08-26','16:55:00',2.4),('8975','2013-08-26','17:05:00',1.92),('8975','2013-08-26','17:10:00',3.02),('8975','2013-08-26','17:15:00',1.75),('8975','2013-08-26','17:20:00',1.32),('8975','2013-08-26','17:25:00',1.24),('8975','2013-08-26','17:30:00',1.09),('8975','2013-08-26','17:35:00',1.25),('8975','2013-08-26','17:40:00',1.16),('8975','2013-08-26','17:45:00',1.61),('8975','2013-08-26','17:50:00',1.63),('8975','2013-08-26','17:55:00',1.8),('8975','2013-08-26','18:00:00',1.43),('8975','2013-08-26','18:05:00',1.09),('8975','2013-08-25','07:10:00',1.01),('8975','2013-08-25','07:15:00',1.23),('8975','2013-08-25','07:20:00',1.47),('8975','2013-08-25','07:25:00',1.78),('8975','2013-08-25','07:30:00',1.5),('8975','2013-08-25','07:40:00',1.49),('8975','2013-08-25','07:45:00',1.49),('8975','2013-08-25','07:50:00',1.15),('8975','2013-08-25','07:55:00',1.66),('8975','2013-08-25','08:00:00',1.84),('8975','2013-08-25','08:05:00',2.64),('8975','2013-08-25','08:10:00',3.44),('8975','2013-08-25','08:15:00',1.45),('8975','2013-08-25','08:20:00',2.03),('8975','2013-08-25','08:25:00',1.92),('8975','2013-08-25','08:30:00',3.08),('8975','2013-08-25','08:35:00',3.25),('8975','2013-08-25','08:40:00',3.61),('8975','2013-08-25','08:45:00',3.7),('8975','2013-08-25','08:50:00',3.78),('8975','2013-08-25','08:55:00',3.86),('8975','2013-08-25','09:00:00',3.97),('8975','2013-08-25','09:05:00',4.04),('8975','2013-08-25','09:10:00',4.13),('8975','2013-08-25','09:15:00',4.2),('8975','2013-08-25','09:20:00',4.31),('8975','2013-08-25','09:25:00',4.42),('8975','2013-08-25','09:30:00',4.5),('8975','2013-08-25','09:35:00',4.52),('8975','2013-08-25','09:40:00',4.63),('8975','2013-08-25','09:45:00',4.73),('8975','2013-08-25','09:50:00',4.79),('8975','2013-08-25','09:55:00',4.93),('8975','2013-08-25','10:00:00',4.93),('8975','2013-08-25','10:05:00',4.85),('8975','2013-08-25','10:10:00',4.91),('8975','2013-08-25','10:15:00',5.08),('8975','2013-08-25','10:20:00',5.27),('8975','2013-08-25','10:25:00',5.35),('8975','2013-08-25','10:30:00',5.35),('8975','2013-08-25','10:35:00',5.41),('8975','2013-08-25','10:40:00',5.5),('8975','2013-08-25','10:45:00',5.55),('8975','2013-08-25','10:50:00',5.58),('8975','2013-08-25','10:55:00',5.6),('8975','2013-08-25','11:00:00',5.66),('8975','2013-08-25','11:05:00',5.68),('8975','2013-08-25','11:10:00',5.69),('8975','2013-08-25','11:15:00',5.75),('8975','2013-08-25','11:20:00',5.73),('8975','2013-08-25','11:25:00',5.78),('8975','2013-08-25','11:30:00',5.83),('8975','2013-08-25','11:35:00',5.86),('8975','2013-08-25','11:40:00',5.91),('8975','2013-08-25','11:45:00',5.96),('8975','2013-08-25','11:50:00',5.97),('8975','2013-08-25','11:55:00',5.95),('8975','2013-08-25','12:00:00',5.91),('8975','2013-08-25','12:05:00',5.91),('8975','2013-08-25','12:10:00',5.91),('8975','2013-08-25','12:15:00',5.94),('8975','2013-08-25','12:20:00',5.9),('8975','2013-08-25','12:25:00',5.9),('8975','2013-08-25','12:30:00',5.88),('8975','2013-08-25','12:35:00',5.87),('8975','2013-08-25','12:40:00',5.96),('8975','2013-08-25','12:45:00',5.91),('8975','2013-08-25','12:50:00',5.93),('8975','2013-08-25','12:55:00',5.91),('8975','2013-08-25','13:00:00',5.84),('8975','2013-08-25','13:05:00',4.86),('8975','2013-08-25','13:10:00',4.57),('8975','2013-08-25','13:15:00',3.16),('8975','2013-08-25','13:20:00',4.26),('8975','2013-08-25','13:25:00',5.31),('8975','2013-08-25','13:30:00',6.28),('8975','2013-08-25','13:35:00',5.97),('8975','2013-08-25','13:40:00',5.65),('8975','2013-08-25','13:45:00',5.68),('8975','2013-08-25','13:50:00',3.76),('8975','2013-08-25','13:55:00',4.07),('8975','2013-08-25','14:00:00',5.06),('8975','2013-08-25','14:05:00',3.77),('8975','2013-08-25','14:10:00',4.06),('8975','2013-08-25','14:15:00',5.01),('8975','2013-08-25','14:20:00',4.7),('8975','2013-08-25','14:25:00',4.51),('8975','2013-08-25','14:30:00',4.56),('8975','2013-08-25','14:35:00',4.43),('8975','2013-08-25','14:40:00',3.19),('8975','2013-08-25','14:45:00',3.16),('8975','2013-08-25','14:50:00',3.17),('8975','2013-08-25','14:55:00',3.12),('8975','2013-08-25','15:00:00',2.67),('8975','2013-08-25','15:05:00',1.81),('8975','2013-08-25','15:10:00',1.56),('8975','2013-08-25','15:15:00',1.38),('8975','2013-08-25','15:20:00',1.17),('8975','2013-08-25','15:25:00',1.07),('8975','2013-08-25','15:30:00',1.17),('8975','2013-08-25','15:35:00',1.57),('8975','2013-08-25','15:40:00',2.39),('8975','2013-08-25','15:45:00',2.7),('8975','2013-08-25','15:50:00',2.5),('8975','2013-08-25','15:55:00',2.78),('8975','2013-08-25','16:00:00',4.2),('8975','2013-08-25','16:05:00',3.78),('8975','2013-08-25','16:10:00',3.37),('8975','2013-08-25','16:15:00',3.11),('8975','2013-08-25','16:20:00',3.02),('8975','2013-08-25','16:25:00',2.9),('8975','2013-08-25','16:30:00',2.78),('8975','2013-08-25','16:35:00',2.73),('8975','2013-08-25','16:40:00',2.43),('8975','2013-08-25','16:45:00',2.59),('8975','2013-08-25','16:50:00',2.42),('8975','2013-08-25','16:55:00',2.21),('8975','2013-08-25','17:00:00',2.23),('8975','2013-08-25','17:05:00',2),('8975','2013-08-25','17:10:00',1.92),('8975','2013-08-25','17:15:00',1.87),('8975','2013-08-25','17:20:00',1.23),('8975','2013-08-25','17:30:00',1.28),('8975','2013-08-25','17:35:00',1.07),('8975','2013-08-25','17:40:00',1.13),('8975','2013-08-25','17:45:00',1.55),('8975','2013-08-25','17:50:00',1.73),('8975','2013-08-25','17:55:00',1.68),('8975','2013-08-25','18:00:00',1.49),('8975','2013-08-25','18:05:00',1.29),('8975','2013-08-25','18:10:00',1.16),('8975','2013-08-25','18:15:00',1.09),('8975','2013-08-25','18:20:00',1.02),('8975','2013-08-24','07:15:00',1.05),('8975','2013-08-24','07:20:00',1.12),('8975','2013-08-24','07:25:00',1.27),('8975','2013-08-24','07:30:00',1.36),('8975','2013-08-24','07:35:00',1.53),('8975','2013-08-24','07:40:00',1.73),('8975','2013-08-24','07:45:00',1.89),('8975','2013-08-24','07:50:00',2.11),('8975','2013-08-24','07:55:00',1.99),('8975','2013-08-24','08:00:00',2.44),('8975','2013-08-24','08:05:00',2.54),('8975','2013-08-24','08:10:00',2.87),('8975','2013-08-24','08:15:00',2.71),('8975','2013-08-24','08:20:00',2.82),('8975','2013-08-24','08:25:00',2.5),('8975','2013-08-24','08:30:00',1.27),('8975','2013-08-24','08:35:00',1.29),('8975','2013-08-24','08:40:00',1.9),('8975','2013-08-24','08:45:00',1.21),('8975','2013-08-24','08:50:00',1.1),('8975','2013-08-24','08:55:00',1.11),('8975','2013-08-24','09:00:00',1.03),('8975','2013-08-24','09:05:00',1.8),('8975','2013-08-24','09:10:00',1.66),('8975','2013-08-24','09:15:00',3.2),('8975','2013-08-24','09:20:00',3.67),('8975','2013-08-24','09:25:00',2.9),('8975','2013-08-24','09:30:00',2.06),('8975','2013-08-24','09:35:00',3.1),('8975','2013-08-24','09:40:00',4.91),('8975','2013-08-24','09:45:00',5.96),('8975','2013-08-24','09:50:00',5.23),('8975','2013-08-24','09:55:00',5.87),('8975','2013-08-24','10:00:00',4.43),('8975','2013-08-24','10:05:00',3.13),('8975','2013-08-24','10:10:00',1.66),('8975','2013-08-24','10:15:00',1.38),('8975','2013-08-24','10:20:00',1.15),('8975','2013-08-24','15:00:00',1.12),('8975','2013-08-24','15:05:00',1.39),('8975','2013-08-24','15:10:00',1.55),('8975','2013-08-24','15:15:00',1.85),('8975','2013-08-24','15:20:00',2.22),('8975','2013-08-24','15:25:00',2.43),('8975','2013-08-24','15:30:00',3.21),('8975','2013-08-24','15:35:00',4.17),('8975','2013-08-24','15:40:00',4.84),('8975','2013-08-24','15:45:00',4.1),('8975','2013-08-24','15:50:00',3.98),('8975','2013-08-24','15:55:00',3.63),('8975','2013-08-24','16:00:00',3.87),('8975','2013-08-24','16:05:00',3.8),('8975','2013-08-24','16:10:00',3.63),('8975','2013-08-24','16:15:00',3.47),('8975','2013-08-24','16:20:00',3.33),('8975','2013-08-24','16:25:00',3.2),('8975','2013-08-24','16:30:00',3.09),('8975','2013-08-24','16:40:00',2.1),('8975','2013-08-24','16:45:00',1.6),('8975','2013-08-24','16:50:00',2.25),('8975','2013-08-24','16:55:00',2.97),('8975','2013-08-24','17:00:00',2.65),('8975','2013-08-24','17:05:00',2.36),('8975','2013-08-24','17:10:00',2.25),('8975','2013-08-24','17:15:00',2.07),('8975','2013-08-24','17:20:00',1.95),('8975','2013-08-24','17:25:00',1.81),('8975','2013-08-24','17:30:00',1.71),('8975','2013-08-24','17:35:00',1.57),('8975','2013-08-24','17:40:00',1.33),('8975','2013-08-24','17:45:00',1.5),('8975','2013-08-24','17:50:00',1.42),('8975','2013-08-24','17:55:00',1.3),('8975','2013-08-24','18:00:00',1.13),('8975','2013-08-24','18:15:00',1.05),('8975','2013-08-24','18:20:00',1.21),('8975','2013-08-24','18:25:00',1.13),('8975','2013-08-24','18:30:00',1),('8975','2013-08-23','07:20:00',1.09),('8975','2013-08-23','07:25:00',1.31),('8975','2013-08-23','07:30:00',1.41),('8975','2013-08-23','07:35:00',1.61),('8975','2013-08-23','07:40:00',1.86),('8975','2013-08-23','07:45:00',1.89),('8975','2013-08-23','07:50:00',1.84),('8975','2013-08-23','07:55:00',1.91),('8975','2013-08-23','08:00:00',1.74),('8975','2013-08-23','08:05:00',2.1),('8975','2013-08-23','08:10:00',2.6),('8975','2013-08-23','08:15:00',2.09),('8975','2013-08-23','08:20:00',2.58),('8975','2013-08-23','08:25:00',2.85),('8975','2013-08-23','08:30:00',3.18),('8975','2013-08-23','08:35:00',3.33),('8975','2013-08-23','08:40:00',3.62),('8975','2013-08-23','08:45:00',2.45),('8975','2013-08-23','08:50:00',1.84),('8975','2013-08-23','08:55:00',1.21),('8975','2013-08-23','09:00:00',1.39),('8975','2013-08-23','09:05:00',2.36),('8975','2013-08-23','09:10:00',3.62),('8975','2013-08-23','09:15:00',3.91),('8975','2013-08-23','09:20:00',4.03),('8975','2013-08-23','09:25:00',3.49),('8975','2013-08-23','09:30:00',4.49),('8975','2013-08-23','09:35:00',4.62),('8975','2013-08-23','09:40:00',4.61),('8975','2013-08-23','09:45:00',4.86),('8975','2013-08-23','09:50:00',5),('8975','2013-08-23','09:55:00',4.96),('8975','2013-08-23','10:00:00',4.88),('8975','2013-08-23','10:05:00',5),('8975','2013-08-23','10:10:00',4.05),('8975','2013-08-23','10:15:00',4.54),('8975','2013-08-23','10:20:00',3.78),('8975','2013-08-23','10:25:00',5.15),('8975','2013-08-23','10:30:00',4.38),('8975','2013-08-23','10:35:00',5.05),('8975','2013-08-23','10:40:00',5.57),('8975','2013-08-23','10:45:00',5.63),('8975','2013-08-23','10:50:00',5.63),('8975','2013-08-23','10:55:00',5.67),('8975','2013-08-23','11:00:00',5.7),('8975','2013-08-23','11:05:00',5.72),('8975','2013-08-23','11:10:00',5.77),('8975','2013-08-23','11:15:00',5.77),('8975','2013-08-23','11:20:00',5.7),('8975','2013-08-23','11:25:00',5.81),('8975','2013-08-23','11:30:00',5.85),('8975','2013-08-23','11:35:00',5.79),('8975','2013-08-23','11:40:00',5.77),('8975','2013-08-23','11:45:00',5.91),('8975','2013-08-23','11:50:00',5.98),('8975','2013-08-23','11:55:00',5.94),('8975','2013-08-23','12:00:00',5.95),('8975','2013-08-23','12:05:00',5.97),('8975','2013-08-23','12:10:00',5.95),('8975','2013-08-23','12:15:00',5.95),('8975','2013-08-23','12:20:00',5.9),('8975','2013-08-23','12:25:00',5.99),('8975','2013-08-23','12:30:00',5.95),('8975','2013-08-23','12:35:00',5.88),('8975','2013-08-23','12:40:00',5.96),('8975','2013-08-23','12:45:00',5.83),('8975','2013-08-23','12:50:00',5.94),('8975','2013-08-23','12:55:00',5.96),('8975','2013-08-23','13:00:00',5.87),('8975','2013-08-23','13:05:00',5.88),('8975','2013-08-23','13:10:00',5.81),('8975','2013-08-23','13:15:00',5.78),('8975','2013-08-23','13:20:00',5.82),('8975','2013-08-23','13:25:00',5.78),('8975','2013-08-23','13:30:00',5.74),('8975','2013-08-23','13:35:00',5.69),('8975','2013-08-23','13:40:00',5.66),('8975','2013-08-23','13:45:00',5.62),('8975','2013-08-23','13:50:00',5.55),('8975','2013-08-23','13:55:00',5.52),('8975','2013-08-23','14:00:00',5.46),('8975','2013-08-23','14:05:00',5.44),('8975','2013-08-23','14:10:00',5.38),('8975','2013-08-23','14:15:00',5.31),('8975','2013-08-23','14:20:00',5.25),('8975','2013-08-23','14:25:00',5.2),('8975','2013-08-23','14:30:00',5.17),('8975','2013-08-23','14:35:00',5.11),('8975','2013-08-23','14:40:00',5.02),('8975','2013-08-23','14:45:00',4.94),('8975','2013-08-23','14:50:00',4.88),('8975','2013-08-23','14:55:00',4.77),('8975','2013-08-23','15:00:00',4.7),('8975','2013-08-23','15:05:00',4.62),('8975','2013-08-23','15:10:00',4.52),('8975','2013-08-23','15:15:00',4.43),('8975','2013-08-23','15:20:00',4.34),('8975','2013-08-23','15:25:00',4.22),('8975','2013-08-23','15:30:00',4.1),('8975','2013-08-23','15:35:00',3.82),('8975','2013-08-23','15:40:00',3.91),('8975','2013-08-23','15:45:00',3.79),('8975','2013-08-23','15:50:00',3.71),('8975','2013-08-23','15:55:00',3.6),('8975','2013-08-23','16:00:00',3.48),('8975','2013-08-23','16:05:00',3.36),('8975','2013-08-23','16:10:00',3.25),('8975','2013-08-23','16:15:00',3.18),('8975','2013-08-23','16:20:00',3.05),('8975','2013-08-23','16:25:00',2.97),('8975','2013-08-23','16:30:00',2.87),('8975','2013-08-23','16:35:00',2.77),('8975','2013-08-23','16:40:00',2.62),('8975','2013-08-23','16:45:00',2.52),('8975','2013-08-23','16:50:00',2.42),('8975','2013-08-23','16:55:00',2.33),('8975','2013-08-23','17:00:00',2.23),('8975','2013-08-23','17:05:00',2.12),('8975','2013-08-23','17:10:00',2.01),('8975','2013-08-23','17:15:00',1.92),('8975','2013-08-23','17:20:00',1.83),('8975','2013-08-23','17:25:00',1.75),('8975','2013-08-23','17:30:00',1.67),('8975','2013-08-23','17:35:00',1.59),('8975','2013-08-23','17:40:00',1.51),('8975','2013-08-23','17:45:00',1.44),('8975','2013-08-23','17:50:00',1.38),('8975','2013-08-23','17:55:00',1.33),('8975','2013-08-23','18:00:00',1.28),('8975','2013-08-23','18:05:00',1.24),('8975','2013-08-23','18:10:00',1.18),('8975','2013-08-23','18:15:00',1.13),('8975','2013-08-23','18:20:00',1.08),('8975','2013-08-23','18:25:00',1.01),('8975','2013-08-22','07:25:00',1.09),('8975','2013-08-22','07:30:00',1.21),('8975','2013-08-22','07:35:00',1.38),('8975','2013-08-22','07:40:00',1.57),('8975','2013-08-22','07:45:00',1.71),('8975','2013-08-22','07:50:00',1.85),('8975','2013-08-22','07:55:00',1.97),('8975','2013-08-22','08:00:00',2.09),('8975','2013-08-22','08:05:00',2.2),('8975','2013-08-22','08:10:00',2.35),('8975','2013-08-22','08:15:00',2.49),('8975','2013-08-22','08:20:00',2.62),('8975','2013-08-22','08:25:00',2.83),('8975','2013-08-22','08:30:00',2.74),('8975','2013-08-22','08:35:00',2.82),('8975','2013-08-22','08:40:00',3.07),('8975','2013-08-22','08:45:00',3.19),('8975','2013-08-22','08:50:00',3.28),('8975','2013-08-22','08:55:00',3.39),('8975','2013-08-22','09:00:00',3.47),('8975','2013-08-22','09:05:00',3.56),('8975','2013-08-22','09:10:00',3.67),('8975','2013-08-22','09:15:00',3.79),('8975','2013-08-22','09:20:00',3.88),('8975','2013-08-22','09:25:00',3.94),('8975','2013-08-22','09:30:00',3.95),('8975','2013-08-22','09:35:00',4.06),('8975','2013-08-22','09:40:00',4.17),('8975','2013-08-22','09:45:00',4.23),('8975','2013-08-22','09:50:00',4.34),('8975','2013-08-22','09:55:00',4.42),('8975','2013-08-22','10:00:00',4.48),('8975','2013-08-22','10:05:00',4.58),('8975','2013-08-22','10:10:00',4.62),('8975','2013-08-22','10:15:00',4.61),('8975','2013-08-22','10:20:00',4.67),('8975','2013-08-22','10:25:00',4.66),('8975','2013-08-22','10:30:00',4.78),('8975','2013-08-22','10:35:00',4.87),('8975','2013-08-22','10:40:00',4.9),('8975','2013-08-22','10:45:00',4.94),('8975','2013-08-22','10:50:00',5.06),('8975','2013-08-22','10:55:00',5.34),('8975','2013-08-22','11:00:00',2.98),('8975','2013-08-22','11:05:00',2.48),('8975','2013-08-22','11:10:00',1.91),('8975','2013-08-22','11:15:00',3.8),('8975','2013-08-22','11:20:00',5.36),('8975','2013-08-22','11:25:00',5.62),('8975','2013-08-22','11:30:00',5.67),('8975','2013-08-22','11:35:00',5.71),('8975','2013-08-22','11:40:00',5.83),('8975','2013-08-22','11:45:00',4.24),('8975','2013-08-22','11:50:00',6.15),('8975','2013-08-22','11:55:00',5.86),('8975','2013-08-22','12:00:00',5.04),('8975','2013-08-22','12:05:00',2.87),('8975','2013-08-22','12:10:00',5.13),('8975','2013-08-22','12:15:00',4.89),('8975','2013-08-22','12:20:00',2.42),('8975','2013-08-22','12:25:00',1.95),('8975','2013-08-22','12:30:00',3.26),('8975','2013-08-22','12:35:00',1.78),('8975','2013-08-22','12:40:00',1.75),('8975','2013-08-22','12:45:00',1.66),('8975','2013-08-22','12:50:00',2.55),('8975','2013-08-22','12:55:00',2.61),('8975','2013-08-22','13:00:00',4.56),('8975','2013-08-22','13:05:00',6.55),('8975','2013-08-22','13:10:00',6.51),('8975','2013-08-22','13:15:00',6.37),('8975','2013-08-22','13:20:00',6.32),('8975','2013-08-22','13:25:00',6.11),('8975','2013-08-22','13:30:00',6.11),('8975','2013-08-22','13:35:00',6.11),('8975','2013-08-22','13:40:00',6.03),('8975','2013-08-22','13:45:00',5.93),('8975','2013-08-22','13:50:00',5.83),('8975','2013-08-22','13:55:00',5.9),('8975','2013-08-22','14:00:00',5.81),('8975','2013-08-22','14:05:00',5.07),('8975','2013-08-22','14:10:00',5.63),('8975','2013-08-22','14:15:00',5.48),('8975','2013-08-22','14:20:00',5.38),('8975','2013-08-22','14:25:00',5.33),('8975','2013-08-22','14:30:00',3.88),('8975','2013-08-22','14:35:00',4.17),('8975','2013-08-22','14:40:00',5.22),('8975','2013-08-22','14:45:00',4.93),('8975','2013-08-22','14:50:00',4.86),('8975','2013-08-22','14:55:00',4.53),('8975','2013-08-22','15:00:00',4.7),('8975','2013-08-22','15:05:00',3.82),('8975','2013-08-22','15:10:00',4.34),('8975','2013-08-22','15:15:00',3.42),('8975','2013-08-22','15:20:00',4.27),('8975','2013-08-22','15:25:00',4.05),('8975','2013-08-22','15:30:00',4.01),('8975','2013-08-22','15:35:00',3.31),('8975','2013-08-22','15:40:00',3.58),('8975','2013-08-22','15:45:00',3.52),('8975','2013-08-22','15:50:00',3.42),('8975','2013-08-22','15:55:00',3.36),('8975','2013-08-22','16:00:00',3.43),('8975','2013-08-22','16:05:00',3.22),('8975','2013-08-22','16:10:00',2.97),('8975','2013-08-22','16:15:00',3.31),('8975','2013-08-22','16:20:00',3.28),('8975','2013-08-22','16:25:00',3.18),('8975','2013-08-22','16:30:00',3.09),('8975','2013-08-22','16:35:00',2.98),('8975','2013-08-22','16:40:00',2.87),('8975','2013-08-22','16:45:00',2.75),('8975','2013-08-22','16:50:00',2.61),('8975','2013-08-22','16:55:00',2.47),('8975','2013-08-22','17:00:00',2.33),('8975','2013-08-22','17:05:00',2.21),('8975','2013-08-22','17:10:00',2.12),('8975','2013-08-22','17:15:00',1.98),('8975','2013-08-22','17:20:00',1.89),('8975','2013-08-22','17:25:00',1.8),('8975','2013-08-22','17:30:00',1.7),('8975','2013-08-22','17:35:00',1.61),('8975','2013-08-22','17:40:00',1.54),('8975','2013-08-22','17:45:00',1.46),('8975','2013-08-22','17:50:00',1.36),('8975','2013-08-22','17:55:00',1.32),('8975','2013-08-22','18:00:00',1.27),('8975','2013-08-22','18:05:00',1.21),('8975','2013-08-22','18:10:00',1.12),('8975','2013-08-22','18:15:00',1.03),('8975','2013-08-22','18:20:00',1.08),('8975','2013-08-22','18:25:00',1.05),('8975','2013-08-22','18:30:00',1.01),('8975','2013-08-21','07:20:00',1.15),('8975','2013-08-21','07:25:00',1.29),('8975','2013-08-21','07:30:00',1.44),('8975','2013-08-21','07:35:00',1.58),('8975','2013-08-21','07:40:00',1.34),('8975','2013-08-21','07:45:00',1.95),('8975','2013-08-21','07:50:00',2.1),('8975','2013-08-21','07:55:00',2.19),('8975','2013-08-21','08:00:00',2.34),('8975','2013-08-21','08:05:00',2.49),('8975','2013-08-21','08:10:00',2.6),('8975','2013-08-21','08:15:00',2.7),('8975','2013-08-21','08:20:00',2.87),('8975','2013-08-21','08:25:00',3.01),('8975','2013-08-21','08:30:00',3.15),('8975','2013-08-21','08:35:00',3.23),('8975','2013-08-21','08:40:00',3.32),('8975','2013-08-21','08:45:00',3.44),('8975','2013-08-21','08:50:00',3.57),('8975','2013-08-21','08:55:00',3.73),('8975','2013-08-21','09:00:00',3.86),('8975','2013-08-21','09:05:00',4.16),('8975','2013-08-21','09:10:00',4.36),('8975','2013-08-21','09:15:00',4.55),('8975','2013-08-21','09:20:00',4.04),('8975','2013-08-21','09:25:00',2.5),('8975','2013-08-21','09:30:00',3.32),('8975','2013-08-21','09:35:00',3.52),('8975','2013-08-21','09:40:00',5),('8975','2013-08-21','09:45:00',4.54),('8975','2013-08-21','09:50:00',4.84),('8975','2013-08-21','09:55:00',4.9),('8975','2013-08-21','10:00:00',4.98),('8975','2013-08-21','10:05:00',5.05),('8975','2013-08-21','10:10:00',5.07),('8975','2013-08-21','10:15:00',5.09),('8975','2013-08-21','10:20:00',5.11),('8975','2013-08-21','10:25:00',5.2),('8975','2013-08-21','10:30:00',5.23),('8975','2013-08-21','10:35:00',5.33),('8975','2013-08-21','10:40:00',5.38),('8975','2013-08-21','10:45:00',5.43),('8975','2013-08-21','10:50:00',5.45),('8975','2013-08-21','10:55:00',5.51),('8975','2013-08-21','11:00:00',5.53),('8975','2013-08-21','11:05:00',5.58),('8975','2013-08-21','11:10:00',5.6),('8975','2013-08-21','11:15:00',5.64),('8975','2013-08-21','11:20:00',5.67),('8975','2013-08-21','11:25:00',5.67),('8975','2013-08-21','11:30:00',5.68),('8975','2013-08-21','11:35:00',5.72),('8975','2013-08-21','11:40:00',5.76),('8975','2013-08-21','11:45:00',5.72),('8975','2013-08-21','11:50:00',5.73),('8975','2013-08-21','11:55:00',5.79),('8975','2013-08-21','12:00:00',5.74),('8975','2013-08-21','12:05:00',5.76),('8975','2013-08-21','12:10:00',5.79),('8975','2013-08-21','12:15:00',5.81),('8975','2013-08-21','12:20:00',5.78),('8975','2013-08-21','12:25:00',5.8),('8975','2013-08-21','12:30:00',5.78),('8975','2013-08-21','12:35:00',5.76),('8975','2013-08-21','12:40:00',5.76),('8975','2013-08-21','12:45:00',5.75),('8975','2013-08-21','12:50:00',5.71),('8975','2013-08-21','12:55:00',5.65),('8975','2013-08-21','13:00:00',5.64),('8975','2013-08-21','13:05:00',5.66),('8975','2013-08-21','13:10:00',5.68),('8975','2013-08-21','13:15:00',5.64),('8975','2013-08-21','13:20:00',5.57),('8975','2013-08-21','13:25:00',5.5),('8975','2013-08-21','13:30:00',5.44),('8975','2013-08-21','13:35:00',5.39),('8975','2013-08-21','13:40:00',5.39),('8975','2013-08-21','13:45:00',5.35),('8975','2013-08-21','13:50:00',5.29),('8975','2013-08-21','13:55:00',5.25),('8975','2013-08-21','14:00:00',5.26),('8975','2013-08-21','14:05:00',5.22),('8975','2013-08-21','14:10:00',5.08),('8975','2013-08-21','14:15:00',5.11),('8975','2013-08-21','14:20:00',5.12),('8975','2013-08-21','14:25:00',5.07),('8975','2013-08-21','14:30:00',5.04),('8975','2013-08-21','14:35:00',4.97),('8975','2013-08-21','14:40:00',4.95),('8975','2013-08-21','14:45:00',4.9),('8975','2013-08-21','14:50:00',4.84),('8975','2013-08-21','14:55:00',4.83),('8975','2013-08-21','15:00:00',4.73),('8975','2013-08-21','15:05:00',4.54),('8975','2013-08-21','15:10:00',4.48),('8975','2013-08-21','15:15:00',4.4),('8975','2013-08-21','15:20:00',4.29),('8975','2013-08-21','15:25:00',4.2),('8975','2013-08-21','15:30:00',4.03),('8975','2013-08-21','15:35:00',3.91),('8975','2013-08-21','15:40:00',3.86),('8975','2013-08-21','15:45:00',3.78),('8975','2013-08-21','15:50:00',3.66),('8975','2013-08-21','15:55:00',3.57),('8975','2013-08-21','16:00:00',3.46),('8975','2013-08-21','16:05:00',3.38),('8975','2013-08-21','16:10:00',3.26),('8975','2013-08-21','16:15:00',3.13),('8975','2013-08-21','16:20:00',3.05),('8975','2013-08-21','16:25:00',2.97),('8975','2013-08-21','16:30:00',2.88),('8975','2013-08-21','16:35:00',2.77),('8975','2013-08-21','16:40:00',2.67),('8975','2013-08-21','16:45:00',2.57),('8975','2013-08-21','16:50:00',2.43),('8975','2013-08-21','16:55:00',2.33),('8975','2013-08-21','17:00:00',2.25),('8975','2013-08-21','17:05:00',2.16),('8975','2013-08-21','17:10:00',2.04),('8975','2013-08-21','17:15:00',1.96),('8975','2013-08-21','17:20:00',1.87),('8975','2013-08-21','17:25:00',1.79),('8975','2013-08-21','17:30:00',1.69),('8975','2013-08-21','17:35:00',1.61),('8975','2013-08-21','17:40:00',1.55),('8975','2013-08-21','17:45:00',1.48),('8975','2013-08-21','17:50:00',1.4),('8975','2013-08-21','17:55:00',1.34),('8975','2013-08-21','18:00:00',1.3),('8975','2013-08-21','18:05:00',1.25),('8975','2013-08-21','18:10:00',1.28),('8975','2013-08-21','18:15:00',1.32),('8975','2013-08-21','18:20:00',1.29),('8975','2013-08-21','18:25:00',1.12),('8975','2013-08-21','18:30:00',1.04),('8975','2013-08-20','08:20:00',1.06),('8975','2013-08-20','08:25:00',1.17),('8975','2013-08-20','08:30:00',1.3),('8975','2013-08-20','08:35:00',1.39),('8975','2013-08-20','08:40:00',1.34),('8975','2013-08-20','08:45:00',1.11),('8975','2013-08-20','08:55:00',1.07),('8975','2013-08-20','09:00:00',1.75),('8975','2013-08-20','09:05:00',2.47),('8975','2013-08-20','09:10:00',3.44),('8975','2013-08-20','09:15:00',3.99),('8975','2013-08-20','09:20:00',2.47),('8975','2013-08-20','09:25:00',1.61),('8975','2013-08-20','09:30:00',1.42),('8975','2013-08-20','09:35:00',1.69),('8975','2013-08-20','09:40:00',1.91),('8975','2013-08-20','09:45:00',3.17),('8975','2013-08-20','09:50:00',4.38),('8975','2013-08-20','09:55:00',5.1),('8975','2013-08-20','10:00:00',4.07),('8975','2013-08-20','10:05:00',3.29),('8975','2013-08-20','10:10:00',2.75),('8975','2013-08-20','10:15:00',3.11),('8975','2013-08-20','10:20:00',3.26),('8975','2013-08-20','10:25:00',4.45),('8975','2013-08-20','10:30:00',5.03),('8975','2013-08-20','10:35:00',3.25),('8975','2013-08-20','10:40:00',3.81),('8975','2013-08-20','10:45:00',5.68),('8975','2013-08-20','10:50:00',3.9),('8975','2013-08-20','10:55:00',4.41),('8975','2013-08-20','11:00:00',4.68),('8975','2013-08-20','11:05:00',4.12),('8975','2013-08-20','11:10:00',4.14),('8975','2013-08-20','11:15:00',3.56),('8975','2013-08-20','11:20:00',4.78),('8975','2013-08-20','11:25:00',7.06),('8975','2013-08-20','11:30:00',7.16),('8975','2013-08-20','11:35:00',6.65),('8975','2013-08-20','11:40:00',6.52),('8975','2013-08-20','11:45:00',6.57),('8975','2013-08-20','11:50:00',6.39),('8975','2013-08-20','11:55:00',6.15),('8975','2013-08-20','12:00:00',6.24),('8975','2013-08-20','12:05:00',6.22),('8975','2013-08-20','12:10:00',6.23),('8975','2013-08-20','12:15:00',6.12),('8975','2013-08-20','12:20:00',4.58),('8975','2013-08-20','12:25:00',4.33),('8975','2013-08-20','12:30:00',4.43),('8975','2013-08-20','12:35:00',4.25),('8975','2013-08-20','12:40:00',6.3),('8975','2013-08-20','12:45:00',5.85),('8975','2013-08-20','12:50:00',5.65),('8975','2013-08-20','12:55:00',5.72),('8975','2013-08-20','13:00:00',5.87),('8975','2013-08-20','13:05:00',5.88),('8975','2013-08-20','13:10:00',5.96),('8975','2013-08-20','13:15:00',6),('8975','2013-08-20','13:20:00',6.07),('8975','2013-08-20','13:25:00',5.87),('8975','2013-08-20','13:30:00',5.61),('8975','2013-08-20','13:35:00',5.51),('8975','2013-08-20','13:40:00',5.81),('8975','2013-08-20','13:45:00',5.58),('8975','2013-08-20','13:50:00',5.46),('8975','2013-08-20','13:55:00',5.51),('8975','2013-08-20','14:00:00',5.44),('8975','2013-08-20','14:05:00',5.39),('8975','2013-08-20','14:10:00',5.24),('8975','2013-08-20','14:15:00',3.88),('8975','2013-08-20','14:20:00',2.26),('8975','2013-08-20','14:25:00',2.42),('8975','2013-08-20','14:30:00',4.71),('8975','2013-08-20','14:35:00',4.84),('8975','2013-08-20','14:40:00',4.64),('8975','2013-08-20','14:45:00',4.69),('8975','2013-08-20','14:50:00',4.63),('8975','2013-08-20','14:55:00',4.58),('8975','2013-08-20','15:00:00',4.54),('8975','2013-08-20','15:05:00',4.41),('8975','2013-08-20','15:10:00',4.34),('8975','2013-08-20','15:15:00',4.29),('8975','2013-08-20','15:20:00',4.12),('8975','2013-08-20','15:25:00',3.87),('8975','2013-08-20','15:30:00',3.58),('8975','2013-08-20','15:35:00',3.45),('8975','2013-08-20','15:40:00',3.47),('8975','2013-08-20','15:45:00',3.5),('8975','2013-08-20','15:50:00',3.47),('8975','2013-08-20','15:55:00',3.43),('8975','2013-08-20','16:00:00',3.54),('8975','2013-08-20','16:05:00',3.2),('8975','2013-08-20','16:10:00',2.88),('8975','2013-08-20','16:15:00',2.83),('8975','2013-08-20','16:20:00',3),('8975','2013-08-20','16:25:00',3.01),('8975','2013-08-20','16:30:00',2.93),('8975','2013-08-20','16:35:00',3.13),('8975','2013-08-20','16:40:00',3),('8975','2013-08-20','16:45:00',2.8),('8975','2013-08-20','16:50:00',2.66),('8975','2013-08-20','16:55:00',2.61),('8975','2013-08-20','17:00:00',2.51),('8975','2013-08-20','17:05:00',2.41),('8975','2013-08-20','17:10:00',2.35),('8975','2013-08-20','17:15:00',2.27),('8975','2013-08-20','17:20:00',2.17),('8975','2013-08-20','17:25:00',2.11),('8975','2013-08-20','17:30:00',2.06),('8975','2013-08-20','17:35:00',2.01),('8975','2013-08-20','17:40:00',1.95),('8975','2013-08-20','17:45:00',1.89),('8975','2013-08-20','17:50:00',1.82),('8975','2013-08-20','17:55:00',1.76),('8975','2013-08-20','18:00:00',1.68),('8975','2013-08-20','18:05:00',1.61),('8975','2013-08-20','18:10:00',1.54),('8975','2013-08-20','18:15:00',1.41),('8975','2013-08-20','18:20:00',1.33),('8975','2013-08-20','18:25:00',1.24),('8975','2013-08-20','18:30:00',1.09),('8975','2013-08-19','07:40:00',1.11),('8975','2013-08-19','07:45:00',1.17),('8975','2013-08-19','07:50:00',1.98),('8975','2013-08-19','07:55:00',2.48),('8975','2013-08-19','08:00:00',1.83),('8975','2013-08-19','08:05:00',1.61),('8975','2013-08-19','08:10:00',1.13),('8975','2013-08-19','08:15:00',1.12),('8975','2013-08-19','08:20:00',1.27),('8975','2013-08-19','08:25:00',1.22),('8975','2013-08-19','08:30:00',1.18),('8975','2013-08-19','08:35:00',1.19),('8975','2013-08-19','08:40:00',1.26),('8975','2013-08-19','08:45:00',1.42),('8975','2013-08-19','08:50:00',1.62),('8975','2013-08-19','08:55:00',1.53),('8975','2013-08-19','09:00:00',1.94),('8975','2013-08-19','09:05:00',1.66),('8975','2013-08-19','09:10:00',1.83),('8975','2013-08-19','09:15:00',1.76),('8975','2013-08-19','09:20:00',1.79),('8975','2013-08-19','09:25:00',3.14),('8975','2013-08-19','09:30:00',3.55),('8975','2013-08-19','09:35:00',5.14),('8975','2013-08-19','09:40:00',5.42),('8975','2013-08-19','09:45:00',5.05),('8975','2013-08-19','09:50:00',3.26),('8975','2013-08-19','09:55:00',3.32),('8975','2013-08-19','10:00:00',5.14),('8975','2013-08-19','10:05:00',4.74),('8975','2013-08-19','10:10:00',4.6),('8975','2013-08-19','10:15:00',4.99),('8975','2013-08-19','10:20:00',3.64),('8975','2013-08-19','10:25:00',2),('8975','2013-08-19','10:30:00',1.78),('8975','2013-08-19','10:35:00',1.82),('8975','2013-08-19','10:40:00',1.89),('8975','2013-08-19','10:45:00',2.27),('8975','2013-08-19','10:50:00',2.18),('8975','2013-08-19','10:55:00',2.47),('8975','2013-08-19','11:00:00',3.28),('8975','2013-08-19','11:05:00',1.6),('8975','2013-08-19','11:10:00',5.62),('8975','2013-08-19','11:15:00',6.4),('8975','2013-08-19','11:20:00',5.56),('8975','2013-08-19','11:25:00',2.05),('8975','2013-08-19','11:30:00',6.31),('8975','2013-08-19','11:35:00',4.84),('8975','2013-08-19','11:40:00',5.82),('8975','2013-08-19','11:45:00',5.72),('8975','2013-08-19','11:50:00',5.17),('8975','2013-08-19','11:55:00',5.19),('8975','2013-08-19','12:00:00',2.59),('8975','2013-08-19','12:05:00',2.76),('8975','2013-08-19','12:10:00',2.38),('8975','2013-08-19','12:15:00',1.77),('8975','2013-08-19','12:20:00',1.94),('8975','2013-08-19','12:25:00',2.44),('8975','2013-08-19','12:30:00',2.57),('8975','2013-08-19','12:35:00',2.66),('8975','2013-08-19','12:40:00',2.73),('8975','2013-08-19','12:45:00',2.61),('8975','2013-08-19','12:50:00',2.62),('8975','2013-08-19','12:55:00',2.73),('8975','2013-08-19','13:00:00',2.68),('8975','2013-08-19','13:05:00',2.67),('8975','2013-08-19','13:10:00',2.8),('8975','2013-08-19','13:15:00',2.87),('8975','2013-08-19','13:20:00',3.05),('8975','2013-08-19','13:25:00',3.09),('8975','2013-08-19','13:30:00',3.31),('8975','2013-08-19','13:35:00',4.26),('8975','2013-08-19','13:40:00',6.9),('8975','2013-08-19','13:45:00',5.76),('8975','2013-08-19','13:50:00',6.24),('8975','2013-08-19','13:55:00',5.96),('8975','2013-08-19','14:00:00',5.81),('8975','2013-08-19','14:05:00',5.8),('8975','2013-08-19','14:10:00',5.76),('8975','2013-08-19','14:15:00',5.63),('8975','2013-08-19','14:20:00',5.62),('8975','2013-08-19','14:25:00',4.5),('8975','2013-08-19','14:30:00',5.88),('8975','2013-08-19','14:35:00',5.78),('8975','2013-08-19','14:40:00',5.58),('8975','2013-08-19','14:45:00',5.69),('8975','2013-08-19','14:50:00',5.44),('8975','2013-08-19','14:55:00',3.82),('8975','2013-08-19','15:00:00',4.07),('8975','2013-08-19','15:05:00',5.35),('8975','2013-08-19','15:10:00',5.18),('8975','2013-08-19','15:15:00',5.14),('8975','2013-08-19','15:20:00',4.97),('8975','2013-08-19','15:25:00',4.87),('8975','2013-08-19','15:30:00',4.81),('8975','2013-08-19','15:35:00',4.69),('8975','2013-08-19','15:40:00',4.64),('8975','2013-08-19','15:45:00',4.92),('8975','2013-08-19','15:50:00',4.72),('8975','2013-08-19','15:55:00',5.43),('8975','2013-08-19','16:00:00',4.55),('8975','2013-08-19','16:05:00',4.75),('8975','2013-08-19','16:10:00',4.53),('8975','2013-08-19','16:15:00',4.39),('8975','2013-08-19','16:20:00',4.29),('8975','2013-08-19','16:25:00',4.16),('8975','2013-08-19','16:30:00',3.79),('8975','2013-08-19','16:35:00',3.85),('8975','2013-08-19','16:40:00',3.84),('8975','2013-08-19','16:45:00',3.72),('8975','2013-08-19','16:50:00',3.42),('8975','2013-08-19','16:55:00',3.16),('8975','2013-08-19','17:00:00',2.86),('8975','2013-08-19','17:05:00',2.45),('8975','2013-08-19','17:10:00',2.24),('8975','2013-08-19','17:15:00',2.2),('8975','2013-08-19','17:20:00',2.06),('8975','2013-08-19','17:25:00',1.79),('8975','2013-08-19','17:30:00',1.86),('8975','2013-08-19','17:35:00',1.81),('8975','2013-08-19','17:40:00',1.81),('8975','2013-08-19','17:45:00',1.74),('8975','2013-08-19','17:50:00',1.61),('8975','2013-08-19','17:55:00',1.44),('8975','2013-08-19','18:00:00',1.29),('8975','2013-08-19','18:05:00',1.29),('8975','2013-08-19','18:10:00',1.46),('8975','2013-08-19','18:15:00',1.57),('8975','2013-08-19','18:20:00',1.5),('8975','2013-08-19','18:25:00',1.48),('8975','2013-08-19','18:30:00',1.51),('8975','2013-08-19','18:35:00',1.42),('8975','2013-08-19','18:40:00',1.44),('8975','2013-08-19','18:45:00',1.4),('8975','2013-08-19','18:50:00',1.05),('8975','2013-08-19','18:55:00',1.24),('8975','2013-08-19','19:00:00',1.13),('8975','2014-04-09','07:10:00',1.14),('8975','2014-04-09','07:15:00',1.45),('8975','2014-04-09','07:20:00',1.51),('8975','2014-04-09','07:25:00',1.85),('8975','2014-04-09','07:30:00',1.97),('8975','2014-04-09','07:35:00',2.2),('8975','2014-04-09','07:40:00',2.21),('8975','2014-04-09','07:45:00',2.51),('8975','2014-04-09','07:50:00',2.57),('8975','2014-04-09','07:55:00',2.87),('8975','2014-04-09','08:00:00',3.05),('8975','2014-04-09','08:05:00',3.21),('8975','2014-04-09','08:10:00',3.33),('8975','2014-04-09','08:15:00',3.43),('8975','2014-04-09','08:20:00',3.56),('8975','2014-04-09','08:25:00',3.67),('8975','2014-04-09','08:30:00',3.77),('8975','2014-04-09','08:35:00',3.86),('8975','2014-04-09','08:40:00',3.97),('8975','2014-04-09','08:45:00',4.08),('8975','2014-04-09','08:50:00',4.16),('8975','2014-04-09','08:55:00',4.25),('8975','2014-04-09','09:00:00',4.32),('8975','2014-04-09','09:05:00',4.47),('8975','2014-04-09','09:10:00',4.55),('8975','2014-04-09','09:15:00',4.61),('8975','2014-04-09','09:20:00',4.67),('8975','2014-04-09','09:25:00',4.83),('8975','2014-04-09','09:30:00',4.95),('8975','2014-04-09','09:35:00',5.04),('8975','2014-04-09','09:40:00',5.11),('8975','2014-04-09','09:45:00',5.18),('8975','2014-04-09','09:50:00',5.29),('8975','2014-04-09','09:55:00',5.38),('8975','2014-04-09','10:00:00',5.43),('8975','2014-04-09','10:05:00',5.52),('8975','2014-04-09','10:10:00',5.67),('8975','2014-04-09','10:15:00',5.65),('8975','2014-04-09','10:20:00',5.69),('8975','2014-04-09','10:25:00',5.74),('8975','2014-04-09','10:30:00',5.79),('8975','2014-04-09','10:35:00',5.95),('8975','2014-04-09','10:40:00',6.05),('8975','2014-04-09','10:45:00',6),('8975','2014-04-09','10:50:00',5.94),('8975','2014-04-09','10:55:00',5.97),('8975','2014-04-09','11:00:00',5.98),('8975','2014-04-09','11:05:00',6.31),('8975','2014-04-09','11:10:00',6.02),('8975','2014-04-09','11:15:00',6.31),('8975','2014-04-09','11:20:00',6.35),('8975','2014-04-09','11:25:00',6.53),('8975','2014-04-09','11:30:00',6.47),('8975','2014-04-09','11:35:00',6.55),('8975','2014-04-09','11:40:00',6.38),('8975','2014-04-09','11:45:00',6.52),('8975','2014-04-09','11:50:00',6.27),('8975','2014-04-09','11:55:00',6.45),('8975','2014-04-09','12:00:00',6.36),('8975','2014-04-09','12:05:00',5.87),('8975','2014-04-09','12:10:00',6.18),('8975','2014-04-09','12:15:00',6.39),('8975','2014-04-09','12:20:00',6.29),('8975','2014-04-09','12:25:00',5.95),('8975','2014-04-09','12:30:00',6.01),('8975','2014-04-09','12:35:00',6.47),('8975','2014-04-09','12:40:00',6.12),('8975','2014-04-09','12:45:00',6.22),('8975','2014-04-09','12:50:00',6.29),('8975','2014-04-09','12:55:00',6.16),('8975','2014-04-09','13:00:00',6.11),('8975','2014-04-09','13:05:00',5.67),('8975','2014-04-09','13:10:00',6.11),('8975','2014-04-09','13:15:00',5.93),('8975','2014-04-09','13:20:00',5.49),('8975','2014-04-09','13:25:00',6.21),('8975','2014-04-09','13:30:00',5.96),('8975','2014-04-09','13:35:00',6.18),('8975','2014-04-09','13:40:00',5.87),('8975','2014-04-09','13:45:00',5.92),('8975','2014-04-09','13:50:00',5.97),('8975','2014-04-09','13:55:00',5.93),('8975','2014-04-09','14:00:00',5.85),('8975','2014-04-09','14:05:00',5.75),('8975','2014-04-09','14:10:00',5.58),('8975','2014-04-09','14:15:00',5.66),('8975','2014-04-09','14:20:00',5.63),('8975','2014-04-09','14:25:00',5.57),('8975','2014-04-09','14:30:00',5.5),('8975','2014-04-09','14:35:00',5.42),('8975','2014-04-09','14:40:00',5.29),('8975','2014-04-09','14:45:00',4.63),('8975','2014-04-09','14:50:00',5.11),('8975','2014-04-09','14:55:00',5.09),('8975','2014-04-09','15:00:00',4.97),('8975','2014-04-09','15:05:00',4.85),('8975','2014-04-09','15:10:00',4.72),('8975','2014-04-09','15:15:00',4.5),('8975','2014-04-09','15:20:00',4.36),('8975','2014-04-09','15:25:00',4.21),('8975','2014-04-09','15:30:00',3.99),('8975','2014-04-09','15:35:00',3.81),('8975','2014-04-09','15:40:00',3.64),('8975','2014-04-09','15:45:00',3.75),('8975','2014-04-09','15:50:00',3.58),('8975','2014-04-09','15:55:00',3.57),('8975','2014-04-09','16:00:00',3.57),('8975','2014-04-09','16:05:00',3.57),('8975','2014-04-09','16:10:00',3.51),('8975','2014-04-09','16:15:00',3.54),('8975','2014-04-09','16:20:00',3.39),('8975','2014-04-09','16:25:00',3.26),('8975','2014-04-09','16:30:00',3.19),('8975','2014-04-09','16:35:00',3.08),('8975','2014-04-09','16:40:00',2.95),('8975','2014-04-09','16:45:00',2.91),('8975','2014-04-09','16:50:00',2.64),('8975','2014-04-09','16:55:00',2.52),('8975','2014-04-09','17:00:00',2.4),('8975','2014-04-09','17:05:00',2.25),('8975','2014-04-09','17:10:00',2.2),('8975','2014-04-09','17:15:00',2.04),('8975','2014-04-09','17:20:00',1.96),('8975','2014-04-09','17:25:00',1.84),('8975','2014-04-09','17:30:00',1.72),('8975','2014-04-09','17:35:00',1.65),('8975','2014-04-09','17:40:00',1.59),('8975','2014-04-09','17:45:00',1.54),('8975','2014-04-09','17:50:00',1.5),('8975','2014-04-09','17:55:00',1.44),('8975','2014-04-09','18:00:00',1.39),('8975','2014-04-09','18:05:00',1.34),('8975','2014-04-09','18:10:00',1.28),('8975','2014-04-09','18:15:00',1.22),('8975','2014-04-09','18:20:00',1.16),('8975','2014-04-09','18:25:00',1.08),('8975','2014-04-09','18:30:00',1.02),('8975','2013-08-18','07:10:00',1.01),('8975','2013-08-18','07:20:00',1.42),('8975','2013-08-18','07:25:00',1.44),('8975','2013-08-18','07:30:00',1.41),('8975','2013-08-18','07:35:00',1.26),('8975','2013-08-18','07:40:00',1.87),('8975','2013-08-18','07:45:00',2.15),('8975','2013-08-18','07:50:00',2.1),('8975','2013-08-18','07:55:00',2.05),('8975','2013-08-18','08:00:00',2.52),('8975','2013-08-18','08:05:00',2.75),('8975','2013-08-18','08:10:00',2.83),('8975','2013-08-18','08:15:00',2.99),('8975','2013-08-18','08:20:00',3.07),('8975','2013-08-18','08:25:00',3.14),('8975','2013-08-18','08:30:00',3.31),('8975','2013-08-18','08:35:00',3.4),('8975','2013-08-18','08:40:00',3.55),('8975','2013-08-18','08:45:00',3.66),('8975','2013-08-18','08:50:00',3.79),('8975','2013-08-18','08:55:00',3.91),('8975','2013-08-18','09:00:00',4),('8975','2013-08-18','09:05:00',4.1),('8975','2013-08-18','09:10:00',4.17),('8975','2013-08-18','09:15:00',4.23),('8975','2013-08-18','09:20:00',4.34),('8975','2013-08-18','09:25:00',4.42),('8975','2013-08-18','09:30:00',4.5),('8975','2013-08-18','09:35:00',4.61),('8975','2013-08-18','09:40:00',4.68),('8975','2013-08-18','09:45:00',4.74),('8975','2013-08-18','09:50:00',4.82),('8975','2013-08-18','09:55:00',4.87),('8975','2013-08-18','10:00:00',4.93),('8975','2013-08-18','10:05:00',4.99),('8975','2013-08-18','10:10:00',5.06),('8975','2013-08-18','10:15:00',5.15),('8975','2013-08-18','10:20:00',5.22),('8975','2013-08-18','10:25:00',5.29),('8975','2013-08-18','10:30:00',5.34),('8975','2013-08-18','10:35:00',5.39),('8975','2013-08-18','10:40:00',5.43),('8975','2013-08-18','10:45:00',5.48),('8975','2013-08-18','10:50:00',5.54),('8975','2013-08-18','10:55:00',5.56),('8975','2013-08-18','11:00:00',5.52),('8975','2013-08-18','11:05:00',5.58),('8975','2013-08-18','11:10:00',5.59),('8975','2013-08-18','11:15:00',5.72),('8975','2013-08-18','11:20:00',5.8),('8975','2013-08-18','11:25:00',5.78),('8975','2013-08-18','11:30:00',5.84),('8975','2013-08-18','11:35:00',5.8),('8975','2013-08-18','11:40:00',5.81),('8975','2013-08-18','11:45:00',5.88),('8975','2013-08-18','11:50:00',5.84),('8975','2013-08-18','11:55:00',5.91),('8975','2013-08-18','12:00:00',5.88),('8975','2013-08-18','12:05:00',5.87),('8975','2013-08-18','12:10:00',5.9),('8975','2013-08-18','12:15:00',5.96),('8975','2013-08-18','12:20:00',5.99),('8975','2013-08-18','12:25:00',6.01),('8975','2013-08-18','12:30:00',6.01),('8975','2013-08-18','12:35:00',5.95),('8975','2013-08-18','12:40:00',5.94),('8975','2013-08-18','12:45:00',6),('8975','2013-08-18','12:50:00',6.01),('8975','2013-08-18','12:55:00',6.06),('8975','2013-08-18','13:00:00',6.02),('8975','2013-08-18','13:05:00',6.04),('8975','2013-08-18','13:10:00',6.01),('8975','2013-08-18','13:15:00',5.93),('8975','2013-08-18','13:20:00',5.91),('8975','2013-08-18','13:25:00',5.92),('8975','2013-08-18','13:30:00',5.87),('8975','2013-08-18','13:35:00',5.86),('8975','2013-08-18','13:40:00',5.82),('8975','2013-08-18','13:45:00',5.78),('8975','2013-08-18','13:50:00',5.74),('8975','2013-08-18','13:55:00',5.71),('8975','2013-08-18','14:00:00',5.62),('8975','2013-08-18','14:05:00',5.58),('8975','2013-08-18','14:10:00',5.52),('8975','2013-08-18','14:15:00',5.45),('8975','2013-08-18','14:20:00',5.43),('8975','2013-08-18','14:25:00',5.35),('8975','2013-08-18','14:30:00',5.3),('8975','2013-08-18','14:35:00',5.25),('8975','2013-08-18','14:40:00',5.17),('8975','2013-08-18','14:45:00',5.12),('8975','2013-08-18','14:50:00',5.04),('8975','2013-08-18','14:55:00',4.98),('8975','2013-08-18','15:00:00',4.89),('8975','2013-08-18','15:05:00',4.79),('8975','2013-08-18','15:10:00',4.72),('8975','2013-08-18','15:15:00',4.64),('8975','2013-08-18','15:20:00',4.56),('8975','2013-08-18','15:25:00',4.47),('8975','2013-08-18','15:30:00',4.38),('8975','2013-08-18','15:35:00',4.22),('8975','2013-08-18','15:40:00',4.06),('8975','2013-08-18','15:45:00',4.06),('8975','2013-08-18','15:50:00',3.95),('8975','2013-08-18','15:55:00',3.86),('8975','2013-08-18','16:00:00',3.76),('8975','2013-08-18','16:05:00',3.63),('8975','2013-08-18','16:10:00',3.52),('8975','2013-08-18','16:15:00',3.42),('8975','2013-08-18','16:20:00',3.32),('8975','2013-08-18','16:25:00',3.22),('8975','2013-08-18','16:30:00',3.1),('8975','2013-08-18','16:35:00',2.99),('8975','2013-08-18','16:40:00',2.87),('8975','2013-08-18','16:45:00',2.77),('8975','2013-08-18','16:50:00',2.64),('8975','2013-08-18','16:55:00',2.51),('8975','2013-08-18','17:00:00',2.41),('8975','2013-08-18','17:05:00',2.3),('8975','2013-08-18','17:10:00',2.19),('8975','2013-08-18','17:15:00',2.09),('8975','2013-08-18','17:20:00',1.99),('8975','2013-08-18','17:25:00',1.91),('8975','2013-08-18','17:30:00',1.81),('8975','2013-08-18','17:35:00',1.72),('8975','2013-08-18','17:40:00',1.65),('8975','2013-08-18','17:45:00',1.57),('8975','2013-08-18','17:50:00',1.5),('8975','2013-08-18','17:55:00',1.45),('8975','2013-08-18','18:00:00',1.38),('8975','2013-08-18','18:05:00',1.34),('8975','2013-08-18','18:10:00',1.29),('8975','2013-08-18','18:15:00',1.25),('8975','2013-08-18','18:20:00',1.18),('8975','2013-08-18','18:25:00',1.12),('8975','2013-08-18','18:30:00',1.07),('8975','2013-08-18','18:35:00',1.03),('8975','2013-08-17','07:05:00',1.1),('8975','2013-08-17','07:10:00',1.2),('8975','2013-08-17','07:15:00',1.34),('8975','2013-08-17','07:20:00',1.5),('8975','2013-08-17','07:25:00',1.67),('8975','2013-08-17','07:30:00',1.93),('8975','2013-08-17','07:35:00',2.14),('8975','2013-08-17','07:40:00',2.3),('8975','2013-08-17','07:45:00',2.44),('8975','2013-08-17','07:50:00',2.57),('8975','2013-08-17','07:55:00',2.68),('8975','2013-08-17','08:00:00',2.8),('8975','2013-08-17','08:05:00',2.93),('8975','2013-08-17','08:10:00',3.05),('8975','2013-08-17','08:15:00',3.18),('8975','2013-08-17','08:20:00',3.29),('8975','2013-08-17','08:25:00',3.37),('8975','2013-08-17','08:30:00',3.43),('8975','2013-08-17','08:35:00',3.53),('8975','2013-08-17','08:40:00',3.61),('8975','2013-08-17','08:45:00',3.73),('8975','2013-08-17','08:50:00',3.82),('8975','2013-08-17','08:55:00',3.91),('8975','2013-08-17','09:00:00',4.04),('8975','2013-08-17','09:05:00',4.14),('8975','2013-08-17','09:10:00',4.24),('8975','2013-08-17','09:15:00',4.36),('8975','2013-08-17','09:20:00',4.47),('8975','2013-08-17','09:25:00',4.55),('8975','2013-08-17','09:30:00',4.64),('8975','2013-08-17','09:35:00',4.71),('8975','2013-08-17','09:40:00',4.83),('8975','2013-08-17','09:45:00',4.76),('8975','2013-08-17','09:50:00',4.2),('8975','2013-08-17','09:55:00',4.51),('8975','2013-08-17','10:00:00',4.97),('8975','2013-08-17','10:05:00',4.41),('8975','2013-08-17','10:10:00',5.08),('8975','2013-08-17','10:15:00',5.2),('8975','2013-08-17','10:20:00',5.22),('8975','2013-08-17','10:25:00',5.26),('8975','2013-08-17','10:30:00',5.29),('8975','2013-08-17','10:35:00',5.36),('8975','2013-08-17','10:40:00',5.41),('8975','2013-08-17','10:45:00',5.47),('8975','2013-08-17','10:50:00',5.56),('8975','2013-08-17','10:55:00',5.57),('8975','2013-08-17','11:00:00',5.53),('8975','2013-08-17','11:05:00',5.44),('8975','2013-08-17','11:10:00',5.51),('8975','2013-08-17','11:15:00',5.6),('8975','2013-08-17','11:20:00',5.66),('8975','2013-08-17','11:25:00',5.69),('8975','2013-08-17','11:30:00',5.76),('8975','2013-08-17','11:35:00',5.83),('8975','2013-08-17','11:40:00',5.82),('8975','2013-08-17','11:45:00',5.81),('8975','2013-08-17','11:50:00',5.75),('8975','2013-08-17','11:55:00',5.75),('8975','2013-08-17','12:00:00',5.85),('8975','2013-08-17','12:05:00',5.76),('8975','2013-08-17','12:10:00',5.97),('8975','2013-08-17','12:15:00',5.94),('8975','2013-08-17','12:20:00',6.05),('8975','2013-08-17','12:25:00',6.15),('8975','2013-08-17','12:30:00',6.25),('8975','2013-08-17','12:35:00',6.3),('8975','2013-08-17','12:40:00',6.15),('8975','2013-08-17','12:45:00',5.4),('8975','2013-08-17','12:50:00',5.37),('8975','2013-08-17','12:55:00',3.31),('8975','2013-08-17','13:00:00',5.9),('8975','2013-08-17','13:05:00',4.31),('8975','2013-08-17','13:10:00',6.29),('8975','2013-08-17','13:15:00',6.31),('8975','2013-08-17','13:20:00',3.97),('8975','2013-08-17','13:25:00',6.15),('8975','2013-08-17','13:30:00',6.03),('8975','2013-08-17','13:35:00',5.85),('8975','2013-08-17','13:40:00',5.12),('8975','2013-08-17','13:45:00',5.63),('8975','2013-08-17','13:50:00',5.83),('8975','2013-08-17','13:55:00',5.72),('8975','2013-08-17','14:00:00',5.67),('8975','2013-08-17','14:05:00',5.55),('8975','2013-08-17','14:10:00',5.5),('8975','2013-08-17','14:15:00',5.42),('8975','2013-08-17','14:20:00',5.32),('8975','2013-08-17','14:25:00',5.27),('8975','2013-08-17','14:30:00',5.28),('8975','2013-08-17','14:35:00',5.22),('8975','2013-08-17','14:40:00',5.17),('8975','2013-08-17','14:45:00',5.03),('8975','2013-08-17','14:50:00',5.03),('8975','2013-08-17','14:55:00',4.96),('8975','2013-08-17','15:00:00',4.86),('8975','2013-08-17','15:05:00',4.82),('8975','2013-08-17','15:10:00',4.77),('8975','2013-08-17','15:15:00',4.64),('8975','2013-08-17','15:20:00',4.57),('8975','2013-08-17','15:25:00',4.48),('8975','2013-08-17','15:30:00',4.35),('8975','2013-08-17','15:35:00',4.23),('8975','2013-08-17','15:40:00',4.1),('8975','2013-08-17','15:45:00',4.01),('8975','2013-08-17','15:50:00',3.97),('8975','2013-08-17','15:55:00',3.87),('8975','2013-08-17','16:00:00',3.77),('8975','2013-08-17','16:05:00',3.64),('8975','2013-08-17','16:10:00',3.52),('8975','2013-08-17','16:15:00',3.42),('8975','2013-08-17','16:20:00',3.33),('8975','2013-08-17','16:25:00',3.23),('8975','2013-08-17','16:30:00',3.11),('8975','2013-08-17','16:35:00',3.03),('8975','2013-08-17','16:40:00',2.92),('8975','2013-08-17','16:45:00',2.81),('8975','2013-08-17','16:50:00',2.7),('8975','2013-08-17','16:55:00',2.59),('8975','2013-08-17','17:00:00',2.46),('8975','2013-08-17','17:05:00',2.35),('8975','2013-08-17','17:10:00',2.25),('8975','2013-08-17','17:15:00',2.14),('8975','2013-08-17','17:20:00',2.05),('8975','2013-08-17','17:25:00',1.94),('8975','2013-08-17','17:30:00',1.85),('8975','2013-08-17','17:35:00',1.77),('8975','2013-08-17','17:40:00',1.68),('8975','2013-08-17','17:45:00',1.58),('8975','2013-08-17','17:50:00',1.52),('8975','2013-08-17','17:55:00',1.46),('8975','2013-08-17','18:00:00',1.39),('8975','2013-08-17','18:05:00',1.34),('8975','2013-08-17','18:10:00',1.3),('8975','2013-08-17','18:15:00',1.26),('8975','2013-08-17','18:20:00',1.21),('8975','2013-08-17','18:25:00',1.14),('8975','2013-08-17','18:30:00',1.08),('8975','2013-08-17','18:35:00',1.03),('8975','2013-08-16','07:00:00',1.03),('8975','2013-08-16','07:05:00',1.16),('8975','2013-08-16','07:10:00',1.28),('8975','2013-08-16','07:15:00',1.32),('8975','2013-08-16','07:20:00',1.62),('8975','2013-08-16','07:25:00',1.72),('8975','2013-08-16','07:30:00',1.89),('8975','2013-08-16','07:35:00',2.07),('8975','2013-08-16','07:40:00',2.21),('8975','2013-08-16','07:45:00',2.35),('8975','2013-08-16','07:50:00',2.49),('8975','2013-08-16','07:55:00',2.62),('8975','2013-08-16','08:00:00',2.72),('8975','2013-08-16','08:05:00',2.8),('8975','2013-08-16','08:10:00',2.9),('8975','2013-08-16','08:15:00',3.02),('8975','2013-08-16','08:20:00',3.13),('8975','2013-08-16','08:25:00',3.22),('8975','2013-08-16','08:30:00',3.34),('8975','2013-08-16','08:35:00',3.47),('8975','2013-08-16','08:40:00',3.58),('8975','2013-08-16','08:45:00',3.72),('8975','2013-08-16','08:50:00',3.84),('8975','2013-08-16','08:55:00',3.95),('8975','2013-08-16','09:00:00',4.03),('8975','2013-08-16','09:05:00',4.13),('8975','2013-08-16','09:10:00',4.22),('8975','2013-08-16','09:15:00',4.31),('8975','2013-08-16','09:20:00',4.4),('8975','2013-08-16','09:25:00',4.49),('8975','2013-08-16','09:30:00',4.59),('8975','2013-08-16','09:35:00',4.67),('8975','2013-08-16','09:40:00',4.75),('8975','2013-08-16','09:45:00',4.82),('8975','2013-08-16','09:50:00',4.89),('8975','2013-08-16','09:55:00',4.98),('8975','2013-08-16','10:00:00',5.04),('8975','2013-08-16','10:05:00',5.12),('8975','2013-08-16','10:10:00',5.19),('8975','2013-08-16','10:15:00',5.27),('8975','2013-08-16','10:20:00',5.33),('8975','2013-08-16','10:25:00',5.36),('8975','2013-08-16','10:30:00',5.4),('8975','2013-08-16','10:35:00',5.46),('8975','2013-08-16','10:40:00',5.5),('8975','2013-08-16','10:45:00',5.56),('8975','2013-08-16','10:50:00',5.57),('8975','2013-08-16','10:55:00',5.61),('8975','2013-08-16','11:00:00',5.64),('8975','2013-08-16','11:05:00',5.65),('8975','2013-08-16','11:10:00',5.68),('8975','2013-08-16','11:15:00',5.8),('8975','2013-08-16','11:20:00',5.78),('8975','2013-08-16','11:25:00',5.81),('8975','2013-08-16','11:30:00',5.82),('8975','2013-08-16','11:35:00',5.88),('8975','2013-08-16','11:40:00',5.92),('8975','2013-08-16','11:45:00',5.93),('8975','2013-08-16','11:50:00',5.95),('8975','2013-08-16','11:55:00',6.01),('8975','2013-08-16','12:00:00',6.03),('8975','2013-08-16','12:05:00',5.9),('8975','2013-08-16','12:10:00',5.25),('8975','2013-08-16','12:15:00',1.13),('8975','2013-08-16','12:20:00',1.35),('8975','2013-08-16','12:25:00',5.24),('8975','2013-08-16','12:30:00',6.46),('8975','2013-08-16','12:35:00',6.42),('8975','2013-08-16','12:40:00',6.31),('8975','2013-08-16','12:45:00',6.09),('8975','2013-08-16','12:50:00',6.12),('8975','2013-08-16','12:55:00',6.01),('8975','2013-08-16','13:00:00',6.08),('8975','2013-08-16','13:05:00',6.05),('8975','2013-08-16','13:10:00',5.97),('8975','2013-08-16','13:15:00',5.84),('8975','2013-08-16','13:20:00',6.08),('8975','2013-08-16','13:25:00',5.96),('8975','2013-08-16','13:30:00',6.12),('8975','2013-08-16','13:35:00',5.54),('8975','2013-08-16','13:40:00',1.37),('8975','2013-08-16','13:45:00',3.78),('8975','2013-08-16','13:50:00',4.13),('8975','2013-08-16','13:55:00',1.44),('8975','2013-08-16','14:00:00',2.28),('8975','2013-08-16','14:05:00',2.66),('8975','2013-08-16','14:10:00',1.35),('8975','2013-08-16','14:15:00',3.96),('8975','2013-08-16','14:20:00',5.37),('8975','2013-08-16','14:25:00',4.42),('8975','2013-08-16','14:30:00',5.57),('8975','2013-08-16','14:35:00',5.34),('8975','2013-08-16','14:40:00',5.32),('8975','2013-08-16','14:45:00',5.2),('8975','2013-08-16','14:50:00',5.11),('8975','2013-08-16','14:55:00',5.03),('8975','2013-08-16','15:00:00',4.95),('8975','2013-08-16','15:05:00',4.84),('8975','2013-08-16','15:10:00',4.76),('8975','2013-08-16','15:15:00',4.68),('8975','2013-08-16','15:20:00',4.61),('8975','2013-08-16','15:25:00',4.51),('8975','2013-08-16','15:30:00',4.43),('8975','2013-08-16','15:35:00',4.28),('8975','2013-08-16','15:40:00',4.19),('8975','2013-08-16','15:45:00',4.09),('8975','2013-08-16','15:50:00',4),('8975','2013-08-16','15:55:00',3.89),('8975','2013-08-16','16:00:00',3.78),('8975','2013-08-16','16:05:00',3.7),('8975','2013-08-16','16:10:00',3.57),('8975','2013-08-16','16:15:00',3.46),('8975','2013-08-16','16:20:00',3.37),('8975','2013-08-16','16:25:00',3.26),('8975','2013-08-16','16:30:00',3.18),('8975','2013-08-16','16:35:00',3.1),('8975','2013-08-16','16:40:00',3),('8975','2013-08-16','16:45:00',2.72),('8975','2013-08-16','16:50:00',2.68),('8975','2013-08-16','16:55:00',2.64),('8975','2013-08-16','17:00:00',2.52),('8975','2013-08-16','17:05:00',2.33),('8975','2013-08-16','17:10:00',2.1),('8975','2013-08-16','17:15:00',2.02),('8975','2013-08-16','17:20:00',1.97),('8975','2013-08-16','17:25:00',2),('8975','2013-08-16','17:30:00',1.95),('8975','2013-08-16','17:35:00',1.89),('8975','2013-08-16','17:40:00',1.82),('8975','2013-08-16','17:45:00',1.74),('8975','2013-08-16','17:50:00',1.66),('8975','2013-08-16','17:55:00',1.58),('8975','2013-08-16','18:00:00',1.51),('8975','2013-08-16','18:05:00',1.46),('8975','2013-08-16','18:10:00',1.4),('8975','2013-08-16','18:15:00',1.36),('8975','2013-08-16','18:20:00',1.3),('8975','2013-08-16','18:25:00',1.23),('8975','2013-08-16','18:30:00',1.16),('8975','2013-08-16','18:35:00',1.09),('8975','2013-08-16','18:40:00',1.05),('8975','2013-08-15','07:00:00',1.06),('8975','2013-08-15','07:05:00',1.25),('8975','2013-08-15','07:10:00',1.38),('8975','2013-08-15','07:15:00',1.42),('8975','2013-08-15','07:20:00',1.69),('8975','2013-08-15','07:25:00',1.85),('8975','2013-08-15','07:30:00',1.96),('8975','2013-08-15','07:35:00',2.21),('8975','2013-08-15','07:40:00',2.35),('8975','2013-08-15','07:45:00',2.5),('8975','2013-08-15','07:50:00',2.62),('8975','2013-08-15','07:55:00',2.74),('8975','2013-08-15','08:00:00',2.86),('8975','2013-08-15','08:05:00',2.97),('8975','2013-08-15','08:10:00',3.09),('8975','2013-08-15','08:15:00',3.2),('8975','2013-08-15','08:20:00',3.33),('8975','2013-08-15','08:25:00',3.44),('8975','2013-08-15','08:30:00',3.54),('8975','2013-08-15','08:35:00',3.65),('8975','2013-08-15','08:40:00',3.71),('8975','2013-08-15','08:45:00',3.84),('8975','2013-08-15','08:50:00',3.95),('8975','2013-08-15','08:55:00',4.05),('8975','2013-08-15','09:00:00',4.16),('8975','2013-08-15','09:05:00',4.28),('8975','2013-08-15','09:10:00',4.39),('8975','2013-08-15','09:15:00',4.49),('8975','2013-08-15','09:20:00',4.62),('8975','2013-08-15','09:25:00',4.71),('8975','2013-08-15','09:30:00',4.8),('8975','2013-08-15','09:35:00',4.88),('8975','2013-08-15','09:40:00',4.96),('8975','2013-08-15','09:45:00',5.05),('8975','2013-08-15','09:50:00',5.13),('8975','2013-08-15','09:55:00',5.21),('8975','2013-08-15','10:00:00',5.27),('8975','2013-08-15','10:05:00',5.32),('8975','2013-08-15','10:10:00',5.4),('8975','2013-08-15','10:15:00',5.46),('8975','2013-08-15','10:20:00',5.52),('8975','2013-08-15','10:25:00',5.59),('8975','2013-08-15','10:30:00',5.65),('8975','2013-08-15','10:35:00',5.67),('8975','2013-08-15','10:40:00',5.72),('8975','2013-08-15','10:45:00',5.75),('8975','2013-08-15','10:50:00',5.82),('8975','2013-08-15','10:55:00',5.88),('8975','2013-08-15','11:00:00',5.92),('8975','2013-08-15','11:05:00',5.96),('8975','2013-08-15','11:10:00',6),('8975','2013-08-15','11:15:00',6.02),('8975','2013-08-15','11:20:00',6.03),('8975','2013-08-15','11:25:00',6.04),('8975','2013-08-15','11:30:00',6.08),('8975','2013-08-15','11:35:00',6.13),('8975','2013-08-15','11:40:00',6.13),('8975','2013-08-15','11:45:00',6.11),('8975','2013-08-15','11:50:00',6.08),('8975','2013-08-15','11:55:00',6.1),('8975','2013-08-15','12:00:00',6.11),('8975','2013-08-15','12:05:00',6.14),('8975','2013-08-15','12:10:00',6.13),('8975','2013-08-15','12:15:00',6.16),('8975','2013-08-15','12:20:00',6.13),('8975','2013-08-15','12:25:00',6.1),('8975','2013-08-15','12:30:00',6.09),('8975','2013-08-15','12:35:00',6.07),('8975','2013-08-15','12:40:00',6.05),('8975','2013-08-15','12:45:00',6.08),('8975','2013-08-15','12:50:00',6.05),('8975','2013-08-15','12:55:00',5.99),('8975','2013-08-15','13:00:00',5.98),('8975','2013-08-15','13:05:00',5.94),('8975','2013-08-15','13:10:00',5.92),('8975','2013-08-15','13:15:00',5.91),('8975','2013-08-15','13:20:00',5.91),('8975','2013-08-15','13:25:00',5.87),('8975','2013-08-15','13:30:00',5.83),('8975','2013-08-15','13:35:00',5.81),('8975','2013-08-15','13:40:00',5.79),('8975','2013-08-15','13:45:00',5.74),('8975','2013-08-15','13:50:00',5.69),('8975','2013-08-15','13:55:00',5.63),('8975','2013-08-15','14:00:00',5.59),('8975','2013-08-15','14:05:00',5.59),('8975','2013-08-15','14:10:00',5.53),('8975','2013-08-15','14:15:00',5.45),('8975','2013-08-15','14:20:00',5.37),('8975','2013-08-15','14:25:00',5.29),('8975','2013-08-15','14:30:00',5.26),('8975','2013-08-15','14:35:00',5.15),('8975','2013-08-15','14:40:00',5.05),('8975','2013-08-15','14:45:00',4.99),('8975','2013-08-15','14:50:00',4.97),('8975','2013-08-15','14:55:00',4.85),('8975','2013-08-15','15:00:00',4.8),('8975','2013-08-15','15:05:00',4.74),('8975','2013-08-15','15:10:00',4.65),('8975','2013-08-15','15:15:00',4.64),('8975','2013-08-15','15:20:00',4.58),('8975','2013-08-15','15:25:00',4.45),('8975','2013-08-15','15:30:00',4.37),('8975','2013-08-15','15:35:00',4.31),('8975','2013-08-15','15:40:00',4.2),('8975','2013-08-15','15:45:00',4.1),('8975','2013-08-15','15:50:00',3.99),('8975','2013-08-15','15:55:00',3.88),('8975','2013-08-15','16:00:00',3.79),('8975','2013-08-15','16:05:00',3.7),('8975','2013-08-15','16:10:00',3.59),('8975','2013-08-15','16:15:00',3.47),('8975','2013-08-15','16:20:00',3.38),('8975','2013-08-15','16:25:00',3.28),('8975','2013-08-15','16:30:00',3.17),('8975','2013-08-15','16:35:00',3.07),('8975','2013-08-15','16:40:00',2.94),('8975','2013-08-15','16:45:00',2.83),('8975','2013-08-15','16:50:00',2.73),('8975','2013-08-15','16:55:00',2.6),('8975','2013-08-15','17:00:00',2.48),('8975','2013-08-15','17:05:00',2.36),('8975','2013-08-15','17:10:00',2.25),('8975','2013-08-15','17:15:00',2.15),('8975','2013-08-15','17:20:00',2.05),('8975','2013-08-15','17:25:00',1.94),('8975','2013-08-15','17:30:00',1.85),('8975','2013-08-15','17:35:00',1.76),('8975','2013-08-15','17:40:00',1.68),('8975','2013-08-15','17:45:00',1.6),('8975','2013-08-15','17:50:00',1.53),('8975','2013-08-15','17:55:00',1.47),('8975','2013-08-15','18:00:00',1.41),('8975','2013-08-15','18:05:00',1.35),('8975','2013-08-15','18:10:00',1.31),('8975','2013-08-15','18:15:00',1.25),('8975','2013-08-15','18:20:00',1.2),('8975','2013-08-15','18:25:00',1.15),('8975','2013-08-15','18:30:00',1.07),('8975','2013-08-14','07:45:00',1.03),('8975','2013-08-14','07:50:00',1.52),('8975','2013-08-14','07:55:00',2.95),('8975','2013-08-14','08:00:00',3.03),('8975','2013-08-14','08:05:00',3.36),('8975','2013-08-14','08:10:00',3.38),('8975','2013-08-14','08:15:00',3.39),('8975','2013-08-14','08:20:00',3.47),('8975','2013-08-14','08:25:00',3.57),('8975','2013-08-14','08:30:00',3.63),('8975','2013-08-14','08:35:00',3.74),('8975','2013-08-14','08:40:00',3.81),('8975','2013-08-14','08:45:00',3.92),('8975','2013-08-14','08:50:00',4.07),('8975','2013-08-14','08:55:00',4.18),('8975','2013-08-14','09:00:00',3.57),('8975','2013-08-14','09:05:00',4),('8975','2013-08-14','09:10:00',3.17),('8975','2013-08-14','09:15:00',4.35),('8975','2013-08-14','09:20:00',4.85),('8975','2013-08-14','09:25:00',4.75),('8975','2013-08-14','09:30:00',4.76),('8975','2013-08-14','09:35:00',4.86),('8975','2013-08-14','09:40:00',4.96),('8975','2013-08-14','09:45:00',5.04),('8975','2013-08-14','09:50:00',5.13),('8975','2013-08-14','09:55:00',5.22),('8975','2013-08-14','10:00:00',5.29),('8975','2013-08-14','10:05:00',5.37),('8975','2013-08-14','10:10:00',5.45),('8975','2013-08-14','10:15:00',5.53),('8975','2013-08-14','10:20:00',5.58),('8975','2013-08-14','10:25:00',5.66),('8975','2013-08-14','10:30:00',5.69),('8975','2013-08-14','10:35:00',5.79),('8975','2013-08-14','10:40:00',5.81),('8975','2013-08-14','10:45:00',5.83),('8975','2013-08-14','10:50:00',5.83),('8975','2013-08-14','10:55:00',5.37),('8975','2013-08-14','11:00:00',5.2),('8975','2013-08-14','11:05:00',4.54),('8975','2013-08-14','11:10:00',3.71),('8975','2013-08-14','11:15:00',3.98),('8975','2013-08-14','11:20:00',4.27),('8975','2013-08-14','11:25:00',4.62),('8975','2013-08-14','11:30:00',5.18),('8975','2013-08-14','11:35:00',5.66),('8975','2013-08-14','11:40:00',6.03),('8975','2013-08-14','11:45:00',6.75),('8975','2013-08-14','11:50:00',6.75),('8975','2013-08-14','11:55:00',6.71),('8975','2013-08-14','12:00:00',6.68),('8975','2013-08-14','12:05:00',6.62),('8975','2013-08-14','12:10:00',6.58),('8975','2013-08-14','12:15:00',6.54),('8975','2013-08-14','12:20:00',6.5),('8975','2013-08-14','12:25:00',6.48),('8975','2013-08-14','12:30:00',6.47),('8975','2013-08-14','12:35:00',6.44),('8975','2013-08-14','12:40:00',6.44),('8975','2013-08-14','12:45:00',6.4),('8975','2013-08-14','12:50:00',6.33),('8975','2013-08-14','12:55:00',6.35),('8975','2013-08-14','13:00:00',6.17),('8975','2013-08-14','13:05:00',6.01),('8975','2013-08-14','13:10:00',5.93),('8975','2013-08-14','13:15:00',5.93),('8975','2013-08-14','13:20:00',5.69),('8975','2013-08-14','13:25:00',5.89),('8975','2013-08-14','13:30:00',6.06),('8975','2013-08-14','13:35:00',5.97),('8975','2013-08-14','13:40:00',5.92),('8975','2013-08-14','13:45:00',5.87),('8975','2013-08-14','13:50:00',5.82),('8975','2013-08-14','13:55:00',5.74),('8975','2013-08-14','14:00:00',5.71),('8975','2013-08-14','14:05:00',5.72),('8975','2013-08-14','14:10:00',5.63),('8975','2013-08-14','14:15:00',5.62),('8975','2013-08-14','14:20:00',5.51),('8975','2013-08-14','14:25:00',5.43),('8975','2013-08-14','14:30:00',5.24),('8975','2013-08-14','14:35:00',5.21),('8975','2013-08-14','14:40:00',5.22),('8975','2013-08-14','14:45:00',5.15),('8975','2013-08-14','14:50:00',5.04),('8975','2013-08-14','14:55:00',4.93),('8975','2013-08-14','15:00:00',4.81),('8975','2013-08-14','15:05:00',4.75),('8975','2013-08-14','15:10:00',4.67),('8975','2013-08-14','15:15:00',4.67),('8975','2013-08-14','15:20:00',4.55),('8975','2013-08-14','15:25:00',4.48),('8975','2013-08-14','15:30:00',4.34),('8975','2013-08-14','15:35:00',4.28),('8975','2013-08-14','15:40:00',4.14),('8975','2013-08-14','15:45:00',3.97),('8975','2013-08-14','15:50:00',3.94),('8975','2013-08-14','15:55:00',3.86),('8975','2013-08-14','16:00:00',3.78),('8975','2013-08-14','16:05:00',3.69),('8975','2013-08-14','16:10:00',3.55),('8975','2013-08-14','16:15:00',3.46),('8975','2013-08-14','16:20:00',3.35),('8975','2013-08-14','16:25:00',3.24),('8975','2013-08-14','16:30:00',2.56),('8975','2013-08-14','16:35:00',3.05),('8975','2013-08-14','16:40:00',2.97),('8975','2013-08-14','16:45:00',2.77),('8975','2013-08-14','16:50:00',2.68),('8975','2013-08-14','16:55:00',2.52),('8975','2013-08-14','17:00:00',2.09),('8975','2013-08-14','17:05:00',2.25),('8975','2013-08-14','17:10:00',2.26),('8975','2013-08-14','17:15:00',2.18),('8975','2013-08-14','17:20:00',2.02),('8975','2013-08-14','17:25:00',1.75),('8975','2013-08-14','17:30:00',1.73),('8975','2013-08-14','17:35:00',1.25),('8975','2013-08-14','17:45:00',1.43),('8975','2013-08-14','17:50:00',1.57),('8975','2013-08-14','17:55:00',1.49),('8975','2013-08-14','18:00:00',1.43),('8975','2013-08-14','18:05:00',1.38),('8975','2013-08-14','18:10:00',1.26),('8975','2013-08-14','18:15:00',1.23),('8975','2013-08-14','18:20:00',1.2),('8975','2013-08-14','18:25:00',1.16),('8975','2013-08-14','18:30:00',1.11),('8975','2013-08-14','18:35:00',1.08),('8975','2013-08-14','18:40:00',1.04),('8975','2013-08-13','07:10:00',1.06),('8975','2013-08-13','07:15:00',1.35),('8975','2013-08-13','07:20:00',1.53),('8975','2013-08-13','07:25:00',1.7),('8975','2013-08-13','07:30:00',1.88),('8975','2013-08-13','07:35:00',2.02),('8975','2013-08-13','07:40:00',2.18),('8975','2013-08-13','07:45:00',2.33),('8975','2013-08-13','07:50:00',2.51),('8975','2013-08-13','07:55:00',2.63),('8975','2013-08-13','08:00:00',2.8),('8975','2013-08-13','08:05:00',2.87),('8975','2013-08-13','08:10:00',2.92),('8975','2013-08-13','08:15:00',2.99),('8975','2013-08-13','08:20:00',3.17),('8975','2013-08-13','08:25:00',3.28),('8975','2013-08-13','08:30:00',3.31),('8975','2013-08-13','08:35:00',3.34),('8975','2013-08-13','08:40:00',3.83),('8975','2013-08-13','08:45:00',2.72),('8975','2013-08-13','08:50:00',3.91),('8975','2013-08-13','08:55:00',2.44),('8975','2013-08-13','09:00:00',3.21),('8975','2013-08-13','09:05:00',4.48),('8975','2013-08-13','09:10:00',4.73),('8975','2013-08-13','09:15:00',4.05),('8975','2013-08-13','09:20:00',3.49),('8975','2013-08-13','09:25:00',4.43),('8975','2013-08-13','09:30:00',4.96),('8975','2013-08-13','09:35:00',4.71),('8975','2013-08-13','09:40:00',4.62),('8975','2013-08-13','09:45:00',5.15),('8975','2013-08-13','09:50:00',4.58),('8975','2013-08-13','09:55:00',4.46),('8975','2013-08-13','10:00:00',3.18),('8975','2013-08-13','10:05:00',1.6),('8975','2013-08-13','10:10:00',1.9),('8975','2013-08-13','10:15:00',4.01),('8975','2013-08-13','10:20:00',4.14),('8975','2013-08-13','10:25:00',4.65),('8975','2013-08-13','10:30:00',2.45),('8975','2013-08-13','10:35:00',6.19),('8975','2013-08-13','10:40:00',5.88),('8975','2013-08-13','10:45:00',5.97),('8975','2013-08-13','10:50:00',6.09),('8975','2013-08-13','10:55:00',5.77),('8975','2013-08-13','11:00:00',1.96),('8975','2013-08-13','11:05:00',1.75),('8975','2013-08-13','11:10:00',2.9),('8975','2013-08-13','11:15:00',5.78),('8975','2013-08-13','11:20:00',3.61),('8975','2013-08-13','11:25:00',5.81),('8975','2013-08-13','11:30:00',6.51),('8975','2013-08-13','11:35:00',5.99),('8975','2013-08-13','11:40:00',5.51),('8975','2013-08-13','11:45:00',2.85),('8975','2013-08-13','11:50:00',1.92),('8975','2013-08-13','11:55:00',1.76),('8975','2013-08-13','12:00:00',2.02),('8975','2013-08-13','12:05:00',1.71),('8975','2013-08-13','12:10:00',1.94),('8975','2013-08-13','12:15:00',1.64),('8975','2013-08-13','12:20:00',1.65),('8975','2013-08-13','12:25:00',1.73),('8975','2013-08-13','12:30:00',2.89),('8975','2013-08-13','12:35:00',4.41),('8975','2013-08-13','12:40:00',2.3),('8975','2013-08-13','12:45:00',1.77),('8975','2013-08-13','12:50:00',1.76),('8975','2013-08-13','12:55:00',2.06),('8975','2013-08-13','13:00:00',2.39),('8975','2013-08-13','13:05:00',4.81),('8975','2013-08-13','13:10:00',5.51),('8975','2013-08-13','13:15:00',4.65),('8975','2013-08-13','13:20:00',2.11),('8975','2013-08-13','13:25:00',1.76),('8975','2013-08-13','13:30:00',1.81),('8975','2013-08-13','13:35:00',1.99),('8975','2013-08-13','13:40:00',2.78),('8975','2013-08-13','13:45:00',3.74),('8975','2013-08-13','13:50:00',6.23),('8975','2013-08-13','13:55:00',5.13),('8975','2013-08-13','14:00:00',5.56),('8975','2013-08-13','14:05:00',6.64),('8975','2013-08-13','14:10:00',6.28),('8975','2013-08-13','14:15:00',6.08),('8975','2013-08-13','14:20:00',6.06),('8975','2013-08-13','14:25:00',5.83),('8975','2013-08-13','14:30:00',5.03),('8975','2013-08-13','14:35:00',5.69),('8975','2013-08-13','14:40:00',5.54),('8975','2013-08-13','14:45:00',5.22),('8975','2013-08-13','14:50:00',5.19),('8975','2013-08-13','14:55:00',5.16),('8975','2013-08-13','15:00:00',5.1),('8975','2013-08-13','15:05:00',5),('8975','2013-08-13','15:10:00',4.91),('8975','2013-08-13','15:15:00',4.8),('8975','2013-08-13','15:20:00',4.8),('8975','2013-08-13','15:25:00',4.65),('8975','2013-08-13','15:30:00',4.48),('8975','2013-08-13','15:35:00',4.46),('8975','2013-08-13','15:40:00',4.35),('8975','2013-08-13','15:45:00',4.24),('8975','2013-08-13','15:50:00',4.18),('8975','2013-08-13','15:55:00',4.09),('8975','2013-08-13','16:00:00',3.93),('8975','2013-08-13','16:05:00',3.91),('8975','2013-08-13','16:10:00',3.83),('8975','2013-08-13','16:15:00',3.69),('8975','2013-08-13','16:20:00',3.6),('8975','2013-08-13','16:25:00',3.47),('8975','2013-08-13','16:30:00',3.34),('8975','2013-08-13','16:35:00',3.24),('8975','2013-08-13','16:40:00',3.12),('8975','2013-08-13','16:45:00',2.99),('8975','2013-08-13','16:50:00',2.84),('8975','2013-08-13','16:55:00',2.73),('8975','2013-08-13','17:00:00',2.61),('8975','2013-08-13','17:05:00',2.5),('8975','2013-08-13','17:10:00',2.36),('8975','2013-08-13','17:15:00',2.27),('8975','2013-08-13','17:20:00',2.17),('8975','2013-08-13','17:25:00',2.07),('8975','2013-08-13','17:30:00',1.97),('8975','2013-08-13','17:35:00',1.87),('8975','2013-08-13','17:40:00',1.81),('8975','2013-08-13','17:45:00',1.7),('8975','2013-08-13','17:50:00',1.65),('8975','2013-08-13','17:55:00',1.58),('8975','2013-08-13','18:00:00',1.52),('8975','2013-08-13','18:05:00',1.48),('8975','2013-08-13','18:10:00',1.47),('8975','2013-08-13','18:15:00',1.44),('8975','2013-08-13','18:20:00',1.44),('8975','2013-08-13','18:25:00',1.42),('8975','2013-08-13','18:30:00',1.32),('8975','2013-08-13','18:35:00',1.2),('8975','2013-08-13','18:40:00',1.11),('8975','2013-08-13','18:45:00',1.12),('8975','2013-08-13','18:50:00',1.14),('8975','2013-08-13','18:55:00',1.07),('8975','2013-08-13','19:00:00',1.09),('8975','2013-08-12','07:05:00',1.12),('8975','2013-08-12','07:10:00',1.27),('8975','2013-08-12','07:15:00',1.39),('8975','2013-08-12','07:20:00',1.52),('8975','2013-08-12','07:25:00',1.76),('8975','2013-08-12','07:30:00',1.96),('8975','2013-08-12','07:35:00',2.13),('8975','2013-08-12','07:40:00',2.3),('8975','2013-08-12','07:45:00',2.46),('8975','2013-08-12','07:50:00',2.58),('8975','2013-08-12','07:55:00',2.72),('8975','2013-08-12','08:00:00',2.81),('8975','2013-08-12','08:05:00',2.82),('8975','2013-08-12','08:10:00',2.96),('8975','2013-08-12','08:15:00',3.1),('8975','2013-08-12','08:20:00',3.26),('8975','2013-08-12','08:25:00',3.41),('8975','2013-08-12','08:30:00',3.53),('8975','2013-08-12','08:35:00',3.58),('8975','2013-08-12','08:40:00',3.68),('8975','2013-08-12','08:45:00',3.8),('8975','2013-08-12','08:50:00',3.92),('8975','2013-08-12','08:55:00',4.02),('8975','2013-08-12','09:00:00',4.11),('8975','2013-08-12','09:05:00',4.24),('8975','2013-08-12','09:10:00',4.37),('8975','2013-08-12','09:15:00',4.44),('8975','2013-08-12','09:20:00',4.53),('8975','2013-08-12','09:25:00',4.61),('8975','2013-08-12','09:30:00',4.71),('8975','2013-08-12','09:35:00',4.81),('8975','2013-08-12','09:40:00',4.83),('8975','2013-08-12','09:45:00',4.94),('8975','2013-08-12','09:50:00',5.02),('8975','2013-08-12','09:55:00',5.11),('8975','2013-08-12','10:00:00',5.15),('8975','2013-08-12','10:05:00',5.25),('8975','2013-08-12','10:10:00',5.3),('8975','2013-08-12','10:15:00',5.4),('8975','2013-08-12','10:20:00',5.47),('8975','2013-08-12','10:25:00',5.56),('8975','2013-08-12','10:30:00',5.56),('8975','2013-08-12','10:35:00',5.55),('8975','2013-08-12','10:40:00',5.61),('8975','2013-08-12','10:45:00',5.6),('8975','2013-08-12','10:50:00',5.67),('8975','2013-08-12','10:55:00',5.68),('8975','2013-08-12','11:00:00',5.78),('8975','2013-08-12','11:05:00',5.76),('8975','2013-08-12','11:10:00',5.74),('8975','2013-08-12','11:15:00',5.83),('8975','2013-08-12','11:20:00',5.34),('8975','2013-08-12','11:25:00',5.84),('8975','2013-08-12','11:30:00',5.94),('8975','2013-08-12','11:35:00',6.04),('8975','2013-08-12','11:40:00',6.07),('8975','2013-08-12','11:45:00',5.99),('8975','2013-08-12','11:50:00',5.86),('8975','2013-08-12','11:55:00',6.08),('8975','2013-08-12','12:00:00',6.17),('8975','2013-08-12','12:05:00',6.11),('8975','2013-08-12','12:10:00',6.34),('8975','2013-08-12','12:15:00',6.41),('8975','2013-08-12','12:20:00',6.43),('8975','2013-08-12','12:25:00',6.58),('8975','2013-08-12','12:30:00',6.56),('8975','2013-08-12','12:35:00',3.72),('8975','2013-08-12','12:40:00',2.28),('8975','2013-08-12','12:45:00',2.13),('8975','2013-08-12','12:50:00',2.08),('8975','2013-08-12','12:55:00',1.59),('8975','2013-08-12','13:00:00',1.46),('8975','2013-08-12','13:05:00',1.5),('8975','2013-08-12','13:10:00',1.31),('8975','2013-08-12','13:15:00',1.68),('8975','2013-08-12','13:20:00',4.48),('8975','2013-08-12','13:25:00',5.62),('8975','2013-08-12','13:30:00',2.05),('8975','2013-08-12','13:35:00',2.7),('8975','2013-08-12','13:40:00',5.36),('8975','2013-08-12','13:45:00',5.5),('8975','2013-08-12','13:50:00',6.68),('8975','2013-08-12','13:55:00',5.23),('8975','2013-08-12','14:00:00',2.79),('8975','2013-08-12','14:05:00',5.83),('8975','2013-08-12','14:10:00',6.46),('8975','2013-08-12','14:15:00',5.71),('8975','2013-08-12','14:20:00',3.69),('8975','2013-08-12','14:25:00',5.22),('8975','2013-08-12','14:30:00',5.47),('8975','2013-08-12','14:35:00',4.17),('8975','2013-08-12','14:40:00',5.76),('8975','2013-08-12','14:45:00',4.49),('8975','2013-08-12','14:50:00',2.94),('8975','2013-08-12','14:55:00',4.43),('8975','2013-08-12','15:00:00',3.89),('8975','2013-08-12','15:05:00',2.84),('8975','2013-08-12','15:10:00',4.16),('8975','2013-08-12','15:15:00',5.26),('8975','2013-08-12','15:20:00',3.9),('8975','2013-08-12','15:25:00',4.66),('8975','2013-08-12','15:30:00',4.7),('8975','2013-08-12','15:35:00',4.57),('8975','2013-08-12','15:40:00',4.46),('8975','2013-08-12','15:45:00',4.14),('8975','2013-08-12','15:50:00',4.2),('8975','2013-08-12','15:55:00',4.1),('8975','2013-08-12','16:00:00',3.99),('8975','2013-08-12','16:05:00',3.87),('8975','2013-08-12','16:10:00',3.76),('8975','2013-08-12','16:15:00',3.65),('8975','2013-08-12','16:20:00',3.54),('8975','2013-08-12','16:25:00',3.43),('8975','2013-08-12','16:30:00',3.31),('8975','2013-08-12','16:35:00',3.23),('8975','2013-08-12','16:40:00',3.11),('8975','2013-08-12','16:45:00',2.97),('8975','2013-08-12','16:50:00',2.87),('8975','2013-08-12','16:55:00',2.73),('8975','2013-08-12','17:00:00',2.62),('8975','2013-08-12','17:05:00',2.52),('8975','2013-08-12','17:10:00',2.42),('8975','2013-08-12','17:15:00',2.29),('8975','2013-08-12','17:20:00',2.18),('8975','2013-08-12','17:25:00',2.09),('8975','2013-08-12','17:30:00',1.98),('8975','2013-08-12','17:35:00',1.87),('8975','2013-08-12','17:40:00',1.77),('8975','2013-08-12','17:45:00',1.68),('8975','2013-08-12','17:50:00',1.61),('8975','2013-08-12','17:55:00',1.53),('8975','2013-08-12','18:00:00',1.46),('8975','2013-08-12','18:05:00',1.39),('8975','2013-08-12','18:10:00',1.35),('8975','2013-08-12','18:15:00',1.3),('8975','2013-08-12','18:20:00',1.25),('8975','2013-08-12','18:25:00',1.19),('8975','2013-08-12','18:30:00',1.14),('8975','2013-08-12','18:35:00',1.07),('8975','2013-08-12','18:40:00',1.03),('8975','2013-08-11','07:05:00',1.12),('8975','2013-08-11','07:10:00',1.22),('8975','2013-08-11','07:15:00',1.39),('8975','2013-08-11','07:20:00',1.52),('8975','2013-08-11','07:25:00',1.78),('8975','2013-08-11','07:30:00',1.96),('8975','2013-08-11','07:35:00',2.12),('8975','2013-08-11','07:40:00',2.25),('8975','2013-08-11','07:45:00',2.39),('8975','2013-08-11','07:50:00',2.53),('8975','2013-08-11','07:55:00',2.66),('8975','2013-08-11','08:00:00',2.77),('8975','2013-08-11','08:05:00',2.87),('8975','2013-08-11','08:10:00',3),('8975','2013-08-11','08:15:00',3.11),('8975','2013-08-11','08:20:00',3.22),('8975','2013-08-11','08:25:00',3.32),('8975','2013-08-11','08:30:00',3.44),('8975','2013-08-11','08:35:00',3.54),('8975','2013-08-11','08:40:00',3.63),('8975','2013-08-11','08:45:00',3.75),('8975','2013-08-11','08:50:00',3.86),('8975','2013-08-11','08:55:00',3.96),('8975','2013-08-11','09:00:00',4.07),('8975','2013-08-11','09:05:00',4.18),('8975','2013-08-11','09:10:00',4.27),('8975','2013-08-11','09:15:00',4.35),('8975','2013-08-11','09:20:00',4.42),('8975','2013-08-11','09:25:00',4.49),('8975','2013-08-11','09:30:00',4.58),('8975','2013-08-11','09:35:00',4.65),('8975','2013-08-11','09:40:00',4.73),('8975','2013-08-11','09:45:00',4.83),('8975','2013-08-11','09:50:00',4.9),('8975','2013-08-11','09:55:00',4.93),('8975','2013-08-11','10:00:00',5.03),('8975','2013-08-11','10:05:00',5.08),('8975','2013-08-11','10:10:00',5.14),('8975','2013-08-11','10:15:00',5.2),('8975','2013-08-11','10:20:00',5.28),('8975','2013-08-11','10:25:00',5.35),('8975','2013-08-11','10:30:00',5.41),('8975','2013-08-11','10:35:00',5.45),('8975','2013-08-11','10:40:00',5.5),('8975','2013-08-11','10:45:00',5.59),('8975','2013-08-11','10:50:00',5.66),('8975','2013-08-11','10:55:00',5.72),('8975','2013-08-11','11:00:00',5.73),('8975','2013-08-11','11:05:00',5.81),('8975','2013-08-11','11:10:00',5.77),('8975','2013-08-11','11:15:00',5.81),('8975','2013-08-11','11:20:00',5.84),('8975','2013-08-11','11:25:00',5.89),('8975','2013-08-11','11:30:00',5.94),('8975','2013-08-11','11:35:00',5.95),('8975','2013-08-11','11:40:00',5.97),('8975','2013-08-11','11:45:00',5.98),('8975','2013-08-11','11:50:00',6.11),('8975','2013-08-11','11:55:00',5.43),('8975','2013-08-11','12:00:00',6.04),('8975','2013-08-11','12:05:00',5.95),('8975','2013-08-11','12:10:00',3.05),('8975','2013-08-11','12:15:00',1.52),('8975','2013-08-11','12:20:00',1.5),('8975','2013-08-11','12:25:00',1.87),('8975','2013-08-11','12:30:00',3.87),('8975','2013-08-11','12:35:00',1.28),('8975','2013-08-11','12:40:00',1.25),('8975','2013-08-11','12:45:00',1.64),('8975','2013-08-11','12:50:00',2.35),('8975','2013-08-11','12:55:00',1.84),('8975','2013-08-11','13:00:00',1.43),('8975','2013-08-11','13:05:00',1.31),('8975','2013-08-11','13:10:00',1.38),('8975','2013-08-11','13:15:00',1.31),('8975','2013-08-11','13:20:00',1.64),('8975','2013-08-11','13:25:00',1.96),('8975','2013-08-11','13:30:00',5.82),('8975','2013-08-11','13:35:00',2.77),('8975','2013-08-11','13:40:00',1.69),('8975','2013-08-11','13:45:00',2.03),('8975','2013-08-11','13:50:00',2.28),('8975','2013-08-11','13:55:00',2.31),('8975','2013-08-11','14:00:00',1.98),('8975','2013-08-11','14:05:00',1.38),('8975','2013-08-11','14:10:00',1.37),('8975','2013-08-11','14:15:00',1.48),('8975','2013-08-11','14:20:00',1.58),('8975','2013-08-11','14:25:00',1.81),('8975','2013-08-11','14:30:00',2.64),('8975','2013-08-11','14:35:00',3.76),('8975','2013-08-11','14:40:00',5.33),('8975','2013-08-11','14:45:00',6.26),('8975','2013-08-11','14:50:00',5.86),('8975','2013-08-11','14:55:00',5.62),('8975','2013-08-11','15:00:00',5.45),('8975','2013-08-11','15:05:00',5.29),('8975','2013-08-11','15:10:00',5.15),('8975','2013-08-11','15:15:00',5.07),('8975','2013-08-11','15:20:00',4.85),('8975','2013-08-11','15:25:00',4.77),('8975','2013-08-11','15:30:00',4.6),('8975','2013-08-11','15:35:00',3.43),('8975','2013-08-11','15:40:00',4.41),('8975','2013-08-11','15:45:00',4.32),('8975','2013-08-11','15:50:00',4.25),('8975','2013-08-11','15:55:00',4.13),('8975','2013-08-11','16:00:00',3.99),('8975','2013-08-11','16:05:00',3.91),('8975','2013-08-11','16:10:00',3.78),('8975','2013-08-11','16:15:00',3.66),('8975','2013-08-11','16:20:00',3.5),('8975','2013-08-11','16:25:00',3.39),('8975','2013-08-11','16:30:00',3.31),('8975','2013-08-11','16:35:00',3.23),('8975','2013-08-11','16:40:00',3.09),('8975','2013-08-11','16:45:00',2.96),('8975','2013-08-11','16:50:00',2.88),('8975','2013-08-11','16:55:00',2.75),('8975','2013-08-11','17:00:00',2.61),('8975','2013-08-11','17:05:00',2.5),('8975','2013-08-11','17:10:00',2.39),('8975','2013-08-11','17:15:00',2.05),('8975','2013-08-11','17:20:00',2.14),('8975','2013-08-11','17:25:00',2.06),('8975','2013-08-11','17:30:00',2.02),('8975','2013-08-11','17:35:00',1.82),('8975','2013-08-11','17:40:00',1.66),('8975','2013-08-11','17:45:00',1.55),('8975','2013-08-11','17:50:00',1.65),('8975','2013-08-11','17:55:00',1.44),('8975','2013-08-11','18:00:00',1.49),('8975','2013-08-11','18:05:00',1.3),('8975','2013-08-11','18:10:00',1.22),('8975','2013-08-11','18:15:00',1.16),('8975','2013-08-11','18:20:00',1.22),('8975','2013-08-11','18:25:00',1.02),('8975','2013-08-11','18:30:00',1.02),('8975','2013-08-11','18:35:00',1.09),('8975','2013-08-11','18:40:00',1.12),('8975','2013-08-11','18:45:00',1.06),('8975','2013-08-11','18:50:00',1.01),('8975','2013-08-10','07:05:00',1.18),('8975','2013-08-10','07:10:00',1.33),('8975','2013-08-10','07:15:00',1.44),('8975','2013-08-10','07:20:00',1.62),('8975','2013-08-10','07:25:00',1.64),('8975','2013-08-10','07:30:00',1.96),('8975','2013-08-10','07:35:00',2.11),('8975','2013-08-10','07:40:00',2.07),('8975','2013-08-10','07:45:00',2.26),('8975','2013-08-10','07:50:00',2.58),('8975','2013-08-10','07:55:00',2.57),('8975','2013-08-10','08:00:00',2.71),('8975','2013-08-10','08:05:00',2.7),('8975','2013-08-10','08:10:00',3.03),('8975','2013-08-10','08:15:00',3.28),('8975','2013-08-10','08:20:00',3.4),('8975','2013-08-10','08:25:00',3.52),('8975','2013-08-10','08:30:00',3.62),('8975','2013-08-10','08:35:00',3.76),('8975','2013-08-10','08:40:00',3.85),('8975','2013-08-10','08:45:00',3.94),('8975','2013-08-10','08:50:00',4.02),('8975','2013-08-10','08:55:00',4.07),('8975','2013-08-10','09:00:00',4.18),('8975','2013-08-10','09:05:00',4.27),('8975','2013-08-10','09:10:00',4.38),('8975','2013-08-10','09:15:00',4.48),('8975','2013-08-10','09:20:00',4.59),('8975','2013-08-10','09:25:00',4.67),('8975','2013-08-10','09:30:00',4.77),('8975','2013-08-10','09:35:00',4.88),('8975','2013-08-10','09:40:00',4.95),('8975','2013-08-10','09:45:00',5.04),('8975','2013-08-10','09:50:00',5.11),('8975','2013-08-10','09:55:00',5.18),('8975','2013-08-10','10:00:00',5.25),('8975','2013-08-10','10:05:00',5.33),('8975','2013-08-10','10:10:00',5.4),('8975','2013-08-10','10:15:00',5.48),('8975','2013-08-10','10:20:00',5.54),('8975','2013-08-10','10:25:00',5.62),('8975','2013-08-10','10:30:00',5.67),('8975','2013-08-10','10:35:00',5.74),('8975','2013-08-10','10:40:00',5.81),('8975','2013-08-10','10:45:00',5.87),('8975','2013-08-10','10:50:00',5.93),('8975','2013-08-10','10:55:00',5.94),('8975','2013-08-10','11:00:00',6.03),('8975','2013-08-10','11:05:00',6.07),('8975','2013-08-10','11:10:00',6.06),('8975','2013-08-10','11:15:00',6.1),('8975','2013-08-10','11:20:00',6.06),('8975','2013-08-10','11:25:00',6.14),('8975','2013-08-10','11:30:00',6.22),('8975','2013-08-10','11:35:00',6.23),('8975','2013-08-10','11:40:00',6.2),('8975','2013-08-10','11:45:00',6.2),('8975','2013-08-10','11:50:00',6.23),('8975','2013-08-10','11:55:00',6.24),('8975','2013-08-10','12:00:00',6.24),('8975','2013-08-10','12:05:00',6.26),('8975','2013-08-10','12:10:00',6.24),('8975','2013-08-10','12:15:00',6.22),('8975','2013-08-10','12:20:00',6.2),('8975','2013-08-10','12:25:00',6.18),('8975','2013-08-10','12:30:00',6.22),('8975','2013-08-10','12:35:00',6.24),('8975','2013-08-10','12:40:00',6.27),('8975','2013-08-10','12:45:00',6.23),('8975','2013-08-10','12:50:00',6.18),('8975','2013-08-10','12:55:00',6.16),('8975','2013-08-10','13:00:00',6.13),('8975','2013-08-10','13:05:00',6.12),('8975','2013-08-10','13:10:00',6.09),('8975','2013-08-10','13:15:00',6.13),('8975','2013-08-10','13:20:00',6.08),('8975','2013-08-10','13:25:00',5.99),('8975','2013-08-10','13:30:00',5.92),('8975','2013-08-10','13:35:00',5.9),('8975','2013-08-10','13:40:00',5.9),('8975','2013-08-10','13:45:00',5.88),('8975','2013-08-10','13:50:00',5.8),('8975','2013-08-10','13:55:00',5.75),('8975','2013-08-10','14:00:00',5.74),('8975','2013-08-10','14:05:00',5.68),('8975','2013-08-10','14:10:00',5.62),('8975','2013-08-10','14:15:00',5.59),('8975','2013-08-10','14:20:00',5.54),('8975','2013-08-10','14:25:00',5.42),('8975','2013-08-10','14:30:00',5.34),('8975','2013-08-10','14:35:00',5.27),('8975','2013-08-10','14:40:00',5.19),('8975','2013-08-10','14:45:00',5.11),('8975','2013-08-10','14:50:00',5.11),('8975','2013-08-10','14:55:00',4.98),('8975','2013-08-10','15:00:00',3.53),('8975','2013-08-10','15:05:00',4.79),('8975','2013-08-10','15:10:00',4.76),('8975','2013-08-10','15:15:00',3.94),('8975','2013-08-10','15:20:00',4.33),('8975','2013-08-10','15:25:00',3.39),('8975','2013-08-10','15:30:00',4.56),('8975','2013-08-10','15:35:00',4.47),('8975','2013-08-10','15:40:00',4.36),('8975','2013-08-10','15:45:00',4.3),('8975','2013-08-10','15:50:00',4.21),('8975','2013-08-10','15:55:00',4.07),('8975','2013-08-10','16:00:00',3.98),('8975','2013-08-10','16:05:00',3.87),('8975','2013-08-10','16:10:00',3.78),('8975','2013-08-10','16:15:00',3.66),('8975','2013-08-10','16:20:00',3.53),('8975','2013-08-10','16:25:00',3.44),('8975','2013-08-10','16:30:00',3.35),('8975','2013-08-10','16:35:00',3.23),('8975','2013-08-10','16:40:00',3.11),('8975','2013-08-10','16:45:00',2.98),('8975','2013-08-10','16:50:00',2.85),('8975','2013-08-10','16:55:00',2.73),('8975','2013-08-10','17:00:00',2.62),('8975','2013-08-10','17:05:00',2.51),('8975','2013-08-10','17:10:00',2.41),('8975','2013-08-10','17:15:00',2.31),('8975','2013-08-10','17:20:00',2.18),('8975','2013-08-10','17:25:00',2.08),('8975','2013-08-10','17:30:00',1.98),('8975','2013-08-10','17:35:00',1.89),('8975','2013-08-10','17:40:00',1.79),('8975','2013-08-10','17:45:00',1.71),('8975','2013-08-10','17:50:00',1.63),('8975','2013-08-10','17:55:00',1.55),('8975','2013-08-10','18:00:00',1.48),('8975','2013-08-10','18:05:00',1.42),('8975','2013-08-10','18:10:00',1.34),('8975','2013-08-10','18:15:00',1.3),('8975','2013-08-10','18:20:00',1.27),('8975','2013-08-10','18:25:00',1.2),('8975','2013-08-10','18:30:00',1.15),('8975','2013-08-10','18:35:00',1.09),('8975','2013-08-10','18:40:00',1.05),('8975','2013-08-09','07:00:00',1.12),('8975','2013-08-09','07:05:00',1.23),('8975','2013-08-09','07:10:00',1.43),('8975','2013-08-09','07:15:00',1.63),('8975','2013-08-09','07:20:00',1.77),('8975','2013-08-09','07:25:00',1.96),('8975','2013-08-09','07:30:00',2.19),('8975','2013-08-09','07:35:00',2.33),('8975','2013-08-09','07:40:00',2.45),('8975','2013-08-09','07:45:00',2.61),('8975','2013-08-09','07:50:00',2.72),('8975','2013-08-09','07:55:00',2.82),('8975','2013-08-09','08:00:00',2.96),('8975','2013-08-09','08:05:00',3.11),('8975','2013-08-09','08:10:00',3.22),('8975','2013-08-09','08:15:00',3.35),('8975','2013-08-09','08:20:00',3.5),('8975','2013-08-09','08:25:00',3.61),('8975','2013-08-09','08:30:00',3.72),('8975','2013-08-09','08:35:00',3.8),('8975','2013-08-09','08:40:00',3.88),('8975','2013-08-09','08:45:00',4),('8975','2013-08-09','08:50:00',4.1),('8975','2013-08-09','08:55:00',4.18),('8975','2013-08-09','09:00:00',4.31),('8975','2013-08-09','09:05:00',4.41),('8975','2013-08-09','09:10:00',4.51),('8975','2013-08-09','09:15:00',4.61),('8975','2013-08-09','09:20:00',4.73),('8975','2013-08-09','09:25:00',4.82),('8975','2013-08-09','09:30:00',3.84),('8975','2013-08-09','09:35:00',4.97),('8975','2013-08-09','09:40:00',5.04),('8975','2013-08-09','09:45:00',5.13),('8975','2013-08-09','09:50:00',5.23),('8975','2013-08-09','09:55:00',5.27),('8975','2013-08-09','10:00:00',5.41),('8975','2013-08-09','10:05:00',5.46),('8975','2013-08-09','10:10:00',5.53),('8975','2013-08-09','10:15:00',5.61),('8975','2013-08-09','10:20:00',5.65),('8975','2013-08-09','10:25:00',5.71),('8975','2013-08-09','10:30:00',5.79),('8975','2013-08-09','10:35:00',5.82),('8975','2013-08-09','10:40:00',5.87),('8975','2013-08-09','10:45:00',5.92),('8975','2013-08-09','10:50:00',5.95),('8975','2013-08-09','10:55:00',6),('8975','2013-08-09','11:00:00',6.12),('8975','2013-08-09','11:05:00',6.21),('8975','2013-08-09','11:10:00',5.28),('8975','2013-08-09','11:15:00',5.03),('8975','2013-08-09','11:20:00',6.68),('8975','2013-08-09','11:25:00',6.7),('8975','2013-08-09','11:30:00',6.59),('8975','2013-08-09','11:35:00',6.28),('8975','2013-08-09','11:40:00',6.3),('8975','2013-08-09','11:45:00',6.31),('8975','2013-08-09','11:50:00',6.29),('8975','2013-08-09','11:55:00',6.36),('8975','2013-08-09','12:00:00',6.35),('8975','2013-08-09','12:05:00',6.37),('8975','2013-08-09','12:10:00',6.39),('8975','2013-08-09','12:15:00',6.36),('8975','2013-08-09','12:20:00',6.38),('8975','2013-08-09','12:25:00',6.41),('8975','2013-08-09','12:30:00',6.42),('8975','2013-08-09','12:35:00',6.39),('8975','2013-08-09','12:40:00',6.42),('8975','2013-08-09','12:45:00',6.48),('8975','2013-08-09','12:50:00',6.57),('8975','2013-08-09','12:55:00',6.53),('8975','2013-08-09','13:00:00',6.43),('8975','2013-08-09','13:05:00',6.35),('8975','2013-08-09','13:10:00',6.36),('8975','2013-08-09','13:15:00',6.44),('8975','2013-08-09','13:20:00',5.66),('8975','2013-08-09','13:25:00',6.36),('8975','2013-08-09','13:30:00',6.55),('8975','2013-08-09','13:35:00',6.8),('8975','2013-08-09','13:40:00',5.2),('8975','2013-08-09','13:45:00',1.81),('8975','2013-08-09','13:55:00',2.65),('8975','2013-08-09','14:00:00',6.04),('8975','2013-08-09','14:05:00',5.59),('8975','2013-08-09','14:10:00',3.67),('8975','2013-08-09','14:15:00',4.02),('8975','2013-08-09','14:20:00',2.89),('8975','2013-08-09','14:25:00',1.74),('8975','2013-08-09','14:30:00',1.85),('8975','2013-08-09','14:35:00',1.57),('8975','2013-08-09','14:40:00',1.44),('8975','2013-08-09','14:45:00',1.48),('8975','2013-08-09','14:50:00',1.49),('8975','2013-08-09','14:55:00',1.41),('8975','2013-08-09','15:00:00',1.56),('8975','2013-08-09','15:05:00',1.69),('8975','2013-08-09','15:10:00',1.77),('8975','2013-08-09','15:15:00',1.87),('8975','2013-08-09','15:20:00',1.97),('8975','2013-08-09','15:25:00',1.97),('8975','2013-08-09','15:30:00',1.84),('8975','2013-08-09','15:35:00',2.08),('8975','2013-08-09','15:40:00',2.12),('8975','2013-08-09','15:45:00',2.33),('8975','2013-08-09','15:50:00',2.95),('8975','2013-08-09','15:55:00',4.76),('8975','2013-08-09','16:00:00',5.04),('8975','2013-08-09','16:05:00',4.97),('8975','2013-08-09','16:10:00',4.22),('8975','2013-08-09','16:15:00',2.62),('8975','2013-08-09','16:20:00',4.58),('8975','2013-08-09','16:25:00',1.73),('8975','2013-08-09','16:30:00',2.24),('8975','2013-08-09','16:35:00',3.64),('8975','2013-08-09','16:40:00',3.47),('8975','2013-08-09','16:45:00',3),('8975','2013-08-09','16:50:00',3.2),('8975','2013-08-09','16:55:00',2.95),('8975','2013-08-09','17:00:00',2.39),('8975','2013-08-09','17:05:00',2.2),('8975','2013-08-09','17:10:00',1.02),('8975','2013-08-09','17:15:00',1.39),('8975','2013-08-09','17:20:00',1.35),('8975','2013-08-09','17:25:00',1.95),('8975','2013-08-09','17:30:00',1.2),('8975','2013-08-09','17:55:00',1.32),('8975','2014-04-08','07:35:00',1.12),('8975','2014-04-08','07:40:00',1.24),('8975','2014-04-08','08:00:00',1.69),('8975','2014-04-08','08:05:00',2.42),('8975','2014-04-08','08:10:00',2.47),('8975','2014-04-08','08:15:00',2.17),('8975','2014-04-08','08:20:00',2.67),('8975','2014-04-08','08:25:00',1.96),('8975','2014-04-08','08:30:00',1.6),('8975','2014-04-08','08:35:00',1.16),('8975','2014-04-08','08:55:00',1.29),('8975','2014-04-08','09:00:00',3.06),('8975','2014-04-08','09:05:00',1.63),('8975','2014-04-08','09:10:00',1.44),('8975','2014-04-08','09:15:00',1.49),('8975','2014-04-08','09:20:00',1.48),('8975','2014-04-08','09:25:00',1.58),('8975','2014-04-08','09:30:00',1.6),('8975','2014-04-08','09:35:00',1.44),('8975','2014-04-08','09:40:00',1.34),('8975','2014-04-08','09:45:00',1.52),('8975','2014-04-08','09:50:00',4.18),('8975','2014-04-08','09:55:00',5.27),('8975','2014-04-08','10:00:00',5.24),('8975','2014-04-08','10:05:00',5.2),('8975','2014-04-08','10:10:00',5.3),('8975','2014-04-08','10:15:00',5.37),('8975','2014-04-08','10:20:00',5.55),('8975','2014-04-08','10:25:00',5.82),('8975','2014-04-08','10:30:00',6.2),('8975','2014-04-08','10:35:00',4.46),('8975','2014-04-08','10:40:00',2.65),('8975','2014-04-08','10:45:00',5.34),('8975','2014-04-08','10:50:00',5.38),('8975','2014-04-08','10:55:00',6.25),('8975','2014-04-08','11:00:00',6.14),('8975','2014-04-08','11:05:00',6.13),('8975','2014-04-08','11:10:00',6.19),('8975','2014-04-08','11:15:00',6.32),('8975','2014-04-08','11:20:00',6.54),('8975','2014-04-08','11:25:00',6.65),('8975','2014-04-08','11:30:00',6.62),('8975','2014-04-08','11:35:00',6.59),('8975','2014-04-08','11:40:00',6.52),('8975','2014-04-08','11:45:00',5.9),('8975','2014-04-08','11:50:00',6.07),('8975','2014-04-08','11:55:00',6.62),('8975','2014-04-08','12:00:00',5.31),('8975','2014-04-08','12:05:00',6.86),('8975','2014-04-08','12:10:00',7.05),('8975','2014-04-08','12:15:00',7.22),('8975','2014-04-08','12:20:00',6.32),('8975','2014-04-08','12:25:00',2.58),('8975','2014-04-08','12:30:00',2.41),('8975','2014-04-08','12:35:00',2.43),('8975','2014-04-08','12:40:00',2.17),('8975','2014-04-08','12:45:00',1.55),('8975','2014-04-08','12:50:00',1.12),('8975','2014-04-08','13:15:00',1.11),('8975','2014-04-08','13:20:00',1.27),('8975','2014-04-08','13:25:00',1.26),('8975','2014-04-08','13:30:00',1.11),('8975','2014-04-08','13:35:00',1.01),('8975','2014-04-08','13:50:00',1.03),('8975','2014-04-08','13:55:00',1.26),('8975','2014-04-08','14:00:00',1.75),('8975','2014-04-08','14:05:00',1.94),('8975','2014-04-08','14:10:00',1.73),('8975','2014-04-08','14:15:00',1.55),('8975','2014-04-08','14:20:00',1.41),('8975','2014-04-08','14:25:00',1.72),('8975','2014-04-08','14:30:00',1.68),('8975','2014-04-08','14:35:00',2.08),('8975','2014-04-08','14:40:00',4.31),('8975','2014-04-08','14:45:00',2.7),('8975','2014-04-08','14:50:00',2.25),('8975','2014-04-08','14:55:00',3.03),('8975','2014-04-08','15:00:00',4.71),('8975','2014-04-08','15:05:00',2.11),('8975','2014-04-08','15:10:00',2.64),('8975','2014-04-08','15:15:00',4.76),('8975','2014-04-08','15:20:00',4.88),('8975','2014-04-08','15:25:00',4.12),('8975','2014-04-08','15:30:00',2.85),('8975','2014-04-08','15:35:00',3.01),('8975','2014-04-08','15:40:00',2.18),('8975','2014-04-08','15:45:00',1.94),('8975','2014-04-08','15:50:00',1.61),('8975','2014-04-08','15:55:00',1.68),('8975','2014-04-08','16:00:00',1.8),('8975','2014-04-08','16:05:00',2.12),('8975','2014-04-08','16:10:00',3.58),('8975','2014-04-08','16:15:00',3.15),('8975','2014-04-08','16:20:00',3.58),('8975','2014-04-08','16:25:00',3.57),('8975','2014-04-08','16:30:00',3.59),('8975','2014-04-08','16:35:00',3.41),('8975','2014-04-08','16:40:00',2.16),('8975','2014-04-08','16:45:00',2.68),('8975','2014-04-08','16:50:00',3.43),('8975','2014-04-08','16:55:00',3.44),('8975','2014-04-08','17:00:00',2.98),('8975','2014-04-08','17:05:00',2.97),('8975','2014-04-08','17:10:00',2.52),('8975','2014-04-08','17:15:00',2.08),('8975','2014-04-08','17:20:00',1.98),('8975','2014-04-08','17:25:00',1.73),('8975','2014-04-08','17:30:00',1.96),('8975','2014-04-08','17:35:00',1.34),('8975','2014-04-08','17:40:00',1.06),('8975','2014-04-08','17:45:00',1.45),('8975','2014-04-08','17:50:00',1.89),('8975','2014-04-08','17:55:00',1.6),('8975','2014-04-08','18:00:00',1.58),('8975','2014-04-08','18:05:00',1.02),('8975','2014-04-08','18:10:00',1.07),('8975','2013-08-08','07:10:00',1.15),('8975','2013-08-08','07:15:00',1.31),('8975','2013-08-08','07:20:00',1.5),('8975','2013-08-08','07:25:00',1.63),('8975','2013-08-08','07:30:00',1.01),('8975','2013-08-08','07:35:00',1.05),('8975','2013-08-08','07:40:00',1.12),('8975','2013-08-08','07:55:00',1.03),('8975','2013-08-08','08:00:00',1.94),('8975','2013-08-08','08:05:00',2.14),('8975','2013-08-08','08:10:00',1.6),('8975','2013-08-08','08:15:00',1.39),('8975','2013-08-08','08:20:00',1.34),('8975','2013-08-08','08:25:00',1.49),('8975','2013-08-08','08:30:00',1.83),('8975','2013-08-08','08:35:00',3.11),('8975','2013-08-08','08:40:00',3.52),('8975','2013-08-08','08:45:00',3.17),('8975','2013-08-08','08:50:00',3.44),('8975','2013-08-08','08:55:00',3.6),('8975','2013-08-08','09:00:00',3.67),('8975','2013-08-08','09:05:00',3.87),('8975','2013-08-08','09:10:00',4.28),('8975','2013-08-08','09:15:00',4.05),('8975','2013-08-08','09:20:00',3.22),('8975','2013-08-08','09:25:00',3.33),('8975','2013-08-08','09:30:00',4.06),('8975','2013-08-08','09:35:00',3.73),('8975','2013-08-08','09:40:00',2.13),('8975','2013-08-08','09:45:00',1.53),('8975','2013-08-08','09:50:00',1.65),('8975','2013-08-08','09:55:00',2.46),('8975','2013-08-08','10:00:00',3.07),('8975','2013-08-08','10:05:00',4.01),('8975','2013-08-08','10:10:00',4.23),('8975','2013-08-08','10:15:00',4.92),('8975','2013-08-08','10:20:00',4.95),('8975','2013-08-08','10:25:00',4.93),('8975','2013-08-08','10:30:00',5.2),('8975','2013-08-08','10:35:00',5.18),('8975','2013-08-08','10:40:00',5.31),('8975','2013-08-08','10:45:00',5.3),('8975','2013-08-08','10:50:00',5.28),('8975','2013-08-08','10:55:00',5.35),('8975','2013-08-08','11:00:00',5.45),('8975','2013-08-08','11:05:00',5.42),('8975','2013-08-08','11:10:00',5.54),('8975','2013-08-08','11:15:00',5.52),('8975','2013-08-08','11:20:00',5.48),('8975','2013-08-08','11:25:00',5.55),('8975','2013-08-08','11:30:00',5.57),('8975','2013-08-08','11:35:00',5.56),('8975','2013-08-08','11:40:00',5.59),('8975','2013-08-08','11:45:00',5.64),('8975','2013-08-08','11:50:00',5.63),('8975','2013-08-08','11:55:00',5.71),('8975','2013-08-08','12:00:00',5.75),('8975','2013-08-08','12:05:00',5.74),('8975','2013-08-08','12:10:00',5.72),('8975','2013-08-08','12:15:00',5.8),('8975','2013-08-08','12:20:00',5.77),('8975','2013-08-08','12:25:00',3.03),('8975','2013-08-08','12:30:00',3.26),('8975','2013-08-08','12:35:00',4.21),('8975','2013-08-08','12:40:00',5.02),('8975','2013-08-08','12:45:00',3.49),('8975','2013-08-08','12:50:00',3.25),('8975','2013-08-08','12:55:00',3.23),('8975','2013-08-08','13:00:00',1.47),('8975','2013-08-08','13:05:00',1.29),('8975','2013-08-08','13:10:00',1.3),('8975','2013-08-08','13:15:00',2.26),('8975','2013-08-08','13:20:00',3.3),('8975','2013-08-08','13:25:00',3.04),('8975','2013-08-08','13:30:00',2.79),('8975','2013-08-08','13:35:00',2.48),('8975','2013-08-08','13:40:00',2.28),('8975','2013-08-08','13:45:00',2.34),('8975','2013-08-08','13:50:00',2.34),('8975','2013-08-08','13:55:00',2),('8975','2013-08-08','14:00:00',1.95),('8975','2013-08-08','14:05:00',2.04),('8975','2013-08-08','14:10:00',1.89),('8975','2013-08-08','14:15:00',1.49),('8975','2013-08-08','14:20:00',1.44),('8975','2013-08-08','14:25:00',1.64),('8975','2013-08-08','14:30:00',1.52),('8975','2013-08-08','14:35:00',1.02),('8975','2013-08-08','15:05:00',2.33),('8975','2013-08-08','15:10:00',3.91),('8975','2013-08-08','15:15:00',3.11),('8975','2013-08-08','15:20:00',2.11),('8975','2013-08-08','15:25:00',1.66),('8975','2013-08-08','15:30:00',2.08),('8975','2013-08-08','15:35:00',3.2),('8975','2013-08-08','15:40:00',2.49),('8975','2013-08-08','15:45:00',4.03),('8975','2013-08-08','15:50:00',3.5),('8975','2013-08-08','15:55:00',3.19),('8975','2013-08-08','16:00:00',1.63),('8975','2013-08-08','16:05:00',1.06),('8975','2013-08-08','16:10:00',1.02),('8975','2013-08-08','16:15:00',1.07),('8975','2013-08-08','16:20:00',1.2),('8975','2013-08-08','16:25:00',1.36),('8975','2013-08-08','16:35:00',1.01),('8975','2013-08-08','16:40:00',1.06),('8975','2013-08-08','16:45:00',1.47),('8975','2013-08-08','16:50:00',2.36),('8975','2013-08-08','16:55:00',2.46),('8975','2013-08-08','17:00:00',2.82),('8975','2013-08-08','17:05:00',1.72),('8975','2013-08-08','17:10:00',1.22),('8975','2013-08-08','17:25:00',1.04),('8975','2013-08-08','17:30:00',1.24),('8975','2013-08-08','17:35:00',1.29),('8975','2013-08-08','17:40:00',1.18),('8975','2013-08-08','17:45:00',1.16),('8975','2013-08-08','19:00:00',1.04),('8975','2013-08-08','19:05:00',1.26),('8975','2013-08-08','19:10:00',1.32),('8975','2013-08-08','19:15:00',1.38),('8975','2013-08-08','19:20:00',1.6),('8975','2013-08-08','19:25:00',1.44),('8975','2013-08-07','07:05:00',1.02),('8975','2013-08-07','07:10:00',1.16),('8975','2013-08-07','07:15:00',1.28),('8975','2013-08-07','07:20:00',1.46),('8975','2013-08-07','07:25:00',1.64),('8975','2013-08-07','07:30:00',1.81),('8975','2013-08-07','07:35:00',1.96),('8975','2013-08-07','07:40:00',2.1),('8975','2013-08-07','07:45:00',2.22),('8975','2013-08-07','07:50:00',2.32),('8975','2013-08-07','07:55:00',2.44),('8975','2013-08-07','08:00:00',2.56),('8975','2013-08-07','08:05:00',2.66),('8975','2013-08-07','08:10:00',2.78),('8975','2013-08-07','08:15:00',2.9),('8975','2013-08-07','08:20:00',2.99),('8975','2013-08-07','08:25:00',3.1),('8975','2013-08-07','08:30:00',3.2),('8975','2013-08-07','08:35:00',3.3),('8975','2013-08-07','08:40:00',3.39),('8975','2013-08-07','08:45:00',3.49),('8975','2013-08-07','08:50:00',3.59),('8975','2013-08-07','08:55:00',3.68),('8975','2013-08-07','09:00:00',3.8),('8975','2013-08-07','09:05:00',3.91),('8975','2013-08-07','09:10:00',4),('8975','2013-08-07','09:15:00',4.09),('8975','2013-08-07','09:20:00',4.16),('8975','2013-08-07','09:25:00',4.26),('8975','2013-08-07','09:30:00',4.32),('8975','2013-08-07','09:35:00',4.38),('8975','2013-08-07','09:40:00',4.45),('8975','2013-08-07','09:45:00',4.54),('8975','2013-08-07','09:50:00',4.64),('8975','2013-08-07','09:55:00',4.71),('8975','2013-08-07','10:00:00',4.75),('8975','2013-08-07','10:05:00',4.82),('8975','2013-08-07','10:10:00',4.85),('8975','2013-08-07','10:15:00',4.95),('8975','2013-08-07','10:20:00',4.99),('8975','2013-08-07','10:25:00',5.04),('8975','2013-08-07','10:30:00',5.09),('8975','2013-08-07','10:35:00',5.16),('8975','2013-08-07','10:40:00',5.21),('8975','2013-08-07','10:45:00',5.27),('8975','2013-08-07','10:50:00',5.31),('8975','2013-08-07','10:55:00',5.34),('8975','2013-08-07','11:00:00',5.4),('8975','2013-08-07','11:05:00',5.41),('8975','2013-08-07','11:10:00',5.45),('8975','2013-08-07','11:15:00',5.48),('8975','2013-08-07','11:20:00',5.49),('8975','2013-08-07','11:25:00',5.53),('8975','2013-08-07','11:30:00',5.58),('8975','2013-08-07','11:35:00',5.55),('8975','2013-08-07','11:40:00',5.56),('8975','2013-08-07','11:45:00',5.52),('8975','2013-08-07','11:50:00',5.57),('8975','2013-08-07','11:55:00',5.65),('8975','2013-08-07','12:00:00',5.65),('8975','2013-08-07','12:05:00',5.67),('8975','2013-08-07','12:10:00',5.69),('8975','2013-08-07','12:15:00',5.7),('8975','2013-08-07','12:20:00',5.7),('8975','2013-08-07','12:25:00',5.71),('8975','2013-08-07','12:30:00',5.78),('8975','2013-08-07','12:35:00',5.72),('8975','2013-08-07','12:40:00',5.72),('8975','2013-08-07','12:45:00',5.77),('8975','2013-08-07','12:50:00',5.68),('8975','2013-08-07','12:55:00',5.64),('8975','2013-08-07','13:00:00',5.73),('8975','2013-08-07','13:05:00',5.68),('8975','2013-08-07','13:10:00',5.68),('8975','2013-08-07','13:15:00',5.66),('8975','2013-08-07','13:20:00',5.61),('8975','2013-08-07','13:25:00',5.61),('8975','2013-08-07','13:30:00',5.57),('8975','2013-08-07','13:35:00',5.54),('8975','2013-08-07','13:40:00',5.55),('8975','2013-08-07','13:45:00',5.51),('8975','2013-08-07','13:50:00',5.49),('8975','2013-08-07','13:55:00',5.44),('8975','2013-08-07','14:00:00',5.36),('8975','2013-08-07','14:05:00',5.32),('8975','2013-08-07','14:10:00',5.31),('8975','2013-08-07','14:15:00',5.25),('8975','2013-08-07','14:20:00',5.17),('8975','2013-08-07','14:25:00',5.15),('8975','2013-08-07','14:30:00',5.06),('8975','2013-08-07','14:35:00',4.96),('8975','2013-08-07','14:40:00',4.89),('8975','2013-08-07','14:45:00',4.85),('8975','2013-08-07','14:50:00',4.77),('8975','2013-08-07','14:55:00',4.71),('8975','2013-08-07','15:00:00',4.63),('8975','2013-08-07','15:05:00',4.58),('8975','2013-08-07','15:10:00',4.47),('8975','2013-08-07','15:15:00',4.37),('8975','2013-08-07','15:20:00',4.34),('8975','2013-08-07','15:25:00',4.25),('8975','2013-08-07','15:30:00',4.16),('8975','2013-08-07','15:35:00',4.1),('8975','2013-08-07','15:40:00',4),('8975','2013-08-07','15:45:00',3.91),('8975','2013-08-07','15:50:00',3.83),('8975','2013-08-07','15:55:00',3.77),('8975','2013-08-07','16:00:00',3.68),('8975','2013-08-07','16:05:00',3.61),('8975','2013-08-07','16:10:00',3.51),('8975','2013-08-07','16:15:00',3.41),('8975','2013-08-07','16:20:00',3.32),('8975','2013-08-07','16:25:00',3.26),('8975','2013-08-07','16:30:00',3.15),('8975','2013-08-07','16:35:00',3.06),('8975','2013-08-07','16:40:00',2.93),('8975','2013-08-07','16:45:00',2.8),('8975','2013-08-07','16:50:00',2.64),('8975','2013-08-07','16:55:00',2.58),('8975','2013-08-07','17:00:00',2.47),('8975','2013-08-07','17:05:00',2.35),('8975','2013-08-07','17:10:00',2.25),('8975','2013-08-07','17:15:00',2.15),('8975','2013-08-07','17:20:00',2.06),('8975','2013-08-07','17:25:00',1.96),('8975','2013-08-07','17:30:00',1.87),('8975','2013-08-07','17:35:00',1.8),('8975','2013-08-07','17:40:00',1.73),('8975','2013-08-07','17:45:00',1.65),('8975','2013-08-07','17:50:00',1.56),('8975','2013-08-07','17:55:00',1.5),('8975','2013-08-07','18:00:00',1.44),('8975','2013-08-07','18:05:00',1.36),('8975','2013-08-07','18:10:00',1.3),('8975','2013-08-07','18:15:00',1.22),('8975','2013-08-07','18:20:00',1.18),('8975','2013-08-07','18:25:00',1.12),('8975','2013-08-07','18:30:00',1.07),('8975','2013-08-07','18:35:00',1.02),('8975','2013-08-06','07:00:00',1.07),('8975','2013-08-06','07:05:00',1.19),('8975','2013-08-06','07:10:00',1.31),('8975','2013-08-06','07:15:00',1.42),('8975','2013-08-06','07:20:00',1.48),('8975','2013-08-06','07:25:00',1.74),('8975','2013-08-06','07:30:00',1.97),('8975','2013-08-06','07:35:00',2.12),('8975','2013-08-06','07:40:00',2.25),('8975','2013-08-06','07:45:00',2.35),('8975','2013-08-06','07:50:00',2.48),('8975','2013-08-06','07:55:00',2.61),('8975','2013-08-06','08:00:00',2.72),('8975','2013-08-06','08:05:00',2.82),('8975','2013-08-06','08:10:00',2.94),('8975','2013-08-06','08:15:00',3.05),('8975','2013-08-06','08:20:00',3.15),('8975','2013-08-06','08:25:00',3.25),('8975','2013-08-06','08:30:00',3.36),('8975','2013-08-06','08:35:00',3.46),('8975','2013-08-06','08:40:00',3.57),('8975','2013-08-06','08:45:00',3.65),('8975','2013-08-06','08:50:00',3.74),('8975','2013-08-06','08:55:00',3.83),('8975','2013-08-06','09:00:00',3.9),('8975','2013-08-06','09:05:00',3.98),('8975','2013-08-06','09:10:00',4.05),('8975','2013-08-06','09:15:00',4.17),('8975','2013-08-06','09:20:00',4.26),('8975','2013-08-06','09:25:00',4.36),('8975','2013-08-06','09:30:00',4.43),('8975','2013-08-06','09:35:00',4.53),('8975','2013-08-06','09:40:00',4.59),('8975','2013-08-06','09:45:00',4.67),('8975','2013-08-06','09:50:00',4.74),('8975','2013-08-06','09:55:00',4.78),('8975','2013-08-06','10:00:00',4.85),('8975','2013-08-06','10:05:00',4.88),('8975','2013-08-06','10:10:00',4.95),('8975','2013-08-06','10:15:00',5.03),('8975','2013-08-06','10:20:00',5.07),('8975','2013-08-06','10:25:00',5.13),('8975','2013-08-06','10:30:00',5.2),('8975','2013-08-06','10:35:00',5.25),('8975','2013-08-06','10:40:00',5.28),('8975','2013-08-06','10:45:00',5.34),('8975','2013-08-06','10:50:00',5.39),('8975','2013-08-06','10:55:00',5.43),('8975','2013-08-06','11:00:00',5.46),('8975','2013-08-06','11:05:00',5.49),('8975','2013-08-06','11:10:00',5.54),('8975','2013-08-06','11:15:00',5.54),('8975','2013-08-06','11:20:00',5.54),('8975','2013-08-06','11:25:00',5.59),('8975','2013-08-06','11:30:00',5.63),('8975','2013-08-06','11:35:00',5.63),('8975','2013-08-06','11:40:00',5.66),('8975','2013-08-06','11:45:00',5.72),('8975','2013-08-06','11:50:00',5.72),('8975','2013-08-06','11:55:00',5.7),('8975','2013-08-06','12:00:00',5.72),('8975','2013-08-06','12:05:00',5.71),('8975','2013-08-06','12:10:00',5.76),('8975','2013-08-06','12:15:00',5.78),('8975','2013-08-06','12:20:00',5.76),('8975','2013-08-06','12:25:00',5.75),('8975','2013-08-06','12:30:00',5.7),('8975','2013-08-06','12:35:00',5.78),('8975','2013-08-06','12:40:00',5.78),('8975','2013-08-06','12:45:00',5.79),('8975','2013-08-06','12:50:00',5.71),('8975','2013-08-06','12:55:00',5.69),('8975','2013-08-06','13:00:00',5.69),('8975','2013-08-06','13:05:00',5.66),('8975','2013-08-06','13:10:00',5.66),('8975','2013-08-06','13:15:00',5.69),('8975','2013-08-06','13:20:00',5.71),('8975','2013-08-06','13:25:00',5.65),('8975','2013-08-06','13:30:00',5.61),('8975','2013-08-06','13:35:00',5.5),('8975','2013-08-06','13:40:00',5.63),('8975','2013-08-06','13:45:00',5.58),('8975','2013-08-06','13:50:00',5.52),('8975','2013-08-06','13:55:00',5.54),('8975','2013-08-06','14:00:00',5.46),('8975','2013-08-06','14:05:00',5.41),('8975','2013-08-06','14:10:00',5.36),('8975','2013-08-06','14:15:00',5.34),('8975','2013-08-06','14:20:00',5.28),('8975','2013-08-06','14:25:00',5.2),('8975','2013-08-06','14:30:00',5.19),('8975','2013-08-06','14:35:00',5.04),('8975','2013-08-06','14:40:00',4.9),('8975','2013-08-06','14:45:00',4.86),('8975','2013-08-06','14:50:00',4.81),('8975','2013-08-06','14:55:00',4.74),('8975','2013-08-06','15:00:00',4.71),('8975','2013-08-06','15:05:00',4.65),('8975','2013-08-06','15:10:00',4.4),('8975','2013-08-06','15:15:00',4.42),('8975','2013-08-06','15:20:00',4.29),('8975','2013-08-06','15:25:00',4.08),('8975','2013-08-06','15:30:00',3.95),('8975','2013-08-06','15:35:00',3.97),('8975','2013-08-06','15:40:00',3.99),('8975','2013-08-06','15:45:00',3.94),('8975','2013-08-06','15:50:00',3.86),('8975','2013-08-06','15:55:00',3.78),('8975','2013-08-06','16:00:00',3.77),('8975','2013-08-06','16:05:00',3.69),('8975','2013-08-06','16:10:00',3.58),('8975','2013-08-06','16:15:00',3.45),('8975','2013-08-06','16:20:00',3.38),('8975','2013-08-06','16:25:00',3.29),('8975','2013-08-06','16:30:00',3.18),('8975','2013-08-06','16:35:00',3.08),('8975','2013-08-06','16:40:00',2.99),('8975','2013-08-06','16:45:00',2.88),('8975','2013-08-06','16:50:00',2.78),('8975','2013-08-06','16:55:00',2.68),('8975','2013-08-06','17:00:00',2.57),('8975','2013-08-06','17:05:00',2.45),('8975','2013-08-06','17:10:00',2.37),('8975','2013-08-06','17:15:00',2.26),('8975','2013-08-06','17:20:00',2.16),('8975','2013-08-06','17:25:00',2.07),('8975','2013-08-06','17:30:00',1.98),('8975','2013-08-06','17:35:00',1.89),('8975','2013-08-06','17:40:00',1.81),('8975','2013-08-06','17:45:00',1.72),('8975','2013-08-06','17:50:00',1.63),('8975','2013-08-06','17:55:00',1.56),('8975','2013-08-06','18:00:00',1.48),('8975','2013-08-06','18:05:00',1.4),('8975','2013-08-06','18:10:00',1.34),('8975','2013-08-06','18:15:00',1.29),('8975','2013-08-06','18:20:00',1.21),('8975','2013-08-06','18:25:00',1.16),('8975','2013-08-06','18:30:00',1.11),('8975','2013-08-06','18:35:00',1.06),('8975','2013-08-06','18:40:00',1.03),('8975','2013-08-05','07:05:00',1.04),('8975','2013-08-05','07:10:00',1.18),('8975','2013-08-05','07:15:00',1.29),('8975','2013-08-05','07:20:00',1.47),('8975','2013-08-05','07:25:00',1.65),('8975','2013-08-05','07:30:00',1.8),('8975','2013-08-05','07:35:00',1.95),('8975','2013-08-05','07:40:00',2.1),('8975','2013-08-05','07:45:00',2.23),('8975','2013-08-05','07:50:00',2.35),('8975','2013-08-05','07:55:00',2.47),('8975','2013-08-05','08:00:00',2.58),('8975','2013-08-05','08:05:00',2.7),('8975','2013-08-05','08:10:00',2.83),('8975','2013-08-05','08:15:00',2.94),('8975','2013-08-05','08:20:00',3.04),('8975','2013-08-05','08:25:00',3.15),('8975','2013-08-05','08:30:00',3.26),('8975','2013-08-05','08:35:00',3.35),('8975','2013-08-05','08:40:00',3.44),('8975','2013-08-05','08:45:00',3.56),('8975','2013-08-05','08:50:00',3.67),('8975','2013-08-05','08:55:00',3.74),('8975','2013-08-05','09:00:00',3.82),('8975','2013-08-05','09:05:00',3.92),('8975','2013-08-05','09:10:00',4.01),('8975','2013-08-05','09:15:00',4.07),('8975','2013-08-05','09:20:00',4.15),('8975','2013-08-05','09:25:00',4.25),('8975','2013-08-05','09:30:00',4.34),('8975','2013-08-05','09:35:00',4.43),('8975','2013-08-05','09:40:00',4.52),('8975','2013-08-05','09:45:00',4.61),('8975','2013-08-05','09:50:00',4.7),('8975','2013-08-05','09:55:00',4.77),('8975','2013-08-05','10:00:00',4.85),('8975','2013-08-05','10:05:00',4.92),('8975','2013-08-05','10:10:00',4.98),('8975','2013-08-05','10:15:00',5.05),('8975','2013-08-05','10:20:00',5.11),('8975','2013-08-05','10:25:00',5.15),('8975','2013-08-05','10:30:00',5.21),('8975','2013-08-05','10:35:00',5.25),('8975','2013-08-05','10:40:00',5.29),('8975','2013-08-05','10:45:00',5.35),('8975','2013-08-05','10:50:00',5.4),('8975','2013-08-05','10:55:00',5.43),('8975','2013-08-05','11:00:00',5.46),('8975','2013-08-05','11:05:00',5.53),('8975','2013-08-05','11:10:00',5.55),('8975','2013-08-05','11:15:00',5.57),('8975','2013-08-05','11:20:00',5.58),('8975','2013-08-05','11:25:00',5.63),('8975','2013-08-05','11:30:00',5.61),('8975','2013-08-05','11:35:00',5.64),('8975','2013-08-05','11:40:00',5.68),('8975','2013-08-05','11:45:00',5.69),('8975','2013-08-05','11:50:00',5.67),('8975','2013-08-05','11:55:00',5.71),('8975','2013-08-05','12:00:00',5.69),('8975','2013-08-05','12:05:00',5.75),('8975','2013-08-05','12:10:00',5.79),('8975','2013-08-05','12:15:00',5.78),('8975','2013-08-05','12:20:00',5.73),('8975','2013-08-05','12:25:00',5.74),('8975','2013-08-05','12:30:00',5.76),('8975','2013-08-05','12:35:00',5.74),('8975','2013-08-05','12:40:00',5.75),('8975','2013-08-05','12:45:00',5.74),('8975','2013-08-05','12:50:00',5.65),('8975','2013-08-05','12:55:00',5.68),('8975','2013-08-05','13:00:00',5.72),('8975','2013-08-05','13:05:00',5.66),('8975','2013-08-05','13:10:00',5.7),('8975','2013-08-05','13:15:00',5.68),('8975','2013-08-05','13:20:00',5.65),('8975','2013-08-05','13:25:00',5.68),('8975','2013-08-05','13:30:00',5.69),('8975','2013-08-05','13:35:00',5.64),('8975','2013-08-05','13:40:00',5.66),('8975','2013-08-05','13:45:00',5.62),('8975','2013-08-05','13:50:00',5.58),('8975','2013-08-05','13:55:00',5.56),('8975','2013-08-05','14:00:00',5.54),('8975','2013-08-05','14:05:00',5.52),('8975','2013-08-05','14:10:00',5.48),('8975','2013-08-05','14:15:00',5.46),('8975','2013-08-05','14:20:00',5.42),('8975','2013-08-05','14:25:00',5.38),('8975','2013-08-05','14:30:00',5.31),('8975','2013-08-05','14:35:00',5.24),('8975','2013-08-05','14:40:00',5.19),('8975','2013-08-05','14:45:00',5.13),('8975','2013-08-05','14:50:00',5.07),('8975','2013-08-05','14:55:00',5),('8975','2013-08-05','15:00:00',4.94),('8975','2013-08-05','15:05:00',4.85),('8975','2013-08-05','15:10:00',4.77),('8975','2013-08-05','15:15:00',4.71),('8975','2013-08-05','15:20:00',4.64),('8975','2013-08-05','15:25:00',4.54),('8975','2013-08-05','15:30:00',4.45),('8975','2013-08-05','15:35:00',4.31),('8975','2013-08-05','15:40:00',4.28),('8975','2013-08-05','15:45:00',4.17),('8975','2013-08-05','15:50:00',4.08),('8975','2013-08-05','15:55:00',3.98),('8975','2013-08-05','16:00:00',3.88),('8975','2013-08-05','16:05:00',3.78),('8975','2013-08-05','16:10:00',3.69),('8975','2013-08-05','16:15:00',3.59),('8975','2013-08-05','16:20:00',3.48),('8975','2013-08-05','16:25:00',3.37),('8975','2013-08-05','16:30:00',3.27),('8975','2013-08-05','16:35:00',3.13),('8975','2013-08-05','16:40:00',3.06),('8975','2013-08-05','16:45:00',2.94),('8975','2013-08-05','16:50:00',2.83),('8975','2013-08-05','16:55:00',2.74),('8975','2013-08-05','17:00:00',2.64),('8975','2013-08-05','17:05:00',2.52),('8975','2013-08-05','17:10:00',2.41),('8975','2013-08-05','17:15:00',2.3),('8975','2013-08-05','17:20:00',2.2),('8975','2013-08-05','17:25:00',2.11),('8975','2013-08-05','17:30:00',2),('8975','2013-08-05','17:35:00',1.88),('8975','2013-08-05','17:40:00',1.78),('8975','2013-08-05','17:45:00',1.7),('8975','2013-08-05','17:50:00',1.63),('8975','2013-08-05','17:55:00',1.55),('8975','2013-08-05','18:00:00',1.49),('8975','2013-08-05','18:05:00',1.43),('8975','2013-08-05','18:10:00',1.36),('8975','2013-08-05','18:15:00',1.31),('8975','2013-08-05','18:20:00',1.25),('8975','2013-08-05','18:25:00',1.2),('8975','2013-08-05','18:30:00',1.14),('8975','2013-08-05','18:35:00',1.11),('8975','2013-08-05','18:40:00',1.05),('8975','2013-08-04','07:00:00',1.1),('8975','2013-08-04','07:05:00',1.23),('8975','2013-08-04','07:10:00',1.33),('8975','2013-08-04','07:15:00',1.44),('8975','2013-08-04','07:20:00',1.61),('8975','2013-08-04','07:25:00',1.82),('8975','2013-08-04','07:30:00',1.96),('8975','2013-08-04','07:35:00',2.11),('8975','2013-08-04','07:40:00',2.23),('8975','2013-08-04','07:45:00',2.37),('8975','2013-08-04','07:50:00',2.53),('8975','2013-08-04','07:55:00',2.65),('8975','2013-08-04','08:00:00',2.75),('8975','2013-08-04','08:05:00',2.88),('8975','2013-08-04','08:10:00',2.99),('8975','2013-08-04','08:15:00',3.07),('8975','2013-08-04','08:20:00',3.18),('8975','2013-08-04','08:25:00',3.27),('8975','2013-08-04','08:30:00',3.33),('8975','2013-08-04','08:35:00',3.42),('8975','2013-08-04','08:40:00',3.51),('8975','2013-08-04','08:45:00',3.61),('8975','2013-08-04','08:50:00',3.72),('8975','2013-08-04','08:55:00',3.84),('8975','2013-08-04','09:00:00',3.92),('8975','2013-08-04','09:05:00',4.04),('8975','2013-08-04','09:10:00',4.12),('8975','2013-08-04','09:15:00',4.22),('8975','2013-08-04','09:20:00',4.31),('8975','2013-08-04','09:25:00',4.41),('8975','2013-08-04','09:30:00',4.47),('8975','2013-08-04','09:35:00',4.58),('8975','2013-08-04','09:40:00',4.67),('8975','2013-08-04','09:45:00',4.72),('8975','2013-08-04','09:50:00',4.79),('8975','2013-08-04','09:55:00',4.86),('8975','2013-08-04','10:00:00',4.94),('8975','2013-08-04','10:05:00',5.01),('8975','2013-08-04','10:10:00',5.07),('8975','2013-08-04','10:15:00',5.13),('8975','2013-08-04','10:20:00',5.21),('8975','2013-08-04','10:25:00',5.25),('8975','2013-08-04','10:30:00',5.3),('8975','2013-08-04','10:35:00',5.37),('8975','2013-08-04','10:40:00',5.39),('8975','2013-08-04','10:45:00',5.47),('8975','2013-08-04','10:50:00',5.54),('8975','2013-08-04','10:55:00',5.58),('8975','2013-08-04','11:00:00',5.6),('8975','2013-08-04','11:05:00',5.61),('8975','2013-08-04','11:10:00',5.68),('8975','2013-08-04','11:15:00',5.71),('8975','2013-08-04','11:20:00',5.71),('8975','2013-08-04','11:25:00',5.77),('8975','2013-08-04','11:30:00',5.72),('8975','2013-08-04','11:35:00',5.78),('8975','2013-08-04','11:40:00',5.85),('8975','2013-08-04','11:45:00',5.87),('8975','2013-08-04','11:50:00',5.87),('8975','2013-08-04','11:55:00',5.86),('8975','2013-08-04','12:00:00',5.85),('8975','2013-08-04','12:05:00',5.87),('8975','2013-08-04','12:10:00',5.98),('8975','2013-08-04','12:15:00',5.93),('8975','2013-08-04','12:20:00',5.88),('8975','2013-08-04','12:25:00',5.91),('8975','2013-08-04','12:30:00',5.91),('8975','2013-08-04','12:35:00',5.89),('8975','2013-08-04','12:40:00',5.92),('8975','2013-08-04','12:45:00',5.89),('8975','2013-08-04','12:50:00',5.84),('8975','2013-08-04','12:55:00',5.82),('8975','2013-08-04','13:00:00',5.8),('8975','2013-08-04','13:05:00',5.82),('8975','2013-08-04','13:10:00',5.75),('8975','2013-08-04','13:15:00',5.75),('8975','2013-08-04','13:20:00',5.74),('8975','2013-08-04','13:25:00',5.67),('8975','2013-08-04','13:30:00',5.71),('8975','2013-08-04','13:35:00',5.63),('8975','2013-08-04','13:40:00',5.55),('8975','2013-08-04','13:45:00',5.55),('8975','2013-08-04','13:50:00',5.24),('8975','2013-08-04','13:55:00',4.88),('8975','2013-08-04','14:00:00',5.34),('8975','2013-08-04','14:05:00',4.34),('8975','2013-08-04','14:10:00',5.17),('8975','2013-08-04','14:15:00',4.64),('8975','2013-08-04','14:20:00',4.4),('8975','2013-08-04','14:25:00',5.21),('8975','2013-08-04','14:30:00',5.15),('8975','2013-08-04','14:35:00',5.05),('8975','2013-08-04','14:40:00',5.05),('8975','2013-08-04','14:45:00',4.98),('8975','2013-08-04','14:50:00',4.94),('8975','2013-08-04','14:55:00',4.88),('8975','2013-08-04','15:00:00',4.82),('8975','2013-08-04','15:05:00',4.78),('8975','2013-08-04','15:10:00',4.69),('8975','2013-08-04','15:15:00',4.64),('8975','2013-08-04','15:20:00',4.55),('8975','2013-08-04','15:25:00',4.47),('8975','2013-08-04','15:30:00',4.42),('8975','2013-08-04','15:35:00',4.35),('8975','2013-08-04','15:40:00',4.25),('8975','2013-08-04','15:45:00',4.14),('8975','2013-08-04','15:50:00',4.06),('8975','2013-08-04','15:55:00',3.98),('8975','2013-08-04','16:00:00',3.9),('8975','2013-08-04','16:05:00',3.8),('8975','2013-08-04','16:10:00',3.7),('8975','2013-08-04','16:15:00',3.58),('8975','2013-08-04','16:20:00',3.47),('8975','2013-08-04','16:25:00',3.36),('8975','2013-08-04','16:30:00',3.25),('8975','2013-08-04','16:35:00',3.15),('8975','2013-08-04','16:40:00',3.04),('8975','2013-08-04','16:45:00',2.95),('8975','2013-08-04','16:50:00',2.83),('8975','2013-08-04','16:55:00',2.71),('8975','2013-08-04','17:00:00',2.59),('8975','2013-08-04','17:05:00',2.5),('8975','2013-08-04','17:10:00',2.39),('8975','2013-08-04','17:15:00',2.29),('8975','2013-08-04','17:20:00',2.19),('8975','2013-08-04','17:25:00',2.09),('8975','2013-08-04','17:30:00',2),('8975','2013-08-04','17:35:00',1.9),('8975','2013-08-04','17:40:00',1.82),('8975','2013-08-04','17:45:00',1.75),('8975','2013-08-04','17:50:00',1.65),('8975','2013-08-04','17:55:00',1.57),('8975','2013-08-04','18:00:00',1.51),('8975','2013-08-04','18:05:00',1.43),('8975','2013-08-04','18:10:00',1.36),('8975','2013-08-04','18:15:00',1.26),('8975','2013-08-04','18:20:00',1.21),('8975','2013-08-04','18:25:00',1.15),('8975','2013-08-04','18:30:00',1.09),('8975','2013-08-04','18:35:00',1.07),('8975','2013-08-04','18:40:00',1.02),('8975','2013-08-03','07:00:00',1.52),('8975','2013-08-03','07:05:00',1.67),('8975','2013-08-03','07:10:00',1.74),('8975','2013-08-03','07:15:00',1.88),('8975','2013-08-03','07:20:00',2.03),('8975','2013-08-03','07:25:00',2.25),('8975','2013-08-03','07:30:00',2.38),('8975','2013-08-03','07:35:00',2.51),('8975','2013-08-03','07:40:00',2.62),('8975','2013-08-03','07:45:00',2.75),('8975','2013-08-03','07:50:00',2.86),('8975','2013-08-03','07:55:00',2.99),('8975','2013-08-03','08:00:00',3.06),('8975','2013-08-03','08:05:00',3.15),('8975','2013-08-03','08:10:00',3.25),('8975','2013-08-03','08:15:00',3.36),('8975','2013-08-03','08:20:00',3.47),('8975','2013-08-03','08:25:00',3.58),('8975','2013-08-03','08:30:00',3.68),('8975','2013-08-03','08:35:00',3.76),('8975','2013-08-03','08:40:00',3.86),('8975','2013-08-03','08:45:00',3.95),('8975','2013-08-03','08:50:00',4.03),('8975','2013-08-03','08:55:00',4.1),('8975','2013-08-03','09:00:00',4.16),('8975','2013-08-03','09:05:00',4.27),('8975','2013-08-03','09:10:00',4.37),('8975','2013-08-03','09:15:00',4.44),('8975','2013-08-03','09:20:00',4.55),('8975','2013-08-03','09:25:00',4.62),('8975','2013-08-03','09:30:00',4.72),('8975','2013-08-03','09:35:00',4.81),('8975','2013-08-03','09:40:00',4.87),('8975','2013-08-03','09:45:00',4.94),('8975','2013-08-03','09:50:00',5.01),('8975','2013-08-03','09:55:00',5.08),('8975','2013-08-03','10:00:00',5.13),('8975','2013-08-03','10:05:00',5.19),('8975','2013-08-03','10:10:00',5.25),('8975','2013-08-03','10:15:00',5.28),('8975','2013-08-03','10:20:00',5.37),('8975','2013-08-03','10:25:00',5.42),('8975','2013-08-03','10:30:00',5.49),('8975','2013-08-03','10:35:00',5.55),('8975','2013-08-03','10:40:00',5.59),('8975','2013-08-03','10:45:00',5.66),('8975','2013-08-03','10:50:00',5.71),('8975','2013-08-03','10:55:00',5.73),('8975','2013-08-03','11:00:00',5.73),('8975','2013-08-03','11:05:00',5.74),('8975','2013-08-03','11:10:00',5.77),('8975','2013-08-03','11:15:00',5.84),('8975','2013-08-03','11:20:00',5.87),('8975','2013-08-03','11:25:00',5.93),('8975','2013-08-03','11:30:00',5.93),('8975','2013-08-03','11:35:00',6),('8975','2013-08-03','11:40:00',6.03),('8975','2013-08-03','11:45:00',6.07),('8975','2013-08-03','11:50:00',6.05),('8975','2013-08-03','11:55:00',6.04),('8975','2013-08-03','12:00:00',6.08),('8975','2013-08-03','12:05:00',6.09),('8975','2013-08-03','12:10:00',6.12),('8975','2013-08-03','12:15:00',6.12),('8975','2013-08-03','12:20:00',6.04),('8975','2013-08-03','12:25:00',6.02),('8975','2013-08-03','12:30:00',6.08),('8975','2013-08-03','12:35:00',6.1),('8975','2013-08-03','12:40:00',6.1),('8975','2013-08-03','12:45:00',5.99),('8975','2013-08-03','12:50:00',6.11),('8975','2013-08-03','12:55:00',6.08),('8975','2013-08-03','13:00:00',5.94),('8975','2013-08-03','13:05:00',5.98),('8975','2013-08-03','13:10:00',5.78),('8975','2013-08-03','13:15:00',5.65),('8975','2013-08-03','13:20:00',5.94),('8975','2013-08-03','13:25:00',5.91),('8975','2013-08-03','13:30:00',5.51),('8975','2013-08-03','13:35:00',5.6),('8975','2013-08-03','13:40:00',5.57),('8975','2013-08-03','13:45:00',5.76),('8975','2013-08-03','13:50:00',5.53),('8975','2013-08-03','13:55:00',5.76),('8975','2013-08-03','14:00:00',5.71),('8975','2013-08-03','14:05:00',5.7),('8975','2013-08-03','14:10:00',5.65),('8975','2013-08-03','14:15:00',5.61),('8975','2013-08-03','14:20:00',5.53),('8975','2013-08-03','14:25:00',5.52),('8975','2013-08-03','14:30:00',5.47),('8975','2013-08-03','14:35:00',5.4),('8975','2013-08-03','14:40:00',5.34),('8975','2013-08-03','14:45:00',5.26),('8975','2013-08-03','14:50:00',5.18),('8975','2013-08-03','14:55:00',5.11),('8975','2013-08-03','15:00:00',4.99),('8975','2013-08-03','15:05:00',4.99),('8975','2013-08-03','15:10:00',4.9),('8975','2013-08-03','15:15:00',4.82),('8975','2013-08-03','15:20:00',4.7),('8975','2013-08-03','15:25:00',4.61),('8975','2013-08-03','15:30:00',4.51),('8975','2013-08-03','15:35:00',4.38),('8975','2013-08-03','15:40:00',4.34),('8975','2013-08-03','15:45:00',4.25),('8975','2013-08-03','15:50:00',4.15),('8975','2013-08-03','15:55:00',3.97),('8975','2013-08-03','16:00:00',3.81),('8975','2013-08-03','16:05:00',3.89),('8975','2013-08-03','16:10:00',3.82),('8975','2013-08-03','16:15:00',3.69),('8975','2013-08-03','16:20:00',3.58),('8975','2013-08-03','16:25:00',3.47),('8975','2013-08-03','16:30:00',3.39),('8975','2013-08-03','16:35:00',3.25),('8975','2013-08-03','16:40:00',3.14),('8975','2013-08-03','16:45:00',3.03),('8975','2013-08-03','16:50:00',2.9),('8975','2013-08-03','16:55:00',2.8),('8975','2013-08-03','17:00:00',2.68),('8975','2013-08-03','17:05:00',2.59),('8975','2013-08-03','17:10:00',2.45),('8975','2013-08-03','17:15:00',2.34),('8975','2013-08-03','17:20:00',2.24),('8975','2013-08-03','17:25:00',2.14),('8975','2013-08-03','17:30:00',2.04),('8975','2013-08-03','17:35:00',1.95),('8975','2013-08-03','17:40:00',1.85),('8975','2013-08-03','17:45:00',1.75),('8975','2013-08-03','17:50:00',1.67),('8975','2013-08-03','17:55:00',1.59),('8975','2013-08-03','18:00:00',1.51),('8975','2013-08-03','18:05:00',1.44),('8975','2013-08-03','18:10:00',1.37),('8975','2013-08-03','18:15:00',1.29),('8975','2013-08-03','18:20:00',1.26),('8975','2013-08-03','18:25:00',1.2),('8975','2013-08-03','18:30:00',1.15),('8975','2013-08-03','18:35:00',1.08),('8975','2013-08-03','18:40:00',1.02),('8975','2013-08-02','07:00:00',1.46),('8975','2013-08-02','07:05:00',1.56),('8975','2013-08-02','07:10:00',1.63),('8975','2013-08-02','07:15:00',1.49),('8975','2013-08-02','07:20:00',2),('8975','2013-08-02','07:25:00',1.93),('8975','2013-08-02','07:30:00',2.16),('8975','2013-08-02','07:35:00',2.4),('8975','2013-08-02','07:40:00',2.52),('8975','2013-08-02','07:45:00',2.49),('8975','2013-08-02','07:50:00',2.8),('8975','2013-08-02','07:55:00',2.5),('8975','2013-08-02','08:00:00',3.04),('8975','2013-08-02','08:05:00',2.72),('8975','2013-08-02','08:10:00',3.19),('8975','2013-08-02','08:15:00',3.33),('8975','2013-08-02','08:20:00',3.44),('8975','2013-08-02','08:25:00',3.53),('8975','2013-08-02','08:30:00',3.62),('8975','2013-08-02','08:35:00',3.72),('8975','2013-08-02','08:40:00',3.83),('8975','2013-08-02','08:45:00',3.92),('8975','2013-08-02','08:50:00',4.01),('8975','2013-08-02','08:55:00',4.08),('8975','2013-08-02','09:00:00',4.2),('8975','2013-08-02','09:05:00',4.28),('8975','2013-08-02','09:10:00',4.35),('8975','2013-08-02','09:15:00',4.43),('8975','2013-08-02','09:20:00',4.5),('8975','2013-08-02','09:25:00',4.59),('8975','2013-08-02','09:30:00',4.63),('8975','2013-08-02','09:35:00',4.74),('8975','2013-08-02','09:40:00',4.81),('8975','2013-08-02','09:45:00',4.89),('8975','2013-08-02','09:50:00',4.96),('8975','2013-08-02','09:55:00',5.03),('8975','2013-08-02','10:00:00',5.09),('8975','2013-08-02','10:05:00',5.17),('8975','2013-08-02','10:10:00',5.24),('8975','2013-08-02','10:15:00',5.26),('8975','2013-08-02','10:20:00',5.34),('8975','2013-08-02','10:25:00',5.4),('8975','2013-08-02','10:30:00',5.44),('8975','2013-08-02','10:35:00',5.53),('8975','2013-08-02','10:40:00',5.58),('8975','2013-08-02','10:45:00',5.64),('8975','2013-08-02','10:50:00',5.7),('8975','2013-08-02','10:55:00',5.73),('8975','2013-08-02','11:00:00',5.78),('8975','2013-08-02','11:05:00',5.82),('8975','2013-08-02','11:10:00',5.85),('8975','2013-08-02','11:15:00',5.84),('8975','2013-08-02','11:20:00',5.94),('8975','2013-08-02','11:25:00',5.95),('8975','2013-08-02','11:30:00',5.94),('8975','2013-08-02','11:35:00',6.02),('8975','2013-08-02','11:40:00',5.97),('8975','2013-08-02','11:45:00',5.99),('8975','2013-08-02','11:50:00',6.01),('8975','2013-08-02','11:55:00',6.07),('8975','2013-08-02','12:00:00',6.05),('8975','2013-08-02','12:05:00',6.11),('8975','2013-08-02','12:10:00',6.12),('8975','2013-08-02','12:15:00',5.99),('8975','2013-08-02','12:20:00',5.97),('8975','2013-08-02','12:25:00',5.95),('8975','2013-08-02','12:30:00',5.89),('8975','2013-08-02','12:35:00',6),('8975','2013-08-02','12:40:00',5.96),('8975','2013-08-02','12:45:00',5.88),('8975','2013-08-02','12:50:00',5.81),('8975','2013-08-02','12:55:00',5.82),('8975','2013-08-02','13:00:00',5.84),('8975','2013-08-02','13:05:00',5.82),('8975','2013-08-02','13:10:00',5.82),('8975','2013-08-02','13:15:00',5.78),('8975','2013-08-02','13:20:00',5.79),('8975','2013-08-02','13:25:00',5.76),('8975','2013-08-02','13:30:00',5.64),('8975','2013-08-02','13:35:00',5.64),('8975','2013-08-02','13:40:00',5.54),('8975','2013-08-02','13:45:00',5.42),('8975','2013-08-02','13:50:00',5.55),('8975','2013-08-02','13:55:00',5.47),('8975','2013-08-02','14:00:00',5.35),('8975','2013-08-02','14:05:00',5.37),('8975','2013-08-02','14:10:00',5.35),('8975','2013-08-02','14:15:00',5.29),('8975','2013-08-02','14:20:00',5.23),('8975','2013-08-02','14:25:00',5.16),('8975','2013-08-02','14:30:00',5.21),('8975','2013-08-02','14:35:00',5.3),('8975','2013-08-02','14:40:00',5.26),('8975','2013-08-02','14:45:00',5.13),('8975','2013-08-02','14:50:00',5.11),('8975','2013-08-02','14:55:00',5.01),('8975','2013-08-02','15:00:00',4.96),('8975','2013-08-02','15:05:00',4.89),('8975','2013-08-02','15:10:00',4.81),('8975','2013-08-02','15:15:00',4.73),('8975','2013-08-02','15:20:00',4.66),('8975','2013-08-02','15:25:00',4.6),('8975','2013-08-02','15:30:00',4.51),('8975','2013-08-02','15:35:00',4.42),('8975','2013-08-02','15:40:00',4.34),('8975','2013-08-02','15:45:00',4.23),('8975','2013-08-02','15:50:00',4.14),('8975','2013-08-02','15:55:00',4.05),('8975','2013-08-02','16:00:00',3.95),('8975','2013-08-02','16:05:00',3.86),('8975','2013-08-02','16:10:00',3.73),('8975','2013-08-02','16:15:00',3.64),('8975','2013-08-02','16:20:00',3.53),('8975','2013-08-02','16:25:00',3.42),('8975','2013-08-02','16:30:00',3.3),('8975','2013-08-02','16:35:00',3.23),('8975','2013-08-02','16:40:00',3.12),('8975','2013-08-02','16:45:00',2.98),('8975','2013-08-02','16:50:00',2.87),('8975','2013-08-02','16:55:00',2.78),('8975','2013-08-02','17:00:00',2.66),('8975','2013-08-02','17:05:00',2.54),('8975','2013-08-02','17:10:00',2.43),('8975','2013-08-02','17:15:00',2.33),('8975','2013-08-02','17:20:00',2.22),('8975','2013-08-02','17:25:00',2.13),('8975','2013-08-02','17:30:00',2.02),('8975','2013-08-02','17:35:00',1.93),('8975','2013-08-02','17:40:00',1.84),('8975','2013-08-02','17:45:00',1.75),('8975','2013-08-02','17:50:00',1.67),('8975','2013-08-02','17:55:00',1.59),('8975','2013-08-02','18:00:00',1.51),('8975','2013-08-02','18:05:00',1.44),('8975','2013-08-02','18:10:00',1.37),('8975','2013-08-02','18:15:00',1.32),('8975','2013-08-02','18:20:00',1.25),('8975','2013-08-02','18:25:00',1.21),('8975','2013-08-02','18:30:00',1.16),('8975','2013-08-02','18:35:00',1.12),('8975','2013-08-02','18:40:00',1.07),('8975','2013-08-02','18:45:00',1.02),('8975','2013-08-01','07:00:00',1.77),('8975','2013-08-01','07:05:00',1.9),('8975','2013-08-01','07:10:00',2.01),('8975','2013-08-01','07:15:00',2.13),('8975','2013-08-01','07:20:00',2.3),('8975','2013-08-01','07:25:00',2.45),('8975','2013-08-01','07:30:00',2.57),('8975','2013-08-01','07:35:00',2.7),('8975','2013-08-01','07:40:00',2.82),('8975','2013-08-01','07:45:00',2.93),('8975','2013-08-01','07:50:00',3.03),('8975','2013-08-01','07:55:00',3.11),('8975','2013-08-01','08:00:00',3.22),('8975','2013-08-01','08:05:00',3.32),('8975','2013-08-01','08:10:00',3.41),('8975','2013-08-01','08:15:00',3.5),('8975','2013-08-01','08:20:00',3.58),('8975','2013-08-01','08:25:00',3.68),('8975','2013-08-01','08:30:00',3.78),('8975','2013-08-01','12:40:00',6.07),('8975','2013-08-01','12:45:00',6.12),('8975','2013-08-01','12:50:00',6.15),('8975','2013-08-01','12:55:00',6.15),('8975','2013-08-01','13:00:00',6.13),('8975','2013-08-01','13:05:00',6.03),('8975','2013-08-01','13:10:00',6.01),('8975','2013-08-01','13:15:00',6.01),('8975','2013-08-01','13:20:00',6.04),('8975','2013-08-01','13:25:00',5.99),('8975','2013-08-01','13:30:00',5.98),('8975','2013-08-01','13:35:00',5.97),('8975','2013-08-01','13:40:00',5.82),('8975','2013-08-01','13:45:00',5.72),('8975','2013-08-01','13:50:00',5.66),('8975','2013-08-01','13:55:00',5.52),('8975','2013-08-01','14:00:00',5.66),('8975','2013-08-01','14:05:00',5.61),('8975','2013-08-01','14:10:00',5.56),('8975','2013-08-01','14:15:00',5.57),('8975','2013-08-01','14:20:00',5.63),('8975','2013-08-01','14:25:00',5.55),('8975','2013-08-01','14:30:00',5.42),('8975','2013-08-01','14:35:00',5.38),('8975','2013-08-01','14:40:00',5.29),('8975','2013-08-01','14:45:00',5.27),('8975','2013-08-01','14:50:00',5.17),('8975','2013-08-01','14:55:00',5.13),('8975','2013-08-01','15:00:00',5.06),('8975','2013-08-01','15:05:00',4.99),('8975','2013-08-01','15:10:00',4.92),('8975','2013-08-01','15:15:00',4.84),('8975','2013-08-01','15:20:00',4.79),('8975','2013-08-01','15:25:00',4.74),('8975','2013-08-01','15:30:00',4.64),('8975','2013-08-01','15:35:00',4.53),('8975','2013-08-01','15:40:00',4.44),('8975','2013-08-01','15:45:00',4.34),('8975','2013-08-01','15:50:00',4.25),('8975','2013-08-01','15:55:00',4.16),('8975','2013-08-01','16:00:00',4.07),('8975','2013-08-01','16:05:00',3.97),('8975','2013-08-01','16:10:00',3.84),('8975','2013-08-01','16:15:00',3.73),('8975','2013-08-01','16:20:00',3.65),('8975','2013-08-01','16:25:00',3.56),('8975','2013-08-01','16:30:00',3.47),('8975','2013-08-01','16:35:00',3.35),('8975','2013-08-01','16:40:00',3.23),('8975','2013-08-01','16:45:00',3.12),('8975','2013-08-01','16:50:00',3),('8975','2013-08-01','16:55:00',2.86),('8975','2013-08-01','17:00:00',2.76),('8975','2013-08-01','17:05:00',2.66),('8975','2013-08-01','17:10:00',2.52),('8975','2013-08-01','17:15:00',2.42),('8975','2013-08-01','17:20:00',2.3),('8975','2013-08-01','17:25:00',2.19),('8975','2013-08-01','17:30:00',2.08),('8975','2013-08-01','17:35:00',1.99),('8975','2013-08-01','17:40:00',1.9),('8975','2013-08-01','17:45:00',1.8),('8975','2013-08-01','17:50:00',1.72),('8975','2013-08-01','17:55:00',1.64),('8975','2013-08-01','18:00:00',1.56),('8975','2013-08-01','18:05:00',1.5),('8975','2013-08-01','18:10:00',1.44),('8975','2013-08-01','18:15:00',1.37),('8975','2013-08-01','18:20:00',1.3),('8975','2013-08-01','18:25:00',1.25),('8975','2013-08-01','18:30:00',1.2),('8975','2013-08-01','18:35:00',1.14),('8975','2013-08-01','18:40:00',1.07),('8975','2013-08-01','18:45:00',1.03),('8975','2013-07-31','07:00:00',1.82),('8975','2013-07-31','07:05:00',1.94),('8975','2013-07-31','07:10:00',2.06),('8975','2013-07-31','07:15:00',2.16),('8975','2013-07-31','07:20:00',2.35),('8975','2013-07-31','07:25:00',2.51),('8975','2013-07-31','07:30:00',2.62),('8975','2013-07-31','07:35:00',2.73),('8975','2013-07-31','07:40:00',2.86),('8975','2013-07-31','07:45:00',2.96),('8975','2013-07-31','07:50:00',3.03),('8975','2013-07-31','07:55:00',3.13),('8975','2013-07-31','08:00:00',3.26),('8975','2013-07-31','08:05:00',3.39),('8975','2013-07-31','08:10:00',3.49),('8975','2013-07-31','08:15:00',3.61),('8975','2013-07-31','08:20:00',3.71),('8975','2013-07-31','08:25:00',3.83),('8975','2013-07-31','08:30:00',3.94),('8975','2013-07-31','08:35:00',4.03),('8975','2013-07-31','08:40:00',4.14),('8975','2013-07-31','08:45:00',4.23),('8975','2013-07-31','08:50:00',4.32),('8975','2013-07-31','08:55:00',4.41),('8975','2013-07-31','09:00:00',4.5),('8975','2013-07-31','09:05:00',4.62),('8975','2013-07-31','09:10:00',4.72),('8975','2013-07-31','09:15:00',4.84),('8975','2013-07-31','09:20:00',4.93),('8975','2013-07-31','09:25:00',5.04),('8975','2013-07-31','09:30:00',5.11),('8975','2013-07-31','09:35:00',5.18),('8975','2013-07-31','09:40:00',5.29),('8975','2013-07-31','09:45:00',5.38),('8975','2013-07-31','09:50:00',5.47),('8975','2013-07-31','09:55:00',5.27),('8975','2013-07-31','10:00:00',5.45),('8975','2013-07-31','10:05:00',4.94),('8975','2013-07-31','10:10:00',5.66),('8975','2013-07-31','10:15:00',5.65),('8975','2013-07-31','10:20:00',5.62),('8975','2013-07-31','10:25:00',5.64),('8975','2013-07-31','10:30:00',5.59),('8975','2013-07-31','10:35:00',4.84),('8975','2013-07-31','10:40:00',5.38),('8975','2013-07-31','10:45:00',5.56),('8975','2013-07-31','10:50:00',5.7),('8975','2013-07-31','10:55:00',6.26),('8975','2013-07-31','11:00:00',6.3),('8975','2013-07-31','11:05:00',6.36),('8975','2013-07-31','11:10:00',6.35),('8975','2013-07-31','11:15:00',6.33),('8975','2013-07-31','11:20:00',6.39),('8975','2013-07-31','11:25:00',6.39),('8975','2013-07-31','11:30:00',6.42),('8975','2013-07-31','11:35:00',6.51),('8975','2013-07-31','11:40:00',6.58),('8975','2013-07-31','11:45:00',6.5),('8975','2013-07-31','11:50:00',6.54),('8975','2013-07-31','11:55:00',6.49),('8975','2013-07-31','12:00:00',6.61),('8975','2013-07-31','12:05:00',6.66),('8975','2013-07-31','12:10:00',6.66),('8975','2013-07-31','12:15:00',6.64),('8975','2013-07-31','12:20:00',6.51),('8975','2013-07-31','12:25:00',6.59),('8975','2013-07-31','12:30:00',6.6),('8975','2013-07-31','12:35:00',6.57),('8975','2013-07-31','12:40:00',6.61),('8975','2013-07-31','12:45:00',6.59),('8975','2013-07-31','12:50:00',6.54),('8975','2013-07-31','12:55:00',6.46),('8975','2013-07-31','13:00:00',6.48),('8975','2013-07-31','13:05:00',6.52),('8975','2013-07-31','13:10:00',6.51),('8975','2013-07-31','13:15:00',6.54),('8975','2013-07-31','13:20:00',6.46),('8975','2013-07-31','13:25:00',6.38),('8975','2013-07-31','13:30:00',6.22),('8975','2013-07-31','13:35:00',6.23),('8975','2013-07-31','13:40:00',6.17),('8975','2013-07-31','13:45:00',6.23),('8975','2013-07-31','13:50:00',5.36),('8975','2013-07-31','13:55:00',6.1),('8975','2013-07-31','14:00:00',5.85),('8975','2013-07-31','14:05:00',5.95),('8975','2013-07-31','14:10:00',5.14),('8975','2013-07-31','14:15:00',4.83),('8975','2013-07-31','14:20:00',5.71),('8975','2013-07-31','14:25:00',5.69),('8975','2013-07-31','14:30:00',5.57),('8975','2013-07-31','14:35:00',5.63),('8975','2013-07-31','14:40:00',5.55),('8975','2013-07-31','14:45:00',5.48),('8975','2013-07-31','14:50:00',5.38),('8975','2013-07-31','14:55:00',5.29),('8975','2013-07-31','15:00:00',5.16),('8975','2013-07-31','15:05:00',5.08),('8975','2013-07-31','15:10:00',4.07),('8975','2013-07-31','15:15:00',5.07),('8975','2013-07-31','15:20:00',5),('8975','2013-07-31','15:25:00',3.8),('8975','2013-07-31','15:30:00',4.78),('8975','2013-07-31','15:35:00',4.72),('8975','2013-07-31','15:40:00',4.91),('8975','2013-07-31','15:45:00',4.41),('8975','2013-07-31','15:50:00',4.34),('8975','2013-07-31','15:55:00',4.08),('8975','2013-07-31','16:00:00',4.19),('8975','2013-07-31','16:05:00',3.92),('8975','2013-07-31','16:10:00',3.92),('8975','2013-07-31','16:15:00',3.72),('8975','2013-07-31','16:20:00',3.72),('8975','2013-07-31','16:25:00',3.62),('8975','2013-07-31','16:30:00',3.52),('8975','2013-07-31','16:35:00',3.39),('8975','2013-07-31','16:40:00',3.27),('8975','2013-07-31','16:45:00',3.16),('8975','2013-07-31','16:50:00',3.04),('8975','2013-07-31','16:55:00',2.9),('8975','2013-07-31','17:00:00',2.78),('8975','2013-07-31','17:05:00',2.64),('8975','2013-07-31','17:10:00',2.54),('8975','2013-07-31','17:15:00',2.43),('8975','2013-07-31','17:20:00',2.32),('8975','2013-07-31','17:25:00',2.21),('8975','2013-07-31','17:30:00',2.11),('8975','2013-07-31','17:35:00',2.01),('8975','2013-07-31','17:40:00',1.91),('8975','2013-07-31','17:45:00',1.81),('8975','2013-07-31','17:50:00',1.72),('8975','2013-07-31','17:55:00',1.63),('8975','2013-07-31','18:00:00',1.56),('8975','2013-07-31','18:05:00',1.49),('8975','2013-07-31','18:10:00',1.42),('8975','2013-07-31','18:15:00',1.35),('8975','2013-07-31','18:20:00',1.3),('8975','2013-07-31','18:25:00',1.26),('8975','2013-07-31','18:30:00',1.22),('8975','2013-07-31','18:35:00',1.17),('8975','2013-07-31','18:40:00',1.12),('8975','2013-07-31','18:45:00',1.08),('8975','2013-07-31','18:50:00',1.02),('8975','2013-07-30','06:45:00',1.36),('8975','2013-07-30','06:50:00',1.49),('8975','2013-07-30','06:55:00',1.64),('8975','2013-07-30','07:00:00',1.79),('8975','2013-07-30','07:05:00',1.85),('8975','2013-07-30','07:10:00',2.06),('8975','2013-07-30','07:15:00',2.17),('8975','2013-07-30','07:20:00',1.99),('8975','2013-07-30','07:25:00',1.36),('8975','2013-07-30','07:35:00',1.46),('8975','2013-07-30','07:40:00',2.48),('8975','2013-07-30','07:45:00',3.09),('8975','2013-07-30','07:50:00',3.19),('8975','2013-07-30','07:55:00',3.3),('8975','2013-07-30','08:00:00',3.42),('8975','2013-07-30','08:05:00',3.51),('8975','2013-07-30','08:10:00',3.61),('8975','2013-07-30','08:15:00',3.71),('8975','2013-07-30','08:20:00',3.82),('8975','2013-07-30','08:25:00',3.92),('8975','2013-07-30','08:30:00',4.02),('8975','2013-07-30','08:35:00',4.11),('8975','2013-07-30','08:40:00',4.21),('8975','2013-07-30','08:45:00',4.3),('8975','2013-07-30','08:50:00',4.4),('8975','2013-07-30','08:55:00',4.48),('8975','2013-07-30','09:00:00',4.6),('8975','2013-07-30','09:05:00',4.7),('8975','2013-07-30','09:10:00',4.81),('8975','2013-07-30','09:15:00',4.9),('8975','2013-07-30','09:20:00',4.99),('8975','2013-07-30','09:25:00',5.06),('8975','2013-07-30','09:30:00',5.13),('8975','2013-07-30','09:35:00',5.25),('8975','2013-07-30','09:40:00',5.34),('8975','2013-07-30','09:45:00',5.39),('8975','2013-07-30','09:50:00',5.46),('8975','2013-07-30','09:55:00',5.54),('8975','2013-07-30','10:00:00',5.62),('8975','2013-07-30','10:05:00',5.7),('8975','2013-07-30','10:10:00',5.73),('8975','2013-07-30','10:15:00',5.82),('8975','2013-07-30','10:20:00',5.92),('8975','2013-07-30','10:25:00',6.01),('8975','2013-07-30','10:30:00',6.06),('8975','2013-07-30','10:35:00',6.12),('8975','2013-07-30','10:40:00',6.15),('8975','2013-07-30','10:45:00',6.2),('8975','2013-07-30','10:50:00',6.3),('8975','2013-07-30','10:55:00',6.34),('8975','2013-07-30','11:00:00',6.4),('8975','2013-07-30','11:05:00',6.42),('8975','2013-07-30','11:10:00',6.43),('8975','2013-07-30','11:15:00',6.47),('8975','2013-07-30','11:20:00',6.5),('8975','2013-07-30','11:25:00',6.49),('8975','2013-07-30','11:30:00',6.55),('8975','2013-07-30','11:35:00',6.57),('8975','2013-07-30','11:40:00',6.61),('8975','2013-07-30','11:45:00',6.65),('8975','2013-07-30','11:50:00',6.67),('8975','2013-07-30','11:55:00',6.65),('8975','2013-07-30','12:00:00',6.68),('8975','2013-07-30','12:05:00',6.69),('8975','2013-07-30','12:10:00',6.68),('8975','2013-07-30','12:15:00',6.73),('8975','2013-07-30','12:20:00',6.71),('8975','2013-07-30','12:25:00',6.72),('8975','2013-07-30','12:30:00',6.69),('8975','2013-07-30','12:35:00',6.65),('8975','2013-07-30','12:40:00',6.61),('8975','2013-07-30','12:45:00',6.69),('8975','2013-07-30','12:50:00',6.86),('8975','2013-07-30','12:55:00',6.69),('8975','2013-07-30','13:00:00',6.85),('8975','2013-07-30','13:05:00',6.85),('8975','2013-07-30','13:10:00',6.67),('8975','2013-07-30','13:15:00',6.56),('8975','2013-07-30','13:20:00',4.1),('8975','2013-07-30','13:25:00',6.57),('8975','2013-07-30','13:30:00',4.31),('8975','2013-07-30','13:35:00',5.57),('8975','2013-07-30','13:40:00',5.91),('8975','2013-07-30','13:45:00',3.29),('8975','2013-07-30','13:50:00',5.19),('8975','2013-07-30','13:55:00',5.16),('8975','2013-07-30','14:00:00',3.58),('8975','2013-07-30','14:05:00',5.55),('8975','2013-07-30','14:10:00',3.57),('8975','2013-07-30','14:15:00',4.32),('8975','2013-07-30','14:20:00',6.36),('8975','2013-07-30','14:25:00',6.26),('8975','2013-07-30','14:30:00',5.9),('8975','2013-07-30','14:35:00',5.75),('8975','2013-07-30','14:40:00',5.77),('8975','2013-07-30','14:45:00',5.72),('8975','2013-07-30','14:50:00',5.2),('8975','2013-07-30','14:55:00',5.07),('8975','2013-07-30','15:00:00',3.17),('8975','2013-07-30','15:05:00',4.06),('8975','2013-07-30','15:10:00',5.38),('8975','2013-07-30','15:15:00',5.28),('8975','2013-07-30','15:20:00',5.26),('8975','2013-07-30','15:25:00',3.13),('8975','2013-07-30','15:30:00',3.28),('8975','2013-07-30','15:35:00',4.86),('8975','2013-07-30','15:40:00',4.83),('8975','2013-07-30','15:45:00',3.24),('8975','2013-07-30','15:50:00',4.42),('8975','2013-07-30','15:55:00',4.32),('8975','2013-07-30','16:00:00',4.21),('8975','2013-07-30','16:05:00',4.25),('8975','2013-07-30','16:10:00',4.22),('8975','2013-07-30','16:15:00',4.01),('8975','2013-07-30','16:20:00',3.93),('8975','2013-07-30','16:25:00',3.97),('8975','2013-07-30','16:30:00',3.81),('8975','2013-07-30','16:35:00',3.54),('8975','2013-07-30','16:40:00',3.39),('8975','2013-07-30','16:45:00',3.01),('8975','2013-07-30','16:50:00',3.01),('8975','2013-07-30','16:55:00',2.96),('8975','2013-07-30','17:00:00',2.85),('8975','2013-07-30','17:05:00',2.73),('8975','2013-07-30','17:10:00',2.63),('8975','2013-07-30','17:15:00',2.57),('8975','2013-07-30','17:20:00',2.4),('8975','2013-07-30','17:25:00',2.26),('8975','2013-07-30','17:30:00',2.11),('8975','2013-07-30','17:35:00',2.01),('8975','2013-07-30','17:40:00',1.91),('8975','2013-07-30','17:45:00',1.81),('8975','2013-07-30','17:50:00',1.76),('8975','2013-07-30','17:55:00',1.68),('8975','2013-07-30','18:00:00',1.61),('8975','2013-07-30','18:05:00',1.52),('8975','2013-07-30','18:10:00',1.45),('8975','2013-07-30','18:15:00',1.36),('8975','2013-07-30','18:20:00',1.31),('8975','2013-07-30','18:25:00',1.27),('8975','2013-07-30','18:30:00',1.23),('8975','2013-07-30','18:35:00',1.21),('8975','2013-07-30','18:40:00',1.16),('8975','2013-07-30','18:45:00',1.1),('8975','2013-07-30','18:50:00',1.06),('8975','2013-07-30','18:55:00',1.01),('8975','2014-04-07','07:45:00',1.15),('8975','2014-04-07','07:50:00',1.92),('8975','2014-04-07','07:55:00',1.82),('8975','2014-04-07','08:00:00',2.52),('8975','2014-04-07','08:05:00',1.62),('8975','2014-04-07','08:10:00',1.53),('8975','2014-04-07','08:15:00',2.15),('8975','2014-04-07','08:20:00',2.94),('8975','2014-04-07','08:25:00',3.35),('8975','2014-04-07','08:30:00',3.33),('8975','2014-04-07','08:35:00',2.92),('8975','2014-04-07','08:40:00',2.81),('8975','2014-04-07','08:45:00',3.39),('8975','2014-04-07','08:50:00',3.35),('8975','2014-04-07','08:55:00',3.65),('8975','2014-04-07','09:00:00',3.74),('8975','2014-04-07','09:05:00',3.84),('8975','2014-04-07','09:10:00',3.96),('8975','2014-04-07','09:15:00',4.03),('8975','2014-04-07','09:20:00',4.14),('8975','2014-04-07','09:25:00',4.26),('8975','2014-04-07','09:30:00',4.32),('8975','2014-04-07','09:35:00',4.4),('8975','2014-04-07','09:40:00',4.4),('8975','2014-04-07','09:45:00',4.47),('8975','2014-04-07','09:50:00',4.58),('8975','2014-04-07','09:55:00',4.63),('8975','2014-04-07','10:00:00',4.64),('8975','2014-04-07','10:05:00',4.65),('8975','2014-04-07','10:10:00',4.81),('8975','2014-04-07','10:15:00',5.09),('8975','2014-04-07','10:20:00',5.12),('8975','2014-04-07','10:25:00',5.2),('8975','2014-04-07','10:30:00',5.32),('8975','2014-04-07','10:35:00',5.43),('8975','2014-04-07','10:40:00',5.47),('8975','2014-04-07','10:45:00',5.5),('8975','2014-04-07','10:50:00',5.51),('8975','2014-04-07','10:55:00',5.62),('8975','2014-04-07','11:00:00',5.63),('8975','2014-04-07','11:05:00',5.73),('8975','2014-04-07','11:10:00',5.71),('8975','2014-04-07','11:15:00',5.41),('8975','2014-04-07','11:20:00',5.62),('8975','2014-04-07','11:25:00',5.51),('8975','2014-04-07','11:30:00',5.84),('8975','2014-04-07','11:35:00',5.47),('8975','2014-04-07','11:40:00',5.83),('8975','2014-04-07','11:45:00',5.81),('8975','2014-04-07','11:50:00',5.8),('8975','2014-04-07','11:55:00',5.77),('8975','2014-04-07','12:00:00',6.01),('8975','2014-04-07','12:05:00',5.81),('8975','2014-04-07','12:10:00',5.65),('8975','2014-04-07','12:15:00',5.22),('8975','2014-04-07','12:20:00',5.3),('8975','2014-04-07','12:25:00',5.43),('8975','2014-04-07','12:30:00',5.88),('8975','2014-04-07','12:35:00',6.3),('8975','2014-04-07','12:40:00',5.11),('8975','2014-04-07','12:45:00',4.09),('8975','2014-04-07','12:50:00',4.84),('8975','2014-04-07','12:55:00',5.82),('8975','2014-04-07','13:00:00',5.77),('8975','2014-04-07','13:05:00',5.85),('8975','2014-04-07','13:10:00',5.92),('8975','2014-04-07','13:15:00',6.04),('8975','2014-04-07','13:20:00',6.02),('8975','2014-04-07','13:25:00',5.98),('8975','2014-04-07','13:30:00',5.98),('8975','2014-04-07','13:35:00',5.93),('8975','2014-04-07','13:40:00',5.89),('8975','2014-04-07','13:45:00',5.81),('8975','2014-04-07','13:50:00',5.73),('8975','2014-04-07','13:55:00',5.72),('8975','2014-04-07','14:00:00',5.65),('8975','2014-04-07','14:05:00',5.56),('8975','2014-04-07','14:10:00',5.55),('8975','2014-04-07','14:15:00',5.49),('8975','2014-04-07','14:20:00',5),('8975','2014-04-07','14:25:00',4.89),('8975','2014-04-07','14:30:00',5.31),('8975','2014-04-07','14:35:00',5.31),('8975','2014-04-07','14:40:00',4.35),('8975','2014-04-07','14:45:00',4.65),('8975','2014-04-07','14:50:00',4.85),('8975','2014-04-07','14:55:00',4.95),('8975','2014-04-07','15:00:00',4.79),('8975','2014-04-07','15:05:00',4.62),('8975','2014-04-07','15:10:00',4.58),('8975','2014-04-07','15:15:00',4.32),('8975','2014-04-07','15:20:00',4.11),('8975','2014-04-07','15:25:00',4.03),('8975','2014-04-07','15:30:00',3.69),('8975','2014-04-07','15:35:00',3.85),('8975','2014-04-07','15:40:00',3.87),('8975','2014-04-07','15:45:00',3.6),('8975','2014-04-07','15:50:00',3.62),('8975','2014-04-07','15:55:00',3.55),('8975','2014-04-07','16:00:00',3.38),('8975','2014-04-07','16:05:00',3.28),('8975','2014-04-07','16:10:00',3.14),('8975','2014-04-07','16:15:00',2.96),('8975','2014-04-07','16:20:00',2.82),('8975','2014-04-07','16:25:00',2.68),('8975','2014-04-07','16:30:00',2.9),('8975','2014-04-07','16:35:00',2.74),('8975','2014-04-07','16:40:00',2.66),('8975','2014-04-07','16:45:00',2.5),('8975','2014-04-07','16:50:00',2.37),('8975','2014-04-07','16:55:00',2.28),('8975','2014-04-07','17:00:00',2.08),('8975','2014-04-07','17:05:00',2.1),('8975','2014-04-07','17:10:00',1.97),('8975','2014-04-07','17:15:00',1.88),('8975','2014-04-07','17:20:00',1.76),('8975','2014-04-07','17:25:00',1.67),('8975','2014-04-07','17:30:00',1.56),('8975','2014-04-07','17:35:00',1.48),('8975','2014-04-07','17:40:00',1.46),('8975','2014-04-07','17:45:00',1.44),('8975','2014-04-07','17:50:00',1.41),('8975','2014-04-07','17:55:00',1.28),('8975','2014-04-07','18:00:00',1.26),('8975','2014-04-07','18:05:00',1.23),('8975','2014-04-07','18:10:00',1.17),('8975','2014-04-07','18:15:00',1.12),('8975','2014-04-07','18:20:00',1.03),('8975','2013-07-29','07:00:00',1.1),('8975','2013-07-29','07:05:00',1.33),('8975','2013-07-29','07:10:00',1.67),('8975','2013-07-29','07:15:00',1.81),('8975','2013-07-29','07:20:00',2.55),('8975','2013-07-29','07:25:00',3.19),('8975','2013-07-29','07:30:00',2.61),('8975','2013-07-29','07:50:00',2.37),('8975','2013-07-29','07:55:00',3.12),('8975','2013-07-29','08:00:00',3.23),('8975','2013-07-29','08:05:00',3.37),('8975','2013-07-29','08:10:00',3.48),('8975','2013-07-29','08:15:00',3.8),('8975','2013-07-29','08:20:00',4.08),('8975','2013-07-29','08:25:00',4.09),('8975','2013-07-29','08:30:00',4.14),('8975','2013-07-29','08:35:00',4.11),('8975','2013-07-29','08:40:00',4.12),('8975','2013-07-29','08:45:00',4.36),('8975','2013-07-29','08:50:00',4.36),('8975','2013-07-29','08:55:00',4.03),('8975','2013-07-29','09:00:00',3.96),('8975','2013-07-29','09:05:00',4.74),('8975','2013-07-29','09:10:00',4.84),('8975','2013-07-29','09:15:00',4.8),('8975','2013-07-29','09:20:00',4.84),('8975','2013-07-29','09:25:00',3.16),('8975','2013-07-29','09:30:00',3.89),('8975','2013-07-29','09:35:00',3.67),('8975','2013-07-29','09:40:00',3.39),('8975','2013-07-29','09:45:00',4.54),('8975','2013-07-29','09:50:00',3.08),('8975','2013-07-29','09:55:00',2.76),('8975','2013-07-29','10:00:00',5.24),('8975','2013-07-29','10:05:00',3.89),('8975','2013-07-29','10:10:00',6.15),('8975','2013-07-29','10:15:00',5.96),('8975','2013-07-29','10:20:00',5.67),('8975','2013-07-29','10:25:00',2.9),('8975','2013-07-29','10:30:00',2.62),('8975','2013-07-29','10:35:00',2.59),('8975','2013-07-29','10:40:00',6.37),('8975','2013-07-29','10:45:00',6.22),('8975','2013-07-29','10:50:00',6.19),('8975','2013-07-29','10:55:00',6.17),('8975','2013-07-29','11:00:00',6.28),('8975','2013-07-29','11:05:00',6.21),('8975','2013-07-29','11:10:00',5.8),('8975','2013-07-29','11:15:00',5.41),('8975','2013-07-29','11:20:00',6.55),('8975','2013-07-29','11:25:00',6.61),('8975','2013-07-29','11:30:00',6.57),('8975','2013-07-29','11:35:00',6.52),('8975','2013-07-29','11:40:00',6.46),('8975','2013-07-29','11:45:00',6.49),('8975','2013-07-29','11:50:00',5.01),('8975','2013-07-29','11:55:00',5.75),('8975','2013-07-29','12:00:00',6.27),('8975','2013-07-29','12:05:00',5.82),('8975','2013-07-29','12:10:00',6.34),('8975','2013-07-29','12:15:00',5.63),('8975','2013-07-29','12:20:00',5.78),('8975','2013-07-29','12:25:00',5.74),('8975','2013-07-29','12:30:00',6.18),('8975','2013-07-29','12:35:00',6.34),('8975','2013-07-29','12:40:00',6.56),('8975','2013-07-29','12:45:00',6.6),('8975','2013-07-29','12:50:00',6.57),('8975','2013-07-29','12:55:00',6.47),('8975','2013-07-29','13:00:00',4.13),('8975','2013-07-29','13:05:00',5.53),('8975','2013-07-29','13:10:00',3.8),('8975','2013-07-29','13:15:00',3.64),('8975','2013-07-29','13:20:00',6.7),('8975','2013-07-29','13:25:00',6.37),('8975','2013-07-29','13:30:00',6.33),('8975','2013-07-29','13:35:00',6.36),('8975','2013-07-29','13:40:00',6.35),('8975','2013-07-29','13:45:00',6.27),('8975','2013-07-29','13:50:00',6.16),('8975','2013-07-29','13:55:00',5.78),('8975','2013-07-29','14:00:00',6.26),('8975','2013-07-29','14:05:00',6.23),('8975','2013-07-29','14:10:00',6.11),('8975','2013-07-29','14:15:00',5.45),('8975','2013-07-29','14:20:00',6.01),('8975','2013-07-29','14:25:00',5.89),('8975','2013-07-29','14:30:00',5.81),('8975','2013-07-29','14:35:00',5.69),('8975','2013-07-29','14:40:00',5.44),('8975','2013-07-29','14:45:00',5.45),('8975','2013-07-29','14:50:00',5.28),('8975','2013-07-29','14:55:00',5.24),('8975','2013-07-29','15:00:00',5.23),('8975','2013-07-29','15:05:00',5.16),('8975','2013-07-29','15:10:00',5.03),('8975','2013-07-29','15:15:00',4.86),('8975','2013-07-29','15:20:00',4.88),('8975','2013-07-29','15:25:00',4.73),('8975','2013-07-29','15:30:00',4.61),('8975','2013-07-29','15:35:00',4.58),('8975','2013-07-29','15:40:00',4.49),('8975','2013-07-29','15:45:00',4.41),('8975','2013-07-29','15:50:00',4.33),('8975','2013-07-29','15:55:00',4.22),('8975','2013-07-29','16:00:00',4.08),('8975','2013-07-29','16:05:00',4),('8975','2013-07-29','16:10:00',3.88),('8975','2013-07-29','16:15:00',3.8),('8975','2013-07-29','16:20:00',3.72),('8975','2013-07-29','16:25:00',3.61),('8975','2013-07-29','16:30:00',3.49),('8975','2013-07-29','16:35:00',3.38),('8975','2013-07-29','16:40:00',3.29),('8975','2013-07-29','16:45:00',3.17),('8975','2013-07-29','16:50:00',3.07),('8975','2013-07-29','16:55:00',2.95),('8975','2013-07-29','17:00:00',2.82),('8975','2013-07-29','17:05:00',2.71),('8975','2013-07-29','17:10:00',2.6),('8975','2013-07-29','17:15:00',2.48),('8975','2013-07-29','17:20:00',2.36),('8975','2013-07-29','17:25:00',2.26),('8975','2013-07-29','17:30:00',2.15),('8975','2013-07-29','17:35:00',2.07),('8975','2013-07-29','17:40:00',1.98),('8975','2013-07-29','17:45:00',1.88),('8975','2013-07-29','17:50:00',1.8),('8975','2013-07-29','17:55:00',1.72),('8975','2013-07-29','18:00:00',1.62),('8975','2013-07-29','18:05:00',1.53),('8975','2013-07-29','18:10:00',1.45),('8975','2013-07-29','18:15:00',1.41),('8975','2013-07-29','18:20:00',1.34),('8975','2013-07-29','18:25:00',1.28),('8975','2013-07-29','18:30:00',1.22),('8975','2013-07-29','18:35:00',1.14),('8975','2013-07-29','18:40:00',1.1),('8975','2013-07-29','18:45:00',1.05),('8975','2013-07-29','18:50:00',1.01),('8975','2013-07-28','06:55:00',1.12),('8975','2013-07-28','07:00:00',1.26),('8975','2013-07-28','07:05:00',1.38),('8975','2013-07-28','07:10:00',1.47),('8975','2013-07-28','07:15:00',1.62),('8975','2013-07-28','07:20:00',1.79),('8975','2013-07-28','07:25:00',1.93),('8975','2013-07-28','07:30:00',2.1),('8975','2013-07-28','07:35:00',2.26),('8975','2013-07-28','07:40:00',2.38),('8975','2013-07-28','07:45:00',2.49),('8975','2013-07-28','07:50:00',2.6),('8975','2013-07-28','07:55:00',2.72),('8975','2013-07-28','08:00:00',2.86),('8975','2013-07-28','08:05:00',2.96),('8975','2013-07-28','08:10:00',3.09),('8975','2013-07-28','08:15:00',3.19),('8975','2013-07-28','08:20:00',3.25),('8975','2013-07-28','08:25:00',3.38),('8975','2013-07-28','08:30:00',3.47),('8975','2013-07-28','08:35:00',3.54),('8975','2013-07-28','08:40:00',3.63),('8975','2013-07-28','08:45:00',3.76),('8975','2013-07-28','08:50:00',3.74),('8975','2013-07-28','08:55:00',3.52),('8975','2013-07-28','09:00:00',3.82),('8975','2013-07-28','09:05:00',3.1),('8975','2013-07-28','09:10:00',3.9),('8975','2013-07-28','09:15:00',3.85),('8975','2013-07-28','09:20:00',4.31),('8975','2013-07-28','09:25:00',4.29),('8975','2013-07-28','09:30:00',4.32),('8975','2013-07-28','09:35:00',4.25),('8975','2013-07-28','09:40:00',4.48),('8975','2013-07-28','09:45:00',4.76),('8975','2013-07-28','09:50:00',4.98),('8975','2013-07-28','09:55:00',5.05),('8975','2013-07-28','10:00:00',5.16),('8975','2013-07-28','10:05:00',5.19),('8975','2013-07-28','10:10:00',5.25),('8975','2013-07-28','10:15:00',5.33),('8975','2013-07-28','10:20:00',5.36),('8975','2013-07-28','10:25:00',5.37),('8975','2013-07-28','10:30:00',5.51),('8975','2013-07-28','10:35:00',5.56),('8975','2013-07-28','10:40:00',5.66),('8975','2013-07-28','10:45:00',5.65),('8975','2013-07-28','10:50:00',5.68),('8975','2013-07-28','10:55:00',5.73),('8975','2013-07-28','11:00:00',5.77),('8975','2013-07-28','11:05:00',5.8),('8975','2013-07-28','11:10:00',5.82),('8975','2013-07-28','11:15:00',5.84),('8975','2013-07-28','11:20:00',5.84),('8975','2013-07-28','11:25:00',5.86),('8975','2013-07-28','11:30:00',5.88),('8975','2013-07-28','11:35:00',5.9),('8975','2013-07-28','11:40:00',5.92),('8975','2013-07-28','11:45:00',5.9),('8975','2013-07-28','11:50:00',5.9),('8975','2013-07-28','11:55:00',5.95),('8975','2013-07-28','12:00:00',5.91),('8975','2013-07-28','12:05:00',5.88),('8975','2013-07-28','12:10:00',5.92),('8975','2013-07-28','12:15:00',5.89),('8975','2013-07-28','12:20:00',5.92),('8975','2013-07-28','12:25:00',5.97),('8975','2013-07-28','12:30:00',6.02),('8975','2013-07-28','12:35:00',5.95),('8975','2013-07-28','12:40:00',5.79),('8975','2013-07-28','12:45:00',5.74),('8975','2013-07-28','12:50:00',5.76),('8975','2013-07-28','12:55:00',5.77),('8975','2013-07-28','13:00:00',5.7),('8975','2013-07-28','13:05:00',5.85),('8975','2013-07-28','13:10:00',5.88),('8975','2013-07-28','13:15:00',5.89),('8975','2013-07-28','13:20:00',5.89),('8975','2013-07-28','13:25:00',5.92),('8975','2013-07-28','13:30:00',5.92),('8975','2013-07-28','13:35:00',5.97),('8975','2013-07-28','13:40:00',5.96),('8975','2013-07-28','13:45:00',5.94),('8975','2013-07-28','13:50:00',5.94),('8975','2013-07-28','13:55:00',5.87),('8975','2013-07-28','14:00:00',5.84),('8975','2013-07-28','14:05:00',5.76),('8975','2013-07-28','14:10:00',5.75),('8975','2013-07-28','14:15:00',5.67),('8975','2013-07-28','14:20:00',5.64),('8975','2013-07-28','14:25:00',5.58),('8975','2013-07-28','14:30:00',5.53),('8975','2013-07-28','14:35:00',5.47),('8975','2013-07-28','14:40:00',5.36),('8975','2013-07-28','14:45:00',5.33),('8975','2013-07-28','14:50:00',5.29),('8975','2013-07-28','14:55:00',5.22),('8975','2013-07-28','15:00:00',5.12),('8975','2013-07-28','15:05:00',5.06),('8975','2013-07-28','15:10:00',4.96),('8975','2013-07-28','15:15:00',4.91),('8975','2013-07-28','15:20:00',4.81),('8975','2013-07-28','15:25:00',4.75),('8975','2013-07-28','15:30:00',4.67),('8975','2013-07-28','15:35:00',4.61),('8975','2013-07-28','15:40:00',4.59),('8975','2013-07-28','15:45:00',4.58),('8975','2013-07-28','15:50:00',3.84),('8975','2013-07-28','15:55:00',2.93),('8975','2013-07-28','16:00:00',2.54),('8975','2013-07-28','16:05:00',3.43),('8975','2013-07-28','16:10:00',3.42),('8975','2013-07-28','16:15:00',3.75),('8975','2013-07-28','16:20:00',3.25),('8975','2013-07-28','16:25:00',3.87),('8975','2013-07-28','16:30:00',3.65),('8975','2013-07-28','16:35:00',2.6),('8975','2013-07-28','16:40:00',3.27),('8975','2013-07-28','16:45:00',3.66),('8975','2013-07-28','16:50:00',3.3),('8975','2013-07-28','16:55:00',1.94),('8975','2013-07-28','17:00:00',1.92),('8975','2013-07-28','17:05:00',2.2),('8975','2013-07-28','17:10:00',1.38),('8975','2013-07-28','17:15:00',1.62),('8975','2013-07-28','17:20:00',2.74),('8975','2013-07-28','17:25:00',2.39),('8975','2013-07-28','17:30:00',1.58),('8975','2013-07-28','17:35:00',1.53),('8975','2013-07-28','17:40:00',1.51),('8975','2013-07-28','17:45:00',2.14),('8975','2013-07-28','17:50:00',1.91),('8975','2013-07-28','17:55:00',1.72),('8975','2013-07-28','18:00:00',1.26),('8975','2013-07-28','18:10:00',1.5),('8975','2013-07-28','18:15:00',1.32),('8975','2013-07-28','18:20:00',1.49),('8975','2013-07-28','18:25:00',1.47),('8975','2013-07-28','18:30:00',1.38),('8975','2013-07-28','18:35:00',1.21),('8975','2013-07-28','19:00:00',1.07),('8975','2013-07-28','19:05:00',1.1),('8975','2013-07-27','06:55:00',1.11),('8975','2013-07-27','07:00:00',1.28),('8975','2013-07-27','07:05:00',1.43),('8975','2013-07-27','07:10:00',1.56),('8975','2013-07-27','07:15:00',1.69),('8975','2013-07-27','07:20:00',1.86),('8975','2013-07-27','07:25:00',1.99),('8975','2013-07-27','07:30:00',2.11),('8975','2013-07-27','07:35:00',2.24),('8975','2013-07-27','07:40:00',2.35),('8975','2013-07-27','07:45:00',2.47),('8975','2013-07-27','07:50:00',2.58),('8975','2013-07-27','07:55:00',2.7),('8975','2013-07-27','08:00:00',2.81),('8975','2013-07-27','08:05:00',2.91),('8975','2013-07-27','08:10:00',3.05),('8975','2013-07-27','08:15:00',3.2),('8975','2013-07-27','08:20:00',3.3),('8975','2013-07-27','08:25:00',3.4),('8975','2013-07-27','08:30:00',3.51),('8975','2013-07-27','08:35:00',3.61),('8975','2013-07-27','08:40:00',3.7),('8975','2013-07-27','08:45:00',3.83),('8975','2013-07-27','08:50:00',3.95),('8975','2013-07-27','08:55:00',4.03),('8975','2013-07-27','09:00:00',4.15),('8975','2013-07-27','09:05:00',4.22),('8975','2013-07-27','09:10:00',4.35),('8975','2013-07-27','09:15:00',4.38),('8975','2013-07-27','09:20:00',4.48),('8975','2013-07-27','09:25:00',4.51),('8975','2013-07-27','09:30:00',4.64),('8975','2013-07-27','09:35:00',4.77),('8975','2013-07-27','09:40:00',4.86),('8975','2013-07-27','09:45:00',4.94),('8975','2013-07-27','09:50:00',4.98),('8975','2013-07-27','09:55:00',5.04),('8975','2013-07-27','10:00:00',5.13),('8975','2013-07-27','10:05:00',5.13),('8975','2013-07-27','10:10:00',5.25),('8975','2013-07-27','10:15:00',5.3),('8975','2013-07-27','10:20:00',5.34),('8975','2013-07-27','10:25:00',5.36),('8975','2013-07-27','10:30:00',5.44),('8975','2013-07-27','10:35:00',5.55),('8975','2013-07-27','10:40:00',5.62),('8975','2013-07-27','10:45:00',5.7),('8975','2013-07-27','10:50:00',5.72),('8975','2013-07-27','10:55:00',5.74),('8975','2013-07-27','11:00:00',5.76),('8975','2013-07-27','11:05:00',5.81),('8975','2013-07-27','11:10:00',5.75),('8975','2013-07-27','11:15:00',5.84),('8975','2013-07-27','11:20:00',5.78),('8975','2013-07-27','11:25:00',5.88),('8975','2013-07-27','11:30:00',5.83),('8975','2013-07-27','11:35:00',5.82),('8975','2013-07-27','11:40:00',5.94),('8975','2013-07-27','11:45:00',5.92),('8975','2013-07-27','11:50:00',5.94),('8975','2013-07-27','11:55:00',5.89),('8975','2013-07-27','12:00:00',5.88),('8975','2013-07-27','12:05:00',5.87),('8975','2013-07-27','12:10:00',5.87),('8975','2013-07-27','12:15:00',5.93),('8975','2013-07-27','12:20:00',6.04),('8975','2013-07-27','12:25:00',6.07),('8975','2013-07-27','12:30:00',6.04),('8975','2013-07-27','12:35:00',5.97),('8975','2013-07-27','12:40:00',6.05),('8975','2013-07-27','12:45:00',6.14),('8975','2013-07-27','12:50:00',6.14),('8975','2013-07-27','12:55:00',5.98),('8975','2013-07-27','13:00:00',5.2),('8975','2013-07-27','13:05:00',3.33),('8975','2013-07-27','13:10:00',5.27),('8975','2013-07-27','13:15:00',5.85),('8975','2013-07-27','13:20:00',6.05),('8975','2013-07-27','13:25:00',5.23),('8975','2013-07-27','13:30:00',5.47),('8975','2013-07-27','13:35:00',5.46),('8975','2013-07-27','13:40:00',5.58),('8975','2013-07-27','13:45:00',5.95),('8975','2013-07-27','13:50:00',5.9),('8975','2013-07-27','13:55:00',5.76),('8975','2013-07-27','14:00:00',5.74),('8975','2013-07-27','14:05:00',5.68),('8975','2013-07-27','14:10:00',5.63),('8975','2013-07-27','14:15:00',5.61),('8975','2013-07-27','14:20:00',5.52),('8975','2013-07-27','14:25:00',5.48),('8975','2013-07-27','14:30:00',5.43),('8975','2013-07-27','14:35:00',5.39),('8975','2013-07-27','14:40:00',5.37),('8975','2013-07-27','14:45:00',5.26),('8975','2013-07-27','14:50:00',5.17),('8975','2013-07-27','14:55:00',5.11),('8975','2013-07-27','15:00:00',5.04),('8975','2013-07-27','15:05:00',5),('8975','2013-07-27','15:10:00',4.94),('8975','2013-07-27','15:15:00',4.83),('8975','2013-07-27','15:20:00',4.72),('8975','2013-07-27','15:25:00',4.63),('8975','2013-07-27','15:30:00',4.58),('8975','2013-07-27','15:35:00',4.52),('8975','2013-07-27','15:40:00',4.42),('8975','2013-07-27','15:45:00',4.32),('8975','2013-07-27','15:50:00',4.25),('8975','2013-07-27','15:55:00',4.15),('8975','2013-07-27','16:00:00',4.08),('8975','2013-07-27','16:05:00',3.96),('8975','2013-07-27','16:10:00',3.87),('8975','2013-07-27','16:15:00',3.82),('8975','2013-07-27','16:20:00',3.74),('8975','2013-07-27','16:25:00',3.64),('8975','2013-07-27','16:30:00',3.52),('8975','2013-07-27','16:35:00',3.41),('8975','2013-07-27','16:40:00',3.32),('8975','2013-07-27','16:45:00',3.21),('8975','2013-07-27','16:50:00',3.11),('8975','2013-07-27','16:55:00',2.97),('8975','2013-07-27','17:00:00',2.84),('8975','2013-07-27','17:05:00',2.74),('8975','2013-07-27','17:10:00',2.63),('8975','2013-07-27','17:15:00',2.52),('8975','2013-07-27','17:20:00',2.42),('8975','2013-07-27','17:25:00',2.31),('8975','2013-07-27','17:30:00',2.21),('8975','2013-07-27','17:35:00',2.11),('8975','2013-07-27','17:40:00',2.01),('8975','2013-07-27','17:45:00',1.91),('8975','2013-07-27','17:50:00',1.82),('8975','2013-07-27','17:55:00',1.72),('8975','2013-07-27','18:00:00',1.63),('8975','2013-07-27','18:05:00',1.56),('8975','2013-07-27','18:10:00',1.48),('8975','2013-07-27','18:15:00',1.43),('8975','2013-07-27','18:20:00',1.37),('8975','2013-07-27','18:25:00',1.31),('8975','2013-07-27','18:30:00',1.25),('8975','2013-07-27','18:35:00',1.2),('8975','2013-07-27','18:40:00',1.13),('8975','2013-07-27','18:45:00',1.06),('8975','2013-07-27','18:50:00',1.03),('8975','2013-07-26','06:50:00',1.02),('8975','2013-07-26','06:55:00',1.16),('8975','2013-07-26','07:00:00',1.29),('8975','2013-07-26','07:05:00',1.41),('8975','2013-07-26','07:10:00',1.52),('8975','2013-07-26','07:15:00',1.68),('8975','2013-07-26','07:20:00',1.81),('8975','2013-07-26','07:25:00',1.94),('8975','2013-07-26','07:30:00',2.08),('8975','2013-07-26','07:35:00',2.21),('8975','2013-07-26','07:40:00',2.34),('8975','2013-07-26','07:45:00',2.48),('8975','2013-07-26','07:50:00',2.63),('8975','2013-07-26','07:55:00',2.77),('8975','2013-07-26','08:00:00',2.9),('8975','2013-07-26','08:05:00',3),('8975','2013-07-26','08:10:00',3.12),('8975','2013-07-26','08:15:00',3.21),('8975','2013-07-26','08:20:00',3.32),('8975','2013-07-26','08:25:00',3.42),('8975','2013-07-26','08:30:00',3.56),('8975','2013-07-26','08:35:00',3.68),('8975','2013-07-26','08:40:00',3.81),('8975','2013-07-26','08:45:00',3.93),('8975','2013-07-26','08:50:00',4.03),('8975','2013-07-26','08:55:00',4.09),('8975','2013-07-26','09:00:00',4.15),('8975','2013-07-26','09:05:00',4.27),('8975','2013-07-26','09:10:00',4.4),('8975','2013-07-26','09:15:00',4.49),('8975','2013-07-26','09:20:00',4.56),('8975','2013-07-26','09:25:00',4.64),('8975','2013-07-26','09:30:00',4.7),('8975','2013-07-26','09:35:00',4.79),('8975','2013-07-26','09:40:00',4.91),('8975','2013-07-26','09:45:00',4.99),('8975','2013-07-26','09:50:00',5.08),('8975','2013-07-26','09:55:00',5.16),('8975','2013-07-26','10:00:00',5.26),('8975','2013-07-26','10:05:00',5.32),('8975','2013-07-26','10:10:00',5.4),('8975','2013-07-26','10:15:00',5.45),('8975','2013-07-26','10:20:00',5.46),('8975','2013-07-26','10:25:00',5.49),('8975','2013-07-26','10:30:00',5.6),('8975','2013-07-26','10:35:00',5.63),('8975','2013-07-26','10:40:00',5.64),('8975','2013-07-26','10:45:00',5.64),('8975','2013-07-26','10:50:00',5.67),('8975','2013-07-26','10:55:00',5.75),('8975','2013-07-26','11:00:00',5.81),('8975','2013-07-26','11:05:00',5.84),('8975','2013-07-26','11:10:00',5.92),('8975','2013-07-26','11:15:00',5.92),('8975','2013-07-26','11:20:00',5.96),('8975','2013-07-26','11:25:00',6),('8975','2013-07-26','11:30:00',6.01),('8975','2013-07-26','11:35:00',6.01),('8975','2013-07-26','11:40:00',5.98),('8975','2013-07-26','11:45:00',6.03),('8975','2013-07-26','11:50:00',6.13),('8975','2013-07-26','11:55:00',6.15),('8975','2013-07-26','12:00:00',6.19),('8975','2013-07-26','12:05:00',6.05),('8975','2013-07-26','12:10:00',6.03),('8975','2013-07-26','12:15:00',6.2),('8975','2013-07-26','12:20:00',6.19),('8975','2013-07-26','12:25:00',6.19),('8975','2013-07-26','12:30:00',6.2),('8975','2013-07-26','12:35:00',6.19),('8975','2013-07-26','12:40:00',5.99),('8975','2013-07-26','12:45:00',6.04),('8975','2013-07-26','12:50:00',5.88),('8975','2013-07-26','12:55:00',6.03),('8975','2013-07-26','13:00:00',6.1),('8975','2013-07-26','13:05:00',6),('8975','2013-07-26','13:10:00',4.39),('8975','2013-07-26','13:15:00',6.19),('8975','2013-07-26','13:20:00',6.46),('8975','2013-07-26','13:25:00',6.24),('8975','2013-07-26','13:30:00',6.25),('8975','2013-07-26','13:35:00',6.18),('8975','2013-07-26','13:40:00',6.25),('8975','2013-07-26','13:45:00',6.03),('8975','2013-07-26','13:50:00',6.01),('8975','2013-07-26','13:55:00',6.02),('8975','2013-07-26','14:00:00',5.91),('8975','2013-07-26','14:05:00',5.83),('8975','2013-07-26','14:10:00',5.8),('8975','2013-07-26','14:15:00',5.67),('8975','2013-07-26','14:20:00',5.63),('8975','2013-07-26','14:25:00',5.67),('8975','2013-07-26','14:30:00',5.49),('8975','2013-07-26','14:35:00',5.4),('8975','2013-07-26','14:40:00',5.41),('8975','2013-07-26','14:45:00',5.37),('8975','2013-07-26','14:50:00',5.27),('8975','2013-07-26','14:55:00',5.2),('8975','2013-07-26','15:00:00',5.12),('8975','2013-07-26','15:05:00',5.04),('8975','2013-07-26','15:10:00',4.96),('8975','2013-07-26','15:15:00',4.92),('8975','2013-07-26','15:20:00',4.84),('8975','2013-07-26','15:25:00',4.77),('8975','2013-07-26','15:30:00',4.7),('8975','2013-07-26','15:35:00',4.62),('8975','2013-07-26','15:40:00',4.54),('8975','2013-07-26','15:45:00',4.43),('8975','2013-07-26','15:50:00',4.35),('8975','2013-07-26','15:55:00',4.24),('8975','2013-07-26','16:00:00',4.17),('8975','2013-07-26','16:05:00',4.07),('8975','2013-07-26','16:10:00',3.98),('8975','2013-07-26','16:15:00',3.87),('8975','2013-07-26','16:20:00',3.79),('8975','2013-07-26','16:25:00',3.67),('8975','2013-07-26','16:30:00',3.3),('8975','2013-07-26','16:35:00',3.06),('8975','2013-07-26','16:40:00',2.93),('8975','2013-07-26','16:45:00',3.17),('8975','2013-07-26','16:50:00',3),('8975','2013-07-26','16:55:00',2.97),('8975','2013-07-26','17:00:00',2.53),('8975','2013-07-26','17:05:00',2.53),('8975','2013-07-26','17:10:00',2.51),('8975','2013-07-26','17:15:00',2.37),('8975','2013-07-26','17:20:00',2.43),('8975','2013-07-26','17:25:00',2.31),('8975','2013-07-26','17:30:00',2.2),('8975','2013-07-26','17:35:00',2.1),('8975','2013-07-26','17:40:00',2.01),('8975','2013-07-26','17:45:00',1.93),('8975','2013-07-26','17:50:00',1.84),('8975','2013-07-26','17:55:00',1.75),('8975','2013-07-26','18:00:00',1.66),('8975','2013-07-26','18:05:00',1.56),('8975','2013-07-26','18:10:00',1.53),('8975','2013-07-26','18:15:00',1.47),('8975','2013-07-26','18:20:00',1.4),('8975','2013-07-26','18:25:00',1.33),('8975','2013-07-26','18:30:00',1.28),('8975','2013-07-26','18:35:00',1.24),('8975','2013-07-26','18:40:00',1.17),('8975','2013-07-26','18:45:00',1.11),('8975','2013-07-26','18:50:00',1.06),('8975','2013-07-26','18:55:00',1.02),('8975','2013-07-25','06:55:00',1.09),('8975','2013-07-25','07:00:00',1.25),('8975','2013-07-25','07:05:00',1.38),('8975','2013-07-25','07:10:00',1.51),('8975','2013-07-25','07:15:00',1.67),('8975','2013-07-25','07:20:00',1.79),('8975','2013-07-25','07:25:00',1.91),('8975','2013-07-25','07:30:00',2.04),('8975','2013-07-25','07:35:00',2.18),('8975','2013-07-25','07:40:00',2.32),('8975','2013-07-25','07:45:00',2.42),('8975','2013-07-25','07:50:00',2.49),('8975','2013-07-25','07:55:00',2.67),('8975','2013-07-25','08:00:00',2.78),('8975','2013-07-25','08:05:00',2.87),('8975','2013-07-25','08:10:00',2.94),('8975','2013-07-25','08:15:00',3.09),('8975','2013-07-25','08:20:00',3.21),('8975','2013-07-25','08:25:00',3.38),('8975','2013-07-25','08:30:00',3.43),('8975','2013-07-25','08:35:00',3.47),('8975','2013-07-25','08:40:00',3.73),('8975','2013-07-25','08:45:00',3.73),('8975','2013-07-25','08:50:00',3.93),('8975','2013-07-25','08:55:00',4.02),('8975','2013-07-25','09:00:00',4.09),('8975','2013-07-25','09:05:00',4.11),('8975','2013-07-25','09:10:00',4.33),('8975','2013-07-25','09:15:00',4.45),('8975','2013-07-25','09:20:00',4.54),('8975','2013-07-25','09:25:00',4.64),('8975','2013-07-25','09:30:00',4.72),('8975','2013-07-25','09:35:00',4.79),('8975','2013-07-25','09:40:00',4.9),('8975','2013-07-25','09:45:00',5),('8975','2013-07-25','09:50:00',5.07),('8975','2013-07-25','09:55:00',5.1),('8975','2013-07-25','10:00:00',5.13),('8975','2013-07-25','10:05:00',5.14),('8975','2013-07-25','10:10:00',5.24),('8975','2013-07-25','10:15:00',5.35),('8975','2013-07-25','10:20:00',5.45),('8975','2013-07-25','10:25:00',5.51),('8975','2013-07-25','10:30:00',5.49),('8975','2013-07-25','10:35:00',5.55),('8975','2013-07-25','10:40:00',5.54),('8975','2013-07-25','10:45:00',5.71),('8975','2013-07-25','10:50:00',5.72),('8975','2013-07-25','10:55:00',5.75),('8975','2013-07-25','11:00:00',5.74),('8975','2013-07-25','11:05:00',5.85),('8975','2013-07-25','11:10:00',6.02),('8975','2013-07-25','11:15:00',6.04),('8975','2013-07-25','11:20:00',6.19),('8975','2013-07-25','11:25:00',5.75),('8975','2013-07-25','11:30:00',6.07),('8975','2013-07-25','11:35:00',6.17),('8975','2013-07-25','11:40:00',6.09),('8975','2013-07-25','11:45:00',5.94),('8975','2013-07-25','11:50:00',3.79),('8975','2013-07-25','11:55:00',5.96),('8975','2013-07-25','12:00:00',6.34),('8975','2013-07-25','12:05:00',3.68),('8975','2013-07-25','12:10:00',5.8),('8975','2013-07-25','12:15:00',5.8),('8975','2013-07-25','12:20:00',3.8),('8975','2013-07-25','12:25:00',2.25),('8975','2013-07-25','12:30:00',3.94),('8975','2013-07-25','12:35:00',5.86),('8975','2013-07-25','12:40:00',4.15),('8975','2013-07-25','12:45:00',2.55),('8975','2013-07-25','12:50:00',5.14),('8975','2013-07-25','12:55:00',3.31),('8975','2013-07-25','13:00:00',6.95),('8975','2013-07-25','13:05:00',6.52),('8975','2013-07-25','13:10:00',6.86),('8975','2013-07-25','13:15:00',5.53),('8975','2013-07-25','13:20:00',4.87),('8975','2013-07-25','13:25:00',4.31),('8975','2013-07-25','13:30:00',2.36),('8975','2013-07-25','13:35:00',3.52),('8975','2013-07-25','13:40:00',6.34),('8975','2013-07-25','13:45:00',6.45),('8975','2013-07-25','13:50:00',6.51),('8975','2013-07-25','13:55:00',6.24),('8975','2013-07-25','14:00:00',6.21),('8975','2013-07-25','14:05:00',6.29),('8975','2013-07-25','14:10:00',6.41),('8975','2013-07-25','14:15:00',5.56),('8975','2013-07-25','14:20:00',6.07),('8975','2013-07-25','14:25:00',5.83),('8975','2013-07-25','14:30:00',5.66),('8975','2013-07-25','14:35:00',5.66),('8975','2013-07-25','14:40:00',5.47),('8975','2013-07-25','14:45:00',5.51),('8975','2013-07-25','14:50:00',5.4),('8975','2013-07-25','14:55:00',5.26),('8975','2013-07-25','15:00:00',5.21),('8975','2013-07-25','15:05:00',5.13),('8975','2013-07-25','15:10:00',5.09),('8975','2013-07-25','15:15:00',5.01),('8975','2013-07-25','15:20:00',4.91),('8975','2013-07-25','15:25:00',4.85),('8975','2013-07-25','15:30:00',4.74),('8975','2013-07-25','15:35:00',4.62),('8975','2013-07-25','15:40:00',4.52),('8975','2013-07-25','15:45:00',4.47),('8975','2013-07-25','15:50:00',4.37),('8975','2013-07-25','15:55:00',4.3),('8975','2013-07-25','16:00:00',4.2),('8975','2013-07-25','16:05:00',4.06),('8975','2013-07-25','16:10:00',3.98),('8975','2013-07-25','16:15:00',3.88),('8975','2013-07-25','16:20:00',3.78),('8975','2013-07-25','16:25:00',3.69),('8975','2013-07-25','16:30:00',3.59),('8975','2013-07-25','16:35:00',3.49),('8975','2013-07-25','16:40:00',3.39),('8975','2013-07-25','16:45:00',3.27),('8975','2013-07-25','16:50:00',3.17),('8975','2013-07-25','16:55:00',3.04),('8975','2013-07-25','17:00:00',2.96),('8975','2013-07-25','17:05:00',2.83),('8975','2013-07-25','17:10:00',2.7),('8975','2013-07-25','17:15:00',2.58),('8975','2013-07-25','17:20:00',2.45),('8975','2013-07-25','17:25:00',2.36),('8975','2013-07-25','17:30:00',2.28),('8975','2013-07-25','17:35:00',2.13),('8975','2013-07-25','17:40:00',2.03),('8975','2013-07-25','17:45:00',1.94),('8975','2013-07-25','17:50:00',1.84),('8975','2013-07-25','17:55:00',1.73),('8975','2013-07-25','18:00:00',1.64),('8975','2013-07-25','18:05:00',1.58),('8975','2013-07-25','18:10:00',1.5),('8975','2013-07-25','18:15:00',1.45),('8975','2013-07-25','18:20:00',1.39),('8975','2013-07-25','18:25:00',1.31),('8975','2013-07-25','18:30:00',1.25),('8975','2013-07-25','18:35:00',1.2),('8975','2013-07-25','18:40:00',1.14),('8975','2013-07-25','18:45:00',1.11),('8975','2013-07-25','18:50:00',1.05),('8975','2013-07-24','06:55:00',1.03),('8975','2013-07-24','07:00:00',1.13),('8975','2013-07-24','07:05:00',1.31),('8975','2013-07-24','07:10:00',1.39),('8975','2013-07-24','07:15:00',1.56),('8975','2013-07-24','07:20:00',1.67),('8975','2013-07-24','07:25:00',1.84),('8975','2013-07-24','07:30:00',2.01),('8975','2013-07-24','07:35:00',2.16),('8975','2013-07-24','07:40:00',2.3),('8975','2013-07-24','07:45:00',2.44),('8975','2013-07-24','07:50:00',2.58),('8975','2013-07-24','07:55:00',2.69),('8975','2013-07-24','08:00:00',2.83),('8975','2013-07-24','08:05:00',2.96),('8975','2013-07-24','08:10:00',3.11),('8975','2013-07-24','08:15:00',3.21),('8975','2013-07-24','08:20:00',3.25),('8975','2013-07-24','08:25:00',3.43),('8975','2013-07-24','08:30:00',3.46),('8975','2013-07-24','08:35:00',3.56),('8975','2013-07-24','08:40:00',3.66),('8975','2013-07-24','08:45:00',3.82),('8975','2013-07-24','08:50:00',3.97),('8975','2013-07-24','08:55:00',4.03),('8975','2013-07-24','09:00:00',4.45),('8975','2013-07-24','09:05:00',3.62),('8975','2013-07-24','09:10:00',4.07),('8975','2013-07-24','09:15:00',2.85),('8975','2013-07-24','09:20:00',3.77),('8975','2013-07-24','09:25:00',1.48),('8975','2013-07-24','09:30:00',2.66),('8975','2013-07-24','09:35:00',5.31),('8975','2013-07-24','09:40:00',2.92),('8975','2013-07-24','09:45:00',3.08),('8975','2013-07-24','09:50:00',5.26),('8975','2013-07-24','09:55:00',4.97),('8975','2013-07-24','10:00:00',5.26),('8975','2013-07-24','10:05:00',5.32),('8975','2013-07-24','10:10:00',5.52),('8975','2013-07-24','10:15:00',5.72),('8975','2013-07-24','10:20:00',5.52),('8975','2013-07-24','10:25:00',5.04),('8975','2013-07-24','10:30:00',4.88),('8975','2013-07-24','10:35:00',3.81),('8975','2013-07-24','10:40:00',2.87),('8975','2013-07-24','10:45:00',5.95),('8975','2013-07-24','10:50:00',6.19),('8975','2013-07-24','10:55:00',4.6),('8975','2013-07-24','11:00:00',3),('8975','2013-07-24','11:05:00',4.25),('8975','2013-07-24','11:10:00',2.13),('8975','2013-07-24','11:15:00',5.24),('8975','2013-07-24','11:20:00',6.6),('8975','2013-07-24','11:25:00',3.97),('8975','2013-07-24','11:30:00',1.44),('8975','2013-07-24','11:35:00',5.87),('8975','2013-07-24','11:40:00',6.77),('8975','2013-07-24','11:45:00',6.69),('8975','2013-07-24','11:50:00',6.71),('8975','2013-07-24','11:55:00',6.36),('8975','2013-07-24','12:00:00',3.93),('8975','2013-07-24','12:05:00',2.06),('8975','2013-07-24','12:10:00',2.48),('8975','2013-07-24','12:15:00',6.82),('8975','2013-07-24','12:20:00',6.4),('8975','2013-07-24','12:25:00',5.82),('8975','2013-07-24','12:30:00',4.26),('8975','2013-07-24','12:35:00',7),('8975','2013-07-24','12:40:00',6.73),('8975','2013-07-24','12:45:00',5.57),('8975','2013-07-24','12:50:00',6.73),('8975','2013-07-24','12:55:00',6.38),('8975','2013-07-24','13:00:00',4.85),('8975','2013-07-24','13:05:00',6.52),('8975','2013-07-24','13:10:00',6.23),('8975','2013-07-24','13:15:00',6.37),('8975','2013-07-24','13:20:00',6.4),('8975','2013-07-24','13:25:00',6.37),('8975','2013-07-24','13:30:00',6.27),('8975','2013-07-24','13:35:00',6.25),('8975','2013-07-24','13:40:00',6.25),('8975','2013-07-24','13:45:00',6.02),('8975','2013-07-24','13:50:00',6.02),('8975','2013-07-24','13:55:00',6.09),('8975','2013-07-24','14:00:00',6.09),('8975','2013-07-24','14:05:00',6.1),('8975','2013-07-24','14:10:00',6.09),('8975','2013-07-24','14:15:00',6),('8975','2013-07-24','14:20:00',5.96),('8975','2013-07-24','14:25:00',5.88),('8975','2013-07-24','14:30:00',5.82),('8975','2013-07-24','14:35:00',5.74),('8975','2013-07-24','14:40:00',5.69),('8975','2013-07-24','14:45:00',5.58),('8975','2013-07-24','14:50:00',5.49),('8975','2013-07-24','14:55:00',5.41),('8975','2013-07-24','15:00:00',5.38),('8975','2013-07-24','15:05:00',5.34),('8975','2013-07-24','15:10:00',5.25),('8975','2013-07-24','15:15:00',5.17),('8975','2013-07-24','15:20:00',5.09),('8975','2013-07-24','15:25:00',4.95),('8975','2013-07-24','15:30:00',4.91),('8975','2013-07-24','15:35:00',4.83),('8975','2013-07-24','15:40:00',4.74),('8975','2013-07-24','15:45:00',4.62),('8975','2013-07-24','15:50:00',4.52),('8975','2013-07-24','15:55:00',4.44),('8975','2013-07-24','16:00:00',4.33),('8975','2013-07-24','16:05:00',4.23),('8975','2013-07-24','16:10:00',4.11),('8975','2013-07-24','16:15:00',4.03),('8975','2013-07-24','16:20:00',3.93),('8975','2013-07-24','16:25:00',3.84),('8975','2013-07-24','16:30:00',3.73),('8975','2013-07-24','16:35:00',3.63),('8975','2013-07-24','16:40:00',3.53),('8975','2013-07-24','16:45:00',3.41),('8975','2013-07-24','16:50:00',3.28),('8975','2013-07-24','16:55:00',3.15),('8975','2013-07-24','17:00:00',2.97),('8975','2013-07-24','17:05:00',2.66),('8975','2013-07-24','17:10:00',2.38),('8975','2013-07-24','17:15:00',2.45),('8975','2013-07-24','17:20:00',2.18),('8975','2013-07-24','17:25:00',2.11),('8975','2013-07-24','17:30:00',2.22),('8975','2013-07-24','17:35:00',1.96),('8975','2013-07-24','17:40:00',1.92),('8975','2013-07-24','17:45:00',1.75),('8975','2013-07-24','17:50:00',1.83),('8975','2013-07-24','17:55:00',1.53),('8975','2013-07-24','18:00:00',1.66),('8975','2013-07-24','18:05:00',1.64),('8975','2013-07-24','18:10:00',1.55),('8975','2013-07-24','18:15:00',1.5),('8975','2013-07-24','18:20:00',1.43),('8975','2013-07-24','18:25:00',1.35),('8975','2013-07-24','18:30:00',1.31),('8975','2013-07-24','18:35:00',1.27),('8975','2013-07-24','18:40:00',1.21),('8975','2013-07-24','18:45:00',1.15),('8975','2013-07-24','18:50:00',1.08),('8975','2013-07-24','18:55:00',1.03),('8975','2013-07-23','07:25:00',1.04),('8975','2013-07-23','07:35:00',1.09),('8975','2013-07-23','07:40:00',1.1),('8975','2013-07-23','07:45:00',1.12),('8975','2013-07-23','07:50:00',1.74),('8975','2013-07-23','07:55:00',2.2),('8975','2013-07-23','08:00:00',1.98),('8975','2013-07-23','08:05:00',1.86),('8975','2013-07-23','08:10:00',3.09),('8975','2013-07-23','08:15:00',2.46),('8975','2013-07-23','08:20:00',1.24),('8975','2013-07-23','08:25:00',2.67),('8975','2013-07-23','08:30:00',2.82),('8975','2013-07-23','08:35:00',3.64),('8975','2013-07-23','08:40:00',3.93),('8975','2013-07-23','08:45:00',3.98),('8975','2013-07-23','08:50:00',4.18),('8975','2013-07-23','08:55:00',4.19),('8975','2013-07-23','09:00:00',3.14),('8975','2013-07-23','09:05:00',4.66),('8975','2013-07-23','09:10:00',4.49),('8975','2013-07-23','09:15:00',4.89),('8975','2013-07-23','09:20:00',5.12),('8975','2013-07-23','09:25:00',4.64),('8975','2013-07-23','09:30:00',2.47),('8975','2013-07-23','09:35:00',2.61),('8975','2013-07-23','09:40:00',1.79),('8975','2013-07-23','09:45:00',1.64),('8975','2013-07-23','09:50:00',1.57),('8975','2013-07-23','09:55:00',1.4),('8975','2013-07-23','10:00:00',1.53),('8975','2013-07-23','10:05:00',2.07),('8975','2013-07-23','10:10:00',4.24),('8975','2013-07-23','10:15:00',4.92),('8975','2013-07-23','10:20:00',5.65),('8975','2013-07-23','10:25:00',5.81),('8975','2013-07-23','10:30:00',5.8),('8975','2013-07-23','10:35:00',6.25),('8975','2013-07-23','10:40:00',6.65),('8975','2013-07-23','10:45:00',6.11),('8975','2013-07-23','10:50:00',6.05),('8975','2013-07-23','10:55:00',3.31),('8975','2013-07-23','11:00:00',2.25),('8975','2013-07-23','11:05:00',6.2),('8975','2013-07-23','11:10:00',6.38),('8975','2013-07-23','11:15:00',6.49),('8975','2013-07-23','11:20:00',6.24),('8975','2013-07-23','11:25:00',6.19),('8975','2013-07-23','11:30:00',6.24),('8975','2013-07-23','11:35:00',5.59),('8975','2013-07-23','11:40:00',6.52),('8975','2013-07-23','11:45:00',6.75),('8975','2013-07-23','11:50:00',6.66),('8975','2013-07-23','11:55:00',6.14),('8975','2013-07-23','12:00:00',5.62),('8975','2013-07-23','12:05:00',3.39),('8975','2013-07-23','12:10:00',5.61),('8975','2013-07-23','12:15:00',3.28),('8975','2013-07-23','12:20:00',3.16),('8975','2013-07-23','12:25:00',2.11),('8975','2013-07-23','12:30:00',3.68),('8975','2013-07-23','12:35:00',5.9),('8975','2013-07-23','12:40:00',2.86),('8975','2013-07-23','12:45:00',7.26),('8975','2013-07-23','12:50:00',6.9),('8975','2013-07-23','12:55:00',3.76),('8975','2013-07-23','13:00:00',2.1),('8975','2013-07-23','13:05:00',3.98),('8975','2013-07-23','13:10:00',2.56),('8975','2013-07-23','13:15:00',1.66),('8975','2013-07-23','13:20:00',1.54),('8975','2013-07-23','13:25:00',2.23),('8975','2013-07-23','13:30:00',2.09),('8975','2013-07-23','13:35:00',4.65),('8975','2013-07-23','13:40:00',2.89),('8975','2013-07-23','13:45:00',5.19),('8975','2013-07-23','13:50:00',6.76),('8975','2013-07-23','13:55:00',6.74),('8975','2013-07-23','14:00:00',6.49),('8975','2013-07-23','14:05:00',5.9),('8975','2013-07-23','14:10:00',6.48),('8975','2013-07-23','14:15:00',6.46),('8975','2013-07-23','14:20:00',6.19),('8975','2013-07-23','14:25:00',6.3),('8975','2013-07-23','14:30:00',5.64),('8975','2013-07-23','14:35:00',5.33),('8975','2013-07-23','14:40:00',5.89),('8975','2013-07-23','14:45:00',5.44),('8975','2013-07-23','14:50:00',5.93),('8975','2013-07-23','14:55:00',4.9),('8975','2013-07-23','15:00:00',5.7),('8975','2013-07-23','15:05:00',5.46),('8975','2013-07-23','15:10:00',5.49),('8975','2013-07-23','15:15:00',5.51),('8975','2013-07-23','15:20:00',5.38),('8975','2013-07-23','15:25:00',5.29),('8975','2013-07-23','15:30:00',5.19),('8975','2013-07-23','15:35:00',4.81),('8975','2013-07-23','15:40:00',4.85),('8975','2013-07-23','15:45:00',4.97),('8975','2013-07-23','15:50:00',4.79),('8975','2013-07-23','15:55:00',4.71),('8975','2013-07-23','16:00:00',4.61),('8975','2013-07-23','16:05:00',4.6),('8975','2013-07-23','16:10:00',4.57),('8975','2013-07-23','16:15:00',4.31),('8975','2013-07-23','16:20:00',4.19),('8975','2013-07-23','16:25:00',4.14),('8975','2013-07-23','16:30:00',4.04),('8975','2013-07-23','16:35:00',3.86),('8975','2013-07-23','16:40:00',3.82),('8975','2013-07-23','16:45:00',3.73),('8975','2013-07-23','16:50:00',3.57),('8975','2013-07-23','16:55:00',3.53),('8975','2013-07-23','17:00:00',3.43),('8975','2013-07-23','17:05:00',3.28),('8975','2013-07-23','17:10:00',3.1),('8975','2013-07-23','17:15:00',2.93),('8975','2013-07-23','17:20:00',2.77),('8975','2013-07-23','17:25:00',2.61),('8975','2013-07-23','17:30:00',2.47),('8975','2013-07-23','17:35:00',2.34),('8975','2013-07-23','17:40:00',2.19),('8975','2013-07-23','17:45:00',2.08),('8975','2013-07-23','17:50:00',1.98),('8975','2013-07-23','17:55:00',1.85),('8975','2013-07-23','18:00:00',1.74),('8975','2013-07-23','18:05:00',1.66),('8975','2013-07-23','18:10:00',1.59),('8975','2013-07-23','18:15:00',1.51),('8975','2013-07-23','18:20:00',1.45),('8975','2013-07-23','18:25:00',1.28),('8975','2013-07-23','18:30:00',1.2),('8975','2013-07-23','18:35:00',1.02),('8975','2013-07-23','18:40:00',1.18),('8975','2013-07-23','18:45:00',1.15),('8975','2013-07-23','18:50:00',1.03),('8975','2013-07-22','06:40:00',1.08),('8975','2013-07-22','06:45:00',1.21),('8975','2013-07-22','06:50:00',1.37),('8975','2013-07-22','06:55:00',1.52),('8975','2013-07-22','07:00:00',1.67),('8975','2013-07-22','07:05:00',1.81),('8975','2013-07-22','07:10:00',1.94),('8975','2013-07-22','07:15:00',2.08),('8975','2013-07-22','07:20:00',2.22),('8975','2013-07-22','07:25:00',2.36),('8975','2013-07-22','07:30:00',2.5),('8975','2013-07-22','07:35:00',2.63),('8975','2013-07-22','07:40:00',2.74),('8975','2013-07-22','07:45:00',2.84),('8975','2013-07-22','07:50:00',2.95),('8975','2013-07-22','07:55:00',3.05),('8975','2013-07-22','08:00:00',3.17),('8975','2013-07-22','08:05:00',3.26),('8975','2013-07-22','08:10:00',3.36),('8975','2013-07-22','08:15:00',3.45),('8975','2013-07-22','08:20:00',3.55),('8975','2013-07-22','08:25:00',3.69),('8975','2013-07-22','08:30:00',3.83),('8975','2013-07-22','08:35:00',3.92),('8975','2013-07-22','08:40:00',4.03),('8975','2013-07-22','08:45:00',4.14),('8975','2013-07-22','08:50:00',4.24),('8975','2013-07-22','08:55:00',4.35),('8975','2013-07-22','09:00:00',4.45),('8975','2013-07-22','09:05:00',4.53),('8975','2013-07-22','09:10:00',4.61),('8975','2013-07-22','09:15:00',4.63),('8975','2013-07-22','09:20:00',4.68),('8975','2013-07-22','09:25:00',4.75),('8975','2013-07-22','09:30:00',4.82),('8975','2013-07-22','09:35:00',4.91),('8975','2013-07-22','09:40:00',4.97),('8975','2013-07-22','09:45:00',4.99),('8975','2013-07-22','09:50:00',5.08),('8975','2013-07-22','09:55:00',5.18),('8975','2013-07-22','10:00:00',5.17),('8975','2013-07-22','10:05:00',5.32),('8975','2013-07-22','10:10:00',5.49),('8975','2013-07-22','10:15:00',5.6),('8975','2013-07-22','10:20:00',5.65),('8975','2013-07-22','10:25:00',5.71),('8975','2013-07-22','10:30:00',5.77),('8975','2013-07-22','10:35:00',5.83),('8975','2013-07-22','10:40:00',5.89),('8975','2013-07-22','10:45:00',5.88),('8975','2013-07-22','10:50:00',5.94),('8975','2013-07-22','10:55:00',6.01),('8975','2013-07-22','11:00:00',6.09),('8975','2013-07-22','11:05:00',6.09),('8975','2013-07-22','11:10:00',6.12),('8975','2013-07-22','11:15:00',6.17),('8975','2013-07-22','11:20:00',6.27),('8975','2013-07-22','11:25:00',6.28),('8975','2013-07-22','11:30:00',6.32),('8975','2013-07-22','11:35:00',6.37),('8975','2013-07-22','11:40:00',6.42),('8975','2013-07-22','11:45:00',6.39),('8975','2013-07-22','11:50:00',6.41),('8975','2013-07-22','11:55:00',6.38),('8975','2013-07-22','12:00:00',6.51),('8975','2013-07-22','12:05:00',6.45),('8975','2013-07-22','12:10:00',6.45),('8975','2013-07-22','12:15:00',6.47),('8975','2013-07-22','12:20:00',6.64),('8975','2013-07-22','12:25:00',6.65),('8975','2013-07-22','12:30:00',6.59),('8975','2013-07-22','12:35:00',6.59),('8975','2013-07-22','12:40:00',3.89),('8975','2013-07-22','12:45:00',2.56),('8975','2013-07-22','12:50:00',2.35),('8975','2013-07-22','12:55:00',2.3),('8975','2013-07-22','13:00:00',7.21),('8975','2013-07-22','13:05:00',4.65),('8975','2013-07-22','13:10:00',2.02),('8975','2013-07-22','13:15:00',1.2),('8975','2013-07-22','13:20:00',1.03),('8975','2013-07-22','13:25:00',1.02),('8975','2013-07-22','13:55:00',1.14),('8975','2013-07-22','14:00:00',1.65),('8975','2013-07-22','14:05:00',2.41),('8975','2013-07-22','14:35:00',1.52),('8975','2013-07-22','14:40:00',1.57),('8975','2013-07-22','14:45:00',2.18),('8975','2013-07-22','14:50:00',3.82),('8975','2013-07-22','14:55:00',4.46),('8975','2013-07-22','15:00:00',5.65),('8975','2013-07-22','15:05:00',5.8),('8975','2013-07-22','15:10:00',5.61),('8975','2013-07-22','15:15:00',5.44),('8975','2013-07-22','15:20:00',5.31),('8975','2013-07-22','15:25:00',5.11),('8975','2013-07-22','15:30:00',4.71),('8975','2013-07-22','15:35:00',4.66),('8975','2013-07-22','15:40:00',4.74),('8975','2013-07-22','15:45:00',4.54),('8975','2013-07-22','15:50:00',4.5),('8975','2013-07-22','15:55:00',4.43),('8975','2013-07-22','16:00:00',4.36),('8975','2013-07-22','16:05:00',4.28),('8975','2013-07-22','16:10:00',4.13),('8975','2013-07-22','16:15:00',4.06),('8975','2013-07-22','16:20:00',3.92),('8975','2013-07-22','16:25:00',3.8),('8975','2013-07-22','16:30:00',3.71),('8975','2013-07-22','16:35:00',3.59),('8975','2013-07-22','16:40:00',3.49),('8975','2013-07-22','16:45:00',3.39),('8975','2013-07-22','16:50:00',3.28),('8975','2013-07-22','16:55:00',3.19),('8975','2013-07-22','17:00:00',3.08),('8975','2013-07-22','17:05:00',2.96),('8975','2013-07-22','17:10:00',2.84),('8975','2013-07-22','17:15:00',2.74),('8975','2013-07-22','17:20:00',2.64),('8975','2013-07-22','17:25:00',2.56),('8975','2013-07-22','17:30:00',2.45),('8975','2013-07-22','17:35:00',2.35),('8975','2013-07-22','17:40:00',2.27),('8975','2013-07-22','17:45:00',2.16),('8975','2013-07-22','17:50:00',2.06),('8975','2013-07-22','17:55:00',1.97),('8975','2013-07-22','18:00:00',1.89),('8975','2013-07-22','18:05:00',1.79),('8975','2013-07-22','18:10:00',1.69),('8975','2013-07-22','18:15:00',1.6),('8975','2013-07-22','18:20:00',1.53),('8975','2013-07-22','18:25:00',1.45),('8975','2013-07-22','18:30:00',1.38),('8975','2013-07-22','18:35:00',1.31),('8975','2013-07-22','18:40:00',1.15),('8975','2013-07-21','06:50:00',1.13),('8975','2013-07-21','06:55:00',1.32),('8975','2013-07-21','07:00:00',1.47),('8975','2013-07-21','07:05:00',1.62),('8975','2013-07-21','07:10:00',1.78),('8975','2013-07-21','07:15:00',1.92),('8975','2013-07-21','07:20:00',2.05),('8975','2013-07-21','07:25:00',2.19),('8975','2013-07-21','07:30:00',2.32),('8975','2013-07-21','07:35:00',2.45),('8975','2013-07-21','07:40:00',2.58),('8975','2013-07-21','07:45:00',2.71),('8975','2013-07-21','07:50:00',2.82),('8975','2013-07-21','07:55:00',2.95),('8975','2013-07-21','08:00:00',3.07),('8975','2013-07-21','08:05:00',3.2),('8975','2013-07-21','08:10:00',3.3),('8975','2013-07-21','08:15:00',3.4),('8975','2013-07-21','08:20:00',3.51),('8975','2013-07-21','08:25:00',3.64),('8975','2013-07-21','08:30:00',3.73),('8975','2013-07-21','08:35:00',3.83),('8975','2013-07-21','08:40:00',3.99),('8975','2013-07-21','08:45:00',4.08),('8975','2013-07-21','08:50:00',4.15),('8975','2013-07-21','08:55:00',4.26),('8975','2013-07-21','09:00:00',4.39),('8975','2013-07-21','09:05:00',4.49),('8975','2013-07-21','09:10:00',4.59),('8975','2013-07-21','09:15:00',4.69),('8975','2013-07-21','09:20:00',4.78),('8975','2013-07-21','09:25:00',4.87),('8975','2013-07-21','09:30:00',4.93),('8975','2013-07-21','09:35:00',5.02),('8975','2013-07-21','09:40:00',5.07),('8975','2013-07-21','09:45:00',5.17),('8975','2013-07-21','09:50:00',5.26),('8975','2013-07-21','09:55:00',5.32),('8975','2013-07-21','10:00:00',5.39),('8975','2013-07-21','10:05:00',5.46),('8975','2013-07-21','10:10:00',5.51),('8975','2013-07-21','10:15:00',5.57),('8975','2013-07-21','10:20:00',5.66),('8975','2013-07-21','10:25:00',5.71),('8975','2013-07-21','10:30:00',5.8),('8975','2013-07-21','10:35:00',5.84),('8975','2013-07-21','10:40:00',5.94),('8975','2013-07-21','10:45:00',5.96),('8975','2013-07-21','10:50:00',5.97),('8975','2013-07-21','10:55:00',6.01),('8975','2013-07-21','11:00:00',6.01),('8975','2013-07-21','11:05:00',6.09),('8975','2013-07-21','11:10:00',6.15),('8975','2013-07-21','11:15:00',6.18),('8975','2013-07-21','11:20:00',6.17),('8975','2013-07-21','11:25:00',6.18),('8975','2013-07-21','11:30:00',6.22),('8975','2013-07-21','11:35:00',6.23),('8975','2013-07-21','11:40:00',6.3),('8975','2013-07-21','11:45:00',6.34),('8975','2013-07-21','11:50:00',6.32),('8975','2013-07-21','11:55:00',6.29),('8975','2013-07-21','12:00:00',6.31),('8975','2013-07-21','12:05:00',6.32),('8975','2013-07-21','12:10:00',6.31),('8975','2013-07-21','12:15:00',6.29),('8975','2013-07-21','12:20:00',6.34),('8975','2013-07-21','12:25:00',6.34),('8975','2013-07-21','12:30:00',6.43),('8975','2013-07-21','12:35:00',6.38),('8975','2013-07-21','12:40:00',6.31),('8975','2013-07-21','12:45:00',6.32),('8975','2013-07-21','12:50:00',6.35),('8975','2013-07-21','12:55:00',6.3),('8975','2013-07-21','13:00:00',6.27),('8975','2013-07-21','13:05:00',6.13),('8975','2013-07-21','13:10:00',6.11),('8975','2013-07-21','13:15:00',6.16),('8975','2013-07-21','13:20:00',6.19),('8975','2013-07-21','13:25:00',6.21),('8975','2013-07-21','13:30:00',6.15),('8975','2013-07-21','13:35:00',6.11),('8975','2013-07-21','13:40:00',6.1),('8975','2013-07-21','13:45:00',6.04),('8975','2013-07-21','13:50:00',6.03),('8975','2013-07-21','13:55:00',5.95),('8975','2013-07-21','14:00:00',5.89),('8975','2013-07-21','14:05:00',5.89),('8975','2013-07-21','14:10:00',5.86),('8975','2013-07-21','14:15:00',5.8),('8975','2013-07-21','14:20:00',5.74),('8975','2013-07-21','14:25:00',5.73),('8975','2013-07-21','14:30:00',5.67),('8975','2013-07-21','14:35:00',5.55),('8975','2013-07-21','14:40:00',5.52),('8975','2013-07-21','14:45:00',5.4),('8975','2013-07-21','14:50:00',5.19),('8975','2013-07-21','14:55:00',5.15),('8975','2013-07-21','15:00:00',5.28),('8975','2013-07-21','15:05:00',5.24),('8975','2013-07-21','15:10:00',5.2),('8975','2013-07-21','15:15:00',5.12),('8975','2013-07-21','15:20:00',5.04),('8975','2013-07-21','15:25:00',4.98),('8975','2013-07-21','15:30:00',4.88),('8975','2013-07-21','15:35:00',3.95),('8975','2013-07-21','15:40:00',1.66),('8975','2013-07-21','15:45:00',2.83),('8975','2013-07-21','15:50:00',3.47),('8975','2013-07-21','15:55:00',3.9),('8975','2013-07-21','16:00:00',4.93),('8975','2013-07-21','16:05:00',4.78),('8975','2013-07-21','16:10:00',4.85),('8975','2013-07-21','16:15:00',4.67),('8975','2013-07-21','16:20:00',4.5),('8975','2013-07-21','16:25:00',4.21),('8975','2013-07-21','16:30:00',3.86),('8975','2013-07-21','16:35:00',3.71),('8975','2013-07-21','16:40:00',3.51),('8975','2013-07-21','16:45:00',3.42),('8975','2013-07-21','16:50:00',3.24),('8975','2013-07-21','16:55:00',2.86),('8975','2013-07-21','17:00:00',3.07),('8975','2013-07-21','17:05:00',2.99),('8975','2013-07-21','17:10:00',2.9),('8975','2013-07-21','17:15:00',2.75),('8975','2013-07-21','17:20:00',2.65),('8975','2013-07-21','17:25:00',2.45),('8975','2013-07-21','17:30:00',2.43),('8975','2013-07-21','17:35:00',2.39),('8975','2013-07-21','17:40:00',2.27),('8975','2013-07-21','17:45:00',2.1),('8975','2013-07-21','17:50:00',2.01),('8975','2013-07-21','17:55:00',1.94),('8975','2013-07-21','18:00:00',1.88),('8975','2013-07-21','18:05:00',1.74),('8975','2013-07-21','18:10:00',1.62),('8975','2013-07-21','18:15:00',1.56),('8975','2013-07-21','18:20:00',1.49),('8975','2013-07-21','18:25:00',1.41),('8975','2013-07-21','18:30:00',1.27),('8975','2013-07-21','18:35:00',1.24),('8975','2013-07-21','18:40:00',1.18),('8975','2013-07-21','18:45:00',1.13),('8975','2013-07-21','18:50:00',1.06),('8975','2013-07-20','06:50:00',1.05),('8975','2013-07-20','06:55:00',1.22),('8975','2013-07-20','07:00:00',1.35),('8975','2013-07-20','07:05:00',1.44),('8975','2013-07-20','07:10:00',1.61),('8975','2013-07-20','07:15:00',1.75),('8975','2013-07-20','07:20:00',1.88),('8975','2013-07-20','07:25:00',2.03),('8975','2013-07-20','07:30:00',2.18),('8975','2013-07-20','07:35:00',2.33),('8975','2013-07-20','07:40:00',2.26),('8975','2013-07-20','07:45:00',2.38),('8975','2013-07-20','07:50:00',2.74),('8975','2013-07-20','07:55:00',2.8),('8975','2013-07-20','08:00:00',2.83),('8975','2013-07-20','08:05:00',2.98),('8975','2013-07-20','08:10:00',3.13),('8975','2013-07-20','08:15:00',3.24),('8975','2013-07-20','08:20:00',3.36),('8975','2013-07-20','08:25:00',3.47),('8975','2013-07-20','08:30:00',3.61),('8975','2013-07-20','08:35:00',3.66),('8975','2013-07-20','08:40:00',3.77),('8975','2013-07-20','08:45:00',3.86),('8975','2013-07-20','08:50:00',3.99),('8975','2013-07-20','08:55:00',4.14),('8975','2013-07-20','09:00:00',4.19),('8975','2013-07-20','09:05:00',4.3),('8975','2013-07-20','09:10:00',4.41),('8975','2013-07-20','09:15:00',4.52),('8975','2013-07-20','09:20:00',4.61),('8975','2013-07-20','09:25:00',4.69),('8975','2013-07-20','09:30:00',4.78),('8975','2013-07-20','09:35:00',4.87),('8975','2013-07-20','09:40:00',4.9),('8975','2013-07-20','09:45:00',5),('8975','2013-07-20','09:50:00',5.08),('8975','2013-07-20','09:55:00',5.17),('8975','2013-07-20','10:00:00',5.25),('8975','2013-07-20','10:05:00',5.35),('8975','2013-07-20','10:10:00',5.46),('8975','2013-07-20','10:15:00',5.49),('8975','2013-07-20','10:20:00',5.57),('8975','2013-07-20','10:25:00',5.63),('8975','2013-07-20','10:30:00',5.71),('8975','2013-07-20','10:35:00',5.79),('8975','2013-07-20','10:40:00',5.8),('8975','2013-07-20','10:45:00',5.81),('8975','2013-07-20','10:50:00',5.82),('8975','2013-07-20','10:55:00',5.89),('8975','2013-07-20','11:00:00',5.89),('8975','2013-07-20','11:05:00',5.97),('8975','2013-07-20','11:10:00',6.04),('8975','2013-07-20','11:15:00',6.08),('8975','2013-07-20','11:20:00',6.1),('8975','2013-07-20','11:25:00',6.12),('8975','2013-07-20','11:30:00',5.98),('8975','2013-07-20','11:35:00',6.09),('8975','2013-07-20','11:40:00',6.34),('8975','2013-07-20','11:45:00',6.42),('8975','2013-07-20','11:50:00',6.33),('8975','2013-07-20','11:55:00',6.31),('8975','2013-07-20','12:00:00',6.31),('8975','2013-07-20','12:05:00',6.33),('8975','2013-07-20','12:10:00',6.36),('8975','2013-07-20','12:15:00',6.62),('8975','2013-07-20','12:20:00',6.7),('8975','2013-07-20','12:25:00',6.13),('8975','2013-07-20','12:30:00',6.78),('8975','2013-07-20','12:35:00',6.71),('8975','2013-07-20','12:40:00',7.14),('8975','2013-07-20','12:45:00',5.36),('8975','2013-07-20','12:50:00',4.79),('8975','2013-07-20','12:55:00',7.37),('8975','2013-07-20','13:00:00',3.98),('8975','2013-07-20','13:05:00',7.48),('8975','2013-07-20','13:10:00',7.56),('8975','2013-07-20','13:15:00',7.49),('8975','2013-07-20','13:20:00',7.33),('8975','2013-07-20','13:25:00',5.57),('8975','2013-07-20','13:30:00',6.64),('8975','2013-07-20','13:35:00',6.8),('8975','2013-07-20','13:40:00',6.81),('8975','2013-07-20','13:45:00',6.45),('8975','2013-07-20','13:50:00',4.01),('8975','2013-07-20','13:55:00',1.56),('8975','2013-07-20','14:00:00',1.08),('8975','2013-07-20','14:05:00',1.14),('8975','2013-07-20','14:10:00',1.13),('8975','2013-07-20','14:15:00',1.25),('8975','2013-07-20','14:20:00',2.9),('8975','2013-07-20','14:25:00',2.49),('8975','2013-07-20','14:30:00',1.83),('8975','2013-07-20','14:35:00',1.88),('8975','2013-07-20','14:40:00',2.08),('8975','2013-07-20','14:45:00',2.19),('8975','2013-07-20','14:50:00',2.43),('8975','2013-07-20','14:55:00',2.75),('8975','2013-07-20','15:00:00',2.46),('8975','2013-07-20','15:05:00',2.53),('8975','2013-07-20','15:10:00',2.48),('8975','2013-07-20','15:15:00',3.36),('8975','2013-07-20','15:20:00',3.13),('8975','2013-07-20','15:25:00',3.06),('8975','2013-07-20','15:30:00',2.84),('8975','2013-07-20','15:35:00',2.59),('8975','2013-07-20','15:40:00',3.32),('8975','2013-07-20','15:45:00',3.44),('8975','2013-07-20','15:50:00',2.96),('8975','2013-07-20','15:55:00',2.63),('8975','2013-07-20','16:00:00',2.17),('8975','2013-07-20','16:05:00',1.77),('8975','2013-07-20','16:10:00',1.42),('8975','2013-07-20','16:15:00',1.25),('8975','2013-07-20','16:20:00',1.17),('8975','2013-07-20','16:25:00',1.2),('8975','2013-07-20','16:30:00',1.24),('8975','2013-07-20','16:35:00',1.31),('8975','2013-07-20','16:40:00',1.38),('8975','2013-07-20','16:45:00',1.33),('8975','2013-07-20','16:50:00',1.34),('8975','2013-07-20','16:55:00',1.46),('8975','2013-07-20','17:00:00',1.71),('8975','2013-07-20','17:05:00',1.82),('8975','2013-07-20','17:10:00',1.99),('8975','2013-07-20','17:15:00',1.78),('8975','2013-07-20','17:20:00',1.55),('8975','2013-07-20','17:25:00',1.38),('8975','2013-07-20','17:30:00',1.29),('8975','2013-07-20','17:35:00',1.23),('8975','2013-07-20','17:40:00',1.22),('8975','2013-07-20','17:45:00',1.19),('8975','2013-07-20','17:50:00',1.2),('8975','2013-07-20','17:55:00',1.22),('8975','2013-07-20','18:00:00',1.23),('8975','2013-07-20','18:05:00',1.2),('8975','2013-07-20','18:10:00',1.05),('8975','2014-04-06','07:30:00',1.08),('8975','2014-04-06','07:35:00',1.1),('8975','2014-04-06','07:40:00',1.22),('8975','2014-04-06','07:45:00',1.12),('8975','2014-04-06','07:50:00',1.02),('8975','2014-04-06','08:10:00',1.37),('8975','2014-04-06','08:15:00',1.52),('8975','2014-04-06','08:20:00',1.7),('8975','2014-04-06','08:25:00',2.05),('8975','2014-04-06','08:30:00',2.41),('8975','2014-04-06','08:35:00',2.8),('8975','2014-04-06','08:40:00',3),('8975','2014-04-06','08:45:00',3.08),('8975','2014-04-06','08:50:00',2.85),('8975','2014-04-06','08:55:00',2.65),('8975','2014-04-06','09:00:00',2.24),('8975','2014-04-06','09:05:00',2.09),('8975','2014-04-06','09:10:00',2.34),('8975','2014-04-06','09:15:00',3.42),('8975','2014-04-06','09:20:00',2.25),('8975','2014-04-06','09:25:00',2.1),('8975','2014-04-06','09:30:00',2.02),('8975','2014-04-06','09:35:00',1.94),('8975','2014-04-06','09:40:00',1.95),('8975','2014-04-06','09:45:00',2.04),('8975','2014-04-06','09:50:00',2.18),('8975','2014-04-06','09:55:00',2.25),('8975','2014-04-06','10:00:00',2.3),('8975','2014-04-06','10:05:00',2.3),('8975','2014-04-06','10:10:00',2.4),('8975','2014-04-06','10:15:00',2.21),('8975','2014-04-06','10:20:00',2.15),('8975','2014-04-06','10:25:00',2.2),('8975','2014-04-06','10:30:00',2.28),('8975','2014-04-06','10:35:00',2.36),('8975','2014-04-06','10:40:00',2.51),('8975','2014-04-06','10:45:00',2.51),('8975','2014-04-06','10:50:00',2.61),('8975','2014-04-06','10:55:00',2.75),('8975','2014-04-06','11:00:00',3.17),('8975','2014-04-06','11:05:00',3.02),('8975','2014-04-06','11:10:00',3.46),('8975','2014-04-06','11:15:00',3.56),('8975','2014-04-06','11:20:00',3.55),('8975','2014-04-06','11:25:00',3.25),('8975','2014-04-06','11:30:00',3.15),('8975','2014-04-06','11:35:00',3.09),('8975','2014-04-06','11:40:00',3.34),('8975','2014-04-06','11:45:00',3.09),('8975','2014-04-06','11:50:00',2.82),('8975','2014-04-06','11:55:00',2.69),('8975','2014-04-06','12:00:00',2.69),('8975','2014-04-06','12:05:00',3.1),('8975','2014-04-06','12:10:00',3.7),('8975','2014-04-06','12:15:00',4.63),('8975','2014-04-06','12:20:00',5.96),('8975','2014-04-06','12:25:00',6.09),('8975','2014-04-06','12:30:00',3.85),('8975','2014-04-06','12:35:00',3.4),('8975','2014-04-06','12:40:00',3.33),('8975','2014-04-06','12:45:00',5.64),('8975','2014-04-06','12:50:00',6.08),('8975','2014-04-06','12:55:00',5.93),('8975','2014-04-06','13:00:00',5.9),('8975','2014-04-06','13:05:00',5.85),('8975','2014-04-06','13:10:00',5.82),('8975','2014-04-06','13:15:00',5.73),('8975','2014-04-06','13:20:00',5.68),('8975','2014-04-06','13:25:00',5.71),('8975','2014-04-06','13:30:00',5.63),('8975','2014-04-06','13:35:00',5.56),('8975','2014-04-06','13:40:00',5.49),('8975','2014-04-06','13:45:00',5.52),('8975','2014-04-06','13:50:00',5.52),('8975','2014-04-06','13:55:00',5.47),('8975','2014-04-06','14:00:00',5.52),('8975','2014-04-06','14:05:00',5.46),('8975','2014-04-06','14:10:00',5.44),('8975','2014-04-06','14:15:00',5.35),('8975','2014-04-06','14:20:00',5.28),('8975','2014-04-06','14:25:00',5.27),('8975','2014-04-06','14:30:00',5.33),('8975','2014-04-06','14:35:00',5.19),('8975','2014-04-06','14:40:00',5.06),('8975','2014-04-06','14:45:00',4.99),('8975','2014-04-06','14:50:00',4.96),('8975','2014-04-06','14:55:00',4.96),('8975','2014-04-06','15:00:00',5.12),('8975','2014-04-06','15:05:00',5.02),('8975','2014-04-06','15:10:00',4.79),('8975','2014-04-06','15:15:00',4.85),('8975','2014-04-06','15:20:00',4.86),('8975','2014-04-06','15:25:00',4.73),('8975','2014-04-06','15:30:00',4.43),('8975','2014-04-06','15:35:00',4.39),('8975','2014-04-06','15:40:00',4.27),('8975','2014-04-06','15:45:00',4.09),('8975','2014-04-06','15:50:00',4.25),('8975','2014-04-06','15:55:00',3.96),('8975','2014-04-06','16:00:00',3.42),('8975','2014-04-06','16:05:00',2.13),('8975','2014-04-06','16:10:00',2.88),('8975','2014-04-06','16:15:00',3.56),('8975','2014-04-06','16:20:00',3.19),('8975','2014-04-06','16:25:00',2.88),('8975','2014-04-06','16:30:00',2.66),('8975','2014-04-06','16:35:00',2.64),('8975','2014-04-06','16:40:00',2.19),('8975','2014-04-06','16:45:00',1.62),('8975','2014-04-06','16:50:00',2.32),('8975','2014-04-06','16:55:00',2.26),('8975','2014-04-06','17:00:00',2.57),('8975','2014-04-06','17:05:00',2.55),('8975','2014-04-06','17:10:00',2.36),('8975','2014-04-06','17:15:00',2.1),('8975','2014-04-06','17:20:00',1.97),('8975','2014-04-06','17:25:00',1.66),('8975','2014-04-06','17:30:00',1.32),('8975','2014-04-06','17:35:00',1.03),('8975','2014-04-06','17:50:00',1.04),('8975','2014-04-06','17:55:00',1.33),('8975','2014-04-06','18:00:00',1.29),('8975','2014-04-06','18:05:00',1.2),('8975','2014-04-06','18:10:00',1.13),('8975','2014-04-06','18:15:00',1.1),('8975','2014-04-06','18:20:00',1.07),('8975','2013-07-19','06:40:00',1.02),('8975','2013-07-19','06:45:00',1.22),('8975','2013-07-19','06:50:00',1.4),('8975','2013-07-19','06:55:00',1.57),('8975','2013-07-19','07:00:00',1.47),('8975','2013-07-19','07:05:00',1.69),('8975','2013-07-19','07:10:00',1.69),('8975','2013-07-19','07:15:00',2.09),('8975','2013-07-19','07:20:00',1.51),('8975','2013-07-19','07:25:00',2.03),('8975','2013-07-19','07:30:00',2.5),('8975','2013-07-19','07:35:00',2.63),('8975','2013-07-19','07:40:00',2.71),('8975','2013-07-19','07:45:00',2.83),('8975','2013-07-19','07:50:00',2.94),('8975','2013-07-19','07:55:00',3.07),('8975','2013-07-19','08:00:00',3.16),('8975','2013-07-19','08:05:00',3.26),('8975','2013-07-19','08:10:00',3.37),('8975','2013-07-19','08:15:00',3.47),('8975','2013-07-19','08:20:00',3.59),('8975','2013-07-19','08:25:00',3.69),('8975','2013-07-19','08:30:00',3.81),('8975','2013-07-19','08:35:00',3.94),('8975','2013-07-19','08:40:00',4.05),('8975','2013-07-19','08:45:00',4.12),('8975','2013-07-19','08:50:00',4.22),('8975','2013-07-19','08:55:00',4.38),('8975','2013-07-19','09:00:00',4.43),('8975','2013-07-19','09:05:00',4.64),('8975','2013-07-19','09:10:00',4.78),('8975','2013-07-19','09:15:00',4.91),('8975','2013-07-19','09:20:00',4.86),('8975','2013-07-19','09:25:00',4.76),('8975','2013-07-19','09:30:00',4.51),('8975','2013-07-19','09:35:00',4.58),('8975','2013-07-19','09:40:00',4.9),('8975','2013-07-19','09:45:00',5.15),('8975','2013-07-19','09:50:00',5.07),('8975','2013-07-19','09:55:00',4.36),('8975','2013-07-19','10:00:00',5.09),('8975','2013-07-19','10:05:00',5.42),('8975','2013-07-19','10:10:00',5.5),('8975','2013-07-19','10:15:00',5.53),('8975','2013-07-19','10:20:00',5.6),('8975','2013-07-19','10:25:00',5.65),('8975','2013-07-19','10:30:00',5.73),('8975','2013-07-19','10:35:00',5.79),('8975','2013-07-19','10:40:00',5.8),('8975','2013-07-19','10:45:00',5.85),('8975','2013-07-19','10:50:00',5.96),('8975','2013-07-19','10:55:00',6.04),('8975','2013-07-19','11:00:00',6.08),('8975','2013-07-19','11:05:00',6.07),('8975','2013-07-19','11:10:00',6.04),('8975','2013-07-19','11:15:00',6.01),('8975','2013-07-19','11:20:00',6.15),('8975','2013-07-19','11:25:00',6.28),('8975','2013-07-19','11:30:00',5.97),('8975','2013-07-19','11:35:00',5.95),('8975','2013-07-19','11:40:00',6.09),('8975','2013-07-19','11:45:00',5.89),('8975','2013-07-19','11:50:00',5.27),('8975','2013-07-19','11:55:00',3.98),('8975','2013-07-19','12:00:00',6.18),('8975','2013-07-19','12:05:00',6.44),('8975','2013-07-19','12:10:00',5.88),('8975','2013-07-19','12:15:00',5.65),('8975','2013-07-19','12:20:00',4.8),('8975','2013-07-19','12:25:00',4.9),('8975','2013-07-19','12:30:00',6.47),('8975','2013-07-19','12:35:00',6.53),('8975','2013-07-19','12:40:00',6.66),('8975','2013-07-19','12:45:00',6.63),('8975','2013-07-19','12:50:00',6.48),('8975','2013-07-19','12:55:00',6.34),('8975','2013-07-19','13:00:00',3.08),('8975','2013-07-19','13:05:00',1.62),('8975','2013-07-19','13:10:00',1.92),('8975','2013-07-19','13:15:00',5.64),('8975','2013-07-19','13:20:00',7.14),('8975','2013-07-19','13:25:00',3.28),('8975','2013-07-19','13:30:00',1.79),('8975','2013-07-19','13:35:00',1.65),('8975','2013-07-19','13:40:00',4.87),('8975','2013-07-19','13:45:00',6.85),('8975','2013-07-19','13:50:00',6.92),('8975','2013-07-19','13:55:00',6.61),('8975','2013-07-19','14:00:00',6.62),('8975','2013-07-19','14:05:00',6.31),('8975','2013-07-19','14:10:00',6.21),('8975','2013-07-19','14:15:00',6.23),('8975','2013-07-19','14:20:00',6.15),('8975','2013-07-19','14:25:00',6.04),('8975','2013-07-19','14:30:00',5.88),('8975','2013-07-19','14:35:00',5.85),('8975','2013-07-19','14:40:00',5.81),('8975','2013-07-19','14:45:00',5.84),('8975','2013-07-19','14:50:00',5.85),('8975','2013-07-19','14:55:00',5.84),('8975','2013-07-19','15:00:00',5.58),('8975','2013-07-19','15:05:00',5.48),('8975','2013-07-19','15:10:00',5.38),('8975','2013-07-19','15:15:00',5.27),('8975','2013-07-19','15:20:00',5.18),('8975','2013-07-19','15:25:00',4.9),('8975','2013-07-19','15:30:00',4.91),('8975','2013-07-19','15:35:00',4.84),('8975','2013-07-19','15:40:00',4.8),('8975','2013-07-19','15:45:00',4.7),('8975','2013-07-19','15:50:00',4.62),('8975','2013-07-19','15:55:00',4.54),('8975','2013-07-19','16:00:00',4.43),('8975','2013-07-19','16:05:00',4.32),('8975','2013-07-19','16:10:00',4.2),('8975','2013-07-19','16:15:00',4.12),('8975','2013-07-19','16:20:00',4.04),('8975','2013-07-19','16:25:00',3.89),('8975','2013-07-19','16:30:00',3.77),('8975','2013-07-19','16:35:00',3.69),('8975','2013-07-19','16:40:00',3.54),('8975','2013-07-19','16:45:00',3.42),('8975','2013-07-19','16:50:00',3.32),('8975','2013-07-19','16:55:00',3.2),('8975','2013-07-19','17:00:00',3.1),('8975','2013-07-19','17:05:00',2.97),('8975','2013-07-19','17:10:00',2.83),('8975','2013-07-19','17:15:00',2.73),('8975','2013-07-19','17:20:00',2.61),('8975','2013-07-19','17:25:00',2.49),('8975','2013-07-19','17:30:00',2.38),('8975','2013-07-19','17:35:00',2.29),('8975','2013-07-19','17:40:00',2.19),('8975','2013-07-19','17:45:00',2.09),('8975','2013-07-19','17:50:00',1.98),('8975','2013-07-19','17:55:00',1.91),('8975','2013-07-19','18:00:00',1.82),('8975','2013-07-19','18:05:00',1.74),('8975','2013-07-19','18:10:00',1.66),('8975','2013-07-19','18:15:00',1.58),('8975','2013-07-19','18:20:00',1.51),('8975','2013-07-19','18:25:00',1.44),('8975','2013-07-19','18:30:00',1.38),('8975','2013-07-19','18:35:00',1.31),('8975','2013-07-19','18:40:00',1.26),('8975','2013-07-19','18:45:00',1.19),('8975','2013-07-19','18:50:00',1.11),('8975','2013-07-19','18:55:00',1.07),('8975','2013-07-19','19:00:00',1.03),('8975','2013-07-18','06:45:00',1),('8975','2013-07-18','06:50:00',1.16),('8975','2013-07-18','06:55:00',1.29),('8975','2013-07-18','07:00:00',1.41),('8975','2013-07-18','07:05:00',1.55),('8975','2013-07-18','07:10:00',1.74),('8975','2013-07-18','07:15:00',1.86),('8975','2013-07-18','07:20:00',1.98),('8975','2013-07-18','07:25:00',2.11),('8975','2013-07-18','07:30:00',2.25),('8975','2013-07-18','07:35:00',2.38),('8975','2013-07-18','07:40:00',2.5),('8975','2013-07-18','07:45:00',2.61),('8975','2013-07-18','07:50:00',2.74),('8975','2013-07-18','07:55:00',2.84),('8975','2013-07-18','08:00:00',2.96),('8975','2013-07-18','08:05:00',3.05),('8975','2013-07-18','08:10:00',3.18),('8975','2013-07-18','08:15:00',3.29),('8975','2013-07-18','08:20:00',3.41),('8975','2013-07-18','08:25:00',3.49),('8975','2013-07-18','08:30:00',3.59),('8975','2013-07-18','08:35:00',3.74),('8975','2013-07-18','08:40:00',3.86),('8975','2013-07-18','08:45:00',3.96),('8975','2013-07-18','08:50:00',4.1),('8975','2013-07-18','08:55:00',4.17),('8975','2013-07-18','09:00:00',4.22),('8975','2013-07-18','09:05:00',4.34),('8975','2013-07-18','09:10:00',4.43),('8975','2013-07-18','09:15:00',4.5),('8975','2013-07-18','09:20:00',4.6),('8975','2013-07-18','09:25:00',4.67),('8975','2013-07-18','09:30:00',4.75),('8975','2013-07-18','09:35:00',4.81),('8975','2013-07-18','09:40:00',4.87),('8975','2013-07-18','09:45:00',4.95),('8975','2013-07-18','09:50:00',4.99),('8975','2013-07-18','09:55:00',5.04),('8975','2013-07-18','10:00:00',5.11),('8975','2013-07-18','10:05:00',5.17),('8975','2013-07-18','10:10:00',5.23),('8975','2013-07-18','10:15:00',5.32),('8975','2013-07-18','10:20:00',5.3),('8975','2013-07-18','10:25:00',5.34),('8975','2013-07-18','10:30:00',5.5),('8975','2013-07-18','10:35:00',5.6),('8975','2013-07-18','10:40:00',5.61),('8975','2013-07-18','10:45:00',5.62),('8975','2013-07-18','10:50:00',5.67),('8975','2013-07-18','10:55:00',5.65),('8975','2013-07-18','11:00:00',5.74),('8975','2013-07-18','11:05:00',5.86),('8975','2013-07-18','11:10:00',5.91),('8975','2013-07-18','11:15:00',5.98),('8975','2013-07-18','11:20:00',6.07),('8975','2013-07-18','11:25:00',6.07),('8975','2013-07-18','11:30:00',6.12),('8975','2013-07-18','11:35:00',6.08),('8975','2013-07-18','11:40:00',5.97),('8975','2013-07-18','11:45:00',6.06),('8975','2013-07-18','11:50:00',6.22),('8975','2013-07-18','11:55:00',6.35),('8975','2013-07-18','12:00:00',6.38),('8975','2013-07-18','12:05:00',6.14),('8975','2013-07-18','12:10:00',3.07),('8975','2013-07-18','12:15:00',5.07),('8975','2013-07-18','12:20:00',6.56),('8975','2013-07-18','12:25:00',5.63),('8975','2013-07-18','12:30:00',6.47),('8975','2013-07-18','12:35:00',6.67),('8975','2013-07-18','12:40:00',6.62),('8975','2013-07-18','12:45:00',2.46),('8975','2013-07-18','12:50:00',4.23),('8975','2013-07-18','12:55:00',3.69),('8975','2013-07-18','13:00:00',4.64),('8975','2013-07-18','13:05:00',6.88),('8975','2013-07-18','13:10:00',6.91),('8975','2013-07-18','13:15:00',6.72),('8975','2013-07-18','13:20:00',2.85),('8975','2013-07-18','13:25:00',4.92),('8975','2013-07-18','13:30:00',6.83),('8975','2013-07-18','13:35:00',6.5),('8975','2013-07-18','13:40:00',5.87),('8975','2013-07-18','13:45:00',5.51),('8975','2013-07-18','13:50:00',6.07),('8975','2013-07-18','13:55:00',6.39),('8975','2013-07-18','14:00:00',6.36),('8975','2013-07-18','14:05:00',6.2),('8975','2013-07-18','14:10:00',6.27),('8975','2013-07-18','14:15:00',6.4),('8975','2013-07-18','14:20:00',5.82),('8975','2013-07-18','14:25:00',4.06),('8975','2013-07-18','14:30:00',5.92),('8975','2013-07-18','14:35:00',6.26),('8975','2013-07-18','14:40:00',4.67),('8975','2013-07-18','14:45:00',5.55),('8975','2013-07-18','14:50:00',5.12),('8975','2013-07-18','14:55:00',5.36),('8975','2013-07-18','15:00:00',4.81),('8975','2013-07-18','15:05:00',5.57),('8975','2013-07-18','15:10:00',4.07),('8975','2013-07-18','15:15:00',4.3),('8975','2013-07-18','15:20:00',5.26),('8975','2013-07-18','15:25:00',5.42),('8975','2013-07-18','15:30:00',5.35),('8975','2013-07-18','15:35:00',5.26),('8975','2013-07-18','15:40:00',5.24),('8975','2013-07-18','15:45:00',5.09),('8975','2013-07-18','15:50:00',4.93),('8975','2013-07-18','15:55:00',4.75),('8975','2013-07-18','16:00:00',4.68),('8975','2013-07-18','16:05:00',4.63),('8975','2013-07-18','16:10:00',4.54),('8975','2013-07-18','16:15:00',4.45),('8975','2013-07-18','16:20:00',4.23),('8975','2013-07-18','16:25:00',4.26),('8975','2013-07-18','16:30:00',4.23),('8975','2013-07-18','16:35:00',4.11),('8975','2013-07-18','16:40:00',3.99),('8975','2013-07-18','16:45:00',3.93),('8975','2013-07-18','16:50:00',3.81),('8975','2013-07-18','16:55:00',3.76),('8975','2013-07-18','17:00:00',3.64),('8975','2013-07-18','17:05:00',3.55),('8975','2013-07-18','17:10:00',3.41),('8975','2013-07-18','17:15:00',3.27),('8975','2013-07-18','17:20:00',3.07),('8975','2013-07-18','17:25:00',2.36),('8975','2013-07-18','17:30:00',2.65),('8975','2013-07-18','17:35:00',2.77),('8975','2013-07-18','17:40:00',2.4),('8975','2013-07-18','17:45:00',2.05),('8975','2013-07-18','17:50:00',1.47),('8975','2013-07-18','17:55:00',1.32),('8975','2013-07-18','18:00:00',1.17),('8975','2013-07-17','06:40:00',1.08),('8975','2013-07-17','06:45:00',1.23),('8975','2013-07-17','06:50:00',1.37),('8975','2013-07-17','06:55:00',1.54),('8975','2013-07-17','07:00:00',1.67),('8975','2013-07-17','07:05:00',1.81),('8975','2013-07-17','07:10:00',1.95),('8975','2013-07-17','07:15:00',2.09),('8975','2013-07-17','07:20:00',2.23),('8975','2013-07-17','07:25:00',2.42),('8975','2013-07-17','07:30:00',2.56),('8975','2013-07-17','07:35:00',2.7),('8975','2013-07-17','07:40:00',2.8),('8975','2013-07-17','07:45:00',2.95),('8975','2013-07-17','07:50:00',3.07),('8975','2013-07-17','07:55:00',3.16),('8975','2013-07-17','08:00:00',3.22),('8975','2013-07-17','08:05:00',3.34),('8975','2013-07-17','08:10:00',3.44),('8975','2013-07-17','08:15:00',3.54),('8975','2013-07-17','08:20:00',3.65),('8975','2013-07-17','08:25:00',3.75),('8975','2013-07-17','08:30:00',3.86),('8975','2013-07-17','08:35:00',3.96),('8975','2013-07-17','08:40:00',4.07),('8975','2013-07-17','08:45:00',4.17),('8975','2013-07-17','08:50:00',4.28),('8975','2013-07-17','08:55:00',4.4),('8975','2013-07-17','09:00:00',4.47),('8975','2013-07-17','09:05:00',4.57),('8975','2013-07-17','09:10:00',4.65),('8975','2013-07-17','09:15:00',4.74),('8975','2013-07-17','09:20:00',4.83),('8975','2013-07-17','09:25:00',4.9),('8975','2013-07-17','09:30:00',4.96),('8975','2013-07-17','09:35:00',5.08),('8975','2013-07-17','09:40:00',5.14),('8975','2013-07-17','09:45:00',5.19),('8975','2013-07-17','09:50:00',5.27),('8975','2013-07-17','09:55:00',5.33),('8975','2013-07-17','10:00:00',5.42),('8975','2013-07-17','10:05:00',5.49),('8975','2013-07-17','10:10:00',5.54),('8975','2013-07-17','10:15:00',5.55),('8975','2013-07-17','10:20:00',5.6),('8975','2013-07-17','10:25:00',5.77),('8975','2013-07-17','10:30:00',5.8),('8975','2013-07-17','10:35:00',5.83),('8975','2013-07-17','10:40:00',5.84),('8975','2013-07-17','10:45:00',5.61),('8975','2013-07-17','10:50:00',5.96),('8975','2013-07-17','10:55:00',6.02),('8975','2013-07-17','11:00:00',6.08),('8975','2013-07-17','11:05:00',6.13),('8975','2013-07-17','11:10:00',6.16),('8975','2013-07-17','11:15:00',6.21),('8975','2013-07-17','11:20:00',6.24),('8975','2013-07-17','11:25:00',6.29),('8975','2013-07-17','11:30:00',6.24),('8975','2013-07-17','11:35:00',6.3),('8975','2013-07-17','11:40:00',6.32),('8975','2013-07-17','11:45:00',6.33),('8975','2013-07-17','11:50:00',6.37),('8975','2013-07-17','11:55:00',6.4),('8975','2013-07-17','12:00:00',6.36),('8975','2013-07-17','12:05:00',6.38),('8975','2013-07-17','12:10:00',6.35),('8975','2013-07-17','12:15:00',6.42),('8975','2013-07-17','12:20:00',6.5),('8975','2013-07-17','12:25:00',6.48),('8975','2013-07-17','12:30:00',6.54),('8975','2013-07-17','12:35:00',6.5),('8975','2013-07-17','12:40:00',6.77),('8975','2013-07-17','12:45:00',6.78),('8975','2013-07-17','12:50:00',6.67),('8975','2013-07-17','12:55:00',6.47),('8975','2013-07-17','13:00:00',5.58),('8975','2013-07-17','13:05:00',1.5),('8975','2013-07-17','13:10:00',2.86),('8975','2013-07-17','13:15:00',6.6),('8975','2013-07-17','13:20:00',6.58),('8975','2013-07-17','13:25:00',6.87),('8975','2013-07-17','13:30:00',6.76),('8975','2013-07-17','13:35:00',6.75),('8975','2013-07-17','13:40:00',5.55),('8975','2013-07-17','13:45:00',6.14),('8975','2013-07-17','13:50:00',6.23),('8975','2013-07-17','13:55:00',6.11),('8975','2013-07-17','14:00:00',6.21),('8975','2013-07-17','14:05:00',6.15),('8975','2013-07-17','14:10:00',6.07),('8975','2013-07-17','14:15:00',6.01),('8975','2013-07-17','14:20:00',5.95),('8975','2013-07-17','14:25:00',5.98),('8975','2013-07-17','14:30:00',5.93),('8975','2013-07-17','14:35:00',5.85),('8975','2013-07-17','14:40:00',5.76),('8975','2013-07-17','14:45:00',5.74),('8975','2013-07-17','14:50:00',5.67),('8975','2013-07-17','14:55:00',5.53),('8975','2013-07-17','15:00:00',5.43),('8975','2013-07-17','15:05:00',5.38),('8975','2013-07-17','15:10:00',5.32),('8975','2013-07-17','15:15:00',5.24),('8975','2013-07-17','15:20:00',5.13),('8975','2013-07-17','15:25:00',5.07),('8975','2013-07-17','15:30:00',4.99),('8975','2013-07-17','15:35:00',4.87),('8975','2013-07-17','15:40:00',4.8),('8975','2013-07-17','15:45:00',4.68),('8975','2013-07-17','15:50:00',4.59),('8975','2013-07-17','15:55:00',4.47),('8975','2013-07-17','16:00:00',4.37),('8975','2013-07-17','16:05:00',4.28),('8975','2013-07-17','16:10:00',4.17),('8975','2013-07-17','16:15:00',4.07),('8975','2013-07-17','16:20:00',3.95),('8975','2013-07-17','16:25:00',3.86),('8975','2013-07-17','16:30:00',3.75),('8975','2013-07-17','16:35:00',3.63),('8975','2013-07-17','16:40:00',3.54),('8975','2013-07-17','16:45:00',3.43),('8975','2013-07-17','16:50:00',3.32),('8975','2013-07-17','16:55:00',3.19),('8975','2013-07-17','17:00:00',3.07),('8975','2013-07-17','17:05:00',2.97),('8975','2013-07-17','17:10:00',2.84),('8975','2013-07-17','17:15:00',2.72),('8975','2013-07-17','17:20:00',2.61),('8975','2013-07-17','17:25:00',2.49),('8975','2013-07-17','17:30:00',2.39),('8975','2013-07-17','17:35:00',2.26),('8975','2013-07-17','17:40:00',2.13),('8975','2013-07-17','17:45:00',2.02),('8975','2013-07-17','17:50:00',1.92),('8975','2013-07-17','17:55:00',1.76),('8975','2013-07-17','18:00:00',1.7),('8975','2013-07-17','18:05:00',1.53),('8975','2013-07-17','18:10:00',1.47),('8975','2013-07-17','18:15:00',1.48),('8975','2013-07-17','18:20:00',1.3),('8975','2013-07-17','18:25:00',1.28),('8975','2013-07-17','18:30:00',1.09),('8975','2013-07-16','06:40:00',1.03),('8975','2013-07-16','06:45:00',1.25),('8975','2013-07-16','06:50:00',1.44),('8975','2013-07-16','06:55:00',1.6),('8975','2013-07-16','07:00:00',1.77),('8975','2013-07-16','07:05:00',1.9),('8975','2013-07-16','07:10:00',2.11),('8975','2013-07-16','07:15:00',2.25),('8975','2013-07-16','07:20:00',2.35),('8975','2013-07-16','07:25:00',2.44),('8975','2013-07-16','07:30:00',2.61),('8975','2013-07-16','07:35:00',2.75),('8975','2013-07-16','07:40:00',2.91),('8975','2013-07-16','07:45:00',3.03),('8975','2013-07-16','07:50:00',3.18),('8975','2013-07-16','07:55:00',3.3),('8975','2013-07-16','08:00:00',3.4),('8975','2013-07-16','08:05:00',3.53),('8975','2013-07-16','08:10:00',3.64),('8975','2013-07-16','08:15:00',3.78),('8975','2013-07-16','08:20:00',3.88),('8975','2013-07-16','08:25:00',3.96),('8975','2013-07-16','08:30:00',4.06),('8975','2013-07-16','08:35:00',4.2),('8975','2013-07-16','08:40:00',4.29),('8975','2013-07-16','08:45:00',4.42),('8975','2013-07-16','08:50:00',4.54),('8975','2013-07-16','08:55:00',4.69),('8975','2013-07-16','09:00:00',4.77),('8975','2013-07-16','09:05:00',4.86),('8975','2013-07-16','09:10:00',4.95),('8975','2013-07-16','09:15:00',5.05),('8975','2013-07-16','09:20:00',5.14),('8975','2013-07-16','09:25:00',5.26),('8975','2013-07-16','09:30:00',5.34),('8975','2013-07-16','09:35:00',5.45),('8975','2013-07-16','09:40:00',5.52),('8975','2013-07-16','09:45:00',5.54),('8975','2013-07-16','09:50:00',5.6),('8975','2013-07-16','09:55:00',5.7),('8975','2013-07-16','10:00:00',5.77),('8975','2013-07-16','10:05:00',5.8),('8975','2013-07-16','10:10:00',5.86),('8975','2013-07-16','10:15:00',5.9),('8975','2013-07-16','10:20:00',5.95),('8975','2013-07-16','10:25:00',6),('8975','2013-07-16','10:30:00',6.07),('8975','2013-07-16','10:35:00',6.11),('8975','2013-07-16','10:40:00',6.12),('8975','2013-07-16','10:45:00',6.18),('8975','2013-07-16','10:50:00',6.25),('8975','2013-07-16','10:55:00',6.29),('8975','2013-07-16','11:00:00',6.32),('8975','2013-07-16','11:05:00',6.37),('8975','2013-07-16','11:10:00',6.46),('8975','2013-07-16','11:15:00',6.47),('8975','2013-07-16','11:20:00',6.51),('8975','2013-07-16','11:25:00',6.59),('8975','2013-07-16','11:30:00',6.64),('8975','2013-07-16','11:35:00',6.66),('8975','2013-07-16','11:40:00',6.67),('8975','2013-07-16','11:45:00',6.67),('8975','2013-07-16','11:50:00',6.63),('8975','2013-07-16','11:55:00',6.66),('8975','2013-07-16','12:00:00',6.65),('8975','2013-07-16','12:05:00',6.66),('8975','2013-07-16','12:10:00',6.64),('8975','2013-07-16','12:15:00',6.67),('8975','2013-07-16','12:20:00',6.65),('8975','2013-07-16','12:25:00',6.64),('8975','2013-07-16','12:30:00',6.72),('8975','2013-07-16','12:35:00',6.67),('8975','2013-07-16','12:40:00',6.61),('8975','2013-07-16','12:45:00',6.61),('8975','2013-07-16','12:50:00',6.63),('8975','2013-07-16','12:55:00',6.64),('8975','2013-07-16','13:00:00',6.57),('8975','2013-07-16','13:05:00',6.49),('8975','2013-07-16','13:10:00',6.52),('8975','2013-07-16','13:15:00',6.45),('8975','2013-07-16','13:20:00',6.38),('8975','2013-07-16','13:25:00',6.38),('8975','2013-07-16','13:30:00',6.36),('8975','2013-07-16','13:35:00',6.32),('8975','2013-07-16','13:40:00',6.23),('8975','2013-07-16','13:45:00',6.22),('8975','2013-07-16','13:50:00',6.24),('8975','2013-07-16','13:55:00',6.2),('8975','2013-07-16','14:00:00',6.14),('8975','2013-07-16','14:05:00',6.08),('8975','2013-07-16','14:10:00',6.03),('8975','2013-07-16','14:15:00',6.02),('8975','2013-07-16','14:20:00',5.86),('8975','2013-07-16','14:25:00',5.87),('8975','2013-07-16','14:30:00',5.85),('8975','2013-07-16','14:35:00',5.83),('8975','2013-07-16','14:40:00',5.82),('8975','2013-07-16','14:45:00',5.64),('8975','2013-07-16','14:50:00',5.6),('8975','2013-07-16','14:55:00',5.58),('8975','2013-07-16','15:00:00',5.54),('8975','2013-07-16','15:05:00',5.36),('8975','2013-07-16','15:10:00',5.31),('8975','2013-07-16','15:15:00',5.23),('8975','2013-07-16','15:20:00',5.11),('8975','2013-07-16','15:25:00',5.13),('8975','2013-07-16','15:30:00',5.05),('8975','2013-07-16','15:35:00',5),('8975','2013-07-16','15:40:00',3.65),('8975','2013-07-16','15:45:00',4.77),('8975','2013-07-16','15:50:00',4.73),('8975','2013-07-16','15:55:00',3.13),('8975','2013-07-16','16:00:00',3.74),('8975','2013-07-16','16:05:00',4.4),('8975','2013-07-16','16:10:00',4.36),('8975','2013-07-16','16:15:00',3.41),('8975','2013-07-16','16:20:00',4.04),('8975','2013-07-16','16:25:00',3.89),('8975','2013-07-16','16:30:00',3.84),('8975','2013-07-16','16:35:00',3.93),('8975','2013-07-16','16:40:00',2.69),('8975','2013-07-16','16:45:00',3.55),('8975','2013-07-16','16:50:00',3.54),('8975','2013-07-16','16:55:00',3.11),('8975','2013-07-16','17:00:00',3.01),('8975','2013-07-16','17:05:00',3.15),('8975','2013-07-16','17:10:00',3.02),('8975','2013-07-16','17:15:00',2.91),('8975','2013-07-16','17:20:00',2.71),('8975','2013-07-16','17:25:00',2.54),('8975','2013-07-16','17:30:00',2.43),('8975','2013-07-16','17:35:00',2.34),('8975','2013-07-16','17:40:00',2.25),('8975','2013-07-16','17:45:00',2.13),('8975','2013-07-16','17:50:00',2.06),('8975','2013-07-16','17:55:00',1.94),('8975','2013-07-16','18:00:00',1.84),('8975','2013-07-16','18:05:00',1.76),('8975','2013-07-16','18:10:00',1.67),('8975','2013-07-16','18:15:00',1.58),('8975','2013-07-16','18:20:00',1.51),('8975','2013-07-16','18:25:00',1.44),('8975','2013-07-16','18:30:00',1.36),('8975','2013-07-16','18:35:00',1.3),('8975','2013-07-16','18:40:00',1.24),('8975','2013-07-16','18:45:00',1.17),('8975','2013-07-16','18:50:00',1.13),('8975','2013-07-16','18:55:00',1.07),('8975','2013-07-16','19:00:00',1.02),('8975','2013-07-15','06:35:00',1),('8975','2013-07-15','06:40:00',1.16),('8975','2013-07-15','06:45:00',1.29),('8975','2013-07-15','06:50:00',1.45),('8975','2013-07-15','06:55:00',1.59),('8975','2013-07-15','07:00:00',1.75),('8975','2013-07-15','07:05:00',1.92),('8975','2013-07-15','07:10:00',2.05),('8975','2013-07-15','07:15:00',2.17),('8975','2013-07-15','07:20:00',2.31),('8975','2013-07-15','07:25:00',2.43),('8975','2013-07-15','07:30:00',2.56),('8975','2013-07-15','07:35:00',2.7),('8975','2013-07-15','07:40:00',2.82),('8975','2013-07-15','07:45:00',2.92),('8975','2013-07-15','07:50:00',3.03),('8975','2013-07-15','07:55:00',3.12),('8975','2013-07-15','08:00:00',3.22),('8975','2013-07-15','08:05:00',3.28),('8975','2013-07-15','08:10:00',3.35),('8975','2013-07-15','08:15:00',3.49),('8975','2013-07-15','08:20:00',3.61),('8975','2013-07-15','08:25:00',3.72),('8975','2013-07-15','08:30:00',3.83),('8975','2013-07-15','08:35:00',3.95),('8975','2013-07-15','08:40:00',4.06),('8975','2013-07-15','08:45:00',4.18),('8975','2013-07-15','08:50:00',4.31),('8975','2013-07-15','08:55:00',4.37),('8975','2013-07-15','09:00:00',4.5),('8975','2013-07-15','09:05:00',4.59),('8975','2013-07-15','09:10:00',4.7),('8975','2013-07-15','09:15:00',4.79),('8975','2013-07-15','09:20:00',4.89),('8975','2013-07-15','09:25:00',4.96),('8975','2013-07-15','09:30:00',5.02),('8975','2013-07-15','09:35:00',5.11),('8975','2013-07-15','09:40:00',5.21),('8975','2013-07-15','09:45:00',5.26),('8975','2013-07-15','09:50:00',5.37),('8975','2013-07-15','09:55:00',5.49),('8975','2013-07-15','10:00:00',5.6),('8975','2013-07-15','10:05:00',5.7),('8975','2013-07-15','10:10:00',5.73),('8975','2013-07-15','10:15:00',5.75),('8975','2013-07-15','10:20:00',5.85),('8975','2013-07-15','10:25:00',5.9),('8975','2013-07-15','10:30:00',5.99),('8975','2013-07-15','10:35:00',5.96),('8975','2013-07-15','10:40:00',6.11),('8975','2013-07-15','10:45:00',6.13),('8975','2013-07-15','10:50:00',6.19),('8975','2013-07-15','10:55:00',6.24),('8975','2013-07-15','11:00:00',6.33),('8975','2013-07-15','11:05:00',6.39),('8975','2013-07-15','11:10:00',6.46),('8975','2013-07-15','11:15:00',6.47),('8975','2013-07-15','11:20:00',6.49),('8975','2013-07-15','11:25:00',6.47),('8975','2013-07-15','11:30:00',6.47),('8975','2013-07-15','11:35:00',6.49),('8975','2013-07-15','11:40:00',6.54),('8975','2013-07-15','11:45:00',6.58),('8975','2013-07-15','11:50:00',6.6),('8975','2013-07-15','11:55:00',6.62),('8975','2013-07-15','12:00:00',6.63),('8975','2013-07-15','12:05:00',6.64),('8975','2013-07-15','12:10:00',6.61),('8975','2013-07-15','12:15:00',6.62),('8975','2013-07-15','12:20:00',6.57),('8975','2013-07-15','12:25:00',6.58),('8975','2013-07-15','12:30:00',6.54),('8975','2013-07-15','12:35:00',6.53),('8975','2013-07-15','12:40:00',6.55),('8975','2013-07-15','12:45:00',6.57),('8975','2013-07-15','12:50:00',6.61),('8975','2013-07-15','12:55:00',6.51),('8975','2013-07-15','13:00:00',6.43),('8975','2013-07-15','13:05:00',6.41),('8975','2013-07-15','13:10:00',6.39),('8975','2013-07-15','13:15:00',6.29),('8975','2013-07-15','13:20:00',6.31),('8975','2013-07-15','13:25:00',6.26),('8975','2013-07-15','13:30:00',6.3),('8975','2013-07-15','13:35:00',6.25),('8975','2013-07-15','13:40:00',6.25),('8975','2013-07-15','13:45:00',6.33),('8975','2013-07-15','13:50:00',6.4),('8975','2013-07-15','13:55:00',6.26),('8975','2013-07-15','14:00:00',6.11),('8975','2013-07-15','14:05:00',6.17),('8975','2013-07-15','14:10:00',6.3),('8975','2013-07-15','14:15:00',4.86),('8975','2013-07-15','14:20:00',4.63),('8975','2013-07-15','14:25:00',5.04),('8975','2013-07-15','14:30:00',4.64),('8975','2013-07-15','14:35:00',5.8),('8975','2013-07-15','14:40:00',6.01),('8975','2013-07-15','14:45:00',5.77),('8975','2013-07-15','14:50:00',5.68),('8975','2013-07-15','14:55:00',5.62),('8975','2013-07-15','15:00:00',5.53),('8975','2013-07-15','15:05:00',5.47),('8975','2013-07-15','15:10:00',5.39),('8975','2013-07-15','15:15:00',5.3),('8975','2013-07-15','15:20:00',5.2),('8975','2013-07-15','15:25:00',5.13),('8975','2013-07-15','15:30:00',5.14),('8975','2013-07-15','15:35:00',5.2),('8975','2013-07-15','15:40:00',5.1),('8975','2013-07-15','15:45:00',4.92),('8975','2013-07-15','15:50:00',4.66),('8975','2013-07-15','15:55:00',4.5),('8975','2013-07-15','16:00:00',4.16),('8975','2013-07-15','16:05:00',3.94),('8975','2013-07-15','16:10:00',2.39),('8975','2013-07-15','16:15:00',1.55),('8975','2013-07-15','16:20:00',2.37),('8975','2013-07-15','16:25:00',2.19),('8975','2013-07-15','16:30:00',1.72),('8975','2013-07-15','16:45:00',1.26),('8975','2013-07-15','16:50:00',1.82),('8975','2013-07-15','16:55:00',2.61),('8975','2013-07-15','17:00:00',2.41),('8975','2013-07-15','17:05:00',3.21),('8975','2013-07-15','17:10:00',3.32),('8975','2013-07-15','17:15:00',2.69),('8975','2013-07-15','17:20:00',2.55),('8975','2013-07-15','17:25:00',2.41),('8975','2013-07-15','17:30:00',2.87),('8975','2013-07-15','17:35:00',2.15),('8975','2013-07-15','17:40:00',2.54),('8975','2013-07-15','17:45:00',2.57),('8975','2013-07-15','17:50:00',2.35),('8975','2013-07-15','17:55:00',1.97),('8975','2013-07-15','18:00:00',1.8),('8975','2013-07-15','18:05:00',1.37),('8975','2013-07-15','18:10:00',1.52),('8975','2013-07-15','18:15:00',1.64),('8975','2013-07-15','18:20:00',1.32),('8975','2013-07-15','18:25:00',1.34),('8975','2013-07-15','18:30:00',1.34),('8975','2013-07-15','18:35:00',1.3),('8975','2013-07-15','18:40:00',1.25),('8975','2013-07-15','18:45:00',1.18),('8975','2013-07-15','18:50:00',1.11),('8975','2013-07-14','06:40:00',1.18),('8975','2013-07-14','06:45:00',1.35),('8975','2013-07-14','06:50:00',1.53),('8975','2013-07-14','06:55:00',1.68),('8975','2013-07-14','07:00:00',1.83),('8975','2013-07-14','07:05:00',1.99),('8975','2013-07-14','07:10:00',2.13),('8975','2013-07-14','07:15:00',2.29),('8975','2013-07-14','07:20:00',2.41),('8975','2013-07-14','07:25:00',2.54),('8975','2013-07-14','07:30:00',2.67),('8975','2013-07-14','07:35:00',2.8),('8975','2013-07-14','07:40:00',2.93),('8975','2013-07-14','07:45:00',3.05),('8975','2013-07-14','07:50:00',3.17),('8975','2013-07-14','07:55:00',3.27),('8975','2013-07-14','08:00:00',3.38),('8975','2013-07-14','08:05:00',3.48),('8975','2013-07-14','08:10:00',3.57),('8975','2013-07-14','08:15:00',3.72),('8975','2013-07-14','08:20:00',3.83),('8975','2013-07-14','08:25:00',3.94),('8975','2013-07-14','08:30:00',4.05),('8975','2013-07-14','08:35:00',4.17),('8975','2013-07-14','08:40:00',4.28),('8975','2013-07-14','08:45:00',4.39),('8975','2013-07-14','08:50:00',4.49),('8975','2013-07-14','08:55:00',4.61),('8975','2013-07-14','09:00:00',4.68),('8975','2013-07-14','09:05:00',4.77),('8975','2013-07-14','09:10:00',4.85),('8975','2013-07-14','09:15:00',4.98),('8975','2013-07-14','09:20:00',5.04),('8975','2013-07-14','09:25:00',5.13),('8975','2013-07-14','09:30:00',5.21),('8975','2013-07-14','09:35:00',5.33),('8975','2013-07-14','09:40:00',5.41),('8975','2013-07-14','09:45:00',5.44),('8975','2013-07-14','09:50:00',5.52),('8975','2013-07-14','09:55:00',5.61),('8975','2013-07-14','10:00:00',5.69),('8975','2013-07-14','10:05:00',5.73),('8975','2013-07-14','10:10:00',5.78),('8975','2013-07-14','10:15:00',5.83),('8975','2013-07-14','10:20:00',5.88),('8975','2013-07-14','10:25:00',5.92),('8975','2013-07-14','10:30:00',5.63),('8975','2013-07-14','10:35:00',5.89),('8975','2013-07-14','10:40:00',5.71),('8975','2013-07-14','10:45:00',5.78),('8975','2013-07-14','10:50:00',6.02),('8975','2013-07-14','10:55:00',5.79),('8975','2013-07-14','11:00:00',5.77),('8975','2013-07-14','11:05:00',5.7),('8975','2013-07-14','11:10:00',5),('8975','2013-07-14','11:15:00',5.17),('8975','2013-07-14','11:20:00',6.07),('8975','2013-07-14','11:25:00',5.82),('8975','2013-07-14','11:30:00',6.26),('8975','2013-07-14','11:35:00',6.47),('8975','2013-07-14','11:40:00',6.5),('8975','2013-07-14','11:45:00',6.51),('8975','2013-07-14','11:50:00',6.53),('8975','2013-07-14','11:55:00',6.56),('8975','2013-07-14','12:00:00',6.47),('8975','2013-07-14','12:05:00',6.43),('8975','2013-07-14','12:10:00',6.39),('8975','2013-07-14','12:15:00',6.56),('8975','2013-07-14','12:20:00',6.49),('8975','2013-07-14','12:25:00',6.57),('8975','2013-07-14','12:30:00',6.52),('8975','2013-07-14','12:35:00',6.51),('8975','2013-07-14','12:40:00',6.53),('8975','2013-07-14','12:45:00',6.54),('8975','2013-07-14','12:50:00',6.52),('8975','2013-07-14','12:55:00',6.55),('8975','2013-07-14','13:00:00',6.52),('8975','2013-07-14','13:05:00',6.55),('8975','2013-07-14','13:10:00',6.34),('8975','2013-07-14','13:15:00',6.36),('8975','2013-07-14','13:20:00',6.54),('8975','2013-07-14','13:25:00',6.6),('8975','2013-07-14','13:30:00',3.73),('8975','2013-07-14','13:35:00',1.67),('8975','2013-07-14','13:40:00',6.42),('8975','2013-07-14','13:45:00',4.19),('8975','2013-07-14','13:50:00',4.93),('8975','2013-07-14','13:55:00',3.13),('8975','2013-07-14','14:00:00',3.43),('8975','2013-07-14','14:05:00',6.26),('8975','2013-07-14','14:10:00',6.67),('8975','2013-07-14','14:15:00',5.17),('8975','2013-07-14','14:20:00',3.35),('8975','2013-07-14','14:25:00',3.45),('8975','2013-07-14','14:30:00',5.81),('8975','2013-07-14','14:35:00',6.27),('8975','2013-07-14','14:40:00',6.18),('8975','2013-07-14','14:45:00',5.08),('8975','2013-07-14','14:50:00',1.75),('8975','2013-07-14','14:55:00',5.31),('8975','2013-07-14','15:00:00',6.09),('8975','2013-07-14','15:05:00',3.76),('8975','2013-07-14','15:10:00',4.88),('8975','2013-07-14','15:15:00',5.59),('8975','2013-07-14','15:20:00',5.4),('8975','2013-07-14','15:25:00',5.27),('8975','2013-07-14','15:30:00',3.88),('8975','2013-07-14','15:35:00',5.04),('8975','2013-07-14','15:40:00',3.83),('8975','2013-07-14','15:45:00',5.17),('8975','2013-07-14','15:50:00',5),('8975','2013-07-14','15:55:00',4.77),('8975','2013-07-14','16:00:00',4.53),('8975','2013-07-14','16:05:00',4.4),('8975','2013-07-14','16:10:00',4.32),('8975','2013-07-14','16:15:00',4.17),('8975','2013-07-14','16:20:00',4.07),('8975','2013-07-14','16:25:00',3.96),('8975','2013-07-14','16:30:00',3.9),('8975','2013-07-14','16:35:00',3.74),('8975','2013-07-14','16:40:00',3.61),('8975','2013-07-14','16:45:00',3.51),('8975','2013-07-14','16:50:00',3.4),('8975','2013-07-14','16:55:00',3.31),('8975','2013-07-14','17:00:00',3.2),('8975','2013-07-14','17:05:00',3.07),('8975','2013-07-14','17:10:00',2.94),('8975','2013-07-14','17:15:00',2.83),('8975','2013-07-14','17:20:00',2.71),('8975','2013-07-14','17:25:00',2.61),('8975','2013-07-14','17:30:00',2.48),('8975','2013-07-14','17:35:00',2.36),('8975','2013-07-14','17:40:00',2.26),('8975','2013-07-14','17:45:00',2.14),('8975','2013-07-14','17:50:00',2.06),('8975','2013-07-14','17:55:00',1.96),('8975','2013-07-14','18:00:00',1.86),('8975','2013-07-14','18:05:00',1.76),('8975','2013-07-14','18:10:00',1.67),('8975','2013-07-14','18:15:00',1.59),('8975','2013-07-14','18:20:00',1.51),('8975','2013-07-14','18:25:00',1.45),('8975','2013-07-14','18:30:00',1.37),('8975','2013-07-14','18:35:00',1.3),('8975','2013-07-14','18:40:00',1.24),('8975','2013-07-14','18:45:00',1.18),('8975','2013-07-14','18:50:00',1.15),('8975','2013-07-14','18:55:00',1.09),('8975','2013-07-14','19:00:00',1.06),('8975','2013-07-14','19:05:00',1.01),('8975','2013-07-13','07:30:00',1.01),('8975','2013-07-13','07:35:00',1.62),('8975','2013-07-13','07:40:00',2.4),('8975','2013-07-13','07:45:00',2.58),('8975','2013-07-13','07:50:00',3.14),('8975','2013-07-13','07:55:00',3.34),('8975','2013-07-13','08:00:00',3.33),('8975','2013-07-13','08:05:00',2.83),('8975','2013-07-13','08:10:00',3.32),('8975','2013-07-13','08:15:00',4.17),('8975','2013-07-13','08:20:00',4.03),('8975','2013-07-13','08:25:00',2.92),('8975','2013-07-13','08:30:00',1.98),('8975','2013-07-13','08:35:00',2.15),('8975','2013-07-13','08:40:00',1.71),('8975','2013-07-13','08:45:00',1.48),('8975','2013-07-13','08:50:00',1.45),('8975','2013-07-13','08:55:00',2.72),('8975','2013-07-13','09:00:00',2.79),('8975','2013-07-13','09:05:00',3.12),('8975','2013-07-13','09:10:00',3.81),('8975','2013-07-13','09:15:00',4.17),('8975','2013-07-13','09:20:00',3),('8975','2013-07-13','09:25:00',4.05),('8975','2013-07-13','09:30:00',3.81),('8975','2013-07-13','09:35:00',3.96),('8975','2013-07-13','09:40:00',3.72),('8975','2013-07-13','09:45:00',3.05),('8975','2013-07-13','09:50:00',2.94),('8975','2013-07-13','09:55:00',2.67),('8975','2013-07-13','10:00:00',2.76),('8975','2013-07-13','10:05:00',3.05),('8975','2013-07-13','10:10:00',3.13),('8975','2013-07-13','10:15:00',3.07),('8975','2013-07-13','10:20:00',3.27),('8975','2013-07-13','10:25:00',4.76),('8975','2013-07-13','10:30:00',6.25),('8975','2013-07-13','10:35:00',6.26),('8975','2013-07-13','10:40:00',5.75),('8975','2013-07-13','10:45:00',5.25),('8975','2013-07-13','10:50:00',5.25),('8975','2013-07-13','10:55:00',6.48),('8975','2013-07-13','11:00:00',2.67),('8975','2013-07-13','11:05:00',3.9),('8975','2013-07-13','11:10:00',5),('8975','2013-07-13','11:15:00',2.91),('8975','2013-07-13','11:20:00',2.83),('8975','2013-07-13','11:25:00',2.65),('8975','2013-07-13','11:30:00',4.64),('8975','2013-07-13','11:35:00',7.76),('8975','2013-07-13','11:40:00',7.72),('8975','2013-07-13','11:45:00',7.63),('8975','2013-07-13','11:50:00',5.15),('8975','2013-07-13','11:55:00',5.33),('8975','2013-07-13','12:00:00',5.74),('8975','2013-07-13','12:05:00',5.69),('8975','2013-07-13','12:10:00',3.99),('8975','2013-07-13','12:15:00',2.47),('8975','2013-07-13','12:20:00',2.08),('8975','2013-07-13','12:25:00',2.46),('8975','2013-07-13','12:30:00',7.68),('8975','2013-07-13','12:35:00',7.49),('8975','2013-07-13','12:40:00',7.27),('8975','2013-07-13','12:45:00',7.17),('8975','2013-07-13','12:50:00',4.87),('8975','2013-07-13','12:55:00',6.25),('8975','2013-07-13','13:00:00',7.25),('8975','2013-07-13','13:05:00',7.03),('8975','2013-07-13','13:10:00',7.13),('8975','2013-07-13','13:15:00',7.01),('8975','2013-07-13','13:20:00',6.83),('8975','2013-07-13','13:25:00',6.56),('8975','2013-07-13','13:30:00',6.65),('8975','2013-07-13','13:35:00',6.57),('8975','2013-07-13','13:40:00',6.55),('8975','2013-07-13','13:45:00',6.56),('8975','2013-07-13','13:50:00',6.51),('8975','2013-07-13','13:55:00',6.47),('8975','2013-07-13','14:00:00',6.41),('8975','2013-07-13','14:05:00',6.48),('8975','2013-07-13','14:10:00',6.43),('8975','2013-07-13','14:15:00',6.39),('8975','2013-07-13','14:20:00',6.37),('8975','2013-07-13','14:25:00',6.26),('8975','2013-07-13','14:30:00',6.12),('8975','2013-07-13','14:35:00',6.03),('8975','2013-07-13','14:40:00',5.94),('8975','2013-07-13','14:45:00',5.84),('8975','2013-07-13','14:50:00',5.76),('8975','2013-07-13','14:55:00',5.61),('8975','2013-07-13','15:00:00',5.54),('8975','2013-07-13','15:05:00',5.46),('8975','2013-07-13','15:10:00',5.38),('8975','2013-07-13','15:15:00',5.34),('8975','2013-07-13','15:20:00',5.26),('8975','2013-07-13','15:25:00',5.14),('8975','2013-07-13','15:30:00',5.09),('8975','2013-07-13','15:35:00',5.01),('8975','2013-07-13','15:40:00',4.88),('8975','2013-07-13','15:45:00',4.78),('8975','2013-07-13','15:50:00',4.62),('8975','2013-07-13','15:55:00',4.64),('8975','2013-07-13','16:00:00',4.55),('8975','2013-07-13','16:05:00',4.42),('8975','2013-07-13','16:10:00',4.37),('8975','2013-07-13','16:15:00',4.35),('8975','2013-07-13','16:20:00',4.33),('8975','2013-07-13','16:25:00',3.59),('8975','2013-07-13','16:30:00',4.2),('8975','2013-07-13','16:35:00',4.06),('8975','2013-07-13','16:40:00',3.25),('8975','2013-07-13','16:45:00',3.19),('8975','2013-07-13','16:50:00',3.31),('8975','2013-07-13','16:55:00',3.67),('8975','2013-07-13','17:00:00',3.47),('8975','2013-07-13','17:05:00',3.33),('8975','2013-07-13','17:10:00',2.98),('8975','2013-07-13','17:15:00',3.1),('8975','2013-07-13','17:20:00',1.78),('8975','2013-07-13','17:25:00',2.7),('8975','2013-07-13','17:30:00',3.21),('8975','2013-07-13','17:35:00',2.93),('8975','2013-07-13','17:40:00',2.6),('8975','2013-07-13','17:45:00',2.13),('8975','2013-07-13','17:50:00',2.01),('8975','2013-07-13','17:55:00',2.23),('8975','2013-07-13','18:00:00',2.15),('8975','2013-07-13','18:05:00',1.94),('8975','2013-07-13','18:10:00',1.61),('8975','2013-07-13','18:45:00',1.22),('8975','2013-07-13','18:50:00',1.13),('8975','2013-07-13','19:10:00',1),('8975','2013-07-13','19:15:00',1.14),('8975','2013-07-13','19:20:00',1.3),('8975','2013-07-12','07:10:00',1.44),('8975','2013-07-12','07:15:00',1.69),('8975','2013-07-12','07:20:00',1.77),('8975','2013-07-12','07:25:00',1.72),('8975','2013-07-12','07:30:00',2.09),('8975','2013-07-12','07:35:00',2.03),('8975','2013-07-12','07:40:00',2.28),('8975','2013-07-12','07:45:00',2.33),('8975','2013-07-12','07:50:00',2.49),('8975','2013-07-12','07:55:00',2.51),('8975','2013-07-12','08:00:00',2.89),('8975','2013-07-12','08:05:00',2.7),('8975','2013-07-12','08:10:00',2.89),('8975','2013-07-12','08:15:00',3.35),('8975','2013-07-12','08:20:00',3.63),('8975','2013-07-12','08:25:00',3.72),('8975','2013-07-12','08:30:00',3.79),('8975','2013-07-12','08:35:00',3.89),('8975','2013-07-12','08:40:00',4.08),('8975','2013-07-12','08:45:00',4.13),('8975','2013-07-12','08:50:00',4.25),('8975','2013-07-12','08:55:00',4.34),('8975','2013-07-12','09:00:00',4.44),('8975','2013-07-12','09:05:00',4.52),('8975','2013-07-12','09:10:00',4.56),('8975','2013-07-12','09:15:00',4.65),('8975','2013-07-12','09:20:00',4.76),('8975','2013-07-12','09:25:00',4.96),('8975','2013-07-12','09:30:00',4.91),('8975','2013-07-12','09:35:00',5.02),('8975','2013-07-12','09:40:00',5.14),('8975','2013-07-12','09:45:00',5.24),('8975','2013-07-12','09:50:00',5.22),('8975','2013-07-12','09:55:00',5.27),('8975','2013-07-12','10:00:00',5.45),('8975','2013-07-12','10:05:00',5.54),('8975','2013-07-12','10:10:00',5.59),('8975','2013-07-12','10:15:00',5.61),('8975','2013-07-12','10:20:00',5.78),('8975','2013-07-12','10:25:00',5.95),('8975','2013-07-12','10:30:00',5.86),('8975','2013-07-12','10:35:00',5.74),('8975','2013-07-12','10:40:00',5.8),('8975','2013-07-12','10:45:00',6.29),('8975','2013-07-12','10:50:00',6.74),('8975','2013-07-12','10:55:00',5.91),('8975','2013-07-12','11:00:00',3.75),('8975','2013-07-12','11:05:00',2.82),('8975','2013-07-12','11:10:00',5.96),('8975','2013-07-12','11:15:00',2.64),('8975','2013-07-12','11:20:00',5.77),('8975','2013-07-12','11:25:00',3.02),('8975','2013-07-12','11:30:00',1.78),('8975','2013-07-12','11:35:00',5.39),('8975','2013-07-12','11:40:00',7.1),('8975','2013-07-12','11:45:00',6.91),('8975','2013-07-12','11:50:00',4.41),('8975','2013-07-12','11:55:00',7.05),('8975','2013-07-12','12:00:00',7.07),('8975','2013-07-12','12:05:00',6.96),('8975','2013-07-12','12:10:00',6.9),('8975','2013-07-12','12:15:00',6.38),('8975','2013-07-12','12:20:00',2.31),('8975','2013-07-12','12:25:00',2.61),('8975','2013-07-12','12:30:00',7.09),('8975','2013-07-12','12:35:00',4.29),('8975','2013-07-12','12:40:00',3.63),('8975','2013-07-12','12:45:00',7.14),('8975','2013-07-12','12:50:00',6.49),('8975','2013-07-12','12:55:00',3.25),('8975','2013-07-12','13:00:00',7.02),('8975','2013-07-12','13:05:00',6.79),('8975','2013-07-12','13:10:00',6.84),('8975','2013-07-12','13:15:00',6.71),('8975','2013-07-12','13:20:00',6.69),('8975','2013-07-12','13:25:00',6.55),('8975','2013-07-12','13:30:00',6.47),('8975','2013-07-12','13:35:00',6.46),('8975','2013-07-12','13:40:00',6.46),('8975','2013-07-12','13:45:00',6.43),('8975','2013-07-12','13:50:00',6.4),('8975','2013-07-12','13:55:00',6.31),('8975','2013-07-12','14:00:00',6.29),('8975','2013-07-12','14:05:00',6.21),('8975','2013-07-12','14:10:00',6.19),('8975','2013-07-12','14:15:00',6.14),('8975','2013-07-12','14:20:00',6.05),('8975','2013-07-12','14:25:00',6.03),('8975','2013-07-12','14:30:00',5.98),('8975','2013-07-12','14:35:00',5.92),('8975','2013-07-12','14:40:00',5.91),('8975','2013-07-12','14:45:00',5.86),('8975','2013-07-12','14:50:00',5.77),('8975','2013-07-12','14:55:00',5.73),('8975','2013-07-12','15:00:00',5.65),('8975','2013-07-12','15:05:00',5.56),('8975','2013-07-12','15:10:00',5.52),('8975','2013-07-12','15:15:00',5.48),('8975','2013-07-12','15:20:00',5.18),('8975','2013-07-12','15:25:00',5.34),('8975','2013-07-12','15:30:00',4.79),('8975','2013-07-12','15:35:00',5.13),('8975','2013-07-12','15:40:00',5.06),('8975','2013-07-12','15:45:00',4.94),('8975','2013-07-12','15:50:00',4.82),('8975','2013-07-12','15:55:00',4.72),('8975','2013-07-12','16:00:00',4.61),('8975','2013-07-12','16:05:00',4.49),('8975','2013-07-12','16:10:00',4.4),('8975','2013-07-12','16:15:00',4.29),('8975','2013-07-12','16:20:00',4.12),('8975','2013-07-12','16:25:00',4.11),('8975','2013-07-12','16:30:00',3.98),('8975','2013-07-12','16:35:00',3.87),('8975','2013-07-12','16:40:00',3.74),('8975','2013-07-12','16:45:00',3.65),('8975','2013-07-12','16:50:00',3.5),('8975','2013-07-12','16:55:00',3.4),('8975','2013-07-12','17:00:00',3.26),('8975','2013-07-12','17:05:00',3.03),('8975','2013-07-12','17:10:00',3.03),('8975','2013-07-12','17:15:00',2.88),('8975','2013-07-12','17:20:00',2.71),('8975','2013-07-12','17:25:00',2.66),('8975','2013-07-12','17:30:00',2.49),('8975','2013-07-12','17:35:00',2.41),('8975','2013-07-12','17:40:00',2.32),('8975','2013-07-12','17:45:00',2.2),('8975','2013-07-12','17:50:00',2.07),('8975','2013-07-12','17:55:00',2.1),('8975','2013-07-12','18:00:00',1.92),('8975','2013-07-12','18:05:00',1.78),('8975','2013-07-12','18:10:00',1.77),('8975','2013-07-12','18:15:00',1.69),('8975','2013-07-12','18:20:00',1.6),('8975','2013-07-12','18:25:00',1.56),('8975','2013-07-12','18:30:00',1.46),('8975','2013-07-12','18:35:00',1.4),('8975','2013-07-12','18:40:00',1.14),('8975','2013-07-12','18:50:00',1.03),('8975','2013-07-12','18:55:00',1.28),('8975','2013-07-12','19:00:00',1.16),('8975','2013-07-12','19:05:00',1.07),('8975','2013-07-12','19:10:00',1.01),('8975','2013-07-11','06:55:00',1.07),('8975','2013-07-11','07:00:00',1.18),('8975','2013-07-11','07:05:00',1.16),('8975','2013-07-11','07:10:00',1.08),('8975','2013-07-11','07:15:00',1.48),('8975','2013-07-11','07:20:00',1.66),('8975','2013-07-11','07:25:00',1.64),('8975','2013-07-11','07:30:00',1.26),('8975','2013-07-11','07:35:00',1.13),('8975','2013-07-11','07:45:00',1.25),('8975','2013-07-11','07:50:00',1.06),('8975','2013-07-11','07:55:00',1.1),('8975','2013-07-11','08:00:00',1.47),('8975','2013-07-11','08:05:00',1.6),('8975','2013-07-11','08:10:00',1.87),('8975','2013-07-11','08:15:00',2.04),('8975','2013-07-11','08:20:00',2.34),('8975','2013-07-11','08:25:00',1.69),('8975','2013-07-11','08:30:00',1.39),('8975','2013-07-11','08:35:00',1.63),('8975','2013-07-11','08:40:00',2.05),('8975','2013-07-11','08:45:00',2.52),('8975','2013-07-11','08:50:00',1.96),('8975','2013-07-11','08:55:00',1.14),('8975','2013-07-11','09:00:00',1.06),('8975','2013-07-11','09:05:00',1.68),('8975','2013-07-11','09:10:00',1.79),('8975','2013-07-11','09:15:00',2.3),('8975','2013-07-11','09:20:00',3.05),('8975','2013-07-11','09:25:00',4.4),('8975','2013-07-11','09:30:00',4.28),('8975','2013-07-11','09:35:00',5.11),('8975','2013-07-11','09:40:00',5.41),('8975','2013-07-11','09:45:00',4.88),('8975','2013-07-11','09:50:00',5.01),('8975','2013-07-11','09:55:00',4.37),('8975','2013-07-11','10:00:00',4.04),('8975','2013-07-11','10:05:00',3.94),('8975','2013-07-11','10:10:00',4.26),('8975','2013-07-11','10:15:00',5.57),('8975','2013-07-11','10:20:00',6.14),('8975','2013-07-11','10:25:00',5.98),('8975','2013-07-11','10:30:00',5.54),('8975','2013-07-11','10:35:00',3.99),('8975','2013-07-11','10:40:00',2.03),('8975','2013-07-11','10:45:00',6.11),('8975','2013-07-11','10:50:00',6.21),('8975','2013-07-11','10:55:00',6.75),('8975','2013-07-11','11:00:00',3.08),('8975','2013-07-11','11:05:00',5.38),('8975','2013-07-11','11:10:00',6.42),('8975','2013-07-11','11:15:00',5.55),('8975','2013-07-11','11:20:00',5.89),('8975','2013-07-11','11:25:00',4.66),('8975','2013-07-11','11:30:00',2.73),('8975','2013-07-11','11:35:00',3.39),('8975','2013-07-11','11:40:00',3.5),('8975','2013-07-11','11:45:00',5.51),('8975','2013-07-11','11:50:00',5.03),('8975','2013-07-11','11:55:00',1.77),('8975','2013-07-11','12:00:00',4.74),('8975','2013-07-11','12:05:00',7.38),('8975','2013-07-11','12:10:00',7.37),('8975','2013-07-11','12:15:00',5.86),('8975','2013-07-11','12:20:00',7.62),('8975','2013-07-11','12:25:00',7.27),('8975','2013-07-11','12:30:00',7.44),('8975','2013-07-11','12:35:00',5.36),('8975','2013-07-11','12:40:00',7.33),('8975','2013-07-11','12:45:00',7.38),('8975','2013-07-11','12:50:00',7.32),('8975','2013-07-11','12:55:00',6.82),('8975','2013-07-11','13:00:00',6.91),('8975','2013-07-11','13:05:00',6.8),('8975','2013-07-11','13:10:00',6.61),('8975','2013-07-11','13:15:00',6.77),('8975','2013-07-11','13:20:00',6.49),('8975','2013-07-11','13:25:00',6.53),('8975','2013-07-11','13:30:00',6.58),('8975','2013-07-11','13:35:00',6.37),('8975','2013-07-11','13:40:00',6.68),('8975','2013-07-11','13:45:00',6.46),('8975','2013-07-11','13:50:00',6.51),('8975','2013-07-11','13:55:00',6.44),('8975','2013-07-11','14:00:00',6.06),('8975','2013-07-11','14:05:00',5.11),('8975','2013-07-11','14:10:00',3.47),('8975','2013-07-11','14:15:00',2.53),('8975','2013-07-11','14:20:00',6.86),('8975','2013-07-11','14:25:00',4.93),('8975','2013-07-11','14:30:00',6.29),('8975','2013-07-11','14:35:00',4.33),('8975','2013-07-11','14:40:00',5.99),('8975','2013-07-11','14:45:00',5.87),('8975','2013-07-11','14:50:00',5.73),('8975','2013-07-11','14:55:00',5.63),('8975','2013-07-11','15:00:00',5.54),('8975','2013-07-11','15:05:00',5.39),('8975','2013-07-11','15:10:00',5.45),('8975','2013-07-11','15:15:00',5.46),('8975','2013-07-11','15:20:00',4.36),('8975','2013-07-11','15:25:00',5.19),('8975','2013-07-11','15:30:00',5.24),('8975','2013-07-11','15:35:00',5.05),('8975','2013-07-11','15:40:00',5.02),('8975','2013-07-11','15:45:00',4.82),('8975','2013-07-11','15:50:00',4.72),('8975','2013-07-11','15:55:00',4.57),('8975','2013-07-11','16:00:00',4.43),('8975','2013-07-11','16:05:00',4.4),('8975','2013-07-11','16:10:00',4.23),('8975','2013-07-11','16:15:00',4.12),('8975','2013-07-11','16:20:00',4.03),('8975','2013-07-11','16:25:00',3.92),('8975','2013-07-11','16:30:00',3.85),('8975','2013-07-11','16:35:00',3.75),('8975','2013-07-11','16:40:00',3.7),('8975','2013-07-11','16:45:00',3.59),('8975','2013-07-11','16:50:00',3.46),('8975','2013-07-11','16:55:00',3.32),('8975','2013-07-11','17:00:00',3.21),('8975','2013-07-11','17:05:00',3.1),('8975','2013-07-11','17:10:00',2.98),('8975','2013-07-11','17:15:00',2.83),('8975','2013-07-11','17:20:00',2.73),('8975','2013-07-11','17:25:00',2.6),('8975','2013-07-11','17:30:00',2.48),('8975','2013-07-11','17:35:00',2.38),('8975','2013-07-11','17:40:00',2.26),('8975','2013-07-11','17:45:00',2.16),('8975','2013-07-11','17:50:00',2.1),('8975','2013-07-11','17:55:00',1.98),('8975','2013-07-11','18:00:00',1.91),('8975','2013-07-11','18:05:00',1.79),('8975','2013-07-11','18:10:00',1.72),('8975','2013-07-11','18:15:00',1.64),('8975','2013-07-11','18:20:00',1.56),('8975','2013-07-11','18:25:00',1.51),('8975','2013-07-11','18:30:00',1.42),('8975','2013-07-11','18:35:00',1.37),('8975','2013-07-11','18:40:00',1.32),('8975','2013-07-11','18:45:00',1.25),('8975','2013-07-11','18:50:00',1.17),('8975','2013-07-11','18:55:00',1.12),('8975','2013-07-11','19:00:00',1.07),('8975','2013-07-11','19:05:00',1.01),('8975','2013-07-10','06:45:00',1.07),('8975','2013-07-10','06:50:00',1.22),('8975','2013-07-10','06:55:00',1.32),('8975','2013-07-10','07:00:00',1.45),('8975','2013-07-10','07:05:00',1.59),('8975','2013-07-10','07:10:00',1.74),('8975','2013-07-10','07:15:00',1.83),('8975','2013-07-10','07:20:00',1.98),('8975','2013-07-10','07:25:00',2.15),('8975','2013-07-10','07:30:00',2.37),('8975','2013-07-10','07:35:00',2.49),('8975','2013-07-10','07:40:00',2.62),('8975','2013-07-10','07:45:00',2.78),('8975','2013-07-10','07:50:00',2.89),('8975','2013-07-10','07:55:00',3.01),('8975','2013-07-10','08:00:00',3.16),('8975','2013-07-10','08:05:00',3.27),('8975','2013-07-10','08:10:00',3.34),('8975','2013-07-10','08:15:00',3.47),('8975','2013-07-10','08:20:00',3.61),('8975','2013-07-10','08:25:00',3.67),('8975','2013-07-10','08:30:00',3.76),('8975','2013-07-10','08:35:00',3.88),('8975','2013-07-10','08:40:00',4),('8975','2013-07-10','08:45:00',3.94),('8975','2013-07-10','08:50:00',4.01),('8975','2013-07-10','08:55:00',4.4),('8975','2013-07-10','09:00:00',4.37),('8975','2013-07-10','09:05:00',4.65),('8975','2013-07-10','09:10:00',3.46),('8975','2013-07-10','09:15:00',3.73),('8975','2013-07-10','09:20:00',4.33),('8975','2013-07-10','09:25:00',4.55),('8975','2013-07-10','09:30:00',5),('8975','2013-07-10','09:35:00',5.11),('8975','2013-07-10','09:40:00',5.38),('8975','2013-07-10','09:45:00',5.37),('8975','2013-07-10','09:50:00',5.13),('8975','2013-07-10','09:55:00',5.59),('8975','2013-07-10','10:00:00',5.21),('8975','2013-07-10','10:05:00',4.76),('8975','2013-07-10','10:10:00',5.83),('8975','2013-07-10','10:15:00',3.34),('8975','2013-07-10','10:20:00',2.67),('8975','2013-07-10','10:25:00',2.56),('8975','2013-07-10','10:30:00',4.77),('8975','2013-07-10','10:35:00',3.5),('8975','2013-07-10','10:40:00',6.04),('8975','2013-07-10','10:45:00',6.55),('8975','2013-07-10','10:50:00',6.72),('8975','2013-07-10','10:55:00',5.37),('8975','2013-07-10','11:00:00',1.8),('8975','2013-07-10','11:05:00',3.01),('8975','2013-07-10','11:10:00',6.92),('8975','2013-07-10','11:15:00',7.07),('8975','2013-07-10','11:20:00',3.96),('8975','2013-07-10','11:25:00',5.4),('8975','2013-07-10','11:30:00',6.78),('8975','2013-07-10','11:35:00',5.68),('8975','2013-07-10','11:40:00',6.94),('8975','2013-07-10','11:45:00',3.29),('8975','2013-07-10','11:50:00',2.12),('8975','2013-07-10','11:55:00',5.58),('8975','2013-07-10','12:00:00',7.06),('8975','2013-07-10','12:05:00',2.24),('8975','2013-07-10','12:10:00',2.06),('8975','2013-07-10','12:15:00',5.05),('8975','2013-07-10','12:20:00',7.26),('8975','2013-07-10','12:25:00',3.31),('8975','2013-07-10','12:30:00',2.97),('8975','2013-07-10','12:35:00',3.41),('8975','2013-07-10','12:40:00',5.84),('8975','2013-07-10','12:45:00',5.71),('8975','2013-07-10','12:50:00',6.65),('8975','2013-07-10','12:55:00',3.85),('8975','2013-07-10','13:00:00',7.28),('8975','2013-07-10','13:05:00',6.26),('8975','2013-07-10','13:10:00',6.11),('8975','2013-07-10','13:15:00',6.08),('8975','2013-07-10','13:20:00',5.71),('8975','2013-07-10','13:25:00',6.46),('8975','2013-07-10','13:30:00',3.57),('8975','2013-07-10','13:35:00',5.93),('8975','2013-07-10','13:40:00',7.12),('8975','2013-07-10','13:45:00',6.88),('8975','2013-07-10','13:50:00',7.02),('8975','2013-07-10','13:55:00',6.65),('8975','2013-07-10','14:00:00',4.54),('8975','2013-07-10','14:05:00',5.64),('8975','2013-07-10','14:10:00',6.63),('8975','2013-07-10','14:15:00',6.25),('8975','2013-07-10','14:20:00',6.63),('8975','2013-07-10','14:25:00',6.24),('8975','2013-07-10','14:30:00',6.28),('8975','2013-07-10','14:35:00',4.08),('8975','2013-07-10','14:40:00',5.76),('8975','2013-07-10','14:45:00',5.98),('8975','2013-07-10','14:50:00',4.51),('8975','2013-07-10','14:55:00',6.11),('8975','2013-07-10','15:00:00',3.53),('8975','2013-07-10','15:05:00',4.36),('8975','2013-07-10','15:10:00',5.68),('8975','2013-07-10','15:15:00',6.05),('8975','2013-07-10','15:20:00',5.44),('8975','2013-07-10','15:25:00',3.85),('8975','2013-07-10','15:30:00',4.33),('8975','2013-07-10','15:35:00',5.01),('8975','2013-07-10','15:40:00',4.66),('8975','2013-07-10','15:45:00',3.2),('8975','2013-07-10','15:50:00',5.04),('8975','2013-07-10','15:55:00',3.21),('8975','2013-07-10','16:00:00',3.33),('8975','2013-07-10','16:05:00',4.54),('8975','2013-07-10','16:10:00',5.05),('8975','2013-07-10','16:15:00',4.05),('8975','2013-07-10','16:20:00',3.35),('8975','2013-07-10','16:25:00',4.78),('8975','2013-07-10','16:30:00',3.65),('8975','2013-07-10','16:35:00',4.15),('8975','2013-07-10','16:40:00',3.41),('8975','2013-07-10','16:45:00',2.84),('8975','2013-07-10','16:50:00',2.67),('8975','2013-07-10','16:55:00',3.63),('8975','2013-07-10','17:00:00',2.94),('8975','2013-07-10','17:05:00',3.62),('8975','2013-07-10','17:10:00',2.98),('8975','2013-07-10','17:15:00',3.35),('8975','2013-07-10','17:20:00',2.15),('8975','2013-07-10','17:25:00',2.11),('8975','2013-07-10','17:30:00',3.01),('8975','2013-07-10','17:35:00',2.7),('8975','2013-07-10','17:40:00',2.59),('8975','2013-07-10','17:45:00',2.69),('8975','2013-07-10','17:50:00',2.34),('8975','2013-07-10','17:55:00',2.26),('8975','2013-07-10','18:00:00',2.13),('8975','2013-07-10','18:05:00',2.3),('8975','2013-07-10','18:10:00',2),('8975','2013-07-10','18:15:00',2.18),('8975','2013-07-10','18:20:00',1.9),('8975','2013-07-10','18:25:00',1.42),('8975','2013-07-10','18:30:00',1.94),('8975','2013-07-10','18:35:00',1.64),('8975','2013-07-10','18:40:00',1.12),('8975','2013-07-10','18:45:00',1.22),('8975','2013-07-10','18:50:00',1.29),('8975','2013-07-10','18:55:00',1.22),('8975','2013-07-10','19:00:00',1.15),('8975','2013-07-10','19:05:00',1.06),('8975','2013-07-10','19:10:00',1.02),('8975','2014-05-02','06:40:00',1.38),('8975','2014-05-02','06:45:00',1.29),('8975','2014-05-02','07:00:00',1.45),('8975','2014-05-02','07:05:00',2.25),('8975','2014-05-02','07:10:00',2.41),('8975','2014-05-02','07:15:00',2.55),('8975','2014-05-02','07:20:00',2.74),('8975','2014-05-02','07:25:00',2.89),('8975','2014-05-02','07:30:00',2.93),('8975','2014-05-02','07:35:00',3.38),('8975','2014-05-02','07:40:00',3.29),('8975','2014-05-02','07:45:00',3.4),('8975','2014-05-02','07:50:00',3.59),('8975','2014-05-02','07:55:00',3.74),('8975','2014-05-02','08:00:00',3.16),('8975','2014-05-02','08:05:00',2.78),('8975','2014-05-02','08:10:00',1.55),('8975','2014-05-02','08:15:00',1.56),('8975','2014-05-02','08:20:00',1.67),('8975','2014-05-02','08:25:00',1.81),('8975','2014-05-02','08:30:00',2.05),('8975','2014-05-02','08:35:00',1.93),('8975','2014-05-02','08:40:00',2.27),('8975','2014-05-02','08:45:00',4.16),('8975','2014-05-02','08:50:00',5.67),('8975','2014-05-02','08:55:00',5.35),('8975','2014-05-02','09:00:00',4.9),('8975','2014-05-02','09:05:00',3.49),('8975','2014-05-02','09:10:00',3.76),('8975','2014-05-02','09:15:00',3.98),('8975','2014-05-02','09:20:00',6.04),('8975','2014-05-02','09:25:00',6.63),('8975','2014-05-02','09:30:00',2.91),('8975','2014-05-02','09:35:00',2.06),('8975','2014-05-02','09:40:00',2.1),('8975','2014-05-02','09:45:00',2.55),('8975','2014-05-02','09:50:00',5.22),('8975','2014-05-02','09:55:00',6.56),('8975','2014-05-02','10:00:00',6.28),('8975','2014-05-02','10:05:00',6.61),('8975','2014-05-02','10:10:00',5.27),('8975','2014-05-02','10:15:00',4.09),('8975','2014-05-02','10:20:00',3.4),('8975','2014-05-02','10:25:00',6.83),('8975','2014-05-02','10:30:00',5.05),('8975','2014-05-02','10:35:00',4.47),('8975','2014-05-02','10:40:00',2.57),('8975','2014-05-02','10:45:00',2.59),('8975','2014-05-02','10:50:00',6.36),('8975','2014-05-02','10:55:00',3.65),('8975','2014-05-02','11:00:00',7.5),('8975','2014-05-02','11:05:00',7.08),('8975','2014-05-02','11:10:00',8.31),('8975','2014-05-02','11:15:00',6.68),('8975','2014-05-02','11:20:00',6.76),('8975','2014-05-02','11:25:00',6.24),('8975','2014-05-02','11:30:00',4.4),('8975','2014-05-02','11:35:00',4.78),('8975','2014-05-02','11:40:00',3.91),('8975','2014-05-02','11:45:00',3.21),('8975','2014-05-02','11:50:00',2.95),('8975','2014-05-02','11:55:00',2.47),('8975','2014-05-02','12:00:00',2.08),('8975','2014-05-02','12:05:00',1.83),('8975','2014-05-02','12:10:00',1.72),('8975','2014-05-02','12:15:00',1.65),('8975','2014-05-02','12:20:00',1.69),('8975','2014-05-02','12:25:00',2.1),('8975','2014-05-02','12:30:00',3.04),('8975','2014-05-02','12:35:00',4.41),('8975','2014-05-02','12:40:00',3.74),('8975','2014-05-02','12:45:00',3.23),('8975','2014-05-02','12:50:00',2.63),('8975','2014-05-02','12:55:00',2.69),('8975','2014-05-02','13:00:00',3.28),('8975','2014-05-02','13:05:00',5.07),('8975','2014-05-02','13:10:00',3.58),('8975','2014-05-02','13:15:00',3.93),('8975','2014-05-02','13:20:00',4.5),('8975','2014-05-02','13:25:00',4.88),('8975','2014-05-02','13:30:00',3.35),('8975','2014-05-02','13:35:00',2.81),('8975','2014-05-02','13:40:00',2.69),('8975','2014-05-02','13:45:00',2.68),('8975','2014-05-02','13:50:00',2.74),('8975','2014-05-02','13:55:00',2.82),('8975','2014-05-02','14:00:00',2.97),('8975','2014-05-02','14:05:00',3.42),('8975','2014-05-02','14:10:00',4.54),('8975','2014-05-02','14:15:00',6.2),('8975','2014-05-02','14:20:00',6.44),('8975','2014-05-02','14:25:00',3.17),('8975','2014-05-02','14:30:00',2.19),('8975','2014-05-02','14:35:00',2.05),('8975','2014-05-02','14:40:00',1.36),('8975','2014-05-02','14:45:00',6.76),('8975','2014-05-02','14:50:00',7.39),('8975','2014-05-02','14:55:00',7.7),('8975','2014-05-02','15:00:00',7.48),('8975','2014-05-02','15:05:00',6.04),('8975','2014-05-02','15:10:00',2.78),('8975','2014-05-02','15:15:00',1.63),('8975','2014-05-02','15:20:00',1.35),('8975','2014-05-02','15:25:00',1.04),('8975','2014-05-02','15:30:00',1.23),('8975','2014-05-02','15:35:00',1.23),('8975','2014-05-02','15:40:00',1.19),('8975','2014-05-02','15:45:00',1.07),('8975','2014-05-02','16:30:00',1.05),('8975','2014-05-02','16:35:00',1.18),('8975','2014-05-02','16:40:00',1.34),('8975','2014-05-02','16:45:00',1.49),('8975','2014-05-02','16:50:00',1.56),('8975','2014-05-02','16:55:00',1.6),('8975','2014-05-02','17:00:00',1.6),('8975','2014-05-02','17:05:00',1.58),('8975','2014-05-02','17:10:00',1.57),('8975','2014-05-02','17:15:00',1.55),('8975','2014-05-02','17:20:00',1.52),('8975','2014-05-02','17:25:00',1.52),('8975','2014-05-02','17:30:00',1.5),('8975','2014-05-02','17:35:00',1.44),('8975','2014-05-02','17:40:00',1.4),('8975','2014-05-02','17:45:00',1.35),('8975','2014-05-02','17:50:00',1.38),('8975','2014-05-02','17:55:00',1.56),('8975','2014-05-02','18:00:00',1.35),('8975','2014-05-02','18:05:00',1.15),('8975','2014-04-05','08:05:00',2.65),('8975','2014-04-05','08:10:00',3.06),('8975','2014-04-05','08:15:00',3.15),('8975','2014-04-05','08:20:00',3.25),('8975','2014-04-05','08:25:00',3.41),('8975','2014-04-05','08:30:00',3.51),('8975','2014-04-05','08:35:00',3.61),('8975','2014-04-05','08:40:00',3.68),('8975','2014-04-05','08:45:00',3.71),('8975','2014-04-05','08:50:00',3.94),('8975','2014-04-05','08:55:00',3.83),('8975','2014-04-05','09:00:00',1.52),('8975','2014-04-05','09:05:00',1.6),('8975','2014-04-05','09:10:00',3.63),('8975','2014-04-05','09:15:00',4.33),('8975','2014-04-05','09:20:00',4.11),('8975','2014-04-05','09:25:00',1.34),('8975','2014-04-05','09:30:00',2.35),('8975','2014-04-05','09:35:00',3.23),('8975','2014-04-05','09:40:00',4.53),('8975','2014-04-05','09:45:00',5.71),('8975','2014-04-05','09:50:00',6.28),('8975','2014-04-05','09:55:00',5.97),('8975','2014-04-05','10:00:00',2.42),('8975','2014-04-05','10:05:00',1.72),('8975','2014-04-05','10:10:00',1.77),('8975','2014-04-05','10:15:00',2.06),('8975','2014-04-05','10:20:00',2.03),('8975','2014-04-05','10:25:00',2.06),('8975','2014-04-05','10:30:00',2.39),('8975','2014-04-05','10:35:00',2.75),('8975','2014-04-05','10:40:00',3.52),('8975','2014-04-05','10:45:00',5.52),('8975','2014-04-05','10:50:00',5.2),('8975','2014-04-05','10:55:00',6.75),('8975','2014-04-05','11:00:00',7.23),('8975','2014-04-05','11:05:00',6.86),('8975','2014-04-05','11:10:00',6.33),('8975','2014-04-05','11:15:00',4.98),('8975','2014-04-05','11:20:00',6.9),('8975','2014-04-05','11:25:00',6.64),('8975','2014-04-05','11:30:00',6.52),('8975','2014-04-05','11:35:00',6.68),('8975','2014-04-05','11:40:00',6.95),('8975','2014-04-05','11:45:00',6.9),('8975','2014-04-05','11:50:00',6.96),('8975','2014-04-05','11:55:00',6.88),('8975','2014-04-05','12:00:00',6.31),('8975','2014-04-05','12:05:00',4.45),('8975','2014-04-05','12:10:00',4.84),('8975','2014-04-05','12:15:00',6.62),('8975','2014-04-05','12:20:00',7.41),('8975','2014-04-05','12:25:00',4.23),('8975','2014-04-05','12:30:00',2.68),('8975','2014-04-05','12:35:00',5.69),('8975','2014-04-05','12:40:00',2.16),('8975','2014-04-05','12:45:00',2.48),('8975','2014-04-05','12:50:00',2.05),('8975','2014-04-05','12:55:00',1.97),('8975','2014-04-05','13:00:00',2.73),('8975','2014-04-05','13:05:00',5.87),('8975','2014-04-05','13:10:00',6.1),('8975','2014-04-05','13:15:00',4.17),('8975','2014-04-05','13:20:00',4.1),('8975','2014-04-05','13:25:00',3.43),('8975','2014-04-05','13:30:00',3.8),('8975','2014-04-05','13:35:00',3.07),('8975','2014-04-05','13:40:00',4.34),('8975','2014-04-05','13:45:00',5.21),('8975','2014-04-05','13:50:00',4.31),('8975','2014-04-05','13:55:00',4.16),('8975','2014-04-05','14:00:00',3.77),('8975','2014-04-05','14:05:00',5.88),('8975','2014-04-05','14:10:00',5.85),('8975','2014-04-05','14:15:00',6),('8975','2014-04-05','14:20:00',6.2),('8975','2014-04-05','14:25:00',4.68),('8975','2014-04-05','14:30:00',1.74),('8975','2014-04-05','14:35:00',2.52),('8975','2014-04-05','14:40:00',4.3),('8975','2014-04-05','14:45:00',2.39),('8975','2014-04-05','14:50:00',2.49),('8975','2014-04-05','14:55:00',2.51),('8975','2014-04-05','15:00:00',2.51),('8975','2014-04-05','15:05:00',1.86),('8975','2014-04-05','15:10:00',1.76),('8975','2014-04-05','15:15:00',2.76),('8975','2014-04-05','15:20:00',4.7),('8975','2014-04-05','15:25:00',1.94),('8975','2014-04-05','15:30:00',1.97),('8975','2014-04-05','15:35:00',1.18),('8975','2014-04-05','15:40:00',1.13),('8975','2014-04-05','15:45:00',1.39),('8975','2014-04-05','15:50:00',1.72),('8975','2014-04-05','15:55:00',3.21),('8975','2014-04-05','16:00:00',4.44),('8975','2014-04-05','16:05:00',2.79),('8975','2014-04-05','16:10:00',2.24),('8975','2014-04-05','16:15:00',1.31),('8975','2014-04-05','16:30:00',1.25),('8975','2014-04-05','16:35:00',1.85),('8975','2014-04-05','16:40:00',2.01),('8975','2014-04-05','16:45:00',3.34),('8975','2014-04-05','16:50:00',3.39),('8975','2014-04-05','16:55:00',2.95),('8975','2014-04-05','17:00:00',1.55),('8975','2014-04-05','17:05:00',1.14),('8975','2014-04-05','17:10:00',1.08),('8975','2014-04-05','17:30:00',1.52),('8975','2014-04-05','17:35:00',1.72),('8975','2014-04-05','17:40:00',1.59),('8975','2014-04-05','17:45:00',1.02),('8975','2014-04-05','17:50:00',1.62),('8975','2014-04-05','17:55:00',1.54),('8975','2014-04-05','18:00:00',1.45),('8975','2014-04-05','18:05:00',1.42),('8975','2014-04-05','18:10:00',1.37),('8975','2014-04-05','18:15:00',1.35),('8975','2014-04-05','18:20:00',1.36),('8975','2014-04-05','18:25:00',1.29),('8975','2014-04-05','18:30:00',1.19),('8975','2013-07-09','06:35:00',1.04),('8975','2013-07-09','06:40:00',1.17),('8975','2013-07-09','06:45:00',1.34),('8975','2013-07-09','06:50:00',1.51),('8975','2013-07-09','06:55:00',1.72),('8975','2013-07-09','07:00:00',1.9),('8975','2013-07-09','07:05:00',2.1),('8975','2013-07-09','07:10:00',2.28),('8975','2013-07-09','07:15:00',2.5),('8975','2013-07-09','07:20:00',2.8),('8975','2013-07-09','07:25:00',3.09),('8975','2013-07-09','07:30:00',3.34),('8975','2013-07-09','07:35:00',3.61),('8975','2013-07-09','07:40:00',3.84),('8975','2013-07-09','07:45:00',4.05),('8975','2013-07-09','07:50:00',4.27),('8975','2013-07-09','07:55:00',2.83),('8975','2013-07-09','08:00:00',3.51),('8975','2013-07-09','08:05:00',3.87),('8975','2013-07-09','08:10:00',3.83),('8975','2013-07-09','08:15:00',3.44),('8975','2013-07-09','08:20:00',4.14),('8975','2013-07-09','08:25:00',4.68),('8975','2013-07-09','08:30:00',5.04),('8975','2013-07-09','08:35:00',3.89),('8975','2013-07-09','08:40:00',4.96),('8975','2013-07-09','08:45:00',4.57),('8975','2013-07-09','08:50:00',4.01),('8975','2013-07-09','08:55:00',3.53),('8975','2013-07-09','09:00:00',4.73),('8975','2013-07-09','09:05:00',4.19),('8975','2013-07-09','09:10:00',4.96),('8975','2013-07-09','09:15:00',5.2),('8975','2013-07-09','09:20:00',4.39),('8975','2013-07-09','09:25:00',5.3),('8975','2013-07-09','09:30:00',5.3),('8975','2013-07-09','09:35:00',5.32),('8975','2013-07-09','09:40:00',5.32),('8975','2013-07-09','09:45:00',5.29),('8975','2013-07-09','09:50:00',5.46),('8975','2013-07-09','09:55:00',5.57),('8975','2013-07-09','10:00:00',5.59),('8975','2013-07-09','10:05:00',5.64),('8975','2013-07-09','10:10:00',5.64),('8975','2013-07-09','10:15:00',5.7),('8975','2013-07-09','10:20:00',5.78),('8975','2013-07-09','10:25:00',5.85),('8975','2013-07-09','10:30:00',5.93),('8975','2013-07-09','10:35:00',5.98),('8975','2013-07-09','10:40:00',5.97),('8975','2013-07-09','10:45:00',5.99),('8975','2013-07-09','10:50:00',6.03),('8975','2013-07-09','10:55:00',6.05),('8975','2013-07-09','11:00:00',6.12),('8975','2013-07-09','11:05:00',6.23),('8975','2013-07-09','11:10:00',6.27),('8975','2013-07-09','11:15:00',6.29),('8975','2013-07-09','11:20:00',6.28),('8975','2013-07-09','11:25:00',6.3),('8975','2013-07-09','11:30:00',6.39),('8975','2013-07-09','11:35:00',6.4),('8975','2013-07-09','11:40:00',6.37),('8975','2013-07-09','11:45:00',6.46),('8975','2013-07-09','11:50:00',6.46),('8975','2013-07-09','11:55:00',6.46),('8975','2013-07-09','12:00:00',6.51),('8975','2013-07-09','12:05:00',6.55),('8975','2013-07-09','12:10:00',6.58),('8975','2013-07-09','12:15:00',6.59),('8975','2013-07-09','12:20:00',6.59),('8975','2013-07-09','12:25:00',6.5),('8975','2013-07-09','12:30:00',6.6),('8975','2013-07-09','12:35:00',6.63),('8975','2013-07-09','12:40:00',6.65),('8975','2013-07-09','12:45:00',6.53),('8975','2013-07-09','12:50:00',6.64),('8975','2013-07-09','12:55:00',6.69),('8975','2013-07-09','13:00:00',6.61),('8975','2013-07-09','13:05:00',6.59),('8975','2013-07-09','13:10:00',6.56),('8975','2013-07-09','13:15:00',6.53),('8975','2013-07-09','13:20:00',6.53),('8975','2013-07-09','13:25:00',6.51),('8975','2013-07-09','13:30:00',6.49),('8975','2013-07-09','13:35:00',6.5),('8975','2013-07-09','13:40:00',6.5),('8975','2013-07-09','13:45:00',6.46),('8975','2013-07-09','13:50:00',6.45),('8975','2013-07-09','13:55:00',6.39),('8975','2013-07-09','14:00:00',6.34),('8975','2013-07-09','14:05:00',6.3),('8975','2013-07-09','14:10:00',6.18),('8975','2013-07-09','14:15:00',6.2),('8975','2013-07-09','14:20:00',6.18),('8975','2013-07-09','14:25:00',5.82),('8975','2013-07-09','14:30:00',5.98),('8975','2013-07-09','14:35:00',5.46),('8975','2013-07-09','14:40:00',5.42),('8975','2013-07-09','14:45:00',5.8),('8975','2013-07-09','14:50:00',5.68),('8975','2013-07-09','14:55:00',5.51),('8975','2013-07-09','15:00:00',5.16),('8975','2013-07-09','15:05:00',4.42),('8975','2013-07-09','15:10:00',5.09),('8975','2013-07-09','15:15:00',5.46),('8975','2013-07-09','15:20:00',5.39),('8975','2013-07-09','15:25:00',5.33),('8975','2013-07-09','15:30:00',5.26),('8975','2013-07-09','15:35:00',5.15),('8975','2013-07-09','15:40:00',5.03),('8975','2013-07-09','15:45:00',4.91),('8975','2013-07-09','15:50:00',4.83),('8975','2013-07-09','15:55:00',4.71),('8975','2013-07-09','16:00:00',4.63),('8975','2013-07-09','16:05:00',4.53),('8975','2013-07-09','16:10:00',4.42),('8975','2013-07-09','16:15:00',4.34),('8975','2013-07-09','16:20:00',4.21),('8975','2013-07-09','16:25:00',4.1),('8975','2013-07-09','16:30:00',4),('8975','2013-07-09','16:35:00',3.88),('8975','2013-07-09','16:40:00',3.77),('8975','2013-07-09','16:45:00',3.68),('8975','2013-07-09','16:50:00',3.58),('8975','2013-07-09','16:55:00',3.47),('8975','2013-07-09','17:00:00',3.41),('8975','2013-07-09','17:05:00',3.48),('8975','2013-07-09','17:10:00',2.17),('8975','2013-07-09','17:15:00',2.84),('8975','2013-07-09','17:20:00',3.12),('8975','2013-07-09','17:25:00',2.23),('8975','2013-07-09','17:35:00',1.23),('8975','2013-07-09','17:40:00',2.24),('8975','2013-07-09','17:45:00',1.72),('8975','2013-07-09','17:50:00',2.23),('8975','2013-07-09','17:55:00',2.04),('8975','2013-07-09','18:00:00',2.04),('8975','2013-07-09','18:05:00',1.69),('8975','2013-07-09','18:10:00',1.68),('8975','2013-07-09','18:15:00',1.78),('8975','2013-07-09','18:20:00',1.4),('8975','2013-07-09','18:25:00',1.4),('8975','2013-07-09','19:10:00',1.08),('8975','2013-07-09','19:15:00',1.05),('8975','2013-07-08','06:45:00',1.16),('8975','2013-07-08','06:50:00',1.32),('8975','2013-07-08','06:55:00',1.28),('8975','2013-07-08','07:00:00',1.76),('8975','2013-07-08','07:05:00',1.98),('8975','2013-07-08','07:10:00',2.1),('8975','2013-07-08','07:15:00',2.24),('8975','2013-07-08','07:20:00',2.32),('8975','2013-07-08','07:25:00',2.33),('8975','2013-07-08','07:30:00',2.53),('8975','2013-07-08','07:35:00',2.76),('8975','2013-07-08','07:40:00',2.9),('8975','2013-07-08','07:45:00',3),('8975','2013-07-08','07:50:00',3.07),('8975','2013-07-08','07:55:00',3.22),('8975','2013-07-08','08:00:00',3.37),('8975','2013-07-08','08:05:00',3.45),('8975','2013-07-08','08:10:00',3.57),('8975','2013-07-08','08:15:00',3.67),('8975','2013-07-08','08:20:00',3.75),('8975','2013-07-08','08:25:00',3.84),('8975','2013-07-08','08:30:00',3.94),('8975','2013-07-08','08:35:00',4.04),('8975','2013-07-08','08:40:00',4.17),('8975','2013-07-08','08:45:00',4.24),('8975','2013-07-08','08:50:00',4.33),('8975','2013-07-08','08:55:00',4.44),('8975','2013-07-08','09:00:00',4.54),('8975','2013-07-08','09:05:00',4.63),('8975','2013-07-08','09:10:00',4.71),('8975','2013-07-08','09:15:00',4.81),('8975','2013-07-08','09:20:00',4.92),('8975','2013-07-08','09:25:00',5),('8975','2013-07-08','09:30:00',5.06),('8975','2013-07-08','09:35:00',5.13),('8975','2013-07-08','09:40:00',5.15),('8975','2013-07-08','09:45:00',5.25),('8975','2013-07-08','09:50:00',5.37),('8975','2013-07-08','09:55:00',5.43),('8975','2013-07-08','10:00:00',5.52),('8975','2013-07-08','10:05:00',5.54),('8975','2013-07-08','10:10:00',5.6),('8975','2013-07-08','10:15:00',5.53),('8975','2013-07-08','10:20:00',5.63),('8975','2013-07-08','10:25:00',5.82),('8975','2013-07-08','10:30:00',5.89),('8975','2013-07-08','10:35:00',5.93),('8975','2013-07-08','10:40:00',5.98),('8975','2013-07-08','10:45:00',6),('8975','2013-07-08','10:50:00',6.05),('8975','2013-07-08','10:55:00',6.13),('8975','2013-07-08','11:00:00',6.3),('8975','2013-07-08','11:05:00',6.36),('8975','2013-07-08','11:10:00',5.9),('8975','2013-07-08','11:15:00',6.47),('8975','2013-07-08','11:20:00',6.24),('8975','2013-07-08','11:25:00',4.09),('8975','2013-07-08','11:30:00',3.91),('8975','2013-07-08','11:35:00',3.85),('8975','2013-07-08','11:40:00',4.24),('8975','2013-07-08','11:45:00',5.13),('8975','2013-07-08','11:50:00',6.85),('8975','2013-07-08','11:55:00',6.95),('8975','2013-07-08','12:00:00',7.21),('8975','2013-07-08','12:05:00',6.58),('8975','2013-07-08','12:10:00',6.09),('8975','2013-07-08','12:15:00',6.63),('8975','2013-07-08','12:20:00',6.59),('8975','2013-07-08','12:25:00',6.51),('8975','2013-07-08','12:30:00',6.51),('8975','2013-07-08','12:35:00',6.46),('8975','2013-07-08','12:40:00',6.46),('8975','2013-07-08','12:45:00',6.45),('8975','2013-07-08','12:50:00',6.46),('8975','2013-07-08','12:55:00',6.37),('8975','2013-07-08','13:00:00',6.27),('8975','2013-07-08','13:05:00',6.56),('8975','2013-07-08','13:10:00',6.66),('8975','2013-07-08','13:15:00',6.71),('8975','2013-07-08','13:20:00',6.61),('8975','2013-07-08','13:25:00',6.62),('8975','2013-07-08','13:30:00',6.79),('8975','2013-07-08','13:35:00',6.28),('8975','2013-07-08','13:40:00',5.81),('8975','2013-07-08','13:45:00',5.81),('8975','2013-07-08','13:50:00',5.2),('8975','2013-07-08','13:55:00',4.62),('8975','2013-07-08','14:00:00',4.63),('8975','2013-07-08','14:05:00',4.59),('8975','2013-07-08','14:10:00',4.79),('8975','2013-07-08','14:15:00',5.14),('8975','2013-07-08','14:20:00',5.69),('8975','2013-07-08','14:25:00',5.93),('8975','2013-07-08','14:30:00',3.78),('8975','2013-07-08','14:35:00',2.05),('8975','2013-07-08','14:40:00',1.59),('8975','2013-07-08','14:45:00',1.31),('8975','2013-07-07','07:00:00',1.49),('8975','2013-07-07','07:05:00',1.08),('8975','2013-07-07','07:10:00',1.34),('8975','2013-07-07','07:15:00',1.55),('8975','2013-07-07','07:20:00',1.38),('8975','2013-07-07','07:35:00',1.48),('8975','2013-07-07','07:40:00',2.51),('8975','2013-07-07','07:45:00',3.4),('8975','2013-07-07','07:50:00',2.91),('8975','2013-07-07','07:55:00',3.13),('8975','2013-07-07','08:00:00',3.2),('8975','2013-07-07','08:05:00',2.87),('8975','2013-07-07','08:10:00',3.26),('8975','2013-07-07','08:15:00',3.62),('8975','2013-07-07','08:20:00',3.81),('8975','2013-07-07','08:25:00',3.88),('8975','2013-07-07','08:30:00',3.96),('8975','2013-07-07','08:35:00',4.03),('8975','2013-07-07','08:40:00',4.12),('8975','2013-07-07','08:45:00',4.24),('8975','2013-07-07','08:50:00',4.33),('8975','2013-07-07','08:55:00',4.41),('8975','2013-07-07','09:00:00',4.51),('8975','2013-07-07','09:05:00',4.61),('8975','2013-07-07','09:10:00',4.73),('8975','2013-07-07','09:15:00',4.79),('8975','2013-07-07','09:20:00',4.94),('8975','2013-07-07','09:25:00',4.95),('8975','2013-07-07','09:30:00',4.86),('8975','2013-07-07','09:35:00',5.2),('8975','2013-07-07','09:40:00',5.31),('8975','2013-07-07','09:45:00',5.48),('8975','2013-07-07','09:50:00',5.53),('8975','2013-07-07','09:55:00',5.63),('8975','2013-07-07','10:00:00',5.72),('8975','2013-07-07','10:05:00',5.74),('8975','2013-07-07','10:10:00',5.73),('8975','2013-07-07','10:15:00',5.88),('8975','2013-07-07','10:20:00',5.94),('8975','2013-07-07','10:25:00',6),('8975','2013-07-07','10:30:00',6.03),('8975','2013-07-07','10:35:00',6.1),('8975','2013-07-07','10:40:00',6.13),('8975','2013-07-07','10:45:00',6.18),('8975','2013-07-07','10:50:00',6.21),('8975','2013-07-07','10:55:00',6.23),('8975','2013-07-07','11:00:00',6.29),('8975','2013-07-07','11:05:00',6.39),('8975','2013-07-07','11:10:00',6.44),('8975','2013-07-07','11:15:00',6.2),('8975','2013-07-07','11:20:00',6.16),('8975','2013-07-07','11:25:00',6.23),('8975','2013-07-07','11:30:00',6.64),('8975','2013-07-07','11:35:00',6.66),('8975','2013-07-07','11:40:00',6.69),('8975','2013-07-07','11:45:00',6.66),('8975','2013-07-07','11:50:00',6.7),('8975','2013-07-07','11:55:00',6.72),('8975','2013-07-07','12:00:00',6.5),('8975','2013-07-07','12:05:00',6.77),('8975','2013-07-07','12:10:00',3.2),('8975','2013-07-07','12:15:00',3.02),('8975','2013-07-07','12:20:00',3.3),('8975','2013-07-07','12:25:00',3.53),('8975','2013-07-07','12:30:00',3.71),('8975','2013-07-07','12:35:00',6.34),('8975','2013-07-07','12:40:00',6.93),('8975','2013-07-07','12:45:00',6.8),('8975','2013-07-07','12:50:00',6.82),('8975','2013-07-07','12:55:00',4.84),('8975','2013-07-07','13:00:00',6.38),('8975','2013-07-07','13:05:00',2.97),('8975','2013-07-07','13:10:00',5.47),('8975','2013-07-07','13:15:00',7.95),('8975','2013-07-07','13:20:00',7.91),('8975','2013-07-07','13:25:00',5.16),('8975','2013-07-07','13:30:00',1.38),('8975','2013-07-07','13:35:00',1.01),('8975','2013-07-07','14:05:00',1.07),('8975','2013-07-07','14:10:00',1.18),('8975','2013-07-07','14:15:00',1.29),('8975','2013-07-07','14:20:00',1.3),('8975','2013-07-07','14:25:00',1.34),('8975','2013-07-07','14:30:00',1.44),('8975','2013-07-07','14:35:00',1.64),('8975','2013-07-07','14:40:00',1.72),('8975','2013-07-07','14:45:00',1.62),('8975','2013-07-07','14:50:00',1.52),('8975','2013-07-07','14:55:00',1.48),('8975','2013-07-07','15:00:00',1.39),('8975','2013-07-07','15:05:00',1.25),('8975','2013-07-07','15:10:00',1.12),('8975','2013-07-07','15:15:00',1.04),('8975','2013-07-07','17:20:00',1.05),('8975','2013-07-07','17:25:00',1.29),('8975','2013-07-07','17:30:00',1.51),('8975','2013-07-07','17:35:00',1.62),('8975','2013-07-07','17:40:00',1.65),('8975','2013-07-07','17:45:00',1.63),('8975','2013-07-07','17:50:00',1.61),('8975','2013-07-07','17:55:00',1.54),('8975','2013-07-07','18:00:00',1.44),('8975','2013-07-07','18:05:00',1.32),('8975','2013-07-07','18:10:00',1.26),('8975','2013-07-07','18:15:00',1.24),('8975','2013-07-07','18:20:00',1.28),('8975','2013-07-07','18:25:00',1.22),('8975','2013-07-07','18:30:00',1.2),('8975','2013-07-07','18:35:00',1.22),('8975','2013-07-07','18:40:00',1.16),('8975','2013-07-07','18:45:00',1.42),('8975','2013-07-07','18:50:00',1.51),('8975','2013-07-07','18:55:00',1.34),('8975','2013-07-07','19:00:00',1.18),('8975','2013-07-07','19:05:00',1.03),('8975','2013-07-06','06:25:00',1),('8975','2013-07-06','06:30:00',1.24),('8975','2013-07-06','06:35:00',1.41),('8975','2013-07-06','06:40:00',1.59),('8975','2013-07-06','06:45:00',1.75),('8975','2013-07-06','06:50:00',1.89),('8975','2013-07-06','06:55:00',2.04),('8975','2013-07-06','07:00:00',2.18),('8975','2013-07-06','07:05:00',2.31),('8975','2013-07-06','07:10:00',2.44),('8975','2013-07-06','07:15:00',2.57),('8975','2013-07-06','07:20:00',2.7),('8975','2013-07-06','07:25:00',2.84),('8975','2013-07-06','07:30:00',2.95),('8975','2013-07-06','07:35:00',3.04),('8975','2013-07-06','07:40:00',3.17),('8975','2013-07-06','07:45:00',3.28),('8975','2013-07-06','07:50:00',3.38),('8975','2013-07-06','07:55:00',3.49),('8975','2013-07-06','08:00:00',3.59),('8975','2013-07-06','08:05:00',3.68),('8975','2013-07-06','08:10:00',3.82),('8975','2013-07-06','08:15:00',3.87),('8975','2013-07-06','08:20:00',2.98),('8975','2013-07-06','08:25:00',3.05),('8975','2013-07-06','08:30:00',3.17),('8975','2013-07-06','08:35:00',4.02),('8975','2013-07-06','08:40:00',3.8),('8975','2013-07-06','08:45:00',3.33),('8975','2013-07-06','08:50:00',1.78),('8975','2013-07-06','08:55:00',4.95),('8975','2013-07-06','09:00:00',5.24),('8975','2013-07-06','09:05:00',5.24),('8975','2013-07-06','09:10:00',5.04),('8975','2013-07-06','09:15:00',4.8),('8975','2013-07-06','09:20:00',2.92),('8975','2013-07-06','09:25:00',2.84),('8975','2013-07-06','09:30:00',5.06),('8975','2013-07-06','09:35:00',5.55),('8975','2013-07-06','09:40:00',5.49),('8975','2013-07-06','09:45:00',5.3),('8975','2013-07-06','09:50:00',5.9),('8975','2013-07-06','09:55:00',5.79),('8975','2013-07-06','10:00:00',5.81),('8975','2013-07-06','10:05:00',5.58),('8975','2013-07-06','10:10:00',6.14),('8975','2013-07-06','10:15:00',6.02),('8975','2013-07-06','10:20:00',5.26),('8975','2013-07-06','10:25:00',5.49),('8975','2013-07-06','10:30:00',5.27),('8975','2013-07-06','10:35:00',5.91),('8975','2013-07-06','10:40:00',6.35),('8975','2013-07-06','10:45:00',5.65),('8975','2013-07-06','10:50:00',6.28),('8975','2013-07-06','10:55:00',6.33),('8975','2013-07-06','11:00:00',6.34),('8975','2013-07-06','11:05:00',6.41),('8975','2013-07-06','11:10:00',6.6),('8975','2013-07-06','11:15:00',6.69),('8975','2013-07-06','11:20:00',6.43),('8975','2013-07-06','11:25:00',6.1),('8975','2013-07-06','11:30:00',5.46),('8975','2013-07-06','11:35:00',5.84),('8975','2013-07-06','11:40:00',5.45),('8975','2013-07-06','11:45:00',5.88),('8975','2013-07-06','11:50:00',4.6),('8975','2013-07-06','11:55:00',3.99),('8975','2013-07-06','12:00:00',3.06),('8975','2013-07-06','12:05:00',5.6),('8975','2013-07-06','12:10:00',6.17),('8975','2013-07-06','12:15:00',6.74),('8975','2013-07-06','12:20:00',7.11),('8975','2013-07-06','12:25:00',6.42),('8975','2013-07-06','12:30:00',6.22),('8975','2013-07-06','12:35:00',6.12),('8975','2013-07-06','12:40:00',5.64),('8975','2013-07-06','12:45:00',5.77),('8975','2013-07-06','12:50:00',6.08),('8975','2013-07-06','12:55:00',5.67),('8975','2013-07-06','13:00:00',6.29),('8975','2013-07-06','13:05:00',5.99),('8975','2013-07-06','13:10:00',5.75),('8975','2013-07-06','13:15:00',5.48),('8975','2013-07-06','13:20:00',5.2),('8975','2013-07-06','13:25:00',6.27),('8975','2013-07-06','13:30:00',6.28),('8975','2013-07-06','13:35:00',6.66),('8975','2013-07-06','13:40:00',6.73),('8975','2013-07-06','13:45:00',7.01),('8975','2013-07-06','13:50:00',7.28),('8975','2013-07-06','13:55:00',4.71),('8975','2013-07-06','14:00:00',4.11),('8975','2013-07-06','14:05:00',2.45),('8975','2013-07-06','14:10:00',2.91),('8975','2013-07-06','14:15:00',2.71),('8975','2013-07-06','14:20:00',1.53),('8975','2013-07-06','14:25:00',1.12),('8975','2013-07-06','14:30:00',1.06),('8975','2013-07-06','14:35:00',1.11),('8975','2013-07-06','14:40:00',1.1),('8975','2013-07-06','14:45:00',1.09),('8975','2013-07-06','14:50:00',1.11),('8975','2013-07-06','14:55:00',1.2),('8975','2013-07-06','15:00:00',1.42),('8975','2013-07-06','15:05:00',1.52),('8975','2013-07-06','15:10:00',1.3),('8975','2013-07-06','15:15:00',1.06),('8975','2013-07-06','15:20:00',1.07),('8975','2013-07-06','15:25:00',1.07),('8975','2013-07-06','16:50:00',1.14),('8975','2013-07-06','16:55:00',1.31),('8975','2013-07-06','17:00:00',1.46),('8975','2013-07-06','17:05:00',1.55),('8975','2013-07-06','17:10:00',1.6),('8975','2013-07-06','17:15:00',1.62),('8975','2013-07-06','17:20:00',1.61),('8975','2013-07-06','17:25:00',1.55),('8975','2013-07-06','17:30:00',1.49),('8975','2013-07-06','17:35:00',1.42),('8975','2013-07-06','17:40:00',1.37),('8975','2013-07-06','17:45:00',1.33),('8975','2013-07-06','17:50:00',1.31),('8975','2013-07-06','17:55:00',1.27),('8975','2013-07-06','18:00:00',1.27),('8975','2013-07-06','18:05:00',1.25),('8975','2013-07-06','18:10:00',1.22),('8975','2013-07-06','18:15:00',1.22),('8975','2013-07-06','18:20:00',1.23),('8975','2013-07-06','18:25:00',1.19),('8975','2013-07-06','18:30:00',1.12),('8975','2013-07-06','18:35:00',1.04),('8975','2013-07-05','06:30:00',1.11),('8975','2013-07-05','06:35:00',1.26),('8975','2013-07-05','06:40:00',1.41),('8975','2013-07-05','06:45:00',1.57),('8975','2013-07-05','06:50:00',1.71),('8975','2013-07-05','06:55:00',1.87),('8975','2013-07-05','07:00:00',2.02),('8975','2013-07-05','07:05:00',2.16),('8975','2013-07-05','07:10:00',2.29),('8975','2013-07-05','07:15:00',2.42),('8975','2013-07-05','07:20:00',2.54),('8975','2013-07-05','07:25:00',2.67),('8975','2013-07-05','07:30:00',2.8),('8975','2013-07-05','07:35:00',2.91),('8975','2013-07-05','07:40:00',3.02),('8975','2013-07-05','07:45:00',3.14),('8975','2013-07-05','07:50:00',3.24),('8975','2013-07-05','07:55:00',3.36),('8975','2013-07-05','08:00:00',3.45),('8975','2013-07-05','08:05:00',3.54),('8975','2013-07-05','08:10:00',3.65),('8975','2013-07-05','08:15:00',3.76),('8975','2013-07-05','08:20:00',3.87),('8975','2013-07-05','08:25:00',3.98),('8975','2013-07-05','08:30:00',4.11),('8975','2013-07-05','08:35:00',4.24),('8975','2013-07-05','08:40:00',4.34),('8975','2013-07-05','08:45:00',4.44),('8975','2013-07-05','08:50:00',4.53),('8975','2013-07-05','08:55:00',4.6),('8975','2013-07-05','09:00:00',4.69),('8975','2013-07-05','09:05:00',4.78),('8975','2013-07-05','09:10:00',4.91),('8975','2013-07-05','09:15:00',4.97),('8975','2013-07-05','09:20:00',5.06),('8975','2013-07-05','09:25:00',5.13),('8975','2013-07-05','09:30:00',5.21),('8975','2013-07-05','09:35:00',5.28),('8975','2013-07-05','09:40:00',5.35),('8975','2013-07-05','09:45:00',5.44),('8975','2013-07-05','09:50:00',5.53),('8975','2013-07-05','09:55:00',5.64),('8975','2013-07-05','10:00:00',5.69),('8975','2013-07-05','10:05:00',5.72),('8975','2013-07-05','10:10:00',5.82),('8975','2013-07-05','10:15:00',5.86),('8975','2013-07-05','10:20:00',5.93),('8975','2013-07-05','10:25:00',5.96),('8975','2013-07-05','10:30:00',5.97),('8975','2013-07-05','10:35:00',6.02),('8975','2013-07-05','10:40:00',6.06),('8975','2013-07-05','10:45:00',6.14),('8975','2013-07-05','10:50:00',6.23),('8975','2013-07-05','10:55:00',6.33),('8975','2013-07-05','11:00:00',5.77),('8975','2013-07-05','11:05:00',5.71),('8975','2013-07-05','11:10:00',6.48),('8975','2013-07-05','11:15:00',5.68),('8975','2013-07-05','11:20:00',5.93),('8975','2013-07-05','11:25:00',5.99),('8975','2013-07-05','11:30:00',5.72),('8975','2013-07-05','11:35:00',6.27),('8975','2013-07-05','11:40:00',6.2),('8975','2013-07-05','11:45:00',6.56),('8975','2013-07-05','11:50:00',6.61),('8975','2013-07-05','11:55:00',6.65),('8975','2013-07-05','12:00:00',6.69),('8975','2013-07-05','12:05:00',6.73),('8975','2013-07-05','12:10:00',6.87),('8975','2013-07-05','12:15:00',6.82),('8975','2013-07-05','12:20:00',7.01),('8975','2013-07-05','12:25:00',7.17),('8975','2013-07-05','12:30:00',7.08),('8975','2013-07-05','12:35:00',6.89),('8975','2013-07-05','12:40:00',6.88),('8975','2013-07-05','12:45:00',6.84),('8975','2013-07-05','12:50:00',6.76),('8975','2013-07-05','12:55:00',6.72),('8975','2013-07-05','13:00:00',6.77),('8975','2013-07-05','13:05:00',6.77),('8975','2013-07-05','13:10:00',6.77),('8975','2013-07-05','13:15:00',6.77),('8975','2013-07-05','13:20:00',6.7),('8975','2013-07-05','13:25:00',6.61),('8975','2013-07-05','13:30:00',6.56),('8975','2013-07-05','13:35:00',6.5),('8975','2013-07-05','13:40:00',6.54),('8975','2013-07-05','13:45:00',6.49),('8975','2013-07-05','13:50:00',6.37),('8975','2013-07-05','13:55:00',6.33),('8975','2013-07-05','14:00:00',6.4),('8975','2013-07-05','14:05:00',6.3),('8975','2013-07-05','14:10:00',6.14),('8975','2013-07-05','14:15:00',6.38),('8975','2013-07-05','14:20:00',3.79),('8975','2013-07-05','14:25:00',2.85),('8975','2013-07-05','14:30:00',6.28),('8975','2013-07-05','14:35:00',6.1),('8975','2013-07-05','14:40:00',5.55),('8975','2013-07-05','14:45:00',4.25),('8975','2013-07-05','14:50:00',5.95),('8975','2013-07-05','14:55:00',6.02),('8975','2013-07-05','15:00:00',5.62),('8975','2013-07-05','15:05:00',1.42),('8975','2013-07-05','15:10:00',2.87),('8975','2013-07-05','15:15:00',5.36),('8975','2013-07-05','15:20:00',5.65),('8975','2013-07-05','15:25:00',5.46),('8975','2013-07-05','15:30:00',5.47),('8975','2013-07-05','15:35:00',3.73),('8975','2013-07-05','15:40:00',1.64),('8975','2013-07-05','16:45:00',1.07),('8975','2013-07-05','16:50:00',2.01),('8975','2013-07-05','16:55:00',2.04),('8975','2013-07-05','17:00:00',1.56),('8975','2013-07-05','17:05:00',1.65),('8975','2013-07-05','17:10:00',1.56),('8975','2013-07-05','17:15:00',1.55),('8975','2013-07-05','17:20:00',2.15),('8975','2013-07-05','17:25:00',1.94),('8975','2013-07-05','17:30:00',1.64),('8975','2013-07-05','17:35:00',1.69),('8975','2013-07-05','17:40:00',1.7),('8975','2013-07-05','17:45:00',1.49),('8975','2013-07-05','17:50:00',1.2),('8975','2013-07-05','17:55:00',1.13),('8975','2013-07-05','18:00:00',1.06),('8975','2013-07-05','18:05:00',1.01),('8975','2013-07-04','06:30:00',1.09),('8975','2013-07-04','06:35:00',1.21),('8975','2013-07-04','06:40:00',1.34),('8975','2013-07-04','06:45:00',1.39),('8975','2013-07-04','06:50:00',1.65),('8975','2013-07-04','06:55:00',1.87),('8975','2013-07-04','07:00:00',2.02),('8975','2013-07-04','07:05:00',2.15),('8975','2013-07-04','07:10:00',2.29),('8975','2013-07-04','07:15:00',2.4),('8975','2013-07-04','07:20:00',2.54),('8975','2013-07-04','07:25:00',2.71),('8975','2013-07-04','07:30:00',2.79),('8975','2013-07-04','07:35:00',2.91),('8975','2013-07-04','07:40:00',3.07),('8975','2013-07-04','07:45:00',3.18),('8975','2013-07-04','07:50:00',3.29),('8975','2013-07-04','07:55:00',3.38),('8975','2013-07-04','08:00:00',3.45),('8975','2013-07-04','08:05:00',3.56),('8975','2013-07-04','08:10:00',3.66),('8975','2013-07-04','08:15:00',3.79),('8975','2013-07-04','08:20:00',3.94),('8975','2013-07-04','08:25:00',4),('8975','2013-07-04','08:30:00',4.07),('8975','2013-07-04','08:35:00',4.13),('8975','2013-07-04','08:40:00',4.24),('8975','2013-07-04','08:45:00',4.33),('8975','2013-07-04','08:50:00',4.41),('8975','2013-07-04','08:55:00',4.52),('8975','2013-07-04','09:00:00',4.65),('8975','2013-07-04','09:05:00',4.74),('8975','2013-07-04','09:10:00',4.86),('8975','2013-07-04','09:15:00',4.98),('8975','2013-07-04','09:20:00',5.09),('8975','2013-07-04','09:25:00',5.15),('8975','2013-07-04','09:30:00',5.2),('8975','2013-07-04','09:35:00',5.24),('8975','2013-07-04','09:40:00',5.34),('8975','2013-07-04','09:45:00',5.42),('8975','2013-07-04','09:50:00',5.46),('8975','2013-07-04','09:55:00',5.56),('8975','2013-07-04','10:00:00',5.65),('8975','2013-07-04','10:05:00',5.73),('8975','2013-07-04','10:10:00',5.77),('8975','2013-07-04','10:15:00',5.84),('8975','2013-07-04','10:20:00',5.86),('8975','2013-07-04','10:25:00',5.91),('8975','2013-07-04','10:30:00',5.96),('8975','2013-07-04','10:35:00',6.02),('8975','2013-07-04','10:40:00',6.07),('8975','2013-07-04','10:45:00',6.1),('8975','2013-07-04','10:50:00',6.16),('8975','2013-07-04','10:55:00',6.2),('8975','2013-07-04','11:00:00',6.22),('8975','2013-07-04','11:05:00',6.19),('8975','2013-07-04','11:10:00',6.21),('8975','2013-07-04','11:15:00',6.3),('8975','2013-07-04','11:20:00',6.31),('8975','2013-07-04','11:25:00',6.34),('8975','2013-07-04','11:30:00',6.38),('8975','2013-07-04','11:35:00',6.47),('8975','2013-07-04','11:40:00',6.47),('8975','2013-07-04','11:45:00',6.53),('8975','2013-07-04','11:50:00',6.54),('8975','2013-07-04','11:55:00',6.61),('8975','2013-07-04','12:00:00',6.54),('8975','2013-07-04','12:05:00',6.51),('8975','2013-07-04','12:10:00',6.56),('8975','2013-07-04','12:15:00',6.6),('8975','2013-07-04','12:20:00',6.6),('8975','2013-07-04','12:25:00',6.8),('8975','2013-07-04','12:30:00',6.81),('8975','2013-07-04','12:35:00',6.71),('8975','2013-07-04','12:40:00',6.73),('8975','2013-07-04','12:45:00',6.66),('8975','2013-07-04','12:50:00',6.7),('8975','2013-07-04','12:55:00',6.68),('8975','2013-07-04','13:00:00',6.71),('8975','2013-07-04','13:05:00',3.01),('8975','2013-07-04','13:10:00',2.66),('8975','2013-07-04','13:15:00',4.84),('8975','2013-07-04','13:20:00',7.01),('8975','2013-07-04','13:25:00',6.3),('8975','2013-07-04','13:30:00',4.72),('8975','2013-07-04','13:35:00',6.12),('8975','2013-07-04','13:40:00',5.62),('8975','2013-07-04','13:45:00',6.6),('8975','2013-07-04','13:50:00',6.54),('8975','2013-07-04','13:55:00',6.31),('8975','2013-07-04','14:00:00',6.42),('8975','2013-07-04','14:05:00',6.53),('8975','2013-07-04','14:10:00',6.46),('8975','2013-07-04','14:15:00',6.21),('8975','2013-07-04','14:20:00',6.21),('8975','2013-07-04','14:25:00',6.16),('8975','2013-07-04','14:30:00',6.06),('8975','2013-07-04','14:35:00',6.05),('8975','2013-07-04','14:40:00',6),('8975','2013-07-04','14:45:00',5.39),('8975','2013-07-04','14:50:00',1.67),('8975','2013-07-04','14:55:00',5.2),('8975','2013-07-04','15:00:00',5.26),('8975','2013-07-04','15:05:00',3.64),('8975','2013-07-04','15:10:00',2.38),('8975','2013-07-04','15:15:00',5.2),('8975','2013-07-04','15:20:00',5.07),('8975','2013-07-04','15:25:00',3.86),('8975','2013-07-04','15:30:00',3.61),('8975','2013-07-04','15:35:00',3.71),('8975','2013-07-04','15:40:00',4.91),('8975','2013-07-04','15:45:00',4.06),('8975','2013-07-04','15:50:00',4.97),('8975','2013-07-04','15:55:00',3.08),('8975','2013-07-04','16:00:00',4.26),('8975','2013-07-04','16:05:00',4.59),('8975','2013-07-04','16:10:00',4.53),('8975','2013-07-04','16:15:00',4.24),('8975','2013-07-04','16:20:00',4.17),('8975','2013-07-04','16:25:00',4.08),('8975','2013-07-04','16:30:00',4),('8975','2013-07-04','16:35:00',3.94),('8975','2013-07-04','16:40:00',3.8),('8975','2013-07-04','16:45:00',3.76),('8975','2013-07-04','16:50:00',3.61),('8975','2013-07-04','16:55:00',3.4),('8975','2013-07-04','17:00:00',3.29),('8975','2013-07-04','17:05:00',3.19),('8975','2013-07-04','17:10:00',3.12),('8975','2013-07-04','17:15:00',3.09),('8975','2013-07-04','17:20:00',2.99),('8975','2013-07-04','17:25:00',2.82),('8975','2013-07-04','17:30:00',2.7),('8975','2013-07-04','17:35:00',2.55),('8975','2013-07-04','17:40:00',2.38),('8975','2013-07-04','17:45:00',2.23),('8975','2013-07-04','17:50:00',2.06),('8975','2013-07-04','17:55:00',2),('8975','2013-07-04','18:00:00',1.98),('8975','2013-07-04','18:05:00',1.92),('8975','2013-07-04','18:10:00',1.74),('8975','2013-07-04','18:15:00',1.6),('8975','2013-07-04','18:20:00',1.37),('8975','2013-07-04','18:25:00',1.29),('8975','2013-07-04','18:35:00',1.27),('8975','2013-07-04','18:40:00',1.26),('8975','2013-07-04','18:45:00',1.22),('8975','2013-07-04','18:50:00',1.16),('8975','2013-07-04','18:55:00',1.08),('8975','2013-07-04','19:00:00',1.03),('8975','2013-07-03','08:50:00',1.2),('8975','2013-07-03','08:55:00',1.48),('8975','2013-07-03','09:00:00',1.44),('8975','2013-07-03','09:05:00',1.22),('8975','2013-07-03','09:10:00',1.04),('8975','2013-07-03','09:15:00',1.07),('8975','2013-07-03','09:20:00',1.08),('8975','2013-07-03','09:25:00',1.21),('8975','2013-07-03','09:30:00',1.28),('8975','2013-07-03','09:35:00',1.21),('8975','2013-07-03','09:40:00',1.01),('8975','2013-07-03','10:15:00',1.08),('8975','2013-07-03','10:20:00',1.18),('8975','2013-07-03','10:25:00',1.21),('8975','2013-07-03','10:30:00',1.23),('8975','2013-07-03','10:35:00',1.25),('8975','2013-07-03','10:40:00',1.19),('8975','2013-07-03','10:45:00',1.02),('8975','2013-07-03','10:55:00',1.03),('8975','2013-07-03','11:00:00',1.29),('8975','2013-07-03','11:05:00',1.48),('8975','2013-07-03','11:10:00',1.62),('8975','2013-07-03','11:15:00',1.72),('8975','2013-07-03','11:20:00',1.73),('8975','2013-07-03','11:25:00',1.94),('8975','2013-07-03','11:30:00',2.21),('8975','2013-07-03','11:35:00',2.49),('8975','2013-07-03','11:40:00',2.76),('8975','2013-07-03','11:45:00',2.82),('8975','2013-07-03','11:50:00',2.68),('8975','2013-07-03','11:55:00',2.46),('8975','2013-07-03','12:00:00',2.5),('8975','2013-07-03','12:05:00',2.83),('8975','2013-07-03','12:10:00',2.88),('8975','2013-07-03','12:15:00',3.44),('8975','2013-07-03','12:20:00',5.78),('8975','2013-07-03','12:25:00',7.31),('8975','2013-07-03','12:30:00',5.58),('8975','2013-07-03','12:35:00',4.28),('8975','2013-07-03','12:40:00',4.05),('8975','2013-07-03','12:45:00',2.91),('8975','2013-07-03','12:50:00',2.09),('8975','2013-07-03','12:55:00',1.79),('8975','2013-07-03','13:00:00',2.17),('8975','2013-07-03','13:05:00',3.28),('8975','2013-07-03','13:10:00',4.65),('8975','2013-07-03','13:15:00',6.29),('8975','2013-07-03','13:20:00',5.06),('8975','2013-07-03','13:25:00',4.99),('8975','2013-07-03','13:30:00',5.22),('8975','2013-07-03','13:35:00',5.58),('8975','2013-07-03','13:40:00',7.61),('8975','2013-07-03','13:45:00',8.19),('8975','2013-07-03','13:50:00',7.81),('8975','2013-07-03','13:55:00',6.96),('8975','2013-07-03','14:00:00',4.99),('8975','2013-07-03','14:05:00',3.65),('8975','2013-07-03','14:10:00',3.63),('8975','2013-07-03','14:15:00',4.09),('8975','2013-07-03','14:20:00',4.06),('8975','2013-07-03','14:25:00',3.36),('8975','2013-07-03','14:30:00',3.35),('8975','2013-07-03','14:35:00',3.51),('8975','2013-07-03','14:40:00',3.58),('8975','2013-07-03','14:45:00',3.45),('8975','2013-07-03','14:50:00',3.36),('8975','2013-07-03','14:55:00',3.46),('8975','2013-07-03','15:00:00',2.79),('8975','2013-07-03','15:05:00',4.49),('8975','2013-07-03','15:10:00',3.84),('8975','2013-07-03','15:15:00',3.67),('8975','2013-07-03','15:20:00',4.62),('8975','2013-07-03','15:25:00',5.83),('8975','2013-07-03','15:30:00',4.66),('8975','2013-07-03','15:35:00',6.01),('8975','2013-07-03','15:40:00',3.57),('8975','2013-07-03','15:45:00',3.19),('8975','2013-07-03','15:50:00',3.36),('8975','2013-07-03','15:55:00',2.82),('8975','2013-07-03','16:00:00',2.96),('8975','2013-07-03','16:05:00',3.54),('8975','2013-07-03','16:10:00',3.3),('8975','2013-07-03','16:15:00',2.9),('8975','2013-07-03','16:20:00',3.01),('8975','2013-07-03','16:25:00',3.95),('8975','2013-07-03','16:30:00',4.23),('8975','2013-07-03','16:35:00',2.9),('8975','2013-07-03','16:40:00',2.79),('8975','2013-07-03','16:45:00',2.49),('8975','2013-07-03','16:50:00',2.93),('8975','2013-07-03','16:55:00',2.27),('8975','2013-07-03','17:00:00',2),('8975','2013-07-03','17:05:00',1.91),('8975','2013-07-03','17:10:00',2.09),('8975','2013-07-03','17:15:00',3.12),('8975','2013-07-03','17:20:00',2.16),('8975','2013-07-03','17:25:00',2.64),('8975','2013-07-03','17:30:00',1.77),('8975','2013-07-03','17:35:00',2.14),('8975','2013-07-03','17:40:00',3.07),('8975','2013-07-03','17:45:00',2.92),('8975','2013-07-03','17:50:00',2.85),('8975','2013-07-03','17:55:00',2.77),('8975','2013-07-03','18:00:00',2.66),('8975','2013-07-03','18:05:00',2.53),('8975','2013-07-03','18:10:00',2.41),('8975','2013-07-03','18:15:00',2.38),('8975','2013-07-03','18:20:00',2.26),('8975','2013-07-03','18:25:00',2.19),('8975','2013-07-03','18:30:00',1.77),('8975','2013-07-03','18:35:00',1.43),('8975','2013-07-03','18:40:00',1.07),('8975','2013-07-02','06:20:00',1.01),('8975','2013-07-02','06:25:00',1.18),('8975','2013-07-02','06:30:00',1.33),('8975','2013-07-02','06:35:00',1.48),('8975','2013-07-02','06:40:00',1.61),('8975','2013-07-02','06:45:00',1.76),('8975','2013-07-02','06:50:00',1.93),('8975','2013-07-02','06:55:00',2.09),('8975','2013-07-02','07:00:00',2.23),('8975','2013-07-02','07:05:00',2.36),('8975','2013-07-02','07:10:00',2.5),('8975','2013-07-02','07:15:00',2.64),('8975','2013-07-02','07:20:00',2.77),('8975','2013-07-02','07:25:00',2.9),('8975','2013-07-02','07:30:00',3.02),('8975','2013-07-02','07:35:00',3.15),('8975','2013-07-02','07:40:00',3.26),('8975','2013-07-02','07:45:00',3.35),('8975','2013-07-02','07:50:00',3.45),('8975','2013-07-02','07:55:00',3.57),('8975','2013-07-02','08:00:00',3.6),('8975','2013-07-02','08:05:00',3.72),('8975','2013-07-02','08:10:00',3.86),('8975','2013-07-02','08:15:00',3.96),('8975','2013-07-02','08:20:00',4.05),('8975','2013-07-02','08:25:00',4.17),('8975','2013-07-02','08:30:00',4.26),('8975','2013-07-02','08:35:00',4.33),('8975','2013-07-02','08:40:00',4.43),('8975','2013-07-02','08:45:00',4.53),('8975','2013-07-02','08:50:00',4.62),('8975','2013-07-02','08:55:00',4.74),('8975','2013-07-02','09:00:00',4.81),('8975','2013-07-02','09:05:00',4.83),('8975','2013-07-02','09:10:00',4.93),('8975','2013-07-02','09:15:00',5),('8975','2013-07-02','09:20:00',5.09),('8975','2013-07-02','09:25:00',5.19),('8975','2013-07-02','09:30:00',5.2),('8975','2013-07-02','09:35:00',5.27),('8975','2013-07-02','09:40:00',5.38),('8975','2013-07-02','09:45:00',5.42),('8975','2013-07-02','09:50:00',5.53),('8975','2013-07-02','09:55:00',5.49),('8975','2013-07-02','10:00:00',5.56),('8975','2013-07-02','10:05:00',5.64),('8975','2013-07-02','10:10:00',5.68),('8975','2013-07-02','10:15:00',5.68),('8975','2013-07-02','10:20:00',5.77),('8975','2013-07-02','10:25:00',5.83),('8975','2013-07-02','10:30:00',5.9),('8975','2013-07-02','10:35:00',5.99),('8975','2013-07-02','10:40:00',6.08),('8975','2013-07-02','10:45:00',6.05),('8975','2013-07-02','10:50:00',6.2),('8975','2013-07-02','10:55:00',6.33),('8975','2013-07-02','11:00:00',6.34),('8975','2013-07-02','11:05:00',6.38),('8975','2013-07-02','11:10:00',6.4),('8975','2013-07-02','11:15:00',6.44),('8975','2013-07-02','11:20:00',6.47),('8975','2013-07-02','11:25:00',6.48),('8975','2013-07-02','11:30:00',6.51),('8975','2013-07-02','11:35:00',6.55),('8975','2013-07-02','11:40:00',6.6),('8975','2013-07-02','11:45:00',6.69),('8975','2013-07-02','11:50:00',6.55),('8975','2013-07-02','11:55:00',6.65),('8975','2013-07-02','12:00:00',6.65),('8975','2013-07-02','12:05:00',6.7),('8975','2013-07-02','12:10:00',6.74),('8975','2013-07-02','12:15:00',6.72),('8975','2013-07-02','12:20:00',6.76),('8975','2013-07-02','12:25:00',6.76),('8975','2013-07-02','12:30:00',6.73),('8975','2013-07-02','12:35:00',6.73),('8975','2013-07-02','12:40:00',6.78),('8975','2013-07-02','12:45:00',6.83),('8975','2013-07-02','12:50:00',6.83),('8975','2013-07-02','12:55:00',6.82),('8975','2013-07-02','13:00:00',6.8),('8975','2013-07-02','13:05:00',6.73),('8975','2013-07-02','13:10:00',6.7),('8975','2013-07-02','13:15:00',5.86),('8975','2013-07-02','13:20:00',5.75),('8975','2013-07-02','13:25:00',6.47),('8975','2013-07-02','13:30:00',6.24),('8975','2013-07-02','13:35:00',6.31),('8975','2013-07-02','13:40:00',6.36),('8975','2013-07-02','13:45:00',6),('8975','2013-07-02','13:50:00',5.63),('8975','2013-07-02','13:55:00',5.75),('8975','2013-07-02','14:00:00',5.71),('8975','2013-07-02','14:05:00',6.2),('8975','2013-07-02','14:10:00',6.3),('8975','2013-07-02','14:15:00',6.26),('8975','2013-07-02','14:20:00',6.23),('8975','2013-07-02','14:25:00',6.18),('8975','2013-07-02','14:30:00',6.12),('8975','2013-07-02','14:35:00',6.03),('8975','2013-07-02','14:40:00',6.01),('8975','2013-07-02','14:45:00',5.93),('8975','2013-07-02','14:50:00',5.89),('8975','2013-07-02','14:55:00',5.8),('8975','2013-07-02','15:00:00',5.73),('8975','2013-07-02','15:05:00',5.64),('8975','2013-07-02','15:10:00',5.58),('8975','2013-07-02','15:15:00',5.51),('8975','2013-07-02','15:20:00',5.43),('8975','2013-07-02','15:25:00',5.32),('8975','2013-07-02','15:30:00',5.24),('8975','2013-07-02','15:35:00',5.14),('8975','2013-07-02','15:40:00',5.04),('8975','2013-07-02','15:45:00',4.94),('8975','2013-07-02','15:50:00',4.83),('8975','2013-07-02','15:55:00',4.75),('8975','2013-07-02','16:00:00',4.64),('8975','2013-07-02','16:05:00',4.51),('8975','2013-07-02','16:10:00',4.44),('8975','2013-07-02','16:15:00',4.34),('8975','2013-07-02','16:20:00',4.24),('8975','2013-07-02','16:25:00',4.14),('8975','2013-07-02','16:30:00',4.03),('8975','2013-07-02','16:35:00',3.92),('8975','2013-07-02','16:40:00',3.79),('8975','2013-07-02','16:45:00',3.68),('8975','2013-07-02','16:50:00',3.56),('8975','2013-07-02','16:55:00',3.45),('8975','2013-07-02','17:00:00',3.33),('8975','2013-07-02','17:05:00',3.21),('8975','2013-07-02','17:10:00',3.1),('8975','2013-07-02','17:15:00',2.97),('8975','2013-07-02','17:20:00',2.85),('8975','2013-07-02','17:25:00',2.73),('8975','2013-07-02','17:30:00',2.62),('8975','2013-07-02','17:35:00',2.5),('8975','2013-07-02','17:40:00',2.4),('8975','2013-07-02','17:45:00',2.29),('8975','2013-07-02','17:50:00',2.18),('8975','2013-07-02','17:55:00',2.07),('8975','2013-07-02','18:00:00',1.97),('8975','2013-07-02','18:05:00',1.88),('8975','2013-07-02','18:10:00',1.79),('8975','2013-07-02','18:15:00',1.7),('8975','2013-07-02','18:20:00',1.62),('8975','2013-07-02','18:25:00',1.55),('8975','2013-07-02','18:30:00',1.48),('8975','2013-07-02','18:35:00',1.42),('8975','2013-07-02','18:40:00',1.37),('8975','2013-07-02','18:45:00',1.32),('8975','2013-07-02','18:50:00',1.26),('8975','2013-07-02','18:55:00',1.23),('8975','2013-07-02','19:00:00',1.18),('8975','2013-07-02','19:05:00',1.11),('8975','2013-07-02','19:10:00',1.06),('8975','2013-07-02','19:15:00',1.02),('8975','2013-07-01','06:30:00',1.15),('8975','2013-07-01','06:35:00',1.32),('8975','2013-07-01','06:40:00',1.47),('8975','2013-07-01','06:45:00',1.64),('8975','2013-07-01','06:50:00',1.8),('8975','2013-07-01','06:55:00',1.95),('8975','2013-07-01','07:00:00',2.1),('8975','2013-07-01','07:05:00',2.24),('8975','2013-07-01','07:10:00',2.38),('8975','2013-07-01','07:15:00',2.52),('8975','2013-07-01','07:20:00',2.64),('8975','2013-07-01','07:25:00',2.77),('8975','2013-07-01','07:30:00',2.88),('8975','2013-07-01','07:35:00',3.01),('8975','2013-07-01','07:40:00',3.12),('8975','2013-07-01','07:45:00',3.22),('8975','2013-07-01','07:50:00',3.33),('8975','2013-07-01','07:55:00',3.44),('8975','2013-07-01','08:00:00',3.55),('8975','2013-07-01','08:05:00',3.66),('8975','2013-07-01','08:10:00',3.76),('8975','2013-07-01','08:15:00',3.85),('8975','2013-07-01','08:20:00',3.96),('8975','2013-07-01','08:25:00',4.09),('8975','2013-07-01','08:30:00',4.19),('8975','2013-07-01','08:35:00',4.3),('8975','2013-07-01','08:40:00',4.4),('8975','2013-07-01','08:45:00',4.49),('8975','2013-07-01','08:50:00',4.57),('8975','2013-07-01','08:55:00',4.67),('8975','2013-07-01','09:00:00',4.77),('8975','2013-07-01','09:05:00',4.87),('8975','2013-07-01','09:10:00',4.93),('8975','2013-07-01','09:15:00',5.01),('8975','2013-07-01','09:20:00',5.1),('8975','2013-07-01','09:25:00',5.17),('8975','2013-07-01','09:30:00',5.21),('8975','2013-07-01','09:35:00',5.32),('8975','2013-07-01','09:40:00',5.37),('8975','2013-07-01','09:45:00',5.42),('8975','2013-07-01','09:50:00',5.45),('8975','2013-07-01','09:55:00',5.52),('8975','2013-07-01','10:00:00',5.61),('8975','2013-07-01','10:05:00',5.68),('8975','2013-07-01','10:10:00',5.69),('8975','2013-07-01','10:15:00',5.78),('8975','2013-07-01','10:20:00',5.87),('8975','2013-07-01','10:25:00',5.92),('8975','2013-07-01','10:30:00',5.94),('8975','2013-07-01','10:35:00',6.01),('8975','2013-07-01','10:40:00',6.06),('8975','2013-07-01','10:45:00',6.1),('8975','2013-07-01','10:50:00',6.12),('8975','2013-07-01','10:55:00',6.15),('8975','2013-07-01','11:00:00',6.14),('8975','2013-07-01','11:05:00',6.18),('8975','2013-07-01','11:10:00',6.28),('8975','2013-07-01','11:15:00',6.19),('8975','2013-07-01','11:20:00',6.22),('8975','2013-07-01','11:25:00',6.28),('8975','2013-07-01','11:30:00',6.27),('8975','2013-07-01','11:35:00',6.21),('8975','2013-07-01','11:40:00',6.28),('8975','2013-07-01','11:45:00',6.21),('8975','2013-07-01','11:50:00',6.24),('8975','2013-07-01','11:55:00',6.19),('8975','2013-07-01','12:00:00',6.23),('8975','2013-07-01','12:05:00',6.33),('8975','2013-07-01','12:10:00',6.35),('8975','2013-07-01','12:15:00',6.34),('8975','2013-07-01','12:20:00',6.42),('8975','2013-07-01','12:25:00',6.45),('8975','2013-07-01','12:30:00',2.84),('8975','2013-07-01','12:35:00',3.53),('8975','2013-07-01','12:40:00',6.94),('8975','2013-07-01','12:45:00',2.05),('8975','2013-07-01','12:50:00',1.65),('8975','2013-07-01','12:55:00',1.45),('8975','2013-07-01','13:00:00',1.33),('8975','2013-07-01','13:05:00',1.26),('8975','2013-07-01','13:10:00',1.47),('8975','2013-07-01','13:15:00',5.76),('8975','2013-07-01','13:20:00',7.01),('8975','2013-07-01','13:25:00',6.77),('8975','2013-07-01','13:30:00',6.58),('8975','2013-07-01','13:35:00',6.46),('8975','2013-07-01','13:40:00',6.55),('8975','2013-07-01','13:45:00',6.36),('8975','2013-07-01','13:50:00',6.12),('8975','2013-07-01','13:55:00',6.27),('8975','2013-07-01','14:00:00',6.21),('8975','2013-07-01','14:05:00',6.28),('8975','2013-07-01','14:10:00',6.12),('8975','2013-07-01','14:15:00',6.12),('8975','2013-07-01','14:20:00',6.06),('8975','2013-07-01','14:25:00',6.03),('8975','2013-07-01','14:30:00',6),('8975','2013-07-01','14:35:00',5.91),('8975','2013-07-01','14:40:00',5.85),('8975','2013-07-01','14:45:00',5.82),('8975','2013-07-01','14:50:00',5.75),('8975','2013-07-01','14:55:00',5.65),('8975','2013-07-01','15:00:00',5.59),('8975','2013-07-01','15:05:00',5.54),('8975','2013-07-01','15:10:00',5.45),('8975','2013-07-01','15:15:00',5.38),('8975','2013-07-01','15:20:00',5.3),('8975','2013-07-01','15:25:00',5.24),('8975','2013-07-01','15:30:00',5.15),('8975','2013-07-01','15:35:00',5.06),('8975','2013-07-01','15:40:00',4.97),('8975','2013-07-01','15:45:00',4.86),('8975','2013-07-01','15:50:00',4.76),('8975','2013-07-01','15:55:00',4.68),('8975','2013-07-01','16:00:00',4.6),('8975','2013-07-01','16:05:00',4.49),('8975','2013-07-01','16:10:00',4.38),('8975','2013-07-01','16:15:00',4.27),('8975','2013-07-01','16:20:00',4.16),('8975','2013-07-01','16:25:00',4.05),('8975','2013-07-01','16:30:00',3.97),('8975','2013-07-01','16:35:00',3.86),('8975','2013-07-01','16:40:00',3.75),('8975','2013-07-01','16:45:00',3.64),('8975','2013-07-01','16:50:00',3.53),('8975','2013-07-01','16:55:00',3.39),('8975','2013-07-01','17:00:00',3.28),('8975','2013-07-01','17:05:00',3.16),('8975','2013-07-01','17:10:00',3.03),('8975','2013-07-01','17:15:00',2.92),('8975','2013-07-01','17:20:00',2.81),('8975','2013-07-01','17:25:00',2.67),('8975','2013-07-01','17:30:00',2.39),('8975','2013-07-01','17:35:00',2.29),('8975','2013-07-01','17:40:00',2.09),('8975','2013-07-01','17:45:00',2.02),('8975','2013-07-01','17:50:00',1.79),('8975','2013-07-01','17:55:00',1.9),('8975','2013-07-01','18:00:00',1.71),('8975','2013-07-01','18:05:00',1.77),('8975','2013-07-01','18:10:00',1.6),('8975','2013-07-01','18:15:00',1.37),('8975','2013-07-01','18:20:00',1.47),('8975','2013-07-01','18:25:00',1.42),('8975','2013-07-01','18:30:00',1.16),('8975','2013-07-01','18:35:00',1.29),('8975','2013-07-01','18:40:00',1.26),('8975','2013-07-01','18:45:00',1.27),('8975','2013-07-01','18:50:00',1.21),('8975','2013-07-01','18:55:00',1.16),('8975','2013-07-01','19:00:00',1.1),('8975','2013-07-01','19:05:00',1.06),('8975','2013-07-01','19:10:00',1.01),('8975','2013-06-30','06:30:00',1.14),('8975','2013-06-30','06:35:00',1.25),('8975','2013-06-30','06:40:00',1.43),('8975','2013-06-30','06:45:00',1.58),('8975','2013-06-30','06:50:00',1.76),('8975','2013-06-30','06:55:00',1.88),('8975','2013-06-30','07:00:00',2.05),('8975','2013-06-30','07:05:00',2.17),('8975','2013-06-30','07:10:00',2.34),('8975','2013-06-30','07:15:00',2.53),('8975','2013-06-30','07:20:00',2.63),('8975','2013-06-30','07:25:00',2.74),('8975','2013-06-30','07:30:00',2.89),('8975','2013-06-30','07:35:00',3),('8975','2013-06-30','07:40:00',3.1),('8975','2013-06-30','07:45:00',3.21),('8975','2013-06-30','07:50:00',3.34),('8975','2013-06-30','07:55:00',3.48),('8975','2013-06-30','08:00:00',3.6),('8975','2013-06-30','08:05:00',3.7),('8975','2013-06-30','08:10:00',3.81),('8975','2013-06-30','08:15:00',3.91),('8975','2013-06-30','08:20:00',4.01),('8975','2013-06-30','08:25:00',4.15),('8975','2013-06-30','08:30:00',4.27),('8975','2013-06-30','08:35:00',4.39),('8975','2013-06-30','08:40:00',4.54),('8975','2013-06-30','08:45:00',4.64),('8975','2013-06-30','08:50:00',4.71),('8975','2013-06-30','08:55:00',4.78),('8975','2013-06-30','09:00:00',4.88),('8975','2013-06-30','09:05:00',4.98),('8975','2013-06-30','09:10:00',5.05),('8975','2013-06-30','09:15:00',5.11),('8975','2013-06-30','09:20:00',5.22),('8975','2013-06-30','09:25:00',5.26),('8975','2013-06-30','09:30:00',5.38),('8975','2013-06-30','09:35:00',5.45),('8975','2013-06-30','09:40:00',5.53),('8975','2013-06-30','09:45:00',5.61),('8975','2013-06-30','09:50:00',5.66),('8975','2013-06-30','09:55:00',5.71),('8975','2013-06-30','10:00:00',5.8),('8975','2013-06-30','10:05:00',5.88),('8975','2013-06-30','10:10:00',5.94),('8975','2013-06-30','10:15:00',6.03),('8975','2013-06-30','10:20:00',6.08),('8975','2013-06-30','10:25:00',6.13),('8975','2013-06-30','10:30:00',6.19),('8975','2013-06-30','10:35:00',6.23),('8975','2013-06-30','10:40:00',6.27),('8975','2013-06-30','10:45:00',6.31),('8975','2013-06-30','10:50:00',6.36),('8975','2013-06-30','10:55:00',6.41),('8975','2013-06-30','11:00:00',6.47),('8975','2013-06-30','11:05:00',6.45),('8975','2013-06-30','11:10:00',6.46),('8975','2013-06-30','11:15:00',6.52),('8975','2013-06-30','11:20:00',6.45),('8975','2013-06-30','11:25:00',6.55),('8975','2013-06-30','11:30:00',6.6),('8975','2013-06-30','11:35:00',6.67),('8975','2013-06-30','11:40:00',6.76),('8975','2013-06-30','11:45:00',6.75),('8975','2013-06-30','11:50:00',6.77),('8975','2013-06-30','11:55:00',6.77),('8975','2013-06-30','12:00:00',6.76),('8975','2013-06-30','12:05:00',6.73),('8975','2013-06-30','12:10:00',6.79),('8975','2013-06-30','12:15:00',6.8),('8975','2013-06-30','12:20:00',6.86),('8975','2013-06-30','12:25:00',6.87),('8975','2013-06-30','12:30:00',6.86),('8975','2013-06-30','12:35:00',6.84),('8975','2013-06-30','12:40:00',6.85),('8975','2013-06-30','12:45:00',6.81),('8975','2013-06-30','12:50:00',6.77),('8975','2013-06-30','12:55:00',6.75),('8975','2013-06-30','13:00:00',6.7),('8975','2013-06-30','13:05:00',6.64),('8975','2013-06-30','13:10:00',6.62),('8975','2013-06-30','13:15:00',6.58),('8975','2013-06-30','13:20:00',6.34),('8975','2013-06-30','13:25:00',6.66),('8975','2013-06-30','13:30:00',6.64),('8975','2013-06-30','13:35:00',6.6),('8975','2013-06-30','13:40:00',6.49),('8975','2013-06-30','13:45:00',6.29),('8975','2013-06-30','13:50:00',6.39),('8975','2013-06-30','13:55:00',6.42),('8975','2013-06-30','14:00:00',6.34),('8975','2013-06-30','14:05:00',6.38),('8975','2013-06-30','14:10:00',6.32),('8975','2013-06-30','14:15:00',6.29),('8975','2013-06-30','14:20:00',6.28),('8975','2013-06-30','14:25:00',6.17),('8975','2013-06-30','14:30:00',6.07),('8975','2013-06-30','14:35:00',6),('8975','2013-06-30','14:40:00',5.99),('8975','2013-06-30','14:45:00',5.89),('8975','2013-06-30','14:50:00',5.77),('8975','2013-06-30','14:55:00',5.68),('8975','2013-06-30','15:00:00',5.6),('8975','2013-06-30','15:05:00',5.56),('8975','2013-06-30','15:10:00',5.47),('8975','2013-06-30','15:15:00',5.44),('8975','2013-06-30','15:20:00',5.33),('8975','2013-06-30','15:25:00',5.27),('8975','2013-06-30','15:30:00',5.16),('8975','2013-06-30','15:35:00',5.02),('8975','2013-06-30','15:40:00',4.94),('8975','2013-06-30','15:45:00',4.87),('8975','2013-06-30','15:50:00',4.78),('8975','2013-06-30','15:55:00',4.67),('8975','2013-06-30','16:00:00',4.56),('8975','2013-06-30','16:05:00',4.48),('8975','2013-06-30','16:10:00',4.38),('8975','2013-06-30','16:15:00',4.24),('8975','2013-06-30','16:20:00',4.13),('8975','2013-06-30','16:25:00',4),('8975','2013-06-30','16:30:00',3.93),('8975','2013-06-30','16:35:00',3.82),('8975','2013-06-30','16:40:00',3.71),('8975','2013-06-30','16:45:00',3.6),('8975','2013-06-30','16:50:00',3.5),('8975','2013-06-30','16:55:00',3.39),('8975','2013-06-30','17:00:00',3.27),('8975','2013-06-30','17:05:00',3.14),('8975','2013-06-30','17:10:00',3.04),('8975','2013-06-30','17:15:00',2.91),('8975','2013-06-30','17:20:00',2.81),('8975','2013-06-30','17:25:00',2.67),('8975','2013-06-30','17:30:00',2.56),('8975','2013-06-30','17:35:00',2.46),('8975','2013-06-30','17:40:00',2.34),('8975','2013-06-30','17:45:00',2.26),('8975','2013-06-30','17:50:00',2.15),('8975','2013-06-30','17:55:00',1.98),('8975','2013-06-30','18:00:00',1.85),('8975','2013-06-30','18:05:00',1.85),('8975','2013-06-30','18:10:00',1.74),('8975','2013-06-30','18:15:00',1.43),('8975','2013-06-30','18:20:00',1.42),('8975','2013-06-30','18:25:00',1.59),('8975','2013-06-30','18:30:00',1.54),('8975','2013-06-30','18:35:00',1.46),('8975','2013-06-30','18:40:00',1.34),('8975','2013-06-30','18:45:00',1.28),('8975','2013-06-30','18:50:00',1.22),('8975','2013-06-30','18:55:00',1.14),('8975','2013-06-30','19:00:00',1.11),('8975','2013-06-30','19:05:00',1.04),('8975','2014-04-04','08:40:00',1.05),('8975','2014-04-04','08:55:00',1.03),('8975','2014-04-04','09:00:00',1.12),('8975','2014-04-04','09:05:00',1.36),('8975','2014-04-04','09:10:00',1.7),('8975','2014-04-04','09:15:00',2.05),('8975','2014-04-04','09:20:00',2.69),('8975','2014-04-04','09:25:00',3.23),('8975','2014-04-04','09:30:00',6.56),('8975','2014-04-04','09:35:00',6.39),('8975','2014-04-04','09:40:00',5.81),('8975','2014-04-04','09:45:00',5.26),('8975','2014-04-04','09:50:00',5.32),('8975','2014-04-04','09:55:00',4.03),('8975','2014-04-04','10:00:00',4.28),('8975','2014-04-04','10:05:00',5.13),('8975','2014-04-04','10:10:00',3.01),('8975','2014-04-04','10:15:00',4.16),('8975','2014-04-04','10:20:00',4.96),('8975','2014-04-04','10:25:00',4.74),('8975','2014-04-04','10:30:00',4.32),('8975','2014-04-04','10:35:00',5.22),('8975','2014-04-04','10:40:00',5.45),('8975','2014-04-04','10:45:00',5.97),('8975','2014-04-04','10:50:00',5.18),('8975','2014-04-04','10:55:00',4.43),('8975','2014-04-04','11:00:00',5.07),('8975','2014-04-04','11:05:00',6.06),('8975','2014-04-04','11:10:00',6.57),('8975','2014-04-04','11:15:00',6.08),('8975','2014-04-04','11:20:00',6.7),('8975','2014-04-04','11:25:00',6.87),('8975','2014-04-04','11:30:00',4.71),('8975','2014-04-04','11:35:00',3.51),('8975','2014-04-04','11:40:00',4.65),('8975','2014-04-04','11:45:00',5.89),('8975','2014-04-04','11:50:00',6.51),('8975','2014-04-04','11:55:00',6.67),('8975','2014-04-04','12:00:00',6.12),('8975','2014-04-04','12:05:00',5.46),('8975','2014-04-04','12:10:00',4.61),('8975','2014-04-04','12:15:00',5.63),('8975','2014-04-04','12:20:00',5.8),('8975','2014-04-04','12:25:00',5.24),('8975','2014-04-04','12:30:00',4.26),('8975','2014-04-04','12:35:00',4.04),('8975','2014-04-04','12:40:00',5.37),('8975','2014-04-04','12:45:00',7.02),('8975','2014-04-04','12:50:00',7.6),('8975','2014-04-04','12:55:00',5.53),('8975','2014-04-04','13:00:00',5.85),('8975','2014-04-04','13:05:00',5.15),('8975','2014-04-04','13:10:00',2.86),('8975','2014-04-04','13:15:00',2.47),('8975','2014-04-04','13:20:00',2.19),('8975','2014-04-04','13:25:00',4.7),('8975','2014-04-04','13:30:00',6.26),('8975','2014-04-04','13:35:00',2.89),('8975','2014-04-04','13:40:00',4.26),('8975','2014-04-04','13:45:00',3.15),('8975','2014-04-04','13:50:00',3.28),('8975','2014-04-04','13:55:00',5.16),('8975','2014-04-04','14:00:00',3.97),('8975','2014-04-04','14:05:00',4.81),('8975','2014-04-04','14:10:00',6.96),('8975','2014-04-04','14:15:00',2.92),('8975','2014-04-04','14:20:00',1.62),('8975','2014-04-04','14:25:00',1.64),('8975','2014-04-04','14:30:00',2.86),('8975','2014-04-04','14:35:00',5.15),('8975','2014-04-04','14:40:00',1.64),('8975','2014-04-04','14:45:00',1.29),('8975','2014-04-04','14:50:00',1.02),('8975','2014-04-04','14:55:00',1.32),('8975','2014-04-04','15:00:00',5.73),('8975','2014-04-04','15:05:00',5.55),('8975','2014-04-04','15:10:00',5.68),('8975','2014-04-04','15:15:00',4.05),('8975','2014-04-04','15:20:00',5.3),('8975','2014-04-04','15:25:00',5.54),('8975','2014-04-04','15:30:00',4.87),('8975','2014-04-04','15:35:00',2.29),('8975','2014-04-04','15:40:00',3.77),('8975','2014-04-04','15:45:00',2.45),('8975','2014-04-04','15:50:00',2.53),('8975','2014-04-04','15:55:00',2.28),('8975','2014-04-04','16:00:00',2.03),('8975','2014-04-04','16:05:00',1.89),('8975','2014-04-04','16:10:00',1.76),('8975','2014-04-04','16:15:00',2.64),('8975','2014-04-04','16:20:00',4.56),('8975','2014-04-04','16:25:00',4.81),('8975','2014-04-04','16:30:00',3.72),('8975','2014-04-04','16:35:00',3.6),('8975','2014-04-04','16:40:00',3.3),('8975','2014-04-04','16:45:00',2.33),('8975','2014-04-04','16:50:00',2.01),('8975','2014-04-04','16:55:00',2.37),('8975','2014-04-04','17:00:00',1.95),('8975','2014-04-04','17:05:00',1.98),('8975','2014-04-04','17:10:00',1.98),('8975','2014-04-04','17:15:00',1.54),('8975','2014-04-04','17:20:00',1.39),('8975','2014-04-04','17:25:00',1.55),('8975','2014-04-04','17:30:00',1.6),('8975','2014-04-04','17:35:00',1.38),('8975','2014-04-04','17:40:00',1.08),('8975','2014-04-04','17:45:00',1.09),('8975','2014-04-04','17:50:00',1.14),('8975','2014-04-04','17:55:00',1.41),('8975','2014-04-04','18:00:00',1.51),('8975','2014-04-04','18:05:00',1.6),('8975','2014-04-04','18:10:00',1.59),('8975','2014-04-04','18:15:00',1.58),('8975','2014-04-04','18:20:00',1.51),('8975','2014-04-04','18:25:00',1.11),('8975','2013-06-29','06:20:00',1.14),('8975','2013-06-29','06:25:00',1.3),('8975','2013-06-29','06:30:00',1.43),('8975','2013-06-29','06:35:00',1.63),('8975','2013-06-29','06:40:00',1.82),('8975','2013-06-29','06:45:00',1.95),('8975','2013-06-29','06:50:00',2.08),('8975','2013-06-29','06:55:00',2.21),('8975','2013-06-29','07:00:00',2.34),('8975','2013-06-29','07:05:00',2.47),('8975','2013-06-29','07:10:00',2.6),('8975','2013-06-29','07:15:00',2.72),('8975','2013-06-29','07:20:00',2.85),('8975','2013-06-29','07:25:00',2.97),('8975','2013-06-29','07:30:00',3.07),('8975','2013-06-29','07:35:00',3.22),('8975','2013-06-29','07:40:00',3.32),('8975','2013-06-29','07:45:00',3.42),('8975','2013-06-29','07:50:00',3.55),('8975','2013-06-29','07:55:00',3.66),('8975','2013-06-29','08:00:00',3.76),('8975','2013-06-29','08:05:00',3.88),('8975','2013-06-29','08:10:00',3.99),('8975','2013-06-29','08:15:00',4.1),('8975','2013-06-29','08:20:00',4.21),('8975','2013-06-29','08:25:00',4.32),('8975','2013-06-29','08:30:00',4.4),('8975','2013-06-29','08:35:00',4.5),('8975','2013-06-29','08:40:00',4.62),('8975','2013-06-29','08:45:00',4.71),('8975','2013-06-29','08:50:00',4.81),('8975','2013-06-29','08:55:00',4.9),('8975','2013-06-29','09:00:00',4.99),('8975','2013-06-29','09:05:00',5.08),('8975','2013-06-29','09:10:00',5.17),('8975','2013-06-29','09:15:00',5.26),('8975','2013-06-29','09:20:00',5.35),('8975','2013-06-29','09:25:00',5.46),('8975','2013-06-29','09:30:00',5.53),('8975','2013-06-29','09:35:00',5.6),('8975','2013-06-29','09:40:00',5.69),('8975','2013-06-29','09:45:00',5.76),('8975','2013-06-29','09:50:00',5.84),('8975','2013-06-29','09:55:00',5.91),('8975','2013-06-29','10:00:00',5.99),('8975','2013-06-29','10:05:00',6.07),('8975','2013-06-29','10:10:00',6.12),('8975','2013-06-29','10:15:00',6.18),('8975','2013-06-29','10:20:00',6.21),('8975','2013-06-29','10:25:00',6.3),('8975','2013-06-29','10:30:00',6.36),('8975','2013-06-29','10:35:00',6.4),('8975','2013-06-29','10:40:00',6.49),('8975','2013-06-29','10:45:00',6.52),('8975','2013-06-29','10:50:00',6.52),('8975','2013-06-29','10:55:00',6.54),('8975','2013-06-29','11:00:00',6.56),('8975','2013-06-29','11:05:00',6.6),('8975','2013-06-29','11:10:00',6.63),('8975','2013-06-29','11:15:00',6.67),('8975','2013-06-29','11:20:00',6.7),('8975','2013-06-29','11:25:00',6.78),('8975','2013-06-29','11:30:00',6.82),('8975','2013-06-29','11:35:00',6.78),('8975','2013-06-29','11:40:00',6.76),('8975','2013-06-29','11:45:00',6.83),('8975','2013-06-29','11:50:00',6.86),('8975','2013-06-29','11:55:00',6.87),('8975','2013-06-29','12:00:00',6.9),('8975','2013-06-29','12:05:00',6.89),('8975','2013-06-29','12:10:00',6.92),('8975','2013-06-29','12:15:00',6.9),('8975','2013-06-29','12:20:00',6.95),('8975','2013-06-29','12:25:00',6.94),('8975','2013-06-29','12:30:00',6.97),('8975','2013-06-29','12:35:00',7),('8975','2013-06-29','12:40:00',6.96),('8975','2013-06-29','12:45:00',6.91),('8975','2013-06-29','12:50:00',6.84),('8975','2013-06-29','12:55:00',6.81),('8975','2013-06-29','13:00:00',6.85),('8975','2013-06-29','13:05:00',6.97),('8975','2013-06-29','13:10:00',6.99),('8975','2013-06-29','13:15:00',6.89),('8975','2013-06-29','13:20:00',6.83),('8975','2013-06-29','13:25:00',6.81),('8975','2013-06-29','13:30:00',6.77),('8975','2013-06-29','13:35:00',6.81),('8975','2013-06-29','13:40:00',6.79),('8975','2013-06-29','13:45:00',6.34),('8975','2013-06-29','13:50:00',6.27),('8975','2013-06-29','13:55:00',6.65),('8975','2013-06-29','14:00:00',6.63),('8975','2013-06-29','14:05:00',6.42),('8975','2013-06-29','14:10:00',6.35),('8975','2013-06-29','14:15:00',6.33),('8975','2013-06-29','14:20:00',6.28),('8975','2013-06-29','14:25:00',6.22),('8975','2013-06-29','14:30:00',6.14),('8975','2013-06-29','14:35:00',6.07),('8975','2013-06-29','14:40:00',5.98),('8975','2013-06-29','14:45:00',5.88),('8975','2013-06-29','14:50:00',5.86),('8975','2013-06-29','14:55:00',5.84),('8975','2013-06-29','15:00:00',5.78),('8975','2013-06-29','15:05:00',5.68),('8975','2013-06-29','15:10:00',5.65),('8975','2013-06-29','15:15:00',5.62),('8975','2013-06-29','15:20:00',5.54),('8975','2013-06-29','15:25:00',5.47),('8975','2013-06-29','15:30:00',5.43),('8975','2013-06-29','15:35:00',5.3),('8975','2013-06-29','15:40:00',5.22),('8975','2013-06-29','15:45:00',5.11),('8975','2013-06-29','15:50:00',5.02),('8975','2013-06-29','15:55:00',4.92),('8975','2013-06-29','16:00:00',4.78),('8975','2013-06-29','16:05:00',4.69),('8975','2013-06-29','16:10:00',4.68),('8975','2013-06-29','16:15:00',4.6),('8975','2013-06-29','16:20:00',4.51),('8975','2013-06-29','16:25:00',4.47),('8975','2013-06-29','16:30:00',4.59),('8975','2013-06-29','16:35:00',4.36),('8975','2013-06-29','16:40:00',3.96),('8975','2013-06-29','16:45:00',3.75),('8975','2013-06-29','16:50:00',3.64),('8975','2013-06-29','16:55:00',3.54),('8975','2013-06-29','17:00:00',3.4),('8975','2013-06-29','17:05:00',3.32),('8975','2013-06-29','17:10:00',3.25),('8975','2013-06-29','17:15:00',3.09),('8975','2013-06-29','17:20:00',2.91),('8975','2013-06-29','17:25:00',2.78),('8975','2013-06-29','17:30:00',2.64),('8975','2013-06-29','17:35:00',2.49),('8975','2013-06-29','17:40:00',2.4),('8975','2013-06-29','17:45:00',2.33),('8975','2013-06-29','17:50:00',2.27),('8975','2013-06-29','17:55:00',1.43),('8975','2013-06-29','18:00:00',1.76),('8975','2013-06-29','18:05:00',1.9),('8975','2013-06-29','18:10:00',1.83),('8975','2013-06-29','18:15:00',1.72),('8975','2013-06-29','18:20:00',1.66),('8975','2013-06-29','18:25:00',1.59),('8975','2013-06-29','18:30:00',1.51),('8975','2013-06-29','18:35:00',1.43),('8975','2013-06-29','18:40:00',1.37),('8975','2013-06-29','18:45:00',1.31),('8975','2013-06-29','18:50:00',1.27),('8975','2013-06-29','18:55:00',1.21),('8975','2013-06-29','19:00:00',1.16),('8975','2013-06-29','19:05:00',1.1),('8975','2013-06-29','19:10:00',1.05),('8975','2013-06-28','07:25:00',1.94),('8975','2013-06-28','07:30:00',3.33),('8975','2013-06-28','07:35:00',3.77),('8975','2013-06-28','07:40:00',3.89),('8975','2013-06-28','07:45:00',3.85),('8975','2013-06-28','07:50:00',3.91),('8975','2013-06-28','07:55:00',4.15),('8975','2013-06-28','08:00:00',4.5),('8975','2013-06-28','08:05:00',4.71),('8975','2013-06-28','08:10:00',4.88),('8975','2013-06-28','08:15:00',4.43),('8975','2013-06-28','08:20:00',4.73),('8975','2013-06-28','08:25:00',4.9),('8975','2013-06-28','08:30:00',4.73),('8975','2013-06-28','08:35:00',4.77),('8975','2013-06-28','08:40:00',3.54),('8975','2013-06-28','08:45:00',4.1),('8975','2013-06-28','08:50:00',4.91),('8975','2013-06-28','08:55:00',4.98),('8975','2013-06-28','09:00:00',5.07),('8975','2013-06-28','09:05:00',5.13),('8975','2013-06-28','09:10:00',5.19),('8975','2013-06-28','09:15:00',5.23),('8975','2013-06-28','09:20:00',5.3),('8975','2013-06-28','09:25:00',5.39),('8975','2013-06-28','09:30:00',5.47),('8975','2013-06-28','09:35:00',5.58),('8975','2013-06-28','09:40:00',5.67),('8975','2013-06-28','09:45:00',5.76),('8975','2013-06-28','09:50:00',5.83),('8975','2013-06-28','09:55:00',5.89),('8975','2013-06-28','10:00:00',5.94),('8975','2013-06-28','10:05:00',5.98),('8975','2013-06-28','10:10:00',6.06),('8975','2013-06-28','10:15:00',6.14),('8975','2013-06-28','10:20:00',6.14),('8975','2013-06-28','10:25:00',6.16),('8975','2013-06-28','10:30:00',6.29),('8975','2013-06-28','10:35:00',6.3),('8975','2013-06-28','10:40:00',6.36),('8975','2013-06-28','10:45:00',6.44),('8975','2013-06-28','10:50:00',6.47),('8975','2013-06-28','10:55:00',6.56),('8975','2013-06-28','11:00:00',6.6),('8975','2013-06-28','11:05:00',4.96),('8975','2013-06-28','11:10:00',6),('8975','2013-06-28','11:15:00',5.73),('8975','2013-06-28','11:20:00',7.24),('8975','2013-06-28','11:25:00',7.43),('8975','2013-06-28','11:30:00',7.57),('8975','2013-06-28','11:35:00',7.2),('8975','2013-06-28','11:40:00',2.25),('8975','2013-06-28','11:45:00',4.37),('8975','2013-06-28','11:50:00',7.35),('8975','2013-06-28','11:55:00',5.95),('8975','2013-06-28','12:00:00',4.07),('8975','2013-06-28','12:05:00',7.53),('8975','2013-06-28','12:10:00',7.44),('8975','2013-06-28','12:15:00',7.51),('8975','2013-06-28','12:20:00',7.62),('8975','2013-06-28','12:25:00',7.55),('8975','2013-06-28','12:30:00',7.05),('8975','2013-06-28','12:35:00',6.35),('8975','2013-06-28','12:40:00',3.44),('8975','2013-06-28','12:45:00',2.25),('8975','2013-06-28','12:50:00',7.2),('8975','2013-06-28','12:55:00',7.69),('8975','2013-06-28','13:00:00',7.34),('8975','2013-06-28','13:05:00',2.7),('8975','2013-06-28','13:10:00',3.28),('8975','2013-06-28','13:15:00',7.05),('8975','2013-06-28','13:20:00',4.53),('8975','2013-06-28','13:25:00',3.94),('8975','2013-06-28','13:30:00',5.27),('8975','2013-06-28','13:35:00',1.37),('8975','2013-06-28','13:40:00',1.22),('8975','2013-06-28','13:45:00',1.72),('8975','2013-06-28','13:50:00',2.41),('8975','2013-06-28','13:55:00',3.59),('8975','2013-06-28','14:00:00',7.86),('8975','2013-06-28','14:05:00',7.26),('8975','2013-06-28','14:10:00',7.15),('8975','2013-06-28','14:15:00',7.05),('8975','2013-06-28','14:20:00',7.18),('8975','2013-06-28','14:25:00',7.24),('8975','2013-06-28','14:30:00',7.16),('8975','2013-06-28','14:35:00',6.97),('8975','2013-06-28','14:40:00',6.82),('8975','2013-06-28','14:45:00',6.86),('8975','2013-06-28','14:50:00',7.09),('8975','2013-06-28','14:55:00',4.35),('8975','2013-06-28','15:00:00',4.19),('8975','2013-06-28','15:05:00',7.73),('8975','2013-06-28','15:10:00',3.98),('8975','2013-06-28','15:15:00',3.64),('8975','2013-06-28','15:20:00',2.58),('8975','2013-06-28','15:25:00',1.51),('8975','2013-06-28','15:45:00',1.24),('8975','2013-06-28','16:35:00',1.21),('8975','2013-06-28','16:40:00',1.68),('8975','2013-06-28','16:45:00',2.26),('8975','2013-06-28','16:50:00',2.65),('8975','2013-06-28','16:55:00',2.02),('8975','2013-06-28','17:00:00',1.99),('8975','2013-06-28','17:05:00',3.41),('8975','2013-06-28','17:10:00',2.08),('8975','2013-06-28','17:15:00',1.67),('8975','2013-06-28','17:20:00',2.05),('8975','2013-06-28','17:25:00',3.24),('8975','2013-06-28','17:30:00',3.27),('8975','2013-06-28','17:35:00',2.75),('8975','2013-06-28','17:40:00',1.27),('8975','2013-06-28','17:45:00',1.86),('8975','2013-06-28','17:50:00',1.98),('8975','2013-06-28','17:55:00',2.18),('8975','2013-06-28','18:00:00',2),('8975','2013-06-28','18:05:00',1.86),('8975','2013-06-28','18:10:00',1.22),('8975','2013-06-28','18:25:00',1.55),('8975','2013-06-28','18:30:00',1.38),('8975','2013-06-28','18:35:00',1.55),('8975','2013-06-28','18:40:00',1.61),('8975','2013-06-28','18:45:00',1.28),('8975','2013-06-28','19:10:00',1.2),('8975','2013-06-27','06:30:00',1.31),('8975','2013-06-27','06:35:00',1.5),('8975','2013-06-27','06:40:00',1.57),('8975','2013-06-27','07:05:00',2.1),('8975','2013-06-27','07:10:00',2.76),('8975','2013-06-27','07:15:00',2.56),('8975','2013-06-27','07:20:00',2.86),('8975','2013-06-27','07:25:00',3.09),('8975','2013-06-27','07:30:00',3.04),('8975','2013-06-27','07:35:00',3.16),('8975','2013-06-27','07:40:00',3.04),('8975','2013-06-27','07:45:00',3.5),('8975','2013-06-27','07:50:00',3.39),('8975','2013-06-27','07:55:00',3.67),('8975','2013-06-27','08:00:00',3.33),('8975','2013-06-27','08:05:00',3.25),('8975','2013-06-27','08:10:00',3.74),('8975','2013-06-27','08:15:00',3.94),('8975','2013-06-27','08:20:00',4.1),('8975','2013-06-27','08:25:00',3.73),('8975','2013-06-27','08:30:00',4.21),('8975','2013-06-27','08:35:00',4.19),('8975','2013-06-27','08:40:00',4.31),('8975','2013-06-27','08:45:00',4.51),('8975','2013-06-27','08:50:00',4.69),('8975','2013-06-27','08:55:00',4.21),('8975','2013-06-27','09:00:00',4.83),('8975','2013-06-27','09:05:00',4.84),('8975','2013-06-27','09:10:00',3.35),('8975','2013-06-27','09:15:00',3.12),('8975','2013-06-27','09:20:00',1.38),('8975','2013-06-27','09:25:00',5.83),('8975','2013-06-27','09:30:00',5.79),('8975','2013-06-27','09:35:00',5.98),('8975','2013-06-27','09:40:00',6.27),('8975','2013-06-27','09:45:00',3.56),('8975','2013-06-27','09:50:00',5.88),('8975','2013-06-27','09:55:00',5.05),('8975','2013-06-27','10:00:00',6.36),('8975','2013-06-27','10:05:00',6.62),('8975','2013-06-27','10:10:00',6.67),('8975','2013-06-27','10:15:00',4.5),('8975','2013-06-27','10:20:00',2.48),('8975','2013-06-27','10:25:00',4.35),('8975','2013-06-27','10:30:00',4.73),('8975','2013-06-27','10:35:00',2.81),('8975','2013-06-27','10:40:00',3.1),('8975','2013-06-27','10:45:00',5.75),('8975','2013-06-27','10:50:00',7.59),('8975','2013-06-27','10:55:00',5.15),('8975','2013-06-27','11:00:00',6.39),('8975','2013-06-27','11:05:00',5.63),('8975','2013-06-27','11:10:00',3.45),('8975','2013-06-27','11:15:00',2.66),('8975','2013-06-27','11:20:00',5.23),('8975','2013-06-27','11:25:00',6.14),('8975','2013-06-27','11:30:00',7.18),('8975','2013-06-27','11:35:00',7.27),('8975','2013-06-27','11:40:00',6.91),('8975','2013-06-27','11:45:00',6.42),('8975','2013-06-27','11:50:00',6.04),('8975','2013-06-27','11:55:00',6.44),('8975','2013-06-27','12:00:00',5.72),('8975','2013-06-27','12:05:00',4.16),('8975','2013-06-27','12:10:00',4.75),('8975','2013-06-27','12:15:00',3.26),('8975','2013-06-27','12:20:00',6.85),('8975','2013-06-27','12:25:00',7.35),('8975','2013-06-27','12:30:00',7.56),('8975','2013-06-27','12:35:00',7.35),('8975','2013-06-27','12:40:00',6.98),('8975','2013-06-27','12:45:00',7.14),('8975','2013-06-27','12:50:00',5.92),('8975','2013-06-27','12:55:00',4.48),('8975','2013-06-27','13:00:00',7.15),('8975','2013-06-27','13:05:00',6.61),('8975','2013-06-27','13:10:00',6.79),('8975','2013-06-27','13:15:00',6.82),('8975','2013-06-27','13:20:00',6.82),('8975','2013-06-27','13:25:00',5.14),('8975','2013-06-27','13:30:00',7),('8975','2013-06-27','13:35:00',6.92),('8975','2013-06-27','13:40:00',6.65),('8975','2013-06-27','13:45:00',6.1),('8975','2013-06-27','13:50:00',6.75),('8975','2013-06-27','13:55:00',5.39),('8975','2013-06-27','14:00:00',5.83),('8975','2013-06-27','14:05:00',6.38),('8975','2013-06-27','14:10:00',5.37),('8975','2013-06-27','14:15:00',6.12),('8975','2013-06-27','14:20:00',5.01),('8975','2013-06-27','14:25:00',6.3),('8975','2013-06-27','14:30:00',5.11),('8975','2013-06-27','14:35:00',6.34),('8975','2013-06-27','14:40:00',5.66),('8975','2013-06-27','14:45:00',6.54),('8975','2013-06-27','14:50:00',4.36),('8975','2013-06-27','14:55:00',6.07),('8975','2013-06-27','15:00:00',6.33),('8975','2013-06-27','15:05:00',5.48),('8975','2013-06-27','15:10:00',6.18),('8975','2013-06-27','15:15:00',3.69),('8975','2013-06-27','15:20:00',5.72),('8975','2013-06-27','15:25:00',5.82),('8975','2013-06-27','15:30:00',5.22),('8975','2013-06-27','15:35:00',5.72),('8975','2013-06-27','15:40:00',3.59),('8975','2013-06-27','15:45:00',4.54),('8975','2013-06-27','15:50:00',5.72),('8975','2013-06-27','15:55:00',4.89),('8975','2013-06-27','16:00:00',4.63),('8975','2013-06-27','16:05:00',3.27),('8975','2013-06-27','16:10:00',4.11),('8975','2013-06-27','16:15:00',3.41),('8975','2013-06-27','16:20:00',3.43),('8975','2013-06-27','16:25:00',3.53),('8975','2013-06-27','16:30:00',2.36),('8975','2013-06-27','16:35:00',3.52),('8975','2013-06-27','16:40:00',4.05),('8975','2013-06-27','16:45:00',3.91),('8975','2013-06-27','16:50:00',3.65),('8975','2013-06-27','16:55:00',3.54),('8975','2013-06-27','17:00:00',3.38),('8975','2013-06-27','17:05:00',3.27),('8975','2013-06-27','17:10:00',3.08),('8975','2013-06-27','17:15:00',2.99),('8975','2013-06-27','17:20:00',2.88),('8975','2013-06-27','17:25:00',2.87),('8975','2013-06-27','17:30:00',2.63),('8975','2013-06-27','17:35:00',2.52),('8975','2013-06-27','17:40:00',2.41),('8975','2013-06-27','17:45:00',2.32),('8975','2013-06-27','17:50:00',2.24),('8975','2013-06-27','17:55:00',2.12),('8975','2013-06-27','18:00:00',2),('8975','2013-06-27','18:05:00',1.9),('8975','2013-06-27','18:10:00',1.84),('8975','2013-06-27','18:15:00',1.88),('8975','2013-06-27','18:20:00',1.81),('8975','2013-06-27','18:25:00',1.61),('8975','2013-06-27','18:30:00',1.53),('8975','2013-06-27','18:35:00',1.27),('8975','2013-06-27','18:40:00',1.41),('8975','2013-06-27','18:45:00',1.33),('8975','2013-06-27','18:50:00',1.28),('8975','2013-06-27','18:55:00',1.18),('8975','2013-06-27','19:00:00',1.1),('8975','2013-06-27','19:05:00',1.11),('8975','2013-06-26','06:35:00',1.3),('8975','2013-06-26','06:40:00',1.1),('8975','2013-06-26','06:50:00',1.05),('8975','2013-06-26','07:20:00',2.79),('8975','2013-06-26','07:25:00',2.88),('8975','2013-06-26','07:30:00',3.02),('8975','2013-06-26','07:35:00',3.1),('8975','2013-06-26','07:40:00',3.25),('8975','2013-06-26','07:45:00',3.42),('8975','2013-06-26','07:50:00',3.56),('8975','2013-06-26','07:55:00',3.53),('8975','2013-06-26','08:00:00',3.67),('8975','2013-06-26','08:05:00',3.79),('8975','2013-06-26','08:10:00',3.84),('8975','2013-06-26','08:15:00',3.94),('8975','2013-06-26','08:20:00',3.57),('8975','2013-06-26','08:25:00',4.18),('8975','2013-06-26','08:30:00',4.33),('8975','2013-06-26','08:35:00',4.34),('8975','2013-06-26','08:40:00',4.46),('8975','2013-06-26','08:45:00',4.57),('8975','2013-06-26','08:50:00',4.65),('8975','2013-06-26','08:55:00',4.9),('8975','2013-06-26','09:00:00',5.04),('8975','2013-06-26','09:05:00',5),('8975','2013-06-26','09:10:00',5.16),('8975','2013-06-26','09:15:00',5.21),('8975','2013-06-26','09:20:00',5.71),('8975','2013-06-26','09:25:00',5.63),('8975','2013-06-26','09:30:00',5.52),('8975','2013-06-26','09:35:00',5.24),('8975','2013-06-26','09:40:00',5.74),('8975','2013-06-26','09:45:00',5.67),('8975','2013-06-26','09:50:00',5.76),('8975','2013-06-26','09:55:00',3.41),('8975','2013-06-26','10:00:00',2.4),('8975','2013-06-26','10:05:00',2.1),('8975','2013-06-26','10:10:00',3.65),('8975','2013-06-26','10:15:00',3.07),('8975','2013-06-26','10:20:00',6.46),('8975','2013-06-26','10:25:00',6.42),('8975','2013-06-26','10:30:00',6.54),('8975','2013-06-26','10:35:00',5.44),('8975','2013-06-26','10:40:00',7.04),('8975','2013-06-26','10:45:00',7.18),('8975','2013-06-26','10:50:00',6.26),('8975','2013-06-26','10:55:00',5.75),('8975','2013-06-26','11:00:00',2.92),('8975','2013-06-26','11:05:00',7.4),('8975','2013-06-26','11:10:00',7.04),('8975','2013-06-26','11:15:00',6.47),('8975','2013-06-26','11:20:00',1.48),('8975','2013-06-26','11:25:00',5.94),('8975','2013-06-26','11:30:00',3.94),('8975','2013-06-26','11:35:00',3.08),('8975','2013-06-26','11:40:00',3.74),('8975','2013-06-26','11:45:00',2.33),('8975','2013-06-26','11:50:00',2.01),('8975','2013-06-26','11:55:00',2),('8975','2013-06-26','12:00:00',1.85),('8975','2013-06-26','12:05:00',1.76),('8975','2013-06-26','12:10:00',1.81),('8975','2013-06-26','12:15:00',1.52),('8975','2013-06-26','12:20:00',1.6),('8975','2013-06-26','12:25:00',2.07),('8975','2013-06-26','12:30:00',2.59),('8975','2013-06-26','12:35:00',2.51),('8975','2013-06-26','12:40:00',5),('8975','2013-06-26','12:45:00',6.55),('8975','2013-06-26','12:50:00',4.13),('8975','2013-06-26','12:55:00',2.23),('8975','2013-06-26','13:00:00',1.69),('8975','2013-06-26','13:05:00',1.64),('8975','2013-06-26','13:10:00',1.83),('8975','2013-06-26','13:15:00',2.06),('8975','2013-06-26','13:20:00',2.34),('8975','2013-06-26','13:25:00',2.3),('8975','2013-06-26','13:30:00',1.9),('8975','2013-06-26','13:35:00',1.91),('8975','2013-06-26','13:40:00',2.22),('8975','2013-06-26','13:45:00',2.68),('8975','2013-06-26','13:50:00',3.26),('8975','2013-06-26','13:55:00',2.91),('8975','2013-06-26','14:00:00',4.26),('8975','2013-06-26','14:05:00',4.02),('8975','2013-06-26','14:10:00',6.87),('8975','2013-06-26','14:15:00',2.69),('8975','2013-06-26','14:20:00',2.65),('8975','2013-06-26','14:25:00',2.62),('8975','2013-06-26','14:30:00',2.51),('8975','2013-06-26','14:35:00',3.08),('8975','2013-06-26','14:40:00',6.2),('8975','2013-06-26','14:45:00',5.98),('8975','2013-06-26','14:50:00',6.22),('8975','2013-06-26','14:55:00',5.95),('8975','2013-06-26','15:00:00',5.61),('8975','2013-06-26','15:05:00',5.5),('8975','2013-06-26','15:10:00',5.46),('8975','2013-06-26','15:15:00',5.43),('8975','2013-06-26','15:20:00',5.38),('8975','2013-06-26','15:25:00',5.34),('8975','2013-06-26','15:30:00',5.23),('8975','2013-06-26','15:35:00',5.13),('8975','2013-06-26','15:40:00',5.04),('8975','2013-06-26','15:45:00',4.93),('8975','2013-06-26','15:50:00',4.83),('8975','2013-06-26','15:55:00',4.72),('8975','2013-06-26','16:00:00',4.54),('8975','2013-06-26','16:05:00',4.47),('8975','2013-06-26','16:10:00',4.4),('8975','2013-06-26','16:15:00',4.35),('8975','2013-06-26','16:20:00',4.26),('8975','2013-06-26','16:25:00',4.15),('8975','2013-06-26','16:30:00',4.05),('8975','2013-06-26','16:35:00',3.84),('8975','2013-06-26','16:40:00',3.81),('8975','2013-06-26','16:45:00',3.74),('8975','2013-06-26','16:50:00',3.65),('8975','2013-06-26','16:55:00',3.54),('8975','2013-06-26','17:00:00',3.4),('8975','2013-06-26','17:05:00',3.24),('8975','2013-06-26','17:10:00',3.06),('8975','2013-06-26','17:15:00',2.99),('8975','2013-06-26','17:20:00',3.04),('8975','2013-06-26','17:25:00',2.89),('8975','2013-06-26','17:30:00',2.79),('8975','2013-06-26','17:35:00',2.62),('8975','2013-06-26','17:40:00',2.5),('8975','2013-06-26','17:45:00',1.83),('8975','2013-06-26','17:50:00',1.97),('8975','2013-06-26','17:55:00',2.13),('8975','2013-06-26','18:00:00',2.04),('8975','2013-06-26','18:05:00',1.93),('8975','2013-06-26','18:10:00',1.83),('8975','2013-06-26','18:15:00',1.71),('8975','2013-06-26','18:20:00',1.61),('8975','2013-06-26','18:25:00',1.62),('8975','2013-06-26','18:30:00',1.6),('8975','2013-06-26','18:35:00',1.48),('8975','2013-06-26','18:40:00',1.33),('8975','2013-06-26','18:45:00',1.23),('8975','2013-06-26','18:50:00',1.22),('8975','2013-06-26','18:55:00',1.18),('8975','2013-06-26','19:00:00',1.12),('8975','2013-06-26','19:05:00',1.05),('8975','2013-06-25','06:20:00',1.03),('8975','2013-06-25','06:25:00',1.19),('8975','2013-06-25','06:30:00',1.42),('8975','2013-06-25','06:35:00',1.62),('8975','2013-06-25','06:40:00',1.8),('8975','2013-06-25','06:45:00',1.97),('8975','2013-06-25','06:50:00',2.12),('8975','2013-06-25','06:55:00',2.21),('8975','2013-06-25','07:00:00',2.16),('8975','2013-06-25','07:05:00',1.92),('8975','2013-06-25','07:10:00',2.17),('8975','2013-06-25','07:15:00',2.53),('8975','2013-06-25','07:20:00',2.65),('8975','2013-06-25','07:25:00',2.53),('8975','2013-06-25','07:30:00',2.99),('8975','2013-06-25','07:35:00',3.01),('8975','2013-06-25','07:40:00',3.18),('8975','2013-06-25','07:45:00',3.14),('8975','2013-06-25','07:50:00',3.49),('8975','2013-06-25','07:55:00',3.29),('8975','2013-06-25','08:00:00',3.47),('8975','2013-06-25','08:05:00',3.43),('8975','2013-06-25','08:10:00',3.8),('8975','2013-06-25','08:15:00',3.98),('8975','2013-06-25','08:20:00',4.1),('8975','2013-06-25','08:25:00',4.2),('8975','2013-06-25','08:30:00',4.29),('8975','2013-06-25','08:35:00',4.36),('8975','2013-06-25','08:40:00',4.42),('8975','2013-06-25','08:45:00',4.53),('8975','2013-06-25','08:50:00',4.59),('8975','2013-06-25','08:55:00',4.72),('8975','2013-06-25','09:00:00',4.84),('8975','2013-06-25','09:05:00',4.93),('8975','2013-06-25','09:10:00',5),('8975','2013-06-25','09:15:00',5.03),('8975','2013-06-25','09:20:00',5.12),('8975','2013-06-25','09:25:00',5.24),('8975','2013-06-25','09:30:00',5.35),('8975','2013-06-25','09:35:00',5.38),('8975','2013-06-25','09:40:00',5.41),('8975','2013-06-25','09:45:00',5.51),('8975','2013-06-25','09:50:00',5.57),('8975','2013-06-25','09:55:00',5.64),('8975','2013-06-25','10:00:00',5.7),('8975','2013-06-25','10:05:00',5.82),('8975','2013-06-25','10:10:00',5.85),('8975','2013-06-25','10:15:00',5.89),('8975','2013-06-25','10:20:00',6.03),('8975','2013-06-25','10:25:00',6.03),('8975','2013-06-25','10:30:00',6.12),('8975','2013-06-25','10:35:00',6.18),('8975','2013-06-25','10:40:00',6.26),('8975','2013-06-25','10:45:00',6.29),('8975','2013-06-25','10:50:00',6.32),('8975','2013-06-25','10:55:00',6.3),('8975','2013-06-25','11:00:00',6.37),('8975','2013-06-25','11:05:00',6.39),('8975','2013-06-25','11:10:00',6.39),('8975','2013-06-25','11:15:00',6.42),('8975','2013-06-25','11:20:00',6.46),('8975','2013-06-25','11:25:00',6.52),('8975','2013-06-25','11:30:00',6.53),('8975','2013-06-25','11:35:00',6.57),('8975','2013-06-25','11:40:00',6.65),('8975','2013-06-25','11:45:00',6.72),('8975','2013-06-25','11:50:00',6.76),('8975','2013-06-25','11:55:00',6.75),('8975','2013-06-25','12:00:00',6.82),('8975','2013-06-25','12:05:00',6.85),('8975','2013-06-25','12:10:00',6.79),('8975','2013-06-25','12:15:00',6.68),('8975','2013-06-25','12:20:00',6.69),('8975','2013-06-25','12:25:00',6.81),('8975','2013-06-25','12:30:00',6.9),('8975','2013-06-25','12:35:00',6.94),('8975','2013-06-25','12:40:00',6.95),('8975','2013-06-25','12:45:00',7.07),('8975','2013-06-25','12:50:00',7.25),('8975','2013-06-25','12:55:00',7.09),('8975','2013-06-25','13:00:00',7.07),('8975','2013-06-25','13:05:00',7.13),('8975','2013-06-25','13:10:00',7.12),('8975','2013-06-25','13:15:00',6.93),('8975','2013-06-25','13:20:00',6.95),('8975','2013-06-25','13:25:00',7.1),('8975','2013-06-25','13:30:00',7.16),('8975','2013-06-25','13:35:00',6.97),('8975','2013-06-25','13:40:00',6.95),('8975','2013-06-25','13:45:00',6.49),('8975','2013-06-25','13:50:00',6.63),('8975','2013-06-25','13:55:00',6.39),('8975','2013-06-25','14:00:00',6.76),('8975','2013-06-25','14:05:00',6.78),('8975','2013-06-25','14:10:00',6.47),('8975','2013-06-25','14:15:00',2.86),('8975','2013-06-25','14:20:00',5.1),('8975','2013-06-25','14:25:00',3.41),('8975','2013-06-25','14:30:00',2.38),('8975','2013-06-25','14:35:00',3.38),('8975','2013-06-25','14:40:00',5.43),('8975','2013-06-25','14:45:00',6.63),('8975','2013-06-25','14:50:00',6.41),('8975','2013-06-25','14:55:00',6.19),('8975','2013-06-25','15:00:00',5.67),('8975','2013-06-25','15:05:00',5.56),('8975','2013-06-25','15:10:00',5.5),('8975','2013-06-25','15:15:00',5.4),('8975','2013-06-25','15:20:00',5.29),('8975','2013-06-25','15:25:00',5.17),('8975','2013-06-25','15:30:00',5.13),('8975','2013-06-25','15:35:00',5.18),('8975','2013-06-25','15:40:00',5.04),('8975','2013-06-25','15:45:00',4.87),('8975','2013-06-25','15:50:00',4.78),('8975','2013-06-25','15:55:00',4.67),('8975','2013-06-25','16:00:00',4.61),('8975','2013-06-25','16:05:00',4.51),('8975','2013-06-25','16:10:00',4.39),('8975','2013-06-25','16:15:00',4.36),('8975','2013-06-25','16:20:00',4.29),('8975','2013-06-25','16:25:00',4.14),('8975','2013-06-25','16:30:00',4.03),('8975','2013-06-25','16:35:00',3.96),('8975','2013-06-25','16:40:00',3.86),('8975','2013-06-25','16:45:00',3.75),('8975','2013-06-25','16:50:00',3.58),('8975','2013-06-25','16:55:00',3.47),('8975','2013-06-25','17:00:00',3.38),('8975','2013-06-25','17:05:00',3.26),('8975','2013-06-25','17:10:00',3.12),('8975','2013-06-25','17:15:00',2.98),('8975','2013-06-25','17:20:00',2.89),('8975','2013-06-25','17:25:00',2.75),('8975','2013-06-25','17:30:00',2.65),('8975','2013-06-25','17:35:00',2.58),('8975','2013-06-25','17:40:00',2.45),('8975','2013-06-25','17:45:00',2.33),('8975','2013-06-25','17:50:00',2.23),('8975','2013-06-25','17:55:00',2.12),('8975','2013-06-25','18:00:00',2.03),('8975','2013-06-25','18:05:00',2.07),('8975','2013-06-25','18:10:00',2.44),('8975','2013-06-25','18:15:00',1.68),('8975','2013-06-25','18:25:00',1.09),('8975','2013-06-24','06:30:00',1.23),('8975','2013-06-24','06:35:00',1.37),('8975','2013-06-24','06:40:00',1.6),('8975','2013-06-24','06:45:00',1.78),('8975','2013-06-24','06:50:00',1.93),('8975','2013-06-24','06:55:00',2.12),('8975','2013-06-24','07:00:00',2.3),('8975','2013-06-24','07:05:00',2.42),('8975','2013-06-24','07:10:00',2.49),('8975','2013-06-24','07:15:00',2.66),('8975','2013-06-24','07:20:00',2.8),('8975','2013-06-24','07:25:00',2.81),('8975','2013-06-24','07:30:00',2.48),('8975','2013-06-24','07:35:00',1.94),('8975','2013-06-24','07:40:00',3.29),('8975','2013-06-24','07:45:00',3.47),('8975','2013-06-24','07:50:00',3.43),('8975','2013-06-24','07:55:00',2.33),('8975','2013-06-24','08:00:00',1.31),('8975','2013-06-24','08:05:00',2.34),('8975','2013-06-24','08:10:00',4.07),('8975','2013-06-24','08:15:00',4.43),('8975','2013-06-24','08:20:00',4.41),('8975','2013-06-24','08:25:00',4.25),('8975','2013-06-24','08:30:00',4.19),('8975','2013-06-24','08:35:00',4.34),('8975','2013-06-24','08:40:00',4.61),('8975','2013-06-24','08:45:00',4.66),('8975','2013-06-24','08:50:00',4.74),('8975','2013-06-24','08:55:00',4.85),('8975','2013-06-24','09:00:00',4.97),('8975','2013-06-24','09:05:00',5.06),('8975','2013-06-24','09:10:00',5.13),('8975','2013-06-24','09:15:00',5.22),('8975','2013-06-24','09:20:00',5.32),('8975','2013-06-24','09:25:00',5.42),('8975','2013-06-24','09:30:00',5.56),('8975','2013-06-24','09:35:00',5.68),('8975','2013-06-24','09:40:00',5.77),('8975','2013-06-24','09:45:00',6.03),('8975','2013-06-24','09:50:00',6.24),('8975','2013-06-24','09:55:00',6.07),('8975','2013-06-24','10:00:00',3.58),('8975','2013-06-24','10:05:00',1.75),('8975','2013-06-24','10:10:00',1.57),('8975','2013-06-24','10:15:00',1.68),('8975','2013-06-24','10:20:00',3),('8975','2013-06-24','10:25:00',7.43),('8975','2013-06-24','10:30:00',5.54),('8975','2013-06-24','10:35:00',1.78),('8975','2013-06-24','10:40:00',6.56),('8975','2013-06-24','10:45:00',7.3),('8975','2013-06-24','10:50:00',7.08),('8975','2013-06-24','10:55:00',7.11),('8975','2013-06-24','11:00:00',7.2),('8975','2013-06-24','11:05:00',7.19),('8975','2013-06-24','11:10:00',5.85),('8975','2013-06-24','11:15:00',1.9),('8975','2013-06-24','11:20:00',4.56),('8975','2013-06-24','11:25:00',4.8),('8975','2013-06-24','11:30:00',7.99),('8975','2013-06-24','11:35:00',7.91),('8975','2013-06-24','11:40:00',7.58),('8975','2013-06-24','11:45:00',7.73),('8975','2013-06-24','11:50:00',7.68),('8975','2013-06-24','11:55:00',4.81),('8975','2013-06-24','12:00:00',6.11),('8975','2013-06-24','12:05:00',4.11),('8975','2013-06-24','12:10:00',1.85),('8975','2013-06-24','12:15:00',1.86),('8975','2013-06-24','12:20:00',2.17),('8975','2013-06-24','12:25:00',2),('8975','2013-06-24','12:30:00',1.94),('8975','2013-06-24','12:35:00',1.59),('8975','2013-06-24','12:40:00',2.68),('8975','2013-06-24','12:45:00',4.65),('8975','2013-06-24','12:50:00',4.47),('8975','2013-06-24','12:55:00',5.11),('8975','2013-06-24','13:00:00',5.51),('8975','2013-06-24','13:05:00',2.89),('8975','2013-06-24','13:10:00',7.9),('8975','2013-06-24','13:15:00',4.51),('8975','2013-06-24','13:20:00',7.45),('8975','2013-06-24','13:25:00',6.82),('8975','2013-06-24','13:30:00',6.02),('8975','2013-06-24','13:35:00',4.47),('8975','2013-06-24','13:40:00',7.09),('8975','2013-06-24','13:45:00',6.64),('8975','2013-06-24','13:50:00',5.71),('8975','2013-06-24','13:55:00',7.07),('8975','2013-06-24','14:00:00',4.08),('8975','2013-06-24','14:05:00',6.91),('8975','2013-06-24','14:10:00',7),('8975','2013-06-24','14:15:00',6.95),('8975','2013-06-24','14:20:00',6.08),('8975','2013-06-24','14:25:00',6.3),('8975','2013-06-24','14:30:00',5.79),('8975','2013-06-24','14:35:00',6.01),('8975','2013-06-24','14:40:00',6.07),('8975','2013-06-24','14:45:00',6.06),('8975','2013-06-24','14:50:00',6.01),('8975','2013-06-24','14:55:00',5.96),('8975','2013-06-24','15:00:00',5.82),('8975','2013-06-24','15:05:00',5.65),('8975','2013-06-24','15:10:00',5.63),('8975','2013-06-24','15:15:00',5.59),('8975','2013-06-24','15:20:00',5.46),('8975','2013-06-24','15:25:00',5.26),('8975','2013-06-24','15:30:00',5.18),('8975','2013-06-24','15:35:00',5.1),('8975','2013-06-24','15:40:00',4.98),('8975','2013-06-24','15:45:00',4.88),('8975','2013-06-24','15:50:00',4.77),('8975','2013-06-24','15:55:00',4.66),('8975','2013-06-24','16:00:00',4.59),('8975','2013-06-24','16:05:00',4.51),('8975','2013-06-24','16:10:00',4.41),('8975','2013-06-24','16:15:00',4.18),('8975','2013-06-24','16:20:00',4.15),('8975','2013-06-24','16:25:00',3.97),('8975','2013-06-24','16:30:00',3.74),('8975','2013-06-24','16:35:00',3.4),('8975','2013-06-24','16:40:00',3.45),('8975','2013-06-24','16:45:00',3.37),('8975','2013-06-24','16:50:00',3.16),('8975','2013-06-24','16:55:00',3.33),('8975','2013-06-24','17:00:00',3.06),('8975','2013-06-24','17:05:00',2.81),('8975','2013-06-24','17:10:00',2.71),('8975','2013-06-24','17:15:00',2.93),('8975','2013-06-24','17:20:00',2.8),('8975','2013-06-24','17:25:00',2.7),('8975','2013-06-24','17:30:00',2.57),('8975','2013-06-24','17:35:00',2.47),('8975','2013-06-24','17:40:00',2.36),('8975','2013-06-24','17:45:00',2.25),('8975','2013-06-24','17:50:00',2.14),('8975','2013-06-24','17:55:00',2.05),('8975','2013-06-24','18:00:00',1.96),('8975','2013-06-24','18:05:00',1.86),('8975','2013-06-24','18:10:00',1.76),('8975','2013-06-24','18:15:00',1.67),('8975','2013-06-24','18:20:00',1.6),('8975','2013-06-24','18:25:00',1.52),('8975','2013-06-24','18:30:00',1.46),('8975','2013-06-24','18:35:00',1.4),('8975','2013-06-24','18:40:00',1.34),('8975','2013-06-24','18:45:00',1.28),('8975','2013-06-24','18:50:00',1.21),('8975','2013-06-24','18:55:00',1.16),('8975','2013-06-24','19:00:00',1.12),('8975','2013-06-24','19:05:00',1.07),('8975','2013-06-24','19:10:00',1.03),('8975','2013-06-23','07:25:00',1.73),('8975','2013-06-23','07:30:00',1.4),('8975','2013-06-23','07:50:00',1.3),('8975','2013-06-23','08:20:00',1.78),('8975','2013-06-23','08:25:00',4.07),('8975','2013-06-23','08:30:00',3.47),('8975','2013-06-23','08:35:00',4.66),('8975','2013-06-23','08:40:00',4.8),('8975','2013-06-23','08:45:00',4.66),('8975','2013-06-23','08:50:00',5.12),('8975','2013-06-23','08:55:00',5.36),('8975','2013-06-23','09:00:00',4.92),('8975','2013-06-23','09:05:00',2.75),('8975','2013-06-23','09:10:00',5.13),('8975','2013-06-23','09:15:00',5.25),('8975','2013-06-23','09:20:00',2.97),('8975','2013-06-23','09:25:00',6.28),('8975','2013-06-23','09:30:00',1.96),('8975','2013-06-23','09:35:00',2.3),('8975','2013-06-23','09:40:00',5.6),('8975','2013-06-23','09:45:00',6.25),('8975','2013-06-23','09:50:00',6.26),('8975','2013-06-23','09:55:00',6.05),('8975','2013-06-23','10:00:00',6.2),('8975','2013-06-23','10:05:00',6.28),('8975','2013-06-23','10:10:00',6.46),('8975','2013-06-23','10:15:00',6.79),('8975','2013-06-23','10:20:00',7.15),('8975','2013-06-23','10:25:00',6.28),('8975','2013-06-23','10:30:00',4.94),('8975','2013-06-23','10:35:00',2.21),('8975','2013-06-23','10:40:00',2.17),('8975','2013-06-23','10:45:00',7.38),('8975','2013-06-23','10:50:00',6.2),('8975','2013-06-23','10:55:00',3.99),('8975','2013-06-23','11:00:00',6.42),('8975','2013-06-23','11:05:00',2.65),('8975','2013-06-23','11:10:00',1.9),('8975','2013-06-23','11:15:00',5.54),('8975','2013-06-23','11:20:00',4.93),('8975','2013-06-23','11:25:00',5),('8975','2013-06-23','11:30:00',4.84),('8975','2013-06-23','11:35:00',2.47),('8975','2013-06-23','11:40:00',2),('8975','2013-06-23','11:45:00',4.36),('8975','2013-06-23','11:50:00',4.42),('8975','2013-06-23','11:55:00',2.59),('8975','2013-06-23','12:00:00',3.41),('8975','2013-06-23','12:05:00',7.32),('8975','2013-06-23','12:10:00',7.93),('8975','2013-06-23','12:15:00',7.26),('8975','2013-06-23','12:20:00',3.21),('8975','2013-06-23','12:25:00',7.32),('8975','2013-06-23','12:30:00',7.86),('8975','2013-06-23','12:35:00',7.88),('8975','2013-06-23','12:40:00',7.01),('8975','2013-06-23','12:45:00',4.57),('8975','2013-06-23','12:50:00',6.18),('8975','2013-06-23','12:55:00',6.14),('8975','2013-06-23','13:00:00',4.16),('8975','2013-06-23','13:05:00',5.57),('8975','2013-06-23','13:10:00',7.18),('8975','2013-06-23','13:15:00',6.68),('8975','2013-06-23','13:20:00',7.55),('8975','2013-06-23','13:25:00',3.76),('8975','2013-06-23','13:30:00',7.65),('8975','2013-06-23','13:35:00',7.03),('8975','2013-06-23','13:40:00',6.08),('8975','2013-06-23','13:45:00',7),('8975','2013-06-23','13:50:00',6.88),('8975','2013-06-23','13:55:00',6.72),('8975','2013-06-23','14:00:00',6.68),('8975','2013-06-23','14:05:00',6.64),('8975','2013-06-23','14:10:00',6.54),('8975','2013-06-23','14:15:00',6.53),('8975','2013-06-23','14:20:00',6.52),('8975','2013-06-23','14:25:00',6.51),('8975','2013-06-23','14:30:00',6.46),('8975','2013-06-23','14:35:00',5.68),('8975','2013-06-23','14:40:00',5.98),('8975','2013-06-23','14:45:00',5.34),('8975','2013-06-23','14:50:00',6.92),('8975','2013-06-23','14:55:00',5.43),('8975','2013-06-23','15:00:00',6.3),('8975','2013-06-23','15:05:00',5.48),('8975','2013-06-23','15:10:00',2.88),('8975','2013-06-23','15:15:00',3.73),('8975','2013-06-23','15:20:00',3.09),('8975','2013-06-23','15:25:00',4.65),('8975','2013-06-23','15:30:00',5.89),('8975','2013-06-23','15:35:00',2.17),('8975','2013-06-23','15:40:00',3.14),('8975','2013-06-23','15:45:00',3.43),('8975','2013-06-23','15:50:00',3.2),('8975','2013-06-23','15:55:00',4.5),('8975','2013-06-23','16:00:00',5.57),('8975','2013-06-23','16:05:00',3.6),('8975','2013-06-23','16:10:00',3.35),('8975','2013-06-23','16:15:00',5.24),('8975','2013-06-23','16:20:00',2.67),('8975','2013-06-23','16:25:00',2.46),('8975','2013-06-23','16:30:00',3.16),('8975','2013-06-23','16:35:00',2.25),('8975','2013-06-23','16:40:00',2.73),('8975','2013-06-23','16:45:00',2.18),('8975','2013-06-23','16:50:00',3.51),('8975','2013-06-23','16:55:00',1.75),('8975','2013-06-23','17:00:00',1.81),('8975','2013-06-23','17:05:00',2.41),('8975','2013-06-23','17:10:00',1.83),('8975','2013-06-23','17:15:00',2.51),('8975','2013-06-23','17:20:00',1.93),('8975','2013-06-23','17:25:00',1.26),('8975','2013-06-23','17:30:00',1.53),('8975','2013-06-23','17:35:00',1.76),('8975','2013-06-23','17:40:00',1.33),('8975','2013-06-23','17:45:00',1.06),('8975','2013-06-23','17:50:00',1.8),('8975','2013-06-23','17:55:00',1.66),('8975','2013-06-23','18:00:00',1.32),('8975','2013-06-23','18:05:00',1.74),('8975','2013-06-23','18:10:00',2.2),('8975','2013-06-23','18:15:00',1.57),('8975','2013-06-23','18:20:00',1.31),('8975','2013-06-23','18:25:00',1.16),('8975','2013-06-23','18:30:00',1.76),('8975','2013-06-23','18:35:00',1.87),('8975','2013-06-23','18:40:00',1.02),('8975','2013-06-23','18:45:00',1.68),('8975','2013-06-23','18:50:00',1.55),('8975','2013-06-23','18:55:00',1.28),('8975','2013-06-23','19:00:00',1.26),('8975','2013-06-23','19:05:00',1.2),('8975','2013-06-22','08:35:00',1.04),('8975','2013-06-22','08:40:00',1.27),('8975','2013-06-22','08:45:00',2.42),('8975','2013-06-22','08:50:00',2.32),('8975','2013-06-22','08:55:00',1.96),('8975','2013-06-22','09:00:00',4.17),('8975','2013-06-22','09:05:00',3.11),('8975','2013-06-22','09:15:00',1.32),('8975','2013-06-22','09:20:00',3.11),('8975','2013-06-22','09:25:00',5.21),('8975','2013-06-22','09:30:00',5.72),('8975','2013-06-22','09:35:00',5.96),('8975','2013-06-22','09:40:00',4.69),('8975','2013-06-22','09:45:00',2.97),('8975','2013-06-22','09:50:00',4.5),('8975','2013-06-22','09:55:00',5.55),('8975','2013-06-22','10:00:00',6.34),('8975','2013-06-22','10:05:00',5.45),('8975','2013-06-22','10:10:00',3.5),('8975','2013-06-22','10:15:00',6.7),('8975','2013-06-22','10:20:00',6.8),('8975','2013-06-22','10:25:00',4.22),('8975','2013-06-22','10:30:00',6.38),('8975','2013-06-22','10:35:00',6.26),('8975','2013-06-22','10:40:00',6.29),('8975','2013-06-22','10:45:00',6.29),('8975','2013-06-22','10:50:00',6.31),('8975','2013-06-22','10:55:00',6.31),('8975','2013-06-22','11:00:00',6.37),('8975','2013-06-22','11:05:00',6.48),('8975','2013-06-22','11:10:00',6.43),('8975','2013-06-22','11:15:00',6.53),('8975','2013-06-22','11:20:00',6.06),('8975','2013-06-22','11:25:00',6.62),('8975','2013-06-22','11:30:00',6.64),('8975','2013-06-22','11:35:00',6.53),('8975','2013-06-22','11:40:00',6.64),('8975','2013-06-22','11:45:00',6.71),('8975','2013-06-22','11:50:00',6.58),('8975','2013-06-22','11:55:00',3.37),('8975','2013-06-22','12:00:00',3.38),('8975','2013-06-22','12:05:00',5.5),('8975','2013-06-22','12:10:00',7.23),('8975','2013-06-22','12:15:00',7.11),('8975','2013-06-22','12:20:00',7.1),('8975','2013-06-22','12:25:00',6.75),('8975','2013-06-22','12:30:00',7.03),('8975','2013-06-22','12:35:00',6.89),('8975','2013-06-22','12:40:00',6.89),('8975','2013-06-22','12:45:00',6.85),('8975','2013-06-22','12:50:00',6.81),('8975','2013-06-22','12:55:00',6.81),('8975','2013-06-22','13:00:00',6.82),('8975','2013-06-22','13:05:00',6.77),('8975','2013-06-22','13:10:00',6.76),('8975','2013-06-22','13:15:00',6.71),('8975','2013-06-22','13:20:00',6.68),('8975','2013-06-22','13:25:00',6.69),('8975','2013-06-22','13:30:00',6.62),('8975','2013-06-22','13:35:00',6.62),('8975','2013-06-22','13:40:00',6.57),('8975','2013-06-22','13:45:00',6.49),('8975','2013-06-22','13:50:00',6.55),('8975','2013-06-22','13:55:00',6.49),('8975','2013-06-22','14:00:00',6.46),('8975','2013-06-22','14:05:00',6.35),('8975','2013-06-22','14:10:00',6.39),('8975','2013-06-22','14:15:00',6.32),('8975','2013-06-22','14:20:00',6.3),('8975','2013-06-22','14:25:00',6.21),('8975','2013-06-22','14:30:00',6.14),('8975','2013-06-22','14:35:00',6.05),('8975','2013-06-22','14:40:00',6.01),('8975','2013-06-22','14:45:00',5.91),('8975','2013-06-22','14:50:00',5.88),('8975','2013-06-22','14:55:00',5.81),('8975','2013-06-22','15:00:00',5.75),('8975','2013-06-22','15:05:00',5.67),('8975','2013-06-22','15:10:00',5.62),('8975','2013-06-22','15:15:00',5.55),('8975','2013-06-22','15:20:00',5.45),('8975','2013-06-22','15:25:00',5.34),('8975','2013-06-22','15:30:00',5.21),('8975','2013-06-22','15:35:00',5.12),('8975','2013-06-22','15:40:00',5.07),('8975','2013-06-22','15:45:00',4.98),('8975','2013-06-22','15:50:00',4.86),('8975','2013-06-22','15:55:00',4.76),('8975','2013-06-22','16:00:00',4.66),('8975','2013-06-22','16:05:00',4.54),('8975','2013-06-22','16:10:00',4.43),('8975','2013-06-22','16:15:00',4.33),('8975','2013-06-22','16:20:00',4.22),('8975','2013-06-22','16:25:00',4.1),('8975','2013-06-22','16:30:00',4.01),('8975','2013-06-22','16:35:00',3.89),('8975','2013-06-22','16:40:00',3.79),('8975','2013-06-22','16:45:00',3.68),('8975','2013-06-22','16:50:00',3.58),('8975','2013-06-22','16:55:00',3.45),('8975','2013-06-22','17:00:00',3.34),('8975','2013-06-22','17:05:00',3.22),('8975','2013-06-22','17:10:00',3.1),('8975','2013-06-22','17:15:00',2.97),('8975','2013-06-22','17:20:00',2.83),('8975','2013-06-22','17:25:00',2.73),('8975','2013-06-22','17:30:00',2.61),('8975','2013-06-22','17:35:00',2.49),('8975','2013-06-22','17:40:00',2.29),('8975','2013-06-22','17:45:00',2.28),('8975','2013-06-22','17:50:00',2.2),('8975','2013-06-22','17:55:00',2.08),('8975','2013-06-22','18:00:00',1.98),('8975','2013-06-22','18:05:00',1.88),('8975','2013-06-22','18:10:00',1.8),('8975','2013-06-22','18:15:00',1.72),('8975','2013-06-22','18:20:00',1.52),('8975','2013-06-22','18:25:00',1.57),('8975','2013-06-22','18:30:00',1.47),('8975','2013-06-22','18:35:00',1.42),('8975','2013-06-22','18:40:00',1.38),('8975','2013-06-22','18:45:00',1.32),('8975','2013-06-22','18:50:00',1.25),('8975','2013-06-22','18:55:00',1.13),('8975','2013-06-22','19:00:00',1.03),('8975','2013-06-22','19:05:00',1),('8975','2013-06-22','19:10:00',1.07),('8975','2013-06-22','19:15:00',1.04),('8975','2013-06-21','06:25:00',1.15),('8975','2013-06-21','06:30:00',1.29),('8975','2013-06-21','06:35:00',1.42),('8975','2013-06-21','06:40:00',1.53),('8975','2013-06-21','06:45:00',1.67),('8975','2013-06-21','06:50:00',1.8),('8975','2013-06-21','06:55:00',1.92),('8975','2013-06-21','07:00:00',2.04),('8975','2013-06-21','07:05:00',2.17),('8975','2013-06-21','07:10:00',2.31),('8975','2013-06-21','07:15:00',2.44),('8975','2013-06-21','07:20:00',2.56),('8975','2013-06-21','07:25:00',2.69),('8975','2013-06-21','07:30:00',2.8),('8975','2013-06-21','07:35:00',2.92),('8975','2013-06-21','07:40:00',3.01),('8975','2013-06-21','07:45:00',3.08),('8975','2013-06-21','07:50:00',3.18),('8975','2013-06-21','07:55:00',3.27),('8975','2013-06-21','08:00:00',3.4),('8975','2013-06-21','08:05:00',3.46),('8975','2013-06-21','08:10:00',3.53),('8975','2013-06-21','08:15:00',3.64),('8975','2013-06-21','08:20:00',3.78),('8975','2013-06-21','08:25:00',3.87),('8975','2013-06-21','08:30:00',3.98),('8975','2013-06-21','08:35:00',4.11),('8975','2013-06-21','08:40:00',4.23),('8975','2013-06-21','08:45:00',4.33),('8975','2013-06-21','08:50:00',4.42),('8975','2013-06-21','08:55:00',4.51),('8975','2013-06-21','09:00:00',4.58),('8975','2013-06-21','09:05:00',4.65),('8975','2013-06-21','09:10:00',4.74),('8975','2013-06-21','09:15:00',4.78),('8975','2013-06-21','09:20:00',4.84),('8975','2013-06-21','09:25:00',4.93),('8975','2013-06-21','09:30:00',5.06),('8975','2013-06-21','09:35:00',5.19),('8975','2013-06-21','09:40:00',5.23),('8975','2013-06-21','09:45:00',5.33),('8975','2013-06-21','09:50:00',5.4),('8975','2013-06-21','09:55:00',5.46),('8975','2013-06-21','10:00:00',5.5),('8975','2013-06-21','10:05:00',5.6),('8975','2013-06-21','10:10:00',5.71),('8975','2013-06-21','10:15:00',5.78),('8975','2013-06-21','10:20:00',5.84),('8975','2013-06-21','10:25:00',5.85),('8975','2013-06-21','10:30:00',5.87),('8975','2013-06-21','10:35:00',5.94),('8975','2013-06-21','10:40:00',6.06),('8975','2013-06-21','10:45:00',6.11),('8975','2013-06-21','10:50:00',6.18),('8975','2013-06-21','10:55:00',6.23),('8975','2013-06-21','11:00:00',6.26),('8975','2013-06-21','11:05:00',6.3),('8975','2013-06-21','11:10:00',6.35),('8975','2013-06-21','11:15:00',6.37),('8975','2013-06-21','11:20:00',6.41),('8975','2013-06-21','11:25:00',6.44),('8975','2013-06-21','11:30:00',6.42),('8975','2013-06-21','11:35:00',6.44),('8975','2013-06-21','11:40:00',6.5),('8975','2013-06-21','11:45:00',6.51),('8975','2013-06-21','11:50:00',6.45),('8975','2013-06-21','11:55:00',6.55),('8975','2013-06-21','12:00:00',6.51),('8975','2013-06-21','12:05:00',6.32),('8975','2013-06-21','12:10:00',6.39),('8975','2013-06-21','12:15:00',6.55),('8975','2013-06-21','12:20:00',6.43),('8975','2013-06-21','12:25:00',6.53),('8975','2013-06-21','12:30:00',6.55),('8975','2013-06-21','12:35:00',6.57),('8975','2013-06-21','12:40:00',6.54),('8975','2013-06-21','12:45:00',6.39),('8975','2013-06-21','12:50:00',5.81),('8975','2013-06-21','12:55:00',5.4),('8975','2013-06-21','13:00:00',6.11),('8975','2013-06-21','13:05:00',6.25),('8975','2013-06-21','13:10:00',6.01),('8975','2013-06-21','13:15:00',5.65),('8975','2013-06-21','13:20:00',5.03),('8975','2013-06-21','13:25:00',4.61),('8975','2013-06-21','13:30:00',5.5),('8975','2013-06-21','13:35:00',6.06),('8975','2013-06-21','13:40:00',5.72),('8975','2013-06-21','13:45:00',6.21),('8975','2013-06-21','13:50:00',6.12),('8975','2013-06-21','13:55:00',4.05),('8975','2013-06-21','14:00:00',4.96),('8975','2013-06-21','14:05:00',6.82),('8975','2013-06-21','14:10:00',6.48),('8975','2013-06-21','14:15:00',6.19),('8975','2013-06-21','14:20:00',5.96),('8975','2013-06-21','14:25:00',6.49),('8975','2013-06-21','14:30:00',4.36),('8975','2013-06-21','14:35:00',3.26),('8975','2013-06-21','14:40:00',2.59),('8975','2013-06-21','14:45:00',3.72),('8975','2013-06-21','14:50:00',5.48),('8975','2013-06-21','14:55:00',5.78),('8975','2013-06-21','15:00:00',5.97),('8975','2013-06-21','15:05:00',4.13),('8975','2013-06-21','15:10:00',6.05),('8975','2013-06-21','15:15:00',5.85),('8975','2013-06-21','15:20:00',5.18),('8975','2013-06-21','15:25:00',4.49),('8975','2013-06-21','15:30:00',3.07),('8975','2013-06-21','15:35:00',2.14),('8975','2013-06-21','15:40:00',2.27),('8975','2013-06-21','15:45:00',3.69),('8975','2013-06-21','15:50:00',3.48),('8975','2013-06-21','15:55:00',3.82),('8975','2013-06-21','16:00:00',2.96),('8975','2013-06-21','16:05:00',1.94),('8975','2013-06-21','16:10:00',2.02),('8975','2013-06-21','16:15:00',2.78),('8975','2013-06-21','16:20:00',2.77),('8975','2013-06-21','16:25:00',1.99),('8975','2013-06-21','16:30:00',1.55),('8975','2013-06-21','16:35:00',1.34),('8975','2013-06-21','16:40:00',1.25),('8975','2013-06-21','16:45:00',1.22),('8975','2013-06-21','16:50:00',1.33),('8975','2013-06-21','16:55:00',1.87),('8975','2013-06-21','17:00:00',2.24),('8975','2013-06-21','17:05:00',2.32),('8975','2013-06-21','17:10:00',3.16),('8975','2013-06-21','17:15:00',3.92),('8975','2013-06-21','17:20:00',3.7),('8975','2013-06-21','17:25:00',3.23),('8975','2013-06-21','17:30:00',2.59),('8975','2013-06-21','17:35:00',2.98),('8975','2013-06-21','17:40:00',2.86),('8975','2013-06-21','17:45:00',2.73),('8975','2013-06-21','17:50:00',2.51),('8975','2013-06-21','17:55:00',2.38),('8975','2013-06-21','18:00:00',2.05),('8975','2013-06-21','18:05:00',1.75),('8975','2013-06-21','18:10:00',1.24),('8975','2013-06-21','18:15:00',1.26),('8975','2013-06-21','18:20:00',1.32),('8975','2013-06-20','06:30:00',1.03),('8975','2013-06-20','06:35:00',1.2),('8975','2013-06-20','06:40:00',1.37),('8975','2013-06-20','06:45:00',1.57),('8975','2013-06-20','06:50:00',1.71),('8975','2013-06-20','06:55:00',1.84),('8975','2013-06-20','07:00:00',1.99),('8975','2013-06-20','07:05:00',2.14),('8975','2013-06-20','07:10:00',2.29),('8975','2013-06-20','07:15:00',2.42),('8975','2013-06-20','07:20:00',2.55),('8975','2013-06-20','07:25:00',2.66),('8975','2013-06-20','07:30:00',2.78),('8975','2013-06-20','07:35:00',2.9),('8975','2013-06-20','07:40:00',2.99),('8975','2013-06-20','07:45:00',3.1),('8975','2013-06-20','07:50:00',3.22),('8975','2013-06-20','07:55:00',3.34),('8975','2013-06-20','08:00:00',3.41),('8975','2013-06-20','08:05:00',3.52),('8975','2013-06-20','08:10:00',3.6),('8975','2013-06-20','08:15:00',3.69),('8975','2013-06-20','08:20:00',3.8),('8975','2013-06-20','08:25:00',3.88),('8975','2013-06-20','08:30:00',3.95),('8975','2013-06-20','08:35:00',4.02),('8975','2013-06-20','08:40:00',4.14),('8975','2013-06-20','08:45:00',4.22),('8975','2013-06-20','08:50:00',4.32),('8975','2013-06-20','08:55:00',4.4),('8975','2013-06-20','09:00:00',4.44),('8975','2013-06-20','09:05:00',4.47),('8975','2013-06-20','09:10:00',4.56),('8975','2013-06-20','09:15:00',4.64),('8975','2013-06-20','09:20:00',4.73),('8975','2013-06-20','09:25:00',4.81),('8975','2013-06-20','09:30:00',4.89),('8975','2013-06-20','09:35:00',4.95),('8975','2013-06-20','09:40:00',5.05),('8975','2013-06-20','09:45:00',5.06),('8975','2013-06-20','09:50:00',5.1),('8975','2013-06-20','09:55:00',5.15),('8975','2013-06-20','10:00:00',5.29),('8975','2013-06-20','10:05:00',5.37),('8975','2013-06-20','10:10:00',5.32),('8975','2013-06-20','10:15:00',5.36),('8975','2013-06-20','10:20:00',5.44),('8975','2013-06-20','10:25:00',5.51),('8975','2013-06-20','10:30:00',5.59),('8975','2013-06-20','10:35:00',5.61),('8975','2013-06-20','10:40:00',5.58),('8975','2013-06-20','10:45:00',5.59),('8975','2013-06-20','10:50:00',5.73),('8975','2013-06-20','10:55:00',5.79),('8975','2013-06-20','11:00:00',5.82),('8975','2013-06-20','11:05:00',5.88),('8975','2013-06-20','11:10:00',5.98),('8975','2013-06-20','11:15:00',6.01),('8975','2013-06-20','11:20:00',6.01),('8975','2013-06-20','11:25:00',6.01),('8975','2013-06-20','11:30:00',6.01),('8975','2013-06-20','11:35:00',6.01),('8975','2013-06-20','11:40:00',6.1),('8975','2013-06-20','11:45:00',6.12),('8975','2013-06-20','11:50:00',6.15),('8975','2013-06-20','11:55:00',6.15),('8975','2013-06-20','12:00:00',6.18),('8975','2013-06-20','12:05:00',6.09),('8975','2013-06-20','12:10:00',6.16),('8975','2013-06-20','12:15:00',6.09),('8975','2013-06-20','12:20:00',6.21),('8975','2013-06-20','12:25:00',6.14),('8975','2013-06-20','12:30:00',6.15),('8975','2013-06-20','12:35:00',6.2),('8975','2013-06-20','12:40:00',6.17),('8975','2013-06-20','12:45:00',6.07),('8975','2013-06-20','12:50:00',6.08),('8975','2013-06-20','12:55:00',6.07),('8975','2013-06-20','13:00:00',6.14),('8975','2013-06-20','13:05:00',6.18),('8975','2013-06-20','13:10:00',6.11),('8975','2013-06-20','13:15:00',6.11),('8975','2013-06-20','13:20:00',6.16),('8975','2013-06-20','13:25:00',6.16),('8975','2013-06-20','13:30:00',6.09),('8975','2013-06-20','13:35:00',6.12),('8975','2013-06-20','13:40:00',6.05),('8975','2013-06-20','13:45:00',6.04),('8975','2013-06-20','13:50:00',5.95),('8975','2013-06-20','13:55:00',5.91),('8975','2013-06-20','14:00:00',5.87),('8975','2013-06-20','14:05:00',5.91),('8975','2013-06-20','14:10:00',5.87),('8975','2013-06-20','14:15:00',5.83),('8975','2013-06-20','14:20:00',5.81),('8975','2013-06-20','14:25:00',5.76),('8975','2013-06-20','14:30:00',5.74),('8975','2013-06-20','14:35:00',5.7),('8975','2013-06-20','14:40:00',5.63),('8975','2013-06-20','14:45:00',5.57),('8975','2013-06-20','14:50:00',5.52),('8975','2013-06-20','14:55:00',5.46),('8975','2013-06-20','15:00:00',5.32),('8975','2013-06-20','15:05:00',5.31),('8975','2013-06-20','15:10:00',5.26),('8975','2013-06-20','15:15:00',5.18),('8975','2013-06-20','15:20:00',4.49),('8975','2013-06-20','15:25:00',4.56),('8975','2013-06-20','15:30:00',4.75),('8975','2013-06-20','15:35:00',4.68),('8975','2013-06-20','15:40:00',4.43),('8975','2013-06-20','15:45:00',4.43),('8975','2013-06-20','15:50:00',4.51),('8975','2013-06-20','15:55:00',4.39),('8975','2013-06-20','16:00:00',4.13),('8975','2013-06-20','16:05:00',4.31),('8975','2013-06-20','16:10:00',4.2),('8975','2013-06-20','16:15:00',4.1),('8975','2013-06-20','16:20:00',3.98),('8975','2013-06-20','16:25:00',3.9),('8975','2013-06-20','16:30:00',3.79),('8975','2013-06-20','16:35:00',3.67),('8975','2013-06-20','16:40:00',3.56),('8975','2013-06-20','16:45:00',3.47),('8975','2013-06-20','16:50:00',3.37),('8975','2013-06-20','16:55:00',3.26),('8975','2013-06-20','17:00:00',3.13),('8975','2013-06-20','17:05:00',3.02),('8975','2013-06-20','17:10:00',2.91),('8975','2013-06-20','17:15:00',2.8),('8975','2013-06-20','17:20:00',2.69),('8975','2013-06-20','17:25:00',2.58),('8975','2013-06-20','17:30:00',2.46),('8975','2013-06-20','17:35:00',2.35),('8975','2013-06-20','17:40:00',2.26),('8975','2013-06-20','17:45:00',2.15),('8975','2013-06-20','17:50:00',2.04),('8975','2013-06-20','17:55:00',1.95),('8975','2013-06-20','18:00:00',1.86),('8975','2013-06-20','18:05:00',1.79),('8975','2013-06-20','18:10:00',1.7),('8975','2013-06-20','18:15:00',1.62),('8975','2013-06-20','18:20:00',1.54),('8975','2013-06-20','18:25:00',1.47),('8975','2013-06-20','18:30:00',1.4),('8975','2013-06-20','18:35:00',1.33),('8975','2013-06-20','18:40:00',1.27),('8975','2013-06-20','18:45:00',1.18),('8975','2013-06-20','18:50:00',1.15),('8975','2013-06-20','18:55:00',1.09),('8975','2013-06-20','19:00:00',1.05),('8975','2013-06-20','19:05:00',1.04),('8975','2014-04-03','08:35:00',1.19),('8975','2014-04-03','08:40:00',1.89),('8975','2014-04-03','08:45:00',2.02),('8975','2014-04-03','08:50:00',2.09),('8975','2014-04-03','08:55:00',2.88),('8975','2014-04-03','09:00:00',3.15),('8975','2014-04-03','09:05:00',3.55),('8975','2014-04-03','09:10:00',3.94),('8975','2014-04-03','09:15:00',4.12),('8975','2014-04-03','09:20:00',4.05),('8975','2014-04-03','09:25:00',3.21),('8975','2014-04-03','09:30:00',2.89),('8975','2014-04-03','09:35:00',2.85),('8975','2014-04-03','09:40:00',2.57),('8975','2014-04-03','09:45:00',2.29),('8975','2014-04-03','09:50:00',1.79),('8975','2014-04-03','09:55:00',1.62),('8975','2014-04-03','10:00:00',1.13),('8975','2014-04-03','10:10:00',1.22),('8975','2014-04-03','10:15:00',1.26),('8975','2014-04-03','10:55:00',1),('8975','2014-04-03','12:45:00',1.06),('8975','2014-04-03','12:50:00',1.05),('8975','2014-04-03','13:15:00',1.28),('8975','2014-04-03','13:20:00',3.36),('8975','2014-04-03','13:25:00',2.67),('8975','2014-04-03','13:30:00',3.7),('8975','2014-04-03','13:35:00',5.6),('8975','2014-04-03','13:40:00',6.46),('8975','2014-04-03','13:45:00',4.52),('8975','2014-04-03','13:50:00',5.97),('8975','2014-04-03','13:55:00',3.75),('8975','2014-04-03','14:00:00',4.26),('8975','2014-04-03','14:05:00',4.44),('8975','2014-04-03','14:10:00',6.49),('8975','2014-04-03','14:15:00',4.07),('8975','2014-04-03','14:20:00',4.97),('8975','2014-04-03','14:25:00',3.41),('8975','2014-04-03','14:30:00',3.05),('8975','2014-04-03','14:35:00',3.09),('8975','2014-04-03','14:40:00',2.8),('8975','2014-04-03','14:45:00',2.99),('8975','2014-04-03','14:50:00',4.3),('8975','2014-04-03','14:55:00',5.18),('8975','2014-04-03','15:00:00',5.27),('8975','2014-04-03','15:05:00',5.27),('8975','2014-04-03','15:10:00',3.6),('8975','2014-04-03','15:15:00',4.47),('8975','2014-04-03','15:20:00',1.64),('8975','2014-04-03','15:25:00',2.58),('8975','2014-04-03','15:30:00',2),('8975','2014-04-03','15:35:00',2.26),('8975','2014-04-03','15:40:00',2.47),('8975','2014-04-03','15:45:00',2.4),('8975','2014-04-03','15:50:00',2.99),('8975','2014-04-03','15:55:00',2.97),('8975','2014-04-03','16:00:00',4.28),('8975','2014-04-03','16:05:00',2.99),('8975','2014-04-03','16:10:00',2.78),('8975','2014-04-03','16:15:00',2.45),('8975','2014-04-03','16:20:00',1.62),('8975','2014-04-03','16:25:00',1.79),('8975','2014-04-03','16:30:00',4.02),('8975','2014-04-03','16:35:00',3.11),('8975','2014-04-03','16:40:00',1.96),('8975','2014-04-03','16:45:00',3.02),('8975','2014-04-03','16:50:00',3.23),('8975','2014-04-03','16:55:00',2.68),('8975','2014-04-03','17:00:00',2.62),('8975','2014-04-03','17:05:00',2.28),('8975','2014-04-03','17:10:00',2.41),('8975','2014-04-03','17:15:00',1.61),('8975','2014-04-03','17:20:00',1.7),('8975','2014-04-03','17:25:00',2.22),('8975','2014-04-03','17:30:00',2.41),('8975','2014-04-03','17:35:00',1.55),('8975','2014-04-03','17:40:00',1.95),('8975','2014-04-03','17:45:00',1.63),('8975','2014-04-03','17:50:00',1.67),('8975','2014-04-03','17:55:00',1.6),('8975','2014-04-03','18:00:00',1.47),('8975','2014-04-03','18:05:00',1.36),('8975','2014-04-03','18:10:00',1.28),('8975','2014-04-03','18:15:00',1.21),('8975','2014-04-03','18:20:00',1.15),('8975','2014-04-03','18:25:00',1.05),('8975','2014-04-03','18:30:00',1.01),('8975','2013-06-19','06:25:00',1.09),('8975','2013-06-19','06:30:00',1.25),('8975','2013-06-19','06:35:00',1.36),('8975','2013-06-19','06:40:00',1.48),('8975','2013-06-19','06:45:00',1.66),('8975','2013-06-19','06:50:00',1.81),('8975','2013-06-19','06:55:00',1.93),('8975','2013-06-19','07:00:00',2.01),('8975','2013-06-19','07:05:00',2.14),('8975','2013-06-19','07:10:00',2.25),('8975','2013-06-19','07:15:00',2.36),('8975','2013-06-19','07:20:00',2.48),('8975','2013-06-19','07:25:00',2.6),('8975','2013-06-19','07:30:00',2.71),('8975','2013-06-19','07:35:00',2.81),('8975','2013-06-19','07:40:00',2.92),('8975','2013-06-19','07:45:00',3.02),('8975','2013-06-19','07:50:00',3.18),('8975','2013-06-19','07:55:00',3.3),('8975','2013-06-19','08:00:00',3.4),('8975','2013-06-19','08:05:00',3.47),('8975','2013-06-19','08:10:00',3.59),('8975','2013-06-19','08:15:00',3.74),('8975','2013-06-19','08:20:00',3.83),('8975','2013-06-19','08:25:00',3.93),('8975','2013-06-19','08:30:00',4.02),('8975','2013-06-19','08:35:00',4.15),('8975','2013-06-19','08:40:00',4.25),('8975','2013-06-19','08:45:00',4.36),('8975','2013-06-19','08:50:00',4.46),('8975','2013-06-19','08:55:00',4.53),('8975','2013-06-19','09:00:00',4.57),('8975','2013-06-19','09:05:00',4.67),('8975','2013-06-19','09:10:00',4.75),('8975','2013-06-19','09:15:00',4.83),('8975','2013-06-19','09:20:00',4.93),('8975','2013-06-19','09:25:00',5.01),('8975','2013-06-19','09:30:00',5.1),('8975','2013-06-19','09:35:00',5.17),('8975','2013-06-19','09:40:00',5.2),('8975','2013-06-19','09:45:00',5.28),('8975','2013-06-19','09:50:00',5.37),('8975','2013-06-19','09:55:00',5.44),('8975','2013-06-19','10:00:00',5.43),('8975','2013-06-19','10:05:00',5.56),('8975','2013-06-19','10:10:00',5.58),('8975','2013-06-19','10:15:00',5.69),('8975','2013-06-19','10:20:00',5.68),('8975','2013-06-19','10:25:00',5.82),('8975','2013-06-19','10:30:00',5.83),('8975','2013-06-19','10:35:00',5.79),('8975','2013-06-19','10:40:00',5.76),('8975','2013-06-19','10:45:00',5.75),('8975','2013-06-19','10:50:00',5.8),('8975','2013-06-19','10:55:00',5.93),('8975','2013-06-19','11:00:00',6),('8975','2013-06-19','11:05:00',6.09),('8975','2013-06-19','11:10:00',6.1),('8975','2013-06-19','11:15:00',6.12),('8975','2013-06-19','11:20:00',6.05),('8975','2013-06-19','11:25:00',6.09),('8975','2013-06-19','11:30:00',6.11),('8975','2013-06-19','11:35:00',6.1),('8975','2013-06-19','11:40:00',6.07),('8975','2013-06-19','11:45:00',6.1),('8975','2013-06-19','11:50:00',6.04),('8975','2013-06-19','11:55:00',5.97),('8975','2013-06-19','12:00:00',5.89),('8975','2013-06-19','12:05:00',3.81),('8975','2013-06-19','12:10:00',5.49),('8975','2013-06-19','12:15:00',3.32),('8975','2013-06-19','12:20:00',4.27),('8975','2013-06-19','12:25:00',6.27),('8975','2013-06-19','12:30:00',2.7),('8975','2013-06-19','12:35:00',1.67),('8975','2013-06-19','12:40:00',4.92),('8975','2013-06-19','12:45:00',6.4),('8975','2013-06-19','12:50:00',6.41),('8975','2013-06-19','12:55:00',6.57),('8975','2013-06-19','13:00:00',5.77),('8975','2013-06-19','13:05:00',3.32),('8975','2013-06-19','13:10:00',4.81),('8975','2013-06-19','13:15:00',6.33),('8975','2013-06-19','13:20:00',6.27),('8975','2013-06-19','13:25:00',6.21),('8975','2013-06-19','13:30:00',6.22),('8975','2013-06-19','13:35:00',6.16),('8975','2013-06-19','13:40:00',6.17),('8975','2013-06-19','13:45:00',6.11),('8975','2013-06-19','13:50:00',6.05),('8975','2013-06-19','13:55:00',6.1),('8975','2013-06-19','14:00:00',5.93),('8975','2013-06-19','14:05:00',6.03),('8975','2013-06-19','14:10:00',6.1),('8975','2013-06-19','14:15:00',6.01),('8975','2013-06-19','14:20:00',5.91),('8975','2013-06-19','14:25:00',5.91),('8975','2013-06-19','14:30:00',5.82),('8975','2013-06-19','14:35:00',5.81),('8975','2013-06-19','14:40:00',5.78),('8975','2013-06-19','14:45:00',5.71),('8975','2013-06-19','14:50:00',5.69),('8975','2013-06-19','14:55:00',5.62),('8975','2013-06-19','15:00:00',5.52),('8975','2013-06-19','15:05:00',5.48),('8975','2013-06-19','15:10:00',5.38),('8975','2013-06-19','15:15:00',5.3),('8975','2013-06-19','15:20:00',5.22),('8975','2013-06-19','15:25:00',5.11),('8975','2013-06-19','15:30:00',5.01),('8975','2013-06-19','15:35:00',4.92),('8975','2013-06-19','15:40:00',4.84),('8975','2013-06-19','15:45:00',4.75),('8975','2013-06-19','15:50:00',4.65),('8975','2013-06-19','15:55:00',4.55),('8975','2013-06-19','16:00:00',4.44),('8975','2013-06-19','16:05:00',4.38),('8975','2013-06-19','16:10:00',4.26),('8975','2013-06-19','16:15:00',4.17),('8975','2013-06-19','16:20:00',4.05),('8975','2013-06-19','16:25:00',3.95),('8975','2013-06-19','16:30:00',3.83),('8975','2013-06-19','16:35:00',3.7),('8975','2013-06-19','16:40:00',3.6),('8975','2013-06-19','16:45:00',3.48),('8975','2013-06-19','16:50:00',3.39),('8975','2013-06-19','16:55:00',3.27),('8975','2013-06-19','17:00:00',3.16),('8975','2013-06-19','17:05:00',3.02),('8975','2013-06-19','17:10:00',2.91),('8975','2013-06-19','17:15:00',2.8),('8975','2013-06-19','17:20:00',2.68),('8975','2013-06-19','17:25:00',2.55),('8975','2013-06-19','17:30:00',2.44),('8975','2013-06-19','17:35:00',2.32),('8975','2013-06-19','17:40:00',2.23),('8975','2013-06-19','17:45:00',2.14),('8975','2013-06-19','17:50:00',2.04),('8975','2013-06-19','17:55:00',1.95),('8975','2013-06-19','18:00:00',1.87),('8975','2013-06-19','18:05:00',1.78),('8975','2013-06-19','18:10:00',1.7),('8975','2013-06-19','18:15:00',1.62),('8975','2013-06-19','18:20:00',1.54),('8975','2013-06-19','18:25:00',1.47),('8975','2013-06-19','18:30:00',1.39),('8975','2013-06-19','18:35:00',1.33),('8975','2013-06-19','18:40:00',1.27),('8975','2013-06-19','18:45:00',1.2),('8975','2013-06-19','18:50:00',1.15),('8975','2013-06-19','18:55:00',1.11),('8975','2013-06-19','19:00:00',1.05),('8975','2013-06-19','19:05:00',1.02),('8975','2013-06-18','06:25:00',1.01),('8975','2013-06-18','06:30:00',1.15),('8975','2013-06-18','06:35:00',1.29),('8975','2013-06-18','06:40:00',1.42),('8975','2013-06-18','06:45:00',1.56),('8975','2013-06-18','06:50:00',1.7),('8975','2013-06-18','06:55:00',1.84),('8975','2013-06-18','07:00:00',1.97),('8975','2013-06-18','07:05:00',2.09),('8975','2013-06-18','07:10:00',2.21),('8975','2013-06-18','07:15:00',2.32),('8975','2013-06-18','07:20:00',2.44),('8975','2013-06-18','07:25:00',2.56),('8975','2013-06-18','07:30:00',2.68),('8975','2013-06-18','07:35:00',2.79),('8975','2013-06-18','07:40:00',2.88),('8975','2013-06-18','07:45:00',2.98),('8975','2013-06-18','07:50:00',3.11),('8975','2013-06-18','07:55:00',3.24),('8975','2013-06-18','08:00:00',3.34),('8975','2013-06-18','08:05:00',3.4),('8975','2013-06-18','08:10:00',3.51),('8975','2013-06-18','08:15:00',3.61),('8975','2013-06-18','08:20:00',3.75),('8975','2013-06-18','08:25:00',3.84),('8975','2013-06-18','08:30:00',3.93),('8975','2013-06-18','08:35:00',4.02),('8975','2013-06-18','08:40:00',4.1),('8975','2013-06-18','08:45:00',4.19),('8975','2013-06-18','08:50:00',4.28),('8975','2013-06-18','08:55:00',4.35),('8975','2013-06-18','09:00:00',4.42),('8975','2013-06-18','09:05:00',4.51),('8975','2013-06-18','09:10:00',4.6),('8975','2013-06-18','09:15:00',4.7),('8975','2013-06-18','09:20:00',4.8),('8975','2013-06-18','09:25:00',4.87),('8975','2013-06-18','09:30:00',4.92),('8975','2013-06-18','09:35:00',4.98),('8975','2013-06-18','09:40:00',5.04),('8975','2013-06-18','09:45:00',5.12),('8975','2013-06-18','09:50:00',5.2),('8975','2013-06-18','09:55:00',5.28),('8975','2013-06-18','10:00:00',5.33),('8975','2013-06-18','10:05:00',5.35),('8975','2013-06-18','10:10:00',5.41),('8975','2013-06-18','10:15:00',5.47),('8975','2013-06-18','10:20:00',5.51),('8975','2013-06-18','10:25:00',5.6),('8975','2013-06-18','10:30:00',5.66),('8975','2013-06-18','10:35:00',5.68),('8975','2013-06-18','10:40:00',5.7),('8975','2013-06-18','10:45:00',5.71),('8975','2013-06-18','10:50:00',5.78),('8975','2013-06-18','10:55:00',5.77),('8975','2013-06-18','11:00:00',5.79),('8975','2013-06-18','11:05:00',5.81),('8975','2013-06-18','11:10:00',5.81),('8975','2013-06-18','11:15:00',5.78),('8975','2013-06-18','11:20:00',5.87),('8975','2013-06-18','11:25:00',5.84),('8975','2013-06-18','11:30:00',5.93),('8975','2013-06-18','11:35:00',6.03),('8975','2013-06-18','11:40:00',5.96),('8975','2013-06-18','11:45:00',5.99),('8975','2013-06-18','11:50:00',6.03),('8975','2013-06-18','11:55:00',6.01),('8975','2013-06-18','12:00:00',6.12),('8975','2013-06-18','12:05:00',6.17),('8975','2013-06-18','12:10:00',6.04),('8975','2013-06-18','12:15:00',6.17),('8975','2013-06-18','12:20:00',6.22),('8975','2013-06-18','12:25:00',6.15),('8975','2013-06-18','12:30:00',6.28),('8975','2013-06-18','12:35:00',6.19),('8975','2013-06-18','12:40:00',6.15),('8975','2013-06-18','12:45:00',6.25),('8975','2013-06-18','12:50:00',6.2),('8975','2013-06-18','12:55:00',6.18),('8975','2013-06-18','13:00:00',6.07),('8975','2013-06-18','13:05:00',6.12),('8975','2013-06-18','13:10:00',6.12),('8975','2013-06-18','13:15:00',6.08),('8975','2013-06-18','13:20:00',6.04),('8975','2013-06-18','13:25:00',6.1),('8975','2013-06-18','13:30:00',6.03),('8975','2013-06-18','13:35:00',6.03),('8975','2013-06-18','13:40:00',6.06),('8975','2013-06-18','13:45:00',6.04),('8975','2013-06-18','13:50:00',6.02),('8975','2013-06-18','13:55:00',5.98),('8975','2013-06-18','14:00:00',5.98),('8975','2013-06-18','14:05:00',5.94),('8975','2013-06-18','14:10:00',5.88),('8975','2013-06-18','14:15:00',5.81),('8975','2013-06-18','14:20:00',5.76),('8975','2013-06-18','14:25:00',5.73),('8975','2013-06-18','14:30:00',5.66),('8975','2013-06-18','14:35:00',5.6),('8975','2013-06-18','14:40:00',5.55),('8975','2013-06-18','14:45:00',5.47),('8975','2013-06-18','14:50:00',5.4),('8975','2013-06-18','14:55:00',5.35),('8975','2013-06-18','15:00:00',5.29),('8975','2013-06-18','15:05:00',5.22),('8975','2013-06-18','15:10:00',5.15),('8975','2013-06-18','15:15:00',5.07),('8975','2013-06-18','15:20:00',5),('8975','2013-06-18','15:25:00',4.92),('8975','2013-06-18','15:30:00',4.81),('8975','2013-06-18','15:35:00',4.72),('8975','2013-06-18','15:40:00',4.64),('8975','2013-06-18','15:45:00',4.53),('8975','2013-06-18','15:50:00',4.46),('8975','2013-06-18','15:55:00',4.34),('8975','2013-06-18','16:00:00',4.16),('8975','2013-06-18','16:05:00',4.13),('8975','2013-06-18','16:10:00',3.76),('8975','2013-06-18','16:15:00',3.59),('8975','2013-06-18','16:20:00',3.85),('8975','2013-06-18','16:25:00',3.36),('8975','2013-06-18','16:30:00',2.92),('8975','2013-06-18','16:35:00',2.65),('8975','2013-06-18','16:40:00',2.71),('8975','2013-06-18','16:45:00',3.39),('8975','2013-06-18','16:50:00',3.3),('8975','2013-06-18','16:55:00',3.2),('8975','2013-06-18','17:00:00',3.1),('8975','2013-06-18','17:05:00',2.99),('8975','2013-06-18','17:10:00',2.88),('8975','2013-06-18','17:15:00',2.77),('8975','2013-06-18','17:20:00',2.67),('8975','2013-06-18','17:25:00',2.57),('8975','2013-06-18','17:30:00',2.46),('8975','2013-06-18','17:35:00',2.35),('8975','2013-06-18','17:40:00',2.24),('8975','2013-06-18','17:45:00',2.13),('8975','2013-06-18','17:50:00',2.04),('8975','2013-06-18','17:55:00',1.94),('8975','2013-06-18','18:00:00',1.84),('8975','2013-06-18','18:05:00',1.75),('8975','2013-06-18','18:10:00',1.65),('8975','2013-06-18','18:15:00',1.57),('8975','2013-06-18','18:20:00',1.49),('8975','2013-06-18','18:25:00',1.41),('8975','2013-06-18','18:30:00',1.2),('8975','2013-06-18','18:35:00',1.14),('8975','2013-06-18','18:40:00',1.06),('8975','2013-06-18','18:45:00',1),('8975','2013-06-18','18:50:00',1),('8975','2013-06-17','06:30:00',1),('8975','2013-06-17','06:35:00',1.14),('8975','2013-06-17','06:40:00',1.27),('8975','2013-06-17','06:45:00',1.4),('8975','2013-06-17','06:50:00',1.55),('8975','2013-06-17','06:55:00',1.7),('8975','2013-06-17','07:00:00',1.83),('8975','2013-06-17','07:05:00',1.98),('8975','2013-06-17','07:10:00',2.11),('8975','2013-06-17','07:15:00',2.24),('8975','2013-06-17','07:20:00',2.36),('8975','2013-06-17','07:25:00',2.49),('8975','2013-06-17','07:30:00',2.61),('8975','2013-06-17','07:35:00',2.73),('8975','2013-06-17','07:40:00',2.83),('8975','2013-06-17','07:45:00',2.92),('8975','2013-06-17','07:50:00',3.03),('8975','2013-06-17','07:55:00',3.14),('8975','2013-06-17','08:00:00',3.24),('8975','2013-06-17','08:05:00',3.35),('8975','2013-06-17','08:10:00',3.46),('8975','2013-06-17','08:15:00',3.58),('8975','2013-06-17','08:20:00',3.69),('8975','2013-06-17','08:25:00',3.77),('8975','2013-06-17','08:30:00',3.86),('8975','2013-06-17','08:35:00',3.95),('8975','2013-06-17','08:40:00',4.04),('8975','2013-06-17','08:45:00',4.11),('8975','2013-06-17','08:50:00',4.24),('8975','2013-06-17','08:55:00',4.33),('8975','2013-06-17','09:00:00',4.39),('8975','2013-06-17','09:05:00',4.47),('8975','2013-06-17','09:10:00',4.54),('8975','2013-06-17','09:15:00',4.61),('8975','2013-06-17','09:20:00',4.71),('8975','2013-06-17','09:25:00',4.81),('8975','2013-06-17','09:30:00',4.87),('8975','2013-06-17','09:35:00',4.95),('8975','2013-06-17','09:40:00',5.04),('8975','2013-06-17','09:45:00',5.1),('8975','2013-06-17','09:50:00',5.17),('8975','2013-06-17','09:55:00',5.24),('8975','2013-06-17','10:00:00',5.28),('8975','2013-06-17','10:05:00',5.37),('8975','2013-06-17','10:10:00',5.37),('8975','2013-06-17','10:15:00',5.39),('8975','2013-06-17','10:20:00',5.55),('8975','2013-06-17','10:25:00',5.54),('8975','2013-06-17','10:30:00',5.62),('8975','2013-06-17','10:35:00',5.7),('8975','2013-06-17','10:40:00',5.73),('8975','2013-06-17','10:45:00',5.77),('8975','2013-06-17','10:50:00',5.85),('8975','2013-06-17','10:55:00',5.81),('8975','2013-06-17','11:00:00',5.74),('8975','2013-06-17','11:05:00',5.81),('8975','2013-06-17','11:10:00',5.85),('8975','2013-06-17','11:15:00',5.81),('8975','2013-06-17','11:20:00',5.99),('8975','2013-06-17','11:25:00',5.98),('8975','2013-06-17','11:30:00',6.04),('8975','2013-06-17','11:35:00',5.97),('8975','2013-06-17','11:40:00',5.92),('8975','2013-06-17','11:45:00',5.93),('8975','2013-06-17','11:50:00',5.96),('8975','2013-06-17','11:55:00',6),('8975','2013-06-17','12:00:00',5.99),('8975','2013-06-17','12:05:00',5.89),('8975','2013-06-17','12:10:00',5.81),('8975','2013-06-17','12:15:00',5.79),('8975','2013-06-17','12:20:00',5.75),('8975','2013-06-17','12:25:00',6.08),('8975','2013-06-17','12:30:00',4.22),('8975','2013-06-17','12:35:00',5.87),('8975','2013-06-17','12:40:00',6.02),('8975','2013-06-17','12:45:00',6.17),('8975','2013-06-17','12:50:00',6.12),('8975','2013-06-17','12:55:00',6.22),('8975','2013-06-17','13:00:00',6.27),('8975','2013-06-17','13:05:00',6.36),('8975','2013-06-17','13:10:00',6.29),('8975','2013-06-17','13:15:00',5.05),('8975','2013-06-17','13:20:00',5.09),('8975','2013-06-17','13:25:00',6.01),('8975','2013-06-17','13:30:00',5.7),('8975','2013-06-17','13:35:00',5.8),('8975','2013-06-17','13:40:00',5.6),('8975','2013-06-17','13:45:00',5.67),('8975','2013-06-17','13:50:00',5.95),('8975','2013-06-17','13:55:00',6.16),('8975','2013-06-17','14:00:00',6.02),('8975','2013-06-17','14:05:00',5.98),('8975','2013-06-17','14:10:00',5.97),('8975','2013-06-17','14:15:00',5.9),('8975','2013-06-17','14:20:00',5.85),('8975','2013-06-17','14:25:00',5.77),('8975','2013-06-17','14:30:00',5.75),('8975','2013-06-17','14:35:00',5.76),('8975','2013-06-17','14:40:00',5.77),('8975','2013-06-17','14:45:00',5.6),('8975','2013-06-17','14:50:00',5.52),('8975','2013-06-17','14:55:00',5.45),('8975','2013-06-17','15:00:00',5.38),('8975','2013-06-17','15:05:00',5.31),('8975','2013-06-17','15:10:00',5.24),('8975','2013-06-17','15:15:00',5.18),('8975','2013-06-17','15:20:00',5.08),('8975','2013-06-17','15:25:00',5.03),('8975','2013-06-17','15:30:00',4.99),('8975','2013-06-17','15:35:00',4.93),('8975','2013-06-17','15:40:00',4.82),('8975','2013-06-17','15:45:00',4.71),('8975','2013-06-17','15:50:00',4.68),('8975','2013-06-17','15:55:00',4.6),('8975','2013-06-17','16:00:00',4.54),('8975','2013-06-17','16:05:00',4.47),('8975','2013-06-17','16:10:00',4.38),('8975','2013-06-17','16:15:00',4.28),('8975','2013-06-17','16:20:00',4.16),('8975','2013-06-17','16:25:00',4.04),('8975','2013-06-17','16:30:00',3.93),('8975','2013-06-17','16:35:00',3.76),('8975','2013-06-17','16:40:00',3.64),('8975','2013-06-17','16:45:00',3.46),('8975','2013-06-17','16:50:00',3.3),('8975','2013-06-17','16:55:00',3.23),('8975','2013-06-17','17:00:00',3.11),('8975','2013-06-17','17:05:00',2.99),('8975','2013-06-17','17:10:00',2.89),('8975','2013-06-17','17:15:00',2.81),('8975','2013-06-17','17:20:00',2.64),('8975','2013-06-17','17:25:00',2.57),('8975','2013-06-17','17:30:00',2.47),('8975','2013-06-17','17:35:00',2.34),('8975','2013-06-17','17:40:00',2.24),('8975','2013-06-17','17:45:00',2.17),('8975','2013-06-17','17:50:00',2.06),('8975','2013-06-17','17:55:00',1.97),('8975','2013-06-17','18:00:00',1.9),('8975','2013-06-17','18:05:00',1.82),('8975','2013-06-17','18:10:00',1.7),('8975','2013-06-17','18:15:00',1.62),('8975','2013-06-17','18:20:00',1.57),('8975','2013-06-17','18:25:00',1.51),('8975','2013-06-17','18:30:00',1.43),('8975','2013-06-17','18:35:00',1.37),('8975','2013-06-17','18:40:00',1.31),('8975','2013-06-17','18:45:00',1.23),('8975','2013-06-17','18:50:00',1.21),('8975','2013-06-17','18:55:00',1.13),('8975','2013-06-17','19:00:00',1.11),('8975','2013-06-17','19:05:00',1.05),('8975','2013-06-16','06:25:00',1.12),('8975','2013-06-16','06:30:00',1.27),('8975','2013-06-16','06:35:00',1.43),('8975','2013-06-16','06:40:00',1.57),('8975','2013-06-16','06:45:00',1.71),('8975','2013-06-16','06:50:00',1.86),('8975','2013-06-16','06:55:00',1.98),('8975','2013-06-16','07:00:00',2.11),('8975','2013-06-16','07:05:00',2.24),('8975','2013-06-16','07:10:00',2.37),('8975','2013-06-16','07:15:00',2.5),('8975','2013-06-16','07:20:00',2.61),('8975','2013-06-16','07:25:00',2.74),('8975','2013-06-16','07:30:00',2.84),('8975','2013-06-16','07:35:00',2.93),('8975','2013-06-16','07:40:00',3.04),('8975','2013-06-16','07:45:00',3.16),('8975','2013-06-16','07:50:00',3.27),('8975','2013-06-16','07:55:00',3.38),('8975','2013-06-16','08:00:00',3.47),('8975','2013-06-16','08:05:00',3.58),('8975','2013-06-16','08:10:00',3.67),('8975','2013-06-16','08:15:00',3.73),('8975','2013-06-16','08:20:00',3.87),('8975','2013-06-16','08:25:00',3.97),('8975','2013-06-16','08:30:00',4.06),('8975','2013-06-16','08:35:00',4.16),('8975','2013-06-16','08:40:00',4.23),('8975','2013-06-16','08:45:00',4.31),('8975','2013-06-16','08:50:00',4.45),('8975','2013-06-16','08:55:00',4.52),('8975','2013-06-16','09:00:00',4.63),('8975','2013-06-16','09:05:00',4.7),('8975','2013-06-16','09:10:00',4.78),('8975','2013-06-16','09:15:00',4.83),('8975','2013-06-16','09:20:00',4.95),('8975','2013-06-16','09:25:00',5.02),('8975','2013-06-16','09:30:00',5.12),('8975','2013-06-16','09:35:00',5.16),('8975','2013-06-16','09:40:00',5.2),('8975','2013-06-16','09:45:00',5.27),('8975','2013-06-16','09:50:00',5.34),('8975','2013-06-16','09:55:00',5.44),('8975','2013-06-16','10:00:00',5.52),('8975','2013-06-16','10:05:00',5.56),('8975','2013-06-16','10:10:00',5.63),('8975','2013-06-16','10:15:00',5.68),('8975','2013-06-16','10:20:00',5.78),('8975','2013-06-16','10:25:00',5.8),('8975','2013-06-16','10:30:00',5.83),('8975','2013-06-16','10:35:00',5.87),('8975','2013-06-16','10:40:00',5.9),('8975','2013-06-16','10:45:00',5.92),('8975','2013-06-16','10:50:00',5.98),('8975','2013-06-16','10:55:00',6.03),('8975','2013-06-16','11:00:00',6.08),('8975','2013-06-16','11:05:00',6.06),('8975','2013-06-16','11:10:00',6.15),('8975','2013-06-16','11:15:00',6.13),('8975','2013-06-16','11:20:00',6.15),('8975','2013-06-16','11:25:00',6.18),('8975','2013-06-16','11:30:00',6.15),('8975','2013-06-16','11:35:00',6.21),('8975','2013-06-16','11:40:00',6.2),('8975','2013-06-16','11:45:00',6.25),('8975','2013-06-16','11:50:00',6.22),('8975','2013-06-16','11:55:00',6.16),('8975','2013-06-16','12:00:00',6.23),('8975','2013-06-16','12:05:00',6.24),('8975','2013-06-16','12:10:00',5.81),('8975','2013-06-16','12:15:00',5.68),('8975','2013-06-16','12:20:00',6),('8975','2013-06-16','12:25:00',5.96),('8975','2013-06-16','12:30:00',5.56),('8975','2013-06-16','12:35:00',6.07),('8975','2013-06-16','12:40:00',5.76),('8975','2013-06-16','12:45:00',4.57),('8975','2013-06-16','12:50:00',4.79),('8975','2013-06-16','12:55:00',5.42),('8975','2013-06-16','13:00:00',6.31),('8975','2013-06-16','13:05:00',6.3),('8975','2013-06-16','13:10:00',6.27),('8975','2013-06-16','13:15:00',6.29),('8975','2013-06-16','13:20:00',6.22),('8975','2013-06-16','13:25:00',6.21),('8975','2013-06-16','13:30:00',6.18),('8975','2013-06-16','13:35:00',6.15),('8975','2013-06-16','13:40:00',6.12),('8975','2013-06-16','13:45:00',6.1),('8975','2013-06-16','13:50:00',6.07),('8975','2013-06-16','13:55:00',6.01),('8975','2013-06-16','14:00:00',5.95),('8975','2013-06-16','14:05:00',5.89),('8975','2013-06-16','14:10:00',5.85),('8975','2013-06-16','14:15:00',5.84),('8975','2013-06-16','14:20:00',5.82),('8975','2013-06-16','14:25:00',5.76),('8975','2013-06-16','14:30:00',5.7),('8975','2013-06-16','14:35:00',5.67),('8975','2013-06-16','14:40:00',5.59),('8975','2013-06-16','14:45:00',5.51),('8975','2013-06-16','14:50:00',5.45),('8975','2013-06-16','14:55:00',5.37),('8975','2013-06-16','15:00:00',5.29),('8975','2013-06-16','15:05:00',5.24),('8975','2013-06-16','15:10:00',5.18),('8975','2013-06-16','15:15:00',5.12),('8975','2013-06-16','15:20:00',5.04),('8975','2013-06-16','15:25:00',4.93),('8975','2013-06-16','15:30:00',4.87),('8975','2013-06-16','15:35:00',4.79),('8975','2013-06-16','15:40:00',4.67),('8975','2013-06-16','15:45:00',4.61),('8975','2013-06-16','15:50:00',4.56),('8975','2013-06-16','15:55:00',4.46),('8975','2013-06-16','16:00:00',4.37),('8975','2013-06-16','16:05:00',4.26),('8975','2013-06-16','16:10:00',4.17),('8975','2013-06-16','16:15:00',4.07),('8975','2013-06-16','16:20:00',4.01),('8975','2013-06-16','16:25:00',3.9),('8975','2013-06-16','16:30:00',3.79),('8975','2013-06-16','16:35:00',3.71),('8975','2013-06-16','16:40:00',3.59),('8975','2013-06-16','16:45:00',3.5),('8975','2013-06-16','16:50:00',3.4),('8975','2013-06-16','16:55:00',3.3),('8975','2013-06-16','17:00:00',3.18),('8975','2013-06-16','17:05:00',3.07),('8975','2013-06-16','17:10:00',2.97),('8975','2013-06-16','17:15:00',2.89),('8975','2013-06-16','17:20:00',2.78),('8975','2013-06-16','17:25:00',2.69),('8975','2013-06-16','17:30:00',2.59),('8975','2013-06-16','17:35:00',2.49),('8975','2013-06-16','17:40:00',2.35),('8975','2013-06-16','17:45:00',2.26),('8975','2013-06-16','17:50:00',2.18),('8975','2013-06-16','17:55:00',2.09),('8975','2013-06-16','18:00:00',1.99),('8975','2013-06-16','18:05:00',1.9),('8975','2013-06-16','18:10:00',1.83),('8975','2013-06-16','18:15:00',1.74),('8975','2013-06-16','18:20:00',1.65),('8975','2013-06-16','18:25:00',1.49),('8975','2013-06-16','18:30:00',1.46),('8975','2013-06-16','18:35:00',1.51),('8975','2013-06-16','18:40:00',1.47),('8975','2013-06-16','18:45:00',1.43),('8975','2013-06-16','18:50:00',1.39),('8975','2013-06-16','18:55:00',1.33),('8975','2013-06-16','19:00:00',1.27),('8975','2013-06-16','19:05:00',1.22),('8975','2013-06-16','19:10:00',1.14),('8975','2013-06-16','19:15:00',1.07),('8975','2013-06-15','06:25:00',1.05),('8975','2013-06-15','06:30:00',1.2),('8975','2013-06-15','06:35:00',1.37),('8975','2013-06-15','06:40:00',1.55),('8975','2013-06-15','06:45:00',1.72),('8975','2013-06-15','06:50:00',1.86),('8975','2013-06-15','06:55:00',2.02),('8975','2013-06-15','07:00:00',2.17),('8975','2013-06-15','07:05:00',2.28),('8975','2013-06-15','07:10:00',2.4),('8975','2013-06-15','07:15:00',2.52),('8975','2013-06-15','07:20:00',2.65),('8975','2013-06-15','07:25:00',2.79),('8975','2013-06-15','07:30:00',2.9),('8975','2013-06-15','07:35:00',3.01),('8975','2013-06-15','07:40:00',3.13),('8975','2013-06-15','07:45:00',3.23),('8975','2013-06-15','07:50:00',3.32),('8975','2013-06-15','07:55:00',3.42),('8975','2013-06-15','08:00:00',3.53),('8975','2013-06-15','08:05:00',3.65),('8975','2013-06-15','08:10:00',3.77),('8975','2013-06-15','08:15:00',3.86),('8975','2013-06-15','08:20:00',3.96),('8975','2013-06-15','08:25:00',4.08),('8975','2013-06-15','08:30:00',4.18),('8975','2013-06-15','08:35:00',4.26),('8975','2013-06-15','08:40:00',4.36),('8975','2013-06-15','08:45:00',4.48),('8975','2013-06-15','08:50:00',4.59),('8975','2013-06-15','08:55:00',4.66),('8975','2013-06-15','09:00:00',4.7),('8975','2013-06-15','09:05:00',4.82),('8975','2013-06-15','09:10:00',4.9),('8975','2013-06-15','09:15:00',4.99),('8975','2013-06-15','09:20:00',4.63),('8975','2013-06-15','09:25:00',5.02),('8975','2013-06-15','09:30:00',4.94),('8975','2013-06-15','09:35:00',5.21),('8975','2013-06-15','09:40:00',4.58),('8975','2013-06-15','09:45:00',5.24),('8975','2013-06-15','09:50:00',5.2),('8975','2013-06-15','09:55:00',4.8),('8975','2013-06-15','10:00:00',5.12),('8975','2013-06-15','10:05:00',4.61),('8975','2013-06-15','10:10:00',5.15),('8975','2013-06-15','10:15:00',5.61),('8975','2013-06-15','10:20:00',5.85),('8975','2013-06-15','10:25:00',5.87),('8975','2013-06-15','10:30:00',5.9),('8975','2013-06-15','10:35:00',5.94),('8975','2013-06-15','10:40:00',6.03),('8975','2013-06-15','10:45:00',6.11),('8975','2013-06-15','10:50:00',6.18),('8975','2013-06-15','10:55:00',6.17),('8975','2013-06-15','11:00:00',6.19),('8975','2013-06-15','11:05:00',6.22),('8975','2013-06-15','11:10:00',6.21),('8975','2013-06-15','11:15:00',6.22),('8975','2013-06-15','11:20:00',6.34),('8975','2013-06-15','11:25:00',6.39),('8975','2013-06-15','11:30:00',6.39),('8975','2013-06-15','11:35:00',6.44),('8975','2013-06-15','11:40:00',6.44),('8975','2013-06-15','11:45:00',6.45),('8975','2013-06-15','11:50:00',6.47),('8975','2013-06-15','11:55:00',6.48),('8975','2013-06-15','12:00:00',6.53),('8975','2013-06-15','12:05:00',6.56),('8975','2013-06-15','12:10:00',6.5),('8975','2013-06-15','12:15:00',6.57),('8975','2013-06-15','12:20:00',6.56),('8975','2013-06-15','12:25:00',6.54),('8975','2013-06-15','12:30:00',6.49),('8975','2013-06-15','12:35:00',6.49),('8975','2013-06-15','12:40:00',6.46),('8975','2013-06-15','12:45:00',6.39),('8975','2013-06-15','12:50:00',6.53),('8975','2013-06-15','12:55:00',6.55),('8975','2013-06-15','13:00:00',6.53),('8975','2013-06-15','13:05:00',6.5),('8975','2013-06-15','13:10:00',6.53),('8975','2013-06-15','13:15:00',6.51),('8975','2013-06-15','13:20:00',6.45),('8975','2013-06-15','13:25:00',6.48),('8975','2013-06-15','13:30:00',6.38),('8975','2013-06-15','13:35:00',6.41),('8975','2013-06-15','13:40:00',6.37),('8975','2013-06-15','13:45:00',6.34),('8975','2013-06-15','13:50:00',6.28),('8975','2013-06-15','13:55:00',6.29),('8975','2013-06-15','14:00:00',6.21),('8975','2013-06-15','14:05:00',6.19),('8975','2013-06-15','14:10:00',6.13),('8975','2013-06-15','14:15:00',6.08),('8975','2013-06-15','14:20:00',6.03),('8975','2013-06-15','14:25:00',5.97),('8975','2013-06-15','14:30:00',5.9),('8975','2013-06-15','14:35:00',5.85),('8975','2013-06-15','14:40:00',5.78),('8975','2013-06-15','14:45:00',5.71),('8975','2013-06-15','14:50:00',5.61),('8975','2013-06-15','14:55:00',5.55),('8975','2013-06-15','15:00:00',5.49),('8975','2013-06-15','15:05:00',5.43),('8975','2013-06-15','15:10:00',5.37),('8975','2013-06-15','15:15:00',5.28),('8975','2013-06-15','15:20:00',5.2),('8975','2013-06-15','15:25:00',5.11),('8975','2013-06-15','15:30:00',5.03),('8975','2013-06-15','15:35:00',4.95),('8975','2013-06-15','15:40:00',4.85),('8975','2013-06-15','15:45:00',4.75),('8975','2013-06-15','15:50:00',4.65),('8975','2013-06-15','15:55:00',4.55),('8975','2013-06-15','16:00:00',4.44),('8975','2013-06-15','16:05:00',4.36),('8975','2013-06-15','16:10:00',4.26),('8975','2013-06-15','16:15:00',4.16),('8975','2013-06-15','16:20:00',4.05),('8975','2013-06-15','16:25:00',3.95),('8975','2013-06-15','16:30:00',3.84),('8975','2013-06-15','16:35:00',3.72),('8975','2013-06-15','16:40:00',3.61),('8975','2013-06-15','16:45:00',3.48),('8975','2013-06-15','16:50:00',3.38),('8975','2013-06-15','16:55:00',3.27),('8975','2013-06-15','17:00:00',3.15),('8975','2013-06-15','17:05:00',3.03),('8975','2013-06-15','17:10:00',2.91),('8975','2013-06-15','17:15:00',2.78),('8975','2013-06-15','17:20:00',2.67),('8975','2013-06-15','17:25:00',2.57),('8975','2013-06-15','17:30:00',2.43),('8975','2013-06-15','17:35:00',2.32),('8975','2013-06-15','17:40:00',2.2),('8975','2013-06-15','17:45:00',2.08),('8975','2013-06-15','17:50:00',2.01),('8975','2013-06-15','17:55:00',1.91),('8975','2013-06-15','18:00:00',1.83),('8975','2013-06-15','18:05:00',1.74),('8975','2013-06-15','18:10:00',1.66),('8975','2013-06-15','18:15:00',1.58),('8975','2013-06-15','18:20:00',1.51),('8975','2013-06-15','18:25:00',1.45),('8975','2013-06-15','18:30:00',1.38),('8975','2013-06-15','18:35:00',1.31),('8975','2013-06-15','18:40:00',1.26),('8975','2013-06-15','18:45:00',1.2),('8975','2013-06-15','18:50:00',1.14),('8975','2013-06-15','18:55:00',1.11),('8975','2013-06-15','19:00:00',1.04),('8975','2013-06-15','19:05:00',1.02),('8975','2013-06-14','06:30:00',1.12),('8975','2013-06-14','06:35:00',1.28),('8975','2013-06-14','06:40:00',1.46),('8975','2013-06-14','06:45:00',1.62),('8975','2013-06-14','06:50:00',1.76),('8975','2013-06-14','06:55:00',1.88),('8975','2013-06-14','07:00:00',2.01),('8975','2013-06-14','07:05:00',2.13),('8975','2013-06-14','07:10:00',2.24),('8975','2013-06-14','07:15:00',2.36),('8975','2013-06-14','07:20:00',2.5),('8975','2013-06-14','07:25:00',2.61),('8975','2013-06-14','07:30:00',2.73),('8975','2013-06-14','07:35:00',2.85),('8975','2013-06-14','07:40:00',2.97),('8975','2013-06-14','07:45:00',3.1),('8975','2013-06-14','07:50:00',3.19),('8975','2013-06-14','07:55:00',3.29),('8975','2013-06-14','08:00:00',3.38),('8975','2013-06-14','08:05:00',3.51),('8975','2013-06-14','08:10:00',3.71),('8975','2013-06-14','08:15:00',3.72),('8975','2013-06-14','08:20:00',3.87),('8975','2013-06-14','08:25:00',3.94),('8975','2013-06-14','08:30:00',4.05),('8975','2013-06-14','08:35:00',4.12),('8975','2013-06-14','08:40:00',4.1),('8975','2013-06-14','08:45:00',4.07),('8975','2013-06-14','08:50:00',4.15),('8975','2013-06-14','08:55:00',4),('8975','2013-06-14','09:00:00',4.09),('8975','2013-06-14','09:05:00',4.65),('8975','2013-06-14','09:10:00',4.77),('8975','2013-06-14','09:15:00',4.85),('8975','2013-06-14','09:20:00',4.92),('8975','2013-06-14','09:25:00',5.17),('8975','2013-06-14','09:30:00',5.18),('8975','2013-06-14','09:35:00',5.27),('8975','2013-06-14','09:40:00',5.29),('8975','2013-06-14','09:45:00',5.33),('8975','2013-06-14','09:50:00',5.53),('8975','2013-06-14','09:55:00',5.41),('8975','2013-06-14','10:00:00',5.42),('8975','2013-06-14','10:05:00',5.76),('8975','2013-06-14','10:10:00',5.92),('8975','2013-06-14','10:15:00',4.41),('8975','2013-06-14','10:20:00',5.45),('8975','2013-06-14','10:25:00',5.73),('8975','2013-06-14','10:30:00',5.88),('8975','2013-06-14','10:35:00',2.3),('8975','2013-06-14','10:40:00',2.97),('8975','2013-06-14','10:45:00',4.52),('8975','2013-06-14','10:50:00',6.63),('8975','2013-06-14','10:55:00',6.54),('8975','2013-06-14','11:00:00',6.69),('8975','2013-06-14','11:05:00',5.97),('8975','2013-06-14','11:10:00',5.65),('8975','2013-06-14','11:15:00',4.5),('8975','2013-06-14','11:20:00',5.56),('8975','2013-06-14','11:25:00',6.99),('8975','2013-06-14','11:30:00',6.22),('8975','2013-06-14','11:35:00',6.91),('8975','2013-06-14','11:40:00',5.4),('8975','2013-06-14','11:45:00',4.95),('8975','2013-06-14','11:50:00',5.96),('8975','2013-06-14','11:55:00',5.17),('8975','2013-06-14','12:00:00',4.35),('8975','2013-06-14','12:05:00',6.86),('8975','2013-06-14','12:10:00',6.8),('8975','2013-06-14','12:15:00',6.72),('8975','2013-06-14','12:20:00',6.7),('8975','2013-06-14','12:25:00',6.64),('8975','2013-06-14','12:30:00',6.65),('8975','2013-06-14','12:35:00',6.76),('8975','2013-06-14','12:40:00',6.7),('8975','2013-06-14','12:45:00',6.66),('8975','2013-06-14','12:50:00',6.66),('8975','2013-06-14','12:55:00',6.7),('8975','2013-06-14','13:00:00',6.68),('8975','2013-06-14','13:05:00',6.6),('8975','2013-06-14','13:10:00',6.59),('8975','2013-06-14','13:15:00',6.49),('8975','2013-06-14','13:20:00',6.5),('8975','2013-06-14','13:25:00',6.49),('8975','2013-06-14','13:30:00',6.42),('8975','2013-06-14','13:35:00',6.39),('8975','2013-06-14','13:40:00',6.36),('8975','2013-06-14','13:45:00',6.31),('8975','2013-06-14','13:50:00',6.29),('8975','2013-06-14','13:55:00',6.27),('8975','2013-06-14','14:00:00',6.19),('8975','2013-06-14','14:05:00',6.08),('8975','2013-06-14','14:10:00',6.09),('8975','2013-06-14','14:15:00',6.04),('8975','2013-06-14','14:20:00',6.01),('8975','2013-06-14','14:25:00',5.96),('8975','2013-06-14','14:30:00',5.86),('8975','2013-06-14','14:35:00',5.78),('8975','2013-06-14','14:40:00',5.7),('8975','2013-06-14','14:45:00',5.64),('8975','2013-06-14','14:50:00',5.61),('8975','2013-06-14','14:55:00',5.53),('8975','2013-06-14','15:00:00',5.46),('8975','2013-06-14','15:05:00',5.36),('8975','2013-06-14','15:10:00',5.3),('8975','2013-06-14','15:15:00',5.22),('8975','2013-06-14','15:20:00',5.02),('8975','2013-06-14','15:25:00',4.52),('8975','2013-06-14','15:30:00',4.51),('8975','2013-06-14','15:35:00',4.7),('8975','2013-06-14','15:40:00',4.81),('8975','2013-06-14','15:45:00',4.58),('8975','2013-06-14','15:50:00',4.51),('8975','2013-06-14','15:55:00',4.14),('8975','2013-06-14','16:00:00',4.15),('8975','2013-06-14','16:05:00',4.16),('8975','2013-06-14','16:10:00',4.18),('8975','2013-06-14','16:15:00',3.73),('8975','2013-06-14','16:20:00',4.03),('8975','2013-06-14','16:25:00',3.94),('8975','2013-06-14','16:30:00',3.82),('8975','2013-06-14','16:35:00',3.7),('8975','2013-06-14','16:40:00',3.58),('8975','2013-06-14','16:45:00',3.47),('8975','2013-06-14','16:50:00',3.38),('8975','2013-06-14','16:55:00',3.28),('8975','2013-06-14','17:00:00',3.16),('8975','2013-06-14','17:05:00',3.04),('8975','2013-06-14','17:10:00',2.93),('8975','2013-06-14','17:15:00',2.79),('8975','2013-06-14','17:20:00',2.67),('8975','2013-06-14','17:25:00',2.57),('8975','2013-06-14','17:30:00',2.46),('8975','2013-06-14','17:35:00',2.34),('8975','2013-06-14','17:40:00',2.24),('8975','2013-06-14','17:45:00',2.11),('8975','2013-06-14','17:50:00',2),('8975','2013-06-14','17:55:00',1.93),('8975','2013-06-14','18:00:00',1.84),('8975','2013-06-14','18:05:00',1.76),('8975','2013-06-14','18:10:00',1.67),('8975','2013-06-14','18:15:00',1.59),('8975','2013-06-14','18:20:00',1.52),('8975','2013-06-14','18:25:00',1.45),('8975','2013-06-14','18:30:00',1.33),('8975','2013-06-14','18:35:00',1.29),('8975','2013-06-14','18:40:00',1.23),('8975','2013-06-14','18:45:00',1.19),('8975','2013-06-14','18:50:00',1.16),('8975','2013-06-14','18:55:00',1.12),('8975','2013-06-14','19:00:00',1.06),('8975','2013-06-14','19:05:00',1.01),('8975','2013-06-13','06:15:00',1.16),('8975','2013-06-13','06:20:00',1.32),('8975','2013-06-13','06:25:00',1.47),('8975','2013-06-13','06:30:00',1.63),('8975','2013-06-13','06:35:00',1.79),('8975','2013-06-13','06:40:00',1.94),('8975','2013-06-13','06:45:00',2.09),('8975','2013-06-13','06:50:00',2.23),('8975','2013-06-13','06:55:00',2.36),('8975','2013-06-13','07:00:00',2.49),('8975','2013-06-13','07:05:00',2.63),('8975','2013-06-13','07:10:00',2.75),('8975','2013-06-13','07:15:00',2.88),('8975','2013-06-13','07:20:00',3.02),('8975','2013-06-13','07:25:00',3.14),('8975','2013-06-13','07:30:00',3.26),('8975','2013-06-13','07:35:00',3.37),('8975','2013-06-13','07:40:00',3.46),('8975','2013-06-13','07:45:00',3.57),('8975','2013-06-13','07:50:00',3.67),('8975','2013-06-13','07:55:00',3.76),('8975','2013-06-13','08:00:00',3.87),('8975','2013-06-13','08:05:00',3.96),('8975','2013-06-13','08:10:00',4.05),('8975','2013-06-13','08:15:00',4.12),('8975','2013-06-13','08:20:00',4.22),('8975','2013-06-13','08:25:00',4.3),('8975','2013-06-13','08:30:00',4.39),('8975','2013-06-13','08:35:00',4.5),('8975','2013-06-13','08:40:00',4.59),('8975','2013-06-13','08:45:00',4.67),('8975','2013-06-13','08:50:00',4.76),('8975','2013-06-13','08:55:00',4.86),('8975','2013-06-13','09:00:00',4.95),('8975','2013-06-13','09:05:00',5.03),('8975','2013-06-13','09:10:00',5.11),('8975','2013-06-13','09:15:00',5.18),('8975','2013-06-13','09:20:00',5.24),('8975','2013-06-13','09:25:00',5.32),('8975','2013-06-13','09:30:00',5.39),('8975','2013-06-13','09:35:00',5.5),('8975','2013-06-13','09:40:00',5.59),('8975','2013-06-13','09:45:00',5.64),('8975','2013-06-13','09:50:00',5.72),('8975','2013-06-13','09:55:00',5.73),('8975','2013-06-13','10:00:00',5.83),('8975','2013-06-13','10:05:00',5.84),('8975','2013-06-13','10:10:00',5.86),('8975','2013-06-13','10:15:00',6),('8975','2013-06-13','10:20:00',6),('8975','2013-06-13','10:25:00',6.05),('8975','2013-06-13','10:30:00',5.86),('8975','2013-06-13','10:35:00',6.33),('8975','2013-06-13','10:40:00',6.33),('8975','2013-06-13','10:45:00',6.39),('8975','2013-06-13','10:50:00',6.38),('8975','2013-06-13','10:55:00',6.38),('8975','2013-06-13','11:00:00',6.36),('8975','2013-06-13','11:05:00',6.41),('8975','2013-06-13','11:10:00',6.45),('8975','2013-06-13','11:15:00',6.55),('8975','2013-06-13','11:20:00',6.62),('8975','2013-06-13','11:25:00',6.33),('8975','2013-06-13','11:30:00',6.73),('8975','2013-06-13','11:35:00',6.73),('8975','2013-06-13','11:40:00',6.67),('8975','2013-06-13','11:45:00',6.65),('8975','2013-06-13','11:50:00',6.65),('8975','2013-06-13','11:55:00',6.63),('8975','2013-06-13','12:00:00',6.62),('8975','2013-06-13','12:05:00',6.64),('8975','2013-06-13','12:10:00',6.64),('8975','2013-06-13','12:15:00',6.69),('8975','2013-06-13','12:20:00',6.73),('8975','2013-06-13','12:25:00',6.69),('8975','2013-06-13','12:30:00',6.72),('8975','2013-06-13','12:35:00',6.67),('8975','2013-06-13','12:40:00',6.63),('8975','2013-06-13','12:45:00',6.65),('8975','2013-06-13','12:50:00',6.72),('8975','2013-06-13','12:55:00',6.68),('8975','2013-06-13','13:00:00',6.62),('8975','2013-06-13','13:05:00',6.69),('8975','2013-06-13','13:10:00',6.66),('8975','2013-06-13','13:15:00',6.63),('8975','2013-06-13','13:20:00',6.73),('8975','2013-06-13','13:25:00',6.66),('8975','2013-06-13','13:30:00',6.52),('8975','2013-06-13','13:35:00',6.4),('8975','2013-06-13','13:40:00',6.4),('8975','2013-06-13','13:45:00',6.37),('8975','2013-06-13','13:50:00',6.3),('8975','2013-06-13','13:55:00',6.24),('8975','2013-06-13','14:00:00',6.26),('8975','2013-06-13','14:05:00',6.2),('8975','2013-06-13','14:10:00',6.2),('8975','2013-06-13','14:15:00',6.2),('8975','2013-06-13','14:20:00',6.11),('8975','2013-06-13','14:25:00',6.01),('8975','2013-06-13','14:30:00',5.95),('8975','2013-06-13','14:35:00',5.96),('8975','2013-06-13','14:40:00',5.81),('8975','2013-06-13','14:45:00',5.77),('8975','2013-06-13','14:50:00',5.74),('8975','2013-06-13','14:55:00',5.66),('8975','2013-06-13','15:00:00',5.61),('8975','2013-06-13','15:05:00',5.52),('8975','2013-06-13','15:10:00',5.44),('8975','2013-06-13','15:15:00',5.37),('8975','2013-06-13','15:20:00',5.33),('8975','2013-06-13','15:25:00',5.22),('8975','2013-06-13','15:30:00',5.13),('8975','2013-06-13','15:35:00',5.04),('8975','2013-06-13','15:40:00',4.96),('8975','2013-06-13','15:45:00',4.84),('8975','2013-06-13','15:50:00',4.76),('8975','2013-06-13','15:55:00',4.68),('8975','2013-06-13','16:00:00',4.56),('8975','2013-06-13','16:05:00',4.44),('8975','2013-06-13','16:10:00',4.34),('8975','2013-06-13','16:15:00',4.22),('8975','2013-06-13','16:20:00',4.11),('8975','2013-06-13','16:25:00',4.02),('8975','2013-06-13','16:30:00',3.9),('8975','2013-06-13','16:35:00',3.79),('8975','2013-06-13','16:40:00',3.66),('8975','2013-06-13','16:45:00',3.53),('8975','2013-06-13','16:50:00',3.38),('8975','2013-06-13','16:55:00',3.27),('8975','2013-06-13','17:00:00',3.18),('8975','2013-06-13','17:05:00',3),('8975','2013-06-13','17:10:00',2.83),('8975','2013-06-13','17:15:00',2.79),('8975','2013-06-13','17:20:00',2.64),('8975','2013-06-13','17:25:00',2.58),('8975','2013-06-13','17:30:00',2.38),('8975','2013-06-13','17:35:00',2.31),('8975','2013-06-13','17:40:00',2.27),('8975','2013-06-13','17:45:00',2.17),('8975','2013-06-13','17:50:00',2.06),('8975','2013-06-13','17:55:00',1.95),('8975','2013-06-13','18:00:00',1.85),('8975','2013-06-13','18:05:00',1.76),('8975','2013-06-13','18:10:00',1.71),('8975','2013-06-13','18:15:00',1.62),('8975','2013-06-13','18:20:00',1.53),('8975','2013-06-13','18:25:00',1.46),('8975','2013-06-13','18:30:00',1.41),('8975','2013-06-13','18:35:00',1.35),('8975','2013-06-13','18:40:00',1.3),('8975','2013-06-13','18:45:00',1.27),('8975','2013-06-13','18:50:00',1.21),('8975','2013-06-13','18:55:00',1.17),('8975','2013-06-13','19:00:00',1.11),('8975','2013-06-13','19:05:00',1.02),('8975','2013-06-12','06:15:00',1.24),('8975','2013-06-12','06:20:00',1.41),('8975','2013-06-12','06:25:00',1.56),('8975','2013-06-12','06:30:00',1.7),('8975','2013-06-12','06:35:00',1.86),('8975','2013-06-12','06:40:00',1.98),('8975','2013-06-12','06:45:00',2.13),('8975','2013-06-12','06:50:00',2.29),('8975','2013-06-12','06:55:00',2.42),('8975','2013-06-12','07:00:00',2.52),('8975','2013-06-12','07:05:00',2.62),('8975','2013-06-12','07:10:00',2.76),('8975','2013-06-12','07:15:00',2.9),('8975','2013-06-12','07:20:00',3.05),('8975','2013-06-12','07:25:00',3.17),('8975','2013-06-12','07:30:00',3.28),('8975','2013-06-12','07:35:00',3.39),('8975','2013-06-12','07:40:00',3.5),('8975','2013-06-12','07:45:00',3.6),('8975','2013-06-12','07:50:00',3.72),('8975','2013-06-12','07:55:00',3.83),('8975','2013-06-12','08:00:00',3.91),('8975','2013-06-12','08:05:00',3.97),('8975','2013-06-12','08:10:00',4.07),('8975','2013-06-12','08:15:00',4.17),('8975','2013-06-12','08:20:00',4.28),('8975','2013-06-12','08:25:00',4.38),('8975','2013-06-12','08:30:00',4.46),('8975','2013-06-12','08:35:00',4.57),('8975','2013-06-12','08:40:00',4.68),('8975','2013-06-12','08:45:00',4.74),('8975','2013-06-12','08:50:00',4.83),('8975','2013-06-12','08:55:00',4.91),('8975','2013-06-12','09:00:00',4.99),('8975','2013-06-12','09:05:00',5.07),('8975','2013-06-12','09:10:00',5.19),('8975','2013-06-12','09:15:00',5.26),('8975','2013-06-12','09:20:00',5.35),('8975','2013-06-12','09:25:00',5.47),('8975','2013-06-12','09:30:00',5.58),('8975','2013-06-12','09:35:00',5.65),('8975','2013-06-12','09:40:00',5.73),('8975','2013-06-12','09:45:00',5.84),('8975','2013-06-12','09:50:00',5.91),('8975','2013-06-12','09:55:00',5.96),('8975','2013-06-12','10:00:00',6.03),('8975','2013-06-12','10:05:00',6.11),('8975','2013-06-12','10:10:00',6.14),('8975','2013-06-12','10:15:00',6.24),('8975','2013-06-12','10:20:00',6.33),('8975','2013-06-12','10:25:00',6.38),('8975','2013-06-12','10:30:00',6.47),('8975','2013-06-12','10:35:00',6.54),('8975','2013-06-12','10:40:00',6.61),('8975','2013-06-12','10:45:00',6.66),('8975','2013-06-12','10:50:00',6.71),('8975','2013-06-12','10:55:00',6.78),('8975','2013-06-12','11:00:00',6.8),('8975','2013-06-12','11:05:00',6.81),('8975','2013-06-12','11:10:00',6.84),('8975','2013-06-12','11:15:00',6.87),('8975','2013-06-12','11:20:00',6.89),('8975','2013-06-12','11:25:00',6.92),('8975','2013-06-12','11:30:00',6.95),('8975','2013-06-12','11:35:00',7.01),('8975','2013-06-12','11:40:00',7.03),('8975','2013-06-12','11:45:00',6.96),('8975','2013-06-12','11:50:00',7.06),('8975','2013-06-12','11:55:00',6.7),('8975','2013-06-12','12:00:00',6.8),('8975','2013-06-12','12:05:00',5.64),('8975','2013-06-12','12:10:00',5.35),('8975','2013-06-12','12:15:00',5.97),('8975','2013-06-12','12:20:00',6.98),('8975','2013-06-12','12:25:00',6.63),('8975','2013-06-12','12:30:00',6.76),('8975','2013-06-12','12:35:00',6.5),('8975','2013-06-12','12:40:00',6.38),('8975','2013-06-12','12:45:00',6.7),('8975','2013-06-12','12:50:00',7),('8975','2013-06-12','12:55:00',7),('8975','2013-06-12','13:00:00',6.99),('8975','2013-06-12','13:05:00',6.93),('8975','2013-06-12','13:10:00',6.92),('8975','2013-06-12','13:15:00',6.83),('8975','2013-06-12','13:20:00',6.85),('8975','2013-06-12','13:25:00',6.81),('8975','2013-06-12','13:30:00',6.75),('8975','2013-06-12','13:35:00',6.68),('8975','2013-06-12','13:40:00',6.65),('8975','2013-06-12','13:45:00',5.98),('8975','2013-06-12','13:50:00',6.53),('8975','2013-06-12','13:55:00',6.53),('8975','2013-06-12','14:00:00',6.49),('8975','2013-06-12','14:05:00',6.41),('8975','2013-06-12','14:10:00',6.3),('8975','2013-06-12','14:15:00',6.28),('8975','2013-06-12','14:20:00',3.52),('8975','2013-06-12','14:25:00',4.92),('8975','2013-06-12','14:30:00',4.19),('8975','2013-06-12','14:35:00',1.77),('8975','2013-06-12','14:40:00',3.44),('8975','2013-06-12','14:45:00',6.15),('8975','2013-06-12','14:50:00',5.99),('8975','2013-06-12','14:55:00',5.79),('8975','2013-06-12','15:00:00',5.67),('8975','2013-06-12','15:05:00',5.6),('8975','2013-06-12','15:10:00',5.5),('8975','2013-06-12','15:15:00',5.41),('8975','2013-06-12','15:20:00',5.32),('8975','2013-06-12','15:25:00',5.21),('8975','2013-06-12','15:30:00',5.11),('8975','2013-06-12','15:35:00',5.08),('8975','2013-06-12','15:40:00',4.97),('8975','2013-06-12','15:45:00',4.83),('8975','2013-06-12','15:50:00',4.76),('8975','2013-06-12','15:55:00',4.65),('8975','2013-06-12','16:00:00',4.47),('8975','2013-06-12','16:05:00',4.4),('8975','2013-06-12','16:10:00',4.29),('8975','2013-06-12','16:15:00',4.18),('8975','2013-06-12','16:20:00',4.03),('8975','2013-06-12','16:25:00',3.95),('8975','2013-06-12','16:30:00',3.8),('8975','2013-06-12','16:35:00',3.7),('8975','2013-06-12','16:40:00',3.56),('8975','2013-06-12','16:45:00',3.5),('8975','2013-06-12','16:50:00',3.37),('8975','2013-06-12','16:55:00',3.31),('8975','2013-06-12','17:00:00',3.22),('8975','2013-06-12','17:05:00',3.09),('8975','2013-06-12','17:10:00',2.97),('8975','2013-06-12','17:15:00',2.84),('8975','2013-06-12','17:20:00',2.71),('8975','2013-06-12','17:25:00',2.58),('8975','2013-06-12','17:30:00',2.46),('8975','2013-06-12','17:35:00',2.36),('8975','2013-06-12','17:40:00',2.25),('8975','2013-06-12','17:45:00',2.13),('8975','2013-06-12','17:50:00',2.04),('8975','2013-06-12','17:55:00',1.93),('8975','2013-06-12','18:00:00',1.84),('8975','2013-06-12','18:05:00',1.75),('8975','2013-06-12','18:10:00',1.67),('8975','2013-06-12','18:15:00',1.6),('8975','2013-06-12','18:20:00',1.52),('8975','2013-06-12','18:25:00',1.45),('8975','2013-06-12','18:30:00',1.38),('8975','2013-06-12','18:35:00',1.32),('8975','2013-06-12','18:40:00',1.27),('8975','2013-06-12','18:45:00',1.22),('8975','2013-06-12','18:50:00',1.19),('8975','2013-06-12','18:55:00',1.13),('8975','2013-06-12','19:00:00',1.09),('8975','2013-06-12','19:05:00',1.04),('8975','2013-06-11','06:15:00',1.26),('8975','2013-06-11','06:20:00',1.44),('8975','2013-06-11','06:25:00',1.61),('8975','2013-06-11','06:30:00',1.75),('8975','2013-06-11','06:35:00',1.9),('8975','2013-06-11','06:40:00',2.05),('8975','2013-06-11','06:45:00',2.18),('8975','2013-06-11','06:50:00',2.31),('8975','2013-06-11','06:55:00',2.44),('8975','2013-06-11','07:00:00',2.61),('8975','2013-06-11','07:05:00',2.74),('8975','2013-06-11','07:10:00',2.85),('8975','2013-06-11','07:15:00',2.95),('8975','2013-06-11','07:20:00',3.08),('8975','2013-06-11','07:25:00',3.18),('8975','2013-06-11','07:30:00',3.29),('8975','2013-06-11','07:35:00',3.38),('8975','2013-06-11','07:40:00',3.49),('8975','2013-06-11','07:45:00',3.57),('8975','2013-06-11','07:50:00',3.68),('8975','2013-06-11','07:55:00',3.8),('8975','2013-06-11','08:00:00',3.9),('8975','2013-06-11','08:05:00',4.01),('8975','2013-06-11','08:10:00',4.12),('8975','2013-06-11','08:15:00',4.22),('8975','2013-06-11','08:20:00',4.34),('8975','2013-06-11','08:25:00',4.46),('8975','2013-06-11','08:30:00',4.57),('8975','2013-06-11','08:35:00',4.66),('8975','2013-06-11','08:40:00',4.74),('8975','2013-06-11','08:45:00',4.85),('8975','2013-06-11','08:50:00',4.98),('8975','2013-06-11','08:55:00',5.09),('8975','2013-06-11','09:00:00',5.2),('8975','2013-06-11','09:05:00',5.28),('8975','2013-06-11','09:10:00',5.4),('8975','2013-06-11','09:15:00',5.5),('8975','2013-06-11','09:20:00',5.61),('8975','2013-06-11','09:25:00',5.7),('8975','2013-06-11','09:30:00',5.77),('8975','2013-06-11','09:35:00',5.87),('8975','2013-06-11','09:40:00',5.92),('8975','2013-06-11','09:45:00',5.94),('8975','2013-06-11','09:50:00',6.03),('8975','2013-06-11','09:55:00',6.14),('8975','2013-06-11','10:00:00',6.2),('8975','2013-06-11','10:05:00',6.24),('8975','2013-06-11','10:10:00',6.32),('8975','2013-06-11','10:15:00',6.35),('8975','2013-06-11','10:20:00',6.44),('8975','2013-06-11','10:25:00',6.48),('8975','2013-06-11','10:30:00',6.57),('8975','2013-06-11','10:35:00',6.58),('8975','2013-06-11','10:40:00',6.57),('8975','2013-06-11','10:45:00',6.63),('8975','2013-06-11','10:50:00',6.63),('8975','2013-06-11','10:55:00',6.73),('8975','2013-06-11','11:00:00',6.71),('8975','2013-06-11','11:05:00',6.82),('8975','2013-06-11','11:10:00',6.86),('8975','2013-06-11','11:15:00',6.91),('8975','2013-06-11','11:20:00',6.98),('8975','2013-06-11','11:25:00',6.96),('8975','2013-06-11','11:30:00',6.98),('8975','2013-06-11','11:35:00',6.95),('8975','2013-06-11','11:40:00',6.92),('8975','2013-06-11','11:45:00',6.95),('8975','2013-06-11','11:50:00',7.01),('8975','2013-06-11','11:55:00',7.04),('8975','2013-06-11','12:00:00',7.11),('8975','2013-06-11','12:05:00',6.98),('8975','2013-06-11','12:10:00',6.5),('8975','2013-06-11','12:15:00',6.63),('8975','2013-06-11','12:20:00',7.07),('8975','2013-06-11','12:25:00',5.87),('8975','2013-06-11','12:30:00',5),('8975','2013-06-11','12:35:00',4.15),('8975','2013-06-11','12:40:00',6.86),('8975','2013-06-11','12:45:00',2.1),('8975','2013-06-11','12:50:00',1.45),('8975','2013-06-11','12:55:00',3.29),('8975','2013-06-11','13:00:00',5.85),('8975','2013-06-11','13:05:00',3.12),('8975','2013-06-11','13:10:00',4.36),('8975','2013-06-11','13:15:00',5.78),('8975','2013-06-11','13:20:00',6.82),('8975','2013-06-11','13:25:00',6.97),('8975','2013-06-11','13:30:00',6.77),('8975','2013-06-11','13:35:00',6.76),('8975','2013-06-11','13:40:00',6.73),('8975','2013-06-11','13:45:00',6.82),('8975','2013-06-11','13:50:00',5.71),('8975','2013-06-11','13:55:00',6.21),('8975','2013-06-11','14:00:00',4.84),('8975','2013-06-11','14:05:00',5.58),('8975','2013-06-11','14:10:00',1.63),('8975','2013-06-11','14:15:00',6.18),('8975','2013-06-11','14:20:00',6.07),('8975','2013-06-11','14:25:00',5.41),('8975','2013-06-11','14:30:00',4.59),('8975','2013-06-11','14:35:00',6.49),('8975','2013-06-11','14:40:00',6.48),('8975','2013-06-11','14:45:00',6.23),('8975','2013-06-11','14:50:00',5.99),('8975','2013-06-11','14:55:00',6.16),('8975','2013-06-11','15:00:00',6.11),('8975','2013-06-11','15:05:00',5.98),('8975','2013-06-11','15:10:00',5.86),('8975','2013-06-11','15:15:00',5.78),('8975','2013-06-11','15:20:00',5.46),('8975','2013-06-11','15:25:00',5.4),('8975','2013-06-11','15:30:00',5.27),('8975','2013-06-11','15:35:00',5.26),('8975','2013-06-11','15:40:00',5.14),('8975','2013-06-11','15:45:00',5.05),('8975','2013-06-11','15:50:00',4.93),('8975','2013-06-11','15:55:00',4.91),('8975','2013-06-11','16:00:00',4.8),('8975','2013-06-11','16:05:00',4.63),('8975','2013-06-11','16:10:00',4.48),('8975','2013-06-11','16:15:00',4.37),('8975','2013-06-11','16:20:00',4.27),('8975','2013-06-11','16:25:00',4.17),('8975','2013-06-11','16:30:00',4.09),('8975','2013-06-11','16:35:00',3.96),('8975','2013-06-11','16:40:00',3.85),('8975','2013-06-11','16:45:00',3.75),('8975','2013-06-11','16:50:00',3.58),('8975','2013-06-11','16:55:00',3.38),('8975','2013-06-11','17:00:00',3.28),('8975','2013-06-11','17:05:00',3.13),('8975','2013-06-11','17:10:00',3.06),('8975','2013-06-11','17:15:00',2.93),('8975','2013-06-11','17:20:00',2.83),('8975','2013-06-11','17:25:00',2.71),('8975','2013-06-11','17:30:00',2.54),('8975','2013-06-11','17:35:00',2.24),('8975','2013-06-11','17:40:00',2.39),('8975','2013-06-11','17:45:00',2.17),('8975','2013-06-11','18:10:00',1.81),('8975','2013-06-11','18:15:00',1.7),('8975','2013-06-11','18:20:00',1.65),('8975','2013-06-11','18:25:00',1.49),('8975','2013-06-11','18:30:00',1.42),('8975','2013-06-11','18:35:00',1.38),('8975','2013-06-11','18:40:00',1.32),('8975','2013-06-11','18:45:00',1.29),('8975','2013-06-11','18:50:00',1.21),('8975','2013-06-11','18:55:00',1.17),('8975','2013-06-11','19:00:00',1.13),('8975','2013-06-11','19:05:00',1.07),('8975','2013-06-10','07:00:00',1.06),('8975','2013-06-10','07:10:00',1.13),('8975','2013-06-10','07:15:00',1.61),('8975','2013-06-10','07:20:00',1.76),('8975','2013-06-10','07:25:00',2.33),('8975','2013-06-10','07:30:00',3.27),('8975','2013-06-10','07:35:00',3.37),('8975','2013-06-10','07:40:00',3.44),('8975','2013-06-10','07:45:00',3.58),('8975','2013-06-10','07:50:00',3.71),('8975','2013-06-10','07:55:00',2.61),('8975','2013-06-10','08:00:00',3.4),('8975','2013-06-10','08:05:00',4.33),('8975','2013-06-10','08:10:00',4.34),('8975','2013-06-10','08:15:00',4.26),('8975','2013-06-10','08:20:00',1.69),('8975','2013-06-10','08:25:00',4.75),('8975','2013-06-10','08:30:00',2.84),('8975','2013-06-10','08:35:00',1.68),('8975','2013-06-10','08:40:00',5.22),('8975','2013-06-10','08:45:00',5.24),('8975','2013-06-10','08:50:00',5.3),('8975','2013-06-10','08:55:00',5.47),('8975','2013-06-10','09:00:00',5.65),('8975','2013-06-10','09:05:00',5.53),('8975','2013-06-10','09:10:00',5.56),('8975','2013-06-10','09:15:00',5.51),('8975','2013-06-10','09:20:00',5.7),('8975','2013-06-10','09:25:00',5.88),('8975','2013-06-10','09:30:00',5.45),('8975','2013-06-10','09:35:00',2.35),('8975','2013-06-10','09:40:00',4.05),('8975','2013-06-10','09:45:00',6.49),('8975','2013-06-10','09:50:00',5.53),('8975','2013-06-10','09:55:00',2),('8975','2013-06-10','10:00:00',3.4),('8975','2013-06-10','10:05:00',5.7),('8975','2013-06-10','10:10:00',4.58),('8975','2013-06-10','10:15:00',4.86),('8975','2013-06-10','10:20:00',3.05),('8975','2013-06-10','10:25:00',5.11),('8975','2013-06-10','10:30:00',6.51),('8975','2013-06-10','10:35:00',6.66),('8975','2013-06-10','10:40:00',6.75),('8975','2013-06-10','10:45:00',6.67),('8975','2013-06-10','10:50:00',6.85),('8975','2013-06-10','10:55:00',6.77),('8975','2013-06-10','11:00:00',6.4),('8975','2013-06-10','11:05:00',5.01),('8975','2013-06-10','11:10:00',4.63),('8975','2013-06-10','11:15:00',7.34),('8975','2013-06-10','11:20:00',7.09),('8975','2013-06-10','11:25:00',7.06),('8975','2013-06-10','11:30:00',7.04),('8975','2013-06-10','11:35:00',7.02),('8975','2013-06-10','11:40:00',7.02),('8975','2013-06-10','11:45:00',7.05),('8975','2013-06-10','11:50:00',7.04),('8975','2013-06-10','11:55:00',7.08),('8975','2013-06-10','12:00:00',7.13),('8975','2013-06-10','12:05:00',7.13),('8975','2013-06-10','12:10:00',7.09),('8975','2013-06-10','12:15:00',7.11),('8975','2013-06-10','12:20:00',7.14),('8975','2013-06-10','12:25:00',7.1),('8975','2013-06-10','12:30:00',7.13),('8975','2013-06-10','12:35:00',7.12),('8975','2013-06-10','12:40:00',7.15),('8975','2013-06-10','12:45:00',7.11),('8975','2013-06-10','12:50:00',7.19),('8975','2013-06-10','12:55:00',7.12),('8975','2013-06-10','13:00:00',7.04),('8975','2013-06-10','13:05:00',7.09),('8975','2013-06-10','13:10:00',7.06),('8975','2013-06-10','13:15:00',7.03),('8975','2013-06-10','13:20:00',6.55),('8975','2013-06-10','13:25:00',6.87),('8975','2013-06-10','13:30:00',6.93),('8975','2013-06-10','13:35:00',6.95),('8975','2013-06-10','13:40:00',6.92),('8975','2013-06-10','13:45:00',7.02),('8975','2013-06-10','13:50:00',7),('8975','2013-06-10','13:55:00',6.83),('8975','2013-06-10','14:00:00',6.48),('8975','2013-06-10','14:05:00',6.73),('8975','2013-06-10','14:10:00',6.57),('8975','2013-06-10','14:15:00',6.42),('8975','2013-06-10','14:20:00',6.37),('8975','2013-06-10','14:25:00',6.32),('8975','2013-06-10','14:30:00',6.24),('8975','2013-06-10','14:35:00',6.2),('8975','2013-06-10','14:40:00',6.16),('8975','2013-06-10','14:45:00',6.09),('8975','2013-06-10','14:50:00',6),('8975','2013-06-10','14:55:00',5.93),('8975','2013-06-10','15:00:00',5.87),('8975','2013-06-10','15:05:00',5.75),('8975','2013-06-10','15:10:00',5.47),('8975','2013-06-10','15:15:00',5.58),('8975','2013-06-10','15:20:00',5.49),('8975','2013-06-10','15:25:00',5.31),('8975','2013-06-10','15:30:00',5.39),('8975','2013-06-10','15:35:00',5.18),('8975','2013-06-10','15:40:00',4.77),('8975','2013-06-10','15:45:00',4.68),('8975','2013-06-10','15:50:00',5.08),('8975','2013-06-10','15:55:00',4.97),('8975','2013-06-10','16:00:00',4.9),('8975','2013-06-10','16:05:00',4.76),('8975','2013-06-10','16:10:00',4.64),('8975','2013-06-10','16:15:00',4.54),('8975','2013-06-10','16:20:00',4.42),('8975','2013-06-10','16:25:00',4.34),('8975','2013-06-10','16:30:00',4.23),('8975','2013-06-10','16:35:00',4.15),('8975','2013-06-10','16:40:00',4.15),('8975','2013-06-10','16:45:00',4.29),('8975','2013-06-10','16:50:00',4.28),('8975','2013-06-10','16:55:00',4.13),('8975','2013-06-10','17:00:00',2.68),('8975','2013-06-10','17:05:00',2.33),('8975','2013-06-10','17:10:00',1.4),('8975','2013-06-10','17:15:00',1.14),('8975','2013-06-10','17:20:00',1.01),('8975','2013-06-10','19:30:00',1),('8975','2013-06-10','19:35:00',1.06),('8975','2014-04-02','08:15:00',1.05),('8975','2014-04-02','08:20:00',1.07),('8975','2014-04-02','08:25:00',1.05),('8975','2014-04-02','08:30:00',1.14),('8975','2014-04-02','08:35:00',1.21),('8975','2014-04-02','08:40:00',1.37),('8975','2014-04-02','08:45:00',1.6),('8975','2014-04-02','08:50:00',1.72),('8975','2014-04-02','08:55:00',1.96),('8975','2014-04-02','09:00:00',2.18),('8975','2014-04-02','09:05:00',2.26),('8975','2014-04-02','09:10:00',2.15),('8975','2014-04-02','09:15:00',2.01),('8975','2014-04-02','09:20:00',2.06),('8975','2014-04-02','09:25:00',2.14),('8975','2014-04-02','09:30:00',2.69),('8975','2014-04-02','09:35:00',3.19),('8975','2014-04-02','09:40:00',3.26),('8975','2014-04-02','09:45:00',3.24),('8975','2014-04-02','09:50:00',3.18),('8975','2014-04-02','09:55:00',3.33),('8975','2014-04-02','10:00:00',3.93),('8975','2014-04-02','10:05:00',4.72),('8975','2014-04-02','10:10:00',4.89),('8975','2014-04-02','10:15:00',5.51),('8975','2014-04-02','10:20:00',5.45),('8975','2014-04-02','10:25:00',3.91),('8975','2014-04-02','10:30:00',4.06),('8975','2014-04-02','10:35:00',4.5),('8975','2014-04-02','10:40:00',3.48),('8975','2014-04-02','10:45:00',3.52),('8975','2014-04-02','10:50:00',3.23),('8975','2014-04-02','10:55:00',3.65),('8975','2014-04-02','11:00:00',3.03),('8975','2014-04-02','11:05:00',2.71),('8975','2014-04-02','11:10:00',2.52),('8975','2014-04-02','11:15:00',2.34),('8975','2014-04-02','11:20:00',2.24),('8975','2014-04-02','11:25:00',2.1),('8975','2014-04-02','11:30:00',2.11),('8975','2014-04-02','11:35:00',2.26),('8975','2014-04-02','11:40:00',2.49),('8975','2014-04-02','11:45:00',2.95),('8975','2014-04-02','11:50:00',3.69),('8975','2014-04-02','11:55:00',3.75),('8975','2014-04-02','12:00:00',3.58),('8975','2014-04-02','12:05:00',3.53),('8975','2014-04-02','12:10:00',3.45),('8975','2014-04-02','12:15:00',3.41),('8975','2014-04-02','12:20:00',3.84),('8975','2014-04-02','12:25:00',4.92),('8975','2014-04-02','12:30:00',6.44),('8975','2014-04-02','12:35:00',6.15),('8975','2014-04-02','12:40:00',6.1),('8975','2014-04-02','12:45:00',3.24),('8975','2014-04-02','12:50:00',4.25),('8975','2014-04-02','12:55:00',3.91),('8975','2014-04-02','13:00:00',4.94),('8975','2014-04-02','13:05:00',5.58),('8975','2014-04-02','13:10:00',4.18),('8975','2014-04-02','13:15:00',6.99),('8975','2014-04-02','13:20:00',3.86),('8975','2014-04-02','13:25:00',4.65),('8975','2014-04-02','13:30:00',5.27),('8975','2014-04-02','13:35:00',6.44),('8975','2014-04-02','13:40:00',4.83),('8975','2014-04-02','13:45:00',3.21),('8975','2014-04-02','13:50:00',3.01),('8975','2014-04-02','13:55:00',4.31),('8975','2014-04-02','14:00:00',5.07),('8975','2014-04-02','14:05:00',4.88),('8975','2014-04-02','14:10:00',3.49),('8975','2014-04-02','14:15:00',5.58),('8975','2014-04-02','14:20:00',5.21),('8975','2014-04-02','14:25:00',4.93),('8975','2014-04-02','14:30:00',5.51),('8975','2014-04-02','14:35:00',5.26),('8975','2014-04-02','14:40:00',5.05),('8975','2014-04-02','14:45:00',4.83),('8975','2014-04-02','14:50:00',4.74),('8975','2014-04-02','14:55:00',4.6),('8975','2014-04-02','15:00:00',4.5),('8975','2014-04-02','15:05:00',4.41),('8975','2014-04-02','15:10:00',4.29),('8975','2014-04-02','15:15:00',4.17),('8975','2014-04-02','15:20:00',4.12),('8975','2014-04-02','15:25:00',4),('8975','2014-04-02','15:30:00',3.92),('8975','2014-04-02','15:35:00',3.71),('8975','2014-04-02','15:40:00',3.76),('8975','2014-04-02','15:45:00',3.66),('8975','2014-04-02','15:50:00',3.5),('8975','2014-04-02','15:55:00',3.35),('8975','2014-04-02','16:00:00',3.36),('8975','2014-04-02','16:05:00',3.25),('8975','2014-04-02','16:10:00',3.21),('8975','2014-04-02','16:15:00',3.09),('8975','2014-04-02','16:20:00',2.99),('8975','2014-04-02','16:25:00',2.84),('8975','2014-04-02','16:30:00',2.72),('8975','2014-04-02','16:35:00',2.63),('8975','2014-04-02','16:40:00',2.55),('8975','2014-04-02','16:45:00',2.36),('8975','2014-04-02','16:50:00',2.16),('8975','2014-04-02','16:55:00',1.9),('8975','2014-04-02','17:00:00',1.53),('8975','2014-04-02','17:05:00',1.41),('8975','2014-04-02','17:10:00',1.26),('8975','2014-04-02','17:15:00',1.16),('8975','2014-04-02','17:20:00',1.55),('8975','2014-04-02','17:25:00',1.25),('8975','2014-04-02','17:30:00',1.17),('8975','2014-04-02','17:45:00',1.55),('8975','2014-04-02','17:50:00',1.49),('8975','2014-04-02','17:55:00',1.39),('8975','2014-04-02','18:00:00',1.31),('8975','2014-04-02','18:05:00',1.24),('8975','2014-04-02','18:10:00',1.18),('8975','2014-04-02','18:15:00',1.09),('8975','2014-04-02','18:20:00',1.02),('8975','2013-06-09','07:05:00',1.59),('8975','2013-06-09','07:10:00',2.27),('8975','2013-06-09','07:20:00',1.94),('8975','2013-06-09','07:25:00',1.71),('8975','2013-06-09','07:30:00',2.66),('8975','2013-06-09','07:35:00',3.83),('8975','2013-06-09','07:40:00',2.05),('8975','2013-06-09','07:45:00',1.69),('8975','2013-06-09','07:50:00',1.37),('8975','2013-06-09','07:55:00',1.48),('8975','2013-06-09','08:00:00',1.64),('8975','2013-06-09','08:05:00',3.17),('8975','2013-06-09','08:10:00',4.28),('8975','2013-06-09','08:15:00',3.31),('8975','2013-06-09','08:20:00',3.25),('8975','2013-06-09','08:25:00',2.35),('8975','2013-06-09','08:30:00',2.14),('8975','2013-06-09','08:35:00',2.1),('8975','2013-06-09','08:40:00',1.68),('8975','2013-06-09','08:45:00',2.03),('8975','2013-06-09','08:50:00',2.27),('8975','2013-06-09','08:55:00',2.19),('8975','2013-06-09','09:00:00',2.74),('8975','2013-06-09','09:05:00',2.03),('8975','2013-06-09','09:10:00',2.88),('8975','2013-06-09','09:15:00',1.59),('8975','2013-06-09','09:20:00',3.91),('8975','2013-06-09','09:25:00',4.93),('8975','2013-06-09','09:30:00',4.86),('8975','2013-06-09','09:35:00',5.74),('8975','2013-06-09','09:40:00',3.16),('8975','2013-06-09','09:45:00',5.04),('8975','2013-06-09','09:50:00',3.05),('8975','2013-06-09','09:55:00',3.21),('8975','2013-06-09','10:00:00',4.75),('8975','2013-06-09','10:05:00',5.95),('8975','2013-06-09','10:10:00',3.77),('8975','2013-06-09','10:15:00',6.21),('8975','2013-06-09','10:20:00',6.85),('8975','2013-06-09','10:25:00',6.14),('8975','2013-06-09','10:30:00',4.97),('8975','2013-06-09','10:35:00',5.07),('8975','2013-06-09','10:40:00',3.66),('8975','2013-06-09','10:45:00',3.36),('8975','2013-06-09','10:50:00',3.27),('8975','2013-06-09','10:55:00',6.51),('8975','2013-06-09','11:00:00',2.25),('8975','2013-06-09','11:05:00',2.35),('8975','2013-06-09','11:10:00',4.96),('8975','2013-06-09','11:15:00',4.29),('8975','2013-06-09','11:20:00',5.29),('8975','2013-06-09','11:25:00',4.9),('8975','2013-06-09','11:30:00',4.67),('8975','2013-06-09','11:35:00',7.14),('8975','2013-06-09','11:40:00',3.43),('8975','2013-06-09','11:45:00',2.88),('8975','2013-06-09','11:50:00',2.57),('8975','2013-06-09','11:55:00',5.88),('8975','2013-06-09','12:00:00',2.8),('8975','2013-06-09','12:05:00',2.29),('8975','2013-06-09','12:10:00',4.55),('8975','2013-06-09','12:15:00',4.14),('8975','2013-06-09','12:20:00',7.08),('8975','2013-06-09','12:25:00',6.35),('8975','2013-06-09','12:30:00',6.1),('8975','2013-06-09','12:35:00',3.66),('8975','2013-06-09','12:40:00',5.28),('8975','2013-06-09','12:45:00',4.85),('8975','2013-06-09','12:50:00',6.34),('8975','2013-06-09','12:55:00',3.64),('8975','2013-06-09','13:00:00',5.28),('8975','2013-06-09','13:05:00',3.96),('8975','2013-06-09','13:10:00',3.14),('8975','2013-06-09','13:15:00',8.04),('8975','2013-06-09','13:20:00',5.51),('8975','2013-06-09','13:25:00',5.33),('8975','2013-06-09','13:30:00',6.7),('8975','2013-06-09','13:35:00',7.74),('8975','2013-06-09','13:40:00',5.42),('8975','2013-06-09','13:45:00',7.36),('8975','2013-06-09','13:50:00',5.36),('8975','2013-06-09','13:55:00',6.3),('8975','2013-06-09','14:00:00',6.32),('8975','2013-06-09','14:05:00',6.55),('8975','2013-06-09','14:10:00',5.36),('8975','2013-06-09','14:15:00',7.01),('8975','2013-06-09','14:20:00',6.69),('8975','2013-06-09','14:25:00',6.31),('8975','2013-06-09','14:30:00',5.83),('8975','2013-06-09','14:35:00',6.22),('8975','2013-06-09','14:40:00',5.27),('8975','2013-06-09','14:45:00',6.42),('8975','2013-06-09','14:50:00',6.1),('8975','2013-06-09','14:55:00',6),('8975','2013-06-09','15:00:00',5.87),('8975','2013-06-09','15:05:00',5.76),('8975','2013-06-09','15:10:00',5.64),('8975','2013-06-09','15:15:00',5.63),('8975','2013-06-09','15:20:00',5.54),('8975','2013-06-09','15:25:00',5.47),('8975','2013-06-09','15:30:00',5.36),('8975','2013-06-09','15:35:00',5.29),('8975','2013-06-09','15:40:00',5.21),('8975','2013-06-09','15:45:00',5.07),('8975','2013-06-09','15:50:00',4.95),('8975','2013-06-09','15:55:00',4.87),('8975','2013-06-09','16:00:00',4.76),('8975','2013-06-09','16:05:00',4.62),('8975','2013-06-09','16:10:00',4.53),('8975','2013-06-09','16:15:00',4.44),('8975','2013-06-09','16:20:00',4.31),('8975','2013-06-09','16:25:00',4.21),('8975','2013-06-09','16:30:00',4.08),('8975','2013-06-09','16:35:00',3.98),('8975','2013-06-09','16:40:00',3.82),('8975','2013-06-09','16:45:00',3.69),('8975','2013-06-09','16:50:00',3.55),('8975','2013-06-09','16:55:00',3.43),('8975','2013-06-09','17:00:00',3.34),('8975','2013-06-09','17:05:00',3.24),('8975','2013-06-09','17:10:00',3.12),('8975','2013-06-09','17:15:00',2.99),('8975','2013-06-09','17:20:00',2.87),('8975','2013-06-09','17:25:00',2.73),('8975','2013-06-09','17:30:00',2.61),('8975','2013-06-09','17:35:00',2.48),('8975','2013-06-09','17:40:00',2.36),('8975','2013-06-09','17:45:00',2.26),('8975','2013-06-09','17:50:00',2.15),('8975','2013-06-09','17:55:00',2.06),('8975','2013-06-09','18:00:00',1.94),('8975','2013-06-09','18:05:00',1.84),('8975','2013-06-09','18:10:00',1.76),('8975','2013-06-09','18:15:00',1.68),('8975','2013-06-09','18:20:00',1.6),('8975','2013-06-09','18:25:00',1.53),('8975','2013-06-09','18:30:00',1.47),('8975','2013-06-09','18:35:00',1.41),('8975','2013-06-09','18:40:00',1.36),('8975','2013-06-09','18:45:00',1.31),('8975','2013-06-09','18:50:00',1.26),('8975','2013-06-09','18:55:00',1.21),('8975','2013-06-09','19:00:00',1.15),('8975','2013-06-09','19:05:00',1.09),('8975','2013-06-09','19:10:00',1.04),('8975','2013-06-08','07:25:00',1.57),('8975','2013-06-08','07:30:00',2.8),('8975','2013-06-08','07:35:00',3.51),('8975','2013-06-08','07:40:00',2.37),('8975','2013-06-08','07:45:00',2.03),('8975','2013-06-08','07:50:00',2.85),('8975','2013-06-08','07:55:00',3.53),('8975','2013-06-08','08:00:00',3.71),('8975','2013-06-08','08:05:00',3.69),('8975','2013-06-08','08:10:00',2.98),('8975','2013-06-08','08:15:00',3.67),('8975','2013-06-08','08:20:00',4.11),('8975','2013-06-08','08:25:00',4.19),('8975','2013-06-08','08:30:00',4.28),('8975','2013-06-08','08:35:00',4.41),('8975','2013-06-08','08:40:00',4.57),('8975','2013-06-08','08:45:00',4.6),('8975','2013-06-08','08:50:00',4.65),('8975','2013-06-08','08:55:00',4.79),('8975','2013-06-08','09:00:00',4.83),('8975','2013-06-08','09:05:00',4.95),('8975','2013-06-08','09:10:00',5.01),('8975','2013-06-08','09:15:00',5.04),('8975','2013-06-08','09:20:00',5.17),('8975','2013-06-08','09:25:00',5.25),('8975','2013-06-08','09:30:00',5.34),('8975','2013-06-08','09:35:00',5.34),('8975','2013-06-08','09:40:00',5.49),('8975','2013-06-08','09:45:00',5.55),('8975','2013-06-08','09:50:00',5.64),('8975','2013-06-08','09:55:00',5.72),('8975','2013-06-08','10:00:00',5.73),('8975','2013-06-08','10:05:00',5.76),('8975','2013-06-08','10:10:00',5.94),('8975','2013-06-08','10:15:00',6.01),('8975','2013-06-08','10:20:00',6.03),('8975','2013-06-08','10:25:00',6.01),('8975','2013-06-08','10:30:00',6.03),('8975','2013-06-08','10:35:00',6.1),('8975','2013-06-08','10:40:00',6.1),('8975','2013-06-08','10:45:00',6.13),('8975','2013-06-08','10:50:00',6.19),('8975','2013-06-08','10:55:00',5.77),('8975','2013-06-08','11:00:00',5.76),('8975','2013-06-08','11:05:00',6.07),('8975','2013-06-08','11:10:00',5.66),('8975','2013-06-08','11:15:00',5.52),('8975','2013-06-08','11:20:00',6.46),('8975','2013-06-08','11:25:00',6.35),('8975','2013-06-08','11:30:00',6.09),('8975','2013-06-08','11:35:00',6.27),('8975','2013-06-08','11:40:00',6.14),('8975','2013-06-08','11:45:00',6.2),('8975','2013-06-08','11:50:00',6.62),('8975','2013-06-08','11:55:00',6.6),('8975','2013-06-08','12:00:00',6.66),('8975','2013-06-08','12:05:00',6.77),('8975','2013-06-08','12:10:00',6.42),('8975','2013-06-08','12:15:00',6.76),('8975','2013-06-08','12:20:00',6.66),('8975','2013-06-08','12:25:00',6.65),('8975','2013-06-08','12:30:00',6.6),('8975','2013-06-08','12:35:00',6.58),('8975','2013-06-08','12:40:00',6.65),('8975','2013-06-08','12:45:00',6.11),('8975','2013-06-08','12:50:00',6.64),('8975','2013-06-08','12:55:00',5.54),('8975','2013-06-08','13:00:00',4.86),('8975','2013-06-08','13:05:00',3.4),('8975','2013-06-08','13:10:00',3.91),('8975','2013-06-08','13:15:00',6.2),('8975','2013-06-08','13:20:00',3.75),('8975','2013-06-08','13:25:00',6.85),('8975','2013-06-08','13:30:00',6.6),('8975','2013-06-08','13:35:00',6.68),('8975','2013-06-08','13:40:00',6.76),('8975','2013-06-08','13:45:00',6.76),('8975','2013-06-08','13:50:00',7.04),('8975','2013-06-08','13:55:00',5.21),('8975','2013-06-08','14:00:00',4.89),('8975','2013-06-08','14:05:00',6.66),('8975','2013-06-08','14:10:00',6.42),('8975','2013-06-08','14:15:00',4.51),('8975','2013-06-08','14:20:00',2.78),('8975','2013-06-08','14:25:00',1.84),('8975','2013-06-08','14:30:00',4.57),('8975','2013-06-08','14:35:00',5.57),('8975','2013-06-08','14:40:00',6.44),('8975','2013-06-08','14:45:00',6.52),('8975','2013-06-08','14:50:00',6.1),('8975','2013-06-08','14:55:00',5.83),('8975','2013-06-08','15:00:00',5.64),('8975','2013-06-08','15:05:00',5.71),('8975','2013-06-08','15:10:00',5.48),('8975','2013-06-08','15:15:00',5.4),('8975','2013-06-08','15:20:00',5.26),('8975','2013-06-08','15:25:00',5.25),('8975','2013-06-08','15:30:00',4.78),('8975','2013-06-08','15:35:00',4.51),('8975','2013-06-08','15:40:00',3.85),('8975','2013-06-08','15:45:00',4.26),('8975','2013-06-08','15:50:00',4.89),('8975','2013-06-08','15:55:00',4.5),('8975','2013-06-08','16:00:00',2.49),('8975','2013-06-08','16:05:00',4.53),('8975','2013-06-08','16:10:00',3.42),('8975','2013-06-08','16:15:00',2.46),('8975','2013-06-08','16:20:00',2.4),('8975','2013-06-08','16:25:00',3.09),('8975','2013-06-08','16:30:00',1.86),('8975','2013-06-08','16:35:00',1.52),('8975','2013-06-08','16:40:00',1.46),('8975','2013-06-08','16:45:00',1.46),('8975','2013-06-08','16:50:00',1.38),('8975','2013-06-08','16:55:00',1.3),('8975','2013-06-08','17:00:00',1.36),('8975','2013-06-08','17:05:00',1.58),('8975','2013-06-08','17:10:00',1.46),('8975','2013-06-08','17:15:00',1.28),('8975','2013-06-08','17:20:00',1.4),('8975','2013-06-08','17:25:00',1.04),('8975','2013-06-08','17:35:00',1.06),('8975','2013-06-08','17:40:00',1.19),('8975','2013-06-08','17:45:00',1.07),('8975','2013-06-08','18:00:00',1.46),('8975','2013-06-08','18:05:00',1.28),('8975','2013-06-08','18:10:00',1.46),('8975','2013-06-08','18:15:00',1.34),('8975','2013-06-08','18:20:00',1.19),('8975','2013-06-08','18:30:00',1.26),('8975','2013-06-07','06:15:00',1.02),('8975','2013-06-07','06:20:00',1.21),('8975','2013-06-07','06:25:00',1.39),('8975','2013-06-07','06:30:00',1.56),('8975','2013-06-07','06:35:00',1.71),('8975','2013-06-07','06:40:00',1.83),('8975','2013-06-07','06:45:00',1.94),('8975','2013-06-07','06:50:00',2.05),('8975','2013-06-07','06:55:00',2.2),('8975','2013-06-07','07:00:00',2.32),('8975','2013-06-07','07:05:00',2.42),('8975','2013-06-07','07:10:00',2.53),('8975','2013-06-07','07:15:00',2.67),('8975','2013-06-07','07:20:00',2.76),('8975','2013-06-07','07:25:00',2.89),('8975','2013-06-07','07:30:00',3),('8975','2013-06-07','07:35:00',3.13),('8975','2013-06-07','07:40:00',3.23),('8975','2013-06-07','07:45:00',3.31),('8975','2013-06-07','07:50:00',3.4),('8975','2013-06-07','07:55:00',3.46),('8975','2013-06-07','08:00:00',3.58),('8975','2013-06-07','08:05:00',3.7),('8975','2013-06-07','08:10:00',3.83),('8975','2013-06-07','08:15:00',3.94),('8975','2013-06-07','08:20:00',4.03),('8975','2013-06-07','08:25:00',4.16),('8975','2013-06-07','08:30:00',4.25),('8975','2013-06-07','08:35:00',4.35),('8975','2013-06-07','08:40:00',4.44),('8975','2013-06-07','08:45:00',4.5),('8975','2013-06-07','08:50:00',4.65),('8975','2013-06-07','08:55:00',4.69),('8975','2013-06-07','09:00:00',4.81),('8975','2013-06-07','09:05:00',4.86),('8975','2013-06-07','09:10:00',4.98),('8975','2013-06-07','09:15:00',5.14),('8975','2013-06-07','09:20:00',5.18),('8975','2013-06-07','09:25:00',5.25),('8975','2013-06-07','09:30:00',5.33),('8975','2013-06-07','09:35:00',5.42),('8975','2013-06-07','09:40:00',5.5),('8975','2013-06-07','09:45:00',5.61),('8975','2013-06-07','09:50:00',5.72),('8975','2013-06-07','09:55:00',5.75),('8975','2013-06-07','10:00:00',5.86),('8975','2013-06-07','10:05:00',6.06),('8975','2013-06-07','10:10:00',6.07),('8975','2013-06-07','10:15:00',6.21),('8975','2013-06-07','10:20:00',6.15),('8975','2013-06-07','10:25:00',6.12),('8975','2013-06-07','10:30:00',6.15),('8975','2013-06-07','10:35:00',6.21),('8975','2013-06-07','10:40:00',6.44),('8975','2013-06-07','10:45:00',6.52),('8975','2013-06-07','10:50:00',6.65),('8975','2013-06-07','10:55:00',4.99),('8975','2013-06-07','11:00:00',3.31),('8975','2013-06-07','11:05:00',2.1),('8975','2013-06-07','11:10:00',6.51),('8975','2013-06-07','11:15:00',7.25),('8975','2013-06-07','11:20:00',4.02),('8975','2013-06-07','11:25:00',5.84),('8975','2013-06-07','11:30:00',6.5),('8975','2013-06-07','11:35:00',7.48),('8975','2013-06-07','11:40:00',5.9),('8975','2013-06-07','11:45:00',3.29),('8975','2013-06-07','11:50:00',4.87),('8975','2013-06-07','11:55:00',7.21),('8975','2013-06-07','12:00:00',7.26),('8975','2013-06-07','12:05:00',7.31),('8975','2013-06-07','12:10:00',7.36),('8975','2013-06-07','12:15:00',2.35),('8975','2013-06-07','12:20:00',5.85),('8975','2013-06-07','12:25:00',2.64),('8975','2013-06-07','12:30:00',1.73),('8975','2013-06-07','12:35:00',2.77),('8975','2013-06-07','12:40:00',6.87),('8975','2013-06-07','12:45:00',7.3),('8975','2013-06-07','12:50:00',7.26),('8975','2013-06-07','12:55:00',6.98),('8975','2013-06-07','13:00:00',6.96),('8975','2013-06-07','13:05:00',7),('8975','2013-06-07','13:10:00',6.73),('8975','2013-06-07','13:15:00',7.26),('8975','2013-06-07','13:20:00',7.32),('8975','2013-06-07','13:25:00',7.18),('8975','2013-06-07','13:30:00',7.1),('8975','2013-06-07','13:35:00',6.98),('8975','2013-06-07','13:40:00',6.66),('8975','2013-06-07','13:45:00',6.91),('8975','2013-06-07','13:50:00',6.76),('8975','2013-06-07','13:55:00',6.61),('8975','2013-06-07','14:00:00',6.52),('8975','2013-06-07','14:05:00',6.54),('8975','2013-06-07','14:10:00',6.45),('8975','2013-06-07','14:15:00',6.36),('8975','2013-06-07','14:20:00',6.32),('8975','2013-06-07','14:25:00',6.32),('8975','2013-06-07','14:30:00',6.22),('8975','2013-06-07','14:35:00',6.14),('8975','2013-06-07','14:40:00',5.95),('8975','2013-06-07','14:45:00',6.18),('8975','2013-06-07','14:50:00',5.99),('8975','2013-06-07','14:55:00',5.92),('8975','2013-06-07','15:00:00',5.78),('8975','2013-06-07','15:05:00',5.48),('8975','2013-06-07','15:10:00',5.37),('8975','2013-06-07','15:15:00',5.15),('8975','2013-06-07','15:20:00',5.39),('8975','2013-06-07','15:25:00',5.13),('8975','2013-06-07','15:30:00',4.21),('8975','2013-06-07','15:35:00',4.22),('8975','2013-06-07','15:40:00',4.24),('8975','2013-06-07','15:45:00',4.71),('8975','2013-06-07','15:50:00',5.27),('8975','2013-06-07','15:55:00',4.69),('8975','2013-06-07','16:00:00',4.78),('8975','2013-06-07','16:05:00',4.64),('8975','2013-06-07','16:10:00',4.63),('8975','2013-06-07','16:15:00',4.5),('8975','2013-06-07','16:20:00',4.39),('8975','2013-06-07','16:25:00',4.18),('8975','2013-06-07','16:30:00',3.98),('8975','2013-06-07','16:35:00',3.81),('8975','2013-06-07','16:40:00',3.73),('8975','2013-06-07','16:45:00',3.61),('8975','2013-06-07','16:50:00',2.96),('8975','2013-06-07','16:55:00',2.96),('8975','2013-06-07','17:00:00',3.24),('8975','2013-06-07','17:05:00',3),('8975','2013-06-07','17:10:00',2.9),('8975','2013-06-07','17:15:00',3.25),('8975','2013-06-07','17:20:00',3.01),('8975','2013-06-07','17:25:00',2.81),('8975','2013-06-07','17:30:00',2.36),('8975','2013-06-07','17:35:00',2.27),('8975','2013-06-07','17:40:00',2.25),('8975','2013-06-07','17:45:00',2.36),('8975','2013-06-07','17:50:00',2.15),('8975','2013-06-07','17:55:00',2.1),('8975','2013-06-07','18:00:00',1.97),('8975','2013-06-07','18:05:00',1.59),('8975','2013-06-07','18:10:00',1.3),('8975','2013-06-07','18:15:00',1.42),('8975','2013-06-07','18:20:00',1.48),('8975','2013-06-07','18:25:00',1.41),('8975','2013-06-07','18:30:00',1.16),('8975','2013-06-06','06:15:00',1.19),('8975','2013-06-06','06:20:00',1.35),('8975','2013-06-06','06:25:00',1.51),('8975','2013-06-06','06:30:00',1.66),('8975','2013-06-06','06:35:00',1.83),('8975','2013-06-06','06:40:00',1.99),('8975','2013-06-06','06:45:00',2.13),('8975','2013-06-06','06:50:00',2.27),('8975','2013-06-06','06:55:00',2.41),('8975','2013-06-06','07:00:00',2.53),('8975','2013-06-06','07:05:00',2.67),('8975','2013-06-06','07:10:00',2.8),('8975','2013-06-06','07:15:00',2.95),('8975','2013-06-06','07:20:00',3.1),('8975','2013-06-06','07:25:00',3.21),('8975','2013-06-06','07:30:00',3.31),('8975','2013-06-06','07:35:00',3.43),('8975','2013-06-06','07:40:00',3.55),('8975','2013-06-06','07:45:00',3.66),('8975','2013-06-06','07:50:00',3.75),('8975','2013-06-06','07:55:00',3.86),('8975','2013-06-06','08:00:00',3.96),('8975','2013-06-06','08:05:00',4.05),('8975','2013-06-06','08:10:00',4.17),('8975','2013-06-06','08:15:00',4.27),('8975','2013-06-06','08:20:00',4.39),('8975','2013-06-06','08:25:00',4.51),('8975','2013-06-06','08:30:00',4.63),('8975','2013-06-06','08:35:00',4.76),('8975','2013-06-06','08:40:00',4.85),('8975','2013-06-06','08:45:00',4.94),('8975','2013-06-06','08:50:00',4.63),('8975','2013-06-06','08:55:00',4.85),('8975','2013-06-06','09:00:00',4.9),('8975','2013-06-06','09:05:00',4.57),('8975','2013-06-06','09:10:00',5.35),('8975','2013-06-06','09:15:00',5.19),('8975','2013-06-06','09:20:00',5.17),('8975','2013-06-06','09:25:00',5.34),('8975','2013-06-06','09:30:00',5.76),('8975','2013-06-06','09:35:00',5.65),('8975','2013-06-06','09:40:00',5.53),('8975','2013-06-06','09:45:00',6.01),('8975','2013-06-06','09:50:00',6.1),('8975','2013-06-06','09:55:00',6.14),('8975','2013-06-06','10:00:00',6.21),('8975','2013-06-06','10:05:00',6.29),('8975','2013-06-06','10:10:00',6.35),('8975','2013-06-06','10:15:00',6.43),('8975','2013-06-06','10:20:00',6.49),('8975','2013-06-06','10:25:00',6.54),('8975','2013-06-06','10:30:00',6.6),('8975','2013-06-06','10:35:00',6.65),('8975','2013-06-06','10:40:00',6.68),('8975','2013-06-06','10:45:00',6.74),('8975','2013-06-06','10:50:00',6.81),('8975','2013-06-06','10:55:00',6.84),('8975','2013-06-06','11:00:00',6.87),('8975','2013-06-06','11:05:00',6.88),('8975','2013-06-06','11:10:00',6.91),('8975','2013-06-06','11:15:00',6.98),('8975','2013-06-06','11:20:00',7.01),('8975','2013-06-06','11:25:00',7.01),('8975','2013-06-06','11:30:00',7.01),('8975','2013-06-06','11:35:00',7.02),('8975','2013-06-06','11:40:00',7.06),('8975','2013-06-06','11:45:00',7.1),('8975','2013-06-06','11:50:00',7.1),('8975','2013-06-06','11:55:00',7.05),('8975','2013-06-06','12:00:00',7.04),('8975','2013-06-06','12:05:00',7.07),('8975','2013-06-06','12:10:00',7.07),('8975','2013-06-06','12:15:00',7.09),('8975','2013-06-06','12:20:00',7.11),('8975','2013-06-06','12:25:00',7.05),('8975','2013-06-06','12:30:00',7.02),('8975','2013-06-06','12:35:00',7.05),('8975','2013-06-06','12:40:00',7.05),('8975','2013-06-06','12:45:00',7.03),('8975','2013-06-06','12:50:00',6.97),('8975','2013-06-06','12:55:00',6.95),('8975','2013-06-06','13:00:00',6.92),('8975','2013-06-06','13:05:00',6.94),('8975','2013-06-06','13:10:00',6.92),('8975','2013-06-06','13:15:00',6.87),('8975','2013-06-06','13:20:00',6.84),('8975','2013-06-06','13:25:00',6.84),('8975','2013-06-06','13:30:00',6.81),('8975','2013-06-06','13:35:00',6.72),('8975','2013-06-06','13:40:00',6.72),('8975','2013-06-06','13:45:00',6.66),('8975','2013-06-06','13:50:00',6.63),('8975','2013-06-06','13:55:00',6.53),('8975','2013-06-06','14:00:00',6.47),('8975','2013-06-06','14:05:00',6.37),('8975','2013-06-06','14:10:00',6.26),('8975','2013-06-06','14:15:00',6.18),('8975','2013-06-06','14:20:00',6.18),('8975','2013-06-06','14:25:00',6.09),('8975','2013-06-06','14:30:00',5.97),('8975','2013-06-06','14:35:00',5.97),('8975','2013-06-06','14:40:00',5.89),('8975','2013-06-06','14:45:00',5.75),('8975','2013-06-06','14:50:00',5.68),('8975','2013-06-06','14:55:00',5.65),('8975','2013-06-06','15:00:00',5.63),('8975','2013-06-06','15:05:00',5.58),('8975','2013-06-06','15:10:00',5.52),('8975','2013-06-06','15:15:00',5.46),('8975','2013-06-06','15:20:00',5.42),('8975','2013-06-06','15:25:00',5.34),('8975','2013-06-06','15:30:00',5.21),('8975','2013-06-06','15:35:00',5.15),('8975','2013-06-06','15:40:00',5.02),('8975','2013-06-06','15:45:00',4.89),('8975','2013-06-06','15:50:00',4.81),('8975','2013-06-06','15:55:00',4.72),('8975','2013-06-06','16:00:00',4.62),('8975','2013-06-06','16:05:00',4.52),('8975','2013-06-06','16:10:00',4.44),('8975','2013-06-06','16:15:00',4.35),('8975','2013-06-06','16:20:00',4.24),('8975','2013-06-06','16:25:00',4.13),('8975','2013-06-06','16:30:00',4),('8975','2013-06-06','16:35:00',3.91),('8975','2013-06-06','16:40:00',3.81),('8975','2013-06-06','16:45:00',3.69),('8975','2013-06-06','16:50:00',3.56),('8975','2013-06-06','16:55:00',3.44),('8975','2013-06-06','17:00:00',3.32),('8975','2013-06-06','17:05:00',3.22),('8975','2013-06-06','17:10:00',3.11),('8975','2013-06-06','17:15:00',3),('8975','2013-06-06','17:20:00',2.87),('8975','2013-06-06','17:25:00',2.72),('8975','2013-06-06','17:30:00',2.62),('8975','2013-06-06','17:35:00',2.53),('8975','2013-06-06','17:40:00',2.45),('8975','2013-06-06','17:45:00',2.38),('8975','2013-06-06','17:50:00',2.3),('8975','2013-06-06','17:55:00',2.2),('8975','2013-06-06','18:00:00',2.05),('8975','2013-06-06','18:05:00',1.88),('8975','2013-06-06','18:10:00',1.81),('8975','2013-06-06','18:15:00',1.73),('8975','2013-06-06','18:20:00',1.6),('8975','2013-06-06','18:25:00',1.49),('8975','2013-06-06','18:30:00',1.38),('8975','2013-06-06','18:35:00',1.34),('8975','2013-06-06','18:40:00',1.3),('8975','2013-06-06','18:45:00',1.22),('8975','2013-06-06','18:50:00',1.17),('8975','2013-06-06','18:55:00',1.13),('8975','2013-06-06','19:00:00',1.09),('8975','2013-06-06','19:05:00',1.04),('8975','2013-06-05','06:55:00',2.24),('8975','2013-06-05','07:00:00',2.58),('8975','2013-06-05','07:05:00',2.87),('8975','2013-06-05','07:10:00',2.98),('8975','2013-06-05','07:15:00',2.7),('8975','2013-06-05','07:20:00',2.3),('8975','2013-06-05','07:25:00',1.42),('8975','2013-06-05','07:30:00',1.39),('8975','2013-06-05','07:35:00',1.82),('8975','2013-06-05','07:40:00',2.18),('8975','2013-06-05','07:45:00',2.13),('8975','2013-06-05','07:50:00',2.63),('8975','2013-06-05','07:55:00',3.61),('8975','2013-06-05','08:00:00',4.09),('8975','2013-06-05','08:05:00',2.73),('8975','2013-06-05','08:10:00',4.16),('8975','2013-06-05','08:15:00',3.61),('8975','2013-06-05','08:20:00',4),('8975','2013-06-05','08:25:00',4.39),('8975','2013-06-05','08:30:00',4.41),('8975','2013-06-05','08:35:00',4.37),('8975','2013-06-05','08:40:00',4.52),('8975','2013-06-05','08:45:00',4.75),('8975','2013-06-05','08:50:00',4.77),('8975','2013-06-05','08:55:00',4.81),('8975','2013-06-05','09:00:00',4.94),('8975','2013-06-05','09:05:00',5.03),('8975','2013-06-05','09:10:00',5.21),('8975','2013-06-05','09:15:00',5.28),('8975','2013-06-05','09:20:00',5.34),('8975','2013-06-05','09:25:00',5.47),('8975','2013-06-05','09:30:00',5.57),('8975','2013-06-05','09:35:00',5.71),('8975','2013-06-05','09:40:00',5.69),('8975','2013-06-05','09:45:00',5.8),('8975','2013-06-05','09:50:00',5.9),('8975','2013-06-05','09:55:00',6),('8975','2013-06-05','10:00:00',6.03),('8975','2013-06-05','10:05:00',6),('8975','2013-06-05','10:10:00',6.01),('8975','2013-06-05','10:15:00',6.11),('8975','2013-06-05','10:20:00',6.21),('8975','2013-06-05','10:25:00',6.3),('8975','2013-06-05','10:30:00',6.3),('8975','2013-06-05','10:35:00',6.3),('8975','2013-06-05','10:40:00',6.31),('8975','2013-06-05','10:45:00',6.46),('8975','2013-06-05','10:50:00',6.5),('8975','2013-06-05','10:55:00',6.56),('8975','2013-06-05','11:00:00',6.64),('8975','2013-06-05','11:05:00',6.64),('8975','2013-06-05','11:10:00',6.67),('8975','2013-06-05','11:15:00',6.8),('8975','2013-06-05','11:20:00',6.75),('8975','2013-06-05','11:25:00',6.71),('8975','2013-06-05','11:30:00',6.82),('8975','2013-06-05','11:35:00',7),('8975','2013-06-05','11:40:00',6.83),('8975','2013-06-05','11:45:00',6.81),('8975','2013-06-05','11:50:00',6.8),('8975','2013-06-05','11:55:00',6.85),('8975','2013-06-05','12:00:00',6.98),('8975','2013-06-05','12:05:00',6.92),('8975','2013-06-05','12:10:00',6.73),('8975','2013-06-05','12:15:00',6.75),('8975','2013-06-05','12:20:00',6.76),('8975','2013-06-05','12:25:00',6.8),('8975','2013-06-05','12:30:00',6.9),('8975','2013-06-05','12:35:00',6.82),('8975','2013-06-05','12:40:00',6.78),('8975','2013-06-05','12:45:00',6.7),('8975','2013-06-05','12:50:00',6.8),('8975','2013-06-05','12:55:00',6.94),('8975','2013-06-05','13:00:00',6.69),('8975','2013-06-05','13:05:00',6.72),('8975','2013-06-05','13:10:00',7.16),('8975','2013-06-05','13:15:00',6.77),('8975','2013-06-05','13:20:00',5.72),('8975','2013-06-05','13:25:00',6.89),('8975','2013-06-05','13:30:00',6.84),('8975','2013-06-05','13:35:00',6.16),('8975','2013-06-05','13:40:00',6.66),('8975','2013-06-05','13:45:00',6.52),('8975','2013-06-05','13:50:00',7),('8975','2013-06-05','13:55:00',6.46),('8975','2013-06-05','14:00:00',3.76),('8975','2013-06-05','14:05:00',4.9),('8975','2013-06-05','14:10:00',5.49),('8975','2013-06-05','14:15:00',6.57),('8975','2013-06-05','14:20:00',6.66),('8975','2013-06-05','14:25:00',6.49),('8975','2013-06-05','14:30:00',6.28),('8975','2013-06-05','14:35:00',6.2),('8975','2013-06-05','14:40:00',6.13),('8975','2013-06-05','14:45:00',6.03),('8975','2013-06-05','14:50:00',6.05),('8975','2013-06-05','14:55:00',5.3),('8975','2013-06-05','15:00:00',5.59),('8975','2013-06-05','15:05:00',6.01),('8975','2013-06-05','15:10:00',5.88),('8975','2013-06-05','15:15:00',5.72),('8975','2013-06-05','15:20:00',4.84),('8975','2013-06-05','15:25:00',5.47),('8975','2013-06-05','15:30:00',4.7),('8975','2013-06-05','15:35:00',4.45),('8975','2013-06-05','15:40:00',5.04),('8975','2013-06-05','15:45:00',2.63),('8975','2013-06-05','15:50:00',5.45),('8975','2013-06-05','15:55:00',5.46),('8975','2013-06-05','16:00:00',5.32),('8975','2013-06-05','16:05:00',5.03),('8975','2013-06-05','16:10:00',4.56),('8975','2013-06-05','16:15:00',4.29),('8975','2013-06-05','16:20:00',4.22),('8975','2013-06-05','16:25:00',4.09),('8975','2013-06-05','16:30:00',3.99),('8975','2013-06-05','16:35:00',3.93),('8975','2013-06-05','16:40:00',3.75),('8975','2013-06-05','16:45:00',3.61),('8975','2013-06-05','16:50:00',3.54),('8975','2013-06-05','16:55:00',3.36),('8975','2013-06-05','17:00:00',3.17),('8975','2013-06-05','17:05:00',3.04),('8975','2013-06-05','17:10:00',2.93),('8975','2013-06-05','17:15:00',2.84),('8975','2013-06-05','17:20:00',2.74),('8975','2013-06-05','17:25:00',2.55),('8975','2013-06-05','17:30:00',2.49),('8975','2013-06-05','17:35:00',2.38),('8975','2013-06-05','17:40:00',2.24),('8975','2013-06-05','17:45:00',2.12),('8975','2013-06-05','17:50:00',2.03),('8975','2013-06-05','17:55:00',1.95),('8975','2013-06-05','18:00:00',1.85),('8975','2013-06-05','18:05:00',1.77),('8975','2013-06-05','18:10:00',1.68),('8975','2013-06-05','18:15:00',1.58),('8975','2013-06-05','18:20:00',1.52),('8975','2013-06-05','18:25:00',1.45),('8975','2013-06-05','18:30:00',1.39),('8975','2013-06-05','18:35:00',1.32),('8975','2013-06-05','18:40:00',1.28),('8975','2013-06-05','18:45:00',1.22),('8975','2013-06-05','18:50:00',1.16),('8975','2013-06-05','18:55:00',1.12),('8975','2013-06-05','19:00:00',1.05),('8975','2013-06-04','07:15:00',1.32),('8975','2013-06-04','07:20:00',2.42),('8975','2013-06-04','07:25:00',2.22),('8975','2013-06-04','07:30:00',2.98),('8975','2013-06-04','07:35:00',2.78),('8975','2013-06-04','07:40:00',1.81),('8975','2013-06-04','07:45:00',2.66),('8975','2013-06-04','07:50:00',2.57),('8975','2013-06-04','07:55:00',3.73),('8975','2013-06-04','08:00:00',3.76),('8975','2013-06-04','08:05:00',3.5),('8975','2013-06-04','08:10:00',4.2),('8975','2013-06-04','08:15:00',4.27),('8975','2013-06-04','08:20:00',4.3),('8975','2013-06-04','08:25:00',4.41),('8975','2013-06-04','08:30:00',4.52),('8975','2013-06-04','08:35:00',4.59),('8975','2013-06-04','08:40:00',4.69),('8975','2013-06-04','08:45:00',4.83),('8975','2013-06-04','08:50:00',4.95),('8975','2013-06-04','08:55:00',5.04),('8975','2013-06-04','09:00:00',5.15),('8975','2013-06-04','09:05:00',5.14),('8975','2013-06-04','09:10:00',5.41),('8975','2013-06-04','09:15:00',5.6),('8975','2013-06-04','09:20:00',5.63),('8975','2013-06-04','09:25:00',5.8),('8975','2013-06-04','09:30:00',6.05),('8975','2013-06-04','09:35:00',5.9),('8975','2013-06-04','09:40:00',6.35),('8975','2013-06-04','09:45:00',5.78),('8975','2013-06-04','09:50:00',5.7),('8975','2013-06-04','09:55:00',6.98),('8975','2013-06-04','10:00:00',5),('8975','2013-06-04','10:05:00',2.7),('8975','2013-06-04','10:10:00',2.63),('8975','2013-06-04','10:15:00',2.3),('8975','2013-06-04','10:20:00',2.48),('8975','2013-06-04','10:25:00',2.4),('8975','2013-06-04','10:30:00',2.55),('8975','2013-06-04','10:35:00',6.51),('8975','2013-06-04','10:40:00',7.2),('8975','2013-06-04','10:45:00',6.51),('8975','2013-06-04','10:50:00',7.01),('8975','2013-06-04','10:55:00',7.03),('8975','2013-06-04','11:00:00',7.2),('8975','2013-06-04','11:05:00',7.54),('8975','2013-06-04','11:10:00',6.16),('8975','2013-06-04','11:15:00',2.68),('8975','2013-06-04','11:20:00',2.11),('8975','2013-06-04','11:25:00',1.8),('8975','2013-06-04','11:30:00',1.82),('8975','2013-06-04','11:35:00',2.77),('8975','2013-06-04','11:40:00',3.01),('8975','2013-06-04','11:45:00',2.61),('8975','2013-06-04','11:50:00',1.58),('8975','2013-06-04','11:55:00',1.64),('8975','2013-06-04','12:00:00',1.85),('8975','2013-06-04','12:05:00',2.55),('8975','2013-06-04','12:10:00',4.31),('8975','2013-06-04','12:15:00',2.83),('8975','2013-06-04','12:20:00',3.9),('8975','2013-06-04','12:25:00',2.84),('8975','2013-06-04','12:30:00',2.23),('8975','2013-06-04','12:35:00',4.53),('8975','2013-06-04','12:40:00',3.31),('8975','2013-06-04','12:45:00',2.68),('8975','2013-06-04','12:50:00',4.58),('8975','2013-06-04','12:55:00',6.3),('8975','2013-06-04','13:00:00',5.5),('8975','2013-06-04','13:05:00',8.38),('8975','2013-06-04','13:10:00',8.05),('8975','2013-06-04','13:15:00',7.17),('8975','2013-06-04','13:20:00',3.94),('8975','2013-06-04','13:25:00',6.11),('8975','2013-06-04','13:30:00',7.72),('8975','2013-06-04','13:35:00',7.76),('8975','2013-06-04','13:40:00',6.78),('8975','2013-06-04','13:45:00',6.03),('8975','2013-06-04','13:50:00',6.65),('8975','2013-06-04','13:55:00',6.93),('8975','2013-06-04','14:00:00',6.72),('8975','2013-06-04','14:05:00',6.69),('8975','2013-06-04','14:10:00',6.64),('8975','2013-06-04','14:15:00',6.54),('8975','2013-06-04','14:20:00',6.48),('8975','2013-06-04','14:25:00',6.42),('8975','2013-06-04','14:30:00',6.33),('8975','2013-06-04','14:35:00',6.29),('8975','2013-06-04','14:40:00',6.27),('8975','2013-06-04','14:45:00',6.19),('8975','2013-06-04','14:50:00',6.08),('8975','2013-06-04','14:55:00',5.97),('8975','2013-06-04','15:00:00',5.88),('8975','2013-06-04','15:05:00',5.87),('8975','2013-06-04','15:10:00',5.65),('8975','2013-06-04','15:15:00',5.67),('8975','2013-06-04','15:20:00',5.59),('8975','2013-06-04','15:25:00',5.37),('8975','2013-06-04','15:30:00',4.82),('8975','2013-06-04','15:35:00',5.37),('8975','2013-06-04','15:40:00',5.46),('8975','2013-06-04','15:45:00',5.14),('8975','2013-06-04','15:50:00',5.07),('8975','2013-06-04','15:55:00',4.93),('8975','2013-06-04','16:00:00',4.83),('8975','2013-06-04','16:05:00',4.77),('8975','2013-06-04','16:10:00',3.73),('8975','2013-06-04','16:15:00',3.79),('8975','2013-06-04','16:20:00',4.3),('8975','2013-06-04','16:25:00',4.29),('8975','2013-06-04','16:30:00',4.15),('8975','2013-06-04','16:35:00',3.97),('8975','2013-06-04','16:40:00',3.88),('8975','2013-06-04','16:45:00',3.75),('8975','2013-06-04','16:50:00',3.64),('8975','2013-06-04','16:55:00',3.51),('8975','2013-06-04','17:00:00',3.09),('8975','2013-06-04','17:05:00',2.46),('8975','2013-06-04','17:10:00',3.32),('8975','2013-06-04','17:15:00',3.01),('8975','2013-06-04','17:20:00',2.65),('8975','2013-06-04','17:25:00',2.87),('8975','2013-06-04','17:30:00',2.69),('8975','2013-06-04','17:35:00',2.07),('8975','2013-06-04','17:40:00',2.31),('8975','2013-06-04','17:45:00',2.25),('8975','2013-06-04','17:50:00',2.11),('8975','2013-06-04','17:55:00',2),('8975','2013-06-04','18:00:00',1.91),('8975','2013-06-04','18:05:00',1.82),('8975','2013-06-04','18:10:00',1.81),('8975','2013-06-04','18:15:00',1.54),('8975','2013-06-04','18:20:00',1),('8975','2013-06-04','18:31:00',1.5),('8975','2013-06-04','18:35:00',1.44),('8975','2013-06-04','18:40:00',1.35),('8975','2013-06-04','18:50:00',1.3),('8975','2013-06-04','18:55:00',1.29),('8975','2013-06-03','07:05:00',1.85),('8975','2013-06-03','07:10:00',2.67),('8975','2013-06-03','07:15:00',2.81),('8975','2013-06-03','07:20:00',2.79),('8975','2013-06-03','07:25:00',2.91),('8975','2013-06-03','07:30:00',3.14),('8975','2013-06-03','07:35:00',3.34),('8975','2013-06-03','07:40:00',3.57),('8975','2013-06-03','07:45:00',3.9),('8975','2013-06-03','07:50:00',4.14),('8975','2013-06-03','07:55:00',4.29),('8975','2013-06-03','08:00:00',4.59),('8975','2013-06-03','08:05:00',4.83),('8975','2013-06-03','08:10:00',4.85),('8975','2013-06-03','08:15:00',4.87),('8975','2013-06-03','08:20:00',5.07),('8975','2013-06-03','08:25:00',5.16),('8975','2013-06-03','08:30:00',5.02),('8975','2013-06-03','08:35:00',3.87),('8975','2013-06-03','08:40:00',3.35),('8975','2013-06-03','08:45:00',2.77),('8975','2013-06-03','08:50:00',2.35),('8975','2013-06-03','08:55:00',2.06),('8975','2013-06-03','09:00:00',2.43),('8975','2013-06-03','09:05:00',3.23),('8975','2013-06-03','09:10:00',3.43),('8975','2013-06-03','09:15:00',4.05),('8975','2013-06-03','09:20:00',4.67),('8975','2013-06-03','09:25:00',4.75),('8975','2013-06-03','09:30:00',5.07),('8975','2013-06-03','09:35:00',4.57),('8975','2013-06-03','09:40:00',3.81),('8975','2013-06-03','09:45:00',3.94),('8975','2013-06-03','09:50:00',4.58),('8975','2013-06-03','09:55:00',3.92),('8975','2013-06-03','10:00:00',3.84),('8975','2013-06-03','10:05:00',3.3),('8975','2013-06-03','10:10:00',3.33),('8975','2013-06-03','10:15:00',2.98),('8975','2013-06-03','10:20:00',3.16),('8975','2013-06-03','10:25:00',3.09),('8975','2013-06-03','10:30:00',2.79),('8975','2013-06-03','10:35:00',2.78),('8975','2013-06-03','10:40:00',3.14),('8975','2013-06-03','10:45:00',4.63),('8975','2013-06-03','10:50:00',5.14),('8975','2013-06-03','10:55:00',5.1),('8975','2013-06-03','11:00:00',4.75),('8975','2013-06-03','11:05:00',4.82),('8975','2013-06-03','11:10:00',5.42),('8975','2013-06-03','11:15:00',6.28),('8975','2013-06-03','11:20:00',4.18),('8975','2013-06-03','11:25:00',4.25),('8975','2013-06-03','11:30:00',4.57),('8975','2013-06-03','11:35:00',5.33),('8975','2013-06-03','11:40:00',5.4),('8975','2013-06-03','11:45:00',5.81),('8975','2013-06-03','11:50:00',6.55),('8975','2013-06-03','11:55:00',7.66),('8975','2013-06-03','12:00:00',7.25),('8975','2013-06-03','12:05:00',8.24),('8975','2013-06-03','12:10:00',6.21),('8975','2013-06-03','12:15:00',5.29),('8975','2013-06-03','12:20:00',3.8),('8975','2013-06-03','12:25:00',4.06),('8975','2013-06-03','12:30:00',4.06),('8975','2013-06-03','12:35:00',5.7),('8975','2013-06-03','12:40:00',3.74),('8975','2013-06-03','12:45:00',4.64),('8975','2013-06-03','12:50:00',3.86),('8975','2013-06-03','12:55:00',3.92),('8975','2013-06-03','13:00:00',3.79),('8975','2013-06-03','13:05:00',2.92),('8975','2013-06-03','13:10:00',2.67),('8975','2013-06-03','13:15:00',2.38),('8975','2013-06-03','13:20:00',1.94),('8975','2013-06-03','13:25:00',2.07),('8975','2013-06-03','13:30:00',6.56),('8975','2013-06-03','13:35:00',6.62),('8975','2013-06-03','13:40:00',8.55),('8975','2013-06-03','13:45:00',8.47),('8975','2013-06-03','13:50:00',8.31),('8975','2013-06-03','13:55:00',5.04),('8975','2013-06-03','14:00:00',2.9),('8975','2013-06-03','14:05:00',4.4),('8975','2013-06-03','14:10:00',6.79),('8975','2013-06-03','14:15:00',5.6),('8975','2013-06-03','14:20:00',2.83),('8975','2013-06-03','14:25:00',2.32),('8975','2013-06-03','14:30:00',1.88),('8975','2013-06-03','14:35:00',2.04),('8975','2013-06-03','14:40:00',3.15),('8975','2013-06-03','14:45:00',3.67),('8975','2013-06-03','14:50:00',2.55),('8975','2013-06-03','14:55:00',6.47),('8975','2013-06-03','15:00:00',7.2),('8975','2013-06-03','15:05:00',4.97),('8975','2013-06-03','15:10:00',3.09),('8975','2013-06-03','15:15:00',4.01),('8975','2013-06-03','15:20:00',5.55),('8975','2013-06-03','15:25:00',3.25),('8975','2013-06-03','15:30:00',2.15),('8975','2013-06-03','16:05:00',1.17),('8975','2013-06-03','16:10:00',1.08),('8975','2013-06-03','17:20:00',1.12),('8975','2013-06-03','17:40:00',1.21),('8975','2013-06-03','17:45:00',1.42),('8975','2013-06-03','17:50:00',1.23),('8975','2013-06-03','17:55:00',1.22),('8975','2013-06-03','18:00:00',1.22),('8975','2013-06-03','18:05:00',1.37),('8975','2013-06-03','18:10:00',1.41),('8975','2013-06-03','18:15:00',1.23),('8975','2013-06-03','18:45:00',1.1),('8975','2013-06-02','06:45:00',1.07),('8975','2013-06-02','06:50:00',1.77),('8975','2013-06-02','06:55:00',2.05),('8975','2013-06-02','07:00:00',2.09),('8975','2013-06-02','07:05:00',1.64),('8975','2013-06-02','07:10:00',1.9),('8975','2013-06-02','07:15:00',2.73),('8975','2013-06-02','07:20:00',3.07),('8975','2013-06-02','07:25:00',1.49),('8975','2013-06-02','07:35:00',1.88),('8975','2013-06-02','07:40:00',3.52),('8975','2013-06-02','07:45:00',3.59),('8975','2013-06-02','07:50:00',3.73),('8975','2013-06-02','07:55:00',3.81),('8975','2013-06-02','08:00:00',3.85),('8975','2013-06-02','08:05:00',3.96),('8975','2013-06-02','08:10:00',4.07),('8975','2013-06-02','08:15:00',4.16),('8975','2013-06-02','08:20:00',4.27),('8975','2013-06-02','08:25:00',4.33),('8975','2013-06-02','08:30:00',4.45),('8975','2013-06-02','08:35:00',4.52),('8975','2013-06-02','08:40:00',4.62),('8975','2013-06-02','08:45:00',4.74),('8975','2013-06-02','08:50:00',4.89),('8975','2013-06-02','08:55:00',5.04),('8975','2013-06-02','09:00:00',5.15),('8975','2013-06-02','09:05:00',5.27),('8975','2013-06-02','09:10:00',5.41),('8975','2013-06-02','09:15:00',5.3),('8975','2013-06-02','09:20:00',5.79),('8975','2013-06-02','09:25:00',5.15),('8975','2013-06-02','09:30:00',3.2),('8975','2013-06-02','09:35:00',3.42),('8975','2013-06-02','09:40:00',4.3),('8975','2013-06-02','09:45:00',5.86),('8975','2013-06-02','09:50:00',4.59),('8975','2013-06-02','09:55:00',7),('8975','2013-06-02','10:00:00',5.62),('8975','2013-06-02','10:05:00',3.82),('8975','2013-06-02','10:10:00',2.14),('8975','2013-06-02','10:15:00',1.59),('8975','2013-06-02','10:20:00',1.74),('8975','2013-06-02','10:25:00',2.34),('8975','2013-06-02','10:30:00',6),('8975','2013-06-02','10:35:00',7.18),('8975','2013-06-02','10:40:00',2.8),('8975','2013-06-02','10:45:00',2.68),('8975','2013-06-02','10:50:00',3.05),('8975','2013-06-02','10:55:00',3.15),('8975','2013-06-02','11:00:00',4.89),('8975','2013-06-02','11:05:00',4.99),('8975','2013-06-02','11:10:00',4.46),('8975','2013-06-02','11:15:00',3.22),('8975','2013-06-02','11:20:00',4.7),('8975','2013-06-02','11:25:00',7.18),('8975','2013-06-02','11:30:00',6.04),('8975','2013-06-02','11:35:00',6.44),('8975','2013-06-02','11:40:00',5.67),('8975','2013-06-02','11:45:00',6.11),('8975','2013-06-02','11:50:00',6.82),('8975','2013-06-02','11:55:00',5.74),('8975','2013-06-02','12:00:00',2.4),('8975','2013-06-02','12:05:00',1.86),('8975','2013-06-02','12:10:00',2.04),('8975','2013-06-02','12:15:00',2.38),('8975','2013-06-02','12:20:00',2.46),('8975','2013-06-02','12:25:00',2.82),('8975','2013-06-02','12:30:00',3.94),('8975','2013-06-02','12:35:00',6.34),('8975','2013-06-02','12:40:00',3.08),('8975','2013-06-02','12:45:00',3.53),('8975','2013-06-02','12:50:00',3.42),('8975','2013-06-02','12:55:00',4.81),('8975','2013-06-02','13:00:00',5.73),('8975','2013-06-02','13:05:00',8.48),('8975','2013-06-02','13:10:00',8.3),('8975','2013-06-02','13:15:00',7.74),('8975','2013-06-02','13:20:00',6.31),('8975','2013-06-02','13:25:00',6.39),('8975','2013-06-02','13:30:00',7.31),('8975','2013-06-02','13:35:00',7.31),('8975','2013-06-02','13:40:00',7.37),('8975','2013-06-02','13:45:00',7.09),('8975','2013-06-02','13:50:00',3.64),('8975','2013-06-02','13:55:00',2.95),('8975','2013-06-02','14:00:00',3.52),('8975','2013-06-02','14:05:00',6.92),('8975','2013-06-02','14:10:00',5.46),('8975','2013-06-02','14:15:00',5.01),('8975','2013-06-02','14:20:00',3.79),('8975','2013-06-02','14:25:00',5.5),('8975','2013-06-02','14:30:00',6.39),('8975','2013-06-02','14:35:00',4.13),('8975','2013-06-02','14:40:00',3.26),('8975','2013-06-02','14:45:00',6.16),('8975','2013-06-02','14:50:00',3.17),('8975','2013-06-02','14:55:00',4.32),('8975','2013-06-02','15:00:00',6.47),('8975','2013-06-02','15:05:00',5.47),('8975','2013-06-02','15:10:00',5.4),('8975','2013-06-02','15:15:00',6.09),('8975','2013-06-02','15:20:00',5.81),('8975','2013-06-02','15:25:00',5.63),('8975','2013-06-02','15:30:00',5.51),('8975','2013-06-02','15:35:00',5.44),('8975','2013-06-02','15:40:00',5.29),('8975','2013-06-02','15:45:00',5.17),('8975','2013-06-02','15:50:00',5.07),('8975','2013-06-02','15:55:00',4.98),('8975','2013-06-02','16:00:00',4.87),('8975','2013-06-02','16:05:00',4.76),('8975','2013-06-02','16:10:00',4.71),('8975','2013-06-02','16:15:00',4.63),('8975','2013-06-02','16:20:00',4.47),('8975','2013-06-02','16:25:00',4.39),('8975','2013-06-02','16:30:00',4.44),('8975','2013-06-02','16:35:00',4.3),('8975','2013-06-02','16:40:00',4.38),('8975','2013-06-02','16:45:00',4.16),('8975','2013-06-02','16:50:00',3.45),('8975','2013-06-02','16:55:00',2.8),('8975','2013-06-02','17:00:00',2.95),('8975','2013-06-02','17:05:00',3.73),('8975','2013-06-02','17:10:00',3.25),('8975','2013-06-02','17:15:00',3.47),('8975','2013-06-02','17:20:00',3.51),('8975','2013-06-02','17:25:00',2.39),('8975','2013-06-02','17:30:00',1.44),('8975','2013-06-02','17:35:00',1.12),('8975','2013-06-02','17:40:00',1.06),('8975','2013-06-02','17:45:00',1.14),('8975','2013-06-02','17:50:00',1.31),('8975','2013-06-02','17:55:00',1.28),('8975','2013-06-02','18:00:00',1.05),('8975','2013-06-01','06:20:00',1.24),('8975','2013-06-01','06:25:00',1.46),('8975','2013-06-01','06:30:00',1.67),('8975','2013-06-01','06:35:00',1.88),('8975','2013-06-01','06:40:00',2.03),('8975','2013-06-01','06:45:00',2.09),('8975','2013-06-01','06:50:00',2.58),('8975','2013-06-01','06:55:00',2.95),('8975','2013-06-01','07:00:00',2.88),('8975','2013-06-01','07:05:00',1.36),('8975','2013-06-01','08:25:00',1.16),('8975','2013-06-01','08:30:00',1.46),('8975','2013-06-01','08:35:00',1.71),('8975','2013-06-01','08:40:00',1.65),('8975','2013-06-01','08:45:00',1.67),('8975','2013-06-01','08:50:00',1.94),('8975','2013-06-01','08:55:00',1.64),('8975','2013-06-01','09:00:00',1.53),('8975','2013-06-01','09:05:00',1.68),('8975','2013-06-01','09:10:00',2.01),('8975','2013-06-01','09:15:00',2.24),('8975','2013-06-01','09:20:00',3.95),('8975','2013-06-01','09:25:00',6.54),('8975','2013-06-01','09:30:00',5.73),('8975','2013-06-01','09:35:00',5.69),('8975','2013-06-01','09:40:00',5.86),('8975','2013-06-01','09:45:00',6.12),('8975','2013-06-01','09:50:00',6.18),('8975','2013-06-01','09:55:00',6.25),('8975','2013-06-01','10:00:00',6.3),('8975','2013-06-01','10:05:00',6.51),('8975','2013-06-01','10:10:00',6.76),('8975','2013-06-01','10:15:00',6.25),('8975','2013-06-01','10:20:00',5.83),('8975','2013-06-01','10:25:00',6.68),('8975','2013-06-01','10:30:00',5.91),('8975','2013-06-01','10:35:00',4.49),('8975','2013-06-01','10:40:00',2.44),('8975','2013-06-01','10:45:00',2.14),('8975','2013-06-01','10:50:00',7.16),('8975','2013-06-01','10:55:00',4.37),('8975','2013-06-01','11:00:00',4.91),('8975','2013-06-01','11:05:00',6.27),('8975','2013-06-01','11:10:00',7.89),('8975','2013-06-01','11:15:00',7.24),('8975','2013-06-01','11:20:00',8.04),('8975','2013-06-01','11:25:00',7.18),('8975','2013-06-01','11:30:00',7.1),('8975','2013-06-01','11:35:00',3.21),('8975','2013-06-01','11:40:00',2.56),('8975','2013-06-01','11:45:00',2.84),('8975','2013-06-01','11:50:00',3.22),('8975','2013-06-01','11:55:00',3.57),('8975','2013-06-01','12:00:00',3.23),('8975','2013-06-01','12:05:00',7.64),('8975','2013-06-01','12:10:00',8.33),('8975','2013-06-01','12:15:00',7.71),('8975','2013-06-01','12:20:00',4.75),('8975','2013-06-01','12:25:00',2.52),('8975','2013-06-01','12:30:00',2.6),('8975','2013-06-01','12:35:00',4.22),('8975','2013-06-01','12:40:00',2.37),('8975','2013-06-01','12:45:00',2.28),('8975','2013-06-01','12:50:00',2.48),('8975','2013-06-01','12:55:00',2.25),('8975','2013-06-01','13:00:00',5.25),('8975','2013-06-01','13:05:00',4.44),('8975','2013-06-01','13:10:00',4.3),('8975','2013-06-01','13:15:00',6.79),('8975','2013-06-01','13:20:00',7.46),('8975','2013-06-01','13:25:00',7.31),('8975','2013-06-01','13:30:00',7.07),('8975','2013-06-01','13:35:00',6.91),('8975','2013-06-01','13:40:00',6.89),('8975','2013-06-01','13:45:00',6.83),('8975','2013-06-01','13:50:00',6.79),('8975','2013-06-01','13:55:00',6.73),('8975','2013-06-01','14:00:00',6.66),('8975','2013-06-01','14:05:00',6.62),('8975','2013-06-01','14:10:00',6.71),('8975','2013-06-01','14:15:00',6.5),('8975','2013-06-01','14:20:00',6.38),('8975','2013-06-01','14:25:00',6.38),('8975','2013-06-01','14:30:00',6.31),('8975','2013-06-01','14:35:00',6.24),('8975','2013-06-01','14:40:00',6.11),('8975','2013-06-01','14:45:00',6.09),('8975','2013-06-01','14:50:00',5.94),('8975','2013-06-01','14:55:00',5.9),('8975','2013-06-01','15:00:00',5.89),('8975','2013-06-01','15:05:00',5.81),('8975','2013-06-01','15:10:00',5.7),('8975','2013-06-01','15:15:00',5.63),('8975','2013-06-01','15:20:00',5.49),('8975','2013-06-01','15:25:00',5.52),('8975','2013-06-01','15:30:00',5.44),('8975','2013-06-01','15:35:00',5.3),('8975','2013-06-01','15:40:00',5.2),('8975','2013-06-01','15:45:00',5.1),('8975','2013-06-01','15:50:00',4.97),('8975','2013-06-01','15:55:00',4.97),('8975','2013-06-01','16:00:00',4.67),('8975','2013-06-01','16:05:00',4.72),('8975','2013-06-01','16:10:00',4.82),('8975','2013-06-01','16:15:00',4.6),('8975','2013-06-01','16:20:00',4.02),('8975','2013-06-01','16:25:00',4.12),('8975','2013-06-01','16:30:00',3),('8975','2013-06-01','16:35:00',4.18),('8975','2013-06-01','16:40:00',4.05),('8975','2013-06-01','16:45:00',3.66),('8975','2013-06-01','16:50:00',3.84),('8975','2013-06-01','16:55:00',3),('8975','2013-06-01','17:00:00',3.15),('8975','2013-06-01','17:05:00',3.27),('8975','2013-06-01','17:10:00',2.22),('8975','2013-06-01','17:15:00',3.23),('8975','2013-06-01','17:20:00',2.67),('8975','2013-06-01','17:25:00',2.85),('8975','2013-06-01','17:30:00',2.36),('8975','2013-06-01','17:35:00',2.39),('8975','2013-06-01','17:40:00',2.81),('8975','2013-06-01','17:45:00',2.4),('8975','2013-06-01','17:50:00',1.65),('8975','2013-06-01','17:55:00',2.03),('8975','2013-06-01','18:00:00',1.75),('8975','2013-06-01','18:05:00',1.74),('8975','2013-06-01','18:10:00',1.76),('8975','2013-06-01','18:15:00',1.33),('8975','2013-06-01','18:20:00',1.45),('8975','2013-06-01','18:25:00',1.6),('8975','2013-06-01','18:30:00',1.32),('8975','2013-06-01','18:45:00',1.51),('8975','2013-06-01','18:50:00',1),('8975','2013-06-01','19:00:00',1.34),('8975','2013-06-01','19:05:00',1.23),('8975','2013-06-01','19:10:00',1.05),('8975','2013-05-31','06:15:00',1.06),('8975','2013-05-31','06:20:00',1.32),('8975','2013-05-31','06:25:00',1.53),('8975','2013-05-31','06:30:00',1.72),('8975','2013-05-31','06:35:00',1.92),('8975','2013-05-31','06:40:00',2.08),('8975','2013-05-31','06:45:00',2.23),('8975','2013-05-31','06:50:00',2.37),('8975','2013-05-31','06:55:00',2.51),('8975','2013-05-31','07:00:00',2.62),('8975','2013-05-31','07:05:00',2.76),('8975','2013-05-31','07:10:00',2.93),('8975','2013-05-31','07:15:00',3.05),('8975','2013-05-31','07:20:00',3.17),('8975','2013-05-31','07:25:00',3.3),('8975','2013-05-31','07:30:00',3.42),('8975','2013-05-31','07:35:00',3.55),('8975','2013-05-31','07:40:00',3.48),('8975','2013-05-31','07:45:00',4.11),('8975','2013-05-31','07:50:00',4.25),('8975','2013-05-31','07:55:00',2.97),('8975','2013-05-31','08:00:00',1.13),('8975','2013-05-31','08:05:00',1.71),('8975','2013-05-31','08:10:00',3.05),('8975','2013-05-31','08:15:00',3.21),('8975','2013-05-31','08:20:00',3.7),('8975','2013-05-31','08:25:00',2.06),('8975','2013-05-31','08:30:00',2.89),('8975','2013-05-31','08:35:00',1.45),('8975','2013-05-31','08:40:00',1.33),('8975','2013-05-31','08:55:00',1.04),('8975','2013-05-31','09:00:00',1.11),('8975','2013-05-31','09:40:00',1.07),('8975','2013-05-31','09:45:00',1.38),('8975','2013-05-31','09:50:00',1.36),('8975','2013-05-31','09:55:00',1.19),('8975','2013-05-31','10:00:00',1.18),('8975','2013-05-31','10:05:00',1.23),('8975','2013-05-31','10:10:00',1.12),('8975','2013-05-31','10:15:00',1.14),('8975','2013-05-31','10:20:00',1.18),('8975','2013-05-31','10:30:00',1.68),('8975','2013-05-31','10:35:00',2.15),('8975','2013-05-31','10:40:00',1.29),('8975','2013-05-31','10:50:00',1.85),('8975','2013-05-31','10:55:00',1.61),('8975','2013-05-31','11:45:00',1.57),('8975','2013-05-31','11:50:00',2.83),('8975','2013-05-31','11:55:00',3.79),('8975','2013-05-31','12:00:00',8.63),('8975','2013-05-31','12:05:00',7.94),('8975','2013-05-31','12:10:00',3.56),('8975','2013-05-31','12:15:00',2.35),('8975','2013-05-31','12:20:00',2.22),('8975','2013-05-31','12:25:00',2.2),('8975','2013-05-31','12:30:00',1.88),('8975','2013-05-31','12:35:00',1.88),('8975','2013-05-31','12:40:00',2.59),('8975','2013-05-31','12:45:00',3.01),('8975','2013-05-31','12:50:00',3.15),('8975','2013-05-31','12:55:00',3.68),('8975','2013-05-31','13:00:00',4.23),('8975','2013-05-31','13:05:00',4.25),('8975','2013-05-31','13:10:00',4.27),('8975','2013-05-31','13:15:00',4.32),('8975','2013-05-31','13:20:00',3.65),('8975','2013-05-31','13:25:00',2.71),('8975','2013-05-31','13:30:00',2.29),('8975','2013-05-31','13:35:00',1.91),('8975','2013-05-31','13:40:00',1.94),('8975','2013-05-31','13:45:00',2.35),('8975','2013-05-31','13:50:00',2.5),('8975','2013-05-31','13:55:00',2.83),('8975','2013-05-31','14:00:00',3.73),('8975','2013-05-31','14:05:00',4.15),('8975','2013-05-31','14:10:00',3.6),('8975','2013-05-31','14:15:00',4.3),('8975','2013-05-31','14:20:00',3.28),('8975','2013-05-31','14:25:00',2.33),('8975','2013-05-31','14:30:00',2.13),('8975','2013-05-31','14:35:00',2.21),('8975','2013-05-31','14:40:00',2.22),('8975','2013-05-31','14:45:00',2.22),('8975','2013-05-31','14:50:00',2.01),('8975','2013-05-31','14:55:00',1.57),('8975','2013-05-31','15:00:00',1.53),('8975','2013-05-31','15:05:00',1.47),('8975','2013-05-31','15:10:00',1.1),('8975','2013-05-31','16:10:00',1.1),('8975','2013-05-31','16:15:00',1.21),('8975','2013-05-31','16:20:00',1.28),('8975','2013-05-31','16:35:00',1.2),('8975','2013-05-31','16:40:00',1.4),('8975','2013-05-31','16:45:00',1.12),('8975','2013-05-31','16:50:00',1.13),('8975','2013-05-31','16:55:00',1.08),('8975','2013-05-31','18:25:00',1.15),('8975','2013-05-31','18:30:00',1.73),('8975','2013-05-31','18:35:00',1.78),('8975','2013-05-31','18:40:00',1.27),('8975','2013-05-31','18:45:00',1.17),('8975','2013-05-31','18:50:00',1.18),('8975','2013-05-31','18:55:00',1.1),('8975','2013-05-31','19:00:00',1.36),('8975','2013-05-31','19:05:00',1.71),('8975','2013-05-31','19:10:00',1.11),('8975','2014-04-01','08:00:00',1.53),('8975','2014-04-01','08:05:00',2.1),('8975','2014-04-01','08:10:00',1.7),('8975','2014-04-01','08:15:00',1.73),('8975','2014-04-01','08:20:00',1.2),('8975','2014-04-01','08:30:00',1.65),('8975','2014-04-01','08:35:00',1.56),('8975','2014-04-01','08:40:00',1.09),('8975','2014-04-01','08:45:00',1.28),('8975','2014-04-01','08:50:00',1.39),('8975','2014-04-01','08:55:00',1.41),('8975','2014-04-01','09:00:00',1.55),('8975','2014-04-01','09:05:00',2.5),('8975','2014-04-01','09:10:00',4.65),('8975','2014-04-01','09:15:00',4.41),('8975','2014-04-01','09:20:00',4.43),('8975','2014-04-01','09:25:00',4.02),('8975','2014-04-01','09:30:00',3.33),('8975','2014-04-01','09:35:00',2.38),('8975','2014-04-01','09:50:00',1.11),('8975','2014-04-01','09:55:00',1.39);
INSERT INTO `solarlogmod` VALUES ('8975','2014-04-01','10:00:00',1.65),('8975','2014-04-01','10:05:00',2.36),('8975','2014-04-01','10:10:00',5.66),('8975','2014-04-01','10:15:00',6.23),('8975','2014-04-01','10:20:00',5.98),('8975','2014-04-01','10:25:00',3.17),('8975','2014-04-01','10:30:00',3.53),('8975','2014-04-01','10:35:00',1.73),('8975','2014-04-01','10:40:00',1.61),('8975','2014-04-01','10:45:00',5.29),('8975','2014-04-01','10:50:00',5.8),('8975','2014-04-01','10:55:00',5.77),('8975','2014-04-01','11:00:00',5.65),('8975','2014-04-01','11:05:00',2.18),('8975','2014-04-01','11:10:00',1.79),('8975','2014-04-01','11:15:00',2.71),('8975','2014-04-01','11:20:00',2.04),('8975','2014-04-01','11:25:00',5.71),('8975','2014-04-01','11:30:00',6.63),('8975','2014-04-01','11:35:00',2.84),('8975','2014-04-01','11:40:00',3.63),('8975','2014-04-01','11:45:00',6.13),('8975','2014-04-01','11:50:00',6.43),('8975','2014-04-01','11:55:00',6.66),('8975','2014-04-01','12:00:00',2.66),('8975','2014-04-01','12:05:00',2.2),('8975','2014-04-01','12:10:00',6.07),('8975','2014-04-01','12:15:00',5.93),('8975','2014-04-01','12:20:00',5.92),('8975','2014-04-01','12:25:00',6.82),('8975','2014-04-01','12:30:00',5.49),('8975','2014-04-01','12:35:00',1.84),('8975','2014-04-01','12:40:00',1.8),('8975','2014-04-01','12:45:00',2.61),('8975','2014-04-01','12:50:00',3.52),('8975','2014-04-01','12:55:00',6.78),('8975','2014-04-01','13:00:00',2.87),('8975','2014-04-01','13:05:00',1.88),('8975','2014-04-01','13:10:00',3.82),('8975','2014-04-01','13:15:00',1.61),('8975','2014-04-01','13:20:00',3.36),('8975','2014-04-01','13:25:00',2.93),('8975','2014-04-01','13:30:00',4.91),('8975','2014-04-01','13:35:00',6.25),('8975','2014-04-01','13:40:00',6.05),('8975','2014-04-01','13:45:00',6.05),('8975','2014-04-01','13:50:00',5.86),('8975','2014-04-01','13:55:00',4.41),('8975','2014-04-01','14:00:00',5.77),('8975','2014-04-01','14:05:00',5.8),('8975','2014-04-01','14:10:00',5.58),('8975','2014-04-01','14:15:00',5.47),('8975','2014-04-01','14:20:00',5.4),('8975','2014-04-01','14:25:00',4.47),('8975','2014-04-01','14:30:00',5.3),('8975','2014-04-01','14:35:00',5.3),('8975','2014-04-01','14:40:00',5.27),('8975','2014-04-01','14:45:00',5.29),('8975','2014-04-01','14:50:00',4.93),('8975','2014-04-01','14:55:00',4.59),('8975','2014-04-01','15:00:00',4.55),('8975','2014-04-01','15:05:00',4.51),('8975','2014-04-01','15:10:00',4.38),('8975','2014-04-01','15:15:00',4.25),('8975','2014-04-01','15:20:00',4.15),('8975','2014-04-01','15:25:00',4.13),('8975','2014-04-01','15:30:00',4.01),('8975','2014-04-01','15:35:00',3.84),('8975','2014-04-01','15:40:00',3.72),('8975','2014-04-01','15:45:00',3.78),('8975','2014-04-01','15:50:00',3.62),('8975','2014-04-01','15:55:00',3.39),('8975','2014-04-01','16:00:00',3.15),('8975','2014-04-01','16:05:00',3.16),('8975','2014-04-01','16:10:00',3.05),('8975','2014-04-01','16:15:00',2.95),('8975','2014-04-01','16:20:00',2.88),('8975','2014-04-01','16:25:00',2.84),('8975','2014-04-01','16:30:00',2.59),('8975','2014-04-01','16:35:00',2.71),('8975','2014-04-01','16:40:00',2.55),('8975','2014-04-01','16:45:00',2.45),('8975','2014-04-01','16:50:00',2.28),('8975','2014-04-01','16:55:00',2.19),('8975','2014-04-01','17:00:00',2.16),('8975','2014-04-01','17:05:00',1.95),('8975','2014-04-01','17:10:00',1.84),('8975','2014-04-01','17:15:00',1.64),('8975','2014-04-01','17:20:00',1.6),('8975','2014-04-01','17:25:00',1.58),('8975','2014-04-01','17:30:00',1.46),('8975','2014-04-01','17:35:00',1.37),('8975','2014-04-01','17:40:00',1.17),('8975','2014-04-01','17:45:00',1.08),('8975','2014-04-01','17:50:00',1.47),('8975','2014-04-01','17:55:00',1.36),('8975','2014-04-01','18:00:00',1.25),('8975','2013-05-30','06:30:00',1.36),('8975','2013-05-30','06:35:00',1.67),('8975','2013-05-30','06:40:00',1.79),('8975','2013-05-30','06:45:00',1.98),('8975','2013-05-30','06:50:00',2.24),('8975','2013-05-30','06:55:00',2.29),('8975','2013-05-30','07:00:00',2.46),('8975','2013-05-30','07:05:00',2.62),('8975','2013-05-30','07:10:00',2.81),('8975','2013-05-30','07:15:00',2.97),('8975','2013-05-30','07:20:00',3.12),('8975','2013-05-30','07:25:00',3.23),('8975','2013-05-30','07:30:00',3.35),('8975','2013-05-30','07:35:00',3.49),('8975','2013-05-30','07:40:00',3.59),('8975','2013-05-30','07:45:00',3.68),('8975','2013-05-30','07:50:00',3.79),('8975','2013-05-30','07:55:00',3.92),('8975','2013-05-30','08:00:00',4.04),('8975','2013-05-30','08:05:00',4.14),('8975','2013-05-30','08:10:00',4.24),('8975','2013-05-30','08:15:00',4.3),('8975','2013-05-30','08:20:00',4.4),('8975','2013-05-30','08:25:00',4.56),('8975','2013-05-30','08:30:00',4.67),('8975','2013-05-30','08:35:00',4.32),('8975','2013-05-30','08:40:00',3.87),('8975','2013-05-30','08:45:00',3.88),('8975','2013-05-30','08:50:00',2.07),('8975','2013-05-30','08:55:00',2.71),('8975','2013-05-30','09:00:00',3.05),('8975','2013-05-30','09:05:00',1.29),('8975','2013-05-30','09:10:00',1.77),('8975','2013-05-30','09:15:00',1.3),('8975','2013-05-30','09:20:00',4.04),('8975','2013-05-30','09:25:00',5.52),('8975','2013-05-30','09:30:00',6.13),('8975','2013-05-30','09:35:00',4.35),('8975','2013-05-30','09:40:00',1.84),('8975','2013-05-30','09:45:00',5.17),('8975','2013-05-30','09:50:00',6.79),('8975','2013-05-30','09:55:00',7.09),('8975','2013-05-30','10:00:00',2.05),('8975','2013-05-30','10:05:00',6.99),('8975','2013-05-30','10:10:00',3.7),('8975','2013-05-30','10:15:00',6.21),('8975','2013-05-30','10:20:00',3.46),('8975','2013-05-30','10:25:00',2.17),('8975','2013-05-30','10:30:00',1.45),('8975','2013-05-30','10:35:00',3.14),('8975','2013-05-30','10:40:00',7.88),('8975','2013-05-30','10:45:00',4),('8975','2013-05-30','10:50:00',2.14),('8975','2013-05-30','10:55:00',3.05),('8975','2013-05-30','11:00:00',4.31),('8975','2013-05-30','11:05:00',8.27),('8975','2013-05-30','11:10:00',5.13),('8975','2013-05-30','11:15:00',4.65),('8975','2013-05-30','11:20:00',1.84),('8975','2013-05-30','11:25:00',4.34),('8975','2013-05-30','11:30:00',3.37),('8975','2013-05-30','11:35:00',5.8),('8975','2013-05-30','11:40:00',2.25),('8975','2013-05-30','11:45:00',1.85),('8975','2013-05-30','11:50:00',7.48),('8975','2013-05-30','11:55:00',4.11),('8975','2013-05-30','12:00:00',4.07),('8975','2013-05-30','12:05:00',2.11),('8975','2013-05-30','12:10:00',4.32),('8975','2013-05-30','12:15:00',1.93),('8975','2013-05-30','12:20:00',2.73),('8975','2013-05-30','12:25:00',3.43),('8975','2013-05-30','12:30:00',3.39),('8975','2013-05-30','12:35:00',2.63),('8975','2013-05-30','12:40:00',4.81),('8975','2013-05-30','12:45:00',3.18),('8975','2013-05-30','12:50:00',1.07),('8975','2013-05-30','12:55:00',1.61),('8975','2013-05-30','13:00:00',4.35),('8975','2013-05-30','13:05:00',2.66),('8975','2013-05-30','13:10:00',1.09),('8975','2013-05-30','13:15:00',1.02),('8975','2013-05-30','13:20:00',1.66),('8975','2013-05-30','13:25:00',3),('8975','2013-05-30','13:30:00',6.62),('8975','2013-05-30','13:35:00',5.75),('8975','2013-05-30','13:40:00',1.66),('8975','2013-05-30','13:45:00',1.63),('8975','2013-05-30','13:50:00',1.52),('8975','2013-05-30','13:55:00',2.7),('8975','2013-05-30','14:00:00',1.95),('8975','2013-05-30','14:05:00',1.46),('8975','2013-05-30','14:10:00',1.46),('8975','2013-05-30','14:20:00',1.26),('8975','2013-05-30','14:25:00',1.23),('8975','2013-05-30','14:50:00',1.28),('8975','2013-05-30','14:55:00',1.03),('8975','2013-05-30','15:00:00',1.13),('8975','2013-05-30','15:05:00',1.85),('8975','2013-05-30','15:10:00',2.53),('8975','2013-05-30','15:15:00',4.86),('8975','2013-05-30','15:20:00',5.98),('8975','2013-05-30','15:25:00',5.61),('8975','2013-05-30','15:30:00',3.6),('8975','2013-05-30','15:35:00',3.01),('8975','2013-05-30','15:40:00',2.68),('8975','2013-05-30','15:45:00',2.75),('8975','2013-05-30','15:50:00',3.3),('8975','2013-05-30','15:55:00',3.08),('8975','2013-05-30','16:00:00',2.12),('8975','2013-05-30','16:05:00',2.3),('8975','2013-05-30','16:10:00',1.96),('8975','2013-05-30','16:15:00',1.65),('8975','2013-05-30','16:20:00',1.97),('8975','2013-05-30','16:25:00',2.45),('8975','2013-05-30','16:30:00',2.23),('8975','2013-05-30','16:35:00',1.98),('8975','2013-05-30','16:40:00',2.23),('8975','2013-05-30','16:45:00',1.93),('8975','2013-05-30','16:50:00',1.34),('8975','2013-05-30','16:55:00',1.16),('8975','2013-05-30','17:00:00',1.01),('8975','2013-05-30','17:15:00',1.12),('8975','2013-05-30','17:20:00',1.33),('8975','2013-05-30','17:25:00',1.42),('8975','2013-05-30','17:30:00',1.38),('8975','2013-05-30','17:35:00',1.13),('8975','2013-05-29','07:40:00',1.11),('8975','2013-05-29','07:45:00',1.56),('8975','2013-05-29','07:50:00',3.81),('8975','2013-05-29','07:55:00',2.24),('8975','2013-05-29','08:00:00',1.07),('8975','2013-05-29','08:15:00',1.03),('8975','2013-05-29','08:20:00',1.27),('8975','2013-05-29','08:25:00',2.77),('8975','2013-05-29','08:30:00',2.05),('8975','2013-05-29','08:35:00',2.88),('8975','2013-05-29','08:40:00',5.29),('8975','2013-05-29','08:45:00',5.22),('8975','2013-05-29','08:50:00',5.24),('8975','2013-05-29','08:55:00',5.28),('8975','2013-05-29','09:00:00',5.02),('8975','2013-05-29','09:05:00',5.61),('8975','2013-05-29','09:10:00',5.67),('8975','2013-05-29','09:15:00',5.44),('8975','2013-05-29','09:20:00',5.76),('8975','2013-05-29','09:25:00',5.84),('8975','2013-05-29','09:30:00',5.96),('8975','2013-05-29','09:35:00',6.02),('8975','2013-05-29','09:40:00',6.39),('8975','2013-05-29','09:45:00',6.1),('8975','2013-05-29','09:50:00',4.97),('8975','2013-05-29','09:55:00',4.33),('8975','2013-05-29','10:00:00',1.92),('8975','2013-05-29','10:05:00',1.41),('8975','2013-05-29','10:10:00',3.33),('8975','2013-05-29','10:15:00',3.4),('8975','2013-05-29','10:20:00',2.07),('8975','2013-05-29','10:25:00',3.75),('8975','2013-05-29','10:30:00',4.38),('8975','2013-05-29','10:35:00',3.84),('8975','2013-05-29','10:40:00',2.57),('8975','2013-05-29','10:45:00',5.18),('8975','2013-05-29','10:50:00',1.65),('8975','2013-05-29','10:55:00',6.33),('8975','2013-05-29','11:00:00',5.17),('8975','2013-05-29','11:05:00',6.38),('8975','2013-05-29','11:10:00',8.31),('8975','2013-05-29','11:15:00',8.28),('8975','2013-05-29','11:20:00',7.98),('8975','2013-05-29','11:25:00',6.7),('8975','2013-05-29','11:30:00',6.44),('8975','2013-05-29','11:35:00',5.64),('8975','2013-05-29','11:40:00',8.6),('8975','2013-05-29','11:45:00',6.82),('8975','2013-05-29','11:50:00',2.24),('8975','2013-05-29','11:55:00',7.13),('8975','2013-05-29','12:00:00',8.44),('8975','2013-05-29','12:05:00',7.04),('8975','2013-05-29','12:10:00',2.66),('8975','2013-05-29','12:15:00',5.72),('8975','2013-05-29','12:20:00',7.52),('8975','2013-05-29','12:25:00',6.35),('8975','2013-05-29','12:30:00',8),('8975','2013-05-29','12:35:00',7.81),('8975','2013-05-29','12:40:00',5.33),('8975','2013-05-29','12:45:00',4.89),('8975','2013-05-29','12:50:00',7.66),('8975','2013-05-29','12:55:00',8.04),('8975','2013-05-29','13:00:00',7.83),('8975','2013-05-29','13:05:00',4.31),('8975','2013-05-29','13:10:00',3.16),('8975','2013-05-29','13:15:00',2.52),('8975','2013-05-29','13:20:00',3.35),('8975','2013-05-29','13:25:00',3.86),('8975','2013-05-29','13:30:00',4.78),('8975','2013-05-29','13:35:00',5.69),('8975','2013-05-29','13:40:00',5.62),('8975','2013-05-29','13:45:00',4.51),('8975','2013-05-29','13:50:00',7.58),('8975','2013-05-29','13:55:00',6.91),('8975','2013-05-29','14:00:00',6.04),('8975','2013-05-29','14:05:00',6.54),('8975','2013-05-29','14:10:00',5.97),('8975','2013-05-29','14:15:00',7.72),('8975','2013-05-29','14:20:00',7.55),('8975','2013-05-29','14:25:00',7.36),('8975','2013-05-29','14:30:00',7.18),('8975','2013-05-29','14:35:00',7.06),('8975','2013-05-29','14:40:00',5.51),('8975','2013-05-29','14:45:00',6.48),('8975','2013-05-29','14:50:00',6.78),('8975','2013-05-29','14:55:00',5.84),('8975','2013-05-29','15:00:00',4.88),('8975','2013-05-29','15:05:00',4.55),('8975','2013-05-29','15:10:00',5.42),('8975','2013-05-29','15:15:00',5.52),('8975','2013-05-29','15:20:00',4.42),('8975','2013-05-29','15:25:00',5.96),('8975','2013-05-29','15:30:00',3.96),('8975','2013-05-29','15:35:00',4.61),('8975','2013-05-29','15:40:00',6.14),('8975','2013-05-29','15:45:00',3.46),('8975','2013-05-29','15:50:00',3.33),('8975','2013-05-29','15:55:00',3.8),('8975','2013-05-29','16:00:00',5.15),('8975','2013-05-29','16:05:00',5.63),('8975','2013-05-29','16:10:00',5.72),('8975','2013-05-29','16:15:00',4.93),('8975','2013-05-29','16:20:00',4.76),('8975','2013-05-29','16:25:00',4.78),('8975','2013-05-29','16:30:00',4.03),('8975','2013-05-29','16:35:00',3.48),('8975','2013-05-29','16:40:00',3.57),('8975','2013-05-29','16:45:00',3.62),('8975','2013-05-29','16:50:00',3.5),('8975','2013-05-29','16:55:00',3.93),('8975','2013-05-29','17:00:00',3.36),('8975','2013-05-29','17:05:00',2.9),('8975','2013-05-29','17:10:00',2.61),('8975','2013-05-29','17:15:00',2.7),('8975','2013-05-29','17:20:00',3.34),('8975','2013-05-29','17:25:00',1.88),('8975','2013-05-29','17:30:00',1.38),('8975','2013-05-29','17:35:00',1.23),('8975','2013-05-29','17:40:00',1.02),('8975','2013-05-29','17:55:00',1.13),('8975','2013-05-29','18:00:00',2.87),('8975','2013-05-29','18:05:00',1.79),('8975','2013-05-29','18:20:00',1.05),('8975','2013-05-29','18:25:00',1.15),('8975','2013-05-29','18:30:00',1.37),('8975','2013-05-29','18:35:00',1.63),('8975','2013-05-29','18:40:00',1.57),('8975','2013-05-29','18:45:00',2.01),('8975','2013-05-29','18:50:00',1.71),('8975','2013-05-29','18:55:00',1.03),('8975','2013-05-28','06:25:00',1.15),('8975','2013-05-28','06:30:00',1.33),('8975','2013-05-28','06:35:00',1.53),('8975','2013-05-28','06:40:00',1.71),('8975','2013-05-28','06:45:00',1.84),('8975','2013-05-28','06:50:00',2.04),('8975','2013-05-28','06:55:00',2.26),('8975','2013-05-28','07:00:00',2.45),('8975','2013-05-28','07:05:00',2.63),('8975','2013-05-28','07:10:00',2.79),('8975','2013-05-28','07:15:00',2.66),('8975','2013-05-28','07:20:00',2.54),('8975','2013-05-28','07:25:00',2.06),('8975','2013-05-28','07:30:00',2.21),('8975','2013-05-28','07:35:00',3.05),('8975','2013-05-28','07:40:00',2.69),('8975','2013-05-28','07:45:00',3.33),('8975','2013-05-28','07:50:00',3.4),('8975','2013-05-28','07:55:00',3.75),('8975','2013-05-28','08:00:00',3.7),('8975','2013-05-28','08:05:00',3.76),('8975','2013-05-28','08:10:00',3.96),('8975','2013-05-28','08:15:00',4.14),('8975','2013-05-28','08:20:00',3.93),('8975','2013-05-28','08:25:00',3.36),('8975','2013-05-28','08:30:00',4.09),('8975','2013-05-28','08:35:00',4.72),('8975','2013-05-28','08:40:00',4.82),('8975','2013-05-28','08:45:00',4.9),('8975','2013-05-28','08:50:00',4.98),('8975','2013-05-28','08:55:00',5.08),('8975','2013-05-28','09:00:00',5.12),('8975','2013-05-28','09:05:00',5.28),('8975','2013-05-28','09:10:00',5.43),('8975','2013-05-28','09:15:00',5.52),('8975','2013-05-28','09:20:00',5.59),('8975','2013-05-28','09:25:00',5.7),('8975','2013-05-28','09:30:00',5.76),('8975','2013-05-28','09:35:00',5.88),('8975','2013-05-28','09:40:00',5.99),('8975','2013-05-28','09:45:00',6.07),('8975','2013-05-28','09:50:00',6.13),('8975','2013-05-28','09:55:00',6.19),('8975','2013-05-28','10:00:00',6.28),('8975','2013-05-28','10:05:00',6.39),('8975','2013-05-28','10:10:00',6.45),('8975','2013-05-28','10:15:00',6.52),('8975','2013-05-28','10:20:00',6.6),('8975','2013-05-28','10:25:00',6.69),('8975','2013-05-28','10:30:00',6.77),('8975','2013-05-28','10:35:00',6.83),('8975','2013-05-28','10:40:00',6.89),('8975','2013-05-28','10:45:00',6.97),('8975','2013-05-28','10:50:00',7.02),('8975','2013-05-28','10:55:00',7.11),('8975','2013-05-28','11:00:00',7.31),('8975','2013-05-28','11:05:00',6.8),('8975','2013-05-28','11:10:00',7.02),('8975','2013-05-28','11:15:00',7.06),('8975','2013-05-28','11:20:00',6.68),('8975','2013-05-28','11:25:00',7.96),('8975','2013-05-28','11:30:00',5.69),('8975','2013-05-28','11:35:00',6.95),('8975','2013-05-28','11:40:00',5.34),('8975','2013-05-28','11:45:00',4.09),('8975','2013-05-28','11:50:00',6.14),('8975','2013-05-28','11:55:00',6.09),('8975','2013-05-28','12:00:00',6.62),('8975','2013-05-28','12:05:00',7.73),('8975','2013-05-28','12:10:00',7.97),('8975','2013-05-28','12:15:00',6.74),('8975','2013-05-28','12:20:00',7.12),('8975','2013-05-28','12:25:00',7.66),('8975','2013-05-28','12:30:00',6.5),('8975','2013-05-28','12:35:00',6.35),('8975','2013-05-28','12:40:00',7.57),('8975','2013-05-28','12:45:00',7.51),('8975','2013-05-28','12:50:00',6.57),('8975','2013-05-28','12:55:00',7.48),('8975','2013-05-28','13:00:00',7.46),('8975','2013-05-28','13:05:00',7.64),('8975','2013-05-28','13:10:00',6.71),('8975','2013-05-28','13:15:00',7.38),('8975','2013-05-28','13:20:00',6.65),('8975','2013-05-28','13:25:00',7.77),('8975','2013-05-28','13:30:00',7.53),('8975','2013-05-28','13:35:00',7.42),('8975','2013-05-28','13:40:00',7.92),('8975','2013-05-28','13:45:00',6.15),('8975','2013-05-28','13:50:00',5.67),('8975','2013-05-28','13:55:00',6.12),('8975','2013-05-28','14:00:00',7.14),('8975','2013-05-28','14:05:00',6.8),('8975','2013-05-28','14:10:00',6.49),('8975','2013-05-28','14:15:00',7.04),('8975','2013-05-28','14:20:00',3.63),('8975','2013-05-28','14:25:00',6.19),('8975','2013-05-28','14:30:00',3.27),('8975','2013-05-28','14:35:00',7.02),('8975','2013-05-28','14:40:00',6.87),('8975','2013-05-28','14:45:00',6.73),('8975','2013-05-28','14:50:00',5.5),('8975','2013-05-28','14:55:00',6.69),('8975','2013-05-28','15:00:00',6.29),('8975','2013-05-28','15:05:00',5.3),('8975','2013-05-28','15:10:00',5.56),('8975','2013-05-28','15:15:00',5.93),('8975','2013-05-28','15:20:00',4.91),('8975','2013-05-28','15:25:00',3.87),('8975','2013-05-28','15:30:00',3.55),('8975','2013-05-28','15:35:00',4.24),('8975','2013-05-28','15:40:00',4.22),('8975','2013-05-28','15:45:00',4.32),('8975','2013-05-28','15:50:00',4.31),('8975','2013-05-28','15:55:00',3.88),('8975','2013-05-28','16:00:00',3.79),('8975','2013-05-28','16:05:00',4.13),('8975','2013-05-28','16:10:00',3.43),('8975','2013-05-28','16:15:00',3.47),('8975','2013-05-28','16:20:00',3.49),('8975','2013-05-28','16:25:00',3.49),('8975','2013-05-28','16:30:00',2.72),('8975','2013-05-28','16:35:00',2.87),('8975','2013-05-28','16:40:00',3.41),('8975','2013-05-28','16:45:00',3.13),('8975','2013-05-28','16:50:00',2.59),('8975','2013-05-28','16:55:00',2.38),('8975','2013-05-28','17:00:00',1.9),('8975','2013-05-28','17:25:00',1.13),('8975','2013-05-28','17:30:00',1.21),('8975','2013-05-28','17:35:00',1.85),('8975','2013-05-28','17:40:00',2.13),('8975','2013-05-28','17:45:00',1.77),('8975','2013-05-28','17:50:00',1.32),('8975','2013-05-28','17:55:00',1.1),('8975','2013-05-28','18:00:00',1.25),('8975','2013-05-28','18:05:00',1.36),('8975','2013-05-28','18:10:00',1.21),('8975','2013-05-28','18:15:00',1.48),('8975','2013-05-28','18:20:00',1.15),('8975','2013-05-28','19:05:00',1.1),('8975','2013-05-28','19:10:00',1.27),('8975','2013-05-28','19:15:00',1.08),('8975','2013-05-27','06:30:00',1.14),('8975','2013-05-27','06:35:00',1.38),('8975','2013-05-27','06:40:00',1.91),('8975','2013-05-27','06:45:00',2.15),('8975','2013-05-27','06:50:00',2.26),('8975','2013-05-27','06:55:00',1.82),('8975','2013-05-27','07:00:00',1.17),('8975','2013-05-27','07:05:00',1.34),('8975','2013-05-27','07:10:00',2.04),('8975','2013-05-27','07:15:00',2.71),('8975','2013-05-27','07:20:00',3.09),('8975','2013-05-27','07:25:00',2.83),('8975','2013-05-27','07:30:00',1.73),('8975','2013-05-27','07:35:00',2.13),('8975','2013-05-27','07:40:00',2.53),('8975','2013-05-27','07:45:00',2.48),('8975','2013-05-27','07:50:00',2.4),('8975','2013-05-27','07:55:00',2.58),('8975','2013-05-27','08:00:00',2.72),('8975','2013-05-27','08:05:00',2.83),('8975','2013-05-27','08:10:00',3.48),('8975','2013-05-27','08:15:00',3.75),('8975','2013-05-27','08:20:00',3.79),('8975','2013-05-27','08:25:00',3.15),('8975','2013-05-27','08:30:00',3.62),('8975','2013-05-27','08:35:00',3.03),('8975','2013-05-27','08:40:00',2.6),('8975','2013-05-27','08:45:00',2.58),('8975','2013-05-27','08:50:00',3.05),('8975','2013-05-27','08:55:00',3.15),('8975','2013-05-27','09:00:00',3.11),('8975','2013-05-27','09:05:00',3.22),('8975','2013-05-27','09:10:00',2.82),('8975','2013-05-27','09:15:00',2.84),('8975','2013-05-27','09:20:00',3.68),('8975','2013-05-27','09:25:00',4.13),('8975','2013-05-27','09:30:00',4.13),('8975','2013-05-27','09:35:00',4.16),('8975','2013-05-27','09:40:00',3.85),('8975','2013-05-27','09:45:00',3.59),('8975','2013-05-27','09:50:00',3.9),('8975','2013-05-27','09:55:00',4.13),('8975','2013-05-27','10:00:00',3.79),('8975','2013-05-27','10:05:00',4.23),('8975','2013-05-27','10:10:00',4.56),('8975','2013-05-27','10:15:00',4.89),('8975','2013-05-27','10:20:00',4.84),('8975','2013-05-27','10:25:00',4.93),('8975','2013-05-27','10:30:00',5.59),('8975','2013-05-27','10:35:00',5.47),('8975','2013-05-27','10:40:00',4.49),('8975','2013-05-27','10:45:00',4.37),('8975','2013-05-27','10:50:00',4.96),('8975','2013-05-27','10:55:00',4.05),('8975','2013-05-27','11:00:00',3.93),('8975','2013-05-27','11:05:00',4.56),('8975','2013-05-27','11:10:00',3.97),('8975','2013-05-27','11:15:00',4),('8975','2013-05-27','11:20:00',4.22),('8975','2013-05-27','11:25:00',3.88),('8975','2013-05-27','11:30:00',5.9),('8975','2013-05-27','11:35:00',5.75),('8975','2013-05-27','11:40:00',6.31),('8975','2013-05-27','11:45:00',4.47),('8975','2013-05-27','11:50:00',1.89),('8975','2013-05-27','11:55:00',2.79),('8975','2013-05-27','12:00:00',2.46),('8975','2013-05-27','12:05:00',3.21),('8975','2013-05-27','12:10:00',6.17),('8975','2013-05-27','12:15:00',4.35),('8975','2013-05-27','12:20:00',4.03),('8975','2013-05-27','12:25:00',4.38),('8975','2013-05-27','12:30:00',4.56),('8975','2013-05-27','12:35:00',4.2),('8975','2013-05-27','12:40:00',4.58),('8975','2013-05-27','12:45:00',4.94),('8975','2013-05-27','12:50:00',4.45),('8975','2013-05-27','12:55:00',4.49),('8975','2013-05-27','13:00:00',4.6),('8975','2013-05-27','13:05:00',4.85),('8975','2013-05-27','13:10:00',4.76),('8975','2013-05-27','13:15:00',4.84),('8975','2013-05-27','13:20:00',4.42),('8975','2013-05-27','13:25:00',3.09),('8975','2013-05-27','13:30:00',3.34),('8975','2013-05-27','13:35:00',3),('8975','2013-05-27','13:40:00',3.21),('8975','2013-05-27','13:45:00',3.7),('8975','2013-05-27','13:50:00',4.99),('8975','2013-05-27','13:55:00',4.34),('8975','2013-05-27','14:00:00',4.09),('8975','2013-05-27','14:05:00',4.92),('8975','2013-05-27','14:10:00',6.21),('8975','2013-05-27','14:15:00',4.69),('8975','2013-05-27','14:20:00',4.36),('8975','2013-05-27','14:25:00',4.54),('8975','2013-05-27','14:30:00',4.78),('8975','2013-05-27','14:35:00',4.97),('8975','2013-05-27','14:40:00',5.35),('8975','2013-05-27','14:45:00',4.89),('8975','2013-05-27','14:50:00',3.86),('8975','2013-05-27','14:55:00',3.45),('8975','2013-05-27','15:00:00',4.33),('8975','2013-05-27','15:05:00',4.65),('8975','2013-05-27','15:10:00',3.16),('8975','2013-05-27','15:15:00',4.44),('8975','2013-05-27','15:20:00',4.44),('8975','2013-05-27','15:25:00',3.03),('8975','2013-05-27','15:30:00',2.46),('8975','2013-05-27','15:35:00',2.77),('8975','2013-05-27','15:40:00',5.18),('8975','2013-05-27','15:45:00',4.75),('8975','2013-05-27','15:50:00',4.2),('8975','2013-05-27','15:55:00',2.78),('8975','2013-05-27','16:00:00',2.14),('8975','2013-05-27','16:05:00',2.61),('8975','2013-05-27','16:10:00',1.85),('8975','2013-05-27','16:15:00',2.67),('8975','2013-05-27','16:20:00',3.4),('8975','2013-05-27','16:25:00',3.88),('8975','2013-05-27','16:30:00',3.75),('8975','2013-05-27','16:35:00',3.81),('8975','2013-05-27','16:40:00',3.57),('8975','2013-05-27','16:45:00',3.41),('8975','2013-05-27','16:50:00',3.31),('8975','2013-05-27','16:55:00',3.19),('8975','2013-05-27','17:00:00',3.1),('8975','2013-05-27','17:05:00',2.99),('8975','2013-05-27','17:10:00',2.88),('8975','2013-05-27','17:15:00',2.78),('8975','2013-05-27','17:20:00',2.66),('8975','2013-05-27','17:25:00',2.47),('8975','2013-05-27','17:30:00',2.39),('8975','2013-05-27','17:35:00',2.26),('8975','2013-05-27','17:40:00',2.12),('8975','2013-05-27','17:45:00',2.01),('8975','2013-05-27','17:50:00',1.91),('8975','2013-05-27','17:55:00',1.82),('8975','2013-05-27','18:00:00',1.82),('8975','2013-05-27','18:05:00',1.73),('8975','2013-05-27','18:10:00',1.43),('8975','2013-05-27','18:35:00',1.33),('8975','2013-05-27','18:40:00',1.25),('8975','2013-05-27','18:45:00',1.21),('8975','2013-05-27','18:50:00',1.15),('8975','2013-05-27','18:55:00',1.1),('8975','2013-05-27','19:00:00',1.03),('8975','2013-05-26','06:40:00',1.04),('8975','2013-05-26','06:45:00',1.06),('8975','2013-05-26','06:50:00',1.54),('8975','2013-05-26','06:55:00',1.41),('8975','2013-05-26','07:00:00',2.41),('8975','2013-05-26','07:05:00',2.98),('8975','2013-05-26','07:10:00',2.17),('8975','2013-05-26','07:15:00',1.1),('8975','2013-05-26','07:20:00',2.5),('8975','2013-05-26','07:25:00',3.44),('8975','2013-05-26','07:30:00',3.45),('8975','2013-05-26','07:35:00',3.55),('8975','2013-05-26','07:40:00',3.73),('8975','2013-05-26','07:45:00',3.62),('8975','2013-05-26','07:50:00',3.67),('8975','2013-05-26','07:55:00',1.85),('8975','2013-05-26','08:00:00',2.7),('8975','2013-05-26','08:05:00',4.22),('8975','2013-05-26','08:10:00',3.92),('8975','2013-05-26','08:15:00',3.78),('8975','2013-05-26','08:20:00',4.68),('8975','2013-05-26','08:25:00',4.72),('8975','2013-05-26','08:30:00',4.72),('8975','2013-05-26','08:35:00',4.43),('8975','2013-05-26','08:40:00',4.49),('8975','2013-05-26','08:45:00',4.48),('8975','2013-05-26','08:50:00',2.83),('8975','2013-05-26','08:55:00',4.01),('8975','2013-05-26','09:00:00',5.53),('8975','2013-05-26','09:05:00',5.77),('8975','2013-05-26','09:10:00',6.06),('8975','2013-05-26','09:15:00',6.3),('8975','2013-05-26','09:20:00',3.05),('8975','2013-05-26','09:25:00',6.16),('8975','2013-05-26','09:30:00',6.23),('8975','2013-05-26','09:35:00',6.36),('8975','2013-05-26','09:40:00',6.35),('8975','2013-05-26','09:45:00',6.47),('8975','2013-05-26','09:50:00',6.79),('8975','2013-05-26','09:55:00',5.82),('8975','2013-05-26','10:00:00',4.33),('8975','2013-05-26','10:05:00',6.73),('8975','2013-05-26','10:10:00',6.95),('8975','2013-05-26','10:15:00',6.99),('8975','2013-05-26','10:20:00',7.02),('8975','2013-05-26','10:25:00',7.4),('8975','2013-05-26','10:30:00',6.71),('8975','2013-05-26','10:35:00',1.67),('8975','2013-05-26','10:40:00',5.53),('8975','2013-05-26','10:45:00',7.75),('8975','2013-05-26','10:50:00',2.75),('8975','2013-05-26','10:55:00',3.07),('8975','2013-05-26','11:00:00',6.3),('8975','2013-05-26','11:05:00',6.25),('8975','2013-05-26','11:10:00',2.4),('8975','2013-05-26','11:15:00',3.89),('8975','2013-05-26','11:20:00',6.98),('8975','2013-05-26','11:25:00',2.28),('8975','2013-05-26','11:30:00',4.02),('8975','2013-05-26','11:35:00',7.9),('8975','2013-05-26','11:40:00',4.43),('8975','2013-05-26','11:45:00',6.39),('8975','2013-05-26','11:50:00',6.06),('8975','2013-05-26','11:55:00',6.76),('8975','2013-05-26','12:00:00',7.27),('8975','2013-05-26','12:05:00',7.87),('8975','2013-05-26','12:10:00',6.55),('8975','2013-05-26','12:15:00',4.91),('8975','2013-05-26','12:20:00',8.38),('8975','2013-05-26','12:25:00',8.11),('8975','2013-05-26','12:30:00',8.01),('8975','2013-05-26','12:35:00',7.23),('8975','2013-05-26','12:40:00',7.47),('8975','2013-05-26','12:45:00',8.04),('8975','2013-05-26','12:50:00',7.61),('8975','2013-05-26','12:55:00',5.39),('8975','2013-05-26','13:00:00',5.47),('8975','2013-05-26','13:05:00',6.02),('8975','2013-05-26','13:10:00',4.88),('8975','2013-05-26','13:15:00',2.32),('8975','2013-05-26','13:20:00',7.81),('8975','2013-05-26','13:25:00',7.52),('8975','2013-05-26','13:30:00',5.59),('8975','2013-05-26','13:35:00',6.35),('8975','2013-05-26','13:40:00',6.58),('8975','2013-05-26','13:45:00',6.97),('8975','2013-05-26','13:50:00',7.31),('8975','2013-05-26','13:55:00',7.13),('8975','2013-05-26','14:00:00',4.5),('8975','2013-05-26','14:05:00',4.7),('8975','2013-05-26','14:10:00',6.81),('8975','2013-05-26','14:15:00',6.82),('8975','2013-05-26','14:20:00',6.91),('8975','2013-05-26','14:25:00',5.87),('8975','2013-05-26','14:30:00',6.67),('8975','2013-05-26','14:35:00',6.56),('8975','2013-05-26','14:40:00',6.67),('8975','2013-05-26','14:45:00',6.45),('8975','2013-05-26','14:50:00',6.36),('8975','2013-05-26','14:55:00',5.42),('8975','2013-05-26','15:00:00',4.43),('8975','2013-05-26','15:05:00',3.51),('8975','2013-05-26','15:10:00',6.27),('8975','2013-05-26','15:15:00',4.21),('8975','2013-05-26','15:20:00',5.71),('8975','2013-05-26','15:25:00',4.94),('8975','2013-05-26','15:30:00',4.92),('8975','2013-05-26','15:35:00',5.79),('8975','2013-05-26','15:40:00',5.18),('8975','2013-05-26','15:45:00',4.77),('8975','2013-05-26','15:50:00',5.38),('8975','2013-05-26','15:55:00',3.97),('8975','2013-05-26','16:00:00',3.91),('8975','2013-05-26','16:05:00',3.36),('8975','2013-05-26','16:10:00',3.63),('8975','2013-05-26','16:15:00',3.25),('8975','2013-05-26','16:20:00',5.27),('8975','2013-05-26','16:25:00',4.78),('8975','2013-05-26','16:30:00',4.45),('8975','2013-05-26','16:35:00',3.52),('8975','2013-05-26','16:40:00',2.01),('8975','2013-05-26','16:45:00',1.87),('8975','2013-05-26','16:50:00',2.06),('8975','2013-05-26','16:55:00',2.22),('8975','2013-05-26','17:00:00',2.31),('8975','2013-05-26','17:05:00',2.29),('8975','2013-05-26','17:10:00',2.6),('8975','2013-05-26','17:15:00',2.36),('8975','2013-05-26','17:20:00',2.1),('8975','2013-05-26','17:25:00',1.93),('8975','2013-05-26','17:30:00',1.84),('8975','2013-05-26','17:35:00',1.7),('8975','2013-05-26','17:40:00',1.6),('8975','2013-05-26','17:45:00',1.52),('8975','2013-05-26','17:50:00',1.46),('8975','2013-05-26','17:55:00',1.48),('8975','2013-05-26','18:00:00',1.47),('8975','2013-05-26','18:05:00',1.31),('8975','2013-05-26','18:10:00',1.34),('8975','2013-05-26','18:15:00',1.48),('8975','2013-05-26','18:20:00',1.73),('8975','2013-05-26','18:25:00',2.08),('8975','2013-05-26','18:30:00',1.9),('8975','2013-05-26','18:35:00',1.2),('8975','2013-05-26','18:45:00',1.23),('8975','2013-05-26','18:50:00',1.02),('8975','2013-05-26','18:55:00',1.29),('8975','2013-05-26','19:00:00',1.49),('8975','2013-05-26','19:05:00',1.61),('8975','2013-05-26','19:10:00',1.46),('8975','2013-05-26','19:15:00',1.27),('8975','2013-05-26','19:30:00',1.09),('8975','2013-05-26','19:35:00',1.01),('8975','2013-05-25','07:20:00',2.29),('8975','2013-05-25','07:25:00',1.35),('8975','2013-05-25','07:35:00',3.67),('8975','2013-05-25','07:40:00',3.79),('8975','2013-05-25','07:45:00',4),('8975','2013-05-25','07:50:00',4.54),('8975','2013-05-25','07:55:00',2.47),('8975','2013-05-25','08:00:00',1.41),('8975','2013-05-25','08:05:00',3.88),('8975','2013-05-25','08:10:00',4.98),('8975','2013-05-25','08:15:00',1.04),('8975','2013-05-25','08:20:00',1.31),('8975','2013-05-25','08:25:00',1.94),('8975','2013-05-25','08:30:00',6.1),('8975','2013-05-25','08:35:00',1.53),('8975','2013-05-25','08:40:00',1.05),('8975','2013-05-25','08:45:00',6.06),('8975','2013-05-25','08:50:00',3.97),('8975','2013-05-25','08:55:00',2.75),('8975','2013-05-25','09:00:00',3.22),('8975','2013-05-25','09:05:00',1.55),('8975','2013-05-25','09:10:00',1.91),('8975','2013-05-25','09:15:00',3.61),('8975','2013-05-25','09:20:00',5.93),('8975','2013-05-25','09:25:00',1.66),('8975','2013-05-25','09:30:00',1.19),('8975','2013-05-25','09:35:00',1.66),('8975','2013-05-25','09:40:00',3.98),('8975','2013-05-25','09:45:00',6.02),('8975','2013-05-25','09:50:00',1.34),('8975','2013-05-25','09:55:00',2.45),('8975','2013-05-25','10:00:00',3.14),('8975','2013-05-25','10:05:00',4.3),('8975','2013-05-25','10:10:00',7.27),('8975','2013-05-25','10:15:00',5.72),('8975','2013-05-25','10:20:00',5.69),('8975','2013-05-25','10:25:00',7.47),('8975','2013-05-25','10:30:00',7.26),('8975','2013-05-25','10:35:00',6.01),('8975','2013-05-25','10:40:00',7.06),('8975','2013-05-25','10:45:00',6.11),('8975','2013-05-25','10:50:00',7.54),('8975','2013-05-25','10:55:00',7.32),('8975','2013-05-25','11:00:00',7.45),('8975','2013-05-25','11:05:00',7.44),('8975','2013-05-25','11:10:00',7.47),('8975','2013-05-25','11:15:00',7.51),('8975','2013-05-25','11:20:00',7.58),('8975','2013-05-25','11:25:00',7.6),('8975','2013-05-25','11:30:00',7.8),('8975','2013-05-25','11:35:00',7.35),('8975','2013-05-25','11:40:00',7.53),('8975','2013-05-25','11:45:00',7.38),('8975','2013-05-25','11:50:00',7.7),('8975','2013-05-25','11:55:00',7.81),('8975','2013-05-25','12:00:00',7.45),('8975','2013-05-25','12:05:00',6.63),('8975','2013-05-25','12:10:00',8.53),('8975','2013-05-25','12:15:00',8.13),('8975','2013-05-25','12:20:00',8.01),('8975','2013-05-25','12:25:00',5.24),('8975','2013-05-25','12:30:00',7.95),('8975','2013-05-25','12:35:00',6.7),('8975','2013-05-25','12:40:00',6.53),('8975','2013-05-25','12:45:00',8.05),('8975','2013-05-25','12:50:00',7.82),('8975','2013-05-25','12:55:00',6.54),('8975','2013-05-25','13:00:00',7.73),('8975','2013-05-25','13:05:00',7.72),('8975','2013-05-25','13:10:00',7.45),('8975','2013-05-25','13:15:00',7.46),('8975','2013-05-25','13:20:00',5.95),('8975','2013-05-25','13:25:00',5.92),('8975','2013-05-25','13:30:00',7.11),('8975','2013-05-25','13:35:00',6.77),('8975','2013-05-25','13:40:00',7.4),('8975','2013-05-25','13:45:00',7.27),('8975','2013-05-25','13:50:00',7.18),('8975','2013-05-25','13:55:00',7.09),('8975','2013-05-25','14:00:00',7.13),('8975','2013-05-25','14:05:00',6.98),('8975','2013-05-25','14:10:00',6.89),('8975','2013-05-25','14:15:00',6.65),('8975','2013-05-25','14:20:00',6.79),('8975','2013-05-25','14:25:00',6.67),('8975','2013-05-25','14:30:00',6.62),('8975','2013-05-25','14:35:00',6.53),('8975','2013-05-25','14:40:00',6.43),('8975','2013-05-25','14:45:00',6.38),('8975','2013-05-25','14:50:00',6.31),('8975','2013-05-25','14:55:00',6.21),('8975','2013-05-25','15:00:00',6.12),('8975','2013-05-25','15:05:00',6.04),('8975','2013-05-25','15:10:00',5.94),('8975','2013-05-25','15:15:00',5.89),('8975','2013-05-25','15:20:00',5.78),('8975','2013-05-25','15:25:00',5.63),('8975','2013-05-25','15:30:00',5.57),('8975','2013-05-25','15:35:00',5.46),('8975','2013-05-25','15:40:00',5.36),('8975','2013-05-25','15:45:00',5.25),('8975','2013-05-25','15:50:00',5.13),('8975','2013-05-25','15:55:00',5.01),('8975','2013-05-25','16:00:00',4.91),('8975','2013-05-25','16:05:00',4.76),('8975','2013-05-25','16:10:00',4.5),('8975','2013-05-25','16:15:00',4.54),('8975','2013-05-25','16:20:00',4.38),('8975','2013-05-25','16:25:00',4.24),('8975','2013-05-25','16:30:00',4.13),('8975','2013-05-25','16:35:00',4.02),('8975','2013-05-25','16:40:00',3.85),('8975','2013-05-25','16:45:00',3.77),('8975','2013-05-25','16:50:00',3.64),('8975','2013-05-25','16:55:00',3.5),('8975','2013-05-25','17:00:00',3.36),('8975','2013-05-25','17:05:00',3.24),('8975','2013-05-25','17:10:00',3.09),('8975','2013-05-25','17:15:00',2.97),('8975','2013-05-25','17:20:00',2.84),('8975','2013-05-25','17:25:00',2.7),('8975','2013-05-25','17:30:00',2.58),('8975','2013-05-25','17:35:00',2.47),('8975','2013-05-25','17:40:00',2.33),('8975','2013-05-25','17:45:00',2.22),('8975','2013-05-25','17:50:00',2.1),('8975','2013-05-25','17:55:00',1.99),('8975','2013-05-25','18:00:00',1.89),('8975','2013-05-25','18:05:00',1.8),('8975','2013-05-25','18:10:00',1.71),('8975','2013-05-25','18:15:00',1.63),('8975','2013-05-25','18:20:00',1.58),('8975','2013-05-25','18:25:00',1.52),('8975','2013-05-25','18:30:00',1.47),('8975','2013-05-25','18:35:00',1.42),('8975','2013-05-25','18:40:00',1.37),('8975','2013-05-25','18:45:00',1.33),('8975','2013-05-25','18:50:00',1.27),('8975','2013-05-25','18:55:00',1.21),('8975','2013-05-25','19:00:00',1.17),('8975','2013-05-25','19:05:00',1.1),('8975','2013-05-25','19:10:00',1.05),('8975','2013-05-24','06:25:00',1.15),('8975','2013-05-24','06:35:00',1.47),('8975','2013-05-24','06:55:00',1.62),('8975','2013-05-24','07:10:00',1.75),('8975','2013-05-24','07:15:00',3.21),('8975','2013-05-24','07:20:00',2.5),('8975','2013-05-24','07:25:00',1.5),('8975','2013-05-24','07:30:00',3.57),('8975','2013-05-24','07:35:00',4.25),('8975','2013-05-24','07:40:00',2.94),('8975','2013-05-24','07:45:00',1.17),('8975','2013-05-24','07:50:00',1.28),('8975','2013-05-24','07:55:00',4.01),('8975','2013-05-24','08:00:00',4.51),('8975','2013-05-24','08:05:00',4.09),('8975','2013-05-24','08:10:00',2.4),('8975','2013-05-24','08:15:00',1.07),('8975','2013-05-24','08:20:00',3.33),('8975','2013-05-24','08:25:00',5.34),('8975','2013-05-24','08:30:00',5.2),('8975','2013-05-24','08:35:00',3.48),('8975','2013-05-24','08:40:00',3.45),('8975','2013-05-24','08:45:00',2.06),('8975','2013-05-24','08:50:00',3.46),('8975','2013-05-24','08:55:00',2.94),('8975','2013-05-24','09:00:00',2.85),('8975','2013-05-24','09:05:00',4.14),('8975','2013-05-24','09:10:00',5.88),('8975','2013-05-24','09:15:00',5.92),('8975','2013-05-24','09:20:00',2.51),('8975','2013-05-24','09:25:00',2.67),('8975','2013-05-24','09:30:00',1.5),('8975','2013-05-24','09:35:00',3.14),('8975','2013-05-24','09:40:00',6.76),('8975','2013-05-24','09:45:00',4.04),('8975','2013-05-24','09:50:00',4.63),('8975','2013-05-24','09:55:00',3.63),('8975','2013-05-24','10:00:00',1.83),('8975','2013-05-24','10:05:00',1.49),('8975','2013-05-24','10:10:00',1.92),('8975','2013-05-24','10:15:00',1.28),('8975','2013-05-24','10:25:00',2),('8975','2013-05-24','10:30:00',1.77),('8975','2013-05-24','10:35:00',2.03),('8975','2013-05-24','10:40:00',3.17),('8975','2013-05-24','10:45:00',2.4),('8975','2013-05-24','10:50:00',2.56),('8975','2013-05-24','10:55:00',1.74),('8975','2013-05-24','11:00:00',2.85),('8975','2013-05-24','11:05:00',3.09),('8975','2013-05-24','11:10:00',5.87),('8975','2013-05-24','11:15:00',5.11),('8975','2013-05-24','11:20:00',2.4),('8975','2013-05-24','11:25:00',1.46),('8975','2013-05-24','11:35:00',1.72),('8975','2013-05-24','11:40:00',2.24),('8975','2013-05-24','11:45:00',4.83),('8975','2013-05-24','11:50:00',4.14),('8975','2013-05-24','11:55:00',2.55),('8975','2013-05-24','12:00:00',1.78),('8975','2013-05-24','12:05:00',2.18),('8975','2013-05-24','12:10:00',2.21),('8975','2013-05-24','12:15:00',1.74),('8975','2013-05-24','12:20:00',2.18),('8975','2013-05-24','12:25:00',3.06),('8975','2013-05-24','12:30:00',2.22),('8975','2013-05-24','12:35:00',2.08),('8975','2013-05-24','12:40:00',2.7),('8975','2013-05-24','12:45:00',4.12),('8975','2013-05-24','12:50:00',5.53),('8975','2013-05-24','12:55:00',6.85),('8975','2013-05-24','13:00:00',4.27),('8975','2013-05-24','13:05:00',2.26),('8975','2013-05-24','13:10:00',3.26),('8975','2013-05-24','13:15:00',4),('8975','2013-05-24','13:20:00',2.42),('8975','2013-05-24','13:25:00',2.99),('8975','2013-05-24','13:30:00',2.35),('8975','2013-05-24','13:35:00',2.26),('8975','2013-05-24','13:40:00',3.35),('8975','2013-05-24','13:45:00',4.27),('8975','2013-05-24','13:50:00',7.78),('8975','2013-05-24','13:55:00',6.43),('8975','2013-05-24','14:00:00',5.94),('8975','2013-05-24','14:05:00',6.46),('8975','2013-05-24','14:10:00',7.62),('8975','2013-05-24','14:15:00',6.08),('8975','2013-05-24','14:20:00',6.21),('8975','2013-05-24','14:25:00',7.45),('8975','2013-05-24','14:30:00',5.48),('8975','2013-05-24','14:35:00',6.45),('8975','2013-05-24','14:40:00',2.34),('8975','2013-05-24','14:45:00',3.83),('8975','2013-05-24','14:50:00',6.3),('8975','2013-05-24','14:55:00',5.7),('8975','2013-05-24','15:00:00',3.53),('8975','2013-05-24','15:05:00',2.55),('8975','2013-05-24','15:10:00',2.54),('8975','2013-05-24','15:15:00',3.74),('8975','2013-05-24','15:20:00',4.68),('8975','2013-05-24','15:25:00',7.45),('8975','2013-05-24','15:30:00',2.5),('8975','2013-05-24','15:35:00',4.73),('8975','2013-05-24','15:40:00',4.71),('8975','2013-05-24','15:45:00',3),('8975','2013-05-24','15:50:00',1.89),('8975','2013-05-24','15:55:00',3.18),('8975','2013-05-24','16:00:00',5),('8975','2013-05-24','16:05:00',3.52),('8975','2013-05-24','16:10:00',3.68),('8975','2013-05-24','16:15:00',4.42),('8975','2013-05-24','16:20:00',5.5),('8975','2013-05-24','16:25:00',2.7),('8975','2013-05-24','16:30:00',3.25),('8975','2013-05-24','16:35:00',2.46),('8975','2013-05-24','16:40:00',1.61),('8975','2013-05-24','16:45:00',1.72),('8975','2013-05-24','16:50:00',4.56),('8975','2013-05-24','16:55:00',2.69),('8975','2013-05-24','17:00:00',3.3),('8975','2013-05-24','17:05:00',3.84),('8975','2013-05-24','17:10:00',3.47),('8975','2013-05-24','17:15:00',2.53),('8975','2013-05-24','17:20:00',2.79),('8975','2013-05-24','17:25:00',1.99),('8975','2013-05-24','17:30:00',2.14),('8975','2013-05-24','17:35:00',1.63),('8975','2013-05-24','17:40:00',2.57),('8975','2013-05-24','17:45:00',3.08),('8975','2013-05-24','17:50:00',1.72),('8975','2013-05-24','17:55:00',1.43),('8975','2013-05-24','18:00:00',2.47),('8975','2013-05-24','18:05:00',2.03),('8975','2013-05-24','18:10:00',1.86),('8975','2013-05-24','18:15:00',1.36),('8975','2013-05-24','18:20:00',1.26),('8975','2013-05-23','07:00:00',1.33),('8975','2013-05-23','07:05:00',1.68),('8975','2013-05-23','07:10:00',1.61),('8975','2013-05-23','08:00:00',2.67),('8975','2013-05-23','08:05:00',3.14),('8975','2013-05-23','08:10:00',4.67),('8975','2013-05-23','08:15:00',3.01),('8975','2013-05-23','08:25:00',1.14),('8975','2013-05-23','08:30:00',4.74),('8975','2013-05-23','08:35:00',4.39),('8975','2013-05-23','08:40:00',4.77),('8975','2013-05-23','08:45:00',4.68),('8975','2013-05-23','08:50:00',5.25),('8975','2013-05-23','08:55:00',5.42),('8975','2013-05-23','09:00:00',5.97),('8975','2013-05-23','09:05:00',3.65),('8975','2013-05-23','09:10:00',1.05),('8975','2013-05-23','09:15:00',1.76),('8975','2013-05-23','09:20:00',4.71),('8975','2013-05-23','09:25:00',6.87),('8975','2013-05-23','09:30:00',6.28),('8975','2013-05-23','09:35:00',2.19),('8975','2013-05-23','09:40:00',7.11),('8975','2013-05-23','09:45:00',3.44),('8975','2013-05-23','09:50:00',3.48),('8975','2013-05-23','09:55:00',6.94),('8975','2013-05-23','10:00:00',1.5),('8975','2013-05-23','10:05:00',2),('8975','2013-05-23','10:10:00',1.68),('8975','2013-05-23','10:15:00',1.07),('8975','2013-05-23','10:20:00',2.77),('8975','2013-05-23','10:25:00',4.7),('8975','2013-05-23','10:30:00',4.18),('8975','2013-05-23','10:35:00',7.16),('8975','2013-05-23','10:40:00',7.88),('8975','2013-05-23','10:45:00',6.71),('8975','2013-05-23','10:50:00',2.18),('8975','2013-05-23','10:55:00',6.61),('8975','2013-05-23','11:00:00',3.57),('8975','2013-05-23','11:05:00',6.55),('8975','2013-05-23','11:10:00',7.55),('8975','2013-05-23','11:15:00',7.67),('8975','2013-05-23','11:20:00',7.74),('8975','2013-05-23','11:25:00',5.94),('8975','2013-05-23','11:30:00',1.92),('8975','2013-05-23','11:35:00',1.61),('8975','2013-05-23','11:40:00',2.82),('8975','2013-05-23','11:45:00',7.9),('8975','2013-05-23','11:50:00',7.35),('8975','2013-05-23','11:55:00',8.11),('8975','2013-05-23','12:00:00',3.17),('8975','2013-05-23','12:05:00',6.12),('8975','2013-05-23','12:10:00',6.11),('8975','2013-05-23','12:15:00',3.12),('8975','2013-05-23','12:20:00',3.91),('8975','2013-05-23','12:25:00',7.09),('8975','2013-05-23','12:30:00',3.79),('8975','2013-05-23','12:35:00',4),('8975','2013-05-23','12:40:00',4.29),('8975','2013-05-23','12:45:00',4.48),('8975','2013-05-23','12:50:00',4.2),('8975','2013-05-23','12:55:00',4.14),('8975','2013-05-23','13:00:00',3.38),('8975','2013-05-23','13:05:00',4.32),('8975','2013-05-23','13:10:00',4.69),('8975','2013-05-23','13:15:00',4),('8975','2013-05-23','13:20:00',3.53),('8975','2013-05-23','13:25:00',5.61),('8975','2013-05-23','13:30:00',5.22),('8975','2013-05-23','13:35:00',7.78),('8975','2013-05-23','13:40:00',7.02),('8975','2013-05-23','13:45:00',2.7),('8975','2013-05-23','13:50:00',5.2),('8975','2013-05-23','13:55:00',7.4),('8975','2013-05-23','14:00:00',5.75),('8975','2013-05-23','14:05:00',3.25),('8975','2013-05-23','14:10:00',1.99),('8975','2013-05-23','14:15:00',4.27),('8975','2013-05-23','14:20:00',4.66),('8975','2013-05-23','14:25:00',4.77),('8975','2013-05-23','14:30:00',7.82),('8975','2013-05-23','14:35:00',6.72),('8975','2013-05-23','14:40:00',2.79),('8975','2013-05-23','14:45:00',2.37),('8975','2013-05-23','14:50:00',2.9),('8975','2013-05-23','14:55:00',3.41),('8975','2013-05-23','15:00:00',6.58),('8975','2013-05-23','15:05:00',3.27),('8975','2013-05-23','15:10:00',3.97),('8975','2013-05-23','15:15:00',7.28),('8975','2013-05-23','15:20:00',6.34),('8975','2013-05-23','15:25:00',7.22),('8975','2013-05-23','15:30:00',5.45),('8975','2013-05-23','15:35:00',3.96),('8975','2013-05-23','15:40:00',4.07),('8975','2013-05-23','15:45:00',5.06),('8975','2013-05-23','15:50:00',6.2),('8975','2013-05-23','15:55:00',4.7),('8975','2013-05-23','16:00:00',3.25),('8975','2013-05-23','16:05:00',3.56),('8975','2013-05-23','16:10:00',3.15),('8975','2013-05-23','16:15:00',3.15),('8975','2013-05-23','16:20:00',2.76),('8975','2013-05-23','16:25:00',3.85),('8975','2013-05-23','16:30:00',3.05),('8975','2013-05-23','16:35:00',1.73),('8975','2013-05-23','16:40:00',1.02),('8975','2013-05-23','16:50:00',1.83),('8975','2013-05-23','16:55:00',2.72),('8975','2013-05-23','17:00:00',1.88),('8975','2013-05-23','17:05:00',1.39),('8975','2013-05-23','17:10:00',1.03),('8975','2013-05-23','17:15:00',1.16),('8975','2013-05-23','17:20:00',1.39),('8975','2013-05-23','17:25:00',1.45),('8975','2013-05-23','17:30:00',1.74),('8975','2013-05-23','17:35:00',1.73),('8975','2013-05-23','17:40:00',1.41),('8975','2013-05-23','17:45:00',1.17),('8975','2013-05-23','18:05:00',1.02),('8975','2013-05-22','07:05:00',1.09),('8975','2013-05-22','07:10:00',1.89),('8975','2013-05-22','07:15:00',1.52),('8975','2013-05-22','07:45:00',1.23),('8975','2013-05-22','07:50:00',1.47),('8975','2013-05-22','07:55:00',1.6),('8975','2013-05-22','08:00:00',2.35),('8975','2013-05-22','08:05:00',2.56),('8975','2013-05-22','08:10:00',1.37),('8975','2013-05-22','08:25:00',2.33),('8975','2013-05-22','08:30:00',5.8),('8975','2013-05-22','08:35:00',1.79),('8975','2013-05-22','08:40:00',1.06),('8975','2013-05-22','08:45:00',1.3),('8975','2013-05-22','08:50:00',3.56),('8975','2013-05-22','08:55:00',3.49),('8975','2013-05-22','09:00:00',4.49),('8975','2013-05-22','09:05:00',3.73),('8975','2013-05-22','09:10:00',1.53),('8975','2013-05-22','09:15:00',1.94),('8975','2013-05-22','09:20:00',4.45),('8975','2013-05-22','09:25:00',2.47),('8975','2013-05-22','09:30:00',3.99),('8975','2013-05-22','09:35:00',5.99),('8975','2013-05-22','09:40:00',2.92),('8975','2013-05-22','09:45:00',5.11),('8975','2013-05-22','09:50:00',6.58),('8975','2013-05-22','09:55:00',4.69),('8975','2013-05-22','10:00:00',5.3),('8975','2013-05-22','10:05:00',3.95),('8975','2013-05-22','10:10:00',4.27),('8975','2013-05-22','10:15:00',2.48),('8975','2013-05-22','10:20:00',7.79),('8975','2013-05-22','10:25:00',7.58),('8975','2013-05-22','10:30:00',5.22),('8975','2013-05-22','10:35:00',5.84),('8975','2013-05-22','10:40:00',3.41),('8975','2013-05-22','10:45:00',5.45),('8975','2013-05-22','10:50:00',5.65),('8975','2013-05-22','10:55:00',8.09),('8975','2013-05-22','11:00:00',4.12),('8975','2013-05-22','11:05:00',8.2),('8975','2013-05-22','11:10:00',6.16),('8975','2013-05-22','11:15:00',2.84),('8975','2013-05-22','11:20:00',7.91),('8975','2013-05-22','11:25:00',7.17),('8975','2013-05-22','11:30:00',5.54),('8975','2013-05-22','11:35:00',5.27),('8975','2013-05-22','11:40:00',3.68),('8975','2013-05-22','11:45:00',6.75),('8975','2013-05-22','11:50:00',7.71),('8975','2013-05-22','11:55:00',7.36),('8975','2013-05-22','12:00:00',5.64),('8975','2013-05-22','12:05:00',8.03),('8975','2013-05-22','12:10:00',7.11),('8975','2013-05-22','12:15:00',3.46),('8975','2013-05-22','12:20:00',4.67),('8975','2013-05-22','12:25:00',7.12),('8975','2013-05-22','12:30:00',7.7),('8975','2013-05-22','12:35:00',1.93),('8975','2013-05-22','12:40:00',6.65),('8975','2013-05-22','12:45:00',6.53),('8975','2013-05-22','12:50:00',7.33),('8975','2013-05-22','12:55:00',6.18),('8975','2013-05-22','13:00:00',6.91),('8975','2013-05-22','13:05:00',7.58),('8975','2013-05-22','13:10:00',6.65),('8975','2013-05-22','13:15:00',5.59),('8975','2013-05-22','13:20:00',7.19),('8975','2013-05-22','13:25:00',5.46),('8975','2013-05-22','13:30:00',5.96),('8975','2013-05-22','13:35:00',3.93),('8975','2013-05-22','13:40:00',2.77),('8975','2013-05-22','13:45:00',6.95),('8975','2013-05-22','13:50:00',6.99),('8975','2013-05-22','13:55:00',4.36),('8975','2013-05-22','14:00:00',6.9),('8975','2013-05-22','14:05:00',5.95),('8975','2013-05-22','14:10:00',6.33),('8975','2013-05-22','14:15:00',5.94),('8975','2013-05-22','14:20:00',6),('8975','2013-05-22','14:25:00',5.03),('8975','2013-05-22','14:30:00',3.96),('8975','2013-05-22','14:35:00',7.06),('8975','2013-05-22','14:40:00',5.91),('8975','2013-05-22','14:45:00',4.75),('8975','2013-05-22','14:50:00',5.89),('8975','2013-05-22','14:55:00',3.64),('8975','2013-05-22','15:00:00',6.32),('8975','2013-05-22','15:05:00',4.73),('8975','2013-05-22','15:10:00',3.38),('8975','2013-05-22','15:15:00',3.27),('8975','2013-05-22','15:20:00',3.31),('8975','2013-05-22','15:25:00',1.7),('8975','2013-05-22','15:30:00',5.36),('8975','2013-05-22','15:35:00',3.48),('8975','2013-05-22','15:40:00',5.37),('8975','2013-05-22','15:45:00',1.84),('8975','2013-05-22','15:50:00',2.06),('8975','2013-05-22','15:55:00',2.2),('8975','2013-05-22','16:00:00',4.19),('8975','2013-05-22','16:05:00',2.66),('8975','2013-05-22','16:10:00',2.54),('8975','2013-05-22','16:15:00',3.13),('8975','2013-05-22','16:20:00',4.52),('8975','2013-05-22','16:25:00',4.27),('8975','2013-05-22','16:30:00',3.75),('8975','2013-05-22','16:35:00',2.21),('8975','2013-05-22','16:40:00',2.75),('8975','2013-05-22','16:45:00',1.38),('8975','2013-05-22','16:50:00',1.77),('8975','2013-05-22','16:55:00',1.93),('8975','2013-05-22','17:00:00',1.2),('8975','2013-05-22','17:05:00',2.75),('8975','2013-05-22','17:10:00',2.03),('8975','2013-05-22','17:15:00',2.5),('8975','2013-05-22','17:20:00',2.83),('8975','2013-05-22','17:25:00',1.44),('8975','2013-05-22','17:30:00',1.06),('8975','2013-05-22','17:35:00',2),('8975','2013-05-22','17:40:00',1.72),('8975','2013-05-22','17:45:00',1.78),('8975','2013-05-22','17:50:00',1.82),('8975','2013-05-22','17:55:00',1.8),('8975','2013-05-22','18:00:00',2.79),('8975','2013-05-22','18:05:00',2.89),('8975','2013-05-22','18:10:00',1.81),('8975','2013-05-22','18:45:00',1.38),('8975','2013-05-22','18:50:00',1.8),('8975','2013-05-22','18:55:00',1.46),('8975','2013-05-22','19:00:00',1.07),('8975','2013-05-21','07:20:00',1.03),('8975','2013-05-21','07:25:00',1.22),('8975','2013-05-21','07:30:00',1.09),('8975','2013-05-21','07:35:00',1.08),('8975','2013-05-21','07:40:00',1.26),('8975','2013-05-21','07:45:00',1.53),('8975','2013-05-21','07:50:00',2.66),('8975','2013-05-21','07:55:00',2.66),('8975','2013-05-21','08:00:00',3.19),('8975','2013-05-21','08:05:00',2.93),('8975','2013-05-21','08:10:00',3.18),('8975','2013-05-21','08:15:00',4.27),('8975','2013-05-21','08:20:00',4.21),('8975','2013-05-21','08:25:00',3.67),('8975','2013-05-21','08:30:00',4.47),('8975','2013-05-21','08:35:00',4.03),('8975','2013-05-21','08:40:00',2.66),('8975','2013-05-21','08:45:00',4.24),('8975','2013-05-21','08:50:00',2.07),('8975','2013-05-21','09:10:00',1.16),('8975','2013-05-21','09:15:00',1.5),('8975','2013-05-21','09:20:00',1.53),('8975','2013-05-21','09:25:00',3.09),('8975','2013-05-21','09:30:00',5.79),('8975','2013-05-21','09:35:00',5.69),('8975','2013-05-21','09:40:00',5.62),('8975','2013-05-21','09:45:00',5.66),('8975','2013-05-21','09:50:00',5.71),('8975','2013-05-21','09:55:00',5.78),('8975','2013-05-21','10:00:00',5.87),('8975','2013-05-21','10:05:00',5.98),('8975','2013-05-21','10:10:00',6.07),('8975','2013-05-21','10:15:00',6.12),('8975','2013-05-21','10:20:00',5.92),('8975','2013-05-21','10:25:00',6.35),('8975','2013-05-21','10:30:00',6.29),('8975','2013-05-21','10:35:00',6.37),('8975','2013-05-21','10:40:00',6.53),('8975','2013-05-21','10:45:00',6.55),('8975','2013-05-21','10:50:00',6.51),('8975','2013-05-21','10:55:00',6.58),('8975','2013-05-21','11:00:00',6.73),('8975','2013-05-21','11:05:00',6.86),('8975','2013-05-21','11:10:00',5.32),('8975','2013-05-21','11:15:00',7),('8975','2013-05-21','11:20:00',6.87),('8975','2013-05-21','11:25:00',6.63),('8975','2013-05-21','11:30:00',6.19),('8975','2013-05-21','11:35:00',5.59),('8975','2013-05-21','11:40:00',6.74),('8975','2013-05-21','11:45:00',6.66),('8975','2013-05-21','11:50:00',4.31),('8975','2013-05-21','11:55:00',4.64),('8975','2013-05-21','12:00:00',4.91),('8975','2013-05-21','12:05:00',3.7),('8975','2013-05-21','12:10:00',4.02),('8975','2013-05-21','12:15:00',6.28),('8975','2013-05-21','12:20:00',7.03),('8975','2013-05-21','12:25:00',4.64),('8975','2013-05-21','12:30:00',3.34),('8975','2013-05-21','12:35:00',4.06),('8975','2013-05-21','12:40:00',2.41),('8975','2013-05-21','12:45:00',1.06),('8975','2013-05-21','13:00:00',3.62),('8975','2013-05-21','13:05:00',5.17),('8975','2013-05-21','13:10:00',4.17),('8975','2013-05-21','13:15:00',4.66),('8975','2013-05-21','13:20:00',3.11),('8975','2013-05-21','13:25:00',2.07),('8975','2013-05-21','13:30:00',3.06),('8975','2013-05-21','13:35:00',6.84),('8975','2013-05-21','13:40:00',4.31),('8975','2013-05-21','13:45:00',3.38),('8975','2013-05-21','13:50:00',4.37),('8975','2013-05-21','13:55:00',3.19),('8975','2013-05-21','14:00:00',4.07),('8975','2013-05-21','14:05:00',5.9),('8975','2013-05-21','14:10:00',6.71),('8975','2013-05-21','14:15:00',6.4),('8975','2013-05-21','14:20:00',6.27),('8975','2013-05-21','14:25:00',6.14),('8975','2013-05-21','14:30:00',6.04),('8975','2013-05-21','14:35:00',5.96),('8975','2013-05-21','14:40:00',5.9),('8975','2013-05-21','14:45:00',5.8),('8975','2013-05-21','14:50:00',5.73),('8975','2013-05-21','14:55:00',5.62),('8975','2013-05-21','15:00:00',5.52),('8975','2013-05-21','15:05:00',5.41),('8975','2013-05-21','15:10:00',5.33),('8975','2013-05-21','15:15:00',5.27),('8975','2013-05-21','15:20:00',5.19),('8975','2013-05-21','15:25:00',4.98),('8975','2013-05-21','15:30:00',3.44),('8975','2013-05-21','15:35:00',5.32),('8975','2013-05-21','15:40:00',5.15),('8975','2013-05-21','15:45:00',4.17),('8975','2013-05-21','15:50:00',4.63),('8975','2013-05-21','15:55:00',4.49),('8975','2013-05-21','16:00:00',4.37),('8975','2013-05-21','16:05:00',4.24),('8975','2013-05-21','16:10:00',3.97),('8975','2013-05-21','16:15:00',4.04),('8975','2013-05-21','16:20:00',3.6),('8975','2013-05-21','16:25:00',2.94),('8975','2013-05-21','16:30:00',3.7),('8975','2013-05-21','16:35:00',3.58),('8975','2013-05-21','16:40:00',3.48),('8975','2013-05-21','16:45:00',2.92),('8975','2013-05-21','16:50:00',2.14),('8975','2013-05-21','16:55:00',1.27),('8975','2013-05-21','17:00:00',1.57),('8975','2013-05-21','17:05:00',1.58),('8975','2013-05-21','17:10:00',1.1),('8975','2013-05-21','17:15:00',1.56),('8975','2013-05-21','17:20:00',1.61),('8975','2013-05-21','17:25:00',1.83),('8975','2013-05-21','17:30:00',1.88),('8975','2013-05-21','17:35:00',2.35),('8975','2013-05-21','17:40:00',1.05),('8975','2013-05-21','17:50:00',1.48),('8975','2013-05-21','17:55:00',1.94),('8975','2013-05-21','18:00:00',1.83),('8975','2014-03-31','07:35:00',1.14),('8975','2014-03-31','07:40:00',1.32),('8975','2014-03-31','07:45:00',1.46),('8975','2014-03-31','07:50:00',1.82),('8975','2014-03-31','07:55:00',2.02),('8975','2014-03-31','08:00:00',2.18),('8975','2014-03-31','08:05:00',2.41),('8975','2014-03-31','08:10:00',2.58),('8975','2014-03-31','08:15:00',2.7),('8975','2014-03-31','08:20:00',2.83),('8975','2014-03-31','08:25:00',2.98),('8975','2014-03-31','08:30:00',3.11),('8975','2014-03-31','08:35:00',3.18),('8975','2014-03-31','08:40:00',3.31),('8975','2014-03-31','08:45:00',3.42),('8975','2014-03-31','08:50:00',3.52),('8975','2014-03-31','08:55:00',3.63),('8975','2014-03-31','09:00:00',3.73),('8975','2014-03-31','09:05:00',3.81),('8975','2014-03-31','09:10:00',3.94),('8975','2014-03-31','09:15:00',3.96),('8975','2014-03-31','09:20:00',4.08),('8975','2014-03-31','09:25:00',4.26),('8975','2014-03-31','09:30:00',4.39),('8975','2014-03-31','09:35:00',4.44),('8975','2014-03-31','09:40:00',4.57),('8975','2014-03-31','09:45:00',4.66),('8975','2014-03-31','09:50:00',4.75),('8975','2014-03-31','09:55:00',4.86),('8975','2014-03-31','10:00:00',3.9),('8975','2014-03-31','10:05:00',3.95),('8975','2014-03-31','10:10:00',5.08),('8975','2014-03-31','10:15:00',5.24),('8975','2014-03-31','10:20:00',5.47),('8975','2014-03-31','10:25:00',2.47),('8975','2014-03-31','10:30:00',2.16),('8975','2014-03-31','10:35:00',2.78),('8975','2014-03-31','10:40:00',5.91),('8975','2014-03-31','10:45:00',5.94),('8975','2014-03-31','10:50:00',5.84),('8975','2014-03-31','10:55:00',5.85),('8975','2014-03-31','11:00:00',5.77),('8975','2014-03-31','11:05:00',5.85),('8975','2014-03-31','11:10:00',5.88),('8975','2014-03-31','11:15:00',5.93),('8975','2014-03-31','11:20:00',5.92),('8975','2014-03-31','11:25:00',6.02),('8975','2014-03-31','11:30:00',6.08),('8975','2014-03-31','11:35:00',6.13),('8975','2014-03-31','11:40:00',6.11),('8975','2014-03-31','11:45:00',6.1),('8975','2014-03-31','11:50:00',6.13),('8975','2014-03-31','11:55:00',6.21),('8975','2014-03-31','12:00:00',6.23),('8975','2014-03-31','12:05:00',6.19),('8975','2014-03-31','12:10:00',6.25),('8975','2014-03-31','12:15:00',6.23),('8975','2014-03-31','12:20:00',6.3),('8975','2014-03-31','12:25:00',6.32),('8975','2014-03-31','12:30:00',6.36),('8975','2014-03-31','12:35:00',6.33),('8975','2014-03-31','12:40:00',6.36),('8975','2014-03-31','12:45:00',6.38),('8975','2014-03-31','12:50:00',6.3),('8975','2014-03-31','12:55:00',6.25),('8975','2014-03-31','13:00:00',6.42),('8975','2014-03-31','13:05:00',6.3),('8975','2014-03-31','13:10:00',6.21),('8975','2014-03-31','13:15:00',5.73),('8975','2014-03-31','13:20:00',6.09),('8975','2014-03-31','13:25:00',5.89),('8975','2014-03-31','13:30:00',5.07),('8975','2014-03-31','13:35:00',5.16),('8975','2014-03-31','13:40:00',5.35),('8975','2014-03-31','13:45:00',4.98),('8975','2014-03-31','13:50:00',5.83),('8975','2014-03-31','13:55:00',5.9),('8975','2014-03-31','14:00:00',4.94),('8975','2014-03-31','14:05:00',5.77),('8975','2014-03-31','14:10:00',5.21),('8975','2014-03-31','14:15:00',3.87),('8975','2014-03-31','14:20:00',5.61),('8975','2014-03-31','14:25:00',4.51),('8975','2014-03-31','14:30:00',4.22),('8975','2014-03-31','14:35:00',4.59),('8975','2014-03-31','14:40:00',4.77),('8975','2014-03-31','14:45:00',5.31),('8975','2014-03-31','14:50:00',5.21),('8975','2014-03-31','14:55:00',5.15),('8975','2014-03-31','15:00:00',4.3),('8975','2014-03-31','15:05:00',4.88),('8975','2014-03-31','15:10:00',2.78),('8975','2014-03-31','15:15:00',4.91),('8975','2014-03-31','15:20:00',4.65),('8975','2014-03-31','15:25:00',4.31),('8975','2014-03-31','15:30:00',4.41),('8975','2014-03-31','15:35:00',4.23),('8975','2014-03-31','15:40:00',4.05),('8975','2014-03-31','15:45:00',3.99),('8975','2014-03-31','15:50:00',3.91),('8975','2014-03-31','15:55:00',3.67),('8975','2014-03-31','16:00:00',2.81),('8975','2014-03-31','16:05:00',3.7),('8975','2014-03-31','16:10:00',3.32),('8975','2014-03-31','16:15:00',3.34),('8975','2014-03-31','16:20:00',3.2),('8975','2014-03-31','16:25:00',3),('8975','2014-03-31','16:30:00',2.7),('8975','2014-03-31','16:35:00',2.73),('8975','2014-03-31','16:40:00',2.28),('8975','2014-03-31','16:45:00',2.32),('8975','2014-03-31','16:50:00',1.4),('8975','2014-03-31','16:55:00',2.16),('8975','2014-03-31','17:00:00',1.89),('8975','2014-03-31','17:05:00',1.59),('8975','2014-03-31','17:10:00',1.87),('8975','2014-03-31','17:15:00',1.82),('8975','2014-03-31','17:20:00',1.63),('8975','2014-03-31','17:25:00',1.36),('8975','2014-03-31','17:30:00',1.19),('8975','2014-03-31','17:35:00',1.42),('8975','2014-03-31','17:40:00',1.27),('8975','2014-03-31','17:45:00',1.34),('8975','2014-03-31','17:50:00',1.36),('8975','2014-03-31','17:55:00',1.32),('8975','2014-03-31','18:00:00',1.29),('8975','2014-03-31','18:05:00',1.25),('8975','2014-03-31','18:10:00',1.09),('8975','2014-03-31','18:15:00',1.09),('8975','2013-05-20','06:30:00',1.01),('8975','2013-05-20','06:35:00',1.19),('8975','2013-05-20','06:40:00',1.37),('8975','2013-05-20','06:45:00',1.55),('8975','2013-05-20','06:50:00',1.71),('8975','2013-05-20','06:55:00',1.88),('8975','2013-05-20','07:00:00',1.99),('8975','2013-05-20','07:05:00',2.16),('8975','2013-05-20','07:10:00',2.35),('8975','2013-05-20','07:15:00',2.49),('8975','2013-05-20','07:20:00',2.65),('8975','2013-05-20','07:25:00',2.81),('8975','2013-05-20','07:30:00',3.09),('8975','2013-05-20','07:35:00',3.54),('8975','2013-05-20','07:40:00',3.77),('8975','2013-05-20','07:45:00',3.16),('8975','2013-05-20','07:50:00',2.32),('8975','2013-05-20','07:55:00',2.01),('8975','2013-05-20','08:00:00',2.96),('8975','2013-05-20','08:05:00',2.45),('8975','2013-05-20','08:10:00',2.59),('8975','2013-05-20','08:15:00',3.38),('8975','2013-05-20','08:20:00',3.63),('8975','2013-05-20','08:25:00',3.75),('8975','2013-05-20','08:30:00',2.47),('8975','2013-05-20','08:35:00',2.38),('8975','2013-05-20','08:40:00',2.82),('8975','2013-05-20','08:45:00',2.24),('8975','2013-05-20','08:50:00',2.62),('8975','2013-05-20','08:55:00',3.46),('8975','2013-05-20','09:00:00',2.84),('8975','2013-05-20','09:05:00',2.52),('8975','2013-05-20','09:10:00',2.72),('8975','2013-05-20','09:15:00',3.43),('8975','2013-05-20','09:20:00',5.1),('8975','2013-05-20','09:25:00',4),('8975','2013-05-20','09:30:00',3.48),('8975','2013-05-20','09:35:00',4.18),('8975','2013-05-20','09:40:00',3.26),('8975','2013-05-20','09:45:00',2.82),('8975','2013-05-20','09:50:00',2.78),('8975','2013-05-20','09:55:00',3.05),('8975','2013-05-20','10:00:00',3.47),('8975','2013-05-20','10:05:00',4.12),('8975','2013-05-20','10:10:00',3.89),('8975','2013-05-20','10:15:00',4.06),('8975','2013-05-20','10:20:00',3.49),('8975','2013-05-20','10:25:00',3.02),('8975','2013-05-20','10:30:00',2.99),('8975','2013-05-20','10:35:00',3.24),('8975','2013-05-20','10:40:00',4.55),('8975','2013-05-20','10:45:00',4.32),('8975','2013-05-20','10:50:00',3.09),('8975','2013-05-20','10:55:00',2.74),('8975','2013-05-20','11:00:00',3.39),('8975','2013-05-20','11:05:00',3.71),('8975','2013-05-20','11:10:00',5.89),('8975','2013-05-20','11:15:00',5.17),('8975','2013-05-20','11:20:00',5.83),('8975','2013-05-20','11:25:00',5.87),('8975','2013-05-20','11:30:00',4.52),('8975','2013-05-20','11:35:00',4.7),('8975','2013-05-20','11:40:00',5.23),('8975','2013-05-20','11:45:00',4.29),('8975','2013-05-20','11:50:00',5.1),('8975','2013-05-20','11:55:00',7.06),('8975','2013-05-20','12:00:00',7.34),('8975','2013-05-20','12:05:00',5.8),('8975','2013-05-20','12:10:00',4.79),('8975','2013-05-20','12:15:00',5.06),('8975','2013-05-20','12:20:00',3.81),('8975','2013-05-20','12:25:00',6.09),('8975','2013-05-20','12:30:00',4.58),('8975','2013-05-20','12:35:00',5.75),('8975','2013-05-20','12:40:00',7.4),('8975','2013-05-20','12:45:00',5.93),('8975','2013-05-20','12:50:00',3.3),('8975','2013-05-20','12:55:00',7.32),('8975','2013-05-20','13:00:00',6.96),('8975','2013-05-20','13:05:00',5.63),('8975','2013-05-20','13:10:00',6.04),('8975','2013-05-20','13:15:00',6.89),('8975','2013-05-20','13:20:00',4.24),('8975','2013-05-20','13:25:00',4.97),('8975','2013-05-20','13:30:00',4.37),('8975','2013-05-20','13:35:00',2.24),('8975','2013-05-20','13:40:00',1.35),('8975','2013-05-20','14:00:00',1.2),('8975','2013-05-20','14:05:00',1.88),('8975','2013-05-20','14:10:00',2.9),('8975','2013-05-20','14:15:00',3.11),('8975','2013-05-20','14:20:00',2.82),('8975','2013-05-20','14:25:00',4.45),('8975','2013-05-20','14:30:00',3.64),('8975','2013-05-20','14:35:00',3.45),('8975','2013-05-20','14:40:00',3.23),('8975','2013-05-20','14:45:00',2.44),('8975','2013-05-20','14:50:00',1.72),('8975','2013-05-20','14:55:00',1.21),('8975','2013-05-20','15:10:00',1.15),('8975','2013-05-20','15:15:00',1.87),('8975','2013-05-20','15:20:00',2.44),('8975','2013-05-20','15:25:00',2.55),('8975','2013-05-20','15:30:00',3.47),('8975','2013-05-20','15:35:00',2.85),('8975','2013-05-20','15:40:00',2.27),('8975','2013-05-20','15:45:00',2.17),('8975','2013-05-20','15:50:00',1.94),('8975','2013-05-20','15:55:00',1.96),('8975','2013-05-20','16:00:00',2.02),('8975','2013-05-20','16:05:00',1.97),('8975','2013-05-20','16:10:00',2.04),('8975','2013-05-20','16:15:00',1.87),('8975','2013-05-20','16:20:00',1.57),('8975','2013-05-20','16:25:00',2.28),('8975','2013-05-20','16:30:00',2.47),('8975','2013-05-20','16:35:00',2.61),('8975','2013-05-20','16:40:00',2.88),('8975','2013-05-20','16:45:00',2.41),('8975','2013-05-20','16:50:00',1.7),('8975','2013-05-20','17:00:00',1.02),('8975','2013-05-20','17:05:00',1.11),('8975','2013-05-19','06:25:00',1.07),('8975','2013-05-19','06:40:00',1.29),('8975','2013-05-19','06:45:00',1.89),('8975','2013-05-19','06:50:00',2.12),('8975','2013-05-19','06:55:00',2.28),('8975','2013-05-19','07:00:00',2.54),('8975','2013-05-19','07:05:00',2.4),('8975','2013-05-19','07:10:00',2.6),('8975','2013-05-19','07:15:00',2.79),('8975','2013-05-19','07:20:00',2.87),('8975','2013-05-19','07:25:00',2.75),('8975','2013-05-19','07:30:00',3.14),('8975','2013-05-19','07:35:00',3.29),('8975','2013-05-19','07:40:00',3.37),('8975','2013-05-19','07:45:00',3.45),('8975','2013-05-19','07:50:00',3.56),('8975','2013-05-19','07:55:00',3.69),('8975','2013-05-19','08:00:00',3.88),('8975','2013-05-19','08:05:00',3.79),('8975','2013-05-19','08:10:00',4.06),('8975','2013-05-19','08:15:00',2.06),('8975','2013-05-19','08:20:00',3.41),('8975','2013-05-19','08:25:00',3.61),('8975','2013-05-19','08:30:00',1.38),('8975','2013-05-19','08:35:00',3.68),('8975','2013-05-19','08:40:00',4.35),('8975','2013-05-19','08:45:00',5.65),('8975','2013-05-19','08:50:00',5.6),('8975','2013-05-19','08:55:00',5.48),('8975','2013-05-19','09:00:00',5.72),('8975','2013-05-19','09:05:00',6.15),('8975','2013-05-19','09:10:00',5.79),('8975','2013-05-19','09:15:00',2.24),('8975','2013-05-19','09:20:00',1.81),('8975','2013-05-19','09:25:00',3.13),('8975','2013-05-19','09:30:00',4.34),('8975','2013-05-19','09:35:00',1.97),('8975','2013-05-19','09:40:00',1),('8975','2013-05-19','09:45:00',4.6),('8975','2013-05-19','09:50:00',2.02),('8975','2013-05-19','09:55:00',4.58),('8975','2013-05-19','10:00:00',2.4),('8975','2013-05-19','10:05:00',3.79),('8975','2013-05-19','10:10:00',6.31),('8975','2013-05-19','10:15:00',2.11),('8975','2013-05-19','10:20:00',4.06),('8975','2013-05-19','10:25:00',1.45),('8975','2013-05-19','10:30:00',2.78),('8975','2013-05-19','10:35:00',5.56),('8975','2013-05-19','10:40:00',5.25),('8975','2013-05-19','10:45:00',4.48),('8975','2013-05-19','10:50:00',3.85),('8975','2013-05-19','10:55:00',6.97),('8975','2013-05-19','11:00:00',4.19),('8975','2013-05-19','11:05:00',7.66),('8975','2013-05-19','11:10:00',5.63),('8975','2013-05-19','11:15:00',5.99),('8975','2013-05-19','11:20:00',7.61),('8975','2013-05-19','11:25:00',1.56),('8975','2013-05-19','11:30:00',4.15),('8975','2013-05-19','11:35:00',2.89),('8975','2013-05-19','11:40:00',4.17),('8975','2013-05-19','11:45:00',1.88),('8975','2013-05-19','11:50:00',5.66),('8975','2013-05-19','11:55:00',5.21),('8975','2013-05-19','12:00:00',2.96),('8975','2013-05-19','12:05:00',8.65),('8975','2013-05-19','12:10:00',4.33),('8975','2013-05-19','12:15:00',4.74),('8975','2013-05-19','12:20:00',8.06),('8975','2013-05-19','12:25:00',3.3),('8975','2013-05-19','12:30:00',4.11),('8975','2013-05-19','12:35:00',6.74),('8975','2013-05-19','12:40:00',2.46),('8975','2013-05-19','12:45:00',7.05),('8975','2013-05-19','12:50:00',7.4),('8975','2013-05-19','12:55:00',4.59),('8975','2013-05-19','13:00:00',2.84),('8975','2013-05-19','13:05:00',2.48),('8975','2013-05-19','13:10:00',2.07),('8975','2013-05-19','13:15:00',2.41),('8975','2013-05-19','13:20:00',2.76),('8975','2013-05-19','13:25:00',7.54),('8975','2013-05-19','13:30:00',5.46),('8975','2013-05-19','13:35:00',6.27),('8975','2013-05-19','13:40:00',4.35),('8975','2013-05-19','13:45:00',6.67),('8975','2013-05-19','13:50:00',7.55),('8975','2013-05-19','13:55:00',5.8),('8975','2013-05-19','14:00:00',5.05),('8975','2013-05-19','14:05:00',2.12),('8975','2013-05-19','14:10:00',6.23),('8975','2013-05-19','14:15:00',3.89),('8975','2013-05-19','14:20:00',1.72),('8975','2013-05-19','14:25:00',4.06),('8975','2013-05-19','14:30:00',7.3),('8975','2013-05-19','14:35:00',1.95),('8975','2013-05-19','14:40:00',5.48),('8975','2013-05-19','14:45:00',2.77),('8975','2013-05-19','14:50:00',4.36),('8975','2013-05-19','14:55:00',6.13),('8975','2013-05-19','15:00:00',3.17),('8975','2013-05-19','15:05:00',6.76),('8975','2013-05-19','15:10:00',5.98),('8975','2013-05-19','15:15:00',5.16),('8975','2013-05-19','15:20:00',2.67),('8975','2013-05-19','15:25:00',1.72),('8975','2013-05-19','15:30:00',5.67),('8975','2013-05-19','15:35:00',3.46),('8975','2013-05-19','15:40:00',5.89),('8975','2013-05-19','15:45:00',5.79),('8975','2013-05-19','15:50:00',3.18),('8975','2013-05-19','15:55:00',4.58),('8975','2013-05-19','16:00:00',1.97),('8975','2013-05-19','16:05:00',2.33),('8975','2013-05-19','16:10:00',3.88),('8975','2013-05-19','16:15:00',2.47),('8975','2013-05-19','16:20:00',4.7),('8975','2013-05-19','16:25:00',4.57),('8975','2013-05-19','16:30:00',4.42),('8975','2013-05-19','16:35:00',4.26),('8975','2013-05-19','16:40:00',4.16),('8975','2013-05-19','16:45:00',3.69),('8975','2013-05-19','16:50:00',3.55),('8975','2013-05-19','16:55:00',3.25),('8975','2013-05-19','17:00:00',3.28),('8975','2013-05-19','17:05:00',3.13),('8975','2013-05-19','17:10:00',2.55),('8975','2013-05-19','17:15:00',1.64),('8975','2013-05-19','17:20:00',2.06),('8975','2013-05-19','17:25:00',2.68),('8975','2013-05-19','17:30:00',3.12),('8975','2013-05-19','17:35:00',2.45),('8975','2013-05-19','17:40:00',2.23),('8975','2013-05-19','17:45:00',2.1),('8975','2013-05-19','17:50:00',1.99),('8975','2013-05-19','17:55:00',1.88),('8975','2013-05-19','18:00:00',1.77),('8975','2013-05-19','18:05:00',2.11),('8975','2013-05-19','18:10:00',2.07),('8975','2013-05-19','18:15:00',1.98),('8975','2013-05-19','18:20:00',1.66),('8975','2013-05-19','18:25:00',1.49),('8975','2013-05-19','18:30:00',1.39),('8975','2013-05-19','18:35:00',1.32),('8975','2013-05-19','18:40:00',1.08),('8975','2013-05-19','18:45:00',1.21),('8975','2013-05-19','18:50:00',1.14),('8975','2013-05-19','18:55:00',1.07),('8975','2013-05-19','19:00:00',1.03),('8975','2013-05-18','08:00:00',1.03),('8975','2013-05-18','08:10:00',1.04),('8975','2013-05-18','08:15:00',1.09),('8975','2013-05-18','08:20:00',1.04),('8975','2013-05-18','08:25:00',1.13),('8975','2013-05-18','08:30:00',1.77),('8975','2013-05-18','08:35:00',2.09),('8975','2013-05-18','08:40:00',1.52),('8975','2013-05-18','08:45:00',1.79),('8975','2013-05-18','08:50:00',2.48),('8975','2013-05-18','08:55:00',2.29),('8975','2013-05-18','09:00:00',2.19),('8975','2013-05-18','09:05:00',2.05),('8975','2013-05-18','09:10:00',2.36),('8975','2013-05-18','09:15:00',2.69),('8975','2013-05-18','09:20:00',1.42),('8975','2013-05-18','09:30:00',1.25),('8975','2013-05-18','09:35:00',1.2),('8975','2013-05-18','09:40:00',1.61),('8975','2013-05-18','09:45:00',1.97),('8975','2013-05-18','09:50:00',1.96),('8975','2013-05-18','09:55:00',2.26),('8975','2013-05-18','10:00:00',3.09),('8975','2013-05-18','10:05:00',3.92),('8975','2013-05-18','10:10:00',4.9),('8975','2013-05-18','10:15:00',4.87),('8975','2013-05-18','10:20:00',5.05),('8975','2013-05-18','10:25:00',6.29),('8975','2013-05-18','10:30:00',7.7),('8975','2013-05-18','10:35:00',7.48),('8975','2013-05-18','10:40:00',7.54),('8975','2013-05-18','10:45:00',7.48),('8975','2013-05-18','10:50:00',7.35),('8975','2013-05-18','10:55:00',7.12),('8975','2013-05-18','11:00:00',7.12),('8975','2013-05-18','11:05:00',6.86),('8975','2013-05-18','11:10:00',6.83),('8975','2013-05-18','11:15:00',7.29),('8975','2013-05-18','11:20:00',7.17),('8975','2013-05-18','11:25:00',7.37),('8975','2013-05-18','11:30:00',7.41),('8975','2013-05-18','11:35:00',7.39),('8975','2013-05-18','11:40:00',7.53),('8975','2013-05-18','11:45:00',7.62),('8975','2013-05-18','11:50:00',7.57),('8975','2013-05-18','11:55:00',8.03),('8975','2013-05-18','12:00:00',7.81),('8975','2013-05-18','12:05:00',7.2),('8975','2013-05-18','12:10:00',5.81),('8975','2013-05-18','12:15:00',6.52),('8975','2013-05-18','12:20:00',4.58),('8975','2013-05-18','12:25:00',3.9),('8975','2013-05-18','12:30:00',4.11),('8975','2013-05-18','12:35:00',5.62),('8975','2013-05-18','12:40:00',6.86),('8975','2013-05-18','12:45:00',5.34),('8975','2013-05-18','12:50:00',4.36),('8975','2013-05-18','12:55:00',3.78),('8975','2013-05-18','13:00:00',5.04),('8975','2013-05-18','13:05:00',5.96),('8975','2013-05-18','13:10:00',5.3),('8975','2013-05-18','13:15:00',6.31),('8975','2013-05-18','13:20:00',5.91),('8975','2013-05-18','13:25:00',7.14),('8975','2013-05-18','13:30:00',7.03),('8975','2013-05-18','13:35:00',7),('8975','2013-05-18','13:40:00',6.93),('8975','2013-05-18','13:45:00',6.83),('8975','2013-05-18','13:50:00',6.82),('8975','2013-05-18','13:55:00',6.77),('8975','2013-05-18','14:00:00',6.7),('8975','2013-05-18','14:05:00',6.63),('8975','2013-05-18','14:10:00',6.62),('8975','2013-05-18','14:15:00',6.59),('8975','2013-05-18','14:20:00',6.53),('8975','2013-05-18','14:25:00',6.46),('8975','2013-05-18','14:30:00',6.4),('8975','2013-05-18','14:35:00',6.35),('8975','2013-05-18','14:40:00',6.27),('8975','2013-05-18','14:45:00',6.15),('8975','2013-05-18','14:50:00',6.09),('8975','2013-05-18','14:55:00',5.98),('8975','2013-05-18','15:00:00',5.93),('8975','2013-05-18','15:05:00',5.84),('8975','2013-05-18','15:10:00',5.69),('8975','2013-05-18','15:15:00',5.62),('8975','2013-05-18','15:20:00',5.56),('8975','2013-05-18','15:25:00',5.42),('8975','2013-05-18','15:30:00',5.31),('8975','2013-05-18','15:35:00',5.24),('8975','2013-05-18','15:40:00',5.14),('8975','2013-05-18','15:45:00',4.67),('8975','2013-05-18','15:50:00',4.43),('8975','2013-05-18','15:55:00',3.78),('8975','2013-05-18','16:00:00',3.61),('8975','2013-05-18','16:05:00',4.37),('8975','2013-05-18','16:10:00',4.12),('8975','2013-05-18','16:15:00',4.17),('8975','2013-05-18','16:20:00',4.15),('8975','2013-05-18','16:25:00',3.72),('8975','2013-05-18','16:30:00',3.96),('8975','2013-05-18','16:35:00',3.69),('8975','2013-05-18','16:40:00',3.51),('8975','2013-05-18','16:45:00',3.42),('8975','2013-05-18','16:50:00',3.16),('8975','2013-05-18','16:55:00',3.29),('8975','2013-05-18','17:00:00',3.2),('8975','2013-05-18','17:05:00',3.09),('8975','2013-05-18','17:10:00',2.95),('8975','2013-05-18','17:15:00',2.82),('8975','2013-05-18','17:20:00',2.71),('8975','2013-05-18','17:25:00',2.57),('8975','2013-05-18','17:30:00',2.45),('8975','2013-05-18','17:35:00',2.34),('8975','2013-05-18','17:40:00',2.22),('8975','2013-05-18','17:45:00',2.1),('8975','2013-05-18','17:50:00',1.99),('8975','2013-05-18','17:55:00',1.89),('8975','2013-05-18','18:00:00',1.81),('8975','2013-05-18','18:05:00',1.72),('8975','2013-05-18','18:10:00',1.65),('8975','2013-05-18','18:15:00',1.58),('8975','2013-05-18','18:20:00',1.51),('8975','2013-05-18','18:25:00',1.48),('8975','2013-05-18','18:30:00',1.43),('8975','2013-05-18','18:35:00',1.39),('8975','2013-05-18','18:40:00',1.34),('8975','2013-05-18','18:45:00',1.29),('8975','2013-05-18','18:50:00',1.23),('8975','2013-05-18','18:55:00',1.18),('8975','2013-05-18','19:00:00',1.13),('8975','2013-05-18','19:05:00',1.06),('8975','2013-05-18','19:10:00',1.01),('8975','2013-05-17','06:25:00',1.04),('8975','2013-05-17','06:30:00',1.23),('8975','2013-05-17','06:35:00',1.4),('8975','2013-05-17','06:40:00',1.62),('8975','2013-05-17','06:45:00',1.79),('8975','2013-05-17','06:50:00',1.94),('8975','2013-05-17','06:55:00',2.11),('8975','2013-05-17','07:00:00',2.26),('8975','2013-05-17','07:05:00',2.39),('8975','2013-05-17','07:10:00',2.54),('8975','2013-05-17','07:15:00',2.68),('8975','2013-05-17','07:20:00',2.81),('8975','2013-05-17','07:25:00',2.94),('8975','2013-05-17','07:30:00',3.08),('8975','2013-05-17','07:35:00',3.19),('8975','2013-05-17','07:40:00',3.46),('8975','2013-05-17','07:45:00',2.41),('8975','2013-05-17','07:50:00',3.96),('8975','2013-05-17','07:55:00',4.5),('8975','2013-05-17','08:00:00',4.51),('8975','2013-05-17','08:05:00',3.66),('8975','2013-05-17','08:10:00',1.84),('8975','2013-05-17','08:15:00',1.8),('8975','2013-05-17','08:20:00',3.12),('8975','2013-05-17','08:25:00',4.64),('8975','2013-05-17','08:30:00',3.98),('8975','2013-05-17','08:35:00',4.25),('8975','2013-05-17','08:40:00',4.9),('8975','2013-05-17','08:45:00',4.81),('8975','2013-05-17','08:50:00',4.91),('8975','2013-05-17','08:55:00',5.01),('8975','2013-05-17','09:00:00',5.1),('8975','2013-05-17','09:05:00',5.19),('8975','2013-05-17','09:10:00',5.38),('8975','2013-05-17','09:15:00',5.42),('8975','2013-05-17','09:20:00',5.49),('8975','2013-05-17','09:25:00',5.56),('8975','2013-05-17','09:30:00',5.62),('8975','2013-05-17','09:35:00',5.69),('8975','2013-05-17','09:40:00',5.76),('8975','2013-05-17','09:45:00',5.83),('8975','2013-05-17','09:50:00',5.9),('8975','2013-05-17','09:55:00',5.99),('8975','2013-05-17','10:00:00',6.03),('8975','2013-05-17','10:05:00',6.08),('8975','2013-05-17','10:10:00',6.19),('8975','2013-05-17','10:15:00',6.22),('8975','2013-05-17','10:20:00',6.31),('8975','2013-05-17','10:25:00',6.35),('8975','2013-05-17','10:30:00',6.37),('8975','2013-05-17','10:35:00',6.36),('8975','2013-05-17','10:40:00',6.43),('8975','2013-05-17','10:45:00',6.48),('8975','2013-05-17','10:50:00',6.54),('8975','2013-05-17','10:55:00',6.72),('8975','2013-05-17','11:00:00',7.09),('8975','2013-05-17','11:05:00',5.21),('8975','2013-05-17','11:10:00',6.01),('8975','2013-05-17','11:15:00',5.86),('8975','2013-05-17','11:20:00',7.1),('8975','2013-05-17','11:25:00',7.06),('8975','2013-05-17','11:30:00',6.57),('8975','2013-05-17','11:35:00',7.03),('8975','2013-05-17','11:40:00',6.87),('8975','2013-05-17','11:45:00',6.4),('8975','2013-05-17','11:50:00',6.99),('8975','2013-05-17','11:55:00',6.52),('8975','2013-05-17','12:00:00',6.51),('8975','2013-05-17','12:05:00',6.78),('8975','2013-05-17','12:10:00',6.65),('8975','2013-05-17','12:15:00',6.72),('8975','2013-05-17','12:20:00',6.78),('8975','2013-05-17','12:25:00',6.58),('8975','2013-05-17','12:30:00',5.09),('8975','2013-05-17','12:35:00',6.84),('8975','2013-05-17','12:40:00',6.59),('8975','2013-05-17','12:45:00',6.15),('8975','2013-05-17','12:50:00',6.68),('8975','2013-05-17','12:55:00',6.63),('8975','2013-05-17','13:00:00',6.6),('8975','2013-05-17','13:05:00',6.62),('8975','2013-05-17','13:10:00',6.57),('8975','2013-05-17','13:15:00',6.51),('8975','2013-05-17','13:20:00',6.49),('8975','2013-05-17','13:25:00',6.49),('8975','2013-05-17','13:30:00',6.51),('8975','2013-05-17','13:35:00',6.68),('8975','2013-05-17','13:40:00',6.78),('8975','2013-05-17','13:45:00',6.76),('8975','2013-05-17','13:50:00',4.75),('8975','2013-05-17','13:55:00',4.68),('8975','2013-05-17','14:00:00',6.16),('8975','2013-05-17','14:05:00',6.45),('8975','2013-05-17','14:10:00',6.45),('8975','2013-05-17','14:15:00',6.32),('8975','2013-05-17','14:20:00',6.12),('8975','2013-05-17','14:25:00',5.92),('8975','2013-05-17','14:30:00',5.64),('8975','2013-05-17','14:35:00',5.42),('8975','2013-05-17','14:40:00',6.18),('8975','2013-05-17','14:45:00',3.83),('8975','2013-05-17','14:50:00',5.78),('8975','2013-05-17','14:55:00',5.37),('8975','2013-05-17','15:00:00',5.34),('8975','2013-05-17','15:05:00',5.22),('8975','2013-05-17','15:10:00',5.09),('8975','2013-05-17','15:15:00',4.99),('8975','2013-05-17','15:20:00',4.87),('8975','2013-05-17','15:25:00',4.77),('8975','2013-05-17','15:30:00',4.69),('8975','2013-05-17','15:35:00',4.59),('8975','2013-05-17','15:40:00',4.47),('8975','2013-05-17','15:45:00',4.36),('8975','2013-05-17','15:50:00',4.26),('8975','2013-05-17','15:55:00',4.15),('8975','2013-05-17','16:00:00',4.06),('8975','2013-05-17','16:05:00',3.94),('8975','2013-05-17','16:10:00',3.84),('8975','2013-05-17','16:15:00',3.77),('8975','2013-05-17','16:20:00',3.67),('8975','2013-05-17','16:25:00',3.55),('8975','2013-05-17','16:30:00',3.45),('8975','2013-05-17','16:35:00',3.34),('8975','2013-05-17','16:40:00',3.22),('8975','2013-05-17','16:45:00',3.1),('8975','2013-05-17','16:50:00',2.98),('8975','2013-05-17','16:55:00',2.88),('8975','2013-05-17','17:00:00',2.77),('8975','2013-05-17','17:05:00',2.68),('8975','2013-05-17','17:10:00',2.57),('8975','2013-05-17','17:15:00',2.46),('8975','2013-05-17','17:20:00',2.36),('8975','2013-05-17','17:25:00',2.25),('8975','2013-05-17','17:30:00',2.15),('8975','2013-05-17','17:35:00',2.07),('8975','2013-05-17','17:40:00',1.98),('8975','2013-05-17','17:45:00',1.9),('8975','2013-05-17','17:50:00',1.82),('8975','2013-05-17','17:55:00',1.73),('8975','2013-05-17','18:00:00',1.65),('8975','2013-05-17','18:05:00',1.57),('8975','2013-05-17','18:10:00',1.5),('8975','2013-05-17','18:15:00',1.43),('8975','2013-05-17','18:20:00',1.36),('8975','2013-05-17','18:25:00',1.3),('8975','2013-05-17','18:30:00',1.24),('8975','2013-05-17','18:35:00',1.16),('8975','2013-05-17','18:40:00',1.1),('8975','2013-05-17','18:45:00',1.02),('8975','2013-05-15','09:15:00',1.5),('8975','2013-05-15','09:20:00',2.09),('8975','2013-05-15','09:25:00',2.72),('8975','2013-05-15','09:30:00',2.93),('8975','2013-05-15','09:35:00',3.72),('8975','2013-05-15','09:40:00',4.04),('8975','2013-05-15','09:45:00',4.51),('8975','2013-05-15','09:50:00',2.19),('8975','2013-05-15','09:55:00',3.02),('8975','2013-05-15','10:00:00',2.89),('8975','2013-05-15','10:05:00',2.96),('8975','2013-05-15','10:10:00',2.37),('8975','2013-05-15','10:15:00',2.99),('8975','2013-05-15','10:20:00',4.91),('8975','2013-05-15','10:25:00',4.02),('8975','2013-05-15','10:30:00',3.6),('8975','2013-05-15','10:35:00',2.41),('8975','2013-05-15','10:40:00',1.87),('8975','2013-05-15','10:45:00',1.91),('8975','2013-05-15','10:50:00',2.38),('8975','2013-05-15','10:55:00',3.85),('8975','2013-05-15','11:00:00',7.37),('8975','2013-05-15','11:05:00',4.65),('8975','2013-05-15','11:10:00',5.77),('8975','2013-05-15','11:15:00',2.62),('8975','2013-05-15','11:20:00',1.77),('8975','2013-05-15','11:25:00',1.91),('8975','2013-05-15','11:30:00',2.57),('8975','2013-05-15','11:35:00',3.28),('8975','2013-05-15','11:40:00',4.45),('8975','2013-05-15','11:45:00',3.03),('8975','2013-05-15','11:50:00',2.88),('8975','2013-05-15','11:55:00',2.85),('8975','2013-05-15','12:00:00',2.89),('8975','2013-05-15','12:05:00',3.2),('8975','2013-05-15','12:10:00',3.75),('8975','2013-05-15','12:15:00',3.81),('8975','2013-05-15','12:20:00',3.38),('8975','2013-05-15','12:25:00',3.89),('8975','2013-05-15','12:30:00',6.12),('8975','2013-05-15','12:35:00',4.68),('8975','2013-05-15','12:40:00',5.21),('8975','2013-05-15','12:45:00',4.32),('8975','2013-05-15','12:50:00',4.89),('8975','2013-05-15','12:55:00',6.84),('8975','2013-05-15','13:00:00',5.31),('8975','2013-05-15','13:05:00',6.42),('8975','2013-05-15','13:10:00',6.53),('8975','2013-05-15','13:15:00',6.49),('8975','2013-05-15','13:20:00',6.48),('8975','2013-05-15','13:25:00',6.33),('8975','2013-05-15','13:30:00',6.27),('8975','2013-05-15','13:35:00',6.23),('8975','2013-05-15','13:40:00',6.15),('8975','2013-05-15','13:45:00',6.04),('8975','2013-05-15','13:50:00',6.04),('8975','2013-05-15','13:55:00',5.98),('8975','2013-05-15','14:00:00',5.96),('8975','2013-05-15','14:05:00',5.95),('8975','2013-05-15','14:10:00',5.87),('8975','2013-05-15','14:15:00',5.8),('8975','2013-05-15','14:20:00',5.73),('8975','2013-05-15','14:25:00',5.61),('8975','2013-05-15','14:30:00',5.53),('8975','2013-05-15','14:35:00',5.44),('8975','2013-05-15','14:40:00',5.39),('8975','2013-05-15','14:45:00',5.3),('8975','2013-05-15','14:50:00',4.97),('8975','2013-05-15','14:55:00',4.65),('8975','2013-05-15','15:00:00',5.13),('8975','2013-05-15','15:05:00',5.11),('8975','2013-05-15','15:10:00',5.09),('8975','2013-05-15','15:15:00',4.57),('8975','2013-05-15','15:20:00',4.87),('8975','2013-05-15','15:25:00',4.71),('8975','2013-05-15','15:30:00',4.59),('8975','2013-05-15','15:35:00',4.46),('8975','2013-05-15','15:40:00',4.55),('8975','2013-05-15','15:45:00',4.36),('8975','2013-05-15','15:50:00',4.33),('8975','2013-05-15','15:55:00',4.25),('8975','2013-05-15','16:00:00',4.17),('8975','2013-05-15','16:05:00',3.92),('8975','2013-05-15','16:10:00',4.02),('8975','2013-05-15','16:15:00',3.62),('8975','2013-05-15','16:20:00',3.9),('8975','2013-05-15','16:25:00',3.82),('8975','2013-05-15','16:30:00',3.76),('8975','2013-05-15','16:35:00',3.39),('8975','2013-05-15','16:40:00',2.63),('8975','2013-05-15','16:45:00',2.63),('8975','2013-05-15','16:50:00',2.93),('8975','2013-05-15','16:55:00',2.46),('8975','2013-05-15','17:00:00',1.78),('8975','2013-05-15','17:05:00',1.22),('8975','2013-05-15','17:10:00',1.4),('8975','2013-05-15','17:15:00',1.8),('8975','2013-05-15','17:20:00',2.43),('8975','2013-05-15','17:25:00',2.67),('8975','2013-05-15','17:30:00',2.88),('8975','2013-05-15','17:35:00',2.59),('8975','2013-05-15','17:40:00',2.14),('8975','2013-05-15','17:45:00',1.58),('8975','2013-05-15','18:30:00',1.1),('8975','2013-05-15','18:35:00',1.2),('8975','2013-05-15','18:40:00',1.18),('8975','2013-05-15','18:45:00',1.37),('8975','2013-05-15','18:50:00',1.5),('8975','2013-05-15','18:55:00',1.5),('8975','2013-05-15','19:00:00',1.59),('8975','2013-05-15','19:05:00',1.48),('8975','2013-05-15','19:10:00',1.25),('8975','2013-05-15','19:15:00',1.06),('8975','2013-05-14','06:50:00',1.2),('8975','2013-05-14','06:55:00',2.04),('8975','2013-05-14','07:00:00',1.91),('8975','2013-05-14','07:05:00',1.87),('8975','2013-05-14','07:10:00',2.6),('8975','2013-05-14','07:15:00',2.75),('8975','2013-05-14','07:20:00',2.88),('8975','2013-05-14','07:25:00',3.06),('8975','2013-05-14','07:30:00',3.22),('8975','2013-05-14','07:35:00',3.36),('8975','2013-05-14','07:40:00',3.49),('8975','2013-05-14','07:45:00',3.7),('8975','2013-05-14','07:50:00',3.64),('8975','2013-05-14','07:55:00',3.31),('8975','2013-05-14','08:00:00',3.34),('8975','2013-05-14','08:05:00',3.44),('8975','2013-05-14','08:10:00',3.87),('8975','2013-05-14','08:15:00',4.04),('8975','2013-05-14','08:20:00',4.03),('8975','2013-05-14','08:25:00',4.13),('8975','2013-05-14','08:30:00',4.23),('8975','2013-05-14','08:35:00',4.37),('8975','2013-05-14','08:40:00',4.47),('8975','2013-05-14','08:45:00',4.64),('8975','2013-05-14','08:50:00',4.79),('8975','2013-05-14','08:55:00',4.82),('8975','2013-05-14','09:00:00',4.66),('8975','2013-05-14','09:05:00',5),('8975','2013-05-14','09:10:00',4.91),('8975','2013-05-14','09:15:00',4.97),('8975','2013-05-14','09:20:00',4.95),('8975','2013-05-14','09:25:00',4.04),('8975','2013-05-14','09:30:00',5.35),('8975','2013-05-14','09:35:00',5.41),('8975','2013-05-14','09:40:00',5.33),('8975','2013-05-14','09:45:00',5.5),('8975','2013-05-14','09:50:00',5.6),('8975','2013-05-14','09:55:00',5.64),('8975','2013-05-14','10:00:00',5.77),('8975','2013-05-14','10:05:00',5.89),('8975','2013-05-14','10:10:00',5.98),('8975','2013-05-14','10:15:00',5.76),('8975','2013-05-14','10:20:00',5.84),('8975','2013-05-14','10:25:00',6.04),('8975','2013-05-14','10:30:00',5.97),('8975','2013-05-14','10:35:00',6.13),('8975','2013-05-14','10:40:00',6.28),('8975','2013-05-14','10:45:00',6.33),('8975','2013-05-14','10:50:00',6.23),('8975','2013-05-14','10:55:00',6.05),('8975','2013-05-14','11:00:00',5.98),('8975','2013-05-14','11:05:00',6.38),('8975','2013-05-14','11:10:00',6.43),('8975','2013-05-14','11:15:00',6.54),('8975','2013-05-14','11:20:00',6.17),('8975','2013-05-14','11:25:00',6.55),('8975','2013-05-14','11:30:00',6.45),('8975','2013-05-14','11:35:00',5.68),('8975','2013-05-14','11:40:00',5.1),('8975','2013-05-14','11:45:00',4.46),('8975','2013-05-14','11:50:00',3.99),('8975','2013-05-14','11:55:00',3.28),('8975','2013-05-14','12:00:00',3.84),('8975','2013-05-14','12:05:00',6.87),('8975','2013-05-14','12:10:00',7.9),('8975','2013-05-14','12:15:00',5.83),('8975','2013-05-14','12:20:00',3.42),('8975','2013-05-14','12:25:00',5.84),('8975','2013-05-14','12:30:00',6.6),('8975','2013-05-14','12:35:00',5.78),('8975','2013-05-14','12:40:00',7.19),('8975','2013-05-14','12:45:00',4.13),('8975','2013-05-14','12:50:00',4.32),('8975','2013-05-14','12:55:00',5.5),('8975','2013-05-14','13:00:00',4.77),('8975','2013-05-14','13:05:00',5.54),('8975','2013-05-14','13:10:00',3.99),('8975','2013-05-14','13:15:00',4.08),('8975','2013-05-14','13:20:00',4.41),('8975','2013-05-14','13:25:00',5.02),('8975','2013-05-14','13:30:00',4.78),('8975','2013-05-14','13:35:00',4.22),('8975','2013-05-14','13:40:00',4.83),('8975','2013-05-14','13:45:00',4.11),('8975','2013-05-14','13:50:00',3.64),('8975','2013-05-14','13:55:00',3.26),('8975','2013-05-14','14:00:00',2.88),('8975','2013-05-14','14:05:00',2.6),('8975','2013-05-14','14:10:00',2.73),('8975','2013-05-14','14:15:00',2.76),('8975','2013-05-14','14:20:00',2.87),('8975','2013-05-14','14:25:00',2.7),('8975','2013-05-14','14:30:00',2.48),('8975','2013-05-14','14:35:00',2.49),('8975','2013-05-14','14:40:00',2.57),('8975','2013-05-14','14:45:00',2.5),('8975','2013-05-14','14:50:00',2.51),('8975','2013-05-14','14:55:00',2.53),('8975','2013-05-14','15:00:00',2.39),('8975','2013-05-14','15:05:00',1.86),('8975','2013-05-14','15:10:00',1.48),('8975','2013-05-14','15:15:00',1.43),('8975','2013-05-14','15:20:00',1.33),('8975','2013-05-14','15:25:00',1.19),('8975','2013-05-14','15:30:00',1.25),('8975','2013-05-14','15:35:00',1.25),('8975','2013-05-14','15:40:00',1.47),('8975','2013-05-14','15:45:00',2),('8975','2013-05-14','15:50:00',2.9),('8975','2013-05-14','15:55:00',3.32),('8975','2013-05-14','16:00:00',3.08),('8975','2013-05-14','16:05:00',2.89),('8975','2013-05-14','16:10:00',2.46),('8975','2013-05-14','16:15:00',2.19),('8975','2013-05-14','16:20:00',2.41),('8975','2013-05-14','16:25:00',2.4),('8975','2013-05-14','16:30:00',2.14),('8975','2013-05-14','16:35:00',2.03),('8975','2013-05-14','16:40:00',1.92),('8975','2013-05-14','16:45:00',1.9),('8975','2013-05-14','16:50:00',1.97),('8975','2013-05-14','16:55:00',2.25),('8975','2013-05-14','17:00:00',2.55),('8975','2013-05-14','17:05:00',3.04),('8975','2013-05-14','17:10:00',2.65),('8975','2013-05-14','17:15:00',2.74),('8975','2013-05-14','17:20:00',2.59),('8975','2013-05-14','17:25:00',2.04),('8975','2013-05-14','17:30:00',1.48),('8975','2013-05-14','17:35:00',1.33),('8975','2013-05-14','17:40:00',1.26),('8975','2013-05-14','17:45:00',1.32),('8975','2013-05-14','17:50:00',1.35),('8975','2013-05-14','17:55:00',1.31),('8975','2013-05-14','18:00:00',1.21),('8975','2013-05-13','06:25:00',1.15),('8975','2013-05-13','06:30:00',1.59),('8975','2013-05-13','06:35:00',1.74),('8975','2013-05-13','06:40:00',1.9),('8975','2013-05-13','06:45:00',2.05),('8975','2013-05-13','06:50:00',2.2),('8975','2013-05-13','06:55:00',2.33),('8975','2013-05-13','07:00:00',2.46),('8975','2013-05-13','07:05:00',2.61),('8975','2013-05-13','07:10:00',2.8),('8975','2013-05-13','07:15:00',2.93),('8975','2013-05-13','07:20:00',3.06),('8975','2013-05-13','07:25:00',3.18),('8975','2013-05-13','07:30:00',3.29),('8975','2013-05-13','07:35:00',3.41),('8975','2013-05-13','07:40:00',3.54),('8975','2013-05-13','07:45:00',3.67),('8975','2013-05-13','07:50:00',3.78),('8975','2013-05-13','07:55:00',3.88),('8975','2013-05-13','08:00:00',3.96),('8975','2013-05-13','08:05:00',4.06),('8975','2013-05-13','08:10:00',4.17),('8975','2013-05-13','08:15:00',4.26),('8975','2013-05-13','08:20:00',4.38),('8975','2013-05-13','08:25:00',4.43),('8975','2013-05-13','08:30:00',4.56),('8975','2013-05-13','08:35:00',4.68),('8975','2013-05-13','08:40:00',4.77),('8975','2013-05-13','08:45:00',4.88),('8975','2013-05-13','08:50:00',4.98),('8975','2013-05-13','08:55:00',5.06),('8975','2013-05-13','09:00:00',5.16),('8975','2013-05-13','09:05:00',5.24),('8975','2013-05-13','09:10:00',5.34),('8975','2013-05-13','09:15:00',5.4),('8975','2013-05-13','09:20:00',5.49),('8975','2013-05-13','09:25:00',5.52),('8975','2013-05-13','09:30:00',5.64),('8975','2013-05-13','09:35:00',5.74),('8975','2013-05-13','09:40:00',5.8),('8975','2013-05-13','09:45:00',5.88),('8975','2013-05-13','09:50:00',5.96),('8975','2013-05-13','09:55:00',6.05),('8975','2013-05-13','10:00:00',6.1),('8975','2013-05-13','10:05:00',6.21),('8975','2013-05-13','10:10:00',6.31),('8975','2013-05-13','10:15:00',6.35),('8975','2013-05-13','10:20:00',6.4),('8975','2013-05-13','10:25:00',6.43),('8975','2013-05-13','10:30:00',6.43),('8975','2013-05-13','10:35:00',6.51),('8975','2013-05-13','10:40:00',6.54),('8975','2013-05-13','10:45:00',6.6),('8975','2013-05-13','10:50:00',6.61),('8975','2013-05-13','10:55:00',6.69),('8975','2013-05-13','11:00:00',6.72),('8975','2013-05-13','11:05:00',6.72),('8975','2013-05-13','11:10:00',6.73),('8975','2013-05-13','11:15:00',6.77),('8975','2013-05-13','11:20:00',6.81),('8975','2013-05-13','11:25:00',6.89),('8975','2013-05-13','11:30:00',6.94),('8975','2013-05-13','11:35:00',6.96),('8975','2013-05-13','11:40:00',6.93),('8975','2013-05-13','11:45:00',6.94),('8975','2013-05-13','11:50:00',6.98),('8975','2013-05-13','11:55:00',7),('8975','2013-05-13','12:00:00',7.02),('8975','2013-05-13','12:05:00',6.97),('8975','2013-05-13','12:10:00',7),('8975','2013-05-13','12:15:00',6.98),('8975','2013-05-13','12:20:00',6.95),('8975','2013-05-13','12:25:00',6.92),('8975','2013-05-13','12:30:00',6.87),('8975','2013-05-13','12:35:00',6.83),('8975','2013-05-13','12:40:00',6.85),('8975','2013-05-13','12:45:00',6.82),('8975','2013-05-13','12:50:00',6.86),('8975','2013-05-13','12:55:00',6.83),('8975','2013-05-13','13:00:00',6.77),('8975','2013-05-13','13:05:00',6.83),('8975','2013-05-13','13:10:00',6.82),('8975','2013-05-13','13:15:00',6.71),('8975','2013-05-13','13:20:00',6.64),('8975','2013-05-13','13:25:00',6.67),('8975','2013-05-13','13:30:00',6.71),('8975','2013-05-13','13:35:00',6.6),('8975','2013-05-13','13:40:00',6.53),('8975','2013-05-13','13:45:00',6.48),('8975','2013-05-13','13:50:00',6.4),('8975','2013-05-13','13:55:00',6.38),('8975','2013-05-13','14:00:00',6.3),('8975','2013-05-13','14:05:00',6.27),('8975','2013-05-13','14:10:00',6.17),('8975','2013-05-13','14:15:00',6.09),('8975','2013-05-13','14:20:00',6.04),('8975','2013-05-13','14:25:00',5.96),('8975','2013-05-13','14:30:00',5.84),('8975','2013-05-13','14:35:00',5.79),('8975','2013-05-13','14:40:00',5.84),('8975','2013-05-13','14:45:00',5.82),('8975','2013-05-13','14:50:00',5.77),('8975','2013-05-13','14:55:00',5.71),('8975','2013-05-13','15:00:00',5.63),('8975','2013-05-13','15:05:00',5.52),('8975','2013-05-13','15:10:00',5.37),('8975','2013-05-13','15:15:00',5.28),('8975','2013-05-13','15:20:00',5.22),('8975','2013-05-13','15:25:00',5.16),('8975','2013-05-13','15:30:00',5.07),('8975','2013-05-13','15:35:00',4.97),('8975','2013-05-13','15:40:00',4.84),('8975','2013-05-13','15:45:00',4.35),('8975','2013-05-13','15:50:00',4.05),('8975','2013-05-13','15:55:00',3.91),('8975','2013-05-13','16:00:00',3.98),('8975','2013-05-13','16:05:00',4.14),('8975','2013-05-13','16:10:00',3.84),('8975','2013-05-13','16:15:00',3.98),('8975','2013-05-13','16:20:00',3.38),('8975','2013-05-13','16:25:00',3.48),('8975','2013-05-13','16:30:00',3.06),('8975','2013-05-13','16:35:00',3.49),('8975','2013-05-13','16:40:00',3.28),('8975','2013-05-13','16:45:00',3.17),('8975','2013-05-13','16:50:00',3.09),('8975','2013-05-13','16:55:00',3.07),('8975','2013-05-13','17:00:00',2.95),('8975','2013-05-13','17:05:00',2.82),('8975','2013-05-13','17:10:00',2.69),('8975','2013-05-13','17:15:00',2.57),('8975','2013-05-13','17:20:00',2.46),('8975','2013-05-13','17:25:00',2.35),('8975','2013-05-13','17:30:00',2.23),('8975','2013-05-13','17:35:00',2.11),('8975','2013-05-13','17:40:00',2.01),('8975','2013-05-13','17:45:00',1.91),('8975','2013-05-13','17:50:00',1.82),('8975','2013-05-13','17:55:00',1.73),('8975','2013-05-13','18:00:00',1.65),('8975','2013-05-13','18:05:00',1.58),('8975','2013-05-13','18:10:00',1.5),('8975','2013-05-13','18:15:00',1.45),('8975','2013-05-13','18:20:00',1.4),('8975','2013-05-13','18:25:00',1.36),('8975','2013-05-13','18:30:00',1.31),('8975','2013-05-13','18:35:00',1.26),('8975','2013-05-13','18:40:00',1.22),('8975','2013-05-13','18:45:00',1.13),('8975','2013-05-13','18:50:00',1.07),('8975','2013-05-13','18:55:00',1.02),('8975','2013-05-12','06:40:00',1.19),('8975','2013-05-12','06:45:00',1.4),('8975','2013-05-12','06:50:00',1.57),('8975','2013-05-12','06:55:00',1.73),('8975','2013-05-12','07:00:00',1.99),('8975','2013-05-12','07:05:00',2.09),('8975','2013-05-12','07:10:00',2.26),('8975','2013-05-12','07:15:00',2.16),('8975','2013-05-12','07:20:00',1.81),('8975','2013-05-12','07:25:00',1.74),('8975','2013-05-12','07:30:00',2.49),('8975','2013-05-12','07:35:00',2.91),('8975','2013-05-12','07:40:00',3.05),('8975','2013-05-12','07:45:00',3.08),('8975','2013-05-12','07:50:00',3.29),('8975','2013-05-12','07:55:00',3.11),('8975','2013-05-12','08:00:00',3.53),('8975','2013-05-12','08:05:00',3.6),('8975','2013-05-12','08:10:00',3.79),('8975','2013-05-12','08:15:00',3.95),('8975','2013-05-12','08:20:00',4.05),('8975','2013-05-12','08:25:00',4.16),('8975','2013-05-12','08:30:00',4.25),('8975','2013-05-12','08:35:00',4.33),('8975','2013-05-12','08:40:00',4.46),('8975','2013-05-12','08:45:00',4.61),('8975','2013-05-12','08:50:00',4.72),('8975','2013-05-12','08:55:00',4.81),('8975','2013-05-12','09:00:00',4.95),('8975','2013-05-12','09:05:00',5),('8975','2013-05-12','09:10:00',5.07),('8975','2013-05-12','09:15:00',5.13),('8975','2013-05-12','09:20:00',5.22),('8975','2013-05-12','09:25:00',5.37),('8975','2013-05-12','09:30:00',5.37),('8975','2013-05-12','09:35:00',5.56),('8975','2013-05-12','09:40:00',5.58),('8975','2013-05-12','09:45:00',5.7),('8975','2013-05-12','09:50:00',5.85),('8975','2013-05-12','09:55:00',6.01),('8975','2013-05-12','10:00:00',4.04),('8975','2013-05-12','10:05:00',6.28),('8975','2013-05-12','10:10:00',6.34),('8975','2013-05-12','10:15:00',6.37),('8975','2013-05-12','10:20:00',6.54),('8975','2013-05-12','10:25:00',5.9),('8975','2013-05-12','10:30:00',6.68),('8975','2013-05-12','10:35:00',4.37),('8975','2013-05-12','10:40:00',6.78),('8975','2013-05-12','10:45:00',7.06),('8975','2013-05-12','10:50:00',2.88),('8975','2013-05-12','10:55:00',1.93),('8975','2013-05-12','11:00:00',2.86),('8975','2013-05-12','11:05:00',5.63),('8975','2013-05-12','11:10:00',5.12),('8975','2013-05-12','11:15:00',6.48),('8975','2013-05-12','11:20:00',2.83),('8975','2013-05-12','11:25:00',2.68),('8975','2013-05-12','11:30:00',2.66),('8975','2013-05-12','11:35:00',2.72),('8975','2013-05-12','11:40:00',5.63),('8975','2013-05-12','11:45:00',4.97),('8975','2013-05-12','11:50:00',3.53),('8975','2013-05-12','11:55:00',3.29),('8975','2013-05-12','12:00:00',3.17),('8975','2013-05-12','12:05:00',3.06),('8975','2013-05-12','12:10:00',4.54),('8975','2013-05-12','12:15:00',5.21),('8975','2013-05-12','12:20:00',4.47),('8975','2013-05-12','12:25:00',1.98),('8975','2013-05-12','12:30:00',1.78),('8975','2013-05-12','12:35:00',5.64),('8975','2013-05-12','12:40:00',7.62),('8975','2013-05-12','12:45:00',7.58),('8975','2013-05-12','12:50:00',7.54),('8975','2013-05-12','12:55:00',7.47),('8975','2013-05-12','13:00:00',7.3),('8975','2013-05-12','13:05:00',6.8),('8975','2013-05-12','13:10:00',4.7),('8975','2013-05-12','13:15:00',4.17),('8975','2013-05-12','13:20:00',2.52),('8975','2013-05-12','13:25:00',4.77),('8975','2013-05-12','13:30:00',5.94),('8975','2013-05-12','13:35:00',7.3),('8975','2013-05-12','13:40:00',7.22),('8975','2013-05-12','13:45:00',7.64),('8975','2013-05-12','13:50:00',5.91),('8975','2013-05-12','13:55:00',4.61),('8975','2013-05-12','14:00:00',2.6),('8975','2013-05-12','14:05:00',1.65),('8975','2013-05-12','14:10:00',1.41),('8975','2013-05-12','14:15:00',5.16),('8975','2013-05-12','14:20:00',5.94),('8975','2013-05-12','14:25:00',5.77),('8975','2013-05-12','14:30:00',6.6),('8975','2013-05-12','14:35:00',2.56),('8975','2013-05-12','14:40:00',1.89),('8975','2013-05-12','14:45:00',1.47),('8975','2013-05-12','14:50:00',1.8),('8975','2013-05-12','14:55:00',1.86),('8975','2013-05-12','15:00:00',1.84),('8975','2013-05-12','15:05:00',4.76),('8975','2013-05-12','15:10:00',1.7),('8975','2013-05-12','15:15:00',1.56),('8975','2013-05-12','15:20:00',1.31),('8975','2013-05-12','15:25:00',1.23),('8975','2013-05-12','15:30:00',1.33),('8975','2013-05-12','15:35:00',1.3),('8975','2013-05-12','15:40:00',1.57),('8975','2013-05-12','15:45:00',1.97),('8975','2013-05-12','15:50:00',1.85),('8975','2013-05-12','15:55:00',1.34),('8975','2013-05-12','16:00:00',1.69),('8975','2013-05-12','16:05:00',2.76),('8975','2013-05-12','16:10:00',2.57),('8975','2013-05-12','16:15:00',2.13),('8975','2013-05-12','16:20:00',2.3),('8975','2013-05-12','16:25:00',2.29),('8975','2013-05-12','16:30:00',2.09),('8975','2013-05-12','16:35:00',2),('8975','2013-05-12','16:40:00',2.05),('8975','2013-05-12','16:45:00',2.23),('8975','2013-05-12','16:50:00',4.31),('8975','2013-05-12','16:55:00',3.87),('8975','2013-05-12','17:00:00',3.53),('8975','2013-05-12','17:05:00',3.4),('8975','2013-05-12','17:10:00',2.53),('8975','2013-05-12','17:15:00',2.62),('8975','2013-05-12','17:20:00',3.53),('8975','2013-05-12','17:25:00',3.56),('8975','2013-05-12','17:30:00',3.54),('8975','2013-05-12','17:35:00',3.42),('8975','2013-05-12','17:40:00',3.16),('8975','2013-05-12','17:45:00',2.94),('8975','2013-05-12','17:50:00',2.85),('8975','2013-05-12','17:55:00',2.11),('8975','2013-05-12','18:00:00',1.41),('8975','2013-05-12','18:05:00',1.23),('8975','2013-05-12','18:10:00',1.22),('8975','2013-05-12','18:15:00',1.84),('8975','2013-05-12','18:20:00',1.77),('8975','2013-05-12','18:25:00',1.22),('8975','2013-05-11','07:35:00',1.02),('8975','2013-05-11','07:40:00',1.22),('8975','2013-05-11','07:45:00',1.34),('8975','2013-05-11','07:50:00',2.11),('8975','2013-05-11','07:55:00',2.27),('8975','2013-05-11','08:00:00',1.66),('8975','2013-05-11','08:05:00',2.78),('8975','2013-05-11','08:10:00',3.2),('8975','2013-05-11','08:15:00',2.23),('8975','2013-05-11','08:20:00',2.33),('8975','2013-05-11','08:25:00',1.97),('8975','2013-05-11','08:30:00',2.02),('8975','2013-05-11','08:35:00',4.48),('8975','2013-05-11','08:40:00',2.6),('8975','2013-05-11','08:45:00',2.22),('8975','2013-05-11','08:50:00',5.03),('8975','2013-05-11','08:55:00',4.3),('8975','2013-05-11','09:00:00',3.65),('8975','2013-05-11','09:05:00',4.85),('8975','2013-05-11','09:10:00',5.86),('8975','2013-05-11','09:15:00',5.99),('8975','2013-05-11','09:20:00',5.76),('8975','2013-05-11','09:25:00',6.55),('8975','2013-05-11','09:30:00',3.6),('8975','2013-05-11','09:35:00',2.35),('8975','2013-05-11','09:40:00',2.45),('8975','2013-05-11','09:45:00',2.51),('8975','2013-05-11','09:50:00',2.13),('8975','2013-05-11','09:55:00',2.13),('8975','2013-05-11','10:00:00',2.18),('8975','2013-05-11','10:05:00',4.56),('8975','2013-05-11','10:10:00',6.85),('8975','2013-05-11','10:15:00',6.25),('8975','2013-05-11','10:20:00',1.91),('8975','2013-05-11','10:25:00',1.48),('8975','2013-05-11','10:30:00',1.55),('8975','2013-05-11','10:35:00',1.51),('8975','2013-05-11','10:40:00',1.48),('8975','2013-05-11','10:45:00',1.68),('8975','2013-05-11','10:50:00',1.74),('8975','2013-05-11','10:55:00',1.81),('8975','2013-05-11','11:00:00',5.95),('8975','2013-05-11','11:05:00',1.95),('8975','2013-05-11','11:10:00',1.79),('8975','2013-05-11','11:15:00',1.74),('8975','2013-05-11','11:20:00',1.78),('8975','2013-05-11','11:25:00',3.67),('8975','2013-05-11','11:30:00',3.66),('8975','2013-05-11','11:35:00',8.18),('8975','2013-05-11','11:40:00',3.92),('8975','2013-05-11','11:45:00',4.01),('8975','2013-05-11','11:50:00',3.4),('8975','2013-05-11','11:55:00',2.26),('8975','2013-05-11','12:00:00',3.4),('8975','2013-05-11','12:05:00',3.87),('8975','2013-05-11','12:10:00',6.23),('8975','2013-05-11','12:15:00',6.71),('8975','2013-05-11','12:20:00',5.37),('8975','2013-05-11','12:25:00',2.28),('8975','2013-05-11','12:30:00',1.7),('8975','2013-05-11','12:35:00',1.96),('8975','2013-05-11','12:40:00',2.45),('8975','2013-05-11','12:45:00',2.25),('8975','2013-05-11','12:50:00',1.77),('8975','2013-05-11','12:55:00',2.11),('8975','2013-05-11','13:00:00',3),('8975','2013-05-11','13:05:00',3.07),('8975','2013-05-11','13:10:00',6.33),('8975','2013-05-11','13:15:00',8.38),('8975','2013-05-11','13:20:00',7.76),('8975','2013-05-11','13:25:00',7.51),('8975','2013-05-11','13:30:00',6.87),('8975','2013-05-11','13:35:00',7.48),('8975','2013-05-11','13:40:00',7.37),('8975','2013-05-11','13:45:00',6.36),('8975','2013-05-11','13:50:00',2.57),('8975','2013-05-11','13:55:00',6.94),('8975','2013-05-11','14:00:00',2.88),('8975','2013-05-11','14:05:00',6.34),('8975','2013-05-11','14:10:00',5.25),('8975','2013-05-11','14:15:00',6.62),('8975','2013-05-11','14:20:00',2.19),('8975','2013-05-11','14:25:00',4.75),('8975','2013-05-11','14:30:00',6.4),('8975','2013-05-11','14:35:00',3.73),('8975','2013-05-11','14:40:00',3.39),('8975','2013-05-11','14:45:00',3.24),('8975','2013-05-11','14:50:00',5.06),('8975','2013-05-11','14:55:00',5.29),('8975','2013-05-11','15:00:00',6.17),('8975','2013-05-11','15:05:00',4.09),('8975','2013-05-11','15:10:00',5.12),('8975','2013-05-11','15:15:00',4.15),('8975','2013-05-11','15:20:00',5.82),('8975','2013-05-11','15:25:00',5.48),('8975','2013-05-11','15:30:00',5.22),('8975','2013-05-11','15:35:00',4.91),('8975','2013-05-11','15:40:00',4.92),('8975','2013-05-11','15:45:00',4.87),('8975','2013-05-11','15:50:00',4.72),('8975','2013-05-11','15:55:00',4.54),('8975','2013-05-11','16:00:00',4.45),('8975','2013-05-11','16:05:00',4.33),('8975','2013-05-11','16:10:00',4.2),('8975','2013-05-11','16:15:00',4.1),('8975','2013-05-11','16:20:00',4),('8975','2013-05-11','16:25:00',3.85),('8975','2013-05-11','16:30:00',3.78),('8975','2013-05-11','16:35:00',3.74),('8975','2013-05-11','16:40:00',3.75),('8975','2013-05-11','16:45:00',3.68),('8975','2013-05-11','16:50:00',3.54),('8975','2013-05-11','16:55:00',4.05),('8975','2013-05-11','17:00:00',3.36),('8975','2013-05-11','17:05:00',3.78),('8975','2013-05-11','17:10:00',3.65),('8975','2013-05-11','17:15:00',3.93),('8975','2013-05-11','17:20:00',2.96),('8975','2013-05-11','17:25:00',2.13),('8975','2013-05-11','17:30:00',2.68),('8975','2013-05-11','17:35:00',1.94),('8975','2013-05-11','17:40:00',2.28),('8975','2013-05-11','17:45:00',2.24),('8975','2013-05-11','17:50:00',2.23),('8975','2013-05-11','17:55:00',1.45),('8975','2013-05-11','18:00:00',2.83),('8975','2013-05-11','18:05:00',2.14),('8975','2013-05-11','18:10:00',1.99),('8975','2013-05-11','18:15:00',2.35),('8975','2013-05-11','18:20:00',2.03),('8975','2013-05-11','18:25:00',1.47),('8975','2013-05-11','18:30:00',1.47),('8975','2013-05-11','18:35:00',1.85),('8975','2013-05-11','18:40:00',1.6),('8975','2013-05-11','18:45:00',1.24),('8975','2013-05-11','18:50:00',1.13),('8975','2013-05-11','19:00:00',1.11),('8975','2013-05-11','19:05:00',1.23),('8975','2013-05-11','19:10:00',1.01),('8975','2013-05-11','19:15:00',1.02),('8975','2014-03-30','07:30:00',1.11),('8975','2014-03-30','07:35:00',1.23),('8975','2014-03-30','07:40:00',1.45),('8975','2014-03-30','07:45:00',1.66),('8975','2014-03-30','07:50:00',1.71),('8975','2014-03-30','07:55:00',1.82),('8975','2014-03-30','08:00:00',2.16),('8975','2014-03-30','08:05:00',2.42),('8975','2014-03-30','08:10:00',2.59),('8975','2014-03-30','08:15:00',2.73),('8975','2014-03-30','08:20:00',2.86),('8975','2014-03-30','08:25:00',2.99),('8975','2014-03-30','08:30:00',3.13),('8975','2014-03-30','08:35:00',3.24),('8975','2014-03-30','08:40:00',3.33),('8975','2014-03-30','08:45:00',3.41),('8975','2014-03-30','08:50:00',3.49),('8975','2014-03-30','08:55:00',3.59),('8975','2014-03-30','09:00:00',3.66),('8975','2014-03-30','09:05:00',3.78),('8975','2014-03-30','09:10:00',3.89),('8975','2014-03-30','09:15:00',3.99),('8975','2014-03-30','09:20:00',4.1),('8975','2014-03-30','09:25:00',4.19),('8975','2014-03-30','09:30:00',4.27),('8975','2014-03-30','09:35:00',4.39),('8975','2014-03-30','09:40:00',4.5),('8975','2014-03-30','09:45:00',4.61),('8975','2014-03-30','09:50:00',4.7),('8975','2014-03-30','09:55:00',4.79),('8975','2014-03-30','10:00:00',4.85),('8975','2014-03-30','10:05:00',4.92),('8975','2014-03-30','10:10:00',5),('8975','2014-03-30','10:15:00',5.05),('8975','2014-03-30','10:20:00',5.14),('8975','2014-03-30','10:25:00',5.2),('8975','2014-03-30','10:30:00',5.26),('8975','2014-03-30','10:35:00',5.33),('8975','2014-03-30','10:40:00',5.36),('8975','2014-03-30','10:45:00',5.38),('8975','2014-03-30','10:50:00',5.44),('8975','2014-03-30','10:55:00',5.5),('8975','2014-03-30','11:00:00',5.54),('8975','2014-03-30','11:05:00',5.61),('8975','2014-03-30','11:10:00',5.66),('8975','2014-03-30','11:15:00',5.67),('8975','2014-03-30','11:20:00',5.72),('8975','2014-03-30','11:25:00',5.74),('8975','2014-03-30','11:30:00',5.81),('8975','2014-03-30','11:35:00',5.86),('8975','2014-03-30','11:40:00',5.85),('8975','2014-03-30','11:45:00',5.89),('8975','2014-03-30','11:50:00',5.97),('8975','2014-03-30','11:55:00',5.96),('8975','2014-03-30','12:00:00',5.97),('8975','2014-03-30','12:05:00',6.01),('8975','2014-03-30','12:10:00',6.03),('8975','2014-03-30','12:15:00',6.03),('8975','2014-03-30','12:20:00',6.01),('8975','2014-03-30','12:25:00',6.01),('8975','2014-03-30','12:30:00',6.01),('8975','2014-03-30','12:35:00',6.03),('8975','2014-03-30','12:40:00',6),('8975','2014-03-30','12:45:00',5.95),('8975','2014-03-30','12:50:00',5.94),('8975','2014-03-30','12:55:00',5.9),('8975','2014-03-30','13:00:00',5.83),('8975','2014-03-30','13:05:00',5.9),('8975','2014-03-30','13:10:00',5.91),('8975','2014-03-30','13:15:00',5.87),('8975','2014-03-30','13:20:00',5.84),('8975','2014-03-30','13:25:00',5.82),('8975','2014-03-30','13:30:00',5.77),('8975','2014-03-30','13:35:00',5.75),('8975','2014-03-30','13:40:00',5.75),('8975','2014-03-30','13:45:00',5.7),('8975','2014-03-30','13:50:00',5.65),('8975','2014-03-30','13:55:00',5.57),('8975','2014-03-30','14:00:00',5.5),('8975','2014-03-30','14:05:00',5.47),('8975','2014-03-30','14:10:00',5.42),('8975','2014-03-30','14:15:00',5.34),('8975','2014-03-30','14:20:00',5.28),('8975','2014-03-30','14:25:00',5.18),('8975','2014-03-30','14:30:00',5.1),('8975','2014-03-30','14:35:00',5.05),('8975','2014-03-30','14:40:00',4.98),('8975','2014-03-30','14:45:00',4.88),('8975','2014-03-30','14:50:00',4.78),('8975','2014-03-30','14:55:00',4.72),('8975','2014-03-30','15:00:00',4.62),('8975','2014-03-30','15:05:00',4.56),('8975','2014-03-30','15:10:00',4.37),('8975','2014-03-30','15:15:00',4.17),('8975','2014-03-30','15:20:00',4.17),('8975','2014-03-30','15:25:00',4.07),('8975','2014-03-30','15:30:00',3.95),('8975','2014-03-30','15:35:00',3.83),('8975','2014-03-30','15:40:00',3.73),('8975','2014-03-30','15:45:00',3.6),('8975','2014-03-30','15:50:00',3.49),('8975','2014-03-30','15:55:00',3.23),('8975','2014-03-30','16:00:00',3.24),('8975','2014-03-30','16:05:00',3.15),('8975','2014-03-30','16:10:00',3.06),('8975','2014-03-30','16:15:00',2.94),('8975','2014-03-30','16:20:00',2.84),('8975','2014-03-30','16:25:00',2.71),('8975','2014-03-30','16:30:00',2.64),('8975','2014-03-30','16:35:00',2.54),('8975','2014-03-30','16:40:00',2.42),('8975','2014-03-30','16:45:00',2.31),('8975','2014-03-30','16:50:00',2.2),('8975','2014-03-30','16:55:00',2.1),('8975','2014-03-30','17:00:00',2),('8975','2014-03-30','17:05:00',1.9),('8975','2014-03-30','17:10:00',1.81),('8975','2014-03-30','17:15:00',1.75),('8975','2014-03-30','17:20:00',1.69),('8975','2014-03-30','17:25:00',1.61),('8975','2014-03-30','17:30:00',1.54),('8975','2014-03-30','17:35:00',1.51),('8975','2014-03-30','17:40:00',1.47),('8975','2014-03-30','17:45:00',1.42),('8975','2014-03-30','17:50:00',1.37),('8975','2014-03-30','17:55:00',1.3),('8975','2014-03-30','18:00:00',1.24),('8975','2014-03-30','18:05:00',1.17),('8975','2014-03-30','18:10:00',1.11),('8975','2014-03-30','18:15:00',1.04),('8975','2013-05-10','07:10:00',1.27),('8975','2013-05-10','07:15:00',2.2),('8975','2013-05-10','07:20:00',2.34),('8975','2013-05-10','07:25:00',2.45),('8975','2013-05-10','07:30:00',2.22),('8975','2013-05-10','07:35:00',2.62),('8975','2013-05-10','07:40:00',2.82),('8975','2013-05-10','07:45:00',3.23),('8975','2013-05-10','07:50:00',3.35),('8975','2013-05-10','07:55:00',3.42),('8975','2013-05-10','08:00:00',3.1),('8975','2013-05-10','08:05:00',2.64),('8975','2013-05-10','08:10:00',2.57),('8975','2013-05-10','08:15:00',2.21),('8975','2013-05-10','08:20:00',2.36),('8975','2013-05-10','08:25:00',1.33),('8975','2013-05-10','08:30:00',2.28),('8975','2013-05-10','08:35:00',2.09),('8975','2013-05-10','08:40:00',1.09),('8975','2013-05-10','08:45:00',1.27),('8975','2013-05-10','08:50:00',1.42),('8975','2013-05-10','08:55:00',1.72),('8975','2013-05-10','09:00:00',1.48),('8975','2013-05-10','09:05:00',2.46),('8975','2013-05-10','09:10:00',2.46),('8975','2013-05-10','09:15:00',2.86),('8975','2013-05-10','09:20:00',3.4),('8975','2013-05-10','09:25:00',3.58),('8975','2013-05-10','09:30:00',4.59),('8975','2013-05-10','09:35:00',4.42),('8975','2013-05-10','09:40:00',4.2),('8975','2013-05-10','09:45:00',3.14),('8975','2013-05-10','09:50:00',6.22),('8975','2013-05-10','09:55:00',5.4),('8975','2013-05-10','10:00:00',2.05),('8975','2013-05-10','10:05:00',1.63),('8975','2013-05-10','10:10:00',1.59),('8975','2013-05-10','10:15:00',1.36),('8975','2013-05-10','10:20:00',1.18),('8975','2013-05-10','10:25:00',1.81),('8975','2013-05-10','10:30:00',2.66),('8975','2013-05-10','10:35:00',2.02),('8975','2013-05-10','10:40:00',1.69),('8975','2013-05-10','10:45:00',5.41),('8975','2013-05-10','10:50:00',4.74),('8975','2013-05-10','10:55:00',2.02),('8975','2013-05-10','11:00:00',2.7),('8975','2013-05-10','11:05:00',2.34),('8975','2013-05-10','11:10:00',1.32),('8975','2013-05-10','11:15:00',1),('8975','2013-05-10','11:20:00',1.35),('8975','2013-05-10','11:25:00',2.11),('8975','2013-05-10','11:30:00',2.55),('8975','2013-05-10','11:35:00',2.94),('8975','2013-05-10','11:40:00',8.22),('8975','2013-05-10','11:45:00',8.2),('8975','2013-05-10','11:50:00',4.44),('8975','2013-05-10','11:55:00',2.76),('8975','2013-05-10','12:00:00',4.02),('8975','2013-05-10','12:05:00',3.3),('8975','2013-05-10','12:10:00',2.31),('8975','2013-05-10','12:15:00',3.57),('8975','2013-05-10','12:20:00',3.04),('8975','2013-05-10','12:25:00',5.06),('8975','2013-05-10','12:30:00',3.88),('8975','2013-05-10','12:35:00',5.74),('8975','2013-05-10','12:40:00',7.09),('8975','2013-05-10','12:45:00',4.92),('8975','2013-05-10','12:50:00',3.09),('8975','2013-05-10','12:55:00',3.21),('8975','2013-05-10','13:00:00',3.92),('8975','2013-05-10','13:05:00',4.59),('8975','2013-05-10','13:10:00',2.15),('8975','2013-05-10','13:15:00',2.53),('8975','2013-05-10','13:20:00',5.03),('8975','2013-05-10','13:25:00',2.18),('8975','2013-05-10','13:30:00',2),('8975','2013-05-10','13:35:00',2.02),('8975','2013-05-10','13:40:00',1.16),('8975','2013-05-10','13:50:00',1.18),('8975','2013-05-10','13:55:00',2.02),('8975','2013-05-10','14:00:00',3.14),('8975','2013-05-10','14:05:00',4.55),('8975','2013-05-10','14:10:00',6.07),('8975','2013-05-10','14:15:00',5.58),('8975','2013-05-10','14:20:00',4.08),('8975','2013-05-10','14:25:00',6.25),('8975','2013-05-10','14:30:00',2.79),('8975','2013-05-10','14:35:00',5.04),('8975','2013-05-10','14:40:00',4.47),('8975','2013-05-10','14:45:00',5.13),('8975','2013-05-10','14:50:00',4.37),('8975','2013-05-10','14:55:00',5.87),('8975','2013-05-10','15:00:00',5.83),('8975','2013-05-10','15:05:00',5.16),('8975','2013-05-10','15:10:00',4.3),('8975','2013-05-10','15:15:00',4.16),('8975','2013-05-10','15:20:00',4.22),('8975','2013-05-10','15:25:00',4.8),('8975','2013-05-10','15:30:00',5.19),('8975','2013-05-10','15:35:00',5.2),('8975','2013-05-10','15:40:00',5.12),('8975','2013-05-10','15:45:00',5.07),('8975','2013-05-10','15:50:00',4.79),('8975','2013-05-10','15:55:00',4.31),('8975','2013-05-10','16:00:00',4.55),('8975','2013-05-10','16:05:00',4.49),('8975','2013-05-10','16:10:00',4.41),('8975','2013-05-10','16:15:00',4.29),('8975','2013-05-10','16:20:00',4.31),('8975','2013-05-10','16:25:00',4.24),('8975','2013-05-10','16:30:00',3.92),('8975','2013-05-10','16:35:00',3.72),('8975','2013-05-10','16:40:00',3.43),('8975','2013-05-10','16:45:00',3.31),('8975','2013-05-10','16:50:00',2.86),('8975','2013-05-10','16:55:00',2.92),('8975','2013-05-10','17:00:00',2.84),('8975','2013-05-10','17:05:00',2.88),('8975','2013-05-10','17:10:00',1.74),('8975','2013-05-10','17:15:00',1.22),('8975','2013-05-10','17:20:00',1.15),('8975','2013-05-10','17:25:00',1.69),('8975','2013-05-10','17:30:00',1.29),('8975','2013-05-10','17:35:00',1.72),('8975','2013-05-10','17:40:00',2.17),('8975','2013-05-10','17:45:00',1.42),('8975','2013-05-10','17:50:00',2.1),('8975','2013-05-10','17:55:00',1.32),('8975','2013-05-10','18:00:00',1.59),('8975','2013-05-10','18:05:00',1.69),('8975','2013-05-10','18:10:00',1.57),('8975','2013-05-10','18:15:00',1.86),('8975','2013-05-10','18:20:00',1.8),('8975','2013-05-10','18:25:00',1.65),('8975','2013-05-10','18:30:00',1),('8975','2013-05-10','18:40:00',1.13),('8975','2013-05-10','18:50:00',1.03),('8975','2013-05-10','18:55:00',1.49),('8975','2013-05-10','19:00:00',1.1),('8975','2013-05-09','06:40:00',1.08),('8975','2013-05-09','06:55:00',1.09),('8975','2013-05-09','07:00:00',1.74),('8975','2013-05-09','07:15:00',1.76),('8975','2013-05-09','07:20:00',1.98),('8975','2013-05-09','07:25:00',2.72),('8975','2013-05-09','07:30:00',2.89),('8975','2013-05-09','07:35:00',2.85),('8975','2013-05-09','07:40:00',1.46),('8975','2013-05-09','07:45:00',1.37),('8975','2013-05-09','07:50:00',2.83),('8975','2013-05-09','07:55:00',3.8),('8975','2013-05-09','08:00:00',3.96),('8975','2013-05-09','08:05:00',4.15),('8975','2013-05-09','08:10:00',4.29),('8975','2013-05-09','08:15:00',4.57),('8975','2013-05-09','08:20:00',4.33),('8975','2013-05-09','08:25:00',4.29),('8975','2013-05-09','08:30:00',4.01),('8975','2013-05-09','08:35:00',3.97),('8975','2013-05-09','08:40:00',1.79),('8975','2013-05-09','08:45:00',1.07),('8975','2013-05-09','08:55:00',1.17),('8975','2013-05-09','09:00:00',2.87),('8975','2013-05-09','09:05:00',4.61),('8975','2013-05-09','09:10:00',5.34),('8975','2013-05-09','09:15:00',5.4),('8975','2013-05-09','09:20:00',5.21),('8975','2013-05-09','09:25:00',4.7),('8975','2013-05-09','09:30:00',5.25),('8975','2013-05-09','09:35:00',5),('8975','2013-05-09','09:40:00',3.32),('8975','2013-05-09','09:45:00',5.31),('8975','2013-05-09','09:50:00',4.25),('8975','2013-05-09','09:55:00',4.41),('8975','2013-05-09','10:00:00',2.65),('8975','2013-05-09','10:05:00',3.02),('8975','2013-05-09','10:10:00',2.17),('8975','2013-05-09','10:15:00',2.56),('8975','2013-05-09','10:20:00',3.38),('8975','2013-05-09','10:25:00',6.55),('8975','2013-05-09','10:30:00',6.85),('8975','2013-05-09','10:35:00',5.52),('8975','2013-05-09','10:40:00',2.86),('8975','2013-05-09','10:45:00',2.22),('8975','2013-05-09','10:50:00',3.06),('8975','2013-05-09','10:55:00',7.09),('8975','2013-05-09','11:00:00',6.94),('8975','2013-05-09','11:05:00',6.84),('8975','2013-05-09','11:10:00',6.85),('8975','2013-05-09','11:15:00',6.79),('8975','2013-05-09','11:20:00',5.22),('8975','2013-05-09','11:25:00',6.8),('8975','2013-05-09','11:30:00',6.09),('8975','2013-05-09','11:35:00',6.93),('8975','2013-05-09','11:40:00',6.7),('8975','2013-05-09','11:45:00',3.76),('8975','2013-05-09','11:50:00',3.95),('8975','2013-05-09','11:55:00',7.04),('8975','2013-05-09','12:00:00',6.3),('8975','2013-05-09','12:05:00',5.97),('8975','2013-05-09','12:10:00',5.94),('8975','2013-05-09','12:15:00',6.25),('8975','2013-05-09','12:20:00',5.92),('8975','2013-05-09','12:25:00',4.98),('8975','2013-05-09','12:30:00',4.49),('8975','2013-05-09','12:35:00',4.77),('8975','2013-05-09','12:40:00',6.12),('8975','2013-05-09','12:45:00',6.89),('8975','2013-05-09','12:50:00',7.2),('8975','2013-05-09','12:55:00',7.62),('8975','2013-05-09','13:00:00',7.56),('8975','2013-05-09','13:05:00',5.9),('8975','2013-05-09','13:10:00',4.59),('8975','2013-05-09','13:15:00',5.35),('8975','2013-05-09','13:20:00',5.42),('8975','2013-05-09','13:25:00',4.83),('8975','2013-05-09','13:30:00',4.51),('8975','2013-05-09','13:35:00',4.31),('8975','2013-05-09','13:40:00',3.92),('8975','2013-05-09','13:45:00',4),('8975','2013-05-09','13:50:00',3.39),('8975','2013-05-09','13:55:00',3.36),('8975','2013-05-09','14:00:00',3.26),('8975','2013-05-09','14:05:00',3.59),('8975','2013-05-09','14:10:00',4.81),('8975','2013-05-09','14:15:00',4.41),('8975','2013-05-09','14:20:00',4.42),('8975','2013-05-09','14:25:00',3.99),('8975','2013-05-09','14:30:00',4.13),('8975','2013-05-09','14:35:00',4.28),('8975','2013-05-09','14:40:00',4.54),('8975','2013-05-09','14:45:00',3.15),('8975','2013-05-09','14:50:00',2.42),('8975','2013-05-09','14:55:00',2.06),('8975','2013-05-09','15:00:00',1.92),('8975','2013-05-09','15:05:00',2.09),('8975','2013-05-09','15:10:00',2.66),('8975','2013-05-09','15:15:00',3.94),('8975','2013-05-09','15:20:00',4.21),('8975','2013-05-09','15:25:00',3.38),('8975','2013-05-09','15:30:00',3.1),('8975','2013-05-09','15:35:00',3.14),('8975','2013-05-09','15:40:00',3.57),('8975','2013-05-09','15:45:00',3.3),('8975','2013-05-09','15:50:00',2.89),('8975','2013-05-09','15:55:00',2.83),('8975','2013-05-09','16:00:00',2.76),('8975','2013-05-09','16:05:00',2.61),('8975','2013-05-09','16:10:00',2.5),('8975','2013-05-09','16:15:00',2.36),('8975','2013-05-09','16:20:00',2.17),('8975','2013-05-09','16:25:00',2.18),('8975','2013-05-09','16:30:00',2.3),('8975','2013-05-09','16:35:00',2.33),('8975','2013-05-09','16:40:00',2.25),('8975','2013-05-09','16:45:00',2.17),('8975','2013-05-09','16:50:00',2.05),('8975','2013-05-09','16:55:00',1.73),('8975','2013-05-09','17:00:00',1.4),('8975','2013-05-09','17:05:00',1.38),('8975','2013-05-09','17:10:00',1.64),('8975','2013-05-09','17:15:00',2.61),('8975','2013-05-09','17:20:00',3.51),('8975','2013-05-09','17:25:00',3.27),('8975','2013-05-09','17:30:00',3.05),('8975','2013-05-09','17:35:00',2.84),('8975','2013-05-09','17:40:00',2.13),('8975','2013-05-09','17:45:00',1.99),('8975','2013-05-09','17:50:00',1.64),('8975','2013-05-09','17:55:00',1.55),('8975','2013-05-09','18:00:00',1.45),('8975','2013-05-09','18:05:00',1.38),('8975','2013-05-09','18:10:00',1.27),('8975','2013-05-09','18:15:00',1.31),('8975','2013-05-09','18:20:00',1.4),('8975','2013-05-09','18:25:00',1.03),('8975','2013-05-08','06:40:00',1.3),('8975','2013-05-08','06:55:00',1.13),('8975','2013-05-08','07:00:00',2.14),('8975','2013-05-08','07:05:00',1.73),('8975','2013-05-08','07:10:00',1.94),('8975','2013-05-08','07:15:00',2.6),('8975','2013-05-08','07:20:00',2.66),('8975','2013-05-08','07:25:00',2.78),('8975','2013-05-08','07:30:00',2.91),('8975','2013-05-08','07:35:00',3.06),('8975','2013-05-08','07:40:00',3.19),('8975','2013-05-08','07:45:00',3.31),('8975','2013-05-08','07:50:00',3.44),('8975','2013-05-08','07:55:00',3.55),('8975','2013-05-08','08:00:00',3.66),('8975','2013-05-08','08:05:00',3.73),('8975','2013-05-08','08:10:00',3.84),('8975','2013-05-08','08:15:00',3.95),('8975','2013-05-08','08:20:00',4.07),('8975','2013-05-08','08:25:00',4.17),('8975','2013-05-08','08:30:00',4.25),('8975','2013-05-08','08:35:00',4.37),('8975','2013-05-08','08:40:00',4.45),('8975','2013-05-08','08:45:00',4.57),('8975','2013-05-08','08:50:00',4.66),('8975','2013-05-08','08:55:00',4.76),('8975','2013-05-08','09:00:00',4.87),('8975','2013-05-08','09:05:00',4.85),('8975','2013-05-08','09:10:00',4.86),('8975','2013-05-08','09:15:00',4.83),('8975','2013-05-08','09:20:00',5.14),('8975','2013-05-08','09:25:00',5.16),('8975','2013-05-08','09:30:00',5.45),('8975','2013-05-08','09:35:00',5.03),('8975','2013-05-08','09:40:00',5.45),('8975','2013-05-08','09:45:00',5.51),('8975','2013-05-08','09:50:00',4.99),('8975','2013-05-08','09:55:00',5.68),('8975','2013-05-08','10:00:00',5.85),('8975','2013-05-08','10:05:00',6),('8975','2013-05-08','10:10:00',6.1),('8975','2013-05-08','10:15:00',6.22),('8975','2013-05-08','10:20:00',6.22),('8975','2013-05-08','10:25:00',6.29),('8975','2013-05-08','10:30:00',6.32),('8975','2013-05-08','10:35:00',6.33),('8975','2013-05-08','10:40:00',6.41),('8975','2013-05-08','10:45:00',6.44),('8975','2013-05-08','10:50:00',6.47),('8975','2013-05-08','10:55:00',6.53),('8975','2013-05-08','11:00:00',6.55),('8975','2013-05-08','11:05:00',6.59),('8975','2013-05-08','11:10:00',6.64),('8975','2013-05-08','11:15:00',6.65),('8975','2013-05-08','11:20:00',6.67),('8975','2013-05-08','11:25:00',6.75),('8975','2013-05-08','11:30:00',6.76),('8975','2013-05-08','11:35:00',6.73),('8975','2013-05-08','11:40:00',6.76),('8975','2013-05-08','11:45:00',6.77),('8975','2013-05-08','11:50:00',6.76),('8975','2013-05-08','11:55:00',6.78),('8975','2013-05-08','12:00:00',6.81),('8975','2013-05-08','12:05:00',6.77),('8975','2013-05-08','12:10:00',6.77),('8975','2013-05-08','12:15:00',6.79),('8975','2013-05-08','12:20:00',6.72),('8975','2013-05-08','12:25:00',6.76),('8975','2013-05-08','12:30:00',6.86),('8975','2013-05-08','12:35:00',6.86),('8975','2013-05-08','12:40:00',6.76),('8975','2013-05-08','12:45:00',6.74),('8975','2013-05-08','12:50:00',6.83),('8975','2013-05-08','12:55:00',6.04),('8975','2013-05-08','13:00:00',3.13),('8975','2013-05-08','13:05:00',6.79),('8975','2013-05-08','13:10:00',6.76),('8975','2013-05-08','13:15:00',6.67),('8975','2013-05-08','13:20:00',6.62),('8975','2013-05-08','13:25:00',6.61),('8975','2013-05-08','13:30:00',6.56),('8975','2013-05-08','13:35:00',6.61),('8975','2013-05-08','13:40:00',6.59),('8975','2013-05-08','13:45:00',6.58),('8975','2013-05-08','13:50:00',6.45),('8975','2013-05-08','13:55:00',5.94),('8975','2013-05-08','14:00:00',6.64),('8975','2013-05-08','14:05:00',6.54),('8975','2013-05-08','14:10:00',6.61),('8975','2013-05-08','14:15:00',6.55),('8975','2013-05-08','14:20:00',6.05),('8975','2013-05-08','14:25:00',6.16),('8975','2013-05-08','14:30:00',5.99),('8975','2013-05-08','14:35:00',5.91),('8975','2013-05-08','14:40:00',5.84),('8975','2013-05-08','14:45:00',5.76),('8975','2013-05-08','14:50:00',5.62),('8975','2013-05-08','14:55:00',5.61),('8975','2013-05-08','15:00:00',5.47),('8975','2013-05-08','15:05:00',5.38),('8975','2013-05-08','15:10:00',5.33),('8975','2013-05-08','15:15:00',5.23),('8975','2013-05-08','15:20:00',5.1),('8975','2013-05-08','15:25:00',5.02),('8975','2013-05-08','15:30:00',4.95),('8975','2013-05-08','15:35:00',4.87),('8975','2013-05-08','15:40:00',4.75),('8975','2013-05-08','15:45:00',4.62),('8975','2013-05-08','15:50:00',4.5),('8975','2013-05-08','15:55:00',4.4),('8975','2013-05-08','16:00:00',4.32),('8975','2013-05-08','16:05:00',4.22),('8975','2013-05-08','16:10:00',4.05),('8975','2013-05-08','16:15:00',3.93),('8975','2013-05-08','16:20:00',3.85),('8975','2013-05-08','16:25:00',3.74),('8975','2013-05-08','16:30:00',3.63),('8975','2013-05-08','16:35:00',3.49),('8975','2013-05-08','16:40:00',3.35),('8975','2013-05-08','16:45:00',3.23),('8975','2013-05-08','16:50:00',3.1),('8975','2013-05-08','16:55:00',2.98),('8975','2013-05-08','17:00:00',2.84),('8975','2013-05-08','17:05:00',2.71),('8975','2013-05-08','17:10:00',2.58),('8975','2013-05-08','17:15:00',2.46),('8975','2013-05-08','17:20:00',2.36),('8975','2013-05-08','17:25:00',2.24),('8975','2013-05-08','17:30:00',2.13),('8975','2013-05-08','17:35:00',2.03),('8975','2013-05-08','17:40:00',1.94),('8975','2013-05-08','17:45:00',1.83),('8975','2013-05-08','17:50:00',1.74),('8975','2013-05-08','17:55:00',1.66),('8975','2013-05-08','18:00:00',1.58),('8975','2013-05-08','18:05:00',1.52),('8975','2013-05-08','18:10:00',1.44),('8975','2013-05-08','18:15:00',1.41),('8975','2013-05-08','18:20:00',1.36),('8975','2013-05-08','18:25:00',1.31),('8975','2013-05-08','18:30:00',1.26),('8975','2013-05-08','18:35:00',1.21),('8975','2013-05-08','18:40:00',1.15),('8975','2013-05-08','18:45:00',1.08),('8975','2013-05-08','18:50:00',1.02),('8975','2013-05-07','07:25:00',1.53),('8975','2013-05-07','07:30:00',2.68),('8975','2013-05-07','07:45:00',1.04),('8975','2013-05-07','07:50:00',1.34),('8975','2013-05-07','07:55:00',1.15),('8975','2013-05-07','08:00:00',1.33),('8975','2013-05-07','08:05:00',3.18),('8975','2013-05-07','08:10:00',4.03),('8975','2013-05-07','08:15:00',4.29),('8975','2013-05-07','08:20:00',4.24),('8975','2013-05-07','08:25:00',4.22),('8975','2013-05-07','08:30:00',4.22),('8975','2013-05-07','08:35:00',4.17),('8975','2013-05-07','08:40:00',4.36),('8975','2013-05-07','08:45:00',4.6),('8975','2013-05-07','08:50:00',5),('8975','2013-05-07','08:55:00',3.63),('8975','2013-05-07','09:00:00',4.26),('8975','2013-05-07','09:05:00',2.88),('8975','2013-05-07','09:10:00',3.98),('8975','2013-05-07','09:15:00',4.28),('8975','2013-05-07','09:20:00',2.43),('8975','2013-05-07','09:25:00',2.65),('8975','2013-05-07','09:30:00',3.29),('8975','2013-05-07','09:35:00',4.71),('8975','2013-05-07','09:40:00',2.86),('8975','2013-05-07','09:45:00',5.98),('8975','2013-05-07','09:50:00',4.16),('8975','2013-05-07','09:55:00',3.22),('8975','2013-05-07','10:00:00',5.25),('8975','2013-05-07','10:05:00',4.07),('8975','2013-05-07','10:10:00',2.37),('8975','2013-05-07','10:15:00',1.75),('8975','2013-05-07','10:20:00',4.15),('8975','2013-05-07','10:25:00',4.46),('8975','2013-05-07','10:30:00',6.56),('8975','2013-05-07','10:35:00',7.06),('8975','2013-05-07','10:40:00',5.95),('8975','2013-05-07','10:45:00',1.97),('8975','2013-05-07','10:50:00',2.5),('8975','2013-05-07','10:55:00',7.47),('8975','2013-05-07','11:00:00',4.88),('8975','2013-05-07','11:05:00',2.09),('8975','2013-05-07','11:10:00',2.44),('8975','2013-05-07','11:15:00',6.3),('8975','2013-05-07','11:20:00',1.61),('8975','2013-05-07','11:25:00',1.79),('8975','2013-05-07','11:30:00',6.43),('8975','2013-05-07','11:35:00',7.71),('8975','2013-05-07','11:40:00',7.61),('8975','2013-05-07','11:45:00',7.74),('8975','2013-05-07','11:50:00',8.05),('8975','2013-05-07','11:55:00',5.8),('8975','2013-05-07','12:00:00',2.14),('8975','2013-05-07','12:05:00',1.23),('8975','2013-05-07','12:20:00',1.29),('8975','2013-05-07','12:25:00',2.3),('8975','2013-05-07','12:30:00',3.66),('8975','2013-05-07','12:35:00',2.96),('8975','2013-05-07','12:40:00',2.52),('8975','2013-05-07','12:45:00',1.47),('8975','2013-05-07','12:50:00',1.62),('8975','2013-05-07','12:55:00',1.47),('8975','2013-05-07','13:00:00',1.33),('8975','2013-05-07','13:05:00',1.49),('8975','2013-05-07','13:10:00',1.83),('8975','2013-05-07','13:15:00',2.07),('8975','2013-05-07','13:20:00',2.15),('8975','2013-05-07','13:25:00',2.95),('8975','2013-05-07','13:30:00',7.39),('8975','2013-05-07','13:35:00',5.22),('8975','2013-05-07','13:40:00',2.21),('8975','2013-05-07','13:45:00',5.68),('8975','2013-05-07','13:50:00',8.23),('8975','2013-05-07','13:55:00',6.89),('8975','2013-05-07','14:00:00',4.28),('8975','2013-05-07','14:05:00',7.75),('8975','2013-05-07','14:10:00',5.27),('8975','2013-05-07','14:15:00',2.5),('8975','2013-05-07','14:20:00',4.31),('8975','2013-05-07','14:25:00',5.73),('8975','2013-05-07','14:30:00',5.78),('8975','2013-05-07','14:35:00',2.63),('8975','2013-05-07','14:40:00',6.67),('8975','2013-05-07','14:45:00',5.12),('8975','2013-05-07','14:50:00',4.34),('8975','2013-05-07','14:55:00',5.99),('8975','2013-05-07','15:00:00',5.76),('8975','2013-05-07','15:05:00',5.63),('8975','2013-05-07','15:10:00',5.44),('8975','2013-05-07','15:15:00',5.31),('8975','2013-05-07','15:20:00',5.03),('8975','2013-05-07','15:25:00',5.22),('8975','2013-05-07','15:30:00',5.18),('8975','2013-05-07','15:35:00',4.98),('8975','2013-05-07','15:40:00',4.87),('8975','2013-05-07','15:45:00',4.75),('8975','2013-05-07','15:50:00',4.64),('8975','2013-05-07','15:55:00',4.5),('8975','2013-05-07','16:00:00',4.41),('8975','2013-05-07','16:05:00',4.31),('8975','2013-05-07','16:10:00',4.21),('8975','2013-05-07','16:15:00',4.09),('8975','2013-05-07','16:20:00',3.98),('8975','2013-05-07','16:25:00',3.82),('8975','2013-05-07','16:30:00',3.78),('8975','2013-05-07','16:35:00',3.7),('8975','2013-05-07','16:40:00',3.08),('8975','2013-05-07','16:45:00',2.75),('8975','2013-05-07','16:50:00',1.69),('8975','2013-05-07','16:55:00',1.5),('8975','2013-05-07','17:00:00',2.68),('8975','2013-05-07','17:05:00',3.46),('8975','2013-05-07','17:10:00',2.42),('8975','2013-05-07','17:15:00',2.64),('8975','2013-05-07','17:20:00',2.73),('8975','2013-05-07','17:25:00',2.84),('8975','2013-05-07','17:30:00',2.73),('8975','2013-05-07','17:35:00',2.55),('8975','2013-05-07','17:40:00',2.54),('8975','2013-05-07','17:45:00',2.67),('8975','2013-05-07','17:50:00',2.62),('8975','2013-05-07','17:55:00',2.59),('8975','2013-05-07','18:00:00',2.43),('8975','2013-05-07','18:05:00',1.45),('8975','2013-05-07','18:10:00',1.5),('8975','2013-05-07','18:15:00',1.7),('8975','2013-05-07','18:20:00',1.83),('8975','2013-05-07','18:25:00',1.75),('8975','2013-05-07','18:30:00',1.55),('8975','2013-05-07','18:35:00',1.1),('8975','2013-05-07','18:40:00',1.14),('8975','2013-05-07','18:50:00',1.1),('8975','2013-05-07','18:55:00',1.02),('8975','2013-05-06','06:35:00',1.18),('8975','2013-05-06','06:40:00',1.35),('8975','2013-05-06','06:55:00',1.09),('8975','2013-05-06','07:00:00',1.75),('8975','2013-05-06','07:05:00',1.52),('8975','2013-05-06','07:10:00',2.3),('8975','2013-05-06','07:15:00',2.37),('8975','2013-05-06','07:20:00',2.67),('8975','2013-05-06','07:25:00',2.8),('8975','2013-05-06','07:30:00',2.66),('8975','2013-05-06','07:35:00',3.02),('8975','2013-05-06','07:40:00',2.82),('8975','2013-05-06','07:45:00',2.9),('8975','2013-05-06','07:50:00',3.03),('8975','2013-05-06','07:55:00',3.11),('8975','2013-05-06','08:00:00',3.64),('8975','2013-05-06','08:05:00',3.71),('8975','2013-05-06','08:10:00',3.84),('8975','2013-05-06','08:15:00',3.97),('8975','2013-05-06','08:20:00',4.1),('8975','2013-05-06','08:25:00',4.18),('8975','2013-05-06','08:30:00',4.31),('8975','2013-05-06','08:35:00',4.44),('8975','2013-05-06','08:40:00',4.45),('8975','2013-05-06','08:45:00',4.68),('8975','2013-05-06','08:50:00',4.51),('8975','2013-05-06','08:55:00',4.5),('8975','2013-05-06','09:00:00',4.9),('8975','2013-05-06','09:05:00',4.02),('8975','2013-05-06','09:10:00',2.74),('8975','2013-05-06','09:15:00',2.52),('8975','2013-05-06','09:20:00',1.67),('8975','2013-05-06','09:25:00',3.59),('8975','2013-05-06','09:30:00',2.28),('8975','2013-05-06','09:35:00',3.19),('8975','2013-05-06','09:40:00',5.36),('8975','2013-05-06','09:45:00',7.36),('8975','2013-05-06','09:50:00',3.22),('8975','2013-05-06','09:55:00',3.45),('8975','2013-05-06','10:00:00',5.42),('8975','2013-05-06','10:05:00',1.7),('8975','2013-05-06','10:10:00',1.48),('8975','2013-05-06','10:15:00',1.81),('8975','2013-05-06','10:20:00',1.28),('8975','2013-05-06','10:25:00',1.03),('8975','2013-05-06','10:45:00',1.01),('8975','2013-05-06','10:50:00',1.13),('8975','2013-05-06','10:55:00',1.21),('8975','2013-05-06','11:00:00',1.55),('8975','2013-05-06','11:05:00',2.38),('8975','2013-05-06','11:10:00',4.26),('8975','2013-05-06','11:15:00',6.32),('8975','2013-05-06','11:20:00',4.13),('8975','2013-05-06','11:25:00',1.5),('8975','2013-05-06','11:30:00',1.6),('8975','2013-05-06','11:35:00',1),('8975','2013-05-06','11:55:00',1.08),('8975','2013-05-06','12:00:00',1.08),('8975','2013-05-06','12:05:00',1.04),('8975','2013-05-06','12:10:00',1.15),('8975','2013-05-06','12:15:00',1.25),('8975','2013-05-06','12:20:00',1.17),('8975','2013-05-06','12:25:00',1.13),('8975','2013-05-06','12:45:00',1.11),('8975','2013-05-06','12:50:00',1.5),('8975','2013-05-06','12:55:00',1.73),('8975','2013-05-06','13:00:00',3.05),('8975','2013-05-06','13:05:00',4.71),('8975','2013-05-06','13:10:00',7.82),('8975','2013-05-06','13:15:00',7.16),('8975','2013-05-06','13:20:00',5.28),('8975','2013-05-06','13:25:00',4.08),('8975','2013-05-06','13:30:00',7.42),('8975','2013-05-06','13:35:00',7.87),('8975','2013-05-06','13:40:00',7.61),('8975','2013-05-06','13:45:00',7.22),('8975','2013-05-06','13:50:00',7.15),('8975','2013-05-06','13:55:00',6.97),('8975','2013-05-06','14:00:00',6.76),('8975','2013-05-06','14:05:00',6.68),('8975','2013-05-06','14:10:00',6.64),('8975','2013-05-06','14:15:00',6.76),('8975','2013-05-06','14:20:00',5),('8975','2013-05-06','14:25:00',4.67),('8975','2013-05-06','14:30:00',5.33),('8975','2013-05-06','14:35:00',7.08),('8975','2013-05-06','14:40:00',5.39),('8975','2013-05-06','14:45:00',6.4),('8975','2013-05-06','14:50:00',3.33),('8975','2013-05-06','14:55:00',6.59),('8975','2013-05-06','15:00:00',5.06),('8975','2013-05-06','15:05:00',6),('8975','2013-05-06','15:10:00',5.77),('8975','2013-05-06','15:15:00',5.79),('8975','2013-05-06','15:20:00',5.98),('8975','2013-05-06','15:25:00',6.09),('8975','2013-05-06','15:30:00',5.3),('8975','2013-05-06','15:35:00',3.51),('8975','2013-05-06','15:40:00',2.52),('8975','2013-05-06','15:45:00',2.21),('8975','2013-05-06','15:50:00',2.18),('8975','2013-05-06','15:55:00',3.83),('8975','2013-05-06','16:00:00',4.61),('8975','2013-05-06','16:05:00',2.36),('8975','2013-05-06','16:10:00',2.73),('8975','2013-05-06','16:15:00',5.13),('8975','2013-05-06','16:20:00',2.62),('8975','2013-05-06','16:25:00',4.82),('8975','2013-05-06','16:30:00',4.86),('8975','2013-05-06','16:35:00',4.52),('8975','2013-05-06','16:40:00',4.63),('8975','2013-05-06','16:45:00',3.87),('8975','2013-05-06','16:50:00',4.57),('8975','2013-05-06','16:55:00',3.69),('8975','2013-05-06','17:00:00',3.87),('8975','2013-05-06','17:05:00',3.13),('8975','2013-05-06','17:10:00',1.91),('8975','2013-05-06','17:15:00',1.81),('8975','2013-05-06','17:20:00',2.07),('8975','2013-05-06','17:25:00',1.94),('8975','2013-05-06','17:30:00',1.72),('8975','2013-05-06','17:35:00',1.59),('8975','2013-05-06','17:40:00',1.49),('8975','2013-05-06','17:45:00',1.4),('8975','2013-05-06','17:50:00',1.2),('8975','2013-05-06','18:45:00',1.54),('8975','2013-05-05','08:15:00',1.13),('8975','2013-05-05','08:20:00',1.38),('8975','2013-05-05','08:25:00',1.88),('8975','2013-05-05','08:30:00',2.09),('8975','2013-05-05','08:35:00',1.97),('8975','2013-05-05','08:40:00',1.43),('8975','2013-05-05','08:45:00',1.56),('8975','2013-05-05','08:50:00',3.56),('8975','2013-05-05','08:55:00',3.42),('8975','2013-05-05','09:00:00',3.5),('8975','2013-05-05','09:05:00',2.64),('8975','2013-05-05','09:10:00',3.22),('8975','2013-05-05','09:15:00',1.87),('8975','2013-05-05','09:20:00',2.22),('8975','2013-05-05','09:25:00',1.82),('8975','2013-05-05','09:30:00',1.3),('8975','2013-05-05','09:50:00',1.48),('8975','2013-05-05','09:55:00',2.41),('8975','2013-05-05','10:00:00',3.38),('8975','2013-05-05','10:05:00',1.82),('8975','2013-05-05','10:10:00',1.86),('8975','2013-05-05','10:15:00',3.48),('8975','2013-05-05','10:20:00',3.65),('8975','2013-05-05','10:25:00',3.47),('8975','2013-05-05','10:30:00',3.52),('8975','2013-05-05','10:35:00',3.1),('8975','2013-05-05','10:40:00',2.97),('8975','2013-05-05','10:45:00',4.53),('8975','2013-05-05','10:50:00',2.95),('8975','2013-05-05','10:55:00',3.55),('8975','2013-05-05','11:00:00',3.34),('8975','2013-05-05','11:05:00',3.41),('8975','2013-05-05','11:10:00',3.03),('8975','2013-05-05','11:15:00',2.8),('8975','2013-05-05','11:20:00',3.47),('8975','2013-05-05','11:25:00',3.3),('8975','2013-05-05','11:30:00',2.01),('8975','2013-05-05','11:35:00',3.97),('8975','2013-05-05','11:40:00',3.7),('8975','2013-05-05','11:45:00',6.02),('8975','2013-05-05','11:50:00',2.5),('8975','2013-05-05','11:55:00',2.84),('8975','2013-05-05','12:00:00',4.13),('8975','2013-05-05','12:05:00',3.88),('8975','2013-05-05','12:10:00',4.47),('8975','2013-05-05','12:15:00',2.99),('8975','2013-05-05','12:20:00',7.11),('8975','2013-05-05','12:25:00',4.18),('8975','2013-05-05','12:30:00',5.94),('8975','2013-05-05','12:35:00',6.66),('8975','2013-05-05','12:40:00',3.62),('8975','2013-05-05','12:45:00',3.85),('8975','2013-05-05','12:50:00',3.76),('8975','2013-05-05','12:55:00',5.96),('8975','2013-05-05','13:00:00',6.39),('8975','2013-05-05','13:05:00',7.85),('8975','2013-05-05','13:10:00',6.48),('8975','2013-05-05','13:15:00',5.73),('8975','2013-05-05','13:20:00',6.47),('8975','2013-05-05','13:25:00',6.67),('8975','2013-05-05','13:30:00',7.89),('8975','2013-05-05','13:35:00',6.32),('8975','2013-05-05','13:40:00',7.13),('8975','2013-05-05','13:45:00',7.03),('8975','2013-05-05','13:50:00',6.05),('8975','2013-05-05','13:55:00',5.28),('8975','2013-05-05','14:00:00',6.83),('8975','2013-05-05','14:05:00',4.94),('8975','2013-05-05','14:10:00',6.38),('8975','2013-05-05','14:15:00',4.24),('8975','2013-05-05','14:20:00',6.28),('8975','2013-05-05','14:25:00',4.27),('8975','2013-05-05','14:30:00',5.64),('8975','2013-05-05','14:35:00',6.95),('8975','2013-05-05','14:40:00',5.31),('8975','2013-05-05','14:45:00',5.04),('8975','2013-05-05','14:50:00',3.3),('8975','2013-05-05','14:55:00',6.46),('8975','2013-05-05','15:00:00',3.35),('8975','2013-05-05','15:05:00',4.36),('8975','2013-05-05','15:10:00',5.49),('8975','2013-05-05','15:15:00',4.06),('8975','2013-05-05','15:20:00',4.6),('8975','2013-05-05','15:25:00',5.28),('8975','2013-05-05','15:30:00',3.31),('8975','2013-05-05','15:35:00',3.04),('8975','2013-05-05','15:40:00',3.29),('8975','2013-05-05','15:45:00',3.82),('8975','2013-05-05','15:50:00',4.65),('8975','2013-05-05','15:55:00',2.11),('8975','2013-05-05','16:00:00',3),('8975','2013-05-05','16:05:00',2.08),('8975','2013-05-05','16:10:00',2.66),('8975','2013-05-05','16:15:00',3.35),('8975','2013-05-05','16:20:00',3.11),('8975','2013-05-05','16:25:00',3.11),('8975','2013-05-05','16:30:00',2.22),('8975','2013-05-05','16:35:00',2.92),('8975','2013-05-05','16:40:00',1.82),('8975','2013-05-05','16:45:00',3.4),('8975','2013-05-05','16:50:00',3.38),('8975','2013-05-05','16:55:00',2.66),('8975','2013-05-05','17:00:00',1.17),('8975','2013-05-05','17:10:00',2.12),('8975','2013-05-05','17:15:00',3.4),('8975','2013-05-05','17:20:00',1.91),('8975','2013-05-05','17:25:00',1.62),('8975','2013-05-05','17:30:00',1.02),('8975','2013-05-05','17:35:00',1.41),('8975','2013-05-05','17:40:00',2.08),('8975','2013-05-05','17:45:00',2.14),('8975','2013-05-05','17:50:00',1.14),('8975','2013-05-05','17:55:00',1.02),('8975','2013-05-05','18:00:00',1.39),('8975','2013-05-05','18:05:00',1.54),('8975','2013-05-05','18:10:00',1.43),('8975','2013-05-05','18:15:00',1.15),('8975','2013-05-05','18:20:00',1.91),('8975','2013-05-05','18:25:00',1.25),('8975','2013-05-04','07:10:00',1.32),('8975','2013-05-04','07:15:00',1.93),('8975','2013-05-04','07:20:00',2.08),('8975','2013-05-04','07:25:00',1.37),('8975','2013-05-04','07:30:00',1.63),('8975','2013-05-04','07:35:00',1.26),('8975','2013-05-04','07:40:00',2.2),('8975','2013-05-04','07:45:00',2.77),('8975','2013-05-04','07:50:00',2.35),('8975','2013-05-04','07:55:00',2.84),('8975','2013-05-04','08:00:00',3.04),('8975','2013-05-04','08:05:00',3.34),('8975','2013-05-04','08:10:00',3.45),('8975','2013-05-04','08:15:00',3.59),('8975','2013-05-04','08:20:00',4.02),('8975','2013-05-04','08:25:00',4.22),('8975','2013-05-04','08:30:00',4.28),('8975','2013-05-04','08:35:00',4.14),('8975','2013-05-04','08:40:00',3.78),('8975','2013-05-04','08:45:00',2.72),('8975','2013-05-04','08:50:00',2.84),('8975','2013-05-04','08:55:00',2.34),('8975','2013-05-04','09:00:00',2.42),('8975','2013-05-04','09:05:00',2.4),('8975','2013-05-04','09:10:00',2.57),('8975','2013-05-04','09:15:00',2.26),('8975','2013-05-04','09:20:00',2.63),('8975','2013-05-04','09:25:00',2.93),('8975','2013-05-04','09:30:00',2.33),('8975','2013-05-04','09:35:00',3.63),('8975','2013-05-04','09:40:00',4.17),('8975','2013-05-04','09:45:00',5.64),('8975','2013-05-04','09:50:00',4.69),('8975','2013-05-04','09:55:00',4.99),('8975','2013-05-04','10:00:00',4.59),('8975','2013-05-04','10:05:00',4.82),('8975','2013-05-04','10:10:00',4.01),('8975','2013-05-04','10:15:00',5.63),('8975','2013-05-04','10:20:00',5.46),('8975','2013-05-04','10:25:00',4.37),('8975','2013-05-04','10:30:00',4.69),('8975','2013-05-04','10:35:00',5.81),('8975','2013-05-04','10:40:00',6.24),('8975','2013-05-04','10:45:00',4.92),('8975','2013-05-04','10:50:00',4.07),('8975','2013-05-04','10:55:00',2.94),('8975','2013-05-04','11:00:00',2.71),('8975','2013-05-04','11:05:00',3.51),('8975','2013-05-04','11:10:00',2.93),('8975','2013-05-04','11:15:00',3.14),('8975','2013-05-04','11:20:00',4.79),('8975','2013-05-04','11:25:00',6.71),('8975','2013-05-04','11:30:00',4.83),('8975','2013-05-04','11:35:00',6.3),('8975','2013-05-04','11:40:00',4.62),('8975','2013-05-04','11:45:00',4.43),('8975','2013-05-04','11:50:00',5.24),('8975','2013-05-04','11:55:00',4.24),('8975','2013-05-04','12:00:00',4.37),('8975','2013-05-04','12:05:00',4.27),('8975','2013-05-04','12:10:00',4.75),('8975','2013-05-04','12:15:00',4.96),('8975','2013-05-04','12:20:00',4.92),('8975','2013-05-04','12:25:00',7.56),('8975','2013-05-04','12:30:00',6.87),('8975','2013-05-04','12:35:00',6.62),('8975','2013-05-04','12:40:00',7.05),('8975','2013-05-04','12:45:00',6.74),('8975','2013-05-04','12:50:00',4.71),('8975','2013-05-04','12:55:00',5.3),('8975','2013-05-04','13:00:00',5.13),('8975','2013-05-04','13:05:00',3.5),('8975','2013-05-04','13:10:00',3.96),('8975','2013-05-04','13:15:00',6.1),('8975','2013-05-04','13:20:00',6.79),('8975','2013-05-04','13:25:00',5.89),('8975','2013-05-04','13:30:00',4.82),('8975','2013-05-04','13:35:00',7.21),('8975','2013-05-04','13:40:00',6.62),('8975','2013-05-04','13:45:00',6.45),('8975','2013-05-04','13:50:00',6.55),('8975','2013-05-04','13:55:00',6.44),('8975','2013-05-04','14:00:00',6.57),('8975','2013-05-04','14:05:00',6.17),('8975','2013-05-04','14:10:00',4.9),('8975','2013-05-04','14:15:00',5.65),('8975','2013-05-04','14:20:00',6.27),('8975','2013-05-04','14:25:00',5.79),('8975','2013-05-04','14:30:00',5.63),('8975','2013-05-04','14:35:00',5.55),('8975','2013-05-04','14:40:00',5.44),('8975','2013-05-04','14:45:00',5.38),('8975','2013-05-04','14:50:00',5.33),('8975','2013-05-04','14:55:00',5.22),('8975','2013-05-04','15:00:00',5.17),('8975','2013-05-04','15:05:00',5.09),('8975','2013-05-04','15:10:00',4.98),('8975','2013-05-04','15:15:00',4.91),('8975','2013-05-04','15:20:00',4.86),('8975','2013-05-04','15:25:00',4.76),('8975','2013-05-04','15:30:00',4.69),('8975','2013-05-04','15:35:00',4.58),('8975','2013-05-04','15:40:00',4.44),('8975','2013-05-04','15:45:00',4.36),('8975','2013-05-04','15:50:00',4.25),('8975','2013-05-04','15:55:00',4.14),('8975','2013-05-04','16:00:00',4.04),('8975','2013-05-04','16:05:00',3.93),('8975','2013-05-04','16:10:00',3.81),('8975','2013-05-04','16:15:00',3.71),('8975','2013-05-04','16:20:00',3.61),('8975','2013-05-04','16:25:00',3.49),('8975','2013-05-04','16:30:00',3.38),('8975','2013-05-04','16:35:00',3.27),('8975','2013-05-04','16:40:00',3.15),('8975','2013-05-04','16:45:00',3.03),('8975','2013-05-04','16:50:00',2.89),('8975','2013-05-04','16:55:00',2.76),('8975','2013-05-04','17:00:00',2.64),('8975','2013-05-04','17:05:00',2.52),('8975','2013-05-04','17:10:00',2.4),('8975','2013-05-04','17:15:00',2.32),('8975','2013-05-04','17:20:00',2.21),('8975','2013-05-04','17:25:00',2.09),('8975','2013-05-04','17:30:00',1.93),('8975','2013-05-04','17:35:00',1.66),('8975','2013-05-04','17:40:00',1.61),('8975','2013-05-04','17:45:00',1.63),('8975','2013-05-04','17:50:00',1.4),('8975','2013-05-04','17:55:00',1.23),('8975','2013-05-04','18:00:00',1.51),('8975','2013-05-04','18:05:00',1.36),('8975','2013-05-04','18:10:00',1.19),('8975','2013-05-04','18:15:00',1.2),('8975','2013-05-04','18:20:00',1.23),('8975','2013-05-04','18:25:00',1.07),('8975','2013-05-04','18:30:00',1.04),('8975','2013-05-04','18:35:00',1.07),('8975','2013-05-04','18:40:00',1.07),('8975','2013-05-03','07:00:00',1.06),('8975','2013-05-03','07:05:00',1.2),('8975','2013-05-03','07:10:00',1.47),('8975','2013-05-03','07:15:00',1.07),('8975','2013-05-03','07:35:00',2.35),('8975','2013-05-03','07:40:00',2.52),('8975','2013-05-03','07:45:00',2.45),('8975','2013-05-03','07:50:00',2.8),('8975','2013-05-03','07:55:00',3.13),('8975','2013-05-03','08:00:00',3.19),('8975','2013-05-03','08:05:00',3.32),('8975','2013-05-03','08:10:00',3.41),('8975','2013-05-03','08:15:00',3.53),('8975','2013-05-03','08:20:00',3.61),('8975','2013-05-03','08:25:00',3.67),('8975','2013-05-03','08:30:00',3.82),('8975','2013-05-03','08:35:00',3.91),('8975','2013-05-03','08:40:00',4.03),('8975','2013-05-03','08:45:00',4.13),('8975','2013-05-03','08:50:00',4.22),('8975','2013-05-03','08:55:00',4.26),('8975','2013-05-03','09:00:00',4.31),('8975','2013-05-03','09:05:00',4.43),('8975','2013-05-03','09:10:00',4.49),('8975','2013-05-03','09:15:00',4.61),('8975','2013-05-03','09:20:00',4.72),('8975','2013-05-03','09:25:00',4.72),('8975','2013-05-03','09:30:00',4.73),('8975','2013-05-03','09:35:00',5.05),('8975','2013-05-03','09:40:00',5.12),('8975','2013-05-03','09:45:00',5.26),('8975','2013-05-03','09:50:00',5.35),('8975','2013-05-03','09:55:00',5.42),('8975','2013-05-03','10:00:00',5.53),('8975','2013-05-03','10:05:00',5.55),('8975','2013-05-03','10:10:00',5.64),('8975','2013-05-03','10:15:00',5.73),('8975','2013-05-03','10:20:00',5.79),('8975','2013-05-03','10:25:00',5.82),('8975','2013-05-03','10:30:00',5.87),('8975','2013-05-03','10:35:00',5.86),('8975','2013-05-03','10:40:00',5.91),('8975','2013-05-03','10:45:00',5.87),('8975','2013-05-03','10:50:00',5.69),('8975','2013-05-03','10:55:00',5.68),('8975','2013-05-03','11:00:00',5.68),('8975','2013-05-03','11:05:00',5.54),('8975','2013-05-03','11:10:00',5.29),('8975','2013-05-03','11:15:00',5.22),('8975','2013-05-03','11:20:00',5.71),('8975','2013-05-03','11:25:00',5.42),('8975','2013-05-03','11:30:00',5.57),('8975','2013-05-03','11:35:00',5.48),('8975','2013-05-03','11:40:00',5.48),('8975','2013-05-03','11:45:00',5.65),('8975','2013-05-03','11:50:00',5.51),('8975','2013-05-03','11:55:00',5.53),('8975','2013-05-03','12:00:00',5.47),('8975','2013-05-03','12:05:00',5.77),('8975','2013-05-03','12:10:00',5.69),('8975','2013-05-03','12:15:00',5.91),('8975','2013-05-03','12:20:00',5.93),('8975','2013-05-03','12:25:00',5.98),('8975','2013-05-03','12:30:00',6.07),('8975','2013-05-03','12:35:00',6.07),('8975','2013-05-03','12:40:00',6.04),('8975','2013-05-03','12:45:00',5.95),('8975','2013-05-03','12:50:00',5.65),('8975','2013-05-03','12:55:00',5.43),('8975','2013-05-03','13:00:00',5.19),('8975','2013-05-03','13:05:00',5.24),('8975','2013-05-03','13:10:00',6.11),('8975','2013-05-03','13:15:00',6.15),('8975','2013-05-03','13:20:00',6.06),('8975','2013-05-03','13:25:00',5.66),('8975','2013-05-03','13:30:00',5.9),('8975','2013-05-03','13:35:00',5.52),('8975','2013-05-03','13:40:00',5.58),('8975','2013-05-03','13:45:00',5.06),('8975','2013-05-03','13:50:00',5.2),('8975','2013-05-03','13:55:00',4.83),('8975','2013-05-03','14:00:00',5.23),('8975','2013-05-03','14:05:00',5.24),('8975','2013-05-03','14:10:00',5.04),('8975','2013-05-03','14:15:00',5.28),('8975','2013-05-03','14:20:00',5.09),('8975','2013-05-03','14:25:00',4.85),('8975','2013-05-03','14:30:00',4.92),('8975','2013-05-03','14:35:00',4.8),('8975','2013-05-03','14:40:00',4.96),('8975','2013-05-03','14:45:00',4.7),('8975','2013-05-03','14:50:00',4.67),('8975','2013-05-03','14:55:00',4.7),('8975','2013-05-03','15:00:00',4.84),('8975','2013-05-03','15:05:00',4.77),('8975','2013-05-03','15:10:00',4.37),('8975','2013-05-03','15:15:00',4.58),('8975','2013-05-03','15:20:00',4.59),('8975','2013-05-03','15:25:00',4.59),('8975','2013-05-03','15:30:00',4.52),('8975','2013-05-03','15:35:00',4.2),('8975','2013-05-03','15:40:00',4.36),('8975','2013-05-03','15:45:00',4.23),('8975','2013-05-03','15:50:00',4.11),('8975','2013-05-03','15:55:00',3.99),('8975','2013-05-03','16:00:00',3.88),('8975','2013-05-03','16:05:00',3.76),('8975','2013-05-03','16:10:00',3.57),('8975','2013-05-03','16:15:00',3.49),('8975','2013-05-03','16:20:00',3.46),('8975','2013-05-03','16:25:00',3.35),('8975','2013-05-03','16:30:00',3.2),('8975','2013-05-03','16:35:00',3.01),('8975','2013-05-03','16:40:00',2.6),('8975','2013-05-03','16:45:00',2.63),('8975','2013-05-03','16:50:00',2.7),('8975','2013-05-03','16:55:00',2.6),('8975','2013-05-03','17:00:00',2.54),('8975','2013-05-03','17:05:00',2.2),('8975','2013-05-03','17:10:00',1.89),('8975','2013-05-03','17:15:00',2.19),('8975','2013-05-03','17:20:00',2.15),('8975','2013-05-03','17:25:00',2.02),('8975','2013-05-03','17:30:00',1.85),('8975','2013-05-03','17:35:00',1.8),('8975','2013-05-03','17:40:00',1.72),('8975','2013-05-03','17:45:00',1.68),('8975','2013-05-03','17:50:00',1.62),('8975','2013-05-03','17:55:00',1.54),('8975','2013-05-03','18:00:00',1.5),('8975','2013-05-03','18:05:00',1.44),('8975','2013-05-03','18:10:00',1.2),('8975','2013-05-03','18:15:00',1.08),('8975','2013-05-02','07:25:00',1.14),('8975','2013-05-02','07:30:00',1),('8975','2013-05-02','07:45:00',1.12),('8975','2013-05-02','07:50:00',1.48),('8975','2013-05-02','07:55:00',1.7),('8975','2013-05-02','08:00:00',2.1),('8975','2013-05-02','08:05:00',3.22),('8975','2013-05-02','08:10:00',3.77),('8975','2013-05-02','08:15:00',3.95),('8975','2013-05-02','08:20:00',3.93),('8975','2013-05-02','08:25:00',3.96),('8975','2013-05-02','08:30:00',4.09),('8975','2013-05-02','08:35:00',4.19),('8975','2013-05-02','08:40:00',4.31),('8975','2013-05-02','08:45:00',4.29),('8975','2013-05-02','08:50:00',4.19),('8975','2013-05-02','08:55:00',4.23),('8975','2013-05-02','09:00:00',4.54),('8975','2013-05-02','09:05:00',4.68),('8975','2013-05-02','09:10:00',4.79),('8975','2013-05-02','09:15:00',4.91),('8975','2013-05-02','09:20:00',4.97),('8975','2013-05-02','09:25:00',5.08),('8975','2013-05-02','09:30:00',5.21),('8975','2013-05-02','09:35:00',5.28),('8975','2013-05-02','09:40:00',5.35),('8975','2013-05-02','09:45:00',5.41),('8975','2013-05-02','09:50:00',5.45),('8975','2013-05-02','09:55:00',5.56),('8975','2013-05-02','10:00:00',5.57),('8975','2013-05-02','10:05:00',5.71),('8975','2013-05-02','10:10:00',5.8),('8975','2013-05-02','10:15:00',5.84),('8975','2013-05-02','10:20:00',5.9),('8975','2013-05-02','10:25:00',5.94),('8975','2013-05-02','10:30:00',6.02),('8975','2013-05-02','10:35:00',6.05),('8975','2013-05-02','10:40:00',6.12),('8975','2013-05-02','10:45:00',6.16),('8975','2013-05-02','10:50:00',6.22),('8975','2013-05-02','10:55:00',6.27),('8975','2013-05-02','11:00:00',6.28),('8975','2013-05-02','11:05:00',6.31),('8975','2013-05-02','11:10:00',6.34),('8975','2013-05-02','11:15:00',6.36),('8975','2013-05-02','11:20:00',6.37),('8975','2013-05-02','11:25:00',6.38),('8975','2013-05-02','11:30:00',6.41),('8975','2013-05-02','11:35:00',6.42),('8975','2013-05-02','11:40:00',6.48),('8975','2013-05-02','11:45:00',6.47),('8975','2013-05-02','11:50:00',6.48),('8975','2013-05-02','11:55:00',6.48),('8975','2013-05-02','12:00:00',6.47),('8975','2013-05-02','12:05:00',6.46),('8975','2013-05-02','12:10:00',6.51),('8975','2013-05-02','12:15:00',6.46),('8975','2013-05-02','12:20:00',6.36),('8975','2013-05-02','12:25:00',6.14),('8975','2013-05-02','12:30:00',6.2),('8975','2013-05-02','12:35:00',5.24),('8975','2013-05-02','12:40:00',5.6),('8975','2013-05-02','12:45:00',6.02),('8975','2013-05-02','12:50:00',6.32),('8975','2013-05-02','12:55:00',6.16),('8975','2013-05-02','13:00:00',6.23),('8975','2013-05-02','13:05:00',5.42),('8975','2013-05-02','13:10:00',6.13),('8975','2013-05-02','13:15:00',6.1),('8975','2013-05-02','13:20:00',6.1),('8975','2013-05-02','13:25:00',6.05),('8975','2013-05-02','13:30:00',6.06),('8975','2013-05-02','13:35:00',5.92),('8975','2013-05-02','13:40:00',5.8),('8975','2013-05-02','13:45:00',5.68),('8975','2013-05-02','13:50:00',5.78),('8975','2013-05-02','13:55:00',5.79),('8975','2013-05-02','14:00:00',5.6),('8975','2013-05-02','14:05:00',5.64),('8975','2013-05-02','14:10:00',5.46),('8975','2013-05-02','14:15:00',5.23),('8975','2013-05-02','14:20:00',5.45),('8975','2013-05-02','14:25:00',5.36),('8975','2013-05-02','14:30:00',5.3),('8975','2013-05-02','14:35:00',5.35),('8975','2013-05-02','14:40:00',5.27),('8975','2013-05-02','14:45:00',5.2),('8975','2013-05-02','14:50:00',5.18),('8975','2013-05-02','14:55:00',5.12),('8975','2013-05-02','15:00:00',5.05),('8975','2013-05-02','15:05:00',4.95),('8975','2013-05-02','15:10:00',4.89),('8975','2013-05-02','15:15:00',4.8),('8975','2013-05-02','15:20:00',4.74),('8975','2013-05-02','15:25:00',4.66),('8975','2013-05-02','15:30:00',4.58),('8975','2013-05-02','15:35:00',4.48),('8975','2013-05-02','15:40:00',4.39),('8975','2013-05-02','15:45:00',4.26),('8975','2013-05-02','15:50:00',4.15),('8975','2013-05-02','15:55:00',4.09),('8975','2013-05-02','16:00:00',3.99),('8975','2013-05-02','16:05:00',3.88),('8975','2013-05-02','16:10:00',3.79),('8975','2013-05-02','16:15:00',3.66),('8975','2013-05-02','16:20:00',3.47),('8975','2013-05-02','16:25:00',3.41),('8975','2013-05-02','16:30:00',3.36),('8975','2013-05-02','16:35:00',3.25),('8975','2013-05-02','16:40:00',3.13),('8975','2013-05-02','16:45:00',2.97),('8975','2013-05-02','16:50:00',2.87),('8975','2013-05-02','16:55:00',2.75),('8975','2013-05-02','17:00:00',2.62),('8975','2013-05-02','17:05:00',2.51),('8975','2013-05-02','17:10:00',2.38),('8975','2013-05-02','17:15:00',2.27),('8975','2013-05-02','17:20:00',2.16),('8975','2013-05-02','17:25:00',2.03),('8975','2013-05-02','17:30:00',1.92),('8975','2013-05-02','17:35:00',1.81),('8975','2013-05-02','17:40:00',1.72),('8975','2013-05-02','17:45:00',1.65),('8975','2013-05-02','17:50:00',1.57),('8975','2013-05-02','17:55:00',1.51),('8975','2013-05-02','18:00:00',1.44),('8975','2013-05-02','18:05:00',1.38),('8975','2013-05-02','18:10:00',1.33),('8975','2013-05-02','18:15:00',1.27),('8975','2013-05-02','18:20:00',1.2),('8975','2013-05-02','18:25:00',1.16),('8975','2013-05-02','18:30:00',1.11),('8975','2013-05-02','18:35:00',1.04),('8975','2013-05-01','08:40:00',1.49),('8975','2013-05-01','08:45:00',1.2),('8975','2013-05-01','08:50:00',1.36),('8975','2013-05-01','08:55:00',2.31),('8975','2013-05-01','09:00:00',3.37),('8975','2013-05-01','09:05:00',2.22),('8975','2013-05-01','09:10:00',1.42),('8975','2013-05-01','09:15:00',1.41),('8975','2013-05-01','09:20:00',1.9),('8975','2013-05-01','09:25:00',2.72),('8975','2013-05-01','09:30:00',3.29),('8975','2013-05-01','09:35:00',3.63),('8975','2013-05-01','09:40:00',3.09),('8975','2013-05-01','09:45:00',3.95),('8975','2013-05-01','09:50:00',2.07),('8975','2013-05-01','09:55:00',1.66),('8975','2013-05-01','10:00:00',1.84),('8975','2013-05-01','10:05:00',2.55),('8975','2013-05-01','10:10:00',2.31),('8975','2013-05-01','10:15:00',2.47),('8975','2013-05-01','10:20:00',2.57),('8975','2013-05-01','10:25:00',3.49),('8975','2013-05-01','10:30:00',5.08),('8975','2013-05-01','10:35:00',4.77),('8975','2013-05-01','10:40:00',6.44),('8975','2013-05-01','10:45:00',3.28),('8975','2013-05-01','10:50:00',6.26),('8975','2013-05-01','10:55:00',6.85),('8975','2013-05-01','11:00:00',6.66),('8975','2013-05-01','11:05:00',5.87),('8975','2013-05-01','11:10:00',4.88),('8975','2013-05-01','11:15:00',5.3),('8975','2013-05-01','11:20:00',5.92),('8975','2013-05-01','11:25:00',6.65),('8975','2013-05-01','11:30:00',6.48),('8975','2013-05-01','11:35:00',6.41),('8975','2013-05-01','11:40:00',6.36),('8975','2013-05-01','11:45:00',6.34),('8975','2013-05-01','11:50:00',6.35),('8975','2013-05-01','11:55:00',6.29),('8975','2013-05-01','12:00:00',6.22),('8975','2013-05-01','12:05:00',6.28),('8975','2013-05-01','12:10:00',6.32),('8975','2013-05-01','12:15:00',6.33),('8975','2013-05-01','12:20:00',6.29),('8975','2013-05-01','12:25:00',6.35),('8975','2013-05-01','12:30:00',6.42),('8975','2013-05-01','12:35:00',6.49),('8975','2013-05-01','12:40:00',6.47),('8975','2013-05-01','12:45:00',6.44),('8975','2013-05-01','12:50:00',6.5),('8975','2013-05-01','12:55:00',6.52),('8975','2013-05-01','13:00:00',6.54),('8975','2013-05-01','13:05:00',6.5),('8975','2013-05-01','13:10:00',6.53),('8975','2013-05-01','13:15:00',6.48),('8975','2013-05-01','13:20:00',6.49),('8975','2013-05-01','13:25:00',6.44),('8975','2013-05-01','13:30:00',6.38),('8975','2013-05-01','13:35:00',6.34),('8975','2013-05-01','13:40:00',6.23),('8975','2013-05-01','13:45:00',6.21),('8975','2013-05-01','13:50:00',6.19),('8975','2013-05-01','13:55:00',6.08),('8975','2013-05-01','14:00:00',6.02),('8975','2013-05-01','14:05:00',5.97),('8975','2013-05-01','14:10:00',5.91),('8975','2013-05-01','14:15:00',5.84),('8975','2013-05-01','14:20:00',5.77),('8975','2013-05-01','14:25:00',5.7),('8975','2013-05-01','14:30:00',5.61),('8975','2013-05-01','14:35:00',5.55),('8975','2013-05-01','14:40:00',5.49),('8975','2013-05-01','14:45:00',5.44),('8975','2013-05-01','14:50:00',5.37),('8975','2013-05-01','14:55:00',5.28),('8975','2013-05-01','15:00:00',5.17),('8975','2013-05-01','15:05:00',5.06),('8975','2013-05-01','15:10:00',4.97),('8975','2013-05-01','15:15:00',4.89),('8975','2013-05-01','15:20:00',4.76),('8975','2013-05-01','15:25:00',4.65),('8975','2013-05-01','15:30:00',4.51),('8975','2013-05-01','15:35:00',4.42),('8975','2013-05-01','15:40:00',4.28),('8975','2013-05-01','15:45:00',4.2),('8975','2013-05-01','15:50:00',4.11),('8975','2013-05-01','15:55:00',4.01),('8975','2013-05-01','16:00:00',3.91),('8975','2013-05-01','16:05:00',3.81),('8975','2013-05-01','16:10:00',3.71),('8975','2013-05-01','16:15:00',3.62),('8975','2013-05-01','16:20:00',3.5),('8975','2013-05-01','16:25:00',3.4),('8975','2013-05-01','16:30:00',3.28),('8975','2013-05-01','16:35:00',3.18),('8975','2013-05-01','16:40:00',3.08),('8975','2013-05-01','16:45:00',2.94),('8975','2013-05-01','16:50:00',2.83),('8975','2013-05-01','16:55:00',2.73),('8975','2013-05-01','17:00:00',2.62),('8975','2013-05-01','17:05:00',2.5),('8975','2013-05-01','17:10:00',2.4),('8975','2013-05-01','17:15:00',2.3),('8975','2013-05-01','17:20:00',2.18),('8975','2013-05-01','17:25:00',2.08),('8975','2013-05-01','17:30:00',1.97),('8975','2013-05-01','17:35:00',1.88),('8975','2013-05-01','17:40:00',1.8),('8975','2013-05-01','17:45:00',1.73),('8975','2013-05-01','17:50:00',1.64),('8975','2013-05-01','17:55:00',1.56),('8975','2013-05-01','18:00:00',1.5),('8975','2013-05-01','18:05:00',1.43),('8975','2013-05-01','18:10:00',1.38),('8975','2013-05-01','18:15:00',1.31),('8975','2013-05-01','18:20:00',1.27),('8975','2013-05-01','18:25:00',1.22),('8975','2013-05-01','18:30:00',1.17),('8975','2013-05-01','18:35:00',1.11),('8975','2013-05-01','18:40:00',1.05),('8975','2014-03-29','07:30:00',1.12),('8975','2014-03-29','07:35:00',1.23),('8975','2014-03-29','07:40:00',1.53),('8975','2014-03-29','07:45:00',1.57),('8975','2014-03-29','07:50:00',1.69),('8975','2014-03-29','07:55:00',1.84),('8975','2014-03-29','08:00:00',1.79),('8975','2014-03-29','08:05:00',1.78),('8975','2014-03-29','08:10:00',2.18),('8975','2014-03-29','08:15:00',2.39),('8975','2014-03-29','08:20:00',2.59),('8975','2014-03-29','08:25:00',2.71),('8975','2014-03-29','08:30:00',2.73),('8975','2014-03-29','08:35:00',2.65),('8975','2014-03-29','08:40:00',2.64),('8975','2014-03-29','08:45:00',2.46),('8975','2014-03-29','08:50:00',2.58),('8975','2014-03-29','08:55:00',2.67),('8975','2014-03-29','09:00:00',2.68),('8975','2014-03-29','09:05:00',2.61),('8975','2014-03-29','09:10:00',2.75),('8975','2014-03-29','09:15:00',2.99),('8975','2014-03-29','09:20:00',3.31),('8975','2014-03-29','09:25:00',3.72),('8975','2014-03-29','09:30:00',3.92),('8975','2014-03-29','09:35:00',4.14),('8975','2014-03-29','09:40:00',4.08),('8975','2014-03-29','09:45:00',3.95),('8975','2014-03-29','09:50:00',4.02),('8975','2014-03-29','09:55:00',4.16),('8975','2014-03-29','10:00:00',4.58),('8975','2014-03-29','10:05:00',4.68),('8975','2014-03-29','10:10:00',4.89),('8975','2014-03-29','10:15:00',5.03),('8975','2014-03-29','10:20:00',5.01),('8975','2014-03-29','10:25:00',4.97),('8975','2014-03-29','10:30:00',5.07),('8975','2014-03-29','10:35:00',5.14),('8975','2014-03-29','10:40:00',5.17),('8975','2014-03-29','10:45:00',5.12),('8975','2014-03-29','10:50:00',5.13),('8975','2014-03-29','10:55:00',5.12),('8975','2014-03-29','11:00:00',5.1),('8975','2014-03-29','11:05:00',5.02),('8975','2014-03-29','11:10:00',4.94),('8975','2014-03-29','11:15:00',5.21),('8975','2014-03-29','11:20:00',5.4),('8975','2014-03-29','11:25:00',5.42),('8975','2014-03-29','11:30:00',5.29),('8975','2014-03-29','11:35:00',5.41),('8975','2014-03-29','11:40:00',5.72),('8975','2014-03-29','11:45:00',5.87),('8975','2014-03-29','11:50:00',5.95),('8975','2014-03-29','11:55:00',5.94),('8975','2014-03-29','12:00:00',6.17),('8975','2014-03-29','12:05:00',6.27),('8975','2014-03-29','12:10:00',5.87),('8975','2014-03-29','12:15:00',5.98),('8975','2014-03-29','12:20:00',5.59),('8975','2014-03-29','12:25:00',5.44),('8975','2014-03-29','12:30:00',5.81),('8975','2014-03-29','12:35:00',6.01),('8975','2014-03-29','12:40:00',5.94),('8975','2014-03-29','12:45:00',5.99),('8975','2014-03-29','12:50:00',6.05),('8975','2014-03-29','12:55:00',6.04),('8975','2014-03-29','13:00:00',6.04),('8975','2014-03-29','13:05:00',6.05),('8975','2014-03-29','13:10:00',6.02),('8975','2014-03-29','13:15:00',6.03),('8975','2014-03-29','13:20:00',5.96),('8975','2014-03-29','13:25:00',5.86),('8975','2014-03-29','13:30:00',5.86),('8975','2014-03-29','13:35:00',5.84),('8975','2014-03-29','13:40:00',5.8),('8975','2014-03-29','13:45:00',5.36),('8975','2014-03-29','13:50:00',5.33),('8975','2014-03-29','13:55:00',5.31),('8975','2014-03-29','14:00:00',5.09),('8975','2014-03-29','14:05:00',5.06),('8975','2014-03-29','14:10:00',5.29),('8975','2014-03-29','14:15:00',5.27),('8975','2014-03-29','14:20:00',5.18),('8975','2014-03-29','14:25:00',4.83),('8975','2014-03-29','14:30:00',4.68),('8975','2014-03-29','14:35:00',4.36),('8975','2014-03-29','14:40:00',3.35),('8975','2014-03-29','14:45:00',2.43),('8975','2014-03-29','14:50:00',1.99),('8975','2014-03-29','14:55:00',2.84),('8975','2014-03-29','15:00:00',4.07),('8975','2014-03-29','15:05:00',4.36),('8975','2014-03-29','15:10:00',4.36),('8975','2014-03-29','15:15:00',4.32),('8975','2014-03-29','15:20:00',4.09),('8975','2014-03-29','15:25:00',3.96),('8975','2014-03-29','15:30:00',3.86),('8975','2014-03-29','15:35:00',3.94),('8975','2014-03-29','15:40:00',3.81),('8975','2014-03-29','15:45:00',3.74),('8975','2014-03-29','15:50:00',3.48),('8975','2014-03-29','15:55:00',3.23),('8975','2014-03-29','16:00:00',3.46),('8975','2014-03-29','16:05:00',3.3),('8975','2014-03-29','16:10:00',3.35),('8975','2014-03-29','16:15:00',3.3),('8975','2014-03-29','16:20:00',3.16),('8975','2014-03-29','16:25:00',2.97),('8975','2014-03-29','16:30:00',3.01),('8975','2014-03-29','16:35:00',2.79),('8975','2014-03-29','16:40:00',2.44),('8975','2014-03-29','16:45:00',2),('8975','2014-03-29','16:50:00',1.84),('8975','2014-03-29','16:55:00',1.85),('8975','2014-03-29','17:00:00',1.96),('8975','2014-03-29','17:05:00',2.11),('8975','2014-03-29','17:10:00',2.05),('8975','2014-03-29','17:15:00',1.93),('8975','2014-03-29','17:20:00',1.83),('8975','2014-03-29','17:25:00',1.73),('8975','2014-03-29','17:30:00',1.69),('8975','2014-03-29','17:35:00',1.59),('8975','2014-03-29','17:40:00',1.57),('8975','2014-03-29','17:45:00',1.39),('8975','2014-03-29','17:50:00',1.26),('8975','2014-03-29','17:55:00',1.18),('8975','2014-03-29','18:00:00',1.18),('8975','2014-03-29','18:05:00',1.22),('8975','2014-03-29','18:10:00',1),('8975','2013-04-30','07:10:00',1.02),('8975','2013-04-30','07:15:00',1.14),('8975','2013-04-30','07:20:00',1.23),('8975','2013-04-30','07:25:00',1.57),('8975','2013-04-30','07:30:00',1.73),('8975','2013-04-30','07:35:00',1.87),('8975','2013-04-30','07:40:00',2.05),('8975','2013-04-30','07:45:00',2.22),('8975','2013-04-30','07:50:00',2.36),('8975','2013-04-30','07:55:00',2.52),('8975','2013-04-30','08:00:00',2.63),('8975','2013-04-30','08:05:00',2.72),('8975','2013-04-30','08:10:00',2.84),('8975','2013-04-30','08:15:00',3.02),('8975','2013-04-30','08:20:00',3.19),('8975','2013-04-30','08:25:00',3.37),('8975','2013-04-30','08:30:00',3.52),('8975','2013-04-30','08:35:00',3.64),('8975','2013-04-30','08:40:00',3.75),('8975','2013-04-30','08:45:00',3.88),('8975','2013-04-30','08:50:00',4.01),('8975','2013-04-30','08:55:00',4.15),('8975','2013-04-30','09:00:00',4.25),('8975','2013-04-30','09:05:00',4.34),('8975','2013-04-30','09:10:00',4.39),('8975','2013-04-30','09:15:00',4.47),('8975','2013-04-30','09:20:00',4.52),('8975','2013-04-30','09:25:00',4.57),('8975','2013-04-30','09:30:00',4.6),('8975','2013-04-30','09:35:00',4.74),('8975','2013-04-30','09:40:00',4.81),('8975','2013-04-30','09:45:00',4.92),('8975','2013-04-30','09:50:00',4.97),('8975','2013-04-30','09:55:00',5.03),('8975','2013-04-30','10:00:00',5.03),('8975','2013-04-30','10:05:00',5.14),('8975','2013-04-30','10:10:00',5.35),('8975','2013-04-30','10:15:00',5.41),('8975','2013-04-30','10:20:00',5.43),('8975','2013-04-30','10:25:00',5.5),('8975','2013-04-30','10:30:00',5.51),('8975','2013-04-30','10:35:00',5.57),('8975','2013-04-30','10:40:00',5.9),('8975','2013-04-30','10:45:00',5.93),('8975','2013-04-30','10:50:00',5.93),('8975','2013-04-30','10:55:00',5.94),('8975','2013-04-30','11:00:00',5.98),('8975','2013-04-30','11:05:00',5.98),('8975','2013-04-30','11:10:00',6.09),('8975','2013-04-30','11:15:00',5.85),('8975','2013-04-30','11:20:00',5.31),('8975','2013-04-30','11:25:00',4.65),('8975','2013-04-30','11:30:00',4.39),('8975','2013-04-30','11:35:00',5.06),('8975','2013-04-30','11:40:00',5.14),('8975','2013-04-30','11:45:00',4.86),('8975','2013-04-30','11:50:00',6.36),('8975','2013-04-30','11:55:00',6.36),('8975','2013-04-30','12:00:00',6.26),('8975','2013-04-30','12:05:00',6.18),('8975','2013-04-30','12:10:00',6.14),('8975','2013-04-30','12:15:00',6.17),('8975','2013-04-30','12:20:00',6.23),('8975','2013-04-30','12:25:00',6.19),('8975','2013-04-30','12:30:00',6.22),('8975','2013-04-30','12:35:00',6.27),('8975','2013-04-30','12:40:00',5.86),('8975','2013-04-30','12:45:00',3.46),('8975','2013-04-30','12:50:00',2.6),('8975','2013-04-30','12:55:00',3.49),('8975','2013-04-30','13:00:00',2.88),('8975','2013-04-30','13:05:00',5.73),('8975','2013-04-30','13:10:00',5.94),('8975','2013-04-30','13:15:00',6.55),('8975','2013-04-30','13:20:00',6.41),('8975','2013-04-30','13:25:00',6.14),('8975','2013-04-30','13:30:00',6.97),('8975','2013-04-30','13:35:00',6),('8975','2013-04-30','13:40:00',6.48),('8975','2013-04-30','13:45:00',6.04),('8975','2013-04-30','13:50:00',5.25),('8975','2013-04-30','13:55:00',5.78),('8975','2013-04-30','14:00:00',5.59),('8975','2013-04-30','14:05:00',5.83),('8975','2013-04-30','14:10:00',4.9),('8975','2013-04-30','14:15:00',5.5),('8975','2013-04-30','14:20:00',5.87),('8975','2013-04-30','14:25:00',5.88),('8975','2013-04-30','14:30:00',5.8),('8975','2013-04-30','14:35:00',5.21),('8975','2013-04-30','14:40:00',4.6),('8975','2013-04-30','14:45:00',5.36),('8975','2013-04-30','14:50:00',4.51),('8975','2013-04-30','14:55:00',4.14),('8975','2013-04-30','15:00:00',4.58),('8975','2013-04-30','15:05:00',4.89),('8975','2013-04-30','15:10:00',4.56),('8975','2013-04-30','15:15:00',4.47),('8975','2013-04-30','15:20:00',4.69),('8975','2013-04-30','15:25:00',4.63),('8975','2013-04-30','15:30:00',3.71),('8975','2013-04-30','15:35:00',3.38),('8975','2013-04-30','15:40:00',3.55),('8975','2013-04-30','15:45:00',3.25),('8975','2013-04-30','15:50:00',2.45),('8975','2013-04-30','15:55:00',2.75),('8975','2013-04-30','16:00:00',3.13),('8975','2013-04-30','16:05:00',2.9),('8975','2013-04-30','16:10:00',2.59),('8975','2013-04-30','16:15:00',2.34),('8975','2013-04-30','16:20:00',1.95),('8975','2013-04-30','16:25:00',1.65),('8975','2013-04-30','16:30:00',1.53),('8975','2013-04-30','16:35:00',1.64),('8975','2013-04-30','16:40:00',1.72),('8975','2013-04-30','16:45:00',1.63),('8975','2013-04-30','16:50:00',1.42),('8975','2013-04-30','16:55:00',1.33),('8975','2013-04-30','17:00:00',1.36),('8975','2013-04-30','17:05:00',1.38),('8975','2013-04-30','17:10:00',1.43),('8975','2013-04-30','17:15:00',1.41),('8975','2013-04-30','17:20:00',1.27),('8975','2013-04-30','17:25:00',1.08),('8975','2013-04-29','07:55:00',1.03),('8975','2013-04-29','08:00:00',1.13),('8975','2013-04-29','08:15:00',1.04),('8975','2013-04-29','08:30:00',1.24),('8975','2013-04-29','08:35:00',1.38),('8975','2013-04-29','08:40:00',1.37),('8975','2013-04-29','08:45:00',1.49),('8975','2013-04-29','08:50:00',2.81),('8975','2013-04-29','08:55:00',3.2),('8975','2013-04-29','09:00:00',2.75),('8975','2013-04-29','09:05:00',2.87),('8975','2013-04-29','09:10:00',4.55),('8975','2013-04-29','09:15:00',4.85),('8975','2013-04-29','09:20:00',5.1),('8975','2013-04-29','09:25:00',4.8),('8975','2013-04-29','09:30:00',4.61),('8975','2013-04-29','09:35:00',3.03),('8975','2013-04-29','09:40:00',3.03),('8975','2013-04-29','09:45:00',3.86),('8975','2013-04-29','09:50:00',4.94),('8975','2013-04-29','09:55:00',5.38),('8975','2013-04-29','10:00:00',5.96),('8975','2013-04-29','10:05:00',4.37),('8975','2013-04-29','10:10:00',4.48),('8975','2013-04-29','10:15:00',3.26),('8975','2013-04-29','10:20:00',5.2),('8975','2013-04-29','10:25:00',4.75),('8975','2013-04-29','10:30:00',4.04),('8975','2013-04-29','10:35:00',2.93),('8975','2013-04-29','10:40:00',2.57),('8975','2013-04-29','10:45:00',2.18),('8975','2013-04-29','10:50:00',2.37),('8975','2013-04-29','10:55:00',2.44),('8975','2013-04-29','11:00:00',2.62),('8975','2013-04-29','11:05:00',2.98),('8975','2013-04-29','11:10:00',2.91),('8975','2013-04-29','11:15:00',3.38),('8975','2013-04-29','11:20:00',3.4),('8975','2013-04-29','11:25:00',3.2),('8975','2013-04-29','11:30:00',3.22),('8975','2013-04-29','11:35:00',3.72),('8975','2013-04-29','11:40:00',3.02),('8975','2013-04-29','11:45:00',2.82),('8975','2013-04-29','11:50:00',2.89),('8975','2013-04-29','11:55:00',2.94),('8975','2013-04-29','12:00:00',2.95),('8975','2013-04-29','12:05:00',2.99),('8975','2013-04-29','12:10:00',2.83),('8975','2013-04-29','12:15:00',2.61),('8975','2013-04-29','12:20:00',2.35),('8975','2013-04-29','12:25:00',2.18),('8975','2013-04-29','12:30:00',2.45),('8975','2013-04-29','12:35:00',5.43),('8975','2013-04-29','12:40:00',7.41),('8975','2013-04-29','12:45:00',7.08),('8975','2013-04-29','12:50:00',6.72),('8975','2013-04-29','12:55:00',6.22),('8975','2013-04-29','13:00:00',6.66),('8975','2013-04-29','13:05:00',6.53),('8975','2013-04-29','13:10:00',6.34),('8975','2013-04-29','13:15:00',6.21),('8975','2013-04-29','13:20:00',6.13),('8975','2013-04-29','13:25:00',6.07),('8975','2013-04-29','13:30:00',6.09),('8975','2013-04-29','13:35:00',6.03),('8975','2013-04-29','13:40:00',5.94),('8975','2013-04-29','13:45:00',5.86),('8975','2013-04-29','13:50:00',5.81),('8975','2013-04-29','13:55:00',5.75),('8975','2013-04-29','14:00:00',5.64),('8975','2013-04-29','14:05:00',5.65),('8975','2013-04-29','14:10:00',5.57),('8975','2013-04-29','14:15:00',5.51),('8975','2013-04-29','14:20:00',5.46),('8975','2013-04-29','14:25:00',5.4),('8975','2013-04-29','14:30:00',5.32),('8975','2013-04-29','14:35:00',5.2),('8975','2013-04-29','14:40:00',4.33),('8975','2013-04-29','14:45:00',4.33),('8975','2013-04-29','14:50:00',4.09),('8975','2013-04-29','14:55:00',4.52),('8975','2013-04-29','15:00:00',4.55),('8975','2013-04-29','15:05:00',3.9),('8975','2013-04-29','15:10:00',3.24),('8975','2013-04-29','15:15:00',3.77),('8975','2013-04-29','15:20:00',4.25),('8975','2013-04-29','15:25:00',4.28),('8975','2013-04-29','15:30:00',4.17),('8975','2013-04-29','15:35:00',4.12),('8975','2013-04-29','15:40:00',4),('8975','2013-04-29','15:45:00',3.93),('8975','2013-04-29','15:50:00',3.85),('8975','2013-04-29','15:55:00',3.75),('8975','2013-04-29','16:00:00',3.64),('8975','2013-04-29','16:05:00',3.54),('8975','2013-04-29','16:10:00',3.45),('8975','2013-04-29','16:15:00',3.31),('8975','2013-04-29','16:20:00',3.25),('8975','2013-04-29','16:25:00',3.17),('8975','2013-04-29','16:30:00',3.07),('8975','2013-04-29','16:35:00',2.52),('8975','2013-04-29','16:40:00',2.64),('8975','2013-04-29','16:45:00',2.41),('8975','2013-04-29','16:50:00',2.66),('8975','2013-04-29','16:55:00',2.63),('8975','2013-04-29','17:00:00',2.36),('8975','2013-04-29','17:05:00',2.27),('8975','2013-04-29','17:10:00',1.56),('8975','2013-04-29','17:15:00',1.24),('8975','2013-04-29','17:20:00',1.46),('8975','2013-04-29','17:25:00',1.86),('8975','2013-04-29','17:30:00',1.84),('8975','2013-04-29','17:35:00',1.76),('8975','2013-04-29','17:40:00',1.68),('8975','2013-04-29','17:45:00',1.59),('8975','2013-04-29','17:50:00',1.5),('8975','2013-04-29','17:55:00',1.41),('8975','2013-04-29','18:00:00',1.34),('8975','2013-04-29','18:05:00',1.28),('8975','2013-04-29','18:10:00',1.21),('8975','2013-04-29','18:15:00',1.14),('8975','2013-04-29','18:20:00',1.08),('8975','2013-04-29','18:25:00',1.01),('8975','2013-04-28','07:15:00',1.27),('8975','2013-04-28','07:20:00',1.65),('8975','2013-04-28','07:25:00',2.01),('8975','2013-04-28','07:30:00',2.07),('8975','2013-04-28','07:35:00',1.95),('8975','2013-04-28','07:40:00',1.8),('8975','2013-04-28','07:45:00',1.98),('8975','2013-04-28','07:50:00',2.01),('8975','2013-04-28','07:55:00',2.28),('8975','2013-04-28','08:00:00',2.74),('8975','2013-04-28','08:05:00',2.94),('8975','2013-04-28','08:10:00',2.8),('8975','2013-04-28','08:15:00',2.9),('8975','2013-04-28','08:20:00',3.08),('8975','2013-04-28','08:25:00',3.36),('8975','2013-04-28','08:30:00',3.78),('8975','2013-04-28','08:35:00',4.18),('8975','2013-04-28','08:40:00',3.88),('8975','2013-04-28','08:45:00',4.01),('8975','2013-04-28','08:50:00',4.29),('8975','2013-04-28','08:55:00',3.79),('8975','2013-04-28','09:00:00',3.29),('8975','2013-04-28','09:05:00',4.53),('8975','2013-04-28','09:10:00',4.81),('8975','2013-04-28','09:15:00',5),('8975','2013-04-28','09:20:00',4.75),('8975','2013-04-28','09:25:00',4.62),('8975','2013-04-28','09:30:00',4.64),('8975','2013-04-28','09:35:00',4.87),('8975','2013-04-28','09:40:00',5.05),('8975','2013-04-28','09:45:00',5.11),('8975','2013-04-28','09:50:00',5.03),('8975','2013-04-28','09:55:00',4.79),('8975','2013-04-28','10:00:00',4.02),('8975','2013-04-28','10:05:00',4.06),('8975','2013-04-28','10:10:00',4.46),('8975','2013-04-28','10:15:00',3.41),('8975','2013-04-28','10:20:00',3.85),('8975','2013-04-28','10:25:00',4.28),('8975','2013-04-28','10:30:00',5.03),('8975','2013-04-28','10:35:00',4.39),('8975','2013-04-28','10:40:00',5.64),('8975','2013-04-28','10:45:00',5.01),('8975','2013-04-28','10:50:00',5.04),('8975','2013-04-28','10:55:00',4.74),('8975','2013-04-28','11:00:00',5.7),('8975','2013-04-28','11:05:00',5.34),('8975','2013-04-28','11:10:00',5.18),('8975','2013-04-28','11:15:00',5.07),('8975','2013-04-28','11:20:00',5.78),('8975','2013-04-28','11:25:00',5.86),('8975','2013-04-28','11:30:00',6.07),('8975','2013-04-28','11:35:00',5.71),('8975','2013-04-28','11:40:00',5.9),('8975','2013-04-28','11:45:00',5.72),('8975','2013-04-28','11:50:00',6.26),('8975','2013-04-28','11:55:00',6.1),('8975','2013-04-28','12:00:00',6.36),('8975','2013-04-28','12:05:00',6.17),('8975','2013-04-28','12:10:00',6.09),('8975','2013-04-28','12:15:00',6.19),('8975','2013-04-28','12:20:00',6.22),('8975','2013-04-28','12:25:00',6.08),('8975','2013-04-28','12:30:00',6.16),('8975','2013-04-28','12:35:00',6.23),('8975','2013-04-28','12:40:00',6.24),('8975','2013-04-28','12:45:00',6.25),('8975','2013-04-28','12:50:00',6.05),('8975','2013-04-28','12:55:00',6.07),('8975','2013-04-28','13:00:00',6.1),('8975','2013-04-28','13:05:00',5.95),('8975','2013-04-28','13:10:00',5.79),('8975','2013-04-28','13:15:00',5.58),('8975','2013-04-28','13:20:00',6.02),('8975','2013-04-28','13:25:00',6.2),('8975','2013-04-28','13:30:00',5.97),('8975','2013-04-28','13:35:00',5.9),('8975','2013-04-28','13:40:00',5.81),('8975','2013-04-28','13:45:00',5.93),('8975','2013-04-28','13:50:00',5.65),('8975','2013-04-28','13:55:00',5.99),('8975','2013-04-28','14:00:00',5.41),('8975','2013-04-28','14:05:00',5.65),('8975','2013-04-28','14:10:00',5.59),('8975','2013-04-28','14:15:00',5.8),('8975','2013-04-28','14:20:00',5.7),('8975','2013-04-28','14:25:00',5.49),('8975','2013-04-28','14:30:00',5.19),('8975','2013-04-28','14:35:00',5.08),('8975','2013-04-28','14:40:00',4.87),('8975','2013-04-28','14:45:00',5.2),('8975','2013-04-28','14:50:00',4.96),('8975','2013-04-28','14:55:00',5.05),('8975','2013-04-28','15:00:00',4.99),('8975','2013-04-28','15:05:00',5.11),('8975','2013-04-28','15:10:00',4.56),('8975','2013-04-28','15:15:00',4.48),('8975','2013-04-28','15:20:00',4.79),('8975','2013-04-28','15:25:00',4.72),('8975','2013-04-28','15:30:00',4.48),('8975','2013-04-28','15:35:00',3.86),('8975','2013-04-28','15:40:00',3.62),('8975','2013-04-28','15:45:00',3.5),('8975','2013-04-28','15:50:00',3.8),('8975','2013-04-28','15:55:00',3.94),('8975','2013-04-28','16:00:00',3.96),('8975','2013-04-28','16:05:00',4.09),('8975','2013-04-28','16:10:00',3.88),('8975','2013-04-28','16:15:00',4.58),('8975','2013-04-28','16:20:00',3.99),('8975','2013-04-28','16:25:00',3.29),('8975','2013-04-28','16:30:00',3.41),('8975','2013-04-28','16:35:00',3.5),('8975','2013-04-28','16:40:00',3.48),('8975','2013-04-28','16:45:00',3.45),('8975','2013-04-28','16:50:00',3.47),('8975','2013-04-28','16:55:00',3.42),('8975','2013-04-28','17:00:00',3.02),('8975','2013-04-28','17:05:00',2.66),('8975','2013-04-28','17:10:00',2.66),('8975','2013-04-28','17:15:00',2.3),('8975','2013-04-28','17:20:00',2.13),('8975','2013-04-28','17:25:00',1.89),('8975','2013-04-28','17:30:00',1.88),('8975','2013-04-28','17:35:00',1.6),('8975','2013-04-28','17:40:00',1.51),('8975','2013-04-28','17:45:00',1.53),('8975','2013-04-28','17:50:00',1.77),('8975','2013-04-28','17:55:00',1.83),('8975','2013-04-28','18:00:00',1.8),('8975','2013-04-28','18:05:00',1.97),('8975','2013-04-28','18:10:00',1.8),('8975','2013-04-28','18:15:00',1.69),('8975','2013-04-28','18:20:00',1.5),('8975','2013-04-28','18:25:00',1.53),('8975','2013-04-28','18:30:00',1.37),('8975','2013-04-28','18:35:00',1.09),('8975','2013-04-27','06:55:00',1.1),('8975','2013-04-27','07:00:00',1.27),('8975','2013-04-27','07:05:00',1.43),('8975','2013-04-27','07:10:00',1.66),('8975','2013-04-27','07:15:00',1.9),('8975','2013-04-27','07:20:00',2.08),('8975','2013-04-27','07:25:00',2.29),('8975','2013-04-27','07:30:00',2.45),('8975','2013-04-27','07:35:00',2.6),('8975','2013-04-27','07:40:00',2.76),('8975','2013-04-27','07:45:00',2.91),('8975','2013-04-27','07:50:00',3.03),('8975','2013-04-27','07:55:00',3.09),('8975','2013-04-27','08:00:00',3.19),('8975','2013-04-27','08:05:00',3.32),('8975','2013-04-27','08:10:00',3.5),('8975','2013-04-27','08:15:00',3.59),('8975','2013-04-27','08:20:00',3.74),('8975','2013-04-27','08:25:00',3.86),('8975','2013-04-27','08:30:00',3.85),('8975','2013-04-27','08:35:00',3.97),('8975','2013-04-27','08:40:00',4.13),('8975','2013-04-27','08:45:00',4.23),('8975','2013-04-27','08:50:00',4.35),('8975','2013-04-27','08:55:00',4.44),('8975','2013-04-27','09:00:00',4.55),('8975','2013-04-27','09:05:00',4.67),('8975','2013-04-27','09:10:00',4.78),('8975','2013-04-27','09:15:00',4.88),('8975','2013-04-27','09:20:00',4.97),('8975','2013-04-27','09:25:00',5.06),('8975','2013-04-27','09:30:00',5.15),('8975','2013-04-27','09:35:00',5.25),('8975','2013-04-27','09:40:00',5.32),('8975','2013-04-27','09:45:00',5.41),('8975','2013-04-27','09:50:00',5.51),('8975','2013-04-27','09:55:00',5.59),('8975','2013-04-27','10:00:00',5.66),('8975','2013-04-27','10:05:00',5.7),('8975','2013-04-27','10:10:00',5.61),('8975','2013-04-27','10:15:00',5.77),('8975','2013-04-27','10:20:00',5.87),('8975','2013-04-27','10:25:00',6.04),('8975','2013-04-27','10:30:00',6.02),('8975','2013-04-27','10:35:00',6.2),('8975','2013-04-27','10:40:00',5.46),('8975','2013-04-27','10:45:00',6.21),('8975','2013-04-27','10:50:00',6.2),('8975','2013-04-27','10:55:00',6.22),('8975','2013-04-27','11:00:00',6.22),('8975','2013-04-27','11:05:00',6.26),('8975','2013-04-27','11:10:00',6.33),('8975','2013-04-27','11:15:00',6.36),('8975','2013-04-27','11:20:00',6.25),('8975','2013-04-27','11:25:00',6.48),('8975','2013-04-27','11:30:00',6.35),('8975','2013-04-27','11:35:00',6.22),('8975','2013-04-27','11:40:00',6.34),('8975','2013-04-27','11:45:00',5.81),('8975','2013-04-27','11:50:00',6.22),('8975','2013-04-27','11:55:00',6.15),('8975','2013-04-27','12:00:00',5.5),('8975','2013-04-27','12:05:00',5.59),('8975','2013-04-27','12:10:00',6.25),('8975','2013-04-27','12:15:00',5.86),('8975','2013-04-27','12:20:00',6.42),('8975','2013-04-27','12:25:00',5.79),('8975','2013-04-27','12:30:00',4.7),('8975','2013-04-27','12:35:00',4.43),('8975','2013-04-27','12:40:00',5.12),('8975','2013-04-27','12:45:00',6.78),('8975','2013-04-27','12:50:00',6.16),('8975','2013-04-27','12:55:00',5.67),('8975','2013-04-27','13:00:00',6.02),('8975','2013-04-27','13:05:00',6.51),('8975','2013-04-27','13:10:00',6.13),('8975','2013-04-27','13:15:00',5.4),('8975','2013-04-27','13:20:00',6.08),('8975','2013-04-27','13:25:00',3.29),('8975','2013-04-27','13:30:00',4.17),('8975','2013-04-27','13:35:00',2.33),('8975','2013-04-27','13:40:00',2.4),('8975','2013-04-27','13:45:00',2.49),('8975','2013-04-27','13:50:00',4.65),('8975','2013-04-27','13:55:00',6.69),('8975','2013-04-27','14:00:00',5.54),('8975','2013-04-27','14:05:00',5.99),('8975','2013-04-27','14:10:00',6.02),('8975','2013-04-27','14:15:00',5.88),('8975','2013-04-27','14:20:00',5.83),('8975','2013-04-27','14:25:00',5.68),('8975','2013-04-27','14:30:00',5.59),('8975','2013-04-27','14:35:00',5.51),('8975','2013-04-27','14:40:00',5.43),('8975','2013-04-27','14:45:00',5.33),('8975','2013-04-27','14:50:00',5.24),('8975','2013-04-27','14:55:00',5.14),('8975','2013-04-27','15:00:00',5.06),('8975','2013-04-27','15:05:00',4.95),('8975','2013-04-27','15:10:00',4.88),('8975','2013-04-27','15:15:00',4.77),('8975','2013-04-27','15:20:00',4.69),('8975','2013-04-27','15:25:00',4.59),('8975','2013-04-27','15:30:00',4.5),('8975','2013-04-27','15:35:00',4.39),('8975','2013-04-27','15:40:00',4.3),('8975','2013-04-27','15:45:00',4.2),('8975','2013-04-27','15:50:00',4.08),('8975','2013-04-27','15:55:00',3.99),('8975','2013-04-27','16:00:00',3.89),('8975','2013-04-27','16:05:00',3.77),('8975','2013-04-27','16:10:00',3.65),('8975','2013-04-27','16:15:00',3.29),('8975','2013-04-27','16:20:00',3.23),('8975','2013-04-27','16:25:00',3.21),('8975','2013-04-27','16:30:00',2.86),('8975','2013-04-27','16:35:00',2.98),('8975','2013-04-27','16:40:00',2.94),('8975','2013-04-27','16:45:00',2.72),('8975','2013-04-27','16:50:00',2.72),('8975','2013-04-27','16:55:00',2.41),('8975','2013-04-27','17:00:00',2.39),('8975','2013-04-27','17:05:00',1.83),('8975','2013-04-27','17:10:00',2.06),('8975','2013-04-27','17:15:00',2.24),('8975','2013-04-27','17:20:00',2.06),('8975','2013-04-27','17:25:00',2.01),('8975','2013-04-27','17:30:00',1.83),('8975','2013-04-27','17:35:00',1.67),('8975','2013-04-27','17:40:00',1.66),('8975','2013-04-27','17:45:00',1.66),('8975','2013-04-27','17:50:00',1.62),('8975','2013-04-27','17:55:00',1.48),('8975','2013-04-27','18:00:00',1.49),('8975','2013-04-27','18:05:00',1.33),('8975','2013-04-27','18:10:00',1.06),('8975','2013-04-27','18:15:00',1.14),('8975','2013-04-27','18:20:00',1.3),('8975','2013-04-27','18:25:00',1.29),('8975','2013-04-27','18:30:00',1.08),('8975','2013-04-27','18:35:00',1),('8975','2013-04-26','11:55:00',1.05),('8975','2013-04-26','12:00:00',1.12),('8975','2013-04-26','12:05:00',1.08),('8975','2013-04-26','12:35:00',1.07),('8975','2013-04-26','12:40:00',1.34),('8975','2013-04-26','12:45:00',1.42),('8975','2013-04-26','12:50:00',1.71),('8975','2013-04-26','12:55:00',2.21),('8975','2013-04-26','13:00:00',2.09),('8975','2013-04-26','13:05:00',1.54),('8975','2013-04-26','13:10:00',1.66),('8975','2013-04-26','13:15:00',2.11),('8975','2013-04-26','13:20:00',2.3),('8975','2013-04-26','13:25:00',1.84),('8975','2013-04-26','13:30:00',2.17),('8975','2013-04-26','13:35:00',2.74),('8975','2013-04-26','13:40:00',3.08),('8975','2013-04-26','13:45:00',2.07),('8975','2013-04-26','13:50:00',1.83),('8975','2013-04-26','13:55:00',1.18),('8975','2013-04-26','14:00:00',1.26),('8975','2013-04-26','14:05:00',1.32),('8975','2013-04-26','14:10:00',1.15),('8975','2013-04-26','14:15:00',1.15),('8975','2013-04-26','14:20:00',1.33),('8975','2013-04-26','14:25:00',2.6),('8975','2013-04-26','14:30:00',3.32),('8975','2013-04-26','14:35:00',1.95),('8975','2013-04-26','14:40:00',2.15),('8975','2013-04-26','14:45:00',1.73),('8975','2013-04-26','14:50:00',1.62),('8975','2013-04-26','14:55:00',2.46),('8975','2013-04-26','15:00:00',3.74),('8975','2013-04-26','15:05:00',4.34),('8975','2013-04-26','15:10:00',2.44),('8975','2013-04-26','15:15:00',1.79),('8975','2013-04-26','16:30:00',1.75),('8975','2013-04-26','16:35:00',1.69),('8975','2013-04-26','16:40:00',2.14),('8975','2013-04-26','16:45:00',2.16),('8975','2013-04-26','16:50:00',2.81),('8975','2013-04-26','16:55:00',3.44),('8975','2013-04-26','17:00:00',2.39),('8975','2013-04-26','17:05:00',1.64),('8975','2013-04-26','17:10:00',1.18),('8975','2013-04-26','17:15:00',1.04),('8975','2013-04-26','17:20:00',1.64),('8975','2013-04-26','17:25:00',1.12),('8975','2013-04-26','17:30:00',1.03),('8975','2013-04-26','17:35:00',1.34),('8975','2013-04-26','17:40:00',1.7),('8975','2013-04-26','17:45:00',1.59),('8975','2013-04-26','17:50:00',1.93),('8975','2013-04-26','17:55:00',2),('8975','2013-04-26','18:00:00',1.9),('8975','2013-04-26','18:05:00',1.49),('8975','2013-04-26','18:10:00',1.37),('8975','2013-04-26','18:15:00',1.22),('8975','2013-04-25','07:00:00',1.11),('8975','2013-04-25','07:05:00',1.24),('8975','2013-04-25','07:10:00',1.4),('8975','2013-04-25','07:15:00',1.48),('8975','2013-04-25','07:20:00',1.45),('8975','2013-04-25','07:25:00',1.47),('8975','2013-04-25','07:30:00',1.36),('8975','2013-04-25','07:35:00',1.15),('8975','2013-04-25','07:40:00',1.11),('8975','2013-04-25','07:45:00',1.2),('8975','2013-04-25','07:50:00',1.5),('8975','2013-04-25','07:55:00',1.59),('8975','2013-04-25','08:00:00',1.76),('8975','2013-04-25','08:05:00',2.5),('8975','2013-04-25','08:10:00',2.83),('8975','2013-04-25','08:15:00',2.97),('8975','2013-04-25','08:20:00',3.02),('8975','2013-04-25','08:25:00',3.02),('8975','2013-04-25','08:30:00',3.27),('8975','2013-04-25','08:35:00',3.36),('8975','2013-04-25','08:40:00',3.47),('8975','2013-04-25','08:45:00',3.77),('8975','2013-04-25','08:50:00',3.89),('8975','2013-04-25','08:55:00',3.82),('8975','2013-04-25','09:00:00',4.04),('8975','2013-04-25','09:05:00',3.07),('8975','2013-04-25','09:10:00',2.21),('8975','2013-04-25','09:15:00',2.32),('8975','2013-04-25','09:20:00',3.07),('8975','2013-04-25','09:25:00',3.62),('8975','2013-04-25','09:30:00',3.53),('8975','2013-04-25','09:35:00',2.75),('8975','2013-04-25','09:40:00',3.9),('8975','2013-04-25','09:45:00',5.28),('8975','2013-04-25','09:50:00',3.65),('8975','2013-04-25','09:55:00',4.25),('8975','2013-04-25','10:00:00',5.58),('8975','2013-04-25','10:05:00',5.41),('8975','2013-04-25','10:10:00',5.45),('8975','2013-04-25','10:15:00',5.52),('8975','2013-04-25','10:20:00',5.07),('8975','2013-04-25','10:25:00',5.33),('8975','2013-04-25','10:30:00',5.8),('8975','2013-04-25','10:35:00',5.94),('8975','2013-04-25','10:40:00',6.17),('8975','2013-04-25','10:45:00',5.26),('8975','2013-04-25','10:50:00',3.05),('8975','2013-04-25','10:55:00',3.97),('8975','2013-04-25','11:00:00',6.03),('8975','2013-04-25','11:05:00',5.98),('8975','2013-04-25','11:10:00',6.07),('8975','2013-04-25','11:15:00',5.92),('8975','2013-04-25','11:20:00',5.37),('8975','2013-04-25','11:25:00',5.52),('8975','2013-04-25','11:30:00',5.2),('8975','2013-04-25','11:35:00',5.63),('8975','2013-04-25','11:40:00',4.62),('8975','2013-04-25','11:45:00',4.75),('8975','2013-04-25','11:50:00',3.87),('8975','2013-04-25','11:55:00',4.79),('8975','2013-04-25','12:00:00',4.8),('8975','2013-04-25','12:05:00',3.92),('8975','2013-04-25','12:10:00',3.79),('8975','2013-04-25','12:15:00',4.64),('8975','2013-04-25','12:20:00',3.23),('8975','2013-04-25','12:25:00',2.79),('8975','2013-04-25','12:30:00',3.09),('8975','2013-04-25','12:35:00',4.02),('8975','2013-04-25','12:40:00',4.14),('8975','2013-04-25','12:45:00',3.41),('8975','2013-04-25','12:50:00',3.36),('8975','2013-04-25','12:55:00',2.58),('8975','2013-04-25','13:00:00',2.12),('8975','2013-04-25','13:05:00',2.28),('8975','2013-04-25','13:10:00',3.21),('8975','2013-04-25','13:15:00',3.29),('8975','2013-04-25','13:20:00',2.99),('8975','2013-04-25','13:25:00',4.06),('8975','2013-04-25','13:30:00',4.59),('8975','2013-04-25','13:35:00',4.17),('8975','2013-04-25','13:40:00',3.27),('8975','2013-04-25','13:45:00',3.39),('8975','2013-04-25','13:50:00',3.85),('8975','2013-04-25','13:55:00',3.61),('8975','2013-04-25','14:00:00',3.96),('8975','2013-04-25','14:05:00',4.02),('8975','2013-04-25','14:10:00',3.85),('8975','2013-04-25','14:15:00',3.64),('8975','2013-04-25','14:20:00',4.29),('8975','2013-04-25','14:25:00',4.77),('8975','2013-04-25','14:30:00',5.1),('8975','2013-04-25','14:35:00',3.31),('8975','2013-04-25','14:40:00',2.3),('8975','2013-04-25','14:45:00',3.22),('8975','2013-04-25','14:50:00',5.93),('8975','2013-04-25','14:55:00',5.04),('8975','2013-04-25','15:00:00',3.83),('8975','2013-04-25','15:05:00',2.02),('8975','2013-04-25','15:10:00',2.74),('8975','2013-04-25','15:15:00',2.31),('8975','2013-04-25','15:20:00',2.32),('8975','2013-04-25','15:25:00',3.34),('8975','2013-04-25','15:30:00',3.29),('8975','2013-04-25','15:35:00',3.18),('8975','2013-04-25','15:40:00',4.1),('8975','2013-04-25','15:45:00',3.46),('8975','2013-04-25','15:50:00',3.27),('8975','2013-04-25','15:55:00',1.83),('8975','2013-04-24','07:40:00',1.16),('8975','2013-04-24','07:45:00',1.89),('8975','2013-04-24','07:50:00',1.27),('8975','2013-04-24','07:55:00',1.32),('8975','2013-04-24','08:00:00',1.76),('8975','2013-04-24','08:05:00',2.15),('8975','2013-04-24','08:10:00',2.11),('8975','2013-04-24','08:15:00',2.78),('8975','2013-04-24','08:20:00',2.16),('8975','2013-04-24','08:25:00',1.94),('8975','2013-04-24','08:30:00',2.11),('8975','2013-04-24','08:35:00',2.06),('8975','2013-04-24','08:40:00',2.05),('8975','2013-04-24','08:45:00',3.72),('8975','2013-04-24','08:50:00',4.05),('8975','2013-04-24','08:55:00',4.16),('8975','2013-04-24','09:00:00',3.38),('8975','2013-04-24','09:05:00',2.66),('8975','2013-04-24','09:10:00',2.99),('8975','2013-04-24','09:15:00',2.56),('8975','2013-04-24','09:20:00',2.8),('8975','2013-04-24','09:25:00',2.79),('8975','2013-04-24','09:30:00',2.58),('8975','2013-04-24','09:35:00',2.7),('8975','2013-04-24','09:40:00',3.65),('8975','2013-04-24','09:45:00',5.32),('8975','2013-04-24','09:50:00',5.55),('8975','2013-04-24','09:55:00',5.6),('8975','2013-04-24','10:00:00',5.28),('8975','2013-04-24','10:05:00',5.17),('8975','2013-04-24','10:10:00',5.42),('8975','2013-04-24','10:15:00',5.04),('8975','2013-04-24','10:20:00',5.62),('8975','2013-04-24','10:25:00',5.75),('8975','2013-04-24','10:30:00',5.98),('8975','2013-04-24','10:35:00',5.94),('8975','2013-04-24','10:40:00',5.91),('8975','2013-04-24','10:45:00',5.97),('8975','2013-04-24','10:50:00',6.16),('8975','2013-04-24','10:55:00',6.18),('8975','2013-04-24','11:00:00',6.23),('8975','2013-04-24','11:05:00',6.28),('8975','2013-04-24','11:10:00',6.19),('8975','2013-04-24','11:15:00',6.23),('8975','2013-04-24','11:20:00',6.25),('8975','2013-04-24','11:25:00',6.35),('8975','2013-04-24','11:30:00',6.36),('8975','2013-04-24','11:35:00',6.42),('8975','2013-04-24','11:40:00',6.45),('8975','2013-04-24','11:45:00',6.46),('8975','2013-04-24','11:50:00',6.36),('8975','2013-04-24','11:55:00',6.16),('8975','2013-04-24','12:00:00',6.2),('8975','2013-04-24','12:05:00',6.3),('8975','2013-04-24','12:10:00',6.43),('8975','2013-04-24','12:15:00',6.47),('8975','2013-04-24','12:20:00',6.45),('8975','2013-04-24','12:25:00',6.41),('8975','2013-04-24','12:30:00',6.38),('8975','2013-04-24','12:35:00',6.38),('8975','2013-04-24','12:40:00',6.38),('8975','2013-04-24','12:45:00',6.4),('8975','2013-04-24','12:50:00',6.34),('8975','2013-04-24','12:55:00',6.31),('8975','2013-04-24','13:00:00',6.32),('8975','2013-04-24','13:05:00',6.34),('8975','2013-04-24','13:10:00',6.38),('8975','2013-04-24','13:15:00',6),('8975','2013-04-24','13:20:00',5.78),('8975','2013-04-24','13:25:00',4.5),('8975','2013-04-24','13:30:00',3.91),('8975','2013-04-24','13:35:00',3.74),('8975','2013-04-24','13:40:00',3.66),('8975','2013-04-24','13:45:00',3.51),('8975','2013-04-24','13:50:00',3.54),('8975','2013-04-24','13:55:00',3.82),('8975','2013-04-24','14:00:00',3.75),('8975','2013-04-24','14:05:00',3.66),('8975','2013-04-24','14:10:00',3.75),('8975','2013-04-24','14:15:00',3.71),('8975','2013-04-24','14:20:00',3.55),('8975','2013-04-24','14:25:00',3.92),('8975','2013-04-24','14:30:00',4.63),('8975','2013-04-24','14:35:00',5.25),('8975','2013-04-24','14:40:00',5.05),('8975','2013-04-24','14:45:00',4.91),('8975','2013-04-24','14:50:00',4.43),('8975','2013-04-24','14:55:00',4.48),('8975','2013-04-24','15:00:00',4.29),('8975','2013-04-24','15:05:00',3.87),('8975','2013-04-24','15:10:00',3.96),('8975','2013-04-24','15:15:00',4.3),('8975','2013-04-24','15:20:00',4.53),('8975','2013-04-24','15:25:00',4.62),('8975','2013-04-24','15:30:00',4.48),('8975','2013-04-24','15:35:00',4.09),('8975','2013-04-24','15:40:00',3.95),('8975','2013-04-24','15:45:00',3.55),('8975','2013-04-24','15:50:00',3.28),('8975','2013-04-24','15:55:00',3.3),('8975','2013-04-24','16:00:00',3.04),('8975','2013-04-24','16:05:00',2.65),('8975','2013-04-24','16:10:00',3.21),('8975','2013-04-24','16:15:00',2.66),('8975','2013-04-24','16:20:00',2.87),('8975','2013-04-24','16:25:00',2.53),('8975','2013-04-24','16:30:00',2.7),('8975','2013-04-24','16:35:00',3.13),('8975','2013-04-24','16:40:00',2.79),('8975','2013-04-24','16:45:00',2.36),('8975','2013-04-24','16:50:00',2.43),('8975','2013-04-24','16:55:00',2.78),('8975','2013-04-24','17:00:00',2.87),('8975','2013-04-24','17:05:00',3.04),('8975','2013-04-24','17:10:00',2.93),('8975','2013-04-24','17:15:00',2.54),('8975','2013-04-24','17:20:00',2.42),('8975','2013-04-24','17:25:00',2.03),('8975','2013-04-24','17:30:00',1.7),('8975','2013-04-24','17:35:00',1.73),('8975','2013-04-24','17:40:00',1.66),('8975','2013-04-24','17:45:00',1.46),('8975','2013-04-24','17:50:00',1.32),('8975','2013-04-24','17:55:00',1.19),('8975','2013-04-24','18:00:00',1.15),('8975','2013-04-24','18:05:00',1.1),('8975','2013-04-24','18:10:00',1.02),('8975','2013-04-23','07:25:00',1.08),('8975','2013-04-23','07:30:00',1.19),('8975','2013-04-23','07:35:00',1.74),('8975','2013-04-23','07:40:00',2.11),('8975','2013-04-23','07:45:00',2.39),('8975','2013-04-23','07:50:00',2.75),('8975','2013-04-23','07:55:00',2.84),('8975','2013-04-23','08:00:00',2.82),('8975','2013-04-23','08:05:00',3.1),('8975','2013-04-23','08:10:00',3.37),('8975','2013-04-23','08:15:00',3.5),('8975','2013-04-23','08:20:00',3.78),('8975','2013-04-23','08:25:00',3.77),('8975','2013-04-23','08:30:00',3.58),('8975','2013-04-23','08:35:00',3.54),('8975','2013-04-23','08:40:00',3.66),('8975','2013-04-23','08:45:00',3.68),('8975','2013-04-23','08:50:00',3.8),('8975','2013-04-23','08:55:00',3.99),('8975','2013-04-23','09:00:00',4.5),('8975','2013-04-23','09:05:00',3.44),('8975','2013-04-23','09:10:00',4.86),('8975','2013-04-23','09:15:00',3.75),('8975','2013-04-23','09:20:00',4.05),('8975','2013-04-23','09:25:00',5.62),('8975','2013-04-23','09:30:00',4.86),('8975','2013-04-23','09:35:00',5.65),('8975','2013-04-23','09:40:00',4.81),('8975','2013-04-23','09:45:00',4.97),('8975','2013-04-23','09:50:00',5.83),('8975','2013-04-23','09:55:00',5.4),('8975','2013-04-23','10:00:00',5.73),('8975','2013-04-23','10:05:00',5.86),('8975','2013-04-23','10:10:00',6.02),('8975','2013-04-23','10:15:00',6.01),('8975','2013-04-23','10:20:00',5.87),('8975','2013-04-23','10:25:00',5.73),('8975','2013-04-23','10:30:00',5.71),('8975','2013-04-23','10:35:00',5.94),('8975','2013-04-23','10:40:00',6.13),('8975','2013-04-23','10:45:00',6.21),('8975','2013-04-23','10:50:00',6.35),('8975','2013-04-23','10:55:00',6.46),('8975','2013-04-23','11:00:00',6.23),('8975','2013-04-23','11:05:00',6.36),('8975','2013-04-23','11:10:00',6.76),('8975','2013-04-23','11:15:00',6.67),('8975','2013-04-23','11:20:00',6.92),('8975','2013-04-23','11:25:00',7.06),('8975','2013-04-23','11:30:00',6.51),('8975','2013-04-23','11:35:00',4.72),('8975','2013-04-23','11:40:00',5.16),('8975','2013-04-23','11:45:00',4.65),('8975','2013-04-23','11:50:00',4.64),('8975','2013-04-23','11:55:00',6.34),('8975','2013-04-23','12:00:00',4.58),('8975','2013-04-23','12:05:00',4.08),('8975','2013-04-23','12:10:00',5.51),('8975','2013-04-23','12:15:00',6.69),('8975','2013-04-23','12:20:00',7.4),('8975','2013-04-23','12:25:00',6.36),('8975','2013-04-23','12:30:00',6.23),('8975','2013-04-23','12:35:00',6.5),('8975','2013-04-23','12:40:00',6.52),('8975','2013-04-23','12:45:00',6.19),('8975','2013-04-23','12:50:00',6.09),('8975','2013-04-23','12:55:00',6.57),('8975','2013-04-23','13:00:00',7.15),('8975','2013-04-23','13:05:00',5.72),('8975','2013-04-23','13:10:00',6.23),('8975','2013-04-23','13:15:00',6.84),('8975','2013-04-23','13:20:00',6.13),('8975','2013-04-23','13:25:00',6.3),('8975','2013-04-23','13:30:00',5.6),('8975','2013-04-23','13:35:00',6.41),('8975','2013-04-23','13:40:00',6.92),('8975','2013-04-23','13:45:00',6.41),('8975','2013-04-23','13:50:00',5.3),('8975','2013-04-23','13:55:00',5.93),('8975','2013-04-23','14:00:00',6.63),('8975','2013-04-23','14:05:00',4.76),('8975','2013-04-23','14:10:00',4.99),('8975','2013-04-23','14:15:00',6.16),('8975','2013-04-23','14:20:00',5.95),('8975','2013-04-23','14:25:00',5.97),('8975','2013-04-23','14:30:00',5.55),('8975','2013-04-23','14:35:00',5.19),('8975','2013-04-23','14:40:00',4.87),('8975','2013-04-23','14:45:00',4.51),('8975','2013-04-23','14:50:00',3.77),('8975','2013-04-23','14:55:00',4.05),('8975','2013-04-23','15:00:00',3.75),('8975','2013-04-23','15:05:00',3.76),('8975','2013-04-23','15:10:00',3.43),('8975','2013-04-23','15:15:00',3.51),('8975','2013-04-23','15:20:00',3.95),('8975','2013-04-23','15:25:00',3.31),('8975','2013-04-23','15:30:00',3),('8975','2013-04-23','15:35:00',2.8),('8975','2013-04-23','15:40:00',2.66),('8975','2013-04-23','15:45:00',2.71),('8975','2013-04-23','15:50:00',2.75),('8975','2013-04-23','15:55:00',3.29),('8975','2013-04-23','16:00:00',4.25),('8975','2013-04-23','16:05:00',3.71),('8975','2013-04-23','16:10:00',3.9),('8975','2013-04-23','16:15:00',4.09),('8975','2013-04-23','16:20:00',4.28),('8975','2013-04-23','16:25:00',3.35),('8975','2013-04-23','16:30:00',2.91),('8975','2013-04-23','16:35:00',2.73),('8975','2013-04-23','16:40:00',3.22),('8975','2013-04-23','16:45:00',3.33),('8975','2013-04-23','16:50:00',3),('8975','2013-04-23','16:55:00',3.16),('8975','2013-04-23','17:00:00',3.1),('8975','2013-04-23','17:05:00',2.98),('8975','2013-04-23','17:10:00',2.81),('8975','2013-04-23','17:15:00',2.2),('8975','2013-04-23','17:20:00',2.06),('8975','2013-04-23','17:25:00',1.73),('8975','2013-04-23','17:30:00',1.43),('8975','2013-04-23','17:35:00',1.45),('8975','2013-04-23','17:40:00',1.15),('8975','2013-04-23','17:45:00',1.37),('8975','2013-04-23','17:50:00',1.37),('8975','2013-04-23','17:55:00',1.66),('8975','2013-04-23','18:00:00',1.38),('8975','2013-04-23','18:05:00',1.31),('8975','2013-04-23','18:10:00',1.16),('8975','2013-04-23','18:15:00',1.08),('8975','2013-04-23','18:20:00',1.43),('8975','2013-04-23','18:25:00',1.2),('8975','2013-04-22','06:50:00',1.02),('8975','2013-04-22','06:55:00',1.3),('8975','2013-04-22','07:00:00',1.43),('8975','2013-04-22','07:05:00',1.66),('8975','2013-04-22','07:10:00',1.81),('8975','2013-04-22','07:15:00',2.06),('8975','2013-04-22','07:20:00',2.09),('8975','2013-04-22','07:25:00',2.44),('8975','2013-04-22','07:30:00',2.67),('8975','2013-04-22','07:35:00',2.83),('8975','2013-04-22','07:40:00',2.95),('8975','2013-04-22','07:45:00',3.09),('8975','2013-04-22','07:50:00',3.21),('8975','2013-04-22','07:55:00',3.32),('8975','2013-04-22','08:00:00',3.44),('8975','2013-04-22','08:05:00',3.55),('8975','2013-04-22','08:10:00',3.66),('8975','2013-04-22','08:15:00',3.79),('8975','2013-04-22','08:20:00',3.93),('8975','2013-04-22','08:25:00',4.05),('8975','2013-04-22','08:30:00',4.16),('8975','2013-04-22','08:35:00',4.26),('8975','2013-04-22','08:40:00',4.35),('8975','2013-04-22','08:45:00',4.46),('8975','2013-04-22','08:50:00',4.56),('8975','2013-04-22','08:55:00',4.65),('8975','2013-04-22','09:00:00',4.76),('8975','2013-04-22','09:05:00',4.9),('8975','2013-04-22','09:10:00',5),('8975','2013-04-22','09:15:00',5.09),('8975','2013-04-22','09:20:00',5.17),('8975','2013-04-22','09:25:00',5.21),('8975','2013-04-22','09:30:00',5.3),('8975','2013-04-22','09:35:00',5.47),('8975','2013-04-22','09:40:00',4.78),('8975','2013-04-22','09:45:00',5.38),('8975','2013-04-22','09:50:00',5.82),('8975','2013-04-22','09:55:00',5.81),('8975','2013-04-22','10:00:00',5.85),('8975','2013-04-22','10:05:00',5.9),('8975','2013-04-22','10:10:00',5.96),('8975','2013-04-22','10:15:00',6.04),('8975','2013-04-22','10:20:00',6.08),('8975','2013-04-22','10:25:00',6.11),('8975','2013-04-22','10:30:00',6.19),('8975','2013-04-22','10:35:00',6.22),('8975','2013-04-22','10:40:00',6.29),('8975','2013-04-22','10:45:00',6.25),('8975','2013-04-22','10:50:00',6.37),('8975','2013-04-22','10:55:00',6.42),('8975','2013-04-22','11:00:00',6.48),('8975','2013-04-22','11:05:00',6.47),('8975','2013-04-22','11:10:00',6.49),('8975','2013-04-22','11:15:00',6.52),('8975','2013-04-22','11:20:00',6.53),('8975','2013-04-22','11:25:00',6.54),('8975','2013-04-22','11:30:00',6.58),('8975','2013-04-22','11:35:00',6.61),('8975','2013-04-22','11:40:00',6.6),('8975','2013-04-22','11:45:00',6.61),('8975','2013-04-22','11:50:00',6.63),('8975','2013-04-22','11:55:00',6.66),('8975','2013-04-22','12:00:00',6.56),('8975','2013-04-22','12:05:00',6.61),('8975','2013-04-22','12:10:00',6.69),('8975','2013-04-22','12:15:00',6.71),('8975','2013-04-22','12:20:00',6.65),('8975','2013-04-22','12:25:00',6.78),('8975','2013-04-22','12:30:00',5.74),('8975','2013-04-22','12:35:00',3.55),('8975','2013-04-22','12:40:00',5.7),('8975','2013-04-22','12:45:00',1.77),('8975','2013-04-22','12:50:00',4.92),('8975','2013-04-22','12:55:00',6.09),('8975','2013-04-22','13:00:00',6.16),('8975','2013-04-22','13:05:00',5.96),('8975','2013-04-22','13:10:00',7.83),('8975','2013-04-22','13:15:00',7.28),('8975','2013-04-22','13:20:00',6.59),('8975','2013-04-22','13:25:00',6.59),('8975','2013-04-22','13:30:00',6.62),('8975','2013-04-22','13:35:00',6.73),('8975','2013-04-22','13:40:00',6.32),('8975','2013-04-22','13:45:00',4.5),('8975','2013-04-22','13:50:00',6.32),('8975','2013-04-22','13:55:00',6.24),('8975','2013-04-22','14:00:00',6.48),('8975','2013-04-22','14:05:00',6.42),('8975','2013-04-22','14:10:00',5.64),('8975','2013-04-22','14:15:00',5.94),('8975','2013-04-22','14:20:00',5.29),('8975','2013-04-22','14:25:00',5.71),('8975','2013-04-22','14:30:00',5.7),('8975','2013-04-22','14:35:00',5.93),('8975','2013-04-22','14:40:00',6.03),('8975','2013-04-22','14:45:00',4.22),('8975','2013-04-22','14:50:00',3.16),('8975','2013-04-22','14:55:00',3.65),('8975','2013-04-22','15:00:00',3.92),('8975','2013-04-22','15:05:00',3.86),('8975','2013-04-22','15:10:00',4.73),('8975','2013-04-22','15:15:00',4.19),('8975','2013-04-22','15:20:00',3.96),('8975','2013-04-22','15:25:00',3.62),('8975','2013-04-22','15:30:00',3.39),('8975','2013-04-22','15:35:00',3.05),('8975','2013-04-22','15:40:00',3.12),('8975','2013-04-22','15:45:00',3.75),('8975','2013-04-22','15:50:00',3.13),('8975','2013-04-22','15:55:00',3.3),('8975','2013-04-22','16:00:00',2.74),('8975','2013-04-22','16:05:00',2.94),('8975','2013-04-22','16:10:00',2.47),('8975','2013-04-22','16:15:00',2.13),('8975','2013-04-22','16:20:00',1.92),('8975','2013-04-22','16:25:00',1.79),('8975','2013-04-22','16:30:00',1.74),('8975','2013-04-22','16:35:00',1.77),('8975','2013-04-22','16:40:00',1.83),('8975','2013-04-22','16:45:00',1.63),('8975','2013-04-22','16:50:00',1.49),('8975','2013-04-22','16:55:00',1.55),('8975','2013-04-22','17:00:00',1.68),('8975','2013-04-22','17:05:00',1.91),('8975','2013-04-22','17:10:00',2.45),('8975','2013-04-22','17:15:00',1.66),('8975','2013-04-22','17:20:00',1.92),('8975','2013-04-22','17:25:00',1.85),('8975','2013-04-22','17:30:00',1.71),('8975','2013-04-22','17:35:00',1.69),('8975','2013-04-22','17:40:00',1.67),('8975','2013-04-22','17:45:00',1.27),('8975','2013-04-21','09:00:00',1.2),('8975','2013-04-21','09:05:00',1.13),('8975','2013-04-21','09:10:00',1.26),('8975','2013-04-21','09:20:00',1.02),('8975','2013-04-21','09:25:00',1.3),('8975','2013-04-21','09:30:00',1.68),('8975','2013-04-21','09:35:00',1.42),('8975','2013-04-21','09:40:00',1.16),('8975','2013-04-21','10:30:00',1.44),('8975','2013-04-21','10:35:00',5.54),('8975','2013-04-21','10:40:00',5.98),('8975','2013-04-21','10:45:00',6.2),('8975','2013-04-21','10:50:00',4.38),('8975','2013-04-21','10:55:00',3.83),('8975','2013-04-21','11:00:00',3.55),('8975','2013-04-21','11:05:00',3.22),('8975','2013-04-21','11:10:00',3.23),('8975','2013-04-21','11:15:00',2.15),('8975','2013-04-21','11:20:00',2.69),('8975','2013-04-21','11:25:00',5.05),('8975','2013-04-21','11:30:00',5.02),('8975','2013-04-21','11:35:00',7.31),('8975','2013-04-21','11:40:00',4.44),('8975','2013-04-21','11:45:00',2.75),('8975','2013-04-21','11:50:00',5.74),('8975','2013-04-21','11:55:00',5.65),('8975','2013-04-21','12:00:00',5.47),('8975','2013-04-21','12:05:00',5.32),('8975','2013-04-21','12:10:00',4.9),('8975','2013-04-21','12:15:00',6.64),('8975','2013-04-21','12:20:00',3.08),('8975','2013-04-21','12:25:00',2.7),('8975','2013-04-21','12:30:00',2.59),('8975','2013-04-21','12:35:00',6.74),('8975','2013-04-21','12:40:00',7.53),('8975','2013-04-21','12:45:00',6.71),('8975','2013-04-21','12:50:00',7.39),('8975','2013-04-21','12:55:00',5.7),('8975','2013-04-21','13:00:00',7.5),('8975','2013-04-21','13:05:00',1.74),('8975','2013-04-21','13:10:00',4.21),('8975','2013-04-21','13:15:00',4.45),('8975','2013-04-21','13:20:00',2.42),('8975','2013-04-21','13:25:00',3.33),('8975','2013-04-21','13:30:00',6.21),('8975','2013-04-21','13:35:00',8.3),('8975','2013-04-21','13:40:00',6.74),('8975','2013-04-21','13:45:00',1.89),('8975','2013-04-21','13:50:00',1.87),('8975','2013-04-21','13:55:00',2.31),('8975','2013-04-21','14:00:00',1.94),('8975','2013-04-21','14:05:00',2.34),('8975','2013-04-21','14:10:00',1.95),('8975','2013-04-21','14:15:00',6.06),('8975','2013-04-21','14:20:00',7.43),('8975','2013-04-21','14:25:00',6.7),('8975','2013-04-21','14:30:00',4.87),('8975','2013-04-21','14:35:00',6.64),('8975','2013-04-21','14:40:00',6.24),('8975','2013-04-21','14:45:00',6.09),('8975','2013-04-21','14:50:00',5.38),('8975','2013-04-21','14:55:00',4.8),('8975','2013-04-21','15:00:00',4.57),('8975','2013-04-21','15:05:00',2.41),('8975','2013-04-21','15:10:00',1.49),('8975','2013-04-21','15:15:00',1.47),('8975','2013-04-21','15:20:00',5.51),('8975','2013-04-21','15:25:00',2.91),('8975','2013-04-21','15:30:00',2.01),('8975','2013-04-21','15:35:00',2.34),('8975','2013-04-21','15:40:00',5.74),('8975','2013-04-21','15:45:00',2.66),('8975','2013-04-21','15:50:00',1.73),('8975','2013-04-21','15:55:00',1.95),('8975','2013-04-21','16:00:00',2.13),('8975','2013-04-21','16:05:00',1.32),('8975','2013-04-21','16:10:00',1.41),('8975','2013-04-21','16:15:00',1.68),('8975','2013-04-21','16:20:00',1.11),('8975','2013-04-21','16:30:00',1.12),('8975','2013-04-21','16:35:00',1.28),('8975','2013-04-21','16:40:00',1.88),('8975','2013-04-21','16:45:00',1.31),('8975','2013-04-21','16:50:00',1.04),('8975','2013-04-21','17:10:00',1.01),('8975','2013-04-21','17:25:00',1.15),('8975','2013-04-21','17:30:00',1.31),('8975','2013-04-21','17:35:00',1.45),('8975','2013-04-21','17:40:00',1.16),('8975','2013-04-21','18:15:00',1.02),('8975','2013-04-21','18:50:00',1.22),('8975','2013-04-21','18:55:00',1.06),('8975','2014-03-28','06:40:00',1.21),('8975','2014-03-28','06:45:00',1.35),('8975','2014-03-28','06:50:00',1.61),('8975','2014-03-28','06:55:00',1.73),('8975','2014-03-28','07:00:00',1.97),('8975','2014-03-28','07:05:00',2.25),('8975','2014-03-28','07:10:00',2.42),('8975','2014-03-28','07:15:00',2.57),('8975','2014-03-28','07:20:00',2.68),('8975','2014-03-28','07:25:00',2.77),('8975','2014-03-28','07:30:00',2.88),('8975','2014-03-28','07:35:00',3.04),('8975','2014-03-28','07:40:00',3.19),('8975','2014-03-28','07:45:00',3.32),('8975','2014-03-28','07:50:00',3.42),('8975','2014-03-28','07:55:00',3.52),('8975','2014-03-28','08:00:00',3.6),('8975','2014-03-28','08:05:00',3.67),('8975','2014-03-28','08:10:00',3.82),('8975','2014-03-28','08:15:00',3.93),('8975','2014-03-28','08:20:00',3.97),('8975','2014-03-28','08:25:00',4.05),('8975','2014-03-28','08:30:00',4.13),('8975','2014-03-28','08:35:00',4.23),('8975','2014-03-28','08:40:00',4.32),('8975','2014-03-28','08:45:00',4.43),('8975','2014-03-28','08:50:00',4.52),('8975','2014-03-28','08:55:00',4.63),('8975','2014-03-28','09:00:00',4.77),('8975','2014-03-28','09:05:00',4.84),('8975','2014-03-28','09:10:00',4.97),('8975','2014-03-28','09:15:00',5.06),('8975','2014-03-28','09:20:00',5.15),('8975','2014-03-28','09:25:00',5.26),('8975','2014-03-28','09:30:00',5.32),('8975','2014-03-28','09:35:00',5.37),('8975','2014-03-28','09:40:00',5.45),('8975','2014-03-28','09:45:00',5.49),('8975','2014-03-28','09:50:00',5.53),('8975','2014-03-28','09:55:00',5.56),('8975','2014-03-28','10:00:00',5.61),('8975','2014-03-28','10:05:00',5.64),('8975','2014-03-28','10:10:00',5.74),('8975','2014-03-28','10:15:00',5.77),('8975','2014-03-28','10:20:00',5.86),('8975','2014-03-28','10:25:00',5.95),('8975','2014-03-28','10:30:00',5.97),('8975','2014-03-28','10:35:00',5.98),('8975','2014-03-28','10:40:00',6.03),('8975','2014-03-28','10:45:00',6.09),('8975','2014-03-28','10:50:00',6.1),('8975','2014-03-28','10:55:00',6.15),('8975','2014-03-28','11:00:00',6.15),('8975','2014-03-28','11:05:00',6.11),('8975','2014-03-28','11:10:00',6.12),('8975','2014-03-28','11:15:00',6.11),('8975','2014-03-28','11:20:00',6.1),('8975','2014-03-28','11:25:00',6.14),('8975','2014-03-28','11:30:00',6.2),('8975','2014-03-28','11:35:00',6.14),('8975','2014-03-28','11:40:00',6.01),('8975','2014-03-28','11:45:00',6.1),('8975','2014-03-28','11:50:00',6.1),('8975','2014-03-28','11:55:00',6.06),('8975','2014-03-28','12:00:00',6.01),('8975','2014-03-28','12:05:00',5.93),('8975','2014-03-28','12:10:00',5.96),('8975','2014-03-28','12:15:00',5.91),('8975','2014-03-28','12:20:00',5.85),('8975','2014-03-28','12:25:00',5.83),('8975','2014-03-28','12:30:00',5.79),('8975','2014-03-28','12:35:00',4.87),('8975','2014-03-28','12:40:00',5.64),('8975','2014-03-28','12:45:00',5.69),('8975','2014-03-28','12:50:00',5.67),('8975','2014-03-28','12:55:00',5.58),('8975','2014-03-28','13:00:00',5.57),('8975','2014-03-28','13:05:00',5.45),('8975','2014-03-28','13:10:00',5.42),('8975','2014-03-28','13:15:00',5.3),('8975','2014-03-28','13:20:00',5.22),('8975','2014-03-28','13:25:00',5.12),('8975','2014-03-28','13:30:00',4.97),('8975','2014-03-28','13:35:00',4.93),('8975','2014-03-28','13:40:00',4.9),('8975','2014-03-28','13:45:00',4.78),('8975','2014-03-28','13:50:00',4.64),('8975','2014-03-28','13:55:00',4.58),('8975','2014-03-28','14:00:00',4.52),('8975','2014-03-28','14:05:00',4.37),('8975','2014-03-28','14:10:00',4.15),('8975','2014-03-28','14:15:00',4.04),('8975','2014-03-28','14:20:00',3.95),('8975','2014-03-28','14:25:00',3.85),('8975','2014-03-28','14:30:00',3.79),('8975','2014-03-28','14:35:00',3.66),('8975','2014-03-28','14:40:00',3.65),('8975','2014-03-28','14:45:00',3.55),('8975','2014-03-28','14:50:00',3.42),('8975','2014-03-28','14:55:00',3.18),('8975','2014-03-28','15:00:00',2.83),('8975','2014-03-28','15:05:00',3.13),('8975','2014-03-28','15:10:00',2.79),('8975','2014-03-28','15:15:00',2.94),('8975','2014-03-28','15:20:00',2.83),('8975','2014-03-28','15:25:00',2.68),('8975','2014-03-28','15:30:00',2.53),('8975','2014-03-28','15:35:00',2.43),('8975','2014-03-28','15:40:00',2.36),('8975','2014-03-28','15:45:00',2.26),('8975','2014-03-28','15:50:00',2.12),('8975','2014-03-28','15:55:00',2.03),('8975','2014-03-28','16:00:00',1.96),('8975','2014-03-28','16:05:00',1.87),('8975','2014-03-28','16:10:00',1.78),('8975','2014-03-28','16:15:00',1.71),('8975','2014-03-28','16:20:00',1.58),('8975','2014-03-28','16:25:00',1.56),('8975','2014-03-28','16:30:00',1.53),('8975','2014-03-28','16:35:00',1.38),('8975','2014-03-28','16:40:00',1.26),('8975','2014-03-28','16:45:00',1.06),('8975','2014-03-28','16:50:00',1.13),('8975','2014-03-28','16:55:00',1.22),('8975','2014-03-28','17:00:00',1.18),('8975','2014-03-28','17:05:00',1.1),('8975','2014-03-28','17:10:00',1.03),('8975','2013-04-20','07:55:00',1.74),('8975','2013-04-20','08:00:00',1.8),('8975','2013-04-20','08:05:00',1.88),('8975','2013-04-20','08:10:00',2.22),('8975','2013-04-20','08:15:00',2.03),('8975','2013-04-20','08:20:00',1.88),('8975','2013-04-20','08:25:00',2.76),('8975','2013-04-20','08:30:00',3.16),('8975','2013-04-20','08:35:00',2.57),('8975','2013-04-20','08:40:00',1.79),('8975','2013-04-20','08:45:00',1.84),('8975','2013-04-20','08:50:00',2.38),('8975','2013-04-20','08:55:00',2.3),('8975','2013-04-20','09:00:00',3.51),('8975','2013-04-20','09:05:00',3.44),('8975','2013-04-20','09:10:00',4.34),('8975','2013-04-20','09:15:00',3.72),('8975','2013-04-20','09:20:00',2.21),('8975','2013-04-20','09:25:00',3.47),('8975','2013-04-20','09:30:00',5.58),('8975','2013-04-20','09:35:00',4.94),('8975','2013-04-20','09:40:00',5.33),('8975','2013-04-20','09:45:00',6.04),('8975','2013-04-20','09:50:00',4.61),('8975','2013-04-20','09:55:00',5.34),('8975','2013-04-20','10:00:00',4.25),('8975','2013-04-20','10:05:00',3.61),('8975','2013-04-20','10:10:00',3.54),('8975','2013-04-20','10:15:00',3.98),('8975','2013-04-20','10:20:00',6.48),('8975','2013-04-20','10:25:00',3.56),('8975','2013-04-20','10:30:00',3.47),('8975','2013-04-20','10:35:00',4),('8975','2013-04-20','10:40:00',5.93),('8975','2013-04-20','10:45:00',3.38),('8975','2013-04-20','10:50:00',3.87),('8975','2013-04-20','10:55:00',4.79),('8975','2013-04-20','11:00:00',7.04),('8975','2013-04-20','11:05:00',5.61),('8975','2013-04-20','11:10:00',4.85),('8975','2013-04-20','11:15:00',4.42),('8975','2013-04-20','11:20:00',4.99),('8975','2013-04-20','11:25:00',4.34),('8975','2013-04-20','11:30:00',4.28),('8975','2013-04-20','11:35:00',4.32),('8975','2013-04-20','11:40:00',4.41),('8975','2013-04-20','11:45:00',5),('8975','2013-04-20','11:50:00',4.38),('8975','2013-04-20','11:55:00',4.69),('8975','2013-04-20','12:00:00',3.83),('8975','2013-04-20','12:05:00',3.9),('8975','2013-04-20','12:10:00',3.65),('8975','2013-04-20','12:15:00',3.53),('8975','2013-04-20','12:20:00',3.11),('8975','2013-04-20','12:25:00',3.25),('8975','2013-04-20','12:30:00',3.45),('8975','2013-04-20','12:35:00',3.45),('8975','2013-04-20','12:40:00',3.51),('8975','2013-04-20','12:45:00',3.46),('8975','2013-04-20','12:50:00',3.25),('8975','2013-04-20','12:55:00',3.3),('8975','2013-04-20','13:00:00',3.87),('8975','2013-04-20','13:05:00',4.1),('8975','2013-04-20','13:10:00',4.23),('8975','2013-04-20','13:15:00',3.77),('8975','2013-04-20','13:20:00',3.59),('8975','2013-04-20','13:25:00',3.78),('8975','2013-04-20','13:30:00',6.3),('8975','2013-04-20','13:35:00',5.51),('8975','2013-04-20','13:40:00',5.06),('8975','2013-04-20','13:45:00',4.92),('8975','2013-04-20','13:50:00',4.09),('8975','2013-04-20','13:55:00',6.83),('8975','2013-04-20','14:00:00',6.48),('8975','2013-04-20','14:05:00',6.4),('8975','2013-04-20','14:10:00',6.31),('8975','2013-04-20','14:15:00',6.71),('8975','2013-04-20','14:20:00',6.45),('8975','2013-04-20','14:25:00',6.33),('8975','2013-04-20','14:30:00',5.6),('8975','2013-04-20','14:35:00',5.98),('8975','2013-04-20','14:40:00',5.45),('8975','2013-04-20','14:45:00',3.61),('8975','2013-04-20','14:50:00',2.83),('8975','2013-04-20','14:55:00',2.77),('8975','2013-04-20','15:00:00',5.1),('8975','2013-04-20','15:05:00',5.36),('8975','2013-04-20','15:10:00',4.71),('8975','2013-04-20','15:15:00',3.26),('8975','2013-04-20','15:20:00',2.64),('8975','2013-04-20','15:25:00',2.75),('8975','2013-04-20','15:30:00',2.49),('8975','2013-04-20','15:35:00',2.18),('8975','2013-04-20','15:40:00',2.19),('8975','2013-04-20','15:45:00',1.82),('8975','2013-04-20','15:50:00',1.61),('8975','2013-04-20','15:55:00',1.45),('8975','2013-04-20','16:00:00',1.27),('8975','2013-04-20','16:05:00',1.13),('8975','2013-04-20','16:10:00',1.18),('8975','2013-04-20','16:15:00',1.13),('8975','2013-04-20','16:35:00',1.01),('8975','2013-04-20','16:55:00',1.25),('8975','2013-04-20','17:00:00',1.42),('8975','2013-04-20','17:05:00',1.31),('8975','2013-04-20','17:10:00',1.11),('8975','2013-04-20','17:15:00',1.1),('8975','2013-04-19','07:15:00',1),('8975','2013-04-19','07:25:00',1.43),('8975','2013-04-19','07:30:00',1.87),('8975','2013-04-19','07:35:00',2.43),('8975','2013-04-19','07:40:00',2.35),('8975','2013-04-19','07:45:00',1.85),('8975','2013-04-19','07:50:00',2.04),('8975','2013-04-19','07:55:00',2.28),('8975','2013-04-19','08:00:00',2.55),('8975','2013-04-19','08:05:00',2.73),('8975','2013-04-19','08:10:00',3.01),('8975','2013-04-19','08:15:00',2.64),('8975','2013-04-19','08:20:00',2.63),('8975','2013-04-19','08:25:00',2.91),('8975','2013-04-19','08:30:00',3.17),('8975','2013-04-19','08:35:00',3.48),('8975','2013-04-19','08:40:00',3.82),('8975','2013-04-19','08:45:00',3.97),('8975','2013-04-19','08:50:00',3.46),('8975','2013-04-19','08:55:00',4.37),('8975','2013-04-19','09:00:00',3.98),('8975','2013-04-19','09:05:00',4.66),('8975','2013-04-19','09:10:00',5.04),('8975','2013-04-19','09:15:00',4.74),('8975','2013-04-19','09:20:00',4.96),('8975','2013-04-19','09:25:00',4.4),('8975','2013-04-19','09:30:00',2.48),('8975','2013-04-19','09:35:00',2.54),('8975','2013-04-19','09:40:00',1.69),('8975','2013-04-19','09:45:00',1.43),('8975','2013-04-19','09:50:00',1.41),('8975','2013-04-19','09:55:00',1.2),('8975','2013-04-19','10:25:00',1.45),('8975','2013-04-19','10:30:00',1.99),('8975','2013-04-19','10:35:00',2.43),('8975','2013-04-19','10:40:00',5.05),('8975','2013-04-19','10:45:00',6.43),('8975','2013-04-19','10:50:00',5.1),('8975','2013-04-19','10:55:00',3.12),('8975','2013-04-19','11:00:00',5.23),('8975','2013-04-19','11:05:00',6.53),('8975','2013-04-19','11:10:00',6.92),('8975','2013-04-19','11:15:00',5.42),('8975','2013-04-19','11:20:00',7.31),('8975','2013-04-19','11:25:00',5.6),('8975','2013-04-19','11:30:00',2.58),('8975','2013-04-19','11:35:00',5.19),('8975','2013-04-19','11:40:00',7.12),('8975','2013-04-19','11:45:00',7.39),('8975','2013-04-19','11:50:00',7.18),('8975','2013-04-19','11:55:00',5.09),('8975','2013-04-19','12:00:00',6.79),('8975','2013-04-19','12:05:00',6.56),('8975','2013-04-19','12:10:00',6.86),('8975','2013-04-19','12:15:00',6.82),('8975','2013-04-19','12:20:00',6.78),('8975','2013-04-19','12:25:00',6.89),('8975','2013-04-19','12:30:00',6.88),('8975','2013-04-19','12:35:00',6.63),('8975','2013-04-19','12:40:00',6.69),('8975','2013-04-19','12:45:00',6.73),('8975','2013-04-19','12:50:00',3.9),('8975','2013-04-19','12:55:00',3.54),('8975','2013-04-19','13:00:00',6.98),('8975','2013-04-19','13:05:00',5.05),('8975','2013-04-19','13:10:00',2.07),('8975','2013-04-19','13:15:00',6.59),('8975','2013-04-19','13:20:00',6.81),('8975','2013-04-19','13:25:00',6.63),('8975','2013-04-19','13:30:00',6.55),('8975','2013-04-19','13:35:00',5.6),('8975','2013-04-19','13:40:00',2.69),('8975','2013-04-19','13:45:00',5.44),('8975','2013-04-19','13:50:00',4),('8975','2013-04-19','13:55:00',5.72),('8975','2013-04-19','14:00:00',7.02),('8975','2013-04-19','14:05:00',6.2),('8975','2013-04-19','14:10:00',5.68),('8975','2013-04-19','14:15:00',5.69),('8975','2013-04-19','14:20:00',5.58),('8975','2013-04-19','14:25:00',5.4),('8975','2013-04-19','14:30:00',5.36),('8975','2013-04-19','14:35:00',5.27),('8975','2013-04-19','14:40:00',5.21),('8975','2013-04-19','14:45:00',5.29),('8975','2013-04-19','14:50:00',5.24),('8975','2013-04-19','14:55:00',5.14),('8975','2013-04-19','15:00:00',5.04),('8975','2013-04-19','15:05:00',4.87),('8975','2013-04-19','15:10:00',3.95),('8975','2013-04-19','15:15:00',4.64),('8975','2013-04-19','15:20:00',4.38),('8975','2013-04-19','15:25:00',3.14),('8975','2013-04-19','15:30:00',1.67),('8975','2013-04-19','15:35:00',1.17),('8975','2013-04-19','15:40:00',1.16),('8975','2013-04-19','15:45:00',1.22),('8975','2013-04-19','15:50:00',1.17),('8975','2013-04-19','15:55:00',1.13),('8975','2013-04-19','16:00:00',1.3),('8975','2013-04-19','16:05:00',1.77),('8975','2013-04-19','16:10:00',2.34),('8975','2013-04-19','16:15:00',2.52),('8975','2013-04-19','16:20:00',3.16),('8975','2013-04-19','16:25:00',3.21),('8975','2013-04-19','16:30:00',3.16),('8975','2013-04-19','16:35:00',3.6),('8975','2013-04-19','16:40:00',3.89),('8975','2013-04-19','16:45:00',3.46),('8975','2013-04-19','16:50:00',3.09),('8975','2013-04-19','16:55:00',2.82),('8975','2013-04-19','17:00:00',2.65),('8975','2013-04-19','17:05:00',2.47),('8975','2013-04-19','17:10:00',2.42),('8975','2013-04-19','17:15:00',2.27),('8975','2013-04-19','17:20:00',2.16),('8975','2013-04-19','17:25:00',2.21),('8975','2013-04-19','17:30:00',2.24),('8975','2013-04-19','17:35:00',2.16),('8975','2013-04-19','17:40:00',1.8),('8975','2013-04-19','17:45:00',1.12),('8975','2013-04-19','17:50:00',1.08),('8975','2013-04-19','17:55:00',1.47),('8975','2013-04-19','18:00:00',1.28),('8975','2013-04-19','18:05:00',1.68),('8975','2013-04-19','18:10:00',1.76),('8975','2013-04-19','18:15:00',1.4),('8975','2013-04-18','07:30:00',1.18),('8975','2013-04-18','07:40:00',1.08),('8975','2013-04-18','07:50:00',1.42),('8975','2013-04-18','07:55:00',2.12),('8975','2013-04-18','08:00:00',2.83),('8975','2013-04-18','08:05:00',1.13),('8975','2013-04-18','08:10:00',2.51),('8975','2013-04-18','08:15:00',2.87),('8975','2013-04-18','08:20:00',3.23),('8975','2013-04-18','08:25:00',3.38),('8975','2013-04-18','08:30:00',3.3),('8975','2013-04-18','08:35:00',3.64),('8975','2013-04-18','08:40:00',3.78),('8975','2013-04-18','08:45:00',3.9),('8975','2013-04-18','08:50:00',4.07),('8975','2013-04-18','08:55:00',4.25),('8975','2013-04-18','09:00:00',4.29),('8975','2013-04-18','09:05:00',4.04),('8975','2013-04-18','09:10:00',4.37),('8975','2013-04-18','09:15:00',4.33),('8975','2013-04-18','09:20:00',4.46),('8975','2013-04-18','09:25:00',4.47),('8975','2013-04-18','09:30:00',4.57),('8975','2013-04-18','09:35:00',4.72),('8975','2013-04-18','09:40:00',4.74),('8975','2013-04-18','09:45:00',4.74),('8975','2013-04-18','09:50:00',4.77),('8975','2013-04-18','09:55:00',4.86),('8975','2013-04-18','10:00:00',4.95),('8975','2013-04-18','10:05:00',5),('8975','2013-04-18','10:10:00',5.15),('8975','2013-04-18','10:15:00',5.23),('8975','2013-04-18','10:20:00',5.4),('8975','2013-04-18','10:25:00',5.49),('8975','2013-04-18','10:30:00',5.48),('8975','2013-04-18','10:35:00',5.5),('8975','2013-04-18','10:40:00',5.59),('8975','2013-04-18','10:45:00',5.63),('8975','2013-04-18','10:50:00',5.64),('8975','2013-04-18','10:55:00',5.65),('8975','2013-04-18','11:00:00',5.63),('8975','2013-04-18','11:05:00',5.75),('8975','2013-04-18','11:10:00',5.78),('8975','2013-04-18','11:15:00',5.76),('8975','2013-04-18','11:20:00',5.73),('8975','2013-04-18','11:25:00',5.79),('8975','2013-04-18','11:30:00',5.83),('8975','2013-04-18','11:35:00',5.9),('8975','2013-04-18','11:40:00',5.94),('8975','2013-04-18','11:45:00',5.76),('8975','2013-04-18','11:50:00',5.94),('8975','2013-04-18','11:55:00',6.07),('8975','2013-04-18','12:00:00',5.99),('8975','2013-04-18','12:05:00',6.1),('8975','2013-04-18','12:10:00',6.07),('8975','2013-04-18','12:15:00',6.13),('8975','2013-04-18','12:20:00',6.08),('8975','2013-04-18','12:25:00',6.12),('8975','2013-04-18','12:30:00',6),('8975','2013-04-18','12:35:00',5.92),('8975','2013-04-18','12:40:00',5.99),('8975','2013-04-18','12:45:00',5.96),('8975','2013-04-18','12:50:00',5.81),('8975','2013-04-18','12:55:00',5.92),('8975','2013-04-18','13:00:00',5.88),('8975','2013-04-18','13:05:00',5.91),('8975','2013-04-18','13:10:00',5.99),('8975','2013-04-18','13:15:00',5.81),('8975','2013-04-18','13:20:00',5.83),('8975','2013-04-18','13:25:00',5.88),('8975','2013-04-18','13:30:00',5.85),('8975','2013-04-18','13:35:00',5.77),('8975','2013-04-18','13:40:00',5.67),('8975','2013-04-18','13:45:00',5.63),('8975','2013-04-18','13:50:00',5.56),('8975','2013-04-18','13:55:00',5.53),('8975','2013-04-18','14:00:00',5.47),('8975','2013-04-18','14:05:00',5.5),('8975','2013-04-18','14:10:00',5.36),('8975','2013-04-18','14:15:00',5.27),('8975','2013-04-18','14:20:00',5.26),('8975','2013-04-18','14:25:00',5.07),('8975','2013-04-18','14:30:00',4.6),('8975','2013-04-18','14:35:00',4.7),('8975','2013-04-18','14:40:00',4.22),('8975','2013-04-18','14:45:00',4.86),('8975','2013-04-18','14:50:00',4.67),('8975','2013-04-18','14:55:00',4.36),('8975','2013-04-18','15:00:00',4.28),('8975','2013-04-18','15:05:00',4.26),('8975','2013-04-18','15:10:00',4.43),('8975','2013-04-18','15:15:00',4.06),('8975','2013-04-18','15:20:00',3.75),('8975','2013-04-18','15:25:00',4.2),('8975','2013-04-18','15:30:00',4.04),('8975','2013-04-18','15:35:00',3.98),('8975','2013-04-18','15:40:00',3.9),('8975','2013-04-18','15:45:00',3.8),('8975','2013-04-18','15:50:00',3.69),('8975','2013-04-18','15:55:00',3.58),('8975','2013-04-18','16:00:00',3.49),('8975','2013-04-18','16:05:00',3.4),('8975','2013-04-18','16:10:00',3.3),('8975','2013-04-18','16:15:00',3.21),('8975','2013-04-18','16:20:00',3.1),('8975','2013-04-18','16:25:00',3.01),('8975','2013-04-18','16:30:00',2.89),('8975','2013-04-18','16:35:00',2.79),('8975','2013-04-18','16:40:00',2.7),('8975','2013-04-18','16:45:00',2.61),('8975','2013-04-18','16:50:00',2.47),('8975','2013-04-18','16:55:00',2.36),('8975','2013-04-18','17:00:00',2.26),('8975','2013-04-18','17:05:00',2.16),('8975','2013-04-18','17:10:00',2.06),('8975','2013-04-18','17:15:00',1.95),('8975','2013-04-18','17:20:00',1.86),('8975','2013-04-18','17:25:00',1.78),('8975','2013-04-18','17:30:00',1.7),('8975','2013-04-18','17:35:00',1.61),('8975','2013-04-18','17:40:00',1.53),('8975','2013-04-18','17:45:00',1.46),('8975','2013-04-18','17:50:00',1.38),('8975','2013-04-18','17:55:00',1.33),('8975','2013-04-18','18:00:00',1.29),('8975','2013-04-18','18:05:00',1.22),('8975','2013-04-18','18:10:00',1.16),('8975','2013-04-18','18:15:00',1.11),('8975','2013-04-18','18:20:00',1.06),('8975','2013-04-18','18:25:00',1.02),('8975','2013-04-17','07:00:00',1.34),('8975','2013-04-17','07:05:00',1.54),('8975','2013-04-17','07:10:00',1.68),('8975','2013-04-17','07:40:00',1.13),('8975','2013-04-17','07:45:00',1.14),('8975','2013-04-17','07:50:00',1.23),('8975','2013-04-17','07:55:00',1.26),('8975','2013-04-17','08:00:00',1.46),('8975','2013-04-17','08:05:00',1.93),('8975','2013-04-17','08:10:00',2.73),('8975','2013-04-17','08:15:00',2.85),('8975','2013-04-17','08:20:00',2.85),('8975','2013-04-17','08:25:00',2.85),('8975','2013-04-17','08:30:00',2.82),('8975','2013-04-17','08:35:00',3.23),('8975','2013-04-17','08:40:00',2.88),('8975','2013-04-17','08:45:00',2.93),('8975','2013-04-17','08:50:00',3.1),('8975','2013-04-17','08:55:00',3.53),('8975','2013-04-17','09:00:00',3.7),('8975','2013-04-17','09:05:00',3.87),('8975','2013-04-17','09:10:00',3.89),('8975','2013-04-17','09:15:00',3.94),('8975','2013-04-17','09:20:00',4.03),('8975','2013-04-17','09:25:00',3.97),('8975','2013-04-17','09:30:00',4.25),('8975','2013-04-17','09:35:00',4.65),('8975','2013-04-17','09:40:00',5.05),('8975','2013-04-17','09:45:00',5.1),('8975','2013-04-17','09:50:00',4.16),('8975','2013-04-17','09:55:00',3.97),('8975','2013-04-17','10:00:00',4.56),('8975','2013-04-17','10:05:00',5.11),('8975','2013-04-17','10:10:00',5.33),('8975','2013-04-17','10:15:00',5.75),('8975','2013-04-17','10:20:00',5.78),('8975','2013-04-17','10:25:00',5.63),('8975','2013-04-17','10:30:00',5.76),('8975','2013-04-17','10:35:00',5.76),('8975','2013-04-17','10:40:00',5.8),('8975','2013-04-17','10:45:00',5.84),('8975','2013-04-17','10:50:00',5.85),('8975','2013-04-17','10:55:00',5.93),('8975','2013-04-17','11:00:00',5.92),('8975','2013-04-17','11:05:00',5.96),('8975','2013-04-17','11:10:00',5.99),('8975','2013-04-17','11:15:00',6.05),('8975','2013-04-17','11:20:00',6.07),('8975','2013-04-17','11:25:00',6.11),('8975','2013-04-17','11:30:00',6.1),('8975','2013-04-17','11:35:00',6.17),('8975','2013-04-17','11:40:00',6.13),('8975','2013-04-17','11:45:00',6.19),('8975','2013-04-17','11:50:00',6.08),('8975','2013-04-17','11:55:00',6.27),('8975','2013-04-17','12:00:00',6.14),('8975','2013-04-17','12:05:00',6.25),('8975','2013-04-17','12:10:00',6.27),('8975','2013-04-17','12:15:00',6.24),('8975','2013-04-17','12:20:00',6.31),('8975','2013-04-17','12:25:00',6.28),('8975','2013-04-17','12:30:00',6.29),('8975','2013-04-17','12:35:00',6.26),('8975','2013-04-17','12:40:00',6.27),('8975','2013-04-17','12:45:00',6.24),('8975','2013-04-17','12:50:00',6.27),('8975','2013-04-17','12:55:00',6.29),('8975','2013-04-17','13:00:00',6.22),('8975','2013-04-17','13:05:00',6.24),('8975','2013-04-17','13:10:00',6.23),('8975','2013-04-17','13:15:00',6.2),('8975','2013-04-17','13:20:00',6.14),('8975','2013-04-17','13:25:00',6.08),('8975','2013-04-17','13:30:00',6.03),('8975','2013-04-17','13:35:00',6.03),('8975','2013-04-17','13:40:00',5.98),('8975','2013-04-17','13:45:00',5.92),('8975','2013-04-17','13:50:00',5.89),('8975','2013-04-17','13:55:00',5.86),('8975','2013-04-17','14:00:00',5.8),('8975','2013-04-17','14:05:00',5.73),('8975','2013-04-17','14:10:00',5.68),('8975','2013-04-17','14:15:00',5.57),('8975','2013-04-17','14:20:00',5.55),('8975','2013-04-17','14:25:00',5.48),('8975','2013-04-17','14:30:00',5.41),('8975','2013-04-17','14:35:00',5.33),('8975','2013-04-17','14:40:00',5.23),('8975','2013-04-17','14:45:00',5.16),('8975','2013-04-17','14:50:00',5.08),('8975','2013-04-17','14:55:00',4.99),('8975','2013-04-17','15:00:00',4.88),('8975','2013-04-17','15:05:00',4.76),('8975','2013-04-17','15:10:00',4.68),('8975','2013-04-17','15:15:00',4.58),('8975','2013-04-17','15:20:00',4.49),('8975','2013-04-17','15:25:00',4.41),('8975','2013-04-17','15:30:00',4.16),('8975','2013-04-17','15:35:00',3.97),('8975','2013-04-17','15:40:00',4.05),('8975','2013-04-17','15:45:00',3.95),('8975','2013-04-17','15:50:00',3.85),('8975','2013-04-17','15:55:00',3.73),('8975','2013-04-17','16:00:00',3.58),('8975','2013-04-17','16:05:00',3.46),('8975','2013-04-17','16:10:00',3.37),('8975','2013-04-17','16:15:00',3.25),('8975','2013-04-17','16:20:00',3.14),('8975','2013-04-17','16:25:00',3.07),('8975','2013-04-17','16:30:00',2.94),('8975','2013-04-17','16:35:00',2.84),('8975','2013-04-17','16:40:00',2.75),('8975','2013-04-17','16:45:00',2.62),('8975','2013-04-17','16:50:00',2.52),('8975','2013-04-17','16:55:00',2.42),('8975','2013-04-17','17:00:00',2.32),('8975','2013-04-17','17:05:00',2.19),('8975','2013-04-17','17:10:00',2.07),('8975','2013-04-17','17:15:00',1.99),('8975','2013-04-17','17:20:00',1.91),('8975','2013-04-17','17:25:00',1.82),('8975','2013-04-17','17:30:00',1.73),('8975','2013-04-17','17:35:00',1.65),('8975','2013-04-17','17:40:00',1.57),('8975','2013-04-17','17:45:00',1.49),('8975','2013-04-17','17:50:00',1.45),('8975','2013-04-17','17:55:00',1.4),('8975','2013-04-17','18:00:00',1.36),('8975','2013-04-17','18:05:00',1.3),('8975','2013-04-17','18:10:00',1.24),('8975','2013-04-17','18:15:00',1.17),('8975','2013-04-17','18:20:00',1.11),('8975','2013-04-17','18:25:00',1.03),('8975','2013-04-16','07:00:00',1.06),('8975','2013-04-16','07:05:00',1.25),('8975','2013-04-16','07:10:00',1.47),('8975','2013-04-16','07:15:00',1.58),('8975','2013-04-16','07:20:00',1.67),('8975','2013-04-16','07:25:00',2.02),('8975','2013-04-16','07:30:00',2.13),('8975','2013-04-16','07:35:00',2.33),('8975','2013-04-16','07:40:00',2.52),('8975','2013-04-16','07:45:00',2.66),('8975','2013-04-16','07:50:00',2.8),('8975','2013-04-16','07:55:00',2.92),('8975','2013-04-16','08:00:00',3.05),('8975','2013-04-16','08:05:00',3.16),('8975','2013-04-16','08:10:00',3.29),('8975','2013-04-16','08:15:00',3.42),('8975','2013-04-16','08:20:00',3.52),('8975','2013-04-16','08:25:00',3.62),('8975','2013-04-16','08:30:00',3.71),('8975','2013-04-16','08:35:00',3.81),('8975','2013-04-16','08:40:00',3.9),('8975','2013-04-16','08:45:00',4),('8975','2013-04-16','08:50:00',4.1),('8975','2013-04-16','08:55:00',4.18),('8975','2013-04-16','09:00:00',4.27),('8975','2013-04-16','09:05:00',4.35),('8975','2013-04-16','09:10:00',4.44),('8975','2013-04-16','09:15:00',4.55),('8975','2013-04-16','09:20:00',4.65),('8975','2013-04-16','09:25:00',4.76),('8975','2013-04-16','09:30:00',4.83),('8975','2013-04-16','09:35:00',4.94),('8975','2013-04-16','09:40:00',5.04),('8975','2013-04-16','09:45:00',5.12),('8975','2013-04-16','09:50:00',5.18),('8975','2013-04-16','09:55:00',5.26),('8975','2013-04-16','10:00:00',5.32),('8975','2013-04-16','10:05:00',5.38),('8975','2013-04-16','10:10:00',5.48),('8975','2013-04-16','10:15:00',5.55),('8975','2013-04-16','10:20:00',5.63),('8975','2013-04-16','10:25:00',5.67),('8975','2013-04-16','10:30:00',5.73),('8975','2013-04-16','10:35:00',5.77),('8975','2013-04-16','10:40:00',5.81),('8975','2013-04-16','10:45:00',5.85),('8975','2013-04-16','10:50:00',5.93),('8975','2013-04-16','10:55:00',5.96),('8975','2013-04-16','11:00:00',5.98),('8975','2013-04-16','11:05:00',6.03),('8975','2013-04-16','11:10:00',6.12),('8975','2013-04-16','11:15:00',6.16),('8975','2013-04-16','11:20:00',6.18),('8975','2013-04-16','11:25:00',6.18),('8975','2013-04-16','11:30:00',6.21),('8975','2013-04-16','11:35:00',6.25),('8975','2013-04-16','11:40:00',6.25),('8975','2013-04-16','11:45:00',6.27),('8975','2013-04-16','11:50:00',6.28),('8975','2013-04-16','11:55:00',6.31),('8975','2013-04-16','12:00:00',6.29),('8975','2013-04-16','12:05:00',6.26),('8975','2013-04-16','12:10:00',6.29),('8975','2013-04-16','12:15:00',6.31),('8975','2013-04-16','12:20:00',6.27),('8975','2013-04-16','12:25:00',6.32),('8975','2013-04-16','12:30:00',6.28),('8975','2013-04-16','12:35:00',6.3),('8975','2013-04-16','12:40:00',6.28),('8975','2013-04-16','12:45:00',6.25),('8975','2013-04-16','12:50:00',6.24),('8975','2013-04-16','12:55:00',6.23),('8975','2013-04-16','13:00:00',6.2),('8975','2013-04-16','13:05:00',6.15),('8975','2013-04-16','13:10:00',5.75),('8975','2013-04-16','13:15:00',4.8),('8975','2013-04-16','13:20:00',4.99),('8975','2013-04-16','13:25:00',5.51),('8975','2013-04-16','13:30:00',5.37),('8975','2013-04-16','13:35:00',6.04),('8975','2013-04-16','13:40:00',5.88),('8975','2013-04-16','13:45:00',5.57),('8975','2013-04-16','13:50:00',5.68),('8975','2013-04-16','13:55:00',5.53),('8975','2013-04-16','14:00:00',5.59),('8975','2013-04-16','14:05:00',5.95),('8975','2013-04-16','14:10:00',6.25),('8975','2013-04-16','14:15:00',5.94),('8975','2013-04-16','14:20:00',5.89),('8975','2013-04-16','14:25:00',5.22),('8975','2013-04-16','14:30:00',5.25),('8975','2013-04-16','14:35:00',6.04),('8975','2013-04-16','14:40:00',5.22),('8975','2013-04-16','14:45:00',4.95),('8975','2013-04-16','14:50:00',5.78),('8975','2013-04-16','14:55:00',5.5),('8975','2013-04-16','15:00:00',5.4),('8975','2013-04-16','15:05:00',5.43),('8975','2013-04-16','15:10:00',5.63),('8975','2013-04-16','15:15:00',5.12),('8975','2013-04-16','15:20:00',3.65),('8975','2013-04-16','15:25:00',2.27),('8975','2013-04-16','15:30:00',3.44),('8975','2013-04-16','15:35:00',4.08),('8975','2013-04-16','15:40:00',4.48),('8975','2013-04-16','15:45:00',4.46),('8975','2013-04-16','15:50:00',4.47),('8975','2013-04-16','15:55:00',4.34),('8975','2013-04-16','16:00:00',4.23),('8975','2013-04-16','16:05:00',3.34),('8975','2013-04-16','16:10:00',3.52),('8975','2013-04-16','16:15:00',3.64),('8975','2013-04-16','16:20:00',3.42),('8975','2013-04-16','16:25:00',3.3),('8975','2013-04-16','16:30:00',3.21),('8975','2013-04-16','16:35:00',3.13),('8975','2013-04-16','16:40:00',2.92),('8975','2013-04-16','16:45:00',2.75),('8975','2013-04-16','16:50:00',2.7),('8975','2013-04-16','16:55:00',2.52),('8975','2013-04-16','17:00:00',2.38),('8975','2013-04-16','17:05:00',2.24),('8975','2013-04-16','17:10:00',2.13),('8975','2013-04-16','17:15:00',2.01),('8975','2013-04-16','17:20:00',1.92),('8975','2013-04-16','17:25:00',1.83),('8975','2013-04-16','17:30:00',1.73),('8975','2013-04-16','17:35:00',1.64),('8975','2013-04-16','17:40:00',1.57),('8975','2013-04-16','17:45:00',1.5),('8975','2013-04-16','17:50:00',1.44),('8975','2013-04-16','17:55:00',1.39),('8975','2013-04-16','18:00:00',1.34),('8975','2013-04-16','18:05:00',1.28),('8975','2013-04-16','18:10:00',1.24),('8975','2013-04-16','18:15:00',1.18),('8975','2013-04-16','18:20:00',1.12),('8975','2013-04-16','18:25:00',1.06),('8975','2013-04-16','18:30:00',1),('8975','2013-04-15','07:15:00',1.02),('8975','2013-04-15','07:20:00',1.05),('8975','2013-04-15','07:30:00',1.02),('8975','2013-04-15','07:35:00',1.05),('8975','2013-04-15','07:40:00',2),('8975','2013-04-15','07:45:00',2.17),('8975','2013-04-15','07:50:00',2.31),('8975','2013-04-15','07:55:00',2.26),('8975','2013-04-15','08:00:00',2.43),('8975','2013-04-15','08:05:00',2.73),('8975','2013-04-15','08:10:00',2.86),('8975','2013-04-15','08:15:00',2.67),('8975','2013-04-15','08:20:00',1.33),('8975','2013-04-15','08:25:00',1.45),('8975','2013-04-15','08:30:00',1.53),('8975','2013-04-15','08:35:00',1.39),('8975','2013-04-15','08:40:00',1.49),('8975','2013-04-15','08:45:00',1.65),('8975','2013-04-15','08:50:00',1.93),('8975','2013-04-15','08:55:00',2.53),('8975','2013-04-15','09:00:00',2.08),('8975','2013-04-15','09:05:00',1.43),('8975','2013-04-15','09:10:00',1.74),('8975','2013-04-15','09:15:00',4.01),('8975','2013-04-15','09:20:00',3.33),('8975','2013-04-15','09:25:00',2.36),('8975','2013-04-15','09:30:00',3.26),('8975','2013-04-15','09:35:00',3.14),('8975','2013-04-15','09:40:00',2.59),('8975','2013-04-15','09:45:00',2.61),('8975','2013-04-15','09:50:00',2.57),('8975','2013-04-15','09:55:00',2.34),('8975','2013-04-15','10:00:00',2.21),('8975','2013-04-15','10:05:00',2.15),('8975','2013-04-15','10:10:00',2.25),('8975','2013-04-15','10:15:00',2.37),('8975','2013-04-15','10:20:00',2.52),('8975','2013-04-15','10:25:00',2.56),('8975','2013-04-15','10:30:00',2.55),('8975','2013-04-15','10:35:00',2.61),('8975','2013-04-15','10:40:00',2.61),('8975','2013-04-15','10:45:00',2.51),('8975','2013-04-15','10:50:00',2.51),('8975','2013-04-15','10:55:00',2.67),('8975','2013-04-15','11:00:00',2.86),('8975','2013-04-15','11:05:00',2.97),('8975','2013-04-15','11:10:00',2.98),('8975','2013-04-15','11:15:00',3.03),('8975','2013-04-15','11:20:00',3.11),('8975','2013-04-15','11:25:00',3.01),('8975','2013-04-15','11:30:00',3.05),('8975','2013-04-15','11:35:00',2.95),('8975','2013-04-15','11:40:00',2.95),('8975','2013-04-15','11:45:00',3.51),('8975','2013-04-15','11:50:00',3.82),('8975','2013-04-15','11:55:00',3.93),('8975','2013-04-15','12:00:00',4.3),('8975','2013-04-15','12:05:00',4.8),('8975','2013-04-15','12:10:00',5.86),('8975','2013-04-15','12:15:00',4.96),('8975','2013-04-15','12:20:00',4.85),('8975','2013-04-15','12:25:00',5.49),('8975','2013-04-15','12:30:00',3.6),('8975','2013-04-15','12:35:00',4.03),('8975','2013-04-15','12:40:00',4.01),('8975','2013-04-15','12:45:00',5.68),('8975','2013-04-15','12:50:00',5.46),('8975','2013-04-15','12:55:00',5.4),('8975','2013-04-15','13:00:00',6.29),('8975','2013-04-15','13:05:00',6.14),('8975','2013-04-15','13:10:00',5.99),('8975','2013-04-15','13:15:00',5.88),('8975','2013-04-15','13:20:00',5.08),('8975','2013-04-15','13:25:00',5.6),('8975','2013-04-15','13:30:00',5.87),('8975','2013-04-15','13:35:00',5.26),('8975','2013-04-15','13:40:00',4.95),('8975','2013-04-15','13:45:00',5.58),('8975','2013-04-15','13:50:00',5.6),('8975','2013-04-15','13:55:00',5.45),('8975','2013-04-15','14:00:00',5.33),('8975','2013-04-15','14:05:00',4.86),('8975','2013-04-15','14:10:00',4.57),('8975','2013-04-15','14:15:00',4.63),('8975','2013-04-15','14:20:00',5.4),('8975','2013-04-15','14:25:00',5.55),('8975','2013-04-15','14:30:00',4.79),('8975','2013-04-15','14:35:00',4.95),('8975','2013-04-15','14:40:00',3.76),('8975','2013-04-15','14:45:00',5.03),('8975','2013-04-15','14:50:00',5.01),('8975','2013-04-15','14:55:00',4.83),('8975','2013-04-15','15:00:00',4.87),('8975','2013-04-15','15:05:00',4.65),('8975','2013-04-15','15:10:00',4.71),('8975','2013-04-15','15:15:00',4.62),('8975','2013-04-15','15:20:00',4.46),('8975','2013-04-15','15:25:00',3.67),('8975','2013-04-15','15:30:00',3.52),('8975','2013-04-15','15:35:00',3.85),('8975','2013-04-15','15:40:00',3.88),('8975','2013-04-15','15:45:00',3.9),('8975','2013-04-15','15:50:00',3.79),('8975','2013-04-15','15:55:00',3.71),('8975','2013-04-15','16:00:00',3.59),('8975','2013-04-15','16:05:00',3.44),('8975','2013-04-15','16:10:00',3.37),('8975','2013-04-15','16:15:00',3.1),('8975','2013-04-15','16:20:00',3.19),('8975','2013-04-15','16:25:00',3.05),('8975','2013-04-15','16:30:00',3.01),('8975','2013-04-15','16:35:00',2.95),('8975','2013-04-15','16:40:00',3.01),('8975','2013-04-15','16:45:00',3.11),('8975','2013-04-15','16:50:00',3.07),('8975','2013-04-15','16:55:00',2.57),('8975','2013-04-15','17:00:00',2.33),('8975','2013-04-15','17:05:00',2.47),('8975','2013-04-15','17:10:00',2.53),('8975','2013-04-15','17:15:00',2.46),('8975','2013-04-15','17:20:00',2.37),('8975','2013-04-15','17:25:00',2.16),('8975','2013-04-15','17:30:00',2),('8975','2013-04-15','17:35:00',1.93),('8975','2013-04-15','17:40:00',2.2),('8975','2013-04-15','17:45:00',2.03),('8975','2013-04-15','17:50:00',1.83),('8975','2013-04-15','17:55:00',1.55),('8975','2013-04-15','18:00:00',1.13),('8975','2013-04-15','18:05:00',1.16),('8975','2013-04-15','18:10:00',1.11),('8975','2013-04-15','18:15:00',1.09),('8975','2013-04-14','07:05:00',1.36),('8975','2013-04-14','07:10:00',1.52),('8975','2013-04-14','07:15:00',1.75),('8975','2013-04-14','07:20:00',1.77),('8975','2013-04-14','07:25:00',1.86),('8975','2013-04-14','07:30:00',2),('8975','2013-04-14','07:35:00',2.27),('8975','2013-04-14','07:40:00',2.55),('8975','2013-04-14','07:45:00',2.73),('8975','2013-04-14','07:50:00',2.83),('8975','2013-04-14','07:55:00',2.95),('8975','2013-04-14','08:00:00',3.09),('8975','2013-04-14','08:05:00',3.17),('8975','2013-04-14','08:10:00',3.24),('8975','2013-04-14','08:15:00',3.33),('8975','2013-04-14','08:20:00',3.43),('8975','2013-04-14','08:25:00',3.54),('8975','2013-04-14','08:30:00',3.69),('8975','2013-04-14','08:35:00',3.72),('8975','2013-04-14','08:40:00',3.86),('8975','2013-04-14','08:45:00',4.01),('8975','2013-04-14','08:50:00',4.09),('8975','2013-04-14','08:55:00',4.19),('8975','2013-04-14','09:00:00',4.3),('8975','2013-04-14','09:05:00',4.4),('8975','2013-04-14','09:10:00',4.48),('8975','2013-04-14','09:15:00',4.55),('8975','2013-04-14','09:20:00',4.65),('8975','2013-04-14','09:25:00',4.75),('8975','2013-04-14','09:30:00',4.83),('8975','2013-04-14','09:35:00',4.93),('8975','2013-04-14','09:40:00',5),('8975','2013-04-14','09:45:00',5.09),('8975','2013-04-14','09:50:00',5.17),('8975','2013-04-14','09:55:00',5.24),('8975','2013-04-14','10:00:00',5.31),('8975','2013-04-14','10:05:00',5.38),('8975','2013-04-14','10:10:00',5.47),('8975','2013-04-14','10:15:00',5.51),('8975','2013-04-14','10:20:00',5.57),('8975','2013-04-14','10:25:00',5.67),('8975','2013-04-14','10:30:00',5.71),('8975','2013-04-14','10:35:00',5.75),('8975','2013-04-14','10:40:00',5.81),('8975','2013-04-14','10:45:00',5.84),('8975','2013-04-14','10:50:00',5.89),('8975','2013-04-14','10:55:00',5.93),('8975','2013-04-14','11:00:00',6.01),('8975','2013-04-14','11:05:00',6.03),('8975','2013-04-14','11:10:00',6.06),('8975','2013-04-14','11:15:00',6.09),('8975','2013-04-14','11:20:00',6.12),('8975','2013-04-14','11:25:00',6.18),('8975','2013-04-14','11:30:00',6.2),('8975','2013-04-14','11:35:00',6.23),('8975','2013-04-14','11:40:00',6.26),('8975','2013-04-14','11:45:00',6.24),('8975','2013-04-14','11:50:00',6.26),('8975','2013-04-14','11:55:00',6.28),('8975','2013-04-14','12:00:00',6.29),('8975','2013-04-14','12:05:00',6.24),('8975','2013-04-14','12:10:00',6.25),('8975','2013-04-14','12:15:00',6.25),('8975','2013-04-14','12:20:00',6.27),('8975','2013-04-14','12:25:00',6.24),('8975','2013-04-14','12:30:00',6.2),('8975','2013-04-14','12:35:00',6.18),('8975','2013-04-14','12:40:00',6.17),('8975','2013-04-14','12:45:00',6.18),('8975','2013-04-14','12:50:00',6.17),('8975','2013-04-14','12:55:00',6.17),('8975','2013-04-14','13:00:00',6.17),('8975','2013-04-14','13:05:00',6.06),('8975','2013-04-14','13:10:00',6.03),('8975','2013-04-14','13:15:00',6),('8975','2013-04-14','13:20:00',5.96),('8975','2013-04-14','13:25:00',5.96),('8975','2013-04-14','13:30:00',5.95),('8975','2013-04-14','13:35:00',5.91),('8975','2013-04-14','13:40:00',5.83),('8975','2013-04-14','13:45:00',5.84),('8975','2013-04-14','13:50:00',5.83),('8975','2013-04-14','13:55:00',5.76),('8975','2013-04-14','14:00:00',5.77),('8975','2013-04-14','14:05:00',5.74),('8975','2013-04-14','14:10:00',5.7),('8975','2013-04-14','14:15:00',5.63),('8975','2013-04-14','14:20:00',5.57),('8975','2013-04-14','14:25:00',5.5),('8975','2013-04-14','14:30:00',5.42),('8975','2013-04-14','14:35:00',5.34),('8975','2013-04-14','14:40:00',5.27),('8975','2013-04-14','14:45:00',5.19),('8975','2013-04-14','14:50:00',5.08),('8975','2013-04-14','14:55:00',4.97),('8975','2013-04-14','15:00:00',4.89),('8975','2013-04-14','15:05:00',4.82),('8975','2013-04-14','15:10:00',4.72),('8975','2013-04-14','15:15:00',4.64),('8975','2013-04-14','15:20:00',4.53),('8975','2013-04-14','15:25:00',4.21),('8975','2013-04-14','15:30:00',4.05),('8975','2013-04-14','15:35:00',4.15),('8975','2013-04-14','15:40:00',4.04),('8975','2013-04-14','15:45:00',3.95),('8975','2013-04-14','15:50:00',3.84),('8975','2013-04-14','15:55:00',3.72),('8975','2013-04-14','16:00:00',3.58),('8975','2013-04-14','16:05:00',3.46),('8975','2013-04-14','16:10:00',3.36),('8975','2013-04-14','16:15:00',3.27),('8975','2013-04-14','16:20:00',3.15),('8975','2013-04-14','16:25:00',3.04),('8975','2013-04-14','16:30:00',2.94),('8975','2013-04-14','16:35:00',2.83),('8975','2013-04-14','16:40:00',2.72),('8975','2013-04-14','16:45:00',2.62),('8975','2013-04-14','16:50:00',2.51),('8975','2013-04-14','16:55:00',2.39),('8975','2013-04-14','17:00:00',2.28),('8975','2013-04-14','17:05:00',2.18),('8975','2013-04-14','17:10:00',2.07),('8975','2013-04-14','17:15:00',1.96),('8975','2013-04-14','17:20:00',1.66),('8975','2013-04-14','17:25:00',1.45),('8975','2013-04-14','17:30:00',1.43),('8975','2013-04-14','17:35:00',1.4),('8975','2013-04-14','17:40:00',1.16),('8975','2013-04-14','17:45:00',1.2),('8975','2013-04-14','17:50:00',1.17),('8975','2013-04-14','17:55:00',1.37),('8975','2013-04-14','18:00:00',1.21),('8975','2013-04-14','18:05:00',1.14),('8975','2013-04-14','18:10:00',1.06),('8975','2013-04-14','18:15:00',1.17),('8975','2013-04-13','07:15:00',1.21),('8975','2013-04-13','07:20:00',1.34),('8975','2013-04-13','07:25:00',1.53),('8975','2013-04-13','07:30:00',1.69),('8975','2013-04-13','07:35:00',1.84),('8975','2013-04-13','07:40:00',2.16),('8975','2013-04-13','07:45:00',2.35),('8975','2013-04-13','07:50:00',2.52),('8975','2013-04-13','07:55:00',2.69),('8975','2013-04-13','08:00:00',2.81),('8975','2013-04-13','08:05:00',2.73),('8975','2013-04-13','08:10:00',2.97),('8975','2013-04-13','08:15:00',3.14),('8975','2013-04-13','08:20:00',3.27),('8975','2013-04-13','08:25:00',3.38),('8975','2013-04-13','08:30:00',3.48),('8975','2013-04-13','08:35:00',3.57),('8975','2013-04-13','08:40:00',3.65),('8975','2013-04-13','08:45:00',3.75),('8975','2013-04-13','08:50:00',3.87),('8975','2013-04-13','08:55:00',3.98),('8975','2013-04-13','09:00:00',4.07),('8975','2013-04-13','09:05:00',4.16),('8975','2013-04-13','09:10:00',4.23),('8975','2013-04-13','09:15:00',4.33),('8975','2013-04-13','09:20:00',4.45),('8975','2013-04-13','09:25:00',4.55),('8975','2013-04-13','09:30:00',4.65),('8975','2013-04-13','09:35:00',4.72),('8975','2013-04-13','09:40:00',4.79),('8975','2013-04-13','09:45:00',4.89),('8975','2013-04-13','09:50:00',5),('8975','2013-04-13','09:55:00',5.06),('8975','2013-04-13','10:00:00',5.15),('8975','2013-04-13','10:05:00',5.21),('8975','2013-04-13','10:10:00',5.3),('8975','2013-04-13','10:15:00',5.4),('8975','2013-04-13','10:20:00',5.38),('8975','2013-04-13','10:25:00',5.47),('8975','2013-04-13','10:30:00',5.58),('8975','2013-04-13','10:35:00',5.63),('8975','2013-04-13','10:40:00',5.68),('8975','2013-04-13','10:45:00',5.73),('8975','2013-04-13','10:50:00',5.79),('8975','2013-04-13','10:55:00',5.84),('8975','2013-04-13','11:00:00',5.9),('8975','2013-04-13','11:05:00',5.97),('8975','2013-04-13','11:10:00',5.99),('8975','2013-04-13','11:15:00',6.02),('8975','2013-04-13','11:20:00',6.05),('8975','2013-04-13','11:25:00',6.09),('8975','2013-04-13','11:30:00',6.12),('8975','2013-04-13','11:35:00',6.17),('8975','2013-04-13','11:40:00',6.16),('8975','2013-04-13','11:45:00',6.17),('8975','2013-04-13','11:50:00',6.23),('8975','2013-04-13','11:55:00',6.21),('8975','2013-04-13','12:00:00',6.2),('8975','2013-04-13','12:05:00',6.25),('8975','2013-04-13','12:10:00',6.25),('8975','2013-04-13','12:15:00',6.21),('8975','2013-04-13','12:20:00',6.17),('8975','2013-04-13','12:25:00',6.24),('8975','2013-04-13','12:30:00',6.14),('8975','2013-04-13','12:35:00',6.19),('8975','2013-04-13','12:40:00',5.71),('8975','2013-04-13','12:45:00',6.49),('8975','2013-04-13','12:50:00',3.99),('8975','2013-04-13','12:55:00',1.2),('8975','2013-04-13','13:00:00',4.62),('8975','2013-04-13','13:05:00',6.62),('8975','2013-04-13','13:10:00',6.15),('8975','2013-04-13','13:15:00',5.04),('8975','2013-04-13','13:20:00',4.69),('8975','2013-04-13','13:25:00',5.93),('8975','2013-04-13','13:30:00',5.53),('8975','2013-04-13','13:35:00',6.1),('8975','2013-04-13','13:40:00',5.95),('8975','2013-04-13','13:45:00',5.89),('8975','2013-04-13','13:50:00',5.83),('8975','2013-04-13','13:55:00',5.75),('8975','2013-04-13','14:00:00',5.63),('8975','2013-04-13','14:05:00',5.62),('8975','2013-04-13','14:10:00',5.52),('8975','2013-04-13','14:15:00',5.49),('8975','2013-04-13','14:20:00',5.45),('8975','2013-04-13','14:25:00',5.36),('8975','2013-04-13','14:30:00',5.32),('8975','2013-04-13','14:35:00',5.34),('8975','2013-04-13','14:40:00',5.24),('8975','2013-04-13','14:45:00',5.08),('8975','2013-04-13','14:50:00',5),('8975','2013-04-13','14:55:00',4.72),('8975','2013-04-13','15:00:00',4.76),('8975','2013-04-13','15:05:00',4.71),('8975','2013-04-13','15:10:00',4.68),('8975','2013-04-13','15:15:00',4.76),('8975','2013-04-13','15:20:00',4.05),('8975','2013-04-13','15:25:00',3.38),('8975','2013-04-13','15:30:00',4.3),('8975','2013-04-13','15:35:00',4.05),('8975','2013-04-13','15:40:00',4.21),('8975','2013-04-13','15:45:00',4.19),('8975','2013-04-13','15:50:00',4.13),('8975','2013-04-13','15:55:00',3.17),('8975','2013-04-13','16:00:00',3.55),('8975','2013-04-13','16:05:00',3.38),('8975','2013-04-13','16:10:00',3.27),('8975','2013-04-13','16:15:00',3.17),('8975','2013-04-13','16:20:00',3.12),('8975','2013-04-13','16:25:00',2.97),('8975','2013-04-13','16:30:00',2.9),('8975','2013-04-13','16:35:00',2.82),('8975','2013-04-13','16:40:00',2.67),('8975','2013-04-13','16:45:00',2.54),('8975','2013-04-13','16:50:00',2.47),('8975','2013-04-13','16:55:00',2.36),('8975','2013-04-13','17:00:00',2.25),('8975','2013-04-13','17:05:00',2.14),('8975','2013-04-13','17:10:00',2.06),('8975','2013-04-13','17:15:00',1.97),('8975','2013-04-13','17:20:00',1.85),('8975','2013-04-13','17:25:00',1.76),('8975','2013-04-13','17:30:00',1.68),('8975','2013-04-13','17:35:00',1.59),('8975','2013-04-13','17:40:00',1.52),('8975','2013-04-13','17:45:00',1.45),('8975','2013-04-13','17:50:00',1.39),('8975','2013-04-13','17:55:00',1.33),('8975','2013-04-13','18:00:00',1.28),('8975','2013-04-13','18:05:00',1.24),('8975','2013-04-13','18:10:00',1.21),('8975','2013-04-13','18:15:00',1.16),('8975','2013-04-13','18:20:00',1.09),('8975','2013-04-13','18:25:00',1.02),('8975','2013-04-12','07:15:00',1.01),('8975','2013-04-12','07:20:00',1.07),('8975','2013-04-12','07:25:00',1.39),('8975','2013-04-12','07:30:00',1.61),('8975','2013-04-12','07:35:00',1.83),('8975','2013-04-12','07:40:00',1.87),('8975','2013-04-12','07:45:00',2.25),('8975','2013-04-12','07:50:00',2.42),('8975','2013-04-12','07:55:00',2.5),('8975','2013-04-12','08:00:00',2.56),('8975','2013-04-12','08:05:00',2.82),('8975','2013-04-12','08:10:00',2.87),('8975','2013-04-12','08:15:00',3.1),('8975','2013-04-12','08:20:00',3.44),('8975','2013-04-12','08:25:00',1.96),('8975','2013-04-12','08:35:00',1.06),('8975','2013-04-12','08:40:00',1.12),('8975','2013-04-12','08:45:00',1.07),('8975','2013-04-12','08:50:00',1.34),('8975','2013-04-12','08:55:00',1.6),('8975','2013-04-12','09:00:00',1.66),('8975','2013-04-12','09:05:00',1.61),('8975','2013-04-12','09:10:00',1.68),('8975','2013-04-12','09:15:00',2.2),('8975','2013-04-12','09:20:00',1.9),('8975','2013-04-12','09:25:00',3.98),('8975','2013-04-12','09:30:00',4.81),('8975','2013-04-12','09:35:00',4.9),('8975','2013-04-12','09:40:00',4.24),('8975','2013-04-12','09:45:00',4.97),('8975','2013-04-12','09:50:00',5.04),('8975','2013-04-12','09:55:00',5.11),('8975','2013-04-12','10:00:00',5.16),('8975','2013-04-12','10:05:00',5.35),('8975','2013-04-12','10:10:00',5.03),('8975','2013-04-12','10:15:00',3.69),('8975','2013-04-12','10:20:00',2.98),('8975','2013-04-12','10:25:00',2.82),('8975','2013-04-12','10:30:00',5.21),('8975','2013-04-12','10:35:00',5.77),('8975','2013-04-12','10:40:00',2.53),('8975','2013-04-12','10:45:00',4.68),('8975','2013-04-12','10:50:00',1.92),('8975','2013-04-12','10:55:00',1.37),('8975','2013-04-12','11:00:00',4.14),('8975','2013-04-12','11:05:00',5.24),('8975','2013-04-12','11:10:00',5.81),('8975','2013-04-12','11:15:00',4.96),('8975','2013-04-12','11:20:00',5.23),('8975','2013-04-12','11:25:00',1.92),('8975','2013-04-12','11:30:00',1.47),('8975','2013-04-12','11:35:00',2.05),('8975','2013-04-12','11:40:00',6.62),('8975','2013-04-12','11:45:00',5.42),('8975','2013-04-12','11:50:00',3.77),('8975','2013-04-12','11:55:00',6.24),('8975','2013-04-12','12:00:00',6.12),('8975','2013-04-12','12:05:00',6.49),('8975','2013-04-12','12:10:00',6.26),('8975','2013-04-12','12:15:00',4.17),('8975','2013-04-12','12:20:00',6.95),('8975','2013-04-12','12:25:00',6.77),('8975','2013-04-12','12:30:00',4.3),('8975','2013-04-12','12:35:00',6.66),('8975','2013-04-12','12:40:00',6.57),('8975','2013-04-12','12:45:00',6.43),('8975','2013-04-12','12:50:00',6.33),('8975','2013-04-12','12:55:00',6.3),('8975','2013-04-12','13:00:00',4.22),('8975','2013-04-12','13:05:00',5.47),('8975','2013-04-12','13:10:00',6.69),('8975','2013-04-12','13:15:00',6.3),('8975','2013-04-12','13:20:00',5.17),('8975','2013-04-12','13:25:00',5.59),('8975','2013-04-12','13:30:00',3.39),('8975','2013-04-12','13:35:00',4.1),('8975','2013-04-12','13:40:00',4.1),('8975','2013-04-12','13:45:00',2.74),('8975','2013-04-12','13:50:00',3.21),('8975','2013-04-12','13:55:00',2.69),('8975','2013-04-12','14:00:00',2.48),('8975','2013-04-12','14:05:00',2.39),('8975','2013-04-12','14:10:00',2.8),('8975','2013-04-12','14:15:00',4.06),('8975','2013-04-12','14:20:00',4.31),('8975','2013-04-12','14:25:00',4.21),('8975','2013-04-12','14:30:00',5.06),('8975','2013-04-12','14:35:00',5.25),('8975','2013-04-12','14:40:00',5.17),('8975','2013-04-12','14:45:00',5.03),('8975','2013-04-12','14:50:00',4.9),('8975','2013-04-12','14:55:00',4.89),('8975','2013-04-12','15:00:00',4.53),('8975','2013-04-12','15:05:00',4.06),('8975','2013-04-12','15:10:00',4.15),('8975','2013-04-12','15:15:00',3.95),('8975','2013-04-12','15:20:00',3.97),('8975','2013-04-12','15:25:00',3.65),('8975','2013-04-12','15:30:00',3.61),('8975','2013-04-12','15:35:00',3.53),('8975','2013-04-12','15:40:00',3.55),('8975','2013-04-12','15:45:00',3.58),('8975','2013-04-12','15:50:00',3.53),('8975','2013-04-12','15:55:00',3.45),('8975','2013-04-12','16:00:00',3.27),('8975','2013-04-12','16:05:00',3.13),('8975','2013-04-12','16:10:00',3.1),('8975','2013-04-12','16:15:00',3.09),('8975','2013-04-12','16:20:00',3),('8975','2013-04-12','16:25:00',2.88),('8975','2013-04-12','16:30:00',2.65),('8975','2013-04-12','16:35:00',2.6),('8975','2013-04-12','16:40:00',2.4),('8975','2013-04-12','16:45:00',2.27),('8975','2013-04-12','16:50:00',2.24),('8975','2013-04-12','16:55:00',2),('8975','2013-04-12','17:00:00',1.77),('8975','2013-04-12','17:05:00',1.63),('8975','2013-04-12','17:10:00',1.77),('8975','2013-04-12','17:15:00',2.21),('8975','2013-04-12','17:20:00',1.88),('8975','2013-04-12','17:25:00',1.98),('8975','2013-04-12','17:30:00',1.79),('8975','2013-04-12','17:35:00',1.7),('8975','2013-04-12','17:40:00',1.63),('8975','2013-04-12','17:45:00',1.51),('8975','2013-04-12','17:50:00',1.4),('8975','2013-04-12','17:55:00',1.47),('8975','2013-04-12','18:00:00',1.22),('8975','2013-04-12','18:05:00',1.24),('8975','2013-04-12','18:10:00',1.13),('8975','2013-04-12','18:15:00',1.19),('8975','2013-04-12','18:20:00',1.17),('8975','2013-04-12','18:25:00',1.09),('8975','2013-04-12','18:30:00',1.04),('8975','2013-04-11','07:50:00',2.08),('8975','2013-04-11','07:55:00',2.24),('8975','2013-04-11','08:00:00',1.93),('8975','2013-04-11','08:05:00',1.92),('8975','2013-04-11','08:10:00',2.83),('8975','2013-04-11','08:15:00',1.63),('8975','2013-04-11','08:20:00',2.54),('8975','2013-04-11','08:25:00',3.07),('8975','2013-04-11','08:30:00',2.38),('8975','2013-04-11','08:35:00',2.84),('8975','2013-04-11','08:40:00',2.46),('8975','2013-04-11','08:45:00',2.76),('8975','2013-04-11','08:50:00',2.49),('8975','2013-04-11','08:55:00',2.49),('8975','2013-04-11','09:00:00',1.89),('8975','2013-04-11','09:05:00',1.34),('8975','2013-04-11','09:10:00',1.64),('8975','2013-04-11','09:15:00',2.05),('8975','2013-04-11','09:20:00',2.31),('8975','2013-04-11','09:25:00',2.12),('8975','2013-04-11','09:30:00',1.7),('8975','2013-04-11','09:35:00',1.38),('8975','2013-04-11','09:40:00',1.42),('8975','2013-04-11','09:45:00',1.34),('8975','2013-04-11','09:50:00',1.52),('8975','2013-04-11','09:55:00',1.78),('8975','2013-04-11','10:00:00',1.97),('8975','2013-04-11','10:05:00',1.67),('8975','2013-04-11','10:10:00',3),('8975','2013-04-11','10:15:00',4.67),('8975','2013-04-11','10:20:00',2.73),('8975','2013-04-11','10:25:00',2.68),('8975','2013-04-11','10:30:00',3.24),('8975','2013-04-11','10:35:00',5.19),('8975','2013-04-11','10:40:00',6.78),('8975','2013-04-11','10:45:00',7.31),('8975','2013-04-11','10:50:00',7.38),('8975','2013-04-11','10:55:00',5.48),('8975','2013-04-11','11:00:00',2.75),('8975','2013-04-11','11:05:00',4.96),('8975','2013-04-11','11:10:00',6.75),('8975','2013-04-11','11:15:00',6.04),('8975','2013-04-11','11:20:00',6.25),('8975','2013-04-11','11:25:00',2.72),('8975','2013-04-11','11:30:00',5.98),('8975','2013-04-11','11:35:00',2.83),('8975','2013-04-11','11:40:00',4.61),('8975','2013-04-11','11:45:00',6.79),('8975','2013-04-11','11:50:00',6.61),('8975','2013-04-11','11:55:00',6.82),('8975','2013-04-11','12:00:00',6.17),('8975','2013-04-11','12:05:00',6.21),('8975','2013-04-11','12:10:00',6.57),('8975','2013-04-11','12:15:00',6.44),('8975','2013-04-11','12:20:00',6.52),('8975','2013-04-11','12:25:00',6.5),('8975','2013-04-11','12:30:00',6.45),('8975','2013-04-11','12:35:00',6.43),('8975','2013-04-11','12:40:00',6.21),('8975','2013-04-11','12:45:00',6.05),('8975','2013-04-11','12:50:00',6.16),('8975','2013-04-11','12:55:00',5.88),('8975','2013-04-11','13:00:00',6.29),('8975','2013-04-11','13:05:00',6.33),('8975','2013-04-11','13:10:00',6.28),('8975','2013-04-11','13:15:00',6.24),('8975','2013-04-11','13:20:00',6.27),('8975','2013-04-11','13:25:00',6.19),('8975','2013-04-11','13:30:00',6.09),('8975','2013-04-11','13:35:00',6.17),('8975','2013-04-11','13:40:00',6.07),('8975','2013-04-11','13:45:00',5.98),('8975','2013-04-11','13:50:00',5.9),('8975','2013-04-11','13:55:00',5.9),('8975','2013-04-11','14:00:00',5.83),('8975','2013-04-11','14:05:00',5.77),('8975','2013-04-11','14:10:00',5.73),('8975','2013-04-11','14:15:00',5.67),('8975','2013-04-11','14:20:00',5.59),('8975','2013-04-11','14:25:00',5.48),('8975','2013-04-11','14:30:00',5.37),('8975','2013-04-11','14:35:00',5.29),('8975','2013-04-11','14:40:00',5.19),('8975','2013-04-11','14:45:00',5.14),('8975','2013-04-11','14:50:00',5.03),('8975','2013-04-11','14:55:00',4.93),('8975','2013-04-11','15:00:00',4.85),('8975','2013-04-11','15:05:00',4.74),('8975','2013-04-11','15:10:00',4.66),('8975','2013-04-11','15:15:00',4.53),('8975','2013-04-11','15:20:00',4.26),('8975','2013-04-11','15:25:00',4.08),('8975','2013-04-11','15:30:00',4.1),('8975','2013-04-11','15:35:00',4.06),('8975','2013-04-11','15:40:00',3.97),('8975','2013-04-11','15:45:00',3.86),('8975','2013-04-11','15:50:00',3.76),('8975','2013-04-11','15:55:00',3.62),('8975','2013-04-11','16:00:00',3.5),('8975','2013-04-11','16:05:00',3.39),('8975','2013-04-11','16:10:00',3.32),('8975','2013-04-11','16:15:00',3.04),('8975','2013-04-11','16:20:00',3.1),('8975','2013-04-11','16:25:00',2.99),('8975','2013-04-11','16:30:00',2.07),('8975','2013-04-11','16:35:00',1.35),('8975','2013-04-11','16:40:00',2.37),('8975','2013-04-11','16:45:00',2.73),('8975','2013-04-11','16:50:00',2.51),('8975','2013-04-11','16:55:00',2.37),('8975','2013-04-11','17:00:00',2.28),('8975','2013-04-11','17:05:00',2.17),('8975','2013-04-11','17:10:00',2.05),('8975','2013-04-11','17:15:00',1.95),('8975','2013-04-11','17:20:00',1.87),('8975','2013-04-11','17:25:00',1.79),('8975','2013-04-11','17:30:00',1.71),('8975','2013-04-11','17:35:00',1.64),('8975','2013-04-11','17:40:00',1.57),('8975','2013-04-11','17:45:00',1.48),('8975','2013-04-11','17:50:00',1.43),('8975','2013-04-11','17:55:00',1.37),('8975','2013-04-11','18:00:00',1.31),('8975','2013-04-11','18:05:00',1.25),('8975','2013-04-11','18:10:00',1.2),('8975','2013-04-11','18:15:00',1.13),('8975','2013-04-11','18:20:00',1.05),('8975','2014-03-27','06:50:00',1.11),('8975','2014-03-27','06:55:00',1.58),('8975','2014-03-27','07:00:00',1.86),('8975','2014-03-27','07:05:00',2.38),('8975','2014-03-27','07:10:00',2.72),('8975','2014-03-27','07:15:00',2.94),('8975','2014-03-27','07:20:00',2.93),('8975','2014-03-27','07:25:00',2.85),('8975','2014-03-27','07:30:00',3.02),('8975','2014-03-27','07:35:00',3.21),('8975','2014-03-27','07:40:00',3.22),('8975','2014-03-27','07:45:00',3.48),('8975','2014-03-27','07:50:00',3.65),('8975','2014-03-27','07:55:00',3.71),('8975','2014-03-27','08:00:00',3.77),('8975','2014-03-27','08:05:00',3.87),('8975','2014-03-27','08:10:00',4),('8975','2014-03-27','08:15:00',4.12),('8975','2014-03-27','08:20:00',4.25),('8975','2014-03-27','08:25:00',4.33),('8975','2014-03-27','08:30:00',4.39),('8975','2014-03-27','08:35:00',4.47),('8975','2014-03-27','08:40:00',4.59),('8975','2014-03-27','08:45:00',4.63),('8975','2014-03-27','08:50:00',4.74),('8975','2014-03-27','08:55:00',4.87),('8975','2014-03-27','09:00:00',4.99),('8975','2014-03-27','09:05:00',5.15),('8975','2014-03-27','09:10:00',5.33),('8975','2014-03-27','09:15:00',5.51),('8975','2014-03-27','09:20:00',5.33),('8975','2014-03-27','09:25:00',5.39),('8975','2014-03-27','09:30:00',5.63),('8975','2014-03-27','09:35:00',5.93),('8975','2014-03-27','09:40:00',5.31),('8975','2014-03-27','09:45:00',3.94),('8975','2014-03-27','09:50:00',3.34),('8975','2014-03-27','09:55:00',5.91),('8975','2014-03-27','10:00:00',5.75),('8975','2014-03-27','10:05:00',5.88),('8975','2014-03-27','10:10:00',6.13),('8975','2014-03-27','10:15:00',5.95),('8975','2014-03-27','10:20:00',4.28),('8975','2014-03-27','10:25:00',5.25),('8975','2014-03-27','10:30:00',5.39),('8975','2014-03-27','10:35:00',5.83),('8975','2014-03-27','10:40:00',5.44),('8975','2014-03-27','10:45:00',5.25),('8975','2014-03-27','10:50:00',6.3),('8975','2014-03-27','10:55:00',6.28),('8975','2014-03-27','11:00:00',6.19),('8975','2014-03-27','11:05:00',6.19),('8975','2014-03-27','11:10:00',6.35),('8975','2014-03-27','11:15:00',5.6),('8975','2014-03-27','11:20:00',3.36),('8975','2014-03-27','11:25:00',1.25),('8975','2014-03-27','11:30:00',3.17),('8975','2014-03-27','11:35:00',2.92),('8975','2014-03-27','11:40:00',5.37),('8975','2014-03-27','11:45:00',3.21),('8975','2014-03-27','11:50:00',1.84),('8975','2014-03-27','11:55:00',2),('8975','2014-03-27','12:00:00',2.22),('8975','2014-03-27','12:05:00',3.59),('8975','2014-03-27','12:10:00',6.7),('8975','2014-03-27','12:15:00',6.73),('8975','2014-03-27','12:20:00',6.72),('8975','2014-03-27','12:25:00',7.17),('8975','2014-03-27','12:30:00',3.09),('8975','2014-03-27','12:35:00',1.59),('8975','2014-03-27','12:40:00',4.36),('8975','2014-03-27','12:45:00',3.89),('8975','2014-03-27','12:50:00',5.05),('8975','2014-03-27','12:55:00',5.46),('8975','2014-03-27','13:00:00',4.91),('8975','2014-03-27','13:05:00',3.66),('8975','2014-03-27','13:10:00',7.06),('8975','2014-03-27','13:15:00',5.74),('8975','2014-03-27','13:20:00',5.33),('8975','2014-03-27','13:25:00',5.2),('8975','2014-03-27','13:30:00',2.75),('8975','2014-03-27','13:35:00',4.69),('8975','2014-03-27','13:40:00',5.2),('8975','2014-03-27','13:45:00',5.24),('8975','2014-03-27','13:50:00',5.1),('8975','2014-03-27','13:55:00',5),('8975','2014-03-27','14:00:00',4.77),('8975','2014-03-27','14:05:00',4.63),('8975','2014-03-27','14:10:00',4.45),('8975','2014-03-27','14:15:00',4.32),('8975','2014-03-27','14:20:00',4.17),('8975','2014-03-27','14:25:00',4.12),('8975','2014-03-27','14:30:00',4.02),('8975','2014-03-27','14:35:00',3.93),('8975','2014-03-27','14:40:00',3.83),('8975','2014-03-27','14:45:00',3.6),('8975','2014-03-27','14:50:00',3.48),('8975','2014-03-27','14:55:00',3.46),('8975','2014-03-27','15:00:00',3.38),('8975','2014-03-27','15:05:00',3.27),('8975','2014-03-27','15:10:00',3.16),('8975','2014-03-27','15:15:00',3.04),('8975','2014-03-27','15:20:00',2.88),('8975','2014-03-27','15:25:00',2.8),('8975','2014-03-27','15:30:00',2.69),('8975','2014-03-27','15:35:00',2.58),('8975','2014-03-27','15:40:00',2.46),('8975','2014-03-27','15:45:00',2.37),('8975','2014-03-27','15:50:00',2.3),('8975','2014-03-27','15:55:00',2.2),('8975','2014-03-27','16:00:00',2.18),('8975','2014-03-27','16:05:00',2.25),('8975','2014-03-27','16:10:00',2.18),('8975','2014-03-27','16:15:00',2.14),('8975','2014-03-27','16:20:00',1.9),('8975','2014-03-27','16:25:00',1.65),('8975','2014-03-27','16:30:00',1.62),('8975','2014-03-27','16:35:00',1.49),('8975','2014-03-27','16:50:00',1.39),('8975','2014-03-27','16:55:00',1.01),('8975','2014-03-27','17:05:00',1.21),('8975','2014-03-27','17:10:00',1.16),('8975','2014-03-27','17:15:00',1.18),('8975','2014-03-27','17:20:00',1.33),('8975','2014-03-27','17:25:00',1.26),('8975','2013-04-10','07:10:00',1.03),('8975','2013-04-10','07:15:00',1.2),('8975','2013-04-10','07:20:00',1.38),('8975','2013-04-10','07:25:00',1.57),('8975','2013-04-10','07:30:00',1.84),('8975','2013-04-10','07:35:00',1.89),('8975','2013-04-10','07:40:00',2.04),('8975','2013-04-10','07:45:00',2.39),('8975','2013-04-10','07:50:00',2.59),('8975','2013-04-10','07:55:00',2.73),('8975','2013-04-10','08:00:00',2.87),('8975','2013-04-10','08:05:00',2.96),('8975','2013-04-10','08:10:00',3.03),('8975','2013-04-10','08:15:00',3.16),('8975','2013-04-10','08:20:00',3.26),('8975','2013-04-10','08:25:00',3.39),('8975','2013-04-10','08:30:00',3.48),('8975','2013-04-10','08:35:00',3.55),('8975','2013-04-10','08:40:00',3.66),('8975','2013-04-10','08:45:00',3.77),('8975','2013-04-10','08:50:00',3.83),('8975','2013-04-10','08:55:00',3.97),('8975','2013-04-10','09:00:00',4.06),('8975','2013-04-10','09:05:00',4.19),('8975','2013-04-10','09:10:00',4.2),('8975','2013-04-10','09:15:00',4.18),('8975','2013-04-10','09:20:00',4.35),('8975','2013-04-10','09:25:00',4.45),('8975','2013-04-10','09:30:00',4.6),('8975','2013-04-10','09:35:00',4.84),('8975','2013-04-10','09:40:00',5.13),('8975','2013-04-10','09:45:00',3.98),('8975','2013-04-10','09:50:00',4.43),('8975','2013-04-10','09:55:00',5.1),('8975','2013-04-10','10:00:00',5.38),('8975','2013-04-10','10:05:00',5),('8975','2013-04-10','10:10:00',5.36),('8975','2013-04-10','10:15:00',3.02),('8975','2013-04-10','10:20:00',3.69),('8975','2013-04-10','10:25:00',4.65),('8975','2013-04-10','10:30:00',4.26),('8975','2013-04-10','10:35:00',6.16),('8975','2013-04-10','10:40:00',6.16),('8975','2013-04-10','10:45:00',6.25),('8975','2013-04-10','10:50:00',6.71),('8975','2013-04-10','10:55:00',6.86),('8975','2013-04-10','11:00:00',6.69),('8975','2013-04-10','11:05:00',5.83),('8975','2013-04-10','11:10:00',6.13),('8975','2013-04-10','11:15:00',6.04),('8975','2013-04-10','11:20:00',4.54),('8975','2013-04-10','11:25:00',5.78),('8975','2013-04-10','11:30:00',2.97),('8975','2013-04-10','11:35:00',6.18),('8975','2013-04-10','11:40:00',3.94),('8975','2013-04-10','11:45:00',7.35),('8975','2013-04-10','11:50:00',7.06),('8975','2013-04-10','11:55:00',3.56),('8975','2013-04-10','12:00:00',6.98),('8975','2013-04-10','12:05:00',3.08),('8975','2013-04-10','12:10:00',4.47),('8975','2013-04-10','12:15:00',3.35),('8975','2013-04-10','12:20:00',7.19),('8975','2013-04-10','12:25:00',7.04),('8975','2013-04-10','12:30:00',6.79),('8975','2013-04-10','12:35:00',6.66),('8975','2013-04-10','12:40:00',7.06),('8975','2013-04-10','12:45:00',5.4),('8975','2013-04-10','12:50:00',6.74),('8975','2013-04-10','12:55:00',6.72),('8975','2013-04-10','13:00:00',6.42),('8975','2013-04-10','13:05:00',5.32),('8975','2013-04-10','13:10:00',5.94),('8975','2013-04-10','13:15:00',5.84),('8975','2013-04-10','13:20:00',5.32),('8975','2013-04-10','13:25:00',5.78),('8975','2013-04-10','13:30:00',5.64),('8975','2013-04-10','13:35:00',5.96),('8975','2013-04-10','13:40:00',5.45),('8975','2013-04-10','13:45:00',5.65),('8975','2013-04-10','13:50:00',5.96),('8975','2013-04-10','13:55:00',5.95),('8975','2013-04-10','14:00:00',4.95),('8975','2013-04-10','14:05:00',5.1),('8975','2013-04-10','14:10:00',5.91),('8975','2013-04-10','14:15:00',5.86),('8975','2013-04-10','14:20:00',5.63),('8975','2013-04-10','14:25:00',5.75),('8975','2013-04-10','14:30:00',5.7),('8975','2013-04-10','14:35:00',5.22),('8975','2013-04-10','14:40:00',5.19),('8975','2013-04-10','14:45:00',5.48),('8975','2013-04-10','14:50:00',5.3),('8975','2013-04-10','14:55:00',4.47),('8975','2013-04-10','15:00:00',4.84),('8975','2013-04-10','15:05:00',4.85),('8975','2013-04-10','15:10:00',4.73),('8975','2013-04-10','15:15:00',4.58),('8975','2013-04-10','15:20:00',4.3),('8975','2013-04-10','15:25:00',4.14),('8975','2013-04-10','15:30:00',4.25),('8975','2013-04-10','15:35:00',4.15),('8975','2013-04-10','15:40:00',4),('8975','2013-04-10','15:45:00',3.9),('8975','2013-04-10','15:50:00',3.79),('8975','2013-04-10','15:55:00',3.63),('8975','2013-04-10','16:00:00',3.48),('8975','2013-04-10','16:05:00',3.4),('8975','2013-04-10','16:10:00',3.31),('8975','2013-04-10','16:15:00',3.17),('8975','2013-04-10','16:20:00',3.08),('8975','2013-04-10','16:25:00',2.97),('8975','2013-04-10','16:30:00',2.87),('8975','2013-04-10','16:35:00',2.77),('8975','2013-04-10','16:40:00',2.69),('8975','2013-04-10','16:45:00',2.56),('8975','2013-04-10','16:50:00',2.46),('8975','2013-04-10','16:55:00',2.35),('8975','2013-04-10','17:00:00',2.22),('8975','2013-04-10','17:05:00',2.15),('8975','2013-04-10','17:10:00',2.05),('8975','2013-04-10','17:15:00',1.95),('8975','2013-04-10','17:20:00',1.86),('8975','2013-04-10','17:25:00',1.77),('8975','2013-04-10','17:30:00',1.69),('8975','2013-04-10','17:35:00',1.62),('8975','2013-04-10','17:40:00',1.55),('8975','2013-04-10','17:45:00',1.48),('8975','2013-04-10','17:50:00',1.44),('8975','2013-04-10','17:55:00',1.35),('8975','2013-04-10','18:00:00',1.26),('8975','2013-04-10','18:05:00',1.2),('8975','2013-04-10','18:10:00',1.05),('8975','2013-04-10','18:15:00',1.13),('8975','2013-04-10','18:20:00',1.12),('8975','2013-04-10','18:25:00',1.09),('8975','2013-04-10','18:30:00',1),('8975','2013-04-09','08:50:00',2.23),('8975','2013-04-09','08:55:00',4.06),('8975','2013-04-09','09:00:00',4.34),('8975','2013-04-09','09:05:00',4.69),('8975','2013-04-09','09:10:00',5.04),('8975','2013-04-09','09:15:00',4.92),('8975','2013-04-09','09:20:00',4.78),('8975','2013-04-09','09:25:00',4.78),('8975','2013-04-09','09:30:00',4.77),('8975','2013-04-09','09:35:00',4.89),('8975','2013-04-09','09:40:00',4.63),('8975','2013-04-09','09:45:00',4.87),('8975','2013-04-09','09:50:00',4.86),('8975','2013-04-09','09:55:00',5.4),('8975','2013-04-09','10:00:00',5.57),('8975','2013-04-09','10:05:00',5.83),('8975','2013-04-09','10:10:00',5.1),('8975','2013-04-09','10:15:00',4.99),('8975','2013-04-09','10:20:00',6.34),('8975','2013-04-09','10:25:00',6.24),('8975','2013-04-09','10:30:00',5.91),('8975','2013-04-09','10:35:00',6.15),('8975','2013-04-09','10:40:00',6.1),('8975','2013-04-09','10:45:00',6.24),('8975','2013-04-09','10:50:00',6.12),('8975','2013-04-09','10:55:00',6.09),('8975','2013-04-09','11:00:00',5.96),('8975','2013-04-09','11:05:00',5.77),('8975','2013-04-09','11:10:00',5.94),('8975','2013-04-09','11:15:00',5.97),('8975','2013-04-09','11:20:00',6.15),('8975','2013-04-09','11:25:00',6.28),('8975','2013-04-09','11:30:00',6.41),('8975','2013-04-09','11:35:00',6.48),('8975','2013-04-09','11:40:00',6.46),('8975','2013-04-09','11:45:00',6.47),('8975','2013-04-09','11:50:00',6.49),('8975','2013-04-09','11:55:00',6.55),('8975','2013-04-09','12:00:00',6.59),('8975','2013-04-09','12:05:00',6.72),('8975','2013-04-09','12:10:00',6.67),('8975','2013-04-09','12:15:00',6.65),('8975','2013-04-09','12:20:00',6.59),('8975','2013-04-09','12:25:00',6.59),('8975','2013-04-09','12:30:00',6.75),('8975','2013-04-09','12:35:00',6.8),('8975','2013-04-09','12:40:00',6.57),('8975','2013-04-09','12:45:00',6.6),('8975','2013-04-09','12:50:00',5.95),('8975','2013-04-09','12:55:00',5.62),('8975','2013-04-09','13:00:00',7.11),('8975','2013-04-09','13:05:00',3.14),('8975','2013-04-09','13:10:00',3.4),('8975','2013-04-09','13:15:00',4.71),('8975','2013-04-09','13:20:00',2.71),('8975','2013-04-09','13:25:00',5.05),('8975','2013-04-09','13:30:00',4.12),('8975','2013-04-09','13:35:00',3.3),('8975','2013-04-09','13:40:00',5.38),('8975','2013-04-09','13:45:00',6.78),('8975','2013-04-09','13:50:00',2.8),('8975','2013-04-09','13:55:00',6.23),('8975','2013-04-09','14:00:00',4.83),('8975','2013-04-09','14:05:00',5.1),('8975','2013-04-09','14:10:00',6.13),('8975','2013-04-09','14:15:00',5.97),('8975','2013-04-09','14:20:00',5.97),('8975','2013-04-09','14:25:00',6),('8975','2013-04-09','14:30:00',4.59),('8975','2013-04-09','14:35:00',5.54),('8975','2013-04-09','14:40:00',4.48),('8975','2013-04-09','14:45:00',4.06),('8975','2013-04-09','14:50:00',4.63),('8975','2013-04-09','14:55:00',3.18),('8975','2013-04-09','15:00:00',5.53),('8975','2013-04-09','15:05:00',2.96),('8975','2013-04-09','15:10:00',4.45),('8975','2013-04-09','15:15:00',3.42),('8975','2013-04-09','15:20:00',4.54),('8975','2013-04-09','15:25:00',4.45),('8975','2013-04-09','15:30:00',4.19),('8975','2013-04-09','15:35:00',4.27),('8975','2013-04-09','15:40:00',4.05),('8975','2013-04-09','15:45:00',4),('8975','2013-04-09','15:50:00',3.94),('8975','2013-04-09','15:55:00',3.99),('8975','2013-04-09','16:00:00',3.35),('8975','2013-04-09','16:05:00',3.63),('8975','2013-04-09','16:10:00',3.19),('8975','2013-04-09','16:15:00',3.2),('8975','2013-04-09','16:20:00',3.24),('8975','2013-04-09','16:25:00',2.71),('8975','2013-04-09','16:30:00',3.23),('8975','2013-04-09','16:35:00',3.2),('8975','2013-04-09','16:40:00',2.98),('8975','2013-04-09','16:45:00',2.57),('8975','2013-04-09','16:50:00',2.74),('8975','2013-04-09','16:55:00',1.97),('8975','2013-04-09','17:00:00',2.38),('8975','2013-04-09','17:05:00',1.16),('8975','2013-04-09','17:10:00',1.77),('8975','2013-04-09','17:15:00',2.25),('8975','2013-04-09','17:20:00',2.07),('8975','2013-04-09','17:25:00',1.99),('8975','2013-04-09','17:30:00',1.87),('8975','2013-04-09','17:35:00',1.74),('8975','2013-04-09','17:40:00',1.71),('8975','2013-04-09','17:45:00',1.69),('8975','2013-04-09','17:50:00',1.62),('8975','2013-04-09','17:55:00',1.52),('8975','2013-04-09','18:00:00',1.29),('8975','2013-04-09','18:05:00',1.03),('8975','2013-04-09','18:10:00',1.22),('8975','2013-04-09','18:15:00',1.15),('8975','2013-04-08','07:20:00',1.12),('8975','2013-04-08','07:25:00',1.35),('8975','2013-04-08','07:30:00',1.53),('8975','2013-04-08','07:35:00',1.83),('8975','2013-04-08','07:40:00',2.02),('8975','2013-04-08','07:45:00',1.9),('8975','2013-04-08','07:50:00',2.17),('8975','2013-04-08','07:55:00',2.72),('8975','2013-04-08','08:00:00',2.96),('8975','2013-04-08','08:05:00',1.66),('8975','2013-04-08','08:10:00',2.26),('8975','2013-04-08','08:15:00',1.15),('8975','2013-04-08','08:20:00',3.51),('8975','2013-04-08','08:25:00',3.21),('8975','2013-04-08','08:30:00',2.64),('8975','2013-04-08','08:35:00',2.2),('8975','2013-04-08','08:40:00',1.04),('8975','2013-04-08','08:55:00',1.05),('8975','2013-04-08','09:00:00',1.67),('8975','2013-04-08','09:05:00',2.76),('8975','2013-04-08','09:10:00',1.87),('8975','2013-04-08','09:15:00',2.5),('8975','2013-04-08','09:20:00',2.24),('8975','2013-04-08','09:25:00',2.06),('8975','2013-04-08','09:30:00',3.28),('8975','2013-04-08','09:35:00',5.42),('8975','2013-04-08','09:40:00',3.55),('8975','2013-04-08','09:45:00',2.6),('8975','2013-04-08','09:50:00',4.49),('8975','2013-04-08','09:55:00',2.33),('8975','2013-04-08','10:00:00',5.03),('8975','2013-04-08','10:05:00',3.36),('8975','2013-04-08','10:10:00',4.18),('8975','2013-04-08','10:15:00',4.01),('8975','2013-04-08','10:20:00',2.01),('8975','2013-04-08','10:25:00',4.4),('8975','2013-04-08','10:30:00',4.12),('8975','2013-04-08','10:35:00',4.73),('8975','2013-04-08','10:40:00',4.71),('8975','2013-04-08','10:45:00',6.36),('8975','2013-04-08','10:50:00',6.54),('8975','2013-04-08','10:55:00',6.86),('8975','2013-04-08','11:00:00',5.74),('8975','2013-04-08','11:05:00',3.47),('8975','2013-04-08','11:10:00',7.48),('8975','2013-04-08','11:15:00',4.44),('8975','2013-04-08','11:20:00',3.62),('8975','2013-04-08','11:25:00',2.74),('8975','2013-04-08','11:30:00',3.97),('8975','2013-04-08','11:35:00',7.36),('8975','2013-04-08','11:40:00',6.74),('8975','2013-04-08','11:45:00',2.6),('8975','2013-04-08','11:50:00',6.4),('8975','2013-04-08','11:55:00',7.42),('8975','2013-04-08','12:00:00',7.06),('8975','2013-04-08','12:05:00',6.17),('8975','2013-04-08','12:10:00',5.83),('8975','2013-04-08','12:15:00',7),('8975','2013-04-08','12:20:00',6.43),('8975','2013-04-08','12:25:00',5.68),('8975','2013-04-08','12:30:00',5.89),('8975','2013-04-08','12:35:00',2.69),('8975','2013-04-08','12:40:00',6.38),('8975','2013-04-08','12:45:00',5.85),('8975','2013-04-08','12:50:00',5.12),('8975','2013-04-08','12:55:00',6.67),('8975','2013-04-08','13:00:00',6.37),('8975','2013-04-08','13:05:00',6.51),('8975','2013-04-08','13:10:00',4.93),('8975','2013-04-08','13:15:00',4.87),('8975','2013-04-08','13:20:00',4.69),('8975','2013-04-08','13:25:00',6.66),('8975','2013-04-08','13:30:00',7.19),('8975','2013-04-08','13:35:00',5.95),('8975','2013-04-08','13:40:00',5.86),('8975','2013-04-08','13:45:00',6.43),('8975','2013-04-08','13:50:00',5.55),('8975','2013-04-08','13:55:00',6.01),('8975','2013-04-08','14:00:00',5.78),('8975','2013-04-08','14:05:00',5.84),('8975','2013-04-08','14:10:00',5.12),('8975','2013-04-08','14:15:00',4.99),('8975','2013-04-08','14:20:00',4.96),('8975','2013-04-08','14:25:00',5.11),('8975','2013-04-08','14:30:00',4.68),('8975','2013-04-08','14:35:00',4.94),('8975','2013-04-08','14:40:00',4.16),('8975','2013-04-08','14:45:00',1.95),('8975','2013-04-08','14:50:00',3.62),('8975','2013-04-08','14:55:00',4.4),('8975','2013-04-08','15:00:00',5.55),('8975','2013-04-08','15:05:00',4.36),('8975','2013-04-08','15:10:00',4.14),('8975','2013-04-08','15:15:00',3.35),('8975','2013-04-08','15:20:00',4.25),('8975','2013-04-08','15:25:00',4.11),('8975','2013-04-08','15:30:00',4.86),('8975','2013-04-08','15:35:00',4.74),('8975','2013-04-08','15:40:00',3.79),('8975','2013-04-08','15:45:00',2.25),('8975','2013-04-08','15:50:00',3.15),('8975','2013-04-08','15:55:00',2.51),('8975','2013-04-08','16:00:00',2.01),('8975','2013-04-08','16:05:00',1.42),('8975','2013-04-08','16:10:00',1.28),('8975','2013-04-08','16:15:00',1.32),('8975','2013-04-08','16:20:00',1.16),('8975','2013-04-08','16:25:00',1.65),('8975','2013-04-08','16:30:00',2.22),('8975','2013-04-08','16:35:00',1.62),('8975','2013-04-08','16:40:00',2.5),('8975','2013-04-08','16:45:00',3.22),('8975','2013-04-08','16:50:00',3.42),('8975','2013-04-08','16:55:00',2.49),('8975','2013-04-08','17:00:00',1.78),('8975','2013-04-08','17:05:00',1.22),('8975','2013-04-08','17:10:00',1.98),('8975','2013-04-08','17:15:00',2.06),('8975','2013-04-08','17:30:00',1.09),('8975','2013-04-08','17:35:00',1.37),('8975','2013-04-08','17:40:00',1.32),('8975','2013-04-08','17:50:00',1.25),('8975','2013-04-08','18:15:00',1.05),('8975','2013-04-08','18:20:00',1.04),('8975','2013-04-07','07:55:00',1.01),('8975','2013-04-07','08:00:00',1.22),('8975','2013-04-07','08:05:00',2.16),('8975','2013-04-07','08:10:00',2.69),('8975','2013-04-07','08:15:00',1.74),('8975','2013-04-07','08:20:00',1.32),('8975','2013-04-07','08:25:00',1.39),('8975','2013-04-07','08:30:00',1.38),('8975','2013-04-07','08:35:00',1.9),('8975','2013-04-07','08:40:00',2.3),('8975','2013-04-07','08:45:00',2.68),('8975','2013-04-07','08:50:00',2.77),('8975','2013-04-07','08:55:00',3.93),('8975','2013-04-07','09:00:00',4.6),('8975','2013-04-07','09:05:00',3.91),('8975','2013-04-07','09:10:00',3.54),('8975','2013-04-07','09:15:00',4.86),('8975','2013-04-07','09:20:00',4.88),('8975','2013-04-07','09:25:00',4.73),('8975','2013-04-07','09:30:00',4.92),('8975','2013-04-07','09:35:00',5.15),('8975','2013-04-07','09:40:00',5.17),('8975','2013-04-07','09:45:00',4.69),('8975','2013-04-07','09:50:00',2.55),('8975','2013-04-07','09:55:00',4.56),('8975','2013-04-07','10:00:00',5.47),('8975','2013-04-07','10:05:00',5.3),('8975','2013-04-07','10:10:00',5.49),('8975','2013-04-07','10:15:00',5.39),('8975','2013-04-07','10:20:00',5.63),('8975','2013-04-07','10:25:00',5.54),('8975','2013-04-07','10:30:00',5.74),('8975','2013-04-07','10:35:00',5.53),('8975','2013-04-07','10:40:00',6.01),('8975','2013-04-07','10:45:00',6.21),('8975','2013-04-07','10:50:00',6),('8975','2013-04-07','10:55:00',5.84),('8975','2013-04-07','11:00:00',5.47),('8975','2013-04-07','11:05:00',5.17),('8975','2013-04-07','11:10:00',4.5),('8975','2013-04-07','11:15:00',3.83),('8975','2013-04-07','11:20:00',3.83),('8975','2013-04-07','11:25:00',3.44),('8975','2013-04-07','11:30:00',4.21),('8975','2013-04-07','11:35:00',4.93),('8975','2013-04-07','11:40:00',5.23),('8975','2013-04-07','11:45:00',4.59),('8975','2013-04-07','11:50:00',4.14),('8975','2013-04-07','11:55:00',3.64),('8975','2013-04-07','12:00:00',3.44),('8975','2013-04-07','12:05:00',3.43),('8975','2013-04-07','12:10:00',3.74),('8975','2013-04-07','12:15:00',4.09),('8975','2013-04-07','12:20:00',4.23),('8975','2013-04-07','12:25:00',3.61),('8975','2013-04-07','12:30:00',3.39),('8975','2013-04-07','12:35:00',3.06),('8975','2013-04-07','12:40:00',2.9),('8975','2013-04-07','12:45:00',2.74),('8975','2013-04-07','12:50:00',2.56),('8975','2013-04-07','12:55:00',3.8),('8975','2013-04-07','13:00:00',4.66),('8975','2013-04-07','13:05:00',3.35),('8975','2013-04-07','13:10:00',4.1),('8975','2013-04-07','13:15:00',3.17),('8975','2013-04-07','13:20:00',2.95),('8975','2013-04-07','13:25:00',4.44),('8975','2013-04-07','13:30:00',4.4),('8975','2013-04-07','13:35:00',4),('8975','2013-04-07','13:40:00',3.81),('8975','2013-04-07','13:45:00',2.79),('8975','2013-04-07','13:50:00',4.23),('8975','2013-04-07','13:55:00',3.83),('8975','2013-04-07','14:00:00',5.33),('8975','2013-04-07','14:05:00',5.38),('8975','2013-04-07','14:10:00',5.16),('8975','2013-04-07','14:15:00',5.48),('8975','2013-04-07','14:20:00',5.42),('8975','2013-04-07','14:25:00',5.73),('8975','2013-04-07','14:30:00',5.14),('8975','2013-04-07','14:35:00',4.55),('8975','2013-04-07','14:40:00',5.24),('8975','2013-04-07','14:45:00',5.5),('8975','2013-04-07','14:50:00',5.05),('8975','2013-04-07','14:55:00',5.02),('8975','2013-04-07','15:00:00',4.24),('8975','2013-04-07','15:05:00',3.66),('8975','2013-04-07','15:10:00',4.39),('8975','2013-04-07','15:15:00',3.94),('8975','2013-04-07','15:20:00',3.53),('8975','2013-04-07','15:25:00',4.54),('8975','2013-04-07','15:30:00',4.47),('8975','2013-04-07','15:35:00',4.19),('8975','2013-04-07','15:40:00',4.04),('8975','2013-04-07','15:45:00',3.91),('8975','2013-04-07','15:50:00',3.77),('8975','2013-04-07','15:55:00',3.6),('8975','2013-04-07','16:00:00',3.48),('8975','2013-04-07','16:05:00',3.18),('8975','2013-04-07','16:10:00',3.08),('8975','2013-04-07','16:15:00',3.28),('8975','2013-04-07','16:20:00',3.19),('8975','2013-04-07','16:25:00',2.99),('8975','2013-04-07','16:30:00',2.92),('8975','2013-04-07','16:35:00',2.76),('8975','2013-04-07','16:40:00',2.71),('8975','2013-04-07','16:45:00',2.6),('8975','2013-04-07','16:50:00',2.47),('8975','2013-04-07','16:55:00',2.36),('8975','2013-04-07','17:00:00',2.28),('8975','2013-04-07','17:05:00',2.18),('8975','2013-04-07','17:10:00',1.99),('8975','2013-04-07','17:15:00',1.82),('8975','2013-04-07','17:20:00',1.82),('8975','2013-04-07','17:25:00',1.89),('8975','2013-04-07','17:30:00',1.75),('8975','2013-04-07','17:35:00',1.56),('8975','2013-04-07','17:40:00',1.48),('8975','2013-04-07','17:45:00',1.44),('8975','2013-04-07','17:50:00',1.23),('8975','2013-04-07','17:55:00',1.17),('8975','2013-04-07','18:00:00',1.26),('8975','2013-04-07','18:15:00',1.05),('8975','2013-04-07','18:20:00',1.58),('8975','2013-04-07','18:25:00',1.5),('8975','2013-04-07','18:30:00',1.01),('8975','2013-04-06','07:55:00',1.01),('8975','2013-04-06','08:00:00',1.17),('8975','2013-04-06','08:05:00',1.34),('8975','2013-04-06','08:10:00',1.54),('8975','2013-04-06','08:15:00',1.72),('8975','2013-04-06','08:20:00',2.07),('8975','2013-04-06','08:25:00',2.31),('8975','2013-04-06','08:30:00',2.39),('8975','2013-04-06','08:35:00',2.46),('8975','2013-04-06','08:40:00',2.47),('8975','2013-04-06','08:45:00',2.49),('8975','2013-04-06','08:50:00',2.53),('8975','2013-04-06','08:55:00',2.6),('8975','2013-04-06','09:00:00',2.65),('8975','2013-04-06','09:05:00',2.63),('8975','2013-04-06','09:10:00',2.73),('8975','2013-04-06','09:15:00',3.15),('8975','2013-04-06','09:20:00',3.17),('8975','2013-04-06','09:25:00',3.22),('8975','2013-04-06','09:30:00',3.16),('8975','2013-04-06','09:35:00',3),('8975','2013-04-06','09:40:00',2.78),('8975','2013-04-06','09:45:00',2.77),('8975','2013-04-06','09:50:00',3.51),('8975','2013-04-06','09:55:00',3.93),('8975','2013-04-06','10:00:00',4.35),('8975','2013-04-06','10:05:00',4.86),('8975','2013-04-06','10:10:00',4.91),('8975','2013-04-06','10:15:00',4.96),('8975','2013-04-06','10:20:00',5.21),('8975','2013-04-06','10:25:00',5.21),('8975','2013-04-06','10:30:00',4.4),('8975','2013-04-06','10:35:00',4.28),('8975','2013-04-06','10:40:00',4.65),('8975','2013-04-06','10:45:00',4.78),('8975','2013-04-06','10:50:00',4.6),('8975','2013-04-06','10:55:00',3.86),('8975','2013-04-06','11:00:00',3.69),('8975','2013-04-06','11:05:00',3.39),('8975','2013-04-06','11:10:00',3.43),('8975','2013-04-06','11:15:00',4.74),('8975','2013-04-06','11:20:00',6.15),('8975','2013-04-06','11:25:00',6.35),('8975','2013-04-06','11:30:00',6.39),('8975','2013-04-06','11:35:00',5.8),('8975','2013-04-06','11:40:00',5.23),('8975','2013-04-06','11:45:00',4.13),('8975','2013-04-06','11:50:00',3.85),('8975','2013-04-06','11:55:00',3.98),('8975','2013-04-06','12:00:00',3.91),('8975','2013-04-06','12:05:00',4.07),('8975','2013-04-06','12:10:00',4.4),('8975','2013-04-06','12:15:00',4.12),('8975','2013-04-06','12:20:00',4.69),('8975','2013-04-06','12:25:00',4.81),('8975','2013-04-06','12:30:00',4.44),('8975','2013-04-06','12:35:00',4.81),('8975','2013-04-06','12:40:00',4.17),('8975','2013-04-06','12:45:00',4.06),('8975','2013-04-06','12:50:00',3.97),('8975','2013-04-06','12:55:00',4.25),('8975','2013-04-06','13:00:00',4.76),('8975','2013-04-06','13:05:00',5.1),('8975','2013-04-06','13:10:00',4.92),('8975','2013-04-06','13:15:00',4.38),('8975','2013-04-06','13:20:00',4.7),('8975','2013-04-06','13:25:00',4.73),('8975','2013-04-06','13:30:00',4.61),('8975','2013-04-06','13:35:00',4.91),('8975','2013-04-06','13:40:00',4.57),('8975','2013-04-06','13:45:00',3.79),('8975','2013-04-06','13:50:00',4.22),('8975','2013-04-06','13:55:00',3.93),('8975','2013-04-06','14:00:00',4.31),('8975','2013-04-06','14:05:00',4.19),('8975','2013-04-06','14:10:00',3.47),('8975','2013-04-06','14:15:00',2.38),('8975','2013-04-06','14:20:00',3.22),('8975','2013-04-06','14:25:00',3.17),('8975','2013-04-06','14:30:00',2.83),('8975','2013-04-06','14:35:00',2.36),('8975','2013-04-06','14:40:00',2.67),('8975','2013-04-06','14:45:00',3.02),('8975','2013-04-06','14:50:00',2.48),('8975','2013-04-06','14:55:00',2.68),('8975','2013-04-06','15:00:00',3.39),('8975','2013-04-06','15:05:00',3.2),('8975','2013-04-06','15:10:00',2.75),('8975','2013-04-06','15:15:00',3.27),('8975','2013-04-06','15:20:00',2.98),('8975','2013-04-06','15:25:00',3.39),('8975','2013-04-06','15:30:00',3.34),('8975','2013-04-06','15:35:00',3.76),('8975','2013-04-06','15:40:00',3.6),('8975','2013-04-06','15:45:00',3.51),('8975','2013-04-06','15:50:00',3.33),('8975','2013-04-06','15:55:00',3.16),('8975','2013-04-06','16:00:00',2.95),('8975','2013-04-06','16:05:00',2.6),('8975','2013-04-06','16:10:00',2.37),('8975','2013-04-06','16:15:00',2.09),('8975','2013-04-06','16:20:00',2.09),('8975','2013-04-06','16:25:00',2.02),('8975','2013-04-06','16:30:00',1.83),('8975','2013-04-06','16:35:00',2.33),('8975','2013-04-06','16:40:00',2.14),('8975','2013-04-06','16:45:00',2.46),('8975','2013-04-06','16:50:00',2.86),('8975','2013-04-06','16:55:00',2.86),('8975','2013-04-06','17:00:00',2.65),('8975','2013-04-06','17:05:00',2.41),('8975','2013-04-06','17:10:00',2.25),('8975','2013-04-06','17:15:00',2.22),('8975','2013-04-06','17:20:00',1.92),('8975','2013-04-06','17:25:00',2.07),('8975','2013-04-06','17:30:00',2),('8975','2013-04-06','17:35:00',1.93),('8975','2013-04-06','17:40:00',1.82),('8975','2013-04-06','17:45:00',1.84),('8975','2013-04-06','17:50:00',1.83),('8975','2013-04-06','17:55:00',1.64),('8975','2013-04-06','18:00:00',1.26),('8975','2013-04-05','07:25:00',1.42),('8975','2013-04-05','07:30:00',1.54),('8975','2013-04-05','07:35:00',1.73),('8975','2013-04-05','07:40:00',1.87),('8975','2013-04-05','07:45:00',2.09),('8975','2013-04-05','07:50:00',2.37),('8975','2013-04-05','07:55:00',2.63),('8975','2013-04-05','08:00:00',2.8),('8975','2013-04-05','08:05:00',2.93),('8975','2013-04-05','08:10:00',3.03),('8975','2013-04-05','08:15:00',3.12),('8975','2013-04-05','08:20:00',3.21),('8975','2013-04-05','08:25:00',3.3),('8975','2013-04-05','08:30:00',3.4),('8975','2013-04-05','08:35:00',3.5),('8975','2013-04-05','08:40:00',3.59),('8975','2013-04-05','08:45:00',3.68),('8975','2013-04-05','08:50:00',3.81),('8975','2013-04-05','08:55:00',3.92),('8975','2013-04-05','09:00:00',4),('8975','2013-04-05','09:05:00',4.08),('8975','2013-04-05','09:10:00',4.22),('8975','2013-04-05','09:15:00',4.35),('8975','2013-04-05','09:20:00',4.45),('8975','2013-04-05','09:25:00',4.54),('8975','2013-04-05','09:30:00',4.62),('8975','2013-04-05','09:35:00',4.61),('8975','2013-04-05','09:40:00',4.83),('8975','2013-04-05','09:45:00',4.9),('8975','2013-04-05','09:50:00',4.96),('8975','2013-04-05','09:55:00',5.04),('8975','2013-04-05','10:00:00',5.11),('8975','2013-04-05','10:05:00',5.18),('8975','2013-04-05','10:10:00',5.28),('8975','2013-04-05','10:15:00',5.36),('8975','2013-04-05','10:20:00',5.48),('8975','2013-04-05','10:25:00',5.57),('8975','2013-04-05','10:30:00',5.64),('8975','2013-04-05','10:35:00',5.64),('8975','2013-04-05','10:40:00',5.67),('8975','2013-04-05','10:45:00',5.78),('8975','2013-04-05','10:50:00',5.81),('8975','2013-04-05','10:55:00',5.84),('8975','2013-04-05','11:00:00',5.9),('8975','2013-04-05','11:05:00',5.91),('8975','2013-04-05','11:10:00',5.86),('8975','2013-04-05','11:15:00',5.99),('8975','2013-04-05','11:20:00',6.09),('8975','2013-04-05','11:25:00',6.11),('8975','2013-04-05','11:30:00',6.14),('8975','2013-04-05','11:35:00',6.2),('8975','2013-04-05','11:40:00',6.22),('8975','2013-04-05','11:45:00',6.22),('8975','2013-04-05','11:50:00',6.25),('8975','2013-04-05','11:55:00',6.29),('8975','2013-04-05','12:00:00',6.28),('8975','2013-04-05','12:05:00',6.28),('8975','2013-04-05','12:10:00',6.27),('8975','2013-04-05','12:15:00',6.3),('8975','2013-04-05','12:20:00',6.29),('8975','2013-04-05','12:25:00',6.39),('8975','2013-04-05','12:30:00',6.36),('8975','2013-04-05','12:35:00',6.38),('8975','2013-04-05','12:40:00',6.3),('8975','2013-04-05','12:45:00',5.78),('8975','2013-04-05','12:50:00',2.64),('8975','2013-04-05','12:55:00',4.59),('8975','2013-04-05','13:00:00',6.73),('8975','2013-04-05','13:05:00',6.63),('8975','2013-04-05','13:10:00',4.11),('8975','2013-04-05','13:15:00',1.33),('8975','2013-04-05','13:20:00',2.39),('8975','2013-04-05','13:25:00',7.23),('8975','2013-04-05','13:30:00',6.08),('8975','2013-04-05','13:35:00',2.81),('8975','2013-04-05','13:40:00',6.61),('8975','2013-04-05','13:45:00',6.74),('8975','2013-04-05','13:50:00',4.8),('8975','2013-04-05','13:55:00',6),('8975','2013-04-05','14:00:00',2.77),('8975','2013-04-05','14:05:00',2.76),('8975','2013-04-05','14:10:00',1.74),('8975','2013-04-05','14:15:00',1.86),('8975','2013-04-05','14:20:00',4.8),('8975','2013-04-05','14:25:00',6.32),('8975','2013-04-05','14:30:00',5.83),('8975','2013-04-05','14:35:00',4.23),('8975','2013-04-05','14:40:00',2.83),('8975','2013-04-05','14:45:00',3.13),('8975','2013-04-05','14:50:00',3.69),('8975','2013-04-05','14:55:00',5.1),('8975','2013-04-05','15:00:00',5),('8975','2013-04-05','15:05:00',4.74),('8975','2013-04-05','15:10:00',4.6),('8975','2013-04-05','15:15:00',4.37),('8975','2013-04-05','15:20:00',4.19),('8975','2013-04-05','15:25:00',4.16),('8975','2013-04-05','15:30:00',4.04),('8975','2013-04-05','15:35:00',3.86),('8975','2013-04-05','15:40:00',3.67),('8975','2013-04-05','15:45:00',3.58),('8975','2013-04-05','15:50:00',3.55),('8975','2013-04-05','15:55:00',3.41),('8975','2013-04-05','16:00:00',2.99),('8975','2013-04-05','16:05:00',3.22),('8975','2013-04-05','16:10:00',3.24),('8975','2013-04-05','16:15:00',2.56),('8975','2013-04-05','16:20:00',2.57),('8975','2013-04-05','16:25:00',2.48),('8975','2013-04-05','16:30:00',2.86),('8975','2013-04-05','16:35:00',2.79),('8975','2013-04-05','16:40:00',2.28),('8975','2013-04-05','16:45:00',2.65),('8975','2013-04-05','16:50:00',2.32),('8975','2013-04-05','16:55:00',1.91),('8975','2013-04-05','17:00:00',1.92),('8975','2013-04-05','17:05:00',1.78),('8975','2013-04-05','17:10:00',1.63),('8975','2013-04-05','17:15:00',1.39),('8975','2013-04-05','17:20:00',1.2),('8975','2013-04-05','17:25:00',1.28),('8975','2013-04-05','17:30:00',1.22),('8975','2013-04-05','17:35:00',1.14),('8975','2013-04-05','17:40:00',1.11),('8975','2013-04-05','17:45:00',1.13),('8975','2013-04-05','17:50:00',1.08),('8975','2013-04-04','08:00:00',2.3),('8975','2013-04-04','08:05:00',2.61),('8975','2013-04-04','08:10:00',2.48),('8975','2013-04-04','08:15:00',2.16),('8975','2013-04-04','08:20:00',3.38),('8975','2013-04-04','08:25:00',2.34),('8975','2013-04-04','08:45:00',1.55),('8975','2013-04-04','08:50:00',1.82),('8975','2013-04-04','08:55:00',3.9),('8975','2013-04-04','09:00:00',4.41),('8975','2013-04-04','09:05:00',4.82),('8975','2013-04-04','09:10:00',4.16),('8975','2013-04-04','09:15:00',3.79),('8975','2013-04-04','09:20:00',3),('8975','2013-04-04','09:25:00',1.59),('8975','2013-04-04','09:30:00',1.17),('8975','2013-04-04','09:35:00',1.72),('8975','2013-04-04','09:40:00',2.83),('8975','2013-04-04','09:45:00',1.39),('8975','2013-04-04','09:50:00',2.15),('8975','2013-04-04','09:55:00',1.83),('8975','2013-04-04','10:00:00',1.77),('8975','2013-04-04','10:05:00',2.73),('8975','2013-04-04','10:10:00',5.04),('8975','2013-04-04','10:15:00',4.05),('8975','2013-04-04','10:20:00',3.1),('8975','2013-04-04','10:25:00',2.52),('8975','2013-04-04','10:30:00',4.83),('8975','2013-04-04','10:35:00',1.56),('8975','2013-04-04','10:40:00',4.79),('8975','2013-04-04','10:45:00',3.83),('8975','2013-04-04','10:50:00',5.7),('8975','2013-04-04','10:55:00',3.83),('8975','2013-04-04','11:00:00',5.08),('8975','2013-04-04','11:05:00',4.32),('8975','2013-04-04','11:10:00',5.33),('8975','2013-04-04','11:15:00',3.79),('8975','2013-04-04','11:20:00',6.83),('8975','2013-04-04','11:25:00',6.64),('8975','2013-04-04','11:30:00',3.57),('8975','2013-04-04','11:35:00',7.27),('8975','2013-04-04','11:40:00',4.75),('8975','2013-04-04','11:45:00',6.21),('8975','2013-04-04','11:50:00',6.2),('8975','2013-04-04','11:55:00',6.97),('8975','2013-04-04','12:00:00',7.1),('8975','2013-04-04','12:05:00',5.16),('8975','2013-04-04','12:10:00',3.25),('8975','2013-04-04','12:15:00',6.28),('8975','2013-04-04','12:20:00',5.96),('8975','2013-04-04','12:25:00',3.8),('8975','2013-04-04','12:30:00',2.71),('8975','2013-04-04','12:35:00',3.13),('8975','2013-04-04','12:40:00',3.18),('8975','2013-04-04','12:45:00',5.14),('8975','2013-04-04','12:50:00',3.32),('8975','2013-04-04','12:55:00',7.2),('8975','2013-04-04','13:00:00',3.89),('8975','2013-04-04','13:05:00',3.03),('8975','2013-04-04','13:10:00',4.15),('8975','2013-04-04','13:15:00',4.01),('8975','2013-04-04','13:20:00',4.52),('8975','2013-04-04','13:25:00',4.5),('8975','2013-04-04','13:30:00',4.97),('8975','2013-04-04','13:35:00',6.19),('8975','2013-04-04','13:40:00',6.1),('8975','2013-04-04','13:45:00',3.37),('8975','2013-04-04','13:50:00',5.15),('8975','2013-04-04','13:55:00',5.77),('8975','2013-04-04','14:00:00',3.41),('8975','2013-04-04','14:05:00',4.92),('8975','2013-04-04','14:10:00',5.42),('8975','2013-04-04','14:15:00',4.45),('8975','2013-04-04','14:20:00',4.3),('8975','2013-04-04','14:25:00',5.49),('8975','2013-04-04','14:30:00',3.14),('8975','2013-04-04','14:35:00',6.39),('8975','2013-04-04','14:40:00',5.76),('8975','2013-04-04','14:45:00',2.72),('8975','2013-04-04','14:50:00',4.36),('8975','2013-04-04','14:55:00',4.78),('8975','2013-04-04','15:00:00',5.21),('8975','2013-04-04','15:05:00',4.63),('8975','2013-04-04','15:10:00',3.18),('8975','2013-04-04','15:15:00',2.68),('8975','2013-04-04','15:20:00',2.6),('8975','2013-04-04','15:25:00',2.79),('8975','2013-04-04','15:30:00',3.2),('8975','2013-04-04','15:35:00',2.28),('8975','2013-04-04','15:40:00',2.12),('8975','2013-04-04','15:45:00',2.66),('8975','2013-04-04','15:50:00',3.52),('8975','2013-04-04','15:55:00',3.04),('8975','2013-04-04','16:00:00',2.72),('8975','2013-04-04','16:05:00',2.67),('8975','2013-04-04','16:10:00',2.97),('8975','2013-04-04','16:15:00',3.35),('8975','2013-04-04','16:20:00',3.79),('8975','2013-04-04','16:25:00',2.61),('8975','2013-04-04','16:30:00',2.37),('8975','2013-04-04','16:35:00',2.73),('8975','2013-04-04','16:40:00',2.51),('8975','2013-04-04','16:45:00',3.14),('8975','2013-04-04','16:50:00',1.93),('8975','2013-04-04','16:55:00',3.04),('8975','2013-04-04','17:00:00',2.41),('8975','2013-04-04','17:05:00',2.88),('8975','2013-04-04','17:10:00',1.91),('8975','2013-04-04','17:15:00',2.04),('8975','2013-04-04','17:20:00',2.46),('8975','2013-04-04','17:25:00',2.03),('8975','2013-04-04','17:30:00',1.9),('8975','2013-04-04','17:35:00',1.83),('8975','2013-04-04','17:40:00',1.64),('8975','2013-04-04','17:55:00',1.46),('8975','2013-04-04','18:00:00',1.54),('8975','2013-04-04','18:05:00',1.39),('8975','2013-04-04','18:10:00',1.38),('8975','2013-04-04','18:15:00',1.39),('8975','2013-04-04','18:20:00',1.25),('8975','2013-04-04','18:25:00',1.1),('8975','2013-04-04','18:30:00',1.05),('8975','2013-04-03','08:05:00',1.06),('8975','2013-04-03','08:20:00',1.07),('8975','2013-04-03','08:25:00',1.12),('8975','2013-04-03','08:30:00',1.18),('8975','2013-04-03','08:35:00',1.55),('8975','2013-04-03','08:40:00',1.38),('8975','2013-04-03','08:45:00',1.43),('8975','2013-04-03','08:50:00',1.69),('8975','2013-04-03','08:55:00',2.92),('8975','2013-04-03','09:00:00',3.76),('8975','2013-04-03','09:05:00',2.2),('8975','2013-04-03','09:10:00',3.09),('8975','2013-04-03','09:15:00',2.36),('8975','2013-04-03','09:20:00',2.18),('8975','2013-04-03','09:25:00',1.76),('8975','2013-04-03','09:30:00',3.26),('8975','2013-04-03','09:35:00',4.54),('8975','2013-04-03','09:40:00',4.17),('8975','2013-04-03','09:45:00',3.25),('8975','2013-04-03','09:50:00',2.2),('8975','2013-04-03','09:55:00',2.12),('8975','2013-04-03','10:00:00',3.15),('8975','2013-04-03','10:05:00',4.29),('8975','2013-04-03','10:10:00',2.65),('8975','2013-04-03','10:15:00',2.79),('8975','2013-04-03','10:20:00',5.16),('8975','2013-04-03','10:25:00',6.9),('8975','2013-04-03','10:30:00',4.64),('8975','2013-04-03','10:35:00',2.79),('8975','2013-04-03','10:40:00',6.07),('8975','2013-04-03','10:45:00',3.09),('8975','2013-04-03','10:50:00',3.14),('8975','2013-04-03','10:55:00',6.78),('8975','2013-04-03','11:00:00',5.68),('8975','2013-04-03','11:05:00',2.16),('8975','2013-04-03','11:10:00',1.74),('8975','2013-04-03','11:15:00',2.29),('8975','2013-04-03','11:20:00',2.27),('8975','2013-04-03','11:25:00',1.66),('8975','2013-04-03','11:30:00',1.95),('8975','2013-04-03','11:35:00',3.17),('8975','2013-04-03','11:40:00',4.4),('8975','2013-04-03','11:45:00',4.01),('8975','2013-04-03','11:50:00',4.07),('8975','2013-04-03','11:55:00',6.89),('8975','2013-04-03','12:00:00',6.1),('8975','2013-04-03','12:05:00',4.75),('8975','2013-04-03','12:10:00',5.98),('8975','2013-04-03','12:15:00',6.37),('8975','2013-04-03','12:20:00',5.59),('8975','2013-04-03','12:25:00',4.91),('8975','2013-04-03','12:30:00',5.36),('8975','2013-04-03','12:35:00',6.62),('8975','2013-04-03','12:40:00',6.36),('8975','2013-04-03','12:45:00',5.99),('8975','2013-04-03','12:50:00',6.09),('8975','2013-04-03','12:55:00',5.51),('8975','2013-04-03','13:00:00',5.66),('8975','2013-04-03','13:05:00',5.63),('8975','2013-04-03','13:10:00',6.05),('8975','2013-04-03','13:15:00',6.09),('8975','2013-04-03','13:20:00',5.94),('8975','2013-04-03','13:25:00',6.04),('8975','2013-04-03','13:30:00',5.78),('8975','2013-04-03','13:35:00',4.82),('8975','2013-04-03','13:40:00',3.95),('8975','2013-04-03','13:45:00',4.96),('8975','2013-04-03','13:50:00',4.84),('8975','2013-04-03','13:55:00',3.7),('8975','2013-04-03','14:00:00',4.23),('8975','2013-04-03','14:05:00',5.72),('8975','2013-04-03','14:10:00',5.63),('8975','2013-04-03','14:15:00',5.57),('8975','2013-04-03','14:20:00',5.34),('8975','2013-04-03','14:25:00',5.14),('8975','2013-04-03','14:30:00',5.05),('8975','2013-04-03','14:35:00',5.15),('8975','2013-04-03','14:40:00',5.07),('8975','2013-04-03','14:45:00',4.87),('8975','2013-04-03','14:50:00',4.75),('8975','2013-04-03','14:55:00',4.82),('8975','2013-04-03','15:00:00',4.69),('8975','2013-04-03','15:05:00',4.47),('8975','2013-04-03','15:10:00',4.18),('8975','2013-04-03','15:15:00',4.27),('8975','2013-04-03','15:20:00',4.16),('8975','2013-04-03','15:25:00',4.09),('8975','2013-04-03','15:30:00',3.97),('8975','2013-04-03','15:35:00',3.87),('8975','2013-04-03','15:40:00',3.8),('8975','2013-04-03','15:45:00',3.68),('8975','2013-04-03','15:50:00',3.52),('8975','2013-04-03','15:55:00',3.37),('8975','2013-04-03','16:00:00',3.31),('8975','2013-04-03','16:05:00',3.11),('8975','2013-04-03','16:10:00',3.07),('8975','2013-04-03','16:15:00',2.79),('8975','2013-04-03','16:20:00',3.08),('8975','2013-04-03','16:25:00',2.31),('8975','2013-04-03','16:30:00',2.65),('8975','2013-04-03','16:35:00',1.99),('8975','2013-04-03','16:40:00',2.27),('8975','2013-04-03','16:45:00',2.02),('8975','2013-04-03','16:50:00',2.05),('8975','2013-04-03','16:55:00',2.14),('8975','2013-04-03','17:00:00',1.97),('8975','2013-04-03','17:05:00',1.94),('8975','2013-04-03','17:10:00',1.71),('8975','2013-04-03','17:15:00',1.68),('8975','2013-04-03','17:20:00',1.37),('8975','2013-04-03','17:25:00',1.36),('8975','2013-04-03','17:30:00',1.11),('8975','2013-04-03','17:35:00',1.07),('8975','2013-04-03','17:40:00',1.18),('8975','2013-04-03','17:45:00',1.17),('8975','2013-04-03','17:50:00',1.28),('8975','2013-04-03','17:55:00',1.36),('8975','2013-04-03','18:00:00',1.16),('8975','2013-04-02','07:35:00',1.37),('8975','2013-04-02','07:40:00',1.79),('8975','2013-04-02','07:45:00',2.2),('8975','2013-04-02','07:50:00',2.14),('8975','2013-04-02','07:55:00',2.39),('8975','2013-04-02','08:00:00',2.68),('8975','2013-04-02','08:05:00',2.75),('8975','2013-04-02','08:10:00',2.98),('8975','2013-04-02','08:15:00',3.23),('8975','2013-04-02','08:20:00',3.27),('8975','2013-04-02','08:25:00',3.57),('8975','2013-04-02','08:30:00',3.45),('8975','2013-04-02','08:35:00',2.87),('8975','2013-04-02','08:40:00',2.97),('8975','2013-04-02','08:45:00',3.87),('8975','2013-04-02','08:50:00',3.9),('8975','2013-04-02','08:55:00',4.06),('8975','2013-04-02','09:00:00',4.21),('8975','2013-04-02','09:05:00',3.35),('8975','2013-04-02','09:10:00',2.89),('8975','2013-04-02','09:15:00',3.02),('8975','2013-04-02','09:20:00',4.26),('8975','2013-04-02','09:25:00',4.24),('8975','2013-04-02','09:30:00',4.02),('8975','2013-04-02','09:35:00',4.7),('8975','2013-04-02','09:40:00',3.27),('8975','2013-04-02','09:45:00',5.35),('8975','2013-04-02','09:50:00',4.46),('8975','2013-04-02','09:55:00',4.46),('8975','2013-04-02','10:00:00',2.71),('8975','2013-04-02','10:05:00',2.8),('8975','2013-04-02','10:10:00',4.85),('8975','2013-04-02','10:15:00',3.04),('8975','2013-04-02','10:20:00',4.88),('8975','2013-04-02','10:25:00',5.82),('8975','2013-04-02','10:30:00',4.89),('8975','2013-04-02','10:35:00',6.08),('8975','2013-04-02','10:40:00',4.52),('8975','2013-04-02','10:45:00',5.27),('8975','2013-04-02','10:50:00',6.88),('8975','2013-04-02','10:55:00',3.75),('8975','2013-04-02','11:00:00',2.4),('8975','2013-04-02','11:05:00',1.5),('8975','2013-04-02','11:10:00',4.4),('8975','2013-04-02','11:15:00',3.02),('8975','2013-04-02','11:20:00',1.48),('8975','2013-04-02','11:25:00',2.25),('8975','2013-04-02','11:30:00',3.11),('8975','2013-04-02','11:35:00',4),('8975','2013-04-02','11:40:00',4.4),('8975','2013-04-02','11:45:00',4.9),('8975','2013-04-02','11:50:00',5.33),('8975','2013-04-02','11:55:00',5.24),('8975','2013-04-02','12:00:00',6.04),('8975','2013-04-02','12:05:00',5.5),('8975','2013-04-02','12:10:00',6.82),('8975','2013-04-02','12:15:00',3.99),('8975','2013-04-02','12:20:00',4.26),('8975','2013-04-02','12:25:00',6),('8975','2013-04-02','12:30:00',4.64),('8975','2013-04-02','12:35:00',4.08),('8975','2013-04-02','12:40:00',5.92),('8975','2013-04-02','12:45:00',4.54),('8975','2013-04-02','12:50:00',7.28),('8975','2013-04-02','12:55:00',7.22),('8975','2013-04-02','13:00:00',5.46),('8975','2013-04-02','13:05:00',3.69),('8975','2013-04-02','13:10:00',6.16),('8975','2013-04-02','13:15:00',7.08),('8975','2013-04-02','13:20:00',4.53),('8975','2013-04-02','13:25:00',5.5),('8975','2013-04-02','13:30:00',4.74),('8975','2013-04-02','13:35:00',4.35),('8975','2013-04-02','13:40:00',5.23),('8975','2013-04-02','13:45:00',6.87),('8975','2013-04-02','13:50:00',7.15),('8975','2013-04-02','13:55:00',6.02),('8975','2013-04-02','14:00:00',4.22),('8975','2013-04-02','14:05:00',5.61),('8975','2013-04-02','14:10:00',7.28),('8975','2013-04-02','14:15:00',3.5),('8975','2013-04-02','14:20:00',3.67),('8975','2013-04-02','14:25:00',2.47),('8975','2013-04-02','14:30:00',5.93),('8975','2013-04-02','14:35:00',4.65),('8975','2013-04-02','14:40:00',4.87),('8975','2013-04-02','14:45:00',5.34),('8975','2013-04-02','14:50:00',5.12),('8975','2013-04-02','14:55:00',4.36),('8975','2013-04-02','15:00:00',5.09),('8975','2013-04-02','15:05:00',3.97),('8975','2013-04-02','15:10:00',4.22),('8975','2013-04-02','15:15:00',5.21),('8975','2013-04-02','15:20:00',4.78),('8975','2013-04-02','15:25:00',4.23),('8975','2013-04-02','15:30:00',2.91),('8975','2013-04-02','15:35:00',4.04),('8975','2013-04-02','15:40:00',3),('8975','2013-04-02','15:45:00',2.84),('8975','2013-04-02','15:50:00',3.95),('8975','2013-04-02','15:55:00',4.05),('8975','2013-04-02','16:00:00',3.98),('8975','2013-04-02','16:05:00',2.6),('8975','2013-04-02','16:10:00',3.68),('8975','2013-04-02','16:15:00',3.36),('8975','2013-04-02','16:20:00',3.36),('8975','2013-04-02','16:25:00',2.62),('8975','2013-04-02','16:30:00',3.32),('8975','2013-04-02','16:35:00',3.07),('8975','2013-04-02','16:40:00',2.79),('8975','2013-04-02','16:45:00',2.54),('8975','2013-04-02','16:50:00',2.24),('8975','2013-04-02','16:55:00',2.23),('8975','2013-04-02','17:00:00',2.19),('8975','2013-04-02','17:05:00',2.06),('8975','2013-04-02','17:10:00',2.04),('8975','2013-04-02','17:15:00',1.93),('8975','2013-04-02','17:20:00',1.84),('8975','2013-04-02','17:25:00',1.76),('8975','2013-04-02','17:30:00',1.69),('8975','2013-04-02','17:35:00',1.63),('8975','2013-04-02','17:40:00',1.58),('8975','2013-04-02','17:45:00',1.53),('8975','2013-04-02','17:50:00',1.47),('8975','2013-04-02','17:55:00',1.42),('8975','2013-04-02','18:00:00',1.38),('8975','2013-04-02','18:05:00',1.32),('8975','2013-04-02','18:10:00',1.28),('8975','2013-04-02','18:15:00',1.19),('8975','2013-04-02','18:20:00',1.14),('8975','2013-04-02','18:30:00',1.02),('8975','2013-04-01','08:40:00',2.8),('8975','2013-04-01','08:45:00',3.2),('8975','2013-04-01','08:50:00',1.18),('8975','2013-04-01','08:55:00',3.53),('8975','2013-04-01','09:00:00',3.96),('8975','2013-04-01','09:05:00',4.05),('8975','2013-04-01','09:10:00',4.64),('8975','2013-04-01','09:15:00',3.77),('8975','2013-04-01','09:20:00',1.27),('8975','2013-04-01','09:25:00',4.05),('8975','2013-04-01','09:30:00',5.32),('8975','2013-04-01','09:35:00',4.73),('8975','2013-04-01','09:40:00',5.42),('8975','2013-04-01','09:45:00',4.91),('8975','2013-04-01','09:50:00',2.12),('8975','2013-04-01','09:55:00',3.07),('8975','2013-04-01','10:00:00',1.92),('8975','2013-04-01','10:05:00',2.23),('8975','2013-04-01','10:10:00',1),('8975','2013-04-01','10:15:00',3.13),('8975','2013-04-01','10:20:00',1.91),('8975','2013-04-01','10:25:00',1.56),('8975','2013-04-01','10:30:00',1.14),('8975','2013-04-01','10:35:00',3.14),('8975','2013-04-01','10:40:00',4.18),('8975','2013-04-01','10:45:00',4.32),('8975','2013-04-01','10:50:00',5.98),('8975','2013-04-01','10:55:00',1.54),('8975','2013-04-01','11:00:00',1.79),('8975','2013-04-01','11:05:00',4.95),('8975','2013-04-01','11:10:00',2.71),('8975','2013-04-01','11:15:00',1.47),('8975','2013-04-01','11:20:00',1.4),('8975','2013-04-01','11:25:00',1.51),('8975','2013-04-01','11:30:00',2.55),('8975','2013-04-01','11:35:00',1.17),('8975','2013-04-01','11:40:00',2.95),('8975','2013-04-01','11:45:00',3.8),('8975','2013-04-01','11:50:00',2.84),('8975','2013-04-01','11:55:00',1.78),('8975','2013-04-01','12:00:00',2.74),('8975','2013-04-01','12:05:00',5.92),('8975','2013-04-01','12:10:00',3.99),('8975','2013-04-01','12:15:00',2.27),('8975','2013-04-01','12:30:00',2.21),('8975','2013-04-01','12:35:00',2.87),('8975','2013-04-01','12:40:00',3.27),('8975','2013-04-01','12:45:00',3.17),('8975','2013-04-01','12:50:00',2.75),('8975','2013-04-01','12:55:00',3.11),('8975','2013-04-01','13:00:00',3.72),('8975','2013-04-01','13:05:00',4.05),('8975','2013-04-01','13:10:00',4.15),('8975','2013-04-01','13:15:00',2.91),('8975','2013-04-01','13:20:00',2.88),('8975','2013-04-01','13:25:00',4.93),('8975','2013-04-01','13:30:00',3.81),('8975','2013-04-01','13:35:00',3.07),('8975','2013-04-01','13:40:00',3.69),('8975','2013-04-01','13:45:00',3.31),('8975','2013-04-01','13:50:00',2.77),('8975','2013-04-01','13:55:00',4.33),('8975','2013-04-01','14:00:00',4.06),('8975','2013-04-01','14:05:00',3.96),('8975','2013-04-01','14:10:00',5.45),('8975','2013-04-01','14:15:00',4.37),('8975','2013-04-01','14:20:00',8.06),('8975','2013-04-01','14:25:00',6.64),('8975','2013-04-01','14:30:00',2.97),('8975','2013-04-01','14:35:00',2.93),('8975','2013-04-01','14:40:00',4.17),('8975','2013-04-01','14:45:00',3.62),('8975','2013-04-01','14:50:00',2.25),('8975','2013-04-01','14:55:00',2.41),('8975','2013-04-01','15:00:00',1.78),('8975','2013-04-01','15:15:00',1.13),('8975','2013-04-01','15:20:00',1.54),('8975','2013-04-01','15:30:00',1),('8975','2013-04-01','15:35:00',1.08),('8975','2013-04-01','15:40:00',1.57),('8975','2013-04-01','15:45:00',1.48),('8975','2013-04-01','15:55:00',1.25),('8975','2013-04-01','16:00:00',1.88),('8975','2013-04-01','16:05:00',1.74),('8975','2013-04-01','16:10:00',1.36),('8975','2013-04-01','16:15:00',1.75),('8975','2013-04-01','16:20:00',1.62),('8975','2013-04-01','16:25:00',1.41),('8975','2013-04-01','16:30:00',1.79),('8975','2013-04-01','16:35:00',1.76),('8975','2013-04-01','16:40:00',1.46),('8975','2013-04-01','16:45:00',1.22),('8975','2013-04-01','16:55:00',1.19),('8975','2013-04-01','17:00:00',1.37),('8975','2013-04-01','17:05:00',1),('8975','2013-04-01','17:40:00',1.72),('8975','2013-04-01','17:45:00',1.02),('8975','2014-05-01','06:50:00',1.4),('8975','2014-05-01','06:55:00',1.44),('8975','2014-05-01','07:00:00',1.51),('8975','2014-05-01','07:05:00',1.94),('8975','2014-05-01','07:10:00',2.12),('8975','2014-05-01','07:15:00',2.34),('8975','2014-05-01','07:20:00',2),('8975','2014-05-01','07:25:00',2.58),('8975','2014-05-01','07:30:00',2.86),('8975','2014-05-01','07:35:00',3.01),('8975','2014-05-01','07:40:00',3.07),('8975','2014-05-01','07:45:00',3.14),('8975','2014-05-01','07:50:00',2.84),('8975','2014-05-01','07:55:00',1.71),('8975','2014-05-01','08:00:00',2.82),('8975','2014-05-01','08:05:00',4.22),('8975','2014-05-01','08:10:00',2.25),('8975','2014-05-01','08:15:00',1.55),('8975','2014-05-01','08:20:00',3.88),('8975','2014-05-01','08:25:00',2.61),('8975','2014-05-01','08:30:00',2.31),('8975','2014-05-01','08:35:00',1.05),('8975','2014-05-01','08:40:00',1.77),('8975','2014-05-01','08:45:00',4.17),('8975','2014-05-01','08:50:00',1.6),('8975','2014-05-01','08:55:00',1.08),('8975','2014-05-01','09:00:00',1.06),('8975','2014-05-01','09:05:00',1.26),('8975','2014-05-01','09:10:00',1.31),('8975','2014-05-01','09:15:00',2.32),('8975','2014-05-01','09:20:00',2.33),('8975','2014-05-01','09:25:00',3.09),('8975','2014-05-01','09:30:00',2.37),('8975','2014-05-01','09:35:00',2.7),('8975','2014-05-01','09:40:00',2.15),('8975','2014-05-01','09:45:00',1.97),('8975','2014-05-01','09:50:00',2.24),('8975','2014-05-01','09:55:00',2.18),('8975','2014-05-01','10:00:00',2.66),('8975','2014-05-01','10:05:00',3.03),('8975','2014-05-01','10:10:00',2.69),('8975','2014-05-01','10:15:00',2.54),('8975','2014-05-01','10:20:00',2.09),('8975','2014-05-01','10:25:00',1.78),('8975','2014-05-01','10:30:00',1.26),('8975','2014-05-01','10:35:00',1.3),('8975','2014-05-01','10:40:00',1.66),('8975','2014-05-01','10:45:00',2.19),('8975','2014-05-01','10:50:00',1.88),('8975','2014-05-01','11:20:00',1.12),('8975','2014-05-01','11:25:00',1.12),('8975','2014-05-01','11:30:00',1.07),('8975','2014-05-01','12:25:00',1.08),('8975','2014-05-01','12:30:00',1.53),('8975','2014-05-01','12:35:00',1.93),('8975','2014-05-01','12:40:00',1.65),('8975','2014-05-01','12:45:00',2.11),('8975','2014-05-01','12:50:00',2.8),('8975','2014-05-01','12:55:00',2.86),('8975','2014-05-01','13:00:00',2.96),('8975','2014-05-01','13:05:00',3.62),('8975','2014-05-01','13:10:00',2.67),('8975','2014-05-01','13:15:00',4.55),('8975','2014-05-01','13:20:00',4.56),('8975','2014-05-01','13:25:00',3.96),('8975','2014-05-01','13:30:00',4.09),('8975','2014-05-01','13:35:00',2.58),('8975','2014-05-01','13:40:00',3.96),('8975','2014-05-01','13:45:00',3.23),('8975','2014-05-01','13:50:00',2.13),('8975','2014-05-01','13:55:00',2.23),('8975','2014-05-01','14:00:00',4.33),('8975','2014-05-01','14:05:00',3.41),('8975','2014-05-01','14:10:00',1.86),('8975','2014-05-01','14:15:00',1.25),('8975','2014-05-01','14:20:00',2.02),('8975','2014-05-01','14:25:00',4.03),('8975','2014-05-01','14:30:00',4.84),('8975','2014-05-01','14:35:00',2.98),('8975','2014-05-01','14:40:00',2.98),('8975','2014-05-01','14:45:00',2.52),('8975','2014-05-01','14:50:00',2.44),('8975','2014-05-01','14:55:00',2.97),('8975','2014-05-01','15:00:00',6.06),('8975','2014-05-01','15:05:00',4.94),('8975','2014-05-01','15:10:00',6.07),('8975','2014-05-01','15:15:00',4.2),('8975','2014-05-01','15:20:00',2.19),('8975','2014-05-01','15:25:00',1.75),('8975','2014-05-01','15:30:00',3.65),('8975','2014-05-01','15:35:00',6.85),('8975','2014-05-01','15:40:00',3.42),('8975','2014-05-01','15:45:00',1.71),('8975','2014-05-01','15:50:00',1.67),('8975','2014-05-01','15:55:00',1.53),('8975','2014-05-01','16:00:00',2.12),('8975','2014-05-01','16:05:00',2.04),('8975','2014-05-01','16:10:00',1.38),('8975','2014-05-01','16:15:00',2.19),('8975','2014-05-01','16:20:00',2.16),('8975','2014-05-01','16:55:00',1.28),('8975','2014-05-01','17:00:00',1.19),('8975','2014-05-01','17:05:00',1.41),('8975','2014-05-01','17:10:00',1.3),('8975','2014-05-01','17:15:00',1.85),('8975','2014-05-01','17:20:00',1.62),('8975','2014-05-01','17:25:00',1.71),('8975','2014-05-01','17:30:00',1.32),('8975','2014-05-01','17:35:00',1.1),('8975','2014-03-26','07:45:00',1.16),('8975','2014-03-26','07:50:00',1.3),('8975','2014-03-26','07:55:00',2.22),('8975','2014-03-26','08:00:00',2.54),('8975','2014-03-26','08:05:00',2.1),('8975','2014-03-26','09:10:00',1.39),('8975','2014-03-26','09:15:00',1.45),('8975','2014-03-26','09:20:00',1.37),('8975','2014-03-26','09:25:00',1.22),('8975','2014-03-26','09:50:00',1.05),('8975','2014-03-26','09:55:00',1.48),('8975','2014-03-26','10:00:00',1.41),('8975','2014-03-26','10:05:00',1.81),('8975','2014-03-26','10:10:00',1.98),('8975','2014-03-26','10:15:00',1.88),('8975','2014-03-26','10:20:00',2.37),('8975','2014-03-26','10:25:00',2.83),('8975','2014-03-26','10:30:00',3.33),('8975','2014-03-26','10:35:00',3.27),('8975','2014-03-26','10:40:00',3.02),('8975','2014-03-26','10:45:00',1.43),('8975','2014-03-26','10:50:00',1.43),('8975','2014-03-26','10:55:00',2.1),('8975','2014-03-26','11:00:00',1.32),('8975','2014-03-26','11:05:00',3.7),('8975','2014-03-26','11:10:00',5.46),('8975','2014-03-26','11:15:00',5.04),('8975','2014-03-26','11:20:00',2.02),('8975','2014-03-26','11:25:00',1.53),('8975','2014-03-26','11:30:00',1.15),('8975','2014-03-26','11:45:00',1.05),('8975','2014-03-26','11:50:00',1.65),('8975','2014-03-26','11:55:00',2.93),('8975','2014-03-26','12:00:00',1.94),('8975','2014-03-26','12:05:00',2.43),('8975','2014-03-26','12:10:00',2.33),('8975','2014-03-26','12:15:00',1.81),('8975','2014-03-26','12:20:00',1.59),('8975','2014-03-26','12:50:00',1.18),('8975','2014-03-26','12:55:00',1.53),('8975','2014-03-26','13:00:00',1.6),('8975','2014-03-26','13:05:00',2.01),('8975','2014-03-26','13:10:00',2.64),('8975','2014-03-26','13:15:00',3.24),('8975','2014-03-26','13:20:00',3.33),('8975','2014-03-26','13:25:00',3.33),('8975','2014-03-26','13:30:00',2.91),('8975','2014-03-26','13:35:00',2.95),('8975','2014-03-26','13:40:00',2.67),('8975','2014-03-26','13:45:00',2.88),('8975','2014-03-26','13:50:00',3.9),('8975','2014-03-26','13:55:00',4.43),('8975','2014-03-26','14:00:00',2.51),('8975','2014-03-26','14:05:00',1.61),('8975','2014-03-26','14:10:00',2.8),('8975','2014-03-26','14:15:00',4.6),('8975','2014-03-26','14:20:00',5.45),('8975','2014-03-26','14:25:00',4.34),('8975','2014-03-26','14:30:00',3.69),('8975','2014-03-26','14:35:00',3.17),('8975','2014-03-26','14:40:00',2.51),('8975','2014-03-26','14:45:00',2.7),('8975','2014-03-26','14:50:00',2.52),('8975','2014-03-26','14:55:00',2.04),('8975','2014-03-26','15:00:00',3.16),('8975','2014-03-26','15:05:00',1.49),('8975','2014-03-26','15:15:00',1.09),('8975','2014-03-26','15:20:00',2.7),('8975','2014-03-26','15:25:00',3.74),('8975','2014-03-26','15:30:00',2.37),('8975','2014-03-26','15:35:00',2.3),('8975','2014-03-26','15:40:00',1.29),('8975','2014-03-26','15:45:00',1.44),('8975','2014-03-26','15:50:00',1.61),('8975','2014-03-26','15:55:00',1.2),('8975','2014-03-26','16:00:00',1.27),('8975','2014-03-26','16:05:00',1.79),('8975','2014-03-26','16:10:00',2),('8975','2014-03-26','16:15:00',1.47),('8975','2014-03-26','16:20:00',1.3),('8975','2014-03-26','16:25:00',1.63),('8975','2014-03-26','16:30:00',1.29),('8975','2014-03-26','16:35:00',1.4),('8975','2014-03-26','16:40:00',1.4),('8975','2014-03-26','16:45:00',1.41),('8975','2014-03-26','16:50:00',1.01),('8975','2014-03-26','16:55:00',1.06),('8975','2013-03-31','08:00:00',1.15),('8975','2013-03-31','08:15:00',1.22),('8975','2013-03-31','08:20:00',2.59),('8975','2013-03-31','08:25:00',3.31),('8975','2013-03-31','08:30:00',3.58),('8975','2013-03-31','08:35:00',3.56),('8975','2013-03-31','08:40:00',2.63),('8975','2013-03-31','08:45:00',2.04),('8975','2013-03-31','08:50:00',1.8),('8975','2013-03-31','08:55:00',2.56),('8975','2013-03-31','09:00:00',4.15),('8975','2013-03-31','09:05:00',3.77),('8975','2013-03-31','09:10:00',4.31),('8975','2013-03-31','09:15:00',4.25),('8975','2013-03-31','09:20:00',3.89),('8975','2013-03-31','09:25:00',4.43),('8975','2013-03-31','09:30:00',4.64),('8975','2013-03-31','09:35:00',3.76),('8975','2013-03-31','09:40:00',4.31),('8975','2013-03-31','09:45:00',5.08),('8975','2013-03-31','09:50:00',5.01),('8975','2013-03-31','09:55:00',4.79),('8975','2013-03-31','10:00:00',5.44),('8975','2013-03-31','10:05:00',5.02),('8975','2013-03-31','10:10:00',3.5),('8975','2013-03-31','10:15:00',5.17),('8975','2013-03-31','10:20:00',2.52),('8975','2013-03-31','10:25:00',2.31),('8975','2013-03-31','10:30:00',1.93),('8975','2013-03-31','10:35:00',2.7),('8975','2013-03-31','10:40:00',4.27),('8975','2013-03-31','10:45:00',2.49),('8975','2013-03-31','10:50:00',1.46),('8975','2013-03-31','10:55:00',1.74),('8975','2013-03-31','11:00:00',2.6),('8975','2013-03-31','11:05:00',4.59),('8975','2013-03-31','11:10:00',4.41),('8975','2013-03-31','11:15:00',5.43),('8975','2013-03-31','11:20:00',3.73),('8975','2013-03-31','11:25:00',3.75),('8975','2013-03-31','11:30:00',3.54),('8975','2013-03-31','11:35:00',5.12),('8975','2013-03-31','11:40:00',5.91),('8975','2013-03-31','11:45:00',4.89),('8975','2013-03-31','11:50:00',3.86),('8975','2013-03-31','11:55:00',4.18),('8975','2013-03-31','12:00:00',4.52),('8975','2013-03-31','12:05:00',3.11),('8975','2013-03-31','12:10:00',3.3),('8975','2013-03-31','12:15:00',3.73),('8975','2013-03-31','12:20:00',3.08),('8975','2013-03-31','12:25:00',3.13),('8975','2013-03-31','12:30:00',4.04),('8975','2013-03-31','12:35:00',3.71),('8975','2013-03-31','12:40:00',3.85),('8975','2013-03-31','12:45:00',4.59),('8975','2013-03-31','12:50:00',4.78),('8975','2013-03-31','12:55:00',4.25),('8975','2013-03-31','13:00:00',4.17),('8975','2013-03-31','13:05:00',4.2),('8975','2013-03-31','13:10:00',4.14),('8975','2013-03-31','13:15:00',4.79),('8975','2013-03-31','13:20:00',3.67),('8975','2013-03-31','13:25:00',3.9),('8975','2013-03-31','13:30:00',3.94),('8975','2013-03-31','13:35:00',4.67),('8975','2013-03-31','13:40:00',6.88),('8975','2013-03-31','13:45:00',6.35),('8975','2013-03-31','13:50:00',5.5),('8975','2013-03-31','13:55:00',4.96),('8975','2013-03-31','14:00:00',3.92),('8975','2013-03-31','14:05:00',3.1),('8975','2013-03-31','14:10:00',3.96),('8975','2013-03-31','14:15:00',4.15),('8975','2013-03-31','14:20:00',4.46),('8975','2013-03-31','14:25:00',4.67),('8975','2013-03-31','14:30:00',2.66),('8975','2013-03-31','14:35:00',2.91),('8975','2013-03-31','14:40:00',2.67),('8975','2013-03-31','14:45:00',2.74),('8975','2013-03-31','14:50:00',3.03),('8975','2013-03-31','14:55:00',3.14),('8975','2013-03-31','15:00:00',3.02),('8975','2013-03-31','15:05:00',3.14),('8975','2013-03-31','15:10:00',3.15),('8975','2013-03-31','15:15:00',3.24),('8975','2013-03-31','15:20:00',3.34),('8975','2013-03-31','15:25:00',3.17),('8975','2013-03-31','15:30:00',3.19),('8975','2013-03-31','15:35:00',3.56),('8975','2013-03-31','15:40:00',3.39),('8975','2013-03-31','15:45:00',3.58),('8975','2013-03-31','15:50:00',3.61),('8975','2013-03-31','15:55:00',2.68),('8975','2013-03-31','16:00:00',2.59),('8975','2013-03-31','16:05:00',2.16),('8975','2013-03-31','16:10:00',2),('8975','2013-03-31','16:15:00',1.71),('8975','2013-03-31','16:20:00',1.6),('8975','2013-03-31','16:25:00',1.42),('8975','2013-03-31','16:30:00',1.16),('8975','2013-03-31','16:35:00',1.19),('8975','2013-03-31','16:40:00',1.12),('8975','2013-03-30','08:15:00',1.23),('8975','2013-03-30','08:20:00',2.4),('8975','2013-03-30','08:25:00',1.46),('8975','2013-03-30','08:30:00',2.09),('8975','2013-03-30','08:35:00',3.01),('8975','2013-03-30','08:40:00',1.98),('8975','2013-03-30','08:45:00',1.76),('8975','2013-03-30','08:50:00',1.55),('8975','2013-03-30','08:55:00',2.59),('8975','2013-03-30','09:00:00',2.08),('8975','2013-03-30','09:05:00',3.02),('8975','2013-03-30','09:10:00',2.64),('8975','2013-03-30','09:15:00',1.92),('8975','2013-03-30','09:20:00',4.88),('8975','2013-03-30','09:25:00',4.03),('8975','2013-03-30','09:30:00',2.97),('8975','2013-03-30','09:35:00',2.7),('8975','2013-03-30','09:40:00',1.63),('8975','2013-03-30','09:45:00',4.57),('8975','2013-03-30','09:50:00',1.94),('8975','2013-03-30','09:55:00',3.15),('8975','2013-03-30','10:00:00',3.19),('8975','2013-03-30','10:05:00',2.29),('8975','2013-03-30','10:15:00',1.65),('8975','2013-03-30','10:20:00',2.9),('8975','2013-03-30','10:25:00',4.21),('8975','2013-03-30','10:30:00',4.85),('8975','2013-03-30','10:35:00',3.97),('8975','2013-03-30','10:45:00',2.05),('8975','2013-03-30','10:50:00',3.18),('8975','2013-03-30','10:55:00',2.77),('8975','2013-03-30','11:00:00',1.14),('8975','2013-03-30','11:05:00',1.02),('8975','2013-03-30','11:10:00',2.67),('8975','2013-03-30','11:15:00',2.17),('8975','2013-03-30','11:20:00',1.77),('8975','2013-03-30','11:25:00',1.48),('8975','2013-03-30','11:30:00',1.17),('8975','2013-03-30','11:35:00',1.9),('8975','2013-03-30','11:40:00',2.28),('8975','2013-03-30','11:45:00',1.69),('8975','2013-03-30','11:50:00',2.62),('8975','2013-03-30','11:55:00',2.66),('8975','2013-03-30','12:00:00',2.1),('8975','2013-03-30','12:05:00',2.23),('8975','2013-03-30','12:10:00',2.39),('8975','2013-03-30','12:15:00',2.3),('8975','2013-03-30','12:20:00',2.68),('8975','2013-03-30','12:25:00',3.24),('8975','2013-03-30','12:30:00',2.64),('8975','2013-03-30','12:35:00',2.62),('8975','2013-03-30','12:40:00',1.99),('8975','2013-03-30','12:45:00',1.59),('8975','2013-03-30','12:50:00',2.55),('8975','2013-03-30','12:55:00',3.53),('8975','2013-03-30','13:00:00',4.1),('8975','2013-03-30','13:05:00',5.19),('8975','2013-03-30','13:10:00',2.41),('8975','2013-03-30','13:15:00',4.17),('8975','2013-03-30','13:20:00',5.45),('8975','2013-03-30','13:25:00',2.9),('8975','2013-03-30','13:30:00',1.55),('8975','2013-03-30','13:35:00',4.75),('8975','2013-03-30','13:40:00',5.7),('8975','2013-03-30','13:45:00',2.45),('8975','2013-03-30','13:50:00',3.51),('8975','2013-03-30','13:55:00',4.48),('8975','2013-03-30','14:00:00',2.18),('8975','2013-03-30','14:05:00',3.19),('8975','2013-03-30','14:10:00',5.01),('8975','2013-03-30','14:15:00',3.87),('8975','2013-03-30','14:20:00',5.21),('8975','2013-03-30','14:25:00',5.62),('8975','2013-03-30','14:30:00',4.72),('8975','2013-03-30','14:35:00',2.87),('8975','2013-03-30','14:40:00',5.33),('8975','2013-03-30','14:45:00',5.68),('8975','2013-03-30','14:50:00',5.16),('8975','2013-03-30','14:55:00',4.27),('8975','2013-03-30','15:00:00',3.94),('8975','2013-03-30','15:05:00',4.09),('8975','2013-03-30','15:10:00',3.87),('8975','2013-03-30','15:15:00',5.66),('8975','2013-03-30','15:20:00',4.39),('8975','2013-03-30','15:25:00',3.12),('8975','2013-03-30','15:30:00',2.97),('8975','2013-03-30','15:35:00',3.96),('8975','2013-03-30','15:40:00',3.79),('8975','2013-03-30','15:45:00',3.35),('8975','2013-03-30','15:50:00',1.57),('8975','2013-03-30','15:55:00',2.99),('8975','2013-03-30','16:00:00',3.94),('8975','2013-03-30','16:05:00',2.17),('8975','2013-03-30','16:10:00',2.17),('8975','2013-03-30','16:15:00',2.88),('8975','2013-03-30','16:20:00',2.44),('8975','2013-03-30','16:25:00',1.89),('8975','2013-03-30','16:30:00',1.68),('8975','2013-03-30','16:35:00',1.75),('8975','2013-03-30','16:40:00',1.79),('8975','2013-03-30','16:45:00',1.78),('8975','2013-03-30','16:50:00',1.42),('8975','2013-03-30','16:55:00',1.38),('8975','2013-03-30','17:00:00',1.67),('8975','2013-03-30','17:05:00',1.61),('8975','2013-03-30','17:10:00',1.67),('8975','2013-03-30','17:15:00',1.55),('8975','2013-03-30','17:20:00',1.74),('8975','2013-03-30','17:25:00',1.65),('8975','2013-03-30','17:30:00',1.78),('8975','2013-03-30','17:35:00',1.72),('8975','2013-03-30','17:40:00',1.1),('8975','2013-03-30','17:45:00',1.29),('8975','2013-03-30','17:50:00',1.33),('8975','2013-03-30','17:55:00',2.06),('8975','2013-03-30','18:00:00',1.05),('8975','2013-03-30','18:10:00',1.17),('8975','2013-03-30','18:15:00',1.75),('8975','2013-03-29','07:05:00',1.05),('8975','2013-03-29','07:50:00',1.21),('8975','2013-03-29','07:55:00',1.39),('8975','2013-03-29','08:00:00',1.14),('8975','2013-03-29','08:05:00',1.01),('8975','2013-03-29','08:10:00',1.12),('8975','2013-03-29','08:15:00',1.35),('8975','2013-03-29','08:20:00',1.36),('8975','2013-03-29','08:25:00',1.48),('8975','2013-03-29','08:30:00',1.55),('8975','2013-03-29','08:35:00',1.82),('8975','2013-03-29','08:40:00',1.61),('8975','2013-03-29','08:45:00',1.29),('8975','2013-03-29','08:50:00',1.5),('8975','2013-03-29','08:55:00',1.18),('8975','2013-03-29','09:00:00',1.45),('8975','2013-03-29','09:05:00',2.32),('8975','2013-03-29','09:10:00',3.72),('8975','2013-03-29','09:15:00',5.91),('8975','2013-03-29','09:20:00',4.82),('8975','2013-03-29','09:25:00',1.73),('8975','2013-03-29','09:30:00',1.75),('8975','2013-03-29','09:35:00',2.17),('8975','2013-03-29','09:40:00',2.38),('8975','2013-03-29','09:45:00',2.27),('8975','2013-03-29','09:50:00',2.16),('8975','2013-03-29','09:55:00',2.51),('8975','2013-03-29','10:00:00',2.97),('8975','2013-03-29','10:05:00',2.99),('8975','2013-03-29','10:10:00',3.04),('8975','2013-03-29','10:15:00',2.68),('8975','2013-03-29','10:20:00',2.28),('8975','2013-03-29','10:25:00',2.31),('8975','2013-03-29','10:30:00',2.69),('8975','2013-03-29','10:35:00',3.19),('8975','2013-03-29','10:40:00',3.7),('8975','2013-03-29','10:45:00',4.07),('8975','2013-03-29','10:50:00',3.98),('8975','2013-03-29','10:55:00',3.11),('8975','2013-03-29','11:00:00',3.21),('8975','2013-03-29','11:05:00',3.29),('8975','2013-03-29','11:10:00',2.99),('8975','2013-03-29','11:15:00',2.87),('8975','2013-03-29','11:20:00',2.71),('8975','2013-03-29','11:25:00',3.4),('8975','2013-03-29','11:30:00',4.9),('8975','2013-03-29','11:35:00',4.88),('8975','2013-03-29','11:40:00',5.05),('8975','2013-03-29','11:45:00',5.46),('8975','2013-03-29','11:50:00',4.57),('8975','2013-03-29','11:55:00',5.73),('8975','2013-03-29','12:00:00',5.51),('8975','2013-03-29','12:05:00',3.72),('8975','2013-03-29','12:10:00',3.77),('8975','2013-03-29','12:15:00',3.6),('8975','2013-03-29','12:20:00',2.38),('8975','2013-03-29','12:25:00',1.22),('8975','2013-03-29','12:30:00',1.94),('8975','2013-03-29','12:35:00',1.03),('8975','2013-03-29','12:45:00',2.16),('8975','2013-03-29','12:50:00',1.05),('8975','2013-03-29','13:05:00',1.07),('8975','2013-03-29','13:10:00',3),('8975','2013-03-29','13:15:00',3.54),('8975','2013-03-29','13:20:00',2.17),('8975','2013-03-29','13:25:00',1.63),('8975','2013-03-29','13:40:00',1.36),('8975','2013-03-29','13:45:00',3.77),('8975','2013-03-29','13:50:00',3.15),('8975','2013-03-29','13:55:00',1.72),('8975','2013-03-29','14:00:00',1.87),('8975','2013-03-29','14:05:00',1.42),('8975','2013-03-29','14:10:00',1.18),('8975','2013-03-29','14:15:00',1.38),('8975','2013-03-29','14:20:00',1.3),('8975','2013-03-29','14:25:00',1.72),('8975','2013-03-29','14:30:00',2.27),('8975','2013-03-29','14:35:00',1.72),('8975','2013-03-29','14:40:00',1.68),('8975','2013-03-29','14:45:00',1.87),('8975','2013-03-29','14:50:00',1.95),('8975','2013-03-29','14:55:00',1.18),('8975','2013-03-29','15:15:00',1.72),('8975','2013-03-29','15:20:00',1.88),('8975','2013-03-29','15:25:00',1.72),('8975','2013-03-29','15:30:00',1.39),('8975','2013-03-29','15:35:00',1.28),('8975','2013-03-29','15:40:00',1.32),('8975','2013-03-29','15:45:00',1.22),('8975','2013-03-28','06:50:00',1.22),('8975','2013-03-28','06:55:00',1.78),('8975','2013-03-28','07:00:00',2.14),('8975','2013-03-28','07:05:00',2.36),('8975','2013-03-28','07:10:00',2.52),('8975','2013-03-28','07:15:00',2.68),('8975','2013-03-28','07:20:00',2.61),('8975','2013-03-28','07:25:00',2.36),('8975','2013-03-28','07:30:00',3.23),('8975','2013-03-28','07:35:00',3.2),('8975','2013-03-28','07:40:00',3.32),('8975','2013-03-28','07:45:00',3.47),('8975','2013-03-28','07:50:00',2.17),('8975','2013-03-28','07:55:00',2.25),('8975','2013-03-28','08:00:00',2.47),('8975','2013-03-28','08:05:00',3.54),('8975','2013-03-28','08:10:00',4.07),('8975','2013-03-28','08:15:00',4.12),('8975','2013-03-28','08:20:00',4.25),('8975','2013-03-28','08:25:00',4.31),('8975','2013-03-28','08:30:00',4.39),('8975','2013-03-28','08:35:00',4.56),('8975','2013-03-28','08:40:00',4.59),('8975','2013-03-28','08:45:00',4.6),('8975','2013-03-28','08:50:00',4.69),('8975','2013-03-28','08:55:00',3.81),('8975','2013-03-28','09:00:00',4.25),('8975','2013-03-28','09:05:00',4.97),('8975','2013-03-28','09:10:00',4.84),('8975','2013-03-28','09:15:00',5.13),('8975','2013-03-28','09:20:00',5.58),('8975','2013-03-28','09:25:00',5.36),('8975','2013-03-28','09:30:00',5.92),('8975','2013-03-28','09:35:00',5.67),('8975','2013-03-28','09:40:00',5.53),('8975','2013-03-28','09:45:00',5.25),('8975','2013-03-28','09:50:00',4.53),('8975','2013-03-28','09:55:00',5.63),('8975','2013-03-28','10:00:00',5.75),('8975','2013-03-28','10:05:00',5.52),('8975','2013-03-28','10:10:00',4.37),('8975','2013-03-28','10:15:00',5.04),('8975','2013-03-28','10:20:00',5.45),('8975','2013-03-28','10:25:00',5.2),('8975','2013-03-28','10:30:00',5.2),('8975','2013-03-28','10:35:00',5.74),('8975','2013-03-28','10:40:00',6.08),('8975','2013-03-28','10:45:00',5.86),('8975','2013-03-28','10:50:00',5.98),('8975','2013-03-28','10:55:00',5.54),('8975','2013-03-28','11:00:00',6.25),('8975','2013-03-28','11:05:00',6.18),('8975','2013-03-28','11:10:00',6.57),('8975','2013-03-28','11:15:00',6.73),('8975','2013-03-28','11:20:00',6.55),('8975','2013-03-28','11:25:00',6.5),('8975','2013-03-28','11:30:00',6.45),('8975','2013-03-28','11:35:00',6.27),('8975','2013-03-28','11:40:00',6.38),('8975','2013-03-28','11:45:00',6.42),('8975','2013-03-28','11:50:00',6.46),('8975','2013-03-28','11:55:00',6.42),('8975','2013-03-28','12:00:00',6.42),('8975','2013-03-28','12:05:00',6.49),('8975','2013-03-28','12:10:00',6.46),('8975','2013-03-28','12:15:00',6.1),('8975','2013-03-28','12:20:00',6.24),('8975','2013-03-28','12:25:00',6.11),('8975','2013-03-28','12:30:00',5.93),('8975','2013-03-28','12:35:00',6.06),('8975','2013-03-28','12:40:00',5.83),('8975','2013-03-28','12:45:00',5.76),('8975','2013-03-28','12:50:00',5.93),('8975','2013-03-28','12:55:00',4.23),('8975','2013-03-28','13:00:00',5.76),('8975','2013-03-28','13:05:00',5.27),('8975','2013-03-28','13:10:00',5.27),('8975','2013-03-28','13:15:00',5.5),('8975','2013-03-28','13:20:00',5.91),('8975','2013-03-28','13:25:00',6.09),('8975','2013-03-28','13:30:00',5.6),('8975','2013-03-28','13:35:00',4.52),('8975','2013-03-28','13:40:00',4.34),('8975','2013-03-28','13:45:00',4.58),('8975','2013-03-28','13:50:00',4.68),('8975','2013-03-28','13:55:00',4.76),('8975','2013-03-28','14:00:00',4.97),('8975','2013-03-28','14:05:00',4.05),('8975','2013-03-28','14:10:00',3.48),('8975','2013-03-28','14:15:00',3.27),('8975','2013-03-28','14:20:00',3.56),('8975','2013-03-28','14:25:00',3.73),('8975','2013-03-28','14:30:00',3.17),('8975','2013-03-28','14:35:00',3.01),('8975','2013-03-28','14:40:00',2.99),('8975','2013-03-28','14:45:00',2.9),('8975','2013-03-28','14:50:00',2.78),('8975','2013-03-28','14:55:00',2.67),('8975','2013-03-28','15:00:00',2.44),('8975','2013-03-28','15:05:00',2.34),('8975','2013-03-28','15:10:00',2.28),('8975','2013-03-28','15:15:00',2.2),('8975','2013-03-28','15:20:00',2.09),('8975','2013-03-28','15:25:00',1.98),('8975','2013-03-28','15:30:00',1.84),('8975','2013-03-28','15:35:00',1.77),('8975','2013-03-28','15:40:00',1.7),('8975','2013-03-28','15:45:00',1.62),('8975','2013-03-28','15:50:00',1.74),('8975','2013-03-28','15:55:00',1.97),('8975','2013-03-28','16:00:00',2.49),('8975','2013-03-28','16:05:00',2.26),('8975','2013-03-28','16:10:00',1.65),('8975','2013-03-28','16:15:00',1.57),('8975','2013-03-28','16:20:00',1.45),('8975','2013-03-28','16:25:00',1.52),('8975','2013-03-28','16:30:00',1.47),('8975','2013-03-28','16:35:00',1.72),('8975','2013-03-28','16:40:00',2.42),('8975','2013-03-28','16:45:00',2.08),('8975','2013-03-28','16:50:00',1.61),('8975','2013-03-28','16:55:00',1.44),('8975','2013-03-28','17:00:00',1.35),('8975','2013-03-28','17:20:00',1.15),('8975','2013-03-28','17:25:00',1.35),('8975','2013-03-28','17:30:00',1.21),('8975','2013-03-27','07:30:00',1.07),('8975','2013-03-27','07:40:00',1.19),('8975','2013-03-27','08:50:00',1.25),('8975','2013-03-27','08:55:00',1.28),('8975','2013-03-27','09:00:00',1.4),('8975','2013-03-27','09:05:00',2.71),('8975','2013-03-27','09:10:00',7.1),('8975','2013-03-27','09:15:00',3.82),('8975','2013-03-27','09:20:00',2.55),('8975','2013-03-27','09:25:00',1.94),('8975','2013-03-27','09:30:00',1.35),('8975','2013-03-27','09:35:00',1.39),('8975','2013-03-27','09:40:00',1.6),('8975','2013-03-27','09:45:00',1.66),('8975','2013-03-27','09:50:00',1.78),('8975','2013-03-27','09:55:00',1.75),('8975','2013-03-27','10:00:00',1.94),('8975','2013-03-27','10:05:00',1.44),('8975','2013-03-27','10:10:00',1.36),('8975','2013-03-27','10:20:00',1.11),('8975','2013-03-27','10:55:00',1.35),('8975','2013-03-27','11:00:00',1.02),('8975','2013-03-27','11:20:00',1.4),('8975','2013-03-27','11:25:00',1.68),('8975','2013-03-27','11:30:00',2.37),('8975','2013-03-27','11:35:00',2.95),('8975','2013-03-27','11:40:00',3.25),('8975','2013-03-27','11:45:00',2.08),('8975','2013-03-27','11:50:00',3.34),('8975','2013-03-27','11:55:00',3.23),('8975','2013-03-27','12:00:00',2.25),('8975','2013-03-27','12:05:00',1.79),('8975','2013-03-27','12:10:00',2.47),('8975','2013-03-27','12:15:00',2.43),('8975','2013-03-27','12:20:00',1.52),('8975','2013-03-27','12:25:00',1.69),('8975','2013-03-27','12:30:00',1.44),('8975','2013-03-27','12:35:00',1.68),('8975','2013-03-27','12:40:00',2.08),('8975','2013-03-27','12:45:00',3.95),('8975','2013-03-27','12:50:00',6.41),('8975','2013-03-27','12:55:00',4.43),('8975','2013-03-27','13:00:00',5.85),('8975','2013-03-27','13:05:00',4.88),('8975','2013-03-27','13:10:00',4.91),('8975','2013-03-27','13:15:00',3.06),('8975','2013-03-27','13:20:00',2.54),('8975','2013-03-27','13:25:00',3.71),('8975','2013-03-27','13:30:00',3.62),('8975','2013-03-27','13:35:00',3.22),('8975','2013-03-27','13:40:00',3.13),('8975','2013-03-27','13:45:00',4.4),('8975','2013-03-27','13:50:00',3.03),('8975','2013-03-27','13:55:00',2.97),('8975','2013-03-27','14:00:00',3.53),('8975','2013-03-27','14:05:00',2.95),('8975','2013-03-27','14:10:00',2.1),('8975','2013-03-27','14:15:00',2.42),('8975','2013-03-27','14:20:00',3.04),('8975','2013-03-27','14:25:00',3.56),('8975','2013-03-27','14:30:00',2.96),('8975','2013-03-27','14:35:00',2.04),('8975','2013-03-27','14:40:00',2.5),('8975','2013-03-27','14:45:00',2.5),('8975','2013-03-27','14:50:00',1.62),('8975','2013-03-27','14:55:00',1.61),('8975','2013-03-27','15:00:00',2.05),('8975','2013-03-27','15:05:00',2.51),('8975','2013-03-27','15:10:00',3),('8975','2013-03-27','15:15:00',3.12),('8975','2013-03-27','15:20:00',2.41),('8975','2013-03-27','15:25:00',1.55),('8975','2013-03-27','15:30:00',1.86),('8975','2013-03-27','15:35:00',3.16),('8975','2013-03-27','15:40:00',1.97),('8975','2013-03-27','15:45:00',2.17),('8975','2013-03-27','15:50:00',1.94),('8975','2013-03-27','15:55:00',2.53),('8975','2013-03-27','16:00:00',2.01),('8975','2013-03-27','16:05:00',1.51),('8975','2013-03-27','16:10:00',1.2),('8975','2013-03-27','16:25:00',1.16),('8975','2013-03-27','16:30:00',1.84),('8975','2013-03-27','16:35:00',1.35),('8975','2013-03-27','16:40:00',1.06),('8975','2013-03-27','16:45:00',1.24),('8975','2013-03-27','16:55:00',1.16),('8975','2013-03-27','17:00:00',2.04),('8975','2013-03-27','17:05:00',1.73),('8975','2013-03-27','17:10:00',1.33),('8975','2013-03-27','17:15:00',1.18),('8975','2013-03-27','17:20:00',1.06),('8975','2013-03-26','06:35:00',1.03),('8975','2013-03-26','06:40:00',1.21),('8975','2013-03-26','06:45:00',1.42),('8975','2013-03-26','06:50:00',1.45),('8975','2013-03-26','06:55:00',1.71),('8975','2013-03-26','07:00:00',1.78),('8975','2013-03-26','07:05:00',2.05),('8975','2013-03-26','07:10:00',2.39),('8975','2013-03-26','07:15:00',2.58),('8975','2013-03-26','07:20:00',2.66),('8975','2013-03-26','07:25:00',2.71),('8975','2013-03-26','07:30:00',2.65),('8975','2013-03-26','07:35:00',2.64),('8975','2013-03-26','07:40:00',3.15),('8975','2013-03-26','07:45:00',1.74),('8975','2013-03-26','07:50:00',1.28),('8975','2013-03-26','07:55:00',2.97),('8975','2013-03-26','08:00:00',3.06),('8975','2013-03-26','08:05:00',2.73),('8975','2013-03-26','08:10:00',2.75),('8975','2013-03-26','08:15:00',2.65),('8975','2013-03-26','08:20:00',2.52),('8975','2013-03-26','08:25:00',2.97),('8975','2013-03-26','08:30:00',3.98),('8975','2013-03-26','08:35:00',2.73),('8975','2013-03-26','08:40:00',2.02),('8975','2013-03-26','08:45:00',2.24),('8975','2013-03-26','08:50:00',4.35),('8975','2013-03-26','08:55:00',3.47),('8975','2013-03-26','09:00:00',2.23),('8975','2013-03-26','09:05:00',2.27),('8975','2013-03-26','09:10:00',2.45),('8975','2013-03-26','09:15:00',5.51),('8975','2013-03-26','09:20:00',4.21),('8975','2013-03-26','09:25:00',2.92),('8975','2013-03-26','09:30:00',1.98),('8975','2013-03-26','09:35:00',1.88),('8975','2013-03-26','09:40:00',2.06),('8975','2013-03-26','09:45:00',3.14),('8975','2013-03-26','09:50:00',3.99),('8975','2013-03-26','09:55:00',5.55),('8975','2013-03-26','10:00:00',2.57),('8975','2013-03-26','10:05:00',2.33),('8975','2013-03-26','10:10:00',3.34),('8975','2013-03-26','10:15:00',3.04),('8975','2013-03-26','10:20:00',2.91),('8975','2013-03-26','10:25:00',3.54),('8975','2013-03-26','10:30:00',4.21),('8975','2013-03-26','10:35:00',2.69),('8975','2013-03-26','10:40:00',3.49),('8975','2013-03-26','10:45:00',3.06),('8975','2013-03-26','10:50:00',3.33),('8975','2013-03-26','10:55:00',3.13),('8975','2013-03-26','11:00:00',2.86),('8975','2013-03-26','11:05:00',2.78),('8975','2013-03-26','11:10:00',2.82),('8975','2013-03-26','11:15:00',3.04),('8975','2013-03-26','11:20:00',3.08),('8975','2013-03-26','11:25:00',2.96),('8975','2013-03-26','11:30:00',3.22),('8975','2013-03-26','11:35:00',2.9),('8975','2013-03-26','11:40:00',2.83),('8975','2013-03-26','11:45:00',2.91),('8975','2013-03-26','11:50:00',2.87),('8975','2013-03-26','11:55:00',4.73),('8975','2013-03-26','12:00:00',4.57),('8975','2013-03-26','12:05:00',4.54),('8975','2013-03-26','12:10:00',3.29),('8975','2013-03-26','12:15:00',3.52),('8975','2013-03-26','12:20:00',3.5),('8975','2013-03-26','12:25:00',3.1),('8975','2013-03-26','12:30:00',5.76),('8975','2013-03-26','12:35:00',7.98),('8975','2013-03-26','12:40:00',5.72),('8975','2013-03-26','12:45:00',6.55),('8975','2013-03-26','12:50:00',5.91),('8975','2013-03-26','12:55:00',4.06),('8975','2013-03-26','13:00:00',2.95),('8975','2013-03-26','13:05:00',2.78),('8975','2013-03-26','13:10:00',3.55),('8975','2013-03-26','13:15:00',2.58),('8975','2013-03-26','13:20:00',2.58),('8975','2013-03-26','13:25:00',2.45),('8975','2013-03-26','13:30:00',3.41),('8975','2013-03-26','13:35:00',3.03),('8975','2013-03-26','13:40:00',2.79),('8975','2013-03-26','13:45:00',3.6),('8975','2013-03-26','13:50:00',2.92),('8975','2013-03-26','13:55:00',3.21),('8975','2013-03-26','14:00:00',3.09),('8975','2013-03-26','14:05:00',2.6),('8975','2013-03-26','14:10:00',2.54),('8975','2013-03-26','14:15:00',2.92),('8975','2013-03-26','14:20:00',3.68),('8975','2013-03-26','14:25:00',3.3),('8975','2013-03-26','14:30:00',2.41),('8975','2013-03-26','14:35:00',2.92),('8975','2013-03-26','14:40:00',3.95),('8975','2013-03-26','14:45:00',3.76),('8975','2013-03-26','14:50:00',2.62),('8975','2013-03-26','14:55:00',2.14),('8975','2013-03-26','15:00:00',1.43),('8975','2013-03-26','15:05:00',1.61),('8975','2013-03-26','15:10:00',1.73),('8975','2013-03-26','15:15:00',1.47),('8975','2013-03-26','15:20:00',1.51),('8975','2013-03-26','15:25:00',1.09),('8975','2013-03-26','15:55:00',1.02),('8975','2013-03-26','16:00:00',1.16),('8975','2013-03-26','16:05:00',1.14),('8975','2013-03-26','16:10:00',1.08),('8975','2013-03-26','16:15:00',1.04),('8975','2013-03-26','16:20:00',1.02),('8975','2013-03-26','16:25:00',1.04),('8975','2013-03-26','16:30:00',1.05),('8975','2013-03-26','16:35:00',1.06),('8975','2013-03-26','16:40:00',1.18),('8975','2013-03-26','16:45:00',1.4),('8975','2013-03-26','16:50:00',1.54),('8975','2013-03-26','16:55:00',2.07),('8975','2013-03-26','17:00:00',1.77),('8975','2013-03-26','17:05:00',1.89),('8975','2013-03-26','17:10:00',1.7),('8975','2013-03-26','17:15:00',1.36),('8975','2013-03-25','07:20:00',1.01),('8975','2013-03-25','07:40:00',1.25),('8975','2013-03-25','07:45:00',1.61),('8975','2013-03-25','07:50:00',2.3),('8975','2013-03-25','07:55:00',1.45),('8975','2013-03-25','08:00:00',1.07),('8975','2013-03-25','08:10:00',1.32),('8975','2013-03-25','08:25:00',1.19),('8975','2013-03-25','08:30:00',1.88),('8975','2013-03-25','08:35:00',2.38),('8975','2013-03-25','08:40:00',2.53),('8975','2013-03-25','08:45:00',1.29),('8975','2013-03-25','09:05:00',1.24),('8975','2013-03-25','09:10:00',2.15),('8975','2013-03-25','09:15:00',2.86),('8975','2013-03-25','09:20:00',1.88),('8975','2013-03-25','09:35:00',1.44),('8975','2013-03-25','09:40:00',3.1),('8975','2013-03-25','09:45:00',3.76),('8975','2013-03-25','09:50:00',1.87),('8975','2013-03-25','09:55:00',2.29),('8975','2013-03-25','10:00:00',3.01),('8975','2013-03-25','10:05:00',4.4),('8975','2013-03-25','10:10:00',3.38),('8975','2013-03-25','10:15:00',2.89),('8975','2013-03-25','10:20:00',4.04),('8975','2013-03-25','10:25:00',2.65),('8975','2013-03-25','10:30:00',1.11),('8975','2013-03-25','10:40:00',1.12),('8975','2013-03-25','10:45:00',2.03),('8975','2013-03-25','10:50:00',2.9),('8975','2013-03-25','10:55:00',1.79),('8975','2013-03-25','11:00:00',2.13),('8975','2013-03-25','11:05:00',2.3),('8975','2013-03-25','11:10:00',2.88),('8975','2013-03-25','11:15:00',3.86),('8975','2013-03-25','11:20:00',3.6),('8975','2013-03-25','11:25:00',2.86),('8975','2013-03-25','11:30:00',1.81),('8975','2013-03-25','11:40:00',1.05),('8975','2013-03-25','11:45:00',2.55),('8975','2013-03-25','11:50:00',4.37),('8975','2013-03-25','11:55:00',2.6),('8975','2013-03-25','12:00:00',2.94),('8975','2013-03-25','12:05:00',2.07),('8975','2013-03-25','12:10:00',2.02),('8975','2013-03-25','12:15:00',2.24),('8975','2013-03-25','12:20:00',2.18),('8975','2013-03-25','12:25:00',2.69),('8975','2013-03-25','12:30:00',2.49),('8975','2013-03-25','12:35:00',4.53),('8975','2013-03-25','12:40:00',3.82),('8975','2013-03-25','12:45:00',3.8),('8975','2013-03-25','12:50:00',3.09),('8975','2013-03-25','12:55:00',1.93),('8975','2013-03-25','13:00:00',3.19),('8975','2013-03-25','13:05:00',3.21),('8975','2013-03-25','13:10:00',2.91),('8975','2013-03-25','13:15:00',2.34),('8975','2013-03-25','13:20:00',2.74),('8975','2013-03-25','13:25:00',3.78),('8975','2013-03-25','13:30:00',2.96),('8975','2013-03-25','13:35:00',2.84),('8975','2013-03-25','13:40:00',2.79),('8975','2013-03-25','13:45:00',2.69),('8975','2013-03-25','13:50:00',2.44),('8975','2013-03-25','13:55:00',2.43),('8975','2013-03-25','14:00:00',2.31),('8975','2013-03-25','14:05:00',2.29),('8975','2013-03-25','14:10:00',2.12),('8975','2013-03-25','14:15:00',1.96),('8975','2013-03-25','14:20:00',1.75),('8975','2013-03-25','14:25:00',1.42),('8975','2013-03-25','14:30:00',1.24),('8975','2013-03-25','14:35:00',1.3),('8975','2013-03-25','14:40:00',1.44),('8975','2013-03-25','14:45:00',1.42),('8975','2013-03-25','14:50:00',1.33),('8975','2013-03-25','14:55:00',1.35),('8975','2013-03-25','15:00:00',1.38),('8975','2013-03-25','15:05:00',1.37),('8975','2013-03-25','15:10:00',1.24),('8975','2013-03-25','15:15:00',1.2),('8975','2013-03-25','15:20:00',1.3),('8975','2013-03-25','15:25:00',1.32),('8975','2013-03-25','15:30:00',1.43),('8975','2013-03-25','15:35:00',1.45),('8975','2013-03-25','15:40:00',1.34),('8975','2013-03-24','08:10:00',1.44),('8975','2013-03-24','08:15:00',2.96),('8975','2013-03-24','08:20:00',4.59),('8975','2013-03-24','08:25:00',3.06),('8975','2013-03-24','08:30:00',1.21),('8975','2013-03-24','08:35:00',1.15),('8975','2013-03-24','08:40:00',2.11),('8975','2013-03-24','08:45:00',2.11),('8975','2013-03-24','08:50:00',1.71),('8975','2013-03-24','08:55:00',2.3),('8975','2013-03-24','09:00:00',2.03),('8975','2013-03-24','09:05:00',1.59),('8975','2013-03-24','09:10:00',1.81),('8975','2013-03-24','09:15:00',2.69),('8975','2013-03-24','09:20:00',4.76),('8975','2013-03-24','09:25:00',2.39),('8975','2013-03-24','09:30:00',1.97),('8975','2013-03-24','09:35:00',1.31),('8975','2013-03-24','09:40:00',1.03),('8975','2013-03-24','09:45:00',2.92),('8975','2013-03-24','09:50:00',7.75),('8975','2013-03-24','09:55:00',7.1),('8975','2013-03-24','10:00:00',5.14),('8975','2013-03-24','10:05:00',3.41),('8975','2013-03-24','10:10:00',1.7),('8975','2013-03-24','10:15:00',2.6),('8975','2013-03-24','10:20:00',2.84),('8975','2013-03-24','10:25:00',4.94),('8975','2013-03-24','10:30:00',4.14),('8975','2013-03-24','10:35:00',3.52),('8975','2013-03-24','10:40:00',4.88),('8975','2013-03-24','10:45:00',5.82),('8975','2013-03-24','10:50:00',6.25),('8975','2013-03-24','10:55:00',5.56),('8975','2013-03-24','11:00:00',6.1),('8975','2013-03-24','11:05:00',6.39),('8975','2013-03-24','11:10:00',2.94),('8975','2013-03-24','11:15:00',7.11),('8975','2013-03-24','11:20:00',7.3),('8975','2013-03-24','11:25:00',6.58),('8975','2013-03-24','11:30:00',7.23),('8975','2013-03-24','11:35:00',4.99),('8975','2013-03-24','11:40:00',3.43),('8975','2013-03-24','11:45:00',2.91),('8975','2013-03-24','11:50:00',6.93),('8975','2013-03-24','11:55:00',7.07),('8975','2013-03-24','12:00:00',5.86),('8975','2013-03-24','12:05:00',5.31),('8975','2013-03-24','12:10:00',4.61),('8975','2013-03-24','12:15:00',4.1),('8975','2013-03-24','12:20:00',3.69),('8975','2013-03-24','12:25:00',3.85),('8975','2013-03-24','12:30:00',4.65),('8975','2013-03-24','12:35:00',4.58),('8975','2013-03-24','12:40:00',4.35),('8975','2013-03-24','12:45:00',4.29),('8975','2013-03-24','12:50:00',4.1),('8975','2013-03-24','12:55:00',3.45),('8975','2013-03-24','13:00:00',6.88),('8975','2013-03-24','13:05:00',4.5),('8975','2013-03-24','13:10:00',4.72),('8975','2013-03-24','13:15:00',6.59),('8975','2013-03-24','13:20:00',3.28),('8975','2013-03-24','13:25:00',5.08),('8975','2013-03-24','13:30:00',2.5),('8975','2013-03-24','13:35:00',1.88),('8975','2013-03-24','13:40:00',2.03),('8975','2013-03-24','13:45:00',3.14),('8975','2013-03-24','13:50:00',2.92),('8975','2013-03-24','13:55:00',2.03),('8975','2013-03-24','14:00:00',1.6),('8975','2013-03-24','14:05:00',2.31),('8975','2013-03-24','14:10:00',3.53),('8975','2013-03-24','14:15:00',1.6),('8975','2013-03-24','14:20:00',2.7),('8975','2013-03-24','14:25:00',4.29),('8975','2013-03-24','14:30:00',5.8),('8975','2013-03-24','14:35:00',4.95),('8975','2013-03-24','14:40:00',2.91),('8975','2013-03-24','14:45:00',2.32),('8975','2013-03-24','14:50:00',2.15),('8975','2013-03-24','14:55:00',2.65),('8975','2013-03-24','15:00:00',3.09),('8975','2013-03-24','15:05:00',2.81),('8975','2013-03-24','15:10:00',2.72),('8975','2013-03-24','15:15:00',2.96),('8975','2013-03-24','15:20:00',2.53),('8975','2013-03-24','15:25:00',2.28),('8975','2013-03-24','15:30:00',2.85),('8975','2013-03-24','15:35:00',3.55),('8975','2013-03-24','15:40:00',3.13),('8975','2013-03-24','15:45:00',2.56),('8975','2013-03-24','15:50:00',2.19),('8975','2013-03-24','15:55:00',3.11),('8975','2013-03-24','16:00:00',2.92),('8975','2013-03-24','16:05:00',2.31),('8975','2013-03-24','16:10:00',1.77),('8975','2013-03-24','16:15:00',1.48),('8975','2013-03-24','16:20:00',1.19),('8975','2013-03-24','16:25:00',1.5),('8975','2013-03-24','16:30:00',2.22),('8975','2013-03-24','16:35:00',2.23),('8975','2013-03-24','16:40:00',2.05),('8975','2013-03-24','16:45:00',1.92),('8975','2013-03-24','16:50:00',1.64),('8975','2013-03-23','06:55:00',1.17),('8975','2013-03-23','07:00:00',1.2),('8975','2013-03-23','07:05:00',1.65),('8975','2013-03-23','07:10:00',1.92),('8975','2013-03-23','07:15:00',1.85),('8975','2013-03-23','07:20:00',2.2),('8975','2013-03-23','07:25:00',2.02),('8975','2013-03-23','07:30:00',2.15),('8975','2013-03-23','07:35:00',2.33),('8975','2013-03-23','07:40:00',2.29),('8975','2013-03-23','07:45:00',2.65),('8975','2013-03-23','07:50:00',2.85),('8975','2013-03-23','07:55:00',3.37),('8975','2013-03-23','08:00:00',3.6),('8975','2013-03-23','08:05:00',3.63),('8975','2013-03-23','08:10:00',3.7),('8975','2013-03-23','08:15:00',3.84),('8975','2013-03-23','08:20:00',3.99),('8975','2013-03-23','08:25:00',4.09),('8975','2013-03-23','08:30:00',4.16),('8975','2013-03-23','08:35:00',4.26),('8975','2013-03-23','08:40:00',4.33),('8975','2013-03-23','08:45:00',4.39),('8975','2013-03-23','08:50:00',4.44),('8975','2013-03-23','08:55:00',4.55),('8975','2013-03-23','09:00:00',4.62),('8975','2013-03-23','09:05:00',4.72),('8975','2013-03-23','09:10:00',4.79),('8975','2013-03-23','09:15:00',4.84),('8975','2013-03-23','09:20:00',4.95),('8975','2013-03-23','09:25:00',5.02),('8975','2013-03-23','09:30:00',5.08),('8975','2013-03-23','09:35:00',5.14),('8975','2013-03-23','09:40:00',5.23),('8975','2013-03-23','09:45:00',5.29),('8975','2013-03-23','09:50:00',5.36),('8975','2013-03-23','09:55:00',5.4),('8975','2013-03-23','10:00:00',5.48),('8975','2013-03-23','10:05:00',5.52),('8975','2013-03-23','10:10:00',5.56),('8975','2013-03-23','10:15:00',5.57),('8975','2013-03-23','10:20:00',5.65),('8975','2013-03-23','10:25:00',5.66),('8975','2013-03-23','10:30:00',5.69),('8975','2013-03-23','10:35:00',5.71),('8975','2013-03-23','10:40:00',5.73),('8975','2013-03-23','10:45:00',5.78),('8975','2013-03-23','10:50:00',5.83),('8975','2013-03-23','10:55:00',5.87),('8975','2013-03-23','11:00:00',5.9),('8975','2013-03-23','11:05:00',5.86),('8975','2013-03-23','11:10:00',5.9),('8975','2013-03-23','11:15:00',5.83),('8975','2013-03-23','11:20:00',5.83),('8975','2013-03-23','11:25:00',5.87),('8975','2013-03-23','11:30:00',5.85),('8975','2013-03-23','11:35:00',5.84),('8975','2013-03-23','11:40:00',5.82),('8975','2013-03-23','11:45:00',5.82),('8975','2013-03-23','11:50:00',5.79),('8975','2013-03-23','11:55:00',5.82),('8975','2013-03-23','12:00:00',5.83),('8975','2013-03-23','12:05:00',5.89),('8975','2013-03-23','12:10:00',5.92),('8975','2013-03-23','12:15:00',5.91),('8975','2013-03-23','12:20:00',5.94),('8975','2013-03-23','12:25:00',5.88),('8975','2013-03-23','12:30:00',5.84),('8975','2013-03-23','12:35:00',5.81),('8975','2013-03-23','12:40:00',5.71),('8975','2013-03-23','12:45:00',5.73),('8975','2013-03-23','12:50:00',5.61),('8975','2013-03-23','12:55:00',5.53),('8975','2013-03-23','13:00:00',5.5),('8975','2013-03-23','13:05:00',5.48),('8975','2013-03-23','13:10:00',5.43),('8975','2013-03-23','13:15:00',5.34),('8975','2013-03-23','13:20:00',5.24),('8975','2013-03-23','13:25:00',5.1),('8975','2013-03-23','13:30:00',4.93),('8975','2013-03-23','13:35:00',4.95),('8975','2013-03-23','13:40:00',4.92),('8975','2013-03-23','13:45:00',4.79),('8975','2013-03-23','13:50:00',4.72),('8975','2013-03-23','13:55:00',4.61),('8975','2013-03-23','14:00:00',4.5),('8975','2013-03-23','14:05:00',4.37),('8975','2013-03-23','14:10:00',4.23),('8975','2013-03-23','14:15:00',4.08),('8975','2013-03-23','14:20:00',3.98),('8975','2013-03-23','14:25:00',3.86),('8975','2013-03-23','14:30:00',3.73),('8975','2013-03-23','14:35:00',3.63),('8975','2013-03-23','14:40:00',3.54),('8975','2013-03-23','14:45:00',3.4),('8975','2013-03-23','14:50:00',3.21),('8975','2013-03-23','14:55:00',3.26),('8975','2013-03-23','15:00:00',3.14),('8975','2013-03-23','15:05:00',3.07),('8975','2013-03-23','15:10:00',2.86),('8975','2013-03-23','15:15:00',3.08),('8975','2013-03-23','15:20:00',2.9),('8975','2013-03-23','15:25:00',2.63),('8975','2013-03-23','15:30:00',2.39),('8975','2013-03-23','15:35:00',2.39),('8975','2013-03-23','15:40:00',2.32),('8975','2013-03-23','15:45:00',1.75),('8975','2013-03-23','15:50:00',1.61),('8975','2013-03-23','15:55:00',1.55),('8975','2013-03-23','16:00:00',1.63),('8975','2013-03-23','16:05:00',1.73),('8975','2013-03-23','16:10:00',1.48),('8975','2013-03-23','16:15:00',1.61),('8975','2013-03-23','16:20:00',1.44),('8975','2013-03-23','16:25:00',1.66),('8975','2013-03-23','16:30:00',1.4),('8975','2013-03-23','16:35:00',1.39),('8975','2013-03-23','16:40:00',1.18),('8975','2013-03-23','16:45:00',1.18),('8975','2013-03-22','06:45:00',1.04),('8975','2013-03-22','06:50:00',1.32),('8975','2013-03-22','06:55:00',1.54),('8975','2013-03-22','07:00:00',1.65),('8975','2013-03-22','07:05:00',1.37),('8975','2013-03-22','07:10:00',1.63),('8975','2013-03-22','07:15:00',2.36),('8975','2013-03-22','07:20:00',2.4),('8975','2013-03-22','07:25:00',2.38),('8975','2013-03-22','07:30:00',2.5),('8975','2013-03-22','07:35:00',2.52),('8975','2013-03-22','07:40:00',2.7),('8975','2013-03-22','07:45:00',2.28),('8975','2013-03-22','07:50:00',2.61),('8975','2013-03-22','07:55:00',2.43),('8975','2013-03-22','08:00:00',3.41),('8975','2013-03-22','08:05:00',3.52),('8975','2013-03-22','08:10:00',3.79),('8975','2013-03-22','08:15:00',3.94),('8975','2013-03-22','08:20:00',4.01),('8975','2013-03-22','08:25:00',4.06),('8975','2013-03-22','08:30:00',4.17),('8975','2013-03-22','08:35:00',4.25),('8975','2013-03-22','08:40:00',4.44),('8975','2013-03-22','08:45:00',4.49),('8975','2013-03-22','08:50:00',4.59),('8975','2013-03-22','08:55:00',4.81),('8975','2013-03-22','09:00:00',4.87),('8975','2013-03-22','09:05:00',5),('8975','2013-03-22','09:10:00',5.03),('8975','2013-03-22','09:15:00',5.11),('8975','2013-03-22','09:20:00',5.13),('8975','2013-03-22','09:25:00',5.31),('8975','2013-03-22','09:30:00',5.39),('8975','2013-03-22','09:35:00',5.42),('8975','2013-03-22','09:40:00',5.29),('8975','2013-03-22','09:45:00',5.46),('8975','2013-03-22','09:50:00',5.4),('8975','2013-03-22','09:55:00',5.56),('8975','2013-03-22','10:00:00',5.5),('8975','2013-03-22','10:05:00',5.64),('8975','2013-03-22','10:10:00',5.79),('8975','2013-03-22','10:15:00',5.81),('8975','2013-03-22','10:20:00',5.68),('8975','2013-03-22','10:25:00',5.73),('8975','2013-03-22','10:30:00',5.92),('8975','2013-03-22','10:35:00',5.94),('8975','2013-03-22','10:40:00',5.83),('8975','2013-03-22','10:45:00',5.79),('8975','2013-03-22','10:50:00',5.76),('8975','2013-03-22','10:55:00',5.69),('8975','2013-03-22','11:00:00',5.43),('8975','2013-03-22','11:05:00',5.81),('8975','2013-03-22','11:10:00',5.03),('8975','2013-03-22','11:15:00',4.64),('8975','2013-03-22','11:20:00',5),('8975','2013-03-22','11:25:00',5.51),('8975','2013-03-22','11:30:00',5.64),('8975','2013-03-22','11:35:00',5.93),('8975','2013-03-22','11:40:00',5.83),('8975','2013-03-22','11:45:00',5.77),('8975','2013-03-22','11:50:00',5.65),('8975','2013-03-22','11:55:00',5.81),('8975','2013-03-22','12:00:00',6.01),('8975','2013-03-22','12:05:00',6.05),('8975','2013-03-22','12:10:00',6.03),('8975','2013-03-22','12:15:00',6),('8975','2013-03-22','12:20:00',6.04),('8975','2013-03-22','12:25:00',5.7),('8975','2013-03-22','12:30:00',5.87),('8975','2013-03-22','12:35:00',5.86),('8975','2013-03-22','12:40:00',5.6),('8975','2013-03-22','12:45:00',5.63),('8975','2013-03-22','12:50:00',5.66),('8975','2013-03-22','12:55:00',5.27),('8975','2013-03-22','13:00:00',4.85),('8975','2013-03-22','13:05:00',5.57),('8975','2013-03-22','13:10:00',5.39),('8975','2013-03-22','13:15:00',5.38),('8975','2013-03-22','13:20:00',5.18),('8975','2013-03-22','13:25:00',4.96),('8975','2013-03-22','13:30:00',4.81),('8975','2013-03-22','13:35:00',4.86),('8975','2013-03-22','13:40:00',4.78),('8975','2013-03-22','13:45:00',4.73),('8975','2013-03-22','13:50:00',4.64),('8975','2013-03-22','13:55:00',4.55),('8975','2013-03-22','14:00:00',4.48),('8975','2013-03-22','14:05:00',4.35),('8975','2013-03-22','14:10:00',4.09),('8975','2013-03-22','14:15:00',3.92),('8975','2013-03-22','14:20:00',3.9),('8975','2013-03-22','14:25:00',3.68),('8975','2013-03-22','14:30:00',3.93),('8975','2013-03-22','14:35:00',3.8),('8975','2013-03-22','14:40:00',3.55),('8975','2013-03-22','14:45:00',3.46),('8975','2013-03-22','14:50:00',3.32),('8975','2013-03-22','14:55:00',3.3),('8975','2013-03-22','15:00:00',2.82),('8975','2013-03-22','15:05:00',3.09),('8975','2013-03-22','15:10:00',2.98),('8975','2013-03-22','15:15:00',2.76),('8975','2013-03-22','15:20:00',2.82),('8975','2013-03-22','15:25:00',2.59),('8975','2013-03-22','15:30:00',2.44),('8975','2013-03-22','15:35:00',2.38),('8975','2013-03-22','15:40:00',2.28),('8975','2013-03-22','15:45:00',2.03),('8975','2013-03-22','15:50:00',1.99),('8975','2013-03-22','15:55:00',1.97),('8975','2013-03-22','16:00:00',1.78),('8975','2013-03-22','16:05:00',1.86),('8975','2013-03-22','16:10:00',2.07),('8975','2013-03-22','16:15:00',1.85),('8975','2013-03-22','16:20:00',1.68),('8975','2013-03-22','16:25:00',1.68),('8975','2013-03-22','16:30:00',1.35),('8975','2013-03-22','16:35:00',1.48),('8975','2013-03-22','16:40:00',1.35),('8975','2013-03-22','16:45:00',1.32),('8975','2013-03-22','16:50:00',1.16),('8975','2013-03-22','16:55:00',1.2),('8975','2013-03-22','17:00:00',1.43),('8975','2013-03-22','17:05:00',1.4),('8975','2013-03-22','17:10:00',1.28),('8975','2013-03-22','17:15:00',1.1),('8975','2014-03-25','06:35:00',1.08),('8975','2014-03-25','06:40:00',1.38),('8975','2014-03-25','06:45:00',1.52),('8975','2014-03-25','06:50:00',1.57),('8975','2014-03-25','06:55:00',1.86),('8975','2014-03-25','07:00:00',2.18),('8975','2014-03-25','07:05:00',2.16),('8975','2014-03-25','07:10:00',2.5),('8975','2014-03-25','07:15:00',2.61),('8975','2014-03-25','07:20:00',2.73),('8975','2014-03-25','07:25:00',2.92),('8975','2014-03-25','07:30:00',3.08),('8975','2014-03-25','07:35:00',3.2),('8975','2014-03-25','07:40:00',3.31),('8975','2014-03-25','07:45:00',3.41),('8975','2014-03-25','07:50:00',3.5),('8975','2014-03-25','07:55:00',3.63),('8975','2014-03-25','08:00:00',3.73),('8975','2014-03-25','08:05:00',3.85),('8975','2014-03-25','08:10:00',4.06),('8975','2014-03-25','08:15:00',4.48),('8975','2014-03-25','08:20:00',1.95),('8975','2014-03-25','08:25:00',1.92),('8975','2014-03-25','08:30:00',1.59),('8975','2014-03-25','08:35:00',1.51),('8975','2014-03-25','08:40:00',1.97),('8975','2014-03-25','08:45:00',2.01),('8975','2014-03-25','08:50:00',2.33),('8975','2014-03-25','08:55:00',2.24),('8975','2014-03-25','09:00:00',2.24),('8975','2014-03-25','09:05:00',2.38),('8975','2014-03-25','09:10:00',2.99),('8975','2014-03-25','09:15:00',2.61),('8975','2014-03-25','09:20:00',2.09),('8975','2014-03-25','09:25:00',3.98),('8975','2014-03-25','09:30:00',5.57),('8975','2014-03-25','09:35:00',5.5),('8975','2014-03-25','09:40:00',5.6),('8975','2014-03-25','09:45:00',2.05),('8975','2014-03-25','09:50:00',5.11),('8975','2014-03-25','09:55:00',6.2),('8975','2014-03-25','10:00:00',4.87),('8975','2014-03-25','10:05:00',6.47),('8975','2014-03-25','10:10:00',6.03),('8975','2014-03-25','10:15:00',5.84),('8975','2014-03-25','10:20:00',4.68),('8975','2014-03-25','10:25:00',5.67),('8975','2014-03-25','10:30:00',4.01),('8975','2014-03-25','10:35:00',1.85),('8975','2014-03-25','10:40:00',3.91),('8975','2014-03-25','10:45:00',7.61),('8975','2014-03-25','10:50:00',6.34),('8975','2014-03-25','10:55:00',5.91),('8975','2014-03-25','11:00:00',4.46),('8975','2014-03-25','11:05:00',7.73),('8975','2014-03-25','11:10:00',7.43),('8975','2014-03-25','11:15:00',3.77),('8975','2014-03-25','11:20:00',1.76),('8975','2014-03-25','11:25:00',1.84),('8975','2014-03-25','11:30:00',2.68),('8975','2014-03-25','11:35:00',2.61),('8975','2014-03-25','11:40:00',3.46),('8975','2014-03-25','11:45:00',4.07),('8975','2014-03-25','11:50:00',3.39),('8975','2014-03-25','11:55:00',6.96),('8975','2014-03-25','12:00:00',2.71),('8975','2014-03-25','12:05:00',6.2),('8975','2014-03-25','12:10:00',2.92),('8975','2014-03-25','12:15:00',4.6),('8975','2014-03-25','12:20:00',3.21),('8975','2014-03-25','12:25:00',2.51),('8975','2014-03-25','12:30:00',2.72),('8975','2014-03-25','12:35:00',2.58),('8975','2014-03-25','12:40:00',2.72),('8975','2014-03-25','12:45:00',2.27),('8975','2014-03-25','12:50:00',1.98),('8975','2014-03-25','12:55:00',1.73),('8975','2014-03-25','13:00:00',1.84),('8975','2014-03-25','13:05:00',1.56),('8975','2014-03-25','13:10:00',1.15),('8975','2014-03-25','13:15:00',1),('8975','2014-03-25','13:20:00',2.72),('8975','2014-03-25','13:25:00',2.61),('8975','2014-03-25','13:30:00',2.15),('8975','2014-03-25','13:35:00',3.05),('8975','2014-03-25','13:40:00',1.47),('8975','2014-03-25','13:45:00',1.28),('8975','2014-03-25','13:50:00',1.87),('8975','2014-03-25','13:55:00',3.57),('8975','2014-03-25','14:00:00',3.28),('8975','2014-03-25','14:05:00',4.51),('8975','2014-03-25','14:10:00',2.95),('8975','2014-03-25','14:15:00',1.73),('8975','2014-03-25','14:20:00',1.58),('8975','2014-03-25','14:25:00',1.44),('8975','2014-03-25','14:30:00',1.25),('8975','2014-03-25','14:35:00',1.26),('8975','2014-03-25','14:40:00',1.92),('8975','2014-03-25','14:45:00',2.84),('8975','2014-03-25','14:50:00',3.6),('8975','2014-03-25','14:55:00',3.82),('8975','2014-03-25','15:00:00',3.6),('8975','2014-03-25','15:05:00',3.42),('8975','2014-03-25','15:10:00',3.49),('8975','2014-03-25','15:15:00',3.58),('8975','2014-03-25','15:20:00',3.12),('8975','2014-03-25','15:25:00',3.45),('8975','2014-03-25','15:30:00',3.4),('8975','2014-03-25','15:35:00',3.03),('8975','2014-03-25','15:40:00',2.69),('8975','2014-03-25','15:45:00',2.19),('8975','2014-03-25','15:50:00',2.14),('8975','2014-03-25','15:55:00',1.82),('8975','2014-03-25','16:00:00',1.34),('8975','2014-03-25','16:05:00',1.32),('8975','2014-03-25','16:10:00',1.44),('8975','2014-03-25','16:15:00',1.68),('8975','2014-03-25','16:20:00',1.58),('8975','2014-03-25','16:25:00',1.16),('8975','2014-03-25','16:30:00',1.15),('8975','2013-03-21','06:45:00',1.07),('8975','2013-03-21','06:50:00',1.11),('8975','2013-03-21','06:55:00',1.41),('8975','2013-03-21','07:00:00',1.71),('8975','2013-03-21','07:05:00',1.3),('8975','2013-03-21','07:10:00',2.02),('8975','2013-03-21','07:15:00',2.2),('8975','2013-03-21','07:20:00',2.34),('8975','2013-03-21','07:25:00',2.59),('8975','2013-03-21','07:30:00',2.65),('8975','2013-03-21','07:35:00',3.06),('8975','2013-03-21','07:40:00',3.19),('8975','2013-03-21','07:45:00',3.27),('8975','2013-03-21','07:50:00',3.39),('8975','2013-03-21','07:55:00',3.49),('8975','2013-03-21','08:00:00',3.57),('8975','2013-03-21','08:05:00',3.69),('8975','2013-03-21','08:10:00',3.78),('8975','2013-03-21','08:15:00',3.9),('8975','2013-03-21','08:20:00',4.01),('8975','2013-03-21','08:25:00',4.12),('8975','2013-03-21','08:30:00',4.21),('8975','2013-03-21','08:35:00',4.34),('8975','2013-03-21','08:40:00',4.43),('8975','2013-03-21','08:45:00',4.49),('8975','2013-03-21','08:50:00',4.64),('8975','2013-03-21','08:55:00',4.67),('8975','2013-03-21','09:00:00',4.75),('8975','2013-03-21','09:05:00',4.82),('8975','2013-03-21','09:10:00',4.91),('8975','2013-03-21','09:15:00',4.99),('8975','2013-03-21','09:20:00',5.08),('8975','2013-03-21','09:25:00',5.16),('8975','2013-03-21','09:30:00',5.15),('8975','2013-03-21','09:35:00',5.37),('8975','2013-03-21','09:40:00',5.41),('8975','2013-03-21','09:45:00',5.42),('8975','2013-03-21','09:50:00',5.55),('8975','2013-03-21','09:55:00',5.61),('8975','2013-03-21','10:00:00',5.64),('8975','2013-03-21','10:05:00',5.74),('8975','2013-03-21','10:10:00',5.81),('8975','2013-03-21','10:15:00',5.83),('8975','2013-03-21','10:20:00',5.85),('8975','2013-03-21','10:25:00',5.94),('8975','2013-03-21','10:30:00',5.94),('8975','2013-03-21','10:35:00',5.99),('8975','2013-03-21','10:40:00',6.03),('8975','2013-03-21','10:45:00',6.04),('8975','2013-03-21','10:50:00',6.04),('8975','2013-03-21','10:55:00',6.1),('8975','2013-03-21','11:00:00',6.11),('8975','2013-03-21','11:05:00',6.16),('8975','2013-03-21','11:10:00',6.16),('8975','2013-03-21','11:15:00',6.12),('8975','2013-03-21','11:20:00',6.14),('8975','2013-03-21','11:25:00',6.15),('8975','2013-03-21','11:30:00',6.15),('8975','2013-03-21','11:35:00',6.14),('8975','2013-03-21','11:40:00',6.18),('8975','2013-03-21','11:45:00',6.17),('8975','2013-03-21','11:50:00',6.15),('8975','2013-03-21','11:55:00',6.11),('8975','2013-03-21','12:00:00',6.16),('8975','2013-03-21','12:05:00',6.14),('8975','2013-03-21','12:10:00',6.11),('8975','2013-03-21','12:15:00',6.09),('8975','2013-03-21','12:20:00',6.06),('8975','2013-03-21','12:25:00',6.04),('8975','2013-03-21','12:30:00',5.98),('8975','2013-03-21','12:35:00',5.93),('8975','2013-03-21','12:40:00',5.81),('8975','2013-03-21','12:45:00',5.82),('8975','2013-03-21','12:50:00',5.78),('8975','2013-03-21','12:55:00',5.73),('8975','2013-03-21','13:00:00',5.72),('8975','2013-03-21','13:05:00',5.68),('8975','2013-03-21','13:10:00',5.64),('8975','2013-03-21','13:15:00',5.52),('8975','2013-03-21','13:20:00',5.4),('8975','2013-03-21','13:25:00',4.74),('8975','2013-03-21','13:30:00',4.5),('8975','2013-03-21','13:35:00',5.16),('8975','2013-03-21','13:40:00',4.71),('8975','2013-03-21','13:45:00',4.97),('8975','2013-03-21','13:50:00',4.95),('8975','2013-03-21','13:55:00',4.8),('8975','2013-03-21','14:00:00',4.64),('8975','2013-03-21','14:05:00',4.41),('8975','2013-03-21','14:10:00',4.25),('8975','2013-03-21','14:15:00',4.18),('8975','2013-03-21','14:20:00',4.1),('8975','2013-03-21','14:25:00',4.04),('8975','2013-03-21','14:30:00',3.95),('8975','2013-03-21','14:35:00',3.84),('8975','2013-03-21','14:40:00',3.53),('8975','2013-03-21','14:45:00',3.42),('8975','2013-03-21','14:50:00',3.39),('8975','2013-03-21','14:55:00',3.35),('8975','2013-03-21','15:00:00',3.23),('8975','2013-03-21','15:05:00',3.16),('8975','2013-03-21','15:10:00',2.78),('8975','2013-03-21','15:15:00',2.38),('8975','2013-03-21','15:20:00',1.72),('8975','2013-03-21','15:25:00',2.07),('8975','2013-03-21','15:30:00',2.08),('8975','2013-03-21','15:35:00',2.13),('8975','2013-03-21','15:40:00',2.01),('8975','2013-03-21','15:45:00',1.88),('8975','2013-03-21','15:50:00',1.89),('8975','2013-03-21','15:55:00',1.62),('8975','2013-03-21','16:00:00',1.72),('8975','2013-03-21','16:05:00',1.52),('8975','2013-03-21','16:10:00',1.8),('8975','2013-03-21','16:15:00',1.82),('8975','2013-03-21','16:20:00',1.83),('8975','2013-03-21','16:25:00',1.78),('8975','2013-03-21','16:30:00',1.83),('8975','2013-03-21','16:35:00',1.83),('8975','2013-03-21','16:40:00',1.76),('8975','2013-03-21','16:45:00',1.69),('8975','2013-03-21','16:50:00',1.65),('8975','2013-03-21','16:55:00',1.61),('8975','2013-03-21','17:00:00',1.28),('8975','2013-03-21','17:05:00',1.34),('8975','2013-03-21','17:10:00',1.28),('8975','2013-03-21','17:15:00',1.2),('8975','2013-03-21','17:20:00',1.12),('8975','2013-03-20','07:25:00',1.16),('8975','2013-03-20','07:30:00',2.72),('8975','2013-03-20','07:35:00',1.97),('8975','2013-03-20','07:40:00',2.42),('8975','2013-03-20','07:45:00',3.77),('8975','2013-03-20','07:50:00',3.39),('8975','2013-03-20','07:55:00',1.57),('8975','2013-03-20','08:00:00',1.17),('8975','2013-03-20','08:05:00',1.22),('8975','2013-03-20','08:10:00',3.25),('8975','2013-03-20','08:15:00',4.12),('8975','2013-03-20','08:20:00',3.74),('8975','2013-03-20','08:25:00',2.66),('8975','2013-03-20','08:30:00',2.83),('8975','2013-03-20','08:35:00',1.48),('8975','2013-03-20','08:40:00',3.92),('8975','2013-03-20','08:45:00',4.53),('8975','2013-03-20','08:50:00',2.64),('8975','2013-03-20','08:55:00',4.95),('8975','2013-03-20','09:00:00',3.35),('8975','2013-03-20','09:05:00',3.5),('8975','2013-03-20','09:10:00',5.69),('8975','2013-03-20','09:15:00',5.55),('8975','2013-03-20','09:20:00',5.81),('8975','2013-03-20','09:25:00',5.3),('8975','2013-03-20','09:30:00',5.44),('8975','2013-03-20','09:35:00',3.75),('8975','2013-03-20','09:40:00',5.31),('8975','2013-03-20','09:45:00',4.48),('8975','2013-03-20','09:50:00',5.31),('8975','2013-03-20','09:55:00',5.36),('8975','2013-03-20','10:00:00',5.62),('8975','2013-03-20','10:05:00',5.99),('8975','2013-03-20','10:10:00',6.08),('8975','2013-03-20','10:15:00',6.07),('8975','2013-03-20','10:20:00',6.11),('8975','2013-03-20','10:25:00',6.19),('8975','2013-03-20','10:30:00',6.23),('8975','2013-03-20','10:35:00',6.23),('8975','2013-03-20','10:40:00',6.26),('8975','2013-03-20','10:45:00',6.22),('8975','2013-03-20','10:50:00',6.22),('8975','2013-03-20','10:55:00',6.45),('8975','2013-03-20','11:00:00',5.9),('8975','2013-03-20','11:05:00',6.35),('8975','2013-03-20','11:10:00',6.34),('8975','2013-03-20','11:15:00',6.37),('8975','2013-03-20','11:20:00',6.39),('8975','2013-03-20','11:25:00',6.42),('8975','2013-03-20','11:30:00',6.45),('8975','2013-03-20','11:35:00',6.43),('8975','2013-03-20','11:40:00',6.45),('8975','2013-03-20','11:45:00',6.48),('8975','2013-03-20','11:50:00',6.49),('8975','2013-03-20','11:55:00',6.46),('8975','2013-03-20','12:00:00',6.43),('8975','2013-03-20','12:05:00',6.42),('8975','2013-03-20','12:10:00',6.38),('8975','2013-03-20','12:15:00',6.35),('8975','2013-03-20','12:20:00',6.32),('8975','2013-03-20','12:25:00',6.27),('8975','2013-03-20','12:30:00',6.25),('8975','2013-03-20','12:35:00',6.18),('8975','2013-03-20','12:40:00',6.13),('8975','2013-03-20','12:45:00',6.07),('8975','2013-03-20','12:50:00',5.97),('8975','2013-03-20','12:55:00',5.94),('8975','2013-03-20','13:00:00',5.87),('8975','2013-03-20','13:05:00',5.8),('8975','2013-03-20','13:10:00',5.72),('8975','2013-03-20','13:15:00',5.62),('8975','2013-03-20','13:20:00',5.43),('8975','2013-03-20','13:25:00',5.37),('8975','2013-03-20','13:30:00',5.29),('8975','2013-03-20','13:35:00',5.2),('8975','2013-03-20','13:40:00',5.14),('8975','2013-03-20','13:45:00',5.02),('8975','2013-03-20','13:50:00',4.91),('8975','2013-03-20','13:55:00',4.82),('8975','2013-03-20','14:00:00',4.71),('8975','2013-03-20','14:05:00',4.53),('8975','2013-03-20','14:10:00',4.43),('8975','2013-03-20','14:15:00',4.24),('8975','2013-03-20','14:20:00',4.13),('8975','2013-03-20','14:25:00',4.07),('8975','2013-03-20','14:30:00',3.99),('8975','2013-03-20','14:35:00',3.85),('8975','2013-03-20','14:40:00',3.7),('8975','2013-03-20','14:45:00',3.57),('8975','2013-03-20','14:50:00',3.5),('8975','2013-03-20','14:55:00',3.35),('8975','2013-03-20','15:00:00',3.27),('8975','2013-03-20','15:05:00',3.17),('8975','2013-03-20','15:10:00',3.06),('8975','2013-03-20','15:15:00',2.91),('8975','2013-03-20','15:20:00',2.81),('8975','2013-03-20','15:25:00',2.7),('8975','2013-03-20','15:30:00',2.56),('8975','2013-03-20','15:35:00',2.44),('8975','2013-03-20','15:40:00',2.32),('8975','2013-03-20','15:45:00',2.2),('8975','2013-03-20','15:50:00',2.09),('8975','2013-03-20','15:55:00',1.99),('8975','2013-03-20','16:00:00',1.9),('8975','2013-03-20','16:05:00',1.82),('8975','2013-03-20','16:10:00',1.74),('8975','2013-03-20','16:15:00',1.69),('8975','2013-03-20','16:20:00',1.64),('8975','2013-03-20','16:25:00',1.59),('8975','2013-03-20','16:30:00',1.55),('8975','2013-03-20','16:35:00',1.49),('8975','2013-03-20','16:40:00',1.44),('8975','2013-03-20','16:45:00',1.39),('8975','2013-03-20','16:50:00',1.34),('8975','2013-03-20','16:55:00',1.27),('8975','2013-03-20','17:00:00',1.22),('8975','2013-03-20','17:05:00',1.17),('8975','2013-03-20','17:10:00',1.13),('8975','2013-03-20','17:15:00',1.06),('8975','2013-03-19','06:45:00',1.08),('8975','2013-03-19','06:50:00',1.31),('8975','2013-03-19','06:55:00',1.41),('8975','2013-03-19','07:00:00',1.6),('8975','2013-03-19','07:05:00',1.94),('8975','2013-03-19','07:10:00',2.17),('8975','2013-03-19','07:15:00',2.25),('8975','2013-03-19','07:20:00',2.56),('8975','2013-03-19','07:25:00',2.74),('8975','2013-03-19','07:30:00',2.94),('8975','2013-03-19','07:35:00',3.18),('8975','2013-03-19','07:40:00',1.58),('8975','2013-03-19','07:45:00',1.8),('8975','2013-03-19','07:50:00',2.88),('8975','2013-03-19','07:55:00',3.72),('8975','2013-03-19','08:00:00',2.2),('8975','2013-03-19','08:05:00',3.19),('8975','2013-03-19','08:10:00',3.75),('8975','2013-03-19','08:15:00',3.86),('8975','2013-03-19','08:20:00',3.91),('8975','2013-03-19','08:25:00',3.91),('8975','2013-03-19','08:30:00',3.31),('8975','2013-03-19','08:35:00',4.24),('8975','2013-03-19','08:40:00',4.19),('8975','2013-03-19','08:45:00',4.29),('8975','2013-03-19','08:50:00',4.38),('8975','2013-03-19','08:55:00',4.47),('8975','2013-03-19','09:00:00',4.87),('8975','2013-03-19','09:05:00',5),('8975','2013-03-19','09:10:00',4),('8975','2013-03-19','09:15:00',4.78),('8975','2013-03-19','09:20:00',5.01),('8975','2013-03-19','09:25:00',5.11),('8975','2013-03-19','09:30:00',5.12),('8975','2013-03-19','09:35:00',5),('8975','2013-03-19','09:40:00',5.36),('8975','2013-03-19','09:45:00',5.43),('8975','2013-03-19','09:50:00',5.45),('8975','2013-03-19','09:55:00',5.42),('8975','2013-03-19','10:00:00',5.59),('8975','2013-03-19','10:05:00',5.18),('8975','2013-03-19','10:10:00',3.47),('8975','2013-03-19','10:15:00',4.09),('8975','2013-03-19','10:20:00',3.34),('8975','2013-03-19','10:25:00',3.73),('8975','2013-03-19','10:30:00',5.52),('8975','2013-03-19','10:35:00',6.41),('8975','2013-03-19','10:40:00',3.11),('8975','2013-03-19','10:45:00',4.48),('8975','2013-03-19','10:50:00',4.97),('8975','2013-03-19','10:55:00',5.38),('8975','2013-03-19','11:00:00',4.92),('8975','2013-03-19','11:05:00',4.87),('8975','2013-03-19','11:10:00',4.14),('8975','2013-03-19','11:15:00',3.86),('8975','2013-03-19','11:20:00',4.24),('8975','2013-03-19','11:25:00',3.99),('8975','2013-03-19','11:30:00',3.92),('8975','2013-03-19','11:35:00',4.16),('8975','2013-03-19','11:40:00',3.35),('8975','2013-03-19','11:45:00',3.21),('8975','2013-03-19','11:50:00',3.25),('8975','2013-03-19','11:55:00',3.44),('8975','2013-03-19','12:00:00',3.64),('8975','2013-03-19','12:05:00',3.94),('8975','2013-03-19','12:10:00',3.03),('8975','2013-03-19','12:15:00',2.69),('8975','2013-03-19','12:20:00',2.4),('8975','2013-03-19','12:25:00',2.06),('8975','2013-03-19','12:30:00',1.9),('8975','2013-03-19','12:35:00',2.44),('8975','2013-03-19','12:40:00',1.64),('8975','2013-03-19','12:45:00',1.99),('8975','2013-03-19','12:50:00',2.68),('8975','2013-03-19','12:55:00',3.13),('8975','2013-03-19','13:00:00',3.08),('8975','2013-03-19','13:05:00',2.51),('8975','2013-03-19','13:10:00',2.33),('8975','2013-03-19','13:15:00',2.11),('8975','2013-03-19','13:20:00',2.17),('8975','2013-03-19','13:25:00',2.22),('8975','2013-03-19','13:30:00',2.41),('8975','2013-03-19','13:35:00',2.33),('8975','2013-03-19','13:40:00',2.89),('8975','2013-03-19','13:45:00',3.18),('8975','2013-03-19','13:50:00',2.66),('8975','2013-03-19','13:55:00',2.55),('8975','2013-03-19','14:00:00',2.49),('8975','2013-03-19','14:05:00',2.15),('8975','2013-03-19','14:10:00',2.16),('8975','2013-03-19','14:15:00',2.82),('8975','2013-03-19','14:20:00',3.25),('8975','2013-03-19','14:25:00',2.85),('8975','2013-03-19','14:30:00',2.49),('8975','2013-03-19','14:35:00',2.16),('8975','2013-03-19','14:40:00',1.75),('8975','2013-03-19','14:45:00',1.61),('8975','2013-03-19','14:50:00',1.32),('8975','2013-03-19','14:55:00',1.14),('8975','2013-03-19','15:00:00',1.16),('8975','2013-03-19','15:05:00',1.06),('8975','2013-03-18','06:55:00',1.12),('8975','2013-03-18','07:00:00',1.15),('8975','2013-03-18','07:05:00',2.11),('8975','2013-03-18','07:10:00',2.27),('8975','2013-03-18','07:15:00',2.18),('8975','2013-03-18','07:20:00',2.25),('8975','2013-03-18','07:25:00',2.6),('8975','2013-03-18','07:30:00',2.76),('8975','2013-03-18','07:35:00',2.89),('8975','2013-03-18','07:40:00',3.04),('8975','2013-03-18','07:45:00',3.14),('8975','2013-03-18','07:50:00',3.29),('8975','2013-03-18','07:55:00',2.94),('8975','2013-03-18','08:00:00',2.09),('8975','2013-03-18','08:05:00',2.36),('8975','2013-03-18','08:10:00',2.44),('8975','2013-03-18','08:15:00',2.3),('8975','2013-03-18','08:20:00',3.79),('8975','2013-03-18','08:25:00',4.02),('8975','2013-03-18','08:30:00',4.16),('8975','2013-03-18','08:35:00',4.32),('8975','2013-03-18','08:40:00',2.98),('8975','2013-03-18','08:45:00',1.72),('8975','2013-03-18','08:50:00',4.62),('8975','2013-03-18','08:55:00',4.69),('8975','2013-03-18','09:00:00',4.77),('8975','2013-03-18','09:05:00',4.8),('8975','2013-03-18','09:10:00',4.97),('8975','2013-03-18','09:15:00',5.08),('8975','2013-03-18','09:20:00',5.21),('8975','2013-03-18','09:25:00',5.23),('8975','2013-03-18','09:30:00',5.28),('8975','2013-03-18','09:35:00',5.03),('8975','2013-03-18','09:40:00',5.25),('8975','2013-03-18','09:45:00',4.36),('8975','2013-03-18','09:50:00',4.2),('8975','2013-03-18','09:55:00',5.33),('8975','2013-03-18','10:00:00',5.78),('8975','2013-03-18','10:05:00',5.89),('8975','2013-03-18','10:10:00',5.69),('8975','2013-03-18','10:15:00',5.92),('8975','2013-03-18','10:20:00',5.94),('8975','2013-03-18','10:25:00',6.18),('8975','2013-03-18','10:30:00',6.06),('8975','2013-03-18','10:35:00',5.79),('8975','2013-03-18','10:40:00',6.2),('8975','2013-03-18','10:45:00',6.26),('8975','2013-03-18','10:50:00',6.27),('8975','2013-03-18','10:55:00',5.4),('8975','2013-03-18','11:00:00',6.43),('8975','2013-03-18','11:05:00',6.1),('8975','2013-03-18','11:10:00',5.97),('8975','2013-03-18','11:15:00',6.08),('8975','2013-03-18','11:20:00',6.32),('8975','2013-03-18','11:25:00',6.12),('8975','2013-03-18','11:30:00',6.2),('8975','2013-03-18','11:35:00',4.58),('8975','2013-03-18','11:40:00',6.53),('8975','2013-03-18','11:45:00',6.66),('8975','2013-03-18','11:50:00',6.53),('8975','2013-03-18','11:55:00',6.38),('8975','2013-03-18','12:00:00',6.22),('8975','2013-03-18','12:05:00',6.25),('8975','2013-03-18','12:10:00',6.06),('8975','2013-03-18','12:15:00',6.01),('8975','2013-03-18','12:20:00',5.87),('8975','2013-03-18','12:25:00',5.93),('8975','2013-03-18','12:30:00',5.99),('8975','2013-03-18','12:35:00',5.95),('8975','2013-03-18','12:40:00',5.91),('8975','2013-03-18','12:45:00',5.03),('8975','2013-03-18','12:50:00',5.92),('8975','2013-03-18','12:55:00',5.87),('8975','2013-03-18','13:00:00',5.67),('8975','2013-03-18','13:05:00',5.6),('8975','2013-03-18','13:10:00',5.53),('8975','2013-03-18','13:15:00',5.46),('8975','2013-03-18','13:20:00',5.34),('8975','2013-03-18','13:25:00',5.24),('8975','2013-03-18','13:30:00',5.14),('8975','2013-03-18','13:35:00',5.06),('8975','2013-03-18','13:40:00',4.96),('8975','2013-03-18','13:45:00',4.86),('8975','2013-03-18','13:50:00',4.71),('8975','2013-03-18','13:55:00',4.67),('8975','2013-03-18','14:00:00',4.58),('8975','2013-03-18','14:05:00',4.44),('8975','2013-03-18','14:10:00',4.24),('8975','2013-03-18','14:15:00',3.91),('8975','2013-03-18','14:20:00',3.93),('8975','2013-03-18','14:25:00',3.97),('8975','2013-03-18','14:30:00',3.84),('8975','2013-03-18','14:35:00',3.72),('8975','2013-03-18','14:40:00',3.52),('8975','2013-03-18','14:45:00',3.3),('8975','2013-03-18','14:50:00',3.29),('8975','2013-03-18','14:55:00',3.27),('8975','2013-03-18','15:00:00',3.04),('8975','2013-03-18','15:05:00',3.05),('8975','2013-03-18','15:10:00',2.93),('8975','2013-03-18','15:15:00',2.84),('8975','2013-03-18','15:20:00',2.72),('8975','2013-03-18','15:25:00',2.63),('8975','2013-03-18','15:30:00',2.49),('8975','2013-03-18','15:35:00',2.38),('8975','2013-03-18','15:40:00',2.29),('8975','2013-03-18','15:45:00',2.17),('8975','2013-03-18','15:50:00',2.06),('8975','2013-03-18','15:55:00',1.99),('8975','2013-03-18','16:00:00',1.9),('8975','2013-03-18','16:05:00',1.81),('8975','2013-03-18','16:10:00',1.73),('8975','2013-03-18','16:15:00',1.7),('8975','2013-03-18','16:20:00',1.63),('8975','2013-03-18','16:25:00',1.6),('8975','2013-03-18','16:30:00',1.57),('8975','2013-03-18','16:35:00',1.51),('8975','2013-03-18','16:40:00',1.3),('8975','2013-03-18','16:45:00',1.1),('8975','2013-03-18','16:50:00',1.07),('8975','2013-03-18','16:55:00',1.24),('8975','2013-03-18','17:00:00',1.04),('8975','2013-03-18','17:15:00',1.14),('8975','2013-03-18','17:20:00',1.07),('8975','2013-03-17','08:25:00',1.06),('8975','2013-03-17','08:30:00',1.19),('8975','2013-03-17','08:35:00',1.12),('8975','2013-03-17','08:40:00',1.11),('8975','2013-03-17','08:45:00',1.51),('8975','2013-03-17','08:50:00',1.24),('8975','2013-03-17','08:55:00',1.08),('8975','2013-03-17','09:40:00',1.09),('8975','2013-03-17','09:45:00',1.16),('8975','2013-03-17','09:50:00',1.21),('8975','2013-03-17','09:55:00',1.63),('8975','2013-03-17','10:00:00',2.13),('8975','2013-03-17','10:05:00',2.68),('8975','2013-03-17','10:10:00',2.45),('8975','2013-03-17','10:15:00',2.12),('8975','2013-03-17','10:20:00',2.83),('8975','2013-03-17','10:25:00',3.22),('8975','2013-03-17','10:30:00',3.13),('8975','2013-03-17','10:35:00',2.51),('8975','2013-03-17','10:40:00',2.34),('8975','2013-03-17','10:45:00',2.35),('8975','2013-03-17','10:50:00',2.26),('8975','2013-03-17','10:55:00',1.91),('8975','2013-03-17','11:00:00',2.02),('8975','2013-03-17','11:05:00',2.2),('8975','2013-03-17','11:10:00',2.64),('8975','2013-03-17','11:15:00',2.84),('8975','2013-03-17','11:20:00',2.94),('8975','2013-03-17','11:25:00',3.46),('8975','2013-03-17','11:30:00',3.66),('8975','2013-03-17','11:35:00',3.39),('8975','2013-03-17','11:40:00',3.14),('8975','2013-03-17','11:45:00',2.62),('8975','2013-03-17','11:50:00',2.19),('8975','2013-03-17','11:55:00',2.74),('8975','2013-03-17','12:00:00',2.74),('8975','2013-03-17','12:05:00',5.08),('8975','2013-03-17','12:10:00',4.22),('8975','2013-03-17','12:15:00',5.46),('8975','2013-03-17','12:20:00',3.76),('8975','2013-03-17','12:25:00',3.82),('8975','2013-03-17','12:30:00',5.52),('8975','2013-03-17','12:35:00',6.04),('8975','2013-03-17','12:40:00',4.42),('8975','2013-03-17','12:45:00',4.24),('8975','2013-03-17','12:50:00',5.4),('8975','2013-03-17','12:55:00',5.93),('8975','2013-03-17','13:00:00',6.54),('8975','2013-03-17','13:05:00',4.46),('8975','2013-03-17','13:10:00',2.36),('8975','2013-03-17','13:15:00',1.62),('8975','2013-03-17','13:20:00',1.81),('8975','2013-03-17','13:25:00',3.74),('8975','2013-03-17','13:30:00',2.07),('8975','2013-03-17','13:35:00',2.06),('8975','2013-03-17','13:40:00',3.4),('8975','2013-03-17','13:45:00',2.84),('8975','2013-03-17','13:50:00',2.54),('8975','2013-03-17','13:55:00',2.52),('8975','2013-03-17','14:00:00',2.78),('8975','2013-03-17','14:05:00',4.14),('8975','2013-03-17','14:10:00',2.84),('8975','2013-03-17','14:15:00',2.07),('8975','2013-03-17','14:20:00',2.44),('8975','2013-03-17','14:25:00',2.61),('8975','2013-03-17','14:30:00',1.44),('8975','2013-03-17','14:35:00',1.85),('8975','2013-03-17','14:40:00',2.08),('8975','2013-03-17','14:45:00',1.94),('8975','2013-03-17','14:50:00',1.15),('8975','2013-03-17','14:55:00',1.6),('8975','2013-03-17','15:00:00',1.68),('8975','2013-03-17','15:05:00',1.5),('8975','2013-03-17','15:10:00',1.09),('8975','2013-03-17','15:15:00',1.45),('8975','2013-03-17','15:20:00',1.14),('8975','2013-03-17','15:25:00',1.06),('8975','2013-03-16','07:50:00',1.02),('8975','2013-03-16','07:55:00',1.08),('8975','2013-03-16','08:00:00',1.24),('8975','2013-03-16','08:05:00',1.38),('8975','2013-03-16','08:10:00',1.56),('8975','2013-03-16','08:15:00',1.67),('8975','2013-03-16','08:20:00',2.08),('8975','2013-03-16','08:25:00',2.84),('8975','2013-03-16','08:30:00',2.55),('8975','2013-03-16','08:35:00',1.97),('8975','2013-03-16','08:40:00',2.11),('8975','2013-03-16','08:45:00',2.62),('8975','2013-03-16','08:50:00',2.44),('8975','2013-03-16','08:55:00',2.23),('8975','2013-03-16','09:00:00',2.25),('8975','2013-03-16','09:05:00',2.48),('8975','2013-03-16','09:10:00',2.91),('8975','2013-03-16','09:15:00',2.99),('8975','2013-03-16','09:20:00',2.43),('8975','2013-03-16','09:25:00',2.05),('8975','2013-03-16','09:30:00',2.33),('8975','2013-03-16','09:35:00',2.48),('8975','2013-03-16','09:40:00',2.62),('8975','2013-03-16','09:45:00',2.65),('8975','2013-03-16','09:50:00',2.89),('8975','2013-03-16','09:55:00',3.11),('8975','2013-03-16','10:00:00',3.48),('8975','2013-03-16','10:05:00',2.91),('8975','2013-03-16','10:10:00',2.91),('8975','2013-03-16','10:15:00',3.12),('8975','2013-03-16','10:20:00',3.27),('8975','2013-03-16','10:25:00',3.28),('8975','2013-03-16','10:30:00',3.15),('8975','2013-03-16','10:35:00',3.07),('8975','2013-03-16','10:40:00',2.85),('8975','2013-03-16','10:45:00',3),('8975','2013-03-16','10:50:00',2.97),('8975','2013-03-16','10:55:00',2.81),('8975','2013-03-16','11:00:00',2.6),('8975','2013-03-16','11:05:00',2.28),('8975','2013-03-16','11:10:00',2.26),('8975','2013-03-16','11:15:00',2.4),('8975','2013-03-16','11:20:00',2.75),('8975','2013-03-16','11:25:00',2.94),('8975','2013-03-16','11:30:00',2.72),('8975','2013-03-16','11:35:00',2.53),('8975','2013-03-16','11:40:00',2.33),('8975','2013-03-16','11:45:00',2.25),('8975','2013-03-16','11:50:00',2.09),('8975','2013-03-16','11:55:00',1.91),('8975','2013-03-16','12:00:00',1.9),('8975','2013-03-16','12:05:00',1.97),('8975','2013-03-16','12:10:00',2.46),('8975','2013-03-16','12:15:00',3.25),('8975','2013-03-16','12:20:00',3.95),('8975','2013-03-16','12:25:00',4.22),('8975','2013-03-16','12:30:00',4.84),('8975','2013-03-16','12:35:00',3.95),('8975','2013-03-16','12:40:00',3.88),('8975','2013-03-16','12:45:00',3.59),('8975','2013-03-16','12:50:00',3.35),('8975','2013-03-16','12:55:00',2.94),('8975','2013-03-16','13:00:00',3.61),('8975','2013-03-16','13:05:00',3.7),('8975','2013-03-16','13:10:00',4.72),('8975','2013-03-16','13:15:00',4.57),('8975','2013-03-16','13:20:00',3.83),('8975','2013-03-16','13:25:00',3.05),('8975','2013-03-16','13:30:00',4.03),('8975','2013-03-16','13:35:00',3.5),('8975','2013-03-16','13:40:00',3.27),('8975','2013-03-16','13:45:00',2.89),('8975','2013-03-16','13:50:00',2.45),('8975','2013-03-16','13:55:00',4.01),('8975','2013-03-16','14:00:00',3.39),('8975','2013-03-16','14:05:00',3.48),('8975','2013-03-16','14:10:00',3.86),('8975','2013-03-16','14:15:00',3.7),('8975','2013-03-16','14:20:00',3.87),('8975','2013-03-16','14:25:00',3.04),('8975','2013-03-16','14:30:00',2.93),('8975','2013-03-16','14:35:00',2.71),('8975','2013-03-16','14:40:00',2.15),('8975','2013-03-16','14:45:00',2.08),('8975','2013-03-16','14:50:00',1.87),('8975','2013-03-16','14:55:00',1.94),('8975','2013-03-16','15:00:00',2.6),('8975','2013-03-16','15:05:00',2.9),('8975','2013-03-16','15:10:00',3.76),('8975','2013-03-16','15:15:00',3.07),('8975','2013-03-16','15:20:00',3.43),('8975','2013-03-16','15:25:00',3.53),('8975','2013-03-16','15:30:00',2.86),('8975','2013-03-16','15:35:00',1.99),('8975','2013-03-16','15:40:00',1.81),('8975','2013-03-16','15:45:00',1.76),('8975','2013-03-16','15:50:00',1.02),('8975','2013-03-16','16:40:00',1.21),('8975','2013-03-16','16:45:00',1.42),('8975','2013-03-15','07:45:00',1.11),('8975','2013-03-15','07:50:00',1.38),('8975','2013-03-15','07:55:00',1.52),('8975','2013-03-15','08:00:00',2.09),('8975','2013-03-15','08:05:00',2.32),('8975','2013-03-15','08:10:00',3.36),('8975','2013-03-15','08:15:00',3.71),('8975','2013-03-15','08:20:00',3.17),('8975','2013-03-15','08:25:00',4.32),('8975','2013-03-15','08:30:00',4.34),('8975','2013-03-15','08:35:00',4.42),('8975','2013-03-15','08:40:00',4.52),('8975','2013-03-15','08:45:00',4.55),('8975','2013-03-15','08:50:00',4.22),('8975','2013-03-15','08:55:00',4.33),('8975','2013-03-15','09:00:00',3.08),('8975','2013-03-15','09:05:00',4.08),('8975','2013-03-15','09:10:00',5.34),('8975','2013-03-15','09:15:00',4.88),('8975','2013-03-15','09:20:00',3.83),('8975','2013-03-15','09:25:00',5.55),('8975','2013-03-15','09:30:00',5.83),('8975','2013-03-15','09:35:00',3.86),('8975','2013-03-15','09:40:00',5.58),('8975','2013-03-15','09:45:00',5.91),('8975','2013-03-15','09:50:00',6.02),('8975','2013-03-15','09:55:00',5.8),('8975','2013-03-15','10:00:00',5.31),('8975','2013-03-15','10:05:00',4.28),('8975','2013-03-15','10:10:00',4.88),('8975','2013-03-15','10:15:00',4.72),('8975','2013-03-15','10:20:00',5.36),('8975','2013-03-15','10:25:00',6.68),('8975','2013-03-15','10:30:00',4.55),('8975','2013-03-15','10:35:00',4.86),('8975','2013-03-15','10:40:00',6.46),('8975','2013-03-15','10:45:00',6.27),('8975','2013-03-15','10:50:00',6.28),('8975','2013-03-15','10:55:00',6.27),('8975','2013-03-15','11:00:00',6.26),('8975','2013-03-15','11:05:00',6.29),('8975','2013-03-15','11:10:00',6.31),('8975','2013-03-15','11:15:00',6.31),('8975','2013-03-15','11:20:00',6.31),('8975','2013-03-15','11:25:00',6.27),('8975','2013-03-15','11:30:00',6.27),('8975','2013-03-15','11:35:00',6.27),('8975','2013-03-15','11:40:00',6.25),('8975','2013-03-15','11:45:00',6.22),('8975','2013-03-15','11:50:00',6.21),('8975','2013-03-15','11:55:00',6.22),('8975','2013-03-15','12:00:00',6.19),('8975','2013-03-15','12:05:00',6.13),('8975','2013-03-15','12:10:00',6.11),('8975','2013-03-15','12:15:00',6.08),('8975','2013-03-15','12:20:00',6.08),('8975','2013-03-15','12:25:00',6.02),('8975','2013-03-15','12:30:00',5.94),('8975','2013-03-15','12:35:00',5.9),('8975','2013-03-15','12:40:00',5.87),('8975','2013-03-15','12:45:00',5.76),('8975','2013-03-15','12:50:00',5.72),('8975','2013-03-15','12:55:00',5.79),('8975','2013-03-15','13:00:00',5.72),('8975','2013-03-15','13:05:00',5.59),('8975','2013-03-15','13:10:00',5.48),('8975','2013-03-15','13:15:00',5.34),('8975','2013-03-15','13:20:00',5.19),('8975','2013-03-15','13:25:00',5.43),('8975','2013-03-15','13:30:00',5.37),('8975','2013-03-15','13:35:00',3.68),('8975','2013-03-15','13:40:00',1.92),('8975','2013-03-15','13:45:00',4.21),('8975','2013-03-15','13:50:00',4.72),('8975','2013-03-15','13:55:00',5.04),('8975','2013-03-15','14:00:00',4.9),('8975','2013-03-15','14:05:00',2.76),('8975','2013-03-15','14:10:00',3.88),('8975','2013-03-15','14:15:00',3.08),('8975','2013-03-15','14:20:00',4.2),('8975','2013-03-15','14:25:00',4.19),('8975','2013-03-15','14:30:00',2.06),('8975','2013-03-15','14:35:00',4.08),('8975','2013-03-15','14:40:00',4.09),('8975','2013-03-15','14:45:00',3.96),('8975','2013-03-15','14:50:00',1.58),('8975','2013-03-15','14:55:00',2.06),('8975','2013-03-15','15:00:00',1.3),('8975','2013-03-15','15:05:00',2.5),('8975','2013-03-15','15:10:00',3.15),('8975','2013-03-15','15:15:00',2.82),('8975','2013-03-15','15:20:00',1.58),('8975','2013-03-15','15:25:00',1.03),('8975','2013-03-15','15:35:00',1.04),('8975','2013-03-15','15:40:00',1.28),('8975','2013-03-15','15:45:00',1.09),('8975','2013-03-15','16:00:00',1.14),('8975','2013-03-15','16:05:00',1.94),('8975','2013-03-15','16:10:00',1.9),('8975','2013-03-15','16:15:00',2.07),('8975','2013-03-15','16:20:00',1.99),('8975','2013-03-15','16:25:00',1.82),('8975','2013-03-15','16:40:00',1.09),('8975','2013-03-15','16:55:00',1.23),('8975','2013-03-15','17:00:00',1.28),('8975','2013-03-15','17:05:00',1.2),('8975','2013-03-15','17:10:00',1.13),('8975','2013-03-15','17:15:00',1.09),('8975','2013-03-15','17:20:00',1.02),('8975','2013-03-14','10:25:00',1.06),('8975','2013-03-14','10:30:00',1.43),('8975','2013-03-14','10:35:00',1.57),('8975','2013-03-14','10:40:00',1.62),('8975','2013-03-14','10:45:00',1.98),('8975','2013-03-14','10:50:00',2.05),('8975','2013-03-14','10:55:00',2.3),('8975','2013-03-14','11:00:00',2.28),('8975','2013-03-14','11:05:00',1.95),('8975','2013-03-14','11:10:00',2),('8975','2013-03-14','11:15:00',1.8),('8975','2013-03-14','11:20:00',2.17),('8975','2013-03-14','11:25:00',2.62),('8975','2013-03-14','11:30:00',3.06),('8975','2013-03-14','11:35:00',4.09),('8975','2013-03-14','11:40:00',4.01),('8975','2013-03-14','11:45:00',4.72),('8975','2013-03-14','11:50:00',3.13),('8975','2013-03-14','11:55:00',3.3),('8975','2013-03-14','12:00:00',3.13),('8975','2013-03-14','12:05:00',2.74),('8975','2013-03-14','12:10:00',2.67),('8975','2013-03-14','12:15:00',2.56),('8975','2013-03-14','12:20:00',2.59),('8975','2013-03-14','12:25:00',2.76),('8975','2013-03-14','12:30:00',2.85),('8975','2013-03-14','12:35:00',3.3),('8975','2013-03-14','12:40:00',2.92),('8975','2013-03-14','12:45:00',2.62),('8975','2013-03-14','12:50:00',2.49),('8975','2013-03-14','12:55:00',2.29),('8975','2013-03-14','13:00:00',2.02),('8975','2013-03-14','13:05:00',1.92),('8975','2013-03-14','13:10:00',1.89),('8975','2013-03-14','13:15:00',2.03),('8975','2013-03-14','13:20:00',2.15),('8975','2013-03-14','13:25:00',2.3),('8975','2013-03-14','13:30:00',2.32),('8975','2013-03-14','13:35:00',2.2),('8975','2013-03-14','13:40:00',2.35),('8975','2013-03-14','13:45:00',2.63),('8975','2013-03-14','13:50:00',2.23),('8975','2013-03-14','13:55:00',1.83),('8975','2013-03-14','14:00:00',1.58),('8975','2013-03-14','14:05:00',1.47),('8975','2013-03-14','14:10:00',1.3),('8975','2013-03-14','14:15:00',1.18),('8975','2013-03-14','14:20:00',1.06),('8975','2013-03-14','14:50:00',1.45),('8975','2013-03-14','14:55:00',1.84),('8975','2013-03-14','15:00:00',2.1),('8975','2013-03-14','15:05:00',1.98),('8975','2013-03-14','15:10:00',1.93),('8975','2013-03-14','15:15:00',2.03),('8975','2013-03-14','15:20:00',2.15),('8975','2013-03-14','15:25:00',2.45),('8975','2013-03-14','15:30:00',2.06),('8975','2013-03-14','15:35:00',1.72),('8975','2013-03-14','15:40:00',1.46),('8975','2013-03-14','15:45:00',1.47),('8975','2013-03-14','15:50:00',1.44),('8975','2013-03-14','15:55:00',1.35),('8975','2013-03-14','16:00:00',1.6),('8975','2013-03-14','16:05:00',1.25),('8975','2013-03-14','16:10:00',1.16),('8975','2013-03-14','16:15:00',1.2),('8975','2013-03-14','16:20:00',1.05),('8975','2013-03-14','17:20:00',1.04),('8975','2013-03-13','08:20:00',1.16),('8975','2013-03-13','08:25:00',1.11),('8975','2013-03-13','10:15:00',1.06),('8975','2013-03-13','10:20:00',1.06),('8975','2013-03-13','10:25:00',1.06),('8975','2013-03-13','11:25:00',1.16),('8975','2013-03-13','11:30:00',1.43),('8975','2013-03-13','11:35:00',1.6),('8975','2013-03-13','11:40:00',1.49),('8975','2013-03-13','11:45:00',1.23),('8975','2013-03-13','11:50:00',1.32),('8975','2013-03-13','11:55:00',1.29),('8975','2013-03-13','12:00:00',1.21),('8975','2013-03-13','12:05:00',1.14),('8975','2013-03-13','12:10:00',1.07),('8975','2013-03-13','12:15:00',1.03),('8975','2013-03-13','12:20:00',1.03),('8975','2013-03-13','12:25:00',1.05),('8975','2013-03-13','12:30:00',1.09),('8975','2013-03-13','12:35:00',1.1),('8975','2013-03-13','12:40:00',1.14),('8975','2013-03-13','12:45:00',1.24),('8975','2013-03-13','12:50:00',1.39),('8975','2013-03-13','12:55:00',1.61),('8975','2013-03-13','13:00:00',1.75),('8975','2013-03-13','13:05:00',1.84),('8975','2013-03-13','13:10:00',1.74),('8975','2013-03-13','13:15:00',1.7),('8975','2013-03-13','13:20:00',2.14),('8975','2013-03-13','13:25:00',2.02),('8975','2013-03-13','13:30:00',1.87),('8975','2013-03-13','13:35:00',2.42),('8975','2013-03-13','13:40:00',3.07),('8975','2013-03-13','13:45:00',2.99),('8975','2013-03-13','13:50:00',2.33),('8975','2013-03-13','13:55:00',2.36),('8975','2013-03-13','14:00:00',2.42),('8975','2013-03-13','14:05:00',1.85),('8975','2013-03-13','14:10:00',1.91),('8975','2013-03-13','14:15:00',1.74),('8975','2013-03-13','14:20:00',1.67),('8975','2013-03-13','14:25:00',1.85),('8975','2013-03-13','14:30:00',1.65),('8975','2013-03-13','14:35:00',1.27),('8975','2013-03-13','15:05:00',1.05),('8975','2013-03-13','15:10:00',1.7),('8975','2013-03-13','15:15:00',2.03),('8975','2013-03-13','15:20:00',1.91),('8975','2013-03-13','15:25:00',1.97),('8975','2013-03-13','15:30:00',2.12),('8975','2013-03-13','15:35:00',1.8),('8975','2013-03-13','15:40:00',1.26),('8975','2013-03-12','07:05:00',1.01),('8975','2013-03-12','07:20:00',1.15),('8975','2013-03-12','07:35:00',1.59),('8975','2013-03-12','07:40:00',1.84),('8975','2013-03-12','08:25:00',1.09),('8975','2013-03-12','08:35:00',1.03),('8975','2013-03-12','08:40:00',1.12),('8975','2013-03-12','08:45:00',1.54),('8975','2013-03-12','08:50:00',2.14),('8975','2013-03-12','08:55:00',1.64),('8975','2013-03-12','09:00:00',1.19),('8975','2013-03-12','09:05:00',1.55),('8975','2013-03-12','09:10:00',1.99),('8975','2013-03-12','09:15:00',1.79),('8975','2013-03-12','09:20:00',1.62),('8975','2013-03-12','09:25:00',1.48),('8975','2013-03-12','09:30:00',1.35),('8975','2013-03-12','09:35:00',1.02),('8975','2013-03-12','09:40:00',2.02),('8975','2013-03-12','09:45:00',1.47),('8975','2013-03-12','10:00:00',1.4),('8975','2013-03-12','10:05:00',1.48),('8975','2013-03-12','10:10:00',3.16),('8975','2013-03-12','10:15:00',3.49),('8975','2013-03-12','10:20:00',3.26),('8975','2013-03-12','10:25:00',4.39),('8975','2013-03-12','10:30:00',6.09),('8975','2013-03-12','10:35:00',4.53),('8975','2013-03-12','10:40:00',2.85),('8975','2013-03-12','10:45:00',1.91),('8975','2013-03-12','10:50:00',1.84),('8975','2013-03-12','10:55:00',2.02),('8975','2013-03-12','11:00:00',1.81),('8975','2013-03-12','11:05:00',1.36),('8975','2013-03-12','11:10:00',1.54),('8975','2013-03-12','11:15:00',1.76),('8975','2013-03-12','11:20:00',1.24),('8975','2013-03-12','11:25:00',2.06),('8975','2013-03-12','11:30:00',2.47),('8975','2013-03-12','11:35:00',2.21),('8975','2013-03-12','11:40:00',2.01),('8975','2013-03-12','11:45:00',2.14),('8975','2013-03-12','11:50:00',1.91),('8975','2013-03-12','11:55:00',1.24),('8975','2013-03-12','12:25:00',1.05),('8975','2013-03-12','12:30:00',1.35),('8975','2013-03-12','12:35:00',1.29),('8975','2013-03-12','12:40:00',1.52),('8975','2013-03-12','12:45:00',1.83),('8975','2013-03-12','12:50:00',2.21),('8975','2013-03-12','12:55:00',2.04),('8975','2013-03-12','13:00:00',2.01),('8975','2013-03-12','13:05:00',1.79),('8975','2013-03-12','13:10:00',1.63),('8975','2013-03-12','13:15:00',1.44),('8975','2013-03-12','13:20:00',1.24),('8975','2013-03-12','13:25:00',1.14),('8975','2013-03-12','13:30:00',1.31),('8975','2013-03-12','13:35:00',1.55),('8975','2013-03-12','13:40:00',1.35),('8975','2013-03-12','13:45:00',1.2),('8975','2013-03-12','13:50:00',1.19),('8975','2013-03-12','13:55:00',1),('8975','2013-03-12','14:30:00',1.05),('8975','2013-03-12','14:35:00',1.01),('8975','2013-03-12','14:40:00',1.01),('8975','2013-03-12','14:45:00',1.37),('8975','2013-03-12','14:50:00',1.49),('8975','2013-03-12','14:55:00',1.28),('8975','2013-03-12','15:00:00',1.33),('8975','2013-03-12','15:05:00',1.45),('8975','2013-03-12','15:10:00',1.36),('8975','2014-03-24','06:35:00',1.16),('8975','2014-03-24','06:40:00',1.54),('8975','2014-03-24','06:45:00',1.63),('8975','2014-03-24','06:50:00',1.6),('8975','2014-03-24','06:55:00',1.74),('8975','2014-03-24','07:00:00',1.75),('8975','2014-03-24','07:05:00',1.8),('8975','2014-03-24','07:10:00',2.59),('8975','2014-03-24','07:15:00',2.97),('8975','2014-03-24','07:20:00',3.27),('8975','2014-03-24','07:25:00',3.25),('8975','2014-03-24','07:30:00',3.19),('8975','2014-03-24','07:35:00',2.15),('8975','2014-03-24','07:40:00',2.14),('8975','2014-03-24','07:45:00',2.39),('8975','2014-03-24','07:50:00',2.6),('8975','2014-03-24','07:55:00',2.51),('8975','2014-03-24','08:00:00',2.35),('8975','2014-03-24','08:05:00',2.2),('8975','2014-03-24','08:10:00',2.4),('8975','2014-03-24','08:15:00',2.63),('8975','2014-03-24','08:20:00',2.39),('8975','2014-03-24','08:25:00',1.99),('8975','2014-03-24','08:30:00',1.77),('8975','2014-03-24','08:35:00',1.79),('8975','2014-03-24','08:40:00',2.18),('8975','2014-03-24','08:45:00',2.91),('8975','2014-03-24','08:50:00',3.37),('8975','2014-03-24','08:55:00',3.53),('8975','2014-03-24','09:00:00',3.3),('8975','2014-03-24','09:05:00',3.14),('8975','2014-03-24','09:10:00',3.16),('8975','2014-03-24','09:15:00',4.25),('8975','2014-03-24','09:20:00',4.32),('8975','2014-03-24','09:25:00',3.55),('8975','2014-03-24','09:30:00',3.2),('8975','2014-03-24','09:35:00',3.04),('8975','2014-03-24','09:40:00',2.98),('8975','2014-03-24','09:45:00',2.72),('8975','2014-03-24','09:50:00',2.89),('8975','2014-03-24','09:55:00',3.41),('8975','2014-03-24','10:00:00',3.72),('8975','2014-03-24','10:05:00',4.13),('8975','2014-03-24','10:10:00',4.5),('8975','2014-03-24','10:15:00',4.54),('8975','2014-03-24','10:20:00',4.53),('8975','2014-03-24','10:25:00',4.13),('8975','2014-03-24','10:30:00',4.58),('8975','2014-03-24','10:35:00',3.85),('8975','2014-03-24','10:40:00',3.37),('8975','2014-03-24','10:45:00',3.07),('8975','2014-03-24','10:50:00',3.01),('8975','2014-03-24','10:55:00',3),('8975','2014-03-24','11:00:00',3.09),('8975','2014-03-24','11:05:00',3.34),('8975','2014-03-24','11:10:00',3.63),('8975','2014-03-24','11:15:00',4.37),('8975','2014-03-24','11:20:00',4.76),('8975','2014-03-24','11:25:00',4.58),('8975','2014-03-24','11:30:00',3.96),('8975','2014-03-24','11:35:00',4.64),('8975','2014-03-24','11:40:00',3.98),('8975','2014-03-24','11:45:00',3.18),('8975','2014-03-24','11:50:00',2.8),('8975','2014-03-24','11:55:00',2.17),('8975','2014-03-24','12:00:00',1.62),('8975','2014-03-24','12:05:00',1.26),('8975','2014-03-24','12:10:00',1.41),('8975','2014-03-24','12:15:00',1.93),('8975','2014-03-24','12:20:00',2.11),('8975','2014-03-24','12:25:00',1.73),('8975','2014-03-24','12:30:00',1.28),('8975','2014-03-24','12:35:00',1.25),('8975','2014-03-24','13:30:00',1.47),('8975','2014-03-24','13:35:00',1.81),('8975','2014-03-24','13:40:00',1.7),('8975','2014-03-24','13:45:00',1.54),('8975','2014-03-24','13:50:00',1.35),('8975','2014-03-24','13:55:00',1.28),('8975','2014-03-24','14:00:00',1.34),('8975','2014-03-24','14:05:00',1.47),('8975','2014-03-24','14:10:00',1.59),('8975','2014-03-24','14:15:00',1.5),('8975','2014-03-24','14:20:00',1.09),('8975','2014-03-24','14:30:00',1.04),('8975','2014-03-24','14:35:00',1.09),('8975','2014-03-24','14:40:00',1.04),('8975','2014-03-24','15:15:00',1.03),('8975','2013-03-11','08:15:00',2.81),('8975','2013-03-11','08:20:00',3.66),('8975','2013-03-11','08:25:00',3.66),('8975','2013-03-11','08:30:00',3.92),('8975','2013-03-11','08:35:00',2.37),('8975','2013-03-11','08:40:00',2.62),('8975','2013-03-11','08:45:00',3.39),('8975','2013-03-11','08:50:00',2.32),('8975','2013-03-11','08:55:00',1.19),('8975','2013-03-11','09:00:00',4.47),('8975','2013-03-11','09:05:00',4.56),('8975','2013-03-11','09:10:00',4.62),('8975','2013-03-11','09:15:00',4.68),('8975','2013-03-11','09:20:00',4.76),('8975','2013-03-11','09:25:00',4.84),('8975','2013-03-11','09:30:00',4.97),('8975','2013-03-11','09:35:00',5.04),('8975','2013-03-11','09:40:00',5.2),('8975','2013-03-11','09:45:00',5.77),('8975','2013-03-11','09:50:00',4.96),('8975','2013-03-11','09:55:00',2.5),('8975','2013-03-11','10:00:00',5.2),('8975','2013-03-11','10:05:00',5.5),('8975','2013-03-11','10:10:00',3.47),('8975','2013-03-11','10:15:00',5.96),('8975','2013-03-11','10:20:00',5.59),('8975','2013-03-11','10:25:00',6.2),('8975','2013-03-11','10:30:00',4.14),('8975','2013-03-11','10:35:00',4.44),('8975','2013-03-11','10:40:00',6.21),('8975','2013-03-11','10:45:00',6.53),('8975','2013-03-11','10:50:00',6.11),('8975','2013-03-11','10:55:00',6.08),('8975','2013-03-11','11:00:00',5.4),('8975','2013-03-11','11:05:00',5.91),('8975','2013-03-11','11:10:00',6.72),('8975','2013-03-11','11:15:00',4.13),('8975','2013-03-11','11:20:00',2.03),('8975','2013-03-11','11:25:00',3.46),('8975','2013-03-11','11:30:00',2.1),('8975','2013-03-11','11:35:00',2.86),('8975','2013-03-11','11:40:00',3.3),('8975','2013-03-11','11:45:00',3.96),('8975','2013-03-11','11:50:00',5.63),('8975','2013-03-11','11:55:00',2.54),('8975','2013-03-11','12:00:00',1.51),('8975','2013-03-11','12:05:00',1.43),('8975','2013-03-11','12:10:00',5.12),('8975','2013-03-11','12:15:00',2.11),('8975','2013-03-11','12:20:00',5.51),('8975','2013-03-11','12:25:00',2.65),('8975','2013-03-11','12:30:00',6.97),('8975','2013-03-11','12:35:00',5.67),('8975','2013-03-11','12:40:00',5.27),('8975','2013-03-11','12:45:00',6.14),('8975','2013-03-11','12:50:00',4.82),('8975','2013-03-11','12:55:00',3.88),('8975','2013-03-11','13:00:00',4.52),('8975','2013-03-11','13:05:00',5.9),('8975','2013-03-11','13:10:00',4.08),('8975','2013-03-11','13:15:00',1.67),('8975','2013-03-11','13:20:00',2.09),('8975','2013-03-11','13:25:00',2.39),('8975','2013-03-11','13:30:00',1.7),('8975','2013-03-11','13:35:00',1.73),('8975','2013-03-11','13:40:00',1.32),('8975','2013-03-11','13:45:00',2.05),('8975','2013-03-11','13:50:00',4.11),('8975','2013-03-11','13:55:00',3.76),('8975','2013-03-11','14:00:00',3.54),('8975','2013-03-11','14:05:00',3.41),('8975','2013-03-11','14:15:00',1.51),('8975','2013-03-11','14:20:00',1.16),('8975','2013-03-11','14:30:00',1.36),('8975','2013-03-11','14:35:00',1.21),('8975','2013-03-11','15:20:00',1.75),('8975','2013-03-11','15:25:00',1.72),('8975','2013-03-11','15:30:00',1.02),('8975','2013-03-11','15:35:00',1),('8975','2013-03-10','07:05:00',1.16),('8975','2013-03-10','07:10:00',1.45),('8975','2013-03-10','07:15:00',1.59),('8975','2013-03-10','07:20:00',1.9),('8975','2013-03-10','07:25:00',2.12),('8975','2013-03-10','07:30:00',2.53),('8975','2013-03-10','07:35:00',2.18),('8975','2013-03-10','07:40:00',1.89),('8975','2013-03-10','07:45:00',1.15),('8975','2013-03-10','07:50:00',1.22),('8975','2013-03-10','07:55:00',1.03),('8975','2013-03-10','08:05:00',2.26),('8975','2013-03-10','08:10:00',3.35),('8975','2013-03-10','08:15:00',3.45),('8975','2013-03-10','08:20:00',3.52),('8975','2013-03-10','08:25:00',3.65),('8975','2013-03-10','08:30:00',3.76),('8975','2013-03-10','08:35:00',3.82),('8975','2013-03-10','08:40:00',3.93),('8975','2013-03-10','08:45:00',4.02),('8975','2013-03-10','08:50:00',4.12),('8975','2013-03-10','08:55:00',4.19),('8975','2013-03-10','09:00:00',4.28),('8975','2013-03-10','09:05:00',4.36),('8975','2013-03-10','09:10:00',4.43),('8975','2013-03-10','09:15:00',4.29),('8975','2013-03-10','09:20:00',4.74),('8975','2013-03-10','09:25:00',2.97),('8975','2013-03-10','09:30:00',5.04),('8975','2013-03-10','09:35:00',4.33),('8975','2013-03-10','09:40:00',3.43),('8975','2013-03-10','09:45:00',3.05),('8975','2013-03-10','09:50:00',2.2),('8975','2013-03-10','09:55:00',1.88),('8975','2013-03-10','10:00:00',1.57),('8975','2013-03-10','10:05:00',1.61),('8975','2013-03-10','10:10:00',1.62),('8975','2013-03-10','10:15:00',1.56),('8975','2013-03-10','10:20:00',1.92),('8975','2013-03-10','10:25:00',2.24),('8975','2013-03-10','10:30:00',2.13),('8975','2013-03-10','10:35:00',2.78),('8975','2013-03-10','10:40:00',3.79),('8975','2013-03-10','10:45:00',4.69),('8975','2013-03-10','10:50:00',3.62),('8975','2013-03-10','10:55:00',3.75),('8975','2013-03-10','11:00:00',2.34),('8975','2013-03-10','11:05:00',2.29),('8975','2013-03-10','11:10:00',2.53),('8975','2013-03-10','11:15:00',1.98),('8975','2013-03-10','11:20:00',1.86),('8975','2013-03-10','11:25:00',2.13),('8975','2013-03-10','11:30:00',2.47),('8975','2013-03-10','11:35:00',4.02),('8975','2013-03-10','11:40:00',3.61),('8975','2013-03-10','11:45:00',4.28),('8975','2013-03-10','11:50:00',4.64),('8975','2013-03-10','11:55:00',3.35),('8975','2013-03-10','12:00:00',2.8),('8975','2013-03-10','12:05:00',2.28),('8975','2013-03-10','12:10:00',1.7),('8975','2013-03-10','12:15:00',1.01),('8975','2013-03-10','12:20:00',1.13),('8975','2013-03-10','12:25:00',1.42),('8975','2013-03-10','12:30:00',1.42),('8975','2013-03-10','12:35:00',1.95),('8975','2013-03-10','12:40:00',1.89),('8975','2013-03-10','12:45:00',2.36),('8975','2013-03-10','12:50:00',3.63),('8975','2013-03-10','12:55:00',2.46),('8975','2013-03-10','13:00:00',2.14),('8975','2013-03-10','13:05:00',2.78),('8975','2013-03-10','13:10:00',4.79),('8975','2013-03-10','13:15:00',3.7),('8975','2013-03-10','13:20:00',2.99),('8975','2013-03-10','13:25:00',3.46),('8975','2013-03-10','13:30:00',2.68),('8975','2013-03-10','13:35:00',3.86),('8975','2013-03-10','13:40:00',3.29),('8975','2013-03-10','13:45:00',2.72),('8975','2013-03-10','13:50:00',3.34),('8975','2013-03-10','13:55:00',1.74),('8975','2013-03-10','14:00:00',1.65),('8975','2013-03-10','14:05:00',1.46),('8975','2013-03-10','14:10:00',1.21),('8975','2013-03-10','14:25:00',1.42),('8975','2013-03-10','14:30:00',1.59),('8975','2013-03-10','14:35:00',1.57),('8975','2013-03-10','14:40:00',1.68),('8975','2013-03-10','14:45:00',1.28),('8975','2013-03-10','14:50:00',1.42),('8975','2013-03-10','14:55:00',1.33),('8975','2013-03-10','15:05:00',1.01),('8975','2013-03-10','15:10:00',1.1),('8975','2013-03-10','15:15:00',1.12),('8975','2013-03-10','15:20:00',1.19),('8975','2013-03-10','15:25:00',1.25),('8975','2013-03-10','15:30:00',2.28),('8975','2013-03-10','15:35:00',2.72),('8975','2013-03-10','15:40:00',2.96),('8975','2013-03-10','15:45:00',2.78),('8975','2013-03-10','15:50:00',2.56),('8975','2013-03-10','15:55:00',2.05),('8975','2013-03-10','16:00:00',2.21),('8975','2013-03-10','16:05:00',1.73),('8975','2013-03-10','16:10:00',1.38),('8975','2013-03-10','16:15:00',1.99),('8975','2013-03-10','16:20:00',2.03),('8975','2013-03-10','16:25:00',1.88),('8975','2013-03-10','16:30:00',1.87),('8975','2013-03-10','16:40:00',1.52),('8975','2013-03-10','16:45:00',1.6),('8975','2013-03-10','16:50:00',1.28),('8975','2013-03-09','07:10:00',1.06),('8975','2013-03-09','07:15:00',1.4),('8975','2013-03-09','07:20:00',1.71),('8975','2013-03-09','07:25:00',1.46),('8975','2013-03-09','07:30:00',1.13),('8975','2013-03-09','07:35:00',1.05),('8975','2013-03-09','07:40:00',1.42),('8975','2013-03-09','07:45:00',1.29),('8975','2013-03-09','07:50:00',2.78),('8975','2013-03-09','07:55:00',3.1),('8975','2013-03-09','08:00:00',3.2),('8975','2013-03-09','08:05:00',3.3),('8975','2013-03-09','08:10:00',3.15),('8975','2013-03-09','08:15:00',3.19),('8975','2013-03-09','08:20:00',3.53),('8975','2013-03-09','08:25:00',3.65),('8975','2013-03-09','08:30:00',3.76),('8975','2013-03-09','08:35:00',3.81),('8975','2013-03-09','08:40:00',3.89),('8975','2013-03-09','08:45:00',4),('8975','2013-03-09','08:50:00',4.11),('8975','2013-03-09','08:55:00',4.19),('8975','2013-03-09','09:00:00',4.27),('8975','2013-03-09','09:05:00',4.35),('8975','2013-03-09','09:10:00',4.43),('8975','2013-03-09','09:15:00',4.51),('8975','2013-03-09','09:20:00',4.57),('8975','2013-03-09','09:25:00',4.67),('8975','2013-03-09','09:30:00',4.76),('8975','2013-03-09','09:35:00',4.87),('8975','2013-03-09','09:40:00',4.91),('8975','2013-03-09','09:45:00',3.19),('8975','2013-03-09','09:50:00',5.57),('8975','2013-03-09','09:55:00',3.18),('8975','2013-03-09','10:00:00',4.16),('8975','2013-03-09','10:05:00',3.53),('8975','2013-03-09','10:10:00',4.12),('8975','2013-03-09','10:15:00',3.84),('8975','2013-03-09','10:20:00',5.51),('8975','2013-03-09','10:25:00',6.06),('8975','2013-03-09','10:30:00',5.35),('8975','2013-03-09','10:35:00',4.39),('8975','2013-03-09','10:40:00',5.65),('8975','2013-03-09','10:45:00',3.49),('8975','2013-03-09','10:50:00',3.57),('8975','2013-03-09','10:55:00',5.95),('8975','2013-03-09','11:00:00',6.35),('8975','2013-03-09','11:05:00',3.41),('8975','2013-03-09','11:10:00',4.9),('8975','2013-03-09','11:15:00',6.85),('8975','2013-03-09','11:20:00',1.96),('8975','2013-03-09','11:25:00',4.3),('8975','2013-03-09','11:30:00',3.22),('8975','2013-03-09','11:35:00',2.58),('8975','2013-03-09','11:40:00',3.1),('8975','2013-03-09','11:45:00',6.48),('8975','2013-03-09','11:50:00',4.88),('8975','2013-03-09','11:55:00',5.79),('8975','2013-03-09','12:00:00',5.69),('8975','2013-03-09','12:05:00',5.56),('8975','2013-03-09','12:10:00',5.71),('8975','2013-03-09','12:15:00',4.89),('8975','2013-03-09','12:20:00',3.31),('8975','2013-03-09','12:25:00',2.95),('8975','2013-03-09','12:30:00',5.64),('8975','2013-03-09','12:35:00',5.31),('8975','2013-03-09','12:40:00',4.7),('8975','2013-03-09','12:45:00',4.77),('8975','2013-03-09','12:50:00',5.66),('8975','2013-03-09','12:55:00',5.34),('8975','2013-03-09','13:00:00',5.21),('8975','2013-03-09','13:05:00',5.04),('8975','2013-03-09','13:10:00',4.96),('8975','2013-03-09','13:15:00',5.03),('8975','2013-03-09','13:20:00',4.74),('8975','2013-03-09','13:25:00',4.9),('8975','2013-03-09','13:30:00',4.77),('8975','2013-03-09','13:35:00',4.87),('8975','2013-03-09','13:40:00',4.52),('8975','2013-03-09','13:45:00',4.8),('8975','2013-03-09','13:50:00',3.4),('8975','2013-03-09','13:55:00',3.09),('8975','2013-03-09','14:00:00',2.49),('8975','2013-03-09','14:05:00',3.3),('8975','2013-03-09','14:10:00',3.13),('8975','2013-03-09','14:15:00',3.49),('8975','2013-03-09','14:20:00',3.56),('8975','2013-03-09','14:25:00',3.66),('8975','2013-03-09','14:30:00',3.39),('8975','2013-03-09','14:35:00',3.85),('8975','2013-03-09','14:40:00',2.6),('8975','2013-03-09','14:45:00',2.26),('8975','2013-03-09','14:50:00',2.91),('8975','2013-03-09','14:55:00',2.17),('8975','2013-03-09','15:00:00',2.42),('8975','2013-03-09','15:05:00',2.39),('8975','2013-03-09','15:10:00',2.19),('8975','2013-03-09','15:15:00',1.48),('8975','2013-03-09','15:20:00',1.55),('8975','2013-03-09','15:50:00',1.42),('8975','2013-03-09','15:55:00',1.22),('8975','2013-03-08','07:45:00',1.94),('8975','2013-03-08','07:50:00',2.65),('8975','2013-03-08','07:55:00',2.84),('8975','2013-03-08','08:00:00',3.38),('8975','2013-03-08','08:05:00',3.25),('8975','2013-03-08','08:10:00',3.25),('8975','2013-03-08','08:15:00',3.03),('8975','2013-03-08','08:20:00',2.75),('8975','2013-03-08','08:25:00',2.84),('8975','2013-03-08','08:30:00',3.71),('8975','2013-03-08','08:35:00',3.78),('8975','2013-03-08','08:40:00',3.79),('8975','2013-03-08','08:45:00',3.49),('8975','2013-03-08','08:50:00',1.72),('8975','2013-03-08','08:55:00',3.59),('8975','2013-03-08','09:00:00',1.42),('8975','2013-03-08','09:05:00',1.21),('8975','2013-03-08','09:10:00',2),('8975','2013-03-08','09:15:00',1.77),('8975','2013-03-08','09:20:00',1.4),('8975','2013-03-08','09:25:00',1.35),('8975','2013-03-08','09:30:00',1.94),('8975','2013-03-08','09:35:00',2.45),('8975','2013-03-08','09:40:00',5.16),('8975','2013-03-08','09:45:00',1.85),('8975','2013-03-08','09:50:00',1.22),('8975','2013-03-08','09:55:00',1.97),('8975','2013-03-08','10:00:00',2.96),('8975','2013-03-08','10:05:00',3.29),('8975','2013-03-08','10:10:00',2.79),('8975','2013-03-08','10:15:00',2.9),('8975','2013-03-08','10:20:00',3.1),('8975','2013-03-08','10:25:00',2.1),('8975','2013-03-08','10:30:00',1.89),('8975','2013-03-08','10:35:00',2.04),('8975','2013-03-08','10:40:00',4.55),('8975','2013-03-08','10:45:00',3.05),('8975','2013-03-08','10:50:00',2.53),('8975','2013-03-08','10:55:00',5.4),('8975','2013-03-08','11:00:00',5.86),('8975','2013-03-08','11:05:00',3.11),('8975','2013-03-08','11:10:00',4.36),('8975','2013-03-08','11:15:00',3.77),('8975','2013-03-08','11:20:00',3.59),('8975','2013-03-08','11:25:00',2.35),('8975','2013-03-08','11:30:00',4.24),('8975','2013-03-08','11:35:00',5.47),('8975','2013-03-08','11:40:00',3.66),('8975','2013-03-08','11:45:00',4.89),('8975','2013-03-08','11:50:00',5.82),('8975','2013-03-08','11:55:00',5.65),('8975','2013-03-08','12:00:00',5.8),('8975','2013-03-08','12:05:00',4.73),('8975','2013-03-08','12:10:00',5.89),('8975','2013-03-08','12:15:00',3.04),('8975','2013-03-08','12:20:00',3.2),('8975','2013-03-08','12:25:00',3.93),('8975','2013-03-08','12:30:00',2.32),('8975','2013-03-08','12:35:00',2.92),('8975','2013-03-08','12:40:00',4.22),('8975','2013-03-08','12:45:00',4.92),('8975','2013-03-08','12:50:00',5.51),('8975','2013-03-08','12:55:00',4.7),('8975','2013-03-08','13:00:00',2.72),('8975','2013-03-08','13:05:00',4.11),('8975','2013-03-08','13:10:00',5.07),('8975','2013-03-08','13:15:00',4.33),('8975','2013-03-08','13:20:00',4.3),('8975','2013-03-08','13:25:00',3.87),('8975','2013-03-08','13:30:00',1.91),('8975','2013-03-08','13:35:00',4.41),('8975','2013-03-08','13:40:00',4.38),('8975','2013-03-08','13:45:00',2.86),('8975','2013-03-08','13:50:00',2.54),('8975','2013-03-08','13:55:00',3.39),('8975','2013-03-08','14:00:00',4.31),('8975','2013-03-08','14:05:00',4.08),('8975','2013-03-08','14:10:00',3.68),('8975','2013-03-08','14:15:00',3.74),('8975','2013-03-08','14:20:00',3.57),('8975','2013-03-08','14:25:00',3.47),('8975','2013-03-08','14:30:00',3.23),('8975','2013-03-08','14:35:00',3.11),('8975','2013-03-08','14:40:00',2.96),('8975','2013-03-08','14:45:00',3.03),('8975','2013-03-08','14:50:00',2.92),('8975','2013-03-08','14:55:00',2.83),('8975','2013-03-08','15:00:00',2.73),('8975','2013-03-08','15:05:00',2.62),('8975','2013-03-08','15:10:00',2.53),('8975','2013-03-08','15:15:00',2.42),('8975','2013-03-08','15:20:00',2.31),('8975','2013-03-08','15:25:00',2.16),('8975','2013-03-08','15:30:00',2.09),('8975','2013-03-08','15:35:00',1.99),('8975','2013-03-08','15:40:00',1.92),('8975','2013-03-08','15:45:00',1.82),('8975','2013-03-08','15:50:00',1.7),('8975','2013-03-08','15:55:00',1.67),('8975','2013-03-08','16:00:00',1.61),('8975','2013-03-08','16:05:00',1.59),('8975','2013-03-08','16:10:00',1.31),('8975','2013-03-08','16:15:00',1.59),('8975','2013-03-08','16:20:00',1.51),('8975','2013-03-08','16:25:00',1.58),('8975','2013-03-08','16:30:00',1.37),('8975','2013-03-08','16:35:00',1.2),('8975','2013-03-08','16:40:00',1.21),('8975','2013-03-07','08:10:00',1.92),('8975','2013-03-07','08:15:00',1.42),('8975','2013-03-07','08:20:00',1.3),('8975','2013-03-07','08:25:00',1.88),('8975','2013-03-07','08:30:00',2.71),('8975','2013-03-07','08:35:00',2.53),('8975','2013-03-07','08:40:00',1.35),('8975','2013-03-07','08:45:00',1.45),('8975','2013-03-07','08:50:00',1.19),('8975','2013-03-07','08:55:00',1.43),('8975','2013-03-07','09:00:00',1.54),('8975','2013-03-07','09:10:00',1.1),('8975','2013-03-07','09:15:00',1.3),('8975','2013-03-07','09:20:00',1.13),('8975','2013-03-07','09:25:00',1.79),('8975','2013-03-07','09:30:00',4.28),('8975','2013-03-07','09:35:00',5.65),('8975','2013-03-07','09:40:00',3.54),('8975','2013-03-07','09:45:00',4.02),('8975','2013-03-07','09:50:00',4.09),('8975','2013-03-07','09:55:00',3.83),('8975','2013-03-07','10:00:00',2.5),('8975','2013-03-07','10:05:00',2.58),('8975','2013-03-07','10:10:00',3.64),('8975','2013-03-07','10:15:00',2.05),('8975','2013-03-07','10:20:00',2.29),('8975','2013-03-07','10:25:00',5.78),('8975','2013-03-07','10:30:00',4.86),('8975','2013-03-07','10:35:00',3.04),('8975','2013-03-07','10:40:00',2.54),('8975','2013-03-07','10:45:00',1.92),('8975','2013-03-07','10:50:00',1.73),('8975','2013-03-07','10:55:00',1.62),('8975','2013-03-07','11:00:00',1.21),('8975','2013-03-07','11:15:00',1.07),('8975','2013-03-07','11:20:00',1.27),('8975','2013-03-07','11:25:00',1.44),('8975','2013-03-07','11:30:00',3.61),('8975','2013-03-07','11:35:00',4.41),('8975','2013-03-07','11:40:00',4.45),('8975','2013-03-07','11:45:00',4.62),('8975','2013-03-07','11:50:00',3.25),('8975','2013-03-07','11:55:00',3.29),('8975','2013-03-07','12:00:00',2.42),('8975','2013-03-07','12:05:00',1.91),('8975','2013-03-07','12:10:00',1.96),('8975','2013-03-07','12:15:00',2.64),('8975','2013-03-07','12:20:00',3.06),('8975','2013-03-07','12:25:00',2.57),('8975','2013-03-07','12:30:00',2.07),('8975','2013-03-07','12:35:00',3.53),('8975','2013-03-07','12:40:00',5.89),('8975','2013-03-07','12:45:00',4.82),('8975','2013-03-07','12:50:00',4.82),('8975','2013-03-07','12:55:00',4.96),('8975','2013-03-07','13:00:00',5.23),('8975','2013-03-07','13:05:00',4.02),('8975','2013-03-07','13:10:00',2.65),('8975','2013-03-07','13:15:00',2.25),('8975','2013-03-07','13:20:00',2.32),('8975','2013-03-07','13:25:00',2.88),('8975','2013-03-07','13:30:00',3.14),('8975','2013-03-07','13:35:00',2.66),('8975','2013-03-07','13:40:00',1.9),('8975','2013-03-07','13:45:00',1.39),('8975','2013-03-07','13:50:00',1.53),('8975','2013-03-07','13:55:00',1.49),('8975','2013-03-07','17:10:00',1.77),('8975','2013-03-07','17:15:00',1.4),('8975','2013-03-06','08:35:00',1.52),('8975','2013-03-06','08:40:00',1.86),('8975','2013-03-06','08:45:00',1.42),('8975','2013-03-06','08:50:00',1.56),('8975','2013-03-06','08:55:00',1.57),('8975','2013-03-06','09:00:00',1.38),('8975','2013-03-06','09:05:00',1.44),('8975','2013-03-06','09:10:00',1.03),('8975','2013-03-06','09:15:00',1.63),('8975','2013-03-06','09:20:00',1.21),('8975','2013-03-06','10:25:00',1.54),('8975','2013-03-06','10:30:00',1.25),('8975','2013-03-06','10:45:00',1.23),('8975','2013-03-06','10:50:00',2.1),('8975','2013-03-06','10:55:00',1.73),('8975','2013-03-06','11:00:00',1.88),('8975','2013-03-06','11:05:00',2.05),('8975','2013-03-06','11:10:00',1.34),('8975','2013-03-06','11:25:00',2.27),('8975','2013-03-06','11:30:00',3.85),('8975','2013-03-06','11:35:00',2.84),('8975','2013-03-06','11:40:00',2.27),('8975','2013-03-06','11:45:00',2.28),('8975','2013-03-06','11:50:00',2.25),('8975','2013-03-06','11:55:00',1.37),('8975','2013-03-06','12:00:00',1.66),('8975','2013-03-06','12:05:00',1.46),('8975','2013-03-06','12:20:00',1.56),('8975','2013-03-06','12:25:00',1.58),('8975','2013-03-06','12:30:00',1.25),('8975','2013-03-06','12:35:00',1.92),('8975','2013-03-06','12:40:00',2.74),('8975','2013-03-06','12:45:00',2.76),('8975','2013-03-06','12:50:00',2.33),('8975','2013-03-06','12:55:00',2.62),('8975','2013-03-06','13:00:00',2.73),('8975','2013-03-06','13:05:00',1.84),('8975','2013-03-06','13:10:00',2.17),('8975','2013-03-06','13:15:00',2.67),('8975','2013-03-06','13:20:00',3.06),('8975','2013-03-06','13:25:00',2.58),('8975','2013-03-06','13:30:00',2.54),('8975','2013-03-06','13:35:00',1.66),('8975','2013-03-06','13:50:00',1.15),('8975','2013-03-06','13:55:00',1.1),('8975','2013-03-06','14:00:00',1.4),('8975','2013-03-06','14:05:00',1.5),('8975','2013-03-06','14:10:00',1.35),('8975','2013-03-06','14:15:00',1.18),('8975','2013-03-06','14:20:00',1.16),('8975','2013-03-06','14:45:00',1.28),('8975','2013-03-06','15:40:00',1.05),('8975','2013-03-06','16:05:00',1.27),('8975','2013-03-06','16:10:00',1.22),('8975','2013-03-06','16:15:00',1.09),('8975','2013-03-06','16:35:00',1.24),('8975','2013-03-06','16:40:00',1.38),('8975','2013-03-04','07:35:00',1.09),('8975','2013-03-04','08:00:00',1.12),('8975','2013-03-04','08:05:00',1.4),('8975','2013-03-04','08:10:00',1.96),('8975','2013-03-04','08:15:00',2.21),('8975','2013-03-04','08:20:00',1.48),('8975','2013-03-04','08:25:00',2.55),('8975','2013-03-04','08:30:00',3.82),('8975','2013-03-04','08:35:00',2.64),('8975','2013-03-04','08:40:00',2.72),('8975','2013-03-04','08:45:00',2.86),('8975','2013-03-04','08:50:00',2.94),('8975','2013-03-04','08:55:00',2.53),('8975','2013-03-04','09:00:00',2.62),('8975','2013-03-04','09:05:00',2.87),('8975','2013-03-04','09:10:00',2.72),('8975','2013-03-04','09:15:00',2.49),('8975','2013-03-04','09:20:00',2.53),('8975','2013-03-04','09:25:00',2.46),('8975','2013-03-04','09:30:00',2.6),('8975','2013-03-04','09:35:00',2.76),('8975','2013-03-04','09:40:00',2.92),('8975','2013-03-04','09:45:00',2.92),('8975','2013-03-04','09:50:00',2.9),('8975','2013-03-04','09:55:00',2.79),('8975','2013-03-04','10:00:00',2.6),('8975','2013-03-04','10:05:00',2.74),('8975','2013-03-04','10:10:00',2.88),('8975','2013-03-04','10:15:00',3.25),('8975','2013-03-04','10:20:00',3.47),('8975','2013-03-04','10:25:00',2.93),('8975','2013-03-04','10:30:00',3.09),('8975','2013-03-04','10:35:00',3.56),('8975','2013-03-04','10:40:00',3.56),('8975','2013-03-04','10:45:00',3.77),('8975','2013-03-04','10:50:00',4.08),('8975','2013-03-04','10:55:00',4.04),('8975','2013-03-04','11:00:00',3.6),('8975','2013-03-04','11:05:00',4.05),('8975','2013-03-04','11:10:00',4.11),('8975','2013-03-04','11:15:00',4.11),('8975','2013-03-04','11:20:00',4.03),('8975','2013-03-04','11:25:00',3.9),('8975','2013-03-04','11:30:00',3.63),('8975','2013-03-04','11:35:00',3.98),('8975','2013-03-04','11:40:00',4.79),('8975','2013-03-04','11:45:00',4.23),('8975','2013-03-04','11:50:00',4.61),('8975','2013-03-04','11:55:00',4.75),('8975','2013-03-04','12:00:00',4.48),('8975','2013-03-04','12:05:00',4.65),('8975','2013-03-04','12:10:00',4.48),('8975','2013-03-04','12:15:00',3.93),('8975','2013-03-04','12:20:00',3.92),('8975','2013-03-04','12:25:00',4.37),('8975','2013-03-04','12:30:00',3.49),('8975','2013-03-04','12:35:00',2.71),('8975','2013-03-04','12:40:00',3.24),('8975','2013-03-04','12:45:00',3.43),('8975','2013-03-04','12:50:00',3.23),('8975','2013-03-04','12:55:00',2.92),('8975','2013-03-04','13:00:00',2.63),('8975','2013-03-04','13:05:00',2.6),('8975','2013-03-04','13:10:00',2.74),('8975','2013-03-04','13:15:00',2.88),('8975','2013-03-04','13:20:00',2.73),('8975','2013-03-04','13:25:00',2.52),('8975','2013-03-04','13:30:00',2.34),('8975','2013-03-04','13:35:00',2.28),('8975','2013-03-04','13:40:00',2.15),('8975','2013-03-04','13:45:00',1.96),('8975','2013-03-04','13:50:00',1.77),('8975','2013-03-04','13:55:00',1.66),('8975','2013-03-04','14:00:00',1.66),('8975','2013-03-04','14:05:00',1.7),('8975','2013-03-04','14:10:00',1.77),('8975','2013-03-04','14:15:00',1.66),('8975','2013-03-04','14:20:00',1.54),('8975','2013-03-04','14:25:00',1.55),('8975','2013-03-04','14:30:00',1.49),('8975','2013-03-04','14:35:00',1.52),('8975','2013-03-04','14:40:00',1.59),('8975','2013-03-04','14:45:00',1.65),('8975','2013-03-04','14:50:00',1.59),('8975','2013-03-04','14:55:00',1.41),('8975','2013-03-04','15:00:00',1.28),('8975','2013-03-04','15:05:00',1.19),('8975','2013-03-04','15:20:00',1.01),('8975','2013-03-04','15:25:00',1.16),('8975','2013-03-04','15:30:00',1.33),('8975','2013-03-04','15:35:00',1.34),('8975','2013-03-04','15:40:00',1.43),('8975','2013-03-04','15:45:00',1.66),('8975','2013-03-04','15:50:00',1.57),('8975','2013-03-04','15:55:00',1.39),('8975','2013-03-04','16:00:00',1.27),('8975','2013-03-04','16:05:00',1.08),('8975','2013-03-03','07:15:00',1.19),('8975','2013-03-03','07:20:00',1.4),('8975','2013-03-03','07:25:00',1.57),('8975','2013-03-03','07:30:00',1.82),('8975','2013-03-03','07:35:00',2),('8975','2013-03-03','07:40:00',2.16),('8975','2013-03-03','07:45:00',2.32),('8975','2013-03-03','07:50:00',2.46),('8975','2013-03-03','07:55:00',2.6),('8975','2013-03-03','08:00:00',2.72),('8975','2013-03-03','08:05:00',2.87),('8975','2013-03-03','08:10:00',2.98),('8975','2013-03-03','08:15:00',3.07),('8975','2013-03-03','08:20:00',3.18),('8975','2013-03-03','08:25:00',3.28),('8975','2013-03-03','08:30:00',3.36),('8975','2013-03-03','08:35:00',3.45),('8975','2013-03-03','08:40:00',3.54),('8975','2013-03-03','08:45:00',3.64),('8975','2013-03-03','08:50:00',3.73),('8975','2013-03-03','08:55:00',3.8),('8975','2013-03-03','09:00:00',3.94),('8975','2013-03-03','09:05:00',4.03),('8975','2013-03-03','09:10:00',4.09),('8975','2013-03-03','09:15:00',4.21),('8975','2013-03-03','09:20:00',4.24),('8975','2013-03-03','09:25:00',4.32),('8975','2013-03-03','09:30:00',4.45),('8975','2013-03-03','09:35:00',4.51),('8975','2013-03-03','09:40:00',4.61),('8975','2013-03-03','09:45:00',4.72),('8975','2013-03-03','09:50:00',4.76),('8975','2013-03-03','09:55:00',4.84),('8975','2013-03-03','10:00:00',4.86),('8975','2013-03-03','10:05:00',4.93),('8975','2013-03-03','10:10:00',4.93),('8975','2013-03-03','10:15:00',4.98),('8975','2013-03-03','10:20:00',5.02),('8975','2013-03-03','10:25:00',5.08),('8975','2013-03-03','10:30:00',5.09),('8975','2013-03-03','10:35:00',5.13),('8975','2013-03-03','10:40:00',5.19),('8975','2013-03-03','10:45:00',5.22),('8975','2013-03-03','10:50:00',5.19),('8975','2013-03-03','10:55:00',5.21),('8975','2013-03-03','11:00:00',5.21),('8975','2013-03-03','11:05:00',5.31),('8975','2013-03-03','11:10:00',5.2),('8975','2013-03-03','11:15:00',5.24),('8975','2013-03-03','11:20:00',5.25),('8975','2013-03-03','11:25:00',5.26),('8975','2013-03-03','11:30:00',5.29),('8975','2013-03-03','11:35:00',5.33),('8975','2013-03-03','11:40:00',5.32),('8975','2013-03-03','11:45:00',5.3),('8975','2013-03-03','11:50:00',5.17),('8975','2013-03-03','11:55:00',5.14),('8975','2013-03-03','12:00:00',5.18),('8975','2013-03-03','12:05:00',5.19),('8975','2013-03-03','12:10:00',5.1),('8975','2013-03-03','12:15:00',5.12),('8975','2013-03-03','12:20:00',5.16),('8975','2013-03-03','12:25:00',5),('8975','2013-03-03','12:30:00',4.98),('8975','2013-03-03','12:35:00',4.87),('8975','2013-03-03','12:40:00',4.79),('8975','2013-03-03','12:45:00',4.8),('8975','2013-03-03','12:50:00',4.68),('8975','2013-03-03','12:55:00',4.58),('8975','2013-03-03','13:00:00',4.53),('8975','2013-03-03','13:05:00',4.48),('8975','2013-03-03','13:10:00',4.25),('8975','2013-03-03','13:15:00',3.93),('8975','2013-03-03','13:20:00',1.27),('8975','2013-03-03','13:25:00',3.77),('8975','2013-03-03','13:30:00',4.06),('8975','2013-03-03','13:35:00',4.52),('8975','2013-03-03','13:40:00',4.27),('8975','2013-03-03','13:45:00',3.95),('8975','2013-03-03','13:50:00',3.89),('8975','2013-03-03','13:55:00',3.64),('8975','2013-03-03','14:00:00',3.55),('8975','2013-03-03','14:05:00',3.53),('8975','2013-03-03','14:10:00',3.36),('8975','2013-03-03','14:15:00',3.4),('8975','2013-03-03','14:20:00',3.4),('8975','2013-03-03','14:25:00',3.05),('8975','2013-03-03','14:30:00',2.98),('8975','2013-03-03','14:35:00',2.94),('8975','2013-03-03','14:40:00',2.7),('8975','2013-03-03','14:45:00',2.75),('8975','2013-03-03','14:50:00',2.65),('8975','2013-03-03','14:55:00',2.34),('8975','2013-03-03','15:00:00',2.57),('8975','2013-03-03','15:05:00',2.37),('8975','2013-03-03','15:10:00',2.27),('8975','2013-03-03','15:15:00',2.22),('8975','2013-03-03','15:20:00',2.12),('8975','2013-03-03','15:25:00',2.01),('8975','2013-03-03','15:30:00',1.93),('8975','2013-03-03','15:35:00',1.83),('8975','2013-03-03','15:40:00',1.78),('8975','2013-03-03','15:45:00',1.73),('8975','2013-03-03','15:50:00',1.64),('8975','2013-03-03','15:55:00',1.59),('8975','2013-03-03','16:00:00',1.53),('8975','2013-03-03','16:05:00',1.46),('8975','2013-03-03','16:10:00',1.39),('8975','2013-03-03','16:15:00',1.39),('8975','2013-03-03','16:20:00',1.37),('8975','2013-03-03','16:25:00',1.34),('8975','2013-03-03','16:30:00',1.29),('8975','2013-03-03','16:35:00',1.21),('8975','2013-03-03','16:40:00',1.13),('8975','2013-03-03','16:45:00',1.07),('8975','2013-03-03','16:50:00',1.02),('8975','2013-03-02','07:10:00',1.08),('8975','2013-03-02','07:15:00',1.46),('8975','2013-03-02','07:20:00',1.69),('8975','2013-03-02','07:25:00',1.88),('8975','2013-03-02','07:30:00',2.09),('8975','2013-03-02','07:35:00',2.27),('8975','2013-03-02','07:40:00',2.43),('8975','2013-03-02','07:45:00',2.58),('8975','2013-03-02','07:50:00',2.74),('8975','2013-03-02','07:55:00',2.86),('8975','2013-03-02','08:00:00',2.98),('8975','2013-03-02','08:05:00',3.08),('8975','2013-03-02','08:10:00',3.17),('8975','2013-03-02','08:15:00',3.25),('8975','2013-03-02','08:20:00',3.35),('8975','2013-03-02','08:25:00',3.5),('8975','2013-03-02','08:30:00',3.57),('8975','2013-03-02','08:35:00',3.65),('8975','2013-03-02','08:40:00',3.74),('8975','2013-03-02','08:45:00',3.83),('8975','2013-03-02','08:50:00',3.91),('8975','2013-03-02','08:55:00',3.99),('8975','2013-03-02','09:00:00',4.08),('8975','2013-03-02','09:05:00',4.16),('8975','2013-03-02','09:10:00',4.24),('8975','2013-03-02','09:15:00',4.32),('8975','2013-03-02','09:20:00',4.41),('8975','2013-03-02','09:25:00',4.5),('8975','2013-03-02','09:30:00',4.63),('8975','2013-03-02','09:35:00',4.69),('8975','2013-03-02','09:40:00',4.77),('8975','2013-03-02','09:45:00',4.83),('8975','2013-03-02','09:50:00',4.96),('8975','2013-03-02','09:55:00',5.05),('8975','2013-03-02','10:00:00',4.96),('8975','2013-03-02','10:05:00',5.14),('8975','2013-03-02','10:10:00',5.22),('8975','2013-03-02','10:15:00',5.27),('8975','2013-03-02','10:20:00',5.34),('8975','2013-03-02','10:25:00',5.39),('8975','2013-03-02','10:30:00',5.43),('8975','2013-03-02','10:35:00',5.46),('8975','2013-03-02','10:40:00',5.48),('8975','2013-03-02','10:45:00',5.48),('8975','2013-03-02','10:50:00',5.49),('8975','2013-03-02','10:55:00',5.5),('8975','2013-03-02','11:00:00',5.51),('8975','2013-03-02','11:05:00',5.53),('8975','2013-03-02','11:10:00',5.55),('8975','2013-03-02','11:15:00',5.52),('8975','2013-03-02','11:20:00',5.51),('8975','2013-03-02','11:25:00',5.52),('8975','2013-03-02','11:30:00',5.54),('8975','2013-03-02','11:35:00',5.51),('8975','2013-03-02','11:40:00',5.5),('8975','2013-03-02','11:45:00',5.47),('8975','2013-03-02','11:50:00',5.48),('8975','2013-03-02','11:55:00',5.41),('8975','2013-03-02','12:00:00',5.33),('8975','2013-03-02','12:05:00',5.34),('8975','2013-03-02','12:10:00',5.34),('8975','2013-03-02','12:15:00',5.28),('8975','2013-03-02','12:20:00',5.23),('8975','2013-03-02','12:25:00',5.17),('8975','2013-03-02','12:30:00',5.13),('8975','2013-03-02','12:35:00',5.1),('8975','2013-03-02','12:40:00',5.04),('8975','2013-03-02','12:45:00',4.98),('8975','2013-03-02','12:50:00',4.92),('8975','2013-03-02','12:55:00',4.89),('8975','2013-03-02','13:00:00',4.82),('8975','2013-03-02','13:05:00',4.7),('8975','2013-03-02','13:10:00',4.63),('8975','2013-03-02','13:15:00',4.36),('8975','2013-03-02','13:20:00',4.33),('8975','2013-03-02','13:25:00',4.34),('8975','2013-03-02','13:30:00',4.23),('8975','2013-03-02','13:35:00',4.23),('8975','2013-03-02','13:40:00',4.23),('8975','2013-03-02','13:45:00',4.14),('8975','2013-03-02','13:50:00',4.04),('8975','2013-03-02','13:55:00',3.77),('8975','2013-03-02','14:00:00',3.69),('8975','2013-03-02','14:05:00',3.65),('8975','2013-03-02','14:10:00',3.55),('8975','2013-03-02','14:15:00',3.41),('8975','2013-03-02','14:20:00',3.37),('8975','2013-03-02','14:25:00',3.21),('8975','2013-03-02','14:30:00',3.01),('8975','2013-03-02','14:35:00',3.01),('8975','2013-03-02','14:40:00',2.95),('8975','2013-03-02','14:45:00',2.84),('8975','2013-03-02','14:50:00',2.76),('8975','2013-03-02','14:55:00',2.66),('8975','2013-03-02','15:00:00',2.53),('8975','2013-03-02','15:05:00',2.47),('8975','2013-03-02','15:10:00',2.38),('8975','2013-03-02','15:15:00',2.29),('8975','2013-03-02','15:20:00',2.15),('8975','2013-03-02','15:25:00',2.06),('8975','2013-03-02','15:30:00',1.98),('8975','2013-03-02','15:35:00',1.87),('8975','2013-03-02','15:40:00',1.81),('8975','2013-03-02','15:45:00',1.73),('8975','2013-03-02','15:50:00',1.67),('8975','2013-03-02','15:55:00',1.62),('8975','2013-03-02','16:00:00',1.56),('8975','2013-03-02','16:05:00',1.52),('8975','2013-03-02','16:10:00',1.48),('8975','2013-03-02','16:15:00',1.44),('8975','2013-03-02','16:20:00',1.4),('8975','2013-03-02','16:25:00',1.36),('8975','2013-03-02','16:30:00',1.31),('8975','2013-03-02','16:35:00',1.25),('8975','2013-03-02','16:40:00',1.21),('8975','2013-03-02','16:45:00',1.15),('8975','2013-03-02','16:50:00',1.09),('8975','2013-03-02','16:55:00',1.03),('8975','2014-03-23','07:45:00',1.98),('8975','2014-03-23','07:50:00',1.48),('8975','2014-03-23','07:55:00',1.2),('8975','2014-03-23','08:35:00',1.31),('8975','2014-03-23','08:40:00',1.31),('8975','2014-03-23','08:45:00',1.16),('8975','2014-03-23','08:50:00',1.52),('8975','2014-03-23','08:55:00',2.66),('8975','2014-03-23','09:00:00',3.12),('8975','2014-03-23','09:05:00',1.54),('8975','2014-03-23','09:15:00',2.66),('8975','2014-03-23','09:20:00',1.57),('8975','2014-03-23','09:25:00',1.48),('8975','2014-03-23','09:30:00',2.22),('8975','2014-03-23','09:35:00',1.55),('8975','2014-03-23','09:40:00',2.8),('8975','2014-03-23','09:45:00',1.33),('8975','2014-03-23','09:50:00',1.53),('8975','2014-03-23','09:55:00',1.53),('8975','2014-03-23','10:00:00',3.44),('8975','2014-03-23','10:05:00',3.74),('8975','2014-03-23','10:10:00',7.26),('8975','2014-03-23','10:15:00',4.03),('8975','2014-03-23','10:20:00',1.56),('8975','2014-03-23','10:25:00',1.07),('8975','2014-03-23','10:30:00',1.22),('8975','2014-03-23','10:35:00',3.83),('8975','2014-03-23','10:40:00',1.89),('8975','2014-03-23','10:45:00',4.08),('8975','2014-03-23','10:50:00',6.34),('8975','2014-03-23','10:55:00',2.29),('8975','2014-03-23','11:00:00',3.95),('8975','2014-03-23','11:05:00',3.63),('8975','2014-03-23','11:10:00',4.78),('8975','2014-03-23','11:15:00',4.73),('8975','2014-03-23','11:20:00',3.08),('8975','2014-03-23','11:25:00',4.73),('8975','2014-03-23','11:30:00',6.47),('8975','2014-03-23','11:35:00',2.06),('8975','2014-03-23','11:40:00',1.37),('8975','2014-03-23','11:45:00',1.01),('8975','2014-03-23','11:55:00',1.36),('8975','2014-03-23','12:00:00',1.1),('8975','2014-03-23','12:20:00',1.25),('8975','2014-03-23','12:25:00',1.31),('8975','2014-03-23','12:30:00',1.66),('8975','2014-03-23','12:35:00',2.62),('8975','2014-03-23','12:40:00',2.88),('8975','2014-03-23','12:45:00',2.69),('8975','2014-03-23','12:50:00',2.17),('8975','2014-03-23','12:55:00',1.96),('8975','2014-03-23','13:00:00',2.04),('8975','2014-03-23','13:05:00',1.91),('8975','2014-03-23','13:10:00',1.57),('8975','2014-03-23','13:25:00',1.24),('8975','2014-03-23','13:30:00',1.92),('8975','2014-03-23','13:35:00',1.72),('8975','2014-03-23','13:40:00',1.18),('8975','2014-03-23','13:45:00',1.5),('8975','2014-03-23','13:50:00',2.04),('8975','2014-03-23','13:55:00',1.92),('8975','2014-03-23','14:00:00',1.79),('8975','2014-03-23','14:05:00',1.57),('8975','2014-03-23','14:10:00',2.03),('8975','2014-03-23','14:15:00',2.77),('8975','2014-03-23','14:20:00',3.27),('8975','2014-03-23','14:25:00',2.99),('8975','2014-03-23','14:30:00',2.98),('8975','2014-03-23','14:35:00',3.18),('8975','2014-03-23','14:40:00',3.58),('8975','2014-03-23','14:45:00',3.65),('8975','2014-03-23','14:50:00',3.5),('8975','2014-03-23','14:55:00',3.13),('8975','2014-03-23','15:00:00',2.78),('8975','2014-03-23','15:05:00',2.75),('8975','2014-03-23','15:10:00',2.35),('8975','2014-03-23','15:15:00',2.34),('8975','2014-03-23','15:20:00',2.09),('8975','2014-03-23','15:25:00',1.99),('8975','2014-03-23','15:30:00',2.36),('8975','2014-03-23','15:35:00',2.25),('8975','2014-03-23','15:40:00',1.92),('8975','2014-03-23','15:45:00',1.41),('8975','2014-03-23','15:50:00',1.6),('8975','2014-03-23','15:55:00',1.95),('8975','2014-03-23','16:00:00',2.4),('8975','2014-03-23','16:05:00',1.8),('8975','2014-03-23','16:10:00',1.59),('8975','2014-03-23','16:15:00',1.51),('8975','2013-03-01','09:45:00',1.17),('8975','2013-03-01','09:50:00',1.21),('8975','2013-03-01','09:55:00',1.06),('8975','2013-03-01','10:00:00',1.09),('8975','2013-03-01','10:05:00',1.13),('8975','2013-03-01','10:15:00',1.02),('8975','2013-03-01','10:20:00',1.2),('8975','2013-03-01','10:25:00',1.11),('8975','2013-03-01','10:30:00',1.14),('8975','2013-03-01','10:35:00',1.33),('8975','2013-03-01','10:40:00',1.46),('8975','2013-03-01','10:45:00',1.46),('8975','2013-03-01','10:50:00',1.63),('8975','2013-03-01','10:55:00',1.7),('8975','2013-03-01','11:00:00',1.78),('8975','2013-03-01','11:05:00',1.47),('8975','2013-03-01','11:10:00',1.75),('8975','2013-03-01','11:15:00',2.05),('8975','2013-03-01','11:20:00',1.96),('8975','2013-03-01','11:25:00',1.64),('8975','2013-03-01','11:30:00',1.49),('8975','2013-03-01','11:35:00',1.59),('8975','2013-03-01','11:40:00',1.68),('8975','2013-03-01','11:45:00',1.53),('8975','2013-03-01','11:50:00',1.61),('8975','2013-03-01','11:55:00',1.49),('8975','2013-03-01','12:00:00',1.51),('8975','2013-03-01','12:05:00',1.77),('8975','2013-03-01','12:10:00',1.79),('8975','2013-03-01','12:15:00',1.88),('8975','2013-03-01','12:20:00',1.6),('8975','2013-03-01','12:25:00',1.76),('8975','2013-03-01','12:30:00',2.09),('8975','2013-03-01','12:35:00',2.11),('8975','2013-03-01','12:40:00',2.37),('8975','2013-03-01','12:45:00',2.23),('8975','2013-03-01','12:50:00',2.24),('8975','2013-03-01','12:55:00',2.94),('8975','2013-03-01','13:00:00',3.43),('8975','2013-03-01','13:05:00',3.59),('8975','2013-03-01','13:10:00',2.28),('8975','2013-03-01','13:15:00',1.65),('8975','2013-03-01','13:20:00',1.53),('8975','2013-03-01','13:25:00',1.54),('8975','2013-03-01','13:30:00',1.56),('8975','2013-03-01','13:35:00',1.6),('8975','2013-03-01','13:40:00',1.67),('8975','2013-03-01','13:45:00',1.78),('8975','2013-03-01','13:50:00',1.75),('8975','2013-03-01','13:55:00',1.79),('8975','2013-03-01','14:00:00',2.02),('8975','2013-03-01','14:05:00',2.07),('8975','2013-03-01','14:10:00',1.9),('8975','2013-03-01','14:15:00',1.67),('8975','2013-03-01','14:20:00',1.62),('8975','2013-03-01','14:25:00',1.49),('8975','2013-03-01','14:30:00',1.05),('8975','2013-03-01','14:55:00',1.18),('8975','2013-03-01','15:00:00',1.22),('8975','2013-03-01','15:05:00',1.31),('8975','2013-03-01','15:10:00',1.31),('8975','2013-03-01','15:15:00',1.32),('8975','2013-03-01','15:20:00',1.29),('8975','2013-03-01','15:25:00',1.17),('8975','2013-03-01','15:30:00',1.34),('8975','2013-03-01','15:35:00',1.38),('8975','2013-03-01','15:40:00',1.28),('8975','2013-03-01','15:45:00',1.31),('8975','2013-03-01','15:50:00',1.14),('8975','2013-03-01','15:55:00',1.11),('8975','2013-03-01','16:00:00',1.09),('8975','2013-02-28','07:45:00',1.17),('8975','2013-02-28','07:50:00',1.54),('8975','2013-02-28','07:55:00',1.94),('8975','2013-02-28','08:00:00',2.08),('8975','2013-02-28','08:05:00',1.99),('8975','2013-02-28','08:10:00',1.86),('8975','2013-02-28','08:15:00',2.07),('8975','2013-02-28','08:20:00',2.16),('8975','2013-02-28','08:25:00',2.18),('8975','2013-02-28','08:30:00',2.36),('8975','2013-02-28','08:35:00',2.55),('8975','2013-02-28','08:40:00',2.91),('8975','2013-02-28','08:45:00',3),('8975','2013-02-28','08:50:00',2.94),('8975','2013-02-28','08:55:00',3.03),('8975','2013-02-28','09:00:00',3.3),('8975','2013-02-28','09:05:00',3.32),('8975','2013-02-28','09:10:00',3.13),('8975','2013-02-28','09:15:00',3.33),('8975','2013-02-28','09:20:00',3.36),('8975','2013-02-28','09:25:00',3.46),('8975','2013-02-28','09:30:00',3.73),('8975','2013-02-28','09:35:00',3.88),('8975','2013-02-28','09:40:00',4.03),('8975','2013-02-28','09:45:00',4.04),('8975','2013-02-28','09:50:00',4),('8975','2013-02-28','09:55:00',4.05),('8975','2013-02-28','10:00:00',4.13),('8975','2013-02-28','10:05:00',3.68),('8975','2013-02-28','10:10:00',3.23),('8975','2013-02-28','10:15:00',3.37),('8975','2013-02-28','10:20:00',3.77),('8975','2013-02-28','10:25:00',3.95),('8975','2013-02-28','10:30:00',4.2),('8975','2013-02-28','10:35:00',3.92),('8975','2013-02-28','10:40:00',3.68),('8975','2013-02-28','10:45:00',3.26),('8975','2013-02-28','10:50:00',3.07),('8975','2013-02-28','10:55:00',2.75),('8975','2013-02-28','11:00:00',2.48),('8975','2013-02-28','11:05:00',2.37),('8975','2013-02-28','11:10:00',2.62),('8975','2013-02-28','11:15:00',2.86),('8975','2013-02-28','11:20:00',2.88),('8975','2013-02-28','11:25:00',2.92),('8975','2013-02-28','11:30:00',3.01),('8975','2013-02-28','11:35:00',2.88),('8975','2013-02-28','11:40:00',2.74),('8975','2013-02-28','11:45:00',2.7),('8975','2013-02-28','11:50:00',2.59),('8975','2013-02-28','11:55:00',2.51),('8975','2013-02-28','12:00:00',2.43),('8975','2013-02-28','12:05:00',2.29),('8975','2013-02-28','12:10:00',2.12),('8975','2013-02-28','12:15:00',1.9),('8975','2013-02-28','12:20:00',1.8),('8975','2013-02-28','12:25:00',1.83),('8975','2013-02-28','12:30:00',1.87),('8975','2013-02-28','12:35:00',1.82),('8975','2013-02-28','12:40:00',1.79),('8975','2013-02-28','12:45:00',1.81),('8975','2013-02-28','12:50:00',1.86),('8975','2013-02-28','12:55:00',1.99),('8975','2013-02-28','13:00:00',2.07),('8975','2013-02-28','13:05:00',2.09),('8975','2013-02-28','13:10:00',2.17),('8975','2013-02-28','13:15:00',2.32),('8975','2013-02-28','13:20:00',2.53),('8975','2013-02-28','13:25:00',2.64),('8975','2013-02-28','13:30:00',2.53),('8975','2013-02-28','13:35:00',2.39),('8975','2013-02-28','13:40:00',2.32),('8975','2013-02-28','13:45:00',2.33),('8975','2013-02-28','13:50:00',2.27),('8975','2013-02-28','13:55:00',2.18),('8975','2013-02-28','14:00:00',2.1),('8975','2013-02-28','14:05:00',2),('8975','2013-02-28','14:10:00',1.87),('8975','2013-02-28','14:15:00',1.78),('8975','2013-02-28','14:20:00',1.73),('8975','2013-02-28','14:25:00',1.74),('8975','2013-02-28','14:30:00',1.79),('8975','2013-02-28','14:35:00',1.77),('8975','2013-02-28','14:40:00',1.69),('8975','2013-02-28','14:45:00',1.58),('8975','2013-02-28','14:50:00',1.52),('8975','2013-02-28','14:55:00',1.52),('8975','2013-02-28','15:00:00',1.51),('8975','2013-02-28','15:05:00',1.42),('8975','2013-02-28','15:10:00',1.29),('8975','2013-02-28','15:15:00',1.24),('8975','2013-02-28','15:20:00',1.15),('8975','2013-02-28','15:25:00',1.02),('8975','2013-02-28','15:40:00',1.06),('8975','2013-02-28','15:45:00',1.02),('8975','2013-02-27','07:25:00',1.12),('8975','2013-02-27','07:30:00',1.31),('8975','2013-02-27','07:35:00',1.5),('8975','2013-02-27','07:40:00',1.68),('8975','2013-02-27','07:45:00',1.85),('8975','2013-02-27','07:50:00',1.97),('8975','2013-02-27','07:55:00',2.13),('8975','2013-02-27','08:00:00',2.27),('8975','2013-02-27','08:05:00',2.41),('8975','2013-02-27','08:10:00',2.55),('8975','2013-02-27','08:15:00',2.67),('8975','2013-02-27','08:20:00',2.77),('8975','2013-02-27','08:25:00',2.91),('8975','2013-02-27','08:30:00',3),('8975','2013-02-27','08:35:00',3.1),('8975','2013-02-27','08:40:00',3.2),('8975','2013-02-27','08:45:00',3.31),('8975','2013-02-27','08:50:00',3.39),('8975','2013-02-27','08:55:00',3.51),('8975','2013-02-27','09:00:00',3.61),('8975','2013-02-27','09:05:00',3.68),('8975','2013-02-27','09:10:00',3.7),('8975','2013-02-27','09:15:00',3.86),('8975','2013-02-27','09:20:00',3.94),('8975','2013-02-27','09:25:00',4.02),('8975','2013-02-27','09:30:00',4.11),('8975','2013-02-27','09:35:00',4.2),('8975','2013-02-27','09:40:00',4.27),('8975','2013-02-27','09:45:00',4.38),('8975','2013-02-27','09:50:00',4.21),('8975','2013-02-27','09:55:00',4.45),('8975','2013-02-27','10:00:00',4.47),('8975','2013-02-27','10:05:00',4.41),('8975','2013-02-27','10:10:00',4.65),('8975','2013-02-27','10:15:00',4.73),('8975','2013-02-27','10:20:00',4.73),('8975','2013-02-27','10:25:00',4.73),('8975','2013-02-27','10:30:00',4.68),('8975','2013-02-27','10:35:00',4.85),('8975','2013-02-27','10:40:00',4.7),('8975','2013-02-27','10:45:00',4.9),('8975','2013-02-27','10:50:00',4.9),('8975','2013-02-27','10:55:00',4.94),('8975','2013-02-27','11:00:00',4.99),('8975','2013-02-27','11:05:00',4.99),('8975','2013-02-27','11:10:00',5.04),('8975','2013-02-27','11:15:00',4.98),('8975','2013-02-27','11:20:00',5.01),('8975','2013-02-27','11:25:00',5.09),('8975','2013-02-27','11:30:00',5.01),('8975','2013-02-27','11:35:00',5),('8975','2013-02-27','11:40:00',4.96),('8975','2013-02-27','11:45:00',5.03),('8975','2013-02-27','11:50:00',4.99),('8975','2013-02-27','11:55:00',5.01),('8975','2013-02-27','12:00:00',4.89),('8975','2013-02-27','12:05:00',4.77),('8975','2013-02-27','12:10:00',3.52),('8975','2013-02-27','12:15:00',4.68),('8975','2013-02-27','12:20:00',4.22),('8975','2013-02-27','12:25:00',4.61),('8975','2013-02-27','12:30:00',4.7),('8975','2013-02-27','12:35:00',4.66),('8975','2013-02-27','12:40:00',4.16),('8975','2013-02-27','12:45:00',4.5),('8975','2013-02-27','12:50:00',4.48),('8975','2013-02-27','12:55:00',4.59),('8975','2013-02-27','13:00:00',4.37),('8975','2013-02-27','13:05:00',4.25),('8975','2013-02-27','13:10:00',3.36),('8975','2013-02-27','13:15:00',2.42),('8975','2013-02-27','13:20:00',4),('8975','2013-02-27','13:25:00',3.75),('8975','2013-02-27','13:30:00',1.53),('8975','2013-02-27','13:35:00',1.14),('8975','2013-02-27','13:40:00',1.23),('8975','2013-02-27','13:45:00',3.15),('8975','2013-02-27','13:50:00',2.13),('8975','2013-02-27','13:55:00',2.83),('8975','2013-02-27','14:00:00',3.28),('8975','2013-02-27','14:05:00',3.25),('8975','2013-02-27','14:10:00',3.29),('8975','2013-02-27','14:15:00',3.38),('8975','2013-02-27','14:20:00',3.12),('8975','2013-02-27','14:25:00',3.01),('8975','2013-02-27','14:30:00',2.87),('8975','2013-02-27','14:35:00',2.58),('8975','2013-02-27','14:40:00',2.79),('8975','2013-02-27','14:45:00',2.68),('8975','2013-02-27','14:50:00',2.57),('8975','2013-02-27','14:55:00',2.49),('8975','2013-02-27','15:00:00',2.38),('8975','2013-02-27','15:05:00',2.28),('8975','2013-02-27','15:10:00',2.17),('8975','2013-02-27','15:15:00',2.07),('8975','2013-02-27','15:20:00',1.96),('8975','2013-02-27','15:25:00',1.87),('8975','2013-02-27','15:30:00',1.81),('8975','2013-02-27','15:35:00',1.71),('8975','2013-02-27','15:40:00',1.66),('8975','2013-02-27','15:45:00',1.62),('8975','2013-02-27','15:50:00',1.57),('8975','2013-02-27','15:55:00',1.5),('8975','2013-02-27','16:00:00',1.46),('8975','2013-02-27','16:05:00',1.42),('8975','2013-02-27','16:10:00',1.36),('8975','2013-02-27','16:15:00',1.31),('8975','2013-02-27','16:20:00',1.26),('8975','2013-02-27','16:25:00',1.2),('8975','2013-02-27','16:30:00',1.14),('8975','2013-02-27','16:35:00',1.1),('8975','2013-02-27','16:40:00',1.04),('8975','2013-02-26','07:30:00',1.21),('8975','2013-02-26','07:35:00',1.39),('8975','2013-02-26','07:40:00',1.56),('8975','2013-02-26','07:45:00',1.73),('8975','2013-02-26','07:50:00',1.88),('8975','2013-02-26','07:55:00',2.06),('8975','2013-02-26','08:00:00',2.24),('8975','2013-02-26','08:05:00',2.36),('8975','2013-02-26','08:10:00',2.46),('8975','2013-02-26','08:15:00',2.56),('8975','2013-02-26','08:20:00',2.68),('8975','2013-02-26','08:25:00',2.78),('8975','2013-02-26','08:30:00',2.88),('8975','2013-02-26','08:35:00',2.99),('8975','2013-02-26','08:40:00',3.1),('8975','2013-02-26','08:45:00',3.2),('8975','2013-02-26','08:50:00',3.3),('8975','2013-02-26','08:55:00',3.38),('8975','2013-02-26','09:00:00',3.46),('8975','2013-02-26','09:05:00',3.56),('8975','2013-02-26','09:10:00',3.67),('8975','2013-02-26','09:15:00',3.79),('8975','2013-02-26','09:20:00',3.83),('8975','2013-02-26','09:25:00',3.87),('8975','2013-02-26','09:30:00',3.99),('8975','2013-02-26','09:35:00',4.1),('8975','2013-02-26','09:40:00',4.21),('8975','2013-02-26','09:45:00',4.29),('8975','2013-02-26','09:50:00',4.36),('8975','2013-02-26','09:55:00',4.43),('8975','2013-02-26','10:00:00',4.48),('8975','2013-02-26','10:05:00',4.37),('8975','2013-02-26','10:10:00',4.57),('8975','2013-02-26','10:15:00',4.63),('8975','2013-02-26','10:20:00',4.71),('8975','2013-02-26','10:25:00',4.72),('8975','2013-02-26','10:30:00',4.84),('8975','2013-02-26','10:35:00',4.83),('8975','2013-02-26','10:40:00',4.93),('8975','2013-02-26','10:45:00',4.89),('8975','2013-02-26','10:50:00',4.94),('8975','2013-02-26','10:55:00',4.97),('8975','2013-02-26','11:00:00',5.02),('8975','2013-02-26','11:05:00',5.07),('8975','2013-02-26','11:10:00',4.32),('8975','2013-02-26','11:15:00',4.33),('8975','2013-02-26','11:20:00',5.23),('8975','2013-02-26','11:25:00',5.2),('8975','2013-02-26','11:30:00',5.26),('8975','2013-02-26','11:35:00',5.4),('8975','2013-02-26','11:40:00',5.41),('8975','2013-02-26','11:45:00',5.43),('8975','2013-02-26','11:50:00',5.35),('8975','2013-02-26','11:55:00',5.44),('8975','2013-02-26','12:00:00',5.45),('8975','2013-02-26','12:05:00',5.33),('8975','2013-02-26','12:10:00',4.7),('8975','2013-02-26','12:15:00',5.13),('8975','2013-02-26','12:20:00',5.33),('8975','2013-02-26','12:25:00',3.4),('8975','2013-02-26','12:30:00',4.75),('8975','2013-02-26','12:35:00',4.85),('8975','2013-02-26','12:40:00',4.67),('8975','2013-02-26','12:45:00',3.73),('8975','2013-02-26','12:50:00',3.72),('8975','2013-02-26','12:55:00',4.66),('8975','2013-02-26','13:00:00',4.72),('8975','2013-02-26','13:05:00',4.47),('8975','2013-02-26','13:10:00',4.29),('8975','2013-02-26','13:15:00',4.37),('8975','2013-02-26','13:20:00',4.37),('8975','2013-02-26','13:25:00',4.22),('8975','2013-02-26','13:30:00',4.36),('8975','2013-02-26','13:35:00',4.19),('8975','2013-02-26','13:40:00',4.11),('8975','2013-02-26','13:45:00',4.09),('8975','2013-02-26','13:50:00',4.08),('8975','2013-02-26','13:55:00',3.69),('8975','2013-02-26','14:00:00',3.57),('8975','2013-02-26','14:05:00',3.57),('8975','2013-02-26','14:10:00',3.52),('8975','2013-02-26','14:15:00',3.44),('8975','2013-02-26','14:20:00',3.2),('8975','2013-02-26','14:25:00',2.84),('8975','2013-02-26','14:30:00',1.94),('8975','2013-02-26','14:35:00',2.79),('8975','2013-02-26','14:40:00',2.94),('8975','2013-02-26','14:45:00',2.83),('8975','2013-02-26','14:50:00',2.75),('8975','2013-02-26','14:55:00',2.59),('8975','2013-02-26','15:00:00',2.49),('8975','2013-02-26','15:05:00',2.37),('8975','2013-02-26','15:10:00',2.24),('8975','2013-02-26','15:15:00',2.09),('8975','2013-02-26','15:20:00',2.02),('8975','2013-02-26','15:25:00',1.93),('8975','2013-02-26','15:30:00',1.85),('8975','2013-02-26','15:35:00',1.77),('8975','2013-02-26','15:40:00',1.72),('8975','2013-02-26','15:45:00',1.64),('8975','2013-02-26','15:50:00',1.59),('8975','2013-02-26','15:55:00',1.54),('8975','2013-02-26','16:00:00',1.48),('8975','2013-02-26','16:05:00',1.46),('8975','2013-02-26','16:10:00',1.41),('8975','2013-02-26','16:15:00',1.35),('8975','2013-02-26','16:20:00',1.3),('8975','2013-02-26','16:25:00',1.24),('8975','2013-02-26','16:30:00',1.19),('8975','2013-02-26','16:35:00',1.13),('8975','2013-02-26','16:40:00',1.07),('8975','2013-02-26','16:45:00',1),('8975','2013-02-25','08:55:00',1.15),('8975','2013-02-25','09:00:00',1.27),('8975','2013-02-25','09:05:00',1.39),('8975','2013-02-25','09:10:00',1.53),('8975','2013-02-25','09:15:00',1.62),('8975','2013-02-25','09:20:00',1.75),('8975','2013-02-25','09:25:00',1.94),('8975','2013-02-25','09:30:00',2.28),('8975','2013-02-25','09:35:00',2.71),('8975','2013-02-25','09:40:00',2.9),('8975','2013-02-25','09:45:00',2.89),('8975','2013-02-25','09:50:00',3.21),('8975','2013-02-25','09:55:00',3.26),('8975','2013-02-25','10:00:00',3.46),('8975','2013-02-25','10:05:00',3.25),('8975','2013-02-25','10:10:00',3.84),('8975','2013-02-25','10:15:00',4.4),('8975','2013-02-25','10:20:00',5.15),('8975','2013-02-25','10:25:00',4.81),('8975','2013-02-25','10:30:00',4.12),('8975','2013-02-25','10:35:00',2.84),('8975','2013-02-25','10:40:00',2.36),('8975','2013-02-25','10:45:00',2.38),('8975','2013-02-25','10:50:00',2.58),('8975','2013-02-25','10:55:00',2.62),('8975','2013-02-25','11:00:00',2.59),('8975','2013-02-25','11:05:00',2.51),('8975','2013-02-25','11:10:00',3.29),('8975','2013-02-25','11:15:00',2.94),('8975','2013-02-25','11:21:00',2.93),('8975','2013-02-25','11:25:00',2.77),('8975','2013-02-25','11:30:00',2.67),('8975','2013-02-25','11:35:00',2.46),('8975','2013-02-25','11:40:00',2.44),('8975','2013-02-25','11:45:00',2.99),('8975','2013-02-25','11:50:00',2.56),('8975','2013-02-25','11:55:00',2.45),('8975','2013-02-25','12:00:00',2.23),('8975','2013-02-25','12:05:00',2.1),('8975','2013-02-25','12:10:00',2.26),('8975','2013-02-25','12:15:00',2.32),('8975','2013-02-25','12:20:00',2.3),('8975','2013-02-25','12:25:00',2.2),('8975','2013-02-25','12:30:00',2.06),('8975','2013-02-25','12:35:00',1.87),('8975','2013-02-25','12:40:00',1.78),('8975','2013-02-25','12:45:00',1.64),('8975','2013-02-25','12:50:00',1.5),('8975','2013-02-25','12:55:00',1.67),('8975','2013-02-25','13:00:00',1.63),('8975','2013-02-25','13:05:00',1.43),('8975','2013-02-25','13:10:00',1.3),('8975','2013-02-25','13:15:00',1.35),('8975','2013-02-25','13:20:00',1.43),('8975','2013-02-25','13:25:00',1.5),('8975','2013-02-25','13:30:00',1.5),('8975','2013-02-25','13:35:00',1.52),('8975','2013-02-25','13:40:00',1.48),('8975','2013-02-25','13:45:00',1.42),('8975','2013-02-25','13:50:00',1.36),('8975','2013-02-25','13:55:00',1.39),('8975','2013-02-25','14:00:00',1.43),('8975','2013-02-25','14:05:00',1.34),('8975','2013-02-25','14:10:00',1.5),('8975','2013-02-25','14:15:00',1.53),('8975','2013-02-24','08:35:00',1.45),('8975','2013-02-24','08:40:00',1.85),('8975','2013-02-24','08:45:00',1.83),('8975','2013-02-24','08:50:00',1.51),('8975','2013-02-24','08:55:00',2.24),('8975','2013-02-24','09:00:00',1.71),('8975','2013-02-24','09:05:00',1.33),('8975','2013-02-24','09:10:00',1.46),('8975','2013-02-24','09:15:00',1.44),('8975','2013-02-24','09:20:00',1.84),('8975','2013-02-24','09:25:00',2.35),('8975','2013-02-24','09:30:00',2.24),('8975','2013-02-24','09:35:00',1.88),('8975','2013-02-24','09:40:00',1.44),('8975','2013-02-24','09:45:00',1.32),('8975','2013-02-24','10:40:00',1.86),('8975','2013-02-24','10:45:00',3.52),('8975','2013-02-24','10:50:00',6.26),('8975','2013-02-24','10:55:00',6.76),('8975','2013-02-24','11:00:00',5.1),('8975','2013-02-24','11:05:00',2.97),('8975','2013-02-24','11:10:00',2.37),('8975','2013-02-24','11:15:00',2.38),('8975','2013-02-24','11:20:00',1.92),('8975','2013-02-24','11:25:00',1.86),('8975','2013-02-24','11:30:00',1.99),('8975','2013-02-24','11:35:00',1.99),('8975','2013-02-24','11:40:00',2.35),('8975','2013-02-24','11:45:00',3.1),('8975','2013-02-24','11:50:00',6.93),('8975','2013-02-24','11:55:00',5.86),('8975','2013-02-24','12:00:00',4.49),('8975','2013-02-24','12:05:00',3.67),('8975','2013-02-24','12:10:00',3.63),('8975','2013-02-24','12:15:00',3.35),('8975','2013-02-24','12:20:00',4.89),('8975','2013-02-24','12:25:00',5.33),('8975','2013-02-24','12:30:00',5.39),('8975','2013-02-24','12:35:00',5.8),('8975','2013-02-24','12:40:00',3.85),('8975','2013-02-24','12:45:00',4.67),('8975','2013-02-24','12:50:00',4.82),('8975','2013-02-24','12:55:00',4.66),('8975','2013-02-24','13:00:00',4.4),('8975','2013-02-24','13:05:00',3.62),('8975','2013-02-24','13:10:00',3.96),('8975','2013-02-24','13:15:00',3.11),('8975','2013-02-24','13:20:00',2.13),('8975','2013-02-24','13:25:00',2.27),('8975','2013-02-24','13:30:00',1.76),('8975','2013-02-24','13:35:00',1.58),('8975','2013-02-24','13:40:00',1.34),('8975','2013-02-24','13:45:00',1.22),('8975','2013-02-24','13:50:00',1.22),('8975','2013-02-24','13:55:00',1.09),('8975','2013-02-24','14:30:00',1.04),('8975','2013-02-24','14:35:00',1.42),('8975','2013-02-24','14:40:00',1.34),('8975','2013-02-24','14:45:00',1.23),('8975','2013-02-24','14:50:00',1.21),('8975','2013-02-24','14:55:00',1.31),('8975','2013-02-24','15:00:00',1.25),('8975','2013-02-24','15:05:00',1.19),('8975','2013-02-24','15:15:00',1.02),('8975','2013-02-24','16:35:00',1.07),('8975','2013-02-24','16:55:00',1.15),('8975','2013-02-23','08:00:00',1.74),('8975','2013-02-23','08:05:00',1.12),('8975','2013-02-23','08:30:00',1.05),('8975','2013-02-23','08:45:00',1.06),('8975','2013-02-23','08:50:00',1.2),('8975','2013-02-23','08:55:00',1.46),('8975','2013-02-23','09:00:00',1.06),('8975','2013-02-23','10:30:00',1.03),('8975','2013-02-23','10:35:00',1.17),('8975','2013-02-23','10:40:00',1.53),('8975','2013-02-23','10:45:00',1.71),('8975','2013-02-23','10:50:00',2.66),('8975','2013-02-23','10:55:00',2.27),('8975','2013-02-23','11:00:00',1.61),('8975','2013-02-23','11:05:00',1.64),('8975','2013-02-23','11:10:00',1.64),('8975','2013-02-23','11:15:00',1.61),('8975','2013-02-23','11:20:00',1.47),('8975','2013-02-23','11:25:00',1.51),('8975','2013-02-23','11:30:00',1.51),('8975','2013-02-23','11:35:00',1.26),('8975','2013-02-23','11:40:00',1.45),('8975','2013-02-23','11:45:00',1.38),('8975','2013-02-23','11:50:00',1.47),('8975','2013-02-23','11:55:00',1.31),('8975','2013-02-23','12:00:00',1.29),('8975','2013-02-23','12:05:00',1.32),('8975','2013-02-23','12:10:00',1.08),('8975','2013-02-23','12:30:00',1.04),('8975','2013-02-23','12:35:00',1.83),('8975','2013-02-23','12:40:00',1.77),('8975','2013-02-23','12:45:00',2.01),('8975','2013-02-23','12:50:00',2.12),('8975','2013-02-23','12:55:00',2.32),('8975','2013-02-23','13:00:00',2.65),('8975','2013-02-23','13:05:00',2.22),('8975','2013-02-23','13:10:00',2.55),('8975','2013-02-23','13:15:00',2.08),('8975','2013-02-23','13:20:00',2.41),('8975','2013-02-23','13:25:00',1.74),('8975','2013-02-23','13:30:00',1.68),('8975','2013-02-23','13:35:00',1.85),('8975','2013-02-23','13:40:00',2.69),('8975','2013-02-23','13:45:00',1.95),('8975','2013-02-23','13:50:00',1.42),('8975','2013-02-23','13:55:00',1.45),('8975','2013-02-23','14:00:00',1.45),('8975','2013-02-23','14:05:00',2.67),('8975','2013-02-23','14:10:00',2.07),('8975','2013-02-23','14:15:00',1.65),('8975','2013-02-23','14:20:00',1.63),('8975','2013-02-23','14:25:00',1.43),('8975','2013-02-23','14:30:00',1.69),('8975','2013-02-23','14:35:00',1.62),('8975','2013-02-23','14:40:00',1.27),('8975','2013-02-23','14:45:00',1.35),('8975','2013-02-23','14:50:00',1.05),('8975','2013-02-23','15:00:00',1.39),('8975','2013-02-23','15:05:00',1.56),('8975','2013-02-23','15:10:00',1.99),('8975','2013-02-23','15:15:00',1.43),('8975','2013-02-23','15:20:00',1.96),('8975','2013-02-23','15:25:00',2.16),('8975','2013-02-23','15:30:00',2.34),('8975','2013-02-23','15:35:00',2.17),('8975','2013-02-23','15:40:00',1.83),('8975','2013-02-23','15:45:00',1.41),('8975','2013-02-23','15:50:00',1.38),('8975','2013-02-23','15:55:00',1.09),('8975','2013-02-23','16:00:00',1.91),('8975','2013-02-23','16:40:00',1.06),('8975','2013-02-23','16:45:00',1.01),('8975','2013-02-22','07:25:00',1.16),('8975','2013-02-22','07:30:00',1.5),('8975','2013-02-22','07:35:00',1.71),('8975','2013-02-22','07:40:00',1.89),('8975','2013-02-22','07:45:00',2.08),('8975','2013-02-22','07:50:00',2.25),('8975','2013-02-22','07:55:00',2.44),('8975','2013-02-22','08:00:00',2.58),('8975','2013-02-22','08:05:00',2.71),('8975','2013-02-22','08:10:00',2.31),('8975','2013-02-22','08:15:00',3.54),('8975','2013-02-22','08:20:00',1.61),('8975','2013-02-22','08:25:00',1.16),('8975','2013-02-22','08:30:00',1.08),('8975','2013-02-22','08:45:00',1.04),('8975','2013-02-22','08:50:00',1.39),('8975','2013-02-22','08:55:00',1.76),('8975','2013-02-22','09:00:00',1.93),('8975','2013-02-22','09:05:00',2.04),('8975','2013-02-22','09:10:00',1.59),('8975','2013-02-22','09:15:00',1.31),('8975','2013-02-22','09:30:00',1.24),('8975','2013-02-22','09:35:00',1.53),('8975','2013-02-22','09:40:00',1.96),('8975','2013-02-22','09:45:00',2.39),('8975','2013-02-22','09:50:00',2.29),('8975','2013-02-22','09:55:00',2.15),('8975','2013-02-22','10:00:00',1.72),('8975','2013-02-22','10:05:00',1.57),('8975','2013-02-22','10:10:00',1.31),('8975','2013-02-22','10:15:00',1.15),('8975','2013-02-22','10:20:00',1.23),('8975','2013-02-22','10:25:00',1.59),('8975','2013-02-22','10:30:00',1.34),('8975','2013-02-22','10:35:00',1.47),('8975','2013-02-22','10:40:00',1.17),('8975','2013-02-22','10:45:00',1.27),('8975','2013-02-22','10:50:00',1.15),('8975','2013-02-22','11:20:00',1.18),('8975','2013-02-22','11:25:00',1.01),('8975','2013-02-22','11:30:00',1.04),('8975','2013-02-22','11:35:00',1.36),('8975','2013-02-22','11:40:00',1.49),('8975','2013-02-22','11:45:00',1.45),('8975','2013-02-22','11:50:00',1.11),('8975','2013-02-22','11:55:00',1.07),('8975','2013-02-22','12:00:00',1),('8975','2013-02-22','12:05:00',1.4),('8975','2013-02-22','12:10:00',1.36),('8975','2013-02-22','12:15:00',1.28),('8975','2013-02-22','12:20:00',1.4),('8975','2013-02-22','12:25:00',1.15),('8975','2013-02-22','12:30:00',1.27),('8975','2013-02-22','12:40:00',1.04),('8975','2013-02-22','12:45:00',1.22),('8975','2013-02-22','12:50:00',1.47),('8975','2013-02-22','12:55:00',1.09),('8975','2013-02-22','13:10:00',1.26),('8975','2013-02-22','13:15:00',1.29),('8975','2013-02-22','13:20:00',1.11),('8975','2013-02-22','13:25:00',1.09),('8975','2013-02-22','13:50:00',1.15),('8975','2013-02-22','13:55:00',1.9),('8975','2013-02-22','14:00:00',2.11),('8975','2013-02-22','14:05:00',2.89),('8975','2013-02-22','14:10:00',2.3),('8975','2013-02-22','14:45:00',1.52),('8975','2013-02-22','14:50:00',1.17),('8975','2013-02-21','09:35:00',1.34),('8975','2013-02-21','09:40:00',1.3),('8975','2013-02-21','09:45:00',1.05),('8975','2013-02-21','09:50:00',1.17),('8975','2013-02-21','10:00:00',1.07),('8975','2013-02-21','10:15:00',1.16),('8975','2013-02-21','11:35:00',1.01),('8975','2013-02-21','12:55:00',1.2),('8975','2013-02-21','14:10:00',1.13),('8975','2013-02-21','14:15:00',1.34),('8975','2013-02-21','14:20:00',1.27),('8975','2013-02-21','14:30:00',1.8),('8975','2013-02-21','14:35:00',1.91),('8975','2013-02-21','14:40:00',1.89),('8975','2013-02-21','14:45:00',1.42),('8975','2013-02-21','14:50:00',1.73),('8975','2013-02-21','14:55:00',1.69),('8975','2013-02-21','15:00:00',1.25),('8975','2013-02-21','15:45:00',1.01),('8975','2013-02-21','15:50:00',1.07),('8975','2013-02-21','16:15:00',1.28),('8975','2013-02-21','16:20:00',1.94),('8975','2013-02-21','16:25:00',1.81),('8975','2013-02-21','16:30:00',1.19),('8975','2013-02-20','09:45:00',1.25),('8975','2013-02-20','09:50:00',1.32),('8975','2013-02-20','09:55:00',1.31),('8975','2013-02-20','10:00:00',1.24),('8975','2013-02-20','10:05:00',1.23),('8975','2013-02-20','10:10:00',1.21),('8975','2013-02-20','10:15:00',1.18),('8975','2013-02-20','10:20:00',1.18),('8975','2013-02-20','10:25:00',1.2),('8975','2013-02-20','10:30:00',1.22),('8975','2013-02-20','10:35:00',1.25),('8975','2013-02-20','10:40:00',1.31),('8975','2013-02-20','10:45:00',1.24),('8975','2013-02-20','10:50:00',1.27),('8975','2013-02-20','10:55:00',1.22),('8975','2013-02-20','11:00:00',1.14),('8975','2013-02-20','11:05:00',1.03),('8975','2013-02-20','11:15:00',1.09),('8975','2013-02-20','11:20:00',1.27),('8975','2013-02-20','11:25:00',1.38),('8975','2013-02-20','11:30:00',1.44),('8975','2013-02-20','11:35:00',1.51),('8975','2013-02-20','11:40:00',1.52),('8975','2013-02-20','11:45:00',1.63),('8975','2013-02-20','11:50:00',1.76),('8975','2013-02-20','11:55:00',1.86),('8975','2013-02-20','12:00:00',1.79),('8975','2013-02-20','12:05:00',1.8),('8975','2013-02-20','12:10:00',1.91),('8975','2013-02-20','12:15:00',2.06),('8975','2013-02-20','12:20:00',2.19),('8975','2013-02-20','12:25:00',2.14),('8975','2013-02-20','12:30:00',2.02),('8975','2013-02-20','12:35:00',1.93),('8975','2013-02-20','12:40:00',1.87),('8975','2013-02-20','12:45:00',1.85),('8975','2013-02-20','12:50:00',1.94),('8975','2013-02-20','12:55:00',2.09),('8975','2013-02-20','13:00:00',2.07),('8975','2013-02-20','13:05:00',1.92),('8975','2013-02-20','13:10:00',1.82),('8975','2013-02-20','13:15:00',1.85),('8975','2013-02-20','13:20:00',1.88),('8975','2013-02-20','13:25:00',1.91),('8975','2013-02-20','13:30:00',1.95),('8975','2013-02-20','13:35:00',1.97),('8975','2013-02-20','13:40:00',1.93),('8975','2013-02-20','13:45:00',1.82),('8975','2013-02-20','13:50:00',1.9),('8975','2013-02-20','13:55:00',1.94),('8975','2013-02-20','14:00:00',1.91),('8975','2013-02-20','14:05:00',1.85),('8975','2013-02-20','14:10:00',1.73),('8975','2013-02-20','14:15:00',1.57),('8975','2013-02-20','14:20:00',1.39),('8975','2013-02-20','14:25:00',1.28),('8975','2013-02-20','14:30:00',1.31),('8975','2013-02-20','14:35:00',1.3),('8975','2013-02-20','14:40:00',1.2),('8975','2013-02-20','14:45:00',1.15),('8975','2013-02-20','14:50:00',1.13),('8975','2013-02-20','14:55:00',1.01),('8975','2013-02-20','15:50:00',1.01),('8975','2013-02-20','15:55:00',1.09),('8975','2013-02-20','16:00:00',1.18),('8975','2013-02-20','16:05:00',1.22),('8975','2013-02-20','16:10:00',1.21),('8975','2013-02-20','16:15:00',1.19),('8975','2013-02-20','16:20:00',1.59),('8975','2013-02-20','16:25:00',1.9),('8975','2013-02-20','16:30:00',1.78),('8975','2013-02-20','16:35:00',1.56),('8975','2013-02-20','16:40:00',1.34),('8975','2013-02-20','16:45:00',1.19),('8975','2013-02-20','16:50:00',1.04),('8975','2014-03-22','08:05:00',1),('8975','2014-03-22','08:10:00',1.11),('8975','2014-03-22','08:15:00',1.11),('8975','2014-03-22','08:20:00',1.26),('8975','2014-03-22','08:25:00',1.38),('8975','2014-03-22','08:30:00',1.59),('8975','2014-03-22','08:35:00',1.67),('8975','2014-03-22','08:40:00',1.26),('8975','2014-03-22','08:45:00',1.46),('8975','2014-03-22','08:50:00',2.06),('8975','2014-03-22','08:55:00',2.6),('8975','2014-03-22','09:00:00',1.9),('8975','2014-03-22','09:05:00',3.42),('8975','2014-03-22','09:10:00',4.65),('8975','2014-03-22','09:15:00',4.05),('8975','2014-03-22','09:20:00',2.75),('8975','2014-03-22','09:25:00',1.85),('8975','2014-03-22','09:30:00',2.26),('8975','2014-03-22','09:35:00',2.28),('8975','2014-03-22','09:40:00',1.99),('8975','2014-03-22','09:45:00',1.49),('8975','2014-03-22','09:50:00',1.37),('8975','2014-03-22','09:55:00',1.17),('8975','2014-03-22','10:00:00',1.14),('8975','2014-03-22','10:05:00',1.17),('8975','2014-03-22','10:10:00',1.38),('8975','2014-03-22','10:15:00',1.16),('8975','2014-03-22','10:20:00',1.35),('8975','2014-03-22','10:25:00',2.08),('8975','2014-03-22','10:30:00',2.05),('8975','2014-03-22','10:35:00',2.05),('8975','2014-03-22','10:40:00',2.07),('8975','2014-03-22','10:45:00',2),('8975','2014-03-22','10:50:00',2.44),('8975','2014-03-22','10:55:00',3.05),('8975','2014-03-22','11:00:00',2.27),('8975','2014-03-22','11:05:00',1.95),('8975','2014-03-22','11:10:00',2.98),('8975','2014-03-22','11:15:00',1.43),('8975','2014-03-22','11:20:00',1.12),('8975','2014-03-22','11:25:00',1.53),('8975','2014-03-22','11:30:00',1.19),('8975','2014-03-22','11:35:00',2.3),('8975','2014-03-22','11:40:00',2.69),('8975','2014-03-22','11:45:00',1.3),('8975','2014-03-22','11:55:00',1.67),('8975','2014-03-22','12:00:00',1.35),('8975','2014-03-22','12:35:00',1.12),('8975','2014-03-22','12:40:00',1.02),('8975','2014-03-22','13:40:00',1.41),('8975','2014-03-22','13:45:00',2.87),('8975','2014-03-22','13:50:00',2.31),('8975','2014-03-22','13:55:00',1.57),('8975','2014-03-22','14:00:00',1.43),('8975','2014-03-22','14:50:00',2.49),('8975','2014-03-22','14:55:00',1.37),('8975','2014-03-22','15:05:00',1.59),('8975','2014-03-22','15:10:00',2.14),('8975','2014-03-22','15:15:00',2.38),('8975','2014-03-22','15:20:00',2.87),('8975','2014-03-22','15:25:00',1.88),('8975','2014-03-22','15:30:00',1.31),('8975','2014-03-22','15:35:00',1.62),('8975','2014-03-22','15:40:00',1.05),('8975','2013-02-19','08:05:00',1.34),('8975','2013-02-19','08:10:00',2.48),('8975','2013-02-19','08:15:00',2.7),('8975','2013-02-19','08:20:00',2.75),('8975','2013-02-19','08:25:00',2.86),('8975','2013-02-19','08:30:00',2.99),('8975','2013-02-19','08:35:00',3.1),('8975','2013-02-19','08:40:00',3.19),('8975','2013-02-19','08:45:00',3.26),('8975','2013-02-19','08:50:00',3.35),('8975','2013-02-19','08:55:00',3.43),('8975','2013-02-19','09:00:00',3.35),('8975','2013-02-19','09:05:00',2.27),('8975','2013-02-19','09:10:00',2.32),('8975','2013-02-19','09:15:00',1.97),('8975','2013-02-19','09:20:00',1.94),('8975','2013-02-19','09:25:00',1.75),('8975','2013-02-19','09:30:00',2.97),('8975','2013-02-19','09:35:00',3.2),('8975','2013-02-19','09:40:00',2.09),('8975','2013-02-19','09:45:00',2.98),('8975','2013-02-19','09:50:00',1.84),('8975','2013-02-19','09:55:00',1.53),('8975','2013-02-19','10:00:00',2.8),('8975','2013-02-19','10:05:00',1.88),('8975','2013-02-19','10:10:00',1.48),('8975','2013-02-19','10:15:00',1.24),('8975','2013-02-19','10:20:00',1.11),('8975','2013-02-19','10:25:00',1.06),('8975','2013-02-19','10:30:00',1.19),('8975','2013-02-19','10:35:00',1.47),('8975','2013-02-19','10:40:00',3.24),('8975','2013-02-19','10:45:00',5.15),('8975','2013-02-19','10:50:00',2.78),('8975','2013-02-19','10:55:00',2.01),('8975','2013-02-19','11:00:00',4.52),('8975','2013-02-19','11:05:00',5.09),('8975','2013-02-19','11:10:00',2.84),('8975','2013-02-19','11:15:00',3.25),('8975','2013-02-19','11:20:00',3.86),('8975','2013-02-19','11:25:00',5.85),('8975','2013-02-19','11:30:00',6.34),('8975','2013-02-19','11:35:00',5.48),('8975','2013-02-19','11:40:00',3.54),('8975','2013-02-19','11:45:00',3.45),('8975','2013-02-19','11:50:00',3.74),('8975','2013-02-19','11:55:00',3.36),('8975','2013-02-19','12:00:00',3.16),('8975','2013-02-19','12:05:00',4.36),('8975','2013-02-19','12:10:00',2.74),('8975','2013-02-19','12:15:00',2.26),('8975','2013-02-19','12:20:00',5.05),('8975','2013-02-19','12:25:00',3.32),('8975','2013-02-19','12:30:00',2.94),('8975','2013-02-19','12:35:00',1.5),('8975','2013-02-19','12:40:00',2.03),('8975','2013-02-19','12:45:00',2.62),('8975','2013-02-19','12:50:00',3.92),('8975','2013-02-19','12:55:00',5.44),('8975','2013-02-19','13:00:00',4.33),('8975','2013-02-19','13:05:00',4.28),('8975','2013-02-19','13:10:00',1.29),('8975','2013-02-19','13:15:00',2.11),('8975','2013-02-19','13:20:00',4.08),('8975','2013-02-19','13:25:00',5.49),('8975','2013-02-19','13:30:00',4.56),('8975','2013-02-19','13:35:00',3.62),('8975','2013-02-19','13:40:00',2.04),('8975','2013-02-19','13:45:00',2.46),('8975','2013-02-19','13:50:00',2.51),('8975','2013-02-19','13:55:00',1.93),('8975','2013-02-19','14:00:00',1.61),('8975','2013-02-19','14:05:00',1.43),('8975','2013-02-19','14:10:00',1.48),('8975','2013-02-19','14:15:00',1.27),('8975','2013-02-19','14:20:00',1.14),('8975','2013-02-19','14:25:00',1.06),('8975','2013-02-19','14:30:00',1.3),('8975','2013-02-19','14:35:00',1.36),('8975','2013-02-19','14:40:00',1.31),('8975','2013-02-19','14:45:00',1.3),('8975','2013-02-19','14:50:00',1.41),('8975','2013-02-19','14:55:00',1.95),('8975','2013-02-19','15:00:00',1.84),('8975','2013-02-19','15:05:00',2.45),('8975','2013-02-19','15:10:00',2.63),('8975','2013-02-19','15:15:00',2.64),('8975','2013-02-19','15:20:00',2.38),('8975','2013-02-19','15:25:00',1.46),('8975','2013-02-19','15:30:00',1.52),('8975','2013-02-19','15:35:00',1.67),('8975','2013-02-19','15:40:00',1.42),('8975','2013-02-19','15:45:00',1.57),('8975','2013-02-19','15:50:00',2.11),('8975','2013-02-19','15:55:00',1.67),('8975','2013-02-19','16:00:00',2.07),('8975','2013-02-19','16:05:00',2.01),('8975','2013-02-19','16:10:00',1.87),('8975','2013-02-19','16:15:00',1.71),('8975','2013-02-19','16:20:00',1.4),('8975','2013-02-19','16:25:00',1.34),('8975','2013-02-19','16:30:00',1.32),('8975','2013-02-19','16:35:00',1.04),('8975','2013-02-18','07:35:00',1.29),('8975','2013-02-18','07:40:00',1.51),('8975','2013-02-18','07:45:00',1.69),('8975','2013-02-18','07:50:00',1.86),('8975','2013-02-18','07:55:00',2.01),('8975','2013-02-18','08:00:00',2.13),('8975','2013-02-18','08:05:00',2.22),('8975','2013-02-18','08:10:00',2.38),('8975','2013-02-18','08:15:00',2.51),('8975','2013-02-18','08:20:00',2.64),('8975','2013-02-18','08:25:00',2.76),('8975','2013-02-18','08:30:00',2.89),('8975','2013-02-18','08:35:00',2.99),('8975','2013-02-18','08:40:00',3.08),('8975','2013-02-18','08:45:00',3.15),('8975','2013-02-18','08:50:00',3.23),('8975','2013-02-18','08:55:00',3.32),('8975','2013-02-18','09:00:00',3.4),('8975','2013-02-18','09:05:00',3.49),('8975','2013-02-18','09:10:00',3.59),('8975','2013-02-18','09:15:00',3.65),('8975','2013-02-18','09:20:00',3.71),('8975','2013-02-18','09:25:00',3.8),('8975','2013-02-18','09:30:00',3.84),('8975','2013-02-18','09:35:00',3.88),('8975','2013-02-18','09:40:00',3.99),('8975','2013-02-18','09:45:00',4.09),('8975','2013-02-18','09:50:00',4.21),('8975','2013-02-18','09:55:00',4.28),('8975','2013-02-18','10:00:00',4.29),('8975','2013-02-18','10:05:00',4.37),('8975','2013-02-18','10:10:00',4.15),('8975','2013-02-18','10:15:00',4.05),('8975','2013-02-18','10:20:00',4.24),('8975','2013-02-18','10:25:00',4.54),('8975','2013-02-18','10:30:00',4.56),('8975','2013-02-18','10:35:00',4.64),('8975','2013-02-18','10:40:00',4.69),('8975','2013-02-18','10:45:00',4.65),('8975','2013-02-18','10:50:00',4.71),('8975','2013-02-18','10:55:00',4.77),('8975','2013-02-18','11:00:00',4.79),('8975','2013-02-18','11:05:00',4.78),('8975','2013-02-18','11:10:00',4.72),('8975','2013-02-18','11:15:00',4.81),('8975','2013-02-18','11:20:00',4.85),('8975','2013-02-18','11:25:00',4.92),('8975','2013-02-18','11:30:00',4.9),('8975','2013-02-18','11:35:00',4.87),('8975','2013-02-18','11:40:00',4.88),('8975','2013-02-18','11:45:00',4.88),('8975','2013-02-18','11:50:00',4.78),('8975','2013-02-18','11:55:00',4.76),('8975','2013-02-18','12:00:00',4.6),('8975','2013-02-18','12:05:00',4.56),('8975','2013-02-18','12:10:00',4.63),('8975','2013-02-18','12:15:00',4.64),('8975','2013-02-18','12:20:00',4.61),('8975','2013-02-18','12:25:00',4.58),('8975','2013-02-18','12:30:00',4.53),('8975','2013-02-18','12:35:00',4.46),('8975','2013-02-18','12:40:00',4.41),('8975','2013-02-18','12:45:00',4.35),('8975','2013-02-18','12:50:00',4.29),('8975','2013-02-18','12:55:00',4.3),('8975','2013-02-18','13:00:00',4.21),('8975','2013-02-18','13:05:00',3.93),('8975','2013-02-18','13:10:00',4.05),('8975','2013-02-18','13:15:00',3.96),('8975','2013-02-18','13:20:00',3.89),('8975','2013-02-18','13:25:00',3.82),('8975','2013-02-18','13:30:00',3.67),('8975','2013-02-18','13:35:00',3.6),('8975','2013-02-18','13:40:00',3.7),('8975','2013-02-18','13:45:00',3.56),('8975','2013-02-18','13:50:00',3.36),('8975','2013-02-18','13:55:00',3.18),('8975','2013-02-18','14:00:00',2.97),('8975','2013-02-18','14:05:00',3.1),('8975','2013-02-18','14:10:00',3.08),('8975','2013-02-18','14:15:00',2.86),('8975','2013-02-18','14:20:00',2.6),('8975','2013-02-18','14:25:00',1.83),('8975','2013-02-18','14:30:00',1.93),('8975','2013-02-18','14:35:00',2.49),('8975','2013-02-18','14:40:00',2.5),('8975','2013-02-18','14:45:00',2.32),('8975','2013-02-18','14:50:00',2.28),('8975','2013-02-18','14:55:00',2.27),('8975','2013-02-18','15:00:00',2.18),('8975','2013-02-18','15:05:00',2.07),('8975','2013-02-18','15:10:00',1.99),('8975','2013-02-18','15:15:00',1.88),('8975','2013-02-18','15:20:00',1.8),('8975','2013-02-18','15:25:00',1.75),('8975','2013-02-18','15:30:00',1.69),('8975','2013-02-18','15:35:00',1.64),('8975','2013-02-18','15:40:00',1.58),('8975','2013-02-18','15:45:00',1.51),('8975','2013-02-18','15:50:00',1.46),('8975','2013-02-18','15:55:00',1.45),('8975','2013-02-18','16:00:00',1.41),('8975','2013-02-18','16:05:00',1.36),('8975','2013-02-18','16:10:00',1.31),('8975','2013-02-18','16:15:00',1.25),('8975','2013-02-18','16:20:00',1.2),('8975','2013-02-18','16:25:00',1.14),('8975','2013-02-18','16:30:00',1.09),('8975','2013-02-18','16:35:00',1.02),('8975','2013-02-17','07:55:00',1.56),('8975','2013-02-17','08:00:00',2.01),('8975','2013-02-17','08:05:00',2.08),('8975','2013-02-17','08:10:00',2.21),('8975','2013-02-17','08:15:00',2.39),('8975','2013-02-17','08:20:00',2.5),('8975','2013-02-17','08:25:00',2.61),('8975','2013-02-17','08:30:00',2.71),('8975','2013-02-17','08:35:00',2.82),('8975','2013-02-17','08:40:00',2.91),('8975','2013-02-17','08:45:00',3.03),('8975','2013-02-17','08:50:00',3.11),('8975','2013-02-17','08:55:00',3.16),('8975','2013-02-17','09:00:00',3.25),('8975','2013-02-17','09:05:00',3.32),('8975','2013-02-17','09:10:00',3.38),('8975','2013-02-17','09:15:00',3.57),('8975','2013-02-17','09:20:00',3.68),('8975','2013-02-17','09:25:00',4.09),('8975','2013-02-17','09:30:00',2.31),('8975','2013-02-17','09:35:00',1.71),('8975','2013-02-17','09:40:00',1.17),('8975','2013-02-17','09:45:00',2.11),('8975','2013-02-17','09:50:00',1.23),('8975','2013-02-17','09:55:00',1.46),('8975','2013-02-17','10:00:00',1.46),('8975','2013-02-17','10:05:00',1.05),('8975','2013-02-17','10:30:00',1.14),('8975','2013-02-17','10:35:00',1.32),('8975','2013-02-17','10:40:00',1.51),('8975','2013-02-17','10:45:00',1.4),('8975','2013-02-17','10:50:00',1.41),('8975','2013-02-17','10:55:00',1.73),('8975','2013-02-17','11:00:00',1.85),('8975','2013-02-17','11:05:00',1.87),('8975','2013-02-17','11:10:00',1.8),('8975','2013-02-17','11:15:00',1.76),('8975','2013-02-17','11:20:00',2.07),('8975','2013-02-17','11:25:00',2.33),('8975','2013-02-17','11:30:00',2.16),('8975','2013-02-17','11:35:00',2.25),('8975','2013-02-17','11:40:00',2.07),('8975','2013-02-17','11:45:00',2.02),('8975','2013-02-17','11:50:00',2.4),('8975','2013-02-17','11:55:00',2.82),('8975','2013-02-17','12:00:00',2.8),('8975','2013-02-17','12:05:00',2.5),('8975','2013-02-17','12:10:00',2.33),('8975','2013-02-17','12:15:00',2.22),('8975','2013-02-17','12:20:00',2.21),('8975','2013-02-17','12:25:00',2.36),('8975','2013-02-17','12:30:00',2.17),('8975','2013-02-17','12:35:00',2.05),('8975','2013-02-17','12:40:00',2.19),('8975','2013-02-17','12:45:00',2.45),('8975','2013-02-17','12:50:00',2.38),('8975','2013-02-17','12:55:00',2.28),('8975','2013-02-17','13:00:00',2.21),('8975','2013-02-17','13:05:00',2.07),('8975','2013-02-17','13:10:00',1.9),('8975','2013-02-17','13:15:00',1.92),('8975','2013-02-17','13:20:00',1.77),('8975','2013-02-17','13:25:00',1.87),('8975','2013-02-17','13:30:00',1.93),('8975','2013-02-17','13:35:00',1.93),('8975','2013-02-17','13:40:00',1.94),('8975','2013-02-17','13:45:00',1.7),('8975','2013-02-17','13:50:00',1.82),('8975','2013-02-17','13:55:00',2.05),('8975','2013-02-17','14:00:00',1.95),('8975','2013-02-17','14:05:00',1.69),('8975','2013-02-17','14:10:00',1.53),('8975','2013-02-17','14:15:00',1.41),('8975','2013-02-17','14:20:00',1.54),('8975','2013-02-17','14:25:00',1.05),('8975','2013-02-17','15:00:00',1.51),('8975','2013-02-17','15:05:00',1.65),('8975','2013-02-17','15:10:00',1.16),('8975','2013-02-17','15:35:00',1.08),('8975','2013-02-16','07:40:00',1.1),('8975','2013-02-16','07:45:00',1.22),('8975','2013-02-16','07:50:00',1.39),('8975','2013-02-16','07:55:00',1.57),('8975','2013-02-16','08:00:00',1.75),('8975','2013-02-16','08:05:00',1.89),('8975','2013-02-16','08:10:00',2.03),('8975','2013-02-16','08:15:00',2.2),('8975','2013-02-16','08:20:00',2.34),('8975','2013-02-16','08:25:00',2.46),('8975','2013-02-16','08:30:00',2.63),('8975','2013-02-16','08:35:00',2.82),('8975','2013-02-16','08:40:00',3),('8975','2013-02-16','08:45:00',3.07),('8975','2013-02-16','08:50:00',2.95),('8975','2013-02-16','08:55:00',2.97),('8975','2013-02-16','09:00:00',3.15),('8975','2013-02-16','09:05:00',3.15),('8975','2013-02-16','09:10:00',3.36),('8975','2013-02-16','09:15:00',3.46),('8975','2013-02-16','09:20:00',3.55),('8975','2013-02-16','09:25:00',3.63),('8975','2013-02-16','09:30:00',3.64),('8975','2013-02-16','09:35:00',3.64),('8975','2013-02-16','09:40:00',3.74),('8975','2013-02-16','09:45:00',3.83),('8975','2013-02-16','09:50:00',3.96),('8975','2013-02-16','09:55:00',4.08),('8975','2013-02-16','10:00:00',4.16),('8975','2013-02-16','10:05:00',4.21),('8975','2013-02-16','10:10:00',4.09),('8975','2013-02-16','10:15:00',3.92),('8975','2013-02-16','10:20:00',3.92),('8975','2013-02-16','10:25:00',4.28),('8975','2013-02-16','10:30:00',4.37),('8975','2013-02-16','10:35:00',4.39),('8975','2013-02-16','10:40:00',4.45),('8975','2013-02-16','10:45:00',4.45),('8975','2013-02-16','10:50:00',4.48),('8975','2013-02-16','10:55:00',4.49),('8975','2013-02-16','11:00:00',4.55),('8975','2013-02-16','11:05:00',4.61),('8975','2013-02-16','11:10:00',4.65),('8975','2013-02-16','11:15:00',4.65),('8975','2013-02-16','11:20:00',4.67),('8975','2013-02-16','11:25:00',4.66),('8975','2013-02-16','11:30:00',4.61),('8975','2013-02-16','11:35:00',4.61),('8975','2013-02-16','11:40:00',4.63),('8975','2013-02-16','11:45:00',4.55),('8975','2013-02-16','11:50:00',4.41),('8975','2013-02-16','11:55:00',4.46),('8975','2013-02-16','12:00:00',4.39),('8975','2013-02-16','12:05:00',4.2),('8975','2013-02-16','12:10:00',4.37),('8975','2013-02-16','12:15:00',4.36),('8975','2013-02-16','12:20:00',4.29),('8975','2013-02-16','12:25:00',4.21),('8975','2013-02-16','12:30:00',4.12),('8975','2013-02-16','12:35:00',4.1),('8975','2013-02-16','12:40:00',1.37),('8975','2013-02-16','12:45:00',1.04),('8975','2013-02-16','12:50:00',1.13),('8975','2013-02-16','12:55:00',1.81),('8975','2013-02-16','13:00:00',2.76),('8975','2013-02-16','13:05:00',1.2),('8975','2013-02-16','13:20:00',1.02),('8975','2013-02-16','13:25:00',1.16),('8975','2013-02-16','13:30:00',1.01),('8975','2013-02-16','13:45:00',2.49),('8975','2013-02-16','13:50:00',2.02),('8975','2013-02-16','13:55:00',1.33),('8975','2013-02-16','14:45:00',1.08),('8975','2013-02-16','14:50:00',1.55),('8975','2013-02-16','14:55:00',1.03),('8975','2013-02-16','15:00:00',1.3),('8975','2013-02-16','15:05:00',2.33),('8975','2013-02-16','15:10:00',2.45),('8975','2013-02-16','15:15:00',1.35),('8975','2013-02-16','15:20:00',1.46),('8975','2013-02-16','15:25:00',1.67),('8975','2013-02-16','15:30:00',1.96),('8975','2013-02-16','15:35:00',1.96),('8975','2013-02-16','15:40:00',2.16),('8975','2013-02-16','15:45:00',1.99),('8975','2013-02-16','15:50:00',1.88),('8975','2013-02-16','15:55:00',1.86),('8975','2013-02-16','16:00:00',1.7),('8975','2013-02-16','16:05:00',1.68),('8975','2013-02-16','16:10:00',1.03),('8975','2013-02-16','16:20:00',1.26),('8975','2013-02-16','16:25:00',1.7),('8975','2013-02-16','16:30:00',1.55),('8975','2013-02-16','16:35:00',1.06),('8975','2013-02-16','16:40:00',1.01),('8975','2013-02-15','07:55:00',1.66),('8975','2013-02-15','08:00:00',1.83),('8975','2013-02-15','08:05:00',1.95),('8975','2013-02-15','08:10:00',2.06),('8975','2013-02-15','08:15:00',2.17),('8975','2013-02-15','08:20:00',2.29),('8975','2013-02-15','08:25:00',2.44),('8975','2013-02-15','08:30:00',2.56),('8975','2013-02-15','08:35:00',2.69),('8975','2013-02-15','08:40:00',2.8),('8975','2013-02-15','08:45:00',2.89),('8975','2013-02-15','08:50:00',2.95),('8975','2013-02-15','08:55:00',2.87),('8975','2013-02-15','09:00:00',2.04),('8975','2013-02-15','09:05:00',1.41),('8975','2013-02-15','09:10:00',1.6),('8975','2013-02-15','09:15:00',2.32),('8975','2013-02-15','09:20:00',3.16),('8975','2013-02-15','09:25:00',3.75),('8975','2013-02-15','09:30:00',3.74),('8975','2013-02-15','09:35:00',3.78),('8975','2013-02-15','09:40:00',3.76),('8975','2013-02-15','09:45:00',3.85),('8975','2013-02-15','09:50:00',3.99),('8975','2013-02-15','09:55:00',4.1),('8975','2013-02-15','10:00:00',4.12),('8975','2013-02-15','10:05:00',4.22),('8975','2013-02-15','10:10:00',4.15),('8975','2013-02-15','10:15:00',4.09),('8975','2013-02-15','10:20:00',4.17),('8975','2013-02-15','10:25:00',4.32),('8975','2013-02-15','10:30:00',4.4),('8975','2013-02-15','10:35:00',4.29),('8975','2013-02-15','10:40:00',3.56),('8975','2013-02-15','10:45:00',4.08),('8975','2013-02-15','10:50:00',3.27),('8975','2013-02-15','10:55:00',4.55),('8975','2013-02-15','11:00:00',4.18),('8975','2013-02-15','11:05:00',3.59),('8975','2013-02-15','11:10:00',4.97),('8975','2013-02-15','11:15:00',4.92),('8975','2013-02-15','11:20:00',4.65),('8975','2013-02-15','11:25:00',4.76),('8975','2013-02-15','11:30:00',4.74),('8975','2013-02-15','11:35:00',4.71),('8975','2013-02-15','11:40:00',4.74),('8975','2013-02-15','11:45:00',4.68),('8975','2013-02-15','11:50:00',4.67),('8975','2013-02-15','11:55:00',4.62),('8975','2013-02-15','12:00:00',4.52),('8975','2013-02-15','12:05:00',4.49),('8975','2013-02-15','12:10:00',4.44),('8975','2013-02-15','12:15:00',4.45),('8975','2013-02-15','12:20:00',4.42),('8975','2013-02-15','12:25:00',4.36),('8975','2013-02-15','12:30:00',4.4),('8975','2013-02-15','12:35:00',3.81),('8975','2013-02-15','12:40:00',4.31),('8975','2013-02-15','12:45:00',4.24),('8975','2013-02-15','12:50:00',4.2),('8975','2013-02-15','12:55:00',4.14),('8975','2013-02-15','13:00:00',4),('8975','2013-02-15','13:05:00',3.93),('8975','2013-02-15','13:10:00',3.66),('8975','2013-02-15','13:15:00',3.57),('8975','2013-02-15','13:20:00',3.75),('8975','2013-02-15','13:25:00',3.79),('8975','2013-02-15','13:30:00',3.7),('8975','2013-02-15','13:35:00',3.66),('8975','2013-02-15','13:40:00',3.68),('8975','2013-02-15','13:45:00',1.52),('8975','2013-02-15','13:50:00',1.77),('8975','2013-02-15','13:55:00',1.89),('8975','2013-02-15','14:00:00',2.31),('8975','2013-02-15','14:05:00',3.23),('8975','2013-02-15','14:10:00',3.08),('8975','2013-02-15','14:15:00',2.21),('8975','2013-02-15','14:20:00',1.36),('8975','2013-02-15','14:25:00',1.41),('8975','2013-02-15','14:30:00',1.5),('8975','2013-02-15','14:35:00',1.73),('8975','2013-02-15','14:40:00',1.86),('8975','2013-02-15','14:45:00',1.71),('8975','2013-02-15','14:50:00',1.75),('8975','2013-02-15','14:55:00',1.38),('8975','2013-02-15','15:00:00',1.32),('8975','2013-02-15','15:05:00',1.42),('8975','2013-02-15','15:10:00',1.38),('8975','2013-02-15','15:15:00',1.38),('8975','2013-02-15','15:20:00',1.35),('8975','2013-02-15','15:25:00',1.44),('8975','2013-02-15','15:30:00',1.53),('8975','2013-02-15','15:35:00',1.61),('8975','2013-02-15','15:40:00',1.54),('8975','2013-02-15','15:45:00',2.15),('8975','2013-02-15','15:50:00',2.11),('8975','2013-02-15','15:55:00',1.3),('8975','2013-02-15','16:00:00',1.29),('8975','2013-02-15','16:05:00',1.35),('8975','2013-02-15','16:10:00',1.45),('8975','2013-02-15','16:15:00',1.34),('8975','2013-02-15','16:20:00',1.02),('8975','2013-02-15','16:25:00',1.26),('8975','2013-02-15','16:30:00',1.23),('8975','2013-02-14','07:40:00',1.15),('8975','2013-02-14','07:45:00',1.25),('8975','2013-02-14','07:50:00',1.54),('8975','2013-02-14','07:55:00',1.61),('8975','2013-02-14','08:00:00',1.8),('8975','2013-02-14','08:05:00',1.4),('8975','2013-02-14','08:10:00',1.73),('8975','2013-02-14','08:15:00',1.4),('8975','2013-02-14','08:50:00',1.05),('8975','2013-02-14','08:55:00',1.7),('8975','2013-02-14','09:00:00',1.29),('8975','2013-02-14','09:05:00',1.1),('8975','2013-02-14','09:10:00',1),('8975','2013-02-14','09:15:00',1.11),('8975','2013-02-14','09:20:00',1.15),('8975','2013-02-14','09:25:00',1.59),('8975','2013-02-14','09:30:00',1.53),('8975','2013-02-14','09:35:00',1.87),('8975','2013-02-14','09:40:00',1.61),('8975','2013-02-14','09:45:00',1.31),('8975','2013-02-14','09:50:00',1.74),('8975','2013-02-14','09:55:00',2.61),('8975','2013-02-14','10:00:00',3.37),('8975','2013-02-14','10:05:00',2.4),('8975','2013-02-14','10:10:00',1.5),('8975','2013-02-14','10:15:00',2.08),('8975','2013-02-14','10:20:00',2.62),('8975','2013-02-14','10:25:00',3.22),('8975','2013-02-14','10:30:00',3.42),('8975','2013-02-14','10:35:00',4.05),('8975','2013-02-14','10:40:00',3.85),('8975','2013-02-14','10:45:00',4.67),('8975','2013-02-14','10:50:00',4.44),('8975','2013-02-14','10:55:00',2.38),('8975','2013-02-14','11:00:00',2.9),('8975','2013-02-14','11:05:00',3.14),('8975','2013-02-14','11:10:00',2.92),('8975','2013-02-14','11:15:00',4.43),('8975','2013-02-14','11:20:00',4.29),('8975','2013-02-14','11:25:00',4.51),('8975','2013-02-14','11:30:00',3.59),('8975','2013-02-14','11:35:00',3.5),('8975','2013-02-14','11:40:00',3.67),('8975','2013-02-14','11:45:00',4.33),('8975','2013-02-14','11:50:00',4.65),('8975','2013-02-14','11:55:00',4.22),('8975','2013-02-14','12:00:00',3.93),('8975','2013-02-14','12:05:00',4.85),('8975','2013-02-14','12:10:00',4.67),('8975','2013-02-14','12:15:00',4.89),('8975','2013-02-14','12:20:00',4.93),('8975','2013-02-14','12:25:00',4.55),('8975','2013-02-14','12:30:00',4.53),('8975','2013-02-14','12:35:00',4.42),('8975','2013-02-14','12:40:00',3.61),('8975','2013-02-14','12:45:00',3.62),('8975','2013-02-14','12:50:00',4.24),('8975','2013-02-14','12:55:00',4.15),('8975','2013-02-14','13:00:00',3.97),('8975','2013-02-14','13:05:00',3.8),('8975','2013-02-14','13:10:00',3.82),('8975','2013-02-14','13:15:00',3.84),('8975','2013-02-14','13:20:00',3.52),('8975','2013-02-14','13:25:00',2.71),('8975','2013-02-14','13:30:00',2.83),('8975','2013-02-14','13:35:00',2.46),('8975','2013-02-14','13:40:00',3.15),('8975','2013-02-14','13:45:00',3.18),('8975','2013-02-14','13:50:00',3.29),('8975','2013-02-14','13:55:00',3.06),('8975','2013-02-14','14:00:00',3.03),('8975','2013-02-14','14:05:00',3.51),('8975','2013-02-14','14:10:00',2.87),('8975','2013-02-14','14:15:00',2.93),('8975','2013-02-14','14:20:00',2.78),('8975','2013-02-14','14:25:00',2.29),('8975','2013-02-14','14:30:00',2.41),('8975','2013-02-14','14:35:00',2.4),('8975','2013-02-14','14:40:00',2.55),('8975','2013-02-14','14:45:00',2.07),('8975','2013-02-14','14:50:00',1.69),('8975','2013-02-14','14:55:00',1.3),('8975','2013-02-14','15:00:00',1.54),('8975','2013-02-14','15:05:00',1.86),('8975','2013-02-14','15:10:00',1.31),('8975','2013-02-14','15:15:00',1.34),('8975','2013-02-14','15:20:00',1.28),('8975','2013-02-14','15:25:00',1.3),('8975','2013-02-14','15:30:00',1.52),('8975','2013-02-14','15:35:00',1.54),('8975','2013-02-14','15:40:00',1.48),('8975','2013-02-14','15:45:00',1.34),('8975','2013-02-14','15:50:00',1.13),('8975','2013-02-14','15:55:00',1.08),('8975','2013-02-14','16:00:00',1.01),('8975','2013-02-13','07:40:00',1.25),('8975','2013-02-13','07:45:00',1.56),('8975','2013-02-13','07:50:00',1.74),('8975','2013-02-13','07:55:00',1.94),('8975','2013-02-13','08:00:00',2.1),('8975','2013-02-13','08:05:00',2.21),('8975','2013-02-13','08:10:00',2.35),('8975','2013-02-13','08:15:00',2.46),('8975','2013-02-13','08:20:00',2.6),('8975','2013-02-13','08:25:00',2.71),('8975','2013-02-13','08:30:00',2.82),('8975','2013-02-13','08:35:00',2.91),('8975','2013-02-13','08:40:00',3),('8975','2013-02-13','08:45:00',3.09),('8975','2013-02-13','08:50:00',3.18),('8975','2013-02-13','08:55:00',3.26),('8975','2013-02-13','09:00:00',3.35),('8975','2013-02-13','09:05:00',3.43),('8975','2013-02-13','09:10:00',3.51),('8975','2013-02-13','09:15:00',3.58),('8975','2013-02-13','09:20:00',3.67),('8975','2013-02-13','09:25:00',3.75),('8975','2013-02-13','09:30:00',3.83),('8975','2013-02-13','09:35:00',3.88),('8975','2013-02-13','09:40:00',3.92),('8975','2013-02-13','09:45:00',4.01),('8975','2013-02-13','09:50:00',4.12),('8975','2013-02-13','09:55:00',4.23),('8975','2013-02-13','10:00:00',4.3),('8975','2013-02-13','10:05:00',4.37),('8975','2013-02-13','10:10:00',4.39),('8975','2013-02-13','10:15:00',4.29),('8975','2013-02-13','10:20:00',4.47),('8975','2013-02-13','10:25:00',4.53),('8975','2013-02-13','10:30:00',4.56),('8975','2013-02-13','10:35:00',4.6),('8975','2013-02-13','10:40:00',4.66),('8975','2013-02-13','10:45:00',4.69),('8975','2013-02-13','10:50:00',4.72),('8975','2013-02-13','10:55:00',4.74),('8975','2013-02-13','11:00:00',4.76),('8975','2013-02-13','11:05:00',4.77),('8975','2013-02-13','11:10:00',4.79),('8975','2013-02-13','11:15:00',4.74),('8975','2013-02-13','11:20:00',4.79),('8975','2013-02-13','11:25:00',4.79),('8975','2013-02-13','11:30:00',4.79),('8975','2013-02-13','11:35:00',4.79),('8975','2013-02-13','11:40:00',4.8),('8975','2013-02-13','11:45:00',4.74),('8975','2013-02-13','11:50:00',4.75),('8975','2013-02-13','11:55:00',4.54),('8975','2013-02-13','12:00:00',4.45),('8975','2013-02-13','12:05:00',4.6),('8975','2013-02-13','12:10:00',4.58),('8975','2013-02-13','12:15:00',4.46),('8975','2013-02-13','12:20:00',4.46),('8975','2013-02-13','12:25:00',4.42),('8975','2013-02-13','12:30:00',4.39),('8975','2013-02-13','12:35:00',4.36),('8975','2013-02-13','12:40:00',4.31),('8975','2013-02-13','12:45:00',4.21),('8975','2013-02-13','12:50:00',4.15),('8975','2013-02-13','12:55:00',4.07),('8975','2013-02-13','13:00:00',3.93),('8975','2013-02-13','13:05:00',3.88),('8975','2013-02-13','13:10:00',3.85),('8975','2013-02-13','13:15:00',3.71),('8975','2013-02-13','13:20:00',3.77),('8975','2013-02-13','13:25:00',3.67),('8975','2013-02-13','13:30:00',3.59),('8975','2013-02-13','13:35:00',3.52),('8975','2013-02-13','13:40:00',3.44),('8975','2013-02-13','13:45:00',3.3),('8975','2013-02-13','13:50:00',3.18),('8975','2013-02-13','13:55:00',2.98),('8975','2013-02-13','14:00:00',2.96),('8975','2013-02-13','14:05:00',2.93),('8975','2013-02-13','14:10:00',2.8),('8975','2013-02-13','14:15:00',2.66),('8975','2013-02-13','14:20:00',2.57),('8975','2013-02-13','14:25:00',2.54),('8975','2013-02-13','14:30:00',2.45),('8975','2013-02-13','14:35:00',2.38),('8975','2013-02-13','14:40:00',2.33),('8975','2013-02-13','14:45:00',2.22),('8975','2013-02-13','14:50:00',2.14),('8975','2013-02-13','14:55:00',2.07),('8975','2013-02-13','15:00:00',1.95),('8975','2013-02-13','15:05:00',1.85),('8975','2013-02-13','15:10:00',1.77),('8975','2013-02-13','15:15:00',1.69),('8975','2013-02-13','15:20:00',1.62),('8975','2013-02-13','15:25:00',1.56),('8975','2013-02-13','15:30:00',1.53),('8975','2013-02-13','15:35:00',1.48),('8975','2013-02-13','15:40:00',1.44),('8975','2013-02-13','15:45:00',1.4),('8975','2013-02-13','15:50:00',1.36),('8975','2013-02-13','15:55:00',1.32),('8975','2013-02-13','16:00:00',1.28),('8975','2013-02-13','16:05:00',1.25),('8975','2013-02-13','16:10:00',1.2),('8975','2013-02-13','16:15:00',1.16),('8975','2013-02-13','16:20:00',1.1),('8975','2013-02-13','16:25:00',1.05),('8975','2013-02-12','08:40:00',1.02),('8975','2013-02-12','08:45:00',1.17),('8975','2013-02-12','08:50:00',1.33),('8975','2013-02-12','08:55:00',1.49),('8975','2013-02-12','09:00:00',1.69),('8975','2013-02-12','09:05:00',1.84),('8975','2013-02-12','09:10:00',2.02),('8975','2013-02-12','09:15:00',2.23),('8975','2013-02-12','09:20:00',2.34),('8975','2013-02-12','09:25:00',2.71),('8975','2013-02-12','09:30:00',3.01),('8975','2013-02-12','09:35:00',3.51),('8975','2013-02-12','09:40:00',3.77),('8975','2013-02-12','09:45:00',3.81),('8975','2013-02-12','09:50:00',3.36),('8975','2013-02-12','09:55:00',3.77),('8975','2013-02-12','10:00:00',4.11),('8975','2013-02-12','10:05:00',4.13),('8975','2013-02-12','10:10:00',4.27),('8975','2013-02-12','10:15:00',4.2),('8975','2013-02-12','10:20:00',4.34),('8975','2013-02-12','10:25:00',4.49),('8975','2013-02-12','10:30:00',4.55),('8975','2013-02-12','10:35:00',4.67),('8975','2013-02-12','10:40:00',4.8),('8975','2013-02-12','10:45:00',4.76),('8975','2013-02-12','10:50:00',4.79),('8975','2013-02-12','10:55:00',4.8),('8975','2013-02-12','11:00:00',4.83),('8975','2013-02-12','11:05:00',4.81),('8975','2013-02-12','11:10:00',4.76),('8975','2013-02-12','11:15:00',4.5),('8975','2013-02-12','11:20:00',3.7),('8975','2013-02-12','11:25:00',1.91),('8975','2013-02-12','11:30:00',2.3),('8975','2013-02-12','11:35:00',4.88),('8975','2013-02-12','11:40:00',4.02),('8975','2013-02-12','11:45:00',3.78),('8975','2013-02-12','11:50:00',2.51),('8975','2013-02-12','11:55:00',3.3),('8975','2013-02-12','12:00:00',4.02),('8975','2013-02-12','12:05:00',2.97),('8975','2013-02-12','12:10:00',3.6),('8975','2013-02-12','12:15:00',2.58),('8975','2013-02-12','12:20:00',3.75),('8975','2013-02-12','12:25:00',3.38),('8975','2013-02-12','12:30:00',2.15),('8975','2013-02-12','12:35:00',3.21),('8975','2013-02-12','12:40:00',3.02),('8975','2013-02-12','12:45:00',2.92),('8975','2013-02-12','12:50:00',3.46),('8975','2013-02-12','12:55:00',3.42),('8975','2013-02-12','13:00:00',3.77),('8975','2013-02-12','13:05:00',3.38),('8975','2013-02-12','13:10:00',3.85),('8975','2013-02-12','13:15:00',4.2),('8975','2013-02-12','13:20:00',4.07),('8975','2013-02-12','13:25:00',3.8),('8975','2013-02-12','13:30:00',3.82),('8975','2013-02-12','13:35:00',3.73),('8975','2013-02-12','13:40:00',3.58),('8975','2013-02-12','13:45:00',3.23),('8975','2013-02-12','13:50:00',3.01),('8975','2013-02-12','13:55:00',2.35),('8975','2013-02-12','14:00:00',3.08),('8975','2013-02-12','14:05:00',2.51),('8975','2013-02-12','14:10:00',2.84),('8975','2013-02-12','14:15:00',2.68),('8975','2013-02-12','14:20:00',2.51),('8975','2013-02-12','14:25:00',2.48),('8975','2013-02-12','14:30:00',2.5),('8975','2013-02-12','14:35:00',2.47),('8975','2013-02-12','14:40:00',2.36),('8975','2013-02-12','14:45:00',2.25),('8975','2013-02-12','14:50:00',2.16),('8975','2013-02-12','14:55:00',2.07),('8975','2013-02-12','15:00:00',2.01),('8975','2013-02-12','15:05:00',1.89),('8975','2013-02-12','15:10:00',1.78),('8975','2013-02-12','15:15:00',1.71),('8975','2013-02-12','15:20:00',1.66),('8975','2013-02-12','15:25:00',1.6),('8975','2013-02-12','15:30:00',1.58),('8975','2013-02-12','15:35:00',1.53),('8975','2013-02-12','15:40:00',1.49),('8975','2013-02-12','15:45:00',1.45),('8975','2013-02-12','15:50:00',1.4),('8975','2013-02-12','15:55:00',1.35),('8975','2013-02-12','16:00:00',1.31),('8975','2013-02-12','16:05:00',1.29),('8975','2013-02-12','16:10:00',1.23),('8975','2013-02-12','16:15:00',1.17),('8975','2013-02-12','16:20:00',1.09),('8975','2013-02-12','16:25:00',1.05),('8975','2013-02-12','16:30:00',1.02),('8975','2013-02-10','09:25:00',1.02),('8975','2013-02-10','09:30:00',1.23),('8975','2013-02-10','09:35:00',1.04),('8975','2013-02-10','10:10:00',1.05),('8975','2013-02-10','10:15:00',1.27),('8975','2013-02-10','10:20:00',1.44),('8975','2013-02-10','10:25:00',1.65),('8975','2013-02-10','10:30:00',1.92),('8975','2013-02-10','10:35:00',1.88),('8975','2013-02-10','10:40:00',1.65),('8975','2013-02-10','10:45:00',1.5),('8975','2013-02-10','10:50:00',1.42),('8975','2013-02-10','10:55:00',1.63),('8975','2013-02-10','11:00:00',2.25),('8975','2013-02-10','11:05:00',2.13),('8975','2013-02-10','11:10:00',2.37),('8975','2013-02-10','11:15:00',2.4),('8975','2013-02-10','11:20:00',1.79),('8975','2013-02-10','11:25:00',1.27),('8975','2013-02-10','11:35:00',1.24),('8975','2013-02-10','11:40:00',1.46),('8975','2013-02-10','11:45:00',1.7),('8975','2013-02-10','11:50:00',1.21),('8975','2013-02-10','12:35:00',1.02),('8975','2013-02-10','12:40:00',1.51),('8975','2013-02-10','12:45:00',2.08),('8975','2013-02-10','12:50:00',1.16),('8975','2013-02-10','13:55:00',1.51),('8975','2013-02-10','14:00:00',1.52),('8975','2013-02-10','14:05:00',1.66),('8975','2013-02-10','14:10:00',1.65),('8975','2013-02-10','14:15:00',1.47),('8975','2013-02-10','14:20:00',1.72),('8975','2013-02-10','14:25:00',2.46),('8975','2013-02-10','14:30:00',2.61),('8975','2013-02-10','14:35:00',2.05),('8975','2013-02-10','14:40:00',2.39),('8975','2013-02-10','14:45:00',2.01),('8975','2013-02-10','14:50:00',1.45),('8975','2013-02-10','14:55:00',1.4),('8975','2013-02-10','15:00:00',1.05),('8975','2013-02-10','15:05:00',1.29),('8975','2013-02-10','15:10:00',1.38),('8975','2013-02-10','15:35:00',1),('8975','2013-02-10','15:40:00',1.09),('8975','2013-02-10','15:45:00',1.11),('8975','2014-03-21','07:30:00',1.37),('8975','2014-03-21','07:35:00',2.41),('8975','2014-03-21','07:41:00',2.57),('8975','2014-03-21','07:45:00',1.55),('8975','2014-03-21','07:50:00',1.69),('8975','2014-03-21','07:55:00',1.25),('8975','2014-03-21','08:11:00',1.21),('8975','2014-03-21','08:15:00',3),('8975','2014-03-21','08:20:00',3.24),('8975','2014-03-21','08:25:00',3.21),('8975','2014-03-21','08:30:00',3.36),('8975','2014-03-21','08:35:00',1.37),('8975','2014-03-21','08:40:00',1.89),('8975','2014-03-21','08:45:00',3.72),('8975','2014-03-21','08:50:00',2.82),('8975','2014-03-21','08:55:00',4.53),('8975','2014-03-21','09:00:00',3.29),('8975','2014-03-21','09:05:00',1.83),('8975','2014-03-21','09:10:00',2.32),('8975','2014-03-21','09:15:00',2.45),('8975','2014-03-21','09:20:00',2.9),('8975','2014-03-21','09:25:00',2.12),('8975','2014-03-21','09:30:00',2.08),('8975','2014-03-21','09:35:00',2.28),('8975','2014-03-21','09:40:00',5.42),('8975','2014-03-21','09:45:00',4.82),('8975','2014-03-21','09:50:00',4.87),('8975','2014-03-21','09:55:00',5.14),('8975','2014-03-21','10:00:00',3.32),('8975','2014-03-21','10:05:00',4.31),('8975','2014-03-21','10:10:00',5.79),('8975','2014-03-21','10:15:00',2.97),('8975','2014-03-21','10:20:00',1.91),('8975','2014-03-21','10:25:00',1.78),('8975','2014-03-21','10:30:00',2.14),('8975','2014-03-21','10:35:00',2.66),('8975','2014-03-21','10:40:00',3.27),('8975','2014-03-21','10:45:00',2.87),('8975','2014-03-21','10:50:00',2.45),('8975','2014-03-21','10:55:00',2.07),('8975','2014-03-21','11:00:00',1.89),('8975','2014-03-21','11:05:00',1.66),('8975','2014-03-21','11:10:00',1.97),('8975','2014-03-21','11:15:00',2.34),('8975','2014-03-21','11:20:00',3.11),('8975','2014-03-21','11:25:00',4.75),('8975','2014-03-21','11:30:00',4.88),('8975','2014-03-21','11:35:00',3.76),('8975','2014-03-21','11:40:00',3.58),('8975','2014-03-21','11:45:00',4.52),('8975','2014-03-21','11:50:00',2.69),('8975','2014-03-21','11:55:00',4.16),('8975','2014-03-21','12:00:00',2.8),('8975','2014-03-21','12:05:00',4.51),('8975','2014-03-21','12:10:00',3.78),('8975','2014-03-21','12:15:00',5.28),('8975','2014-03-21','12:20:00',3.79),('8975','2014-03-21','12:25:00',4.65),('8975','2014-03-21','12:30:00',2.16),('8975','2014-03-21','12:35:00',3.25),('8975','2014-03-21','12:40:00',5.69),('8975','2014-03-21','12:45:00',4.07),('8975','2014-03-21','12:50:00',5.52),('8975','2014-03-21','12:55:00',3.27),('8975','2014-03-21','13:00:00',3.43),('8975','2014-03-21','13:05:00',2.84),('8975','2014-03-21','13:10:00',1.76),('8975','2014-03-21','13:15:00',1.96),('8975','2014-03-21','13:20:00',3.54),('8975','2014-03-21','13:25:00',2.47),('8975','2014-03-21','13:30:00',3.92),('8975','2014-03-21','13:35:00',3.82),('8975','2014-03-21','13:40:00',3.32),('8975','2014-03-21','13:45:00',3.31),('8975','2014-03-21','13:50:00',1.57),('8975','2014-03-21','13:55:00',3.77),('8975','2014-03-21','14:00:00',3.67),('8975','2014-03-21','14:05:00',3.85),('8975','2014-03-21','14:10:00',4.16),('8975','2014-03-21','14:15:00',3.86),('8975','2014-03-21','14:20:00',3.62),('8975','2014-03-21','14:25:00',3.44),('8975','2014-03-21','14:30:00',3.59),('8975','2014-03-21','14:35:00',3.45),('8975','2014-03-21','14:40:00',3.25),('8975','2014-03-21','14:45:00',3.16),('8975','2014-03-21','14:50:00',2.99),('8975','2014-03-21','14:55:00',2.91),('8975','2014-03-21','15:00:00',2.93),('8975','2014-03-21','15:05:00',2.84),('8975','2014-03-21','15:10:00',2.74),('8975','2014-03-21','15:15:00',2.56),('8975','2014-03-21','15:20:00',2.51),('8975','2014-03-21','15:25:00',2.11),('8975','2014-03-21','15:30:00',1.6),('8975','2014-03-21','15:35:00',1.86),('8975','2014-03-21','15:40:00',1.98),('8975','2014-03-21','15:45:00',2.68),('8975','2014-03-21','15:50:00',2.9),('8975','2014-03-21','15:55:00',2.54),('8975','2014-03-21','16:00:00',2.29),('8975','2014-03-21','16:05:00',1.96),('8975','2014-03-21','16:10:00',1.71),('8975','2014-03-21','16:15:00',1.19),('8975','2014-03-21','17:05:00',1.09),('8975','2013-02-09','09:15:00',1.08),('8975','2013-02-09','09:40:00',1.34),('8975','2013-02-09','09:45:00',2.25),('8975','2013-02-09','09:50:00',2.78),('8975','2013-02-09','09:55:00',3.35),('8975','2013-02-09','10:00:00',3.08),('8975','2013-02-09','10:05:00',3.86),('8975','2013-02-09','10:10:00',3.67),('8975','2013-02-09','10:15:00',4.02),('8975','2013-02-09','10:20:00',3.88),('8975','2013-02-09','10:25:00',3.92),('8975','2013-02-09','10:30:00',4.38),('8975','2013-02-09','10:35:00',4.46),('8975','2013-02-09','10:40:00',4.49),('8975','2013-02-09','10:45:00',4.51),('8975','2013-02-09','10:50:00',4.56),('8975','2013-02-09','10:55:00',4.6),('8975','2013-02-09','11:00:00',4.64),('8975','2013-02-09','11:05:00',4.65),('8975','2013-02-09','11:10:00',4.64),('8975','2013-02-09','11:15:00',4.65),('8975','2013-02-09','11:20:00',4.68),('8975','2013-02-09','11:25:00',4.69),('8975','2013-02-09','11:30:00',4.7),('8975','2013-02-09','11:35:00',4.67),('8975','2013-02-09','11:40:00',4.64),('8975','2013-02-09','11:45:00',4.57),('8975','2013-02-09','11:50:00',4.25),('8975','2013-02-09','11:55:00',4.12),('8975','2013-02-09','12:00:00',4.37),('8975','2013-02-09','12:05:00',4.36),('8975','2013-02-09','12:10:00',4.43),('8975','2013-02-09','12:15:00',4.38),('8975','2013-02-09','12:20:00',4.26),('8975','2013-02-09','12:25:00',4.2),('8975','2013-02-09','12:30:00',4.2),('8975','2013-02-09','12:35:00',4.14),('8975','2013-02-09','12:40:00',4.07),('8975','2013-02-09','12:45:00',4.07),('8975','2013-02-09','12:50:00',4),('8975','2013-02-09','12:55:00',3.95),('8975','2013-02-09','13:00:00',3.87),('8975','2013-02-09','13:05:00',3.65),('8975','2013-02-09','13:10:00',3.49),('8975','2013-02-09','13:15:00',3.56),('8975','2013-02-09','13:20:00',3.65),('8975','2013-02-09','13:25:00',3.55),('8975','2013-02-09','13:30:00',3.4),('8975','2013-02-09','13:35:00',3.35),('8975','2013-02-09','13:40:00',3.2),('8975','2013-02-09','13:45:00',3.1),('8975','2013-02-09','13:50:00',2.85),('8975','2013-02-09','13:55:00',2.77),('8975','2013-02-09','14:00:00',2.79),('8975','2013-02-09','14:05:00',2.72),('8975','2013-02-09','14:10:00',2.6),('8975','2013-02-09','14:15:00',2.49),('8975','2013-02-09','14:20:00',2.42),('8975','2013-02-09','14:25:00',2.15),('8975','2013-02-09','14:30:00',1.77),('8975','2013-02-09','14:35:00',1.53),('8975','2013-02-09','14:40:00',2.12),('8975','2013-02-09','14:45:00',2.13),('8975','2013-02-09','14:50:00',2.02),('8975','2013-02-09','14:55:00',1.87),('8975','2013-02-09','15:00:00',1.82),('8975','2013-02-09','15:05:00',1.78),('8975','2013-02-09','15:10:00',1.75),('8975','2013-02-09','15:15:00',1.36),('8975','2013-02-09','15:20:00',1.55),('8975','2013-02-09','15:25:00',1.86),('8975','2013-02-09','15:30:00',1.44),('8975','2013-02-09','15:35:00',2.23),('8975','2013-02-09','15:40:00',2),('8975','2013-02-09','15:45:00',1.2),('8975','2013-02-09','16:25:00',1.1),('8975','2013-02-09','16:30:00',1.4),('8975','2013-02-09','16:35:00',1.25),('8975','2013-02-09','16:40:00',1.01),('8975','2013-02-08','09:20:00',1.11),('8975','2013-02-08','09:25:00',1.3),('8975','2013-02-08','09:30:00',1.54),('8975','2013-02-08','09:35:00',1.61),('8975','2013-02-08','09:40:00',1.38),('8975','2013-02-08','09:45:00',1.25),('8975','2013-02-08','09:50:00',1.22),('8975','2013-02-08','09:55:00',1.15),('8975','2013-02-08','10:00:00',1.02),('8975','2013-02-08','10:40:00',1.07),('8975','2013-02-08','10:45:00',1.25),('8975','2013-02-08','10:50:00',1.39),('8975','2013-02-08','10:55:00',1.49),('8975','2013-02-08','11:00:00',1.58),('8975','2013-02-08','11:05:00',1.63),('8975','2013-02-08','11:10:00',1.67),('8975','2013-02-08','11:15:00',1.77),('8975','2013-02-08','11:20:00',1.84),('8975','2013-02-08','11:25:00',1.89),('8975','2013-02-08','11:30:00',1.92),('8975','2013-02-08','11:35:00',1.87),('8975','2013-02-08','11:40:00',1.85),('8975','2013-02-08','11:45:00',1.88),('8975','2013-02-08','11:50:00',1.85),('8975','2013-02-08','11:55:00',1.81),('8975','2013-02-08','12:00:00',1.81),('8975','2013-02-08','12:05:00',1.81),('8975','2013-02-08','12:10:00',1.79),('8975','2013-02-08','12:15:00',1.82),('8975','2013-02-08','12:20:00',1.84),('8975','2013-02-08','12:25:00',1.85),('8975','2013-02-08','12:30:00',1.91),('8975','2013-02-08','12:35:00',2.01),('8975','2013-02-08','12:40:00',2.03),('8975','2013-02-08','12:45:00',2.06),('8975','2013-02-08','12:50:00',2.07),('8975','2013-02-08','12:55:00',2.04),('8975','2013-02-08','13:00:00',2.19),('8975','2013-02-08','13:05:00',2.43),('8975','2013-02-08','13:10:00',2.62),('8975','2013-02-08','13:15:00',2.76),('8975','2013-02-08','13:20:00',2.99),('8975','2013-02-08','13:25:00',3.11),('8975','2013-02-08','13:30:00',3.19),('8975','2013-02-08','13:35:00',3.24),('8975','2013-02-08','13:40:00',3.19),('8975','2013-02-08','13:45:00',3.36),('8975','2013-02-08','13:50:00',3.21),('8975','2013-02-08','13:55:00',3.35),('8975','2013-02-08','14:00:00',3.16),('8975','2013-02-08','14:05:00',3),('8975','2013-02-08','14:10:00',2.92),('8975','2013-02-08','14:15:00',2.63),('8975','2013-02-08','14:20:00',3.53),('8975','2013-02-08','14:25:00',3.34),('8975','2013-02-08','14:30:00',2.98),('8975','2013-02-08','14:35:00',2.59),('8975','2013-02-08','14:40:00',2.28),('8975','2013-02-08','14:45:00',2.11),('8975','2013-02-08','14:50:00',2.04),('8975','2013-02-08','14:55:00',1.92),('8975','2013-02-08','15:00:00',1.81),('8975','2013-02-08','15:05:00',1.71),('8975','2013-02-08','15:10:00',1.63),('8975','2013-02-08','15:15:00',1.62),('8975','2013-02-08','15:20:00',1.58),('8975','2013-02-08','15:25:00',1.54),('8975','2013-02-08','15:30:00',1.46),('8975','2013-02-08','15:35:00',1.4),('8975','2013-02-08','15:40:00',1.35),('8975','2013-02-08','15:45:00',1.24),('8975','2013-02-08','15:50:00',1.3),('8975','2013-02-08','15:55:00',1.25),('8975','2013-02-08','16:20:00',1.08),('8975','2013-02-08','16:25:00',1.02),('8975','2013-02-07','08:55:00',1.1),('8975','2013-02-07','09:20:00',1.06),('8975','2013-02-07','09:25:00',1.27),('8975','2013-02-07','09:30:00',1.35),('8975','2013-02-07','09:35:00',2.04),('8975','2013-02-07','09:40:00',4.26),('8975','2013-02-07','09:45:00',4),('8975','2013-02-07','09:50:00',4.52),('8975','2013-02-07','09:55:00',4.03),('8975','2013-02-07','10:00:00',3.34),('8975','2013-02-07','10:05:00',4.48),('8975','2013-02-07','10:10:00',4.52),('8975','2013-02-07','10:15:00',4.53),('8975','2013-02-07','10:20:00',5.03),('8975','2013-02-07','10:25:00',4.96),('8975','2013-02-07','10:30:00',3.87),('8975','2013-02-07','10:35:00',4.36),('8975','2013-02-07','10:40:00',3.2),('8975','2013-02-07','10:45:00',4.68),('8975','2013-02-07','10:50:00',4.78),('8975','2013-02-07','10:55:00',4.75),('8975','2013-02-07','11:00:00',4.82),('8975','2013-02-07','11:05:00',4.28),('8975','2013-02-07','11:10:00',4.73),('8975','2013-02-07','11:15:00',4.72),('8975','2013-02-07','11:20:00',4.72),('8975','2013-02-07','11:25:00',4.71),('8975','2013-02-07','11:30:00',4.7),('8975','2013-02-07','11:35:00',4.68),('8975','2013-02-07','11:40:00',4.66),('8975','2013-02-07','11:45:00',4.39),('8975','2013-02-07','11:50:00',4.51),('8975','2013-02-07','11:55:00',4.44),('8975','2013-02-07','12:00:00',4.32),('8975','2013-02-07','12:05:00',4.42),('8975','2013-02-07','12:10:00',4.37),('8975','2013-02-07','12:15:00',4.29),('8975','2013-02-07','12:20:00',4.24),('8975','2013-02-07','12:25:00',4.22),('8975','2013-02-07','12:30:00',4.17),('8975','2013-02-07','12:35:00',4.14),('8975','2013-02-07','12:40:00',4.24),('8975','2013-02-07','12:45:00',4.19),('8975','2013-02-07','12:50:00',2.27),('8975','2013-02-07','12:55:00',2.61),('8975','2013-02-07','13:00:00',3.18),('8975','2013-02-07','13:05:00',2.64),('8975','2013-02-07','13:10:00',2.59),('8975','2013-02-07','13:15:00',2.71),('8975','2013-02-07','13:20:00',2.56),('8975','2013-02-07','13:25:00',2.65),('8975','2013-02-07','13:30:00',2.61),('8975','2013-02-07','13:35:00',2.86),('8975','2013-02-07','13:40:00',2.4),('8975','2013-02-07','13:45:00',2.03),('8975','2013-02-07','13:50:00',2.2),('8975','2013-02-07','13:55:00',2.34),('8975','2013-02-07','14:00:00',2.14),('8975','2013-02-07','14:05:00',2.02),('8975','2013-02-07','14:10:00',1.9),('8975','2013-02-07','14:15:00',1.87),('8975','2013-02-07','14:20:00',1.91),('8975','2013-02-07','14:25:00',2.1),('8975','2013-02-07','14:30:00',2.21),('8975','2013-02-07','14:35:00',2.97),('8975','2013-02-07','14:40:00',3.5),('8975','2013-02-07','14:45:00',2.09),('8975','2013-02-07','14:50:00',2.18),('8975','2013-02-07','14:55:00',2.31),('8975','2013-02-07','15:00:00',2.9),('8975','2013-02-07','15:05:00',2.92),('8975','2013-02-07','15:10:00',2.65),('8975','2013-02-07','15:15:00',2.38),('8975','2013-02-07','15:20:00',2.1),('8975','2013-02-07','15:25:00',1.56),('8975','2013-02-07','15:30:00',1.62),('8975','2013-02-07','15:35:00',1.55),('8975','2013-02-07','15:40:00',1.49),('8975','2013-02-07','15:45:00',1.44),('8975','2013-02-07','15:50:00',1.39),('8975','2013-02-07','15:55:00',1.33),('8975','2013-02-07','16:00:00',1.3),('8975','2013-02-07','16:05:00',1.23),('8975','2013-02-07','16:10:00',1.18),('8975','2013-02-07','16:15:00',1.13),('8975','2013-02-06','10:25:00',1.17),('8975','2013-02-06','10:30:00',1.11),('8975','2013-02-06','10:35:00',1.54),('8975','2013-02-06','10:40:00',1.54),('8975','2013-02-06','10:45:00',1.37),('8975','2013-02-06','10:50:00',1.12),('8975','2013-02-06','10:55:00',1.64),('8975','2013-02-06','11:00:00',1.81),('8975','2013-02-06','11:05:00',2.01),('8975','2013-02-06','11:10:00',1.46),('8975','2013-02-06','12:20:00',2.48),('8975','2013-02-06','12:25:00',3.75),('8975','2013-02-06','12:30:00',2.4),('8975','2013-02-06','12:35:00',1.42),('8975','2013-02-06','12:45:00',1.02),('8975','2013-02-06','12:50:00',1.15),('8975','2013-02-06','13:10:00',1.25),('8975','2013-02-06','13:15:00',2.62),('8975','2013-02-06','13:20:00',1.46),('8975','2013-02-06','13:25:00',1.94),('8975','2013-02-06','13:30:00',1.5),('8975','2013-02-06','13:45:00',1.37),('8975','2013-02-06','13:50:00',1.28),('8975','2013-02-06','13:55:00',1.57),('8975','2013-02-06','14:00:00',2.05),('8975','2013-02-06','14:05:00',2.14),('8975','2013-02-06','14:10:00',2.78),('8975','2013-02-06','14:15:00',2.61),('8975','2013-02-06','14:20:00',1.98),('8975','2013-02-06','14:25:00',1.47),('8975','2013-02-06','14:30:00',1.12),('8975','2013-02-06','14:35:00',1.58),('8975','2013-02-06','14:40:00',2.71),('8975','2013-02-06','14:45:00',2.83),('8975','2013-02-06','14:50:00',2.01),('8975','2013-02-06','14:55:00',2.01),('8975','2013-02-06','15:00:00',1.79),('8975','2013-02-06','15:05:00',2.63),('8975','2013-02-06','15:10:00',2.5),('8975','2013-02-06','15:15:00',2.81),('8975','2013-02-06','15:20:00',2),('8975','2013-02-06','15:25:00',2.19),('8975','2013-02-06','15:30:00',2.36),('8975','2013-02-06','15:35:00',1.79),('8975','2013-02-06','15:40:00',1.24),('8975','2013-02-05','07:55:00',1.14),('8975','2013-02-05','08:35:00',1.37),('8975','2013-02-05','08:40:00',1.54),('8975','2013-02-05','08:45:00',1.98),('8975','2013-02-05','08:50:00',2.67),('8975','2013-02-05','08:55:00',1.77),('8975','2013-02-05','09:00:00',2.17),('8975','2013-02-05','09:05:00',2.1),('8975','2013-02-05','09:10:00',2.36),('8975','2013-02-05','09:15:00',1.77),('8975','2013-02-05','09:20:00',1.76),('8975','2013-02-05','09:25:00',1.94),('8975','2013-02-05','09:30:00',2.6),('8975','2013-02-05','09:35:00',1.9),('8975','2013-02-05','09:40:00',1.97),('8975','2013-02-05','09:45:00',2.15),('8975','2013-02-05','09:50:00',2.23),('8975','2013-02-05','09:55:00',2.71),('8975','2013-02-05','10:00:00',2.38),('8975','2013-02-05','10:05:00',2.62),('8975','2013-02-05','10:10:00',2.68),('8975','2013-02-05','10:15:00',2.05),('8975','2013-02-05','10:20:00',1.9),('8975','2013-02-05','10:25:00',2.38),('8975','2013-02-05','10:30:00',2.25),('8975','2013-02-05','10:35:00',3.08),('8975','2013-02-05','10:40:00',2.11),('8975','2013-02-05','10:45:00',1.96),('8975','2013-02-05','10:50:00',4.02),('8975','2013-02-05','10:55:00',3.31),('8975','2013-02-05','11:00:00',2.32),('8975','2013-02-05','11:05:00',2.3),('8975','2013-02-05','11:10:00',2.56),('8975','2013-02-05','11:15:00',2.21),('8975','2013-02-05','11:20:00',3.05),('8975','2013-02-05','11:25:00',3.63),('8975','2013-02-05','11:30:00',2.6),('8975','2013-02-05','11:35:00',2.35),('8975','2013-02-05','11:40:00',2.47),('8975','2013-02-05','11:45:00',2.49),('8975','2013-02-05','11:50:00',2.47),('8975','2013-02-05','11:55:00',2.33),('8975','2013-02-05','12:00:00',2.15),('8975','2013-02-05','12:05:00',1.7),('8975','2013-02-05','12:10:00',1.4),('8975','2013-02-05','12:15:00',1.81),('8975','2013-02-05','12:20:00',1.64),('8975','2013-02-05','12:25:00',1.66),('8975','2013-02-05','12:30:00',1.37),('8975','2013-02-05','12:35:00',1.11),('8975','2013-02-05','12:45:00',1.04),('8975','2013-02-05','12:50:00',1.02),('8975','2013-02-05','12:55:00',1.03),('8975','2013-02-05','13:10:00',1.06),('8975','2013-02-05','13:15:00',1.26),('8975','2013-02-05','13:20:00',1.38),('8975','2013-02-05','13:25:00',1.51),('8975','2013-02-05','13:30:00',1.74),('8975','2013-02-05','13:35:00',1.75),('8975','2013-02-05','13:40:00',1.61),('8975','2013-02-05','13:45:00',1.47),('8975','2013-02-05','13:50:00',1.8),('8975','2013-02-05','13:55:00',1.97),('8975','2013-02-05','14:00:00',2.22),('8975','2013-02-05','14:05:00',1.8),('8975','2013-02-05','14:10:00',1.28),('8975','2013-02-05','14:30:00',3.14),('8975','2013-02-05','14:35:00',2.13),('8975','2013-02-05','14:40:00',1.89),('8975','2013-02-05','15:25:00',1.34),('8975','2013-02-04','07:50:00',1.11),('8975','2013-02-04','07:55:00',1.34),('8975','2013-02-04','08:00:00',1.55),('8975','2013-02-04','08:05:00',1.74),('8975','2013-02-04','08:10:00',1.88),('8975','2013-02-04','08:15:00',2.02),('8975','2013-02-04','08:20:00',2.11),('8975','2013-02-04','08:25:00',2.24),('8975','2013-02-04','08:30:00',2.38),('8975','2013-02-04','08:35:00',2.49),('8975','2013-02-04','08:40:00',2.57),('8975','2013-02-04','08:45:00',2.64),('8975','2013-02-04','08:50:00',2.72),('8975','2013-02-04','08:55:00',2.8),('8975','2013-02-04','09:00:00',2.89),('8975','2013-02-04','09:05:00',2.93),('8975','2013-02-04','09:10:00',3.04),('8975','2013-02-04','09:15:00',3.14),('8975','2013-02-04','09:20:00',3.22),('8975','2013-02-04','09:25:00',3.31),('8975','2013-02-04','09:30:00',3.36),('8975','2013-02-04','09:35:00',3.43),('8975','2013-02-04','09:40:00',3.44),('8975','2013-02-04','09:45:00',3.44),('8975','2013-02-04','09:50:00',3.53),('8975','2013-02-04','09:55:00',3.63),('8975','2013-02-04','10:00:00',3.71),('8975','2013-02-04','10:05:00',3.75),('8975','2013-02-04','10:10:00',3.46),('8975','2013-02-04','10:15:00',3.47),('8975','2013-02-04','10:20:00',3.6),('8975','2013-02-04','10:25:00',3.88),('8975','2013-02-04','10:30:00',3.86),('8975','2013-02-04','10:35:00',3.84),('8975','2013-02-04','10:40:00',3.87),('8975','2013-02-04','10:45:00',3.94),('8975','2013-02-04','10:50:00',3.93),('8975','2013-02-04','10:55:00',3.96),('8975','2013-02-04','11:00:00',3.91),('8975','2013-02-04','11:05:00',3.85),('8975','2013-02-04','11:10:00',3.88),('8975','2013-02-04','11:15:00',3.89),('8975','2013-02-04','11:20:00',4),('8975','2013-02-04','11:25:00',3.94),('8975','2013-02-04','11:30:00',3.74),('8975','2013-02-04','11:35:00',3.64),('8975','2013-02-04','11:40:00',3.82),('8975','2013-02-04','11:45:00',4.07),('8975','2013-02-04','11:50:00',2.82),('8975','2013-02-04','11:55:00',2.41),('8975','2013-02-04','12:00:00',2.38),('8975','2013-02-04','12:05:00',2.19),('8975','2013-02-04','12:10:00',1.81),('8975','2013-02-04','12:15:00',2.87),('8975','2013-02-04','12:20:00',2.13),('8975','2013-02-04','12:25:00',1.85),('8975','2013-02-04','12:30:00',1.64),('8975','2013-02-04','12:35:00',2.42),('8975','2013-02-04','12:40:00',2.47),('8975','2013-02-04','12:45:00',3.37),('8975','2013-02-04','12:50:00',2.64),('8975','2013-02-04','12:55:00',1.49),('8975','2013-02-04','13:00:00',1),('8975','2013-02-04','13:05:00',1.56),('8975','2013-02-04','13:10:00',2.07),('8975','2013-02-04','13:15:00',1.81),('8975','2013-02-04','13:20:00',1.82),('8975','2013-02-04','13:25:00',2.15),('8975','2013-02-04','13:30:00',2.03),('8975','2013-02-04','13:35:00',1.55),('8975','2013-02-04','13:40:00',1.47),('8975','2013-02-04','13:45:00',1.66),('8975','2013-02-04','13:50:00',1.89),('8975','2013-02-04','13:55:00',1.81),('8975','2013-02-04','14:00:00',1.78),('8975','2013-02-04','14:05:00',1.76),('8975','2013-02-04','14:10:00',1.5),('8975','2013-02-04','14:15:00',1.31),('8975','2013-02-04','14:20:00',1.92),('8975','2013-02-04','14:25:00',2.29),('8975','2013-02-04','14:30:00',2.13),('8975','2013-02-04','14:35:00',2.03),('8975','2013-02-04','14:40:00',2.38),('8975','2013-02-04','14:45:00',2.36),('8975','2013-02-04','14:50:00',1.22),('8975','2013-02-04','14:55:00',1.12),('8975','2013-02-04','15:00:00',1.09),('8975','2013-02-04','15:05:00',1.42),('8975','2013-02-04','15:10:00',1.33),('8975','2013-02-04','15:15:00',1.12),('8975','2013-02-03','07:50:00',1.05),('8975','2013-02-03','07:55:00',1.45),('8975','2013-02-03','08:00:00',1.64),('8975','2013-02-03','08:05:00',1.83),('8975','2013-02-03','08:10:00',1.96),('8975','2013-02-03','08:15:00',2.11),('8975','2013-02-03','08:20:00',2.24),('8975','2013-02-03','08:25:00',2.35),('8975','2013-02-03','08:30:00',2.48),('8975','2013-02-03','08:35:00',2.6),('8975','2013-02-03','08:40:00',2.68),('8975','2013-02-03','08:45:00',2.75),('8975','2013-02-03','08:50:00',2.83),('8975','2013-02-03','08:55:00',2.6),('8975','2013-02-03','09:00:00',3.03),('8975','2013-02-03','09:05:00',3.17),('8975','2013-02-03','09:10:00',3.27),('8975','2013-02-03','09:15:00',3.39),('8975','2013-02-03','09:20:00',3.27),('8975','2013-02-03','09:25:00',3.18),('8975','2013-02-03','09:30:00',3.43),('8975','2013-02-03','09:35:00',3.45),('8975','2013-02-03','09:40:00',3.5),('8975','2013-02-03','09:45:00',3.07),('8975','2013-02-03','09:50:00',3.46),('8975','2013-02-03','09:55:00',3.81),('8975','2013-02-03','10:00:00',3.91),('8975','2013-02-03','10:05:00',4.03),('8975','2013-02-03','10:10:00',4.15),('8975','2013-02-03','10:15:00',4.23),('8975','2013-02-03','10:20:00',3.93),('8975','2013-02-03','10:25:00',4.12),('8975','2013-02-03','10:30:00',4.02),('8975','2013-02-03','10:35:00',3.67),('8975','2013-02-03','10:40:00',3.86),('8975','2013-02-03','10:45:00',4.23),('8975','2013-02-03','10:50:00',4.24),('8975','2013-02-03','10:55:00',4.27),('8975','2013-02-03','11:00:00',4.27),('8975','2013-02-03','11:05:00',4.33),('8975','2013-02-03','11:10:00',4.33),('8975','2013-02-03','11:15:00',4.34),('8975','2013-02-03','11:20:00',4.34),('8975','2013-02-03','11:25:00',4.31),('8975','2013-02-03','11:30:00',4.32),('8975','2013-02-03','11:35:00',4.29),('8975','2013-02-03','11:40:00',4.28),('8975','2013-02-03','11:45:00',3.99),('8975','2013-02-03','11:50:00',3.69),('8975','2013-02-03','11:55:00',4),('8975','2013-02-03','12:00:00',3.99),('8975','2013-02-03','12:05:00',4.01),('8975','2013-02-03','12:10:00',4.04),('8975','2013-02-03','12:15:00',4),('8975','2013-02-03','12:20:00',3.92),('8975','2013-02-03','12:25:00',3.86),('8975','2013-02-03','12:30:00',3.83),('8975','2013-02-03','12:35:00',3.78),('8975','2013-02-03','12:40:00',3.73),('8975','2013-02-03','12:45:00',3.62),('8975','2013-02-03','12:50:00',3.59),('8975','2013-02-03','12:55:00',3.45),('8975','2013-02-03','13:00:00',3.36),('8975','2013-02-03','13:05:00',3.39),('8975','2013-02-03','13:10:00',3.4),('8975','2013-02-03','13:15:00',3.38),('8975','2013-02-03','13:20:00',3.27),('8975','2013-02-03','13:25:00',3.1),('8975','2013-02-03','13:30:00',2.95),('8975','2013-02-03','13:35:00',2.74),('8975','2013-02-03','13:40:00',2.82),('8975','2013-02-03','13:45:00',2.51),('8975','2013-02-03','13:50:00',2.61),('8975','2013-02-03','13:55:00',2.43),('8975','2013-02-03','14:00:00',2.33),('8975','2013-02-03','14:05:00',2.23),('8975','2013-02-03','14:10:00',2.33),('8975','2013-02-03','14:15:00',2.13),('8975','2013-02-03','14:20:00',1.85),('8975','2013-02-03','14:25:00',1.81),('8975','2013-02-03','14:30:00',1.94),('8975','2013-02-03','14:35:00',1.79),('8975','2013-02-03','14:40:00',1.31),('8975','2013-02-03','14:45:00',1.62),('8975','2013-02-03','14:50:00',1.58),('8975','2013-02-03','14:55:00',1.53),('8975','2013-02-03','15:00:00',1.6),('8975','2013-02-03','15:05:00',1.53),('8975','2013-02-03','15:10:00',1.49),('8975','2013-02-03','15:15:00',1.48),('8975','2013-02-03','15:20:00',1.45),('8975','2013-02-03','15:25:00',1.41),('8975','2013-02-03','15:30:00',1.38),('8975','2013-02-03','15:35:00',1.34),('8975','2013-02-03','15:40:00',1.31),('8975','2013-02-03','15:45:00',1.28),('8975','2013-02-03','15:50:00',1.25),('8975','2013-02-03','15:55:00',1.21),('8975','2013-02-03','16:00:00',1.17),('8975','2013-02-03','16:05:00',1.13),('8975','2013-02-03','16:10:00',1.09),('8975','2013-02-03','16:15:00',1.04),('8975','2013-02-02','08:40:00',1.36),('8975','2013-02-02','08:45:00',1.16),('8975','2013-02-02','09:00:00',1.33),('8975','2013-02-02','09:15:00',1.09),('8975','2013-02-02','09:20:00',1.49),('8975','2013-02-02','09:25:00',1.59),('8975','2013-02-02','09:30:00',1.37),('8975','2013-02-02','09:35:00',1.48),('8975','2013-02-02','09:40:00',2.78),('8975','2013-02-02','09:45:00',4.55),('8975','2013-02-02','09:50:00',2.38),('8975','2013-02-02','09:55:00',2.78),('8975','2013-02-02','10:00:00',3.55),('8975','2013-02-02','10:05:00',1.53),('8975','2013-02-02','10:10:00',1.11),('8975','2013-02-02','10:15:00',2.16),('8975','2013-02-02','10:20:00',2.38),('8975','2013-02-02','10:25:00',1.46),('8975','2013-02-02','10:30:00',1.25),('8975','2013-02-02','10:35:00',1.2),('8975','2013-02-02','10:40:00',1.08),('8975','2013-02-02','11:15:00',2.23),('8975','2013-02-02','11:20:00',1.89),('8975','2013-02-02','11:40:00',1.1),('8975','2013-02-02','11:45:00',1.82),('8975','2013-02-02','11:50:00',2.02),('8975','2013-02-02','11:55:00',1.96),('8975','2013-02-02','12:00:00',1.83),('8975','2013-02-02','12:05:00',1.8),('8975','2013-02-02','12:10:00',1.6),('8975','2013-02-02','12:15:00',1.09),('8975','2013-02-02','13:50:00',1.16),('8975','2013-02-02','14:55:00',1),('8975','2013-02-01','10:05:00',1.08),('8975','2013-02-01','10:10:00',1.28),('8975','2013-02-01','10:15:00',1.94),('8975','2013-02-01','10:20:00',1.97),('8975','2013-02-01','10:25:00',1.78),('8975','2013-02-01','10:30:00',2.03),('8975','2013-02-01','10:35:00',2.09),('8975','2013-02-01','10:40:00',2.2),('8975','2013-02-01','10:45:00',2.34),('8975','2013-02-01','10:50:00',2.17),('8975','2013-02-01','10:55:00',2.85),('8975','2013-02-01','11:00:00',3.12),('8975','2013-02-01','11:05:00',2.64),('8975','2013-02-01','11:10:00',2.83),('8975','2013-02-01','11:15:00',3.03),('8975','2013-02-01','11:20:00',2.88),('8975','2013-02-01','11:25:00',3.48),('8975','2013-02-01','11:30:00',3.16),('8975','2013-02-01','11:35:00',2.74),('8975','2013-02-01','11:40:00',2.6),('8975','2013-02-01','11:45:00',2.17),('8975','2013-02-01','11:50:00',2.23),('8975','2013-02-01','11:55:00',1.71),('8975','2013-02-01','12:00:00',1.33),('8975','2013-02-01','12:05:00',1.08),('8975','2013-02-01','12:50:00',1.42),('8975','2013-02-01','12:55:00',2.8),('8975','2013-02-01','13:00:00',1.86),('8975','2013-02-01','13:05:00',2.14),('8975','2013-02-01','13:10:00',2.49),('8975','2013-02-01','13:15:00',2.5),('8975','2013-02-01','13:20:00',2.24),('8975','2013-02-01','13:25:00',2.21),('8975','2013-02-01','13:30:00',2.01),('8975','2013-02-01','13:35:00',2.56),('8975','2013-02-01','13:40:00',2.77),('8975','2013-02-01','13:45:00',2.63),('8975','2013-02-01','13:50:00',2.31),('8975','2013-02-01','13:55:00',1.54),('8975','2013-01-31','08:15:00',1.38),('8975','2013-01-31','08:20:00',1.49),('8975','2013-01-31','08:25:00',1),('8975','2013-01-31','08:30:00',1.89),('8975','2013-01-31','08:35:00',1.85),('8975','2013-01-31','08:40:00',1.69),('8975','2013-01-31','08:45:00',2.05),('8975','2013-01-31','08:50:00',1.35),('8975','2013-01-31','09:00:00',1.1),('8975','2013-01-31','09:05:00',1.47),('8975','2013-01-31','09:10:00',1.06),('8975','2013-01-31','09:15:00',1.39),('8975','2013-01-31','09:20:00',1.11),('8975','2013-01-31','09:30:00',1.38),('8975','2013-01-31','09:35:00',1.47),('8975','2013-01-31','09:40:00',1.33),('8975','2013-01-31','09:45:00',1.42),('8975','2013-01-31','09:50:00',1.6),('8975','2013-01-31','09:55:00',1.16),('8975','2013-01-31','10:00:00',1.04),('8975','2013-01-31','10:10:00',2.5),('8975','2013-01-31','10:15:00',3),('8975','2013-01-31','10:20:00',1.96),('8975','2013-01-31','10:25:00',3.44),('8975','2013-01-31','10:30:00',3.81),('8975','2013-01-31','10:35:00',1.61),('8975','2013-01-31','10:40:00',1.91),('8975','2013-01-31','10:45:00',3.14),('8975','2013-01-31','10:50:00',2.32),('8975','2013-01-31','10:55:00',3.8),('8975','2013-01-31','11:00:00',4.03),('8975','2013-01-31','11:05:00',3.59),('8975','2013-01-31','11:10:00',4.25),('8975','2013-01-31','11:15:00',4.58),('8975','2013-01-31','11:20:00',4.91),('8975','2013-01-31','11:25:00',5.21),('8975','2013-01-31','11:30:00',5.16),('8975','2013-01-31','11:35:00',5.26),('8975','2013-01-31','11:40:00',4.98),('8975','2013-01-31','11:45:00',4.82),('8975','2013-01-31','11:50:00',4.08),('8975','2013-01-31','11:55:00',4.09),('8975','2013-01-31','12:00:00',4.72),('8975','2013-01-31','12:05:00',4.36),('8975','2013-01-31','12:10:00',4.3),('8975','2013-01-31','12:15:00',3.93),('8975','2013-01-31','12:20:00',3.2),('8975','2013-01-31','12:25:00',1.79),('8975','2013-01-31','12:30:00',2.87),('8975','2013-01-31','12:35:00',3.99),('8975','2013-01-31','12:40:00',3.67),('8975','2013-01-31','12:45:00',3.27),('8975','2013-01-31','12:50:00',3.8),('8975','2013-01-31','12:55:00',2.29),('8975','2013-01-31','13:00:00',3.68),('8975','2013-01-31','13:05:00',3.29),('8975','2013-01-31','13:10:00',3.02),('8975','2013-01-31','13:15:00',3.2),('8975','2013-01-31','13:20:00',2.47),('8975','2013-01-31','13:25:00',3.24),('8975','2013-01-31','13:30:00',3.05),('8975','2013-01-31','13:35:00',2.55),('8975','2013-01-31','13:40:00',2.71),('8975','2013-01-31','13:45:00',2.31),('8975','2013-01-31','13:50:00',2.29),('8975','2013-01-31','13:55:00',3.25),('8975','2013-01-31','14:00:00',1.99),('8975','2013-01-31','14:05:00',1.95),('8975','2013-01-31','14:10:00',2.12),('8975','2013-01-31','14:15:00',2.41),('8975','2013-01-31','14:20:00',2.06),('8975','2013-01-31','14:25:00',1.98),('8975','2013-01-31','14:30:00',2.02),('8975','2013-01-31','14:35:00',1.47),('8975','2013-01-31','14:40:00',1.92),('8975','2013-01-31','14:45:00',1.61),('8975','2013-01-31','14:50:00',1.15),('8975','2013-01-31','14:55:00',1.74),('8975','2013-01-31','15:05:00',1.26),('8975','2013-01-31','15:10:00',1.94),('8975','2013-01-31','15:15:00',1.63),('8975','2013-01-31','15:20:00',1.5),('8975','2013-01-31','15:25:00',1.24),('8975','2013-01-31','15:30:00',1.31),('8975','2013-01-31','15:35:00',1.03),('8975','2013-01-31','15:40:00',1.06),('8975','2013-01-31','15:50:00',1.34),('8975','2014-03-20','07:00:00',1.11),('8975','2014-03-20','07:05:00',1.04),('8975','2014-03-20','07:14:00',1.2),('8975','2014-03-20','07:15:00',1.72),('8975','2014-03-20','07:20:00',1.82),('8975','2014-03-20','07:25:00',1.79),('8975','2014-03-20','07:30:00',1.85),('8975','2014-03-20','07:35:00',2.19),('8975','2014-03-20','07:40:00',2.42),('8975','2014-03-20','07:46:00',2.55),('8975','2014-03-20','07:50:00',2.85),('8975','2014-03-20','07:55:00',2.92),('8975','2014-03-20','08:00:00',3.03),('8975','2014-03-20','08:05:00',3.1),('8975','2014-03-20','08:10:00',3.24),('8975','2014-03-20','08:16:00',3.33),('8975','2014-03-20','08:20:00',3.41),('8975','2014-03-20','08:25:00',3.52),('8975','2014-03-20','08:30:00',3.66),('8975','2014-03-20','08:35:00',3.72),('8975','2014-03-20','08:40:00',3.81),('8975','2014-03-20','08:45:00',3.87),('8975','2014-03-20','08:50:00',4),('8975','2014-03-20','08:55:00',4.06),('8975','2014-03-20','09:00:00',4.19),('8975','2014-03-20','09:05:00',4.21),('8975','2014-03-20','09:10:00',4.39),('8975','2014-03-20','09:15:00',4.43),('8975','2014-03-20','09:20:00',4.46),('8975','2014-03-20','09:25:00',4.69),('8975','2014-03-20','09:30:00',4.6),('8975','2014-03-20','09:35:00',4.68),('8975','2014-03-20','09:40:00',4.87),('8975','2014-03-20','09:45:00',4.9),('8975','2014-03-20','09:50:00',4.95),('8975','2014-03-20','09:55:00',4.93),('8975','2014-03-20','10:00:00',5),('8975','2014-03-20','10:05:00',4.99),('8975','2014-03-20','10:10:00',5),('8975','2014-03-20','10:15:00',5.06),('8975','2014-03-20','10:20:00',5.06),('8975','2014-03-20','10:25:00',5.11),('8975','2014-03-20','10:30:00',5.22),('8975','2014-03-20','10:35:00',5.25),('8975','2014-03-20','10:40:00',5.3),('8975','2014-03-20','10:45:00',5.25),('8975','2014-03-20','10:50:00',5.2),('8975','2014-03-20','10:55:00',5.16),('8975','2014-03-20','11:00:00',5.31),('8975','2014-03-20','11:05:00',5.27),('8975','2014-03-20','11:10:00',5.29),('8975','2014-03-20','11:15:00',5.24),('8975','2014-03-20','11:20:00',5.43),('8975','2014-03-20','11:25:00',5.41),('8975','2014-03-20','11:30:00',5.54),('8975','2014-03-20','11:35:00',5.15),('8975','2014-03-20','11:40:00',2.72),('8975','2014-03-20','11:45:00',2.87),('8975','2014-03-20','11:50:00',6.07),('8975','2014-03-20','11:55:00',5.82),('8975','2014-03-20','12:00:00',5.62),('8975','2014-03-20','12:05:00',5.52),('8975','2014-03-20','12:10:00',5.44),('8975','2014-03-20','12:15:00',5.43),('8975','2014-03-20','12:20:00',5.31),('8975','2014-03-20','12:25:00',5.29),('8975','2014-03-20','12:30:00',5.32),('8975','2014-03-20','12:35:00',5.3),('8975','2014-03-20','12:40:00',5.33),('8975','2014-03-20','12:45:00',5.25),('8975','2014-03-20','12:50:00',5.09),('8975','2014-03-20','12:55:00',5.11),('8975','2014-03-20','13:00:00',5.01),('8975','2014-03-20','13:05:00',4.99),('8975','2014-03-20','13:10:00',4.95),('8975','2014-03-20','13:15:00',4.91),('8975','2014-03-20','13:20:00',4.73),('8975','2014-03-20','13:25:00',4.64),('8975','2014-03-20','13:30:00',4.47),('8975','2014-03-20','13:35:00',4.51),('8975','2014-03-20','13:40:00',4.43),('8975','2014-03-20','13:45:00',4.38),('8975','2014-03-20','13:50:00',4.28),('8975','2014-03-20','13:55:00',4.22),('8975','2014-03-20','14:00:00',4.12),('8975','2014-03-20','14:05:00',4.03),('8975','2014-03-20','14:10:00',3.92),('8975','2014-03-20','14:15:00',3.85),('8975','2014-03-20','14:20:00',3.73),('8975','2014-03-20','14:25:00',3.62),('8975','2014-03-20','14:30:00',3.41),('8975','2014-03-20','14:35:00',3.23),('8975','2014-03-20','14:40:00',3.11),('8975','2014-03-20','14:45:00',3.02),('8975','2014-03-20','14:50:00',1.99),('8975','2014-03-20','14:55:00',1.18),('8975','2014-03-20','15:00:00',1.33),('8975','2014-03-20','15:05:00',2.3),('8975','2014-03-20','15:10:00',3.46),('8975','2014-03-20','15:15:00',3.25),('8975','2014-03-20','15:20:00',3.03),('8975','2014-03-20','15:25:00',3.29),('8975','2014-03-20','15:30:00',2.96),('8975','2014-03-20','15:35:00',2.96),('8975','2014-03-20','15:40:00',2.84),('8975','2014-03-20','15:45:00',2.8),('8975','2014-03-20','15:50:00',2.71),('8975','2014-03-20','15:55:00',2.57),('8975','2014-03-20','16:00:00',2.37),('8975','2014-03-20','16:05:00',2.19),('8975','2014-03-20','16:10:00',2.04),('8975','2014-03-20','16:15:00',1.86),('8975','2014-03-20','16:20:00',1.65),('8975','2014-03-20','16:25:00',1.56),('8975','2014-03-20','16:30:00',1.44),('8975','2014-03-20','16:35:00',1.39),('8975','2014-03-20','16:40:00',1.34),('8975','2014-03-20','16:45:00',1.3),('8975','2014-03-20','16:50:00',1.22),('8975','2014-03-20','16:55:00',1.16),('8975','2014-03-20','17:00:00',1.02),('8975','2014-03-20','17:05:00',1),('8975','2013-01-30','09:05:00',1.6),('8975','2013-01-30','09:10:00',2.43),('8975','2013-01-30','09:15:00',1.45),('8975','2013-01-30','09:20:00',1.71),('8975','2013-01-30','09:25:00',1.14),('8975','2013-01-30','09:30:00',1.57),('8975','2013-01-30','09:35:00',2.55),('8975','2013-01-30','09:40:00',2.89),('8975','2013-01-30','09:45:00',2.51),('8975','2013-01-30','09:50:00',1.62),('8975','2013-01-30','09:55:00',1.05),('8975','2013-01-30','10:00:00',1.07),('8975','2013-01-30','10:05:00',3.46),('8975','2013-01-30','10:10:00',3.44),('8975','2013-01-30','10:15:00',3.14),('8975','2013-01-30','10:20:00',3.15),('8975','2013-01-30','10:25:00',3.39),('8975','2013-01-30','10:30:00',3.54),('8975','2013-01-30','10:35:00',3.39),('8975','2013-01-30','10:40:00',3.31),('8975','2013-01-30','10:45:00',3.72),('8975','2013-01-30','10:50:00',3.71),('8975','2013-01-30','10:55:00',4.05),('8975','2013-01-30','11:00:00',3.98),('8975','2013-01-30','11:05:00',2.98),('8975','2013-01-30','11:10:00',1.69),('8975','2013-01-30','11:15:00',3.87),('8975','2013-01-30','11:20:00',3.85),('8975','2013-01-30','11:25:00',4.13),('8975','2013-01-30','11:30:00',3.93),('8975','2013-01-30','11:35:00',3.93),('8975','2013-01-30','11:40:00',3.74),('8975','2013-01-30','11:45:00',3.67),('8975','2013-01-30','11:50:00',3.79),('8975','2013-01-30','11:55:00',3.63),('8975','2013-01-30','12:00:00',3.57),('8975','2013-01-30','12:05:00',3.64),('8975','2013-01-30','12:10:00',3.56),('8975','2013-01-30','12:15:00',3.48),('8975','2013-01-30','12:20:00',3.47),('8975','2013-01-30','12:25:00',3.45),('8975','2013-01-30','12:30:00',3.38),('8975','2013-01-30','12:35:00',3.37),('8975','2013-01-30','12:40:00',3.29),('8975','2013-01-30','12:45:00',3.29),('8975','2013-01-30','12:50:00',3.24),('8975','2013-01-30','12:55:00',3.11),('8975','2013-01-30','13:00:00',3.05),('8975','2013-01-30','13:05:00',3.04),('8975','2013-01-30','13:10:00',3.01),('8975','2013-01-30','13:15:00',2.99),('8975','2013-01-30','13:20:00',2.91),('8975','2013-01-30','13:25:00',2.67),('8975','2013-01-30','13:30:00',2.72),('8975','2013-01-30','13:35:00',2.58),('8975','2013-01-30','13:40:00',2.6),('8975','2013-01-30','13:45:00',2.46),('8975','2013-01-30','13:50:00',2.46),('8975','2013-01-30','13:55:00',2.32),('8975','2013-01-30','14:00:00',2.18),('8975','2013-01-30','14:05:00',2.14),('8975','2013-01-30','14:10:00',2.08),('8975','2013-01-30','14:15:00',2.01),('8975','2013-01-30','14:20:00',1.92),('8975','2013-01-30','14:25:00',1.9),('8975','2013-01-30','14:30:00',1.82),('8975','2013-01-30','14:35:00',1.74),('8975','2013-01-30','14:40:00',1.66),('8975','2013-01-30','14:45:00',1.58),('8975','2013-01-30','14:50:00',1.55),('8975','2013-01-30','14:55:00',1.52),('8975','2013-01-30','15:00:00',1.48),('8975','2013-01-30','15:05:00',1.47),('8975','2013-01-30','15:10:00',1.42),('8975','2013-01-30','15:15:00',1.46),('8975','2013-01-30','15:20:00',1.46),('8975','2013-01-30','15:25:00',1.3),('8975','2013-01-30','15:30:00',1.28),('8975','2013-01-30','15:35:00',1.38),('8975','2013-01-30','15:40:00',1.31),('8975','2013-01-30','15:45:00',1.23),('8975','2013-01-30','15:50:00',1.17),('8975','2013-01-30','15:55:00',1.11),('8975','2013-01-29','09:20:00',1.22),('8975','2013-01-29','09:25:00',1.36),('8975','2013-01-29','09:30:00',1.47),('8975','2013-01-29','09:35:00',1.53),('8975','2013-01-29','09:40:00',1.28),('8975','2013-01-29','09:45:00',1.15),('8975','2013-01-29','10:00:00',1.62),('8975','2013-01-29','10:05:00',1.62),('8975','2013-01-29','10:10:00',2.59),('8975','2013-01-29','10:15:00',2.3),('8975','2013-01-29','10:20:00',2.7),('8975','2013-01-29','10:25:00',2.34),('8975','2013-01-29','10:30:00',2),('8975','2013-01-29','10:35:00',1.94),('8975','2013-01-29','10:40:00',2.37),('8975','2013-01-29','10:45:00',2.38),('8975','2013-01-29','10:50:00',3.58),('8975','2013-01-29','10:55:00',2.86),('8975','2013-01-29','11:00:00',2.73),('8975','2013-01-29','11:05:00',3),('8975','2013-01-29','11:10:00',2.88),('8975','2013-01-29','11:15:00',3.62),('8975','2013-01-29','11:20:00',3.45),('8975','2013-01-29','11:25:00',3.52),('8975','2013-01-29','11:30:00',3.64),('8975','2013-01-29','11:35:00',3.37),('8975','2013-01-29','11:40:00',3.74),('8975','2013-01-29','11:45:00',2.18),('8975','2013-01-29','11:50:00',2.59),('8975','2013-01-29','11:55:00',2.57),('8975','2013-01-29','12:00:00',1.89),('8975','2013-01-29','12:05:00',2.63),('8975','2013-01-29','12:10:00',3.77),('8975','2013-01-29','12:15:00',2.91),('8975','2013-01-29','12:20:00',1.55),('8975','2013-01-29','12:25:00',1.28),('8975','2013-01-29','12:30:00',1.37),('8975','2013-01-29','12:35:00',2.94),('8975','2013-01-29','12:40:00',3.45),('8975','2013-01-29','12:45:00',3.95),('8975','2013-01-29','12:50:00',3.7),('8975','2013-01-29','12:55:00',3.45),('8975','2013-01-29','13:00:00',3.28),('8975','2013-01-29','13:05:00',3.27),('8975','2013-01-29','13:10:00',3.17),('8975','2013-01-29','13:15:00',3.2),('8975','2013-01-29','13:20:00',3.15),('8975','2013-01-29','13:25:00',1.89),('8975','2013-01-29','13:35:00',2.23),('8975','2013-01-29','13:40:00',2.26),('8975','2013-01-29','13:45:00',2.58),('8975','2013-01-29','13:50:00',2.75),('8975','2013-01-29','13:55:00',2.42),('8975','2013-01-29','14:00:00',1.71),('8975','2013-01-29','14:05:00',1.4),('8975','2013-01-29','14:10:00',1.7),('8975','2013-01-29','14:15:00',1.92),('8975','2013-01-29','14:20:00',1.78),('8975','2013-01-29','14:25:00',1.41),('8975','2013-01-29','14:30:00',1.7),('8975','2013-01-29','14:35:00',1.71),('8975','2013-01-29','14:40:00',1.95),('8975','2013-01-29','14:45:00',1.61),('8975','2013-01-29','14:50:00',1.26),('8975','2013-01-29','14:55:00',1.24),('8975','2013-01-29','15:00:00',1.29),('8975','2013-01-29','15:05:00',1.35),('8975','2013-01-29','15:10:00',1.17),('8975','2013-01-29','15:15:00',1.06),('8975','2013-01-28','08:00:00',1.12),('8975','2013-01-28','08:05:00',1.33),('8975','2013-01-28','08:10:00',1.49),('8975','2013-01-28','08:15:00',1.62),('8975','2013-01-28','08:20:00',1.73),('8975','2013-01-28','08:25:00',1.83),('8975','2013-01-28','08:30:00',1.93),('8975','2013-01-28','08:35:00',2.01),('8975','2013-01-28','08:40:00',2.17),('8975','2013-01-28','08:45:00',1.67),('8975','2013-01-28','08:50:00',1.72),('8975','2013-01-28','08:55:00',2.45),('8975','2013-01-28','09:00:00',2.56),('8975','2013-01-28','09:05:00',2.64),('8975','2013-01-28','09:10:00',2.71),('8975','2013-01-28','09:15:00',2.75),('8975','2013-01-28','09:20:00',2.85),('8975','2013-01-28','09:25:00',2.92),('8975','2013-01-28','09:30:00',3),('8975','2013-01-28','09:35:00',3.1),('8975','2013-01-28','09:40:00',3.19),('8975','2013-01-28','09:45:00',3.24),('8975','2013-01-28','09:50:00',3.27),('8975','2013-01-28','09:55:00',3.29),('8975','2013-01-28','10:00:00',3.37),('8975','2013-01-28','10:05:00',3.48),('8975','2013-01-28','10:10:00',3.58),('8975','2013-01-28','10:15:00',3.67),('8975','2013-01-28','10:20:00',3.59),('8975','2013-01-28','10:25:00',3.48),('8975','2013-01-28','10:30:00',3.62),('8975','2013-01-28','10:35:00',3.81),('8975','2013-01-28','10:40:00',3.86),('8975','2013-01-28','10:45:00',3.89),('8975','2013-01-28','10:50:00',3.88),('8975','2013-01-28','10:55:00',3.83),('8975','2013-01-28','11:00:00',3.84),('8975','2013-01-28','11:05:00',3.9),('8975','2013-01-28','11:10:00',3.88),('8975','2013-01-28','11:15:00',3.86),('8975','2013-01-28','11:20:00',3.88),('8975','2013-01-28','11:25:00',3.89),('8975','2013-01-28','11:30:00',3.78),('8975','2013-01-28','11:35:00',3.96),('8975','2013-01-28','11:40:00',3.94),('8975','2013-01-28','11:45:00',3.86),('8975','2013-01-28','11:50:00',3.84),('8975','2013-01-28','11:55:00',3.72),('8975','2013-01-28','12:00:00',3.71),('8975','2013-01-28','12:05:00',3.64),('8975','2013-01-28','12:10:00',3.69),('8975','2013-01-28','12:15:00',3.61),('8975','2013-01-28','12:20:00',3.53),('8975','2013-01-28','12:25:00',3.45),('8975','2013-01-28','12:30:00',3.44),('8975','2013-01-28','12:35:00',3.39),('8975','2013-01-28','12:40:00',3.34),('8975','2013-01-28','12:45:00',3.25),('8975','2013-01-28','12:50:00',3.07),('8975','2013-01-28','12:55:00',3.1),('8975','2013-01-28','13:00:00',3.04),('8975','2013-01-28','13:05:00',3.05),('8975','2013-01-28','13:10:00',3.06),('8975','2013-01-28','13:15:00',2.99),('8975','2013-01-28','13:20:00',2.93),('8975','2013-01-28','13:25:00',2.85),('8975','2013-01-28','13:30:00',2.69),('8975','2013-01-28','13:35:00',2.57),('8975','2013-01-28','13:40:00',2.53),('8975','2013-01-28','13:45:00',2.46),('8975','2013-01-28','13:50:00',2.32),('8975','2013-01-28','13:55:00',2.1),('8975','2013-01-28','14:00:00',2.02),('8975','2013-01-28','14:05:00',2.02),('8975','2013-01-28','14:10:00',2.06),('8975','2013-01-28','14:15:00',1.99),('8975','2013-01-28','14:20:00',1.94),('8975','2013-01-28','14:25:00',1.87),('8975','2013-01-28','14:30:00',1.8),('8975','2013-01-28','14:35:00',1.78),('8975','2013-01-28','14:40:00',1.7),('8975','2013-01-28','14:45:00',1.57),('8975','2013-01-28','14:50:00',1.5),('8975','2013-01-28','14:55:00',1.45),('8975','2013-01-28','15:00:00',1.39),('8975','2013-01-28','15:05:00',1.39),('8975','2013-01-28','15:10:00',1.39),('8975','2013-01-28','15:15:00',1.37),('8975','2013-01-28','15:20:00',1.34),('8975','2013-01-28','15:25:00',1.3),('8975','2013-01-28','15:30:00',1.27),('8975','2013-01-28','15:35:00',1.25),('8975','2013-01-28','15:40:00',1.22),('8975','2013-01-28','15:45:00',1.17),('8975','2013-01-28','15:50:00',1.14),('8975','2013-01-28','15:55:00',1.09),('8975','2013-01-28','16:00:00',1.05),('8975','2013-01-28','16:05:00',1.03),('8975','2013-01-27','10:55:00',1.02),('8975','2013-01-27','11:00:00',1.22),('8975','2013-01-27','11:05:00',1.4),('8975','2013-01-27','11:10:00',1.37),('8975','2013-01-27','11:15:00',1.16),('8975','2013-01-27','11:20:00',1.14),('8975','2013-01-27','11:25:00',1.1),('8975','2013-01-27','12:35:00',1.13),('8975','2013-01-27','12:40:00',1.46),('8975','2013-01-27','12:45:00',1.87),('8975','2013-01-27','12:50:00',2.06),('8975','2013-01-27','12:55:00',1.89),('8975','2013-01-27','13:00:00',1.72),('8975','2013-01-27','13:05:00',1.62),('8975','2013-01-27','13:10:00',1.44),('8975','2013-01-27','13:15:00',1.42),('8975','2013-01-27','13:20:00',1.47),('8975','2013-01-27','13:25:00',1.59),('8975','2013-01-27','13:30:00',1.5),('8975','2013-01-27','13:35:00',1.21),('8975','2013-01-27','13:40:00',1.05),('8975','2013-01-27','13:50:00',1.05),('8975','2013-01-27','13:55:00',1.07),('8975','2013-01-27','14:00:00',1.15),('8975','2013-01-27','14:05:00',1.15),('8975','2013-01-27','14:10:00',1.11),('8975','2013-01-27','14:15:00',1.01),('8975','2013-01-26','08:05:00',1.18),('8975','2013-01-26','08:10:00',1.34),('8975','2013-01-26','08:15:00',1.48),('8975','2013-01-26','08:20:00',1.62),('8975','2013-01-26','08:25:00',1.81),('8975','2013-01-26','08:30:00',2.01),('8975','2013-01-26','08:35:00',2.29),('8975','2013-01-26','08:40:00',2.44),('8975','2013-01-26','08:45:00',2.4),('8975','2013-01-26','08:50:00',1.95),('8975','2013-01-26','08:55:00',2.45),('8975','2013-01-26','09:00:00',2.6),('8975','2013-01-26','09:05:00',2.52),('8975','2013-01-26','09:10:00',2.63),('8975','2013-01-26','09:15:00',2.7),('8975','2013-01-26','09:20:00',2.79),('8975','2013-01-26','09:25:00',2.87),('8975','2013-01-26','09:30:00',2.95),('8975','2013-01-26','09:35:00',3.05),('8975','2013-01-26','09:40:00',3.12),('8975','2013-01-26','09:45:00',3.18),('8975','2013-01-26','09:50:00',3.19),('8975','2013-01-26','09:55:00',3.25),('8975','2013-01-26','10:00:00',3.3),('8975','2013-01-26','10:05:00',3.38),('8975','2013-01-26','10:10:00',3.45),('8975','2013-01-26','10:15:00',3.52),('8975','2013-01-26','10:20:00',3.45),('8975','2013-01-26','10:25:00',3.34),('8975','2013-01-26','10:30:00',3.41),('8975','2013-01-26','10:35:00',3.59),('8975','2013-01-26','10:40:00',3.62),('8975','2013-01-26','10:45:00',3.65),('8975','2013-01-26','10:50:00',3.65),('8975','2013-01-26','10:55:00',3.6),('8975','2013-01-26','11:00:00',3.65),('8975','2013-01-26','11:05:00',3.76),('8975','2013-01-26','11:10:00',3.76),('8975','2013-01-26','11:15:00',3.79),('8975','2013-01-26','11:20:00',3.8),('8975','2013-01-26','11:25:00',3.78),('8975','2013-01-26','11:30:00',3.79),('8975','2013-01-26','11:35:00',3.79),('8975','2013-01-26','11:40:00',3.71),('8975','2013-01-26','11:45:00',3.54),('8975','2013-01-26','11:50:00',3.64),('8975','2013-01-26','11:55:00',3.59),('8975','2013-01-26','12:00:00',3.53),('8975','2013-01-26','12:05:00',3.61),('8975','2013-01-26','12:10:00',3.57),('8975','2013-01-26','12:15:00',3.46),('8975','2013-01-26','12:20:00',3.44),('8975','2013-01-26','12:25:00',3.33),('8975','2013-01-26','12:30:00',3.37),('8975','2013-01-26','12:35:00',3.28),('8975','2013-01-26','12:40:00',3.26),('8975','2013-01-26','12:45:00',3.2),('8975','2013-01-26','12:50:00',3.11),('8975','2013-01-26','12:55:00',3),('8975','2013-01-26','13:00:00',3.03),('8975','2013-01-26','13:05:00',3.01),('8975','2013-01-26','13:10:00',2.98),('8975','2013-01-26','13:15:00',2.92),('8975','2013-01-26','13:20:00',2.83),('8975','2013-01-26','13:25:00',2.73),('8975','2013-01-26','13:30:00',2.54),('8975','2013-01-26','13:35:00',2.48),('8975','2013-01-26','13:40:00',2.39),('8975','2013-01-26','13:45:00',2.35),('8975','2013-01-26','13:50:00',2.33),('8975','2013-01-26','13:55:00',2.25),('8975','2013-01-26','14:00:00',2.15),('8975','2013-01-26','14:05:00',2.08),('8975','2013-01-26','14:10:00',2.02),('8975','2013-01-26','14:15:00',1.95),('8975','2013-01-26','14:20:00',1.92),('8975','2013-01-26','14:25:00',1.83),('8975','2013-01-26','14:30:00',1.74),('8975','2013-01-26','14:35:00',1.69),('8975','2013-01-26','14:40:00',1.66),('8975','2013-01-26','14:45:00',1.55),('8975','2013-01-26','14:50:00',1.48),('8975','2013-01-26','14:55:00',1.44),('8975','2013-01-26','15:00:00',1.39),('8975','2013-01-26','15:05:00',1.4),('8975','2013-01-26','15:10:00',1.38),('8975','2013-01-26','15:15:00',1.35),('8975','2013-01-26','15:20:00',1.3),('8975','2013-01-26','15:25:00',1.26),('8975','2013-01-26','15:30:00',1.21),('8975','2013-01-26','15:35:00',1.17),('8975','2013-01-26','15:40:00',1.13),('8975','2013-01-26','15:45:00',1.09),('8975','2013-01-26','15:50:00',1.06),('8975','2013-01-26','15:55:00',1.01),('8975','2013-01-25','08:55:00',1.7),('8975','2013-01-25','09:00:00',2.46),('8975','2013-01-25','09:05:00',2.77),('8975','2013-01-25','09:10:00',2.77),('8975','2013-01-25','09:15:00',1.88),('8975','2013-01-25','09:20:00',1.88),('8975','2013-01-25','09:25:00',1.62),('8975','2013-01-25','09:30:00',1.2),('8975','2013-01-25','09:35:00',1.75),('8975','2013-01-25','09:40:00',1.72),('8975','2013-01-25','09:50:00',1.54),('8975','2013-01-25','09:55:00',1.99),('8975','2013-01-25','10:00:00',1.77),('8975','2013-01-25','10:05:00',1.51),('8975','2013-01-25','10:10:00',1.3),('8975','2013-01-25','10:15:00',1.46),('8975','2013-01-25','10:20:00',1.85),('8975','2013-01-25','10:25:00',2.2),('8975','2013-01-25','10:30:00',1.49),('8975','2013-01-25','10:35:00',1.39),('8975','2013-01-25','10:40:00',1.61),('8975','2013-01-25','10:45:00',1.71),('8975','2013-01-25','10:50:00',1.88),('8975','2013-01-25','10:55:00',1.87),('8975','2013-01-25','11:00:00',1.68),('8975','2013-01-25','11:05:00',1.55),('8975','2013-01-25','11:10:00',1.63),('8975','2013-01-25','11:15:00',1.62),('8975','2013-01-25','11:20:00',1.63),('8975','2013-01-25','11:25:00',1.42),('8975','2013-01-25','11:30:00',1.57),('8975','2013-01-25','11:35:00',1.49),('8975','2013-01-25','11:40:00',1.49),('8975','2013-01-25','11:45:00',1.37),('8975','2013-01-25','11:50:00',1.47),('8975','2013-01-25','11:55:00',1.41),('8975','2013-01-25','12:00:00',1.29),('8975','2013-01-25','12:05:00',1.23),('8975','2013-01-25','12:10:00',1.11),('8975','2013-01-25','12:15:00',1.11),('8975','2013-01-25','12:20:00',1.22),('8975','2013-01-25','12:25:00',1.34),('8975','2013-01-25','12:30:00',1.26),('8975','2013-01-25','12:35:00',1.28),('8975','2013-01-25','12:40:00',1.24),('8975','2013-01-25','12:45:00',1.24),('8975','2013-01-25','12:50:00',1.35),('8975','2013-01-25','12:55:00',1.08),('8975','2013-01-25','13:05:00',1.07),('8975','2013-01-25','13:10:00',1.12),('8975','2013-01-25','13:35:00',1.1),('8975','2013-01-25','13:40:00',1.16),('8975','2013-01-25','13:45:00',1.09),('8975','2013-01-25','13:50:00',1.01),('8975','2013-01-25','13:55:00',1),('8975','2013-01-24','08:20:00',1.21),('8975','2013-01-24','08:25:00',1.34),('8975','2013-01-24','08:30:00',1.92),('8975','2013-01-24','08:35:00',2.1),('8975','2013-01-24','08:40:00',2.1),('8975','2013-01-24','08:45:00',2.02),('8975','2013-01-24','08:50:00',2.28),('8975','2013-01-24','08:55:00',2.55),('8975','2013-01-24','09:00:00',2.36),('8975','2013-01-24','09:05:00',1.87),('8975','2013-01-24','09:10:00',2.5),('8975','2013-01-24','09:15:00',2.69),('8975','2013-01-24','09:20:00',2.83),('8975','2013-01-24','09:25:00',3.04),('8975','2013-01-24','09:30:00',2.93),('8975','2013-01-24','09:35:00',2.69),('8975','2013-01-24','09:40:00',2.93),('8975','2013-01-24','09:45:00',3.38),('8975','2013-01-24','09:50:00',3.57),('8975','2013-01-24','09:55:00',3.74),('8975','2013-01-24','10:00:00',3.74),('8975','2013-01-24','10:05:00',3.64),('8975','2013-01-24','10:10:00',3.67),('8975','2013-01-24','10:15:00',2.33),('8975','2013-01-24','10:20:00',1.5),('8975','2013-01-24','10:25:00',2.21),('8975','2013-01-24','10:30:00',2.24),('8975','2013-01-24','10:35:00',1.43),('8975','2013-01-24','10:40:00',3.42),('8975','2013-01-24','10:45:00',3.88),('8975','2013-01-24','10:50:00',3.05),('8975','2013-01-24','10:55:00',3.56),('8975','2013-01-24','11:00:00',4.2),('8975','2013-01-24','11:05:00',3.2),('8975','2013-01-24','11:10:00',3.66),('8975','2013-01-24','11:15:00',3.94),('8975','2013-01-24','11:20:00',3.85),('8975','2013-01-24','11:25:00',3.88),('8975','2013-01-24','11:30:00',3.94),('8975','2013-01-24','11:35:00',3.93),('8975','2013-01-24','11:40:00',3.82),('8975','2013-01-24','11:45:00',3.64),('8975','2013-01-24','11:50:00',3.78),('8975','2013-01-24','11:55:00',3.69),('8975','2013-01-24','12:00:00',3.51),('8975','2013-01-24','12:05:00',3.6),('8975','2013-01-24','12:10:00',3.58),('8975','2013-01-24','12:15:00',3.44),('8975','2013-01-24','12:20:00',3.45),('8975','2013-01-24','12:25:00',3.46),('8975','2013-01-24','12:30:00',2.97),('8975','2013-01-24','12:35:00',3.03),('8975','2013-01-24','12:40:00',3.22),('8975','2013-01-24','12:45:00',3.21),('8975','2013-01-24','12:50:00',3.02),('8975','2013-01-24','12:55:00',3.09),('8975','2013-01-24','13:00:00',2.96),('8975','2013-01-24','13:05:00',2.96),('8975','2013-01-24','13:10:00',2.97),('8975','2013-01-24','13:15:00',2.98),('8975','2013-01-24','13:20:00',2.91),('8975','2013-01-24','13:25:00',2.94),('8975','2013-01-24','13:30:00',2.79),('8975','2013-01-24','13:35:00',2.7),('8975','2013-01-24','13:40:00',2.59),('8975','2013-01-24','13:45:00',2.37),('8975','2013-01-24','13:50:00',2.25),('8975','2013-01-24','13:55:00',2.19),('8975','2013-01-24','14:00:00',2.09),('8975','2013-01-24','14:05:00',1.94),('8975','2013-01-24','14:10:00',1.97),('8975','2013-01-24','14:15:00',1.84),('8975','2013-01-24','14:20:00',1.78),('8975','2013-01-24','14:25:00',1.73),('8975','2013-01-24','14:30:00',1.6),('8975','2013-01-24','14:35:00',1.55),('8975','2013-01-24','14:40:00',1.5),('8975','2013-01-24','14:45:00',1.5),('8975','2013-01-24','14:50:00',1.48),('8975','2013-01-24','14:55:00',1.42),('8975','2013-01-24','15:00:00',1.38),('8975','2013-01-24','15:05:00',1.41),('8975','2013-01-24','15:10:00',1.39),('8975','2013-01-24','15:15:00',1.36),('8975','2013-01-24','15:20:00',1.36),('8975','2013-01-24','15:25:00',1.36),('8975','2013-01-24','15:30:00',1.41),('8975','2013-01-24','15:35:00',1.38),('8975','2013-01-24','15:40:00',1.24),('8975','2013-01-24','15:45:00',1.32),('8975','2013-01-24','15:50:00',1.33),('8975','2013-01-24','15:55:00',1.18),('8975','2013-01-23','08:50:00',1.04),('8975','2013-01-23','08:55:00',1.08),('8975','2013-01-23','09:15:00',1.49),('8975','2013-01-23','09:20:00',1.23),('8975','2013-01-23','09:25:00',1.42),('8975','2013-01-23','09:30:00',1.28),('8975','2013-01-23','09:35:00',1.35),('8975','2013-01-23','09:40:00',2.31),('8975','2013-01-23','09:45:00',3.13),('8975','2013-01-23','09:50:00',3.34),('8975','2013-01-23','09:55:00',3.47),('8975','2013-01-23','10:00:00',3.33),('8975','2013-01-23','10:05:00',3.57),('8975','2013-01-23','10:10:00',3.46),('8975','2013-01-23','10:15:00',3.56),('8975','2013-01-23','10:20:00',3.68),('8975','2013-01-23','10:25:00',3.49),('8975','2013-01-23','10:30:00',3.64),('8975','2013-01-23','10:35:00',3.76),('8975','2013-01-23','10:40:00',3.61),('8975','2013-01-23','10:45:00',2.84),('8975','2013-01-23','10:50:00',3),('8975','2013-01-23','10:55:00',1.42),('8975','2013-01-23','11:00:00',1.73),('8975','2013-01-23','11:05:00',1.24),('8975','2013-01-23','12:40:00',1.13),('8975','2013-01-23','12:45:00',1.24),('8975','2013-01-23','12:50:00',1.34),('8975','2013-01-23','12:55:00',1.4),('8975','2013-01-23','13:00:00',1.44),('8975','2013-01-23','13:05:00',1.42),('8975','2013-01-23','13:10:00',1.28),('8975','2013-01-23','13:15:00',1.21),('8975','2013-01-23','13:20:00',1.26),('8975','2013-01-23','13:25:00',1.34),('8975','2013-01-23','13:30:00',1.4),('8975','2013-01-23','13:35:00',1.39),('8975','2013-01-23','13:40:00',1.39),('8975','2013-01-23','13:45:00',1.42),('8975','2013-01-23','13:50:00',1.46),('8975','2013-01-23','13:55:00',1.53),('8975','2013-01-23','14:00:00',1.78),('8975','2013-01-23','14:05:00',1.72),('8975','2013-01-23','14:10:00',1.71),('8975','2013-01-23','14:15:00',1.89),('8975','2013-01-23','14:20:00',2.65),('8975','2013-01-23','14:25:00',2.94),('8975','2013-01-23','14:30:00',2.37),('8975','2013-01-23','14:35:00',1.71),('8975','2013-01-23','14:40:00',1.43),('8975','2013-01-23','14:45:00',1.69),('8975','2013-01-23','14:50:00',1.76),('8975','2013-01-23','14:55:00',1.61),('8975','2013-01-23','15:20:00',1.24),('8975','2013-01-23','15:25:00',1.36),('8975','2013-01-23','15:30:00',1.35),('8975','2013-01-23','15:35:00',1.02),('8975','2013-01-23','15:45:00',1.15),('8975','2013-01-23','15:50:00',1.2),('8975','2013-01-23','15:55:00',1.11),('8975','2013-01-23','16:00:00',1.02),('8975','2013-01-22','09:45:00',1.06),('8975','2013-01-22','09:50:00',1.38),('8975','2013-01-22','09:55:00',2.12),('8975','2013-01-22','10:00:00',1.25),('8975','2013-01-22','10:15:00',1.16),('8975','2013-01-22','10:20:00',1.3),('8975','2013-01-22','10:25:00',1.98),('8975','2013-01-22','10:30:00',3.3),('8975','2013-01-22','10:35:00',2.79),('8975','2013-01-22','10:40:00',2.09),('8975','2013-01-22','10:45:00',2.79),('8975','2013-01-22','10:50:00',3.05),('8975','2013-01-22','10:55:00',1.68),('8975','2013-01-22','11:00:00',1.07),('8975','2013-01-21','08:05:00',1.26),('8975','2013-01-21','08:10:00',1.17),('8975','2013-01-21','08:15:00',1.1),('8975','2013-01-21','08:20:00',1.17),('8975','2013-01-21','08:30:00',1.2),('8975','2013-01-21','08:35:00',1.43),('8975','2013-01-21','08:40:00',1.15),('8975','2013-01-21','08:45:00',2.01),('8975','2013-01-21','08:50:00',1.78),('8975','2013-01-21','09:00:00',1.56),('8975','2013-01-21','09:05:00',2.44),('8975','2013-01-21','09:25:00',2.01),('8975','2013-01-21','09:30:00',3.01),('8975','2013-01-21','09:35:00',3.21),('8975','2013-01-21','09:40:00',2.81),('8975','2013-01-21','09:45:00',2.71),('8975','2013-01-21','09:50:00',1.68),('8975','2013-01-21','09:55:00',2.89),('8975','2013-01-21','10:00:00',2.11),('8975','2013-01-21','10:05:00',3.35),('8975','2013-01-21','10:10:00',3.29),('8975','2013-01-21','10:15:00',3.74),('8975','2013-01-21','10:20:00',3.51),('8975','2013-01-21','10:25:00',3.54),('8975','2013-01-21','10:30:00',3.56),('8975','2013-01-21','10:35:00',3.75),('8975','2013-01-21','10:40:00',3.57),('8975','2013-01-21','10:45:00',4.07),('8975','2013-01-21','10:50:00',3.49),('8975','2013-01-21','10:55:00',2.72),('8975','2013-01-21','11:00:00',1.17),('8975','2013-01-21','11:05:00',1.16),('8975','2013-01-21','11:10:00',1.7),('8975','2013-01-21','11:15:00',1.81),('8975','2013-01-21','11:20:00',2.24),('8975','2013-01-21','11:25:00',1.25),('8975','2013-01-21','11:30:00',1.21),('8975','2013-01-21','11:35:00',1.24),('8975','2013-01-21','11:45:00',1.4),('8975','2013-01-21','11:50:00',2.45),('8975','2013-01-21','11:55:00',1.61),('8975','2013-01-21','12:00:00',1.2),('8975','2013-01-21','12:05:00',1.43),('8975','2013-01-21','12:10:00',2.44),('8975','2013-01-21','12:15:00',2.95),('8975','2013-01-21','12:20:00',2.27),('8975','2013-01-21','12:25:00',2.07),('8975','2013-01-21','12:30:00',1.55),('8975','2013-01-21','12:35:00',1.68),('8975','2013-01-21','12:40:00',3.17),('8975','2013-01-21','12:45:00',1.31),('8975','2013-01-21','12:50:00',1.5),('8975','2013-01-21','12:55:00',1.09),('8975','2013-01-21','13:00:00',2.39),('8975','2013-01-21','13:05:00',2.11),('8975','2013-01-21','13:10:00',2.13),('8975','2013-01-21','13:15:00',1.55),('8975','2013-01-21','13:20:00',2.11),('8975','2013-01-21','13:25:00',1.03),('8975','2013-01-21','13:30:00',1.3),('8975','2013-01-21','13:40:00',1.25),('8975','2013-01-21','13:45:00',1.43),('8975','2013-01-21','13:50:00',1.33),('8975','2013-01-21','14:00:00',1.01),('8975','2013-01-21','14:05:00',1.05),('8975','2013-01-21','14:10:00',1.45),('8975','2013-01-21','14:15:00',1.29),('8975','2013-01-21','14:25:00',1.28),('8975','2013-01-21','14:30:00',1.26),('8975','2013-01-21','14:35:00',1.63),('8975','2013-01-21','14:40:00',2.36),('8975','2013-01-21','14:45:00',1.8),('8975','2013-01-21','14:50:00',1.05),('8975','2014-03-19','06:53:00',1.07),('8975','2014-03-19','06:55:00',1.23),('8975','2014-03-19','07:00:00',1.37),('8975','2014-03-19','07:05:00',1.46),('8975','2014-03-19','07:13:00',1.7),('8975','2014-03-19','07:15:00',2.06),('8975','2014-03-19','07:20:00',2.15),('8975','2014-03-19','07:25:00',2.25),('8975','2014-03-19','07:30:00',2.36),('8975','2014-03-19','07:35:00',2.5),('8975','2014-03-19','07:40:00',2.72),('8975','2014-03-19','07:45:00',2.78),('8975','2014-03-19','07:50:00',2.86),('8975','2014-03-19','07:55:00',2.94),('8975','2014-03-19','08:00:00',3.14),('8975','2014-03-19','08:05:00',3.19),('8975','2014-03-19','08:10:00',3.33),('8975','2014-03-19','08:15:00',3.37),('8975','2014-03-19','08:20:00',3.4),('8975','2014-03-19','08:25:00',3.42),('8975','2014-03-19','08:30:00',3.65),('8975','2014-03-19','08:35:00',3.73),('8975','2014-03-19','08:40:00',3.93),('8975','2014-03-19','08:45:00',4.08),('8975','2014-03-19','08:50:00',4.1),('8975','2014-03-19','08:55:00',4.24),('8975','2014-03-19','09:00:00',4.14),('8975','2014-03-19','09:05:00',4.34),('8975','2014-03-19','09:10:00',4.43),('8975','2014-03-19','09:15:00',4.49),('8975','2014-03-19','09:20:00',4.58),('8975','2014-03-19','09:25:00',4.54),('8975','2014-03-19','09:30:00',4.57),('8975','2014-03-19','09:35:00',4.76),('8975','2014-03-19','09:40:00',4.75),('8975','2014-03-19','09:45:00',4.78),('8975','2014-03-19','09:50:00',4.79),('8975','2014-03-19','09:55:00',4.83),('8975','2014-03-19','10:00:00',4.97),('8975','2014-03-19','10:05:00',5.23),('8975','2014-03-19','10:10:00',5.15),('8975','2014-03-19','10:15:00',5.1),('8975','2014-03-19','10:20:00',5.14),('8975','2014-03-19','10:25:00',5.33),('8975','2014-03-19','10:30:00',5.14),('8975','2014-03-19','10:35:00',5.02),('8975','2014-03-19','10:40:00',4.81),('8975','2014-03-19','10:45:00',5.01),('8975','2014-03-19','10:50:00',5.3),('8975','2014-03-19','10:55:00',5.39),('8975','2014-03-19','11:00:00',5.51),('8975','2014-03-19','11:05:00',5.52),('8975','2014-03-19','11:10:00',5.42),('8975','2014-03-19','11:15:00',5.27),('8975','2014-03-19','11:20:00',5.38),('8975','2014-03-19','11:25:00',5.37),('8975','2014-03-19','11:30:00',5.56),('8975','2014-03-19','11:35:00',5.66),('8975','2014-03-19','11:40:00',5.82),('8975','2014-03-19','11:45:00',5.38),('8975','2014-03-19','11:50:00',5.11),('8975','2014-03-19','11:55:00',4.76),('8975','2014-03-19','12:00:00',5),('8975','2014-03-19','12:05:00',5.11),('8975','2014-03-19','12:10:00',5.28),('8975','2014-03-19','12:15:00',5.1),('8975','2014-03-19','12:20:00',4.87),('8975','2014-03-19','12:25:00',5.07),('8975','2014-03-19','12:30:00',5.1),('8975','2014-03-19','12:35:00',5.15),('8975','2014-03-19','12:40:00',5.22),('8975','2014-03-19','12:45:00',5.21),('8975','2014-03-19','12:50:00',5.12),('8975','2014-03-19','12:55:00',5.01),('8975','2014-03-19','13:00:00',4.92),('8975','2014-03-19','13:05:00',4.87),('8975','2014-03-19','13:10:00',4.8),('8975','2014-03-19','13:15:00',4.76),('8975','2014-03-19','13:20:00',4.62),('8975','2014-03-19','13:25:00',4.39),('8975','2014-03-19','13:30:00',4.23),('8975','2014-03-19','13:35:00',4.16),('8975','2014-03-19','13:40:00',3.91),('8975','2014-03-19','13:45:00',3.84),('8975','2014-03-19','13:50:00',3.75),('8975','2014-03-19','13:55:00',3.41),('8975','2014-03-19','14:00:00',3.65),('8975','2014-03-19','14:05:00',2.84),('8975','2014-03-19','14:10:00',3.39),('8975','2014-03-19','14:15:00',3.41),('8975','2014-03-19','14:20:00',3.4),('8975','2014-03-19','14:25:00',3.21),('8975','2014-03-19','14:30:00',2.7),('8975','2014-03-19','14:35:00',2.7),('8975','2014-03-19','14:40:00',2.8),('8975','2014-03-19','14:45:00',2.71),('8975','2014-03-19','14:50:00',2.67),('8975','2014-03-19','14:55:00',2.39),('8975','2014-03-19','15:00:00',2.31),('8975','2014-03-19','15:05:00',2.37),('8975','2014-03-19','15:10:00',2.27),('8975','2014-03-19','15:15:00',2.25),('8975','2014-03-19','15:20:00',2.31),('8975','2014-03-19','15:25:00',2.15),('8975','2014-03-19','15:30:00',2.08),('8975','2014-03-19','15:35:00',1.87),('8975','2014-03-19','15:40:00',1.7),('8975','2014-03-19','15:45:00',1.66),('8975','2014-03-19','15:50:00',1.55),('8975','2014-03-19','15:55:00',1.42),('8975','2014-03-19','16:00:00',1.18),('8975','2014-03-19','16:05:00',1.15),('8975','2014-03-19','16:10:00',1.17),('8975','2014-03-19','16:15:00',1.16),('8975','2014-03-19','16:20:00',1.26),('8975','2014-03-19','16:25:00',1.23),('8975','2014-03-19','16:30:00',1.15),('8975','2014-03-19','16:35:00',1.11),('8975','2013-01-20','10:15:00',1.08),('8975','2013-01-20','11:00:00',1.43),('8975','2013-01-20','11:05:00',1.58),('8975','2013-01-20','11:10:00',2.1),('8975','2013-01-20','11:15:00',2.03),('8975','2013-01-20','11:20:00',1.65),('8975','2013-01-20','11:25:00',1.46),('8975','2013-01-20','11:30:00',1.02),('8975','2013-01-20','11:40:00',1.42),('8975','2013-01-20','11:45:00',1.3),('8975','2013-01-20','11:50:00',1.72),('8975','2013-01-20','11:55:00',3.01),('8975','2013-01-20','12:00:00',2.87),('8975','2013-01-20','12:05:00',2.92),('8975','2013-01-20','12:10:00',3.41),('8975','2013-01-20','12:15:00',2.75),('8975','2013-01-20','12:20:00',1.42),('8975','2013-01-20','12:25:00',1.75),('8975','2013-01-20','12:30:00',1.27),('8975','2013-01-20','12:35:00',1.55),('8975','2013-01-20','12:40:00',1.35),('8975','2013-01-20','12:45:00',1.03),('8975','2013-01-20','12:50:00',2.72),('8975','2013-01-20','12:55:00',2.36),('8975','2013-01-20','13:00:00',1.8),('8975','2013-01-20','13:05:00',1.69),('8975','2013-01-20','13:10:00',1.38),('8975','2013-01-20','13:15:00',1.39),('8975','2013-01-20','13:20:00',1.33),('8975','2013-01-20','13:25:00',1.33),('8975','2013-01-20','13:30:00',2.2),('8975','2013-01-20','13:35:00',1.94),('8975','2013-01-20','13:40:00',1.61),('8975','2013-01-20','13:45:00',1.89),('8975','2013-01-20','13:50:00',2.61),('8975','2013-01-20','13:55:00',2.03),('8975','2013-01-20','14:00:00',2.04),('8975','2013-01-20','14:05:00',1.85),('8975','2013-01-20','14:10:00',1.97),('8975','2013-01-20','14:15:00',1.6),('8975','2013-01-20','14:25:00',1.19),('8975','2013-01-20','14:30:00',1.31),('8975','2013-01-19','08:30:00',1.05),('8975','2013-01-19','08:35:00',1.3),('8975','2013-01-19','08:40:00',1.08),('8975','2013-01-19','10:00:00',1.06),('8975','2013-01-19','10:05:00',1.07),('8975','2013-01-19','10:20:00',1.01),('8975','2013-01-19','10:25:00',1.26),('8975','2013-01-19','10:30:00',1.31),('8975','2013-01-19','10:35:00',1.03),('8975','2013-01-19','10:40:00',1.25),('8975','2013-01-19','10:45:00',1.25),('8975','2013-01-19','10:50:00',1.53),('8975','2013-01-19','10:55:00',1.71),('8975','2013-01-19','11:00:00',1.92),('8975','2013-01-19','11:05:00',1.8),('8975','2013-01-19','11:10:00',2.06),('8975','2013-01-19','11:15:00',2.15),('8975','2013-01-19','11:20:00',1.95),('8975','2013-01-19','11:25:00',2.37),('8975','2013-01-19','11:30:00',2.6),('8975','2013-01-19','11:35:00',2.11),('8975','2013-01-19','11:40:00',1.74),('8975','2013-01-19','11:45:00',1.72),('8975','2013-01-19','12:10:00',1.1),('8975','2013-01-19','12:15:00',1.34),('8975','2013-01-19','12:20:00',1.51),('8975','2013-01-19','12:25:00',1.54),('8975','2013-01-19','12:30:00',1.42),('8975','2013-01-19','12:35:00',1.35),('8975','2013-01-19','12:40:00',1.27),('8975','2013-01-19','12:45:00',1.25),('8975','2013-01-19','12:50:00',1.2),('8975','2013-01-19','12:55:00',1.19),('8975','2013-01-19','13:00:00',1.16),('8975','2013-01-19','13:05:00',1.12),('8975','2013-01-19','13:10:00',1.15),('8975','2013-01-19','13:15:00',1.25),('8975','2013-01-19','13:20:00',1.27),('8975','2013-01-19','13:25:00',1.25),('8975','2013-01-19','13:30:00',1.16),('8975','2013-01-19','13:35:00',1.31),('8975','2013-01-19','13:40:00',1.45),('8975','2013-01-19','13:45:00',1.36),('8975','2013-01-19','13:50:00',1.33),('8975','2013-01-19','13:55:00',1.17),('8975','2013-01-19','14:00:00',1.06),('8975','2013-01-19','14:20:00',1.11),('8975','2013-01-18','09:00:00',1.04),('8975','2013-01-18','09:05:00',1.23),('8975','2013-01-18','09:10:00',1.54),('8975','2013-01-18','09:15:00',1.99),('8975','2013-01-18','09:20:00',1.85),('8975','2013-01-18','09:25:00',1.4),('8975','2013-01-18','09:30:00',1.18),('8975','2013-01-18','09:35:00',1.08),('8975','2013-01-18','09:45:00',1.26),('8975','2013-01-18','09:50:00',1.7),('8975','2013-01-18','09:55:00',2.22),('8975','2013-01-18','10:00:00',2.09),('8975','2013-01-18','10:05:00',1.74),('8975','2013-01-18','10:10:00',1.2),('8975','2013-01-18','10:35:00',1.51),('8975','2013-01-18','10:40:00',1.95),('8975','2013-01-18','10:45:00',2.32),('8975','2013-01-18','10:50:00',2.08),('8975','2013-01-18','10:55:00',1.21),('8975','2013-01-18','11:00:00',1.26),('8975','2013-01-18','11:05:00',1.39),('8975','2013-01-18','11:10:00',1.53),('8975','2013-01-18','11:15:00',1.57),('8975','2013-01-18','11:20:00',1.78),('8975','2013-01-18','11:25:00',1.81),('8975','2013-01-18','11:30:00',1.38),('8975','2013-01-18','11:35:00',1.12),('8975','2013-01-18','11:40:00',1.04),('8975','2013-01-18','11:45:00',1.13),('8975','2013-01-18','11:50:00',1.13),('8975','2013-01-18','12:05:00',1.04),('8975','2013-01-18','12:10:00',1.06),('8975','2013-01-18','12:15:00',1.08),('8975','2013-01-18','14:30:00',1.02),('8975','2013-01-17','08:50:00',1.11),('8975','2013-01-17','08:55:00',1.24),('8975','2013-01-17','10:10:00',1.2),('8975','2013-01-17','10:15:00',2.65),('8975','2013-01-17','10:20:00',4.33),('8975','2013-01-17','10:25:00',3.18),('8975','2013-01-17','10:30:00',2.31),('8975','2013-01-17','10:35:00',1.82),('8975','2013-01-17','10:40:00',1.42),('8975','2013-01-17','10:45:00',1.23),('8975','2013-01-17','10:50:00',1.24),('8975','2013-01-17','10:55:00',1.24),('8975','2013-01-17','11:00:00',1.3),('8975','2013-01-17','11:05:00',1.45),('8975','2013-01-17','11:10:00',1.42),('8975','2013-01-17','11:15:00',1.37),('8975','2013-01-17','11:20:00',1.26),('8975','2013-01-17','11:25:00',1.32),('8975','2013-01-17','11:30:00',1.64),('8975','2013-01-17','11:35:00',1.96),('8975','2013-01-17','11:40:00',1.77),('8975','2013-01-17','11:45:00',1.55),('8975','2013-01-17','11:50:00',1.35),('8975','2013-01-17','11:55:00',1.35),('8975','2013-01-17','12:00:00',1.43),('8975','2013-01-17','12:05:00',1.43),('8975','2013-01-17','12:10:00',1.62),('8975','2013-01-17','12:15:00',1.67),('8975','2013-01-17','12:20:00',1.67),('8975','2013-01-17','12:25:00',1.7),('8975','2013-01-17','12:30:00',1.68),('8975','2013-01-17','12:35:00',1.92),('8975','2013-01-17','12:40:00',2.02),('8975','2013-01-17','12:45:00',2.1),('8975','2013-01-17','12:50:00',2.54),('8975','2013-01-17','12:55:00',2.75),('8975','2013-01-17','13:00:00',3.36),('8975','2013-01-17','13:05:00',3.53),('8975','2013-01-17','13:10:00',3.63),('8975','2013-01-17','13:15:00',3.29),('8975','2013-01-17','13:20:00',3.22),('8975','2013-01-17','13:25:00',2.35),('8975','2013-01-17','13:30:00',2.03),('8975','2013-01-17','13:35:00',1.81),('8975','2013-01-17','13:40:00',2.58),('8975','2013-01-17','13:45:00',2.91),('8975','2013-01-17','13:50:00',2.44),('8975','2013-01-17','13:55:00',2.01),('8975','2013-01-17','14:00:00',2.41),('8975','2013-01-17','14:05:00',2.79),('8975','2013-01-17','14:10:00',2.89),('8975','2013-01-17','14:15:00',2.91),('8975','2013-01-17','14:20:00',2.8),('8975','2013-01-17','14:25:00',2.36),('8975','2013-01-17','14:30:00',1.81),('8975','2013-01-17','14:35:00',1.6),('8975','2013-01-17','14:40:00',1.42),('8975','2013-01-17','14:45:00',1.51),('8975','2013-01-17','14:50:00',1.34),('8975','2013-01-17','14:55:00',1.44),('8975','2013-01-17','15:00:00',1.24),('8975','2013-01-17','15:05:00',1.15),('8975','2013-01-17','15:10:00',1.18),('8975','2013-01-17','15:15:00',1.1),('8975','2013-01-17','15:25:00',1.11),('8975','2013-01-16','09:10:00',1.16),('8975','2013-01-16','09:15:00',1.23),('8975','2013-01-16','09:20:00',1.15),('8975','2013-01-16','09:25:00',1.02),('8975','2013-01-16','09:30:00',1.18),('8975','2013-01-16','09:35:00',1.27),('8975','2013-01-16','09:40:00',1.41),('8975','2013-01-16','09:45:00',1.62),('8975','2013-01-16','09:50:00',1.93),('8975','2013-01-16','09:55:00',1.84),('8975','2013-01-16','10:00:00',1.36),('8975','2013-01-16','10:05:00',1.45),('8975','2013-01-16','10:10:00',1.75),('8975','2013-01-16','10:15:00',1.96),('8975','2013-01-16','10:20:00',2.1),('8975','2013-01-16','10:25:00',2.51),('8975','2013-01-16','10:30:00',2.33),('8975','2013-01-16','10:35:00',2.24),('8975','2013-01-16','10:40:00',2.15),('8975','2013-01-16','10:45:00',2.33),('8975','2013-01-16','10:50:00',2.27),('8975','2013-01-16','10:55:00',2.63),('8975','2013-01-16','11:00:00',2.36),('8975','2013-01-16','11:05:00',2.25),('8975','2013-01-16','11:10:00',2.57),('8975','2013-01-16','11:15:00',2.7),('8975','2013-01-16','11:20:00',2.51),('8975','2013-01-16','11:25:00',2.2),('8975','2013-01-16','11:30:00',2.01),('8975','2013-01-16','11:35:00',2.02),('8975','2013-01-16','11:40:00',2.13),('8975','2013-01-16','11:45:00',1.82),('8975','2013-01-16','11:50:00',2.03),('8975','2013-01-16','11:55:00',2.1),('8975','2013-01-16','12:00:00',2.32),('8975','2013-01-16','12:05:00',2.35),('8975','2013-01-16','12:10:00',2.46),('8975','2013-01-16','12:15:00',2.74),('8975','2013-01-16','12:20:00',2.45),('8975','2013-01-16','12:25:00',2.34),('8975','2013-01-16','12:30:00',1.86),('8975','2013-01-16','12:35:00',2.07),('8975','2013-01-16','12:40:00',2.19),('8975','2013-01-16','12:45:00',1.71),('8975','2013-01-16','12:50:00',1.33),('8975','2013-01-16','12:55:00',1.83),('8975','2013-01-16','13:00:00',2.1),('8975','2013-01-16','13:05:00',1.93),('8975','2013-01-16','13:10:00',1.62),('8975','2013-01-16','13:15:00',1.61),('8975','2013-01-16','13:20:00',1.78),('8975','2013-01-16','13:25:00',1.75),('8975','2013-01-16','13:30:00',1.58),('8975','2013-01-16','13:35:00',1.69),('8975','2013-01-16','13:40:00',2.1),('8975','2013-01-16','13:45:00',2.11),('8975','2013-01-16','13:50:00',1.29),('8975','2013-01-16','13:55:00',1.15),('8975','2013-01-16','14:00:00',1.55),('8975','2013-01-16','14:05:00',1.32),('8975','2013-01-16','14:10:00',1.45),('8975','2013-01-16','14:15:00',1.06),('8975','2013-01-16','14:20:00',1.14),('8975','2013-01-16','14:25:00',1.57),('8975','2013-01-16','14:30:00',2.06),('8975','2013-01-16','14:35:00',1.9),('8975','2013-01-16','14:40:00',1.26),('8975','2013-01-15','09:15:00',1.56),('8975','2013-01-15','09:20:00',1.78),('8975','2013-01-15','09:25:00',2.09),('8975','2013-01-15','09:30:00',2.79),('8975','2013-01-15','09:35:00',2.87),('8975','2013-01-15','09:40:00',2.76),('8975','2013-01-15','09:45:00',1.44),('8975','2013-01-15','09:55:00',1.46),('8975','2013-01-15','10:00:00',1.51),('8975','2013-01-15','10:05:00',1.29),('8975','2013-01-15','10:30:00',1.27),('8975','2013-01-15','10:35:00',2.81),('8975','2013-01-15','10:40:00',2.47),('8975','2013-01-15','10:45:00',2.22),('8975','2013-01-15','10:50:00',1.16),('8975','2013-01-15','10:55:00',1.78),('8975','2013-01-15','11:00:00',1.16),('8975','2013-01-15','11:05:00',1.17),('8975','2013-01-15','11:20:00',1.13),('8975','2013-01-15','11:25:00',2.31),('8975','2013-01-15','12:00:00',2.43),('8975','2013-01-15','12:05:00',2.12),('8975','2013-01-15','12:10:00',2.58),('8975','2013-01-15','12:15:00',3.93),('8975','2013-01-15','12:20:00',3.2),('8975','2013-01-15','12:25:00',1),('8975','2013-01-15','13:00:00',2.01),('8975','2013-01-15','13:05:00',3.92),('8975','2013-01-15','13:10:00',3.54),('8975','2013-01-15','13:15:00',3.62),('8975','2013-01-15','13:20:00',2.97),('8975','2013-01-15','13:25:00',1.43),('8975','2013-01-15','13:50:00',1.09),('8975','2013-01-15','13:55:00',2.61),('8975','2013-01-15','14:00:00',2.65),('8975','2013-01-15','14:05:00',2.08),('8975','2013-01-15','15:05:00',1.18),('8975','2013-01-15','15:10:00',1.04),('8975','2013-01-14','08:15:00',1.19),('8975','2013-01-14','08:55:00',1.14),('8975','2013-01-14','09:00:00',1.03),('8975','2013-01-14','09:50:00',1.25),('8975','2013-01-14','09:55:00',1.56),('8975','2013-01-14','10:00:00',1.51),('8975','2013-01-14','10:05:00',1.22),('8975','2013-01-14','10:10:00',1.65),('8975','2013-01-14','10:15:00',1.44),('8975','2013-01-14','10:20:00',1.52),('8975','2013-01-14','10:25:00',1.47),('8975','2013-01-14','10:30:00',1.13),('8975','2013-01-14','10:35:00',1.29),('8975','2013-01-14','10:40:00',1.51),('8975','2013-01-14','10:45:00',1.72),('8975','2013-01-14','10:50:00',2.07),('8975','2013-01-14','10:55:00',2.13),('8975','2013-01-14','11:00:00',2.07),('8975','2013-01-14','11:05:00',2.16),('8975','2013-01-14','11:10:00',2.16),('8975','2013-01-14','11:15:00',2.04),('8975','2013-01-14','11:20:00',2.09),('8975','2013-01-14','11:25:00',2.01),('8975','2013-01-14','11:30:00',1.83),('8975','2013-01-14','11:35:00',1.83),('8975','2013-01-14','11:40:00',1.72),('8975','2013-01-14','11:45:00',1.55),('8975','2013-01-14','11:50:00',1.54),('8975','2013-01-14','11:55:00',1.67),('8975','2013-01-14','12:00:00',1.59),('8975','2013-01-14','12:05:00',1.53),('8975','2013-01-14','12:10:00',1.62),('8975','2013-01-14','12:15:00',1.86),('8975','2013-01-14','12:20:00',2.02),('8975','2013-01-14','12:25:00',1.87),('8975','2013-01-14','12:30:00',1.73),('8975','2013-01-14','12:35:00',1.68),('8975','2013-01-14','12:40:00',1.88),('8975','2013-01-14','12:45:00',1.91),('8975','2013-01-14','12:50:00',1.78),('8975','2013-01-14','12:55:00',1.6),('8975','2013-01-14','13:00:00',1.49),('8975','2013-01-14','13:05:00',1.47),('8975','2013-01-14','13:10:00',1.41),('8975','2013-01-14','13:15:00',1.55),('8975','2013-01-14','13:20:00',1.51),('8975','2013-01-14','13:25:00',1.51),('8975','2013-01-14','13:30:00',1.64),('8975','2013-01-14','13:35:00',1.65),('8975','2013-01-14','13:40:00',1.79),('8975','2013-01-14','13:45:00',1.69),('8975','2013-01-14','13:50:00',1.7),('8975','2013-01-14','13:55:00',2),('8975','2013-01-14','14:00:00',2.75),('8975','2013-01-14','14:05:00',2.5),('8975','2013-01-14','14:10:00',2.3),('8975','2013-01-14','14:15:00',2.36),('8975','2013-01-14','14:20:00',2.49),('8975','2013-01-14','14:25:00',1.72),('8975','2013-01-14','14:30:00',1.48),('8975','2013-01-14','14:35:00',1.3),('8975','2013-01-14','14:40:00',1.53),('8975','2013-01-14','14:45:00',1.49),('8975','2013-01-14','14:50:00',1.06),('8975','2013-01-14','14:55:00',1.06),('8975','2013-01-14','15:00:00',1.58),('8975','2013-01-14','15:05:00',1.65),('8975','2013-01-14','15:10:00',1.58),('8975','2013-01-14','15:15:00',1.41),('8975','2013-01-14','15:20:00',1.28),('8975','2013-01-14','16:00:00',1.05),('8975','2013-01-14','16:05:00',1.14),('8975','2013-01-14','16:10:00',1.07),('8975','2013-01-13','11:20:00',1.44),('8975','2013-01-13','11:25:00',1.37),('8975','2013-01-13','11:30:00',1.02),('8975','2013-01-13','11:35:00',1.03),('8975','2013-01-13','11:50:00',1.18),('8975','2013-01-13','12:20:00',1.15),('8975','2013-01-13','12:25:00',1.52),('8975','2013-01-13','12:30:00',1.41),('8975','2013-01-13','12:35:00',1.43),('8975','2013-01-13','12:40:00',1.41),('8975','2013-01-13','12:45:00',1.68),('8975','2013-01-13','12:50:00',1.93),('8975','2013-01-13','12:55:00',1.85),('8975','2013-01-13','13:00:00',1.85),('8975','2013-01-13','13:05:00',1.7),('8975','2013-01-13','13:10:00',1.56),('8975','2013-01-13','13:15:00',1.34),('8975','2013-01-13','13:35:00',1.14),('8975','2013-01-13','15:15:00',1.4),('8975','2013-01-13','15:20:00',1.44),('8975','2013-01-13','15:25:00',1.41),('8975','2013-01-12','09:10:00',1.65),('8975','2013-01-12','09:15:00',2.84),('8975','2013-01-12','09:20:00',2.75),('8975','2013-01-12','09:25:00',2.74),('8975','2013-01-12','09:30:00',2.73),('8975','2013-01-12','09:35:00',2.39),('8975','2013-01-12','09:40:00',1.23),('8975','2013-01-12','09:45:00',1.35),('8975','2013-01-12','09:50:00',2.26),('8975','2013-01-12','09:55:00',2.75),('8975','2013-01-12','10:00:00',2.62),('8975','2013-01-12','10:05:00',2.31),('8975','2013-01-12','10:10:00',1.34),('8975','2013-01-12','10:15:00',1.26),('8975','2013-01-12','10:20:00',1.41),('8975','2013-01-12','10:25:00',2.31),('8975','2013-01-12','10:30:00',2.31),('8975','2013-01-12','10:35:00',1.33),('8975','2013-01-11','08:10:00',1.07),('8975','2013-01-11','08:15:00',1.21),('8975','2013-01-11','08:20:00',1.32),('8975','2013-01-11','08:25:00',1.48),('8975','2013-01-11','08:30:00',1.6),('8975','2013-01-11','08:35:00',1.72),('8975','2013-01-11','08:40:00',1.81),('8975','2013-01-11','08:45:00',1.91),('8975','2013-01-11','08:50:00',1.99),('8975','2013-01-11','08:55:00',2.06),('8975','2013-01-11','09:00:00',2.16),('8975','2013-01-11','09:05:00',2.23),('8975','2013-01-11','09:10:00',2.29),('8975','2013-01-11','09:15:00',2.35),('8975','2013-01-11','09:20:00',2.43),('8975','2013-01-11','09:25:00',2.5),('8975','2013-01-11','09:30:00',2.54),('8975','2013-01-11','09:35:00',2.59),('8975','2013-01-11','09:40:00',2.64),('8975','2013-01-11','09:45:00',2.73),('8975','2013-01-11','09:50:00',2.75),('8975','2013-01-11','09:55:00',2.76),('8975','2013-01-11','10:00:00',2.83),('8975','2013-01-11','10:05:00',2.88),('8975','2013-01-11','10:10:00',2.94),('8975','2013-01-11','10:15:00',3),('8975','2013-01-11','10:20:00',3.03),('8975','2013-01-11','10:25:00',2.98),('8975','2013-01-11','10:30:00',3.05),('8975','2013-01-11','10:35:00',3.1),('8975','2013-01-11','10:40:00',3.15),('8975','2013-01-11','10:45:00',3.18),('8975','2013-01-11','10:50:00',3.18),('8975','2013-01-11','10:55:00',3.16),('8975','2013-01-11','11:00:00',3.16),('8975','2013-01-11','11:05:00',3.16),('8975','2013-01-11','11:10:00',3.13),('8975','2013-01-11','11:15:00',3.1),('8975','2013-01-11','11:20:00',3.08),('8975','2013-01-11','11:25:00',3.08),('8975','2013-01-11','11:30:00',3.08),('8975','2013-01-11','11:35:00',3.05),('8975','2013-01-11','11:40:00',3.01),('8975','2013-01-11','11:45:00',3),('8975','2013-01-11','11:50:00',2.92),('8975','2013-01-11','11:55:00',2.9),('8975','2013-01-11','12:00:00',2.85),('8975','2013-01-11','12:05:00',2.82),('8975','2013-01-11','12:10:00',2.37),('8975','2013-01-11','12:15:00',2.67),('8975','2013-01-11','12:20:00',2.67),('8975','2013-01-11','12:25:00',2.73),('8975','2013-01-11','12:30:00',1.75),('8975','2013-01-11','12:40:00',1.22),('8975','2013-01-11','12:45:00',2.15),('8975','2013-01-11','12:50:00',1.02),('8975','2013-01-11','12:55:00',1.19),('8975','2013-01-11','13:00:00',1.2),('8975','2013-01-11','13:05:00',1.54),('8975','2013-01-11','13:10:00',1.76),('8975','2013-01-11','13:15:00',1.11),('8975','2013-01-11','13:20:00',1.52),('8975','2013-01-11','13:25:00',1.69),('8975','2013-01-11','13:30:00',1.65),('8975','2013-01-11','13:35:00',1.34),('8975','2013-01-11','13:40:00',2),('8975','2013-01-11','13:45:00',2.02),('8975','2013-01-11','13:50:00',2.13),('8975','2013-01-11','13:55:00',1.74),('8975','2013-01-11','14:00:00',1.97),('8975','2013-01-11','14:05:00',1.94),('8975','2013-01-11','14:10:00',1.6),('8975','2013-01-11','14:15:00',1.43),('8975','2013-01-11','14:20:00',1.37),('8975','2013-01-11','14:25:00',1.36),('8975','2013-01-11','14:30:00',1.28),('8975','2013-01-11','14:35:00',1.25),('8975','2013-01-11','14:40:00',1.24),('8975','2013-01-11','14:45:00',1.23),('8975','2013-01-11','14:50:00',1.22),('8975','2013-01-11','14:55:00',1.18),('8975','2013-01-11','15:00:00',1.04),('8975','2013-01-11','15:10:00',1.07),('8975','2013-01-11','15:15:00',1.09),('8975','2013-01-11','15:20:00',1.01),('8975','2014-03-18','07:10:00',1.26),('8975','2014-03-18','07:20:00',1.06),('8975','2014-03-18','07:28:00',1.86),('8975','2014-03-18','08:35:00',1.06),('8975','2014-03-18','08:40:00',1.12),('8975','2014-03-18','08:45:00',1.34),('8975','2014-03-18','08:50:00',1.47),('8975','2014-03-18','08:55:00',1.58),('8975','2014-03-18','09:00:00',1.67),('8975','2014-03-18','09:05:00',2.04),('8975','2014-03-18','09:10:00',2.19),('8975','2014-03-18','09:15:00',2.33),('8975','2014-03-18','09:20:00',2.18),('8975','2014-03-18','09:25:00',2.68),('8975','2014-03-18','09:30:00',3),('8975','2014-03-18','09:35:00',3.8),('8975','2014-03-18','09:40:00',4.33),('8975','2014-03-18','09:45:00',4.91),('8975','2014-03-18','09:50:00',3.01),('8975','2014-03-18','09:55:00',2.79),('8975','2014-03-18','10:00:00',2.21),('8975','2014-03-18','10:05:00',1.62),('8975','2014-03-18','10:10:00',1.5),('8975','2014-03-18','10:15:00',1.64),('8975','2014-03-18','10:20:00',2.03),('8975','2014-03-18','10:25:00',2.48),('8975','2014-03-18','10:30:00',4.24),('8975','2014-03-18','10:35:00',5.91),('8975','2014-03-18','10:40:00',4.47),('8975','2014-03-18','10:45:00',3.2),('8975','2014-03-18','10:50:00',2.66),('8975','2014-03-18','10:55:00',1.89),('8975','2014-03-18','11:00:00',1.88),('8975','2014-03-18','11:05:00',2.31),('8975','2014-03-18','11:10:00',2.37),('8975','2014-03-18','11:15:00',2.55),('8975','2014-03-18','11:20:00',3.11),('8975','2014-03-18','11:25:00',4.59),('8975','2014-03-18','11:30:00',5.42),('8975','2014-03-18','11:35:00',6.15),('8975','2014-03-18','11:40:00',6.17),('8975','2014-03-18','11:45:00',6.89),('8975','2014-03-18','11:50:00',6.71),('8975','2014-03-18','11:55:00',4.77),('8975','2014-03-18','12:00:00',3.1),('8975','2014-03-18','12:05:00',2.56),('8975','2014-03-18','12:10:00',3.15),('8975','2014-03-18','12:15:00',6.24),('8975','2014-03-18','12:20:00',3.4),('8975','2014-03-18','12:25:00',3.54),('8975','2014-03-18','12:30:00',3.71),('8975','2014-03-18','12:35:00',5.37),('8975','2014-03-18','12:40:00',5.33),('8975','2014-03-18','12:45:00',3.15),('8975','2014-03-18','12:50:00',4.53),('8975','2014-03-18','12:55:00',5.26),('8975','2014-03-18','13:00:00',5.23),('8975','2014-03-18','13:05:00',3.98),('8975','2014-03-18','13:10:00',4.94),('8975','2014-03-18','13:15:00',5.01),('8975','2014-03-18','13:20:00',5.03),('8975','2014-03-18','13:25:00',2.41),('8975','2014-03-18','13:30:00',1.87),('8975','2014-03-18','13:35:00',4.23),('8975','2014-03-18','13:40:00',4.31),('8975','2014-03-18','13:45:00',4.57),('8975','2014-03-18','13:50:00',4.57),('8975','2014-03-18','13:55:00',3.82),('8975','2014-03-18','14:00:00',3.77),('8975','2014-03-18','14:05:00',4.01),('8975','2014-03-18','14:10:00',3.95),('8975','2014-03-18','14:15:00',3.59),('8975','2014-03-18','14:20:00',2.85),('8975','2014-03-18','14:25:00',3.36),('8975','2014-03-18','14:30:00',3.29),('8975','2014-03-18','14:35:00',3.35),('8975','2014-03-18','14:40:00',3.2),('8975','2014-03-18','14:45:00',3.11),('8975','2014-03-18','14:50:00',3.1),('8975','2014-03-18','14:55:00',3),('8975','2014-03-18','15:00:00',2.95),('8975','2014-03-18','15:05:00',2.85),('8975','2014-03-18','15:10:00',2.67),('8975','2014-03-18','15:15:00',2.59),('8975','2014-03-18','15:20:00',2.47),('8975','2014-03-18','15:25:00',2.39),('8975','2014-03-18','15:30:00',2.32),('8975','2014-03-18','15:35:00',1.91),('8975','2014-03-18','15:40:00',1.48),('8975','2014-03-18','15:45:00',1.4),('8975','2014-03-18','15:55:00',1.58),('8975','2014-03-18','16:00:00',1.72),('8975','2014-03-18','16:05:00',1.44),('8975','2014-03-18','16:10:00',1.65),('8975','2014-03-18','16:15:00',1.55),('8975','2014-03-18','16:20:00',1.5),('8975','2014-03-18','16:25:00',1.32),('8975','2014-03-18','16:30:00',1.11),('8975','2014-03-18','16:35:00',1.13),('8975','2014-03-18','16:40:00',1.01),('8975','2013-01-10','09:45:00',1.08),('8975','2013-01-10','09:50:00',1.08),('8975','2013-01-10','09:55:00',1.72),('8975','2013-01-10','10:00:00',1.31),('8975','2013-01-10','10:05:00',1.54),('8975','2013-01-10','10:10:00',1.43),('8975','2013-01-10','10:15:00',1.82),('8975','2013-01-10','10:20:00',2.85),('8975','2013-01-10','10:25:00',2.99),('8975','2013-01-10','10:30:00',2.87),('8975','2013-01-10','10:35:00',2.93),('8975','2013-01-10','10:40:00',3.01),('8975','2013-01-10','10:45:00',3.04),('8975','2013-01-10','10:50:00',3.08),('8975','2013-01-10','10:55:00',3.06),('8975','2013-01-10','11:00:00',2.51),('8975','2013-01-10','11:05:00',2.82),('8975','2013-01-10','11:10:00',2.78),('8975','2013-01-10','11:15:00',3.01),('8975','2013-01-10','11:20:00',2.79),('8975','2013-01-10','11:25:00',1.33),('8975','2013-01-10','11:30:00',1.33),('8975','2013-01-10','11:35:00',1.81),('8975','2013-01-10','11:40:00',1.04),('8975','2013-01-10','11:45:00',1.99),('8975','2013-01-10','11:50:00',2.5),('8975','2013-01-10','11:55:00',1.87),('8975','2013-01-10','12:00:00',1.49),('8975','2013-01-10','12:05:00',1.27),('8975','2013-01-10','12:10:00',1.13),('8975','2013-01-10','12:15:00',1.32),('8975','2013-01-10','12:20:00',1.06),('8975','2013-01-10','12:50:00',1.52),('8975','2013-01-10','12:55:00',1.85),('8975','2013-01-10','13:00:00',1.88),('8975','2013-01-10','13:05:00',1.85),('8975','2013-01-10','13:10:00',2.51),('8975','2013-01-10','13:15:00',1.89),('8975','2013-01-10','13:20:00',1.26),('8975','2013-01-10','13:30:00',1.75),('8975','2013-01-10','13:35:00',2.22),('8975','2013-01-10','13:40:00',1.47),('8975','2013-01-10','13:45:00',1.51),('8975','2013-01-10','14:20:00',1.58),('8975','2013-01-10','14:25:00',1.26),('8975','2013-01-10','14:30:00',1.29),('8975','2013-01-10','14:35:00',1.05),('8975','2013-01-10','14:40:00',1.01),('8975','2013-01-10','14:45:00',1.29),('8975','2013-01-10','14:50:00',1.32),('8975','2013-01-10','15:00:00',1.39),('8975','2013-01-10','15:05:00',1.31),('8975','2013-01-09','11:20:00',1.24),('8975','2013-01-09','11:25:00',1.47),('8975','2013-01-09','11:30:00',1.5),('8975','2013-01-09','11:35:00',1.15),('8975','2013-01-09','11:45:00',1.13),('8975','2013-01-09','11:50:00',1.65),('8975','2013-01-09','11:55:00',1.98),('8975','2013-01-09','12:00:00',2.07),('8975','2013-01-09','12:05:00',2),('8975','2013-01-09','12:10:00',1.75),('8975','2013-01-09','12:15:00',1.21),('8975','2013-01-09','13:45:00',1),('8975','2013-01-09','13:55:00',1.06),('8975','2013-01-09','14:00:00',1.04),('8975','2013-01-08','09:35:00',1.01),('8975','2013-01-08','09:40:00',1.08),('8975','2013-01-08','09:45:00',1.02),('8975','2013-01-08','10:10:00',1.02),('8975','2013-01-08','10:15:00',1.06),('8975','2013-01-08','10:20:00',1.15),('8975','2013-01-08','10:25:00',1.25),('8975','2013-01-08','10:30:00',1.31),('8975','2013-01-08','10:35:00',1.39),('8975','2013-01-08','10:40:00',1.45),('8975','2013-01-08','10:45:00',1.67),('8975','2013-01-08','10:50:00',2.19),('8975','2013-01-08','10:55:00',1.61),('8975','2013-01-08','11:00:00',1.91),('8975','2013-01-08','11:05:00',1.93),('8975','2013-01-08','11:10:00',2.89),('8975','2013-01-08','11:15:00',2.64),('8975','2013-01-08','11:20:00',1.7),('8975','2013-01-08','11:25:00',1.9),('8975','2013-01-08','11:30:00',2),('8975','2013-01-08','11:35:00',1.82),('8975','2013-01-08','11:40:00',1.57),('8975','2013-01-08','11:45:00',1.79),('8975','2013-01-08','11:50:00',1.87),('8975','2013-01-08','11:55:00',1.74),('8975','2013-01-08','12:00:00',1.76),('8975','2013-01-08','12:05:00',1.71),('8975','2013-01-08','12:10:00',1.59),('8975','2013-01-08','12:15:00',1.68),('8975','2013-01-08','12:20:00',1.54),('8975','2013-01-08','12:25:00',1.47),('8975','2013-01-08','12:30:00',1.51),('8975','2013-01-08','12:35:00',1.51),('8975','2013-01-08','12:40:00',1.42),('8975','2013-01-08','12:45:00',1.45),('8975','2013-01-08','12:50:00',1.6),('8975','2013-01-08','12:55:00',1.8),('8975','2013-01-08','13:00:00',2),('8975','2013-01-08','13:05:00',2.08),('8975','2013-01-08','13:10:00',1.86),('8975','2013-01-08','13:15:00',1.49),('8975','2013-01-08','13:20:00',1.37),('8975','2013-01-08','13:25:00',1.21),('8975','2013-01-08','13:30:00',1.28),('8975','2013-01-08','13:35:00',1.3),('8975','2013-01-08','13:40:00',1.26),('8975','2013-01-08','13:45:00',1.18),('8975','2013-01-08','13:50:00',1.12),('8975','2013-01-08','13:55:00',1.1),('8975','2013-01-08','14:00:00',1.06),('8975','2013-01-08','14:05:00',1.02),('8975','2013-01-07','08:30:00',1.37),('8975','2013-01-07','08:35:00',2.17),('8975','2013-01-07','08:40:00',2.25),('8975','2013-01-07','08:45:00',2.34),('8975','2013-01-07','08:50:00',2.4),('8975','2013-01-07','08:55:00',2.49),('8975','2013-01-07','09:00:00',2.69),('8975','2013-01-07','09:05:00',2.64),('8975','2013-01-07','09:10:00',1.65),('8975','2013-01-07','09:15:00',1.98),('8975','2013-01-07','09:20:00',2.25),('8975','2013-01-07','09:25:00',2.45),('8975','2013-01-07','09:30:00',2.39),('8975','2013-01-07','09:35:00',2),('8975','2013-01-07','09:40:00',2.85),('8975','2013-01-07','09:45:00',3.04),('8975','2013-01-07','09:50:00',3.16),('8975','2013-01-07','09:55:00',3.15),('8975','2013-01-07','10:00:00',2.98),('8975','2013-01-07','10:05:00',2.7),('8975','2013-01-07','10:10:00',2.73),('8975','2013-01-07','10:15:00',2.65),('8975','2013-01-07','10:20:00',2.4),('8975','2013-01-07','10:25:00',2.44),('8975','2013-01-07','10:30:00',2.46),('8975','2013-01-07','10:35:00',2.62),('8975','2013-01-07','10:40:00',3.01),('8975','2013-01-07','10:45:00',2.92),('8975','2013-01-07','10:50:00',2.8),('8975','2013-01-07','10:55:00',3.02),('8975','2013-01-07','11:00:00',3.02),('8975','2013-01-07','11:05:00',3.09),('8975','2013-01-07','11:10:00',3.09),('8975','2013-01-07','11:15:00',3.08),('8975','2013-01-07','11:20:00',2.78),('8975','2013-01-07','11:25:00',2.85),('8975','2013-01-07','11:30:00',2.93),('8975','2013-01-07','11:35:00',2.62),('8975','2013-01-07','11:40:00',2.89),('8975','2013-01-07','11:45:00',3.26),('8975','2013-01-07','11:50:00',2.68),('8975','2013-01-07','11:55:00',2.21),('8975','2013-01-07','12:00:00',2.26),('8975','2013-01-07','12:05:00',2.03),('8975','2013-01-07','12:10:00',2.01),('8975','2013-01-07','12:15:00',2.18),('8975','2013-01-07','12:20:00',1.73),('8975','2013-01-07','12:25:00',1.9),('8975','2013-01-07','12:30:00',1.56),('8975','2013-01-07','12:35:00',1.47),('8975','2013-01-07','12:40:00',1.92),('8975','2013-01-07','12:45:00',2.06),('8975','2013-01-07','12:50:00',1.61),('8975','2013-01-07','12:55:00',1.56),('8975','2013-01-07','13:00:00',1.57),('8975','2013-01-07','13:05:00',1.72),('8975','2013-01-07','13:10:00',1.36),('8975','2013-01-07','13:15:00',1.34),('8975','2013-01-07','13:20:00',1.52),('8975','2013-01-07','13:25:00',1.28),('8975','2013-01-07','13:30:00',1.16),('8975','2013-01-07','13:35:00',1.24),('8975','2013-01-07','13:40:00',1.51),('8975','2013-01-07','13:45:00',1.62),('8975','2013-01-07','13:50:00',1.46),('8975','2013-01-07','13:55:00',1.56),('8975','2013-01-07','14:00:00',1.39),('8975','2013-01-07','14:05:00',1.2),('8975','2013-01-07','14:10:00',1.13),('8975','2013-01-07','14:15:00',1.12),('8975','2013-01-07','14:20:00',1.12),('8975','2013-01-07','14:25:00',1.18),('8975','2013-01-07','14:30:00',1.19),('8975','2013-01-07','14:35:00',1.24),('8975','2013-01-07','14:40:00',1.28),('8975','2013-01-07','15:10:00',1.07),('8975','2013-01-06','08:15:00',1.02),('8975','2013-01-06','08:20:00',1.15),('8975','2013-01-06','08:25:00',1.28),('8975','2013-01-06','08:30:00',1.42),('8975','2013-01-06','08:35:00',1.55),('8975','2013-01-06','08:40:00',1.61),('8975','2013-01-06','08:45:00',1.75),('8975','2013-01-06','08:50:00',1.83),('8975','2013-01-06','08:55:00',1.95),('8975','2013-01-06','09:00:00',2.05),('8975','2013-01-06','09:05:00',1.94),('8975','2013-01-06','09:10:00',1.88),('8975','2013-01-06','09:15:00',1.7),('8975','2013-01-06','09:20:00',2.23),('8975','2013-01-06','09:25:00',2.38),('8975','2013-01-06','09:30:00',2.46),('8975','2013-01-06','09:35:00',2.5),('8975','2013-01-06','09:40:00',2.61),('8975','2013-01-06','09:45:00',2.68),('8975','2013-01-06','09:50:00',2.72),('8975','2013-01-06','09:55:00',2.69),('8975','2013-01-06','10:00:00',2.71),('8975','2013-01-06','10:05:00',2.79),('8975','2013-01-06','10:10:00',2.83),('8975','2013-01-06','10:15:00',2.91),('8975','2013-01-06','10:20:00',2.91),('8975','2013-01-06','10:25:00',2.83),('8975','2013-01-06','10:30:00',2.93),('8975','2013-01-06','10:35:00',3.01),('8975','2013-01-06','10:40:00',3.07),('8975','2013-01-06','10:45:00',3.11),('8975','2013-01-06','10:50:00',2.83),('8975','2013-01-06','10:55:00',3.01),('8975','2013-01-06','11:00:00',3.09),('8975','2013-01-06','11:05:00',3.11),('8975','2013-01-06','11:10:00',3.07),('8975','2013-01-06','11:15:00',3.03),('8975','2013-01-06','11:20:00',3.04),('8975','2013-01-06','11:25:00',3.01),('8975','2013-01-06','11:30:00',2.95),('8975','2013-01-06','11:35:00',2.87),('8975','2013-01-06','11:40:00',2.9),('8975','2013-01-06','11:45:00',2.85),('8975','2013-01-06','11:50:00',2.74),('8975','2013-01-06','11:55:00',2.7),('8975','2013-01-06','12:00:00',2.78),('8975','2013-01-06','12:05:00',2.69),('8975','2013-01-06','12:10:00',2.68),('8975','2013-01-06','12:15:00',2.68),('8975','2013-01-06','12:20:00',2.62),('8975','2013-01-06','12:25:00',2.55),('8975','2013-01-06','12:30:00',2.58),('8975','2013-01-06','12:35:00',2.47),('8975','2013-01-06','12:40:00',2.36),('8975','2013-01-06','12:45:00',2.28),('8975','2013-01-06','12:50:00',2.32),('8975','2013-01-06','12:55:00',2.32),('8975','2013-01-06','13:00:00',2.26),('8975','2013-01-06','13:05:00',2.15),('8975','2013-01-06','13:10:00',2.12),('8975','2013-01-06','13:15:00',2.01),('8975','2013-01-06','13:20:00',1.97),('8975','2013-01-06','13:25:00',1.88),('8975','2013-01-06','13:30:00',1.84),('8975','2013-01-06','13:35:00',1.77),('8975','2013-01-06','13:40:00',1.7),('8975','2013-01-06','13:45:00',1.63),('8975','2013-01-06','13:50:00',1.6),('8975','2013-01-06','13:55:00',1.51),('8975','2013-01-06','14:00:00',1.5),('8975','2013-01-06','14:05:00',1.43),('8975','2013-01-06','14:10:00',1.38),('8975','2013-01-06','14:15:00',1.34),('8975','2013-01-06','14:20:00',1.25),('8975','2013-01-06','14:25:00',1.19),('8975','2013-01-06','14:30:00',1.13),('8975','2013-01-06','14:35:00',1.06),('8975','2013-01-06','14:40:00',1.01),('8975','2013-01-06','14:45:00',1.09),('8975','2013-01-06','14:50:00',1.1),('8975','2013-01-06','14:55:00',1.11),('8975','2013-01-06','15:00:00',1.08),('8975','2013-01-06','15:05:00',1.05),('8975','2013-01-06','15:10:00',1.03),('8975','2013-01-05','08:05:00',1.06),('8975','2013-01-05','08:10:00',1.19),('8975','2013-01-05','08:15:00',1.31),('8975','2013-01-05','08:20:00',1.41),('8975','2013-01-05','08:25:00',1.5),('8975','2013-01-05','08:30:00',1.61),('8975','2013-01-05','08:35:00',1.71),('8975','2013-01-05','08:40:00',1.8),('8975','2013-01-05','08:45:00',1.9),('8975','2013-01-05','08:50:00',1.99),('8975','2013-01-05','08:55:00',2.06),('8975','2013-01-05','09:00:00',2.12),('8975','2013-01-05','09:05:00',2.2),('8975','2013-01-05','09:10:00',2.26),('8975','2013-01-05','09:15:00',2.33),('8975','2013-01-05','09:20:00',2.39),('8975','2013-01-05','09:25:00',2.43),('8975','2013-01-05','09:30:00',2.49),('8975','2013-01-05','09:35:00',2.54),('8975','2013-01-05','09:40:00',2.64),('8975','2013-01-05','09:45:00',2.68),('8975','2013-01-05','09:50:00',2.75),('8975','2013-01-05','09:55:00',2.74),('8975','2013-01-05','10:00:00',2.76),('8975','2013-01-05','10:05:00',2.77),('8975','2013-01-05','10:10:00',2.81),('8975','2013-01-05','10:15:00',2.83),('8975','2013-01-05','10:20:00',2.8),('8975','2013-01-05','10:25:00',2.82),('8975','2013-01-05','10:30:00',2.91),('8975','2013-01-05','10:35:00',2.97),('8975','2013-01-05','10:40:00',3.02),('8975','2013-01-05','10:45:00',3.04),('8975','2013-01-05','10:50:00',3.03),('8975','2013-01-05','10:55:00',3.05),('8975','2013-01-05','11:00:00',3.03),('8975','2013-01-05','11:05:00',3.05),('8975','2013-01-05','11:10:00',3.03),('8975','2013-01-05','11:15:00',3.04),('8975','2013-01-05','11:20:00',3.05),('8975','2013-01-05','11:25:00',3.05),('8975','2013-01-05','11:30:00',3.04),('8975','2013-01-05','11:35:00',2.93),('8975','2013-01-05','11:40:00',2.98),('8975','2013-01-05','11:45:00',2.92),('8975','2013-01-05','11:50:00',2.75),('8975','2013-01-05','11:55:00',2.7),('8975','2013-01-05','12:00:00',2.79),('8975','2013-01-05','12:05:00',2.68),('8975','2013-01-05','12:10:00',2.68),('8975','2013-01-05','12:15:00',2.65),('8975','2013-01-05','12:20:00',2.59),('8975','2013-01-05','12:25:00',2.55),('8975','2013-01-05','12:30:00',2.56),('8975','2013-01-05','12:35:00',2.47),('8975','2013-01-05','12:40:00',2.35),('8975','2013-01-05','12:45:00',2.39),('8975','2013-01-05','12:50:00',2.34),('8975','2013-01-05','12:55:00',2.33),('8975','2013-01-05','13:00:00',2.3),('8975','2013-01-05','13:05:00',2.25),('8975','2013-01-05','13:10:00',2.1),('8975','2013-01-05','13:15:00',2.03),('8975','2013-01-05','13:20:00',1.99),('8975','2013-01-05','13:25:00',1.86),('8975','2013-01-05','13:30:00',1.88),('8975','2013-01-05','13:35:00',1.78),('8975','2013-01-05','13:40:00',1.71),('8975','2013-01-05','13:45:00',1.66),('8975','2013-01-05','13:50:00',1.63),('8975','2013-01-05','13:55:00',1.57),('8975','2013-01-05','14:00:00',1.59),('8975','2013-01-05','14:05:00',1.55),('8975','2013-01-05','14:10:00',1.49),('8975','2013-01-05','14:15:00',1.41),('8975','2013-01-05','14:20:00',1.35),('8975','2013-01-05','14:25:00',1.25),('8975','2013-01-05','14:30:00',1.19),('8975','2013-01-05','14:35:00',1.09),('8975','2013-01-05','14:40:00',1.02),('8975','2013-01-05','14:45:00',1.14),('8975','2013-01-05','14:50:00',1.16),('8975','2013-01-05','14:55:00',1.15),('8975','2013-01-05','15:00:00',1.13),('8975','2013-01-05','15:05:00',1.08),('8975','2013-01-05','15:10:00',1.08),('8975','2013-01-05','15:15:00',1.03),('8975','2013-01-04','08:45:00',1.16),('8975','2013-01-04','08:50:00',1.13),('8975','2013-01-04','08:55:00',1),('8975','2013-01-04','09:05:00',1.07),('8975','2013-01-04','09:10:00',1.11),('8975','2013-01-04','09:15:00',1.06),('8975','2013-01-04','09:20:00',1),('8975','2013-01-04','09:25:00',1.08),('8975','2013-01-04','09:30:00',1.07),('8975','2013-01-04','09:35:00',1.17),('8975','2013-01-04','09:40:00',1.26),('8975','2013-01-04','09:45:00',1.21),('8975','2013-01-04','09:50:00',1.18),('8975','2013-01-04','09:55:00',1.23),('8975','2013-01-04','10:00:00',1.36),('8975','2013-01-04','10:05:00',1.46),('8975','2013-01-04','10:10:00',1.59),('8975','2013-01-04','10:15:00',1.68),('8975','2013-01-04','10:20:00',1.57),('8975','2013-01-04','10:25:00',1.51),('8975','2013-01-04','10:30:00',1.5),('8975','2013-01-04','10:35:00',1.67),('8975','2013-01-04','10:40:00',1.74),('8975','2013-01-04','10:45:00',1.67),('8975','2013-01-04','10:50:00',1.75),('8975','2013-01-04','10:55:00',2.66),('8975','2013-01-04','11:00:00',2.8),('8975','2013-01-04','11:05:00',2.51),('8975','2013-01-04','11:10:00',2.93),('8975','2013-01-04','11:15:00',2.25),('8975','2013-01-04','11:20:00',2.89),('8975','2013-01-04','11:25:00',3.21),('8975','2013-01-04','11:30:00',3.2),('8975','2013-01-04','11:35:00',2.97),('8975','2013-01-04','11:40:00',2.6),('8975','2013-01-04','11:45:00',2.72),('8975','2013-01-04','11:50:00',2.53),('8975','2013-01-04','11:55:00',2.12),('8975','2013-01-04','12:00:00',1.87),('8975','2013-01-04','12:05:00',1.75),('8975','2013-01-04','12:10:00',1.74),('8975','2013-01-04','12:15:00',2.03),('8975','2013-01-04','12:20:00',1.78),('8975','2013-01-04','12:25:00',1.68),('8975','2013-01-04','12:30:00',1.53),('8975','2013-01-04','12:35:00',1.74),('8975','2013-01-04','12:40:00',2.34),('8975','2013-01-04','12:45:00',2.54),('8975','2013-01-04','12:50:00',2.02),('8975','2013-01-04','12:55:00',1.76),('8975','2013-01-04','13:00:00',1.54),('8975','2013-01-04','13:05:00',1.6),('8975','2013-01-04','13:10:00',1.63),('8975','2013-01-04','13:15:00',1.45),('8975','2013-01-04','13:20:00',1.29),('8975','2013-01-04','13:25:00',1.32),('8975','2013-01-04','13:30:00',2),('8975','2013-01-04','13:35:00',1.78),('8975','2013-01-04','13:40:00',1.42),('8975','2013-01-04','13:45:00',1.28),('8975','2013-01-04','13:50:00',1.37),('8975','2013-01-04','13:55:00',1.53),('8975','2013-01-04','14:00:00',1.43),('8975','2013-01-04','14:05:00',1.75),('8975','2013-01-04','14:10:00',1.81),('8975','2013-01-04','14:15:00',1.47),('8975','2013-01-04','14:20:00',1.25),('8975','2013-01-04','14:30:00',1.21),('8975','2013-01-04','14:35:00',1.29),('8975','2013-01-04','14:40:00',1.36),('8975','2013-01-04','14:45:00',1.56),('8975','2013-01-04','14:50:00',1.15),('8975','2013-01-04','15:00:00',1.27),('8975','2013-01-04','15:05:00',1.17),('8975','2013-01-03','08:15:00',1.01),('8975','2013-01-03','08:20:00',1.1),('8975','2013-01-03','08:25:00',1.02),('8975','2013-01-03','08:35:00',1.1),('8975','2013-01-03','08:40:00',1.29),('8975','2013-01-03','08:45:00',1.84),('8975','2013-01-03','08:50:00',2.03),('8975','2013-01-03','08:55:00',1.96),('8975','2013-01-03','09:00:00',2.07),('8975','2013-01-03','09:05:00',1.95),('8975','2013-01-03','09:10:00',1.91),('8975','2013-01-03','09:15:00',2),('8975','2013-01-03','09:20:00',2.15),('8975','2013-01-03','09:25:00',1.96),('8975','2013-01-03','09:30:00',2.09),('8975','2013-01-03','09:35:00',1.94),('8975','2013-01-03','09:40:00',1.71),('8975','2013-01-03','09:45:00',2.02),('8975','2013-01-03','09:50:00',2.03),('8975','2013-01-03','09:55:00',2.26),('8975','2013-01-03','10:00:00',2.98),('8975','2013-01-03','10:05:00',3.05),('8975','2013-01-03','10:10:00',2.82),('8975','2013-01-03','10:15:00',2.76),('8975','2013-01-03','10:20:00',2.67),('8975','2013-01-03','10:25:00',2.56),('8975','2013-01-03','10:30:00',2.94),('8975','2013-01-03','10:35:00',3.09),('8975','2013-01-03','10:40:00',3.18),('8975','2013-01-03','10:45:00',3.26),('8975','2013-01-03','10:50:00',3.43),('8975','2013-01-03','10:55:00',3.58),('8975','2013-01-03','11:00:00',3.39),('8975','2013-01-03','11:05:00',2.57),('8975','2013-01-03','11:10:00',1.57),('8975','2013-01-03','11:15:00',1.44),('8975','2013-01-03','11:20:00',1.42),('8975','2013-01-03','11:25:00',1.28),('8975','2013-01-03','11:30:00',1.09),('8975','2013-01-03','11:35:00',1.12),('8975','2013-01-03','11:40:00',1.02),('8975','2013-01-03','11:45:00',1.48),('8975','2013-01-03','11:50:00',2.04),('8975','2013-01-03','11:55:00',2.87),('8975','2013-01-03','12:00:00',3.62),('8975','2013-01-03','12:05:00',3.22),('8975','2013-01-03','12:10:00',2.54),('8975','2013-01-03','12:15:00',1.85),('8975','2013-01-03','12:20:00',1.44),('8975','2013-01-03','12:25:00',1.22),('8975','2013-01-03','12:30:00',1.82),('8975','2013-01-03','12:35:00',1.94),('8975','2013-01-03','12:40:00',2.23),('8975','2013-01-03','12:45:00',2.48),('8975','2013-01-03','12:50:00',2.53),('8975','2013-01-03','12:55:00',2.53),('8975','2013-01-03','13:00:00',2.38),('8975','2013-01-03','13:05:00',2.19),('8975','2013-01-03','13:10:00',1.32),('8975','2013-01-03','13:15:00',1.59),('8975','2013-01-03','13:20:00',1.88),('8975','2013-01-03','13:25:00',1.81),('8975','2013-01-03','13:30:00',1.78),('8975','2013-01-03','13:35:00',1.64),('8975','2013-01-03','13:40:00',1.61),('8975','2013-01-03','13:45:00',1.57),('8975','2013-01-03','13:50:00',1.49),('8975','2013-01-03','13:55:00',1.48),('8975','2013-01-03','14:00:00',1.46),('8975','2013-01-03','14:05:00',1.39),('8975','2013-01-03','14:10:00',1.31),('8975','2013-01-03','14:15:00',1.29),('8975','2013-01-03','14:20:00',1.21),('8975','2013-01-03','14:25:00',1.15),('8975','2013-01-03','14:30:00',1.06),('8975','2013-01-03','14:40:00',1.1),('8975','2013-01-03','14:45:00',1.16),('8975','2013-01-03','14:50:00',1.13),('8975','2013-01-03','14:55:00',1.1),('8975','2013-01-03','15:00:00',1.08),('8975','2013-01-03','15:05:00',1.05),('8975','2013-01-03','15:15:00',1.02),('8975','2013-01-01','10:00:00',1.03),('8975','2013-01-01','13:40:00',1.2),('8975','2013-01-01','13:45:00',1.35),('8975','2013-01-01','13:50:00',1.27),('8975','2013-01-01','13:55:00',1.11),('8975','2014-03-17','07:30:00',1.24),('8975','2014-03-17','07:35:00',1.33),('8975','2014-03-17','07:40:00',1.68),('8975','2014-03-17','07:45:00',1.59),('8975','2014-03-17','07:50:00',1.06),('8975','2014-03-17','08:00:00',1.2),('8975','2014-03-17','08:05:00',2.3),('8975','2014-03-17','08:10:00',2.07),('8975','2014-03-17','08:15:00',1.57),('8975','2014-03-17','08:20:00',1.14),('8975','2014-03-17','08:25:00',1.08),('8975','2014-03-17','08:30:00',1.14),('8975','2014-03-17','08:35:00',1.23),('8975','2014-03-17','08:40:00',1.88),('8975','2014-03-17','08:45:00',1.51),('8975','2014-03-17','08:50:00',1.52),('8975','2014-03-17','08:55:00',1.67),('8975','2014-03-17','09:00:00',2.52),('8975','2014-03-17','09:05:00',3.31),('8975','2014-03-17','09:10:00',1.68),('8975','2014-03-17','09:15:00',1.37),('8975','2014-03-17','09:20:00',1.38),('8975','2014-03-17','09:25:00',1.57),('8975','2014-03-17','09:30:00',1.44),('8975','2014-03-17','09:35:00',1.92),('8975','2014-03-17','09:40:00',1.55),('8975','2014-03-17','09:45:00',1.47),('8975','2014-03-17','09:50:00',1.74),('8975','2014-03-17','09:55:00',1.43),('8975','2014-03-17','10:00:00',1.33),('8975','2014-03-17','10:05:00',1.6),('8975','2014-03-17','10:10:00',3.68),('8975','2014-03-17','10:15:00',5.38),('8975','2014-03-17','10:20:00',4.1),('8975','2014-03-17','10:25:00',3.13),('8975','2014-03-17','10:30:00',2.36),('8975','2014-03-17','10:35:00',1.69),('8975','2014-03-17','10:40:00',1.9),('8975','2014-03-17','10:45:00',3.09),('8975','2014-03-17','10:50:00',3.51),('8975','2014-03-17','10:55:00',6.14),('8975','2014-03-17','11:00:00',4.44),('8975','2014-03-17','11:05:00',3.15),('8975','2014-03-17','11:10:00',2.29),('8975','2014-03-17','11:15:00',2.56),('8975','2014-03-17','11:20:00',3.54),('8975','2014-03-17','11:25:00',2.71),('8975','2014-03-17','11:30:00',3.33),('8975','2014-03-17','11:35:00',6.41),('8975','2014-03-17','11:40:00',4.75),('8975','2014-03-17','11:45:00',6.37),('8975','2014-03-17','11:50:00',5.86),('8975','2014-03-17','11:55:00',4.43),('8975','2014-03-17','12:00:00',3.08),('8975','2014-03-17','12:05:00',2.83),('8975','2014-03-17','12:10:00',4.67),('8975','2014-03-17','12:15:00',6.43),('8975','2014-03-17','12:20:00',3.63),('8975','2014-03-17','12:25:00',5.74),('8975','2014-03-17','12:30:00',6.17),('8975','2014-03-17','12:35:00',5.6),('8975','2014-03-17','12:40:00',4.4),('8975','2014-03-17','12:45:00',5.91),('8975','2014-03-17','12:50:00',5.42),('8975','2014-03-17','12:55:00',5.28),('8975','2014-03-17','13:00:00',5.1),('8975','2014-03-17','13:05:00',4.57),('8975','2014-03-17','13:10:00',5.21),('8975','2014-03-17','13:15:00',4.35),('8975','2014-03-17','13:20:00',4.73),('8975','2014-03-17','13:25:00',4.52),('8975','2014-03-17','13:30:00',4.3),('8975','2014-03-17','13:35:00',4.51),('8975','2014-03-17','13:40:00',4.42),('8975','2014-03-17','13:45:00',4.29),('8975','2014-03-17','13:50:00',4.1),('8975','2014-03-17','13:55:00',4.15),('8975','2014-03-17','14:00:00',4.01),('8975','2014-03-17','14:05:00',3.94),('8975','2014-03-17','14:10:00',3.67),('8975','2014-03-17','14:15:00',3.56),('8975','2014-03-17','14:20:00',3.65),('8975','2014-03-17','14:25:00',3.56),('8975','2014-03-17','14:30:00',3.48),('8975','2014-03-17','14:35:00',3.31),('8975','2014-03-17','14:40:00',3.1),('8975','2014-03-17','14:45:00',2.98),('8975','2014-03-17','14:50:00',3.04),('8975','2014-03-17','14:55:00',2.92),('8975','2014-03-17','15:00:00',2.87),('8975','2014-03-17','15:05:00',2.78),('8975','2014-03-17','15:10:00',2.66),('8975','2014-03-17','15:15:00',2.56),('8975','2014-03-17','15:20:00',2.46),('8975','2014-03-17','15:25:00',2.34),('8975','2014-03-17','15:30:00',2.21),('8975','2014-03-17','15:35:00',2.15),('8975','2014-03-17','15:40:00',2.03),('8975','2014-03-17','15:45:00',1.94),('8975','2014-03-17','15:50:00',1.85),('8975','2014-03-17','15:55:00',1.77),('8975','2014-03-17','16:00:00',1.69),('8975','2014-03-17','16:05:00',1.61),('8975','2014-03-17','16:10:00',1.55),('8975','2014-03-17','16:15:00',1.48),('8975','2014-03-17','16:20:00',1.45),('8975','2014-03-17','16:25:00',1.4),('8975','2014-03-17','16:30:00',1.36),('8975','2014-03-17','16:35:00',1.35),('8975','2014-03-17','16:40:00',1.3),('8975','2014-03-17','16:45:00',1.24),('8975','2014-03-17','16:50:00',1.18),('8975','2014-03-17','16:55:00',1.11),('8975','2014-03-17','17:00:00',1.04),('8975','2012-12-31','08:15:00',1.08),('8975','2012-12-31','08:20:00',1.19),('8975','2012-12-31','08:25:00',1.31),('8975','2012-12-31','08:30:00',1.4),('8975','2012-12-31','08:35:00',1.53),('8975','2012-12-31','08:40:00',1.66),('8975','2012-12-31','08:45:00',1.75),('8975','2012-12-31','08:50:00',1.81),('8975','2012-12-31','08:55:00',1.87),('8975','2012-12-31','09:00:00',1.93),('8975','2012-12-31','09:05:00',2.04),('8975','2012-12-31','09:10:00',2.11),('8975','2012-12-31','09:15:00',2.17),('8975','2012-12-31','09:20:00',2.22),('8975','2012-12-31','09:25:00',2.29),('8975','2012-12-31','09:30:00',2.34),('8975','2012-12-31','09:35:00',2.4),('8975','2012-12-31','09:40:00',2.47),('8975','2012-12-31','09:45:00',2.53),('8975','2012-12-31','09:50:00',2.57),('8975','2012-12-31','09:55:00',2.58),('8975','2012-12-31','10:00:00',2.61),('8975','2012-12-31','10:05:00',2.64),('8975','2012-12-31','10:10:00',2.68),('8975','2012-12-31','10:15:00',2.73),('8975','2012-12-31','10:20:00',2.71),('8975','2012-12-31','10:25:00',2.73),('8975','2012-12-31','10:30:00',2.8),('8975','2012-12-31','10:35:00',2.88),('8975','2012-12-31','10:40:00',2.97),('8975','2012-12-31','10:45:00',3.03),('8975','2012-12-31','10:50:00',1.93),('8975','2012-12-31','10:55:00',1.85),('8975','2012-12-31','11:00:00',1.05),('8975','2012-12-31','11:05:00',1.05),('8975','2012-12-31','11:10:00',1.33),('8975','2012-12-31','11:15:00',1.29),('8975','2012-12-31','11:20:00',2.01),('8975','2012-12-31','11:25:00',3.33),('8975','2012-12-31','11:30:00',3.36),('8975','2012-12-31','11:35:00',2.61),('8975','2012-12-31','11:40:00',2.74),('8975','2012-12-31','11:45:00',2.59),('8975','2012-12-31','11:50:00',1.72),('8975','2012-12-31','11:55:00',2.44),('8975','2012-12-31','12:00:00',2.86),('8975','2012-12-31','12:05:00',1.88),('8975','2012-12-31','12:10:00',1.87),('8975','2012-12-31','12:15:00',1.83),('8975','2012-12-31','12:20:00',1.71),('8975','2012-12-31','12:25:00',1.59),('8975','2012-12-31','12:30:00',1.72),('8975','2012-12-31','12:35:00',1.65),('8975','2012-12-31','12:40:00',2.12),('8975','2012-12-31','12:45:00',2.11),('8975','2012-12-31','12:50:00',2.71),('8975','2012-12-31','12:55:00',2.93),('8975','2012-12-31','13:00:00',2.38),('8975','2012-12-31','13:05:00',1.55),('8975','2012-12-31','13:10:00',1.24),('8975','2012-12-31','13:15:00',1.28),('8975','2012-12-31','13:20:00',1.2),('8975','2012-12-31','13:25:00',1.1),('8975','2012-12-30','08:00:00',1),('8975','2012-12-30','08:05:00',1.18),('8975','2012-12-30','08:10:00',1.26),('8975','2012-12-30','08:15:00',1.43),('8975','2012-12-30','08:20:00',1.42),('8975','2012-12-30','08:25:00',1.62),('8975','2012-12-30','08:30:00',1.74),('8975','2012-12-30','08:35:00',1.85),('8975','2012-12-30','08:40:00',1.31),('8975','2012-12-30','08:45:00',1.01),('8975','2012-12-30','08:50:00',1.27),('8975','2012-12-30','08:55:00',1.53),('8975','2012-12-30','09:00:00',2.1),('8975','2012-12-30','09:05:00',2.12),('8975','2012-12-30','09:10:00',2),('8975','2012-12-30','09:15:00',2.21),('8975','2012-12-30','09:20:00',2.23),('8975','2012-12-30','09:25:00',2.52),('8975','2012-12-30','09:30:00',2.77),('8975','2012-12-30','09:35:00',1.96),('8975','2012-12-30','09:40:00',1.06),('8975','2012-12-30','09:55:00',1.01),('8975','2012-12-30','10:00:00',2.17),('8975','2012-12-30','10:05:00',2.83),('8975','2012-12-30','10:10:00',2.89),('8975','2012-12-30','10:15:00',3.07),('8975','2012-12-30','10:20:00',3),('8975','2012-12-30','10:25:00',2.9),('8975','2012-12-30','10:30:00',2.98),('8975','2012-12-30','10:35:00',3.04),('8975','2012-12-30','10:40:00',3.08),('8975','2012-12-30','10:45:00',3.03),('8975','2012-12-30','10:50:00',2.98),('8975','2012-12-30','10:55:00',3.02),('8975','2012-12-30','11:00:00',2.99),('8975','2012-12-30','11:05:00',2.95),('8975','2012-12-30','11:10:00',2.99),('8975','2012-12-30','11:15:00',3.06),('8975','2012-12-30','11:20:00',3.03),('8975','2012-12-30','11:25:00',3.06),('8975','2012-12-30','11:30:00',3.02),('8975','2012-12-30','11:35:00',2.99),('8975','2012-12-30','11:40:00',2.92),('8975','2012-12-30','11:45:00',2.6),('8975','2012-12-30','11:50:00',2.8),('8975','2012-12-30','11:55:00',2.82),('8975','2012-12-30','12:00:00',2.76),('8975','2012-12-30','12:05:00',2.72),('8975','2012-12-30','12:10:00',2.71),('8975','2012-12-30','12:15:00',2.62),('8975','2012-12-30','12:20:00',2.63),('8975','2012-12-30','12:25:00',2.61),('8975','2012-12-30','12:30:00',2.52),('8975','2012-12-30','12:35:00',2.44),('8975','2012-12-30','12:40:00',2.43),('8975','2012-12-30','12:45:00',2.38),('8975','2012-12-30','12:50:00',2.36),('8975','2012-12-30','12:55:00',2.31),('8975','2012-12-30','13:00:00',2.19),('8975','2012-12-30','13:05:00',2.12),('8975','2012-12-30','13:10:00',2.05),('8975','2012-12-30','13:15:00',1.96),('8975','2012-12-30','13:20:00',1.9),('8975','2012-12-30','13:25:00',1.89),('8975','2012-12-30','13:30:00',1.77),('8975','2012-12-30','13:35:00',1.68),('8975','2012-12-30','13:40:00',1.59),('8975','2012-12-30','13:45:00',1.57),('8975','2012-12-30','13:50:00',1.55),('8975','2012-12-30','13:55:00',1.53),('8975','2012-12-30','14:00:00',1.47),('8975','2012-12-30','14:05:00',1.4),('8975','2012-12-30','14:10:00',1.3),('8975','2012-12-30','14:15:00',1.22),('8975','2012-12-30','14:20:00',1.11),('8975','2012-12-30','14:25:00',1.11),('8975','2012-12-30','14:30:00',1.12),('8975','2012-12-30','14:35:00',1.11),('8975','2012-12-30','14:40:00',1.13),('8975','2012-12-30','14:45:00',1.17),('8975','2012-12-30','14:50:00',1.14),('8975','2012-12-30','14:55:00',1.11),('8975','2012-12-30','15:00:00',1.09),('8975','2012-12-30','15:05:00',1.06),('8975','2012-12-30','15:10:00',1.04),('8975','2012-12-29','08:10:00',1.12),('8975','2012-12-29','08:15:00',1.24),('8975','2012-12-29','08:20:00',1.35),('8975','2012-12-29','08:25:00',1.45),('8975','2012-12-29','08:30:00',1.56),('8975','2012-12-29','08:35:00',1.67),('8975','2012-12-29','08:40:00',1.75),('8975','2012-12-29','08:45:00',1.86),('8975','2012-12-29','08:50:00',1.94),('8975','2012-12-29','08:55:00',2.02),('8975','2012-12-29','09:00:00',2.07),('8975','2012-12-29','09:05:00',2.13),('8975','2012-12-29','09:10:00',2.2),('8975','2012-12-29','09:15:00',2.27),('8975','2012-12-29','09:20:00',2.34),('8975','2012-12-29','09:25:00',2.38),('8975','2012-12-29','09:30:00',2.44),('8975','2012-12-29','09:35:00',2.51),('8975','2012-12-29','09:40:00',2.57),('8975','2012-12-29','09:45:00',2.63),('8975','2012-12-29','09:50:00',2.67),('8975','2012-12-29','09:55:00',2.63),('8975','2012-12-29','10:00:00',2.48),('8975','2012-12-29','10:05:00',2.68),('8975','2012-12-29','10:10:00',2.62),('8975','2012-12-29','10:15:00',2.76),('8975','2012-12-29','10:20:00',2.65),('8975','2012-12-29','10:25:00',2.81),('8975','2012-12-29','10:30:00',2.58),('8975','2012-12-29','10:35:00',2.84),('8975','2012-12-29','10:40:00',2.92),('8975','2012-12-29','10:45:00',2.96),('8975','2012-12-29','10:50:00',2.81),('8975','2012-12-29','10:55:00',2.7),('8975','2012-12-29','11:00:00',2.99),('8975','2012-12-29','11:05:00',2.92),('8975','2012-12-29','11:10:00',3.06),('8975','2012-12-29','11:15:00',3.06),('8975','2012-12-29','11:20:00',2.81),('8975','2012-12-29','11:25:00',3),('8975','2012-12-29','11:30:00',2.99),('8975','2012-12-29','11:35:00',2.98),('8975','2012-12-29','11:40:00',2.89),('8975','2012-12-29','11:45:00',2.84),('8975','2012-12-29','11:50:00',2.77),('8975','2012-12-29','11:55:00',2.73),('8975','2012-12-29','12:00:00',2.72),('8975','2012-12-29','12:05:00',2.64),('8975','2012-12-29','12:10:00',2.61),('8975','2012-12-29','12:15:00',2.6),('8975','2012-12-29','12:20:00',2.56),('8975','2012-12-29','12:25:00',2.53),('8975','2012-12-29','12:30:00',2.46),('8975','2012-12-29','12:35:00',2.38),('8975','2012-12-29','12:40:00',2.34),('8975','2012-12-29','12:45:00',2.33),('8975','2012-12-29','12:50:00',2.23),('8975','2012-12-29','12:55:00',2.2),('8975','2012-12-29','13:00:00',2.17),('8975','2012-12-29','13:05:00',1.98),('8975','2012-12-29','13:10:00',1.94),('8975','2012-12-29','13:15:00',1.92),('8975','2012-12-29','13:20:00',1.87),('8975','2012-12-29','13:25:00',1.86),('8975','2012-12-29','13:30:00',1.75),('8975','2012-12-29','13:35:00',1.65),('8975','2012-12-29','13:40:00',1.61),('8975','2012-12-29','13:45:00',1.61),('8975','2012-12-29','13:50:00',1.54),('8975','2012-12-29','13:55:00',1.52),('8975','2012-12-29','14:00:00',1.47),('8975','2012-12-29','14:05:00',1.39),('8975','2012-12-29','14:10:00',1.3),('8975','2012-12-29','14:15:00',1.19),('8975','2012-12-29','14:20:00',1.01),('8975','2012-12-29','14:30:00',1.14),('8975','2012-12-29','14:35:00',1.13),('8975','2012-12-29','14:40:00',1.14),('8975','2012-12-29','14:45:00',1.18),('8975','2012-12-29','14:50:00',1.15),('8975','2012-12-29','14:55:00',1.11),('8975','2012-12-29','15:00:00',1.09),('8975','2012-12-29','15:05:00',1.07),('8975','2012-12-29','15:10:00',1.04),('8975','2012-12-29','15:15:00',1.01),('8975','2012-12-29','15:20:00',1),('8975','2012-12-28','08:10:00',1.1),('8975','2012-12-28','08:15:00',1.22),('8975','2012-12-28','08:20:00',1.33),('8975','2012-12-28','08:25:00',1.46),('8975','2012-12-28','08:30:00',1.6),('8975','2012-12-28','08:35:00',1.74),('8975','2012-12-28','08:40:00',1.84),('8975','2012-12-28','08:45:00',1.96),('8975','2012-12-28','08:50:00',2.02),('8975','2012-12-28','08:55:00',2.06),('8975','2012-12-28','09:00:00',2.12),('8975','2012-12-28','09:05:00',2.16),('8975','2012-12-28','09:10:00',2.19),('8975','2012-12-28','09:15:00',2.19),('8975','2012-12-28','09:20:00',2.35),('8975','2012-12-28','09:25:00',2.4),('8975','2012-12-28','09:30:00',2.45),('8975','2012-12-28','09:35:00',2.54),('8975','2012-12-28','09:40:00',2.62),('8975','2012-12-28','09:45:00',2.72),('8975','2012-12-28','09:50:00',2.77),('8975','2012-12-28','09:55:00',2.79),('8975','2012-12-28','10:00:00',2.82),('8975','2012-12-28','10:05:00',2.83),('8975','2012-12-28','10:10:00',2.85),('8975','2012-12-28','10:15:00',2.89),('8975','2012-12-28','10:20:00',2.84),('8975','2012-12-28','10:25:00',2.83),('8975','2012-12-28','10:30:00',2.92),('8975','2012-12-28','10:35:00',2.96),('8975','2012-12-28','10:40:00',3.01),('8975','2012-12-28','10:45:00',3),('8975','2012-12-28','10:50:00',2.93),('8975','2012-12-28','10:55:00',2.97),('8975','2012-12-28','11:00:00',3.05),('8975','2012-12-28','11:05:00',3.04),('8975','2012-12-28','11:10:00',3.06),('8975','2012-12-28','11:15:00',3.09),('8975','2012-12-28','11:20:00',3.07),('8975','2012-12-28','11:25:00',3.08),('8975','2012-12-28','11:30:00',3.04),('8975','2012-12-28','11:35:00',3.02),('8975','2012-12-28','11:40:00',2.86),('8975','2012-12-28','11:45:00',2.87),('8975','2012-12-28','11:50:00',2.82),('8975','2012-12-28','11:55:00',2.73),('8975','2012-12-28','12:00:00',2.74),('8975','2012-12-28','12:05:00',2.68),('8975','2012-12-28','12:10:00',2.64),('8975','2012-12-28','12:15:00',2.62),('8975','2012-12-28','12:20:00',2.56),('8975','2012-12-28','12:25:00',2.55),('8975','2012-12-28','12:30:00',2.49),('8975','2012-12-28','12:35:00',2.41),('8975','2012-12-28','12:40:00',2.37),('8975','2012-12-28','12:45:00',2.36),('8975','2012-12-28','12:50:00',2.23),('8975','2012-12-28','12:55:00',2.26),('8975','2012-12-28','13:00:00',2.17),('8975','2012-12-28','13:05:00',1.97),('8975','2012-12-28','13:10:00',1.95),('8975','2012-12-28','13:15:00',1.92),('8975','2012-12-28','13:20:00',1.89),('8975','2012-12-28','13:25:00',1.87),('8975','2012-12-28','13:30:00',1.76),('8975','2012-12-28','13:35:00',1.65),('8975','2012-12-28','13:40:00',1.62),('8975','2012-12-28','13:45:00',1.61),('8975','2012-12-28','13:50:00',1.57),('8975','2012-12-28','13:55:00',1.52),('8975','2012-12-28','14:00:00',1.45),('8975','2012-12-28','14:05:00',1.39),('8975','2012-12-28','14:10:00',1.31),('8975','2012-12-28','14:15:00',1.16),('8975','2012-12-28','14:25:00',1.06),('8975','2012-12-28','14:30:00',1.13),('8975','2012-12-28','14:35:00',1.14),('8975','2012-12-28','14:40:00',1.16),('8975','2012-12-28','14:45:00',1.19),('8975','2012-12-28','14:50:00',1.16),('8975','2012-12-28','14:55:00',1.12),('8975','2012-12-28','15:00:00',1.1),('8975','2012-12-28','15:05:00',1.08),('8975','2012-12-28','15:10:00',1.05),('8975','2012-12-28','15:15:00',1.04),('8975','2012-12-28','15:20:00',1.01),('8975','2012-12-27','08:40:00',1.32),('8975','2012-12-27','08:45:00',1.59),('8975','2012-12-27','08:50:00',1.75),('8975','2012-12-27','08:55:00',1.85),('8975','2012-12-27','09:00:00',1.94),('8975','2012-12-27','09:05:00',1.99),('8975','2012-12-27','09:10:00',2.07),('8975','2012-12-27','09:15:00',2.16),('8975','2012-12-27','09:20:00',2.2),('8975','2012-12-27','09:25:00',2.24),('8975','2012-12-27','09:30:00',2.29),('8975','2012-12-27','09:35:00',2.33),('8975','2012-12-27','09:40:00',2.41),('8975','2012-12-27','09:45:00',2.47),('8975','2012-12-27','09:50:00',2.51),('8975','2012-12-27','09:55:00',2.55),('8975','2012-12-27','10:00:00',2.54),('8975','2012-12-27','10:05:00',2.59),('8975','2012-12-27','10:10:00',2.59),('8975','2012-12-27','10:15:00',2.65),('8975','2012-12-27','10:20:00',2.63),('8975','2012-12-27','10:25:00',2.6),('8975','2012-12-27','10:30:00',2.69),('8975','2012-12-27','10:35:00',2.78),('8975','2012-12-27','10:40:00',2.85),('8975','2012-12-27','10:45:00',2.85),('8975','2012-12-27','10:50:00',2.85),('8975','2012-12-27','10:55:00',2.85),('8975','2012-12-27','11:00:00',2.86),('8975','2012-12-27','11:05:00',2.92),('8975','2012-12-27','11:10:00',2.92),('8975','2012-12-27','11:15:00',2.76),('8975','2012-12-27','11:20:00',3.07),('8975','2012-12-27','11:25:00',2.78),('8975','2012-12-27','11:30:00',2.92),('8975','2012-12-27','11:35:00',2.94),('8975','2012-12-27','11:40:00',2.4),('8975','2012-12-27','11:45:00',2.36),('8975','2012-12-27','11:50:00',1.69),('8975','2012-12-27','11:55:00',2.31),('8975','2012-12-27','12:05:00',1.92),('8975','2012-12-27','12:10:00',1.99),('8975','2012-12-27','12:15:00',2.35),('8975','2012-12-27','12:20:00',2.46),('8975','2012-12-27','12:25:00',2.47),('8975','2012-12-27','12:30:00',2.42),('8975','2012-12-27','12:35:00',2.38),('8975','2012-12-27','12:40:00',2.27),('8975','2012-12-27','12:45:00',2.3),('8975','2012-12-27','12:50:00',2.26),('8975','2012-12-27','12:55:00',2.14),('8975','2012-12-27','13:00:00',2.03),('8975','2012-12-27','13:05:00',1.89),('8975','2012-12-27','13:10:00',1.88),('8975','2012-12-27','13:15:00',1.88),('8975','2012-12-27','13:20:00',1.84),('8975','2012-12-27','13:25:00',1.81),('8975','2012-12-27','13:30:00',1.7),('8975','2012-12-27','13:35:00',1.59),('8975','2012-12-27','13:40:00',1.46),('8975','2012-12-27','13:45:00',1.42),('8975','2012-12-27','13:50:00',1.52),('8975','2012-12-27','13:55:00',1.44),('8975','2012-12-27','14:00:00',1.42),('8975','2012-12-27','14:05:00',1.33),('8975','2012-12-27','14:10:00',1.24),('8975','2012-12-27','14:15:00',1.15),('8975','2012-12-27','14:20:00',1.15),('8975','2012-12-27','14:25:00',1.14),('8975','2012-12-27','14:30:00',1.12),('8975','2012-12-27','14:35:00',1.11),('8975','2012-12-27','14:40:00',1.17),('8975','2012-12-27','14:45:00',1.19),('8975','2012-12-27','14:50:00',1.13),('8975','2012-12-27','14:55:00',1.11),('8975','2012-12-27','15:00:00',1.06),('8975','2012-12-27','15:05:00',1.02),('8975','2012-12-26','08:25:00',1.19),('8975','2012-12-26','08:30:00',1.25),('8975','2012-12-26','08:35:00',1.36),('8975','2012-12-26','08:40:00',1.27),('8975','2012-12-26','08:45:00',1.1),('8975','2012-12-26','08:50:00',1.67),('8975','2012-12-26','08:55:00',1.89),('8975','2012-12-26','09:00:00',1.37),('8975','2012-12-26','09:10:00',1.59),('8975','2012-12-26','09:15:00',1.74),('8975','2012-12-26','09:20:00',2.13),('8975','2012-12-26','09:25:00',2.13),('8975','2012-12-26','09:30:00',2.16),('8975','2012-12-26','09:35:00',2.3),('8975','2012-12-26','09:40:00',2.37),('8975','2012-12-26','09:45:00',2.42),('8975','2012-12-26','09:50:00',2.48),('8975','2012-12-26','09:55:00',2.59),('8975','2012-12-26','10:00:00',2.57),('8975','2012-12-26','10:05:00',2.58),('8975','2012-12-26','10:10:00',2.62),('8975','2012-12-26','10:15:00',2.59),('8975','2012-12-26','10:20:00',2.43),('8975','2012-12-26','10:25:00',2.46),('8975','2012-12-26','10:30:00',2.47),('8975','2012-12-26','10:35:00',2.57),('8975','2012-12-26','10:40:00',2.59),('8975','2012-12-26','10:45:00',1.53),('8975','2012-12-26','10:55:00',1.2),('8975','2012-12-26','11:00:00',1.9),('8975','2012-12-26','11:05:00',2.71),('8975','2012-12-26','11:10:00',2.02),('8975','2012-12-26','11:15:00',2.67),('8975','2012-12-26','11:20:00',1.43),('8975','2012-12-26','11:55:00',1.05),('8975','2012-12-26','12:00:00',2.2),('8975','2012-12-26','12:05:00',2.61),('8975','2012-12-26','12:10:00',2.57),('8975','2012-12-26','12:15:00',2.51),('8975','2012-12-26','12:20:00',1.48),('8975','2012-12-26','12:35:00',1.15),('8975','2012-12-26','12:40:00',1.75),('8975','2012-12-26','12:45:00',1.85),('8975','2012-12-26','12:50:00',2.35),('8975','2012-12-26','12:55:00',2.27),('8975','2012-12-26','13:05:00',1.33),('8975','2012-12-26','13:10:00',1.35),('8975','2012-12-26','13:15:00',1.21),('8975','2012-12-26','13:20:00',1.31),('8975','2012-12-26','13:25:00',1.29),('8975','2012-12-26','13:30:00',1.28),('8975','2012-12-26','13:35:00',2.17),('8975','2012-12-26','13:40:00',1.98),('8975','2012-12-26','13:45:00',1.09),('8975','2012-12-26','13:50:00',1.75),('8975','2012-12-26','13:55:00',2.22),('8975','2012-12-26','14:00:00',1.4),('8975','2012-12-26','14:05:00',1.65),('8975','2012-12-26','14:10:00',1.44),('8975','2012-12-26','14:15:00',1.12),('8975','2012-12-26','14:20:00',1.16),('8975','2012-12-26','14:25:00',1.12),('8975','2012-12-26','14:30:00',1.04),('8975','2012-12-26','14:35:00',1.04),('8975','2012-12-26','14:50:00',1.03),('8975','2012-12-26','14:55:00',1.03),('8975','2012-12-25','09:15:00',1.71),('8975','2012-12-25','09:20:00',2.32),('8975','2012-12-25','09:25:00',2.33),('8975','2012-12-25','09:30:00',2.33),('8975','2012-12-25','09:35:00',2.35),('8975','2012-12-25','09:40:00',2.49),('8975','2012-12-25','09:45:00',2.55),('8975','2012-12-25','09:50:00',2.58),('8975','2012-12-25','09:55:00',2.61),('8975','2012-12-25','10:00:00',2.64),('8975','2012-12-25','10:05:00',2.66),('8975','2012-12-25','10:10:00',2.68),('8975','2012-12-25','10:15:00',2.68),('8975','2012-12-25','10:20:00',2.63),('8975','2012-12-25','10:25:00',2.58),('8975','2012-12-25','10:30:00',2.57),('8975','2012-12-25','10:35:00',2.69),('8975','2012-12-25','10:40:00',2.75),('8975','2012-12-25','10:45:00',2.69),('8975','2012-12-25','10:50:00',2.74),('8975','2012-12-25','10:55:00',2.78),('8975','2012-12-25','11:00:00',2.77),('8975','2012-12-25','11:05:00',2.77),('8975','2012-12-25','11:10:00',2.76),('8975','2012-12-25','11:15:00',2.77),('8975','2012-12-25','11:20:00',2.77),('8975','2012-12-25','11:25:00',2.8),('8975','2012-12-25','11:30:00',2.68),('8975','2012-12-25','11:35:00',2.67),('8975','2012-12-25','11:40:00',2.54),('8975','2012-12-25','11:45:00',2.64),('8975','2012-12-25','11:50:00',2.67),('8975','2012-12-25','11:55:00',2.66),('8975','2012-12-25','12:00:00',2.59),('8975','2012-12-25','12:05:00',2.55),('8975','2012-12-25','12:10:00',2.55),('8975','2012-12-25','12:15:00',2.5),('8975','2012-12-25','12:20:00',2.46),('8975','2012-12-25','12:25:00',2.45),('8975','2012-12-25','12:30:00',2.2),('8975','2012-12-25','12:35:00',1.97),('8975','2012-12-25','12:40:00',2.25),('8975','2012-12-25','12:45:00',2.2),('8975','2012-12-25','12:50:00',2.01),('8975','2012-12-25','12:55:00',1.98),('8975','2012-12-25','13:00:00',2.01),('8975','2012-12-25','13:05:00',1.82),('8975','2012-12-25','13:10:00',1.94),('8975','2012-12-25','13:15:00',1.62),('8975','2012-12-25','13:20:00',1.51),('8975','2012-12-25','13:25:00',1.56),('8975','2012-12-25','13:35:00',1.49),('8975','2012-12-25','13:40:00',1.62),('8975','2012-12-25','13:45:00',1.44),('8975','2012-12-25','13:50:00',1.1),('8975','2012-12-25','14:00:00',1.36),('8975','2012-12-25','14:05:00',1.25),('8975','2012-12-25','14:10:00',1.3),('8975','2012-12-25','14:15:00',1.2),('8975','2012-12-25','14:20:00',1.05),('8975','2012-12-24','10:05:00',1.03),('8975','2012-12-24','10:10:00',1.08),('8975','2012-12-24','10:15:00',1.11),('8975','2012-12-24','10:20:00',1.18),('8975','2012-12-24','10:25:00',1.18),('8975','2012-12-24','10:30:00',1.14),('8975','2012-12-24','10:35:00',1.14),('8975','2012-12-24','10:40:00',1.1),('8975','2012-12-24','10:45:00',1.13),('8975','2012-12-24','10:50:00',1.11),('8975','2012-12-24','10:55:00',1.26),('8975','2012-12-24','11:00:00',1.2),('8975','2012-12-24','11:05:00',1.33),('8975','2012-12-24','11:10:00',1.37),('8975','2012-12-24','11:15:00',1.32),('8975','2012-12-24','11:20:00',1.38),('8975','2012-12-24','11:25:00',1.33),('8975','2012-12-24','11:30:00',1.39),('8975','2012-12-24','11:35:00',1.35),('8975','2012-12-24','11:40:00',1.29),('8975','2012-12-24','11:45:00',1.31),('8975','2012-12-24','11:50:00',1.32),('8975','2012-12-24','11:55:00',1.36),('8975','2012-12-24','12:00:00',1.32),('8975','2012-12-24','12:05:00',1.28),('8975','2012-12-24','12:10:00',1.36),('8975','2012-12-24','12:15:00',1.38),('8975','2012-12-24','12:20:00',1.3),('8975','2012-12-24','12:25:00',1.35),('8975','2012-12-24','12:30:00',1.26),('8975','2012-12-24','12:35:00',1.15),('8975','2012-12-24','12:40:00',1.18),('8975','2012-12-24','12:45:00',1.31),('8975','2012-12-24','12:50:00',1.27),('8975','2012-12-24','12:55:00',1.4),('8975','2012-12-24','13:00:00',1.23),('8975','2012-12-24','13:05:00',1.26),('8975','2012-12-24','13:10:00',1.43),('8975','2012-12-24','13:15:00',1.29),('8975','2012-12-24','13:20:00',1.2),('8975','2012-12-24','13:30:00',1.17),('8975','2012-12-24','13:35:00',1.11),('8975','2012-12-24','13:40:00',1.03),('8975','2012-12-24','14:00:00',1.05),('8975','2012-12-23','11:40:00',1.03),('8975','2012-12-23','11:45:00',1.05),('8975','2012-12-23','11:50:00',1.06),('8975','2012-12-23','11:55:00',1.15),('8975','2012-12-23','12:00:00',1.28),('8975','2012-12-23','12:05:00',1.36),('8975','2012-12-23','12:10:00',1.27),('8975','2012-12-23','12:15:00',1.21),('8975','2012-12-23','12:20:00',1.14),('8975','2012-12-23','12:25:00',1.15),('8975','2012-12-23','12:30:00',1.17),('8975','2012-12-23','12:35:00',1.19),('8975','2012-12-23','12:40:00',1.15),('8975','2012-12-23','12:45:00',1.09),('8975','2012-12-23','12:50:00',1.04),('8975','2012-12-23','12:55:00',1.03),('8975','2012-12-22','08:10:00',1.13),('8975','2012-12-22','08:15:00',1.23),('8975','2012-12-22','08:20:00',1.37),('8975','2012-12-22','08:25:00',1.46),('8975','2012-12-22','08:30:00',1.58),('8975','2012-12-22','08:35:00',1.7),('8975','2012-12-22','08:40:00',1.79),('8975','2012-12-22','08:45:00',1.87),('8975','2012-12-22','08:50:00',1.92),('8975','2012-12-22','08:55:00',2),('8975','2012-12-22','09:00:00',2.09),('8975','2012-12-22','09:05:00',2.15),('8975','2012-12-22','09:10:00',2.21),('8975','2012-12-22','09:15:00',2.21),('8975','2012-12-22','09:20:00',2.22),('8975','2012-12-22','09:25:00',2.3),('8975','2012-12-22','09:30:00',2.34),('8975','2012-12-22','09:35:00',2.46),('8975','2012-12-22','09:40:00',2.51),('8975','2012-12-22','09:45:00',2.57),('8975','2012-12-22','09:50:00',2.58),('8975','2012-12-22','09:55:00',2.6),('8975','2012-12-22','10:00:00',2.61),('8975','2012-12-22','10:05:00',2.65),('8975','2012-12-22','10:10:00',2.7),('8975','2012-12-22','10:15:00',2.71),('8975','2012-12-22','10:20:00',2.6),('8975','2012-12-22','10:25:00',2.63),('8975','2012-12-22','10:30:00',2.58),('8975','2012-12-22','10:35:00',2.68),('8975','2012-12-22','10:40:00',2.76),('8975','2012-12-22','10:45:00',2.76),('8975','2012-12-22','10:50:00',2.75),('8975','2012-12-22','10:55:00',2.7),('8975','2012-12-22','11:00:00',2.83),('8975','2012-12-22','11:05:00',2.86),('8975','2012-12-22','11:10:00',2.86),('8975','2012-12-22','11:15:00',2.88),('8975','2012-12-22','11:20:00',2.9),('8975','2012-12-22','11:25:00',2.71),('8975','2012-12-22','11:30:00',2.49),('8975','2012-12-22','11:35:00',2.72),('8975','2012-12-22','11:40:00',2.76),('8975','2012-12-22','11:45:00',2.69),('8975','2012-12-22','11:50:00',2.69),('8975','2012-12-22','11:55:00',2.65),('8975','2012-12-22','12:00:00',2.41),('8975','2012-12-22','12:05:00',2.39),('8975','2012-12-22','12:10:00',2.39),('8975','2012-12-22','12:15:00',1.91),('8975','2012-12-22','12:20:00',2.29),('8975','2012-12-22','12:25:00',1.69),('8975','2012-12-22','12:30:00',1.43),('8975','2012-12-22','12:35:00',1.64),('8975','2012-12-22','12:40:00',1.85),('8975','2012-12-22','12:45:00',1.38),('8975','2012-12-22','12:50:00',1.42),('8975','2012-12-22','12:55:00',2.33),('8975','2012-12-22','13:00:00',2.19),('8975','2012-12-22','13:05:00',1.68),('8975','2012-12-22','13:10:00',1.86),('8975','2012-12-22','13:15:00',2.36),('8975','2012-12-22','13:20:00',1.74),('8975','2012-12-22','13:25:00',1.42),('8975','2012-12-22','13:30:00',1.44),('8975','2012-12-22','13:35:00',1.43),('8975','2012-12-22','13:40:00',1.28),('8975','2012-12-22','13:45:00',1.23),('8975','2012-12-22','13:50:00',1.21),('8975','2012-12-22','13:55:00',1.26),('8975','2012-12-22','14:00:00',1.79),('8975','2012-12-22','14:05:00',1.6),('8975','2012-12-22','14:10:00',1.36),('8975','2012-12-22','14:15:00',1.4),('8975','2012-12-22','14:20:00',1.16),('8975','2012-12-22','14:35:00',1.16),('8975','2012-12-22','14:40:00',1.27),('8975','2012-12-22','14:45:00',1.32),('8975','2012-12-22','14:50:00',1.02),('8975','2014-04-30','07:40:00',1.57),('8975','2014-04-30','07:45:00',2.48),('8975','2014-04-30','07:50:00',3.19),('8975','2014-04-30','07:55:00',3.41),('8975','2014-04-30','08:00:00',3.73),('8975','2014-04-30','08:05:00',3.82),('8975','2014-04-30','08:10:00',3.85),('8975','2014-04-30','08:15:00',3.87),('8975','2014-04-30','08:20:00',3.93),('8975','2014-04-30','08:25:00',4.06),('8975','2014-04-30','08:30:00',4.17),('8975','2014-04-30','08:35:00',4.12),('8975','2014-04-30','08:40:00',4.37),('8975','2014-04-30','08:45:00',4.5),('8975','2014-04-30','08:50:00',4.62),('8975','2014-04-30','08:55:00',4.92),('8975','2014-04-30','09:00:00',4.11),('8975','2014-04-30','09:05:00',4.01),('8975','2014-04-30','09:10:00',3.59),('8975','2014-04-30','09:15:00',5.41),('8975','2014-04-30','09:20:00',5.53),('8975','2014-04-30','09:25:00',5.39),('8975','2014-04-30','09:30:00',4.13),('8975','2014-04-30','09:35:00',4.87),('8975','2014-04-30','09:40:00',3.59),('8975','2014-04-30','09:45:00',5.54),('8975','2014-04-30','09:50:00',3.55),('8975','2014-04-30','09:55:00',1.94),('8975','2014-04-30','10:00:00',1.64),('8975','2014-04-30','10:05:00',1.95),('8975','2014-04-30','10:10:00',2.72),('8975','2014-04-30','10:15:00',4.48),('8975','2014-04-30','10:20:00',4.31),('8975','2014-04-30','10:25:00',6.15),('8975','2014-04-30','10:30:00',7.17),('8975','2014-04-30','10:35:00',6.8),('8975','2014-04-30','10:40:00',7.18),('8975','2014-04-30','10:45:00',5.56),('8975','2014-04-30','10:50:00',4.3),('8975','2014-04-30','10:55:00',4.68),('8975','2014-04-30','11:00:00',5.41),('8975','2014-04-30','11:05:00',7.36),('8975','2014-04-30','11:10:00',7.44),('8975','2014-04-30','11:15:00',4.74),('8975','2014-04-30','11:20:00',4.19),('8975','2014-04-30','11:25:00',3.94),('8975','2014-04-30','11:30:00',6.75),('8975','2014-04-30','11:35:00',7.69),('8975','2014-04-30','11:40:00',5.41),('8975','2014-04-30','11:45:00',3.15),('8975','2014-04-30','11:50:00',5.17),('8975','2014-04-30','11:55:00',5.52),('8975','2014-04-30','12:00:00',7.69),('8975','2014-04-30','12:05:00',7.4),('8975','2014-04-30','12:10:00',7.45),('8975','2014-04-30','12:15:00',7.53),('8975','2014-04-30','12:20:00',7.52),('8975','2014-04-30','12:25:00',3.51),('8975','2014-04-30','12:30:00',1.92),('8975','2014-04-30','12:35:00',2.73),('8975','2014-04-30','12:40:00',5.97),('8975','2014-04-30','12:45:00',7.97),('8975','2014-04-30','12:50:00',7.56),('8975','2014-04-30','12:55:00',7.15),('8975','2014-04-30','13:00:00',7.28),('8975','2014-04-30','13:05:00',7.08),('8975','2014-04-30','13:10:00',7.05),('8975','2014-04-30','13:15:00',7.02),('8975','2014-04-30','13:20:00',7.14),('8975','2014-04-30','13:25:00',7.44),('8975','2014-04-30','13:30:00',6.85),('8975','2014-04-30','13:35:00',7.21),('8975','2014-04-30','13:40:00',6.59),('8975','2014-04-30','13:45:00',7.05),('8975','2014-04-30','13:50:00',7.19),('8975','2014-04-30','13:55:00',6.81),('8975','2014-04-30','14:00:00',6.76),('8975','2014-04-30','14:05:00',6.66),('8975','2014-04-30','14:10:00',6.75),('8975','2014-04-30','14:15:00',6.55),('8975','2014-04-30','14:20:00',6.49),('8975','2014-04-30','14:25:00',6.24),('8975','2014-04-30','14:30:00',6.07),('8975','2014-04-30','14:35:00',6.1),('8975','2014-04-30','14:40:00',6.27),('8975','2014-04-30','14:45:00',6.26),('8975','2014-04-30','14:50:00',6.08),('8975','2014-04-30','14:55:00',6.18),('8975','2014-04-30','15:00:00',5.57),('8975','2014-04-30','15:05:00',5.98),('8975','2014-04-30','15:10:00',5.69),('8975','2014-04-30','15:15:00',5.41),('8975','2014-04-30','15:20:00',5.39),('8975','2014-04-30','15:25:00',5.25),('8975','2014-04-30','15:30:00',5.01),('8975','2014-04-30','15:35:00',4.84),('8975','2014-04-30','15:40:00',4.73),('8975','2014-04-30','15:45:00',4.67),('8975','2014-04-30','15:50:00',4.52),('8975','2014-04-30','15:55:00',4.29),('8975','2014-04-30','16:00:00',4.26),('8975','2014-04-30','16:05:00',4.28),('8975','2014-04-30','16:10:00',4.03),('8975','2014-04-30','16:15:00',3.87),('8975','2014-04-30','16:20:00',3.79),('8975','2014-04-30','16:25:00',3.49),('8975','2014-04-30','16:30:00',3.64),('8975','2014-04-30','16:35:00',3.62),('8975','2014-04-30','16:40:00',3.31),('8975','2014-04-30','16:45:00',2.84),('8975','2014-04-30','16:50:00',2.38),('8975','2014-04-30','16:55:00',3.03),('8975','2014-04-30','17:00:00',2.87),('8975','2014-04-30','17:05:00',2.37),('8975','2014-04-30','17:10:00',2.56),('8975','2014-04-30','17:15:00',2.46),('8975','2014-04-30','17:20:00',2.34),('8975','2014-04-30','17:25:00',2.24),('8975','2014-04-30','17:30:00',2.12),('8975','2014-04-30','17:35:00',2),('8975','2014-04-30','17:40:00',1.87),('8975','2014-04-30','17:45:00',1.8),('8975','2014-04-30','17:50:00',1.74),('8975','2014-04-30','17:55:00',1.69),('8975','2014-04-30','18:00:00',1.64),('8975','2014-04-30','18:05:00',1.55),('8975','2014-04-30','18:10:00',1.5),('8975','2014-04-30','18:15:00',1.44),('8975','2014-04-30','18:20:00',1.37),('8975','2014-04-30','18:25:00',1.33),('8975','2014-04-30','18:30:00',1.3),('8975','2014-04-30','18:35:00',1.22),('8975','2014-04-30','18:40:00',1.15),('8975','2014-04-30','18:45:00',1.08),('8975','2014-03-16','08:40:00',1.1),('8975','2014-03-16','08:45:00',1.22),('8975','2014-03-16','08:50:00',1.45),('8975','2014-03-16','08:55:00',1.46),('8975','2014-03-16','09:00:00',1.86),('8975','2014-03-16','09:05:00',1.83),('8975','2014-03-16','09:10:00',1.81),('8975','2014-03-16','09:15:00',2.02),('8975','2014-03-16','09:20:00',2.32),('8975','2014-03-16','09:25:00',2.1),('8975','2014-03-16','09:30:00',2.2),('8975','2014-03-16','09:35:00',2.26),('8975','2014-03-16','09:40:00',2.49),('8975','2014-03-16','09:45:00',2.49),('8975','2014-03-16','09:50:00',2.76),('8975','2014-03-16','09:55:00',2.72),('8975','2014-03-16','10:00:00',2.69),('8975','2014-03-16','10:05:00',2.59),('8975','2014-03-16','10:10:00',2.89),('8975','2014-03-16','10:15:00',3.89),('8975','2014-03-16','10:20:00',2.69),('8975','2014-03-16','10:25:00',2.31),('8975','2014-03-16','10:30:00',2.05),('8975','2014-03-16','10:35:00',1.93),('8975','2014-03-16','10:40:00',2.07),('8975','2014-03-16','10:45:00',2.62),('8975','2014-03-16','10:50:00',2.5),('8975','2014-03-16','10:55:00',2.87),('8975','2014-03-16','11:00:00',2.74),('8975','2014-03-16','11:05:00',2.87),('8975','2014-03-16','11:10:00',2.63),('8975','2014-03-16','11:15:00',2.29),('8975','2014-03-16','11:20:00',2.29),('8975','2014-03-16','11:25:00',2.72),('8975','2014-03-16','11:30:00',2.56),('8975','2014-03-16','11:35:00',2.15),('8975','2014-03-16','11:40:00',1.9),('8975','2014-03-16','11:45:00',2.03),('8975','2014-03-16','11:50:00',2.16),('8975','2014-03-16','11:55:00',2.55),('8975','2014-03-16','12:00:00',2.56),('8975','2014-03-16','12:05:00',2.23),('8975','2014-03-16','12:10:00',2.19),('8975','2014-03-16','12:15:00',3.63),('8975','2014-03-16','12:20:00',2.14),('8975','2014-03-16','12:25:00',2.2),('8975','2014-03-16','12:30:00',2.39),('8975','2014-03-16','12:35:00',2.81),('8975','2014-03-16','12:40:00',4.6),('8975','2014-03-16','12:45:00',4.04),('8975','2014-03-16','12:50:00',5.63),('8975','2014-03-16','12:55:00',5.45),('8975','2014-03-16','13:00:00',5.38),('8975','2014-03-16','13:05:00',5.41),('8975','2014-03-16','13:10:00',5),('8975','2014-03-16','13:15:00',4.44),('8975','2014-03-16','13:20:00',4.25),('8975','2014-03-16','13:25:00',4.12),('8975','2014-03-16','13:30:00',4.47),('8975','2014-03-16','13:35:00',4.54),('8975','2014-03-16','13:40:00',4.26),('8975','2014-03-16','13:45:00',4.15),('8975','2014-03-16','13:50:00',3.81),('8975','2014-03-16','13:55:00',4.36),('8975','2014-03-16','14:00:00',2.91),('8975','2014-03-16','14:05:00',3.73),('8975','2014-03-16','14:10:00',4.14),('8975','2014-03-16','14:15:00',4.03),('8975','2014-03-16','14:20:00',3.89),('8975','2014-03-16','14:25:00',3.76),('8975','2014-03-16','14:30:00',3.54),('8975','2014-03-16','14:35:00',3.39),('8975','2014-03-16','14:40:00',3.19),('8975','2014-03-16','14:45:00',3.15),('8975','2014-03-16','14:50:00',3.05),('8975','2014-03-16','14:55:00',2.92),('8975','2014-03-16','15:00:00',2.86),('8975','2014-03-16','15:05:00',2.86),('8975','2014-03-16','15:10:00',2.71),('8975','2014-03-16','15:15:00',2.48),('8975','2014-03-16','15:20:00',2.5),('8975','2014-03-16','15:25:00',2.33),('8975','2014-03-16','15:30:00',1.72),('8975','2014-03-16','15:35:00',2.04),('8975','2014-03-16','15:40:00',2.07),('8975','2014-03-16','15:45:00',1.94),('8975','2014-03-16','15:50:00',1.88),('8975','2014-03-16','15:55:00',1.83),('8975','2014-03-16','16:00:00',1.44),('8975','2014-03-16','16:15:00',1.21),('8975','2014-03-16','16:20:00',1.47),('8975','2014-03-16','16:26:00',1.34),('8975','2012-12-21','09:30:00',1.12),('8975','2012-12-21','09:35:00',1.26),('8975','2012-12-21','09:40:00',1.35),('8975','2012-12-21','09:45:00',1.05),('8975','2012-12-21','09:50:00',1.03),('8975','2012-12-21','09:55:00',1.13),('8975','2012-12-21','10:00:00',1.17),('8975','2012-12-21','10:05:00',1.17),('8975','2012-12-21','10:10:00',1.23),('8975','2012-12-21','10:15:00',1.25),('8975','2012-12-21','10:20:00',1.19),('8975','2012-12-21','10:25:00',1.3),('8975','2012-12-21','10:30:00',1.32),('8975','2012-12-21','10:35:00',3.02),('8975','2012-12-21','10:40:00',3.36),('8975','2012-12-21','10:45:00',3.32),('8975','2012-12-21','10:50:00',3.18),('8975','2012-12-21','10:55:00',2.85),('8975','2012-12-21','11:00:00',1.19),('8975','2012-12-21','11:20:00',1.53),('8975','2012-12-21','11:25:00',1.2),('8975','2012-12-21','11:30:00',1.43),('8975','2012-12-21','11:35:00',1.45),('8975','2012-12-21','11:40:00',3.41),('8975','2012-12-21','11:45:00',2.98),('8975','2012-12-21','11:50:00',2.86),('8975','2012-12-21','11:55:00',1.94),('8975','2012-12-21','12:00:00',2.17),('8975','2012-12-21','12:05:00',2.16),('8975','2012-12-21','12:10:00',2.11),('8975','2012-12-21','12:15:00',2.91),('8975','2012-12-21','12:20:00',2.33),('8975','2012-12-21','12:25:00',2.06),('8975','2012-12-21','12:30:00',2.86),('8975','2012-12-21','12:35:00',3.1),('8975','2012-12-21','12:40:00',3.04),('8975','2012-12-21','12:45:00',3.07),('8975','2012-12-21','12:50:00',3.09),('8975','2012-12-21','12:55:00',2.47),('8975','2012-12-21','13:00:00',2.38),('8975','2012-12-21','13:05:00',2.06),('8975','2012-12-21','13:10:00',1.89),('8975','2012-12-21','13:15:00',2.31),('8975','2012-12-21','13:20:00',2.42),('8975','2012-12-21','13:25:00',2.59),('8975','2012-12-21','13:30:00',2.13),('8975','2012-12-21','13:35:00',1.45),('8975','2012-12-21','13:40:00',1.34),('8975','2012-12-21','13:45:00',1.19),('8975','2012-12-21','13:50:00',1.21),('8975','2012-12-21','13:55:00',1.36),('8975','2012-12-21','14:00:00',1.27),('8975','2012-12-21','14:05:00',1.2),('8975','2012-12-21','14:20:00',1.2),('8975','2014-03-15','07:10:00',1.17),('8975','2014-03-15','07:15:00',1.24),('8975','2014-03-15','07:20:00',1.38),('8975','2014-03-15','07:28:00',1.51),('8975','2014-03-15','07:30:00',1.64),('8975','2014-03-15','07:35:00',1.68),('8975','2014-03-15','07:41:00',1.71),('8975','2014-03-15','07:45:00',1.86),('8975','2014-03-15','07:50:00',1.9),('8975','2014-03-15','07:55:00',2.26),('8975','2014-03-15','08:00:00',2.38),('8975','2014-03-15','08:05:00',2.57),('8975','2014-03-15','08:11:00',2.6),('8975','2014-03-15','08:15:00',2.63),('8975','2014-03-15','08:20:00',2.71),('8975','2014-03-15','08:25:00',2.91),('8975','2014-03-15','08:30:00',3.06),('8975','2014-03-15','08:35:00',3.16),('8975','2014-03-15','08:40:00',3.24),('8975','2014-03-15','08:45:00',3.36),('8975','2014-03-15','08:50:00',3.4),('8975','2014-03-15','08:55:00',3.5),('8975','2014-03-15','09:00:00',3.45),('8975','2014-03-15','09:05:00',3.55),('8975','2014-03-15','09:10:00',3.72),('8975','2014-03-15','09:15:00',4.08),('8975','2014-03-15','09:20:00',3.99),('8975','2014-03-15','09:25:00',4.03),('8975','2014-03-15','09:30:00',4.05),('8975','2014-03-15','09:35:00',4.04),('8975','2014-03-15','09:40:00',3.98),('8975','2014-03-15','09:45:00',4.33),('8975','2014-03-15','09:50:00',4.57),('8975','2014-03-15','09:55:00',4.53),('8975','2014-03-15','10:00:00',4.58),('8975','2014-03-15','10:05:00',4.62),('8975','2014-03-15','10:10:00',4.66),('8975','2014-03-15','10:15:00',4.82),('8975','2014-03-15','10:20:00',4.84),('8975','2014-03-15','10:25:00',4.84),('8975','2014-03-15','10:30:00',4.78),('8975','2014-03-15','10:35:00',4.75),('8975','2014-03-15','10:40:00',4.85),('8975','2014-03-15','10:45:00',4.94),('8975','2014-03-15','10:50:00',4.33),('8975','2014-03-15','10:55:00',3.71),('8975','2014-03-15','11:00:00',5.04),('8975','2014-03-15','11:05:00',4.41),('8975','2014-03-15','11:10:00',4.27),('8975','2014-03-15','11:15:00',4.82),('8975','2014-03-15','11:20:00',5.13),('8975','2014-03-15','11:25:00',5.01),('8975','2014-03-15','11:30:00',5.16),('8975','2014-03-15','11:35:00',5.09),('8975','2014-03-15','11:40:00',5.17),('8975','2014-03-15','11:45:00',5.03),('8975','2014-03-15','11:50:00',5.06),('8975','2014-03-15','11:55:00',4.98),('8975','2014-03-15','12:00:00',3.66),('8975','2014-03-15','12:05:00',4.68),('8975','2014-03-15','12:10:00',4.59),('8975','2014-03-15','12:15:00',4.91),('8975','2014-03-15','12:20:00',4.85),('8975','2014-03-15','12:25:00',4.88),('8975','2014-03-15','12:30:00',4.88),('8975','2014-03-15','12:35:00',4.79),('8975','2014-03-15','12:40:00',4.79),('8975','2014-03-15','12:45:00',4.69),('8975','2014-03-15','12:50:00',4.62),('8975','2014-03-15','12:55:00',4.58),('8975','2014-03-15','13:00:00',4.26),('8975','2014-03-15','13:05:00',4.51),('8975','2014-03-15','13:10:00',4.47),('8975','2014-03-15','13:15:00',4.36),('8975','2014-03-15','13:20:00',4.14),('8975','2014-03-15','13:25:00',4.14),('8975','2014-03-15','13:30:00',4.09),('8975','2014-03-15','13:35:00',4.23),('8975','2014-03-15','13:40:00',4.27),('8975','2014-03-15','13:45:00',4.19),('8975','2014-03-15','13:50:00',4.03),('8975','2014-03-15','13:55:00',3.91),('8975','2014-03-15','14:00:00',3.78),('8975','2014-03-15','14:05:00',3.5),('8975','2014-03-15','14:10:00',3.42),('8975','2014-03-15','14:15:00',3.37),('8975','2014-03-15','14:20:00',3.39),('8975','2014-03-15','14:25:00',3.33),('8975','2014-03-15','14:30:00',3.3),('8975','2014-03-15','14:35:00',3.16),('8975','2014-03-15','14:40:00',3),('8975','2014-03-15','14:45:00',2.98),('8975','2014-03-15','14:50:00',2.83),('8975','2014-03-15','14:55:00',2.78),('8975','2014-03-15','15:00:00',2.67),('8975','2014-03-15','15:05:00',2.78),('8975','2014-03-15','15:10:00',2.86),('8975','2014-03-15','15:15:00',2.5),('8975','2014-03-15','15:20:00',2.22),('8975','2014-03-15','15:25:00',2.22),('8975','2014-03-15','15:30:00',2.12),('8975','2014-03-15','15:35:00',2.04),('8975','2014-03-15','15:40:00',1.64),('8975','2014-03-15','15:45:00',1.52),('8975','2014-03-15','15:50:00',1.61),('8975','2014-03-15','15:55:00',1.5),('8975','2014-03-15','16:00:00',1.34),('8975','2014-03-15','16:05:00',1.46),('8975','2014-03-15','16:10:00',1.41),('8975','2014-03-15','16:15:00',1.58),('8975','2014-03-15','16:20:00',1.52),('8975','2014-03-15','16:25:00',1.5),('8975','2014-03-15','16:30:00',1.54),('8975','2014-03-15','16:35:00',1.48),('8975','2014-03-15','16:40:00',1.38),('8975','2014-03-15','16:45:00',1.19),('8975','2014-03-15','16:50:00',1.11),('8975','2014-03-14','07:15:00',1.02),('8975','2014-03-14','07:20:00',1.14),('8975','2014-03-14','07:25:00',1.3),('8975','2014-03-14','07:30:00',1.46),('8975','2014-03-14','07:35:00',1.58),('8975','2014-03-14','07:40:00',1.72),('8975','2014-03-14','07:45:00',1.86),('8975','2014-03-14','07:50:00',2.02),('8975','2014-03-14','07:55:00',2.16),('8975','2014-03-14','08:00:00',2.3),('8975','2014-03-14','08:05:00',2.44),('8975','2014-03-14','08:10:00',2.57),('8975','2014-03-14','08:15:00',2.68),('8975','2014-03-14','08:20:00',2.82),('8975','2014-03-14','08:25:00',2.92),('8975','2014-03-14','08:30:00',3.02),('8975','2014-03-14','08:35:00',3.12),('8975','2014-03-14','08:40:00',3.2),('8975','2014-03-14','08:45:00',3.3),('8975','2014-03-14','08:50:00',3.38),('8975','2014-03-14','08:55:00',3.46),('8975','2014-03-14','09:00:00',3.56),('8975','2014-03-14','09:05:00',3.66),('8975','2014-03-14','09:10:00',3.75),('8975','2014-03-14','09:15:00',3.81),('8975','2014-03-14','09:20:00',3.93),('8975','2014-03-14','09:25:00',4.04),('8975','2014-03-14','09:30:00',4.11),('8975','2014-03-14','09:35:00',4.21),('8975','2014-03-14','09:40:00',4.27),('8975','2014-03-14','09:45:00',4.32),('8975','2014-03-14','09:50:00',4.36),('8975','2014-03-14','09:55:00',4.46),('8975','2014-03-14','10:00:00',4.51),('8975','2014-03-14','10:05:00',4.51),('8975','2014-03-14','10:10:00',4.58),('8975','2014-03-14','10:15:00',4.63),('8975','2014-03-14','10:20:00',4.65),('8975','2014-03-14','10:25:00',4.76),('8975','2014-03-14','10:30:00',4.75),('8975','2014-03-14','10:35:00',4.77),('8975','2014-03-14','10:40:00',4.82),('8975','2014-03-14','10:45:00',4.85),('8975','2014-03-14','10:50:00',4.9),('8975','2014-03-14','10:55:00',4.97),('8975','2014-03-14','11:00:00',5.03),('8975','2014-03-14','11:05:00',4.97),('8975','2014-03-14','11:10:00',5.08),('8975','2014-03-14','11:15:00',5.12),('8975','2014-03-14','11:20:00',5.08),('8975','2014-03-14','11:25:00',5.17),('8975','2014-03-14','11:30:00',5.08),('8975','2014-03-14','11:35:00',5.08),('8975','2014-03-14','11:40:00',5.18),('8975','2014-03-14','11:45:00',5.08),('8975','2014-03-14','11:50:00',5.07),('8975','2014-03-14','11:55:00',5.09),('8975','2014-03-14','12:00:00',5.06),('8975','2014-03-14','12:05:00',5.09),('8975','2014-03-14','12:10:00',5.04),('8975','2014-03-14','12:15:00',4.91),('8975','2014-03-14','12:20:00',4.87),('8975','2014-03-14','12:25:00',4.93),('8975','2014-03-14','12:30:00',5.05),('8975','2014-03-14','12:35:00',4.93),('8975','2014-03-14','12:40:00',4.86),('8975','2014-03-14','12:45:00',4.86),('8975','2014-03-14','12:50:00',4.76),('8975','2014-03-14','12:55:00',4.74),('8975','2014-03-14','13:00:00',4.68),('8975','2014-03-14','13:05:00',4.68),('8975','2014-03-14','13:10:00',4.61),('8975','2014-03-14','13:15:00',4.46),('8975','2014-03-14','13:20:00',4.46),('8975','2014-03-14','13:25:00',4.38),('8975','2014-03-14','13:30:00',4.16),('8975','2014-03-14','13:35:00',4.21),('8975','2014-03-14','13:40:00',4.22),('8975','2014-03-14','13:45:00',4.13),('8975','2014-03-14','13:50:00',4.05),('8975','2014-03-14','13:55:00',4),('8975','2014-03-14','14:00:00',3.87),('8975','2014-03-14','14:05:00',3.76),('8975','2014-03-14','14:10:00',3.67),('8975','2014-03-14','14:15:00',3.42),('8975','2014-03-14','14:20:00',3.49),('8975','2014-03-14','14:25:00',3.37),('8975','2014-03-14','14:30:00',3.28),('8975','2014-03-14','14:35:00',3.24),('8975','2014-03-14','14:40:00',3.06),('8975','2014-03-14','14:45:00',2.98),('8975','2014-03-14','14:50:00',2.97),('8975','2014-03-14','14:55:00',2.86),('8975','2014-03-14','15:00:00',2.78),('8975','2014-03-14','15:05:00',2.69),('8975','2014-03-14','15:10:00',2.52),('8975','2014-03-14','15:15:00',2.39),('8975','2014-03-14','15:20:00',2.34),('8975','2014-03-14','15:25:00',2.25),('8975','2014-03-14','15:30:00',2.15),('8975','2014-03-14','15:35:00',2.02),('8975','2014-03-14','15:40:00',1.94),('8975','2014-03-14','15:45:00',1.87),('8975','2014-03-14','15:51:00',1.83),('8975','2014-03-14','15:55:00',1.72),('8975','2014-03-14','16:00:00',1.67),('8975','2014-03-14','16:05:00',1.58),('8975','2014-03-14','16:10:00',1.54),('8975','2014-03-14','16:15:00',1.46),('8975','2014-03-14','16:20:00',1.4),('8975','2014-03-14','16:25:00',1.29),('8975','2014-03-14','16:30:00',1.22),('8975','2014-03-14','16:35:00',1.18),('8975','2014-03-14','16:40:00',1.15),('8975','2014-03-14','16:45:00',1.09),('8975','2014-03-14','16:50:00',1.03),('8975','2014-03-13','07:45:00',1.05),('8975','2014-03-13','07:50:00',1.15),('8975','2014-03-13','07:55:00',1.24),('8975','2014-03-13','08:00:00',1.33),('8975','2014-03-13','08:05:00',1.45),('8975','2014-03-13','08:10:00',1.65),('8975','2014-03-13','08:15:00',1.83),('8975','2014-03-13','08:20:00',1.95),('8975','2014-03-13','08:25:00',2.1),('8975','2014-03-13','08:30:00',2.15),('8975','2014-03-13','08:35:00',2),('8975','2014-03-13','08:40:00',1.73),('8975','2014-03-13','08:45:00',1.63),('8975','2014-03-13','08:50:00',1.66),('8975','2014-03-13','08:55:00',1.77),('8975','2014-03-13','09:00:00',1.98),('8975','2014-03-13','09:05:00',2.27),('8975','2014-03-13','09:10:00',2.43),('8975','2014-03-13','09:15:00',2.42),('8975','2014-03-13','09:20:00',2.5),('8975','2014-03-13','09:25:00',2.58),('8975','2014-03-13','09:30:00',2.77),('8975','2014-03-13','09:35:00',3.4),('8975','2014-03-13','09:40:00',4.04),('8975','2014-03-13','09:45:00',4.89),('8975','2014-03-13','09:50:00',5.39),('8975','2014-03-13','09:55:00',5.6),('8975','2014-03-13','10:00:00',5.7),('8975','2014-03-13','10:05:00',5.57),('8975','2014-03-13','10:10:00',5.43),('8975','2014-03-13','10:15:00',5.32),('8975','2014-03-13','10:20:00',4.98),('8975','2014-03-13','10:25:00',4.89),('8975','2014-03-13','10:30:00',4.99),('8975','2014-03-13','10:35:00',5.23),('8975','2014-03-13','10:40:00',5.03),('8975','2014-03-13','10:45:00',3.62),('8975','2014-03-13','10:50:00',3.37),('8975','2014-03-13','10:55:00',4.72),('8975','2014-03-13','11:00:00',4.95),('8975','2014-03-13','11:05:00',5.25),('8975','2014-03-13','11:10:00',5.51),('8975','2014-03-13','11:15:00',5.44),('8975','2014-03-13','11:20:00',5.35),('8975','2014-03-13','11:25:00',5.29),('8975','2014-03-13','11:30:00',5.45),('8975','2014-03-13','11:35:00',5.4),('8975','2014-03-13','11:40:00',5.45),('8975','2014-03-13','11:45:00',5.56),('8975','2014-03-13','11:50:00',5.57),('8975','2014-03-13','11:55:00',5.52),('8975','2014-03-13','12:00:00',5.41),('8975','2014-03-13','12:05:00',5.37),('8975','2014-03-13','12:10:00',4.96),('8975','2014-03-13','12:15:00',4.23),('8975','2014-03-13','12:20:00',3.39),('8975','2014-03-13','12:25:00',3),('8975','2014-03-13','12:30:00',2.42),('8975','2014-03-13','12:35:00',2.72),('8975','2014-03-13','12:40:00',3.93),('8975','2014-03-13','12:45:00',4.67),('8975','2014-03-13','12:50:00',3.92),('8975','2014-03-13','12:55:00',4.01),('8975','2014-03-13','13:00:00',2.77),('8975','2014-03-13','13:05:00',3.24),('8975','2014-03-13','13:10:00',3.26),('8975','2014-03-13','13:15:00',3.92),('8975','2014-03-13','13:20:00',3.77),('8975','2014-03-13','13:25:00',3.33),('8975','2014-03-13','13:30:00',3.34),('8975','2014-03-13','13:35:00',2.92),('8975','2014-03-13','13:40:00',3.18),('8975','2014-03-13','13:45:00',3.27),('8975','2014-03-13','13:50:00',3.31),('8975','2014-03-13','13:55:00',3.35),('8975','2014-03-13','14:00:00',3.82),('8975','2014-03-13','14:05:00',3.84),('8975','2014-03-13','14:10:00',3.55),('8975','2014-03-13','14:15:00',3.65),('8975','2014-03-13','14:20:00',3.72),('8975','2014-03-13','14:25:00',3.35),('8975','2014-03-13','14:30:00',3.08),('8975','2014-03-13','14:35:00',2.8),('8975','2014-03-13','14:40:00',2.31),('8975','2014-03-13','14:45:00',2.12),('8975','2014-03-13','14:50:00',2.06),('8975','2014-03-13','14:55:00',1.93),('8975','2014-03-13','15:00:00',1.88),('8975','2014-03-13','15:05:00',1.83),('8975','2014-03-13','15:10:00',1.69),('8975','2014-03-13','15:15:00',1.63),('8975','2014-03-13','15:20:00',1.67),('8975','2014-03-13','15:25:00',1.73),('8975','2014-03-13','15:30:00',2.08),('8975','2014-03-13','15:35:00',2.15),('8975','2014-03-13','15:40:00',1.83),('8975','2014-03-13','15:45:00',1.57),('8975','2014-03-13','15:50:00',1.58),('8975','2014-03-13','15:55:00',1.52),('8975','2014-03-13','16:00:00',1.45),('8975','2014-03-13','16:05:00',1.38),('8975','2014-03-13','16:10:00',1.25),('8975','2014-03-13','16:15:00',1.13),('8975','2014-03-13','16:20:00',1.03),('8975','2014-03-12','07:09:00',1.31),('8975','2014-03-12','07:10:00',1.54),('8975','2014-03-12','07:15:00',1.69),('8975','2014-03-12','07:20:00',1.86),('8975','2014-03-12','07:28:00',2.04),('8975','2014-03-12','07:30:00',2.3),('8975','2014-03-12','07:35:00',2.4),('8975','2014-03-12','07:41:00',2.51),('8975','2014-03-12','07:45:00',2.67),('8975','2014-03-12','07:50:00',2.77),('8975','2014-03-12','07:55:00',2.91),('8975','2014-03-12','08:00:00',3),('8975','2014-03-12','08:05:00',3.12),('8975','2014-03-12','08:10:00',3.21),('8975','2014-03-12','08:15:00',3.33),('8975','2014-03-12','08:20:00',3.4),('8975','2014-03-12','08:25:00',3.52),('8975','2014-03-12','08:30:00',3.58),('8975','2014-03-12','08:35:00',3.69),('8975','2014-03-12','08:40:00',3.76),('8975','2014-03-12','08:45:00',3.88),('8975','2014-03-12','08:50:00',3.95),('8975','2014-03-12','08:55:00',4.04),('8975','2014-03-12','09:00:00',4.11),('8975','2014-03-12','09:05:00',4.23),('8975','2014-03-12','09:10:00',4.3),('8975','2014-03-12','09:15:00',4.41),('8975','2014-03-12','09:20:00',4.48),('8975','2014-03-12','09:25:00',4.55),('8975','2014-03-12','09:30:00',4.63),('8975','2014-03-12','09:35:00',4.69),('8975','2014-03-12','09:40:00',4.71),('8975','2014-03-12','09:45:00',4.82),('8975','2014-03-12','09:50:00',4.87),('8975','2014-03-12','09:55:00',4.96),('8975','2014-03-12','10:00:00',5.03),('8975','2014-03-12','10:05:00',5.12),('8975','2014-03-12','10:10:00',5.17),('8975','2014-03-12','10:15:00',5.2),('8975','2014-03-12','10:20:00',5.24),('8975','2014-03-12','10:25:00',5.25),('8975','2014-03-12','10:30:00',5.29),('8975','2014-03-12','10:35:00',5.34),('8975','2014-03-12','10:40:00',5.37),('8975','2014-03-12','10:45:00',5.38),('8975','2014-03-12','10:50:00',5.39),('8975','2014-03-12','10:55:00',5.42),('8975','2014-03-12','11:00:00',5.43),('8975','2014-03-12','11:05:00',5.44),('8975','2014-03-12','11:10:00',5.45),('8975','2014-03-12','11:15:00',5.21),('8975','2014-03-12','11:20:00',5.34),('8975','2014-03-12','11:25:00',5.44),('8975','2014-03-12','11:30:00',5.46),('8975','2014-03-12','11:35:00',4.97),('8975','2014-03-12','11:40:00',5.34),('8975','2014-03-12','11:45:00',4.55),('8975','2014-03-12','11:50:00',5.24),('8975','2014-03-12','11:55:00',4.96),('8975','2014-03-12','12:00:00',4.88),('8975','2014-03-12','12:05:00',4.78),('8975','2014-03-12','12:10:00',4.75),('8975','2014-03-12','12:15:00',5.25),('8975','2014-03-12','12:20:00',5.21),('8975','2014-03-12','12:25:00',5.18),('8975','2014-03-12','12:30:00',5.13),('8975','2014-03-12','12:35:00',5.07),('8975','2014-03-12','12:40:00',5),('8975','2014-03-12','12:45:00',4.93),('8975','2014-03-12','12:50:00',4.89),('8975','2014-03-12','12:55:00',4.84),('8975','2014-03-12','13:00:00',4.75),('8975','2014-03-12','13:05:00',4.67),('8975','2014-03-12','13:10:00',4.54),('8975','2014-03-12','13:15:00',4.35),('8975','2014-03-12','13:20:00',4.45),('8975','2014-03-12','13:25:00',4.25),('8975','2014-03-12','13:30:00',3.97),('8975','2014-03-12','13:35:00',4.21),('8975','2014-03-12','13:40:00',4.19),('8975','2014-03-12','13:45:00',4.11),('8975','2014-03-12','13:50:00',3.99),('8975','2014-03-12','13:55:00',3.85),('8975','2014-03-12','14:00:00',3.67),('8975','2014-03-12','14:05:00',3.64),('8975','2014-03-12','14:10:00',3.4),('8975','2014-03-12','14:15:00',3.4),('8975','2014-03-12','14:20:00',3.39),('8975','2014-03-12','14:25:00',3.34),('8975','2014-03-12','14:30:00',3.2),('8975','2014-03-12','14:35:00',3.07),('8975','2014-03-12','14:40:00',2.91),('8975','2014-03-12','14:45:00',2.91),('8975','2014-03-12','14:50:00',2.86),('8975','2014-03-12','14:55:00',2.78),('8975','2014-03-12','15:00:00',2.69),('8975','2014-03-12','15:05:00',2.59),('8975','2014-03-12','15:10:00',2.47),('8975','2014-03-12','15:15:00',2.36),('8975','2014-03-12','15:20:00',2.26),('8975','2014-03-12','15:25:00',2.15),('8975','2014-03-12','15:30:00',2.04),('8975','2014-03-12','15:35:00',1.95),('8975','2014-03-12','15:40:00',1.87),('8975','2014-03-12','15:45:00',1.77),('8975','2014-03-12','15:50:00',1.7),('8975','2014-03-12','15:55:00',1.62),('8975','2014-03-12','16:00:00',1.55),('8975','2014-03-12','16:05:00',1.48),('8975','2014-03-12','16:10:00',1.43),('8975','2014-03-12','16:15:00',1.38),('8975','2014-03-12','16:20:00',1.35),('8975','2014-03-12','16:25:00',1.32),('8975','2014-03-12','16:30:00',1.26),('8975','2014-03-12','16:35:00',1.21),('8975','2014-03-12','16:40:00',1.16),('8975','2014-03-12','16:45:00',1.09),('8975','2014-03-12','16:50:00',1.04),('8975','2014-03-11','07:00:00',1.06),('8975','2014-03-11','07:05:00',1.27),('8975','2014-03-11','07:10:00',1.42),('8975','2014-03-11','07:15:00',1.6),('8975','2014-03-11','07:20:00',1.83),('8975','2014-03-11','07:25:00',2.01),('8975','2014-03-11','07:30:00',2.19),('8975','2014-03-11','07:35:00',2.36),('8975','2014-03-11','07:40:00',2.49),('8975','2014-03-11','07:45:00',2.62),('8975','2014-03-11','07:50:00',2.74),('8975','2014-03-11','07:55:00',2.87),('8975','2014-03-11','08:00:00',2.98),('8975','2014-03-11','08:05:00',3.07),('8975','2014-03-11','08:10:00',3.17),('8975','2014-03-11','08:15:00',3.26),('8975','2014-03-11','08:20:00',3.37),('8975','2014-03-11','08:25:00',3.49),('8975','2014-03-11','08:30:00',3.59),('8975','2014-03-11','08:35:00',3.69),('8975','2014-03-11','08:40:00',3.78),('8975','2014-03-11','08:45:00',3.87),('8975','2014-03-11','08:50:00',3.97),('8975','2014-03-11','08:55:00',4.07),('8975','2014-03-11','09:00:00',4.17),('8975','2014-03-11','09:05:00',4.26),('8975','2014-03-11','09:10:00',4.36),('8975','2014-03-11','09:15:00',4.41),('8975','2014-03-11','09:20:00',4.51),('8975','2014-03-11','09:25:00',4.59),('8975','2014-03-11','09:30:00',4.67),('8975','2014-03-11','09:35:00',4.7),('8975','2014-03-11','09:40:00',4.79),('8975','2014-03-11','09:45:00',4.86),('8975','2014-03-11','09:50:00',4.91),('8975','2014-03-11','09:55:00',4.97),('8975','2014-03-11','10:00:00',5.05),('8975','2014-03-11','10:05:00',5.11),('8975','2014-03-11','10:10:00',5.17),('8975','2014-03-11','10:15:00',5.21),('8975','2014-03-11','10:20:00',5.24),('8975','2014-03-11','10:25:00',5.31),('8975','2014-03-11','10:30:00',5.35),('8975','2014-03-11','10:35:00',5.41),('8975','2014-03-11','10:40:00',5.47),('8975','2014-03-11','10:45:00',5.52),('8975','2014-03-11','10:50:00',5.53),('8975','2014-03-11','10:55:00',5.53),('8975','2014-03-11','11:00:00',5.55),('8975','2014-03-11','11:05:00',5.56),('8975','2014-03-11','11:10:00',5.57),('8975','2014-03-11','11:15:00',5.6),('8975','2014-03-11','11:20:00',5.6),('8975','2014-03-11','11:25:00',5.64),('8975','2014-03-11','11:30:00',5.64),('8975','2014-03-11','11:35:00',5.63),('8975','2014-03-11','11:40:00',5.61),('8975','2014-03-11','11:45:00',5.58),('8975','2014-03-11','11:50:00',5.56),('8975','2014-03-11','11:55:00',5.48),('8975','2014-03-11','12:00:00',5.46),('8975','2014-03-11','12:05:00',5.45),('8975','2014-03-11','12:10:00',5.42),('8975','2014-03-11','12:15:00',5.37),('8975','2014-03-11','12:20:00',5.33),('8975','2014-03-11','12:25:00',5.31),('8975','2014-03-11','12:30:00',5.27),('8975','2014-03-11','12:35:00',5.15),('8975','2014-03-11','12:40:00',5.16),('8975','2014-03-11','12:45:00',5.08),('8975','2014-03-11','12:50:00',5.04),('8975','2014-03-11','12:55:00',4.98),('8975','2014-03-11','13:00:00',4.91),('8975','2014-03-11','13:05:00',4.87),('8975','2014-03-11','13:10:00',4.64),('8975','2014-03-11','13:15:00',4.52),('8975','2014-03-11','13:20:00',4.54),('8975','2014-03-11','13:25:00',4.19),('8975','2014-03-11','13:30:00',4.09),('8975','2014-03-11','13:35:00',4.28),('8975','2014-03-11','13:40:00',4.25),('8975','2014-03-11','13:45:00',4.12),('8975','2014-03-11','13:50:00',4.08),('8975','2014-03-11','13:55:00',4.03),('8975','2014-03-11','14:00:00',3.41),('8975','2014-03-11','14:05:00',3.49),('8975','2014-03-11','14:10:00',3.43),('8975','2014-03-11','14:15:00',2.84),('8975','2014-03-11','14:20:00',2.96),('8975','2014-03-11','14:25:00',3.35),('8975','2014-03-11','14:30:00',3.14),('8975','2014-03-11','14:35:00',3.14),('8975','2014-03-11','14:40:00',2.88),('8975','2014-03-11','14:45:00',2.75),('8975','2014-03-11','14:50:00',2.67),('8975','2014-03-11','14:55:00',2.53),('8975','2014-03-11','15:00:00',2.46),('8975','2014-03-11','15:05:00',2.32),('8975','2014-03-11','15:10:00',2.31),('8975','2014-03-11','15:15:00',2.33),('8975','2014-03-11','15:20:00',2.22),('8975','2014-03-11','15:25:00',2.08),('8975','2014-03-11','15:30:00',2.02),('8975','2014-03-11','15:35:00',1.92),('8975','2014-03-11','15:40:00',1.85),('8975','2014-03-11','15:45:00',1.78),('8975','2014-03-11','15:50:00',1.74),('8975','2014-03-11','15:55:00',1.68),('8975','2014-03-11','16:00:00',1.61),('8975','2014-03-11','16:05:00',1.55),('8975','2014-03-11','16:10:00',1.5),('8975','2014-03-11','16:15:00',1.44),('8975','2014-03-11','16:20:00',1.4),('8975','2014-03-11','16:25:00',1.35),('8975','2014-03-11','16:30:00',1.28),('8975','2014-03-11','16:35:00',1.22),('8975','2014-03-11','16:40:00',1.19),('8975','2014-03-11','16:45:00',1.11),('8975','2014-03-11','16:51:00',1.06),('8975','2014-03-10','10:15:00',1.1),('8975','2014-03-10','10:20:00',1.41),('8975','2014-03-10','10:25:00',1.44),('8975','2014-03-10','10:30:00',1.48),('8975','2014-03-10','10:35:00',1.51),('8975','2014-03-10','10:40:00',1.49),('8975','2014-03-10','10:45:00',1.5),('8975','2014-03-10','10:50:00',1.35),('8975','2014-03-10','10:55:00',1.38),('8975','2014-03-10','11:00:00',1.55),('8975','2014-03-10','11:05:00',1.63),('8975','2014-03-10','11:10:00',1.5),('8975','2014-03-10','11:15:00',1.57),('8975','2014-03-10','11:20:00',1.55),('8975','2014-03-10','11:25:00',1.54),('8975','2014-03-10','11:30:00',1.47),('8975','2014-03-10','11:35:00',1.62),('8975','2014-03-10','11:40:00',1.54),('8975','2014-03-10','11:45:00',1.56),('8975','2014-03-10','11:50:00',1.38),('8975','2014-03-10','11:55:00',1.47),('8975','2014-03-10','12:00:00',1.61),('8975','2014-03-10','12:05:00',1.63),('8975','2014-03-10','12:10:00',1.75),('8975','2014-03-10','12:15:00',1.97),('8975','2014-03-10','12:20:00',2.2),('8975','2014-03-10','12:25:00',2.03),('8975','2014-03-10','12:30:00',1.89),('8975','2014-03-10','12:35:00',1.9),('8975','2014-03-10','12:40:00',1.95),('8975','2014-03-10','12:45:00',1.95),('8975','2014-03-10','12:50:00',1.98),('8975','2014-03-10','12:55:00',2.02),('8975','2014-03-10','13:00:00',1.92),('8975','2014-03-10','13:05:00',1.94),('8975','2014-03-10','13:10:00',2.09),('8975','2014-03-10','13:15:00',1.91),('8975','2014-03-10','13:20:00',1.94),('8975','2014-03-10','13:25:00',1.74),('8975','2014-03-10','13:30:00',1.84),('8975','2014-03-10','13:35:00',1.64),('8975','2014-03-10','13:40:00',1.7),('8975','2014-03-10','13:45:00',2.03),('8975','2014-03-10','13:50:00',2.47),('8975','2014-03-10','13:55:00',2.81),('8975','2014-03-10','14:00:00',2.9),('8975','2014-03-10','14:05:00',2.59),('8975','2014-03-10','14:10:00',2.86),('8975','2014-03-10','14:15:00',2.83),('8975','2014-03-10','14:20:00',2.78),('8975','2014-03-10','14:25:00',2.63),('8975','2014-03-10','14:30:00',2.1),('8975','2014-03-10','14:35:00',2.01),('8975','2014-03-10','14:40:00',1.88),('8975','2014-03-10','14:45:00',1.8),('8975','2014-03-10','14:50:00',1.71),('8975','2014-03-10','14:55:00',1.72),('8975','2014-03-10','15:00:00',2.03),('8975','2014-03-10','15:05:00',2.38),('8975','2014-03-10','15:10:00',2.36),('8975','2014-03-10','15:15:00',2.03),('8975','2014-03-10','15:20:00',1.89),('8975','2014-03-10','15:25:00',1.67),('8975','2014-03-10','15:30:00',1.59),('8975','2014-03-10','15:35:00',1.54),('8975','2014-03-10','15:40:00',1.56),('8975','2014-03-10','15:45:00',1.49),('8975','2014-03-10','15:50:00',1.56),('8975','2014-03-10','15:55:00',1.43),('8975','2014-03-10','16:00:00',1.32),('8975','2014-03-10','16:05:00',1.26),('8975','2014-03-10','16:10:00',1.27),('8975','2014-03-10','16:15:00',1.19),('8975','2014-03-10','16:20:00',1.17),('8975','2014-03-10','16:25:00',1.06),('8975','2014-03-09','08:20:00',1.01),('8975','2014-03-09','08:25:00',1.11),('8975','2014-03-09','08:30:00',1.17),('8975','2014-03-09','08:35:00',1.37),('8975','2014-03-09','08:40:00',1.53),('8975','2014-03-09','08:45:00',1.51),('8975','2014-03-09','08:50:00',1.57),('8975','2014-03-09','08:55:00',1.57),('8975','2014-03-09','09:00:00',1.6),('8975','2014-03-09','09:05:00',1.73),('8975','2014-03-09','09:10:00',1.63),('8975','2014-03-09','09:15:00',1.24),('8975','2014-03-09','09:20:00',1.12),('8975','2014-03-09','09:25:00',1.31),('8975','2014-03-09','09:30:00',1.57),('8975','2014-03-09','09:35:00',1.52),('8975','2014-03-09','09:40:00',1.58),('8975','2014-03-09','09:45:00',1.54),('8975','2014-03-09','09:50:00',1.48),('8975','2014-03-09','09:55:00',1.45),('8975','2014-03-09','10:00:00',1.23),('8975','2014-03-09','10:05:00',1.2),('8975','2014-03-09','10:10:00',1.4),('8975','2014-03-09','10:15:00',1.58),('8975','2014-03-09','10:20:00',1.55),('8975','2014-03-09','10:25:00',1.48),('8975','2014-03-09','10:30:00',1.62),('8975','2014-03-09','10:35:00',2.05),('8975','2014-03-09','10:40:00',1.7),('8975','2014-03-09','10:45:00',1.17),('8975','2014-03-09','11:10:00',1.07),('8975','2014-03-09','11:15:00',1.35),('8975','2014-03-09','11:20:00',1.55),('8975','2014-03-09','11:25:00',1.45),('8975','2014-03-09','11:30:00',1.23),('8975','2014-03-09','12:30:00',1.08),('8975','2014-03-09','12:35:00',1.22),('8975','2014-03-09','12:40:00',1.38),('8975','2014-03-09','12:45:00',1.56),('8975','2014-03-09','12:50:00',1.78),('8975','2014-03-09','12:55:00',1.91),('8975','2014-03-09','13:00:00',2.01),('8975','2014-03-09','13:05:00',2.06),('8975','2014-03-09','13:10:00',2.19),('8975','2014-03-09','13:15:00',2.37),('8975','2014-03-09','13:20:00',2.17),('8975','2014-03-09','13:25:00',2.12),('8975','2014-03-09','13:30:00',2.05),('8975','2014-03-09','13:35:00',1.66),('8975','2014-03-09','13:40:00',1.36),('8975','2014-03-09','13:45:00',1.33),('8975','2014-03-09','13:50:00',1.94),('8975','2014-03-09','13:55:00',1.63),('8975','2014-03-09','14:00:00',1.35),('8975','2014-03-09','14:05:00',2.01),('8975','2014-03-09','14:10:00',2.38),('8975','2014-03-09','14:15:00',2.12),('8975','2014-03-09','14:20:00',1.57),('8975','2014-03-09','14:25:00',1.76),('8975','2014-03-09','14:30:00',2.3),('8975','2014-03-09','14:35:00',2.07),('8975','2014-03-09','14:40:00',2.55),('8975','2014-03-09','14:45:00',3.35),('8975','2014-03-09','14:50:00',3.51),('8975','2014-03-09','14:55:00',3.02),('8975','2014-03-09','15:00:00',2.62),('8975','2014-03-09','15:05:00',2.09),('8975','2014-03-09','15:10:00',1.43),('8975','2014-03-09','15:15:00',1.77),('8975','2014-03-09','15:20:00',2.6),('8975','2014-03-09','15:25:00',2.72),('8975','2014-03-09','15:30:00',2.63),('8975','2014-03-09','15:35:00',2.44),('8975','2014-03-09','15:40:00',2.14),('8975','2014-03-09','15:45:00',1.85),('8975','2014-03-09','15:55:00',1.12),('8975','2014-03-09','16:00:00',1.33),('8975','2014-03-09','16:05:00',1.22),('8975','2014-03-09','16:10:00',1.23),('8975','2014-03-09','16:15:00',1.02),('8975','2014-03-09','16:25:00',1.02),('8975','2014-03-08','07:30:00',1.95),('8975','2014-03-08','07:35:00',2.06),('8975','2014-03-08','07:40:00',2.06),('8975','2014-03-08','07:45:00',2.28),('8975','2014-03-08','07:50:00',2.45),('8975','2014-03-08','07:55:00',2.57),('8975','2014-03-08','08:00:00',2.76),('8975','2014-03-08','08:05:00',2.88),('8975','2014-03-08','08:10:00',3.03),('8975','2014-03-08','08:15:00',2.9),('8975','2014-03-08','08:20:00',1.11),('8975','2014-03-08','08:25:00',1.2),('8975','2014-03-08','08:30:00',2.35),('8975','2014-03-08','08:35:00',1.13),('8975','2014-03-08','08:40:00',1.47),('8975','2014-03-08','08:45:00',1.92),('8975','2014-03-08','08:50:00',1.74),('8975','2014-03-08','08:55:00',2.85),('8975','2014-03-08','09:00:00',3.16),('8975','2014-03-08','09:05:00',3.47),('8975','2014-03-08','09:10:00',3.72),('8975','2014-03-08','09:15:00',2.51),('8975','2014-03-08','09:20:00',4.34),('8975','2014-03-08','09:25:00',4.62),('8975','2014-03-08','09:30:00',4.67),('8975','2014-03-08','09:35:00',4.84),('8975','2014-03-08','09:40:00',5.01),('8975','2014-03-08','09:45:00',5.09),('8975','2014-03-08','09:50:00',5.11),('8975','2014-03-08','09:55:00',5.05),('8975','2014-03-08','10:00:00',5.13),('8975','2014-03-08','10:05:00',5.19),('8975','2014-03-08','10:10:00',5.27),('8975','2014-03-08','10:15:00',5.25),('8975','2014-03-08','10:20:00',5.29),('8975','2014-03-08','10:25:00',5.43),('8975','2014-03-08','10:30:00',5.54),('8975','2014-03-08','10:35:00',5.49),('8975','2014-03-08','10:40:00',4.95),('8975','2014-03-08','10:45:00',5.44),('8975','2014-03-08','10:50:00',5.29),('8975','2014-03-08','10:55:00',5.63),('8975','2014-03-08','11:00:00',5.73),('8975','2014-03-08','11:05:00',5.93),('8975','2014-03-08','11:10:00',5.36),('8975','2014-03-08','11:15:00',5.11),('8975','2014-03-08','11:20:00',2.59),('8975','2014-03-08','11:25:00',2.68),('8975','2014-03-08','11:30:00',4),('8975','2014-03-08','11:35:00',4.5),('8975','2014-03-08','11:40:00',6.36),('8975','2014-03-08','11:45:00',4.88),('8975','2014-03-08','11:50:00',6.84),('8975','2014-03-08','11:55:00',5.8),('8975','2014-03-08','12:00:00',2.15),('8975','2014-03-08','12:05:00',2.81),('8975','2014-03-08','12:10:00',3.82),('8975','2014-03-08','12:15:00',1.92),('8975','2014-03-08','12:20:00',3.03),('8975','2014-03-08','12:25:00',5.38),('8975','2014-03-08','12:30:00',6.03),('8975','2014-03-08','12:35:00',6.09),('8975','2014-03-08','12:40:00',5.82),('8975','2014-03-08','12:45:00',5.36),('8975','2014-03-08','12:50:00',5.47),('8975','2014-03-08','12:55:00',5.7),('8975','2014-03-08','13:00:00',5.72),('8975','2014-03-08','13:05:00',5.64),('8975','2014-03-08','13:10:00',4.39),('8975','2014-03-08','13:15:00',4.35),('8975','2014-03-08','13:20:00',4.99),('8975','2014-03-08','13:25:00',4.84),('8975','2014-03-08','13:30:00',4.69),('8975','2014-03-08','13:35:00',4.69),('8975','2014-03-08','13:40:00',3.4),('8975','2014-03-08','13:45:00',1.58),('8975','2014-03-08','13:50:00',3.25),('8975','2014-03-08','13:55:00',4.29),('8975','2014-03-08','14:00:00',2.83),('8975','2014-03-08','14:05:00',3.79),('8975','2014-03-08','14:10:00',3.12),('8975','2014-03-08','14:15:00',3.78),('8975','2014-03-08','14:20:00',3.6),('8975','2014-03-08','14:25:00',3.95),('8975','2014-03-08','14:30:00',3.81),('8975','2014-03-08','14:35:00',3.61),('8975','2014-03-08','14:40:00',2.64),('8975','2014-03-08','14:45:00',2.22),('8975','2014-03-08','14:50:00',3.05),('8975','2014-03-08','14:55:00',3),('8975','2014-03-08','15:00:00',2.94),('8975','2014-03-08','15:05:00',2.8),('8975','2014-03-08','15:10:00',2.67),('8975','2014-03-08','15:15:00',2.52),('8975','2014-03-08','15:20:00',2.37),('8975','2014-03-08','15:25:00',2.29),('8975','2014-03-08','15:30:00',2.29),('8975','2014-03-08','15:35:00',2.13),('8975','2014-03-08','15:40:00',1.96),('8975','2014-03-08','15:45:00',1.76),('8975','2014-03-08','15:50:00',1.6),('8975','2014-03-08','15:55:00',1.97),('8975','2014-03-08','16:00:00',1.86),('8975','2014-03-08','16:05:00',1.68),('8975','2014-03-08','16:10:00',1.25),('8975','2014-03-08','16:20:00',1.15),('8975','2014-03-08','16:25:00',1.15),('8975','2014-03-08','16:30:00',1.34),('8975','2014-03-08','16:35:00',1.32),('8975','2014-03-08','16:40:00',1.31),('8975','2014-03-08','16:45:00',1.19),('8975','2014-03-08','16:50:00',1.06),('8975','2014-03-07','07:10:00',1.22),('8975','2014-03-07','07:15:00',1.41),('8975','2014-03-07','07:20:00',1.6),('8975','2014-03-07','07:25:00',1.83),('8975','2014-03-07','07:30:00',2.01),('8975','2014-03-07','07:35:00',2.15),('8975','2014-03-07','07:40:00',2.31),('8975','2014-03-07','07:45:00',2.42),('8975','2014-03-07','07:50:00',2.54),('8975','2014-03-07','07:55:00',2.67),('8975','2014-03-07','08:00:00',2.8),('8975','2014-03-07','08:05:00',2.91),('8975','2014-03-07','08:10:00',3.02),('8975','2014-03-07','08:15:00',3.12),('8975','2014-03-07','08:20:00',3.23),('8975','2014-03-07','08:25:00',3.34),('8975','2014-03-07','08:30:00',3.45),('8975','2014-03-07','08:35:00',3.53),('8975','2014-03-07','08:40:00',3.63),('8975','2014-03-07','08:45:00',3.73),('8975','2014-03-07','08:50:00',3.83),('8975','2014-03-07','08:55:00',3.93),('8975','2014-03-07','09:00:00',4.04),('8975','2014-03-07','09:05:00',4.14),('8975','2014-03-07','09:10:00',4.2),('8975','2014-03-07','09:15:00',4.3),('8975','2014-03-07','09:20:00',4.4),('8975','2014-03-07','09:25:00',4.48),('8975','2014-03-07','09:30:00',4.57),('8975','2014-03-07','09:35:00',4.63),('8975','2014-03-07','09:40:00',4.66),('8975','2014-03-07','09:45:00',4.78),('8975','2014-03-07','09:50:00',4.83),('8975','2014-03-07','09:55:00',4.89),('8975','2014-03-07','10:00:00',4.96),('8975','2014-03-07','10:05:00',5),('8975','2014-03-07','10:10:00',5.07),('8975','2014-03-07','10:15:00',5.12),('8975','2014-03-07','10:20:00',5.2),('8975','2014-03-07','10:25:00',5.24),('8975','2014-03-07','10:30:00',5.3),('8975','2014-03-07','10:35:00',5.34),('8975','2014-03-07','10:40:00',5.37),('8975','2014-03-07','10:45:00',5.4),('8975','2014-03-07','10:50:00',5.43),('8975','2014-03-07','10:55:00',5.45),('8975','2014-03-07','11:00:00',5.49),('8975','2014-03-07','11:05:00',5.53),('8975','2014-03-07','11:10:00',5.57),('8975','2014-03-07','11:15:00',5.63),('8975','2014-03-07','11:20:00',5.74),('8975','2014-03-07','11:25:00',5.87),('8975','2014-03-07','11:30:00',6.11),('8975','2014-03-07','11:35:00',4.53),('8975','2014-03-07','11:40:00',2.38),('8975','2014-03-07','11:45:00',2.02),('8975','2014-03-07','11:50:00',2.13),('8975','2014-03-07','11:55:00',2.05),('8975','2014-03-07','12:00:00',1.76),('8975','2014-03-07','12:05:00',1.63),('8975','2014-03-07','12:10:00',1.62),('8975','2014-03-07','12:15:00',1.7),('8975','2014-03-07','12:20:00',2.05),('8975','2014-03-07','12:25:00',2.29),('8975','2014-03-07','12:30:00',2.54),('8975','2014-03-07','12:35:00',4.59),('8975','2014-03-07','12:40:00',3.31),('8975','2014-03-07','12:45:00',2.84),('8975','2014-03-07','12:50:00',2.54),('8975','2014-03-07','12:55:00',3.9),('8975','2014-03-07','13:00:00',2.59),('8975','2014-03-07','13:05:00',2.36),('8975','2014-03-07','13:10:00',2.11),('8975','2014-03-07','13:15:00',1.73),('8975','2014-03-07','13:20:00',1.49),('8975','2014-03-07','13:25:00',1.98),('8975','2014-03-07','13:30:00',3.49),('8975','2014-03-07','13:35:00',3.42),('8975','2014-03-07','13:40:00',4.62),('8975','2014-03-07','13:45:00',3.5),('8975','2014-03-07','13:50:00',4),('8975','2014-03-07','13:55:00',1.95),('8975','2014-03-07','14:00:00',1.61),('8975','2014-03-07','14:05:00',1.65),('8975','2014-03-07','14:10:00',1.54),('8975','2014-03-07','14:15:00',1.27),('8975','2014-03-07','14:20:00',1.13),('8975','2014-03-07','14:25:00',1.02),('8975','2014-03-07','14:30:00',1.05),('8975','2014-03-07','14:35:00',1.3),('8975','2014-03-07','14:40:00',1.52),('8975','2014-03-07','14:45:00',1.47),('8975','2014-03-07','14:50:00',1.49),('8975','2014-03-07','14:55:00',1.51),('8975','2014-03-07','15:00:00',1.33),('8975','2014-03-07','15:05:00',1.3),('8975','2014-03-07','15:10:00',1.42),('8975','2014-03-07','15:15:00',1.91),('8975','2014-03-07','15:20:00',1.98),('8975','2014-03-07','15:25:00',2.16),('8975','2014-03-07','15:30:00',2.69),('8975','2014-03-07','15:35:00',1.43),('8975','2014-03-07','15:45:00',1.02),('8975','2014-03-07','15:50:00',1.26),('8975','2014-03-07','15:55:00',1.25),('8975','2014-03-07','16:00:00',1.25),('8975','2014-03-07','16:05:00',1.04),('8975','2014-03-07','16:20:00',1.02),('8975','2014-03-07','16:30:00',1.54),('8975','2014-03-07','16:35:00',1.39),('8975','2014-03-07','16:40:00',1.26),('8975','2014-03-07','16:45:00',1.23),('8975','2014-03-07','16:50:00',1.15),('8975','2014-03-07','16:55:00',1.08),('8975','2014-04-29','07:00:00',1.19),('8975','2014-04-29','07:05:00',1.37),('8975','2014-04-29','07:10:00',1.76),('8975','2014-04-29','07:15:00',1.9),('8975','2014-04-29','07:20:00',2.33),('8975','2014-04-29','07:25:00',2.52),('8975','2014-04-29','07:30:00',2.66),('8975','2014-04-29','07:35:00',2.8),('8975','2014-04-29','07:40:00',2.92),('8975','2014-04-29','07:45:00',3.08),('8975','2014-04-29','07:50:00',3.19),('8975','2014-04-29','07:55:00',3.29),('8975','2014-04-29','08:00:00',3.39),('8975','2014-04-29','08:05:00',3.5),('8975','2014-04-29','08:10:00',3.6),('8975','2014-04-29','08:15:00',3.65),('8975','2014-04-29','08:20:00',3.75),('8975','2014-04-29','08:25:00',3.86),('8975','2014-04-29','08:30:00',3.96),('8975','2014-04-29','08:35:00',4.04),('8975','2014-04-29','08:40:00',4.09),('8975','2014-04-29','08:45:00',4.06),('8975','2014-04-29','08:50:00',3.85),('8975','2014-04-29','08:55:00',5.07),('8975','2014-04-29','09:00:00',4.64),('8975','2014-04-29','09:05:00',3.2),('8975','2014-04-29','09:10:00',2.4),('8975','2014-04-29','09:15:00',4.4),('8975','2014-04-29','09:20:00',2.69),('8975','2014-04-29','09:25:00',2.01),('8975','2014-04-29','09:30:00',2.41),('8975','2014-04-29','09:35:00',5.74),('8975','2014-04-29','09:40:00',5.76),('8975','2014-04-29','09:45:00',5.97),('8975','2014-04-29','09:50:00',3.89),('8975','2014-04-29','09:55:00',5.06),('8975','2014-04-29','10:00:00',3.98),('8975','2014-04-29','10:05:00',4.05),('8975','2014-04-29','10:10:00',2.45),('8975','2014-04-29','10:15:00',3.08),('8975','2014-04-29','10:20:00',2.37),('8975','2014-04-29','10:25:00',2.36),('8975','2014-04-29','10:30:00',3.07),('8975','2014-04-29','10:35:00',2.84),('8975','2014-04-29','10:40:00',2.7),('8975','2014-04-29','10:45:00',2.51),('8975','2014-04-29','10:50:00',2.36),('8975','2014-04-29','10:55:00',2.41),('8975','2014-04-29','11:00:00',4.49),('8975','2014-04-29','11:05:00',4.16),('8975','2014-04-29','11:10:00',2.72),('8975','2014-04-29','11:15:00',3.13),('8975','2014-04-29','11:20:00',2.82),('8975','2014-04-29','11:25:00',3.07),('8975','2014-04-29','11:30:00',3.42),('8975','2014-04-29','11:35:00',4.24),('8975','2014-04-29','11:40:00',3.54),('8975','2014-04-29','11:45:00',2.52),('8975','2014-04-29','11:50:00',2.09),('8975','2014-04-29','11:55:00',3.13),('8975','2014-04-29','12:00:00',2.92),('8975','2014-04-29','12:05:00',4.74),('8975','2014-04-29','12:10:00',5.75),('8975','2014-04-29','12:15:00',8.86),('8975','2014-04-29','12:20:00',4.62),('8975','2014-04-29','12:25:00',3.47),('8975','2014-04-29','12:30:00',5.18),('8975','2014-04-29','12:35:00',5.53),('8975','2014-04-29','12:40:00',3.62),('8975','2014-04-29','12:45:00',2.77),('8975','2014-04-29','12:50:00',5.17),('8975','2014-04-29','12:55:00',6.24),('8975','2014-04-29','13:00:00',4.41),('8975','2014-04-29','13:05:00',4.01),('8975','2014-04-29','13:10:00',5.55),('8975','2014-04-29','13:15:00',4.88),('8975','2014-04-29','13:20:00',4.54),('8975','2014-04-29','13:25:00',4.32),('8975','2014-04-29','13:30:00',5.17),('8975','2014-04-29','13:35:00',5.16),('8975','2014-04-29','13:40:00',7.42),('8975','2014-04-29','13:45:00',6.57),('8975','2014-04-29','13:50:00',3.89),('8975','2014-04-29','13:55:00',4.41),('8975','2014-04-29','14:00:00',3.22),('8975','2014-04-29','14:05:00',3.01),('8975','2014-04-29','14:10:00',2.46),('8975','2014-04-29','14:15:00',2.94),('8975','2014-04-29','14:20:00',3.92),('8975','2014-04-29','14:25:00',4.31),('8975','2014-04-29','14:30:00',4.88),('8975','2014-04-29','14:35:00',5.72),('8975','2014-04-29','14:40:00',3.72),('8975','2014-04-29','14:45:00',3.02),('8975','2014-04-29','14:50:00',2.73),('8975','2014-04-29','14:55:00',2.74),('8975','2014-04-29','15:00:00',2.59),('8975','2014-04-29','15:05:00',2.26),('8975','2014-04-29','15:10:00',2.48),('8975','2014-04-29','15:15:00',2.22),('8975','2014-04-29','15:20:00',1.62),('8975','2014-04-29','15:25:00',1.73),('8975','2014-04-29','15:30:00',2.87),('8975','2014-04-29','15:35:00',3.5),('8975','2014-04-29','15:40:00',5.65),('8975','2014-04-29','15:45:00',5.3),('8975','2014-04-29','15:50:00',5.53),('8975','2014-04-29','15:55:00',3.62),('8975','2014-04-29','16:00:00',3.19),('8975','2014-04-29','16:05:00',3.16),('8975','2014-04-29','16:10:00',2.17),('8975','2014-04-29','16:15:00',1.83),('8975','2014-04-29','16:20:00',2.15),('8975','2014-04-29','16:25:00',2.9),('8975','2014-04-29','16:30:00',3.57),('8975','2014-04-29','16:35:00',4.32),('8975','2014-04-29','16:40:00',3.96),('8975','2014-04-29','16:45:00',3.76),('8975','2014-04-29','16:50:00',2.36),('8975','2014-04-29','16:55:00',3.49),('8975','2014-04-29','17:00:00',2.98),('8975','2014-04-29','17:05:00',2.98),('8975','2014-04-29','17:10:00',2),('8975','2014-04-29','17:15:00',1.9),('8975','2014-04-29','17:20:00',1.37),('8975','2014-04-29','17:25:00',1.14),('8975','2014-04-29','17:30:00',1.6),('8975','2014-04-29','17:35:00',1.84),('8975','2014-04-29','17:40:00',1.55),('8975','2014-04-29','17:45:00',1.3),('8975','2014-04-29','17:55:00',1.18),('8975','2014-04-29','18:00:00',1.01),('8975','2014-04-29','18:10:00',1.14),('8975','2014-03-06','09:30:00',1.02),('8975','2014-03-06','09:35:00',1.33),('8975','2014-03-06','09:40:00',1.07),('8975','2014-03-06','10:10:00',1.06),('8975','2014-03-06','10:15:00',1.06),('8975','2014-03-06','10:20:00',1.08),('8975','2014-03-06','10:30:00',1.04),('8975','2014-03-06','10:35:00',1.54),('8975','2014-03-06','10:40:00',1.31),('8975','2014-03-06','10:45:00',1.11),('8975','2014-03-06','10:50:00',1.05),('8975','2014-03-06','10:55:00',1.11),('8975','2014-03-06','11:00:00',1.38),('8975','2014-03-06','11:05:00',1.39),('8975','2014-03-06','11:10:00',1.22),('8975','2014-03-06','11:15:00',1.29),('8975','2014-03-06','11:20:00',1.53),('8975','2014-03-06','11:25:00',1.47),('8975','2014-03-06','11:30:00',4.04),('8975','2014-03-06','11:35:00',4.08),('8975','2014-03-06','11:40:00',2.83),('8975','2014-03-06','11:45:00',4.45),('8975','2014-03-06','11:50:00',4.88),('8975','2014-03-06','11:55:00',6.49),('8975','2014-03-06','12:00:00',6.42),('8975','2014-03-06','12:05:00',4.21),('8975','2014-03-06','12:10:00',5.36),('8975','2014-03-06','12:15:00',5.85),('8975','2014-03-06','12:20:00',5.77),('8975','2014-03-06','12:25:00',5.21),('8975','2014-03-06','12:30:00',3.48),('8975','2014-03-06','12:35:00',3.98),('8975','2014-03-06','12:40:00',4.02),('8975','2014-03-06','12:45:00',1.47),('8975','2014-03-06','12:50:00',3.68),('8975','2014-03-06','12:55:00',5.85),('8975','2014-03-06','13:00:00',5.79),('8975','2014-03-06','13:05:00',5.58),('8975','2014-03-06','13:10:00',5.7),('8975','2014-03-06','13:15:00',5.5),('8975','2014-03-06','13:20:00',5.24),('8975','2014-03-06','13:25:00',5.29),('8975','2014-03-06','13:30:00',5.12),('8975','2014-03-06','13:35:00',4.4),('8975','2014-03-06','13:40:00',4),('8975','2014-03-06','13:45:00',3.47),('8975','2014-03-06','13:50:00',2.09),('8975','2014-03-06','13:55:00',1.8),('8975','2014-03-06','14:00:00',1.76),('8975','2014-03-06','14:05:00',1.72),('8975','2014-03-06','14:10:00',1.7),('8975','2014-03-06','14:15:00',1.64),('8975','2014-03-06','14:20:00',1.62),('8975','2014-03-06','14:25:00',1.56),('8975','2014-03-06','14:30:00',1.62),('8975','2014-03-06','14:35:00',1.77),('8975','2014-03-06','14:40:00',1.9),('8975','2014-03-06','14:45:00',1.89),('8975','2014-03-06','14:50:00',2.23),('8975','2014-03-06','14:55:00',3.03),('8975','2014-03-06','15:00:00',3.52),('8975','2014-03-06','15:05:00',3.84),('8975','2014-03-06','15:10:00',3.84),('8975','2014-03-06','15:15:00',3.69),('8975','2014-03-06','15:20:00',3.5),('8975','2014-03-06','15:25:00',3.15),('8975','2014-03-06','15:30:00',2.81),('8975','2014-03-06','15:35:00',2.57),('8975','2014-03-06','15:40:00',1.1),('8975','2014-03-06','15:45:00',1.02),('8975','2014-03-06','15:50:00',1.04),('8975','2014-03-06','15:55:00',2.03),('8975','2014-03-06','16:00:00',2.21),('8975','2014-03-06','16:05:00',1.97),('8975','2014-03-06','16:10:00',1.89),('8975','2014-03-06','16:15:00',1.94),('8975','2014-03-06','16:20:00',1.75),('8975','2014-03-06','16:25:00',1.61),('8975','2014-03-06','16:30:00',1.08),('8975','2014-03-06','16:35:00',1.54),('8975','2014-03-06','16:40:00',1.69),('8975','2014-03-06','16:45:00',1.7),('8975','2014-03-06','16:50:00',1.59),('8975','2014-03-06','16:55:00',1.5),('8975','2014-03-06','17:00:00',1.43),('8975','2014-03-06','17:05:00',1.36),('8975','2014-03-06','17:10:00',1.24),('8975','2014-03-06','17:15:00',1.09),('8975','2014-03-05','07:55:00',1.52),('8975','2014-03-05','08:00:00',1.38),('8975','2014-03-05','08:05:00',3.26),('8975','2014-03-05','08:10:00',3.33),('8975','2014-03-05','08:15:00',1.68),('8975','2014-03-05','08:20:00',1.55),('8975','2014-03-05','08:25:00',1.75),('8975','2014-03-05','08:30:00',1.06),('8975','2014-03-05','08:35:00',1.11),('8975','2014-03-05','08:40:00',1.04),('8975','2014-03-05','08:45:00',1.37),('8975','2014-03-05','08:50:00',1.31),('8975','2014-03-05','08:55:00',1.21),('8975','2014-03-05','09:00:00',1.48),('8975','2014-03-05','09:05:00',1.37),('8975','2014-03-05','09:10:00',1.37),('8975','2014-03-05','09:15:00',1.53),('8975','2014-03-05','09:20:00',1.76),('8975','2014-03-05','09:25:00',1.65),('8975','2014-03-05','09:30:00',1.72),('8975','2014-03-05','09:35:00',1.89),('8975','2014-03-05','09:40:00',2.27),('8975','2014-03-05','09:45:00',2.57),('8975','2014-03-05','09:50:00',2.9),('8975','2014-03-05','09:55:00',3.79),('8975','2014-03-05','10:00:00',3.74),('8975','2014-03-05','10:05:00',3.81),('8975','2014-03-05','10:10:00',4.64),('8975','2014-03-05','10:15:00',4.78),('8975','2014-03-05','10:20:00',5.07),('8975','2014-03-05','10:25:00',4.44),('8975','2014-03-05','10:30:00',3.07),('8975','2014-03-05','10:35:00',2.39),('8975','2014-03-05','10:40:00',1.93),('8975','2014-03-05','10:45:00',4.31),('8975','2014-03-05','10:50:00',1.98),('8975','2014-03-05','10:55:00',1.25),('8975','2014-03-05','11:00:00',1.61),('8975','2014-03-05','11:05:00',1.18),('8975','2014-03-05','11:10:00',1.42),('8975','2014-03-05','11:15:00',3.16),('8975','2014-03-05','11:20:00',3.57),('8975','2014-03-05','11:25:00',3.45),('8975','2014-03-05','11:30:00',4.82),('8975','2014-03-05','11:35:00',3.01),('8975','2014-03-05','11:40:00',3.29),('8975','2014-03-05','11:45:00',6.32),('8975','2014-03-05','11:50:00',6.94),('8975','2014-03-05','11:55:00',7.28),('8975','2014-03-05','12:00:00',6.79),('8975','2014-03-05','12:05:00',2.99),('8975','2014-03-05','12:10:00',5.54),('8975','2014-03-05','12:15:00',3.11),('8975','2014-03-05','12:20:00',1.92),('8975','2014-03-05','12:25:00',4.63),('8975','2014-03-05','12:30:00',5.44),('8975','2014-03-05','12:35:00',3.91),('8975','2014-03-05','12:40:00',2.35),('8975','2014-03-05','12:45:00',1.62),('8975','2014-03-05','12:50:00',1.57),('8975','2014-03-05','12:55:00',1.86),('8975','2014-03-05','13:00:00',2.19),('8975','2014-03-05','13:05:00',2.16),('8975','2014-03-05','13:10:00',1.92),('8975','2014-03-05','13:15:00',1.87),('8975','2014-03-05','13:20:00',1.99),('8975','2014-03-05','13:25:00',1.69),('8975','2014-03-05','13:30:00',2.06),('8975','2014-03-05','13:35:00',1.84),('8975','2014-03-05','13:40:00',1.79),('8975','2014-03-05','13:45:00',1.66),('8975','2014-03-05','13:50:00',1.54),('8975','2014-03-05','13:55:00',1.5),('8975','2014-03-05','14:00:00',1.58),('8975','2014-03-05','14:05:00',1.64),('8975','2014-03-05','14:10:00',1.72),('8975','2014-03-05','14:15:00',1.61),('8975','2014-03-05','14:20:00',1.99),('8975','2014-03-05','14:25:00',2.19),('8975','2014-03-05','14:30:00',2.07),('8975','2014-03-05','14:35:00',2.62),('8975','2014-03-05','14:40:00',2.19),('8975','2014-03-05','14:45:00',1.47),('8975','2014-03-05','14:50:00',1.59),('8975','2014-03-05','14:55:00',1.55),('8975','2014-03-05','15:00:00',1.67),('8975','2014-03-05','15:05:00',1.81),('8975','2014-03-05','15:10:00',1.81),('8975','2014-03-05','15:15:00',1.34),('8975','2014-03-05','15:35:00',1.05),('8975','2014-03-05','16:40:00',1.45),('8975','2014-03-05','16:45:00',1.49),('8975','2014-03-05','16:50:00',1.41),('8975','2014-03-05','17:10:00',1.05),('8975','2014-03-04','07:05:00',1.13),('8975','2014-03-04','07:10:00',1.36),('8975','2014-03-04','07:15:00',1.84),('8975','2014-03-04','07:20:00',2.03),('8975','2014-03-04','07:25:00',2.28),('8975','2014-03-04','07:30:00',2.48),('8975','2014-03-04','07:35:00',2.64),('8975','2014-03-04','07:40:00',2.82),('8975','2014-03-04','07:45:00',2.94),('8975','2014-03-04','07:50:00',3.06),('8975','2014-03-04','07:55:00',3.16),('8975','2014-03-04','08:00:00',3.19),('8975','2014-03-04','08:05:00',1.5),('8975','2014-03-04','08:10:00',1.03),('8975','2014-03-04','08:15:00',3.3),('8975','2014-03-04','08:20:00',3.65),('8975','2014-03-04','08:25:00',1.98),('8975','2014-03-04','08:30:00',1.04),('8975','2014-03-04','08:35:00',1.5),('8975','2014-03-04','08:40:00',2.04),('8975','2014-03-04','08:45:00',2.81),('8975','2014-03-04','08:50:00',4.06),('8975','2014-03-04','08:55:00',1.46),('8975','2014-03-04','09:00:00',2.66),('8975','2014-03-04','09:05:00',3.53),('8975','2014-03-04','09:10:00',3.59),('8975','2014-03-04','09:15:00',3.74),('8975','2014-03-04','09:20:00',4.47),('8975','2014-03-04','09:25:00',4.52),('8975','2014-03-04','09:30:00',4.61),('8975','2014-03-04','09:35:00',4.69),('8975','2014-03-04','09:40:00',4.74),('8975','2014-03-04','09:45:00',4.79),('8975','2014-03-04','09:50:00',4.84),('8975','2014-03-04','09:55:00',4.92),('8975','2014-03-04','10:00:00',4.96),('8975','2014-03-04','10:05:00',5.03),('8975','2014-03-04','10:10:00',5.16),('8975','2014-03-04','10:15:00',5.17),('8975','2014-03-04','10:20:00',5.19),('8975','2014-03-04','10:25:00',5.22),('8975','2014-03-04','10:30:00',5.23),('8975','2014-03-04','10:35:00',5.27),('8975','2014-03-04','10:40:00',5.28),('8975','2014-03-04','10:45:00',5.31),('8975','2014-03-04','10:50:00',5.34),('8975','2014-03-04','10:55:00',5.36),('8975','2014-03-04','11:00:00',5.43),('8975','2014-03-04','11:05:00',5.45),('8975','2014-03-04','11:10:00',5.47),('8975','2014-03-04','11:15:00',5.19),('8975','2014-03-04','11:20:00',5.51),('8975','2014-03-04','11:25:00',5.55),('8975','2014-03-04','11:30:00',5.56),('8975','2014-03-04','11:35:00',5.6),('8975','2014-03-04','11:40:00',5.51),('8975','2014-03-04','11:45:00',5.29),('8975','2014-03-04','11:50:00',5.21),('8975','2014-03-04','11:55:00',4.97),('8975','2014-03-04','12:00:00',4.87),('8975','2014-03-04','12:05:00',4.82),('8975','2014-03-04','12:10:00',3.98),('8975','2014-03-04','12:15:00',3.22),('8975','2014-03-04','12:20:00',1.54),('8975','2014-03-04','12:25:00',1.44),('8975','2014-03-04','12:30:00',1.58),('8975','2014-03-04','12:35:00',1.89),('8975','2014-03-04','12:40:00',2.07),('8975','2014-03-04','12:45:00',2.04),('8975','2014-03-04','12:50:00',1.76),('8975','2014-03-04','12:55:00',1.58),('8975','2014-03-04','13:00:00',1.48),('8975','2014-03-04','13:05:00',2.42),('8975','2014-03-04','13:10:00',2.78),('8975','2014-03-04','13:15:00',2.54),('8975','2014-03-04','13:20:00',1.76),('8975','2014-03-04','13:25:00',1.88),('8975','2014-03-04','13:30:00',1.78),('8975','2014-03-04','13:35:00',1.87),('8975','2014-03-04','13:40:00',2.59),('8975','2014-03-04','13:45:00',3.94),('8975','2014-03-04','13:50:00',2.2),('8975','2014-03-04','13:55:00',1.66),('8975','2014-03-04','14:00:00',1.52),('8975','2014-03-04','14:05:00',1.56),('8975','2014-03-04','14:10:00',1.52),('8975','2014-03-04','14:15:00',1.71),('8975','2014-03-04','14:20:00',1.79),('8975','2014-03-04','14:25:00',1.81),('8975','2014-03-04','14:30:00',1.94),('8975','2014-03-04','14:35:00',1.61),('8975','2014-03-04','14:40:00',1.66),('8975','2014-03-04','14:45:00',1.82),('8975','2014-03-04','14:50:00',2.16),('8975','2014-03-04','14:55:00',2.4),('8975','2014-03-04','15:00:00',1.78),('8975','2014-03-04','15:05:00',1.5),('8975','2014-03-04','15:10:00',2.38),('8975','2014-03-04','15:15:00',1.55),('8975','2014-03-04','15:20:00',1.32),('8975','2014-03-04','15:25:00',1.18),('8975','2014-03-04','15:30:00',1.37),('8975','2014-03-04','15:35:00',1.56),('8975','2014-03-04','15:40:00',2),('8975','2014-03-04','15:45:00',1.98),('8975','2014-03-04','15:50:00',1.98),('8975','2014-03-04','15:55:00',2.6),('8975','2014-03-04','16:00:00',2.78),('8975','2014-03-04','16:05:00',2.29),('8975','2014-03-04','16:10:00',2.21),('8975','2014-03-04','16:15:00',1.29),('8975','2014-03-04','16:20:00',1.07),('8975','2014-03-03','09:00:00',1.23),('8975','2014-03-03','09:05:00',3.27),('8975','2014-03-03','09:10:00',1.32),('8975','2014-03-03','09:15:00',4.77),('8975','2014-03-03','09:20:00',2.47),('8975','2014-03-03','09:25:00',1.94),('8975','2014-03-03','09:30:00',1.94),('8975','2014-03-03','09:35:00',2.18),('8975','2014-03-03','09:40:00',3.21),('8975','2014-03-03','09:45:00',1.76),('8975','2014-03-03','09:50:00',1.54),('8975','2014-03-03','09:55:00',4.72),('8975','2014-03-03','10:00:00',2.2),('8975','2014-03-03','10:05:00',1.45),('8975','2014-03-03','10:15:00',1.11),('8975','2014-03-03','10:20:00',2.48),('8975','2014-03-03','10:25:00',6.43),('8975','2014-03-03','10:30:00',3.14),('8975','2014-03-03','10:35:00',6.21),('8975','2014-03-03','10:40:00',5.97),('8975','2014-03-03','10:45:00',3.75),('8975','2014-03-03','10:50:00',1.18),('8975','2014-03-03','10:55:00',3.52),('8975','2014-03-03','11:00:00',1.92),('8975','2014-03-03','11:05:00',2.24),('8975','2014-03-03','11:10:00',4.03),('8975','2014-03-03','11:15:00',5.29),('8975','2014-03-03','11:20:00',2.57),('8975','2014-03-03','11:25:00',2.08),('8975','2014-03-03','11:30:00',1.28),('8975','2014-03-03','11:35:00',1),('8975','2014-03-03','11:40:00',1.79),('8975','2014-03-03','11:45:00',6.67),('8975','2014-03-03','11:50:00',6.54),('8975','2014-03-03','11:55:00',5.79),('8975','2014-03-03','12:00:00',5.6),('8975','2014-03-03','12:05:00',5.47),('8975','2014-03-03','12:10:00',5.45),('8975','2014-03-03','12:15:00',5.37),('8975','2014-03-03','12:20:00',5.34),('8975','2014-03-03','12:25:00',5.31),('8975','2014-03-03','12:30:00',5.19),('8975','2014-03-03','12:35:00',5.09),('8975','2014-03-03','12:40:00',5.18),('8975','2014-03-03','12:45:00',4.71),('8975','2014-03-03','12:50:00',4.95),('8975','2014-03-03','12:55:00',5.02),('8975','2014-03-03','13:00:00',4.75),('8975','2014-03-03','13:05:00',3.79),('8975','2014-03-03','13:10:00',4.82),('8975','2014-03-03','13:15:00',3.3),('8975','2014-03-03','13:20:00',1.81),('8975','2014-03-03','13:25:00',1.61),('8975','2014-03-03','13:30:00',2.07),('8975','2014-03-03','13:35:00',1.28),('8975','2014-03-03','13:40:00',1.04),('8975','2014-03-03','13:45:00',1.26),('8975','2014-03-03','13:50:00',1.55),('8975','2014-03-03','13:55:00',1.64),('8975','2014-03-03','14:00:00',1.2),('8975','2014-03-03','14:05:00',2.02),('8975','2014-03-03','14:10:00',1.98),('8975','2014-03-03','14:15:00',3.56),('8975','2014-03-03','14:20:00',4.2),('8975','2014-03-03','14:25:00',3.15),('8975','2014-03-03','14:30:00',3.34),('8975','2014-03-03','14:35:00',3.18),('8975','2014-03-03','14:40:00',3.12),('8975','2014-03-03','14:45:00',3.05),('8975','2014-03-03','14:50:00',3.07),('8975','2014-03-03','14:55:00',1.84),('8975','2014-03-03','15:00:00',1.93),('8975','2014-03-03','15:05:00',2.71),('8975','2014-03-03','15:10:00',2.5),('8975','2014-03-03','15:15:00',2.08),('8975','2014-03-03','15:20:00',1.54),('8975','2014-03-03','15:25:00',2.49),('8975','2014-03-03','15:30:00',2.38),('8975','2014-03-03','15:35:00',2.34),('8975','2014-03-03','15:40:00',2.03),('8975','2014-03-03','15:45:00',1.7),('8975','2014-03-03','15:50:00',1.88),('8975','2014-03-03','16:00:00',1.23),('8975','2014-03-03','16:05:00',1.41),('8975','2014-03-03','16:10:00',1.4),('8975','2014-03-03','16:15:00',1.39),('8975','2014-03-03','16:20:00',1.66),('8975','2014-03-03','16:25:00',1.36),('8975','2014-03-03','16:35:00',1.07),('8975','2014-03-03','16:45:00',1.25),('8975','2014-03-03','16:50:00',1.19),('8975','2014-03-02','07:10:00',1.04),('8975','2014-03-02','07:15:00',1.41),('8975','2014-03-02','07:20:00',1.65),('8975','2014-03-02','07:25:00',1.84),('8975','2014-03-02','07:30:00',2.07),('8975','2014-03-02','07:35:00',2.25),('8975','2014-03-02','07:40:00',2.38),('8975','2014-03-02','07:45:00',2.51),('8975','2014-03-02','07:50:00',2.6),('8975','2014-03-02','07:55:00',2.77),('8975','2014-03-02','08:00:00',2.34),('8975','2014-03-02','08:05:00',2.27),('8975','2014-03-02','08:10:00',3.11),('8975','2014-03-02','08:15:00',3.19),('8975','2014-03-02','08:20:00',3.27),('8975','2014-03-02','08:25:00',3.35),('8975','2014-03-02','08:30:00',3.41),('8975','2014-03-02','08:35:00',3.49),('8975','2014-03-02','08:40:00',3.62),('8975','2014-03-02','08:45:00',3.72),('8975','2014-03-02','08:50:00',3.69),('8975','2014-03-02','08:55:00',3.84),('8975','2014-03-02','09:00:00',3.75),('8975','2014-03-02','09:05:00',3.55),('8975','2014-03-02','09:10:00',3.18),('8975','2014-03-02','09:15:00',3.58),('8975','2014-03-02','09:20:00',4.15),('8975','2014-03-02','09:25:00',4.32),('8975','2014-03-02','09:30:00',4.49),('8975','2014-03-02','09:35:00',4.43),('8975','2014-03-02','09:40:00',3.86),('8975','2014-03-02','09:45:00',4.19),('8975','2014-03-02','09:50:00',4.44),('8975','2014-03-02','09:55:00',4.3),('8975','2014-03-02','10:00:00',4.5),('8975','2014-03-02','10:05:00',4.82),('8975','2014-03-02','10:10:00',4.88),('8975','2014-03-02','10:15:00',4.93),('8975','2014-03-02','10:20:00',4.94),('8975','2014-03-02','10:25:00',4.98),('8975','2014-03-02','10:30:00',5.03),('8975','2014-03-02','10:35:00',5.05),('8975','2014-03-02','10:40:00',5.05),('8975','2014-03-02','10:45:00',5.09),('8975','2014-03-02','10:50:00',5.12),('8975','2014-03-02','10:55:00',5.11),('8975','2014-03-02','11:00:00',5.13),('8975','2014-03-02','11:05:00',5.12),('8975','2014-03-02','11:10:00',5.18),('8975','2014-03-02','11:15:00',5.16),('8975','2014-03-02','11:20:00',3.86),('8975','2014-03-02','11:25:00',2.12),('8975','2014-03-02','11:30:00',5.58),('8975','2014-03-02','11:35:00',5.72),('8975','2014-03-02','11:40:00',5.49),('8975','2014-03-02','11:45:00',5.33),('8975','2014-03-02','11:50:00',5.29),('8975','2014-03-02','11:55:00',5.31),('8975','2014-03-02','12:00:00',5.25),('8975','2014-03-02','12:05:00',5.21),('8975','2014-03-02','12:10:00',5.25),('8975','2014-03-02','12:15:00',5.22),('8975','2014-03-02','12:20:00',5.18),('8975','2014-03-02','12:25:00',5.07),('8975','2014-03-02','12:30:00',5.07),('8975','2014-03-02','12:35:00',5.03),('8975','2014-03-02','12:40:00',5.01),('8975','2014-03-02','12:45:00',4.95),('8975','2014-03-02','12:50:00',4.9),('8975','2014-03-02','12:55:00',4.85),('8975','2014-03-02','13:00:00',4.8),('8975','2014-03-02','13:05:00',4.65),('8975','2014-03-02','13:10:00',4.61),('8975','2014-03-02','13:15:00',4.38),('8975','2014-03-02','13:20:00',4.21),('8975','2014-03-02','13:25:00',4.36),('8975','2014-03-02','13:30:00',4.26),('8975','2014-03-02','13:35:00',4.19),('8975','2014-03-02','13:40:00',4.15),('8975','2014-03-02','13:45:00',4.08),('8975','2014-03-02','13:50:00',4.03),('8975','2014-03-02','13:55:00',3.82),('8975','2014-03-02','14:00:00',3.71),('8975','2014-03-02','14:05:00',3.64),('8975','2014-03-02','14:10:00',3.62),('8975','2014-03-02','14:15:00',2.79),('8975','2014-03-02','14:20:00',3.34),('8975','2014-03-02','14:25:00',3.09),('8975','2014-03-02','14:30:00',3.05),('8975','2014-03-02','14:35:00',2.9),('8975','2014-03-02','14:40:00',2.98),('8975','2014-03-02','14:45:00',2.87),('8975','2014-03-02','14:50:00',2.76),('8975','2014-03-02','14:55:00',2.7),('8975','2014-03-02','15:00:00',2.36),('8975','2014-03-02','15:05:00',2.43),('8975','2014-03-02','15:10:00',2.35),('8975','2014-03-02','15:15:00',1.52),('8975','2014-03-02','15:20:00',1.01),('8975','2014-03-02','15:25:00',1.92),('8975','2014-03-02','15:30:00',1.49),('8975','2014-03-02','15:35:00',1.41),('8975','2014-03-02','15:40:00',1.63),('8975','2014-03-02','15:45:00',1.58),('8975','2014-03-02','15:50:00',1.52),('8975','2014-03-02','15:55:00',1.43),('8975','2014-03-02','16:00:00',1.45),('8975','2014-03-02','16:05:00',1.39),('8975','2014-03-02','16:10:00',1.39),('8975','2014-03-02','16:15:00',1.32),('8975','2014-03-02','16:20:00',1.27),('8975','2014-03-02','16:25:00',1.15),('8975','2014-03-02','16:30:00',1.19),('8975','2014-03-02','16:35:00',1.19),('8975','2014-03-02','16:40:00',1.03),('8975','2014-03-02','16:45:00',1.12),('8975','2014-03-02','16:55:00',1.16),('8975','2014-03-02','17:00:00',1.06),('8975','2014-03-01','07:45:00',1.23),('8975','2014-03-01','08:00:00',1.27),('8975','2014-03-01','08:05:00',2.14),('8975','2014-03-01','08:10:00',3.82),('8975','2014-03-01','08:15:00',3.8),('8975','2014-03-01','08:20:00',3.49),('8975','2014-03-01','08:25:00',3.39),('8975','2014-03-01','08:30:00',3.34),('8975','2014-03-01','08:35:00',3.43),('8975','2014-03-01','08:40:00',3.59),('8975','2014-03-01','08:45:00',3.69),('8975','2014-03-01','08:50:00',3.78),('8975','2014-03-01','08:55:00',3.86),('8975','2014-03-01','09:00:00',3.97),('8975','2014-03-01','09:05:00',4.05),('8975','2014-03-01','09:10:00',4.18),('8975','2014-03-01','09:15:00',4.2),('8975','2014-03-01','09:20:00',4.05),('8975','2014-03-01','09:25:00',4.67),('8975','2014-03-01','09:30:00',4.77),('8975','2014-03-01','09:35:00',4.91),('8975','2014-03-01','09:40:00',4.5),('8975','2014-03-01','09:45:00',1.24),('8975','2014-03-01','09:50:00',1.38),('8975','2014-03-01','09:55:00',1.88),('8975','2014-03-01','10:00:00',2.26),('8975','2014-03-01','10:05:00',2.37),('8975','2014-03-01','10:10:00',2),('8975','2014-03-01','10:15:00',1.86),('8975','2014-03-01','10:20:00',1.74),('8975','2014-03-01','10:25:00',1.93),('8975','2014-03-01','10:30:00',1.85),('8975','2014-03-01','10:35:00',1.77),('8975','2014-03-01','10:40:00',1.52),('8975','2014-03-01','10:45:00',1.64),('8975','2014-03-01','10:50:00',1.63),('8975','2014-03-01','10:55:00',4.61),('8975','2014-03-01','11:00:00',4.46),('8975','2014-03-01','11:05:00',2.39),('8975','2014-03-01','11:10:00',1.98),('8975','2014-03-01','11:15:00',2.18),('8975','2014-03-01','11:20:00',3.03),('8975','2014-03-01','11:25:00',3.17),('8975','2014-03-01','11:30:00',3.24),('8975','2014-03-01','11:35:00',3.39),('8975','2014-03-01','11:40:00',6.37),('8975','2014-03-01','11:45:00',6.35),('8975','2014-03-01','11:50:00',3.64),('8975','2014-03-01','11:55:00',3.4),('8975','2014-03-01','12:00:00',2.67),('8975','2014-03-01','12:05:00',2.89),('8975','2014-03-01','12:10:00',4.31),('8975','2014-03-01','12:15:00',3.84),('8975','2014-03-01','12:20:00',2.96),('8975','2014-03-01','12:25:00',2.25),('8975','2014-03-01','12:30:00',2.09),('8975','2014-03-01','12:35:00',1.71),('8975','2014-03-01','12:40:00',1.57),('8975','2014-03-01','12:45:00',1.76),('8975','2014-03-01','12:50:00',2.03),('8975','2014-03-01','12:55:00',2.12),('8975','2014-03-01','13:00:00',2.09),('8975','2014-03-01','13:05:00',1.92),('8975','2014-03-01','13:10:00',1.53),('8975','2014-03-01','13:15:00',1.42),('8975','2014-03-01','13:20:00',1.47),('8975','2014-03-01','13:25:00',1.53),('8975','2014-03-01','13:30:00',1.59),('8975','2014-03-01','13:35:00',1.65),('8975','2014-03-01','13:40:00',1.52),('8975','2014-03-01','13:45:00',1.5),('8975','2014-03-01','13:50:00',1.62),('8975','2014-03-01','13:55:00',1.92),('8975','2014-03-01','14:00:00',2.19),('8975','2014-03-01','14:05:00',2.19),('8975','2014-03-01','14:10:00',2),('8975','2014-03-01','14:15:00',1.84),('8975','2014-03-01','14:20:00',1.73),('8975','2014-03-01','14:25:00',1.81),('8975','2014-03-01','14:30:00',1.87),('8975','2014-03-01','14:35:00',1.9),('8975','2014-03-01','14:40:00',1.86),('8975','2014-03-01','14:45:00',1.87),('8975','2014-03-01','14:50:00',1.87),('8975','2014-03-01','14:55:00',1.81),('8975','2014-03-01','15:00:00',1.85),('8975','2014-03-01','15:05:00',1.88),('8975','2014-03-01','15:10:00',1.84),('8975','2014-03-01','15:15:00',1.84),('8975','2014-03-01','15:20:00',1.85),('8975','2014-03-01','15:25:00',1.85),('8975','2014-03-01','15:30:00',1.81),('8975','2014-03-01','15:35:00',1.73),('8975','2014-03-01','15:40:00',1.59),('8975','2014-03-01','15:45:00',1.47),('8975','2014-03-01','15:50:00',1.36),('8975','2014-03-01','15:55:00',1.25),('8975','2014-03-01','16:00:00',1.16),('8975','2014-03-01','16:05:00',1.06),('8975','2014-02-28','14:45:00',1.12),('8975','2014-02-28','14:50:00',1.08),('8975','2014-02-28','14:55:00',1.13),('8975','2014-02-27','07:40:00',1.75),('8975','2014-02-27','07:45:00',2.22),('8975','2014-02-27','07:50:00',2.34),('8975','2014-02-27','07:55:00',2.58),('8975','2014-02-27','08:00:00',2.95),('8975','2014-02-27','08:05:00',3.04),('8975','2014-02-27','08:10:00',1.48),('8975','2014-02-27','08:15:00',1.99),('8975','2014-02-27','08:20:00',2.71),('8975','2014-02-27','08:25:00',2.72),('8975','2014-02-27','08:30:00',2),('8975','2014-02-27','08:35:00',3.58),('8975','2014-02-27','09:10:00',1.28),('8975','2014-02-27','09:15:00',2.05),('8975','2014-02-27','09:20:00',2.93),('8975','2014-02-27','09:25:00',2.96),('8975','2014-02-27','09:30:00',3.98),('8975','2014-02-27','09:35:00',1.53),('8975','2014-02-27','09:40:00',2.79),('8975','2014-02-27','09:45:00',4.94),('8975','2014-02-27','09:50:00',5.63),('8975','2014-02-27','09:55:00',4.18),('8975','2014-02-27','10:00:00',1.89),('8975','2014-02-27','10:05:00',2.13),('8975','2014-02-27','10:10:00',2.39),('8975','2014-02-27','10:15:00',2.07),('8975','2014-02-27','10:20:00',3.86),('8975','2014-02-27','10:25:00',5.57),('8975','2014-02-27','10:30:00',5.73),('8975','2014-02-27','10:35:00',5.99),('8975','2014-02-27','10:40:00',2.34),('8975','2014-02-27','10:45:00',1.36),('8975','2014-02-27','11:05:00',1.52),('8975','2014-02-27','11:10:00',1.08),('8975','2014-02-27','11:15:00',1.3),('8975','2014-02-27','11:20:00',1.61),('8975','2014-02-27','11:25:00',1.31),('8975','2014-02-27','11:40:00',1.13),('8975','2014-02-27','11:45:00',1.51),('8975','2014-02-27','11:50:00',1.85),('8975','2014-02-27','11:55:00',2.16),('8975','2014-02-27','12:00:00',2.76),('8975','2014-02-27','12:05:00',3.53),('8975','2014-02-27','12:10:00',3.41),('8975','2014-02-27','12:15:00',2.47),('8975','2014-02-27','12:20:00',1.95),('8975','2014-02-27','12:25:00',1.96),('8975','2014-02-27','12:30:00',2.26),('8975','2014-02-27','12:35:00',4.7),('8975','2014-02-27','12:40:00',1.95),('8975','2014-02-27','12:45:00',1.92),('8975','2014-02-27','12:50:00',1.94),('8975','2014-02-27','12:55:00',1.95),('8975','2014-02-27','13:00:00',4.2),('8975','2014-02-27','13:05:00',2.89),('8975','2014-02-27','13:10:00',2.51),('8975','2014-02-27','13:15:00',1.5),('8975','2014-02-27','13:45:00',2.5),('8975','2014-02-27','13:50:00',4.25),('8975','2014-02-27','13:55:00',3.09),('8975','2014-02-27','14:00:00',2.07),('8975','2014-02-27','14:05:00',1.56),('8975','2014-02-27','14:10:00',2.88),('8975','2014-02-27','14:15:00',3.81),('8975','2014-02-27','14:20:00',3.12),('8975','2014-02-27','14:25:00',2.58),('8975','2014-02-27','14:30:00',2.93),('8975','2014-02-27','14:35:00',2.15),('8975','2014-02-27','14:40:00',2.09),('8975','2014-02-27','14:45:00',2.02),('8975','2014-02-27','14:50:00',2.18),('8975','2014-02-27','14:55:00',2.47),('8975','2014-02-27','15:00:00',2.1),('8975','2014-02-27','15:05:00',1.34),('8975','2014-02-27','15:20:00',1.31),('8975','2014-02-27','15:25:00',2.75),('8975','2014-02-27','15:30:00',2.49),('8975','2014-02-27','15:35:00',2.47),('8975','2014-02-27','15:40:00',1.33),('8975','2014-02-27','16:10:00',1.69),('8975','2014-02-27','16:15:00',2.42),('8975','2014-02-27','16:20:00',1.86),('8975','2014-02-27','16:25:00',1.14),('8975','2014-02-27','16:35:00',1.13),('8975','2014-02-27','16:40:00',1.51),('8975','2014-02-27','16:45:00',1.67),('8975','2014-02-27','16:50:00',1.44),('8975','2014-02-26','10:30:00',1.31),('8975','2014-02-26','10:35:00',1.39),('8975','2014-02-26','10:40:00',1.58),('8975','2014-02-26','10:45:00',1.85),('8975','2014-02-26','10:50:00',1.98),('8975','2014-02-26','10:55:00',2.05),('8975','2014-02-26','11:00:00',2.37),('8975','2014-02-26','11:05:00',2.51),('8975','2014-02-26','11:10:00',2.51),('8975','2014-02-26','11:15:00',2.46),('8975','2014-02-26','11:20:00',2.31),('8975','2014-02-26','11:25:00',2.65),('8975','2014-02-26','11:30:00',2.97),('8975','2014-02-26','11:35:00',2.72),('8975','2014-02-26','11:40:00',2.36),('8975','2014-02-26','11:45:00',2.09),('8975','2014-02-26','11:50:00',2.03),('8975','2014-02-26','11:55:00',2),('8975','2014-02-26','12:00:00',1.91),('8975','2014-02-26','12:05:00',1.77),('8975','2014-02-26','12:10:00',1.45),('8975','2014-02-26','12:15:00',1.76),('8975','2014-02-26','12:20:00',1.99),('8975','2014-02-26','12:25:00',2),('8975','2014-02-26','12:30:00',1.75),('8975','2014-02-26','12:35:00',1.64),('8975','2014-02-26','12:40:00',1.66),('8975','2014-02-26','12:45:00',1.71),('8975','2014-02-26','12:50:00',1.7),('8975','2014-02-26','12:55:00',1.75),('8975','2014-02-26','13:00:00',1.84),('8975','2014-02-26','13:05:00',1.9),('8975','2014-02-26','13:10:00',2),('8975','2014-02-26','13:15:00',2.08),('8975','2014-02-26','13:20:00',2.03),('8975','2014-02-26','13:25:00',2.09),('8975','2014-02-26','13:30:00',2.33),('8975','2014-02-26','13:35:00',2.51),('8975','2014-02-26','13:40:00',2.53),('8975','2014-02-26','13:45:00',2.52),('8975','2014-02-26','13:50:00',2.82),('8975','2014-02-26','13:55:00',2.89),('8975','2014-02-26','14:00:00',2.66),('8975','2014-02-26','14:05:00',2.51),('8975','2014-02-26','14:10:00',2.22),('8975','2014-02-26','14:15:00',2.12),('8975','2014-02-26','14:20:00',2.14),('8975','2014-02-26','14:25:00',2.23),('8975','2014-02-26','14:30:00',2.34),('8975','2014-02-26','14:35:00',2.22),('8975','2014-02-26','14:40:00',2.06),('8975','2014-02-26','14:45:00',2),('8975','2014-02-26','14:50:00',1.92),('8975','2014-02-26','14:55:00',1.83),('8975','2014-02-26','15:00:00',1.83),('8975','2014-02-26','15:05:00',1.76),('8975','2014-02-26','15:10:00',1.9),('8975','2014-02-26','15:15:00',2.02),('8975','2014-02-26','15:20:00',1.98),('8975','2014-02-26','15:25:00',1.8),('8975','2014-02-26','15:30:00',1.8),('8975','2014-02-26','15:35:00',1.72),('8975','2014-02-26','15:40:00',1.44),('8975','2014-02-26','15:45:00',1.2),('8975','2014-02-26','15:50:00',1),('8975','2014-02-26','16:00:00',1.02),('8975','2014-02-26','16:35:00',1.11),('8975','2014-02-26','16:40:00',1.74),('8975','2014-02-26','16:45:00',1.45),('8975','2014-02-26','16:50:00',1.4),('8975','2014-02-26','16:55:00',1.44),('8975','2014-02-26','17:00:00',1.17),('8975','2014-02-26','17:05:00',1.07),('8975','2014-02-25','07:30:00',1),('8975','2014-02-25','07:35:00',1.08),('8975','2014-02-25','07:40:00',1.59),('8975','2014-02-25','07:45:00',1.75),('8975','2014-02-25','07:50:00',1.74),('8975','2014-02-25','07:55:00',2.08),('8975','2014-02-25','08:00:00',2.37),('8975','2014-02-25','08:05:00',2.5),('8975','2014-02-25','08:10:00',2.69),('8975','2014-02-25','08:15:00',2.81),('8975','2014-02-25','08:20:00',2.9),('8975','2014-02-25','08:25:00',2.99),('8975','2014-02-25','08:30:00',3.02),('8975','2014-02-25','08:35:00',3.2),('8975','2014-02-25','08:40:00',3.35),('8975','2014-02-25','08:45:00',3.68),('8975','2014-02-25','08:50:00',3.41),('8975','2014-02-25','08:55:00',3.53),('8975','2014-02-25','09:00:00',3.58),('8975','2014-02-25','09:05:00',3.45),('8975','2014-02-25','09:10:00',3.63),('8975','2014-02-25','09:15:00',3.33),('8975','2014-02-25','09:20:00',3.95),('8975','2014-02-25','09:25:00',4.26),('8975','2014-02-25','09:30:00',3.55),('8975','2014-02-25','09:35:00',3.39),('8975','2014-02-25','09:40:00',3.86),('8975','2014-02-25','09:45:00',2.32),('8975','2014-02-25','09:50:00',2.09),('8975','2014-02-25','09:55:00',1.89),('8975','2014-02-25','10:00:00',1.66),('8975','2014-02-25','10:05:00',1.43),('8975','2014-02-25','10:10:00',1.39),('8975','2014-02-25','10:15:00',1.48),('8975','2014-02-25','10:20:00',1.56),('8975','2014-02-25','10:25:00',1.82),('8975','2014-02-25','10:30:00',1.54),('8975','2014-02-25','10:35:00',1.33),('8975','2014-02-25','10:40:00',1.15),('8975','2014-02-25','10:50:00',1.03),('8975','2014-02-25','10:55:00',1.26),('8975','2014-02-25','11:00:00',1.54),('8975','2014-02-25','11:05:00',1.61),('8975','2014-02-25','11:10:00',1.59),('8975','2014-02-25','11:15:00',1.23),('8975','2014-02-25','11:25:00',1.01),('8975','2014-02-25','11:30:00',1.2),('8975','2014-02-25','11:35:00',1.01),('8975','2014-02-25','11:40:00',1.02),('8975','2014-02-25','11:45:00',1.37),('8975','2014-02-25','11:50:00',1.63),('8975','2014-02-25','11:55:00',1.91),('8975','2014-02-25','12:00:00',3.3),('8975','2014-02-25','12:05:00',2.56),('8975','2014-02-25','12:10:00',2.35),('8975','2014-02-25','12:15:00',1.92),('8975','2014-02-25','12:20:00',2.3),('8975','2014-02-25','12:25:00',3.21),('8975','2014-02-25','12:30:00',3.39),('8975','2014-02-25','12:35:00',5.05),('8975','2014-02-25','12:40:00',3.84),('8975','2014-02-25','12:45:00',4.76),('8975','2014-02-25','12:50:00',2.59),('8975','2014-02-25','12:55:00',4.26),('8975','2014-02-25','13:00:00',4.49),('8975','2014-02-25','13:05:00',3.83),('8975','2014-02-25','13:10:00',3.9),('8975','2014-02-25','13:15:00',3.84),('8975','2014-02-25','13:20:00',4),('8975','2014-02-25','13:25:00',4.23),('8975','2014-02-25','13:30:00',4.65),('8975','2014-02-25','13:35:00',3.81),('8975','2014-02-25','13:40:00',3.7),('8975','2014-02-25','13:45:00',4.5),('8975','2014-02-25','13:50:00',4.88),('8975','2014-02-25','13:55:00',4.24),('8975','2014-02-25','14:00:00',3.44),('8975','2014-02-25','14:05:00',1.71),('8975','2014-02-25','14:10:00',2.45),('8975','2014-02-25','14:15:00',1.84),('8975','2014-02-25','14:20:00',4.05),('8975','2014-02-25','14:25:00',2.67),('8975','2014-02-25','14:30:00',2.69),('8975','2014-02-25','14:35:00',3.38),('8975','2014-02-25','14:40:00',2.86),('8975','2014-02-25','14:45:00',2.36),('8975','2014-02-25','14:50:00',2.99),('8975','2014-02-25','14:55:00',2.68),('8975','2014-02-25','15:00:00',2.44),('8975','2014-02-25','15:05:00',2.48),('8975','2014-02-25','15:10:00',2.46),('8975','2014-02-25','15:15:00',1.99),('8975','2014-02-25','15:20:00',1.69),('8975','2014-02-25','15:25:00',1.29),('8975','2014-02-25','15:30:00',1.32),('8975','2014-02-25','15:35:00',1.62),('8975','2014-02-25','15:40:00',1.43),('8975','2014-02-25','15:45:00',1.33),('8975','2014-02-25','15:50:00',1.5),('8975','2014-02-25','15:55:00',1.64),('8975','2014-02-25','16:00:00',1.96),('8975','2014-02-25','16:05:00',1.74),('8975','2014-02-25','16:10:00',1.33),('8975','2014-02-25','16:15:00',1.07),('8975','2014-02-25','16:20:00',1.07),('8975','2014-04-28','09:45:00',1.13),('8975','2014-04-28','09:50:00',1.61),('8975','2014-04-28','09:55:00',1.93),('8975','2014-04-28','10:00:00',1.98),('8975','2014-04-28','10:05:00',3.25),('8975','2014-04-28','10:10:00',4.09),('8975','2014-04-28','10:15:00',3.82),('8975','2014-04-28','10:20:00',4.78),('8975','2014-04-28','10:25:00',6.12),('8975','2014-04-28','10:30:00',6.84),('8975','2014-04-28','10:35:00',6.73),('8975','2014-04-28','10:40:00',6.75),('8975','2014-04-28','10:45:00',6.72),('8975','2014-04-28','10:50:00',6.85),('8975','2014-04-28','10:55:00',6.76),('8975','2014-04-28','11:00:00',6.38),('8975','2014-04-28','11:05:00',5.26),('8975','2014-04-28','11:10:00',5.6),('8975','2014-04-28','11:15:00',5.86),('8975','2014-04-28','11:20:00',3.06),('8975','2014-04-28','11:25:00',1.96),('8975','2014-04-28','11:30:00',4.01),('8975','2014-04-28','11:35:00',4.58),('8975','2014-04-28','11:40:00',3.46),('8975','2014-04-28','11:45:00',3.07),('8975','2014-04-28','11:50:00',3.79),('8975','2014-04-28','11:55:00',2.75),('8975','2014-04-28','12:00:00',4.67),('8975','2014-04-28','12:05:00',3),('8975','2014-04-28','12:10:00',2.67),('8975','2014-04-28','12:15:00',2.34),('8975','2014-04-28','12:20:00',2.55),('8975','2014-04-28','12:25:00',4.51),('8975','2014-04-28','12:30:00',3.51),('8975','2014-04-28','12:35:00',3.51),('8975','2014-04-28','12:40:00',6.76),('8975','2014-04-28','12:45:00',8.62),('8975','2014-04-28','12:50:00',4.16),('8975','2014-04-28','12:55:00',4.16),('8975','2014-04-28','13:00:00',3.24),('8975','2014-04-28','13:05:00',3.53),('8975','2014-04-28','13:10:00',4.74),('8975','2014-04-28','13:15:00',4.93),('8975','2014-04-28','13:20:00',7.52),('8975','2014-04-28','13:25:00',2.5),('8975','2014-04-28','13:30:00',7.94),('8975','2014-04-28','13:35:00',5.84),('8975','2014-04-28','13:40:00',3.77),('8975','2014-04-28','13:45:00',4.23),('8975','2014-04-28','13:50:00',2.29),('8975','2014-04-28','13:55:00',2.23),('8975','2014-04-28','14:00:00',1.79),('8975','2014-04-28','14:05:00',1.09),('8975','2014-04-28','14:35:00',1.02),('8975','2014-04-28','14:40:00',1.15),('8975','2014-04-28','14:45:00',1.31),('8975','2014-04-28','14:50:00',1.23),('8975','2014-04-28','14:55:00',1.03),('8975','2014-04-28','15:00:00',1.23),('8975','2014-04-28','15:05:00',1.75),('8975','2014-04-28','15:10:00',1.88),('8975','2014-04-28','15:15:00',1.51),('8975','2014-04-28','15:20:00',1.11),('8975','2014-04-28','15:25:00',1.29),('8975','2014-04-28','15:30:00',1.01),('8975','2014-04-28','15:35:00',1.05),('8975','2014-04-28','15:40:00',1.01),('8975','2014-04-28','16:00:00',1.14),('8975','2014-04-28','16:05:00',1.34),('8975','2014-04-28','16:10:00',1.41),('8975','2014-04-28','16:15:00',1.45),('8975','2014-04-28','16:20:00',1.5),('8975','2014-04-28','16:25:00',1.56),('8975','2014-04-28','16:30:00',1.57),('8975','2014-04-28','16:35:00',1.38),('8975','2014-04-28','16:40:00',1.08),('8975','2014-04-28','16:50:00',1.03),('8975','2014-04-28','16:55:00',1.15),('8975','2014-04-28','17:00:00',1.27),('8975','2014-04-28','17:05:00',1.68),('8975','2014-04-28','17:10:00',1.74),('8975','2014-04-28','17:15:00',1.47),('8975','2014-04-28','17:20:00',1.46),('8975','2014-04-28','17:25:00',2.64),('8975','2014-04-28','17:30:00',2.06),('8975','2014-04-28','17:35:00',2.03),('8975','2014-04-28','17:40:00',2.08),('8975','2014-04-28','17:45:00',1.99),('8975','2014-04-28','17:50:00',1.53),('8975','2014-02-24','07:35:00',1.07),('8975','2014-02-24','07:40:00',1.19),('8975','2014-02-24','07:45:00',1.3),('8975','2014-02-24','07:50:00',1.41),('8975','2014-02-24','07:55:00',1.51),('8975','2014-02-24','08:00:00',1.6),('8975','2014-02-24','08:05:00',1.68),('8975','2014-02-24','08:10:00',1.75),('8975','2014-02-24','08:15:00',1.83),('8975','2014-02-24','08:20:00',1.9),('8975','2014-02-24','08:25:00',1.97),('8975','2014-02-24','08:30:00',2.02),('8975','2014-02-24','08:35:00',2.09),('8975','2014-02-24','08:40:00',2.15),('8975','2014-02-24','08:45:00',2.22),('8975','2014-02-24','08:50:00',2.29),('8975','2014-02-24','08:55:00',2.35),('8975','2014-02-24','09:00:00',2.42),('8975','2014-02-24','09:05:00',2.34),('8975','2014-02-24','09:10:00',2.4),('8975','2014-02-24','09:15:00',2.25),('8975','2014-02-24','09:20:00',2.27),('8975','2014-02-24','09:25:00',2.45),('8975','2014-02-24','09:30:00',2.32),('8975','2014-02-24','09:35:00',2.06),('8975','2014-02-24','09:40:00',2.77),('8975','2014-02-24','09:45:00',2.91),('8975','2014-02-24','09:50:00',2.91),('8975','2014-02-24','09:55:00',2.93),('8975','2014-02-24','10:00:00',3.08),('8975','2014-02-24','10:05:00',2.85),('8975','2014-02-24','10:10:00',2.88),('8975','2014-02-24','10:15:00',3.1),('8975','2014-02-24','10:20:00',2.78),('8975','2014-02-24','10:25:00',2.98),('8975','2014-02-24','10:30:00',3.09),('8975','2014-02-24','10:35:00',2.91),('8975','2014-02-24','10:40:00',3.29),('8975','2014-02-24','10:45:00',3.37),('8975','2014-02-24','10:50:00',3.39),('8975','2014-02-24','10:55:00',3.38),('8975','2014-02-24','11:00:00',3.4),('8975','2014-02-24','11:05:00',3.42),('8975','2014-02-24','11:10:00',3.45),('8975','2014-02-24','11:15:00',3.49),('8975','2014-02-24','11:20:00',3.48),('8975','2014-02-24','11:25:00',3.53),('8975','2014-02-24','11:30:00',3.53),('8975','2014-02-24','11:35:00',3.51),('8975','2014-02-24','11:40:00',3.55),('8975','2014-02-24','11:45:00',3.53),('8975','2014-02-24','11:50:00',3.54),('8975','2014-02-24','11:55:00',3.55),('8975','2014-02-24','12:00:00',3.43),('8975','2014-02-24','12:05:00',3.45),('8975','2014-02-24','12:10:00',3.37),('8975','2014-02-24','12:15:00',3.38),('8975','2014-02-24','12:20:00',3.47),('8975','2014-02-24','12:25:00',3.45),('8975','2014-02-24','12:30:00',3.41),('8975','2014-02-24','12:35:00',3.32),('8975','2014-02-24','12:40:00',3.25),('8975','2014-02-24','12:45:00',3.23),('8975','2014-02-24','12:50:00',2.38),('8975','2014-02-24','12:55:00',1.42),('8975','2014-02-24','13:00:00',2.94),('8975','2014-02-24','13:05:00',1.81),('8975','2014-02-24','13:30:00',1.27),('8975','2014-02-24','13:35:00',1.41),('8975','2014-02-24','13:40:00',1.35),('8975','2014-02-24','13:45:00',1.16),('8975','2014-02-24','13:50:00',1.28),('8975','2014-02-24','13:55:00',1.34),('8975','2014-02-24','14:00:00',1.18),('8975','2014-02-24','14:05:00',1.13),('8975','2014-02-24','14:10:00',1.11),('8975','2014-02-24','14:15:00',1.22),('8975','2014-02-24','14:20:00',1.85),('8975','2014-02-24','14:25:00',2.36),('8975','2014-02-24','14:30:00',2.15),('8975','2014-02-24','14:35:00',1.79),('8975','2014-02-24','14:40:00',2.47),('8975','2014-02-24','14:45:00',2.08),('8975','2014-02-24','14:50:00',1.55),('8975','2014-02-24','14:55:00',1.87),('8975','2014-02-24','15:00:00',1.95),('8975','2014-02-24','15:05:00',1.79),('8975','2014-02-24','15:10:00',1.77),('8975','2014-02-24','15:15:00',1.16),('8975','2014-02-24','15:20:00',1.71),('8975','2014-02-24','15:25:00',1.61),('8975','2014-02-24','15:30:00',1.38),('8975','2014-02-24','15:35:00',1.2),('8975','2014-02-24','15:40:00',1.38),('8975','2014-02-24','15:45:00',1.06),('8975','2014-02-24','16:20:00',1.01),('8975','2014-02-23','07:30:00',1.05),('8975','2014-02-23','07:35:00',1.16),('8975','2014-02-23','07:40:00',1.11),('8975','2014-02-23','07:45:00',1.26),('8975','2014-02-23','07:50:00',1.39),('8975','2014-02-23','07:55:00',1.52),('8975','2014-02-23','08:00:00',1.69),('8975','2014-02-23','08:05:00',1.94),('8975','2014-02-23','08:10:00',2.12),('8975','2014-02-23','08:15:00',2.23),('8975','2014-02-23','08:20:00',2.3),('8975','2014-02-23','08:25:00',2.39),('8975','2014-02-23','08:30:00',2.27),('8975','2014-02-23','08:35:00',2.47),('8975','2014-02-23','08:40:00',2.76),('8975','2014-02-23','08:45:00',1.76),('8975','2014-02-23','08:50:00',2.12),('8975','2014-02-23','08:55:00',2.45),('8975','2014-02-23','09:00:00',2.42),('8975','2014-02-23','09:05:00',2.43),('8975','2014-02-23','09:10:00',2.49),('8975','2014-02-23','09:15:00',2.55),('8975','2014-02-23','09:20:00',2.63),('8975','2014-02-23','09:25:00',2.67),('8975','2014-02-23','09:30:00',2.71),('8975','2014-02-23','09:35:00',2.79),('8975','2014-02-23','09:40:00',2.87),('8975','2014-02-23','09:45:00',2.94),('8975','2014-02-23','09:50:00',3),('8975','2014-02-23','09:55:00',3.08),('8975','2014-02-23','10:00:00',3.14),('8975','2014-02-23','10:05:00',3.13),('8975','2014-02-23','10:10:00',3.2),('8975','2014-02-23','10:15:00',3.25),('8975','2014-02-23','10:20:00',3.29),('8975','2014-02-23','10:25:00',3.32),('8975','2014-02-23','10:30:00',3.35),('8975','2014-02-23','10:35:00',3.41),('8975','2014-02-23','10:40:00',3.44),('8975','2014-02-23','10:45:00',3.48),('8975','2014-02-23','10:50:00',3.53),('8975','2014-02-23','10:55:00',3.55),('8975','2014-02-23','11:00:00',3.54),('8975','2014-02-23','11:05:00',3.57),('8975','2014-02-23','11:10:00',3.6),('8975','2014-02-23','11:15:00',3.6),('8975','2014-02-23','11:20:00',3.67),('8975','2014-02-23','11:25:00',3.77),('8975','2014-02-23','11:30:00',3.94),('8975','2014-02-23','11:35:00',4.28),('8975','2014-02-23','11:40:00',4.13),('8975','2014-02-23','11:45:00',3.47),('8975','2014-02-23','11:50:00',4.17),('8975','2014-02-23','11:55:00',3.72),('8975','2014-02-23','12:00:00',3.07),('8975','2014-02-23','12:05:00',3.34),('8975','2014-02-23','12:10:00',3.51),('8975','2014-02-23','12:15:00',3.76),('8975','2014-02-23','12:20:00',3.76),('8975','2014-02-23','12:25:00',3.7),('8975','2014-02-23','12:30:00',3.87),('8975','2014-02-23','12:35:00',4.01),('8975','2014-02-23','12:40:00',2.32),('8975','2014-02-23','12:45:00',3.67),('8975','2014-02-23','12:50:00',2.69),('8975','2014-02-23','12:55:00',3.56),('8975','2014-02-23','13:00:00',3.58),('8975','2014-02-23','13:05:00',3.58),('8975','2014-02-23','13:10:00',3.29),('8975','2014-02-23','13:15:00',4.03),('8975','2014-02-23','13:20:00',3.87),('8975','2014-02-23','13:25:00',1.56),('8975','2014-02-23','13:30:00',1.12),('8975','2014-02-23','13:35:00',1.01),('8975','2014-02-23','14:10:00',1.03),('8975','2014-02-23','14:15:00',1.12),('8975','2014-02-23','14:20:00',1.15),('8975','2014-02-23','14:25:00',1.17),('8975','2014-02-23','14:30:00',1.26),('8975','2014-02-23','14:35:00',1.26),('8975','2014-02-23','14:40:00',1.19),('8975','2014-02-23','14:45:00',1.2),('8975','2014-02-23','14:50:00',1.24),('8975','2014-02-23','14:55:00',1.18),('8975','2014-02-23','15:00:00',1.05),('8975','2014-02-23','15:10:00',1.06),('8975','2014-02-23','15:15:00',1.15),('8975','2014-02-23','15:20:00',1.34),('8975','2014-02-23','15:25:00',2.1),('8975','2014-02-23','15:30:00',1.87),('8975','2014-02-23','15:35:00',1.91),('8975','2014-02-23','15:40:00',1.96),('8975','2014-02-23','15:45:00',1.93),('8975','2014-02-23','15:50:00',1.85),('8975','2014-02-23','15:55:00',1.91),('8975','2014-02-23','16:00:00',1.97),('8975','2014-02-23','16:05:00',1.95),('8975','2014-02-23','16:10:00',1.88),('8975','2014-02-23','16:15:00',1.74),('8975','2014-02-23','16:20:00',1.48),('8975','2014-02-23','16:25:00',1.29),('8975','2014-02-23','16:30:00',1.02),('8975','2014-02-22','07:40:00',1.09),('8975','2014-02-22','07:45:00',1.28),('8975','2014-02-22','07:50:00',1.39),('8975','2014-02-22','07:55:00',1.48),('8975','2014-02-22','08:00:00',1.57),('8975','2014-02-22','08:05:00',1.65),('8975','2014-02-22','08:10:00',1.72),('8975','2014-02-22','08:15:00',1.79),('8975','2014-02-22','08:20:00',1.87),('8975','2014-02-22','08:25:00',1.94),('8975','2014-02-22','08:30:00',2),('8975','2014-02-22','08:35:00',2.07),('8975','2014-02-22','08:40:00',2.13),('8975','2014-02-22','08:45:00',2.2),('8975','2014-02-22','08:50:00',2.26),('8975','2014-02-22','08:55:00',2.32),('8975','2014-02-22','09:00:00',2.38),('8975','2014-02-22','09:05:00',2.46),('8975','2014-02-22','09:10:00',2.54),('8975','2014-02-22','09:15:00',2.63),('8975','2014-02-22','09:20:00',2.69),('8975','2014-02-22','09:25:00',2.54),('8975','2014-02-22','09:30:00',2.4),('8975','2014-02-22','09:35:00',2.67),('8975','2014-02-22','09:40:00',2.81),('8975','2014-02-22','09:45:00',2.89),('8975','2014-02-22','09:50:00',2.93),('8975','2014-02-22','09:55:00',2.99),('8975','2014-02-22','10:00:00',3.05),('8975','2014-02-22','10:05:00',3.08),('8975','2014-02-22','10:10:00',3.1),('8975','2014-02-22','10:15:00',3.12),('8975','2014-02-22','10:20:00',3.15),('8975','2014-02-22','10:25:00',3.23),('8975','2014-02-22','10:30:00',3.29),('8975','2014-02-22','10:35:00',3.3),('8975','2014-02-22','10:40:00',3.3),('8975','2014-02-22','10:45:00',3.36),('8975','2014-02-22','10:50:00',3.43),('8975','2014-02-22','10:55:00',3.43),('8975','2014-02-22','11:00:00',3.48),('8975','2014-02-22','11:05:00',3.52),('8975','2014-02-22','11:10:00',3.57),('8975','2014-02-22','11:15:00',3.64),('8975','2014-02-22','11:20:00',3.36),('8975','2014-02-22','11:25:00',3.62),('8975','2014-02-22','11:30:00',3.13),('8975','2014-02-22','11:35:00',3.73),('8975','2014-02-22','11:40:00',3.71),('8975','2014-02-22','11:45:00',3.82),('8975','2014-02-22','11:50:00',3.89),('8975','2014-02-22','11:55:00',3.86),('8975','2014-02-22','12:00:00',3.69),('8975','2014-02-22','12:05:00',3.82),('8975','2014-02-22','12:10:00',3.64),('8975','2014-02-22','12:15:00',3.67),('8975','2014-02-22','12:20:00',3.26),('8975','2014-02-22','12:25:00',1.32),('8975','2014-02-22','12:30:00',1.62),('8975','2014-02-22','12:35:00',2.91),('8975','2014-02-22','12:40:00',2.03),('8975','2014-02-22','12:45:00',2.62),('8975','2014-02-22','12:50:00',2.77),('8975','2014-02-22','12:55:00',2.99),('8975','2014-02-22','13:00:00',3),('8975','2014-02-22','13:05:00',3.15),('8975','2014-02-22','13:10:00',3.22),('8975','2014-02-22','13:15:00',2.96),('8975','2014-02-22','13:20:00',3.01),('8975','2014-02-22','13:25:00',2.99),('8975','2014-02-22','13:30:00',2.87),('8975','2014-02-22','13:35:00',2.63),('8975','2014-02-22','13:40:00',2.53),('8975','2014-02-22','13:45:00',2.58),('8975','2014-02-22','13:50:00',2.6),('8975','2014-02-22','13:55:00',2.33),('8975','2014-02-22','14:00:00',1.9),('8975','2014-02-22','14:05:00',2.37),('8975','2014-02-22','14:10:00',2.25),('8975','2014-02-22','14:15:00',2.48),('8975','2014-02-22','14:20:00',1.13),('8975','2014-02-22','14:25:00',2.15),('8975','2014-02-22','14:30:00',2.52),('8975','2014-02-22','14:35:00',1.52),('8975','2014-02-22','14:40:00',2.4),('8975','2014-02-22','14:45:00',2.53),('8975','2014-02-22','14:50:00',1.74),('8975','2014-02-21','09:05:00',1.51),('8975','2014-02-21','09:10:00',1.5),('8975','2014-02-21','09:25:00',1.29),('8975','2014-02-21','09:45:00',1),('8975','2014-02-21','09:50:00',1.11),('8975','2014-02-21','09:55:00',1.11),('8975','2014-02-21','10:00:00',1.97),('8975','2014-02-21','10:05:00',2.57),('8975','2014-02-21','10:10:00',3.13),('8975','2014-02-21','10:15:00',2.67),('8975','2014-02-21','10:20:00',2.17),('8975','2014-02-21','10:25:00',1.96),('8975','2014-02-21','10:30:00',2.17),('8975','2014-02-21','10:35:00',1.79),('8975','2014-02-21','10:40:00',1.57),('8975','2014-02-21','10:45:00',2.47),('8975','2014-02-21','10:50:00',2.67),('8975','2014-02-21','10:55:00',1.21),('8975','2014-02-21','12:00:00',1.06),('8975','2014-02-21','12:05:00',1.11),('8975','2014-02-21','12:10:00',1.65),('8975','2014-02-21','12:15:00',1.97),('8975','2014-02-21','12:20:00',2.39),('8975','2014-02-21','12:25:00',1.85),('8975','2014-02-21','12:30:00',1.32),('8975','2014-02-21','12:35:00',1.24),('8975','2014-02-21','12:40:00',1.47),('8975','2014-02-21','12:45:00',2.65),('8975','2014-02-21','12:50:00',2.12),('8975','2014-02-21','12:55:00',1.72),('8975','2014-02-21','13:00:00',1.61),('8975','2014-02-21','13:05:00',2.29),('8975','2014-02-21','13:10:00',3.41),('8975','2014-02-21','13:15:00',2.6),('8975','2014-02-21','13:20:00',2.03),('8975','2014-02-21','13:25:00',1.86),('8975','2014-02-21','13:30:00',2.32),('8975','2014-02-21','13:35:00',1.55),('8975','2014-02-21','13:40:00',1.37),('8975','2014-02-21','13:45:00',1.1),('8975','2014-02-21','13:50:00',2.01),('8975','2014-02-21','13:55:00',1.1),('8975','2014-02-21','14:00:00',2.71),('8975','2014-02-21','14:05:00',2.59),('8975','2014-02-21','14:10:00',1.04),('8975','2014-02-21','14:15:00',1.36),('8975','2014-02-21','14:20:00',2.73),('8975','2014-02-21','14:25:00',1.64),('8975','2014-02-21','14:30:00',2.31),('8975','2014-02-21','14:35:00',2.02),('8975','2014-02-21','14:40:00',2.07),('8975','2014-02-21','14:45:00',1.87),('8975','2014-02-21','15:00:00',1.24),('8975','2014-02-21','15:05:00',1.67),('8975','2014-02-21','15:10:00',1.05),('8975','2014-02-21','15:20:00',1.48),('8975','2014-02-21','15:40:00',1.43),('8975','2014-02-21','15:45:00',1.05),('8975','2014-02-21','16:00:00',1.12),('8975','2014-02-21','16:05:00',1.35),('8975','2014-02-21','16:10:00',1.35),('8975','2014-02-21','16:15:00',1.22),('8975','2014-02-21','16:20:00',1.2),('8975','2014-02-21','16:25:00',1.04),('8975','2014-02-21','16:30:00',1.01),('8975','2014-02-20','09:35:00',1.13),('8975','2014-02-20','09:40:00',1.24),('8975','2014-02-20','09:45:00',1.4),('8975','2014-02-20','09:50:00',1.45),('8975','2014-02-20','09:55:00',1.38),('8975','2014-02-20','10:00:00',1.57),('8975','2014-02-20','10:05:00',1.65),('8975','2014-02-20','10:10:00',1.55),('8975','2014-02-20','10:15:00',2),('8975','2014-02-20','10:20:00',2.42),('8975','2014-02-20','10:25:00',2.83),('8975','2014-02-20','10:30:00',2.37),('8975','2014-02-20','10:35:00',1.99),('8975','2014-02-20','10:40:00',1.85),('8975','2014-02-20','10:45:00',1.77),('8975','2014-02-20','10:50:00',2.53),('8975','2014-02-20','10:55:00',2.24),('8975','2014-02-20','11:00:00',2.07),('8975','2014-02-20','11:05:00',1.8),('8975','2014-02-20','11:10:00',1.85),('8975','2014-02-20','11:15:00',2),('8975','2014-02-20','11:20:00',1.89),('8975','2014-02-20','11:25:00',1.92),('8975','2014-02-20','11:30:00',1.86),('8975','2014-02-20','11:35:00',1.92),('8975','2014-02-20','11:40:00',1.99),('8975','2014-02-20','11:45:00',1.85),('8975','2014-02-20','11:50:00',1.79),('8975','2014-02-20','11:55:00',2.19),('8975','2014-02-20','12:00:00',2.62),('8975','2014-02-20','12:05:00',2.42),('8975','2014-02-20','12:10:00',2.93),('8975','2014-02-20','12:15:00',1.65),('8975','2014-02-20','12:20:00',1.46),('8975','2014-02-20','12:25:00',1.39),('8975','2014-02-20','12:30:00',1.22),('8975','2014-02-20','12:35:00',1.06),('8975','2014-02-20','14:40:00',1.03),('8975','2014-02-20','14:45:00',1.26),('8975','2014-02-20','14:50:00',1.25),('8975','2014-02-20','14:55:00',1.32),('8975','2014-02-20','15:00:00',1.57),('8975','2014-02-20','15:05:00',1.33),('8975','2014-02-20','15:10:00',1.29),('8975','2014-02-20','15:20:00',1),('8975','2014-02-20','15:30:00',1.16),('8975','2014-02-20','15:35:00',1.22),('8975','2014-02-20','15:40:00',1.21),('8975','2014-02-20','15:45:00',1.41),('8975','2014-02-20','15:50:00',1.35),('8975','2014-02-20','15:55:00',1.29),('8975','2014-02-20','16:00:00',1.25),('8975','2014-02-20','16:05:00',1.2),('8975','2014-02-20','16:10:00',1.16),('8975','2014-02-20','16:15:00',1.11),('8975','2014-02-20','16:20:00',1.06),('8975','2014-02-19','11:20:00',1.23),('8975','2014-02-19','11:25:00',1.27),('8975','2014-02-19','11:30:00',1.24),('8975','2014-02-19','11:55:00',1.02),('8975','2014-02-19','12:00:00',1.07),('8975','2014-02-19','12:20:00',1.08),('8975','2014-02-19','12:25:00',1.22),('8975','2014-02-19','12:30:00',1.15),('8975','2014-02-19','12:35:00',1.13),('8975','2014-02-19','12:40:00',1.45),('8975','2014-02-19','12:45:00',1.38),('8975','2014-02-19','12:50:00',1.2),('8975','2014-02-19','12:55:00',1.33),('8975','2014-02-19','13:00:00',1.45),('8975','2014-02-19','13:15:00',1.42),('8975','2014-02-19','13:20:00',1.1),('8975','2014-02-19','13:25:00',1.05),('8975','2014-02-19','13:30:00',1.42),('8975','2014-02-19','13:35:00',1.23),('8975','2014-02-19','13:40:00',1.04),('8975','2014-02-19','13:55:00',1.04),('8975','2014-02-19','14:00:00',1.29),('8975','2014-02-18','09:20:00',1.05),('8975','2014-02-18','09:25:00',1.19),('8975','2014-02-18','09:30:00',1.25),('8975','2014-02-18','09:35:00',1.41),('8975','2014-02-18','09:40:00',1.55),('8975','2014-02-18','09:45:00',1.72),('8975','2014-02-18','09:50:00',1.63),('8975','2014-02-18','09:55:00',1.53),('8975','2014-02-18','10:00:00',1.48),('8975','2014-02-18','10:05:00',1.49),('8975','2014-02-18','10:10:00',1.6),('8975','2014-02-18','10:15:00',1.65),('8975','2014-02-18','10:20:00',1.49),('8975','2014-02-18','10:25:00',1.56),('8975','2014-02-18','10:30:00',1.67),('8975','2014-02-18','10:35:00',1.76),('8975','2014-02-18','10:40:00',2.05),('8975','2014-02-18','10:45:00',2.16),('8975','2014-02-18','10:50:00',1.98),('8975','2014-02-18','10:55:00',1.78),('8975','2014-02-18','11:00:00',1.66),('8975','2014-02-18','11:05:00',1.82),('8975','2014-02-18','11:10:00',2.06),('8975','2014-02-18','11:15:00',1.96),('8975','2014-02-18','11:20:00',2.08),('8975','2014-02-18','11:25:00',1.98),('8975','2014-02-18','11:30:00',2.09),('8975','2014-02-18','11:35:00',2.23),('8975','2014-02-18','11:40:00',1.86),('8975','2014-02-18','11:45:00',2),('8975','2014-02-18','11:50:00',2.07),('8975','2014-02-18','11:55:00',1.7),('8975','2014-02-18','12:00:00',1.83),('8975','2014-02-18','12:05:00',1.85),('8975','2014-02-18','12:10:00',1.58),('8975','2014-02-18','12:15:00',1.45),('8975','2014-02-18','12:20:00',1.24),('8975','2014-02-18','12:25:00',1.48),('8975','2014-02-18','12:30:00',1.65),('8975','2014-02-18','12:35:00',1.22),('8975','2014-02-18','12:40:00',1.3),('8975','2014-02-18','12:45:00',1.27),('8975','2014-02-18','13:00:00',1.03),('8975','2014-02-18','13:05:00',1.03),('8975','2014-02-18','13:10:00',1.16),('8975','2014-02-18','13:15:00',1.25),('8975','2014-02-18','13:20:00',1.21),('8975','2014-02-18','13:25:00',1.56),('8975','2014-02-18','13:30:00',1.52),('8975','2014-02-18','13:35:00',1.68),('8975','2014-02-18','13:40:00',1.57),('8975','2014-02-18','13:45:00',1.92),('8975','2014-02-18','13:50:00',1.97),('8975','2014-02-18','13:55:00',1.88),('8975','2014-02-18','14:00:00',1.66),('8975','2014-02-18','14:05:00',1.89),('8975','2014-02-18','14:10:00',1.59),('8975','2014-02-18','14:15:00',1.63),('8975','2014-02-18','14:20:00',2.15),('8975','2014-02-18','14:25:00',1.73),('8975','2014-02-18','14:30:00',1.53),('8975','2014-02-18','14:35:00',1.7),('8975','2014-02-18','14:40:00',1.35),('8975','2014-02-18','14:45:00',1.45),('8975','2014-02-18','14:50:00',1.49),('8975','2014-02-18','14:55:00',1.36),('8975','2014-02-18','15:00:00',1.25),('8975','2014-02-18','15:05:00',1.36),('8975','2014-02-18','15:10:00',1.24),('8975','2014-02-18','15:15:00',1.4),('8975','2014-02-18','15:20:00',1.12),('8975','2014-02-18','15:25:00',1.26),('8975','2014-02-18','15:30:00',1.05),('8975','2014-02-18','15:45:00',1.04),('8975','2014-02-18','15:50:00',1.25),('8975','2014-02-18','15:55:00',1.02),('8975','2014-02-17','07:45:00',1.1),('8975','2014-02-17','07:50:00',1.21),('8975','2014-02-17','07:55:00',1.3),('8975','2014-02-17','08:00:00',1.39),('8975','2014-02-17','08:05:00',1.46),('8975','2014-02-17','08:10:00',1.52),('8975','2014-02-17','08:15:00',1.6),('8975','2014-02-17','08:20:00',1.67),('8975','2014-02-17','08:25:00',1.73),('8975','2014-02-17','08:30:00',1.8),('8975','2014-02-17','08:35:00',1.85),('8975','2014-02-17','08:40:00',1.91),('8975','2014-02-17','08:45:00',1.97),('8975','2014-02-17','08:50:00',1.96),('8975','2014-02-17','08:55:00',2.09),('8975','2014-02-17','09:00:00',2.14),('8975','2014-02-17','09:05:00',2.19),('8975','2014-02-17','09:10:00',2.25),('8975','2014-02-17','09:15:00',2.29),('8975','2014-02-17','09:20:00',2.35),('8975','2014-02-17','09:25:00',2.41),('8975','2014-02-17','09:30:00',2.44),('8975','2014-02-17','09:35:00',2.47),('8975','2014-02-17','09:40:00',2.53),('8975','2014-02-17','09:45:00',2.6),('8975','2014-02-17','09:50:00',2.68),('8975','2014-02-17','09:55:00',2.76),('8975','2014-02-17','10:00:00',2.81),('8975','2014-02-17','10:05:00',2.87),('8975','2014-02-17','10:10:00',2.87),('8975','2014-02-17','10:15:00',2.9),('8975','2014-02-17','10:20:00',2.92),('8975','2014-02-17','10:25:00',2.96),('8975','2014-02-17','10:30:00',2.98),('8975','2014-02-17','10:35:00',3.02),('8975','2014-02-17','10:40:00',3.05),('8975','2014-02-17','10:45:00',3.08),('8975','2014-02-17','10:50:00',3.12),('8975','2014-02-17','10:55:00',3.16),('8975','2014-02-17','11:00:00',3.08),('8975','2014-02-17','11:05:00',2.66),('8975','2014-02-17','11:10:00',2.46),('8975','2014-02-17','11:15:00',2.26),('8975','2014-02-17','11:20:00',2.95),('8975','2014-02-17','11:25:00',3.3),('8975','2014-02-17','11:30:00',2.9),('8975','2014-02-17','11:35:00',2.38),('8975','2014-02-17','11:40:00',2.35),('8975','2014-02-17','11:45:00',2.38),('8975','2014-02-17','11:50:00',1.94),('8975','2014-02-17','11:55:00',1.7),('8975','2014-02-17','12:00:00',1.72),('8975','2014-02-17','12:05:00',1.77),('8975','2014-02-17','12:10:00',2),('8975','2014-02-17','12:15:00',2.04),('8975','2014-02-17','12:20:00',2.06),('8975','2014-02-17','12:25:00',2.37),('8975','2014-02-17','12:30:00',2.4),('8975','2014-02-17','12:35:00',1.9),('8975','2014-02-17','12:40:00',1.86),('8975','2014-02-17','12:45:00',1.78),('8975','2014-02-17','12:50:00',1.85),('8975','2014-02-17','12:55:00',1.88),('8975','2014-02-17','13:00:00',1.59),('8975','2014-02-17','13:05:00',1.55),('8975','2014-02-17','13:10:00',1.74),('8975','2014-02-17','13:15:00',2.11),('8975','2014-02-17','13:20:00',2.29),('8975','2014-02-17','13:25:00',2.2),('8975','2014-02-17','13:30:00',1.51),('8975','2014-02-17','13:35:00',1.16),('8975','2014-02-17','13:40:00',1.97),('8975','2014-02-17','13:45:00',1.96),('8975','2014-02-17','13:50:00',1.64),('8975','2014-02-17','13:55:00',1.55),('8975','2014-02-17','14:00:00',2.02),('8975','2014-02-17','14:05:00',2.29),('8975','2014-02-17','14:10:00',1.46),('8975','2014-02-17','14:15:00',1.15),('8975','2014-02-17','14:20:00',1.09),('8975','2014-02-17','14:25:00',1.32),('8975','2014-02-17','14:30:00',1.54),('8975','2014-02-17','14:35:00',1.46),('8975','2014-02-17','14:40:00',1.28),('8975','2014-02-17','14:45:00',1.2),('8975','2014-02-17','14:50:00',1.14),('8975','2014-02-17','14:55:00',1.09),('8975','2014-02-17','15:00:00',1.03),('8975','2014-02-17','15:35:00',1.17),('8975','2014-02-17','15:40:00',1.37),('8975','2014-02-17','15:45:00',1.4),('8975','2014-02-17','15:50:00',1.16),('8975','2014-02-17','15:55:00',1.05),('8975','2014-02-17','16:00:00',1.05),('8975','2014-02-17','16:05:00',1.18),('8975','2014-02-16','07:55:00',1.07),('8975','2014-02-16','08:00:00',1.15),('8975','2014-02-16','08:05:00',1.22),('8975','2014-02-16','08:10:00',1.31),('8975','2014-02-16','08:15:00',1.37),('8975','2014-02-16','08:20:00',1.46),('8975','2014-02-16','08:25:00',1.54),('8975','2014-02-16','08:30:00',1.62),('8975','2014-02-16','08:35:00',1.67),('8975','2014-02-16','08:40:00',1.72),('8975','2014-02-16','08:45:00',1.78),('8975','2014-02-16','08:50:00',1.81),('8975','2014-02-16','08:55:00',1.84),('8975','2014-02-16','09:00:00',1.91),('8975','2014-02-16','09:05:00',1.97),('8975','2014-02-16','09:10:00',2.09),('8975','2014-02-16','09:15:00',2.17),('8975','2014-02-16','09:20:00',2.22),('8975','2014-02-16','09:25:00',2.28),('8975','2014-02-16','09:30:00',2.32),('8975','2014-02-16','09:35:00',2.37),('8975','2014-02-16','09:40:00',2.39),('8975','2014-02-16','09:45:00',2.44),('8975','2014-02-16','09:50:00',2.52),('8975','2014-02-16','09:55:00',2.58),('8975','2014-02-16','10:00:00',2.61),('8975','2014-02-16','10:05:00',2.67),('8975','2014-02-16','10:10:00',2.67),('8975','2014-02-16','10:15:00',2.67),('8975','2014-02-16','10:20:00',2.68),('8975','2014-02-16','10:25:00',2.69),('8975','2014-02-16','10:30:00',2.74),('8975','2014-02-16','10:35:00',2.74),('8975','2014-02-16','10:40:00',2.77),('8975','2014-02-16','10:45:00',2.8),('8975','2014-02-16','10:50:00',2.84),('8975','2014-02-16','10:55:00',2.86),('8975','2014-02-16','11:00:00',2.89),('8975','2014-02-16','11:05:00',2.95),('8975','2014-02-16','11:10:00',3.01),('8975','2014-02-16','11:15:00',3.05),('8975','2014-02-16','11:20:00',3.09),('8975','2014-02-16','11:25:00',3.12),('8975','2014-02-16','11:30:00',3.14),('8975','2014-02-16','11:35:00',3.16),('8975','2014-02-16','11:40:00',3.17),('8975','2014-02-16','11:45:00',3.14),('8975','2014-02-16','11:50:00',3.08),('8975','2014-02-16','11:55:00',3.09),('8975','2014-02-16','12:00:00',3.01),('8975','2014-02-16','12:05:00',2.83),('8975','2014-02-16','12:10:00',2.92),('8975','2014-02-16','12:15:00',2.88),('8975','2014-02-16','12:20:00',2.87),('8975','2014-02-16','12:25:00',2.89),('8975','2014-02-16','12:30:00',2.87),('8975','2014-02-16','12:35:00',2.85),('8975','2014-02-16','12:40:00',2.82),('8975','2014-02-16','12:45:00',2.79),('8975','2014-02-16','12:50:00',2.79),('8975','2014-02-16','12:55:00',2.77),('8975','2014-02-16','13:00:00',2.73),('8975','2014-02-16','13:05:00',2.63),('8975','2014-02-16','13:10:00',2.65),('8975','2014-02-16','13:15:00',2.62),('8975','2014-02-16','13:20:00',2.56),('8975','2014-02-16','13:25:00',2.6),('8975','2014-02-16','13:30:00',2.6),('8975','2014-02-16','13:35:00',2.56),('8975','2014-02-16','13:40:00',2.48),('8975','2014-02-16','13:45:00',2.36),('8975','2014-02-16','13:50:00',2.29),('8975','2014-02-16','13:55:00',2.23),('8975','2014-02-16','14:00:00',2.16),('8975','2014-02-16','14:05:00',2.25),('8975','2014-02-16','14:10:00',2.14),('8975','2014-02-16','14:15:00',2.06),('8975','2014-02-16','14:20:00',2.13),('8975','2014-02-16','14:25:00',2.04),('8975','2014-02-16','14:30:00',1.99),('8975','2014-02-16','14:35:00',1.89),('8975','2014-02-16','14:40:00',1.78),('8975','2014-02-16','14:45:00',1.89),('8975','2014-02-16','14:50:00',1.7),('8975','2014-02-16','14:55:00',1.73),('8975','2014-02-16','15:00:00',1.65),('8975','2014-02-16','15:05:00',1.61),('8975','2014-02-16','15:10:00',1.55),('8975','2014-02-16','15:15:00',1.55),('8975','2014-02-16','15:20:00',1.52),('8975','2014-02-16','15:25:00',1.42),('8975','2014-02-16','15:30:00',1.4),('8975','2014-02-16','15:35:00',1.33),('8975','2014-02-16','15:40:00',1.26),('8975','2014-02-16','15:45:00',1.25),('8975','2014-02-16','15:50:00',1.2),('8975','2014-02-16','15:55:00',1.14),('8975','2014-02-16','16:00:00',1.08),('8975','2014-02-16','16:05:00',1.06),('8975','2014-02-16','16:10:00',1.01),('8975','2014-02-15','07:45:00',1.08),('8975','2014-02-15','07:50:00',1.17),('8975','2014-02-15','07:55:00',1.22),('8975','2014-02-15','08:00:00',1.34),('8975','2014-02-15','08:05:00',1.44),('8975','2014-02-15','08:10:00',1.52),('8975','2014-02-15','08:15:00',1.6),('8975','2014-02-15','08:20:00',1.69),('8975','2014-02-15','08:25:00',1.76),('8975','2014-02-15','08:30:00',1.83),('8975','2014-02-15','08:35:00',1.9),('8975','2014-02-15','08:40:00',1.88),('8975','2014-02-15','08:45:00',2.03),('8975','2014-02-15','08:50:00',2.02),('8975','2014-02-15','08:55:00',2.02),('8975','2014-02-15','09:00:00',2.21),('8975','2014-02-15','09:05:00',2.3),('8975','2014-02-15','09:10:00',2.21),('8975','2014-02-15','09:15:00',2.04),('8975','2014-02-15','09:20:00',2.43),('8975','2014-02-15','09:25:00',2.29),('8975','2014-02-15','09:30:00',2.28),('8975','2014-02-15','09:35:00',1.78),('8975','2014-02-15','09:40:00',2.42),('8975','2014-02-15','09:45:00',2.51),('8975','2014-02-15','09:50:00',2.68),('8975','2014-02-15','09:55:00',2.61),('8975','2014-02-15','10:00:00',2.74),('8975','2014-02-15','10:05:00',2.84),('8975','2014-02-15','10:10:00',2.85),('8975','2014-02-15','10:15:00',2.9),('8975','2014-02-15','10:20:00',2.97),('8975','2014-02-15','10:25:00',3.02),('8975','2014-02-15','10:30:00',2.98),('8975','2014-02-15','10:35:00',3.18),('8975','2014-02-15','10:40:00',3.21),('8975','2014-02-15','10:45:00',3.22),('8975','2014-02-15','10:50:00',2.54),('8975','2014-02-15','10:55:00',2.81),('8975','2014-02-15','11:00:00',3.2),('8975','2014-02-15','11:05:00',3.27),('8975','2014-02-15','11:10:00',3.09),('8975','2014-02-15','11:15:00',3.31),('8975','2014-02-15','11:20:00',3.17),('8975','2014-02-15','11:25:00',3.25),('8975','2014-02-15','11:30:00',3.21),('8975','2014-02-15','11:35:00',3.18),('8975','2014-02-15','11:40:00',3.18),('8975','2014-02-15','11:45:00',2.74),('8975','2014-02-15','11:50:00',3.21),('8975','2014-02-15','11:55:00',2.77),('8975','2014-02-15','12:00:00',2.93),('8975','2014-02-15','12:05:00',2.64),('8975','2014-02-15','12:10:00',2.94),('8975','2014-02-15','12:15:00',3.06),('8975','2014-02-15','12:20:00',3.06),('8975','2014-02-15','12:25:00',3.02),('8975','2014-02-15','12:30:00',3.01),('8975','2014-02-15','12:35:00',3.01),('8975','2014-02-15','12:40:00',2.96),('8975','2014-02-15','12:45:00',2.96),('8975','2014-02-15','12:50:00',2.93),('8975','2014-02-15','12:55:00',2.87),('8975','2014-02-15','13:00:00',2.74),('8975','2014-02-15','13:05:00',2.58),('8975','2014-02-15','13:10:00',2.63),('8975','2014-02-15','13:15:00',2.64),('8975','2014-02-15','13:20:00',2.45),('8975','2014-02-15','13:25:00',2.6),('8975','2014-02-15','13:30:00',2.65),('8975','2014-02-15','13:35:00',2.6),('8975','2014-02-15','13:40:00',2.57),('8975','2014-02-15','13:45:00',2.46),('8975','2014-02-15','13:50:00',2.19),('8975','2014-02-15','13:55:00',2.33),('8975','2014-02-15','14:00:00',2.32),('8975','2014-02-15','14:05:00',2.3),('8975','2014-02-15','14:10:00',2.2),('8975','2014-02-15','14:15:00',2.15),('8975','2014-02-15','14:20:00',2.14),('8975','2014-02-15','14:25:00',2.12),('8975','2014-02-15','14:30:00',2.06),('8975','2014-02-15','14:35:00',1.91),('8975','2014-02-15','14:40:00',1.91),('8975','2014-02-15','14:45:00',1.88),('8975','2014-02-15','14:50:00',1.82),('8975','2014-02-15','14:55:00',1.75),('8975','2014-02-15','15:00:00',1.69),('8975','2014-02-15','15:05:00',1.65),('8975','2014-02-15','15:10:00',1.52),('8975','2014-02-15','15:15:00',1.51),('8975','2014-02-15','15:20:00',1.43),('8975','2014-02-15','15:25:00',1.39),('8975','2014-02-15','15:30:00',1.36),('8975','2014-02-15','15:35:00',1.27),('8975','2014-02-15','15:40:00',1.25),('8975','2014-02-15','15:45:00',1.31),('8975','2014-02-15','16:20:00',1.05),('8975','2014-02-15','16:25:00',1.34),('8975','2014-02-15','16:30:00',1.3),('8975','2014-02-15','16:35:00',1.11),('8975','2014-04-27','07:20:00',1.89),('8975','2014-04-27','07:25:00',1.47),('8975','2014-04-27','07:45:00',1.01),('8975','2014-04-27','07:50:00',1.1),('8975','2014-04-27','07:55:00',1.27),('8975','2014-04-27','08:00:00',1.52),('8975','2014-04-27','08:05:00',1.23),('8975','2014-04-27','08:10:00',1.44),('8975','2014-04-27','08:15:00',3.59),('8975','2014-04-27','08:20:00',4.43),('8975','2014-04-27','08:25:00',3.72),('8975','2014-04-27','08:30:00',2.73),('8975','2014-04-27','08:35:00',1.82),('8975','2014-04-27','08:40:00',1.79),('8975','2014-04-27','08:45:00',2.09),('8975','2014-04-27','08:50:00',3.24),('8975','2014-04-27','08:55:00',1.94),('8975','2014-04-27','09:00:00',2.53),('8975','2014-04-27','09:05:00',4.33),('8975','2014-04-27','09:10:00',3.95),('8975','2014-04-27','09:15:00',5.63),('8975','2014-04-27','09:20:00',4.61),('8975','2014-04-27','09:25:00',3.59),('8975','2014-04-27','09:30:00',3.5),('8975','2014-04-27','09:35:00',2.9),('8975','2014-04-27','09:40:00',3.19),('8975','2014-04-27','09:45:00',2.91),('8975','2014-04-27','09:50:00',2.85),('8975','2014-04-27','09:55:00',3.05),('8975','2014-04-27','10:00:00',3.66),('8975','2014-04-27','10:05:00',4.43),('8975','2014-04-27','10:10:00',4.09),('8975','2014-04-27','10:15:00',3.17),('8975','2014-04-27','10:20:00',2.78),('8975','2014-04-27','10:25:00',2.01),('8975','2014-04-27','10:35:00',1.19),('8975','2014-04-27','10:40:00',2.02),('8975','2014-04-27','10:45:00',2.62),('8975','2014-04-27','10:50:00',2.61),('8975','2014-04-27','10:55:00',2.77),('8975','2014-04-27','11:00:00',4.88),('8975','2014-04-27','11:05:00',4.46),('8975','2014-04-27','11:10:00',4.19),('8975','2014-04-27','11:15:00',4),('8975','2014-04-27','11:20:00',3.18),('8975','2014-04-27','11:25:00',3.38),('8975','2014-04-27','11:30:00',3.51),('8975','2014-04-27','11:35:00',2.81),('8975','2014-04-27','11:40:00',2.11),('8975','2014-04-27','11:45:00',2.18),('8975','2014-04-27','11:50:00',2.21),('8975','2014-04-27','11:55:00',2.52),('8975','2014-04-27','12:00:00',2.76),('8975','2014-04-27','12:05:00',2.69),('8975','2014-04-27','12:10:00',3.43),('8975','2014-04-27','12:15:00',4),('8975','2014-04-27','12:20:00',4.3),('8975','2014-04-27','12:25:00',4.89),('8975','2014-04-27','12:30:00',4.51),('8975','2014-04-27','12:35:00',3.92),('8975','2014-04-27','12:40:00',3.4),('8975','2014-04-27','12:45:00',3.4),('8975','2014-04-27','12:50:00',3.56),('8975','2014-04-27','12:55:00',3.39),('8975','2014-04-27','13:00:00',3.47),('8975','2014-04-27','13:05:00',3.58),('8975','2014-04-27','13:10:00',4.21),('8975','2014-04-27','13:15:00',3.56),('8975','2014-04-27','13:20:00',4.03),('8975','2014-04-27','13:25:00',4.7),('8975','2014-04-27','13:30:00',6.21),('8975','2014-04-27','13:35:00',6.95),('8975','2014-04-27','13:40:00',5.29),('8975','2014-04-27','13:45:00',4.93),('8975','2014-04-27','13:50:00',5.27),('8975','2014-04-27','13:55:00',7.07),('8975','2014-04-27','14:00:00',5.61),('8975','2014-04-27','14:05:00',7.69),('8975','2014-04-27','14:10:00',5.52),('8975','2014-04-27','14:15:00',5.64),('8975','2014-04-27','14:20:00',4.2),('8975','2014-04-27','14:25:00',2.83),('8975','2014-04-27','14:30:00',3.17),('8975','2014-04-27','14:35:00',3.47),('8975','2014-04-27','14:40:00',5.61),('8975','2014-04-27','14:45:00',5.28),('8975','2014-04-27','14:50:00',5.33),('8975','2014-04-27','14:55:00',4.73),('8975','2014-04-27','15:00:00',4.71),('8975','2014-04-27','15:05:00',5.13),('8975','2014-04-27','15:10:00',3.93),('8975','2014-04-27','15:15:00',2.8),('8975','2014-04-27','15:20:00',4.77),('8975','2014-04-27','15:25:00',2.96),('8975','2014-04-27','15:30:00',2.41),('8975','2014-04-27','15:35:00',3.51),('8975','2014-04-27','15:40:00',4.88),('8975','2014-04-27','15:45:00',5.33),('8975','2014-04-27','15:50:00',3.3),('8975','2014-04-27','15:55:00',3.34),('8975','2014-04-27','16:00:00',3.4),('8975','2014-04-27','16:05:00',4.55),('8975','2014-04-27','16:10:00',4.45),('8975','2014-04-27','16:15:00',3.46),('8975','2014-04-27','16:20:00',2.7),('8975','2014-04-27','16:25:00',3.15),('8975','2014-04-27','16:30:00',3.08),('8975','2014-04-27','16:35:00',2.11),('8975','2014-04-27','16:40:00',1.05),('8975','2014-04-27','16:45:00',1.02),('8975','2014-04-27','17:20:00',1.49),('8975','2014-04-27','17:25:00',1.45),('8975','2014-04-27','17:30:00',2.31),('8975','2014-04-27','17:35:00',1.99),('8975','2014-04-27','17:40:00',1.33),('8975','2014-02-14','07:50:00',1.06),('8975','2014-02-14','07:55:00',1.17),('8975','2014-02-14','08:00:00',1.26),('8975','2014-02-14','08:05:00',1.34),('8975','2014-02-14','08:10:00',1.42),('8975','2014-02-14','08:15:00',1.48),('8975','2014-02-14','08:20:00',1.55),('8975','2014-02-14','08:25:00',1.63),('8975','2014-02-14','08:30:00',1.7),('8975','2014-02-14','08:35:00',1.76),('8975','2014-02-14','08:40:00',1.81),('8975','2014-02-14','08:45:00',1.88),('8975','2014-02-14','08:50:00',1.88),('8975','2014-02-14','08:55:00',1.85),('8975','2014-02-14','09:00:00',2.05),('8975','2014-02-14','09:05:00',2.12),('8975','2014-02-14','09:10:00',2.18),('8975','2014-02-14','09:15:00',2.21),('8975','2014-02-14','09:20:00',2.27),('8975','2014-02-14','09:25:00',2.33),('8975','2014-02-14','09:30:00',2.39),('8975','2014-02-14','09:35:00',2.39),('8975','2014-02-14','09:40:00',2.41),('8975','2014-02-14','09:45:00',2.5),('8975','2014-02-14','09:50:00',2.56),('8975','2014-02-14','09:55:00',2.64),('8975','2014-02-14','10:00:00',2.7),('8975','2014-02-14','10:05:00',2.75),('8975','2014-02-14','10:10:00',2.77),('8975','2014-02-14','10:15:00',2.77),('8975','2014-02-14','10:20:00',2.8),('8975','2014-02-14','10:25:00',2.81),('8975','2014-02-14','10:30:00',2.82),('8975','2014-02-14','10:35:00',2.89),('8975','2014-02-14','10:40:00',2.92),('8975','2014-02-14','10:45:00',2.99),('8975','2014-02-14','10:50:00',3.06),('8975','2014-02-14','10:55:00',2.64),('8975','2014-02-14','11:00:00',3.3),('8975','2014-02-14','11:05:00',3.36),('8975','2014-02-14','11:10:00',3.47),('8975','2014-02-14','11:15:00',3.72),('8975','2014-02-14','11:20:00',3.15),('8975','2014-02-14','11:25:00',2.69),('8975','2014-02-14','11:30:00',1.56),('8975','2014-02-14','11:35:00',3.39),('8975','2014-02-14','11:40:00',2.6),('8975','2014-02-14','11:45:00',3.26),('8975','2014-02-14','11:50:00',3.4),('8975','2014-02-14','11:55:00',3.21),('8975','2014-02-14','12:00:00',3.58),('8975','2014-02-14','12:05:00',3.04),('8975','2014-02-14','12:10:00',3.19),('8975','2014-02-14','12:15:00',3.11),('8975','2014-02-14','12:20:00',1.17),('8975','2014-02-14','12:25:00',3.16),('8975','2014-02-14','12:30:00',3.19),('8975','2014-02-14','12:35:00',3.02),('8975','2014-02-14','12:40:00',3.19),('8975','2014-02-14','12:45:00',3.02),('8975','2014-02-14','12:50:00',2.47),('8975','2014-02-14','12:55:00',3.2),('8975','2014-02-14','13:00:00',2.83),('8975','2014-02-14','13:05:00',2.28),('8975','2014-02-14','13:10:00',2.64),('8975','2014-02-14','13:15:00',2.6),('8975','2014-02-14','13:20:00',2.55),('8975','2014-02-14','13:25:00',2.36),('8975','2014-02-14','13:30:00',2.61),('8975','2014-02-14','13:35:00',2.53),('8975','2014-02-14','13:40:00',2.46),('8975','2014-02-14','13:45:00',2.33),('8975','2014-02-14','13:50:00',1.81),('8975','2014-02-14','13:55:00',2.24),('8975','2014-02-14','14:00:00',2.26),('8975','2014-02-14','14:05:00',2.21),('8975','2014-02-14','14:10:00',2.19),('8975','2014-02-14','14:15:00',2.09),('8975','2014-02-14','14:20:00',2.07),('8975','2014-02-14','14:25:00',2.03),('8975','2014-02-14','14:30:00',1.97),('8975','2014-02-14','14:35:00',1.88),('8975','2014-02-14','14:40:00',1.88),('8975','2014-02-14','14:45:00',1.79),('8975','2014-02-14','14:50:00',1.75),('8975','2014-02-14','14:55:00',1.65),('8975','2014-02-14','15:00:00',1.59),('8975','2014-02-14','15:05:00',1.56),('8975','2014-02-14','15:10:00',1.52),('8975','2014-02-14','15:15:00',1.46),('8975','2014-02-14','15:20:00',1.43),('8975','2014-02-14','15:25:00',1.39),('8975','2014-02-14','15:30:00',1.35),('8975','2014-02-14','15:35:00',1.32),('8975','2014-02-14','15:40:00',1.27),('8975','2014-02-14','15:45:00',1.23),('8975','2014-02-14','15:50:00',1.2),('8975','2014-02-14','15:55:00',1.16),('8975','2014-02-14','16:00:00',1.13),('8975','2014-02-14','16:05:00',1.08),('8975','2014-02-14','16:10:00',1.06),('8975','2014-02-13','08:40:00',1.19),('8975','2014-02-13','08:45:00',1.76),('8975','2014-02-13','08:50:00',1.91),('8975','2014-02-13','08:55:00',1.96),('8975','2014-02-13','09:00:00',2.02),('8975','2014-02-13','09:05:00',1.97),('8975','2014-02-13','09:10:00',1.58),('8975','2014-02-13','09:15:00',1.1),('8975','2014-02-13','09:20:00',1.85),('8975','2014-02-13','09:25:00',2.56),('8975','2014-02-13','09:30:00',1.64),('8975','2014-02-13','09:35:00',2.09),('8975','2014-02-13','09:40:00',1.83),('8975','2014-02-13','09:45:00',1.82),('8975','2014-02-13','09:50:00',2.62),('8975','2014-02-13','09:55:00',2.82),('8975','2014-02-13','10:00:00',2.88),('8975','2014-02-13','10:05:00',2.9),('8975','2014-02-13','10:10:00',2.79),('8975','2014-02-13','10:15:00',2.85),('8975','2014-02-13','10:20:00',2.9),('8975','2014-02-13','10:25:00',2.98),('8975','2014-02-13','10:30:00',2.98),('8975','2014-02-13','10:35:00',3),('8975','2014-02-13','10:40:00',3.02),('8975','2014-02-13','10:45:00',3.13),('8975','2014-02-13','10:50:00',3.16),('8975','2014-02-13','10:55:00',3.19),('8975','2014-02-13','11:00:00',3.24),('8975','2014-02-13','11:05:00',3.23),('8975','2014-02-13','11:10:00',3.24),('8975','2014-02-13','11:15:00',3.25),('8975','2014-02-13','11:20:00',3.26),('8975','2014-02-13','11:25:00',3.27),('8975','2014-02-13','11:30:00',3.28),('8975','2014-02-13','11:35:00',3.31),('8975','2014-02-13','11:40:00',3.3),('8975','2014-02-13','11:45:00',3.31),('8975','2014-02-13','11:50:00',3.32),('8975','2014-02-13','11:55:00',3.18),('8975','2014-02-13','12:00:00',3.26),('8975','2014-02-13','12:05:00',3.25),('8975','2014-02-13','12:10:00',3.2),('8975','2014-02-13','12:15:00',3.1),('8975','2014-02-13','12:20:00',3.15),('8975','2014-02-13','12:25:00',3.12),('8975','2014-02-13','12:30:00',3.09),('8975','2014-02-13','12:35:00',3.08),('8975','2014-02-13','12:40:00',3.05),('8975','2014-02-13','12:45:00',2.97),('8975','2014-02-13','12:50:00',2.95),('8975','2014-02-13','12:55:00',2.91),('8975','2014-02-13','13:00:00',2.78),('8975','2014-02-13','13:05:00',2.83),('8975','2014-02-13','13:10:00',2.77),('8975','2014-02-13','13:15:00',2.59),('8975','2014-02-13','13:20:00',2.76),('8975','2014-02-13','13:25:00',2.68),('8975','2014-02-13','13:30:00',2.67),('8975','2014-02-13','13:35:00',2.62),('8975','2014-02-13','13:40:00',2.54),('8975','2014-02-13','13:45:00',2.47),('8975','2014-02-13','13:50:00',2.37),('8975','2014-02-13','13:55:00',2.24),('8975','2014-02-13','14:00:00',2.27),('8975','2014-02-13','14:05:00',2.25),('8975','2014-02-13','14:10:00',2.23),('8975','2014-02-13','14:15:00',2.16),('8975','2014-02-13','14:20:00',2.11),('8975','2014-02-13','14:25:00',2.09),('8975','2014-02-13','14:30:00',2.02),('8975','2014-02-13','14:35:00',1.97),('8975','2014-02-13','14:40:00',1.9),('8975','2014-02-13','14:45:00',1.8),('8975','2014-02-13','14:50:00',1.76),('8975','2014-02-13','14:55:00',1.72),('8975','2014-02-13','15:00:00',1.65),('8975','2014-02-13','15:05:00',1.6),('8975','2014-02-13','15:10:00',1.55),('8975','2014-02-13','15:15:00',1.5),('8975','2014-02-13','15:20:00',1.45),('8975','2014-02-13','15:25:00',1.4),('8975','2014-02-13','15:30:00',1.36),('8975','2014-02-13','15:35:00',1.25),('8975','2014-02-13','15:40:00',1.13),('8975','2014-02-13','15:55:00',1.1),('8975','2014-02-13','16:05:00',1.06),('8975','2014-02-12','07:50:00',1.03),('8975','2014-02-12','07:55:00',1.13),('8975','2014-02-12','08:00:00',1.23),('8975','2014-02-12','08:05:00',1.33),('8975','2014-02-12','08:10:00',1.39),('8975','2014-02-12','08:15:00',1.37),('8975','2014-02-12','08:20:00',1.53),('8975','2014-02-12','08:25:00',1.43),('8975','2014-02-12','08:30:00',1.37),('8975','2014-02-12','08:35:00',1.65),('8975','2014-02-12','08:40:00',1.62),('8975','2014-02-12','08:45:00',1.78),('8975','2014-02-12','08:50:00',1.77),('8975','2014-02-12','08:55:00',1.94),('8975','2014-02-12','09:00:00',1.63),('8975','2014-02-12','09:05:00',1.2),('8975','2014-02-12','09:10:00',1.89),('8975','2014-02-12','09:15:00',2.11),('8975','2014-02-12','09:20:00',2.06),('8975','2014-02-12','09:25:00',2.13),('8975','2014-02-12','09:30:00',2.08),('8975','2014-02-12','09:35:00',2.4),('8975','2014-02-12','09:40:00',2.07),('8975','2014-02-12','09:45:00',2.26),('8975','2014-02-12','09:50:00',2.5),('8975','2014-02-12','09:55:00',2.62),('8975','2014-02-12','10:00:00',2.73),('8975','2014-02-12','10:05:00',2.79),('8975','2014-02-12','10:10:00',2.78),('8975','2014-02-12','10:15:00',2.77),('8975','2014-02-12','10:20:00',2.78),('8975','2014-02-12','10:25:00',2.84),('8975','2014-02-12','10:30:00',2.87),('8975','2014-02-12','10:35:00',2.92),('8975','2014-02-12','10:40:00',2.93),('8975','2014-02-12','10:45:00',2.97),('8975','2014-02-12','10:50:00',3.02),('8975','2014-02-12','10:55:00',3.03),('8975','2014-02-12','11:00:00',3.08),('8975','2014-02-12','11:05:00',3.09),('8975','2014-02-12','11:10:00',3.1),('8975','2014-02-12','11:15:00',3.12),('8975','2014-02-12','11:20:00',2.97),('8975','2014-02-12','11:25:00',3.19),('8975','2014-02-12','11:30:00',2.81),('8975','2014-02-12','11:35:00',2.13),('8975','2014-02-12','11:40:00',2.8),('8975','2014-02-12','11:45:00',3.41),('8975','2014-02-12','11:50:00',3.64),('8975','2014-02-12','11:55:00',3.62),('8975','2014-02-12','12:00:00',3.44),('8975','2014-02-12','12:05:00',2.94),('8975','2014-02-12','12:10:00',2.47),('8975','2014-02-12','12:15:00',3.25),('8975','2014-02-12','12:20:00',3.68),('8975','2014-02-12','12:25:00',3.51),('8975','2014-02-12','12:30:00',2.43),('8975','2014-02-12','12:35:00',2.14),('8975','2014-02-12','12:40:00',3.3),('8975','2014-02-12','12:45:00',2.99),('8975','2014-02-12','12:50:00',2.94),('8975','2014-02-12','12:55:00',3.08),('8975','2014-02-12','13:00:00',3.04),('8975','2014-02-12','13:05:00',2.9),('8975','2014-02-12','13:10:00',2.76),('8975','2014-02-12','13:15:00',2.68),('8975','2014-02-12','13:20:00',2.77),('8975','2014-02-12','13:25:00',2.73),('8975','2014-02-12','13:30:00',2.69),('8975','2014-02-12','13:35:00',2.64),('8975','2014-02-12','13:40:00',2.55),('8975','2014-02-12','13:45:00',2.31),('8975','2014-02-12','13:50:00',2.36),('8975','2014-02-12','13:55:00',2.32),('8975','2014-02-12','14:00:00',2.27),('8975','2014-02-12','14:05:00',2.24),('8975','2014-02-12','14:10:00',2.21),('8975','2014-02-12','14:15:00',2.16),('8975','2014-02-12','14:20:00',2.15),('8975','2014-02-12','14:25:00',2.09),('8975','2014-02-12','14:30:00',2.05),('8975','2014-02-12','14:35:00',2),('8975','2014-02-12','14:40:00',1.99),('8975','2014-02-12','14:45:00',1.82),('8975','2014-02-12','14:50:00',1.63),('8975','2014-02-12','14:55:00',1.06),('8975','2014-02-12','15:00:00',1.46),('8975','2014-02-12','15:05:00',1.77),('8975','2014-02-12','15:10:00',1.64),('8975','2014-02-12','15:15:00',1.58),('8975','2014-02-12','15:20:00',1.3),('8975','2014-02-12','15:25:00',1.51),('8975','2014-02-12','15:30:00',1.56),('8975','2014-02-12','15:35:00',1.22),('8975','2014-02-12','15:40:00',1.21),('8975','2014-02-11','08:45:00',1.86),('8975','2014-02-11','08:50:00',1.96),('8975','2014-02-11','08:55:00',1.85),('8975','2014-02-11','09:00:00',2.2),('8975','2014-02-11','09:05:00',2.02),('8975','2014-02-11','09:10:00',2.26),('8975','2014-02-11','09:15:00',2.22),('8975','2014-02-11','09:20:00',1.97),('8975','2014-02-11','09:25:00',1.97),('8975','2014-02-11','09:30:00',2.59),('8975','2014-02-11','09:35:00',2.57),('8975','2014-02-11','09:40:00',1.93),('8975','2014-02-11','09:45:00',2.01),('8975','2014-02-11','09:50:00',2.81),('8975','2014-02-11','09:55:00',1.43),('8975','2014-02-11','10:00:00',1.34),('8975','2014-02-11','10:05:00',2.29),('8975','2014-02-11','10:10:00',1.59),('8975','2014-02-11','10:15:00',1.41),('8975','2014-02-11','10:20:00',1.41),('8975','2014-02-11','10:25:00',2.17),('8975','2014-02-11','10:30:00',3.6),('8975','2014-02-11','10:35:00',2.87),('8975','2014-02-11','10:40:00',1.65),('8975','2014-02-11','10:45:00',2.18),('8975','2014-02-11','10:50:00',2.13),('8975','2014-02-11','10:55:00',1.71),('8975','2014-02-11','11:00:00',1.88),('8975','2014-02-11','11:05:00',1.84),('8975','2014-02-11','11:10:00',1.63),('8975','2014-02-11','11:15:00',1.68),('8975','2014-02-11','11:20:00',1.52),('8975','2014-02-11','11:25:00',1.67),('8975','2014-02-11','11:30:00',1.74),('8975','2014-02-11','11:35:00',1.46),('8975','2014-02-11','11:40:00',1.27),('8975','2014-02-11','11:45:00',1.19),('8975','2014-02-11','11:50:00',1.07),('8975','2014-02-11','12:05:00',1.19),('8975','2014-02-11','12:10:00',1.41),('8975','2014-02-11','12:15:00',1.58),('8975','2014-02-11','12:20:00',1.6),('8975','2014-02-11','12:25:00',1.65),('8975','2014-02-11','12:30:00',1.69),('8975','2014-02-11','12:35:00',1.62),('8975','2014-02-11','12:40:00',1.62),('8975','2014-02-11','12:45:00',1.82),('8975','2014-02-11','12:50:00',1.97),('8975','2014-02-11','12:55:00',1.86),('8975','2014-02-11','13:00:00',1.74),('8975','2014-02-11','13:05:00',1.56),('8975','2014-02-11','13:10:00',1.49),('8975','2014-02-11','13:15:00',1.42),('8975','2014-02-11','13:20:00',1.45),('8975','2014-02-11','13:25:00',2.14),('8975','2014-02-11','13:30:00',2.8),('8975','2014-02-11','13:35:00',3.23),('8975','2014-02-11','13:40:00',2.89),('8975','2014-02-11','13:45:00',2.05),('8975','2014-02-11','13:50:00',2.05),('8975','2014-02-11','13:55:00',2.04),('8975','2014-02-11','14:00:00',2.55),('8975','2014-02-11','14:05:00',2.63),('8975','2014-02-11','14:10:00',2.52),('8975','2014-02-11','14:15:00',2.22),('8975','2014-02-11','14:20:00',2.13),('8975','2014-02-11','14:25:00',2.18),('8975','2014-02-11','14:30:00',2.07),('8975','2014-02-11','14:35:00',2.22),('8975','2014-02-11','14:40:00',2.18),('8975','2014-02-11','14:45:00',1.67),('8975','2014-02-11','14:50:00',1.79),('8975','2014-02-11','14:55:00',1.41),('8975','2014-02-11','15:00:00',1.2),('8975','2014-02-11','15:05:00',1.5),('8975','2014-02-11','15:10:00',1.59),('8975','2014-02-11','15:15:00',1.55),('8975','2014-02-11','15:20:00',1.01),('8975','2014-02-11','15:25:00',1.14),('8975','2014-02-11','15:30:00',1.23),('8975','2014-02-11','15:35:00',1.59),('8975','2014-02-11','15:40:00',1.06),('8975','2014-02-10','09:20:00',1.4),('8975','2014-02-10','09:25:00',1.47),('8975','2014-02-10','09:30:00',1.4),('8975','2014-02-10','09:35:00',1.47),('8975','2014-02-10','09:40:00',1.39),('8975','2014-02-10','09:45:00',1.39),('8975','2014-02-10','09:50:00',1.51),('8975','2014-02-10','09:55:00',1.51),('8975','2014-02-10','10:00:00',1.3),('8975','2014-02-10','10:05:00',1.49),('8975','2014-02-10','10:10:00',1.64),('8975','2014-02-10','10:15:00',1.9),('8975','2014-02-10','10:20:00',2.08),('8975','2014-02-10','10:25:00',2.09),('8975','2014-02-10','10:30:00',2.3),('8975','2014-02-10','10:35:00',2.59),('8975','2014-02-10','10:40:00',2.6),('8975','2014-02-10','10:45:00',2.42),('8975','2014-02-10','10:50:00',2.21),('8975','2014-02-10','10:55:00',1.65),('8975','2014-02-10','11:00:00',1.65),('8975','2014-02-10','11:05:00',1.91),('8975','2014-02-10','11:10:00',2.45),('8975','2014-02-10','11:15:00',2.55),('8975','2014-02-10','11:20:00',2.48),('8975','2014-02-10','11:25:00',2.13),('8975','2014-02-10','11:30:00',1.77),('8975','2014-02-10','11:35:00',1.61),('8975','2014-02-10','11:40:00',1.47),('8975','2014-02-10','11:45:00',1.73),('8975','2014-02-10','11:50:00',1.89),('8975','2014-02-10','11:55:00',1.59),('8975','2014-02-10','12:00:00',1.53),('8975','2014-02-10','12:05:00',1.88),('8975','2014-02-10','12:10:00',1.79),('8975','2014-02-10','12:15:00',1.7),('8975','2014-02-10','12:20:00',1.92),('8975','2014-02-10','12:25:00',2.35),('8975','2014-02-10','12:30:00',2.22),('8975','2014-02-10','12:35:00',1.97),('8975','2014-02-10','12:40:00',1.64),('8975','2014-02-10','12:45:00',1.84),('8975','2014-02-10','12:50:00',1.55),('8975','2014-02-10','12:55:00',1.92),('8975','2014-02-10','13:00:00',1.89),('8975','2014-02-10','13:05:00',2.35),('8975','2014-02-10','13:10:00',2.6),('8975','2014-02-10','13:15:00',2.56),('8975','2014-02-10','13:20:00',2.77),('8975','2014-02-10','13:25:00',2.5),('8975','2014-02-10','13:30:00',2.28),('8975','2014-02-10','13:35:00',2.16),('8975','2014-02-10','13:40:00',2.63),('8975','2014-02-10','13:45:00',1.79),('8975','2014-02-10','13:50:00',1.63),('8975','2014-02-10','13:55:00',1.51),('8975','2014-02-10','14:00:00',1.94),('8975','2014-02-10','14:05:00',1.86),('8975','2014-02-10','14:10:00',1.79),('8975','2014-02-10','14:15:00',1.89),('8975','2014-02-10','14:20:00',1.5),('8975','2014-02-10','14:25:00',1.39),('8975','2014-02-10','14:30:00',1.49),('8975','2014-02-10','14:35:00',1.41),('8975','2014-02-10','14:40:00',1.23),('8975','2014-02-10','14:45:00',1.2),('8975','2014-02-10','14:50:00',1.02),('8975','2014-02-10','14:55:00',1.05),('8975','2014-02-10','15:00:00',1),('8975','2014-02-10','15:05:00',1.04),('8975','2014-02-10','15:10:00',1.1),('8975','2014-02-10','15:15:00',1.36),('8975','2014-02-10','15:20:00',1.41),('8975','2014-02-10','15:25:00',1.11),('8975','2014-02-10','16:05:00',1.05),('8975','2014-02-09','12:55:00',1.17),('8975','2014-02-09','13:00:00',1.43),('8975','2014-02-09','13:05:00',1.17),('8975','2014-02-09','13:35:00',1.02),('8975','2014-02-09','13:40:00',1.01),('8975','2014-02-09','13:55:00',1.14),('8975','2014-02-09','14:00:00',1.14),('8975','2014-02-09','14:20:00',1.02),('8975','2014-02-09','14:25:00',1.07),('8975','2014-02-09','14:30:00',1.17),('8975','2014-02-09','14:35:00',1.23),('8975','2014-02-09','14:40:00',1.24),('8975','2014-02-09','14:45:00',1.11),('8975','2014-02-08','11:05:00',1.05),('8975','2014-02-08','11:25:00',1.12),('8975','2014-02-08','11:30:00',1.21),('8975','2014-02-08','11:35:00',1.45),('8975','2014-02-08','12:25:00',2.47),('8975','2014-02-08','12:30:00',2.25),('8975','2014-02-08','12:35:00',1.88),('8975','2014-02-08','12:40:00',1.65),('8975','2014-02-08','12:45:00',2.92),('8975','2014-02-08','12:50:00',1.35),('8975','2014-02-08','12:55:00',1.59),('8975','2014-02-08','13:00:00',2.47),('8975','2014-02-08','13:05:00',2.43),('8975','2014-02-08','13:10:00',1.68),('8975','2014-02-08','13:15:00',1.38),('8975','2014-02-08','13:25:00',1.08),('8975','2014-02-08','13:40:00',1.04),('8975','2014-02-08','13:45:00',1.48),('8975','2014-02-08','13:55:00',1.1),('8975','2014-02-08','14:00:00',1.79),('8975','2014-02-08','14:05:00',1.59),('8975','2014-02-08','14:10:00',1.85),('8975','2014-02-08','14:15:00',1.07),('8975','2014-02-08','14:25:00',1.17),('8975','2014-02-08','14:30:00',1.23),('8975','2014-02-08','14:40:00',1.67),('8975','2014-02-08','14:45:00',1.27),('8975','2014-02-08','14:50:00',1.27),('8975','2014-02-08','15:00:00',1.13),('8975','2014-02-08','15:10:00',1.26),('8975','2014-02-08','15:15:00',1.6),('8975','2014-02-08','15:20:00',1.14),('8975','2014-02-08','15:45:00',1.02),('8975','2014-02-07','09:50:00',1.36),('8975','2014-02-07','10:05:00',1.28),('8975','2014-02-07','10:15:00',1.34),('8975','2014-02-07','10:20:00',1.27),('8975','2014-02-07','10:25:00',1.48),('8975','2014-02-07','10:30:00',2.47),('8975','2014-02-07','10:35:00',2.17),('8975','2014-02-07','10:45:00',1.57),('8975','2014-02-07','10:50:00',1.7),('8975','2014-02-07','10:55:00',2.83),('8975','2014-02-07','11:00:00',2.21),('8975','2014-02-07','11:05:00',2.47),('8975','2014-02-07','11:10:00',1),('8975','2014-02-07','11:15:00',2.25),('8975','2014-02-07','11:20:00',1.05),('8975','2014-02-07','11:30:00',1.45),('8975','2014-02-07','11:35:00',2.13),('8975','2014-02-07','11:40:00',1.71),('8975','2014-02-07','11:45:00',1.05),('8975','2014-02-07','11:50:00',1.4),('8975','2014-02-07','11:55:00',3.05),('8975','2014-02-07','12:00:00',2.27),('8975','2014-02-07','12:05:00',1.11),('8975','2014-02-07','12:10:00',1.22),('8975','2014-02-07','12:15:00',2.36),('8975','2014-02-07','12:20:00',1.59),('8975','2014-02-07','12:25:00',1.22),('8975','2014-02-07','12:30:00',2.42),('8975','2014-02-07','12:35:00',2.32),('8975','2014-02-07','12:40:00',2.66),('8975','2014-02-07','12:45:00',3.26),('8975','2014-02-07','12:50:00',3.17),('8975','2014-02-07','12:55:00',1.53),('8975','2014-02-07','13:00:00',1.94),('8975','2014-02-07','13:05:00',2.15),('8975','2014-02-07','13:10:00',1.13),('8975','2014-02-07','13:15:00',2.84),('8975','2014-02-07','13:20:00',1.08),('8975','2014-02-07','13:25:00',2.8),('8975','2014-02-07','13:30:00',1.9),('8975','2014-02-07','13:35:00',2.48),('8975','2014-02-07','13:40:00',1.16),('8975','2014-02-07','13:45:00',2.27),('8975','2014-02-07','13:50:00',1.86),('8975','2014-02-07','13:55:00',2.09),('8975','2014-02-07','14:00:00',2.27),('8975','2014-02-07','14:05:00',1.81),('8975','2014-02-07','14:15:00',2.3),('8975','2014-02-07','14:20:00',2.22),('8975','2014-02-07','14:25:00',2.04),('8975','2014-02-07','14:30:00',2.05),('8975','2014-02-07','14:35:00',2.24),('8975','2014-02-07','14:40:00',1.59),('8975','2014-02-07','14:45:00',2.04),('8975','2014-02-07','14:50:00',1.25),('8975','2014-02-07','14:55:00',1.42),('8975','2014-02-07','15:10:00',1.33),('8975','2014-02-07','15:15:00',1.84),('8975','2014-02-07','15:20:00',1.48),('8975','2014-02-07','15:35:00',1.87),('8975','2014-02-07','15:40:00',1.64),('8975','2014-02-07','15:55:00',1.15),('8975','2014-02-06','08:05:00',1.05),('8975','2014-02-06','08:15:00',1.27),('8975','2014-02-06','08:20:00',1.37),('8975','2014-02-06','08:25:00',1.45),('8975','2014-02-06','08:30:00',1.55),('8975','2014-02-06','08:35:00',1.61),('8975','2014-02-06','08:40:00',1.68),('8975','2014-02-06','08:45:00',1.73),('8975','2014-02-06','08:50:00',1.79),('8975','2014-02-06','08:55:00',1.85),('8975','2014-02-06','09:00:00',1.9),('8975','2014-02-06','09:05:00',1.96),('8975','2014-02-06','09:10:00',2),('8975','2014-02-06','09:15:00',2.05),('8975','2014-02-06','09:20:00',2.11),('8975','2014-02-06','09:25:00',2.16),('8975','2014-02-06','09:30:00',2.18),('8975','2014-02-06','09:35:00',2.22),('8975','2014-02-06','09:40:00',2.24),('8975','2014-02-06','09:45:00',2.25),('8975','2014-02-06','09:50:00',2.32),('8975','2014-02-06','09:55:00',2.38),('8975','2014-02-06','10:00:00',2.43),('8975','2014-02-06','10:05:00',2.52),('8975','2014-02-06','10:10:00',2.61),('8975','2014-02-06','10:15:00',2.7),('8975','2014-02-06','10:20:00',2.6),('8975','2014-02-06','10:25:00',2.22),('8975','2014-02-06','10:30:00',2.56),('8975','2014-02-06','10:35:00',2.56),('8975','2014-02-06','10:40:00',2.86),('8975','2014-02-06','10:45:00',2.66),('8975','2014-02-06','10:50:00',3.08),('8975','2014-02-06','10:55:00',3.14),('8975','2014-02-06','11:00:00',3.1),('8975','2014-02-06','11:05:00',3.21),('8975','2014-02-06','11:10:00',3.11),('8975','2014-02-06','11:15:00',3.05),('8975','2014-02-06','11:20:00',2.47),('8975','2014-02-06','11:25:00',3.03),('8975','2014-02-06','11:30:00',2.06),('8975','2014-02-06','11:35:00',3.23),('8975','2014-02-06','11:40:00',2.92),('8975','2014-02-06','11:45:00',3.29),('8975','2014-02-06','11:50:00',3.35),('8975','2014-02-06','11:55:00',3.45),('8975','2014-02-06','12:00:00',2.05),('8975','2014-02-06','12:05:00',2.12),('8975','2014-02-06','12:10:00',3.2),('8975','2014-02-06','12:15:00',2.73),('8975','2014-02-06','12:20:00',3.07),('8975','2014-02-06','12:25:00',2.59),('8975','2014-02-06','12:30:00',2.08),('8975','2014-02-06','12:35:00',2.02),('8975','2014-02-06','12:40:00',2.15),('8975','2014-02-06','12:45:00',1.52),('8975','2014-02-06','12:50:00',1.37),('8975','2014-02-06','12:55:00',1.99),('8975','2014-02-06','13:00:00',2.38),('8975','2014-02-06','13:05:00',2.62),('8975','2014-02-06','13:10:00',1.19),('8975','2014-02-06','13:15:00',1.38),('8975','2014-02-06','13:20:00',1.12),('8975','2014-02-06','13:25:00',2.19),('8975','2014-02-06','13:30:00',1.38),('8975','2014-02-06','13:35:00',1.89),('8975','2014-02-06','13:40:00',2.88),('8975','2014-02-06','13:45:00',2.15),('8975','2014-02-06','13:50:00',1.65),('8975','2014-02-06','13:55:00',2.08),('8975','2014-02-06','14:00:00',2.14),('8975','2014-02-06','14:05:00',2.04),('8975','2014-02-06','14:10:00',2.19),('8975','2014-02-06','14:15:00',2),('8975','2014-02-06','14:20:00',1.21),('8975','2014-02-06','14:25:00',1.41),('8975','2014-02-06','14:30:00',1.79),('8975','2014-02-06','14:35:00',1.92),('8975','2014-02-06','14:40:00',1.49),('8975','2014-02-06','14:45:00',1.59),('8975','2014-02-06','14:50:00',1.55),('8975','2014-02-06','14:55:00',1.54),('8975','2014-02-06','15:00:00',1.48),('8975','2014-02-06','15:05:00',1.43),('8975','2014-02-06','15:10:00',1.39),('8975','2014-02-06','15:15:00',1.4),('8975','2014-02-06','15:20:00',1.36),('8975','2014-02-06','15:25:00',1.31),('8975','2014-02-06','15:30:00',1.27),('8975','2014-02-06','15:35:00',1.23),('8975','2014-02-06','15:40:00',1.2),('8975','2014-02-06','15:45:00',1.16),('8975','2014-02-06','15:50:00',1.14),('8975','2014-02-06','15:55:00',1.08),('8975','2014-02-06','16:00:00',1.04),('8975','2014-02-06','16:05:00',1),('8975','2014-02-05','08:20:00',1.18),('8975','2014-02-05','08:25:00',1.07),('8975','2014-02-05','08:30:00',1.16),('8975','2014-02-05','08:35:00',1.13),('8975','2014-02-05','08:40:00',1.36),('8975','2014-02-05','08:45:00',1.54),('8975','2014-02-05','08:50:00',1.84),('8975','2014-02-05','08:55:00',1.97),('8975','2014-02-05','09:00:00',2.2),('8975','2014-02-05','09:05:00',2.39),('8975','2014-02-05','09:10:00',2.55),('8975','2014-02-05','09:15:00',2.4),('8975','2014-02-05','09:20:00',1.31),('8975','2014-02-05','09:30:00',1.78),('8975','2014-02-05','09:35:00',2.34),('8975','2014-02-05','09:40:00',2.37),('8975','2014-02-05','09:45:00',2.35),('8975','2014-02-05','09:50:00',2.39),('8975','2014-02-05','09:55:00',2.43),('8975','2014-02-05','10:00:00',2.52),('8975','2014-02-05','10:05:00',2.59),('8975','2014-02-05','10:10:00',2.64),('8975','2014-02-05','10:15:00',2.65),('8975','2014-02-05','10:20:00',2.66),('8975','2014-02-05','10:25:00',1.76),('8975','2014-02-05','10:30:00',2.38),('8975','2014-02-05','10:35:00',2.93),('8975','2014-02-05','10:40:00',2.87),('8975','2014-02-05','10:45:00',1.84),('8975','2014-02-05','10:50:00',3.25),('8975','2014-02-05','10:55:00',3.07),('8975','2014-02-05','11:00:00',1.17),('8975','2014-02-05','11:05:00',1.68),('8975','2014-02-05','11:10:00',1.31),('8975','2014-02-05','11:15:00',3.49),('8975','2014-02-05','11:20:00',3.41),('8975','2014-02-05','11:25:00',3.18),('8975','2014-02-05','11:30:00',3.22),('8975','2014-02-05','11:35:00',3.12),('8975','2014-02-05','11:40:00',3.06),('8975','2014-02-05','11:45:00',2.87),('8975','2014-02-05','11:50:00',2.97),('8975','2014-02-05','11:55:00',3.02),('8975','2014-02-05','12:00:00',2.99),('8975','2014-02-05','12:05:00',2.95),('8975','2014-02-05','12:10:00',2.97),('8975','2014-02-05','12:15:00',2.93),('8975','2014-02-05','12:20:00',2.87),('8975','2014-02-05','12:25:00',2.86),('8975','2014-02-05','12:30:00',2.87),('8975','2014-02-05','12:35:00',2.88),('8975','2014-02-05','12:40:00',2.84),('8975','2014-02-05','12:45:00',2.8),('8975','2014-02-05','12:50:00',2.73),('8975','2014-02-05','12:55:00',2.53),('8975','2014-02-05','13:00:00',2.46),('8975','2014-02-05','13:05:00',2.68),('8975','2014-02-05','13:10:00',2.58),('8975','2014-02-05','13:15:00',2.54),('8975','2014-02-05','13:20:00',2.37),('8975','2014-02-05','13:25:00',2.68),('8975','2014-02-05','13:30:00',2.76),('8975','2014-02-05','13:35:00',2.37),('8975','2014-02-05','13:40:00',2.07),('8975','2014-02-05','13:45:00',2.16),('8975','2014-02-05','13:50:00',2.08),('8975','2014-02-05','13:55:00',2.02),('8975','2014-02-05','14:00:00',2.01),('8975','2014-02-05','14:05:00',2.12),('8975','2014-02-05','14:10:00',2.13),('8975','2014-02-05','14:15:00',1.96),('8975','2014-02-05','14:20:00',1.94),('8975','2014-02-05','14:25:00',1.86),('8975','2014-02-05','14:30:00',1.51),('8975','2014-02-05','14:35:00',1.38),('8975','2014-02-05','14:40:00',1.73),('8975','2014-02-05','14:45:00',1.87),('8975','2014-02-05','14:50:00',1.81),('8975','2014-02-05','14:55:00',1.56),('8975','2014-02-05','15:00:00',1.49),('8975','2014-02-05','15:05:00',1.43),('8975','2014-02-05','15:10:00',1.37),('8975','2014-02-05','15:15:00',1.38),('8975','2014-02-05','15:20:00',1.39),('8975','2014-02-05','15:25:00',1.31),('8975','2014-02-05','15:30:00',1.26),('8975','2014-02-05','15:35:00',1.22),('8975','2014-02-05','15:40:00',1.19),('8975','2014-02-05','15:45:00',1.15),('8975','2014-02-05','15:50:00',1.11),('8975','2014-02-05','15:55:00',1.07),('8975','2014-02-05','16:00:00',1.03),('8975','2014-04-26','08:50:00',1.51),('8975','2014-04-26','08:55:00',1.48),('8975','2014-04-26','09:00:00',1.13),('8975','2014-04-26','09:15:00',1.01),('8975','2014-04-26','09:20:00',1.08),('8975','2014-04-26','09:40:00',1.11),('8975','2014-04-26','09:45:00',1.44),('8975','2014-04-26','09:50:00',1.34),('8975','2014-04-26','09:55:00',1.56),('8975','2014-04-26','10:00:00',1.54),('8975','2014-04-26','10:05:00',1.76),('8975','2014-04-26','10:10:00',1.62),('8975','2014-04-26','10:15:00',1.61),('8975','2014-04-26','10:25:00',1.17),('8975','2014-04-26','10:50:00',1.35),('8975','2014-04-26','10:55:00',1.65),('8975','2014-04-26','11:00:00',1.96),('8975','2014-04-26','11:05:00',1.87),('8975','2014-04-26','11:10:00',2.91),('8975','2014-04-26','11:15:00',2.58),('8975','2014-04-26','11:20:00',1.83),('8975','2014-04-26','11:25:00',1.28),('8975','2014-04-26','11:30:00',2.89),('8975','2014-04-26','11:35:00',3.2),('8975','2014-04-26','11:40:00',4),('8975','2014-04-26','11:45:00',5.01),('8975','2014-04-26','11:50:00',4.06),('8975','2014-04-26','11:55:00',4.36),('8975','2014-04-26','12:00:00',4.4),('8975','2014-04-26','12:05:00',3.62),('8975','2014-04-26','12:10:00',4.74),('8975','2014-04-26','12:15:00',5.52),('8975','2014-04-26','12:20:00',4.98),('8975','2014-04-26','12:25:00',4.37),('8975','2014-04-26','12:30:00',4.61),('8975','2014-04-26','12:35:00',5.19),('8975','2014-04-26','12:40:00',4.82),('8975','2014-04-26','12:45:00',5),('8975','2014-04-26','12:50:00',5.03),('8975','2014-04-26','12:55:00',4.42),('8975','2014-04-26','13:00:00',4.09),('8975','2014-04-26','13:05:00',3.44),('8975','2014-04-26','13:10:00',2.92),('8975','2014-04-26','13:15:00',3.37),('8975','2014-04-26','13:20:00',4.19),('8975','2014-04-26','13:25:00',3.65),('8975','2014-04-26','13:30:00',3.24),('8975','2014-04-26','13:35:00',3.01),('8975','2014-04-26','13:40:00',2.89),('8975','2014-04-26','13:45:00',2.89),('8975','2014-04-26','13:50:00',2.58),('8975','2014-04-26','13:55:00',2.33),('8975','2014-04-26','14:00:00',3.51),('8975','2014-04-26','14:05:00',3.11),('8975','2014-04-26','14:10:00',2.51),('8975','2014-04-26','14:15:00',2.72),('8975','2014-04-26','14:20:00',3.28),('8975','2014-04-26','14:25:00',3.88),('8975','2014-04-26','14:30:00',3.63),('8975','2014-04-26','14:35:00',4.25),('8975','2014-04-26','14:40:00',3.64),('8975','2014-04-26','14:45:00',3.15),('8975','2014-04-26','14:50:00',3.2),('8975','2014-04-26','14:55:00',3.27),('8975','2014-04-26','15:00:00',3.66),('8975','2014-04-26','15:05:00',4.95),('8975','2014-04-26','15:10:00',4.77),('8975','2014-04-26','15:15:00',3.34),('8975','2014-04-26','15:20:00',2.88),('8975','2014-04-26','15:25:00',1.91),('8975','2014-04-26','15:30:00',1.52),('8975','2014-04-26','15:35:00',1.68),('8975','2014-04-26','15:40:00',2.03),('8975','2014-04-26','15:45:00',1.69),('8975','2014-04-26','15:50:00',1.52),('8975','2014-02-04','10:10:00',1.52),('8975','2014-02-04','10:15:00',2.86),('8975','2014-02-04','10:20:00',2.52),('8975','2014-02-04','10:25:00',1.2),('8975','2014-02-04','10:30:00',1.03),('8975','2014-02-04','10:35:00',1.13),('8975','2014-02-04','10:50:00',1.53),('8975','2014-02-04','10:55:00',1.29),('8975','2014-02-04','11:05:00',2.26),('8975','2014-02-04','11:10:00',3.28),('8975','2014-02-04','11:15:00',2.55),('8975','2014-02-04','11:20:00',1.44),('8975','2014-02-04','11:25:00',1.53),('8975','2014-02-04','12:55:00',1.28),('8975','2014-02-04','13:05:00',1.18),('8975','2014-02-04','13:10:00',1.35),('8975','2014-02-04','13:15:00',1.09),('8975','2014-02-04','13:20:00',1.37),('8975','2014-02-04','13:25:00',1.51),('8975','2014-02-04','13:30:00',1.62),('8975','2014-02-04','13:35:00',1.77),('8975','2014-02-04','13:40:00',1.8),('8975','2014-02-04','13:45:00',1.77),('8975','2014-02-04','13:50:00',1.84),('8975','2014-02-04','13:55:00',1.38),('8975','2014-02-04','14:00:00',1.03),('8975','2014-02-04','14:30:00',2.21),('8975','2014-02-04','14:35:00',1.24),('8975','2014-02-03','09:10:00',1.08),('8975','2014-02-03','09:15:00',1.82),('8975','2014-02-03','09:20:00',1.77),('8975','2014-02-03','09:25:00',2.06),('8975','2014-02-03','09:30:00',2.63),('8975','2014-02-03','09:35:00',2.32),('8975','2014-02-03','09:40:00',2.55),('8975','2014-02-03','09:45:00',2.44),('8975','2014-02-03','09:50:00',1.83),('8975','2014-02-03','09:55:00',2.18),('8975','2014-02-03','10:00:00',1.88),('8975','2014-02-03','10:05:00',3.03),('8975','2014-02-03','10:10:00',1.69),('8975','2014-02-03','10:15:00',2.01),('8975','2014-02-03','10:20:00',1.65),('8975','2014-02-03','10:25:00',2.18),('8975','2014-02-03','10:30:00',1.31),('8975','2014-02-03','10:35:00',1.66),('8975','2014-02-03','10:40:00',2.93),('8975','2014-02-03','10:45:00',3.2),('8975','2014-02-03','10:50:00',2.57),('8975','2014-02-03','10:55:00',1.99),('8975','2014-02-03','11:00:00',2.99),('8975','2014-02-03','11:05:00',1.87),('8975','2014-02-03','11:10:00',1.47),('8975','2014-02-03','11:15:00',1.42),('8975','2014-02-03','11:20:00',1.59),('8975','2014-02-03','11:25:00',2.05),('8975','2014-02-03','11:30:00',1.75),('8975','2014-02-03','11:35:00',1.72),('8975','2014-02-03','11:45:00',1.55),('8975','2014-02-03','11:50:00',2.5),('8975','2014-02-03','11:55:00',2.23),('8975','2014-02-03','12:00:00',1.65),('8975','2014-02-03','12:05:00',2.34),('8975','2014-02-03','12:10:00',2.1),('8975','2014-02-03','12:15:00',1.64),('8975','2014-02-03','12:20:00',1.5),('8975','2014-02-03','12:25:00',1.24),('8975','2014-02-03','12:35:00',1),('8975','2014-02-03','12:40:00',1.07),('8975','2014-02-03','12:45:00',1.53),('8975','2014-02-03','12:50:00',1.32),('8975','2014-02-03','12:55:00',1.47),('8975','2014-02-03','13:00:00',1.53),('8975','2014-02-03','13:05:00',1.29),('8975','2014-02-03','13:10:00',1.24),('8975','2014-02-03','13:15:00',1.38),('8975','2014-02-03','13:20:00',1.62),('8975','2014-02-03','13:25:00',1.17),('8975','2014-02-03','13:30:00',1.22),('8975','2014-02-03','13:40:00',1.21),('8975','2014-02-03','13:45:00',1.24),('8975','2014-02-03','13:50:00',1.47),('8975','2014-02-03','13:55:00',1.2),('8975','2014-02-03','14:10:00',1.06),('8975','2014-02-02','09:45:00',1.03),('8975','2014-02-02','09:50:00',1.08),('8975','2014-02-02','10:10:00',1.05),('8975','2014-02-02','10:15:00',1.06),('8975','2014-02-02','10:20:00',1.07),('8975','2014-02-02','10:25:00',1.09),('8975','2014-02-02','10:30:00',1.25),('8975','2014-02-02','10:35:00',1.36),('8975','2014-02-02','10:40:00',1.26),('8975','2014-02-02','10:45:00',1.47),('8975','2014-02-02','10:50:00',1.19),('8975','2014-02-02','10:55:00',1.18),('8975','2014-02-02','11:00:00',1.08),('8975','2014-02-02','11:15:00',1.12),('8975','2014-02-02','11:20:00',1.24),('8975','2014-02-02','11:25:00',1.26),('8975','2014-02-02','11:30:00',1.41),('8975','2014-02-02','11:35:00',1.44),('8975','2014-02-02','11:40:00',1.56),('8975','2014-02-02','11:45:00',1.59),('8975','2014-02-02','11:50:00',1.52),('8975','2014-02-02','11:55:00',1.37),('8975','2014-02-02','12:00:00',1.21),('8975','2014-02-02','12:05:00',1.2),('8975','2014-02-02','12:10:00',1.2),('8975','2014-02-02','12:15:00',1.25),('8975','2014-02-02','12:20:00',1.29),('8975','2014-02-02','12:25:00',1.27),('8975','2014-02-02','12:30:00',1.14),('8975','2014-02-02','13:30:00',1.05),('8975','2014-02-02','13:35:00',1),('8975','2014-02-02','14:35:00',1.02),('8975','2014-02-02','14:40:00',1.04),('8975','2014-02-02','14:45:00',1.01),('8975','2014-02-01','11:55:00',1.1),('8975','2014-02-01','12:00:00',1.19),('8975','2014-02-01','12:05:00',1.21),('8975','2014-02-01','12:10:00',1.14),('8975','2014-01-31','10:55:00',1.06),('8975','2014-01-31','11:00:00',1.27),('8975','2014-01-31','11:05:00',1),('8975','2014-01-31','11:15:00',1.07),('8975','2014-01-31','11:20:00',1.72),('8975','2014-01-31','11:25:00',1.35),('8975','2014-01-31','11:30:00',1.59),('8975','2014-01-31','11:35:00',1.28),('8975','2014-01-31','11:55:00',1.6),('8975','2014-01-31','12:00:00',1.15),('8975','2014-01-31','12:05:00',1.88),('8975','2014-01-31','12:10:00',1.56),('8975','2014-01-31','12:15:00',1.67),('8975','2014-01-31','12:20:00',2.1),('8975','2014-01-31','12:25:00',1.33),('8975','2014-01-31','12:35:00',1.3),('8975','2014-01-31','12:40:00',1.76),('8975','2014-01-31','12:45:00',1.94),('8975','2014-01-31','12:50:00',1.67),('8975','2014-01-31','12:55:00',1.55),('8975','2014-01-31','13:00:00',1.54),('8975','2014-01-31','13:30:00',1),('8975','2014-01-30','13:50:00',1.05),('8975','2014-01-29','09:25:00',1.02),('8975','2014-01-29','09:50:00',1.76),('8975','2014-01-29','09:55:00',2.3),('8975','2014-01-29','10:00:00',1.51),('8975','2014-01-29','10:05:00',1.32),('8975','2014-01-29','10:10:00',2.23),('8975','2014-01-29','10:15:00',2.29),('8975','2014-01-29','10:20:00',2.11),('8975','2014-01-29','10:25:00',2.61),('8975','2014-01-29','10:30:00',2.55),('8975','2014-01-29','10:35:00',2.63),('8975','2014-01-29','10:40:00',2.42),('8975','2014-01-29','10:45:00',2.13),('8975','2014-01-29','10:50:00',2.82),('8975','2014-01-29','10:55:00',3.06),('8975','2014-01-29','11:00:00',2.52),('8975','2014-01-29','11:05:00',1.82),('8975','2014-01-29','11:10:00',2.44),('8975','2014-01-29','11:15:00',1.98),('8975','2014-01-29','11:20:00',1.76),('8975','2014-01-29','11:25:00',2.37),('8975','2014-01-29','11:30:00',1.88),('8975','2014-01-29','11:35:00',2.46),('8975','2014-01-29','11:40:00',3),('8975','2014-01-29','11:45:00',2.66),('8975','2014-01-29','11:50:00',2.83),('8975','2014-01-29','11:55:00',2.21),('8975','2014-01-29','12:00:00',2.18),('8975','2014-01-29','12:05:00',2.49),('8975','2014-01-29','12:10:00',2.76),('8975','2014-01-29','12:15:00',2.25),('8975','2014-01-29','12:20:00',2.41),('8975','2014-01-29','12:25:00',2.05),('8975','2014-01-29','12:30:00',1.94),('8975','2014-01-29','12:35:00',1.89),('8975','2014-01-29','12:40:00',2.11),('8975','2014-01-29','12:45:00',2.36),('8975','2014-01-29','12:50:00',2.43),('8975','2014-01-29','12:55:00',2.44),('8975','2014-01-29','13:00:00',2.53),('8975','2014-01-29','13:05:00',2.56),('8975','2014-01-29','13:10:00',2.35),('8975','2014-01-29','13:15:00',2.4),('8975','2014-01-29','13:20:00',2.34),('8975','2014-01-29','13:25:00',2.03),('8975','2014-01-29','13:30:00',1.66),('8975','2014-01-29','13:35:00',1.69),('8975','2014-01-29','13:40:00',2.01),('8975','2014-01-29','13:45:00',2.08),('8975','2014-01-29','13:50:00',1.8),('8975','2014-01-29','13:55:00',1.62),('8975','2014-01-29','14:00:00',1.59),('8975','2014-01-29','14:05:00',1.53),('8975','2014-01-29','14:10:00',1.52),('8975','2014-01-29','14:15:00',1.25),('8975','2014-01-29','14:20:00',1.15),('8975','2014-01-29','14:25:00',1.27),('8975','2014-01-29','14:30:00',1.34),('8975','2014-01-29','14:35:00',1.44),('8975','2014-01-29','14:40:00',1.54),('8975','2014-01-29','14:45:00',1.41),('8975','2014-01-29','14:50:00',1.46),('8975','2014-01-29','14:55:00',1.37),('8975','2014-01-29','15:00:00',1.33),('8975','2014-01-29','15:05:00',1.37),('8975','2014-01-29','15:10:00',1.33),('8975','2014-01-29','15:15:00',1.33),('8975','2014-01-29','15:20:00',1.37),('8975','2014-01-29','15:25:00',1.35),('8975','2014-01-29','15:30:00',1.23),('8975','2014-01-29','15:35:00',1.26),('8975','2014-01-29','15:40:00',1.12),('8975','2014-01-28','09:15:00',1.31),('8975','2014-01-28','09:20:00',1.99),('8975','2014-01-28','09:25:00',1.25),('8975','2014-01-28','09:30:00',1.84),('8975','2014-01-28','09:35:00',2.08),('8975','2014-01-28','09:40:00',2.08),('8975','2014-01-28','09:45:00',1.98),('8975','2014-01-28','09:50:00',1.88),('8975','2014-01-28','09:55:00',1.62),('8975','2014-01-28','10:00:00',1.42),('8975','2014-01-28','10:05:00',1.42),('8975','2014-01-28','10:10:00',1.8),('8975','2014-01-28','10:15:00',2.41),('8975','2014-01-28','10:20:00',1.62),('8975','2014-01-28','10:25:00',2.67),('8975','2014-01-28','10:30:00',2.61),('8975','2014-01-28','10:35:00',2.08),('8975','2014-01-28','10:40:00',2.72),('8975','2014-01-28','10:45:00',2.33),('8975','2014-01-28','10:50:00',2.04),('8975','2014-01-28','10:55:00',1.99),('8975','2014-01-28','11:00:00',2.14),('8975','2014-01-28','11:05:00',2.21),('8975','2014-01-28','11:10:00',1.99),('8975','2014-01-28','11:15:00',2.02),('8975','2014-01-28','11:20:00',1.86),('8975','2014-01-28','11:25:00',2.17),('8975','2014-01-28','11:30:00',2.1),('8975','2014-01-28','11:35:00',1.48),('8975','2014-01-28','11:40:00',1.66),('8975','2014-01-28','11:45:00',1.41),('8975','2014-01-28','12:45:00',1.56),('8975','2014-01-28','12:50:00',2.55),('8975','2014-01-28','12:55:00',2.24),('8975','2014-01-28','13:00:00',1.39),('8975','2014-01-28','13:30:00',1.52),('8975','2014-01-28','13:35:00',1.85),('8975','2014-01-28','13:40:00',1.42),('8975','2014-01-28','13:45:00',1.26),('8975','2014-01-28','13:50:00',1.54),('8975','2014-01-28','13:55:00',1.09),('8975','2014-01-28','14:00:00',1.02),('8975','2014-01-28','14:40:00',1),('8975','2014-01-28','15:10:00',1.6),('8975','2014-01-28','15:15:00',1.66),('8975','2014-01-27','09:05:00',1.28),('8975','2014-01-27','09:10:00',1.59),('8975','2014-01-27','09:15:00',1.6),('8975','2014-01-27','09:20:00',1.59),('8975','2014-01-27','09:25:00',1.52),('8975','2014-01-27','09:30:00',1.65),('8975','2014-01-27','09:35:00',1.71),('8975','2014-01-27','09:40:00',1.61),('8975','2014-01-27','09:45:00',2.05),('8975','2014-01-27','09:50:00',2.17),('8975','2014-01-27','09:55:00',2.14),('8975','2014-01-27','10:00:00',2.18),('8975','2014-01-27','10:05:00',2.08),('8975','2014-01-27','10:10:00',2.06),('8975','2014-01-27','10:15:00',2.3),('8975','2014-01-27','10:20:00',2.4),('8975','2014-01-27','10:25:00',2.49),('8975','2014-01-27','10:30:00',2.34),('8975','2014-01-27','10:35:00',2.54),('8975','2014-01-27','10:40:00',2.53),('8975','2014-01-27','10:45:00',1.91),('8975','2014-01-27','10:50:00',1.61),('8975','2014-01-27','10:55:00',2.24),('8975','2014-01-27','11:00:00',2.13),('8975','2014-01-27','11:05:00',2.96),('8975','2014-01-27','11:10:00',2.42),('8975','2014-01-27','11:15:00',2.31),('8975','2014-01-27','11:20:00',2.37),('8975','2014-01-27','11:25:00',2.65),('8975','2014-01-27','11:30:00',3.31),('8975','2014-01-27','11:35:00',3.08),('8975','2014-01-27','11:40:00',1.44),('8975','2014-01-27','11:45:00',2.16),('8975','2014-01-27','11:50:00',1.07),('8975','2014-01-27','11:55:00',1.01),('8975','2014-01-27','12:00:00',1.59),('8975','2014-01-27','12:05:00',2.35),('8975','2014-01-27','12:10:00',2.7),('8975','2014-01-27','12:15:00',2.45),('8975','2014-01-27','12:20:00',1.41),('8975','2014-01-27','12:25:00',1.23),('8975','2014-01-27','12:30:00',1.28),('8975','2014-01-27','12:35:00',1.54),('8975','2014-01-27','12:40:00',1.59),('8975','2014-01-27','12:45:00',2.13),('8975','2014-01-27','12:50:00',2.1),('8975','2014-01-27','12:55:00',2.3),('8975','2014-01-27','13:00:00',2.91),('8975','2014-01-27','13:05:00',2.07),('8975','2014-01-27','13:10:00',1.85),('8975','2014-01-27','13:15:00',2.52),('8975','2014-01-27','13:20:00',2.33),('8975','2014-01-27','13:25:00',2.18),('8975','2014-01-27','13:30:00',2.31),('8975','2014-01-27','13:35:00',2.14),('8975','2014-01-27','13:40:00',2.06),('8975','2014-01-27','13:45:00',1.9),('8975','2014-01-27','13:50:00',1.87),('8975','2014-01-27','13:55:00',1.82),('8975','2014-01-27','14:00:00',1.77),('8975','2014-01-27','14:05:00',1.71),('8975','2014-01-27','14:10:00',1.71),('8975','2014-01-27','14:15:00',1.66),('8975','2014-01-27','14:20:00',1.45),('8975','2014-01-27','14:25:00',1.21),('8975','2014-01-27','14:30:00',1.18),('8975','2014-01-27','14:35:00',1.41),('8975','2014-01-27','14:40:00',1.51),('8975','2014-01-27','14:45:00',1.44),('8975','2014-01-27','14:50:00',1.4),('8975','2014-01-27','14:55:00',1.32),('8975','2014-01-27','15:00:00',1.29),('8975','2014-01-27','15:05:00',1.29),('8975','2014-01-27','15:10:00',1.28),('8975','2014-01-27','15:15:00',1.24),('8975','2014-01-27','15:20:00',1.21),('8975','2014-01-27','15:25:00',1.17),('8975','2014-01-27','15:30:00',1.15),('8975','2014-01-27','15:35:00',1.11),('8975','2014-01-27','15:40:00',1.08),('8975','2014-01-27','15:45:00',1.03),('8975','2014-01-26','10:25:00',1.03),('8975','2014-01-26','10:30:00',1.1),('8975','2014-01-26','10:35:00',1.11),('8975','2014-01-26','10:40:00',1.09),('8975','2014-01-26','10:45:00',1.18),('8975','2014-01-26','10:50:00',1.16),('8975','2014-01-26','10:55:00',1.03),('8975','2014-01-26','11:00:00',1.14),('8975','2014-01-26','11:05:00',1.28),('8975','2014-01-26','11:10:00',1.14),('8975','2014-01-26','11:15:00',1.07),('8975','2014-01-26','11:20:00',1.22),('8975','2014-01-26','11:25:00',1.17),('8998','2014-05-04','07:40:00',1.07),('8998','2014-05-04','07:45:00',1.24),('8998','2014-05-04','07:50:00',1.36),('8998','2014-05-04','07:55:00',1.45),('8998','2014-05-04','08:00:00',1.44),('8998','2014-05-04','08:05:00',1.4),('8998','2014-05-04','08:10:00',1.38),('8998','2014-05-04','08:15:00',1.77),('8998','2014-05-04','08:20:00',1.73),('8998','2014-05-04','08:25:00',1.58),('8998','2014-05-04','08:30:00',1.97),('8998','2014-05-04','08:35:00',2.02),('8998','2014-05-04','08:40:00',2.03),('8998','2014-05-04','08:45:00',1.86),('8998','2014-05-04','08:50:00',1.76),('8998','2014-05-04','08:55:00',1.68),('8998','2014-05-04','09:00:00',1.84),('8998','2014-05-04','09:05:00',1.82),('8998','2014-05-04','09:10:00',1.98),('8998','2014-05-04','09:15:00',2.48),('8998','2014-05-04','09:20:00',2.52),('8998','2014-05-04','09:25:00',2.6),('8998','2014-05-04','09:30:00',2.71),('8998','2014-05-04','09:35:00',2.8),('8998','2014-05-04','09:40:00',2.84),('8998','2014-05-04','09:45:00',2.87),('8998','2014-05-04','09:50:00',2.91),('8998','2014-05-04','09:55:00',2.94),('8998','2014-05-04','10:00:00',2.97),('8998','2014-05-04','10:05:00',3),('8998','2014-05-04','10:10:00',3.04),('8998','2014-05-04','10:15:00',3.02),('8998','2014-05-04','10:20:00',3),('8998','2014-05-04','10:25:00',3.03),('8998','2014-05-04','10:30:00',3.06),('8998','2014-05-04','10:35:00',3.11),('8998','2014-05-04','10:40:00',3.09),('8998','2014-05-04','10:45:00',3.09),('8998','2014-05-04','10:50:00',3.13),('8998','2014-05-04','10:55:00',3.11),('8998','2014-05-04','11:00:00',3.14),('8998','2014-05-04','11:05:00',3.14),('8998','2014-05-04','11:10:00',3.14),('8998','2014-05-04','11:15:00',3.13),('8998','2014-05-04','11:20:00',3.13),('8998','2014-05-04','11:25:00',3.12),('8998','2014-05-04','11:30:00',3.11),('8998','2014-05-04','11:35:00',3.11),('8998','2014-05-04','11:40:00',3.14),('8998','2014-05-04','11:45:00',3.15),('8998','2014-05-04','11:50:00',3.16),('8998','2014-05-04','11:55:00',3.24),('8998','2014-05-04','12:00:00',2.33),('8998','2014-05-04','12:05:00',1.56),('8998','2014-05-04','12:10:00',2.12),('8998','2014-05-04','12:15:00',1.82),('8998','2014-05-04','12:20:00',1.65),('8998','2014-05-04','12:25:00',2.78),('8998','2014-05-04','12:30:00',2.98),('8998','2014-05-04','12:35:00',1.33),('8998','2014-05-04','12:40:00',1.32),('8998','2014-05-04','12:45:00',3.75),('8998','2014-05-04','12:50:00',2.55),('8998','2014-05-04','12:55:00',1.98),('8998','2014-05-04','13:00:00',1.7),('8998','2014-05-04','13:05:00',2.91),('8998','2014-05-04','13:10:00',3.1),('8998','2014-05-04','13:15:00',3.04),('8998','2014-05-04','13:20:00',2.93),('8998','2014-05-04','13:25:00',2.89),('8998','2014-05-04','13:30:00',2.88),('8998','2014-05-04','13:35:00',2.87),('8998','2014-05-04','13:40:00',2.82),('8998','2014-05-04','13:45:00',2.8),('8998','2014-05-04','13:50:00',2.8),('8998','2014-05-04','13:55:00',2.8),('8998','2014-05-04','14:00:00',2.79),('8998','2014-05-04','14:05:00',2.89),('8998','2014-05-04','14:10:00',2.92),('8998','2014-05-04','14:15:00',2.96),('8998','2014-05-04','14:20:00',3.19),('8998','2014-05-04','14:25:00',2.81),('8998','2014-05-04','14:30:00',1.54),('8998','2014-05-04','14:35:00',1.08),('8998','2014-05-04','14:55:00',1.12),('8998','2014-05-04','15:05:00',1.01),('8998','2014-05-04','15:25:00',1.75),('8998','2014-05-04','15:30:00',2.39),('8998','2014-05-04','15:35:00',1.59),('8998','2014-05-04','15:40:00',1.84),('8998','2014-05-04','15:45:00',1.13),('8998','2014-05-04','16:05:00',1.25),('8998','2014-05-04','17:00:00',1.06),('8998','2014-04-25','09:55:00',1.11),('8998','2014-04-25','10:00:00',1.07),('8998','2014-04-25','10:20:00',1.04),('8998','2014-04-25','10:25:00',1.12),('8998','2014-04-25','10:30:00',1.56),('8998','2014-04-25','10:35:00',1.42),('8998','2014-04-25','10:40:00',1.35),('8998','2014-04-25','10:45:00',1.44),('8998','2014-04-25','10:50:00',1.79),('8998','2014-04-25','10:55:00',2.5),('8998','2014-04-25','11:00:00',2.83),('8998','2014-04-25','11:05:00',2.59),('8998','2014-04-25','11:10:00',2.63),('8998','2014-04-25','11:15:00',2.53),('8998','2014-04-25','11:20:00',2.39),('8998','2014-04-25','11:25:00',2.37),('8998','2014-04-25','11:30:00',2.34),('8998','2014-04-25','11:35:00',2.27),('8998','2014-04-25','11:40:00',2.2),('8998','2014-04-25','11:45:00',2.39),('8998','2014-04-25','11:50:00',2.37),('8998','2014-04-25','11:55:00',2),('8998','2014-04-25','12:00:00',2.33),('8998','2014-04-25','12:05:00',2.32),('8998','2014-04-25','12:10:00',2.33),('8998','2014-04-25','12:15:00',2.13),('8998','2014-04-25','12:20:00',1.95),('8998','2014-04-25','12:25:00',1.33),('8998','2014-04-25','12:30:00',1.74),('8998','2014-04-25','12:35:00',2.37),('8998','2014-04-25','12:40:00',2.23),('8998','2014-04-25','12:45:00',2.34),('8998','2014-04-25','12:50:00',2.88),('8998','2014-04-25','12:55:00',2.99),('8998','2014-04-25','13:00:00',2.77),('8998','2014-04-25','13:05:00',2.32),('8998','2014-04-25','13:10:00',2.05),('8998','2014-04-25','13:15:00',3.01),('8998','2014-04-25','13:20:00',2.48),('8998','2014-04-25','13:25:00',1.42),('8998','2014-04-25','13:35:00',1.95),('8998','2014-04-25','13:40:00',2.83),('8998','2014-04-25','13:45:00',2.7),('8998','2014-04-25','13:50:00',2.71),('8998','2014-04-25','13:55:00',2.88),('8998','2014-04-25','14:00:00',2.01),('8998','2014-04-25','14:10:00',2.37),('8998','2014-04-25','14:35:00',1.41),('8998','2014-04-25','14:40:00',1.44),('8998','2014-01-25','09:05:00',1.18),('8998','2014-01-25','09:30:00',1.34),('8998','2014-01-25','09:35:00',1.56),('8998','2014-01-25','09:45:00',1.11),('8998','2014-01-25','09:50:00',1.23),('8998','2014-01-25','10:10:00',1.5),('8998','2014-01-25','10:15:00',2.03),('8998','2014-01-25','12:30:00',1.49),('8998','2014-01-25','12:35:00',1.49),('8998','2014-01-25','13:15:00',1.02),('8998','2014-01-25','13:20:00',1),('8998','2014-01-24','09:00:00',1.11),('8998','2014-01-24','09:05:00',1.8),('8998','2014-01-24','09:10:00',1.01),('8998','2014-01-24','09:15:00',1.06),('8998','2014-01-24','09:20:00',1.44),('8998','2014-01-24','09:50:00',1.03),('8998','2014-01-24','09:55:00',1.17),('8998','2014-01-24','10:00:00',1.06),('8998','2014-01-24','10:05:00',1.92),('8998','2014-01-24','10:10:00',2.22),('8998','2014-01-24','10:15:00',2.25),('8998','2014-01-24','10:20:00',2.1),('8998','2014-01-24','10:25:00',1.27),('8998','2014-01-24','10:30:00',1.28),('8998','2014-01-24','10:35:00',1.1),('8998','2014-01-24','10:40:00',1.45),('8998','2014-01-24','10:45:00',1.14),('8998','2014-01-24','10:50:00',1.39),('8998','2014-01-24','10:55:00',1.16),('8998','2014-01-24','11:30:00',2.28),('8998','2014-01-24','11:35:00',2.41),('8998','2014-01-24','11:40:00',1.19),('8998','2014-01-24','11:45:00',1.02),('8998','2014-01-24','11:50:00',1.07),('8998','2014-01-24','11:55:00',1.06),('8998','2014-01-24','12:00:00',1.05),('8998','2014-01-24','12:05:00',1.1),('8998','2014-01-24','12:10:00',1.18),('8998','2014-01-24','12:15:00',1.12),('8998','2014-01-24','12:20:00',1.12),('8998','2014-01-24','12:25:00',1.12),('8998','2014-01-24','12:30:00',1.13),('8998','2014-01-24','12:40:00',1.05),('8998','2014-01-24','12:45:00',1.26),('8998','2014-01-24','12:50:00',1.32),('8998','2014-01-24','12:55:00',1.49),('8998','2014-01-24','13:00:00',1.41),('8998','2014-01-24','13:05:00',1.54),('8998','2014-01-24','13:10:00',1.54),('8998','2014-01-24','13:15:00',1.01),('8998','2014-01-23','10:15:00',1.3),('8998','2014-01-23','10:30:00',1.29),('8998','2014-01-23','10:40:00',1.39),('8998','2014-01-23','10:45:00',1.57),('8998','2014-01-23','11:35:00',1.17),('8998','2014-01-23','11:50:00',2.19),('8998','2014-01-23','11:55:00',1.99),('8998','2014-01-23','12:00:00',1.05),('8998','2014-01-23','12:05:00',1.02),('8998','2014-01-23','12:25:00',1.01),('8998','2014-01-23','12:35:00',1.59),('8998','2014-01-23','12:40:00',1.53),('8998','2014-01-23','12:45:00',1.21),('8998','2014-01-23','13:05:00',1.06),('8998','2014-01-23','14:10:00',1.04),('8998','2014-01-20','10:55:00',1.18),('8998','2014-01-20','11:00:00',1.69),('8998','2014-01-20','12:05:00',1.09),('8998','2014-01-20','12:10:00',1.29),('8998','2014-01-20','12:15:00',1.15),('8998','2014-01-20','12:30:00',1.47),('8998','2014-01-20','12:35:00',1.04),('8998','2014-01-20','12:40:00',1.02),('8998','2014-01-20','12:50:00',1.16),('8998','2014-01-19','11:25:00',1.2),('8998','2014-01-19','11:30:00',1.33),('8998','2014-01-19','11:35:00',1.25),('8998','2014-01-19','11:40:00',2),('8998','2014-01-19','11:45:00',2.04),('8998','2014-01-19','11:50:00',1.11),('8998','2014-01-19','13:20:00',2.08),('8998','2014-01-19','13:25:00',1.85),('8998','2014-01-19','13:30:00',1.48),('8998','2014-01-19','13:35:00',1.29),('8998','2014-01-19','13:40:00',1.07),('8998','2014-01-19','13:45:00',1.1),('8998','2014-01-19','14:00:00',1.35),('8998','2014-01-17','10:05:00',1.27),('8998','2014-01-17','10:10:00',1.91),('8998','2014-01-17','10:15:00',1.96),('8998','2014-01-17','10:20:00',1.72),('8998','2014-01-17','10:25:00',1.11),('8998','2014-01-17','10:30:00',1.28),('8998','2014-01-17','11:10:00',1.29),('8998','2014-01-17','11:15:00',1.91),('8998','2014-01-17','11:20:00',1.85),('8998','2014-01-17','11:25:00',1.73),('8998','2014-01-17','11:30:00',1.7),('8998','2014-01-17','11:35:00',1.72),('8998','2014-01-17','11:40:00',1.45),('8998','2014-01-17','11:45:00',1.92),('8998','2014-01-17','11:50:00',1.94),('8998','2014-01-17','11:55:00',2.05),('8998','2014-01-17','12:00:00',1.9),('8998','2014-01-17','12:05:00',1.49),('8998','2014-01-17','12:10:00',1.7),('8998','2014-01-17','12:15:00',1.58),('8998','2014-01-17','12:20:00',1.56),('8998','2014-01-17','12:25:00',1.53),('8998','2014-01-17','12:30:00',1.54),('8998','2014-01-17','12:35:00',1.51),('8998','2014-01-17','12:40:00',1.49),('8998','2014-01-17','12:45:00',1.45),('8998','2014-01-17','12:50:00',1.35),('8998','2014-01-17','12:55:00',1.49),('8998','2014-01-17','13:00:00',1.04),('8998','2014-01-17','13:10:00',1.15),('8998','2014-01-17','13:15:00',1.36),('8998','2014-01-17','13:30:00',1.17),('8998','2014-01-17','13:45:00',1.05),('8998','2014-01-16','09:00:00',1.07),('8998','2014-01-16','09:05:00',1.27),('8998','2014-01-16','09:10:00',1.13),('8998','2014-01-16','09:20:00',1.26),('8998','2014-01-16','09:25:00',1.46),('8998','2014-01-16','09:30:00',1.42),('8998','2014-01-16','09:35:00',1.43),('8998','2014-01-16','09:40:00',1.57),('8998','2014-01-16','09:45:00',1.62),('8998','2014-01-16','09:50:00',1.02),('8998','2014-01-16','11:30:00',1.12),('8998','2014-01-16','12:05:00',1.17),('8998','2014-01-16','12:10:00',1.06),('8998','2014-04-24','07:55:00',1.11),('8998','2014-04-24','08:00:00',1.26),('8998','2014-04-24','08:05:00',1.21),('8998','2014-04-24','08:10:00',1.24),('8998','2014-04-24','08:15:00',1.26),('8998','2014-04-24','08:20:00',1.46),('8998','2014-04-24','08:25:00',1.57),('8998','2014-04-24','08:30:00',1.56),('8998','2014-04-24','08:35:00',1.49),('8998','2014-04-24','08:40:00',1.48),('8998','2014-04-24','08:45:00',1.55),('8998','2014-04-24','08:50:00',1.58),('8998','2014-04-24','08:55:00',1.61),('8998','2014-04-24','09:00:00',1.79),('8998','2014-04-24','09:05:00',1.73),('8998','2014-04-24','09:10:00',2.02),('8998','2014-04-24','09:15:00',2.01),('8998','2014-04-24','09:20:00',1.36),('8998','2014-04-24','09:25:00',1.03),('8998','2014-04-24','09:30:00',1.14),('8998','2014-04-24','09:35:00',1.01),('8998','2014-04-24','10:35:00',1.91),('8998','2014-04-24','10:40:00',3.08),('8998','2014-04-24','10:45:00',3.15),('8998','2014-04-24','10:50:00',2.74),('8998','2014-04-24','10:55:00',1.84),('8998','2014-04-24','11:00:00',2.83),('8998','2014-04-24','11:05:00',2.02),('8998','2014-04-24','11:15:00',1.36),('8998','2014-04-24','11:20:00',3.22),('8998','2014-04-24','11:25:00',2.79),('8998','2014-04-24','11:30:00',1.34),('8998','2014-04-24','11:35:00',3.08),('8998','2014-04-24','11:40:00',1.83),('8998','2014-04-24','11:45:00',1.41),('8998','2014-04-24','12:00:00',1.41),('8998','2014-04-24','12:05:00',1.21),('8998','2014-04-24','12:10:00',1.23),('8998','2014-04-24','12:15:00',1.97),('8998','2014-04-24','12:20:00',3.2),('8998','2014-04-24','12:25:00',2.11),('8998','2014-04-24','12:30:00',1.66),('8998','2014-04-24','12:35:00',2.47),('8998','2014-04-24','12:40:00',2.82),('8998','2014-04-24','12:45:00',2.97),('8998','2014-04-24','12:50:00',1.99),('8998','2014-04-24','12:55:00',1.68),('8998','2014-04-24','13:05:00',1.93),('8998','2014-04-24','13:10:00',1.08),('8998','2014-04-24','13:15:00',1.56),('8998','2014-04-24','13:20:00',1.24),('8998','2014-04-24','13:25:00',1.25),('8998','2014-04-24','13:30:00',1.49),('8998','2014-04-24','13:40:00',1.98),('8998','2014-04-24','13:45:00',1.48),('8998','2014-04-24','14:05:00',1.08),('8998','2014-04-24','14:10:00',1.01),('8998','2014-04-24','14:20:00',1.81),('8998','2014-04-24','14:25:00',2.09),('8998','2014-04-24','14:30:00',2.31),('8998','2014-04-24','14:35:00',2.51),('8998','2014-04-24','14:40:00',2.32),('8998','2014-04-24','14:45:00',2.3),('8998','2014-04-24','14:50:00',2.28),('8998','2014-04-24','14:55:00',2.17),('8998','2014-04-24','15:00:00',2.11),('8998','2014-04-24','15:05:00',2),('8998','2014-04-24','15:10:00',1.93),('8998','2014-04-24','15:15:00',1.89),('8998','2014-04-24','15:20:00',1.77),('8998','2014-04-24','15:25:00',1.75),('8998','2014-04-24','15:30:00',1.65),('8998','2014-04-24','15:35:00',1.65),('8998','2014-04-24','15:40:00',1.61),('8998','2014-04-24','15:45:00',1.53),('8998','2014-04-24','15:50:00',1.48),('8998','2014-04-24','15:55:00',1.44),('8998','2014-04-24','16:00:00',1.4),('8998','2014-04-24','16:05:00',1.3),('8998','2014-04-24','16:10:00',1.25),('8998','2014-04-24','16:15:00',1.16),('8998','2014-04-24','16:20:00',1.05),('8998','2014-04-24','16:25:00',1.03),('8998','2014-04-24','16:30:00',1.06),('8998','2014-04-24','16:35:00',1.02),('8998','2014-01-15','09:10:00',1.03),('8998','2014-01-15','09:20:00',1.37),('8998','2014-01-15','09:25:00',1.57),('8998','2014-01-15','09:30:00',1.61),('8998','2014-01-15','09:35:00',1.59),('8998','2014-01-15','09:40:00',1.67),('8998','2014-01-15','09:45:00',1.48),('8998','2014-01-15','09:50:00',1.09),('8998','2014-01-15','10:25:00',1.05),('8998','2014-01-15','10:30:00',1.44),('8998','2014-01-15','10:35:00',1.86),('8998','2014-01-15','10:40:00',1.82),('8998','2014-01-15','10:45:00',1.3),('8998','2014-01-15','10:50:00',1.35),('8998','2014-01-15','10:55:00',1.49),('8998','2014-01-15','11:00:00',1.45),('8998','2014-01-15','11:05:00',1.43),('8998','2014-01-15','11:10:00',1.46),('8998','2014-01-15','11:15:00',1.5),('8998','2014-01-15','11:20:00',1.33),('8998','2014-01-15','11:25:00',1.35),('8998','2014-01-15','11:30:00',1.2),('8998','2014-01-15','11:35:00',1.19),('8998','2014-01-15','11:40:00',1.12),('8998','2014-01-15','11:45:00',1.07),('8998','2014-01-15','11:50:00',1.21),('8998','2014-01-15','12:05:00',1.04),('8998','2014-01-15','12:10:00',1.13),('8998','2014-01-15','12:15:00',1.07),('8998','2014-01-15','12:35:00',1.07),('8998','2014-01-15','12:40:00',1.13),('8998','2014-01-15','12:45:00',1.16),('8998','2014-01-15','12:50:00',1.23),('8998','2014-01-15','12:55:00',1.25),('8998','2014-01-15','13:00:00',1.24),('8998','2014-01-15','13:05:00',1.3),('8998','2014-01-15','13:10:00',1.14),('8998','2014-01-15','13:15:00',1.2),('8998','2014-01-15','13:20:00',1.11),('8998','2014-01-15','13:25:00',1.15),('8998','2014-01-15','13:50:00',1.06),('8998','2014-01-14','10:15:00',1.17),('8998','2014-01-14','10:20:00',1.55),('8998','2014-01-14','10:25:00',1.71),('8998','2014-01-14','10:30:00',1.74),('8998','2014-01-14','10:35:00',1.08),('8998','2014-01-14','10:40:00',1.07),('8998','2014-01-14','10:45:00',1.56),('8998','2014-01-14','10:50:00',1.09),('8998','2014-01-14','11:05:00',1.02),('8998','2014-01-14','11:10:00',1.93),('8998','2014-01-14','11:15:00',1.77),('8998','2014-01-14','11:20:00',1.72),('8998','2014-01-14','11:25:00',1.64),('8998','2014-01-14','11:30:00',1.57),('8998','2014-01-14','11:35:00',1.51),('8998','2014-01-14','11:40:00',1.16),('8998','2014-01-14','11:45:00',1.63),('8998','2014-01-14','11:50:00',1.42),('8998','2014-01-14','11:55:00',1.33),('8998','2014-01-14','12:00:00',1.1),('8998','2014-01-14','12:05:00',1.08),('8998','2014-01-14','12:10:00',1.09),('8998','2014-01-14','12:15:00',1.25),('8998','2014-01-14','12:20:00',1.62),('8998','2014-01-14','12:25:00',1.44),('8998','2014-01-14','12:50:00',1),('8998','2014-01-14','13:15:00',1.35),('8998','2014-01-14','13:20:00',1.34),('8998','2014-01-14','13:25:00',1.22),('8998','2014-01-14','13:30:00',1.13),('8998','2014-01-14','13:35:00',1.03),('8998','2014-01-13','10:30:00',2.02),('8998','2014-01-13','10:35:00',2.26),('8998','2014-01-13','10:40:00',1.9),('8998','2014-01-13','10:45:00',1.76),('8998','2014-01-13','10:50:00',1.1),('8998','2014-01-13','11:00:00',1.01),('8998','2014-01-13','11:40:00',1.04),('8998','2014-01-12','09:15:00',1.21),('8998','2014-01-12','09:20:00',1.37),('8998','2014-01-12','09:25:00',1.38),('8998','2014-01-12','09:30:00',1.41),('8998','2014-01-12','09:35:00',1.44),('8998','2014-01-12','09:40:00',1.46),('8998','2014-01-12','09:45:00',1.48),('8998','2014-01-12','09:50:00',1.49),('8998','2014-01-12','09:55:00',1.51),('8998','2014-01-12','10:00:00',1.52),('8998','2014-01-12','10:05:00',1.52),('8998','2014-01-12','10:10:00',1.53),('8998','2014-01-12','10:15:00',1.54),('8998','2014-01-12','10:20:00',1.57),('8998','2014-01-12','10:25:00',1.58),('8998','2014-01-12','10:30:00',1.59),('8998','2014-01-12','10:35:00',1.6),('8998','2014-01-12','10:40:00',1.58),('8998','2014-01-12','10:45:00',1.62),('8998','2014-01-12','10:50:00',1.63),('8998','2014-01-12','10:55:00',1.64),('8998','2014-01-12','11:00:00',1.62),('8998','2014-01-12','11:05:00',1.64),('8998','2014-01-12','11:10:00',1.64),('8998','2014-01-12','11:15:00',1.64),('8998','2014-01-12','11:20:00',1.63),('8998','2014-01-12','11:25:00',1.62),('8998','2014-01-12','11:30:00',1.6),('8998','2014-01-12','11:35:00',1.6),('8998','2014-01-12','11:40:00',1.57),('8998','2014-01-12','11:45:00',1.55),('8998','2014-01-12','11:50:00',1.53),('8998','2014-01-12','11:55:00',1.51),('8998','2014-01-12','12:00:00',1.44),('8998','2014-01-12','12:05:00',1.43),('8998','2014-01-12','12:10:00',1.43),('8998','2014-01-12','12:15:00',1.42),('8998','2014-01-12','12:20:00',1.41),('8998','2014-01-12','12:25:00',1.37),('8998','2014-01-12','12:30:00',1.32),('8998','2014-01-12','12:35:00',1.3),('8998','2014-01-12','12:40:00',1.29),('8998','2014-01-12','12:45:00',1.27),('8998','2014-01-12','12:50:00',1.21),('8998','2014-01-12','12:55:00',1.16),('8998','2014-01-12','13:00:00',1.16),('8998','2014-01-12','13:05:00',1.1),('8998','2014-01-12','13:10:00',1.07),('8998','2014-01-12','13:15:00',1.01),('8998','2014-01-11','10:55:00',1.07),('8998','2014-01-11','11:00:00',1.09),('8998','2014-01-11','11:05:00',1.07),('8998','2014-01-11','11:10:00',1.33),('8998','2014-01-11','11:15:00',1.19),('8998','2014-01-11','11:20:00',1.17),('8998','2014-01-11','11:25:00',1.05),('8998','2014-01-11','11:30:00',1.15),('8998','2014-01-11','11:40:00',1.09),('8998','2014-01-11','11:45:00',1.26),('8998','2014-01-11','11:50:00',1.28),('8998','2014-01-11','11:55:00',1.26),('8998','2014-01-10','09:55:00',1.16),('8998','2014-01-10','10:00:00',1.35),('8998','2014-01-10','10:05:00',1.03),('8998','2014-01-10','10:15:00',1.13),('8998','2014-01-10','10:20:00',1.1),('8998','2014-01-10','10:25:00',1.36),('8998','2014-01-10','10:30:00',1.29),('8998','2014-01-10','10:35:00',1.32),('8998','2014-01-10','10:40:00',1.61),('8998','2014-01-10','10:45:00',1.71),('8998','2014-01-10','10:50:00',1.71),('8998','2014-01-10','10:55:00',1.66),('8998','2014-01-10','11:00:00',1.6),('8998','2014-01-10','11:05:00',1.51),('8998','2014-01-10','11:10:00',1.59),('8998','2014-01-10','11:15:00',1.47),('8998','2014-01-10','11:20:00',1.3),('8998','2014-01-10','11:25:00',1.28),('8998','2014-01-10','11:30:00',1.27),('8998','2014-01-10','11:35:00',1.18),('8998','2014-01-10','11:40:00',1.04),('8998','2014-01-10','11:45:00',1.07),('8998','2014-01-10','11:50:00',1.15),('8998','2014-01-10','11:55:00',1.15),('8998','2014-01-10','12:00:00',1.16),('8998','2014-01-10','12:05:00',1.26),('8998','2014-01-10','12:55:00',1.14),('8998','2014-01-10','13:00:00',1.13),('8998','2014-01-10','13:15:00',1.08),('8998','2014-01-08','09:30:00',1.04),('8998','2014-01-08','09:35:00',1.31),('8998','2014-01-08','09:40:00',1.23),('8998','2014-01-08','09:45:00',1.36),('8998','2014-01-08','09:50:00',1.48),('8998','2014-01-08','09:55:00',1.46),('8998','2014-01-08','10:00:00',1.47),('8998','2014-01-08','10:05:00',1.44),('8998','2014-01-08','10:10:00',1.19),('8998','2014-01-08','10:15:00',1.26),('8998','2014-01-08','10:20:00',1.3),('8998','2014-01-08','10:25:00',1.33),('8998','2014-01-08','10:30:00',1.38),('8998','2014-01-08','10:35:00',1.35),('8998','2014-01-08','10:40:00',1.35),('8998','2014-01-08','10:45:00',1.38),('8998','2014-01-08','10:50:00',1.49),('8998','2014-01-08','10:55:00',1.11),('8998','2014-01-08','11:45:00',1.05),('8998','2014-01-07','09:00:00',1),('8998','2014-01-07','09:05:00',1.06),('8998','2014-01-07','09:10:00',1.13),('8998','2014-01-07','09:15:00',1.19),('8998','2014-01-07','09:20:00',1.23),('8998','2014-01-07','09:25:00',1.25),('8998','2014-01-07','09:30:00',1.27),('8998','2014-01-07','09:35:00',1.28),('8998','2014-01-07','09:40:00',1.38),('8998','2014-01-07','09:45:00',1.42),('8998','2014-01-07','09:50:00',1.4),('8998','2014-01-07','09:55:00',1.44),('8998','2014-01-07','10:00:00',1.46),('8998','2014-01-07','10:05:00',1.43),('8998','2014-01-07','10:10:00',1.42),('8998','2014-01-07','10:15:00',1.46),('8998','2014-01-07','10:20:00',1.56),('8998','2014-01-07','10:25:00',1.6),('8998','2014-01-07','10:30:00',1.6),('8998','2014-01-07','10:35:00',1.48),('8998','2014-01-07','10:40:00',1.46),('8998','2014-01-07','10:45:00',1.58),('8998','2014-01-07','10:50:00',1.62),('8998','2014-01-07','10:55:00',1.64),('8998','2014-01-07','11:00:00',1.62),('8998','2014-01-07','11:05:00',1.62),('8998','2014-01-07','11:10:00',1.62),('8998','2014-01-07','11:15:00',1.63),('8998','2014-01-07','11:20:00',1.61),('8998','2014-01-07','11:25:00',1.6),('8998','2014-01-07','11:30:00',1.58),('8998','2014-01-07','11:35:00',1.62),('8998','2014-01-07','11:40:00',1.62),('8998','2014-01-07','11:45:00',1.57),('8998','2014-01-07','11:50:00',1.55),('8998','2014-01-07','11:55:00',1.5),('8998','2014-01-07','12:00:00',1.48),('8998','2014-01-07','12:05:00',1.47),('8998','2014-01-07','12:10:00',1.43),('8998','2014-01-07','12:15:00',1.42),('8998','2014-01-07','12:20:00',1.39),('8998','2014-01-07','12:25:00',1.37),('8998','2014-01-07','12:30:00',1.35),('8998','2014-01-07','12:35:00',1.32),('8998','2014-01-07','12:40:00',1.27),('8998','2014-01-07','12:45:00',1.19),('8998','2014-01-07','12:50:00',1.16),('8998','2014-01-07','12:55:00',1.15),('8998','2014-01-07','13:00:00',1.14),('8998','2014-01-07','13:05:00',1.09),('8998','2014-01-06','08:50:00',1.04),('8998','2014-01-06','08:55:00',1.06),('8998','2014-01-06','09:00:00',1.07),('8998','2014-01-06','09:05:00',1.24),('8998','2014-01-06','09:10:00',1.28),('8998','2014-01-06','09:15:00',1.32),('8998','2014-01-06','09:20:00',1.36),('8998','2014-01-06','09:25:00',1.39),('8998','2014-01-06','09:30:00',1.43),('8998','2014-01-06','09:35:00',1.46),('8998','2014-01-06','09:40:00',1.48),('8998','2014-01-06','09:45:00',1.51),('8998','2014-01-06','09:50:00',1.53),('8998','2014-01-06','09:55:00',1.55),('8998','2014-01-06','10:00:00',1.56),('8998','2014-01-06','10:05:00',1.57),('8998','2014-01-06','10:10:00',1.59),('8998','2014-01-06','10:15:00',1.6),('8998','2014-01-06','10:20:00',1.61),('8998','2014-01-06','10:25:00',1.62),('8998','2014-01-06','10:30:00',1.64),('8998','2014-01-06','10:35:00',1.65),('8998','2014-01-06','10:40:00',1.66),('8998','2014-01-06','10:45:00',1.67),('8998','2014-01-06','10:50:00',1.68),('8998','2014-01-06','10:55:00',1.68),('8998','2014-01-06','11:00:00',1.67),('8998','2014-01-06','11:05:00',1.67),('8998','2014-01-06','11:10:00',1.67),('8998','2014-01-06','11:15:00',1.66),('8998','2014-01-06','11:20:00',1.66),('8998','2014-01-06','11:25:00',1.66),('8998','2014-01-06','11:30:00',1.65),('8998','2014-01-06','11:35:00',1.64),('8998','2014-01-06','11:40:00',1.62),('8998','2014-01-06','11:45:00',1.61),('8998','2014-01-06','11:50:00',1.59),('8998','2014-01-06','11:55:00',1.57),('8998','2014-01-06','12:00:00',1.54),('8998','2014-01-06','12:05:00',1.52),('8998','2014-01-06','12:10:00',1.51),('8998','2014-01-06','12:15:00',1.46),('8998','2014-01-06','12:20:00',1.45),('8998','2014-01-06','12:25:00',1.42),('8998','2014-01-06','12:30:00',1.39),('8998','2014-01-06','12:35:00',1.35),('8998','2014-01-06','12:40:00',1.3),('8998','2014-01-06','12:45:00',1.28),('8998','2014-01-06','12:50:00',1.27),('8998','2014-01-06','12:55:00',1.22),('8998','2014-01-06','13:00:00',1.12),('8998','2014-01-06','13:05:00',1.04),('8998','2014-04-23','07:50:00',1.19),('8998','2014-04-23','07:55:00',1.29),('8998','2014-04-23','08:00:00',1.28),('8998','2014-04-23','08:05:00',1.3),('8998','2014-04-23','08:10:00',1.26),('8998','2014-04-23','08:15:00',1.29),('8998','2014-04-23','08:20:00',1.48),('8998','2014-04-23','08:25:00',1.64),('8998','2014-04-23','08:30:00',1.52),('8998','2014-04-23','08:35:00',1.41),('8998','2014-04-23','08:40:00',1.45),('8998','2014-04-23','08:45:00',1.54),('8998','2014-04-23','08:50:00',1.48),('8998','2014-04-23','08:55:00',1.59),('8998','2014-04-23','09:00:00',1.66),('8998','2014-04-23','09:05:00',1.83),('8998','2014-04-23','09:10:00',2.09),('8998','2014-04-23','09:15:00',2.24),('8998','2014-04-23','09:20:00',2.28),('8998','2014-04-23','09:25:00',2.35),('8998','2014-04-23','09:30:00',2.41),('8998','2014-04-23','09:35:00',2.45),('8998','2014-04-23','09:40:00',2.5),('8998','2014-04-23','09:45:00',2.58),('8998','2014-04-23','09:50:00',2.6),('8998','2014-04-23','09:55:00',2.61),('8998','2014-04-23','10:00:00',2.64),('8998','2014-04-23','10:05:00',2.67),('8998','2014-04-23','10:10:00',2.68),('8998','2014-04-23','10:15:00',2.71),('8998','2014-04-23','10:20:00',2.73),('8998','2014-04-23','10:25:00',2.72),('8998','2014-04-23','10:30:00',2.74),('8998','2014-04-23','10:35:00',2.75),('8998','2014-04-23','10:40:00',2.77),('8998','2014-04-23','10:45:00',2.79),('8998','2014-04-23','10:50:00',2.8),('8998','2014-04-23','10:55:00',2.81),('8998','2014-04-23','11:00:00',2.85),('8998','2014-04-23','11:05:00',2.87),('8998','2014-04-23','11:10:00',2.85),('8998','2014-04-23','11:15:00',2.87),('8998','2014-04-23','11:20:00',2.86),('8998','2014-04-23','11:25:00',2.85),('8998','2014-04-23','11:30:00',2.86),('8998','2014-04-23','11:35:00',2.87),('8998','2014-04-23','11:40:00',2.86),('8998','2014-04-23','11:45:00',2.83),('8998','2014-04-23','11:50:00',2.86),('8998','2014-04-23','11:55:00',2.87),('8998','2014-04-23','12:00:00',2.84),('8998','2014-04-23','12:05:00',2.86),('8998','2014-04-23','12:10:00',2.86),('8998','2014-04-23','12:15:00',2.93),('8998','2014-04-23','12:20:00',2.9),('8998','2014-04-23','12:25:00',2.81),('8998','2014-04-23','12:30:00',2.89),('8998','2014-04-23','12:35:00',2.86),('8998','2014-04-23','12:40:00',2.84),('8998','2014-04-23','12:45:00',2.87),('8998','2014-04-23','12:50:00',2.88),('8998','2014-04-23','12:55:00',2.74),('8998','2014-04-23','13:00:00',2.67),('8998','2014-04-23','13:05:00',2.76),('8998','2014-04-23','13:10:00',2.81),('8998','2014-04-23','13:15:00',2.84),('8998','2014-04-23','13:20:00',2.84),('8998','2014-04-23','13:25:00',2.76),('8998','2014-04-23','13:30:00',2.75),('8998','2014-04-23','13:35:00',2.74),('8998','2014-04-23','13:45:00',2.9),('8998','2014-04-23','13:50:00',1.05),('8998','2014-04-23','13:55:00',1.58),('8998','2014-04-23','14:00:00',2.16),('8998','2014-04-23','14:05:00',1.24),('8998','2014-04-23','14:10:00',2.59),('8998','2014-04-23','14:15:00',1.91),('8998','2014-04-23','14:20:00',2.14),('8998','2014-04-23','14:25:00',1.88),('8998','2014-04-23','14:30:00',2.7),('8998','2014-04-23','14:35:00',2.56),('8998','2014-04-23','14:40:00',1.78),('8998','2014-04-23','14:45:00',2.13),('8998','2014-04-23','14:50:00',1.02),('8998','2014-04-23','14:55:00',2.09),('8998','2014-04-23','15:00:00',2.79),('8998','2014-04-23','15:05:00',2.69),('8998','2014-04-23','15:10:00',2.38),('8998','2014-04-23','15:15:00',2.34),('8998','2014-04-23','15:20:00',1.5),('8998','2014-04-23','15:25:00',1.37),('8998','2014-04-23','15:30:00',1.49),('8998','2014-04-23','15:35:00',1.6),('8998','2014-04-23','15:40:00',1.3),('8998','2014-04-23','15:45:00',1.19),('8998','2014-04-23','15:50:00',1.48),('8998','2014-04-23','15:55:00',1.37),('8998','2014-04-23','16:00:00',1.86),('8998','2014-04-23','16:05:00',1.73),('8998','2014-04-23','16:10:00',1.33),('8998','2014-04-23','16:15:00',1.44),('8998','2014-04-23','16:20:00',1.43),('8998','2014-04-23','16:25:00',1.3),('8998','2014-04-23','16:30:00',1.62),('8998','2014-04-23','16:35:00',1.06),('8998','2014-04-23','16:40:00',1.05),('8998','2014-04-23','16:45:00',1.06),('8998','2014-01-05','11:40:00',1.78),('8998','2014-01-05','11:45:00',1.63),('8998','2014-01-05','11:50:00',1.63),('8998','2014-01-05','11:55:00',1.52),('8998','2014-01-05','12:00:00',1.58),('8998','2014-01-05','12:05:00',1.58),('8998','2014-01-05','12:10:00',1.53),('8998','2014-01-05','12:15:00',1.48),('8998','2014-01-05','12:20:00',1.44),('8998','2014-01-05','12:25:00',1.43),('8998','2014-01-05','12:30:00',1.39),('8998','2014-01-05','12:35:00',1.36),('8998','2014-01-05','12:40:00',1.34),('8998','2014-01-05','12:45:00',1.32),('8998','2014-01-05','12:50:00',1.32),('8998','2014-01-05','12:55:00',1.24),('8998','2014-01-05','13:00:00',1.15),('8998','2014-01-05','13:05:00',1.06),('8998','2014-01-02','09:20:00',1.14),('8998','2014-01-02','09:30:00',1.19),('8998','2014-01-02','09:35:00',1.42),('8998','2014-01-02','09:40:00',1.59),('8998','2014-01-02','09:45:00',1.55),('8998','2014-01-02','10:00:00',1.13),('8998','2014-01-02','10:05:00',1.34),('8998','2014-01-02','10:20:00',1.51),('8998','2014-01-02','12:05:00',1.02),('8998','2014-01-02','12:10:00',1.08),('8998','2014-01-02','12:45:00',1.04),('8998','2014-01-02','12:55:00',1.12),('8998','2014-01-01','08:50:00',1.02),('8998','2014-01-01','08:55:00',1.05),('8998','2014-01-01','09:05:00',1.18),('8998','2014-01-01','09:10:00',1.22),('8998','2014-01-01','09:15:00',1.25),('8998','2014-01-01','09:20:00',1.3),('8998','2014-01-01','09:25:00',1.33),('8998','2014-01-01','09:30:00',1.34),('8998','2014-01-01','09:35:00',1.36),('8998','2014-01-01','09:40:00',1.39),('8998','2014-01-01','09:45:00',1.42),('8998','2014-01-01','09:50:00',1.43),('8998','2014-01-01','09:55:00',1.46),('8998','2014-01-01','10:00:00',1.49),('8998','2014-01-01','10:05:00',1.56),('8998','2014-01-01','10:10:00',1.56),('8998','2014-01-01','10:15:00',1.53),('8998','2014-01-01','10:20:00',1.53),('8998','2014-01-01','10:25:00',1.55),('8998','2014-01-01','10:30:00',1.56),('8998','2014-01-01','10:35:00',1.57),('8998','2014-01-01','10:40:00',1.55),('8998','2014-01-01','10:45:00',1.55),('8998','2014-01-01','10:50:00',1.56),('8998','2014-01-01','10:55:00',1.6),('8998','2014-01-01','11:00:00',1.58),('8998','2014-01-01','11:05:00',1.56),('8998','2014-01-01','11:10:00',1.18),('8998','2014-01-01','11:30:00',1.01),('8998','2014-01-01','11:35:00',1.05),('8998','2014-01-01','11:40:00',1.06),('8998','2014-01-01','11:45:00',1.03),('8998','2014-01-01','12:55:00',1.25),('8998','2013-12-31','08:55:00',1.14),('8998','2013-12-31','09:00:00',1.08),('8998','2013-12-31','09:05:00',1.06),('8998','2013-12-31','09:10:00',1.48),('8998','2013-12-31','09:30:00',1.56),('8998','2013-12-31','09:40:00',1.19),('8998','2013-12-31','09:45:00',1.26),('8998','2013-12-31','09:50:00',1.68),('8998','2013-12-31','09:55:00',1.07),('8998','2013-12-31','13:40:00',1.18),('8998','2013-12-30','08:50:00',1.09),('8998','2013-12-30','09:00:00',1.3),('8998','2013-12-30','09:05:00',1.04),('8998','2013-12-30','09:15:00',1.09),('8998','2013-12-30','09:20:00',1.4),('8998','2013-12-30','09:25:00',1.43),('8998','2013-12-30','09:30:00',1.54),('8998','2013-12-30','09:35:00',1.58),('8998','2013-12-30','09:40:00',1.53),('8998','2013-12-30','09:45:00',1.54),('8998','2013-12-30','09:50:00',1.42),('8998','2013-12-30','11:10:00',1.23),('8998','2013-12-30','11:15:00',1.37),('8998','2013-12-30','11:20:00',1.06),('8998','2013-12-30','11:25:00',1.23),('8998','2013-12-30','11:30:00',1.29),('8998','2013-12-30','11:40:00',1.42),('8998','2013-12-30','11:55:00',1.62),('8998','2013-12-30','12:00:00',1.59),('8998','2013-12-30','12:05:00',1.54),('8998','2013-12-30','12:10:00',1.51),('8998','2013-12-30','12:15:00',1.48),('8998','2013-12-30','12:20:00',1.45),('8998','2013-12-30','12:25:00',1.41),('8998','2013-12-30','12:30:00',1.39),('8998','2013-12-30','12:35:00',1.35),('8998','2013-12-30','12:40:00',1.32),('8998','2013-12-30','12:45:00',1.28),('8998','2013-12-30','12:50:00',1.24),('8998','2013-12-30','12:55:00',1.18),('8998','2013-12-30','13:00:00',1.14),('8998','2013-12-30','13:05:00',1.08),('8998','2013-12-30','13:10:00',1.04),('8998','2013-12-28','08:40:00',1.21),('8998','2013-12-28','08:45:00',1.08),('8998','2013-12-28','09:10:00',1.15),('8998','2013-12-28','09:15:00',1.23),('8998','2013-12-28','09:20:00',1.39),('8998','2013-12-28','09:25:00',1.39),('8998','2013-12-28','09:30:00',1.43),('8998','2013-12-28','09:35:00',1.42),('8998','2013-12-28','09:40:00',1.47),('8998','2013-12-28','09:45:00',1.48),('8998','2013-12-28','09:50:00',1.41),('8998','2013-12-28','09:55:00',1.17),('8998','2013-12-28','10:00:00',1.24),('8998','2013-12-28','10:05:00',1.34),('8998','2013-12-28','10:10:00',1.04),('8998','2013-12-28','10:15:00',1.59),('8998','2013-12-28','10:20:00',1.68),('8998','2013-12-28','10:25:00',1.44),('8998','2013-12-28','10:30:00',1.8),('8998','2013-12-28','10:35:00',1.89),('8998','2013-12-28','10:40:00',2.11),('8998','2013-12-27','08:45:00',1.03),('8998','2013-12-27','08:50:00',1.08),('8998','2013-12-27','09:00:00',1.12),('8998','2013-12-27','09:05:00',1.21),('8998','2013-12-27','09:10:00',1.25),('8998','2013-12-27','09:15:00',1.3),('8998','2013-12-27','09:20:00',1.35),('8998','2013-12-27','09:25:00',1.39),('8998','2013-12-27','09:30:00',1.43),('8998','2013-12-27','09:35:00',1.44),('8998','2013-12-27','09:40:00',1.46),('8998','2013-12-27','09:45:00',1.49),('8998','2013-12-27','09:50:00',1.52),('8998','2013-12-27','09:55:00',1.54),('8998','2013-12-27','10:00:00',1.56),('8998','2013-12-27','10:05:00',1.56),('8998','2013-12-27','10:10:00',1.58),('8998','2013-12-27','10:15:00',1.58),('8998','2013-12-27','10:20:00',1.6),('8998','2013-12-27','10:25:00',1.62),('8998','2013-12-27','10:30:00',1.63),('8998','2013-12-27','10:35:00',1.64),('8998','2013-12-27','10:40:00',1.64),('8998','2013-12-27','10:45:00',1.64),('8998','2013-12-27','10:50:00',1.64),('8998','2013-12-27','10:55:00',1.64),('8998','2013-12-27','11:00:00',1.64),('8998','2013-12-27','11:05:00',1.64),('8998','2013-12-27','11:10:00',1.64),('8998','2013-12-27','11:15:00',1.63),('8998','2013-12-27','11:20:00',1.62),('8998','2013-12-27','11:25:00',1.61),('8998','2013-12-27','11:30:00',1.6),('8998','2013-12-27','11:35:00',1.59),('8998','2013-12-27','11:40:00',1.57),('8998','2013-12-27','11:45:00',1.56),('8998','2013-12-27','11:50:00',1.53),('8998','2013-12-27','11:55:00',1.51),('8998','2013-12-27','12:00:00',1.48),('8998','2013-12-27','12:05:00',1.44),('8998','2013-12-27','12:10:00',1.45),('8998','2013-12-27','12:15:00',1.43),('8998','2013-12-27','12:20:00',1.4),('8998','2013-12-27','12:25:00',1.36),('8998','2013-12-27','12:30:00',1.32),('8998','2013-12-27','12:35:00',1.29),('8998','2013-12-27','12:40:00',1.25),('8998','2013-12-27','12:45:00',1.22),('8998','2013-12-27','12:50:00',1.17),('8998','2013-12-27','12:55:00',1.06),('8998','2014-04-22','13:40:00',1.05),('8998','2014-04-22','13:45:00',1.08),('8998','2014-04-22','13:50:00',1.08),('8998','2014-04-22','13:55:00',1.04),('8998','2014-04-22','14:50:00',1.05),('8998','2014-04-22','14:55:00',1.2),('8998','2014-04-22','15:00:00',1.25),('8998','2014-04-22','15:05:00',1.25),('8998','2014-04-22','15:10:00',1.19),('8998','2014-04-22','15:15:00',1.15),('8998','2013-12-26','12:15:00',1.46),('8998','2013-12-26','12:45:00',1.07),('8998','2013-12-26','12:50:00',1.18),('8998','2013-12-26','12:55:00',1.08),('8998','2013-12-26','13:30:00',1.01),('8998','2013-12-26','13:35:00',1.13),('8998','2013-12-24','10:30:00',1.02),('8998','2013-12-24','10:35:00',1.16),('8998','2013-12-24','10:40:00',1.16),('8998','2013-12-24','10:45:00',1.01),('8998','2013-12-24','10:50:00',1.16),('8998','2013-12-24','11:20:00',1.05),('8998','2013-12-24','11:25:00',1.14),('8998','2013-12-24','11:30:00',1.06),('8998','2013-12-24','11:40:00',1.11),('8998','2013-12-24','11:45:00',1.18),('8998','2013-12-24','11:55:00',1.41),('8998','2013-12-24','12:00:00',1.5),('8998','2013-12-23','09:05:00',1.1),('8998','2013-12-23','09:10:00',1.14),('8998','2013-12-23','09:15:00',1.18),('8998','2013-12-23','09:20:00',1.21),('8998','2013-12-23','09:25:00',1.23),('8998','2013-12-23','09:30:00',1.29),('8998','2013-12-23','09:35:00',1.34),('8998','2013-12-23','09:40:00',1.37),('8998','2013-12-23','09:45:00',1.38),('8998','2013-12-23','09:50:00',1.37),('8998','2013-12-23','09:55:00',1.38),('8998','2013-12-23','10:00:00',1.35),('8998','2013-12-23','10:05:00',1.35),('8998','2013-12-23','10:10:00',1.42),('8998','2013-12-23','10:15:00',1.47),('8998','2013-12-23','10:20:00',1.45),('8998','2013-12-23','10:25:00',1.46),('8998','2013-12-23','10:30:00',1.49),('8998','2013-12-23','10:35:00',1.49),('8998','2013-12-23','10:40:00',1.5),('8998','2013-12-23','10:45:00',1.52),('8998','2013-12-23','10:50:00',1.51),('8998','2013-12-23','10:55:00',1.49),('8998','2013-12-23','11:00:00',1.49),('8998','2013-12-23','11:05:00',1.51),('8998','2013-12-23','11:10:00',1.47),('8998','2013-12-23','11:15:00',1.47),('8998','2013-12-23','11:20:00',1.48),('8998','2013-12-23','11:25:00',1.48),('8998','2013-12-23','11:30:00',1.48),('8998','2013-12-23','11:35:00',1.46),('8998','2013-12-23','11:40:00',1.45),('8998','2013-12-23','11:45:00',1.44),('8998','2013-12-23','11:50:00',1.41),('8998','2013-12-23','11:55:00',1.38),('8998','2013-12-23','12:00:00',1.35),('8998','2013-12-23','12:05:00',1.32),('8998','2013-12-23','12:10:00',1.29),('8998','2013-12-23','12:15:00',1.26),('8998','2013-12-23','12:20:00',1.25),('8998','2013-12-23','12:25:00',1.23),('8998','2013-12-23','12:30:00',1.2),('8998','2013-12-23','12:35:00',1.16),('8998','2013-12-23','12:40:00',1.12),('8998','2013-12-23','12:45:00',1.09),('8998','2013-12-23','12:50:00',1.05),('8998','2013-12-22','09:55:00',1.23),('8998','2013-12-22','10:00:00',1.44),('8998','2013-12-22','10:05:00',1.55),('8998','2013-12-22','10:10:00',1.6),('8998','2013-12-22','10:15:00',1.46),('8998','2013-12-22','10:20:00',1.56),('8998','2013-12-22','10:25:00',1.51),('8998','2013-12-22','10:30:00',1.39),('8998','2013-12-22','10:35:00',1.39),('8998','2013-12-22','10:40:00',1.4),('8998','2013-12-22','10:45:00',1.4),('8998','2013-12-22','10:50:00',1.38),('8998','2013-12-22','10:55:00',1.41),('8998','2013-12-22','11:00:00',1.62),('8998','2013-12-22','11:05:00',1.69),('8998','2013-12-22','11:10:00',1.69),('8998','2013-12-22','11:15:00',1.68),('8998','2013-12-22','11:20:00',1.6),('8998','2013-12-22','11:25:00',1.62),('8998','2013-12-22','11:30:00',1.51),('8998','2013-12-22','11:35:00',1.54),('8998','2013-12-22','11:40:00',1.56),('8998','2013-12-22','11:45:00',1.35),('8998','2013-12-22','11:50:00',1.36),('8998','2013-12-22','11:55:00',1.36),('8998','2013-12-22','12:00:00',1.38),('8998','2013-12-22','12:05:00',1.41),('8998','2013-12-22','12:10:00',1.36),('8998','2013-12-22','12:15:00',1.31),('8998','2013-12-22','12:20:00',1.29),('8998','2013-12-22','12:25:00',1.25),('8998','2013-12-22','12:30:00',1.3),('8998','2013-12-22','12:35:00',1.27),('8998','2013-12-22','12:40:00',1.23),('8998','2013-12-22','12:45:00',1.19),('8998','2013-12-22','12:50:00',1.14),('8998','2013-12-21','09:20:00',1.05),('8998','2013-12-21','09:30:00',1.03),('8998','2013-12-21','09:35:00',1.23),('8998','2013-12-21','09:40:00',1.68),('8998','2013-12-21','09:45:00',1.71),('8998','2013-12-21','09:50:00',1.8),('8998','2013-12-21','09:55:00',1.81),('8998','2013-12-21','10:00:00',1.78),('8998','2013-12-21','10:05:00',1.76),('8998','2013-12-21','10:10:00',1.77),('8998','2013-12-21','10:15:00',1.72),('8998','2013-12-21','10:20:00',1.64),('8998','2013-12-21','10:25:00',1.63),('8998','2013-12-21','10:30:00',1.69),('8998','2013-12-21','10:35:00',1.57),('8998','2013-12-21','10:40:00',1.46),('8998','2013-12-21','10:45:00',1.5),('8998','2013-12-21','10:50:00',1.57),('8998','2013-12-21','10:55:00',1.45),('8998','2013-12-21','11:00:00',1.28),('8998','2013-12-21','11:05:00',1.24),('8998','2013-12-21','11:10:00',1.64),('8998','2013-12-21','11:15:00',1.61),('8998','2013-12-21','11:20:00',1.44),('8998','2013-12-21','11:25:00',1.45),('8998','2013-12-21','11:30:00',1.35),('8998','2013-12-21','11:35:00',1.32),('8998','2013-12-21','11:40:00',1.4),('8998','2013-12-21','11:45:00',1.3),('8998','2013-12-21','12:35:00',1.04),('8998','2013-12-21','12:40:00',1.03),('8998','2013-12-21','12:50:00',1.11),('8998','2013-12-21','12:55:00',1.26),('8998','2013-12-21','13:00:00',1.2),('8998','2013-12-21','13:05:00',1.34),('8998','2013-12-21','13:10:00',1.31),('8998','2013-12-21','13:15:00',1.06),('8998','2013-12-20','08:50:00',1),('8998','2013-12-20','09:00:00',1.12),('8998','2013-12-20','09:05:00',1.14),('8998','2013-12-20','09:10:00',1.17),('8998','2013-12-20','09:15:00',1.22),('8998','2013-12-20','09:20:00',1.25),('8998','2013-12-20','09:25:00',1.28),('8998','2013-12-20','09:30:00',1.31),('8998','2013-12-20','09:35:00',1.35),('8998','2013-12-20','09:40:00',1.37),('8998','2013-12-20','09:45:00',1.39),('8998','2013-12-20','09:50:00',1.42),('8998','2013-12-20','09:55:00',1.46),('8998','2013-12-20','10:00:00',1.49),('8998','2013-12-20','10:05:00',1.5),('8998','2013-12-20','10:10:00',1.51),('8998','2013-12-20','10:15:00',1.52),('8998','2013-12-20','10:20:00',1.53),('8998','2013-12-20','10:25:00',1.54),('8998','2013-12-20','10:30:00',1.56),('8998','2013-12-20','10:35:00',1.57),('8998','2013-12-20','10:40:00',1.57),('8998','2013-12-20','10:45:00',1.58),('8998','2013-12-20','10:50:00',1.58),('8998','2013-12-20','10:55:00',1.57),('8998','2013-12-20','11:00:00',1.58),('8998','2013-12-20','11:05:00',1.59),('8998','2013-12-20','11:10:00',1.58),('8998','2013-12-20','11:15:00',1.57),('8998','2013-12-20','11:20:00',1.57),('8998','2013-12-20','11:25:00',1.57),('8998','2013-12-20','11:30:00',1.56),('8998','2013-12-20','11:35:00',1.54),('8998','2013-12-20','11:40:00',1.53),('8998','2013-12-20','11:45:00',1.51),('8998','2013-12-20','11:50:00',1.5),('8998','2013-12-20','11:55:00',1.48),('8998','2013-12-20','12:00:00',1.46),('8998','2013-12-20','12:05:00',1.44),('8998','2013-12-20','12:10:00',1.41),('8998','2013-12-20','12:15:00',1.38),('8998','2013-12-20','12:20:00',1.36),('8998','2013-12-20','12:25:00',1.33),('8998','2013-12-20','12:30:00',1.3),('8998','2013-12-20','12:35:00',1.27),('8998','2013-12-20','12:40:00',1.24),('8998','2013-12-20','12:45:00',1.18),('8998','2013-12-20','12:50:00',1.15),('8998','2013-12-20','12:55:00',1.08),('8998','2013-12-20','13:00:00',1.03),('8998','2013-12-19','09:05:00',1.07),('8998','2013-12-19','09:10:00',1.12),('8998','2013-12-19','09:15:00',1.15),('8998','2013-12-19','09:20:00',1.2),('8998','2013-12-19','09:25:00',1.24),('8998','2013-12-19','09:30:00',1.27),('8998','2013-12-19','09:35:00',1.3),('8998','2013-12-19','09:40:00',1.33),('8998','2013-12-19','09:45:00',1.36),('8998','2013-12-19','09:50:00',1.37),('8998','2013-12-19','09:55:00',1.39),('8998','2013-12-19','10:00:00',1.41),('8998','2013-12-19','10:05:00',1.43),('8998','2013-12-19','10:10:00',1.43),('8998','2013-12-19','10:15:00',1.44),('8998','2013-12-19','10:20:00',1.46),('8998','2013-12-19','10:25:00',1.48),('8998','2013-12-19','10:30:00',1.47),('8998','2013-12-19','10:35:00',1.48),('8998','2013-12-19','10:40:00',1.5),('8998','2013-12-19','10:45:00',1.5),('8998','2013-12-19','10:50:00',1.51),('8998','2013-12-19','10:55:00',1.51),('8998','2013-12-19','11:00:00',1.51),('8998','2013-12-19','11:05:00',1.51),('8998','2013-12-19','11:10:00',1.49),('8998','2013-12-19','11:15:00',1.48),('8998','2013-12-19','11:20:00',1.48),('8998','2013-12-19','11:25:00',1.47),('8998','2013-12-19','11:30:00',1.45),('8998','2013-12-19','11:35:00',1.44),('8998','2013-12-19','11:40:00',1.44),('8998','2013-12-19','11:45:00',1.43),('8998','2013-12-19','11:50:00',1.42),('8998','2013-12-19','11:55:00',1.41),('8998','2013-12-19','12:00:00',1.38),('8998','2013-12-19','12:05:00',1.35),('8998','2013-12-19','12:10:00',1.35),('8998','2013-12-19','12:15:00',1.32),('8998','2013-12-19','12:20:00',1.29),('8998','2013-12-19','12:25:00',1.24),('8998','2013-12-19','12:30:00',1.23),('8998','2013-12-19','12:35:00',1.2),('8998','2013-12-19','12:40:00',1.17),('8998','2013-12-19','12:45:00',1.11),('8998','2013-12-19','12:50:00',1.05),('8998','2013-12-18','09:00:00',1.14),('8998','2013-12-18','09:05:00',1.28),('8998','2013-12-18','09:10:00',1.2),('8998','2013-12-18','09:15:00',1.12),('8998','2013-12-18','09:25:00',1.41),('8998','2013-12-18','09:35:00',1.1),('8998','2013-12-18','09:50:00',1.08),('8998','2013-12-18','09:55:00',1.63),('8998','2013-12-18','10:00:00',1.48),('8998','2013-12-18','10:05:00',1.47),('8998','2013-12-18','10:10:00',1.54),('8998','2013-12-18','10:15:00',1.56),('8998','2013-12-18','10:20:00',1.27),('8998','2013-12-18','10:45:00',1.25),('8998','2013-12-18','10:50:00',1.76),('8998','2013-12-18','11:15:00',1.32),('8998','2013-12-17','08:55:00',1.09),('8998','2013-12-17','09:00:00',1.14),('8998','2013-12-17','09:05:00',1.18),('8998','2013-12-17','09:10:00',1.23),('8998','2013-12-17','09:15:00',1.26),('8998','2013-12-17','09:20:00',1.3),('8998','2013-12-17','09:25:00',1.33),('8998','2013-12-17','09:30:00',1.36),('8998','2013-12-17','09:35:00',1.39),('8998','2013-12-17','09:40:00',1.4),('8998','2013-12-17','09:45:00',1.44),('8998','2013-12-17','09:50:00',1.45),('8998','2013-12-17','09:55:00',1.46),('8998','2013-12-17','10:00:00',1.48),('8998','2013-12-17','10:05:00',1.52),('8998','2013-12-17','10:10:00',1.54),('8998','2013-12-17','10:15:00',1.56),('8998','2013-12-17','10:20:00',1.57),('8998','2013-12-17','10:25:00',1.58),('8998','2013-12-17','10:30:00',1.6),('8998','2013-12-17','10:35:00',1.6),('8998','2013-12-17','10:40:00',1.59),('8998','2013-12-17','10:45:00',1.59),('8998','2013-12-17','10:50:00',1.59),('8998','2013-12-17','10:55:00',1.59),('8998','2013-12-17','11:00:00',1.58),('8998','2013-12-17','11:05:00',1.58),('8998','2013-12-17','11:10:00',1.58),('8998','2013-12-17','11:15:00',1.57),('8998','2013-12-17','11:20:00',1.55),('8998','2013-12-17','11:25:00',1.53),('8998','2013-12-17','11:30:00',1.52),('8998','2013-12-17','11:35:00',1.5),('8998','2013-12-17','11:40:00',1.49),('8998','2013-12-17','11:45:00',1.47),('8998','2013-12-17','11:50:00',1.45),('8998','2013-12-17','11:55:00',1.44),('8998','2013-12-17','12:00:00',1.42),('8998','2013-12-17','12:05:00',1.4),('8998','2013-12-17','12:10:00',1.39),('8998','2013-12-17','12:15:00',1.36),('8998','2013-12-17','12:20:00',1.33),('8998','2013-12-17','12:25:00',1.3),('8998','2013-12-17','12:30:00',1.29),('8998','2013-12-17','12:35:00',1.24),('8998','2013-12-17','12:40:00',1.2),('8998','2013-12-17','12:45:00',1.16),('8998','2013-12-17','12:50:00',1.07),('8998','2014-04-21','07:55:00',1.09),('8998','2014-04-21','08:00:00',1.14),('8998','2014-04-21','08:05:00',1.16),('8998','2014-04-21','08:10:00',1.25),('8998','2014-04-21','08:15:00',1.3),('8998','2014-04-21','08:20:00',1.37),('8998','2014-04-21','08:25:00',1.54),('8998','2014-04-21','08:30:00',1.48),('8998','2014-04-21','08:35:00',1.47),('8998','2014-04-21','08:40:00',1.58),('8998','2014-04-21','08:45:00',1.57),('8998','2014-04-21','08:50:00',1.63),('8998','2014-04-21','08:55:00',1.7),('8998','2014-04-21','09:00:00',1.69),('8998','2014-04-21','09:05:00',1.85),('8998','2014-04-21','09:10:00',1.77),('8998','2014-04-21','09:15:00',1.68),('8998','2014-04-21','09:20:00',1.88),('8998','2014-04-21','09:25:00',1.89),('8998','2014-04-21','09:30:00',1.54),('8998','2014-04-21','09:35:00',1.96),('8998','2014-04-21','09:40:00',2.43),('8998','2014-04-21','09:45:00',2.52),('8998','2014-04-21','09:50:00',2.02),('8998','2014-04-21','09:55:00',1.13),('8998','2014-04-21','10:05:00',1.03),('8998','2014-04-21','10:10:00',1.4),('8998','2014-04-21','10:15:00',1.55),('8998','2014-04-21','10:20:00',2.39),('8998','2014-04-21','10:25:00',1.77),('8998','2014-04-21','10:30:00',2.65),('8998','2014-04-21','10:35:00',2.88),('8998','2014-04-21','10:40:00',2.65),('8998','2014-04-21','10:45:00',2.86),('8998','2014-04-21','10:50:00',3.27),('8998','2014-04-21','10:55:00',2.34),('8998','2014-04-21','11:00:00',1.5),('8998','2014-04-21','11:05:00',1.63),('8998','2014-04-21','11:10:00',1.19),('8998','2014-04-21','12:30:00',1.12),('8998','2014-04-21','12:35:00',1.06),('8998','2014-04-21','13:20:00',1.49),('8998','2014-04-21','13:25:00',1.74),('8998','2014-04-21','13:30:00',1.96),('8998','2014-04-21','13:35:00',1.76),('8998','2014-04-21','13:40:00',2.15),('8998','2014-04-21','13:45:00',2.15),('8998','2014-04-21','13:50:00',1.93),('8998','2014-04-21','13:55:00',1.12),('8998','2014-04-21','14:05:00',1.04),('8998','2014-04-21','14:10:00',2.22),('8998','2014-04-21','14:15:00',2.07),('8998','2014-04-21','14:20:00',2.3),('8998','2014-04-21','14:25:00',1.9),('8998','2014-04-21','14:30:00',1.3),('8998','2014-04-21','14:35:00',1.51),('8998','2014-04-21','14:40:00',2.02),('8998','2014-04-21','14:45:00',2.39),('8998','2014-04-21','14:50:00',2.15),('8998','2014-04-21','14:55:00',1.76),('8998','2014-04-21','15:30:00',1.11),('8998','2014-04-21','15:35:00',1.49),('8998','2014-04-21','15:40:00',1.35),('8998','2014-04-21','15:45:00',1.11),('8998','2014-04-21','15:50:00',1.3),('8998','2014-04-21','15:55:00',1.16),('8998','2014-04-21','16:00:00',1.31),('8998','2014-04-21','16:05:00',1.01),('8998','2014-04-21','16:20:00',1.03),('8998','2014-04-21','16:25:00',1.02),('8998','2013-12-16','08:40:00',1.04),('8998','2013-12-16','08:45:00',1.1),('8998','2013-12-16','08:55:00',1.21),('8998','2013-12-16','09:00:00',1.25),('8998','2013-12-16','09:05:00',1.29),('8998','2013-12-16','09:10:00',1.33),('8998','2013-12-16','09:15:00',1.36),('8998','2013-12-16','09:20:00',1.38),('8998','2013-12-16','09:25:00',1.41),('8998','2013-12-16','09:30:00',1.44),('8998','2013-12-16','09:35:00',1.46),('8998','2013-12-16','09:40:00',1.49),('8998','2013-12-16','09:45:00',1.52),('8998','2013-12-16','09:50:00',1.55),('8998','2013-12-16','09:55:00',1.57),('8998','2013-12-16','10:00:00',1.58),('8998','2013-12-16','10:05:00',1.6),('8998','2013-12-16','10:10:00',1.61),('8998','2013-12-16','10:15:00',1.61),('8998','2013-12-16','10:20:00',1.63),('8998','2013-12-16','10:25:00',1.63),('8998','2013-12-16','10:30:00',1.65),('8998','2013-12-16','10:35:00',1.65),('8998','2013-12-16','10:40:00',1.65),('8998','2013-12-16','10:45:00',1.64),('8998','2013-12-16','10:50:00',1.63),('8998','2013-12-16','10:55:00',1.63),('8998','2013-12-16','11:00:00',1.63),('8998','2013-12-16','11:05:00',1.62),('8998','2013-12-16','11:10:00',1.62),('8998','2013-12-16','11:15:00',1.62),('8998','2013-12-16','11:20:00',1.61),('8998','2013-12-16','11:25:00',1.59),('8998','2013-12-16','11:30:00',1.59),('8998','2013-12-16','11:35:00',1.57),('8998','2013-12-16','11:40:00',1.56),('8998','2013-12-16','11:45:00',1.55),('8998','2013-12-16','11:50:00',1.53),('8998','2013-12-16','11:55:00',1.5),('8998','2013-12-16','12:00:00',1.47),('8998','2013-12-16','12:05:00',1.45),('8998','2013-12-16','12:10:00',1.42),('8998','2013-12-16','12:15:00',1.41),('8998','2013-12-16','12:20:00',1.38),('8998','2013-12-16','12:25:00',1.35),('8998','2013-12-16','12:30:00',1.32),('8998','2013-12-16','12:35:00',1.3),('8998','2013-12-16','12:40:00',1.25),('8998','2013-12-16','12:45:00',1.2),('8998','2013-12-16','12:50:00',1.09),('8998','2013-12-15','08:40:00',1.02),('8998','2013-12-15','08:45:00',1.06),('8998','2013-12-15','08:55:00',1.18),('8998','2013-12-15','09:00:00',1.23),('8998','2013-12-15','09:05:00',1.27),('8998','2013-12-15','09:10:00',1.3),('8998','2013-12-15','09:15:00',1.33),('8998','2013-12-15','09:20:00',1.35),('8998','2013-12-15','09:25:00',1.39),('8998','2013-12-15','09:30:00',1.43),('8998','2013-12-15','09:35:00',1.46),('8998','2013-12-15','09:40:00',1.48),('8998','2013-12-15','09:45:00',1.5),('8998','2013-12-15','09:50:00',1.52),('8998','2013-12-15','09:55:00',1.53),('8998','2013-12-15','10:00:00',1.54),('8998','2013-12-15','10:05:00',1.56),('8998','2013-12-15','10:10:00',1.58),('8998','2013-12-15','10:15:00',1.58),('8998','2013-12-15','10:20:00',1.58),('8998','2013-12-15','10:25:00',1.57),('8998','2013-12-15','10:30:00',1.58),('8998','2013-12-15','10:35:00',1.58),('8998','2013-12-15','10:40:00',1.59),('8998','2013-12-15','10:45:00',1.59),('8998','2013-12-15','10:50:00',1.6),('8998','2013-12-15','10:55:00',1.6),('8998','2013-12-15','11:00:00',1.6),('8998','2013-12-15','11:05:00',1.59),('8998','2013-12-15','11:10:00',1.58),('8998','2013-12-15','11:15:00',1.57),('8998','2013-12-15','11:20:00',1.55),('8998','2013-12-15','11:25:00',1.55),('8998','2013-12-15','11:30:00',1.55),('8998','2013-12-15','11:35:00',1.54),('8998','2013-12-15','11:40:00',1.51),('8998','2013-12-15','11:45:00',1.5),('8998','2013-12-15','11:50:00',1.48),('8998','2013-12-15','11:55:00',1.47),('8998','2013-12-15','12:00:00',1.46),('8998','2013-12-15','12:05:00',1.44),('8998','2013-12-15','12:10:00',1.43),('8998','2013-12-15','12:15:00',1.4),('8998','2013-12-15','12:20:00',1.38),('8998','2013-12-15','12:25:00',1.35),('8998','2013-12-15','12:30:00',1.31),('8998','2013-12-15','12:35:00',1.28),('8998','2013-12-15','12:40:00',1.24),('8998','2013-12-15','12:45:00',1.2),('8998','2013-12-15','12:50:00',1.07),('8998','2013-12-15','12:55:00',1.05),('8998','2013-12-15','13:00:00',1.04),('8998','2013-12-13','08:55:00',1.09),('8998','2013-12-13','09:00:00',1.14),('8998','2013-12-13','09:05:00',1.19),('8998','2013-12-13','09:10:00',1.24),('8998','2013-12-13','09:15:00',1.28),('8998','2013-12-13','09:20:00',1.33),('8998','2013-12-13','09:25:00',1.36),('8998','2013-12-13','09:30:00',1.39),('8998','2013-12-13','09:35:00',1.42),('8998','2013-12-13','09:40:00',1.44),('8998','2013-12-13','09:45:00',1.46),('8998','2013-12-13','09:50:00',1.48),('8998','2013-12-13','09:55:00',1.49),('8998','2013-12-13','10:00:00',1.5),('8998','2013-12-13','10:05:00',1.52),('8998','2013-12-13','10:10:00',1.53),('8998','2013-12-13','10:15:00',1.56),('8998','2013-12-13','10:20:00',1.57),('8998','2013-12-13','10:25:00',1.56),('8998','2013-12-13','10:30:00',1.56),('8998','2013-12-13','10:35:00',1.57),('8998','2013-12-13','10:40:00',1.57),('8998','2013-12-13','10:45:00',1.57),('8998','2013-12-13','10:50:00',1.57),('8998','2013-12-13','10:55:00',1.55),('8998','2013-12-13','11:00:00',1.54),('8998','2013-12-13','11:05:00',1.53),('8998','2013-12-13','11:10:00',1.55),('8998','2013-12-13','11:15:00',1.54),('8998','2013-12-13','11:20:00',1.53),('8998','2013-12-13','11:25:00',1.51),('8998','2013-12-13','11:30:00',1.5),('8998','2013-12-13','11:35:00',1.49),('8998','2013-12-13','11:40:00',1.49),('8998','2013-12-13','11:45:00',1.45),('8998','2013-12-13','11:50:00',1.41),('8998','2013-12-13','11:55:00',1.38),('8998','2013-12-13','12:00:00',1.35),('8998','2013-12-13','12:05:00',1.34),('8998','2013-12-13','12:10:00',1.31),('8998','2013-12-13','12:15:00',1.31),('8998','2013-12-13','12:20:00',1.27),('8998','2013-12-13','12:25:00',1.24),('8998','2013-12-13','12:30:00',1.19),('8998','2013-12-13','12:35:00',1.17),('8998','2013-12-13','12:40:00',1.14),('8998','2013-12-13','12:45:00',1.09),('8998','2013-12-13','12:50:00',1.01),('8998','2013-12-12','09:00:00',1.03),('8998','2013-12-12','09:05:00',1.07),('8998','2013-12-12','09:10:00',1.11),('8998','2013-12-12','09:15:00',1.17),('8998','2013-12-12','09:20:00',1.21),('8998','2013-12-12','09:25:00',1.23),('8998','2013-12-12','09:30:00',1.24),('8998','2013-12-12','09:35:00',1.26),('8998','2013-12-12','09:40:00',1.29),('8998','2013-12-12','09:45:00',1.31),('8998','2013-12-12','09:50:00',1.35),('8998','2013-12-12','09:55:00',1.37),('8998','2013-12-12','10:00:00',1.38),('8998','2013-12-12','10:05:00',1.4),('8998','2013-12-12','10:10:00',1.41),('8998','2013-12-12','10:15:00',1.43),('8998','2013-12-12','10:20:00',1.44),('8998','2013-12-12','10:25:00',1.44),('8998','2013-12-12','10:30:00',1.46),('8998','2013-12-12','10:35:00',1.48),('8998','2013-12-12','10:40:00',1.48),('8998','2013-12-12','10:45:00',1.48),('8998','2013-12-12','10:50:00',1.48),('8998','2013-12-12','10:55:00',1.5),('8998','2013-12-12','11:00:00',1.5),('8998','2013-12-12','11:05:00',1.49),('8998','2013-12-12','11:10:00',1.46),('8998','2013-12-12','11:15:00',1.47),('8998','2013-12-12','11:20:00',1.48),('8998','2013-12-12','11:25:00',1.47),('8998','2013-12-12','11:30:00',1.45),('8998','2013-12-12','11:35:00',1.43),('8998','2013-12-12','11:40:00',1.41),('8998','2013-12-12','11:45:00',1.42),('8998','2013-12-12','11:50:00',1.4),('8998','2013-12-12','11:55:00',1.38),('8998','2013-12-12','12:00:00',1.38),('8998','2013-12-12','12:05:00',1.35),('8998','2013-12-12','12:10:00',1.3),('8998','2013-12-12','12:15:00',1.27),('8998','2013-12-12','12:20:00',1.23),('8998','2013-12-12','12:25:00',1.24),('8998','2013-12-12','12:30:00',1.22),('8998','2013-12-12','12:35:00',1.19),('8998','2013-12-12','12:40:00',1.15),('8998','2013-12-12','12:45:00',1.13),('8998','2013-12-11','08:55:00',1.1),('8998','2013-12-11','09:00:00',1.14),('8998','2013-12-11','09:05:00',1.17),('8998','2013-12-11','09:10:00',1.22),('8998','2013-12-11','09:15:00',1.25),('8998','2013-12-11','09:20:00',1.27),('8998','2013-12-11','09:25:00',1.32),('8998','2013-12-11','09:30:00',1.35),('8998','2013-12-11','09:35:00',1.39),('8998','2013-12-11','09:40:00',1.42),('8998','2013-12-11','09:45:00',1.43),('8998','2013-12-11','09:50:00',1.45),('8998','2013-12-11','09:55:00',1.46),('8998','2013-12-11','10:00:00',1.48),('8998','2013-12-11','10:05:00',1.5),('8998','2013-12-11','10:10:00',1.52),('8998','2013-12-11','10:15:00',1.54),('8998','2013-12-11','10:20:00',1.54),('8998','2013-12-11','10:25:00',1.54),('8998','2013-12-11','10:30:00',1.56),('8998','2013-12-11','10:35:00',1.56),('8998','2013-12-11','10:40:00',1.56),('8998','2013-12-11','10:45:00',1.56),('8998','2013-12-11','10:50:00',1.57),('8998','2013-12-11','10:55:00',1.56),('8998','2013-12-11','11:00:00',1.55),('8998','2013-12-11','11:05:00',1.54),('8998','2013-12-11','11:10:00',1.53),('8998','2013-12-11','11:15:00',1.53),('8998','2013-12-11','11:20:00',1.51),('8998','2013-12-11','11:25:00',1.51),('8998','2013-12-11','11:30:00',1.5),('8998','2013-12-11','11:35:00',1.5),('8998','2013-12-11','11:40:00',1.48),('8998','2013-12-11','11:45:00',1.45),('8998','2013-12-11','11:50:00',1.42),('8998','2013-12-11','11:55:00',1.4),('8998','2013-12-11','12:00:00',1.38),('8998','2013-12-11','12:05:00',1.38),('8998','2013-12-11','12:10:00',1.36),('8998','2013-12-11','12:15:00',1.33),('8998','2013-12-11','12:20:00',1.29),('8998','2013-12-11','12:25:00',1.28),('8998','2013-12-11','12:30:00',1.24),('8998','2013-12-11','12:35:00',1.21),('8998','2013-12-11','12:40:00',1.17),('8998','2013-12-11','12:45:00',1.13),('8998','2013-12-10','08:45:00',1.01),('8998','2013-12-10','08:55:00',1.15),('8998','2013-12-10','09:00:00',1.18),('8998','2013-12-10','09:05:00',1.22),('8998','2013-12-10','09:10:00',1.26),('8998','2013-12-10','09:15:00',1.3),('8998','2013-12-10','09:20:00',1.33),('8998','2013-12-10','09:25:00',1.36),('8998','2013-12-10','09:30:00',1.4),('8998','2013-12-10','09:35:00',1.43),('8998','2013-12-10','09:40:00',1.46),('8998','2013-12-10','09:45:00',1.49),('8998','2013-12-10','09:50:00',1.5),('8998','2013-12-10','09:55:00',1.54),('8998','2013-12-10','10:00:00',1.54),('8998','2013-12-10','10:05:00',1.55),('8998','2013-12-10','10:10:00',1.58),('8998','2013-12-10','10:15:00',1.59),('8998','2013-12-10','10:20:00',1.61),('8998','2013-12-10','10:25:00',1.62),('8998','2013-12-10','10:30:00',1.65),('8998','2013-12-10','10:35:00',1.66),('8998','2013-12-10','10:40:00',1.66),('8998','2013-12-10','10:45:00',1.63),('8998','2013-12-10','10:50:00',1.61),('8998','2013-12-10','10:55:00',1.61),('8998','2013-12-10','11:00:00',1.63),('8998','2013-12-10','11:05:00',1.64),('8998','2013-12-10','11:10:00',1.63),('8998','2013-12-10','11:15:00',1.61),('8998','2013-12-10','11:20:00',1.6),('8998','2013-12-10','11:25:00',1.55),('8998','2013-12-10','11:30:00',1.53),('8998','2013-12-10','11:35:00',1.53),('8998','2013-12-10','11:40:00',1.53),('8998','2013-12-10','11:45:00',1.51),('8998','2013-12-10','11:50:00',1.5),('8998','2013-12-10','11:55:00',1.49),('8998','2013-12-10','12:00:00',1.47),('8998','2013-12-10','12:05:00',1.44),('8998','2013-12-10','12:10:00',1.42),('8998','2013-12-10','12:15:00',1.4),('8998','2013-12-10','12:20:00',1.37),('8998','2013-12-10','12:25:00',1.29),('8998','2013-12-10','12:30:00',1.26),('8998','2013-12-10','12:35:00',1.24),('8998','2013-12-10','12:40:00',1.21),('8998','2013-12-10','12:45:00',1.17),('8998','2013-12-10','12:50:00',1.1),('8998','2013-12-10','12:55:00',1.06),('8998','2013-12-10','13:00:00',1.03),('8998','2013-12-09','08:40:00',1.01),('8998','2013-12-09','08:50:00',1.09),('8998','2013-12-09','08:55:00',1.18),('8998','2013-12-09','09:00:00',1.23),('8998','2013-12-09','09:05:00',1.27),('8998','2013-12-09','09:10:00',1.31),('8998','2013-12-09','09:15:00',1.34),('8998','2013-12-09','09:20:00',1.39),('8998','2013-12-09','09:25:00',1.42),('8998','2013-12-09','09:30:00',1.43),('8998','2013-12-09','09:35:00',1.45),('8998','2013-12-09','09:40:00',1.48),('8998','2013-12-09','09:45:00',1.51),('8998','2013-12-09','09:50:00',1.53),('8998','2013-12-09','09:55:00',1.56),('8998','2013-12-09','10:00:00',1.58),('8998','2013-12-09','10:05:00',1.6),('8998','2013-12-09','10:10:00',1.61),('8998','2013-12-09','10:15:00',1.62),('8998','2013-12-09','10:20:00',1.61),('8998','2013-12-09','10:25:00',1.61),('8998','2013-12-09','10:30:00',1.62),('8998','2013-12-09','10:35:00',1.63),('8998','2013-12-09','10:40:00',1.63),('8998','2013-12-09','10:45:00',1.63),('8998','2013-12-09','10:50:00',1.64),('8998','2013-12-09','10:55:00',1.64),('8998','2013-12-09','11:00:00',1.63),('8998','2013-12-09','11:05:00',1.63),('8998','2013-12-09','11:10:00',1.62),('8998','2013-12-09','11:15:00',1.62),('8998','2013-12-09','11:20:00',1.61),('8998','2013-12-09','11:25:00',1.6),('8998','2013-12-09','11:30:00',1.59),('8998','2013-12-09','11:35:00',1.58),('8998','2013-12-09','11:40:00',1.56),('8998','2013-12-09','11:45:00',1.54),('8998','2013-12-09','11:50:00',1.52),('8998','2013-12-09','11:55:00',1.5),('8998','2013-12-09','12:00:00',1.47),('8998','2013-12-09','12:05:00',1.44),('8998','2013-12-09','12:10:00',1.41),('8998','2013-12-09','12:15:00',1.38),('8998','2013-12-09','12:20:00',1.36),('8998','2013-12-09','12:25:00',1.32),('8998','2013-12-09','12:30:00',1.29),('8998','2013-12-09','12:35:00',1.23),('8998','2013-12-09','12:40:00',1.19),('8998','2013-12-09','12:45:00',1.14),('8998','2013-12-09','12:50:00',1.01),('8998','2013-12-08','09:35:00',1.39),('8998','2013-12-08','09:40:00',1.49),('8998','2013-12-08','09:45:00',1.49),('8998','2013-12-08','09:50:00',1.48),('8998','2013-12-08','09:55:00',1.5),('8998','2013-12-08','10:00:00',1.51),('8998','2013-12-08','10:05:00',1.57),('8998','2013-12-08','10:10:00',1.9),('8998','2013-12-08','10:15:00',1.85),('8998','2013-12-08','10:20:00',2.05),('8998','2013-12-08','10:25:00',1.32),('8998','2013-12-08','12:30:00',1.21),('8998','2013-12-08','12:55:00',1.02),('8998','2013-12-08','13:00:00',1.29),('8998','2013-12-08','13:05:00',1.03),('8998','2013-12-08','13:20:00',1.03),('8998','2013-12-07','11:15:00',1.08),('8998','2013-12-07','11:20:00',1.19),('8998','2014-04-20','09:20:00',1.16),('8998','2014-04-20','09:25:00',1.04),('8998','2014-04-20','10:00:00',1.08),('8998','2014-04-20','10:05:00',1.95),('8998','2014-04-20','10:10:00',2.74),('8998','2014-04-20','10:15:00',2.92),('8998','2014-04-20','10:20:00',2.8),('8998','2014-04-20','10:25:00',2.79),('8998','2014-04-20','10:30:00',2.76),('8998','2014-04-20','10:35:00',2.76),('8998','2014-04-20','10:40:00',2.77),('8998','2014-04-20','10:45:00',2.78),('8998','2014-04-20','10:50:00',2.79),('8998','2014-04-20','10:55:00',2.8),('8998','2014-04-20','11:00:00',2.81),('8998','2014-04-20','11:05:00',2.82),('8998','2014-04-20','11:10:00',2.83),('8998','2014-04-20','11:15:00',2.84),('8998','2014-04-20','11:20:00',2.84),('8998','2014-04-20','11:25:00',2.85),('8998','2014-04-20','11:30:00',2.85),('8998','2014-04-20','11:35:00',2.86),('8998','2014-04-20','11:40:00',2.86),('8998','2014-04-20','11:45:00',2.88),('8998','2014-04-20','11:50:00',2.89),('8998','2014-04-20','11:55:00',2.89),('8998','2014-04-20','12:00:00',2.88),('8998','2014-04-20','12:05:00',2.86),('8998','2014-04-20','12:10:00',2.86),('8998','2014-04-20','12:15:00',2.87),('8998','2014-04-20','12:20:00',2.88),('8998','2014-04-20','12:25:00',2.88),('8998','2014-04-20','12:30:00',2.87),('8998','2014-04-20','12:35:00',2.86),('8998','2014-04-20','12:40:00',2.86),('8998','2014-04-20','12:45:00',2.84),('8998','2014-04-20','12:50:00',2.83),('8998','2014-04-20','12:55:00',2.81),('8998','2014-04-20','13:00:00',2.78),('8998','2014-04-20','13:05:00',2.77),('8998','2014-04-20','13:10:00',2.75),('8998','2014-04-20','13:15:00',2.72),('8998','2014-04-20','13:20:00',2.7),('8998','2014-04-20','13:25:00',2.68),('8998','2014-04-20','13:30:00',2.66),('8998','2014-04-20','13:35:00',2.62),('8998','2014-04-20','13:40:00',2.57),('8998','2014-04-20','13:45:00',2.57),('8998','2014-04-20','13:50:00',2.56),('8998','2014-04-20','13:55:00',2.53),('8998','2014-04-20','14:00:00',2.51),('8998','2014-04-20','14:05:00',2.48),('8998','2014-04-20','14:10:00',2.44),('8998','2014-04-20','14:15:00',2.42),('8998','2014-04-20','14:20:00',2.39),('8998','2014-04-20','14:25:00',2.35),('8998','2014-04-20','14:30:00',2.31),('8998','2014-04-20','14:35:00',2.26),('8998','2014-04-20','14:40:00',2.21),('8998','2014-04-20','14:45:00',2.17),('8998','2014-04-20','14:50:00',2.13),('8998','2014-04-20','14:55:00',2.08),('8998','2014-04-20','15:00:00',2.04),('8998','2014-04-20','15:05:00',2),('8998','2014-04-20','15:10:00',1.94),('8998','2014-04-20','15:15:00',1.89),('8998','2014-04-20','15:20:00',1.84),('8998','2014-04-20','15:25:00',1.78),('8998','2014-04-20','15:30:00',1.73),('8998','2014-04-20','15:35:00',1.67),('8998','2014-04-20','15:40:00',1.62),('8998','2014-04-20','15:45:00',1.56),('8998','2014-04-20','15:50:00',1.51),('8998','2014-04-20','15:55:00',1.46),('8998','2014-04-20','16:00:00',1.4),('8998','2014-04-20','16:05:00',1.35),('8998','2014-04-20','16:10:00',1.24),('8998','2014-04-20','16:15:00',1.03),('8998','2014-04-20','16:20:00',1.23),('8998','2014-04-20','16:25:00',1.13),('8998','2014-04-20','16:30:00',1.04),('8998','2013-12-06','08:40:00',1.04),('8998','2013-12-06','08:50:00',1.15),('8998','2013-12-06','08:55:00',1.18),('8998','2013-12-06','09:00:00',1.22),('8998','2013-12-06','09:05:00',1.26),('8998','2013-12-06','09:10:00',1.3),('8998','2013-12-06','09:15:00',1.35),('8998','2013-12-06','09:20:00',1.37),('8998','2013-12-06','09:25:00',1.39),('8998','2013-12-06','09:30:00',1.42),('8998','2013-12-06','09:35:00',1.45),('8998','2013-12-06','09:40:00',1.48),('8998','2013-12-06','09:45:00',1.48),('8998','2013-12-06','09:50:00',1.5),('8998','2013-12-06','09:55:00',1.51),('8998','2013-12-06','10:00:00',1.53),('8998','2013-12-06','10:05:00',1.56),('8998','2013-12-06','10:10:00',1.56),('8998','2013-12-06','10:15:00',1.57),('8998','2013-12-06','10:20:00',1.58),('8998','2013-12-06','10:25:00',1.59),('8998','2013-12-06','10:30:00',1.59),('8998','2013-12-06','10:35:00',1.61),('8998','2013-12-06','10:40:00',1.62),('8998','2013-12-06','10:45:00',1.61),('8998','2013-12-06','10:50:00',1.58),('8998','2013-12-06','10:55:00',1.56),('8998','2013-12-06','11:00:00',1.57),('8998','2013-12-06','11:05:00',1.57),('8998','2013-12-06','11:10:00',1.56),('8998','2013-12-06','11:15:00',1.55),('8998','2013-12-06','11:20:00',1.55),('8998','2013-12-06','11:25:00',1.54),('8998','2013-12-06','11:30:00',1.53),('8998','2013-12-06','11:35:00',1.5),('8998','2013-12-06','11:40:00',1.48),('8998','2013-12-06','11:45:00',1.46),('8998','2013-12-06','11:50:00',1.44),('8998','2013-12-06','11:55:00',1.41),('8998','2013-12-06','12:00:00',1.39),('8998','2013-12-06','12:05:00',1.37),('8998','2013-12-06','12:10:00',1.35),('8998','2013-12-06','12:15:00',1.34),('8998','2013-12-06','12:20:00',1.31),('8998','2013-12-06','12:25:00',1.28),('8998','2013-12-06','12:30:00',1.25),('8998','2013-12-06','12:35:00',1.22),('8998','2013-12-06','12:40:00',1.18),('8998','2013-12-06','12:45:00',1.13),('8998','2013-12-06','12:50:00',1.04),('8998','2013-12-05','11:40:00',1.14),('8998','2013-12-05','11:45:00',1.01),('8998','2013-12-05','11:50:00',1.17),('8998','2013-12-05','11:55:00',1.04),('8998','2013-12-05','12:10:00',1.04),('8998','2013-12-05','12:20:00',1.06),('8998','2013-12-05','12:35:00',1.1),('8998','2013-12-05','12:40:00',1.07),('8998','2013-12-04','08:35:00',1),('8998','2013-12-04','08:45:00',1.09),('8998','2013-12-04','08:50:00',1.21),('8998','2013-12-04','08:55:00',1.25),('8998','2013-12-04','09:00:00',1.28),('8998','2013-12-04','09:05:00',1.32),('8998','2013-12-04','09:10:00',1.36),('8998','2013-12-04','09:15:00',1.39),('8998','2013-12-04','09:20:00',1.43),('8998','2013-12-04','09:25:00',1.45),('8998','2013-12-04','09:30:00',1.48),('8998','2013-12-04','09:35:00',1.5),('8998','2013-12-04','09:40:00',1.52),('8998','2013-12-04','09:45:00',1.53),('8998','2013-12-04','09:50:00',1.56),('8998','2013-12-04','09:55:00',1.57),('8998','2013-12-04','10:00:00',1.58),('8998','2013-12-04','10:05:00',1.6),('8998','2013-12-04','10:10:00',1.61),('8998','2013-12-04','10:15:00',1.63),('8998','2013-12-04','10:20:00',1.63),('8998','2013-12-04','10:25:00',1.64),('8998','2013-12-04','10:30:00',1.65),('8998','2013-12-04','10:35:00',1.66),('8998','2013-12-04','10:40:00',1.65),('8998','2013-12-04','10:45:00',1.64),('8998','2013-12-04','10:50:00',1.63),('8998','2013-12-04','10:55:00',1.62),('8998','2013-12-04','11:00:00',1.62),('8998','2013-12-04','11:05:00',1.63),('8998','2013-12-04','11:10:00',1.58),('8998','2013-12-04','11:15:00',1.6),('8998','2013-12-04','11:20:00',1.6),('8998','2013-12-04','11:25:00',1.59),('8998','2013-12-04','11:30:00',1.59),('8998','2013-12-04','11:35:00',1.54),('8998','2013-12-04','11:40:00',1.53),('8998','2013-12-04','11:45:00',1.5),('8998','2013-12-04','11:50:00',1.48),('8998','2013-12-04','11:55:00',1.47),('8998','2013-12-04','12:00:00',1.46),('8998','2013-12-04','12:05:00',1.43),('8998','2013-12-04','12:10:00',1.38),('8998','2013-12-04','12:15:00',1.34),('8998','2013-12-04','12:20:00',1.35),('8998','2013-12-04','12:25:00',1.27),('8998','2013-12-04','12:30:00',1.25),('8998','2013-12-04','12:35:00',1.25),('8998','2013-12-04','12:40:00',1.2),('8998','2013-12-04','12:45:00',1.05),('8998','2013-12-03','08:25:00',1.01),('8998','2013-12-03','08:30:00',1.08),('8998','2013-12-03','08:35:00',1.13),('8998','2013-12-03','08:40:00',1.03),('8998','2013-12-03','08:45:00',1.27),('8998','2013-12-03','08:50:00',1.32),('8998','2013-12-03','08:55:00',1.37),('8998','2013-12-03','09:00:00',1.41),('8998','2013-12-03','09:05:00',1.44),('8998','2013-12-03','09:10:00',1.48),('8998','2013-12-03','09:15:00',1.5),('8998','2013-12-03','09:20:00',1.53),('8998','2013-12-03','09:25:00',1.55),('8998','2013-12-03','09:30:00',1.58),('8998','2013-12-03','09:35:00',1.61),('8998','2013-12-03','09:40:00',1.64),('8998','2013-12-03','09:45:00',1.66),('8998','2013-12-03','09:50:00',1.68),('8998','2013-12-03','09:55:00',1.69),('8998','2013-12-03','10:00:00',1.7),('8998','2013-12-03','10:05:00',1.72),('8998','2013-12-03','10:10:00',1.72),('8998','2013-12-03','10:15:00',1.73),('8998','2013-12-03','10:20:00',1.73),('8998','2013-12-03','10:25:00',1.74),('8998','2013-12-03','10:30:00',1.75),('8998','2013-12-03','10:35:00',1.75),('8998','2013-12-03','10:40:00',1.74),('8998','2013-12-03','10:45:00',1.75),('8998','2013-12-03','10:50:00',1.75),('8998','2013-12-03','10:55:00',1.75),('8998','2013-12-03','11:00:00',1.73),('8998','2013-12-03','11:05:00',1.72),('8998','2013-12-03','11:10:00',1.71),('8998','2013-12-03','11:15:00',1.7),('8998','2013-12-03','11:20:00',1.68),('8998','2013-12-03','11:25:00',1.67),('8998','2013-12-03','11:30:00',1.66),('8998','2013-12-03','11:35:00',1.65),('8998','2013-12-03','11:40:00',1.62),('8998','2013-12-03','11:45:00',1.61),('8998','2013-12-03','11:50:00',1.58),('8998','2013-12-03','11:55:00',1.56),('8998','2013-12-03','12:00:00',1.54),('8998','2013-12-03','12:05:00',1.51),('8998','2013-12-03','12:10:00',1.48),('8998','2013-12-03','12:15:00',1.44),('8998','2013-12-03','12:20:00',1.42),('8998','2013-12-03','12:25:00',1.39),('8998','2013-12-03','12:30:00',1.36),('8998','2013-12-03','12:35:00',1.32),('8998','2013-12-03','12:40:00',1.28),('8998','2013-12-03','12:45:00',1.22),('8998','2013-12-03','12:50:00',1.12),('8998','2013-12-03','12:55:00',1.01),('8998','2013-12-02','09:30:00',1.06),('8998','2013-12-02','09:35:00',1.04),('8998','2013-12-02','09:40:00',1.21),('8998','2013-12-02','09:45:00',1.3),('8998','2013-12-02','09:50:00',1.41),('8998','2013-12-02','09:55:00',1.37),('8998','2013-12-02','10:00:00',1.71),('8998','2013-12-02','10:05:00',1.7),('8998','2013-12-02','10:10:00',1.72),('8998','2013-12-02','10:15:00',1.73),('8998','2013-12-02','10:20:00',1.72),('8998','2013-12-02','10:25:00',1.73),('8998','2013-12-02','10:30:00',1.74),('8998','2013-12-02','10:35:00',1.74),('8998','2013-12-02','10:40:00',1.74),('8998','2013-12-02','10:45:00',1.73),('8998','2013-12-02','10:50:00',1.75),('8998','2013-12-02','10:55:00',1.77),('8998','2013-12-02','11:00:00',1.78),('8998','2013-12-02','11:05:00',1.78),('8998','2013-12-02','11:10:00',1.78),('8998','2013-12-02','11:15:00',1.77),('8998','2013-12-02','11:20:00',1.75),('8998','2013-12-02','11:25:00',1.72),('8998','2013-12-02','11:30:00',1.68),('8998','2013-12-02','11:35:00',1.67),('8998','2013-12-02','11:40:00',1.65),('8998','2013-12-02','11:45:00',1.64),('8998','2013-12-02','11:50:00',1.62),('8998','2013-12-02','11:55:00',1.61),('8998','2013-12-02','12:00:00',1.59),('8998','2013-12-02','12:05:00',1.58),('8998','2013-12-02','12:10:00',1.57),('8998','2013-12-02','12:15:00',1.57),('8998','2013-12-02','12:20:00',1.56),('8998','2013-12-02','12:25:00',1.55),('8998','2013-12-02','12:30:00',1.54),('8998','2013-12-02','12:35:00',1.55),('8998','2013-12-02','12:40:00',1.55),('8998','2013-12-02','12:45:00',1.54),('8998','2013-12-02','12:50:00',1.54),('8998','2013-12-02','12:55:00',1.55),('8998','2013-12-02','13:00:00',1.53),('8998','2013-12-02','13:05:00',1.5),('8998','2013-12-02','13:10:00',1.44),('8998','2013-12-02','13:15:00',1.34),('8998','2013-12-02','13:20:00',1.28),('8998','2013-12-02','13:25:00',1.18),('8998','2013-12-02','13:30:00',1.06),('8998','2013-11-29','09:10:00',1.1),('8998','2013-11-29','09:15:00',1.38),('8998','2013-11-29','09:20:00',1.52),('8998','2013-11-29','09:25:00',1.46),('8998','2013-11-29','09:30:00',1.35),('8998','2013-11-29','09:35:00',1.55),('8998','2013-11-29','09:40:00',1.72),('8998','2013-11-29','09:45:00',1.42),('8998','2013-11-29','09:50:00',1.05),('8998','2013-11-28','08:25:00',1.05),('8998','2013-11-28','08:30:00',1.1),('8998','2013-11-28','08:40:00',1.24),('8998','2013-11-28','08:45:00',1.29),('8998','2013-11-28','08:50:00',1.33),('8998','2013-11-28','08:55:00',1.37),('8998','2013-11-28','09:00:00',1.42),('8998','2013-11-28','09:05:00',1.46),('8998','2013-11-28','09:10:00',1.49),('8998','2013-11-28','09:15:00',1.52),('8998','2013-11-28','09:20:00',1.56),('8998','2013-11-28','09:25:00',1.59),('8998','2013-11-28','09:30:00',1.61),('8998','2013-11-28','09:35:00',1.64),('8998','2013-11-28','09:40:00',1.67),('8998','2013-11-28','09:45:00',1.69),('8998','2013-11-28','09:50:00',1.71),('8998','2013-11-28','09:55:00',1.73),('8998','2013-11-28','10:00:00',1.74),('8998','2013-11-28','10:05:00',1.76),('8998','2013-11-28','10:10:00',1.77),('8998','2013-11-28','10:15:00',1.77),('8998','2013-11-28','10:20:00',1.78),('8998','2013-11-28','10:25:00',1.79),('8998','2013-11-28','10:30:00',1.79),('8998','2013-11-28','10:35:00',1.79),('8998','2013-11-28','10:40:00',1.8),('8998','2013-11-28','10:45:00',1.8),('8998','2013-11-28','10:50:00',1.79),('8998','2013-11-28','10:55:00',1.79),('8998','2013-11-28','11:00:00',1.78),('8998','2013-11-28','11:05:00',1.78),('8998','2013-11-28','11:10:00',1.76),('8998','2013-11-28','11:15:00',1.75),('8998','2013-11-28','11:20:00',1.74),('8998','2013-11-28','11:25:00',1.74),('8998','2013-11-28','11:30:00',1.71),('8998','2013-11-28','11:35:00',1.7),('8998','2013-11-28','11:40:00',1.68),('8998','2013-11-28','11:45:00',1.66),('8998','2013-11-28','11:50:00',1.63),('8998','2013-11-28','11:55:00',1.61),('8998','2013-11-28','12:00:00',1.59),('8998','2013-11-28','12:05:00',1.56),('8998','2013-11-28','12:10:00',1.53),('8998','2013-11-28','12:15:00',1.5),('8998','2013-11-28','12:20:00',1.47),('8998','2013-11-28','12:25:00',1.44),('8998','2013-11-28','12:30:00',1.4),('8998','2013-11-28','12:35:00',1.35),('8998','2013-11-28','12:40:00',1.3),('8998','2013-11-28','12:45:00',1.25),('8998','2013-11-28','12:50:00',1.21),('8998','2013-11-28','12:55:00',1.17),('8998','2013-11-28','13:00:00',1.1),('8998','2013-11-28','13:05:00',1.03),('8998','2014-04-19','07:55:00',1.18),('8998','2014-04-19','08:00:00',1.16),('8998','2014-04-19','08:05:00',1.18),('8998','2014-04-19','08:10:00',1.21),('8998','2014-04-19','08:15:00',1.4),('8998','2014-04-19','08:20:00',1.65),('8998','2014-04-19','08:25:00',2.11),('8998','2014-04-19','08:30:00',2.16),('8998','2014-04-19','08:35:00',2.24),('8998','2014-04-19','08:40:00',1.86),('8998','2014-04-19','08:45:00',1.16),('8998','2014-04-19','08:50:00',1.81),('8998','2014-04-19','09:00:00',1.56),('8998','2014-04-19','09:10:00',1.21),('8998','2014-04-19','09:15:00',2.4),('8998','2014-04-19','09:20:00',2.54),('8998','2014-04-19','09:25:00',2.67),('8998','2014-04-19','09:30:00',2.82),('8998','2014-04-19','09:35:00',2.52),('8998','2014-04-19','09:40:00',1.47),('8998','2014-04-19','09:45:00',1.15),('8998','2014-04-19','09:50:00',1.17),('8998','2014-04-19','09:55:00',1.51),('8998','2014-04-19','10:00:00',1.82),('8998','2014-04-19','10:05:00',2.56),('8998','2014-04-19','10:10:00',2.15),('8998','2014-04-19','10:15:00',2.23),('8998','2014-04-19','10:20:00',2.3),('8998','2014-04-19','10:25:00',2.04),('8998','2014-04-19','10:30:00',1.91),('8998','2014-04-19','10:35:00',2.04),('8998','2014-04-19','10:40:00',2),('8998','2014-04-19','10:45:00',2.03),('8998','2014-04-19','10:50:00',2.28),('8998','2014-04-19','10:55:00',2.45),('8998','2014-04-19','11:00:00',2.64),('8998','2014-04-19','11:05:00',2.56),('8998','2014-04-19','11:10:00',2.34),('8998','2014-04-19','11:15:00',2.84),('8998','2014-04-19','11:20:00',2.57),('8998','2014-04-19','11:25:00',2.43),('8998','2014-04-19','11:30:00',3.06),('8998','2014-04-19','11:35:00',3.27),('8998','2014-04-19','11:40:00',2.48),('8998','2014-04-19','11:45:00',2.56),('8998','2014-04-19','11:50:00',2.66),('8998','2014-04-19','12:00:00',2.15),('8998','2014-04-19','12:05:00',2.05),('8998','2014-04-19','12:10:00',2.64),('8998','2014-04-19','12:15:00',2.37),('8998','2014-04-19','12:20:00',1.02),('8998','2014-04-19','12:25:00',2.58),('8998','2014-04-19','12:30:00',3.21),('8998','2014-04-19','12:35:00',2.99),('8998','2014-04-19','12:40:00',2.96),('8998','2014-04-19','12:45:00',2.94),('8998','2014-04-19','12:50:00',2.97),('8998','2014-04-19','12:55:00',2.97),('8998','2014-04-19','13:00:00',2.97),('8998','2014-04-19','13:05:00',2.94),('8998','2014-04-19','13:10:00',2.99),('8998','2014-04-19','13:15:00',2.94),('8998','2014-04-19','13:20:00',2.81),('8998','2014-04-19','13:25:00',2.78),('8998','2014-04-19','13:30:00',2.79),('8998','2014-04-19','13:35:00',2.76),('8998','2014-04-19','13:40:00',2.74),('8998','2014-04-19','13:45:00',2.71),('8998','2014-04-19','13:50:00',2.68),('8998','2014-04-19','13:55:00',2.63),('8998','2014-04-19','14:00:00',2.59),('8998','2014-04-19','14:05:00',2.58),('8998','2014-04-19','14:10:00',2.55),('8998','2014-04-19','14:15:00',2.59),('8998','2014-04-19','14:20:00',2.12),('8998','2014-04-19','14:25:00',1.84),('8998','2014-04-19','14:30:00',1.88),('8998','2014-04-19','14:35:00',1.59),('8998','2014-04-19','14:40:00',1.62),('8998','2014-04-19','14:45:00',1.71),('8998','2014-04-19','14:50:00',1.65),('8998','2014-04-19','14:55:00',1.85),('8998','2014-04-19','15:00:00',2.23),('8998','2014-04-19','15:05:00',2.25),('8998','2014-04-19','15:10:00',1.98),('8998','2014-04-19','15:15:00',2.06),('8998','2014-04-19','15:20:00',1.93),('8998','2014-04-19','15:25:00',1.88),('8998','2014-04-19','15:30:00',1.82),('8998','2014-04-19','15:35:00',1.75),('8998','2014-04-19','15:40:00',1.72),('8998','2014-04-19','15:45:00',1.51),('8998','2014-04-19','15:50:00',1.18),('8998','2014-04-19','15:55:00',1.59),('8998','2014-04-19','16:00:00',1.47),('8998','2014-04-19','16:05:00',1.41),('8998','2014-04-19','16:10:00',1.35),('8998','2014-04-19','16:15:00',1.29),('8998','2014-04-19','16:20:00',1.25),('8998','2014-04-19','16:30:00',1.15),('8998','2014-04-19','16:35:00',1),('8998','2013-11-26','10:45:00',1.06),('8998','2013-11-26','10:50:00',1.02),('8998','2013-11-26','11:10:00',1.22),('8998','2013-11-26','11:20:00',1.04),('8998','2013-11-26','11:30:00',1.33),('8998','2013-11-26','11:35:00',1.39),('8998','2013-11-26','11:40:00',1.09),('8998','2013-11-26','11:45:00',1.05),('8998','2013-11-26','11:50:00',1.28),('8998','2013-11-26','11:55:00',1.91),('8998','2013-11-26','12:00:00',1.86),('8998','2013-11-26','12:05:00',1.43),('8998','2013-11-26','12:15:00',1.19),('8998','2013-11-26','12:20:00',1.63),('8998','2013-11-26','12:30:00',1.25),('8998','2013-11-25','08:05:00',1.05),('8998','2013-11-25','08:10:00',1.11),('8998','2013-11-25','09:15:00',1.08),('8998','2013-11-25','09:20:00',1.09),('8998','2013-11-25','09:25:00',1),('8998','2013-11-25','09:35:00',1.02),('8998','2013-11-25','09:40:00',1.5),('8998','2013-11-25','09:45:00',1.09),('8998','2013-11-25','09:50:00',1.19),('8998','2013-11-25','09:55:00',1.49),('8998','2013-11-25','10:00:00',1.38),('8998','2013-11-25','10:05:00',1.64),('8998','2013-11-25','10:25:00',1.22),('8998','2013-11-25','10:30:00',1.77),('8998','2013-11-25','10:35:00',1.95),('8998','2013-11-25','10:40:00',1.94),('8998','2013-11-25','10:45:00',1.94),('8998','2013-11-25','10:50:00',1.97),('8998','2013-11-25','10:55:00',2),('8998','2013-11-25','11:00:00',2.12),('8998','2013-11-25','11:05:00',1.64),('8998','2013-11-25','11:10:00',2.09),('8998','2013-11-25','11:15:00',2.33),('8998','2013-11-25','11:20:00',2.14),('8998','2013-11-25','11:25:00',2.11),('8998','2013-11-25','11:30:00',2.13),('8998','2013-11-25','11:35:00',2.22),('8998','2013-11-25','11:40:00',2.08),('8998','2013-11-25','11:45:00',1.98),('8998','2013-11-25','11:50:00',1.87),('8998','2013-11-25','11:55:00',1.01),('8998','2013-11-25','12:20:00',1.62),('8998','2013-11-25','12:25:00',1.56),('8998','2013-11-25','12:30:00',1.5),('8998','2013-11-25','12:35:00',1.47),('8998','2013-11-25','12:40:00',1.42),('8998','2013-11-25','12:45:00',1.35),('8998','2013-11-25','12:50:00',1.29),('8998','2013-11-25','12:55:00',1.26),('8998','2013-11-25','13:00:00',1.21),('8998','2013-11-25','13:05:00',1.12),('8998','2013-11-25','13:10:00',1.07),('8998','2013-11-25','13:15:00',1.02),('8998','2013-11-24','08:15:00',1.08),('8998','2013-11-24','08:20:00',1.17),('8998','2013-11-24','08:25:00',1.27),('8998','2013-11-24','08:30:00',1.3),('8998','2013-11-24','08:35:00',1.17),('8998','2013-11-24','08:40:00',1.45),('8998','2013-11-24','08:45:00',1.55),('8998','2013-11-24','08:50:00',1.65),('8998','2013-11-24','08:55:00',1.74),('8998','2013-11-24','09:00:00',1.87),('8998','2013-11-24','09:05:00',1.93),('8998','2013-11-24','09:10:00',1.92),('8998','2013-11-24','09:15:00',1.98),('8998','2013-11-24','09:20:00',2.04),('8998','2013-11-24','09:25:00',2.04),('8998','2013-11-24','09:30:00',1.86),('8998','2013-11-24','09:35:00',1.8),('8998','2013-11-24','09:40:00',1.54),('8998','2013-11-24','09:50:00',1.02),('8998','2013-11-24','09:55:00',1.07),('8998','2013-11-24','10:05:00',1.02),('8998','2013-11-24','10:15:00',1.11),('8998','2013-11-24','10:20:00',1.25),('8998','2013-11-24','10:25:00',1.2),('8998','2013-11-24','10:30:00',1.58),('8998','2013-11-24','10:35:00',2.45),('8998','2013-11-24','10:40:00',2.36),('8998','2013-11-24','10:45:00',2.06),('8998','2013-11-24','10:50:00',1.79),('8998','2013-11-24','10:55:00',1.74),('8998','2013-11-24','11:00:00',1.95),('8998','2013-11-24','11:05:00',2.04),('8998','2013-11-24','11:10:00',2.31),('8998','2013-11-24','11:15:00',1.35),('8998','2013-11-24','11:20:00',1.12),('8998','2013-11-24','11:55:00',1.12),('8998','2013-11-24','12:10:00',1.14),('8998','2013-11-24','12:40:00',1.47),('8998','2013-11-24','12:45:00',1.45),('8998','2013-11-24','12:50:00',1.04),('8998','2013-11-24','12:55:00',1.23),('8998','2013-11-24','13:00:00',1.61),('8998','2013-11-24','13:05:00',1.6),('8998','2013-11-24','13:10:00',1.08),('8998','2013-11-24','13:15:00',1.07),('8998','2013-11-24','13:20:00',1.13),('8998','2013-11-23','10:05:00',1.07),('8998','2013-11-23','10:10:00',1.12),('8998','2013-11-23','10:25:00',1.22),('8998','2013-11-23','10:30:00',1.29),('8998','2013-11-23','11:25:00',1.04),('8998','2013-11-22','10:30:00',1.22),('8998','2013-11-22','10:40:00',1.88),('8998','2013-11-20','08:15:00',1.08),('8998','2013-11-20','09:20:00',1.1),('8998','2013-11-20','09:40:00',1.15),('8998','2013-11-20','09:45:00',1.62),('8998','2013-11-20','09:50:00',1.6),('8998','2013-11-20','09:55:00',1.37),('8998','2013-11-20','10:00:00',1.09),('8998','2013-11-20','10:05:00',1.84),('8998','2013-11-20','10:10:00',1.73),('8998','2013-11-20','10:15:00',1.87),('8998','2013-11-20','10:20:00',1.87),('8998','2013-11-20','10:25:00',1.27),('8998','2013-11-20','10:30:00',1.59),('8998','2013-11-20','10:35:00',1.8),('8998','2013-11-20','10:40:00',1.86),('8998','2013-11-20','10:45:00',1.48),('8998','2013-11-20','11:25:00',1.22),('8998','2013-11-20','11:30:00',1.71),('8998','2013-11-20','11:35:00',1.01),('8998','2013-11-20','11:40:00',1.73),('8998','2013-11-20','11:45:00',1.31),('8998','2013-11-20','11:50:00',1.67),('8998','2013-11-20','11:55:00',1.63),('8998','2013-11-20','12:00:00',1.1),('8998','2013-11-20','12:05:00',1.55),('8998','2013-11-20','12:10:00',1.59),('8998','2013-11-20','12:15:00',1.56),('8998','2013-11-20','12:20:00',1.53),('8998','2013-11-20','12:25:00',1.55),('8998','2013-11-20','12:30:00',1.63),('8998','2013-11-20','12:35:00',1.72),('8998','2013-11-20','12:40:00',1.77),('8998','2013-11-20','12:45:00',1.67),('8998','2013-11-20','12:50:00',1.52),('8998','2013-11-20','12:55:00',1.65),('8998','2013-11-20','13:00:00',1.57),('8998','2013-11-20','13:05:00',1.32),('8998','2013-11-20','13:15:00',1.18),('8998','2013-11-20','13:20:00',1.19),('8998','2013-11-19','08:20:00',1.19),('8998','2013-11-19','09:00:00',1.19),('8998','2013-11-19','09:15:00',1.55),('8998','2013-11-19','09:20:00',1.53),('8998','2013-11-19','09:25:00',1.68),('8998','2013-11-19','09:30:00',1.72),('8998','2013-11-19','10:00:00',1.23),('8998','2013-11-19','10:15:00',1.28),('8998','2013-11-19','11:45:00',2.08),('8998','2013-11-19','11:50:00',2.1),('8998','2013-11-19','12:20:00',1.51),('8998','2013-11-19','13:00:00',1.08),('8998','2013-11-18','09:40:00',1.7),('8998','2013-11-18','09:45:00',1.61),('8998','2013-11-18','10:05:00',1.11),('8998','2013-11-18','10:50:00',1.16),('8998','2013-11-18','11:20:00',1.63),('8998','2013-11-18','11:25:00',1.5),('8998','2013-11-18','11:30:00',1.55),('8998','2013-11-18','11:35:00',1.76),('8998','2013-11-18','11:40:00',1.62),('8998','2013-11-18','11:45:00',1.55),('8998','2013-11-18','11:50:00',1.57),('8998','2013-11-18','11:55:00',1.56),('8998','2013-11-18','12:00:00',1.46),('8998','2013-11-18','12:05:00',1.38),('8998','2013-11-18','12:10:00',1.49),('8998','2013-11-18','12:15:00',1.47),('8998','2013-11-18','12:45:00',1.23),('8998','2013-11-18','12:55:00',1.61),('8998','2013-11-18','13:00:00',1.28),('8998','2013-11-18','13:15:00',1.11),('8998','2013-11-18','13:20:00',1.18),('8998','2013-11-17','08:25:00',1.04),('8998','2013-11-17','08:30:00',1.14),('8998','2013-11-17','08:35:00',1.15),('8998','2013-11-17','09:20:00',1.28),('8998','2013-11-17','09:25:00',1.33),('8998','2013-11-17','09:30:00',1.23),('8998','2013-11-17','09:35:00',1.61),('8998','2013-11-17','09:40:00',1.25),('8998','2013-11-17','09:45:00',1.08),('8998','2013-11-17','10:05:00',1),('8998','2013-11-17','10:10:00',1.1),('8998','2013-11-17','10:15:00',1.3),('8998','2013-11-17','10:20:00',1.11),('8998','2013-11-17','12:20:00',1.03),('8998','2013-11-17','12:25:00',1.06),('8998','2014-04-18','07:40:00',1.02),('8998','2014-04-18','07:55:00',1.52),('8998','2014-04-18','08:00:00',1.23),('8998','2014-04-18','08:10:00',1.41),('8998','2014-04-18','08:25:00',1.25),('8998','2014-04-18','08:30:00',1.62),('8998','2014-04-18','08:35:00',2.08),('8998','2014-04-18','08:40:00',1.86),('8998','2014-04-18','08:45:00',1.63),('8998','2014-04-18','08:50:00',1.28),('8998','2014-04-18','09:30:00',1.71),('8998','2014-04-18','09:35:00',1.8),('8998','2014-04-18','09:40:00',1.05),('8998','2014-04-18','10:55:00',1.01),('8998','2014-04-18','11:00:00',1.13),('8998','2014-04-18','11:15:00',1.16),('8998','2014-04-18','11:20:00',2.48),('8998','2014-04-18','11:25:00',1.99),('8998','2014-04-18','11:30:00',1.91),('8998','2014-04-18','11:35:00',1.69),('8998','2014-04-18','11:40:00',2.03),('8998','2014-04-18','11:45:00',1.53),('8998','2014-04-18','11:50:00',1.38),('8998','2014-04-18','14:35:00',1.02),('8998','2014-04-18','14:40:00',1.08),('8998','2014-04-18','14:45:00',1.18),('8998','2014-04-18','15:50:00',1.57),('8998','2014-04-18','15:55:00',2.03),('8998','2014-04-18','16:00:00',1.22),('8998','2014-04-18','16:05:00',1.01),('8998','2014-04-18','16:10:00',1.02),('8998','2014-04-18','16:20:00',1.14),('8998','2014-04-18','16:25:00',1.14),('8998','2014-04-18','16:30:00',1.55),('8998','2014-04-18','16:35:00',1.03),('8998','2013-11-16','08:45:00',1.1),('8998','2013-11-16','08:50:00',1.1),('8998','2013-11-16','08:55:00',1.9),('8998','2013-11-16','09:00:00',1.71),('8998','2013-11-16','09:05:00',1.65),('8998','2013-11-16','09:10:00',1.63),('8998','2013-11-16','09:15:00',1.61),('8998','2013-11-16','09:20:00',1.38),('8998','2013-11-16','09:25:00',1.66),('8998','2013-11-16','09:30:00',1.68),('8998','2013-11-16','09:35:00',1.7),('8998','2013-11-16','09:40:00',1.72),('8998','2013-11-16','09:45:00',1.72),('8998','2013-11-16','09:50:00',1.74),('8998','2013-11-16','09:55:00',1.75),('8998','2013-11-16','10:00:00',1.77),('8998','2013-11-16','10:05:00',1.78),('8998','2013-11-16','10:10:00',1.79),('8998','2013-11-16','10:15:00',1.79),('8998','2013-11-16','10:20:00',1.8),('8998','2013-11-16','10:25:00',1.79),('8998','2013-11-16','10:30:00',1.79),('8998','2013-11-16','10:35:00',1.78),('8998','2013-11-16','10:40:00',1.78),('8998','2013-11-16','10:45:00',1.77),('8998','2013-11-16','10:50:00',1.78),('8998','2013-11-16','10:55:00',1.77),('8998','2013-11-16','11:00:00',1.76),('8998','2013-11-16','11:05:00',1.75),('8998','2013-11-16','11:10:00',1.74),('8998','2013-11-16','11:15:00',1.73),('8998','2013-11-16','11:20:00',1.71),('8998','2013-11-16','11:25:00',1.69),('8998','2013-11-16','11:30:00',1.67),('8998','2013-11-16','11:35:00',1.66),('8998','2013-11-16','11:40:00',1.65),('8998','2013-11-16','11:45:00',1.63),('8998','2013-11-16','11:50:00',1.61),('8998','2013-11-16','11:55:00',1.58),('8998','2013-11-16','12:00:00',1.53),('8998','2013-11-16','12:05:00',1.52),('8998','2013-11-16','12:10:00',1.5),('8998','2013-11-16','12:15:00',1.47),('8998','2013-11-16','12:20:00',1.45),('8998','2013-11-16','12:25:00',1.41),('8998','2013-11-16','12:30:00',1.39),('8998','2013-11-16','12:35:00',1.36),('8998','2013-11-16','12:40:00',1.33),('8998','2013-11-16','12:45:00',1.29),('8998','2013-11-16','12:50:00',1.24),('8998','2013-11-16','12:55:00',1.19),('8998','2013-11-16','13:00:00',1.12),('8998','2013-11-14','10:55:00',1.33),('8998','2013-11-14','11:00:00',1.04),('8998','2013-11-14','11:20:00',1.12),('8998','2013-11-14','11:25:00',1.74),('8998','2013-11-14','11:30:00',1.1),('8998','2013-11-14','11:35:00',1.11),('8998','2013-11-14','11:40:00',1.28),('8998','2013-11-14','11:45:00',1.09),('8998','2013-11-14','12:25:00',1.12),('8998','2013-11-14','12:30:00',1.01),('8998','2013-11-13','08:25:00',1.22),('8998','2013-11-13','08:30:00',1.09),('8998','2013-11-13','08:35:00',1.21),('8998','2013-11-13','09:05:00',1.1),('8998','2013-11-13','09:10:00',1.01),('8998','2013-11-13','09:15:00',1.23),('8998','2013-11-13','09:20:00',1.69),('8998','2013-11-13','09:25:00',1.67),('8998','2013-11-13','09:30:00',1.68),('8998','2013-11-13','09:35:00',1.69),('8998','2013-11-13','09:40:00',1.7),('8998','2013-11-13','09:45:00',1.65),('8998','2013-11-13','09:50:00',1.33),('8998','2013-11-13','10:05:00',1.35),('8998','2013-11-13','10:15:00',1.81),('8998','2013-11-13','10:20:00',1.83),('8998','2013-11-13','10:25:00',1.79),('8998','2013-11-13','10:30:00',1.77),('8998','2013-11-13','10:35:00',1.76),('8998','2013-11-13','10:40:00',1.76),('8998','2013-11-13','10:45:00',1.77),('8998','2013-11-13','10:50:00',1.76),('8998','2013-11-13','10:55:00',1.72),('8998','2013-11-13','11:00:00',1.72),('8998','2013-11-13','11:05:00',1.76),('8998','2013-11-13','11:10:00',1.79),('8998','2013-11-13','11:15:00',1.81),('8998','2013-11-13','11:20:00',1.8),('8998','2013-11-13','11:25:00',1.81),('8998','2013-11-13','11:30:00',1.79),('8998','2013-11-13','11:35:00',1.72),('8998','2013-11-13','11:40:00',1.45),('8998','2013-11-13','11:50:00',1),('8998','2013-11-13','11:55:00',1.36),('8998','2013-11-13','12:00:00',1.22),('8998','2013-11-13','12:15:00',1.06),('8998','2013-11-12','10:20:00',1.06),('8998','2013-11-12','10:30:00',1.24),('8998','2013-11-12','10:35:00',2.33),('8998','2013-11-12','10:40:00',2.09),('8998','2013-11-12','10:45:00',1.92),('8998','2013-11-12','10:50:00',2.49),('8998','2013-11-12','10:55:00',2.37),('8998','2013-11-12','11:00:00',2.26),('8998','2013-11-11','11:40:00',1.73),('8998','2013-11-11','12:00:00',1.82),('8998','2013-11-11','12:30:00',2.14),('8998','2013-11-11','12:35:00',1.79),('8998','2013-11-11','12:40:00',1.31),('8998','2013-11-11','12:45:00',1.25),('8998','2013-11-11','12:50:00',1.01),('8998','2013-11-11','12:55:00',1.25),('8998','2013-11-11','13:00:00',1.26),('8998','2013-11-11','13:05:00',1.31),('8998','2013-11-11','13:10:00',1.43),('8998','2013-11-11','13:15:00',1.85),('8998','2013-11-11','13:20:00',1.56),('8998','2013-11-11','13:25:00',1.37),('8998','2013-11-11','13:30:00',1.2),('8998','2013-11-11','13:35:00',1.33),('8998','2013-11-11','13:40:00',1.66),('8998','2013-11-11','13:45:00',1.04),('8998','2013-11-10','10:15:00',1.52),('8998','2013-11-10','10:20:00',2.32),('8998','2013-11-10','10:25:00',1.17),('8998','2013-11-10','11:10:00',1.58),('8998','2013-11-10','11:15:00',1.39),('8998','2013-11-10','11:20:00',1.1),('8998','2013-11-10','11:25:00',2.11),('8998','2013-11-10','11:35:00',1.79),('8998','2013-11-10','11:40:00',2.33),('8998','2013-11-10','11:45:00',2.26),('8998','2013-11-10','11:50:00',2.23),('8998','2013-11-10','11:55:00',1.99),('8998','2013-11-10','12:00:00',1.85),('8998','2013-11-10','12:05:00',1.8),('8998','2013-11-10','12:10:00',1.76),('8998','2013-11-10','12:15:00',1.73),('8998','2013-11-10','12:20:00',1.61),('8998','2013-11-10','12:25:00',1.33),('8998','2013-11-10','12:30:00',1.66),('8998','2013-11-10','12:40:00',1.17),('8998','2013-11-10','13:10:00',1.3),('8998','2013-11-09','08:40:00',1.23),('8998','2013-11-09','08:45:00',1.12),('8998','2013-11-09','08:50:00',1.33),('8998','2013-11-09','08:55:00',1.61),('8998','2013-11-09','09:00:00',1.2),('8998','2013-11-09','09:05:00',1),('8998','2013-11-09','09:15:00',1.26),('8998','2013-11-09','09:20:00',1.63),('8998','2013-11-09','09:25:00',1.78),('8998','2013-11-09','09:30:00',1.58),('8998','2013-11-09','09:35:00',1.55),('8998','2013-11-09','09:40:00',1.61),('8998','2013-11-09','09:45:00',1.75),('8998','2013-11-09','09:50:00',1.81),('8998','2013-11-09','09:55:00',1.86),('8998','2013-11-09','10:00:00',1.79),('8998','2013-11-09','10:05:00',1.97),('8998','2013-11-09','10:10:00',2.01),('8998','2013-11-09','10:15:00',1.99),('8998','2013-11-09','10:20:00',1.82),('8998','2013-11-09','10:25:00',2.02),('8998','2013-11-09','10:30:00',2.16),('8998','2013-11-09','10:35:00',1.97),('8998','2013-11-09','10:40:00',1.63),('8998','2013-11-09','10:45:00',1.55),('8998','2013-11-09','10:50:00',1.75),('8998','2013-11-09','10:55:00',1.72),('8998','2013-11-09','11:00:00',1.65),('8998','2013-11-09','11:05:00',1.26),('8998','2013-11-09','11:45:00',1.21),('8998','2013-11-09','11:50:00',1.02),('8998','2013-11-09','12:10:00',1.05),('8998','2013-11-09','12:15:00',1.64),('8998','2013-11-09','12:20:00',1.66),('8998','2013-11-09','12:25:00',1.55),('8998','2013-11-09','12:30:00',1.19),('8998','2013-11-09','12:35:00',1.02),('8998','2013-11-09','12:40:00',1.56),('8998','2013-11-09','12:45:00',1.68),('8998','2013-11-09','12:50:00',1.77),('8998','2013-11-08','09:40:00',2.08),('8998','2013-11-08','09:45:00',1.41),('8998','2013-11-08','09:50:00',1.96),('8998','2013-11-08','09:55:00',2.24),('8998','2013-11-08','10:00:00',2.07),('8998','2013-11-08','10:05:00',1.86),('8998','2013-11-08','10:10:00',1.79),('8998','2013-11-08','10:15:00',1.69),('8998','2013-11-08','10:20:00',1.82),('8998','2013-11-08','10:25:00',1.95),('8998','2013-11-08','10:55:00',1.35),('8998','2013-11-08','11:00:00',1.64),('8998','2013-11-08','11:05:00',2.31),('8998','2013-11-08','11:10:00',1.99),('8998','2013-11-08','11:15:00',2.58),('8998','2013-11-08','11:20:00',1.86),('8998','2013-11-08','11:30:00',1.77),('8998','2013-11-08','11:35:00',1.71),('8998','2013-11-08','11:40:00',1.48),('8998','2013-11-08','11:45:00',1.37),('8998','2013-11-08','11:55:00',1.38),('8998','2013-11-08','12:00:00',1.57),('8998','2013-11-08','12:05:00',1.74),('8998','2013-11-08','12:10:00',1.26),('8998','2013-11-08','12:15:00',1.25),('8998','2013-11-08','12:25:00',1.01),('8998','2013-11-08','12:30:00',1.47),('8998','2013-11-08','12:35:00',1.81),('8998','2013-11-08','12:40:00',1.2),('8998','2013-11-08','12:50:00',1.5),('8998','2013-11-08','12:55:00',1.45),('8998','2013-11-08','13:00:00',1.75),('8998','2013-11-08','13:05:00',1.58),('8998','2013-11-08','13:10:00',1.61),('8998','2013-11-08','13:15:00',1.53),('8998','2013-11-08','13:20:00',1.01),('8998','2013-11-08','13:25:00',1.01),('8998','2013-11-08','13:30:00',1.17),('8998','2013-11-08','13:35:00',1.02),('8998','2013-11-07','09:10:00',1.07),('8998','2013-11-07','09:20:00',1.67),('8998','2013-11-07','09:25:00',1.7),('8998','2013-11-07','09:30:00',1.77),('8998','2013-11-07','09:35:00',1.84),('8998','2013-11-07','09:40:00',1.36),('8998','2013-11-07','09:50:00',1.51),('8998','2013-11-07','10:00:00',1.02),('8998','2013-11-07','10:05:00',1.3),('8998','2013-11-07','10:10:00',1.89),('8998','2013-11-07','10:50:00',1.62),('8998','2013-11-07','10:55:00',1.48),('8998','2013-11-07','11:25:00',1.84),('8998','2013-11-07','11:30:00',2.3),('8998','2013-11-07','11:35:00',2.22),('8998','2013-11-07','11:40:00',2.11),('8998','2013-11-07','11:45:00',2.05),('8998','2013-11-07','11:50:00',2.07),('8998','2013-11-07','11:55:00',1.88),('8998','2013-11-07','12:00:00',1.09),('8998','2013-11-07','12:05:00',1.72),('8998','2013-11-07','12:10:00',1.64),('8998','2013-11-07','12:15:00',1.38),('8998','2013-11-07','12:40:00',1.36),('8998','2013-11-07','12:50:00',1.41),('8998','2013-11-07','12:55:00',1.6),('8998','2013-11-07','13:00:00',1.55),('8998','2013-11-07','13:05:00',1.4),('8998','2013-11-07','13:10:00',1.36),('8998','2013-11-07','13:15:00',1.4),('8998','2013-11-07','13:20:00',1.02),('8998','2013-11-07','13:25:00',1.25),('8998','2014-04-17','08:05:00',1.59),('8998','2014-04-17','08:10:00',1.22),('8998','2014-04-17','08:40:00',1.32),('8998','2014-04-17','08:45:00',1.16),('8998','2014-04-17','09:05:00',2.03),('8998','2014-04-17','09:10:00',2.29),('8998','2014-04-17','09:15:00',2.12),('8998','2014-04-17','09:20:00',2.1),('8998','2014-04-17','09:25:00',1.71),('8998','2014-04-17','09:30:00',2.68),('8998','2014-04-17','09:35:00',1.42),('8998','2014-04-17','09:40:00',1.02),('8998','2014-04-17','09:45:00',1.56),('8998','2014-04-17','09:50:00',2.56),('8998','2014-04-17','09:55:00',2.38),('8998','2014-04-17','10:00:00',2.06),('8998','2014-04-17','10:05:00',1.27),('8998','2014-04-17','10:10:00',1.15),('8998','2014-04-17','10:15:00',1.32),('8998','2014-04-17','10:20:00',1.07),('8998','2014-04-17','10:25:00',1.11),('8998','2014-04-17','10:40:00',1.06),('8998','2014-04-17','10:45:00',2.1),('8998','2014-04-17','10:50:00',2.37),('8998','2014-04-17','10:55:00',2.33),('8998','2014-04-17','11:00:00',1.34),('8998','2014-04-17','11:05:00',1.18),('8998','2014-04-17','11:10:00',1.68),('8998','2014-04-17','11:15:00',1.99),('8998','2014-04-17','11:20:00',1.23),('8998','2014-04-17','11:30:00',1.23),('8998','2014-04-17','11:35:00',1.13),('8998','2014-04-17','11:40:00',1.2),('8998','2014-04-17','11:45:00',1.14),('8998','2014-04-17','11:50:00',1.34),('8998','2014-04-17','11:55:00',1.28),('8998','2014-04-17','12:00:00',1.26),('8998','2014-04-17','12:05:00',2.1),('8998','2014-04-17','12:10:00',2.41),('8998','2014-04-17','12:15:00',2.24),('8998','2014-04-17','12:20:00',2.85),('8998','2014-04-17','12:25:00',2.09),('8998','2014-04-17','12:30:00',3.2),('8998','2014-04-17','12:35:00',3),('8998','2014-04-17','12:40:00',3.1),('8998','2014-04-17','12:45:00',2.62),('8998','2014-04-17','12:50:00',2.55),('8998','2014-04-17','12:55:00',1.82),('8998','2014-04-17','13:00:00',3.12),('8998','2014-04-17','13:05:00',2.16),('8998','2014-04-17','13:10:00',1.84),('8998','2014-04-17','13:15:00',1.72),('8998','2014-04-17','13:20:00',1.52),('8998','2014-04-17','13:25:00',1.12),('8998','2014-04-17','13:30:00',1.03),('8998','2014-04-17','13:35:00',1.02),('8998','2014-04-17','13:55:00',1.51),('8998','2014-04-17','14:00:00',1.33),('8998','2014-04-17','14:05:00',1.06),('8998','2014-04-17','14:20:00',1.08),('8998','2014-04-17','14:25:00',1.36),('8998','2014-04-17','14:30:00',1.49),('8998','2014-04-17','14:35:00',1.62),('8998','2014-04-17','14:40:00',1.5),('8998','2014-04-17','14:45:00',1.74),('8998','2014-04-17','14:50:00',1.93),('8998','2014-04-17','14:55:00',1.35),('8998','2014-04-17','15:00:00',2.48),('8998','2014-04-17','15:05:00',1.43),('8998','2014-04-17','15:10:00',1.42),('8998','2014-04-17','15:15:00',1.54),('8998','2014-04-17','15:20:00',1.27),('8998','2014-04-17','15:25:00',1.34),('8998','2014-04-17','15:30:00',1.54),('8998','2014-04-17','15:35:00',1.99),('8998','2014-04-17','15:40:00',1.03),('8998','2014-04-17','15:45:00',1.31),('8998','2014-04-17','15:50:00',1.5),('8998','2014-04-17','15:55:00',1.41),('8998','2014-04-17','16:00:00',1.33),('8998','2014-04-17','16:05:00',1.08),('8998','2014-04-17','16:25:00',1.05),('8998','2014-04-17','16:30:00',1.12),('8998','2014-04-17','16:35:00',1.19),('8998','2014-04-17','16:40:00',1.07),('8998','2013-11-06','07:55:00',1.02),('8998','2013-11-06','08:00:00',1.08),('8998','2013-11-06','08:05:00',1.13),('8998','2013-11-06','08:15:00',1.29),('8998','2013-11-06','08:20:00',1.37),('8998','2013-11-06','08:25:00',1.41),('8998','2013-11-06','08:30:00',1.45),('8998','2013-11-06','08:35:00',1.48),('8998','2013-11-06','08:40:00',1.51),('8998','2013-11-06','08:45:00',1.54),('8998','2013-11-06','08:50:00',1.58),('8998','2013-11-06','08:55:00',1.61),('8998','2013-11-06','09:00:00',1.64),('8998','2013-11-06','09:05:00',1.67),('8998','2013-11-06','09:10:00',1.69),('8998','2013-11-06','09:15:00',1.72),('8998','2013-11-06','09:20:00',1.74),('8998','2013-11-06','09:25:00',1.77),('8998','2013-11-06','09:30:00',1.78),('8998','2013-11-06','09:35:00',1.8),('8998','2013-11-06','09:40:00',1.81),('8998','2013-11-06','09:45:00',1.83),('8998','2013-11-06','09:50:00',1.83),('8998','2013-11-06','09:55:00',1.84),('8998','2013-11-06','10:00:00',1.84),('8998','2013-11-06','10:05:00',1.82),('8998','2013-11-06','10:10:00',1.84),('8998','2013-11-06','10:15:00',1.84),('8998','2013-11-06','10:20:00',1.83),('8998','2013-11-06','10:25:00',1.84),('8998','2013-11-06','10:30:00',1.84),('8998','2013-11-06','10:35:00',1.84),('8998','2013-11-06','10:40:00',1.82),('8998','2013-11-06','10:45:00',1.81),('8998','2013-11-06','10:50:00',1.81),('8998','2013-11-06','10:55:00',1.79),('8998','2013-11-06','11:00:00',1.8),('8998','2013-11-06','11:05:00',1.78),('8998','2013-11-06','11:10:00',1.77),('8998','2013-11-06','11:15:00',1.76),('8998','2013-11-06','11:20:00',1.73),('8998','2013-11-06','11:25:00',1.71),('8998','2013-11-06','11:30:00',1.66),('8998','2013-11-06','11:35:00',1.62),('8998','2013-11-06','11:40:00',1.63),('8998','2013-11-06','11:45:00',1.65),('8998','2013-11-06','11:50:00',1.6),('8998','2013-11-06','11:55:00',1.57),('8998','2013-11-06','12:00:00',1.55),('8998','2013-11-06','12:05:00',1.54),('8998','2013-11-06','12:10:00',1.48),('8998','2013-11-06','12:15:00',1.47),('8998','2013-11-06','12:20:00',1.45),('8998','2013-11-06','12:25:00',1.42),('8998','2013-11-06','12:30:00',1.37),('8998','2013-11-06','12:35:00',1.37),('8998','2013-11-06','12:40:00',1.32),('8998','2013-11-06','12:45:00',1.28),('8998','2013-11-06','12:50:00',1.25),('8998','2013-11-06','12:55:00',1.28),('8998','2013-11-06','13:00:00',1.31),('8998','2013-11-06','13:05:00',1.37),('8998','2013-11-06','13:40:00',1.1),('8998','2013-11-05','08:10:00',1.26),('8998','2013-11-05','08:15:00',1.48),('8998','2013-11-05','08:20:00',1.32),('8998','2013-11-05','08:35:00',1.59),('8998','2013-11-05','08:40:00',1.6),('8998','2013-11-05','08:45:00',1.65),('8998','2013-11-05','08:50:00',1.75),('8998','2013-11-05','08:55:00',1.6),('8998','2013-11-05','09:00:00',1.13),('8998','2013-11-05','09:05:00',1.21),('8998','2013-11-05','09:10:00',1.05),('8998','2013-11-05','09:15:00',1.45),('8998','2013-11-05','09:20:00',1.73),('8998','2013-11-05','09:25:00',1.75),('8998','2013-11-05','09:30:00',1.86),('8998','2013-11-05','09:35:00',1.86),('8998','2013-11-05','09:40:00',1.88),('8998','2013-11-05','09:45:00',1.88),('8998','2013-11-05','09:50:00',1.88),('8998','2013-11-05','09:55:00',1.89),('8998','2013-11-05','10:00:00',1.92),('8998','2013-11-05','10:05:00',1.92),('8998','2013-11-05','10:10:00',1.93),('8998','2013-11-05','10:15:00',1.92),('8998','2013-11-05','10:20:00',1.94),('8998','2013-11-05','10:25:00',1.96),('8998','2013-11-05','10:30:00',1.96),('8998','2013-11-05','10:35:00',1.96),('8998','2013-11-05','10:40:00',1.95),('8998','2013-11-05','10:45:00',1.94),('8998','2013-11-05','10:50:00',1.94),('8998','2013-11-05','10:55:00',1.93),('8998','2013-11-05','11:00:00',1.92),('8998','2013-11-05','11:05:00',1.92),('8998','2013-11-05','11:10:00',1.89),('8998','2013-11-05','11:15:00',1.88),('8998','2013-11-05','11:20:00',1.87),('8998','2013-11-05','11:25:00',1.86),('8998','2013-11-05','11:30:00',1.84),('8998','2013-11-05','11:35:00',1.81),('8998','2013-11-05','11:40:00',1.8),('8998','2013-11-05','11:45:00',1.78),('8998','2013-11-05','11:50:00',1.77),('8998','2013-11-05','11:55:00',1.74),('8998','2013-11-05','12:00:00',1.71),('8998','2013-11-05','12:05:00',1.7),('8998','2013-11-05','12:10:00',1.66),('8998','2013-11-05','12:15:00',1.64),('8998','2013-11-05','12:20:00',1.61),('8998','2013-11-05','12:25:00',1.58),('8998','2013-11-05','12:30:00',1.54),('8998','2013-11-05','12:35:00',1.51),('8998','2013-11-05','12:40:00',1.47),('8998','2013-11-05','12:45:00',1.44),('8998','2013-11-05','12:50:00',1.4),('8998','2013-11-05','12:55:00',1.36),('8998','2013-11-05','13:00:00',1.32),('8998','2013-11-05','13:05:00',1.28),('8998','2013-11-05','13:10:00',1.24),('8998','2013-11-05','13:15:00',1.14),('8998','2013-11-05','13:20:00',1.08),('8998','2013-11-04','08:25:00',1.1),('8998','2013-11-04','08:30:00',1.4),('8998','2013-11-04','08:35:00',1.58),('8998','2013-11-04','08:40:00',1.62),('8998','2013-11-04','10:20:00',1.06),('8998','2013-11-04','10:25:00',1.52),('8998','2013-11-04','10:30:00',1.3),('8998','2013-11-04','10:35:00',1.48),('8998','2013-11-04','10:40:00',1.41),('8998','2013-11-04','10:45:00',1.39),('8998','2013-11-04','10:50:00',1.2),('8998','2013-11-04','10:55:00',1.07),('8998','2013-11-04','11:45:00',1.04),('8998','2013-11-04','12:20:00',1.09),('8998','2013-11-04','12:25:00',1.16),('8998','2013-11-04','13:35:00',1.1),('8998','2013-11-04','13:40:00',1.23),('8998','2013-11-04','13:45:00',1.09),('8998','2013-11-03','08:00:00',1.06),('8998','2013-11-03','08:10:00',1.16),('8998','2013-11-03','08:15:00',1.27),('8998','2013-11-03','08:20:00',1.37),('8998','2013-11-03','08:25:00',1.23),('8998','2013-11-03','08:30:00',1.1),('8998','2013-11-03','09:10:00',1.73),('8998','2013-11-03','09:15:00',1.94),('8998','2013-11-03','09:20:00',2),('8998','2013-11-03','09:25:00',2.29),('8998','2013-11-03','09:30:00',1.37),('8998','2013-11-03','10:05:00',1.77),('8998','2013-11-03','10:10:00',2.02),('8998','2013-11-03','10:15:00',2.02),('8998','2013-11-03','10:20:00',2.03),('8998','2013-11-03','10:25:00',2.21),('8998','2013-11-03','10:30:00',2.1),('8998','2013-11-03','10:35:00',1.45),('8998','2013-11-03','10:40:00',2.24),('8998','2013-11-03','10:45:00',1.46),('8998','2013-11-03','10:50:00',1.2),('8998','2013-11-03','11:00:00',1.34),('8998','2013-11-03','11:05:00',2.47),('8998','2013-11-03','11:10:00',1.23),('8998','2013-11-03','11:15:00',1.96),('8998','2013-11-03','11:20:00',1.22),('8998','2013-11-03','11:30:00',1.5),('8998','2013-11-03','11:35:00',1.87),('8998','2013-11-03','11:40:00',1.26),('8998','2013-11-03','11:45:00',1.51),('8998','2013-11-03','11:50:00',2.4),('8998','2013-11-03','11:55:00',2.08),('8998','2013-11-03','12:00:00',1.7),('8998','2013-11-03','12:05:00',1.74),('8998','2013-11-03','12:10:00',1.66),('8998','2013-11-03','12:15:00',1.38),('8998','2013-11-03','12:20:00',1.76),('8998','2013-11-03','12:25:00',1.7),('8998','2013-11-03','12:30:00',1.64),('8998','2013-11-03','12:35:00',1.65),('8998','2013-11-03','12:40:00',1.38),('8998','2013-11-03','12:45:00',1.37),('8998','2013-11-03','12:50:00',1.34),('8998','2013-11-03','12:55:00',1.42),('8998','2013-11-03','13:00:00',1.36),('8998','2013-11-03','13:05:00',1.34),('8998','2013-11-03','13:10:00',1.23),('8998','2013-11-03','13:15:00',1.15),('8998','2013-11-03','13:20:00',1.05),('8998','2013-11-03','13:25:00',1.07),('8998','2013-11-03','13:30:00',1.01),('8998','2013-11-02','08:40:00',1.22),('8998','2013-11-02','08:55:00',1.04),('8998','2013-11-02','09:40:00',1.81),('8998','2013-11-02','09:45:00',1.48),('8998','2013-11-02','10:10:00',1.6),('8998','2013-11-02','10:20:00',1.42),('8998','2013-11-02','10:25:00',1.73),('8998','2013-11-02','10:30:00',1.06),('8998','2013-11-02','11:25:00',1.39),('8998','2013-11-02','11:30:00',1.11),('8998','2013-11-02','11:35:00',1.75),('8998','2013-11-02','11:40:00',1.94),('8998','2013-11-02','11:45:00',1.51),('8998','2013-11-02','11:50:00',2.1),('8998','2013-11-02','11:55:00',2.03),('8998','2013-11-02','12:00:00',1.14),('8998','2013-11-02','12:05:00',1.58),('8998','2013-11-02','12:10:00',1.91),('8998','2013-11-02','14:05:00',1.02),('8998','2013-11-01','08:15:00',1.23),('8998','2013-11-01','08:20:00',1.28),('8998','2013-11-01','08:25:00',1.31),('8998','2013-11-01','08:30:00',1.37),('8998','2013-11-01','08:35:00',1.42),('8998','2013-11-01','08:40:00',1.46),('8998','2013-11-01','08:45:00',1.5),('8998','2013-11-01','08:50:00',1.53),('8998','2013-11-01','08:55:00',1.56),('8998','2013-11-01','09:00:00',1.6),('8998','2013-11-01','09:05:00',1.68),('8998','2013-11-01','09:10:00',1.75),('8998','2013-11-01','09:20:00',1.45),('8998','2013-11-01','09:25:00',1.86),('8998','2013-11-01','09:30:00',1.77),('8998','2013-11-01','09:35:00',1.79),('8998','2013-11-01','09:40:00',1.75),('8998','2013-11-01','09:45:00',1.34),('8998','2013-11-01','09:50:00',1.97),('8998','2013-11-01','09:55:00',1.97),('8998','2013-11-01','10:00:00',2.08),('8998','2013-11-01','10:05:00',2.31),('8998','2013-11-01','10:10:00',1.26),('8998','2013-11-01','11:55:00',1.01),('8998','2013-11-01','12:00:00',2.06),('8998','2013-11-01','12:05:00',2.18),('8998','2013-11-01','12:10:00',1.93),('8998','2013-11-01','12:15:00',2.19),('8998','2013-11-01','12:20:00',2.02),('8998','2013-11-01','12:25:00',2.04),('8998','2013-11-01','12:30:00',2.21),('8998','2013-11-01','12:35:00',2.08),('8998','2013-11-01','12:40:00',1.71),('8998','2013-11-01','12:45:00',1.44),('8998','2013-11-01','12:50:00',1.41),('8998','2013-11-01','12:55:00',1.79),('8998','2013-11-01','13:00:00',1.53),('8998','2013-11-01','13:05:00',1.72),('8998','2013-11-01','13:10:00',1.77),('8998','2013-11-01','13:15:00',1.21),('8998','2013-11-01','13:40:00',1.35),('8998','2013-11-01','13:45:00',1.14),('8998','2013-11-01','13:50:00',1.31),('8998','2013-11-01','13:55:00',1.21),('8998','2013-11-01','14:00:00',1.04),('8998','2013-10-31','08:20:00',1.07),('8998','2013-10-31','08:25:00',1.11),('8998','2013-10-31','08:30:00',1.29),('8998','2013-10-31','08:35:00',1.36),('8998','2013-10-31','08:40:00',1.46),('8998','2013-10-31','08:45:00',1.49),('8998','2013-10-31','08:50:00',1.4),('8998','2013-10-31','08:55:00',1.45),('8998','2013-10-31','09:00:00',1.5),('8998','2013-10-31','09:05:00',1.64),('8998','2013-10-31','09:10:00',1.68),('8998','2013-10-31','09:15:00',1.68),('8998','2013-10-31','09:20:00',1.72),('8998','2013-10-31','09:25:00',1.75),('8998','2013-10-31','09:30:00',1.76),('8998','2013-10-31','09:35:00',1.78),('8998','2013-10-31','09:40:00',1.81),('8998','2013-10-31','09:45:00',1.84),('8998','2013-10-31','09:50:00',1.86),('8998','2013-10-31','09:55:00',1.87),('8998','2013-10-31','10:00:00',1.88),('8998','2013-10-31','10:05:00',1.89),('8998','2013-10-31','10:10:00',1.9),('8998','2013-10-31','10:15:00',1.91),('8998','2013-10-31','10:20:00',1.92),('8998','2013-10-31','10:25:00',1.93),('8998','2013-10-31','10:30:00',1.88),('8998','2013-10-31','10:35:00',1.86),('8998','2013-10-31','10:40:00',1.89),('8998','2013-10-31','10:45:00',1.84),('8998','2013-10-31','10:50:00',1.83),('8998','2013-10-31','10:55:00',1.78),('8998','2013-10-31','11:00:00',1.83),('8998','2013-10-31','11:05:00',1.74),('8998','2013-10-31','11:10:00',1.5),('8998','2013-10-31','11:15:00',1.48),('8998','2013-10-31','11:20:00',1.78),('8998','2013-10-31','11:25:00',1.91),('8998','2013-10-31','11:30:00',1.9),('8998','2013-10-31','11:35:00',1.83),('8998','2013-10-31','11:40:00',1.69),('8998','2013-10-31','11:45:00',1.54),('8998','2013-10-31','11:50:00',1.77),('8998','2013-10-31','11:55:00',1.82),('8998','2013-10-31','12:00:00',1.8),('8998','2013-10-31','12:05:00',1.75),('8998','2013-10-31','12:10:00',1.62),('8998','2013-10-31','12:15:00',1.58),('8998','2013-10-31','12:20:00',1.25),('8998','2013-10-31','12:30:00',1.11),('8998','2013-10-31','12:35:00',1.33),('8998','2013-10-30','08:30:00',1.21),('8998','2013-10-30','08:35:00',1.34),('8998','2013-10-30','08:40:00',1.54),('8998','2013-10-30','08:45:00',1.52),('8998','2013-10-30','08:50:00',1.53),('8998','2013-10-30','09:00:00',1.53),('8998','2013-10-30','09:05:00',1.41),('8998','2013-10-30','09:20:00',1.02),('8998','2013-10-30','09:35:00',1.52),('8998','2013-10-30','09:40:00',1.37),('8998','2013-10-30','09:45:00',1.48),('8998','2013-10-30','09:50:00',1.52),('8998','2013-10-30','09:55:00',1.46),('8998','2013-10-30','10:00:00',1.45),('8998','2013-10-30','10:05:00',1.25),('8998','2013-10-30','10:10:00',1.09),('8998','2013-10-30','10:15:00',1.01),('8998','2013-10-30','10:20:00',1.17),('8998','2013-10-30','10:25:00',1.27),('8998','2013-10-30','10:30:00',1.21),('8998','2013-10-30','10:35:00',1.24),('8998','2013-10-30','10:40:00',1.29),('8998','2013-10-30','10:45:00',1.24),('8998','2013-10-30','10:50:00',1.25),('8998','2013-10-30','10:55:00',1.42),('8998','2013-10-30','11:00:00',1.76),('8998','2013-10-30','11:05:00',1.9),('8998','2013-10-30','11:10:00',1.83),('8998','2013-10-30','11:15:00',1.35),('8998','2013-10-30','11:20:00',1.8),('8998','2013-10-30','11:25:00',1.59),('8998','2013-10-30','11:30:00',1.63),('8998','2013-10-30','11:35:00',1.57),('8998','2013-10-30','11:40:00',1.65),('8998','2013-10-30','11:45:00',1.77),('8998','2013-10-30','11:50:00',1.76),('8998','2013-10-30','11:55:00',1.76),('8998','2013-10-30','12:00:00',1.7),('8998','2013-10-30','12:05:00',1.64),('8998','2013-10-30','12:10:00',1.59),('8998','2013-10-30','12:15:00',1.62),('8998','2013-10-30','12:20:00',1.57),('8998','2013-10-30','12:25:00',1.57),('8998','2013-10-30','12:30:00',1.51),('8998','2013-10-30','12:35:00',1.46),('8998','2013-10-30','12:40:00',1.48),('8998','2013-10-30','12:45:00',1.49),('8998','2013-10-30','12:50:00',1.48),('8998','2013-10-30','12:55:00',1.48),('8998','2013-10-30','13:00:00',1.43),('8998','2013-10-30','13:05:00',1.37),('8998','2013-10-30','13:10:00',1.32),('8998','2013-10-30','13:15:00',1.28),('8998','2013-10-30','13:20:00',1.21),('8998','2013-10-30','13:25:00',1.13),('8998','2013-10-29','08:10:00',1.03),('8998','2013-10-29','08:15:00',1.09),('8998','2013-10-29','08:20:00',1.13),('8998','2013-10-29','08:25:00',1.18),('8998','2013-10-29','08:30:00',1.22),('8998','2013-10-29','08:35:00',1.28),('8998','2013-10-29','08:40:00',1.35),('8998','2013-10-29','08:45:00',1.42),('8998','2013-10-29','08:50:00',1.42),('8998','2013-10-29','08:55:00',1.4),('8998','2013-10-29','09:00:00',1.47),('8998','2013-10-29','09:05:00',1.55),('8998','2013-10-29','09:10:00',1.63),('8998','2013-10-29','09:15:00',1.66),('8998','2013-10-29','09:20:00',1.67),('8998','2013-10-29','09:25:00',1.69),('8998','2013-10-29','09:30:00',1.73),('8998','2013-10-29','09:35:00',1.77),('8998','2013-10-29','09:40:00',1.74),('8998','2013-10-29','09:45:00',1.78),('8998','2013-10-29','09:50:00',1.73),('8998','2013-10-29','09:55:00',1.75),('8998','2013-10-29','10:00:00',1.61),('8998','2013-10-29','10:05:00',1.66),('8998','2013-10-29','10:10:00',1.69),('8998','2013-10-29','10:15:00',1.81),('8998','2013-10-29','10:20:00',1.8),('8998','2013-10-29','10:25:00',1.72),('8998','2013-10-29','10:30:00',1.62),('8998','2013-10-29','10:35:00',1.68),('8998','2013-10-29','10:40:00',1.7),('8998','2013-10-29','10:45:00',1.67),('8998','2013-10-29','10:50:00',1.63),('8998','2013-10-29','11:00:00',1.35),('8998','2013-10-29','11:05:00',1.47),('8998','2013-10-29','11:10:00',1.87),('8998','2013-10-29','11:15:00',1.85),('8998','2013-10-29','11:20:00',1.61),('8998','2013-10-29','11:50:00',1.51),('8998','2013-10-29','11:55:00',1.04),('8998','2013-10-29','12:30:00',1.45),('8998','2013-10-29','12:45:00',1.13),('8998','2013-10-29','12:55:00',1.27),('8998','2013-10-29','13:00:00',1.21),('8998','2013-10-28','08:40:00',1.17),('8998','2013-10-28','08:45:00',1.2),('8998','2013-10-28','08:50:00',1.6),('8998','2013-10-28','08:55:00',1.61),('8998','2013-10-28','09:00:00',1.65),('8998','2013-10-28','09:05:00',1.69),('8998','2013-10-28','09:10:00',1.7),('8998','2013-10-28','09:15:00',1.7),('8998','2013-10-28','09:20:00',1.76),('8998','2013-10-28','09:25:00',1.78),('8998','2013-10-28','09:30:00',1.8),('8998','2013-10-28','09:35:00',1.81),('8998','2013-10-28','09:40:00',1.83),('8998','2013-10-28','09:45:00',1.82),('8998','2013-10-28','09:50:00',1.49),('8998','2013-10-28','09:55:00',1.76),('8998','2013-10-28','10:00:00',1.77),('8998','2013-10-28','10:05:00',2.01),('8998','2013-10-28','10:10:00',1.98),('8998','2013-10-28','10:15:00',1.71),('8998','2013-10-28','10:20:00',1.69),('8998','2013-10-28','10:25:00',2.04),('8998','2013-10-28','10:30:00',2.19),('8998','2013-10-28','10:35:00',2.06),('8998','2013-10-28','10:40:00',2.08),('8998','2013-10-28','10:45:00',2.06),('8998','2013-10-28','10:50:00',2.12),('8998','2013-10-28','10:55:00',1.93),('8998','2013-10-28','11:00:00',1.29),('8998','2013-10-28','11:05:00',1.36),('8998','2013-10-28','11:10:00',1.02),('8998','2013-10-28','11:15:00',1.9),('8998','2013-10-28','11:20:00',1.87),('8998','2013-10-28','11:25:00',1.81),('8998','2013-10-28','11:30:00',1.95),('8998','2013-10-28','11:35:00',1.92),('8998','2013-10-28','11:40:00',1.88),('8998','2013-10-28','11:45:00',1.76),('8998','2013-10-28','11:50:00',1.73),('8998','2013-10-28','11:55:00',1.69),('8998','2013-10-28','12:00:00',1.62),('8998','2013-10-28','12:05:00',1.69),('8998','2013-10-28','12:10:00',1.63),('8998','2013-10-28','12:15:00',1.6),('8998','2013-10-28','12:20:00',1.59),('8998','2013-10-28','12:25:00',1.57),('8998','2013-10-28','12:30:00',1.53),('8998','2013-10-28','12:35:00',1.46),('8998','2013-10-28','12:40:00',1.48),('8998','2013-10-28','12:45:00',1.48),('8998','2013-10-28','12:50:00',1.44),('8998','2013-10-28','12:55:00',1.38),('8998','2013-10-28','13:00:00',1.31),('8998','2013-10-28','13:05:00',1.25),('8998','2013-10-28','13:10:00',1.25),('8998','2013-10-28','13:15:00',1.22),('8998','2013-10-28','13:20:00',1.16),('8998','2013-10-28','13:25:00',1.06),('8998','2013-10-28','13:30:00',1),('8998','2014-04-16','08:00:00',1.22),('8998','2014-04-16','08:05:00',1.29),('8998','2014-04-16','08:10:00',1.32),('8998','2014-04-16','08:15:00',1.53),('8998','2014-04-16','08:20:00',1.42),('8998','2014-04-16','08:25:00',1.56),('8998','2014-04-16','08:30:00',1.46),('8998','2014-04-16','08:35:00',1.48),('8998','2014-04-16','08:40:00',1.5),('8998','2014-04-16','08:45:00',1.55),('8998','2014-04-16','08:50:00',1.6),('8998','2014-04-16','08:55:00',1.42),('8998','2014-04-16','09:00:00',1.47),('8998','2014-04-16','09:05:00',1.57),('8998','2014-04-16','09:10:00',1.68),('8998','2014-04-16','09:15:00',1.8),('8998','2014-04-16','09:20:00',2),('8998','2014-04-16','09:25:00',2.34),('8998','2014-04-16','09:30:00',2.48),('8998','2014-04-16','09:35:00',2.56),('8998','2014-04-16','09:40:00',2.74),('8998','2014-04-16','09:45:00',2.8),('8998','2014-04-16','09:50:00',2.84),('8998','2014-04-16','09:55:00',2.91),('8998','2014-04-16','10:00:00',2.99),('8998','2014-04-16','10:05:00',3.18),('8998','2014-04-16','10:10:00',2.92),('8998','2014-04-16','10:15:00',2.51),('8998','2014-04-16','10:20:00',2.92),('8998','2014-04-16','10:25:00',3.29),('8998','2014-04-16','10:30:00',3.42),('8998','2014-04-16','10:35:00',3.53),('8998','2014-04-16','10:40:00',3.3),('8998','2014-04-16','10:45:00',2.64),('8998','2014-04-16','10:50:00',1.97),('8998','2014-04-16','10:55:00',1.97),('8998','2014-04-16','11:00:00',2),('8998','2014-04-16','11:05:00',2.95),('8998','2014-04-16','11:10:00',2.49),('8998','2014-04-16','11:15:00',2.35),('8998','2014-04-16','11:20:00',2.5),('8998','2014-04-16','11:25:00',2.72),('8998','2014-04-16','11:30:00',1.83),('8998','2014-04-16','11:35:00',2.15),('8998','2014-04-16','11:40:00',2.13),('8998','2014-04-16','11:45:00',2.43),('8998','2014-04-16','11:50:00',1.81),('8998','2014-04-16','11:55:00',1.45),('8998','2014-04-16','12:00:00',1.59),('8998','2014-04-16','12:05:00',2.06),('8998','2014-04-16','12:10:00',2.08),('8998','2014-04-16','12:15:00',1.78),('8998','2014-04-16','12:20:00',1.73),('8998','2014-04-16','12:25:00',1.88),('8998','2014-04-16','12:30:00',2.17),('8998','2014-04-16','12:35:00',2.78),('8998','2014-04-16','12:40:00',3.08),('8998','2014-04-16','12:45:00',2.95),('8998','2014-04-16','12:50:00',3.01),('8998','2014-04-16','12:55:00',3.06),('8998','2014-04-16','13:00:00',2.71),('8998','2014-04-16','13:05:00',1.5),('8998','2014-04-16','13:10:00',1.08),('8998','2014-04-16','13:20:00',2.64),('8998','2014-04-16','13:25:00',3.37),('8998','2014-04-16','13:30:00',2.35),('8998','2014-04-16','14:10:00',1.72),('8998','2014-04-16','14:30:00',1.03),('8998','2014-04-16','14:35:00',1.24),('8998','2014-04-16','14:40:00',2.18),('8998','2014-04-16','15:30:00',1.15),('8998','2014-04-16','15:35:00',1.31),('8998','2013-10-27','08:50:00',1.03),('8998','2013-10-27','08:55:00',1.56),('8998','2013-10-27','09:00:00',1.7),('8998','2013-10-27','09:05:00',1.84),('8998','2013-10-27','09:10:00',1.93),('8998','2013-10-27','09:15:00',1.53),('8998','2013-10-27','09:20:00',1.17),('8998','2013-10-27','09:25:00',1.85),('8998','2013-10-27','09:30:00',2.04),('8998','2013-10-27','09:35:00',1.62),('8998','2013-10-27','09:40:00',1.08),('8998','2013-10-27','09:45:00',1.06),('8998','2013-10-27','09:50:00',1.68),('8998','2013-10-27','09:55:00',1.29),('8998','2013-10-27','10:50:00',2.02),('8998','2013-10-27','10:55:00',1.99),('8998','2013-10-27','11:00:00',1.99),('8998','2013-10-27','11:05:00',1.97),('8998','2013-10-27','11:10:00',1.96),('8998','2013-10-27','11:15:00',1.96),('8998','2013-10-27','11:20:00',1.94),('8998','2013-10-27','11:25:00',1.92),('8998','2013-10-27','11:30:00',1.88),('8998','2013-10-27','11:35:00',1.88),('8998','2013-10-27','11:40:00',1.8),('8998','2013-10-27','11:45:00',1.81),('8998','2013-10-27','11:50:00',1.81),('8998','2013-10-27','11:55:00',1.7),('8998','2013-10-27','12:00:00',1.58),('8998','2013-10-27','12:05:00',1.68),('8998','2013-10-27','12:10:00',1.26),('8998','2013-10-27','12:15:00',1.83),('8998','2013-10-27','12:20:00',1.85),('8998','2013-10-27','12:25:00',1.84),('8998','2013-10-27','12:30:00',1.66),('8998','2013-10-27','12:35:00',1.89),('8998','2013-10-27','12:40:00',1.81),('8998','2013-10-27','12:45:00',1.72),('8998','2013-10-27','12:50:00',1.72),('8998','2013-10-27','12:55:00',1.63),('8998','2013-10-27','13:00:00',1.47),('8998','2013-10-27','13:05:00',1.4),('8998','2013-10-27','13:10:00',1.38),('8998','2013-10-27','13:15:00',1.32),('8998','2013-10-27','13:20:00',1.24),('8998','2013-10-27','13:25:00',1.18),('8998','2013-10-27','13:30:00',1.09),('8998','2013-10-27','13:35:00',1.02),('8998','2013-10-26','10:50:00',1),('8998','2013-10-26','11:40:00',1.57),('8998','2013-10-26','11:45:00',1.84),('8998','2013-10-26','11:50:00',1.48),('8998','2013-10-26','12:20:00',1.43),('8998','2013-10-26','12:25:00',1.73),('8998','2013-10-26','12:30:00',1.51),('8998','2013-10-26','12:35:00',1.69),('8998','2013-10-26','12:40:00',1.39),('8998','2013-10-26','12:50:00',1),('8998','2013-10-26','13:00:00',1.24),('8998','2013-10-26','13:10:00',1.2),('8998','2013-10-26','13:30:00',1.22),('8998','2013-10-26','13:35:00',1),('8998','2013-10-26','13:40:00',1.13),('8998','2013-10-25','09:05:00',1.17),('8998','2013-10-25','09:10:00',1.24),('8998','2013-10-25','09:15:00',1.31),('8998','2013-10-25','09:20:00',1.36),('8998','2013-10-25','09:25:00',1.4),('8998','2013-10-25','09:30:00',1.44),('8998','2013-10-25','09:35:00',1.49),('8998','2013-10-25','09:40:00',1.53),('8998','2013-10-25','09:45:00',1.57),('8998','2013-10-25','09:50:00',1.61),('8998','2013-10-25','09:55:00',1.65),('8998','2013-10-25','10:00:00',1.68),('8998','2013-10-25','10:05:00',1.72),('8998','2013-10-25','10:10:00',1.74),('8998','2013-10-25','10:15:00',1.77),('8998','2013-10-25','10:20:00',1.79),('8998','2013-10-25','10:25:00',1.81),('8998','2013-10-25','10:30:00',1.83),('8998','2013-10-25','10:35:00',1.84),('8998','2013-10-25','10:40:00',1.87),('8998','2013-10-25','10:45:00',1.87),('8998','2013-10-25','10:50:00',1.9),('8998','2013-10-25','10:55:00',1.92),('8998','2013-10-25','11:00:00',1.94),('8998','2013-10-25','11:05:00',1.96),('8998','2013-10-25','11:10:00',1.95),('8998','2013-10-25','11:15:00',1.95),('8998','2013-10-25','11:20:00',1.96),('8998','2013-10-25','11:25:00',1.95),('8998','2013-10-25','11:30:00',1.97),('8998','2013-10-25','11:35:00',1.95),('8998','2013-10-25','11:40:00',1.96),('8998','2013-10-25','11:45:00',1.96),('8998','2013-10-25','11:50:00',1.96),('8998','2013-10-25','11:55:00',1.92),('8998','2013-10-25','12:00:00',1.93),('8998','2013-10-25','12:05:00',1.91),('8998','2013-10-25','12:10:00',1.9),('8998','2013-10-25','12:15:00',1.85),('8998','2013-10-25','12:20:00',1.89),('8998','2013-10-25','12:25:00',1.84),('8998','2013-10-25','12:30:00',1.87),('8998','2013-10-25','12:35:00',1.87),('8998','2013-10-25','12:40:00',1.81),('8998','2013-10-25','12:45:00',1.79),('8998','2013-10-25','12:50:00',1.77),('8998','2013-10-25','12:55:00',1.73),('8998','2013-10-25','13:00:00',1.74),('8998','2013-10-25','13:05:00',1.71),('8998','2013-10-25','13:10:00',1.66),('8998','2013-10-25','13:15:00',1.52),('8998','2013-10-25','13:20:00',1.48),('8998','2013-10-25','13:25:00',1.54),('8998','2013-10-25','13:30:00',1.45),('8998','2013-10-25','13:35:00',1.52),('8998','2013-10-25','13:40:00',1.57),('8998','2013-10-25','13:45:00',1.46),('8998','2013-10-25','13:50:00',1.3),('8998','2013-10-25','13:55:00',1.39),('8998','2013-10-25','14:00:00',1.36),('8998','2013-10-25','14:05:00',1.25),('8998','2013-10-25','14:10:00',1.25),('8998','2013-10-25','14:15:00',1.31),('8998','2013-10-25','14:20:00',1.17),('8998','2013-10-24','09:05:00',1.21),('8998','2013-10-24','09:10:00',1.26),('8998','2013-10-24','09:15:00',1.34),('8998','2013-10-24','09:20:00',1.39),('8998','2013-10-24','09:25:00',1.44),('8998','2013-10-24','09:30:00',1.48),('8998','2013-10-24','09:35:00',1.52),('8998','2013-10-24','09:40:00',1.56),('8998','2013-10-24','09:45:00',1.59),('8998','2013-10-24','09:50:00',1.63),('8998','2013-10-24','09:55:00',1.67),('8998','2013-10-24','10:00:00',1.71),('8998','2013-10-24','10:05:00',1.74),('8998','2013-10-24','10:10:00',1.77),('8998','2013-10-24','10:15:00',1.79),('8998','2013-10-24','10:20:00',1.81),('8998','2013-10-24','10:25:00',1.85),('8998','2013-10-24','10:30:00',1.88),('8998','2013-10-24','10:35:00',1.9),('8998','2013-10-24','10:40:00',1.91),('8998','2013-10-24','10:45:00',1.92),('8998','2013-10-24','10:50:00',1.95),('8998','2013-10-24','10:55:00',1.94),('8998','2013-10-24','11:00:00',1.96),('8998','2013-10-24','11:05:00',1.95),('8998','2013-10-24','11:10:00',1.96),('8998','2013-10-24','11:15:00',1.98),('8998','2013-10-24','11:20:00',1.98),('8998','2013-10-24','11:25:00',1.98),('8998','2013-10-24','11:30:00',1.97),('8998','2013-10-24','11:35:00',1.97),('8998','2013-10-24','11:40:00',1.97),('8998','2013-10-24','11:45:00',1.97),('8998','2013-10-24','11:50:00',1.99),('8998','2013-10-24','11:55:00',2),('8998','2013-10-24','12:00:00',1.99),('8998','2013-10-24','12:05:00',1.99),('8998','2013-10-24','12:10:00',1.97),('8998','2013-10-24','12:15:00',1.97),('8998','2013-10-24','12:20:00',1.96),('8998','2013-10-24','12:25:00',1.94),('8998','2013-10-24','12:30:00',1.93),('8998','2013-10-24','12:35:00',1.91),('8998','2013-10-24','12:40:00',1.89),('8998','2013-10-24','12:45:00',1.86),('8998','2013-10-24','12:50:00',1.82),('8998','2013-10-24','12:55:00',1.8),('8998','2013-10-24','13:00:00',1.81),('8998','2013-10-24','13:05:00',1.78),('8998','2013-10-24','13:10:00',1.75),('8998','2013-10-24','13:15:00',1.7),('8998','2013-10-24','13:20:00',1.67),('8998','2013-10-24','13:25:00',1.61),('8998','2013-10-24','13:30:00',1.58),('8998','2013-10-24','13:35:00',1.57),('8998','2013-10-24','13:40:00',1.56),('8998','2013-10-24','13:45:00',1.5),('8998','2013-10-24','13:50:00',1.48),('8998','2013-10-24','13:55:00',1.46),('8998','2013-10-24','14:00:00',1.41),('8998','2013-10-24','14:05:00',1.37),('8998','2013-10-24','14:10:00',1.34),('8998','2013-10-24','14:15:00',1.3),('8998','2013-10-24','14:20:00',1.26),('8998','2013-10-24','14:25:00',1.2),('8998','2013-10-24','14:30:00',1.07),('8998','2013-10-23','09:15:00',1.29),('8998','2013-10-23','09:20:00',1.31),('8998','2013-10-23','10:40:00',1.07),('8998','2013-10-23','10:45:00',1.9),('8998','2013-10-23','10:50:00',1.53),('8998','2013-10-23','10:55:00',1.89),('8998','2013-10-23','11:00:00',2.22),('8998','2013-10-23','11:05:00',2.34),('8998','2013-10-23','11:10:00',2.54),('8998','2013-10-23','11:15:00',1.25),('8998','2013-10-23','11:20:00',1.04),('8998','2013-10-23','11:25:00',1.77),('8998','2013-10-23','11:30:00',1.41),('8998','2013-10-23','11:50:00',1.21),('8998','2013-10-23','11:55:00',2.19),('8998','2013-10-23','12:00:00',1.31),('8998','2013-10-23','12:05:00',1.02),('8998','2013-10-23','12:25:00',1.01),('8998','2013-10-23','12:30:00',1.04),('8998','2013-10-23','12:35:00',1.12),('8998','2013-10-23','12:40:00',1.26),('8998','2013-10-23','12:45:00',1.36),('8998','2013-10-23','12:50:00',1.43),('8998','2013-10-23','12:55:00',1.42),('8998','2013-10-23','13:00:00',1.75),('8998','2013-10-23','13:05:00',2.29),('8998','2013-10-23','13:10:00',1.86),('8998','2013-10-23','13:15:00',1.49),('8998','2013-10-23','13:20:00',1.51),('8998','2013-10-23','13:25:00',1.55),('8998','2013-10-23','13:55:00',1.14),('8998','2013-10-23','14:00:00',1.31),('8998','2013-10-23','14:05:00',1.21),('8998','2013-10-23','14:35:00',1.05),('8998','2013-10-23','14:40:00',1.03),('8998','2013-10-23','14:50:00',1.02),('8998','2013-10-22','10:50:00',1.3),('8998','2013-10-22','10:55:00',1.01),('8998','2013-10-22','11:00:00',1.12),('8998','2013-10-22','11:10:00',1.23),('8998','2013-10-22','11:15:00',1.96),('8998','2013-10-22','11:20:00',1.97),('8998','2013-10-22','11:25:00',2.11),('8998','2013-10-22','11:30:00',1.75),('8998','2013-10-22','11:35:00',1.97),('8998','2013-10-22','11:40:00',2.06),('8998','2013-10-22','11:45:00',1.96),('8998','2013-10-22','11:50:00',1.86),('8998','2013-10-22','11:55:00',1.89),('8998','2013-10-22','12:00:00',1.97),('8998','2013-10-22','12:05:00',1.92),('8998','2013-10-22','12:10:00',1.81),('8998','2013-10-22','12:15:00',1.83),('8998','2013-10-22','12:20:00',1.8),('8998','2013-10-22','12:25:00',1.86),('8998','2013-10-22','12:30:00',1.83),('8998','2013-10-22','12:35:00',1.79),('8998','2013-10-22','12:40:00',1.79),('8998','2013-10-22','12:45:00',1.62),('8998','2013-10-22','12:50:00',1.48),('8998','2013-10-22','12:55:00',1.28),('8998','2013-10-22','13:00:00',1.75),('8998','2013-10-22','13:05:00',1.69),('8998','2013-10-22','13:10:00',1.66),('8998','2013-10-22','13:15:00',1.67),('8998','2013-10-22','13:20:00',1.64),('8998','2013-10-22','13:25:00',1.62),('8998','2013-10-22','13:30:00',1.6),('8998','2013-10-22','13:35:00',1.57),('8998','2013-10-22','13:40:00',1.56),('8998','2013-10-22','13:45:00',1.54),('8998','2013-10-22','13:50:00',1.4),('8998','2013-10-22','13:55:00',1.09),('8998','2013-10-22','14:00:00',1.32),('8998','2013-10-22','14:05:00',1.3),('8998','2013-10-22','14:10:00',1.27),('8998','2013-10-22','14:15:00',1.33),('8998','2013-10-22','14:20:00',1.26),('8998','2013-10-22','14:25:00',1.19),('8998','2013-10-22','14:30:00',1.16),('8998','2013-10-22','14:35:00',1.09),('8998','2013-10-21','09:00:00',1.11),('8998','2013-10-21','09:05:00',1.18),('8998','2013-10-21','09:10:00',1.24),('8998','2013-10-21','09:15:00',1.31),('8998','2013-10-21','09:20:00',1.37),('8998','2013-10-21','09:25:00',1.43),('8998','2013-10-21','09:30:00',1.47),('8998','2013-10-21','09:35:00',1.52),('8998','2013-10-21','09:40:00',1.56),('8998','2013-10-21','09:45:00',1.59),('8998','2013-10-21','09:50:00',1.62),('8998','2013-10-21','09:55:00',1.66),('8998','2013-10-21','10:00:00',1.68),('8998','2013-10-21','10:05:00',1.71),('8998','2013-10-21','10:10:00',1.74),('8998','2013-10-21','10:15:00',1.78),('8998','2013-10-21','10:20:00',1.81),('8998','2013-10-21','10:25:00',1.84),('8998','2013-10-21','10:30:00',1.85),('8998','2013-10-21','10:35:00',1.87),('8998','2013-10-21','10:40:00',1.89),('8998','2013-10-21','10:45:00',1.91),('8998','2013-10-21','10:50:00',1.94),('8998','2013-10-21','10:55:00',1.92),('8998','2013-10-21','11:00:00',1.91),('8998','2013-10-21','11:05:00',1.94),('8998','2013-10-21','11:10:00',1.95),('8998','2013-10-21','11:15:00',1.95),('8998','2013-10-21','11:20:00',1.97),('8998','2013-10-21','11:25:00',1.95),('8998','2013-10-21','11:30:00',1.94),('8998','2013-10-21','11:35:00',1.95),('8998','2013-10-21','11:40:00',1.93),('8998','2013-10-21','11:45:00',1.9),('8998','2013-10-21','11:50:00',1.9),('8998','2013-10-21','11:55:00',1.92),('8998','2013-10-21','12:00:00',1.92),('8998','2013-10-21','12:05:00',1.92),('8998','2013-10-21','12:10:00',1.89),('8998','2013-10-21','12:15:00',1.86),('8998','2013-10-21','12:20:00',1.88),('8998','2013-10-21','12:25:00',1.88),('8998','2013-10-21','12:30:00',1.84),('8998','2013-10-21','12:35:00',1.84),('8998','2013-10-21','12:40:00',1.83),('8998','2013-10-21','12:45:00',1.82),('8998','2013-10-21','12:50:00',1.81),('8998','2013-10-21','12:55:00',1.73),('8998','2013-10-21','13:00:00',1.72),('8998','2013-10-21','13:05:00',1.7),('8998','2013-10-21','13:10:00',1.64),('8998','2013-10-21','13:15:00',1.63),('8998','2013-10-21','13:20:00',1.63),('8998','2013-10-21','13:25:00',1.62),('8998','2013-10-21','13:30:00',1.6),('8998','2013-10-21','13:35:00',1.5),('8998','2013-10-21','13:40:00',1.53),('8998','2013-10-21','13:45:00',1.5),('8998','2013-10-21','13:50:00',1.41),('8998','2013-10-21','13:55:00',1.39),('8998','2013-10-21','14:00:00',1.32),('8998','2013-10-21','14:05:00',1.37),('8998','2013-10-21','14:10:00',1.33),('8998','2013-10-21','14:15:00',1.25),('8998','2013-10-21','14:25:00',1.17),('8998','2013-10-20','09:10:00',1.09),('8998','2013-10-20','09:15:00',1.3),('8998','2013-10-20','09:20:00',1.48),('8998','2013-10-20','09:25:00',1.54),('8998','2013-10-20','09:30:00',1.44),('8998','2013-10-20','09:35:00',1.3),('8998','2013-10-20','09:40:00',1.57),('8998','2013-10-20','09:45:00',1.36),('8998','2013-10-20','09:50:00',1.42),('8998','2013-10-20','09:55:00',1.55),('8998','2013-10-20','10:00:00',1.54),('8998','2013-10-20','10:05:00',1.69),('8998','2013-10-20','10:10:00',1.82),('8998','2013-10-20','10:15:00',1.86),('8998','2013-10-20','10:20:00',1.82),('8998','2013-10-20','10:25:00',1.89),('8998','2013-10-20','10:30:00',1.85),('8998','2013-10-20','10:35:00',1.83),('8998','2013-10-20','10:40:00',1.79),('8998','2013-10-20','10:45:00',1.83),('8998','2013-10-20','10:50:00',1.9),('8998','2013-10-20','10:55:00',1.89),('8998','2013-10-20','11:00:00',2),('8998','2013-10-20','11:05:00',1.86),('8998','2013-10-20','11:10:00',1.62),('8998','2013-10-20','11:15:00',2.05),('8998','2013-10-20','11:20:00',2.04),('8998','2013-10-20','11:25:00',1.99),('8998','2013-10-20','11:30:00',2.03),('8998','2013-10-20','11:35:00',2.04),('8998','2013-10-20','11:40:00',1.99),('8998','2013-10-20','11:45:00',2.06),('8998','2013-10-20','11:50:00',2.04),('8998','2013-10-20','11:55:00',2.04),('8998','2013-10-20','12:00:00',2.05),('8998','2013-10-20','12:05:00',2.06),('8998','2013-10-20','12:10:00',2.04),('8998','2013-10-20','12:15:00',2.02),('8998','2013-10-20','12:20:00',2),('8998','2013-10-20','12:25:00',2),('8998','2013-10-20','12:30:00',1.9),('8998','2013-10-20','12:35:00',1.9),('8998','2013-10-20','12:40:00',1.94),('8998','2013-10-20','12:45:00',1.93),('8998','2013-10-20','12:50:00',1.9),('8998','2013-10-20','12:55:00',1.87),('8998','2013-10-20','13:00:00',1.83),('8998','2013-10-20','13:05:00',1.78),('8998','2013-10-20','13:10:00',1.66),('8998','2013-10-20','13:15:00',1.7),('8998','2013-10-20','13:20:00',1.69),('8998','2013-10-20','13:25:00',1.66),('8998','2013-10-20','13:30:00',1.69),('8998','2013-10-20','13:35:00',1.66),('8998','2013-10-20','13:40:00',1.61),('8998','2013-10-20','13:45:00',1.58),('8998','2013-10-20','13:50:00',1.54),('8998','2013-10-20','13:55:00',1.48),('8998','2013-10-20','14:00:00',1.41),('8998','2013-10-20','14:05:00',1.44),('8998','2013-10-20','14:10:00',1.4),('8998','2013-10-20','14:15:00',1.36),('8998','2013-10-20','14:20:00',1.32),('8998','2013-10-20','14:25:00',1.27),('8998','2013-10-20','14:30:00',1.19),('8998','2013-10-20','14:35:00',1.09),('8998','2013-10-19','08:55:00',1.08),('8998','2013-10-19','09:00:00',1.28),('8998','2013-10-19','09:05:00',1.3),('8998','2013-10-19','09:10:00',1.37),('8998','2013-10-19','09:15:00',1.44),('8998','2013-10-19','09:20:00',1.51),('8998','2013-10-19','09:25:00',1.56),('8998','2013-10-19','09:30:00',1.59),('8998','2013-10-19','09:35:00',1.62),('8998','2013-10-19','09:40:00',1.68),('8998','2013-10-19','09:45:00',1.72),('8998','2013-10-19','09:50:00',1.73),('8998','2013-10-19','09:55:00',1.77),('8998','2013-10-19','10:00:00',1.81),('8998','2013-10-19','10:05:00',1.86),('8998','2013-10-19','10:10:00',1.9),('8998','2013-10-19','10:15:00',1.91),('8998','2013-10-19','10:20:00',1.93),('8998','2013-10-19','10:25:00',1.96),('8998','2013-10-19','10:30:00',1.99),('8998','2013-10-19','10:35:00',2),('8998','2013-10-19','10:40:00',2.01),('8998','2013-10-19','10:45:00',2.04),('8998','2013-10-19','10:50:00',2.04),('8998','2013-10-19','10:55:00',2.05),('8998','2013-10-19','11:00:00',2.06),('8998','2013-10-19','11:05:00',2.08),('8998','2013-10-19','11:10:00',2.1),('8998','2013-10-19','11:15:00',2.09),('8998','2013-10-19','11:20:00',2.1),('8998','2013-10-19','11:25:00',2.1),('8998','2013-10-19','11:30:00',2.12),('8998','2013-10-19','11:35:00',2.11),('8998','2013-10-19','11:40:00',2.12),('8998','2013-10-19','11:45:00',2.11),('8998','2013-10-19','11:50:00',2.13),('8998','2013-10-19','11:55:00',2.06),('8998','2013-10-19','12:00:00',2.08),('8998','2013-10-19','12:05:00',2.09),('8998','2013-10-19','12:10:00',2.1),('8998','2013-10-19','12:15:00',1.31),('8998','2013-10-19','12:30:00',1.97),('8998','2013-10-19','12:35:00',1.62),('8998','2013-10-19','12:40:00',1.71),('8998','2013-10-19','12:50:00',1.16),('8998','2013-10-19','12:55:00',1.73),('8998','2013-10-19','13:00:00',1.59),('8998','2013-10-19','13:05:00',1.64),('8998','2013-10-19','13:10:00',2.19),('8998','2013-10-19','13:15:00',1.31),('8998','2013-10-19','13:30:00',1.43),('8998','2013-10-19','13:35:00',1.38),('8998','2013-10-19','13:45:00',1.5),('8998','2013-10-19','13:55:00',1.11),('8998','2013-10-19','14:10:00',1),('8998','2013-10-18','08:55:00',1.17),('8998','2013-10-18','09:00:00',1.2),('8998','2013-10-18','09:05:00',1.12),('8998','2013-10-18','09:10:00',1.59),('8998','2013-10-18','09:15:00',1.85),('8998','2013-10-18','09:20:00',1.87),('8998','2013-10-18','09:25:00',1.87),('8998','2013-10-18','09:30:00',1.88),('8998','2013-10-18','09:35:00',1.9),('8998','2013-10-18','09:40:00',1.96),('8998','2013-10-18','09:45:00',2.04),('8998','2013-10-18','09:50:00',2.08),('8998','2013-10-18','09:55:00',2.15),('8998','2013-10-18','10:00:00',2.12),('8998','2013-10-18','10:05:00',1.98),('8998','2013-10-18','10:10:00',2.12),('8998','2013-10-18','10:15:00',2.06),('8998','2013-10-18','10:20:00',2.2),('8998','2013-10-18','10:25:00',2.33),('8998','2013-10-18','10:30:00',2.34),('8998','2013-10-18','10:35:00',2.32),('8998','2013-10-18','10:40:00',2.3),('8998','2013-10-18','10:45:00',2.25),('8998','2013-10-18','10:50:00',2.27),('8998','2013-10-18','10:55:00',2.31),('8998','2013-10-18','11:00:00',2.3),('8998','2013-10-18','11:05:00',2.03),('8998','2013-10-18','11:20:00',1.6),('8998','2013-10-18','11:25:00',2.55),('8998','2013-10-18','11:30:00',2.43),('8998','2013-10-18','11:35:00',2.41),('8998','2013-10-18','11:40:00',1.56),('8998','2013-10-18','11:45:00',2.31),('8998','2013-10-18','11:50:00',2.25),('8998','2013-10-18','11:55:00',2.28),('8998','2013-10-18','12:00:00',1.69),('8998','2013-10-18','12:05:00',2.21),('8998','2013-10-18','12:10:00',2.26),('8998','2013-10-18','12:15:00',2.25),('8998','2013-10-18','12:20:00',2.27),('8998','2013-10-18','12:25:00',1.48),('8998','2013-10-18','12:30:00',2.16),('8998','2013-10-18','12:35:00',2.2),('8998','2013-10-18','12:40:00',2.26),('8998','2013-10-18','12:45:00',1.63),('8998','2013-10-18','12:50:00',2.24),('8998','2013-10-18','12:55:00',2.2),('8998','2013-10-18','13:00:00',2.39),('8998','2013-10-18','13:05:00',1.87),('8998','2013-10-18','13:10:00',1.91),('8998','2013-10-18','13:15:00',1.9),('8998','2013-10-18','13:20:00',1.85),('8998','2013-10-18','13:25:00',2.04),('8998','2013-10-18','13:30:00',2.05),('8998','2013-10-18','13:35:00',1.71),('8998','2013-10-18','13:40:00',1.52),('8998','2013-10-18','13:45:00',1.55),('8998','2013-10-18','13:50:00',1.57),('8998','2013-10-18','13:55:00',1.89),('8998','2013-10-18','14:00:00',1.51),('8998','2013-10-18','14:05:00',1.28),('8998','2013-10-18','14:15:00',1.19),('8998','2013-10-18','14:20:00',1.08),('8998','2013-10-18','14:25:00',1.07),('8998','2013-10-18','14:30:00',1.22),('8998','2013-10-18','14:35:00',1.55),('8998','2013-10-18','14:40:00',1.16),('8998','2013-10-18','14:50:00',1.12),('8998','2013-10-18','14:55:00',1.07),('8998','2014-05-03','07:40:00',1.31),('8998','2014-05-03','07:45:00',1.36),('8998','2014-05-03','07:50:00',1.54),('8998','2014-05-03','07:55:00',1.52),('8998','2014-05-03','08:00:00',1.42),('8998','2014-05-03','08:05:00',1.72),('8998','2014-05-03','08:10:00',1.7),('8998','2014-05-03','08:15:00',1.83),('8998','2014-05-03','08:20:00',1.76),('8998','2014-05-03','08:25:00',1.65),('8998','2014-05-03','08:30:00',2.06),('8998','2014-05-03','08:35:00',2.05),('8998','2014-05-03','08:40:00',1.19),('8998','2014-05-03','08:45:00',1.04),('8998','2014-05-03','08:50:00',1.45),('8998','2014-05-03','08:55:00',1.07),('8998','2014-05-03','09:00:00',1.21),('8998','2014-05-03','09:05:00',1.91),('8998','2014-05-03','09:10:00',1.6),('8998','2014-05-03','09:15:00',2),('8998','2014-05-03','09:20:00',2.95),('8998','2014-05-03','09:25:00',2.39),('8998','2014-05-03','09:30:00',1.09),('8998','2014-05-03','09:35:00',1.03),('8998','2014-05-03','09:40:00',1.68),('8998','2014-05-03','09:45:00',2.14),('8998','2014-05-03','09:50:00',2.04),('8998','2014-05-03','09:55:00',2.31),('8998','2014-05-03','10:00:00',3.28),('8998','2014-05-03','10:05:00',3.27),('8998','2014-05-03','10:10:00',3.19),('8998','2014-05-03','10:15:00',2.26),('8998','2014-05-03','10:20:00',1.5),('8998','2014-05-03','10:25:00',1.41),('8998','2014-05-03','10:30:00',1.42),('8998','2014-05-03','10:35:00',1.52),('8998','2014-05-03','10:40:00',1.57),('8998','2014-05-03','10:45:00',2.3),('8998','2014-05-03','10:50:00',2.27),('8998','2014-05-03','10:55:00',1.99),('8998','2014-05-03','11:00:00',1.87),('8998','2014-05-03','11:05:00',2.8),('8998','2014-05-03','11:10:00',3.37),('8998','2014-05-03','11:15:00',3.28),('8998','2014-05-03','11:20:00',3.19),('8998','2014-05-03','11:25:00',2.64),('8998','2014-05-03','11:30:00',3.16),('8998','2014-05-03','11:35:00',3.05),('8998','2014-05-03','11:40:00',2.3),('8998','2014-05-03','11:45:00',3.41),('8998','2014-05-03','11:50:00',2.05),('8998','2014-05-03','11:55:00',2.56),('8998','2014-05-03','12:00:00',2.31),('8998','2014-05-03','12:05:00',2.01),('8998','2014-05-03','12:10:00',1.92),('8998','2014-05-03','12:15:00',1.19),('8998','2014-05-03','12:20:00',1.31),('8998','2014-05-03','12:25:00',2.25),('8998','2014-05-03','12:30:00',3.77),('8998','2014-05-03','12:35:00',3.49),('8998','2014-05-03','12:40:00',3.63),('8998','2014-05-03','12:45:00',2.86),('8998','2014-05-03','12:50:00',1.81),('8998','2014-05-03','12:55:00',1.71),('8998','2014-05-03','13:00:00',1.77),('8998','2014-05-03','13:05:00',1.72),('8998','2014-05-03','13:10:00',1.68),('8998','2014-05-03','13:15:00',1.49),('8998','2014-05-03','13:20:00',1.36),('8998','2014-05-03','13:25:00',1.14),('8998','2014-05-03','13:30:00',1.27),('8998','2014-05-03','13:35:00',1.29),('8998','2014-05-03','13:40:00',1.2),('8998','2014-05-03','13:45:00',1.07),('8998','2014-05-03','13:50:00',1.06),('8998','2014-05-03','13:55:00',1.07),('8998','2014-05-03','14:00:00',1.06),('8998','2014-05-03','14:05:00',1.08),('8998','2014-05-03','14:10:00',1.05),('8998','2014-05-03','14:55:00',1.2),('8998','2014-05-03','15:00:00',1.3),('8998','2014-05-03','15:05:00',1.88),('8998','2014-05-03','15:10:00',1.95),('8998','2014-05-03','15:15:00',1.65),('8998','2014-05-03','15:20:00',1.02),('8998','2014-04-15','08:00:00',1.24),('8998','2014-04-15','08:05:00',1.2),('8998','2014-04-15','08:10:00',1.36),('8998','2014-04-15','08:15:00',1.55),('8998','2014-04-15','08:20:00',1.44),('8998','2014-04-15','08:25:00',1.58),('8998','2014-04-15','08:30:00',1.09),('8998','2014-04-15','08:35:00',1.02),('8998','2014-04-15','08:40:00',1.11),('8998','2014-04-15','08:45:00',1.56),('8998','2014-04-15','08:50:00',2.23),('8998','2014-04-15','08:55:00',2.27),('8998','2014-04-15','09:00:00',2.3),('8998','2014-04-15','09:05:00',2.35),('8998','2014-04-15','09:10:00',2.4),('8998','2014-04-15','09:15:00',2.45),('8998','2014-04-15','09:20:00',2.5),('8998','2014-04-15','09:25:00',2.58),('8998','2014-04-15','09:30:00',1.34),('8998','2014-04-15','09:45:00',1.02),('8998','2014-04-15','09:50:00',2.03),('8998','2014-04-15','09:55:00',3.1),('8998','2014-04-15','10:00:00',2.99),('8998','2014-04-15','10:05:00',3.01),('8998','2014-04-15','10:10:00',3.03),('8998','2014-04-15','10:15:00',3.07),('8998','2014-04-15','10:20:00',3.09),('8998','2014-04-15','10:25:00',3.09),('8998','2014-04-15','10:30:00',3.11),('8998','2014-04-15','10:35:00',3.13),('8998','2014-04-15','10:40:00',3.15),('8998','2014-04-15','10:45:00',3.18),('8998','2014-04-15','10:50:00',3.25),('8998','2014-04-15','10:55:00',2.91),('8998','2014-04-15','11:00:00',3.16),('8998','2014-04-15','11:05:00',2.43),('8998','2014-04-15','11:10:00',1.22),('8998','2014-04-15','11:15:00',1.75),('8998','2014-04-15','11:20:00',3.42),('8998','2014-04-15','11:25:00',2.22),('8998','2014-04-15','11:30:00',2.92),('8998','2014-04-15','11:35:00',2.04),('8998','2014-04-15','11:40:00',2.87),('8998','2014-04-15','11:45:00',3.15),('8998','2014-04-15','11:50:00',3.6),('8998','2014-04-15','11:55:00',3.38),('8998','2014-04-15','12:00:00',3.52),('8998','2014-04-15','12:05:00',1.36),('8998','2014-04-15','12:10:00',3.19),('8998','2014-04-15','12:15:00',3.41),('8998','2014-04-15','12:20:00',2.77),('8998','2014-04-15','12:30:00',1.87),('8998','2014-04-15','12:35:00',3.31),('8998','2014-04-15','12:40:00',3.33),('8998','2014-04-15','12:45:00',3.22),('8998','2014-04-15','12:50:00',3.25),('8998','2014-04-15','12:55:00',2.26),('8998','2014-04-15','13:00:00',1.92),('8998','2014-04-15','13:20:00',1.1),('8998','2014-04-15','13:35:00',1.11),('8998','2014-04-15','13:40:00',1.43),('8998','2014-04-15','13:45:00',3.13),('8998','2014-04-15','13:50:00',3.02),('8998','2014-04-15','13:55:00',1.79),('8998','2014-04-15','14:00:00',1.2),('8998','2014-04-15','14:05:00',2.08),('8998','2014-04-15','14:10:00',3.05),('8998','2014-04-15','14:15:00',3.12),('8998','2014-04-15','14:20:00',2.75),('8998','2014-04-15','14:25:00',2.31),('8998','2014-04-15','14:30:00',2.37),('8998','2014-04-15','14:35:00',2.59),('8998','2014-04-15','14:40:00',2.51),('8998','2014-04-15','14:45:00',1.74),('8998','2014-04-15','14:50:00',2.04),('8998','2014-04-15','15:05:00',1.71),('8998','2014-04-15','15:10:00',2.82),('8998','2014-04-15','15:15:00',1.55),('8998','2014-04-15','15:30:00',1.9),('8998','2014-04-15','15:35:00',2.06),('8998','2014-04-15','15:43:00',1.93),('8998','2014-04-15','15:45:00',1.74),('8998','2014-04-15','15:50:00',1.68),('8998','2014-04-15','15:55:00',1.6),('8998','2014-04-15','16:00:00',1.52),('8998','2014-04-15','16:05:00',1.45),('8998','2014-04-15','16:10:00',1.39),('8998','2014-04-15','16:15:00',1.33),('8998','2014-04-15','16:20:00',1.28),('8998','2014-04-15','16:25:00',1.2),('8998','2014-04-15','16:30:00',1.14),('8998','2014-04-15','16:35:00',1.09),('8998','2014-04-15','16:40:00',1.02),('8998','2013-10-17','08:50:00',1.15),('8998','2013-10-17','08:55:00',1.25),('8998','2013-10-17','09:00:00',1.42),('8998','2013-10-17','09:05:00',1.54),('8998','2013-10-17','09:10:00',1.62),('8998','2013-10-17','09:15:00',1.64),('8998','2013-10-17','09:20:00',1.78),('8998','2013-10-17','09:25:00',1.79),('8998','2013-10-17','09:30:00',1.86),('8998','2013-10-17','09:35:00',1.9),('8998','2013-10-17','09:40:00',1.94),('8998','2013-10-17','09:45:00',1.97),('8998','2013-10-17','09:50:00',2),('8998','2013-10-17','09:55:00',2.03),('8998','2013-10-17','10:00:00',2.04),('8998','2013-10-17','10:05:00',2.08),('8998','2013-10-17','10:10:00',2.09),('8998','2013-10-17','10:15:00',2.11),('8998','2013-10-17','10:20:00',2.12),('8998','2013-10-17','10:25:00',2.15),('8998','2013-10-17','10:30:00',2.18),('8998','2013-10-17','10:35:00',2.2),('8998','2013-10-17','10:40:00',2.23),('8998','2013-10-17','10:45:00',2.24),('8998','2013-10-17','10:50:00',2.23),('8998','2013-10-17','10:55:00',2.26),('8998','2013-10-17','11:00:00',2.22),('8998','2013-10-17','11:05:00',2.19),('8998','2013-10-17','11:10:00',2.12),('8998','2013-10-17','11:15:00',1.97),('8998','2013-10-17','11:20:00',2.21),('8998','2013-10-17','11:25:00',2.02),('8998','2013-10-17','11:30:00',2.26),('8998','2013-10-17','11:35:00',2.25),('8998','2013-10-17','11:40:00',2.29),('8998','2013-10-17','11:45:00',2.18),('8998','2013-10-17','11:50:00',2.22),('8998','2013-10-17','11:55:00',2.26),('8998','2013-10-17','12:00:00',2.14),('8998','2013-10-17','12:05:00',2.22),('8998','2013-10-17','12:10:00',2.2),('8998','2013-10-17','12:15:00',2.14),('8998','2013-10-17','12:20:00',2.11),('8998','2013-10-17','12:25:00',2.14),('8998','2013-10-17','12:30:00',2.14),('8998','2013-10-17','12:35:00',2.07),('8998','2013-10-17','12:40:00',2.08),('8998','2013-10-17','12:45:00',1.99),('8998','2013-10-17','12:50:00',1.96),('8998','2013-10-17','12:55:00',2),('8998','2013-10-17','13:00:00',1.97),('8998','2013-10-17','13:05:00',1.9),('8998','2013-10-17','13:10:00',1.8),('8998','2013-10-17','13:15:00',1.86),('8998','2013-10-17','13:20:00',1.84),('8998','2013-10-17','13:25:00',1.88),('8998','2013-10-17','13:30:00',1.84),('8998','2013-10-17','13:35:00',1.79),('8998','2013-10-17','13:40:00',1.77),('8998','2013-10-17','13:45:00',1.71),('8998','2013-10-17','13:50:00',1.68),('8998','2013-10-17','13:55:00',1.65),('8998','2013-10-17','14:00:00',1.48),('8998','2013-10-17','14:05:00',1.51),('8998','2013-10-17','14:10:00',1.47),('8998','2013-10-17','14:15:00',1.47),('8998','2013-10-17','14:20:00',1.43),('8998','2013-10-17','14:25:00',1.4),('8998','2013-10-17','14:30:00',1.34),('8998','2013-10-17','14:35:00',1.17),('8998','2013-10-17','14:40:00',1.06),('8998','2013-10-16','08:50:00',1.15),('8998','2013-10-16','08:55:00',1.46),('8998','2013-10-16','09:00:00',1.53),('8998','2013-10-16','09:05:00',1.59),('8998','2013-10-16','09:10:00',1.63),('8998','2013-10-16','09:15:00',1.71),('8998','2013-10-16','09:20:00',1.77),('8998','2013-10-16','09:25:00',1.82),('8998','2013-10-16','09:30:00',1.85),('8998','2013-10-16','09:35:00',1.89),('8998','2013-10-16','09:40:00',1.93),('8998','2013-10-16','09:45:00',1.96),('8998','2013-10-16','09:50:00',1.99),('8998','2013-10-16','09:55:00',2.03),('8998','2013-10-16','10:00:00',2.05),('8998','2013-10-16','10:05:00',2.07),('8998','2013-10-16','10:10:00',2.1),('8998','2013-10-16','10:15:00',2.13),('8998','2013-10-16','10:20:00',2.15),('8998','2013-10-16','10:25:00',2.17),('8998','2013-10-16','10:30:00',2.2),('8998','2013-10-16','10:35:00',2.22),('8998','2013-10-16','10:40:00',2.24),('8998','2013-10-16','10:45:00',2.25),('8998','2013-10-16','10:50:00',2.27),('8998','2013-10-16','10:55:00',2.28),('8998','2013-10-16','11:00:00',2.29),('8998','2013-10-16','11:05:00',2.3),('8998','2013-10-16','11:10:00',2.3),('8998','2013-10-16','11:15:00',2.3),('8998','2013-10-16','11:20:00',2.31),('8998','2013-10-16','11:25:00',2.31),('8998','2013-10-16','11:30:00',2.32),('8998','2013-10-16','11:35:00',2.33),('8998','2013-10-16','11:40:00',2.33),('8998','2013-10-16','11:45:00',2.3),('8998','2013-10-16','11:50:00',2.3),('8998','2013-10-16','11:55:00',2.3),('8998','2013-10-16','12:00:00',2.28),('8998','2013-10-16','12:05:00',2.27),('8998','2013-10-16','12:10:00',2.26),('8998','2013-10-16','12:15:00',2.26),('8998','2013-10-16','12:20:00',2.24),('8998','2013-10-16','12:25:00',2.22),('8998','2013-10-16','12:30:00',2.21),('8998','2013-10-16','12:35:00',2.18),('8998','2013-10-16','12:40:00',2.17),('8998','2013-10-16','12:45:00',2.17),('8998','2013-10-16','12:50:00',2.14),('8998','2013-10-16','12:55:00',2.12),('8998','2013-10-16','13:00:00',2.08),('8998','2013-10-16','13:05:00',2.05),('8998','2013-10-16','13:10:00',2.02),('8998','2013-10-16','13:15:00',2),('8998','2013-10-16','13:20:00',1.98),('8998','2013-10-16','13:25:00',1.94),('8998','2013-10-16','13:30:00',1.9),('8998','2013-10-16','13:35:00',1.86),('8998','2013-10-16','13:40:00',1.83),('8998','2013-10-16','13:45:00',1.8),('8998','2013-10-16','13:50:00',1.75),('8998','2013-10-16','13:55:00',1.73),('8998','2013-10-16','14:00:00',1.69),('8998','2013-10-16','14:05:00',1.64),('8998','2013-10-16','14:10:00',1.6),('8998','2013-10-16','14:15:00',1.56),('8998','2013-10-16','14:20:00',1.51),('8998','2013-10-16','14:25:00',1.46),('8998','2013-10-16','14:30:00',1.41),('8998','2013-10-16','14:35:00',1.27),('8998','2013-10-16','14:40:00',1.13),('8998','2013-10-16','14:45:00',1),('8998','2013-10-15','09:50:00',1.44),('8998','2013-10-15','11:15:00',1.09),('8998','2013-10-15','12:15:00',1.19),('8998','2013-10-15','12:20:00',2.05),('8998','2013-10-15','12:25:00',1.1),('8998','2013-10-15','12:40:00',2.35),('8998','2013-10-15','12:45:00',2.29),('8998','2013-10-15','12:50:00',2.15),('8998','2013-10-15','12:55:00',1.94),('8998','2013-10-15','13:00:00',1.66),('8998','2013-10-15','13:05:00',2.02),('8998','2013-10-15','13:10:00',2.06),('8998','2013-10-15','13:15:00',1.51),('8998','2013-10-15','13:20:00',1.49),('8998','2013-10-15','13:25:00',2.01),('8998','2013-10-15','13:30:00',1.72),('8998','2013-10-15','13:35:00',1.82),('8998','2013-10-15','13:40:00',1.91),('8998','2013-10-15','13:45:00',1.81),('8998','2013-10-15','13:50:00',1.76),('8998','2013-10-15','13:55:00',1.84),('8998','2013-10-15','14:00:00',1.56),('8998','2013-10-15','14:05:00',1.23),('8998','2013-10-15','14:10:00',1.61),('8998','2013-10-15','14:15:00',1.08),('8998','2013-10-15','14:20:00',1.57),('8998','2013-10-15','14:30:00',1.26),('8998','2013-10-15','14:35:00',1.11),('8998','2013-10-15','14:40:00',1.03),('8998','2013-10-15','14:45:00',1.29),('8998','2013-10-15','14:50:00',1.16),('8998','2013-10-15','15:00:00',1.06),('8998','2013-10-14','09:30:00',1.53),('8998','2013-10-14','09:40:00',1.33),('8998','2013-10-14','09:45:00',1.74),('8998','2013-10-14','09:50:00',1.93),('8998','2013-10-14','09:55:00',1.99),('8998','2013-10-14','10:00:00',1.93),('8998','2013-10-14','10:05:00',2.05),('8998','2013-10-14','10:10:00',1.6),('8998','2013-10-14','10:25:00',1.01),('8998','2013-10-14','10:30:00',1.57),('8998','2013-10-14','10:35:00',1.24),('8998','2013-10-14','10:40:00',1.51),('8998','2013-10-14','10:45:00',1.72),('8998','2013-10-14','10:50:00',1.69),('8998','2013-10-14','10:55:00',1.42),('8998','2013-10-14','11:00:00',1.41),('8998','2013-10-14','11:05:00',1.46),('8998','2013-10-14','11:10:00',1.97),('8998','2013-10-14','11:15:00',2.08),('8998','2013-10-14','11:20:00',2.12),('8998','2013-10-14','11:25:00',1.99),('8998','2013-10-14','11:30:00',2.02),('8998','2013-10-14','11:35:00',1.72),('8998','2013-10-14','11:40:00',1.35),('8998','2013-10-14','11:45:00',1.08),('8998','2013-10-14','11:50:00',1.04),('8998','2013-10-14','11:55:00',1.01),('8998','2013-10-14','12:00:00',1.04),('8998','2013-10-14','12:05:00',1.05),('8998','2013-10-14','12:10:00',1.08),('8998','2013-10-14','12:15:00',1.06),('8998','2013-10-14','12:20:00',1.1),('8998','2013-10-14','12:25:00',1.04),('8998','2013-10-14','13:10:00',1.19),('8998','2013-10-14','13:15:00',1.2),('8998','2013-10-14','13:20:00',1.61),('8998','2013-10-14','13:25:00',1.84),('8998','2013-10-14','13:30:00',1.19),('8998','2013-10-14','13:35:00',1.06),('8998','2013-10-14','13:40:00',1.02),('8998','2013-10-14','13:45:00',1.06),('8998','2013-10-14','14:15:00',1.08),('8998','2013-10-14','14:20:00',1.25),('8998','2013-10-14','14:25:00',1.3),('8998','2013-10-14','14:30:00',1.25),('8998','2013-10-14','14:40:00',1.04),('8998','2013-10-14','14:45:00',1.11),('8998','2013-10-14','14:50:00',1.18),('8998','2013-10-14','14:55:00',1.08),('8998','2013-10-13','08:55:00',1.29),('8998','2013-10-13','09:00:00',1.15),('8998','2013-10-13','09:05:00',1.17),('8998','2013-10-13','09:10:00',1.1),('8998','2013-10-13','09:20:00',1.06),('8998','2013-10-13','09:25:00',1.65),('8998','2013-10-13','09:30:00',1.78),('8998','2013-10-13','09:35:00',1.71),('8998','2013-10-13','09:40:00',1.41),('8998','2013-10-13','09:45:00',1.3),('8998','2013-10-13','09:50:00',1.53),('8998','2013-10-13','09:55:00',1.8),('8998','2013-10-13','10:00:00',1.72),('8998','2013-10-13','10:05:00',1.88),('8998','2013-10-13','10:10:00',1.95),('8998','2013-10-13','10:15:00',2.04),('8998','2013-10-13','10:20:00',2.05),('8998','2013-10-13','10:25:00',2.06),('8998','2013-10-13','10:30:00',2.07),('8998','2013-10-13','10:35:00',2.07),('8998','2013-10-13','10:40:00',2.02),('8998','2013-10-13','10:45:00',2.06),('8998','2013-10-13','10:50:00',2.13),('8998','2013-10-13','10:55:00',2.13),('8998','2013-10-13','11:00:00',2.17),('8998','2013-10-13','11:05:00',2.13),('8998','2013-10-13','11:10:00',2.2),('8998','2013-10-13','11:15:00',2.19),('8998','2013-10-13','11:20:00',2.17),('8998','2013-10-13','11:25:00',2.21),('8998','2013-10-13','11:30:00',2.24),('8998','2013-10-13','11:35:00',2.18),('8998','2013-10-13','11:40:00',2.18),('8998','2013-10-13','11:45:00',2.13),('8998','2013-10-13','11:50:00',2.14),('8998','2013-10-13','11:55:00',2.14),('8998','2013-10-13','12:00:00',2.13),('8998','2013-10-13','12:05:00',2.13),('8998','2013-10-13','12:10:00',2.14),('8998','2013-10-13','12:15:00',2.1),('8998','2013-10-13','12:20:00',1.94),('8998','2013-10-13','12:25:00',2.01),('8998','2013-10-13','12:30:00',2.13),('8998','2013-10-13','12:35:00',2.09),('8998','2013-10-13','12:40:00',2.07),('8998','2013-10-13','12:45:00',2.04),('8998','2013-10-13','12:50:00',2.01),('8998','2013-10-13','12:55:00',2),('8998','2013-10-13','13:00:00',1.98),('8998','2013-10-13','13:05:00',1.96),('8998','2013-10-13','13:10:00',1.94),('8998','2013-10-13','13:15:00',1.91),('8998','2013-10-13','13:20:00',1.88),('8998','2013-10-13','13:25:00',1.85),('8998','2013-10-13','13:30:00',1.82),('8998','2013-10-13','13:35:00',1.78),('8998','2013-10-13','13:40:00',1.75),('8998','2013-10-13','13:45:00',1.72),('8998','2013-10-13','13:50:00',1.69),('8998','2013-10-13','13:55:00',1.65),('8998','2013-10-13','14:00:00',1.61),('8998','2013-10-13','14:05:00',1.58),('8998','2013-10-13','14:10:00',1.54),('8998','2013-10-13','14:15:00',1.5),('8998','2013-10-13','14:20:00',1.46),('8998','2013-10-13','14:25:00',1.42),('8998','2013-10-13','14:30:00',1.38),('8998','2013-10-13','14:35:00',1.32),('8998','2013-10-13','14:40:00',1.17),('8998','2013-10-13','14:45:00',1.03),('8998','2013-10-12','09:15:00',1.59),('8998','2013-10-12','09:20:00',1.77),('8998','2013-10-12','09:25:00',1.64),('8998','2013-10-12','09:30:00',1.09),('8998','2013-10-12','09:35:00',1.24),('8998','2013-10-12','09:40:00',1.65),('8998','2013-10-12','09:45:00',2.35),('8998','2013-10-12','09:50:00',2.25),('8998','2013-10-12','09:55:00',2.31),('8998','2013-10-12','10:00:00',1.85),('8998','2013-10-12','10:05:00',1.24),('8998','2013-10-12','10:10:00',1.55),('8998','2013-10-12','10:15:00',1.87),('8998','2013-10-12','10:20:00',1.54),('8998','2013-10-12','10:25:00',1.64),('8998','2013-10-12','10:30:00',2.11),('8998','2013-10-12','10:35:00',2.5),('8998','2013-10-12','10:40:00',2.56),('8998','2013-10-12','10:45:00',2.58),('8998','2013-10-12','10:50:00',2.35),('8998','2013-10-12','10:55:00',1.65),('8998','2013-10-12','11:00:00',2.14),('8998','2013-10-12','11:05:00',2.29),('8998','2013-10-12','11:10:00',2.38),('8998','2013-10-12','11:15:00',2.44),('8998','2013-10-12','11:20:00',2.31),('8998','2013-10-12','11:25:00',2.24),('8998','2013-10-12','11:30:00',2.27),('8998','2013-10-12','11:35:00',2.25),('8998','2013-10-12','11:40:00',2.23),('8998','2013-10-12','11:45:00',2.21),('8998','2013-10-12','11:50:00',2.21),('8998','2013-10-12','11:55:00',2.19),('8998','2013-10-12','12:00:00',2.2),('8998','2013-10-12','12:05:00',2.19),('8998','2013-10-12','12:10:00',2.18),('8998','2013-10-12','12:15:00',2.18),('8998','2013-10-12','12:20:00',2.15),('8998','2013-10-12','12:25:00',2.04),('8998','2013-10-12','12:30:00',2.13),('8998','2013-10-12','12:35:00',2.14),('8998','2013-10-12','12:40:00',2.12),('8998','2013-10-12','12:45:00',2.06),('8998','2013-10-12','12:50:00',2.02),('8998','2013-10-12','12:55:00',2.02),('8998','2013-10-12','13:00:00',2),('8998','2013-10-12','13:05:00',1.97),('8998','2013-10-12','13:10:00',1.97),('8998','2013-10-12','13:15:00',1.98),('8998','2013-10-12','13:20:00',1.96),('8998','2013-10-12','13:25:00',1.74),('8998','2013-10-12','13:30:00',1.37),('8998','2013-10-12','13:35:00',1.72),('8998','2013-10-12','13:40:00',1.07),('8998','2013-10-12','13:45:00',1.15),('8998','2013-10-12','13:50:00',1.22),('8998','2013-10-12','13:55:00',1.34),('8998','2013-10-12','14:00:00',1.68),('8998','2013-10-12','14:05:00',1.73),('8998','2013-10-12','14:10:00',1.69),('8998','2013-10-12','14:15:00',1.54),('8998','2013-10-12','14:20:00',1.63),('8998','2013-10-12','14:25:00',1.6),('8998','2013-10-12','14:30:00',1.47),('8998','2013-10-12','14:35:00',1.08),('8998','2013-10-12','14:40:00',1.26),('8998','2013-10-12','14:45:00',1.04),('8998','2013-10-12','15:00:00',1.14),('8998','2013-10-12','15:05:00',1.14),('8998','2013-10-11','11:35:00',1.24),('8998','2013-10-11','11:40:00',2.19),('8998','2013-10-11','11:45:00',1.25),('8998','2013-10-11','11:50:00',1.08),('8998','2013-10-11','12:20:00',1.16),('8998','2013-10-11','12:25:00',2.46),('8998','2013-10-11','12:30:00',1.82),('8998','2013-10-11','12:35:00',2.18),('8998','2013-10-11','12:40:00',2.1),('8998','2013-10-11','12:45:00',1.86),('8998','2013-10-11','12:50:00',2.01),('8998','2013-10-11','12:55:00',1.65),('8998','2013-10-11','13:00:00',1.22),('8998','2013-10-11','13:30:00',2.13),('8998','2013-10-11','13:35:00',1.24),('8998','2013-10-10','09:25:00',1.05),('8998','2013-10-10','09:35:00',1.18),('8998','2013-10-10','09:45:00',2.09),('8998','2013-10-10','09:50:00',2.09),('8998','2013-10-10','09:55:00',2.09),('8998','2013-10-10','10:00:00',2.1),('8998','2013-10-10','10:05:00',2.14),('8998','2013-10-10','10:10:00',2.17),('8998','2013-10-10','10:15:00',1.89),('8998','2013-10-10','10:20:00',1.92),('8998','2013-10-10','10:25:00',1.4),('8998','2013-10-10','10:30:00',1.79),('8998','2013-10-10','10:35:00',2.52),('8998','2013-10-10','10:40:00',1.25),('8998','2013-10-10','11:05:00',1.87),('8998','2013-10-10','11:10:00',2.15),('8998','2013-10-10','11:40:00',1.37),('8998','2013-10-10','11:45:00',1.26),('8998','2013-10-10','11:50:00',1.47),('8998','2013-10-10','11:55:00',1.29),('8998','2013-10-10','12:00:00',1.74),('8998','2013-10-10','12:05:00',3),('8998','2013-10-10','12:10:00',1.4),('8998','2013-10-10','12:30:00',1.26),('8998','2013-10-10','13:05:00',1.79),('8998','2013-10-10','13:10:00',1.18),('8998','2013-10-10','13:20:00',1.23),('8998','2013-10-10','13:25:00',2.3),('8998','2013-10-10','13:30:00',1.09),('8998','2013-10-10','13:40:00',1.66),('8998','2013-10-10','13:45:00',2.23),('8998','2013-10-09','09:10:00',1.58),('8998','2013-10-09','09:15:00',1.77),('8998','2013-10-09','09:20:00',1.82),('8998','2013-10-09','09:25:00',1.77),('8998','2013-10-09','09:30:00',1.77),('8998','2013-10-09','09:35:00',1.53),('8998','2013-10-09','09:40:00',1.58),('8998','2013-10-09','09:45:00',1.47),('8998','2013-10-09','10:15:00',1.66),('8998','2013-10-09','10:20:00',2.19),('8998','2013-10-09','10:25:00',2.12),('8998','2013-10-09','10:30:00',2.15),('8998','2013-10-09','10:45:00',1.36),('8998','2013-10-09','11:25:00',2.41),('8998','2013-10-09','11:30:00',1.73),('8998','2013-10-09','11:45:00',1.07),('8998','2013-10-09','11:50:00',1.02),('8998','2013-10-09','11:55:00',2.3),('8998','2013-10-09','12:00:00',2.47),('8998','2013-10-09','12:05:00',1.75),('8998','2013-10-09','12:10:00',1.01),('8998','2013-10-09','12:25:00',2.04),('8998','2013-10-09','12:30:00',1.14),('8998','2013-10-09','12:35:00',2.4),('8998','2013-10-09','12:40:00',2.72),('8998','2013-10-09','12:45:00',2),('8998','2013-10-09','12:50:00',1.73),('8998','2013-10-09','13:00:00',1.8),('8998','2013-10-09','13:05:00',2.44),('8998','2013-10-09','13:10:00',1.53),('8998','2013-10-09','13:25:00',1.64),('8998','2013-10-09','13:30:00',1.52),('8998','2013-10-09','13:35:00',1.44),('8998','2013-10-09','13:40:00',1.25),('8998','2013-10-09','13:45:00',2.06),('8998','2013-10-09','13:50:00',2.06),('8998','2013-10-09','13:55:00',1.99),('8998','2013-10-09','14:00:00',1.89),('8998','2013-10-09','14:05:00',1.36),('8998','2013-10-09','14:10:00',1.19),('8998','2013-10-09','14:15:00',1),('8998','2013-10-09','14:20:00',1.85),('8998','2013-10-09','14:25:00',1.74),('8998','2013-10-09','14:30:00',1.38),('8998','2013-10-09','14:35:00',1.1),('8998','2013-10-09','14:40:00',1.73),('8998','2013-10-09','14:45:00',1.4),('8998','2013-10-09','14:50:00',1.39),('8998','2013-10-09','14:55:00',1.34),('8998','2013-10-09','15:00:00',1.2),('8998','2013-10-09','15:05:00',1.3),('8998','2013-10-09','15:10:00',1.14),('8998','2013-10-09','15:15:00',1.09),('8998','2013-10-08','08:40:00',1.04),('8998','2013-10-08','08:45:00',1.2),('8998','2013-10-08','08:50:00',1.52),('8998','2013-10-08','08:55:00',1.58),('8998','2013-10-08','09:00:00',1.64),('8998','2013-10-08','09:05:00',1.7),('8998','2013-10-08','09:10:00',1.76),('8998','2013-10-08','09:15:00',1.7),('8998','2013-10-08','09:20:00',1.57),('8998','2013-10-08','09:25:00',1.9),('8998','2013-10-08','09:30:00',1.92),('8998','2013-10-08','09:35:00',1.95),('8998','2013-10-08','09:40:00',2.01),('8998','2013-10-08','09:45:00',2.07),('8998','2013-10-08','09:50:00',2.09),('8998','2013-10-08','09:55:00',2.16),('8998','2013-10-08','10:00:00',2.25),('8998','2013-10-08','10:05:00',2.24),('8998','2013-10-08','10:10:00',2.38),('8998','2013-10-08','10:15:00',1.1),('8998','2013-10-08','10:30:00',1.12),('8998','2013-10-08','10:35:00',1.45),('8998','2013-10-08','10:40:00',1.22),('8998','2013-10-08','10:45:00',1.5),('8998','2013-10-08','10:50:00',2.95),('8998','2013-10-08','10:55:00',1.3),('8998','2013-10-08','11:00:00',2.12),('8998','2013-10-08','11:05:00',2.42),('8998','2013-10-08','11:10:00',2.99),('8998','2013-10-08','11:15:00',2.92),('8998','2013-10-08','11:20:00',2.65),('8998','2013-10-08','11:25:00',2.22),('8998','2013-10-08','11:30:00',2.77),('8998','2013-10-08','11:35:00',2.92),('8998','2013-10-08','11:40:00',2.31),('8998','2013-10-08','11:45:00',2.01),('8998','2013-10-08','11:50:00',2.3),('8998','2013-10-08','11:55:00',2.5),('8998','2013-10-08','12:00:00',1.94),('8998','2013-10-08','12:10:00',1.58),('8998','2013-10-08','12:15:00',1.39),('8998','2013-10-08','12:20:00',2.22),('8998','2013-10-08','12:25:00',2.42),('8998','2013-10-08','12:30:00',1.13),('8998','2013-10-08','12:40:00',1.01),('8998','2013-10-08','13:15:00',1.04),('8998','2013-10-08','13:20:00',1.31),('8998','2013-10-08','13:25:00',1.48),('8998','2013-10-08','13:30:00',1.33),('8998','2013-10-08','13:35:00',1.4),('8998','2013-10-08','13:40:00',2.1),('8998','2013-10-08','13:45:00',1.8),('8998','2013-10-08','13:50:00',1.76),('8998','2013-10-08','13:55:00',2.44),('8998','2013-10-08','14:00:00',2.23),('8998','2013-10-08','14:10:00',1.29),('8998','2013-10-08','14:55:00',1.23),('8998','2013-10-08','15:05:00',1.26),('8998','2013-10-08','15:10:00',1.3),('8998','2013-10-08','15:15:00',1.16),('8998','2014-04-14','09:00:00',1.52),('8998','2014-04-14','09:05:00',1.92),('8998','2014-04-14','09:10:00',1.24),('8998','2014-04-14','09:15:00',1.81),('8998','2014-04-14','09:20:00',1.45),('8998','2014-04-14','09:25:00',2.12),('8998','2014-04-14','09:30:00',1.8),('8998','2014-04-14','09:50:00',2.61),('8998','2014-04-14','10:10:00',1.02),('8998','2014-04-14','10:15:00',1.7),('8998','2014-04-14','10:20:00',1.22),('8998','2014-04-14','10:25:00',1.02),('8998','2014-04-14','10:30:00',1.59),('8998','2014-04-14','10:35:00',2.67),('8998','2014-04-14','10:40:00',1.5),('8998','2014-04-14','10:45:00',2.29),('8998','2014-04-14','10:50:00',1.9),('8998','2014-04-14','10:55:00',1.2),('8998','2014-04-14','11:00:00',1.03),('8998','2014-04-14','11:05:00',2.54),('8998','2014-04-14','11:10:00',2.46),('8998','2014-04-14','11:15:00',1.17),('8998','2014-04-14','11:25:00',1.06),('8998','2014-04-14','11:50:00',1.01),('8998','2014-04-14','12:15:00',1.21),('8998','2014-04-14','12:20:00',1.45),('8998','2014-04-14','13:10:00',1.14),('8998','2014-04-14','13:15:00',1.15),('8998','2014-04-14','13:20:00',1.95),('8998','2014-04-14','13:25:00',1.27),('8998','2014-04-14','13:30:00',2.21),('8998','2014-04-14','13:35:00',1.9),('8998','2014-04-14','13:40:00',1.91),('8998','2014-04-14','13:45:00',1.02),('8998','2014-04-14','14:00:00',1.46),('8998','2014-04-14','14:05:00',1.83),('8998','2014-04-14','14:10:00',1.12),('8998','2014-04-14','14:15:00',2.16),('8998','2014-04-14','14:20:00',2.09),('8998','2014-04-14','14:25:00',2.19),('8998','2014-04-14','14:30:00',1.51),('8998','2014-04-14','14:35:00',1.45),('8998','2014-04-14','14:40:00',1.01),('8998','2014-04-14','15:20:00',1.1),('8998','2014-04-14','15:25:00',1.43),('8998','2014-04-14','15:30:00',1.05),('8998','2013-10-07','11:00:00',1.23),('8998','2013-10-07','11:05:00',1.03),('8998','2013-10-07','11:10:00',2.05),('8998','2013-10-07','11:15:00',3.03),('8998','2013-10-07','11:20:00',2.7),('8998','2013-10-07','11:25:00',1.41),('8998','2013-10-07','11:30:00',2.2),('8998','2013-10-07','11:35:00',1.87),('8998','2013-10-07','11:40:00',1.19),('8998','2013-10-07','11:45:00',1.15),('8998','2013-10-07','12:30:00',2.47),('8998','2013-10-07','12:35:00',1.39),('8998','2013-10-07','12:40:00',3.05),('8998','2013-10-07','12:45:00',2.63),('8998','2013-10-07','12:50:00',2.6),('8998','2013-10-07','12:55:00',2.55),('8998','2013-10-07','13:00:00',2.23),('8998','2013-10-07','13:05:00',2.26),('8998','2013-10-07','13:10:00',1.52),('8998','2013-10-07','13:15:00',2.33),('8998','2013-10-07','13:20:00',1.23),('8998','2013-10-07','13:25:00',1.96),('8998','2013-10-07','13:30:00',1.29),('8998','2013-10-07','14:10:00',1.32),('8998','2013-10-07','14:15:00',1.32),('8998','2013-10-07','14:20:00',1.58),('8998','2013-10-07','14:25:00',1.58),('8998','2013-10-07','14:30:00',1.65),('8998','2013-10-07','14:45:00',1.53),('8998','2013-10-07','14:50:00',1.51),('8998','2013-10-07','14:55:00',1.35),('8998','2013-10-07','15:00:00',1.27),('8998','2013-10-07','15:05:00',1.24),('8998','2013-10-07','15:10:00',1.21),('8998','2013-10-07','15:15:00',1.04),('8998','2013-10-07','15:30:00',1.22),('8998','2013-10-07','15:35:00',1.03),('8998','2013-10-06','08:40:00',1.18),('8998','2013-10-06','09:10:00',1.71),('8998','2013-10-06','09:15:00',1.79),('8998','2013-10-06','09:20:00',1.84),('8998','2013-10-06','09:25:00',1.9),('8998','2013-10-06','09:30:00',1.41),('8998','2013-10-06','09:35:00',1.97),('8998','2013-10-06','09:40:00',2.02),('8998','2013-10-06','09:45:00',2.06),('8998','2013-10-06','09:50:00',1.52),('8998','2013-10-06','09:55:00',2.03),('8998','2013-10-06','10:00:00',2.13),('8998','2013-10-06','10:05:00',2.17),('8998','2013-10-06','10:10:00',2.18),('8998','2013-10-06','10:15:00',1.57),('8998','2013-10-06','10:20:00',2.23),('8998','2013-10-06','10:25:00',2.25),('8998','2013-10-06','10:30:00',2.3),('8998','2013-10-06','10:35:00',1.65),('8998','2013-10-06','10:40:00',2.28),('8998','2013-10-06','10:45:00',2.39),('8998','2013-10-06','10:50:00',2.41),('8998','2013-10-06','10:55:00',2.11),('8998','2013-10-06','11:00:00',2.19),('8998','2013-10-06','11:05:00',2.4),('8998','2013-10-06','11:10:00',1.93),('8998','2013-10-06','11:15:00',2.23),('8998','2013-10-06','11:20:00',2.47),('8998','2013-10-06','11:25:00',2.45),('8998','2013-10-06','11:30:00',2.42),('8998','2013-10-06','11:35:00',2.42),('8998','2013-10-06','11:40:00',2.42),('8998','2013-10-06','11:45:00',2.4),('8998','2013-10-06','11:50:00',2.38),('8998','2013-10-06','11:55:00',2.42),('8998','2013-10-06','12:00:00',2.36),('8998','2013-10-06','12:05:00',2.04),('8998','2013-10-06','12:10:00',2.57),('8998','2013-10-06','12:15:00',1.85),('8998','2013-10-06','12:20:00',1.96),('8998','2013-10-06','12:25:00',2.36),('8998','2013-10-06','12:30:00',2.6),('8998','2013-10-06','12:35:00',2.43),('8998','2013-10-06','12:40:00',2.47),('8998','2013-10-06','12:45:00',2.45),('8998','2013-10-06','12:50:00',2.41),('8998','2013-10-06','12:55:00',2.45),('8998','2013-10-06','13:00:00',2.1),('8998','2013-10-06','13:05:00',2.33),('8998','2013-10-06','13:10:00',2.31),('8998','2013-10-06','13:15:00',1.34),('8998','2013-10-06','13:20:00',2.07),('8998','2013-10-06','13:25:00',2.06),('8998','2013-10-06','13:30:00',2.25),('8998','2013-10-06','13:40:00',1.15),('8998','2013-10-06','13:45:00',1.18),('8998','2013-10-06','13:50:00',1.56),('8998','2013-10-06','13:55:00',2.4),('8998','2013-10-06','14:00:00',2.51),('8998','2013-10-06','14:05:00',1.42),('8998','2013-10-06','14:10:00',1.01),('8998','2013-10-06','14:25:00',1.63),('8998','2013-10-06','14:35:00',1.11),('8998','2013-10-06','14:40:00',1.18),('8998','2013-10-06','14:45:00',1.57),('8998','2013-10-06','14:50:00',1.74),('8998','2013-10-06','14:55:00',1.71),('8998','2013-10-06','15:00:00',1.06),('8998','2013-10-06','15:10:00',1.15),('8998','2013-10-05','09:35:00',1.39),('8998','2013-10-05','09:40:00',1.23),('8998','2013-10-05','09:50:00',1.79),('8998','2013-10-05','09:55:00',2.11),('8998','2013-10-05','10:00:00',2.45),('8998','2013-10-05','10:05:00',2.47),('8998','2013-10-05','10:10:00',2.38),('8998','2013-10-05','10:15:00',2.19),('8998','2013-10-05','10:20:00',2.18),('8998','2013-10-05','10:25:00',2.42),('8998','2013-10-05','10:30:00',2.33),('8998','2013-10-05','10:35:00',2.29),('8998','2013-10-05','10:40:00',1.92),('8998','2013-10-05','10:45:00',1.55),('8998','2013-10-05','10:50:00',1.71),('8998','2013-10-05','10:55:00',1.89),('8998','2013-10-05','11:00:00',1.92),('8998','2013-10-05','11:05:00',2.11),('8998','2013-10-05','11:10:00',2.19),('8998','2013-10-05','11:15:00',2.08),('8998','2013-10-05','11:20:00',2.07),('8998','2013-10-05','11:25:00',2.2),('8998','2013-10-05','11:30:00',2.1),('8998','2013-10-05','11:35:00',2.06),('8998','2013-10-05','11:40:00',1.78),('8998','2013-10-05','11:45:00',1.38),('8998','2013-10-05','11:50:00',1.44),('8998','2013-10-05','11:55:00',1.86),('8998','2013-10-05','12:00:00',1.9),('8998','2013-10-05','12:05:00',1.89),('8998','2013-10-05','12:10:00',2.35),('8998','2013-10-05','12:15:00',2.24),('8998','2013-10-05','12:20:00',1.9),('8998','2013-10-05','12:25:00',1.63),('8998','2013-10-05','12:30:00',1.76),('8998','2013-10-05','12:35:00',1.81),('8998','2013-10-05','12:40:00',1.51),('8998','2013-10-05','12:45:00',1.47),('8998','2013-10-05','12:50:00',1.77),('8998','2013-10-05','12:55:00',2.11),('8998','2013-10-05','13:00:00',2.16),('8998','2013-10-05','13:05:00',2.05),('8998','2013-10-05','13:10:00',1.53),('8998','2013-10-05','13:20:00',2.08),('8998','2013-10-05','13:50:00',2.02),('8998','2013-10-05','13:55:00',1.36),('8998','2013-10-05','14:00:00',1.08),('8998','2013-10-05','14:05:00',2.07),('8998','2013-10-05','14:10:00',2.17),('8998','2013-10-05','14:15:00',1.42),('8998','2013-10-05','14:20:00',1.2),('8998','2013-10-05','14:25:00',1.05),('8998','2013-10-05','14:30:00',1.02),('8998','2013-10-05','14:50:00',1.09),('8998','2013-10-05','14:55:00',1.38),('8998','2013-10-05','15:00:00',1.22),('8998','2013-10-03','09:55:00',2.28),('8998','2013-10-03','10:00:00',1.7),('8998','2013-10-03','10:05:00',1.24),('8998','2013-10-03','10:10:00',1.19),('8998','2013-10-03','10:15:00',1.47),('8998','2013-10-03','10:20:00',1.1),('8998','2013-10-03','10:25:00',1.75),('8998','2013-10-03','10:30:00',1.57),('8998','2013-10-03','10:35:00',1.21),('8998','2013-10-03','10:40:00',2.19),('8998','2013-10-03','10:45:00',1.86),('8998','2013-10-03','10:50:00',1.33),('8998','2013-10-03','10:55:00',2.13),('8998','2013-10-03','11:00:00',1.87),('8998','2013-10-03','11:05:00',1.28),('8998','2013-10-03','11:10:00',1.22),('8998','2013-10-03','11:15:00',2.61),('8998','2013-10-03','11:20:00',2.2),('8998','2013-10-03','11:25:00',2.3),('8998','2013-10-03','11:30:00',2.8),('8998','2013-10-03','11:35:00',2.73),('8998','2013-10-03','11:40:00',2.67),('8998','2013-10-03','11:45:00',2.61),('8998','2013-10-03','11:50:00',2.56),('8998','2013-10-03','11:55:00',2.54),('8998','2013-10-03','12:00:00',2.53),('8998','2013-10-03','12:05:00',2.52),('8998','2013-10-03','12:10:00',2.53),('8998','2013-10-03','12:15:00',2.27),('8998','2013-10-03','12:20:00',2.38),('8998','2013-10-03','12:25:00',2.51),('8998','2013-10-03','12:30:00',2.33),('8998','2013-10-03','12:35:00',2.18),('8998','2013-10-03','12:40:00',2.4),('8998','2013-10-03','12:45:00',2.39),('8998','2013-10-03','12:50:00',2.28),('8998','2013-10-03','12:55:00',2.28),('8998','2013-10-03','13:00:00',2.27),('8998','2013-10-03','13:05:00',2.29),('8998','2013-10-03','13:10:00',2.31),('8998','2013-10-03','13:15:00',2.48),('8998','2013-10-03','13:20:00',2.34),('8998','2013-10-03','13:25:00',2.14),('8998','2013-10-03','13:30:00',2.24),('8998','2013-10-03','13:35:00',1.59),('8998','2013-10-03','13:40:00',2.07),('8998','2013-10-03','13:45:00',1.99),('8998','2013-10-03','13:50:00',1.94),('8998','2013-10-03','13:55:00',1.91),('8998','2013-10-03','14:00:00',1.88),('8998','2013-10-03','14:05:00',1.84),('8998','2013-10-03','14:10:00',1.67),('8998','2013-10-03','14:15:00',1.49),('8998','2013-10-03','14:20:00',1.53),('8998','2013-10-03','14:25:00',1.67),('8998','2013-10-03','14:30:00',1.44),('8998','2013-10-03','14:35:00',1.05),('8998','2013-10-03','14:50:00',1.26),('8998','2013-10-03','14:55:00',1.24),('8998','2013-10-03','15:00:00',1.06),('8998','2013-10-03','15:05:00',1.13),('8998','2013-10-03','15:25:00',1),('8998','2013-10-03','15:30:00',1.03),('8998','2013-10-02','08:40:00',1.52),('8998','2013-10-02','08:45:00',1.63),('8998','2013-10-02','08:50:00',1.71),('8998','2013-10-02','08:55:00',1.78),('8998','2013-10-02','09:00:00',1.84),('8998','2013-10-02','09:05:00',1.89),('8998','2013-10-02','09:10:00',1.94),('8998','2013-10-02','09:15:00',1.99),('8998','2013-10-02','09:20:00',2.05),('8998','2013-10-02','09:25:00',2.13),('8998','2013-10-02','09:30:00',2.17),('8998','2013-10-02','09:35:00',2.21),('8998','2013-10-02','09:40:00',2.25),('8998','2013-10-02','09:45:00',2.3),('8998','2013-10-02','09:50:00',2.33),('8998','2013-10-02','09:55:00',2.36),('8998','2013-10-02','10:00:00',2.4),('8998','2013-10-02','10:05:00',2.44),('8998','2013-10-02','10:10:00',2.46),('8998','2013-10-02','10:15:00',2.5),('8998','2013-10-02','10:20:00',2.52),('8998','2013-10-02','10:25:00',2.54),('8998','2013-10-02','10:30:00',2.56),('8998','2013-10-02','10:35:00',2.58),('8998','2013-10-02','10:40:00',2.59),('8998','2013-10-02','10:45:00',2.62),('8998','2013-10-02','10:50:00',2.62),('8998','2013-10-02','10:55:00',2.64),('8998','2013-10-02','11:00:00',2.64),('8998','2013-10-02','11:05:00',2.64),('8998','2013-10-02','11:10:00',2.65),('8998','2013-10-02','11:15:00',2.66),('8998','2013-10-02','11:20:00',2.67),('8998','2013-10-02','11:25:00',2.67),('8998','2013-10-02','11:30:00',2.66),('8998','2013-10-02','11:35:00',2.68),('8998','2013-10-02','11:40:00',2.68),('8998','2013-10-02','11:45:00',2.67),('8998','2013-10-02','11:50:00',2.68),('8998','2013-10-02','11:55:00',2.68),('8998','2013-10-02','12:00:00',2.66),('8998','2013-10-02','12:05:00',2.65),('8998','2013-10-02','12:10:00',2.63),('8998','2013-10-02','12:15:00',2.6),('8998','2013-10-02','12:20:00',2.57),('8998','2013-10-02','12:25:00',2.57),('8998','2013-10-02','12:30:00',2.57),('8998','2013-10-02','12:35:00',2.55),('8998','2013-10-02','12:40:00',2.53),('8998','2013-10-02','12:45:00',2.5),('8998','2013-10-02','12:50:00',2.48),('8998','2013-10-02','12:55:00',2.46),('8998','2013-10-02','13:00:00',2.42),('8998','2013-10-02','13:05:00',2.37),('8998','2013-10-02','13:10:00',2.36),('8998','2013-10-02','13:15:00',2.33),('8998','2013-10-02','13:20:00',2.3),('8998','2013-10-02','13:25:00',2.26),('8998','2013-10-02','13:30:00',2.24),('8998','2013-10-02','13:35:00',2.21),('8998','2013-10-02','13:40:00',2.18),('8998','2013-10-02','13:45:00',2.13),('8998','2013-10-02','13:50:00',2.09),('8998','2013-10-02','13:55:00',2.06),('8998','2013-10-02','14:00:00',2.03),('8998','2013-10-02','14:05:00',1.99),('8998','2013-10-02','14:10:00',1.94),('8998','2013-10-02','14:15:00',1.89),('8998','2013-10-02','14:20:00',1.85),('8998','2013-10-02','14:25:00',1.8),('8998','2013-10-02','14:30:00',1.75),('8998','2013-10-02','14:35:00',1.7),('8998','2013-10-02','14:40:00',1.65),('8998','2013-10-02','14:45:00',1.59),('8998','2013-10-02','14:50:00',1.52),('8998','2013-10-02','14:55:00',1.45),('8998','2013-10-02','15:00:00',1.4),('8998','2013-10-02','15:05:00',1.32),('8998','2013-10-02','15:10:00',1.24),('8998','2013-10-02','15:15:00',1.18),('8998','2013-10-02','15:20:00',1.11),('8998','2013-10-02','15:25:00',1),('8998','2013-10-01','08:35:00',1.08),('8998','2013-10-01','08:40:00',1.4),('8998','2013-10-01','08:45:00',1.49),('8998','2013-10-01','08:50:00',1.59),('8998','2013-10-01','08:55:00',1.67),('8998','2013-10-01','09:00:00',1.73),('8998','2013-10-01','09:05:00',1.77),('8998','2013-10-01','09:10:00',1.83),('8998','2013-10-01','09:15:00',1.88),('8998','2013-10-01','09:20:00',1.94),('8998','2013-10-01','09:25:00',2.01),('8998','2013-10-01','09:30:00',2.05),('8998','2013-10-01','09:35:00',2.1),('8998','2013-10-01','09:40:00',2.13),('8998','2013-10-01','09:45:00',2.16),('8998','2013-10-01','09:50:00',2.19),('8998','2013-10-01','09:55:00',2.22),('8998','2013-10-01','10:00:00',2.24),('8998','2013-10-01','10:05:00',2.27),('8998','2013-10-01','10:10:00',2.29),('8998','2013-10-01','10:15:00',2.31),('8998','2013-10-01','10:20:00',2.35),('8998','2013-10-01','10:25:00',2.38),('8998','2013-10-01','10:30:00',2.4),('8998','2013-10-01','10:35:00',2.43),('8998','2013-10-01','10:40:00',2.47),('8998','2013-10-01','10:45:00',2.49),('8998','2013-10-01','10:50:00',2.51),('8998','2013-10-01','10:55:00',2.52),('8998','2013-10-01','11:00:00',2.54),('8998','2013-10-01','11:05:00',2.55),('8998','2013-10-01','11:10:00',2.56),('8998','2013-10-01','11:15:00',2.57),('8998','2013-10-01','11:20:00',2.58),('8998','2013-10-01','11:25:00',2.57),('8998','2013-10-01','11:30:00',2.57),('8998','2013-10-01','11:35:00',2.57),('8998','2013-10-01','11:40:00',2.58),('8998','2013-10-01','11:45:00',2.58),('8998','2013-10-01','11:50:00',2.58),('8998','2013-10-01','11:55:00',2.56),('8998','2013-10-01','12:00:00',2.56),('8998','2013-10-01','12:05:00',2.54),('8998','2013-10-01','12:10:00',2.54),('8998','2013-10-01','12:15:00',2.53),('8998','2013-10-01','12:20:00',2.51),('8998','2013-10-01','12:25:00',2.49),('8998','2013-10-01','12:30:00',2.47),('8998','2013-10-01','12:35:00',2.46),('8998','2013-10-01','12:40:00',2.43),('8998','2013-10-01','12:45:00',2.42),('8998','2013-10-01','12:50:00',2.41),('8998','2013-10-01','12:55:00',2.38),('8998','2013-10-01','13:00:00',2.36),('8998','2013-10-01','13:05:00',2.34),('8998','2013-10-01','13:10:00',2.31),('8998','2013-10-01','13:15:00',2.28),('8998','2013-10-01','13:20:00',2.25),('8998','2013-10-01','13:25:00',2.23),('8998','2013-10-01','13:30:00',2.2),('8998','2013-10-01','13:35:00',2.16),('8998','2013-10-01','13:40:00',2.13),('8998','2013-10-01','13:45:00',2.1),('8998','2013-10-01','13:50:00',2.06),('8998','2013-10-01','13:55:00',2.01),('8998','2013-10-01','14:00:00',1.98),('8998','2013-10-01','14:05:00',1.93),('8998','2013-10-01','14:10:00',1.89),('8998','2013-10-01','14:15:00',1.85),('8998','2013-10-01','14:20:00',1.8),('8998','2013-10-01','14:25:00',1.76),('8998','2013-10-01','14:30:00',1.71),('8998','2013-10-01','14:35:00',1.67),('8998','2013-10-01','14:40:00',1.61),('8998','2013-10-01','14:45:00',1.56),('8998','2013-10-01','14:50:00',1.5),('8998','2013-10-01','14:55:00',1.43),('8998','2013-10-01','15:00:00',1.38),('8998','2013-10-01','15:05:00',1.33),('8998','2013-10-01','15:10:00',1.24),('8998','2013-10-01','15:15:00',1.17),('8998','2013-10-01','15:20:00',1.11),('8998','2013-10-01','15:25:00',1),('8998','2013-09-30','08:40:00',1.25),('8998','2013-09-30','08:45:00',1.56),('8998','2013-09-30','08:50:00',1.63),('8998','2013-09-30','08:55:00',1.7),('8998','2013-09-30','09:00:00',1.74),('8998','2013-09-30','09:05:00',1.78),('8998','2013-09-30','09:10:00',1.81),('8998','2013-09-30','09:15:00',1.85),('8998','2013-09-30','09:20:00',1.9),('8998','2013-09-30','09:25:00',1.96),('8998','2013-09-30','09:30:00',2),('8998','2013-09-30','09:35:00',2.02),('8998','2013-09-30','09:40:00',2.05),('8998','2013-09-30','09:45:00',2.09),('8998','2013-09-30','09:50:00',2.13),('8998','2013-09-30','09:55:00',2.16),('8998','2013-09-30','10:00:00',2.19),('8998','2013-09-30','10:05:00',2.21),('8998','2013-09-30','10:10:00',2.25),('8998','2013-09-30','10:15:00',2.27),('8998','2013-09-30','10:20:00',2.3),('8998','2013-09-30','10:25:00',2.33),('8998','2013-09-30','10:30:00',2.37),('8998','2013-09-30','10:35:00',2.38),('8998','2013-09-30','10:40:00',2.39),('8998','2013-09-30','10:45:00',2.4),('8998','2013-09-30','10:50:00',2.41),('8998','2013-09-30','10:55:00',2.41),('8998','2013-09-30','11:00:00',2.44),('8998','2013-09-30','11:05:00',1.7),('8998','2013-09-30','11:10:00',2.68),('8998','2013-09-30','11:15:00',1.35),('8998','2013-09-30','11:20:00',2.48),('8998','2013-09-30','11:25:00',2.01),('8998','2013-09-30','11:30:00',2.59),('8998','2013-09-30','11:35:00',1.53),('8998','2013-09-30','11:40:00',2.59),('8998','2013-09-30','11:45:00',2.69),('8998','2013-09-30','11:50:00',2.67),('8998','2013-09-30','11:55:00',2.67),('8998','2013-09-30','12:00:00',2.44),('8998','2013-09-30','12:10:00',2.38),('8998','2013-09-30','12:15:00',2.51),('8998','2013-09-30','12:20:00',2.63),('8998','2013-09-30','12:25:00',2.64),('8998','2013-09-30','12:30:00',2.7),('8998','2013-09-30','12:35:00',2.67),('8998','2013-09-30','12:40:00',1.66),('8998','2013-09-30','12:45:00',2.12),('8998','2013-09-30','12:50:00',2.45),('8998','2013-09-30','12:55:00',2.41),('8998','2013-09-30','13:00:00',2.34),('8998','2013-09-30','13:05:00',2.41),('8998','2013-09-30','13:20:00',2.47),('8998','2013-09-30','13:25:00',2.5),('8998','2013-09-30','13:30:00',1.95),('8998','2013-09-30','13:35:00',2.15),('8998','2013-09-30','13:40:00',1.39),('8998','2013-09-30','13:45:00',1.75),('8998','2013-09-30','13:55:00',1.18),('8998','2013-09-30','14:00:00',2.05),('8998','2013-09-30','14:05:00',1.95),('8998','2013-09-30','14:10:00',1.89),('8998','2013-09-30','14:15:00',1.85),('8998','2013-09-30','14:20:00',1.81),('8998','2013-09-30','14:25:00',1.76),('8998','2013-09-30','14:30:00',1.71),('8998','2013-09-30','14:35:00',1.66),('8998','2013-09-30','14:40:00',1.64),('8998','2013-09-30','14:45:00',1.63),('8998','2013-09-30','14:50:00',1.62),('8998','2013-09-30','14:55:00',1.55),('8998','2013-09-30','15:00:00',1.46),('8998','2013-09-30','15:05:00',1.38),('8998','2013-09-30','15:10:00',1.28),('8998','2013-09-30','15:15:00',1.19),('8998','2013-09-30','15:20:00',1.13),('8998','2013-09-30','15:25:00',1.02),('8998','2013-09-29','10:25:00',1.03),('8998','2013-09-29','10:30:00',1.2),('8998','2013-09-29','10:35:00',1.38),('8998','2013-09-29','10:40:00',1.72),('8998','2013-09-29','10:45:00',2.59),('8998','2013-09-29','10:50:00',2.69),('8998','2013-09-29','10:55:00',2.43),('8998','2013-09-29','11:00:00',2.13),('8998','2013-09-29','11:05:00',2.44),('8998','2013-09-29','11:10:00',2.36),('8998','2013-09-29','11:15:00',2.04),('8998','2013-09-29','11:20:00',1.81),('8998','2013-09-29','11:25:00',2.14),('8998','2013-09-29','11:30:00',1.25),('8998','2013-09-29','11:35:00',1.29),('8998','2013-09-29','11:40:00',2.07),('8998','2013-09-29','11:45:00',1.46),('8998','2013-09-29','11:50:00',1.27),('8998','2013-09-29','11:55:00',1.03),('8998','2013-09-29','12:00:00',1.22),('8998','2013-09-29','12:05:00',2.26),('8998','2013-09-29','12:10:00',1.86),('8998','2013-09-29','12:15:00',2.66),('8998','2013-09-29','12:20:00',2.76),('8998','2013-09-29','12:25:00',2.76),('8998','2013-09-29','12:30:00',2.57),('8998','2013-09-29','12:35:00',2.49),('8998','2013-09-29','12:40:00',2.56),('8998','2013-09-29','12:45:00',1.88),('8998','2013-09-29','12:50:00',2.52),('8998','2013-09-29','12:55:00',2.49),('8998','2013-09-29','13:00:00',2.46),('8998','2013-09-29','13:05:00',2.01),('8998','2013-09-29','13:10:00',2.56),('8998','2013-09-29','13:15:00',2.14),('8998','2013-09-29','13:20:00',2.63),('8998','2013-09-29','13:25:00',2.78),('8998','2013-09-29','13:30:00',2.78),('8998','2013-09-29','13:35:00',2.11),('8998','2013-09-29','13:40:00',1.67),('8998','2013-09-29','13:45:00',1.04),('8998','2013-09-29','13:50:00',1.78),('8998','2013-09-29','13:55:00',1.47),('8998','2013-09-29','14:30:00',1.36),('8998','2013-09-29','14:35:00',1.73),('8998','2013-09-29','14:40:00',2.15),('8998','2013-09-29','14:45:00',1.62),('8998','2013-09-29','14:50:00',1.86),('8998','2013-09-29','14:55:00',1.21),('8998','2013-09-29','15:00:00',1.42),('8998','2013-09-29','15:05:00',1.28),('8998','2013-09-29','15:10:00',1.41),('8998','2013-09-29','15:15:00',1.07),('8998','2013-09-29','15:25:00',1.25),('8998','2013-09-29','15:40:00',1.23),('8998','2013-09-28','09:15:00',1.05),('8998','2013-09-28','10:00:00',1.01),('8998','2013-09-28','10:05:00',1.4),('8998','2013-09-28','10:10:00',1.6),('8998','2013-09-28','10:15:00',2.06),('8998','2013-09-28','10:20:00',1.79),('8998','2013-09-28','10:25:00',1.64),('8998','2013-09-28','10:30:00',1.91),('8998','2013-09-28','10:35:00',2.07),('8998','2013-09-28','10:40:00',2.24),('8998','2013-09-28','10:45:00',2.12),('8998','2013-09-28','10:50:00',2.2),('8998','2013-09-28','10:55:00',2.15),('8998','2013-09-28','11:00:00',2.18),('8998','2013-09-28','11:05:00',2.08),('8998','2013-09-28','11:10:00',2.05),('8998','2013-09-28','11:15:00',2.22),('8998','2013-09-28','11:20:00',2.21),('8998','2013-09-28','11:25:00',2.06),('8998','2013-09-28','11:30:00',2.21),('8998','2013-09-28','11:35:00',2.18),('8998','2013-09-28','11:40:00',2.24),('8998','2013-09-28','11:45:00',2.21),('8998','2013-09-28','11:50:00',2.35),('8998','2013-09-28','11:55:00',2.29),('8998','2013-09-28','12:00:00',2.13),('8998','2013-09-28','12:05:00',2.26),('8998','2013-09-28','12:10:00',2.24),('8998','2013-09-28','12:15:00',2.45),('8998','2013-09-28','12:20:00',2.08),('8998','2013-09-28','12:25:00',1.4),('8998','2013-09-28','12:30:00',1.42),('8998','2013-09-28','12:35:00',1.35),('8998','2013-09-28','12:40:00',1.17),('8998','2013-09-28','12:45:00',1.06),('8998','2013-09-28','12:50:00',1.08),('8998','2013-09-28','13:30:00',1.51),('8998','2013-09-28','13:35:00',1.09),('8998','2013-09-28','13:40:00',1.09),('8998','2013-09-28','13:45:00',1),('8998','2013-09-28','13:50:00',1.03),('8998','2013-09-28','13:55:00',1.37),('8998','2013-09-28','14:00:00',1.24),('8998','2013-09-28','14:05:00',1.49),('8998','2013-09-28','14:10:00',1.04),('8998','2013-09-28','14:15:00',1.04),('8998','2013-09-28','14:20:00',1.41),('8998','2013-09-28','14:25:00',1.02),('8998','2014-04-13','08:00:00',1.02),('8998','2014-04-13','08:05:00',1.31),('8998','2014-04-13','08:10:00',1.45),('8998','2014-04-13','08:15:00',1.54),('8998','2014-04-13','08:20:00',1.52),('8998','2014-04-13','08:25:00',1.38),('8998','2014-04-13','08:30:00',1.41),('8998','2014-04-13','08:35:00',1.66),('8998','2014-04-13','08:40:00',1.76),('8998','2014-04-13','08:45:00',1.97),('8998','2014-04-13','08:50:00',2.04),('8998','2014-04-13','08:55:00',2.08),('8998','2014-04-13','09:00:00',2.16),('8998','2014-04-13','09:05:00',2.22),('8998','2014-04-13','09:10:00',2.27),('8998','2014-04-13','09:15:00',2.31),('8998','2014-04-13','09:20:00',2.34),('8998','2014-04-13','09:25:00',2.38),('8998','2014-04-13','09:30:00',2.46),('8998','2014-04-13','09:35:00',2.49),('8998','2014-04-13','09:40:00',2.51),('8998','2014-04-13','09:45:00',2.56),('8998','2014-04-13','09:50:00',2.6),('8998','2014-04-13','09:55:00',2.64),('8998','2014-04-13','10:00:00',2.68),('8998','2014-04-13','10:05:00',2.71),('8998','2014-04-13','10:10:00',2.75),('8998','2014-04-13','10:15:00',2.77),('8998','2014-04-13','10:20:00',2.8),('8998','2014-04-13','10:25:00',2.82),('8998','2014-04-13','10:30:00',2.83),('8998','2014-04-13','10:35:00',2.86),('8998','2014-04-13','10:40:00',2.87),('8998','2014-04-13','10:45:00',2.88),('8998','2014-04-13','10:50:00',2.9),('8998','2014-04-13','10:55:00',2.92),('8998','2014-04-13','11:00:00',2.93),('8998','2014-04-13','11:05:00',2.94),('8998','2014-04-13','11:10:00',2.94),('8998','2014-04-13','11:15:00',2.96),('8998','2014-04-13','11:20:00',2.96),('8998','2014-04-13','11:25:00',2.96),('8998','2014-04-13','11:30:00',2.95),('8998','2014-04-13','11:35:00',2.96),('8998','2014-04-13','11:40:00',2.97),('8998','2014-04-13','11:45:00',2.95),('8998','2014-04-13','11:50:00',2.95),('8998','2014-04-13','11:55:00',2.96),('8998','2014-04-13','12:00:00',2.96),('8998','2014-04-13','12:05:00',2.95),('8998','2014-04-13','12:10:00',2.95),('8998','2014-04-13','12:15:00',2.99),('8998','2014-04-13','12:20:00',2.97),('8998','2014-04-13','12:25:00',2.95),('8998','2014-04-13','12:30:00',2.96),('8998','2014-04-13','12:35:00',2.94),('8998','2014-04-13','12:40:00',2.92),('8998','2014-04-13','12:45:00',2.91),('8998','2014-04-13','12:50:00',2.89),('8998','2014-04-13','12:55:00',2.86),('8998','2014-04-13','13:00:00',2.84),('8998','2014-04-13','13:05:00',2.82),('8998','2014-04-13','13:10:00',2.8),('8998','2014-04-13','13:15:00',2.75),('8998','2014-04-13','13:20:00',2.74),('8998','2014-04-13','13:25:00',2.72),('8998','2014-04-13','13:30:00',2.72),('8998','2014-04-13','13:35:00',2.69),('8998','2014-04-13','13:40:00',2.66),('8998','2014-04-13','13:45:00',2.63),('8998','2014-04-13','13:50:00',2.6),('8998','2014-04-13','13:55:00',2.58),('8998','2014-04-13','14:00:00',2.56),('8998','2014-04-13','14:05:00',2.51),('8998','2014-04-13','14:10:00',2.49),('8998','2014-04-13','14:15:00',2.47),('8998','2014-04-13','14:20:00',2.41),('8998','2014-04-13','14:25:00',2.38),('8998','2014-04-13','14:30:00',2.34),('8998','2014-04-13','14:35:00',2.29),('8998','2014-04-13','14:40:00',2.26),('8998','2014-04-13','14:45:00',2.21),('8998','2014-04-13','14:50:00',2.16),('8998','2014-04-13','14:55:00',2.11),('8998','2014-04-13','15:00:00',2.07),('8998','2014-04-13','15:05:00',2.02),('8998','2014-04-13','15:10:00',1.97),('8998','2014-04-13','15:15:00',1.92),('8998','2014-04-13','15:20:00',1.86),('8998','2014-04-13','15:25:00',1.8),('8998','2014-04-13','15:30:00',1.75),('8998','2014-04-13','15:35:00',1.7),('8998','2014-04-13','15:40:00',1.65),('8998','2014-04-13','15:45:00',1.58),('8998','2014-04-13','15:50:00',1.53),('8998','2014-04-13','15:55:00',1.46),('8998','2014-04-13','16:00:00',1.4),('8998','2014-04-13','16:05:00',1.34),('8998','2014-04-13','16:10:00',1.28),('8998','2014-04-13','16:15:00',1.22),('8998','2014-04-13','16:20:00',1.16),('8998','2014-04-13','16:25:00',1.09),('8998','2014-04-13','16:30:00',1.03),('8998','2013-09-27','08:35:00',1.05),('8998','2013-09-27','08:40:00',1.32),('8998','2013-09-27','08:45:00',1.38),('8998','2013-09-27','08:50:00',1.42),('8998','2013-09-27','08:55:00',1.5),('8998','2013-09-27','09:00:00',1.53),('8998','2013-09-27','09:05:00',1.6),('8998','2013-09-27','09:10:00',1.68),('8998','2013-09-27','09:15:00',1.74),('8998','2013-09-27','09:20:00',1.8),('8998','2013-09-27','09:25:00',1.87),('8998','2013-09-27','09:30:00',1.92),('8998','2013-09-27','09:35:00',1.96),('8998','2013-09-27','09:40:00',2.02),('8998','2013-09-27','09:45:00',2.05),('8998','2013-09-27','09:50:00',2.11),('8998','2013-09-27','09:55:00',2.16),('8998','2013-09-27','10:00:00',1.13),('8998','2013-09-27','10:05:00',1.4),('8998','2013-09-27','10:10:00',1.21),('8998','2013-09-27','10:35:00',2.13),('8998','2013-09-27','10:40:00',1.71),('8998','2013-09-27','10:45:00',2.09),('8998','2013-09-27','10:50:00',2.44),('8998','2013-09-27','10:55:00',2.68),('8998','2013-09-27','11:00:00',1.33),('8998','2013-09-27','11:15:00',1.13),('8998','2013-09-27','11:20:00',1.87),('8998','2013-09-27','11:25:00',2.68),('8998','2013-09-27','11:30:00',2.79),('8998','2013-09-27','11:35:00',2.24),('8998','2013-09-27','11:40:00',1.58),('8998','2013-09-27','12:00:00',1.06),('8998','2013-09-27','12:05:00',2.73),('8998','2013-09-27','12:10:00',2.68),('8998','2013-09-27','12:15:00',2.11),('8998','2013-09-27','12:20:00',1.44),('8998','2013-09-27','12:25:00',2.49),('8998','2013-09-27','12:35:00',1.68),('8998','2013-09-27','12:40:00',2.16),('8998','2013-09-27','12:50:00',2.14),('8998','2013-09-27','12:55:00',2.46),('8998','2013-09-27','13:00:00',1.24),('8998','2013-09-27','13:05:00',2.35),('8998','2013-09-27','13:30:00',1.93),('8998','2013-09-27','13:35:00',1.09),('8998','2013-09-27','13:45:00',1.05),('8998','2013-09-27','13:50:00',1.37),('8998','2013-09-27','14:20:00',1.13),('8998','2013-09-27','14:25:00',2.26),('8998','2013-09-27','14:30:00',1.69),('8998','2013-09-27','14:35:00',1.38),('8998','2013-09-27','14:40:00',2.06),('8998','2013-09-27','14:45:00',1.95),('8998','2013-09-27','14:50:00',1.71),('8998','2013-09-27','15:00:00',1.5),('8998','2013-09-27','15:05:00',1.67),('8998','2013-09-27','15:10:00',1.28),('8998','2013-09-27','15:15:00',1.61),('8998','2013-09-27','15:20:00',1.53),('8998','2013-09-27','15:25:00',1.51),('8998','2013-09-27','15:30:00',1.39),('8998','2013-09-27','15:35:00',1.22),('8998','2013-09-27','15:40:00',1.19),('8998','2013-09-27','15:45:00',1.04),('8998','2013-09-26','08:35:00',1.28),('8998','2013-09-26','08:40:00',1.31),('8998','2013-09-26','08:45:00',1.36),('8998','2013-09-26','08:50:00',1.29),('8998','2013-09-26','08:55:00',1.54),('8998','2013-09-26','09:00:00',1.27),('8998','2013-09-26','09:55:00',1.1),('8998','2013-09-26','10:00:00',1.1),('8998','2013-09-26','10:05:00',1.77),('8998','2013-09-26','10:10:00',1.7),('8998','2013-09-26','10:15:00',1.2),('8998','2013-09-26','10:20:00',1.73),('8998','2013-09-26','10:25:00',1.35),('8998','2013-09-26','10:30:00',1.69),('8998','2013-09-26','10:45:00',1.15),('8998','2013-09-26','10:50:00',2.19),('8998','2013-09-26','10:55:00',2.36),('8998','2013-09-26','11:00:00',2.4),('8998','2013-09-26','11:05:00',2.37),('8998','2013-09-26','11:10:00',2.14),('8998','2013-09-26','11:15:00',2.38),('8998','2013-09-26','11:20:00',2.29),('8998','2013-09-26','11:25:00',2.25),('8998','2013-09-26','11:30:00',2.28),('8998','2013-09-26','11:45:00',1.62),('8998','2013-09-26','12:00:00',2.2),('8998','2013-09-26','12:05:00',1.34),('8998','2013-09-26','12:10:00',2.12),('8998','2013-09-26','12:15:00',2.03),('8998','2013-09-26','12:45:00',1.03),('8998','2013-09-26','12:50:00',2.38),('8998','2013-09-26','12:55:00',2.32),('8998','2013-09-26','13:00:00',2.31),('8998','2013-09-26','13:05:00',2.29),('8998','2013-09-26','13:10:00',2.29),('8998','2013-09-26','13:15:00',1.11),('8998','2013-09-26','13:20:00',2.24),('8998','2013-09-26','13:25:00',1.99),('8998','2013-09-26','13:45:00',1.72),('8998','2013-09-26','13:50:00',1.04),('8998','2013-09-26','14:05:00',1.89),('8998','2013-09-26','14:10:00',1.75),('8998','2013-09-26','14:15:00',1.82),('8998','2013-09-26','14:20:00',2.01),('8998','2013-09-26','14:25:00',1.9),('8998','2013-09-26','14:30:00',1.86),('8998','2013-09-26','14:35:00',1.77),('8998','2013-09-26','14:40:00',1.73),('8998','2013-09-26','14:45:00',1.63),('8998','2013-09-26','14:50:00',1.43),('8998','2013-09-26','14:55:00',1.45),('8998','2013-09-26','15:00:00',1.15),('8998','2013-09-26','15:05:00',1.15),('8998','2013-09-26','15:15:00',1.32),('8998','2013-09-26','15:25:00',1.12),('8998','2013-09-26','15:30:00',1.12),('8998','2013-09-25','08:40:00',1.4),('8998','2013-09-25','08:45:00',1.51),('8998','2013-09-25','08:50:00',1.57),('8998','2013-09-25','08:55:00',1.65),('8998','2013-09-25','09:00:00',1.73),('8998','2013-09-25','09:05:00',1.78),('8998','2013-09-25','09:10:00',1.84),('8998','2013-09-25','09:15:00',1.88),('8998','2013-09-25','09:20:00',1.96),('8998','2013-09-25','09:25:00',1.99),('8998','2013-09-25','09:30:00',2.04),('8998','2013-09-25','09:35:00',2.07),('8998','2013-09-25','09:40:00',2.09),('8998','2013-09-25','09:45:00',2.13),('8998','2013-09-25','09:50:00',2.14),('8998','2013-09-25','09:55:00',2.15),('8998','2013-09-25','10:00:00',2.21),('8998','2013-09-25','10:05:00',2.21),('8998','2013-09-25','10:10:00',2.22),('8998','2013-09-25','10:15:00',2.27),('8998','2013-09-25','10:20:00',2.27),('8998','2013-09-25','10:25:00',2.29),('8998','2013-09-25','10:30:00',2.29),('8998','2013-09-25','10:35:00',2.31),('8998','2013-09-25','10:40:00',2.31),('8998','2013-09-25','10:45:00',2.08),('8998','2013-09-25','10:50:00',2.38),('8998','2013-09-25','10:55:00',2.41),('8998','2013-09-25','11:00:00',2.41),('8998','2013-09-25','11:05:00',2.35),('8998','2013-09-25','11:10:00',2.4),('8998','2013-09-25','11:15:00',2.39),('8998','2013-09-25','11:20:00',2.42),('8998','2013-09-25','11:25:00',2.46),('8998','2013-09-25','11:30:00',2.43),('8998','2013-09-25','11:35:00',2.49),('8998','2013-09-25','11:40:00',2.17),('8998','2013-09-25','11:45:00',1.94),('8998','2013-09-25','11:50:00',2.44),('8998','2013-09-25','11:55:00',2.11),('8998','2013-09-25','12:00:00',1.59),('8998','2013-09-25','12:05:00',1.99),('8998','2013-09-25','12:20:00',1.18),('8998','2013-09-25','12:40:00',1.15),('8998','2013-09-25','12:45:00',1.29),('8998','2013-09-25','12:50:00',1.15),('8998','2013-09-25','12:55:00',1.47),('8998','2013-09-25','13:00:00',2.16),('8998','2013-09-25','13:05:00',1.43),('8998','2013-09-25','13:10:00',1.01),('8998','2013-09-25','13:15:00',2.09),('8998','2013-09-25','13:20:00',2.56),('8998','2013-09-25','13:25:00',2.12),('8998','2013-09-25','13:30:00',1.42),('8998','2013-09-25','13:35:00',1.36),('8998','2013-09-25','13:40:00',1.01),('8998','2013-09-25','13:55:00',1.18),('8998','2013-09-25','14:00:00',1.28),('8998','2013-09-25','14:05:00',1.61),('8998','2013-09-25','14:10:00',2.3),('8998','2013-09-25','14:15:00',2.17),('8998','2013-09-25','14:20:00',2),('8998','2013-09-25','14:25:00',1.28),('8998','2013-09-25','14:35:00',1.17),('8998','2013-09-25','14:40:00',1.26),('8998','2013-09-25','14:45:00',1.4),('8998','2013-09-25','14:50:00',2),('8998','2013-09-25','14:55:00',1.41),('8998','2013-09-25','15:25:00',1.35),('8998','2013-09-25','15:45:00',1.04),('8998','2013-09-25','15:50:00',1.1),('8998','2013-09-24','08:50:00',1.06),('8998','2013-09-24','09:10:00',1.6),('8998','2013-09-24','09:15:00',1.58),('8998','2013-09-24','09:25:00',1.08),('8998','2013-09-24','09:30:00',1.72),('8998','2013-09-24','09:35:00',1.6),('8998','2013-09-24','09:40:00',2.05),('8998','2013-09-24','09:45:00',1.9),('8998','2013-09-24','09:50:00',1.55),('8998','2013-09-24','09:55:00',1.25),('8998','2013-09-24','10:00:00',2.47),('8998','2013-09-24','10:05:00',1.63),('8998','2013-09-24','10:25:00',1.3),('8998','2013-09-24','10:30:00',1.22),('8998','2013-09-24','10:45:00',2.35),('8998','2013-09-24','10:50:00',2.83),('8998','2013-09-24','10:55:00',2.95),('8998','2013-09-24','11:00:00',2.24),('8998','2013-09-24','11:10:00',1.16),('8998','2013-09-24','11:15:00',1.06),('8998','2013-09-24','11:25:00',1.5),('8998','2013-09-24','11:30:00',2.67),('8998','2013-09-24','11:35:00',2.63),('8998','2013-09-24','11:40:00',2.4),('8998','2013-09-24','11:45:00',2.6),('8998','2013-09-24','11:50:00',1.81),('8998','2013-09-24','11:55:00',1.42),('8998','2013-09-24','12:00:00',1.7),('8998','2013-09-24','12:15:00',2.29),('8998','2013-09-24','12:20:00',2.62),('8998','2013-09-24','12:25:00',2.56),('8998','2013-09-24','12:30:00',1.85),('8998','2013-09-24','12:35:00',2.57),('8998','2013-09-24','12:40:00',2.67),('8998','2013-09-24','12:45:00',1.14),('8998','2013-09-24','13:35:00',2.12),('8998','2013-09-24','13:40:00',1.73),('8998','2013-09-24','13:45:00',2.52),('8998','2013-09-24','13:50:00',2.55),('8998','2013-09-24','13:55:00',2.45),('8998','2013-09-24','14:00:00',1.09),('8998','2013-09-24','14:35:00',1.02),('8998','2013-09-24','14:40:00',1.67),('8998','2013-09-24','14:45:00',1.69),('8998','2013-09-24','14:50:00',1.29),('8998','2013-09-24','14:55:00',1.87),('8998','2013-09-24','15:00:00',1.45),('8998','2013-09-24','15:05:00',1.86),('8998','2013-09-24','15:10:00',1.71),('8998','2013-09-24','15:15:00',1.59),('8998','2013-09-24','15:20:00',1.47),('8998','2013-09-24','15:25:00',1.32),('8998','2013-09-24','15:30:00',1.29),('8998','2013-09-24','15:35:00',1.06),('8998','2013-09-24','15:40:00',1.29),('8998','2013-09-24','15:45:00',1.1),('8998','2013-09-23','08:30:00',1.39),('8998','2013-09-23','08:35:00',1.53),('8998','2013-09-23','08:40:00',1.59),('8998','2013-09-23','08:45:00',1.64),('8998','2013-09-23','08:50:00',1.69),('8998','2013-09-23','08:55:00',1.75),('8998','2013-09-23','09:00:00',1.82),('8998','2013-09-23','09:05:00',1.87),('8998','2013-09-23','09:10:00',1.94),('8998','2013-09-23','09:15:00',1.99),('8998','2013-09-23','09:20:00',2.05),('8998','2013-09-23','09:25:00',2.1),('8998','2013-09-23','09:30:00',2.15),('8998','2013-09-23','09:35:00',2.18),('8998','2013-09-23','09:40:00',2.21),('8998','2013-09-23','09:45:00',2.24),('8998','2013-09-23','09:50:00',2.26),('8998','2013-09-23','09:55:00',2.28),('8998','2013-09-23','10:00:00',2.29),('8998','2013-09-23','10:05:00',2.33),('8998','2013-09-23','10:10:00',2.37),('8998','2013-09-23','10:15:00',2.41),('8998','2013-09-23','10:20:00',2.43),('8998','2013-09-23','10:25:00',2.45),('8998','2013-09-23','10:30:00',2.48),('8998','2013-09-23','10:35:00',2.48),('8998','2013-09-23','10:40:00',2.49),('8998','2013-09-23','10:45:00',2.52),('8998','2013-09-23','10:50:00',2.53),('8998','2013-09-23','10:55:00',2.53),('8998','2013-09-23','11:00:00',2.54),('8998','2013-09-23','11:05:00',2.55),('8998','2013-09-23','11:10:00',2.54),('8998','2013-09-23','11:15:00',2.55),('8998','2013-09-23','11:20:00',2.55),('8998','2013-09-23','11:25:00',2.55),('8998','2013-09-23','11:30:00',2.55),('8998','2013-09-23','11:35:00',2.55),('8998','2013-09-23','11:40:00',2.56),('8998','2013-09-23','11:45:00',2.55),('8998','2013-09-23','11:50:00',2.55),('8998','2013-09-23','11:55:00',2.55),('8998','2013-09-23','12:00:00',2.54),('8998','2013-09-23','12:05:00',2.53),('8998','2013-09-23','12:10:00',2.52),('8998','2013-09-23','12:15:00',2.5),('8998','2013-09-23','12:20:00',2.49),('8998','2013-09-23','12:25:00',2.46),('8998','2013-09-23','12:30:00',2.44),('8998','2013-09-23','12:35:00',2.43),('8998','2013-09-23','12:40:00',2.44),('8998','2013-09-23','12:45:00',2.44),('8998','2013-09-23','12:50:00',2.43),('8998','2013-09-23','12:55:00',2.39),('8998','2013-09-23','13:00:00',2.35),('8998','2013-09-23','13:05:00',2.36),('8998','2013-09-23','13:10:00',2.33),('8998','2013-09-23','13:15:00',2.31),('8998','2013-09-23','13:20:00',2.29),('8998','2013-09-23','13:25:00',2.25),('8998','2013-09-23','13:30:00',2.23),('8998','2013-09-23','13:35:00',2.18),('8998','2013-09-23','13:40:00',2.16),('8998','2013-09-23','13:45:00',2.15),('8998','2013-09-23','13:50:00',2.12);
INSERT INTO `solarlogmod` VALUES ('8998','2013-09-23','13:55:00',2.07),('8998','2013-09-23','14:00:00',2.03),('8998','2013-09-23','14:05:00',2),('8998','2013-09-23','14:10:00',1.96),('8998','2013-09-23','14:15:00',1.91),('8998','2013-09-23','14:20:00',1.87),('8998','2013-09-23','14:25:00',1.83),('8998','2013-09-23','14:30:00',1.8),('8998','2013-09-23','14:35:00',1.75),('8998','2013-09-23','14:40:00',1.71),('8998','2013-09-23','14:45:00',1.65),('8998','2013-09-23','14:50:00',1.6),('8998','2013-09-23','14:55:00',1.55),('8998','2013-09-23','15:00:00',1.49),('8998','2013-09-23','15:05:00',1.45),('8998','2013-09-23','15:10:00',1.41),('8998','2013-09-23','15:15:00',1.35),('8998','2013-09-23','15:20:00',1.3),('8998','2013-09-23','15:25:00',1.21),('8998','2013-09-23','15:30:00',1.17),('8998','2013-09-23','15:35:00',1.08),('8998','2013-09-23','15:40:00',1.03),('8998','2013-09-22','08:25:00',1.1),('8998','2013-09-22','08:30:00',1.45),('8998','2013-09-22','08:35:00',1.59),('8998','2013-09-22','08:40:00',1.64),('8998','2013-09-22','08:45:00',1.7),('8998','2013-09-22','08:50:00',1.75),('8998','2013-09-22','08:55:00',1.8),('8998','2013-09-22','09:00:00',1.89),('8998','2013-09-22','09:05:00',1.95),('8998','2013-09-22','09:10:00',1.99),('8998','2013-09-22','09:15:00',2.06),('8998','2013-09-22','09:20:00',2.12),('8998','2013-09-22','09:25:00',2.16),('8998','2013-09-22','09:30:00',2.2),('8998','2013-09-22','09:35:00',2.24),('8998','2013-09-22','09:40:00',2.27),('8998','2013-09-22','09:45:00',2.29),('8998','2013-09-22','09:50:00',2.32),('8998','2013-09-22','09:55:00',2.34),('8998','2013-09-22','10:00:00',2.38),('8998','2013-09-22','10:05:00',2.4),('8998','2013-09-22','10:10:00',2.43),('8998','2013-09-22','10:15:00',2.44),('8998','2013-09-22','10:20:00',2.46),('8998','2013-09-22','10:25:00',2.48),('8998','2013-09-22','10:30:00',2.49),('8998','2013-09-22','10:35:00',2.51),('8998','2013-09-22','10:40:00',2.53),('8998','2013-09-22','10:45:00',2.54),('8998','2013-09-22','10:50:00',2.57),('8998','2013-09-22','10:55:00',2.57),('8998','2013-09-22','11:00:00',2.57),('8998','2013-09-22','11:05:00',2.61),('8998','2013-09-22','11:10:00',2.62),('8998','2013-09-22','11:15:00',2.65),('8998','2013-09-22','11:20:00',2.66),('8998','2013-09-22','11:25:00',2.66),('8998','2013-09-22','11:30:00',2.67),('8998','2013-09-22','11:35:00',2.67),('8998','2013-09-22','11:40:00',2.66),('8998','2013-09-22','11:45:00',2.67),('8998','2013-09-22','11:50:00',2.66),('8998','2013-09-22','11:55:00',2.66),('8998','2013-09-22','12:00:00',2.65),('8998','2013-09-22','12:05:00',2.66),('8998','2013-09-22','12:10:00',2.68),('8998','2013-09-22','12:15:00',2.66),('8998','2013-09-22','12:20:00',2.63),('8998','2013-09-22','12:25:00',2.59),('8998','2013-09-22','12:30:00',2.56),('8998','2013-09-22','12:35:00',2.54),('8998','2013-09-22','12:40:00',2.53),('8998','2013-09-22','12:45:00',2.52),('8998','2013-09-22','12:50:00',2.49),('8998','2013-09-22','12:55:00',2.48),('8998','2013-09-22','13:00:00',2.46),('8998','2013-09-22','13:05:00',2.44),('8998','2013-09-22','13:10:00',2.42),('8998','2013-09-22','13:15:00',2.38),('8998','2013-09-22','13:20:00',2.33),('8998','2013-09-22','13:25:00',2.33),('8998','2013-09-22','13:30:00',2.29),('8998','2013-09-22','13:35:00',2.26),('8998','2013-09-22','13:40:00',2.22),('8998','2013-09-22','13:45:00',2.19),('8998','2013-09-22','13:50:00',2.16),('8998','2013-09-22','13:55:00',2.11),('8998','2013-09-22','14:00:00',2.06),('8998','2013-09-22','14:05:00',2),('8998','2013-09-22','14:10:00',1.97),('8998','2013-09-22','14:15:00',1.95),('8998','2013-09-22','14:20:00',1.9),('8998','2013-09-22','14:25:00',1.89),('8998','2013-09-22','14:30:00',1.91),('8998','2013-09-22','14:35:00',1.83),('8998','2013-09-22','14:40:00',1.76),('8998','2013-09-22','14:45:00',1.69),('8998','2013-09-22','14:50:00',1.63),('8998','2013-09-22','14:55:00',1.61),('8998','2013-09-22','15:00:00',1.56),('8998','2013-09-22','15:05:00',1.18),('8998','2013-09-22','15:10:00',1.04),('8998','2013-09-22','15:15:00',1.42),('8998','2013-09-22','15:20:00',1.35),('8998','2013-09-22','15:25:00',1.29),('8998','2013-09-22','15:30:00',1.17),('8998','2013-09-22','15:35:00',1.11),('8998','2013-09-22','15:40:00',1),('8998','2013-09-21','08:30:00',1.42),('8998','2013-09-21','08:35:00',1.52),('8998','2013-09-21','08:40:00',1.59),('8998','2013-09-21','08:45:00',1.65),('8998','2013-09-21','08:50:00',1.7),('8998','2013-09-21','08:55:00',1.77),('8998','2013-09-21','09:00:00',1.85),('8998','2013-09-21','09:05:00',1.91),('8998','2013-09-21','09:10:00',1.98),('8998','2013-09-21','09:15:00',2.08),('8998','2013-09-21','09:20:00',2.12),('8998','2013-09-21','09:25:00',2.17),('8998','2013-09-21','09:30:00',2.2),('8998','2013-09-21','09:35:00',2.24),('8998','2013-09-21','09:40:00',2.26),('8998','2013-09-21','09:45:00',2.29),('8998','2013-09-21','09:50:00',2.32),('8998','2013-09-21','09:55:00',2.36),('8998','2013-09-21','10:00:00',2.4),('8998','2013-09-21','10:05:00',2.45),('8998','2013-09-21','10:10:00',2.48),('8998','2013-09-21','10:15:00',2.5),('8998','2013-09-21','10:20:00',2.53),('8998','2013-09-21','10:25:00',2.54),('8998','2013-09-21','10:30:00',2.58),('8998','2013-09-21','10:35:00',2.61),('8998','2013-09-21','10:40:00',2.62),('8998','2013-09-21','10:45:00',2.62),('8998','2013-09-21','10:50:00',2.63),('8998','2013-09-21','10:55:00',2.63),('8998','2013-09-21','11:00:00',2.64),('8998','2013-09-21','11:05:00',2.63),('8998','2013-09-21','11:10:00',2.63),('8998','2013-09-21','11:15:00',2.64),('8998','2013-09-21','11:20:00',2.67),('8998','2013-09-21','11:25:00',2.68),('8998','2013-09-21','11:30:00',2.68),('8998','2013-09-21','11:35:00',2.7),('8998','2013-09-21','11:40:00',2.71),('8998','2013-09-21','11:45:00',2.72),('8998','2013-09-21','11:50:00',2.71),('8998','2013-09-21','11:55:00',2.71),('8998','2013-09-21','12:00:00',2.71),('8998','2013-09-21','12:05:00',2.71),('8998','2013-09-21','12:10:00',2.7),('8998','2013-09-21','12:15:00',2.67),('8998','2013-09-21','12:20:00',2.68),('8998','2013-09-21','12:25:00',2.65),('8998','2013-09-21','12:30:00',2.62),('8998','2013-09-21','12:35:00',2.61),('8998','2013-09-21','12:40:00',2.6),('8998','2013-09-21','12:45:00',2.55),('8998','2013-09-21','12:50:00',2.57),('8998','2013-09-21','12:55:00',2.59),('8998','2013-09-21','13:00:00',2.54),('8998','2013-09-21','13:05:00',2.51),('8998','2013-09-21','13:10:00',2.52),('8998','2013-09-21','13:15:00',2.46),('8998','2013-09-21','13:20:00',2.41),('8998','2013-09-21','13:25:00',2.38),('8998','2013-09-21','13:30:00',2.34),('8998','2013-09-21','13:35:00',2.3),('8998','2013-09-21','13:40:00',2.27),('8998','2013-09-21','13:45:00',2.25),('8998','2013-09-21','13:50:00',2.24),('8998','2013-09-21','13:55:00',2.06),('8998','2013-09-21','14:00:00',2.14),('8998','2013-09-21','14:05:00',2.15),('8998','2013-09-21','14:10:00',2.08),('8998','2013-09-21','14:15:00',2.11),('8998','2013-09-21','14:20:00',1.46),('8998','2013-09-21','14:25:00',1.9),('8998','2013-09-21','14:30:00',1.97),('8998','2013-09-21','14:35:00',1.9),('8998','2013-09-21','14:40:00',1.38),('8998','2013-09-21','14:45:00',1.6),('8998','2013-09-21','14:50:00',1.75),('8998','2013-09-21','14:55:00',1.7),('8998','2013-09-21','15:00:00',1.68),('8998','2013-09-21','15:05:00',1.71),('8998','2013-09-21','15:10:00',1.63),('8998','2013-09-21','15:15:00',1.71),('8998','2013-09-21','15:20:00',1.79),('8998','2013-09-21','15:40:00',1.04),('8998','2013-09-21','15:45:00',1.2),('8998','2013-09-21','15:50:00',1.09),('8998','2013-09-21','15:55:00',1.09),('8998','2013-09-21','16:00:00',1.24),('8998','2013-09-21','16:05:00',1.29),('8998','2013-09-21','16:10:00',1.36),('8998','2013-09-21','16:15:00',1.09),('8998','2013-09-20','08:25:00',1.22),('8998','2013-09-20','08:30:00',1.44),('8998','2013-09-20','08:35:00',1.54),('8998','2013-09-20','08:40:00',1.59),('8998','2013-09-20','08:45:00',1.64),('8998','2013-09-20','08:50:00',1.69),('8998','2013-09-20','08:55:00',1.75),('8998','2013-09-20','09:00:00',1.82),('8998','2013-09-20','09:05:00',1.88),('8998','2013-09-20','09:10:00',1.94),('8998','2013-09-20','09:15:00',2.01),('8998','2013-09-20','09:20:00',2.06),('8998','2013-09-20','09:25:00',2.09),('8998','2013-09-20','09:30:00',2.13),('8998','2013-09-20','09:35:00',2.17),('8998','2013-09-20','09:40:00',2.19),('8998','2013-09-20','09:45:00',2.24),('8998','2013-09-20','09:50:00',2.26),('8998','2013-09-20','09:55:00',2.31),('8998','2013-09-20','10:00:00',2.34),('8998','2013-09-20','10:05:00',2.37),('8998','2013-09-20','10:10:00',2.4),('8998','2013-09-20','10:15:00',2.43),('8998','2013-09-20','10:20:00',2.44),('8998','2013-09-20','10:25:00',2.46),('8998','2013-09-20','10:30:00',2.47),('8998','2013-09-20','10:35:00',2.49),('8998','2013-09-20','10:40:00',2.51),('8998','2013-09-20','10:45:00',2.52),('8998','2013-09-20','10:50:00',2.54),('8998','2013-09-20','10:55:00',2.56),('8998','2013-09-20','11:00:00',2.57),('8998','2013-09-20','11:05:00',2.57),('8998','2013-09-20','11:10:00',2.57),('8998','2013-09-20','11:15:00',2.58),('8998','2013-09-20','11:20:00',2.6),('8998','2013-09-20','11:25:00',2.61),('8998','2013-09-20','11:30:00',2.61),('8998','2013-09-20','11:35:00',2.6),('8998','2013-09-20','11:40:00',2.62),('8998','2013-09-20','11:45:00',2.61),('8998','2013-09-20','11:50:00',2.63),('8998','2013-09-20','11:55:00',2.55),('8998','2013-09-20','12:00:00',2.6),('8998','2013-09-20','12:05:00',2.62),('8998','2013-09-20','12:10:00',2.6),('8998','2013-09-20','12:15:00',2.6),('8998','2013-09-20','12:20:00',2.58),('8998','2013-09-20','12:25:00',2.32),('8998','2013-09-20','12:30:00',2.62),('8998','2013-09-20','12:35:00',2.57),('8998','2013-09-20','12:40:00',2.31),('8998','2013-09-20','12:45:00',2.3),('8998','2013-09-20','12:50:00',2.5),('8998','2013-09-20','12:55:00',2.48),('8998','2013-09-20','13:00:00',2.46),('8998','2013-09-20','13:05:00',2.34),('8998','2013-09-20','13:10:00',2.42),('8998','2013-09-20','13:15:00',2.4),('8998','2013-09-20','13:20:00',1.88),('8998','2013-09-20','13:25:00',2.14),('8998','2013-09-20','13:30:00',2.22),('8998','2013-09-20','13:35:00',2.25),('8998','2013-09-20','13:40:00',1.96),('8998','2013-09-20','13:45:00',1.92),('8998','2013-09-20','13:50:00',1.98),('8998','2013-09-20','13:55:00',2.02),('8998','2013-09-20','14:00:00',1.94),('8998','2013-09-20','14:05:00',2.04),('8998','2013-09-20','14:10:00',1.96),('8998','2013-09-20','14:15:00',2.01),('8998','2013-09-20','14:20:00',2),('8998','2013-09-20','14:25:00',1.94),('8998','2013-09-20','14:30:00',1.89),('8998','2013-09-20','14:35:00',1.84),('8998','2013-09-20','14:40:00',1.78),('8998','2013-09-20','14:45:00',1.73),('8998','2013-09-20','14:50:00',1.69),('8998','2013-09-20','14:55:00',1.64),('8998','2013-09-20','15:00:00',1.58),('8998','2013-09-20','15:05:00',1.53),('8998','2013-09-20','15:10:00',1.44),('8998','2013-09-20','15:15:00',1.41),('8998','2013-09-20','15:20:00',1.37),('8998','2013-09-20','15:25:00',1.31),('8998','2013-09-20','15:30:00',1.25),('8998','2013-09-20','15:35:00',1.18),('8998','2013-09-19','08:35:00',1.26),('8998','2013-09-19','08:40:00',1.45),('8998','2013-09-19','08:45:00',1.44),('8998','2013-09-19','09:05:00',1.04),('8998','2013-09-19','09:20:00',1.38),('8998','2013-09-19','09:25:00',1.68),('8998','2013-09-19','09:30:00',1.06),('8998','2013-09-19','09:45:00',1),('8998','2013-09-19','09:50:00',1.06),('8998','2013-09-19','09:55:00',1.07),('8998','2013-09-19','10:00:00',1.19),('8998','2013-09-19','10:05:00',1.5),('8998','2013-09-19','10:10:00',2.76),('8998','2013-09-19','10:15:00',1.55),('8998','2013-09-19','10:20:00',2.8),('8998','2013-09-19','10:25:00',1.47),('8998','2013-09-19','10:30:00',1.5),('8998','2013-09-19','10:35:00',1.95),('8998','2013-09-19','10:40:00',1.72),('8998','2013-09-19','10:45:00',1.9),('8998','2013-09-19','10:50:00',1.95),('8998','2013-09-19','10:55:00',2.08),('8998','2013-09-19','11:00:00',1.86),('8998','2013-09-19','11:05:00',1.49),('8998','2013-09-19','11:10:00',1.49),('8998','2013-09-19','11:15:00',1.86),('8998','2013-09-19','11:20:00',1.93),('8998','2013-09-19','11:25:00',1.71),('8998','2013-09-19','11:30:00',2.07),('8998','2013-09-19','11:35:00',2),('8998','2013-09-19','11:40:00',2.28),('8998','2013-09-19','11:45:00',3),('8998','2013-09-19','11:50:00',2.95),('8998','2013-09-19','11:55:00',2.82),('8998','2013-09-19','12:00:00',2.69),('8998','2013-09-19','12:05:00',2.66),('8998','2013-09-19','12:10:00',2.64),('8998','2013-09-19','12:15:00',2.66),('8998','2013-09-19','12:20:00',2.67),('8998','2013-09-19','12:25:00',2.7),('8998','2013-09-19','12:30:00',2.17),('8998','2013-09-19','12:35:00',2.36),('8998','2013-09-19','12:40:00',1.9),('8998','2013-09-19','12:45:00',2.57),('8998','2013-09-19','12:50:00',2.17),('8998','2013-09-19','12:55:00',2.63),('8998','2013-09-19','13:00:00',2.41),('8998','2013-09-19','13:05:00',2.12),('8998','2013-09-19','13:10:00',2.39),('8998','2013-09-19','13:15:00',2.24),('8998','2013-09-19','13:20:00',2.19),('8998','2013-09-19','13:25:00',2.56),('8998','2013-09-19','13:30:00',2.44),('8998','2013-09-19','13:35:00',1.52),('8998','2013-09-19','13:40:00',2.08),('8998','2013-09-19','13:45:00',2.34),('8998','2013-09-19','13:50:00',2.23),('8998','2013-09-19','13:55:00',2.01),('8998','2013-09-19','14:00:00',2.15),('8998','2013-09-19','14:05:00',2.17),('8998','2013-09-19','14:10:00',1.42),('8998','2013-09-19','14:15:00',1.95),('8998','2013-09-19','14:20:00',1.27),('8998','2013-09-19','14:30:00',2.13),('8998','2013-09-19','14:35:00',2.06),('8998','2013-09-19','14:40:00',1.99),('8998','2013-09-19','14:45:00',1.97),('8998','2013-09-19','14:50:00',1.96),('8998','2013-09-19','14:55:00',1.91),('8998','2013-09-19','15:00:00',1.63),('8998','2013-09-19','15:10:00',1.6),('8998','2013-09-19','15:15:00',1.27),('8998','2013-09-19','15:20:00',1.34),('8998','2013-09-19','15:45:00',1.28),('8998','2013-09-19','15:50:00',1.21),('8998','2013-09-19','15:55:00',1.22),('8998','2013-09-19','16:10:00',1.08),('8998','2013-09-19','16:15:00',1.06),('8998','2013-09-18','08:30:00',1.43),('8998','2013-09-18','08:35:00',1.53),('8998','2013-09-18','08:45:00',1.48),('8998','2013-09-18','08:50:00',1.07),('8998','2013-09-18','09:00:00',1.02),('8998','2013-09-18','09:10:00',1.27),('8998','2013-09-18','09:15:00',1.81),('8998','2013-09-18','10:05:00',1.41),('8998','2013-09-18','10:10:00',2.16),('8998','2013-09-18','10:15:00',2.34),('8998','2013-09-18','10:20:00',1.07),('8998','2013-09-18','10:35:00',2.01),('8998','2013-09-18','10:40:00',2.72),('8998','2013-09-18','10:45:00',1.86),('8998','2013-09-18','10:50:00',1.31),('8998','2013-09-18','10:55:00',1.73),('8998','2013-09-18','11:00:00',2.98),('8998','2013-09-18','11:05:00',2.69),('8998','2013-09-18','11:10:00',1.07),('8998','2013-09-18','11:15:00',1.48),('8998','2013-09-18','11:20:00',1.72),('8998','2013-09-18','11:25:00',1.1),('8998','2013-09-18','11:30:00',3.22),('8998','2013-09-18','11:35:00',2.15),('8998','2013-09-18','11:40:00',2.72),('8998','2013-09-18','11:45:00',1.78),('8998','2013-09-18','11:50:00',2.78),('8998','2013-09-18','11:55:00',2.66),('8998','2013-09-18','12:00:00',1.9),('8998','2013-09-18','12:05:00',1.26),('8998','2013-09-18','12:10:00',2.25),('8998','2013-09-18','12:15:00',2.64),('8998','2013-09-18','12:20:00',2.26),('8998','2013-09-18','12:25:00',3.09),('8998','2013-09-18','12:30:00',2.99),('8998','2013-09-18','12:35:00',2.71),('8998','2013-09-18','12:40:00',2.67),('8998','2013-09-18','12:45:00',1.16),('8998','2013-09-18','12:50:00',2.74),('8998','2013-09-18','12:55:00',2.71),('8998','2013-09-18','13:00:00',2.73),('8998','2013-09-18','13:05:00',2.69),('8998','2013-09-18','13:10:00',2.78),('8998','2013-09-18','13:15:00',2.58),('8998','2013-09-18','13:20:00',2.45),('8998','2013-09-18','13:25:00',1.39),('8998','2013-09-18','13:30:00',2.52),('8998','2013-09-18','13:35:00',2.61),('8998','2013-09-18','13:40:00',2.62),('8998','2013-09-18','13:45:00',2.34),('8998','2013-09-18','13:50:00',1.02),('8998','2013-09-18','14:05:00',1.59),('8998','2013-09-18','14:10:00',2.04),('8998','2013-09-18','14:15:00',2.16),('8998','2013-09-18','14:20:00',2.1),('8998','2013-09-18','14:25:00',1.92),('8998','2013-09-18','14:30:00',1.96),('8998','2013-09-18','14:35:00',1.91),('8998','2013-09-18','14:40:00',1.86),('8998','2013-09-18','14:45:00',1.83),('8998','2013-09-18','14:50:00',1.77),('8998','2013-09-18','14:55:00',1.4),('8998','2013-09-18','15:00:00',1.78),('8998','2013-09-18','15:05:00',1.67),('8998','2013-09-18','15:10:00',1.43),('8998','2013-09-18','15:15:00',1.4),('8998','2013-09-18','15:20:00',1.54),('8998','2013-09-18','15:25:00',1.42),('8998','2013-09-18','15:30:00',1.14),('8998','2013-09-18','15:40:00',1.19),('8998','2013-09-18','15:45:00',1.21),('8998','2013-09-18','15:50:00',1.14),('8998','2014-04-12','09:10:00',1.27),('8998','2014-04-12','09:15:00',1.07),('8998','2014-04-12','09:20:00',1.16),('8998','2014-04-12','09:25:00',1.48),('8998','2014-04-12','09:30:00',1.65),('8998','2014-04-12','09:35:00',1.14),('8998','2014-04-12','09:40:00',1.58),('8998','2014-04-12','09:45:00',1.39),('8998','2014-04-12','09:50:00',1.34),('8998','2014-04-12','09:55:00',1.29),('8998','2014-04-12','10:00:00',2.35),('8998','2014-04-12','10:05:00',2.8),('8998','2014-04-12','10:10:00',1.53),('8998','2014-04-12','10:15:00',2.09),('8998','2014-04-12','10:20:00',2.42),('8998','2014-04-12','10:25:00',1.33),('8998','2014-04-12','10:30:00',3.1),('8998','2014-04-12','10:35:00',2.94),('8998','2014-04-12','10:40:00',2.86),('8998','2014-04-12','10:45:00',2.95),('8998','2014-04-12','10:50:00',2.93),('8998','2014-04-12','10:55:00',2.91),('8998','2014-04-12','11:00:00',2.94),('8998','2014-04-12','11:05:00',2.97),('8998','2014-04-12','11:10:00',2.9),('8998','2014-04-12','11:15:00',3.18),('8998','2014-04-12','11:20:00',3.55),('8998','2014-04-12','11:25:00',1.94),('8998','2014-04-12','11:30:00',1.51),('8998','2014-04-12','11:35:00',2.98),('8998','2014-04-12','11:40:00',2.64),('8998','2014-04-12','11:45:00',2.74),('8998','2014-04-12','11:50:00',2.57),('8998','2014-04-12','11:55:00',2.13),('8998','2014-04-12','12:00:00',1.79),('8998','2014-04-12','12:05:00',1.17),('8998','2014-04-12','12:10:00',1.04),('8998','2014-04-12','13:10:00',1.39),('8998','2014-04-12','13:15:00',1.27),('8998','2014-04-12','13:20:00',1.54),('8998','2014-04-12','13:25:00',2.14),('8998','2014-04-12','13:30:00',2.83),('8998','2014-04-12','13:35:00',2.56),('8998','2014-04-12','13:40:00',2.56),('8998','2014-04-12','13:45:00',1.33),('8998','2014-04-12','13:50:00',2.11),('8998','2014-04-12','13:55:00',2.05),('8998','2014-04-12','14:00:00',2.43),('8998','2014-04-12','14:05:00',1.8),('8998','2014-04-12','14:10:00',2.44),('8998','2014-04-12','14:15:00',2.31),('8998','2014-04-12','14:20:00',1.15),('8998','2014-04-12','14:45:00',1.39),('8998','2014-04-12','14:50:00',1.41),('8998','2014-04-12','14:55:00',1.1),('8998','2014-04-12','15:00:00',1.87),('8998','2014-04-12','15:05:00',1.97),('8998','2014-04-12','15:10:00',2.07),('8998','2014-04-12','15:15:00',1.88),('8998','2014-04-12','15:20:00',1.85),('8998','2014-04-12','15:25:00',1.81),('8998','2014-04-12','15:30:00',1.79),('8998','2014-04-12','15:35:00',1.26),('8998','2014-04-12','15:50:00',1.2),('8998','2014-04-12','15:55:00',1.22),('8998','2014-04-12','16:00:00',1.78),('8998','2014-04-12','16:05:00',1.3),('8998','2014-04-12','16:40:00',1.37),('8998','2014-04-12','16:45:00',1.5),('8998','2014-04-12','16:50:00',1.14),('8998','2014-04-12','16:55:00',1.28),('8998','2014-04-12','17:00:00',1.07),('8998','2013-09-17','08:45:00',1.09),('8998','2013-09-17','09:05:00',1.53),('8998','2013-09-17','09:20:00',2.22),('8998','2013-09-17','09:25:00',1.57),('8998','2013-09-17','09:30:00',1.59),('8998','2013-09-17','09:35:00',1.8),('8998','2013-09-17','09:40:00',2.37),('8998','2013-09-17','09:45:00',1.65),('8998','2013-09-17','10:00:00',1.51),('8998','2013-09-17','10:05:00',2.93),('8998','2013-09-17','10:10:00',2.7),('8998','2013-09-17','10:15:00',2.52),('8998','2013-09-17','10:20:00',2.45),('8998','2013-09-17','10:25:00',2.47),('8998','2013-09-17','10:30:00',2.45),('8998','2013-09-17','10:35:00',2.48),('8998','2013-09-17','10:40:00',2.47),('8998','2013-09-17','10:45:00',2.24),('8998','2013-09-17','10:50:00',2.34),('8998','2013-09-17','10:55:00',1.84),('8998','2013-09-17','11:00:00',1.87),('8998','2013-09-17','11:05:00',2.53),('8998','2013-09-17','11:10:00',1.6),('8998','2013-09-17','11:15:00',2.18),('8998','2013-09-17','11:20:00',1.71),('8998','2013-09-17','11:25:00',2.16),('8998','2013-09-17','11:30:00',2.86),('8998','2013-09-17','11:35:00',2.8),('8998','2013-09-17','11:40:00',1.39),('8998','2013-09-17','11:45:00',1.48),('8998','2013-09-17','11:50:00',2.59),('8998','2013-09-17','11:55:00',2.85),('8998','2013-09-17','12:00:00',2.82),('8998','2013-09-17','12:05:00',2.02),('8998','2013-09-17','12:10:00',2.87),('8998','2013-09-17','12:15:00',2.89),('8998','2013-09-17','12:20:00',2.76),('8998','2013-09-17','12:25:00',2.78),('8998','2013-09-17','12:30:00',2.56),('8998','2013-09-17','12:35:00',1.41),('8998','2013-09-17','12:40:00',3),('8998','2013-09-17','12:45:00',2.65),('8998','2013-09-17','12:50:00',2.77),('8998','2013-09-17','12:55:00',2.72),('8998','2013-09-17','13:00:00',2.68),('8998','2013-09-17','13:05:00',1.46),('8998','2013-09-17','13:10:00',2.67),('8998','2013-09-17','13:15:00',1.51),('8998','2013-09-17','13:20:00',2.66),('8998','2013-09-17','13:25:00',2.43),('8998','2013-09-17','13:30:00',2.57),('8998','2013-09-17','13:35:00',2.47),('8998','2013-09-17','13:40:00',2.4),('8998','2013-09-17','13:45:00',2.38),('8998','2013-09-17','13:50:00',2.15),('8998','2013-09-17','13:55:00',1.7),('8998','2013-09-17','14:00:00',2.35),('8998','2013-09-17','14:05:00',2.12),('8998','2013-09-17','14:10:00',2.21),('8998','2013-09-17','14:15:00',2.17),('8998','2013-09-17','14:20:00',2.13),('8998','2013-09-17','14:25:00',2.07),('8998','2013-09-17','14:30:00',1.99),('8998','2013-09-17','14:35:00',1.95),('8998','2013-09-17','14:40:00',1.91),('8998','2013-09-17','14:45:00',1.83),('8998','2013-09-17','14:50:00',1.79),('8998','2013-09-17','14:55:00',1.77),('8998','2013-09-17','15:00:00',1.68),('8998','2013-09-17','15:05:00',1.64),('8998','2013-09-17','15:15:00',1.15),('8998','2013-09-17','15:20:00',1.54),('8998','2013-09-17','15:25:00',1.52),('8998','2013-09-17','15:30:00',1.47),('8998','2013-09-17','15:35:00',1.4),('8998','2013-09-17','15:40:00',1.41),('8998','2013-09-17','15:45:00',1.16),('8998','2013-09-17','16:10:00',1.08),('8998','2013-09-16','09:40:00',1.13),('8998','2013-09-16','09:45:00',2.11),('8998','2013-09-16','09:50:00',1.23),('8998','2013-09-16','09:55:00',1.09),('8998','2013-09-16','10:00:00',1.82),('8998','2013-09-16','10:05:00',1.39),('8998','2013-09-16','10:10:00',1.62),('8998','2013-09-16','10:25:00',1.66),('8998','2013-09-16','10:30:00',2.48),('8998','2013-09-16','10:35:00',1.33),('8998','2013-09-16','10:40:00',1.49),('8998','2013-09-16','10:45:00',1.91),('8998','2013-09-16','10:50:00',3.03),('8998','2013-09-16','10:55:00',2.09),('8998','2013-09-16','11:00:00',1.51),('8998','2013-09-16','11:05:00',1.22),('8998','2013-09-16','11:10:00',2.54),('8998','2013-09-16','11:15:00',2.12),('8998','2013-09-16','11:20:00',1.79),('8998','2013-09-16','11:25:00',1.35),('8998','2013-09-16','11:30:00',1.3),('8998','2013-09-16','11:35:00',2.42),('8998','2013-09-16','11:40:00',2.77),('8998','2013-09-16','11:45:00',2.65),('8998','2013-09-16','11:50:00',2.36),('8998','2013-09-16','11:55:00',2.09),('8998','2013-09-16','12:00:00',2.52),('8998','2013-09-16','12:05:00',2.3),('8998','2013-09-16','12:10:00',1.24),('8998','2013-09-16','12:15:00',1.64),('8998','2013-09-16','12:20:00',1.5),('8998','2013-09-16','12:25:00',2.74),('8998','2013-09-16','12:30:00',2.48),('8998','2013-09-16','12:35:00',1.49),('8998','2013-09-16','12:40:00',2.35),('8998','2013-09-16','12:45:00',2.32),('8998','2013-09-16','12:50:00',2.03),('8998','2013-09-16','12:55:00',1.59),('8998','2013-09-16','13:00:00',1.86),('8998','2013-09-16','13:05:00',1.01),('8998','2013-09-16','13:10:00',1.48),('8998','2013-09-16','13:15:00',2.23),('8998','2013-09-16','13:20:00',1.54),('8998','2013-09-16','13:25:00',1.39),('8998','2013-09-16','13:30:00',1.2),('8998','2013-09-16','13:35:00',1.18),('8998','2013-09-16','13:40:00',1.73),('8998','2013-09-16','13:45:00',1.24),('8998','2013-09-16','14:00:00',1.15),('8998','2013-09-16','14:25:00',1.17),('8998','2013-09-16','14:55:00',1.76),('8998','2013-09-16','15:00:00',1.93),('8998','2013-09-16','15:05:00',1.5),('8998','2013-09-16','15:10:00',1.45),('8998','2013-09-16','15:15:00',1.33),('8998','2013-09-16','15:20:00',1.51),('8998','2013-09-16','15:25:00',1.49),('8998','2013-09-16','15:30:00',1.23),('8998','2013-09-16','15:50:00',1.06),('8998','2013-09-16','15:55:00',1.22),('8998','2013-09-16','16:05:00',1.02),('8998','2013-09-15','08:20:00',1.01),('8998','2013-09-15','08:25:00',1.29),('8998','2013-09-15','08:30:00',1.14),('8998','2013-09-15','08:35:00',1.41),('8998','2013-09-15','08:40:00',1.64),('8998','2013-09-15','08:50:00',1.37),('8998','2013-09-15','08:55:00',1.1),('8998','2013-09-15','09:05:00',1.73),('8998','2013-09-15','09:10:00',2.07),('8998','2013-09-15','09:15:00',1.76),('8998','2013-09-15','09:20:00',1.77),('8998','2013-09-15','09:25:00',2.03),('8998','2013-09-15','09:30:00',1.99),('8998','2013-09-15','09:35:00',2.18),('8998','2013-09-15','09:40:00',2.2),('8998','2013-09-15','09:45:00',2.23),('8998','2013-09-15','09:50:00',2.31),('8998','2013-09-15','09:55:00',2.36),('8998','2013-09-15','10:00:00',2.39),('8998','2013-09-15','10:05:00',2.43),('8998','2013-09-15','10:10:00',2.48),('8998','2013-09-15','10:15:00',1.24),('8998','2013-09-15','10:20:00',1.68),('8998','2013-09-15','10:25:00',1.43),('8998','2013-09-15','10:30:00',2.39),('8998','2013-09-15','10:35:00',2.92),('8998','2013-09-15','10:40:00',2.71),('8998','2013-09-15','10:45:00',3.17),('8998','2013-09-15','10:50:00',1.53),('8998','2013-09-15','11:05:00',2.04),('8998','2013-09-15','11:10:00',1.52),('8998','2013-09-15','11:15:00',1.39),('8998','2013-09-15','11:20:00',1.85),('8998','2013-09-15','11:25:00',1.2),('8998','2013-09-15','11:30:00',2.92),('8998','2013-09-15','11:35:00',2.89),('8998','2013-09-15','11:40:00',2.91),('8998','2013-09-15','11:45:00',1.66),('8998','2013-09-15','11:50:00',1.94),('8998','2013-09-15','11:55:00',2.93),('8998','2013-09-15','12:00:00',2.97),('8998','2013-09-15','12:05:00',2.79),('8998','2013-09-15','12:10:00',2.5),('8998','2013-09-15','12:15:00',2.35),('8998','2013-09-15','12:20:00',2.84),('8998','2013-09-15','12:25:00',2.73),('8998','2013-09-15','12:30:00',2.69),('8998','2013-09-15','12:35:00',2.67),('8998','2013-09-15','12:40:00',2.75),('8998','2013-09-15','12:45:00',2.94),('8998','2013-09-15','12:50:00',1.95),('8998','2013-09-15','12:55:00',2.04),('8998','2013-09-15','13:00:00',1.67),('8998','2013-09-15','13:05:00',2.53),('8998','2013-09-15','13:10:00',2.48),('8998','2013-09-15','13:15:00',2.57),('8998','2013-09-15','13:20:00',2.58),('8998','2013-09-15','13:25:00',2.49),('8998','2013-09-15','13:30:00',2.42),('8998','2013-09-15','13:35:00',2.46),('8998','2013-09-15','13:40:00',2.43),('8998','2013-09-15','13:45:00',2.35),('8998','2013-09-15','13:50:00',2.33),('8998','2013-09-15','13:55:00',2.43),('8998','2013-09-15','14:00:00',2.33),('8998','2013-09-15','14:05:00',1.87),('8998','2013-09-15','14:10:00',2.18),('8998','2013-09-15','14:15:00',2.12),('8998','2013-09-15','14:20:00',2.07),('8998','2013-09-15','14:25:00',2.03),('8998','2013-09-15','14:30:00',2),('8998','2013-09-15','14:35:00',1.95),('8998','2013-09-15','14:40:00',1.9),('8998','2013-09-15','14:45:00',1.85),('8998','2013-09-15','14:50:00',1.8),('8998','2013-09-15','14:55:00',1.76),('8998','2013-09-15','15:00:00',1.71),('8998','2013-09-15','15:05:00',1.66),('8998','2013-09-15','15:10:00',1.61),('8998','2013-09-15','15:15:00',1.56),('8998','2013-09-15','15:20:00',1.5),('8998','2013-09-15','15:25:00',1.44),('8998','2013-09-15','15:30:00',1.39),('8998','2013-09-15','15:35:00',1.33),('8998','2013-09-15','15:40:00',1.28),('8998','2013-09-15','15:45:00',1.22),('8998','2013-09-15','15:50:00',1.15),('8998','2013-09-15','15:55:00',1.05),('8998','2013-09-15','16:00:00',1.02),('8998','2013-09-14','08:20:00',1.27),('8998','2013-09-14','08:25:00',1.42),('8998','2013-09-14','08:30:00',1.34),('8998','2013-09-14','08:35:00',1.31),('8998','2013-09-14','08:40:00',1.41),('8998','2013-09-14','08:45:00',1.6),('8998','2013-09-14','08:50:00',1.67),('8998','2013-09-14','08:55:00',1.57),('8998','2013-09-14','09:00:00',1.74),('8998','2013-09-14','09:05:00',1.85),('8998','2013-09-14','09:10:00',2.03),('8998','2013-09-14','09:15:00',2.18),('8998','2013-09-14','09:20:00',2.08),('8998','2013-09-14','09:25:00',2.15),('8998','2013-09-14','09:30:00',2.18),('8998','2013-09-14','09:35:00',2.27),('8998','2013-09-14','09:40:00',2.3),('8998','2013-09-14','09:45:00',2.28),('8998','2013-09-14','09:50:00',2.35),('8998','2013-09-14','09:55:00',2.35),('8998','2013-09-14','10:00:00',2.43),('8998','2013-09-14','10:05:00',2.46),('8998','2013-09-14','10:10:00',2.44),('8998','2013-09-14','10:15:00',2.32),('8998','2013-09-14','10:20:00',2.41),('8998','2013-09-14','10:25:00',2.47),('8998','2013-09-14','10:30:00',2.29),('8998','2013-09-14','10:35:00',2.11),('8998','2013-09-14','10:40:00',1.17),('8998','2013-09-14','10:55:00',1.88),('8998','2013-09-14','11:00:00',1.76),('8998','2013-09-14','11:05:00',2.88),('8998','2013-09-14','11:10:00',2.09),('8998','2013-09-14','11:15:00',1.13),('8998','2013-09-14','11:35:00',2.03),('8998','2013-09-14','11:40:00',1.08),('8998','2013-09-14','11:50:00',2.06),('8998','2013-09-14','11:55:00',1.45),('8998','2013-09-14','12:25:00',1.12),('8998','2013-09-14','12:30:00',1.21),('8998','2013-09-14','12:35:00',1.12),('8998','2013-09-14','12:40:00',1.11),('8998','2013-09-14','13:45:00',1.52),('8998','2013-09-14','13:50:00',1.67),('8998','2013-09-14','14:00:00',1.14),('8998','2013-09-14','14:05:00',1.14),('8998','2013-09-14','14:10:00',1.02),('8998','2013-09-14','15:15:00',1.45),('8998','2013-09-14','15:20:00',1.35),('8998','2013-09-14','15:25:00',1.04),('8998','2013-09-13','08:20:00',1.15),('8998','2013-09-13','08:25:00',1.4),('8998','2013-09-13','08:30:00',1.41),('8998','2013-09-13','08:35:00',1.52),('8998','2013-09-13','08:40:00',1.65),('8998','2013-09-13','08:45:00',1.72),('8998','2013-09-13','08:50:00',1.76),('8998','2013-09-13','08:55:00',1.81),('8998','2013-09-13','09:00:00',1.87),('8998','2013-09-13','09:05:00',1.97),('8998','2013-09-13','09:10:00',2.05),('8998','2013-09-13','09:15:00',2.1),('8998','2013-09-13','09:20:00',2.14),('8998','2013-09-13','09:25:00',2.18),('8998','2013-09-13','09:30:00',2.23),('8998','2013-09-13','09:35:00',2.24),('8998','2013-09-13','09:40:00',2.27),('8998','2013-09-13','09:45:00',2.31),('8998','2013-09-13','09:50:00',2.29),('8998','2013-09-13','09:55:00',2.39),('8998','2013-09-13','10:00:00',2.27),('8998','2013-09-13','10:05:00',1.69),('8998','2013-09-13','10:10:00',2.2),('8998','2013-09-13','10:15:00',2.21),('8998','2013-09-13','10:20:00',2.43),('8998','2013-09-13','10:25:00',2.52),('8998','2013-09-13','10:30:00',2.5),('8998','2013-09-13','10:35:00',2.56),('8998','2013-09-13','10:40:00',2.65),('8998','2013-09-13','10:45:00',2.75),('8998','2013-09-13','10:50:00',2.96),('8998','2013-09-13','10:55:00',2.76),('8998','2013-09-13','11:00:00',2.97),('8998','2013-09-13','11:05:00',1.45),('8998','2013-09-13','11:25:00',1.65),('8998','2013-09-13','11:30:00',2.94),('8998','2013-09-13','11:35:00',2.88),('8998','2013-09-13','11:40:00',2.95),('8998','2013-09-13','11:45:00',2.79),('8998','2013-09-13','11:50:00',2.58),('8998','2013-09-13','11:55:00',2.44),('8998','2013-09-13','12:00:00',1.31),('8998','2013-09-13','12:05:00',2.34),('8998','2013-09-13','12:10:00',1.27),('8998','2013-09-13','12:15:00',1.32),('8998','2013-09-13','12:20:00',1.1),('8998','2013-09-13','12:40:00',2.11),('8998','2013-09-13','13:15:00',2.36),('8998','2013-09-13','13:20:00',2.78),('8998','2013-09-13','13:25:00',2.33),('8998','2013-09-13','13:30:00',2.76),('8998','2013-09-13','13:35:00',1.89),('8998','2013-09-13','13:45:00',1.52),('8998','2013-09-13','13:50:00',1.42),('8998','2013-09-13','13:55:00',2.34),('8998','2013-09-13','14:00:00',2.66),('8998','2013-09-13','14:05:00',2.41),('8998','2013-09-13','14:10:00',2.31),('8998','2013-09-13','14:15:00',2.25),('8998','2013-09-13','14:20:00',2.21),('8998','2013-09-13','14:25:00',2.1),('8998','2013-09-13','14:30:00',2.12),('8998','2013-09-13','14:35:00',2.06),('8998','2013-09-13','14:40:00',1.99),('8998','2013-09-13','14:45:00',1.95),('8998','2013-09-13','14:50:00',1.91),('8998','2013-09-13','14:55:00',1.85),('8998','2013-09-13','15:00:00',1.76),('8998','2013-09-13','15:05:00',1.72),('8998','2013-09-13','15:10:00',1.65),('8998','2013-09-13','15:15:00',1.59),('8998','2013-09-13','15:20:00',1.53),('8998','2013-09-13','15:25:00',1.49),('8998','2013-09-13','15:30:00',1.45),('8998','2013-09-13','15:35:00',1.38),('8998','2013-09-13','15:40:00',1.34),('8998','2013-09-13','15:45:00',1.27),('8998','2013-09-13','15:50:00',1.2),('8998','2013-09-13','15:55:00',1.15),('8998','2013-09-13','16:00:00',1.08),('8998','2013-09-12','09:35:00',1),('8998','2013-09-12','09:40:00',1.22),('8998','2013-09-12','09:45:00',1.11),('8998','2013-09-12','09:50:00',1.15),('8998','2013-09-12','09:55:00',1.55),('8998','2013-09-12','10:00:00',2.43),('8998','2013-09-12','10:05:00',1.36),('8998','2013-09-12','10:10:00',1.64),('8998','2013-09-12','10:15:00',3.1),('8998','2013-09-12','10:20:00',2.74),('8998','2013-09-12','10:25:00',1.37),('8998','2013-09-12','10:30:00',1.71),('8998','2013-09-12','10:35:00',2.9),('8998','2013-09-12','10:40:00',2.67),('8998','2013-09-12','10:45:00',2.65),('8998','2013-09-12','10:50:00',2.65),('8998','2013-09-12','10:55:00',2.66),('8998','2013-09-12','11:00:00',2.68),('8998','2013-09-12','11:05:00',2.68),('8998','2013-09-12','11:10:00',2.7),('8998','2013-09-12','11:15:00',2.71),('8998','2013-09-12','11:20:00',2.69),('8998','2013-09-12','11:25:00',2.71),('8998','2013-09-12','11:30:00',2.7),('8998','2013-09-12','11:35:00',2.72),('8998','2013-09-12','11:40:00',2.72),('8998','2013-09-12','11:45:00',2.72),('8998','2013-09-12','11:50:00',2.73),('8998','2013-09-12','11:55:00',2.71),('8998','2013-09-12','12:00:00',2.71),('8998','2013-09-12','12:05:00',2.74),('8998','2013-09-12','12:10:00',2.74),('8998','2013-09-12','12:15:00',2.73),('8998','2013-09-12','12:20:00',2.73),('8998','2013-09-12','12:25:00',2.73),('8998','2013-09-12','12:30:00',1.42),('8998','2013-09-12','12:35:00',2.76),('8998','2013-09-12','12:40:00',2.74),('8998','2013-09-12','12:45:00',2.71),('8998','2013-09-12','12:50:00',2.69),('8998','2013-09-12','12:55:00',2.63),('8998','2013-09-12','13:00:00',2.6),('8998','2013-09-12','13:05:00',2.59),('8998','2013-09-12','13:10:00',2.56),('8998','2013-09-12','13:15:00',2.53),('8998','2013-09-12','13:20:00',2.5),('8998','2013-09-12','13:25:00',2.47),('8998','2013-09-12','13:30:00',2.43),('8998','2013-09-12','13:35:00',2.39),('8998','2013-09-12','13:40:00',2.36),('8998','2013-09-12','13:45:00',2.34),('8998','2013-09-12','13:50:00',2.31),('8998','2013-09-12','13:55:00',2.28),('8998','2013-09-12','14:00:00',2.25),('8998','2013-09-12','14:05:00',2.22),('8998','2013-09-12','14:10:00',2.18),('8998','2013-09-12','14:15:00',2.14),('8998','2013-09-12','14:20:00',2.1),('8998','2013-09-12','14:25:00',2.08),('8998','2013-09-12','14:30:00',2.05),('8998','2013-09-12','14:35:00',2),('8998','2013-09-12','14:40:00',1.93),('8998','2013-09-12','14:45:00',1.91),('8998','2013-09-12','14:50:00',1.86),('8998','2013-09-12','14:55:00',1.82),('8998','2013-09-12','15:00:00',1.73),('8998','2013-09-12','15:05:00',1.7),('8998','2013-09-12','15:10:00',1.66),('8998','2013-09-12','15:15:00',1.63),('8998','2013-09-12','15:20:00',1.55),('8998','2013-09-12','15:25:00',1.5),('8998','2013-09-12','15:30:00',1.44),('8998','2013-09-12','15:35:00',1.39),('8998','2013-09-12','15:40:00',1.34),('8998','2013-09-12','15:45:00',1.28),('8998','2013-09-12','15:50:00',1.23),('8998','2013-09-12','15:55:00',1.17),('8998','2013-09-12','16:00:00',1.11),('8998','2013-09-12','16:05:00',1.05),('8998','2013-09-11','08:20:00',1.36),('8998','2013-09-11','08:25:00',1.57),('8998','2013-09-11','08:30:00',1.68),('8998','2013-09-11','08:35:00',1.45),('8998','2013-09-11','08:55:00',1.59),('8998','2013-09-11','09:00:00',1.9),('8998','2013-09-11','09:05:00',1.77),('8998','2013-09-11','09:10:00',1.23),('8998','2013-09-11','09:15:00',1.88),('8998','2013-09-11','09:20:00',1.92),('8998','2013-09-11','09:25:00',2.16),('8998','2013-09-11','09:30:00',2.24),('8998','2013-09-11','09:35:00',1.95),('8998','2013-09-11','09:40:00',1.62),('8998','2013-09-11','09:45:00',1.98),('8998','2013-09-11','09:50:00',1.65),('8998','2013-09-11','09:55:00',1.11),('8998','2013-09-11','10:05:00',1.01),('8998','2013-09-11','10:10:00',1.27),('8998','2013-09-11','10:15:00',1.23),('8998','2013-09-11','10:20:00',1.07),('8998','2013-09-11','10:30:00',1.12),('8998','2013-09-11','10:35:00',1.22),('8998','2013-09-11','10:55:00',1.32),('8998','2013-09-11','11:00:00',1.73),('8998','2013-09-11','11:05:00',2.81),('8998','2013-09-11','11:10:00',2.02),('8998','2013-09-11','11:15:00',2.26),('8998','2013-09-11','11:45:00',1.36),('8998','2013-09-11','11:50:00',1.13),('8998','2013-09-11','11:55:00',2.31),('8998','2013-09-11','12:00:00',2.49),('8998','2013-09-11','12:05:00',2.73),('8998','2013-09-11','12:10:00',2.63),('8998','2013-09-11','12:15:00',2.45),('8998','2013-09-11','12:20:00',1.15),('8998','2013-09-11','12:25:00',1.26),('8998','2013-09-11','12:30:00',1.26),('8998','2013-09-11','12:35:00',1.84),('8998','2013-09-11','12:40:00',2.78),('8998','2013-09-11','12:45:00',1.07),('8998','2013-09-11','12:50:00',2.02),('8998','2013-09-11','12:55:00',1.23),('8998','2013-09-11','13:00:00',2.78),('8998','2013-09-11','13:05:00',2.04),('8998','2013-09-11','13:10:00',1.96),('8998','2013-09-11','13:15:00',2.32),('8998','2013-09-11','13:20:00',2.77),('8998','2013-09-11','13:25:00',3.1),('8998','2013-09-11','13:30:00',2.62),('8998','2013-09-11','13:35:00',2.12),('8998','2013-09-11','13:40:00',1.87),('8998','2013-09-11','13:45:00',2.55),('8998','2013-09-11','13:50:00',2.61),('8998','2013-09-11','13:55:00',2.41),('8998','2013-09-11','14:00:00',2.33),('8998','2013-09-11','14:05:00',2.1),('8998','2013-09-11','14:10:00',1.71),('8998','2013-09-11','14:15:00',2.27),('8998','2013-09-11','14:20:00',2.12),('8998','2013-09-11','14:25:00',2.25),('8998','2013-09-11','14:30:00',2.2),('8998','2013-09-11','14:35:00',1.75),('8998','2013-09-11','14:40:00',1.54),('8998','2013-09-11','14:45:00',1.99),('8998','2013-09-11','14:50:00',1.92),('8998','2013-09-11','14:55:00',1.87),('8998','2013-09-11','15:00:00',1.82),('8998','2013-09-11','15:05:00',1.8),('8998','2013-09-11','15:10:00',1.34),('8998','2013-09-11','15:15:00',1.52),('8998','2013-09-11','15:20:00',1.6),('8998','2013-09-11','15:25:00',1.34),('8998','2013-09-11','15:30:00',1.49),('8998','2013-09-11','15:35:00',1.43),('8998','2013-09-11','15:40:00',1.34),('8998','2013-09-11','15:45:00',1.33),('8998','2013-09-11','15:50:00',1.25),('8998','2013-09-11','15:55:00',1.13),('8998','2013-09-11','16:00:00',1.14),('8998','2013-09-10','09:00:00',1.45),('8998','2013-09-10','09:05:00',2.09),('8998','2013-09-10','09:10:00',2.27),('8998','2013-09-10','09:15:00',1.9),('8998','2013-09-10','09:20:00',2.46),('8998','2013-09-10','09:25:00',1.75),('8998','2013-09-10','09:30:00',1.19),('8998','2013-09-10','09:35:00',1.15),('8998','2013-09-10','09:40:00',1.27),('8998','2013-09-10','10:05:00',1.38),('8998','2013-09-10','10:10:00',1.37),('8998','2013-09-10','10:15:00',1.63),('8998','2013-09-10','10:20:00',2.56),('8998','2013-09-10','10:25:00',1.59),('8998','2013-09-10','10:30:00',2.59),('8998','2013-09-10','10:35:00',2.34),('8998','2013-09-10','10:40:00',2.18),('8998','2013-09-10','10:45:00',1.25),('8998','2013-09-10','10:50:00',2.23),('8998','2013-09-10','10:55:00',1.39),('8998','2013-09-10','11:00:00',1.12),('8998','2013-09-10','11:05:00',1.72),('8998','2013-09-10','11:10:00',2.23),('8998','2013-09-10','11:15:00',2.04),('8998','2013-09-10','11:20:00',2.91),('8998','2013-09-10','11:25:00',2.3),('8998','2013-09-10','11:35:00',1.85),('8998','2013-09-10','11:40:00',2.05),('8998','2013-09-10','11:45:00',2.91),('8998','2013-09-10','11:50:00',2.9),('8998','2013-09-10','11:55:00',2.94),('8998','2013-09-10','12:00:00',1.5),('8998','2013-09-10','12:05:00',2.86),('8998','2013-09-10','12:10:00',2.06),('8998','2013-09-10','12:15:00',1.47),('8998','2013-09-10','12:20:00',2.31),('8998','2013-09-10','12:25:00',2.11),('8998','2013-09-10','12:30:00',2.61),('8998','2013-09-10','12:35:00',2.35),('8998','2013-09-10','12:45:00',1.04),('8998','2013-09-10','12:50:00',2.57),('8998','2013-09-10','12:55:00',2.29),('8998','2013-09-10','13:00:00',2.09),('8998','2013-09-10','13:05:00',2.66),('8998','2013-09-10','13:10:00',2.7),('8998','2013-09-10','13:15:00',2.86),('8998','2013-09-10','13:20:00',2.36),('8998','2013-09-10','13:25:00',2.63),('8998','2013-09-10','13:30:00',2.39),('8998','2013-09-10','13:35:00',1.08),('8998','2013-09-10','13:40:00',1.89),('8998','2013-09-10','13:45:00',1.11),('8998','2013-09-10','13:50:00',2.31),('8998','2013-09-10','13:55:00',1.69),('8998','2013-09-10','14:00:00',1.62),('8998','2013-09-10','14:05:00',2.43),('8998','2013-09-10','14:10:00',2.16),('8998','2013-09-10','14:15:00',2.29),('8998','2013-09-10','14:20:00',1.32),('8998','2013-09-10','14:25:00',2.21),('8998','2013-09-10','14:30:00',1.35),('8998','2013-09-10','14:35:00',2),('8998','2013-09-10','14:45:00',1.67),('8998','2013-09-10','14:50:00',2.09),('8998','2013-09-10','14:55:00',1.88),('8998','2013-09-10','15:05:00',2),('8998','2013-09-10','15:15:00',1.7),('8998','2013-09-10','15:20:00',1.44),('8998','2013-09-10','15:25:00',1.59),('8998','2013-09-10','15:30:00',1.49),('8998','2013-09-10','15:45:00',1.46),('8998','2013-09-10','15:50:00',1.38),('8998','2013-09-10','15:55:00',1.01),('8998','2013-09-10','16:00:00',1.11),('8998','2013-09-10','16:05:00',1.24),('8998','2013-09-10','16:15:00',1.04),('8998','2013-09-09','08:55:00',1.38),('8998','2013-09-09','09:00:00',1.78),('8998','2013-09-09','09:05:00',1.78),('8998','2013-09-09','09:10:00',2.21),('8998','2013-09-09','09:15:00',1.83),('8998','2013-09-09','09:20:00',1.4),('8998','2013-09-09','09:25:00',1.39),('8998','2013-09-09','09:30:00',2.22),('8998','2013-09-09','09:35:00',2.42),('8998','2013-09-09','09:40:00',1.26),('8998','2013-09-09','09:45:00',1.05),('8998','2013-09-09','10:40:00',1.06),('8998','2013-09-09','10:45:00',1.57),('8998','2013-09-09','11:00:00',1.14),('8998','2013-09-09','11:10:00',1.02),('8998','2013-09-09','11:25:00',1.21),('8998','2013-09-09','11:55:00',1.26),('8998','2013-09-09','12:00:00',1.06),('8998','2013-09-09','13:40:00',1.19),('8998','2013-09-09','13:45:00',1.82),('8998','2013-09-09','13:50:00',1.25),('8998','2013-09-09','13:55:00',1.07),('8998','2013-09-09','14:15:00',1.09),('8998','2013-09-09','14:20:00',1.09),('8998','2013-09-09','14:25:00',1.37),('8998','2013-09-09','14:30:00',1.33),('8998','2013-09-09','14:40:00',1.14),('8998','2013-09-09','14:45:00',1.21),('8998','2013-09-09','14:50:00',1.3),('8998','2013-09-09','14:55:00',1.21),('8998','2013-09-09','15:00:00',1.37),('8998','2013-09-09','15:05:00',1.3),('8998','2013-09-09','15:10:00',1.03),('8998','2013-09-09','15:20:00',1.15),('8998','2013-09-09','15:25:00',1.05),('8998','2013-09-09','15:30:00',1.18),('8998','2013-09-09','15:35:00',1.12),('8998','2013-09-08','09:00:00',1.05),('8998','2013-09-08','10:05:00',1.28),('8998','2013-09-08','10:10:00',1.38),('8998','2013-09-08','10:15:00',1.35),('8998','2013-09-08','10:35:00',1.26),('8998','2013-09-08','10:40:00',1.34),('8998','2013-09-08','10:45:00',1.48),('8998','2013-09-08','10:50:00',1.95),('8998','2013-09-08','10:55:00',1.86),('8998','2013-09-08','11:00:00',2.04),('8998','2013-09-08','11:05:00',1.57),('8998','2013-09-08','11:10:00',1.25),('8998','2013-09-08','11:15:00',1.54),('8998','2013-09-08','11:20:00',1.83),('8998','2013-09-08','11:25:00',2.04),('8998','2013-09-08','11:30:00',1.59),('8998','2013-09-08','11:35:00',1.53),('8998','2013-09-08','11:40:00',2.37),('8998','2013-09-08','11:45:00',2.46),('8998','2013-09-08','11:50:00',1.85),('8998','2013-09-08','11:55:00',2.29),('8998','2013-09-08','12:00:00',2.1),('8998','2013-09-08','12:05:00',2.24),('8998','2013-09-08','12:10:00',2.11),('8998','2013-09-08','12:15:00',1.6),('8998','2013-09-08','12:20:00',1.27),('8998','2013-09-08','12:45:00',1.18),('8998','2013-09-08','12:55:00',1.02),('8998','2013-09-08','13:05:00',1.53),('8998','2013-09-08','13:10:00',1.8),('8998','2013-09-08','13:15:00',2.22),('8998','2013-09-08','13:20:00',1.81),('8998','2013-09-08','13:25:00',1.59),('8998','2013-09-08','13:30:00',1.87),('8998','2013-09-08','13:35:00',2.38),('8998','2013-09-08','13:40:00',2.3),('8998','2013-09-08','13:45:00',2.36),('8998','2013-09-08','13:50:00',2.49),('8998','2013-09-08','13:55:00',2.49),('8998','2013-09-08','14:00:00',2.2),('8998','2013-09-08','14:05:00',2.06),('8998','2013-09-08','14:10:00',2.27),('8998','2013-09-08','14:15:00',1.72),('8998','2013-09-08','14:20:00',1.34),('8998','2013-09-08','14:25:00',1.21),('8998','2013-09-08','14:30:00',1.13),('8998','2013-09-08','14:35:00',2.25),('8998','2013-09-08','14:40:00',2.08),('8998','2013-09-08','14:45:00',1.17),('8998','2013-09-08','14:50:00',1.9),('8998','2013-09-08','14:55:00',1.89),('8998','2013-09-08','15:00:00',1.51),('8998','2013-09-08','15:05:00',1.39),('8998','2013-09-08','15:10:00',1.6),('8998','2013-09-08','15:20:00',1.15),('8998','2013-09-08','15:30:00',1.54),('8998','2013-09-08','15:35:00',1.25),('8998','2013-09-08','15:40:00',1.4),('8998','2013-09-08','16:15:00',1.07),('8998','2013-09-08','16:45:00',1.09),('8998','2014-04-11','09:15:00',1.19),('8998','2014-04-11','09:20:00',1.31),('8998','2014-04-11','09:25:00',1.52),('8998','2014-04-11','09:30:00',1.4),('8998','2014-04-11','09:35:00',1.19),('8998','2014-04-11','09:40:00',1.07),('8998','2014-04-11','10:10:00',1.06),('8998','2014-04-11','10:15:00',1.13),('8998','2014-04-11','10:20:00',1.23),('8998','2014-04-11','10:25:00',1.41),('8998','2014-04-11','10:30:00',1.5),('8998','2014-04-11','10:35:00',1.67),('8998','2014-04-11','10:40:00',1.93),('8998','2014-04-11','10:45:00',1.96),('8998','2014-04-11','10:50:00',2.15),('8998','2014-04-11','10:55:00',1.81),('8998','2014-04-11','11:00:00',2.12),('8998','2014-04-11','11:05:00',2.37),('8998','2014-04-11','11:10:00',2.99),('8998','2014-04-11','11:15:00',3.19),('8998','2014-04-11','11:20:00',2.95),('8998','2014-04-11','11:25:00',2.54),('8998','2014-04-11','11:30:00',2.72),('8998','2014-04-11','11:35:00',2.94),('8998','2014-04-11','11:40:00',2.82),('8998','2014-04-11','11:45:00',2.89),('8998','2014-04-11','11:50:00',2.54),('8998','2014-04-11','11:55:00',2.03),('8998','2014-04-11','12:00:00',2.14),('8998','2014-04-11','12:05:00',1.15),('8998','2014-04-11','12:10:00',2.16),('8998','2014-04-11','12:15:00',2.03),('8998','2014-04-11','12:20:00',1.55),('8998','2014-04-11','12:25:00',1.8),('8998','2014-04-11','12:30:00',1.86),('8998','2014-04-11','12:35:00',1.81),('8998','2014-04-11','12:40:00',1.99),('8998','2014-04-11','12:45:00',2.33),('8998','2014-04-11','12:50:00',2.05),('8998','2014-04-11','12:55:00',1.08),('8998','2014-04-11','13:00:00',1.03),('8998','2014-04-11','13:05:00',1.23),('8998','2014-04-11','13:10:00',2.27),('8998','2014-04-11','13:15:00',2.69),('8998','2014-04-11','13:20:00',2.85),('8998','2014-04-11','13:25:00',2.53),('8998','2014-04-11','13:30:00',2.96),('8998','2014-04-11','13:35:00',2.1),('8998','2014-04-11','13:40:00',1.73),('8998','2014-04-11','13:50:00',1.9),('8998','2014-04-11','13:55:00',1.35),('8998','2014-04-11','14:05:00',1.51),('8998','2014-04-11','14:10:00',2.08),('8998','2014-04-11','14:15:00',2.65),('8998','2014-04-11','14:20:00',1.83),('8998','2014-04-11','14:25:00',2.28),('8998','2014-04-11','14:30:00',2.02),('8998','2014-04-11','14:35:00',1.59),('8998','2014-04-11','14:40:00',1.3),('8998','2014-04-11','14:45:00',1.08),('8998','2014-04-11','14:50:00',1.78),('8998','2014-04-11','14:55:00',2.29),('8998','2014-04-11','15:00:00',1.77),('8998','2014-04-11','15:05:00',1.86),('8998','2014-04-11','15:10:00',1.91),('8998','2014-04-11','15:15:00',1.74),('8998','2014-04-11','15:20:00',1.62),('8998','2014-04-11','15:25:00',1.5),('8998','2014-04-11','15:35:00',1.28),('8998','2014-04-11','15:40:00',1.47),('8998','2014-04-11','15:45:00',1.52),('8998','2014-04-11','15:50:00',1.63),('8998','2014-04-11','15:55:00',1.57),('8998','2014-04-11','16:00:00',1.51),('8998','2014-04-11','16:05:00',1.46),('8998','2014-04-11','16:10:00',1.43),('8998','2014-04-11','16:15:00',1.32),('8998','2014-04-11','16:20:00',1.38),('8998','2014-04-11','16:25:00',1.27),('8998','2014-04-11','16:30:00',1.18),('8998','2014-04-11','16:35:00',1.08),('8998','2013-09-07','11:35:00',2.46),('8998','2013-09-07','11:40:00',2.48),('8998','2013-09-07','11:45:00',2.46),('8998','2013-09-07','11:50:00',2.42),('8998','2013-09-07','11:55:00',2.4),('8998','2013-09-07','12:00:00',2.38),('8998','2013-09-07','12:05:00',2.37),('8998','2013-09-07','12:10:00',2.4),('8998','2013-09-07','12:15:00',2.49),('8998','2013-09-07','12:20:00',2.5),('8998','2013-09-07','12:25:00',2.4),('8998','2013-09-07','12:30:00',2.41),('8998','2013-09-07','12:35:00',2.47),('8998','2013-09-07','12:40:00',2.37),('8998','2013-09-07','12:45:00',2.3),('8998','2013-09-07','12:50:00',2.33),('8998','2013-09-07','12:55:00',2.33),('8998','2013-09-07','13:00:00',2.29),('8998','2013-09-07','13:05:00',2.32),('8998','2013-09-07','13:10:00',2.34),('8998','2013-09-07','13:15:00',2.25),('8998','2013-09-07','13:20:00',2.2),('8998','2013-09-07','13:25:00',2.09),('8998','2013-09-07','13:30:00',1.96),('8998','2013-09-07','13:35:00',1.97),('8998','2013-09-07','13:40:00',1.52),('8998','2013-09-07','13:45:00',1.3),('8998','2013-09-07','13:50:00',1.47),('8998','2013-09-07','13:55:00',1.57),('8998','2013-09-07','14:00:00',1.94),('8998','2013-09-07','14:05:00',1.97),('8998','2013-09-07','14:10:00',2.06),('8998','2013-09-07','14:15:00',1.9),('8998','2013-09-07','14:20:00',1.75),('8998','2013-09-07','14:25:00',2.26),('8998','2013-09-07','14:30:00',1.91),('8998','2013-09-07','14:35:00',2.04),('8998','2013-09-07','14:40:00',1.91),('8998','2013-09-07','14:45:00',1.87),('8998','2013-09-07','14:50:00',1.82),('8998','2013-09-07','14:55:00',1.75),('8998','2013-09-07','15:00:00',1.71),('8998','2013-09-07','15:05:00',1.45),('8998','2013-09-07','15:15:00',1.27),('8998','2013-09-07','15:20:00',1.58),('8998','2013-09-07','15:25:00',1.6),('8998','2013-09-07','15:30:00',1.56),('8998','2013-09-07','15:35:00',1.46),('8998','2013-09-07','15:40:00',1.32),('8998','2013-09-07','15:45:00',1.31),('8998','2013-09-07','15:50:00',1.29),('8998','2013-09-07','15:55:00',1.02),('8998','2013-09-07','16:00:00',1.01),('8998','2014-04-10','08:30:00',1.38),('8998','2014-04-10','08:35:00',1.42),('8998','2014-04-10','08:40:00',1.47),('8998','2014-04-10','08:45:00',1.68),('8998','2014-04-10','08:50:00',1.91),('8998','2014-04-10','08:55:00',2.08),('8998','2014-04-10','09:00:00',2.12),('8998','2014-04-10','09:05:00',2.16),('8998','2014-04-10','09:10:00',2.19),('8998','2014-04-10','09:15:00',2.2),('8998','2014-04-10','09:20:00',2.25),('8998','2014-04-10','09:25:00',2.36),('8998','2014-04-10','09:30:00',2.41),('8998','2014-04-10','09:35:00',2.45),('8998','2014-04-10','09:40:00',2.47),('8998','2014-04-10','09:45:00',2.49),('8998','2014-04-10','09:50:00',2.52),('8998','2014-04-10','09:55:00',2.56),('8998','2014-04-10','10:00:00',2.59),('8998','2014-04-10','10:05:00',2.64),('8998','2014-04-10','10:10:00',2.67),('8998','2014-04-10','10:15:00',2.73),('8998','2014-04-10','10:20:00',2.72),('8998','2014-04-10','10:25:00',2.73),('8998','2014-04-10','10:30:00',2.77),('8998','2014-04-10','10:35:00',2.77),('8998','2014-04-10','10:40:00',2.78),('8998','2014-04-10','10:45:00',2.8),('8998','2014-04-10','10:50:00',2.84),('8998','2014-04-10','10:55:00',2.86),('8998','2014-04-10','11:00:00',2.89),('8998','2014-04-10','11:05:00',2.89),('8998','2014-04-10','11:10:00',2.9),('8998','2014-04-10','11:15:00',2.88),('8998','2014-04-10','11:20:00',2.87),('8998','2014-04-10','11:25:00',2.98),('8998','2014-04-10','11:30:00',2.96),('8998','2014-04-10','11:35:00',2.98),('8998','2014-04-10','11:40:00',2.91),('8998','2014-04-10','11:45:00',2.94),('8998','2014-04-10','11:50:00',2.95),('8998','2014-04-10','11:55:00',3),('8998','2014-04-10','12:00:00',3.13),('8998','2014-04-10','12:05:00',2.68),('8998','2014-04-10','12:10:00',2.09),('8998','2014-04-10','12:15:00',3.18),('8998','2014-04-10','12:20:00',3),('8998','2014-04-10','12:25:00',1.85),('8998','2014-04-10','12:30:00',3.03),('8998','2014-04-10','12:35:00',3.1),('8998','2014-04-10','12:40:00',1.44),('8998','2014-04-10','12:45:00',3.2),('8998','2014-04-10','12:50:00',3.16),('8998','2014-04-10','12:55:00',3.04),('8998','2014-04-10','13:00:00',2.96),('8998','2014-04-10','13:05:00',1.53),('8998','2014-04-10','13:10:00',1.6),('8998','2014-04-10','13:15:00',2.41),('8998','2014-04-10','13:20:00',2.34),('8998','2014-04-10','13:25:00',2.98),('8998','2014-04-10','13:30:00',1.8),('8998','2014-04-10','13:35:00',1.85),('8998','2014-04-10','13:40:00',2.99),('8998','2014-04-10','13:45:00',2.48),('8998','2014-04-10','13:50:00',2.79),('8998','2014-04-10','13:55:00',1.95),('8998','2014-04-10','14:00:00',2.2),('8998','2014-04-10','14:05:00',2.32),('8998','2014-04-10','14:10:00',2.51),('8998','2014-04-10','14:15:00',2.17),('8998','2014-04-10','14:20:00',1.7),('8998','2014-04-10','14:25:00',2.26),('8998','2014-04-10','14:30:00',2.47),('8998','2014-04-10','14:35:00',2.21),('8998','2014-04-10','14:40:00',2.62),('8998','2014-04-10','14:45:00',2.35),('8998','2014-04-10','14:50:00',2.64),('8998','2014-04-10','14:55:00',2),('8998','2014-04-10','15:00:00',1.53),('8998','2014-04-10','15:05:00',2.12),('8998','2014-04-10','15:10:00',2.18),('8998','2014-04-10','15:15:00',1.96),('8998','2014-04-10','15:20:00',1.74),('8998','2014-04-10','15:25:00',2),('8998','2014-04-10','15:30:00',1.79),('8998','2014-04-10','15:35:00',1.75),('8998','2014-04-10','15:40:00',1.55),('8998','2014-04-10','15:45:00',1.56),('8998','2014-04-10','15:50:00',1.51),('8998','2014-04-10','15:55:00',1.5),('8998','2014-04-10','16:00:00',1.42),('8998','2014-04-10','16:05:00',1.34),('8998','2014-04-10','16:10:00',1.27),('8998','2014-04-10','16:15:00',1.2),('8998','2014-04-10','16:20:00',1.13),('8998','2014-04-10','16:25:00',1.08),('8998','2014-04-10','16:30:00',1.03),('8998','2013-08-27','08:10:00',1.29),('8998','2013-08-27','08:15:00',1.38),('8998','2013-08-27','08:20:00',1.42),('8998','2013-08-27','08:25:00',1.38),('8998','2013-08-27','08:30:00',1.32),('8998','2013-08-27','08:35:00',1.42),('8998','2013-08-27','08:40:00',1.4),('8998','2013-08-27','08:45:00',1.32),('8998','2013-08-27','08:50:00',1.04),('8998','2013-08-27','08:55:00',1.04),('8998','2013-08-27','09:00:00',1.57),('8998','2013-08-27','09:05:00',1.3),('8998','2013-08-27','09:10:00',1.26),('8998','2013-08-27','09:15:00',1.34),('8998','2013-08-27','09:20:00',1.18),('8998','2013-08-27','09:30:00',1.1),('8998','2013-08-27','09:35:00',2.36),('8998','2013-08-27','09:40:00',2.45),('8998','2013-08-27','09:45:00',2.47),('8998','2013-08-27','09:50:00',2.5),('8998','2013-08-27','09:55:00',2.49),('8998','2013-08-27','10:00:00',2.49),('8998','2013-08-27','10:05:00',2.54),('8998','2013-08-27','10:10:00',1.16),('8998','2013-08-27','10:15:00',2.58),('8998','2013-08-27','10:20:00',2.64),('8998','2013-08-27','10:25:00',1.93),('8998','2013-08-27','10:30:00',1.97),('8998','2013-08-27','10:35:00',1.73),('8998','2013-08-27','10:40:00',2.35),('8998','2013-08-27','10:45:00',1.92),('8998','2013-08-27','10:50:00',2.82),('8998','2013-08-27','10:55:00',2.84),('8998','2013-08-27','11:00:00',2.19),('8998','2013-08-27','11:05:00',1.67),('8998','2013-08-27','11:10:00',1.99),('8998','2013-08-27','11:15:00',2.48),('8998','2013-08-27','11:20:00',2.57),('8998','2013-08-27','11:25:00',2.96),('8998','2013-08-27','11:30:00',2.99),('8998','2013-08-27','11:35:00',2.91),('8998','2013-08-27','11:40:00',3.08),('8998','2013-08-27','11:45:00',2.56),('8998','2013-08-27','11:50:00',1.42),('8998','2013-08-27','11:55:00',2.48),('8998','2013-08-27','12:00:00',1.22),('8998','2013-08-27','12:05:00',2.34),('8998','2013-08-27','12:10:00',2.93),('8998','2013-08-27','12:15:00',2.92),('8998','2013-08-27','12:20:00',2.91),('8998','2013-08-27','12:25:00',2.78),('8998','2013-08-27','12:30:00',2.91),('8998','2013-08-27','12:35:00',2.85),('8998','2013-08-27','12:40:00',2.72),('8998','2013-08-27','12:45:00',2.89),('8998','2013-08-27','12:50:00',2.88),('8998','2013-08-27','12:55:00',2.8),('8998','2013-08-27','13:00:00',2.8),('8998','2013-08-27','13:05:00',2.41),('8998','2013-08-27','13:10:00',2.67),('8998','2013-08-27','13:15:00',2.83),('8998','2013-08-27','13:20:00',2.71),('8998','2013-08-27','13:25:00',2.7),('8998','2013-08-27','13:30:00',2.68),('8998','2013-08-27','13:35:00',2.61),('8998','2013-08-27','13:40:00',2.6),('8998','2013-08-27','13:45:00',2.42),('8998','2013-08-27','13:50:00',2.5),('8998','2013-08-27','13:55:00',2.47),('8998','2013-08-27','14:00:00',2.21),('8998','2013-08-27','14:05:00',2.5),('8998','2013-08-27','14:10:00',2.37),('8998','2013-08-27','14:15:00',2.48),('8998','2013-08-27','14:20:00',2.37),('8998','2013-08-27','14:25:00',2.32),('8998','2013-08-27','14:30:00',2.2),('8998','2013-08-27','14:35:00',1.74),('8998','2013-08-27','14:40:00',1.61),('8998','2013-08-27','14:45:00',2.25),('8998','2013-08-27','14:50:00',2.13),('8998','2013-08-27','14:55:00',2.07),('8998','2013-08-27','15:00:00',2),('8998','2013-08-27','15:05:00',1.96),('8998','2013-08-27','15:10:00',1.96),('8998','2013-08-27','15:15:00',1.92),('8998','2013-08-27','15:20:00',1.86),('8998','2013-08-27','15:25:00',1.77),('8998','2013-08-27','15:30:00',1.16),('8998','2013-08-27','15:35:00',1.15),('8998','2013-08-27','15:40:00',1.27),('8998','2013-08-27','15:50:00',1.47),('8998','2013-08-27','15:55:00',1.16),('8998','2013-08-27','16:00:00',1.45),('8998','2013-08-27','16:05:00',1.45),('8998','2013-08-27','16:10:00',1.44),('8998','2013-08-27','16:15:00',1.26),('8998','2013-08-27','16:25:00',1.26),('8998','2013-08-27','16:30:00',1.12),('8998','2013-08-26','08:20:00',1.05),('8998','2013-08-26','08:25:00',1.38),('8998','2013-08-26','08:30:00',1.41),('8998','2013-08-26','08:35:00',1.03),('8998','2013-08-26','08:45:00',1.15),('8998','2013-08-26','09:10:00',1.14),('8998','2013-08-26','09:15:00',1.18),('8998','2013-08-26','09:20:00',1.31),('8998','2013-08-26','09:25:00',1.76),('8998','2013-08-26','09:30:00',2.04),('8998','2013-08-26','09:35:00',1.2),('8998','2013-08-26','09:55:00',1.26),('8998','2013-08-26','10:00:00',1.69),('8998','2013-08-26','10:05:00',2.05),('8998','2013-08-26','10:10:00',2.47),('8998','2013-08-26','10:15:00',2.52),('8998','2013-08-26','10:20:00',2.61),('8998','2013-08-26','10:25:00',2.61),('8998','2013-08-26','10:30:00',2.61),('8998','2013-08-26','10:35:00',2.65),('8998','2013-08-26','10:40:00',2.58),('8998','2013-08-26','10:45:00',2.65),('8998','2013-08-26','10:50:00',2.68),('8998','2013-08-26','10:55:00',2.65),('8998','2013-08-26','11:00:00',2.67),('8998','2013-08-26','11:05:00',2.72),('8998','2013-08-26','11:10:00',2.68),('8998','2013-08-26','11:15:00',2.66),('8998','2013-08-26','11:20:00',2.51),('8998','2013-08-26','11:25:00',2.66),('8998','2013-08-26','11:30:00',2.68),('8998','2013-08-26','11:35:00',2.67),('8998','2013-08-26','11:40:00',2.55),('8998','2013-08-26','11:45:00',2.97),('8998','2013-08-26','11:50:00',2.7),('8998','2013-08-26','11:55:00',2.83),('8998','2013-08-26','12:00:00',2.92),('8998','2013-08-26','12:05:00',2.95),('8998','2013-08-26','12:10:00',2.42),('8998','2013-08-26','12:15:00',2.41),('8998','2013-08-26','12:20:00',2.66),('8998','2013-08-26','12:25:00',2.53),('8998','2013-08-26','12:30:00',2.66),('8998','2013-08-26','12:35:00',2.89),('8998','2013-08-26','12:40:00',2.6),('8998','2013-08-26','12:45:00',2.12),('8998','2013-08-26','12:50:00',1.67),('8998','2013-08-26','12:55:00',1.54),('8998','2013-08-26','13:00:00',1.1),('8998','2013-08-26','13:05:00',1.21),('8998','2013-08-26','13:10:00',1.71),('8998','2013-08-26','13:15:00',1.25),('8998','2013-08-26','13:20:00',1.24),('8998','2013-08-26','13:25:00',1.31),('8998','2013-08-26','13:30:00',1.69),('8998','2013-08-26','13:35:00',1.35),('8998','2013-08-26','13:40:00',1.34),('8998','2013-08-26','13:45:00',1.45),('8998','2013-08-26','13:50:00',2.63),('8998','2013-08-26','13:55:00',2.03),('8998','2013-08-26','14:00:00',2.24),('8998','2013-08-26','14:05:00',1.52),('8998','2013-08-26','14:10:00',1.3),('8998','2013-08-26','14:15:00',2.14),('8998','2013-08-26','14:20:00',1.7),('8998','2013-08-26','14:25:00',1),('8998','2013-08-26','16:10:00',1.57),('8998','2013-08-26','16:15:00',1.6),('8998','2013-08-26','17:10:00',1.01),('8998','2013-08-25','08:05:00',1.34),('8998','2013-08-25','08:10:00',1.25),('8998','2013-08-25','08:20:00',1.44),('8998','2013-08-25','08:25:00',1.22),('8998','2013-08-25','08:30:00',1.67),('8998','2013-08-25','08:35:00',1.4),('8998','2013-08-25','08:40:00',1.56),('8998','2013-08-25','08:45:00',1.46),('8998','2013-08-25','08:50:00',1.65),('8998','2013-08-25','08:55:00',1.9),('8998','2013-08-25','09:00:00',1.94),('8998','2013-08-25','09:05:00',1.96),('8998','2013-08-25','09:10:00',2.03),('8998','2013-08-25','09:15:00',2.09),('8998','2013-08-25','09:20:00',2.15),('8998','2013-08-25','09:25:00',2.18),('8998','2013-08-25','09:30:00',2.23),('8998','2013-08-25','09:35:00',2.26),('8998','2013-08-25','09:40:00',2.31),('8998','2013-08-25','09:45:00',2.36),('8998','2013-08-25','09:50:00',2.39),('8998','2013-08-25','09:55:00',2.41),('8998','2013-08-25','10:00:00',2.43),('8998','2013-08-25','10:05:00',2.47),('8998','2013-08-25','10:10:00',2.49),('8998','2013-08-25','10:15:00',2.5),('8998','2013-08-25','10:20:00',2.56),('8998','2013-08-25','10:25:00',2.61),('8998','2013-08-25','10:30:00',2.61),('8998','2013-08-25','10:35:00',2.62),('8998','2013-08-25','10:40:00',2.63),('8998','2013-08-25','10:45:00',2.65),('8998','2013-08-25','10:50:00',2.65),('8998','2013-08-25','10:55:00',2.71),('8998','2013-08-25','11:00:00',2.7),('8998','2013-08-25','11:05:00',2.71),('8998','2013-08-25','11:10:00',2.71),('8998','2013-08-25','11:15:00',2.73),('8998','2013-08-25','11:20:00',2.74),('8998','2013-08-25','11:25:00',2.72),('8998','2013-08-25','11:30:00',2.72),('8998','2013-08-25','11:35:00',2.76),('8998','2013-08-25','11:40:00',2.76),('8998','2013-08-25','11:45:00',2.74),('8998','2013-08-25','11:50:00',2.73),('8998','2013-08-25','11:55:00',2.73),('8998','2013-08-25','12:00:00',2.75),('8998','2013-08-25','12:05:00',2.74),('8998','2013-08-25','12:10:00',2.74),('8998','2013-08-25','12:15:00',2.74),('8998','2013-08-25','12:20:00',2.72),('8998','2013-08-25','12:25:00',2.68),('8998','2013-08-25','12:30:00',2.66),('8998','2013-08-25','12:35:00',2.65),('8998','2013-08-25','12:40:00',2.66),('8998','2013-08-25','12:45:00',2.66),('8998','2013-08-25','12:50:00',2.66),('8998','2013-08-25','12:55:00',2.64),('8998','2013-08-25','13:00:00',2.74),('8998','2013-08-25','13:05:00',3.04),('8998','2013-08-25','13:10:00',2.71),('8998','2013-08-25','13:15:00',1.85),('8998','2013-08-25','13:20:00',2.01),('8998','2013-08-25','13:25:00',1.82),('8998','2013-08-25','13:30:00',1.83),('8998','2013-08-25','13:35:00',2.42),('8998','2013-08-25','13:40:00',2.46),('8998','2013-08-25','13:45:00',2.43),('8998','2013-08-25','13:50:00',2.49),('8998','2013-08-25','13:55:00',1.97),('8998','2013-08-25','14:00:00',1.88),('8998','2013-08-25','14:05:00',2.35),('8998','2013-08-25','14:10:00',1.41),('8998','2013-08-25','14:15:00',2.38),('8998','2013-08-25','14:20:00',2.23),('8998','2013-08-25','14:25:00',2.16),('8998','2013-08-25','14:30:00',2.14),('8998','2013-08-25','14:35:00',2.06),('8998','2013-08-25','14:40:00',1.86),('8998','2013-08-25','14:45:00',1.48),('8998','2013-08-25','14:50:00',1.19),('8998','2013-08-25','14:55:00',1.08),('8998','2013-08-25','15:00:00',1.07),('8998','2013-08-25','15:45:00',1.06),('8998','2013-08-25','15:50:00',1.01),('8998','2013-08-25','16:00:00',1.13),('8998','2013-08-25','16:05:00',1.64),('8998','2013-08-25','16:10:00',1.33),('8998','2013-08-25','16:15:00',1.16),('8998','2013-08-25','16:20:00',1.12),('8998','2013-08-25','16:25:00',1.04),('8998','2013-08-24','08:05:00',1.01),('8998','2013-08-24','08:10:00',1.16),('8998','2013-08-24','08:15:00',1.17),('8998','2013-08-24','08:20:00',1.03),('8998','2013-08-24','08:25:00',1.09),('8998','2013-08-24','08:30:00',1.04),('8998','2013-08-24','08:45:00',1.41),('8998','2013-08-24','09:20:00',1.87),('8998','2013-08-24','09:25:00',1.77),('8998','2013-08-24','09:30:00',2.03),('8998','2013-08-24','09:35:00',1.63),('8998','2013-08-24','09:40:00',2.59),('8998','2013-08-24','09:45:00',2.78),('8998','2013-08-24','09:50:00',2.5),('8998','2013-08-24','09:55:00',2.73),('8998','2013-08-24','10:00:00',1.96),('8998','2013-08-24','10:05:00',1.36),('8998','2013-08-24','15:25:00',1.05),('8998','2013-08-24','15:30:00',1.37),('8998','2013-08-24','15:35:00',1.89),('8998','2013-08-24','15:40:00',1.9),('8998','2013-08-24','15:45:00',1.93),('8998','2013-08-24','15:50:00',1.57),('8998','2013-08-24','16:00:00',1.64),('8998','2013-08-24','16:05:00',1.5),('8998','2013-08-24','16:10:00',1.38),('8998','2013-08-24','16:15:00',1.29),('8998','2013-08-24','16:20:00',1.21),('8998','2013-08-24','16:25:00',1.15),('8998','2013-08-24','16:30:00',1.08),('8998','2013-08-23','08:25:00',1.31),('8998','2013-08-23','08:30:00',1.3),('8998','2013-08-23','08:35:00',1.43),('8998','2013-08-23','08:40:00',1.55),('8998','2013-08-23','08:45:00',1.53),('8998','2013-08-23','08:50:00',1.41),('8998','2013-08-23','08:55:00',1.79),('8998','2013-08-23','09:00:00',1.89),('8998','2013-08-23','09:05:00',1.88),('8998','2013-08-23','09:10:00',1.99),('8998','2013-08-23','09:15:00',1.82),('8998','2013-08-23','09:20:00',2.07),('8998','2013-08-23','09:25:00',1.75),('8998','2013-08-23','09:30:00',1.69),('8998','2013-08-23','09:35:00',1.58),('8998','2013-08-23','09:40:00',2.27),('8998','2013-08-23','09:45:00',1.53),('8998','2013-08-23','09:50:00',1.94),('8998','2013-08-23','09:55:00',2.06),('8998','2013-08-23','10:00:00',2.52),('8998','2013-08-23','10:05:00',2.51),('8998','2013-08-23','10:10:00',2.53),('8998','2013-08-23','10:15:00',2.53),('8998','2013-08-23','10:20:00',2.55),('8998','2013-08-23','10:25:00',2.56),('8998','2013-08-23','10:30:00',2.57),('8998','2013-08-23','10:35:00',2.57),('8998','2013-08-23','10:40:00',2.62),('8998','2013-08-23','10:45:00',2.62),('8998','2013-08-23','10:50:00',2.34),('8998','2013-08-23','10:55:00',2.36),('8998','2013-08-23','11:00:00',2.69),('8998','2013-08-23','11:05:00',2.7),('8998','2013-08-23','11:10:00',2.72),('8998','2013-08-23','11:15:00',2.72),('8998','2013-08-23','11:20:00',2.74),('8998','2013-08-23','11:25:00',2.73),('8998','2013-08-23','11:30:00',2.68),('8998','2013-08-23','11:35:00',2.73),('8998','2013-08-23','11:40:00',2.72),('8998','2013-08-23','11:45:00',2.71),('8998','2013-08-23','11:50:00',2.74),('8998','2013-08-23','11:55:00',2.71),('8998','2013-08-23','12:00:00',2.71),('8998','2013-08-23','12:05:00',2.69),('8998','2013-08-23','12:10:00',2.69),('8998','2013-08-23','12:15:00',2.71),('8998','2013-08-23','12:20:00',2.69),('8998','2013-08-23','12:25:00',2.69),('8998','2013-08-23','12:30:00',2.66),('8998','2013-08-23','12:35:00',2.66),('8998','2013-08-23','12:40:00',2.66),('8998','2013-08-23','12:45:00',2.65),('8998','2013-08-23','12:50:00',2.63),('8998','2013-08-23','12:55:00',2.6),('8998','2013-08-23','13:00:00',2.54),('8998','2013-08-23','13:05:00',2.56),('8998','2013-08-23','13:10:00',2.57),('8998','2013-08-23','13:15:00',2.55),('8998','2013-08-23','13:20:00',2.54),('8998','2013-08-23','13:25:00',2.53),('8998','2013-08-23','13:30:00',2.51),('8998','2013-08-23','13:35:00',2.48),('8998','2013-08-23','13:40:00',2.45),('8998','2013-08-23','13:45:00',2.43),('8998','2013-08-23','13:50:00',2.42),('8998','2013-08-23','13:55:00',2.38),('8998','2013-08-23','14:00:00',2.35),('8998','2013-08-23','14:05:00',2.31),('8998','2013-08-23','14:10:00',2.29),('8998','2013-08-23','14:15:00',2.25),('8998','2013-08-23','14:20:00',2.22),('8998','2013-08-23','14:25:00',2.18),('8998','2013-08-23','14:30:00',2.15),('8998','2013-08-23','14:35:00',2.12),('8998','2013-08-23','14:40:00',2.07),('8998','2013-08-23','14:45:00',2.02),('8998','2013-08-23','14:50:00',1.99),('8998','2013-08-23','14:55:00',1.95),('8998','2013-08-23','15:00:00',1.9),('8998','2013-08-23','15:05:00',1.86),('8998','2013-08-23','15:10:00',1.81),('8998','2013-08-23','15:15:00',1.77),('8998','2013-08-23','15:20:00',1.71),('8998','2013-08-23','15:25:00',1.67),('8998','2013-08-23','15:30:00',1.62),('8998','2013-08-23','15:35:00',1.57),('8998','2013-08-23','15:40:00',1.52),('8998','2013-08-23','15:45:00',1.46),('8998','2013-08-23','15:50:00',1.42),('8998','2013-08-23','15:55:00',1.36),('8998','2013-08-23','16:00:00',1.31),('8998','2013-08-23','16:05:00',1.26),('8998','2013-08-23','16:10:00',1.21),('8998','2013-08-23','16:15:00',1.16),('8998','2013-08-23','16:20:00',1.1),('8998','2013-08-23','16:25:00',1.04),('8998','2013-08-22','08:15:00',1.01),('8998','2013-08-22','08:20:00',1.07),('8998','2013-08-22','08:25:00',1.14),('8998','2013-08-22','08:30:00',1.2),('8998','2013-08-22','08:35:00',1.25),('8998','2013-08-22','08:40:00',1.27),('8998','2013-08-22','08:45:00',1.31),('8998','2013-08-22','08:50:00',1.37),('8998','2013-08-22','08:55:00',1.39),('8998','2013-08-22','09:00:00',1.44),('8998','2013-08-22','09:05:00',1.49),('8998','2013-08-22','09:10:00',1.53),('8998','2013-08-22','09:15:00',1.54),('8998','2013-08-22','09:20:00',1.58),('8998','2013-08-22','09:25:00',1.66),('8998','2013-08-22','09:30:00',1.93),('8998','2013-08-22','09:35:00',1.97),('8998','2013-08-22','09:40:00',2.01),('8998','2013-08-22','09:45:00',2.09),('8998','2013-08-22','09:50:00',2.16),('8998','2013-08-22','09:55:00',2.18),('8998','2013-08-22','10:00:00',2.24),('8998','2013-08-22','10:05:00',2.24),('8998','2013-08-22','10:10:00',2.23),('8998','2013-08-22','10:15:00',2.28),('8998','2013-08-22','10:20:00',2.33),('8998','2013-08-22','10:25:00',2.35),('8998','2013-08-22','10:30:00',2.36),('8998','2013-08-22','10:35:00',2.38),('8998','2013-08-22','10:40:00',2.36),('8998','2013-08-22','10:45:00',2.41),('8998','2013-08-22','10:50:00',2.41),('8998','2013-08-22','10:55:00',2.38),('8998','2013-08-22','11:00:00',2.41),('8998','2013-08-22','11:05:00',2.52),('8998','2013-08-22','11:10:00',2.55),('8998','2013-08-22','11:15:00',2.02),('8998','2013-08-22','11:20:00',1.64),('8998','2013-08-22','11:25:00',2.23),('8998','2013-08-22','11:30:00',2.67),('8998','2013-08-22','11:35:00',1.87),('8998','2013-08-22','11:40:00',1.8),('8998','2013-08-22','11:45:00',2.61),('8998','2013-08-22','11:50:00',2.63),('8998','2013-08-22','11:55:00',2.6),('8998','2013-08-22','12:00:00',2.15),('8998','2013-08-22','12:05:00',1.61),('8998','2013-08-22','12:15:00',1.46),('8998','2013-08-22','13:10:00',1.07),('8998','2013-08-22','13:15:00',1.76),('8998','2013-08-22','13:25:00',1.71),('8998','2013-08-22','13:30:00',2.75),('8998','2013-08-22','13:35:00',2.46),('8998','2013-08-22','13:40:00',1.92),('8998','2013-08-22','13:45:00',2.47),('8998','2013-08-22','13:50:00',1.51),('8998','2013-08-22','13:55:00',2.06),('8998','2013-08-22','14:00:00',2.71),('8998','2013-08-22','14:05:00',2.52),('8998','2013-08-22','14:10:00',2.49),('8998','2013-08-22','14:15:00',2.48),('8998','2013-08-22','14:20:00',2.11),('8998','2013-08-22','14:25:00',1.9),('8998','2013-08-22','14:30:00',2.2),('8998','2013-08-22','14:35:00',2.21),('8998','2013-08-22','14:40:00',2.19),('8998','2013-08-22','14:45:00',2.12),('8998','2013-08-22','14:50:00',2.02),('8998','2013-08-22','14:55:00',1.91),('8998','2013-08-22','15:00:00',1.83),('8998','2013-08-22','15:05:00',1.74),('8998','2013-08-22','15:10:00',1.76),('8998','2013-08-22','15:15:00',1.75),('8998','2013-08-22','15:20:00',1.7),('8998','2013-08-22','15:25:00',1.68),('8998','2013-08-22','15:30:00',1.72),('8998','2013-08-22','15:35:00',1.57),('8998','2013-08-22','15:40:00',1.51),('8998','2013-08-22','15:45:00',1.48),('8998','2013-08-22','15:50:00',1.36),('8998','2013-08-22','15:55:00',1.37),('8998','2013-08-22','16:00:00',1.3),('8998','2013-08-22','16:05:00',1.2),('8998','2013-08-22','16:10:00',1.03),('8998','2013-08-22','16:15:00',1.05),('8998','2013-08-22','16:20:00',1.19),('8998','2013-08-22','16:25:00',1.07),('8998','2013-08-22','16:30:00',1.01),('8998','2013-08-22','16:35:00',1.02),('8998','2013-08-21','08:10:00',1.02),('8998','2013-08-21','08:15:00',1.08),('8998','2013-08-21','08:20:00',1.16),('8998','2013-08-21','08:25:00',1.18),('8998','2013-08-21','08:30:00',1.23),('8998','2013-08-21','08:35:00',1.28),('8998','2013-08-21','08:40:00',1.31),('8998','2013-08-21','08:45:00',1.36),('8998','2013-08-21','08:50:00',1.4),('8998','2013-08-21','08:55:00',1.46),('8998','2013-08-21','09:00:00',1.53),('8998','2013-08-21','09:05:00',1.62),('8998','2013-08-21','09:10:00',1.68),('8998','2013-08-21','09:15:00',1.73),('8998','2013-08-21','09:20:00',1.78),('8998','2013-08-21','09:25:00',1.7),('8998','2013-08-21','09:30:00',1.65),('8998','2013-08-21','09:35:00',1.1),('8998','2013-08-21','09:40:00',1.25),('8998','2013-08-21','09:45:00',1.63),('8998','2013-08-21','09:50:00',1.96),('8998','2013-08-21','09:55:00',2.22),('8998','2013-08-21','10:00:00',2.59),('8998','2013-08-21','10:05:00',2.6),('8998','2013-08-21','10:10:00',2.59),('8998','2013-08-21','10:15:00',2.54),('8998','2013-08-21','10:20:00',2.52),('8998','2013-08-21','10:25:00',2.55),('8998','2013-08-21','10:30:00',2.57),('8998','2013-08-21','10:35:00',2.56),('8998','2013-08-21','10:40:00',2.59),('8998','2013-08-21','10:45:00',2.6),('8998','2013-08-21','10:50:00',2.62),('8998','2013-08-21','10:55:00',2.63),('8998','2013-08-21','11:00:00',2.63),('8998','2013-08-21','11:05:00',2.63),('8998','2013-08-21','11:10:00',2.64),('8998','2013-08-21','11:15:00',2.65),('8998','2013-08-21','11:20:00',2.63),('8998','2013-08-21','11:25:00',2.64),('8998','2013-08-21','11:30:00',2.67),('8998','2013-08-21','11:35:00',2.67),('8998','2013-08-21','11:40:00',2.67),('8998','2013-08-21','11:45:00',2.67),('8998','2013-08-21','11:50:00',2.67),('8998','2013-08-21','11:55:00',2.67),('8998','2013-08-21','12:00:00',2.66),('8998','2013-08-21','12:05:00',2.66),('8998','2013-08-21','12:10:00',2.66),('8998','2013-08-21','12:15:00',2.65),('8998','2013-08-21','12:20:00',2.64),('8998','2013-08-21','12:25:00',2.63),('8998','2013-08-21','12:30:00',2.61),('8998','2013-08-21','12:35:00',2.61),('8998','2013-08-21','12:40:00',2.59),('8998','2013-08-21','12:45:00',2.59),('8998','2013-08-21','12:50:00',2.57),('8998','2013-08-21','12:55:00',2.55),('8998','2013-08-21','13:00:00',2.38),('8998','2013-08-21','13:05:00',2.38),('8998','2013-08-21','13:10:00',2.41),('8998','2013-08-21','13:15:00',2.43),('8998','2013-08-21','13:20:00',2.39),('8998','2013-08-21','13:25:00',2.4),('8998','2013-08-21','13:30:00',2.38),('8998','2013-08-21','13:35:00',2.37),('8998','2013-08-21','13:40:00',2.37),('8998','2013-08-21','13:45:00',2.35),('8998','2013-08-21','13:50:00',2.33),('8998','2013-08-21','13:55:00',2.3),('8998','2013-08-21','14:00:00',2.26),('8998','2013-08-21','14:05:00',2.25),('8998','2013-08-21','14:10:00',2.23),('8998','2013-08-21','14:15:00',2.2),('8998','2013-08-21','14:20:00',2.19),('8998','2013-08-21','14:25:00',2.19),('8998','2013-08-21','14:30:00',2.09),('8998','2013-08-21','14:35:00',2.1),('8998','2013-08-21','14:40:00',1.91),('8998','2013-08-21','14:45:00',2.05),('8998','2013-08-21','14:50:00',1.99),('8998','2013-08-21','14:55:00',1.84),('8998','2013-08-21','15:00:00',1.89),('8998','2013-08-21','15:05:00',1.87),('8998','2013-08-21','15:10:00',1.83),('8998','2013-08-21','15:15:00',1.78),('8998','2013-08-21','15:20:00',1.7),('8998','2013-08-21','15:25:00',1.64),('8998','2013-08-21','15:30:00',1.61),('8998','2013-08-21','15:35:00',1.56),('8998','2013-08-21','15:40:00',1.53),('8998','2013-08-21','15:45:00',1.48),('8998','2013-08-21','15:50:00',1.44),('8998','2013-08-21','15:55:00',1.39),('8998','2013-08-21','16:00:00',1.34),('8998','2013-08-21','16:05:00',1.26),('8998','2013-08-21','16:10:00',1.21),('8998','2013-08-21','16:15:00',1.16),('8998','2013-08-21','16:20:00',1.11),('8998','2013-08-21','16:25:00',1.06),('8998','2013-08-21','16:30:00',1.02),('8998','2013-08-20','09:05:00',1.08),('8998','2013-08-20','09:10:00',1.09),('8998','2013-08-20','09:15:00',1.92),('8998','2013-08-20','09:20:00',2.06),('8998','2013-08-20','09:50:00',2.58),('8998','2013-08-20','09:55:00',2.96),('8998','2013-08-20','10:00:00',2.74),('8998','2013-08-20','10:05:00',2.13),('8998','2013-08-20','10:10:00',1.78),('8998','2013-08-20','10:15:00',2.2),('8998','2013-08-20','10:20:00',1.55),('8998','2013-08-20','10:25:00',1.5),('8998','2013-08-20','10:30:00',1.44),('8998','2013-08-20','10:35:00',2.77),('8998','2013-08-20','10:40:00',2.45),('8998','2013-08-20','10:45:00',2.15),('8998','2013-08-20','10:50:00',1.89),('8998','2013-08-20','10:55:00',1.37),('8998','2013-08-20','11:00:00',1.73),('8998','2013-08-20','11:05:00',1.5),('8998','2013-08-20','11:10:00',1.27),('8998','2013-08-20','11:15:00',1.64),('8998','2013-08-20','11:20:00',2.69),('8998','2013-08-20','11:25:00',2.12),('8998','2013-08-20','11:30:00',2.07),('8998','2013-08-20','11:35:00',2.94),('8998','2013-08-20','11:40:00',3.02),('8998','2013-08-20','11:45:00',2.98),('8998','2013-08-20','11:50:00',2.39),('8998','2013-08-20','11:55:00',2.75),('8998','2013-08-20','12:00:00',2.98),('8998','2013-08-20','12:05:00',2.95),('8998','2013-08-20','12:10:00',2.92),('8998','2013-08-20','12:15:00',2.89),('8998','2013-08-20','12:20:00',2.76),('8998','2013-08-20','12:25:00',1.76),('8998','2013-08-20','12:30:00',2.73),('8998','2013-08-20','12:35:00',2.44),('8998','2013-08-20','12:40:00',2.43),('8998','2013-08-20','12:45:00',2.67),('8998','2013-08-20','12:50:00',2.56),('8998','2013-08-20','12:55:00',2.44),('8998','2013-08-20','13:00:00',2.51),('8998','2013-08-20','13:05:00',2.57),('8998','2013-08-20','13:10:00',2.58),('8998','2013-08-20','13:15:00',2.59),('8998','2013-08-20','13:20:00',2.57),('8998','2013-08-20','13:25:00',2.58),('8998','2013-08-20','13:30:00',2.56),('8998','2013-08-20','13:35:00',2.53),('8998','2013-08-20','13:40:00',2.53),('8998','2013-08-20','13:45:00',2.43),('8998','2013-08-20','13:50:00',2.35),('8998','2013-08-20','13:55:00',2.31),('8998','2013-08-20','14:00:00',2.39),('8998','2013-08-20','14:05:00',2.35),('8998','2013-08-20','14:10:00',2.35),('8998','2013-08-20','14:15:00',2.36),('8998','2013-08-20','14:20:00',2.23),('8998','2013-08-20','14:25:00',1.86),('8998','2013-08-20','14:30:00',1.98),('8998','2013-08-20','14:35:00',1.9),('8998','2013-08-20','14:40:00',1.92),('8998','2013-08-20','14:45:00',1.92),('8998','2013-08-20','14:50:00',1.84),('8998','2013-08-20','14:55:00',1.79),('8998','2013-08-20','15:00:00',1.82),('8998','2013-08-20','15:05:00',1.83),('8998','2013-08-20','15:10:00',1.75),('8998','2013-08-20','15:15:00',1.69),('8998','2013-08-20','15:20:00',1.66),('8998','2013-08-20','15:25:00',1.65),('8998','2013-08-20','15:30:00',1.55),('8998','2013-08-20','15:35:00',1.47),('8998','2013-08-20','15:40:00',1.38),('8998','2013-08-20','15:45:00',1.41),('8998','2013-08-20','15:50:00',1.43),('8998','2013-08-20','15:55:00',1.29),('8998','2013-08-20','16:00:00',1.21),('8998','2013-08-20','16:05:00',1.2),('8998','2013-08-20','16:10:00',1.14),('8998','2013-08-20','16:15:00',1.16),('8998','2013-08-20','16:20:00',1.17),('8998','2013-08-20','16:25:00',1.13),('8998','2013-08-20','16:30:00',1.15),('8998','2013-08-20','16:35:00',1.08),('8998','2013-08-20','16:40:00',1.03),('8998','2013-08-19','09:05:00',1.02),('8998','2013-08-19','09:25:00',1.34),('8998','2013-08-19','09:30:00',2),('8998','2013-08-19','09:35:00',2.08),('8998','2013-08-19','09:40:00',2.4),('8998','2013-08-19','09:45:00',2.5),('8998','2013-08-19','09:50:00',2.39),('8998','2013-08-19','09:55:00',1.48),('8998','2013-08-19','10:00:00',2.97),('8998','2013-08-19','10:05:00',1.42),('8998','2013-08-19','10:10:00',1.55),('8998','2013-08-19','10:15:00',2.05),('8998','2013-08-19','10:20:00',1.44),('8998','2013-08-19','10:25:00',1.1),('8998','2013-08-19','10:50:00',1.57),('8998','2013-08-19','10:55:00',2.07),('8998','2013-08-19','11:20:00',3.08),('8998','2013-08-19','11:25:00',3.06),('8998','2013-08-19','11:30:00',1.34),('8998','2013-08-19','11:40:00',2.56),('8998','2013-08-19','11:45:00',3.05),('8998','2013-08-19','11:50:00',2.12),('8998','2013-08-19','11:55:00',3.26),('8998','2013-08-19','12:00:00',1.7),('8998','2013-08-19','12:40:00',1.17),('8998','2013-08-19','12:45:00',1.25),('8998','2013-08-19','12:50:00',1.33),('8998','2013-08-19','12:55:00',1.34),('8998','2013-08-19','13:00:00',1.31),('8998','2013-08-19','13:05:00',1.17),('8998','2013-08-19','13:10:00',1.1),('8998','2013-08-19','13:15:00',1.1),('8998','2013-08-19','13:20:00',1.14),('8998','2013-08-19','13:25:00',1.22),('8998','2013-08-19','13:30:00',1.33),('8998','2013-08-19','13:35:00',1.61),('8998','2013-08-19','13:40:00',2.42),('8998','2013-08-19','13:45:00',2.32),('8998','2013-08-19','13:50:00',2.63),('8998','2013-08-19','13:55:00',2.58),('8998','2013-08-19','14:00:00',2.51),('8998','2013-08-19','14:05:00',2.48),('8998','2013-08-19','14:10:00',2.41),('8998','2013-08-19','14:15:00',2.37),('8998','2013-08-19','14:20:00',2.36),('8998','2013-08-19','14:25:00',2.24),('8998','2013-08-19','14:30:00',1.81),('8998','2013-08-19','14:35:00',2.14),('8998','2013-08-19','14:40:00',2.13),('8998','2013-08-19','14:45:00',2.08),('8998','2013-08-19','14:50:00',2.2),('8998','2013-08-19','14:55:00',1.85),('8998','2013-08-19','15:00:00',2.21),('8998','2013-08-19','15:05:00',2.12),('8998','2013-08-19','15:10:00',2.2),('8998','2013-08-19','15:15:00',2.09),('8998','2013-08-19','15:20:00',2.03),('8998','2013-08-19','15:25:00',2),('8998','2013-08-19','15:30:00',1.97),('8998','2013-08-19','15:35:00',1.94),('8998','2013-08-19','15:40:00',1.98),('8998','2013-08-19','15:45:00',2.05),('8998','2013-08-19','15:50:00',2.06),('8998','2013-08-19','15:55:00',2.19),('8998','2013-08-19','16:00:00',2),('8998','2013-08-19','16:05:00',1.86),('8998','2013-08-19','16:10:00',1.85),('8998','2013-08-19','16:15:00',1.78),('8998','2013-08-19','16:20:00',1.7),('8998','2013-08-19','16:25:00',1.54),('8998','2013-08-19','16:30:00',1.35),('8998','2013-08-19','16:35:00',1.39),('8998','2013-08-19','16:40:00',1.42),('8998','2013-08-19','16:45:00',1.33),('8998','2013-08-19','16:50:00',1.1),('8998','2014-04-09','08:05:00',1.13),('8998','2014-04-09','08:10:00',1.22),('8998','2014-04-09','08:15:00',1.45),('8998','2014-04-09','08:20:00',1.55),('8998','2014-04-09','08:25:00',1.58),('8998','2014-04-09','08:30:00',1.51),('8998','2014-04-09','08:35:00',1.41),('8998','2014-04-09','08:40:00',1.43),('8998','2014-04-09','08:45:00',1.59),('8998','2014-04-09','08:50:00',1.93),('8998','2014-04-09','08:55:00',2.16),('8998','2014-04-09','09:00:00',2.22),('8998','2014-04-09','09:05:00',2.3),('8998','2014-04-09','09:10:00',2.34),('8998','2014-04-09','09:15:00',2.34),('8998','2014-04-09','09:20:00',2.33),('8998','2014-04-09','09:25:00',2.5),('8998','2014-04-09','09:30:00',2.57),('8998','2014-04-09','09:35:00',2.6),('8998','2014-04-09','09:40:00',2.61),('8998','2014-04-09','09:45:00',2.63),('8998','2014-04-09','09:50:00',2.68),('8998','2014-04-09','09:55:00',2.71),('8998','2014-04-09','10:00:00',2.75),('8998','2014-04-09','10:05:00',2.77),('8998','2014-04-09','10:10:00',2.81),('8998','2014-04-09','10:15:00',2.78),('8998','2014-04-09','10:20:00',2.81),('8998','2014-04-09','10:25:00',2.83),('8998','2014-04-09','10:30:00',2.84),('8998','2014-04-09','10:35:00',2.93),('8998','2014-04-09','10:40:00',2.93),('8998','2014-04-09','10:45:00',2.91),('8998','2014-04-09','10:50:00',2.85),('8998','2014-04-09','10:55:00',2.91),('8998','2014-04-09','11:00:00',2.93),('8998','2014-04-09','11:05:00',2.99),('8998','2014-04-09','11:10:00',2.92),('8998','2014-04-09','11:15:00',3),('8998','2014-04-09','11:20:00',3.07),('8998','2014-04-09','11:25:00',3.09),('8998','2014-04-09','11:30:00',3.04),('8998','2014-04-09','11:35:00',3.07),('8998','2014-04-09','11:40:00',2.96),('8998','2014-04-09','11:45:00',2.99),('8998','2014-04-09','11:50:00',2.87),('8998','2014-04-09','11:55:00',3.01),('8998','2014-04-09','12:00:00',2.95),('8998','2014-04-09','12:05:00',2.75),('8998','2014-04-09','12:10:00',2.86),('8998','2014-04-09','12:15:00',2.89),('8998','2014-04-09','12:20:00',2.88),('8998','2014-04-09','12:25:00',2.78),('8998','2014-04-09','12:30:00',2.82),('8998','2014-04-09','12:35:00',2.91),('8998','2014-04-09','12:40:00',2.88),('8998','2014-04-09','12:45:00',2.87),('8998','2014-04-09','12:50:00',2.81),('8998','2014-04-09','12:55:00',2.76),('8998','2014-04-09','13:00:00',2.7),('8998','2014-04-09','13:05:00',2.58),('8998','2014-04-09','13:10:00',2.59),('8998','2014-04-09','13:15:00',2.61),('8998','2014-04-09','13:20:00',2.59),('8998','2014-04-09','13:25:00',2.75),('8998','2014-04-09','13:30:00',2.68),('8998','2014-04-09','13:35:00',2.72),('8998','2014-04-09','13:40:00',2.52),('8998','2014-04-09','13:45:00',2.66),('8998','2014-04-09','13:50:00',2.6),('8998','2014-04-09','13:55:00',2.55),('8998','2014-04-09','14:00:00',2.52),('8998','2014-04-09','14:05:00',2.48),('8998','2014-04-09','14:10:00',2.45),('8998','2014-04-09','14:15:00',2.4),('8998','2014-04-09','14:20:00',2.39),('8998','2014-04-09','14:25:00',2.36),('8998','2014-04-09','14:30:00',2.31),('8998','2014-04-09','14:35:00',2.28),('8998','2014-04-09','14:40:00',2.23),('8998','2014-04-09','14:45:00',2),('8998','2014-04-09','14:50:00',2.17),('8998','2014-04-09','14:55:00',2.09),('8998','2014-04-09','15:00:00',2.04),('8998','2014-04-09','15:05:00',1.99),('8998','2014-04-09','15:10:00',1.93),('8998','2014-04-09','15:15:00',1.89),('8998','2014-04-09','15:20:00',1.84),('8998','2014-04-09','15:25:00',1.78),('8998','2014-04-09','15:30:00',1.59),('8998','2014-04-09','15:35:00',1.54),('8998','2014-04-09','15:40:00',1.56),('8998','2014-04-09','15:45:00',1.49),('8998','2014-04-09','15:50:00',1.49),('8998','2014-04-09','15:55:00',1.45),('8998','2014-04-09','16:00:00',1.36),('8998','2014-04-09','16:05:00',1.37),('8998','2014-04-09','16:10:00',1.31),('8998','2014-04-09','16:15:00',1.3),('8998','2014-04-09','16:20:00',1.19),('8998','2014-04-09','16:25:00',1.17),('8998','2014-04-09','16:30:00',1.1),('8998','2014-04-09','16:35:00',1.05),('8998','2013-08-18','08:05:00',1.08),('8998','2013-08-18','08:10:00',1.11),('8998','2013-08-18','08:15:00',1.18),('8998','2013-08-18','08:20:00',1.25),('8998','2013-08-18','08:25:00',1.31),('8998','2013-08-18','08:30:00',1.48),('8998','2013-08-18','08:35:00',1.45),('8998','2013-08-18','08:40:00',1.41),('8998','2013-08-18','08:45:00',1.42),('8998','2013-08-18','08:50:00',1.44),('8998','2013-08-18','08:55:00',1.49),('8998','2013-08-18','09:00:00',1.51),('8998','2013-08-18','09:05:00',1.55),('8998','2013-08-18','09:10:00',1.58),('8998','2013-08-18','09:15:00',1.59),('8998','2013-08-18','09:20:00',1.67),('8998','2013-08-18','09:25:00',1.62),('8998','2013-08-18','09:30:00',1.98),('8998','2013-08-18','09:35:00',2.18),('8998','2013-08-18','09:40:00',2.29),('8998','2013-08-18','09:45:00',2.33),('8998','2013-08-18','09:50:00',2.4),('8998','2013-08-18','09:55:00',2.43),('8998','2013-08-18','10:00:00',2.45),('8998','2013-08-18','10:05:00',2.49),('8998','2013-08-18','10:10:00',2.52),('8998','2013-08-18','10:15:00',2.55),('8998','2013-08-18','10:20:00',2.57),('8998','2013-08-18','10:25:00',2.58),('8998','2013-08-18','10:30:00',2.6),('8998','2013-08-18','10:35:00',2.6),('8998','2013-08-18','10:40:00',2.62),('8998','2013-08-18','10:45:00',2.63),('8998','2013-08-18','10:50:00',2.66),('8998','2013-08-18','10:55:00',2.67),('8998','2013-08-18','11:00:00',2.66),('8998','2013-08-18','11:05:00',2.66),('8998','2013-08-18','11:10:00',2.67),('8998','2013-08-18','11:15:00',2.69),('8998','2013-08-18','11:20:00',2.69),('8998','2013-08-18','11:25:00',2.7),('8998','2013-08-18','11:30:00',2.7),('8998','2013-08-18','11:35:00',2.71),('8998','2013-08-18','11:40:00',2.69),('8998','2013-08-18','11:45:00',2.68),('8998','2013-08-18','11:50:00',2.69),('8998','2013-08-18','11:55:00',2.69),('8998','2013-08-18','12:00:00',2.65),('8998','2013-08-18','12:05:00',2.65),('8998','2013-08-18','12:10:00',2.72),('8998','2013-08-18','12:15:00',2.7),('8998','2013-08-18','12:20:00',2.7),('8998','2013-08-18','12:25:00',2.69),('8998','2013-08-18','12:30:00',2.69),('8998','2013-08-18','12:35:00',2.66),('8998','2013-08-18','12:40:00',2.66),('8998','2013-08-18','12:45:00',2.64),('8998','2013-08-18','12:50:00',2.64),('8998','2013-08-18','12:55:00',2.62),('8998','2013-08-18','13:00:00',2.62),('8998','2013-08-18','13:05:00',2.62),('8998','2013-08-18','13:10:00',2.6),('8998','2013-08-18','13:15:00',2.56),('8998','2013-08-18','13:20:00',2.56),('8998','2013-08-18','13:25:00',2.53),('8998','2013-08-18','13:30:00',2.53),('8998','2013-08-18','13:35:00',2.5),('8998','2013-08-18','13:40:00',2.48),('8998','2013-08-18','13:45:00',2.46),('8998','2013-08-18','13:50:00',2.43),('8998','2013-08-18','13:55:00',2.42),('8998','2013-08-18','14:00:00',2.39),('8998','2013-08-18','14:05:00',2.35),('8998','2013-08-18','14:10:00',2.33),('8998','2013-08-18','14:15:00',2.29),('8998','2013-08-18','14:20:00',2.26),('8998','2013-08-18','14:25:00',2.23),('8998','2013-08-18','14:30:00',2.2),('8998','2013-08-18','14:35:00',2.17),('8998','2013-08-18','14:40:00',2.13),('8998','2013-08-18','14:45:00',2.1),('8998','2013-08-18','14:50:00',2.06),('8998','2013-08-18','14:55:00',2.02),('8998','2013-08-18','15:00:00',1.98),('8998','2013-08-18','15:05:00',1.94),('8998','2013-08-18','15:10:00',1.91),('8998','2013-08-18','15:15:00',1.85),('8998','2013-08-18','15:20:00',1.81),('8998','2013-08-18','15:25:00',1.77),('8998','2013-08-18','15:30:00',1.72),('8998','2013-08-18','15:35:00',1.67),('8998','2013-08-18','15:40:00',1.62),('8998','2013-08-18','15:45:00',1.57),('8998','2013-08-18','15:50:00',1.51),('8998','2013-08-18','15:55:00',1.47),('8998','2013-08-18','16:00:00',1.41),('8998','2013-08-18','16:05:00',1.35),('8998','2013-08-18','16:10:00',1.29),('8998','2013-08-18','16:15:00',1.22),('8998','2013-08-18','16:20:00',1.19),('8998','2013-08-18','16:25:00',1.14),('8998','2013-08-18','16:30:00',1.08),('8998','2013-08-18','16:35:00',1.02),('8998','2013-08-17','07:55:00',1.01),('8998','2013-08-17','08:05:00',1.09),('8998','2013-08-17','08:10:00',1.14),('8998','2013-08-17','08:15:00',1.19),('8998','2013-08-17','08:20:00',1.28),('8998','2013-08-17','08:25:00',1.42),('8998','2013-08-17','08:30:00',1.57),('8998','2013-08-17','08:35:00',1.52),('8998','2013-08-17','08:40:00',1.45),('8998','2013-08-17','08:45:00',1.45),('8998','2013-08-17','08:50:00',1.49),('8998','2013-08-17','08:55:00',1.67),('8998','2013-08-17','09:00:00',1.91),('8998','2013-08-17','09:05:00',2.02),('8998','2013-08-17','09:10:00',2.08),('8998','2013-08-17','09:15:00',2.12),('8998','2013-08-17','09:20:00',2.16),('8998','2013-08-17','09:25:00',2.19),('8998','2013-08-17','09:30:00',2.24),('8998','2013-08-17','09:35:00',2.32),('8998','2013-08-17','09:40:00',2.38),('8998','2013-08-17','09:45:00',2.2),('8998','2013-08-17','09:50:00',2.49),('8998','2013-08-17','09:55:00',1.8),('8998','2013-08-17','10:00:00',2.53),('8998','2013-08-17','10:05:00',2.11),('8998','2013-08-17','10:10:00',2.19),('8998','2013-08-17','10:15:00',2.58),('8998','2013-08-17','10:20:00',2.58),('8998','2013-08-17','10:25:00',2.61),('8998','2013-08-17','10:30:00',2.61),('8998','2013-08-17','10:35:00',2.6),('8998','2013-08-17','10:40:00',2.62),('8998','2013-08-17','10:45:00',2.63),('8998','2013-08-17','10:50:00',2.64),('8998','2013-08-17','10:55:00',2.65),('8998','2013-08-17','11:00:00',2.63),('8998','2013-08-17','11:05:00',2.69),('8998','2013-08-17','11:10:00',2.67),('8998','2013-08-17','11:15:00',2.66),('8998','2013-08-17','11:20:00',2.67),('8998','2013-08-17','11:25:00',2.68),('8998','2013-08-17','11:30:00',2.69),('8998','2013-08-17','11:35:00',2.67),('8998','2013-08-17','11:40:00',2.69),('8998','2013-08-17','11:45:00',2.71),('8998','2013-08-17','11:50:00',2.72),('8998','2013-08-17','11:55:00',2.7),('8998','2013-08-17','12:00:00',2.67),('8998','2013-08-17','12:05:00',2.68),('8998','2013-08-17','12:10:00',2.71),('8998','2013-08-17','12:15:00',2.63),('8998','2013-08-17','12:20:00',2.7),('8998','2013-08-17','12:25:00',2.76),('8998','2013-08-17','12:30:00',2.69),('8998','2013-08-17','12:35:00',2.5),('8998','2013-08-17','12:40:00',1.65),('8998','2013-08-17','12:45:00',1.47),('8998','2013-08-17','12:55:00',1.72),('8998','2013-08-17','13:00:00',1.04),('8998','2013-08-17','13:05:00',2.85),('8998','2013-08-17','13:10:00',2.81),('8998','2013-08-17','13:15:00',2.48),('8998','2013-08-17','13:20:00',2.53),('8998','2013-08-17','13:25:00',2.67),('8998','2013-08-17','13:30:00',2.57),('8998','2013-08-17','13:35:00',2.54),('8998','2013-08-17','13:40:00',2.56),('8998','2013-08-17','13:45:00',2.51),('8998','2013-08-17','13:50:00',2.49),('8998','2013-08-17','13:55:00',2.14),('8998','2013-08-17','14:00:00',2.45),('8998','2013-08-17','14:05:00',2.43),('8998','2013-08-17','14:10:00',2.36),('8998','2013-08-17','14:15:00',2.32),('8998','2013-08-17','14:20:00',2.27),('8998','2013-08-17','14:25:00',2.24),('8998','2013-08-17','14:30:00',2.21),('8998','2013-08-17','14:35:00',2.18),('8998','2013-08-17','14:40:00',2.14),('8998','2013-08-17','14:45:00',2.11),('8998','2013-08-17','14:50:00',2.06),('8998','2013-08-17','14:55:00',2.02),('8998','2013-08-17','15:00:00',1.98),('8998','2013-08-17','15:05:00',1.94),('8998','2013-08-17','15:10:00',1.89),('8998','2013-08-17','15:15:00',1.85),('8998','2013-08-17','15:20:00',1.8),('8998','2013-08-17','15:25:00',1.76),('8998','2013-08-17','15:30:00',1.71),('8998','2013-08-17','15:35:00',1.67),('8998','2013-08-17','15:40:00',1.62),('8998','2013-08-17','15:45:00',1.57),('8998','2013-08-17','15:50:00',1.52),('8998','2013-08-17','15:55:00',1.46),('8998','2013-08-17','16:00:00',1.42),('8998','2013-08-17','16:05:00',1.36),('8998','2013-08-17','16:10:00',1.3),('8998','2013-08-17','16:15:00',1.25),('8998','2013-08-17','16:20:00',1.21),('8998','2013-08-17','16:25:00',1.15),('8998','2013-08-17','16:30:00',1.09),('8998','2013-08-17','16:35:00',1.04),('8998','2013-08-16','08:05:00',1.06),('8998','2013-08-16','08:10:00',1.11),('8998','2013-08-16','08:15:00',1.17),('8998','2013-08-16','08:20:00',1.25),('8998','2013-08-16','08:25:00',1.29),('8998','2013-08-16','08:30:00',1.28),('8998','2013-08-16','08:35:00',1.47),('8998','2013-08-16','08:40:00',1.44),('8998','2013-08-16','08:45:00',1.41),('8998','2013-08-16','08:50:00',1.45),('8998','2013-08-16','08:55:00',1.45),('8998','2013-08-16','09:00:00',1.51),('8998','2013-08-16','09:05:00',1.51),('8998','2013-08-16','09:10:00',1.59),('8998','2013-08-16','09:15:00',1.56),('8998','2013-08-16','09:20:00',1.61),('8998','2013-08-16','09:25:00',1.7),('8998','2013-08-16','09:30:00',1.88),('8998','2013-08-16','09:35:00',2.16),('8998','2013-08-16','09:40:00',2.22),('8998','2013-08-16','09:45:00',2.3),('8998','2013-08-16','09:50:00',2.42),('8998','2013-08-16','09:55:00',2.47),('8998','2013-08-16','10:00:00',2.5),('8998','2013-08-16','10:05:00',2.53),('8998','2013-08-16','10:10:00',2.55),('8998','2013-08-16','10:15:00',2.57),('8998','2013-08-16','10:20:00',2.58),('8998','2013-08-16','10:25:00',2.6),('8998','2013-08-16','10:30:00',2.62),('8998','2013-08-16','10:35:00',2.63),('8998','2013-08-16','10:40:00',2.64),('8998','2013-08-16','10:45:00',2.66),('8998','2013-08-16','10:50:00',2.69),('8998','2013-08-16','10:55:00',2.7),('8998','2013-08-16','11:00:00',2.7),('8998','2013-08-16','11:05:00',2.71),('8998','2013-08-16','11:10:00',2.73),('8998','2013-08-16','11:15:00',2.71),('8998','2013-08-16','11:20:00',2.71),('8998','2013-08-16','11:25:00',2.72),('8998','2013-08-16','11:30:00',2.73),('8998','2013-08-16','11:35:00',2.72),('8998','2013-08-16','11:40:00',2.75),('8998','2013-08-16','11:45:00',2.74),('8998','2013-08-16','11:50:00',2.73),('8998','2013-08-16','11:55:00',2.77),('8998','2013-08-16','12:00:00',2.71),('8998','2013-08-16','12:05:00',2.71),('8998','2013-08-16','12:10:00',2.69),('8998','2013-08-16','12:15:00',2.59),('8998','2013-08-16','12:20:00',2.7),('8998','2013-08-16','12:25:00',2.72),('8998','2013-08-16','12:30:00',2.75),('8998','2013-08-16','12:35:00',2.71),('8998','2013-08-16','12:40:00',2.57),('8998','2013-08-16','12:45:00',2.63),('8998','2013-08-16','12:50:00',2.69),('8998','2013-08-16','12:55:00',2.64),('8998','2013-08-16','13:00:00',2.59),('8998','2013-08-16','13:05:00',2.44),('8998','2013-08-16','13:10:00',2.66),('8998','2013-08-16','13:15:00',2.67),('8998','2013-08-16','13:20:00',2.64),('8998','2013-08-16','13:25:00',2.68),('8998','2013-08-16','13:30:00',2.01),('8998','2013-08-16','13:35:00',2.33),('8998','2013-08-16','13:40:00',1.15),('8998','2013-08-16','14:00:00',1.29),('8998','2013-08-16','14:05:00',2.02),('8998','2013-08-16','14:10:00',2.11),('8998','2013-08-16','14:15:00',2.43),('8998','2013-08-16','14:20:00',2.39),('8998','2013-08-16','14:25:00',2.36),('8998','2013-08-16','14:30:00',2.27),('8998','2013-08-16','14:35:00',2.23),('8998','2013-08-16','14:40:00',2.15),('8998','2013-08-16','14:45:00',2.13),('8998','2013-08-16','14:50:00',2.12),('8998','2013-08-16','14:55:00',2.03),('8998','2013-08-16','15:00:00',2.01),('8998','2013-08-16','15:05:00',1.97),('8998','2013-08-16','15:10:00',1.91),('8998','2013-08-16','15:15:00',1.85),('8998','2013-08-16','15:20:00',1.83),('8998','2013-08-16','15:25:00',1.77),('8998','2013-08-16','15:30:00',1.73),('8998','2013-08-16','15:35:00',1.7),('8998','2013-08-16','15:40:00',1.63),('8998','2013-08-16','15:45:00',1.57),('8998','2013-08-16','15:50:00',1.52),('8998','2013-08-16','15:55:00',1.47),('8998','2013-08-16','16:00:00',1.42),('8998','2013-08-16','16:05:00',1.36),('8998','2013-08-16','16:10:00',1.31),('8998','2013-08-16','16:15:00',1.26),('8998','2013-08-16','16:20:00',1.22),('8998','2013-08-16','16:25:00',1.16),('8998','2013-08-16','16:30:00',1.11),('8998','2013-08-16','16:35:00',1.06),('8998','2013-08-15','08:00:00',1.1),('8998','2013-08-15','08:05:00',1.13),('8998','2013-08-15','08:10:00',1.18),('8998','2013-08-15','08:15:00',1.34),('8998','2013-08-15','08:20:00',1.34),('8998','2013-08-15','08:25:00',1.47),('8998','2013-08-15','08:30:00',1.59),('8998','2013-08-15','08:35:00',1.62),('8998','2013-08-15','08:40:00',1.54),('8998','2013-08-15','08:45:00',1.49),('8998','2013-08-15','08:50:00',1.53),('8998','2013-08-15','08:55:00',1.51),('8998','2013-08-15','09:00:00',1.57),('8998','2013-08-15','09:05:00',1.7),('8998','2013-08-15','09:10:00',1.66),('8998','2013-08-15','09:15:00',1.73),('8998','2013-08-15','09:20:00',2.03),('8998','2013-08-15','09:25:00',2.29),('8998','2013-08-15','09:30:00',2.34),('8998','2013-08-15','09:35:00',2.41),('8998','2013-08-15','09:40:00',2.46),('8998','2013-08-15','09:45:00',2.5),('8998','2013-08-15','09:50:00',2.58),('8998','2013-08-15','09:55:00',2.6),('8998','2013-08-15','10:00:00',2.64),('8998','2013-08-15','10:05:00',2.65),('8998','2013-08-15','10:10:00',2.67),('8998','2013-08-15','10:15:00',2.7),('8998','2013-08-15','10:20:00',2.72),('8998','2013-08-15','10:25:00',2.73),('8998','2013-08-15','10:30:00',2.76),('8998','2013-08-15','10:35:00',2.77),('8998','2013-08-15','10:40:00',2.78),('8998','2013-08-15','10:45:00',2.79),('8998','2013-08-15','10:50:00',2.8),('8998','2013-08-15','10:55:00',2.81),('8998','2013-08-15','11:00:00',2.81),('8998','2013-08-15','11:05:00',2.84),('8998','2013-08-15','11:10:00',2.83),('8998','2013-08-15','11:15:00',2.82),('8998','2013-08-15','11:20:00',2.83),('8998','2013-08-15','11:25:00',2.83),('8998','2013-08-15','11:30:00',2.83),('8998','2013-08-15','11:35:00',2.84),('8998','2013-08-15','11:40:00',2.82),('8998','2013-08-15','11:45:00',2.82),('8998','2013-08-15','11:50:00',2.81),('8998','2013-08-15','11:55:00',2.8),('8998','2013-08-15','12:00:00',2.82),('8998','2013-08-15','12:05:00',2.82),('8998','2013-08-15','12:10:00',2.82),('8998','2013-08-15','12:15:00',2.81),('8998','2013-08-15','12:20:00',2.82),('8998','2013-08-15','12:25:00',2.79),('8998','2013-08-15','12:30:00',2.78),('8998','2013-08-15','12:35:00',2.74),('8998','2013-08-15','12:40:00',2.73),('8998','2013-08-15','12:45:00',2.72),('8998','2013-08-15','12:50:00',2.71),('8998','2013-08-15','12:55:00',2.69),('8998','2013-08-15','13:00:00',2.67),('8998','2013-08-15','13:05:00',2.66),('8998','2013-08-15','13:10:00',2.64),('8998','2013-08-15','13:15:00',2.63),('8998','2013-08-15','13:20:00',2.59),('8998','2013-08-15','13:25:00',2.56),('8998','2013-08-15','13:30:00',2.54),('8998','2013-08-15','13:35:00',2.53),('8998','2013-08-15','13:40:00',2.5),('8998','2013-08-15','13:45:00',2.49),('8998','2013-08-15','13:50:00',2.47),('8998','2013-08-15','13:55:00',2.43),('8998','2013-08-15','14:00:00',2.41),('8998','2013-08-15','14:05:00',2.39),('8998','2013-08-15','14:10:00',2.36),('8998','2013-08-15','14:15:00',2.33),('8998','2013-08-15','14:20:00',2.29),('8998','2013-08-15','14:25:00',2.26),('8998','2013-08-15','14:30:00',2.21),('8998','2013-08-15','14:35:00',2.17),('8998','2013-08-15','14:40:00',2.13),('8998','2013-08-15','14:45:00',2.1),('8998','2013-08-15','14:50:00',2.06),('8998','2013-08-15','14:55:00',2.02),('8998','2013-08-15','15:00:00',1.98),('8998','2013-08-15','15:05:00',1.92),('8998','2013-08-15','15:10:00',1.89),('8998','2013-08-15','15:15:00',1.84),('8998','2013-08-15','15:20:00',1.79),('8998','2013-08-15','15:25:00',1.75),('8998','2013-08-15','15:30:00',1.72),('8998','2013-08-15','15:35:00',1.67),('8998','2013-08-15','15:40:00',1.62),('8998','2013-08-15','15:45:00',1.58),('8998','2013-08-15','15:50:00',1.52),('8998','2013-08-15','15:55:00',1.48),('8998','2013-08-15','16:00:00',1.43),('8998','2013-08-15','16:05:00',1.38),('8998','2013-08-15','16:10:00',1.33),('8998','2013-08-15','16:15:00',1.27),('8998','2013-08-15','16:20:00',1.21),('8998','2013-08-15','16:25:00',1.16),('8998','2013-08-15','16:30:00',1.1),('8998','2013-08-15','16:35:00',1.05),('8998','2013-08-14','08:05:00',1.28),('8998','2013-08-14','08:10:00',1.18),('8998','2013-08-14','08:15:00',1.19),('8998','2013-08-14','08:20:00',1.48),('8998','2013-08-14','08:25:00',1.41),('8998','2013-08-14','08:30:00',1.43),('8998','2013-08-14','08:35:00',1.59),('8998','2013-08-14','08:40:00',1.62),('8998','2013-08-14','08:45:00',1.58),('8998','2013-08-14','08:50:00',1.56),('8998','2013-08-14','08:55:00',1.58),('8998','2013-08-14','09:00:00',1.67),('8998','2013-08-14','09:05:00',1.59),('8998','2013-08-14','09:10:00',1.32),('8998','2013-08-14','09:15:00',1.16),('8998','2013-08-14','09:20:00',1.7),('8998','2013-08-14','09:25:00',1.81),('8998','2013-08-14','09:30:00',1.86),('8998','2013-08-14','09:35:00',2.25),('8998','2013-08-14','09:40:00',2.33),('8998','2013-08-14','09:45:00',2.46),('8998','2013-08-14','09:50:00',2.58),('8998','2013-08-14','09:55:00',2.61),('8998','2013-08-14','10:00:00',2.63),('8998','2013-08-14','10:05:00',2.64),('8998','2013-08-14','10:10:00',2.67),('8998','2013-08-14','10:15:00',2.7),('8998','2013-08-14','10:20:00',2.72),('8998','2013-08-14','10:25:00',2.77),('8998','2013-08-14','10:30:00',2.79),('8998','2013-08-14','10:35:00',2.78),('8998','2013-08-14','10:40:00',2.8),('8998','2013-08-14','10:45:00',2.76),('8998','2013-08-14','10:50:00',2.7),('8998','2013-08-14','10:55:00',2.62),('8998','2013-08-14','11:00:00',2.58),('8998','2013-08-14','11:05:00',2.22),('8998','2013-08-14','11:10:00',1.95),('8998','2013-08-14','11:15:00',2.1),('8998','2013-08-14','11:20:00',2.38),('8998','2013-08-14','11:25:00',2.62),('8998','2013-08-14','11:30:00',2.92),('8998','2013-08-14','11:35:00',3.02),('8998','2013-08-14','11:40:00',3.07),('8998','2013-08-14','11:45:00',3.1),('8998','2013-08-14','11:50:00',3.09),('8998','2013-08-14','11:55:00',3.07),('8998','2013-08-14','12:00:00',3.04),('8998','2013-08-14','12:05:00',3.02),('8998','2013-08-14','12:10:00',2.97),('8998','2013-08-14','12:15:00',2.97),('8998','2013-08-14','12:20:00',2.94),('8998','2013-08-14','12:25:00',2.93),('8998','2013-08-14','12:30:00',2.9),('8998','2013-08-14','12:35:00',2.91),('8998','2013-08-14','12:40:00',2.87),('8998','2013-08-14','12:45:00',2.87),('8998','2013-08-14','12:50:00',2.81),('8998','2013-08-14','12:55:00',2.65),('8998','2013-08-14','13:00:00',2.66),('8998','2013-08-14','13:05:00',2.64),('8998','2013-08-14','13:10:00',2.6),('8998','2013-08-14','13:15:00',2.52),('8998','2013-08-14','13:20:00',2.5),('8998','2013-08-14','13:25:00',2.6),('8998','2013-08-14','13:30:00',2.64),('8998','2013-08-14','13:35:00',2.62),('8998','2013-08-14','13:40:00',2.57),('8998','2013-08-14','13:45:00',2.53),('8998','2013-08-14','13:50:00',2.49),('8998','2013-08-14','13:55:00',2.44),('8998','2013-08-14','14:00:00',2.46),('8998','2013-08-14','14:05:00',2.44),('8998','2013-08-14','14:10:00',2.4),('8998','2013-08-14','14:15:00',2.37),('8998','2013-08-14','14:20:00',2.33),('8998','2013-08-14','14:25:00',2.24),('8998','2013-08-14','14:30:00',2.18),('8998','2013-08-14','14:35:00',2.22),('8998','2013-08-14','14:40:00',2.17),('8998','2013-08-14','14:45:00',2.11),('8998','2013-08-14','14:50:00',2.09),('8998','2013-08-14','14:55:00',2.03),('8998','2013-08-14','15:00:00',1.99),('8998','2013-08-14','15:05:00',1.97),('8998','2013-08-14','15:10:00',1.93),('8998','2013-08-14','15:15:00',1.87),('8998','2013-08-14','15:20:00',1.8),('8998','2013-08-14','15:25:00',1.76),('8998','2013-08-14','15:30:00',1.74),('8998','2013-08-14','15:35:00',1.7),('8998','2013-08-14','15:40:00',1.64),('8998','2013-08-14','15:45:00',1.57),('8998','2013-08-14','15:50:00',1.52),('8998','2013-08-14','15:55:00',1.5),('8998','2013-08-14','16:00:00',1.43),('8998','2013-08-14','16:05:00',1.36),('8998','2013-08-14','16:10:00',1.16),('8998','2013-08-14','16:15:00',1.26),('8998','2013-08-14','16:20:00',1.24),('8998','2013-08-14','16:25:00',1.16),('8998','2013-08-14','16:30:00',1.09),('8998','2013-08-14','16:35:00',1.05),('8998','2013-08-13','07:55:00',1.1),('8998','2013-08-13','08:00:00',1.07),('8998','2013-08-13','08:05:00',1.11),('8998','2013-08-13','08:10:00',1.15),('8998','2013-08-13','08:15:00',1.21),('8998','2013-08-13','08:20:00',1.27),('8998','2013-08-13','08:25:00',1.28),('8998','2013-08-13','08:30:00',1.34),('8998','2013-08-13','08:35:00',1.44),('8998','2013-08-13','08:40:00',1.63),('8998','2013-08-13','08:45:00',1.63),('8998','2013-08-13','08:50:00',1.53),('8998','2013-08-13','08:55:00',1.54),('8998','2013-08-13','09:00:00',1.56),('8998','2013-08-13','09:05:00',1.77),('8998','2013-08-13','09:10:00',1.72),('8998','2013-08-13','09:15:00',1.72),('8998','2013-08-13','09:20:00',1.7),('8998','2013-08-13','09:25:00',1.75),('8998','2013-08-13','09:30:00',1.88),('8998','2013-08-13','09:35:00',2.22),('8998','2013-08-13','09:40:00',2.21),('8998','2013-08-13','10:00:00',1.31),('8998','2013-08-13','10:05:00',2.17),('8998','2013-08-13','10:10:00',2.23),('8998','2013-08-13','10:15:00',2.35),('8998','2013-08-13','10:20:00',2.28),('8998','2013-08-13','10:25:00',2.63),('8998','2013-08-13','10:30:00',2.78),('8998','2013-08-13','10:35:00',2.81),('8998','2013-08-13','10:40:00',2.87),('8998','2013-08-13','10:45:00',2.09),('8998','2013-08-13','10:50:00',2.33),('8998','2013-08-13','10:55:00',1.16),('8998','2013-08-13','11:00:00',1.9),('8998','2013-08-13','11:05:00',2.94),('8998','2013-08-13','11:10:00',1.44),('8998','2013-08-13','11:15:00',1.52),('8998','2013-08-13','11:20:00',2.32),('8998','2013-08-13','11:25:00',2.38),('8998','2013-08-13','11:30:00',2.88),('8998','2013-08-13','11:35:00',2.9),('8998','2013-08-13','11:40:00',2.94),('8998','2013-08-13','11:45:00',2.06),('8998','2013-08-13','11:50:00',1.04),('8998','2013-08-13','11:55:00',1.02),('8998','2013-08-13','12:05:00',1.46),('8998','2013-08-13','12:10:00',1.44),('8998','2013-08-13','12:15:00',1.55),('8998','2013-08-13','12:20:00',1.39),('8998','2013-08-13','12:35:00',1.64),('8998','2013-08-13','12:55:00',1.47),('8998','2013-08-13','13:00:00',1.11),('8998','2013-08-13','13:30:00',1.23),('8998','2013-08-13','13:40:00',1.87),('8998','2013-08-13','13:45:00',2.41),('8998','2013-08-13','13:50:00',2.87),('8998','2013-08-13','13:55:00',2.05),('8998','2013-08-13','14:00:00',1.16),('8998','2013-08-13','14:05:00',2.63),('8998','2013-08-13','14:10:00',1.62),('8998','2013-08-13','14:15:00',2.68),('8998','2013-08-13','14:20:00',2.59),('8998','2013-08-13','14:25:00',2.57),('8998','2013-08-13','14:30:00',2.49),('8998','2013-08-13','14:35:00',2.44),('8998','2013-08-13','14:40:00',2.33),('8998','2013-08-13','14:45:00',2.25),('8998','2013-08-13','14:50:00',2.22),('8998','2013-08-13','14:55:00',1.58),('8998','2013-08-13','15:00:00',2.12),('8998','2013-08-13','15:05:00',2.08),('8998','2013-08-13','15:10:00',2),('8998','2013-08-13','15:15:00',1.98),('8998','2013-08-13','15:20:00',2.03),('8998','2013-08-13','15:25:00',1.95),('8998','2013-08-13','15:30:00',1.81),('8998','2013-08-13','15:35:00',1.74),('8998','2013-08-13','15:40:00',1.7),('8998','2013-08-13','15:45:00',1.65),('8998','2013-08-13','15:50:00',1.6),('8998','2013-08-13','15:55:00',1.54),('8998','2013-08-13','16:00:00',1.5),('8998','2013-08-13','16:05:00',1.46),('8998','2013-08-13','16:10:00',1.42),('8998','2013-08-13','16:15:00',1.35),('8998','2013-08-13','16:20:00',1.31),('8998','2013-08-13','16:25:00',1.24),('8998','2013-08-13','16:30:00',1.18),('8998','2013-08-13','16:35:00',1.14),('8998','2013-08-13','16:40:00',1.08),('8998','2013-08-13','16:45:00',1.01),('8998','2013-08-12','07:55:00',1.02),('8998','2013-08-12','08:00:00',1.13),('8998','2013-08-12','08:05:00',1.14),('8998','2013-08-12','08:10:00',1.18),('8998','2013-08-12','08:15:00',1.21),('8998','2013-08-12','08:20:00',1.3),('8998','2013-08-12','08:25:00',1.39),('8998','2013-08-12','08:30:00',1.37),('8998','2013-08-12','08:35:00',1.66),('8998','2013-08-12','08:40:00',1.66),('8998','2013-08-12','08:45:00',1.59),('8998','2013-08-12','08:50:00',1.54),('8998','2013-08-12','08:55:00',1.54),('8998','2013-08-12','09:00:00',1.56),('8998','2013-08-12','09:05:00',1.61),('8998','2013-08-12','09:10:00',1.61),('8998','2013-08-12','09:15:00',1.66),('8998','2013-08-12','09:20:00',1.66),('8998','2013-08-12','09:25:00',1.76),('8998','2013-08-12','09:30:00',1.75),('8998','2013-08-12','09:35:00',2.06),('8998','2013-08-12','09:40:00',2.28),('8998','2013-08-12','09:45:00',2.42),('8998','2013-08-12','09:50:00',2.47),('8998','2013-08-12','09:55:00',2.51),('8998','2013-08-12','10:00:00',2.16),('8998','2013-08-12','10:05:00',1.26),('8998','2013-08-12','10:10:00',2.54),('8998','2013-08-12','10:15:00',2.7),('8998','2013-08-12','10:20:00',2.62),('8998','2013-08-12','10:25:00',2.67),('8998','2013-08-12','10:30:00',2.66),('8998','2013-08-12','10:35:00',2.71),('8998','2013-08-12','10:40:00',2.71),('8998','2013-08-12','10:45:00',2.7),('8998','2013-08-12','10:50:00',2.71),('8998','2013-08-12','10:55:00',2.71),('8998','2013-08-12','11:00:00',2.73),('8998','2013-08-12','11:05:00',2.76),('8998','2013-08-12','11:10:00',2.75),('8998','2013-08-12','11:15:00',2.74),('8998','2013-08-12','11:20:00',2.77),('8998','2013-08-12','11:25:00',2.76),('8998','2013-08-12','11:30:00',2.77),('8998','2013-08-12','11:35:00',2.75),('8998','2013-08-12','11:40:00',2.75),('8998','2013-08-12','11:45:00',2.74),('8998','2013-08-12','11:50:00',2.76),('8998','2013-08-12','11:55:00',2.81),('8998','2013-08-12','12:00:00',2.84),('8998','2013-08-12','12:05:00',2.87),('8998','2013-08-12','12:10:00',2.87),('8998','2013-08-12','12:15:00',2.9),('8998','2013-08-12','12:20:00',2.91),('8998','2013-08-12','12:25:00',2.92),('8998','2013-08-12','12:30:00',2.92),('8998','2013-08-12','12:35:00',2.67),('8998','2013-08-12','12:40:00',2.76),('8998','2013-08-12','12:45:00',1.63),('8998','2013-08-12','12:50:00',2.48),('8998','2013-08-12','12:55:00',2.83),('8998','2013-08-12','13:15:00',1.2),('8998','2013-08-12','13:20:00',3.19),('8998','2013-08-12','13:25:00',3.01),('8998','2013-08-12','13:30:00',2.92),('8998','2013-08-12','13:35:00',2.82),('8998','2013-08-12','13:40:00',2.82),('8998','2013-08-12','13:45:00',2.88),('8998','2013-08-12','13:50:00',2.88),('8998','2013-08-12','13:55:00',2.78),('8998','2013-08-12','14:00:00',2.65),('8998','2013-08-12','14:05:00',2.7),('8998','2013-08-12','14:10:00',2.23),('8998','2013-08-12','14:15:00',2.64),('8998','2013-08-12','14:20:00',2.6),('8998','2013-08-12','14:25:00',2.01),('8998','2013-08-12','14:35:00',2.46),('8998','2013-08-12','14:40:00',1.64),('8998','2013-08-12','14:45:00',1.16),('8998','2013-08-12','14:50:00',2.25),('8998','2013-08-12','14:55:00',2.4),('8998','2013-08-12','15:00:00',1.92),('8998','2013-08-12','15:05:00',1.67),('8998','2013-08-12','15:10:00',1.38),('8998','2013-08-12','15:15:00',1.68),('8998','2013-08-12','15:20:00',1.91),('8998','2013-08-12','15:25:00',1.92),('8998','2013-08-12','15:30:00',1.82),('8998','2013-08-12','15:35:00',1.8),('8998','2013-08-12','15:40:00',1.76),('8998','2013-08-12','15:45:00',1.68),('8998','2013-08-12','15:50:00',1.61),('8998','2013-08-12','15:55:00',1.54),('8998','2013-08-12','16:00:00',1.49),('8998','2013-08-12','16:05:00',1.43),('8998','2013-08-12','16:10:00',1.37),('8998','2013-08-12','16:15:00',1.33),('8998','2013-08-12','16:20:00',1.28),('8998','2013-08-12','16:25:00',1.22),('8998','2013-08-12','16:30:00',1.17),('8998','2013-08-12','16:35:00',1.12),('8998','2013-08-12','16:40:00',1.06),('8998','2013-08-12','16:45:00',1.01),('8998','2013-08-11','07:50:00',1.02),('8998','2013-08-11','07:55:00',1.12),('8998','2013-08-11','08:00:00',1.14),('8998','2013-08-11','08:05:00',1.1),('8998','2013-08-11','08:10:00',1.16),('8998','2013-08-11','08:15:00',1.21),('8998','2013-08-11','08:20:00',1.29),('8998','2013-08-11','08:25:00',1.39),('8998','2013-08-11','08:30:00',1.35),('8998','2013-08-11','08:35:00',1.39),('8998','2013-08-11','08:40:00',1.58),('8998','2013-08-11','08:45:00',1.59),('8998','2013-08-11','08:50:00',1.52),('8998','2013-08-11','08:55:00',1.49),('8998','2013-08-11','09:00:00',1.53),('8998','2013-08-11','09:05:00',1.58),('8998','2013-08-11','09:10:00',1.6),('8998','2013-08-11','09:15:00',1.64),('8998','2013-08-11','09:20:00',1.69),('8998','2013-08-11','09:25:00',1.78),('8998','2013-08-11','09:30:00',1.85),('8998','2013-08-11','09:35:00',2.03),('8998','2013-08-11','09:40:00',2.23),('8998','2013-08-11','09:45:00',2.38),('8998','2013-08-11','09:50:00',2.42),('8998','2013-08-11','09:55:00',2.46),('8998','2013-08-11','10:00:00',2.48),('8998','2013-08-11','10:05:00',2.49),('8998','2013-08-11','10:10:00',2.5),('8998','2013-08-11','10:15:00',2.53),('8998','2013-08-11','10:20:00',2.56),('8998','2013-08-11','10:25:00',2.58),('8998','2013-08-11','10:30:00',2.59),('8998','2013-08-11','10:35:00',2.59),('8998','2013-08-11','10:40:00',2.63),('8998','2013-08-11','10:45:00',2.65),('8998','2013-08-11','10:50:00',2.67),('8998','2013-08-11','10:55:00',2.7),('8998','2013-08-11','11:00:00',2.69),('8998','2013-08-11','11:05:00',2.69),('8998','2013-08-11','11:10:00',2.72),('8998','2013-08-11','11:15:00',2.73),('8998','2013-08-11','11:20:00',2.69),('8998','2013-08-11','11:25:00',2.72),('8998','2013-08-11','11:30:00',2.73),('8998','2013-08-11','11:35:00',2.65),('8998','2013-08-11','11:40:00',2.73),('8998','2013-08-11','11:45:00',2.75),('8998','2013-08-11','11:50:00',2.74),('8998','2013-08-11','11:55:00',2.76),('8998','2013-08-11','12:00:00',2.8),('8998','2013-08-11','12:05:00',2.86),('8998','2013-08-11','12:10:00',2.78),('8998','2013-08-11','12:15:00',2.17),('8998','2013-08-11','12:45:00',2.15),('8998','2013-08-11','12:50:00',1.25),('8998','2013-08-11','13:25:00',1.44),('8998','2013-08-11','13:50:00',1.65),('8998','2013-08-11','13:55:00',2.53),('8998','2013-08-11','14:15:00',1.08),('8998','2013-08-11','14:50:00',1.35),('8998','2013-08-11','14:55:00',2.62),('8998','2013-08-11','15:00:00',2.39),('8998','2013-08-11','15:05:00',2.1),('8998','2013-08-11','15:10:00',2.26),('8998','2013-08-11','15:15:00',2.16),('8998','2013-08-11','15:20:00',1.66),('8998','2013-08-11','15:25:00',1.98),('8998','2013-08-11','15:30:00',1.93),('8998','2013-08-11','15:35:00',1.76),('8998','2013-08-11','15:40:00',1.73),('8998','2013-08-11','15:45:00',1.67),('8998','2013-08-11','15:50:00',1.62),('8998','2013-08-11','15:55:00',1.57),('8998','2013-08-11','16:00:00',1.5),('8998','2013-08-11','16:05:00',1.44),('8998','2013-08-11','16:10:00',1.39),('8998','2013-08-11','16:15:00',1.33),('8998','2013-08-11','16:20:00',1.28),('8998','2013-08-11','16:25:00',1.24),('8998','2013-08-11','16:30:00',1.19),('8998','2013-08-11','16:35:00',1.12),('8998','2013-08-11','16:40:00',1.08),('8998','2013-08-11','16:45:00',1.01),('8998','2013-08-10','07:50:00',1.04),('8998','2013-08-10','07:55:00',1.18),('8998','2013-08-10','08:00:00',1.16),('8998','2013-08-10','08:05:00',1.14),('8998','2013-08-10','08:10:00',1.2),('8998','2013-08-10','08:15:00',1.26),('8998','2013-08-10','08:20:00',1.37),('8998','2013-08-10','08:25:00',1.44),('8998','2013-08-10','08:30:00',1.41),('8998','2013-08-10','08:35:00',1.41),('8998','2013-08-10','08:40:00',1.57),('8998','2013-08-10','08:45:00',1.66),('8998','2013-08-10','08:50:00',1.57),('8998','2013-08-10','08:55:00',1.52),('8998','2013-08-10','09:00:00',1.56),('8998','2013-08-10','09:05:00',1.59),('8998','2013-08-10','09:10:00',1.62),('8998','2013-08-10','09:15:00',1.66),('8998','2013-08-10','09:20:00',1.71),('8998','2013-08-10','09:25:00',1.8),('8998','2013-08-10','09:30:00',1.92),('8998','2013-08-10','09:35:00',2.08),('8998','2013-08-10','09:40:00',2.31),('8998','2013-08-10','09:45:00',2.48),('8998','2013-08-10','09:50:00',2.51),('8998','2013-08-10','09:55:00',2.54),('8998','2013-08-10','10:00:00',2.58),('8998','2013-08-10','10:05:00',2.61),('8998','2013-08-10','10:10:00',2.62),('8998','2013-08-10','10:15:00',2.66),('8998','2013-08-10','10:20:00',2.67),('8998','2013-08-10','10:25:00',2.68),('8998','2013-08-10','10:30:00',2.7),('8998','2013-08-10','10:35:00',2.71),('8998','2013-08-10','10:40:00',2.72),('8998','2013-08-10','10:45:00',2.75),('8998','2013-08-10','10:50:00',2.76),('8998','2013-08-10','10:55:00',2.78),('8998','2013-08-10','11:00:00',2.79),('8998','2013-08-10','11:05:00',2.81),('8998','2013-08-10','11:10:00',2.83),('8998','2013-08-10','11:15:00',2.81),('8998','2013-08-10','11:20:00',2.83),('8998','2013-08-10','11:25:00',2.84),('8998','2013-08-10','11:30:00',2.84),('8998','2013-08-10','11:35:00',2.82),('8998','2013-08-10','11:40:00',2.82),('8998','2013-08-10','11:45:00',2.81),('8998','2013-08-10','11:50:00',2.85),('8998','2013-08-10','11:55:00',2.84),('8998','2013-08-10','12:00:00',2.83),('8998','2013-08-10','12:05:00',2.83),('8998','2013-08-10','12:10:00',2.83),('8998','2013-08-10','12:15:00',2.82),('8998','2013-08-10','12:20:00',2.82),('8998','2013-08-10','12:25:00',2.82),('8998','2013-08-10','12:30:00',2.81),('8998','2013-08-10','12:35:00',2.79),('8998','2013-08-10','12:40:00',2.78),('8998','2013-08-10','12:45:00',2.75),('8998','2013-08-10','12:50:00',2.74),('8998','2013-08-10','12:55:00',2.73),('8998','2013-08-10','13:00:00',2.71),('8998','2013-08-10','13:05:00',2.7),('8998','2013-08-10','13:10:00',2.66),('8998','2013-08-10','13:15:00',2.64),('8998','2013-08-10','13:20:00',2.61),('8998','2013-08-10','13:25:00',2.61),('8998','2013-08-10','13:30:00',2.59),('8998','2013-08-10','13:35:00',2.55),('8998','2013-08-10','13:40:00',2.56),('8998','2013-08-10','13:45:00',2.52),('8998','2013-08-10','13:50:00',2.5),('8998','2013-08-10','13:55:00',2.46),('8998','2013-08-10','14:00:00',2.44),('8998','2013-08-10','14:05:00',2.41),('8998','2013-08-10','14:10:00',2.41),('8998','2013-08-10','14:15:00',2.33),('8998','2013-08-10','14:20:00',2.33),('8998','2013-08-10','14:25:00',2.28),('8998','2013-08-10','14:30:00',2.25),('8998','2013-08-10','14:35:00',2.2),('8998','2013-08-10','14:40:00',2.2),('8998','2013-08-10','14:45:00',2.15),('8998','2013-08-10','14:50:00',2.08),('8998','2013-08-10','14:55:00',2.07),('8998','2013-08-10','15:00:00',2.06),('8998','2013-08-10','15:05:00',2.01),('8998','2013-08-10','15:10:00',1.95),('8998','2013-08-10','15:15:00',1.89),('8998','2013-08-10','15:20:00',1.86),('8998','2013-08-10','15:25:00',1.86),('8998','2013-08-10','15:30:00',1.26),('8998','2013-08-10','15:35:00',1.73),('8998','2013-08-10','15:40:00',1.72),('8998','2013-08-10','15:45:00',1.67),('8998','2013-08-10','15:50:00',1.64),('8998','2013-08-10','15:55:00',1.58),('8998','2013-08-10','16:00:00',1.52),('8998','2013-08-10','16:05:00',1.47),('8998','2013-08-10','16:10:00',1.42),('8998','2013-08-10','16:15:00',1.36),('8998','2013-08-10','16:20:00',1.31),('8998','2013-08-10','16:25:00',1.25),('8998','2013-08-10','16:30:00',1.18),('8998','2013-08-10','16:35:00',1.13),('8998','2013-08-10','16:40:00',1.07),('8998','2013-08-10','16:45:00',1.01),('8998','2013-08-09','07:50:00',1.04),('8998','2013-08-09','07:55:00',1.19),('8998','2013-08-09','08:00:00',1.19),('8998','2013-08-09','08:05:00',1.24),('8998','2013-08-09','08:10:00',1.21),('8998','2013-08-09','08:15:00',1.3),('8998','2013-08-09','08:20:00',1.4),('8998','2013-08-09','08:25:00',1.52),('8998','2013-08-09','08:30:00',1.47),('8998','2013-08-09','08:35:00',1.45),('8998','2013-08-09','08:40:00',1.55),('8998','2013-08-09','08:45:00',1.73),('8998','2013-08-09','08:50:00',1.66),('8998','2013-08-09','08:55:00',1.59),('8998','2013-08-09','09:00:00',1.58),('8998','2013-08-09','09:05:00',1.6),('8998','2013-08-09','09:10:00',1.65),('8998','2013-08-09','09:15:00',1.67),('8998','2013-08-09','09:20:00',1.75),('8998','2013-08-09','09:25:00',1.81),('8998','2013-08-09','09:30:00',1.96),('8998','2013-08-09','09:35:00',2.13),('8998','2013-08-09','09:40:00',2.33),('8998','2013-08-09','09:45:00',2.5),('8998','2013-08-09','09:50:00',2.53),('8998','2013-08-09','09:55:00',2.54),('8998','2013-08-09','10:00:00',2.59),('8998','2013-08-09','10:05:00',2.6),('8998','2013-08-09','10:10:00',2.62),('8998','2013-08-09','10:15:00',2.65),('8998','2013-08-09','10:20:00',2.67),('8998','2013-08-09','10:25:00',2.69),('8998','2013-08-09','10:30:00',2.7),('8998','2013-08-09','10:35:00',2.71),('8998','2013-08-09','10:40:00',2.75),('8998','2013-08-09','10:45:00',2.76),('8998','2013-08-09','10:50:00',2.79),('8998','2013-08-09','10:55:00',2.83),('8998','2013-08-09','11:00:00',2.9),('8998','2013-08-09','11:05:00',2.89),('8998','2013-08-09','11:10:00',2.7),('8998','2013-08-09','11:15:00',2.61),('8998','2013-08-09','11:20:00',1.94),('8998','2013-08-09','11:25:00',2.14),('8998','2013-08-09','11:30:00',2.48),('8998','2013-08-09','11:35:00',2.95),('8998','2013-08-09','11:40:00',2.91),('8998','2013-08-09','11:45:00',2.89),('8998','2013-08-09','11:50:00',2.89),('8998','2013-08-09','11:55:00',2.87),('8998','2013-08-09','12:00:00',2.87),('8998','2013-08-09','12:05:00',2.87),('8998','2013-08-09','12:10:00',2.87),('8998','2013-08-09','12:15:00',2.85),('8998','2013-08-09','12:20:00',2.84),('8998','2013-08-09','12:25:00',2.85),('8998','2013-08-09','12:30:00',2.81),('8998','2013-08-09','12:35:00',2.82),('8998','2013-08-09','12:40:00',2.83),('8998','2013-08-09','12:45:00',2.89),('8998','2013-08-09','12:50:00',2.92),('8998','2013-08-09','12:55:00',2.91),('8998','2013-08-09','13:00:00',2.86),('8998','2013-08-09','13:05:00',2.81),('8998','2013-08-09','13:10:00',2.83),('8998','2013-08-09','13:15:00',2.88),('8998','2013-08-09','13:20:00',2.89),('8998','2013-08-09','13:25:00',2.93),('8998','2013-08-09','13:30:00',2.46),('8998','2013-08-09','13:35:00',1.84),('8998','2013-08-09','13:45:00',1.09),('8998','2013-08-09','13:50:00',2.77),('8998','2013-08-09','13:55:00',2.7),('8998','2013-08-09','14:00:00',2.84),('8998','2013-08-09','14:05:00',2.2),('8998','2013-08-09','14:10:00',2.83),('8998','2013-08-09','14:15:00',2.41),('8998','2013-08-09','14:20:00',1.33),('8998','2013-08-09','15:50:00',1.07),('8998','2013-08-09','15:55:00',1.22),('8998','2013-08-09','16:00:00',1.31),('8998','2013-08-09','16:05:00',2.09),('8998','2013-08-09','16:10:00',1.17),('8998','2013-08-09','16:15:00',1.24),('8998','2013-08-09','16:20:00',1.38),('8998','2013-08-09','16:30:00',1.03),('8998','2013-08-09','16:35:00',1.49),('8998','2013-08-09','16:40:00',1.31),('8998','2013-08-09','16:45:00',1.26),('8998','2013-08-09','16:50:00',1.13),('8998','2014-04-08','08:20:00',1.07),('8998','2014-04-08','09:50:00',1.62),('8998','2014-04-08','09:55:00',2.67),('8998','2014-04-08','10:00:00',2.64),('8998','2014-04-08','10:05:00',2.62),('8998','2014-04-08','10:10:00',2.66),('8998','2014-04-08','10:15:00',2.78),('8998','2014-04-08','10:20:00',2.83),('8998','2014-04-08','10:25:00',2.35),('8998','2014-04-08','10:30:00',2.47),('8998','2014-04-08','10:35:00',3.01),('8998','2014-04-08','10:40:00',1.75),('8998','2014-04-08','10:55:00',1.05),('8998','2014-04-08','11:00:00',2.75),('8998','2014-04-08','11:05:00',3.29),('8998','2014-04-08','11:10:00',3.3),('8998','2014-04-08','11:15:00',3.26),('8998','2014-04-08','11:20:00',2.21),('8998','2014-04-08','11:25:00',1.05),('8998','2014-04-08','11:40:00',2.32),('8998','2014-04-08','11:45:00',3.16),('8998','2014-04-08','11:50:00',1.67),('8998','2014-04-08','11:55:00',2.79),('8998','2014-04-08','12:00:00',2.77),('8998','2014-04-08','12:05:00',3.1),('8998','2014-04-08','12:10:00',1.24),('8998','2014-04-08','13:25:00',1.34),('8998','2014-04-08','13:30:00',1.1),('8998','2014-04-08','13:35:00',1.03),('8998','2014-04-08','14:10:00',1.66),('8998','2014-04-08','14:15:00',1.72),('8998','2014-04-08','14:20:00',1.56),('8998','2014-04-08','14:25:00',1.61),('8998','2014-04-08','14:30:00',1.55),('8998','2014-04-08','14:35:00',2.41),('8998','2014-04-08','14:40:00',1.38),('8998','2014-04-08','14:45:00',1.26),('8998','2014-04-08','14:50:00',1.21),('8998','2014-04-08','14:55:00',1.35),('8998','2014-04-08','15:00:00',1.28),('8998','2014-04-08','15:05:00',2.42),('8998','2014-04-08','15:10:00',2.43),('8998','2014-04-08','15:15:00',2.19),('8998','2014-04-08','15:20:00',2.08),('8998','2014-04-08','15:25:00',1.08),('8998','2014-04-08','15:30:00',1.72),('8998','2014-04-08','15:35:00',1.37),('8998','2014-04-08','15:40:00',1),('8998','2014-04-08','15:45:00',1.29),('8998','2014-04-08','16:10:00',1.35),('8998','2014-04-08','16:15:00',1.43),('8998','2014-04-08','16:20:00',1.46),('8998','2014-04-08','16:25:00',1.32),('8998','2014-04-08','16:30:00',1.13),('8998','2014-04-08','17:05:00',1.06),('8998','2013-08-08','08:05:00',1.12),('8998','2013-08-08','08:35:00',1.04),('8998','2013-08-08','08:40:00',1.37),('8998','2013-08-08','08:45:00',1.27),('8998','2013-08-08','08:50:00',1.57),('8998','2013-08-08','08:55:00',1.45),('8998','2013-08-08','09:00:00',1.4),('8998','2013-08-08','09:05:00',1.63),('8998','2013-08-08','09:10:00',1.71),('8998','2013-08-08','09:15:00',1.53),('8998','2013-08-08','09:20:00',1.38),('8998','2013-08-08','09:25:00',1.25),('8998','2013-08-08','09:30:00',1.8),('8998','2013-08-08','09:35:00',2.21),('8998','2013-08-08','09:40:00',1.77),('8998','2013-08-08','09:45:00',2.33),('8998','2013-08-08','09:50:00',2.33),('8998','2013-08-08','09:55:00',1.58),('8998','2013-08-08','10:00:00',1.68),('8998','2013-08-08','10:05:00',2.08),('8998','2013-08-08','10:10:00',2.34),('8998','2013-08-08','10:15:00',2.39),('8998','2013-08-08','10:20:00',2.37),('8998','2013-08-08','10:25:00',2.39),('8998','2013-08-08','10:30:00',2.43),('8998','2013-08-08','10:35:00',2.44),('8998','2013-08-08','10:40:00',2.52),('8998','2013-08-08','10:45:00',2.44),('8998','2013-08-08','10:50:00',2.51),('8998','2013-08-08','10:55:00',2.53),('8998','2013-08-08','11:00:00',2.54),('8998','2013-08-08','11:05:00',2.55),('8998','2013-08-08','11:10:00',2.56),('8998','2013-08-08','11:15:00',2.59),('8998','2013-08-08','11:20:00',2.6),('8998','2013-08-08','11:25:00',2.61),('8998','2013-08-08','11:30:00',2.62),('8998','2013-08-08','11:35:00',2.58),('8998','2013-08-08','11:40:00',2.58),('8998','2013-08-08','11:45:00',2.6),('8998','2013-08-08','11:50:00',2.61),('8998','2013-08-08','11:55:00',2.63),('8998','2013-08-08','12:00:00',2.6),('8998','2013-08-08','12:05:00',2.59),('8998','2013-08-08','12:10:00',2.61),('8998','2013-08-08','12:15:00',2.63),('8998','2013-08-08','12:20:00',2.69),('8998','2013-08-08','12:25:00',2.52),('8998','2013-08-08','12:30:00',1.82),('8998','2013-08-08','12:35:00',2.14),('8998','2013-08-08','12:40:00',2.77),('8998','2013-08-08','12:45:00',2.01),('8998','2013-08-08','12:50:00',1.65),('8998','2013-08-08','12:55:00',1.79),('8998','2013-08-08','13:00:00',1.04),('8998','2013-08-08','13:25:00',1.4),('8998','2013-08-08','13:30:00',1.38),('8998','2013-08-08','13:35:00',1.03),('8998','2013-08-08','13:40:00',1.09),('8998','2013-08-08','13:45:00',1.01),('8998','2013-08-08','13:50:00',1.04),('8998','2013-08-08','14:10:00',1.09),('8998','2013-08-08','15:10:00',1.73),('8998','2013-08-08','15:15:00',1.59),('8998','2013-08-08','15:35:00',1.18),('8998','2013-08-08','15:45:00',1.68),('8998','2013-08-08','15:50:00',1.33),('8998','2013-08-08','15:55:00',1.3),('8998','2013-08-08','16:55:00',1.18),('8998','2013-08-08','17:05:00',1.01),('8998','2013-08-07','08:00:00',1.02),('8998','2013-08-07','08:05:00',1.08),('8998','2013-08-07','08:10:00',1.13),('8998','2013-08-07','08:15:00',1.21),('8998','2013-08-07','08:20:00',1.2),('8998','2013-08-07','08:25:00',1.25),('8998','2013-08-07','08:30:00',1.28),('8998','2013-08-07','08:35:00',1.33),('8998','2013-08-07','08:40:00',1.37),('8998','2013-08-07','08:45:00',1.39),('8998','2013-08-07','08:50:00',1.41),('8998','2013-08-07','08:55:00',1.45),('8998','2013-08-07','09:00:00',1.48),('8998','2013-08-07','09:05:00',1.53),('8998','2013-08-07','09:10:00',1.55),('8998','2013-08-07','09:15:00',1.57),('8998','2013-08-07','09:20:00',1.69),('8998','2013-08-07','09:25:00',1.7),('8998','2013-08-07','09:30:00',1.86),('8998','2013-08-07','09:35:00',2.05),('8998','2013-08-07','09:40:00',2.21),('8998','2013-08-07','09:45:00',2.3),('8998','2013-08-07','09:50:00',2.32),('8998','2013-08-07','09:55:00',2.35),('8998','2013-08-07','10:00:00',2.37),('8998','2013-08-07','10:05:00',2.4),('8998','2013-08-07','10:10:00',2.43),('8998','2013-08-07','10:15:00',2.45),('8998','2013-08-07','10:20:00',2.45),('8998','2013-08-07','10:25:00',2.47),('8998','2013-08-07','10:30:00',2.5),('8998','2013-08-07','10:35:00',2.5),('8998','2013-08-07','10:40:00',2.52),('8998','2013-08-07','10:45:00',2.54),('8998','2013-08-07','10:50:00',2.55),('8998','2013-08-07','10:55:00',2.56),('8998','2013-08-07','11:00:00',2.56),('8998','2013-08-07','11:05:00',2.58),('8998','2013-08-07','11:10:00',2.59),('8998','2013-08-07','11:15:00',2.59),('8998','2013-08-07','11:20:00',2.6),('8998','2013-08-07','11:25:00',2.6),('8998','2013-08-07','11:30:00',2.56),('8998','2013-08-07','11:35:00',2.58),('8998','2013-08-07','11:40:00',2.61),('8998','2013-08-07','11:45:00',2.59),('8998','2013-08-07','11:50:00',2.58),('8998','2013-08-07','11:55:00',2.59),('8998','2013-08-07','12:00:00',2.62),('8998','2013-08-07','12:05:00',2.6),('8998','2013-08-07','12:10:00',2.57),('8998','2013-08-07','12:15:00',2.58),('8998','2013-08-07','12:20:00',2.56),('8998','2013-08-07','12:25:00',2.57),('8998','2013-08-07','12:30:00',2.59),('8998','2013-08-07','12:35:00',2.6),('8998','2013-08-07','12:40:00',2.56),('8998','2013-08-07','12:45:00',2.56),('8998','2013-08-07','12:50:00',2.55),('8998','2013-08-07','12:55:00',2.55),('8998','2013-08-07','13:00:00',2.52),('8998','2013-08-07','13:05:00',2.53),('8998','2013-08-07','13:10:00',2.51),('8998','2013-08-07','13:15:00',2.49),('8998','2013-08-07','13:20:00',2.47),('8998','2013-08-07','13:25:00',2.47),('8998','2013-08-07','13:30:00',2.45),('8998','2013-08-07','13:35:00',2.42),('8998','2013-08-07','13:40:00',2.39),('8998','2013-08-07','13:45:00',2.34),('8998','2013-08-07','13:50:00',2.34),('8998','2013-08-07','13:55:00',2.31),('8998','2013-08-07','14:00:00',2.31),('8998','2013-08-07','14:05:00',2.28),('8998','2013-08-07','14:10:00',2.24),('8998','2013-08-07','14:15:00',2.21),('8998','2013-08-07','14:20:00',2.18),('8998','2013-08-07','14:25:00',2.14),('8998','2013-08-07','14:30:00',2.12),('8998','2013-08-07','14:35:00',2.09),('8998','2013-08-07','14:40:00',2.06),('8998','2013-08-07','14:45:00',2.02),('8998','2013-08-07','14:50:00',1.99),('8998','2013-08-07','14:55:00',1.94),('8998','2013-08-07','15:00:00',1.91),('8998','2013-08-07','15:05:00',1.86),('8998','2013-08-07','15:10:00',1.81),('8998','2013-08-07','15:15:00',1.79),('8998','2013-08-07','15:20:00',1.74),('8998','2013-08-07','15:25:00',1.7),('8998','2013-08-07','15:30:00',1.66),('8998','2013-08-07','15:35:00',1.6),('8998','2013-08-07','15:40:00',1.55),('8998','2013-08-07','15:45:00',1.52),('8998','2013-08-07','15:50:00',1.47),('8998','2013-08-07','15:55:00',1.42),('8998','2013-08-07','16:00:00',1.38),('8998','2013-08-07','16:05:00',1.33),('8998','2013-08-07','16:10:00',1.29),('8998','2013-08-07','16:15:00',1.25),('8998','2013-08-07','16:20:00',1.2),('8998','2013-08-07','16:25:00',1.16),('8998','2013-08-07','16:30:00',1.11),('8998','2013-08-07','16:35:00',1.06),('8998','2013-08-07','16:40:00',1.02),('8998','2013-08-06','07:50:00',1.01),('8998','2013-08-06','07:55:00',1.03),('8998','2013-08-06','08:00:00',1.04),('8998','2013-08-06','08:05:00',1.09),('8998','2013-08-06','08:10:00',1.15),('8998','2013-08-06','08:15:00',1.25),('8998','2013-08-06','08:20:00',1.24),('8998','2013-08-06','08:25:00',1.27),('8998','2013-08-06','08:30:00',1.31),('8998','2013-08-06','08:35:00',1.34),('8998','2013-08-06','08:40:00',1.42),('8998','2013-08-06','08:45:00',1.44),('8998','2013-08-06','08:50:00',1.6),('8998','2013-08-06','08:55:00',1.63),('8998','2013-08-06','09:00:00',1.88),('8998','2013-08-06','09:05:00',1.88),('8998','2013-08-06','09:10:00',1.88),('8998','2013-08-06','09:15:00',1.9),('8998','2013-08-06','09:20:00',1.79),('8998','2013-08-06','09:25:00',1.76),('8998','2013-08-06','09:30:00',1.98),('8998','2013-08-06','09:35:00',2.11),('8998','2013-08-06','09:40:00',2.24),('8998','2013-08-06','09:45:00',2.28),('8998','2013-08-06','09:50:00',2.33),('8998','2013-08-06','09:55:00',2.37),('8998','2013-08-06','10:00:00',2.41),('8998','2013-08-06','10:05:00',2.41),('8998','2013-08-06','10:10:00',2.47),('8998','2013-08-06','10:15:00',2.47),('8998','2013-08-06','10:20:00',2.52),('8998','2013-08-06','10:25:00',2.53),('8998','2013-08-06','10:30:00',2.54),('8998','2013-08-06','10:35:00',2.52),('8998','2013-08-06','10:40:00',2.55),('8998','2013-08-06','10:45:00',2.58),('8998','2013-08-06','10:50:00',2.6),('8998','2013-08-06','10:55:00',2.6),('8998','2013-08-06','11:00:00',2.6),('8998','2013-08-06','11:05:00',2.61),('8998','2013-08-06','11:10:00',2.61),('8998','2013-08-06','11:15:00',2.63),('8998','2013-08-06','11:20:00',2.64),('8998','2013-08-06','11:25:00',2.65),('8998','2013-08-06','11:30:00',2.64),('8998','2013-08-06','11:35:00',2.64),('8998','2013-08-06','11:40:00',2.63),('8998','2013-08-06','11:45:00',2.63),('8998','2013-08-06','11:50:00',2.63),('8998','2013-08-06','11:55:00',2.62),('8998','2013-08-06','12:00:00',2.65),('8998','2013-08-06','12:05:00',2.63),('8998','2013-08-06','12:10:00',2.64),('8998','2013-08-06','12:15:00',2.62),('8998','2013-08-06','12:20:00',2.61),('8998','2013-08-06','12:25:00',2.59),('8998','2013-08-06','12:30:00',2.57),('8998','2013-08-06','12:35:00',2.58),('8998','2013-08-06','12:40:00',2.53),('8998','2013-08-06','12:45:00',2.52),('8998','2013-08-06','12:50:00',2.53),('8998','2013-08-06','12:55:00',2.53),('8998','2013-08-06','13:00:00',2.51),('8998','2013-08-06','13:05:00',2.51),('8998','2013-08-06','13:10:00',2.52),('8998','2013-08-06','13:15:00',2.48),('8998','2013-08-06','13:20:00',2.5),('8998','2013-08-06','13:25:00',2.44),('8998','2013-08-06','13:30:00',2.45),('8998','2013-08-06','13:35:00',2.34),('8998','2013-08-06','13:40:00',2.4),('8998','2013-08-06','13:45:00',2.4),('8998','2013-08-06','13:50:00',2.34),('8998','2013-08-06','13:55:00',2.36),('8998','2013-08-06','14:00:00',2.3),('8998','2013-08-06','14:05:00',2.31),('8998','2013-08-06','14:10:00',2.3),('8998','2013-08-06','14:15:00',2.2),('8998','2013-08-06','14:20:00',2.19),('8998','2013-08-06','14:25:00',2.14),('8998','2013-08-06','14:30:00',2.1),('8998','2013-08-06','14:35:00',2.07),('8998','2013-08-06','14:40:00',2.06),('8998','2013-08-06','14:45:00',2.07),('8998','2013-08-06','14:50:00',2.02),('8998','2013-08-06','14:55:00',1.99),('8998','2013-08-06','15:00:00',1.95),('8998','2013-08-06','15:05:00',1.9),('8998','2013-08-06','15:10:00',1.87),('8998','2013-08-06','15:15:00',1.82),('8998','2013-08-06','15:20:00',1.79),('8998','2013-08-06','15:25:00',1.74),('8998','2013-08-06','15:30:00',1.71),('8998','2013-08-06','15:35:00',1.66),('8998','2013-08-06','15:40:00',1.61),('8998','2013-08-06','15:45:00',1.56),('8998','2013-08-06','15:50:00',1.51),('8998','2013-08-06','15:55:00',1.46),('8998','2013-08-06','16:00:00',1.39),('8998','2013-08-06','16:05:00',1.36),('8998','2013-08-06','16:10:00',1.31),('8998','2013-08-06','16:15:00',1.26),('8998','2013-08-06','16:20:00',1.22),('8998','2013-08-06','16:25:00',1.18),('8998','2013-08-06','16:30:00',1.13),('8998','2013-08-06','16:35:00',1.08),('8998','2013-08-06','16:40:00',1.02),('8998','2013-08-05','08:00:00',1.05),('8998','2013-08-05','08:05:00',1.09),('8998','2013-08-05','08:10:00',1.17),('8998','2013-08-05','08:15:00',1.23),('8998','2013-08-05','08:20:00',1.26),('8998','2013-08-05','08:25:00',1.27),('8998','2013-08-05','08:30:00',1.33),('8998','2013-08-05','08:35:00',1.34),('8998','2013-08-05','08:40:00',1.41),('8998','2013-08-05','08:45:00',1.43),('8998','2013-08-05','08:50:00',1.46),('8998','2013-08-05','08:55:00',1.49),('8998','2013-08-05','09:00:00',1.51),('8998','2013-08-05','09:05:00',1.54),('8998','2013-08-05','09:10:00',1.59),('8998','2013-08-05','09:15:00',1.61),('8998','2013-08-05','09:20:00',1.69),('8998','2013-08-05','09:25:00',1.78),('8998','2013-08-05','09:30:00',1.89),('8998','2013-08-05','09:35:00',2.09),('8998','2013-08-05','09:40:00',2.23),('8998','2013-08-05','09:45:00',2.3),('8998','2013-08-05','09:50:00',2.33),('8998','2013-08-05','09:55:00',2.33),('8998','2013-08-05','10:00:00',2.38),('8998','2013-08-05','10:05:00',2.41),('8998','2013-08-05','10:10:00',2.43),('8998','2013-08-05','10:15:00',2.45),('8998','2013-08-05','10:20:00',2.48),('8998','2013-08-05','10:25:00',2.49),('8998','2013-08-05','10:30:00',2.5),('8998','2013-08-05','10:35:00',2.51),('8998','2013-08-05','10:40:00',2.52),('8998','2013-08-05','10:45:00',2.54),('8998','2013-08-05','10:50:00',2.55),('8998','2013-08-05','10:55:00',2.55),('8998','2013-08-05','11:00:00',2.56),('8998','2013-08-05','11:05:00',2.59),('8998','2013-08-05','11:10:00',2.61),('8998','2013-08-05','11:15:00',2.62),('8998','2013-08-05','11:20:00',2.64),('8998','2013-08-05','11:25:00',2.63),('8998','2013-08-05','11:30:00',2.65),('8998','2013-08-05','11:35:00',2.66),('8998','2013-08-05','11:40:00',2.65),('8998','2013-08-05','11:45:00',2.64),('8998','2013-08-05','11:50:00',2.63),('8998','2013-08-05','11:55:00',2.63),('8998','2013-08-05','12:00:00',2.65),('8998','2013-08-05','12:05:00',2.64),('8998','2013-08-05','12:10:00',2.64),('8998','2013-08-05','12:15:00',2.63),('8998','2013-08-05','12:20:00',2.61),('8998','2013-08-05','12:25:00',2.57),('8998','2013-08-05','12:30:00',2.58),('8998','2013-08-05','12:35:00',2.57),('8998','2013-08-05','12:40:00',2.56),('8998','2013-08-05','12:45:00',2.53),('8998','2013-08-05','12:50:00',2.52),('8998','2013-08-05','12:55:00',2.54),('8998','2013-08-05','13:00:00',2.53),('8998','2013-08-05','13:05:00',2.53),('8998','2013-08-05','13:10:00',2.5),('8998','2013-08-05','13:15:00',2.5),('8998','2013-08-05','13:20:00',2.49),('8998','2013-08-05','13:25:00',2.48),('8998','2013-08-05','13:30:00',2.46),('8998','2013-08-05','13:35:00',2.45),('8998','2013-08-05','13:40:00',2.43),('8998','2013-08-05','13:45:00',2.42),('8998','2013-08-05','13:50:00',2.41),('8998','2013-08-05','13:55:00',2.39),('8998','2013-08-05','14:00:00',2.38),('8998','2013-08-05','14:05:00',2.35),('8998','2013-08-05','14:10:00',2.32),('8998','2013-08-05','14:15:00',2.3),('8998','2013-08-05','14:20:00',2.27),('8998','2013-08-05','14:25:00',2.24),('8998','2013-08-05','14:30:00',2.22),('8998','2013-08-05','14:35:00',2.18),('8998','2013-08-05','14:40:00',2.14),('8998','2013-08-05','14:45:00',2.1),('8998','2013-08-05','14:50:00',2.07),('8998','2013-08-05','14:55:00',2.04),('8998','2013-08-05','15:00:00',2.01),('8998','2013-08-05','15:05:00',1.97),('8998','2013-08-05','15:10:00',1.92),('8998','2013-08-05','15:15:00',1.88),('8998','2013-08-05','15:20:00',1.84),('8998','2013-08-05','15:25:00',1.8),('8998','2013-08-05','15:30:00',1.75),('8998','2013-08-05','15:35:00',1.71),('8998','2013-08-05','15:40:00',1.66),('8998','2013-08-05','15:45:00',1.61),('8998','2013-08-05','15:50:00',1.57),('8998','2013-08-05','15:55:00',1.52),('8998','2013-08-05','16:00:00',1.47),('8998','2013-08-05','16:05:00',1.41),('8998','2013-08-05','16:10:00',1.36),('8998','2013-08-05','16:15:00',1.31),('8998','2013-08-05','16:20:00',1.27),('8998','2013-08-05','16:25:00',1.21),('8998','2013-08-05','16:30:00',1.17),('8998','2013-08-05','16:35:00',1.11),('8998','2013-08-05','16:40:00',1.06),('8998','2013-08-05','16:45:00',1.01),('8998','2013-08-04','07:50:00',1.08),('8998','2013-08-04','07:55:00',1.08),('8998','2013-08-04','08:00:00',1.1),('8998','2013-08-04','08:05:00',1.14),('8998','2013-08-04','08:10:00',1.21),('8998','2013-08-04','08:15:00',1.27),('8998','2013-08-04','08:20:00',1.32),('8998','2013-08-04','08:25:00',1.3),('8998','2013-08-04','08:30:00',1.36),('8998','2013-08-04','08:35:00',1.37),('8998','2013-08-04','08:40:00',1.43),('8998','2013-08-04','08:45:00',1.47),('8998','2013-08-04','08:50:00',1.49),('8998','2013-08-04','08:55:00',1.52),('8998','2013-08-04','09:00:00',1.55),('8998','2013-08-04','09:05:00',1.56),('8998','2013-08-04','09:10:00',1.61),('8998','2013-08-04','09:15:00',1.64),('8998','2013-08-04','09:20:00',1.68),('8998','2013-08-04','09:25:00',1.82),('8998','2013-08-04','09:30:00',1.91),('8998','2013-08-04','09:35:00',2.14),('8998','2013-08-04','09:40:00',2.26),('8998','2013-08-04','09:45:00',2.31),('8998','2013-08-04','09:50:00',2.34),('8998','2013-08-04','09:55:00',2.38),('8998','2013-08-04','10:00:00',2.41),('8998','2013-08-04','10:05:00',2.44),('8998','2013-08-04','10:10:00',2.47),('8998','2013-08-04','10:15:00',2.48),('8998','2013-08-04','10:20:00',2.52),('8998','2013-08-04','10:25:00',2.55),('8998','2013-08-04','10:30:00',2.56),('8998','2013-08-04','10:35:00',2.56),('8998','2013-08-04','10:40:00',2.58),('8998','2013-08-04','10:45:00',2.6),('8998','2013-08-04','10:50:00',2.62),('8998','2013-08-04','10:55:00',2.64),('8998','2013-08-04','11:00:00',2.64),('8998','2013-08-04','11:05:00',2.67),('8998','2013-08-04','11:10:00',2.68),('8998','2013-08-04','11:15:00',2.69),('8998','2013-08-04','11:20:00',2.71),('8998','2013-08-04','11:25:00',2.71),('8998','2013-08-04','11:30:00',2.7),('8998','2013-08-04','11:35:00',2.7),('8998','2013-08-04','11:40:00',2.69),('8998','2013-08-04','11:45:00',2.7),('8998','2013-08-04','11:50:00',2.7),('8998','2013-08-04','11:55:00',2.7),('8998','2013-08-04','12:00:00',2.7),('8998','2013-08-04','12:05:00',2.69),('8998','2013-08-04','12:10:00',2.69),('8998','2013-08-04','12:15:00',2.68),('8998','2013-08-04','12:20:00',2.68),('8998','2013-08-04','12:25:00',2.68),('8998','2013-08-04','12:30:00',2.66),('8998','2013-08-04','12:35:00',2.64),('8998','2013-08-04','12:40:00',2.65),('8998','2013-08-04','12:45:00',2.66),('8998','2013-08-04','12:50:00',2.62),('8998','2013-08-04','12:55:00',2.59),('8998','2013-08-04','13:00:00',2.61),('8998','2013-08-04','13:05:00',2.6),('8998','2013-08-04','13:10:00',2.53),('8998','2013-08-04','13:15:00',2.53),('8998','2013-08-04','13:20:00',2.52),('8998','2013-08-04','13:25:00',2.49),('8998','2013-08-04','13:30:00',2.47),('8998','2013-08-04','13:35:00',2.47),('8998','2013-08-04','13:40:00',2.45),('8998','2013-08-04','13:45:00',2.43),('8998','2013-08-04','13:50:00',2.39),('8998','2013-08-04','13:55:00',2.33),('8998','2013-08-04','14:00:00',2.31),('8998','2013-08-04','14:05:00',2.32),('8998','2013-08-04','14:10:00',2.27),('8998','2013-08-04','14:15:00',2.25),('8998','2013-08-04','14:20:00',2.24),('8998','2013-08-04','14:25:00',2.18),('8998','2013-08-04','14:30:00',2.17),('8998','2013-08-04','14:35:00',2.14),('8998','2013-08-04','14:40:00',2.11),('8998','2013-08-04','14:45:00',2.08),('8998','2013-08-04','14:50:00',2.04),('8998','2013-08-04','14:55:00',2.01),('8998','2013-08-04','15:00:00',1.96),('8998','2013-08-04','15:05:00',1.93),('8998','2013-08-04','15:10:00',1.89),('8998','2013-08-04','15:15:00',1.86),('8998','2013-08-04','15:20:00',1.81),('8998','2013-08-04','15:25:00',1.78),('8998','2013-08-04','15:30:00',1.75),('8998','2013-08-04','15:35:00',1.7),('8998','2013-08-04','15:40:00',1.65),('8998','2013-08-04','15:45:00',1.6),('8998','2013-08-04','15:50:00',1.54),('8998','2013-08-04','15:55:00',1.5),('8998','2013-08-04','16:00:00',1.46),('8998','2013-08-04','16:05:00',1.43),('8998','2013-08-04','16:10:00',1.37),('8998','2013-08-04','16:15:00',1.31),('8998','2013-08-04','16:20:00',1.26),('8998','2013-08-04','16:25:00',1.21),('8998','2013-08-04','16:30:00',1.16),('8998','2013-08-04','16:35:00',1.12),('8998','2013-08-04','16:40:00',1.06),('8998','2013-08-04','16:45:00',1.01),('8998','2013-08-03','07:45:00',1.08),('8998','2013-08-03','07:50:00',1.16),('8998','2013-08-03','07:55:00',1.16),('8998','2013-08-03','08:00:00',1.3),('8998','2013-08-03','08:05:00',1.16),('8998','2013-08-03','08:10:00',1.25),('8998','2013-08-03','08:15:00',1.3),('8998','2013-08-03','08:20:00',1.33),('8998','2013-08-03','08:25:00',1.34),('8998','2013-08-03','08:30:00',1.54),('8998','2013-08-03','08:35:00',1.54),('8998','2013-08-03','08:40:00',1.87),('8998','2013-08-03','08:45:00',1.88),('8998','2013-08-03','08:50:00',1.82),('8998','2013-08-03','08:55:00',1.93),('8998','2013-08-03','09:00:00',2.05),('8998','2013-08-03','09:05:00',2.08),('8998','2013-08-03','09:10:00',2.06),('8998','2013-08-03','09:15:00',2.04),('8998','2013-08-03','09:20:00',2.04),('8998','2013-08-03','09:25:00',1.88),('8998','2013-08-03','09:30:00',1.99),('8998','2013-08-03','09:35:00',2.24),('8998','2013-08-03','09:40:00',2.42),('8998','2013-08-03','09:45:00',2.45),('8998','2013-08-03','09:50:00',2.48),('8998','2013-08-03','09:55:00',2.5),('8998','2013-08-03','10:00:00',2.53),('8998','2013-08-03','10:05:00',2.56),('8998','2013-08-03','10:10:00',2.57),('8998','2013-08-03','10:15:00',2.59),('8998','2013-08-03','10:20:00',2.62),('8998','2013-08-03','10:25:00',2.65),('8998','2013-08-03','10:30:00',2.67),('8998','2013-08-03','10:35:00',2.68),('8998','2013-08-03','10:40:00',2.69),('8998','2013-08-03','10:45:00',2.69),('8998','2013-08-03','10:50:00',2.7),('8998','2013-08-03','10:55:00',2.7),('8998','2013-08-03','11:00:00',2.7),('8998','2013-08-03','11:05:00',2.7),('8998','2013-08-03','11:10:00',2.71),('8998','2013-08-03','11:15:00',2.72),('8998','2013-08-03','11:20:00',2.74),('8998','2013-08-03','11:25:00',2.75),('8998','2013-08-03','11:30:00',2.76),('8998','2013-08-03','11:35:00',2.78),('8998','2013-08-03','11:40:00',2.78),('8998','2013-08-03','11:45:00',2.77),('8998','2013-08-03','11:50:00',2.77),('8998','2013-08-03','11:55:00',2.79),('8998','2013-08-03','12:00:00',2.79),('8998','2013-08-03','12:05:00',2.78),('8998','2013-08-03','12:10:00',2.78),('8998','2013-08-03','12:15:00',2.76),('8998','2013-08-03','12:20:00',2.75),('8998','2013-08-03','12:25:00',2.73),('8998','2013-08-03','12:30:00',2.72),('8998','2013-08-03','12:35:00',2.71),('8998','2013-08-03','12:40:00',2.72),('8998','2013-08-03','12:45:00',2.69),('8998','2013-08-03','12:50:00',2.69),('8998','2013-08-03','12:55:00',2.64),('8998','2013-08-03','13:00:00',2.64),('8998','2013-08-03','13:05:00',2.66),('8998','2013-08-03','13:10:00',2.6),('8998','2013-08-03','13:15:00',2.58),('8998','2013-08-03','13:20:00',2.56),('8998','2013-08-03','13:25:00',2.52),('8998','2013-08-03','13:30:00',2.52),('8998','2013-08-03','13:35:00',2.53),('8998','2013-08-03','13:40:00',2.52),('8998','2013-08-03','13:45:00',2.52),('8998','2013-08-03','13:50:00',2.5),('8998','2013-08-03','13:55:00',2.46),('8998','2013-08-03','14:00:00',2.45),('8998','2013-08-03','14:05:00',2.43),('8998','2013-08-03','14:10:00',2.39),('8998','2013-08-03','14:15:00',2.37),('8998','2013-08-03','14:20:00',2.32),('8998','2013-08-03','14:25:00',2.3),('8998','2013-08-03','14:30:00',2.27),('8998','2013-08-03','14:35:00',2.25),('8998','2013-08-03','14:40:00',2.22),('8998','2013-08-03','14:45:00',2.17),('8998','2013-08-03','14:50:00',2.13),('8998','2013-08-03','14:55:00',2.09),('8998','2013-08-03','15:00:00',2.05),('8998','2013-08-03','15:05:00',2.01),('8998','2013-08-03','15:10:00',1.98),('8998','2013-08-03','15:15:00',1.93),('8998','2013-08-03','15:20:00',1.89),('8998','2013-08-03','15:25:00',1.83),('8998','2013-08-03','15:30:00',1.77),('8998','2013-08-03','15:35:00',1.76),('8998','2013-08-03','15:40:00',1.7),('8998','2013-08-03','15:45:00',1.65),('8998','2013-08-03','15:50:00',1.59),('8998','2013-08-03','15:55:00',1.54),('8998','2013-08-03','16:00:00',1.5),('8998','2013-08-03','16:05:00',1.44),('8998','2013-08-03','16:10:00',1.39),('8998','2013-08-03','16:15:00',1.35),('8998','2013-08-03','16:20:00',1.31),('8998','2013-08-03','16:25:00',1.25),('8998','2013-08-03','16:30:00',1.2),('8998','2013-08-03','16:35:00',1.14),('8998','2013-08-03','16:40:00',1.09),('8998','2013-08-03','16:45:00',1.03),('8998','2013-08-02','07:40:00',1.05),('8998','2013-08-02','07:45:00',1.1),('8998','2013-08-02','07:50:00',1.16),('8998','2013-08-02','07:55:00',1.28),('8998','2013-08-02','08:00:00',1.28),('8998','2013-08-02','08:05:00',1.18),('8998','2013-08-02','08:10:00',1.26),('8998','2013-08-02','08:15:00',1.32),('8998','2013-08-02','08:20:00',1.31),('8998','2013-08-02','08:25:00',1.29),('8998','2013-08-02','08:30:00',1.33),('8998','2013-08-02','08:35:00',1.35),('8998','2013-08-02','08:40:00',1.43),('8998','2013-08-02','08:45:00',1.48),('8998','2013-08-02','08:50:00',1.48),('8998','2013-08-02','08:55:00',1.73),('8998','2013-08-02','09:00:00',1.68),('8998','2013-08-02','09:05:00',1.61),('8998','2013-08-02','09:10:00',1.55),('8998','2013-08-02','09:15:00',1.69),('8998','2013-08-02','09:20:00',1.68),('8998','2013-08-02','09:25:00',1.84),('8998','2013-08-02','09:30:00',2.03),('8998','2013-08-02','09:35:00',2.25),('8998','2013-08-02','09:40:00',2.4),('8998','2013-08-02','09:45:00',2.43),('8998','2013-08-02','09:50:00',2.47),('8998','2013-08-02','09:55:00',2.5),('8998','2013-08-02','10:00:00',2.52),('8998','2013-08-02','10:05:00',2.55),('8998','2013-08-02','10:10:00',2.56),('8998','2013-08-02','10:15:00',2.6),('8998','2013-08-02','10:20:00',2.6),('8998','2013-08-02','10:25:00',2.62),('8998','2013-08-02','10:30:00',2.62),('8998','2013-08-02','10:35:00',2.62),('8998','2013-08-02','10:40:00',2.69),('8998','2013-08-02','10:45:00',2.71),('8998','2013-08-02','10:50:00',2.71),('8998','2013-08-02','10:55:00',2.73),('8998','2013-08-02','11:00:00',2.75),('8998','2013-08-02','11:05:00',2.74),('8998','2013-08-02','11:10:00',2.73),('8998','2013-08-02','11:15:00',2.76),('8998','2013-08-02','11:20:00',2.75),('8998','2013-08-02','11:25:00',2.77),('8998','2013-08-02','11:30:00',2.77),('8998','2013-08-02','11:35:00',2.75),('8998','2013-08-02','11:40:00',2.75),('8998','2013-08-02','11:45:00',2.73),('8998','2013-08-02','11:50:00',2.76),('8998','2013-08-02','11:55:00',2.76),('8998','2013-08-02','12:00:00',2.75),('8998','2013-08-02','12:05:00',2.78),('8998','2013-08-02','12:10:00',2.76),('8998','2013-08-02','12:15:00',2.75),('8998','2013-08-02','12:20:00',2.74),('8998','2013-08-02','12:25:00',2.74),('8998','2013-08-02','12:30:00',2.74),('8998','2013-08-02','12:35:00',2.71),('8998','2013-08-02','12:40:00',2.71),('8998','2013-08-02','12:45:00',2.7),('8998','2013-08-02','12:50:00',2.7),('8998','2013-08-02','12:55:00',2.68),('8998','2013-08-02','13:00:00',2.63),('8998','2013-08-02','13:05:00',2.59),('8998','2013-08-02','13:10:00',2.56),('8998','2013-08-02','13:15:00',2.53),('8998','2013-08-02','13:20:00',2.48),('8998','2013-08-02','13:25:00',2.47),('8998','2013-08-02','13:30:00',2.45),('8998','2013-08-02','13:35:00',2.38),('8998','2013-08-02','13:40:00',2.43),('8998','2013-08-02','13:45:00',2.43),('8998','2013-08-02','13:50:00',2.41),('8998','2013-08-02','13:55:00',2.4),('8998','2013-08-02','14:00:00',2.43),('8998','2013-08-02','14:05:00',2.4),('8998','2013-08-02','14:10:00',2.3),('8998','2013-08-02','14:15:00',2.24),('8998','2013-08-02','14:20:00',2.18),('8998','2013-08-02','14:25:00',2.14),('8998','2013-08-02','14:30:00',2.17),('8998','2013-08-02','14:35:00',2.19),('8998','2013-08-02','14:40:00',2.14),('8998','2013-08-02','14:45:00',2.13),('8998','2013-08-02','14:50:00',2.09),('8998','2013-08-02','14:55:00',2.07),('8998','2013-08-02','15:00:00',2.03),('8998','2013-08-02','15:05:00',1.98),('8998','2013-08-02','15:10:00',1.94),('8998','2013-08-02','15:15:00',1.89),('8998','2013-08-02','15:20:00',1.88),('8998','2013-08-02','15:25:00',1.84),('8998','2013-08-02','15:30:00',1.79),('8998','2013-08-02','15:35:00',1.75),('8998','2013-08-02','15:40:00',1.7),('8998','2013-08-02','15:45:00',1.65),('8998','2013-08-02','15:50:00',1.61),('8998','2013-08-02','15:55:00',1.55),('8998','2013-08-02','16:00:00',1.49),('8998','2013-08-02','16:05:00',1.44),('8998','2013-08-02','16:10:00',1.39),('8998','2013-08-02','16:15:00',1.33),('8998','2013-08-02','16:20:00',1.28),('8998','2013-08-02','16:25:00',1.23),('8998','2013-08-02','16:30:00',1.18),('8998','2013-08-02','16:35:00',1.13),('8998','2013-08-02','16:40:00',1.08),('8998','2013-08-02','16:45:00',1.03),('8998','2013-08-01','07:35:00',1.01),('8998','2013-08-01','07:40:00',1.11),('8998','2013-08-01','07:45:00',1.19),('8998','2013-08-01','07:50:00',1.26),('8998','2013-08-01','07:55:00',1.23),('8998','2013-08-01','08:00:00',1.19),('8998','2013-08-01','08:05:00',1.26),('8998','2013-08-01','08:10:00',1.29),('8998','2013-08-01','08:15:00',1.39),('8998','2013-08-01','08:20:00',1.37),('8998','2013-08-01','08:25:00',1.35),('8998','2013-08-01','08:30:00',1.36),('8998','2013-08-01','08:35:00',1.41),('8998','2013-08-01','08:40:00',1.53),('8998','2013-08-01','08:45:00',1.53),('8998','2013-08-01','08:50:00',1.57),('8998','2013-08-01','08:55:00',1.84),('8998','2013-08-01','09:00:00',1.74),('8998','2013-08-01','09:05:00',1.67),('8998','2013-08-01','09:10:00',1.58),('8998','2013-08-01','09:15:00',1.77),('8998','2013-08-01','09:20:00',1.76),('8998','2013-08-01','09:25:00',1.92),('8998','2013-08-01','09:30:00',2.14),('8998','2013-08-01','09:35:00',2.36),('8998','2013-08-01','09:40:00',2.48),('8998','2013-08-01','09:45:00',2.5),('8998','2013-08-01','09:50:00',2.54),('8998','2013-08-01','09:55:00',2.55),('8998','2013-08-01','10:00:00',2.55),('8998','2013-08-01','10:05:00',2.59),('8998','2013-08-01','10:10:00',2.62),('8998','2013-08-01','10:15:00',2.64),('8998','2013-08-01','10:20:00',2.65),('8998','2013-08-01','10:25:00',2.66),('8998','2013-08-01','10:30:00',2.68),('8998','2013-08-01','10:35:00',2.71),('8998','2013-08-01','10:40:00',2.72),('8998','2013-08-01','10:45:00',2.74),('8998','2013-08-01','10:50:00',2.76),('8998','2013-08-01','10:55:00',2.76),('8998','2013-08-01','11:00:00',2.76),('8998','2013-08-01','11:05:00',2.77),('8998','2013-08-01','11:10:00',2.77),('8998','2013-08-01','11:15:00',2.78),('8998','2013-08-01','11:20:00',2.8),('8998','2013-08-01','11:25:00',2.82),('8998','2013-08-01','11:30:00',2.83),('8998','2013-08-01','11:35:00',2.82),('8998','2013-08-01','11:40:00',2.8),('8998','2013-08-01','11:45:00',2.82),('8998','2013-08-01','11:50:00',2.81),('8998','2013-08-01','11:55:00',2.83),('8998','2013-08-01','12:00:00',2.83),('8998','2013-08-01','12:05:00',2.82),('8998','2013-08-01','12:10:00',2.83),('8998','2013-08-01','12:15:00',2.8),('8998','2013-08-01','12:20:00',2.79),('8998','2013-08-01','12:25:00',2.75),('8998','2013-08-01','12:30:00',2.73),('8998','2013-08-01','12:35:00',2.73),('8998','2013-08-01','12:40:00',2.72),('8998','2013-08-01','12:45:00',2.7),('8998','2013-08-01','12:50:00',2.68),('8998','2013-08-01','12:55:00',2.65),('8998','2013-08-01','13:00:00',2.68),('8998','2013-08-01','13:05:00',2.69),('8998','2013-08-01','13:10:00',2.7),('8998','2013-08-01','13:15:00',2.68),('8998','2013-08-01','13:20:00',2.65),('8998','2013-08-01','13:25:00',2.6),('8998','2013-08-01','13:30:00',2.61),('8998','2013-08-01','13:35:00',2.6),('8998','2013-08-01','13:40:00',2.55),('8998','2013-08-01','13:45:00',2.51),('8998','2013-08-01','13:50:00',2.49),('8998','2013-08-01','13:55:00',2.47),('8998','2013-08-01','14:00:00',2.45),('8998','2013-08-01','14:05:00',2.42),('8998','2013-08-01','14:10:00',2.39),('8998','2013-08-01','14:15:00',2.36),('8998','2013-08-01','14:20:00',2.3),('8998','2013-08-01','14:25:00',2.25),('8998','2013-08-01','14:30:00',2.28),('8998','2013-08-01','14:35:00',2.28),('8998','2013-08-01','14:40:00',2.23),('8998','2013-08-01','14:45:00',2.21),('8998','2013-08-01','14:50:00',2.16),('8998','2013-08-01','14:55:00',2.12),('8998','2013-08-01','15:00:00',2.08),('8998','2013-08-01','15:05:00',2.05),('8998','2013-08-01','15:10:00',1.98),('8998','2013-08-01','15:15:00',1.91),('8998','2013-08-01','15:20:00',1.9),('8998','2013-08-01','15:25:00',1.86),('8998','2013-08-01','15:30:00',1.83),('8998','2013-08-01','15:35:00',1.78),('8998','2013-08-01','15:40:00',1.73),('8998','2013-08-01','15:45:00',1.7),('8998','2013-08-01','15:50:00',1.64),('8998','2013-08-01','15:55:00',1.57),('8998','2013-08-01','16:00:00',1.53),('8998','2013-08-01','16:05:00',1.49),('8998','2013-08-01','16:10:00',1.44),('8998','2013-08-01','16:15:00',1.38),('8998','2013-08-01','16:20:00',1.32),('8998','2013-08-01','16:25:00',1.26),('8998','2013-08-01','16:30:00',1.22),('8998','2013-08-01','16:35:00',1.18),('8998','2013-08-01','16:40:00',1.12),('8998','2013-08-01','16:45:00',1.07),('8998','2013-08-01','16:50:00',1.02),('8998','2013-07-31','07:35:00',1.06),('8998','2013-07-31','07:40:00',1.12),('8998','2013-07-31','07:45:00',1.23),('8998','2013-07-31','07:50:00',1.28),('8998','2013-07-31','07:55:00',1.28),('8998','2013-07-31','08:00:00',1.2),('8998','2013-07-31','08:05:00',1.22),('8998','2013-07-31','08:10:00',1.26),('8998','2013-07-31','08:15:00',1.37),('8998','2013-07-31','08:20:00',1.38),('8998','2013-07-31','08:25:00',1.4),('8998','2013-07-31','08:30:00',1.37),('8998','2013-07-31','08:35:00',1.48),('8998','2013-07-31','08:40:00',1.59),('8998','2013-07-31','08:45:00',1.57),('8998','2013-07-31','08:50:00',1.66),('8998','2013-07-31','08:55:00',1.85),('8998','2013-07-31','09:00:00',1.83),('8998','2013-07-31','09:05:00',1.73),('8998','2013-07-31','09:10:00',1.71),('8998','2013-07-31','09:15:00',1.82),('8998','2013-07-31','09:20:00',1.86),('8998','2013-07-31','09:25:00',2.02),('8998','2013-07-31','09:30:00',2.28),('8998','2013-07-31','09:35:00',2.46),('8998','2013-07-31','09:40:00',2.59),('8998','2013-07-31','09:45:00',2.63),('8998','2013-07-31','09:50:00',2.65),('8998','2013-07-31','09:55:00',2.68),('8998','2013-07-31','10:00:00',2.71),('8998','2013-07-31','10:05:00',2.75),('8998','2013-07-31','10:10:00',2.78),('8998','2013-07-31','10:15:00',2.79),('8998','2013-07-31','10:20:00',2.8),('8998','2013-07-31','10:25:00',2.83),('8998','2013-07-31','10:30:00',2.85),('8998','2013-07-31','10:35:00',2.85),('8998','2013-07-31','10:40:00',2.86),('8998','2013-07-31','10:45:00',2.88),('8998','2013-07-31','10:50:00',2.91),('8998','2013-07-31','10:55:00',2.91),('8998','2013-07-31','11:00:00',2.92),('8998','2013-07-31','11:05:00',2.94),('8998','2013-07-31','11:10:00',2.98),('8998','2013-07-31','11:15:00',3),('8998','2013-07-31','11:20:00',3),('8998','2013-07-31','11:25:00',3.01),('8998','2013-07-31','11:30:00',3),('8998','2013-07-31','11:35:00',3.02),('8998','2013-07-31','11:40:00',3.02),('8998','2013-07-31','11:45:00',3.03),('8998','2013-07-31','11:50:00',3.01),('8998','2013-07-31','11:55:00',3),('8998','2013-07-31','12:00:00',3.01),('8998','2013-07-31','12:05:00',3.01),('8998','2013-07-31','12:10:00',2.98),('8998','2013-07-31','12:15:00',3.01),('8998','2013-07-31','12:20:00',2.98),('8998','2013-07-31','12:25:00',2.96),('8998','2013-07-31','12:30:00',2.95),('8998','2013-07-31','12:35:00',2.95),('8998','2013-07-31','12:40:00',2.95),('8998','2013-07-31','12:45:00',2.91),('8998','2013-07-31','12:50:00',2.93),('8998','2013-07-31','12:55:00',2.9),('8998','2013-07-31','13:00:00',2.87),('8998','2013-07-31','13:05:00',2.84),('8998','2013-07-31','13:10:00',2.83),('8998','2013-07-31','13:15:00',2.8),('8998','2013-07-31','13:20:00',2.8),('8998','2013-07-31','13:25:00',2.8),('8998','2013-07-31','13:30:00',2.59),('8998','2013-07-31','13:35:00',2.71),('8998','2013-07-31','13:40:00',2.71),('8998','2013-07-31','13:45:00',2.66),('8998','2013-07-31','13:50:00',2.61),('8998','2013-07-31','13:55:00',2.53),('8998','2013-07-31','14:00:00',2.51),('8998','2013-07-31','14:05:00',2.58),('8998','2013-07-31','14:10:00',2.48),('8998','2013-07-31','14:15:00',2.45),('8998','2013-07-31','14:20:00',2.36),('8998','2013-07-31','14:25:00',2.4),('8998','2013-07-31','14:30:00',2.36),('8998','2013-07-31','14:35:00',1.88),('8998','2013-07-31','14:40:00',2.14),('8998','2013-07-31','14:45:00',1.9),('8998','2013-07-31','14:50:00',1.9),('8998','2013-07-31','14:55:00',2.2),('8998','2013-07-31','15:00:00',2.15),('8998','2013-07-31','15:05:00',2.12),('8998','2013-07-31','15:10:00',1.74),('8998','2013-07-31','15:15:00',1.84),('8998','2013-07-31','15:20:00',2.05),('8998','2013-07-31','15:25:00',1.98),('8998','2013-07-31','15:30:00',1.92),('8998','2013-07-31','15:35:00',1.7),('8998','2013-07-31','15:40:00',1.24),('8998','2013-07-31','15:45:00',1.76),('8998','2013-07-31','15:50:00',1.71),('8998','2013-07-31','15:55:00',1.67),('8998','2013-07-31','16:00:00',1.62),('8998','2013-07-31','16:05:00',1.56),('8998','2013-07-31','16:10:00',1.49),('8998','2013-07-31','16:15:00',1.43),('8998','2013-07-31','16:20:00',1.38),('8998','2013-07-31','16:25:00',1.32),('8998','2013-07-31','16:30:00',1.26),('8998','2013-07-31','16:35:00',1.21),('8998','2013-07-31','16:40:00',1.16),('8998','2013-07-31','16:45:00',1.1),('8998','2013-07-31','16:50:00',1.03),('8998','2013-07-30','07:40:00',1.18),('8998','2013-07-30','07:45:00',1.29),('8998','2013-07-30','07:50:00',1.34),('8998','2013-07-30','07:55:00',1.35),('8998','2013-07-30','08:00:00',1.25),('8998','2013-07-30','08:05:00',1.46),('8998','2013-07-30','08:10:00',1.5),('8998','2013-07-30','08:15:00',1.45),('8998','2013-07-30','08:20:00',1.74),('8998','2013-07-30','08:25:00',1.91),('8998','2013-07-30','08:30:00',1.86),('8998','2013-07-30','08:35:00',1.76),('8998','2013-07-30','08:40:00',1.94),('8998','2013-07-30','08:45:00',2.12),('8998','2013-07-30','08:50:00',2.08),('8998','2013-07-30','08:55:00',2.01),('8998','2013-07-30','09:00:00',1.96),('8998','2013-07-30','09:05:00',1.85),('8998','2013-07-30','09:10:00',2.33),('8998','2013-07-30','09:15:00',2.32),('8998','2013-07-30','09:20:00',2.26),('8998','2013-07-30','09:25:00',2.31),('8998','2013-07-30','09:30:00',2.39),('8998','2013-07-30','09:35:00',2.54),('8998','2013-07-30','09:40:00',2.61),('8998','2013-07-30','09:45:00',2.63),('8998','2013-07-30','09:50:00',2.67),('8998','2013-07-30','09:55:00',2.7),('8998','2013-07-30','10:00:00',2.71),('8998','2013-07-30','10:05:00',2.75),('8998','2013-07-30','10:10:00',2.76),('8998','2013-07-30','10:15:00',2.81),('8998','2013-07-30','10:20:00',2.81),('8998','2013-07-30','10:25:00',2.8),('8998','2013-07-30','10:30:00',2.82),('8998','2013-07-30','10:35:00',2.87),('8998','2013-07-30','10:40:00',2.9),('8998','2013-07-30','10:45:00',2.93),('8998','2013-07-30','10:50:00',2.95),('8998','2013-07-30','10:55:00',2.95),('8998','2013-07-30','11:00:00',2.99),('8998','2013-07-30','11:05:00',2.99),('8998','2013-07-30','11:10:00',3.01),('8998','2013-07-30','11:15:00',3.01),('8998','2013-07-30','11:20:00',3.02),('8998','2013-07-30','11:25:00',3.02),('8998','2013-07-30','11:30:00',3.01),('8998','2013-07-30','11:35:00',3.02),('8998','2013-07-30','11:40:00',3.03),('8998','2013-07-30','11:45:00',3.04),('8998','2013-07-30','11:50:00',3.05),('8998','2013-07-30','11:55:00',3.05),('8998','2013-07-30','12:00:00',3.05),('8998','2013-07-30','12:05:00',3.03),('8998','2013-07-30','12:10:00',3),('8998','2013-07-30','12:15:00',3),('8998','2013-07-30','12:20:00',3.01),('8998','2013-07-30','12:25:00',3.04),('8998','2013-07-30','12:30:00',2.99),('8998','2013-07-30','12:35:00',2.98),('8998','2013-07-30','12:40:00',2.99),('8998','2013-07-30','12:45:00',2.14),('8998','2013-07-30','12:50:00',2.14),('8998','2013-07-30','12:55:00',3.03),('8998','2013-07-30','13:00:00',1.21),('8998','2013-07-30','13:05:00',3.04),('8998','2013-07-30','13:10:00',2.82),('8998','2013-07-30','13:15:00',2.89),('8998','2013-07-30','13:20:00',2.66),('8998','2013-07-30','13:25:00',2.8),('8998','2013-07-30','13:30:00',2.8),('8998','2013-07-30','13:35:00',2.78),('8998','2013-07-30','13:40:00',2.81),('8998','2013-07-30','13:45:00',2.84),('8998','2013-07-30','13:50:00',2.37),('8998','2013-07-30','13:55:00',1.38),('8998','2013-07-30','14:00:00',2.36),('8998','2013-07-30','14:05:00',2.67),('8998','2013-07-30','14:10:00',2.1),('8998','2013-07-30','14:15:00',2.46),('8998','2013-07-30','14:20:00',2.6),('8998','2013-07-30','14:25:00',2.53),('8998','2013-07-30','14:30:00',2.44),('8998','2013-07-30','14:35:00',2.39),('8998','2013-07-30','14:40:00',2.4),('8998','2013-07-30','14:45:00',2.39),('8998','2013-07-30','14:50:00',1.97),('8998','2013-07-30','15:00:00',1.17),('8998','2013-07-30','15:05:00',2.18),('8998','2013-07-30','15:10:00',1.6),('8998','2013-07-30','15:15:00',1.17),('8998','2013-07-30','15:20:00',1.97),('8998','2013-07-30','15:25:00',1.8),('8998','2013-07-30','15:30:00',2.02),('8998','2013-07-30','15:35:00',1.71),('8998','2013-07-30','15:40:00',1.85),('8998','2013-07-30','15:45:00',1.77),('8998','2013-07-30','15:50:00',1.72),('8998','2013-07-30','15:55:00',1.65),('8998','2013-07-30','16:00:00',1.6),('8998','2013-07-30','16:05:00',1.58),('8998','2013-07-30','16:10:00',1.55),('8998','2013-07-30','16:15:00',1.5),('8998','2013-07-30','16:20:00',1.39),('8998','2013-07-30','16:25:00',1.36),('8998','2013-07-30','16:40:00',1.17),('8998','2013-07-30','16:45:00',1.1),('8998','2013-07-30','16:50:00',1.06),('8998','2014-04-07','08:15:00',1.18),('8998','2014-04-07','08:20:00',1.18),('8998','2014-04-07','08:25:00',1.21),('8998','2014-04-07','08:30:00',1.17),('8998','2014-04-07','08:35:00',1.09),('8998','2014-04-07','08:40:00',1.25),('8998','2014-04-07','08:45:00',1.39),('8998','2014-04-07','08:50:00',1.59),('8998','2014-04-07','08:55:00',1.79),('8998','2014-04-07','09:00:00',1.85),('8998','2014-04-07','09:05:00',1.91),('8998','2014-04-07','09:10:00',2),('8998','2014-04-07','09:15:00',2.11),('8998','2014-04-07','09:20:00',2.16),('8998','2014-04-07','09:25:00',2.22),('8998','2014-04-07','09:30:00',2.24),('8998','2014-04-07','09:35:00',2.28),('8998','2014-04-07','09:40:00',2.29),('8998','2014-04-07','09:45:00',2.32),('8998','2014-04-07','09:50:00',2.36),('8998','2014-04-07','09:55:00',2.37),('8998','2014-04-07','10:00:00',2.38),('8998','2014-04-07','10:05:00',2.38),('8998','2014-04-07','10:10:00',2.38),('8998','2014-04-07','10:15:00',2.52),('8998','2014-04-07','10:20:00',2.58),('8998','2014-04-07','10:25:00',2.57),('8998','2014-04-07','10:30:00',2.59),('8998','2014-04-07','10:35:00',2.57),('8998','2014-04-07','10:40:00',2.62),('8998','2014-04-07','10:45:00',2.66),('8998','2014-04-07','10:50:00',2.7),('8998','2014-04-07','10:55:00',2.71),('8998','2014-04-07','11:00:00',2.69),('8998','2014-04-07','11:05:00',2.7),('8998','2014-04-07','11:10:00',2.73),('8998','2014-04-07','11:15:00',2.7),('8998','2014-04-07','11:20:00',2.62),('8998','2014-04-07','11:25:00',2.81),('8998','2014-04-07','11:30:00',2.78),('8998','2014-04-07','11:35:00',2.59),('8998','2014-04-07','11:40:00',2.73),('8998','2014-04-07','11:45:00',2.75),('8998','2014-04-07','11:50:00',2.7),('8998','2014-04-07','11:55:00',2.66),('8998','2014-04-07','12:00:00',2.77),('8998','2014-04-07','12:05:00',2.72),('8998','2014-04-07','12:10:00',2.57),('8998','2014-04-07','12:15:00',2.52),('8998','2014-04-07','12:20:00',2.5),('8998','2014-04-07','12:25:00',2.42),('8998','2014-04-07','12:30:00',2.97),('8998','2014-04-07','12:35:00',2.8),('8998','2014-04-07','12:40:00',2.47),('8998','2014-04-07','12:45:00',2.2),('8998','2014-04-07','12:50:00',2.51),('8998','2014-04-07','12:55:00',2.68),('8998','2014-04-07','13:00:00',2.54),('8998','2014-04-07','13:05:00',2.71),('8998','2014-04-07','13:10:00',2.72),('8998','2014-04-07','13:15:00',2.7),('8998','2014-04-07','13:20:00',2.64),('8998','2014-04-07','13:25:00',2.6),('8998','2014-04-07','13:30:00',2.63),('8998','2014-04-07','13:35:00',2.59),('8998','2014-04-07','13:40:00',2.54),('8998','2014-04-07','13:45:00',2.5),('8998','2014-04-07','13:50:00',2.49),('8998','2014-04-07','13:55:00',2.48),('8998','2014-04-07','14:00:00',2.42),('8998','2014-04-07','14:05:00',2.39),('8998','2014-04-07','14:10:00',2.36),('8998','2014-04-07','14:15:00',2.33),('8998','2014-04-07','14:20:00',2.19),('8998','2014-04-07','14:25:00',2.21),('8998','2014-04-07','14:30:00',2.19),('8998','2014-04-07','14:35:00',2.04),('8998','2014-04-07','14:40:00',1.96),('8998','2014-04-07','14:45:00',1.75),('8998','2014-04-07','14:50:00',2.02),('8998','2014-04-07','14:55:00',2.03),('8998','2014-04-07','15:00:00',1.96),('8998','2014-04-07','15:05:00',1.88),('8998','2014-04-07','15:10:00',1.86),('8998','2014-04-07','15:15:00',1.8),('8998','2014-04-07','15:20:00',1.74),('8998','2014-04-07','15:25:00',1.69),('8998','2014-04-07','15:30:00',1.63),('8998','2014-04-07','15:35:00',1.57),('8998','2014-04-07','15:40:00',1.52),('8998','2014-04-07','15:45:00',1.4),('8998','2014-04-07','15:50:00',1.4),('8998','2014-04-07','15:55:00',1.35),('8998','2014-04-07','16:00:00',1.28),('8998','2014-04-07','16:05:00',1.23),('8998','2014-04-07','16:10:00',1.15),('8998','2014-04-07','16:15:00',1.05),('8998','2014-04-07','16:25:00',1),('8998','2014-04-07','16:30:00',1.01),('8998','2013-07-29','07:55:00',1.13),('8998','2013-07-29','08:00:00',1.21),('8998','2013-07-29','08:05:00',1.25),('8998','2013-07-29','08:10:00',1.3),('8998','2013-07-29','08:15:00',1.33),('8998','2013-07-29','08:20:00',1.45),('8998','2013-07-29','08:25:00',1.5),('8998','2013-07-29','08:30:00',1.42),('8998','2013-07-29','08:35:00',1.49),('8998','2013-07-29','08:40:00',1.49),('8998','2013-07-29','08:45:00',1.59),('8998','2013-07-29','08:50:00',1.61),('8998','2013-07-29','08:55:00',1.65),('8998','2013-07-29','09:00:00',1.66),('8998','2013-07-29','09:05:00',1.69),('8998','2013-07-29','09:10:00',1.66),('8998','2013-07-29','09:15:00',1.82),('8998','2013-07-29','09:20:00',2.04),('8998','2013-07-29','09:25:00',2.13),('8998','2013-07-29','09:30:00',2.44),('8998','2013-07-29','09:35:00',2.61),('8998','2013-07-29','09:40:00',2.73),('8998','2013-07-29','09:45:00',2.72),('8998','2013-07-29','09:50:00',2.7),('8998','2013-07-29','09:55:00',2.71),('8998','2013-07-29','10:00:00',2.65),('8998','2013-07-29','10:05:00',2.74),('8998','2013-07-29','10:10:00',2.78),('8998','2013-07-29','10:15:00',2.38),('8998','2013-07-29','10:20:00',2.52),('8998','2013-07-29','10:25:00',2.81),('8998','2013-07-29','10:30:00',2.83),('8998','2013-07-29','10:35:00',2.87),('8998','2013-07-29','10:40:00',2.84),('8998','2013-07-29','10:45:00',2.85),('8998','2013-07-29','10:50:00',2.83),('8998','2013-07-29','10:55:00',2.82),('8998','2013-07-29','11:00:00',2.84),('8998','2013-07-29','11:05:00',2.9),('8998','2013-07-29','11:10:00',2.95),('8998','2013-07-29','11:15:00',2.97),('8998','2013-07-29','11:20:00',2.83),('8998','2013-07-29','11:25:00',2.83),('8998','2013-07-29','11:30:00',2.7),('8998','2013-07-29','11:35:00',1.49),('8998','2013-07-29','11:40:00',2.49),('8998','2013-07-29','11:45:00',2.96),('8998','2013-07-29','11:50:00',2.98),('8998','2013-07-29','11:55:00',2.95),('8998','2013-07-29','12:00:00',2.95),('8998','2013-07-29','12:05:00',2.92),('8998','2013-07-29','12:10:00',2.93),('8998','2013-07-29','12:15:00',2.87),('8998','2013-07-29','12:20:00',2.84),('8998','2013-07-29','12:25:00',2.82),('8998','2013-07-29','12:30:00',2.8),('8998','2013-07-29','12:35:00',2.9),('8998','2013-07-29','12:40:00',2.67),('8998','2013-07-29','12:45:00',2.23),('8998','2013-07-29','12:50:00',2.94),('8998','2013-07-29','12:55:00',2.99),('8998','2013-07-29','13:00:00',1.58),('8998','2013-07-29','13:05:00',1.84),('8998','2013-07-29','13:10:00',2.86),('8998','2013-07-29','13:15:00',2.9),('8998','2013-07-29','13:20:00',2),('8998','2013-07-29','13:25:00',1.44),('8998','2013-07-29','13:30:00',2.43),('8998','2013-07-29','13:35:00',2.92),('8998','2013-07-29','13:40:00',2.78),('8998','2013-07-29','13:45:00',2.74),('8998','2013-07-29','13:50:00',2.81),('8998','2013-07-29','13:55:00',2.8),('8998','2013-07-29','14:00:00',2.57),('8998','2013-07-29','14:05:00',2.74),('8998','2013-07-29','14:10:00',2.71),('8998','2013-07-29','14:15:00',2.52),('8998','2013-07-29','14:20:00',2.45),('8998','2013-07-29','14:25:00',2.46),('8998','2013-07-29','14:30:00',2),('8998','2013-07-29','14:35:00',2.3),('8998','2013-07-29','14:40:00',2.27),('8998','2013-07-29','14:45:00',2.25),('8998','2013-07-29','14:50:00',2.24),('8998','2013-07-29','14:55:00',2.19),('8998','2013-07-29','15:00:00',2.12),('8998','2013-07-29','15:05:00',2.07),('8998','2013-07-29','15:10:00',1.95),('8998','2013-07-29','15:15:00',1.97),('8998','2013-07-29','15:20:00',1.96),('8998','2013-07-29','15:25:00',1.88),('8998','2013-07-29','15:30:00',1.83),('8998','2013-07-29','15:35:00',1.8),('8998','2013-07-29','15:40:00',1.75),('8998','2013-07-29','15:45:00',1.69),('8998','2013-07-29','15:50:00',1.65),('8998','2013-07-29','15:55:00',1.6),('8998','2013-07-29','16:00:00',1.56),('8998','2013-07-29','16:05:00',1.5),('8998','2013-07-29','16:10:00',1.44),('8998','2013-07-29','16:15:00',1.4),('8998','2013-07-29','16:20:00',1.36),('8998','2013-07-29','16:25:00',1.3),('8998','2013-07-29','16:30:00',1.24),('8998','2013-07-29','16:35:00',1.19),('8998','2013-07-29','16:40:00',1.15),('8998','2013-07-29','16:45:00',1.09),('8998','2013-07-29','16:50:00',1.03),('8998','2013-07-28','07:50:00',1.08),('8998','2013-07-28','07:55:00',1.17),('8998','2013-07-28','08:00:00',1.17),('8998','2013-07-28','08:05:00',1.2),('8998','2013-07-28','08:10:00',1.23),('8998','2013-07-28','08:15:00',1.27),('8998','2013-07-28','08:20:00',1.34),('8998','2013-07-28','08:25:00',1.39),('8998','2013-07-28','08:30:00',1.39),('8998','2013-07-28','08:35:00',1.42),('8998','2013-07-28','08:40:00',1.46),('8998','2013-07-28','08:45:00',1.5),('8998','2013-07-28','08:50:00',1.56),('8998','2013-07-28','08:55:00',1.6),('8998','2013-07-28','09:00:00',1.6),('8998','2013-07-28','09:05:00',1.65),('8998','2013-07-28','09:10:00',1.7),('8998','2013-07-28','09:15:00',1.74),('8998','2013-07-28','09:20:00',1.85),('8998','2013-07-28','09:25:00',1.92),('8998','2013-07-28','09:30:00',2.13),('8998','2013-07-28','09:35:00',2.28),('8998','2013-07-28','09:40:00',2.37),('8998','2013-07-28','09:45:00',2.41),('8998','2013-07-28','09:50:00',2.43),('8998','2013-07-28','09:55:00',2.45),('8998','2013-07-28','10:00:00',2.5),('8998','2013-07-28','10:05:00',2.53),('8998','2013-07-28','10:10:00',2.56),('8998','2013-07-28','10:15:00',2.57),('8998','2013-07-28','10:20:00',2.61),('8998','2013-07-28','10:25:00',2.64),('8998','2013-07-28','10:30:00',2.63),('8998','2013-07-28','10:35:00',2.67),('8998','2013-07-28','10:40:00',2.69),('8998','2013-07-28','10:45:00',2.68),('8998','2013-07-28','10:50:00',2.68),('8998','2013-07-28','10:55:00',2.68),('8998','2013-07-28','11:00:00',2.71),('8998','2013-07-28','11:05:00',2.7),('8998','2013-07-28','11:10:00',2.66),('8998','2013-07-28','11:15:00',2.66),('8998','2013-07-28','11:20:00',2.68),('8998','2013-07-28','11:25:00',2.7),('8998','2013-07-28','11:30:00',2.71),('8998','2013-07-28','11:35:00',2.7),('8998','2013-07-28','11:40:00',2.7),('8998','2013-07-28','11:45:00',2.71),('8998','2013-07-28','11:50:00',2.72),('8998','2013-07-28','11:55:00',2.72),('8998','2013-07-28','12:00:00',2.72),('8998','2013-07-28','12:05:00',2.69),('8998','2013-07-28','12:10:00',2.67),('8998','2013-07-28','12:15:00',2.69),('8998','2013-07-28','12:20:00',2.69),('8998','2013-07-28','12:25:00',2.7),('8998','2013-07-28','12:30:00',2.69),('8998','2013-07-28','12:35:00',2.69),('8998','2013-07-28','12:40:00',2.68),('8998','2013-07-28','12:45:00',2.67),('8998','2013-07-28','12:50:00',2.65),('8998','2013-07-28','12:55:00',2.62),('8998','2013-07-28','13:00:00',2.56),('8998','2013-07-28','13:05:00',2.63),('8998','2013-07-28','13:10:00',2.62),('8998','2013-07-28','13:15:00',2.58),('8998','2013-07-28','13:20:00',2.63),('8998','2013-07-28','13:25:00',2.6),('8998','2013-07-28','13:30:00',2.57),('8998','2013-07-28','13:35:00',2.56),('8998','2013-07-28','13:40:00',2.57),('8998','2013-07-28','13:45:00',2.56),('8998','2013-07-28','13:50:00',2.52),('8998','2013-07-28','13:55:00',2.5),('8998','2013-07-28','14:00:00',2.48),('8998','2013-07-28','14:05:00',2.45),('8998','2013-07-28','14:10:00',2.42),('8998','2013-07-28','14:15:00',2.39),('8998','2013-07-28','14:20:00',2.37),('8998','2013-07-28','14:25:00',2.33),('8998','2013-07-28','14:30:00',2.29),('8998','2013-07-28','14:35:00',2.25),('8998','2013-07-28','14:40:00',2.22),('8998','2013-07-28','14:45:00',2.19),('8998','2013-07-28','14:50:00',2.16),('8998','2013-07-28','14:55:00',2.12),('8998','2013-07-28','15:00:00',2.09),('8998','2013-07-28','15:05:00',2.05),('8998','2013-07-28','15:10:00',2),('8998','2013-07-28','15:15:00',1.97),('8998','2013-07-28','15:20:00',1.92),('8998','2013-07-28','15:25:00',1.87),('8998','2013-07-28','15:30:00',1.83),('8998','2013-07-28','15:35:00',1.79),('8998','2013-07-28','15:40:00',1.77),('8998','2013-07-28','15:45:00',1.74),('8998','2013-07-28','15:50:00',1.52),('8998','2013-07-28','16:05:00',1.36),('8998','2013-07-28','16:10:00',1.5),('8998','2013-07-28','16:15:00',1.43),('8998','2013-07-28','16:20:00',1.24),('8998','2013-07-28','16:25:00',1.09),('8998','2013-07-28','16:30:00',1.38),('8998','2013-07-28','16:35:00',1.28),('8998','2013-07-28','16:45:00',1.26),('8998','2013-07-28','16:50:00',1.17),('8998','2013-07-27','07:50:00',1.08),('8998','2013-07-27','07:55:00',1.13),('8998','2013-07-27','08:00:00',1.12),('8998','2013-07-27','08:05:00',1.16),('8998','2013-07-27','08:10:00',1.2),('8998','2013-07-27','08:15:00',1.25),('8998','2013-07-27','08:20:00',1.33),('8998','2013-07-27','08:25:00',1.38),('8998','2013-07-27','08:30:00',1.37),('8998','2013-07-27','08:35:00',1.39),('8998','2013-07-27','08:40:00',1.44),('8998','2013-07-27','08:45:00',1.48),('8998','2013-07-27','08:50:00',1.52),('8998','2013-07-27','08:55:00',1.6),('8998','2013-07-27','09:00:00',1.57),('8998','2013-07-27','09:05:00',1.61),('8998','2013-07-27','09:10:00',1.7),('8998','2013-07-27','09:15:00',1.73),('8998','2013-07-27','09:20:00',1.83),('8998','2013-07-27','09:25:00',1.95),('8998','2013-07-27','09:30:00',2.2),('8998','2013-07-27','09:35:00',2.33),('8998','2013-07-27','09:40:00',2.4),('8998','2013-07-27','09:45:00',2.41),('8998','2013-07-27','09:50:00',2.44),('8998','2013-07-27','09:55:00',2.46),('8998','2013-07-27','10:00:00',2.49),('8998','2013-07-27','10:05:00',2.5),('8998','2013-07-27','10:10:00',2.53),('8998','2013-07-27','10:15:00',2.55),('8998','2013-07-27','10:20:00',2.57),('8998','2013-07-27','10:25:00',2.59),('8998','2013-07-27','10:30:00',2.62),('8998','2013-07-27','10:35:00',2.59),('8998','2013-07-27','10:40:00',2.65),('8998','2013-07-27','10:45:00',2.67),('8998','2013-07-27','10:50:00',2.67),('8998','2013-07-27','10:55:00',2.67),('8998','2013-07-27','11:00:00',2.66),('8998','2013-07-27','11:05:00',2.68),('8998','2013-07-27','11:10:00',2.72),('8998','2013-07-27','11:15:00',2.73),('8998','2013-07-27','11:20:00',2.75),('8998','2013-07-27','11:25:00',2.76),('8998','2013-07-27','11:30:00',2.74),('8998','2013-07-27','11:35:00',2.75),('8998','2013-07-27','11:40:00',2.72),('8998','2013-07-27','11:45:00',2.71),('8998','2013-07-27','11:50:00',2.7),('8998','2013-07-27','11:55:00',2.71),('8998','2013-07-27','12:00:00',2.74),('8998','2013-07-27','12:05:00',2.74),('8998','2013-07-27','12:10:00',2.69),('8998','2013-07-27','12:15:00',2.71),('8998','2013-07-27','12:20:00',2.66),('8998','2013-07-27','12:25:00',2.67),('8998','2013-07-27','12:30:00',2.69),('8998','2013-07-27','12:35:00',2.75),('8998','2013-07-27','12:40:00',2.73),('8998','2013-07-27','12:45:00',2.69),('8998','2013-07-27','12:50:00',2.68),('8998','2013-07-27','12:55:00',2.65),('8998','2013-07-27','13:00:00',2.65),('8998','2013-07-27','13:05:00',2.59),('8998','2013-07-27','13:10:00',2.53),('8998','2013-07-27','13:15:00',2.69),('8998','2013-07-27','13:20:00',2.65),('8998','2013-07-27','13:25:00',2.66),('8998','2013-07-27','13:30:00',2.56),('8998','2013-07-27','13:35:00',2.57),('8998','2013-07-27','13:40:00',2.55),('8998','2013-07-27','13:45:00',2.52),('8998','2013-07-27','13:50:00',2.57),('8998','2013-07-27','13:55:00',2.52),('8998','2013-07-27','14:00:00',2.48),('8998','2013-07-27','14:05:00',2.47),('8998','2013-07-27','14:10:00',2.43),('8998','2013-07-27','14:15:00',2.39),('8998','2013-07-27','14:20:00',2.36),('8998','2013-07-27','14:25:00',2.31),('8998','2013-07-27','14:30:00',2.29),('8998','2013-07-27','14:35:00',2.24),('8998','2013-07-27','14:40:00',2.25),('8998','2013-07-27','14:45:00',2.18),('8998','2013-07-27','14:50:00',2.15),('8998','2013-07-27','14:55:00',2.11),('8998','2013-07-27','15:00:00',2.07),('8998','2013-07-27','15:05:00',2.03),('8998','2013-07-27','15:10:00',1.98),('8998','2013-07-27','15:15:00',1.97),('8998','2013-07-27','15:20:00',1.93),('8998','2013-07-27','15:25:00',1.85),('8998','2013-07-27','15:30:00',1.83),('8998','2013-07-27','15:35:00',1.79),('8998','2013-07-27','15:40:00',1.73),('8998','2013-07-27','15:45:00',1.7),('8998','2013-07-27','15:50:00',1.64),('8998','2013-07-27','15:55:00',1.6),('8998','2013-07-27','16:00:00',1.56),('8998','2013-07-27','16:05:00',1.51),('8998','2013-07-27','16:10:00',1.47),('8998','2013-07-27','16:15:00',1.42),('8998','2013-07-27','16:20:00',1.37),('8998','2013-07-27','16:25:00',1.33),('8998','2013-07-27','16:30:00',1.27),('8998','2013-07-27','16:35:00',1.21),('8998','2013-07-27','16:40:00',1.17),('8998','2013-07-27','16:45:00',1.11),('8998','2013-07-27','16:50:00',1.05),('8998','2013-07-27','16:55:00',1),('8998','2013-07-26','07:50:00',1.06),('8998','2013-07-26','07:55:00',1.14),('8998','2013-07-26','08:00:00',1.16),('8998','2013-07-26','08:05:00',1.18),('8998','2013-07-26','08:10:00',1.22),('8998','2013-07-26','08:15:00',1.28),('8998','2013-07-26','08:20:00',1.37),('8998','2013-07-26','08:25:00',1.32),('8998','2013-07-26','08:30:00',1.41),('8998','2013-07-26','08:35:00',1.42),('8998','2013-07-26','08:40:00',1.47),('8998','2013-07-26','08:45:00',1.49),('8998','2013-07-26','08:50:00',1.56),('8998','2013-07-26','08:55:00',1.63),('8998','2013-07-26','09:00:00',1.6),('8998','2013-07-26','09:05:00',1.62),('8998','2013-07-26','09:10:00',1.74),('8998','2013-07-26','09:15:00',1.77),('8998','2013-07-26','09:20:00',1.9),('8998','2013-07-26','09:25:00',2.07),('8998','2013-07-26','09:30:00',2.24),('8998','2013-07-26','09:35:00',2.38),('8998','2013-07-26','09:40:00',2.42),('8998','2013-07-26','09:45:00',2.47),('8998','2013-07-26','09:50:00',2.49),('8998','2013-07-26','09:55:00',2.51),('8998','2013-07-26','10:00:00',2.55),('8998','2013-07-26','10:05:00',2.58),('8998','2013-07-26','10:10:00',2.61),('8998','2013-07-26','10:15:00',2.64),('8998','2013-07-26','10:20:00',2.67),('8998','2013-07-26','10:25:00',2.69),('8998','2013-07-26','10:30:00',2.7),('8998','2013-07-26','10:35:00',2.69),('8998','2013-07-26','10:40:00',2.7),('8998','2013-07-26','10:45:00',2.72),('8998','2013-07-26','10:50:00',2.72),('8998','2013-07-26','10:55:00',2.73),('8998','2013-07-26','11:00:00',2.74),('8998','2013-07-26','11:05:00',2.77),('8998','2013-07-26','11:10:00',2.8),('8998','2013-07-26','11:15:00',2.79),('8998','2013-07-26','11:20:00',2.78),('8998','2013-07-26','11:25:00',2.82),('8998','2013-07-26','11:30:00',2.82),('8998','2013-07-26','11:35:00',2.84),('8998','2013-07-26','11:40:00',2.81),('8998','2013-07-26','11:45:00',2.82),('8998','2013-07-26','11:50:00',2.8),('8998','2013-07-26','11:55:00',2.8),('8998','2013-07-26','12:00:00',2.79),('8998','2013-07-26','12:05:00',2.79),('8998','2013-07-26','12:10:00',2.79),('8998','2013-07-26','12:15:00',2.77),('8998','2013-07-26','12:20:00',2.82),('8998','2013-07-26','12:25:00',2.8),('8998','2013-07-26','12:30:00',2.73),('8998','2013-07-26','12:35:00',2.79),('8998','2013-07-26','12:40:00',2.77),('8998','2013-07-26','12:45:00',2.69),('8998','2013-07-26','12:50:00',2.67),('8998','2013-07-26','12:55:00',2.7),('8998','2013-07-26','13:00:00',2.71),('8998','2013-07-26','13:05:00',2.78),('8998','2013-07-26','13:10:00',2.74),('8998','2013-07-26','13:15:00',2.72),('8998','2013-07-26','13:20:00',2.72),('8998','2013-07-26','13:25:00',2.75),('8998','2013-07-26','13:30:00',2.76),('8998','2013-07-26','13:35:00',2.52),('8998','2013-07-26','13:40:00',2.39),('8998','2013-07-26','13:45:00',2.69),('8998','2013-07-26','13:50:00',2.67),('8998','2013-07-26','13:55:00',2.65),('8998','2013-07-26','14:00:00',2.45),('8998','2013-07-26','14:05:00',2.49),('8998','2013-07-26','14:10:00',2.07),('8998','2013-07-26','14:15:00',2.26),('8998','2013-07-26','14:20:00',2.45),('8998','2013-07-26','14:25:00',2.37),('8998','2013-07-26','14:30:00',2.31),('8998','2013-07-26','14:35:00',2.29),('8998','2013-07-26','14:40:00',2.26),('8998','2013-07-26','14:45:00',2.22),('8998','2013-07-26','14:50:00',2.17),('8998','2013-07-26','14:55:00',2.12),('8998','2013-07-26','15:00:00',2.07),('8998','2013-07-26','15:05:00',2),('8998','2013-07-26','15:10:00',2.01),('8998','2013-07-26','15:15:00',1.96),('8998','2013-07-26','15:20:00',1.92),('8998','2013-07-26','15:25:00',1.88),('8998','2013-07-26','15:30:00',1.84),('8998','2013-07-26','15:35:00',1.8),('8998','2013-07-26','15:40:00',1.75),('8998','2013-07-26','15:45:00',1.71),('8998','2013-07-26','15:50:00',1.67),('8998','2013-07-26','15:55:00',1.61),('8998','2013-07-26','16:00:00',1.57),('8998','2013-07-26','16:05:00',1.52),('8998','2013-07-26','16:10:00',1.47),('8998','2013-07-26','16:15:00',1.42),('8998','2013-07-26','16:20:00',1.37),('8998','2013-07-26','16:25:00',1.32),('8998','2013-07-26','16:30:00',1.27),('8998','2013-07-26','16:35:00',1.22),('8998','2013-07-26','16:40:00',1.16),('8998','2013-07-26','16:45:00',1.11),('8998','2013-07-26','16:50:00',1.05),('8998','2013-07-26','16:55:00',1),('8998','2013-07-25','07:50:00',1.03),('8998','2013-07-25','07:55:00',1.09),('8998','2013-07-25','08:00:00',1.1),('8998','2013-07-25','08:05:00',1.16),('8998','2013-07-25','08:10:00',1.23),('8998','2013-07-25','08:15:00',1.29),('8998','2013-07-25','08:20:00',1.34),('8998','2013-07-25','08:25:00',1.31),('8998','2013-07-25','08:30:00',1.39),('8998','2013-07-25','08:35:00',1.42),('8998','2013-07-25','08:40:00',1.46),('8998','2013-07-25','08:45:00',1.5),('8998','2013-07-25','08:50:00',1.59),('8998','2013-07-25','08:55:00',1.63),('8998','2013-07-25','09:00:00',1.64),('8998','2013-07-25','09:05:00',1.63),('8998','2013-07-25','09:10:00',1.76),('8998','2013-07-25','09:15:00',1.79),('8998','2013-07-25','09:20:00',1.91),('8998','2013-07-25','09:25:00',2.05),('8998','2013-07-25','09:30:00',2.16),('8998','2013-07-25','09:35:00',2.26),('8998','2013-07-25','09:40:00',2.32),('8998','2013-07-25','09:45:00',2.34),('8998','2013-07-25','09:50:00',1.51),('8998','2013-07-25','09:55:00',2.43),('8998','2013-07-25','10:00:00',2.47),('8998','2013-07-25','10:05:00',2.54),('8998','2013-07-25','10:10:00',2.51),('8998','2013-07-25','10:15:00',2.57),('8998','2013-07-25','10:20:00',2.59),('8998','2013-07-25','10:25:00',2.61),('8998','2013-07-25','10:30:00',2.65),('8998','2013-07-25','10:35:00',2.65),('8998','2013-07-25','10:40:00',2.67),('8998','2013-07-25','10:45:00',2.69),('8998','2013-07-25','10:50:00',2.7),('8998','2013-07-25','10:55:00',2.7),('8998','2013-07-25','11:00:00',2.73),('8998','2013-07-25','11:05:00',2.74),('8998','2013-07-25','11:10:00',2.73),('8998','2013-07-25','11:15:00',2.72),('8998','2013-07-25','11:20:00',2.07),('8998','2013-07-25','11:25:00',2.66),('8998','2013-07-25','11:30:00',2.57),('8998','2013-07-25','11:35:00',2.58),('8998','2013-07-25','11:40:00',2.66),('8998','2013-07-25','11:45:00',2.7),('8998','2013-07-25','11:50:00',2.81),('8998','2013-07-25','11:55:00',2.8),('8998','2013-07-25','12:00:00',2.76),('8998','2013-07-25','12:05:00',2.74),('8998','2013-07-25','12:15:00',1.92),('8998','2013-07-25','12:20:00',1.49),('8998','2013-07-25','12:25:00',2.82),('8998','2013-07-25','12:30:00',2.79),('8998','2013-07-25','12:35:00',2.82),('8998','2013-07-25','12:40:00',2.89),('8998','2013-07-25','12:45:00',2.97),('8998','2013-07-25','12:50:00',2.94),('8998','2013-07-25','12:55:00',2.83),('8998','2013-07-25','13:00:00',1.92),('8998','2013-07-25','13:15:00',1.41),('8998','2013-07-25','13:20:00',2.32),('8998','2013-07-25','13:25:00',2.61),('8998','2013-07-25','13:30:00',2.96),('8998','2013-07-25','13:35:00',2.78),('8998','2013-07-25','13:40:00',2.69),('8998','2013-07-25','13:45:00',2.7),('8998','2013-07-25','13:50:00',2.62),('8998','2013-07-25','13:55:00',2.22),('8998','2013-07-25','14:00:00',2.68),('8998','2013-07-25','14:05:00',2.69),('8998','2013-07-25','14:10:00',2.54),('8998','2013-07-25','14:15:00',2.52),('8998','2013-07-25','14:20:00',2.52),('8998','2013-07-25','14:25:00',2.47),('8998','2013-07-25','14:30:00',2.36),('8998','2013-07-25','14:35:00',2.31),('8998','2013-07-25','14:40:00',2.32),('8998','2013-07-25','14:45:00',2.22),('8998','2013-07-25','14:50:00',2.21),('8998','2013-07-25','14:55:00',2.14),('8998','2013-07-25','15:00:00',2.15),('8998','2013-07-25','15:05:00',2.07),('8998','2013-07-25','15:10:00',2.05),('8998','2013-07-25','15:15:00',2),('8998','2013-07-25','15:20:00',1.96),('8998','2013-07-25','15:25:00',1.9),('8998','2013-07-25','15:30:00',1.86),('8998','2013-07-25','15:35:00',1.83),('8998','2013-07-25','15:40:00',1.78),('8998','2013-07-25','15:45:00',1.75),('8998','2013-07-25','15:50:00',1.71),('8998','2013-07-25','15:55:00',1.65),('8998','2013-07-25','16:00:00',1.59),('8998','2013-07-25','16:05:00',1.54),('8998','2013-07-25','16:10:00',1.48),('8998','2013-07-25','16:15:00',1.44),('8998','2013-07-25','16:20:00',1.39),('8998','2013-07-25','16:25:00',1.35),('8998','2013-07-25','16:30:00',1.3),('8998','2013-07-25','16:35:00',1.24),('8998','2013-07-25','16:40:00',1.19),('8998','2013-07-25','16:45:00',1.15),('8998','2013-07-25','16:50:00',1.09),('8998','2013-07-25','16:55:00',1.03),('8998','2013-07-24','07:50:00',1.03),('8998','2013-07-24','07:55:00',1.09),('8998','2013-07-24','08:00:00',1.16),('8998','2013-07-24','08:05:00',1.21),('8998','2013-07-24','08:10:00',1.26),('8998','2013-07-24','08:15:00',1.32),('8998','2013-07-24','08:20:00',1.4),('8998','2013-07-24','08:25:00',1.4),('8998','2013-07-24','08:30:00',1.45),('8998','2013-07-24','08:35:00',1.44),('8998','2013-07-24','08:40:00',1.5),('8998','2013-07-24','08:45:00',1.54),('8998','2013-07-24','08:50:00',1.59),('8998','2013-07-24','08:55:00',1.58),('8998','2013-07-24','09:00:00',1.66),('8998','2013-07-24','09:05:00',1.63),('8998','2013-07-24','09:10:00',1.65),('8998','2013-07-24','09:15:00',2.06),('8998','2013-07-24','09:20:00',2.19),('8998','2013-07-24','09:25:00',1.78),('8998','2013-07-24','09:30:00',1.44),('8998','2013-07-24','09:40:00',1.32),('8998','2013-07-24','09:45:00',1),('8998','2013-07-24','09:50:00',1.62),('8998','2013-07-24','10:10:00',1.59),('8998','2013-07-24','10:15:00',2.77),('8998','2013-07-24','10:20:00',2.8),('8998','2013-07-24','10:25:00',2.85),('8998','2013-07-24','10:30:00',2.84),('8998','2013-07-24','10:35:00',2.62),('8998','2013-07-24','10:40:00',2.28),('8998','2013-07-24','10:45:00',2.5),('8998','2013-07-24','10:50:00',2.71),('8998','2013-07-24','10:55:00',2.9),('8998','2013-07-24','11:00:00',2.85),('8998','2013-07-24','11:05:00',1.99),('8998','2013-07-24','11:10:00',2.2),('8998','2013-07-24','11:15:00',2.8),('8998','2013-07-24','11:20:00',2.58),('8998','2013-07-24','11:25:00',2.5),('8998','2013-07-24','11:30:00',2.58),('8998','2013-07-24','11:35:00',2.88),('8998','2013-07-24','11:40:00',2.88),('8998','2013-07-24','11:45:00',3.06),('8998','2013-07-24','11:50:00',3.11),('8998','2013-07-24','11:55:00',2.32),('8998','2013-07-24','12:00:00',2.3),('8998','2013-07-24','12:05:00',2.98),('8998','2013-07-24','12:10:00',2.99),('8998','2013-07-24','12:15:00',2.4),('8998','2013-07-24','12:20:00',1.9),('8998','2013-07-24','12:25:00',2.41),('8998','2013-07-24','12:35:00',1.69),('8998','2013-07-24','12:55:00',1.22),('8998','2013-07-24','13:00:00',2.84),('8998','2013-07-24','13:05:00',1.7),('8998','2013-07-24','13:10:00',1.35),('8998','2013-07-24','13:15:00',1.67),('8998','2013-07-24','13:20:00',2.46),('8998','2013-07-24','13:25:00',2.96),('8998','2013-07-24','13:30:00',2.87),('8998','2013-07-24','13:35:00',2.63),('8998','2013-07-24','13:40:00',2.63),('8998','2013-07-24','13:45:00',2.64),('8998','2013-07-24','13:50:00',2.6),('8998','2013-07-24','13:55:00',2.57),('8998','2013-07-24','14:00:00',2.59),('8998','2013-07-24','14:05:00',2.58),('8998','2013-07-24','14:10:00',2.57),('8998','2013-07-24','14:15:00',2.53),('8998','2013-07-24','14:20:00',2.53),('8998','2013-07-24','14:25:00',2.49),('8998','2013-07-24','14:30:00',2.44),('8998','2013-07-24','14:35:00',2.4),('8998','2013-07-24','14:40:00',2.35),('8998','2013-07-24','14:45:00',2.3),('8998','2013-07-24','14:50:00',2.25),('8998','2013-07-24','14:55:00',2.22),('8998','2013-07-24','15:00:00',2.19),('8998','2013-07-24','15:05:00',2.16),('8998','2013-07-24','15:10:00',2.11),('8998','2013-07-24','15:15:00',2.06),('8998','2013-07-24','15:20:00',2.03),('8998','2013-07-24','15:25:00',1.99),('8998','2013-07-24','15:30:00',1.95),('8998','2013-07-24','15:35:00',1.9),('8998','2013-07-24','15:40:00',1.86),('8998','2013-07-24','15:45:00',1.82),('8998','2013-07-24','15:50:00',1.76),('8998','2013-07-24','15:55:00',1.71),('8998','2013-07-24','16:00:00',1.65),('8998','2013-07-24','16:05:00',1.59),('8998','2013-07-24','16:10:00',1.54),('8998','2013-07-24','16:15:00',1.48),('8998','2013-07-24','16:20:00',1.43),('8998','2013-07-24','16:25:00',1.38),('8998','2013-07-24','16:30:00',1.32),('8998','2013-07-24','16:35:00',1.29),('8998','2013-07-24','16:40:00',1.23),('8998','2013-07-24','16:45:00',1.17),('8998','2013-07-24','16:50:00',1.12),('8998','2013-07-24','16:55:00',1.07),('8998','2013-07-23','08:00:00',1.12),('8998','2013-07-23','08:20:00',1.16),('8998','2013-07-23','08:40:00',1.01),('8998','2013-07-23','08:45:00',1.15),('8998','2013-07-23','08:50:00',1.71),('8998','2013-07-23','08:55:00',1.34),('8998','2013-07-23','09:00:00',1.07),('8998','2013-07-23','09:05:00',1.66),('8998','2013-07-23','09:10:00',1.93),('8998','2013-07-23','09:15:00',1.72),('8998','2013-07-23','09:20:00',1.53),('8998','2013-07-23','09:30:00',1.24),('8998','2013-07-23','09:35:00',1.66),('8998','2013-07-23','09:40:00',1.58),('8998','2013-07-23','09:45:00',1.65),('8998','2013-07-23','09:50:00',1.57),('8998','2013-07-23','09:55:00',1.05),('8998','2013-07-23','10:20:00',1.1),('8998','2013-07-23','10:25:00',2.29),('8998','2013-07-23','10:30:00',2.78),('8998','2013-07-23','10:35:00',2.81),('8998','2013-07-23','10:40:00',2.91),('8998','2013-07-23','10:45:00',2.91),('8998','2013-07-23','10:50:00',1.99),('8998','2013-07-23','10:55:00',1.98),('8998','2013-07-23','11:00:00',1.31),('8998','2013-07-23','11:05:00',1.52),('8998','2013-07-23','11:10:00',3.05),('8998','2013-07-23','11:15:00',3.05),('8998','2013-07-23','11:20:00',3.04),('8998','2013-07-23','11:25:00',3.02),('8998','2013-07-23','11:30:00',2.99),('8998','2013-07-23','11:35:00',3.07),('8998','2013-07-23','11:40:00',2.94),('8998','2013-07-23','11:45:00',2.89),('8998','2013-07-23','11:50:00',2.9),('8998','2013-07-23','11:55:00',2.91),('8998','2013-07-23','12:00:00',3.03),('8998','2013-07-23','12:05:00',3.16),('8998','2013-07-23','12:10:00',2.2),('8998','2013-07-23','12:15:00',1.11),('8998','2013-07-23','12:20:00',1.98),('8998','2013-07-23','12:25:00',3.19),('8998','2013-07-23','12:30:00',1.76),('8998','2013-07-23','12:40:00',1.69),('8998','2013-07-23','12:45:00',3.18),('8998','2013-07-23','12:50:00',1.3),('8998','2013-07-23','13:00:00',3.03),('8998','2013-07-23','13:05:00',2.75),('8998','2013-07-23','13:15:00',2.13),('8998','2013-07-23','13:25:00',2.73),('8998','2013-07-23','13:30:00',1.02),('8998','2013-07-23','13:35:00',2.97),('8998','2013-07-23','13:40:00',2.2),('8998','2013-07-23','13:45:00',2.58),('8998','2013-07-23','13:50:00',2.04),('8998','2013-07-23','13:55:00',2.83),('8998','2013-07-23','14:00:00',2.81),('8998','2013-07-23','14:05:00',2.75),('8998','2013-07-23','14:10:00',2.71),('8998','2013-07-23','14:15:00',2.68),('8998','2013-07-23','14:20:00',2.62),('8998','2013-07-23','14:25:00',2.52),('8998','2013-07-23','14:30:00',2.56),('8998','2013-07-23','14:35:00',1.94),('8998','2013-07-23','14:40:00',2.53),('8998','2013-07-23','14:45:00',2.43),('8998','2013-07-23','14:50:00',2.5),('8998','2013-07-23','14:55:00',2.45),('8998','2013-07-23','15:00:00',2.31),('8998','2013-07-23','15:05:00',2.31),('8998','2013-07-23','15:10:00',2.22),('8998','2013-07-23','15:15:00',2.2),('8998','2013-07-23','15:20:00',2.14),('8998','2013-07-23','15:25:00',2.1),('8998','2013-07-23','15:30:00',1.97),('8998','2013-07-23','15:35:00',1.9),('8998','2013-07-23','15:40:00',1.92),('8998','2013-07-23','15:45:00',1.86),('8998','2013-07-23','15:50:00',1.81),('8998','2013-07-23','15:55:00',1.84),('8998','2013-07-23','16:00:00',1.78),('8998','2013-07-23','16:05:00',1.71),('8998','2013-07-23','16:10:00',1.63),('8998','2013-07-23','16:15:00',1.49),('8998','2013-07-23','16:20:00',1.64),('8998','2013-07-23','16:25:00',1.52),('8998','2013-07-23','16:30:00',1.51),('8998','2013-07-23','16:35:00',1.37),('8998','2013-07-23','16:40:00',1.37),('8998','2013-07-23','16:45:00',1.25),('8998','2013-07-23','16:50:00',1.22),('8998','2013-07-23','16:55:00',1.25),('8998','2013-07-23','17:00:00',1.19),('8998','2013-07-22','07:45:00',1.14),('8998','2013-07-22','07:50:00',1.2),('8998','2013-07-22','07:55:00',1.28),('8998','2013-07-22','08:00:00',1.34),('8998','2013-07-22','08:05:00',1.35),('8998','2013-07-22','08:10:00',1.35),('8998','2013-07-22','08:15:00',1.38),('8998','2013-07-22','08:20:00',1.45),('8998','2013-07-22','08:25:00',1.42),('8998','2013-07-22','08:30:00',1.51),('8998','2013-07-22','08:35:00',1.46),('8998','2013-07-22','08:40:00',1.51),('8998','2013-07-22','08:45:00',1.61),('8998','2013-07-22','08:50:00',1.69),('8998','2013-07-22','08:55:00',1.67),('8998','2013-07-22','09:00:00',1.74),('8998','2013-07-22','09:05:00',1.72),('8998','2013-07-22','09:10:00',1.79),('8998','2013-07-22','09:15:00',1.91),('8998','2013-07-22','09:20:00',1.99),('8998','2013-07-22','09:25:00',2.23),('8998','2013-07-22','09:30:00',2.38),('8998','2013-07-22','09:35:00',2.46),('8998','2013-07-22','09:40:00',2.49),('8998','2013-07-22','09:45:00',2.5),('8998','2013-07-22','09:50:00',2.53),('8998','2013-07-22','09:55:00',2.54),('8998','2013-07-22','10:00:00',2.54),('8998','2013-07-22','10:05:00',2.6),('8998','2013-07-22','10:10:00',2.61),('8998','2013-07-22','10:15:00',2.63),('8998','2013-07-22','10:20:00',2.66),('8998','2013-07-22','10:25:00',2.69),('8998','2013-07-22','10:30:00',2.73),('8998','2013-07-22','10:35:00',2.79),('8998','2013-07-22','10:40:00',2.83),('8998','2013-07-22','10:45:00',2.82),('8998','2013-07-22','10:50:00',2.82),('8998','2013-07-22','10:55:00',2.82),('8998','2013-07-22','11:00:00',2.84),('8998','2013-07-22','11:05:00',2.85),('8998','2013-07-22','11:10:00',2.84),('8998','2013-07-22','11:15:00',2.86),('8998','2013-07-22','11:20:00',2.85),('8998','2013-07-22','11:25:00',2.86),('8998','2013-07-22','11:30:00',2.89),('8998','2013-07-22','11:35:00',2.92),('8998','2013-07-22','11:40:00',2.89),('8998','2013-07-22','11:45:00',2.87),('8998','2013-07-22','11:50:00',2.85),('8998','2013-07-22','11:55:00',2.83),('8998','2013-07-22','12:00:00',2.9),('8998','2013-07-22','12:05:00',2.88),('8998','2013-07-22','12:10:00',2.88),('8998','2013-07-22','12:15:00',2.89),('8998','2013-07-22','12:20:00',2.87),('8998','2013-07-22','12:25:00',2.87),('8998','2013-07-22','12:30:00',2.86),('8998','2013-07-22','12:35:00',2.82),('8998','2013-07-22','12:40:00',2.87),('8998','2013-07-22','12:45:00',2.07),('8998','2013-07-22','12:50:00',1.86),('8998','2013-07-22','12:55:00',1.94),('8998','2013-07-22','13:00:00',1.07),('8998','2013-07-22','13:10:00',1.92),('8998','2013-07-22','13:15:00',2.11),('8998','2013-07-22','13:30:00',1.93),('8998','2013-07-22','13:35:00',2.97),('8998','2013-07-22','13:40:00',2.92),('8998','2013-07-22','13:45:00',2.75),('8998','2013-07-22','13:50:00',1.87),('8998','2013-07-22','13:55:00',1.83),('8998','2013-07-22','14:00:00',2.74),('8998','2013-07-22','14:05:00',1.44),('8998','2013-07-22','14:40:00',2.47),('8998','2013-07-22','14:45:00',2.02),('8998','2013-07-22','14:50:00',2.5),('8998','2013-07-22','14:55:00',2.64),('8998','2013-07-22','15:00:00',1.85),('8998','2013-07-22','15:05:00',2.68),('8998','2013-07-22','15:10:00',2.47),('8998','2013-07-22','15:15:00',2.24),('8998','2013-07-22','15:20:00',2.23),('8998','2013-07-22','15:25:00',2.09),('8998','2013-07-22','15:30:00',2),('8998','2013-07-22','15:35:00',1.43),('8998','2013-07-22','15:40:00',1.89),('8998','2013-07-22','15:45:00',1.79),('8998','2013-07-22','15:50:00',1.75),('8998','2013-07-22','15:55:00',1.72),('8998','2013-07-22','16:00:00',1.67),('8998','2013-07-22','16:05:00',1.61),('8998','2013-07-22','16:10:00',1.56),('8998','2013-07-22','16:15:00',1.48),('8998','2013-07-22','16:20:00',1.47),('8998','2013-07-22','16:25:00',1.41),('8998','2013-07-22','16:30:00',1.36),('8998','2013-07-22','16:35:00',1.29),('8998','2013-07-22','16:40:00',1.25),('8998','2013-07-22','16:45:00',1.19),('8998','2013-07-22','16:50:00',1.13),('8998','2013-07-22','16:55:00',1.09),('8998','2013-07-22','17:00:00',1.03),('8998','2013-07-21','07:45:00',1.06),('8998','2013-07-21','07:50:00',1.2),('8998','2013-07-21','07:55:00',1.29),('8998','2013-07-21','08:00:00',1.26),('8998','2013-07-21','08:05:00',1.3),('8998','2013-07-21','08:10:00',1.31),('8998','2013-07-21','08:15:00',1.36),('8998','2013-07-21','08:20:00',1.42),('8998','2013-07-21','08:25:00',1.47),('8998','2013-07-21','08:30:00',1.51),('8998','2013-07-21','08:35:00',1.49),('8998','2013-07-21','08:40:00',1.52),('8998','2013-07-21','08:45:00',1.58),('8998','2013-07-21','08:50:00',1.68),('8998','2013-07-21','08:55:00',1.68),('8998','2013-07-21','09:00:00',1.75),('8998','2013-07-21','09:05:00',1.74),('8998','2013-07-21','09:10:00',1.79),('8998','2013-07-21','09:15:00',1.9),('8998','2013-07-21','09:20:00',2.02),('8998','2013-07-21','09:25:00',2.24),('8998','2013-07-21','09:30:00',2.4),('8998','2013-07-21','09:35:00',2.46),('8998','2013-07-21','09:40:00',2.5),('8998','2013-07-21','09:45:00',2.54),('8998','2013-07-21','09:50:00',2.56),('8998','2013-07-21','09:55:00',2.59),('8998','2013-07-21','10:00:00',2.62),('8998','2013-07-21','10:05:00',2.65),('8998','2013-07-21','10:10:00',2.67),('8998','2013-07-21','10:15:00',2.71),('8998','2013-07-21','10:20:00',2.74),('8998','2013-07-21','10:25:00',2.77),('8998','2013-07-21','10:30:00',2.78),('8998','2013-07-21','10:35:00',2.78),('8998','2013-07-21','10:40:00',2.81),('8998','2013-07-21','10:45:00',2.82),('8998','2013-07-21','10:50:00',2.83),('8998','2013-07-21','10:55:00',2.84),('8998','2013-07-21','11:00:00',2.84),('8998','2013-07-21','11:05:00',2.85),('8998','2013-07-21','11:10:00',2.86),('8998','2013-07-21','11:15:00',2.85),('8998','2013-07-21','11:20:00',2.85),('8998','2013-07-21','11:25:00',2.86),('8998','2013-07-21','11:30:00',2.86),('8998','2013-07-21','11:35:00',2.86),('8998','2013-07-21','11:40:00',2.85),('8998','2013-07-21','11:45:00',2.85),('8998','2013-07-21','11:50:00',2.83),('8998','2013-07-21','11:55:00',2.83),('8998','2013-07-21','12:00:00',2.84),('8998','2013-07-21','12:05:00',2.86),('8998','2013-07-21','12:10:00',2.85),('8998','2013-07-21','12:15:00',2.85),('8998','2013-07-21','12:20:00',2.85),('8998','2013-07-21','12:25:00',2.87),('8998','2013-07-21','12:30:00',2.87),('8998','2013-07-21','12:35:00',2.84),('8998','2013-07-21','12:40:00',2.84),('8998','2013-07-21','12:45:00',2.83),('8998','2013-07-21','12:50:00',2.81),('8998','2013-07-21','12:55:00',2.8),('8998','2013-07-21','13:00:00',2.83),('8998','2013-07-21','13:05:00',2.81),('8998','2013-07-21','13:10:00',2.77),('8998','2013-07-21','13:15:00',2.76),('8998','2013-07-21','13:20:00',2.74),('8998','2013-07-21','13:25:00',2.7),('8998','2013-07-21','13:30:00',2.67),('8998','2013-07-21','13:35:00',2.67),('8998','2013-07-21','13:40:00',2.7),('8998','2013-07-21','13:45:00',2.66),('8998','2013-07-21','13:50:00',2.63),('8998','2013-07-21','13:55:00',2.56),('8998','2013-07-21','14:00:00',2.56),('8998','2013-07-21','14:05:00',2.49),('8998','2013-07-21','14:10:00',2.49),('8998','2013-07-21','14:15:00',2.49),('8998','2013-07-21','14:20:00',2.47),('8998','2013-07-21','14:25:00',2.42),('8998','2013-07-21','14:30:00',2.38),('8998','2013-07-21','14:35:00',2.36),('8998','2013-07-21','14:40:00',2.33),('8998','2013-07-21','14:45:00',2.29),('8998','2013-07-21','14:50:00',2.25),('8998','2013-07-21','14:55:00',2.17),('8998','2013-07-21','15:00:00',2.11),('8998','2013-07-21','15:05:00',2),('8998','2013-07-21','15:10:00',2.08),('8998','2013-07-21','15:15:00',2.09),('8998','2013-07-21','15:20:00',2.03),('8998','2013-07-21','15:25:00',1.95),('8998','2013-07-21','15:40:00',1.83),('8998','2013-07-21','15:45:00',2.02),('8998','2013-07-21','15:50:00',1.97),('8998','2013-07-21','15:55:00',2.07),('8998','2013-07-21','16:00:00',1.89),('8998','2013-07-21','16:05:00',1.15),('8998','2013-07-21','16:15:00',1.54),('8998','2013-07-21','16:20:00',1.8),('8998','2013-07-21','16:25:00',1.68),('8998','2013-07-21','16:30:00',1.54),('8998','2013-07-21','16:35:00',1.44),('8998','2013-07-21','16:40:00',1.31),('8998','2013-07-21','16:45:00',1.23),('8998','2013-07-21','16:50:00',1.17),('8998','2013-07-21','16:55:00',1.1),('8998','2013-07-21','17:00:00',1.05),('8998','2013-07-21','17:05:00',1.01),('8998','2013-07-20','07:45:00',1.03),('8998','2013-07-20','07:50:00',1.1),('8998','2013-07-20','07:55:00',1.1),('8998','2013-07-20','08:00:00',1.14),('8998','2013-07-20','08:05:00',1.16),('8998','2013-07-20','08:10:00',1.26),('8998','2013-07-20','08:15:00',1.32),('8998','2013-07-20','08:20:00',1.36),('8998','2013-07-20','08:25:00',1.44),('8998','2013-07-20','08:30:00',1.47),('8998','2013-07-20','08:35:00',1.49),('8998','2013-07-20','08:40:00',1.49),('8998','2013-07-20','08:45:00',1.53),('8998','2013-07-20','08:50:00',1.54),('8998','2013-07-20','08:55:00',1.63),('8998','2013-07-20','09:00:00',1.72),('8998','2013-07-20','09:05:00',1.72),('8998','2013-07-20','09:10:00',1.76),('8998','2013-07-20','09:15:00',1.86),('8998','2013-07-20','09:20:00',1.99),('8998','2013-07-20','09:25:00',2.19),('8998','2013-07-20','09:30:00',2.33),('8998','2013-07-20','09:35:00',2.38),('8998','2013-07-20','09:40:00',2.43),('8998','2013-07-20','09:45:00',2.45),('8998','2013-07-20','09:50:00',2.48),('8998','2013-07-20','09:55:00',2.52),('8998','2013-07-20','10:00:00',2.55),('8998','2013-07-20','10:05:00',2.58),('8998','2013-07-20','10:10:00',2.58),('8998','2013-07-20','10:15:00',2.62),('8998','2013-07-20','10:20:00',2.65),('8998','2013-07-20','10:25:00',2.68),('8998','2013-07-20','10:30:00',2.66),('8998','2013-07-20','10:35:00',2.69),('8998','2013-07-20','10:40:00',2.72),('8998','2013-07-20','10:45:00',2.74),('8998','2013-07-20','10:50:00',2.76),('8998','2013-07-20','10:55:00',2.75),('8998','2013-07-20','11:00:00',2.76),('8998','2013-07-20','11:05:00',2.75),('8998','2013-07-20','11:10:00',2.77),('8998','2013-07-20','11:15:00',2.82),('8998','2013-07-20','11:20:00',2.83),('8998','2013-07-20','11:25:00',2.86),('8998','2013-07-20','11:30:00',2.85),('8998','2013-07-20','11:35:00',2.86),('8998','2013-07-20','11:40:00',3.01),('8998','2013-07-20','11:45:00',2.65),('8998','2013-07-20','11:50:00',2.95),('8998','2013-07-20','11:55:00',2.9),('8998','2013-07-20','12:00:00',2.88),('8998','2013-07-20','12:05:00',2.66),('8998','2013-07-20','12:10:00',2.9),('8998','2013-07-20','12:15:00',3.01),('8998','2013-07-20','12:20:00',3.07),('8998','2013-07-20','12:25:00',3.09),('8998','2013-07-20','12:30:00',3.13),('8998','2013-07-20','12:35:00',3),('8998','2013-07-20','12:40:00',3.12),('8998','2013-07-20','12:45:00',2.62),('8998','2013-07-20','12:50:00',3.14),('8998','2013-07-20','12:55:00',3.41),('8998','2013-07-20','13:00:00',3.21),('8998','2013-07-20','13:05:00',3.24),('8998','2013-07-20','13:10:00',3),('8998','2013-07-20','13:15:00',2.74),('8998','2013-07-20','13:20:00',2.78),('8998','2013-07-20','13:25:00',3.03),('8998','2013-07-20','13:30:00',2.83),('8998','2013-07-20','13:35:00',1.49),('8998','2013-07-20','14:45:00',1.51),('8998','2013-07-20','14:50:00',1.46),('8998','2013-07-20','14:55:00',1.17),('8998','2013-07-20','15:00:00',1.14),('8998','2013-07-20','15:15:00',2.07),('8998','2013-07-20','15:20:00',2.06),('8998','2013-07-20','15:25:00',1.02),('8998','2013-07-20','15:35:00',1.07),('8998','2013-07-20','15:40:00',2.34),('8998','2013-07-20','15:45:00',1.34),('8998','2013-07-20','15:50:00',1.45),('8998','2013-07-20','15:55:00',1.29),('8998','2014-04-06','08:30:00',1),('8998','2014-04-06','08:35:00',1.31),('8998','2014-04-06','08:40:00',1.38),('8998','2014-04-06','08:45:00',1.48),('8998','2014-04-06','08:50:00',1.22),('8998','2014-04-06','09:10:00',1.13),('8998','2014-04-06','09:15:00',1.19),('8998','2014-04-06','09:20:00',1.11),('8998','2014-04-06','09:55:00',1.13),('8998','2014-04-06','10:00:00',1.02),('8998','2014-04-06','10:05:00',1.03),('8998','2014-04-06','10:10:00',1.07),('8998','2014-04-06','10:30:00',1.04),('8998','2014-04-06','10:35:00',1.12),('8998','2014-04-06','10:40:00',1.16),('8998','2014-04-06','10:45:00',1.17),('8998','2014-04-06','10:50:00',1.21),('8998','2014-04-06','10:55:00',1.27),('8998','2014-04-06','11:00:00',1.34),('8998','2014-04-06','11:05:00',1.44),('8998','2014-04-06','11:10:00',1.68),('8998','2014-04-06','11:15:00',1.78),('8998','2014-04-06','11:20:00',1.61),('8998','2014-04-06','11:25:00',1.52),('8998','2014-04-06','11:30:00',1.5),('8998','2014-04-06','11:35:00',1.48),('8998','2014-04-06','11:40:00',1.4),('8998','2014-04-06','11:45:00',1.32),('8998','2014-04-06','11:50:00',1.29),('8998','2014-04-06','11:55:00',1.27),('8998','2014-04-06','12:00:00',1.4),('8998','2014-04-06','12:05:00',1.69),('8998','2014-04-06','12:10:00',1.98),('8998','2014-04-06','12:15:00',2.6),('8998','2014-04-06','12:20:00',3.11),('8998','2014-04-06','12:25:00',2.79),('8998','2014-04-06','12:30:00',1.83),('8998','2014-04-06','12:35:00',1.57),('8998','2014-04-06','12:40:00',2.12),('8998','2014-04-06','12:45:00',2.78),('8998','2014-04-06','12:50:00',2.76),('8998','2014-04-06','12:55:00',2.71),('8998','2014-04-06','13:00:00',2.69),('8998','2014-04-06','13:05:00',2.65),('8998','2014-04-06','13:10:00',2.62),('8998','2014-04-06','13:15:00',2.6),('8998','2014-04-06','13:20:00',2.59),('8998','2014-04-06','13:25:00',2.56),('8998','2014-04-06','13:30:00',2.54),('8998','2014-04-06','13:35:00',2.49),('8998','2014-04-06','13:40:00',2.47),('8998','2014-04-06','13:45:00',2.45),('8998','2014-04-06','13:50:00',2.41),('8998','2014-04-06','13:55:00',2.4),('8998','2014-04-06','14:00:00',2.36),('8998','2014-04-06','14:05:00',2.33),('8998','2014-04-06','14:10:00',2.3),('8998','2014-04-06','14:15:00',2.28),('8998','2014-04-06','14:20:00',2.28),('8998','2014-04-06','14:25:00',2.36),('8998','2014-04-06','14:30:00',2.28),('8998','2014-04-06','14:35:00',2.19),('8998','2014-04-06','14:40:00',2.14),('8998','2014-04-06','14:45:00',2.01),('8998','2014-04-06','14:50:00',2.08),('8998','2014-04-06','14:55:00',1.67),('8998','2014-04-06','15:00:00',1.83),('8998','2014-04-06','15:05:00',2.02),('8998','2014-04-06','15:10:00',1.54),('8998','2014-04-06','15:15:00',2.05),('8998','2014-04-06','15:20:00',2.16),('8998','2014-04-06','15:25:00',1.98),('8998','2014-04-06','15:30:00',1.77),('8998','2014-04-06','15:35:00',1.79),('8998','2014-04-06','15:40:00',1.71),('8998','2014-04-06','15:45:00',1.79),('8998','2014-04-06','15:50:00',1.88),('8998','2014-04-06','15:55:00',1.7),('8998','2014-04-06','16:10:00',1.38),('8998','2014-04-06','16:15:00',1.23),('8998','2014-04-06','16:20:00',1.07),('8998','2014-04-06','16:25:00',1.02),('8998','2013-07-19','07:45:00',1.14),('8998','2013-07-19','07:50:00',1.12),('8998','2013-07-19','07:55:00',1.14),('8998','2013-07-19','08:00:00',1.17),('8998','2013-07-19','08:05:00',1.22),('8998','2013-07-19','08:10:00',1.29),('8998','2013-07-19','08:15:00',1.37),('8998','2013-07-19','08:20:00',1.4),('8998','2013-07-19','08:25:00',1.48),('8998','2013-07-19','08:30:00',1.46),('8998','2013-07-19','08:35:00',1.54),('8998','2013-07-19','08:40:00',1.49),('8998','2013-07-19','08:45:00',1.57),('8998','2013-07-19','08:50:00',1.7),('8998','2013-07-19','08:55:00',1.73),('8998','2013-07-19','09:00:00',1.78),('8998','2013-07-19','09:05:00',1.81),('8998','2013-07-19','09:10:00',1.87),('8998','2013-07-19','09:15:00',2.01),('8998','2013-07-19','09:20:00',2.16),('8998','2013-07-19','09:25:00',2.26),('8998','2013-07-19','09:30:00',2.36),('8998','2013-07-19','09:35:00',2.41),('8998','2013-07-19','09:40:00',2.39),('8998','2013-07-19','09:45:00',2.49),('8998','2013-07-19','09:50:00',2.43),('8998','2013-07-19','09:55:00',2.47),('8998','2013-07-19','10:00:00',2.6),('8998','2013-07-19','10:05:00',2.61),('8998','2013-07-19','10:10:00',2.65),('8998','2013-07-19','10:15:00',2.67),('8998','2013-07-19','10:20:00',2.69),('8998','2013-07-19','10:25:00',2.71),('8998','2013-07-19','10:30:00',2.73),('8998','2013-07-19','10:35:00',2.76),('8998','2013-07-19','10:40:00',2.77),('8998','2013-07-19','10:45:00',2.79),('8998','2013-07-19','10:50:00',2.82),('8998','2013-07-19','10:55:00',2.82),('8998','2013-07-19','11:00:00',2.83),('8998','2013-07-19','11:05:00',2.83),('8998','2013-07-19','11:10:00',2.82),('8998','2013-07-19','11:15:00',2.87),('8998','2013-07-19','11:20:00',2.87),('8998','2013-07-19','11:25:00',2.87),('8998','2013-07-19','11:30:00',2.87),('8998','2013-07-19','11:35:00',2.85),('8998','2013-07-19','11:40:00',2.87),('8998','2013-07-19','11:45:00',2.86),('8998','2013-07-19','11:50:00',2.91),('8998','2013-07-19','11:55:00',2.93),('8998','2013-07-19','12:00:00',2.93),('8998','2013-07-19','12:05:00',2.93),('8998','2013-07-19','12:10:00',2.96),('8998','2013-07-19','12:15:00',2.91),('8998','2013-07-19','12:20:00',2.5),('8998','2013-07-19','12:25:00',2.57),('8998','2013-07-19','12:30:00',2.88),('8998','2013-07-19','12:35:00',2.82),('8998','2013-07-19','12:40:00',2.84),('8998','2013-07-19','12:45:00',2.94),('8998','2013-07-19','12:50:00',2.89),('8998','2013-07-19','12:55:00',2.9),('8998','2013-07-19','13:00:00',2.92),('8998','2013-07-19','13:05:00',2.87),('8998','2013-07-19','13:10:00',2.77),('8998','2013-07-19','13:15:00',2.54),('8998','2013-07-19','13:20:00',2.6),('8998','2013-07-19','13:25:00',2.11),('8998','2013-07-19','13:30:00',2.85),('8998','2013-07-19','13:35:00',2.84),('8998','2013-07-19','13:40:00',2.86),('8998','2013-07-19','13:45:00',2.82),('8998','2013-07-19','13:50:00',1.93),('8998','2013-07-19','14:00:00',2.06),('8998','2013-07-19','14:05:00',2.85),('8998','2013-07-19','14:10:00',2.63),('8998','2013-07-19','14:15:00',2.14),('8998','2013-07-19','14:20:00',1.36),('8998','2013-07-19','14:25:00',2.71),('8998','2013-07-19','14:30:00',2.61),('8998','2013-07-19','14:35:00',2.07),('8998','2013-07-19','14:40:00',2.33),('8998','2013-07-19','14:45:00',1.02),('8998','2013-07-19','14:50:00',1.96),('8998','2013-07-19','15:00:00',1.1),('8998','2013-07-19','15:05:00',2.41),('8998','2013-07-19','15:10:00',2.32),('8998','2013-07-19','15:15:00',2.22),('8998','2013-07-19','15:20:00',2.12),('8998','2013-07-19','15:25:00',2.06),('8998','2013-07-19','15:30:00',2),('8998','2013-07-19','15:35:00',1.93),('8998','2013-07-19','15:40:00',1.9),('8998','2013-07-19','15:45:00',1.84),('8998','2013-07-19','15:50:00',1.78),('8998','2013-07-19','15:55:00',1.75),('8998','2013-07-19','16:00:00',1.71),('8998','2013-07-19','16:05:00',1.65),('8998','2013-07-19','16:10:00',1.59),('8998','2013-07-19','16:15:00',1.55),('8998','2013-07-19','16:20:00',1.5),('8998','2013-07-19','16:25:00',1.44),('8998','2013-07-19','16:30:00',1.39),('8998','2013-07-19','16:35:00',1.33),('8998','2013-07-19','16:40:00',1.27),('8998','2013-07-19','16:45:00',1.2),('8998','2013-07-19','16:50:00',1.14),('8998','2013-07-19','16:55:00',1.09),('8998','2013-07-19','17:00:00',1.02),('8998','2013-07-18','07:45:00',1.05),('8998','2013-07-18','07:50:00',1.1),('8998','2013-07-18','07:55:00',1.11),('8998','2013-07-18','08:00:00',1.15),('8998','2013-07-18','08:05:00',1.21),('8998','2013-07-18','08:10:00',1.28),('8998','2013-07-18','08:15:00',1.32),('8998','2013-07-18','08:20:00',1.38),('8998','2013-07-18','08:25:00',1.45),('8998','2013-07-18','08:30:00',1.41),('8998','2013-07-18','08:35:00',1.51),('8998','2013-07-18','08:40:00',1.49),('8998','2013-07-18','08:45:00',1.59),('8998','2013-07-18','08:50:00',1.57),('8998','2013-07-18','08:55:00',1.64),('8998','2013-07-18','09:00:00',1.73),('8998','2013-07-18','09:05:00',1.78),('8998','2013-07-18','09:10:00',1.79),('8998','2013-07-18','09:15:00',1.91),('8998','2013-07-18','09:20:00',2.07),('8998','2013-07-18','09:25:00',2.21),('8998','2013-07-18','09:30:00',2.34),('8998','2013-07-18','09:35:00',2.38),('8998','2013-07-18','09:40:00',2.42),('8998','2013-07-18','09:45:00',2.43),('8998','2013-07-18','09:50:00',2.46),('8998','2013-07-18','09:55:00',2.47),('8998','2013-07-18','10:00:00',2.5),('8998','2013-07-18','10:05:00',2.51),('8998','2013-07-18','10:10:00',2.53),('8998','2013-07-18','10:15:00',2.54),('8998','2013-07-18','10:20:00',2.55),('8998','2013-07-18','10:25:00',2.65),('8998','2013-07-18','10:30:00',2.59),('8998','2013-07-18','10:35:00',2.69),('8998','2013-07-18','10:40:00',2.66),('8998','2013-07-18','10:45:00',2.67),('8998','2013-07-18','10:50:00',2.7),('8998','2013-07-18','10:55:00',2.71),('8998','2013-07-18','11:00:00',2.73),('8998','2013-07-18','11:05:00',2.69),('8998','2013-07-18','11:10:00',2.69),('8998','2013-07-18','11:15:00',2.71),('8998','2013-07-18','11:20:00',2.73),('8998','2013-07-18','11:25:00',2.76),('8998','2013-07-18','11:30:00',2.75),('8998','2013-07-18','11:35:00',2.71),('8998','2013-07-18','11:40:00',2.71),('8998','2013-07-18','11:45:00',2.82),('8998','2013-07-18','11:50:00',2.78),('8998','2013-07-18','11:55:00',2.7),('8998','2013-07-18','12:00:00',2.16),('8998','2013-07-18','12:05:00',2.66),('8998','2013-07-18','12:10:00',2.83),('8998','2013-07-18','12:15:00',2.89),('8998','2013-07-18','12:20:00',2.84),('8998','2013-07-18','12:25:00',2.84),('8998','2013-07-18','12:30:00',2.83),('8998','2013-07-18','12:35:00',2.78),('8998','2013-07-18','12:40:00',2.79),('8998','2013-07-18','12:45:00',2.75),('8998','2013-07-18','12:50:00',2.8),('8998','2013-07-18','12:55:00',1.97),('8998','2013-07-18','13:00:00',2.51),('8998','2013-07-18','13:05:00',2.83),('8998','2013-07-18','13:10:00',2.8),('8998','2013-07-18','13:15:00',1.49),('8998','2013-07-18','13:20:00',1.05),('8998','2013-07-18','13:25:00',2.41),('8998','2013-07-18','13:30:00',2.95),('8998','2013-07-18','13:35:00',2.85),('8998','2013-07-18','13:40:00',2.78),('8998','2013-07-18','13:45:00',2.77),('8998','2013-07-18','13:50:00',2.75),('8998','2013-07-18','13:55:00',2.74),('8998','2013-07-18','14:00:00',2.74),('8998','2013-07-18','14:05:00',2.7),('8998','2013-07-18','14:10:00',2.15),('8998','2013-07-18','14:15:00',2.46),('8998','2013-07-18','14:20:00',2.15),('8998','2013-07-18','14:25:00',2.12),('8998','2013-07-18','14:30:00',2.49),('8998','2013-07-18','14:35:00',2.59),('8998','2013-07-18','14:40:00',2.31),('8998','2013-07-18','14:45:00',2.41),('8998','2013-07-18','14:50:00',2.17),('8998','2013-07-18','14:55:00',2.34),('8998','2013-07-18','15:00:00',2.11),('8998','2013-07-18','15:05:00',2.29),('8998','2013-07-18','15:10:00',2.2),('8998','2013-07-18','15:15:00',1.84),('8998','2013-07-18','15:20:00',1.71),('8998','2013-07-18','15:25:00',1.67),('8998','2013-07-18','15:30:00',2.18),('8998','2013-07-18','15:35:00',2.1),('8998','2013-07-18','15:40:00',1.84),('8998','2013-07-18','15:45:00',2.02),('8998','2013-07-18','15:50:00',2),('8998','2013-07-18','15:55:00',1.82),('8998','2013-07-18','16:00:00',1.85),('8998','2013-07-18','16:05:00',1.8),('8998','2013-07-18','16:10:00',1.73),('8998','2013-07-18','16:15:00',1.7),('8998','2013-07-18','16:20:00',1.66),('8998','2013-07-18','16:25:00',1.62),('8998','2013-07-18','16:30:00',1.59),('8998','2013-07-18','16:35:00',1.55),('8998','2013-07-18','16:40:00',1.5),('8998','2013-07-18','16:45:00',1.46),('8998','2013-07-18','16:50:00',1.34),('8998','2013-07-18','16:55:00',1.39),('8998','2013-07-18','17:00:00',1.05),('8998','2013-07-18','17:05:00',1.34),('8998','2013-07-18','17:10:00',1.3),('8998','2013-07-18','17:15:00',1.1),('8998','2013-07-17','07:40:00',1.03),('8998','2013-07-17','07:45:00',1.26),('8998','2013-07-17','07:50:00',1.21),('8998','2013-07-17','07:55:00',1.28),('8998','2013-07-17','08:00:00',1.25),('8998','2013-07-17','08:05:00',1.27),('8998','2013-07-17','08:10:00',1.33),('8998','2013-07-17','08:15:00',1.49),('8998','2013-07-17','08:20:00',1.57),('8998','2013-07-17','08:25:00',1.54),('8998','2013-07-17','08:30:00',1.48),('8998','2013-07-17','08:35:00',1.57),('8998','2013-07-17','08:40:00',1.51),('8998','2013-07-17','08:45:00',1.58),('8998','2013-07-17','08:50:00',1.56),('8998','2013-07-17','08:55:00',1.64),('8998','2013-07-17','09:00:00',1.76),('8998','2013-07-17','09:05:00',1.83),('8998','2013-07-17','09:10:00',1.82),('8998','2013-07-17','09:15:00',1.98),('8998','2013-07-17','09:20:00',2.17),('8998','2013-07-17','09:25:00',2.32),('8998','2013-07-17','09:30:00',2.45),('8998','2013-07-17','09:35:00',2.48),('8998','2013-07-17','09:40:00',2.51),('8998','2013-07-17','09:45:00',2.53),('8998','2013-07-17','09:50:00',2.57),('8998','2013-07-17','09:55:00',2.59),('8998','2013-07-17','10:00:00',2.61),('8998','2013-07-17','10:05:00',2.62),('8998','2013-07-17','10:10:00',2.67),('8998','2013-07-17','10:15:00',2.68),('8998','2013-07-17','10:20:00',2.69),('8998','2013-07-17','10:25:00',2.71),('8998','2013-07-17','10:30:00',2.75),('8998','2013-07-17','10:35:00',2.78),('8998','2013-07-17','10:40:00',2.8),('8998','2013-07-17','10:45:00',2.81),('8998','2013-07-17','10:50:00',2.83),('8998','2013-07-17','10:55:00',2.83),('8998','2013-07-17','11:00:00',2.82),('8998','2013-07-17','11:05:00',2.82),('8998','2013-07-17','11:10:00',2.84),('8998','2013-07-17','11:15:00',2.85),('8998','2013-07-17','11:20:00',2.87),('8998','2013-07-17','11:25:00',2.86),('8998','2013-07-17','11:30:00',2.86),('8998','2013-07-17','11:35:00',2.87),('8998','2013-07-17','11:40:00',2.86),('8998','2013-07-17','11:45:00',2.86),('8998','2013-07-17','11:50:00',2.86),('8998','2013-07-17','11:55:00',2.89),('8998','2013-07-17','12:00:00',2.9),('8998','2013-07-17','12:05:00',2.85),('8998','2013-07-17','12:10:00',2.82),('8998','2013-07-17','12:15:00',2.82),('8998','2013-07-17','12:20:00',2.85),('8998','2013-07-17','12:25:00',2.84),('8998','2013-07-17','12:30:00',2.75),('8998','2013-07-17','12:35:00',2.95),('8998','2013-07-17','12:40:00',3.02),('8998','2013-07-17','12:45:00',2),('8998','2013-07-17','12:50:00',1.08),('8998','2013-07-17','12:55:00',2.48),('8998','2013-07-17','13:00:00',2.98),('8998','2013-07-17','13:05:00',2.83),('8998','2013-07-17','13:10:00',2.77),('8998','2013-07-17','13:15:00',2.74),('8998','2013-07-17','13:20:00',2.83),('8998','2013-07-17','13:25:00',2.82),('8998','2013-07-17','13:30:00',2.85),('8998','2013-07-17','13:35:00',2.68),('8998','2013-07-17','13:40:00',2.43),('8998','2013-07-17','13:45:00',2.76),('8998','2013-07-17','13:50:00',2.72),('8998','2013-07-17','13:55:00',2.58),('8998','2013-07-17','14:00:00',2.62),('8998','2013-07-17','14:05:00',2.55),('8998','2013-07-17','14:10:00',2.53),('8998','2013-07-17','14:15:00',2.27),('8998','2013-07-17','14:20:00',2.52),('8998','2013-07-17','14:25:00',2.48),('8998','2013-07-17','14:30:00',2.42),('8998','2013-07-17','14:35:00',2.41),('8998','2013-07-17','14:40:00',2.37),('8998','2013-07-17','14:45:00',2.32),('8998','2013-07-17','14:50:00',2.29),('8998','2013-07-17','14:55:00',2.22),('8998','2013-07-17','15:00:00',2.17),('8998','2013-07-17','15:05:00',2.16),('8998','2013-07-17','15:10:00',2.12),('8998','2013-07-17','15:15:00',2.06),('8998','2013-07-17','15:20:00',2.03),('8998','2013-07-17','15:25:00',2.02),('8998','2013-07-17','15:30:00',1.95),('8998','2013-07-17','15:35:00',1.89),('8998','2013-07-17','15:40:00',1.86),('8998','2013-07-17','15:45:00',1.81),('8998','2013-07-17','15:50:00',1.76),('8998','2013-07-17','15:55:00',1.71),('8998','2013-07-17','16:00:00',1.65),('8998','2013-07-17','16:05:00',1.61),('8998','2013-07-17','16:10:00',1.55),('8998','2013-07-17','16:15:00',1.49),('8998','2013-07-17','16:20:00',1.44),('8998','2013-07-17','16:25:00',1.39),('8998','2013-07-17','16:30:00',1.34),('8998','2013-07-17','16:35:00',1.3),('8998','2013-07-17','16:40:00',1.24),('8998','2013-07-17','16:45:00',1.18),('8998','2013-07-17','16:50:00',1.13),('8998','2013-07-17','16:55:00',1.07),('8998','2013-07-17','17:00:00',1),('8998','2013-07-16','07:40:00',1.05),('8998','2013-07-16','07:45:00',1.2),('8998','2013-07-16','07:50:00',1.21),('8998','2013-07-16','07:55:00',1.31),('8998','2013-07-16','08:00:00',1.25),('8998','2013-07-16','08:05:00',1.32),('8998','2013-07-16','08:10:00',1.42),('8998','2013-07-16','08:15:00',1.53),('8998','2013-07-16','08:20:00',1.67),('8998','2013-07-16','08:25:00',1.62),('8998','2013-07-16','08:30:00',1.54),('8998','2013-07-16','08:35:00',1.65),('8998','2013-07-16','08:40:00',1.57),('8998','2013-07-16','08:45:00',1.64),('8998','2013-07-16','08:50:00',1.79),('8998','2013-07-16','08:55:00',1.78),('8998','2013-07-16','09:00:00',1.83),('8998','2013-07-16','09:05:00',1.93),('8998','2013-07-16','09:10:00',1.94),('8998','2013-07-16','09:15:00',2.14),('8998','2013-07-16','09:20:00',2.39),('8998','2013-07-16','09:25:00',2.54),('8998','2013-07-16','09:30:00',2.6),('8998','2013-07-16','09:35:00',2.61),('8998','2013-07-16','09:40:00',2.65),('8998','2013-07-16','09:45:00',2.69),('8998','2013-07-16','09:50:00',2.71),('8998','2013-07-16','09:55:00',2.72),('8998','2013-07-16','10:00:00',2.75),('8998','2013-07-16','10:05:00',2.77),('8998','2013-07-16','10:10:00',2.79),('8998','2013-07-16','10:15:00',2.79),('8998','2013-07-16','10:20:00',2.81),('8998','2013-07-16','10:25:00',2.84),('8998','2013-07-16','10:30:00',2.85),('8998','2013-07-16','10:35:00',2.87),('8998','2013-07-16','10:40:00',2.88),('8998','2013-07-16','10:45:00',2.92),('8998','2013-07-16','10:50:00',2.94),('8998','2013-07-16','10:55:00',2.95),('8998','2013-07-16','11:00:00',2.97),('8998','2013-07-16','11:05:00',3),('8998','2013-07-16','11:10:00',2.99),('8998','2013-07-16','11:15:00',2.99),('8998','2013-07-16','11:20:00',2.99),('8998','2013-07-16','11:25:00',3.01),('8998','2013-07-16','11:30:00',3.01),('8998','2013-07-16','11:35:00',3.01),('8998','2013-07-16','11:40:00',3),('8998','2013-07-16','11:45:00',3),('8998','2013-07-16','11:50:00',3.02),('8998','2013-07-16','11:55:00',3.03),('8998','2013-07-16','12:00:00',3.02),('8998','2013-07-16','12:05:00',3.01),('8998','2013-07-16','12:10:00',3),('8998','2013-07-16','12:15:00',2.96),('8998','2013-07-16','12:20:00',2.95),('8998','2013-07-16','12:25:00',2.97),('8998','2013-07-16','12:30:00',2.94),('8998','2013-07-16','12:35:00',2.94),('8998','2013-07-16','12:40:00',2.92),('8998','2013-07-16','12:45:00',2.91),('8998','2013-07-16','12:50:00',2.91),('8998','2013-07-16','12:55:00',2.91),('8998','2013-07-16','13:00:00',2.9),('8998','2013-07-16','13:05:00',2.88),('8998','2013-07-16','13:10:00',2.84),('8998','2013-07-16','13:15:00',2.82),('8998','2013-07-16','13:20:00',2.77),('8998','2013-07-16','13:25:00',2.76),('8998','2013-07-16','13:30:00',2.74),('8998','2013-07-16','13:35:00',2.71),('8998','2013-07-16','13:40:00',2.71),('8998','2013-07-16','13:45:00',2.7),('8998','2013-07-16','13:50:00',2.66),('8998','2013-07-16','13:55:00',2.64),('8998','2013-07-16','14:00:00',2.63),('8998','2013-07-16','14:05:00',2.58),('8998','2013-07-16','14:10:00',2.55),('8998','2013-07-16','14:15:00',2.53),('8998','2013-07-16','14:20:00',2.5),('8998','2013-07-16','14:25:00',2.46),('8998','2013-07-16','14:30:00',2.43),('8998','2013-07-16','14:35:00',2.4),('8998','2013-07-16','14:40:00',2.55),('8998','2013-07-16','14:45:00',2.44),('8998','2013-07-16','14:50:00',2.32),('8998','2013-07-16','14:55:00',2.23),('8998','2013-07-16','15:00:00',2.25),('8998','2013-07-16','15:05:00',2.19),('8998','2013-07-16','15:10:00',2.09),('8998','2013-07-16','15:15:00',2.21),('8998','2013-07-16','15:20:00',2.13),('8998','2013-07-16','15:25:00',2.04),('8998','2013-07-16','15:30:00',1.96),('8998','2013-07-16','15:35:00',1.94),('8998','2013-07-16','15:40:00',1.51),('8998','2013-07-16','15:45:00',1.84),('8998','2013-07-16','15:50:00',1.8),('8998','2013-07-16','15:55:00',1.76),('8998','2013-07-16','16:00:00',1.72),('8998','2013-07-16','16:05:00',1.66),('8998','2013-07-16','16:10:00',1.64),('8998','2013-07-16','16:15:00',1.58),('8998','2013-07-16','16:20:00',1.5),('8998','2013-07-16','16:25:00',1.44),('8998','2013-07-16','16:30:00',1.4),('8998','2013-07-16','16:35:00',1.36),('8998','2013-07-16','16:40:00',1.29),('8998','2013-07-16','16:45:00',1.28),('8998','2013-07-16','16:50:00',1.21),('8998','2013-07-16','16:55:00',1.13),('8998','2013-07-16','17:05:00',1.05),('8998','2013-07-16','17:10:00',1.01),('8998','2013-07-15','07:45:00',1.18),('8998','2013-07-15','07:50:00',1.19),('8998','2013-07-15','07:55:00',1.27),('8998','2013-07-15','08:00:00',1.21),('8998','2013-07-15','08:05:00',1.26),('8998','2013-07-15','08:10:00',1.33),('8998','2013-07-15','08:15:00',1.44),('8998','2013-07-15','08:20:00',1.61),('8998','2013-07-15','08:25:00',1.58),('8998','2013-07-15','08:30:00',1.54),('8998','2013-07-15','08:35:00',1.59),('8998','2013-07-15','08:40:00',1.52),('8998','2013-07-15','08:45:00',1.57),('8998','2013-07-15','08:50:00',1.61),('8998','2013-07-15','08:55:00',1.62),('8998','2013-07-15','09:00:00',1.77),('8998','2013-07-15','09:05:00',1.85),('8998','2013-07-15','09:10:00',1.86),('8998','2013-07-15','09:15:00',2.03),('8998','2013-07-15','09:20:00',2.22),('8998','2013-07-15','09:25:00',2.36),('8998','2013-07-15','09:30:00',2.43),('8998','2013-07-15','09:35:00',2.46),('8998','2013-07-15','09:40:00',2.49),('8998','2013-07-15','09:45:00',2.56),('8998','2013-07-15','09:50:00',2.6),('8998','2013-07-15','09:55:00',2.63),('8998','2013-07-15','10:00:00',2.66),('8998','2013-07-15','10:05:00',2.7),('8998','2013-07-15','10:10:00',2.75),('8998','2013-07-15','10:15:00',2.75),('8998','2013-07-15','10:20:00',2.75),('8998','2013-07-15','10:25:00',2.78),('8998','2013-07-15','10:30:00',2.81),('8998','2013-07-15','10:35:00',2.82),('8998','2013-07-15','10:40:00',2.84),('8998','2013-07-15','10:45:00',2.85),('8998','2013-07-15','10:50:00',2.86),('8998','2013-07-15','10:55:00',2.88),('8998','2013-07-15','11:00:00',2.89),('8998','2013-07-15','11:05:00',2.91),('8998','2013-07-15','11:10:00',2.93),('8998','2013-07-15','11:15:00',2.92),('8998','2013-07-15','11:20:00',2.93),('8998','2013-07-15','11:25:00',2.94),('8998','2013-07-15','11:30:00',2.92),('8998','2013-07-15','11:35:00',2.9),('8998','2013-07-15','11:40:00',2.92),('8998','2013-07-15','11:45:00',2.95),('8998','2013-07-15','11:50:00',2.99),('8998','2013-07-15','11:55:00',2.99),('8998','2013-07-15','12:00:00',2.99),('8998','2013-07-15','12:05:00',2.97),('8998','2013-07-15','12:10:00',2.98),('8998','2013-07-15','12:15:00',2.97),('8998','2013-07-15','12:20:00',2.95),('8998','2013-07-15','12:25:00',2.94),('8998','2013-07-15','12:30:00',2.92),('8998','2013-07-15','12:35:00',2.9),('8998','2013-07-15','12:40:00',2.88),('8998','2013-07-15','12:45:00',2.83),('8998','2013-07-15','12:50:00',2.83),('8998','2013-07-15','12:55:00',2.81),('8998','2013-07-15','13:00:00',2.81),('8998','2013-07-15','13:05:00',2.82),('8998','2013-07-15','13:10:00',2.8),('8998','2013-07-15','13:15:00',2.81),('8998','2013-07-15','13:20:00',2.77),('8998','2013-07-15','13:25:00',2.78),('8998','2013-07-15','13:30:00',2.75),('8998','2013-07-15','13:35:00',2.75),('8998','2013-07-15','13:40:00',2.74),('8998','2013-07-15','13:45:00',2.78),('8998','2013-07-15','13:50:00',2.75),('8998','2013-07-15','13:55:00',2.47),('8998','2013-07-15','14:00:00',2.6),('8998','2013-07-15','14:05:00',2.62),('8998','2013-07-15','14:10:00',2.4),('8998','2013-07-15','14:15:00',1.78),('8998','2013-07-15','14:20:00',1.24),('8998','2013-07-15','14:25:00',2.59),('8998','2013-07-15','14:30:00',2.53),('8998','2013-07-15','14:35:00',2.5),('8998','2013-07-15','14:40:00',2.42),('8998','2013-07-15','14:45:00',2.37),('8998','2013-07-15','14:50:00',2.36),('8998','2013-07-15','14:55:00',2.32),('8998','2013-07-15','15:00:00',2.26),('8998','2013-07-15','15:05:00',2.2),('8998','2013-07-15','15:10:00',2.14),('8998','2013-07-15','15:15:00',2.09),('8998','2013-07-15','15:20:00',2.07),('8998','2013-07-15','15:25:00',2.03),('8998','2013-07-15','15:30:00',2.02),('8998','2013-07-15','15:35:00',1.96),('8998','2013-07-15','15:40:00',1.85),('8998','2013-07-15','15:45:00',1.33),('8998','2013-07-15','15:50:00',1.81),('8998','2013-07-15','15:55:00',1.75),('8998','2013-07-15','16:00:00',1.05),('8998','2013-07-15','16:10:00',1.57),('8998','2013-07-15','16:15:00',1.52),('8998','2013-07-15','16:20:00',1.13),('8998','2013-07-15','17:00:00',1.25),('8998','2013-07-15','17:05:00',1.25),('8998','2013-07-15','17:10:00',1.28),('8998','2013-07-15','17:15:00',1.18),('8998','2013-07-15','17:20:00',1.05),('8998','2013-07-14','07:45:00',1.18),('8998','2013-07-14','07:50:00',1.2),('8998','2013-07-14','07:55:00',1.29),('8998','2013-07-14','08:00:00',1.24),('8998','2013-07-14','08:05:00',1.29),('8998','2013-07-14','08:10:00',1.36),('8998','2013-07-14','08:15:00',1.4),('8998','2013-07-14','08:20:00',1.48),('8998','2013-07-14','08:25:00',1.59),('8998','2013-07-14','08:30:00',1.57),('8998','2013-07-14','08:35:00',1.64),('8998','2013-07-14','08:40:00',1.59),('8998','2013-07-14','08:45:00',1.6),('8998','2013-07-14','08:50:00',1.67),('8998','2013-07-14','08:55:00',1.74),('8998','2013-07-14','09:00:00',1.83),('8998','2013-07-14','09:05:00',1.91),('8998','2013-07-14','09:10:00',1.91),('8998','2013-07-14','09:15:00',2.11),('8998','2013-07-14','09:20:00',2.32),('8998','2013-07-14','09:25:00',2.48),('8998','2013-07-14','09:30:00',2.55),('8998','2013-07-14','09:35:00',2.58),('8998','2013-07-14','09:40:00',2.6),('8998','2013-07-14','09:45:00',2.62),('8998','2013-07-14','09:50:00',2.67),('8998','2013-07-14','09:55:00',2.69),('8998','2013-07-14','10:00:00',2.69),('8998','2013-07-14','10:05:00',2.71),('8998','2013-07-14','10:10:00',2.75),('8998','2013-07-14','10:15:00',2.76),('8998','2013-07-14','10:20:00',2.76),('8998','2013-07-14','10:25:00',2.79),('8998','2013-07-14','10:30:00',2.79),('8998','2013-07-14','10:35:00',2.81),('8998','2013-07-14','10:40:00',2.83),('8998','2013-07-14','10:45:00',2.84),('8998','2013-07-14','10:50:00',2.85),('8998','2013-07-14','10:55:00',2.87),('8998','2013-07-14','11:00:00',2.89),('8998','2013-07-14','11:05:00',2.9),('8998','2013-07-14','11:10:00',2.91),('8998','2013-07-14','11:15:00',2.92),('8998','2013-07-14','11:20:00',2.93),('8998','2013-07-14','11:25:00',2.93),('8998','2013-07-14','11:30:00',2.93),('8998','2013-07-14','11:35:00',2.94),('8998','2013-07-14','11:40:00',2.96),('8998','2013-07-14','11:45:00',2.93),('8998','2013-07-14','11:50:00',2.92),('8998','2013-07-14','11:55:00',2.95),('8998','2013-07-14','12:00:00',2.95),('8998','2013-07-14','12:05:00',2.91),('8998','2013-07-14','12:10:00',2.91),('8998','2013-07-14','12:15:00',2.96),('8998','2013-07-14','12:20:00',2.95),('8998','2013-07-14','12:25:00',2.92),('8998','2013-07-14','12:30:00',2.92),('8998','2013-07-14','12:35:00',2.89),('8998','2013-07-14','12:40:00',2.85),('8998','2013-07-14','12:45:00',2.82),('8998','2013-07-14','12:50:00',2.84),('8998','2013-07-14','12:55:00',2.85),('8998','2013-07-14','13:00:00',2.42),('8998','2013-07-14','13:05:00',2.58),('8998','2013-07-14','13:10:00',2.6),('8998','2013-07-14','13:15:00',2.82),('8998','2013-07-14','13:20:00',2.75),('8998','2013-07-14','13:25:00',2.9),('8998','2013-07-14','13:30:00',2.91),('8998','2013-07-14','13:35:00',1.8),('8998','2013-07-14','13:45:00',1.55),('8998','2013-07-14','13:50:00',2.98),('8998','2013-07-14','13:55:00',2.92),('8998','2013-07-14','14:00:00',2.91),('8998','2013-07-14','14:05:00',1.75),('8998','2013-07-14','14:20:00',2.32),('8998','2013-07-14','14:25:00',2.65),('8998','2013-07-14','14:30:00',2.29),('8998','2013-07-14','14:35:00',2.56),('8998','2013-07-14','14:40:00',2.53),('8998','2013-07-14','14:45:00',2.45),('8998','2013-07-14','14:50:00',2.44),('8998','2013-07-14','14:55:00',2.41),('8998','2013-07-14','15:00:00',2.38),('8998','2013-07-14','15:05:00',2.32),('8998','2013-07-14','15:10:00',2.27),('8998','2013-07-14','15:15:00',2.21),('8998','2013-07-14','15:20:00',2.12),('8998','2013-07-14','15:25:00',2.09),('8998','2013-07-14','15:30:00',2.04),('8998','2013-07-14','15:35:00',1.98),('8998','2013-07-14','15:40:00',2.02),('8998','2013-07-14','15:45:00',1.82),('8998','2013-07-14','15:50:00',1.93),('8998','2013-07-14','15:55:00',1.66),('8998','2013-07-14','16:00:00',1.72),('8998','2013-07-14','16:05:00',1.67),('8998','2013-07-14','16:10:00',1.62),('8998','2013-07-14','16:15:00',1.58),('8998','2013-07-14','16:20:00',1.48),('8998','2013-07-14','16:25:00',1.42),('8998','2013-07-14','16:30:00',1.38),('8998','2013-07-14','16:35:00',1.34),('8998','2013-07-14','16:40:00',1.28),('8998','2013-07-14','16:45:00',1.22),('8998','2013-07-14','16:50:00',1.17),('8998','2013-07-14','16:55:00',1.12),('8998','2013-07-14','17:00:00',1.07),('8998','2013-07-14','17:05:00',1.02),('8998','2013-07-13','07:55:00',1.09),('8998','2013-07-13','08:05:00',1.26),('8998','2013-07-13','08:10:00',1.91),('8998','2013-07-13','08:15:00',1.53),('8998','2013-07-13','08:20:00',2.08),('8998','2013-07-13','08:25:00',1.42),('8998','2013-07-13','08:35:00',1.04),('8998','2013-07-13','08:40:00',1.04),('8998','2013-07-13','08:50:00',1.04),('8998','2013-07-13','08:55:00',1.16),('8998','2013-07-13','09:05:00',1.14),('8998','2013-07-13','09:10:00',1.17),('8998','2013-07-13','09:15:00',1.29),('8998','2013-07-13','09:20:00',1.63),('8998','2013-07-13','09:25:00',2.14),('8998','2013-07-13','09:30:00',1.98),('8998','2013-07-13','09:35:00',1.47),('8998','2013-07-13','09:40:00',1.3),('8998','2013-07-13','09:45:00',1.3),('8998','2013-07-13','09:50:00',1.23),('8998','2013-07-13','09:55:00',1.37),('8998','2013-07-13','10:00:00',1.29),('8998','2013-07-13','10:05:00',1.37),('8998','2013-07-13','10:10:00',1.36),('8998','2013-07-13','10:15:00',1.43),('8998','2013-07-13','10:20:00',1.87),('8998','2013-07-13','10:25:00',2.25),('8998','2013-07-13','10:30:00',2.02),('8998','2013-07-13','10:35:00',2.79),('8998','2013-07-13','10:40:00',2.92),('8998','2013-07-13','10:45:00',2.7),('8998','2013-07-13','10:50:00',3.17),('8998','2013-07-13','10:55:00',2.66),('8998','2013-07-13','11:00:00',3.1),('8998','2013-07-13','11:05:00',3.04),('8998','2013-07-13','11:10:00',2.02),('8998','2013-07-13','11:15:00',2.44),('8998','2013-07-13','11:20:00',3.31),('8998','2013-07-13','11:25:00',3.03),('8998','2013-07-13','11:30:00',3.13),('8998','2013-07-13','11:35:00',3.05),('8998','2013-07-13','11:40:00',2.89),('8998','2013-07-13','11:45:00',3.22),('8998','2013-07-13','11:50:00',3.09),('8998','2013-07-13','11:55:00',1.27),('8998','2013-07-13','12:05:00',1.16),('8998','2013-07-13','12:10:00',2.77),('8998','2013-07-13','12:15:00',2.68),('8998','2013-07-13','12:20:00',1.56),('8998','2013-07-13','12:25:00',1.73),('8998','2013-07-13','12:30:00',1.2),('8998','2013-07-13','12:35:00',1.07),('8998','2013-07-13','12:40:00',1.27),('8998','2013-07-13','12:45:00',2.28),('8998','2013-07-13','12:50:00',2.13),('8998','2013-07-13','12:55:00',2.61),('8998','2013-07-13','13:00:00',3.14),('8998','2013-07-13','13:05:00',3.17),('8998','2013-07-13','13:10:00',3.04),('8998','2013-07-13','13:15:00',3.03),('8998','2013-07-13','13:20:00',3.08),('8998','2013-07-13','13:25:00',2.95),('8998','2013-07-13','13:30:00',2.92),('8998','2013-07-13','13:35:00',2.87),('8998','2013-07-13','13:40:00',2.83),('8998','2013-07-13','13:45:00',2.83),('8998','2013-07-13','13:50:00',2.83),('8998','2013-07-13','13:55:00',2.81),('8998','2013-07-13','14:00:00',2.8),('8998','2013-07-13','14:05:00',2.78),('8998','2013-07-13','14:10:00',2.74),('8998','2013-07-13','14:15:00',2.72),('8998','2013-07-13','14:20:00',2.69),('8998','2013-07-13','14:25:00',2.64),('8998','2013-07-13','14:30:00',2.6),('8998','2013-07-13','14:35:00',2.51),('8998','2013-07-13','14:40:00',2.44),('8998','2013-07-13','14:45:00',2.42),('8998','2013-07-13','14:50:00',2.45),('8998','2013-07-13','14:55:00',2.42),('8998','2013-07-13','15:00:00',2.3),('8998','2013-07-13','15:05:00',2.24),('8998','2013-07-13','15:10:00',2.18),('8998','2013-07-13','15:15:00',2.14),('8998','2013-07-13','15:20:00',2.09),('8998','2013-07-13','15:25:00',2.05),('8998','2013-07-13','15:30:00',2),('8998','2013-07-13','15:35:00',1.95),('8998','2013-07-13','15:40:00',1.9),('8998','2013-07-13','15:45:00',1.85),('8998','2013-07-13','15:50:00',1.8),('8998','2013-07-13','15:55:00',1.79),('8998','2013-07-13','16:00:00',1.72),('8998','2013-07-13','16:05:00',1.71),('8998','2013-07-13','16:10:00',1.66),('8998','2013-07-13','16:15:00',1.61),('8998','2013-07-13','16:20:00',1.44),('8998','2013-07-13','16:25:00',1.51),('8998','2013-07-13','16:30:00',1.22),('8998','2013-07-13','16:35:00',1.2),('8998','2013-07-13','16:40:00',1.38),('8998','2013-07-13','16:45:00',1.3),('8998','2013-07-13','16:50:00',1.33),('8998','2013-07-13','16:55:00',1.28),('8998','2013-07-13','17:00:00',1.14),('8998','2013-07-12','07:45:00',1.1),('8998','2013-07-12','07:50:00',1.13),('8998','2013-07-12','07:55:00',1.21),('8998','2013-07-12','08:00:00',1.2),('8998','2013-07-12','08:05:00',1.28),('8998','2013-07-12','08:10:00',1.37),('8998','2013-07-12','08:15:00',1.42),('8998','2013-07-12','08:20:00',1.49),('8998','2013-07-12','08:25:00',1.54),('8998','2013-07-12','08:30:00',1.56),('8998','2013-07-12','08:35:00',1.55),('8998','2013-07-12','08:40:00',1.58),('8998','2013-07-12','08:45:00',1.6),('8998','2013-07-12','08:50:00',1.69),('8998','2013-07-12','08:55:00',1.61),('8998','2013-07-12','09:00:00',1.89),('8998','2013-07-12','09:05:00',2.08),('8998','2013-07-12','09:10:00',2.13),('8998','2013-07-12','09:15:00',2.23),('8998','2013-07-12','09:20:00',2.29),('8998','2013-07-12','09:25:00',2.42),('8998','2013-07-12','09:30:00',2.45),('8998','2013-07-12','09:35:00',2.48),('8998','2013-07-12','09:40:00',2.5),('8998','2013-07-12','09:45:00',2.55),('8998','2013-07-12','09:50:00',2.6),('8998','2013-07-12','09:55:00',2.59),('8998','2013-07-12','10:00:00',2.57),('8998','2013-07-12','10:05:00',2.65),('8998','2013-07-12','10:10:00',2.68),('8998','2013-07-12','10:15:00',2.63),('8998','2013-07-12','10:20:00',2.71),('8998','2013-07-12','10:25:00',2.79),('8998','2013-07-12','10:30:00',2.85),('8998','2013-07-12','10:35:00',2.77),('8998','2013-07-12','10:40:00',2.69),('8998','2013-07-12','10:45:00',2.79),('8998','2013-07-12','10:50:00',2.58),('8998','2013-07-12','10:55:00',2.92),('8998','2013-07-12','11:00:00',2.83),('8998','2013-07-12','11:05:00',2.98),('8998','2013-07-12','11:10:00',3.06),('8998','2013-07-12','11:15:00',2.09),('8998','2013-07-12','11:20:00',1.09),('8998','2013-07-12','11:25:00',1.76),('8998','2013-07-12','11:30:00',2.93),('8998','2013-07-12','11:35:00',3.11),('8998','2013-07-12','11:40:00',2.36),('8998','2013-07-12','11:45:00',1.18),('8998','2013-07-12','11:50:00',2.97),('8998','2013-07-12','11:55:00',2.32),('8998','2013-07-12','12:00:00',2.13),('8998','2013-07-12','12:05:00',2.52),('8998','2013-07-12','12:10:00',3.01),('8998','2013-07-12','12:15:00',1.32),('8998','2013-07-12','12:20:00',1.31),('8998','2013-07-12','12:25:00',1.93),('8998','2013-07-12','12:35:00',3.16),('8998','2013-07-12','12:40:00',3.17),('8998','2013-07-12','12:45:00',1.81),('8998','2013-07-12','12:50:00',2.26),('8998','2013-07-12','12:55:00',3.03),('8998','2013-07-12','13:00:00',3.01),('8998','2013-07-12','13:05:00',3.05),('8998','2013-07-12','13:10:00',2.32),('8998','2013-07-12','13:15:00',2.45),('8998','2013-07-12','13:20:00',3.03),('8998','2013-07-12','13:25:00',2.94),('8998','2013-07-12','13:30:00',2.85),('8998','2013-07-12','13:35:00',2.83),('8998','2013-07-12','13:40:00',2.79),('8998','2013-07-12','13:45:00',2.74),('8998','2013-07-12','13:50:00',2.73),('8998','2013-07-12','13:55:00',2.69),('8998','2013-07-12','14:00:00',2.65),('8998','2013-07-12','14:05:00',2.64),('8998','2013-07-12','14:10:00',2.59),('8998','2013-07-12','14:15:00',2.57),('8998','2013-07-12','14:20:00',2.55),('8998','2013-07-12','14:25:00',2.51),('8998','2013-07-12','14:30:00',2.49),('8998','2013-07-12','14:35:00',2.46),('8998','2013-07-12','14:40:00',2.42),('8998','2013-07-12','14:45:00',2.39),('8998','2013-07-12','14:50:00',2.34),('8998','2013-07-12','14:55:00',2.32),('8998','2013-07-12','15:00:00',2.28),('8998','2013-07-12','15:05:00',2.26),('8998','2013-07-12','15:10:00',2.21),('8998','2013-07-12','15:15:00',2.17),('8998','2013-07-12','15:20:00',2.05),('8998','2013-07-12','15:25:00',2.11),('8998','2013-07-12','15:30:00',2.03),('8998','2013-07-12','15:35:00',2.01),('8998','2013-07-12','15:40:00',1.95),('8998','2013-07-12','15:45:00',1.9),('8998','2013-07-12','15:50:00',1.85),('8998','2013-07-12','15:55:00',1.8),('8998','2013-07-12','16:00:00',1.75),('8998','2013-07-12','16:05:00',1.7),('8998','2013-07-12','16:10:00',1.65),('8998','2013-07-12','16:15:00',1.57),('8998','2013-07-12','16:20:00',1.48),('8998','2013-07-12','16:25:00',1.49),('8998','2013-07-12','16:30:00',1.44),('8998','2013-07-12','16:35:00',1.39),('8998','2013-07-12','16:40:00',1.33),('8998','2013-07-12','16:45:00',1.27),('8998','2013-07-12','16:50:00',1.2),('8998','2013-07-12','16:55:00',1.14),('8998','2013-07-12','17:00:00',1.08),('8998','2013-07-12','17:05:00',1.01),('8998','2013-07-11','08:15:00',1.5),('8998','2013-07-11','08:20:00',1.87),('8998','2013-07-11','08:40:00',1),('8998','2013-07-11','08:45:00',1.19),('8998','2013-07-11','09:10:00',1.23),('8998','2013-07-11','09:15:00',1.47),('8998','2013-07-11','09:20:00',1.75),('8998','2013-07-11','09:25:00',2.28),('8998','2013-07-11','09:30:00',1.6),('8998','2013-07-11','09:35:00',1.42),('8998','2013-07-11','09:40:00',1.65),('8998','2013-07-11','09:45:00',2.58),('8998','2013-07-11','09:50:00',2.54),('8998','2013-07-11','09:55:00',2.6),('8998','2013-07-11','10:00:00',2.58),('8998','2013-07-11','10:05:00',2.6),('8998','2013-07-11','10:10:00',1.46),('8998','2013-07-11','10:15:00',2.28),('8998','2013-07-11','10:20:00',1.16),('8998','2013-07-11','10:25:00',1.07),('8998','2013-07-11','10:30:00',1.63),('8998','2013-07-11','10:35:00',1.68),('8998','2013-07-11','10:50:00',1.2),('8998','2013-07-11','10:55:00',1.58),('8998','2013-07-11','11:00:00',3.27),('8998','2013-07-11','11:05:00',1.52),('8998','2013-07-11','11:15:00',2.04),('8998','2013-07-11','11:25:00',2.82),('8998','2013-07-11','11:30:00',3.17),('8998','2013-07-11','11:35:00',3.1),('8998','2013-07-11','11:40:00',1.72),('8998','2013-07-11','11:45:00',2.53),('8998','2013-07-11','11:50:00',2.64),('8998','2013-07-11','11:55:00',2.81),('8998','2013-07-11','12:00:00',3.19),('8998','2013-07-11','12:05:00',1.87),('8998','2013-07-11','12:10:00',3.14),('8998','2013-07-11','12:15:00',1.66),('8998','2013-07-11','12:20:00',3.18),('8998','2013-07-11','12:25:00',2.04),('8998','2013-07-11','12:30:00',3.17),('8998','2013-07-11','12:35:00',2.84),('8998','2013-07-11','12:40:00',2.11),('8998','2013-07-11','12:45:00',2.62),('8998','2013-07-11','12:50:00',1.99),('8998','2013-07-11','12:55:00',3.1),('8998','2013-07-11','13:00:00',2.99),('8998','2013-07-11','13:05:00',2.99),('8998','2013-07-11','13:10:00',2.96),('8998','2013-07-11','13:15:00',2.96),('8998','2013-07-11','13:20:00',2.9),('8998','2013-07-11','13:25:00',2.86),('8998','2013-07-11','13:30:00',2.9),('8998','2013-07-11','13:35:00',2.86),('8998','2013-07-11','13:40:00',2.85),('8998','2013-07-11','13:45:00',2.81),('8998','2013-07-11','13:50:00',2.85),('8998','2013-07-11','13:55:00',2.78),('8998','2013-07-11','14:00:00',2.21),('8998','2013-07-11','14:05:00',2.32),('8998','2013-07-11','14:10:00',2.02),('8998','2013-07-11','14:15:00',2.56),('8998','2013-07-11','14:20:00',2.92),('8998','2013-07-11','14:25:00',2.8),('8998','2013-07-11','14:30:00',1.87),('8998','2013-07-11','14:35:00',2.13),('8998','2013-07-11','14:40:00',2.47),('8998','2013-07-11','14:45:00',2.41),('8998','2013-07-11','14:50:00',2.38),('8998','2013-07-11','14:55:00',2.34),('8998','2013-07-11','15:00:00',2.18),('8998','2013-07-11','15:05:00',2.25),('8998','2013-07-11','15:10:00',2.14),('8998','2013-07-11','15:15:00',1.79),('8998','2013-07-11','15:20:00',2.13),('8998','2013-07-11','15:25:00',2.08),('8998','2013-07-11','15:30:00',2.02),('8998','2013-07-11','15:35:00',1.67),('8998','2013-07-11','15:40:00',2),('8998','2013-07-11','15:45:00',1.66),('8998','2013-07-11','15:50:00',1.8),('8998','2013-07-11','15:55:00',1.77),('8998','2013-07-11','16:00:00',1.72),('8998','2013-07-11','16:05:00',1.66),('8998','2013-07-11','16:10:00',1.61),('8998','2013-07-11','16:15:00',1.54),('8998','2013-07-11','16:20:00',1.5),('8998','2013-07-11','16:25:00',1.46),('8998','2013-07-11','16:30:00',1.4),('8998','2013-07-11','16:35:00',1.34),('8998','2013-07-11','16:40:00',1.3),('8998','2013-07-11','16:45:00',1.25),('8998','2013-07-11','16:50:00',1.19),('8998','2013-07-11','16:55:00',1.14),('8998','2013-07-11','17:00:00',1.08),('8998','2013-07-11','17:05:00',1.03),('8998','2013-07-10','07:45:00',1.07),('8998','2013-07-10','07:50:00',1.12),('8998','2013-07-10','07:55:00',1.15),('8998','2013-07-10','08:00:00',1.22),('8998','2013-07-10','08:05:00',1.29),('8998','2013-07-10','08:10:00',1.34),('8998','2013-07-10','08:15:00',1.38),('8998','2013-07-10','08:20:00',1.45),('8998','2013-07-10','08:25:00',1.53),('8998','2013-07-10','08:30:00',1.6),('8998','2013-07-10','08:35:00',1.5),('8998','2013-07-10','08:40:00',1.6),('8998','2013-07-10','08:45:00',1.59),('8998','2013-07-10','08:50:00',1.64),('8998','2013-07-10','08:55:00',1.66),('8998','2013-07-10','09:00:00',1.82),('8998','2013-07-10','09:05:00',1.89),('8998','2013-07-10','09:10:00',1.9),('8998','2013-07-10','09:15:00',2.14),('8998','2013-07-10','09:20:00',2.2),('8998','2013-07-10','09:25:00',2.52),('8998','2013-07-10','09:30:00',2.55),('8998','2013-07-10','09:35:00',2.29),('8998','2013-07-10','09:40:00',2.19),('8998','2013-07-10','09:45:00',2.69),('8998','2013-07-10','09:50:00',2.15),('8998','2013-07-10','09:55:00',1.8),('8998','2013-07-10','10:00:00',2.05),('8998','2013-07-10','10:05:00',1.14),('8998','2013-07-10','10:10:00',1.15),('8998','2013-07-10','10:15:00',2.84),('8998','2013-07-10','10:20:00',2.78),('8998','2013-07-10','10:25:00',2.72),('8998','2013-07-10','10:30:00',2.96),('8998','2013-07-10','10:35:00',1.63),('8998','2013-07-10','10:45:00',2.24),('8998','2013-07-10','10:50:00',2.86),('8998','2013-07-10','10:55:00',3.04),('8998','2013-07-10','11:00:00',2.47),('8998','2013-07-10','11:05:00',2.21),('8998','2013-07-10','11:10:00',2.93),('8998','2013-07-10','11:15:00',2.02),('8998','2013-07-10','11:20:00',2.12),('8998','2013-07-10','11:25:00',1.93),('8998','2013-07-10','11:30:00',2.35),('8998','2013-07-10','11:35:00',2.11),('8998','2013-07-10','11:40:00',3.33),('8998','2013-07-10','11:45:00',3.1),('8998','2013-07-10','11:50:00',1.71),('8998','2013-07-10','11:55:00',1.41),('8998','2013-07-10','12:00:00',2.69),('8998','2013-07-10','12:15:00',1.3),('8998','2013-07-10','12:20:00',3.1),('8998','2013-07-10','12:25:00',3.14),('8998','2013-07-10','12:30:00',2.89),('8998','2013-07-10','12:35:00',3.11),('8998','2013-07-10','12:40:00',2.28),('8998','2013-07-10','12:45:00',1.67),('8998','2013-07-10','12:50:00',2.19),('8998','2013-07-10','12:55:00',2.65),('8998','2013-07-10','13:00:00',3.15),('8998','2013-07-10','13:05:00',2.74),('8998','2013-07-10','13:10:00',2.91),('8998','2013-07-10','13:15:00',3.03),('8998','2013-07-10','13:20:00',2.95),('8998','2013-07-10','13:25:00',2.92),('8998','2013-07-10','13:30:00',2.98),('8998','2013-07-10','13:35:00',2.81),('8998','2013-07-10','13:40:00',2.92),('8998','2013-07-10','13:45:00',2.61),('8998','2013-07-10','13:50:00',2.07),('8998','2013-07-10','13:55:00',2.15),('8998','2013-07-10','14:00:00',2.5),('8998','2013-07-10','14:05:00',2.48),('8998','2013-07-10','14:10:00',2.73),('8998','2013-07-10','14:15:00',2.71),('8998','2013-07-10','14:20:00',2.62),('8998','2013-07-10','14:25:00',2.36),('8998','2013-07-10','14:30:00',2.13),('8998','2013-07-10','14:35:00',2.55),('8998','2013-07-10','14:40:00',2.49),('8998','2013-07-10','14:45:00',2.46),('8998','2013-07-10','14:50:00',2.47),('8998','2013-07-10','14:55:00',1.76),('8998','2013-07-10','15:00:00',2.55),('8998','2013-07-10','15:05:00',1.28),('8998','2013-07-10','15:10:00',1.17),('8998','2013-07-10','15:15:00',2.31),('8998','2013-07-10','15:20:00',1.47),('8998','2013-07-10','15:25:00',1.6),('8998','2013-07-10','15:30:00',1.85),('8998','2013-07-10','15:35:00',2.19),('8998','2013-07-10','15:40:00',1.63),('8998','2013-07-10','15:45:00',1.79),('8998','2013-07-10','15:50:00',1.56),('8998','2013-07-10','15:55:00',1.25),('8998','2013-07-10','16:00:00',1.45),('8998','2013-07-10','16:05:00',1.51),('8998','2013-07-10','16:10:00',1.62),('8998','2013-07-10','16:15:00',1.29),('8998','2013-07-10','16:20:00',1.24),('8998','2013-07-10','16:25:00',1.28),('8998','2013-07-10','16:30:00',1.45),('8998','2013-07-10','16:40:00',1.5),('8998','2013-07-10','16:45:00',1.16),('8998','2013-07-10','16:50:00',1.34),('8998','2013-07-10','16:55:00',1.3),('8998','2013-07-10','17:00:00',1.14),('8998','2013-07-10','17:05:00',1),('8998','2014-05-02','07:40:00',1.28),('8998','2014-05-02','07:45:00',1.2),('8998','2014-05-02','07:50:00',1.23),('8998','2014-05-02','07:55:00',1.5),('8998','2014-05-02','08:00:00',1.47),('8998','2014-05-02','08:05:00',1.76),('8998','2014-05-02','08:10:00',1.88),('8998','2014-05-02','08:15:00',1.69),('8998','2014-05-02','08:20:00',1.19),('8998','2014-05-02','08:30:00',1.09),('8998','2014-05-02','08:40:00',1.15),('8998','2014-05-02','08:45:00',1.96),('8998','2014-05-02','08:50:00',2.34),('8998','2014-05-02','08:55:00',2.51),('8998','2014-05-02','09:00:00',2.76),('8998','2014-05-02','09:05:00',3.01),('8998','2014-05-02','09:10:00',1.87),('8998','2014-05-02','09:15:00',1.2),('8998','2014-05-02','09:20:00',2.13),('8998','2014-05-02','09:25:00',2.71),('8998','2014-05-02','09:30:00',1.65),('8998','2014-05-02','09:35:00',2.72),('8998','2014-05-02','09:40:00',1.57),('8998','2014-05-02','09:45:00',2.52),('8998','2014-05-02','09:50:00',1.39),('8998','2014-05-02','09:55:00',2.54),('8998','2014-05-02','10:00:00',3.08),('8998','2014-05-02','10:05:00',3.05),('8998','2014-05-02','10:10:00',3.08),('8998','2014-05-02','10:15:00',3.22),('8998','2014-05-02','10:20:00',2.41),('8998','2014-05-02','10:25:00',2.77),('8998','2014-05-02','10:30:00',1.89),('8998','2014-05-02','10:45:00',1.47),('8998','2014-05-02','10:55:00',1.58),('8998','2014-05-02','11:05:00',2.28),('8998','2014-05-02','11:10:00',3.83),('8998','2014-05-02','11:15:00',1.33),('8998','2014-05-02','11:20:00',2),('8998','2014-05-02','11:25:00',2.49),('8998','2014-05-02','11:30:00',3.45),('8998','2014-05-02','11:35:00',2.15),('8998','2014-05-02','11:40:00',2.05),('8998','2014-05-02','11:45:00',2),('8998','2014-05-02','11:50:00',1.7),('8998','2014-05-02','11:55:00',1.84),('8998','2014-05-02','12:00:00',1.62),('8998','2014-05-02','12:05:00',1.42),('8998','2014-05-02','12:10:00',1.31),('8998','2014-05-02','12:15:00',1.15),('8998','2014-05-02','12:20:00',1),('8998','2014-05-02','12:25:00',1.01),('8998','2014-05-02','12:30:00',1.24),('8998','2014-05-02','12:35:00',1.42),('8998','2014-05-02','12:40:00',1.27),('8998','2014-05-02','12:45:00',1.34),('8998','2014-05-02','12:50:00',1.44),('8998','2014-05-02','12:55:00',1.49),('8998','2014-05-02','13:00:00',1.47),('8998','2014-05-02','13:05:00',1.33),('8998','2014-05-02','13:10:00',1.97),('8998','2014-05-02','13:15:00',1.98),('8998','2014-05-02','13:20:00',1.74),('8998','2014-05-02','13:25:00',2.13),('8998','2014-05-02','13:30:00',2.04),('8998','2014-05-02','13:35:00',1.68),('8998','2014-05-02','13:40:00',1.27),('8998','2014-05-02','13:45:00',1.22),('8998','2014-05-02','13:50:00',1.21),('8998','2014-05-02','13:55:00',1.22),('8998','2014-05-02','14:00:00',1.2),('8998','2014-05-02','14:05:00',1.19),('8998','2014-05-02','14:10:00',1.29),('8998','2014-05-02','14:15:00',1.42),('8998','2014-05-02','14:20:00',1.59),('8998','2014-05-02','14:25:00',1.87),('8998','2014-05-02','14:30:00',1.6),('8998','2014-05-02','14:35:00',1.22),('8998','2014-05-02','14:40:00',1.12),('8998','2014-04-05','08:15:00',1.15),('8998','2014-04-05','08:20:00',1.44),('8998','2014-04-05','08:25:00',1.36),('8998','2014-04-05','08:30:00',1.29),('8998','2014-04-05','08:35:00',1.64),('8998','2014-04-05','08:40:00',1.81),('8998','2014-04-05','08:45:00',1.86),('8998','2014-04-05','08:50:00',1.77),('8998','2014-04-05','08:55:00',1.57),('8998','2014-04-05','09:00:00',1.75),('8998','2014-04-05','09:05:00',2.12),('8998','2014-04-05','09:10:00',2.37),('8998','2014-04-05','09:15:00',2.38),('8998','2014-04-05','09:20:00',2.09),('8998','2014-04-05','09:25:00',1.95),('8998','2014-04-05','09:30:00',1.56),('8998','2014-04-05','09:35:00',2.24),('8998','2014-04-05','09:40:00',2.29),('8998','2014-04-05','09:45:00',2.98),('8998','2014-04-05','09:50:00',3.1),('8998','2014-04-05','09:55:00',2.91),('8998','2014-04-05','10:00:00',2.22),('8998','2014-04-05','10:05:00',2.85),('8998','2014-04-05','10:10:00',2.89),('8998','2014-04-05','10:15:00',3.07),('8998','2014-04-05','10:20:00',2.35),('8998','2014-04-05','10:30:00',1),('8998','2014-04-05','10:35:00',1.11),('8998','2014-04-05','10:40:00',1.23),('8998','2014-04-05','10:45:00',2.41),('8998','2014-04-05','10:50:00',2.1),('8998','2014-04-05','10:55:00',1.42),('8998','2014-04-05','11:00:00',1.45),('8998','2014-04-05','11:05:00',1.38),('8998','2014-04-05','11:10:00',2.08),('8998','2014-04-05','11:15:00',2.89),('8998','2014-04-05','11:20:00',3.17),('8998','2014-04-05','11:25:00',3.13),('8998','2014-04-05','11:30:00',3.23),('8998','2014-04-05','11:35:00',3.41),('8998','2014-04-05','11:40:00',3.19),('8998','2014-04-05','11:45:00',3.21),('8998','2014-04-05','11:50:00',2.87),('8998','2014-04-05','11:55:00',3.05),('8998','2014-04-05','12:00:00',3.22),('8998','2014-04-05','12:05:00',3.06),('8998','2014-04-05','12:10:00',3.05),('8998','2014-04-05','12:15:00',3.06),('8998','2014-04-05','12:20:00',2.72),('8998','2014-04-05','12:25:00',2.34),('8998','2014-04-05','12:30:00',2.36),('8998','2014-04-05','12:35:00',2.21),('8998','2014-04-05','12:40:00',1.93),('8998','2014-04-05','12:45:00',2.29),('8998','2014-04-05','12:50:00',2.14),('8998','2014-04-05','12:55:00',3.1),('8998','2014-04-05','13:00:00',2.55),('8998','2014-04-05','13:05:00',2.31),('8998','2014-04-05','13:10:00',2.88),('8998','2014-04-05','13:15:00',2.67),('8998','2014-04-05','13:20:00',1.46),('8998','2014-04-05','13:30:00',3.04),('8998','2014-04-05','13:35:00',1.47),('8998','2014-04-05','13:40:00',2.07),('8998','2014-04-05','13:45:00',3.01),('8998','2014-04-05','13:50:00',2.77),('8998','2014-04-05','13:55:00',2.71),('8998','2014-04-05','14:00:00',2.63),('8998','2014-04-05','14:05:00',2.48),('8998','2014-04-05','14:10:00',2.62),('8998','2014-04-05','14:15:00',2.12),('8998','2014-04-05','14:20:00',2.23),('8998','2014-04-05','14:25:00',1.64),('8998','2014-04-05','14:40:00',2.38),('8998','2014-04-05','14:45:00',2.92),('8998','2014-04-05','14:50:00',2.41),('8998','2014-04-05','14:55:00',1.22),('8998','2014-04-05','15:10:00',1.81),('8998','2014-04-05','15:15:00',1.74),('8998','2014-04-05','15:50:00',1.04),('8998','2014-04-05','15:55:00',1.9),('8998','2014-04-05','16:00:00',1.36),('8998','2014-04-05','16:40:00',1.07),('8998','2014-04-05','16:45:00',1.23),('8998','2014-04-05','16:50:00',1.09),('8998','2013-07-09','07:25:00',1.12),('8998','2013-07-09','07:30:00',1.18),('8998','2013-07-09','07:35:00',1.13),('8998','2013-07-09','07:40:00',1.14),('8998','2013-07-09','07:45:00',1.37),('8998','2013-07-09','07:50:00',1.57),('8998','2013-07-09','07:55:00',1.68),('8998','2013-07-09','08:00:00',1.76),('8998','2013-07-09','08:05:00',1.54),('8998','2013-07-09','08:10:00',1.41),('8998','2013-07-09','08:15:00',1.49),('8998','2013-07-09','08:20:00',1.58),('8998','2013-07-09','08:25:00',2),('8998','2013-07-09','08:30:00',1.91),('8998','2013-07-09','08:35:00',2),('8998','2013-07-09','08:40:00',2.11),('8998','2013-07-09','08:45:00',1.82),('8998','2013-07-09','08:50:00',1.82),('8998','2013-07-09','08:55:00',1.73),('8998','2013-07-09','09:00:00',1.85),('8998','2013-07-09','09:05:00',1.96),('8998','2013-07-09','09:10:00',2.07),('8998','2013-07-09','09:15:00',2.32),('8998','2013-07-09','09:20:00',2.48),('8998','2013-07-09','09:25:00',2.55),('8998','2013-07-09','09:30:00',2.6),('8998','2013-07-09','09:35:00',2.59),('8998','2013-07-09','09:40:00',2.59),('8998','2013-07-09','09:45:00',2.61),('8998','2013-07-09','09:50:00',2.63),('8998','2013-07-09','09:55:00',2.71),('8998','2013-07-09','10:00:00',2.56),('8998','2013-07-09','10:05:00',2.72),('8998','2013-07-09','10:10:00',2.73),('8998','2013-07-09','10:15:00',2.74),('8998','2013-07-09','10:20:00',2.77),('8998','2013-07-09','10:25:00',2.81),('8998','2013-07-09','10:30:00',2.81),('8998','2013-07-09','10:35:00',2.83),('8998','2013-07-09','10:40:00',2.84),('8998','2013-07-09','10:45:00',2.86),('8998','2013-07-09','10:50:00',2.84),('8998','2013-07-09','10:55:00',2.84),('8998','2013-07-09','11:00:00',2.89),('8998','2013-07-09','11:05:00',2.92),('8998','2013-07-09','11:10:00',2.91),('8998','2013-07-09','11:15:00',2.91),('8998','2013-07-09','11:20:00',2.92),('8998','2013-07-09','11:25:00',2.92),('8998','2013-07-09','11:30:00',2.9),('8998','2013-07-09','11:35:00',2.87),('8998','2013-07-09','11:40:00',2.83),('8998','2013-07-09','11:45:00',2.87),('8998','2013-07-09','11:50:00',2.91),('8998','2013-07-09','11:55:00',2.94),('8998','2013-07-09','12:00:00',2.91),('8998','2013-07-09','12:05:00',2.92),('8998','2013-07-09','12:10:00',2.91),('8998','2013-07-09','12:15:00',2.92),('8998','2013-07-09','12:20:00',2.94),('8998','2013-07-09','12:25:00',2.97),('8998','2013-07-09','12:30:00',2.97),('8998','2013-07-09','12:35:00',2.92),('8998','2013-07-09','12:40:00',2.88),('8998','2013-07-09','12:45:00',2.9),('8998','2013-07-09','12:50:00',2.9),('8998','2013-07-09','12:55:00',2.88),('8998','2013-07-09','13:00:00',2.86),('8998','2013-07-09','13:05:00',2.88),('8998','2013-07-09','13:10:00',2.88),('8998','2013-07-09','13:15:00',2.83),('8998','2013-07-09','13:20:00',2.8),('8998','2013-07-09','13:25:00',2.8),('8998','2013-07-09','13:30:00',2.78),('8998','2013-07-09','13:35:00',2.76),('8998','2013-07-09','13:40:00',2.74),('8998','2013-07-09','13:45:00',2.73),('8998','2013-07-09','13:50:00',2.72),('8998','2013-07-09','13:55:00',2.67),('8998','2013-07-09','14:00:00',2.66),('8998','2013-07-09','14:05:00',2.64),('8998','2013-07-09','14:10:00',2.61),('8998','2013-07-09','14:15:00',2.59),('8998','2013-07-09','14:20:00',2.55),('8998','2013-07-09','14:25:00',2.51),('8998','2013-07-09','14:30:00',2.47),('8998','2013-07-09','14:35:00',2.46),('8998','2013-07-09','14:40:00',2.43),('8998','2013-07-09','14:45:00',2.4),('8998','2013-07-09','14:50:00',2.36),('8998','2013-07-09','14:55:00',2.33),('8998','2013-07-09','15:00:00',2.29),('8998','2013-07-09','15:05:00',2.26),('8998','2013-07-09','15:10:00',2.22),('8998','2013-07-09','15:15:00',2.18),('8998','2013-07-09','15:20:00',2.14),('8998','2013-07-09','15:25:00',2.1),('8998','2013-07-09','15:30:00',2.06),('8998','2013-07-09','15:35:00',2.02),('8998','2013-07-09','15:40:00',1.96),('8998','2013-07-09','15:45:00',1.9),('8998','2013-07-09','15:50:00',1.85),('8998','2013-07-09','15:55:00',1.81),('8998','2013-07-09','16:00:00',1.77),('8998','2013-07-09','16:05:00',1.72),('8998','2013-07-09','16:10:00',1.66),('8998','2013-07-09','16:15:00',1.58),('8998','2013-07-09','16:20:00',1.55),('8998','2013-07-09','16:25:00',1.49),('8998','2013-07-09','16:30:00',1.43),('8998','2013-07-09','16:35:00',1.39),('8998','2013-07-09','16:40:00',1.33),('8998','2013-07-09','16:45:00',1.29),('8998','2013-07-09','16:50:00',1.24),('8998','2013-07-09','16:55:00',1.22),('8998','2013-07-09','17:00:00',1.22),('8998','2013-07-09','17:05:00',1.11),('8998','2013-07-08','07:35:00',1.05),('8998','2013-07-08','07:40:00',1.07),('8998','2013-07-08','07:45:00',1.08),('8998','2013-07-08','07:50:00',1.15),('8998','2013-07-08','07:55:00',1.16),('8998','2013-07-08','08:00:00',1.22),('8998','2013-07-08','08:05:00',1.29),('8998','2013-07-08','08:10:00',1.34),('8998','2013-07-08','08:15:00',1.4),('8998','2013-07-08','08:20:00',1.44),('8998','2013-07-08','08:25:00',1.52),('8998','2013-07-08','08:30:00',1.6),('8998','2013-07-08','08:35:00',1.48),('8998','2013-07-08','08:40:00',1.63),('8998','2013-07-08','08:45:00',1.55),('8998','2013-07-08','08:50:00',1.62),('8998','2013-07-08','08:55:00',1.66),('8998','2013-07-08','09:00:00',1.81),('8998','2013-07-08','09:05:00',1.85),('8998','2013-07-08','09:10:00',1.95),('8998','2013-07-08','09:15:00',2.18),('8998','2013-07-08','09:20:00',2.35),('8998','2013-07-08','09:25:00',2.44),('8998','2013-07-08','09:30:00',2.49),('8998','2013-07-08','09:35:00',2.52),('8998','2013-07-08','09:40:00',2.56),('8998','2013-07-08','09:45:00',2.6),('8998','2013-07-08','09:50:00',2.61),('8998','2013-07-08','09:55:00',2.64),('8998','2013-07-08','10:00:00',2.65),('8998','2013-07-08','10:05:00',2.68),('8998','2013-07-08','10:10:00',2.72),('8998','2013-07-08','10:15:00',2.73),('8998','2013-07-08','10:20:00',2.76),('8998','2013-07-08','10:25:00',2.79),('8998','2013-07-08','10:30:00',2.78),('8998','2013-07-08','10:35:00',2.79),('8998','2013-07-08','10:40:00',2.8),('8998','2013-07-08','10:45:00',2.82),('8998','2013-07-08','10:50:00',2.84),('8998','2013-07-08','10:55:00',2.89),('8998','2013-07-08','11:00:00',2.92),('8998','2013-07-08','11:05:00',2.77),('8998','2013-07-08','11:10:00',2.58),('8998','2013-07-08','11:15:00',2.44),('8998','2013-07-08','11:20:00',2.52),('8998','2013-07-08','11:25:00',2.55),('8998','2013-07-08','11:30:00',1.68),('8998','2013-07-08','11:35:00',1.94),('8998','2013-07-08','11:40:00',2.04),('8998','2013-07-08','11:45:00',2.94),('8998','2013-07-08','11:50:00',3.47),('8998','2013-07-08','11:55:00',3.4),('8998','2013-07-08','12:00:00',3.37),('8998','2013-07-08','12:05:00',3.12),('8998','2013-07-08','12:10:00',2.38),('8998','2013-07-08','12:15:00',3.02),('8998','2013-07-08','12:20:00',2.95),('8998','2013-07-08','12:25:00',2.89),('8998','2013-07-08','12:30:00',2.84),('8998','2013-07-08','12:35:00',2.86),('8998','2013-07-08','12:40:00',2.85),('8998','2013-07-08','12:45:00',2.81),('8998','2013-07-08','12:50:00',2.83),('8998','2013-07-08','12:55:00',2.85),('8998','2013-07-08','13:00:00',2.82),('8998','2013-07-08','13:05:00',2.64),('8998','2013-07-08','13:10:00',2.87),('8998','2013-07-08','13:15:00',2.93),('8998','2013-07-08','13:20:00',2.89),('8998','2013-07-08','13:25:00',2.91),('8998','2013-07-08','13:30:00',2.96),('8998','2013-07-08','13:35:00',2.78),('8998','2013-07-08','13:40:00',2.73),('8998','2013-07-08','13:45:00',2.27),('8998','2013-07-08','13:50:00',2.12),('8998','2013-07-08','13:55:00',2.12),('8998','2013-07-08','14:00:00',2.08),('8998','2013-07-08','14:05:00',2.07),('8998','2013-07-08','14:10:00',2.28),('8998','2013-07-08','14:15:00',2.28),('8998','2013-07-08','14:20:00',1.73),('8998','2013-07-08','14:25:00',1.35),('8998','2013-07-07','07:40:00',1.17),('8998','2013-07-07','07:45:00',1.1),('8998','2013-07-07','07:50:00',1.06),('8998','2013-07-07','07:55:00',1.05),('8998','2013-07-07','08:00:00',1.07),('8998','2013-07-07','08:05:00',1.1),('8998','2013-07-07','08:10:00',1.27),('8998','2013-07-07','08:15:00',1.37),('8998','2013-07-07','08:20:00',1.44),('8998','2013-07-07','08:25:00',1.56),('8998','2013-07-07','08:30:00',1.65),('8998','2013-07-07','08:35:00',1.52),('8998','2013-07-07','08:40:00',1.67),('8998','2013-07-07','08:45:00',1.57),('8998','2013-07-07','08:50:00',1.63),('8998','2013-07-07','08:55:00',1.7),('8998','2013-07-07','09:00:00',1.82),('8998','2013-07-07','09:05:00',1.87),('8998','2013-07-07','09:10:00',1.97),('8998','2013-07-07','09:15:00',2.19),('8998','2013-07-07','09:20:00',2.35),('8998','2013-07-07','09:25:00',2.4),('8998','2013-07-07','09:30:00',2.49),('8998','2013-07-07','09:35:00',2.59),('8998','2013-07-07','09:40:00',2.6),('8998','2013-07-07','09:45:00',2.59),('8998','2013-07-07','09:50:00',2.58),('8998','2013-07-07','09:55:00',2.66),('8998','2013-07-07','10:00:00',2.69),('8998','2013-07-07','10:05:00',2.71),('8998','2013-07-07','10:10:00',2.68),('8998','2013-07-07','10:15:00',2.73),('8998','2013-07-07','10:20:00',2.75),('8998','2013-07-07','10:25:00',2.78),('8998','2013-07-07','10:30:00',2.71),('8998','2013-07-07','10:35:00',2.82),('8998','2013-07-07','10:40:00',2.81),('8998','2013-07-07','10:45:00',2.8),('8998','2013-07-07','10:50:00',2.81),('8998','2013-07-07','10:55:00',2.8),('8998','2013-07-07','11:00:00',2.82),('8998','2013-07-07','11:05:00',2.85),('8998','2013-07-07','11:10:00',2.89),('8998','2013-07-07','11:15:00',2.93),('8998','2013-07-07','11:20:00',2.98),('8998','2013-07-07','11:25:00',2.99),('8998','2013-07-07','11:30:00',3.03),('8998','2013-07-07','11:35:00',3.01),('8998','2013-07-07','11:40:00',2.8),('8998','2013-07-07','11:45:00',3),('8998','2013-07-07','11:50:00',2.98),('8998','2013-07-07','11:55:00',2.95),('8998','2013-07-07','12:00:00',2.94),('8998','2013-07-07','12:05:00',2.98),('8998','2013-07-07','12:10:00',3.03),('8998','2013-07-07','12:15:00',3.04),('8998','2013-07-07','12:20:00',3.13),('8998','2013-07-07','12:25:00',2.99),('8998','2013-07-07','12:30:00',2.84),('8998','2013-07-07','12:35:00',2.98),('8998','2013-07-07','12:40:00',2.96),('8998','2013-07-07','12:45:00',2.97),('8998','2013-07-07','12:50:00',2.97),('8998','2013-07-07','12:55:00',3.02),('8998','2013-07-07','13:00:00',2.8),('8998','2013-07-07','13:05:00',3.15),('8998','2013-07-07','13:10:00',3.34),('8998','2013-07-07','13:15:00',2.61),('8998','2013-07-07','13:20:00',1.7),('8998','2013-07-06','07:30:00',1.03),('8998','2013-07-06','07:35:00',1.22),('8998','2013-07-06','07:40:00',1.14),('8998','2013-07-06','07:45:00',1.29),('8998','2013-07-06','07:50:00',1.32),('8998','2013-07-06','07:55:00',1.3),('8998','2013-07-06','08:00:00',1.3),('8998','2013-07-06','08:05:00',1.38),('8998','2013-07-06','08:10:00',1.42),('8998','2013-07-06','08:15:00',1.48),('8998','2013-07-06','08:20:00',1.45),('8998','2013-07-06','08:25:00',1.39),('8998','2013-07-06','08:30:00',1.69),('8998','2013-07-06','08:35:00',1.48),('8998','2013-07-06','08:50:00',1.9),('8998','2013-07-06','08:55:00',2.06),('8998','2013-07-06','09:00:00',1.93),('8998','2013-07-06','09:05:00',1.77),('8998','2013-07-06','09:10:00',1.86),('8998','2013-07-06','09:15:00',1.92),('8998','2013-07-06','09:20:00',1.58),('8998','2013-07-06','09:25:00',2.1),('8998','2013-07-06','09:30:00',2.5),('8998','2013-07-06','09:35:00',2.58),('8998','2013-07-06','09:40:00',2.36),('8998','2013-07-06','09:45:00',2.83),('8998','2013-07-06','09:50:00',2.81),('8998','2013-07-06','09:55:00',2.84),('8998','2013-07-06','10:00:00',2.82),('8998','2013-07-06','10:05:00',2.66),('8998','2013-07-06','10:10:00',2.77),('8998','2013-07-06','10:15:00',2.56),('8998','2013-07-06','10:20:00',2.77),('8998','2013-07-06','10:25:00',2.66),('8998','2013-07-06','10:30:00',2.61),('8998','2013-07-06','10:35:00',3),('8998','2013-07-06','10:40:00',2.72),('8998','2013-07-06','10:45:00',2.97),('8998','2013-07-06','10:50:00',2.98),('8998','2013-07-06','10:55:00',2.96),('8998','2013-07-06','11:00:00',2.96),('8998','2013-07-06','11:05:00',2.99),('8998','2013-07-06','11:10:00',3.02),('8998','2013-07-06','11:15:00',2.89),('8998','2013-07-06','11:20:00',2.82),('8998','2013-07-06','11:25:00',2.54),('8998','2013-07-06','11:30:00',2.64),('8998','2013-07-06','11:35:00',2.59),('8998','2013-07-06','11:40:00',2.57),('8998','2013-07-06','11:45:00',2.18),('8998','2013-07-06','11:50:00',2.04),('8998','2013-07-06','11:55:00',1.51),('8998','2013-07-06','12:00:00',2.26),('8998','2013-07-06','12:05:00',2.88),('8998','2013-07-06','12:10:00',2.88),('8998','2013-07-06','12:15:00',3.07),('8998','2013-07-06','12:20:00',2.94),('8998','2013-07-06','12:25:00',2.75),('8998','2013-07-06','12:30:00',2.79),('8998','2013-07-06','12:35:00',2.96),('8998','2013-07-06','12:40:00',3.02),('8998','2013-07-06','12:45:00',2.98),('8998','2013-07-06','12:50:00',2.91),('8998','2013-07-06','12:55:00',3.03),('8998','2013-07-06','13:00:00',2.96),('8998','2013-07-06','13:05:00',2.94),('8998','2013-07-06','13:10:00',2.94),('8998','2013-07-06','13:15:00',2.89),('8998','2013-07-06','13:20:00',2.88),('8998','2013-07-06','13:25:00',2.79),('8998','2013-07-06','13:30:00',2.69),('8998','2013-07-06','13:35:00',2.92),('8998','2013-07-06','13:40:00',1.97),('8998','2013-07-06','13:45:00',3.08),('8998','2013-07-06','13:50:00',3.05),('8998','2013-07-06','13:55:00',2.62),('8998','2013-07-06','14:00:00',2.35),('8998','2013-07-06','14:05:00',2.51),('8998','2013-07-06','14:10:00',1.51),('8998','2013-07-06','14:15:00',1.26),('8998','2013-07-05','07:35:00',1.11),('8998','2013-07-05','07:40:00',1.11),('8998','2013-07-05','07:45:00',1.21),('8998','2013-07-05','07:50:00',1.25),('8998','2013-07-05','07:55:00',1.26),('8998','2013-07-05','08:00:00',1.24),('8998','2013-07-05','08:05:00',1.33),('8998','2013-07-05','08:10:00',1.37),('8998','2013-07-05','08:15:00',1.63),('8998','2013-07-05','08:20:00',1.76),('8998','2013-07-05','08:25:00',1.64),('8998','2013-07-05','08:30:00',1.63),('8998','2013-07-05','08:35:00',1.49),('8998','2013-07-05','08:40:00',1.66),('8998','2013-07-05','08:45:00',1.57),('8998','2013-07-05','08:50:00',1.93),('8998','2013-07-05','08:55:00',1.88),('8998','2013-07-05','09:00:00',1.84),('8998','2013-07-05','09:05:00',1.87),('8998','2013-07-05','09:10:00',2.1),('8998','2013-07-05','09:15:00',2.29),('8998','2013-07-05','09:20:00',2.45),('8998','2013-07-05','09:25:00',2.51),('8998','2013-07-05','09:30:00',2.53),('8998','2013-07-05','09:35:00',2.55),('8998','2013-07-05','09:40:00',2.58),('8998','2013-07-05','09:45:00',2.61),('8998','2013-07-05','09:50:00',2.64),('8998','2013-07-05','09:55:00',2.69),('8998','2013-07-05','10:00:00',2.71),('8998','2013-07-05','10:05:00',2.75),('8998','2013-07-05','10:10:00',2.79),('8998','2013-07-05','10:15:00',2.8),('8998','2013-07-05','10:20:00',2.81),('8998','2013-07-05','10:25:00',2.83),('8998','2013-07-05','10:30:00',2.84),('8998','2013-07-05','10:35:00',2.84),('8998','2013-07-05','10:40:00',2.86),('8998','2013-07-05','10:45:00',2.89),('8998','2013-07-05','10:50:00',2.94),('8998','2013-07-05','10:55:00',2.96),('8998','2013-07-05','11:00:00',2.96),('8998','2013-07-05','11:05:00',2.98),('8998','2013-07-05','11:10:00',2.97),('8998','2013-07-05','11:15:00',2.94),('8998','2013-07-05','11:20:00',2.98),('8998','2013-07-05','11:25:00',3),('8998','2013-07-05','11:30:00',2.97),('8998','2013-07-05','11:35:00',2.96),('8998','2013-07-05','11:40:00',2.94),('8998','2013-07-05','11:45:00',2.96),('8998','2013-07-05','11:50:00',2.96),('8998','2013-07-05','11:55:00',2.94),('8998','2013-07-05','12:00:00',2.96),('8998','2013-07-05','12:05:00',2.96),('8998','2013-07-05','12:10:00',3),('8998','2013-07-05','12:15:00',2.99),('8998','2013-07-05','12:20:00',3.01),('8998','2013-07-05','12:25:00',2.95),('8998','2013-07-05','12:30:00',2.98),('8998','2013-07-05','12:35:00',2.95),('8998','2013-07-05','12:40:00',2.97),('8998','2013-07-05','12:45:00',2.96),('8998','2013-07-05','12:50:00',2.93),('8998','2013-07-05','12:55:00',2.94),('8998','2013-07-05','13:00:00',2.95),('8998','2013-07-05','13:05:00',2.95),('8998','2013-07-05','13:10:00',2.96),('8998','2013-07-05','13:15:00',2.95),('8998','2013-07-05','13:20:00',2.9),('8998','2013-07-05','13:25:00',2.86),('8998','2013-07-05','13:30:00',2.87),('8998','2013-07-05','13:35:00',2.8),('8998','2013-07-05','13:40:00',2.8),('8998','2013-07-05','13:45:00',2.78),('8998','2013-07-05','13:50:00',2.72),('8998','2013-07-05','13:55:00',2.71),('8998','2013-07-05','14:00:00',2.72),('8998','2013-07-05','14:05:00',2.69),('8998','2013-07-05','14:10:00',2.65),('8998','2013-07-05','14:15:00',2.47),('8998','2013-07-05','14:20:00',2.68),('8998','2013-07-05','14:25:00',2.59),('8998','2013-07-05','14:30:00',2.54),('8998','2013-07-05','14:35:00',2.54),('8998','2013-07-05','14:40:00',2.48),('8998','2013-07-05','14:45:00',2.45),('8998','2013-07-05','14:50:00',2.39),('8998','2013-07-05','14:55:00',2.07),('8998','2013-07-05','15:00:00',2.41),('8998','2013-07-05','15:05:00',2.33),('8998','2013-07-05','15:10:00',2.32),('8998','2013-07-05','15:15:00',2.27),('8998','2013-07-05','15:20:00',2.27),('8998','2013-07-05','15:25:00',2.24),('8998','2013-07-05','15:30:00',2),('8998','2013-07-04','07:45:00',1.22),('8998','2013-07-04','07:50:00',1.24),('8998','2013-07-04','07:55:00',1.24),('8998','2013-07-04','08:00:00',1.28),('8998','2013-07-04','08:05:00',1.35),('8998','2013-07-04','08:10:00',1.38),('8998','2013-07-04','08:15:00',1.63),('8998','2013-07-04','08:20:00',1.76),('8998','2013-07-04','08:25:00',1.64),('8998','2013-07-04','08:30:00',1.63),('8998','2013-07-04','08:35:00',1.52),('8998','2013-07-04','08:40:00',1.64),('8998','2013-07-04','08:45:00',1.58),('8998','2013-07-04','08:50:00',1.97),('8998','2013-07-04','08:55:00',1.89),('8998','2013-07-04','09:00:00',1.84),('8998','2013-07-04','09:05:00',1.87),('8998','2013-07-04','09:10:00',2.08),('8998','2013-07-04','09:15:00',2.25),('8998','2013-07-04','09:20:00',2.41),('8998','2013-07-04','09:25:00',2.48),('8998','2013-07-04','09:30:00',2.52),('8998','2013-07-04','09:35:00',2.57),('8998','2013-07-04','09:40:00',2.6),('8998','2013-07-04','09:45:00',2.61),('8998','2013-07-04','09:50:00',2.63),('8998','2013-07-04','09:55:00',2.65),('8998','2013-07-04','10:00:00',2.67),('8998','2013-07-04','10:05:00',2.7),('8998','2013-07-04','10:10:00',2.74),('8998','2013-07-04','10:15:00',2.77),('8998','2013-07-04','10:20:00',2.79),('8998','2013-07-04','10:25:00',2.8),('8998','2013-07-04','10:30:00',2.82),('8998','2013-07-04','10:35:00',2.83),('8998','2013-07-04','10:40:00',2.83),('8998','2013-07-04','10:45:00',2.84),('8998','2013-07-04','10:50:00',2.85),('8998','2013-07-04','10:55:00',2.87),('8998','2013-07-04','11:00:00',2.87),('8998','2013-07-04','11:05:00',2.88),('8998','2013-07-04','11:10:00',2.9),('8998','2013-07-04','11:15:00',2.9),('8998','2013-07-04','11:20:00',2.91),('8998','2013-07-04','11:25:00',2.93),('8998','2013-07-04','11:30:00',2.95),('8998','2013-07-04','11:35:00',2.95),('8998','2013-07-04','11:40:00',2.94),('8998','2013-07-04','11:45:00',2.92),('8998','2013-07-04','11:50:00',2.97),('8998','2013-07-04','11:55:00',2.94),('8998','2013-07-04','12:00:00',2.94),('8998','2013-07-04','12:05:00',2.94),('8998','2013-07-04','12:10:00',2.92),('8998','2013-07-04','12:15:00',2.95),('8998','2013-07-04','12:20:00',2.97),('8998','2013-07-04','12:25:00',1.85),('8998','2013-07-04','12:30:00',2.81),('8998','2013-07-04','12:35:00',2.13),('8998','2013-07-04','12:40:00',2.91),('8998','2013-07-04','12:45:00',3.01),('8998','2013-07-04','12:50:00',2.83),('8998','2013-07-04','12:55:00',2.63),('8998','2013-07-04','13:00:00',2.91),('8998','2013-07-04','13:05:00',1.9),('8998','2013-07-04','13:10:00',2.95),('8998','2013-07-04','13:15:00',2.65),('8998','2013-07-04','13:20:00',2.63),('8998','2013-07-04','13:25:00',2.78),('8998','2013-07-04','13:30:00',2.61),('8998','2013-07-04','13:35:00',2.84),('8998','2013-07-04','13:40:00',2.84),('8998','2013-07-04','13:45:00',2.78),('8998','2013-07-04','13:50:00',2.72),('8998','2013-07-04','13:55:00',2.76),('8998','2013-07-04','14:00:00',2.76),('8998','2013-07-04','14:05:00',2.42),('8998','2013-07-04','14:10:00',2.27),('8998','2013-07-04','14:15:00',2.64),('8998','2013-07-04','14:20:00',2.57),('8998','2013-07-04','14:25:00',2.59),('8998','2013-07-04','14:30:00',2.49),('8998','2013-07-04','14:35:00',2.3),('8998','2013-07-04','14:40:00',2.45),('8998','2013-07-04','14:45:00',2.04),('8998','2013-07-04','14:50:00',2.37),('8998','2013-07-04','14:55:00',2.31),('8998','2013-07-04','15:00:00',2.17),('8998','2013-07-04','15:05:00',2.28),('8998','2013-07-04','15:10:00',2.29),('8998','2013-07-04','15:15:00',1.88),('8998','2013-07-04','15:20:00',1.7),('8998','2013-07-04','15:25:00',1.62),('8998','2013-07-04','15:30:00',1.99),('8998','2013-07-04','15:35:00',2.07),('8998','2013-07-04','15:40:00',1.99),('8998','2013-07-04','15:45:00',1.99),('8998','2013-07-04','15:50:00',1.93),('8998','2013-07-04','15:55:00',1.83),('8998','2013-07-04','16:00:00',1.76),('8998','2013-07-04','16:05:00',1.74),('8998','2013-07-04','16:10:00',1.67),('8998','2013-07-04','16:15:00',1.61),('8998','2013-07-04','16:20:00',1.57),('8998','2013-07-04','16:25:00',1.51),('8998','2013-07-04','16:30:00',1.47),('8998','2013-07-04','16:35:00',1.4),('8998','2013-07-04','16:40:00',1.36),('8998','2013-07-04','16:45:00',1.32),('8998','2013-07-04','16:50:00',1.23),('8998','2013-07-04','16:55:00',1.11),('8998','2013-07-04','17:00:00',1.1),('8998','2013-07-04','17:05:00',1.09),('8998','2013-07-04','17:10:00',1.07),('8998','2013-07-04','17:15:00',1.04),('8998','2013-07-03','11:45:00',1.17),('8998','2013-07-03','11:50:00',1.26),('8998','2013-07-03','11:55:00',1.15),('8998','2013-07-03','12:00:00',1.11),('8998','2013-07-03','12:05:00',1.07),('8998','2013-07-03','12:10:00',1.51),('8998','2013-07-03','12:15:00',2.15),('8998','2013-07-03','12:20:00',1.9),('8998','2013-07-03','12:25:00',2.24),('8998','2013-07-03','12:30:00',2.19),('8998','2013-07-03','12:35:00',1.73),('8998','2013-07-03','12:40:00',1.27),('8998','2013-07-03','12:45:00',1.03),('8998','2013-07-03','13:15:00',1.03),('8998','2013-07-03','13:20:00',1.22),('8998','2013-07-03','13:25:00',1.42),('8998','2013-07-03','13:30:00',1.32),('8998','2013-07-03','13:35:00',1.4),('8998','2013-07-03','13:40:00',1.65),('8998','2013-07-03','13:45:00',1.52),('8998','2013-07-03','13:50:00',2.14),('8998','2013-07-03','13:55:00',1.86),('8998','2013-07-03','14:00:00',1.53),('8998','2013-07-03','14:05:00',1.49),('8998','2013-07-03','14:10:00',1.46),('8998','2013-07-03','14:15:00',1.49),('8998','2013-07-03','14:20:00',1.53),('8998','2013-07-03','14:25:00',1.31),('8998','2013-07-03','14:30:00',1.24),('8998','2013-07-03','14:35:00',1.27),('8998','2013-07-03','14:40:00',2.1),('8998','2013-07-03','14:45:00',3.21),('8998','2013-07-03','14:50:00',1.58),('8998','2013-07-03','14:55:00',1.59),('8998','2013-07-03','15:00:00',2.76),('8998','2013-07-03','15:05:00',2.38),('8998','2013-07-03','15:10:00',1.84),('8998','2013-07-03','15:15:00',2.68),('8998','2013-07-03','15:20:00',2.53),('8998','2013-07-03','15:25:00',2.47),('8998','2013-07-03','15:30:00',1.65),('8998','2013-07-03','15:35:00',1.83),('8998','2013-07-03','15:40:00',1.82),('8998','2013-07-03','15:45:00',1.84),('8998','2013-07-03','15:50:00',1.39),('8998','2013-07-03','15:55:00',1.41),('8998','2013-07-03','16:00:00',1.46),('8998','2013-07-03','16:05:00',1.3),('8998','2013-07-03','16:10:00',1.24),('8998','2013-07-03','16:15:00',1.16),('8998','2013-07-03','16:20:00',1.2),('8998','2013-07-03','16:25:00',1.24),('8998','2013-07-03','16:30:00',1.2),('8998','2013-07-03','16:35:00',1.19),('8998','2013-07-03','16:40:00',1),('8998','2013-07-03','16:50:00',1.01),('8998','2013-07-03','17:10:00',1.1),('8998','2013-07-03','17:15:00',1.22),('8998','2013-07-03','17:20:00',1.24),('8998','2013-07-03','17:25:00',1.12),('8998','2013-07-02','07:40:00',1.03),('8998','2013-07-02','07:45:00',1.3),('8998','2013-07-02','07:50:00',1.32),('8998','2013-07-02','07:55:00',1.3),('8998','2013-07-02','08:00:00',1.34),('8998','2013-07-02','08:05:00',1.37),('8998','2013-07-02','08:10:00',1.7),('8998','2013-07-02','08:15:00',1.9),('8998','2013-07-02','08:20:00',1.86),('8998','2013-07-02','08:25:00',1.7),('8998','2013-07-02','08:30:00',1.68),('8998','2013-07-02','08:35:00',1.67),('8998','2013-07-02','08:40:00',1.69),('8998','2013-07-02','08:45:00',1.72),('8998','2013-07-02','08:50:00',2.06),('8998','2013-07-02','08:55:00',1.98),('8998','2013-07-02','09:00:00',1.92),('8998','2013-07-02','09:05:00',1.91),('8998','2013-07-02','09:10:00',2.24),('8998','2013-07-02','09:15:00',2.36),('8998','2013-07-02','09:20:00',2.52),('8998','2013-07-02','09:25:00',2.56),('8998','2013-07-02','09:30:00',2.59),('8998','2013-07-02','09:35:00',2.58),('8998','2013-07-02','09:40:00',2.6),('8998','2013-07-02','09:45:00',2.66),('8998','2013-07-02','09:50:00',2.69),('8998','2013-07-02','09:55:00',2.7),('8998','2013-07-02','10:00:00',2.74),('8998','2013-07-02','10:05:00',2.75),('8998','2013-07-02','10:10:00',2.71),('8998','2013-07-02','10:15:00',2.72),('8998','2013-07-02','10:20:00',2.72),('8998','2013-07-02','10:25:00',2.79),('8998','2013-07-02','10:30:00',2.85),('8998','2013-07-02','10:35:00',2.82),('8998','2013-07-02','10:40:00',2.84),('8998','2013-07-02','10:45:00',2.88),('8998','2013-07-02','10:50:00',2.9),('8998','2013-07-02','10:55:00',2.9),('8998','2013-07-02','11:00:00',2.92),('8998','2013-07-02','11:05:00',2.93),('8998','2013-07-02','11:10:00',2.94),('8998','2013-07-02','11:15:00',2.97),('8998','2013-07-02','11:20:00',2.99),('8998','2013-07-02','11:25:00',3),('8998','2013-07-02','11:30:00',2.98),('8998','2013-07-02','11:35:00',2.96),('8998','2013-07-02','11:40:00',2.94),('8998','2013-07-02','11:45:00',3.01),('8998','2013-07-02','11:50:00',3.03),('8998','2013-07-02','11:55:00',3.02),('8998','2013-07-02','12:00:00',3.03),('8998','2013-07-02','12:05:00',3.06),('8998','2013-07-02','12:10:00',2.99),('8998','2013-07-02','12:15:00',3.03),('8998','2013-07-02','12:20:00',3.02),('8998','2013-07-02','12:25:00',3),('8998','2013-07-02','12:30:00',2.99),('8998','2013-07-02','12:35:00',3),('8998','2013-07-02','12:40:00',2.98),('8998','2013-07-02','12:45:00',2.93),('8998','2013-07-02','12:50:00',2.94),('8998','2013-07-02','12:55:00',2.93),('8998','2013-07-02','13:00:00',2.94),('8998','2013-07-02','13:05:00',2.93),('8998','2013-07-02','13:10:00',2.92),('8998','2013-07-02','13:15:00',2.9),('8998','2013-07-02','13:20:00',2.89),('8998','2013-07-02','13:25:00',2.84),('8998','2013-07-02','13:30:00',2.83),('8998','2013-07-02','13:35:00',2.8),('8998','2013-07-02','13:40:00',2.79),('8998','2013-07-02','13:45:00',2.78),('8998','2013-07-02','13:50:00',2.75),('8998','2013-07-02','13:55:00',2.72),('8998','2013-07-02','14:00:00',2.69),('8998','2013-07-02','14:05:00',2.66),('8998','2013-07-02','14:10:00',2.63),('8998','2013-07-02','14:15:00',2.6),('8998','2013-07-02','14:20:00',2.59),('8998','2013-07-02','14:25:00',2.56),('8998','2013-07-02','14:30:00',2.54),('8998','2013-07-02','14:35:00',2.5),('8998','2013-07-02','14:40:00',2.45),('8998','2013-07-02','14:45:00',2.42),('8998','2013-07-02','14:50:00',2.39),('8998','2013-07-02','14:55:00',2.35),('8998','2013-07-02','15:00:00',2.32),('8998','2013-07-02','15:05:00',2.29),('8998','2013-07-02','15:10:00',2.24),('8998','2013-07-02','15:15:00',2.21),('8998','2013-07-02','15:20:00',2.16),('8998','2013-07-02','15:25:00',2.12),('8998','2013-07-02','15:30:00',2.07),('8998','2013-07-02','15:35:00',2.02),('8998','2013-07-02','15:40:00',1.98),('8998','2013-07-02','15:45:00',1.93),('8998','2013-07-02','15:50:00',1.88),('8998','2013-07-02','15:55:00',1.83),('8998','2013-07-02','16:00:00',1.77),('8998','2013-07-02','16:05:00',1.72),('8998','2013-07-02','16:10:00',1.67),('8998','2013-07-02','16:15:00',1.62),('8998','2013-07-02','16:20:00',1.56),('8998','2013-07-02','16:25:00',1.5),('8998','2013-07-02','16:30:00',1.45),('8998','2013-07-02','16:35:00',1.4),('8998','2013-07-02','16:40:00',1.34),('8998','2013-07-02','16:45:00',1.29),('8998','2013-07-02','16:50:00',1.23),('8998','2013-07-02','16:55:00',1.17),('8998','2013-07-02','17:00:00',1.11),('8998','2013-07-02','17:05:00',1.06),('8998','2013-07-02','17:10:00',1),('8998','2013-07-01','07:30:00',1.03),('8998','2013-07-01','07:35:00',1.18),('8998','2013-07-01','07:40:00',1.15),('8998','2013-07-01','07:45:00',1.28),('8998','2013-07-01','07:50:00',1.29),('8998','2013-07-01','07:55:00',1.28),('8998','2013-07-01','08:00:00',1.32),('8998','2013-07-01','08:05:00',1.34),('8998','2013-07-01','08:10:00',1.38),('8998','2013-07-01','08:15:00',1.45),('8998','2013-07-01','08:20:00',1.89),('8998','2013-07-01','08:25:00',1.95),('8998','2013-07-01','08:30:00',1.99),('8998','2013-07-01','08:35:00',2.02),('8998','2013-07-01','08:40:00',2.11),('8998','2013-07-01','08:45:00',2.1),('8998','2013-07-01','08:50:00',2.03),('8998','2013-07-01','08:55:00',1.96),('8998','2013-07-01','09:00:00',1.91),('8998','2013-07-01','09:05:00',1.91),('8998','2013-07-01','09:10:00',2.24),('8998','2013-07-01','09:15:00',2.4),('8998','2013-07-01','09:20:00',2.52),('8998','2013-07-01','09:25:00',2.55),('8998','2013-07-01','09:30:00',2.59),('8998','2013-07-01','09:35:00',2.6),('8998','2013-07-01','09:40:00',2.62),('8998','2013-07-01','09:45:00',2.65),('8998','2013-07-01','09:50:00',2.67),('8998','2013-07-01','09:55:00',2.7),('8998','2013-07-01','10:00:00',2.73),('8998','2013-07-01','10:05:00',2.75),('8998','2013-07-01','10:10:00',2.75),('8998','2013-07-01','10:15:00',2.76),('8998','2013-07-01','10:20:00',2.78),('8998','2013-07-01','10:25:00',2.79),('8998','2013-07-01','10:30:00',2.82),('8998','2013-07-01','10:35:00',2.84),('8998','2013-07-01','10:40:00',2.85),('8998','2013-07-01','10:45:00',2.87),('8998','2013-07-01','10:50:00',2.87),('8998','2013-07-01','10:55:00',2.86),('8998','2013-07-01','11:00:00',2.88),('8998','2013-07-01','11:05:00',2.87),('8998','2013-07-01','11:10:00',2.86),('8998','2013-07-01','11:15:00',2.86),('8998','2013-07-01','11:20:00',2.86),('8998','2013-07-01','11:25:00',2.87),('8998','2013-07-01','11:30:00',2.89),('8998','2013-07-01','11:35:00',2.93),('8998','2013-07-01','11:40:00',2.92),('8998','2013-07-01','11:45:00',2.87),('8998','2013-07-01','11:50:00',2.86),('8998','2013-07-01','11:55:00',2.88),('8998','2013-07-01','12:00:00',2.86),('8998','2013-07-01','12:05:00',2.81),('8998','2013-07-01','12:10:00',2.91),('8998','2013-07-01','12:15:00',2.88),('8998','2013-07-01','12:20:00',2.84),('8998','2013-07-01','12:25:00',2.75),('8998','2013-07-01','12:30:00',2.86),('8998','2013-07-01','12:35:00',2.92),('8998','2013-07-01','12:40:00',2.94),('8998','2013-07-01','12:45:00',2.94),('8998','2013-07-01','12:50:00',2.95),('8998','2013-07-01','12:55:00',1.32),('8998','2013-07-01','13:00:00',2.43),('8998','2013-07-01','13:10:00',2.91),('8998','2013-07-01','13:15:00',3.02),('8998','2013-07-01','13:20:00',2.97),('8998','2013-07-01','13:25:00',3),('8998','2013-07-01','13:30:00',2.93),('8998','2013-07-01','13:35:00',2.86),('8998','2013-07-01','13:40:00',2.84),('8998','2013-07-01','13:45:00',2.65),('8998','2013-07-01','13:50:00',2.58),('8998','2013-07-01','13:55:00',2.61),('8998','2013-07-01','14:00:00',2.59),('8998','2013-07-01','14:05:00',2.57),('8998','2013-07-01','14:10:00',2.54),('8998','2013-07-01','14:15:00',2.54),('8998','2013-07-01','14:20:00',2.53),('8998','2013-07-01','14:25:00',2.49),('8998','2013-07-01','14:30:00',2.45),('8998','2013-07-01','14:35:00',2.44),('8998','2013-07-01','14:40:00',2.4),('8998','2013-07-01','14:45:00',2.36),('8998','2013-07-01','14:50:00',2.33),('8998','2013-07-01','14:55:00',2.29),('8998','2013-07-01','15:00:00',2.24),('8998','2013-07-01','15:05:00',2.22),('8998','2013-07-01','15:10:00',2.19),('8998','2013-07-01','15:15:00',2.14),('8998','2013-07-01','15:20:00',2.1),('8998','2013-07-01','15:25:00',2.06),('8998','2013-07-01','15:30:00',2.02),('8998','2013-07-01','15:35:00',1.98),('8998','2013-07-01','15:40:00',1.94),('8998','2013-07-01','15:45:00',1.88),('8998','2013-07-01','15:50:00',1.83),('8998','2013-07-01','15:55:00',1.78),('8998','2013-07-01','16:00:00',1.74),('8998','2013-07-01','16:05:00',1.7),('8998','2013-07-01','16:10:00',1.64),('8998','2013-07-01','16:15:00',1.58),('8998','2013-07-01','16:20:00',1.53),('8998','2013-07-01','16:25:00',1.47),('8998','2013-07-01','16:30:00',1.42),('8998','2013-07-01','16:35:00',1.36),('8998','2013-07-01','16:40:00',1.31),('8998','2013-07-01','16:45:00',1.25),('8998','2013-07-01','16:50:00',1.2),('8998','2013-07-01','16:55:00',1.15),('8998','2013-07-01','17:00:00',1.11),('8998','2013-07-01','17:05:00',1.05),('8998','2013-06-30','07:40:00',1.1),('8998','2013-06-30','07:45:00',1.28),('8998','2013-06-30','07:50:00',1.3),('8998','2013-06-30','07:55:00',1.31),('8998','2013-06-30','08:00:00',1.38),('8998','2013-06-30','08:05:00',1.38),('8998','2013-06-30','08:10:00',1.42),('8998','2013-06-30','08:15:00',1.64),('8998','2013-06-30','08:20:00',1.84),('8998','2013-06-30','08:25:00',1.72),('8998','2013-06-30','08:30:00',1.7),('8998','2013-06-30','08:35:00',1.69),('8998','2013-06-30','08:40:00',1.7),('8998','2013-06-30','08:45:00',1.75),('8998','2013-06-30','08:50:00',2.08),('8998','2013-06-30','08:55:00',2.03),('8998','2013-06-30','09:00:00',1.98),('8998','2013-06-30','09:05:00',2.01),('8998','2013-06-30','09:10:00',2.3),('8998','2013-06-30','09:15:00',2.43),('8998','2013-06-30','09:20:00',2.58),('8998','2013-06-30','09:25:00',2.61),('8998','2013-06-30','09:30:00',2.66),('8998','2013-06-30','09:35:00',2.68),('8998','2013-06-30','09:40:00',2.7),('8998','2013-06-30','09:45:00',2.72),('8998','2013-06-30','09:50:00',2.75),('8998','2013-06-30','09:55:00',2.76),('8998','2013-06-30','10:00:00',2.78),('8998','2013-06-30','10:05:00',2.8),('8998','2013-06-30','10:10:00',2.84),('8998','2013-06-30','10:15:00',2.88),('8998','2013-06-30','10:20:00',2.88),('8998','2013-06-30','10:25:00',2.91),('8998','2013-06-30','10:30:00',2.92),('8998','2013-06-30','10:35:00',2.93),('8998','2013-06-30','10:40:00',2.99),('8998','2013-06-30','10:45:00',3),('8998','2013-06-30','10:50:00',2.99),('8998','2013-06-30','10:55:00',2.99),('8998','2013-06-30','11:00:00',3.02),('8998','2013-06-30','11:05:00',3.04),('8998','2013-06-30','11:10:00',3.07),('8998','2013-06-30','11:15:00',3.07),('8998','2013-06-30','11:20:00',3.07),('8998','2013-06-30','11:25:00',3.07),('8998','2013-06-30','11:30:00',3.08),('8998','2013-06-30','11:35:00',3.06),('8998','2013-06-30','11:40:00',3.05),('8998','2013-06-30','11:45:00',3.04),('8998','2013-06-30','11:50:00',3.04),('8998','2013-06-30','11:55:00',3.05),('8998','2013-06-30','12:00:00',3.04),('8998','2013-06-30','12:05:00',3.03),('8998','2013-06-30','12:10:00',3.01),('8998','2013-06-30','12:15:00',3.02),('8998','2013-06-30','12:20:00',3.01),('8998','2013-06-30','12:25:00',2.99),('8998','2013-06-30','12:30:00',3),('8998','2013-06-30','12:35:00',2.98),('8998','2013-06-30','12:40:00',2.96),('8998','2013-06-30','12:45:00',2.98),('8998','2013-06-30','12:50:00',2.98),('8998','2013-06-30','12:55:00',2.99),('8998','2013-06-30','13:00:00',2.97),('8998','2013-06-30','13:05:00',2.93),('8998','2013-06-30','13:10:00',2.93),('8998','2013-06-30','13:15:00',2.9),('8998','2013-06-30','13:20:00',2.89),('8998','2013-06-30','13:25:00',2.88),('8998','2013-06-30','13:30:00',2.85),('8998','2013-06-30','13:35:00',2.82),('8998','2013-06-30','13:40:00',2.78),('8998','2013-06-30','13:45:00',2.72),('8998','2013-06-30','13:50:00',2.72),('8998','2013-06-30','13:55:00',2.67),('8998','2013-06-30','14:00:00',2.64),('8998','2013-06-30','14:05:00',2.68),('8998','2013-06-30','14:10:00',2.67),('8998','2013-06-30','14:15:00',2.64),('8998','2013-06-30','14:20:00',2.6),('8998','2013-06-30','14:25:00',2.55),('8998','2013-06-30','14:30:00',2.51),('8998','2013-06-30','14:35:00',2.47),('8998','2013-06-30','14:40:00',2.45),('8998','2013-06-30','14:45:00',2.42),('8998','2013-06-30','14:50:00',2.35),('8998','2013-06-30','14:55:00',2.32),('8998','2013-06-30','15:00:00',2.27),('8998','2013-06-30','15:05:00',2.21),('8998','2013-06-30','15:10:00',2.18),('8998','2013-06-30','15:15:00',2.15),('8998','2013-06-30','15:20:00',2.11),('8998','2013-06-30','15:25:00',2.06),('8998','2013-06-30','15:30:00',2.02),('8998','2013-06-30','15:35:00',1.97),('8998','2013-06-30','15:40:00',1.92),('8998','2013-06-30','15:45:00',1.88),('8998','2013-06-30','15:50:00',1.84),('8998','2013-06-30','15:55:00',1.78),('8998','2013-06-30','16:00:00',1.74),('8998','2013-06-30','16:05:00',1.68),('8998','2013-06-30','16:10:00',1.64),('8998','2013-06-30','16:15:00',1.58),('8998','2013-06-30','16:20:00',1.51),('8998','2013-06-30','16:25:00',1.46),('8998','2013-06-30','16:30:00',1.41),('8998','2013-06-30','16:35:00',1.35),('8998','2013-06-30','16:40:00',1.3),('8998','2013-06-30','16:45:00',1.25),('8998','2013-06-30','16:50:00',1.21),('8998','2013-06-30','16:55:00',1.15),('8998','2013-06-30','17:00:00',1.11),('8998','2013-06-30','17:05:00',1.05),('8998','2014-04-04','09:20:00',1.28),('8998','2014-04-04','09:25:00',2.41),('8998','2014-04-04','09:30:00',3.13),('8998','2014-04-04','09:35:00',3.01),('8998','2014-04-04','09:40:00',2.49),('8998','2014-04-04','09:45:00',1.91),('8998','2014-04-04','09:50:00',1.49),('8998','2014-04-04','09:55:00',1.84),('8998','2014-04-04','10:00:00',1.75),('8998','2014-04-04','10:05:00',1.64),('8998','2014-04-04','10:10:00',1.79),('8998','2014-04-04','10:15:00',1.2),('8998','2014-04-04','10:20:00',1.97),('8998','2014-04-04','10:25:00',2.16),('8998','2014-04-04','10:30:00',2.24),('8998','2014-04-04','10:35:00',2.48),('8998','2014-04-04','10:40:00',2.67),('8998','2014-04-04','10:45:00',2.35),('8998','2014-04-04','10:50:00',2.19),('8998','2014-04-04','10:55:00',2.44),('8998','2014-04-04','11:00:00',2.69),('8998','2014-04-04','11:05:00',2.91),('8998','2014-04-04','11:10:00',3.04),('8998','2014-04-04','11:15:00',3.26),('8998','2014-04-04','11:20:00',3.08),('8998','2014-04-04','11:25:00',1.95),('8998','2014-04-04','11:30:00',1.6),('8998','2014-04-04','11:35:00',2.07),('8998','2014-04-04','11:40:00',2.76),('8998','2014-04-04','11:45:00',3.01),('8998','2014-04-04','11:50:00',3.21),('8998','2014-04-04','11:55:00',3),('8998','2014-04-04','12:00:00',2.21),('8998','2014-04-04','12:05:00',2.12),('8998','2014-04-04','12:10:00',2.25),('8998','2014-04-04','12:15:00',2.04),('8998','2014-04-04','12:20:00',2.48),('8998','2014-04-04','12:25:00',1.91),('8998','2014-04-04','12:30:00',1.73),('8998','2014-04-04','12:35:00',1.66),('8998','2014-04-04','12:40:00',2.82),('8998','2014-04-04','12:45:00',3.26),('8998','2014-04-04','12:50:00',3.23),('8998','2014-04-04','12:55:00',2.33),('8998','2014-04-04','13:00:00',2.4),('8998','2014-04-04','13:05:00',1.88),('8998','2014-04-04','13:10:00',2.72),('8998','2014-04-04','13:15:00',1.68),('8998','2014-04-04','13:20:00',2.79),('8998','2014-04-04','13:25:00',2.33),('8998','2014-04-04','13:30:00',2.67),('8998','2014-04-04','13:35:00',3.14),('8998','2014-04-04','13:40:00',3.06),('8998','2014-04-04','13:45:00',2.2),('8998','2014-04-04','13:50:00',2.73),('8998','2014-04-04','13:55:00',2.56),('8998','2014-04-04','14:00:00',2.42),('8998','2014-04-04','14:05:00',3.07),('8998','2014-04-04','14:10:00',1.19),('8998','2014-04-04','14:50:00',1.49),('8998','2014-04-04','14:55:00',2.24),('8998','2014-04-04','15:00:00',1.78),('8998','2014-04-04','15:05:00',2.1),('8998','2014-04-04','15:15:00',1.7),('8998','2014-04-04','15:20:00',2.45),('8998','2014-04-04','15:25:00',1.79),('8998','2014-04-04','15:35:00',1.04),('8998','2014-04-04','15:40:00',1.39),('8998','2014-04-04','15:45:00',1.09),('8998','2014-04-04','16:15:00',1.28),('8998','2014-04-04','16:20:00',1.55),('8998','2014-04-04','16:25:00',1.75),('8998','2014-04-04','16:30:00',1.09),('8998','2014-04-04','16:35:00',1.11),('8998','2013-06-29','07:35:00',1.05),('8998','2013-06-29','07:40:00',1.16),('8998','2013-06-29','07:45:00',1.36),('8998','2013-06-29','07:50:00',1.44),('8998','2013-06-29','07:55:00',1.59),('8998','2013-06-29','08:00:00',1.73),('8998','2013-06-29','08:05:00',1.78),('8998','2013-06-29','08:10:00',1.9),('8998','2013-06-29','08:15:00',1.97),('8998','2013-06-29','08:20:00',1.91),('8998','2013-06-29','08:25:00',1.78),('8998','2013-06-29','08:30:00',1.75),('8998','2013-06-29','08:35:00',1.73),('8998','2013-06-29','08:40:00',1.73),('8998','2013-06-29','08:45:00',1.82),('8998','2013-06-29','08:50:00',2.15),('8998','2013-06-29','08:55:00',2.09),('8998','2013-06-29','09:00:00',2),('8998','2013-06-29','09:05:00',2),('8998','2013-06-29','09:10:00',2.32),('8998','2013-06-29','09:15:00',2.5),('8998','2013-06-29','09:20:00',2.63),('8998','2013-06-29','09:25:00',2.66),('8998','2013-06-29','09:30:00',2.69),('8998','2013-06-29','09:35:00',2.72),('8998','2013-06-29','09:40:00',2.76),('8998','2013-06-29','09:45:00',2.8),('8998','2013-06-29','09:50:00',2.83),('8998','2013-06-29','09:55:00',2.84),('8998','2013-06-29','10:00:00',2.88),('8998','2013-06-29','10:05:00',2.89),('8998','2013-06-29','10:10:00',2.88),('8998','2013-06-29','10:15:00',2.92),('8998','2013-06-29','10:20:00',2.94),('8998','2013-06-29','10:25:00',2.94),('8998','2013-06-29','10:30:00',2.97),('8998','2013-06-29','10:35:00',3),('8998','2013-06-29','10:40:00',3.02),('8998','2013-06-29','10:45:00',3.01),('8998','2013-06-29','10:50:00',3.02),('8998','2013-06-29','10:55:00',3.04),('8998','2013-06-29','11:00:00',3.05),('8998','2013-06-29','11:05:00',3.06),('8998','2013-06-29','11:10:00',3.05),('8998','2013-06-29','11:15:00',3.06),('8998','2013-06-29','11:20:00',3.06),('8998','2013-06-29','11:25:00',3.07),('8998','2013-06-29','11:30:00',3.08),('8998','2013-06-29','11:35:00',3.08),('8998','2013-06-29','11:40:00',3.08),('8998','2013-06-29','11:45:00',3.07),('8998','2013-06-29','11:50:00',3.08),('8998','2013-06-29','11:55:00',3.07),('8998','2013-06-29','12:00:00',3.06),('8998','2013-06-29','12:05:00',3.08),('8998','2013-06-29','12:10:00',3.08),('8998','2013-06-29','12:15:00',3.04),('8998','2013-06-29','12:20:00',3.03),('8998','2013-06-29','12:25:00',3.04),('8998','2013-06-29','12:30:00',3.04),('8998','2013-06-29','12:35:00',3.04),('8998','2013-06-29','12:40:00',3.04),('8998','2013-06-29','12:45:00',3.04),('8998','2013-06-29','12:50:00',3.04),('8998','2013-06-29','12:55:00',3.01),('8998','2013-06-29','13:00:00',2.98),('8998','2013-06-29','13:05:00',2.97),('8998','2013-06-29','13:10:00',2.95),('8998','2013-06-29','13:15:00',2.94),('8998','2013-06-29','13:20:00',2.93),('8998','2013-06-29','13:25:00',2.95),('8998','2013-06-29','13:30:00',2.9),('8998','2013-06-29','13:35:00',2.86),('8998','2013-06-29','13:40:00',2.85),('8998','2013-06-29','13:45:00',2.85),('8998','2013-06-29','13:50:00',2.87),('8998','2013-06-29','13:55:00',2.33),('8998','2013-06-29','14:00:00',2.81),('8998','2013-06-29','14:05:00',2.77),('8998','2013-06-29','14:10:00',2.73),('8998','2013-06-29','14:15:00',2.67),('8998','2013-06-29','14:20:00',2.65),('8998','2013-06-29','14:25:00',2.61),('8998','2013-06-29','14:30:00',2.57),('8998','2013-06-29','14:35:00',2.54),('8998','2013-06-29','14:40:00',2.53),('8998','2013-06-29','14:45:00',2.48),('8998','2013-06-29','14:50:00',2.45),('8998','2013-06-29','14:55:00',2.41),('8998','2013-06-29','15:00:00',2.36),('8998','2013-06-29','15:05:00',2.32),('8998','2013-06-29','15:10:00',2.29),('8998','2013-06-29','15:15:00',2.24),('8998','2013-06-29','15:20:00',2.22),('8998','2013-06-29','15:25:00',2.16),('8998','2013-06-29','15:30:00',2.12),('8998','2013-06-29','15:35:00',2.08),('8998','2013-06-29','15:40:00',2.03),('8998','2013-06-29','15:45:00',1.99),('8998','2013-06-29','15:50:00',1.95),('8998','2013-06-29','15:55:00',1.91),('8998','2013-06-29','16:00:00',1.85),('8998','2013-06-29','16:05:00',1.8),('8998','2013-06-29','16:10:00',1.77),('8998','2013-06-29','16:15:00',1.75),('8998','2013-06-29','16:20:00',1.8),('8998','2013-06-29','16:25:00',1.84),('8998','2013-06-29','16:30:00',1.52),('8998','2013-06-29','16:35:00',1.49),('8998','2013-06-29','16:40:00',1.37),('8998','2013-06-29','16:45:00',1.32),('8998','2013-06-29','16:50:00',1.27),('8998','2013-06-29','16:55:00',1.2),('8998','2013-06-29','17:00:00',1.14),('8998','2013-06-29','17:05:00',1.11),('8998','2013-06-29','17:10:00',1.07),('8998','2013-06-28','07:35:00',1.28),('8998','2013-06-28','07:40:00',1.22),('8998','2013-06-28','07:45:00',1.34),('8998','2013-06-28','07:50:00',1.37),('8998','2013-06-28','07:55:00',1.41),('8998','2013-06-28','08:00:00',1.79),('8998','2013-06-28','08:05:00',1.85),('8998','2013-06-28','08:10:00',1.91),('8998','2013-06-28','08:15:00',1.73),('8998','2013-06-28','08:20:00',1.2),('8998','2013-06-28','08:25:00',1.53),('8998','2013-06-28','08:30:00',1.9),('8998','2013-06-28','08:35:00',1.86),('8998','2013-06-28','08:40:00',1.12),('8998','2013-06-28','08:45:00',1.76),('8998','2013-06-28','08:50:00',2.2),('8998','2013-06-28','08:55:00',2.13),('8998','2013-06-28','09:00:00',2.03),('8998','2013-06-28','09:05:00',2.03),('8998','2013-06-28','09:10:00',2.32),('8998','2013-06-28','09:15:00',2.5),('8998','2013-06-28','09:20:00',2.6),('8998','2013-06-28','09:25:00',2.64),('8998','2013-06-28','09:30:00',2.65),('8998','2013-06-28','09:35:00',2.72),('8998','2013-06-28','09:40:00',2.73),('8998','2013-06-28','09:45:00',2.74),('8998','2013-06-28','09:50:00',2.78),('8998','2013-06-28','09:55:00',2.8),('8998','2013-06-28','10:00:00',2.83),('8998','2013-06-28','10:05:00',2.86),('8998','2013-06-28','10:10:00',2.88),('8998','2013-06-28','10:15:00',2.87),('8998','2013-06-28','10:20:00',2.9),('8998','2013-06-28','10:25:00',2.93),('8998','2013-06-28','10:30:00',2.94),('8998','2013-06-28','10:35:00',2.95),('8998','2013-06-28','10:40:00',2.97),('8998','2013-06-28','10:45:00',3.01),('8998','2013-06-28','10:50:00',3),('8998','2013-06-28','10:55:00',3.07),('8998','2013-06-28','11:00:00',3.08),('8998','2013-06-28','11:05:00',3.11),('8998','2013-06-28','11:10:00',3.13),('8998','2013-06-28','11:15:00',3.2),('8998','2013-06-28','11:20:00',1.79),('8998','2013-06-28','11:25:00',3.35),('8998','2013-06-28','11:30:00',3.36),('8998','2013-06-28','11:35:00',2.81),('8998','2013-06-28','11:40:00',2.81),('8998','2013-06-28','11:50:00',2.25),('8998','2013-06-28','11:55:00',3.53),('8998','2013-06-28','12:00:00',2.32),('8998','2013-06-28','12:05:00',3.26),('8998','2013-06-28','12:10:00',3.31),('8998','2013-06-28','12:15:00',2.58),('8998','2013-06-28','12:20:00',1.05),('8998','2013-06-28','12:25:00',3.41),('8998','2013-06-28','12:30:00',3.09),('8998','2013-06-28','12:35:00',3.27),('8998','2013-06-28','12:40:00',3.21),('8998','2013-06-28','12:45:00',3.45),('8998','2013-06-28','12:50:00',1.53),('8998','2013-06-28','12:55:00',2.57),('8998','2013-06-28','13:00:00',2.24),('8998','2013-06-28','13:05:00',1.66),('8998','2013-06-28','13:10:00',3.57),('8998','2013-06-28','13:15:00',3.27),('8998','2013-06-28','13:20:00',1.61),('8998','2013-06-28','13:25:00',2.79),('8998','2013-06-28','13:30:00',1.06),('8998','2013-06-28','13:45:00',2),('8998','2013-06-28','13:50:00',3.05),('8998','2013-06-28','13:55:00',2.47),('8998','2013-06-28','14:00:00',3.09),('8998','2013-06-28','14:05:00',2.37),('8998','2013-06-28','14:10:00',2.95),('8998','2013-06-28','14:15:00',3.25),('8998','2013-06-28','14:20:00',2.91),('8998','2013-06-28','14:25:00',1.87),('8998','2013-06-28','14:30:00',3.16),('8998','2013-06-28','14:35:00',2.96),('8998','2013-06-28','14:40:00',2.94),('8998','2013-06-28','14:45:00',2.99),('8998','2013-06-28','14:50:00',2.25),('8998','2013-06-28','15:00:00',1.17),('8998','2013-06-28','15:05:00',1.91),('8998','2013-06-28','15:10:00',1.29),('8998','2013-06-28','16:50:00',1.26),('8998','2013-06-28','17:30:00',1.07),('8998','2013-06-27','07:20:00',1.15),('8998','2013-06-27','07:25:00',1.23),('8998','2013-06-27','07:30:00',1.26),('8998','2013-06-27','07:35:00',1.23),('8998','2013-06-27','07:40:00',1.26),('8998','2013-06-27','07:45:00',1.41),('8998','2013-06-27','07:50:00',1.38),('8998','2013-06-27','07:55:00',1.39),('8998','2013-06-27','08:00:00',1.46),('8998','2013-06-27','08:05:00',1.73),('8998','2013-06-27','08:10:00',1.74),('8998','2013-06-27','08:15:00',1.88),('8998','2013-06-27','08:20:00',1.84),('8998','2013-06-27','08:25:00',1.64),('8998','2013-06-27','08:30:00',1.71),('8998','2013-06-27','08:35:00',1.73),('8998','2013-06-27','08:40:00',1.74),('8998','2013-06-27','08:45:00',1.76),('8998','2013-06-27','08:50:00',2.1),('8998','2013-06-27','08:55:00',2.04),('8998','2013-06-27','09:00:00',2.11),('8998','2013-06-27','09:05:00',2.23),('8998','2013-06-27','09:10:00',2.34),('8998','2013-06-27','09:15:00',2.22),('8998','2013-06-27','09:30:00',1.5),('8998','2013-06-27','09:35:00',2.92),('8998','2013-06-27','09:40:00',2.75),('8998','2013-06-27','09:45:00',1.72),('8998','2013-06-27','09:50:00',1.15),('8998','2013-06-27','09:55:00',2.02),('8998','2013-06-27','10:00:00',3.01),('8998','2013-06-27','10:05:00',1.99),('8998','2013-06-27','10:10:00',3.1),('8998','2013-06-27','10:15:00',3.04),('8998','2013-06-27','10:20:00',3.09),('8998','2013-06-27','10:25:00',2.6),('8998','2013-06-27','10:35:00',2.34),('8998','2013-06-27','10:40:00',3.44),('8998','2013-06-27','10:45:00',3.17),('8998','2013-06-27','10:50:00',3.22),('8998','2013-06-27','10:55:00',1.79),('8998','2013-06-27','11:00:00',2.23),('8998','2013-06-27','11:05:00',3.56),('8998','2013-06-27','11:10:00',2.26),('8998','2013-06-27','11:15:00',1.08),('8998','2013-06-27','11:20:00',1.22),('8998','2013-06-27','11:25:00',2.09),('8998','2013-06-27','11:30:00',3.5),('8998','2013-06-27','11:35:00',2.95),('8998','2013-06-27','11:40:00',3.28),('8998','2013-06-27','11:45:00',2.86),('8998','2013-06-27','11:50:00',3.46),('8998','2013-06-27','11:55:00',2.49),('8998','2013-06-27','12:00:00',1.99),('8998','2013-06-27','12:05:00',2.17),('8998','2013-06-27','12:10:00',2.17),('8998','2013-06-27','12:15:00',3.52),('8998','2013-06-27','12:20:00',3.29),('8998','2013-06-27','12:25:00',3.31),('8998','2013-06-27','12:30:00',3.06),('8998','2013-06-27','12:35:00',3.3),('8998','2013-06-27','12:40:00',2.55),('8998','2013-06-27','12:45:00',2.91),('8998','2013-06-27','12:50:00',3.23),('8998','2013-06-27','12:55:00',3.17),('8998','2013-06-27','13:00:00',2.92),('8998','2013-06-27','13:05:00',3.12),('8998','2013-06-27','13:10:00',2.62),('8998','2013-06-27','13:15:00',3.24),('8998','2013-06-27','13:20:00',3.09),('8998','2013-06-27','13:25:00',2.99),('8998','2013-06-27','13:30:00',3.04),('8998','2013-06-27','13:35:00',3.03),('8998','2013-06-27','13:40:00',2.97),('8998','2013-06-27','13:45:00',2.82),('8998','2013-06-27','13:50:00',3.04),('8998','2013-06-27','13:55:00',2.88),('8998','2013-06-27','14:00:00',2.74),('8998','2013-06-27','14:05:00',2.6),('8998','2013-06-27','14:10:00',2.72),('8998','2013-06-27','14:15:00',2.34),('8998','2013-06-27','14:20:00',2.87),('8998','2013-06-27','14:25:00',2.86),('8998','2013-06-27','14:30:00',2.41),('8998','2013-06-27','14:35:00',2.46),('8998','2013-06-27','14:40:00',2.33),('8998','2013-06-27','14:45:00',2.19),('8998','2013-06-27','14:50:00',2.72),('8998','2013-06-27','14:55:00',2.31),('8998','2013-06-27','15:00:00',2.04),('8998','2013-06-27','15:05:00',2.4),('8998','2013-06-27','15:10:00',2.24),('8998','2013-06-27','15:15:00',2.27),('8998','2013-06-27','15:20:00',1.13),('8998','2013-06-27','15:25:00',2.37),('8998','2013-06-27','15:30:00',1.6),('8998','2013-06-27','15:35:00',1.12),('8998','2013-06-27','15:40:00',2.1),('8998','2013-06-27','15:45:00',1.37),('8998','2013-06-27','15:50:00',2.36),('8998','2013-06-27','15:55:00',2.1),('8998','2013-06-27','16:00:00',1.45),('8998','2013-06-27','16:05:00',2.13),('8998','2013-06-27','16:10:00',1.41),('8998','2013-06-27','16:15:00',1.9),('8998','2013-06-27','16:20:00',1.18),('8998','2013-06-27','16:25:00',1.23),('8998','2013-06-27','16:35:00',1.05),('8998','2013-06-27','16:40:00',1.37),('8998','2013-06-27','17:05:00',1.14),('8998','2013-06-27','17:10:00',1.04),('8998','2013-06-26','07:30:00',1.23),('8998','2013-06-26','07:35:00',1.22),('8998','2013-06-26','07:40:00',1.26),('8998','2013-06-26','07:45:00',1.37),('8998','2013-06-26','07:50:00',1.42),('8998','2013-06-26','07:55:00',1.41),('8998','2013-06-26','08:00:00',1.42),('8998','2013-06-26','08:05:00',1.43),('8998','2013-06-26','08:10:00',1.47),('8998','2013-06-26','08:15:00',1.61),('8998','2013-06-26','08:20:00',1.88),('8998','2013-06-26','08:25:00',1.78),('8998','2013-06-26','08:30:00',1.76),('8998','2013-06-26','08:35:00',1.7),('8998','2013-06-26','08:40:00',1.71),('8998','2013-06-26','08:45:00',1.87),('8998','2013-06-26','08:50:00',2.11),('8998','2013-06-26','08:55:00',2.07),('8998','2013-06-26','09:00:00',1.97),('8998','2013-06-26','09:05:00',2.03),('8998','2013-06-26','09:10:00',2.31),('8998','2013-06-26','09:15:00',2.51),('8998','2013-06-26','09:20:00',2.62),('8998','2013-06-26','09:25:00',2.64),('8998','2013-06-26','09:30:00',2.68),('8998','2013-06-26','09:35:00',2.7),('8998','2013-06-26','09:40:00',2.72),('8998','2013-06-26','09:45:00',2.74),('8998','2013-06-26','09:50:00',2.81),('8998','2013-06-26','09:55:00',2.81),('8998','2013-06-26','10:00:00',2.6),('8998','2013-06-26','10:05:00',3.03),('8998','2013-06-26','10:10:00',2.46),('8998','2013-06-26','10:15:00',2.84),('8998','2013-06-26','10:20:00',2.97),('8998','2013-06-26','10:25:00',2.96),('8998','2013-06-26','10:30:00',3),('8998','2013-06-26','10:35:00',3.05),('8998','2013-06-26','10:40:00',3.08),('8998','2013-06-26','10:45:00',3.21),('8998','2013-06-26','10:50:00',3.21),('8998','2013-06-26','10:55:00',3.16),('8998','2013-06-26','11:00:00',2.64),('8998','2013-06-26','11:05:00',3.22),('8998','2013-06-26','11:10:00',3.06),('8998','2013-06-26','11:15:00',3.17),('8998','2013-06-26','11:20:00',3.13),('8998','2013-06-26','11:25:00',3.09),('8998','2013-06-26','11:30:00',3.15),('8998','2013-06-26','11:35:00',3),('8998','2013-06-26','11:40:00',1.1),('8998','2013-06-26','11:45:00',3.17),('8998','2013-06-26','11:50:00',1.99),('8998','2013-06-26','11:55:00',1.01),('8998','2013-06-26','12:00:00',1.48),('8998','2013-06-26','12:10:00',1.61),('8998','2013-06-26','12:25:00',1.07),('8998','2013-06-26','12:30:00',1.03),('8998','2013-06-26','12:35:00',2.52),('8998','2013-06-26','12:40:00',1.68),('8998','2013-06-26','12:45:00',1.02),('8998','2013-06-26','13:10:00',1.06),('8998','2013-06-26','13:15:00',1.94),('8998','2013-06-26','13:20:00',2.27),('8998','2013-06-26','13:25:00',1.57),('8998','2013-06-26','13:30:00',1.2),('8998','2013-06-26','13:35:00',2.4),('8998','2013-06-26','13:40:00',1.03),('8998','2013-06-26','13:55:00',1.01),('8998','2013-06-26','14:10:00',1.03),('8998','2013-06-26','14:15:00',1.19),('8998','2013-06-26','14:20:00',1.21),('8998','2013-06-26','14:25:00',1.33),('8998','2013-06-26','14:30:00',2.88),('8998','2013-06-26','14:35:00',2.71),('8998','2013-06-26','14:40:00',2.64),('8998','2013-06-26','14:45:00',2.18),('8998','2013-06-26','14:50:00',1.77),('8998','2013-06-26','14:55:00',2.17),('8998','2013-06-26','15:00:00',2.36),('8998','2013-06-26','15:05:00',2.31),('8998','2013-06-26','15:10:00',2.25),('8998','2013-06-26','15:15:00',2.19),('8998','2013-06-26','15:20:00',2.15),('8998','2013-06-26','15:25:00',2.14),('8998','2013-06-26','15:30:00',2.1),('8998','2013-06-26','15:35:00',2.04),('8998','2013-06-26','15:40:00',1.99),('8998','2013-06-26','15:45:00',1.94),('8998','2013-06-26','15:50:00',1.88),('8998','2013-06-26','15:55:00',1.83),('8998','2013-06-26','16:00:00',1.75),('8998','2013-06-26','16:05:00',1.69),('8998','2013-06-26','16:10:00',1.65),('8998','2013-06-26','16:15:00',1.61),('8998','2013-06-26','16:20:00',1.57),('8998','2013-06-26','16:25:00',1.53),('8998','2013-06-26','16:30:00',1.48),('8998','2013-06-26','16:35:00',1.35),('8998','2013-06-26','16:40:00',1.34),('8998','2013-06-26','16:45:00',1.34),('8998','2013-06-26','16:50:00',1.28),('8998','2013-06-26','16:55:00',1.23),('8998','2013-06-26','17:00:00',1.18),('8998','2013-06-26','17:05:00',1.11),('8998','2013-06-26','17:10:00',1.04),('8998','2013-06-25','07:35:00',1.06),('8998','2013-06-25','07:40:00',1.2),('8998','2013-06-25','07:45:00',1.39),('8998','2013-06-25','07:50:00',1.42),('8998','2013-06-25','07:55:00',1.39),('8998','2013-06-25','08:00:00',1.38),('8998','2013-06-25','08:05:00',1.4),('8998','2013-06-25','08:10:00',1.44),('8998','2013-06-25','08:15:00',1.79),('8998','2013-06-25','08:20:00',1.85),('8998','2013-06-25','08:25:00',1.75),('8998','2013-06-25','08:30:00',1.74),('8998','2013-06-25','08:35:00',1.68),('8998','2013-06-25','08:40:00',1.7),('8998','2013-06-25','08:45:00',1.84),('8998','2013-06-25','08:50:00',2.1),('8998','2013-06-25','08:55:00',2.04),('8998','2013-06-25','09:00:00',1.91),('8998','2013-06-25','09:05:00',2),('8998','2013-06-25','09:10:00',2.27),('8998','2013-06-25','09:15:00',2.44),('8998','2013-06-25','09:20:00',2.51),('8998','2013-06-25','09:25:00',2.56),('8998','2013-06-25','09:30:00',2.61),('8998','2013-06-25','09:35:00',2.65),('8998','2013-06-25','09:40:00',2.66),('8998','2013-06-25','09:45:00',2.67),('8998','2013-06-25','09:50:00',2.69),('8998','2013-06-25','09:55:00',2.73),('8998','2013-06-25','10:00:00',2.78),('8998','2013-06-25','10:05:00',2.82),('8998','2013-06-25','10:10:00',2.83),('8998','2013-06-25','10:15:00',2.85),('8998','2013-06-25','10:20:00',2.88),('8998','2013-06-25','10:25:00',2.87),('8998','2013-06-25','10:30:00',2.87),('8998','2013-06-25','10:35:00',2.91),('8998','2013-06-25','10:40:00',2.96),('8998','2013-06-25','10:45:00',2.96),('8998','2013-06-25','10:50:00',2.98),('8998','2013-06-25','10:55:00',2.98),('8998','2013-06-25','11:00:00',3),('8998','2013-06-25','11:05:00',2.99),('8998','2013-06-25','11:10:00',3.01),('8998','2013-06-25','11:15:00',3.01),('8998','2013-06-25','11:20:00',3.01),('8998','2013-06-25','11:25:00',3.01),('8998','2013-06-25','11:30:00',3.01),('8998','2013-06-25','11:35:00',3.02),('8998','2013-06-25','11:40:00',3.02),('8998','2013-06-25','11:45:00',3.03),('8998','2013-06-25','11:50:00',3.03),('8998','2013-06-25','11:55:00',3.04),('8998','2013-06-25','12:00:00',3.07),('8998','2013-06-25','12:05:00',3.05),('8998','2013-06-25','12:10:00',3.04),('8998','2013-06-25','12:15:00',2.95),('8998','2013-06-25','12:20:00',2.9),('8998','2013-06-25','12:25:00',2.94),('8998','2013-06-25','12:30:00',3.02),('8998','2013-06-25','12:35:00',2.98),('8998','2013-06-25','12:40:00',3.05),('8998','2013-06-25','12:45:00',3),('8998','2013-06-25','12:50:00',1.5),('8998','2013-06-25','13:15:00',2.41),('8998','2013-06-25','13:20:00',3.27),('8998','2013-06-25','13:25:00',2.45),('8998','2013-06-25','13:55:00',1.71),('8998','2013-06-25','14:00:00',1.85),('8998','2013-06-25','14:10:00',1.36),('8998','2013-06-25','14:15:00',2.98),('8998','2013-06-25','14:20:00',2.78),('8998','2013-06-25','14:25:00',2.33),('8998','2013-06-25','14:30:00',2.23),('8998','2013-06-25','14:35:00',2.59),('8998','2013-06-25','14:45:00',2.2),('8998','2013-06-25','14:50:00',2.66),('8998','2013-06-25','14:55:00',2.31),('8998','2013-06-25','15:00:00',2.39),('8998','2013-06-25','15:05:00',2.33),('8998','2013-06-25','15:10:00',2.28),('8998','2013-06-25','15:15:00',2.22),('8998','2013-06-25','15:20:00',2.16),('8998','2013-06-25','15:25:00',2.12),('8998','2013-06-25','15:30:00',2.1),('8998','2013-06-25','15:35:00',2.09),('8998','2013-06-25','15:40:00',2.01),('8998','2013-06-25','15:45:00',1.95),('8998','2013-06-25','15:50:00',1.92),('8998','2013-06-25','15:55:00',1.66),('8998','2013-06-25','16:00:00',1.79),('8998','2013-06-25','16:05:00',1.73),('8998','2013-06-25','16:10:00',1.69),('8998','2013-06-25','16:15:00',1.65),('8998','2013-06-25','16:20:00',1.59),('8998','2013-06-25','16:25:00',1.54),('8998','2013-06-25','16:30:00',1.51),('8998','2013-06-25','16:35:00',1.44),('8998','2013-06-25','16:40:00',1.36),('8998','2013-06-25','16:45:00',1.32),('8998','2013-06-25','16:50:00',1.25),('8998','2013-06-25','16:55:00',1.19),('8998','2013-06-25','17:00:00',1.14),('8998','2013-06-25','17:05:00',1.09),('8998','2013-06-25','17:10:00',1.05),('8998','2013-06-24','07:40:00',1.37),('8998','2013-06-24','07:45:00',1.48),('8998','2013-06-24','07:50:00',1.31),('8998','2013-06-24','07:55:00',1.26),('8998','2013-06-24','08:05:00',1.28),('8998','2013-06-24','08:10:00',1.21),('8998','2013-06-24','08:15:00',1.18),('8998','2013-06-24','08:20:00',1.85),('8998','2013-06-24','08:30:00',1.61),('8998','2013-06-24','08:35:00',2.18),('8998','2013-06-24','08:40:00',2.22),('8998','2013-06-24','08:45:00',2.21),('8998','2013-06-24','08:50:00',2.18),('8998','2013-06-24','08:55:00',2.13),('8998','2013-06-24','09:00:00',2),('8998','2013-06-24','09:05:00',2.09),('8998','2013-06-24','09:10:00',2.36),('8998','2013-06-24','09:15:00',2.58),('8998','2013-06-24','09:20:00',2.52),('8998','2013-06-24','09:25:00',2.73),('8998','2013-06-24','09:30:00',2.75),('8998','2013-06-24','09:35:00',2.85),('8998','2013-06-24','09:40:00',2.86),('8998','2013-06-24','09:45:00',2.86),('8998','2013-06-24','09:50:00',2.98),('8998','2013-06-24','09:55:00',3.05),('8998','2013-06-24','10:00:00',3.08),('8998','2013-06-24','10:05:00',1.4),('8998','2013-06-24','10:10:00',2.35),('8998','2013-06-24','10:15:00',3.24),('8998','2013-06-24','10:20:00',3.2),('8998','2013-06-24','10:25:00',1.99),('8998','2013-06-24','10:30:00',3.29),('8998','2013-06-24','10:35:00',3.29),('8998','2013-06-24','10:40:00',3.26),('8998','2013-06-24','10:45:00',3.18),('8998','2013-06-24','10:50:00',3.16),('8998','2013-06-24','10:55:00',2.72),('8998','2013-06-24','11:05:00',1.45),('8998','2013-06-24','11:10:00',2.67),('8998','2013-06-24','11:15:00',1.71),('8998','2013-06-24','11:20:00',2.82),('8998','2013-06-24','11:30:00',1.5),('8998','2013-06-24','11:35:00',2.61),('8998','2013-06-24','11:40:00',3.32),('8998','2013-06-24','11:45:00',3.39),('8998','2013-06-24','11:50:00',2.79),('8998','2013-06-24','11:55:00',2.31),('8998','2013-06-24','12:00:00',2.96),('8998','2013-06-24','12:05:00',2.23),('8998','2013-06-24','12:10:00',1.82),('8998','2013-06-24','12:15:00',2.3),('8998','2013-06-24','12:20:00',1.43),('8998','2013-06-24','12:40:00',1.2),('8998','2013-06-24','12:55:00',1.63),('8998','2013-06-24','13:00:00',3.44),('8998','2013-06-24','13:05:00',3.26),('8998','2013-06-24','13:10:00',3.2),('8998','2013-06-24','13:15:00',2.88),('8998','2013-06-24','13:20:00',3.08),('8998','2013-06-24','13:25:00',3.01),('8998','2013-06-24','13:30:00',3.07),('8998','2013-06-24','13:35:00',2.84),('8998','2013-06-24','13:40:00',2.15),('8998','2013-06-24','13:45:00',3.13),('8998','2013-06-24','13:50:00',2.49),('8998','2013-06-24','13:55:00',2.94),('8998','2013-06-24','14:00:00',2.29),('8998','2013-06-24','14:05:00',2.9),('8998','2013-06-24','14:10:00',2.94),('8998','2013-06-24','14:15:00',2.04),('8998','2013-06-24','14:20:00',2.61),('8998','2013-06-24','14:25:00',2.71),('8998','2013-06-24','14:30:00',2.63),('8998','2013-06-24','14:35:00',2.56),('8998','2013-06-24','14:40:00',2.39),('8998','2013-06-24','14:45:00',2.31),('8998','2013-06-24','14:50:00',2.49),('8998','2013-06-24','14:55:00',2.42),('8998','2013-06-24','15:00:00',2.38),('8998','2013-06-24','15:05:00',2.34),('8998','2013-06-24','15:10:00',2.27),('8998','2013-06-24','15:15:00',2.27),('8998','2013-06-24','15:20:00',2.19),('8998','2013-06-24','15:25:00',2.1),('8998','2013-06-24','15:30:00',2.05),('8998','2013-06-24','15:35:00',2),('8998','2013-06-24','15:40:00',1.94),('8998','2013-06-24','15:45:00',1.89),('8998','2013-06-24','15:50:00',1.84),('8998','2013-06-24','15:55:00',1.78),('8998','2013-06-24','16:00:00',1.74),('8998','2013-06-24','16:05:00',1.7),('8998','2013-06-24','16:10:00',1.65),('8998','2013-06-24','16:15:00',1.59),('8998','2013-06-24','16:20:00',1.54),('8998','2013-06-24','16:25:00',1.48),('8998','2013-06-24','16:30:00',1.43),('8998','2013-06-24','16:35:00',1.37),('8998','2013-06-24','16:40:00',1.32),('8998','2013-06-24','16:45:00',1.27),('8998','2013-06-24','16:50:00',1.22),('8998','2013-06-24','16:55:00',1.16),('8998','2013-06-24','17:00:00',1.1),('8998','2013-06-24','17:05:00',1.05),('8998','2013-06-23','08:45:00',1.89),('8998','2013-06-23','08:50:00',2.48),('8998','2013-06-23','08:55:00',2.49),('8998','2013-06-23','09:00:00',1.9),('8998','2013-06-23','09:05:00',2.05),('8998','2013-06-23','09:15:00',2.31),('8998','2013-06-23','09:20:00',2.71),('8998','2013-06-23','09:25:00',2.65),('8998','2013-06-23','09:30:00',2.46),('8998','2013-06-23','09:40:00',1.74),('8998','2013-06-23','09:45:00',1.88),('8998','2013-06-23','09:50:00',2.39),('8998','2013-06-23','09:55:00',3.04),('8998','2013-06-23','10:00:00',2.99),('8998','2013-06-23','10:05:00',2.98),('8998','2013-06-23','10:10:00',3.04),('8998','2013-06-23','10:15:00',3.2),('8998','2013-06-23','10:20:00',1.93),('8998','2013-06-23','10:25:00',3.3),('8998','2013-06-23','10:30:00',1.77),('8998','2013-06-23','10:35:00',2.56),('8998','2013-06-23','10:40:00',1.68),('8998','2013-06-23','10:45:00',1.95),('8998','2013-06-23','10:50:00',2.68),('8998','2013-06-23','10:55:00',2.46),('8998','2013-06-23','11:00:00',3.51),('8998','2013-06-23','11:05:00',2.81),('8998','2013-06-23','11:10:00',2.96),('8998','2013-06-23','11:15:00',1.78),('8998','2013-06-23','11:20:00',2.54),('8998','2013-06-23','11:25:00',1.05),('8998','2013-06-23','11:30:00',1.31),('8998','2013-06-23','11:45:00',1.13),('8998','2013-06-23','11:50:00',2.23),('8998','2013-06-23','11:55:00',2.8),('8998','2013-06-23','12:00:00',2.62),('8998','2013-06-23','12:05:00',2.75),('8998','2013-06-23','12:10:00',3.31),('8998','2013-06-23','12:15:00',2.79),('8998','2013-06-23','12:20:00',2.77),('8998','2013-06-23','12:25:00',1.83),('8998','2013-06-23','12:30:00',1.78),('8998','2013-06-23','12:35:00',3.48),('8998','2013-06-23','12:40:00',3.55),('8998','2013-06-23','12:45:00',1.59),('8998','2013-06-23','12:50:00',3.64),('8998','2013-06-23','12:55:00',3.54),('8998','2013-06-23','13:00:00',3.36),('8998','2013-06-23','13:05:00',3.4),('8998','2013-06-23','13:10:00',2.86),('8998','2013-06-23','13:15:00',2.22),('8998','2013-06-23','13:20:00',1.68),('8998','2013-06-23','13:25:00',2.86),('8998','2013-06-23','13:30:00',3.07),('8998','2013-06-23','13:35:00',2.7),('8998','2013-06-23','13:40:00',2.87),('8998','2013-06-23','13:45:00',3.06),('8998','2013-06-23','13:50:00',2.93),('8998','2013-06-23','13:55:00',2.86),('8998','2013-06-23','14:00:00',2.83),('8998','2013-06-23','14:05:00',2.82),('8998','2013-06-23','14:10:00',2.78),('8998','2013-06-23','14:15:00',2.73),('8998','2013-06-23','14:20:00',2.71),('8998','2013-06-23','14:25:00',2.68),('8998','2013-06-23','14:30:00',2.66),('8998','2013-06-23','14:35:00',2.6),('8998','2013-06-23','14:40:00',2.58),('8998','2013-06-23','14:45:00',2.58),('8998','2013-06-23','14:50:00',2.44),('8998','2013-06-23','14:55:00',2.69),('8998','2013-06-23','15:00:00',2.67),('8998','2013-06-23','15:05:00',1.87),('8998','2013-06-23','15:10:00',1.18),('8998','2013-06-23','15:15:00',2.23),('8998','2013-06-23','15:20:00',2.4),('8998','2013-06-23','15:25:00',2.15),('8998','2013-06-23','15:30:00',1.63),('8998','2013-06-23','15:35:00',1.94),('8998','2013-06-23','15:40:00',1.29),('8998','2013-06-23','15:45:00',2),('8998','2013-06-23','15:50:00',1.4),('8998','2013-06-23','15:55:00',1.66),('8998','2013-06-23','16:00:00',2.04),('8998','2013-06-23','16:05:00',1.94),('8998','2013-06-23','16:10:00',1.97),('8998','2013-06-23','16:15:00',1.96),('8998','2013-06-23','16:20:00',1.49),('8998','2013-06-23','16:25:00',1.34),('8998','2013-06-23','16:30:00',1.74),('8998','2013-06-23','16:35:00',1.39),('8998','2013-06-23','16:40:00',1.02),('8998','2013-06-23','16:45:00',1.11),('8998','2013-06-23','16:50:00',1.1),('8998','2013-06-23','17:10:00',1.13),('8998','2013-06-23','17:15:00',1.37),('8998','2013-06-23','17:20:00',1.2),('8998','2013-06-23','17:30:00',1.04),('8998','2013-06-22','08:50:00',1.36),('8998','2013-06-22','09:00:00',1.41),('8998','2013-06-22','09:05:00',1.38),('8998','2013-06-22','09:20:00',1.51),('8998','2013-06-22','09:25:00',2.5),('8998','2013-06-22','09:30:00',2.8),('8998','2013-06-22','09:35:00',2.78),('8998','2013-06-22','09:40:00',2.99),('8998','2013-06-22','09:45:00',1.95),('8998','2013-06-22','09:50:00',1.09),('8998','2013-06-22','09:55:00',1.07),('8998','2013-06-22','10:00:00',2.82),('8998','2013-06-22','10:05:00',3.04),('8998','2013-06-22','10:10:00',2.36),('8998','2013-06-22','10:15:00',2.7),('8998','2013-06-22','10:20:00',1.96),('8998','2013-06-22','10:25:00',1.18),('8998','2013-06-22','10:40:00',1.63),('8998','2013-06-22','10:45:00',3.18),('8998','2013-06-22','10:50:00',1.75),('8998','2013-06-22','10:55:00',3.05),('8998','2013-06-22','11:00:00',2.94),('8998','2013-06-22','11:05:00',2.96),('8998','2013-06-22','11:10:00',3.03),('8998','2013-06-22','11:15:00',3.02),('8998','2013-06-22','11:20:00',3.11),('8998','2013-06-22','11:25:00',3.02),('8998','2013-06-22','11:30:00',2.97),('8998','2013-06-22','11:35:00',3),('8998','2013-06-22','11:40:00',2.95),('8998','2013-06-22','11:45:00',2.97),('8998','2013-06-22','11:50:00',3.02),('8998','2013-06-22','11:55:00',3.04),('8998','2013-06-22','12:00:00',2.08),('8998','2013-06-22','12:05:00',2.18),('8998','2013-06-22','12:10:00',3.15),('8998','2013-06-22','12:15:00',3.08),('8998','2013-06-22','12:20:00',3.07),('8998','2013-06-22','12:25:00',2.98),('8998','2013-06-22','12:30:00',3.04),('8998','2013-06-22','12:35:00',3.02),('8998','2013-06-22','12:40:00',3),('8998','2013-06-22','12:45:00',2.98),('8998','2013-06-22','12:50:00',2.96),('8998','2013-06-22','12:55:00',2.95),('8998','2013-06-22','13:00:00',2.94),('8998','2013-06-22','13:05:00',2.94),('8998','2013-06-22','13:10:00',2.92),('8998','2013-06-22','13:15:00',2.89),('8998','2013-06-22','13:20:00',2.87),('8998','2013-06-22','13:25:00',2.85),('8998','2013-06-22','13:30:00',2.83),('8998','2013-06-22','13:35:00',2.82),('8998','2013-06-22','13:40:00',2.8),('8998','2013-06-22','13:45:00',2.78),('8998','2013-06-22','13:50:00',2.76),('8998','2013-06-22','13:55:00',2.73),('8998','2013-06-22','14:00:00',2.69),('8998','2013-06-22','14:05:00',2.67),('8998','2013-06-22','14:10:00',2.63),('8998','2013-06-22','14:15:00',2.6),('8998','2013-06-22','14:20:00',2.59),('8998','2013-06-22','14:25:00',2.57),('8998','2013-06-22','14:30:00',2.55),('8998','2013-06-22','14:35:00',2.52),('8998','2013-06-22','14:40:00',2.48),('8998','2013-06-22','14:45:00',2.44),('8998','2013-06-22','14:50:00',2.41),('8998','2013-06-22','14:55:00',2.38),('8998','2013-06-22','15:00:00',2.34),('8998','2013-06-22','15:05:00',2.3),('8998','2013-06-22','15:10:00',2.26),('8998','2013-06-22','15:15:00',2.22),('8998','2013-06-22','15:20:00',2.17),('8998','2013-06-22','15:25:00',2.12),('8998','2013-06-22','15:30:00',2.06),('8998','2013-06-22','15:35:00',2),('8998','2013-06-22','15:40:00',1.97),('8998','2013-06-22','15:45:00',1.92),('8998','2013-06-22','15:50:00',1.87),('8998','2013-06-22','15:55:00',1.82),('8998','2013-06-22','16:00:00',1.76),('8998','2013-06-22','16:05:00',1.72),('8998','2013-06-22','16:10:00',1.65),('8998','2013-06-22','16:15:00',1.6),('8998','2013-06-22','16:20:00',1.54),('8998','2013-06-22','16:25:00',1.48),('8998','2013-06-22','16:30:00',1.43),('8998','2013-06-22','16:35:00',1.38),('8998','2013-06-22','16:40:00',1.33),('8998','2013-06-22','16:45:00',1.27),('8998','2013-06-22','16:50:00',1.21),('8998','2013-06-22','16:55:00',1.15),('8998','2013-06-22','17:00:00',1.1),('8998','2013-06-22','17:05:00',1.04),('8998','2013-06-21','07:40:00',1.13),('8998','2013-06-21','07:45:00',1.25),('8998','2013-06-21','07:50:00',1.27),('8998','2013-06-21','07:55:00',1.28),('8998','2013-06-21','08:00:00',1.32),('8998','2013-06-21','08:05:00',1.32),('8998','2013-06-21','08:10:00',1.38),('8998','2013-06-21','08:15:00',1.39),('8998','2013-06-21','08:20:00',1.45),('8998','2013-06-21','08:25:00',1.58),('8998','2013-06-21','08:30:00',1.69),('8998','2013-06-21','08:35:00',1.63),('8998','2013-06-21','08:40:00',1.69),('8998','2013-06-21','08:45:00',1.81),('8998','2013-06-21','08:50:00',2),('8998','2013-06-21','08:55:00',1.96),('8998','2013-06-21','09:00:00',1.85),('8998','2013-06-21','09:05:00',1.98),('8998','2013-06-21','09:10:00',2.19),('8998','2013-06-21','09:15:00',2.36),('8998','2013-06-21','09:20:00',2.42),('8998','2013-06-21','09:25:00',2.44),('8998','2013-06-21','09:30:00',2.45),('8998','2013-06-21','09:35:00',2.5),('8998','2013-06-21','09:40:00',2.53),('8998','2013-06-21','09:45:00',2.56),('8998','2013-06-21','09:50:00',2.58),('8998','2013-06-21','09:55:00',2.6),('8998','2013-06-21','10:00:00',2.64),('8998','2013-06-21','10:05:00',2.67),('8998','2013-06-21','10:10:00',2.69),('8998','2013-06-21','10:15:00',2.72),('8998','2013-06-21','10:20:00',2.74),('8998','2013-06-21','10:25:00',2.77),('8998','2013-06-21','10:30:00',2.76),('8998','2013-06-21','10:35:00',2.78),('8998','2013-06-21','10:40:00',2.81),('8998','2013-06-21','10:45:00',2.85),('8998','2013-06-21','10:50:00',2.86),('8998','2013-06-21','10:55:00',2.85),('8998','2013-06-21','11:00:00',2.86),('8998','2013-06-21','11:05:00',2.87),('8998','2013-06-21','11:10:00',2.89),('8998','2013-06-21','11:15:00',2.9),('8998','2013-06-21','11:20:00',2.92),('8998','2013-06-21','11:25:00',2.91),('8998','2013-06-21','11:30:00',2.9),('8998','2013-06-21','11:35:00',2.92),('8998','2013-06-21','11:40:00',2.91),('8998','2013-06-21','11:45:00',2.9),('8998','2013-06-21','11:50:00',2.9),('8998','2013-06-21','11:55:00',2.89),('8998','2013-06-21','12:00:00',2.9),('8998','2013-06-21','12:05:00',2.85),('8998','2013-06-21','12:10:00',2.78),('8998','2013-06-21','12:15:00',2.89),('8998','2013-06-21','12:20:00',2.89),('8998','2013-06-21','12:25:00',2.83),('8998','2013-06-21','12:30:00',2.86),('8998','2013-06-21','12:35:00',2.87),('8998','2013-06-21','12:40:00',2.87),('8998','2013-06-21','12:45:00',2.83),('8998','2013-06-21','12:50:00',2.76),('8998','2013-06-21','12:55:00',2.73),('8998','2013-06-21','13:00:00',2.69),('8998','2013-06-21','13:05:00',2.69),('8998','2013-06-21','13:10:00',2.64),('8998','2013-06-21','13:15:00',2.58),('8998','2013-06-21','13:20:00',2.48),('8998','2013-06-21','13:25:00',2.57),('8998','2013-06-21','13:30:00',2.81),('8998','2013-06-21','13:35:00',2.79),('8998','2013-06-21','13:40:00',2.55),('8998','2013-06-21','13:45:00',2.53),('8998','2013-06-21','13:50:00',2.71),('8998','2013-06-21','13:55:00',2.11),('8998','2013-06-21','14:00:00',1.4),('8998','2013-06-21','14:05:00',2.9),('8998','2013-06-21','14:10:00',2.74),('8998','2013-06-21','14:15:00',2.69),('8998','2013-06-21','14:20:00',2.12),('8998','2013-06-21','14:25:00',2.62),('8998','2013-06-21','14:30:00',1.89),('8998','2013-06-21','14:35:00',1.43),('8998','2013-06-21','14:40:00',1.1),('8998','2013-06-21','14:45:00',1.27),('8998','2013-06-21','14:50:00',2.04),('8998','2013-06-21','14:55:00',2.53),('8998','2013-06-21','15:00:00',2.33),('8998','2013-06-21','15:05:00',2.04),('8998','2013-06-21','15:10:00',2.12),('8998','2013-06-21','15:15:00',2.35),('8998','2013-06-21','15:20:00',2.13),('8998','2013-06-21','15:25:00',1.97),('8998','2013-06-21','15:30:00',1.27),('8998','2013-06-21','15:35:00',1.17),('8998','2013-06-21','15:40:00',1.12),('8998','2013-06-21','15:45:00',1.47),('8998','2013-06-21','15:50:00',1.49),('8998','2013-06-21','15:55:00',1.45),('8998','2013-06-21','16:00:00',1.28),('8998','2013-06-21','16:20:00',1.17),('8998','2013-06-21','17:10:00',1.06),('8998','2013-06-21','17:15:00',1.43),('8998','2013-06-21','17:20:00',1.34),('8998','2013-06-21','17:25:00',1.27),('8998','2013-06-21','17:30:00',1.06),('8998','2013-06-20','07:40:00',1.13),('8998','2013-06-20','07:45:00',1.27),('8998','2013-06-20','07:50:00',1.31),('8998','2013-06-20','07:55:00',1.32),('8998','2013-06-20','08:00:00',1.36),('8998','2013-06-20','08:05:00',1.38),('8998','2013-06-20','08:10:00',1.42),('8998','2013-06-20','08:15:00',1.42),('8998','2013-06-20','08:20:00',1.46),('8998','2013-06-20','08:25:00',1.59),('8998','2013-06-20','08:30:00',1.69),('8998','2013-06-20','08:35:00',1.62),('8998','2013-06-20','08:40:00',1.68),('8998','2013-06-20','08:45:00',1.58),('8998','2013-06-20','08:50:00',1.77),('8998','2013-06-20','08:55:00',1.85),('8998','2013-06-20','09:00:00',1.83),('8998','2013-06-20','09:05:00',1.96),('8998','2013-06-20','09:10:00',2.14),('8998','2013-06-20','09:15:00',2.28),('8998','2013-06-20','09:20:00',2.32),('8998','2013-06-20','09:25:00',2.37),('8998','2013-06-20','09:30:00',2.39),('8998','2013-06-20','09:35:00',2.41),('8998','2013-06-20','09:40:00',2.42),('8998','2013-06-20','09:45:00',2.46),('8998','2013-06-20','09:50:00',2.5),('8998','2013-06-20','09:55:00',2.49),('8998','2013-06-20','10:00:00',2.5),('8998','2013-06-20','10:05:00',2.51),('8998','2013-06-20','10:10:00',2.55),('8998','2013-06-20','10:15:00',2.57),('8998','2013-06-20','10:20:00',2.59),('8998','2013-06-20','10:25:00',2.59),('8998','2013-06-20','10:30:00',2.63),('8998','2013-06-20','10:35:00',2.65),('8998','2013-06-20','10:40:00',2.63),('8998','2013-06-20','10:45:00',2.63),('8998','2013-06-20','10:50:00',2.69),('8998','2013-06-20','10:55:00',2.71),('8998','2013-06-20','11:00:00',2.7),('8998','2013-06-20','11:05:00',2.69),('8998','2013-06-20','11:10:00',2.68),('8998','2013-06-20','11:15:00',2.75),('8998','2013-06-20','11:20:00',2.77),('8998','2013-06-20','11:25:00',2.78),('8998','2013-06-20','11:30:00',2.78),('8998','2013-06-20','11:35:00',2.75),('8998','2013-06-20','11:40:00',2.78),('8998','2013-06-20','11:45:00',2.77),('8998','2013-06-20','11:50:00',2.8),('8998','2013-06-20','11:55:00',2.81),('8998','2013-06-20','12:00:00',2.79),('8998','2013-06-20','12:05:00',2.79),('8998','2013-06-20','12:10:00',2.77),('8998','2013-06-20','12:15:00',2.76),('8998','2013-06-20','12:20:00',2.74),('8998','2013-06-20','12:25:00',2.7),('8998','2013-06-20','12:30:00',2.78),('8998','2013-06-20','12:35:00',2.74),('8998','2013-06-20','12:40:00',2.7),('8998','2013-06-20','12:45:00',2.71),('8998','2013-06-20','12:50:00',2.67),('8998','2013-06-20','12:55:00',2.66),('8998','2013-06-20','13:00:00',2.65),('8998','2013-06-20','13:05:00',2.59),('8998','2013-06-20','13:10:00',2.58),('8998','2013-06-20','13:15:00',2.61),('8998','2013-06-20','13:20:00',2.6),('8998','2013-06-20','13:25:00',2.61),('8998','2013-06-20','13:30:00',2.61),('8998','2013-06-20','13:35:00',2.62),('8998','2013-06-20','13:40:00',2.58),('8998','2013-06-20','13:45:00',2.54),('8998','2013-06-20','13:50:00',2.53),('8998','2013-06-20','13:55:00',2.54),('8998','2013-06-20','14:00:00',2.51),('8998','2013-06-20','14:05:00',2.52),('8998','2013-06-20','14:10:00',2.47),('8998','2013-06-20','14:15:00',2.43),('8998','2013-06-20','14:20:00',2.42),('8998','2013-06-20','14:25:00',2.39),('8998','2013-06-20','14:30:00',2.37),('8998','2013-06-20','14:35:00',2.35),('8998','2013-06-20','14:40:00',2.31),('8998','2013-06-20','14:45:00',2.29),('8998','2013-06-20','14:50:00',2.25),('8998','2013-06-20','14:55:00',2.22),('8998','2013-06-20','15:00:00',2.18),('8998','2013-06-20','15:05:00',2.14),('8998','2013-06-20','15:10:00',2.09),('8998','2013-06-20','15:15:00',2.05),('8998','2013-06-20','15:20:00',2.01),('8998','2013-06-20','15:25:00',1.97),('8998','2013-06-20','15:30:00',1.93),('8998','2013-06-20','15:35:00',1.88),('8998','2013-06-20','15:40:00',1.84),('8998','2013-06-20','15:45:00',1.79),('8998','2013-06-20','15:50:00',1.75),('8998','2013-06-20','15:55:00',1.7),('8998','2013-06-20','16:00:00',1.65),('8998','2013-06-20','16:05:00',1.6),('8998','2013-06-20','16:10:00',1.56),('8998','2013-06-20','16:15:00',1.51),('8998','2013-06-20','16:20:00',1.45),('8998','2013-06-20','16:25:00',1.41),('8998','2013-06-20','16:30:00',1.36),('8998','2013-06-20','16:35:00',1.3),('8998','2013-06-20','16:40:00',1.25),('8998','2013-06-20','16:45:00',1.2),('8998','2013-06-20','16:50:00',1.14),('8998','2013-06-20','16:55:00',1.09),('8998','2013-06-20','17:00:00',1.03),('8998','2014-04-03','09:10:00',1.1),('8998','2014-04-03','13:20:00',1.04),('8998','2014-04-03','13:25:00',1.88),('8998','2014-04-03','13:30:00',1.37),('8998','2014-04-03','13:35:00',1.98),('8998','2014-04-03','13:40:00',2.36),('8998','2014-04-03','13:45:00',2.26),('8998','2014-04-03','13:50:00',2.03),('8998','2014-04-03','13:55:00',1.92),('8998','2014-04-03','14:00:00',1.21),('8998','2014-04-03','14:05:00',3.06),('8998','2014-04-03','14:10:00',1.93),('8998','2014-04-03','14:15:00',2.84),('8998','2014-04-03','14:20:00',2.09),('8998','2014-04-03','14:25:00',2.12),('8998','2014-04-03','14:35:00',1.51),('8998','2014-04-03','14:40:00',1.27),('8998','2014-04-03','14:50:00',1.58),('8998','2014-04-03','14:55:00',1.82),('8998','2014-04-03','15:00:00',2.22),('8998','2014-04-03','15:05:00',2.14),('8998','2014-04-03','15:10:00',2.19),('8998','2014-04-03','15:15:00',1.43),('8998','2014-04-03','15:20:00',1.31),('8998','2014-04-03','15:25:00',1.06),('8998','2014-04-03','15:40:00',1.08),('8998','2014-04-03','15:45:00',1.18),('8998','2014-04-03','15:50:00',1.05),('8998','2014-04-03','15:55:00',1.46),('8998','2014-04-03','16:00:00',1.57),('8998','2014-04-03','16:05:00',1.24),('8998','2014-04-03','16:10:00',1.47),('8998','2014-04-03','16:15:00',1.09),('8998','2014-04-03','16:35:00',1.05),('8998','2014-04-03','16:45:00',1.22),('8998','2014-04-03','16:50:00',1.38),('8998','2013-06-19','07:30:00',1.04),('8998','2013-06-19','07:45:00',1.11),('8998','2013-06-19','07:50:00',1.22),('8998','2013-06-19','07:55:00',1.4),('8998','2013-06-19','08:00:00',1.48),('8998','2013-06-19','08:05:00',1.64),('8998','2013-06-19','08:10:00',1.7),('8998','2013-06-19','08:15:00',1.77),('8998','2013-06-19','08:20:00',1.73),('8998','2013-06-19','08:25:00',1.65),('8998','2013-06-19','08:30:00',1.65),('8998','2013-06-19','08:35:00',1.57),('8998','2013-06-19','08:40:00',1.64),('8998','2013-06-19','08:45:00',1.85),('8998','2013-06-19','08:50:00',2),('8998','2013-06-19','08:55:00',1.92),('8998','2013-06-19','09:00:00',1.79),('8998','2013-06-19','09:05:00',1.98),('8998','2013-06-19','09:10:00',2.24),('8998','2013-06-19','09:15:00',2.36),('8998','2013-06-19','09:20:00',2.42),('8998','2013-06-19','09:25:00',2.45),('8998','2013-06-19','09:30:00',2.48),('8998','2013-06-19','09:35:00',2.51),('8998','2013-06-19','09:40:00',2.53),('8998','2013-06-19','09:45:00',2.52),('8998','2013-06-19','09:50:00',2.57),('8998','2013-06-19','09:55:00',2.6),('8998','2013-06-19','10:00:00',2.64),('8998','2013-06-19','10:05:00',2.66),('8998','2013-06-19','10:10:00',2.69),('8998','2013-06-19','10:15:00',2.69),('8998','2013-06-19','10:20:00',2.71),('8998','2013-06-19','10:25:00',2.74),('8998','2013-06-19','10:30:00',2.74),('8998','2013-06-19','10:35:00',2.78),('8998','2013-06-19','10:40:00',2.77),('8998','2013-06-19','10:45:00',2.78),('8998','2013-06-19','10:50:00',2.76),('8998','2013-06-19','10:55:00',2.77),('8998','2013-06-19','11:00:00',2.79),('8998','2013-06-19','11:05:00',2.82),('8998','2013-06-19','11:10:00',2.83),('8998','2013-06-19','11:15:00',2.81),('8998','2013-06-19','11:20:00',2.82),('8998','2013-06-19','11:25:00',2.76),('8998','2013-06-19','11:30:00',2.77),('8998','2013-06-19','11:35:00',2.81),('8998','2013-06-19','11:40:00',2.82),('8998','2013-06-19','11:45:00',2.79),('8998','2013-06-19','11:50:00',2.8),('8998','2013-06-19','11:55:00',2.77),('8998','2013-06-19','12:00:00',2.75),('8998','2013-06-19','12:05:00',2.73),('8998','2013-06-19','12:10:00',2.72),('8998','2013-06-19','12:15:00',2.71),('8998','2013-06-19','12:20:00',2.65),('8998','2013-06-19','12:25:00',2.63),('8998','2013-06-19','12:30:00',2.6),('8998','2013-06-19','12:35:00',2.79),('8998','2013-06-19','12:40:00',2.77),('8998','2013-06-19','12:45:00',2.63),('8998','2013-06-19','12:50:00',2.75),('8998','2013-06-19','12:55:00',2.55),('8998','2013-06-19','13:00:00',1.45),('8998','2013-06-19','13:05:00',2.17),('8998','2013-06-19','13:10:00',2.84),('8998','2013-06-19','13:15:00',2.77),('8998','2013-06-19','13:20:00',2.64),('8998','2013-06-19','13:25:00',2.63),('8998','2013-06-19','13:30:00',2.18),('8998','2013-06-19','13:35:00',2.58),('8998','2013-06-19','13:40:00',2.59),('8998','2013-06-19','13:45:00',2.6),('8998','2013-06-19','13:50:00',2.55),('8998','2013-06-19','13:55:00',2.51),('8998','2013-06-19','14:00:00',2.52),('8998','2013-06-19','14:05:00',2.55),('8998','2013-06-19','14:10:00',2.53),('8998','2013-06-19','14:15:00',2.49),('8998','2013-06-19','14:20:00',2.46),('8998','2013-06-19','14:25:00',2.43),('8998','2013-06-19','14:30:00',2.39),('8998','2013-06-19','14:35:00',2.39),('8998','2013-06-19','14:40:00',2.39),('8998','2013-06-19','14:45:00',2.34),('8998','2013-06-19','14:50:00',2.32),('8998','2013-06-19','14:55:00',2.28),('8998','2013-06-19','15:00:00',2.24),('8998','2013-06-19','15:05:00',2.19),('8998','2013-06-19','15:10:00',2.15),('8998','2013-06-19','15:15:00',2.11),('8998','2013-06-19','15:20:00',2.06),('8998','2013-06-19','15:25:00',2.02),('8998','2013-06-19','15:30:00',1.98),('8998','2013-06-19','15:35:00',1.93),('8998','2013-06-19','15:40:00',1.88),('8998','2013-06-19','15:45:00',1.83),('8998','2013-06-19','15:50:00',1.78),('8998','2013-06-19','15:55:00',1.73),('8998','2013-06-19','16:00:00',1.68),('8998','2013-06-19','16:05:00',1.64),('8998','2013-06-19','16:10:00',1.59),('8998','2013-06-19','16:15:00',1.53),('8998','2013-06-19','16:20:00',1.47),('8998','2013-06-19','16:25:00',1.42),('8998','2013-06-19','16:30:00',1.37),('8998','2013-06-19','16:35:00',1.31),('8998','2013-06-19','16:40:00',1.26),('8998','2013-06-19','16:45:00',1.19),('8998','2013-06-19','16:50:00',1.14),('8998','2013-06-19','16:55:00',1.1),('8998','2013-06-19','17:00:00',1.04),('8998','2013-06-18','07:40:00',1.07),('8998','2013-06-18','07:45:00',1.2),('8998','2013-06-18','07:50:00',1.22),('8998','2013-06-18','07:55:00',1.23),('8998','2013-06-18','08:00:00',1.26),('8998','2013-06-18','08:05:00',1.28),('8998','2013-06-18','08:10:00',1.33),('8998','2013-06-18','08:15:00',1.34),('8998','2013-06-18','08:20:00',1.66),('8998','2013-06-18','08:25:00',1.6),('8998','2013-06-18','08:30:00',1.6),('8998','2013-06-18','08:35:00',1.55),('8998','2013-06-18','08:40:00',1.61),('8998','2013-06-18','08:45:00',1.79),('8998','2013-06-18','08:50:00',1.95),('8998','2013-06-18','08:55:00',1.89),('8998','2013-06-18','09:00:00',1.77),('8998','2013-06-18','09:05:00',1.95),('8998','2013-06-18','09:10:00',2.16),('8998','2013-06-18','09:15:00',2.32),('8998','2013-06-18','09:20:00',2.37),('8998','2013-06-18','09:25:00',2.39),('8998','2013-06-18','09:30:00',2.42),('8998','2013-06-18','09:35:00',2.45),('8998','2013-06-18','09:40:00',2.47),('8998','2013-06-18','09:45:00',2.5),('8998','2013-06-18','09:50:00',2.52),('8998','2013-06-18','09:55:00',2.55),('8998','2013-06-18','10:00:00',2.56),('8998','2013-06-18','10:05:00',2.58),('8998','2013-06-18','10:10:00',2.6),('8998','2013-06-18','10:15:00',2.63),('8998','2013-06-18','10:20:00',2.65),('8998','2013-06-18','10:25:00',2.65),('8998','2013-06-18','10:30:00',2.64),('8998','2013-06-18','10:35:00',2.65),('8998','2013-06-18','10:40:00',2.65),('8998','2013-06-18','10:45:00',2.69),('8998','2013-06-18','10:50:00',2.69),('8998','2013-06-18','10:55:00',2.7),('8998','2013-06-18','11:00:00',2.67),('8998','2013-06-18','11:05:00',2.71),('8998','2013-06-18','11:10:00',2.72),('8998','2013-06-18','11:15:00',2.71),('8998','2013-06-18','11:20:00',2.71),('8998','2013-06-18','11:25:00',2.69),('8998','2013-06-18','11:30:00',2.7),('8998','2013-06-18','11:35:00',2.73),('8998','2013-06-18','11:40:00',2.76),('8998','2013-06-18','11:45:00',2.75),('8998','2013-06-18','11:50:00',2.71),('8998','2013-06-18','11:55:00',2.68),('8998','2013-06-18','12:00:00',2.73),('8998','2013-06-18','12:05:00',2.68),('8998','2013-06-18','12:10:00',2.73),('8998','2013-06-18','12:15:00',2.7),('8998','2013-06-18','12:20:00',2.71),('8998','2013-06-18','12:25:00',2.71),('8998','2013-06-18','12:30:00',2.73),('8998','2013-06-18','12:35:00',2.73),('8998','2013-06-18','12:40:00',2.68),('8998','2013-06-18','12:45:00',2.71),('8998','2013-06-18','12:50:00',2.69),('8998','2013-06-18','12:55:00',2.68),('8998','2013-06-18','13:00:00',2.64),('8998','2013-06-18','13:05:00',2.62),('8998','2013-06-18','13:10:00',2.61),('8998','2013-06-18','13:15:00',2.61),('8998','2013-06-18','13:20:00',2.57),('8998','2013-06-18','13:25:00',2.61),('8998','2013-06-18','13:30:00',2.61),('8998','2013-06-18','13:35:00',2.59),('8998','2013-06-18','13:40:00',2.58),('8998','2013-06-18','13:45:00',2.55),('8998','2013-06-18','13:50:00',2.51),('8998','2013-06-18','13:55:00',2.53),('8998','2013-06-18','14:00:00',2.52),('8998','2013-06-18','14:05:00',2.49),('8998','2013-06-18','14:10:00',2.45),('8998','2013-06-18','14:15:00',2.41),('8998','2013-06-18','14:20:00',2.37),('8998','2013-06-18','14:25:00',2.34),('8998','2013-06-18','14:30:00',2.31),('8998','2013-06-18','14:35:00',2.27),('8998','2013-06-18','14:40:00',2.24),('8998','2013-06-18','14:45:00',2.21),('8998','2013-06-18','14:50:00',2.18),('8998','2013-06-18','14:55:00',2.14),('8998','2013-06-18','15:00:00',2.12),('8998','2013-06-18','15:05:00',2.08),('8998','2013-06-18','15:10:00',2.04),('8998','2013-06-18','15:15:00',2),('8998','2013-06-18','15:20:00',1.97),('8998','2013-06-18','15:25:00',1.94),('8998','2013-06-18','15:30:00',1.9),('8998','2013-06-18','15:35:00',1.85),('8998','2013-06-18','15:40:00',1.8),('8998','2013-06-18','15:45:00',1.76),('8998','2013-06-18','15:50:00',1.7),('8998','2013-06-18','15:55:00',1.65),('8998','2013-06-18','16:00:00',1.6),('8998','2013-06-18','16:05:00',1.55),('8998','2013-06-18','16:10:00',1.51),('8998','2013-06-18','16:15:00',1.46),('8998','2013-06-18','16:20:00',1.4),('8998','2013-06-18','16:25:00',1.36),('8998','2013-06-18','16:30:00',1.31),('8998','2013-06-18','16:35:00',1.26),('8998','2013-06-18','16:40:00',1.21),('8998','2013-06-18','16:45:00',1.16),('8998','2013-06-18','16:50:00',1.11),('8998','2013-06-18','16:55:00',1.07),('8998','2013-06-18','17:00:00',1.02),('8998','2013-06-17','07:40:00',1.08),('8998','2013-06-17','07:45:00',1.2),('8998','2013-06-17','07:50:00',1.22),('8998','2013-06-17','07:55:00',1.22),('8998','2013-06-17','08:00:00',1.25),('8998','2013-06-17','08:05:00',1.27),('8998','2013-06-17','08:10:00',1.33),('8998','2013-06-17','08:15:00',1.33),('8998','2013-06-17','08:20:00',1.39),('8998','2013-06-17','08:25:00',1.55),('8998','2013-06-17','08:30:00',1.6),('8998','2013-06-17','08:35:00',1.54),('8998','2013-06-17','08:40:00',1.6),('8998','2013-06-17','08:45:00',1.64),('8998','2013-06-17','08:50:00',1.92),('8998','2013-06-17','08:55:00',1.87),('8998','2013-06-17','09:00:00',1.75),('8998','2013-06-17','09:05:00',1.94),('8998','2013-06-17','09:10:00',2.12),('8998','2013-06-17','09:15:00',2.3),('8998','2013-06-17','09:20:00',2.34),('8998','2013-06-17','09:25:00',2.38),('8998','2013-06-17','09:30:00',2.4),('8998','2013-06-17','09:35:00',2.42),('8998','2013-06-17','09:40:00',2.45),('8998','2013-06-17','09:45:00',2.45),('8998','2013-06-17','09:50:00',2.48),('8998','2013-06-17','09:55:00',2.49),('8998','2013-06-17','10:00:00',2.52),('8998','2013-06-17','10:05:00',2.52),('8998','2013-06-17','10:10:00',2.56),('8998','2013-06-17','10:15:00',2.59),('8998','2013-06-17','10:20:00',2.62),('8998','2013-06-17','10:25:00',2.63),('8998','2013-06-17','10:30:00',2.61),('8998','2013-06-17','10:35:00',2.59),('8998','2013-06-17','10:40:00',2.63),('8998','2013-06-17','10:45:00',2.66),('8998','2013-06-17','10:50:00',2.67),('8998','2013-06-17','10:55:00',2.7),('8998','2013-06-17','11:00:00',2.71),('8998','2013-06-17','11:05:00',2.72),('8998','2013-06-17','11:10:00',2.74),('8998','2013-06-17','11:15:00',2.75),('8998','2013-06-17','11:20:00',2.74),('8998','2013-06-17','11:25:00',2.74),('8998','2013-06-17','11:30:00',2.76),('8998','2013-06-17','11:35:00',2.76),('8998','2013-06-17','11:40:00',2.7),('8998','2013-06-17','11:45:00',2.71),('8998','2013-06-17','11:50:00',2.73),('8998','2013-06-17','11:55:00',2.7),('8998','2013-06-17','12:00:00',2.67),('8998','2013-06-17','12:05:00',2.67),('8998','2013-06-17','12:10:00',2.65),('8998','2013-06-17','12:15:00',2.61),('8998','2013-06-17','12:20:00',2.62),('8998','2013-06-17','12:25:00',2.62),('8998','2013-06-17','12:30:00',2.64),('8998','2013-06-17','12:35:00',2.62),('8998','2013-06-17','12:40:00',2.5),('8998','2013-06-17','12:45:00',2.03),('8998','2013-06-17','12:50:00',1.63),('8998','2013-06-17','12:55:00',2.61),('8998','2013-06-17','13:00:00',2.69),('8998','2013-06-17','13:05:00',1.51),('8998','2013-06-17','13:10:00',1.87),('8998','2013-06-17','13:15:00',2.72),('8998','2013-06-17','13:20:00',2.73),('8998','2013-06-17','13:25:00',2.72),('8998','2013-06-17','13:30:00',1.73),('8998','2013-06-17','13:35:00',2.6),('8998','2013-06-17','13:40:00',2.61),('8998','2013-06-17','13:45:00',2.59),('8998','2013-06-17','13:50:00',2.6),('8998','2013-06-17','13:55:00',2.63),('8998','2013-06-17','14:00:00',2.58),('8998','2013-06-17','14:05:00',2.59),('8998','2013-06-17','14:10:00',2.53),('8998','2013-06-17','14:15:00',2.48),('8998','2013-06-17','14:20:00',2.42),('8998','2013-06-17','14:25:00',2.41),('8998','2013-06-17','14:30:00',2.38),('8998','2013-06-17','14:35:00',2.37),('8998','2013-06-17','14:40:00',2.37),('8998','2013-06-17','14:45:00',2.3),('8998','2013-06-17','14:50:00',2.27),('8998','2013-06-17','14:55:00',2.23),('8998','2013-06-17','15:00:00',2.21),('8998','2013-06-17','15:05:00',2.15),('8998','2013-06-17','15:10:00',2.1),('8998','2013-06-17','15:15:00',2.06),('8998','2013-06-17','15:20:00',2.02),('8998','2013-06-17','15:25:00',1.99),('8998','2013-06-17','15:30:00',1.95),('8998','2013-06-17','15:35:00',1.92),('8998','2013-06-17','15:40:00',1.9),('8998','2013-06-17','15:45:00',1.88),('8998','2013-06-17','15:50:00',1.83),('8998','2013-06-17','15:55:00',1.81),('8998','2013-06-17','16:00:00',1.78),('8998','2013-06-17','16:05:00',1.75),('8998','2013-06-17','16:10:00',1.71),('8998','2013-06-17','16:15:00',1.67),('8998','2013-06-17','16:20:00',1.6),('8998','2013-06-17','16:25:00',1.47),('8998','2013-06-17','16:30:00',1.37),('8998','2013-06-17','16:35:00',1.34),('8998','2013-06-17','16:40:00',1.29),('8998','2013-06-17','16:45:00',1.21),('8998','2013-06-17','16:50:00',1.15),('8998','2013-06-17','16:55:00',1.1),('8998','2013-06-17','17:00:00',1.05),('8998','2013-06-16','07:35:00',1.01),('8998','2013-06-16','07:40:00',1.18),('8998','2013-06-16','07:45:00',1.28),('8998','2013-06-16','07:50:00',1.39),('8998','2013-06-16','07:55:00',1.54),('8998','2013-06-16','08:00:00',1.64),('8998','2013-06-16','08:05:00',1.71),('8998','2013-06-16','08:10:00',1.76),('8998','2013-06-16','08:15:00',1.81),('8998','2013-06-16','08:20:00',1.73),('8998','2013-06-16','08:25:00',1.66),('8998','2013-06-16','08:30:00',1.65),('8998','2013-06-16','08:35:00',1.6),('8998','2013-06-16','08:40:00',1.64),('8998','2013-06-16','08:45:00',1.85),('8998','2013-06-16','08:50:00',2.01),('8998','2013-06-16','08:55:00',1.94),('8998','2013-06-16','09:00:00',1.82),('8998','2013-06-16','09:05:00',2.04),('8998','2013-06-16','09:10:00',2.27),('8998','2013-06-16','09:15:00',2.4),('8998','2013-06-16','09:20:00',2.43),('8998','2013-06-16','09:25:00',2.47),('8998','2013-06-16','09:30:00',2.51),('8998','2013-06-16','09:35:00',2.54),('8998','2013-06-16','09:40:00',2.56),('8998','2013-06-16','09:45:00',2.59),('8998','2013-06-16','09:50:00',2.62),('8998','2013-06-16','09:55:00',2.63),('8998','2013-06-16','10:00:00',2.65),('8998','2013-06-16','10:05:00',2.66),('8998','2013-06-16','10:10:00',2.68),('8998','2013-06-16','10:15:00',2.7),('8998','2013-06-16','10:20:00',2.72),('8998','2013-06-16','10:25:00',2.74),('8998','2013-06-16','10:30:00',2.75),('8998','2013-06-16','10:35:00',2.76),('8998','2013-06-16','10:40:00',2.78),('8998','2013-06-16','10:45:00',2.8),('8998','2013-06-16','10:50:00',2.8),('8998','2013-06-16','10:55:00',2.83),('8998','2013-06-16','11:00:00',2.81),('8998','2013-06-16','11:05:00',2.81),('8998','2013-06-16','11:10:00',2.81),('8998','2013-06-16','11:15:00',2.81),('8998','2013-06-16','11:20:00',2.84),('8998','2013-06-16','11:25:00',2.84),('8998','2013-06-16','11:30:00',2.83),('8998','2013-06-16','11:35:00',2.83),('8998','2013-06-16','11:40:00',2.81),('8998','2013-06-16','11:45:00',2.81),('8998','2013-06-16','11:50:00',2.79),('8998','2013-06-16','11:55:00',2.78),('8998','2013-06-16','12:00:00',2.77),('8998','2013-06-16','12:05:00',2.78),('8998','2013-06-16','12:10:00',2.78),('8998','2013-06-16','12:15:00',2.78),('8998','2013-06-16','12:20:00',2.79),('8998','2013-06-16','12:25:00',2.76),('8998','2013-06-16','12:30:00',2.75),('8998','2013-06-16','12:35:00',2.74),('8998','2013-06-16','12:40:00',2.73),('8998','2013-06-16','12:45:00',2.71),('8998','2013-06-16','12:50:00',2.72),('8998','2013-06-16','12:55:00',2.72),('8998','2013-06-16','13:00:00',2.74),('8998','2013-06-16','13:05:00',2.73),('8998','2013-06-16','13:10:00',2.71),('8998','2013-06-16','13:15:00',2.71),('8998','2013-06-16','13:20:00',2.67),('8998','2013-06-16','13:25:00',2.65),('8998','2013-06-16','13:30:00',2.65),('8998','2013-06-16','13:35:00',2.62),('8998','2013-06-16','13:40:00',2.6),('8998','2013-06-16','13:45:00',2.57),('8998','2013-06-16','13:50:00',2.54),('8998','2013-06-16','13:55:00',2.53),('8998','2013-06-16','14:00:00',2.51),('8998','2013-06-16','14:05:00',2.49),('8998','2013-06-16','14:10:00',2.46),('8998','2013-06-16','14:15:00',2.44),('8998','2013-06-16','14:20:00',2.43),('8998','2013-06-16','14:25:00',2.39),('8998','2013-06-16','14:30:00',2.36),('8998','2013-06-16','14:35:00',2.34),('8998','2013-06-16','14:40:00',2.31),('8998','2013-06-16','14:45:00',2.27),('8998','2013-06-16','14:50:00',2.23),('8998','2013-06-16','14:55:00',2.19),('8998','2013-06-16','15:00:00',2.15),('8998','2013-06-16','15:05:00',2.1),('8998','2013-06-16','15:10:00',2.06),('8998','2013-06-16','15:15:00',2.02),('8998','2013-06-16','15:20:00',1.99),('8998','2013-06-16','15:25:00',1.94),('8998','2013-06-16','15:30:00',1.91),('8998','2013-06-16','15:35:00',1.88),('8998','2013-06-16','15:40:00',1.82),('8998','2013-06-16','15:45:00',1.78),('8998','2013-06-16','15:50:00',1.74),('8998','2013-06-16','15:55:00',1.69),('8998','2013-06-16','16:00:00',1.65),('8998','2013-06-16','16:05:00',1.6),('8998','2013-06-16','16:10:00',1.56),('8998','2013-06-16','16:15:00',1.51),('8998','2013-06-16','16:20:00',1.47),('8998','2013-06-16','16:25:00',1.42),('8998','2013-06-16','16:30:00',1.37),('8998','2013-06-16','16:35:00',1.33),('8998','2013-06-16','16:40:00',1.28),('8998','2013-06-16','16:45:00',1.23),('8998','2013-06-16','16:50:00',1.18),('8998','2013-06-16','16:55:00',1.13),('8998','2013-06-16','17:00:00',1.09),('8998','2013-06-16','17:05:00',1.04),('8998','2013-06-15','07:35:00',1.03),('8998','2013-06-15','07:40:00',1.19),('8998','2013-06-15','07:45:00',1.32),('8998','2013-06-15','07:50:00',1.32),('8998','2013-06-15','07:55:00',1.32),('8998','2013-06-15','08:00:00',1.34),('8998','2013-06-15','08:05:00',1.49),('8998','2013-06-15','08:10:00',1.75),('8998','2013-06-15','08:15:00',1.82),('8998','2013-06-15','08:20:00',1.75),('8998','2013-06-15','08:25:00',1.7),('8998','2013-06-15','08:30:00',1.67),('8998','2013-06-15','08:35:00',1.64),('8998','2013-06-15','08:40:00',1.66),('8998','2013-06-15','08:45:00',1.98),('8998','2013-06-15','08:50:00',2.01),('8998','2013-06-15','08:55:00',2.12),('8998','2013-06-15','09:00:00',2.25),('8998','2013-06-15','09:05:00',2.29),('8998','2013-06-15','09:10:00',2.34),('8998','2013-06-15','09:15:00',2.47),('8998','2013-06-15','09:20:00',2.52),('8998','2013-06-15','09:25:00',2.54),('8998','2013-06-15','09:30:00',2.55),('8998','2013-06-15','09:35:00',2.6),('8998','2013-06-15','09:40:00',2.62),('8998','2013-06-15','09:45:00',2.63),('8998','2013-06-15','09:50:00',2.65),('8998','2013-06-15','09:55:00',2.66),('8998','2013-06-15','10:00:00',2.68),('8998','2013-06-15','10:05:00',2.7),('8998','2013-06-15','10:10:00',2.7),('8998','2013-06-15','10:15:00',2.75),('8998','2013-06-15','10:20:00',2.75),('8998','2013-06-15','10:25:00',2.77),('8998','2013-06-15','10:30:00',2.79),('8998','2013-06-15','10:35:00',2.81),('8998','2013-06-15','10:40:00',2.83),('8998','2013-06-15','10:45:00',2.83),('8998','2013-06-15','10:50:00',2.85),('8998','2013-06-15','10:55:00',2.84),('8998','2013-06-15','11:00:00',2.85),('8998','2013-06-15','11:05:00',2.85),('8998','2013-06-15','11:10:00',2.86),('8998','2013-06-15','11:15:00',2.86),('8998','2013-06-15','11:20:00',2.86),('8998','2013-06-15','11:25:00',2.88),('8998','2013-06-15','11:30:00',2.9),('8998','2013-06-15','11:35:00',2.94),('8998','2013-06-15','11:40:00',2.93),('8998','2013-06-15','11:45:00',2.9),('8998','2013-06-15','11:50:00',2.91),('8998','2013-06-15','11:55:00',2.93),('8998','2013-06-15','12:00:00',2.94),('8998','2013-06-15','12:05:00',2.93),('8998','2013-06-15','12:10:00',2.93),('8998','2013-06-15','12:15:00',2.92),('8998','2013-06-15','12:20:00',2.9),('8998','2013-06-15','12:25:00',2.9),('8998','2013-06-15','12:30:00',2.89),('8998','2013-06-15','12:35:00',2.87),('8998','2013-06-15','12:40:00',2.85),('8998','2013-06-15','12:45:00',2.82),('8998','2013-06-15','12:50:00',2.81),('8998','2013-06-15','12:55:00',2.81),('8998','2013-06-15','13:00:00',2.81),('8998','2013-06-15','13:05:00',2.8),('8998','2013-06-15','13:10:00',2.8),('8998','2013-06-15','13:15:00',2.78),('8998','2013-06-15','13:20:00',2.76),('8998','2013-06-15','13:25:00',2.74),('8998','2013-06-15','13:30:00',2.73),('8998','2013-06-15','13:35:00',2.71),('8998','2013-06-15','13:40:00',2.68),('8998','2013-06-15','13:45:00',2.65),('8998','2013-06-15','13:50:00',2.63),('8998','2013-06-15','13:55:00',2.6),('8998','2013-06-15','14:00:00',2.6),('8998','2013-06-15','14:05:00',2.57),('8998','2013-06-15','14:10:00',2.55),('8998','2013-06-15','14:15:00',2.52),('8998','2013-06-15','14:20:00',2.48),('8998','2013-06-15','14:25:00',2.45),('8998','2013-06-15','14:30:00',2.41),('8998','2013-06-15','14:35:00',2.38),('8998','2013-06-15','14:40:00',2.34),('8998','2013-06-15','14:45:00',2.3),('8998','2013-06-15','14:50:00',2.26),('8998','2013-06-15','14:55:00',2.23),('8998','2013-06-15','15:00:00',2.19),('8998','2013-06-15','15:05:00',2.16),('8998','2013-06-15','15:10:00',2.12),('8998','2013-06-15','15:15:00',2.08),('8998','2013-06-15','15:20:00',2.04),('8998','2013-06-15','15:25:00',2.01),('8998','2013-06-15','15:30:00',1.96),('8998','2013-06-15','15:35:00',1.91),('8998','2013-06-15','15:40:00',1.87),('8998','2013-06-15','15:45:00',1.82),('8998','2013-06-15','15:50:00',1.77),('8998','2013-06-15','15:55:00',1.72),('8998','2013-06-15','16:00:00',1.67),('8998','2013-06-15','16:05:00',1.62),('8998','2013-06-15','16:10:00',1.57),('8998','2013-06-15','16:15:00',1.52),('8998','2013-06-15','16:20:00',1.47),('8998','2013-06-15','16:25:00',1.41),('8998','2013-06-15','16:30:00',1.36),('8998','2013-06-15','16:35:00',1.31),('8998','2013-06-15','16:40:00',1.26),('8998','2013-06-15','16:45:00',1.2),('8998','2013-06-15','16:50:00',1.14),('8998','2013-06-15','16:55:00',1.09),('8998','2013-06-15','17:00:00',1.04),('8998','2013-06-14','07:40:00',1.11),('8998','2013-06-14','07:45:00',1.18),('8998','2013-06-14','07:50:00',1.22),('8998','2013-06-14','07:55:00',1.29),('8998','2013-06-14','08:00:00',1.31),('8998','2013-06-14','08:05:00',1.35),('8998','2013-06-14','08:10:00',1.39),('8998','2013-06-14','08:15:00',1.67),('8998','2013-06-14','08:20:00',1.69),('8998','2013-06-14','08:25:00',1.66),('8998','2013-06-14','08:30:00',1.63),('8998','2013-06-14','08:35:00',1.63),('8998','2013-06-14','08:40:00',1.66),('8998','2013-06-14','08:45:00',1.66),('8998','2013-06-14','08:50:00',1.83),('8998','2013-06-14','08:55:00',1.85),('8998','2013-06-14','09:00:00',1.84),('8998','2013-06-14','09:05:00',2.09),('8998','2013-06-14','09:10:00',2.25),('8998','2013-06-14','09:15:00',2.42),('8998','2013-06-14','09:20:00',2.45),('8998','2013-06-14','09:25:00',2.42),('8998','2013-06-14','09:30:00',2.48),('8998','2013-06-14','09:35:00',2.26),('8998','2013-06-14','09:40:00',2.48),('8998','2013-06-14','09:45:00',2.37),('8998','2013-06-14','09:50:00',2.6),('8998','2013-06-14','09:55:00',2.61),('8998','2013-06-14','10:00:00',1.78),('8998','2013-06-14','10:05:00',1.33),('8998','2013-06-14','10:10:00',1.53),('8998','2013-06-14','10:15:00',2.33),('8998','2013-06-14','10:20:00',2.61),('8998','2013-06-14','10:25:00',2.57),('8998','2013-06-14','10:30:00',2.77),('8998','2013-06-14','10:35:00',2.92),('8998','2013-06-14','10:40:00',2.87),('8998','2013-06-14','10:45:00',2.78),('8998','2013-06-14','10:50:00',2.92),('8998','2013-06-14','10:55:00',2.92),('8998','2013-06-14','11:00:00',1.82),('8998','2013-06-14','11:05:00',1.33),('8998','2013-06-14','11:10:00',2.58),('8998','2013-06-14','11:15:00',2.67),('8998','2013-06-14','11:20:00',2.9),('8998','2013-06-14','11:25:00',2.75),('8998','2013-06-14','11:30:00',2.32),('8998','2013-06-14','11:35:00',2.61),('8998','2013-06-14','11:40:00',1.85),('8998','2013-06-14','11:45:00',1.46),('8998','2013-06-14','11:50:00',1.6),('8998','2013-06-14','11:55:00',3.22),('8998','2013-06-14','12:00:00',3.14),('8998','2013-06-14','12:05:00',2.82),('8998','2013-06-14','12:10:00',3.09),('8998','2013-06-14','12:15:00',3.11),('8998','2013-06-14','12:20:00',3.06),('8998','2013-06-14','12:25:00',2.99),('8998','2013-06-14','12:30:00',2.98),('8998','2013-06-14','12:35:00',2.97),('8998','2013-06-14','12:40:00',2.94),('8998','2013-06-14','12:45:00',2.91),('8998','2013-06-14','12:50:00',2.87),('8998','2013-06-14','12:55:00',2.86),('8998','2013-06-14','13:00:00',2.86),('8998','2013-06-14','13:05:00',2.83),('8998','2013-06-14','13:10:00',2.82),('8998','2013-06-14','13:15:00',2.82),('8998','2013-06-14','13:20:00',2.78),('8998','2013-06-14','13:25:00',2.75),('8998','2013-06-14','13:30:00',2.74),('8998','2013-06-14','13:35:00',2.71),('8998','2013-06-14','13:40:00',2.69),('8998','2013-06-14','13:45:00',2.68),('8998','2013-06-14','13:50:00',2.66),('8998','2013-06-14','13:55:00',2.62),('8998','2013-06-14','14:00:00',2.6),('8998','2013-06-14','14:05:00',2.57),('8998','2013-06-14','14:10:00',2.54),('8998','2013-06-14','14:15:00',2.51),('8998','2013-06-14','14:20:00',2.48),('8998','2013-06-14','14:25:00',2.43),('8998','2013-06-14','14:30:00',2.4),('8998','2013-06-14','14:35:00',2.36),('8998','2013-06-14','14:40:00',2.34),('8998','2013-06-14','14:45:00',2.31),('8998','2013-06-14','14:50:00',2.25),('8998','2013-06-14','14:55:00',2.25),('8998','2013-06-14','15:00:00',2.2),('8998','2013-06-14','15:05:00',2.15),('8998','2013-06-14','15:10:00',2.12),('8998','2013-06-14','15:15:00',2.09),('8998','2013-06-14','15:20:00',2.05),('8998','2013-06-14','15:25:00',2.01),('8998','2013-06-14','15:30:00',1.97),('8998','2013-06-14','15:35:00',1.92),('8998','2013-06-14','15:40:00',1.87),('8998','2013-06-14','15:45:00',1.82),('8998','2013-06-14','15:50:00',1.77),('8998','2013-06-14','15:55:00',1.72),('8998','2013-06-14','16:00:00',1.67),('8998','2013-06-14','16:05:00',1.62),('8998','2013-06-14','16:10:00',1.56),('8998','2013-06-14','16:15:00',1.51),('8998','2013-06-14','16:20:00',1.46),('8998','2013-06-14','16:25:00',1.41),('8998','2013-06-14','16:30:00',1.36),('8998','2013-06-14','16:35:00',1.31),('8998','2013-06-14','16:40:00',1.25),('8998','2013-06-14','16:45:00',1.2),('8998','2013-06-14','16:50:00',1.15),('8998','2013-06-14','16:55:00',1.09),('8998','2013-06-14','17:00:00',1.05),('8998','2013-06-13','07:30:00',1.01),('8998','2013-06-13','07:35:00',1.09),('8998','2013-06-13','07:40:00',1.29),('8998','2013-06-13','07:45:00',1.39),('8998','2013-06-13','07:50:00',1.38),('8998','2013-06-13','07:55:00',1.37),('8998','2013-06-13','08:00:00',1.36),('8998','2013-06-13','08:05:00',1.51),('8998','2013-06-13','08:10:00',1.9),('8998','2013-06-13','08:15:00',1.93),('8998','2013-06-13','08:20:00',1.8),('8998','2013-06-13','08:25:00',1.74),('8998','2013-06-13','08:30:00',1.69),('8998','2013-06-13','08:35:00',1.67),('8998','2013-06-13','08:40:00',1.69),('8998','2013-06-13','08:45:00',2.08),('8998','2013-06-13','08:50:00',2.08),('8998','2013-06-13','08:55:00',1.98),('8998','2013-06-13','09:00:00',1.87),('8998','2013-06-13','09:05:00',2.16),('8998','2013-06-13','09:10:00',2.36),('8998','2013-06-13','09:15:00',2.55),('8998','2013-06-13','09:20:00',2.58),('8998','2013-06-13','09:25:00',2.61),('8998','2013-06-13','09:30:00',2.63),('8998','2013-06-13','09:35:00',2.67),('8998','2013-06-13','09:40:00',2.71),('8998','2013-06-13','09:45:00',2.75),('8998','2013-06-13','09:50:00',2.77),('8998','2013-06-13','09:55:00',2.8),('8998','2013-06-13','10:00:00',2.83),('8998','2013-06-13','10:05:00',2.83),('8998','2013-06-13','10:10:00',2.81),('8998','2013-06-13','10:15:00',2.83),('8998','2013-06-13','10:20:00',2.88),('8998','2013-06-13','10:25:00',2.83),('8998','2013-06-13','10:30:00',2.9),('8998','2013-06-13','10:35:00',2.95),('8998','2013-06-13','10:40:00',2.93),('8998','2013-06-13','10:45:00',2.95),('8998','2013-06-13','10:50:00',2.94),('8998','2013-06-13','10:55:00',2.9),('8998','2013-06-13','11:00:00',2.88),('8998','2013-06-13','11:05:00',2.91),('8998','2013-06-13','11:10:00',2.96),('8998','2013-06-13','11:15:00',3),('8998','2013-06-13','11:20:00',2.96),('8998','2013-06-13','11:25:00',2.89),('8998','2013-06-13','11:30:00',3.03),('8998','2013-06-13','11:35:00',3.01),('8998','2013-06-13','11:40:00',3),('8998','2013-06-13','11:45:00',2.99),('8998','2013-06-13','11:50:00',3.01),('8998','2013-06-13','11:55:00',2.98),('8998','2013-06-13','12:00:00',2.96),('8998','2013-06-13','12:05:00',2.93),('8998','2013-06-13','12:10:00',2.96),('8998','2013-06-13','12:15:00',2.95),('8998','2013-06-13','12:20:00',2.93),('8998','2013-06-13','12:25:00',2.92),('8998','2013-06-13','12:30:00',2.91),('8998','2013-06-13','12:35:00',2.88),('8998','2013-06-13','12:40:00',2.88),('8998','2013-06-13','12:45:00',2.87),('8998','2013-06-13','12:50:00',2.82),('8998','2013-06-13','12:55:00',2.81),('8998','2013-06-13','13:00:00',2.8),('8998','2013-06-13','13:05:00',2.83),('8998','2013-06-13','13:10:00',2.02),('8998','2013-06-13','13:15:00',1.33),('8998','2013-06-13','13:20:00',1.89),('8998','2013-06-13','13:30:00',2.23),('8998','2013-06-13','13:35:00',2.46),('8998','2013-06-13','13:40:00',2.76),('8998','2013-06-13','13:45:00',2.69),('8998','2013-06-13','13:50:00',2.7),('8998','2013-06-13','13:55:00',2.66),('8998','2013-06-13','14:00:00',2.6),('8998','2013-06-13','14:05:00',2.64),('8998','2013-06-13','14:10:00',2.62),('8998','2013-06-13','14:15:00',2.58),('8998','2013-06-13','14:20:00',2.52),('8998','2013-06-13','14:25:00',2.49),('8998','2013-06-13','14:30:00',2.48),('8998','2013-06-13','14:35:00',2.46),('8998','2013-06-13','14:40:00',2.4),('8998','2013-06-13','14:45:00',2.34),('8998','2013-06-13','14:50:00',2.3),('8998','2013-06-13','14:55:00',2.27),('8998','2013-06-13','15:00:00',2.24),('8998','2013-06-13','15:05:00',2.2),('8998','2013-06-13','15:10:00',2.17),('8998','2013-06-13','15:15:00',2.13),('8998','2013-06-13','15:20:00',2.09),('8998','2013-06-13','15:25:00',2.04),('8998','2013-06-13','15:30:00',1.99),('8998','2013-06-13','15:35:00',1.95),('8998','2013-06-13','15:40:00',1.91),('8998','2013-06-13','15:45:00',1.86),('8998','2013-06-13','15:50:00',1.81),('8998','2013-06-13','15:55:00',1.75),('8998','2013-06-13','16:00:00',1.69),('8998','2013-06-13','16:05:00',1.64),('8998','2013-06-13','16:10:00',1.59),('8998','2013-06-13','16:15:00',1.54),('8998','2013-06-13','16:20:00',1.5),('8998','2013-06-13','16:25:00',1.44),('8998','2013-06-13','16:30:00',1.38),('8998','2013-06-13','16:35:00',1.32),('8998','2013-06-13','16:40:00',1.26),('8998','2013-06-13','16:45:00',1.21),('8998','2013-06-13','16:50:00',1.16),('8998','2013-06-13','16:55:00',1.09),('8998','2013-06-13','17:00:00',1.05),('8998','2013-06-12','07:30:00',1.02),('8998','2013-06-12','07:35:00',1.12),('8998','2013-06-12','07:40:00',1.34),('8998','2013-06-12','07:45:00',1.38),('8998','2013-06-12','07:50:00',1.38),('8998','2013-06-12','07:55:00',1.38),('8998','2013-06-12','08:00:00',1.38),('8998','2013-06-12','08:05:00',1.56),('8998','2013-06-12','08:10:00',1.94),('8998','2013-06-12','08:15:00',1.95),('8998','2013-06-12','08:20:00',1.8),('8998','2013-06-12','08:25:00',1.73),('8998','2013-06-12','08:30:00',1.67),('8998','2013-06-12','08:35:00',1.67),('8998','2013-06-12','08:40:00',1.68),('8998','2013-06-12','08:45:00',2.08),('8998','2013-06-12','08:50:00',2.07),('8998','2013-06-12','08:55:00',1.99),('8998','2013-06-12','09:00:00',1.88),('8998','2013-06-12','09:05:00',2.19),('8998','2013-06-12','09:10:00',2.4),('8998','2013-06-12','09:15:00',2.59),('8998','2013-06-12','09:20:00',2.65),('8998','2013-06-12','09:25:00',2.69),('8998','2013-06-12','09:30:00',2.73),('8998','2013-06-12','09:35:00',2.76),('8998','2013-06-12','09:40:00',2.78),('8998','2013-06-12','09:45:00',2.8),('8998','2013-06-12','09:50:00',2.83),('8998','2013-06-12','09:55:00',2.85),('8998','2013-06-12','10:00:00',2.89),('8998','2013-06-12','10:05:00',2.91),('8998','2013-06-12','10:10:00',2.93),('8998','2013-06-12','10:15:00',2.94),('8998','2013-06-12','10:20:00',2.94),('8998','2013-06-12','10:25:00',2.96),('8998','2013-06-12','10:30:00',2.99),('8998','2013-06-12','10:35:00',3),('8998','2013-06-12','10:40:00',3.01),('8998','2013-06-12','10:45:00',3.07),('8998','2013-06-12','10:50:00',3.07),('8998','2013-06-12','10:55:00',3.07),('8998','2013-06-12','11:00:00',3.09),('8998','2013-06-12','11:05:00',3.09),('8998','2013-06-12','11:10:00',3.09),('8998','2013-06-12','11:15:00',3.1),('8998','2013-06-12','11:20:00',3.12),('8998','2013-06-12','11:25:00',3.12),('8998','2013-06-12','11:30:00',3.12),('8998','2013-06-12','11:35:00',3.14),('8998','2013-06-12','11:40:00',3.12),('8998','2013-06-12','11:45:00',3.15),('8998','2013-06-12','11:50:00',3.15),('8998','2013-06-12','11:55:00',3.13),('8998','2013-06-12','12:00:00',3.11),('8998','2013-06-12','12:05:00',3.13),('8998','2013-06-12','12:10:00',3.11),('8998','2013-06-12','12:15:00',3.11),('8998','2013-06-12','12:20:00',3.11),('8998','2013-06-12','12:25:00',3.11),('8998','2013-06-12','12:30:00',3.1),('8998','2013-06-12','12:35:00',3.07),('8998','2013-06-12','12:40:00',3.06),('8998','2013-06-12','12:45:00',3.04),('8998','2013-06-12','12:50:00',3.01),('8998','2013-06-12','12:55:00',2.98),('8998','2013-06-12','13:00:00',2.98),('8998','2013-06-12','13:05:00',2.96),('8998','2013-06-12','13:10:00',2.94),('8998','2013-06-12','13:15:00',2.93),('8998','2013-06-12','13:20:00',2.88),('8998','2013-06-12','13:25:00',2.88),('8998','2013-06-12','13:30:00',2.86),('8998','2013-06-12','13:35:00',2.85),('8998','2013-06-12','13:40:00',2.83),('8998','2013-06-12','13:45:00',2.78),('8998','2013-06-12','13:50:00',2.76),('8998','2013-06-12','13:55:00',2.73),('8998','2013-06-12','14:00:00',2.71),('8998','2013-06-12','14:05:00',2.67),('8998','2013-06-12','14:10:00',2.63),('8998','2013-06-12','14:15:00',2.62),('8998','2013-06-12','14:20:00',2.58),('8998','2013-06-12','14:25:00',2.62),('8998','2013-06-12','14:30:00',1.39),('8998','2013-06-12','14:35:00',2.47),('8998','2013-06-12','14:40:00',2.51),('8998','2013-06-12','14:45:00',2.44),('8998','2013-06-12','14:50:00',2.35),('8998','2013-06-12','14:55:00',2.34),('8998','2013-06-12','15:00:00',2.31),('8998','2013-06-12','15:05:00',2.24),('8998','2013-06-12','15:10:00',2.19),('8998','2013-06-12','15:15:00',2.15),('8998','2013-06-12','15:20:00',2.11),('8998','2013-06-12','15:25:00',2.07),('8998','2013-06-12','15:30:00',2.02),('8998','2013-06-12','15:35:00',1.97),('8998','2013-06-12','15:40:00',1.93),('8998','2013-06-12','15:45:00',1.88),('8998','2013-06-12','15:50:00',1.83),('8998','2013-06-12','15:55:00',1.78),('8998','2013-06-12','16:00:00',1.72),('8998','2013-06-12','16:05:00',1.67),('8998','2013-06-12','16:10:00',1.61),('8998','2013-06-12','16:15:00',1.56),('8998','2013-06-12','16:20:00',1.5),('8998','2013-06-12','16:25:00',1.45),('8998','2013-06-12','16:30:00',1.39),('8998','2013-06-12','16:35:00',1.33),('8998','2013-06-12','16:40:00',1.28),('8998','2013-06-12','16:45:00',1.22),('8998','2013-06-12','16:50:00',1.16),('8998','2013-06-12','16:55:00',1.11),('8998','2013-06-12','17:00:00',1.04),('8998','2013-06-11','07:30:00',1.03),('8998','2013-06-11','07:35:00',1.11),('8998','2013-06-11','07:40:00',1.32),('8998','2013-06-11','07:45:00',1.37),('8998','2013-06-11','07:50:00',1.35),('8998','2013-06-11','07:55:00',1.38),('8998','2013-06-11','08:00:00',1.38),('8998','2013-06-11','08:05:00',1.69),('8998','2013-06-11','08:10:00',1.98),('8998','2013-06-11','08:15:00',1.98),('8998','2013-06-11','08:20:00',1.81),('8998','2013-06-11','08:25:00',1.76),('8998','2013-06-11','08:30:00',1.71),('8998','2013-06-11','08:35:00',1.72),('8998','2013-06-11','08:40:00',1.85),('8998','2013-06-11','08:45:00',2.18),('8998','2013-06-11','08:50:00',2.21),('8998','2013-06-11','08:55:00',2.37),('8998','2013-06-11','09:00:00',2.45),('8998','2013-06-11','09:05:00',2.5),('8998','2013-06-11','09:10:00',2.56),('8998','2013-06-11','09:15:00',2.69),('8998','2013-06-11','09:20:00',2.72),('8998','2013-06-11','09:25:00',2.75),('8998','2013-06-11','09:30:00',2.78),('8998','2013-06-11','09:35:00',2.8),('8998','2013-06-11','09:40:00',2.82),('8998','2013-06-11','09:45:00',2.85),('8998','2013-06-11','09:50:00',2.88),('8998','2013-06-11','09:55:00',2.91),('8998','2013-06-11','10:00:00',2.9),('8998','2013-06-11','10:05:00',2.92),('8998','2013-06-11','10:10:00',2.94),('8998','2013-06-11','10:15:00',2.98),('8998','2013-06-11','10:20:00',3),('8998','2013-06-11','10:25:00',3),('8998','2013-06-11','10:30:00',3),('8998','2013-06-11','10:35:00',3),('8998','2013-06-11','10:40:00',3),('8998','2013-06-11','10:45:00',3.05),('8998','2013-06-11','10:50:00',3.08),('8998','2013-06-11','10:55:00',3.13),('8998','2013-06-11','11:00:00',3.15),('8998','2013-06-11','11:05:00',3.15),('8998','2013-06-11','11:10:00',3.16),('8998','2013-06-11','11:15:00',3.14),('8998','2013-06-11','11:20:00',3.14),('8998','2013-06-11','11:25:00',3.15),('8998','2013-06-11','11:30:00',3.16),('8998','2013-06-11','11:35:00',3.15),('8998','2013-06-11','11:40:00',3.16),('8998','2013-06-11','11:45:00',3.12),('8998','2013-06-11','11:50:00',3.16),('8998','2013-06-11','11:55:00',3.16),('8998','2013-06-11','12:00:00',3.15),('8998','2013-06-11','12:05:00',3.16),('8998','2013-06-11','12:10:00',3.13),('8998','2013-06-11','12:15:00',3.14),('8998','2013-06-11','12:20:00',3.12),('8998','2013-06-11','12:25:00',3.08),('8998','2013-06-11','12:30:00',3.13),('8998','2013-06-11','12:35:00',2.95),('8998','2013-06-11','12:40:00',1.66),('8998','2013-06-11','12:45:00',1.97),('8998','2013-06-11','12:50:00',3.32),('8998','2013-06-11','12:55:00',2.66),('8998','2013-06-11','13:00:00',2.5),('8998','2013-06-11','13:05:00',3.1),('8998','2013-06-11','13:10:00',3),('8998','2013-06-11','13:15:00',2.94),('8998','2013-06-11','13:20:00',2.9),('8998','2013-06-11','13:25:00',2.89),('8998','2013-06-11','13:30:00',2.9),('8998','2013-06-11','13:35:00',2.89),('8998','2013-06-11','13:40:00',2.84),('8998','2013-06-11','13:45:00',2.84),('8998','2013-06-11','13:50:00',2.81),('8998','2013-06-11','13:55:00',2.82),('8998','2013-06-11','14:00:00',2.83),('8998','2013-06-11','14:05:00',1.61),('8998','2013-06-11','14:10:00',2.38),('8998','2013-06-11','14:15:00',2.51),('8998','2013-06-11','14:20:00',1.48),('8998','2013-06-11','14:25:00',1.18),('8998','2013-06-11','14:30:00',2.77),('8998','2013-06-11','14:35:00',2.71),('8998','2013-06-11','14:40:00',2.52),('8998','2013-06-11','14:45:00',2.42),('8998','2013-06-11','14:50:00',2.6),('8998','2013-06-11','14:55:00',2.62),('8998','2013-06-11','15:00:00',2.56),('8998','2013-06-11','15:05:00',2.32),('8998','2013-06-11','15:10:00',2.35),('8998','2013-06-11','15:15:00',1.74),('8998','2013-06-11','15:20:00',2.31),('8998','2013-06-11','15:25:00',2.09),('8998','2013-06-11','15:30:00',2.09),('8998','2013-06-11','15:35:00',2.09),('8998','2013-06-11','15:40:00',2.02),('8998','2013-06-11','15:45:00',1.96),('8998','2013-06-11','15:50:00',1.87),('8998','2013-06-11','15:55:00',1.87),('8998','2013-06-11','16:00:00',1.65),('8998','2013-06-11','16:05:00',1.68),('8998','2013-06-11','16:10:00',1.72),('8998','2013-06-11','16:15:00',1.65),('8998','2013-06-11','16:20:00',1.54),('8998','2013-06-11','16:25:00',1.46),('8998','2013-06-11','16:30:00',1.44),('8998','2013-06-11','16:35:00',1.38),('8998','2013-06-11','16:40:00',1.34),('8998','2013-06-11','16:45:00',1.05),('8998','2013-06-11','16:50:00',1.21),('8998','2013-06-11','16:55:00',1.13),('8998','2013-06-11','17:00:00',1.06),('8998','2013-06-11','17:05:00',1.02),('8998','2013-06-10','07:35:00',1.11),('8998','2013-06-10','07:40:00',1.34),('8998','2013-06-10','07:45:00',1.38),('8998','2013-06-10','07:50:00',1.34),('8998','2013-06-10','08:00:00',1.37),('8998','2013-06-10','08:10:00',1.47),('8998','2013-06-10','08:15:00',2.15),('8998','2013-06-10','08:20:00',2.01),('8998','2013-06-10','08:25:00',1.88),('8998','2013-06-10','08:30:00',1.87),('8998','2013-06-10','08:35:00',1.82),('8998','2013-06-10','08:40:00',1.84),('8998','2013-06-10','08:45:00',2.01),('8998','2013-06-10','08:50:00',2.19),('8998','2013-06-10','08:55:00',2.18),('8998','2013-06-10','09:00:00',2.14),('8998','2013-06-10','09:05:00',2.42),('8998','2013-06-10','09:10:00',2.58),('8998','2013-06-10','09:15:00',2.73),('8998','2013-06-10','09:20:00',2.75),('8998','2013-06-10','09:25:00',2.88),('8998','2013-06-10','09:30:00',2.8),('8998','2013-06-10','09:35:00',2.72),('8998','2013-06-10','09:45:00',1.11),('8998','2013-06-10','09:50:00',2.22),('8998','2013-06-10','09:55:00',2.86),('8998','2013-06-10','10:00:00',1.91),('8998','2013-06-10','10:05:00',2.64),('8998','2013-06-10','10:10:00',1.98),('8998','2013-06-10','10:15:00',3.08),('8998','2013-06-10','10:20:00',3.1),('8998','2013-06-10','10:25:00',2.55),('8998','2013-06-10','10:30:00',3.15),('8998','2013-06-10','10:35:00',3.02),('8998','2013-06-10','10:40:00',2.31),('8998','2013-06-10','10:45:00',2.77),('8998','2013-06-10','10:50:00',3.17),('8998','2013-06-10','10:55:00',3.22),('8998','2013-06-10','11:00:00',3.26),('8998','2013-06-10','11:05:00',3.08),('8998','2013-06-10','11:10:00',2.47),('8998','2013-06-10','11:15:00',2.99),('8998','2013-06-10','11:20:00',3.3),('8998','2013-06-10','11:25:00',2.19),('8998','2013-06-10','11:30:00',3.02),('8998','2013-06-10','11:35:00',3.21),('8998','2013-06-10','11:40:00',3.19),('8998','2013-06-10','11:45:00',3.16),('8998','2013-06-10','11:50:00',3.17),('8998','2013-06-10','11:55:00',3.17),('8998','2013-06-10','12:00:00',2.91),('8998','2013-06-10','12:05:00',1.84),('8998','2013-06-10','12:10:00',3.25),('8998','2013-06-10','12:15:00',3.18),('8998','2013-06-10','12:20:00',3),('8998','2013-06-10','12:25:00',3.17),('8998','2013-06-10','12:30:00',3.15),('8998','2013-06-10','12:35:00',3.14),('8998','2013-06-10','12:40:00',3.11),('8998','2013-06-10','12:45:00',3.09),('8998','2013-06-10','12:50:00',3.08),('8998','2013-06-10','12:55:00',3.08),('8998','2013-06-10','13:00:00',3.06),('8998','2013-06-10','13:05:00',3.06),('8998','2013-06-10','13:10:00',3.06),('8998','2013-06-10','13:15:00',3.06),('8998','2013-06-10','13:20:00',3.01),('8998','2013-06-10','13:25:00',2.98),('8998','2013-06-10','13:30:00',2.97),('8998','2013-06-10','13:35:00',2.96),('8998','2013-06-10','13:40:00',2.98),('8998','2013-06-10','13:45:00',2.91),('8998','2013-06-10','13:50:00',2.79),('8998','2013-06-10','13:55:00',2.95),('8998','2013-06-10','14:00:00',2.89),('8998','2013-06-10','14:05:00',2.81),('8998','2013-06-10','14:10:00',2.74),('8998','2013-06-10','14:15:00',2.7),('8998','2013-06-10','14:20:00',2.66),('8998','2013-06-10','14:25:00',2.62),('8998','2013-06-10','14:30:00',2.58),('8998','2013-06-10','14:35:00',2.55),('8998','2013-06-10','14:40:00',2.51),('8998','2013-06-10','14:45:00',2.47),('8998','2013-06-10','14:50:00',2.43),('8998','2013-06-10','14:55:00',2.38),('8998','2013-06-10','15:00:00',2.34),('8998','2013-06-10','15:05:00',2.3),('8998','2013-06-10','15:10:00',2.25),('8998','2013-06-10','15:15:00',2.21),('8998','2013-06-10','15:20:00',2.18),('8998','2013-06-10','15:25:00',2.1),('8998','2013-06-10','15:30:00',2.09),('8998','2013-06-10','15:35:00',2.08),('8998','2013-06-10','15:40:00',2.01),('8998','2013-06-10','15:45:00',1.44),('8998','2013-06-10','15:50:00',1.87),('8998','2013-06-10','15:55:00',1.69),('8998','2013-06-10','16:00:00',1.87),('8998','2013-06-10','16:05:00',1.81),('8998','2013-06-10','16:10:00',1.76),('8998','2013-06-10','16:15:00',1.69),('8998','2013-06-10','16:20:00',1.64),('8998','2013-06-10','16:25:00',1.58),('8998','2013-06-10','16:30:00',1.54),('8998','2013-06-10','16:35:00',1.51),('8998','2013-06-10','16:40:00',1.54),('8998','2013-06-10','16:45:00',1.63),('8998','2013-06-10','16:50:00',1.65),('8998','2013-06-10','16:55:00',1.53),('8998','2013-06-10','17:00:00',1.39),('8998','2013-06-10','17:05:00',1.14),('8998','2014-04-02','09:05:00',1.09),('8998','2014-04-02','09:10:00',1.07),('8998','2014-04-02','09:30:00',1.14),('8998','2014-04-02','09:35:00',1.44),('8998','2014-04-02','09:40:00',1.56),('8998','2014-04-02','09:45:00',1.52),('8998','2014-04-02','09:50:00',1.46),('8998','2014-04-02','09:55:00',1.51),('8998','2014-04-02','10:00:00',1.85),('8998','2014-04-02','10:05:00',2.2),('8998','2014-04-02','10:10:00',2.31),('8998','2014-04-02','10:15:00',2.62),('8998','2014-04-02','10:20:00',2.63),('8998','2014-04-02','10:25:00',2.4),('8998','2014-04-02','10:30:00',2.16),('8998','2014-04-02','10:35:00',2.33),('8998','2014-04-02','10:40:00',1.76),('8998','2014-04-02','10:45:00',1.88),('8998','2014-04-02','10:50:00',1.58),('8998','2014-04-02','10:55:00',1.64),('8998','2014-04-02','11:00:00',1.55),('8998','2014-04-02','11:05:00',1.25),('8998','2014-04-02','11:10:00',1.18),('8998','2014-04-02','11:15:00',1.09),('8998','2014-04-02','11:20:00',1.04),('8998','2014-04-02','11:40:00',1.05),('8998','2014-04-02','11:45:00',1.19),('8998','2014-04-02','11:50:00',1.47),('8998','2014-04-02','11:55:00',1.7),('8998','2014-04-02','12:00:00',1.61),('8998','2014-04-02','12:05:00',1.64),('8998','2014-04-02','12:10:00',1.57),('8998','2014-04-02','12:15:00',1.53),('8998','2014-04-02','12:20:00',1.67),('8998','2014-04-02','12:25:00',2.05),('8998','2014-04-02','12:30:00',2.7),('8998','2014-04-02','12:35:00',2.61),('8998','2014-04-02','12:40:00',2.85),('8998','2014-04-02','12:45:00',1.72),('8998','2014-04-02','12:50:00',1.82),('8998','2014-04-02','12:55:00',1.88),('8998','2014-04-02','13:00:00',1.77),('8998','2014-04-02','13:05:00',2.23),('8998','2014-04-02','13:10:00',1.61),('8998','2014-04-02','13:15:00',3.01),('8998','2014-04-02','13:20:00',2.09),('8998','2014-04-02','13:25:00',1.88),('8998','2014-04-02','13:30:00',1.87),('8998','2014-04-02','13:35:00',2.92),('8998','2014-04-02','13:40:00',2.65),('8998','2014-04-02','13:45:00',1.47),('8998','2014-04-02','13:50:00',1.39),('8998','2014-04-02','13:55:00',1.6),('8998','2014-04-02','14:00:00',2.35),('8998','2014-04-02','14:05:00',2.29),('8998','2014-04-02','14:10:00',1.75),('8998','2014-04-02','14:15:00',2.12),('8998','2014-04-02','14:20:00',2.25),('8998','2014-04-02','14:25:00',2.21),('8998','2014-04-02','14:30:00',2.23),('8998','2014-04-02','14:35:00',2.26),('8998','2014-04-02','14:40:00',2.16),('8998','2014-04-02','14:45:00',2.08),('8998','2014-04-02','14:50:00',2),('8998','2014-04-02','14:55:00',1.92),('8998','2014-04-02','15:00:00',1.88),('8998','2014-04-02','15:05:00',1.83),('8998','2014-04-02','15:10:00',1.77),('8998','2014-04-02','15:15:00',1.73),('8998','2014-04-02','15:20:00',1.7),('8998','2014-04-02','15:25:00',1.64),('8998','2014-04-02','15:30:00',1.59),('8998','2014-04-02','15:35:00',1.54),('8998','2014-04-02','15:40:00',1.48),('8998','2014-04-02','15:45:00',1.43),('8998','2014-04-02','15:50:00',1.38),('8998','2014-04-02','15:55:00',1.33),('8998','2014-04-02','16:00:00',1.3),('8998','2014-04-02','16:05:00',1.22),('8998','2014-04-02','16:10:00',1.19),('8998','2014-04-02','16:15:00',1.1),('8998','2014-04-02','16:20:00',1.06),('8998','2013-06-09','07:30:00',1.2),('8998','2013-06-09','07:35:00',1.45),('8998','2013-06-09','08:00:00',1.03),('8998','2013-06-09','08:05:00',1.5),('8998','2013-06-09','08:10:00',2.08),('8998','2013-06-09','08:15:00',1.61),('8998','2013-06-09','08:20:00',1.97),('8998','2013-06-09','08:25:00',1.13),('8998','2013-06-09','08:30:00',1.03),('8998','2013-06-09','09:00:00',1.03),('8998','2013-06-09','09:10:00',1.68),('8998','2013-06-09','09:20:00',2.28),('8998','2013-06-09','09:25:00',1.54),('8998','2013-06-09','09:30:00',1.89),('8998','2013-06-09','09:35:00',2.84),('8998','2013-06-09','09:40:00',2.08),('8998','2013-06-09','09:45:00',3.18),('8998','2013-06-09','09:50:00',1.66),('8998','2013-06-09','09:55:00',1.55),('8998','2013-06-09','10:00:00',1.74),('8998','2013-06-09','10:05:00',1.98),('8998','2013-06-09','10:10:00',2.56),('8998','2013-06-09','10:15:00',2.38),('8998','2013-06-09','10:20:00',1.64),('8998','2013-06-09','10:25:00',1.34),('8998','2013-06-09','10:30:00',1.43),('8998','2013-06-09','10:35:00',1.28),('8998','2013-06-09','10:40:00',1.33),('8998','2013-06-09','10:50:00',1.39),('8998','2013-06-09','10:55:00',1.82),('8998','2013-06-09','11:00:00',2.69),('8998','2013-06-09','11:05:00',2.34),('8998','2013-06-09','11:10:00',2.22),('8998','2013-06-09','11:15:00',3.27),('8998','2013-06-09','11:20:00',3.4),('8998','2013-06-09','11:25:00',3.27),('8998','2013-06-09','11:30:00',3.24),('8998','2013-06-09','11:35:00',3.26),('8998','2013-06-09','11:40:00',2.09),('8998','2013-06-09','11:45:00',2.34),('8998','2013-06-09','11:50:00',1.85),('8998','2013-06-09','11:55:00',2.3),('8998','2013-06-09','12:00:00',3.45),('8998','2013-06-09','12:05:00',1.51),('8998','2013-06-09','12:10:00',2.06),('8998','2013-06-09','12:15:00',2.11),('8998','2013-06-09','12:20:00',2.64),('8998','2013-06-09','12:25:00',3.3),('8998','2013-06-09','12:30:00',3.37),('8998','2013-06-09','12:35:00',3.37),('8998','2013-06-09','12:40:00',2.91),('8998','2013-06-09','12:45:00',3.43),('8998','2013-06-09','12:50:00',1.49),('8998','2013-06-09','12:55:00',3.07),('8998','2013-06-09','13:00:00',3.52),('8998','2013-06-09','13:05:00',2.99),('8998','2013-06-09','13:10:00',2.84),('8998','2013-06-09','13:15:00',2.01),('8998','2013-06-09','13:20:00',1.48),('8998','2013-06-09','13:25:00',1.66),('8998','2013-06-09','13:30:00',1.27),('8998','2013-06-09','13:35:00',2.5),('8998','2013-06-09','13:40:00',2.63),('8998','2013-06-09','13:45:00',3.04),('8998','2013-06-09','13:50:00',3.21),('8998','2013-06-09','13:55:00',2.63),('8998','2013-06-09','14:00:00',2.97),('8998','2013-06-09','14:05:00',2.88),('8998','2013-06-09','14:10:00',2.81),('8998','2013-06-09','14:15:00',2.73),('8998','2013-06-09','14:20:00',2.48),('8998','2013-06-09','14:25:00',2.56),('8998','2013-06-09','14:30:00',2.62),('8998','2013-06-09','14:35:00',2.59),('8998','2013-06-09','14:40:00',2.53),('8998','2013-06-09','14:45:00',2.53),('8998','2013-06-09','14:50:00',2.48),('8998','2013-06-09','14:55:00',2.41),('8998','2013-06-09','15:00:00',2.36),('8998','2013-06-09','15:05:00',2.33),('8998','2013-06-09','15:10:00',2.28),('8998','2013-06-09','15:15:00',2.24),('8998','2013-06-09','15:20:00',2.21),('8998','2013-06-09','15:25:00',2.15),('8998','2013-06-09','15:30:00',2.11),('8998','2013-06-09','15:35:00',2.06),('8998','2013-06-09','15:40:00',2.02),('8998','2013-06-09','15:45:00',1.97),('8998','2013-06-09','15:50:00',1.9),('8998','2013-06-09','15:55:00',1.86),('8998','2013-06-09','16:00:00',1.8),('8998','2013-06-09','16:05:00',1.74),('8998','2013-06-09','16:10:00',1.68),('8998','2013-06-09','16:15:00',1.63),('8998','2013-06-09','16:20:00',1.57),('8998','2013-06-09','16:25:00',1.51),('8998','2013-06-09','16:30:00',1.45),('8998','2013-06-09','16:35:00',1.39),('8998','2013-06-09','16:40:00',1.33),('8998','2013-06-09','16:45:00',1.28),('8998','2013-06-09','16:50:00',1.22),('8998','2013-06-09','16:55:00',1.16),('8998','2013-06-09','17:00:00',1.1),('8998','2013-06-09','17:05:00',1.04),('8998','2013-06-08','07:35:00',1.34),('8998','2013-06-08','07:40:00',1.19),('8998','2013-06-08','07:55:00',1.45),('8998','2013-06-08','08:00:00',1.51),('8998','2013-06-08','08:05:00',1.51),('8998','2013-06-08','08:10:00',1.47),('8998','2013-06-08','08:15:00',1.61),('8998','2013-06-08','08:20:00',1.65),('8998','2013-06-08','08:25:00',1.74),('8998','2013-06-08','08:30:00',1.73),('8998','2013-06-08','08:35:00',1.75),('8998','2013-06-08','08:40:00',1.7),('8998','2013-06-08','08:45:00',1.76),('8998','2013-06-08','08:50:00',1.89),('8998','2013-06-08','08:55:00',1.96),('8998','2013-06-08','09:00:00',1.97),('8998','2013-06-08','09:05:00',2.23),('8998','2013-06-08','09:10:00',2.36),('8998','2013-06-08','09:15:00',2.51),('8998','2013-06-08','09:20:00',2.44),('8998','2013-06-08','09:25:00',2.55),('8998','2013-06-08','09:30:00',2.58),('8998','2013-06-08','09:35:00',2.64),('8998','2013-06-08','09:40:00',2.68),('8998','2013-06-08','09:45:00',2.7),('8998','2013-06-08','09:50:00',2.72),('8998','2013-06-08','09:55:00',2.73),('8998','2013-06-08','10:00:00',2.75),('8998','2013-06-08','10:05:00',2.77),('8998','2013-06-08','10:10:00',2.79),('8998','2013-06-08','10:15:00',2.82),('8998','2013-06-08','10:20:00',2.84),('8998','2013-06-08','10:25:00',2.85),('8998','2013-06-08','10:30:00',2.83),('8998','2013-06-08','10:35:00',2.9),('8998','2013-06-08','10:40:00',2.91),('8998','2013-06-08','10:45:00',2.88),('8998','2013-06-08','10:50:00',2.92),('8998','2013-06-08','10:55:00',2.9),('8998','2013-06-08','11:00:00',2.92),('8998','2013-06-08','11:05:00',2.95),('8998','2013-06-08','11:10:00',2.92),('8998','2013-06-08','11:15:00',2.9),('8998','2013-06-08','11:20:00',2.93),('8998','2013-06-08','11:25:00',2.98),('8998','2013-06-08','11:30:00',2.95),('8998','2013-06-08','11:35:00',2.95),('8998','2013-06-08','11:40:00',2.94),('8998','2013-06-08','11:45:00',2.96),('8998','2013-06-08','11:50:00',2.97),('8998','2013-06-08','11:55:00',2.95),('8998','2013-06-08','12:00:00',2.96),('8998','2013-06-08','12:05:00',2.95),('8998','2013-06-08','12:10:00',2.61),('8998','2013-06-08','12:15:00',2.85),('8998','2013-06-08','12:20:00',2.94),('8998','2013-06-08','12:25:00',2.9),('8998','2013-06-08','12:30:00',2.88),('8998','2013-06-08','12:35:00',2.85),('8998','2013-06-08','12:40:00',2.89),('8998','2013-06-08','12:45:00',2.82),('8998','2013-06-08','12:50:00',2.7),('8998','2013-06-08','12:55:00',2.5),('8998','2013-06-08','13:00:00',2.52),('8998','2013-06-08','13:05:00',1.78),('8998','2013-06-08','13:10:00',2.65),('8998','2013-06-08','13:15:00',1.24),('8998','2013-06-08','13:20:00',1.36),('8998','2013-06-08','13:25:00',3.17),('8998','2013-06-08','13:30:00',2.97),('8998','2013-06-08','13:35:00',2.88),('8998','2013-06-08','13:40:00',2.9),('8998','2013-06-08','13:45:00',2.86),('8998','2013-06-08','13:50:00',2.91),('8998','2013-06-08','13:55:00',2.73),('8998','2013-06-08','14:00:00',2.52),('8998','2013-06-08','14:05:00',2.75),('8998','2013-06-08','14:10:00',2.74),('8998','2013-06-08','14:15:00',1.7),('8998','2013-06-08','14:20:00',1.33),('8998','2013-06-08','14:35:00',2.14),('8998','2013-06-08','14:40:00',2.36),('8998','2013-06-08','14:45:00',2.22),('8998','2013-06-08','14:50:00',2.36),('8998','2013-06-08','14:55:00',2.4),('8998','2013-06-08','15:00:00',2.32),('8998','2013-06-08','15:05:00',2.21),('8998','2013-06-08','15:10:00',2.21),('8998','2013-06-08','15:15:00',2.08),('8998','2013-06-08','15:20:00',2.08),('8998','2013-06-08','15:25:00',2.06),('8998','2013-06-08','15:30:00',1.94),('8998','2013-06-08','15:35:00',2.01),('8998','2013-06-08','15:40:00',1.52),('8998','2013-06-08','15:45:00',1.54),('8998','2013-06-08','15:50:00',1.69),('8998','2013-06-08','15:55:00',1.88),('8998','2013-06-08','16:00:00',1.15),('8998','2013-06-08','16:05:00',1.61),('8998','2013-06-08','16:10:00',1.57),('8998','2013-06-08','16:25:00',1.29),('8998','2013-06-07','07:35:00',1.11),('8998','2013-06-07','07:40:00',1.28),('8998','2013-06-07','07:45:00',1.3),('8998','2013-06-07','07:50:00',1.27),('8998','2013-06-07','07:55:00',1.31),('8998','2013-06-07','08:00:00',1.35),('8998','2013-06-07','08:05:00',1.37),('8998','2013-06-07','08:10:00',1.76),('8998','2013-06-07','08:15:00',1.87),('8998','2013-06-07','08:20:00',1.93),('8998','2013-06-07','08:25:00',1.98),('8998','2013-06-07','08:30:00',2.04),('8998','2013-06-07','08:35:00',2.11),('8998','2013-06-07','08:40:00',2.09),('8998','2013-06-07','08:45:00',2.04),('8998','2013-06-07','08:50:00',1.97),('8998','2013-06-07','08:55:00',1.91),('8998','2013-06-07','09:00:00',2.11),('8998','2013-06-07','09:05:00',2.3),('8998','2013-06-07','09:10:00',2.39),('8998','2013-06-07','09:15:00',2.52),('8998','2013-06-07','09:20:00',2.54),('8998','2013-06-07','09:25:00',2.56),('8998','2013-06-07','09:30:00',2.61),('8998','2013-06-07','09:35:00',2.61),('8998','2013-06-07','09:40:00',2.64),('8998','2013-06-07','09:45:00',2.63),('8998','2013-06-07','09:50:00',2.65),('8998','2013-06-07','09:55:00',2.61),('8998','2013-06-07','10:00:00',2.65),('8998','2013-06-07','10:05:00',2.77),('8998','2013-06-07','10:10:00',2.87),('8998','2013-06-07','10:15:00',2.87),('8998','2013-06-07','10:20:00',2.87),('8998','2013-06-07','10:25:00',2.87),('8998','2013-06-07','10:30:00',2.9),('8998','2013-06-07','10:35:00',2.93),('8998','2013-06-07','10:40:00',2.96),('8998','2013-06-07','10:45:00',2.85),('8998','2013-06-07','10:50:00',3.02),('8998','2013-06-07','10:55:00',2.41),('8998','2013-06-07','11:00:00',1.18),('8998','2013-06-07','11:05:00',3.02),('8998','2013-06-07','11:10:00',3.35),('8998','2013-06-07','11:15:00',3.22),('8998','2013-06-07','11:20:00',3.22),('8998','2013-06-07','11:25:00',3.3),('8998','2013-06-07','11:30:00',2.85),('8998','2013-06-07','11:35:00',1.77),('8998','2013-06-07','11:40:00',3.3),('8998','2013-06-07','11:45:00',3.22),('8998','2013-06-07','11:50:00',3.23),('8998','2013-06-07','11:55:00',2.78),('8998','2013-06-07','12:05:00',2.2),('8998','2013-06-07','12:15:00',2.39),('8998','2013-06-07','12:20:00',3.15),('8998','2013-06-07','12:35:00',2.42),('8998','2013-06-07','12:40:00',3.21),('8998','2013-06-07','12:45:00',3.21),('8998','2013-06-07','12:50:00',3.19),('8998','2013-06-07','12:55:00',3.14),('8998','2013-06-07','13:00:00',1.98),('8998','2013-06-07','13:05:00',3.2),('8998','2013-06-07','13:10:00',3.1),('8998','2013-06-07','13:15:00',3.12),('8998','2013-06-07','13:20:00',3.11),('8998','2013-06-07','13:25:00',2.98),('8998','2013-06-07','13:30:00',2.91),('8998','2013-06-07','13:35:00',2.96),('8998','2013-06-07','13:40:00',2.94),('8998','2013-06-07','13:45:00',2.88),('8998','2013-06-07','13:50:00',2.84),('8998','2013-06-07','13:55:00',2.8),('8998','2013-06-07','14:00:00',2.75),('8998','2013-06-07','14:05:00',2.72),('8998','2013-06-07','14:10:00',2.69),('8998','2013-06-07','14:15:00',2.67),('8998','2013-06-07','14:20:00',2.63),('8998','2013-06-07','14:25:00',2.58),('8998','2013-06-07','14:30:00',2.56),('8998','2013-06-07','14:35:00',2.51),('8998','2013-06-07','14:40:00',2.48),('8998','2013-06-07','14:45:00',2.45),('8998','2013-06-07','14:50:00',2.43),('8998','2013-06-07','14:55:00',2.37),('8998','2013-06-07','15:00:00',2.37),('8998','2013-06-07','15:05:00',2.26),('8998','2013-06-07','15:10:00',2.06),('8998','2013-06-07','15:15:00',2.13),('8998','2013-06-07','15:20:00',2.17),('8998','2013-06-07','15:25:00',2.01),('8998','2013-06-07','15:30:00',2.03),('8998','2013-06-07','15:35:00',2.1),('8998','2013-06-07','15:40:00',2.03),('8998','2013-06-07','15:45:00',2.05),('8998','2013-06-07','15:50:00',2),('8998','2013-06-07','15:55:00',1.85),('8998','2013-06-07','16:00:00',1.81),('8998','2013-06-07','16:05:00',1.76),('8998','2013-06-07','16:10:00',1.72),('8998','2013-06-07','16:15:00',1.76),('8998','2013-06-07','16:20:00',1.7),('8998','2013-06-07','16:25:00',1.59),('8998','2013-06-07','16:30:00',1.45),('8998','2013-06-07','16:35:00',1.37),('8998','2013-06-07','16:40:00',1.31),('8998','2013-06-07','16:45:00',1.25),('8998','2013-06-07','16:50:00',1.06),('8998','2013-06-07','16:55:00',1.05),('8998','2013-06-07','17:00:00',1.1),('8998','2013-06-07','17:10:00',1.13),('8998','2013-06-07','17:15:00',1.15),('8998','2013-06-07','17:20:00',1.05),('8998','2013-06-06','07:25:00',1.17),('8998','2013-06-06','07:30:00',1.28),('8998','2013-06-06','07:35:00',1.25),('8998','2013-06-06','07:40:00',1.37),('8998','2013-06-06','07:45:00',1.37),('8998','2013-06-06','07:50:00',1.33),('8998','2013-06-06','07:55:00',1.36),('8998','2013-06-06','08:00:00',1.39),('8998','2013-06-06','08:05:00',1.42),('8998','2013-06-06','08:10:00',1.8),('8998','2013-06-06','08:15:00',1.9),('8998','2013-06-06','08:20:00',1.75),('8998','2013-06-06','08:25:00',1.69),('8998','2013-06-06','08:30:00',1.71),('8998','2013-06-06','08:35:00',1.72),('8998','2013-06-06','08:40:00',1.86),('8998','2013-06-06','08:45:00',2.16),('8998','2013-06-06','08:50:00',2.04),('8998','2013-06-06','08:55:00',1.98),('8998','2013-06-06','09:00:00',2.03),('8998','2013-06-06','09:05:00',2.33),('8998','2013-06-06','09:10:00',2.52),('8998','2013-06-06','09:15:00',2.7),('8998','2013-06-06','09:20:00',2.73),('8998','2013-06-06','09:25:00',2.77),('8998','2013-06-06','09:30:00',2.8),('8998','2013-06-06','09:35:00',2.86),('8998','2013-06-06','09:40:00',2.92),('8998','2013-06-06','09:45:00',2.96),('8998','2013-06-06','09:50:00',2.96),('8998','2013-06-06','09:55:00',2.99),('8998','2013-06-06','10:00:00',3.01),('8998','2013-06-06','10:05:00',3.03),('8998','2013-06-06','10:10:00',3.07),('8998','2013-06-06','10:15:00',3.08),('8998','2013-06-06','10:20:00',3.08),('8998','2013-06-06','10:25:00',3.12),('8998','2013-06-06','10:30:00',3.13),('8998','2013-06-06','10:35:00',3.13),('8998','2013-06-06','10:40:00',3.14),('8998','2013-06-06','10:45:00',3.14),('8998','2013-06-06','10:50:00',3.16),('8998','2013-06-06','10:55:00',3.17),('8998','2013-06-06','11:00:00',3.19),('8998','2013-06-06','11:05:00',3.19),('8998','2013-06-06','11:10:00',3.19),('8998','2013-06-06','11:15:00',3.18),('8998','2013-06-06','11:20:00',3.17),('8998','2013-06-06','11:25:00',3.18),('8998','2013-06-06','11:30:00',3.19),('8998','2013-06-06','11:35:00',3.19),('8998','2013-06-06','11:40:00',3.2),('8998','2013-06-06','11:45:00',3.2),('8998','2013-06-06','11:50:00',3.2),('8998','2013-06-06','11:55:00',3.19),('8998','2013-06-06','12:00:00',3.19),('8998','2013-06-06','12:05:00',3.18),('8998','2013-06-06','12:10:00',3.18),('8998','2013-06-06','12:15:00',3.18),('8998','2013-06-06','12:20:00',3.17),('8998','2013-06-06','12:25:00',3.16),('8998','2013-06-06','12:30:00',3.14),('8998','2013-06-06','12:35:00',3.1),('8998','2013-06-06','12:40:00',3.12),('8998','2013-06-06','12:45:00',3.1),('8998','2013-06-06','12:50:00',3.07),('8998','2013-06-06','12:55:00',3.05),('8998','2013-06-06','13:00:00',3.03),('8998','2013-06-06','13:05:00',3),('8998','2013-06-06','13:10:00',2.98),('8998','2013-06-06','13:15:00',2.97),('8998','2013-06-06','13:20:00',2.94),('8998','2013-06-06','13:25:00',2.92),('8998','2013-06-06','13:30:00',2.9),('8998','2013-06-06','13:35:00',2.85),('8998','2013-06-06','13:40:00',2.81),('8998','2013-06-06','13:45:00',2.79),('8998','2013-06-06','13:50:00',2.76),('8998','2013-06-06','13:55:00',2.75),('8998','2013-06-06','14:00:00',2.71),('8998','2013-06-06','14:05:00',2.68),('8998','2013-06-06','14:10:00',2.63),('8998','2013-06-06','14:15:00',2.61),('8998','2013-06-06','14:20:00',2.56),('8998','2013-06-06','14:25:00',2.52),('8998','2013-06-06','14:30:00',2.5),('8998','2013-06-06','14:35:00',2.47),('8998','2013-06-06','14:40:00',2.45),('8998','2013-06-06','14:45:00',2.42),('8998','2013-06-06','14:50:00',2.39),('8998','2013-06-06','14:55:00',2.34),('8998','2013-06-06','15:00:00',2.3),('8998','2013-06-06','15:05:00',2.29),('8998','2013-06-06','15:10:00',2.29),('8998','2013-06-06','15:15:00',2.22),('8998','2013-06-06','15:20:00',2.13),('8998','2013-06-06','15:25:00',2.09),('8998','2013-06-06','15:30:00',2.06),('8998','2013-06-06','15:35:00',2.02),('8998','2013-06-06','15:40:00',1.94),('8998','2013-06-06','15:45:00',1.91),('8998','2013-06-06','15:50:00',1.85),('8998','2013-06-06','15:55:00',1.8),('8998','2013-06-06','16:00:00',1.76),('8998','2013-06-06','16:05:00',1.69),('8998','2013-06-06','16:10:00',1.64),('8998','2013-06-06','16:15:00',1.55),('8998','2013-06-06','16:20:00',1.5),('8998','2013-06-06','16:25:00',1.47),('8998','2013-06-06','16:30:00',1.4),('8998','2013-06-06','16:35:00',1.35),('8998','2013-06-06','16:40:00',1.32),('8998','2013-06-06','16:45:00',1.27),('8998','2013-06-06','16:50:00',1.21),('8998','2013-06-06','16:55:00',1.16),('8998','2013-06-06','17:00:00',1.1),('8998','2013-06-06','17:05:00',1.05),('8998','2013-06-05','07:50:00',1.19),('8998','2013-06-05','07:55:00',1.51),('8998','2013-06-05','08:00:00',1.62),('8998','2013-06-05','08:05:00',1.21),('8998','2013-06-05','08:10:00',1.36),('8998','2013-06-05','08:15:00',1.38),('8998','2013-06-05','08:20:00',1.57),('8998','2013-06-05','08:25:00',1.78),('8998','2013-06-05','08:30:00',1.78),('8998','2013-06-05','08:35:00',1.78),('8998','2013-06-05','08:40:00',1.76),('8998','2013-06-05','08:45:00',2.07),('8998','2013-06-05','08:50:00',1.98),('8998','2013-06-05','08:55:00',1.96),('8998','2013-06-05','09:00:00',2.04),('8998','2013-06-05','09:05:00',2.39),('8998','2013-06-05','09:10:00',2.48),('8998','2013-06-05','09:15:00',2.6),('8998','2013-06-05','09:20:00',2.62),('8998','2013-06-05','09:25:00',2.68),('8998','2013-06-05','09:30:00',2.68),('8998','2013-06-05','09:35:00',2.74),('8998','2013-06-05','09:40:00',2.81),('8998','2013-06-05','09:45:00',2.83),('8998','2013-06-05','09:50:00',2.84),('8998','2013-06-05','09:55:00',2.79),('8998','2013-06-05','10:00:00',2.84),('8998','2013-06-05','10:05:00',2.94),('8998','2013-06-05','10:10:00',2.94),('8998','2013-06-05','10:15:00',2.96),('8998','2013-06-05','10:20:00',3),('8998','2013-06-05','10:25:00',3.02),('8998','2013-06-05','10:30:00',3),('8998','2013-06-05','10:35:00',2.99),('8998','2013-06-05','10:40:00',3),('8998','2013-06-05','10:45:00',3.05),('8998','2013-06-05','10:50:00',3.04),('8998','2013-06-05','10:55:00',3.05),('8998','2013-06-05','11:00:00',3.08),('8998','2013-06-05','11:05:00',3.05),('8998','2013-06-05','11:10:00',3.06),('8998','2013-06-05','11:15:00',3.09),('8998','2013-06-05','11:20:00',3.08),('8998','2013-06-05','11:25:00',3.08),('8998','2013-06-05','11:30:00',3.07),('8998','2013-06-05','11:35:00',3.08),('8998','2013-06-05','11:40:00',3.11),('8998','2013-06-05','11:45:00',3.07),('8998','2013-06-05','11:50:00',3.04),('8998','2013-06-05','11:55:00',2.99),('8998','2013-06-05','12:00:00',2.99),('8998','2013-06-05','12:05:00',3.06),('8998','2013-06-05','12:10:00',3.09),('8998','2013-06-05','12:15:00',3.07),('8998','2013-06-05','12:20:00',3.06),('8998','2013-06-05','12:25:00',3.05),('8998','2013-06-05','12:30:00',3.06),('8998','2013-06-05','12:35:00',3.02),('8998','2013-06-05','12:40:00',3.01),('8998','2013-06-05','12:45:00',3.01),('8998','2013-06-05','12:50:00',3),('8998','2013-06-05','12:55:00',2.98),('8998','2013-06-05','13:00:00',2.97),('8998','2013-06-05','13:05:00',2.98),('8998','2013-06-05','13:10:00',2.97),('8998','2013-06-05','13:15:00',2.98),('8998','2013-06-05','13:20:00',2.98),('8998','2013-06-05','13:25:00',2.93),('8998','2013-06-05','13:30:00',2.92),('8998','2013-06-05','13:35:00',2.86),('8998','2013-06-05','13:40:00',2.85),('8998','2013-06-05','13:45:00',2.58),('8998','2013-06-05','13:50:00',2.76),('8998','2013-06-05','13:55:00',2.74),('8998','2013-06-05','14:00:00',2.76),('8998','2013-06-05','14:05:00',2.82),('8998','2013-06-05','14:10:00',2.81),('8998','2013-06-05','14:15:00',2.51),('8998','2013-06-05','14:20:00',2.54),('8998','2013-06-05','14:25:00',2.22),('8998','2013-06-05','14:30:00',2.65),('8998','2013-06-05','14:35:00',2.53),('8998','2013-06-05','14:40:00',2.52),('8998','2013-06-05','14:45:00',1.78),('8998','2013-06-05','14:50:00',2.08),('8998','2013-06-05','14:55:00',2.7),('8998','2013-06-05','15:00:00',2.55),('8998','2013-06-05','15:05:00',2.43),('8998','2013-06-05','15:10:00',2.36),('8998','2013-06-05','15:15:00',2.09),('8998','2013-06-05','15:20:00',2.24),('8998','2013-06-05','15:25:00',2.16),('8998','2013-06-05','15:30:00',2.08),('8998','2013-06-05','15:35:00',2),('8998','2013-06-05','15:40:00',2),('8998','2013-06-05','15:45:00',1.96),('8998','2013-06-05','15:50:00',1.88),('8998','2013-06-05','15:55:00',1.78),('8998','2013-06-05','16:00:00',1.84),('8998','2013-06-05','16:05:00',1.78),('8998','2013-06-05','16:10:00',1.6),('8998','2013-06-05','16:15:00',1.55),('8998','2013-06-05','16:20:00',1.47),('8998','2013-06-05','16:25:00',1.46),('8998','2013-06-05','16:30:00',1.43),('8998','2013-06-05','16:35:00',1.41),('8998','2013-06-05','16:40:00',1.35),('8998','2013-06-05','16:45:00',1.24),('8998','2013-06-05','16:50:00',1.17),('8998','2013-06-05','16:55:00',1.12),('8998','2013-06-05','17:00:00',1.06),('8998','2013-06-04','07:55:00',1.41),('8998','2013-06-04','08:00:00',1.42),('8998','2013-06-04','08:10:00',1.32),('8998','2013-06-04','08:15:00',1.56),('8998','2013-06-04','08:20:00',1.79),('8998','2013-06-04','08:25:00',1.78),('8998','2013-06-04','08:30:00',1.78),('8998','2013-06-04','08:35:00',1.75),('8998','2013-06-04','08:40:00',1.74),('8998','2013-06-04','08:45:00',1.79),('8998','2013-06-04','08:50:00',1.9),('8998','2013-06-04','08:55:00',2),('8998','2013-06-04','09:00:00',2.05),('8998','2013-06-04','09:05:00',2.23),('8998','2013-06-04','09:10:00',2.5),('8998','2013-06-04','09:15:00',2.63),('8998','2013-06-04','09:20:00',2.8),('8998','2013-06-04','09:25:00',2.49),('8998','2013-06-04','09:30:00',2.79),('8998','2013-06-04','09:35:00',2.94),('8998','2013-06-04','09:40:00',3.08),('8998','2013-06-04','09:45:00',2.63),('8998','2013-06-04','09:50:00',2.49),('8998','2013-06-04','09:55:00',1.64),('8998','2013-06-04','10:00:00',1.65),('8998','2013-06-04','10:05:00',3.1),('8998','2013-06-04','10:10:00',1.22),('8998','2013-06-04','10:15:00',1.36),('8998','2013-06-04','10:20:00',1.27),('8998','2013-06-04','10:25:00',2.25),('8998','2013-06-04','10:30:00',1.21),('8998','2013-06-04','10:35:00',2.67),('8998','2013-06-04','10:40:00',2.26),('8998','2013-06-04','10:45:00',2.6),('8998','2013-06-04','10:50:00',2.88),('8998','2013-06-04','10:55:00',3.27),('8998','2013-06-04','11:00:00',3.24),('8998','2013-06-04','11:05:00',3.25),('8998','2013-06-04','11:10:00',1.08),('8998','2013-06-04','11:20:00',1.16),('8998','2013-06-04','11:35:00',1.45),('8998','2013-06-04','11:40:00',2.12),('8998','2013-06-04','11:45:00',3.37),('8998','2013-06-04','11:50:00',2.47),('8998','2013-06-04','11:55:00',2.61),('8998','2013-06-04','12:00:00',1.1),('8998','2013-06-04','12:05:00',2.67),('8998','2013-06-04','12:10:00',3.61),('8998','2013-06-04','12:15:00',1.74),('8998','2013-06-04','12:20:00',3.05),('8998','2013-06-04','12:25:00',3.62),('8998','2013-06-04','12:30:00',3.02),('8998','2013-06-04','12:35:00',3.14),('8998','2013-06-04','12:40:00',3.24),('8998','2013-06-04','12:45:00',2.92),('8998','2013-06-04','12:50:00',2.41),('8998','2013-06-04','12:55:00',1.03),('8998','2013-06-04','13:00:00',1.31),('8998','2013-06-04','13:05:00',2.35),('8998','2013-06-04','13:10:00',1.7),('8998','2013-06-04','13:15:00',1.37),('8998','2013-06-04','13:20:00',1.97),('8998','2013-06-04','13:25:00',2.68),('8998','2013-06-04','13:30:00',2.29),('8998','2013-06-04','13:35:00',3.56),('8998','2013-06-04','13:40:00',3.3),('8998','2013-06-04','13:45:00',3.16),('8998','2013-06-04','13:50:00',3),('8998','2013-06-04','13:55:00',2.95),('8998','2013-06-04','14:00:00',2.88),('8998','2013-06-04','14:05:00',2.82),('8998','2013-06-04','14:10:00',2.77),('8998','2013-06-04','14:15:00',2.75),('8998','2013-06-04','14:20:00',2.73),('8998','2013-06-04','14:25:00',2.66),('8998','2013-06-04','14:30:00',2.61),('8998','2013-06-04','14:35:00',2.55),('8998','2013-06-04','14:40:00',2.56),('8998','2013-06-04','14:45:00',2.56),('8998','2013-06-04','14:50:00',2.51),('8998','2013-06-04','14:55:00',2.46),('8998','2013-06-04','15:00:00',2.37),('8998','2013-06-04','15:05:00',2.31),('8998','2013-06-04','15:10:00',2.28),('8998','2013-06-04','15:15:00',2.25),('8998','2013-06-04','15:20:00',2.14),('8998','2013-06-04','15:25:00',2.19),('8998','2013-06-04','15:30:00',2.14),('8998','2013-06-04','15:35:00',2),('8998','2013-06-04','15:40:00',2),('8998','2013-06-04','15:45:00',2.03),('8998','2013-06-04','15:50:00',1.97),('8998','2013-06-04','15:55:00',1.9),('8998','2013-06-04','16:00:00',1.83),('8998','2013-06-04','16:05:00',1.78),('8998','2013-06-04','16:10:00',1.69),('8998','2013-06-04','16:15:00',1.65),('8998','2013-06-04','16:20:00',1.58),('8998','2013-06-04','16:25:00',1.53),('8998','2013-06-04','16:30:00',1.44),('8998','2013-06-04','16:35:00',1.4),('8998','2013-06-04','16:40:00',1.35),('8998','2013-06-04','16:45:00',1.29),('8998','2013-06-04','16:50:00',1.25),('8998','2013-06-04','16:55:00',1.19),('8998','2013-06-04','17:00:00',1.13),('8998','2013-06-04','17:05:00',1.06),('8998','2013-06-03','07:20:00',1.02),('8998','2013-06-03','07:25:00',1.04),('8998','2013-06-03','07:35:00',1.15),('8998','2013-06-03','07:40:00',1.28),('8998','2013-06-03','07:45:00',1.38),('8998','2013-06-03','07:50:00',1.46),('8998','2013-06-03','07:55:00',1.55),('8998','2013-06-03','08:00:00',1.66),('8998','2013-06-03','08:05:00',1.74),('8998','2013-06-03','08:10:00',1.73),('8998','2013-06-03','08:15:00',1.81),('8998','2013-06-03','08:20:00',1.97),('8998','2013-06-03','08:25:00',1.81),('8998','2013-06-03','08:30:00',1.66),('8998','2013-06-03','08:35:00',2.15),('8998','2013-06-03','08:40:00',1.92),('8998','2013-06-03','08:45:00',1.68),('8998','2013-06-03','08:50:00',1.04),('8998','2013-06-03','08:55:00',1.08),('8998','2013-06-03','09:00:00',1.25),('8998','2013-06-03','09:05:00',1.58),('8998','2013-06-03','09:10:00',1.92),('8998','2013-06-03','09:15:00',2.51),('8998','2013-06-03','09:20:00',2.56),('8998','2013-06-03','09:25:00',3.32),('8998','2013-06-03','09:30:00',2.57),('8998','2013-06-03','09:35:00',2.34),('8998','2013-06-03','09:40:00',1.36),('8998','2013-06-03','09:45:00',1.43),('8998','2013-06-03','09:50:00',1.24),('8998','2013-06-03','09:55:00',1.17),('8998','2013-06-03','10:00:00',1.48),('8998','2013-06-03','10:05:00',1.68),('8998','2013-06-03','10:10:00',2.68),('8998','2013-06-03','10:15:00',2.39),('8998','2013-06-03','10:20:00',1.43),('8998','2013-06-03','10:25:00',1.33),('8998','2013-06-03','10:30:00',1.25),('8998','2013-06-03','10:35:00',1.31),('8998','2013-06-03','10:40:00',1.36),('8998','2013-06-03','10:45:00',1.57),('8998','2013-06-03','10:50:00',2.17),('8998','2013-06-03','10:55:00',2.73),('8998','2013-06-03','11:00:00',1.77),('8998','2013-06-03','11:05:00',2.06),('8998','2013-06-03','11:10:00',2.62),('8998','2013-06-03','11:15:00',2.39),('8998','2013-06-03','11:20:00',1.67),('8998','2013-06-03','11:25:00',2.2),('8998','2013-06-03','11:30:00',2.64),('8998','2013-06-03','11:35:00',2.18),('8998','2013-06-03','11:40:00',2.36),('8998','2013-06-03','11:45:00',3.14),('8998','2013-06-03','11:50:00',3.46),('8998','2013-06-03','11:55:00',3.12),('8998','2013-06-03','12:00:00',2.47),('8998','2013-06-03','12:05:00',2.12),('8998','2013-06-03','12:10:00',1.8),('8998','2013-06-03','12:15:00',1.89),('8998','2013-06-03','12:20:00',1.33),('8998','2013-06-03','12:25:00',1.46),('8998','2013-06-03','12:30:00',1.96),('8998','2013-06-03','12:35:00',2.81),('8998','2013-06-03','12:40:00',1.81),('8998','2013-06-03','12:45:00',2.05),('8998','2013-06-03','12:50:00',1.75),('8998','2013-06-03','12:55:00',1.41),('8998','2013-06-03','13:00:00',1.56),('8998','2013-06-03','13:05:00',1.13),('8998','2013-06-03','13:15:00',1.01),('8998','2013-06-03','13:25:00',1.07),('8998','2013-06-03','13:30:00',1.29),('8998','2013-06-03','13:35:00',3.06),('8998','2013-06-03','13:40:00',2.88),('8998','2013-06-03','13:45:00',3.64),('8998','2013-06-03','13:50:00',3.61),('8998','2013-06-03','13:55:00',1.87),('8998','2013-06-03','14:00:00',1.27),('8998','2013-06-03','14:05:00',2.95),('8998','2013-06-03','14:10:00',3.35),('8998','2013-06-03','14:15:00',3.09),('8998','2013-06-03','14:20:00',2.3),('8998','2013-06-03','14:25:00',1.63),('8998','2013-06-03','14:30:00',1.03),('8998','2013-06-03','14:35:00',1.27),('8998','2013-06-03','14:40:00',1.65),('8998','2013-06-03','14:55:00',2.24),('8998','2013-06-03','15:00:00',3.4),('8998','2013-06-03','15:05:00',3.28),('8998','2013-06-03','15:10:00',1.65),('8998','2013-06-02','07:45:00',1.33),('8998','2013-06-02','07:50:00',1.33),('8998','2013-06-02','07:55:00',1.46),('8998','2013-06-02','08:00:00',1.53),('8998','2013-06-02','08:05:00',1.52),('8998','2013-06-02','08:10:00',1.53),('8998','2013-06-02','08:15:00',1.6),('8998','2013-06-02','08:20:00',1.76),('8998','2013-06-02','08:25:00',1.75),('8998','2013-06-02','08:30:00',1.77),('8998','2013-06-02','08:35:00',1.73),('8998','2013-06-02','08:40:00',1.76),('8998','2013-06-02','08:45:00',1.79),('8998','2013-06-02','08:50:00',1.93),('8998','2013-06-02','08:55:00',1.93),('8998','2013-06-02','09:00:00',2.06),('8998','2013-06-02','09:05:00',2.19),('8998','2013-06-02','09:10:00',2.54),('8998','2013-06-02','09:15:00',2.68),('8998','2013-06-02','09:20:00',2.19),('8998','2013-06-02','09:25:00',2.41),('8998','2013-06-02','09:30:00',2.26),('8998','2013-06-02','09:35:00',1.57),('8998','2013-06-02','09:40:00',1.77),('8998','2013-06-02','09:45:00',2.23),('8998','2013-06-02','09:50:00',3),('8998','2013-06-02','09:55:00',3.27),('8998','2013-06-02','10:00:00',3.48),('8998','2013-06-02','10:05:00',3.49),('8998','2013-06-02','10:10:00',2.96),('8998','2013-06-02','10:15:00',1.96),('8998','2013-06-02','10:20:00',1.09),('8998','2013-06-02','10:25:00',1.29),('8998','2013-06-02','10:30:00',1.02),('8998','2013-06-02','10:35:00',1.01),('8998','2013-06-02','10:40:00',1.25),('8998','2013-06-02','10:45:00',1.36),('8998','2013-06-02','10:50:00',2.55),('8998','2013-06-02','10:55:00',3.74),('8998','2013-06-02','11:00:00',1.68),('8998','2013-06-02','11:05:00',1.26),('8998','2013-06-02','11:15:00',1.05),('8998','2013-06-02','11:20:00',1.25),('8998','2013-06-02','11:25:00',1.28),('8998','2013-06-02','11:30:00',1.09),('8998','2013-06-02','11:35:00',1.01),('8998','2013-06-02','11:40:00',1.11),('8998','2013-06-02','11:45:00',1.96),('8998','2013-06-02','11:50:00',1.23),('8998','2013-06-02','11:55:00',1.21),('8998','2013-06-02','12:00:00',1.23),('8998','2013-06-02','12:05:00',2.94),('8998','2013-06-02','12:10:00',1.27),('8998','2013-06-02','12:15:00',1.03),('8998','2013-06-02','12:20:00',1.15),('8998','2013-06-02','12:25:00',1.09),('8998','2013-06-02','12:30:00',1.22),('8998','2013-06-02','12:35:00',1.25),('8998','2013-06-02','12:40:00',2.94),('8998','2013-06-02','12:45:00',1.74),('8998','2013-06-02','12:50:00',1.94),('8998','2013-06-02','12:55:00',1.89),('8998','2013-06-02','13:00:00',1.43),('8998','2013-06-02','13:05:00',1.26),('8998','2013-06-02','13:10:00',1.36),('8998','2013-06-02','13:15:00',1.79),('8998','2013-06-02','13:20:00',3.48),('8998','2013-06-02','13:25:00',2.37),('8998','2013-06-02','13:30:00',2.59),('8998','2013-06-02','13:35:00',2.82),('8998','2013-06-02','13:40:00',3.33),('8998','2013-06-02','13:45:00',1.62),('8998','2013-06-02','13:50:00',3.37),('8998','2013-06-02','13:55:00',2.08),('8998','2013-06-02','14:00:00',2.86),('8998','2013-06-02','14:05:00',2.87),('8998','2013-06-02','14:10:00',1.55),('8998','2013-06-02','14:15:00',1.47),('8998','2013-06-02','14:20:00',1.15),('8998','2013-06-02','14:25:00',1.84),('8998','2013-06-02','14:30:00',2.93),('8998','2013-06-02','14:35:00',3.04),('8998','2013-06-02','14:40:00',2.21),('8998','2013-06-02','14:45:00',2.33),('8998','2013-06-02','14:50:00',2.03),('8998','2013-06-02','14:55:00',2.17),('8998','2013-06-02','15:00:00',2.29),('8998','2013-06-02','15:05:00',1.94),('8998','2013-06-02','15:10:00',2.28),('8998','2013-06-02','15:15:00',1.53),('8998','2013-06-02','15:20:00',1.9),('8998','2013-06-02','15:25:00',2.24),('8998','2013-06-02','15:30:00',2.15),('8998','2013-06-02','15:35:00',2.11),('8998','2013-06-02','15:40:00',2.05),('8998','2013-06-02','15:45:00',2),('8998','2013-06-02','15:50:00',1.96),('8998','2013-06-02','15:55:00',1.93),('8998','2013-06-02','16:00:00',1.87),('8998','2013-06-02','16:05:00',1.82),('8998','2013-06-02','16:10:00',1.79),('8998','2013-06-02','16:15:00',1.68),('8998','2013-06-02','16:20:00',1.64),('8998','2013-06-02','16:25:00',1.61),('8998','2013-06-02','16:30:00',1.67),('8998','2013-06-02','16:35:00',1.59),('8998','2013-06-02','16:40:00',1.59),('8998','2013-06-02','16:45:00',1.4),('8998','2013-06-02','16:50:00',1.14),('8998','2013-06-02','16:55:00',1.06),('8998','2013-06-02','17:00:00',1.24),('8998','2013-06-02','17:05:00',1.38),('8998','2013-06-02','17:10:00',1.44),('8998','2013-06-02','17:15:00',1.27),('8998','2013-06-02','17:20:00',1.15),('8998','2013-06-01','09:15:00',1.02),('8998','2013-06-01','09:20:00',1.59),('8998','2013-06-01','09:25:00',3.18),('8998','2013-06-01','09:30:00',2.99),('8998','2013-06-01','09:35:00',2.92),('8998','2013-06-01','09:40:00',2.9),('8998','2013-06-01','09:45:00',2.9),('8998','2013-06-01','09:50:00',2.93),('8998','2013-06-01','09:55:00',2.95),('8998','2013-06-01','10:00:00',2.94),('8998','2013-06-01','10:05:00',3.04),('8998','2013-06-01','10:10:00',3.05),('8998','2013-06-01','10:15:00',3.03),('8998','2013-06-01','10:20:00',3.04),('8998','2013-06-01','10:25:00',3.11),('8998','2013-06-01','10:30:00',3.16),('8998','2013-06-01','10:35:00',3.25),('8998','2013-06-01','10:40:00',3.29),('8998','2013-06-01','10:45:00',2.63),('8998','2013-06-01','10:50:00',1.29),('8998','2013-06-01','10:55:00',1.18),('8998','2013-06-01','11:00:00',3.4),('8998','2013-06-01','11:05:00',3.07),('8998','2013-06-01','11:10:00',3.39),('8998','2013-06-01','11:15:00',2.33),('8998','2013-06-01','11:20:00',2.95),('8998','2013-06-01','11:25:00',1.83),('8998','2013-06-01','11:30:00',3.32),('8998','2013-06-01','11:35:00',1.75),('8998','2013-06-01','11:40:00',1.25),('8998','2013-06-01','11:50:00',1.35),('8998','2013-06-01','11:55:00',3.28),('8998','2013-06-01','12:00:00',3.05),('8998','2013-06-01','12:05:00',1.88),('8998','2013-06-01','12:10:00',2.75),('8998','2013-06-01','12:15:00',3.46),('8998','2013-06-01','12:20:00',1.81),('8998','2013-06-01','12:25:00',1.81),('8998','2013-06-01','12:30:00',2.84),('8998','2013-06-01','12:35:00',3.66),('8998','2013-06-01','12:40:00',2.41),('8998','2013-06-01','12:45:00',3.33),('8998','2013-06-01','12:50:00',1.7),('8998','2013-06-01','13:00:00',2.03),('8998','2013-06-01','13:05:00',1.87),('8998','2013-06-01','13:10:00',1.39),('8998','2013-06-01','13:15:00',3.58),('8998','2013-06-01','13:20:00',3.24),('8998','2013-06-01','13:25:00',3.08),('8998','2013-06-01','13:30:00',3.01),('8998','2013-06-01','13:35:00',2.97),('8998','2013-06-01','13:40:00',2.93),('8998','2013-06-01','13:45:00',2.88),('8998','2013-06-01','13:50:00',2.84),('8998','2013-06-01','13:55:00',2.82),('8998','2013-06-01','14:00:00',2.8),('8998','2013-06-01','14:05:00',2.76),('8998','2013-06-01','14:10:00',2.74),('8998','2013-06-01','14:15:00',2.74),('8998','2013-06-01','14:20:00',2.63),('8998','2013-06-01','14:25:00',2.66),('8998','2013-06-01','14:30:00',2.62),('8998','2013-06-01','14:35:00',2.56),('8998','2013-06-01','14:40:00',2.53),('8998','2013-06-01','14:45:00',2.49),('8998','2013-06-01','14:50:00',2.43),('8998','2013-06-01','14:55:00',2.41),('8998','2013-06-01','15:00:00',2.35),('8998','2013-06-01','15:05:00',2.32),('8998','2013-06-01','15:10:00',2.28),('8998','2013-06-01','15:15:00',2.26),('8998','2013-06-01','15:20:00',2.2),('8998','2013-06-01','15:25:00',1.96),('8998','2013-06-01','15:30:00',1.92),('8998','2013-06-01','15:35:00',1.88),('8998','2013-06-01','15:40:00',1.54),('8998','2013-06-01','15:45:00',1.61),('8998','2013-06-01','15:50:00',1.91),('8998','2013-06-01','15:55:00',1.69),('8998','2013-06-01','16:00:00',1.7),('8998','2013-06-01','16:05:00',1.75),('8998','2013-06-01','16:10:00',1.78),('8998','2013-06-01','16:15:00',1.74),('8998','2013-06-01','16:20:00',1.58),('8998','2013-06-01','16:25:00',1.59),('8998','2013-06-01','16:30:00',1.49),('8998','2013-06-01','16:35:00',1.4),('8998','2013-06-01','16:40:00',1.46),('8998','2013-06-01','16:45:00',1.34),('8998','2013-06-01','16:50:00',1.21),('8998','2013-06-01','16:55:00',1.25),('8998','2013-06-01','17:00:00',1.1),('8998','2013-06-01','17:10:00',1.05),('8998','2013-05-31','07:15:00',1.08),('8998','2013-05-31','07:20:00',1.25),('8998','2013-05-31','07:25:00',1.27),('8998','2013-05-31','07:30:00',1.22),('8998','2013-05-31','07:35:00',1.23),('8998','2013-05-31','07:40:00',1.36),('8998','2013-05-31','07:45:00',1.51),('8998','2013-05-31','07:55:00',1.29),('8998','2013-05-31','08:15:00',1.04),('8998','2013-05-31','08:20:00',1.27),('8998','2013-05-31','08:35:00',1.58),('8998','2013-05-31','10:50:00',1.42),('8998','2013-05-31','10:55:00',1.76),('8998','2013-05-31','11:55:00',1.32),('8998','2013-05-31','12:00:00',1.56),('8998','2013-05-31','12:05:00',2.19),('8998','2013-05-31','12:10:00',2.32),('8998','2013-05-31','12:15:00',1.26),('8998','2013-05-31','12:45:00',1.05),('8998','2013-05-31','12:50:00',1.34),('8998','2013-05-31','12:55:00',1.26),('8998','2013-05-31','13:00:00',1.46),('8998','2013-05-31','13:05:00',1.64),('8998','2013-05-31','13:10:00',1.7),('8998','2013-05-31','13:15:00',1.89),('8998','2013-05-31','13:20:00',1.77),('8998','2013-05-31','13:25:00',1.36),('8998','2013-05-31','13:30:00',1.24),('8998','2013-05-31','13:55:00',1.03),('8998','2013-05-31','14:00:00',1.3),('8998','2013-05-31','14:05:00',1.71),('8998','2013-05-31','14:10:00',1.71),('8998','2013-05-31','14:15:00',1.77),('8998','2013-05-31','14:20:00',1.98),('8998','2013-05-31','14:25:00',1.3),('8998','2013-05-31','14:30:00',1),('8998','2013-05-31','14:35:00',1.04),('8998','2013-05-31','14:40:00',1.01),('8998','2014-04-01','08:55:00',1.86),('8998','2014-04-01','09:00:00',1.14),('8998','2014-04-01','09:55:00',1.14),('8998','2014-04-01','10:00:00',2.28),('8998','2014-04-01','10:05:00',2),('8998','2014-04-01','10:10:00',2.58),('8998','2014-04-01','10:15:00',2.69),('8998','2014-04-01','10:20:00',2.57),('8998','2014-04-01','10:25:00',2.35),('8998','2014-04-01','10:50:00',2.07),('8998','2014-04-01','10:55:00',2.87),('8998','2014-04-01','11:00:00',2.73),('8998','2014-04-01','11:05:00',2.6),('8998','2014-04-01','11:10:00',1.4),('8998','2014-04-01','11:15:00',2.13),('8998','2014-04-01','11:20:00',2.46),('8998','2014-04-01','11:25:00',2.98),('8998','2014-04-01','11:30:00',1.81),('8998','2014-04-01','11:35:00',1.35),('8998','2014-04-01','11:40:00',1.51),('8998','2014-04-01','11:45:00',1.76),('8998','2014-04-01','11:50:00',3.12),('8998','2014-04-01','11:55:00',3.07),('8998','2014-04-01','12:00:00',2.97),('8998','2014-04-01','12:05:00',1.94),('8998','2014-04-01','12:15:00',1.81),('8998','2014-04-01','12:20:00',2.91),('8998','2014-04-01','12:25:00',3.12),('8998','2014-04-01','12:30:00',2.91),('8998','2014-04-01','12:35:00',2.29),('8998','2014-04-01','12:40:00',2.3),('8998','2014-04-01','12:45:00',2.66),('8998','2014-04-01','12:50:00',2.87),('8998','2014-04-01','12:55:00',1.69),('8998','2014-04-01','13:00:00',2.1),('8998','2014-04-01','13:05:00',1.75),('8998','2014-04-01','13:10:00',2.23),('8998','2014-04-01','13:15:00',1.44),('8998','2014-04-01','13:20:00',1.71),('8998','2014-04-01','13:25:00',1.43),('8998','2014-04-01','13:30:00',2.1),('8998','2014-04-01','13:35:00',2.13),('8998','2014-04-01','13:40:00',2.04),('8998','2014-04-01','13:45:00',2.85),('8998','2014-04-01','13:50:00',2.64),('8998','2014-04-01','13:55:00',2.63),('8998','2014-04-01','14:00:00',2.6),('8998','2014-04-01','14:05:00',2.48),('8998','2014-04-01','14:10:00',2.52),('8998','2014-04-01','14:15:00',2.5),('8998','2014-04-01','14:20:00',2.39),('8998','2014-04-01','14:25:00',2.4),('8998','2014-04-01','14:30:00',2.31),('8998','2014-04-01','14:35:00',2.17),('8998','2014-04-01','14:40:00',2.27),('8998','2014-04-01','14:45:00',2.18),('8998','2014-04-01','14:50:00',1.72),('8998','2014-04-01','14:55:00',1.69),('8998','2014-04-01','15:00:00',1.96),('8998','2014-04-01','15:05:00',1.91),('8998','2014-04-01','15:10:00',1.75),('8998','2014-04-01','15:15:00',1.72),('8998','2014-04-01','15:20:00',1.7),('8998','2014-04-01','15:25:00',1.64),('8998','2014-04-01','15:30:00',1.53),('8998','2014-04-01','15:35:00',1.46),('8998','2014-04-01','15:40:00',1.52),('8998','2014-04-01','15:45:00',1.5),('8998','2014-04-01','15:50:00',1.44),('8998','2014-04-01','15:55:00',1.25),('8998','2014-04-01','16:00:00',1.26),('8998','2014-04-01','16:05:00',1.22),('8998','2014-04-01','16:10:00',1.15),('8998','2014-04-01','16:15:00',1.1),('8998','2014-04-01','16:20:00',1.03),('8998','2013-05-30','07:15:00',1.11),('8998','2013-05-30','07:20:00',1.22),('8998','2013-05-30','07:25:00',1.31),('8998','2013-05-30','07:30:00',1.26),('8998','2013-05-30','07:35:00',1.3),('8998','2013-05-30','07:40:00',1.34),('8998','2013-05-30','07:45:00',1.46),('8998','2013-05-30','07:50:00',1.41),('8998','2013-05-30','07:55:00',1.48),('8998','2013-05-30','08:00:00',1.59),('8998','2013-05-30','08:05:00',1.66),('8998','2013-05-30','08:10:00',1.97),('8998','2013-05-30','08:15:00',1.85),('8998','2013-05-30','08:20:00',1.81),('8998','2013-05-30','08:25:00',1.78),('8998','2013-05-30','08:30:00',1.84),('8998','2013-05-30','08:35:00',1.32),('8998','2013-05-30','08:40:00',2.53),('8998','2013-05-30','08:45:00',2.43),('8998','2013-05-30','08:50:00',2.84),('8998','2013-05-30','08:55:00',1.57),('8998','2013-05-30','09:15:00',1.65),('8998','2013-05-30','09:35:00',1.68),('8998','2013-05-30','09:40:00',1.71),('8998','2013-05-30','09:45:00',3.25),('8998','2013-05-30','09:50:00',3.22),('8998','2013-05-30','09:55:00',3.27),('8998','2013-05-30','10:00:00',3),('8998','2013-05-30','10:05:00',2.84),('8998','2013-05-30','10:10:00',2.06),('8998','2013-05-30','10:15:00',1.8),('8998','2013-05-30','10:20:00',2.41),('8998','2013-05-30','10:35:00',1.74),('8998','2013-05-30','10:40:00',2.64),('8998','2013-05-30','10:45:00',3.77),('8998','2013-05-30','10:50:00',1.95),('8998','2013-05-30','10:55:00',2.32),('8998','2013-05-30','11:00:00',1.21),('8998','2013-05-30','11:05:00',1.42),('8998','2013-05-30','11:10:00',2.99),('8998','2013-05-30','11:15:00',3.11),('8998','2013-05-30','11:20:00',1.35),('8998','2013-05-30','11:25:00',2.28),('8998','2013-05-30','11:30:00',3.6),('8998','2013-05-30','11:35:00',1.35),('8998','2013-05-30','11:45:00',2.57),('8998','2013-05-30','11:50:00',2.97),('8998','2013-05-30','11:55:00',1.84),('8998','2013-05-30','12:00:00',2.32),('8998','2013-05-30','12:05:00',3.31),('8998','2013-05-30','12:10:00',2.75),('8998','2013-05-30','12:15:00',1.25),('8998','2013-05-30','12:20:00',1.18),('8998','2013-05-30','12:25:00',2.64),('8998','2013-05-30','12:30:00',1.36),('8998','2013-05-30','12:35:00',1.11),('8998','2013-05-30','12:40:00',3.23),('8998','2013-05-30','12:45:00',2.05),('8998','2013-05-30','12:55:00',1.07),('8998','2013-05-30','13:00:00',3.36),('8998','2013-05-30','13:05:00',1.75),('8998','2013-05-30','13:25:00',1.35),('8998','2013-05-30','13:30:00',2.27),('8998','2013-05-30','13:35:00',3.33),('8998','2013-05-30','13:40:00',2.01),('8998','2013-05-30','13:45:00',1.15),('8998','2013-05-30','14:00:00',1.88),('8998','2013-05-30','15:10:00',1.17),('8998','2013-05-30','15:15:00',1.63),('8998','2013-05-30','15:20:00',2.89),('8998','2013-05-30','15:25:00',1.41),('8998','2013-05-30','15:30:00',1.75),('8998','2013-05-30','15:35:00',1.48),('8998','2013-05-30','15:40:00',1.32),('8998','2013-05-30','15:45:00',1.14),('8998','2013-05-30','15:50:00',1.25),('8998','2013-05-30','15:55:00',1.46),('8998','2013-05-30','16:00:00',1.17),('8998','2013-05-29','08:25:00',1.02),('8998','2013-05-29','08:40:00',2.44),('8998','2013-05-29','08:45:00',2.52),('8998','2013-05-29','08:50:00',2.54),('8998','2013-05-29','08:55:00',2.56),('8998','2013-05-29','09:00:00',2.56),('8998','2013-05-29','09:05:00',2.6),('8998','2013-05-29','09:10:00',2.68),('8998','2013-05-29','09:15:00',2.74),('8998','2013-05-29','09:20:00',2.75),('8998','2013-05-29','09:25:00',2.99),('8998','2013-05-29','09:30:00',3.09),('8998','2013-05-29','09:35:00',3),('8998','2013-05-29','09:40:00',3.04),('8998','2013-05-29','09:45:00',2.75),('8998','2013-05-29','09:50:00',3.18),('8998','2013-05-29','09:55:00',2.27),('8998','2013-05-29','10:05:00',1.03),('8998','2013-05-29','10:10:00',3.18),('8998','2013-05-29','10:15:00',1.03),('8998','2013-05-29','10:20:00',3.23),('8998','2013-05-29','10:25:00',1.01),('8998','2013-05-29','10:40:00',1.35),('8998','2013-05-29','10:45:00',3.08),('8998','2013-05-29','10:50:00',3.65),('8998','2013-05-29','10:55:00',3.41),('8998','2013-05-29','11:00:00',3.35),('8998','2013-05-29','11:05:00',3.15),('8998','2013-05-29','11:10:00',1.6),('8998','2013-05-29','11:15:00',1.11),('8998','2013-05-29','11:20:00',3.45),('8998','2013-05-29','11:25:00',1.97),('8998','2013-05-29','11:30:00',2.07),('8998','2013-05-29','11:35:00',3.16),('8998','2013-05-29','11:40:00',3.78),('8998','2013-05-29','11:45:00',2.47),('8998','2013-05-29','11:50:00',3.74),('8998','2013-05-29','11:55:00',1.02),('8998','2013-05-29','12:00:00',1.87),('8998','2013-05-29','12:05:00',3.76),('8998','2013-05-29','12:10:00',3.18),('8998','2013-05-29','12:15:00',2.58),('8998','2013-05-29','12:20:00',3.59),('8998','2013-05-29','12:25:00',2.76),('8998','2013-05-29','12:30:00',2.96),('8998','2013-05-29','12:35:00',2.82),('8998','2013-05-29','12:40:00',2.78),('8998','2013-05-29','12:45:00',1.53),('8998','2013-05-29','12:50:00',2.73),('8998','2013-05-29','12:55:00',3.33),('8998','2013-05-29','13:00:00',2.65),('8998','2013-05-29','13:05:00',1.38),('8998','2013-05-29','13:10:00',1.33),('8998','2013-05-29','13:15:00',1.8),('8998','2013-05-29','13:20:00',1.49),('8998','2013-05-29','13:25:00',1.49),('8998','2013-05-29','13:30:00',1.82),('8998','2013-05-29','13:35:00',1.22),('8998','2013-05-29','13:40:00',2.64),('8998','2013-05-29','13:45:00',2.39),('8998','2013-05-29','13:50:00',1.13),('8998','2013-05-29','13:55:00',1.34),('8998','2013-05-29','14:00:00',3.09),('8998','2013-05-29','14:05:00',3.35),('8998','2013-05-29','14:10:00',2.6),('8998','2013-05-29','14:15:00',1.48),('8998','2013-05-29','14:20:00',2.87),('8998','2013-05-29','14:25:00',1.55),('8998','2013-05-29','14:30:00',3.07),('8998','2013-05-29','14:35:00',2.4),('8998','2013-05-29','14:40:00',2.86),('8998','2013-05-29','14:45:00',2.77),('8998','2013-05-29','14:50:00',2.79),('8998','2013-05-29','14:55:00',2.65),('8998','2013-05-29','15:00:00',2.59),('8998','2013-05-29','15:05:00',2.57),('8998','2013-05-29','15:15:00',2.41),('8998','2013-05-29','15:20:00',2.5),('8998','2013-05-29','15:25:00',2.39),('8998','2013-05-29','15:30:00',2.36),('8998','2013-05-29','15:35:00',2.43),('8998','2013-05-29','15:40:00',2.35),('8998','2013-05-29','15:45:00',1.86),('8998','2013-05-29','15:50:00',2),('8998','2013-05-29','15:55:00',1.62),('8998','2013-05-29','16:00:00',2.37),('8998','2013-05-29','16:05:00',1.92),('8998','2013-05-29','16:10:00',1.97),('8998','2013-05-29','16:15:00',1.82),('8998','2013-05-29','16:20:00',1.61),('8998','2013-05-29','16:25:00',1.35),('8998','2013-05-29','16:45:00',1.08),('8998','2013-05-29','16:50:00',1.22),('8998','2013-05-29','16:55:00',1.2),('8998','2013-05-28','07:15:00',1.09),('8998','2013-05-28','07:20:00',1.21),('8998','2013-05-28','07:25:00',1.21),('8998','2013-05-28','07:30:00',1.19),('8998','2013-05-28','07:35:00',1.28),('8998','2013-05-28','07:40:00',1.37),('8998','2013-05-28','07:45:00',1.4),('8998','2013-05-28','07:50:00',1.32),('8998','2013-05-28','07:55:00',1.34),('8998','2013-05-28','08:00:00',1.65),('8998','2013-05-28','08:05:00',1.9),('8998','2013-05-28','08:10:00',1.88),('8998','2013-05-28','08:15:00',1.75),('8998','2013-05-28','08:20:00',1.71),('8998','2013-05-28','08:25:00',1.68),('8998','2013-05-28','08:30:00',1.69),('8998','2013-05-28','08:35:00',1.67),('8998','2013-05-28','08:40:00',1.74),('8998','2013-05-28','08:45:00',1.79),('8998','2013-05-28','08:50:00',1.91),('8998','2013-05-28','08:55:00',1.97),('8998','2013-05-28','09:00:00',2.36),('8998','2013-05-28','09:05:00',2.48),('8998','2013-05-28','09:10:00',2.57),('8998','2013-05-28','09:15:00',2.69),('8998','2013-05-28','09:20:00',2.76),('8998','2013-05-28','09:25:00',2.79),('8998','2013-05-28','09:30:00',2.81),('8998','2013-05-28','09:35:00',2.84),('8998','2013-05-28','09:40:00',2.88),('8998','2013-05-28','09:45:00',2.92),('8998','2013-05-28','09:50:00',2.93),('8998','2013-05-28','09:55:00',2.96),('8998','2013-05-28','10:00:00',2.97),('8998','2013-05-28','10:05:00',3),('8998','2013-05-28','10:10:00',3.01),('8998','2013-05-28','10:15:00',3.02),('8998','2013-05-28','10:20:00',3.08),('8998','2013-05-28','10:25:00',3.11),('8998','2013-05-28','10:30:00',3.14),('8998','2013-05-28','10:35:00',3.17),('8998','2013-05-28','10:40:00',3.18),('8998','2013-05-28','10:45:00',3.22),('8998','2013-05-28','10:50:00',3.22),('8998','2013-05-28','10:55:00',3.25),('8998','2013-05-28','11:00:00',3.26),('8998','2013-05-28','11:05:00',3.29),('8998','2013-05-28','11:10:00',3.31),('8998','2013-05-28','11:15:00',2.53),('8998','2013-05-28','11:20:00',2.89),('8998','2013-05-28','11:25:00',2),('8998','2013-05-28','11:30:00',3.48),('8998','2013-05-28','11:35:00',3.49),('8998','2013-05-28','11:40:00',2.84),('8998','2013-05-28','11:45:00',2.99),('8998','2013-05-28','11:50:00',2.82),('8998','2013-05-28','11:55:00',2.73),('8998','2013-05-28','12:00:00',3.43),('8998','2013-05-28','12:05:00',2.8),('8998','2013-05-28','12:10:00',2.72),('8998','2013-05-28','12:15:00',2.76),('8998','2013-05-28','12:20:00',3.51),('8998','2013-05-28','12:25:00',3.31),('8998','2013-05-28','12:30:00',3.31),('8998','2013-05-28','12:35:00',3.29),('8998','2013-05-28','12:40:00',3.28),('8998','2013-05-28','12:45:00',3.1),('8998','2013-05-28','12:50:00',3.14),('8998','2013-05-28','12:55:00',3.14),('8998','2013-05-28','13:00:00',3.21),('8998','2013-05-28','13:05:00',3.24),('8998','2013-05-28','13:10:00',2.6),('8998','2013-05-28','13:15:00',3.16),('8998','2013-05-28','13:20:00',3.46),('8998','2013-05-28','13:25:00',3.48),('8998','2013-05-28','13:30:00',3.35),('8998','2013-05-28','13:35:00',2.78),('8998','2013-05-28','13:40:00',3.05),('8998','2013-05-28','13:45:00',2.93),('8998','2013-05-28','13:50:00',2.67),('8998','2013-05-28','13:55:00',2.51),('8998','2013-05-28','14:00:00',2.99),('8998','2013-05-28','14:05:00',2.89),('8998','2013-05-28','14:10:00',2.75),('8998','2013-05-28','14:15:00',2.81),('8998','2013-05-28','14:20:00',2.78),('8998','2013-05-28','14:25:00',2.31),('8998','2013-05-28','14:30:00',2.73),('8998','2013-05-28','14:35:00',2.12),('8998','2013-05-28','14:40:00',2.84),('8998','2013-05-28','14:45:00',2.74),('8998','2013-05-28','14:50:00',2.49),('8998','2013-05-28','14:55:00',2.54),('8998','2013-05-28','15:00:00',2.65),('8998','2013-05-28','15:05:00',2.64),('8998','2013-05-28','15:10:00',2.51),('8998','2013-05-28','15:15:00',1.59),('8998','2013-05-28','15:20:00',1.84),('8998','2013-05-28','15:25:00',1.59),('8998','2013-05-28','15:30:00',1.7),('8998','2013-05-28','15:35:00',1.85),('8998','2013-05-28','15:40:00',1.83),('8998','2013-05-28','15:45:00',1.78),('8998','2013-05-28','15:50:00',1.72),('8998','2013-05-28','15:55:00',1.78),('8998','2013-05-28','16:00:00',1.61),('8998','2013-05-28','16:05:00',1.59),('8998','2013-05-28','16:10:00',1.37),('8998','2013-05-28','16:15:00',1.28),('8998','2013-05-28','16:20:00',1.24),('8998','2013-05-28','16:25:00',1.25),('8998','2013-05-28','16:30:00',1.23),('8998','2013-05-28','16:35:00',1.13),('8998','2013-05-28','16:40:00',1.25),('8998','2013-05-28','16:45:00',1.15),('8998','2013-05-27','07:20:00',1.11),('8998','2013-05-27','07:25:00',1.12),('8998','2013-05-27','07:40:00',1.05),('8998','2013-05-27','07:45:00',1.13),('8998','2013-05-27','07:50:00',1.12),('8998','2013-05-27','07:55:00',1.1),('8998','2013-05-27','08:00:00',1.15),('8998','2013-05-27','08:05:00',1.24),('8998','2013-05-27','08:10:00',1.34),('8998','2013-05-27','08:15:00',1.6),('8998','2013-05-27','08:20:00',1.69),('8998','2013-05-27','08:25:00',1.48),('8998','2013-05-27','08:30:00',1.58),('8998','2013-05-27','08:35:00',1.45),('8998','2013-05-27','08:40:00',1.27),('8998','2013-05-27','08:45:00',1.16),('8998','2013-05-27','08:50:00',1.36),('8998','2013-05-27','08:55:00',1.21),('8998','2013-05-27','09:00:00',1.37),('8998','2013-05-27','09:05:00',1.51),('8998','2013-05-27','09:10:00',1.42),('8998','2013-05-27','09:15:00',1.3),('8998','2013-05-27','09:20:00',1.57),('8998','2013-05-27','09:25:00',1.84),('8998','2013-05-27','09:30:00',1.98),('8998','2013-05-27','09:35:00',2.07),('8998','2013-05-27','09:40:00',1.91),('8998','2013-05-27','09:45:00',1.71),('8998','2013-05-27','09:50:00',1.72),('8998','2013-05-27','09:55:00',1.81),('8998','2013-05-27','10:00:00',1.67),('8998','2013-05-27','10:05:00',1.77),('8998','2013-05-27','10:10:00',2.01),('8998','2013-05-27','10:15:00',2.08),('8998','2013-05-27','10:20:00',2.22),('8998','2013-05-27','10:25:00',2.16),('8998','2013-05-27','10:30:00',2.41),('8998','2013-05-27','10:35:00',2.48),('8998','2013-05-27','10:40:00',2.21),('8998','2013-05-27','10:45:00',1.98),('8998','2013-05-27','10:50:00',2.16),('8998','2013-05-27','10:55:00',1.89),('8998','2013-05-27','11:00:00',1.86),('8998','2013-05-27','11:05:00',1.79),('8998','2013-05-27','11:10:00',2.05),('8998','2013-05-27','11:15:00',1.49),('8998','2013-05-27','11:20:00',1.74),('8998','2013-05-27','11:25:00',1.56),('8998','2013-05-27','11:30:00',2.7),('8998','2013-05-27','11:35:00',2.34),('8998','2013-05-27','11:40:00',2.66),('8998','2013-05-27','11:45:00',2.78),('8998','2013-05-27','11:55:00',1.09),('8998','2013-05-27','12:00:00',1.15),('8998','2013-05-27','12:05:00',1.23),('8998','2013-05-27','12:10:00',2),('8998','2013-05-27','12:15:00',1.96),('8998','2013-05-27','12:20:00',1.64),('8998','2013-05-27','12:25:00',1.64),('8998','2013-05-27','12:30:00',1.91),('8998','2013-05-27','12:35:00',1.86),('8998','2013-05-27','12:40:00',1.86),('8998','2013-05-27','12:45:00',2.13),('8998','2013-05-27','12:50:00',1.92),('8998','2013-05-27','12:55:00',1.9),('8998','2013-05-27','13:00:00',1.97),('8998','2013-05-27','13:05:00',2.09),('8998','2013-05-27','13:10:00',2.2),('8998','2013-05-27','13:15:00',1.94),('8998','2013-05-27','13:20:00',2.55),('8998','2013-05-27','13:25:00',1.4),('8998','2013-05-27','13:30:00',1.52),('8998','2013-05-27','13:35:00',1.27),('8998','2013-05-27','13:40:00',1.41),('8998','2013-05-27','13:45:00',1.31),('8998','2013-05-27','13:50:00',1.87),('8998','2013-05-27','13:55:00',1.94),('8998','2013-05-27','14:00:00',1.8),('8998','2013-05-27','14:05:00',1.83),('8998','2013-05-27','14:10:00',2.54),('8998','2013-05-27','14:15:00',2.69),('8998','2013-05-27','14:20:00',1.66),('8998','2013-05-27','14:25:00',1.93),('8998','2013-05-27','14:30:00',2.24),('8998','2013-05-27','14:35:00',1.93),('8998','2013-05-27','14:40:00',2.16),('8998','2013-05-27','14:45:00',2.48),('8998','2013-05-27','14:50:00',1.89),('8998','2013-05-27','14:55:00',1.72),('8998','2013-05-27','15:00:00',1.45),('8998','2013-05-27','15:05:00',2.29),('8998','2013-05-27','15:10:00',1.16),('8998','2013-05-27','15:15:00',1.54),('8998','2013-05-27','15:20:00',1.9),('8998','2013-05-27','15:25:00',1.33),('8998','2013-05-27','15:30:00',1.01),('8998','2013-05-27','15:35:00',1.01),('8998','2013-05-27','15:40:00',1.32),('8998','2013-05-27','15:45:00',2.11),('8998','2013-05-27','15:50:00',1.73),('8998','2013-05-27','15:55:00',1.38),('8998','2013-05-27','16:20:00',1.24),('8998','2013-05-27','16:25:00',1.22),('8998','2013-05-27','16:30:00',1.15),('8998','2013-05-27','16:35:00',1.44),('8998','2013-05-27','16:40:00',1.28),('8998','2013-05-27','16:45:00',1.2),('8998','2013-05-27','16:50:00',1.15),('8998','2013-05-27','16:55:00',1.08),('8998','2013-05-27','17:00:00',1.04),('8998','2013-05-26','07:30:00',1.46),('8998','2013-05-26','07:35:00',1.52),('8998','2013-05-26','07:40:00',1.44),('8998','2013-05-26','07:45:00',1.35),('8998','2013-05-26','07:50:00',1.37),('8998','2013-05-26','08:00:00',1.37),('8998','2013-05-26','08:05:00',1.84),('8998','2013-05-26','08:10:00',2.21),('8998','2013-05-26','08:15:00',1.7),('8998','2013-05-26','08:20:00',2.06),('8998','2013-05-26','08:25:00',2.31),('8998','2013-05-26','08:30:00',2.22),('8998','2013-05-26','08:35:00',2.16),('8998','2013-05-26','08:40:00',2.1),('8998','2013-05-26','08:45:00',2.1),('8998','2013-05-26','08:50:00',2.34),('8998','2013-05-26','08:55:00',1.91),('8998','2013-05-26','09:00:00',2.27),('8998','2013-05-26','09:05:00',2.76),('8998','2013-05-26','09:10:00',2.52),('8998','2013-05-26','09:15:00',1.62),('8998','2013-05-26','09:20:00',2.18),('8998','2013-05-26','09:25:00',2.59),('8998','2013-05-26','09:30:00',3.03),('8998','2013-05-26','09:35:00',2.99),('8998','2013-05-26','09:40:00',2.97),('8998','2013-05-26','09:45:00',3),('8998','2013-05-26','09:50:00',1.91),('8998','2013-05-26','09:55:00',2.24),('8998','2013-05-26','10:00:00',3.27),('8998','2013-05-26','10:05:00',2.81),('8998','2013-05-26','10:10:00',3.23),('8998','2013-05-26','10:15:00',3.28),('8998','2013-05-26','10:20:00',2.8),('8998','2013-05-26','10:25:00',1.9),('8998','2013-05-26','10:30:00',1.74),('8998','2013-05-26','10:45:00',2.37),('8998','2013-05-26','10:50:00',2.18),('8998','2013-05-26','10:55:00',1.99),('8998','2013-05-26','11:00:00',2.13),('8998','2013-05-26','11:05:00',2.4),('8998','2013-05-26','11:10:00',2.43),('8998','2013-05-26','11:15:00',1.47),('8998','2013-05-26','11:20:00',2.48),('8998','2013-05-26','11:25:00',3.53),('8998','2013-05-26','11:30:00',2.11),('8998','2013-05-26','11:35:00',2.75),('8998','2013-05-26','11:40:00',2.05),('8998','2013-05-26','11:45:00',3.6),('8998','2013-05-26','11:50:00',1.73),('8998','2013-05-26','11:55:00',1.46),('8998','2013-05-26','12:00:00',3.12),('8998','2013-05-26','12:05:00',3.2),('8998','2013-05-26','12:10:00',1.84),('8998','2013-05-26','12:15:00',3),('8998','2013-05-26','12:20:00',2.31),('8998','2013-05-26','12:25:00',2.69),('8998','2013-05-26','12:30:00',2.73),('8998','2013-05-26','12:35:00',1.83),('8998','2013-05-26','12:40:00',2.48),('8998','2013-05-26','12:45:00',3.7),('8998','2013-05-26','12:50:00',3.46),('8998','2013-05-26','12:55:00',3.26),('8998','2013-05-26','13:00:00',2.17),('8998','2013-05-26','13:05:00',2.55),('8998','2013-05-26','13:10:00',3.3),('8998','2013-05-26','13:15:00',2.8),('8998','2013-05-26','13:20:00',3.08),('8998','2013-05-26','13:25:00',2.65),('8998','2013-05-26','13:30:00',3.25),('8998','2013-05-26','13:35:00',2.8),('8998','2013-05-26','13:40:00',2.97),('8998','2013-05-26','13:45:00',3.26),('8998','2013-05-26','13:50:00',2.68),('8998','2013-05-26','13:55:00',2.04),('8998','2013-05-26','14:00:00',2.98),('8998','2013-05-26','14:05:00',2.93),('8998','2013-05-26','14:10:00',2.83),('8998','2013-05-26','14:15:00',2.26),('8998','2013-05-26','14:20:00',2.51),('8998','2013-05-26','14:25:00',2.36),('8998','2013-05-26','14:30:00',2.5),('8998','2013-05-26','14:35:00',2.74),('8998','2013-05-26','14:45:00',2.85),('8998','2013-05-26','14:50:00',2.75),('8998','2013-05-26','14:55:00',2.14),('8998','2013-05-26','15:00:00',1.69),('8998','2013-05-26','15:05:00',1.59),('8998','2013-05-26','15:10:00',2.49),('8998','2013-05-26','15:15:00',1.72),('8998','2013-05-26','15:20:00',1.99),('8998','2013-05-26','15:25:00',1.9),('8998','2013-05-26','15:30:00',2.02),('8998','2013-05-26','15:35:00',2.27),('8998','2013-05-26','15:40:00',1.82),('8998','2013-05-26','15:45:00',1.73),('8998','2013-05-26','15:50:00',2.16),('8998','2013-05-26','15:55:00',1.44),('8998','2013-05-26','16:00:00',1.68),('8998','2013-05-26','16:05:00',1.22),('8998','2013-05-26','16:10:00',1.45),('8998','2013-05-26','16:15:00',1.28),('8998','2013-05-26','16:20:00',1.89),('8998','2013-05-26','16:25:00',1.74),('8998','2013-05-26','16:30:00',1.5),('8998','2013-05-26','16:35:00',1.41),('8998','2013-05-26','17:10:00',1.04),('8998','2013-05-25','07:35:00',1.17),('8998','2013-05-25','07:40:00',1.49),('8998','2013-05-25','07:45:00',1.68),('8998','2013-05-25','07:50:00',2.08),('8998','2013-05-25','07:55:00',1.04),('8998','2013-05-25','08:05:00',2.25),('8998','2013-05-25','08:10:00',2.09),('8998','2013-05-25','08:25:00',1.4),('8998','2013-05-25','08:30:00',2.08),('8998','2013-05-25','08:35:00',2.34),('8998','2013-05-25','08:40:00',2.29),('8998','2013-05-25','08:45:00',2.07),('8998','2013-05-25','08:50:00',2.11),('8998','2013-05-25','09:00:00',2.19),('8998','2013-05-25','09:10:00',1.48),('8998','2013-05-25','09:15:00',2.51),('8998','2013-05-25','09:25:00',1.33),('8998','2013-05-25','09:45:00',1.78),('8998','2013-05-25','10:00:00',1.09),('8998','2013-05-25','10:05:00',2.76),('8998','2013-05-25','10:10:00',3.56),('8998','2013-05-25','10:15:00',2.4),('8998','2013-05-25','10:20:00',3.03),('8998','2013-05-25','10:25:00',2.51),('8998','2013-05-25','10:30:00',2.91),('8998','2013-05-25','10:35:00',2.7),('8998','2013-05-25','10:40:00',3.4),('8998','2013-05-25','10:45:00',3.39),('8998','2013-05-25','10:50:00',3.4),('8998','2013-05-25','10:55:00',3.19),('8998','2013-05-25','11:00:00',3.31),('8998','2013-05-25','11:05:00',3.44),('8998','2013-05-25','11:10:00',3.43),('8998','2013-05-25','11:15:00',3.41),('8998','2013-05-25','11:20:00',3.44),('8998','2013-05-25','11:25:00',3.46),('8998','2013-05-25','11:30:00',3.46),('8998','2013-05-25','11:35:00',3.48),('8998','2013-05-25','11:40:00',3.5),('8998','2013-05-25','11:45:00',3.51),('8998','2013-05-25','11:50:00',3.52),('8998','2013-05-25','11:55:00',3.44),('8998','2013-05-25','12:00:00',3.43),('8998','2013-05-25','12:05:00',3.48),('8998','2013-05-25','12:10:00',3.45),('8998','2013-05-25','12:15:00',3.22),('8998','2013-05-25','12:20:00',2.69),('8998','2013-05-25','12:25:00',2.8),('8998','2013-05-25','12:30:00',3.53),('8998','2013-05-25','12:35:00',3.43),('8998','2013-05-25','12:40:00',2.98),('8998','2013-05-25','12:45:00',2.36),('8998','2013-05-25','12:50:00',3.41),('8998','2013-05-25','12:55:00',3.36),('8998','2013-05-25','13:00:00',3.35),('8998','2013-05-25','13:05:00',3.33),('8998','2013-05-25','13:10:00',3.28),('8998','2013-05-25','13:15:00',3.12),('8998','2013-05-25','13:20:00',3.21),('8998','2013-05-25','13:25:00',3.22),('8998','2013-05-25','13:30:00',3.18),('8998','2013-05-25','13:35:00',3.15),('8998','2013-05-25','13:40:00',3.1),('8998','2013-05-25','13:45:00',3.09),('8998','2013-05-25','13:50:00',2.57),('8998','2013-05-25','13:55:00',2.99),('8998','2013-05-25','14:00:00',2.94),('8998','2013-05-25','14:05:00',2.92),('8998','2013-05-25','14:10:00',2.87),('8998','2013-05-25','14:15:00',2.82),('8998','2013-05-25','14:20:00',2.79),('8998','2013-05-25','14:25:00',2.74),('8998','2013-05-25','14:30:00',2.71),('8998','2013-05-25','14:35:00',2.68),('8998','2013-05-25','14:40:00',2.63),('8998','2013-05-25','14:45:00',2.59),('8998','2013-05-25','14:50:00',2.56),('8998','2013-05-25','14:55:00',2.51),('8998','2013-05-25','15:00:00',2.45),('8998','2013-05-25','15:05:00',2.41),('8998','2013-05-25','15:10:00',2.38),('8998','2013-05-25','15:15:00',2.34),('8998','2013-05-25','15:20:00',2.28),('8998','2013-05-25','15:25:00',2.22),('8998','2013-05-25','15:30:00',2.17),('8998','2013-05-25','15:35:00',2.12),('8998','2013-05-25','15:40:00',2.07),('8998','2013-05-25','15:45:00',2.01),('8998','2013-05-25','15:50:00',1.94),('8998','2013-05-25','15:55:00',1.89),('8998','2013-05-25','16:00:00',1.83),('8998','2013-05-25','16:05:00',1.77),('8998','2013-05-25','16:10:00',1.71),('8998','2013-05-25','16:15:00',1.65),('8998','2013-05-25','16:20:00',1.59),('8998','2013-05-25','16:25:00',1.53),('8998','2013-05-25','16:30:00',1.46),('8998','2013-05-25','16:35:00',1.39),('8998','2013-05-25','16:40:00',1.33),('8998','2013-05-25','16:45:00',1.27),('8998','2013-05-25','16:50:00',1.21),('8998','2013-05-25','16:55:00',1.14),('8998','2013-05-25','17:00:00',1.07),('8998','2013-05-25','17:05:00',1.01),('8998','2013-05-24','07:15:00',1.04),('8998','2013-05-24','07:20:00',1.07),('8998','2013-05-24','07:30:00',1.44),('8998','2013-05-24','07:35:00',1.74),('8998','2013-05-24','07:40:00',1.46),('8998','2013-05-24','07:55:00',1.87),('8998','2013-05-24','08:00:00',2.18),('8998','2013-05-24','08:05:00',2.26),('8998','2013-05-24','08:10:00',1.49),('8998','2013-05-24','08:20:00',1.36),('8998','2013-05-24','08:25:00',2.49),('8998','2013-05-24','08:30:00',2.45),('8998','2013-05-24','08:35:00',1.3),('8998','2013-05-24','08:40:00',1.45),('8998','2013-05-24','08:45:00',1.35),('8998','2013-05-24','08:50:00',1.65),('8998','2013-05-24','08:55:00',2.37),('8998','2013-05-24','09:00:00',1.74),('8998','2013-05-24','09:05:00',2.73),('8998','2013-05-24','09:10:00',2.12),('8998','2013-05-24','09:15:00',2.59),('8998','2013-05-24','09:20:00',1.49),('8998','2013-05-24','09:25:00',1.36),('8998','2013-05-24','09:35:00',2.07),('8998','2013-05-24','09:40:00',3.38),('8998','2013-05-24','09:45:00',2.31),('8998','2013-05-24','09:50:00',2.99),('8998','2013-05-24','09:55:00',1.92),('8998','2013-05-24','10:15:00',1.08),('8998','2013-05-24','10:45:00',1.07),('8998','2013-05-24','10:50:00',1.03),('8998','2013-05-24','11:05:00',1.38),('8998','2013-05-24','11:10:00',3.14),('8998','2013-05-24','11:15:00',2.77),('8998','2013-05-24','11:20:00',2.21),('8998','2013-05-24','11:40:00',1.92),('8998','2013-05-24','11:45:00',1.62),('8998','2013-05-24','11:50:00',1.3),('8998','2013-05-24','11:55:00',1.49),('8998','2013-05-24','12:00:00',1),('8998','2013-05-24','12:10:00',1.24),('8998','2013-05-24','12:25:00',1.37),('8998','2013-05-24','12:30:00',1.16),('8998','2013-05-24','12:40:00',1.2),('8998','2013-05-24','12:45:00',1.31),('8998','2013-05-24','12:55:00',1.33),('8998','2013-05-24','13:05:00',1.33),('8998','2013-05-24','13:10:00',1.01),('8998','2013-05-24','13:15:00',1.27),('8998','2013-05-24','13:20:00',1.92),('8998','2013-05-24','13:25:00',1.72),('8998','2013-05-24','13:30:00',1.57),('8998','2013-05-24','13:40:00',1.38),('8998','2013-05-24','13:45:00',1.45),('8998','2013-05-24','13:50:00',1.56),('8998','2013-05-24','13:55:00',2.22),('8998','2013-05-24','14:00:00',2.59),('8998','2013-05-24','14:05:00',3.02),('8998','2013-05-24','14:10:00',2.73),('8998','2013-05-24','14:15:00',3.02),('8998','2013-05-24','14:20:00',2.47),('8998','2013-05-24','14:25:00',1.15),('8998','2013-05-24','14:30:00',1.96),('8998','2013-05-24','14:35:00',1.22),('8998','2013-05-24','14:40:00',1.45),('8998','2013-05-24','14:45:00',1.41),('8998','2013-05-24','14:50:00',1.76),('8998','2013-05-24','14:55:00',1.26),('8998','2013-05-24','15:00:00',2.2),('8998','2013-05-24','15:05:00',2.06),('8998','2013-05-24','15:10:00',1.37),('8998','2013-05-24','15:15:00',1.73),('8998','2013-05-24','15:20:00',1.04),('8998','2013-05-24','15:25:00',1.6),('8998','2013-05-24','15:30:00',2.06),('8998','2013-05-24','15:35:00',2.43),('8998','2013-05-24','15:40:00',2.28),('8998','2013-05-24','15:45:00',2.12),('8998','2013-05-24','15:50:00',2.1),('8998','2013-05-24','15:55:00',2.17),('8998','2013-05-24','16:00:00',1.83),('8998','2013-05-24','16:10:00',1.32),('8998','2013-05-24','16:25:00',1.01),('8998','2013-05-24','16:30:00',1.56),('8998','2013-05-24','16:35:00',1.58),('8998','2013-05-24','16:40:00',1.68),('8998','2013-05-24','16:45:00',1.23),('8998','2013-05-24','17:10:00',1.17),('8998','2013-05-23','08:05:00',1.97),('8998','2013-05-23','08:10:00',1.88),('8998','2013-05-23','08:15:00',1.95),('8998','2013-05-23','08:25:00',1.16),('8998','2013-05-23','08:30:00',2.13),('8998','2013-05-23','08:35:00',1.71),('8998','2013-05-23','08:45:00',2.41),('8998','2013-05-23','08:50:00',2.5),('8998','2013-05-23','08:55:00',2.55),('8998','2013-05-23','09:00:00',2.59),('8998','2013-05-23','09:05:00',2.67),('8998','2013-05-23','09:20:00',1.59),('8998','2013-05-23','09:25:00',1.44),('8998','2013-05-23','09:30:00',2.68),('8998','2013-05-23','09:40:00',1.05),('8998','2013-05-23','09:55:00',2.02),('8998','2013-05-23','10:00:00',2.7),('8998','2013-05-23','10:25:00',1.62),('8998','2013-05-23','10:30:00',3.3),('8998','2013-05-23','10:35:00',3.4),('8998','2013-05-23','10:40:00',3.36),('8998','2013-05-23','10:45:00',3.07),('8998','2013-05-23','10:50:00',3.1),('8998','2013-05-23','10:55:00',3.53),('8998','2013-05-23','11:00:00',3.07),('8998','2013-05-23','11:05:00',3.14),('8998','2013-05-23','11:10:00',3),('8998','2013-05-23','11:15:00',2.73),('8998','2013-05-23','11:20:00',3.46),('8998','2013-05-23','11:25:00',3.58),('8998','2013-05-23','11:30:00',2.79),('8998','2013-05-23','11:35:00',1.06),('8998','2013-05-23','11:45:00',1.8),('8998','2013-05-23','11:50:00',3.71),('8998','2013-05-23','11:55:00',2.9),('8998','2013-05-23','12:00:00',1.39),('8998','2013-05-23','12:05:00',2.09),('8998','2013-05-23','12:10:00',2.93),('8998','2013-05-23','12:15:00',2.16),('8998','2013-05-23','12:20:00',1.47),('8998','2013-05-23','12:25:00',2.7),('8998','2013-05-23','12:30:00',3.27),('8998','2013-05-23','12:35:00',1.5),('8998','2013-05-23','12:40:00',1.97),('8998','2013-05-23','12:45:00',1.89),('8998','2013-05-23','12:50:00',2.24),('8998','2013-05-23','12:55:00',1.91),('8998','2013-05-23','13:00:00',1.69),('8998','2013-05-23','13:05:00',1.43),('8998','2013-05-23','13:10:00',1.77),('8998','2013-05-23','13:15:00',2.22),('8998','2013-05-23','13:20:00',2.39),('8998','2013-05-23','13:25:00',1.82),('8998','2013-05-23','13:30:00',1.29),('8998','2013-05-23','13:35:00',2.51),('8998','2013-05-23','13:40:00',1.91),('8998','2013-05-23','13:55:00',1.91),('8998','2013-05-23','14:00:00',1.64),('8998','2013-05-23','14:05:00',1.69),('8998','2013-05-23','14:15:00',2.76),('8998','2013-05-23','14:20:00',2.49),('8998','2013-05-23','14:25:00',1.85),('8998','2013-05-23','14:30:00',1.83),('8998','2013-05-23','14:35:00',1.92),('8998','2013-05-23','14:40:00',1.84),('8998','2013-05-23','14:45:00',1.7),('8998','2013-05-23','14:50:00',1.11),('8998','2013-05-23','14:55:00',1.26),('8998','2013-05-23','15:00:00',1.46),('8998','2013-05-23','15:05:00',2.39),('8998','2013-05-23','15:10:00',1.99),('8998','2013-05-23','15:15:00',1.53),('8998','2013-05-23','15:20:00',3.04),('8998','2013-05-23','15:25:00',2.23),('8998','2013-05-23','15:30:00',2.02),('8998','2013-05-23','15:35:00',1.76),('8998','2013-05-23','15:40:00',1.97),('8998','2013-05-23','15:45:00',2.48),('8998','2013-05-23','15:50:00',2.78),('8998','2013-05-23','15:55:00',2.69),('8998','2013-05-23','16:00:00',1.53),('8998','2013-05-23','16:05:00',1.33),('8998','2013-05-23','16:10:00',1.4),('8998','2013-05-23','16:15:00',1.58),('8998','2013-05-23','16:20:00',1.3),('8998','2013-05-23','16:25:00',1.53),('8998','2013-05-23','16:30:00',1.81),('8998','2013-05-23','16:35:00',1.1),('8998','2013-05-23','16:55:00',1.12),('8998','2013-05-22','08:05:00',1.36),('8998','2013-05-22','08:10:00',1.9),('8998','2013-05-22','08:30:00',1.25),('8998','2013-05-22','08:35:00',1.81),('8998','2013-05-22','08:40:00',2.13),('8998','2013-05-22','08:45:00',1.99),('8998','2013-05-22','08:50:00',1.77),('8998','2013-05-22','09:00:00',2.43),('8998','2013-05-22','09:05:00',1.52),('8998','2013-05-22','09:20:00',2.28),('8998','2013-05-22','09:25:00',2.88),('8998','2013-05-22','09:30:00',3.31),('8998','2013-05-22','09:35:00',1.84),('8998','2013-05-22','09:40:00',2.08),('8998','2013-05-22','09:45:00',1.36),('8998','2013-05-22','09:50:00',3.14),('8998','2013-05-22','09:55:00',1.55),('8998','2013-05-22','10:05:00',3.07),('8998','2013-05-22','10:10:00',2.53),('8998','2013-05-22','10:15:00',3.08),('8998','2013-05-22','10:20:00',2.42),('8998','2013-05-22','10:25:00',3.11),('8998','2013-05-22','10:30:00',2.79),('8998','2013-05-22','10:35:00',3.06),('8998','2013-05-22','10:40:00',2.93),('8998','2013-05-22','10:45:00',3.52),('8998','2013-05-22','10:50:00',3.24),('8998','2013-05-22','10:55:00',2.34),('8998','2013-05-22','11:00:00',2.31),('8998','2013-05-22','11:05:00',2.24),('8998','2013-05-22','11:10:00',2.26),('8998','2013-05-22','11:15:00',1.75),('8998','2013-05-22','11:20:00',1.5),('8998','2013-05-22','11:25:00',2.04),('8998','2013-05-22','11:30:00',2.17),('8998','2013-05-22','11:35:00',2.59),('8998','2013-05-22','11:40:00',3.45),('8998','2013-05-22','11:45:00',2.48),('8998','2013-05-22','11:50:00',2.15),('8998','2013-05-22','11:55:00',2.65),('8998','2013-05-22','12:00:00',3.39),('8998','2013-05-22','12:05:00',3.45),('8998','2013-05-22','12:10:00',3.45),('8998','2013-05-22','12:15:00',3.11),('8998','2013-05-22','12:20:00',2.37),('8998','2013-05-22','12:25:00',2.86),('8998','2013-05-22','12:30:00',2.81),('8998','2013-05-22','12:35:00',1.83),('8998','2013-05-22','12:40:00',3.07),('8998','2013-05-22','12:45:00',2.36),('8998','2013-05-22','12:50:00',2.35),('8998','2013-05-22','12:55:00',2.95),('8998','2013-05-22','13:00:00',3.45),('8998','2013-05-22','13:05:00',2.06),('8998','2013-05-22','13:10:00',3.25),('8998','2013-05-22','13:15:00',2.77),('8998','2013-05-22','13:20:00',2.32),('8998','2013-05-22','13:25:00',2.86),('8998','2013-05-22','13:30:00',2.74),('8998','2013-05-22','13:35:00',1.54),('8998','2013-05-22','13:40:00',1.28),('8998','2013-05-22','13:45:00',2.5),('8998','2013-05-22','13:50:00',2.14),('8998','2013-05-22','13:55:00',2.7),('8998','2013-05-22','14:00:00',2.98),('8998','2013-05-22','14:05:00',3),('8998','2013-05-22','14:10:00',2.22),('8998','2013-05-22','14:15:00',2.82),('8998','2013-05-22','14:20:00',2.76),('8998','2013-05-22','14:25:00',1.91),('8998','2013-05-22','14:35:00',3.06),('8998','2013-05-22','14:40:00',2.03),('8998','2013-05-22','14:45:00',1.48),('8998','2013-05-22','14:50:00',1.36),('8998','2013-05-22','14:55:00',2.14),('8998','2013-05-22','15:00:00',2.44),('8998','2013-05-22','15:05:00',2.4),('8998','2013-05-22','15:15:00',1),('8998','2013-05-22','15:20:00',2.47),('8998','2013-05-22','15:25:00',1.05),('8998','2013-05-22','15:30:00',1.59),('8998','2013-05-22','15:35:00',1.94),('8998','2013-05-22','15:40:00',1.32),('8998','2013-05-22','15:45:00',1.71),('8998','2013-05-22','16:00:00',1.9),('8998','2013-05-22','16:05:00',2.13),('8998','2013-05-22','16:10:00',1.45),('8998','2013-05-22','16:15:00',1.24),('8998','2013-05-22','16:20:00',1.7),('8998','2013-05-22','16:25:00',1.09),('8998','2013-05-22','16:30:00',1.47),('8998','2013-05-22','16:45:00',1.09),('8998','2013-05-22','17:10:00',1.36),('8998','2013-05-22','17:15:00',1.15),('8998','2013-05-21','08:00:00',1.06),('8998','2013-05-21','08:05:00',1.57),('8998','2013-05-21','08:10:00',1.07),('8998','2013-05-21','08:15:00',1.95),('8998','2013-05-21','08:20:00',1.88),('8998','2013-05-21','08:25:00',1.67),('8998','2013-05-21','08:30:00',1.87),('8998','2013-05-21','08:35:00',2.25),('8998','2013-05-21','08:40:00',1.29),('8998','2013-05-21','08:45:00',1.35),('8998','2013-05-21','09:30:00',2.56),('8998','2013-05-21','09:35:00',2.79),('8998','2013-05-21','09:40:00',2.73),('8998','2013-05-21','09:45:00',2.71),('8998','2013-05-21','09:50:00',2.73),('8998','2013-05-21','09:55:00',2.76),('8998','2013-05-21','10:00:00',2.79),('8998','2013-05-21','10:05:00',2.82),('8998','2013-05-21','10:10:00',2.87),('8998','2013-05-21','10:15:00',2.89),('8998','2013-05-21','10:20:00',2.83),('8998','2013-05-21','10:25:00',2.96),('8998','2013-05-21','10:30:00',2.95),('8998','2013-05-21','10:35:00',2.9),('8998','2013-05-21','10:40:00',3.06),('8998','2013-05-21','10:45:00',3.05),('8998','2013-05-21','10:50:00',3),('8998','2013-05-21','10:55:00',3.01),('8998','2013-05-21','11:00:00',3.06),('8998','2013-05-21','11:05:00',3.12),('8998','2013-05-21','11:10:00',2.89),('8998','2013-05-21','11:15:00',2.75),('8998','2013-05-21','11:20:00',3.18),('8998','2013-05-21','11:25:00',3.3),('8998','2013-05-21','11:30:00',2.68),('8998','2013-05-21','11:35:00',2.72),('8998','2013-05-21','11:40:00',2.52),('8998','2013-05-21','11:45:00',3.29),('8998','2013-05-21','11:50:00',1.93),('8998','2013-05-21','11:55:00',1.44),('8998','2013-05-21','12:00:00',2.23),('8998','2013-05-21','12:05:00',1.73),('8998','2013-05-21','12:10:00',1.64),('8998','2013-05-21','12:15:00',2.13),('8998','2013-05-21','12:20:00',2.99),('8998','2013-05-21','12:25:00',2.31),('8998','2013-05-21','12:30:00',1.69),('8998','2013-05-21','12:35:00',1.66),('8998','2013-05-21','12:40:00',1.26),('8998','2013-05-21','13:05:00',2.97),('8998','2013-05-21','13:10:00',1.66),('8998','2013-05-21','13:15:00',1.59),('8998','2013-05-21','13:20:00',1.75),('8998','2013-05-21','13:30:00',1.21),('8998','2013-05-21','13:35:00',2.25),('8998','2013-05-21','13:40:00',2.38),('8998','2013-05-21','13:45:00',1.57),('8998','2013-05-21','13:50:00',1.58),('8998','2013-05-21','13:55:00',1.69),('8998','2013-05-21','14:00:00',1.74),('8998','2013-05-21','14:05:00',2.4),('8998','2013-05-21','14:10:00',2.52),('8998','2013-05-21','14:15:00',2.77),('8998','2013-05-21','14:20:00',2.65),('8998','2013-05-21','14:25:00',2.59),('8998','2013-05-21','14:30:00',2.51),('8998','2013-05-21','14:35:00',2.46),('8998','2013-05-21','14:40:00',2.45),('8998','2013-05-21','14:45:00',2.4),('8998','2013-05-21','14:50:00',2.35),('8998','2013-05-21','14:55:00',2.3),('8998','2013-05-21','15:00:00',2.26),('8998','2013-05-21','15:05:00',2.2),('8998','2013-05-21','15:10:00',2.16),('8998','2013-05-21','15:15:00',2.13),('8998','2013-05-21','15:20:00',1.96),('8998','2013-05-21','15:25:00',1.19),('8998','2013-05-21','15:30:00',1.01),('8998','2013-05-21','15:35:00',1.2),('8998','2013-05-21','15:45:00',1.31),('8998','2013-05-21','15:50:00',1.82),('8998','2013-05-21','15:55:00',1.7),('8998','2013-05-21','16:00:00',1.67),('8998','2013-05-21','16:05:00',1.6),('8998','2013-05-21','16:10:00',1.55),('8998','2013-05-21','16:15:00',1.48),('8998','2013-05-21','16:20:00',1.44),('8998','2013-05-21','16:25:00',1.39),('8998','2013-05-21','16:30:00',1.34),('8998','2013-05-21','16:35:00',1.28),('8998','2013-05-21','16:40:00',1.23),('8998','2014-03-31','08:20:00',1.03),('8998','2014-03-31','08:25:00',1.07),('8998','2014-03-31','08:30:00',1.46),('8998','2014-03-31','08:35:00',1.56),('8998','2014-03-31','08:40:00',1.6),('8998','2014-03-31','08:45:00',1.59),('8998','2014-03-31','08:50:00',1.59),('8998','2014-03-31','08:55:00',1.84),('8998','2014-03-31','09:00:00',1.93),('8998','2014-03-31','09:05:00',1.98),('8998','2014-03-31','09:10:00',2.06),('8998','2014-03-31','09:15:00',2.14),('8998','2014-03-31','09:20:00',2.17),('8998','2014-03-31','09:25:00',2.21),('8998','2014-03-31','09:30:00',2.23),('8998','2014-03-31','09:35:00',2.28),('8998','2014-03-31','09:40:00',2.31),('8998','2014-03-31','09:45:00',2.39),('8998','2014-03-31','09:50:00',2.44),('8998','2014-03-31','09:55:00',2.44),('8998','2014-03-31','10:00:00',2.5),('8998','2014-03-31','10:05:00',2.56),('8998','2014-03-31','10:10:00',2.47),('8998','2014-03-31','10:15:00',2.53),('8998','2014-03-31','10:20:00',2.61),('8998','2014-03-31','10:25:00',2.69),('8998','2014-03-31','10:30:00',2.67),('8998','2014-03-31','10:35:00',2.39),('8998','2014-03-31','10:40:00',2.18),('8998','2014-03-31','10:45:00',2.2),('8998','2014-03-31','10:50:00',2.17),('8998','2014-03-31','10:55:00',2.93),('8998','2014-03-31','11:00:00',2.84),('8998','2014-03-31','11:05:00',2.85),('8998','2014-03-31','11:10:00',2.83),('8998','2014-03-31','11:15:00',2.83),('8998','2014-03-31','11:20:00',2.85),('8998','2014-03-31','11:25:00',2.79),('8998','2014-03-31','11:30:00',2.89),('8998','2014-03-31','11:35:00',2.89),('8998','2014-03-31','11:40:00',2.88),('8998','2014-03-31','11:45:00',2.85),('8998','2014-03-31','11:50:00',2.91),('8998','2014-03-31','11:55:00',2.87),('8998','2014-03-31','12:00:00',2.9),('8998','2014-03-31','12:05:00',2.87),('8998','2014-03-31','12:10:00',2.88),('8998','2014-03-31','12:15:00',2.86),('8998','2014-03-31','12:20:00',2.88),('8998','2014-03-31','12:25:00',2.88),('8998','2014-03-31','12:30:00',2.88),('8998','2014-03-31','12:35:00',2.87),('8998','2014-03-31','12:40:00',2.85),('8998','2014-03-31','12:45:00',2.84),('8998','2014-03-31','12:50:00',2.83),('8998','2014-03-31','12:55:00',2.78),('8998','2014-03-31','13:00:00',2.82),('8998','2014-03-31','13:05:00',2.86),('8998','2014-03-31','13:10:00',2.83),('8998','2014-03-31','13:15:00',2.37),('8998','2014-03-31','13:20:00',2.65),('8998','2014-03-31','13:25:00',2.7),('8998','2014-03-31','13:30:00',2.67),('8998','2014-03-31','13:35:00',2.65),('8998','2014-03-31','13:40:00',2.62),('8998','2014-03-31','13:45:00',2.49),('8998','2014-03-31','13:50:00',2.51),('8998','2014-03-31','13:55:00',2.43),('8998','2014-03-31','14:00:00',2.5),('8998','2014-03-31','14:05:00',2.47),('8998','2014-03-31','14:10:00',2.42),('8998','2014-03-31','14:15:00',2.42),('8998','2014-03-31','14:20:00',2.35),('8998','2014-03-31','14:25:00',2.27),('8998','2014-03-31','14:30:00',1.74),('8998','2014-03-31','14:35:00',1.91),('8998','2014-03-31','14:40:00',2.28),('8998','2014-03-31','14:45:00',2.33),('8998','2014-03-31','14:50:00',1.82),('8998','2014-03-31','14:55:00',2.12),('8998','2014-03-31','15:00:00',1.8),('8998','2014-03-31','15:05:00',1.82),('8998','2014-03-31','15:10:00',2.06),('8998','2014-03-31','15:15:00',1.53),('8998','2014-03-31','15:20:00',1.69),('8998','2014-03-31','15:25:00',1.78),('8998','2014-03-31','15:30:00',1.85),('8998','2014-03-31','15:35:00',1.58),('8998','2014-03-31','15:40:00',1.34),('8998','2014-03-31','15:45:00',1.6),('8998','2014-03-31','15:50:00',1.64),('8998','2014-03-31','15:55:00',1.01),('8998','2014-03-31','16:00:00',1.28),('8998','2014-03-31','16:05:00',1.01),('8998','2014-03-31','16:10:00',1.02),('8998','2014-03-31','16:15:00',1.12),('8998','2014-03-31','16:20:00',1.07),('8998','2013-05-20','07:30:00',1.01),('8998','2013-05-20','07:35:00',1.19),('8998','2013-05-20','07:40:00',1.32),('8998','2013-05-20','07:45:00',1.34),('8998','2013-05-20','07:50:00',1.14),('8998','2013-05-20','08:00:00',1.3),('8998','2013-05-20','08:10:00',1.35),('8998','2013-05-20','08:15:00',1.82),('8998','2013-05-20','08:20:00',1.27),('8998','2013-05-20','08:25:00',1.72),('8998','2013-05-20','08:30:00',1.21),('8998','2013-05-20','08:35:00',1.04),('8998','2013-05-20','08:40:00',1.2),('8998','2013-05-20','08:50:00',1.03),('8998','2013-05-20','08:55:00',1.45),('8998','2013-05-20','09:00:00',1.29),('8998','2013-05-20','09:05:00',1.09),('8998','2013-05-20','09:10:00',1.22),('8998','2013-05-20','09:15:00',1.39),('8998','2013-05-20','09:20:00',1.89),('8998','2013-05-20','09:25:00',2.17),('8998','2013-05-20','09:30:00',1.62),('8998','2013-05-20','09:35:00',1.57),('8998','2013-05-20','09:40:00',1.59),('8998','2013-05-20','09:45:00',1.34),('8998','2013-05-20','09:50:00',1.25),('8998','2013-05-20','09:55:00',1.47),('8998','2013-05-20','10:00:00',1.56),('8998','2013-05-20','10:05:00',1.74),('8998','2013-05-20','10:10:00',1.79),('8998','2013-05-20','10:15:00',1.78),('8998','2013-05-20','10:20:00',1.72),('8998','2013-05-20','10:25:00',1.52),('8998','2013-05-20','10:30:00',1.36),('8998','2013-05-20','10:35:00',1.36),('8998','2013-05-20','10:40:00',1.55),('8998','2013-05-20','10:45:00',2.38),('8998','2013-05-20','10:50:00',1.69),('8998','2013-05-20','10:55:00',1.23),('8998','2013-05-20','11:00:00',1.37),('8998','2013-05-20','11:05:00',1.24),('8998','2013-05-20','11:10:00',2.13),('8998','2013-05-20','11:15:00',3.27),('8998','2013-05-20','11:20:00',2.5),('8998','2013-05-20','11:25:00',3.16),('8998','2013-05-20','11:30:00',2.08),('8998','2013-05-20','11:35:00',1.84),('8998','2013-05-20','11:40:00',1.91),('8998','2013-05-20','11:45:00',2.68),('8998','2013-05-20','11:50:00',1.93),('8998','2013-05-20','11:55:00',2.78),('8998','2013-05-20','12:00:00',2.28),('8998','2013-05-20','12:05:00',2.71),('8998','2013-05-20','12:10:00',2.05),('8998','2013-05-20','12:15:00',2.27),('8998','2013-05-20','12:20:00',1.7),('8998','2013-05-20','12:25:00',2.32),('8998','2013-05-20','12:30:00',2.96),('8998','2013-05-20','12:35:00',1.73),('8998','2013-05-20','12:40:00',2.96),('8998','2013-05-20','12:45:00',2.92),('8998','2013-05-20','12:50:00',1.82),('8998','2013-05-20','12:55:00',3.17),('8998','2013-05-20','13:00:00',2.82),('8998','2013-05-20','13:05:00',3.01),('8998','2013-05-20','13:10:00',1.75),('8998','2013-05-20','13:15:00',2.51),('8998','2013-05-20','13:20:00',1.85),('8998','2013-05-20','13:25:00',2.16),('8998','2013-05-20','13:30:00',2.08),('8998','2013-05-20','13:35:00',1.15),('8998','2013-05-20','14:10:00',1.12),('8998','2013-05-20','14:15:00',1.4),('8998','2013-05-20','14:20:00',1.27),('8998','2013-05-20','14:25:00',1.58),('8998','2013-05-20','14:30:00',1.66),('8998','2013-05-20','14:35:00',1.31),('8998','2013-05-20','14:40:00',1.29),('8998','2013-05-20','14:45:00',1.2),('8998','2013-05-20','15:20:00',1.03),('8998','2013-05-20','15:25:00',1.08),('8998','2013-05-20','15:30:00',1.47),('8998','2013-05-20','15:35:00',1.1),('8998','2013-05-20','16:30:00',1.08),('8998','2013-05-20','16:35:00',1.18),('8998','2013-05-20','16:40:00',1.25),('8998','2013-05-20','16:45:00',1.18),('8998','2013-05-19','07:30:00',1.09),('8998','2013-05-19','07:35:00',1.22),('8998','2013-05-19','07:40:00',1.44),('8998','2013-05-19','07:45:00',1.51),('8998','2013-05-19','07:50:00',1.55),('8998','2013-05-19','07:55:00',1.56),('8998','2013-05-19','08:00:00',1.78),('8998','2013-05-19','08:05:00',1.57),('8998','2013-05-19','08:10:00',1.9),('8998','2013-05-19','08:15:00',1.55),('8998','2013-05-19','08:20:00',1.24),('8998','2013-05-19','08:50:00',2.57),('8998','2013-05-19','08:55:00',2.62),('8998','2013-05-19','09:00:00',2.74),('8998','2013-05-19','09:05:00',2.27),('8998','2013-05-19','09:10:00',2.87),('8998','2013-05-19','09:15:00',2.03),('8998','2013-05-19','09:20:00',1.76),('8998','2013-05-19','09:25:00',1.55),('8998','2013-05-19','09:35:00',1.54),('8998','2013-05-19','09:50:00',3.02),('8998','2013-05-19','09:55:00',1.34),('8998','2013-05-19','10:15:00',1.13),('8998','2013-05-19','10:30:00',2.17),('8998','2013-05-19','10:35:00',2.05),('8998','2013-05-19','10:45:00',1.07),('8998','2013-05-19','10:50:00',1.02),('8998','2013-05-19','10:55:00',1.4),('8998','2013-05-19','11:00:00',2.7),('8998','2013-05-19','11:05:00',3.52),('8998','2013-05-19','11:10:00',3.26),('8998','2013-05-19','11:15:00',3.46),('8998','2013-05-19','11:20:00',2.47),('8998','2013-05-19','11:25:00',2.62),('8998','2013-05-19','11:30:00',2.81),('8998','2013-05-19','11:35:00',2.79),('8998','2013-05-19','11:40:00',1.3),('8998','2013-05-19','11:45:00',1.17),('8998','2013-05-19','11:50:00',1.29),('8998','2013-05-19','11:55:00',2.67),('8998','2013-05-19','12:00:00',1.91),('8998','2013-05-19','12:05:00',3.67),('8998','2013-05-19','12:10:00',2.46),('8998','2013-05-19','12:15:00',1.43),('8998','2013-05-19','12:20:00',1.96),('8998','2013-05-19','12:25:00',1.31),('8998','2013-05-19','12:30:00',1.51),('8998','2013-05-19','12:35:00',2.42),('8998','2013-05-19','12:40:00',2.19),('8998','2013-05-19','12:45:00',3.39),('8998','2013-05-19','12:50:00',1.69),('8998','2013-05-19','12:55:00',1.36),('8998','2013-05-19','13:00:00',1.41),('8998','2013-05-19','13:05:00',2.37),('8998','2013-05-19','13:10:00',1.52),('8998','2013-05-19','13:15:00',1.6),('8998','2013-05-19','13:20:00',3.24),('8998','2013-05-19','13:25:00',2.67),('8998','2013-05-19','13:30:00',2.34),('8998','2013-05-19','13:35:00',1.73),('8998','2013-05-19','13:40:00',2),('8998','2013-05-19','13:45:00',1.8),('8998','2013-05-19','13:50:00',3.28),('8998','2013-05-19','13:55:00',2.26),('8998','2013-05-19','14:00:00',3.17),('8998','2013-05-19','14:05:00',1.9),('8998','2013-05-19','14:15:00',2.88),('8998','2013-05-19','14:20:00',2.2),('8998','2013-05-19','14:25:00',1.47),('8998','2013-05-19','14:30:00',2.91),('8998','2013-05-19','14:35:00',2.06),('8998','2013-05-19','14:45:00',1.74),('8998','2013-05-19','14:50:00',2.91),('8998','2013-05-19','14:55:00',2.54),('8998','2013-05-19','15:00:00',2.17),('8998','2013-05-19','15:10:00',2.27),('8998','2013-05-19','15:15:00',2.27),('8998','2013-05-19','15:20:00',1.5),('8998','2013-05-19','15:25:00',2.48),('8998','2013-05-19','15:30:00',1.68),('8998','2013-05-19','15:35:00',2.35),('8998','2013-05-19','15:40:00',1.63),('8998','2013-05-19','15:45:00',1.3),('8998','2013-05-19','15:50:00',1.64),('8998','2013-05-19','16:00:00',1.2),('8998','2013-05-19','16:05:00',1.75),('8998','2013-05-19','16:10:00',1.78),('8998','2013-05-19','16:15:00',1.85),('8998','2013-05-19','16:20:00',1.69),('8998','2013-05-19','16:25:00',1.59),('8998','2013-05-19','16:30:00',1.52),('8998','2013-05-19','16:35:00',1.4),('8998','2013-05-19','16:40:00',1.36),('8998','2013-05-19','16:45:00',1.19),('8998','2013-05-19','16:50:00',1.14),('8998','2013-05-19','16:55:00',1.08),('8998','2013-05-19','17:05:00',1.03),('8998','2013-05-18','08:55:00',1.34),('8998','2013-05-18','09:00:00',1.4),('8998','2013-05-18','09:15:00',1.01),('8998','2013-05-18','10:00:00',1.04),('8998','2013-05-18','10:05:00',1.18),('8998','2013-05-18','10:10:00',1.44),('8998','2013-05-18','10:15:00',2.34),('8998','2013-05-18','10:20:00',2.4),('8998','2013-05-18','10:25:00',1.71),('8998','2013-05-18','10:30:00',2.16),('8998','2013-05-18','10:35:00',1.91),('8998','2013-05-18','10:40:00',1.53),('8998','2013-05-18','10:45:00',2.28),('8998','2013-05-18','10:50:00',1.4),('8998','2013-05-18','10:55:00',1.61),('8998','2013-05-18','11:00:00',1.53),('8998','2013-05-18','11:05:00',2.5),('8998','2013-05-18','11:10:00',2.07),('8998','2013-05-18','11:15:00',2.95),('8998','2013-05-18','11:20:00',3.54),('8998','2013-05-18','11:25:00',3.42),('8998','2013-05-18','11:30:00',3.45),('8998','2013-05-18','11:35:00',3.38),('8998','2013-05-18','11:40:00',3.46),('8998','2013-05-18','11:45:00',3.46),('8998','2013-05-18','11:50:00',3.41),('8998','2013-05-18','11:55:00',3.41),('8998','2013-05-18','12:00:00',3.42),('8998','2013-05-18','12:05:00',3.36),('8998','2013-05-18','12:10:00',3.35),('8998','2013-05-18','12:15:00',3.34),('8998','2013-05-18','12:20:00',3.43),('8998','2013-05-18','12:25:00',3.7),('8998','2013-05-18','12:30:00',2.9),('8998','2013-05-18','12:35:00',3.6),('8998','2013-05-18','12:40:00',3.42),('8998','2013-05-18','12:45:00',3.36),('8998','2013-05-18','12:50:00',2.46),('8998','2013-05-18','12:55:00',1.94),('8998','2013-05-18','13:00:00',3.03),('8998','2013-05-18','13:05:00',3.21),('8998','2013-05-18','13:10:00',2.85),('8998','2013-05-18','13:15:00',2.66),('8998','2013-05-18','13:20:00',3.04),('8998','2013-05-18','13:25:00',2.73),('8998','2013-05-18','13:30:00',2.99),('8998','2013-05-18','13:35:00',2.97),('8998','2013-05-18','13:40:00',2.92),('8998','2013-05-18','13:45:00',2.88),('8998','2013-05-18','13:50:00',2.86),('8998','2013-05-18','13:55:00',2.84),('8998','2013-05-18','14:00:00',2.81),('8998','2013-05-18','14:05:00',2.8),('8998','2013-05-18','14:10:00',2.77),('8998','2013-05-18','14:15:00',2.72),('8998','2013-05-18','14:20:00',2.69),('8998','2013-05-18','14:25:00',2.65),('8998','2013-05-18','14:30:00',2.62),('8998','2013-05-18','14:35:00',2.56),('8998','2013-05-18','14:40:00',2.54),('8998','2013-05-18','14:45:00',2.49),('8998','2013-05-18','14:50:00',2.44),('8998','2013-05-18','14:55:00',2.39),('8998','2013-05-18','15:00:00',2.37),('8998','2013-05-18','15:05:00',2.32),('8998','2013-05-18','15:10:00',2.27),('8998','2013-05-18','15:15:00',2.24),('8998','2013-05-18','15:20:00',2.17),('8998','2013-05-18','15:25:00',2.12),('8998','2013-05-18','15:30:00',2.06),('8998','2013-05-18','15:35:00',2.01),('8998','2013-05-18','15:40:00',1.95),('8998','2013-05-18','15:45:00',1.9),('8998','2013-05-18','15:50:00',1.84),('8998','2013-05-18','15:55:00',1.8),('8998','2013-05-18','16:00:00',1.73),('8998','2013-05-18','16:05:00',1.67),('8998','2013-05-18','16:10:00',1.61),('8998','2013-05-18','16:15:00',1.55),('8998','2013-05-18','16:20:00',1.49),('8998','2013-05-18','16:25:00',1.44),('8998','2013-05-18','16:30:00',1.38),('8998','2013-05-18','16:35:00',1.32),('8998','2013-05-18','16:40:00',1.26),('8998','2013-05-18','16:45:00',1.2),('8998','2013-05-18','16:50:00',1.13),('8998','2013-05-18','16:55:00',1.07),('8998','2013-05-18','17:00:00',1.01),('8998','2013-05-17','07:30:00',1.08),('8998','2013-05-17','07:35:00',1.29),('8998','2013-05-17','07:40:00',1.38),('8998','2013-05-17','07:45:00',1.39),('8998','2013-05-17','07:50:00',1.05),('8998','2013-05-17','07:55:00',1.81),('8998','2013-05-17','08:00:00',1.9),('8998','2013-05-17','08:05:00',1.82),('8998','2013-05-17','08:20:00',1.06),('8998','2013-05-17','08:25:00',2.48),('8998','2013-05-17','08:30:00',2.29),('8998','2013-05-17','08:35:00',2.02),('8998','2013-05-17','08:40:00',2.32),('8998','2013-05-17','08:45:00',2.22),('8998','2013-05-17','08:50:00',2.21),('8998','2013-05-17','08:55:00',2.22),('8998','2013-05-17','09:00:00',2.07),('8998','2013-05-17','09:05:00',1.98),('8998','2013-05-17','09:10:00',2.19),('8998','2013-05-17','09:15:00',2.42),('8998','2013-05-17','09:20:00',2.6),('8998','2013-05-17','09:25:00',2.71),('8998','2013-05-17','09:30:00',2.74),('8998','2013-05-17','09:35:00',2.77),('8998','2013-05-17','09:40:00',2.78),('8998','2013-05-17','09:45:00',2.82),('8998','2013-05-17','09:50:00',2.85),('8998','2013-05-17','09:55:00',2.89),('8998','2013-05-17','10:00:00',2.91),('8998','2013-05-17','10:05:00',2.9),('8998','2013-05-17','10:10:00',2.94),('8998','2013-05-17','10:15:00',2.94),('8998','2013-05-17','10:20:00',2.98),('8998','2013-05-17','10:25:00',2.98),('8998','2013-05-17','10:30:00',2.98),('8998','2013-05-17','10:35:00',2.96),('8998','2013-05-17','10:40:00',3.01),('8998','2013-05-17','10:45:00',3.01),('8998','2013-05-17','10:50:00',3.02),('8998','2013-05-17','10:55:00',2.92),('8998','2013-05-17','11:00:00',3.15),('8998','2013-05-17','11:05:00',2.99),('8998','2013-05-17','11:10:00',2.5),('8998','2013-05-17','11:15:00',3.32),('8998','2013-05-17','11:20:00',3.19),('8998','2013-05-17','11:25:00',3.24),('8998','2013-05-17','11:30:00',3.2),('8998','2013-05-17','11:35:00',3),('8998','2013-05-17','11:40:00',3.14),('8998','2013-05-17','11:45:00',2.93),('8998','2013-05-17','11:50:00',2.93),('8998','2013-05-17','11:55:00',3.03),('8998','2013-05-17','12:00:00',3.07),('8998','2013-05-17','12:05:00',2.99),('8998','2013-05-17','12:10:00',3.02),('8998','2013-05-17','12:15:00',2.99),('8998','2013-05-17','12:20:00',2.99),('8998','2013-05-17','12:25:00',3),('8998','2013-05-17','12:30:00',2.43),('8998','2013-05-17','12:35:00',3.06),('8998','2013-05-17','12:40:00',2.99),('8998','2013-05-17','12:45:00',2.88),('8998','2013-05-17','12:50:00',2.94),('8998','2013-05-17','12:55:00',2.91),('8998','2013-05-17','13:00:00',2.89),('8998','2013-05-17','13:05:00',2.87),('8998','2013-05-17','13:10:00',2.85),('8998','2013-05-17','13:15:00',2.85),('8998','2013-05-17','13:20:00',2.82),('8998','2013-05-17','13:25:00',2.8),('8998','2013-05-17','13:30:00',2.81),('8998','2013-05-17','13:35:00',2.41),('8998','2013-05-17','13:40:00',2.71),('8998','2013-05-17','13:45:00',2.85),('8998','2013-05-17','13:50:00',2.51),('8998','2013-05-17','13:55:00',2.31),('8998','2013-05-17','14:00:00',1.93),('8998','2013-05-17','14:05:00',2.04),('8998','2013-05-17','14:10:00',2.91),('8998','2013-05-17','14:15:00',2.72),('8998','2013-05-17','14:20:00',2.68),('8998','2013-05-17','14:25:00',2.59),('8998','2013-05-17','14:30:00',2.58),('8998','2013-05-17','14:35:00',2.43),('8998','2013-05-17','14:40:00',2.65),('8998','2013-05-17','14:45:00',2.49),('8998','2013-05-17','14:50:00',2.28),('8998','2013-05-17','14:55:00',1.99),('8998','2013-05-17','15:00:00',2.18),('8998','2013-05-17','15:05:00',2.11),('8998','2013-05-17','15:10:00',2.05),('8998','2013-05-17','15:15:00',1.99),('8998','2013-05-17','15:20:00',1.93),('8998','2013-05-17','15:25:00',1.88),('8998','2013-05-17','15:30:00',1.83),('8998','2013-05-17','15:35:00',1.79),('8998','2013-05-17','15:40:00',1.74),('8998','2013-05-17','15:45:00',1.68),('8998','2013-05-17','15:50:00',1.64),('8998','2013-05-17','15:55:00',1.59),('8998','2013-05-17','16:00:00',1.54),('8998','2013-05-17','16:05:00',1.49),('8998','2013-05-17','16:10:00',1.44),('8998','2013-05-17','16:15:00',1.38),('8998','2013-05-17','16:20:00',1.34),('8998','2013-05-17','16:25:00',1.28),('8998','2013-05-17','16:30:00',1.23),('8998','2013-05-17','16:35:00',1.18),('8998','2013-05-17','16:40:00',1.13),('8998','2013-05-17','16:45:00',1.08),('8998','2013-05-17','16:50:00',1.02),('8998','2013-05-16','07:45:00',1.27),('8998','2013-05-16','07:50:00',1.02),('8998','2013-05-16','08:00:00',1.37),('8998','2013-05-16','08:15:00',1.36),('8998','2013-05-16','08:20:00',2.03),('8998','2013-05-16','08:25:00',1.19),('8998','2013-05-16','10:30:00',1.15),('8998','2013-05-16','10:40:00',1.07),('8998','2013-05-16','10:45:00',1.17),('8998','2013-05-16','10:50:00',2.16),('8998','2013-05-16','10:55:00',2.79),('8998','2013-05-16','11:00:00',1.69),('8998','2013-05-16','11:05:00',1.67),('8998','2013-05-16','11:10:00',1.11),('8998','2013-05-16','11:15:00',1.88),('8998','2013-05-16','11:20:00',1.55),('8998','2013-05-16','11:25:00',1.3),('8998','2013-05-16','11:30:00',1.42),('8998','2013-05-16','11:35:00',1.96),('8998','2013-05-16','11:40:00',1.21),('8998','2013-05-16','11:45:00',1.15),('8998','2013-05-16','11:50:00',2.01),('8998','2013-05-16','11:55:00',1.9),('8998','2013-05-16','12:00:00',1.79),('8998','2013-05-16','12:05:00',1.88),('8998','2013-05-16','12:10:00',2.35),('8998','2013-05-16','12:15:00',1.78),('8998','2013-05-16','12:20:00',1.86),('8998','2013-05-16','12:25:00',1.99),('8998','2013-05-16','12:30:00',1.77),('8998','2013-05-16','12:35:00',2.23),('8998','2013-05-16','12:40:00',2.84),('8998','2013-05-16','12:45:00',3.12),('8998','2013-05-16','12:50:00',3.28),('8998','2013-05-16','12:55:00',3.15),('8998','2013-05-16','13:00:00',2.54),('8998','2013-05-16','13:05:00',3.21),('8998','2013-05-16','13:10:00',2.24),('8998','2013-05-16','13:15:00',2.65),('8998','2013-05-16','13:20:00',3.32),('8998','2013-05-16','13:25:00',3.12),('8998','2013-05-16','13:30:00',2.22),('8998','2013-05-16','13:35:00',3.17),('8998','2013-05-16','13:40:00',2.49),('8998','2013-05-16','13:45:00',2.84),('8998','2013-05-16','13:50:00',2.77),('8998','2013-05-16','13:55:00',3.06),('8998','2013-05-16','14:00:00',2.22),('8998','2013-05-16','14:05:00',1.53),('8998','2013-05-16','14:10:00',2.82),('8998','2013-05-16','14:15:00',2.75),('8998','2013-05-16','14:20:00',2.82),('8998','2013-05-16','14:25:00',2.37),('8998','2013-05-16','14:30:00',2.61),('8998','2013-05-16','14:35:00',2.42),('8998','2013-05-16','14:40:00',1.79),('8998','2013-05-16','14:45:00',1.87),('8998','2013-05-16','14:50:00',1.96),('8998','2013-05-16','14:55:00',1.39),('8998','2013-05-16','15:00:00',2.38),('8998','2013-05-16','15:05:00',1.73),('8998','2013-05-16','15:10:00',1.13),('8998','2013-05-16','15:15:00',1.5),('8998','2013-05-16','15:20:00',1.79),('8998','2013-05-16','15:25:00',1.94),('8998','2013-05-16','15:30:00',1.1),('8998','2013-05-16','15:35:00',1.65),('8998','2013-05-16','15:40:00',2.34),('8998','2013-05-16','15:45:00',1.02),('8998','2013-05-16','15:50:00',1.71),('8998','2013-05-16','15:55:00',1.79),('8998','2013-05-16','16:00:00',1.99),('8998','2013-05-16','16:05:00',1.21),('8998','2013-05-16','16:15:00',1.45),('8998','2013-05-16','16:20:00',1.56),('8998','2013-05-16','16:25:00',1.45),('8998','2013-05-16','16:30:00',1.57),('8998','2013-05-16','16:35:00',1.66),('8998','2013-05-16','16:40:00',1.66),('8998','2013-05-16','16:45:00',1.45),('8998','2013-05-16','16:50:00',1.2),('8998','2013-05-16','16:55:00',1.06),('8998','2013-05-15','09:25:00',1.3),('8998','2013-05-15','09:30:00',1.35),('8998','2013-05-15','09:35:00',1.58),('8998','2013-05-15','09:40:00',1.94),('8998','2013-05-15','09:45:00',2.3),('8998','2013-05-15','09:50:00',1),('8998','2013-05-15','10:00:00',1.25),('8998','2013-05-15','10:15:00',1.12),('8998','2013-05-15','10:20:00',1.57),('8998','2013-05-15','10:25:00',1.67),('8998','2013-05-15','10:30:00',1.34),('8998','2013-05-15','10:40:00',1.02),('8998','2013-05-15','10:50:00',1.18),('8998','2013-05-15','10:55:00',1.31),('8998','2013-05-15','11:00:00',3.2),('8998','2013-05-15','11:05:00',2.88),('8998','2013-05-15','11:10:00',2.32),('8998','2013-05-15','11:15:00',1.58),('8998','2013-05-15','11:30:00',1.15),('8998','2013-05-15','11:35:00',2.33),('8998','2013-05-15','11:40:00',3.05),('8998','2013-05-15','11:45:00',3.05),('8998','2013-05-15','11:50:00',2.88),('8998','2013-05-15','11:55:00',1.94),('8998','2013-05-15','12:00:00',1.26),('8998','2013-05-15','12:05:00',1.14),('8998','2013-05-15','12:10:00',1.2),('8998','2013-05-15','12:15:00',2.01),('8998','2013-05-15','12:20:00',1.43),('8998','2013-05-15','12:25:00',1.61),('8998','2013-05-15','12:30:00',2.19),('8998','2013-05-15','12:35:00',2.47),('8998','2013-05-15','12:40:00',2.87),('8998','2013-05-15','12:45:00',2.59),('8998','2013-05-15','12:50:00',1.88),('8998','2013-05-15','12:55:00',2.96),('8998','2013-05-15','13:00:00',2.88),('8998','2013-05-15','13:05:00',2.64),('8998','2013-05-15','13:10:00',2.81),('8998','2013-05-15','13:15:00',2.32),('8998','2013-05-15','13:20:00',2.24),('8998','2013-05-15','13:25:00',2.81),('8998','2013-05-15','13:30:00',2.73),('8998','2013-05-15','13:35:00',2.69),('8998','2013-05-15','13:40:00',2.63),('8998','2013-05-15','13:45:00',2.6),('8998','2013-05-15','13:50:00',2.58),('8998','2013-05-15','13:55:00',2.57),('8998','2013-05-15','14:00:00',2.54),('8998','2013-05-15','14:05:00',2.52),('8998','2013-05-15','14:10:00',2.47),('8998','2013-05-15','14:15:00',2.42),('8998','2013-05-15','14:20:00',2.41),('8998','2013-05-15','14:25:00',2.32),('8998','2013-05-15','14:30:00',2.32),('8998','2013-05-15','14:35:00',2.27),('8998','2013-05-15','14:40:00',2.23),('8998','2013-05-15','14:45:00',2.19),('8998','2013-05-15','14:50:00',2.07),('8998','2013-05-15','14:55:00',1.73),('8998','2013-05-15','15:00:00',2.07),('8998','2013-05-15','15:05:00',2.06),('8998','2013-05-15','15:10:00',2.03),('8998','2013-05-15','15:15:00',1.84),('8998','2013-05-15','15:20:00',1.87),('8998','2013-05-15','15:25:00',1.89),('8998','2013-05-15','15:30:00',1.82),('8998','2013-05-15','15:35:00',1.75),('8998','2013-05-15','15:40:00',1.79),('8998','2013-05-15','15:45:00',1.72),('8998','2013-05-15','15:50:00',1.68),('8998','2013-05-15','15:55:00',1.64),('8998','2013-05-15','16:00:00',1.6),('8998','2013-05-15','16:05:00',1.53),('8998','2013-05-15','16:10:00',1.51),('8998','2013-05-15','16:15:00',1.43),('8998','2013-05-15','16:20:00',1.47),('8998','2013-05-15','16:25:00',1.43),('8998','2013-05-15','16:30:00',1.42),('8998','2013-05-15','16:35:00',1.38),('8998','2013-05-15','16:50:00',1.07),('8998','2013-05-14','07:35:00',1.16),('8998','2013-05-14','07:40:00',1.43),('8998','2013-05-14','07:45:00',1.48),('8998','2013-05-14','07:50:00',1.36),('8998','2013-05-14','07:55:00',1.29),('8998','2013-05-14','08:00:00',1.35),('8998','2013-05-14','08:05:00',1.34),('8998','2013-05-14','08:10:00',1.52),('8998','2013-05-14','08:15:00',1.51),('8998','2013-05-14','08:20:00',1.48),('8998','2013-05-14','08:25:00',1.52),('8998','2013-05-14','08:30:00',1.6),('8998','2013-05-14','08:35:00',1.72),('8998','2013-05-14','08:40:00',1.67),('8998','2013-05-14','08:45:00',1.8),('8998','2013-05-14','08:50:00',2.09),('8998','2013-05-14','08:55:00',2.03),('8998','2013-05-14','09:00:00',1.83),('8998','2013-05-14','09:05:00',1.86),('8998','2013-05-14','09:10:00',1.98),('8998','2013-05-14','09:15:00',2.12),('8998','2013-05-14','09:20:00',2.35),('8998','2013-05-14','09:25:00',2.53),('8998','2013-05-14','09:30:00',2.65),('8998','2013-05-14','09:35:00',2.68),('8998','2013-05-14','09:40:00',2.65),('8998','2013-05-14','09:45:00',2.72),('8998','2013-05-14','09:50:00',2.77),('8998','2013-05-14','09:55:00',2.77),('8998','2013-05-14','10:00:00',2.84),('8998','2013-05-14','10:05:00',2.89),('8998','2013-05-14','10:10:00',2.87),('8998','2013-05-14','10:15:00',2.82),('8998','2013-05-14','10:20:00',2.92),('8998','2013-05-14','10:25:00',2.95),('8998','2013-05-14','10:30:00',2.88),('8998','2013-05-14','10:35:00',2.91),('8998','2013-05-14','10:40:00',2.95),('8998','2013-05-14','10:45:00',3),('8998','2013-05-14','10:50:00',2.99),('8998','2013-05-14','10:55:00',2.9),('8998','2013-05-14','11:00:00',2.87),('8998','2013-05-14','11:05:00',2.88),('8998','2013-05-14','11:10:00',2.98),('8998','2013-05-14','11:15:00',3.01),('8998','2013-05-14','11:20:00',2.88),('8998','2013-05-14','11:25:00',2.96),('8998','2013-05-14','11:30:00',2.91),('8998','2013-05-14','11:35:00',2.81),('8998','2013-05-14','11:40:00',2.47),('8998','2013-05-14','11:45:00',2.23),('8998','2013-05-14','11:50:00',1.86),('8998','2013-05-14','11:55:00',1.39),('8998','2013-05-14','12:00:00',1.55),('8998','2013-05-14','12:05:00',2.37),('8998','2013-05-14','12:10:00',3.15),('8998','2013-05-14','12:15:00',3.5),('8998','2013-05-14','12:20:00',1.94),('8998','2013-05-14','12:25:00',2.57),('8998','2013-05-14','12:30:00',1.9),('8998','2013-05-14','12:35:00',2.04),('8998','2013-05-14','12:40:00',3.41),('8998','2013-05-14','12:45:00',1.76),('8998','2013-05-14','12:50:00',1.73),('8998','2013-05-14','12:55:00',1.9),('8998','2013-05-14','13:00:00',1.99),('8998','2013-05-14','13:05:00',2.28),('8998','2013-05-14','13:10:00',2.06),('8998','2013-05-14','13:15:00',1.61),('8998','2013-05-14','13:20:00',1.9),('8998','2013-05-14','13:25:00',1.81),('8998','2013-05-14','13:30:00',1.88),('8998','2013-05-14','13:35:00',1.69),('8998','2013-05-14','13:40:00',1.7),('8998','2013-05-14','13:45:00',1.81),('8998','2013-05-14','13:50:00',1.5),('8998','2013-05-14','13:55:00',1.47),('8998','2013-05-14','14:00:00',1.32),('8998','2013-05-14','14:05:00',1.16),('8998','2013-05-14','14:10:00',1.15),('8998','2013-05-14','14:15:00',1.16),('8998','2013-05-14','14:20:00',1.17),('8998','2013-05-14','14:25:00',1.19),('8998','2013-05-14','14:30:00',1.06),('8998','2013-05-14','14:35:00',1.01),('8998','2013-05-14','14:40:00',1.1),('8998','2013-05-14','14:45:00',1.03),('8998','2013-05-14','14:50:00',1.04),('8998','2013-05-14','14:55:00',1.03),('8998','2013-05-14','15:00:00',1.04),('8998','2013-05-14','15:55:00',1.21),('8998','2013-05-14','16:00:00',1.27),('8998','2013-05-14','16:05:00',1.2),('8998','2013-05-14','16:10:00',1.13),('8998','2013-05-14','16:15:00',1.01),('8998','2013-05-14','16:20:00',1.08),('8998','2013-05-14','16:25:00',1.12),('8998','2013-05-14','16:30:00',1.03),('8998','2013-05-14','17:00:00',1.02),('8998','2013-05-14','17:05:00',1.18),('8998','2013-05-14','17:10:00',1.04),('8998','2013-05-14','17:15:00',1.2),('8998','2013-05-13','07:35:00',1.3),('8998','2013-05-13','07:40:00',1.49),('8998','2013-05-13','07:45:00',1.49),('8998','2013-05-13','07:50:00',1.35),('8998','2013-05-13','07:55:00',1.63),('8998','2013-05-13','08:00:00',1.71),('8998','2013-05-13','08:05:00',1.66),('8998','2013-05-13','08:10:00',1.56),('8998','2013-05-13','08:15:00',1.57),('8998','2013-05-13','08:20:00',1.55),('8998','2013-05-13','08:25:00',1.57),('8998','2013-05-13','08:30:00',1.73),('8998','2013-05-13','08:35:00',1.78),('8998','2013-05-13','08:40:00',1.74),('8998','2013-05-13','08:45:00',2.07),('8998','2013-05-13','08:50:00',2.21),('8998','2013-05-13','08:55:00',2.02),('8998','2013-05-13','09:00:00',1.92),('8998','2013-05-13','09:05:00',1.89),('8998','2013-05-13','09:10:00',2.1),('8998','2013-05-13','09:15:00',2.21),('8998','2013-05-13','09:20:00',2.57),('8998','2013-05-13','09:25:00',2.78),('8998','2013-05-13','09:30:00',2.81),('8998','2013-05-13','09:35:00',2.84),('8998','2013-05-13','09:40:00',2.84),('8998','2013-05-13','09:45:00',2.88),('8998','2013-05-13','09:50:00',2.92),('8998','2013-05-13','09:55:00',2.94),('8998','2013-05-13','10:00:00',2.98),('8998','2013-05-13','10:05:00',2.99),('8998','2013-05-13','10:10:00',3.01),('8998','2013-05-13','10:15:00',3.04),('8998','2013-05-13','10:20:00',3.04),('8998','2013-05-13','10:25:00',3.04),('8998','2013-05-13','10:30:00',3.06),('8998','2013-05-13','10:35:00',3.08),('8998','2013-05-13','10:40:00',3.09),('8998','2013-05-13','10:45:00',3.09),('8998','2013-05-13','10:50:00',3.12),('8998','2013-05-13','10:55:00',3.11),('8998','2013-05-13','11:00:00',3.11),('8998','2013-05-13','11:05:00',3.13),('8998','2013-05-13','11:10:00',3.13),('8998','2013-05-13','11:15:00',3.12),('8998','2013-05-13','11:20:00',3.12),('8998','2013-05-13','11:25:00',3.12),('8998','2013-05-13','11:30:00',3.13),('8998','2013-05-13','11:35:00',3.11),('8998','2013-05-13','11:40:00',3.11),('8998','2013-05-13','11:45:00',3.1),('8998','2013-05-13','11:50:00',3.11),('8998','2013-05-13','11:55:00',3.11),('8998','2013-05-13','12:00:00',3.09),('8998','2013-05-13','12:05:00',3.08),('8998','2013-05-13','12:10:00',3.08),('8998','2013-05-13','12:15:00',3.07),('8998','2013-05-13','12:20:00',3.08),('8998','2013-05-13','12:25:00',3.08),('8998','2013-05-13','12:30:00',3.06),('8998','2013-05-13','12:35:00',3.04),('8998','2013-05-13','12:40:00',3.05),('8998','2013-05-13','12:45:00',3.03),('8998','2013-05-13','12:50:00',3.01),('8998','2013-05-13','12:55:00',3),('8998','2013-05-13','13:00:00',2.96),('8998','2013-05-13','13:05:00',2.95),('8998','2013-05-13','13:10:00',2.97),('8998','2013-05-13','13:15:00',2.94),('8998','2013-05-13','13:20:00',2.91),('8998','2013-05-13','13:25:00',2.86),('8998','2013-05-13','13:30:00',2.85),('8998','2013-05-13','13:35:00',2.85),('8998','2013-05-13','13:40:00',2.82),('8998','2013-05-13','13:45:00',2.77),('8998','2013-05-13','13:50:00',2.74),('8998','2013-05-13','13:55:00',2.69),('8998','2013-05-13','14:00:00',2.65),('8998','2013-05-13','14:05:00',2.65),('8998','2013-05-13','14:10:00',2.63),('8998','2013-05-13','14:15:00',2.59),('8998','2013-05-13','14:20:00',2.54),('8998','2013-05-13','14:25:00',2.49),('8998','2013-05-13','14:30:00',2.45),('8998','2013-05-13','14:35:00',2.41),('8998','2013-05-13','14:40:00',2.36),('8998','2013-05-13','14:45:00',2.33),('8998','2013-05-13','14:50:00',2.31),('8998','2013-05-13','14:55:00',2.29),('8998','2013-05-13','15:00:00',2.25),('8998','2013-05-13','15:05:00',2.22),('8998','2013-05-13','15:10:00',2.17),('8998','2013-05-13','15:15:00',2.12),('8998','2013-05-13','15:20:00',2.07),('8998','2013-05-13','15:25:00',2.03),('8998','2013-05-13','15:30:00',1.98),('8998','2013-05-13','15:35:00',1.93),('8998','2013-05-13','15:40:00',1.87),('8998','2013-05-13','15:45:00',1.81),('8998','2013-05-13','15:50:00',1.77),('8998','2013-05-13','15:55:00',1.71),('8998','2013-05-13','16:00:00',1.65),('8998','2013-05-13','16:05:00',1.59),('8998','2013-05-13','16:10:00',1.54),('8998','2013-05-13','16:15:00',1.48),('8998','2013-05-13','16:20:00',1.42),('8998','2013-05-13','16:25:00',1.36),('8998','2013-05-13','16:30:00',1.3),('8998','2013-05-13','16:35:00',1.24),('8998','2013-05-13','16:40:00',1.17),('8998','2013-05-13','16:45:00',1.11),('8998','2013-05-13','16:50:00',1.05),('8998','2013-05-12','07:35:00',1.14),('8998','2013-05-12','07:45:00',1.08),('8998','2013-05-12','08:00:00',1.32),('8998','2013-05-12','08:05:00',1.58),('8998','2013-05-12','08:10:00',1.83),('8998','2013-05-12','08:15:00',1.9),('8998','2013-05-12','08:20:00',1.89),('8998','2013-05-12','08:25:00',1.84),('8998','2013-05-12','08:30:00',1.79),('8998','2013-05-12','08:35:00',1.73),('8998','2013-05-12','08:40:00',1.73),('8998','2013-05-12','08:45:00',1.7),('8998','2013-05-12','08:50:00',1.76),('8998','2013-05-12','08:55:00',1.79),('8998','2013-05-12','09:00:00',1.8),('8998','2013-05-12','09:05:00',1.91),('8998','2013-05-12','09:10:00',2.07),('8998','2013-05-12','09:15:00',2.14),('8998','2013-05-12','09:20:00',2.41),('8998','2013-05-12','09:25:00',2.63),('8998','2013-05-12','09:30:00',2.67),('8998','2013-05-12','09:35:00',2.69),('8998','2013-05-12','09:40:00',2.73),('8998','2013-05-12','09:45:00',2.8),('8998','2013-05-12','09:50:00',2.83),('8998','2013-05-12','09:55:00',2.91),('8998','2013-05-12','10:00:00',2.79),('8998','2013-05-12','10:05:00',2.01),('8998','2013-05-12','10:10:00',2.98),('8998','2013-05-12','10:15:00',3.2),('8998','2013-05-12','10:20:00',2.16),('8998','2013-05-12','10:25:00',2.24),('8998','2013-05-12','10:30:00',3.34),('8998','2013-05-12','10:40:00',1.22),('8998','2013-05-12','10:45:00',2.99),('8998','2013-05-12','10:50:00',3.46),('8998','2013-05-12','10:55:00',2.08),('8998','2013-05-12','11:00:00',2.2),('8998','2013-05-12','11:05:00',1.6),('8998','2013-05-12','11:10:00',1.26),('8998','2013-05-12','11:15:00',1.71),('8998','2013-05-12','11:20:00',1.12),('8998','2013-05-12','11:25:00',1.36),('8998','2013-05-12','11:30:00',1.51),('8998','2013-05-12','11:35:00',2.5),('8998','2013-05-12','11:40:00',1.79),('8998','2013-05-12','11:45:00',2.05),('8998','2013-05-12','11:50:00',1.28),('8998','2013-05-12','11:55:00',1.22),('8998','2013-05-12','12:00:00',1.08),('8998','2013-05-12','12:05:00',1.11),('8998','2013-05-12','12:10:00',2.32),('8998','2013-05-12','12:15:00',1.78),('8998','2013-05-12','12:20:00',1.02),('8998','2013-05-12','12:25:00',1.88),('8998','2013-05-12','12:30:00',2.97),('8998','2013-05-12','12:35:00',2.17),('8998','2013-05-12','12:40:00',1.54),('8998','2013-05-12','12:45:00',1.55),('8998','2013-05-12','12:50:00',2.68),('8998','2013-05-12','12:55:00',3.42),('8998','2013-05-12','13:00:00',3.33),('8998','2013-05-12','13:05:00',2.91),('8998','2013-05-12','13:10:00',3.26),('8998','2013-05-12','13:15:00',3.35),('8998','2013-05-12','13:20:00',3.1),('8998','2013-05-12','13:25:00',3.2),('8998','2013-05-12','13:30:00',3.2),('8998','2013-05-12','13:35:00',2.9),('8998','2013-05-12','13:40:00',1.69),('8998','2013-05-12','13:45:00',1.66),('8998','2013-05-12','14:00:00',1.07),('8998','2013-05-12','14:05:00',3.17),('8998','2013-05-12','14:10:00',3.14),('8998','2013-05-12','14:15:00',2.98),('8998','2013-05-12','14:20:00',2.75),('8998','2013-05-12','14:25:00',2.04),('8998','2013-05-12','14:30:00',1.2),('8998','2013-05-12','14:35:00',2.66),('8998','2013-05-12','14:40:00',2.71),('8998','2013-05-12','14:45:00',1.19),('8998','2013-05-12','14:50:00',1.63),('8998','2013-05-12','14:55:00',2.7),('8998','2013-05-12','15:00:00',2.31),('8998','2013-05-12','15:05:00',1.32),('8998','2013-05-12','16:20:00',1),('8998','2013-05-12','16:30:00',1.19),('8998','2013-05-12','16:40:00',1.28),('8998','2013-05-12','16:45:00',1.46),('8998','2013-05-12','16:50:00',1.71),('8998','2013-05-12','16:55:00',1.47),('8998','2013-05-12','17:00:00',1.31),('8998','2013-05-12','17:05:00',1.12),('8998','2013-05-12','17:15:00',1.3),('8998','2013-05-12','17:20:00',1.28),('8998','2013-05-12','17:25:00',1.07),('8998','2013-05-11','08:00:00',1.29),('8998','2013-05-11','08:10:00',1.44),('8998','2013-05-11','08:15:00',1.97),('8998','2013-05-11','08:20:00',1.67),('8998','2013-05-11','08:25:00',1.18),('8998','2013-05-11','08:45:00',1.64),('8998','2013-05-11','08:50:00',1.33),('8998','2013-05-11','09:00:00',1.08),('8998','2013-05-11','09:30:00',2.37),('8998','2013-05-11','09:35:00',1.03),('8998','2013-05-11','09:40:00',1.35),('8998','2013-05-11','09:45:00',2.13),('8998','2013-05-11','09:50:00',2.83),('8998','2013-05-11','09:55:00',2.82),('8998','2013-05-11','10:00:00',3.08),('8998','2013-05-11','10:05:00',2.11),('8998','2013-05-11','10:10:00',1.04),('8998','2013-05-11','10:15:00',2.06),('8998','2013-05-11','10:45:00',2.85),('8998','2013-05-11','10:50:00',1.87),('8998','2013-05-11','10:55:00',3.64),('8998','2013-05-11','11:00:00',3.39),('8998','2013-05-11','11:05:00',1.03),('8998','2013-05-11','11:15:00',3.02),('8998','2013-05-11','11:20:00',3.54),('8998','2013-05-11','11:25:00',3.5),('8998','2013-05-11','11:30:00',3.56),('8998','2013-05-11','11:35:00',3.37),('8998','2013-05-11','11:40:00',3.2),('8998','2013-05-11','11:45:00',3.54),('8998','2013-05-11','11:50:00',1.99),('8998','2013-05-11','11:55:00',3.55),('8998','2013-05-11','12:00:00',2.71),('8998','2013-05-11','12:05:00',2.69),('8998','2013-05-11','12:10:00',3.15),('8998','2013-05-11','12:15:00',1.99),('8998','2013-05-11','12:35:00',1.12),('8998','2013-05-11','12:40:00',1.42),('8998','2013-05-11','12:45:00',1.72),('8998','2013-05-11','12:50:00',3.72),('8998','2013-05-11','12:55:00',2.42),('8998','2013-05-11','13:00:00',2.83),('8998','2013-05-11','13:05:00',1.01),('8998','2013-05-11','13:10:00',2.3),('8998','2013-05-11','13:15:00',2.81),('8998','2013-05-11','13:20:00',1.33),('8998','2013-05-11','13:25:00',1.52),('8998','2013-05-11','13:30:00',2.47),('8998','2013-05-11','13:35:00',3.1),('8998','2013-05-11','13:40:00',3.29),('8998','2013-05-11','13:45:00',2.39),('8998','2013-05-11','13:50:00',2.8),('8998','2013-05-11','13:55:00',2.72),('8998','2013-05-11','14:00:00',2.01),('8998','2013-05-11','14:05:00',3.3),('8998','2013-05-11','14:10:00',2.37),('8998','2013-05-11','14:15:00',2.53),('8998','2013-05-11','14:20:00',2.9),('8998','2013-05-11','14:25:00',2.78),('8998','2013-05-11','14:30:00',2.71),('8998','2013-05-11','14:35:00',2.67),('8998','2013-05-11','14:40:00',2.61),('8998','2013-05-11','14:45:00',2.5),('8998','2013-05-11','14:50:00',2.5),('8998','2013-05-11','14:55:00',2.45),('8998','2013-05-11','15:00:00',2.12),('8998','2013-05-11','15:05:00',2.41),('8998','2013-05-11','15:10:00',2.25),('8998','2013-05-11','15:15:00',1.92),('8998','2013-05-11','15:20:00',2),('8998','2013-05-11','15:25:00',2.14),('8998','2013-05-11','15:30:00',2.06),('8998','2013-05-11','15:35:00',1.98),('8998','2013-05-11','15:40:00',1.91),('8998','2013-05-11','15:45:00',1.86),('8998','2013-05-11','15:50:00',1.79),('8998','2013-05-11','15:55:00',1.72),('8998','2013-05-11','16:00:00',1.65),('8998','2013-05-11','16:05:00',1.45),('8998','2013-05-11','16:10:00',1.54),('8998','2013-05-11','16:15:00',1.49),('8998','2013-05-11','16:20:00',1.43),('8998','2013-05-11','16:25:00',1.37),('8998','2013-05-11','16:30:00',1.32),('8998','2013-05-11','16:35:00',1.31),('8998','2013-05-11','16:40:00',1.33),('8998','2013-05-11','16:45:00',1.45),('8998','2013-05-11','16:50:00',1.51),('8998','2013-05-11','16:55:00',1.41),('8998','2013-05-11','17:00:00',1.6),('8998','2013-05-11','17:05:00',1.42),('8998','2013-05-11','17:10:00',1.43),('8998','2013-05-11','17:15:00',1.46),('8998','2013-05-11','17:20:00',1.33),('8998','2013-05-11','17:25:00',1.11),('8998','2013-05-11','17:30:00',1.05),('8998','2014-03-30','08:25:00',1.09),('8998','2014-03-30','08:30:00',1.45),('8998','2014-03-30','08:35:00',1.54),('8998','2014-03-30','08:40:00',1.57),('8998','2014-03-30','08:45:00',1.62),('8998','2014-03-30','08:50:00',1.76),('8998','2014-03-30','08:55:00',1.85),('8998','2014-03-30','09:00:00',1.95),('8998','2014-03-30','09:05:00',2),('8998','2014-03-30','09:10:00',2.05),('8998','2014-03-30','09:15:00',2.13),('8998','2014-03-30','09:20:00',2.18),('8998','2014-03-30','09:25:00',2.23),('8998','2014-03-30','09:30:00',2.28),('8998','2014-03-30','09:35:00',2.31),('8998','2014-03-30','09:40:00',2.34),('8998','2014-03-30','09:45:00',2.38),('8998','2014-03-30','09:50:00',2.41),('8998','2014-03-30','09:55:00',2.44),('8998','2014-03-30','10:00:00',2.48),('8998','2014-03-30','10:05:00',2.5),('8998','2014-03-30','10:10:00',2.52),('8998','2014-03-30','10:15:00',2.54),('8998','2014-03-30','10:20:00',2.56),('8998','2014-03-30','10:25:00',2.58),('8998','2014-03-30','10:30:00',2.59),('8998','2014-03-30','10:35:00',2.62),('8998','2014-03-30','10:40:00',2.66),('8998','2014-03-30','10:45:00',2.69),('8998','2014-03-30','10:50:00',2.67),('8998','2014-03-30','10:55:00',2.7),('8998','2014-03-30','11:00:00',2.72),('8998','2014-03-30','11:05:00',2.75),('8998','2014-03-30','11:10:00',2.75),('8998','2014-03-30','11:15:00',2.75),('8998','2014-03-30','11:20:00',2.77),('8998','2014-03-30','11:25:00',2.77),('8998','2014-03-30','11:30:00',2.78),('8998','2014-03-30','11:35:00',2.78),('8998','2014-03-30','11:40:00',2.77),('8998','2014-03-30','11:45:00',2.74),('8998','2014-03-30','11:50:00',2.75),('8998','2014-03-30','11:55:00',2.78),('8998','2014-03-30','12:00:00',2.79),('8998','2014-03-30','12:05:00',2.77),('8998','2014-03-30','12:10:00',2.75),('8998','2014-03-30','12:15:00',2.73),('8998','2014-03-30','12:20:00',2.76),('8998','2014-03-30','12:25:00',2.75),('8998','2014-03-30','12:30:00',2.72),('8998','2014-03-30','12:35:00',2.72),('8998','2014-03-30','12:40:00',2.7),('8998','2014-03-30','12:45:00',2.68),('8998','2014-03-30','12:50:00',2.64),('8998','2014-03-30','12:55:00',2.64),('8998','2014-03-30','13:00:00',2.63),('8998','2014-03-30','13:05:00',2.63),('8998','2014-03-30','13:10:00',2.62),('8998','2014-03-30','13:15:00',2.6),('8998','2014-03-30','13:20:00',2.58),('8998','2014-03-30','13:25:00',2.56),('8998','2014-03-30','13:30:00',2.53),('8998','2014-03-30','13:35:00',2.52),('8998','2014-03-30','13:40:00',2.49),('8998','2014-03-30','13:45:00',2.48),('8998','2014-03-30','13:50:00',2.44),('8998','2014-03-30','13:55:00',2.42),('8998','2014-03-30','14:00:00',2.39),('8998','2014-03-30','14:05:00',2.37),('8998','2014-03-30','14:10:00',2.32),('8998','2014-03-30','14:15:00',2.29),('8998','2014-03-30','14:20:00',2.26),('8998','2014-03-30','14:25:00',2.22),('8998','2014-03-30','14:30:00',2.18),('8998','2014-03-30','14:35:00',2.13),('8998','2014-03-30','14:40:00',2.09),('8998','2014-03-30','14:45:00',2.05),('8998','2014-03-30','14:50:00',1.99),('8998','2014-03-30','14:55:00',1.95),('8998','2014-03-30','15:00:00',1.91),('8998','2014-03-30','15:05:00',1.86),('8998','2014-03-30','15:10:00',1.81),('8998','2014-03-30','15:15:00',1.76),('8998','2014-03-30','15:20:00',1.7),('8998','2014-03-30','15:25:00',1.64),('8998','2014-03-30','15:30:00',1.59),('8998','2014-03-30','15:35:00',1.53),('8998','2014-03-30','15:40:00',1.48),('8998','2014-03-30','15:45:00',1.42),('8998','2014-03-30','15:50:00',1.36),('8998','2014-03-30','15:55:00',1.3),('8998','2014-03-30','16:00:00',1.23),('8998','2014-03-30','16:05:00',1.17),('8998','2014-03-30','16:10:00',1.11),('8998','2014-03-30','16:15:00',1.04),('8998','2013-05-10','07:45:00',1.32),('8998','2013-05-10','07:50:00',1.35),('8998','2013-05-10','07:55:00',1.45),('8998','2013-05-10','08:00:00',1.35),('8998','2013-05-10','08:05:00',1.48),('8998','2013-05-10','08:20:00',1.07),('8998','2013-05-10','09:20:00',1.51),('8998','2013-05-10','09:25:00',1.02),('8998','2013-05-10','09:30:00',2.12),('8998','2013-05-10','09:35:00',1.35),('8998','2013-05-10','09:40:00',1.51),('8998','2013-05-10','09:45:00',1.96),('8998','2013-05-10','09:50:00',1.2),('8998','2013-05-10','09:55:00',1.31),('8998','2013-05-10','10:00:00',1.17),('8998','2013-05-10','10:05:00',1.31),('8998','2013-05-10','10:55:00',2.03),('8998','2013-05-10','11:00:00',3.22),('8998','2013-05-10','11:05:00',2.53),('8998','2013-05-10','11:35:00',1.95),('8998','2013-05-10','11:40:00',1.57),('8998','2013-05-10','11:45:00',2.46),('8998','2013-05-10','11:50:00',2.4),('8998','2013-05-10','12:05:00',1.27),('8998','2013-05-10','12:10:00',1.11),('8998','2013-05-10','12:15:00',1.09),('8998','2013-05-10','12:20:00',1.24),('8998','2013-05-10','12:25:00',3.64),('8998','2013-05-10','12:30:00',2.44),('8998','2013-05-10','12:35:00',1.57),('8998','2013-05-10','12:40:00',1.34),('8998','2013-05-10','12:45:00',1.44),('8998','2013-05-10','12:50:00',1.29),('8998','2013-05-10','12:55:00',1.1),('8998','2013-05-10','13:00:00',1.04),('8998','2013-05-10','13:05:00',1.02),('8998','2013-05-10','14:00:00',1.28),('8998','2013-05-10','14:05:00',1.85),('8998','2013-05-10','14:10:00',2.23),('8998','2013-05-10','14:15:00',1.45),('8998','2013-05-10','14:20:00',2.67),('8998','2013-05-10','14:25:00',2.33),('8998','2013-05-10','14:30:00',2.07),('8998','2013-05-10','14:35:00',1.73),('8998','2013-05-10','14:40:00',1.68),('8998','2013-05-10','14:45:00',2.07),('8998','2013-05-10','14:50:00',2.6),('8998','2013-05-10','14:55:00',2.56),('8998','2013-05-10','15:00:00',2.34),('8998','2013-05-10','15:05:00',2.2),('8998','2013-05-10','15:10:00',2.16),('8998','2013-05-10','15:15:00',2.2),('8998','2013-05-10','15:20:00',2.15),('8998','2013-05-10','15:25:00',2.08),('8998','2013-05-10','15:30:00',2.02),('8998','2013-05-10','15:35:00',1.97),('8998','2013-05-10','15:40:00',1.93),('8998','2013-05-10','15:45:00',1.88),('8998','2013-05-10','15:50:00',1.53),('8998','2013-05-10','15:55:00',1.8),('8998','2013-05-10','16:00:00',1.5),('8998','2013-05-10','16:05:00',1.69),('8998','2013-05-10','16:10:00',1.6),('8998','2013-05-10','16:15:00',1.01),('8998','2013-05-10','16:20:00',1.56),('8998','2013-05-10','16:25:00',1.46),('8998','2013-05-10','16:30:00',1.32),('8998','2013-05-10','16:35:00',1.18),('8998','2013-05-10','16:40:00',1.2),('8998','2013-05-10','16:45:00',1.15),('8998','2013-05-09','07:35:00',1),('8998','2013-05-09','08:00:00',1.29),('8998','2013-05-09','08:05:00',1.86),('8998','2013-05-09','08:10:00',1.84),('8998','2013-05-09','08:15:00',1.92),('8998','2013-05-09','08:20:00',1.77),('8998','2013-05-09','08:25:00',1.65),('8998','2013-05-09','08:30:00',1.7),('8998','2013-05-09','08:35:00',1.71),('8998','2013-05-09','08:40:00',1.14),('8998','2013-05-09','09:00:00',1.24),('8998','2013-05-09','09:05:00',1.9),('8998','2013-05-09','09:10:00',2.09),('8998','2013-05-09','09:15:00',2.26),('8998','2013-05-09','09:20:00',2.32),('8998','2013-05-09','09:25:00',2.14),('8998','2013-05-09','09:30:00',2.2),('8998','2013-05-09','09:35:00',2.71),('8998','2013-05-09','09:40:00',2.6),('8998','2013-05-09','09:45:00',2.33),('8998','2013-05-09','09:50:00',2.4),('8998','2013-05-09','09:55:00',2.64),('8998','2013-05-09','10:00:00',2.08),('8998','2013-05-09','10:05:00',2.49),('8998','2013-05-09','10:10:00',2.53),('8998','2013-05-09','10:15:00',2.71),('8998','2013-05-09','10:20:00',1.55),('8998','2013-05-09','10:25:00',2.09),('8998','2013-05-09','10:30:00',2.3),('8998','2013-05-09','10:40:00',2.5),('8998','2013-05-09','10:45:00',3.25),('8998','2013-05-09','10:50:00',3.26),('8998','2013-05-09','10:55:00',3.07),('8998','2013-05-09','11:00:00',3.2),('8998','2013-05-09','11:05:00',3.21),('8998','2013-05-09','11:10:00',3.17),('8998','2013-05-09','11:15:00',2.85),('8998','2013-05-09','11:20:00',3.33),('8998','2013-05-09','11:25:00',2.99),('8998','2013-05-09','11:30:00',2.69),('8998','2013-05-09','11:35:00',2.94),('8998','2013-05-09','11:40:00',3.16),('8998','2013-05-09','11:45:00',2.14),('8998','2013-05-09','11:50:00',2.55),('8998','2013-05-09','11:55:00',2.92),('8998','2013-05-09','12:00:00',2.9),('8998','2013-05-09','12:05:00',2.4),('8998','2013-05-09','12:10:00',1.68),('8998','2013-05-09','12:15:00',1.58),('8998','2013-05-09','12:20:00',1.89),('8998','2013-05-09','12:25:00',1.69),('8998','2013-05-09','12:30:00',1.58),('8998','2013-05-09','12:35:00',1.8),('8998','2013-05-09','12:40:00',2.54),('8998','2013-05-09','12:45:00',3.24),('8998','2013-05-09','12:50:00',2.7),('8998','2013-05-09','12:55:00',2.36),('8998','2013-05-09','13:00:00',2.76),('8998','2013-05-09','13:05:00',2.61),('8998','2013-05-09','13:10:00',3.22),('8998','2013-05-09','13:15:00',3.32),('8998','2013-05-09','13:20:00',2.34),('8998','2013-05-09','13:25:00',2.01),('8998','2013-05-09','13:30:00',2.15),('8998','2013-05-09','13:35:00',2.33),('8998','2013-05-09','13:40:00',3.08),('8998','2013-05-09','13:45:00',2.86),('8998','2013-05-09','13:50:00',1.72),('8998','2013-05-09','13:55:00',1.49),('8998','2013-05-09','14:00:00',1.34),('8998','2013-05-09','14:05:00',1.33),('8998','2013-05-09','14:10:00',1.57),('8998','2013-05-09','14:15:00',1.7),('8998','2013-05-09','14:20:00',1.77),('8998','2013-05-09','14:25:00',1.75),('8998','2013-05-09','14:30:00',1.73),('8998','2013-05-09','14:35:00',2.13),('8998','2013-05-09','14:40:00',1.93),('8998','2013-05-09','14:45:00',1.5),('8998','2013-05-09','14:50:00',1.14),('8998','2013-05-09','15:10:00',1.07),('8998','2013-05-09','15:15:00',1.83),('8998','2013-05-09','15:20:00',1.82),('8998','2013-05-09','15:25:00',1.36),('8998','2013-05-09','15:30:00',1.25),('8998','2013-05-09','15:35:00',1.26),('8998','2013-05-09','15:40:00',1.3),('8998','2013-05-09','15:45:00',1.29),('8998','2013-05-09','15:50:00',1.21),('8998','2013-05-09','15:55:00',1.15),('8998','2013-05-09','16:00:00',1.1),('8998','2013-05-09','16:05:00',1.09),('8998','2013-05-09','16:10:00',1.08),('8998','2013-05-09','16:15:00',1.02),('8998','2013-05-09','17:20:00',1.01),('8998','2013-05-09','17:25:00',1.03),('8998','2013-05-09','17:35:00',1.01),('8998','2013-05-08','07:35:00',1.19),('8998','2013-05-08','07:40:00',1.28),('8998','2013-05-08','07:45:00',1.3),('8998','2013-05-08','07:50:00',1.27),('8998','2013-05-08','07:55:00',1.31),('8998','2013-05-08','08:00:00',1.39),('8998','2013-05-08','08:05:00',1.44),('8998','2013-05-08','08:10:00',1.43),('8998','2013-05-08','08:15:00',1.48),('8998','2013-05-08','08:20:00',1.74),('8998','2013-05-08','08:25:00',1.72),('8998','2013-05-08','08:30:00',1.61),('8998','2013-05-08','08:35:00',1.65),('8998','2013-05-08','08:40:00',1.81),('8998','2013-05-08','08:45:00',1.99),('8998','2013-05-08','08:50:00',1.86),('8998','2013-05-08','08:55:00',1.74),('8998','2013-05-08','09:00:00',1.7),('8998','2013-05-08','09:05:00',1.84),('8998','2013-05-08','09:10:00',1.85),('8998','2013-05-08','09:15:00',2.04),('8998','2013-05-08','09:20:00',2.23),('8998','2013-05-08','09:25:00',2.53),('8998','2013-05-08','09:30:00',2.71),('8998','2013-05-08','09:35:00',2.74),('8998','2013-05-08','09:40:00',2.76),('8998','2013-05-08','09:45:00',2.79),('8998','2013-05-08','09:50:00',2.83),('8998','2013-05-08','09:55:00',2.87),('8998','2013-05-08','10:00:00',2.88),('8998','2013-05-08','10:05:00',2.9),('8998','2013-05-08','10:10:00',2.93),('8998','2013-05-08','10:15:00',2.94),('8998','2013-05-08','10:20:00',2.96),('8998','2013-05-08','10:25:00',2.98),('8998','2013-05-08','10:30:00',3),('8998','2013-05-08','10:35:00',3.01),('8998','2013-05-08','10:40:00',3.03),('8998','2013-05-08','10:45:00',3.04),('8998','2013-05-08','10:50:00',3.04),('8998','2013-05-08','10:55:00',3.05),('8998','2013-05-08','11:00:00',3.06),('8998','2013-05-08','11:05:00',3.07),('8998','2013-05-08','11:10:00',3.09),('8998','2013-05-08','11:15:00',3.08),('8998','2013-05-08','11:20:00',3.08),('8998','2013-05-08','11:25:00',3.06),('8998','2013-05-08','11:30:00',3.08),('8998','2013-05-08','11:35:00',3.07),('8998','2013-05-08','11:40:00',3.05),('8998','2013-05-08','11:45:00',3.04),('8998','2013-05-08','11:50:00',3.04),('8998','2013-05-08','11:55:00',3.05),('8998','2013-05-08','12:00:00',3.05),('8998','2013-05-08','12:05:00',3.04),('8998','2013-05-08','12:10:00',3.06),('8998','2013-05-08','12:15:00',3.03),('8998','2013-05-08','12:20:00',3.01),('8998','2013-05-08','12:25:00',3.01),('8998','2013-05-08','12:30:00',3.01),('8998','2013-05-08','12:35:00',2.79),('8998','2013-05-08','12:40:00',3.03),('8998','2013-05-08','12:45:00',3),('8998','2013-05-08','12:50:00',3.01),('8998','2013-05-08','12:55:00',2.96),('8998','2013-05-08','13:00:00',2.91),('8998','2013-05-08','13:05:00',2.88),('8998','2013-05-08','13:10:00',2.89),('8998','2013-05-08','13:15:00',2.89),('8998','2013-05-08','13:20:00',2.89),('8998','2013-05-08','13:25:00',2.86),('8998','2013-05-08','13:30:00',2.84),('8998','2013-05-08','13:35:00',2.81),('8998','2013-05-08','13:40:00',2.81),('8998','2013-05-08','13:45:00',2.83),('8998','2013-05-08','13:50:00',2.77),('8998','2013-05-08','13:55:00',2.69),('8998','2013-05-08','14:00:00',2.05),('8998','2013-05-08','14:05:00',2.57),('8998','2013-05-08','14:10:00',1.92),('8998','2013-05-08','14:15:00',1.87),('8998','2013-05-08','14:20:00',2.37),('8998','2013-05-08','14:25:00',2.01),('8998','2013-05-08','14:30:00',2.25),('8998','2013-05-08','14:35:00',2.42),('8998','2013-05-08','14:40:00',2.39),('8998','2013-05-08','14:45:00',2.37),('8998','2013-05-08','14:50:00',2.3),('8998','2013-05-08','14:55:00',2.07),('8998','2013-05-08','15:00:00',2.28),('8998','2013-05-08','15:05:00',2.2),('8998','2013-05-08','15:10:00',2.16),('8998','2013-05-08','15:15:00',2.09),('8998','2013-05-08','15:20:00',2.01),('8998','2013-05-08','15:25:00',1.95),('8998','2013-05-08','15:30:00',1.92),('8998','2013-05-08','15:35:00',1.88),('8998','2013-05-08','15:40:00',1.82),('8998','2013-05-08','15:45:00',1.77),('8998','2013-05-08','15:50:00',1.71),('8998','2013-05-08','15:55:00',1.66),('8998','2013-05-08','16:00:00',1.59),('8998','2013-05-08','16:05:00',1.53),('8998','2013-05-08','16:10:00',1.48),('8998','2013-05-08','16:15:00',1.42),('8998','2013-05-08','16:20:00',1.36),('8998','2013-05-08','16:25:00',1.29),('8998','2013-05-08','16:30:00',1.24),('8998','2013-05-08','16:35:00',1.18),('8998','2013-05-08','16:40:00',1.13),('8998','2013-05-08','16:45:00',1.06),('8998','2013-05-08','16:50:00',1),('8998','2013-05-07','08:05:00',1.33),('8998','2013-05-07','08:10:00',1.65),('8998','2013-05-07','08:15:00',1.61),('8998','2013-05-07','08:20:00',1.61),('8998','2013-05-07','08:25:00',1.56),('8998','2013-05-07','08:30:00',1.57),('8998','2013-05-07','08:35:00',1.69),('8998','2013-05-07','08:40:00',1.37),('8998','2013-05-07','08:45:00',1.9),('8998','2013-05-07','08:50:00',2.28),('8998','2013-05-07','08:55:00',2.51),('8998','2013-05-07','09:00:00',2.44),('8998','2013-05-07','09:05:00',2.65),('8998','2013-05-07','09:10:00',2.56),('8998','2013-05-07','09:15:00',1.73),('8998','2013-05-07','09:20:00',1.97),('8998','2013-05-07','09:25:00',1.2),('8998','2013-05-07','09:40:00',1.67),('8998','2013-05-07','09:45:00',1.71),('8998','2013-05-07','09:50:00',1.08),('8998','2013-05-07','10:05:00',1.25),('8998','2013-05-07','10:10:00',2.92),('8998','2013-05-07','10:15:00',1.68),('8998','2013-05-07','11:05:00',3.64),('8998','2013-05-07','11:10:00',3.45),('8998','2013-05-07','11:15:00',3.34),('8998','2013-05-07','11:20:00',3.19),('8998','2013-05-07','11:25:00',3.22),('8998','2013-05-07','11:30:00',3.33),('8998','2013-05-07','11:35:00',3.13),('8998','2013-05-07','11:40:00',2.65),('8998','2013-05-07','11:45:00',1.57),('8998','2013-05-07','11:50:00',1.12),('8998','2013-05-07','11:55:00',1.16),('8998','2013-05-07','12:00:00',3),('8998','2013-05-07','12:05:00',2.45),('8998','2013-05-07','12:20:00',1.79),('8998','2013-05-07','12:25:00',3.56),('8998','2013-05-07','12:30:00',1.4),('8998','2013-05-07','12:45:00',1.25),('8998','2013-05-07','12:50:00',1.01),('8998','2013-05-07','12:55:00',1.74),('8998','2013-05-07','13:00:00',2.68),('8998','2013-05-07','13:05:00',3.62),('8998','2013-05-07','13:10:00',3.56),('8998','2013-05-07','13:15:00',2.19),('8998','2013-05-07','13:45:00',3.34),('8998','2013-05-07','13:50:00',3.18),('8998','2013-05-07','13:55:00',2.72),('8998','2013-05-07','14:00:00',2.21),('8998','2013-05-07','14:05:00',1.8),('8998','2013-05-07','14:10:00',2.07),('8998','2013-05-07','14:20:00',1),('8998','2013-05-07','14:30:00',1.16),('8998','2013-05-07','14:35:00',1.14),('8998','2013-05-07','14:40:00',2.89),('8998','2013-05-07','14:45:00',1.91),('8998','2013-05-07','14:50:00',2.09),('8998','2013-05-07','14:55:00',2.58),('8998','2013-05-07','15:00:00',2.28),('8998','2013-05-07','15:05:00',2.28),('8998','2013-05-07','15:10:00',2.02),('8998','2013-05-07','15:15:00',2.28),('8998','2013-05-07','15:20:00',2.17),('8998','2013-05-07','15:25:00',2.12),('8998','2013-05-07','15:30:00',2.08),('8998','2013-05-07','15:35:00',1.96),('8998','2013-05-07','15:40:00',1.9),('8998','2013-05-07','15:45:00',1.84),('8998','2013-05-07','15:50:00',1.78),('8998','2013-05-07','15:55:00',1.74),('8998','2013-05-07','16:00:00',1.7),('8998','2013-05-07','16:05:00',1.66),('8998','2013-05-07','16:10:00',1.62),('8998','2013-05-07','16:15:00',1.56),('8998','2013-05-07','16:20:00',1.47),('8998','2013-05-07','16:25:00',1.36),('8998','2013-05-07','16:30:00',1.44),('8998','2013-05-07','16:35:00',1.4),('8998','2013-05-07','16:40:00',1.37),('8998','2013-05-07','16:50:00',1.13),('8998','2013-05-07','16:55:00',1.25),('8998','2013-05-07','17:00:00',1.31),('8998','2013-05-07','17:05:00',1.14),('8998','2013-05-07','17:10:00',1.16),('8998','2013-05-07','17:15:00',1.07),('8998','2013-05-06','07:35:00',1.15),('8998','2013-05-06','07:40:00',1.29),('8998','2013-05-06','07:45:00',1.29),('8998','2013-05-06','07:50:00',1.27),('8998','2013-05-06','07:55:00',1.3),('8998','2013-05-06','08:00:00',1.34),('8998','2013-05-06','08:05:00',1.43),('8998','2013-05-06','08:10:00',1.46),('8998','2013-05-06','08:15:00',1.45),('8998','2013-05-06','08:20:00',1.49),('8998','2013-05-06','08:25:00',1.49),('8998','2013-05-06','08:30:00',1.93),('8998','2013-05-06','08:35:00',2.03),('8998','2013-05-06','08:40:00',2),('8998','2013-05-06','08:45:00',1.96),('8998','2013-05-06','08:50:00',1.8),('8998','2013-05-06','08:55:00',2.05),('8998','2013-05-06','09:00:00',2.43),('8998','2013-05-06','09:05:00',2.57),('8998','2013-05-06','09:10:00',1.84),('8998','2013-05-06','09:15:00',2.11),('8998','2013-05-06','09:20:00',1.53),('8998','2013-05-06','09:35:00',1.82),('8998','2013-05-06','09:40:00',1.71),('8998','2013-05-06','09:45:00',1.31),('8998','2013-05-06','09:50:00',2),('8998','2013-05-06','10:00:00',1.12),('8998','2013-05-06','11:20:00',2.39),('8998','2013-05-06','11:25:00',2.32),('8998','2013-05-06','11:30:00',1.28),('8998','2013-05-06','12:05:00',1.54),('8998','2013-05-06','12:15:00',2.87),('8998','2013-05-06','12:25:00',1.61),('8998','2013-05-06','12:30:00',3.69),('8998','2013-05-06','12:35:00',1.01),('8998','2013-05-06','13:30:00',1.01),('8998','2013-05-06','13:40:00',2.61),('8998','2013-05-06','13:45:00',3.02),('8998','2013-05-06','13:50:00',3.28),('8998','2013-05-06','13:55:00',3.11),('8998','2013-05-06','14:00:00',3),('8998','2013-05-06','14:05:00',2.87),('8998','2013-05-06','14:10:00',2.85),('8998','2013-05-06','14:15:00',2.86),('8998','2013-05-06','14:20:00',2.79),('8998','2013-05-06','14:25:00',1.69),('8998','2013-05-06','14:30:00',2.7),('8998','2013-05-06','14:35:00',1.96),('8998','2013-05-06','14:40:00',3.03),('8998','2013-05-06','14:45:00',2.43),('8998','2013-05-06','14:50:00',2.24),('8998','2013-05-06','14:55:00',2.74),('8998','2013-05-06','15:00:00',2.03),('8998','2013-05-06','15:05:00',2.61),('8998','2013-05-06','15:10:00',2),('8998','2013-05-06','15:15:00',2.18),('8998','2013-05-06','15:20:00',1.93),('8998','2013-05-06','15:25:00',1.36),('8998','2013-05-06','15:30:00',1.29),('8998','2013-05-06','15:35:00',1.78),('8998','2013-05-06','15:40:00',1.34),('8998','2013-05-06','15:45:00',1.59),('8998','2013-05-06','15:50:00',1.09),('8998','2013-05-06','15:55:00',1.15),('8998','2013-05-06','16:00:00',1.86),('8998','2013-05-06','16:05:00',1.56),('8998','2013-05-06','16:15:00',1.13),('8998','2013-05-06','16:20:00',2.24),('8998','2013-05-06','16:25:00',2.08),('8998','2013-05-06','16:30:00',1.89),('8998','2013-05-06','16:35:00',1.79),('8998','2013-05-06','16:40:00',1.8),('8998','2013-05-06','16:45:00',1.37),('8998','2013-05-06','16:50:00',1.4),('8998','2013-05-06','16:55:00',1.32),('8998','2013-05-06','17:00:00',1.35),('8998','2013-05-06','17:05:00',1.3),('8998','2013-05-06','17:10:00',1.08),('8998','2013-05-05','08:30:00',1.07),('8998','2013-05-05','08:55:00',1.22),('8998','2013-05-05','09:00:00',1.49),('8998','2013-05-05','09:10:00',1.23),('8998','2013-05-05','09:15:00',1.07),('8998','2013-05-05','10:00:00',1.22),('8998','2013-05-05','10:15:00',1.07),('8998','2013-05-05','10:20:00',1.42),('8998','2013-05-05','10:25:00',1.11),('8998','2013-05-05','10:30:00',1.18),('8998','2013-05-05','10:35:00',1.16),('8998','2013-05-05','10:40:00',1.17),('8998','2013-05-05','10:45:00',1.87),('8998','2013-05-05','10:50:00',1.92),('8998','2013-05-05','10:55:00',1.5),('8998','2013-05-05','11:00:00',1.52),('8998','2013-05-05','11:05:00',1.5),('8998','2013-05-05','11:10:00',1.47),('8998','2013-05-05','11:15:00',1.19),('8998','2013-05-05','11:20:00',1.55),('8998','2013-05-05','11:25:00',1.56),('8998','2013-05-05','11:30:00',1.6),('8998','2013-05-05','11:35:00',1.06),('8998','2013-05-05','11:40:00',2.27),('8998','2013-05-05','11:45:00',2.87),('8998','2013-05-05','11:50:00',2.43),('8998','2013-05-05','11:55:00',1.26),('8998','2013-05-05','12:00:00',1.17),('8998','2013-05-05','12:05:00',1.39),('8998','2013-05-05','12:10:00',3.26),('8998','2013-05-05','12:15:00',2.29),('8998','2013-05-05','12:20:00',1.87),('8998','2013-05-05','12:25:00',2.11),('8998','2013-05-05','12:30:00',2.81),('8998','2013-05-05','12:35:00',2.39),('8998','2013-05-05','12:40:00',2.02),('8998','2013-05-05','12:45:00',1.68),('8998','2013-05-05','12:50:00',1.96),('8998','2013-05-05','12:55:00',3.08),('8998','2013-05-05','13:00:00',1.25),('8998','2013-05-05','13:05:00',2.27),('8998','2013-05-05','13:10:00',2.91),('8998','2013-05-05','13:15:00',2.39),('8998','2013-05-05','13:20:00',2.38),('8998','2013-05-05','13:25:00',1.68),('8998','2013-05-05','13:30:00',2.68),('8998','2013-05-05','13:35:00',1.73),('8998','2013-05-05','13:40:00',2.6),('8998','2013-05-05','13:45:00',3.13),('8998','2013-05-05','13:50:00',2.87),('8998','2013-05-05','13:55:00',2.81),('8998','2013-05-05','14:00:00',1.95),('8998','2013-05-05','14:05:00',3.01),('8998','2013-05-05','14:10:00',1.61),('8998','2013-05-05','14:15:00',2.19),('8998','2013-05-05','14:20:00',2.49),('8998','2013-05-05','14:25:00',1.74),('8998','2013-05-05','14:30:00',2.15),('8998','2013-05-05','14:35:00',2.21),('8998','2013-05-05','14:40:00',1.25),('8998','2013-05-05','14:45:00',2.21),('8998','2013-05-05','14:50:00',1.23),('8998','2013-05-05','14:55:00',2.18),('8998','2013-05-05','15:00:00',2.57),('8998','2013-05-05','15:05:00',1.62),('8998','2013-05-05','15:10:00',2.23),('8998','2013-05-05','15:15:00',1.48),('8998','2013-05-05','15:20:00',1.14),('8998','2013-05-05','15:25:00',1.95),('8998','2013-05-05','15:30:00',1.37),('8998','2013-05-05','15:35:00',1.04),('8998','2013-05-05','15:40:00',1.14),('8998','2013-05-05','15:55:00',1.25),('8998','2013-05-05','16:00:00',1.15),('8998','2013-05-05','16:20:00',1.01),('8998','2013-05-05','16:25:00',1.22),('8998','2013-05-05','16:30:00',1.25),('8998','2013-05-05','16:35:00',1.04),('8998','2013-05-05','16:40:00',1.43),('8998','2013-05-05','16:45:00',1.32),('8998','2013-05-05','16:50:00',1.07),('8998','2013-05-05','16:55:00',1.27),('8998','2013-05-04','07:45:00',1.16),('8998','2013-05-04','07:50:00',1.19),('8998','2013-05-04','07:55:00',1.2),('8998','2013-05-04','08:00:00',1.26),('8998','2013-05-04','08:05:00',1.38),('8998','2013-05-04','08:10:00',1.41),('8998','2013-05-04','08:15:00',1.47),('8998','2013-05-04','08:20:00',1.61),('8998','2013-05-04','08:25:00',1.88),('8998','2013-05-04','08:30:00',1.95),('8998','2013-05-04','08:35:00',1.75),('8998','2013-05-04','08:40:00',1.84),('8998','2013-05-04','08:45:00',1.61),('8998','2013-05-04','08:50:00',1.21),('8998','2013-05-04','08:55:00',1.06),('8998','2013-05-04','09:00:00',1.14),('8998','2013-05-04','09:05:00',1.22),('8998','2013-05-04','09:10:00',1.48),('8998','2013-05-04','09:15:00',1.55),('8998','2013-05-04','09:20:00',1.46),('8998','2013-05-04','09:25:00',1.55),('8998','2013-05-04','09:30:00',1.75),('8998','2013-05-04','09:35:00',1.19),('8998','2013-05-04','09:40:00',1.97),('8998','2013-05-04','09:45:00',2.56),('8998','2013-05-04','09:50:00',1.76),('8998','2013-05-04','09:55:00',2.99),('8998','2013-05-04','10:00:00',2.01),('8998','2013-05-04','10:05:00',1.96),('8998','2013-05-04','10:10:00',1.82),('8998','2013-05-04','10:15:00',1.48),('8998','2013-05-04','10:20:00',2.64),('8998','2013-05-04','10:25:00',1.92),('8998','2013-05-04','10:30:00',2),('8998','2013-05-04','10:35:00',1.87),('8998','2013-05-04','10:40:00',1.83),('8998','2013-05-04','10:45:00',1.93),('8998','2013-05-04','10:50:00',1.48),('8998','2013-05-04','10:55:00',1.31),('8998','2013-05-04','11:00:00',1.15),('8998','2013-05-04','11:05:00',1.38),('8998','2013-05-04','11:10:00',1.35),('8998','2013-05-04','11:15:00',1.31),('8998','2013-05-04','11:20:00',1.73),('8998','2013-05-04','11:25:00',2.57),('8998','2013-05-04','11:30:00',2.06),('8998','2013-05-04','11:35:00',2.77),('8998','2013-05-04','11:40:00',2.38),('8998','2013-05-04','11:45:00',2.22),('8998','2013-05-04','11:50:00',2),('8998','2013-05-04','11:55:00',2.64),('8998','2013-05-04','12:00:00',1.86),('8998','2013-05-04','12:05:00',1.98),('8998','2013-05-04','12:10:00',1.81),('8998','2013-05-04','12:15:00',2.03),('8998','2013-05-04','12:20:00',2.21),('8998','2013-05-04','12:25:00',2.49),('8998','2013-05-04','12:30:00',2.64),('8998','2013-05-04','12:35:00',2.81),('8998','2013-05-04','12:40:00',2.53),('8998','2013-05-04','12:45:00',2.48),('8998','2013-05-04','12:50:00',2.34),('8998','2013-05-04','12:55:00',2.62),('8998','2013-05-04','13:00:00',2.79),('8998','2013-05-04','13:05:00',2.96),('8998','2013-05-04','13:10:00',2.89),('8998','2013-05-04','13:15:00',3.03),('8998','2013-05-04','13:20:00',2.48),('8998','2013-05-04','13:25:00',1.45),('8998','2013-05-04','13:30:00',1.03),('8998','2013-05-04','13:35:00',2.52),('8998','2013-05-04','13:40:00',2.8),('8998','2013-05-04','13:45:00',2.82),('8998','2013-05-04','13:50:00',2.77),('8998','2013-05-04','13:55:00',2.76),('8998','2013-05-04','14:00:00',2.81),('8998','2013-05-04','14:05:00',2.89),('8998','2013-05-04','14:10:00',2.15),('8998','2013-05-04','14:15:00',1.89),('8998','2013-05-04','14:20:00',2.46),('8998','2013-05-04','14:25:00',2.43),('8998','2013-05-04','14:30:00',2.33),('8998','2013-05-04','14:35:00',2.28),('8998','2013-05-04','14:40:00',2.23),('8998','2013-05-04','14:45:00',2.21),('8998','2013-05-04','14:50:00',2.16),('8998','2013-05-04','14:55:00',2.12),('8998','2013-05-04','15:00:00',2.08),('8998','2013-05-04','15:05:00',2.04),('8998','2013-05-04','15:10:00',1.98),('8998','2013-05-04','15:15:00',1.94),('8998','2013-05-04','15:20:00',1.9),('8998','2013-05-04','15:25:00',1.85),('8998','2013-05-04','15:30:00',1.81),('8998','2013-05-04','15:35:00',1.76),('8998','2013-05-04','15:40:00',1.7),('8998','2013-05-04','15:45:00',1.65),('8998','2013-05-04','15:50:00',1.61),('8998','2013-05-04','15:55:00',1.55),('8998','2013-05-04','16:00:00',1.5),('8998','2013-05-04','16:05:00',1.45),('8998','2013-05-04','16:10:00',1.4),('8998','2013-05-04','16:15:00',1.35),('8998','2013-05-04','16:20:00',1.29),('8998','2013-05-04','16:25:00',1.24),('8998','2013-05-04','16:30:00',1.18),('8998','2013-05-04','16:35:00',1.12),('8998','2013-05-04','16:40:00',1.07),('8998','2013-05-04','16:45:00',1.01),('8998','2013-05-03','07:40:00',1.14),('8998','2013-05-03','07:45:00',1.08),('8998','2013-05-03','07:55:00',1.19),('8998','2013-05-03','08:00:00',1.27),('8998','2013-05-03','08:05:00',1.33),('8998','2013-05-03','08:10:00',1.37),('8998','2013-05-03','08:15:00',1.4),('8998','2013-05-03','08:20:00',1.41),('8998','2013-05-03','08:25:00',1.45),('8998','2013-05-03','08:30:00',1.51),('8998','2013-05-03','08:35:00',1.53),('8998','2013-05-03','08:40:00',1.58),('8998','2013-05-03','08:45:00',1.62),('8998','2013-05-03','08:50:00',1.63),('8998','2013-05-03','08:55:00',1.68),('8998','2013-05-03','09:00:00',1.71),('8998','2013-05-03','09:05:00',1.72),('8998','2013-05-03','09:10:00',1.82),('8998','2013-05-03','09:15:00',1.85),('8998','2013-05-03','09:20:00',1.99),('8998','2013-05-03','09:25:00',2.18),('8998','2013-05-03','09:30:00',2.34),('8998','2013-05-03','09:35:00',2.47),('8998','2013-05-03','09:40:00',2.52),('8998','2013-05-03','09:45:00',2.58),('8998','2013-05-03','09:50:00',2.62),('8998','2013-05-03','09:55:00',2.64),('8998','2013-05-03','10:00:00',2.69),('8998','2013-05-03','10:05:00',2.7),('8998','2013-05-03','10:10:00',2.72),('8998','2013-05-03','10:15:00',2.75),('8998','2013-05-03','10:20:00',2.8),('8998','2013-05-03','10:25:00',2.8),('8998','2013-05-03','10:30:00',2.82),('8998','2013-05-03','10:35:00',2.83),('8998','2013-05-03','10:40:00',2.8),('8998','2013-05-03','10:45:00',2.78),('8998','2013-05-03','10:50:00',2.75),('8998','2013-05-03','10:55:00',2.72),('8998','2013-05-03','11:00:00',2.71),('8998','2013-05-03','11:05:00',2.71),('8998','2013-05-03','11:10:00',2.58),('8998','2013-05-03','11:15:00',2.43),('8998','2013-05-03','11:20:00',2.59),('8998','2013-05-03','11:25:00',2.7),('8998','2013-05-03','11:30:00',2.54),('8998','2013-05-03','11:35:00',2.64),('8998','2013-05-03','11:40:00',2.53),('8998','2013-05-03','11:45:00',2.56),('8998','2013-05-03','11:50:00',2.58),('8998','2013-05-03','11:55:00',2.54),('8998','2013-05-03','12:00:00',2.49),('8998','2013-05-03','12:05:00',2.58),('8998','2013-05-03','12:10:00',2.6),('8998','2013-05-03','12:15:00',2.62),('8998','2013-05-03','12:20:00',2.66),('8998','2013-05-03','12:25:00',2.72),('8998','2013-05-03','12:30:00',2.71),('8998','2013-05-03','12:35:00',2.74),('8998','2013-05-03','12:40:00',2.7),('8998','2013-05-03','12:45:00',2.69),('8998','2013-05-03','12:50:00',2.6),('8998','2013-05-03','12:55:00',2.54),('8998','2013-05-03','13:00:00',2.49),('8998','2013-05-03','13:05:00',2.29),('8998','2013-05-03','13:10:00',2.33),('8998','2013-05-03','13:15:00',2.67),('8998','2013-05-03','13:20:00',2.7),('8998','2013-05-03','13:25:00',2.54),('8998','2013-05-03','13:30:00',2.5),('8998','2013-05-03','13:35:00',2.39),('8998','2013-05-03','13:40:00',2.43),('8998','2013-05-03','13:45:00',2.4),('8998','2013-05-03','13:50:00',2.09),('8998','2013-05-03','13:55:00',2.22),('8998','2013-05-03','14:00:00',2.26),('8998','2013-05-03','14:05:00',2.32),('8998','2013-05-03','14:10:00',2.18),('8998','2013-05-03','14:15:00',2.19),('8998','2013-05-03','14:20:00',2.25),('8998','2013-05-03','14:25:00',2.01),('8998','2013-05-03','14:30:00',2.11),('8998','2013-05-03','14:35:00',1.96),('8998','2013-05-03','14:40:00',2.02),('8998','2013-05-03','14:45:00',1.99),('8998','2013-05-03','14:50:00',1.85),('8998','2013-05-03','14:55:00',1.91),('8998','2013-05-03','15:00:00',1.91),('8998','2013-05-03','15:05:00',1.96),('8998','2013-05-03','15:10:00',1.79),('8998','2013-05-03','15:15:00',1.82),('8998','2013-05-03','15:20:00',1.81),('8998','2013-05-03','15:25:00',1.82),('8998','2013-05-03','15:30:00',1.76),('8998','2013-05-03','15:35:00',1.67),('8998','2013-05-03','15:40:00',1.59),('8998','2013-05-03','15:45:00',1.61),('8998','2013-05-03','15:50:00',1.54),('8998','2013-05-03','15:55:00',1.49),('8998','2013-05-03','16:00:00',1.43),('8998','2013-05-03','16:05:00',1.38),('8998','2013-05-03','16:10:00',1.33),('8998','2013-05-03','16:15:00',1.28),('8998','2013-05-03','16:20:00',1.22),('8998','2013-05-03','16:25:00',1.17),('8998','2013-05-03','16:30:00',1.11),('8998','2013-05-03','16:35:00',1.06),('8998','2013-05-03','16:40:00',1),('8998','2013-05-02','08:05:00',1.29),('8998','2013-05-02','08:10:00',1.47),('8998','2013-05-02','08:15:00',1.64),('8998','2013-05-02','08:20:00',1.54),('8998','2013-05-02','08:25:00',1.64),('8998','2013-05-02','08:30:00',1.69),('8998','2013-05-02','08:35:00',1.68),('8998','2013-05-02','08:40:00',1.71),('8998','2013-05-02','08:45:00',1.73),('8998','2013-05-02','08:50:00',1.67),('8998','2013-05-02','08:55:00',1.66),('8998','2013-05-02','09:00:00',1.75),('8998','2013-05-02','09:05:00',1.76),('8998','2013-05-02','09:10:00',1.82),('8998','2013-05-02','09:15:00',1.89),('8998','2013-05-02','09:20:00',2.02),('8998','2013-05-02','09:25:00',2.15),('8998','2013-05-02','09:30:00',2.4),('8998','2013-05-02','09:35:00',2.58),('8998','2013-05-02','09:40:00',2.63),('8998','2013-05-02','09:45:00',2.65),('8998','2013-05-02','09:50:00',2.69),('8998','2013-05-02','09:55:00',2.7),('8998','2013-05-02','10:00:00',2.75),('8998','2013-05-02','10:05:00',2.77),('8998','2013-05-02','10:10:00',2.81),('8998','2013-05-02','10:15:00',2.82),('8998','2013-05-02','10:20:00',2.83),('8998','2013-05-02','10:25:00',2.84),('8998','2013-05-02','10:30:00',2.86),('8998','2013-05-02','10:35:00',2.86),('8998','2013-05-02','10:40:00',2.85),('8998','2013-05-02','10:45:00',2.89),('8998','2013-05-02','10:50:00',2.9),('8998','2013-05-02','10:55:00',2.91),('8998','2013-05-02','11:00:00',2.92),('8998','2013-05-02','11:05:00',2.93),('8998','2013-05-02','11:10:00',2.94),('8998','2013-05-02','11:15:00',2.93),('8998','2013-05-02','11:20:00',2.95),('8998','2013-05-02','11:25:00',2.96),('8998','2013-05-02','11:30:00',2.94),('8998','2013-05-02','11:35:00',2.95),('8998','2013-05-02','11:40:00',2.95),('8998','2013-05-02','11:45:00',2.93),('8998','2013-05-02','11:50:00',2.95),('8998','2013-05-02','11:55:00',2.94),('8998','2013-05-02','12:00:00',2.93),('8998','2013-05-02','12:05:00',2.9),('8998','2013-05-02','12:10:00',2.92),('8998','2013-05-02','12:15:00',2.93),('8998','2013-05-02','12:20:00',2.92),('8998','2013-05-02','12:25:00',2.91),('8998','2013-05-02','12:30:00',2.89),('8998','2013-05-02','12:35:00',2.85),('8998','2013-05-02','12:40:00',2.82),('8998','2013-05-02','12:45:00',2.81),('8998','2013-05-02','12:50:00',2.81),('8998','2013-05-02','12:55:00',2.84),('8998','2013-05-02','13:00:00',2.81),('8998','2013-05-02','13:05:00',2.77),('8998','2013-05-02','13:10:00',2.75),('8998','2013-05-02','13:15:00',2.72),('8998','2013-05-02','13:20:00',2.73),('8998','2013-05-02','13:25:00',2.7),('8998','2013-05-02','13:30:00',2.66),('8998','2013-05-02','13:35:00',2.61),('8998','2013-05-02','13:40:00',2.49),('8998','2013-05-02','13:45:00',2.48),('8998','2013-05-02','13:50:00',2.46),('8998','2013-05-02','13:55:00',2.47),('8998','2013-05-02','14:00:00',2.43),('8998','2013-05-02','14:05:00',2.29),('8998','2013-05-02','14:10:00',2.3),('8998','2013-05-02','14:15:00',2.23),('8998','2013-05-02','14:20:00',2.27),('8998','2013-05-02','14:25:00',2.25),('8998','2013-05-02','14:30:00',2.24),('8998','2013-05-02','14:35:00',2.23),('8998','2013-05-02','14:40:00',2.14),('8998','2013-05-02','14:45:00',2.09),('8998','2013-05-02','14:50:00',2.06),('8998','2013-05-02','14:55:00',2.02),('8998','2013-05-02','15:00:00',1.98),('8998','2013-05-02','15:05:00',1.95),('8998','2013-05-02','15:10:00',1.94),('8998','2013-05-02','15:15:00',1.91),('8998','2013-05-02','15:20:00',1.86),('8998','2013-05-02','15:25:00',1.81),('8998','2013-05-02','15:30:00',1.77),('8998','2013-05-02','15:35:00',1.73),('8998','2013-05-02','15:40:00',1.67),('8998','2013-05-02','15:45:00',1.62),('8998','2013-05-02','15:50:00',1.56),('8998','2013-05-02','15:55:00',1.5),('8998','2013-05-02','16:00:00',1.47),('8998','2013-05-02','16:05:00',1.41),('8998','2013-05-02','16:10:00',1.36),('8998','2013-05-02','16:15:00',1.3),('8998','2013-05-02','16:20:00',1.23),('8998','2013-05-02','16:25:00',1.17),('8998','2013-05-02','16:30:00',1.15),('8998','2013-05-02','16:35:00',1.1),('8998','2013-05-02','16:40:00',1.04),('8998','2013-05-01','09:00:00',1.61),('8998','2013-05-01','09:05:00',1.52),('8998','2013-05-01','09:25:00',1.19),('8998','2013-05-01','09:30:00',1.43),('8998','2013-05-01','09:35:00',1.74),('8998','2013-05-01','09:40:00',1.13),('8998','2013-05-01','09:45:00',2.08),('8998','2013-05-01','10:05:00',1.1),('8998','2013-05-01','10:10:00',1.15),('8998','2013-05-01','10:15:00',1.17),('8998','2013-05-01','10:20:00',1.18),('8998','2013-05-01','10:25:00',1.43),('8998','2013-05-01','10:30:00',2.47),('8998','2013-05-01','10:35:00',2.17),('8998','2013-05-01','10:40:00',2.93),('8998','2013-05-01','10:45:00',2.27),('8998','2013-05-01','10:50:00',2.65),('8998','2013-05-01','10:55:00',3.09),('8998','2013-05-01','11:00:00',3.14),('8998','2013-05-01','11:05:00',2.99),('8998','2013-05-01','11:10:00',2.24),('8998','2013-05-01','11:15:00',2.18),('8998','2013-05-01','11:20:00',2.04),('8998','2013-05-01','11:25:00',3.06),('8998','2013-05-01','11:30:00',3.06),('8998','2013-05-01','11:35:00',3.04),('8998','2013-05-01','11:40:00',2.95),('8998','2013-05-01','11:45:00',2.93),('8998','2013-05-01','11:50:00',2.91),('8998','2013-05-01','11:55:00',2.89),('8998','2013-05-01','12:00:00',2.87),('8998','2013-05-01','12:05:00',2.83),('8998','2013-05-01','12:10:00',2.79),('8998','2013-05-01','12:15:00',2.8),('8998','2013-05-01','12:20:00',2.81),('8998','2013-05-01','12:25:00',2.78),('8998','2013-05-01','12:30:00',2.79),('8998','2013-05-01','12:35:00',2.83),('8998','2013-05-01','12:40:00',2.85),('8998','2013-05-01','12:45:00',2.86),('8998','2013-05-01','12:50:00',2.84),('8998','2013-05-01','12:55:00',2.83),('8998','2013-05-01','13:00:00',2.84),('8998','2013-05-01','13:05:00',2.82),('8998','2013-05-01','13:10:00',2.83),('8998','2013-05-01','13:15:00',2.83),('8998','2013-05-01','13:20:00',2.81),('8998','2013-05-01','13:25:00',2.78),('8998','2013-05-01','13:30:00',2.75),('8998','2013-05-01','13:35:00',2.72),('8998','2013-05-01','13:40:00',2.69),('8998','2013-05-01','13:45:00',2.66),('8998','2013-05-01','13:50:00',2.63),('8998','2013-05-01','13:55:00',2.61),('8998','2013-05-01','14:00:00',2.57),('8998','2013-05-01','14:05:00',2.52),('8998','2013-05-01','14:10:00',2.48),('8998','2013-05-01','14:15:00',2.46),('8998','2013-05-01','14:20:00',2.42),('8998','2013-05-01','14:25:00',2.37),('8998','2013-05-01','14:30:00',2.33),('8998','2013-05-01','14:35:00',2.3),('8998','2013-05-01','14:40:00',2.26),('8998','2013-05-01','14:45:00',2.23),('8998','2013-05-01','14:50:00',2.19),('8998','2013-05-01','14:55:00',2.15),('8998','2013-05-01','15:00:00',2.1),('8998','2013-05-01','15:05:00',2.04),('8998','2013-05-01','15:10:00',2),('8998','2013-05-01','15:15:00',1.94),('8998','2013-05-01','15:20:00',1.9),('8998','2013-05-01','15:25:00',1.84),('8998','2013-05-01','15:30:00',1.77),('8998','2013-05-01','15:35:00',1.7),('8998','2013-05-01','15:40:00',1.66),('8998','2013-05-01','15:45:00',1.6),('8998','2013-05-01','15:50:00',1.56),('8998','2013-05-01','15:55:00',1.51),('8998','2013-05-01','16:00:00',1.46),('8998','2013-05-01','16:05:00',1.4),('8998','2013-05-01','16:10:00',1.36),('8998','2013-05-01','16:15:00',1.3),('8998','2013-05-01','16:20:00',1.25),('8998','2013-05-01','16:25:00',1.19),('8998','2013-05-01','16:30:00',1.13),('8998','2013-05-01','16:35:00',1.07),('8998','2013-05-01','16:40:00',1.02),('8998','2014-03-29','08:25:00',1.01),('8998','2014-03-29','08:30:00',1.04),('8998','2014-03-29','08:35:00',1.09),('8998','2014-03-29','08:40:00',1.08),('8998','2014-03-29','08:45:00',1.08),('8998','2014-03-29','08:50:00',1.1),('8998','2014-03-29','08:55:00',1.12),('8998','2014-03-29','09:00:00',1.21),('8998','2014-03-29','09:05:00',1.31),('8998','2014-03-29','09:10:00',1.36),('8998','2014-03-29','09:15:00',1.27),('8998','2014-03-29','09:20:00',1.43),('8998','2014-03-29','09:25:00',1.62),('8998','2014-03-29','09:30:00',1.77),('8998','2014-03-29','09:35:00',2.02),('8998','2014-03-29','09:40:00',2.05),('8998','2014-03-29','09:45:00',2.11),('8998','2014-03-29','09:50:00',2.11),('8998','2014-03-29','09:55:00',2.13),('8998','2014-03-29','10:00:00',1.99),('8998','2014-03-29','10:05:00',2.26),('8998','2014-03-29','10:10:00',2.38),('8998','2014-03-29','10:15:00',2.37),('8998','2014-03-29','10:20:00',2.35),('8998','2014-03-29','10:25:00',2.34),('8998','2014-03-29','10:30:00',2.45),('8998','2014-03-29','10:35:00',2.52),('8998','2014-03-29','10:40:00',2.52),('8998','2014-03-29','10:45:00',2.52),('8998','2014-03-29','10:50:00',2.5),('8998','2014-03-29','10:55:00',2.53),('8998','2014-03-29','11:00:00',2.52),('8998','2014-03-29','11:05:00',2.49),('8998','2014-03-29','11:10:00',2.48),('8998','2014-03-29','11:15:00',2.42),('8998','2014-03-29','11:20:00',2.28),('8998','2014-03-29','11:25:00',2.36),('8998','2014-03-29','11:30:00',2.58),('8998','2014-03-29','11:35:00',2.58),('8998','2014-03-29','11:40:00',2.65),('8998','2014-03-29','11:45:00',2.72),('8998','2014-03-29','11:50:00',2.76),('8998','2014-03-29','11:55:00',2.79),('8998','2014-03-29','12:00:00',2.79),('8998','2014-03-29','12:05:00',2.89),('8998','2014-03-29','12:10:00',2.92),('8998','2014-03-29','12:15:00',2.96),('8998','2014-03-29','12:20:00',2.93),('8998','2014-03-29','12:25:00',2.88),('8998','2014-03-29','12:30:00',2.78),('8998','2014-03-29','12:35:00',2.57),('8998','2014-03-29','12:40:00',2.7),('8998','2014-03-29','12:45:00',2.68),('8998','2014-03-29','12:50:00',2.69),('8998','2014-03-29','12:55:00',2.65),('8998','2014-03-29','13:00:00',2.7),('8998','2014-03-29','13:05:00',2.74),('8998','2014-03-29','13:10:00',2.72),('8998','2014-03-29','13:15:00',2.71),('8998','2014-03-29','13:20:00',2.66),('8998','2014-03-29','13:25:00',2.65),('8998','2014-03-29','13:30:00',2.65),('8998','2014-03-29','13:35:00',2.66),('8998','2014-03-29','13:40:00',2.6),('8998','2014-03-29','13:45:00',2.57),('8998','2014-03-29','13:50:00',2.54),('8998','2014-03-29','13:55:00',2.48),('8998','2014-03-29','14:00:00',2.38),('8998','2014-03-29','14:05:00',2.37),('8998','2014-03-29','14:10:00',2.32),('8998','2014-03-29','14:15:00',2.24),('8998','2014-03-29','14:20:00',2.25),('8998','2014-03-29','14:25:00',2.25),('8998','2014-03-29','14:30:00',2.26),('8998','2014-03-29','14:35:00',2.22),('8998','2014-03-29','14:40:00',2.04),('8998','2014-03-29','14:45:00',1.89),('8998','2014-03-29','14:50:00',1.71),('8998','2014-03-29','14:55:00',1.45),('8998','2014-03-29','15:00:00',1.06),('8998','2014-03-29','15:25:00',1.25),('8998','2014-03-29','15:30:00',1.53),('8998','2014-03-29','15:35:00',1.48),('8998','2014-03-29','15:40:00',1.44),('8998','2014-03-29','15:45:00',1.46),('8998','2014-03-29','15:50:00',1.42),('8998','2014-03-29','15:55:00',1.36),('8998','2014-03-29','16:00:00',1.26),('8998','2014-03-29','16:05:00',1.1),('8998','2014-03-29','16:10:00',1.02),('8998','2014-03-29','16:20:00',1.06),('8998','2014-03-29','16:25:00',1.04),('8998','2013-04-30','07:50:00',1.04),('8998','2013-04-30','07:55:00',1.11),('8998','2013-04-30','08:00:00',1.17),('8998','2013-04-30','08:05:00',1.24),('8998','2013-04-30','08:10:00',1.26),('8998','2013-04-30','08:15:00',1.32),('8998','2013-04-30','08:20:00',1.38),('8998','2013-04-30','08:25:00',1.46),('8998','2013-04-30','08:30:00',1.5),('8998','2013-04-30','08:35:00',1.56),('8998','2013-04-30','08:40:00',1.6),('8998','2013-04-30','08:45:00',1.62),('8998','2013-04-30','08:50:00',1.69),('8998','2013-04-30','08:55:00',1.73),('8998','2013-04-30','09:00:00',1.76),('8998','2013-04-30','09:05:00',1.79),('8998','2013-04-30','09:10:00',1.84),('8998','2013-04-30','09:15:00',1.9),('8998','2013-04-30','09:20:00',2),('8998','2013-04-30','09:25:00',2.02),('8998','2013-04-30','09:30:00',2.16),('8998','2013-04-30','09:35:00',2.26),('8998','2013-04-30','09:40:00',2.32),('8998','2013-04-30','09:45:00',2.37),('8998','2013-04-30','09:50:00',2.4),('8998','2013-04-30','09:55:00',2.42),('8998','2013-04-30','10:00:00',2.44),('8998','2013-04-30','10:05:00',2.44),('8998','2013-04-30','10:10:00',2.49),('8998','2013-04-30','10:15:00',2.55),('8998','2013-04-30','10:20:00',2.58),('8998','2013-04-30','10:25:00',2.6),('8998','2013-04-30','10:30:00',2.62),('8998','2013-04-30','10:35:00',2.62),('8998','2013-04-30','10:40:00',2.69),('8998','2013-04-30','10:45:00',2.81),('8998','2013-04-30','10:50:00',2.82),('8998','2013-04-30','10:55:00',2.8),('8998','2013-04-30','11:00:00',2.79),('8998','2013-04-30','11:05:00',2.82),('8998','2013-04-30','11:10:00',2.8),('8998','2013-04-30','11:15:00',2.61),('8998','2013-04-30','11:20:00',2.6),('8998','2013-04-30','11:25:00',2.52),('8998','2013-04-30','11:30:00',2.47),('8998','2013-04-30','11:35:00',2.55),('8998','2013-04-30','11:40:00',2.1),('8998','2013-04-30','11:45:00',1.93),('8998','2013-04-30','11:50:00',2.35),('8998','2013-04-30','11:55:00',2.88),('8998','2013-04-30','12:00:00',2.83),('8998','2013-04-30','12:05:00',2.78),('8998','2013-04-30','12:10:00',2.76),('8998','2013-04-30','12:15:00',2.73),('8998','2013-04-30','12:20:00',2.72),('8998','2013-04-30','12:25:00',2.74),('8998','2013-04-30','12:30:00',2.73),('8998','2013-04-30','12:35:00',2.74),('8998','2013-04-30','12:40:00',2.75),('8998','2013-04-30','12:45:00',2.61),('8998','2013-04-30','12:50:00',2.11),('8998','2013-04-30','12:55:00',1),('8998','2013-04-30','13:00:00',1),('8998','2013-04-30','13:05:00',1.16),('8998','2013-04-30','13:10:00',1.42),('8998','2013-04-30','13:15:00',2.5),('8998','2013-04-30','13:20:00',3.22),('8998','2013-04-30','13:25:00',2.61),('8998','2013-04-30','13:30:00',1.71),('8998','2013-04-30','13:35:00',2.21),('8998','2013-04-30','13:40:00',2.54),('8998','2013-04-30','13:45:00',2.94),('8998','2013-04-30','13:50:00',2.7),('8998','2013-04-30','13:55:00',2.58),('8998','2013-04-30','14:00:00',2.49),('8998','2013-04-30','14:05:00',2.36),('8998','2013-04-30','14:10:00',2.32),('8998','2013-04-30','14:15:00',2),('8998','2013-04-30','14:20:00',2.37),('8998','2013-04-30','14:25:00',2.36),('8998','2013-04-30','14:30:00',2.35),('8998','2013-04-30','14:35:00',2.27),('8998','2013-04-30','14:40:00',1.98),('8998','2013-04-30','14:45:00',2.11),('8998','2013-04-30','14:50:00',1.78),('8998','2013-04-30','14:55:00',1.66),('8998','2013-04-30','15:00:00',1.68),('8998','2013-04-30','15:05:00',1.96),('8998','2013-04-30','15:10:00',1.99),('8998','2013-04-30','15:15:00',1.9),('8998','2013-04-30','15:20:00',1.79),('8998','2013-04-30','15:25:00',1.86),('8998','2013-04-30','15:30:00',1.6),('8998','2013-04-30','15:35:00',1.35),('8998','2013-04-30','15:40:00',1.35),('8998','2013-04-30','15:45:00',1.34),('8998','2013-04-30','15:50:00',1.08),('8998','2013-04-30','15:55:00',1.01),('8998','2013-04-30','16:00:00',1.2),('8998','2013-04-30','16:05:00',1.2),('8998','2013-04-30','16:10:00',1.07),('8998','2013-04-29','08:55:00',1.26),('8998','2013-04-29','09:00:00',1.54),('8998','2013-04-29','09:05:00',1.35),('8998','2013-04-29','09:10:00',1.77),('8998','2013-04-29','09:15:00',2.12),('8998','2013-04-29','09:20:00',2.12),('8998','2013-04-29','09:25:00',2.27),('8998','2013-04-29','09:30:00',2.36),('8998','2013-04-29','09:35:00',2.03),('8998','2013-04-29','09:40:00',1.44),('8998','2013-04-29','09:45:00',1.59),('8998','2013-04-29','09:50:00',2.21),('8998','2013-04-29','09:55:00',2.41),('8998','2013-04-29','10:00:00',2.71),('8998','2013-04-29','10:05:00',2.8),('8998','2013-04-29','10:10:00',2.24),('8998','2013-04-29','10:15:00',1.93),('8998','2013-04-29','10:20:00',1.73),('8998','2013-04-29','10:25:00',1.9),('8998','2013-04-29','10:30:00',1.57),('8998','2013-04-29','10:35:00',1.48),('8998','2013-04-29','10:40:00',1.23),('8998','2013-04-29','10:50:00',1),('8998','2013-04-29','10:55:00',1.09),('8998','2013-04-29','11:00:00',1.08),('8998','2013-04-29','11:05:00',1.2),('8998','2013-04-29','11:10:00',1.25),('8998','2013-04-29','11:15:00',1.29),('8998','2013-04-29','11:20:00',1.54),('8998','2013-04-29','11:25:00',1.41),('8998','2013-04-29','11:30:00',1.36),('8998','2013-04-29','11:35:00',1.43),('8998','2013-04-29','11:40:00',1.47),('8998','2013-04-29','11:45:00',1.25),('8998','2013-04-29','11:50:00',1.28),('8998','2013-04-29','11:55:00',1.29),('8998','2013-04-29','12:00:00',1.29),('8998','2013-04-29','12:05:00',1.29),('8998','2013-04-29','12:10:00',1.28),('8998','2013-04-29','12:15:00',1.19),('8998','2013-04-29','12:20:00',1.04),('8998','2013-04-29','12:35:00',1.51),('8998','2013-04-29','12:40:00',2.97),('8998','2013-04-29','12:45:00',3.27),('8998','2013-04-29','12:50:00',3.1),('8998','2013-04-29','12:55:00',2.79),('8998','2013-04-29','13:00:00',2.86),('8998','2013-04-29','13:05:00',2.79),('8998','2013-04-29','13:10:00',2.84),('8998','2013-04-29','13:15:00',2.76),('8998','2013-04-29','13:20:00',2.7),('8998','2013-04-29','13:25:00',2.65),('8998','2013-04-29','13:30:00',2.6),('8998','2013-04-29','13:35:00',2.59),('8998','2013-04-29','13:40:00',2.53),('8998','2013-04-29','13:45:00',2.49),('8998','2013-04-29','13:50:00',2.45),('8998','2013-04-29','13:55:00',2.41),('8998','2013-04-29','14:00:00',2.38),('8998','2013-04-29','14:05:00',2.35),('8998','2013-04-29','14:10:00',2.31),('8998','2013-04-29','14:15:00',2.28),('8998','2013-04-29','14:20:00',2.26),('8998','2013-04-29','14:25:00',2.23),('8998','2013-04-29','14:30:00',2.18),('8998','2013-04-29','14:35:00',2.15),('8998','2013-04-29','14:40:00',2.11),('8998','2013-04-29','14:45:00',2.07),('8998','2013-04-29','14:50:00',2.02),('8998','2013-04-29','14:55:00',1.97),('8998','2013-04-29','15:00:00',1.92),('8998','2013-04-29','15:05:00',1.87),('8998','2013-04-29','15:10:00',1.82),('8998','2013-04-29','15:15:00',1.77),('8998','2013-04-29','15:20:00',1.73),('8998','2013-04-29','15:25:00',1.69),('8998','2013-04-29','15:30:00',1.64),('8998','2013-04-29','15:35:00',1.6),('8998','2013-04-29','15:40:00',1.55),('8998','2013-04-29','15:45:00',1.5),('8998','2013-04-29','15:50:00',1.44),('8998','2013-04-29','15:55:00',1.4),('8998','2013-04-29','16:00:00',1.35),('8998','2013-04-29','16:05:00',1.3),('8998','2013-04-29','16:10:00',1.26),('8998','2013-04-29','16:15:00',1.21),('8998','2013-04-29','16:20:00',1.16),('8998','2013-04-29','16:25:00',1.11),('8998','2013-04-29','16:30:00',1.07),('8998','2013-04-29','16:35:00',1.02),('8998','2013-04-28','08:00:00',1.18),('8998','2013-04-28','08:05:00',1.31),('8998','2013-04-28','08:10:00',1.26),('8998','2013-04-28','08:15:00',1.25),('8998','2013-04-28','08:20:00',1.32),('8998','2013-04-28','08:25:00',1.48),('8998','2013-04-28','08:30:00',1.62),('8998','2013-04-28','08:35:00',1.8),('8998','2013-04-28','08:40:00',1.81),('8998','2013-04-28','08:45:00',1.74),('8998','2013-04-28','08:50:00',1.85),('8998','2013-04-28','08:55:00',1.82),('8998','2013-04-28','09:00:00',1.38),('8998','2013-04-28','09:05:00',1.8),('8998','2013-04-28','09:10:00',2.02),('8998','2013-04-28','09:15:00',2.15),('8998','2013-04-28','09:20:00',2.07),('8998','2013-04-28','09:25:00',1.98),('8998','2013-04-28','09:30:00',2.09),('8998','2013-04-28','09:35:00',2.26),('8998','2013-04-28','09:40:00',2.28),('8998','2013-04-28','09:45:00',2.34),('8998','2013-04-28','09:50:00',2.51),('8998','2013-04-28','09:55:00',2.28),('8998','2013-04-28','10:00:00',2.39),('8998','2013-04-28','10:05:00',2.37),('8998','2013-04-28','10:10:00',2.32),('8998','2013-04-28','10:15:00',1.95),('8998','2013-04-28','10:20:00',1.84),('8998','2013-04-28','10:25:00',2.29),('8998','2013-04-28','10:30:00',2.22),('8998','2013-04-28','10:35:00',2.63),('8998','2013-04-28','10:40:00',2.64),('8998','2013-04-28','10:45:00',2.67),('8998','2013-04-28','10:50:00',2.53),('8998','2013-04-28','10:55:00',2.33),('8998','2013-04-28','11:00:00',2.59),('8998','2013-04-28','11:05:00',2.54),('8998','2013-04-28','11:10:00',2.43),('8998','2013-04-28','11:15:00',2.25),('8998','2013-04-28','11:20:00',2.62),('8998','2013-04-28','11:25:00',2.7),('8998','2013-04-28','11:30:00',2.8),('8998','2013-04-28','11:35:00',2.66),('8998','2013-04-28','11:40:00',2.67),('8998','2013-04-28','11:45:00',2.6),('8998','2013-04-28','11:50:00',2.83),('8998','2013-04-28','11:55:00',2.8),('8998','2013-04-28','12:00:00',2.86),('8998','2013-04-28','12:05:00',2.86),('8998','2013-04-28','12:10:00',2.75),('8998','2013-04-28','12:15:00',2.74),('8998','2013-04-28','12:20:00',2.77),('8998','2013-04-28','12:25:00',2.68),('8998','2013-04-28','12:30:00',2.7),('8998','2013-04-28','12:35:00',2.74),('8998','2013-04-28','12:40:00',2.78),('8998','2013-04-28','12:45:00',2.77),('8998','2013-04-28','12:50:00',2.76),('8998','2013-04-28','12:55:00',2.65),('8998','2013-04-28','13:00:00',2.7),('8998','2013-04-28','13:05:00',2.66),('8998','2013-04-28','13:10:00',2.56),('8998','2013-04-28','13:15:00',2.39),('8998','2013-04-28','13:20:00',2.52),('8998','2013-04-28','13:25:00',2.65),('8998','2013-04-28','13:30:00',2.61),('8998','2013-04-28','13:35:00',2.53),('8998','2013-04-28','13:40:00',2.55),('8998','2013-04-28','13:45:00',2.52),('8998','2013-04-28','13:50:00',2.38),('8998','2013-04-28','13:55:00',2.61),('8998','2013-04-28','14:00:00',2.4),('8998','2013-04-28','14:05:00',2.38),('8998','2013-04-28','14:10:00',2.42),('8998','2013-04-28','14:15:00',2.45),('8998','2013-04-28','14:20:00',2.42),('8998','2013-04-28','14:25:00',2.32),('8998','2013-04-28','14:30:00',2.19),('8998','2013-04-28','14:35:00',2.11),('8998','2013-04-28','14:40:00',1.99),('8998','2013-04-28','14:45:00',2.13),('8998','2013-04-28','14:50:00',2.05),('8998','2013-04-28','14:55:00',2.08),('8998','2013-04-28','15:00:00',1.99),('8998','2013-04-28','15:05:00',2.09),('8998','2013-04-28','15:10:00',1.89),('8998','2013-04-28','15:15:00',1.73),('8998','2013-04-28','15:20:00',1.8),('8998','2013-04-28','15:25:00',1.91),('8998','2013-04-28','15:30:00',1.83),('8998','2013-04-28','15:35:00',1.6),('8998','2013-04-28','15:40:00',1.45),('8998','2013-04-28','15:45:00',1.39),('8998','2013-04-28','15:50:00',1.41),('8998','2013-04-28','15:55:00',1.5),('8998','2013-04-28','16:00:00',1.45),('8998','2013-04-28','16:05:00',1.54),('8998','2013-04-28','16:10:00',1.45),('8998','2013-04-28','16:15:00',1.63),('8998','2013-04-28','16:20:00',1.6),('8998','2013-04-28','16:25:00',1.25),('8998','2013-04-28','16:30:00',1.26),('8998','2013-04-28','16:35:00',1.23),('8998','2013-04-28','16:40:00',1.26),('8998','2013-04-28','16:45:00',1.2),('8998','2013-04-28','16:50:00',1.18),('8998','2013-04-28','16:55:00',1.17),('8998','2013-04-28','17:00:00',1.05),('8998','2013-04-27','07:45:00',1.02),('8998','2013-04-27','07:50:00',1.17),('8998','2013-04-27','07:55:00',1.17),('8998','2013-04-27','08:00:00',1.21),('8998','2013-04-27','08:05:00',1.33),('8998','2013-04-27','08:10:00',1.4),('8998','2013-04-27','08:15:00',1.5),('8998','2013-04-27','08:20:00',1.45),('8998','2013-04-27','08:25:00',1.54),('8998','2013-04-27','08:30:00',1.77),('8998','2013-04-27','08:35:00',1.68),('8998','2013-04-27','08:40:00',1.6),('8998','2013-04-27','08:45:00',1.61),('8998','2013-04-27','08:50:00',1.64),('8998','2013-04-27','08:55:00',1.64),('8998','2013-04-27','09:00:00',1.68),('8998','2013-04-27','09:05:00',1.74),('8998','2013-04-27','09:10:00',1.76),('8998','2013-04-27','09:15:00',1.81),('8998','2013-04-27','09:20:00',1.92),('8998','2013-04-27','09:25:00',2.03),('8998','2013-04-27','09:30:00',2.34),('8998','2013-04-27','09:35:00',2.45),('8998','2013-04-27','09:40:00',2.6),('8998','2013-04-27','09:45:00',2.66),('8998','2013-04-27','09:50:00',2.7),('8998','2013-04-27','09:55:00',2.72),('8998','2013-04-27','10:00:00',2.73),('8998','2013-04-27','10:05:00',2.72),('8998','2013-04-27','10:10:00',2.79),('8998','2013-04-27','10:15:00',2.73),('8998','2013-04-27','10:20:00',2.81),('8998','2013-04-27','10:25:00',2.87),('8998','2013-04-27','10:30:00',2.79),('8998','2013-04-27','10:35:00',2.86),('8998','2013-04-27','10:40:00',2.6),('8998','2013-04-27','10:45:00',2.94),('8998','2013-04-27','10:50:00',2.91),('8998','2013-04-27','10:55:00',2.91),('8998','2013-04-27','11:00:00',2.92),('8998','2013-04-27','11:05:00',2.91),('8998','2013-04-27','11:10:00',2.95),('8998','2013-04-27','11:15:00',2.93),('8998','2013-04-27','11:20:00',2.95),('8998','2013-04-27','11:25:00',2.97),('8998','2013-04-27','11:30:00',2.97),('8998','2013-04-27','11:35:00',2.87),('8998','2013-04-27','11:40:00',2.86),('8998','2013-04-27','11:45:00',2.75),('8998','2013-04-27','11:50:00',2.76),('8998','2013-04-27','11:55:00',2.87),('8998','2013-04-27','12:00:00',2.5),('8998','2013-04-27','12:05:00',2.47),('8998','2013-04-27','12:10:00',2.71),('8998','2013-04-27','12:15:00',2.83),('8998','2013-04-27','12:20:00',2.74),('8998','2013-04-27','12:25:00',2.41),('8998','2013-04-27','12:30:00',2.33),('8998','2013-04-27','12:35:00',2.09),('8998','2013-04-27','12:40:00',2.12),('8998','2013-04-27','12:45:00',2.74),('8998','2013-04-27','12:50:00',2.86),('8998','2013-04-27','12:55:00',2.59),('8998','2013-04-27','13:00:00',2.66),('8998','2013-04-27','13:05:00',2.83),('8998','2013-04-27','13:10:00',2.76),('8998','2013-04-27','13:15:00',2.55),('8998','2013-04-27','13:20:00',2.57),('8998','2013-04-27','13:25:00',2.55),('8998','2013-04-27','13:30:00',2.66),('8998','2013-04-27','13:35:00',2.64),('8998','2013-04-27','13:40:00',2.79),('8998','2013-04-27','13:45:00',2.7),('8998','2013-04-27','13:50:00',2.66),('8998','2013-04-27','13:55:00',2.29),('8998','2013-04-27','14:00:00',2.49),('8998','2013-04-27','14:05:00',2.48),('8998','2013-04-27','14:10:00',2.4),('8998','2013-04-27','14:15:00',2.43),('8998','2013-04-27','14:20:00',1.98),('8998','2013-04-27','14:25:00',2.08),('8998','2013-04-27','14:30:00',2.29),('8998','2013-04-27','14:35:00',2.26),('8998','2013-04-27','14:40:00',2.21),('8998','2013-04-27','14:45:00',2.15),('8998','2013-04-27','14:50:00',2.11),('8998','2013-04-27','14:55:00',2.06),('8998','2013-04-27','15:00:00',2.03),('8998','2013-04-27','15:05:00',1.98),('8998','2013-04-27','15:10:00',1.94),('8998','2013-04-27','15:15:00',1.91),('8998','2013-04-27','15:20:00',1.86),('8998','2013-04-27','15:25:00',1.81),('8998','2013-04-27','15:30:00',1.76),('8998','2013-04-27','15:35:00',1.71),('8998','2013-04-27','15:40:00',1.66),('8998','2013-04-27','15:45:00',1.61),('8998','2013-04-27','15:50:00',1.55),('8998','2013-04-27','15:55:00',1.5),('8998','2013-04-27','16:00:00',1.45),('8998','2013-04-27','16:05:00',1.4),('8998','2013-04-27','16:10:00',1.34),('8998','2013-04-27','16:15:00',1.28),('8998','2013-04-27','16:20:00',1.22),('8998','2013-04-27','16:25:00',1.17),('8998','2013-04-27','16:30:00',1.12),('8998','2013-04-27','16:35:00',1.06),('8998','2013-04-27','16:40:00',1),('8998','2013-04-26','13:00:00',1.04),('8998','2013-04-26','13:20:00',1.03),('8998','2013-04-26','13:40:00',1.27),('8998','2013-04-26','14:30:00',1.47),('8998','2013-04-26','14:35:00',1.42),('8998','2013-04-26','16:50:00',1.04),('8998','2013-04-26','16:55:00',1.09),('8998','2013-04-26','17:00:00',1.25),('8998','2013-04-25','08:10:00',1.23),('8998','2013-04-25','08:15:00',1.34),('8998','2013-04-25','08:20:00',1.38),('8998','2013-04-25','08:25:00',1.42),('8998','2013-04-25','08:30:00',1.44),('8998','2013-04-25','08:35:00',1.52),('8998','2013-04-25','08:40:00',1.56),('8998','2013-04-25','08:45:00',1.62),('8998','2013-04-25','08:50:00',1.64),('8998','2013-04-25','08:55:00',1.41),('8998','2013-04-25','09:00:00',1.08),('8998','2013-04-25','09:05:00',1.44),('8998','2013-04-25','09:10:00',1.62),('8998','2013-04-25','09:15:00',1.03),('8998','2013-04-25','09:25:00',1.1),('8998','2013-04-25','09:30:00',1.51),('8998','2013-04-25','09:35:00',1.59),('8998','2013-04-25','09:40:00',1.96),('8998','2013-04-25','09:45:00',2.31),('8998','2013-04-25','09:50:00',2.28),('8998','2013-04-25','09:55:00',1.45),('8998','2013-04-25','10:00:00',1.46),('8998','2013-04-25','10:05:00',1.88),('8998','2013-04-25','10:10:00',2.51),('8998','2013-04-25','10:15:00',2.65),('8998','2013-04-25','10:20:00',2.66),('8998','2013-04-25','10:25:00',2.09),('8998','2013-04-25','10:30:00',2.61),('8998','2013-04-25','10:35:00',2.82),('8998','2013-04-25','10:40:00',2.82),('8998','2013-04-25','10:45:00',2.39),('8998','2013-04-25','10:50:00',1.55),('8998','2013-04-25','10:55:00',2.21),('8998','2013-04-25','11:00:00',2.38),('8998','2013-04-25','11:05:00',2.72),('8998','2013-04-25','11:10:00',2.38),('8998','2013-04-25','11:15:00',2.72),('8998','2013-04-25','11:20:00',2.21),('8998','2013-04-25','11:25:00',2.25),('8998','2013-04-25','11:30:00',2.25),('8998','2013-04-25','11:35:00',2.48),('8998','2013-04-25','11:40:00',2.52),('8998','2013-04-25','11:45:00',2.51),('8998','2013-04-25','11:50:00',1.99),('8998','2013-04-25','11:55:00',1.82),('8998','2013-04-25','12:00:00',1.96),('8998','2013-04-25','12:05:00',1.95),('8998','2013-04-25','12:10:00',1.63),('8998','2013-04-25','12:15:00',1.79),('8998','2013-04-25','12:20:00',1.78),('8998','2013-04-25','12:25:00',1.52),('8998','2013-04-25','12:30:00',1.28),('8998','2013-04-25','12:35:00',1.53),('8998','2013-04-25','12:40:00',2.33),('8998','2013-04-25','12:45:00',2.67),('8998','2013-04-25','12:50:00',1.67),('8998','2013-04-25','12:55:00',1.41),('8998','2013-04-25','13:00:00',1.05),('8998','2013-04-25','13:10:00',1.1),('8998','2013-04-25','13:15:00',1.53),('8998','2013-04-25','13:20:00',1.13),('8998','2013-04-25','13:25:00',1.27),('8998','2013-04-25','13:30:00',1.64),('8998','2013-04-25','13:35:00',1.52),('8998','2013-04-25','13:40:00',1.82),('8998','2013-04-25','13:45:00',1.51),('8998','2013-04-25','13:50:00',2),('8998','2013-04-25','13:55:00',1.69),('8998','2013-04-25','14:00:00',1.76),('8998','2013-04-25','14:05:00',2.28),('8998','2013-04-25','14:10:00',2.07),('8998','2013-04-25','14:15:00',2.29),('8998','2013-04-25','14:20:00',1.91),('8998','2013-04-25','14:25:00',2.2),('8998','2013-04-25','14:30:00',2.35),('8998','2013-04-25','14:35:00',1.85),('8998','2013-04-25','14:40:00',1.15),('8998','2013-04-25','14:45:00',1.08),('8998','2013-04-25','14:50:00',2.13),('8998','2013-04-25','14:55:00',2.38),('8998','2013-04-25','15:00:00',2.16),('8998','2013-04-25','15:05:00',1.83),('8998','2013-04-25','15:15:00',1.05),('8998','2013-04-25','15:30:00',1.28),('8998','2013-04-25','15:35:00',1.18),('8998','2013-04-25','15:40:00',1.12),('8998','2013-04-25','15:45:00',1.16),('8998','2013-04-25','15:50:00',1.08),('8998','2013-04-24','08:10:00',1.02),('8998','2013-04-24','08:15:00',1.28),('8998','2013-04-24','08:20:00',1.08),('8998','2013-04-24','08:45:00',1.08),('8998','2013-04-24','08:50:00',1.7),('8998','2013-04-24','08:55:00',2.02),('8998','2013-04-24','09:00:00',1.74),('8998','2013-04-24','09:05:00',1.26),('8998','2013-04-24','09:10:00',1.12),('8998','2013-04-24','09:15:00',1.07),('8998','2013-04-24','09:20:00',1.09),('8998','2013-04-24','09:25:00',1.34),('8998','2013-04-24','09:30:00',1.27),('8998','2013-04-24','09:35:00',1.39),('8998','2013-04-24','09:40:00',2.02),('8998','2013-04-24','09:45:00',2.4),('8998','2013-04-24','09:50:00',2.77),('8998','2013-04-24','09:55:00',2.75),('8998','2013-04-24','10:00:00',2.74),('8998','2013-04-24','10:05:00',2.58),('8998','2013-04-24','10:10:00',2.37),('8998','2013-04-24','10:15:00',2.44),('8998','2013-04-24','10:20:00',2.77),('8998','2013-04-24','10:25:00',2.82),('8998','2013-04-24','10:30:00',2.87),('8998','2013-04-24','10:35:00',2.9),('8998','2013-04-24','10:40:00',2.87),('8998','2013-04-24','10:45:00',2.76),('8998','2013-04-24','10:50:00',2.87),('8998','2013-04-24','10:55:00',2.92),('8998','2013-04-24','11:00:00',2.95),('8998','2013-04-24','11:05:00',2.99),('8998','2013-04-24','11:10:00',2.97),('8998','2013-04-24','11:15:00',2.95),('8998','2013-04-24','11:20:00',2.96),('8998','2013-04-24','11:25:00',2.97),('8998','2013-04-24','11:30:00',2.95),('8998','2013-04-24','11:35:00',2.99),('8998','2013-04-24','11:40:00',2.99),('8998','2013-04-24','11:45:00',3),('8998','2013-04-24','11:50:00',3.01),('8998','2013-04-24','11:55:00',2.95),('8998','2013-04-24','12:00:00',2.88),('8998','2013-04-24','12:05:00',2.88),('8998','2013-04-24','12:10:00',2.91),('8998','2013-04-24','12:15:00',2.91),('8998','2013-04-24','12:20:00',2.91),('8998','2013-04-24','12:25:00',2.88),('8998','2013-04-24','12:30:00',2.88),('8998','2013-04-24','12:35:00',2.87),('8998','2013-04-24','12:40:00',2.84),('8998','2013-04-24','12:45:00',2.83),('8998','2013-04-24','12:50:00',2.8),('8998','2013-04-24','12:55:00',2.81),('8998','2013-04-24','13:00:00',2.83),('8998','2013-04-24','13:05:00',2.88),('8998','2013-04-24','13:10:00',2.76),('8998','2013-04-24','13:15:00',2.64),('8998','2013-04-24','13:20:00',2.51),('8998','2013-04-24','13:25:00',2.51),('8998','2013-04-24','13:30:00',1.99),('8998','2013-04-24','13:35:00',1.97),('8998','2013-04-24','13:40:00',1.64),('8998','2013-04-24','13:45:00',1.51),('8998','2013-04-24','13:50:00',1.38),('8998','2013-04-24','13:55:00',1.44),('8998','2013-04-24','14:00:00',1.55),('8998','2013-04-24','14:05:00',1.41),('8998','2013-04-24','14:10:00',1.52),('8998','2013-04-24','14:15:00',1.6),('8998','2013-04-24','14:20:00',1.64),('8998','2013-04-24','14:25:00',1.65),('8998','2013-04-24','14:30:00',1.9),('8998','2013-04-24','14:35:00',2.26),('8998','2013-04-24','14:40:00',2.16),('8998','2013-04-24','14:45:00',2.14),('8998','2013-04-24','14:50:00',1.9),('8998','2013-04-24','14:55:00',1.96),('8998','2013-04-24','15:00:00',1.84),('8998','2013-04-24','15:05:00',1.68),('8998','2013-04-24','15:10:00',1.59),('8998','2013-04-24','15:15:00',1.79),('8998','2013-04-24','15:20:00',1.88),('8998','2013-04-24','15:25:00',1.9),('8998','2013-04-24','15:30:00',1.86),('8998','2013-04-24','15:35:00',1.72),('8998','2013-04-24','15:40:00',1.61),('8998','2013-04-24','15:45:00',1.49),('8998','2013-04-24','15:50:00',1.4),('8998','2013-04-24','15:55:00',1.34),('8998','2013-04-24','16:00:00',1.37),('8998','2013-04-24','16:05:00',1.17),('8998','2013-04-24','16:10:00',1.16),('8998','2013-04-24','16:15:00',1.14),('8998','2013-04-24','16:20:00',1.16),('8998','2013-04-24','16:25:00',1.09),('8998','2013-04-24','16:35:00',1.18),('8998','2013-04-24','16:40:00',1.03),('8998','2013-04-24','16:45:00',1.07),('8998','2013-04-24','17:10:00',1.03),('8998','2013-04-23','07:55:00',1.24),('8998','2013-04-23','08:00:00',1.26),('8998','2013-04-23','08:05:00',1.25),('8998','2013-04-23','08:10:00',1.3),('8998','2013-04-23','08:15:00',1.47),('8998','2013-04-23','08:20:00',1.59),('8998','2013-04-23','08:25:00',1.78),('8998','2013-04-23','08:30:00',1.83),('8998','2013-04-23','08:35:00',1.74),('8998','2013-04-23','08:40:00',1.72),('8998','2013-04-23','08:45:00',1.7),('8998','2013-04-23','08:50:00',1.73),('8998','2013-04-23','08:55:00',1.7),('8998','2013-04-23','09:00:00',1.72),('8998','2013-04-23','09:05:00',2.21),('8998','2013-04-23','09:10:00',2.24),('8998','2013-04-23','09:15:00',2.05),('8998','2013-04-23','09:20:00',1.71),('8998','2013-04-23','09:25:00',1.96),('8998','2013-04-23','09:30:00',2.45),('8998','2013-04-23','09:35:00',2.49),('8998','2013-04-23','09:40:00',2.36),('8998','2013-04-23','09:45:00',2.34),('8998','2013-04-23','09:50:00',2.47),('8998','2013-04-23','09:55:00',2.86),('8998','2013-04-23','10:00:00',2.82),('8998','2013-04-23','10:05:00',2.87),('8998','2013-04-23','10:10:00',2.85),('8998','2013-04-23','10:15:00',2.83),('8998','2013-04-23','10:20:00',2.81),('8998','2013-04-23','10:25:00',2.77),('8998','2013-04-23','10:30:00',2.71),('8998','2013-04-23','10:35:00',2.66),('8998','2013-04-23','10:40:00',2.9),('8998','2013-04-23','10:45:00',3.01),('8998','2013-04-23','10:50:00',2.99),('8998','2013-04-23','10:55:00',3.04),('8998','2013-04-23','11:00:00',3.07),('8998','2013-04-23','11:05:00',2.96),('8998','2013-04-23','11:10:00',3.12),('8998','2013-04-23','11:15:00',3.19),('8998','2013-04-23','11:20:00',3.22),('8998','2013-04-23','11:25:00',3.3),('8998','2013-04-23','11:30:00',3.12),('8998','2013-04-23','11:35:00',2.56),('8998','2013-04-23','11:40:00',1.75),('8998','2013-04-23','11:45:00',2.03),('8998','2013-04-23','11:50:00',1.45),('8998','2013-04-23','11:55:00',1.9),('8998','2013-04-23','12:00:00',2.49),('8998','2013-04-23','12:05:00',1.72),('8998','2013-04-23','12:10:00',2.07),('8998','2013-04-23','12:15:00',2.78),('8998','2013-04-23','12:20:00',3.37),('8998','2013-04-23','12:25:00',2.82),('8998','2013-04-23','12:30:00',2.74),('8998','2013-04-23','12:35:00',2.77),('8998','2013-04-23','12:40:00',2.55),('8998','2013-04-23','12:45:00',2.73),('8998','2013-04-23','12:50:00',2.91),('8998','2013-04-23','12:55:00',2.76),('8998','2013-04-23','13:00:00',2.6),('8998','2013-04-23','13:05:00',2.27),('8998','2013-04-23','13:10:00',3.04),('8998','2013-04-23','13:15:00',2.61),('8998','2013-04-23','13:20:00',2.6),('8998','2013-04-23','13:25:00',2.56),('8998','2013-04-23','13:30:00',2.41),('8998','2013-04-23','13:35:00',2.29),('8998','2013-04-23','13:40:00',2.86),('8998','2013-04-23','13:45:00',2.3),('8998','2013-04-23','13:50:00',1.67),('8998','2013-04-23','13:55:00',2.57),('8998','2013-04-23','14:00:00',2.56),('8998','2013-04-23','14:05:00',1.82),('8998','2013-04-23','14:10:00',1.75),('8998','2013-04-23','14:15:00',2.6),('8998','2013-04-23','14:20:00',2.24),('8998','2013-04-23','14:25:00',2.38),('8998','2013-04-23','14:30:00',2.25),('8998','2013-04-23','14:35:00',1.92),('8998','2013-04-23','14:40:00',1.78),('8998','2013-04-23','14:45:00',1.75),('8998','2013-04-23','14:50:00',1.52),('8998','2013-04-23','14:55:00',1.39),('8998','2013-04-23','15:00:00',1.55),('8998','2013-04-23','15:05:00',1.44),('8998','2013-04-23','15:10:00',1.37),('8998','2013-04-23','15:15:00',1.45),('8998','2013-04-23','15:20:00',1.5),('8998','2013-04-23','15:25:00',1.32),('8998','2013-04-23','15:30:00',1.16),('8998','2013-04-23','15:35:00',1.11),('8998','2013-04-23','15:40:00',1.09),('8998','2013-04-23','15:45:00',1.09),('8998','2013-04-23','15:50:00',1.1),('8998','2013-04-23','15:55:00',1.24),('8998','2013-04-23','16:00:00',1.44),('8998','2013-04-23','16:05:00',1.48),('8998','2013-04-23','16:10:00',1.45),('8998','2013-04-23','16:15:00',1.39),('8998','2013-04-23','16:20:00',1.74),('8998','2013-04-23','16:25:00',1.32),('8998','2013-04-23','16:30:00',1.13),('8998','2013-04-23','16:40:00',1.16),('8998','2013-04-23','16:45:00',1.2),('8998','2013-04-23','16:50:00',1.08),('8998','2013-04-23','16:55:00',1.16),('8998','2013-04-23','17:00:00',1.12),('8998','2013-04-22','07:50:00',1.07),('8998','2013-04-22','07:55:00',1.14),('8998','2013-04-22','08:00:00',1.21),('8998','2013-04-22','08:05:00',1.33),('8998','2013-04-22','08:10:00',1.39),('8998','2013-04-22','08:15:00',1.52),('8998','2013-04-22','08:20:00',1.55),('8998','2013-04-22','08:25:00',1.75),('8998','2013-04-22','08:30:00',1.58),('8998','2013-04-22','08:35:00',1.51),('8998','2013-04-22','08:40:00',1.55),('8998','2013-04-22','08:45:00',1.86),('8998','2013-04-22','08:50:00',1.91),('8998','2013-04-22','08:55:00',1.75),('8998','2013-04-22','09:00:00',1.71),('8998','2013-04-22','09:05:00',1.67),('8998','2013-04-22','09:10:00',1.8),('8998','2013-04-22','09:15:00',1.85),('8998','2013-04-22','09:20:00',1.87),('8998','2013-04-22','09:25:00',2.36),('8998','2013-04-22','09:30:00',2.44),('8998','2013-04-22','09:35:00',2.59),('8998','2013-04-22','09:40:00',2.5),('8998','2013-04-22','09:45:00',2.36),('8998','2013-04-22','09:50:00',2.84),('8998','2013-04-22','09:55:00',2.87),('8998','2013-04-22','10:00:00',2.86),('8998','2013-04-22','10:05:00',2.89),('8998','2013-04-22','10:10:00',2.9),('8998','2013-04-22','10:15:00',2.92),('8998','2013-04-22','10:20:00',2.95),('8998','2013-04-22','10:25:00',2.97),('8998','2013-04-22','10:30:00',2.98),('8998','2013-04-22','10:35:00',3),('8998','2013-04-22','10:40:00',2.97),('8998','2013-04-22','10:45:00',2.92),('8998','2013-04-22','10:50:00',2.97),('8998','2013-04-22','10:55:00',3.03),('8998','2013-04-22','11:00:00',3.05),('8998','2013-04-22','11:05:00',3.06),('8998','2013-04-22','11:10:00',3.07),('8998','2013-04-22','11:15:00',3.07),('8998','2013-04-22','11:20:00',3.09),('8998','2013-04-22','11:25:00',3.11),('8998','2013-04-22','11:30:00',3.1),('8998','2013-04-22','11:35:00',3.07),('8998','2013-04-22','11:40:00',3.05),('8998','2013-04-22','11:45:00',3.04),('8998','2013-04-22','11:50:00',3.05),('8998','2013-04-22','11:55:00',3.06),('8998','2013-04-22','12:00:00',3.04),('8998','2013-04-22','12:05:00',3.01),('8998','2013-04-22','12:10:00',2.99),('8998','2013-04-22','12:15:00',2.98),('8998','2013-04-22','12:20:00',2.95),('8998','2013-04-22','12:25:00',2.92),('8998','2013-04-22','12:30:00',1.5),('8998','2013-04-22','12:35:00',1.18),('8998','2013-04-22','12:40:00',2.1),('8998','2013-04-22','12:45:00',1.17),('8998','2013-04-22','12:50:00',2.22),('8998','2013-04-22','12:55:00',1.55),('8998','2013-04-22','13:00:00',1.69),('8998','2013-04-22','13:05:00',2.41),('8998','2013-04-22','13:10:00',1.08),('8998','2013-04-22','13:15:00',2.5),('8998','2013-04-22','13:20:00',2.83),('8998','2013-04-22','13:25:00',2.97),('8998','2013-04-22','13:30:00',2.79),('8998','2013-04-22','13:35:00',2.84),('8998','2013-04-22','13:40:00',2.94),('8998','2013-04-22','13:45:00',2.04),('8998','2013-04-22','13:50:00',2.45),('8998','2013-04-22','13:55:00',2.78),('8998','2013-04-22','14:00:00',1.88),('8998','2013-04-22','14:05:00',2.42),('8998','2013-04-22','14:10:00',1.85),('8998','2013-04-22','14:15:00',2.26),('8998','2013-04-22','14:20:00',2.4),('8998','2013-04-22','14:25:00',2.18),('8998','2013-04-22','14:30:00',2.5),('8998','2013-04-22','14:35:00',2.45),('8998','2013-04-22','14:40:00',2.41),('8998','2013-04-22','14:45:00',2.08),('8998','2013-04-22','14:50:00',1.43),('8998','2013-04-22','14:55:00',1.52),('8998','2013-04-22','15:00:00',1.55),('8998','2013-04-22','15:05:00',1.56),('8998','2013-04-22','15:10:00',1.77),('8998','2013-04-22','15:15:00',1.84),('8998','2013-04-22','15:20:00',1.68),('8998','2013-04-22','15:25:00',1.54),('8998','2013-04-22','15:30:00',1.5),('8998','2013-04-22','15:35:00',1.52),('8998','2013-04-22','15:40:00',1.29),('8998','2013-04-22','15:45:00',1.49),('8998','2013-04-22','15:50:00',1.19),('8998','2013-04-22','15:55:00',1.01),('8998','2013-04-22','16:00:00',1),('8998','2013-04-22','16:05:00',1.05),('8998','2013-04-22','16:10:00',1.01),('8998','2013-04-22','16:15:00',1.05),('8998','2013-04-21','10:35:00',1.54),('8998','2013-04-21','10:40:00',2.66),('8998','2013-04-21','10:45:00',3.75),('8998','2013-04-21','10:50:00',1.77),('8998','2013-04-21','10:55:00',1.56),('8998','2013-04-21','11:00:00',1.46),('8998','2013-04-21','11:05:00',1.37),('8998','2013-04-21','11:10:00',1.79),('8998','2013-04-21','11:15:00',1.12),('8998','2013-04-21','11:20:00',1.06),('8998','2013-04-21','11:25:00',1.38),('8998','2013-04-21','11:30:00',2.24),('8998','2013-04-21','11:35:00',2.72),('8998','2013-04-21','11:40:00',3.03),('8998','2013-04-21','11:45:00',1.56),('8998','2013-04-21','11:50:00',1.27),('8998','2013-04-21','11:55:00',2.61),('8998','2013-04-21','12:00:00',2.61),('8998','2013-04-21','12:05:00',2.49),('8998','2013-04-21','12:10:00',2.89),('8998','2013-04-21','12:15:00',2.31),('8998','2013-04-21','12:20:00',2.39),('8998','2013-04-21','12:25:00',2.07),('8998','2013-04-21','12:30:00',1.66),('8998','2013-04-21','12:35:00',1.48),('8998','2013-04-21','12:40:00',3.09),('8998','2013-04-21','12:45:00',2.79),('8998','2013-04-21','12:50:00',3.19),('8998','2013-04-21','12:55:00',3.14),('8998','2013-04-21','13:00:00',3.12),('8998','2013-04-21','13:15:00',2.09),('8998','2013-04-21','13:20:00',2.74),('8998','2013-04-21','13:25:00',1.51),('8998','2013-04-21','13:30:00',2.63),('8998','2013-04-21','13:35:00',1.37),('8998','2013-04-21','13:40:00',1.4),('8998','2013-04-21','13:45:00',2.96),('8998','2013-04-21','14:10:00',1.44),('8998','2013-04-21','14:20:00',1.45),('8998','2013-04-21','14:25:00',1.74),('8998','2013-04-21','14:30:00',2.79),('8998','2013-04-21','14:35:00',1.85),('8998','2013-04-21','14:40:00',1.78),('8998','2013-04-21','14:45:00',2.55),('8998','2013-04-21','14:50:00',2.59),('8998','2013-04-21','14:55:00',2.58),('8998','2013-04-21','15:00:00',1.6),('8998','2013-04-21','15:05:00',1.5),('8998','2013-04-21','15:10:00',1.38),('8998','2013-04-21','15:25:00',1.13),('8998','2013-04-21','15:30:00',1.1),('8998','2013-04-21','15:45:00',1.67),('8998','2013-04-21','15:50:00',1.53),('8998','2014-03-28','07:30:00',1.27),('8998','2014-03-28','07:35:00',1.43),('8998','2014-03-28','07:40:00',1.46),('8998','2014-03-28','07:45:00',1.33),('8998','2014-03-28','07:50:00',1.43),('8998','2014-03-28','07:55:00',1.7),('8998','2014-03-28','08:00:00',1.82),('8998','2014-03-28','08:05:00',1.87),('8998','2014-03-28','08:10:00',1.96),('8998','2014-03-28','08:15:00',2.05),('8998','2014-03-28','08:20:00',2.11),('8998','2014-03-28','08:25:00',2.16),('8998','2014-03-28','08:30:00',2.2),('8998','2014-03-28','08:35:00',2.25),('8998','2014-03-28','08:40:00',2.27),('8998','2014-03-28','08:45:00',2.31),('8998','2014-03-28','08:50:00',2.36),('8998','2014-03-28','08:55:00',2.36),('8998','2014-03-28','09:00:00',2.38),('8998','2014-03-28','09:05:00',2.4),('8998','2014-03-28','09:10:00',2.43),('8998','2014-03-28','09:15:00',2.48),('8998','2014-03-28','09:20:00',2.54),('8998','2014-03-28','09:25:00',2.57),('8998','2014-03-28','09:30:00',2.59),('8998','2014-03-28','09:35:00',2.63),('8998','2014-03-28','09:40:00',2.65),('8998','2014-03-28','09:45:00',2.67),('8998','2014-03-28','09:50:00',2.7),('8998','2014-03-28','09:55:00',2.76),('8998','2014-03-28','10:00:00',2.76),('8998','2014-03-28','10:05:00',2.79),('8998','2014-03-28','10:10:00',2.82),('8998','2014-03-28','10:15:00',2.84),('8998','2014-03-28','10:20:00',2.85),('8998','2014-03-28','10:25:00',2.88),('8998','2014-03-28','10:30:00',2.86),('8998','2014-03-28','10:35:00',2.87),('8998','2014-03-28','10:40:00',2.88),('8998','2014-03-28','10:45:00',2.88),('8998','2014-03-28','10:50:00',2.88),('8998','2014-03-28','10:55:00',2.87),('8998','2014-03-28','11:00:00',2.86),('8998','2014-03-28','11:05:00',2.83),('8998','2014-03-28','11:10:00',2.83),('8998','2014-03-28','11:15:00',2.82),('8998','2014-03-28','11:20:00',2.81),('8998','2014-03-28','11:25:00',2.81),('8998','2014-03-28','11:30:00',2.79),('8998','2014-03-28','11:35:00',2.75),('8998','2014-03-28','11:40:00',2.7),('8998','2014-03-28','11:45:00',2.76),('8998','2014-03-28','11:50:00',2.74),('8998','2014-03-28','11:55:00',2.71),('8998','2014-03-28','12:00:00',2.69),('8998','2014-03-28','12:05:00',2.65),('8998','2014-03-28','12:10:00',2.63),('8998','2014-03-28','12:15:00',2.65),('8998','2014-03-28','12:20:00',2.65),('8998','2014-03-28','12:25:00',2.62),('8998','2014-03-28','12:30:00',2.6),('8998','2014-03-28','12:35:00',2.58),('8998','2014-03-28','12:40:00',2.53),('8998','2014-03-28','12:45:00',2.51),('8998','2014-03-28','12:50:00',2.48),('8998','2014-03-28','12:55:00',2.43),('8998','2014-03-28','13:00:00',2.39),('8998','2014-03-28','13:05:00',2.38),('8998','2014-03-28','13:10:00',2.33),('8998','2014-03-28','13:15:00',2.3),('8998','2014-03-28','13:20:00',2.25),('8998','2014-03-28','13:25:00',2.2),('8998','2014-03-28','13:30:00',2.14),('8998','2014-03-28','13:35:00',2.1),('8998','2014-03-28','13:40:00',2.04),('8998','2014-03-28','13:45:00',1.99),('8998','2014-03-28','13:50:00',1.94),('8998','2014-03-28','13:55:00',1.89),('8998','2014-03-28','14:00:00',1.85),('8998','2014-03-28','14:05:00',1.82),('8998','2014-03-28','14:10:00',1.77),('8998','2014-03-28','14:15:00',1.71),('8998','2014-03-28','14:20:00',1.65),('8998','2014-03-28','14:25:00',1.6),('8998','2014-03-28','14:30:00',1.54),('8998','2014-03-28','14:35:00',1.35),('8998','2014-03-28','14:40:00',1.29),('8998','2014-03-28','14:45:00',1.35),('8998','2014-03-28','14:50:00',1.34),('8998','2014-03-28','14:55:00',1.32),('8998','2014-03-28','15:00:00',1.25),('8998','2014-03-28','15:05:00',1.16),('8998','2014-03-28','15:10:00',1.07),('8998','2014-03-28','15:15:00',1.02),('8998','2013-04-20','08:40:00',1.13),('8998','2013-04-20','08:45:00',1.25),('8998','2013-04-20','08:50:00',2.32),('8998','2013-04-20','08:55:00',2.25),('8998','2013-04-20','09:00:00',1.45),('8998','2013-04-20','09:05:00',1.56),('8998','2013-04-20','09:10:00',1.82),('8998','2013-04-20','09:15:00',2.05),('8998','2013-04-20','09:20:00',1.57),('8998','2013-04-20','09:25:00',1.81),('8998','2013-04-20','09:30:00',2.63),('8998','2013-04-20','09:35:00',2.61),('8998','2013-04-20','09:40:00',2.63),('8998','2013-04-20','09:45:00',2.75),('8998','2013-04-20','09:50:00',3.1),('8998','2013-04-20','09:55:00',2.85),('8998','2013-04-20','10:00:00',2.43),('8998','2013-04-20','10:05:00',1.83),('8998','2013-04-20','10:10:00',1.55),('8998','2013-04-20','10:15:00',1.44),('8998','2013-04-20','10:20:00',2.25),('8998','2013-04-20','10:25:00',2.78),('8998','2013-04-20','10:30:00',2.37),('8998','2013-04-20','10:35:00',1.57),('8998','2013-04-20','10:40:00',2.04),('8998','2013-04-20','10:45:00',1.74),('8998','2013-04-20','10:50:00',3.06),('8998','2013-04-20','10:55:00',2.65),('8998','2013-04-20','11:00:00',3.06),('8998','2013-04-20','11:05:00',2.59),('8998','2013-04-20','11:10:00',2.98),('8998','2013-04-20','11:15:00',2.41),('8998','2013-04-20','11:20:00',2.21),('8998','2013-04-20','11:25:00',2.39),('8998','2013-04-20','11:30:00',2.1),('8998','2013-04-20','11:35:00',1.86),('8998','2013-04-20','11:40:00',2.33),('8998','2013-04-20','11:45:00',2.51),('8998','2013-04-20','11:50:00',2.18),('8998','2013-04-20','11:55:00',2.07),('8998','2013-04-20','12:00:00',1.71),('8998','2013-04-20','12:05:00',1.68),('8998','2013-04-20','12:10:00',1.69),('8998','2013-04-20','12:15:00',1.56),('8998','2013-04-20','12:20:00',1.44),('8998','2013-04-20','12:25:00',1.33),('8998','2013-04-20','12:30:00',1.46),('8998','2013-04-20','12:35:00',1.51),('8998','2013-04-20','12:40:00',1.51),('8998','2013-04-20','12:45:00',1.53),('8998','2013-04-20','12:50:00',1.41),('8998','2013-04-20','12:55:00',1.36),('8998','2013-04-20','13:00:00',1.51),('8998','2013-04-20','13:05:00',1.78),('8998','2013-04-20','13:10:00',1.83),('8998','2013-04-20','13:15:00',1.71),('8998','2013-04-20','13:20:00',1.63),('8998','2013-04-20','13:25:00',1.51),('8998','2013-04-20','13:30:00',2.2),('8998','2013-04-20','13:35:00',2.58),('8998','2013-04-20','13:40:00',1.82),('8998','2013-04-20','13:45:00',1.87),('8998','2013-04-20','13:50:00',1.71),('8998','2013-04-20','13:55:00',2.39),('8998','2013-04-20','14:00:00',2.82),('8998','2013-04-20','14:05:00',2.28),('8998','2013-04-20','14:10:00',2.33),('8998','2013-04-20','14:15:00',2.03),('8998','2013-04-20','14:20:00',2.72),('8998','2013-04-20','14:25:00',2.19),('8998','2013-04-20','14:30:00',2.27),('8998','2013-04-20','14:35:00',2.34),('8998','2013-04-20','14:40:00',2.53),('8998','2013-04-20','14:45:00',2.18),('8998','2013-04-20','14:50:00',1.24),('8998','2013-04-20','14:55:00',1.23),('8998','2013-04-20','15:00:00',1.57),('8998','2013-04-20','15:05:00',2.13),('8998','2013-04-20','15:10:00',2.2),('8998','2013-04-20','15:15:00',1.66),('8998','2013-04-20','15:20:00',1.2),('8998','2013-04-20','15:25:00',1.23),('8998','2013-04-20','15:30:00',1.15),('8998','2013-04-20','15:40:00',1.01),('8998','2013-04-19','08:00:00',1.02),('8998','2013-04-19','08:05:00',1.12),('8998','2013-04-19','08:10:00',1.24),('8998','2013-04-19','08:15:00',1.16),('8998','2013-04-19','08:20:00',1.05),('8998','2013-04-19','08:25:00',1.19),('8998','2013-04-19','08:30:00',1.32),('8998','2013-04-19','08:35:00',1.43),('8998','2013-04-19','08:40:00',1.5),('8998','2013-04-19','08:45:00',1.52),('8998','2013-04-19','08:50:00',1.55),('8998','2013-04-19','08:55:00',1.54),('8998','2013-04-19','09:00:00',1.69),('8998','2013-04-19','09:05:00',1.78),('8998','2013-04-19','09:10:00',1.71),('8998','2013-04-19','09:15:00',1.57),('8998','2013-04-19','09:20:00',1.98),('8998','2013-04-19','09:25:00',2.03),('8998','2013-04-19','09:30:00',1.85),('8998','2013-04-19','09:35:00',1.51),('8998','2013-04-19','09:45:00',1.07),('8998','2013-04-19','09:50:00',1.04),('8998','2013-04-19','10:45:00',1.2),('8998','2013-04-19','10:50:00',1.73),('8998','2013-04-19','10:55:00',1.58),('8998','2013-04-19','11:00:00',2.24),('8998','2013-04-19','11:05:00',2.09),('8998','2013-04-19','11:10:00',1.15),('8998','2013-04-19','11:15:00',3.21),('8998','2013-04-19','11:20:00',2.68),('8998','2013-04-19','11:25:00',1.36),('8998','2013-04-19','11:30:00',3.38),('8998','2013-04-19','11:35:00',2.77),('8998','2013-04-19','11:40:00',1.33),('8998','2013-04-19','11:45:00',1.92),('8998','2013-04-19','11:50:00',2.08),('8998','2013-04-19','11:55:00',2.93),('8998','2013-04-19','12:00:00',3.27),('8998','2013-04-19','12:05:00',1.84),('8998','2013-04-19','12:10:00',3.16),('8998','2013-04-19','12:15:00',2.92),('8998','2013-04-19','12:20:00',2.12),('8998','2013-04-19','12:25:00',2.5),('8998','2013-04-19','12:30:00',1.59),('8998','2013-04-19','12:35:00',2.89),('8998','2013-04-19','12:40:00',1.26),('8998','2013-04-19','12:45:00',3.01),('8998','2013-04-19','12:50:00',3.16),('8998','2013-04-19','12:55:00',3.11),('8998','2013-04-19','13:00:00',1.25),('8998','2013-04-19','13:05:00',1.86),('8998','2013-04-19','13:10:00',3.12),('8998','2013-04-19','13:15:00',2.85),('8998','2013-04-19','13:20:00',1.21),('8998','2013-04-19','13:25:00',2.38),('8998','2013-04-19','13:30:00',2.01),('8998','2013-04-19','13:35:00',1.11),('8998','2013-04-19','13:40:00',2.75),('8998','2013-04-19','13:45:00',1.4),('8998','2013-04-19','13:50:00',1.37),('8998','2013-04-19','13:55:00',1.89),('8998','2013-04-19','14:00:00',1.66),('8998','2013-04-19','14:05:00',2.52),('8998','2013-04-19','14:10:00',2.78),('8998','2013-04-19','14:15:00',2.41),('8998','2013-04-19','14:20:00',2.35),('8998','2013-04-19','14:25:00',2.36),('8998','2013-04-19','14:30:00',2.28),('8998','2013-04-19','14:35:00',2.2),('8998','2013-04-19','14:40:00',2.16),('8998','2013-04-19','14:45:00',2.13),('8998','2013-04-19','14:50:00',2.14),('8998','2013-04-19','14:55:00',2.11),('8998','2013-04-19','15:00:00',2.07),('8998','2013-04-19','15:05:00',2),('8998','2013-04-19','15:10:00',1.42),('8998','2013-04-19','15:15:00',1.38),('8998','2013-04-19','15:20:00',1.2),('8998','2013-04-19','15:25:00',1.64),('8998','2013-04-19','15:30:00',1.13),('8998','2013-04-19','16:15:00',1.11),('8998','2013-04-19','16:20:00',1.17),('8998','2013-04-19','16:25:00',1.25),('8998','2013-04-19','16:30:00',1.44),('8998','2013-04-19','16:35:00',1.4),('8998','2013-04-19','16:40:00',1.23),('8998','2013-04-19','16:45:00',1.16),('8998','2013-04-19','16:50:00',1.09),('8998','2013-04-18','08:05:00',1.18),('8998','2013-04-18','08:15:00',1.02),('8998','2013-04-18','08:20:00',1.28),('8998','2013-04-18','08:25:00',1.41),('8998','2013-04-18','08:30:00',1.33),('8998','2013-04-18','08:35:00',1.38),('8998','2013-04-18','08:40:00',1.49),('8998','2013-04-18','08:45:00',1.5),('8998','2013-04-18','08:50:00',1.56),('8998','2013-04-18','08:55:00',1.59),('8998','2013-04-18','09:00:00',1.62),('8998','2013-04-18','09:05:00',1.67),('8998','2013-04-18','09:10:00',1.62),('8998','2013-04-18','09:15:00',1.65),('8998','2013-04-18','09:20:00',1.79),('8998','2013-04-18','09:25:00',2.13),('8998','2013-04-18','09:30:00',2.29),('8998','2013-04-18','09:35:00',2.35),('8998','2013-04-18','09:40:00',2.38),('8998','2013-04-18','09:45:00',2.45),('8998','2013-04-18','09:50:00',2.43),('8998','2013-04-18','09:55:00',2.46),('8998','2013-04-18','10:00:00',2.52),('8998','2013-04-18','10:05:00',2.54),('8998','2013-04-18','10:10:00',2.56),('8998','2013-04-18','10:15:00',2.64),('8998','2013-04-18','10:20:00',1.97),('8998','2013-04-18','10:25:00',2.64),('8998','2013-04-18','10:30:00',2.33),('8998','2013-04-18','10:35:00',2.41),('8998','2013-04-18','10:40:00',2.7),('8998','2013-04-18','10:45:00',2.67),('8998','2013-04-18','10:50:00',2.72),('8998','2013-04-18','10:55:00',2.69),('8998','2013-04-18','11:00:00',2.69),('8998','2013-04-18','11:05:00',2.7),('8998','2013-04-18','11:10:00',2.71),('8998','2013-04-18','11:15:00',2.72),('8998','2013-04-18','11:20:00',2.7),('8998','2013-04-18','11:25:00',2.72),('8998','2013-04-18','11:30:00',2.73),('8998','2013-04-18','11:35:00',2.76),('8998','2013-04-18','11:40:00',2.77),('8998','2013-04-18','11:45:00',2.78),('8998','2013-04-18','11:50:00',2.79),('8998','2013-04-18','11:55:00',2.78),('8998','2013-04-18','12:00:00',2.77),('8998','2013-04-18','12:05:00',2.76),('8998','2013-04-18','12:10:00',2.76),('8998','2013-04-18','12:15:00',2.78),('8998','2013-04-18','12:20:00',2.76),('8998','2013-04-18','12:25:00',2.75),('8998','2013-04-18','12:30:00',2.69),('8998','2013-04-18','12:35:00',2.66),('8998','2013-04-18','12:40:00',2.68),('8998','2013-04-18','12:45:00',2.69),('8998','2013-04-18','12:50:00',2.68),('8998','2013-04-18','12:55:00',2.62),('8998','2013-04-18','13:00:00',2.64),('8998','2013-04-18','13:05:00',2.6),('8998','2013-04-18','13:10:00',2.6),('8998','2013-04-18','13:15:00',2.61),('8998','2013-04-18','13:20:00',2.56),('8998','2013-04-18','13:25:00',2.55),('8998','2013-04-18','13:30:00',2.58),('8998','2013-04-18','13:35:00',2.49),('8998','2013-04-18','13:40:00',2.48),('8998','2013-04-18','13:45:00',2.45),('8998','2013-04-18','13:50:00',2.41),('8998','2013-04-18','13:55:00',2.34),('8998','2013-04-18','14:00:00',2.33),('8998','2013-04-18','14:05:00',2.28),('8998','2013-04-18','14:10:00',2.29),('8998','2013-04-18','14:15:00',2.23),('8998','2013-04-18','14:20:00',2.18),('8998','2013-04-18','14:25:00',2.13),('8998','2013-04-18','14:30:00',2.14),('8998','2013-04-18','14:35:00',2.08),('8998','2013-04-18','14:40:00',2.04),('8998','2013-04-18','14:45:00',2.01),('8998','2013-04-18','14:50:00',2),('8998','2013-04-18','14:55:00',1.97),('8998','2013-04-18','15:00:00',1.91),('8998','2013-04-18','15:05:00',1.87),('8998','2013-04-18','15:10:00',1.81),('8998','2013-04-18','15:15:00',1.76),('8998','2013-04-18','15:20:00',1.69),('8998','2013-04-18','15:25:00',1.65),('8998','2013-04-18','15:30:00',1.59),('8998','2013-04-18','15:35:00',1.54),('8998','2013-04-18','15:40:00',1.5),('8998','2013-04-18','15:45:00',1.45),('8998','2013-04-18','15:50:00',1.4),('8998','2013-04-18','15:55:00',1.35),('8998','2013-04-18','16:00:00',1.3),('8998','2013-04-18','16:05:00',1.25),('8998','2013-04-18','16:10:00',1.19),('8998','2013-04-18','16:15:00',1.13),('8998','2013-04-18','16:20:00',1.08),('8998','2013-04-18','16:25:00',1.04),('8998','2013-04-17','08:10:00',1.02),('8998','2013-04-17','08:15:00',1.1),('8998','2013-04-17','08:20:00',1.13),('8998','2013-04-17','08:25:00',1.11),('8998','2013-04-17','08:30:00',1.29),('8998','2013-04-17','08:35:00',1.32),('8998','2013-04-17','08:40:00',1.26),('8998','2013-04-17','08:45:00',1.28),('8998','2013-04-17','08:50:00',1.4),('8998','2013-04-17','08:55:00',1.55),('8998','2013-04-17','09:00:00',1.49),('8998','2013-04-17','09:05:00',1.7),('8998','2013-04-17','09:10:00',1.63),('8998','2013-04-17','09:15:00',1.66),('8998','2013-04-17','09:20:00',1.82),('8998','2013-04-17','09:25:00',2.04),('8998','2013-04-17','09:30:00',2.13),('8998','2013-04-17','09:35:00',2.26),('8998','2013-04-17','09:40:00',2.62),('8998','2013-04-17','09:45:00',2.31),('8998','2013-04-17','09:50:00',2),('8998','2013-04-17','09:55:00',2.05),('8998','2013-04-17','10:00:00',2.47),('8998','2013-04-17','10:05:00',2.65),('8998','2013-04-17','10:10:00',2.67),('8998','2013-04-17','10:15:00',2.75),('8998','2013-04-17','10:20:00',2.77),('8998','2013-04-17','10:25:00',2.74),('8998','2013-04-17','10:30:00',2.79),('8998','2013-04-17','10:35:00',2.79),('8998','2013-04-17','10:40:00',2.81),('8998','2013-04-17','10:45:00',2.81),('8998','2013-04-17','10:50:00',2.82),('8998','2013-04-17','10:55:00',2.83),('8998','2013-04-17','11:00:00',2.84),('8998','2013-04-17','11:05:00',2.86),('8998','2013-04-17','11:10:00',2.86),('8998','2013-04-17','11:15:00',2.87),('8998','2013-04-17','11:20:00',2.89),('8998','2013-04-17','11:25:00',2.89),('8998','2013-04-17','11:30:00',2.88),('8998','2013-04-17','11:35:00',2.88),('8998','2013-04-17','11:40:00',2.86),('8998','2013-04-17','11:45:00',2.82),('8998','2013-04-17','11:50:00',2.81),('8998','2013-04-17','11:55:00',2.86),('8998','2013-04-17','12:00:00',2.82),('8998','2013-04-17','12:05:00',2.89),('8998','2013-04-17','12:10:00',2.89),('8998','2013-04-17','12:15:00',2.85),('8998','2013-04-17','12:20:00',2.85),('8998','2013-04-17','12:25:00',2.85),('8998','2013-04-17','12:30:00',2.83),('8998','2013-04-17','12:35:00',2.82),('8998','2013-04-17','12:40:00',2.83),('8998','2013-04-17','12:45:00',2.81),('8998','2013-04-17','12:50:00',2.79),('8998','2013-04-17','12:55:00',2.79),('8998','2013-04-17','13:00:00',2.77),('8998','2013-04-17','13:05:00',2.74),('8998','2013-04-17','13:10:00',2.72),('8998','2013-04-17','13:15:00',2.71),('8998','2013-04-17','13:20:00',2.67),('8998','2013-04-17','13:25:00',2.65),('8998','2013-04-17','13:30:00',2.64),('8998','2013-04-17','13:35:00',2.61),('8998','2013-04-17','13:40:00',2.57),('8998','2013-04-17','13:45:00',2.53),('8998','2013-04-17','13:50:00',2.53),('8998','2013-04-17','13:55:00',2.5),('8998','2013-04-17','14:00:00',2.45),('8998','2013-04-17','14:05:00',2.42),('8998','2013-04-17','14:10:00',2.39),('8998','2013-04-17','14:15:00',2.35),('8998','2013-04-17','14:20:00',2.32),('8998','2013-04-17','14:25:00',2.29),('8998','2013-04-17','14:30:00',2.24),('8998','2013-04-17','14:35:00',2.2),('8998','2013-04-17','14:40:00',2.16),('8998','2013-04-17','14:45:00',2.11),('8998','2013-04-17','14:50:00',2.06),('8998','2013-04-17','14:55:00',2.01),('8998','2013-04-17','15:00:00',1.95),('8998','2013-04-17','15:05:00',1.92),('8998','2013-04-17','15:10:00',1.87),('8998','2013-04-17','15:15:00',1.82),('8998','2013-04-17','15:20:00',1.77),('8998','2013-04-17','15:25:00',1.71),('8998','2013-04-17','15:30:00',1.66),('8998','2013-04-17','15:35:00',1.62),('8998','2013-04-17','15:40:00',1.56),('8998','2013-04-17','15:45:00',1.5),('8998','2013-04-17','15:50:00',1.45),('8998','2013-04-17','15:55:00',1.39),('8998','2013-04-17','16:00:00',1.34),('8998','2013-04-17','16:05:00',1.27),('8998','2013-04-17','16:10:00',1.23),('8998','2013-04-17','16:15:00',1.18),('8998','2013-04-17','16:20:00',1.11),('8998','2013-04-17','16:25:00',1.05),('8998','2013-04-16','07:55:00',1.01),('8998','2013-04-16','08:00:00',1.07),('8998','2013-04-16','08:05:00',1.16),('8998','2013-04-16','08:10:00',1.15),('8998','2013-04-16','08:15:00',1.39),('8998','2013-04-16','08:20:00',1.36),('8998','2013-04-16','08:25:00',1.43),('8998','2013-04-16','08:30:00',1.35),('8998','2013-04-16','08:35:00',1.38),('8998','2013-04-16','08:40:00',1.48),('8998','2013-04-16','08:45:00',1.52),('8998','2013-04-16','08:50:00',2.02),('8998','2013-04-16','08:55:00',2.07),('8998','2013-04-16','09:00:00',2.12),('8998','2013-04-16','09:05:00',2.16),('8998','2013-04-16','09:10:00',2.21),('8998','2013-04-16','09:15:00',2.29),('8998','2013-04-16','09:20:00',2.34),('8998','2013-04-16','09:25:00',2.38),('8998','2013-04-16','09:30:00',2.42),('8998','2013-04-16','09:35:00',2.46),('8998','2013-04-16','09:40:00',2.53),('8998','2013-04-16','09:45:00',2.56),('8998','2013-04-16','09:50:00',2.59),('8998','2013-04-16','09:55:00',2.61),('8998','2013-04-16','10:00:00',2.65),('8998','2013-04-16','10:05:00',2.68),('8998','2013-04-16','10:10:00',2.71),('8998','2013-04-16','10:15:00',2.73),('8998','2013-04-16','10:20:00',2.75),('8998','2013-04-16','10:25:00',2.78),('8998','2013-04-16','10:30:00',2.79),('8998','2013-04-16','10:35:00',2.81),('8998','2013-04-16','10:40:00',2.83),('8998','2013-04-16','10:45:00',2.84),('8998','2013-04-16','10:50:00',2.86),('8998','2013-04-16','10:55:00',2.87),('8998','2013-04-16','11:00:00',2.89),('8998','2013-04-16','11:05:00',2.91),('8998','2013-04-16','11:10:00',2.9),('8998','2013-04-16','11:15:00',2.9),('8998','2013-04-16','11:20:00',2.91),('8998','2013-04-16','11:25:00',2.91),('8998','2013-04-16','11:30:00',2.89),('8998','2013-04-16','11:35:00',2.89),('8998','2013-04-16','11:40:00',2.9),('8998','2013-04-16','11:45:00',2.9),('8998','2013-04-16','11:50:00',2.92),('8998','2013-04-16','11:55:00',2.9),('8998','2013-04-16','12:00:00',2.89),('8998','2013-04-16','12:05:00',2.91),('8998','2013-04-16','12:10:00',2.89),('8998','2013-04-16','12:15:00',2.88),('8998','2013-04-16','12:20:00',2.86),('8998','2013-04-16','12:25:00',2.87),('8998','2013-04-16','12:30:00',2.87),('8998','2013-04-16','12:35:00',2.84),('8998','2013-04-16','12:40:00',2.82),('8998','2013-04-16','12:45:00',2.82),('8998','2013-04-16','12:50:00',2.8),('8998','2013-04-16','12:55:00',2.79),('8998','2013-04-16','13:00:00',2.75),('8998','2013-04-16','13:05:00',2.71),('8998','2013-04-16','13:10:00',2.69),('8998','2013-04-16','13:15:00',2.69),('8998','2013-04-16','13:20:00',2.69),('8998','2013-04-16','13:25:00',2.68),('8998','2013-04-16','13:30:00',2.64),('8998','2013-04-16','13:35:00',2.57),('8998','2013-04-16','13:40:00',2.6),('8998','2013-04-16','13:45:00',2.39),('8998','2013-04-16','13:50:00',2.39),('8998','2013-04-16','13:55:00',2.58),('8998','2013-04-16','14:00:00',2.44),('8998','2013-04-16','14:05:00',2.62),('8998','2013-04-16','14:10:00',2.55),('8998','2013-04-16','14:15:00',2.24),('8998','2013-04-16','14:20:00',2.21),('8998','2013-04-16','14:25:00',2.22),('8998','2013-04-16','14:30:00',2.08),('8998','2013-04-16','14:35:00',2.41),('8998','2013-04-16','14:40:00',2.32),('8998','2013-04-16','14:45:00',1.91),('8998','2013-04-16','14:50:00',2.19),('8998','2013-04-16','14:55:00',2.21),('8998','2013-04-16','15:00:00',2.16),('8998','2013-04-16','15:05:00',2.22),('8998','2013-04-16','15:10:00',2.27),('8998','2013-04-16','15:15:00',1.99),('8998','2013-04-16','15:25:00',1.06),('8998','2013-04-16','15:30:00',1.65),('8998','2013-04-16','15:35:00',1.74),('8998','2013-04-16','15:40:00',1.73),('8998','2013-04-16','15:45:00',1.75),('8998','2013-04-16','15:50:00',1.74),('8998','2013-04-16','15:55:00',1.75),('8998','2013-04-16','16:00:00',1.65),('8998','2013-04-16','16:05:00',1.2),('8998','2013-04-16','16:10:00',1.43),('8998','2013-04-16','16:15:00',1.33),('8998','2013-04-16','16:20:00',1.23),('8998','2013-04-16','16:25:00',1.16),('8998','2013-04-16','16:30:00',1.11),('8998','2013-04-16','16:35:00',1.09),('8998','2013-04-15','08:05:00',1.06),('8998','2013-04-15','08:10:00',1.05),('8998','2013-04-15','09:10:00',1.3),('8998','2013-04-15','09:15:00',1.6),('8998','2013-04-15','09:20:00',1.18),('8998','2013-04-15','09:25:00',1.5),('8998','2013-04-15','09:30:00',1.36),('8998','2013-04-15','09:35:00',1.16),('8998','2013-04-15','09:40:00',1.08),('8998','2013-04-15','09:45:00',1.07),('8998','2013-04-15','09:50:00',1.02),('8998','2013-04-15','10:15:00',1.06),('8998','2013-04-15','10:20:00',1.09),('8998','2013-04-15','10:25:00',1.12),('8998','2013-04-15','10:30:00',1.13),('8998','2013-04-15','10:35:00',1.14),('8998','2013-04-15','10:40:00',1.09),('8998','2013-04-15','10:45:00',1.04),('8998','2013-04-15','10:50:00',1.06),('8998','2013-04-15','10:55:00',1.14),('8998','2013-04-15','11:00:00',1.25),('8998','2013-04-15','11:05:00',1.28),('8998','2013-04-15','11:10:00',1.29),('8998','2013-04-15','11:15:00',1.33),('8998','2013-04-15','11:20:00',1.37),('8998','2013-04-15','11:25:00',1.36),('8998','2013-04-15','11:30:00',1.33),('8998','2013-04-15','11:35:00',1.33),('8998','2013-04-15','11:40:00',1.48),('8998','2013-04-15','11:45:00',1.72),('8998','2013-04-15','11:50:00',1.83),('8998','2013-04-15','11:55:00',1.89),('8998','2013-04-15','12:00:00',2.13),('8998','2013-04-15','12:05:00',2.76),('8998','2013-04-15','12:10:00',2.9),('8998','2013-04-15','12:15:00',3.39),('8998','2013-04-15','12:20:00',2.49),('8998','2013-04-15','12:25:00',2.14),('8998','2013-04-15','12:30:00',2.5),('8998','2013-04-15','12:35:00',2.79),('8998','2013-04-15','12:40:00',2.9),('8998','2013-04-15','12:45:00',2.38),('8998','2013-04-15','12:50:00',2.04),('8998','2013-04-15','12:55:00',2.71),('8998','2013-04-15','13:00:00',2.78),('8998','2013-04-15','13:05:00',2.61),('8998','2013-04-15','13:10:00',2.62),('8998','2013-04-15','13:15:00',2.62),('8998','2013-04-15','13:20:00',2.63),('8998','2013-04-15','13:25:00',2.62),('8998','2013-04-15','13:30:00',2.6),('8998','2013-04-15','13:35:00',2.58),('8998','2013-04-15','13:40:00',2.53),('8998','2013-04-15','13:45:00',2.47),('8998','2013-04-15','13:50:00',2.44),('8998','2013-04-15','13:55:00',2.33),('8998','2013-04-15','14:00:00',2.33),('8998','2013-04-15','14:05:00',2.36),('8998','2013-04-15','14:10:00',2.34),('8998','2013-04-15','14:15:00',2.23),('8998','2013-04-15','14:20:00',2.24),('8998','2013-04-15','14:25:00',1.74),('8998','2013-04-15','14:30:00',1.82),('8998','2013-04-15','14:35:00',1.81),('8998','2013-04-15','14:40:00',2.03),('8998','2013-04-15','14:45:00',2.09),('8998','2013-04-15','14:50:00',1.98),('8998','2013-04-15','14:55:00',1.9),('8998','2013-04-15','15:00:00',1.94),('8998','2013-04-15','15:05:00',1.89),('8998','2013-04-15','15:10:00',1.85),('8998','2013-04-15','15:15:00',1.82),('8998','2013-04-15','15:20:00',1.77),('8998','2013-04-15','15:25:00',1.67),('8998','2013-04-15','15:30:00',1.58),('8998','2013-04-15','15:35:00',1.57),('8998','2013-04-15','15:40:00',1.53),('8998','2013-04-15','15:45:00',1.48),('8998','2013-04-15','15:50:00',1.45),('8998','2013-04-15','15:55:00',1.39),('8998','2013-04-15','16:00:00',1.28),('8998','2013-04-15','16:05:00',1.28),('8998','2013-04-15','16:10:00',1.23),('8998','2013-04-15','16:15:00',1.16),('8998','2013-04-15','16:20:00',1.14),('8998','2013-04-15','16:25:00',1.1),('8998','2013-04-15','16:30:00',1.07),('8998','2013-04-15','16:35:00',1.07),('8998','2013-04-15','16:40:00',1.17),('8998','2013-04-15','16:45:00',1.16),('8998','2013-04-14','08:00:00',1.14),('8998','2013-04-14','08:05:00',1.13),('8998','2013-04-14','08:10:00',1.15),('8998','2013-04-14','08:15:00',1.22),('8998','2013-04-14','08:20:00',1.26),('8998','2013-04-14','08:25:00',1.45),('8998','2013-04-14','08:30:00',1.35),('8998','2013-04-14','08:35:00',1.63),('8998','2013-04-14','08:40:00',1.5),('8998','2013-04-14','08:45:00',1.52),('8998','2013-04-14','08:50:00',2.05),('8998','2013-04-14','08:55:00',2.11),('8998','2013-04-14','09:00:00',2.15),('8998','2013-04-14','09:05:00',2.2),('8998','2013-04-14','09:10:00',2.29),('8998','2013-04-14','09:15:00',2.33),('8998','2013-04-14','09:20:00',2.37),('8998','2013-04-14','09:25:00',2.4),('8998','2013-04-14','09:30:00',2.43),('8998','2013-04-14','09:35:00',2.46),('8998','2013-04-14','09:40:00',2.54),('8998','2013-04-14','09:45:00',2.57),('8998','2013-04-14','09:50:00',2.59),('8998','2013-04-14','09:55:00',2.62),('8998','2013-04-14','10:00:00',2.65),('8998','2013-04-14','10:05:00',2.67),('8998','2013-04-14','10:10:00',2.7),('8998','2013-04-14','10:15:00',2.73),('8998','2013-04-14','10:20:00',2.74),('8998','2013-04-14','10:25:00',2.75),('8998','2013-04-14','10:30:00',2.78),('8998','2013-04-14','10:35:00',2.8),('8998','2013-04-14','10:40:00',2.81),('8998','2013-04-14','10:45:00',2.83),('8998','2013-04-14','10:50:00',2.84),('8998','2013-04-14','10:55:00',2.86),('8998','2013-04-14','11:00:00',2.87),('8998','2013-04-14','11:05:00',2.89),('8998','2013-04-14','11:10:00',2.89),('8998','2013-04-14','11:15:00',2.91),('8998','2013-04-14','11:20:00',2.89),('8998','2013-04-14','11:25:00',2.89),('8998','2013-04-14','11:30:00',2.9),('8998','2013-04-14','11:35:00',2.9),('8998','2013-04-14','11:40:00',2.89),('8998','2013-04-14','11:45:00',2.9),('8998','2013-04-14','11:50:00',2.9),('8998','2013-04-14','11:55:00',2.89),('8998','2013-04-14','12:00:00',2.89),('8998','2013-04-14','12:05:00',2.86),('8998','2013-04-14','12:10:00',2.86),('8998','2013-04-14','12:15:00',2.88),('8998','2013-04-14','12:20:00',2.85),('8998','2013-04-14','12:25:00',2.82),('8998','2013-04-14','12:30:00',2.82),('8998','2013-04-14','12:35:00',2.81),('8998','2013-04-14','12:40:00',2.8),('8998','2013-04-14','12:45:00',2.77),('8998','2013-04-14','12:50:00',2.76),('8998','2013-04-14','12:55:00',2.74),('8998','2013-04-14','13:00:00',2.72),('8998','2013-04-14','13:05:00',2.7),('8998','2013-04-14','13:10:00',2.72),('8998','2013-04-14','13:15:00',2.71),('8998','2013-04-14','13:20:00',2.66),('8998','2013-04-14','13:25:00',2.62),('8998','2013-04-14','13:30:00',2.59),('8998','2013-04-14','13:35:00',2.59),('8998','2013-04-14','13:40:00',2.58),('8998','2013-04-14','13:45:00',2.51),('8998','2013-04-14','13:50:00',2.48),('8998','2013-04-14','13:55:00',2.47),('8998','2013-04-14','14:00:00',2.45),('8998','2013-04-14','14:05:00',2.41),('8998','2013-04-14','14:10:00',2.38),('8998','2013-04-14','14:15:00',2.36),('8998','2013-04-14','14:20:00',2.33),('8998','2013-04-14','14:25:00',2.28),('8998','2013-04-14','14:30:00',2.24),('8998','2013-04-14','14:35:00',2.19),('8998','2013-04-14','14:40:00',2.15),('8998','2013-04-14','14:45:00',2.11),('8998','2013-04-14','14:50:00',2.07),('8998','2013-04-14','14:55:00',2.02),('8998','2013-04-14','15:00:00',1.97),('8998','2013-04-14','15:05:00',1.93),('8998','2013-04-14','15:10:00',1.88),('8998','2013-04-14','15:15:00',1.82),('8998','2013-04-14','15:20:00',1.78),('8998','2013-04-14','15:25:00',1.72),('8998','2013-04-14','15:30:00',1.67),('8998','2013-04-14','15:35:00',1.62),('8998','2013-04-14','15:40:00',1.56),('8998','2013-04-14','15:45:00',1.5),('8998','2013-04-14','15:50:00',1.45),('8998','2013-04-14','15:55:00',1.39),('8998','2013-04-14','16:00:00',1.33),('8998','2013-04-14','16:05:00',1.27),('8998','2013-04-14','16:10:00',1.22),('8998','2013-04-14','16:15:00',1.16),('8998','2013-04-14','16:20:00',1.1),('8998','2013-04-14','16:25:00',1.04),('8998','2013-04-13','08:05:00',1.01),('8998','2013-04-13','08:10:00',1.11),('8998','2013-04-13','08:15:00',1.17),('8998','2013-04-13','08:20:00',1.22),('8998','2013-04-13','08:25:00',1.42),('8998','2013-04-13','08:30:00',1.34),('8998','2013-04-13','08:35:00',1.32),('8998','2013-04-13','08:40:00',1.41),('8998','2013-04-13','08:45:00',1.45),('8998','2013-04-13','08:50:00',1.58),('8998','2013-04-13','08:55:00',1.77),('8998','2013-04-13','09:00:00',1.97),('8998','2013-04-13','09:05:00',2.07),('8998','2013-04-13','09:10:00',2.12),('8998','2013-04-13','09:15:00',2.16),('8998','2013-04-13','09:20:00',2.21),('8998','2013-04-13','09:25:00',2.26),('8998','2013-04-13','09:30:00',2.29),('8998','2013-04-13','09:35:00',2.34),('8998','2013-04-13','09:40:00',2.43),('8998','2013-04-13','09:45:00',2.46),('8998','2013-04-13','09:50:00',2.5),('8998','2013-04-13','09:55:00',2.53),('8998','2013-04-13','10:00:00',2.57),('8998','2013-04-13','10:05:00',2.61),('8998','2013-04-13','10:10:00',2.63),('8998','2013-04-13','10:15:00',2.65),('8998','2013-04-13','10:20:00',2.67),('8998','2013-04-13','10:25:00',2.69),('8998','2013-04-13','10:30:00',2.71),('8998','2013-04-13','10:35:00',2.73),('8998','2013-04-13','10:40:00',2.74),('8998','2013-04-13','10:45:00',2.76),('8998','2013-04-13','10:50:00',2.78),('8998','2013-04-13','10:55:00',2.79),('8998','2013-04-13','11:00:00',2.82),('8998','2013-04-13','11:05:00',2.82),('8998','2013-04-13','11:10:00',2.85),('8998','2013-04-13','11:15:00',2.85),('8998','2013-04-13','11:20:00',2.84),('8998','2013-04-13','11:25:00',2.82),('8998','2013-04-13','11:30:00',2.83),('8998','2013-04-13','11:35:00',2.86),('8998','2013-04-13','11:40:00',2.87),('8998','2013-04-13','11:45:00',2.86),('8998','2013-04-13','11:50:00',2.83),('8998','2013-04-13','11:55:00',2.84),('8998','2013-04-13','12:00:00',2.81),('8998','2013-04-13','12:05:00',2.8),('8998','2013-04-13','12:10:00',2.83),('8998','2013-04-13','12:15:00',2.81),('8998','2013-04-13','12:20:00',2.82),('8998','2013-04-13','12:25:00',2.79),('8998','2013-04-13','12:30:00',2.78),('8998','2013-04-13','12:35:00',2.79),('8998','2013-04-13','12:40:00',2.81),('8998','2013-04-13','12:45:00',2.82),('8998','2013-04-13','12:50:00',2.83),('8998','2013-04-13','12:55:00',2.88),('8998','2013-04-13','13:00:00',2.11),('8998','2013-04-13','13:05:00',2.2),('8998','2013-04-13','13:10:00',2.84),('8998','2013-04-13','13:15:00',2.8),('8998','2013-04-13','13:20:00',2.75),('8998','2013-04-13','13:25:00',2.71),('8998','2013-04-13','13:30:00',2.61),('8998','2013-04-13','13:35:00',2.6),('8998','2013-04-13','13:40:00',2.56),('8998','2013-04-13','13:45:00',2.52),('8998','2013-04-13','13:50:00',2.47),('8998','2013-04-13','13:55:00',2.42),('8998','2013-04-13','14:00:00',2.37),('8998','2013-04-13','14:05:00',2.39),('8998','2013-04-13','14:10:00',2.38),('8998','2013-04-13','14:15:00',2.34),('8998','2013-04-13','14:20:00',2.29),('8998','2013-04-13','14:25:00',2.24),('8998','2013-04-13','14:30:00',2.22),('8998','2013-04-13','14:35:00',2.23),('8998','2013-04-13','14:40:00',2.24),('8998','2013-04-13','14:45:00',2.27),('8998','2013-04-13','14:50:00',2.25),('8998','2013-04-13','14:55:00',2.12),('8998','2013-04-13','15:00:00',2.08),('8998','2013-04-13','15:05:00',2.04),('8998','2013-04-13','15:10:00',1.91),('8998','2013-04-13','15:15:00',1.81),('8998','2013-04-13','15:20:00',1.64),('8998','2013-04-13','15:25:00',1.48),('8998','2013-04-13','15:30:00',1.72),('8998','2013-04-13','15:35:00',1.76),('8998','2013-04-13','15:40:00',1.77),('8998','2013-04-13','15:45:00',1.65),('8998','2013-04-13','15:50:00',1.54),('8998','2013-04-13','16:00:00',1.36),('8998','2013-04-13','16:05:00',1.29),('8998','2013-04-13','16:10:00',1.24),('8998','2013-04-13','16:15:00',1.13),('8998','2013-04-13','16:20:00',1.08),('8998','2013-04-13','16:25:00',1.06),('8998','2013-04-12','08:05:00',1.09),('8998','2013-04-12','08:10:00',1.05),('8998','2013-04-12','09:00:00',1),('8998','2013-04-12','09:05:00',1.49),('8998','2013-04-12','09:10:00',1.54),('8998','2013-04-12','09:15:00',2.02),('8998','2013-04-12','09:20:00',2.09),('8998','2013-04-12','09:25:00',1.89),('8998','2013-04-12','09:30:00',2.34),('8998','2013-04-12','09:35:00',2.31),('8998','2013-04-12','09:40:00',2.12),('8998','2013-04-12','09:45:00',2.47),('8998','2013-04-12','09:50:00',2.49),('8998','2013-04-12','09:55:00',2.57),('8998','2013-04-12','10:00:00',2.61),('8998','2013-04-12','10:05:00',2.62),('8998','2013-04-12','10:10:00',2.72),('8998','2013-04-12','10:15:00',2.9),('8998','2013-04-12','10:20:00',2.9),('8998','2013-04-12','10:25:00',2.37),('8998','2013-04-12','10:30:00',2.63),('8998','2013-04-12','10:35:00',1.75),('8998','2013-04-12','10:40:00',1.69),('8998','2013-04-12','10:45:00',2.57),('8998','2013-04-12','10:50:00',1.16),('8998','2013-04-12','10:55:00',2.06),('8998','2013-04-12','11:00:00',1.8),('8998','2013-04-12','11:05:00',1.84),('8998','2013-04-12','11:10:00',1.53),('8998','2013-04-12','11:15:00',2.03),('8998','2013-04-12','11:20:00',2.74),('8998','2013-04-12','11:25:00',1.36),('8998','2013-04-12','11:30:00',1.03),('8998','2013-04-12','11:35:00',3.3),('8998','2013-04-12','11:40:00',2.89),('8998','2013-04-12','11:45:00',2.31),('8998','2013-04-12','11:50:00',3.16),('8998','2013-04-12','11:55:00',1.78),('8998','2013-04-12','12:00:00',3.17),('8998','2013-04-12','12:05:00',3.07),('8998','2013-04-12','12:10:00',3.12),('8998','2013-04-12','12:15:00',3.09),('8998','2013-04-12','12:20:00',2.95),('8998','2013-04-12','12:25:00',2.92),('8998','2013-04-12','12:30:00',2.62),('8998','2013-04-12','12:35:00',2.96),('8998','2013-04-12','12:40:00',2.96),('8998','2013-04-12','12:45:00',2.88),('8998','2013-04-12','12:50:00',2.8),('8998','2013-04-12','12:55:00',2.82),('8998','2013-04-12','13:00:00',2.6),('8998','2013-04-12','13:05:00',2.84),('8998','2013-04-12','13:10:00',2.89),('8998','2013-04-12','13:15:00',2.75),('8998','2013-04-12','13:20:00',2.52),('8998','2013-04-12','13:25:00',2.72),('8998','2013-04-12','13:30:00',2.7),('8998','2013-04-12','13:35:00',1.5),('8998','2013-04-12','13:40:00',1.3),('8998','2013-04-12','13:45:00',2.28),('8998','2013-04-12','13:50:00',1.91),('8998','2013-04-12','13:55:00',1.23),('8998','2013-04-12','14:00:00',1.35),('8998','2013-04-12','14:05:00',1.58),('8998','2013-04-12','14:10:00',1.05),('8998','2013-04-12','14:15:00',1.1),('8998','2013-04-12','14:20:00',2.04),('8998','2013-04-12','14:25:00',2.24),('8998','2013-04-12','14:30:00',2.16),('8998','2013-04-12','14:35:00',2.28),('8998','2013-04-12','14:40:00',2.14),('8998','2013-04-12','14:45:00',2.1),('8998','2013-04-12','14:50:00',1.99),('8998','2013-04-12','14:55:00',1.98),('8998','2013-04-12','15:00:00',1.83),('8998','2013-04-12','15:05:00',1.61),('8998','2013-04-12','15:10:00',1.47),('8998','2013-04-12','15:15:00',1.65),('8998','2013-04-12','15:20:00',1.57),('8998','2013-04-12','15:25:00',1.47),('8998','2013-04-12','15:30:00',1.48),('8998','2013-04-12','15:35:00',1.42),('8998','2013-04-12','15:40:00',1.44),('8998','2013-04-12','15:45:00',1.44),('8998','2013-04-12','15:50:00',1.39),('8998','2013-04-12','15:55:00',1.33),('8998','2013-04-12','16:00:00',1.32),('8998','2013-04-12','16:05:00',1.25),('8998','2013-04-12','16:10:00',1.16),('8998','2013-04-12','16:15:00',1.17),('8998','2013-04-12','16:20:00',1.11),('8998','2013-04-12','16:25:00',1.05),('8998','2013-04-12','16:30:00',1),('8998','2013-04-11','08:05:00',1.03),('8998','2013-04-11','08:10:00',1.23),('8998','2013-04-11','08:35:00',1.05),('8998','2013-04-11','08:45:00',1.03),('8998','2013-04-11','08:55:00',1),('8998','2013-04-11','09:00:00',1.62),('8998','2013-04-11','09:05:00',1.58),('8998','2013-04-11','09:10:00',1),('8998','2013-04-11','09:15:00',1.96),('8998','2013-04-11','09:20:00',1.66),('8998','2013-04-11','09:25:00',1.45),('8998','2013-04-11','09:30:00',1.62),('8998','2013-04-11','09:35:00',1.05),('8998','2013-04-11','09:40:00',1.39),('8998','2013-04-11','09:45:00',1.15),('8998','2013-04-11','09:50:00',1.08),('8998','2013-04-11','10:20:00',1.05),('8998','2013-04-11','10:25:00',1.26),('8998','2013-04-11','10:40:00',1.09),('8998','2013-04-11','10:45:00',2.88),('8998','2013-04-11','10:50:00',2.33),('8998','2013-04-11','10:55:00',3.49),('8998','2013-04-11','11:00:00',1.44),('8998','2013-04-11','11:05:00',1.04),('8998','2013-04-11','11:10:00',1.28),('8998','2013-04-11','11:15:00',1.75),('8998','2013-04-11','11:20:00',3.46),('8998','2013-04-11','11:25:00',3.32),('8998','2013-04-11','11:30:00',2.44),('8998','2013-04-11','11:35:00',2.82),('8998','2013-04-11','11:40:00',3.21),('8998','2013-04-11','11:45:00',2.56),('8998','2013-04-11','11:50:00',2.37),('8998','2013-04-11','11:55:00',3.16),('8998','2013-04-11','12:00:00',3.07),('8998','2013-04-11','12:05:00',2.9),('8998','2013-04-11','12:10:00',2.84),('8998','2013-04-11','12:15:00',2.96),('8998','2013-04-11','12:20:00',3.03),('8998','2013-04-11','12:25:00',2.99),('8998','2013-04-11','12:30:00',2.96),('8998','2013-04-11','12:35:00',2.89),('8998','2013-04-11','12:40:00',2.79),('8998','2013-04-11','12:45:00',2.77),('8998','2013-04-11','12:50:00',2.74),('8998','2013-04-11','12:55:00',2.85),('8998','2013-04-11','13:00:00',2.88),('8998','2013-04-11','13:05:00',2.82),('8998','2013-04-11','13:10:00',2.8),('8998','2013-04-11','13:15:00',2.76),('8998','2013-04-11','13:20:00',2.76),('8998','2013-04-11','13:25:00',2.72),('8998','2013-04-11','13:30:00',2.69),('8998','2013-04-11','13:35:00',2.68),('8998','2013-04-11','13:40:00',2.62),('8998','2013-04-11','13:45:00',2.62),('8998','2013-04-11','13:50:00',2.58),('8998','2013-04-11','13:55:00',2.54),('8998','2013-04-11','14:00:00',2.51),('8998','2013-04-11','14:05:00',2.48),('8998','2013-04-11','14:10:00',2.44),('8998','2013-04-11','14:15:00',2.39),('8998','2013-04-11','14:20:00',2.34),('8998','2013-04-11','14:25:00',2.3),('8998','2013-04-11','14:30:00',2.25),('8998','2013-04-11','14:35:00',2.21),('8998','2013-04-11','14:40:00',2.16),('8998','2013-04-11','14:45:00',2.12),('8998','2013-04-11','14:50:00',2.07),('8998','2013-04-11','14:55:00',2.02),('8998','2013-04-11','15:00:00',1.97),('8998','2013-04-11','15:05:00',1.93),('8998','2013-04-11','15:10:00',1.86),('8998','2013-04-11','15:15:00',1.81),('8998','2013-04-11','15:20:00',1.76),('8998','2013-04-11','15:25:00',1.7),('8998','2013-04-11','15:30:00',1.65),('8998','2013-04-11','15:35:00',1.59),('8998','2013-04-11','15:40:00',1.54),('8998','2013-04-11','15:45:00',1.48),('8998','2013-04-11','15:50:00',1.43),('8998','2013-04-11','15:55:00',1.37),('8998','2013-04-11','16:00:00',1.31),('8998','2013-04-11','16:05:00',1.26),('8998','2013-04-11','16:10:00',1.2),('8998','2013-04-11','16:15:00',1.06),('8998','2013-04-11','16:20:00',1.06),('8998','2013-04-11','16:25:00',1.03),('8998','2014-03-27','07:30:00',1.3),('8998','2014-03-27','07:35:00',1.42),('8998','2014-03-27','07:40:00',1.32),('8998','2014-03-27','07:45:00',1.35),('8998','2014-03-27','07:50:00',1.46),('8998','2014-03-27','07:55:00',1.57),('8998','2014-03-27','08:00:00',1.77),('8998','2014-03-27','08:05:00',1.88),('8998','2014-03-27','08:10:00',2.02),('8998','2014-03-27','08:15:00',2.17),('8998','2014-03-27','08:20:00',2.26),('8998','2014-03-27','08:25:00',2.29),('8998','2014-03-27','08:30:00',2.32),('8998','2014-03-27','08:35:00',2.36),('8998','2014-03-27','08:40:00',2.41),('8998','2014-03-27','08:45:00',2.42),('8998','2014-03-27','08:50:00',2.47),('8998','2014-03-27','08:55:00',2.52),('8998','2014-03-27','09:00:00',2.5),('8998','2014-03-27','09:05:00',2.62),('8998','2014-03-27','09:10:00',2.71),('8998','2014-03-27','09:15:00',2.61),('8998','2014-03-27','09:20:00',2.3),('8998','2014-03-27','09:25:00',2.61),('8998','2014-03-27','09:30:00',2.74),('8998','2014-03-27','09:35:00',2.29),('8998','2014-03-27','09:40:00',1.82),('8998','2014-03-27','09:45:00',1.41),('8998','2014-03-27','09:50:00',1.7),('8998','2014-03-27','09:55:00',2.75),('8998','2014-03-27','10:00:00',3),('8998','2014-03-27','10:05:00',2.84),('8998','2014-03-27','10:10:00',2.14),('8998','2014-03-27','10:15:00',2.19),('8998','2014-03-27','10:20:00',2.11),('8998','2014-03-27','10:25:00',2.84),('8998','2014-03-27','10:30:00',2.82),('8998','2014-03-27','10:35:00',2.64),('8998','2014-03-27','10:40:00',2.68),('8998','2014-03-27','10:45:00',2.06),('8998','2014-03-27','10:50:00',2.85),('8998','2014-03-27','10:55:00',2.95),('8998','2014-03-27','11:00:00',2.6),('8998','2014-03-27','11:05:00',2.95),('8998','2014-03-27','11:10:00',2.68),('8998','2014-03-27','11:15:00',2.48),('8998','2014-03-27','11:20:00',2.88),('8998','2014-03-27','11:25:00',2.08),('8998','2014-03-27','11:30:00',1.2),('8998','2014-03-27','11:35:00',2.74),('8998','2014-03-27','11:40:00',1.06),('8998','2014-03-27','11:45:00',1.27),('8998','2014-03-27','11:55:00',1.39),('8998','2014-03-27','12:00:00',2.63),('8998','2014-03-27','12:05:00',2.98),('8998','2014-03-27','12:10:00',3.01),('8998','2014-03-27','12:15:00',3.15),('8998','2014-03-27','12:20:00',2.82),('8998','2014-03-27','12:35:00',3.12),('8998','2014-03-27','12:40:00',1.99),('8998','2014-03-27','12:45:00',2.72),('8998','2014-03-27','12:50:00',2.62),('8998','2014-03-27','12:55:00',2.9),('8998','2014-03-27','13:00:00',2.13),('8998','2014-03-27','13:05:00',2.14),('8998','2014-03-27','13:15:00',1.22),('8998','2014-03-27','13:20:00',2.75),('8998','2014-03-27','13:25:00',1.14),('8998','2014-03-27','13:30:00',1.89),('8998','2014-03-27','13:35:00',2.3),('8998','2014-03-27','13:40:00',2.08),('8998','2014-03-27','13:45:00',2.22),('8998','2014-03-27','13:50:00',2.1),('8998','2014-03-27','13:55:00',1.99),('8998','2014-03-27','14:00:00',1.99),('8998','2014-03-27','14:05:00',1.9),('8998','2014-03-27','14:10:00',1.81),('8998','2014-03-27','14:15:00',1.8),('8998','2014-03-27','14:20:00',1.75),('8998','2014-03-27','14:25:00',1.69),('8998','2014-03-27','14:30:00',1.63),('8998','2014-03-27','14:35:00',1.57),('8998','2014-03-27','14:40:00',1.52),('8998','2014-03-27','14:45:00',1.46),('8998','2014-03-27','14:50:00',1.41),('8998','2014-03-27','14:55:00',1.36),('8998','2014-03-27','15:00:00',1.33),('8998','2014-03-27','15:05:00',1.22),('8998','2014-03-27','15:10:00',1.12),('8998','2014-03-27','15:15:00',1.08),('8998','2013-04-10','08:05:00',1.04),('8998','2013-04-10','08:10:00',1.1),('8998','2013-04-10','08:15:00',1.14),('8998','2013-04-10','08:20:00',1.16),('8998','2013-04-10','08:25:00',1.39),('8998','2013-04-10','08:30:00',1.34),('8998','2013-04-10','08:35:00',1.36),('8998','2013-04-10','08:40:00',1.34),('8998','2013-04-10','08:45:00',1.41),('8998','2013-04-10','08:50:00',1.77),('8998','2013-04-10','08:55:00',1.96),('8998','2013-04-10','09:00:00',2.08),('8998','2013-04-10','09:05:00',2.13),('8998','2013-04-10','09:10:00',2.16),('8998','2013-04-10','09:15:00',2.21),('8998','2013-04-10','09:20:00',2.25),('8998','2013-04-10','09:25:00',2.3),('8998','2013-04-10','09:30:00',2.28),('8998','2013-04-10','09:35:00',2.36),('8998','2013-04-10','09:40:00',2.42),('8998','2013-04-10','09:45:00',2.47),('8998','2013-04-10','09:50:00',2.54),('8998','2013-04-10','09:55:00',2.12),('8998','2013-04-10','10:00:00',1.48),('8998','2013-04-10','10:10:00',1.61),('8998','2013-04-10','10:15:00',1.94),('8998','2013-04-10','10:20:00',2.82),('8998','2013-04-10','10:25:00',2.75),('8998','2013-04-10','10:30:00',2.78),('8998','2013-04-10','10:35:00',2.94),('8998','2013-04-10','10:40:00',2.97),('8998','2013-04-10','10:45:00',3.13),('8998','2013-04-10','10:50:00',1.52),('8998','2013-04-10','11:05:00',2.91),('8998','2013-04-10','11:10:00',3.03),('8998','2013-04-10','11:15:00',3.03),('8998','2013-04-10','11:20:00',2.38),('8998','2013-04-10','11:25:00',1.17),('8998','2013-04-10','11:30:00',2.34),('8998','2013-04-10','11:35:00',3.14),('8998','2013-04-10','11:40:00',1.31),('8998','2013-04-10','11:55:00',1.33),('8998','2013-04-10','12:00:00',2.83),('8998','2013-04-10','12:05:00',3.21),('8998','2013-04-10','12:10:00',3.15),('8998','2013-04-10','12:15:00',1.23),('8998','2013-04-10','12:20:00',1.51),('8998','2013-04-10','12:25:00',3.25),('8998','2013-04-10','12:30:00',3.17),('8998','2013-04-10','12:35:00',3.15),('8998','2013-04-10','12:40:00',3.14),('8998','2013-04-10','12:45:00',3.11),('8998','2013-04-10','12:50:00',3.01),('8998','2013-04-10','12:55:00',2.5),('8998','2013-04-10','13:00:00',2.61),('8998','2013-04-10','13:05:00',2.79),('8998','2013-04-10','13:10:00',2.34),('8998','2013-04-10','13:15:00',2.9),('8998','2013-04-10','13:20:00',1.99),('8998','2013-04-10','13:25:00',2.5),('8998','2013-04-10','13:30:00',2.79),('8998','2013-04-10','13:35:00',2.72),('8998','2013-04-10','13:40:00',2.72),('8998','2013-04-10','13:45:00',2.65),('8998','2013-04-10','13:50:00',2.59),('8998','2013-04-10','13:55:00',2.62),('8998','2013-04-10','14:00:00',2.57),('8998','2013-04-10','14:05:00',2.54),('8998','2013-04-10','14:10:00',2.53),('8998','2013-04-10','14:15:00',2.48),('8998','2013-04-10','14:20:00',2.45),('8998','2013-04-10','14:25:00',2.38),('8998','2013-04-10','14:30:00',2.31),('8998','2013-04-10','14:35:00',2.05),('8998','2013-04-10','14:40:00',2.26),('8998','2013-04-10','14:45:00',2.29),('8998','2013-04-10','14:50:00',2.19),('8998','2013-04-10','14:55:00',2.11),('8998','2013-04-10','15:00:00',2.05),('8998','2013-04-10','15:05:00',1.99),('8998','2013-04-10','15:10:00',1.91),('8998','2013-04-10','15:15:00',1.85),('8998','2013-04-10','15:20:00',1.79),('8998','2013-04-10','15:25:00',1.73),('8998','2013-04-10','15:30:00',1.68),('8998','2013-04-10','15:35:00',1.63),('8998','2013-04-10','15:40:00',1.56),('8998','2013-04-10','15:45:00',1.5),('8998','2013-04-10','15:50:00',1.43),('8998','2013-04-10','15:55:00',1.38),('8998','2013-04-10','16:00:00',1.33),('8998','2013-04-10','16:05:00',1.27),('8998','2013-04-10','16:10:00',1.21),('8998','2013-04-10','16:15:00',1.14),('8998','2013-04-10','16:20:00',1.09),('8998','2013-04-10','16:25:00',1.03),('8998','2013-04-09','08:55:00',1.61),('8998','2013-04-09','09:00:00',2.06),('8998','2013-04-09','09:05:00',2.16),('8998','2013-04-09','09:10:00',2.22),('8998','2013-04-09','09:15:00',2.17),('8998','2013-04-09','09:20:00',2.13),('8998','2013-04-09','09:25:00',2.35),('8998','2013-04-09','09:30:00',2.44),('8998','2013-04-09','09:35:00',2.53),('8998','2013-04-09','09:40:00',2.55),('8998','2013-04-09','09:45:00',2.6),('8998','2013-04-09','09:50:00',2.66),('8998','2013-04-09','09:55:00',2.73),('8998','2013-04-09','10:00:00',2.75),('8998','2013-04-09','10:05:00',2.84),('8998','2013-04-09','10:10:00',2.97),('8998','2013-04-09','10:15:00',3.03),('8998','2013-04-09','10:20:00',3.02),('8998','2013-04-09','10:25:00',3.02),('8998','2013-04-09','10:30:00',3.02),('8998','2013-04-09','10:35:00',3.01),('8998','2013-04-09','10:40:00',3.01),('8998','2013-04-09','10:45:00',3.06),('8998','2013-04-09','10:50:00',2.87),('8998','2013-04-09','10:55:00',2.83),('8998','2013-04-09','11:00:00',2.8),('8998','2013-04-09','11:05:00',2.76),('8998','2013-04-09','11:10:00',2.82),('8998','2013-04-09','11:15:00',2.62),('8998','2013-04-09','11:20:00',2.94),('8998','2013-04-09','11:25:00',3.02),('8998','2013-04-09','11:30:00',2.98),('8998','2013-04-09','11:35:00',3),('8998','2013-04-09','11:40:00',2.92),('8998','2013-04-09','11:45:00',3.03),('8998','2013-04-09','11:50:00',2.98),('8998','2013-04-09','11:55:00',2.7),('8998','2013-04-09','12:00:00',3.03),('8998','2013-04-09','12:05:00',3.01),('8998','2013-04-09','12:10:00',3),('8998','2013-04-09','12:15:00',3.02),('8998','2013-04-09','12:20:00',3.01),('8998','2013-04-09','12:25:00',3.04),('8998','2013-04-09','12:30:00',3.05),('8998','2013-04-09','12:35:00',3.04),('8998','2013-04-09','12:40:00',2.97),('8998','2013-04-09','12:45:00',2.94),('8998','2013-04-09','12:50:00',2.96),('8998','2013-04-09','12:55:00',2.77),('8998','2013-04-09','13:00:00',2.89),('8998','2013-04-09','13:05:00',2.86),('8998','2013-04-09','13:10:00',2.96),('8998','2013-04-09','13:15:00',2.04),('8998','2013-04-09','13:20:00',3.41),('8998','2013-04-09','13:25:00',1.69),('8998','2013-04-09','13:30:00',1.95),('8998','2013-04-09','13:35:00',2.67),('8998','2013-04-09','13:40:00',2.2),('8998','2013-04-09','13:45:00',2.9),('8998','2013-04-09','13:50:00',2.18),('8998','2013-04-09','13:55:00',2.23),('8998','2013-04-09','14:00:00',2.02),('8998','2013-04-09','14:05:00',2.62),('8998','2013-04-09','14:10:00',2.61),('8998','2013-04-09','14:15:00',2.53),('8998','2013-04-09','14:20:00',2.49),('8998','2013-04-09','14:25:00',2.45),('8998','2013-04-09','14:30:00',2.41),('8998','2013-04-09','14:35:00',2.38),('8998','2013-04-09','14:40:00',2.35),('8998','2013-04-09','14:45:00',2.15),('8998','2013-04-09','14:50:00',2.16),('8998','2013-04-09','14:55:00',2.06),('8998','2013-04-09','15:00:00',2.21),('8998','2013-04-09','15:05:00',2.19),('8998','2013-04-09','15:10:00',2.12),('8998','2013-04-09','15:15:00',1.65),('8998','2013-04-09','15:20:00',1.49),('8998','2013-04-09','15:25:00',1.92),('8998','2013-04-09','15:30:00',1.72),('8998','2013-04-09','15:35:00',1.49),('8998','2013-04-09','15:40:00',1.65),('8998','2013-04-09','15:45:00',1.59),('8998','2013-04-09','15:50:00',1.68),('8998','2013-04-09','15:55:00',1.38),('8998','2013-04-09','16:00:00',1.47),('8998','2013-04-09','16:05:00',1.19),('8998','2013-04-09','16:10:00',1.31),('8998','2013-04-09','16:15:00',1.22),('8998','2013-04-09','16:20:00',1.26),('8998','2013-04-09','16:25:00',1.01),('8998','2013-04-09','16:30:00',1.06),('8998','2013-04-08','08:00:00',1.01),('8998','2013-04-08','08:20:00',1.42),('8998','2013-04-08','09:30:00',1.03),('8998','2013-04-08','09:50:00',1.45),('8998','2013-04-08','09:55:00',2.7),('8998','2013-04-08','10:00:00',1.63),('8998','2013-04-08','10:10:00',1.16),('8998','2013-04-08','10:15:00',1.63),('8998','2013-04-08','10:20:00',1.39),('8998','2013-04-08','10:35:00',2.59),('8998','2013-04-08','10:40:00',1.62),('8998','2013-04-08','10:45:00',2.57),('8998','2013-04-08','10:50:00',3.39),('8998','2013-04-08','10:55:00',2.7),('8998','2013-04-08','11:00:00',2.54),('8998','2013-04-08','11:05:00',2.82),('8998','2013-04-08','11:10:00',3.19),('8998','2013-04-08','11:15:00',1.77),('8998','2013-04-08','11:25:00',2.89),('8998','2013-04-08','11:30:00',3.53),('8998','2013-04-08','11:35:00',2.63),('8998','2013-04-08','11:45:00',2.28),('8998','2013-04-08','11:50:00',3.22),('8998','2013-04-08','11:55:00',1.76),('8998','2013-04-08','12:00:00',3.45),('8998','2013-04-08','12:05:00',3.23),('8998','2013-04-08','12:10:00',3.19),('8998','2013-04-08','12:15:00',3.17),('8998','2013-04-08','12:20:00',2.15),('8998','2013-04-08','12:25:00',2.83),('8998','2013-04-08','12:30:00',3.05),('8998','2013-04-08','12:35:00',2.75),('8998','2013-04-08','12:40:00',3.04),('8998','2013-04-08','12:45:00',2.97),('8998','2013-04-08','12:50:00',3.07),('8998','2013-04-08','12:55:00',3.02),('8998','2013-04-08','13:00:00',3.01),('8998','2013-04-08','13:05:00',3.04),('8998','2013-04-08','13:10:00',3.15),('8998','2013-04-08','13:15:00',3.09),('8998','2013-04-08','13:20:00',1.82),('8998','2013-04-08','13:25:00',2.78),('8998','2013-04-08','13:30:00',2.41),('8998','2013-04-08','13:40:00',1.46),('8998','2013-04-08','13:45:00',1.06),('8998','2013-04-08','13:50:00',2.08),('8998','2013-04-08','13:55:00',2.69),('8998','2013-04-08','14:00:00',2.53),('8998','2013-04-08','14:05:00',2.28),('8998','2013-04-08','14:10:00',1.92),('8998','2013-04-08','14:15:00',2.21),('8998','2013-04-08','14:20:00',1.29),('8998','2013-04-08','14:25:00',1.64),('8998','2013-04-08','14:30:00',2.13),('8998','2013-04-08','14:35:00',2.18),('8998','2013-04-08','14:40:00',2.28),('8998','2013-04-08','14:45:00',2.09),('8998','2013-04-08','14:50:00',2.02),('8998','2013-04-08','14:55:00',1.98),('8998','2013-04-08','15:00:00',1.63),('8998','2013-04-08','15:05:00',1.7),('8998','2013-04-08','15:10:00',2.15),('8998','2013-04-08','15:15:00',1.47),('8998','2013-04-08','15:20:00',1.95),('8998','2013-04-08','15:25:00',2.01),('8998','2013-04-08','15:30:00',1.72),('8998','2013-04-08','15:35:00',1.26),('8998','2013-04-08','15:40:00',1.82),('8998','2013-04-08','15:45:00',1.39),('8998','2013-04-08','15:50:00',1.58),('8998','2013-04-08','15:55:00',1.39),('8998','2013-04-08','16:00:00',1.25),('8998','2013-04-08','16:05:00',1.33),('8998','2013-04-08','16:10:00',1.34),('8998','2013-04-07','08:40:00',1.03),('8998','2013-04-07','08:45:00',1.1),('8998','2013-04-07','08:50:00',1.3),('8998','2013-04-07','08:55:00',1.09),('8998','2013-04-07','09:00:00',1.29),('8998','2013-04-07','09:05:00',1.41),('8998','2013-04-07','09:10:00',1.94),('8998','2013-04-07','09:15:00',1.79),('8998','2013-04-07','09:20:00',1.93),('8998','2013-04-07','09:25:00',1.84),('8998','2013-04-07','09:30:00',2.41),('8998','2013-04-07','09:35:00',2.6),('8998','2013-04-07','09:40:00',2.67),('8998','2013-04-07','09:45:00',2.65),('8998','2013-04-07','09:50:00',1.93),('8998','2013-04-07','09:55:00',1.31),('8998','2013-04-07','10:00:00',2.73),('8998','2013-04-07','10:05:00',2.86),('8998','2013-04-07','10:10:00',2.74),('8998','2013-04-07','10:15:00',2.8),('8998','2013-04-07','10:20:00',2.76),('8998','2013-04-07','10:25:00',2.73),('8998','2013-04-07','10:30:00',2.74),('8998','2013-04-07','10:35:00',2.6),('8998','2013-04-07','10:40:00',2.79),('8998','2013-04-07','10:45:00',2.88),('8998','2013-04-07','10:50:00',2.91),('8998','2013-04-07','10:55:00',2.74),('8998','2013-04-07','11:00:00',2.86),('8998','2013-04-07','11:05:00',2.51),('8998','2013-04-07','11:10:00',2.08),('8998','2013-04-07','11:15:00',2.12),('8998','2013-04-07','11:20:00',1.73),('8998','2013-04-07','11:25:00',1.46),('8998','2013-04-07','11:30:00',1.59),('8998','2013-04-07','11:35:00',2.08),('8998','2013-04-07','11:40:00',2.35),('8998','2013-04-07','11:45:00',2.11),('8998','2013-04-07','11:50:00',2),('8998','2013-04-07','11:55:00',1.7),('8998','2013-04-07','12:00:00',1.64),('8998','2013-04-07','12:05:00',1.53),('8998','2013-04-07','12:10:00',1.62),('8998','2013-04-07','12:15:00',1.92),('8998','2013-04-07','12:20:00',1.94),('8998','2013-04-07','12:25:00',1.96),('8998','2013-04-07','12:30:00',2.11),('8998','2013-04-07','12:35:00',2),('8998','2013-04-07','12:40:00',1.51),('8998','2013-04-07','12:45:00',1.62),('8998','2013-04-07','12:50:00',1.99),('8998','2013-04-07','12:55:00',2.11),('8998','2013-04-07','13:00:00',1.45),('8998','2013-04-07','13:05:00',1.58),('8998','2013-04-07','13:10:00',1.88),('8998','2013-04-07','13:15:00',1.98),('8998','2013-04-07','13:20:00',2.48),('8998','2013-04-07','13:25:00',2.15),('8998','2013-04-07','13:30:00',1.86),('8998','2013-04-07','13:35:00',2.01),('8998','2013-04-07','13:40:00',2.3),('8998','2013-04-07','13:45:00',1.84),('8998','2013-04-07','13:50:00',1.91),('8998','2013-04-07','13:55:00',2.45),('8998','2013-04-07','14:00:00',2.44),('8998','2013-04-07','14:05:00',1.99),('8998','2013-04-07','14:10:00',2.05),('8998','2013-04-07','14:15:00',2.27),('8998','2013-04-07','14:20:00',2.06),('8998','2013-04-07','14:25:00',2.36),('8998','2013-04-07','14:30:00',2.26),('8998','2013-04-07','14:35:00',2.13),('8998','2013-04-07','14:40:00',2.07),('8998','2013-04-07','14:45:00',2.1),('8998','2013-04-07','14:50:00',2.05),('8998','2013-04-07','14:55:00',2.12),('8998','2013-04-07','15:00:00',1.68),('8998','2013-04-07','15:05:00',1.67),('8998','2013-04-07','15:10:00',1.59),('8998','2013-04-07','15:15:00',1.66),('8998','2013-04-07','15:20:00',1.39),('8998','2013-04-07','15:25:00',1.82),('8998','2013-04-07','15:30:00',1.84),('8998','2013-04-07','15:35:00',1.71),('8998','2013-04-07','15:40:00',1.61),('8998','2013-04-07','15:45:00',1.52),('8998','2013-04-07','15:50:00',1.45),('8998','2013-04-07','15:55:00',1.39),('8998','2013-04-07','16:00:00',1.32),('8998','2013-04-07','16:05:00',1.23),('8998','2013-04-07','16:10:00',1.11),('8998','2013-04-07','16:15:00',1.17),('8998','2013-04-07','16:20:00',1.13),('8998','2013-04-07','16:25:00',1.03),('8998','2013-04-06','08:35:00',1.04),('8998','2013-04-06','08:40:00',1.19),('8998','2013-04-06','08:45:00',1.3),('8998','2013-04-06','08:50:00',1.34),('8998','2013-04-06','08:55:00',1.4),('8998','2013-04-06','09:00:00',1.36),('8998','2013-04-06','09:05:00',1.38),('8998','2013-04-06','09:10:00',1.47),('8998','2013-04-06','09:15:00',1.44),('8998','2013-04-06','09:20:00',1.53),('8998','2013-04-06','09:25:00',1.5),('8998','2013-04-06','09:30:00',1.43),('8998','2013-04-06','09:35:00',1.32),('8998','2013-04-06','09:40:00',1.37),('8998','2013-04-06','09:45:00',1.75),('8998','2013-04-06','09:50:00',1.86),('8998','2013-04-06','09:55:00',2.05),('8998','2013-04-06','10:00:00',2.36),('8998','2013-04-06','10:05:00',2.4),('8998','2013-04-06','10:10:00',2.37),('8998','2013-04-06','10:15:00',2.41),('8998','2013-04-06','10:20:00',2.46),('8998','2013-04-06','10:25:00',2.39),('8998','2013-04-06','10:30:00',2.08),('8998','2013-04-06','10:35:00',2.31),('8998','2013-04-06','10:40:00',2.25),('8998','2013-04-06','10:45:00',2.2),('8998','2013-04-06','10:50:00',2.13),('8998','2013-04-06','10:55:00',1.89),('8998','2013-04-06','11:00:00',1.68),('8998','2013-04-06','11:05:00',1.44),('8998','2013-04-06','11:10:00',1.72),('8998','2013-04-06','11:15:00',2.36),('8998','2013-04-06','11:20:00',2.67),('8998','2013-04-06','11:25:00',2.9),('8998','2013-04-06','11:30:00',2.73),('8998','2013-04-06','11:35:00',2.55),('8998','2013-04-06','11:40:00',2.27),('8998','2013-04-06','11:45:00',1.8),('8998','2013-04-06','11:50:00',1.71),('8998','2013-04-06','11:55:00',1.81),('8998','2013-04-06','12:00:00',1.87),('8998','2013-04-06','12:05:00',1.8),('8998','2013-04-06','12:10:00',1.95),('8998','2013-04-06','12:15:00',1.87),('8998','2013-04-06','12:20:00',2.02),('8998','2013-04-06','12:25:00',2.22),('8998','2013-04-06','12:30:00',1.87),('8998','2013-04-06','12:35:00',2.02),('8998','2013-04-06','12:40:00',1.96),('8998','2013-04-06','12:45:00',1.69),('8998','2013-04-06','12:50:00',1.76),('8998','2013-04-06','12:55:00',1.88),('8998','2013-04-06','13:00:00',2.18),('8998','2013-04-06','13:05:00',2.38),('8998','2013-04-06','13:10:00',2.3),('8998','2013-04-06','13:15:00',2.02),('8998','2013-04-06','13:20:00',1.87),('8998','2013-04-06','13:25:00',2.14),('8998','2013-04-06','13:30:00',2.19),('8998','2013-04-06','13:35:00',1.97),('8998','2013-04-06','13:40:00',2.08),('8998','2013-04-06','13:45:00',2.27),('8998','2013-04-06','13:50:00',2.07),('8998','2013-04-06','13:55:00',1.92),('8998','2013-04-06','14:00:00',2.26),('8998','2013-04-06','14:05:00',2.03),('8998','2013-04-06','14:10:00',1.57),('8998','2013-04-06','14:15:00',1.43),('8998','2013-04-06','14:20:00',1.29),('8998','2013-04-06','14:25:00',1.5),('8998','2013-04-06','14:30:00',1.57),('8998','2013-04-06','14:35:00',1.45),('8998','2013-04-06','14:40:00',1.26),('8998','2013-04-06','14:45:00',1.28),('8998','2013-04-06','14:50:00',1.38),('8998','2013-04-06','14:55:00',1.33),('8998','2013-04-06','15:00:00',1.33),('8998','2013-04-06','15:05:00',1.65),('8998','2013-04-06','15:10:00',1.62),('8998','2013-04-06','15:15:00',1.59),('8998','2013-04-06','15:20:00',1.59),('8998','2013-04-06','15:25:00',1.66),('8998','2013-04-06','15:30:00',1.58),('8998','2013-04-06','15:35:00',1.45),('8998','2013-04-06','15:40:00',1.47),('8998','2013-04-06','15:45:00',1.38),('8998','2013-04-06','15:50:00',1.29),('8998','2013-04-06','15:55:00',1.32),('8998','2013-04-06','16:00:00',1.21),('8998','2013-04-06','16:05:00',1.09),('8998','2013-04-05','08:15:00',1.25),('8998','2013-04-05','08:20:00',1.34),('8998','2013-04-05','08:25:00',1.26),('8998','2013-04-05','08:30:00',1.19),('8998','2013-04-05','08:35:00',1.31),('8998','2013-04-05','08:40:00',1.41),('8998','2013-04-05','08:45:00',1.69),('8998','2013-04-05','08:50:00',1.84),('8998','2013-04-05','08:55:00',1.92),('8998','2013-04-05','09:00:00',1.98),('8998','2013-04-05','09:05:00',2.08),('8998','2013-04-05','09:10:00',2.14),('8998','2013-04-05','09:15:00',2.22),('8998','2013-04-05','09:20:00',2.3),('8998','2013-04-05','09:25:00',2.34),('8998','2013-04-05','09:30:00',2.37),('8998','2013-04-05','09:35:00',2.36),('8998','2013-04-05','09:40:00',2.43),('8998','2013-04-05','09:45:00',2.45),('8998','2013-04-05','09:50:00',2.47),('8998','2013-04-05','09:55:00',2.52),('8998','2013-04-05','10:00:00',2.57),('8998','2013-04-05','10:05:00',2.57),('8998','2013-04-05','10:10:00',2.58),('8998','2013-04-05','10:15:00',2.56),('8998','2013-04-05','10:20:00',2.6),('8998','2013-04-05','10:25:00',2.69),('8998','2013-04-05','10:30:00',2.72),('8998','2013-04-05','10:35:00',2.72),('8998','2013-04-05','10:40:00',2.74),('8998','2013-04-05','10:45:00',2.74),('8998','2013-04-05','10:50:00',2.76),('8998','2013-04-05','10:55:00',2.78),('8998','2013-04-05','11:00:00',2.81),('8998','2013-04-05','11:05:00',2.84),('8998','2013-04-05','11:10:00',2.86),('8998','2013-04-05','11:15:00',2.84),('8998','2013-04-05','11:20:00',2.87),('8998','2013-04-05','11:25:00',2.92),('8998','2013-04-05','11:30:00',2.89),('8998','2013-04-05','11:35:00',2.9),('8998','2013-04-05','11:40:00',2.91),('8998','2013-04-05','11:45:00',2.9),('8998','2013-04-05','11:50:00',2.89),('8998','2013-04-05','11:55:00',2.9),('8998','2013-04-05','12:00:00',2.86),('8998','2013-04-05','12:05:00',2.87),('8998','2013-04-05','12:10:00',2.85),('8998','2013-04-05','12:15:00',2.84),('8998','2013-04-05','12:20:00',2.5),('8998','2013-04-05','12:25:00',2.41),('8998','2013-04-05','12:30:00',2.67),('8998','2013-04-05','12:35:00',2.9),('8998','2013-04-05','12:40:00',2.85),('8998','2013-04-05','12:45:00',2.85),('8998','2013-04-05','12:50:00',2.83),('8998','2013-04-05','12:55:00',2.82),('8998','2013-04-05','13:00:00',2.78),('8998','2013-04-05','13:05:00',2.77),('8998','2013-04-05','13:10:00',2.47),('8998','2013-04-05','13:15:00',1.95),('8998','2013-04-05','13:20:00',1.45),('8998','2013-04-05','13:30:00',1.42),('8998','2013-04-05','13:35:00',2.74),('8998','2013-04-05','13:40:00',2.99),('8998','2013-04-05','13:45:00',2.98),('8998','2013-04-05','13:50:00',2.76),('8998','2013-04-05','13:55:00',2.6),('8998','2013-04-05','14:00:00',2.09),('8998','2013-04-05','14:05:00',2.57),('8998','2013-04-05','14:15:00',2.55),('8998','2013-04-05','14:20:00',1.23),('8998','2013-04-05','14:25:00',1.77),('8998','2013-04-05','14:30:00',1.92),('8998','2013-04-05','14:35:00',2.24),('8998','2013-04-05','14:40:00',2.25),('8998','2013-04-05','14:45:00',2.1),('8998','2013-04-05','14:50:00',2.09),('8998','2013-04-05','14:55:00',1.96),('8998','2013-04-05','15:00:00',2.05),('8998','2013-04-05','15:05:00',1.98),('8998','2013-04-05','15:10:00',1.73),('8998','2013-04-05','15:15:00',1.78),('8998','2013-04-05','15:20:00',1.72),('8998','2013-04-05','15:25:00',1.67),('8998','2013-04-05','15:30:00',1.57),('8998','2013-04-05','15:35:00',1.51),('8998','2013-04-05','15:40:00',1.49),('8998','2013-04-05','15:45:00',1.32),('8998','2013-04-05','15:50:00',1.27),('8998','2013-04-05','15:55:00',1.36),('8998','2013-04-05','16:00:00',1.21),('8998','2013-04-05','16:05:00',1.26),('8998','2013-04-05','16:10:00',1.25),('8998','2013-04-05','16:15:00',1.13),('8998','2013-04-04','08:20:00',1.12),('8998','2013-04-04','08:55:00',1.33),('8998','2013-04-04','09:05:00',2.31),('8998','2013-04-04','09:10:00',1.35),('8998','2013-04-04','09:15:00',2.36),('8998','2013-04-04','09:20:00',1.87),('8998','2013-04-04','09:35:00',1.11),('8998','2013-04-04','09:40:00',1.88),('8998','2013-04-04','09:45:00',1.9),('8998','2013-04-04','10:00:00',1.01),('8998','2013-04-04','10:10:00',1.82),('8998','2013-04-04','10:15:00',2.73),('8998','2013-04-04','10:20:00',1.03),('8998','2013-04-04','10:25:00',2.07),('8998','2013-04-04','10:30:00',2.06),('8998','2013-04-04','10:35:00',1.86),('8998','2013-04-04','10:40:00',2.81),('8998','2013-04-04','10:45:00',1.69),('8998','2013-04-04','10:50:00',1.71),('8998','2013-04-04','10:55:00',1.92),('8998','2013-04-04','11:00:00',1.93),('8998','2013-04-04','11:05:00',2.57),('8998','2013-04-04','11:10:00',3.21),('8998','2013-04-04','11:15:00',3.15),('8998','2013-04-04','11:20:00',2.17),('8998','2013-04-04','11:25:00',2.49),('8998','2013-04-04','11:30:00',2.35),('8998','2013-04-04','11:35:00',3.18),('8998','2013-04-04','11:40:00',2.93),('8998','2013-04-04','11:45:00',2.8),('8998','2013-04-04','11:50:00',2.18),('8998','2013-04-04','11:55:00',2.68),('8998','2013-04-04','12:00:00',3.23),('8998','2013-04-04','12:05:00',2.47),('8998','2013-04-04','12:10:00',2.44),('8998','2013-04-04','12:15:00',1.34),('8998','2013-04-04','12:20:00',1.09),('8998','2013-04-04','12:25:00',1.4),('8998','2013-04-04','12:40:00',1.12),('8998','2013-04-04','12:45:00',2.44),('8998','2013-04-04','12:50:00',2.96),('8998','2013-04-04','12:55:00',3),('8998','2013-04-04','13:00:00',1.88),('8998','2013-04-04','13:05:00',2.6),('8998','2013-04-04','13:10:00',1.77),('8998','2013-04-04','13:15:00',1.71),('8998','2013-04-04','13:20:00',1.51),('8998','2013-04-04','13:25:00',2.05),('8998','2013-04-04','13:30:00',1.64),('8998','2013-04-04','13:35:00',2.11),('8998','2013-04-04','13:40:00',2.83),('8998','2013-04-04','13:45:00',1.79),('8998','2013-04-04','13:50:00',2.89),('8998','2013-04-04','13:55:00',2.55),('8998','2013-04-04','14:00:00',1.7),('8998','2013-04-04','14:05:00',2.96),('8998','2013-04-04','14:10:00',2.28),('8998','2013-04-04','14:15:00',2.08),('8998','2013-04-04','14:20:00',2.44),('8998','2013-04-04','14:25:00',2.41),('8998','2013-04-04','14:30:00',2.47),('8998','2013-04-04','14:35:00',2.28),('8998','2013-04-04','14:40:00',2.29),('8998','2013-04-04','14:45:00',2.11),('8998','2013-04-04','14:50:00',1.32),('8998','2013-04-04','14:55:00',2.58),('8998','2013-04-04','15:00:00',2.19),('8998','2013-04-04','15:05:00',2.06),('8998','2013-04-04','15:10:00',1.98),('8998','2013-04-04','15:15:00',1.15),('8998','2013-04-04','15:20:00',1.17),('8998','2013-04-04','15:25:00',1.35),('8998','2013-04-04','15:30:00',1.15),('8998','2013-04-04','15:35:00',1.01),('8998','2013-04-04','15:50:00',1.12),('8998','2013-04-04','15:55:00',1.08),('8998','2013-04-04','16:00:00',1.15),('8998','2013-04-04','16:05:00',1.04),('8998','2013-04-04','16:15:00',1.32),('8998','2013-04-04','16:20:00',1.13),('8998','2013-04-04','16:25:00',1.12),('8998','2013-04-04','16:45:00',1.03),('8998','2013-04-04','16:50:00',1.35),('8998','2013-04-03','08:55:00',1.08),('8998','2013-04-03','09:00:00',1.82),('8998','2013-04-03','09:05:00',1.22),('8998','2013-04-03','09:20:00',1.1),('8998','2013-04-03','09:30:00',1.18),('8998','2013-04-03','09:35:00',2.18),('8998','2013-04-03','09:40:00',1.99),('8998','2013-04-03','09:45:00',1.67),('8998','2013-04-03','10:00:00',1.39),('8998','2013-04-03','10:05:00',1.99),('8998','2013-04-03','10:10:00',1.92),('8998','2013-04-03','10:15:00',1.28),('8998','2013-04-03','10:20:00',1.29),('8998','2013-04-03','10:25:00',2.67),('8998','2013-04-03','10:30:00',2.64),('8998','2013-04-03','10:35:00',1.59),('8998','2013-04-03','10:40:00',3.14),('8998','2013-04-03','10:45:00',1.73),('8998','2013-04-03','10:50:00',1.82),('8998','2013-04-03','10:55:00',2.82),('8998','2013-04-03','11:00:00',1.7),('8998','2013-04-03','11:15:00',1),('8998','2013-04-03','11:20:00',1.02),('8998','2013-04-03','11:35:00',1.09),('8998','2013-04-03','11:40:00',1.99),('8998','2013-04-03','11:45:00',2.47),('8998','2013-04-03','11:50:00',2.85),('8998','2013-04-03','11:55:00',2.96),('8998','2013-04-03','12:00:00',2.94),('8998','2013-04-03','12:05:00',2.83),('8998','2013-04-03','12:10:00',2.9),('8998','2013-04-03','12:15:00',2.82),('8998','2013-04-03','12:20:00',2.57),('8998','2013-04-03','12:25:00',2.1),('8998','2013-04-03','12:30:00',2.06),('8998','2013-04-03','12:35:00',1.5),('8998','2013-04-03','12:40:00',2.54),('8998','2013-04-03','12:45:00',1.8),('8998','2013-04-03','12:50:00',2.55),('8998','2013-04-03','12:55:00',2.68),('8998','2013-04-03','13:00:00',2.58),('8998','2013-04-03','13:05:00',2.67),('8998','2013-04-03','13:10:00',2.75),('8998','2013-04-03','13:15:00',2.84),('8998','2013-04-03','13:20:00',2.71),('8998','2013-04-03','13:25:00',2.76),('8998','2013-04-03','13:30:00',2.68),('8998','2013-04-03','13:35:00',2.45),('8998','2013-04-03','13:40:00',2.02),('8998','2013-04-03','13:45:00',2.03),('8998','2013-04-03','13:50:00',2.01),('8998','2013-04-03','13:55:00',1.58),('8998','2013-04-03','14:00:00',1.67),('8998','2013-04-03','14:05:00',2.21),('8998','2013-04-03','14:10:00',2.5),('8998','2013-04-03','14:15:00',2.43),('8998','2013-04-03','14:20:00',2.31),('8998','2013-04-03','14:25:00',2.2),('8998','2013-04-03','14:30:00',2.16),('8998','2013-04-03','14:35:00',2.12),('8998','2013-04-03','14:40:00',2.1),('8998','2013-04-03','14:45:00',2.05),('8998','2013-04-03','14:50:00',1.99),('8998','2013-04-03','14:55:00',1.96),('8998','2013-04-03','15:00:00',1.9),('8998','2013-04-03','15:05:00',1.81),('8998','2013-04-03','15:10:00',1.71),('8998','2013-04-03','15:15:00',1.66),('8998','2013-04-03','15:20:00',1.67),('8998','2013-04-03','15:25:00',1.67),('8998','2013-04-03','15:30:00',1.64),('8998','2013-04-03','15:35:00',1.58),('8998','2013-04-03','15:40:00',1.52),('8998','2013-04-03','15:45:00',1.48),('8998','2013-04-03','15:50:00',1.39),('8998','2013-04-03','15:55:00',1.33),('8998','2013-04-03','16:00:00',1.27),('8998','2013-04-03','16:05:00',1.22),('8998','2013-04-03','16:10:00',1.13),('8998','2013-04-03','16:15:00',1.13),('8998','2013-04-03','16:20:00',1.07),('8998','2013-04-03','16:25:00',1.05),('8998','2013-04-02','08:15:00',1.01),('8998','2013-04-02','08:20:00',1.02),('8998','2013-04-02','08:25:00',1.39),('8998','2013-04-02','08:30:00',1.63),('8998','2013-04-02','08:35:00',1.88),('8998','2013-04-02','08:40:00',1.82),('8998','2013-04-02','08:45:00',1.93),('8998','2013-04-02','09:00:00',1.55),('8998','2013-04-02','09:05:00',2.28),('8998','2013-04-02','09:10:00',2.37),('8998','2013-04-02','09:15:00',2.44),('8998','2013-04-02','09:20:00',2.45),('8998','2013-04-02','09:25:00',1.34),('8998','2013-04-02','09:30:00',1.76),('8998','2013-04-02','09:35:00',1.37),('8998','2013-04-02','09:40:00',2.84),('8998','2013-04-02','09:45:00',1.91),('8998','2013-04-02','09:50:00',2.81),('8998','2013-04-02','09:55:00',2.89),('8998','2013-04-02','10:00:00',2.99),('8998','2013-04-02','10:15:00',1.18),('8998','2013-04-02','10:20:00',2.45),('8998','2013-04-02','10:25:00',2.82),('8998','2013-04-02','10:30:00',1.88),('8998','2013-04-02','10:35:00',1.67),('8998','2013-04-02','10:40:00',1.34),('8998','2013-04-02','10:45:00',1.3),('8998','2013-04-02','10:50:00',1.34),('8998','2013-04-02','10:55:00',2.43),('8998','2013-04-02','11:00:00',1.34),('8998','2013-04-02','11:05:00',3.52),('8998','2013-04-02','11:10:00',1.76),('8998','2013-04-02','11:15:00',2.17),('8998','2013-04-02','11:20:00',1.59),('8998','2013-04-02','11:25:00',1.98),('8998','2013-04-02','11:30:00',1.34),('8998','2013-04-02','11:35:00',1.04),('8998','2013-04-02','11:40:00',1.65),('8998','2013-04-02','11:50:00',1.84),('8998','2013-04-02','11:55:00',1.62),('8998','2013-04-02','12:00:00',2.8),('8998','2013-04-02','12:05:00',2.16),('8998','2013-04-02','12:10:00',3.34),('8998','2013-04-02','12:15:00',1.19),('8998','2013-04-02','12:20:00',2.46),('8998','2013-04-02','12:25:00',2.28),('8998','2013-04-02','12:30:00',2.91),('8998','2013-04-02','12:35:00',2.46),('8998','2013-04-02','12:40:00',2.67),('8998','2013-04-02','12:45:00',2.97),('8998','2013-04-02','12:50:00',3.11),('8998','2013-04-02','12:55:00',2.94),('8998','2013-04-02','13:00:00',2.99),('8998','2013-04-02','13:05:00',2.02),('8998','2013-04-02','13:10:00',1.58),('8998','2013-04-02','13:15:00',2.95),('8998','2013-04-02','13:20:00',2.09),('8998','2013-04-02','13:25:00',1.78),('8998','2013-04-02','13:30:00',1.7),('8998','2013-04-02','13:35:00',2.44),('8998','2013-04-02','13:40:00',2.18),('8998','2013-04-02','13:45:00',2.52),('8998','2013-04-02','13:50:00',2.16),('8998','2013-04-02','13:55:00',2.69),('8998','2013-04-02','14:00:00',2.7),('8998','2013-04-02','14:05:00',1.76),('8998','2013-04-02','14:10:00',1.62),('8998','2013-04-02','14:15:00',2.11),('8998','2013-04-02','14:20:00',1.51),('8998','2013-04-02','14:25:00',2.13),('8998','2013-04-02','14:30:00',1.94),('8998','2013-04-02','14:35:00',2.32),('8998','2013-04-02','14:40:00',2.31),('8998','2013-04-02','14:45:00',1.91),('8998','2013-04-02','14:55:00',1.29),('8998','2013-04-02','15:00:00',2.5),('8998','2013-04-02','15:05:00',2.19),('8998','2013-04-02','15:10:00',2.31),('8998','2013-04-02','15:15:00',2.21),('8998','2013-04-02','15:20:00',2.11),('8998','2013-04-02','15:25:00',2.05),('8998','2013-04-02','15:30:00',1.91),('8998','2013-04-02','15:35:00',1.84),('8998','2013-04-02','15:40:00',1.85),('8998','2013-04-02','15:45:00',1.54),('8998','2013-04-02','15:50:00',1.62),('8998','2013-04-02','15:55:00',1.45),('8998','2013-04-02','16:00:00',1.51),('8998','2013-04-02','16:05:00',1.38),('8998','2013-04-02','16:10:00',1.3),('8998','2013-04-02','16:15:00',1.21),('8998','2013-04-02','16:20:00',1.12),('8998','2013-04-02','16:25:00',1.05),('8998','2013-04-01','08:40:00',1.38),('8998','2013-04-01','08:45:00',1.8),('8998','2013-04-01','08:50:00',1.44),('8998','2013-04-01','09:00:00',2.08),('8998','2013-04-01','09:05:00',2.15),('8998','2013-04-01','09:10:00',2.26),('8998','2013-04-01','09:15:00',2.39),('8998','2013-04-01','09:20:00',2.06),('8998','2013-04-01','09:30:00',2.67),('8998','2013-04-01','09:35:00',2.55),('8998','2013-04-01','09:40:00',1.84),('8998','2013-04-01','09:45:00',2.53),('8998','2013-04-01','09:50:00',1.74),('8998','2013-04-01','09:55:00',1.64),('8998','2013-04-01','10:00:00',1.83),('8998','2013-04-01','10:05:00',1.34),('8998','2013-04-01','10:10:00',1.34),('8998','2013-04-01','10:20:00',1.61),('8998','2013-04-01','10:25:00',1.47),('8998','2013-04-01','10:35:00',1.04),('8998','2013-04-01','10:40:00',1.1),('8998','2013-04-01','10:45:00',2.45),('8998','2013-04-01','10:50:00',3.13),('8998','2013-04-01','10:55:00',1.29),('8998','2013-04-01','11:05:00',1.93),('8998','2013-04-01','11:10:00',1.86),('8998','2013-04-01','11:35:00',1.17),('8998','2013-04-01','11:45:00',1.1),('8998','2013-04-01','11:50:00',1.31),('8998','2013-04-01','11:55:00',1.17),('8998','2013-04-01','12:05:00',1.57),('8998','2013-04-01','12:10:00',1.68),('8998','2013-04-01','12:15:00',2.06),('8998','2013-04-01','12:35:00',1.15),('8998','2013-04-01','12:40:00',1.77),('8998','2013-04-01','12:45:00',1.46),('8998','2013-04-01','12:50:00',1.55),('8998','2013-04-01','12:55:00',1.49),('8998','2013-04-01','13:00:00',1.53),('8998','2013-04-01','13:05:00',1.64),('8998','2013-04-01','13:10:00',2.29),('8998','2013-04-01','13:15:00',1.76),('8998','2013-04-01','13:20:00',1.38),('8998','2013-04-01','13:25:00',2.22),('8998','2013-04-01','13:30:00',2.02),('8998','2013-04-01','13:35:00',1.42),('8998','2013-04-01','13:40:00',1.64),('8998','2013-04-01','13:45:00',1.77),('8998','2013-04-01','13:50:00',1.51),('8998','2013-04-01','13:55:00',1.12),('8998','2013-04-01','14:00:00',1.65),('8998','2013-04-01','14:05:00',1.44),('8998','2013-04-01','14:10:00',2.24),('8998','2013-04-01','14:15:00',1.72),('8998','2013-04-01','14:20:00',2.53),('8998','2013-04-01','14:25:00',3.02),('8998','2013-04-01','14:30:00',2.22),('8998','2013-04-01','14:35:00',1.27),('8998','2013-04-01','14:40:00',1.5),('8998','2013-04-01','14:45:00',1.54),('8998','2013-04-01','14:50:00',1.4),('8998','2013-04-01','14:55:00',1.14),('8998','2013-04-01','15:00:00',1.13),('8998','2014-05-01','07:40:00',1.24),('8998','2014-05-01','07:45:00',1.14),('8998','2014-05-01','07:50:00',1.22),('8998','2014-05-01','08:00:00',1.47),('8998','2014-05-01','08:05:00',1.55),('8998','2014-05-01','08:15:00',1.34),('8998','2014-05-01','08:20:00',2.15),('8998','2014-05-01','08:25:00',1.08),('8998','2014-05-01','08:30:00',1.08),('8998','2014-05-01','09:25:00',1.04),('8998','2014-05-01','09:30:00',1.41),('8998','2014-05-01','09:35:00',1.45),('8998','2014-05-01','09:40:00',1.05),('8998','2014-05-01','09:45:00',1.04),('8998','2014-05-01','09:50:00',1.12),('8998','2014-05-01','09:55:00',1.02),('8998','2014-05-01','10:00:00',1.34),('8998','2014-05-01','10:05:00',1.23),('8998','2014-05-01','10:10:00',1.4),('8998','2014-05-01','10:15:00',1.2),('8998','2014-05-01','10:20:00',1.15),('8998','2014-05-01','12:50:00',1.09),('8998','2014-05-01','12:55:00',1.17),('8998','2014-05-01','13:05:00',1.16),('8998','2014-05-01','13:10:00',1.29),('8998','2014-05-01','13:15:00',1.5),('8998','2014-05-01','13:20:00',2.14),('8998','2014-05-01','13:25:00',1.93),('8998','2014-05-01','13:30:00',1.7),('8998','2014-05-01','13:35:00',1.58),('8998','2014-05-01','13:40:00',1.76),('8998','2014-05-01','13:45:00',1.42),('8998','2014-05-01','13:50:00',1.11),('8998','2014-05-01','14:10:00',1.09),('8998','2014-05-01','14:40:00',2.16),('8998','2014-05-01','14:45:00',1.64),('8998','2014-05-01','14:50:00',1.01),('8998','2014-05-01','14:55:00',1.22),('8998','2014-05-01','15:00:00',1.52),('8998','2014-05-01','15:05:00',1.34),('8998','2014-05-01','15:10:00',2.03),('8998','2014-05-01','15:15:00',2.83),('8998','2014-05-01','15:20:00',1.35),('8998','2014-05-01','15:25:00',1.19),('8998','2014-05-01','15:35:00',1.36),('8998','2014-05-01','15:40:00',2.02),('8998','2014-05-01','15:45:00',1.04),('8998','2014-05-01','16:05:00',1.23),('8998','2014-05-01','16:20:00',1.54),('8998','2014-03-26','08:00:00',1),('8998','2014-03-26','10:20:00',1.05),('8998','2014-03-26','10:25:00',1.33),('8998','2014-03-26','10:30:00',1.63),('8998','2014-03-26','10:35:00',1.34),('8998','2014-03-26','10:40:00',1.74),('8998','2014-03-26','10:45:00',1.17),('8998','2014-03-26','11:10:00',1.7),('8998','2014-03-26','11:15:00',2.19),('8998','2014-03-26','11:20:00',1.81),('8998','2014-03-26','12:10:00',1.12),('8998','2014-03-26','13:15:00',1.28),('8998','2014-03-26','13:20:00',1.48),('8998','2014-03-26','13:25:00',1.62),('8998','2014-03-26','13:30:00',1.47),('8998','2014-03-26','13:35:00',1.33),('8998','2014-03-26','13:40:00',1.25),('8998','2014-03-26','13:45:00',1.13),('8998','2014-03-26','13:50:00',1.28),('8998','2014-03-26','13:55:00',1.64),('8998','2014-03-26','14:00:00',1.42),('8998','2014-03-26','14:15:00',1.29),('8998','2014-03-26','14:20:00',2.1),('8998','2014-03-26','14:25:00',1.92),('8998','2014-03-26','14:30:00',2.04),('8998','2014-03-26','14:35:00',1.39),('8998','2014-03-26','14:40:00',1.16),('8998','2014-03-26','14:45:00',1.1),('8998','2014-03-26','14:50:00',1.38),('8998','2014-03-26','14:55:00',1.56),('8998','2014-03-26','15:00:00',1.27),('8998','2014-03-26','15:25:00',1.37),('8998','2014-03-26','15:30:00',1.36),('8998','2013-03-31','08:25:00',1.12),('8998','2013-03-31','08:30:00',1.56),('8998','2013-03-31','08:35:00',1.77),('8998','2013-03-31','08:40:00',1.94),('8998','2013-03-31','08:50:00',1.22),('8998','2013-03-31','08:55:00',1.69),('8998','2013-03-31','09:00:00',2.08),('8998','2013-03-31','09:05:00',2.14),('8998','2013-03-31','09:10:00',2.28),('8998','2013-03-31','09:15:00',2.32),('8998','2013-03-31','09:20:00',1.88),('8998','2013-03-31','09:25:00',2.11),('8998','2013-03-31','09:30:00',2.4),('8998','2013-03-31','09:35:00',1.2),('8998','2013-03-31','09:40:00',2.49),('8998','2013-03-31','09:45:00',1.81),('8998','2013-03-31','09:50:00',2.33),('8998','2013-03-31','09:55:00',2.37),('8998','2013-03-31','10:00:00',2.54),('8998','2013-03-31','10:05:00',2.65),('8998','2013-03-31','10:10:00',2.34),('8998','2013-03-31','10:15:00',1.95),('8998','2013-03-31','10:20:00',2.5),('8998','2013-03-31','10:25:00',2.36),('8998','2013-03-31','10:30:00',1.97),('8998','2013-03-31','10:35:00',1.07),('8998','2013-03-31','10:40:00',1.73),('8998','2013-03-31','10:45:00',2.99),('8998','2013-03-31','10:50:00',1.97),('8998','2013-03-31','11:00:00',1.15),('8998','2013-03-31','11:10:00',1.72),('8998','2013-03-31','11:15:00',2.55),('8998','2013-03-31','11:20:00',1.91),('8998','2013-03-31','11:25:00',2.02),('8998','2013-03-31','11:30:00',1.19),('8998','2013-03-31','11:35:00',1.36),('8998','2013-03-31','11:40:00',2.2),('8998','2013-03-31','11:45:00',2.35),('8998','2013-03-31','11:50:00',1.94),('8998','2013-03-31','11:55:00',1.58),('8998','2013-03-31','12:00:00',2.15),('8998','2013-03-31','12:05:00',1.4),('8998','2013-03-31','12:10:00',1.62),('8998','2013-03-31','12:15:00',1.55),('8998','2013-03-31','12:20:00',1.29),('8998','2013-03-31','12:25:00',1.33),('8998','2013-03-31','12:30:00',1.78),('8998','2013-03-31','12:35:00',1.66),('8998','2013-03-31','12:40:00',1.63),('8998','2013-03-31','12:45:00',1.84),('8998','2013-03-31','12:50:00',1.93),('8998','2013-03-31','12:55:00',2.17),('8998','2013-03-31','13:00:00',2.07),('8998','2013-03-31','13:05:00',2.27),('8998','2013-03-31','13:10:00',2.11),('8998','2013-03-31','13:15:00',2),('8998','2013-03-31','13:20:00',1.93),('8998','2013-03-31','13:25:00',1.76),('8998','2013-03-31','13:30:00',2.04),('8998','2013-03-31','13:35:00',1.77),('8998','2013-03-31','13:40:00',2.07),('8998','2013-03-31','13:45:00',2.37),('8998','2013-03-31','13:50:00',2.65),('8998','2013-03-31','13:55:00',2.79),('8998','2013-03-31','14:00:00',1.66),('8998','2013-03-31','14:05:00',1.25),('8998','2013-03-31','14:10:00',1.49),('8998','2013-03-31','14:15:00',1.69),('8998','2013-03-31','14:20:00',1.7),('8998','2013-03-31','14:25:00',2.6),('8998','2013-03-31','14:30:00',1.88),('8998','2013-03-31','14:35:00',1.43),('8998','2013-03-31','14:40:00',1.3),('8998','2013-03-31','14:45:00',1.24),('8998','2013-03-31','14:50:00',1.34),('8998','2013-03-31','14:55:00',1.47),('8998','2013-03-31','15:00:00',1.33),('8998','2013-03-31','15:05:00',1.33),('8998','2013-03-31','15:10:00',1.35),('8998','2013-03-31','15:15:00',1.43),('8998','2013-03-31','15:20:00',1.43),('8998','2013-03-31','15:25:00',1.39),('8998','2013-03-31','15:30:00',1.17),('8998','2013-03-31','15:35:00',1.43),('8998','2013-03-31','15:40:00',1.38),('8998','2013-03-31','15:45:00',1.4),('8998','2013-03-31','15:50:00',1.58),('8998','2013-03-31','15:55:00',1.31),('8998','2013-03-31','16:00:00',1.18),('8998','2013-03-31','16:05:00',1),('8998','2013-03-30','08:45:00',1.1),('8998','2013-03-30','09:20:00',2.06),('8998','2013-03-30','09:25:00',2.74),('8998','2013-03-30','09:30:00',2.18),('8998','2013-03-30','09:35:00',2.03),('8998','2013-03-30','09:40:00',1.29),('8998','2013-03-30','09:45:00',2.52),('8998','2013-03-30','09:50:00',1.11),('8998','2013-03-30','09:55:00',1.5),('8998','2013-03-30','10:00:00',2.16),('8998','2013-03-30','10:20:00',1.54),('8998','2013-03-30','10:25:00',2.31),('8998','2013-03-30','10:30:00',1.92),('8998','2013-03-30','10:35:00',2.12),('8998','2013-03-30','10:50:00',1.38),('8998','2013-03-30','10:55:00',1.02),('8998','2013-03-30','11:25:00',1.1),('8998','2013-03-30','11:35:00',1.05),('8998','2013-03-30','11:40:00',1.26),('8998','2013-03-30','11:45:00',1.07),('8998','2013-03-30','11:50:00',1.07),('8998','2013-03-30','11:55:00',1.17),('8998','2013-03-30','12:00:00',1.06),('8998','2013-03-30','12:30:00',1.16),('8998','2013-03-30','12:35:00',1.95),('8998','2013-03-30','12:40:00',2.39),('8998','2013-03-30','12:45:00',1.32),('8998','2013-03-30','12:50:00',1.08),('8998','2013-03-30','12:55:00',1.32),('8998','2013-03-30','13:00:00',1.64),('8998','2013-03-30','13:05:00',1.42),('8998','2013-03-30','13:10:00',1.79),('8998','2013-03-30','13:15:00',2.03),('8998','2013-03-30','13:20:00',2.68),('8998','2013-03-30','13:25:00',2.16),('8998','2013-03-30','13:45:00',1.37),('8998','2013-03-30','13:50:00',1.26),('8998','2013-03-30','13:55:00',1.03),('8998','2013-03-30','14:00:00',1.3),('8998','2013-03-30','14:05:00',2.23),('8998','2013-03-30','14:10:00',1.5),('8998','2013-03-30','14:15:00',1.89),('8998','2013-03-30','14:20:00',1.17),('8998','2013-03-30','14:25:00',1.11),('8998','2013-03-30','14:30:00',1.34),('8998','2013-03-30','14:35:00',2.4),('8998','2013-03-30','14:40:00',2.53),('8998','2013-03-30','14:45:00',2.12),('8998','2013-03-30','14:50:00',2.17),('8998','2013-03-30','14:55:00',1.55),('8998','2013-03-30','15:00:00',1.75),('8998','2013-03-30','15:05:00',1.23),('8998','2013-03-30','15:10:00',1.89),('8998','2013-03-30','15:15:00',1.51),('8998','2013-03-30','15:20:00',2.15),('8998','2013-03-30','15:25:00',1.68),('8998','2013-03-30','15:30:00',1.52),('8998','2013-03-30','15:35:00',1.39),('8998','2013-03-30','15:40:00',1.87),('8998','2013-03-30','15:45:00',1.39),('8998','2013-03-30','16:00:00',1.12),('8998','2013-03-30','16:15:00',1.08),('8998','2013-03-30','16:20:00',1.23),('8998','2013-03-30','16:25:00',1.05),('8998','2013-03-30','17:05:00',1.01),('8998','2013-03-29','09:05:00',1.53),('8998','2013-03-29','09:10:00',1.12),('8998','2013-03-29','09:15:00',1.08),('8998','2013-03-29','09:20:00',2.76),('8998','2013-03-29','09:25:00',2.12),('8998','2013-03-29','09:30:00',1.04),('8998','2013-03-29','09:35:00',1.38),('8998','2013-03-29','09:40:00',1.08),('8998','2013-03-29','10:00:00',1.02),('8998','2013-03-29','10:05:00',1.06),('8998','2013-03-29','10:10:00',1.3),('8998','2013-03-29','10:15:00',1.29),('8998','2013-03-29','10:20:00',1.09),('8998','2013-03-29','10:25:00',1.03),('8998','2013-03-29','10:30:00',1.16),('8998','2013-03-29','10:35:00',1.39),('8998','2013-03-29','10:40:00',1.77),('8998','2013-03-29','10:45:00',2.53),('8998','2013-03-29','10:50:00',2.6),('8998','2013-03-29','10:55:00',1.71),('8998','2013-03-29','11:00:00',2.31),('8998','2013-03-29','11:05:00',2.99),('8998','2013-03-29','11:10:00',3.41),('8998','2013-03-29','11:15:00',3.06),('8998','2013-03-29','11:20:00',3.76),('8998','2013-03-29','11:25:00',3.42),('8998','2013-03-29','11:30:00',2.26),('8998','2013-03-29','11:35:00',2.01),('8998','2013-03-29','11:40:00',1.33),('8998','2013-03-29','11:45:00',2.14),('8998','2013-03-29','11:50:00',2.86),('8998','2013-03-29','11:55:00',2.41),('8998','2013-03-29','12:00:00',3.39),('8998','2013-03-29','12:05:00',1.83),('8998','2013-03-29','12:10:00',1.44),('8998','2013-03-29','12:15:00',1.35),('8998','2013-03-29','12:20:00',1.4),('8998','2013-03-29','12:25:00',1.04),('8998','2013-03-29','13:15:00',1.53),('8998','2013-03-29','13:20:00',2.27),('8998','2013-03-29','13:50:00',1.54),('8998','2013-03-29','13:55:00',1.96),('8998','2013-03-29','14:00:00',1.82),('8998','2013-03-29','14:05:00',1.63),('8998','2013-03-29','14:20:00',1.39),('8998','2013-03-29','14:25:00',1.01),('8998','2013-03-29','14:30:00',1.1),('8998','2013-03-29','14:35:00',1.16),('8998','2013-03-29','14:50:00',1.07),('8998','2013-03-28','07:25:00',1.06),('8998','2013-03-28','07:30:00',1.17),('8998','2013-03-28','07:35:00',1.28),('8998','2013-03-28','07:40:00',1.5),('8998','2013-03-28','07:45:00',1.72),('8998','2013-03-28','07:50:00',1.61),('8998','2013-03-28','08:00:00',1.28),('8998','2013-03-28','08:05:00',1.77),('8998','2013-03-28','08:10:00',2.1),('8998','2013-03-28','08:15:00',2.12),('8998','2013-03-28','08:20:00',2.17),('8998','2013-03-28','08:25:00',2.2),('8998','2013-03-28','08:30:00',2.25),('8998','2013-03-28','08:35:00',2.32),('8998','2013-03-28','08:40:00',2.36),('8998','2013-03-28','08:45:00',2.33),('8998','2013-03-28','08:50:00',2.28),('8998','2013-03-28','08:55:00',2.24),('8998','2013-03-28','09:00:00',2.16),('8998','2013-03-28','09:05:00',2.32),('8998','2013-03-28','09:10:00',2.39),('8998','2013-03-28','09:15:00',2.65),('8998','2013-03-28','09:20:00',2.76),('8998','2013-03-28','09:25:00',2.53),('8998','2013-03-28','09:30:00',2.81),('8998','2013-03-28','09:35:00',2.83),('8998','2013-03-28','09:40:00',2.66),('8998','2013-03-28','09:45:00',2.53),('8998','2013-03-28','09:50:00',2.76),('8998','2013-03-28','09:55:00',2.65),('8998','2013-03-28','10:00:00',2.69),('8998','2013-03-28','10:05:00',2.31),('8998','2013-03-28','10:10:00',2.1),('8998','2013-03-28','10:15:00',2.61),('8998','2013-03-28','10:20:00',2.39),('8998','2013-03-28','10:25:00',2.41),('8998','2013-03-28','10:30:00',2.38),('8998','2013-03-28','10:35:00',2.05),('8998','2013-03-28','10:40:00',2.33),('8998','2013-03-28','10:45:00',1.52),('8998','2013-03-28','10:50:00',2.18),('8998','2013-03-28','10:55:00',2.07),('8998','2013-03-28','11:00:00',2.94),('8998','2013-03-28','11:05:00',2.91),('8998','2013-03-28','11:10:00',3.24),('8998','2013-03-28','11:15:00',2.29),('8998','2013-03-28','11:20:00',1.42),('8998','2013-03-28','11:25:00',1.68),('8998','2013-03-28','11:30:00',3.26),('8998','2013-03-28','11:35:00',2.32),('8998','2013-03-28','11:40:00',2.99),('8998','2013-03-28','11:45:00',2.92),('8998','2013-03-28','11:50:00',2.9),('8998','2013-03-28','11:55:00',2.88),('8998','2013-03-28','12:00:00',2.86),('8998','2013-03-28','12:05:00',2.93),('8998','2013-03-28','12:10:00',2.88),('8998','2013-03-28','12:15:00',2.66),('8998','2013-03-28','12:20:00',2.82),('8998','2013-03-28','12:25:00',2.64),('8998','2013-03-28','12:30:00',2.46),('8998','2013-03-28','12:35:00',2.58),('8998','2013-03-28','12:40:00',2.72),('8998','2013-03-28','12:45:00',2.36),('8998','2013-03-28','12:50:00',2.18),('8998','2013-03-28','12:55:00',1.93),('8998','2013-03-28','13:00:00',2.42),('8998','2013-03-28','13:05:00',1.65),('8998','2013-03-28','13:10:00',2.41),('8998','2013-03-28','13:15:00',2.11),('8998','2013-03-28','13:20:00',2.17),('8998','2013-03-28','13:25:00',2.64),('8998','2013-03-28','13:30:00',2.33),('8998','2013-03-28','13:35:00',1.98),('8998','2013-03-28','13:40:00',2.01),('8998','2013-03-28','13:45:00',1.92),('8998','2013-03-28','13:50:00',2.01),('8998','2013-03-28','13:55:00',1.97),('8998','2013-03-28','14:00:00',1.98),('8998','2013-03-28','14:05:00',1.72),('8998','2013-03-28','14:10:00',1.38),('8998','2013-03-28','14:15:00',1.4),('8998','2013-03-28','14:20:00',1.4),('8998','2013-03-28','14:25:00',1.41),('8998','2013-03-28','14:30:00',1.26),('8998','2013-03-28','14:35:00',1.27),('8998','2013-03-28','14:40:00',1.24),('8998','2013-03-28','14:45:00',1.2),('8998','2013-03-28','14:50:00',1.15),('8998','2013-03-28','14:55:00',1.12),('8998','2013-03-28','15:00:00',1.04),('8998','2013-03-28','15:05:00',1.03),('8998','2013-03-27','09:10:00',1.03),('8998','2013-03-27','09:15:00',2.42),('8998','2013-03-27','09:20:00',1.3),('8998','2013-03-27','09:25:00',1.15),('8998','2013-03-27','11:40:00',1.23),('8998','2013-03-27','11:55:00',1.35),('8998','2013-03-27','12:00:00',1.22),('8998','2013-03-27','12:45:00',1.11),('8998','2013-03-27','12:50:00',1.95),('8998','2013-03-27','12:55:00',2.32),('8998','2013-03-27','13:00:00',2.13),('8998','2013-03-27','13:05:00',2.72),('8998','2013-03-27','13:10:00',2.01),('8998','2013-03-27','13:15:00',2.11),('8998','2013-03-27','13:20:00',2.25),('8998','2013-03-27','13:25:00',1.97),('8998','2013-03-27','13:30:00',2.17),('8998','2013-03-27','13:35:00',1.67),('8998','2013-03-27','13:40:00',1.46),('8998','2013-03-27','13:45:00',1.33),('8998','2013-03-27','13:50:00',2.05),('8998','2013-03-27','13:55:00',1.09),('8998','2013-03-27','14:00:00',1.24),('8998','2013-03-27','14:05:00',1.64),('8998','2013-03-27','14:10:00',1.31),('8998','2013-03-27','14:15:00',1.04),('8998','2013-03-27','14:30:00',1.19),('8998','2013-03-27','14:35:00',1.17),('8998','2013-03-27','15:10:00',1.2),('8998','2013-03-27','15:15:00',1.44),('8998','2013-03-27','15:20:00',1.04),('8998','2013-03-27','15:25:00',1.07),('8998','2013-03-27','15:35:00',1.01),('8998','2013-03-27','15:55:00',1.11),('8998','2013-03-26','07:30:00',1.02),('8998','2013-03-26','07:35:00',1.21),('8998','2013-03-26','07:40:00',1.28),('8998','2013-03-26','07:55:00',1.14),('8998','2013-03-26','08:00:00',1.14),('8998','2013-03-26','08:05:00',1.37),('8998','2013-03-26','08:10:00',1.12),('8998','2013-03-26','08:15:00',1.25),('8998','2013-03-26','08:20:00',1.11),('8998','2013-03-26','08:25:00',1.28),('8998','2013-03-26','08:30:00',1.73),('8998','2013-03-26','08:35:00',1.7),('8998','2013-03-26','08:40:00',1.27),('8998','2013-03-26','08:45:00',1.09),('8998','2013-03-26','08:50:00',1.47),('8998','2013-03-26','08:55:00',1.11),('8998','2013-03-26','09:00:00',1.16),('8998','2013-03-26','09:15:00',1.23),('8998','2013-03-26','09:20:00',1.64),('8998','2013-03-26','09:45:00',1.09),('8998','2013-03-26','09:50:00',1.73),('8998','2013-03-26','09:55:00',1.49),('8998','2013-03-26','10:00:00',1.07),('8998','2013-03-26','10:15:00',1.33),('8998','2013-03-26','10:20:00',1.12),('8998','2013-03-26','10:25:00',1.31),('8998','2013-03-26','10:30:00',1.65),('8998','2013-03-26','10:35:00',1.34),('8998','2013-03-26','10:40:00',1.3),('8998','2013-03-26','10:45:00',1.63),('8998','2013-03-26','10:50:00',1.41),('8998','2013-03-26','10:55:00',1.35),('8998','2013-03-26','11:00:00',1.13),('8998','2013-03-26','11:05:00',1.11),('8998','2013-03-26','11:10:00',1.23),('8998','2013-03-26','11:15:00',1.29),('8998','2013-03-26','11:20:00',1.35),('8998','2013-03-26','11:25:00',1.24),('8998','2013-03-26','11:30:00',1.41),('8998','2013-03-26','11:35:00',1.36),('8998','2013-03-26','11:40:00',1.36),('8998','2013-03-26','11:45:00',1.24),('8998','2013-03-26','11:50:00',1.2),('8998','2013-03-26','11:55:00',1.76),('8998','2013-03-26','12:00:00',1.99),('8998','2013-03-26','12:05:00',1.94),('8998','2013-03-26','12:10:00',1.78),('8998','2013-03-26','12:15:00',1.33),('8998','2013-03-26','12:20:00',1.3),('8998','2013-03-26','12:25:00',1.18),('8998','2013-03-26','12:30:00',1.98),('8998','2013-03-26','12:35:00',3.11),('8998','2013-03-26','12:40:00',2.61),('8998','2013-03-26','12:45:00',3.33),('8998','2013-03-26','12:50:00',1.85),('8998','2013-03-26','12:55:00',1.74),('8998','2013-03-26','13:00:00',1.21),('8998','2013-03-26','13:05:00',1.16),('8998','2013-03-26','13:10:00',1.44),('8998','2013-03-26','13:15:00',1.26),('8998','2013-03-26','13:20:00',1.07),('8998','2013-03-26','13:30:00',1.17),('8998','2013-03-26','13:35:00',1.41),('8998','2013-03-26','13:40:00',1.31),('8998','2013-03-26','13:45:00',1.45),('8998','2013-03-26','13:50:00',1.61),('8998','2013-03-26','13:55:00',1.61),('8998','2013-03-26','14:00:00',1.23),('8998','2013-03-26','14:05:00',1.04),('8998','2013-03-26','14:10:00',1.09),('8998','2013-03-26','14:15:00',1.22),('8998','2013-03-26','14:20:00',1.43),('8998','2013-03-26','14:25:00',1.18),('8998','2013-03-26','14:30:00',1.04),('8998','2013-03-26','14:35:00',1.04),('8998','2013-03-26','14:40:00',1.3),('8998','2013-03-26','14:45:00',1.3),('8998','2013-03-26','15:10:00',1.11),('8998','2013-03-25','07:50:00',1.28),('8998','2013-03-25','07:55:00',1.76),('8998','2013-03-25','08:40:00',1.07),('8998','2013-03-25','09:55:00',1.89),('8998','2013-03-25','10:00:00',1.25),('8998','2013-03-25','11:10:00',1.77),('8998','2013-03-25','11:15:00',1.24),('8998','2013-03-25','11:20:00',1.1),('8998','2013-03-25','12:20:00',1.07),('8998','2013-03-25','12:25:00',1.67),('8998','2013-03-25','12:30:00',1.6),('8998','2013-03-25','12:35:00',1.94),('8998','2013-03-25','12:40:00',1.24),('8998','2013-03-25','12:45:00',1.95),('8998','2013-03-25','12:50:00',1.49),('8998','2013-03-25','13:05:00',1.61),('8998','2013-03-25','13:10:00',1.48),('8998','2013-03-25','13:15:00',1.48),('8998','2013-03-25','13:20:00',1.08),('8998','2013-03-25','13:25:00',1.48),('8998','2013-03-25','13:30:00',1.12),('8998','2013-03-25','13:35:00',1.29),('8998','2013-03-25','13:40:00',1.48),('8998','2013-03-25','13:45:00',1.35),('8998','2013-03-25','13:50:00',1.23),('8998','2013-03-25','13:55:00',1.12),('8998','2013-03-25','14:00:00',1.1),('8998','2013-03-25','14:05:00',1.05),('8998','2013-03-25','14:10:00',1.08),('8998','2013-03-25','14:15:00',1.03),('8998','2013-03-24','08:25:00',1.64),('8998','2013-03-24','08:30:00',1.08),('8998','2013-03-24','09:20:00',1.9),('8998','2013-03-24','09:25:00',2.59),('8998','2013-03-24','09:30:00',1.34),('8998','2013-03-24','09:50:00',2.24),('8998','2013-03-24','09:55:00',3.08),('8998','2013-03-24','10:00:00',1.92),('8998','2013-03-24','10:25:00',1.66),('8998','2013-03-24','10:30:00',1.89),('8998','2013-03-24','10:40:00',1.23),('8998','2013-03-24','10:45:00',1.76),('8998','2013-03-24','10:50:00',1.48),('8998','2013-03-24','10:55:00',1.72),('8998','2013-03-24','11:00:00',1.61),('8998','2013-03-24','11:05:00',1.39),('8998','2013-03-24','11:10:00',1.36),('8998','2013-03-24','11:15:00',1.34),('8998','2013-03-24','11:20:00',2.78),('8998','2013-03-24','11:25:00',2.56),('8998','2013-03-24','11:30:00',2.11),('8998','2013-03-24','11:35:00',1.78),('8998','2013-03-24','11:40:00',1.11),('8998','2013-03-24','11:45:00',1.24),('8998','2013-03-24','11:50:00',1.24),('8998','2013-03-24','11:55:00',1.87),('8998','2013-03-24','12:00:00',3.1),('8998','2013-03-24','12:05:00',2.54),('8998','2013-03-24','12:10:00',2.61),('8998','2013-03-24','12:15:00',2.88),('8998','2013-03-24','12:20:00',2.03),('8998','2013-03-24','12:25:00',2.47),('8998','2013-03-24','12:30:00',2.6),('8998','2013-03-24','12:35:00',2.07),('8998','2013-03-24','12:40:00',1.66),('8998','2013-03-24','12:45:00',1.78),('8998','2013-03-24','12:50:00',1.98),('8998','2013-03-24','12:55:00',1.94),('8998','2013-03-24','13:00:00',1.57),('8998','2013-03-24','13:05:00',2.8),('8998','2013-03-24','13:10:00',2.39),('8998','2013-03-24','13:15:00',2.31),('8998','2013-03-24','13:20:00',2.6),('8998','2013-03-24','13:25:00',1.69),('8998','2013-03-24','13:30:00',1.33),('8998','2013-03-24','13:45:00',1.23),('8998','2013-03-24','13:50:00',1.47),('8998','2013-03-24','13:55:00',1.31),('8998','2013-03-24','14:10:00',1.63),('8998','2013-03-24','14:15:00',1.39),('8998','2013-03-24','14:20:00',1.36),('8998','2013-03-24','14:25:00',1.74),('8998','2013-03-24','14:30:00',1.94),('8998','2013-03-24','14:35:00',1.34),('8998','2013-03-24','14:55:00',1.35),('8998','2013-03-24','15:00:00',1.25),('8998','2013-03-24','15:05:00',1.17),('8998','2013-03-24','15:10:00',1.09),('8998','2013-03-24','15:15:00',1.02),('8998','2013-03-24','15:20:00',1.24),('8998','2013-03-24','15:25:00',1.45),('8998','2013-03-24','15:30:00',1.12),('8998','2013-03-24','15:35:00',1.28),('8998','2013-03-23','07:45:00',1.04),('8998','2013-03-23','07:50:00',1.3),('8998','2013-03-23','07:55:00',1.48),('8998','2013-03-23','08:00:00',1.77),('8998','2013-03-23','08:05:00',1.84),('8998','2013-03-23','08:10:00',1.85),('8998','2013-03-23','08:15:00',1.97),('8998','2013-03-23','08:20:00',2.04),('8998','2013-03-23','08:25:00',2.13),('8998','2013-03-23','08:30:00',2.17),('8998','2013-03-23','08:35:00',2.21),('8998','2013-03-23','08:40:00',2.25),('8998','2013-03-23','08:45:00',2.27),('8998','2013-03-23','08:50:00',2.28),('8998','2013-03-23','08:55:00',2.31),('8998','2013-03-23','09:00:00',2.34),('8998','2013-03-23','09:05:00',2.4),('8998','2013-03-23','09:10:00',2.45),('8998','2013-03-23','09:15:00',2.47),('8998','2013-03-23','09:20:00',2.5),('8998','2013-03-23','09:25:00',2.52),('8998','2013-03-23','09:30:00',2.53),('8998','2013-03-23','09:35:00',2.55),('8998','2013-03-23','09:40:00',2.57),('8998','2013-03-23','09:45:00',2.59),('8998','2013-03-23','09:50:00',2.63),('8998','2013-03-23','09:55:00',2.63),('8998','2013-03-23','10:00:00',2.65),('8998','2013-03-23','10:05:00',2.68),('8998','2013-03-23','10:10:00',2.7),('8998','2013-03-23','10:15:00',2.71),('8998','2013-03-23','10:20:00',2.71),('8998','2013-03-23','10:25:00',2.71),('8998','2013-03-23','10:30:00',2.71),('8998','2013-03-23','10:35:00',2.71),('8998','2013-03-23','10:40:00',2.7),('8998','2013-03-23','10:45:00',2.7),('8998','2013-03-23','10:50:00',2.7),('8998','2013-03-23','10:55:00',2.7),('8998','2013-03-23','11:00:00',2.69),('8998','2013-03-23','11:05:00',2.69),('8998','2013-03-23','11:10:00',2.7),('8998','2013-03-23','11:15:00',2.69),('8998','2013-03-23','11:20:00',2.68),('8998','2013-03-23','11:25:00',2.68),('8998','2013-03-23','11:30:00',2.68),('8998','2013-03-23','11:35:00',2.66),('8998','2013-03-23','11:40:00',2.64),('8998','2013-03-23','11:45:00',2.62),('8998','2013-03-23','11:50:00',2.62),('8998','2013-03-23','11:55:00',2.6),('8998','2013-03-23','12:00:00',2.6),('8998','2013-03-23','12:05:00',2.58),('8998','2013-03-23','12:10:00',2.58),('8998','2013-03-23','12:15:00',2.58),('8998','2013-03-23','12:20:00',2.58),('8998','2013-03-23','12:25:00',2.58),('8998','2013-03-23','12:30:00',2.56),('8998','2013-03-23','12:35:00',2.55),('8998','2013-03-23','12:40:00',2.51),('8998','2013-03-23','12:45:00',2.49),('8998','2013-03-23','12:50:00',2.47),('8998','2013-03-23','12:55:00',2.43),('8998','2013-03-23','13:00:00',2.38),('8998','2013-03-23','13:05:00',2.37),('8998','2013-03-23','13:10:00',2.32),('8998','2013-03-23','13:15:00',2.29),('8998','2013-03-23','13:20:00',2.26),('8998','2013-03-23','13:25:00',2.2),('8998','2013-03-23','13:30:00',2.15),('8998','2013-03-23','13:35:00',2.11),('8998','2013-03-23','13:40:00',2.08),('8998','2013-03-23','13:45:00',2.02),('8998','2013-03-23','13:50:00',1.98),('8998','2013-03-23','13:55:00',1.93),('8998','2013-03-23','14:00:00',1.88),('8998','2013-03-23','14:05:00',1.82),('8998','2013-03-23','14:10:00',1.75),('8998','2013-03-23','14:15:00',1.71),('8998','2013-03-23','14:20:00',1.65),('8998','2013-03-23','14:25:00',1.59),('8998','2013-03-23','14:30:00',1.53),('8998','2013-03-23','14:35:00',1.44),('8998','2013-03-23','14:40:00',1.4),('8998','2013-03-23','14:45:00',1.35),('8998','2013-03-23','14:50:00',1.28),('8998','2013-03-23','14:55:00',1.24),('8998','2013-03-23','15:00:00',1.17),('8998','2013-03-23','15:05:00',1.1),('8998','2013-03-23','15:10:00',1.02),('8998','2013-03-23','15:15:00',1.08),('8998','2013-03-23','15:20:00',1.03),('8998','2013-03-22','07:40:00',1.07),('8998','2013-03-22','07:45:00',1.23),('8998','2013-03-22','07:50:00',1.51),('8998','2013-03-22','07:55:00',1.67),('8998','2013-03-22','08:00:00',1.78),('8998','2013-03-22','08:05:00',1.91),('8998','2013-03-22','08:10:00',1.94),('8998','2013-03-22','08:15:00',2.03),('8998','2013-03-22','08:20:00',2.07),('8998','2013-03-22','08:25:00',2.12),('8998','2013-03-22','08:30:00',2.13),('8998','2013-03-22','08:35:00',2.19),('8998','2013-03-22','08:40:00',2.26),('8998','2013-03-22','08:45:00',2.31),('8998','2013-03-22','08:50:00',2.33),('8998','2013-03-22','08:55:00',2.44),('8998','2013-03-22','09:00:00',2.46),('8998','2013-03-22','09:05:00',2.5),('8998','2013-03-22','09:10:00',2.48),('8998','2013-03-22','09:15:00',2.56),('8998','2013-03-22','09:20:00',2.52),('8998','2013-03-22','09:25:00',2.59),('8998','2013-03-22','09:30:00',2.66),('8998','2013-03-22','09:35:00',2.65),('8998','2013-03-22','09:40:00',2.5),('8998','2013-03-22','09:45:00',2.65),('8998','2013-03-22','09:50:00',2.66),('8998','2013-03-22','09:55:00',2.72),('8998','2013-03-22','10:00:00',2.73),('8998','2013-03-22','10:05:00',2.74),('8998','2013-03-22','10:10:00',2.77),('8998','2013-03-22','10:15:00',2.71),('8998','2013-03-22','10:20:00',2.69),('8998','2013-03-22','10:25:00',2.65),('8998','2013-03-22','10:30:00',2.81),('8998','2013-03-22','10:35:00',2.81),('8998','2013-03-22','10:40:00',2.77),('8998','2013-03-22','10:45:00',2.74),('8998','2013-03-22','10:50:00',2.72),('8998','2013-03-22','10:55:00',2.6),('8998','2013-03-22','11:00:00',2.52),('8998','2013-03-22','11:05:00',2.35),('8998','2013-03-22','11:10:00',1.97),('8998','2013-03-22','11:15:00',2.09),('8998','2013-03-22','11:20:00',2.62),('8998','2013-03-22','11:25:00',2.61),('8998','2013-03-22','11:30:00',2.6),('8998','2013-03-22','11:35:00',2.7),('8998','2013-03-22','11:40:00',2.68),('8998','2013-03-22','11:45:00',2.67),('8998','2013-03-22','11:50:00',2.54),('8998','2013-03-22','11:55:00',2.65),('8998','2013-03-22','12:00:00',2.63),('8998','2013-03-22','12:05:00',2.59),('8998','2013-03-22','12:10:00',2.56),('8998','2013-03-22','12:15:00',2.58),('8998','2013-03-22','12:20:00',2.58),('8998','2013-03-22','12:25:00',2.54),('8998','2013-03-22','12:30:00',2.56),('8998','2013-03-22','12:35:00',2.53),('8998','2013-03-22','12:40:00',2.37),('8998','2013-03-22','12:45:00',2.41),('8998','2013-03-22','12:50:00',2.43),('8998','2013-03-22','12:55:00',2.37),('8998','2013-03-22','13:00:00',1.77),('8998','2013-03-22','13:05:00',2.3),('8998','2013-03-22','13:10:00',2.3),('8998','2013-03-22','13:15:00',2.16),('8998','2013-03-22','13:20:00',2.19),('8998','2013-03-22','13:25:00',2.16),('8998','2013-03-22','13:30:00',2.04),('8998','2013-03-22','13:35:00',1.85),('8998','2013-03-22','13:40:00',1.99),('8998','2013-03-22','13:45:00',1.54),('8998','2013-03-22','13:50:00',1.94),('8998','2013-03-22','13:55:00',1.89),('8998','2013-03-22','14:00:00',1.83),('8998','2013-03-22','14:05:00',1.8),('8998','2013-03-22','14:10:00',1.74),('8998','2013-03-22','14:15:00',1.67),('8998','2013-03-22','14:20:00',1.68),('8998','2013-03-22','14:25:00',1.63),('8998','2013-03-22','14:30:00',1.59),('8998','2013-03-22','14:35:00',1.51),('8998','2013-03-22','14:40:00',1.44),('8998','2013-03-22','14:45:00',1.32),('8998','2013-03-22','14:50:00',1.28),('8998','2013-03-22','14:55:00',1.25),('8998','2013-03-22','15:00:00',1.11),('8998','2013-03-22','15:05:00',1.08),('8998','2013-03-22','15:10:00',1.06),('8998','2014-03-25','07:35:00',1.32),('8998','2014-03-25','07:40:00',1.31),('8998','2014-03-25','07:45:00',1.2),('8998','2014-03-25','07:50:00',1.34),('8998','2014-03-25','07:55:00',1.47),('8998','2014-03-25','08:00:00',1.61),('8998','2014-03-25','08:05:00',1.66),('8998','2014-03-25','08:10:00',1.77),('8998','2014-03-25','08:15:00',2.02),('8998','2014-03-25','08:20:00',2.44),('8998','2014-03-25','08:25:00',1.56),('8998','2014-03-25','08:50:00',1.05),('8998','2014-03-25','09:00:00',1.04),('8998','2014-03-25','09:05:00',1.02),('8998','2014-03-25','09:10:00',1.19),('8998','2014-03-25','09:30:00',2.67),('8998','2014-03-25','09:35:00',2.82),('8998','2014-03-25','09:40:00',2.79),('8998','2014-03-25','09:45:00',2.8),('8998','2014-03-25','09:50:00',2.8),('8998','2014-03-25','09:55:00',2.69),('8998','2014-03-25','10:00:00',2.89),('8998','2014-03-25','10:05:00',2.21),('8998','2014-03-25','10:10:00',3.01),('8998','2014-03-25','10:15:00',3.05),('8998','2014-03-25','10:20:00',2.96),('8998','2014-03-25','10:25:00',3.06),('8998','2014-03-25','10:30:00',3.03),('8998','2014-03-25','10:35:00',2.31),('8998','2014-03-25','10:45:00',1.97),('8998','2014-03-25','10:50:00',2.76),('8998','2014-03-25','10:55:00',1.91),('8998','2014-03-25','11:00:00',2.71),('8998','2014-03-25','11:05:00',1.27),('8998','2014-03-25','11:10:00',1.48),('8998','2014-03-25','11:15:00',3.18),('8998','2014-03-25','11:20:00',2.39),('8998','2014-03-25','11:30:00',1.08),('8998','2014-03-25','11:35:00',1.33),('8998','2014-03-25','11:40:00',1.65),('8998','2014-03-25','11:45:00',1.34),('8998','2014-03-25','11:50:00',2.28),('8998','2014-03-25','11:55:00',2.45),('8998','2014-03-25','12:00:00',3.32),('8998','2014-03-25','12:05:00',2.47),('8998','2014-03-25','12:10:00',3.04),('8998','2014-03-25','12:15:00',1.06),('8998','2014-03-25','12:20:00',1.18),('8998','2014-03-25','12:25:00',1.24),('8998','2014-03-25','12:30:00',1.16),('8998','2014-03-25','12:35:00',1.21),('8998','2014-03-25','12:40:00',1.2),('8998','2014-03-25','12:45:00',1.46),('8998','2014-03-25','12:50:00',1.15),('8998','2014-03-25','13:25:00',2.42),('8998','2014-03-25','13:30:00',2.23),('8998','2014-03-25','13:35:00',1.19),('8998','2014-03-25','13:40:00',1.25),('8998','2014-03-25','14:05:00',1.36),('8998','2014-03-25','14:10:00',2.54),('8998','2014-03-25','14:15:00',1.77),('8998','2014-03-25','14:50:00',1.59),('8998','2014-03-25','14:55:00',1.57),('8998','2014-03-25','15:00:00',1.42),('8998','2014-03-25','15:05:00',1.37),('8998','2014-03-25','15:10:00',1.36),('8998','2014-03-25','15:15:00',1.41),('8998','2014-03-25','15:20:00',1.33),('8998','2014-03-25','15:25:00',1.3),('8998','2014-03-25','15:30:00',1.24),('8998','2014-03-25','15:35:00',1.15),('8998','2013-03-21','07:40:00',1.47),('8998','2013-03-21','07:45:00',1.62),('8998','2013-03-21','07:50:00',1.68),('8998','2013-03-21','07:55:00',1.73),('8998','2013-03-21','08:00:00',1.78),('8998','2013-03-21','08:05:00',1.84),('8998','2013-03-21','08:10:00',1.91),('8998','2013-03-21','08:15:00',2),('8998','2013-03-21','08:20:00',2.07),('8998','2013-03-21','08:25:00',2.15),('8998','2013-03-21','08:30:00',2.22),('8998','2013-03-21','08:35:00',2.27),('8998','2013-03-21','08:40:00',2.32),('8998','2013-03-21','08:45:00',2.35),('8998','2013-03-21','08:50:00',2.38),('8998','2013-03-21','08:55:00',2.41),('8998','2013-03-21','09:00:00',2.44),('8998','2013-03-21','09:05:00',2.47),('8998','2013-03-21','09:10:00',2.51),('8998','2013-03-21','09:15:00',2.54),('8998','2013-03-21','09:20:00',2.53),('8998','2013-03-21','09:25:00',2.58),('8998','2013-03-21','09:30:00',2.6),('8998','2013-03-21','09:35:00',2.64),('8998','2013-03-21','09:40:00',2.68),('8998','2013-03-21','09:45:00',2.68),('8998','2013-03-21','09:50:00',2.73),('8998','2013-03-21','09:55:00',2.7),('8998','2013-03-21','10:00:00',2.73),('8998','2013-03-21','10:05:00',2.7),('8998','2013-03-21','10:10:00',2.74),('8998','2013-03-21','10:15:00',2.75),('8998','2013-03-21','10:20:00',2.72),('8998','2013-03-21','10:25:00',2.77),('8998','2013-03-21','10:30:00',2.82),('8998','2013-03-21','10:35:00',2.83),('8998','2013-03-21','10:40:00',2.86),('8998','2013-03-21','10:45:00',2.85),('8998','2013-03-21','10:50:00',2.86),('8998','2013-03-21','10:55:00',2.85),('8998','2013-03-21','11:00:00',2.84),('8998','2013-03-21','11:05:00',2.84),('8998','2013-03-21','11:10:00',2.84),('8998','2013-03-21','11:15:00',2.83),('8998','2013-03-21','11:20:00',2.82),('8998','2013-03-21','11:25:00',2.8),('8998','2013-03-21','11:30:00',2.8),('8998','2013-03-21','11:35:00',2.8),('8998','2013-03-21','11:40:00',2.76),('8998','2013-03-21','11:45:00',2.8),('8998','2013-03-21','11:50:00',2.77),('8998','2013-03-21','11:55:00',2.76),('8998','2013-03-21','12:00:00',2.74),('8998','2013-03-21','12:05:00',2.72),('8998','2013-03-21','12:10:00',2.7),('8998','2013-03-21','12:15:00',2.67),('8998','2013-03-21','12:20:00',2.66),('8998','2013-03-21','12:25:00',2.62),('8998','2013-03-21','12:30:00',2.6),('8998','2013-03-21','12:35:00',2.58),('8998','2013-03-21','12:40:00',2.57),('8998','2013-03-21','12:45:00',2.53),('8998','2013-03-21','12:50:00',2.43),('8998','2013-03-21','12:55:00',2.25),('8998','2013-03-21','13:00:00',2.46),('8998','2013-03-21','13:05:00',2.34),('8998','2013-03-21','13:10:00',2.39),('8998','2013-03-21','13:15:00',2.35),('8998','2013-03-21','13:20:00',2.29),('8998','2013-03-21','13:25:00',2.15),('8998','2013-03-21','13:30:00',2.09),('8998','2013-03-21','13:35:00',2.13),('8998','2013-03-21','13:40:00',1.74),('8998','2013-03-21','13:45:00',1.8),('8998','2013-03-21','13:50:00',2.06),('8998','2013-03-21','13:55:00',1.99),('8998','2013-03-21','14:00:00',1.91),('8998','2013-03-21','14:05:00',1.86),('8998','2013-03-21','14:10:00',1.81),('8998','2013-03-21','14:15:00',1.75),('8998','2013-03-21','14:20:00',1.7),('8998','2013-03-21','14:25:00',1.62),('8998','2013-03-21','14:30:00',1.58),('8998','2013-03-21','14:35:00',1.51),('8998','2013-03-21','14:40:00',1.44),('8998','2013-03-21','14:45:00',1.39),('8998','2013-03-21','14:50:00',1.32),('8998','2013-03-21','14:55:00',1.22),('8998','2013-03-21','15:00:00',1.18),('8998','2013-03-21','15:05:00',1.11),('8998','2013-03-20','07:45:00',1.36),('8998','2013-03-20','07:50:00',1.84),('8998','2013-03-20','08:10:00',1.31),('8998','2013-03-20','08:15:00',2.16),('8998','2013-03-20','08:20:00',2.18),('8998','2013-03-20','08:25:00',2.09),('8998','2013-03-20','08:30:00',2.29),('8998','2013-03-20','08:35:00',2.36),('8998','2013-03-20','08:40:00',2.35),('8998','2013-03-20','08:45:00',2.38),('8998','2013-03-20','08:50:00',2.46),('8998','2013-03-20','08:55:00',2.44),('8998','2013-03-20','09:00:00',2.57),('8998','2013-03-20','09:05:00',2.66),('8998','2013-03-20','09:10:00',2.92),('8998','2013-03-20','09:15:00',1.99),('8998','2013-03-20','09:20:00',2.43),('8998','2013-03-20','09:25:00',2.82),('8998','2013-03-20','09:30:00',2.81),('8998','2013-03-20','09:35:00',2.79),('8998','2013-03-20','09:40:00',2.84),('8998','2013-03-20','09:45:00',2.87),('8998','2013-03-20','09:50:00',2.45),('8998','2013-03-20','09:55:00',2.96),('8998','2013-03-20','10:00:00',2.98),('8998','2013-03-20','10:05:00',2.97),('8998','2013-03-20','10:10:00',2.98),('8998','2013-03-20','10:15:00',2.97),('8998','2013-03-20','10:20:00',2.98),('8998','2013-03-20','10:25:00',2.96),('8998','2013-03-20','10:30:00',2.96),('8998','2013-03-20','10:35:00',2.98),('8998','2013-03-20','10:40:00',2.99),('8998','2013-03-20','10:45:00',2.96),('8998','2013-03-20','10:50:00',2.93),('8998','2013-03-20','10:55:00',2.12),('8998','2013-03-20','11:00:00',3.01),('8998','2013-03-20','11:05:00',2.99),('8998','2013-03-20','11:10:00',2.98),('8998','2013-03-20','11:15:00',2.97),('8998','2013-03-20','11:20:00',2.96),('8998','2013-03-20','11:25:00',2.96),('8998','2013-03-20','11:30:00',2.95),('8998','2013-03-20','11:35:00',2.94),('8998','2013-03-20','11:40:00',2.93),('8998','2013-03-20','11:45:00',2.92),('8998','2013-03-20','11:50:00',2.91),('8998','2013-03-20','11:55:00',2.89),('8998','2013-03-20','12:00:00',2.88),('8998','2013-03-20','12:05:00',2.86),('8998','2013-03-20','12:10:00',2.84),('8998','2013-03-20','12:15:00',2.8),('8998','2013-03-20','12:20:00',2.77),('8998','2013-03-20','12:25:00',2.74),('8998','2013-03-20','12:30:00',2.72),('8998','2013-03-20','12:35:00',2.7),('8998','2013-03-20','12:40:00',2.67),('8998','2013-03-20','12:45:00',2.63),('8998','2013-03-20','12:50:00',2.59),('8998','2013-03-20','12:55:00',2.54),('8998','2013-03-20','13:00:00',2.5),('8998','2013-03-20','13:05:00',2.45),('8998','2013-03-20','13:10:00',2.41),('8998','2013-03-20','13:15:00',2.37),('8998','2013-03-20','13:20:00',2.33),('8998','2013-03-20','13:25:00',2.28),('8998','2013-03-20','13:30:00',2.25),('8998','2013-03-20','13:35:00',2.21),('8998','2013-03-20','13:40:00',2.16),('8998','2013-03-20','13:45:00',2.11),('8998','2013-03-20','13:50:00',2.06),('8998','2013-03-20','13:55:00',2),('8998','2013-03-20','14:00:00',1.95),('8998','2013-03-20','14:05:00',1.88),('8998','2013-03-20','14:10:00',1.82),('8998','2013-03-20','14:15:00',1.76),('8998','2013-03-20','14:20:00',1.7),('8998','2013-03-20','14:25:00',1.65),('8998','2013-03-20','14:30:00',1.58),('8998','2013-03-20','14:35:00',1.52),('8998','2013-03-20','14:40:00',1.45),('8998','2013-03-20','14:45:00',1.38),('8998','2013-03-20','14:50:00',1.29),('8998','2013-03-20','14:55:00',1.25),('8998','2013-03-20','15:00:00',1.17),('8998','2013-03-20','15:05:00',1.1),('8998','2013-03-20','15:10:00',1.04),('8998','2013-03-19','07:40:00',1.02),('8998','2013-03-19','07:45:00',1.43),('8998','2013-03-19','07:50:00',1.48),('8998','2013-03-19','07:55:00',1.61),('8998','2013-03-19','08:00:00',1.56),('8998','2013-03-19','08:05:00',1.54),('8998','2013-03-19','08:10:00',1.89),('8998','2013-03-19','08:15:00',1.98),('8998','2013-03-19','08:20:00',2.03),('8998','2013-03-19','08:25:00',2.09),('8998','2013-03-19','08:30:00',2.16),('8998','2013-03-19','08:35:00',2.14),('8998','2013-03-19','08:40:00',2.06),('8998','2013-03-19','08:45:00',2.19),('8998','2013-03-19','08:50:00',2.27),('8998','2013-03-19','08:55:00',2.2),('8998','2013-03-19','09:00:00',2.08),('8998','2013-03-19','09:05:00',2.69),('8998','2013-03-19','09:10:00',2.2),('8998','2013-03-19','09:15:00',2.49),('8998','2013-03-19','09:20:00',2.47),('8998','2013-03-19','09:25:00',2.49),('8998','2013-03-19','09:30:00',2.64),('8998','2013-03-19','09:35:00',2.55),('8998','2013-03-19','09:40:00',2.65),('8998','2013-03-19','09:45:00',2.68),('8998','2013-03-19','09:50:00',2.67),('8998','2013-03-19','09:55:00',2.63),('8998','2013-03-19','10:00:00',2.71),('8998','2013-03-19','10:05:00',2.68),('8998','2013-03-19','10:10:00',2.55),('8998','2013-03-19','10:15:00',1.97),('8998','2013-03-19','10:20:00',2.1),('8998','2013-03-19','10:25:00',1.81),('8998','2013-03-19','10:30:00',2.43),('8998','2013-03-19','10:35:00',2.74),('8998','2013-03-19','10:40:00',2.43),('8998','2013-03-19','10:45:00',1.7),('8998','2013-03-19','10:50:00',2.5),('8998','2013-03-19','10:55:00',2.19),('8998','2013-03-19','11:00:00',2.06),('8998','2013-03-19','11:05:00',2.23),('8998','2013-03-19','11:10:00',2.03),('8998','2013-03-19','11:15:00',1.69),('8998','2013-03-19','11:20:00',1.91),('8998','2013-03-19','11:25:00',1.86),('8998','2013-03-19','11:30:00',1.71),('8998','2013-03-19','11:35:00',1.89),('8998','2013-03-19','11:40:00',1.56),('8998','2013-03-19','11:45:00',1.44),('8998','2013-03-19','11:50:00',1.37),('8998','2013-03-19','11:55:00',1.55),('8998','2013-03-19','12:00:00',1.48),('8998','2013-03-19','12:05:00',1.67),('8998','2013-03-19','12:10:00',1.39),('8998','2013-03-19','12:15:00',1.22),('8998','2013-03-19','12:20:00',1.16),('8998','2013-03-19','12:55:00',1.08),('8998','2013-03-19','13:00:00',1.28),('8998','2013-03-19','13:30:00',1.04),('8998','2013-03-19','13:40:00',1.14),('8998','2013-03-19','13:45:00',1.39),('8998','2013-03-19','13:50:00',1.2),('8998','2013-03-19','13:55:00',1.09),('8998','2013-03-19','14:00:00',1.12),('8998','2013-03-19','14:15:00',1.09),('8998','2013-03-19','14:20:00',1.35),('8998','2013-03-19','14:25:00',1.29),('8998','2013-03-19','14:30:00',1.14),('8998','2013-03-18','07:40:00',1.06),('8998','2013-03-18','07:45:00',1.27),('8998','2013-03-18','07:50:00',1.6),('8998','2013-03-18','07:55:00',1.62),('8998','2013-03-18','08:00:00',1.15),('8998','2013-03-18','08:05:00',1.52),('8998','2013-03-18','08:10:00',1.79),('8998','2013-03-18','08:15:00',1.99),('8998','2013-03-18','08:20:00',2.03),('8998','2013-03-18','08:25:00',2.06),('8998','2013-03-18','08:30:00',1.88),('8998','2013-03-18','08:35:00',2.19),('8998','2013-03-18','08:40:00',2.25),('8998','2013-03-18','08:45:00',2.34),('8998','2013-03-18','08:50:00',2.41),('8998','2013-03-18','08:55:00',2.43),('8998','2013-03-18','09:00:00',2.47),('8998','2013-03-18','09:05:00',2.38),('8998','2013-03-18','09:10:00',2.57),('8998','2013-03-18','09:15:00',2.44),('8998','2013-03-18','09:20:00',2.05),('8998','2013-03-18','09:25:00',2.4),('8998','2013-03-18','09:30:00',2.7),('8998','2013-03-18','09:35:00',2.71),('8998','2013-03-18','09:40:00',2.78),('8998','2013-03-18','09:45:00',2.86),('8998','2013-03-18','09:50:00',2.83),('8998','2013-03-18','09:55:00',2.2),('8998','2013-03-18','10:00:00',3.02),('8998','2013-03-18','10:05:00',2.46),('8998','2013-03-18','10:10:00',2.77),('8998','2013-03-18','10:15:00',2.87),('8998','2013-03-18','10:20:00',2.89),('8998','2013-03-18','10:25:00',2.93),('8998','2013-03-18','10:30:00',2.92),('8998','2013-03-18','10:35:00',2.91),('8998','2013-03-18','10:40:00',2.92),('8998','2013-03-18','10:45:00',2.91),('8998','2013-03-18','10:50:00',2.94),('8998','2013-03-18','10:55:00',2.87),('8998','2013-03-18','11:00:00',2.96),('8998','2013-03-18','11:05:00',2.94),('8998','2013-03-18','11:10:00',2.87),('8998','2013-03-18','11:15:00',2.93),('8998','2013-03-18','11:20:00',2.91),('8998','2013-03-18','11:25:00',2.9),('8998','2013-03-18','11:30:00',2.85),('8998','2013-03-18','11:35:00',1.83),('8998','2013-03-18','11:40:00',2.47),('8998','2013-03-18','11:45:00',2.65),('8998','2013-03-18','11:50:00',2.81),('8998','2013-03-18','11:55:00',2.88),('8998','2013-03-18','12:00:00',2.81),('8998','2013-03-18','12:05:00',2.73),('8998','2013-03-18','12:10:00',2.75),('8998','2013-03-18','12:15:00',2.6),('8998','2013-03-18','12:20:00',2.7),('8998','2013-03-18','12:25:00',2.63),('8998','2013-03-18','12:30:00',2.62),('8998','2013-03-18','12:35:00',2.59),('8998','2013-03-18','12:40:00',2.57),('8998','2013-03-18','12:45:00',2.56),('8998','2013-03-18','12:50:00',2.44),('8998','2013-03-18','12:55:00',2.38),('8998','2013-03-18','13:00:00',2.43),('8998','2013-03-18','13:05:00',2.39),('8998','2013-03-18','13:10:00',2.33),('8998','2013-03-18','13:15:00',2.3),('8998','2013-03-18','13:20:00',2.25),('8998','2013-03-18','13:25:00',2.21),('8998','2013-03-18','13:30:00',2.18),('8998','2013-03-18','13:35:00',2.12),('8998','2013-03-18','13:40:00',2.06),('8998','2013-03-18','13:45:00',2.04),('8998','2013-03-18','13:50:00',1.99),('8998','2013-03-18','13:55:00',1.93),('8998','2013-03-18','14:00:00',1.88),('8998','2013-03-18','14:05:00',1.82),('8998','2013-03-18','14:10:00',1.78),('8998','2013-03-18','14:15:00',1.73),('8998','2013-03-18','14:20:00',1.66),('8998','2013-03-18','14:25:00',1.6),('8998','2013-03-18','14:30:00',1.53),('8998','2013-03-18','14:35:00',1.47),('8998','2013-03-18','14:40:00',1.4),('8998','2013-03-18','14:45:00',1.32),('8998','2013-03-18','14:50:00',1.22),('8998','2013-03-18','14:55:00',1.17),('8998','2013-03-18','15:00:00',1.11),('8998','2013-03-18','15:05:00',1.05),('8998','2013-03-17','10:05:00',1.01),('8998','2013-03-17','10:10:00',1.02),('8998','2013-03-17','10:20:00',1.09),('8998','2013-03-17','10:25:00',1.39),('8998','2013-03-17','10:30:00',1.34),('8998','2013-03-17','10:35:00',1.04),('8998','2013-03-17','11:10:00',1.07),('8998','2013-03-17','11:15:00',1.16),('8998','2013-03-17','11:20:00',1.2),('8998','2013-03-17','11:25:00',1.25),('8998','2013-03-17','11:30:00',1.55),('8998','2013-03-17','11:35:00',1.35),('8998','2013-03-17','11:40:00',1.21),('8998','2013-03-17','11:45:00',1.04),('8998','2013-03-17','12:00:00',1.01),('8998','2013-03-17','12:05:00',1.7),('8998','2013-03-17','12:10:00',1.63),('8998','2013-03-17','12:15:00',1.92),('8998','2013-03-17','12:20:00',1.89),('8998','2013-03-17','12:25:00',1.25),('8998','2013-03-17','12:30:00',2.15),('8998','2013-03-17','12:35:00',2.27),('8998','2013-03-17','12:40:00',2.03),('8998','2013-03-17','12:45:00',1.66),('8998','2013-03-17','12:50:00',2.32),('8998','2013-03-17','12:55:00',2.44),('8998','2013-03-17','13:00:00',1.64),('8998','2013-03-17','13:25:00',1.08),('8998','2013-03-17','13:40:00',1.1),('8998','2013-03-17','13:45:00',1.1),('8998','2013-03-17','13:50:00',1.1),('8998','2013-03-17','13:55:00',1.07),('8998','2013-03-17','14:00:00',1.09),('8998','2013-03-17','14:05:00',1.59),('8998','2013-03-17','14:10:00',1.57),('8998','2013-03-17','14:25:00',1.05),('8998','2013-03-16','08:20:00',1.11),('8998','2013-03-16','08:25:00',1.34),('8998','2013-03-16','08:30:00',1.27),('8998','2013-03-16','08:45:00',1.15),('8998','2013-03-16','08:50:00',1.16),('8998','2013-03-16','08:55:00',1.07),('8998','2013-03-16','09:00:00',1.01),('8998','2013-03-16','09:05:00',1.18),('8998','2013-03-16','09:10:00',1.35),('8998','2013-03-16','09:15:00',1.51),('8998','2013-03-16','09:20:00',1.27),('8998','2013-03-16','09:25:00',1.05),('8998','2013-03-16','09:30:00',1.08),('8998','2013-03-16','09:35:00',1.3),('8998','2013-03-16','09:40:00',1.16),('8998','2013-03-16','09:45:00',1.16),('8998','2013-03-16','09:50:00',1.3),('8998','2013-03-16','09:55:00',1.41),('8998','2013-03-16','10:00:00',1.55),('8998','2013-03-16','10:05:00',1.3),('8998','2013-03-16','10:10:00',1.24),('8998','2013-03-16','10:15:00',1.36),('8998','2013-03-16','10:20:00',1.36),('8998','2013-03-16','10:25:00',1.43),('8998','2013-03-16','10:30:00',1.4),('8998','2013-03-16','10:35:00',1.32),('8998','2013-03-16','10:40:00',1.25),('8998','2013-03-16','10:45:00',1.31),('8998','2013-03-16','10:50:00',1.31),('8998','2013-03-16','10:55:00',1.15),('8998','2013-03-16','11:00:00',1.19),('8998','2013-03-16','11:05:00',1.04),('8998','2013-03-16','11:20:00',1.14),('8998','2013-03-16','11:25:00',1.21),('8998','2013-03-16','11:30:00',1.08),('8998','2013-03-16','11:35:00',1.07),('8998','2013-03-16','11:40:00',1.01),('8998','2013-03-16','12:15:00',1.25),('8998','2013-03-16','12:20:00',1.56),('8998','2013-03-16','12:25:00',2.29),('8998','2013-03-16','12:30:00',2.63),('8998','2013-03-16','12:35:00',1.83),('8998','2013-03-16','12:40:00',1.97),('8998','2013-03-16','12:45:00',1.74),('8998','2013-03-16','12:50:00',1.54),('8998','2013-03-16','12:55:00',1.2),('8998','2013-03-16','13:00:00',1.31),('8998','2013-03-16','13:05:00',1.47),('8998','2013-03-16','13:10:00',1.59),('8998','2013-03-16','13:15:00',1.57),('8998','2013-03-16','13:20:00',1.35),('8998','2013-03-16','13:25:00',1.21),('8998','2013-03-16','13:30:00',1.66),('8998','2013-03-16','13:35:00',1.94),('8998','2013-03-16','13:40:00',1.35),('8998','2013-03-16','13:45:00',1.3),('8998','2013-03-16','13:55:00',1.31),('8998','2013-03-16','14:00:00',1.42),('8998','2013-03-16','14:05:00',1.32),('8998','2013-03-16','14:10:00',1.52),('8998','2013-03-16','14:15:00',1.58),('8998','2013-03-16','14:20:00',1.42),('8998','2013-03-16','14:25:00',1.42),('8998','2013-03-16','14:30:00',1.39),('8998','2013-03-16','14:35:00',1.18),('8998','2013-03-16','15:10:00',1.12),('8998','2013-03-15','08:15:00',1.2),('8998','2013-03-15','08:20:00',1.67),('8998','2013-03-15','08:25:00',1.89),('8998','2013-03-15','08:30:00',2.04),('8998','2013-03-15','08:35:00',2.29),('8998','2013-03-15','08:40:00',2.36),('8998','2013-03-15','08:45:00',2.1),('8998','2013-03-15','08:50:00',2.47),('8998','2013-03-15','08:55:00',2.6),('8998','2013-03-15','09:00:00',2.47),('8998','2013-03-15','09:05:00',2.01),('8998','2013-03-15','09:10:00',1.98),('8998','2013-03-15','09:15:00',2.66),('8998','2013-03-15','09:20:00',2.73),('8998','2013-03-15','09:25:00',2.66),('8998','2013-03-15','09:30:00',2.75),('8998','2013-03-15','09:35:00',2.86),('8998','2013-03-15','09:40:00',2.89),('8998','2013-03-15','09:45:00',2.94),('8998','2013-03-15','09:50:00',2.92),('8998','2013-03-15','09:55:00',2.95),('8998','2013-03-15','10:00:00',2.29),('8998','2013-03-15','10:05:00',1.44),('8998','2013-03-15','10:10:00',2.22),('8998','2013-03-15','10:15:00',2.03),('8998','2013-03-15','10:20:00',1.4),('8998','2013-03-15','10:25:00',1.79),('8998','2013-03-15','10:30:00',1.5),('8998','2013-03-15','10:35:00',1.18),('8998','2013-03-15','10:40:00',2.13),('8998','2013-03-15','10:45:00',3.03),('8998','2013-03-15','10:50:00',2.99),('8998','2013-03-15','10:55:00',2.83),('8998','2013-03-15','11:00:00',2.97),('8998','2013-03-15','11:05:00',2.96),('8998','2013-03-15','11:10:00',2.95),('8998','2013-03-15','11:15:00',2.95),('8998','2013-03-15','11:20:00',2.92),('8998','2013-03-15','11:25:00',2.91),('8998','2013-03-15','11:30:00',2.89),('8998','2013-03-15','11:35:00',2.86),('8998','2013-03-15','11:40:00',2.87),('8998','2013-03-15','11:45:00',2.85),('8998','2013-03-15','11:50:00',2.84),('8998','2013-03-15','11:55:00',2.81),('8998','2013-03-15','12:00:00',2.8),('8998','2013-03-15','12:05:00',2.76),('8998','2013-03-15','12:10:00',2.73),('8998','2013-03-15','12:15:00',2.71),('8998','2013-03-15','12:20:00',2.69),('8998','2013-03-15','12:25:00',2.68),('8998','2013-03-15','12:30:00',2.65),('8998','2013-03-15','12:35:00',2.61),('8998','2013-03-15','12:40:00',2.57),('8998','2013-03-15','12:45:00',2.54),('8998','2013-03-15','12:50:00',2.49),('8998','2013-03-15','12:55:00',2.46),('8998','2013-03-15','13:00:00',2.42),('8998','2013-03-15','13:05:00',2.38),('8998','2013-03-15','13:10:00',2.35),('8998','2013-03-15','13:15:00',2.32),('8998','2013-03-15','13:20:00',1.01),('8998','2013-03-15','13:30:00',1.03),('8998','2013-03-15','13:35:00',2.25),('8998','2013-03-15','13:40:00',2.17),('8998','2013-03-15','13:45:00',2.1),('8998','2013-03-15','13:50:00',2.08),('8998','2013-03-15','13:55:00',1.71),('8998','2013-03-15','14:00:00',2.01),('8998','2013-03-15','14:05:00',1.94),('8998','2013-03-15','14:15:00',1.43),('8998','2013-03-15','14:20:00',1.17),('8998','2013-03-15','14:30:00',1.62),('8998','2013-03-15','14:35:00',1.49),('8998','2013-03-14','10:45:00',1.01),('8998','2013-03-14','10:55:00',1.06),('8998','2013-03-14','11:00:00',1.02),('8998','2013-03-14','11:25:00',1.02),('8998','2013-03-14','11:30:00',1.14),('8998','2013-03-14','11:35:00',1.34),('8998','2013-03-14','11:40:00',1.61),('8998','2013-03-14','11:45:00',1.5),('8998','2013-03-14','11:50:00',1.43),('8998','2013-03-14','11:55:00',1.46),('8998','2013-03-14','12:00:00',1.29),('8998','2013-03-14','12:05:00',1.33),('8998','2013-03-14','12:10:00',1.37),('8998','2013-03-14','12:15:00',1.21),('8998','2013-03-14','12:20:00',1.23),('8998','2013-03-14','12:25:00',1.21),('8998','2013-03-14','12:30:00',1.24),('8998','2013-03-14','12:35:00',1.38),('8998','2013-03-14','12:40:00',1.3),('8998','2013-03-14','12:45:00',1.16),('8998','2013-03-14','12:50:00',1.09),('8998','2013-03-14','12:55:00',1.02),('8998','2013-03-14','13:20:00',1.04),('8998','2013-03-14','13:25:00',1.14),('8998','2013-03-14','13:30:00',1.12),('8998','2013-03-14','13:35:00',1.04),('8998','2013-03-14','13:40:00',1.07),('8998','2013-03-14','13:45:00',1.12),('8998','2013-03-13','13:45:00',1.17),('8998','2013-03-13','13:50:00',1.36),('8998','2013-03-13','13:55:00',1.56),('8998','2013-03-13','14:00:00',1.34),('8998','2013-03-13','14:05:00',1.32),('8998','2013-03-13','14:10:00',1.05),('8998','2013-03-12','10:15:00',1.68),('8998','2013-03-12','10:20:00',1.29),('8998','2013-03-12','10:25:00',1.28),('8998','2013-03-12','10:30:00',2.75),('8998','2013-03-12','10:35:00',1.9),('8998','2013-03-12','10:40:00',2.06),('8998','2013-03-12','10:45:00',1.1),('8998','2014-03-24','07:20:00',1.03),('8998','2014-03-24','07:30:00',1.2),('8998','2014-03-24','07:35:00',1.02),('8998','2014-03-24','07:50:00',1.03),('8998','2014-03-24','07:55:00',1.06),('8998','2014-03-24','08:00:00',1.01),('8998','2014-03-24','08:05:00',1.04),('8998','2014-03-24','08:10:00',1.1),('8998','2014-03-24','08:15:00',1.17),('8998','2014-03-24','08:20:00',1.03),('8998','2014-03-24','08:45:00',1.51),('8998','2014-03-24','08:50:00',1.55),('8998','2014-03-24','08:55:00',1.63),('8998','2014-03-24','09:00:00',1.44),('8998','2014-03-24','09:05:00',1.39),('8998','2014-03-24','09:10:00',1.42),('8998','2014-03-24','09:15:00',1.91),('8998','2014-03-24','09:20:00',1.99),('8998','2014-03-24','09:25:00',1.72),('8998','2014-03-24','09:30:00',1.51),('8998','2014-03-24','09:35:00',1.38),('8998','2014-03-24','09:40:00',1.41),('8998','2014-03-24','09:45:00',1.32),('8998','2014-03-24','09:50:00',1.37),('8998','2014-03-24','09:55:00',1.54),('8998','2014-03-24','10:00:00',1.82),('8998','2014-03-24','10:05:00',1.92),('8998','2014-03-24','10:10:00',2.07),('8998','2014-03-24','10:15:00',2.17),('8998','2014-03-24','10:20:00',2.03),('8998','2014-03-24','10:25:00',2.09),('8998','2014-03-24','10:30:00',2.01),('8998','2014-03-24','10:35:00',1.8),('8998','2014-03-24','10:40:00',1.48),('8998','2014-03-24','10:45:00',1.36),('8998','2014-03-24','10:50:00',1.31),('8998','2014-03-24','10:55:00',1.31),('8998','2014-03-24','11:00:00',1.43),('8998','2014-03-24','11:05:00',1.64),('8998','2014-03-24','11:10:00',1.85),('8998','2014-03-24','11:15:00',2.09),('8998','2014-03-24','11:20:00',2.11),('8998','2014-03-24','11:25:00',2.1),('8998','2014-03-24','11:30:00',2.02),('8998','2014-03-24','11:35:00',2.01),('8998','2014-03-24','11:40:00',1.67),('8998','2014-03-24','11:45:00',1.42),('8998','2014-03-24','11:50:00',1.41),('8998','2014-03-24','11:55:00',1.46),('8998','2014-03-24','12:00:00',1.01),('8998','2013-03-11','08:20:00',1.03),('8998','2013-03-11','08:25:00',1.24),('8998','2013-03-11','08:30:00',1.5),('8998','2013-03-11','08:35:00',1.67),('8998','2013-03-11','08:40:00',1.95),('8998','2013-03-11','08:45:00',2.2),('8998','2013-03-11','08:50:00',1.5),('8998','2013-03-11','09:00:00',1.31),('8998','2013-03-11','09:05:00',2.41),('8998','2013-03-11','09:10:00',2.43),('8998','2013-03-11','09:15:00',2.43),('8998','2013-03-11','09:20:00',2.44),('8998','2013-03-11','09:25:00',2.47),('8998','2013-03-11','09:30:00',2.51),('8998','2013-03-11','09:35:00',2.54),('8998','2013-03-11','09:40:00',2.58),('8998','2013-03-11','09:45:00',2.61),('8998','2013-03-11','09:50:00',1.69),('8998','2013-03-11','09:55:00',2.82),('8998','2013-03-11','10:00:00',2.58),('8998','2013-03-11','10:05:00',2.67),('8998','2013-03-11','10:10:00',2.12),('8998','2013-03-11','10:15:00',2.04),('8998','2013-03-11','10:20:00',2.52),('8998','2013-03-11','10:25:00',2.61),('8998','2013-03-11','10:30:00',2.93),('8998','2013-03-11','10:35:00',1.79),('8998','2013-03-11','10:40:00',2.17),('8998','2013-03-11','10:45:00',1.48),('8998','2013-03-11','10:50:00',2.55),('8998','2013-03-11','10:55:00',2.64),('8998','2013-03-11','11:00:00',2.52),('8998','2013-03-11','11:05:00',3.13),('8998','2013-03-11','11:10:00',2.22),('8998','2013-03-11','11:15:00',2.4),('8998','2013-03-11','11:20:00',2.99),('8998','2013-03-11','11:25:00',1.39),('8998','2013-03-11','11:30:00',1.1),('8998','2013-03-11','11:35:00',1.22),('8998','2013-03-11','11:40:00',1.48),('8998','2013-03-11','11:45:00',1.59),('8998','2013-03-11','11:50:00',1.87),('8998','2013-03-11','11:55:00',2.94),('8998','2013-03-11','12:10:00',2.39),('8998','2013-03-11','12:15:00',2.63),('8998','2013-03-11','12:20:00',1.18),('8998','2013-03-11','12:25:00',2.34),('8998','2013-03-11','12:30:00',3.2),('8998','2013-03-11','12:35:00',2.09),('8998','2013-03-11','12:40:00',2.45),('8998','2013-03-11','12:50:00',1.08),('8998','2013-03-11','12:55:00',1.31),('8998','2013-03-11','13:00:00',2.16),('8998','2013-03-11','13:05:00',1.41),('8998','2013-03-11','13:10:00',1.53),('8998','2013-03-11','13:15:00',1.33),('8998','2013-03-11','13:20:00',1.85),('8998','2013-03-11','13:25:00',1.29),('8998','2013-03-11','13:35:00',1.07),('8998','2013-03-11','13:55:00',1.01),('8998','2013-03-11','14:00:00',1.2),('8998','2013-03-11','14:05:00',1.36),('8998','2013-03-11','14:10:00',1.39),('8998','2013-03-10','08:10:00',1.08),('8998','2013-03-10','08:15:00',1.8),('8998','2013-03-10','08:20:00',1.86),('8998','2013-03-10','08:25:00',1.91),('8998','2013-03-10','08:30:00',1.96),('8998','2013-03-10','08:35:00',2.02),('8998','2013-03-10','08:40:00',2.06),('8998','2013-03-10','08:45:00',2.13),('8998','2013-03-10','08:50:00',2.19),('8998','2013-03-10','08:55:00',2.22),('8998','2013-03-10','09:00:00',2.24),('8998','2013-03-10','09:05:00',2.3),('8998','2013-03-10','09:10:00',2.3),('8998','2013-03-10','09:15:00',2.37),('8998','2013-03-10','09:20:00',1.97),('8998','2013-03-10','09:25:00',1.72),('8998','2013-03-10','09:35:00',2.05),('8998','2013-03-10','09:40:00',2.74),('8998','2013-03-10','09:45:00',2.43),('8998','2013-03-10','09:50:00',1.01),('8998','2013-03-10','10:25:00',1.02),('8998','2013-03-10','10:35:00',1.03),('8998','2013-03-10','10:40:00',1.46),('8998','2013-03-10','10:45:00',1.8),('8998','2013-03-10','10:50:00',2.15),('8998','2013-03-10','10:55:00',1.24),('8998','2013-03-10','11:00:00',1.06),('8998','2013-03-10','11:10:00',1.12),('8998','2013-03-10','11:15:00',1.21),('8998','2013-03-10','11:20:00',1.04),('8998','2013-03-10','11:30:00',1.69),('8998','2013-03-10','11:35:00',1.93),('8998','2013-03-10','11:40:00',1.49),('8998','2013-03-10','11:45:00',1.73),('8998','2013-03-10','11:50:00',1.79),('8998','2013-03-10','11:55:00',1.29),('8998','2013-03-10','12:00:00',1.16),('8998','2013-03-10','12:05:00',1.15),('8998','2013-03-10','12:10:00',1.19),('8998','2013-03-10','12:50:00',1.36),('8998','2013-03-10','12:55:00',2.61),('8998','2013-03-10','13:00:00',1.67),('8998','2013-03-10','13:05:00',1.33),('8998','2013-03-10','13:10:00',1.77),('8998','2013-03-10','13:15:00',2.26),('8998','2013-03-10','13:20:00',2.15),('8998','2013-03-10','13:25:00',2.25),('8998','2013-03-10','13:30:00',2.19),('8998','2013-03-10','13:35:00',2.06),('8998','2013-03-10','13:40:00',1.98),('8998','2013-03-10','13:45:00',1.64),('8998','2013-03-10','13:50:00',1.2),('8998','2013-03-10','13:55:00',1.29),('8998','2013-03-10','14:25:00',1.03),('8998','2013-03-09','08:00:00',1.51),('8998','2013-03-09','08:05:00',1.63),('8998','2013-03-09','08:10:00',1.72),('8998','2013-03-09','08:15:00',1.64),('8998','2013-03-09','08:20:00',1.85),('8998','2013-03-09','08:25:00',1.9),('8998','2013-03-09','08:30:00',1.94),('8998','2013-03-09','08:35:00',2),('8998','2013-03-09','08:40:00',2.03),('8998','2013-03-09','08:45:00',2.13),('8998','2013-03-09','08:50:00',2.17),('8998','2013-03-09','08:55:00',2.23),('8998','2013-03-09','09:00:00',2.26),('8998','2013-03-09','09:05:00',2.3),('8998','2013-03-09','09:10:00',2.33),('8998','2013-03-09','09:15:00',2.35),('8998','2013-03-09','09:20:00',2.38),('8998','2013-03-09','09:25:00',2.4),('8998','2013-03-09','09:30:00',2.44),('8998','2013-03-09','09:35:00',2.47),('8998','2013-03-09','09:40:00',2.53),('8998','2013-03-09','09:45:00',2.5),('8998','2013-03-09','09:50:00',1.52),('8998','2013-03-09','09:55:00',2.84),('8998','2013-03-09','10:00:00',1.41),('8998','2013-03-09','10:05:00',2.06),('8998','2013-03-09','10:10:00',1.74),('8998','2013-03-09','10:15:00',1.71),('8998','2013-03-09','10:20:00',2.43),('8998','2013-03-09','10:25:00',2.42),('8998','2013-03-09','10:30:00',2.61),('8998','2013-03-09','10:35:00',2.42),('8998','2013-03-09','10:40:00',2.28),('8998','2013-03-09','10:45:00',2.79),('8998','2013-03-09','10:50:00',2.6),('8998','2013-03-09','10:55:00',1.79),('8998','2013-03-09','11:00:00',2.45),('8998','2013-03-09','11:05:00',2.21),('8998','2013-03-09','11:10:00',2.36),('8998','2013-03-09','11:15:00',1.86),('8998','2013-03-09','11:20:00',1.39),('8998','2013-03-09','11:25:00',2.05),('8998','2013-03-09','11:30:00',1.73),('8998','2013-03-09','11:35:00',1.18),('8998','2013-03-09','11:40:00',1.09),('8998','2013-03-09','11:45:00',1.1),('8998','2013-03-09','11:50:00',1.89),('8998','2013-03-09','11:55:00',2.53),('8998','2013-03-09','12:00:00',2.53),('8998','2013-03-09','12:05:00',2.61),('8998','2013-03-09','12:10:00',2.15),('8998','2013-03-09','12:15:00',2.41),('8998','2013-03-09','12:20:00',1.24),('8998','2013-03-09','12:25:00',2.32),('8998','2013-03-09','12:35:00',1.19),('8998','2013-03-09','12:40:00',1.05),('8998','2013-03-09','12:45:00',2.76),('8998','2013-03-09','12:50:00',2.52),('8998','2013-03-09','12:55:00',2.53),('8998','2013-03-09','13:00:00',2.34),('8998','2013-03-09','13:05:00',2.23),('8998','2013-03-09','13:10:00',2.1),('8998','2013-03-09','13:15:00',2.25),('8998','2013-03-09','13:20:00',2.19),('8998','2013-03-09','13:25:00',1.94),('8998','2013-03-09','13:30:00',1.91),('8998','2013-03-09','13:35:00',1.67),('8998','2013-03-09','13:40:00',1.04),('8998','2013-03-09','13:45:00',1.22),('8998','2013-03-09','13:50:00',1.11),('8998','2013-03-09','13:55:00',1.11),('8998','2013-03-09','14:00:00',1.03),('8998','2013-03-09','14:05:00',1.12),('8998','2013-03-09','14:10:00',1.27),('8998','2013-03-09','14:15:00',1.52),('8998','2013-03-09','14:20:00',1.38),('8998','2013-03-09','14:25:00',1.04),('8998','2013-03-09','14:35:00',1.57),('8998','2013-03-09','14:40:00',1.45),('8998','2013-03-09','14:45:00',1.02),('8998','2013-03-08','08:05:00',1.74),('8998','2013-03-08','08:10:00',1.32),('8998','2013-03-08','08:15:00',1.77),('8998','2013-03-08','08:20:00',1.77),('8998','2013-03-08','08:25:00',1.86),('8998','2013-03-08','08:30:00',1.93),('8998','2013-03-08','08:35:00',1.99),('8998','2013-03-08','08:40:00',1.84),('8998','2013-03-08','08:45:00',1.04),('8998','2013-03-08','08:55:00',1.78),('8998','2013-03-08','09:30:00',1.63),('8998','2013-03-08','09:35:00',2.06),('8998','2013-03-08','09:40:00',2.78),('8998','2013-03-08','09:45:00',2.94),('8998','2013-03-08','09:50:00',2.11),('8998','2013-03-08','09:55:00',1.86),('8998','2013-03-08','10:00:00',1.31),('8998','2013-03-08','10:20:00',1.55),('8998','2013-03-08','10:40:00',1.21),('8998','2013-03-08','10:45:00',1.44),('8998','2013-03-08','10:50:00',2.43),('8998','2013-03-08','10:55:00',3),('8998','2013-03-08','11:00:00',1.94),('8998','2013-03-08','11:05:00',2.81),('8998','2013-03-08','11:10:00',2.95),('8998','2013-03-08','11:15:00',2.91),('8998','2013-03-08','11:20:00',2.87),('8998','2013-03-08','11:25:00',2.24),('8998','2013-03-08','11:30:00',2.82),('8998','2013-03-08','11:35:00',2.76),('8998','2013-03-08','11:40:00',2.73),('8998','2013-03-08','11:45:00',2.76),('8998','2013-03-08','11:50:00',2.64),('8998','2013-03-08','11:55:00',2.63),('8998','2013-03-08','12:00:00',2.51),('8998','2013-03-08','12:05:00',1.31),('8998','2013-03-08','12:25:00',1.12),('8998','2013-03-08','12:30:00',1.01),('8998','2013-03-08','12:35:00',1.01),('8998','2013-03-08','12:45:00',1.24),('8998','2013-03-08','12:50:00',1.52),('8998','2013-03-08','12:55:00',1.76),('8998','2013-03-08','13:00:00',2.42),('8998','2013-03-08','13:05:00',2.29),('8998','2013-03-08','13:10:00',2.24),('8998','2013-03-08','13:15:00',2.23),('8998','2013-03-08','13:20:00',2.27),('8998','2013-03-08','13:25:00',1.51),('8998','2013-03-08','13:30:00',2.01),('8998','2013-03-08','13:35:00',1.51),('8998','2013-03-08','13:40:00',1.83),('8998','2013-03-08','13:45:00',2.03),('8998','2013-03-08','13:50:00',1.95),('8998','2013-03-08','14:10:00',1.85),('8998','2013-03-08','14:15:00',1.53),('8998','2013-03-08','14:20:00',1.49),('8998','2013-03-08','14:25:00',1.38),('8998','2013-03-08','14:30:00',1.29),('8998','2013-03-08','14:35:00',1.24),('8998','2013-03-08','14:40:00',1.18),('8998','2013-03-08','14:45:00',1.07),('8998','2013-03-07','08:15:00',1.01),('8998','2013-03-07','08:35:00',1.26),('8998','2013-03-07','09:30:00',1.07),('8998','2013-03-07','09:35:00',1.62),('8998','2013-03-07','09:40:00',1.16),('8998','2013-03-07','09:45:00',1.87),('8998','2013-03-07','09:50:00',2.12),('8998','2013-03-07','09:55:00',1.64),('8998','2013-03-07','10:10:00',1.6),('8998','2013-03-07','10:15:00',1.51),('8998','2013-03-07','10:20:00',1.69),('8998','2013-03-07','10:25:00',1.28),('8998','2013-03-07','10:30:00',1.06),('8998','2013-03-07','10:35:00',1.53),('8998','2013-03-07','10:40:00',1.4),('8998','2013-03-07','11:40:00',1.41),('8998','2013-03-07','11:45:00',1.13),('8998','2013-03-07','12:00:00',1.51),('8998','2013-03-07','12:35:00',1.06),('8998','2013-03-07','12:40:00',1.39),('8998','2013-03-07','12:45:00',1.58),('8998','2013-03-07','12:50:00',1.55),('8998','2013-03-07','12:55:00',1.3),('8998','2013-03-07','13:00:00',1.4),('8998','2013-03-07','13:05:00',1.38),('8998','2013-03-07','13:10:00',1.03),('8998','2013-03-07','13:30:00',1.11),('8998','2013-03-06','11:05:00',1.11),('8998','2013-03-06','11:35:00',1.19),('8998','2013-03-06','11:40:00',1.32),('8998','2013-03-06','11:45:00',1.71),('8998','2013-03-06','11:50:00',1.44),('8998','2013-03-06','11:55:00',1.17),('8998','2013-03-06','12:45:00',1.38),('8998','2013-03-06','12:50:00',1.27),('8998','2013-03-06','12:55:00',1.15),('8998','2013-03-06','13:00:00',1.13),('8998','2013-03-06','13:05:00',1.18),('8998','2013-03-06','13:15:00',1.14),('8998','2013-03-06','13:20:00',1.31),('8998','2013-03-06','13:25:00',1.24),('8998','2013-03-06','13:30:00',1.05),('8998','2013-03-04','08:15:00',1.35),('8998','2013-03-04','08:20:00',1.3),('8998','2013-03-04','08:25:00',1.37),('8998','2013-03-04','08:30:00',2.01),('8998','2013-03-04','08:35:00',1.74),('8998','2013-03-04','08:40:00',1.73),('8998','2013-03-04','08:45:00',1.34),('8998','2013-03-04','08:50:00',1.32),('8998','2013-03-04','08:55:00',1.21),('8998','2013-03-04','09:00:00',1.31),('8998','2013-03-04','09:05:00',1.3),('8998','2013-03-04','09:10:00',1.25),('8998','2013-03-04','09:15:00',1.16),('8998','2013-03-04','09:20:00',1.14),('8998','2013-03-04','09:25:00',1.09),('8998','2013-03-04','09:30:00',1.14),('8998','2013-03-04','09:35:00',1.26),('8998','2013-03-04','09:40:00',1.31),('8998','2013-03-04','09:45:00',1.32),('8998','2013-03-04','09:50:00',1.37),('8998','2013-03-04','09:55:00',1.28),('8998','2013-03-04','10:00:00',1.23),('8998','2013-03-04','10:05:00',1.34),('8998','2013-03-04','10:10:00',1.41),('8998','2013-03-04','10:15:00',1.36),('8998','2013-03-04','10:20:00',1.53),('8998','2013-03-04','10:25:00',1.47),('8998','2013-03-04','10:30:00',1.37),('8998','2013-03-04','10:35:00',1.61),('8998','2013-03-04','10:40:00',1.65),('8998','2013-03-04','10:45:00',1.74),('8998','2013-03-04','10:50:00',1.88),('8998','2013-03-04','10:55:00',1.93),('8998','2013-03-04','11:00:00',1.83),('8998','2013-03-04','11:05:00',1.88),('8998','2013-03-04','11:10:00',1.93),('8998','2013-03-04','11:15:00',1.88),('8998','2013-03-04','11:20:00',1.8),('8998','2013-03-04','11:25:00',1.75),('8998','2013-03-04','11:30:00',1.77),('8998','2013-03-04','11:35:00',1.94),('8998','2013-03-04','11:40:00',2.15),('8998','2013-03-04','11:45:00',2.06),('8998','2013-03-04','11:50:00',2.09),('8998','2013-03-04','11:55:00',2.09),('8998','2013-03-04','12:00:00',2.11),('8998','2013-03-04','12:05:00',2.17),('8998','2013-03-04','12:10:00',2.19),('8998','2013-03-04','12:15:00',1.78),('8998','2013-03-04','12:20:00',1.98),('8998','2013-03-04','12:25:00',2),('8998','2013-03-04','12:30:00',1.67),('8998','2013-03-04','12:35:00',1.78),('8998','2013-03-04','12:40:00',1.65),('8998','2013-03-04','12:45:00',1.66),('8998','2013-03-04','12:50:00',1.47),('8998','2013-03-04','12:55:00',1.38),('8998','2013-03-04','13:00:00',1.17),('8998','2013-03-04','13:05:00',1.11),('8998','2013-03-04','13:10:00',1.17),('8998','2013-03-04','13:15:00',1.25),('8998','2013-03-04','13:20:00',1.23),('8998','2013-03-04','13:25:00',1.12),('8998','2013-03-04','13:30:00',1.03),('8998','2013-03-03','08:05:00',1.05),('8998','2013-03-03','08:10:00',1.45),('8998','2013-03-03','08:15:00',1.57),('8998','2013-03-03','08:20:00',1.63),('8998','2013-03-03','08:25:00',1.69),('8998','2013-03-03','08:30:00',1.74),('8998','2013-03-03','08:35:00',1.79),('8998','2013-03-03','08:40:00',1.84),('8998','2013-03-03','08:45:00',1.9),('8998','2013-03-03','08:50:00',1.97),('8998','2013-03-03','08:55:00',2.02),('8998','2013-03-03','09:00:00',2.05),('8998','2013-03-03','09:05:00',2.09),('8998','2013-03-03','09:10:00',2.13),('8998','2013-03-03','09:15:00',2.16),('8998','2013-03-03','09:20:00',2.2),('8998','2013-03-03','09:25:00',2.24),('8998','2013-03-03','09:30:00',2.28),('8998','2013-03-03','09:35:00',2.32),('8998','2013-03-03','09:40:00',2.34),('8998','2013-03-03','09:45:00',2.38),('8998','2013-03-03','09:50:00',2.41),('8998','2013-03-03','09:55:00',2.42),('8998','2013-03-03','10:00:00',2.45),('8998','2013-03-03','10:05:00',2.47),('8998','2013-03-03','10:10:00',2.48),('8998','2013-03-03','10:15:00',2.48),('8998','2013-03-03','10:20:00',2.51),('8998','2013-03-03','10:25:00',2.51),('8998','2013-03-03','10:30:00',2.53),('8998','2013-03-03','10:35:00',2.52),('8998','2013-03-03','10:40:00',2.51),('8998','2013-03-03','10:45:00',2.52),('8998','2013-03-03','10:50:00',2.52),('8998','2013-03-03','10:55:00',2.53),('8998','2013-03-03','11:00:00',2.49),('8998','2013-03-03','11:05:00',2.46),('8998','2013-03-03','11:10:00',2.51),('8998','2013-03-03','11:15:00',2.54),('8998','2013-03-03','11:20:00',2.53),('8998','2013-03-03','11:25:00',2.5),('8998','2013-03-03','11:30:00',2.47),('8998','2013-03-03','11:35:00',2.47),('8998','2013-03-03','11:40:00',2.49),('8998','2013-03-03','11:45:00',2.48),('8998','2013-03-03','11:50:00',2.4),('8998','2013-03-03','11:55:00',2.37),('8998','2013-03-03','12:00:00',2.39),('8998','2013-03-03','12:05:00',2.3),('8998','2013-03-03','12:10:00',2.29),('8998','2013-03-03','12:15:00',2.33),('8998','2013-03-03','12:20:00',2.34),('8998','2013-03-03','12:25:00',2.33),('8998','2013-03-03','12:30:00',2.3),('8998','2013-03-03','12:35:00',2.25),('8998','2013-03-03','12:40:00',2.19),('8998','2013-03-03','12:45:00',2.18),('8998','2013-03-03','12:50:00',2.16),('8998','2013-03-03','12:55:00',2.11),('8998','2013-03-03','13:00:00',2.07),('8998','2013-03-03','13:05:00',2.02),('8998','2013-03-03','13:10:00',2.01),('8998','2013-03-03','13:15:00',1.97),('8998','2013-03-03','13:20:00',1.94),('8998','2013-03-03','13:25:00',1.93),('8998','2013-03-03','13:30:00',1.52),('8998','2013-03-03','13:35:00',1.27),('8998','2013-03-03','13:40:00',1.56),('8998','2013-03-03','13:45:00',1.56),('8998','2013-03-03','13:50:00',1.65),('8998','2013-03-03','13:55:00',1.65),('8998','2013-03-03','14:00:00',1.58),('8998','2013-03-03','14:05:00',1.52),('8998','2013-03-03','14:10:00',1.45),('8998','2013-03-03','14:15:00',1.24),('8998','2013-03-03','14:20:00',1.17),('8998','2013-03-03','14:25:00',1.13),('8998','2013-03-03','14:30:00',1.08),('8998','2013-03-03','14:35:00',1.02),('8998','2013-03-02','08:10:00',1.52),('8998','2013-03-02','08:15:00',1.67),('8998','2013-03-02','08:20:00',1.75),('8998','2013-03-02','08:25:00',1.81),('8998','2013-03-02','08:30:00',1.87),('8998','2013-03-02','08:35:00',1.93),('8998','2013-03-02','08:40:00',1.98),('8998','2013-03-02','08:45:00',2.05),('8998','2013-03-02','08:50:00',2.11),('8998','2013-03-02','08:55:00',2.15),('8998','2013-03-02','09:00:00',2.19),('8998','2013-03-02','09:05:00',2.23),('8998','2013-03-02','09:10:00',2.26),('8998','2013-03-02','09:15:00',2.28),('8998','2013-03-02','09:20:00',2.32),('8998','2013-03-02','09:25:00',2.35),('8998','2013-03-02','09:30:00',2.38),('8998','2013-03-02','09:35:00',2.41),('8998','2013-03-02','09:40:00',2.42),('8998','2013-03-02','09:45:00',2.46),('8998','2013-03-02','09:50:00',2.51),('8998','2013-03-02','09:55:00',2.57),('8998','2013-03-02','10:00:00',2.6),('8998','2013-03-02','10:05:00',2.6),('8998','2013-03-02','10:10:00',2.62),('8998','2013-03-02','10:15:00',2.63),('8998','2013-03-02','10:20:00',2.65),('8998','2013-03-02','10:25:00',2.67),('8998','2013-03-02','10:30:00',2.67),('8998','2013-03-02','10:35:00',2.68),('8998','2013-03-02','10:40:00',2.68),('8998','2013-03-02','10:45:00',2.67),('8998','2013-03-02','10:50:00',2.66),('8998','2013-03-02','10:55:00',2.65),('8998','2013-03-02','11:00:00',2.65),('8998','2013-03-02','11:05:00',2.64),('8998','2013-03-02','11:10:00',2.63),('8998','2013-03-02','11:15:00',2.61),('8998','2013-03-02','11:20:00',2.61),('8998','2013-03-02','11:25:00',2.61),('8998','2013-03-02','11:30:00',2.59),('8998','2013-03-02','11:35:00',2.58),('8998','2013-03-02','11:40:00',2.58),('8998','2013-03-02','11:45:00',2.56),('8998','2013-03-02','11:50:00',2.54),('8998','2013-03-02','11:55:00',2.51),('8998','2013-03-02','12:00:00',2.5),('8998','2013-03-02','12:05:00',2.47),('8998','2013-03-02','12:10:00',2.44),('8998','2013-03-02','12:15:00',2.43),('8998','2013-03-02','12:20:00',2.41),('8998','2013-03-02','12:25:00',2.39),('8998','2013-03-02','12:30:00',2.36),('8998','2013-03-02','12:35:00',2.32),('8998','2013-03-02','12:40:00',2.3),('8998','2013-03-02','12:45:00',2.26),('8998','2013-03-02','12:50:00',2.24),('8998','2013-03-02','12:55:00',2.19),('8998','2013-03-02','13:00:00',2.16),('8998','2013-03-02','13:05:00',2.14),('8998','2013-03-02','13:10:00',2.1),('8998','2013-03-02','13:15:00',2.06),('8998','2013-03-02','13:20:00',2.01),('8998','2013-03-02','13:25:00',1.97),('8998','2013-03-02','13:30:00',1.92),('8998','2013-03-02','13:35:00',1.88),('8998','2013-03-02','13:40:00',1.82),('8998','2013-03-02','13:45:00',1.77),('8998','2013-03-02','13:50:00',1.73),('8998','2013-03-02','13:55:00',1.68),('8998','2013-03-02','14:00:00',1.62),('8998','2013-03-02','14:05:00',1.55),('8998','2013-03-02','14:10:00',1.46),('8998','2013-03-02','14:15:00',1.33),('8998','2013-03-02','14:20:00',1.27),('8998','2013-03-02','14:25:00',1.27),('8998','2013-03-02','14:30:00',1.21),('8998','2013-03-02','14:35:00',1.13),('8998','2014-03-23','08:55:00',1.21),('8998','2014-03-23','09:00:00',1.57),('8998','2014-03-23','09:05:00',1),('8998','2014-03-23','09:20:00',1.42),('8998','2014-03-23','09:30:00',1.13),('8998','2014-03-23','09:40:00',1.01),('8998','2014-03-23','10:00:00',1.64),('8998','2014-03-23','10:05:00',2.06),('8998','2014-03-23','10:10:00',2.43),('8998','2014-03-23','10:15:00',2.52),('8998','2014-03-23','10:50:00',3.45),('8998','2014-03-23','10:55:00',3.19),('8998','2014-03-23','11:00:00',1.28),('8998','2014-03-23','11:05:00',1.84),('8998','2014-03-23','11:10:00',1.57),('8998','2014-03-23','11:15:00',2.25),('8998','2014-03-23','11:20:00',1.76),('8998','2014-03-23','11:25:00',1.78),('8998','2014-03-23','11:30:00',2.52),('8998','2014-03-23','11:35:00',1.44),('8998','2014-03-23','12:35:00',1.27),('8998','2014-03-23','12:40:00',1.43),('8998','2014-03-23','12:45:00',1.27),('8998','2014-03-23','12:50:00',1.08),('8998','2014-03-23','12:55:00',1.02),('8998','2014-03-23','13:00:00',1.03),('8998','2014-03-23','13:05:00',1.02),('8998','2014-03-23','14:15:00',1.01),('8998','2014-03-23','14:20:00',1.32),('8998','2014-03-23','14:25:00',1.33),('8998','2014-03-23','14:30:00',1.16),('8998','2014-03-23','14:35:00',1.25),('8998','2014-03-23','14:40:00',1.62),('8998','2014-03-23','14:45:00',1.71),('8998','2014-03-23','14:50:00',1.82),('8998','2014-03-23','14:55:00',1.53),('8998','2014-03-23','15:00:00',1.32),('8998','2014-03-23','15:05:00',1.11),('8998','2014-03-23','15:10:00',1.11),('8998','2013-02-28','08:20:00',1.08),('8998','2013-02-28','08:25:00',1.08),('8998','2013-02-28','08:30:00',1.14),('8998','2013-02-28','08:35:00',1.21),('8998','2013-02-28','08:40:00',1.29),('8998','2013-02-28','08:45:00',1.4),('8998','2013-02-28','08:50:00',1.47),('8998','2013-02-28','08:55:00',1.55),('8998','2013-02-28','09:00:00',1.64),('8998','2013-02-28','09:05:00',1.84),('8998','2013-02-28','09:10:00',1.82),('8998','2013-02-28','09:15:00',1.8),('8998','2013-02-28','09:20:00',1.82),('8998','2013-02-28','09:25:00',1.83),('8998','2013-02-28','09:30:00',2.05),('8998','2013-02-28','09:35:00',1.92),('8998','2013-02-28','09:40:00',1.97),('8998','2013-02-28','09:45:00',2.09),('8998','2013-02-28','09:50:00',2.09),('8998','2013-02-28','09:55:00',2),('8998','2013-02-28','10:00:00',2.03),('8998','2013-02-28','10:05:00',2),('8998','2013-02-28','10:10:00',1.95),('8998','2013-02-28','10:15:00',1.73),('8998','2013-02-28','10:20:00',1.56),('8998','2013-02-28','10:25:00',1.64),('8998','2013-02-28','10:30:00',1.79),('8998','2013-02-28','10:35:00',2.04),('8998','2013-02-28','10:40:00',1.8),('8998','2013-02-28','10:45:00',1.69),('8998','2013-02-28','10:50:00',1.58),('8998','2013-02-28','10:55:00',1.49),('8998','2013-02-28','11:00:00',1.31),('8998','2013-02-28','11:05:00',1.13),('8998','2013-02-28','11:10:00',1.05),('8998','2013-02-28','11:15:00',1.14),('8998','2013-02-28','11:20:00',1.22),('8998','2013-02-28','11:25:00',1.23),('8998','2013-02-28','11:30:00',1.23),('8998','2013-02-28','11:35:00',1.26),('8998','2013-02-28','11:40:00',1.21),('8998','2013-02-28','11:45:00',1.16),('8998','2013-02-28','11:50:00',1.14),('8998','2013-02-28','11:55:00',1.1),('8998','2013-02-28','12:00:00',1.06),('8998','2013-02-28','12:05:00',1.01),('8998','2013-02-28','13:20:00',1.01),('8998','2013-02-28','13:25:00',1.1),('8998','2013-02-28','13:30:00',1.11),('8998','2013-02-28','13:35:00',1.05),('8998','2013-02-27','08:30:00',1.13),('8998','2013-02-27','08:35:00',1.36),('8998','2013-02-27','08:40:00',1.59),('8998','2013-02-27','08:45:00',1.74),('8998','2013-02-27','08:50:00',1.81),('8998','2013-02-27','08:55:00',1.87),('8998','2013-02-27','09:00:00',1.91),('8998','2013-02-27','09:05:00',1.94),('8998','2013-02-27','09:10:00',1.97),('8998','2013-02-27','09:15:00',1.99),('8998','2013-02-27','09:20:00',2.05),('8998','2013-02-27','09:25:00',2.07),('8998','2013-02-27','09:30:00',2.11),('8998','2013-02-27','09:35:00',2.15),('8998','2013-02-27','09:40:00',2.17),('8998','2013-02-27','09:45:00',2.21),('8998','2013-02-27','09:50:00',2.07),('8998','2013-02-27','09:55:00',2.25),('8998','2013-02-27','10:00:00',2.29),('8998','2013-02-27','10:05:00',2.31),('8998','2013-02-27','10:10:00',2.29),('8998','2013-02-27','10:15:00',2.31),('8998','2013-02-27','10:20:00',2.33),('8998','2013-02-27','10:25:00',2.33),('8998','2013-02-27','10:30:00',2.29),('8998','2013-02-27','10:35:00',2.37),('8998','2013-02-27','10:40:00',2.37),('8998','2013-02-27','10:45:00',2.37),('8998','2013-02-27','10:50:00',2.37),('8998','2013-02-27','10:55:00',2.38),('8998','2013-02-27','11:00:00',2.42),('8998','2013-02-27','11:05:00',2.43),('8998','2013-02-27','11:10:00',2.41),('8998','2013-02-27','11:15:00',2.4),('8998','2013-02-27','11:20:00',2.41),('8998','2013-02-27','11:25:00',2.45),('8998','2013-02-27','11:30:00',2.43),('8998','2013-02-27','11:35:00',2.41),('8998','2013-02-27','11:40:00',2.4),('8998','2013-02-27','11:45:00',2.38),('8998','2013-02-27','11:50:00',2.38),('8998','2013-02-27','11:55:00',2.36),('8998','2013-02-27','12:00:00',2.28),('8998','2013-02-27','12:05:00',2.24),('8998','2013-02-27','12:10:00',2.28),('8998','2013-02-27','12:15:00',2.27),('8998','2013-02-27','12:20:00',2.24),('8998','2013-02-27','12:25:00',2.19),('8998','2013-02-27','12:30:00',2.19),('8998','2013-02-27','12:35:00',2.18),('8998','2013-02-27','12:40:00',2.16),('8998','2013-02-27','12:45:00',2.07),('8998','2013-02-27','12:50:00',2.04),('8998','2013-02-27','12:55:00',2.06),('8998','2013-02-27','13:00:00',1.95),('8998','2013-02-27','13:05:00',2.02),('8998','2013-02-27','13:10:00',1.97),('8998','2013-02-27','13:15:00',1.97),('8998','2013-02-27','13:20:00',1.98),('8998','2013-02-27','13:25:00',1.95),('8998','2013-02-27','13:30:00',1.83),('8998','2013-02-27','13:35:00',1.77),('8998','2013-02-27','13:40:00',1.53),('8998','2013-02-27','13:45:00',1.64),('8998','2013-02-27','13:50:00',1.76),('8998','2013-02-27','13:55:00',1.68),('8998','2013-02-27','14:00:00',1.63),('8998','2013-02-27','14:05:00',1.54),('8998','2013-02-27','14:10:00',1.37),('8998','2013-02-27','14:15:00',1.28),('8998','2013-02-27','14:30:00',1),('8998','2013-02-26','08:20:00',1.35),('8998','2013-02-26','08:25:00',1.44),('8998','2013-02-26','08:30:00',1.5),('8998','2013-02-26','08:35:00',1.55),('8998','2013-02-26','08:40:00',1.59),('8998','2013-02-26','08:45:00',1.67),('8998','2013-02-26','08:50:00',1.75),('8998','2013-02-26','08:55:00',1.8),('8998','2013-02-26','09:00:00',1.84),('8998','2013-02-26','09:05:00',1.9),('8998','2013-02-26','09:10:00',1.94),('8998','2013-02-26','09:15:00',1.99),('8998','2013-02-26','09:20:00',2.03),('8998','2013-02-26','09:25:00',2.06),('8998','2013-02-26','09:30:00',2.1),('8998','2013-02-26','09:35:00',2.12),('8998','2013-02-26','09:40:00',2.15),('8998','2013-02-26','09:45:00',2.19),('8998','2013-02-26','09:50:00',2.2),('8998','2013-02-26','09:55:00',2.24),('8998','2013-02-26','10:00:00',2.26),('8998','2013-02-26','10:05:00',2.28),('8998','2013-02-26','10:10:00',2.3),('8998','2013-02-26','10:15:00',2.34),('8998','2013-02-26','10:20:00',2.35),('8998','2013-02-26','10:25:00',2.34),('8998','2013-02-26','10:30:00',2.34),('8998','2013-02-26','10:35:00',2.39),('8998','2013-02-26','10:40:00',2.38),('8998','2013-02-26','10:45:00',2.38),('8998','2013-02-26','10:50:00',2.43),('8998','2013-02-26','10:55:00',2.42),('8998','2013-02-26','11:00:00',2.44),('8998','2013-02-26','11:05:00',2.46),('8998','2013-02-26','11:10:00',2.44),('8998','2013-02-26','11:15:00',2.41),('8998','2013-02-26','11:20:00',2.36),('8998','2013-02-26','11:25:00',2.43),('8998','2013-02-26','11:30:00',2.1),('8998','2013-02-26','11:35:00',1.93),('8998','2013-02-26','11:40:00',1.96),('8998','2013-02-26','11:45:00',2.37),('8998','2013-02-26','11:50:00',2.45),('8998','2013-02-26','11:55:00',2.42),('8998','2013-02-26','12:00:00',2.4),('8998','2013-02-26','12:05:00',2.37),('8998','2013-02-26','12:10:00',2.38),('8998','2013-02-26','12:15:00',2.45),('8998','2013-02-26','12:20:00',2.41),('8998','2013-02-26','12:25:00',2.3),('8998','2013-02-26','12:30:00',2.21),('8998','2013-02-26','12:35:00',2.21),('8998','2013-02-26','12:40:00',2.21),('8998','2013-02-26','12:45:00',2.19),('8998','2013-02-26','12:50:00',2.13),('8998','2013-02-26','12:55:00',2.07),('8998','2013-02-26','13:00:00',2.06),('8998','2013-02-26','13:05:00',2.08),('8998','2013-02-26','13:10:00',2.04),('8998','2013-02-26','13:15:00',1.9),('8998','2013-02-26','13:20:00',1.05),('8998','2013-02-26','13:30:00',1.66),('8998','2013-02-26','13:35:00',1.84),('8998','2013-02-26','13:40:00',1.73),('8998','2013-02-26','13:45:00',1.7),('8998','2013-02-26','13:50:00',1.33),('8998','2013-02-26','13:55:00',1.06),('8998','2013-02-26','14:00:00',1.18),('8998','2013-02-26','14:10:00',1.14),('8998','2013-02-26','14:20:00',1.07),('8998','2013-02-26','14:25:00',1),('8998','2013-02-25','09:30:00',1.03),('8998','2013-02-25','09:35:00',1.3),('8998','2013-02-25','09:40:00',1.46),('8998','2013-02-25','09:45:00',1.45),('8998','2013-02-25','09:50:00',1.47),('8998','2013-02-25','09:55:00',1.64),('8998','2013-02-25','10:00:00',1.54),('8998','2013-02-25','10:05:00',1.55),('8998','2013-02-25','10:10:00',1.84),('8998','2013-02-25','10:15:00',2.11),('8998','2013-02-25','10:20:00',2.44),('8998','2013-02-25','10:25:00',2.62),('8998','2013-02-25','10:30:00',2.48),('8998','2013-02-25','10:35:00',2.21),('8998','2013-02-25','10:40:00',1.54),('8998','2013-02-25','10:50:00',1.17),('8998','2013-02-25','10:55:00',1.26),('8998','2013-02-25','11:00:00',1.38),('8998','2013-02-25','11:05:00',1.52),('8998','2013-02-25','11:10:00',1.53),('8998','2013-02-25','11:15:00',1.42),('8998','2013-02-25','11:20:00',1.13),('8998','2013-02-25','11:25:00',1.07),('8998','2013-02-25','11:30:00',1.04),('8998','2013-02-25','11:35:00',1.02),('8998','2013-02-25','11:40:00',1.12),('8998','2013-02-25','11:45:00',1.06),('8998','2013-02-25','11:50:00',1.27),('8998','2013-02-25','11:55:00',1.22),('8998','2013-02-25','12:00:00',1.24),('8998','2013-02-25','12:05:00',1.2),('8998','2013-02-25','12:10:00',1.22),('8998','2013-02-25','12:15:00',1.07),('8998','2013-02-25','12:20:00',1.06),('8998','2013-02-24','08:50:00',1.07),('8998','2013-02-24','09:00:00',1.09),('8998','2013-02-24','09:30:00',1.12),('8998','2013-02-24','09:35:00',1.12),('8998','2013-02-24','10:45:00',1.08),('8998','2013-02-24','10:50:00',2.07),('8998','2013-02-24','10:55:00',2.9),('8998','2013-02-24','11:00:00',3.31),('8998','2013-02-24','11:05:00',1.88),('8998','2013-02-24','11:10:00',1.35),('8998','2013-02-24','11:15:00',1.15),('8998','2013-02-24','11:30:00',1.24),('8998','2013-02-24','11:45:00',1.04),('8998','2013-02-24','11:50:00',1.3),('8998','2013-02-24','11:55:00',3.08),('8998','2013-02-24','12:00:00',1.92),('8998','2013-02-24','12:05:00',1.44),('8998','2013-02-24','12:10:00',1.18),('8998','2013-02-24','12:15:00',1.58),('8998','2013-02-24','12:20:00',2.51),('8998','2013-02-24','12:25:00',2.69),('8998','2013-02-24','12:30:00',2.39),('8998','2013-02-24','12:35:00',1.68),('8998','2013-02-24','12:40:00',2.45),('8998','2013-02-24','12:45:00',2.3),('8998','2013-02-24','12:50:00',2.17),('8998','2013-02-24','12:55:00',2.11),('8998','2013-02-24','13:00:00',2.21),('8998','2013-02-24','13:05:00',1.66),('8998','2013-02-24','13:10:00',1.99),('8998','2013-02-24','13:15:00',1.44),('8998','2013-02-24','13:20:00',1.23),('8998','2013-02-24','13:30:00',1.07),('8998','2013-02-23','13:05:00',1.12),('8998','2013-02-23','13:10:00',1.06),('8998','2013-02-23','14:05:00',1.02),('8998','2013-02-23','14:10:00',1.03),('8998','2013-02-22','08:15:00',1.13),('8998','2013-02-22','09:00:00',1.02),('8998','2013-02-22','09:05:00',1.06),('8998','2014-03-22','08:35:00',1.01),('8998','2014-03-22','08:55:00',1.38),('8998','2014-03-22','09:05:00',1.27),('8998','2014-03-22','09:10:00',2.11),('8998','2014-03-22','09:15:00',2.11),('8998','2014-03-22','09:20:00',1.49),('8998','2014-03-22','10:55:00',1.06),('8998','2014-03-22','11:40:00',2.64),('8998','2014-03-22','13:45:00',1.35),('8998','2014-03-22','13:50:00',1.27),('8998','2014-03-22','15:15:00',1.15),('8998','2014-03-22','15:25:00',1.24),('8998','2013-02-19','08:25:00',1.11),('8998','2013-02-19','08:30:00',1.54),('8998','2013-02-19','08:35:00',1.6),('8998','2013-02-19','08:40:00',1.66),('8998','2013-02-19','08:45:00',1.74),('8998','2013-02-19','08:50:00',1.79),('8998','2013-02-19','08:55:00',1.84),('8998','2013-02-19','09:00:00',1.88),('8998','2013-02-19','09:05:00',1.28),('8998','2013-02-19','09:10:00',1.08),('8998','2013-02-19','09:15:00',1.38),('8998','2013-02-19','09:20:00',1.01),('8998','2013-02-19','09:25:00',1.39),('8998','2013-02-19','09:30:00',2.2),('8998','2013-02-19','09:35:00',1.61),('8998','2013-02-19','09:50:00',1.15),('8998','2013-02-19','09:55:00',1.8),('8998','2013-02-19','10:00:00',1.07),('8998','2013-02-19','10:10:00',1.49),('8998','2013-02-19','10:50:00',2.1),('8998','2013-02-19','10:55:00',2.51),('8998','2013-02-19','11:10:00',2.6),('8998','2013-02-19','11:15:00',2.58),('8998','2013-02-19','11:20:00',1.12),('8998','2013-02-19','11:25:00',2.2),('8998','2013-02-19','11:30:00',1.5),('8998','2013-02-19','11:35:00',2.14),('8998','2013-02-19','11:40:00',2.73),('8998','2013-02-19','11:45:00',2.53),('8998','2013-02-19','11:50:00',2.85),('8998','2013-02-19','11:55:00',1.73),('8998','2013-02-19','12:00:00',2.32),('8998','2013-02-19','12:05:00',1.15),('8998','2013-02-19','12:10:00',2),('8998','2013-02-19','12:15:00',1.63),('8998','2013-02-19','12:25:00',1.41),('8998','2013-02-19','12:30:00',2.91),('8998','2013-02-19','12:35:00',2.16),('8998','2013-02-19','12:40:00',1.67),('8998','2013-02-19','13:00:00',1.12),('8998','2013-02-19','13:05:00',2.18),('8998','2013-02-19','13:10:00',1.8),('8998','2013-02-19','13:15:00',2.4),('8998','2013-02-19','13:20:00',1.41),('8998','2013-02-19','13:30:00',1.65),('8998','2013-02-18','08:25:00',1.31),('8998','2013-02-18','08:30:00',1.5),('8998','2013-02-18','08:35:00',1.57),('8998','2013-02-18','08:40:00',1.62),('8998','2013-02-18','08:45:00',1.7),('8998','2013-02-18','08:50:00',1.76),('8998','2013-02-18','08:55:00',1.8),('8998','2013-02-18','09:00:00',1.84),('8998','2013-02-18','09:05:00',1.88),('8998','2013-02-18','09:10:00',1.92),('8998','2013-02-18','09:15:00',1.97),('8998','2013-02-18','09:20:00',2.01),('8998','2013-02-18','09:25:00',2.05),('8998','2013-02-18','09:30:00',2.08),('8998','2013-02-18','09:35:00',2.1),('8998','2013-02-18','09:40:00',2.11),('8998','2013-02-18','09:45:00',2.15),('8998','2013-02-18','09:50:00',2.17),('8998','2013-02-18','09:55:00',2.2),('8998','2013-02-18','10:00:00',2.22),('8998','2013-02-18','10:05:00',2.24),('8998','2013-02-18','10:10:00',2.26),('8998','2013-02-18','10:15:00',2.29),('8998','2013-02-18','10:20:00',2.3),('8998','2013-02-18','10:25:00',2.32),('8998','2013-02-18','10:30:00',2.33),('8998','2013-02-18','10:35:00',2.34),('8998','2013-02-18','10:40:00',2.35),('8998','2013-02-18','10:45:00',2.34),('8998','2013-02-18','10:50:00',2.35),('8998','2013-02-18','10:55:00',2.33),('8998','2013-02-18','11:00:00',2.35),('8998','2013-02-18','11:05:00',2.38),('8998','2013-02-18','11:10:00',2.36),('8998','2013-02-18','11:15:00',2.37),('8998','2013-02-18','11:20:00',2.38),('8998','2013-02-18','11:25:00',2.38),('8998','2013-02-18','11:30:00',2.35),('8998','2013-02-18','11:35:00',2.36),('8998','2013-02-18','11:40:00',2.34),('8998','2013-02-18','11:45:00',2.32),('8998','2013-02-18','11:50:00',2.32),('8998','2013-02-18','11:55:00',2.29),('8998','2013-02-18','12:00:00',2.26),('8998','2013-02-18','12:05:00',2.26),('8998','2013-02-18','12:10:00',2.22),('8998','2013-02-18','12:15:00',2.18),('8998','2013-02-18','12:20:00',2.16),('8998','2013-02-18','12:25:00',2.14),('8998','2013-02-18','12:30:00',2.12),('8998','2013-02-18','12:35:00',2.09),('8998','2013-02-18','12:40:00',2.08),('8998','2013-02-18','12:45:00',2.05),('8998','2013-02-18','12:50:00',2.03),('8998','2013-02-18','12:55:00',2),('8998','2013-02-18','13:00:00',1.96),('8998','2013-02-18','13:05:00',1.94),('8998','2013-02-18','13:10:00',1.88),('8998','2013-02-18','13:15:00',1.83),('8998','2013-02-18','13:20:00',1.76),('8998','2013-02-18','13:25:00',1.77),('8998','2013-02-18','13:30:00',1.73),('8998','2013-02-18','13:35:00',1.7),('8998','2013-02-18','13:40:00',1.64),('8998','2013-02-18','13:45:00',1.6),('8998','2013-02-18','13:50:00',1.56),('8998','2013-02-18','13:55:00',1.44),('8998','2013-02-18','14:00:00',1.28),('8998','2013-02-18','14:05:00',1.18),('8998','2013-02-18','14:10:00',1.11),('8998','2013-02-18','14:15:00',1.04),('8998','2013-02-17','08:35:00',1.37),('8998','2013-02-17','08:40:00',1.53),('8998','2013-02-17','08:45:00',1.59),('8998','2013-02-17','08:50:00',1.6),('8998','2013-02-17','08:55:00',1.66),('8998','2013-02-17','09:00:00',1.69),('8998','2013-02-17','09:05:00',1.75),('8998','2013-02-17','09:10:00',1.8),('8998','2013-02-17','09:15:00',1.81),('8998','2013-02-17','09:20:00',2.04),('8998','2013-02-17','09:25:00',2.13),('8998','2013-02-17','09:30:00',1.97),('8998','2013-02-17','09:35:00',1.1),('8998','2013-02-17','09:50:00',1.21),('8998','2013-02-17','10:10:00',1.04),('8998','2013-02-17','11:25:00',1.08),('8998','2013-02-17','11:55:00',1.05),('8998','2013-02-17','12:00:00',1.12),('8998','2013-02-17','12:05:00',1.07),('8998','2013-02-17','12:10:00',1.01),('8998','2013-02-17','12:45:00',1.05),('8998','2013-02-17','12:50:00',1.1),('8998','2013-02-17','12:55:00',1),('8998','2013-02-17','13:05:00',1),('8998','2013-02-17','13:15:00',1.15),('8998','2013-02-17','13:25:00',1.18),('8998','2013-02-17','13:30:00',1.07),('8998','2013-02-17','14:00:00',1.04),('8998','2013-02-16','08:30:00',1.33),('8998','2013-02-16','08:35:00',1.47),('8998','2013-02-16','08:40:00',1.6),('8998','2013-02-16','08:45:00',1.53),('8998','2013-02-16','08:50:00',1.36),('8998','2013-02-16','08:55:00',1.5),('8998','2013-02-16','09:00:00',1.64),('8998','2013-02-16','09:05:00',1.64),('8998','2013-02-16','09:10:00',1.73),('8998','2013-02-16','09:15:00',1.78),('8998','2013-02-16','09:20:00',1.87),('8998','2013-02-16','09:25:00',1.9),('8998','2013-02-16','09:30:00',1.91),('8998','2013-02-16','09:35:00',1.95),('8998','2013-02-16','09:40:00',1.98),('8998','2013-02-16','09:45:00',2.02),('8998','2013-02-16','09:50:00',2.05),('8998','2013-02-16','09:55:00',2.08),('8998','2013-02-16','10:00:00',2.12),('8998','2013-02-16','10:05:00',2.14),('8998','2013-02-16','10:10:00',2.14),('8998','2013-02-16','10:15:00',2.17),('8998','2013-02-16','10:20:00',2.2),('8998','2013-02-16','10:25:00',2.2),('8998','2013-02-16','10:30:00',2.23),('8998','2013-02-16','10:35:00',2.24),('8998','2013-02-16','10:40:00',2.25),('8998','2013-02-16','10:45:00',2.24),('8998','2013-02-16','10:50:00',2.26),('8998','2013-02-16','10:55:00',2.26),('8998','2013-02-16','11:00:00',2.25),('8998','2013-02-16','11:05:00',2.26),('8998','2013-02-16','11:10:00',2.25),('8998','2013-02-16','11:15:00',2.26),('8998','2013-02-16','11:20:00',2.25),('8998','2013-02-16','11:25:00',2.23),('8998','2013-02-16','11:30:00',2.23),('8998','2013-02-16','11:35:00',2.22),('8998','2013-02-16','11:40:00',2.21),('8998','2013-02-16','11:45:00',2.19),('8998','2013-02-16','11:50:00',2.18),('8998','2013-02-16','11:55:00',2.18),('8998','2013-02-16','12:00:00',2.16),('8998','2013-02-16','12:05:00',2.15),('8998','2013-02-16','12:10:00',2.15),('8998','2013-02-16','12:15:00',2.13),('8998','2013-02-16','12:20:00',2.11),('8998','2013-02-16','12:25:00',2.08),('8998','2013-02-16','12:30:00',2.05),('8998','2013-02-16','12:35:00',2.03),('8998','2013-02-16','12:40:00',1.99),('8998','2013-02-16','12:45:00',1.93),('8998','2013-02-16','12:50:00',1.87),('8998','2013-02-16','12:55:00',1.85),('8998','2013-02-16','13:00:00',1.85),('8998','2013-02-16','13:05:00',1.82),('8998','2013-02-16','13:10:00',1.77),('8998','2013-02-16','13:15:00',1.73),('8998','2013-02-16','13:20:00',1.66),('8998','2013-02-16','13:25:00',1.65),('8998','2013-02-16','13:30:00',1.63),('8998','2013-02-16','13:35:00',1.58),('8998','2013-02-16','13:40:00',1.51),('8998','2013-02-16','13:45:00',1.45),('8998','2013-02-16','13:50:00',1.33),('8998','2013-02-16','13:55:00',1.27),('8998','2013-02-16','14:15:00',1.07),('8998','2013-02-15','08:35:00',1.33),('8998','2013-02-15','08:40:00',1.49),('8998','2013-02-15','08:45:00',1.49),('8998','2013-02-15','09:15:00',1.95),('8998','2013-02-15','09:20:00',1.98),('8998','2013-02-15','09:25:00',1.99),('8998','2013-02-15','09:30:00',2.02),('8998','2013-02-15','09:35:00',2.05),('8998','2013-02-15','09:40:00',2.06),('8998','2013-02-15','09:45:00',2.09),('8998','2013-02-15','09:50:00',2.15),('8998','2013-02-15','09:55:00',2.15),('8998','2013-02-15','10:00:00',2.14),('8998','2013-02-15','10:05:00',2.17),('8998','2013-02-15','10:10:00',2.22),('8998','2013-02-15','10:15:00',2.21),('8998','2013-02-15','10:20:00',2.25),('8998','2013-02-15','10:25:00',2.25),('8998','2013-02-15','10:30:00',2.3),('8998','2013-02-15','10:35:00',2.35),('8998','2013-02-15','10:40:00',2.41),('8998','2013-02-15','10:45:00',2.41),('8998','2013-02-15','10:50:00',2.38),('8998','2013-02-15','10:55:00',2.36),('8998','2013-02-15','11:00:00',2.33),('8998','2013-02-15','11:05:00',2.29),('8998','2013-02-15','11:10:00',2.36),('8998','2013-02-15','11:15:00',2.37),('8998','2013-02-15','11:20:00',2.23),('8998','2013-02-15','11:25:00',2.27),('8998','2013-02-15','11:30:00',2.31),('8998','2013-02-15','11:35:00',2.31),('8998','2013-02-15','11:40:00',2.29),('8998','2013-02-15','11:45:00',2.3),('8998','2013-02-15','11:50:00',2.3),('8998','2013-02-15','11:55:00',2.28),('8998','2013-02-15','12:00:00',2.25),('8998','2013-02-15','12:05:00',2.21),('8998','2013-02-15','12:10:00',2.2),('8998','2013-02-15','12:15:00',2.17),('8998','2013-02-15','12:20:00',2.15),('8998','2013-02-15','12:25:00',2.12),('8998','2013-02-15','12:30:00',2.09),('8998','2013-02-15','12:35:00',2.07),('8998','2013-02-15','12:40:00',2.05),('8998','2013-02-15','12:45:00',2.03),('8998','2013-02-15','12:50:00',2.01),('8998','2013-02-15','12:55:00',1.97),('8998','2013-02-15','13:00:00',1.93),('8998','2013-02-15','13:05:00',1.89),('8998','2013-02-15','13:10:00',1.84),('8998','2013-02-15','13:15:00',1.8),('8998','2013-02-15','13:20:00',1.76),('8998','2013-02-15','13:25:00',1.72),('8998','2013-02-15','13:30:00',1.68),('8998','2013-02-15','13:35:00',1.64),('8998','2013-02-15','13:40:00',1.61),('8998','2013-02-15','13:45:00',1.56),('8998','2013-02-15','13:50:00',1.45),('8998','2013-02-15','13:55:00',1.43),('8998','2013-02-15','14:00:00',1.31),('8998','2013-02-15','14:05:00',1.23),('8998','2013-02-15','14:10:00',1.17),('8998','2013-02-15','14:15:00',1.14),('8998','2013-02-14','09:25:00',1.3),('8998','2013-02-14','09:30:00',1.14),('8998','2013-02-14','10:00:00',1.23),('8998','2013-02-14','10:05:00',1.36),('8998','2013-02-14','10:10:00',1.13),('8998','2013-02-14','10:15:00',1.01),('8998','2013-02-14','10:25:00',1.74),('8998','2013-02-14','10:30:00',1.35),('8998','2013-02-14','10:35:00',2.06),('8998','2013-02-14','10:40:00',2.11),('8998','2013-02-14','10:45:00',2.13),('8998','2013-02-14','10:50:00',2.29),('8998','2013-02-14','10:55:00',1.42),('8998','2013-02-14','11:00:00',1.29),('8998','2013-02-14','11:05:00',1.36),('8998','2013-02-14','11:10:00',1.56),('8998','2013-02-14','11:15:00',1.85),('8998','2013-02-14','11:20:00',2.42),('8998','2013-02-14','11:25:00',2.42),('8998','2013-02-14','11:30:00',2.39),('8998','2013-02-14','11:35:00',1.92),('8998','2013-02-14','11:40:00',1.31),('8998','2013-02-14','11:45:00',1.31),('8998','2013-02-14','11:50:00',2.31),('8998','2013-02-14','11:55:00',2.22),('8998','2013-02-14','12:00:00',1.84),('8998','2013-02-14','12:05:00',1.78),('8998','2013-02-14','12:10:00',1.91),('8998','2013-02-14','12:15:00',1.84),('8998','2013-02-14','12:20:00',2.43),('8998','2013-02-14','12:25:00',2.07),('8998','2013-02-14','12:30:00',2.11),('8998','2013-02-14','12:35:00',2.13),('8998','2013-02-14','12:40:00',2.07),('8998','2013-02-14','12:45:00',2.04),('8998','2013-02-14','12:50:00',1.99),('8998','2013-02-14','12:55:00',1.96),('8998','2013-02-14','13:00:00',1.9),('8998','2013-02-14','13:05:00',1.86),('8998','2013-02-14','13:10:00',1.83),('8998','2013-02-14','13:15:00',1.79),('8998','2013-02-14','13:20:00',1.63),('8998','2013-02-14','13:25:00',1.47),('8998','2013-02-14','13:30:00',1.27),('8998','2013-02-14','13:35:00',1.38),('8998','2013-02-14','13:40:00',1.76),('8998','2013-02-14','13:45:00',1.42),('8998','2013-02-14','13:50:00',1.43),('8998','2013-02-14','13:55:00',1.52),('8998','2013-02-14','14:00:00',1.1),('8998','2013-02-14','14:05:00',1.24),('8998','2013-02-14','14:10:00',1.47),('8998','2013-02-14','14:15:00',1.07),('8998','2013-02-14','14:20:00',1.08),('8998','2013-02-13','08:30:00',1.02),('8998','2013-02-13','08:35:00',1.49),('8998','2013-02-13','08:40:00',1.63),('8998','2013-02-13','08:45:00',1.69),('8998','2013-02-13','08:50:00',1.74),('8998','2013-02-13','08:55:00',1.79),('8998','2013-02-13','09:00:00',1.84),('8998','2013-02-13','09:05:00',1.88),('8998','2013-02-13','09:10:00',1.93),('8998','2013-02-13','09:15:00',1.97),('8998','2013-02-13','09:20:00',2.01),('8998','2013-02-13','09:25:00',2.05),('8998','2013-02-13','09:30:00',2.09),('8998','2013-02-13','09:35:00',2.12),('8998','2013-02-13','09:40:00',2.15),('8998','2013-02-13','09:45:00',2.18),('8998','2013-02-13','09:50:00',2.2),('8998','2013-02-13','09:55:00',2.24),('8998','2013-02-13','10:00:00',2.26),('8998','2013-02-13','10:05:00',2.29),('8998','2013-02-13','10:10:00',2.32),('8998','2013-02-13','10:15:00',2.33),('8998','2013-02-13','10:20:00',2.34),('8998','2013-02-13','10:25:00',2.36),('8998','2013-02-13','10:30:00',2.36),('8998','2013-02-13','10:35:00',2.37),('8998','2013-02-13','10:40:00',2.38),('8998','2013-02-13','10:45:00',2.39),('8998','2013-02-13','10:50:00',2.4),('8998','2013-02-13','10:55:00',2.4),('8998','2013-02-13','11:00:00',2.4),('8998','2013-02-13','11:05:00',2.4),('8998','2013-02-13','11:10:00',2.39),('8998','2013-02-13','11:15:00',2.39),('8998','2013-02-13','11:20:00',2.38),('8998','2013-02-13','11:25:00',2.37),('8998','2013-02-13','11:30:00',2.36),('8998','2013-02-13','11:35:00',2.35),('8998','2013-02-13','11:40:00',2.32),('8998','2013-02-13','11:45:00',2.32),('8998','2013-02-13','11:50:00',2.31),('8998','2013-02-13','11:55:00',2.3),('8998','2013-02-13','12:00:00',2.27),('8998','2013-02-13','12:05:00',2.25),('8998','2013-02-13','12:10:00',2.22),('8998','2013-02-13','12:15:00',2.2),('8998','2013-02-13','12:20:00',2.18),('8998','2013-02-13','12:25:00',2.16),('8998','2013-02-13','12:30:00',2.12),('8998','2013-02-13','12:35:00',2.09),('8998','2013-02-13','12:40:00',2.06),('8998','2013-02-13','12:45:00',2.02),('8998','2013-02-13','12:50:00',1.98),('8998','2013-02-13','12:55:00',1.95),('8998','2013-02-13','13:00:00',1.91),('8998','2013-02-13','13:05:00',1.87),('8998','2013-02-13','13:10:00',1.84),('8998','2013-02-13','13:15:00',1.81),('8998','2013-02-13','13:20:00',1.76),('8998','2013-02-13','13:25:00',1.71),('8998','2013-02-13','13:30:00',1.66),('8998','2013-02-13','13:35:00',1.62),('8998','2013-02-13','13:40:00',1.58),('8998','2013-02-13','13:45:00',1.52),('8998','2013-02-13','13:50:00',1.45),('8998','2013-02-13','13:55:00',1.36),('8998','2013-02-13','14:00:00',1.28),('8998','2013-02-13','14:05:00',1.17),('8998','2013-02-13','14:10:00',1.13),('8998','2013-02-13','14:15:00',1.07),('8998','2013-02-12','09:05:00',1.09),('8998','2013-02-12','09:10:00',1.17),('8998','2013-02-12','09:15:00',1.1),('8998','2013-02-12','09:20:00',1.09),('8998','2013-02-12','09:25:00',1.07),('8998','2013-02-12','09:30:00',1.18),('8998','2013-02-12','09:35:00',1.4),('8998','2013-02-12','09:40:00',1.89),('8998','2013-02-12','09:45:00',2.09),('8998','2013-02-12','09:50:00',2.06),('8998','2013-02-12','09:55:00',2.06),('8998','2013-02-12','10:00:00',1.86),('8998','2013-02-12','10:05:00',2.05),('8998','2013-02-12','10:10:00',2.15),('8998','2013-02-12','10:15:00',2.26),('8998','2013-02-12','10:20:00',2.26),('8998','2013-02-12','10:25:00',2.36),('8998','2013-02-12','10:30:00',2.39),('8998','2013-02-12','10:35:00',2.36),('8998','2013-02-12','10:40:00',2.43),('8998','2013-02-12','10:45:00',2.54),('8998','2013-02-12','10:50:00',2.53),('8998','2013-02-12','10:55:00',2.47),('8998','2013-02-12','11:00:00',2.46),('8998','2013-02-12','11:05:00',2.34),('8998','2013-02-12','11:10:00',2.36),('8998','2013-02-12','11:15:00',2.36),('8998','2013-02-12','11:20:00',2.31),('8998','2013-02-12','11:25:00',1.98),('8998','2013-02-12','11:30:00',1.77),('8998','2013-02-12','11:35:00',1.49),('8998','2013-02-12','11:50:00',1.27),('8998','2013-02-12','12:15:00',1.68),('8998','2013-02-12','12:20:00',1.1),('8998','2013-02-12','12:25:00',1.36),('8998','2013-02-12','12:50:00',1.26),('8998','2013-02-12','12:55:00',1.38),('8998','2013-02-12','13:00:00',1.51),('8998','2013-02-12','13:05:00',1.57),('8998','2013-02-12','13:10:00',1.34),('8998','2013-02-12','13:15:00',1.08),('8998','2013-02-12','13:20:00',1.83),('8998','2013-02-12','13:25:00',1.83),('8998','2013-02-12','13:30:00',1.86),('8998','2013-02-12','13:35:00',1.77),('8998','2013-02-12','13:40:00',1.59),('8998','2013-02-12','13:45:00',1.43),('8998','2013-02-12','13:50:00',1.19),('8998','2013-02-12','13:55:00',1.2),('8998','2013-02-12','14:00:00',1.35),('8998','2013-02-12','14:05:00',1.26),('8998','2013-02-12','14:10:00',1.02),('8998','2013-02-10','14:30:00',1.17),('8998','2014-03-21','07:40:00',1.15),('8998','2014-03-21','07:50:00',1.13),('8998','2014-03-21','08:15:00',1.22),('8998','2014-03-21','08:20:00',1.59),('8998','2014-03-21','08:25:00',1.61),('8998','2014-03-21','08:30:00',1.82),('8998','2014-03-21','08:40:00',1.84),('8998','2014-03-21','08:45:00',2.13),('8998','2014-03-21','08:50:00',1.43),('8998','2014-03-21','08:55:00',1.16),('8998','2014-03-21','09:00:00',1.78),('8998','2014-03-21','09:05:00',1.03),('8998','2014-03-21','09:10:00',1.05),('8998','2014-03-21','09:25:00',1.28),('8998','2014-03-21','09:30:00',2),('8998','2014-03-21','09:35:00',1.7),('8998','2014-03-21','09:40:00',2.11),('8998','2014-03-21','09:45:00',2.53),('8998','2014-03-21','09:50:00',2.42),('8998','2014-03-21','09:55:00',2.46),('8998','2014-03-21','10:00:00',2.52),('8998','2014-03-21','10:05:00',2.52),('8998','2014-03-21','10:10:00',2.79),('8998','2014-03-21','10:15:00',1.41),('8998','2014-03-21','10:35:00',1.02),('8998','2014-03-21','10:40:00',1.59),('8998','2014-03-21','10:45:00',1.91),('8998','2014-03-21','10:50:00',2.72),('8998','2014-03-21','10:55:00',1.18),('8998','2014-03-21','11:20:00',2.21),('8998','2014-03-21','11:25:00',2.9),('8998','2014-03-21','11:30:00',2.98),('8998','2014-03-21','11:35:00',1.08),('8998','2014-03-21','11:40:00',1.72),('8998','2014-03-21','11:45:00',1.36),('8998','2014-03-21','11:50:00',1.53),('8998','2014-03-21','11:55:00',2.25),('8998','2014-03-21','12:00:00',2.37),('8998','2014-03-21','12:05:00',1.21),('8998','2014-03-21','12:15:00',1.09),('8998','2014-03-21','12:20:00',1.98),('8998','2014-03-21','12:25:00',2.49),('8998','2014-03-21','12:30:00',1.2),('8998','2014-03-21','12:35:00',1.89),('8998','2014-03-21','12:40:00',1.08),('8998','2014-03-21','12:45:00',2.56),('8998','2014-03-21','12:50:00',1.63),('8998','2014-03-21','12:55:00',1.78),('8998','2014-03-21','13:00:00',1.53),('8998','2014-03-21','13:10:00',2.42),('8998','2014-03-21','13:15:00',1.51),('8998','2014-03-21','13:20:00',1.9),('8998','2014-03-21','13:25:00',2.02),('8998','2014-03-21','13:30:00',1.7),('8998','2014-03-21','13:35:00',2.02),('8998','2014-03-21','13:40:00',1.34),('8998','2014-03-21','13:45:00',2.37),('8998','2014-03-21','13:50:00',1.25),('8998','2014-03-21','13:55:00',1.19),('8998','2014-03-21','14:00:00',1.32),('8998','2014-03-21','14:10:00',1.75),('8998','2014-03-21','14:15:00',1.49),('8998','2014-03-21','14:20:00',1.5),('8998','2014-03-21','14:25:00',1.54),('8998','2014-03-21','14:30:00',1.45),('8998','2014-03-21','14:35:00',1.37),('8998','2014-03-21','14:40:00',1.31),('8998','2014-03-21','14:45:00',1.25),('8998','2014-03-21','14:50:00',1.16),('8998','2014-03-21','14:55:00',1.13),('8998','2014-03-21','15:00:00',1.07),('8998','2014-03-21','15:05:00',1),('8998','2013-02-09','09:45:00',1.03),('8998','2013-02-09','09:50:00',1.17),('8998','2013-02-09','10:00:00',1.98),('8998','2013-02-09','10:05:00',2.29),('8998','2013-02-09','10:10:00',2.22),('8998','2013-02-09','10:15:00',2.27),('8998','2013-02-09','10:20:00',2.28),('8998','2013-02-09','10:25:00',2.29),('8998','2013-02-09','10:30:00',2.3),('8998','2013-02-09','10:35:00',2.3),('8998','2013-02-09','10:40:00',2.3),('8998','2013-02-09','10:45:00',2.32),('8998','2013-02-09','10:50:00',2.33),('8998','2013-02-09','10:55:00',2.33),('8998','2013-02-09','11:00:00',2.33),('8998','2013-02-09','11:05:00',2.32),('8998','2013-02-09','11:10:00',2.31),('8998','2013-02-09','11:15:00',2.3),('8998','2013-02-09','11:20:00',2.29),('8998','2013-02-09','11:25:00',2.27),('8998','2013-02-09','11:30:00',2.27),('8998','2013-02-09','11:35:00',2.26),('8998','2013-02-09','11:40:00',2.25),('8998','2013-02-09','11:45:00',2.24),('8998','2013-02-09','11:50:00',2.23),('8998','2013-02-09','11:55:00',2.23),('8998','2013-02-09','12:00:00',2.23),('8998','2013-02-09','12:05:00',2.2),('8998','2013-02-09','12:10:00',2.2),('8998','2013-02-09','12:15:00',2.18),('8998','2013-02-09','12:20:00',2.14),('8998','2013-02-09','12:25:00',2.11),('8998','2013-02-09','12:30:00',2.08),('8998','2013-02-09','12:35:00',2.05),('8998','2013-02-09','12:40:00',2.01),('8998','2013-02-09','12:45:00',1.98),('8998','2013-02-09','12:50:00',1.97),('8998','2013-02-09','12:55:00',1.93),('8998','2013-02-09','13:00:00',1.87),('8998','2013-02-09','13:05:00',1.82),('8998','2013-02-09','13:10:00',1.78),('8998','2013-02-09','13:15:00',1.74),('8998','2013-02-09','13:20:00',1.71),('8998','2013-02-09','13:25:00',1.67),('8998','2013-02-09','13:30:00',1.61),('8998','2013-02-09','13:35:00',1.55),('8998','2013-02-09','13:40:00',1.49),('8998','2013-02-09','13:45:00',1.41),('8998','2013-02-09','13:50:00',1.34),('8998','2013-02-09','13:55:00',1.24),('8998','2013-02-09','14:00:00',1.12),('8998','2013-02-08','13:10:00',1.1),('8998','2013-02-08','13:15:00',1.19),('8998','2013-02-08','13:20:00',1.27),('8998','2013-02-08','13:25:00',1.32),('8998','2013-02-08','13:30:00',1.51),('8998','2013-02-08','13:35:00',1.48),('8998','2013-02-08','13:40:00',1.5),('8998','2013-02-08','13:45:00',1.55),('8998','2013-02-08','13:50:00',1.61),('8998','2013-02-08','13:55:00',1.51),('8998','2013-02-08','14:00:00',1.43),('8998','2013-02-08','14:05:00',1.26),('8998','2013-02-08','14:10:00',1.02),('8998','2013-02-08','14:15:00',1.25),('8998','2013-02-08','14:20:00',1.39),('8998','2013-02-08','14:25:00',1.37),('8998','2013-02-08','14:30:00',1.07),('8998','2013-02-07','09:35:00',1.75),('8998','2013-02-07','09:40:00',2.19),('8998','2013-02-07','09:45:00',2.11),('8998','2013-02-07','09:50:00',2.49),('8998','2013-02-07','09:55:00',2.49),('8998','2013-02-07','10:00:00',2.59),('8998','2013-02-07','10:05:00',2.72),('8998','2013-02-07','10:10:00',2.77),('8998','2013-02-07','10:15:00',2.85),('8998','2013-02-07','10:20:00',2.71),('8998','2013-02-07','10:25:00',2.64),('8998','2013-02-07','10:30:00',2.74),('8998','2013-02-07','10:35:00',1.32),('8998','2013-02-07','10:40:00',1.94),('8998','2013-02-07','10:45:00',2.56),('8998','2013-02-07','10:50:00',2.65),('8998','2013-02-07','10:55:00',2.58),('8998','2013-02-07','11:00:00',2.49),('8998','2013-02-07','11:05:00',2.44),('8998','2013-02-07','11:10:00',2.42),('8998','2013-02-07','11:15:00',2.38),('8998','2013-02-07','11:20:00',2.37),('8998','2013-02-07','11:25:00',2.35),('8998','2013-02-07','11:30:00',2.33),('8998','2013-02-07','11:35:00',2.3),('8998','2013-02-07','11:40:00',2.29),('8998','2013-02-07','11:45:00',2.27),('8998','2013-02-07','11:50:00',2.24),('8998','2013-02-07','11:55:00',2.23),('8998','2013-02-07','12:00:00',2.2),('8998','2013-02-07','12:05:00',2.19),('8998','2013-02-07','12:10:00',2.16),('8998','2013-02-07','12:15:00',2.13),('8998','2013-02-07','12:20:00',2.12),('8998','2013-02-07','12:25:00',2.09),('8998','2013-02-07','12:30:00',2.07),('8998','2013-02-07','12:35:00',2.04),('8998','2013-02-07','12:40:00',2.06),('8998','2013-02-07','12:45:00',2),('8998','2013-02-07','12:50:00',1.61),('8998','2013-02-07','12:55:00',1.17),('8998','2013-02-07','13:00:00',1.14),('8998','2013-02-07','13:05:00',1.09),('8998','2013-02-07','13:10:00',1.21),('8998','2013-02-07','13:15:00',1.18),('8998','2013-02-07','13:20:00',1.21),('8998','2013-02-07','13:25:00',1.14),('8998','2013-02-07','13:30:00',1.07),('8998','2013-02-07','13:35:00',1.36),('8998','2013-02-07','13:40:00',1.2),('8998','2013-02-07','13:45:00',1.01),('8998','2013-02-07','13:50:00',1),('8998','2013-02-07','13:55:00',1),('8998','2013-02-07','14:40:00',1.2),('8998','2013-02-07','14:45:00',1.21),('8998','2013-02-07','14:55:00',1.03),('8998','2013-02-06','10:45:00',1.13),('8998','2013-02-06','11:00:00',1.55),('8998','2013-02-06','12:25:00',1.61),('8998','2013-02-06','12:30:00',1.47),('8998','2013-02-06','14:05:00',1.02),('8998','2013-02-06','14:10:00',1.41),('8998','2013-02-06','14:15:00',1.37),('8998','2013-02-06','14:20:00',1.25),('8998','2013-02-05','08:50:00',1.31),('8998','2013-02-05','09:05:00',1.13),('8998','2013-02-05','09:10:00',1.43),('8998','2013-02-05','09:30:00',1.26),('8998','2013-02-05','09:40:00',1.37),('8998','2013-02-05','09:55:00',1.22),('8998','2013-02-05','10:05:00',1.33),('8998','2013-02-05','10:10:00',1.14),('8998','2013-02-05','10:15:00',1.01),('8998','2013-02-05','10:25:00',1.2),('8998','2013-02-05','10:30:00',1.05),('8998','2013-02-05','10:35:00',1.38),('8998','2013-02-05','10:40:00',1.01),('8998','2013-02-05','10:50:00',1.15),('8998','2013-02-05','10:55:00',1.64),('8998','2013-02-05','11:00:00',1.34),('8998','2013-02-05','11:10:00',1.12),('8998','2013-02-05','11:15:00',1.01),('8998','2013-02-05','11:20:00',1.3),('8998','2013-02-05','11:25:00',1.79),('8998','2013-02-05','11:30:00',1.18),('8998','2013-02-05','11:35:00',1.03),('8998','2013-02-05','11:40:00',1.11),('8998','2013-02-05','11:45:00',1.15),('8998','2013-02-05','11:50:00',1.18),('8998','2013-02-05','11:55:00',1.14),('8998','2013-02-05','12:00:00',1),('8998','2013-02-05','14:35:00',1.09),('8998','2013-02-04','08:40:00',1.06),('8998','2013-02-04','08:45:00',1.39),('8998','2013-02-04','08:50:00',1.47),('8998','2013-02-04','08:55:00',1.51),('8998','2013-02-04','09:00:00',1.55),('8998','2013-02-04','09:05:00',1.59),('8998','2013-02-04','09:10:00',1.63),('8998','2013-02-04','09:15:00',1.69),('8998','2013-02-04','09:20:00',1.73),('8998','2013-02-04','09:25:00',1.78),('8998','2013-02-04','09:30:00',1.79),('8998','2013-02-04','09:35:00',1.84),('8998','2013-02-04','09:40:00',1.88),('8998','2013-02-04','09:45:00',1.9),('8998','2013-02-04','09:50:00',1.92),('8998','2013-02-04','09:55:00',1.95),('8998','2013-02-04','10:00:00',1.94),('8998','2013-02-04','10:05:00',1.96),('8998','2013-02-04','10:10:00',1.83),('8998','2013-02-04','10:15:00',1.84),('8998','2013-02-04','10:20:00',2.03),('8998','2013-02-04','10:25:00',2.06),('8998','2013-02-04','10:30:00',2.07),('8998','2013-02-04','10:35:00',2.07),('8998','2013-02-04','10:40:00',2.08),('8998','2013-02-04','10:45:00',2.07),('8998','2013-02-04','10:50:00',2.05),('8998','2013-02-04','10:55:00',2.04),('8998','2013-02-04','11:00:00',2.04),('8998','2013-02-04','11:05:00',2.03),('8998','2013-02-04','11:10:00',2.06),('8998','2013-02-04','11:15:00',2.05),('8998','2013-02-04','11:20:00',2.03),('8998','2013-02-04','11:25:00',2.03),('8998','2013-02-04','11:30:00',1.97),('8998','2013-02-04','11:35:00',1.87),('8998','2013-02-04','11:40:00',1.62),('8998','2013-02-04','11:45:00',1.47),('8998','2013-02-04','11:50:00',1.19),('8998','2013-02-04','11:55:00',1.03),('8998','2013-02-04','12:10:00',1.46),('8998','2013-02-04','12:15:00',1.07),('8998','2013-02-04','12:40:00',1.11),('8998','2013-02-04','12:45:00',1.21),('8998','2013-02-04','12:50:00',1.43),('8998','2013-02-04','14:30:00',1.03),('8998','2013-02-03','08:40:00',1.08),('8998','2013-02-03','08:45:00',1.45),('8998','2013-02-03','08:50:00',1.56),('8998','2013-02-03','08:55:00',1.39),('8998','2013-02-03','09:00:00',1.68),('8998','2013-02-03','09:05:00',1.76),('8998','2013-02-03','09:10:00',1.83),('8998','2013-02-03','09:15:00',1.85),('8998','2013-02-03','09:20:00',1.8),('8998','2013-02-03','09:25:00',1.77),('8998','2013-02-03','09:30:00',1.89),('8998','2013-02-03','09:35:00',1.86),('8998','2013-02-03','09:40:00',1.89),('8998','2013-02-03','09:45:00',1.67),('8998','2013-02-03','09:50:00',1.97),('8998','2013-02-03','09:55:00',2.1),('8998','2013-02-03','10:00:00',2.13),('8998','2013-02-03','10:05:00',2.15),('8998','2013-02-03','10:10:00',2.21),('8998','2013-02-03','10:15:00',2.24),('8998','2013-02-03','10:20:00',2.1),('8998','2013-02-03','10:25:00',2.19),('8998','2013-02-03','10:30:00',2.06),('8998','2013-02-03','10:35:00',1.92),('8998','2013-02-03','10:40:00',2.03),('8998','2013-02-03','10:45:00',2.19),('8998','2013-02-03','10:50:00',2.22),('8998','2013-02-03','10:55:00',2.18),('8998','2013-02-03','11:00:00',2.18),('8998','2013-02-03','11:05:00',2.2),('8998','2013-02-03','11:10:00',2.2),('8998','2013-02-03','11:15:00',2.19),('8998','2013-02-03','11:20:00',2.18),('8998','2013-02-03','11:25:00',2.17),('8998','2013-02-03','11:30:00',2.17),('8998','2013-02-03','11:35:00',2.14),('8998','2013-02-03','11:40:00',2.14),('8998','2013-02-03','11:45:00',2.12),('8998','2013-02-03','11:50:00',2.11),('8998','2013-02-03','11:55:00',2.08),('8998','2013-02-03','12:00:00',2.07),('8998','2013-02-03','12:05:00',2.06),('8998','2013-02-03','12:10:00',2.04),('8998','2013-02-03','12:15:00',2),('8998','2013-02-03','12:20:00',1.98),('8998','2013-02-03','12:25:00',1.95),('8998','2013-02-03','12:30:00',1.93),('8998','2013-02-03','12:35:00',1.9),('8998','2013-02-03','12:40:00',1.88),('8998','2013-02-03','12:45:00',1.84),('8998','2013-02-03','12:50:00',1.79),('8998','2013-02-03','12:55:00',1.77),('8998','2013-02-03','13:00:00',1.75),('8998','2013-02-03','13:05:00',1.71),('8998','2013-02-03','13:10:00',1.67),('8998','2013-02-03','13:15:00',1.63),('8998','2013-02-03','13:20:00',1.58),('8998','2013-02-03','13:25:00',1.53),('8998','2013-02-03','13:30:00',1.5),('8998','2013-02-03','13:35:00',1.45),('8998','2013-02-03','13:40:00',1.39),('8998','2013-02-03','13:45:00',1.27),('8998','2013-02-03','13:50:00',1.22),('8998','2013-02-03','13:55:00',1.12),('8998','2013-02-02','09:45:00',1.17),('8998','2013-02-02','09:50:00',1.2),('8998','2013-02-02','10:00:00',1.5),('8998','2013-02-01','10:40:00',1.04),('8998','2013-02-01','10:45:00',1.13),('8998','2013-02-01','10:55:00',1.25),('8998','2013-02-01','11:00:00',1.45),('8998','2013-02-01','11:05:00',1.29),('8998','2013-02-01','11:10:00',1.35),('8998','2013-02-01','11:15:00',1.31),('8998','2013-02-01','11:20:00',1.3),('8998','2013-02-01','11:25:00',1.39),('8998','2013-02-01','11:30:00',1.38),('8998','2013-02-01','11:35:00',1.2),('8998','2013-02-01','11:40:00',1.2),('8998','2013-02-01','12:55:00',1.27),('8998','2013-02-01','13:00:00',1.12),('8998','2013-02-01','13:05:00',1.18),('8998','2013-02-01','13:10:00',1.06),('8998','2013-02-01','13:15:00',1.22),('8998','2013-02-01','13:20:00',1.09),('8998','2013-02-01','13:25:00',1.02),('8998','2013-02-01','13:35:00',1.18),('8998','2013-02-01','13:40:00',1.41),('8998','2013-02-01','13:45:00',1.15),('8998','2013-02-01','13:50:00',1.13),('8998','2013-01-31','09:00:00',1.36),('8998','2013-01-31','09:05:00',1.49),('8998','2013-01-31','09:10:00',1.64),('8998','2013-01-31','09:25:00',1.42),('8998','2013-01-31','09:30:00',1.03),('8998','2013-01-31','09:40:00',1.36),('8998','2013-01-31','09:45:00',1.06),('8998','2013-01-31','10:00:00',1.34),('8998','2013-01-31','10:20:00',1.42),('8998','2013-01-31','10:25:00',1.21),('8998','2013-01-31','10:35:00',1.05),('8998','2013-01-31','10:50:00',1.6),('8998','2013-01-31','10:55:00',2.37),('8998','2013-01-31','11:00:00',2.18),('8998','2013-01-31','11:05:00',1.95),('8998','2013-01-31','11:10:00',2.04),('8998','2013-01-31','11:15:00',1.29),('8998','2013-01-31','11:20:00',1.62),('8998','2013-01-31','11:25:00',1.21),('8998','2013-01-31','11:35:00',1.08),('8998','2013-01-31','11:40:00',1.88),('8998','2013-01-31','11:45:00',1.12),('8998','2013-01-31','11:50:00',1.11),('8998','2013-01-31','12:10:00',1.07),('8998','2013-01-31','12:15:00',1.25),('8998','2013-01-31','12:20:00',2.28),('8998','2013-01-31','12:25:00',1.98),('8998','2013-01-31','12:40:00',1.58),('8998','2013-01-31','12:45:00',1.62),('8998','2013-01-31','12:50:00',1.79),('8998','2013-01-31','12:55:00',2.03),('8998','2013-01-31','13:00:00',1.89),('8998','2013-01-31','13:05:00',1.11),('8998','2013-01-31','13:10:00',1.65),('8998','2013-01-31','13:15:00',1.54),('8998','2013-01-31','13:20:00',1.47),('8998','2013-01-31','13:25:00',1.12),('8998','2013-01-31','13:30:00',1.15),('8998','2013-01-31','13:35:00',1.21),('8998','2013-01-31','13:40:00',1.13),('8998','2013-01-31','13:45:00',1.16),('8998','2014-03-20','07:45:00',1.05),('8998','2014-03-20','07:50:00',1.07),('8998','2014-03-20','07:55:00',1.1),('8998','2014-03-20','08:00:00',1.13),('8998','2014-03-20','08:05:00',1.12),('8998','2014-03-20','08:10:00',1.56),('8998','2014-03-20','08:15:00',1.71),('8998','2014-03-20','08:20:00',1.76),('8998','2014-03-20','08:25:00',1.83),('8998','2014-03-20','08:30:00',1.95),('8998','2014-03-20','08:35:00',2),('8998','2014-03-20','08:40:00',2.05),('8998','2014-03-20','08:45:00',2.07),('8998','2014-03-20','08:50:00',2.11),('8998','2014-03-20','08:55:00',2.17),('8998','2014-03-20','09:00:00',2.21),('8998','2014-03-20','09:05:00',2.2),('8998','2014-03-20','09:10:00',2.27),('8998','2014-03-20','09:15:00',2.32),('8998','2014-03-20','09:20:00',2.37),('8998','2014-03-20','09:25:00',2.26),('8998','2014-03-20','09:30:00',2.41),('8998','2014-03-20','09:35:00',2.41),('8998','2014-03-20','09:40:00',2.43),('8998','2014-03-20','09:45:00',2.44),('8998','2014-03-20','09:50:00',2.45),('8998','2014-03-20','09:55:00',2.47),('8998','2014-03-20','10:00:00',2.49),('8998','2014-03-20','10:05:00',2.47),('8998','2014-03-20','10:10:00',2.43),('8998','2014-03-20','10:15:00',2.43),('8998','2014-03-20','10:20:00',2.47),('8998','2014-03-20','10:25:00',2.56),('8998','2014-03-20','10:30:00',2.6),('8998','2014-03-20','10:35:00',2.55),('8998','2014-03-20','10:40:00',2.56),('8998','2014-03-20','10:45:00',2.55),('8998','2014-03-20','10:50:00',2.53),('8998','2014-03-20','10:55:00',2.51),('8998','2014-03-20','11:00:00',2.49),('8998','2014-03-20','11:05:00',2.49),('8998','2014-03-20','11:10:00',2.48),('8998','2014-03-20','11:15:00',2.43),('8998','2014-03-20','11:20:00',2.41),('8998','2014-03-20','11:25:00',2.47),('8998','2014-03-20','11:30:00',1.98),('8998','2014-03-20','11:35:00',1.04),('8998','2014-03-20','11:50:00',1.09),('8998','2014-03-20','11:55:00',2.78),('8998','2014-03-20','12:00:00',2.09),('8998','2014-03-20','12:05:00',2.05),('8998','2014-03-20','12:10:00',2.27),('8998','2014-03-20','12:15:00',2.59),('8998','2014-03-20','12:20:00',2.53),('8998','2014-03-20','12:25:00',2.43),('8998','2014-03-20','12:30:00',2.38),('8998','2014-03-20','12:35:00',2.35),('8998','2014-03-20','12:40:00',2.33),('8998','2014-03-20','12:45:00',2.3),('8998','2014-03-20','12:50:00',2.26),('8998','2014-03-20','12:55:00',2.23),('8998','2014-03-20','13:00:00',2.18),('8998','2014-03-20','13:05:00',2.17),('8998','2014-03-20','13:10:00',2.14),('8998','2014-03-20','13:15:00',2.1),('8998','2014-03-20','13:20:00',2.08),('8998','2014-03-20','13:25:00',2.02),('8998','2014-03-20','13:30:00',2),('8998','2014-03-20','13:35:00',1.93),('8998','2014-03-20','13:40:00',1.88),('8998','2014-03-20','13:45:00',1.85),('8998','2014-03-20','13:50:00',1.8),('8998','2014-03-20','13:55:00',1.74),('8998','2014-03-20','14:00:00',1.71),('8998','2014-03-20','14:05:00',1.67),('8998','2014-03-20','14:10:00',1.63),('8998','2014-03-20','14:15:00',1.57),('8998','2014-03-20','14:20:00',1.51),('8998','2014-03-20','14:25:00',1.46),('8998','2014-03-20','14:30:00',1.39),('8998','2014-03-20','14:35:00',1.24),('8998','2014-03-20','14:40:00',1.22),('8998','2014-03-20','14:45:00',1.17),('8998','2014-03-20','15:10:00',1.03),('8998','2014-03-20','15:15:00',1.14),('8998','2014-03-20','15:20:00',1.1),('8998','2014-03-20','15:25:00',1.07),('8998','2014-03-20','15:30:00',1.1),('8998','2013-01-30','09:20:00',1.11),('8998','2013-01-30','09:25:00',1.58),('8998','2013-01-30','09:30:00',1.8),('8998','2013-01-30','09:35:00',1.71),('8998','2013-01-30','09:40:00',1.74),('8998','2013-01-30','09:45:00',1.54),('8998','2013-01-30','09:50:00',1.71),('8998','2013-01-30','09:55:00',1.86),('8998','2013-01-30','10:00:00',1.85),('8998','2013-01-30','10:05:00',1.84),('8998','2013-01-30','10:10:00',1.83),('8998','2013-01-30','10:15:00',1.88),('8998','2013-01-30','10:20:00',1.92),('8998','2013-01-30','10:25:00',1.85),('8998','2013-01-30','10:30:00',1.73),('8998','2013-01-30','10:35:00',2.06),('8998','2013-01-30','10:40:00',2.1),('8998','2013-01-30','10:45:00',2.07),('8998','2013-01-30','10:50:00',1.92),('8998','2013-01-30','11:00:00',1.86),('8998','2013-01-30','11:05:00',2.29),('8998','2013-01-30','11:10:00',2.27),('8998','2013-01-30','11:15:00',2.2),('8998','2013-01-30','11:20:00',2.19),('8998','2013-01-30','11:25:00',2.04),('8998','2013-01-30','11:30:00',1.94),('8998','2013-01-30','11:35:00',1.98),('8998','2013-01-30','11:40:00',1.95),('8998','2013-01-30','11:45:00',1.93),('8998','2013-01-30','11:50:00',1.91),('8998','2013-01-30','11:55:00',1.87),('8998','2013-01-30','12:00:00',1.85),('8998','2013-01-30','12:05:00',1.86),('8998','2013-01-30','12:10:00',1.52),('8998','2013-01-30','12:15:00',1.75),('8998','2013-01-30','12:20:00',1.79),('8998','2013-01-30','12:25:00',1.77),('8998','2013-01-30','12:30:00',1.74),('8998','2013-01-30','12:35:00',1.72),('8998','2013-01-30','12:40:00',1.69),('8998','2013-01-30','12:45:00',1.66),('8998','2013-01-30','12:50:00',1.63),('8998','2013-01-30','12:55:00',1.58),('8998','2013-01-30','13:00:00',1.56),('8998','2013-01-30','13:05:00',1.54),('8998','2013-01-30','13:10:00',1.5),('8998','2013-01-30','13:15:00',1.44),('8998','2013-01-30','13:20:00',1.38),('8998','2013-01-30','13:25:00',1.35),('8998','2013-01-30','13:30:00',1.3),('8998','2013-01-30','13:35:00',1.27),('8998','2013-01-30','13:40:00',1.19),('8998','2013-01-30','13:45:00',1.14),('8998','2013-01-30','13:50:00',1.09),('8998','2013-01-30','13:55:00',1),('8998','2013-01-29','10:10:00',1.13),('8998','2013-01-29','10:20:00',1.18),('8998','2013-01-29','10:25:00',1.17),('8998','2013-01-29','10:30:00',1.08),('8998','2013-01-29','10:40:00',1.08),('8998','2013-01-29','10:45:00',1.49),('8998','2013-01-29','10:50:00',1.92),('8998','2013-01-29','10:55:00',1.87),('8998','2013-01-29','11:00:00',1.96),('8998','2013-01-29','11:05:00',1.89),('8998','2013-01-29','11:10:00',1.89),('8998','2013-01-29','11:15:00',1.9),('8998','2013-01-29','11:20:00',1.89),('8998','2013-01-29','11:25:00',1.92),('8998','2013-01-29','11:30:00',1.91),('8998','2013-01-29','11:35:00',1.88),('8998','2013-01-29','11:40:00',1.59),('8998','2013-01-29','11:45:00',1.92),('8998','2013-01-29','11:50:00',1.91),('8998','2013-01-29','11:55:00',1.83),('8998','2013-01-29','12:00:00',1.89),('8998','2013-01-29','12:05:00',1.87),('8998','2013-01-29','12:10:00',1.16),('8998','2013-01-29','12:15:00',1.57),('8998','2013-01-29','12:20:00',1.19),('8998','2013-01-29','12:40:00',1.1),('8998','2013-01-29','12:55:00',1.93),('8998','2013-01-29','13:00:00',1.86),('8998','2013-01-29','13:05:00',1.86),('8998','2013-01-29','13:10:00',1.73),('8998','2013-01-29','13:15:00',1.57),('8998','2013-01-29','13:20:00',1.6),('8998','2013-01-29','13:25:00',1.62),('8998','2013-01-29','13:30:00',1.43),('8998','2013-01-29','13:35:00',1.47),('8998','2013-01-29','13:50:00',1.17),('8998','2013-01-29','13:55:00',1.02),('8998','2013-01-29','14:00:00',1.08),('8998','2013-01-29','14:10:00',1.13),('8998','2013-01-28','08:30:00',1.04),('8998','2013-01-28','08:35:00',1.1),('8998','2013-01-28','08:40:00',1.14),('8998','2013-01-28','08:45:00',1.2),('8998','2013-01-28','08:50:00',1.08),('8998','2013-01-28','08:55:00',1.38),('8998','2013-01-28','09:00:00',1.43),('8998','2013-01-28','09:05:00',1.48),('8998','2013-01-28','09:10:00',1.53),('8998','2013-01-28','09:15:00',1.57),('8998','2013-01-28','09:20:00',1.6),('8998','2013-01-28','09:25:00',1.64),('8998','2013-01-28','09:30:00',1.67),('8998','2013-01-28','09:35:00',1.7),('8998','2013-01-28','09:40:00',1.74),('8998','2013-01-28','09:45:00',1.78),('8998','2013-01-28','09:50:00',1.8),('8998','2013-01-28','09:55:00',1.83),('8998','2013-01-28','10:00:00',1.85),('8998','2013-01-28','10:05:00',1.89),('8998','2013-01-28','10:10:00',1.92),('8998','2013-01-28','10:15:00',1.95),('8998','2013-01-28','10:20:00',1.97),('8998','2013-01-28','10:25:00',2),('8998','2013-01-28','10:30:00',2.01),('8998','2013-01-28','10:35:00',2.02),('8998','2013-01-28','10:40:00',2.04),('8998','2013-01-28','10:45:00',2.03),('8998','2013-01-28','10:50:00',2.04),('8998','2013-01-28','10:55:00',2.03),('8998','2013-01-28','11:00:00',2),('8998','2013-01-28','11:05:00',2),('8998','2013-01-28','11:10:00',2),('8998','2013-01-28','11:15:00',2.01),('8998','2013-01-28','11:20:00',2.01),('8998','2013-01-28','11:25:00',1.97),('8998','2013-01-28','11:30:00',1.93),('8998','2013-01-28','11:35:00',1.98),('8998','2013-01-28','11:40:00',2),('8998','2013-01-28','11:45:00',1.98),('8998','2013-01-28','11:50:00',1.96),('8998','2013-01-28','11:55:00',1.93),('8998','2013-01-28','12:00:00',1.88),('8998','2013-01-28','12:05:00',1.87),('8998','2013-01-28','12:10:00',1.88),('8998','2013-01-28','12:15:00',1.84),('8998','2013-01-28','12:20:00',1.82),('8998','2013-01-28','12:25:00',1.81),('8998','2013-01-28','12:30:00',1.77),('8998','2013-01-28','12:35:00',1.72),('8998','2013-01-28','12:40:00',1.69),('8998','2013-01-28','12:45:00',1.64),('8998','2013-01-28','12:50:00',1.61),('8998','2013-01-28','12:55:00',1.61),('8998','2013-01-28','13:00:00',1.58),('8998','2013-01-28','13:05:00',1.53),('8998','2013-01-28','13:10:00',1.49),('8998','2013-01-28','13:15:00',1.44),('8998','2013-01-28','13:20:00',1.41),('8998','2013-01-28','13:25:00',1.38),('8998','2013-01-28','13:30:00',1.33),('8998','2013-01-28','13:35:00',1.29),('8998','2013-01-28','13:40:00',1.21),('8998','2013-01-28','13:45:00',1.06),('8998','2013-01-26','08:55:00',1.28),('8998','2013-01-26','09:00:00',1.36),('8998','2013-01-26','09:05:00',1.41),('8998','2013-01-26','09:10:00',1.44),('8998','2013-01-26','09:15:00',1.49),('8998','2013-01-26','09:20:00',1.54),('8998','2013-01-26','09:25:00',1.59),('8998','2013-01-26','09:30:00',1.62),('8998','2013-01-26','09:35:00',1.66),('8998','2013-01-26','09:40:00',1.7),('8998','2013-01-26','09:45:00',1.73),('8998','2013-01-26','09:50:00',1.76),('8998','2013-01-26','09:55:00',1.8),('8998','2013-01-26','10:00:00',1.81),('8998','2013-01-26','10:05:00',1.84),('8998','2013-01-26','10:10:00',1.85),('8998','2013-01-26','10:15:00',1.88),('8998','2013-01-26','10:20:00',1.89),('8998','2013-01-26','10:25:00',1.9),('8998','2013-01-26','10:30:00',1.92),('8998','2013-01-26','10:35:00',1.93),('8998','2013-01-26','10:40:00',1.93),('8998','2013-01-26','10:45:00',1.94),('8998','2013-01-26','10:50:00',1.95),('8998','2013-01-26','10:55:00',1.96),('8998','2013-01-26','11:00:00',1.95),('8998','2013-01-26','11:05:00',1.96),('8998','2013-01-26','11:10:00',1.96),('8998','2013-01-26','11:15:00',1.96),('8998','2013-01-26','11:20:00',1.96),('8998','2013-01-26','11:25:00',1.95),('8998','2013-01-26','11:30:00',1.93),('8998','2013-01-26','11:35:00',1.92),('8998','2013-01-26','11:40:00',1.91),('8998','2013-01-26','11:45:00',1.9),('8998','2013-01-26','11:50:00',1.88),('8998','2013-01-26','11:55:00',1.88),('8998','2013-01-26','12:00:00',1.86),('8998','2013-01-26','12:05:00',1.84),('8998','2013-01-26','12:10:00',1.82),('8998','2013-01-26','12:15:00',1.81),('8998','2013-01-26','12:20:00',1.79),('8998','2013-01-26','12:25:00',1.75),('8998','2013-01-26','12:30:00',1.72),('8998','2013-01-26','12:35:00',1.69),('8998','2013-01-26','12:40:00',1.65),('8998','2013-01-26','12:45:00',1.6),('8998','2013-01-26','12:50:00',1.6),('8998','2013-01-26','12:55:00',1.59),('8998','2013-01-26','13:00:00',1.56),('8998','2013-01-26','13:05:00',1.52),('8998','2013-01-26','13:10:00',1.48),('8998','2013-01-26','13:15:00',1.43),('8998','2013-01-26','13:20:00',1.37),('8998','2013-01-26','13:25:00',1.33),('8998','2013-01-26','13:30:00',1.29),('8998','2013-01-26','13:35:00',1.22),('8998','2013-01-26','13:40:00',1.06),('8998','2013-01-25','09:05:00',1.11),('8998','2013-01-25','09:20:00',1.16),('8998','2013-01-24','08:35:00',1),('8998','2013-01-24','08:40:00',1.23),('8998','2013-01-24','08:45:00',1.28),('8998','2013-01-24','08:50:00',1.27),('8998','2013-01-24','08:55:00',1.09),('8998','2013-01-24','09:00:00',1.54),('8998','2013-01-24','09:05:00',1.28),('8998','2013-01-24','09:10:00',1.29),('8998','2013-01-24','09:15:00',1.57),('8998','2013-01-24','09:20:00',1.66),('8998','2013-01-24','09:25:00',1.74),('8998','2013-01-24','09:30:00',1.8),('8998','2013-01-24','09:35:00',1.74),('8998','2013-01-24','09:40:00',1.6),('8998','2013-01-24','09:45:00',1.65),('8998','2013-01-24','09:50:00',1.96),('8998','2013-01-24','09:55:00',2.03),('8998','2013-01-24','10:00:00',2.05),('8998','2013-01-24','10:05:00',2.07),('8998','2013-01-24','10:10:00',2.01),('8998','2013-01-24','10:15:00',2),('8998','2013-01-24','10:20:00',2.02),('8998','2013-01-24','10:25:00',2.05),('8998','2013-01-24','10:30:00',1.99),('8998','2013-01-24','10:35:00',1.56),('8998','2013-01-24','10:40:00',2.16),('8998','2013-01-24','10:45:00',1.91),('8998','2013-01-24','10:50:00',1.5),('8998','2013-01-24','10:55:00',2.16),('8998','2013-01-24','11:00:00',1.2),('8998','2013-01-24','11:05:00',1.88),('8998','2013-01-24','11:10:00',1.99),('8998','2013-01-24','11:15:00',2.06),('8998','2013-01-24','11:20:00',2.01),('8998','2013-01-24','11:25:00',1.98),('8998','2013-01-24','11:30:00',1.98),('8998','2013-01-24','11:35:00',1.99),('8998','2013-01-24','11:40:00',1.97),('8998','2013-01-24','11:45:00',1.96),('8998','2013-01-24','11:50:00',1.97),('8998','2013-01-24','11:55:00',1.94),('8998','2013-01-24','12:00:00',1.9),('8998','2013-01-24','12:05:00',1.88),('8998','2013-01-24','12:10:00',1.88),('8998','2013-01-24','12:15:00',1.87),('8998','2013-01-24','12:20:00',1.85),('8998','2013-01-24','12:25:00',1.83),('8998','2013-01-24','12:30:00',1.81),('8998','2013-01-24','12:35:00',1.53),('8998','2013-01-24','12:40:00',1.54),('8998','2013-01-24','12:45:00',1.61),('8998','2013-01-24','12:50:00',1.64),('8998','2013-01-24','12:55:00',1.58),('8998','2013-01-24','13:00:00',1.57),('8998','2013-01-24','13:05:00',1.52),('8998','2013-01-24','13:10:00',1.48),('8998','2013-01-24','13:15:00',1.46),('8998','2013-01-24','13:20:00',1.43),('8998','2013-01-24','13:25:00',1.41),('8998','2013-01-24','13:30:00',1.4),('8998','2013-01-24','13:35:00',1.35),('8998','2013-01-24','13:40:00',1.25),('8998','2013-01-24','13:45:00',1.16),('8998','2013-01-24','13:50:00',1.07),('8998','2013-01-24','13:55:00',1.01),('8998','2013-01-23','09:45:00',1.12),('8998','2013-01-23','09:50:00',1.08),('8998','2013-01-23','09:55:00',1.81),('8998','2013-01-23','10:00:00',1.86),('8998','2013-01-23','10:05:00',1.9),('8998','2013-01-23','10:10:00',2.06),('8998','2013-01-23','10:15:00',2.01),('8998','2013-01-23','10:20:00',2.04),('8998','2013-01-23','10:25:00',2.02),('8998','2013-01-23','10:30:00',2.02),('8998','2013-01-23','10:35:00',2.02),('8998','2013-01-23','10:40:00',2.02),('8998','2013-01-23','10:45:00',2.05),('8998','2013-01-23','10:50:00',2.09),('8998','2013-01-23','10:55:00',1.95),('8998','2013-01-23','11:00:00',1.1),('8998','2013-01-23','14:25:00',1.08),('8998','2013-01-22','09:55:00',1.27),('8998','2013-01-22','10:30:00',1.52),('8998','2013-01-22','10:35:00',2.11),('8998','2013-01-22','10:45:00',1.33),('8998','2013-01-22','10:50:00',1.69),('8998','2013-01-22','10:55:00',1.47),('8998','2013-01-21','08:45:00',1.04),('8998','2013-01-21','08:50:00',1.11),('8998','2013-01-21','09:05:00',1.17),('8998','2013-01-21','09:30:00',1.6),('8998','2013-01-21','09:35:00',1.8),('8998','2013-01-21','09:40:00',1.32),('8998','2013-01-21','09:45:00',2.17),('8998','2013-01-21','09:50:00',1.44),('8998','2013-01-21','09:55:00',1.56),('8998','2013-01-21','10:00:00',1.08),('8998','2013-01-21','10:05:00',1.85),('8998','2013-01-21','10:10:00',1.96),('8998','2013-01-21','10:15:00',1.84),('8998','2013-01-21','10:20:00',1.71),('8998','2013-01-21','10:25:00',1.83),('8998','2013-01-21','10:30:00',2.04),('8998','2013-01-21','10:35:00',2.09),('8998','2013-01-21','10:40:00',2.33),('8998','2013-01-21','10:45:00',1.93),('8998','2013-01-21','10:50:00',1.6),('8998','2013-01-21','11:15:00',1.28),('8998','2013-01-21','11:20:00',1.23),('8998','2013-01-21','11:50:00',1.53),('8998','2013-01-21','12:10:00',1.45),('8998','2013-01-21','12:15:00',1.6),('8998','2013-01-21','12:20:00',1.03),('8998','2013-01-21','12:25:00',1.61),('8998','2013-01-21','12:40:00',1.85),('8998','2013-01-21','13:00:00',1.36),('8998','2013-01-21','13:05:00',1.68),('8998','2013-01-21','13:10:00',1.13),('8998','2013-01-21','13:20:00',1.36),('8998','2014-03-19','07:50:00',1.11),('8998','2014-03-19','07:55:00',1.2),('8998','2014-03-19','08:00:00',1.19),('8998','2014-03-19','08:05:00',1.37),('8998','2014-03-19','08:10:00',1.63),('8998','2014-03-19','08:15:00',1.7),('8998','2014-03-19','08:20:00',1.73),('8998','2014-03-19','08:25:00',1.79),('8998','2014-03-19','08:30:00',1.89),('8998','2014-03-19','08:35:00',1.97),('8998','2014-03-19','08:40:00',2.07),('8998','2014-03-19','08:45:00',2.15),('8998','2014-03-19','08:50:00',2.17),('8998','2014-03-19','08:55:00',2.18),('8998','2014-03-19','09:00:00',2.19),('8998','2014-03-19','09:05:00',2.25),('8998','2014-03-19','09:10:00',2.31),('8998','2014-03-19','09:15:00',2.29),('8998','2014-03-19','09:20:00',2.35),('8998','2014-03-19','09:25:00',2.37),('8998','2014-03-19','09:30:00',2.38),('8998','2014-03-19','09:35:00',2.43),('8998','2014-03-19','09:40:00',2.42),('8998','2014-03-19','09:45:00',2.42),('8998','2014-03-19','09:50:00',2.39),('8998','2014-03-19','09:55:00',2.42),('8998','2014-03-19','10:00:00',2.5),('8998','2014-03-19','10:05:00',2.57),('8998','2014-03-19','10:10:00',2.58),('8998','2014-03-19','10:15:00',2.52),('8998','2014-03-19','10:20:00',2.53),('8998','2014-03-19','10:25:00',2.52),('8998','2014-03-19','10:30:00',2.54),('8998','2014-03-19','10:35:00',2.45),('8998','2014-03-19','10:40:00',2.4),('8998','2014-03-19','10:45:00',2.37),('8998','2014-03-19','10:50:00',2.5),('8998','2014-03-19','10:55:00',2.63),('8998','2014-03-19','11:00:00',2.65),('8998','2014-03-19','11:05:00',2.61),('8998','2014-03-19','11:10:00',2.56),('8998','2014-03-19','11:15:00',2.41),('8998','2014-03-19','11:20:00',2.46),('8998','2014-03-19','11:25:00',2.5),('8998','2014-03-19','11:30:00',2.52),('8998','2014-03-19','11:35:00',2.61),('8998','2014-03-19','11:40:00',2.55),('8998','2014-03-19','11:45:00',2.55),('8998','2014-03-19','11:50:00',2.47),('8998','2014-03-19','11:55:00',2.46),('8998','2014-03-19','12:00:00',2.17),('8998','2014-03-19','12:05:00',2.29),('8998','2014-03-19','12:10:00',2.47),('8998','2014-03-19','12:15:00',2.5),('8998','2014-03-19','12:20:00',2.41),('8998','2014-03-19','12:25:00',2.24),('8998','2014-03-19','12:30:00',2.29),('8998','2014-03-19','12:35:00',2.32),('8998','2014-03-19','12:40:00',2.27),('8998','2014-03-19','12:45:00',2.33),('8998','2014-03-19','12:50:00',2.29),('8998','2014-03-19','12:55:00',2.24),('8998','2014-03-19','13:00:00',2.2),('8998','2014-03-19','13:05:00',2.16),('8998','2014-03-19','13:10:00',2.09),('8998','2014-03-19','13:15:00',2.06),('8998','2014-03-19','13:20:00',2.04),('8998','2014-03-19','13:25:00',1.96),('8998','2014-03-19','13:30:00',1.96),('8998','2014-03-19','13:35:00',1.89),('8998','2014-03-19','13:40:00',1.72),('8998','2014-03-19','13:45:00',1.64),('8998','2014-03-19','13:50:00',1.56),('8998','2014-03-19','13:55:00',1.49),('8998','2014-03-19','14:00:00',1.45),('8998','2014-03-19','14:05:00',1.55),('8998','2014-03-19','14:10:00',1.5),('8998','2014-03-19','14:15:00',1.43),('8998','2014-03-19','14:20:00',1.39),('8998','2014-03-19','14:25:00',1.38),('8998','2014-03-19','14:30:00',1.2),('8998','2014-03-19','14:35:00',1.03),('8998','2014-03-19','14:40:00',1.1),('8998','2014-03-19','14:45:00',1.08),('8998','2013-01-20','11:55:00',2.23),('8998','2013-01-20','12:00:00',1.83),('8998','2013-01-20','12:05:00',1.75),('8998','2013-01-20','12:10:00',1.81),('8998','2013-01-20','12:15:00',1.54),('8998','2013-01-20','13:05:00',1.19),('8998','2013-01-20','13:10:00',1.06),('8998','2013-01-20','13:30:00',1.26),('8998','2013-01-20','13:35:00',1.48),('8998','2013-01-20','13:40:00',1.03),('8998','2013-01-20','14:00:00',1.09),('8998','2013-01-20','14:05:00',1.12),('8998','2013-01-19','11:15:00',1.16),('8998','2013-01-19','11:30:00',1.53),('8998','2013-01-19','11:35:00',1.26),('8998','2013-01-18','09:15:00',1.13),('8998','2013-01-18','09:20:00',1.17),('8998','2013-01-18','09:55:00',1.15),('8998','2013-01-18','10:00:00',1.02),('8998','2013-01-18','10:50:00',1.02),('8998','2013-01-17','10:15:00',1.76),('8998','2013-01-17','10:20:00',1.81),('8998','2013-01-17','10:25:00',1.11),('8998','2013-01-17','12:45:00',1),('8998','2013-01-17','12:50:00',1.37),('8998','2013-01-17','12:55:00',1.34),('8998','2013-01-17','13:00:00',1.4),('8998','2013-01-17','13:05:00',1.27),('8998','2013-01-17','13:10:00',1.21),('8998','2013-01-17','13:15:00',1.41),('8998','2013-01-17','13:20:00',1.18),('8998','2013-01-17','13:25:00',1),('8998','2013-01-17','13:35:00',1.01),('8998','2013-01-17','13:40:00',1.22),('8998','2013-01-17','13:45:00',1.27),('8998','2013-01-17','13:50:00',1.42),('8998','2013-01-17','13:55:00',1.32),('8998','2013-01-17','14:00:00',1.1),('8998','2013-01-17','14:05:00',1.19),('8998','2013-01-17','14:10:00',1.12),('8998','2013-01-16','09:50:00',1.06),('8998','2013-01-16','10:25:00',1.18),('8998','2013-01-16','10:30:00',1.28),('8998','2013-01-16','10:35:00',1.15),('8998','2013-01-16','10:40:00',1.08),('8998','2013-01-16','10:45:00',1.17),('8998','2013-01-16','10:50:00',1.08),('8998','2013-01-16','10:55:00',1.27),('8998','2013-01-16','11:00:00',1.13),('8998','2013-01-16','11:05:00',1.11),('8998','2013-01-16','11:10:00',1.31),('8998','2013-01-16','11:15:00',1.27),('8998','2013-01-16','11:20:00',1.2),('8998','2013-01-16','11:25:00',1.05),('8998','2013-01-16','11:40:00',1.03),('8998','2013-01-16','11:55:00',1.05),('8998','2013-01-16','12:00:00',1.17),('8998','2013-01-16','12:05:00',1.15),('8998','2013-01-16','12:10:00',1.07),('8998','2013-01-16','12:15:00',1.27),('8998','2013-01-16','12:20:00',1.12),('8998','2013-01-16','12:25:00',1.05),('8998','2013-01-16','12:35:00',1.05),('8998','2013-01-16','12:40:00',1.14),('8998','2013-01-16','13:40:00',1.04),('8998','2013-01-16','13:45:00',1.08),('8998','2013-01-15','09:15:00',1.01),('8998','2013-01-15','09:25:00',1.46),('8998','2013-01-15','09:30:00',1.55),('8998','2013-01-15','09:35:00',1.6),('8998','2013-01-15','09:40:00',1.68),('8998','2013-01-15','10:35:00',1.34),('8998','2013-01-15','10:40:00',1.6),('8998','2013-01-15','10:45:00',1.73),('8998','2013-01-15','10:55:00',1.49),('8998','2013-01-15','11:25:00',1.04),('8998','2013-01-15','12:10:00',1.02),('8998','2013-01-15','12:15:00',2.09),('8998','2013-01-15','12:20:00',1.94),('8998','2013-01-15','13:10:00',1.98),('8998','2013-01-15','13:15:00',2.05),('8998','2013-01-15','13:20:00',1.52),('8998','2013-01-15','13:25:00',1.1),('8998','2013-01-15','14:00:00',1.15),('8998','2013-01-14','10:55:00',1.06),('8998','2013-01-14','11:00:00',1.01),('8998','2013-01-14','11:05:00',1.04),('8998','2013-01-14','11:10:00',1.06),('8998','2013-01-14','11:15:00',1),('8998','2013-01-14','11:20:00',1.05),('8998','2013-01-14','11:25:00',1.04),('8998','2013-01-14','14:20:00',1.06),('8998','2013-01-12','09:15:00',1.38),('8998','2013-01-12','09:20:00',1.5),('8998','2013-01-12','09:25:00',1.45),('8998','2013-01-12','09:30:00',1.5),('8998','2013-01-12','09:35:00',1.56),('8998','2013-01-12','09:40:00',1.09),('8998','2013-01-12','09:50:00',1.17),('8998','2013-01-12','09:55:00',1.45),('8998','2013-01-12','10:00:00',1.48),('8998','2013-01-12','10:05:00',1.53),('8998','2013-01-12','10:10:00',1.07),('8998','2013-01-12','10:20:00',1.07),('8998','2013-01-12','10:25:00',1.06),('8998','2013-01-12','10:30:00',1.32),('8998','2013-01-11','08:45:00',1.03),('8998','2013-01-11','08:50:00',1.07),('8998','2013-01-11','09:00:00',1.19),('8998','2013-01-11','09:05:00',1.25),('8998','2013-01-11','09:10:00',1.28),('8998','2013-01-11','09:15:00',1.3),('8998','2013-01-11','09:20:00',1.34),('8998','2013-01-11','09:25:00',1.38),('8998','2013-01-11','09:30:00',1.41),('8998','2013-01-11','09:35:00',1.43),('8998','2013-01-11','09:40:00',1.48),('8998','2013-01-11','09:45:00',1.5),('8998','2013-01-11','09:50:00',1.55),('8998','2013-01-11','09:55:00',1.57),('8998','2013-01-11','10:00:00',1.6),('8998','2013-01-11','10:05:00',1.63),('8998','2013-01-11','10:10:00',1.62),('8998','2013-01-11','10:15:00',1.61),('8998','2013-01-11','10:20:00',1.62),('8998','2013-01-11','10:25:00',1.65),('8998','2013-01-11','10:30:00',1.67),('8998','2013-01-11','10:35:00',1.67),('8998','2013-01-11','10:40:00',1.69),('8998','2013-01-11','10:45:00',1.69),('8998','2013-01-11','10:50:00',1.69),('8998','2013-01-11','10:55:00',1.68),('8998','2013-01-11','11:00:00',1.66),('8998','2013-01-11','11:05:00',1.7),('8998','2013-01-11','11:10:00',1.68),('8998','2013-01-11','11:15:00',1.67),('8998','2013-01-11','11:20:00',1.66),('8998','2013-01-11','11:25:00',1.67),('8998','2013-01-11','11:30:00',1.65),('8998','2013-01-11','11:35:00',1.64),('8998','2013-01-11','11:40:00',1.63),('8998','2013-01-11','11:45:00',1.62),('8998','2013-01-11','11:50:00',1.61),('8998','2013-01-11','11:55:00',1.6),('8998','2013-01-11','12:00:00',1.57),('8998','2013-01-11','12:05:00',1.55),('8998','2013-01-11','12:10:00',1.51),('8998','2013-01-11','12:15:00',1.5),('8998','2013-01-11','12:20:00',1.47),('8998','2013-01-11','12:25:00',1.43),('8998','2013-01-11','12:30:00',1.42),('8998','2013-01-11','12:35:00',1.16),('8998','2013-01-11','12:40:00',1.06),('8998','2013-01-11','12:50:00',1.01),('8998','2013-01-11','13:00:00',1.15),('8998','2013-01-11','13:05:00',1.18),('8998','2013-01-11','13:10:00',1.03),('8998','2014-03-18','09:10:00',1),('8998','2014-03-18','09:15:00',1.26),('8998','2014-03-18','09:20:00',1.37),('8998','2014-03-18','09:25:00',1.43),('8998','2014-03-18','09:30:00',2.28),('8998','2014-03-18','09:35:00',1.99),('8998','2014-03-18','09:40:00',2.62),('8998','2014-03-18','09:45:00',2.62),('8998','2014-03-18','09:50:00',2.29),('8998','2014-03-18','09:55:00',2.25),('8998','2014-03-18','10:00:00',1.26),('8998','2014-03-18','10:35:00',1.03),('8998','2014-03-18','10:40:00',1.68),('8998','2014-03-18','10:45:00',2.13),('8998','2014-03-18','10:50:00',2.3),('8998','2014-03-18','10:55:00',1.37),('8998','2014-03-18','11:00:00',1.15),('8998','2014-03-18','11:05:00',1.88),('8998','2014-03-18','11:10:00',1.45),('8998','2014-03-18','11:15:00',1.19),('8998','2014-03-18','11:20:00',1.28),('8998','2014-03-18','11:25:00',1.28),('8998','2014-03-18','11:30:00',1.64),('8998','2014-03-18','11:35:00',1.5),('8998','2014-03-18','11:40:00',1.18),('8998','2014-03-18','11:45:00',1.19),('8998','2014-03-18','11:50:00',1.12),('8998','2014-03-18','11:55:00',1.06),('8998','2014-03-18','12:00:00',1.4),('8998','2014-03-18','12:05:00',2.88),('8998','2014-03-18','12:10:00',2.84),('8998','2014-03-18','12:15:00',2.84),('8998','2014-03-18','12:20:00',2.17),('8998','2014-03-18','12:25:00',1.46),('8998','2014-03-18','12:30:00',1.39),('8998','2014-03-18','12:35:00',1.76),('8998','2014-03-18','12:40:00',2.7),('8998','2014-03-18','12:45:00',2.53),('8998','2014-03-18','12:50:00',1.88),('8998','2014-03-18','12:55:00',1.33),('8998','2014-03-18','13:00:00',1.97),('8998','2014-03-18','13:05:00',2.25),('8998','2014-03-18','13:10:00',2.28),('8998','2014-03-18','13:15:00',2.16),('8998','2014-03-18','13:20:00',1.95),('8998','2014-03-18','13:25:00',1.85),('8998','2014-03-18','13:30:00',2),('8998','2014-03-18','13:35:00',1.98),('8998','2014-03-18','13:40:00',1.91),('8998','2014-03-18','13:45:00',1.85),('8998','2014-03-18','13:50:00',1.78),('8998','2014-03-18','13:55:00',1.77),('8998','2014-03-18','14:00:00',1.7),('8998','2014-03-18','14:05:00',1.67),('8998','2014-03-18','14:10:00',1.63),('8998','2014-03-18','14:15:00',1.59),('8998','2014-03-18','14:20:00',1.5),('8998','2014-03-18','14:25:00',1.44),('8998','2014-03-18','14:30:00',1.36),('8998','2014-03-18','14:35:00',1.33),('8998','2014-03-18','14:40:00',1.25),('8998','2014-03-18','14:45:00',1.17),('8998','2014-03-18','14:50:00',1.13),('8998','2014-03-18','14:55:00',1.07),('8998','2014-03-18','15:00:00',1.03),('8998','2013-01-10','10:05:00',1.07),('8998','2013-01-10','10:10:00',1.12),('8998','2013-01-10','10:15:00',1.39),('8998','2013-01-10','10:25:00',1.71),('8998','2013-01-10','10:30:00',1.65),('8998','2013-01-10','10:35:00',1.65),('8998','2013-01-10','10:40:00',1.64),('8998','2013-01-10','10:45:00',1.65),('8998','2013-01-10','10:50:00',1.66),('8998','2013-01-10','10:55:00',1.65),('8998','2013-01-10','11:00:00',1.67),('8998','2013-01-10','11:05:00',1.66),('8998','2013-01-10','11:10:00',1.64),('8998','2013-01-10','11:15:00',1.6),('8998','2013-01-10','11:20:00',1.59),('8998','2013-01-10','11:25:00',1.19),('8998','2013-01-10','11:35:00',1.04),('8998','2013-01-10','11:45:00',1.05),('8998','2013-01-08','11:15:00',1.38),('8998','2013-01-08','11:20:00',1.15),('8998','2013-01-08','13:10:00',1.18),('8998','2013-01-07','08:40:00',1.16),('8998','2013-01-07','08:45:00',1.23),('8998','2013-01-07','08:50:00',1.24),('8998','2013-01-07','08:55:00',1.08),('8998','2013-01-07','09:00:00',1.42),('8998','2013-01-07','09:05:00',1.39),('8998','2013-01-07','09:15:00',1.11),('8998','2013-01-07','09:20:00',1.35),('8998','2013-01-07','09:25:00',1.42),('8998','2013-01-07','09:30:00',1.23),('8998','2013-01-07','09:40:00',1.42),('8998','2013-01-07','09:45:00',1.63),('8998','2013-01-07','09:50:00',1.68),('8998','2013-01-07','09:55:00',1.61),('8998','2013-01-07','10:00:00',1.44),('8998','2013-01-07','10:05:00',1.41),('8998','2013-01-07','10:10:00',1.45),('8998','2013-01-07','10:15:00',1.48),('8998','2013-01-07','10:20:00',1.39),('8998','2013-01-07','10:25:00',1.5),('8998','2013-01-07','10:30:00',1.5),('8998','2013-01-07','10:35:00',1.64),('8998','2013-01-07','10:40:00',1.75),('8998','2013-01-07','10:45:00',1.68),('8998','2013-01-07','10:50:00',1.71),('8998','2013-01-07','10:55:00',1.72),('8998','2013-01-07','11:00:00',1.65),('8998','2013-01-07','11:05:00',1.69),('8998','2013-01-07','11:10:00',1.67),('8998','2013-01-07','11:15:00',1.66),('8998','2013-01-07','11:20:00',1.65),('8998','2013-01-07','11:25:00',1.65),('8998','2013-01-07','11:30:00',1.66),('8998','2013-01-07','11:35:00',1.65),('8998','2013-01-07','11:40:00',1.62),('8998','2013-01-07','11:45:00',2),('8998','2013-01-07','11:50:00',1.52),('8998','2013-01-07','11:55:00',1.17),('8998','2013-01-07','12:00:00',1.04),('8998','2013-01-07','12:10:00',1.02),('8998','2013-01-07','12:50:00',1.15),('8998','2013-01-06','08:55:00',1.08),('8998','2013-01-06','09:10:00',1.08),('8998','2013-01-06','09:20:00',1.23),('8998','2013-01-06','09:25:00',1.32),('8998','2013-01-06','09:30:00',1.35),('8998','2013-01-06','09:35:00',1.37),('8998','2013-01-06','09:40:00',1.38),('8998','2013-01-06','09:45:00',1.45),('8998','2013-01-06','09:50:00',1.46),('8998','2013-01-06','09:55:00',1.51),('8998','2013-01-06','10:00:00',1.54),('8998','2013-01-06','10:05:00',1.59),('8998','2013-01-06','10:10:00',1.64),('8998','2013-01-06','10:15:00',1.66),('8998','2013-01-06','10:20:00',1.64),('8998','2013-01-06','10:25:00',1.68),('8998','2013-01-06','10:30:00',1.66),('8998','2013-01-06','10:35:00',1.67),('8998','2013-01-06','10:40:00',1.69),('8998','2013-01-06','10:45:00',1.68),('8998','2013-01-06','10:50:00',1.66),('8998','2013-01-06','10:55:00',1.62),('8998','2013-01-06','11:00:00',1.63),('8998','2013-01-06','11:05:00',1.6),('8998','2013-01-06','11:10:00',1.62),('8998','2013-01-06','11:15:00',1.64),('8998','2013-01-06','11:20:00',1.62),('8998','2013-01-06','11:25:00',1.62),('8998','2013-01-06','11:30:00',1.61),('8998','2013-01-06','11:35:00',1.59),('8998','2013-01-06','11:40:00',1.58),('8998','2013-01-06','11:45:00',1.56),('8998','2013-01-06','11:50:00',1.56),('8998','2013-01-06','11:55:00',1.55),('8998','2013-01-06','12:00:00',1.53),('8998','2013-01-06','12:05:00',1.51),('8998','2013-01-06','12:10:00',1.49),('8998','2013-01-06','12:15:00',1.47),('8998','2013-01-06','12:20:00',1.44),('8998','2013-01-06','12:25:00',1.42),('8998','2013-01-06','12:30:00',1.39),('8998','2013-01-06','12:35:00',1.35),('8998','2013-01-06','12:40:00',1.33),('8998','2013-01-06','12:45:00',1.31),('8998','2013-01-06','12:50:00',1.26),('8998','2013-01-06','12:55:00',1.23),('8998','2013-01-06','13:00:00',1.18),('8998','2013-01-06','13:05:00',1.09),('8998','2013-01-05','08:45:00',1.02),('8998','2013-01-05','08:50:00',1.07),('8998','2013-01-05','08:55:00',1.14),('8998','2013-01-05','09:05:00',1.25),('8998','2013-01-05','09:10:00',1.29),('8998','2013-01-05','09:15:00',1.33),('8998','2013-01-05','09:20:00',1.36),('8998','2013-01-05','09:25:00',1.39),('8998','2013-01-05','09:30:00',1.43),('8998','2013-01-05','09:35:00',1.46),('8998','2013-01-05','09:40:00',1.49),('8998','2013-01-05','09:45:00',1.51),('8998','2013-01-05','09:50:00',1.54),('8998','2013-01-05','09:55:00',1.54),('8998','2013-01-05','10:00:00',1.57),('8998','2013-01-05','10:05:00',1.57),('8998','2013-01-05','10:10:00',1.6),('8998','2013-01-05','10:15:00',1.62),('8998','2013-01-05','10:20:00',1.6),('8998','2013-01-05','10:25:00',1.64),('8998','2013-01-05','10:30:00',1.65),('8998','2013-01-05','10:35:00',1.66),('8998','2013-01-05','10:40:00',1.67),('8998','2013-01-05','10:45:00',1.67),('8998','2013-01-05','10:50:00',1.68),('8998','2013-01-05','10:55:00',1.67),('8998','2013-01-05','11:00:00',1.66),('8998','2013-01-05','11:05:00',1.66),('8998','2013-01-05','11:10:00',1.66),('8998','2013-01-05','11:15:00',1.64),('8998','2013-01-05','11:20:00',1.64),('8998','2013-01-05','11:25:00',1.64),('8998','2013-01-05','11:30:00',1.63),('8998','2013-01-05','11:35:00',1.61),('8998','2013-01-05','11:40:00',1.59),('8998','2013-01-05','11:45:00',1.58),('8998','2013-01-05','11:50:00',1.57),('8998','2013-01-05','11:55:00',1.55),('8998','2013-01-05','12:00:00',1.54),('8998','2013-01-05','12:05:00',1.53),('8998','2013-01-05','12:10:00',1.5),('8998','2013-01-05','12:15:00',1.47),('8998','2013-01-05','12:20:00',1.44),('8998','2013-01-05','12:25:00',1.39),('8998','2013-01-05','12:30:00',1.38),('8998','2013-01-05','12:35:00',1.34),('8998','2013-01-05','12:40:00',1.31),('8998','2013-01-05','12:45:00',1.28),('8998','2013-01-05','12:50:00',1.26),('8998','2013-01-05','12:55:00',1.22),('8998','2013-01-05','13:00:00',1.17),('8998','2013-01-05','13:05:00',1.12),('8998','2013-01-05','13:10:00',1.08),('8998','2013-01-05','13:15:00',1.01),('8998','2013-01-04','10:55:00',1.5),('8998','2013-01-04','11:00:00',1.26),('8998','2013-01-04','11:05:00',1.51),('8998','2013-01-04','11:10:00',1.44),('8998','2013-01-04','11:15:00',1.23),('8998','2013-01-04','11:20:00',1.59),('8998','2013-01-04','11:25:00',1.65),('8998','2013-01-04','11:30:00',1.65),('8998','2013-01-04','11:35:00',1.51),('8998','2013-01-04','11:40:00',1.36),('8998','2013-01-04','11:45:00',1.35),('8998','2013-01-04','11:50:00',1.19),('8998','2013-01-04','11:55:00',1.07),('8998','2013-01-04','12:00:00',1.01),('8998','2013-01-04','12:35:00',1.04),('8998','2013-01-04','12:40:00',1.22),('8998','2013-01-04','12:45:00',1.33),('8998','2013-01-03','08:50:00',1.04),('8998','2013-01-03','09:05:00',1.13),('8998','2013-01-03','09:10:00',1.18),('8998','2013-01-03','09:20:00',1.16),('8998','2013-01-03','09:25:00',1.07),('8998','2013-01-03','09:30:00',1.03),('8998','2013-01-03','09:40:00',1.04),('8998','2013-01-03','09:45:00',1.02),('8998','2013-01-03','09:50:00',1.06),('8998','2013-01-03','09:55:00',1.41),('8998','2013-01-03','10:00:00',1.63),('8998','2013-01-03','10:05:00',1.65),('8998','2013-01-03','10:10:00',1.37),('8998','2013-01-03','10:15:00',1.62),('8998','2013-01-03','10:20:00',1.3),('8998','2013-01-03','10:25:00',1.63),('8998','2013-01-03','10:30:00',1.68),('8998','2013-01-03','10:35:00',1.7),('8998','2013-01-03','10:40:00',1.74),('8998','2013-01-03','10:45:00',1.81),('8998','2013-01-03','10:50:00',1.88),('8998','2013-01-03','10:55:00',1.88),('8998','2013-01-03','11:00:00',1.62),('8998','2013-01-03','11:45:00',1.07),('8998','2013-01-03','11:50:00',1.57),('8998','2013-01-03','11:55:00',1.8),('8998','2013-01-03','12:00:00',1.79),('8998','2013-01-03','12:05:00',1.53),('8998','2013-01-03','12:10:00',1.22),('8998','2013-01-03','12:30:00',1.04),('8998','2013-01-03','12:40:00',1.31),('8998','2013-01-03','12:45:00',1.38),('8998','2013-01-03','12:50:00',1.37),('8998','2013-01-03','12:55:00',1.31),('8998','2013-01-03','13:00:00',1.17),('8998','2013-01-03','13:05:00',1),('8998','2013-01-02','08:50:00',1.02),('8998','2013-01-02','08:55:00',1.05),('8998','2013-01-02','09:05:00',1.2),('8998','2013-01-02','09:10:00',1.25),('8998','2013-01-02','09:15:00',1.3),('8998','2013-01-02','09:20:00',1.34),('8998','2013-01-02','09:25:00',1.38),('8998','2013-01-02','09:30:00',1.42),('8998','2013-01-02','09:35:00',1.46),('8998','2013-01-02','09:40:00',1.54),('8998','2013-01-02','09:45:00',1.65),('8998','2013-01-02','09:50:00',1.75),('8998','2013-01-02','09:55:00',1.83),('8998','2013-01-02','10:00:00',1.9),('8998','2013-01-02','10:05:00',1.82),('8998','2013-01-02','10:10:00',1.9),('8998','2013-01-02','10:15:00',2.04),('8998','2013-01-02','10:20:00',1.57),('8998','2013-01-02','10:25:00',1.52),('8998','2013-01-02','10:30:00',1.38),('8998','2013-01-02','10:35:00',1.46),('8998','2013-01-02','10:40:00',1.3),('8998','2013-01-02','10:45:00',1.18),('8998','2013-01-02','10:50:00',1.12),('8998','2013-01-02','10:55:00',1.04),('8998','2013-01-02','11:00:00',1.12),('8998','2013-01-02','11:05:00',1.06),('8998','2013-01-02','11:35:00',1.46),('8998','2013-01-02','11:40:00',1.68),('8998','2013-01-02','11:45:00',1.65),('8998','2013-01-02','11:50:00',1.6),('8998','2013-01-02','11:55:00',1.56),('8998','2013-01-02','12:00:00',1.53),('8998','2013-01-02','12:05:00',1.51),('8998','2013-01-02','12:10:00',1.48),('8998','2013-01-02','12:15:00',1.45),('8998','2013-01-02','12:20:00',1.43),('8998','2013-01-02','12:25:00',1.41),('8998','2013-01-02','12:30:00',1.38),('8998','2013-01-02','12:35:00',1.36),('8998','2013-01-02','12:40:00',1.32),('8998','2013-01-02','12:45:00',1.29),('8998','2013-01-02','12:50:00',1.24),('8998','2013-01-02','12:55:00',1.2),('8998','2013-01-02','13:00:00',1.14),('8998','2013-01-02','13:05:00',1.1),('8998','2013-01-02','13:10:00',1.05),('8998','2014-03-17','07:55:00',1.09),('8998','2014-03-17','08:00:00',1.13),('8998','2014-03-17','08:55:00',1.87),('8998','2014-03-17','09:00:00',2.11),('8998','2014-03-17','09:05:00',1.54),('8998','2014-03-17','09:10:00',1.13),('8998','2014-03-17','09:15:00',1.57),('8998','2014-03-17','09:20:00',2.2),('8998','2014-03-17','09:25:00',2.75),('8998','2014-03-17','09:30:00',1.7),('8998','2014-03-17','09:35:00',1.59),('8998','2014-03-17','09:40:00',2.06),('8998','2014-03-17','09:45:00',1.45),('8998','2014-03-17','09:50:00',1.9),('8998','2014-03-17','09:55:00',1.15),('8998','2014-03-17','10:00:00',1.48),('8998','2014-03-17','10:05:00',2.33),('8998','2014-03-17','10:10:00',1.62),('8998','2014-03-17','10:15:00',2.86),('8998','2014-03-17','10:20:00',2.61),('8998','2014-03-17','10:25:00',2.68),('8998','2014-03-17','10:30:00',2.14),('8998','2014-03-17','10:35:00',2.73),('8998','2014-03-17','10:40:00',2.34),('8998','2014-03-17','10:45:00',2.2),('8998','2014-03-17','10:50:00',1.53),('8998','2014-03-17','10:55:00',1.31),('8998','2014-03-17','11:00:00',2.89),('8998','2014-03-17','11:05:00',2.24),('8998','2014-03-17','11:10:00',1.55),('8998','2014-03-17','11:15:00',1.72),('8998','2014-03-17','11:25:00',1.07),('8998','2014-03-17','11:30:00',1.26),('8998','2014-03-17','11:35:00',1.66),('8998','2014-03-17','11:40:00',1.86),('8998','2014-03-17','11:45:00',2.18),('8998','2014-03-17','11:50:00',1.76),('8998','2014-03-17','11:55:00',1.22),('8998','2014-03-17','12:00:00',1.13),('8998','2014-03-17','12:05:00',1.19),('8998','2014-03-17','12:10:00',1.31),('8998','2014-03-17','12:15:00',1.6),('8998','2014-03-17','12:20:00',2.22),('8998','2014-03-17','12:25:00',1.85),('8998','2014-03-17','12:30:00',1.7),('8998','2014-03-17','12:35:00',2.59),('8998','2014-03-17','12:40:00',1.99),('8998','2014-03-17','12:45:00',2.21),('8998','2014-03-17','12:50:00',1.52),('8998','2014-03-17','12:55:00',2.16),('8998','2014-03-17','13:00:00',2.02),('8998','2014-03-17','13:05:00',2.32),('8998','2014-03-17','13:10:00',2.29),('8998','2014-03-17','13:15:00',2.2),('8998','2014-03-17','13:20:00',2.14),('8998','2014-03-17','13:25:00',1.95),('8998','2014-03-17','13:30:00',1.97),('8998','2014-03-17','13:35:00',1.96),('8998','2014-03-17','13:40:00',1.92),('8998','2014-03-17','13:45:00',1.84),('8998','2014-03-17','13:50:00',1.78),('8998','2014-03-17','13:55:00',1.76),('8998','2014-03-17','14:00:00',1.74),('8998','2014-03-17','14:05:00',1.68),('8998','2014-03-17','14:10:00',1.62),('8998','2014-03-17','14:15:00',1.57),('8998','2014-03-17','14:20:00',1.52),('8998','2014-03-17','14:25:00',1.46),('8998','2014-03-17','14:30:00',1.38),('8998','2014-03-17','14:35:00',1.31),('8998','2014-03-17','14:40:00',1.22),('8998','2014-03-17','14:45:00',1.18),('8998','2014-03-17','14:50:00',1.1),('8998','2014-03-17','14:55:00',1.04),('8998','2012-12-31','09:00:00',1.06),('8998','2012-12-31','09:05:00',1.16),('8998','2012-12-31','09:10:00',1.2),('8998','2012-12-31','09:15:00',1.23),('8998','2012-12-31','09:20:00',1.26),('8998','2012-12-31','09:25:00',1.29),('8998','2012-12-31','09:30:00',1.32),('8998','2012-12-31','09:35:00',1.35),('8998','2012-12-31','09:40:00',1.37),('8998','2012-12-31','09:45:00',1.4),('8998','2012-12-31','09:50:00',1.43),('8998','2012-12-31','09:55:00',1.45),('8998','2012-12-31','10:00:00',1.45),('8998','2012-12-31','10:05:00',1.47),('8998','2012-12-31','10:10:00',1.49),('8998','2012-12-31','10:15:00',1.51),('8998','2012-12-31','10:20:00',1.53),('8998','2012-12-31','10:25:00',1.54),('8998','2012-12-31','10:30:00',1.55),('8998','2012-12-31','10:35:00',1.56),('8998','2012-12-31','10:40:00',1.58),('8998','2012-12-31','10:45:00',1.48),('8998','2012-12-31','10:50:00',1.45),('8998','2012-12-31','11:05:00',1.63),('8998','2012-12-31','11:10:00',1.7),('8998','2012-12-31','11:15:00',1.69),('8998','2012-12-31','11:20:00',1.23),('8998','2012-12-31','11:25:00',1.48),('8998','2012-12-31','11:30:00',1.89),('8998','2012-12-31','11:45:00',1.41),('8998','2012-12-31','11:50:00',1.52),('8998','2012-12-31','11:55:00',1.45),('8998','2012-12-30','09:15:00',1.14),('8998','2012-12-30','09:20:00',1.4),('8998','2012-12-30','09:25:00',1.51),('8998','2012-12-30','09:30:00',1.29),('8998','2012-12-30','10:10:00',1.3),('8998','2012-12-30','10:15:00',1.74),('8998','2012-12-30','10:20:00',1.75),('8998','2012-12-30','10:25:00',1.72),('8998','2012-12-30','10:30:00',1.72),('8998','2012-12-30','10:35:00',1.72),('8998','2012-12-30','10:40:00',1.72),('8998','2012-12-30','10:45:00',1.68),('8998','2012-12-30','10:50:00',1.65),('8998','2012-12-30','10:55:00',1.66),('8998','2012-12-30','11:00:00',1.67),('8998','2012-12-30','11:05:00',1.66),('8998','2012-12-30','11:10:00',1.6),('8998','2012-12-30','11:15:00',1.58),('8998','2012-12-30','11:20:00',1.63),('8998','2012-12-30','11:25:00',1.64),('8998','2012-12-30','11:30:00',1.63),('8998','2012-12-30','11:35:00',1.63),('8998','2012-12-30','11:40:00',1.62),('8998','2012-12-30','11:45:00',1.59),('8998','2012-12-30','11:50:00',1.58),('8998','2012-12-30','11:55:00',1.56),('8998','2012-12-30','12:00:00',1.56),('8998','2012-12-30','12:05:00',1.55),('8998','2012-12-30','12:10:00',1.53),('8998','2012-12-30','12:15:00',1.5),('8998','2012-12-30','12:20:00',1.47),('8998','2012-12-30','12:25:00',1.44),('8998','2012-12-30','12:30:00',1.41),('8998','2012-12-30','12:35:00',1.38),('8998','2012-12-30','12:40:00',1.34),('8998','2012-12-30','12:45:00',1.31),('8998','2012-12-30','12:50:00',1.26),('8998','2012-12-30','12:55:00',1.19),('8998','2012-12-30','13:00:00',1.13),('8998','2012-12-30','13:05:00',1.07),('8998','2012-12-29','08:45:00',1.01),('8998','2012-12-29','08:50:00',1.06),('8998','2012-12-29','09:00:00',1.17),('8998','2012-12-29','09:05:00',1.22),('8998','2012-12-29','09:10:00',1.26),('8998','2012-12-29','09:15:00',1.3),('8998','2012-12-29','09:20:00',1.34),('8998','2012-12-29','09:25:00',1.38),('8998','2012-12-29','09:30:00',1.4),('8998','2012-12-29','09:35:00',1.44),('8998','2012-12-29','09:40:00',1.46),('8998','2012-12-29','09:45:00',1.48),('8998','2012-12-29','09:50:00',1.49),('8998','2012-12-29','09:55:00',1.51),('8998','2012-12-29','10:00:00',1.55),('8998','2012-12-29','10:05:00',1.57),('8998','2012-12-29','10:10:00',1.59),('8998','2012-12-29','10:15:00',1.61),('8998','2012-12-29','10:20:00',1.63),('8998','2012-12-29','10:25:00',1.63),('8998','2012-12-29','10:30:00',1.65),('8998','2012-12-29','10:35:00',1.66),('8998','2012-12-29','10:40:00',1.66),('8998','2012-12-29','10:45:00',1.66),('8998','2012-12-29','10:50:00',1.66),('8998','2012-12-29','10:55:00',1.66),('8998','2012-12-29','11:00:00',1.65),('8998','2012-12-29','11:05:00',1.65),('8998','2012-12-29','11:10:00',1.66),('8998','2012-12-29','11:15:00',1.65),('8998','2012-12-29','11:20:00',1.64),('8998','2012-12-29','11:25:00',1.62),('8998','2012-12-29','11:30:00',1.62),('8998','2012-12-29','11:35:00',1.61),('8998','2012-12-29','11:40:00',1.58),('8998','2012-12-29','11:45:00',1.58),('8998','2012-12-29','11:50:00',1.56),('8998','2012-12-29','11:55:00',1.54),('8998','2012-12-29','12:00:00',1.51),('8998','2012-12-29','12:05:00',1.49),('8998','2012-12-29','12:10:00',1.47),('8998','2012-12-29','12:15:00',1.45),('8998','2012-12-29','12:20:00',1.42),('8998','2012-12-29','12:25:00',1.4),('8998','2012-12-29','12:30:00',1.37),('8998','2012-12-29','12:35:00',1.33),('8998','2012-12-29','12:40:00',1.3),('8998','2012-12-29','12:45:00',1.25),('8998','2012-12-29','12:50:00',1.2),('8998','2012-12-29','12:55:00',1.15),('8998','2012-12-29','13:00:00',1.12),('8998','2012-12-29','13:05:00',1.08),('8998','2012-12-29','13:10:00',1.04),('8998','2012-12-28','08:45:00',1.07),('8998','2012-12-28','08:50:00',1.12),('8998','2012-12-28','08:55:00',1.16),('8998','2012-12-28','09:00:00',1.03),('8998','2012-12-28','09:05:00',1.24),('8998','2012-12-28','09:10:00',1.29),('8998','2012-12-28','09:15:00',1.33),('8998','2012-12-28','09:20:00',1.36),('8998','2012-12-28','09:25:00',1.39),('8998','2012-12-28','09:30:00',1.41),('8998','2012-12-28','09:35:00',1.44),('8998','2012-12-28','09:40:00',1.47),('8998','2012-12-28','09:45:00',1.51),('8998','2012-12-28','09:50:00',1.55),('8998','2012-12-28','09:55:00',1.57),('8998','2012-12-28','10:00:00',1.6),('8998','2012-12-28','10:05:00',1.62),('8998','2012-12-28','10:10:00',1.63),('8998','2012-12-28','10:15:00',1.65),('8998','2012-12-28','10:20:00',1.66),('8998','2012-12-28','10:25:00',1.68),('8998','2012-12-28','10:30:00',1.69),('8998','2012-12-28','10:35:00',1.69),('8998','2012-12-28','10:40:00',1.7),('8998','2012-12-28','10:45:00',1.7),('8998','2012-12-28','10:50:00',1.71),('8998','2012-12-28','10:55:00',1.71),('8998','2012-12-28','11:00:00',1.7),('8998','2012-12-28','11:05:00',1.7),('8998','2012-12-28','11:10:00',1.69),('8998','2012-12-28','11:15:00',1.69),('8998','2012-12-28','11:20:00',1.68),('8998','2012-12-28','11:25:00',1.67),('8998','2012-12-28','11:30:00',1.65),('8998','2012-12-28','11:35:00',1.64),('8998','2012-12-28','11:40:00',1.61),('8998','2012-12-28','11:45:00',1.6),('8998','2012-12-28','11:50:00',1.58),('8998','2012-12-28','11:55:00',1.56),('8998','2012-12-28','12:00:00',1.55),('8998','2012-12-28','12:05:00',1.53),('8998','2012-12-28','12:10:00',1.52),('8998','2012-12-28','12:15:00',1.47),('8998','2012-12-28','12:20:00',1.44),('8998','2012-12-28','12:25:00',1.4),('8998','2012-12-28','12:30:00',1.37),('8998','2012-12-28','12:35:00',1.36),('8998','2012-12-28','12:40:00',1.34),('8998','2012-12-28','12:45:00',1.28),('8998','2012-12-28','12:50:00',1.22),('8998','2012-12-28','12:55:00',1.16),('8998','2012-12-28','13:00:00',1.13),('8998','2012-12-28','13:05:00',1.08),('8998','2012-12-28','13:10:00',1.04),('8998','2012-12-27','08:55:00',1.03),('8998','2012-12-27','09:00:00',1.09),('8998','2012-12-27','09:10:00',1.17),('8998','2012-12-27','09:15:00',1.22),('8998','2012-12-27','09:20:00',1.24),('8998','2012-12-27','09:25:00',1.25),('8998','2012-12-27','09:30:00',1.29),('8998','2012-12-27','09:35:00',1.32),('8998','2012-12-27','09:40:00',1.35),('8998','2012-12-27','09:45:00',1.38),('8998','2012-12-27','09:50:00',1.33),('8998','2012-12-27','09:55:00',1.41),('8998','2012-12-27','10:00:00',1.43),('8998','2012-12-27','10:05:00',1.46),('8998','2012-12-27','10:10:00',1.49),('8998','2012-12-27','10:15:00',1.54),('8998','2012-12-27','10:20:00',1.54),('8998','2012-12-27','10:25:00',1.56),('8998','2012-12-27','10:30:00',1.59),('8998','2012-12-27','10:35:00',1.6),('8998','2012-12-27','10:40:00',1.58),('8998','2012-12-27','10:45:00',1.6),('8998','2012-12-27','10:50:00',1.6),('8998','2012-12-27','10:55:00',1.6),('8998','2012-12-27','11:00:00',1.6),('8998','2012-12-27','11:05:00',1.63),('8998','2012-12-27','11:10:00',1.56),('8998','2012-12-27','11:15:00',1.36),('8998','2012-12-27','11:20:00',1.59),('8998','2012-12-27','11:25:00',1.59),('8998','2012-12-27','11:30:00',1.58),('8998','2012-12-27','11:35:00',1.58),('8998','2012-12-27','11:40:00',1.57),('8998','2012-12-27','11:45:00',1.57),('8998','2012-12-27','11:50:00',1.49),('8998','2012-12-27','11:55:00',1.53),('8998','2012-12-27','12:00:00',1.5),('8998','2012-12-27','12:05:00',1.49),('8998','2012-12-27','12:10:00',1.46),('8998','2012-12-27','12:15:00',1.43),('8998','2012-12-27','12:20:00',1.39),('8998','2012-12-27','12:25:00',1.36),('8998','2012-12-27','12:30:00',1.33),('8998','2012-12-27','12:35:00',1.29),('8998','2012-12-27','12:40:00',1.09),('8998','2012-12-27','12:45:00',1.24),('8998','2012-12-27','12:50:00',1.23),('8998','2012-12-27','12:55:00',1.08),('8998','2012-12-26','09:35:00',1.22),('8998','2012-12-26','09:40:00',1.44),('8998','2012-12-26','09:45:00',1.46),('8998','2012-12-26','09:50:00',1.48),('8998','2012-12-26','09:55:00',1.03),('8998','2012-12-26','10:15:00',1.23),('8998','2012-12-26','10:20:00',1.46),('8998','2012-12-26','10:25:00',1.47),('8998','2012-12-26','10:30:00',1.43),('8998','2012-12-26','10:35:00',1.48),('8998','2012-12-26','10:40:00',1.49),('8998','2012-12-26','10:45:00',1.5),('8998','2012-12-26','10:50:00',1.5),('8998','2012-12-26','10:55:00',1.43),('8998','2012-12-26','11:00:00',1.42),('8998','2012-12-26','11:05:00',1.27),('8998','2012-12-26','11:55:00',1.41),('8998','2012-12-26','12:00:00',1.47),('8998','2012-12-26','12:05:00',1.56),('8998','2012-12-26','12:10:00',1.65),('8998','2012-12-26','12:15:00',1.51),('8998','2012-12-26','12:25:00',1.28),('8998','2012-12-26','12:30:00',1.35),('8998','2012-12-26','12:35:00',1.35),('8998','2012-12-26','12:40:00',1.3),('8998','2012-12-26','12:45:00',1.34),('8998','2012-12-26','12:55:00',1.18),('8998','2012-12-26','13:00:00',1.18),('8998','2012-12-25','09:15:00',1.04),('8998','2012-12-25','09:20:00',1.31),('8998','2012-12-25','09:25:00',1.33),('8998','2012-12-25','09:30:00',1.34),('8998','2012-12-25','09:35:00',1.35),('8998','2012-12-25','09:40:00',1.39),('8998','2012-12-25','09:45:00',1.4),('8998','2012-12-25','09:50:00',1.43),('8998','2012-12-25','09:55:00',1.46),('8998','2012-12-25','10:00:00',1.48),('8998','2012-12-25','10:05:00',1.49),('8998','2012-12-25','10:10:00',1.51),('8998','2012-12-25','10:15:00',1.51),('8998','2012-12-25','10:20:00',1.52),('8998','2012-12-25','10:25:00',1.52),('8998','2012-12-25','10:30:00',1.52),('8998','2012-12-25','10:35:00',1.53),('8998','2012-12-25','10:40:00',1.53),('8998','2012-12-25','10:45:00',1.52),('8998','2012-12-25','10:50:00',1.51),('8998','2012-12-25','10:55:00',1.52),('8998','2012-12-25','11:00:00',1.51),('8998','2012-12-25','11:05:00',1.52),('8998','2012-12-25','11:10:00',1.51),('8998','2012-12-25','11:15:00',1.5),('8998','2012-12-25','11:20:00',1.49),('8998','2012-12-25','11:25:00',1.49),('8998','2012-12-25','11:30:00',1.46),('8998','2012-12-25','11:35:00',1.45),('8998','2012-12-25','11:40:00',1.45),('8998','2012-12-25','11:45:00',1.44),('8998','2012-12-25','11:50:00',1.43),('8998','2012-12-25','11:55:00',1.44),('8998','2012-12-25','12:00:00',1.46),('8998','2012-12-25','12:05:00',1.46),('8998','2012-12-25','12:10:00',1.42),('8998','2012-12-25','12:15:00',1.42),('8998','2012-12-25','12:20:00',1.41),('8998','2012-12-25','12:25:00',1.41),('8998','2012-12-25','12:30:00',1.37),('8998','2012-12-25','12:35:00',1.33),('8998','2012-12-25','12:40:00',1.34),('8998','2012-12-25','12:45:00',1.29),('8998','2012-12-25','12:50:00',1.2),('8998','2012-12-25','12:55:00',1.15),('8998','2012-12-25','13:00:00',1.15),('8998','2012-12-25','13:05:00',1.09),('8998','2012-12-25','13:10:00',1.08),('8998','2012-12-25','13:15:00',1.03),('8998','2012-12-25','13:20:00',1.05),('8998','2012-12-25','13:25:00',1.05),('8998','2012-12-25','13:30:00',1.17),('8998','2012-12-25','13:35:00',1.09),('8998','2012-12-25','13:40:00',1.03),('8998','2012-12-22','08:45:00',1.03),('8998','2012-12-22','08:50:00',1.07),('8998','2012-12-22','09:00:00',1.21),('8998','2012-12-22','09:05:00',1.26),('8998','2012-12-22','09:10:00',1.28),('8998','2012-12-22','09:15:00',1.28),('8998','2012-12-22','09:20:00',1.31),('8998','2012-12-22','09:25:00',1.36),('8998','2012-12-22','09:30:00',1.35),('8998','2012-12-22','09:35:00',1.4),('8998','2012-12-22','09:40:00',1.42),('8998','2012-12-22','09:45:00',1.44),('8998','2012-12-22','09:50:00',1.45),('8998','2012-12-22','09:55:00',1.45),('8998','2012-12-22','10:00:00',1.46),('8998','2012-12-22','10:05:00',1.5),('8998','2012-12-22','10:10:00',1.51),('8998','2012-12-22','10:15:00',1.52),('8998','2012-12-22','10:20:00',1.54),('8998','2012-12-22','10:25:00',1.54),('8998','2012-12-22','10:30:00',1.52),('8998','2012-12-22','10:35:00',1.56),('8998','2012-12-22','10:40:00',1.56),('8998','2012-12-22','10:45:00',1.58),('8998','2012-12-22','10:50:00',1.56),('8998','2012-12-22','10:55:00',1.46),('8998','2012-12-22','11:00:00',1.56),('8998','2012-12-22','11:05:00',1.55),('8998','2012-12-22','11:10:00',1.54),('8998','2012-12-22','11:15:00',1.54),('8998','2012-12-22','11:20:00',1.57),('8998','2012-12-22','11:25:00',1.41),('8998','2012-12-22','11:30:00',1.48),('8998','2012-12-22','11:35:00',1.55),('8998','2012-12-22','11:40:00',1.53),('8998','2012-12-22','11:45:00',1.5),('8998','2012-12-22','11:50:00',1.53),('8998','2012-12-22','11:55:00',1.41),('8998','2012-12-22','12:00:00',1.31),('8998','2012-12-22','12:05:00',1.31),('8998','2012-12-22','12:10:00',1.3),('8998','2012-12-22','12:15:00',1.05),('8998','2012-12-22','12:55:00',1.05),('8998','2012-12-22','13:00:00',1.07),('8998','2012-12-22','13:10:00',1.07),('8998','2014-04-30','07:45:00',1.09),('8998','2014-04-30','07:50:00',1.31),('8998','2014-04-30','07:55:00',1.42),('8998','2014-04-30','08:00:00',1.23),('8998','2014-04-30','08:05:00',1.57),('8998','2014-04-30','08:10:00',1.69),('8998','2014-04-30','08:15:00',1.69),('8998','2014-04-30','08:20:00',1.3),('8998','2014-04-30','08:25:00',1.78),('8998','2014-04-30','08:30:00',2.03),('8998','2014-04-30','08:35:00',2.1),('8998','2014-04-30','08:40:00',2.18),('8998','2014-04-30','08:45:00',2.16),('8998','2014-04-30','08:50:00',2.2),('8998','2014-04-30','08:55:00',2.42),('8998','2014-04-30','09:00:00',1.25),('8998','2014-04-30','09:05:00',1.18),('8998','2014-04-30','09:10:00',1.83),('8998','2014-04-30','09:15:00',1.57),('8998','2014-04-30','09:25:00',1.82),('8998','2014-04-30','09:30:00',2.66),('8998','2014-04-30','09:35:00',2.44),('8998','2014-04-30','09:40:00',1.13),('8998','2014-04-30','09:45:00',1.81),('8998','2014-04-30','09:50:00',1.29),('8998','2014-04-30','09:55:00',1.4),('8998','2014-04-30','10:00:00',1.37),('8998','2014-04-30','10:05:00',2.37),('8998','2014-04-30','10:10:00',2.34),('8998','2014-04-30','10:15:00',2.59),('8998','2014-04-30','10:20:00',2.43),('8998','2014-04-30','10:25:00',2.92),('8998','2014-04-30','10:30:00',2.08),('8998','2014-04-30','10:35:00',1.23),('8998','2014-04-30','10:40:00',1.06),('8998','2014-04-30','10:45:00',3.41),('8998','2014-04-30','10:50:00',3.38),('8998','2014-04-30','10:55:00',2.59),('8998','2014-04-30','11:00:00',2.86),('8998','2014-04-30','11:05:00',1.19),('8998','2014-04-30','11:10:00',1.19),('8998','2014-04-30','11:15:00',2.42),('8998','2014-04-30','11:20:00',3.69),('8998','2014-04-30','11:25:00',2.57),('8998','2014-04-30','11:30:00',3.46),('8998','2014-04-30','11:35:00',2.54),('8998','2014-04-30','11:40:00',2.74),('8998','2014-04-30','11:45:00',3.24),('8998','2014-04-30','11:50:00',1.57),('8998','2014-04-30','11:55:00',3.3),('8998','2014-04-30','12:00:00',2.66),('8998','2014-04-30','12:05:00',3.53),('8998','2014-04-30','12:10:00',2.79),('8998','2014-04-30','12:15:00',2.25),('8998','2014-04-30','12:20:00',1.96),('8998','2014-04-30','12:25:00',2.97),('8998','2014-04-30','12:30:00',3.43),('8998','2014-04-30','12:35:00',3.43),('8998','2014-04-30','12:40:00',3.38),('8998','2014-04-30','12:45:00',3.26),('8998','2014-04-30','12:50:00',3.25),('8998','2014-04-30','12:55:00',3.23),('8998','2014-04-30','13:00:00',3.28),('8998','2014-04-30','13:05:00',3.2),('8998','2014-04-30','13:10:00',3.24),('8998','2014-04-30','13:15:00',3.12),('8998','2014-04-30','13:25:00',2.89),('8998','2014-04-30','13:30:00',3.34),('8998','2014-04-30','13:35:00',3.19),('8998','2014-04-30','13:40:00',2.74),('8998','2014-04-30','13:45:00',2.33),('8998','2014-04-30','13:50:00',1.64),('8998','2014-04-30','14:00:00',1.04),('8998','2014-04-30','14:10:00',3.13),('8998','2014-04-30','14:15:00',3.01),('8998','2014-04-30','14:20:00',2.67),('8998','2014-04-30','14:25:00',2.9),('8998','2014-04-30','14:30:00',2.63),('8998','2014-04-30','14:35:00',2.56),('8998','2014-04-30','14:40:00',2.67),('8998','2014-04-30','14:45:00',2.27),('8998','2014-04-30','14:50:00',2.34),('8998','2014-04-30','14:55:00',2.51),('8998','2014-04-30','15:00:00',2.37),('8998','2014-04-30','15:05:00',2.56),('8998','2014-04-30','15:10:00',1.83),('8998','2014-04-30','15:15:00',2.23),('8998','2014-04-30','15:20:00',2.19),('8998','2014-04-30','15:25:00',2.12),('8998','2014-04-30','15:30:00',2.01),('8998','2014-04-30','15:35:00',1.94),('8998','2014-04-30','15:40:00',1.89),('8998','2014-04-30','15:45:00',1.86),('8998','2014-04-30','15:50:00',1.74),('8998','2014-04-30','15:55:00',1.67),('8998','2014-04-30','16:00:00',1.6),('8998','2014-04-30','16:05:00',1.57),('8998','2014-04-30','16:10:00',1.48),('8998','2014-04-30','16:15:00',1.43),('8998','2014-04-30','16:20:00',1.36),('8998','2014-04-30','16:25:00',1.2),('8998','2014-04-30','16:30:00',1.23),('8998','2014-04-30','16:35:00',1.19),('8998','2014-04-30','16:40:00',1.09),('8998','2014-03-16','09:30:00',1.14),('8998','2014-03-16','09:35:00',1.34),('8998','2014-03-16','09:40:00',1.08),('8998','2014-03-16','09:50:00',1.07),('8998','2014-03-16','09:55:00',1.42),('8998','2014-03-16','10:00:00',1.43),('8998','2014-03-16','10:05:00',1.33),('8998','2014-03-16','10:10:00',1.22),('8998','2014-03-16','10:15:00',1.27),('8998','2014-03-16','10:20:00',1.6),('8998','2014-03-16','10:25:00',1.35),('8998','2014-03-16','10:35:00',1.03),('8998','2014-03-16','10:40:00',1.23),('8998','2014-03-16','10:45:00',1.2),('8998','2014-03-16','10:50:00',1.11),('8998','2014-03-16','11:00:00',1.05),('8998','2014-03-16','11:05:00',1.09),('8998','2014-03-16','11:10:00',1.08),('8998','2014-03-16','11:15:00',1.23),('8998','2014-03-16','11:20:00',1.13),('8998','2014-03-16','11:50:00',1.05),('8998','2014-03-16','11:55:00',1.13),('8998','2014-03-16','12:00:00',1.7),('8998','2014-03-16','12:05:00',1.44),('8998','2014-03-16','12:10:00',1.19),('8998','2014-03-16','12:15:00',1.2),('8998','2014-03-16','12:20:00',1.08),('8998','2014-03-16','12:25:00',1.77),('8998','2014-03-16','12:30:00',1.08),('8998','2014-03-16','12:35:00',1.2),('8998','2014-03-16','12:40:00',2.35),('8998','2014-03-16','12:45:00',2.62),('8998','2014-03-16','12:50:00',2.55),('8998','2014-03-16','12:55:00',2.46),('8998','2014-03-16','13:00:00',2.37),('8998','2014-03-16','13:05:00',1.85),('8998','2014-03-16','13:10:00',2.1),('8998','2014-03-16','13:15:00',2.21),('8998','2014-03-16','13:20:00',2.19),('8998','2014-03-16','13:25:00',2.17),('8998','2014-03-16','13:30:00',2.04),('8998','2014-03-16','13:35:00',2.08),('8998','2014-03-16','13:40:00',2.07),('8998','2014-03-16','13:45:00',2.09),('8998','2014-03-16','13:50:00',1.92),('8998','2014-03-16','13:55:00',1.84),('8998','2014-03-16','14:00:00',1.34),('8998','2014-03-16','14:05:00',1.92),('8998','2014-03-16','14:10:00',1.53),('8998','2014-03-16','14:20:00',1.38),('8998','2014-03-16','14:25:00',1.56),('8998','2014-03-16','14:35:00',1.12),('8998','2014-03-16','14:40:00',1.26),('8998','2014-03-16','14:45:00',1.01),('8998','2014-03-16','14:55:00',1.07),('8998','2012-12-21','10:25:00',1.5),('8998','2012-12-21','10:30:00',1.84),('8998','2012-12-21','10:35:00',1.94),('8998','2012-12-21','10:40:00',1.86),('8998','2012-12-21','10:45:00',1.81),('8998','2012-12-21','10:50:00',1.77),('8998','2012-12-21','10:55:00',1.77),('8998','2012-12-21','11:00:00',1.12),('8998','2012-12-21','11:50:00',1.34),('8998','2012-12-21','12:00:00',1.24),('8998','2012-12-21','13:05:00',1.32),('8998','2012-12-21','13:10:00',1.35),('8998','2012-12-21','13:15:00',1.24),('8998','2012-12-21','13:20:00',1.21),('8998','2012-12-21','13:25:00',1.13),('8998','2014-03-15','08:05:00',1),('8998','2014-03-15','08:10:00',1),('8998','2014-03-15','08:15:00',1.08),('8998','2014-03-15','08:20:00',1.21),('8998','2014-03-15','08:25:00',1.3),('8998','2014-03-15','08:30:00',1.45),('8998','2014-03-15','08:35:00',1.61),('8998','2014-03-15','08:40:00',1.67),('8998','2014-03-15','08:45:00',1.74),('8998','2014-03-15','08:50:00',1.81),('8998','2014-03-15','08:55:00',1.81),('8998','2014-03-15','09:00:00',1.78),('8998','2014-03-15','09:05:00',1.84),('8998','2014-03-15','09:10:00',1.94),('8998','2014-03-15','09:15:00',2.07),('8998','2014-03-15','09:20:00',2.06),('8998','2014-03-15','09:25:00',2.05),('8998','2014-03-15','09:30:00',2.07),('8998','2014-03-15','09:35:00',2.06),('8998','2014-03-15','09:40:00',2.04),('8998','2014-03-15','09:45:00',2.2),('8998','2014-03-15','09:50:00',2.32),('8998','2014-03-15','09:55:00',2.31),('8998','2014-03-15','10:00:00',2.28),('8998','2014-03-15','10:05:00',2.28),('8998','2014-03-15','10:10:00',2.35),('8998','2014-03-15','10:15:00',2.39),('8998','2014-03-15','10:20:00',2.37),('8998','2014-03-15','10:25:00',2.34),('8998','2014-03-15','10:30:00',2.3),('8998','2014-03-15','10:35:00',2.31),('8998','2014-03-15','10:40:00',2.43),('8998','2014-03-15','10:45:00',2.44),('8998','2014-03-15','10:50:00',2.45),('8998','2014-03-15','10:55:00',2.45),('8998','2014-03-15','11:00:00',2.39),('8998','2014-03-15','11:05:00',2.33),('8998','2014-03-15','11:10:00',2.23),('8998','2014-03-15','11:15:00',2.14),('8998','2014-03-15','11:20:00',2.41),('8998','2014-03-15','11:25:00',2.43),('8998','2014-03-15','11:30:00',2.43),('8998','2014-03-15','11:35:00',2.41),('8998','2014-03-15','11:40:00',2.43),('8998','2014-03-15','11:45:00',2.41),('8998','2014-03-15','11:50:00',2.43),('8998','2014-03-15','11:55:00',2.35),('8998','2014-03-15','12:00:00',2.32),('8998','2014-03-15','12:05:00',2.29),('8998','2014-03-15','12:10:00',2.28),('8998','2014-03-15','12:15:00',2.3),('8998','2014-03-15','12:20:00',2.27),('8998','2014-03-15','12:25:00',2.17),('8998','2014-03-15','12:30:00',2.15),('8998','2014-03-15','12:35:00',2.17),('8998','2014-03-15','12:40:00',2.17),('8998','2014-03-15','12:45:00',2.16),('8998','2014-03-15','12:50:00',2.12),('8998','2014-03-15','12:55:00',2.03),('8998','2014-03-15','13:00:00',2),('8998','2014-03-15','13:05:00',1.99),('8998','2014-03-15','13:10:00',1.96),('8998','2014-03-15','13:15:00',1.95),('8998','2014-03-15','13:20:00',1.89),('8998','2014-03-15','13:25:00',1.9),('8998','2014-03-15','13:30:00',1.87),('8998','2014-03-15','13:35:00',1.82),('8998','2014-03-15','13:40:00',1.88),('8998','2014-03-15','13:45:00',1.8),('8998','2014-03-15','13:50:00',1.74),('8998','2014-03-15','13:55:00',1.71),('8998','2014-03-15','14:00:00',1.66),('8998','2014-03-15','14:05:00',1.59),('8998','2014-03-15','14:10:00',1.52),('8998','2014-03-15','14:15:00',1.46),('8998','2014-03-15','14:20:00',1.43),('8998','2014-03-15','14:25:00',1.37),('8998','2014-03-15','14:30:00',1.3),('8998','2014-03-15','14:35:00',1.18),('8998','2014-03-15','14:40:00',1.12),('8998','2014-03-15','14:45:00',1.08),('8998','2014-03-14','07:55:00',1.02),('8998','2014-03-14','08:00:00',1.12),('8998','2014-03-14','08:05:00',1.19),('8998','2014-03-14','08:10:00',1.24),('8998','2014-03-14','08:15:00',1.34),('8998','2014-03-14','08:20:00',1.41),('8998','2014-03-14','08:25:00',1.47),('8998','2014-03-14','08:30:00',1.51),('8998','2014-03-14','08:35:00',1.56),('8998','2014-03-14','08:40:00',1.64),('8998','2014-03-14','08:45:00',1.68),('8998','2014-03-14','08:50:00',1.72),('8998','2014-03-14','08:55:00',1.77),('8998','2014-03-14','09:00:00',1.82),('8998','2014-03-14','09:05:00',1.86),('8998','2014-03-14','09:10:00',1.9),('8998','2014-03-14','09:15:00',1.95),('8998','2014-03-14','09:20:00',2.01),('8998','2014-03-14','09:25:00',2.05),('8998','2014-03-14','09:30:00',2.08),('8998','2014-03-14','09:35:00',2.12),('8998','2014-03-14','09:40:00',2.14),('8998','2014-03-14','09:45:00',2.14),('8998','2014-03-14','09:50:00',2.16),('8998','2014-03-14','09:55:00',2.18),('8998','2014-03-14','10:00:00',2.2),('8998','2014-03-14','10:05:00',2.21),('8998','2014-03-14','10:10:00',2.22),('8998','2014-03-14','10:15:00',2.22),('8998','2014-03-14','10:20:00',2.26),('8998','2014-03-14','10:25:00',2.29),('8998','2014-03-14','10:30:00',2.32),('8998','2014-03-14','10:35:00',2.32),('8998','2014-03-14','10:40:00',2.33),('8998','2014-03-14','10:45:00',2.34),('8998','2014-03-14','10:50:00',2.32),('8998','2014-03-14','10:55:00',2.31),('8998','2014-03-14','11:00:00',2.27),('8998','2014-03-14','11:05:00',2.28),('8998','2014-03-14','11:10:00',2.3),('8998','2014-03-14','11:15:00',2.32),('8998','2014-03-14','11:20:00',2.41),('8998','2014-03-14','11:25:00',2.33),('8998','2014-03-14','11:30:00',2.41),('8998','2014-03-14','11:35:00',2.36),('8998','2014-03-14','11:40:00',2.36),('8998','2014-03-14','11:45:00',2.36),('8998','2014-03-14','11:50:00',2.34),('8998','2014-03-14','11:55:00',2.35),('8998','2014-03-14','12:00:00',2.34),('8998','2014-03-14','12:05:00',2.3),('8998','2014-03-14','12:10:00',2.25),('8998','2014-03-14','12:15:00',2.28),('8998','2014-03-14','12:20:00',2.25),('8998','2014-03-14','12:25:00',2.21),('8998','2014-03-14','12:30:00',2.2),('8998','2014-03-14','12:35:00',2.22),('8998','2014-03-14','12:40:00',2.21),('8998','2014-03-14','12:45:00',2.18),('8998','2014-03-14','12:50:00',2.14),('8998','2014-03-14','12:55:00',2.11),('8998','2014-03-14','13:00:00',2.05),('8998','2014-03-14','13:05:00',2.04),('8998','2014-03-14','13:10:00',2.03),('8998','2014-03-14','13:15:00',1.98),('8998','2014-03-14','13:20:00',1.94),('8998','2014-03-14','13:25:00',1.91),('8998','2014-03-14','13:30:00',1.89),('8998','2014-03-14','13:35:00',1.84),('8998','2014-03-14','13:40:00',1.81),('8998','2014-03-14','13:45:00',1.76),('8998','2014-03-14','13:50:00',1.73),('8998','2014-03-14','13:55:00',1.68),('8998','2014-03-14','14:00:00',1.64),('8998','2014-03-14','14:05:00',1.61),('8998','2014-03-14','14:10:00',1.55),('8998','2014-03-14','14:15:00',1.5),('8998','2014-03-14','14:20:00',1.44),('8998','2014-03-14','14:25:00',1.38),('8998','2014-03-14','14:30:00',1.32),('8998','2014-03-14','14:35:00',1.26),('8998','2014-03-14','14:40:00',1.19),('8998','2014-03-14','14:45:00',1.05),('8998','2014-03-14','14:50:00',1.03),('8998','2014-03-13','08:30:00',1.05),('8998','2014-03-13','08:35:00',1.08),('8998','2014-03-13','08:40:00',1.05),('8998','2014-03-13','09:10:00',1.12),('8998','2014-03-13','09:15:00',1.15),('8998','2014-03-13','09:20:00',1.12),('8998','2014-03-13','09:25:00',1.21),('8998','2014-03-13','09:30:00',1.22),('8998','2014-03-13','09:35:00',1.45),('8998','2014-03-13','09:40:00',1.83),('8998','2014-03-13','09:45:00',2.12),('8998','2014-03-13','09:50:00',2.49),('8998','2014-03-13','09:55:00',2.62),('8998','2014-03-13','10:00:00',2.75),('8998','2014-03-13','10:05:00',2.73),('8998','2014-03-13','10:10:00',2.67),('8998','2014-03-13','10:15:00',2.61),('8998','2014-03-13','10:20:00',2.53),('8998','2014-03-13','10:25:00',2.45),('8998','2014-03-13','10:30:00',2.37),('8998','2014-03-13','10:35:00',2.45),('8998','2014-03-13','10:40:00',2.53),('8998','2014-03-13','10:45:00',2.3),('8998','2014-03-13','10:50:00',1.46),('8998','2014-03-13','10:55:00',1.78),('8998','2014-03-13','11:00:00',2.37),('8998','2014-03-13','11:05:00',2.46),('8998','2014-03-13','11:10:00',2.63),('8998','2014-03-13','11:15:00',2.66),('8998','2014-03-13','11:20:00',2.53),('8998','2014-03-13','11:25:00',2.46),('8998','2014-03-13','11:30:00',2.43),('8998','2014-03-13','11:35:00',2.46),('8998','2014-03-13','11:40:00',2.45),('8998','2014-03-13','11:45:00',2.44),('8998','2014-03-13','11:50:00',2.43),('8998','2014-03-13','11:55:00',2.42),('8998','2014-03-13','12:00:00',2.43),('8998','2014-03-13','12:05:00',2.46),('8998','2014-03-13','12:10:00',2.29),('8998','2014-03-13','12:15:00',2.19),('8998','2014-03-13','12:20:00',1.96),('8998','2014-03-13','12:25:00',1.56),('8998','2014-03-13','12:30:00',1.37),('8998','2014-03-13','12:35:00',1.22),('8998','2014-03-13','12:40:00',1.4),('8998','2014-03-13','12:45:00',1.46),('8998','2014-03-13','12:50:00',1.76),('8998','2014-03-13','12:55:00',1.73),('8998','2014-03-13','13:00:00',1.32),('8998','2014-03-13','13:05:00',1.14),('8998','2014-03-13','13:10:00',1.37),('8998','2014-03-13','13:15:00',1.61),('8998','2014-03-13','13:20:00',1.69),('8998','2014-03-13','13:25:00',1.56),('8998','2014-03-13','13:30:00',1.42),('8998','2014-03-13','13:35:00',1.31),('8998','2014-03-13','13:40:00',1.16),('8998','2014-03-13','13:45:00',1.2),('8998','2014-03-13','13:50:00',1.11),('8998','2014-03-13','13:55:00',1.16),('8998','2014-03-13','14:00:00',1.26),('8998','2014-03-13','14:05:00',1.4),('8998','2014-03-13','14:10:00',1.46),('8998','2014-03-13','14:15:00',1.48),('8998','2014-03-13','14:20:00',1.46),('8998','2014-03-13','14:25:00',1.46),('8998','2014-03-13','14:30:00',1.35),('8998','2014-03-13','14:35:00',1.24),('8998','2014-03-13','14:40:00',1.1),('8998','2014-03-12','07:55:00',1.4),('8998','2014-03-12','08:00:00',1.53),('8998','2014-03-12','08:05:00',1.6),('8998','2014-03-12','08:10:00',1.66),('8998','2014-03-12','08:15:00',1.74),('8998','2014-03-12','08:20:00',1.8),('8998','2014-03-12','08:25:00',1.85),('8998','2014-03-12','08:30:00',1.9),('8998','2014-03-12','08:35:00',1.96),('8998','2014-03-12','08:40:00',2.01),('8998','2014-03-12','08:45:00',2.09),('8998','2014-03-12','08:50:00',2.13),('8998','2014-03-12','08:55:00',2.17),('8998','2014-03-12','09:00:00',2.23),('8998','2014-03-12','09:05:00',2.25),('8998','2014-03-12','09:10:00',2.28),('8998','2014-03-12','09:15:00',2.32),('8998','2014-03-12','09:20:00',2.35),('8998','2014-03-12','09:25:00',2.37),('8998','2014-03-12','09:30:00',2.41),('8998','2014-03-12','09:35:00',2.44),('8998','2014-03-12','09:40:00',2.46),('8998','2014-03-12','09:45:00',2.49),('8998','2014-03-12','09:50:00',2.53),('8998','2014-03-12','09:55:00',2.56),('8998','2014-03-12','10:00:00',2.57),('8998','2014-03-12','10:05:00',2.58),('8998','2014-03-12','10:10:00',2.6),('8998','2014-03-12','10:15:00',2.6),('8998','2014-03-12','10:20:00',2.6),('8998','2014-03-12','10:25:00',2.6),('8998','2014-03-12','10:30:00',2.61),('8998','2014-03-12','10:35:00',2.62),('8998','2014-03-12','10:40:00',2.62),('8998','2014-03-12','10:45:00',2.62),('8998','2014-03-12','10:50:00',2.62),('8998','2014-03-12','10:55:00',2.61),('8998','2014-03-12','11:00:00',2.61),('8998','2014-03-12','11:05:00',2.61),('8998','2014-03-12','11:10:00',2.6),('8998','2014-03-12','11:15:00',2.6),('8998','2014-03-12','11:20:00',2.6),('8998','2014-03-12','11:25:00',2.58),('8998','2014-03-12','11:30:00',2.56),('8998','2014-03-12','11:35:00',2.54),('8998','2014-03-12','11:40:00',2.55),('8998','2014-03-12','11:45:00',2.54),('8998','2014-03-12','11:50:00',2.54),('8998','2014-03-12','11:55:00',2.53),('8998','2014-03-12','12:00:00',2.48),('8998','2014-03-12','12:05:00',2.47),('8998','2014-03-12','12:10:00',2.46),('8998','2014-03-12','12:15:00',2.42),('8998','2014-03-12','12:20:00',2.4),('8998','2014-03-12','12:25:00',2.36),('8998','2014-03-12','12:30:00',2.34),('8998','2014-03-12','12:35:00',2.3),('8998','2014-03-12','12:40:00',2.26),('8998','2014-03-12','12:45:00',2.23),('8998','2014-03-12','12:50:00',2.19),('8998','2014-03-12','12:55:00',2.15),('8998','2014-03-12','13:00:00',2.11),('8998','2014-03-12','13:05:00',2.08),('8998','2014-03-12','13:10:00',2.05),('8998','2014-03-12','13:15:00',1.99),('8998','2014-03-12','13:20:00',1.96),('8998','2014-03-12','13:25:00',1.92),('8998','2014-03-12','13:30:00',1.91),('8998','2014-03-12','13:35:00',1.88),('8998','2014-03-12','13:40:00',1.82),('8998','2014-03-12','13:45:00',1.77),('8998','2014-03-12','13:50:00',1.72),('8998','2014-03-12','13:55:00',1.67),('8998','2014-03-12','14:00:00',1.61),('8998','2014-03-12','14:05:00',1.56),('8998','2014-03-12','14:10:00',1.51),('8998','2014-03-12','14:15:00',1.46),('8998','2014-03-12','14:20:00',1.38),('8998','2014-03-12','14:25:00',1.32),('8998','2014-03-12','14:30:00',1.28),('8998','2014-03-12','14:35:00',1.22),('8998','2014-03-12','14:40:00',1.07),('8998','2014-03-11','07:55:00',1.35),('8998','2014-03-11','08:00:00',1.5),('8998','2014-03-11','08:05:00',1.58),('8998','2014-03-11','08:10:00',1.66),('8998','2014-03-11','08:15:00',1.75),('8998','2014-03-11','08:20:00',1.8),('8998','2014-03-11','08:25:00',1.86),('8998','2014-03-11','08:30:00',1.91),('8998','2014-03-11','08:35:00',1.96),('8998','2014-03-11','08:40:00',2.03),('8998','2014-03-11','08:45:00',2.1),('8998','2014-03-11','08:50:00',2.15),('8998','2014-03-11','08:55:00',2.18),('8998','2014-03-11','09:00:00',2.21),('8998','2014-03-11','09:05:00',2.24),('8998','2014-03-11','09:10:00',2.28),('8998','2014-03-11','09:15:00',2.32),('8998','2014-03-11','09:20:00',2.35),('8998','2014-03-11','09:25:00',2.38),('8998','2014-03-11','09:30:00',2.39),('8998','2014-03-11','09:35:00',2.41),('8998','2014-03-11','09:40:00',2.43),('8998','2014-03-11','09:45:00',2.46),('8998','2014-03-11','09:50:00',2.48),('8998','2014-03-11','09:55:00',2.51),('8998','2014-03-11','10:00:00',2.53),('8998','2014-03-11','10:05:00',2.55),('8998','2014-03-11','10:10:00',2.55),('8998','2014-03-11','10:15:00',2.57),('8998','2014-03-11','10:20:00',2.58),('8998','2014-03-11','10:25:00',2.6),('8998','2014-03-11','10:30:00',2.61),('8998','2014-03-11','10:35:00',2.64),('8998','2014-03-11','10:40:00',2.65),('8998','2014-03-11','10:45:00',2.67),('8998','2014-03-11','10:50:00',2.68),('8998','2014-03-11','10:55:00',2.67),('8998','2014-03-11','11:00:00',2.68),('8998','2014-03-11','11:05:00',2.69),('8998','2014-03-11','11:10:00',2.68),('8998','2014-03-11','11:15:00',2.68),('8998','2014-03-11','11:20:00',2.68),('8998','2014-03-11','11:25:00',2.67),('8998','2014-03-11','11:30:00',2.65),('8998','2014-03-11','11:35:00',2.65),('8998','2014-03-11','11:40:00',2.65),('8998','2014-03-11','11:45:00',2.62),('8998','2014-03-11','11:50:00',2.6),('8998','2014-03-11','11:55:00',2.58),('8998','2014-03-11','12:00:00',2.56),('8998','2014-03-11','12:05:00',2.53),('8998','2014-03-11','12:10:00',2.5),('8998','2014-03-11','12:15:00',2.49),('8998','2014-03-11','12:20:00',2.45),('8998','2014-03-11','12:25:00',2.42),('8998','2014-03-11','12:30:00',2.4),('8998','2014-03-11','12:35:00',2.37),('8998','2014-03-11','12:40:00',2.33),('8998','2014-03-11','12:45:00',2.31),('8998','2014-03-11','12:50:00',2.28),('8998','2014-03-11','12:55:00',2.23),('8998','2014-03-11','13:00:00',2.22),('8998','2014-03-11','13:05:00',2.17),('8998','2014-03-11','13:10:00',2.13),('8998','2014-03-11','13:15:00',2.1),('8998','2014-03-11','13:20:00',2.06),('8998','2014-03-11','13:25:00',2.01),('8998','2014-03-11','13:30:00',1.95),('8998','2014-03-11','13:35:00',1.92),('8998','2014-03-11','13:40:00',1.87),('8998','2014-03-11','13:45:00',1.82),('8998','2014-03-11','13:50:00',1.78),('8998','2014-03-11','13:55:00',1.73),('8998','2014-03-11','14:00:00',1.69),('8998','2014-03-11','14:05:00',1.64),('8998','2014-03-11','14:10:00',1.58),('8998','2014-03-11','14:15:00',1.52),('8998','2014-03-11','14:20:00',1.39),('8998','2014-03-11','14:25:00',1.39),('8998','2014-03-11','14:30:00',1.33),('8998','2014-03-11','14:35:00',1.23),('8998','2014-03-11','14:40:00',1.04),('8998','2014-03-10','13:50:00',1.07),('8998','2014-03-10','13:55:00',1.22),('8998','2014-03-10','14:00:00',1.26),('8998','2014-03-10','14:05:00',1.31),('8998','2014-03-10','14:10:00',1.73),('8998','2014-03-10','14:15:00',1.5),('8998','2014-03-10','14:20:00',1.26),('8998','2014-03-10','14:25:00',1.14),('8998','2014-03-10','15:05:00',1.02),('8998','2014-03-10','15:10:00',1.03),('8998','2014-03-09','13:10:00',1.03),('8998','2014-03-09','13:15:00',1.14),('8998','2014-03-09','13:20:00',1.07),('8998','2014-03-09','14:05:00',1.08),('8998','2014-03-09','14:10:00',1.41),('8998','2014-03-09','14:15:00',1.69),('8998','2014-03-09','14:20:00',1.2),('8998','2014-03-09','14:25:00',1.02),('8998','2014-03-09','14:35:00',1.08),('8998','2014-03-09','14:40:00',1.14),('8998','2014-03-09','14:45:00',1.04),('8998','2014-03-08','08:00:00',1.09),('8998','2014-03-08','08:05:00',1.46),('8998','2014-03-08','08:10:00',1.58),('8998','2014-03-08','08:15:00',1.67),('8998','2014-03-08','08:20:00',1.62),('8998','2014-03-08','08:25:00',1.2),('8998','2014-03-08','08:30:00',1.33),('8998','2014-03-08','08:35:00',1.16),('8998','2014-03-08','08:40:00',1.47),('8998','2014-03-08','08:45:00',1.11),('8998','2014-03-08','08:50:00',1.26),('8998','2014-03-08','08:55:00',1.63),('8998','2014-03-08','09:00:00',1.99),('8998','2014-03-08','09:05:00',1.1),('8998','2014-03-08','09:15:00',1.79),('8998','2014-03-08','09:20:00',2.38),('8998','2014-03-08','09:25:00',2.52),('8998','2014-03-08','09:30:00',1.81),('8998','2014-03-08','09:35:00',2.57),('8998','2014-03-08','09:40:00',2.68),('8998','2014-03-08','09:45:00',2.72),('8998','2014-03-08','09:50:00',2.72),('8998','2014-03-08','09:55:00',2.68),('8998','2014-03-08','10:00:00',2.67),('8998','2014-03-08','10:05:00',2.68),('8998','2014-03-08','10:10:00',2.72),('8998','2014-03-08','10:15:00',2.69),('8998','2014-03-08','10:20:00',2.52),('8998','2014-03-08','10:25:00',2.69),('8998','2014-03-08','10:30:00',2.69),('8998','2014-03-08','10:35:00',2.7),('8998','2014-03-08','10:40:00',2.71),('8998','2014-03-08','10:45:00',2.73),('8998','2014-03-08','10:50:00',2.76),('8998','2014-03-08','10:55:00',2.76),('8998','2014-03-08','11:00:00',2.99),('8998','2014-03-08','11:05:00',3.04),('8998','2014-03-08','11:10:00',3.13),('8998','2014-03-08','11:15:00',2.99),('8998','2014-03-08','11:20:00',3),('8998','2014-03-08','11:25:00',3.01),('8998','2014-03-08','11:30:00',2.28),('8998','2014-03-08','11:35:00',2.35),('8998','2014-03-08','11:40:00',2.38),('8998','2014-03-08','11:45:00',2.32),('8998','2014-03-08','11:50:00',2.06),('8998','2014-03-08','11:55:00',3.04),('8998','2014-03-08','12:00:00',2.96),('8998','2014-03-08','12:05:00',3.01),('8998','2014-03-08','12:10:00',2.91),('8998','2014-03-08','12:15:00',2.85),('8998','2014-03-08','12:20:00',2.82),('8998','2014-03-08','12:25:00',2.75),('8998','2014-03-08','12:30:00',2.76),('8998','2014-03-08','12:35:00',2.8),('8998','2014-03-08','12:40:00',2.64),('8998','2014-03-08','12:45:00',2.55),('8998','2014-03-08','12:50:00',2.57),('8998','2014-03-08','12:55:00',2.58),('8998','2014-03-08','13:00:00',2.6),('8998','2014-03-08','13:05:00',2.59),('8998','2014-03-08','13:10:00',2.51),('8998','2014-03-08','13:15:00',2.29),('8998','2014-03-08','13:20:00',2.09),('8998','2014-03-08','13:25:00',2.22),('8998','2014-03-08','13:30:00',2.15),('8998','2014-03-08','13:35:00',1.49),('8998','2014-03-08','13:45:00',1.57),('8998','2014-03-08','13:50:00',1.96),('8998','2014-03-08','13:55:00',1.88),('8998','2014-03-08','14:00:00',1.84),('8998','2014-03-08','14:05:00',1.73),('8998','2014-03-08','14:10:00',1.67),('8998','2014-03-08','14:15:00',1.56),('8998','2014-03-08','14:20:00',1.32),('8998','2014-03-08','14:40:00',1.09),('8998','2014-03-08','14:45:00',1.22),('8998','2014-03-08','14:50:00',1.11),('8998','2014-03-08','14:55:00',1.02),('8998','2014-03-07','08:00:00',1.09),('8998','2014-03-07','08:05:00',1.47),('8998','2014-03-07','08:10:00',1.58),('8998','2014-03-07','08:15:00',1.66),('8998','2014-03-07','08:20:00',1.73),('8998','2014-03-07','08:25:00',1.78),('8998','2014-03-07','08:30:00',1.84),('8998','2014-03-07','08:35:00',1.89),('8998','2014-03-07','08:40:00',1.94),('8998','2014-03-07','08:45:00',2.02),('8998','2014-03-07','08:50:00',2.08),('8998','2014-03-07','08:55:00',2.13),('8998','2014-03-07','09:00:00',2.18),('8998','2014-03-07','09:05:00',2.21),('8998','2014-03-07','09:10:00',2.26),('8998','2014-03-07','09:15:00',2.29),('8998','2014-03-07','09:20:00',2.33),('8998','2014-03-07','09:25:00',2.36),('8998','2014-03-07','09:30:00',2.39),('8998','2014-03-07','09:35:00',2.41),('8998','2014-03-07','09:40:00',2.43),('8998','2014-03-07','09:45:00',2.46),('8998','2014-03-07','09:50:00',2.49),('8998','2014-03-07','09:55:00',2.51),('8998','2014-03-07','10:00:00',2.53),('8998','2014-03-07','10:05:00',2.55),('8998','2014-03-07','10:10:00',2.55),('8998','2014-03-07','10:15:00',2.57),('8998','2014-03-07','10:20:00',2.6),('8998','2014-03-07','10:25:00',2.61),('8998','2014-03-07','10:30:00',2.63),('8998','2014-03-07','10:35:00',2.66),('8998','2014-03-07','10:40:00',2.65),('8998','2014-03-07','10:45:00',2.65),('8998','2014-03-07','10:50:00',2.66),('8998','2014-03-07','10:55:00',2.64),('8998','2014-03-07','11:00:00',2.65),('8998','2014-03-07','11:05:00',2.65),('8998','2014-03-07','11:10:00',2.65),('8998','2014-03-07','11:15:00',2.67),('8998','2014-03-07','11:20:00',2.73),('8998','2014-03-07','11:25:00',2.78),('8998','2014-03-07','11:30:00',2.68),('8998','2014-03-07','11:35:00',1.77),('8998','2014-03-07','11:50:00',1.27),('8998','2014-03-07','11:55:00',2.9),('8998','2014-03-07','12:00:00',1.15),('8998','2014-03-07','12:20:00',1.02),('8998','2014-03-07','12:25:00',1.08),('8998','2014-03-07','12:30:00',1.31),('8998','2014-03-07','12:35:00',2.14),('8998','2014-03-07','12:40:00',1.28),('8998','2014-03-07','12:45:00',1.2),('8998','2014-03-07','12:50:00',1.26),('8998','2014-03-07','12:55:00',2.02),('8998','2014-03-07','13:00:00',1.11),('8998','2014-03-07','13:05:00',1.08),('8998','2014-03-07','13:30:00',1.31),('8998','2014-03-07','13:35:00',1.01),('8998','2014-03-07','13:40:00',1.54),('8998','2014-03-07','13:45:00',1.58),('8998','2014-03-07','13:50:00',1.1),('8998','2014-04-29','07:40:00',1.13),('8998','2014-04-29','07:45:00',1.27),('8998','2014-04-29','07:50:00',1.35),('8998','2014-04-29','07:55:00',1.32),('8998','2014-04-29','08:00:00',1.3),('8998','2014-04-29','08:05:00',1.3),('8998','2014-04-29','08:10:00',1.43),('8998','2014-04-29','08:15:00',1.55),('8998','2014-04-29','08:20:00',1.43),('8998','2014-04-29','08:25:00',1.57),('8998','2014-04-29','08:30:00',1.81),('8998','2014-04-29','08:35:00',1.8),('8998','2014-04-29','08:40:00',1.64),('8998','2014-04-29','08:45:00',1.56),('8998','2014-04-29','08:50:00',1.69),('8998','2014-04-29','08:55:00',2.14),('8998','2014-04-29','09:00:00',2.21),('8998','2014-04-29','09:05:00',2.34),('8998','2014-04-29','09:10:00',2.47),('8998','2014-04-29','09:15:00',2.63),('8998','2014-04-29','09:20:00',1.82),('8998','2014-04-29','09:25:00',2.09),('8998','2014-04-29','09:30:00',1.47),('8998','2014-04-29','09:35:00',2.56),('8998','2014-04-29','09:40:00',2.18),('8998','2014-04-29','09:45:00',2.88),('8998','2014-04-29','09:50:00',1.69),('8998','2014-04-29','09:55:00',1.93),('8998','2014-04-29','10:00:00',3.09),('8998','2014-04-29','10:05:00',2.9),('8998','2014-04-29','10:10:00',1.88),('8998','2014-04-29','10:15:00',2.39),('8998','2014-04-29','10:20:00',1.5),('8998','2014-04-29','10:25:00',1.32),('8998','2014-04-29','10:30:00',1.19),('8998','2014-04-29','10:35:00',1.66),('8998','2014-04-29','10:40:00',1.66),('8998','2014-04-29','10:45:00',1.28),('8998','2014-04-29','10:55:00',2.83),('8998','2014-04-29','11:00:00',2.01),('8998','2014-04-29','11:05:00',3.09),('8998','2014-04-29','11:10:00',2.05),('8998','2014-04-29','11:15:00',2.09),('8998','2014-04-29','11:20:00',1.22),('8998','2014-04-29','11:25:00',1.84),('8998','2014-04-29','11:30:00',1.52),('8998','2014-04-29','11:35:00',1.46),('8998','2014-04-29','11:40:00',1.44),('8998','2014-04-29','11:45:00',1.56),('8998','2014-04-29','11:50:00',2.38),('8998','2014-04-29','11:55:00',1.64),('8998','2014-04-29','12:00:00',2.36),('8998','2014-04-29','12:05:00',1.11),('8998','2014-04-29','12:15:00',1.22),('8998','2014-04-29','12:20:00',1.63),('8998','2014-04-29','12:25:00',1.04),('8998','2014-04-29','12:45:00',1.39),('8998','2014-04-29','12:50:00',1.18),('8998','2014-04-29','12:55:00',2.6),('8998','2014-04-29','13:00:00',3.27),('8998','2014-04-29','13:05:00',2.7),('8998','2014-04-29','13:10:00',3.43),('8998','2014-04-29','13:15:00',1.54),('8998','2014-04-29','13:20:00',1.23),('8998','2014-04-29','13:25:00',1.56),('8998','2014-04-29','13:30:00',1.48),('8998','2014-04-29','13:35:00',1.2),('8998','2014-04-29','13:40:00',2.29),('8998','2014-04-29','13:45:00',1.96),('8998','2014-04-29','13:50:00',2.9),('8998','2014-04-29','13:55:00',3.55),('8998','2014-04-29','14:00:00',1.47),('8998','2014-04-29','14:05:00',1.29),('8998','2014-04-29','14:10:00',1.13),('8998','2014-04-29','14:15:00',1.27),('8998','2014-04-29','14:20:00',2.06),('8998','2014-04-29','14:25:00',2),('8998','2014-04-29','14:30:00',2.71),('8998','2014-04-29','14:35:00',2.95),('8998','2014-04-29','14:40:00',1.54),('8998','2014-04-29','14:45:00',1.01),('8998','2014-04-29','14:50:00',1.12),('8998','2014-04-29','14:55:00',1.27),('8998','2014-04-29','15:00:00',1.01),('8998','2014-04-29','15:30:00',1.24),('8998','2014-04-29','15:35:00',1.51),('8998','2014-04-29','15:40:00',2.31),('8998','2014-04-29','15:45:00',2.23),('8998','2014-04-29','15:50:00',1.58),('8998','2014-04-29','15:55:00',1.74),('8998','2014-04-29','16:05:00',1.19),('8998','2014-04-29','16:15:00',1.1),('8998','2014-04-29','16:20:00',1),('8998','2014-04-29','16:25:00',1),('8998','2014-04-29','16:30:00',1.33),('8998','2014-04-29','16:40:00',1.17),('8998','2014-04-29','16:45:00',1.26),('8998','2014-04-29','16:50:00',1.33),('8998','2014-04-29','16:55:00',1.13),('8998','2014-04-29','17:05:00',1.18),('8998','2014-03-06','11:45:00',1.12),('8998','2014-03-06','11:50:00',1.08),('8998','2014-03-06','11:55:00',2.53),('8998','2014-03-06','12:00:00',3.15),('8998','2014-03-06','12:05:00',1.9),('8998','2014-03-06','12:10:00',3.05),('8998','2014-03-06','12:15:00',2.83),('8998','2014-03-06','12:20:00',2.84),('8998','2014-03-06','12:25:00',2.74),('8998','2014-03-06','12:30:00',2.73),('8998','2014-03-06','12:35:00',2.57),('8998','2014-03-06','12:40:00',1.94),('8998','2014-03-06','12:45:00',2.11),('8998','2014-03-06','12:50:00',1.19),('8998','2014-03-06','13:15:00',1.01),('8998','2014-03-06','13:20:00',1.13),('8998','2014-03-06','13:25:00',1.28),('8998','2014-03-06','13:30:00',1.19),('8998','2014-03-06','13:35:00',1.48),('8998','2014-03-06','13:40:00',1.73),('8998','2014-03-06','13:45:00',1.31),('8998','2014-03-06','15:00:00',1.09),('8998','2014-03-06','15:05:00',1.21),('8998','2014-03-06','15:10:00',1.16),('8998','2014-03-06','15:15:00',1.12),('8998','2014-03-06','15:20:00',1.08),('8998','2014-03-06','15:25:00',1.04),('8998','2014-03-06','15:30:00',1.07),('8998','2014-03-05','08:10:00',1.08),('8998','2014-03-05','08:15:00',1.7),('8998','2014-03-05','08:20:00',1.24),('8998','2014-03-05','08:35:00',1.11),('8998','2014-03-05','08:40:00',1),('8998','2014-03-05','09:35:00',1),('8998','2014-03-05','09:40:00',1.24),('8998','2014-03-05','09:45:00',1.39),('8998','2014-03-05','09:50:00',1.44),('8998','2014-03-05','09:55:00',1.43),('8998','2014-03-05','10:00:00',1.44),('8998','2014-03-05','10:05:00',1.79),('8998','2014-03-05','10:10:00',2.32),('8998','2014-03-05','10:15:00',2.64),('8998','2014-03-05','10:20:00',2.16),('8998','2014-03-05','10:25:00',1.75),('8998','2014-03-05','10:30:00',1.02),('8998','2014-03-05','10:40:00',1.26),('8998','2014-03-05','10:45:00',1.06),('8998','2014-03-05','10:55:00',1.21),('8998','2014-03-05','11:00:00',1.61),('8998','2014-03-05','11:05:00',2.71),('8998','2014-03-05','11:10:00',1.45),('8998','2014-03-05','11:15:00',1.74),('8998','2014-03-05','11:20:00',1.05),('8998','2014-03-05','11:25:00',1.25),('8998','2014-03-05','11:30:00',1.12),('8998','2014-03-05','11:40:00',1.28),('8998','2014-03-05','11:45:00',2.17),('8998','2014-03-05','11:50:00',1.77),('8998','2014-03-05','11:55:00',1.94),('8998','2014-03-05','12:00:00',1.01),('8998','2014-03-05','12:05:00',2.2),('8998','2014-03-05','12:10:00',3.04),('8998','2014-03-05','12:15:00',3.04),('8998','2014-03-05','12:20:00',1.93),('8998','2014-03-05','12:25:00',2.7),('8998','2014-03-05','12:30:00',2.86),('8998','2014-03-05','12:35:00',1.66),('8998','2014-03-05','12:40:00',1.13),('8998','2014-03-05','13:15:00',1.2),('8998','2014-03-04','07:50:00',1.01),('8998','2014-03-04','07:55:00',1.02),('8998','2014-03-04','08:00:00',1.01),('8998','2014-03-04','08:05:00',1.27),('8998','2014-03-04','08:10:00',1.35),('8998','2014-03-04','08:15:00',1.41),('8998','2014-03-04','08:30:00',2.07),('8998','2014-03-04','08:35:00',2.26),('8998','2014-03-04','08:40:00',2.07),('8998','2014-03-04','08:45:00',1.71),('8998','2014-03-04','09:00:00',1.92),('8998','2014-03-04','09:10:00',1.17),('8998','2014-03-04','09:15:00',2.07),('8998','2014-03-04','09:20:00',2.47),('8998','2014-03-04','09:25:00',2.42),('8998','2014-03-04','09:30:00',2.44),('8998','2014-03-04','09:35:00',2.48),('8998','2014-03-04','09:40:00',2.49),('8998','2014-03-04','09:45:00',2.5),('8998','2014-03-04','09:50:00',2.51),('8998','2014-03-04','09:55:00',2.54),('8998','2014-03-04','10:00:00',2.56),('8998','2014-03-04','10:05:00',2.58),('8998','2014-03-04','10:10:00',2.6),('8998','2014-03-04','10:15:00',2.58),('8998','2014-03-04','10:20:00',2.6),('8998','2014-03-04','10:25:00',2.61),('8998','2014-03-04','10:30:00',2.6),('8998','2014-03-04','10:35:00',2.61),('8998','2014-03-04','10:40:00',2.61),('8998','2014-03-04','10:45:00',2.61),('8998','2014-03-04','10:50:00',2.62),('8998','2014-03-04','10:55:00',2.63),('8998','2014-03-04','11:00:00',2.66),('8998','2014-03-04','11:05:00',2.69),('8998','2014-03-04','11:10:00',2.68),('8998','2014-03-04','11:15:00',2.7),('8998','2014-03-04','11:20:00',2.67),('8998','2014-03-04','11:25:00',2.67),('8998','2014-03-04','11:30:00',2.74),('8998','2014-03-04','11:35:00',2.82),('8998','2014-03-04','11:40:00',2.78),('8998','2014-03-04','11:45:00',2.72),('8998','2014-03-04','11:50:00',2.66),('8998','2014-03-04','11:55:00',2.37),('8998','2014-03-04','12:00:00',2.29),('8998','2014-03-04','12:05:00',1.69),('8998','2014-03-04','12:35:00',1.03),('8998','2014-03-04','12:50:00',1.09),('8998','2014-03-04','12:55:00',1.5),('8998','2014-03-04','13:00:00',1.28),('8998','2014-03-04','13:05:00',1.94),('8998','2014-03-04','13:10:00',2.33),('8998','2014-03-04','13:15:00',1.59),('8998','2014-03-04','13:20:00',1.51),('8998','2014-03-04','13:25:00',1.27),('8998','2014-03-04','13:40:00',1.01),('8998','2014-03-03','09:10:00',1.22),('8998','2014-03-03','09:15:00',1.51),('8998','2014-03-03','09:20:00',2.51),('8998','2014-03-03','09:45:00',1.28),('8998','2014-03-03','09:55:00',1.21),('8998','2014-03-03','10:00:00',1.31),('8998','2014-03-03','10:25:00',2.05),('8998','2014-03-03','10:30:00',2.13),('8998','2014-03-03','10:35:00',2.5),('8998','2014-03-03','10:40:00',3.09),('8998','2014-03-03','10:45:00',3.01),('8998','2014-03-03','10:50:00',1.07),('8998','2014-03-03','10:55:00',1.73),('8998','2014-03-03','11:00:00',2.3),('8998','2014-03-03','11:05:00',1.54),('8998','2014-03-03','11:10:00',2.35),('8998','2014-03-03','11:15:00',3.41),('8998','2014-03-03','11:20:00',2.62),('8998','2014-03-03','11:45:00',1.1),('8998','2014-03-03','11:50:00',3.25),('8998','2014-03-03','11:55:00',2.88),('8998','2014-03-03','12:00:00',2.69),('8998','2014-03-03','12:05:00',2.61),('8998','2014-03-03','12:10:00',2.55),('8998','2014-03-03','12:15:00',2.49),('8998','2014-03-03','12:20:00',2.46),('8998','2014-03-03','12:25:00',2.45),('8998','2014-03-03','12:30:00',2.41),('8998','2014-03-03','12:35:00',2.35),('8998','2014-03-03','12:40:00',2.32),('8998','2014-03-03','12:45:00',1.97),('8998','2014-03-03','12:50:00',2.13),('8998','2014-03-03','12:55:00',1.62),('8998','2014-03-03','13:00:00',1.84),('8998','2014-03-03','13:05:00',1.87),('8998','2014-03-03','13:10:00',2.41),('8998','2014-03-03','13:15:00',2.17),('8998','2014-03-03','14:10:00',1.63),('8998','2014-03-03','14:15:00',1.32),('8998','2014-03-03','14:25:00',1.55),('8998','2014-03-03','14:30:00',1.31),('8998','2014-03-03','14:35:00',1.14),('8998','2014-03-03','14:40:00',1.05),('8998','2014-03-02','08:10:00',1.22),('8998','2014-03-02','08:15:00',1.7),('8998','2014-03-02','08:20:00',1.75),('8998','2014-03-02','08:25:00',1.79),('8998','2014-03-02','08:30:00',1.86),('8998','2014-03-02','08:35:00',1.89),('8998','2014-03-02','08:40:00',1.97),('8998','2014-03-02','08:45:00',2),('8998','2014-03-02','08:50:00',1.96),('8998','2014-03-02','08:55:00',2.14),('8998','2014-03-02','09:00:00',2.14),('8998','2014-03-02','09:05:00',2.13),('8998','2014-03-02','09:10:00',2.06),('8998','2014-03-02','09:15:00',2.06),('8998','2014-03-02','09:20:00',2.22),('8998','2014-03-02','09:25:00',2.32),('8998','2014-03-02','09:30:00',2.25),('8998','2014-03-02','09:35:00',1.99),('8998','2014-03-02','09:40:00',1.91),('8998','2014-03-02','09:45:00',1.82),('8998','2014-03-02','09:50:00',1.94),('8998','2014-03-02','09:55:00',2.16),('8998','2014-03-02','10:00:00',2.39),('8998','2014-03-02','10:05:00',2.48),('8998','2014-03-02','10:10:00',2.48),('8998','2014-03-02','10:15:00',2.48),('8998','2014-03-02','10:20:00',2.5),('8998','2014-03-02','10:25:00',2.51),('8998','2014-03-02','10:30:00',2.51),('8998','2014-03-02','10:35:00',2.52),('8998','2014-03-02','10:40:00',2.53),('8998','2014-03-02','10:45:00',2.55),('8998','2014-03-02','10:50:00',2.51),('8998','2014-03-02','10:55:00',2.52),('8998','2014-03-02','11:00:00',2.53),('8998','2014-03-02','11:05:00',2.52),('8998','2014-03-02','11:10:00',2.51),('8998','2014-03-02','11:15:00',2.5),('8998','2014-03-02','11:20:00',2.5),('8998','2014-03-02','11:25:00',2.51),('8998','2014-03-02','11:30:00',2.51),('8998','2014-03-02','11:35:00',2.57),('8998','2014-03-02','11:40:00',2.44),('8998','2014-03-02','11:45:00',2.52),('8998','2014-03-02','11:50:00',2.53),('8998','2014-03-02','11:55:00',2.51),('8998','2014-03-02','12:00:00',2.49),('8998','2014-03-02','12:05:00',2.47),('8998','2014-03-02','12:10:00',2.45),('8998','2014-03-02','12:15:00',2.42),('8998','2014-03-02','12:20:00',2.41),('8998','2014-03-02','12:25:00',2.38),('8998','2014-03-02','12:30:00',2.34),('8998','2014-03-02','12:35:00',2.31),('8998','2014-03-02','12:40:00',2.29),('8998','2014-03-02','12:45:00',2.24),('8998','2014-03-02','12:50:00',2.22),('8998','2014-03-02','12:55:00',2.18),('8998','2014-03-02','13:00:00',2.16),('8998','2014-03-02','13:05:00',2.11),('8998','2014-03-02','13:10:00',2.09),('8998','2014-03-02','13:15:00',2.04),('8998','2014-03-02','13:20:00',2),('8998','2014-03-02','13:25:00',1.96),('8998','2014-03-02','13:30:00',1.94),('8998','2014-03-02','13:35:00',1.89),('8998','2014-03-02','13:40:00',1.83),('8998','2014-03-02','13:45:00',1.78),('8998','2014-03-02','13:50:00',1.73),('8998','2014-03-02','13:55:00',1.69),('8998','2014-03-02','14:00:00',1.6),('8998','2014-03-02','14:05:00',1.44),('8998','2014-03-02','14:10:00',1.48),('8998','2014-03-02','14:15:00',1.48),('8998','2014-03-02','14:20:00',1.39),('8998','2014-03-02','14:25:00',1.19),('8998','2014-03-02','14:30:00',1.16),('8998','2014-03-02','14:35:00',1.12),('8998','2014-03-02','14:40:00',1.01),('8998','2014-03-01','08:10:00',1.18),('8998','2014-03-01','08:15:00',1.76),('8998','2014-03-01','08:20:00',2.08),('8998','2014-03-01','08:25:00',1.9),('8998','2014-03-01','08:30:00',1.78),('8998','2014-03-01','08:35:00',1.86),('8998','2014-03-01','08:40:00',1.92),('8998','2014-03-01','08:45:00',2),('8998','2014-03-01','08:50:00',2.06),('8998','2014-03-01','08:55:00',2.1),('8998','2014-03-01','09:00:00',2.13),('8998','2014-03-01','09:05:00',2.18),('8998','2014-03-01','09:10:00',2.26),('8998','2014-03-01','09:15:00',2.31),('8998','2014-03-01','09:20:00',1.76),('8998','2014-03-01','09:25:00',2.01),('8998','2014-03-01','09:30:00',2.42),('8998','2014-03-01','09:35:00',2.43),('8998','2014-03-01','09:40:00',1.9),('8998','2014-03-01','09:45:00',1.17),('8998','2014-03-01','10:05:00',1.13),('8998','2014-03-01','10:10:00',1.15),('8998','2014-03-01','10:30:00',1.06),('8998','2014-03-01','10:35:00',1.25),('8998','2014-03-01','10:40:00',2.46),('8998','2014-03-01','10:45:00',1.27),('8998','2014-03-01','11:00:00',1.2),('8998','2014-03-01','11:05:00',3.06),('8998','2014-03-01','11:10:00',1.34),('8998','2014-03-01','11:25:00',1.4),('8998','2014-03-01','11:30:00',1.33),('8998','2014-03-01','11:35:00',2.07),('8998','2014-03-01','11:40:00',2.64),('8998','2014-03-01','11:45:00',2.35),('8998','2014-03-01','11:50:00',3.22),('8998','2014-03-01','11:55:00',3.06),('8998','2014-03-01','12:00:00',2.07),('8998','2014-03-01','12:05:00',1.34),('8998','2014-03-01','12:10:00',1.28),('8998','2014-03-01','12:15:00',1.98),('8998','2014-03-01','12:20:00',1.51),('8998','2014-03-01','12:25:00',1.21),('8998','2014-03-01','13:00:00',1.05),('8998','2014-03-01','13:05:00',1.13),('8998','2014-03-01','13:10:00',1.16),('8998','2014-03-01','13:15:00',1.14),('8998','2014-03-01','13:20:00',1.1),('8998','2014-02-27','08:00:00',1),('8998','2014-02-27','08:20:00',1.88),('8998','2014-02-27','08:25:00',1.57),('8998','2014-02-27','08:35:00',1.41),('8998','2014-02-27','09:30:00',1.52),('8998','2014-02-27','09:35:00',1.08),('8998','2014-02-27','09:40:00',1.73),('8998','2014-02-27','09:45:00',2.37),('8998','2014-02-27','09:50:00',2.79),('8998','2014-02-27','09:55:00',2.28),('8998','2014-02-27','10:10:00',1.14),('8998','2014-02-27','10:20:00',1.29),('8998','2014-02-27','10:25:00',2.57),('8998','2014-02-27','10:30:00',2.8),('8998','2014-02-27','10:35:00',1.76),('8998','2014-02-27','12:05:00',1.32),('8998','2014-02-27','12:10:00',1.62),('8998','2014-02-27','12:30:00',1.57),('8998','2014-02-27','12:35:00',1.9),('8998','2014-02-27','12:40:00',2.38),('8998','2014-02-27','12:50:00',1.74),('8998','2014-02-27','12:55:00',1.77),('8998','2014-02-27','13:00:00',1.53),('8998','2014-02-27','13:05:00',1.17),('8998','2014-02-27','13:10:00',1.15),('8998','2014-02-27','13:50:00',1.72),('8998','2014-02-27','13:55:00',2.06),('8998','2014-02-27','14:00:00',1.05),('8998','2014-02-27','14:25:00',1.01),('8998','2014-02-27','14:30:00',1.04),('8998','2014-02-26','11:00:00',1.1),('8998','2014-02-26','11:05:00',1.22),('8998','2014-02-26','11:10:00',1.13),('8998','2014-02-26','11:15:00',1.09),('8998','2014-02-26','11:20:00',1.03),('8998','2014-02-26','11:25:00',1.05),('8998','2014-02-26','11:30:00',1.31),('8998','2014-02-26','11:35:00',1.32),('8998','2014-02-26','11:40:00',1.12),('8998','2014-02-26','13:35:00',1.09),('8998','2014-02-26','13:40:00',1.1),('8998','2014-02-26','13:45:00',1.08),('8998','2014-02-26','13:50:00',1.05),('8998','2014-02-26','13:55:00',1.18),('8998','2014-02-26','14:00:00',1.18),('8998','2014-02-26','14:05:00',1.05),('8998','2014-02-25','08:15:00',1.32),('8998','2014-02-25','08:20:00',1.52),('8998','2014-02-25','08:25:00',1.59),('8998','2014-02-25','08:30:00',1.61),('8998','2014-02-25','08:35:00',1.71),('8998','2014-02-25','08:40:00',1.77),('8998','2014-02-25','08:45:00',1.91),('8998','2014-02-25','08:50:00',1.72),('8998','2014-02-25','08:55:00',1.7),('8998','2014-02-25','09:00:00',1.93),('8998','2014-02-25','09:05:00',1.92),('8998','2014-02-25','09:10:00',1.92),('8998','2014-02-25','09:15:00',2.04),('8998','2014-02-25','09:20:00',2.05),('8998','2014-02-25','09:25:00',2.1),('8998','2014-02-25','09:30:00',1.64),('8998','2014-02-25','09:35:00',1.93),('8998','2014-02-25','09:40:00',1.45),('8998','2014-02-25','09:45:00',1.64),('8998','2014-02-25','09:50:00',1.46),('8998','2014-02-25','09:55:00',1.24),('8998','2014-02-25','10:00:00',1.1),('8998','2014-02-25','12:05:00',1.12),('8998','2014-02-25','12:10:00',1.11),('8998','2014-02-25','12:30:00',1.04),('8998','2014-02-25','12:35:00',1.57),('8998','2014-02-25','12:40:00',1.11),('8998','2014-02-25','12:45:00',2.02),('8998','2014-02-25','12:50:00',2.1),('8998','2014-02-25','12:55:00',2.2),('8998','2014-02-25','13:00:00',2.1),('8998','2014-02-25','13:05:00',1.64),('8998','2014-02-25','13:10:00',1.78),('8998','2014-02-25','13:15:00',1.78),('8998','2014-02-25','13:20:00',1.61),('8998','2014-02-25','13:25:00',1.35),('8998','2014-02-25','13:30:00',1.77),('8998','2014-02-25','13:35:00',1.48),('8998','2014-02-25','13:45:00',1.4),('8998','2014-02-25','14:00:00',1.64),('8998','2014-02-25','14:05:00',1.49),('8998','2014-02-25','14:20:00',1.3),('8998','2014-02-25','14:25:00',1.53),('8998','2014-04-28','10:05:00',1.48),('8998','2014-04-28','10:10:00',2.25),('8998','2014-04-28','10:15:00',3.2),('8998','2014-04-28','10:20:00',3.3),('8998','2014-04-28','10:25:00',3.28),('8998','2014-04-28','10:30:00',3.33),('8998','2014-04-28','10:35:00',3.22),('8998','2014-04-28','10:40:00',3.21),('8998','2014-04-28','10:45:00',3.21),('8998','2014-04-28','10:50:00',3.22),('8998','2014-04-28','10:55:00',3),('8998','2014-04-28','11:00:00',3.14),('8998','2014-04-28','11:05:00',3.09),('8998','2014-04-28','11:10:00',3.01),('8998','2014-04-28','11:15:00',2.99),('8998','2014-04-28','11:20:00',2.87),('8998','2014-04-28','11:25:00',3.31),('8998','2014-04-28','11:30:00',3.36),('8998','2014-04-28','11:35:00',2.89),('8998','2014-04-28','11:40:00',2.64),('8998','2014-04-28','11:45:00',1.82),('8998','2014-04-28','11:50:00',1.92),('8998','2014-04-28','12:05:00',2.17),('8998','2014-04-28','12:10:00',1.74),('8998','2014-04-28','12:15:00',1.61),('8998','2014-04-28','12:20:00',1.22),('8998','2014-04-28','12:25:00',3.22),('8998','2014-04-28','12:30:00',2.15),('8998','2014-04-28','12:35:00',1.28),('8998','2014-04-28','12:40:00',1.57),('8998','2014-04-28','12:45:00',1.94),('8998','2014-04-28','12:50:00',1.95),('8998','2014-04-28','12:55:00',2.2),('8998','2014-04-28','13:00:00',1.35),('8998','2014-04-28','13:05:00',1.25),('8998','2014-04-28','13:10:00',1.21),('8998','2014-04-28','13:15:00',2),('8998','2014-04-28','13:20:00',1.73),('8998','2014-04-28','13:25:00',2.85),('8998','2014-04-28','13:30:00',1.31),('8998','2014-04-28','13:35:00',1.89),('8998','2014-04-28','13:40:00',1.04),('8998','2014-02-24','08:20:00',1.43),('8998','2014-02-24','08:25:00',1.54),('8998','2014-02-24','08:30:00',1.6),('8998','2014-02-24','08:35:00',1.64),('8998','2014-02-24','08:40:00',1.69),('8998','2014-02-24','08:45:00',1.76),('8998','2014-02-24','08:50:00',1.82),('8998','2014-02-24','08:55:00',1.86),('8998','2014-02-24','09:00:00',1.91),('8998','2014-02-24','09:05:00',1.96),('8998','2014-02-24','09:10:00',2),('8998','2014-02-24','09:15:00',2.03),('8998','2014-02-24','09:20:00',2.07),('8998','2014-02-24','09:25:00',2.1),('8998','2014-02-24','09:30:00',2.13),('8998','2014-02-24','09:35:00',2.15),('8998','2014-02-24','09:40:00',2.17),('8998','2014-02-24','09:45:00',2.19),('8998','2014-02-24','09:50:00',2.21),('8998','2014-02-24','09:55:00',2.26),('8998','2014-02-24','10:00:00',2.27),('8998','2014-02-24','10:05:00',2.29),('8998','2014-02-24','10:10:00',2.3),('8998','2014-02-24','10:15:00',2.32),('8998','2014-02-24','10:20:00',2.35),('8998','2014-02-24','10:25:00',2.35),('8998','2014-02-24','10:30:00',2.36),('8998','2014-02-24','10:35:00',2.38),('8998','2014-02-24','10:40:00',2.37),('8998','2014-02-24','10:45:00',2.37),('8998','2014-02-24','10:50:00',2.36),('8998','2014-02-24','10:55:00',2.36),('8998','2014-02-24','11:00:00',2.35),('8998','2014-02-24','11:05:00',2.35),('8998','2014-02-24','11:10:00',2.36),('8998','2014-02-24','11:15:00',2.35),('8998','2014-02-24','11:20:00',2.33),('8998','2014-02-24','11:25:00',2.32),('8998','2014-02-24','11:30:00',2.31),('8998','2014-02-24','11:35:00',2.3),('8998','2014-02-24','11:40:00',2.29),('8998','2014-02-24','11:45:00',2.27),('8998','2014-02-24','11:50:00',2.26),('8998','2014-02-24','11:55:00',2.26),('8998','2014-02-24','12:00:00',2.25),('8998','2014-02-24','12:05:00',2.2),('8998','2014-02-24','12:10:00',2.2),('8998','2014-02-24','12:15:00',2.21),('8998','2014-02-24','12:20:00',2.1),('8998','2014-02-24','12:25:00',2.08),('8998','2014-02-24','12:30:00',2.12),('8998','2014-02-24','12:35:00',2.09),('8998','2014-02-24','12:40:00',2.09),('8998','2014-02-24','12:45:00',2.1),('8998','2014-02-24','12:50:00',2.07),('8998','2014-02-24','12:55:00',1.99),('8998','2014-02-24','13:00:00',1.94),('8998','2014-02-24','13:05:00',1.92),('8998','2014-02-24','13:10:00',1.89),('8998','2014-02-24','13:15:00',1.85),('8998','2014-02-24','13:20:00',1.41),('8998','2014-02-24','14:30:00',1.2),('8998','2014-02-24','14:40:00',1.18),('8998','2014-02-24','14:45:00',1.08),('8998','2014-02-23','08:20:00',1.61),('8998','2014-02-23','08:25:00',1.77),('8998','2014-02-23','08:30:00',1.85),('8998','2014-02-23','08:35:00',1.93),('8998','2014-02-23','08:40:00',1.88),('8998','2014-02-23','08:45:00',2.01),('8998','2014-02-23','08:50:00',1.92),('8998','2014-02-23','08:55:00',1.91),('8998','2014-02-23','09:00:00',1.93),('8998','2014-02-23','09:05:00',1.96),('8998','2014-02-23','09:10:00',2),('8998','2014-02-23','09:15:00',2.03),('8998','2014-02-23','09:20:00',2.07),('8998','2014-02-23','09:25:00',2.12),('8998','2014-02-23','09:30:00',2.14),('8998','2014-02-23','09:35:00',2.17),('8998','2014-02-23','09:40:00',2.2),('8998','2014-02-23','09:45:00',2.22),('8998','2014-02-23','09:50:00',2.26),('8998','2014-02-23','09:55:00',2.26),('8998','2014-02-23','10:00:00',2.29),('8998','2014-02-23','10:05:00',2.32),('8998','2014-02-23','10:10:00',2.35),('8998','2014-02-23','10:15:00',2.37),('8998','2014-02-23','10:20:00',2.39),('8998','2014-02-23','10:25:00',2.4),('8998','2014-02-23','10:30:00',2.41),('8998','2014-02-23','10:35:00',2.42),('8998','2014-02-23','10:40:00',2.42),('8998','2014-02-23','10:45:00',2.43),('8998','2014-02-23','10:50:00',2.44),('8998','2014-02-23','10:55:00',2.44),('8998','2014-02-23','11:00:00',2.42),('8998','2014-02-23','11:05:00',2.44),('8998','2014-02-23','11:10:00',2.44),('8998','2014-02-23','11:15:00',2.42),('8998','2014-02-23','11:20:00',2.45),('8998','2014-02-23','11:25:00',2.58),('8998','2014-02-23','11:30:00',2.62),('8998','2014-02-23','11:35:00',2.13),('8998','2014-02-23','11:40:00',1.68),('8998','2014-02-23','11:45:00',2.33),('8998','2014-02-23','11:50:00',2.28),('8998','2014-02-23','11:55:00',2.4),('8998','2014-02-23','12:00:00',1.76),('8998','2014-02-23','12:05:00',1.9),('8998','2014-02-23','12:15:00',1.56),('8998','2014-02-23','12:20:00',2.11),('8998','2014-02-23','12:25:00',2.44),('8998','2014-02-23','12:30:00',2.51),('8998','2014-02-23','12:35:00',2.01),('8998','2014-02-23','12:40:00',2.47),('8998','2014-02-23','12:45:00',2.2),('8998','2014-02-23','12:50:00',2.19),('8998','2014-02-23','12:55:00',2.17),('8998','2014-02-23','13:00:00',2.24),('8998','2014-02-23','13:05:00',2.1),('8998','2014-02-23','13:10:00',2.56),('8998','2014-02-23','13:15:00',2.36),('8998','2014-02-22','08:20:00',1.06),('8998','2014-02-22','08:25:00',1.51),('8998','2014-02-22','08:30:00',1.58),('8998','2014-02-22','08:35:00',1.64),('8998','2014-02-22','08:40:00',1.69),('8998','2014-02-22','08:45:00',1.75),('8998','2014-02-22','08:50:00',1.81),('8998','2014-02-22','08:55:00',1.84),('8998','2014-02-22','09:00:00',1.88),('8998','2014-02-22','09:05:00',1.93),('8998','2014-02-22','09:10:00',1.97),('8998','2014-02-22','09:15:00',2.01),('8998','2014-02-22','09:20:00',2.07),('8998','2014-02-22','09:25:00',2.06),('8998','2014-02-22','09:30:00',1.93),('8998','2014-02-22','09:35:00',2.15),('8998','2014-02-22','09:40:00',2.17),('8998','2014-02-22','09:45:00',2.18),('8998','2014-02-22','09:50:00',2.17),('8998','2014-02-22','09:55:00',2.2),('8998','2014-02-22','10:00:00',2.22),('8998','2014-02-22','10:05:00',2.24),('8998','2014-02-22','10:10:00',2.2),('8998','2014-02-22','10:15:00',2.26),('8998','2014-02-22','10:20:00',2.29),('8998','2014-02-22','10:25:00',2.31),('8998','2014-02-22','10:30:00',2.34),('8998','2014-02-22','10:35:00',2.34),('8998','2014-02-22','10:40:00',2.35),('8998','2014-02-22','10:45:00',2.35),('8998','2014-02-22','10:50:00',2.33),('8998','2014-02-22','10:55:00',1.77),('8998','2014-02-22','11:00:00',2.43),('8998','2014-02-22','11:05:00',2.42),('8998','2014-02-22','11:10:00',2.41),('8998','2014-02-22','11:15:00',2.18),('8998','2014-02-22','11:20:00',2.39),('8998','2014-02-22','11:25:00',2.38),('8998','2014-02-22','11:30:00',2.44),('8998','2014-02-22','11:35:00',2.43),('8998','2014-02-22','11:40:00',2.49),('8998','2014-02-22','11:45:00',2.42),('8998','2014-02-22','11:50:00',2.4),('8998','2014-02-22','11:55:00',2.05),('8998','2014-02-22','12:00:00',2.45),('8998','2014-02-22','12:05:00',2.45),('8998','2014-02-22','12:10:00',1.67),('8998','2014-02-22','12:15:00',2.41),('8998','2014-02-22','12:20:00',2.26),('8998','2014-02-22','12:25:00',1.28),('8998','2014-02-22','12:30:00',1.61),('8998','2014-02-22','12:35:00',2.39),('8998','2014-02-22','12:40:00',1.56),('8998','2014-02-22','12:45:00',1.44),('8998','2014-02-22','12:50:00',1.04),('8998','2014-02-22','12:55:00',1.5),('8998','2014-02-22','13:00:00',1.7),('8998','2014-02-22','13:05:00',2.06),('8998','2014-02-22','13:10:00',2),('8998','2014-02-22','13:15:00',1.95),('8998','2014-02-22','13:20:00',1.91),('8998','2014-02-22','13:25:00',1.86),('8998','2014-02-22','13:30:00',1.78),('8998','2014-02-22','13:40:00',1.64),('8998','2014-02-22','13:45:00',1.56),('8998','2014-02-22','14:00:00',1.4),('8998','2014-02-22','14:05:00',1.38),('8998','2014-02-22','14:10:00',1.5),('8998','2014-02-22','14:15:00',1.2),('8998','2014-02-22','14:20:00',1.18),('8998','2014-02-22','14:25:00',1.51),('8998','2014-02-22','14:30:00',1.27),('8998','2014-02-21','10:05:00',1.59),('8998','2014-02-21','10:10:00',1.47),('8998','2014-02-21','10:15:00',1.5),('8998','2014-02-21','10:25:00',1.25),('8998','2014-02-21','10:30:00',1.85),('8998','2014-02-21','10:35:00',1.32),('8998','2014-02-21','10:40:00',1.38),('8998','2014-02-21','10:45:00',2.37),('8998','2014-02-21','10:50:00',2.58),('8998','2014-02-21','12:10:00',1.04),('8998','2014-02-21','12:15:00',1.35),('8998','2014-02-21','12:20:00',1.04),('8998','2014-02-21','12:25:00',1.3),('8998','2014-02-21','12:45:00',2.19),('8998','2014-02-21','12:50:00',1.85),('8998','2014-02-21','13:05:00',1.22),('8998','2014-02-21','13:10:00',2.55),('8998','2014-02-21','13:15:00',1.62),('8998','2014-02-21','13:20:00',1.03),('8998','2014-02-21','13:35:00',1.04),('8998','2014-02-21','13:40:00',1),('8998','2014-02-21','13:45:00',1.07),('8998','2014-02-21','13:55:00',1.54),('8998','2014-02-21','14:00:00',1.68),('8998','2014-02-21','14:05:00',1.55),('8998','2014-02-21','14:10:00',1.45),('8998','2014-02-21','14:15:00',1.2),('8998','2014-02-21','14:20:00',1.11),('8998','2014-02-21','14:25:00',1.01),('8998','2014-02-21','14:30:00',1.11),('8998','2014-02-20','10:05:00',1.07),('8998','2014-02-20','10:10:00',1.05),('8998','2014-02-20','10:15:00',1.08),('8998','2014-02-20','10:20:00',1.47),('8998','2014-02-20','10:25:00',1.84),('8998','2014-02-20','10:30:00',2.14),('8998','2014-02-20','10:35:00',1.75),('8998','2014-02-20','10:40:00',1.42),('8998','2014-02-20','10:45:00',1.37),('8998','2014-02-20','10:50:00',1.12),('8998','2014-02-20','10:55:00',1.58),('8998','2014-02-20','11:00:00',1.45),('8998','2014-02-20','11:05:00',1.21),('8998','2014-02-20','11:10:00',1.04),('8998','2014-02-20','11:15:00',1.17),('8998','2014-02-20','11:20:00',1.17),('8998','2014-02-20','11:25:00',1.33),('8998','2014-02-20','11:30:00',2.85),('8998','2014-02-20','11:35:00',2.75),('8998','2014-02-20','11:40:00',1.9),('8998','2014-02-20','11:45:00',2.56),('8998','2014-02-20','11:50:00',1.61),('8998','2014-02-20','11:55:00',1.68),('8998','2014-02-20','12:00:00',2.95),('8998','2014-02-20','12:05:00',2.82),('8998','2014-02-20','12:10:00',2.62),('8998','2014-02-20','12:15:00',1.27),('8998','2014-02-20','12:30:00',1.01),('8998','2014-02-18','09:45:00',1.14),('8998','2014-02-18','09:50:00',1.06),('8998','2014-02-18','10:15:00',1.04),('8998','2014-02-18','10:30:00',1.03),('8998','2014-02-18','10:35:00',1.06),('8998','2014-02-18','10:40:00',1.23),('8998','2014-02-18','10:45:00',1.38),('8998','2014-02-18','10:50:00',1.27),('8998','2014-02-18','10:55:00',1.12),('8998','2014-02-18','11:05:00',1.03),('8998','2014-02-18','11:10:00',1.19),('8998','2014-02-18','11:15:00',1.17),('8998','2014-02-18','11:20:00',1.26),('8998','2014-02-18','11:25:00',1.21),('8998','2014-02-18','11:30:00',1.12),('8998','2014-02-18','11:35:00',1.06),('8998','2014-02-18','11:40:00',1.02),('8998','2014-02-18','12:05:00',1.09),('8998','2014-02-18','12:10:00',1.09),('8998','2014-02-18','12:15:00',1.03),('8998','2014-02-18','12:30:00',1.1),('8998','2014-02-18','13:35:00',1.1),('8998','2014-02-18','13:40:00',1.08),('8998','2014-02-18','13:45:00',1.12),('8998','2014-02-18','13:50:00',1.22),('8998','2014-02-18','13:55:00',1.1),('8998','2014-02-18','14:00:00',1.01),('8998','2014-02-18','14:05:00',1.09),('8998','2014-02-18','14:20:00',1.2),('8998','2014-02-17','08:25:00',1.04),('8998','2014-02-17','08:30:00',1.41),('8998','2014-02-17','08:35:00',1.48),('8998','2014-02-17','08:40:00',1.53),('8998','2014-02-17','08:45:00',1.6),('8998','2014-02-17','08:50:00',1.6),('8998','2014-02-17','08:55:00',1.7),('8998','2014-02-17','09:00:00',1.74),('8998','2014-02-17','09:05:00',1.76),('8998','2014-02-17','09:10:00',1.81),('8998','2014-02-17','09:15:00',1.85),('8998','2014-02-17','09:20:00',1.89),('8998','2014-02-17','09:25:00',1.92),('8998','2014-02-17','09:30:00',1.97),('8998','2014-02-17','09:35:00',1.99),('8998','2014-02-17','09:40:00',2.01),('8998','2014-02-17','09:45:00',2.03),('8998','2014-02-17','09:50:00',2.07),('8998','2014-02-17','09:55:00',2.1),('8998','2014-02-17','10:00:00',2.11),('8998','2014-02-17','10:05:00',2.12),('8998','2014-02-17','10:10:00',2.14),('8998','2014-02-17','10:15:00',2.15),('8998','2014-02-17','10:20:00',2.16),('8998','2014-02-17','10:25:00',2.16),('8998','2014-02-17','10:30:00',2.19),('8998','2014-02-17','10:35:00',2.19),('8998','2014-02-17','10:40:00',2.19),('8998','2014-02-17','10:45:00',2.2),('8998','2014-02-17','10:50:00',2.2),('8998','2014-02-17','10:55:00',2.21),('8998','2014-02-17','11:00:00',2.22),('8998','2014-02-17','11:05:00',1.91),('8998','2014-02-17','11:10:00',1.82),('8998','2014-02-17','11:15:00',1.76),('8998','2014-02-17','11:20:00',1.91),('8998','2014-02-17','11:25:00',2.17),('8998','2014-02-17','11:30:00',1.94),('8998','2014-02-17','11:35:00',1.79),('8998','2014-02-17','11:40:00',1.44),('8998','2014-02-17','11:45:00',1.37),('8998','2014-02-17','11:50:00',1.2),('8998','2014-02-17','11:55:00',1.04),('8998','2014-02-17','12:00:00',1.02),('8998','2014-02-17','12:05:00',1.03),('8998','2014-02-17','12:10:00',1.15),('8998','2014-02-17','12:15:00',1.26),('8998','2014-02-17','12:20:00',1.22),('8998','2014-02-17','12:25:00',1.4),('8998','2014-02-17','12:30:00',1.54),('8998','2014-02-17','12:35:00',1.22),('8998','2014-02-17','12:40:00',1.09),('8998','2014-02-17','12:45:00',1.06),('8998','2014-02-17','12:50:00',1.09),('8998','2014-02-17','12:55:00',1.21),('8998','2014-02-17','13:15:00',1.16),('8998','2014-02-17','13:20:00',1.28),('8998','2014-02-17','13:25:00',1.5),('8998','2014-02-17','13:30:00',1.15),('8998','2014-02-17','13:40:00',1.08),('8998','2014-02-17','13:45:00',1.28),('8998','2014-02-17','13:50:00',1.02),('8998','2014-02-17','14:00:00',1.08),('8998','2014-02-17','14:05:00',1.38),('8998','2014-02-16','08:30:00',1.2),('8998','2014-02-16','08:35:00',1.29),('8998','2014-02-16','08:40:00',1.33),('8998','2014-02-16','08:45:00',1.41),('8998','2014-02-16','08:50:00',1.45),('8998','2014-02-16','08:55:00',1.49),('8998','2014-02-16','09:00:00',1.52),('8998','2014-02-16','09:05:00',1.57),('8998','2014-02-16','09:10:00',1.64),('8998','2014-02-16','09:15:00',1.68),('8998','2014-02-16','09:20:00',1.72),('8998','2014-02-16','09:25:00',1.77),('8998','2014-02-16','09:30:00',1.81),('8998','2014-02-16','09:35:00',1.84),('8998','2014-02-16','09:40:00',1.87),('8998','2014-02-16','09:45:00',1.9),('8998','2014-02-16','09:50:00',1.9),('8998','2014-02-16','09:55:00',1.93),('8998','2014-02-16','10:00:00',1.96),('8998','2014-02-16','10:05:00',1.98),('8998','2014-02-16','10:10:00',1.99),('8998','2014-02-16','10:15:00',1.99),('8998','2014-02-16','10:20:00',1.98),('8998','2014-02-16','10:25:00',1.99),('8998','2014-02-16','10:30:00',2.01),('8998','2014-02-16','10:35:00',2),('8998','2014-02-16','10:40:00',2),('8998','2014-02-16','10:45:00',2),('8998','2014-02-16','10:50:00',1.99),('8998','2014-02-16','10:55:00',1.99),('8998','2014-02-16','11:00:00',1.99),('8998','2014-02-16','11:05:00',1.98),('8998','2014-02-16','11:10:00',1.98),('8998','2014-02-16','11:15:00',2),('8998','2014-02-16','11:20:00',2.01),('8998','2014-02-16','11:25:00',2.04),('8998','2014-02-16','11:30:00',2.06),('8998','2014-02-16','11:35:00',2.08),('8998','2014-02-16','11:40:00',2.09),('8998','2014-02-16','11:45:00',2.08),('8998','2014-02-16','11:50:00',2.05),('8998','2014-02-16','11:55:00',2.03),('8998','2014-02-16','12:00:00',2.03),('8998','2014-02-16','12:05:00',2.02),('8998','2014-02-16','12:10:00',2),('8998','2014-02-16','12:15:00',1.97),('8998','2014-02-16','12:20:00',1.95),('8998','2014-02-16','12:25:00',1.94),('8998','2014-02-16','12:30:00',1.91),('8998','2014-02-16','12:35:00',1.89),('8998','2014-02-16','12:40:00',1.86),('8998','2014-02-16','12:45:00',1.83),('8998','2014-02-16','12:50:00',1.8),('8998','2014-02-16','12:55:00',1.76),('8998','2014-02-16','13:00:00',1.73),('8998','2014-02-16','13:05:00',1.69),('8998','2014-02-16','13:10:00',1.65),('8998','2014-02-16','13:15:00',1.61),('8998','2014-02-16','13:20:00',1.58),('8998','2014-02-16','13:25:00',1.55),('8998','2014-02-16','13:30:00',1.52),('8998','2014-02-16','13:35:00',1.48),('8998','2014-02-16','13:40:00',1.44),('8998','2014-02-16','13:45:00',1.37),('8998','2014-02-16','13:50:00',1.32),('8998','2014-02-16','13:55:00',1.27),('8998','2014-02-16','14:00:00',1.2),('8998','2014-02-16','14:05:00',1.15),('8998','2014-02-16','14:10:00',1.06),('8998','2014-02-15','08:30:00',1.36),('8998','2014-02-15','08:35:00',1.52),('8998','2014-02-15','08:40:00',1.47),('8998','2014-02-15','08:45:00',1.66),('8998','2014-02-15','08:50:00',1.54),('8998','2014-02-15','08:55:00',1.75),('8998','2014-02-15','09:00:00',1.83),('8998','2014-02-15','09:05:00',1.86),('8998','2014-02-15','09:10:00',1.77),('8998','2014-02-15','09:15:00',1.48),('8998','2014-02-15','09:20:00',1.83),('8998','2014-02-15','09:25:00',1.83),('8998','2014-02-15','09:30:00',1.88),('8998','2014-02-15','09:35:00',1.6),('8998','2014-02-15','09:40:00',1.93),('8998','2014-02-15','09:45:00',2.03),('8998','2014-02-15','09:50:00',2.06),('8998','2014-02-15','09:55:00',1.98),('8998','2014-02-15','10:00:00',1.91),('8998','2014-02-15','10:05:00',2.13),('8998','2014-02-15','10:10:00',2.16),('8998','2014-02-15','10:15:00',2.16),('8998','2014-02-15','10:20:00',2.2),('8998','2014-02-15','10:25:00',2.18),('8998','2014-02-15','10:30:00',2.22),('8998','2014-02-15','10:35:00',2.23),('8998','2014-02-15','10:40:00',2.28),('8998','2014-02-15','10:45:00',2.27),('8998','2014-02-15','10:50:00',2.07),('8998','2014-02-15','10:55:00',1.91),('8998','2014-02-15','11:00:00',2.22),('8998','2014-02-15','11:05:00',2.24),('8998','2014-02-15','11:10:00',2.15),('8998','2014-02-15','11:15:00',2.18),('8998','2014-02-15','11:20:00',2.17),('8998','2014-02-15','11:25:00',2.01),('8998','2014-02-15','11:30:00',2.05),('8998','2014-02-15','11:35:00',2.17),('8998','2014-02-15','11:40:00',2.14),('8998','2014-02-15','11:45:00',1.89),('8998','2014-02-15','11:50:00',2.11),('8998','2014-02-15','11:55:00',1.86),('8998','2014-02-15','12:00:00',2.12),('8998','2014-02-15','12:05:00',2.07),('8998','2014-02-15','12:10:00',2.06),('8998','2014-02-15','12:15:00',2.03),('8998','2014-02-15','12:20:00',2.02),('8998','2014-02-15','12:25:00',1.94),('8998','2014-02-15','12:30:00',1.98),('8998','2014-02-15','12:35:00',1.93),('8998','2014-02-15','12:40:00',1.91),('8998','2014-02-15','12:45:00',1.86),('8998','2014-02-15','12:50:00',1.84),('8998','2014-02-15','12:55:00',1.81),('8998','2014-02-15','13:00:00',1.77),('8998','2014-02-15','13:05:00',1.73),('8998','2014-02-15','13:10:00',1.67),('8998','2014-02-15','13:15:00',1.7),('8998','2014-02-15','13:20:00',1.65),('8998','2014-02-15','13:25:00',1.59),('8998','2014-02-15','13:30:00',1.55),('8998','2014-02-15','13:35:00',1.51),('8998','2014-02-15','13:40:00',1.46),('8998','2014-02-15','13:45:00',1.43),('8998','2014-02-15','13:50:00',1.31),('8998','2014-02-15','13:55:00',1.26),('8998','2014-02-15','14:00:00',1.21),('8998','2014-02-15','14:05:00',1.14),('8998','2014-02-15','14:10:00',1.06),('8998','2014-02-15','14:15:00',1.03),('8998','2014-04-27','08:15:00',1.86),('8998','2014-04-27','08:20:00',1.87),('8998','2014-04-27','08:25:00',1.53),('8998','2014-04-27','08:30:00',1.13),('8998','2014-04-27','08:35:00',1.07),('8998','2014-04-27','08:45:00',1.09),('8998','2014-04-27','08:50:00',1.26),('8998','2014-04-27','08:55:00',1.19),('8998','2014-04-27','09:00:00',1.06),('8998','2014-04-27','09:10:00',1.34),('8998','2014-04-27','09:15:00',2.08),('8998','2014-04-27','09:20:00',2.32),('8998','2014-04-27','09:25:00',1.46),('8998','2014-04-27','09:30:00',2.49),('8998','2014-04-27','09:35:00',1.58),('8998','2014-04-27','09:40:00',1.54),('8998','2014-04-27','09:45:00',1.85),('8998','2014-04-27','09:50:00',2.96),('8998','2014-04-27','09:55:00',1.39),('8998','2014-04-27','10:00:00',1.06),('8998','2014-04-27','10:05:00',1.48),('8998','2014-04-27','10:10:00',1.72),('8998','2014-04-27','10:15:00',1.71),('8998','2014-04-27','10:20:00',1.6),('8998','2014-04-27','10:25:00',1.23),('8998','2014-04-27','10:50:00',1.37),('8998','2014-04-27','10:55:00',1.44),('8998','2014-04-27','11:00:00',1.26),('8998','2014-04-27','11:05:00',1.67),('8998','2014-04-27','11:10:00',1.88),('8998','2014-04-27','11:15:00',1.7),('8998','2014-04-27','11:20:00',1.82),('8998','2014-04-27','11:25:00',1.27),('8998','2014-04-27','11:30:00',1.27),('8998','2014-04-27','11:35:00',1.3),('8998','2014-04-27','11:40:00',1.1),('8998','2014-04-27','11:45:00',1.18),('8998','2014-04-27','11:50:00',1.26),('8998','2014-04-27','11:55:00',1.32),('8998','2014-04-27','12:00:00',1.26),('8998','2014-04-27','12:10:00',1.21),('8998','2014-04-27','12:15:00',1.99),('8998','2014-04-27','12:20:00',2.13),('8998','2014-04-27','12:25:00',2),('8998','2014-04-27','12:30:00',1.86),('8998','2014-04-27','12:35:00',1.72),('8998','2014-04-27','12:40:00',1.54),('8998','2014-04-27','12:45:00',1.33),('8998','2014-04-27','12:50:00',1.55),('8998','2014-04-27','12:55:00',1.58),('8998','2014-04-27','13:00:00',1.63),('8998','2014-04-27','13:05:00',1.85),('8998','2014-04-27','13:10:00',2.48),('8998','2014-04-27','13:15:00',1.72),('8998','2014-04-27','13:20:00',1.53),('8998','2014-04-27','13:25:00',1.83),('8998','2014-04-27','13:30:00',3.1),('8998','2014-04-27','13:35:00',2.24),('8998','2014-04-27','13:40:00',2.92),('8998','2014-04-27','13:45:00',1.38),('8998','2014-04-27','13:50:00',3.1),('8998','2014-04-27','13:55:00',2.6),('8998','2014-04-27','14:00:00',2.13),('8998','2014-04-27','14:05:00',1.36),('8998','2014-04-27','14:10:00',3.08),('8998','2014-04-27','14:15:00',2.66),('8998','2014-04-27','14:20:00',2.19),('8998','2014-04-27','14:25:00',1.93),('8998','2014-04-27','14:30:00',2.17),('8998','2014-04-27','14:35:00',2.6),('8998','2014-04-27','14:40:00',1.92),('8998','2014-04-27','14:45:00',1.66),('8998','2014-04-27','14:50:00',1.33),('8998','2014-04-27','14:55:00',1.73),('8998','2014-04-27','15:00:00',1.49),('8998','2014-04-27','15:05:00',1.85),('8998','2014-04-27','15:10:00',1.72),('8998','2014-04-27','15:15:00',1.72),('8998','2014-04-27','15:20:00',1.84),('8998','2014-04-27','15:25:00',1.32),('8998','2014-04-27','15:30:00',1),('8998','2014-04-27','15:35:00',1.15),('8998','2014-04-27','15:40:00',1.65),('8998','2014-04-27','15:50:00',1.94),('8998','2014-04-27','16:00:00',1.9),('8998','2014-04-27','16:05:00',1.89),('8998','2014-04-27','16:10:00',1.58),('8998','2014-04-27','16:20:00',1.47),('8998','2014-04-27','16:25:00',1.04),('8998','2014-04-27','16:30:00',1.32),('8998','2014-04-27','16:35:00',1.01),('8998','2014-02-14','08:30:00',1.05),('8998','2014-02-14','08:35:00',1.35),('8998','2014-02-14','08:40:00',1.42),('8998','2014-02-14','08:45:00',1.48),('8998','2014-02-14','08:50:00',1.54),('8998','2014-02-14','08:55:00',1.59),('8998','2014-02-14','09:00:00',1.64),('8998','2014-02-14','09:05:00',1.67),('8998','2014-02-14','09:10:00',1.72),('8998','2014-02-14','09:15:00',1.74),('8998','2014-02-14','09:20:00',1.79),('8998','2014-02-14','09:25:00',1.84),('8998','2014-02-14','09:30:00',1.88),('8998','2014-02-14','09:35:00',1.91),('8998','2014-02-14','09:40:00',1.95),('8998','2014-02-14','09:45:00',1.98),('8998','2014-02-14','09:50:00',1.98),('8998','2014-02-14','09:55:00',2.01),('8998','2014-02-14','10:00:00',2.04),('8998','2014-02-14','10:05:00',2.05),('8998','2014-02-14','10:10:00',2.08),('8998','2014-02-14','10:15:00',2.08),('8998','2014-02-14','10:20:00',2.09),('8998','2014-02-14','10:25:00',2.1),('8998','2014-02-14','10:30:00',2.08),('8998','2014-02-14','10:35:00',2.08),('8998','2014-02-14','10:40:00',2.1),('8998','2014-02-14','10:45:00',2.11),('8998','2014-02-14','10:50:00',2.07),('8998','2014-02-14','10:55:00',2.12),('8998','2014-02-14','11:00:00',2.07),('8998','2014-02-14','11:05:00',2.2),('8998','2014-02-14','11:10:00',1.97),('8998','2014-02-14','11:15:00',2.24),('8998','2014-02-14','11:20:00',1.53),('8998','2014-02-14','11:35:00',1.62),('8998','2014-02-14','11:40:00',1.51),('8998','2014-02-14','11:45:00',2.36),('8998','2014-02-14','11:50:00',2.24),('8998','2014-02-14','11:55:00',2.31),('8998','2014-02-14','12:00:00',1.74),('8998','2014-02-14','12:05:00',1.49),('8998','2014-02-14','12:10:00',1.06),('8998','2014-02-14','12:15:00',1.84),('8998','2014-02-14','12:20:00',2.51),('8998','2014-02-14','12:25:00',2.24),('8998','2014-02-14','12:30:00',1.13),('8998','2014-02-14','12:35:00',2),('8998','2014-02-14','12:45:00',1.55),('8998','2014-02-14','12:50:00',2.23),('8998','2014-02-14','12:55:00',2.16),('8998','2014-02-14','13:00:00',1.87),('8998','2014-02-14','13:05:00',2.06),('8998','2014-02-14','13:10:00',2.04),('8998','2014-02-14','13:15:00',1.94),('8998','2014-02-14','13:20:00',1.65),('8998','2014-02-14','13:25:00',1.62),('8998','2014-02-14','13:30:00',1.42),('8998','2014-02-14','13:35:00',1.56),('8998','2014-02-14','13:40:00',1.5),('8998','2014-02-14','13:45:00',1.39),('8998','2014-02-14','13:50:00',1.27),('8998','2014-02-14','13:55:00',1.28),('8998','2014-02-14','14:00:00',1.19),('8998','2014-02-14','14:05:00',1.12),('8998','2014-02-14','14:10:00',1.04),('8998','2014-02-13','08:40:00',1.05),('8998','2014-02-13','08:50:00',1.54),('8998','2014-02-13','08:55:00',1.6),('8998','2014-02-13','09:00:00',1.63),('8998','2014-02-13','09:05:00',1.73),('8998','2014-02-13','09:10:00',1.52),('8998','2014-02-13','09:25:00',1.68),('8998','2014-02-13','09:30:00',1.73),('8998','2014-02-13','09:50:00',1.96),('8998','2014-02-13','09:55:00',1.41),('8998','2014-02-13','10:00:00',1.74),('8998','2014-02-13','10:05:00',2.22),('8998','2014-02-13','10:10:00',1.95),('8998','2014-02-13','10:15:00',1.77),('8998','2014-02-13','10:20:00',2.22),('8998','2014-02-13','10:25:00',1.46),('8998','2014-02-13','10:30:00',2.25),('8998','2014-02-13','10:35:00',2.17),('8998','2014-02-13','10:40:00',2.03),('8998','2014-02-13','10:45:00',2.29),('8998','2014-02-13','10:50:00',2.25),('8998','2014-02-13','10:55:00',2.26),('8998','2014-02-13','11:00:00',2.25),('8998','2014-02-13','11:05:00',2.25),('8998','2014-02-13','11:10:00',2.25),('8998','2014-02-13','11:15:00',2.24),('8998','2014-02-13','11:20:00',2.25),('8998','2014-02-13','11:25:00',2.26),('8998','2014-02-13','11:30:00',2.26),('8998','2014-02-13','11:35:00',2.26),('8998','2014-02-13','11:40:00',2.28),('8998','2014-02-13','11:45:00',2.11),('8998','2014-02-13','11:50:00',2.01),('8998','2014-02-13','11:55:00',2.19),('8998','2014-02-13','12:00:00',2.17),('8998','2014-02-13','12:05:00',2.16),('8998','2014-02-13','12:10:00',1.99),('8998','2014-02-13','12:15:00',2.1),('8998','2014-02-13','12:20:00',2.08),('8998','2014-02-13','12:25:00',2.04),('8998','2014-02-13','12:30:00',2.01),('8998','2014-02-13','12:35:00',2),('8998','2014-02-13','12:40:00',1.97),('8998','2014-02-13','12:45:00',1.93),('8998','2014-02-13','12:50:00',1.89),('8998','2014-02-13','12:55:00',1.86),('8998','2014-02-13','13:00:00',1.83),('8998','2014-02-13','13:05:00',1.78),('8998','2014-02-13','13:10:00',1.76),('8998','2014-02-13','13:15:00',1.72),('8998','2014-02-13','13:20:00',1.67),('8998','2014-02-13','13:25:00',1.62),('8998','2014-02-13','13:30:00',1.59),('8998','2014-02-13','13:35:00',1.53),('8998','2014-02-13','13:40:00',1.5),('8998','2014-02-13','13:45:00',1.4),('8998','2014-02-13','13:50:00',1.33),('8998','2014-02-13','13:55:00',1.25),('8998','2014-02-13','14:00:00',1.19),('8998','2014-02-13','14:05:00',1.13),('8998','2014-02-13','14:10:00',1.03),('8998','2014-02-12','08:35:00',1.24),('8998','2014-02-12','08:40:00',1.42),('8998','2014-02-12','08:45:00',1.53),('8998','2014-02-12','08:50:00',1.61),('8998','2014-02-12','08:55:00',1.67),('8998','2014-02-12','09:00:00',1.72),('8998','2014-02-12','09:05:00',1.76),('8998','2014-02-12','09:10:00',1.8),('8998','2014-02-12','09:15:00',1.84),('8998','2014-02-12','09:20:00',1.85),('8998','2014-02-12','09:25:00',1.89),('8998','2014-02-12','09:30:00',1.92),('8998','2014-02-12','09:35:00',1.95),('8998','2014-02-12','09:40:00',1.97),('8998','2014-02-12','09:45:00',1.99),('8998','2014-02-12','09:50:00',2),('8998','2014-02-12','09:55:00',2.04),('8998','2014-02-12','10:00:00',2.07),('8998','2014-02-12','10:05:00',2.08),('8998','2014-02-12','10:10:00',2.09),('8998','2014-02-12','10:15:00',2.1),('8998','2014-02-12','10:20:00',2.11),('8998','2014-02-12','10:25:00',2.11),('8998','2014-02-12','10:30:00',2.13),('8998','2014-02-12','10:35:00',2.14),('8998','2014-02-12','10:40:00',2.15),('8998','2014-02-12','10:45:00',2.13),('8998','2014-02-12','10:50:00',2.16),('8998','2014-02-12','10:55:00',2.13),('8998','2014-02-12','11:00:00',2.15),('8998','2014-02-12','11:05:00',2.14),('8998','2014-02-12','11:10:00',1.74),('8998','2014-02-12','11:15:00',2.21),('8998','2014-02-12','11:20:00',2.21),('8998','2014-02-12','11:25:00',2.3),('8998','2014-02-12','11:30:00',1.3),('8998','2014-02-12','11:35:00',1.66),('8998','2014-02-12','11:40:00',1.77),('8998','2014-02-12','11:45:00',1.85),('8998','2014-02-12','11:50:00',1.78),('8998','2014-02-12','12:00:00',1.13),('8998','2014-02-12','12:10:00',1.01),('8998','2014-02-12','12:30:00',2.29),('8998','2014-02-12','12:35:00',2.41),('8998','2014-02-12','12:40:00',2.36),('8998','2014-02-12','12:45:00',1.03),('8998','2014-02-12','12:50:00',1.5),('8998','2014-02-12','12:55:00',1.99),('8998','2014-02-12','13:00:00',1.99),('8998','2014-02-12','13:05:00',1.89),('8998','2014-02-12','13:10:00',1.83),('8998','2014-02-12','13:15:00',1.76),('8998','2014-02-12','13:20:00',1.68),('8998','2014-02-12','13:25:00',1.65),('8998','2014-02-12','13:30:00',1.62),('8998','2014-02-12','13:35:00',1.56),('8998','2014-02-12','13:40:00',1.52),('8998','2014-02-12','13:45:00',1.44),('8998','2014-02-12','13:50:00',1.36),('8998','2014-02-12','13:55:00',1.3),('8998','2014-02-12','14:00:00',1.2),('8998','2014-02-12','14:05:00',1.12),('8998','2014-02-12','14:10:00',1.03),('8998','2014-02-11','08:45:00',1.43),('8998','2014-02-11','08:50:00',1.58),('8998','2014-02-11','08:55:00',1.67),('8998','2014-02-11','09:00:00',1.17),('8998','2014-02-11','09:10:00',1.04),('8998','2014-02-11','09:15:00',1.89),('8998','2014-02-11','09:20:00',1.95),('8998','2014-02-11','09:25:00',1.56),('8998','2014-02-11','09:40:00',1.14),('8998','2014-02-11','09:45:00',1.86),('8998','2014-02-11','09:50:00',1.23),('8998','2014-02-11','09:55:00',1.15),('8998','2014-02-11','10:05:00',1.31),('8998','2014-02-11','10:30:00',1.03),('8998','2014-02-11','10:35:00',1.18),('8998','2014-02-11','10:45:00',1.25),('8998','2014-02-11','10:50:00',1.03),('8998','2014-02-11','10:55:00',1.06),('8998','2014-02-11','11:00:00',1.01),('8998','2014-02-11','11:05:00',1.71),('8998','2014-02-11','11:10:00',1.18),('8998','2014-02-11','11:15:00',1.13),('8998','2014-02-11','11:20:00',1.24),('8998','2014-02-11','11:25:00',1.19),('8998','2014-02-11','11:30:00',1.42),('8998','2014-02-11','11:35:00',1.56),('8998','2014-02-11','12:45:00',1.02),('8998','2014-02-11','12:50:00',1.14),('8998','2014-02-11','12:55:00',1.18),('8998','2014-02-11','13:00:00',1.22),('8998','2014-02-11','13:05:00',1.01),('8998','2014-02-11','13:10:00',1.23),('8998','2014-02-11','13:30:00',1.36),('8998','2014-02-11','13:35:00',1.68),('8998','2014-02-11','13:40:00',2.09),('8998','2014-02-11','13:45:00',1.46),('8998','2014-02-11','13:50:00',1.44),('8998','2014-02-11','13:55:00',1.2),('8998','2014-02-11','14:00:00',1.5),('8998','2014-02-11','14:05:00',1.42),('8998','2014-02-11','14:10:00',1.19),('8998','2014-02-11','14:15:00',1.15),('8998','2014-02-11','14:20:00',1.04),('8998','2014-02-10','09:25:00',1.01),('8998','2014-02-10','09:55:00',1.02),('8998','2014-02-10','10:10:00',1.05),('8998','2014-02-10','10:15:00',1.25),('8998','2014-02-10','10:20:00',1.44),('8998','2014-02-10','10:25:00',1.51),('8998','2014-02-10','10:30:00',1.59),('8998','2014-02-10','10:35:00',1.8),('8998','2014-02-10','10:40:00',1.83),('8998','2014-02-10','10:45:00',1.61),('8998','2014-02-10','10:50:00',1.71),('8998','2014-02-10','10:55:00',1.45),('8998','2014-02-10','11:00:00',1.56),('8998','2014-02-10','11:05:00',1.48),('8998','2014-02-10','11:10:00',1.66),('8998','2014-02-10','11:15:00',1.4),('8998','2014-02-10','11:20:00',1.3),('8998','2014-02-10','11:25:00',1.7),('8998','2014-02-10','11:30:00',1.67),('8998','2014-02-10','11:35:00',1.13),('8998','2014-02-10','11:45:00',1.18),('8998','2014-02-10','11:50:00',1.47),('8998','2014-02-10','11:55:00',1),('8998','2014-02-10','12:05:00',1.11),('8998','2014-02-10','12:10:00',1.24),('8998','2014-02-10','12:15:00',1.07),('8998','2014-02-10','12:20:00',1.13),('8998','2014-02-10','12:25:00',1.51),('8998','2014-02-10','12:30:00',1.4),('8998','2014-02-10','12:35:00',1.25),('8998','2014-02-10','12:45:00',1.13),('8998','2014-02-10','12:55:00',1.1),('8998','2014-02-10','13:00:00',1.16),('8998','2014-02-10','13:05:00',1.34),('8998','2014-02-10','13:10:00',1.59),('8998','2014-02-10','13:15:00',1.48),('8998','2014-02-10','13:20:00',1.73),('8998','2014-02-10','13:25:00',1.57),('8998','2014-02-10','13:30:00',1.39),('8998','2014-02-10','13:35:00',1.33),('8998','2014-02-10','13:40:00',1.51),('8998','2014-02-10','13:45:00',1.23),('8998','2014-02-10','14:00:00',1.05),('8998','2014-02-10','14:05:00',1.13),('8998','2014-02-10','14:15:00',1.1),('8998','2014-02-08','12:30:00',1.04),('8998','2014-02-08','13:00:00',1.8),('8998','2014-02-08','13:05:00',1.28),('8998','2014-02-08','13:10:00',1.19),('8998','2014-02-08','13:15:00',1.12),('8998','2014-02-08','13:45:00',1.42),('8998','2014-02-08','14:05:00',1.02),('8998','2014-02-07','09:50:00',1.13),('8998','2014-02-07','09:55:00',1.25),('8998','2014-02-07','10:15:00',1.15),('8998','2014-02-07','10:20:00',1.28),('8998','2014-02-07','10:30:00',1.19),('8998','2014-02-07','10:35:00',1.64),('8998','2014-02-07','10:40:00',1.22),('8998','2014-02-07','10:45:00',1.22),('8998','2014-02-07','10:50:00',1.33),('8998','2014-02-07','10:55:00',1.87),('8998','2014-02-07','11:00:00',1.62),('8998','2014-02-07','11:05:00',2.29),('8998','2014-02-07','11:10:00',1.86),('8998','2014-02-07','11:15:00',1.5),('8998','2014-02-07','11:20:00',2.14),('8998','2014-02-07','11:30:00',1.1),('8998','2014-02-07','11:35:00',2.4),('8998','2014-02-07','11:40:00',1.7),('8998','2014-02-07','11:55:00',2.49),('8998','2014-02-07','12:00:00',1.17),('8998','2014-02-07','12:15:00',2.24),('8998','2014-02-07','12:25:00',1.06),('8998','2014-02-07','12:30:00',2.34),('8998','2014-02-07','12:35:00',1.94),('8998','2014-02-07','12:40:00',1.33),('8998','2014-02-07','12:45:00',1.78),('8998','2014-02-07','12:50:00',2.25),('8998','2014-02-07','12:55:00',2.09),('8998','2014-02-07','13:00:00',1.39),('8998','2014-02-07','13:15:00',2.04),('8998','2014-02-07','13:20:00',1.96),('8998','2014-02-07','13:25:00',1.53),('8998','2014-02-07','13:30:00',1.4),('8998','2014-02-07','13:35:00',1.58),('8998','2014-02-07','13:40:00',1.31),('8998','2014-02-07','13:45:00',1.66),('8998','2014-02-07','13:50:00',1.43),('8998','2014-02-07','13:55:00',1.29),('8998','2014-02-07','14:00:00',1.21),('8998','2014-02-07','14:05:00',1.09),('8998','2014-02-07','14:10:00',1.03),('8998','2014-02-06','08:40:00',1.02),('8998','2014-02-06','08:45:00',1.47),('8998','2014-02-06','08:50:00',1.51),('8998','2014-02-06','08:55:00',1.56),('8998','2014-02-06','09:00:00',1.61),('8998','2014-02-06','09:05:00',1.64),('8998','2014-02-06','09:10:00',1.68),('8998','2014-02-06','09:15:00',1.72),('8998','2014-02-06','09:20:00',1.75),('8998','2014-02-06','09:25:00',1.78),('8998','2014-02-06','09:30:00',1.8),('8998','2014-02-06','09:35:00',1.83),('8998','2014-02-06','09:40:00',1.85),('8998','2014-02-06','09:45:00',1.87),('8998','2014-02-06','09:50:00',1.89),('8998','2014-02-06','09:55:00',1.9),('8998','2014-02-06','10:00:00',1.91),('8998','2014-02-06','10:05:00',1.93),('8998','2014-02-06','10:10:00',1.95),('8998','2014-02-06','10:15:00',1.96),('8998','2014-02-06','10:20:00',1.98),('8998','2014-02-06','10:25:00',2.01),('8998','2014-02-06','10:30:00',2.05),('8998','2014-02-06','10:35:00',2.04),('8998','2014-02-06','10:40:00',2.11),('8998','2014-02-06','10:45:00',2.17),('8998','2014-02-06','10:50:00',2.12),('8998','2014-02-06','10:55:00',1.54),('8998','2014-02-06','11:00:00',2.02),('8998','2014-02-06','11:05:00',1.28),('8998','2014-02-06','11:10:00',1.89),('8998','2014-02-06','11:15:00',2.26),('8998','2014-02-06','11:20:00',2.26),('8998','2014-02-06','11:25:00',2.37),('8998','2014-02-06','11:30:00',2.23),('8998','2014-02-06','11:35:00',2.19),('8998','2014-02-06','11:40:00',2.05),('8998','2014-02-06','11:45:00',2.2),('8998','2014-02-06','11:50:00',1.97),('8998','2014-02-06','11:55:00',2.38),('8998','2014-02-06','12:00:00',2.36),('8998','2014-02-06','12:05:00',2.22),('8998','2014-02-06','12:10:00',2.05),('8998','2014-02-06','12:15:00',2.22),('8998','2014-02-06','12:25:00',2.14),('8998','2014-02-06','12:30:00',1.09),('8998','2014-02-06','12:55:00',1.78),('8998','2014-02-06','13:00:00',1.51),('8998','2014-02-06','13:05:00',1.06),('8998','2014-02-06','13:10:00',1.99),('8998','2014-02-06','13:15:00',1.21),('8998','2014-02-06','13:20:00',1.38),('8998','2014-02-06','13:25:00',1.12),('8998','2014-02-06','13:30:00',1.24),('8998','2014-02-06','13:35:00',1.09),('8998','2014-02-06','13:45:00',1.44),('8998','2014-02-06','13:50:00',1.25),('8998','2014-02-06','13:55:00',1.04),('8998','2014-02-06','14:00:00',1.12),('8998','2014-02-06','14:05:00',1.16),('8998','2014-02-06','14:10:00',1.11),('8998','2014-02-06','14:20:00',1.05),('8998','2014-02-05','08:40:00',1.07),('8998','2014-02-05','08:45:00',1.29),('8998','2014-02-05','08:50:00',1.49),('8998','2014-02-05','08:55:00',1.48),('8998','2014-02-05','09:00:00',1.91),('8998','2014-02-05','09:05:00',2),('8998','2014-02-05','09:10:00',1.36),('8998','2014-02-05','09:15:00',1.16),('8998','2014-02-05','09:30:00',1.74),('8998','2014-02-05','09:35:00',1.92),('8998','2014-02-05','09:40:00',1.93),('8998','2014-02-05','09:45:00',1.95),('8998','2014-02-05','09:50:00',1.96),('8998','2014-02-05','09:55:00',1.96),('8998','2014-02-05','10:00:00',1.97),('8998','2014-02-05','10:05:00',2),('8998','2014-02-05','10:10:00',2.03),('8998','2014-02-05','10:15:00',2.04),('8998','2014-02-05','10:20:00',2.06),('8998','2014-02-05','10:25:00',2.07),('8998','2014-02-05','10:30:00',2.02),('8998','2014-02-05','10:35:00',2.03),('8998','2014-02-05','10:40:00',1.23),('8998','2014-02-05','10:45:00',1.08),('8998','2014-02-05','10:50:00',1.37),('8998','2014-02-05','10:55:00',1.45),('8998','2014-02-05','11:00:00',2.22),('8998','2014-02-05','11:10:00',1.75),('8998','2014-02-05','11:15:00',1.39),('8998','2014-02-05','11:25:00',1.94),('8998','2014-02-05','11:30:00',1.9),('8998','2014-02-05','11:35:00',2.14),('8998','2014-02-05','11:40:00',2.13),('8998','2014-02-05','11:45:00',2.11),('8998','2014-02-05','11:50:00',2.1),('8998','2014-02-05','11:55:00',2.11),('8998','2014-02-05','12:00:00',2.12),('8998','2014-02-05','12:05:00',2.18),('8998','2014-02-05','12:10:00',2.17),('8998','2014-02-05','12:15:00',2.06),('8998','2014-02-05','12:20:00',2.01),('8998','2014-02-05','12:25:00',1.99),('8998','2014-02-05','12:30:00',1.98),('8998','2014-02-05','12:35:00',1.99),('8998','2014-02-05','12:40:00',1.85),('8998','2014-02-05','12:45:00',1.64),('8998','2014-02-05','12:50:00',1.81),('8998','2014-02-05','12:55:00',1.78),('8998','2014-02-05','13:00:00',1.76),('8998','2014-02-05','13:05:00',1.76),('8998','2014-02-05','13:10:00',1.78),('8998','2014-02-05','13:15:00',1.78),('8998','2014-02-05','13:20:00',1.8),('8998','2014-02-05','13:25:00',1.8),('8998','2014-02-05','13:30:00',1.19),('8998','2014-02-05','13:35:00',1.55),('8998','2014-02-05','13:40:00',1.48),('8998','2014-02-05','13:45:00',1.19),('8998','2014-02-05','13:50:00',1.22),('8998','2014-02-05','14:00:00',1.15),('8998','2014-02-05','14:05:00',1.13),('8998','2014-04-26','11:10:00',1.11),('8998','2014-04-26','11:15:00',1.05),('8998','2014-04-26','11:40:00',1.1),('8998','2014-04-26','11:45:00',2.24),('8998','2014-04-26','11:50:00',2.14),('8998','2014-04-26','11:55:00',1.73),('8998','2014-04-26','12:00:00',1.81),('8998','2014-04-26','12:05:00',1.93),('8998','2014-04-26','12:10:00',2.2),('8998','2014-04-26','12:15:00',2.18),('8998','2014-04-26','12:20:00',1.98),('8998','2014-04-26','12:25:00',2.04),('8998','2014-04-26','12:30:00',1.86),('8998','2014-04-26','12:35:00',1.86),('8998','2014-04-26','12:40:00',1.69),('8998','2014-04-26','12:45:00',1.81),('8998','2014-04-26','12:50:00',1.65),('8998','2014-04-26','12:55:00',1.17),('8998','2014-04-26','13:00:00',1.34),('8998','2014-04-26','13:05:00',1.46),('8998','2014-04-26','13:10:00',1.25),('8998','2014-04-26','13:15:00',1.21),('8998','2014-04-26','13:20:00',1.61),('8998','2014-04-26','13:25:00',1.59),('8998','2014-04-26','13:30:00',1.41),('8998','2014-04-26','13:35:00',1.24),('8998','2014-04-26','13:40:00',1.14),('8998','2014-04-26','13:45:00',1.08),('8998','2014-04-26','14:00:00',1.12),('8998','2014-04-26','14:05:00',1.59),('8998','2014-04-26','14:10:00',1.23),('8998','2014-04-26','14:15:00',1.02),('8998','2014-04-26','14:20:00',1.17),('8998','2014-04-26','14:25:00',1.45),('8998','2014-04-26','14:30:00',1.57),('8998','2014-04-26','14:35:00',1.53),('8998','2014-04-26','14:40:00',1.58),('8998','2014-04-26','14:45:00',1.44),('8998','2014-04-26','14:50:00',1.34),('8998','2014-04-26','14:55:00',1.39),('8998','2014-04-26','15:00:00',1.44),('8998','2014-04-26','15:05:00',1.88),('8998','2014-04-26','15:10:00',2.4),('8998','2014-04-26','15:15:00',1.91),('8998','2014-04-26','15:20:00',1.32),('8998','2014-02-04','10:15:00',1.07),('8998','2014-02-04','10:20:00',1.95),('8998','2014-02-04','10:25:00',2.29),('8998','2014-02-04','11:15:00',2.14),('8998','2014-02-04','11:20:00',2.23),('8998','2014-02-04','11:25:00',2.28),('8998','2014-02-04','13:25:00',1.02),('8998','2014-02-04','13:30:00',1.02),('8998','2014-02-04','13:35:00',1.19),('8998','2014-02-04','13:40:00',1.21),('8998','2014-02-04','13:45:00',1.29),('8998','2014-02-04','13:50:00',1.05),('8998','2014-02-04','14:35:00',1.02),('8998','2014-02-03','09:20:00',1.16),('8998','2014-02-03','09:25:00',1.58),('8998','2014-02-03','09:30:00',1.72),('8998','2014-02-03','09:35:00',2.23),('8998','2014-02-03','09:40:00',2.07),('8998','2014-02-03','09:45:00',1.94),('8998','2014-02-03','09:50:00',1.88),('8998','2014-02-03','09:55:00',1.9),('8998','2014-02-03','10:00:00',2.12),('8998','2014-02-03','10:05:00',1.88),('8998','2014-02-03','10:10:00',1.11),('8998','2014-02-03','10:15:00',1.71),('8998','2014-02-03','10:20:00',1),('8998','2014-02-03','10:45:00',1.01),('8998','2014-02-03','10:50:00',1.55),('8998','2014-02-03','10:55:00',2.11),('8998','2014-02-03','11:00:00',1.06),('8998','2014-02-03','11:55:00',1.83),('8998','2014-02-03','12:00:00',2.22),('8998','2014-02-03','12:05:00',1.16),('8998','2014-02-03','12:15:00',1.03),('8998','2014-02-03','12:25:00',1),('8998','2014-01-31','11:20:00',1.45),('8998','2014-01-31','11:30:00',1.39),('8998','2014-01-31','11:35:00',1.38),('8998','2014-01-31','11:55:00',1.15),('8998','2014-01-31','12:00:00',1.25),('8998','2014-01-31','12:10:00',1.5),('8998','2014-01-31','12:20:00',1.42),('8998','2014-01-31','12:25:00',1.01),('8998','2014-01-31','12:40:00',1.03),('8998','2014-01-31','12:45:00',1.39),('8998','2014-01-31','12:50:00',1.28),('8998','2014-01-29','09:55:00',1.71),('8998','2014-01-29','10:00:00',1.66),('8998','2014-01-29','10:05:00',1.48),('8998','2014-01-29','10:10:00',1.57),('8998','2014-01-29','10:15:00',1.86),('8998','2014-01-29','10:20:00',1.59),('8998','2014-01-29','10:25:00',1.77),('8998','2014-01-29','10:30:00',1.92),('8998','2014-01-29','10:35:00',1.89),('8998','2014-01-29','10:40:00',1.89),('8998','2014-01-29','10:45:00',1.66),('8998','2014-01-29','10:50:00',1.95),('8998','2014-01-29','10:55:00',2.26),('8998','2014-01-29','11:00:00',2.25),('8998','2014-01-29','11:05:00',2.11),('8998','2014-01-29','11:10:00',2.05),('8998','2014-01-29','11:15:00',1.94),('8998','2014-01-29','11:20:00',1.82),('8998','2014-01-29','11:25:00',1.95),('8998','2014-01-29','11:30:00',1.66),('8998','2014-01-29','11:35:00',1.76),('8998','2014-01-29','11:40:00',1.02),('8998','2014-01-29','11:45:00',1.68),('8998','2014-01-29','11:55:00',2.16),('8998','2014-01-29','12:00:00',1.25),('8998','2014-01-29','12:05:00',1.76),('8998','2014-01-29','12:10:00',1.25),('8998','2014-01-29','12:15:00',1.06),('8998','2014-01-29','12:20:00',1.57),('8998','2014-01-29','12:25:00',1.69),('8998','2014-01-29','12:30:00',1.29),('8998','2014-01-29','12:35:00',1.35),('8998','2014-01-29','12:40:00',1.44),('8998','2014-01-29','12:45:00',1.54),('8998','2014-01-29','12:50:00',1.49),('8998','2014-01-29','12:55:00',1.46),('8998','2014-01-29','13:05:00',1.34),('8998','2014-01-29','13:15:00',1.42),('8998','2014-01-29','13:20:00',1.13),('8998','2014-01-29','13:25:00',1.44),('8998','2014-01-29','13:30:00',1.18),('8998','2014-01-29','13:35:00',1.01),('8998','2014-01-29','13:40:00',1.14),('8998','2014-01-29','13:45:00',1.28),('8998','2014-01-29','13:50:00',1.12),('8998','2014-01-28','09:20:00',1.34),('8998','2014-01-28','09:30:00',1.1),('8998','2014-01-28','09:35:00',1.45),('8998','2014-01-28','09:40:00',1.39),('8998','2014-01-28','09:45:00',1.51),('8998','2014-01-28','09:50:00',1.27),('8998','2014-01-28','09:55:00',1.36),('8998','2014-01-28','10:00:00',1.16),('8998','2014-01-28','10:05:00',1.11),('8998','2014-01-28','10:10:00',1.19),('8998','2014-01-28','10:15:00',1.21),('8998','2014-01-28','10:25:00',1.81),('8998','2014-01-28','10:30:00',1.84),('8998','2014-01-28','10:35:00',1.56),('8998','2014-01-28','10:40:00',1.39),('8998','2014-01-28','10:45:00',1.38),('8998','2014-01-28','10:50:00',1.31),('8998','2014-01-28','10:55:00',1.23),('8998','2014-01-28','11:00:00',1.24),('8998','2014-01-28','11:05:00',1.41),('8998','2014-01-28','11:10:00',1.28),('8998','2014-01-28','11:15:00',1.27),('8998','2014-01-28','11:20:00',1.35),('8998','2014-01-28','11:25:00',1.32),('8998','2014-01-28','11:30:00',1.74),('8998','2014-01-28','11:35:00',1.61),('8998','2014-01-28','11:40:00',1.4),('8998','2014-01-28','12:50:00',1.46),('8998','2014-01-28','12:55:00',1.76),('8998','2014-01-28','13:00:00',1.63),('8998','2014-01-28','13:40:00',1.49),('8998','2014-01-27','09:10:00',1.16),('8998','2014-01-27','09:15:00',1.24),('8998','2014-01-27','09:20:00',1.21),('8998','2014-01-27','09:25:00',1.23),('8998','2014-01-27','09:30:00',1.17),('8998','2014-01-27','09:35:00',1.33),('8998','2014-01-27','09:40:00',1.16),('8998','2014-01-27','09:45:00',1.25),('8998','2014-01-27','09:50:00',1.57),('8998','2014-01-27','09:55:00',1.68),('8998','2014-01-27','10:00:00',1.84),('8998','2014-01-27','10:05:00',1.79),('8998','2014-01-27','10:10:00',1.75),('8998','2014-01-27','10:15:00',1.76),('8998','2014-01-27','10:20:00',1.8),('8998','2014-01-27','10:25:00',1.89),('8998','2014-01-27','10:30:00',1.86),('8998','2014-01-27','10:35:00',1.91),('8998','2014-01-27','10:40:00',1.93),('8998','2014-01-27','10:45:00',1.62),('8998','2014-01-27','10:50:00',1.84),('8998','2014-01-27','10:55:00',1.84),('8998','2014-01-27','11:00:00',1.88),('8998','2014-01-27','11:10:00',1.17),('8998','2014-01-27','11:15:00',1.51),('8998','2014-01-27','11:30:00',1.5),('8998','2014-01-27','11:35:00',1.37),('8998','2014-01-27','11:40:00',1.93),('8998','2014-01-27','11:45:00',1.44),('8998','2014-01-27','11:50:00',1.26),('8998','2014-01-27','12:00:00',1.43),('8998','2014-01-27','12:05:00',1.47),('8998','2014-01-27','12:10:00',1.2),('8998','2014-01-27','12:15:00',1.63),('8998','2014-01-27','12:20:00',1.31),('8998','2014-01-27','12:40:00',1.12),('8998','2014-01-27','12:45:00',1.1),('8998','2014-01-27','12:50:00',1.98),('8998','2014-01-27','12:55:00',1.67),('8998','2014-01-27','13:00:00',1.83),('8998','2014-01-27','13:05:00',2),('8998','2014-01-27','13:10:00',1.5),('8998','2014-01-27','13:15:00',1.37),('8998','2014-01-27','13:20:00',1.33),('8998','2014-01-27','13:25:00',1.44),('8998','2014-01-27','13:30:00',1.41),('8998','2014-01-27','13:35:00',1.5),('8998','2014-01-27','13:40:00',1.38),('8998','2014-01-27','13:45:00',1.25),('8998','2014-01-27','13:50:00',1.1),('8998','2014-01-27','13:55:00',1.02),('9303','2014-05-05','07:50:00',1.02),('9303','2014-05-05','07:55:00',1.13),('9303','2014-05-05','08:00:00',1.23),('9303','2014-05-05','08:05:00',1.33),('9303','2014-05-05','08:10:00',1.44),('9303','2014-05-05','08:15:00',1.54),('9303','2014-05-05','08:20:00',1.66),('9303','2014-05-05','08:25:00',1.77),('9303','2014-05-05','08:30:00',1.87),('9303','2014-05-05','08:35:00',1.97),('9303','2014-05-05','08:40:00',2.06),('9303','2014-05-05','08:45:00',2.15),('9303','2014-05-05','08:50:00',2.25),('9303','2014-05-05','08:55:00',2.31),('9303','2014-05-05','09:00:00',2.38),('9303','2014-05-05','09:05:00',2.44),('9303','2014-05-05','09:10:00',2.49),('9303','2014-05-05','09:15:00',2.61),('9303','2014-05-05','09:20:00',2.66),('9303','2014-05-05','09:25:00',2.76),('9303','2014-05-05','09:30:00',2.86),('9303','2014-05-05','09:35:00',2.92),('9303','2014-05-05','09:40:00',2.99),('9303','2014-05-05','09:45:00',3.08),('9303','2014-05-05','09:50:00',3.15),('9303','2014-05-05','09:55:00',3.21),('9303','2014-05-05','10:00:00',3.28),('9303','2014-05-05','10:05:00',3.38),('9303','2014-05-05','10:10:00',3.43),('9303','2014-05-05','10:15:00',3.45),('9303','2014-05-05','10:20:00',3.46),('9303','2014-05-05','10:25:00',3.54),('9303','2014-05-05','10:30:00',3.6),('9303','2014-05-05','10:35:00',3.66),('9303','2014-05-05','10:40:00',3.67),('9303','2014-05-05','10:45:00',3.7),('9303','2014-05-05','10:50:00',3.78),('9303','2014-05-05','10:55:00',3.79),('9303','2014-05-05','11:00:00',3.85),('9303','2014-05-05','11:05:00',3.85),('9303','2014-05-05','11:10:00',3.89),('9303','2014-05-05','11:15:00',3.92),('9303','2014-05-05','11:20:00',3.93),('9303','2014-05-05','11:25:00',3.78),('9303','2014-05-05','11:30:00',3.98),('9303','2014-05-05','11:35:00',3.99),('9303','2014-05-05','11:40:00',4.05),('9303','2014-05-05','11:45:00',4.11),('9303','2014-05-05','11:50:00',4.12),('9303','2014-05-05','11:55:00',4.31),('9303','2014-05-05','12:00:00',4.35),('9303','2014-05-05','12:05:00',2.75),('9303','2014-05-05','12:10:00',2.32),('9303','2014-05-05','12:15:00',2.08),('9303','2014-05-05','12:20:00',2.08),('9303','2014-05-05','12:25:00',3.53),('9303','2014-05-05','12:30:00',3.77),('9303','2014-05-05','12:35:00',1.96),('9303','2014-05-05','12:40:00',1.46),('9303','2014-05-05','12:45:00',4.18),('9303','2014-05-05','12:50:00',4.07),('9303','2014-05-05','12:55:00',2.22),('9303','2014-05-05','13:00:00',3.48),('9303','2014-05-05','13:05:00',3.81),('9303','2014-05-05','13:10:00',4.47),('9303','2014-05-05','13:15:00',4.43),('9303','2014-05-05','13:20:00',4.39),('9303','2014-05-05','13:25:00',4.32),('9303','2014-05-05','13:30:00',4.31),('9303','2014-05-05','13:35:00',4.36),('9303','2014-05-05','13:40:00',4.35),('9303','2014-05-05','13:45:00',4.37),('9303','2014-05-05','13:50:00',4.35),('9303','2014-05-05','13:55:00',4.34),('9303','2014-05-05','14:00:00',4.29),('9303','2014-05-05','14:05:00',4.43),('9303','2014-05-05','14:10:00',4.53),('9303','2014-05-05','14:15:00',4.59),('9303','2014-05-05','14:20:00',4.82),('9303','2014-05-05','14:25:00',4.09),('9303','2014-05-05','14:30:00',2.1),('9303','2014-05-05','14:35:00',1.99),('9303','2014-05-05','14:40:00',1.39),('9303','2014-05-05','14:45:00',1.21),('9303','2014-05-05','14:50:00',1.24),('9303','2014-05-05','14:55:00',1.69),('9303','2014-05-05','15:00:00',1.86),('9303','2014-05-05','15:05:00',1.59),('9303','2014-05-05','15:10:00',1.39),('9303','2014-05-05','15:15:00',1.26),('9303','2014-05-05','15:20:00',1.33),('9303','2014-05-05','15:25:00',2.88),('9303','2014-05-05','15:30:00',4.08),('9303','2014-05-05','15:35:00',2.14),('9303','2014-05-05','15:40:00',2.48),('9303','2014-05-05','15:45:00',2.24),('9303','2014-05-05','15:50:00',1.28),('9303','2014-05-05','15:55:00',1.35),('9303','2014-05-05','16:00:00',1.6),('9303','2014-05-05','16:05:00',2.65),('9303','2014-05-05','16:10:00',1.19),('9303','2014-05-05','16:15:00',1.35),('9303','2014-05-05','16:20:00',1.16),('9303','2014-05-05','16:40:00',1.66),('9303','2014-05-05','16:45:00',2.33),('9303','2014-05-05','16:50:00',2.12),('9303','2014-05-05','16:55:00',2.6),('9303','2014-05-05','17:00:00',2.44),('9303','2014-05-05','17:05:00',2.18),('9303','2014-05-05','17:10:00',2.27),('9303','2014-05-05','17:15:00',2.21),('9303','2014-05-05','17:20:00',2.14),('9303','2014-05-05','17:25:00',1.96),('9303','2014-05-05','17:30:00',1.82),('9303','2014-05-05','17:35:00',1.74),('9303','2014-05-05','17:40:00',1.65),('9303','2014-05-05','17:45:00',1.53),('9303','2014-05-05','17:50:00',1.45),('9303','2014-05-05','17:55:00',1.36),('9303','2014-05-05','18:00:00',1.23),('9303','2014-05-05','18:05:00',1.14),('9303','2014-05-05','18:10:00',1.06),('9303','2014-04-26','09:55:00',1.36),('9303','2014-04-26','10:00:00',1.36),('9303','2014-04-26','10:05:00',1.25),('9303','2014-04-26','10:10:00',1.22),('9303','2014-04-26','10:15:00',1.26),('9303','2014-04-26','10:20:00',1.34),('9303','2014-04-26','10:25:00',1.45),('9303','2014-04-26','10:30:00',1.93),('9303','2014-04-26','10:35:00',1.91),('9303','2014-04-26','10:40:00',1.68),('9303','2014-04-26','10:45:00',1.81),('9303','2014-04-26','10:50:00',2.43),('9303','2014-04-26','10:55:00',3.04),('9303','2014-04-26','11:00:00',3.54),('9303','2014-04-26','11:05:00',2.57),('9303','2014-04-26','11:10:00',3.32),('9303','2014-04-26','11:15:00',3.26),('9303','2014-04-26','11:20:00',3.12),('9303','2014-04-26','11:25:00',3),('9303','2014-04-26','11:30:00',2.99),('9303','2014-04-26','11:35:00',2.99),('9303','2014-04-26','11:40:00',2.86),('9303','2014-04-26','11:45:00',3.14),('9303','2014-04-26','11:50:00',3.16),('9303','2014-04-26','11:55:00',2.72),('9303','2014-04-26','12:00:00',3.1),('9303','2014-04-26','12:05:00',2.96),('9303','2014-04-26','12:10:00',3.22),('9303','2014-04-26','12:15:00',3.05),('9303','2014-04-26','12:20:00',2.8),('9303','2014-04-26','12:25:00',1.8),('9303','2014-04-26','12:30:00',2.29),('9303','2014-04-26','12:35:00',3.24),('9303','2014-04-26','12:40:00',3.35),('9303','2014-04-26','12:45:00',3.06),('9303','2014-04-26','12:50:00',4.08),('9303','2014-04-26','12:55:00',4.28),('9303','2014-04-26','13:00:00',4.14),('9303','2014-04-26','13:05:00',3.34),('9303','2014-04-26','13:10:00',3.09),('9303','2014-04-26','13:15:00',4.43),('9303','2014-04-26','13:20:00',4.37),('9303','2014-04-26','13:25:00',2.77),('9303','2014-04-26','13:30:00',1.42),('9303','2014-04-26','13:35:00',2.38),('9303','2014-04-26','13:40:00',4.48),('9303','2014-04-26','13:45:00',4.17),('9303','2014-04-26','13:50:00',4.2),('9303','2014-04-26','13:55:00',4.47),('9303','2014-04-26','14:00:00',2.68),('9303','2014-04-26','14:10:00',3.2),('9303','2014-04-26','14:35:00',1.85),('9303','2014-04-26','14:40:00',2.16),('9303','2014-01-26','09:05:00',1.01),('9303','2014-01-26','09:30:00',1.31),('9303','2014-01-26','09:35:00',1.4),('9303','2014-01-26','09:45:00',1.15),('9303','2014-01-26','09:50:00',1.35),('9303','2014-01-26','10:10:00',1.55),('9303','2014-01-26','10:15:00',2.13),('9303','2014-01-26','10:20:00',1.02),('9303','2014-01-26','12:20:00',1.1),('9303','2014-01-26','12:25:00',1.21),('9303','2014-01-26','12:30:00',2.09),('9303','2014-01-26','12:35:00',1.95),('9303','2014-01-26','12:40:00',1.16),('9303','2014-01-26','12:45:00',1.02),('9303','2014-01-26','13:05:00',1.05),('9303','2014-01-26','13:10:00',1.15),('9303','2014-01-26','13:15:00',1.48),('9303','2014-01-26','13:20:00',1.45),('9303','2014-01-26','13:25:00',1.09),('9303','2014-01-26','15:45:00',1.1),('9303','2014-01-25','09:05:00',1.08),('9303','2014-01-25','09:20:00',1.04),('9303','2014-01-25','09:50:00',1.06),('9303','2014-01-25','09:55:00',1.35),('9303','2014-01-25','10:00:00',1.29),('9303','2014-01-25','10:05:00',1.69),('9303','2014-01-25','10:10:00',2.22),('9303','2014-01-25','10:15:00',2.32),('9303','2014-01-25','10:20:00',2.16),('9303','2014-01-25','10:25:00',1.42),('9303','2014-01-25','10:30:00',1.39),('9303','2014-01-25','10:35:00',1.44),('9303','2014-01-25','10:40:00',1.62),('9303','2014-01-25','10:45:00',1.45),('9303','2014-01-25','10:50:00',1.61),('9303','2014-01-25','10:55:00',1.43),('9303','2014-01-25','11:00:00',1.25),('9303','2014-01-25','11:05:00',1.18),('9303','2014-01-25','11:20:00',1.03),('9303','2014-01-25','11:25:00',1.32),('9303','2014-01-25','11:30:00',3.13),('9303','2014-01-25','11:35:00',3.04),('9303','2014-01-25','11:40:00',1.65),('9303','2014-01-25','11:45:00',1.35),('9303','2014-01-25','11:50:00',1.45),('9303','2014-01-25','11:55:00',1.45),('9303','2014-01-25','12:00:00',1.44),('9303','2014-01-25','12:05:00',1.54),('9303','2014-01-25','12:10:00',1.66),('9303','2014-01-25','12:15:00',1.56),('9303','2014-01-25','12:20:00',1.65),('9303','2014-01-25','12:25:00',1.7),('9303','2014-01-25','12:30:00',1.64),('9303','2014-01-25','12:35:00',1.44),('9303','2014-01-25','12:40:00',1.54),('9303','2014-01-25','12:45:00',1.87),('9303','2014-01-25','12:50:00',1.97),('9303','2014-01-25','12:55:00',2.3),('9303','2014-01-25','13:00:00',2.3),('9303','2014-01-25','13:05:00',2.57),('9303','2014-01-25','13:10:00',2.48),('9303','2014-01-25','13:15:00',1.88),('9303','2014-01-25','13:20:00',1.17),('9303','2014-01-25','13:25:00',1.08),('9303','2014-01-25','13:30:00',1.59),('9303','2014-01-25','13:35:00',1.08),('9303','2014-01-25','13:45:00',1.4),('9303','2014-01-25','13:50:00',1.23),('9303','2014-01-25','14:00:00',1.49),('9303','2014-01-25','14:05:00',1.76),('9303','2014-01-25','14:10:00',1.76),('9303','2014-01-25','14:15:00',1.4),('9303','2014-01-25','14:20:00',1.91),('9303','2014-01-25','14:25:00',1.99),('9303','2014-01-25','14:30:00',2.29),('9303','2014-01-25','14:35:00',1.83),('9303','2014-01-25','14:40:00',2.2),('9303','2014-01-25','14:45:00',2.2),('9303','2014-01-25','14:50:00',2.08),('9303','2014-01-25','14:55:00',1.91),('9303','2014-01-25','15:00:00',1.72),('9303','2014-01-25','15:05:00',1.58),('9303','2014-01-25','15:10:00',1.48),('9303','2014-01-25','15:15:00',1.38),('9303','2014-01-25','15:20:00',1.29),('9303','2014-01-25','15:25:00',1.2),('9303','2014-01-25','15:30:00',1.1),('9303','2014-01-25','15:35:00',1.02),('9303','2014-01-24','10:10:00',1.07),('9303','2014-01-24','10:15:00',1.39),('9303','2014-01-24','10:30:00',1.43),('9303','2014-01-24','10:35:00',1.02),('9303','2014-01-24','10:40:00',1.65),('9303','2014-01-24','10:45:00',1.55),('9303','2014-01-24','11:30:00',1.13),('9303','2014-01-24','11:35:00',1.5),('9303','2014-01-24','11:45:00',1.1),('9303','2014-01-24','11:50:00',2.53),('9303','2014-01-24','11:55:00',2.39),('9303','2014-01-24','12:00:00',1.59),('9303','2014-01-24','12:05:00',1.49),('9303','2014-01-24','12:25:00',1.51),('9303','2014-01-24','12:30:00',1.24),('9303','2014-01-24','12:35:00',2.43),('9303','2014-01-24','12:40:00',2.47),('9303','2014-01-24','12:45:00',1.72),('9303','2014-01-24','12:50:00',1.24),('9303','2014-01-24','12:55:00',1.23),('9303','2014-01-24','13:00:00',1.46),('9303','2014-01-24','13:05:00',1.68),('9303','2014-01-24','13:10:00',1.19),('9303','2014-01-24','13:35:00',1.27),('9303','2014-01-24','13:40:00',1.14),('9303','2014-01-24','14:00:00',1.11),('9303','2014-01-24','14:10:00',2.07),('9303','2014-01-24','14:15:00',2.38),('9303','2014-01-24','14:20:00',2.11),('9303','2014-01-24','14:25:00',2.14),('9303','2014-01-24','14:45:00',1.12),('9303','2014-01-23','11:15:00',1),('9303','2014-01-22','13:15:00',1.09),('9303','2014-01-21','10:00:00',1.11),('9303','2014-01-21','10:05:00',1.1),('9303','2014-01-21','10:55:00',1.45),('9303','2014-01-21','11:00:00',2.1),('9303','2014-01-21','11:05:00',1.08),('9303','2014-01-21','11:50:00',1.02),('9303','2014-01-21','11:55:00',1.05),('9303','2014-01-21','12:05:00',1.55),('9303','2014-01-21','12:10:00',1.93),('9303','2014-01-21','12:15:00',1.61),('9303','2014-01-21','12:20:00',1.1),('9303','2014-01-21','12:25:00',1.16),('9303','2014-01-21','12:30:00',2.04),('9303','2014-01-21','12:35:00',1.35),('9303','2014-01-21','12:40:00',1.27),('9303','2014-01-21','12:45:00',1.32),('9303','2014-01-21','12:50:00',1.67),('9303','2014-01-21','13:20:00',1.1),('9303','2014-01-21','14:05:00',1.22),('9303','2014-01-21','14:10:00',1.12),('9303','2014-01-20','11:20:00',1.27),('9303','2014-01-20','11:25:00',1.65),('9303','2014-01-20','11:30:00',1.75),('9303','2014-01-20','11:35:00',1.71),('9303','2014-01-20','11:40:00',2.42),('9303','2014-01-20','11:45:00',2.62),('9303','2014-01-20','11:50:00',1.44),('9303','2014-01-20','13:20:00',3.25),('9303','2014-01-20','13:25:00',2.97),('9303','2014-01-20','13:30:00',2.59),('9303','2014-01-20','13:35:00',2.46),('9303','2014-01-20','13:40:00',2.01),('9303','2014-01-20','13:45:00',1.82),('9303','2014-01-20','13:50:00',1.07),('9303','2014-01-20','13:55:00',1.02),('9303','2014-01-20','14:00:00',2.57),('9303','2014-01-20','14:05:00',1.86),('9303','2014-01-20','14:10:00',1.37),('9303','2014-01-19','13:10:00',1.03),('9303','2014-01-19','14:20:00',1.13),('9303','2014-01-19','14:25:00',1.48),('9303','2014-01-19','14:30:00',1.73),('9303','2014-01-19','14:35:00',1.13),('9303','2014-01-18','10:00:00',1.08),('9303','2014-01-18','10:05:00',1.33),('9303','2014-01-18','10:10:00',1.75),('9303','2014-01-18','10:15:00',1.96),('9303','2014-01-18','10:20:00',1.74),('9303','2014-01-18','10:25:00',1.26),('9303','2014-01-18','10:30:00',1.42),('9303','2014-01-18','10:50:00',1.09),('9303','2014-01-18','10:55:00',1.04),('9303','2014-01-18','11:05:00',1.01),('9303','2014-01-18','11:10:00',1.44),('9303','2014-01-18','11:15:00',2.14),('9303','2014-01-18','11:20:00',2.04),('9303','2014-01-18','11:25:00',1.97),('9303','2014-01-18','11:30:00',2),('9303','2014-01-18','11:35:00',2.04),('9303','2014-01-18','11:40:00',2.1),('9303','2014-01-18','11:45:00',2.37),('9303','2014-01-18','11:50:00',2.24),('9303','2014-01-18','11:55:00',2.57),('9303','2014-01-18','12:00:00',2.37),('9303','2014-01-18','12:05:00',1.95),('9303','2014-01-18','12:10:00',2.22),('9303','2014-01-18','12:15:00',2.11),('9303','2014-01-18','12:20:00',2.13),('9303','2014-01-18','12:25:00',2.18),('9303','2014-01-18','12:30:00',2.24),('9303','2014-01-18','12:35:00',2.27),('9303','2014-01-18','12:40:00',2.33),('9303','2014-01-18','12:45:00',2.31),('9303','2014-01-18','12:50:00',2.17),('9303','2014-01-18','12:55:00',2.51),('9303','2014-01-18','13:00:00',1.79),('9303','2014-01-18','13:05:00',1.43),('9303','2014-01-18','13:10:00',1.93),('9303','2014-01-18','13:15:00',2.32),('9303','2014-01-18','13:20:00',1.54),('9303','2014-01-18','13:25:00',1.11),('9303','2014-01-18','13:30:00',2.1),('9303','2014-01-18','13:35:00',1.32),('9303','2014-01-18','13:40:00',1.76),('9303','2014-01-18','13:45:00',2.07),('9303','2014-01-18','13:50:00',1.52),('9303','2014-01-18','13:55:00',1.99),('9303','2014-01-18','14:00:00',1.94),('9303','2014-01-18','14:05:00',1.84),('9303','2014-01-18','14:10:00',1.7),('9303','2014-01-18','14:15:00',1.63),('9303','2014-01-18','14:20:00',1.68),('9303','2014-01-18','14:25:00',1.62),('9303','2014-01-18','14:30:00',1.54),('9303','2014-01-18','14:35:00',1.52),('9303','2014-01-18','14:40:00',1.46),('9303','2014-01-18','14:45:00',1.44),('9303','2014-01-18','14:50:00',1.39),('9303','2014-01-18','14:55:00',1),('9303','2014-01-17','09:35:00',1.07),('9303','2014-01-17','09:40:00',1.29),('9303','2014-01-17','09:45:00',1.42),('9303','2014-01-17','09:50:00',1.01),('9303','2014-01-17','11:30:00',1.38),('9303','2014-01-17','11:35:00',1.45),('9303','2014-01-17','11:40:00',1.15),('9303','2014-01-17','12:00:00',1.03),('9303','2014-01-17','12:05:00',1.45),('9303','2014-01-17','12:10:00',1.39),('9303','2014-01-17','12:45:00',1.03),('9303','2014-04-25','07:55:00',1.01),('9303','2014-04-25','08:00:00',1.15),('9303','2014-04-25','08:05:00',1.13),('9303','2014-04-25','08:10:00',1.19),('9303','2014-04-25','08:15:00',1.25),('9303','2014-04-25','08:20:00',1.38),('9303','2014-04-25','08:25:00',1.47),('9303','2014-04-25','08:30:00',1.54),('9303','2014-04-25','08:35:00',1.63),('9303','2014-04-25','08:40:00',1.71),('9303','2014-04-25','08:45:00',1.79),('9303','2014-04-25','08:50:00',1.86),('9303','2014-04-25','08:55:00',2.04),('9303','2014-04-25','09:00:00',2.23),('9303','2014-04-25','09:05:00',2.05),('9303','2014-04-25','09:10:00',2.43),('9303','2014-04-25','09:15:00',1.15),('9303','2014-04-25','09:20:00',1.19),('9303','2014-04-25','09:25:00',1.44),('9303','2014-04-25','09:30:00',1.29),('9303','2014-04-25','09:35:00',1.15),('9303','2014-04-25','10:00:00',1.18),('9303','2014-04-25','10:05:00',1.11),('9303','2014-04-25','10:10:00',1.04),('9303','2014-04-25','10:15:00',1.1),('9303','2014-04-25','10:20:00',1.13),('9303','2014-04-25','10:25:00',1.27),('9303','2014-04-25','10:30:00',1.31),('9303','2014-04-25','10:35:00',2.77),('9303','2014-04-25','10:40:00',3.38),('9303','2014-04-25','10:45:00',3.04),('9303','2014-04-25','10:50:00',2.98),('9303','2014-04-25','10:55:00',2.38),('9303','2014-04-25','11:00:00',3.64),('9303','2014-04-25','11:05:00',1.42),('9303','2014-04-25','11:10:00',1.07),('9303','2014-04-25','11:15:00',2.52),('9303','2014-04-25','11:20:00',3.96),('9303','2014-04-25','11:25:00',3.46),('9303','2014-04-25','11:30:00',3.7),('9303','2014-04-25','11:35:00',2.25),('9303','2014-04-25','11:40:00',4.03),('9303','2014-04-25','11:45:00',1.47),('9303','2014-04-25','11:50:00',1.22),('9303','2014-04-25','11:55:00',1.42),('9303','2014-04-25','12:00:00',1.94),('9303','2014-04-25','12:05:00',1.53),('9303','2014-04-25','12:10:00',2.21),('9303','2014-04-25','12:15:00',4.54),('9303','2014-04-25','12:20:00',3.69),('9303','2014-04-25','12:25:00',1.99),('9303','2014-04-25','12:30:00',1.39),('9303','2014-04-25','12:35:00',3.17),('9303','2014-04-25','12:40:00',3.35),('9303','2014-04-25','12:45:00',4.79),('9303','2014-04-25','12:50:00',1.98),('9303','2014-04-25','12:55:00',1.47),('9303','2014-04-25','13:00:00',2.48),('9303','2014-04-25','13:05:00',2.49),('9303','2014-04-25','13:10:00',2.7),('9303','2014-04-25','13:15:00',1.59),('9303','2014-04-25','13:20:00',1.33),('9303','2014-04-25','13:25:00',1.47),('9303','2014-04-25','13:30:00',2.5),('9303','2014-04-25','13:35:00',1.01),('9303','2014-04-25','13:40:00',3.5),('9303','2014-04-25','13:45:00',1.34),('9303','2014-04-25','13:50:00',1.17),('9303','2014-04-25','13:55:00',1.4),('9303','2014-04-25','14:00:00',1.28),('9303','2014-04-25','14:05:00',1.7),('9303','2014-04-25','14:10:00',1.28),('9303','2014-04-25','14:15:00',1.29),('9303','2014-04-25','14:20:00',3.95),('9303','2014-04-25','14:25:00',3.7),('9303','2014-04-25','14:30:00',2.73),('9303','2014-04-25','14:35:00',4.15),('9303','2014-04-25','14:40:00',3.85),('9303','2014-04-25','14:45:00',3.85),('9303','2014-04-25','14:50:00',3.87),('9303','2014-04-25','14:55:00',3.79),('9303','2014-04-25','15:00:00',3.73),('9303','2014-04-25','15:05:00',3.67),('9303','2014-04-25','15:10:00',3.6),('9303','2014-04-25','15:15:00',3.6),('9303','2014-04-25','15:20:00',3.45),('9303','2014-04-25','15:25:00',3.42),('9303','2014-04-25','15:30:00',3.3),('9303','2014-04-25','15:35:00',3.35),('9303','2014-04-25','15:40:00',3.33),('9303','2014-04-25','15:45:00',3.23),('9303','2014-04-25','15:50:00',3.17),('9303','2014-04-25','15:55:00',3.16),('9303','2014-04-25','16:00:00',3.11),('9303','2014-04-25','16:05:00',2.95),('9303','2014-04-25','16:10:00',2.88),('9303','2014-04-25','16:15:00',2.76),('9303','2014-04-25','16:20:00',2.52),('9303','2014-04-25','16:25:00',2.55),('9303','2014-04-25','16:30:00',2.67),('9303','2014-04-25','16:35:00',2.65),('9303','2014-04-25','16:40:00',2.67),('9303','2014-04-25','16:45:00',2.54),('9303','2014-04-25','16:50:00',2.3),('9303','2014-04-25','16:55:00',1.94),('9303','2014-04-25','17:00:00',1.74),('9303','2014-04-25','17:05:00',1.96),('9303','2014-04-25','17:10:00',1.75),('9303','2014-04-25','17:15:00',1.68),('9303','2014-04-25','17:20:00',1.3),('9303','2014-01-16','09:25:00',1.03),('9303','2014-01-16','09:30:00',1.15),('9303','2014-01-16','09:35:00',1.26),('9303','2014-01-16','09:40:00',1.46),('9303','2014-01-16','09:45:00',1.41),('9303','2014-01-16','09:50:00',1.19),('9303','2014-01-16','10:10:00',1),('9303','2014-01-16','10:15:00',1.1),('9303','2014-01-16','10:20:00',1.12),('9303','2014-01-16','10:25:00',1.2),('9303','2014-01-16','10:30:00',1.51),('9303','2014-01-16','10:35:00',1.88),('9303','2014-01-16','10:40:00',1.81),('9303','2014-01-16','10:45:00',1.4),('9303','2014-01-16','10:50:00',1.46),('9303','2014-01-16','10:55:00',1.61),('9303','2014-01-16','11:00:00',1.61),('9303','2014-01-16','11:05:00',1.63),('9303','2014-01-16','11:10:00',1.7),('9303','2014-01-16','11:15:00',1.75),('9303','2014-01-16','11:20:00',1.58),('9303','2014-01-16','11:25:00',1.66),('9303','2014-01-16','11:30:00',1.49),('9303','2014-01-16','11:35:00',1.45),('9303','2014-01-16','11:40:00',1.36),('9303','2014-01-16','11:45:00',1.45),('9303','2014-01-16','11:50:00',1.46),('9303','2014-01-16','11:55:00',1.32),('9303','2014-01-16','12:00:00',1.34),('9303','2014-01-16','12:05:00',1.39),('9303','2014-01-16','12:10:00',1.55),('9303','2014-01-16','12:15:00',1.45),('9303','2014-01-16','12:20:00',1.35),('9303','2014-01-16','12:25:00',1.31),('9303','2014-01-16','12:30:00',1.34),('9303','2014-01-16','12:35:00',1.59),('9303','2014-01-16','12:40:00',1.71),('9303','2014-01-16','12:45:00',1.78),('9303','2014-01-16','12:50:00',1.91),('9303','2014-01-16','12:55:00',1.94),('9303','2014-01-16','13:00:00',1.97),('9303','2014-01-16','13:05:00',2.04),('9303','2014-01-16','13:10:00',1.84),('9303','2014-01-16','13:15:00',1.93),('9303','2014-01-16','13:20:00',1.85),('9303','2014-01-16','13:25:00',1.8),('9303','2014-01-16','13:35:00',1.28),('9303','2014-01-16','13:40:00',1.04),('9303','2014-01-16','13:45:00',2.05),('9303','2014-01-16','13:50:00',2.07),('9303','2014-01-16','13:55:00',1.6),('9303','2014-01-15','10:15:00',1.18),('9303','2014-01-15','10:20:00',1.54),('9303','2014-01-15','10:25:00',1.73),('9303','2014-01-15','10:30:00',1.75),('9303','2014-01-15','10:35:00',1.17),('9303','2014-01-15','10:40:00',1.12),('9303','2014-01-15','10:45:00',1.58),('9303','2014-01-15','10:50:00',1.03),('9303','2014-01-15','10:55:00',1.08),('9303','2014-01-15','11:00:00',1.13),('9303','2014-01-15','11:05:00',1.39),('9303','2014-01-15','11:10:00',1.93),('9303','2014-01-15','11:15:00',1.89),('9303','2014-01-15','11:20:00',1.94),('9303','2014-01-15','11:25:00',1.85),('9303','2014-01-15','11:30:00',1.82),('9303','2014-01-15','11:35:00',1.37),('9303','2014-01-15','11:40:00',1.62),('9303','2014-01-15','11:45:00',1.91),('9303','2014-01-15','11:50:00',1.86),('9303','2014-01-15','11:55:00',1.65),('9303','2014-01-15','12:00:00',1.49),('9303','2014-01-15','12:05:00',1.41),('9303','2014-01-15','12:10:00',1.42),('9303','2014-01-15','12:15:00',1.57),('9303','2014-01-15','12:20:00',2.01),('9303','2014-01-15','12:25:00',1.83),('9303','2014-01-15','12:30:00',1.28),('9303','2014-01-15','12:35:00',1.42),('9303','2014-01-15','12:40:00',1.29),('9303','2014-01-15','12:45:00',1.19),('9303','2014-01-15','12:50:00',1.42),('9303','2014-01-15','12:55:00',1.25),('9303','2014-01-15','13:00:00',1.22),('9303','2014-01-15','13:05:00',1.31),('9303','2014-01-15','13:10:00',1.49),('9303','2014-01-15','13:15:00',2.31),('9303','2014-01-15','13:20:00',2.44),('9303','2014-01-15','13:25:00',2.32),('9303','2014-01-15','13:30:00',2.18),('9303','2014-01-15','13:35:00',2.09),('9303','2014-01-15','13:40:00',2.03),('9303','2014-01-15','13:45:00',1.98),('9303','2014-01-15','13:50:00',1.93),('9303','2014-01-15','13:55:00',1.84),('9303','2014-01-15','14:00:00',1.76),('9303','2014-01-15','14:05:00',1.73),('9303','2014-01-15','14:10:00',1.69),('9303','2014-01-15','14:15:00',1.67),('9303','2014-01-15','14:20:00',1.64),('9303','2014-01-15','14:25:00',1.63),('9303','2014-01-15','14:30:00',1.63),('9303','2014-01-15','14:35:00',1.62),('9303','2014-01-15','14:40:00',1.69),('9303','2014-01-15','14:45:00',1.72),('9303','2014-01-15','14:50:00',1.65),('9303','2014-01-15','14:55:00',1.6),('9303','2014-01-15','15:00:00',1.55),('9303','2014-01-15','15:05:00',1.45),('9303','2014-01-15','15:10:00',1.39),('9303','2014-01-15','15:15:00',1.33),('9303','2014-01-15','15:20:00',1.18),('9303','2014-01-14','10:25:00',1.08),('9303','2014-01-14','10:30:00',2.14),('9303','2014-01-14','10:35:00',2.24),('9303','2014-01-14','10:40:00',1.93),('9303','2014-01-14','10:45:00',1.87),('9303','2014-01-14','10:50:00',1.32),('9303','2014-01-14','10:55:00',1.11),('9303','2014-01-14','11:00:00',1.4),('9303','2014-01-14','11:05:00',1.05),('9303','2014-01-14','11:35:00',1.02),('9303','2014-01-14','11:40:00',1.19),('9303','2014-01-13','09:40:00',1.02),('9303','2014-01-13','09:45:00',1.14),('9303','2014-01-13','09:50:00',1.25),('9303','2014-01-13','09:55:00',1.32),('9303','2014-01-13','10:00:00',1.38),('9303','2014-01-13','10:05:00',1.38),('9303','2014-01-13','10:10:00',1.42),('9303','2014-01-13','10:15:00',1.48),('9303','2014-01-13','10:20:00',1.52),('9303','2014-01-13','10:25:00',1.55),('9303','2014-01-13','10:30:00',1.57),('9303','2014-01-13','10:35:00',1.62),('9303','2014-01-13','10:40:00',1.6),('9303','2014-01-13','10:45:00',1.63),('9303','2014-01-13','10:50:00',1.71),('9303','2014-01-13','10:55:00',1.73),('9303','2014-01-13','11:00:00',1.77),('9303','2014-01-13','11:05:00',1.79),('9303','2014-01-13','11:10:00',1.83),('9303','2014-01-13','11:15:00',1.87),('9303','2014-01-13','11:20:00',1.85),('9303','2014-01-13','11:25:00',1.89),('9303','2014-01-13','11:30:00',1.91),('9303','2014-01-13','11:35:00',1.96),('9303','2014-01-13','11:40:00',1.98),('9303','2014-01-13','11:45:00',1.94),('9303','2014-01-13','11:50:00',1.96),('9303','2014-01-13','11:55:00',1.92),('9303','2014-01-13','12:00:00',1.89),('9303','2014-01-13','12:05:00',1.9),('9303','2014-01-13','12:10:00',1.94),('9303','2014-01-13','12:15:00',1.9),('9303','2014-01-13','12:20:00',1.97),('9303','2014-01-13','12:25:00',1.97),('9303','2014-01-13','12:30:00',1.98),('9303','2014-01-13','12:35:00',2),('9303','2014-01-13','12:40:00',2.04),('9303','2014-01-13','12:45:00',2.06),('9303','2014-01-13','12:50:00',2.02),('9303','2014-01-13','12:55:00',1.99),('9303','2014-01-13','13:00:00',1.98),('9303','2014-01-13','13:05:00',1.89),('9303','2014-01-13','13:10:00',1.85),('9303','2014-01-13','13:15:00',1.78),('9303','2014-01-13','13:20:00',1.75),('9303','2014-01-13','13:25:00',1.84),('9303','2014-01-13','13:30:00',1.87),('9303','2014-01-13','13:35:00',1.8),('9303','2014-01-13','13:40:00',1.73),('9303','2014-01-13','13:45:00',1.59),('9303','2014-01-13','13:50:00',1.61),('9303','2014-01-13','13:55:00',1.62),('9303','2014-01-13','14:00:00',1.55),('9303','2014-01-13','14:05:00',1.56),('9303','2014-01-13','14:10:00',1.47),('9303','2014-01-13','14:15:00',1.49),('9303','2014-01-13','14:20:00',1.43),('9303','2014-01-13','14:25:00',1.4),('9303','2014-01-13','14:30:00',1.36),('9303','2014-01-13','14:35:00',1.31),('9303','2014-01-13','14:40:00',1.29),('9303','2014-01-13','14:45:00',1.28),('9303','2014-01-13','14:50:00',1.24),('9303','2014-01-13','14:55:00',1.15),('9303','2014-01-13','15:00:00',1.11),('9303','2014-01-13','15:05:00',1.06),('9303','2014-01-12','10:35:00',1.06),('9303','2014-01-12','10:40:00',1.19),('9303','2014-01-12','10:45:00',1.24),('9303','2014-01-12','10:50:00',1.31),('9303','2014-01-12','10:55:00',1.42),('9303','2014-01-12','11:00:00',1.43),('9303','2014-01-12','11:05:00',1.4),('9303','2014-01-12','11:10:00',1.68),('9303','2014-01-12','11:15:00',1.49),('9303','2014-01-12','11:20:00',1.47),('9303','2014-01-12','11:25:00',1.36),('9303','2014-01-12','11:30:00',1.47),('9303','2014-01-12','11:35:00',1.27),('9303','2014-01-12','11:40:00',1.45),('9303','2014-01-12','11:45:00',1.56),('9303','2014-01-12','11:50:00',1.64),('9303','2014-01-12','11:55:00',1.71),('9303','2014-01-12','12:00:00',1.34),('9303','2014-01-12','12:05:00',1.36),('9303','2014-01-12','12:10:00',1.16),('9303','2014-01-12','12:20:00',1.14),('9303','2014-01-12','12:25:00',1.08),('9303','2014-01-12','12:30:00',1.12),('9303','2014-01-12','12:35:00',1.12),('9303','2014-01-12','12:40:00',1.24),('9303','2014-01-12','12:45:00',1.18),('9303','2014-01-12','12:50:00',1.2),('9303','2014-01-12','12:55:00',1.19),('9303','2014-01-12','13:00:00',1.19),('9303','2014-01-12','13:05:00',1.08),('9303','2014-01-12','13:10:00',1.04),('9303','2014-01-12','13:15:00',1.01),('9303','2014-01-12','13:20:00',1.05),('9303','2014-01-12','13:25:00',1.06),('9303','2014-01-12','13:30:00',1.28),('9303','2014-01-12','13:35:00',1.17),('9303','2014-01-12','13:40:00',1.07),('9303','2014-01-11','09:55:00',1.14),('9303','2014-01-11','10:00:00',1.28),('9303','2014-01-11','10:05:00',1.02),('9303','2014-01-11','10:10:00',1.01),('9303','2014-01-11','10:15:00',1.07),('9303','2014-01-11','10:20:00',1.03),('9303','2014-01-11','10:25:00',1.18),('9303','2014-01-11','10:30:00',1.2),('9303','2014-01-11','10:35:00',1.19),('9303','2014-01-11','10:40:00',1.46),('9303','2014-01-11','10:45:00',1.72),('9303','2014-01-11','10:50:00',1.79),('9303','2014-01-11','10:55:00',1.75),('9303','2014-01-11','11:00:00',1.72),('9303','2014-01-11','11:05:00',1.66),('9303','2014-01-11','11:10:00',1.81),('9303','2014-01-11','11:15:00',1.68),('9303','2014-01-11','11:20:00',1.41),('9303','2014-01-11','11:25:00',1.52),('9303','2014-01-11','11:30:00',1.5),('9303','2014-01-11','11:35:00',1.41),('9303','2014-01-11','11:40:00',1.33),('9303','2014-01-11','11:45:00',1.36),('9303','2014-01-11','11:50:00',1.5),('9303','2014-01-11','11:55:00',1.51),('9303','2014-01-11','12:00:00',1.49),('9303','2014-01-11','12:05:00',1.63),('9303','2014-01-11','12:10:00',1.56),('9303','2014-01-11','12:15:00',1.57),('9303','2014-01-11','12:20:00',1.55),('9303','2014-01-11','12:25:00',1.47),('9303','2014-01-11','12:30:00',1.38),('9303','2014-01-11','12:35:00',1.35),('9303','2014-01-11','12:40:00',1.21),('9303','2014-01-11','12:45:00',1.27),('9303','2014-01-11','12:50:00',1.7),('9303','2014-01-11','12:55:00',1.85),('9303','2014-01-11','13:00:00',1.85),('9303','2014-01-11','13:05:00',1.72),('9303','2014-01-11','13:10:00',1.68),('9303','2014-01-11','13:15:00',1.77),('9303','2014-01-11','13:20:00',1.61),('9303','2014-01-11','13:25:00',1.35),('9303','2014-01-11','13:30:00',1.17),('9303','2014-01-11','13:35:00',1.18),('9303','2014-01-11','13:40:00',1.04),('9303','2014-01-11','13:45:00',1.09),('9303','2014-01-11','14:00:00',1.26),('9303','2014-01-11','14:05:00',1.37),('9303','2014-01-11','14:10:00',1.21),('9303','2014-01-09','09:35:00',1.15),('9303','2014-01-09','09:40:00',1.15),('9303','2014-01-09','09:45:00',1.44),('9303','2014-01-09','09:50:00',1.51),('9303','2014-01-09','09:55:00',1.49),('9303','2014-01-09','10:00:00',1.52),('9303','2014-01-09','10:05:00',1.44),('9303','2014-01-09','10:10:00',1.28),('9303','2014-01-09','10:15:00',1.34),('9303','2014-01-09','10:20:00',1.36),('9303','2014-01-09','10:25:00',1.38),('9303','2014-01-09','10:30:00',1.45),('9303','2014-01-09','10:35:00',1.47),('9303','2014-01-09','10:40:00',1.59),('9303','2014-01-09','10:45:00',1.66),('9303','2014-01-09','10:50:00',1.67),('9303','2014-01-09','10:55:00',1.1),('9303','2014-01-09','11:00:00',1.08),('9303','2014-01-09','11:05:00',1.08),('9303','2014-01-09','11:10:00',1.1),('9303','2014-01-09','11:15:00',1.01),('9303','2014-01-09','11:20:00',1.13),('9303','2014-01-09','11:25:00',1.24),('9303','2014-01-09','11:30:00',1.08),('9303','2014-01-09','11:35:00',1.11),('9303','2014-01-09','11:40:00',1.42),('9303','2014-01-09','11:45:00',1.31),('9303','2014-01-09','13:15:00',1.01),('9303','2014-01-08','09:45:00',1.08),('9303','2014-01-08','09:50:00',1.17),('9303','2014-01-08','09:55:00',1.26),('9303','2014-01-08','10:00:00',1.32),('9303','2014-01-08','10:05:00',1.28),('9303','2014-01-08','10:10:00',1.34),('9303','2014-01-08','10:15:00',1.41),('9303','2014-01-08','10:20:00',1.5),('9303','2014-01-08','10:25:00',1.57),('9303','2014-01-08','10:30:00',1.57),('9303','2014-01-08','10:35:00',1.47),('9303','2014-01-08','10:40:00',1.45),('9303','2014-01-08','10:45:00',1.6),('9303','2014-01-08','10:50:00',1.7),('9303','2014-01-08','10:55:00',1.71),('9303','2014-01-08','11:00:00',1.76),('9303','2014-01-08','11:05:00',1.78),('9303','2014-01-08','11:10:00',1.84),('9303','2014-01-08','11:15:00',1.83),('9303','2014-01-08','11:20:00',1.84),('9303','2014-01-08','11:25:00',1.88),('9303','2014-01-08','11:30:00',1.89),('9303','2014-01-08','11:35:00',2),('9303','2014-01-08','11:40:00',2.02),('9303','2014-01-08','11:45:00',1.98),('9303','2014-01-08','11:50:00',1.98),('9303','2014-01-08','11:55:00',1.95),('9303','2014-01-08','12:00:00',1.97),('9303','2014-01-08','12:05:00',1.9),('9303','2014-01-08','12:10:00',1.96),('9303','2014-01-08','12:15:00',1.95),('9303','2014-01-08','12:20:00',1.98),('9303','2014-01-08','12:25:00',2.05),('9303','2014-01-08','12:30:00',2.05),('9303','2014-01-08','12:35:00',2.04),('9303','2014-01-08','12:40:00',2.02),('9303','2014-01-08','12:45:00',1.96),('9303','2014-01-08','12:50:00',1.91),('9303','2014-01-08','12:55:00',1.98),('9303','2014-01-08','13:00:00',1.94),('9303','2014-01-08','13:05:00',1.94),('9303','2014-01-08','13:10:00',1.87),('9303','2014-01-08','13:15:00',1.88),('9303','2014-01-08','13:20:00',1.79),('9303','2014-01-08','13:25:00',1.8),('9303','2014-01-08','13:30:00',1.74),('9303','2014-01-08','13:35:00',1.72),('9303','2014-01-08','13:40:00',1.72),('9303','2014-01-08','13:45:00',1.64),('9303','2014-01-08','13:50:00',1.59),('9303','2014-01-08','13:55:00',1.58),('9303','2014-01-08','14:00:00',1.54),('9303','2014-01-08','14:05:00',1.54),('9303','2014-01-08','14:10:00',1.49),('9303','2014-01-08','14:15:00',1.46),('9303','2014-01-08','14:20:00',1.46),('9303','2014-01-08','14:25:00',1.42),('9303','2014-01-08','14:30:00',1.45),('9303','2014-01-08','14:35:00',1.42),('9303','2014-01-08','14:40:00',1.31),('9303','2014-01-08','14:45:00',1.25),('9303','2014-01-08','14:50:00',1.21),('9303','2014-01-08','14:55:00',1.04),('9303','2014-01-07','09:40:00',1.07),('9303','2014-01-07','09:45:00',1.16),('9303','2014-01-07','09:50:00',1.27),('9303','2014-01-07','09:55:00',1.35),('9303','2014-01-07','10:00:00',1.36),('9303','2014-01-07','10:05:00',1.38),('9303','2014-01-07','10:10:00',1.44),('9303','2014-01-07','10:15:00',1.5),('9303','2014-01-07','10:20:00',1.53),('9303','2014-01-07','10:25:00',1.59),('9303','2014-01-07','10:30:00',1.63),('9303','2014-01-07','10:35:00',1.64),('9303','2014-01-07','10:40:00',1.67),('9303','2014-01-07','10:45:00',1.7),('9303','2014-01-07','10:50:00',1.76),('9303','2014-01-07','10:55:00',1.74),('9303','2014-01-07','11:00:00',1.8),('9303','2014-01-07','11:05:00',1.82),('9303','2014-01-07','11:10:00',1.87),('9303','2014-01-07','11:15:00',1.87),('9303','2014-01-07','11:20:00',1.89),('9303','2014-01-07','11:25:00',1.94),('9303','2014-01-07','11:30:00',1.95),('9303','2014-01-07','11:35:00',2),('9303','2014-01-07','11:40:00',1.98),('9303','2014-01-07','11:45:00',1.99),('9303','2014-01-07','11:50:00',2.01),('9303','2014-01-07','11:55:00',2.01),('9303','2014-01-07','12:00:00',2.04),('9303','2014-01-07','12:05:00',2.03),('9303','2014-01-07','12:10:00',2.08),('9303','2014-01-07','12:15:00',2.05),('9303','2014-01-07','12:20:00',2.08),('9303','2014-01-07','12:25:00',2.09),('9303','2014-01-07','12:30:00',2.1),('9303','2014-01-07','12:35:00',2.08),('9303','2014-01-07','12:40:00',2.07),('9303','2014-01-07','12:45:00',2.15),('9303','2014-01-07','12:50:00',2.11),('9303','2014-01-07','12:55:00',2.03),('9303','2014-01-07','13:00:00',1.96),('9303','2014-01-07','13:05:00',1.96),('9303','2014-01-07','13:10:00',1.92),('9303','2014-01-07','13:15:00',1.9),('9303','2014-01-07','13:20:00',1.83),('9303','2014-01-07','13:25:00',1.79),('9303','2014-01-07','13:30:00',1.73),('9303','2014-01-07','13:35:00',1.69),('9303','2014-01-07','13:40:00',1.71),('9303','2014-01-07','13:45:00',1.73),('9303','2014-01-07','13:50:00',1.74),('9303','2014-01-07','13:55:00',1.69),('9303','2014-01-07','14:00:00',1.68),('9303','2014-01-07','14:05:00',1.57),('9303','2014-01-07','14:10:00',1.5),('9303','2014-01-07','14:15:00',1.48),('9303','2014-01-07','14:20:00',1.48),('9303','2014-01-07','14:25:00',1.42),('9303','2014-01-07','14:30:00',1.37),('9303','2014-01-07','14:35:00',1.35),('9303','2014-01-07','14:40:00',1.36),('9303','2014-01-07','14:45:00',1.27),('9303','2014-01-07','14:50:00',1.26),('9303','2014-01-07','14:55:00',1.23),('9303','2014-01-07','15:00:00',1.14),('9303','2014-01-07','15:05:00',1.08),('9303','2014-04-24','08:05:00',1.1),('9303','2014-04-24','08:10:00',1.18),('9303','2014-04-24','08:15:00',1.28),('9303','2014-04-24','08:20:00',1.39),('9303','2014-04-24','08:25:00',1.49),('9303','2014-04-24','08:30:00',1.59),('9303','2014-04-24','08:35:00',1.69),('9303','2014-04-24','08:40:00',1.78),('9303','2014-04-24','08:45:00',1.87),('9303','2014-04-24','08:50:00',1.94),('9303','2014-04-24','08:55:00',2.02),('9303','2014-04-24','09:00:00',2.1),('9303','2014-04-24','09:05:00',2.19),('9303','2014-04-24','09:10:00',2.26),('9303','2014-04-24','09:15:00',2.32),('9303','2014-04-24','09:20:00',2.4),('9303','2014-04-24','09:25:00',2.48),('9303','2014-04-24','09:30:00',2.54),('9303','2014-04-24','09:35:00',2.63),('9303','2014-04-24','09:40:00',2.71),('9303','2014-04-24','09:45:00',2.78),('9303','2014-04-24','09:50:00',2.83),('9303','2014-04-24','09:55:00',2.88),('9303','2014-04-24','10:00:00',2.96),('9303','2014-04-24','10:05:00',3.02),('9303','2014-04-24','10:10:00',3.07),('9303','2014-04-24','10:15:00',3.12),('9303','2014-04-24','10:20:00',3.13),('9303','2014-04-24','10:25:00',3.17),('9303','2014-04-24','10:30:00',3.23),('9303','2014-04-24','10:35:00',3.3),('9303','2014-04-24','10:40:00',3.37),('9303','2014-04-24','10:45:00',3.4),('9303','2014-04-24','10:50:00',3.44),('9303','2014-04-24','10:55:00',3.49),('9303','2014-04-24','11:00:00',3.57),('9303','2014-04-24','11:05:00',3.58),('9303','2014-04-24','11:10:00',3.56),('9303','2014-04-24','11:15:00',3.59),('9303','2014-04-24','11:20:00',3.62),('9303','2014-04-24','11:25:00',3.63),('9303','2014-04-24','11:30:00',3.66),('9303','2014-04-24','11:35:00',3.68),('9303','2014-04-24','11:40:00',3.67),('9303','2014-04-24','11:45:00',3.74),('9303','2014-04-24','11:50:00',3.8),('9303','2014-04-24','11:55:00',3.8),('9303','2014-04-24','12:00:00',3.82),('9303','2014-04-24','12:05:00',3.91),('9303','2014-04-24','12:10:00',3.99),('9303','2014-04-24','12:15:00',4.06),('9303','2014-04-24','12:20:00',4.03),('9303','2014-04-24','12:25:00',3.95),('9303','2014-04-24','12:30:00',4.04),('9303','2014-04-24','12:35:00',3.98),('9303','2014-04-24','12:40:00',3.92),('9303','2014-04-24','12:45:00',4.1),('9303','2014-04-24','12:50:00',4.14),('9303','2014-04-24','12:55:00',4.08),('9303','2014-04-24','13:00:00',4.01),('9303','2014-04-24','13:05:00',4.14),('9303','2014-04-24','13:10:00',4.17),('9303','2014-04-24','13:15:00',4.25),('9303','2014-04-24','13:20:00',4.24),('9303','2014-04-24','13:25:00',4.13),('9303','2014-04-24','13:30:00',4.16),('9303','2014-04-24','13:35:00',3.4),('9303','2014-04-24','13:40:00',1.2),('9303','2014-04-24','13:45:00',4.13),('9303','2014-04-24','13:50:00',4.59),('9303','2014-04-24','13:55:00',3.32),('9303','2014-04-24','14:00:00',1.56),('9303','2014-04-24','14:05:00',3.25),('9303','2014-04-24','14:10:00',3.91),('9303','2014-04-24','14:15:00',3.17),('9303','2014-04-24','14:20:00',3.4),('9303','2014-04-24','14:25:00',3.37),('9303','2014-04-24','14:30:00',4.43),('9303','2014-04-24','14:35:00',4.25),('9303','2014-04-24','14:40:00',3.31),('9303','2014-04-24','14:45:00',2.32),('9303','2014-04-24','14:50:00',1.5),('9303','2014-04-24','14:55:00',3.94),('9303','2014-04-24','15:00:00',4.52),('9303','2014-04-24','15:05:00',4.42),('9303','2014-04-24','15:10:00',3.86),('9303','2014-04-24','15:15:00',3.83),('9303','2014-04-24','15:20:00',2.35),('9303','2014-04-24','15:25:00',2.03),('9303','2014-04-24','15:30:00',3.03),('9303','2014-04-24','15:35:00',2.48),('9303','2014-04-24','15:40:00',2.03),('9303','2014-04-24','15:45:00',1.94),('9303','2014-04-24','15:50:00',2.2),('9303','2014-04-24','15:55:00',2.52),('9303','2014-04-24','16:00:00',3.78),('9303','2014-04-24','16:05:00',3.49),('9303','2014-04-24','16:10:00',2.64),('9303','2014-04-24','16:15:00',3.35),('9303','2014-04-24','16:20:00',2.86),('9303','2014-04-24','16:25:00',2.79),('9303','2014-04-24','16:30:00',3.23),('9303','2014-04-24','16:35:00',1.73),('9303','2014-04-24','16:40:00',1.83),('9303','2014-04-24','16:45:00',1.92),('9303','2014-04-24','16:50:00',1.41),('9303','2014-04-24','16:55:00',1.43),('9303','2014-04-24','17:00:00',1.31),('9303','2014-04-24','17:05:00',1.17),('9303','2014-04-24','17:10:00',1.1),('9303','2014-04-24','17:15:00',1),('9303','2014-01-06','11:35:00',1.02),('9303','2014-01-06','11:40:00',1.84),('9303','2014-01-06','11:45:00',2.02),('9303','2014-01-06','11:50:00',2.1),('9303','2014-01-06','11:55:00',2.04),('9303','2014-01-06','12:00:00',2.12),('9303','2014-01-06','12:05:00',2.07),('9303','2014-01-06','12:10:00',2.03),('9303','2014-01-06','12:15:00',1.99),('9303','2014-01-06','12:20:00',2.04),('9303','2014-01-06','12:25:00',2.08),('9303','2014-01-06','12:30:00',2.09),('9303','2014-01-06','12:35:00',2.1),('9303','2014-01-06','12:40:00',2.13),('9303','2014-01-06','12:45:00',2.18),('9303','2014-01-06','12:50:00',2.16),('9303','2014-01-06','12:55:00',2.11),('9303','2014-01-06','13:00:00',2.08),('9303','2014-01-06','13:05:00',2.03),('9303','2014-01-06','13:10:00',2.03),('9303','2014-01-06','13:15:00',2.04),('9303','2014-01-06','13:20:00',2.01),('9303','2014-01-06','13:25:00',2.01),('9303','2014-01-06','13:30:00',1.85),('9303','2014-01-06','13:35:00',1.83),('9303','2014-01-06','13:40:00',1.78),('9303','2014-01-06','13:45:00',1.69),('9303','2014-01-06','13:50:00',1.71),('9303','2014-01-06','13:55:00',1.67),('9303','2014-01-06','14:00:00',1.22),('9303','2014-01-06','14:15:00',1.1),('9303','2014-01-06','14:20:00',1.68),('9303','2014-01-06','14:35:00',1.02),('9303','2014-01-06','14:40:00',1.52),('9303','2014-01-06','14:45:00',1.71),('9303','2014-01-06','14:50:00',1.4),('9303','2014-01-06','15:05:00',1),('9303','2014-01-03','09:40:00',1.24),('9303','2014-01-03','09:45:00',1.18),('9303','2014-01-03','10:00:00',1.23),('9303','2014-01-03','10:05:00',1.29),('9303','2014-01-03','10:20:00',1.41),('9303','2014-01-03','10:45:00',1.17),('9303','2014-01-03','10:50:00',1.14),('9303','2014-01-03','11:45:00',1.08),('9303','2014-01-03','11:50:00',1.04),('9303','2014-01-03','11:55:00',1.04),('9303','2014-01-03','12:00:00',1.14),('9303','2014-01-03','12:05:00',1.58),('9303','2014-01-03','12:10:00',1.65),('9303','2014-01-03','12:15:00',1.28),('9303','2014-01-03','12:20:00',1.62),('9303','2014-01-03','12:25:00',1.05),('9303','2014-01-03','12:30:00',1.2),('9303','2014-01-03','12:35:00',1.46),('9303','2014-01-03','12:40:00',1.61),('9303','2014-01-03','12:45:00',1.64),('9303','2014-01-03','12:50:00',1.26),('9303','2014-01-03','12:55:00',1.94),('9303','2014-01-03','13:00:00',1.16),('9303','2014-01-03','13:05:00',1.2),('9303','2014-01-03','13:10:00',1.81),('9303','2014-01-03','13:15:00',1.1),('9303','2014-01-03','13:30:00',1.05),('9303','2014-01-03','13:35:00',1.32),('9303','2014-01-03','13:40:00',1.36),('9303','2014-01-03','13:45:00',1.19),('9303','2014-01-02','09:45:00',1.09),('9303','2014-01-02','09:50:00',1.19),('9303','2014-01-02','09:55:00',1.26),('9303','2014-01-02','10:00:00',1.33),('9303','2014-01-02','10:05:00',1.37),('9303','2014-01-02','10:10:00',1.43),('9303','2014-01-02','10:15:00',1.48),('9303','2014-01-02','10:20:00',1.51),('9303','2014-01-02','10:25:00',1.54),('9303','2014-01-02','10:30:00',1.56),('9303','2014-01-02','10:35:00',1.53),('9303','2014-01-02','10:40:00',1.55),('9303','2014-01-02','10:45:00',1.59),('9303','2014-01-02','10:50:00',1.66),('9303','2014-01-02','10:55:00',1.7),('9303','2014-01-02','11:00:00',1.77),('9303','2014-01-02','11:05:00',1.81),('9303','2014-01-02','11:10:00',1.39),('9303','2014-01-02','11:15:00',1.17),('9303','2014-01-02','11:20:00',1.03),('9303','2014-01-02','11:25:00',1.27),('9303','2014-01-02','11:30:00',1.45),('9303','2014-01-02','11:35:00',1.51),('9303','2014-01-02','11:40:00',1.48),('9303','2014-01-02','11:45:00',1.46),('9303','2014-01-02','11:50:00',1.27),('9303','2014-01-02','11:55:00',1.13),('9303','2014-01-02','12:00:00',1.05),('9303','2014-01-02','12:05:00',1.11),('9303','2014-01-02','12:10:00',1.12),('9303','2014-01-02','12:50:00',1.65),('9303','2014-01-02','12:55:00',2.12),('9303','2014-01-02','13:35:00',1.05),('9303','2014-01-02','13:40:00',1.7),('9303','2014-01-02','13:45:00',1.1),('9303','2014-01-01','09:45:00',1.12),('9303','2014-01-01','09:50:00',1.45),('9303','2014-01-01','09:55:00',1.14),('9303','2014-01-01','10:00:00',1.02),('9303','2014-01-01','12:10:00',1.05),('9303','2014-01-01','12:15:00',1.09),('9303','2014-01-01','12:20:00',1.12),('9303','2014-01-01','12:25:00',1.13),('9303','2014-01-01','12:30:00',1.19),('9303','2014-01-01','12:35:00',1.23),('9303','2014-01-01','12:40:00',1.08),('9303','2014-01-01','12:45:00',1.05),('9303','2014-01-01','12:50:00',1.1),('9303','2014-01-01','12:55:00',1.08),('9303','2014-01-01','13:00:00',1.1),('9303','2014-01-01','13:25:00',1.06),('9303','2014-01-01','13:30:00',1.42),('9303','2014-01-01','13:35:00',2.49),('9303','2014-01-01','13:40:00',1.91),('9303','2014-01-01','13:45:00',1.08),('9303','2014-01-01','13:50:00',1.07),('9303','2014-01-01','13:55:00',1.11),('9303','2014-01-01','14:00:00',1.51),('9303','2014-01-01','14:15:00',1.07),('9303','2014-01-01','15:10:00',1.12),('9303','2013-12-31','09:50:00',1.43),('9303','2013-12-31','10:50:00',1.03),('9303','2013-12-31','10:55:00',1.18),('9303','2013-12-31','11:05:00',1.11),('9303','2013-12-31','11:10:00',1.65),('9303','2013-12-31','11:15:00',2.05),('9303','2013-12-31','11:20:00',1.42),('9303','2013-12-31','11:25:00',1.21),('9303','2013-12-31','11:30:00',1.7),('9303','2013-12-31','11:40:00',1.64),('9303','2013-12-31','11:50:00',1.16),('9303','2013-12-31','11:55:00',1.7),('9303','2013-12-31','12:00:00',2.12),('9303','2013-12-31','12:05:00',2.1),('9303','2013-12-31','12:10:00',2.05),('9303','2013-12-31','12:15:00',2.09),('9303','2013-12-31','12:20:00',2.1),('9303','2013-12-31','12:25:00',2.13),('9303','2013-12-31','12:30:00',2.14),('9303','2013-12-31','12:35:00',2.12),('9303','2013-12-31','12:40:00',2.18),('9303','2013-12-31','12:45:00',2.17),('9303','2013-12-31','12:50:00',2.13),('9303','2013-12-31','12:55:00',2.1),('9303','2013-12-31','13:00:00',2.07),('9303','2013-12-31','13:05:00',2.02),('9303','2013-12-31','13:10:00',1.96),('9303','2013-12-31','13:15:00',1.92),('9303','2013-12-31','13:20:00',1.9),('9303','2013-12-31','13:25:00',1.89),('9303','2013-12-31','13:30:00',1.86),('9303','2013-12-31','13:35:00',1.84),('9303','2013-12-31','13:40:00',1.78),('9303','2013-12-31','13:45:00',1.74),('9303','2013-12-31','13:50:00',1.7),('9303','2013-12-31','13:55:00',1.64),('9303','2013-12-31','14:00:00',1.59),('9303','2013-12-31','14:05:00',1.56),('9303','2013-12-31','14:10:00',1.51),('9303','2013-12-31','14:15:00',1.47),('9303','2013-12-31','14:20:00',1.44),('9303','2013-12-31','14:25:00',1.4),('9303','2013-12-31','14:30:00',1.36),('9303','2013-12-31','14:35:00',1.32),('9303','2013-12-31','14:40:00',1.28),('9303','2013-12-31','14:45:00',1.21),('9303','2013-12-31','14:50:00',1.15),('9303','2013-12-31','14:55:00',1.08),('9303','2013-12-29','09:45:00',1.14),('9303','2013-12-29','09:50:00',1.15),('9303','2013-12-29','10:00:00',1.11),('9303','2013-12-29','10:05:00',1.29),('9303','2013-12-29','10:10:00',1.16),('9303','2013-12-29','10:15:00',1.55),('9303','2013-12-29','10:20:00',1.69),('9303','2013-12-29','10:25:00',1.5),('9303','2013-12-29','10:30:00',1.9),('9303','2013-12-29','10:35:00',1.99),('9303','2013-12-29','10:40:00',1.93),('9303','2013-12-29','10:45:00',1.1),('9303','2013-12-29','11:00:00',1.02),('9303','2013-12-28','09:45:00',1.12),('9303','2013-12-28','09:50:00',1.23),('9303','2013-12-28','09:55:00',1.31),('9303','2013-12-28','10:00:00',1.38),('9303','2013-12-28','10:05:00',1.43),('9303','2013-12-28','10:10:00',1.49),('9303','2013-12-28','10:15:00',1.49),('9303','2013-12-28','10:20:00',1.55),('9303','2013-12-28','10:25:00',1.57),('9303','2013-12-28','10:30:00',1.58),('9303','2013-12-28','10:35:00',1.6),('9303','2013-12-28','10:40:00',1.61),('9303','2013-12-28','10:45:00',1.68),('9303','2013-12-28','10:50:00',1.69),('9303','2013-12-28','10:55:00',1.79),('9303','2013-12-28','11:00:00',1.81),('9303','2013-12-28','11:05:00',1.85),('9303','2013-12-28','11:10:00',1.85),('9303','2013-12-28','11:15:00',1.86),('9303','2013-12-28','11:20:00',1.92),('9303','2013-12-28','11:25:00',1.93),('9303','2013-12-28','11:30:00',1.96),('9303','2013-12-28','11:35:00',1.98),('9303','2013-12-28','11:40:00',1.97),('9303','2013-12-28','11:45:00',2),('9303','2013-12-28','11:50:00',2),('9303','2013-12-28','11:55:00',2.01),('9303','2013-12-28','12:00:00',1.97),('9303','2013-12-28','12:05:00',2.01),('9303','2013-12-28','12:10:00',1.98),('9303','2013-12-28','12:15:00',2.04),('9303','2013-12-28','12:20:00',2.06),('9303','2013-12-28','12:25:00',2.07),('9303','2013-12-28','12:30:00',2.05),('9303','2013-12-28','12:35:00',2.08),('9303','2013-12-28','12:40:00',2.09),('9303','2013-12-28','12:45:00',2.05),('9303','2013-12-28','12:50:00',2.03),('9303','2013-12-28','12:55:00',1.98),('9303','2013-12-28','13:00:00',1.94),('9303','2013-12-28','13:05:00',1.9),('9303','2013-12-28','13:10:00',1.86),('9303','2013-12-28','13:15:00',1.82),('9303','2013-12-28','13:20:00',1.81),('9303','2013-12-28','13:25:00',1.73),('9303','2013-12-28','13:30:00',1.72),('9303','2013-12-28','13:35:00',1.69),('9303','2013-12-28','13:40:00',1.64),('9303','2013-12-28','13:45:00',1.6),('9303','2013-12-28','13:50:00',1.56),('9303','2013-12-28','13:55:00',1.52),('9303','2013-12-28','14:00:00',1.48),('9303','2013-12-28','14:05:00',1.29),('9303','2013-12-28','14:15:00',1.34),('9303','2013-12-28','14:20:00',1.3),('9303','2013-12-28','14:25:00',1.28),('9303','2013-12-28','14:30:00',1.22),('9303','2013-12-28','14:35:00',1.19),('9303','2013-12-28','14:40:00',1.15),('9303','2013-12-28','14:45:00',1),('9303','2014-04-23','13:15:00',1.08),('9303','2014-04-23','13:20:00',1.13),('9303','2014-04-23','13:25:00',1.21),('9303','2014-04-23','13:30:00',1.3),('9303','2014-04-23','13:35:00',1.37),('9303','2014-04-23','13:40:00',1.46),('9303','2014-04-23','13:45:00',1.51),('9303','2014-04-23','13:50:00',1.49),('9303','2014-04-23','13:55:00',1.47),('9303','2014-04-23','14:00:00',1.38),('9303','2014-04-23','14:05:00',1.4),('9303','2014-04-23','14:10:00',1.32),('9303','2014-04-23','14:15:00',1.11),('9303','2014-04-23','14:45:00',1.06),('9303','2014-04-23','14:50:00',1.3),('9303','2014-04-23','14:55:00',1.5),('9303','2014-04-23','15:00:00',1.63),('9303','2014-04-23','15:05:00',1.65),('9303','2014-04-23','15:10:00',1.62),('9303','2014-04-23','15:15:00',1.61),('9303','2014-04-23','15:20:00',1.37),('9303','2014-04-23','15:25:00',1.3),('9303','2014-04-23','15:30:00',1.29),('9303','2014-04-23','15:35:00',1.22),('9303','2014-04-23','15:40:00',1.2),('9303','2014-04-23','15:45:00',1.19),('9303','2013-12-27','12:10:00',1.39),('9303','2013-12-27','12:15:00',1.91),('9303','2013-12-27','12:20:00',1.51),('9303','2013-12-27','12:25:00',1.29),('9303','2013-12-27','12:35:00',1.07),('9303','2013-12-27','12:40:00',1.35),('9303','2013-12-27','12:45:00',1.71),('9303','2013-12-27','12:50:00',1.96),('9303','2013-12-27','12:55:00',2),('9303','2013-12-27','13:00:00',1.98),('9303','2013-12-27','13:05:00',1.78),('9303','2013-12-27','13:10:00',1.08),('9303','2013-12-27','13:15:00',1.11),('9303','2013-12-27','13:20:00',1.19),('9303','2013-12-27','13:25:00',1.24),('9303','2013-12-27','13:30:00',1.94),('9303','2013-12-27','13:35:00',1.93),('9303','2013-12-27','13:40:00',1.3),('9303','2013-12-27','13:45:00',1.22),('9303','2013-12-27','13:50:00',1.03),('9303','2013-12-27','14:15:00',1.03),('9303','2013-12-27','14:20:00',1.03),('9303','2013-12-27','14:30:00',1.02),('9303','2013-12-27','14:35:00',1.09),('9303','2013-12-27','14:40:00',1.11),('9303','2013-12-25','10:30:00',1.31),('9303','2013-12-25','10:35:00',1.42),('9303','2013-12-25','10:40:00',1.31),('9303','2013-12-25','10:45:00',1.28),('9303','2013-12-25','10:50:00',1.33),('9303','2013-12-25','11:15:00',1.28),('9303','2013-12-25','11:20:00',1.45),('9303','2013-12-25','11:25:00',1.16),('9303','2013-12-25','11:30:00',1.35),('9303','2013-12-25','11:40:00',1.48),('9303','2013-12-25','11:45:00',1.66),('9303','2013-12-25','11:50:00',1.01),('9303','2013-12-25','11:55:00',1.77),('9303','2013-12-25','12:00:00',1.51),('9303','2013-12-25','12:15:00',1.05),('9303','2013-12-25','12:20:00',1.38),('9303','2013-12-25','12:25:00',1.62),('9303','2013-12-24','09:45:00',1.08),('9303','2013-12-24','09:50:00',1.17),('9303','2013-12-24','09:55:00',1.23),('9303','2013-12-24','10:00:00',1.25),('9303','2013-12-24','10:05:00',1.32),('9303','2013-12-24','10:10:00',1.4),('9303','2013-12-24','10:15:00',1.4),('9303','2013-12-24','10:20:00',1.43),('9303','2013-12-24','10:25:00',1.43),('9303','2013-12-24','10:30:00',1.44),('9303','2013-12-24','10:35:00',1.46),('9303','2013-12-24','10:40:00',1.5),('9303','2013-12-24','10:45:00',1.49),('9303','2013-12-24','10:50:00',1.56),('9303','2013-12-24','10:55:00',1.63),('9303','2013-12-24','11:00:00',1.65),('9303','2013-12-24','11:05:00',1.68),('9303','2013-12-24','11:10:00',1.66),('9303','2013-12-24','11:15:00',1.68),('9303','2013-12-24','11:20:00',1.74),('9303','2013-12-24','11:25:00',1.76),('9303','2013-12-24','11:30:00',1.8),('9303','2013-12-24','11:35:00',1.79),('9303','2013-12-24','11:40:00',1.81),('9303','2013-12-24','11:45:00',1.84),('9303','2013-12-24','11:50:00',1.83),('9303','2013-12-24','11:55:00',1.81),('9303','2013-12-24','12:00:00',1.8),('9303','2013-12-24','12:05:00',1.77),('9303','2013-12-24','12:10:00',1.76),('9303','2013-12-24','12:15:00',1.81),('9303','2013-12-24','12:20:00',1.84),('9303','2013-12-24','12:25:00',1.86),('9303','2013-12-24','12:30:00',1.83),('9303','2013-12-24','12:35:00',1.87),('9303','2013-12-24','12:40:00',1.85),('9303','2013-12-24','12:45:00',1.83),('9303','2013-12-24','12:50:00',1.81),('9303','2013-12-24','12:55:00',1.75),('9303','2013-12-24','13:00:00',1.72),('9303','2013-12-24','13:05:00',1.66),('9303','2013-12-24','13:10:00',1.65),('9303','2013-12-24','13:15:00',1.62),('9303','2013-12-24','13:20:00',1.59),('9303','2013-12-24','13:25:00',1.55),('9303','2013-12-24','13:30:00',1.54),('9303','2013-12-24','13:35:00',1.5),('9303','2013-12-24','13:40:00',1.45),('9303','2013-12-24','13:45:00',1.4),('9303','2013-12-24','13:50:00',1.35),('9303','2013-12-24','13:55:00',1.3),('9303','2013-12-24','14:00:00',1.27),('9303','2013-12-24','14:05:00',1.25),('9303','2013-12-24','14:10:00',1.23),('9303','2013-12-24','14:15:00',1.21),('9303','2013-12-24','14:20:00',1.15),('9303','2013-12-24','14:25:00',1.07),('9303','2013-12-24','14:30:00',1.01),('9303','2013-12-23','09:55:00',1.17),('9303','2013-12-23','10:00:00',1.41),('9303','2013-12-23','10:05:00',1.57),('9303','2013-12-23','10:10:00',1.58),('9303','2013-12-23','10:15:00',1.51),('9303','2013-12-23','10:20:00',1.58),('9303','2013-12-23','10:25:00',1.51),('9303','2013-12-23','10:30:00',1.37),('9303','2013-12-23','10:35:00',1.38),('9303','2013-12-23','10:40:00',1.42),('9303','2013-12-23','10:45:00',1.44),('9303','2013-12-23','10:50:00',1.49),('9303','2013-12-23','10:55:00',1.59),('9303','2013-12-23','11:00:00',1.84),('9303','2013-12-23','11:05:00',1.92),('9303','2013-12-23','11:10:00',1.92),('9303','2013-12-23','11:15:00',1.94),('9303','2013-12-23','11:20:00',1.89),('9303','2013-12-23','11:25:00',1.91),('9303','2013-12-23','11:30:00',1.88),('9303','2013-12-23','11:35:00',1.94),('9303','2013-12-23','11:40:00',1.9),('9303','2013-12-23','11:45:00',1.67),('9303','2013-12-23','11:50:00',1.79),('9303','2013-12-23','11:55:00',1.81),('9303','2013-12-23','12:00:00',1.86),('9303','2013-12-23','12:05:00',1.86),('9303','2013-12-23','12:10:00',1.88),('9303','2013-12-23','12:15:00',1.91),('9303','2013-12-23','12:20:00',1.91),('9303','2013-12-23','12:25:00',1.89),('9303','2013-12-23','12:30:00',1.99),('9303','2013-12-23','12:35:00',2.07),('9303','2013-12-23','12:40:00',2.05),('9303','2013-12-23','12:45:00',2.03),('9303','2013-12-23','12:50:00',1.99),('9303','2013-12-23','12:55:00',1.97),('9303','2013-12-23','13:00:00',1.94),('9303','2013-12-23','13:05:00',1.89),('9303','2013-12-23','13:10:00',1.83),('9303','2013-12-23','13:15:00',1.8),('9303','2013-12-23','13:20:00',1.64),('9303','2013-12-23','13:25:00',1.46),('9303','2013-12-23','13:30:00',1.65),('9303','2013-12-23','13:40:00',1.25),('9303','2013-12-23','13:45:00',1.02),('9303','2013-12-23','13:50:00',1.13),('9303','2013-12-23','13:55:00',1.3),('9303','2013-12-23','14:00:00',1.5),('9303','2013-12-23','14:05:00',1.45),('9303','2013-12-23','14:10:00',1.4),('9303','2013-12-23','14:15:00',1.37),('9303','2013-12-23','14:20:00',1.32),('9303','2013-12-23','14:25:00',1.25),('9303','2013-12-23','14:30:00',1.14),('9303','2013-12-23','14:35:00',1.18),('9303','2013-12-23','14:40:00',1.1),('9303','2013-12-23','14:45:00',1.02),('9303','2013-12-22','09:40:00',1.3),('9303','2013-12-22','09:45:00',1.55),('9303','2013-12-22','09:50:00',1.65),('9303','2013-12-22','09:55:00',1.64),('9303','2013-12-22','10:00:00',1.68),('9303','2013-12-22','10:05:00',1.69),('9303','2013-12-22','10:10:00',1.72),('9303','2013-12-22','10:15:00',1.71),('9303','2013-12-22','10:20:00',1.65),('9303','2013-12-22','10:25:00',1.62),('9303','2013-12-22','10:30:00',1.63),('9303','2013-12-22','10:35:00',1.55),('9303','2013-12-22','10:40:00',1.5),('9303','2013-12-22','10:45:00',1.58),('9303','2013-12-22','10:50:00',1.69),('9303','2013-12-22','10:55:00',1.6),('9303','2013-12-22','11:00:00',1.47),('9303','2013-12-22','11:05:00',1.43),('9303','2013-12-22','11:10:00',1.88),('9303','2013-12-22','11:15:00',1.86),('9303','2013-12-22','11:20:00',1.71),('9303','2013-12-22','11:25:00',1.74),('9303','2013-12-22','11:30:00',1.65),('9303','2013-12-22','11:35:00',1.64),('9303','2013-12-22','11:40:00',1.78),('9303','2013-12-22','11:45:00',1.69),('9303','2013-12-22','11:50:00',1.26),('9303','2013-12-22','12:20:00',1.01),('9303','2013-12-22','12:25:00',1.11),('9303','2013-12-22','12:30:00',1.33),('9303','2013-12-22','12:35:00',1.54),('9303','2013-12-22','12:40:00',1.53),('9303','2013-12-22','12:45:00',1.44),('9303','2013-12-22','12:50:00',1.72),('9303','2013-12-22','12:55:00',2.07),('9303','2013-12-22','13:00:00',2),('9303','2013-12-22','13:05:00',2.33),('9303','2013-12-22','13:10:00',2.34),('9303','2013-12-22','13:15:00',1.8),('9303','2013-12-22','13:20:00',1.73),('9303','2013-12-22','13:25:00',1.72),('9303','2013-12-22','13:30:00',1.58),('9303','2013-12-22','13:35:00',1.48),('9303','2013-12-22','13:40:00',1.2),('9303','2013-12-22','13:45:00',1.34),('9303','2013-12-22','13:50:00',1.29),('9303','2013-12-22','13:55:00',1.14),('9303','2013-12-22','14:00:00',1.06),('9303','2013-12-22','14:05:00',1.13),('9303','2013-12-22','14:10:00',1.29),('9303','2013-12-22','14:40:00',1.05),('9303','2013-12-22','14:45:00',1),('9303','2013-12-21','09:45:00',1.11),('9303','2013-12-21','09:50:00',1.18),('9303','2013-12-21','09:55:00',1.27),('9303','2013-12-21','10:00:00',1.34),('9303','2013-12-21','10:05:00',1.4),('9303','2013-12-21','10:10:00',1.42),('9303','2013-12-21','10:15:00',1.45),('9303','2013-12-21','10:20:00',1.47),('9303','2013-12-21','10:25:00',1.47),('9303','2013-12-21','10:30:00',1.49),('9303','2013-12-21','10:35:00',1.51),('9303','2013-12-21','10:40:00',1.57),('9303','2013-12-21','10:45:00',1.55),('9303','2013-12-21','10:50:00',1.63),('9303','2013-12-21','10:55:00',1.7),('9303','2013-12-21','11:00:00',1.75),('9303','2013-12-21','11:05:00',1.77),('9303','2013-12-21','11:10:00',1.78),('9303','2013-12-21','11:15:00',1.82),('9303','2013-12-21','11:20:00',1.87),('9303','2013-12-21','11:25:00',1.89),('9303','2013-12-21','11:30:00',1.93),('9303','2013-12-21','11:35:00',1.91),('9303','2013-12-21','11:40:00',1.96),('9303','2013-12-21','11:45:00',1.97),('9303','2013-12-21','11:50:00',1.97),('9303','2013-12-21','11:55:00',1.97),('9303','2013-12-21','12:00:00',1.99),('9303','2013-12-21','12:05:00',1.97),('9303','2013-12-21','12:10:00',1.99),('9303','2013-12-21','12:15:00',2.02),('9303','2013-12-21','12:20:00',2.04),('9303','2013-12-21','12:25:00',2.06),('9303','2013-12-21','12:30:00',2.06),('9303','2013-12-21','12:35:00',2.12),('9303','2013-12-21','12:40:00',2.1),('9303','2013-12-21','12:45:00',2.07),('9303','2013-12-21','12:50:00',2.04),('9303','2013-12-21','12:55:00',2.01),('9303','2013-12-21','13:00:00',1.95),('9303','2013-12-21','13:05:00',1.89),('9303','2013-12-21','13:10:00',1.86),('9303','2013-12-21','13:15:00',1.85),('9303','2013-12-21','13:20:00',1.81),('9303','2013-12-21','13:25:00',1.76),('9303','2013-12-21','13:30:00',1.74),('9303','2013-12-21','13:35:00',1.68),('9303','2013-12-21','13:40:00',1.64),('9303','2013-12-21','13:45:00',1.61),('9303','2013-12-21','13:50:00',1.55),('9303','2013-12-21','13:55:00',1.52),('9303','2013-12-21','14:00:00',1.48),('9303','2013-12-21','14:05:00',1.42),('9303','2013-12-21','14:10:00',1.38),('9303','2013-12-21','14:15:00',1.38),('9303','2013-12-21','14:20:00',1.35),('9303','2013-12-21','14:25:00',1.28),('9303','2013-12-21','14:30:00',1.25),('9303','2013-12-21','14:35:00',1.2),('9303','2013-12-21','14:40:00',1.15),('9303','2013-12-21','14:45:00',1.08),('9303','2013-12-20','09:45:00',1.08),('9303','2013-12-20','09:50:00',1.15),('9303','2013-12-20','09:55:00',1.21),('9303','2013-12-20','10:00:00',1.27),('9303','2013-12-20','10:05:00',1.35),('9303','2013-12-20','10:10:00',1.36),('9303','2013-12-20','10:15:00',1.38),('9303','2013-12-20','10:20:00',1.4),('9303','2013-12-20','10:25:00',1.41),('9303','2013-12-20','10:30:00',1.39),('9303','2013-12-20','10:35:00',1.42),('9303','2013-12-20','10:40:00',1.49),('9303','2013-12-20','10:45:00',1.5),('9303','2013-12-20','10:50:00',1.58),('9303','2013-12-20','10:55:00',1.64),('9303','2013-12-20','11:00:00',1.67),('9303','2013-12-20','11:05:00',1.69),('9303','2013-12-20','11:10:00',1.7),('9303','2013-12-20','11:15:00',1.73),('9303','2013-12-20','11:20:00',1.76),('9303','2013-12-20','11:25:00',1.77),('9303','2013-12-20','11:30:00',1.8),('9303','2013-12-20','11:35:00',1.77),('9303','2013-12-20','11:40:00',1.83),('9303','2013-12-20','11:45:00',1.86),('9303','2013-12-20','11:50:00',1.85),('9303','2013-12-20','11:55:00',1.85),('9303','2013-12-20','12:00:00',1.89),('9303','2013-12-20','12:05:00',1.82),('9303','2013-12-20','12:10:00',1.88),('9303','2013-12-20','12:15:00',1.89),('9303','2013-12-20','12:20:00',1.92),('9303','2013-12-20','12:25:00',1.9),('9303','2013-12-20','12:30:00',1.94),('9303','2013-12-20','12:35:00',1.97),('9303','2013-12-20','12:40:00',1.95),('9303','2013-12-20','12:45:00',1.91),('9303','2013-12-20','12:50:00',1.87),('9303','2013-12-20','12:55:00',1.83),('9303','2013-12-20','13:00:00',1.8),('9303','2013-12-20','13:05:00',1.77),('9303','2013-12-20','13:10:00',1.73),('9303','2013-12-20','13:15:00',1.71),('9303','2013-12-20','13:20:00',1.65),('9303','2013-12-20','13:25:00',1.6),('9303','2013-12-20','13:30:00',1.56),('9303','2013-12-20','13:35:00',1.52),('9303','2013-12-20','13:40:00',1.48),('9303','2013-12-20','13:45:00',1.46),('9303','2013-12-20','13:50:00',1.41),('9303','2013-12-20','13:55:00',1.34),('9303','2013-12-20','14:00:00',1.21),('9303','2013-12-20','14:05:00',1),('9303','2013-12-19','09:35:00',1.03),('9303','2013-12-19','09:50:00',1.09),('9303','2013-12-19','09:55:00',1.5),('9303','2013-12-19','10:00:00',1.38),('9303','2013-12-19','10:05:00',1.53),('9303','2013-12-19','10:10:00',1.66),('9303','2013-12-19','10:15:00',1.7),('9303','2013-12-19','10:20:00',1.3),('9303','2013-12-19','10:30:00',1.04),('9303','2013-12-19','10:40:00',1.01),('9303','2013-12-19','10:45:00',1.44),('9303','2013-12-19','10:50:00',1.7),('9303','2013-12-19','11:15:00',1.56),('9303','2013-12-19','11:20:00',1.4),('9303','2013-12-19','14:30:00',1),('9303','2013-12-19','14:35:00',1.36),('9303','2013-12-19','14:40:00',1.17),('9303','2013-12-18','09:40:00',1.07),('9303','2013-12-18','09:45:00',1.18),('9303','2013-12-18','09:50:00',1.25),('9303','2013-12-18','09:55:00',1.31),('9303','2013-12-18','10:00:00',1.38),('9303','2013-12-18','10:05:00',1.42),('9303','2013-12-18','10:10:00',1.46),('9303','2013-12-18','10:15:00',1.49),('9303','2013-12-18','10:20:00',1.51),('9303','2013-12-18','10:25:00',1.52),('9303','2013-12-18','10:30:00',1.51),('9303','2013-12-18','10:35:00',1.55),('9303','2013-12-18','10:40:00',1.61),('9303','2013-12-18','10:45:00',1.6),('9303','2013-12-18','10:50:00',1.71),('9303','2013-12-18','10:55:00',1.73),('9303','2013-12-18','11:00:00',1.78),('9303','2013-12-18','11:05:00',1.78),('9303','2013-12-18','11:10:00',1.8),('9303','2013-12-18','11:15:00',1.85),('9303','2013-12-18','11:20:00',1.84),('9303','2013-12-18','11:25:00',1.85),('9303','2013-12-18','11:30:00',1.87),('9303','2013-12-18','11:35:00',1.87),('9303','2013-12-18','11:40:00',1.91),('9303','2013-12-18','11:45:00',1.9),('9303','2013-12-18','11:50:00',1.9),('9303','2013-12-18','11:55:00',1.89),('9303','2013-12-18','12:00:00',1.94),('9303','2013-12-18','12:05:00',1.9),('9303','2013-12-18','12:10:00',1.95),('9303','2013-12-18','12:15:00',1.98),('9303','2013-12-18','12:20:00',2),('9303','2013-12-18','12:25:00',1.99),('9303','2013-12-18','12:30:00',2.01),('9303','2013-12-18','12:35:00',2.04),('9303','2013-12-18','12:40:00',2.02),('9303','2013-12-18','12:45:00',2.02),('9303','2013-12-18','12:50:00',1.96),('9303','2013-12-18','12:55:00',1.93),('9303','2013-12-18','13:00:00',1.85),('9303','2013-12-18','13:05:00',1.78),('9303','2013-12-18','13:10:00',1.81),('9303','2013-12-18','13:15:00',1.79),('9303','2013-12-18','13:20:00',1.73),('9303','2013-12-18','13:25:00',1.7),('9303','2013-12-18','13:30:00',1.65),('9303','2013-12-18','13:35:00',1.62),('9303','2013-12-18','13:40:00',1.57),('9303','2013-12-18','13:45:00',1.5),('9303','2013-12-18','13:50:00',1.47),('9303','2013-12-18','13:55:00',1.43),('9303','2013-12-18','14:00:00',1.4),('9303','2013-12-18','14:05:00',1.33),('9303','2013-12-18','14:10:00',1.31),('9303','2013-12-18','14:15:00',1.31),('9303','2013-12-18','14:20:00',1.23),('9303','2013-12-18','14:25:00',1.23),('9303','2013-12-18','14:30:00',1.2),('9303','2013-12-18','14:35:00',1.15),('9303','2013-12-18','14:40:00',1.09),('9303','2013-12-18','14:45:00',1),('9303','2014-04-22','08:05:00',1.04),('9303','2014-04-22','08:10:00',1.16),('9303','2014-04-22','08:15:00',1.25),('9303','2014-04-22','08:20:00',1.36),('9303','2014-04-22','08:25:00',1.44),('9303','2014-04-22','08:30:00',1.54),('9303','2014-04-22','08:35:00',1.63),('9303','2014-04-22','08:40:00',1.75),('9303','2014-04-22','08:45:00',1.81),('9303','2014-04-22','08:50:00',1.89),('9303','2014-04-22','08:55:00',1.9),('9303','2014-04-22','09:00:00',2.01),('9303','2014-04-22','09:05:00',2.21),('9303','2014-04-22','09:10:00',2.09),('9303','2014-04-22','09:15:00',2.11),('9303','2014-04-22','09:20:00',2.33),('9303','2014-04-22','09:25:00',2.52),('9303','2014-04-22','09:30:00',2.36),('9303','2014-04-22','09:35:00',2.3),('9303','2014-04-22','09:40:00',2.62),('9303','2014-04-22','09:45:00',2.87),('9303','2014-04-22','09:50:00',2.36),('9303','2014-04-22','09:55:00',1.39),('9303','2014-04-22','10:00:00',1.27),('9303','2014-04-22','10:05:00',1.35),('9303','2014-04-22','10:10:00',1.73),('9303','2014-04-22','10:15:00',1.82),('9303','2014-04-22','10:20:00',2.87),('9303','2014-04-22','10:25:00',2.1),('9303','2014-04-22','10:30:00',3.23),('9303','2014-04-22','10:35:00',3.48),('9303','2014-04-22','10:40:00',3.2),('9303','2014-04-22','10:45:00',3.54),('9303','2014-04-22','10:50:00',3.88),('9303','2014-04-22','10:55:00',2.86),('9303','2014-04-22','11:00:00',1.87),('9303','2014-04-22','11:05:00',2.1),('9303','2014-04-22','11:10:00',1.55),('9303','2014-04-22','11:15:00',1.3),('9303','2014-04-22','11:20:00',1.11),('9303','2014-04-22','11:25:00',1.13),('9303','2014-04-22','11:35:00',1.06),('9303','2014-04-22','12:05:00',1.08),('9303','2014-04-22','12:10:00',1.12),('9303','2014-04-22','12:15:00',1.13),('9303','2014-04-22','12:20:00',1.18),('9303','2014-04-22','12:25:00',1.26),('9303','2014-04-22','12:30:00',1.48),('9303','2014-04-22','12:35:00',1.31),('9303','2014-04-22','13:15:00',1.18),('9303','2014-04-22','13:20:00',1.9),('9303','2014-04-22','13:25:00',2.36),('9303','2014-04-22','13:30:00',2.69),('9303','2014-04-22','13:35:00',2.48),('9303','2014-04-22','13:40:00',3.07),('9303','2014-04-22','13:45:00',3.12),('9303','2014-04-22','13:50:00',2.66),('9303','2014-04-22','13:55:00',1.48),('9303','2014-04-22','14:00:00',1.28),('9303','2014-04-22','14:05:00',1.51),('9303','2014-04-22','14:10:00',3.5),('9303','2014-04-22','14:15:00',3.13),('9303','2014-04-22','14:20:00',3.6),('9303','2014-04-22','14:25:00',2.7),('9303','2014-04-22','14:30:00',1.88),('9303','2014-04-22','14:35:00',2.19),('9303','2014-04-22','14:40:00',3.14),('9303','2014-04-22','14:45:00',3.8),('9303','2014-04-22','14:50:00',3.45),('9303','2014-04-22','14:55:00',2.74),('9303','2014-04-22','15:00:00',1.28),('9303','2014-04-22','15:05:00',1.21),('9303','2014-04-22','15:10:00',1.12),('9303','2014-04-22','15:15:00',1.08),('9303','2014-04-22','15:20:00',1.21),('9303','2014-04-22','15:25:00',1.32),('9303','2014-04-22','15:30:00',1.64),('9303','2014-04-22','15:35:00',2.43),('9303','2014-04-22','15:40:00',2.12),('9303','2014-04-22','15:45:00',1.79),('9303','2014-04-22','15:50:00',2.1),('9303','2014-04-22','15:55:00',1.7),('9303','2014-04-22','16:00:00',2.02),('9303','2014-04-22','16:05:00',1.42),('9303','2014-04-22','16:10:00',1.34),('9303','2014-04-22','16:15:00',1.27),('9303','2014-04-22','16:20:00',1.5),('9303','2014-04-22','16:25:00',1.45),('9303','2014-04-22','16:30:00',1.2),('9303','2014-04-22','16:35:00',1.28),('9303','2014-04-22','16:40:00',1.7),('9303','2014-04-22','16:45:00',1.57),('9303','2014-04-22','16:50:00',1.22),('9303','2014-04-22','16:55:00',1.07),('9303','2014-04-22','17:00:00',1.12),('9303','2014-04-22','17:05:00',1.33),('9303','2014-04-22','17:10:00',1.04),('9303','2013-12-17','09:40:00',1.1),('9303','2013-12-17','09:45:00',1.22),('9303','2013-12-17','09:50:00',1.31),('9303','2013-12-17','09:55:00',1.38),('9303','2013-12-17','10:00:00',1.43),('9303','2013-12-17','10:05:00',1.49),('9303','2013-12-17','10:10:00',1.5),('9303','2013-12-17','10:15:00',1.54),('9303','2013-12-17','10:20:00',1.56),('9303','2013-12-17','10:25:00',1.57),('9303','2013-12-17','10:30:00',1.57),('9303','2013-12-17','10:35:00',1.6),('9303','2013-12-17','10:40:00',1.66),('9303','2013-12-17','10:45:00',1.65),('9303','2013-12-17','10:50:00',1.76),('9303','2013-12-17','10:55:00',1.79),('9303','2013-12-17','11:00:00',1.84),('9303','2013-12-17','11:05:00',1.82),('9303','2013-12-17','11:10:00',1.86),('9303','2013-12-17','11:15:00',1.91),('9303','2013-12-17','11:20:00',1.92),('9303','2013-12-17','11:25:00',1.95),('9303','2013-12-17','11:30:00',1.97),('9303','2013-12-17','11:35:00',1.97),('9303','2013-12-17','11:40:00',2.01),('9303','2013-12-17','11:45:00',2.02),('9303','2013-12-17','11:50:00',2.04),('9303','2013-12-17','11:55:00',2.02),('9303','2013-12-17','12:00:00',2.03),('9303','2013-12-17','12:05:00',2),('9303','2013-12-17','12:10:00',2.05),('9303','2013-12-17','12:15:00',2.09),('9303','2013-12-17','12:20:00',2.11),('9303','2013-12-17','12:25:00',2.1),('9303','2013-12-17','12:30:00',2.13),('9303','2013-12-17','12:35:00',2.17),('9303','2013-12-17','12:40:00',2.15),('9303','2013-12-17','12:45:00',2.09),('9303','2013-12-17','12:50:00',2.06),('9303','2013-12-17','12:55:00',2),('9303','2013-12-17','13:00:00',1.95),('9303','2013-12-17','13:05:00',1.92),('9303','2013-12-17','13:10:00',1.88),('9303','2013-12-17','13:15:00',1.85),('9303','2013-12-17','13:20:00',1.79),('9303','2013-12-17','13:25:00',1.77),('9303','2013-12-17','13:30:00',1.74),('9303','2013-12-17','13:35:00',1.72),('9303','2013-12-17','13:40:00',1.67),('9303','2013-12-17','13:45:00',1.62),('9303','2013-12-17','13:50:00',1.57),('9303','2013-12-17','13:55:00',1.51),('9303','2013-12-17','14:00:00',1.49),('9303','2013-12-17','14:05:00',1.39),('9303','2013-12-17','14:10:00',1.38),('9303','2013-12-17','14:15:00',1.36),('9303','2013-12-17','14:20:00',1.32),('9303','2013-12-17','14:25:00',1.28),('9303','2013-12-17','14:30:00',1.24),('9303','2013-12-17','14:35:00',1.2),('9303','2013-12-17','14:40:00',1.15),('9303','2013-12-17','14:45:00',1.06),('9303','2013-12-16','09:40:00',1.12),('9303','2013-12-16','09:45:00',1.23),('9303','2013-12-16','09:50:00',1.28),('9303','2013-12-16','09:55:00',1.34),('9303','2013-12-16','10:00:00',1.4),('9303','2013-12-16','10:05:00',1.44),('9303','2013-12-16','10:10:00',1.46),('9303','2013-12-16','10:15:00',1.51),('9303','2013-12-16','10:20:00',1.5),('9303','2013-12-16','10:25:00',1.49),('9303','2013-12-16','10:30:00',1.47),('9303','2013-12-16','10:35:00',1.52),('9303','2013-12-16','10:40:00',1.6),('9303','2013-12-16','10:45:00',1.62),('9303','2013-12-16','10:50:00',1.7),('9303','2013-12-16','10:55:00',1.74),('9303','2013-12-16','11:00:00',1.78),('9303','2013-12-16','11:05:00',1.77),('9303','2013-12-16','11:10:00',1.79),('9303','2013-12-16','11:15:00',1.85),('9303','2013-12-16','11:20:00',1.85),('9303','2013-12-16','11:25:00',1.91),('9303','2013-12-16','11:30:00',1.9),('9303','2013-12-16','11:35:00',1.92),('9303','2013-12-16','11:40:00',1.95),('9303','2013-12-16','11:45:00',1.95),('9303','2013-12-16','11:50:00',1.96),('9303','2013-12-16','11:55:00',1.95),('9303','2013-12-16','12:00:00',1.99),('9303','2013-12-16','12:05:00',1.98),('9303','2013-12-16','12:10:00',2.03),('9303','2013-12-16','12:15:00',2.07),('9303','2013-12-16','12:20:00',2.09),('9303','2013-12-16','12:25:00',2.1),('9303','2013-12-16','12:30:00',2.13),('9303','2013-12-16','12:35:00',2.14),('9303','2013-12-16','12:40:00',2.12),('9303','2013-12-16','12:45:00',2.1),('9303','2013-12-16','12:50:00',2.07),('9303','2013-12-16','12:55:00',2.01),('9303','2013-12-16','13:00:00',1.96),('9303','2013-12-16','13:05:00',1.95),('9303','2013-12-16','13:10:00',1.89),('9303','2013-12-16','13:15:00',1.88),('9303','2013-12-16','13:20:00',1.8),('9303','2013-12-16','13:25:00',1.78),('9303','2013-12-16','13:30:00',1.75),('9303','2013-12-16','13:35:00',1.7),('9303','2013-12-16','13:40:00',1.64),('9303','2013-12-16','13:45:00',1.6),('9303','2013-12-16','13:50:00',1.58),('9303','2013-12-16','13:55:00',1.51),('9303','2013-12-16','14:00:00',1.45),('9303','2013-12-16','14:05:00',1.41),('9303','2013-12-16','14:10:00',1.4),('9303','2013-12-16','14:15:00',1.38),('9303','2013-12-16','14:20:00',1.32),('9303','2013-12-16','14:25:00',1.28),('9303','2013-12-16','14:30:00',1.25),('9303','2013-12-16','14:35:00',1.19),('9303','2013-12-16','14:40:00',1.13),('9303','2013-12-16','14:45:00',1.05),('9303','2013-12-15','10:20:00',1.08),('9303','2013-12-15','10:25:00',1.07),('9303','2013-12-15','10:30:00',1.02),('9303','2013-12-15','10:35:00',1.15),('9303','2013-12-15','10:40:00',1.17),('9303','2013-12-15','10:45:00',1.14),('9303','2013-12-14','09:35:00',1),('9303','2013-12-14','09:40:00',1.14),('9303','2013-12-14','09:45:00',1.25),('9303','2013-12-14','09:50:00',1.3),('9303','2013-12-14','09:55:00',1.37),('9303','2013-12-14','10:00:00',1.4),('9303','2013-12-14','10:05:00',1.43),('9303','2013-12-14','10:10:00',1.46),('9303','2013-12-14','10:15:00',1.52),('9303','2013-12-14','10:20:00',1.52),('9303','2013-12-14','10:25:00',1.51),('9303','2013-12-14','10:30:00',1.52),('9303','2013-12-14','10:35:00',1.57),('9303','2013-12-14','10:40:00',1.62),('9303','2013-12-14','10:45:00',1.63),('9303','2013-12-14','10:50:00',1.7),('9303','2013-12-14','10:55:00',1.72),('9303','2013-12-14','11:00:00',1.75),('9303','2013-12-14','11:05:00',1.74),('9303','2013-12-14','11:10:00',1.77),('9303','2013-12-14','11:15:00',1.82),('9303','2013-12-14','11:20:00',1.81),('9303','2013-12-14','11:25:00',1.85),('9303','2013-12-14','11:30:00',1.83),('9303','2013-12-14','11:35:00',1.88),('9303','2013-12-14','11:40:00',1.92),('9303','2013-12-14','11:45:00',1.87),('9303','2013-12-14','11:50:00',1.85),('9303','2013-12-14','11:55:00',1.86),('9303','2013-12-14','12:00:00',1.85),('9303','2013-12-14','12:05:00',1.85),('9303','2013-12-14','12:10:00',1.92),('9303','2013-12-14','12:15:00',1.94),('9303','2013-12-14','12:20:00',1.93),('9303','2013-12-14','12:25:00',1.92),('9303','2013-12-14','12:30:00',1.96),('9303','2013-12-14','12:35:00',1.96),('9303','2013-12-14','12:40:00',1.92),('9303','2013-12-14','12:45:00',1.9),('9303','2013-12-14','12:50:00',1.94),('9303','2013-12-14','12:55:00',1.89),('9303','2013-12-14','13:00:00',1.81),('9303','2013-12-14','13:05:00',1.82),('9303','2013-12-14','13:10:00',1.79),('9303','2013-12-14','13:15:00',1.77),('9303','2013-12-14','13:20:00',1.76),('9303','2013-12-14','13:25:00',1.74),('9303','2013-12-14','13:30:00',1.66),('9303','2013-12-14','13:35:00',1.66),('9303','2013-12-14','13:40:00',1.65),('9303','2013-12-14','13:45:00',1.6),('9303','2013-12-14','13:50:00',1.54),('9303','2013-12-14','13:55:00',1.49),('9303','2013-12-14','14:00:00',1.45),('9303','2013-12-14','14:05:00',1.42),('9303','2013-12-14','14:10:00',1.38),('9303','2013-12-14','14:15:00',1.37),('9303','2013-12-14','14:20:00',1.3),('9303','2013-12-14','14:25:00',1.27),('9303','2013-12-14','14:30:00',1.23),('9303','2013-12-14','14:35:00',1.18),('9303','2013-12-14','14:40:00',1.11),('9303','2013-12-14','14:45:00',1.03),('9303','2013-12-13','09:40:00',1.06),('9303','2013-12-13','09:45:00',1.16),('9303','2013-12-13','09:50:00',1.21),('9303','2013-12-13','09:55:00',1.28),('9303','2013-12-13','10:00:00',1.32),('9303','2013-12-13','10:05:00',1.35),('9303','2013-12-13','10:10:00',1.37),('9303','2013-12-13','10:15:00',1.43),('9303','2013-12-13','10:20:00',1.43),('9303','2013-12-13','10:25:00',1.44),('9303','2013-12-13','10:30:00',1.43),('9303','2013-12-13','10:35:00',1.5),('9303','2013-12-13','10:40:00',1.56),('9303','2013-12-13','10:45:00',1.58),('9303','2013-12-13','10:50:00',1.61),('9303','2013-12-13','10:55:00',1.63),('9303','2013-12-13','11:00:00',1.68),('9303','2013-12-13','11:05:00',1.7),('9303','2013-12-13','11:10:00',1.7),('9303','2013-12-13','11:15:00',1.77),('9303','2013-12-13','11:20:00',1.74),('9303','2013-12-13','11:25:00',1.78),('9303','2013-12-13','11:30:00',1.75),('9303','2013-12-13','11:35:00',1.78),('9303','2013-12-13','11:40:00',1.82),('9303','2013-12-13','11:45:00',1.82),('9303','2013-12-13','11:50:00',1.84),('9303','2013-12-13','11:55:00',1.86),('9303','2013-12-13','12:00:00',1.85),('9303','2013-12-13','12:05:00',1.83),('9303','2013-12-13','12:10:00',1.84),('9303','2013-12-13','12:15:00',1.86),('9303','2013-12-13','12:20:00',1.87),('9303','2013-12-13','12:25:00',1.92),('9303','2013-12-13','12:30:00',1.96),('9303','2013-12-13','12:35:00',1.94),('9303','2013-12-13','12:40:00',1.93),('9303','2013-12-13','12:45:00',1.94),('9303','2013-12-13','12:50:00',1.88),('9303','2013-12-13','12:55:00',1.8),('9303','2013-12-13','13:00:00',1.81),('9303','2013-12-13','13:05:00',1.77),('9303','2013-12-13','13:10:00',1.74),('9303','2013-12-13','13:15:00',1.73),('9303','2013-12-13','13:20:00',1.65),('9303','2013-12-13','13:25:00',1.72),('9303','2013-12-13','13:30:00',1.69),('9303','2013-12-13','13:35:00',1.64),('9303','2013-12-13','13:40:00',1.59),('9303','2013-12-13','13:45:00',1.54),('9303','2013-12-13','13:50:00',1.5),('9303','2013-12-13','13:55:00',1.45),('9303','2013-12-13','14:00:00',1.43),('9303','2013-12-13','14:05:00',1.4),('9303','2013-12-13','14:10:00',1.38),('9303','2013-12-13','14:15:00',1.36),('9303','2013-12-13','14:20:00',1.31),('9303','2013-12-13','14:25:00',1.29),('9303','2013-12-13','14:30:00',1.23),('9303','2013-12-13','14:35:00',1.19),('9303','2013-12-13','14:40:00',1.12),('9303','2013-12-13','14:45:00',1.05),('9303','2013-12-12','09:35:00',1.06),('9303','2013-12-12','09:40:00',1.19),('9303','2013-12-12','09:45:00',1.26),('9303','2013-12-12','09:50:00',1.3),('9303','2013-12-12','09:55:00',1.35),('9303','2013-12-12','10:00:00',1.39),('9303','2013-12-12','10:05:00',1.44),('9303','2013-12-12','10:10:00',1.48),('9303','2013-12-12','10:15:00',1.53),('9303','2013-12-12','10:20:00',1.52),('9303','2013-12-12','10:25:00',1.51),('9303','2013-12-12','10:30:00',1.52),('9303','2013-12-12','10:35:00',1.58),('9303','2013-12-12','10:40:00',1.63),('9303','2013-12-12','10:45:00',1.65),('9303','2013-12-12','10:50:00',1.7),('9303','2013-12-12','10:55:00',1.73),('9303','2013-12-12','11:00:00',1.73),('9303','2013-12-12','11:05:00',1.74),('9303','2013-12-12','11:10:00',1.77),('9303','2013-12-12','11:15:00',1.82),('9303','2013-12-12','11:20:00',1.82),('9303','2013-12-12','11:25:00',1.85),('9303','2013-12-12','11:30:00',1.82),('9303','2013-12-12','11:35:00',1.86),('9303','2013-12-12','11:40:00',1.88),('9303','2013-12-12','11:45:00',1.86),('9303','2013-12-12','11:50:00',1.84),('9303','2013-12-12','11:55:00',1.87),('9303','2013-12-12','12:00:00',1.84),('9303','2013-12-12','12:05:00',1.88),('9303','2013-12-12','12:10:00',1.92),('9303','2013-12-12','12:15:00',1.95),('9303','2013-12-12','12:20:00',1.98),('9303','2013-12-12','12:25:00',1.97),('9303','2013-12-12','12:30:00',2.02),('9303','2013-12-12','12:35:00',2.03),('9303','2013-12-12','12:40:00',2.01),('9303','2013-12-12','12:45:00',1.99),('9303','2013-12-12','12:50:00',1.91),('9303','2013-12-12','12:55:00',1.85),('9303','2013-12-12','13:00:00',1.79),('9303','2013-12-12','13:05:00',1.74),('9303','2013-12-12','13:10:00',1.76),('9303','2013-12-12','13:15:00',1.8),('9303','2013-12-12','13:20:00',1.73),('9303','2013-12-12','13:25:00',1.68),('9303','2013-12-12','13:30:00',1.67),('9303','2013-12-12','13:35:00',1.65),('9303','2013-12-12','13:40:00',1.6),('9303','2013-12-12','13:45:00',1.54),('9303','2013-12-12','13:50:00',1.52),('9303','2013-12-12','13:55:00',1.48),('9303','2013-12-12','14:00:00',1.42),('9303','2013-12-12','14:05:00',1.39),('9303','2013-12-12','14:10:00',1.33),('9303','2013-12-12','14:15:00',1.29),('9303','2013-12-12','14:20:00',1.25),('9303','2013-12-12','14:25:00',1.19),('9303','2013-12-12','14:30:00',1.15),('9303','2013-12-12','14:35:00',1.12),('9303','2013-12-12','14:40:00',1.06),('9303','2013-12-11','09:40:00',1.07),('9303','2013-12-11','09:45:00',1.12),('9303','2013-12-11','09:50:00',1.17),('9303','2013-12-11','09:55:00',1.34),('9303','2013-12-11','10:00:00',1.4),('9303','2013-12-11','10:05:00',1.43),('9303','2013-12-11','10:10:00',1.48),('9303','2013-12-11','10:15:00',1.55),('9303','2013-12-11','10:20:00',1.56),('9303','2013-12-11','10:25:00',1.56),('9303','2013-12-11','10:30:00',1.6),('9303','2013-12-11','10:35:00',1.68),('9303','2013-12-11','10:40:00',1.7),('9303','2013-12-11','10:45:00',1.71),('9303','2013-12-11','10:50:00',1.74),('9303','2013-12-11','10:55:00',1.79),('9303','2013-12-11','11:00:00',1.83),('9303','2013-12-11','11:05:00',1.84),('9303','2013-12-11','11:10:00',1.87),('9303','2013-12-11','11:15:00',1.9),('9303','2013-12-11','11:20:00',1.91),('9303','2013-12-11','11:25:00',1.92),('9303','2013-12-11','11:30:00',1.87),('9303','2013-12-11','11:35:00',1.92),('9303','2013-12-11','11:40:00',1.97),('9303','2013-12-11','11:45:00',1.96),('9303','2013-12-11','11:50:00',1.98),('9303','2013-12-11','11:55:00',2.02),('9303','2013-12-11','12:00:00',1.99),('9303','2013-12-11','12:05:00',2.01),('9303','2013-12-11','12:10:00',2.05),('9303','2013-12-11','12:15:00',2.09),('9303','2013-12-11','12:20:00',2.1),('9303','2013-12-11','12:25:00',2.02),('9303','2013-12-11','12:30:00',2.06),('9303','2013-12-11','12:35:00',2.07),('9303','2013-12-11','12:40:00',2.06),('9303','2013-12-11','12:45:00',2.03),('9303','2013-12-11','12:50:00',1.99),('9303','2013-12-11','12:55:00',1.95),('9303','2013-12-11','13:00:00',1.94),('9303','2013-12-11','13:05:00',1.89),('9303','2013-12-11','13:10:00',1.84),('9303','2013-12-11','13:15:00',1.8),('9303','2013-12-11','13:20:00',1.77),('9303','2013-12-11','13:25:00',1.76),('9303','2013-12-11','13:30:00',1.73),('9303','2013-12-11','13:35:00',1.69),('9303','2013-12-11','13:40:00',1.65),('9303','2013-12-11','13:45:00',1.59),('9303','2013-12-11','13:50:00',1.53),('9303','2013-12-11','13:55:00',1.5),('9303','2013-12-11','14:00:00',1.46),('9303','2013-12-11','14:05:00',1.42),('9303','2013-12-11','14:10:00',1.39),('9303','2013-12-11','14:15:00',1.35),('9303','2013-12-11','14:20:00',1.32),('9303','2013-12-11','14:25:00',1.29),('9303','2013-12-11','14:30:00',1.25),('9303','2013-12-11','14:35:00',1.2),('9303','2013-12-11','14:40:00',1.12),('9303','2013-12-11','14:45:00',1.04),('9303','2013-12-10','09:35:00',1.14),('9303','2013-12-10','09:40:00',1.25),('9303','2013-12-10','09:45:00',1.29),('9303','2013-12-10','09:50:00',1.32),('9303','2013-12-10','09:55:00',1.38),('9303','2013-12-10','10:00:00',1.44),('9303','2013-12-10','10:05:00',1.49),('9303','2013-12-10','10:10:00',1.54),('9303','2013-12-10','10:15:00',1.57),('9303','2013-12-10','10:20:00',1.57),('9303','2013-12-10','10:25:00',1.56),('9303','2013-12-10','10:30:00',1.61),('9303','2013-12-10','10:35:00',1.68),('9303','2013-12-10','10:40:00',1.67),('9303','2013-12-10','10:45:00',1.74),('9303','2013-12-10','10:50:00',1.78),('9303','2013-12-10','10:55:00',1.81),('9303','2013-12-10','11:00:00',1.83),('9303','2013-12-10','11:05:00',1.84),('9303','2013-12-10','11:10:00',1.88),('9303','2013-12-10','11:15:00',1.9),('9303','2013-12-10','11:20:00',1.93),('9303','2013-12-10','11:25:00',1.96),('9303','2013-12-10','11:30:00',1.95),('9303','2013-12-10','11:35:00',2),('9303','2013-12-10','11:40:00',2.02),('9303','2013-12-10','11:45:00',2.01),('9303','2013-12-10','11:50:00',1.99),('9303','2013-12-10','11:55:00',2.03),('9303','2013-12-10','12:00:00',1.99),('9303','2013-12-10','12:05:00',2.01),('9303','2013-12-10','12:10:00',2.04),('9303','2013-12-10','12:15:00',2.07),('9303','2013-12-10','12:20:00',2.07),('9303','2013-12-10','12:25:00',2.07),('9303','2013-12-10','12:30:00',2.1),('9303','2013-12-10','12:35:00',2.07),('9303','2013-12-10','12:40:00',2.03),('9303','2013-12-10','12:45:00',2.03),('9303','2013-12-10','12:50:00',1.97),('9303','2013-12-10','12:55:00',1.9),('9303','2013-12-10','13:00:00',1.82),('9303','2013-12-10','13:05:00',1.84),('9303','2013-12-10','13:10:00',1.81),('9303','2013-12-10','13:15:00',1.77),('9303','2013-12-10','13:20:00',1.73),('9303','2013-12-10','13:25:00',1.72),('9303','2013-12-10','13:30:00',1.69),('9303','2013-12-10','13:35:00',1.69),('9303','2013-12-10','13:40:00',1.68),('9303','2013-12-10','13:45:00',1.61),('9303','2013-12-10','13:50:00',1.58),('9303','2013-12-10','13:55:00',1.52),('9303','2013-12-10','14:00:00',1.5),('9303','2013-12-10','14:05:00',1.44),('9303','2013-12-10','14:10:00',1.4),('9303','2013-12-10','14:15:00',1.37),('9303','2013-12-10','14:20:00',1.35),('9303','2013-12-10','14:25:00',1.32),('9303','2013-12-10','14:30:00',1.28),('9303','2013-12-10','14:35:00',1.23),('9303','2013-12-10','14:40:00',1.16),('9303','2013-12-10','14:45:00',1.07),('9303','2013-12-09','09:35:00',1.06),('9303','2013-12-09','09:40:00',1.16),('9303','2013-12-09','09:45:00',1.18),('9303','2013-12-09','09:50:00',1.2),('9303','2013-12-09','09:55:00',1.27),('9303','2013-12-09','10:00:00',1.31),('9303','2013-12-09','10:05:00',1.48),('9303','2013-12-09','10:10:00',1.9),('9303','2013-12-09','10:15:00',1.91),('9303','2013-12-09','10:20:00',2.12),('9303','2013-12-09','10:25:00',1.28),('9303','2013-12-09','12:30:00',1.72),('9303','2013-12-09','12:35:00',1.15),('9303','2013-12-09','12:40:00',1.13),('9303','2013-12-09','12:45:00',1.4),('9303','2013-12-09','12:50:00',1.21),('9303','2013-12-09','12:55:00',1.74),('9303','2013-12-09','13:00:00',2.04),('9303','2013-12-09','13:05:00',1.7),('9303','2013-12-09','13:10:00',1.46),('9303','2013-12-09','13:15:00',1.3),('9303','2013-12-09','13:20:00',1.58),('9303','2013-12-09','13:25:00',1.1),('9303','2013-12-09','13:50:00',1.05),('9303','2013-12-09','13:55:00',1.1),('9303','2013-12-08','10:50:00',1.01),('9303','2013-12-08','10:55:00',1.01),('9303','2013-12-08','11:00:00',1.2),('9303','2013-12-08','11:05:00',1.12),('9303','2013-12-08','11:10:00',1.18),('9303','2013-12-08','11:15:00',1.4),('9303','2013-12-08','11:20:00',1.2),('9303','2013-12-08','13:00:00',1.09),('9303','2013-12-08','13:05:00',1.03),('9303','2013-12-08','13:10:00',1.09),('9303','2013-12-08','13:15:00',1.6),('9303','2013-12-08','13:20:00',1.26),('9303','2013-12-08','13:25:00',1.25),('9303','2014-04-21','09:20:00',1.33),('9303','2014-04-21','09:25:00',1.39),('9303','2014-04-21','10:00:00',1.28),('9303','2014-04-21','10:05:00',3.07),('9303','2014-04-21','10:10:00',2.99),('9303','2014-04-21','10:15:00',3.28),('9303','2014-04-21','10:20:00',3.18),('9303','2014-04-21','10:25:00',3.21),('9303','2014-04-21','10:30:00',3.2),('9303','2014-04-21','10:35:00',3.26),('9303','2014-04-21','10:40:00',3.29),('9303','2014-04-21','10:45:00',3.35),('9303','2014-04-21','10:50:00',3.37),('9303','2014-04-21','10:55:00',3.38),('9303','2014-04-21','11:00:00',3.41),('9303','2014-04-21','11:05:00',3.48),('9303','2014-04-21','11:10:00',3.51),('9303','2014-04-21','11:15:00',3.53),('9303','2014-04-21','11:20:00',3.58),('9303','2014-04-21','11:25:00',3.62),('9303','2014-04-21','11:30:00',3.67),('9303','2014-04-21','11:35:00',3.7),('9303','2014-04-21','11:40:00',3.73),('9303','2014-04-21','11:45:00',3.79),('9303','2014-04-21','11:50:00',3.83),('9303','2014-04-21','11:55:00',3.89),('9303','2014-04-21','12:00:00',3.89),('9303','2014-04-21','12:05:00',3.88),('9303','2014-04-21','12:10:00',3.94),('9303','2014-04-21','12:15:00',3.96),('9303','2014-04-21','12:20:00',4.01),('9303','2014-04-21','12:25:00',4.03),('9303','2014-04-21','12:30:00',4.04),('9303','2014-04-21','12:35:00',4.05),('9303','2014-04-21','12:40:00',4.11),('9303','2014-04-21','12:45:00',4.09),('9303','2014-04-21','12:50:00',4.11),('9303','2014-04-21','12:55:00',4.11),('9303','2014-04-21','13:00:00',4.1),('9303','2014-04-21','13:05:00',4.1),('9303','2014-04-21','13:10:00',4.11),('9303','2014-04-21','13:15:00',4.09),('9303','2014-04-21','13:20:00',4.11),('9303','2014-04-21','13:25:00',4.11),('9303','2014-04-21','13:30:00',4.09),('9303','2014-04-21','13:35:00',4.07),('9303','2014-04-21','13:40:00',4.04),('9303','2014-04-21','13:45:00',4.09),('9303','2014-04-21','13:50:00',4.1),('9303','2014-04-21','13:55:00',4.08),('9303','2014-04-21','14:00:00',4.06),('9303','2014-04-21','14:05:00',4.03),('9303','2014-04-21','14:10:00',4.01),('9303','2014-04-21','14:15:00',4.01),('9303','2014-04-21','14:20:00',3.99),('9303','2014-04-21','14:25:00',3.96),('9303','2014-04-21','14:30:00',3.95),('9303','2014-04-21','14:35:00',3.9),('9303','2014-04-21','14:40:00',3.85),('9303','2014-04-21','14:45:00',3.82),('9303','2014-04-21','14:50:00',3.79),('9303','2014-04-21','14:55:00',3.76),('9303','2014-04-21','15:00:00',3.72),('9303','2014-04-21','15:05:00',3.68),('9303','2014-04-21','15:10:00',3.65),('9303','2014-04-21','15:15:00',3.59),('9303','2014-04-21','15:20:00',3.53),('9303','2014-04-21','15:25:00',3.48),('9303','2014-04-21','15:30:00',3.43),('9303','2014-04-21','15:35:00',3.38),('9303','2014-04-21','15:40:00',3.32),('9303','2014-04-21','15:45:00',3.26),('9303','2014-04-21','15:50:00',3.2),('9303','2014-04-21','15:55:00',3.16),('9303','2014-04-21','16:00:00',3.1),('9303','2014-04-21','16:05:00',3.05),('9303','2014-04-21','16:10:00',3.01),('9303','2014-04-21','16:15:00',2.35),('9303','2014-04-21','16:20:00',2.91),('9303','2014-04-21','16:25:00',2.71),('9303','2014-04-21','16:30:00',2.45),('9303','2014-04-21','16:35:00',2.66),('9303','2014-04-21','16:40:00',2.6),('9303','2014-04-21','16:45:00',2.54),('9303','2014-04-21','16:50:00',2.42),('9303','2014-04-21','16:55:00',2.27),('9303','2014-04-21','17:00:00',2.16),('9303','2014-04-21','17:05:00',2.1),('9303','2014-04-21','17:10:00',2.02),('9303','2014-04-21','17:15:00',1.93),('9303','2014-04-21','17:20:00',1.87),('9303','2014-04-21','17:25:00',1.79),('9303','2014-04-21','17:30:00',1.72),('9303','2014-04-21','17:35:00',1.62),('9303','2014-04-21','17:40:00',1.46),('9303','2014-04-21','17:45:00',1.43),('9303','2014-04-21','17:50:00',1.35),('9303','2014-04-21','17:55:00',1.25),('9303','2014-04-21','18:00:00',1.16),('9303','2014-04-21','18:05:00',1.04),('9303','2013-12-07','09:30:00',1.03),('9303','2013-12-07','09:35:00',1.23),('9303','2013-12-07','09:40:00',1.35),('9303','2013-12-07','09:45:00',1.36),('9303','2013-12-07','09:50:00',1.36),('9303','2013-12-07','09:55:00',1.41),('9303','2013-12-07','10:00:00',1.5),('9303','2013-12-07','10:05:00',1.52),('9303','2013-12-07','10:10:00',1.56),('9303','2013-12-07','10:15:00',1.61),('9303','2013-12-07','10:20:00',1.62),('9303','2013-12-07','10:25:00',1.63),('9303','2013-12-07','10:30:00',1.64),('9303','2013-12-07','10:35:00',1.71),('9303','2013-12-07','10:40:00',1.7),('9303','2013-12-07','10:45:00',1.74),('9303','2013-12-07','10:50:00',1.74),('9303','2013-12-07','10:55:00',1.77),('9303','2013-12-07','11:00:00',1.77),('9303','2013-12-07','11:05:00',1.8),('9303','2013-12-07','11:10:00',1.85),('9303','2013-12-07','11:15:00',1.86),('9303','2013-12-07','11:20:00',1.91),('9303','2013-12-07','11:25:00',1.9),('9303','2013-12-07','11:30:00',1.91),('9303','2013-12-07','11:35:00',1.93),('9303','2013-12-07','11:40:00',1.9),('9303','2013-12-07','11:45:00',1.92),('9303','2013-12-07','11:50:00',1.9),('9303','2013-12-07','11:55:00',1.91),('9303','2013-12-07','12:00:00',1.89),('9303','2013-12-07','12:05:00',1.94),('9303','2013-12-07','12:10:00',1.98),('9303','2013-12-07','12:15:00',2.02),('9303','2013-12-07','12:20:00',2.02),('9303','2013-12-07','12:25:00',2.04),('9303','2013-12-07','12:30:00',2.06),('9303','2013-12-07','12:35:00',2.05),('9303','2013-12-07','12:40:00',2),('9303','2013-12-07','12:45:00',2),('9303','2013-12-07','12:50:00',1.95),('9303','2013-12-07','12:55:00',1.86),('9303','2013-12-07','13:00:00',1.87),('9303','2013-12-07','13:05:00',1.85),('9303','2013-12-07','13:10:00',1.84),('9303','2013-12-07','13:15:00',1.8),('9303','2013-12-07','13:20:00',1.79),('9303','2013-12-07','13:25:00',1.74),('9303','2013-12-07','13:30:00',1.7),('9303','2013-12-07','13:35:00',1.68),('9303','2013-12-07','13:40:00',1.66),('9303','2013-12-07','13:45:00',1.62),('9303','2013-12-07','13:50:00',1.57),('9303','2013-12-07','13:55:00',1.5),('9303','2013-12-07','14:00:00',1.45),('9303','2013-12-07','14:05:00',1.42),('9303','2013-12-07','14:10:00',1.4),('9303','2013-12-07','14:15:00',1.34),('9303','2013-12-07','14:20:00',1.3),('9303','2013-12-07','14:25:00',1.25),('9303','2013-12-07','14:30:00',1.2),('9303','2013-12-07','14:35:00',1.15),('9303','2013-12-07','14:40:00',1.08),('9303','2013-12-07','14:45:00',1.02),('9303','2013-12-06','10:10:00',1.02),('9303','2013-12-06','11:35:00',1.1),('9303','2013-12-06','11:40:00',1.61),('9303','2013-12-06','11:45:00',1.35),('9303','2013-12-06','11:50:00',1.51),('9303','2013-12-06','11:55:00',1.43),('9303','2013-12-06','12:00:00',1.47),('9303','2013-12-06','12:05:00',1.37),('9303','2013-12-06','12:10:00',1.45),('9303','2013-12-06','12:15:00',1.13),('9303','2013-12-06','12:20:00',1.61),('9303','2013-12-06','12:25:00',1.15),('9303','2013-12-06','12:30:00',1.25),('9303','2013-12-06','12:35:00',1.74),('9303','2013-12-06','12:40:00',1.7),('9303','2013-12-06','14:40:00',1.06),('9303','2013-12-05','09:25:00',1.08),('9303','2013-12-05','09:30:00',1.17),('9303','2013-12-05','09:35:00',1.27),('9303','2013-12-05','09:40:00',1.36),('9303','2013-12-05','09:45:00',1.36),('9303','2013-12-05','09:50:00',1.41),('9303','2013-12-05','09:55:00',1.47),('9303','2013-12-05','10:00:00',1.53),('9303','2013-12-05','10:05:00',1.56),('9303','2013-12-05','10:10:00',1.61),('9303','2013-12-05','10:15:00',1.65),('9303','2013-12-05','10:20:00',1.66),('9303','2013-12-05','10:25:00',1.68),('9303','2013-12-05','10:30:00',1.71),('9303','2013-12-05','10:35:00',1.76),('9303','2013-12-05','10:40:00',1.75),('9303','2013-12-05','10:45:00',1.78),('9303','2013-12-05','10:50:00',1.8),('9303','2013-12-05','10:55:00',1.86),('9303','2013-12-05','11:00:00',1.84),('9303','2013-12-05','11:05:00',1.86),('9303','2013-12-05','11:10:00',1.86),('9303','2013-12-05','11:15:00',1.92),('9303','2013-12-05','11:20:00',1.95),('9303','2013-12-05','11:25:00',1.94),('9303','2013-12-05','11:30:00',1.96),('9303','2013-12-05','11:35:00',1.99),('9303','2013-12-05','11:40:00',1.99),('9303','2013-12-05','11:45:00',1.97),('9303','2013-12-05','11:50:00',1.97),('9303','2013-12-05','11:55:00',1.99),('9303','2013-12-05','12:00:00',2),('9303','2013-12-05','12:05:00',2.04),('9303','2013-12-05','12:10:00',2.05),('9303','2013-12-05','12:15:00',2.03),('9303','2013-12-05','12:20:00',2.08),('9303','2013-12-05','12:25:00',2.02),('9303','2013-12-05','12:30:00',2.11),('9303','2013-12-05','12:35:00',2.09),('9303','2013-12-05','12:40:00',2.04),('9303','2013-12-05','12:45:00',1.97),('9303','2013-12-05','12:50:00',1.72),('9303','2013-12-05','12:55:00',1.72),('9303','2013-12-05','13:00:00',1.47),('9303','2013-12-05','13:05:00',1.22),('9303','2013-12-05','13:10:00',1.9),('9303','2013-12-05','13:15:00',1.89),('9303','2013-12-05','13:20:00',1.75),('9303','2013-12-05','13:25:00',1.67),('9303','2013-12-05','13:30:00',1.02),('9303','2013-12-05','13:35:00',1.62),('9303','2013-12-05','13:40:00',1.64),('9303','2013-12-05','13:45:00',1.59),('9303','2013-12-05','13:50:00',1.55),('9303','2013-12-05','13:55:00',1.47),('9303','2013-12-05','14:00:00',1.45),('9303','2013-12-05','14:05:00',1.45),('9303','2013-12-05','14:10:00',1.39),('9303','2013-12-05','14:15:00',1.32),('9303','2013-12-05','14:20:00',1.31),('9303','2013-12-05','14:25:00',1.28),('9303','2013-12-05','14:30:00',1.24),('9303','2013-12-05','14:35:00',1.18),('9303','2013-12-05','14:40:00',1.13),('9303','2013-12-05','14:45:00',1.03),('9303','2013-12-04','11:40:00',1.01),('9303','2013-12-04','11:45:00',1.04),('9303','2013-12-04','11:50:00',1.03),('9303','2013-12-04','11:55:00',1.03),('9303','2013-12-04','12:00:00',1.04),('9303','2013-12-04','12:05:00',1.04),('9303','2013-12-04','12:10:00',1.03),('9303','2013-12-04','12:15:00',1.02),('9303','2013-12-04','12:20:00',1.01),('9303','2013-12-04','13:25:00',1.11),('9303','2013-12-04','13:30:00',1.56),('9303','2013-12-04','13:35:00',1.45),('9303','2013-12-04','13:40:00',1.64),('9303','2013-12-04','13:45:00',1.6),('9303','2013-12-04','13:50:00',1.63),('9303','2013-12-04','13:55:00',1.6),('9303','2013-12-04','14:00:00',1.55),('9303','2013-12-04','14:05:00',1.52),('9303','2013-12-04','14:10:00',1.49),('9303','2013-12-04','14:15:00',1.45),('9303','2013-12-04','14:20:00',1.4),('9303','2013-12-04','14:25:00',1.36),('9303','2013-12-04','14:30:00',1.33),('9303','2013-12-04','14:35:00',1.3),('9303','2013-12-04','14:40:00',1.25),('9303','2013-12-04','14:45:00',1.15),('9303','2013-12-04','14:50:00',1.07),('9303','2013-12-03','11:10:00',1.01),('9303','2013-12-03','11:15:00',1.02),('9303','2013-12-03','11:20:00',1.04),('9303','2013-12-03','11:25:00',1.05),('9303','2013-12-03','11:30:00',1.06),('9303','2013-12-03','11:35:00',1.07),('9303','2013-12-03','11:40:00',1.1),('9303','2013-12-03','11:45:00',1.13),('9303','2013-12-03','11:50:00',1.14),('9303','2013-12-03','11:55:00',1.16),('9303','2013-12-03','12:00:00',1.17),('9303','2013-12-03','12:05:00',1.18),('9303','2013-12-03','12:10:00',1.18),('9303','2013-12-03','12:15:00',1.19),('9303','2013-12-03','12:20:00',1.2),('9303','2013-12-03','12:25:00',1.22),('9303','2013-12-03','12:30:00',1.25),('9303','2013-12-03','12:35:00',1.29),('9303','2013-12-03','12:40:00',1.32),('9303','2013-12-03','12:45:00',1.36),('9303','2013-12-03','12:50:00',1.43),('9303','2013-12-03','12:55:00',1.52),('9303','2013-12-03','13:00:00',1.57),('9303','2013-12-03','13:05:00',1.58);
INSERT INTO `solarlogmod` VALUES ('9303','2013-12-03','13:10:00',1.54),('9303','2013-12-03','13:15:00',1.47),('9303','2013-12-03','13:20:00',1.4),('9303','2013-12-03','13:25:00',1.28),('9303','2013-12-03','13:30:00',1.12),('9303','2013-12-01','11:55:00',1.14),('9303','2013-12-01','12:00:00',1.02),('9303','2013-12-01','12:05:00',1.1),('9303','2013-12-01','12:10:00',1.4),('9303','2013-12-01','12:15:00',1.03),('9303','2013-11-30','09:35:00',1.01),('9303','2013-11-30','09:40:00',1.09),('9303','2013-11-30','09:45:00',1.02),('9303','2013-11-30','10:00:00',1.01),('9303','2013-11-30','10:20:00',1.09),('9303','2013-11-30','10:25:00',1.06),('9303','2013-11-30','10:30:00',1.12),('9303','2013-11-30','10:35:00',1.21),('9303','2013-11-30','10:40:00',1.31),('9303','2013-11-30','10:45:00',1.24),('9303','2013-11-30','10:50:00',1.19),('9303','2013-11-30','10:55:00',1.05),('9303','2013-11-30','11:05:00',1.17),('9303','2013-11-30','11:10:00',1.29),('9303','2013-11-30','11:15:00',1.24),('9303','2013-11-30','11:20:00',1.11),('9303','2013-11-30','11:25:00',1.18),('9303','2013-11-30','11:30:00',1.08),('9303','2013-11-29','10:50:00',1.04),('9303','2013-11-29','10:55:00',1.08),('9303','2013-11-29','11:00:00',1.11),('9303','2013-11-29','11:05:00',1.15),('9303','2013-11-29','11:10:00',1.16),('9303','2013-11-29','11:15:00',1.2),('9303','2013-11-29','11:20:00',1.24),('9303','2013-11-29','11:25:00',1.26),('9303','2013-11-29','11:30:00',1.29),('9303','2013-11-29','11:35:00',1.3),('9303','2013-11-29','11:40:00',1.31),('9303','2013-11-29','11:45:00',1.31),('9303','2013-11-29','11:50:00',1.32),('9303','2013-11-29','11:55:00',1.32),('9303','2013-11-29','12:00:00',1.33),('9303','2013-11-29','12:05:00',1.32),('9303','2013-11-29','12:10:00',1.31),('9303','2013-11-29','12:15:00',1.3),('9303','2013-11-29','12:20:00',1.29),('9303','2013-11-29','12:25:00',1.27),('9303','2013-11-29','12:30:00',1.23),('9303','2013-11-29','12:35:00',1.19),('9303','2013-11-29','12:40:00',1.14),('9303','2013-11-29','12:45:00',1.11),('9303','2013-11-29','12:50:00',1.07),('9303','2013-11-29','12:55:00',1.03),('9303','2014-04-20','08:10:00',1.06),('9303','2014-04-20','08:15:00',1.27),('9303','2014-04-20','08:20:00',1.45),('9303','2014-04-20','08:25:00',2.09),('9303','2014-04-20','08:30:00',2.21),('9303','2014-04-20','08:35:00',2.19),('9303','2014-04-20','08:40:00',1.22),('9303','2014-04-20','08:45:00',1.31),('9303','2014-04-20','08:50:00',1.71),('9303','2014-04-20','09:00:00',1.96),('9303','2014-04-20','09:10:00',1.61),('9303','2014-04-20','09:15:00',2.51),('9303','2014-04-20','09:20:00',2.59),('9303','2014-04-20','09:25:00',2.86),('9303','2014-04-20','09:30:00',3.32),('9303','2014-04-20','09:35:00',2.88),('9303','2014-04-20','09:40:00',2.04),('9303','2014-04-20','09:45:00',1.38),('9303','2014-04-20','09:50:00',1.41),('9303','2014-04-20','09:55:00',1.74),('9303','2014-04-20','10:00:00',2.11),('9303','2014-04-20','10:05:00',2.91),('9303','2014-04-20','10:10:00',2.51),('9303','2014-04-20','10:15:00',2.75),('9303','2014-04-20','10:20:00',2.72),('9303','2014-04-20','10:25:00',2.54),('9303','2014-04-20','10:30:00',2.37),('9303','2014-04-20','10:35:00',2.53),('9303','2014-04-20','10:40:00',2.41),('9303','2014-04-20','10:45:00',2.48),('9303','2014-04-20','10:50:00',2.85),('9303','2014-04-20','10:55:00',2.93),('9303','2014-04-20','11:00:00',3.31),('9303','2014-04-20','11:05:00',3.28),('9303','2014-04-20','11:10:00',3.17),('9303','2014-04-20','11:15:00',3.8),('9303','2014-04-20','11:20:00',2.47),('9303','2014-04-20','11:25:00',2.77),('9303','2014-04-20','11:30:00',3.78),('9303','2014-04-20','11:35:00',4.15),('9303','2014-04-20','11:40:00',3.83),('9303','2014-04-20','11:45:00',4.05),('9303','2014-04-20','11:50:00',3.22),('9303','2014-04-20','12:00:00',3.02),('9303','2014-04-20','12:05:00',4.43),('9303','2014-04-20','12:10:00',4.57),('9303','2014-04-20','12:15:00',2.82),('9303','2014-04-20','12:20:00',1.29),('9303','2014-04-20','12:25:00',4.67),('9303','2014-04-20','12:30:00',4.4),('9303','2014-04-20','12:35:00',4.2),('9303','2014-04-20','12:40:00',4.15),('9303','2014-04-20','12:45:00',4.2),('9303','2014-04-20','12:50:00',4.22),('9303','2014-04-20','12:55:00',4.27),('9303','2014-04-20','13:00:00',4.28),('9303','2014-04-20','13:05:00',4.31),('9303','2014-04-20','13:10:00',4.39),('9303','2014-04-20','13:15:00',4.37),('9303','2014-04-20','13:20:00',4.21),('9303','2014-04-20','13:25:00',4.16),('9303','2014-04-20','13:30:00',4.19),('9303','2014-04-20','13:35:00',4.2),('9303','2014-04-20','13:40:00',4.2),('9303','2014-04-20','13:45:00',4.16),('9303','2014-04-20','13:50:00',4.15),('9303','2014-04-20','13:55:00',4.15),('9303','2014-04-20','14:00:00',4.12),('9303','2014-04-20','14:05:00',4.12),('9303','2014-04-20','14:10:00',4.1),('9303','2014-04-20','14:15:00',4.27),('9303','2014-04-20','14:20:00',3.39),('9303','2014-04-20','14:25:00',2.92),('9303','2014-04-20','14:30:00',2.92),('9303','2014-04-20','14:35:00',2.34),('9303','2014-04-20','14:40:00',2.31),('9303','2014-04-20','14:45:00',2.49),('9303','2014-04-20','14:50:00',2.37),('9303','2014-04-20','14:55:00',2.7),('9303','2014-04-20','15:00:00',3.6),('9303','2014-04-20','15:05:00',3.61),('9303','2014-04-20','15:10:00',3.49),('9303','2014-04-20','15:15:00',3.73),('9303','2014-04-20','15:20:00',3.56),('9303','2014-04-20','15:25:00',3.55),('9303','2014-04-20','15:30:00',3.5),('9303','2014-04-20','15:35:00',3.45),('9303','2014-04-20','15:40:00',3.46),('9303','2014-04-20','15:45:00',3.14),('9303','2014-04-20','15:50:00',2.37),('9303','2014-04-20','15:55:00',3.31),('9303','2014-04-20','16:00:00',3.2),('9303','2014-04-20','16:05:00',3.13),('9303','2014-04-20','16:10:00',3.09),('9303','2014-04-20','16:15:00',3.04),('9303','2014-04-20','16:20:00',3.05),('9303','2014-04-20','16:25:00',2.45),('9303','2014-04-20','16:30:00',2.94),('9303','2014-04-20','16:35:00',2.7),('9303','2014-04-20','16:40:00',2.63),('9303','2014-04-20','16:45:00',2.41),('9303','2014-04-20','16:50:00',2.34),('9303','2014-04-20','16:55:00',2.45),('9303','2014-04-20','17:00:00',2.27),('9303','2014-04-20','17:05:00',2.17),('9303','2014-04-20','17:10:00',2.06),('9303','2014-04-20','17:15:00',1.96),('9303','2014-04-20','17:20:00',1.88),('9303','2014-04-20','17:25:00',1.79),('9303','2014-04-20','17:30:00',1.71),('9303','2014-04-20','17:35:00',1.61),('9303','2014-04-20','17:40:00',1.51),('9303','2014-04-20','17:45:00',1.4),('9303','2014-04-20','17:50:00',1.3),('9303','2014-04-20','17:55:00',1.22),('9303','2014-04-20','18:00:00',1.13),('9303','2014-04-20','18:05:00',1.03),('9303','2013-11-27','10:00:00',1.04),('9303','2013-11-27','10:05:00',1.14),('9303','2013-11-27','10:10:00',1.13),('9303','2013-11-27','10:15:00',1.11),('9303','2013-11-27','10:20:00',1.04),('9303','2013-11-27','10:35:00',1.01),('9303','2013-11-27','10:40:00',1.11),('9303','2013-11-27','10:45:00',1.3),('9303','2013-11-27','10:50:00',1.24),('9303','2013-11-27','10:55:00',1.19),('9303','2013-11-27','11:00:00',1.22),('9303','2013-11-27','11:05:00',1.26),('9303','2013-11-27','11:10:00',1.45),('9303','2013-11-27','11:15:00',1.33),('9303','2013-11-27','11:20:00',1.26),('9303','2013-11-27','11:25:00',1.19),('9303','2013-11-27','11:30:00',1.74),('9303','2013-11-27','11:35:00',1.74),('9303','2013-11-27','11:40:00',1.42),('9303','2013-11-27','11:45:00',1.42),('9303','2013-11-27','11:50:00',1.57),('9303','2013-11-27','11:55:00',1.87),('9303','2013-11-27','12:00:00',1.82),('9303','2013-11-27','12:05:00',1.45),('9303','2013-11-27','12:15:00',1.53),('9303','2013-11-27','12:20:00',1.79),('9303','2013-11-27','12:25:00',1.07),('9303','2013-11-27','12:30:00',1.21),('9303','2013-11-27','12:35:00',1.49),('9303','2013-11-27','12:40:00',1.11),('9303','2013-11-26','09:55:00',1.01),('9303','2013-11-26','10:00:00',1.05),('9303','2013-11-26','10:05:00',1.11),('9303','2013-11-26','10:30:00',1.06),('9303','2013-11-26','10:35:00',1.11),('9303','2013-11-26','10:40:00',1.18),('9303','2013-11-26','10:45:00',1.25),('9303','2013-11-26','10:50:00',1.3),('9303','2013-11-26','10:55:00',1.35),('9303','2013-11-26','11:00:00',1.58),('9303','2013-11-26','11:05:00',1.32),('9303','2013-11-26','11:10:00',1.79),('9303','2013-11-26','11:15:00',2.06),('9303','2013-11-26','11:20:00',1.71),('9303','2013-11-26','11:25:00',1.84),('9303','2013-11-26','11:30:00',1.92),('9303','2013-11-26','11:35:00',1.99),('9303','2013-11-26','11:40:00',2.12),('9303','2013-11-26','11:45:00',2.14),('9303','2013-11-26','11:50:00',2.09),('9303','2013-11-26','11:55:00',1.33),('9303','2013-11-26','12:05:00',1.03),('9303','2013-11-26','12:20:00',1.56),('9303','2013-11-26','12:25:00',1.52),('9303','2013-11-26','12:30:00',1.46),('9303','2013-11-26','12:35:00',1.45),('9303','2013-11-26','12:40:00',1.43),('9303','2013-11-26','12:45:00',1.32),('9303','2013-11-26','12:50:00',1.29),('9303','2013-11-26','12:55:00',1.23),('9303','2013-11-26','13:00:00',1.19),('9303','2013-11-26','13:05:00',1.13),('9303','2013-11-26','13:10:00',1.07),('9303','2013-11-26','13:15:00',1.01),('9303','2013-11-26','14:15:00',1.05),('9303','2013-11-25','09:20:00',1.01),('9303','2013-11-25','09:25:00',1.04),('9303','2013-11-25','10:20:00',1.01),('9303','2013-11-25','10:25:00',1.13),('9303','2013-11-25','10:30:00',1.57),('9303','2013-11-25','10:35:00',1.83),('9303','2013-11-25','10:40:00',1.91),('9303','2013-11-25','10:45:00',1.56),('9303','2013-11-25','10:50:00',1.34),('9303','2013-11-25','10:55:00',1.39),('9303','2013-11-25','11:00:00',1.52),('9303','2013-11-25','11:05:00',1.72),('9303','2013-11-25','11:10:00',2.15),('9303','2013-11-25','11:15:00',1.7),('9303','2013-11-25','11:20:00',1.04),('9303','2013-11-25','11:25:00',1.07),('9303','2013-11-25','11:30:00',1.13),('9303','2013-11-25','11:35:00',1.02),('9303','2013-11-25','11:50:00',1.14),('9303','2013-11-25','11:55:00',1.17),('9303','2013-11-25','12:05:00',1.03),('9303','2013-11-25','12:10:00',1.45),('9303','2013-11-25','12:15:00',1.29),('9303','2013-11-25','12:20:00',1.24),('9303','2013-11-25','12:25:00',1.27),('9303','2013-11-25','12:30:00',1.12),('9303','2013-11-25','12:40:00',1.83),('9303','2013-11-25','12:45:00',1.73),('9303','2013-11-25','12:50:00',1.29),('9303','2013-11-25','12:55:00',1.52),('9303','2013-11-25','13:00:00',1.97),('9303','2013-11-25','13:05:00',2.02),('9303','2013-11-25','13:10:00',1.49),('9303','2013-11-25','13:15:00',1.44),('9303','2013-11-25','13:20:00',1.73),('9303','2013-11-25','13:25:00',1.21),('9303','2013-11-24','09:55:00',1.03),('9303','2013-11-24','10:00:00',1.29),('9303','2013-11-24','10:05:00',1.41),('9303','2013-11-24','10:10:00',1.47),('9303','2013-11-24','10:15:00',1.31),('9303','2013-11-24','10:20:00',1.13),('9303','2013-11-24','10:25:00',1.47),('9303','2013-11-24','10:30:00',1.45),('9303','2013-11-24','10:35:00',1.04),('9303','2013-11-24','10:55:00',1.06),('9303','2013-11-24','11:00:00',1.09),('9303','2013-11-24','11:05:00',1.11),('9303','2013-11-24','11:10:00',1.18),('9303','2013-11-24','11:15:00',1.21),('9303','2013-11-24','11:20:00',1.37),('9303','2013-11-24','11:25:00',1.48),('9303','2013-11-24','11:30:00',1.28),('9303','2013-11-24','11:35:00',1.08),('9303','2013-11-24','11:50:00',1.11),('9303','2013-11-24','13:05:00',1.03),('9303','2013-11-24','13:10:00',1.15),('9303','2013-11-24','13:15:00',1.1),('9303','2013-11-23','10:25:00',1.08),('9303','2013-11-23','10:30:00',1.21),('9303','2013-11-23','10:40:00',1.72),('9303','2013-11-23','13:35:00',1.17),('9303','2013-11-23','13:40:00',1.09),('9303','2013-11-21','09:45:00',1.04),('9303','2013-11-21','09:50:00',1.05),('9303','2013-11-21','10:05:00',1.14),('9303','2013-11-21','10:10:00',1.08),('9303','2013-11-21','10:15:00',1.29),('9303','2013-11-21','10:20:00',1.41),('9303','2013-11-21','10:30:00',1.29),('9303','2013-11-21','10:35:00',1.42),('9303','2013-11-21','10:40:00',1.62),('9303','2013-11-21','10:45:00',1.34),('9303','2013-11-21','11:25:00',1.34),('9303','2013-11-21','11:30:00',1.79),('9303','2013-11-21','11:35:00',1.08),('9303','2013-11-21','11:40:00',1.66),('9303','2013-11-21','11:45:00',1.48),('9303','2013-11-21','11:50:00',1.77),('9303','2013-11-21','11:55:00',1.77),('9303','2013-11-21','12:00:00',1.04),('9303','2013-11-21','12:05:00',1.76),('9303','2013-11-21','12:10:00',1.84),('9303','2013-11-21','12:15:00',1.81),('9303','2013-11-21','12:20:00',1.82),('9303','2013-11-21','12:25:00',1.9),('9303','2013-11-21','12:30:00',2.05),('9303','2013-11-21','12:35:00',2.13),('9303','2013-11-21','12:40:00',2.22),('9303','2013-11-21','12:45:00',2.04),('9303','2013-11-21','12:50:00',1.96),('9303','2013-11-21','12:55:00',2.18),('9303','2013-11-21','13:00:00',2.08),('9303','2013-11-21','13:05:00',1.79),('9303','2013-11-21','13:10:00',1.02),('9303','2013-11-21','13:15:00',1.71),('9303','2013-11-21','13:20:00',1.65),('9303','2013-11-21','13:25:00',1.18),('9303','2013-11-21','13:45:00',1.12),('9303','2013-11-21','13:55:00',1.12),('9303','2013-11-20','09:30:00',1.04),('9303','2013-11-20','10:00:00',1.22),('9303','2013-11-20','10:15:00',1.22),('9303','2013-11-20','11:25:00',1.18),('9303','2013-11-20','11:30:00',1.13),('9303','2013-11-20','11:35:00',1.06),('9303','2013-11-20','11:40:00',1.07),('9303','2013-11-20','11:45:00',2.8),('9303','2013-11-20','11:50:00',2.55),('9303','2013-11-20','11:55:00',1.26),('9303','2013-11-20','12:20:00',1.97),('9303','2013-11-20','12:25:00',1.26),('9303','2013-11-20','12:50:00',1.09),('9303','2013-11-20','12:55:00',1.28),('9303','2013-11-20','13:00:00',1.63),('9303','2013-11-20','13:05:00',1.28),('9303','2013-11-20','13:20:00',1.21),('9303','2013-11-20','13:45:00',1.06),('9303','2013-11-20','13:50:00',1.39),('9303','2013-11-20','13:55:00',1.01),('9303','2013-11-19','10:05:00',1.05),('9303','2013-11-19','10:50:00',1.39),('9303','2013-11-19','11:20:00',1.98),('9303','2013-11-19','11:25:00',1.54),('9303','2013-11-19','11:30:00',1.33),('9303','2013-11-19','11:35:00',1.85),('9303','2013-11-19','11:40:00',1.7),('9303','2013-11-19','11:45:00',1.77),('9303','2013-11-19','11:50:00',1.78),('9303','2013-11-19','11:55:00',1.74),('9303','2013-11-19','12:00:00',1.5),('9303','2013-11-19','12:05:00',1.81),('9303','2013-11-19','12:10:00',1.79),('9303','2013-11-19','12:15:00',1.8),('9303','2013-11-19','12:20:00',1.11),('9303','2013-11-19','12:30:00',1.28),('9303','2013-11-19','12:45:00',1.68),('9303','2013-11-19','12:50:00',1.17),('9303','2013-11-19','12:55:00',2.21),('9303','2013-11-19','13:00:00',1.2),('9303','2013-11-19','13:10:00',1.04),('9303','2013-11-19','13:15:00',1.62),('9303','2013-11-19','13:20:00',1.57),('9303','2013-11-18','09:35:00',1.11),('9303','2013-11-18','10:00:00',1.05),('9303','2013-11-18','10:05:00',1.17),('9303','2013-11-18','10:10:00',1.28),('9303','2013-11-18','10:15:00',1.38),('9303','2013-11-18','10:20:00',1.23),('9303','2013-11-18','10:25:00',1.14),('9303','2013-11-18','10:30:00',1.12),('9303','2013-11-18','10:35:00',1.1),('9303','2013-11-18','10:40:00',1.15),('9303','2013-11-18','10:45:00',1.18),('9303','2013-11-18','10:50:00',1.12),('9303','2013-11-18','11:35:00',1.01),('9303','2013-11-18','11:40:00',1.06),('9303','2013-11-18','11:45:00',1.1),('9303','2013-11-18','11:50:00',1.15),('9303','2013-11-18','11:55:00',1.22),('9303','2013-11-18','12:00:00',1.28),('9303','2013-11-18','12:05:00',1.33),('9303','2013-11-18','12:10:00',1.33),('9303','2013-11-18','12:15:00',1.37),('9303','2013-11-18','12:20:00',1.44),('9303','2013-11-18','12:25:00',1.51),('9303','2013-11-18','12:30:00',1.38),('9303','2013-11-18','12:35:00',1.21),('9303','2013-11-18','12:40:00',1.04),('9303','2013-11-18','13:40:00',1.05),('9303','2014-04-19','07:55:00',1.36),('9303','2014-04-19','08:00:00',1.16),('9303','2014-04-19','08:10:00',1.36),('9303','2014-04-19','08:15:00',1.03),('9303','2014-04-19','08:20:00',1.1),('9303','2014-04-19','08:25:00',1.36),('9303','2014-04-19','08:30:00',1.75),('9303','2014-04-19','08:35:00',2.16),('9303','2014-04-19','08:40:00',1.89),('9303','2014-04-19','08:45:00',1.7),('9303','2014-04-19','08:50:00',1.41),('9303','2014-04-19','09:25:00',1.26),('9303','2014-04-19','09:30:00',1.97),('9303','2014-04-19','09:35:00',2.01),('9303','2014-04-19','09:40:00',1.18),('9303','2014-04-19','10:40:00',1.11),('9303','2014-04-19','10:45:00',1.08),('9303','2014-04-19','10:50:00',1.12),('9303','2014-04-19','10:55:00',1.42),('9303','2014-04-19','11:00:00',1.5),('9303','2014-04-19','11:05:00',1.19),('9303','2014-04-19','11:10:00',1.12),('9303','2014-04-19','11:15:00',1.64),('9303','2014-04-19','11:20:00',3.07),('9303','2014-04-19','11:25:00',2.6),('9303','2014-04-19','11:30:00',2.51),('9303','2014-04-19','11:35:00',2.27),('9303','2014-04-19','11:40:00',2.72),('9303','2014-04-19','11:45:00',1.85),('9303','2014-04-19','11:50:00',1.54),('9303','2014-04-19','13:15:00',1.14),('9303','2014-04-19','13:20:00',1.17),('9303','2014-04-19','14:30:00',1.21),('9303','2014-04-19','14:35:00',1.4),('9303','2014-04-19','14:40:00',1.61),('9303','2014-04-19','14:45:00',1.71),('9303','2014-04-19','14:50:00',1.14),('9303','2014-04-19','15:00:00',1.27),('9303','2014-04-19','15:05:00',1.21),('9303','2014-04-19','15:30:00',1.06),('9303','2014-04-19','15:50:00',2.68),('9303','2014-04-19','15:55:00',3.1),('9303','2014-04-19','16:00:00',1.89),('9303','2014-04-19','16:05:00',1.84),('9303','2014-04-19','16:10:00',1.65),('9303','2014-04-19','16:15:00',1.51),('9303','2014-04-19','16:20:00',1.75),('9303','2014-04-19','16:25:00',1.8),('9303','2014-04-19','16:30:00',2.64),('9303','2014-04-19','16:35:00',1.49),('9303','2014-04-19','16:40:00',1.06),('9303','2014-04-19','17:20:00',1.58),('9303','2014-04-19','17:25:00',1.21),('9303','2014-04-19','17:30:00',1.01),('9303','2013-11-17','09:50:00',1.01),('9303','2013-11-17','09:55:00',1.09),('9303','2013-11-17','10:00:00',1.17),('9303','2013-11-17','10:05:00',1.24),('9303','2013-11-17','10:10:00',1.3),('9303','2013-11-17','10:15:00',1.38),('9303','2013-11-17','10:20:00',1.44),('9303','2013-11-17','10:25:00',1.45),('9303','2013-11-17','10:30:00',1.51),('9303','2013-11-17','10:35:00',1.47),('9303','2013-11-17','10:40:00',1.56),('9303','2013-11-17','10:45:00',1.56),('9303','2013-11-17','10:50:00',1.62),('9303','2013-11-17','10:55:00',1.68),('9303','2013-11-17','11:00:00',1.66),('9303','2013-11-17','11:05:00',1.75),('9303','2013-11-17','11:10:00',1.78),('9303','2013-11-17','11:15:00',1.78),('9303','2013-11-17','11:20:00',1.83),('9303','2013-11-17','11:25:00',1.82),('9303','2013-11-17','11:30:00',1.85),('9303','2013-11-17','11:35:00',1.83),('9303','2013-11-17','11:40:00',1.85),('9303','2013-11-17','11:45:00',1.89),('9303','2013-11-17','11:50:00',1.88),('9303','2013-11-17','11:55:00',1.93),('9303','2013-11-17','12:00:00',1.91),('9303','2013-11-17','12:05:00',1.91),('9303','2013-11-17','12:10:00',1.92),('9303','2013-11-17','12:15:00',1.92),('9303','2013-11-17','12:20:00',1.91),('9303','2013-11-17','12:25:00',1.89),('9303','2013-11-17','12:30:00',1.8),('9303','2013-11-17','12:35:00',1.77),('9303','2013-11-17','12:40:00',1.71),('9303','2013-11-17','12:45:00',1.71),('9303','2013-11-17','12:50:00',1.66),('9303','2013-11-17','12:55:00',1.61),('9303','2013-11-17','13:00:00',1.57),('9303','2013-11-17','13:05:00',1.48),('9303','2013-11-17','13:10:00',1.46),('9303','2013-11-17','13:15:00',1.39),('9303','2013-11-17','13:20:00',1.32),('9303','2013-11-17','13:35:00',1.19),('9303','2013-11-15','09:15:00',1.05),('9303','2013-11-15','09:30:00',1.01),('9303','2013-11-15','09:35:00',1.1),('9303','2013-11-15','10:15:00',1.15),('9303','2013-11-15','10:20:00',1.2),('9303','2013-11-15','10:55:00',1.25),('9303','2013-11-15','11:00:00',1.29),('9303','2013-11-15','11:05:00',1.15),('9303','2013-11-15','11:10:00',1.09),('9303','2013-11-15','11:15:00',1.15),('9303','2013-11-15','11:20:00',1.44),('9303','2013-11-15','11:25:00',2.02),('9303','2013-11-15','11:30:00',1.54),('9303','2013-11-15','11:35:00',1.54),('9303','2013-11-15','11:40:00',1.74),('9303','2013-11-15','11:45:00',1.41),('9303','2013-11-15','11:50:00',1.26),('9303','2013-11-15','11:55:00',1.14),('9303','2013-11-15','12:00:00',1.17),('9303','2013-11-15','12:05:00',1.2),('9303','2013-11-15','12:10:00',1.07),('9303','2013-11-15','12:15:00',1.12),('9303','2013-11-15','12:20:00',1.14),('9303','2013-11-15','12:25:00',1.54),('9303','2013-11-15','12:30:00',1.39),('9303','2013-11-15','12:35:00',1.16),('9303','2013-11-15','12:40:00',1.09),('9303','2013-11-15','12:45:00',1.03),('9303','2013-11-15','12:50:00',1.27),('9303','2013-11-15','12:55:00',1.36),('9303','2013-11-15','13:00:00',1.25),('9303','2013-11-15','13:05:00',1.16),('9303','2013-11-15','13:10:00',1.09),('9303','2013-11-15','13:45:00',1.19),('9303','2013-11-15','13:50:00',1.35),('9303','2013-11-14','09:20:00',1.05),('9303','2013-11-14','09:25:00',1.1),('9303','2013-11-14','09:30:00',1.18),('9303','2013-11-14','09:35:00',1.19),('9303','2013-11-14','09:40:00',1.29),('9303','2013-11-14','09:45:00',1.36),('9303','2013-11-14','09:50:00',1.17),('9303','2013-11-14','10:05:00',1.1),('9303','2013-11-14','10:10:00',1.18),('9303','2013-11-14','10:15:00',1.66),('9303','2013-11-14','10:20:00',1.65),('9303','2013-11-14','10:25:00',1.7),('9303','2013-11-14','10:30:00',1.68),('9303','2013-11-14','10:35:00',1.6),('9303','2013-11-14','10:40:00',1.65),('9303','2013-11-14','10:45:00',1.8),('9303','2013-11-14','10:50:00',1.82),('9303','2013-11-14','10:55:00',1.83),('9303','2013-11-14','11:00:00',1.87),('9303','2013-11-14','11:05:00',1.91),('9303','2013-11-14','11:10:00',2.02),('9303','2013-11-14','11:15:00',2.07),('9303','2013-11-14','11:20:00',2),('9303','2013-11-14','11:25:00',2.15),('9303','2013-11-14','11:30:00',2.11),('9303','2013-11-14','11:35:00',2.01),('9303','2013-11-14','11:40:00',1.88),('9303','2013-11-14','11:45:00',1.29),('9303','2013-11-14','11:50:00',1.13),('9303','2013-11-14','11:55:00',1.37),('9303','2013-11-14','12:00:00',1.93),('9303','2013-11-14','12:05:00',1.17),('9303','2013-11-14','12:10:00',1.24),('9303','2013-11-14','12:15:00',1.38),('9303','2013-11-14','12:20:00',1.21),('9303','2013-11-14','12:25:00',1.03),('9303','2013-11-14','12:35:00',1.02),('9303','2013-11-14','12:45:00',1.02),('9303','2013-11-14','12:50:00',1.09),('9303','2013-11-14','12:55:00',1.06),('9303','2013-11-14','13:00:00',1.05),('9303','2013-11-13','10:20:00',1.59),('9303','2013-11-13','10:25:00',1.92),('9303','2013-11-13','10:30:00',2),('9303','2013-11-13','10:35:00',2.55),('9303','2013-11-13','10:40:00',2.41),('9303','2013-11-13','10:45:00',2.11),('9303','2013-11-13','10:50:00',2.67),('9303','2013-11-13','10:55:00',2.53),('9303','2013-11-13','11:00:00',2.24),('9303','2013-11-13','11:50:00',1.14),('9303','2013-11-13','11:55:00',1.02),('9303','2013-11-13','13:00:00',1.03),('9303','2013-11-13','13:05:00',1.3),('9303','2013-11-13','13:10:00',1.14),('9303','2013-11-13','13:15:00',1.15),('9303','2013-11-13','13:55:00',1.13),('9303','2013-11-13','14:00:00',1.23),('9303','2013-11-13','14:05:00',1.14),('9303','2013-11-13','14:10:00',1.09),('9303','2013-11-13','14:15:00',1.11),('9303','2013-11-13','14:20:00',1.01),('9303','2013-11-13','14:25:00',1.09),('9303','2013-11-12','11:25:00',1.16),('9303','2013-11-12','11:35:00',1),('9303','2013-11-12','11:40:00',2.11),('9303','2013-11-12','11:45:00',1.26),('9303','2013-11-12','11:50:00',1.24),('9303','2013-11-12','12:00:00',2.46),('9303','2013-11-12','12:05:00',1.08),('9303','2013-11-12','12:30:00',2.95),('9303','2013-11-12','12:35:00',2.67),('9303','2013-11-12','12:40:00',1.87),('9303','2013-11-12','12:45:00',1.8),('9303','2013-11-12','12:50:00',1.48),('9303','2013-11-12','12:55:00',1.88),('9303','2013-11-12','13:00:00',1.84),('9303','2013-11-12','13:05:00',2.09),('9303','2013-11-12','13:10:00',2.36),('9303','2013-11-12','13:15:00',2.98),('9303','2013-11-12','13:20:00',2.5),('9303','2013-11-12','13:25:00',2.66),('9303','2013-11-12','13:30:00',1.83),('9303','2013-11-12','13:35:00',1.95),('9303','2013-11-12','13:40:00',2.64),('9303','2013-11-12','13:45:00',1.52),('9303','2013-11-12','13:50:00',1.05),('9303','2013-11-12','13:55:00',1.21),('9303','2013-11-12','14:00:00',1.25),('9303','2013-11-12','14:05:00',1.04),('9303','2013-11-12','14:10:00',1.36),('9303','2013-11-12','14:15:00',1.61),('9303','2013-11-12','14:20:00',1.53),('9303','2013-11-12','14:25:00',1.23),('9303','2013-11-12','14:30:00',1),('9303','2013-11-11','09:50:00',1.16),('9303','2013-11-11','09:55:00',1.25),('9303','2013-11-11','10:10:00',1.03),('9303','2013-11-11','10:15:00',1.59),('9303','2013-11-11','10:20:00',2.3),('9303','2013-11-11','10:25:00',1.37),('9303','2013-11-11','11:05:00',1.07),('9303','2013-11-11','11:10:00',2.18),('9303','2013-11-11','11:15:00',1.99),('9303','2013-11-11','11:20:00',1.22),('9303','2013-11-11','11:25:00',2.47),('9303','2013-11-11','11:30:00',1.43),('9303','2013-11-11','11:35:00',2.35),('9303','2013-11-11','11:40:00',3.11),('9303','2013-11-11','11:45:00',2.87),('9303','2013-11-11','11:50:00',3.06),('9303','2013-11-11','11:55:00',2.91),('9303','2013-11-11','12:00:00',2.7),('9303','2013-11-11','12:05:00',2.66),('9303','2013-11-11','12:10:00',2.57),('9303','2013-11-11','12:15:00',2.59),('9303','2013-11-11','12:20:00',2.6),('9303','2013-11-11','12:25:00',2.24),('9303','2013-11-11','12:30:00',2.17),('9303','2013-11-11','12:35:00',1.18),('9303','2013-11-11','12:40:00',1.78),('9303','2013-11-11','12:45:00',1.34),('9303','2013-11-11','13:10:00',2.15),('9303','2013-11-11','13:15:00',1.39),('9303','2013-11-11','13:35:00',1.08),('9303','2013-11-11','13:40:00',1.23),('9303','2013-11-11','14:15:00',1.02),('9303','2013-11-11','14:20:00',1.16),('9303','2013-11-11','14:25:00',1.05),('9303','2013-11-10','08:50:00',1.04),('9303','2013-11-10','08:55:00',1.17),('9303','2013-11-10','09:00:00',1.03),('9303','2013-11-10','09:15:00',1),('9303','2013-11-10','09:20:00',1.24),('9303','2013-11-10','09:25:00',1.42),('9303','2013-11-10','09:30:00',1.23),('9303','2013-11-10','09:35:00',1.21),('9303','2013-11-10','09:40:00',1.3),('9303','2013-11-10','09:45:00',1.48),('9303','2013-11-10','09:50:00',1.55),('9303','2013-11-10','09:55:00',1.6),('9303','2013-11-10','10:00:00',1.69),('9303','2013-11-10','10:05:00',1.82),('9303','2013-11-10','10:10:00',1.94),('9303','2013-11-10','10:15:00',2),('9303','2013-11-10','10:20:00',1.94),('9303','2013-11-10','10:25:00',2.16),('9303','2013-11-10','10:30:00',2.4),('9303','2013-11-10','10:35:00',2.27),('9303','2013-11-10','10:40:00',2.06),('9303','2013-11-10','10:45:00',1.6),('9303','2013-11-10','10:50:00',2.26),('9303','2013-11-10','10:55:00',2.1),('9303','2013-11-10','11:00:00',2.01),('9303','2013-11-10','11:05:00',1.59),('9303','2013-11-10','11:10:00',1.2),('9303','2013-11-10','11:25:00',1.16),('9303','2013-11-10','11:35:00',1.01),('9303','2013-11-10','11:40:00',1.17),('9303','2013-11-10','11:45:00',1.56),('9303','2013-11-10','11:50:00',1.21),('9303','2013-11-10','11:55:00',1.22),('9303','2013-11-10','12:05:00',1.38),('9303','2013-11-10','12:10:00',1.48),('9303','2013-11-10','12:15:00',2.55),('9303','2013-11-10','12:20:00',2.57),('9303','2013-11-10','12:25:00',2.5),('9303','2013-11-10','12:30:00',1.65),('9303','2013-11-10','12:35:00',1.6),('9303','2013-11-10','12:40:00',2.42),('9303','2013-11-10','12:45:00',2.7),('9303','2013-11-10','12:50:00',2.88),('9303','2013-11-10','12:55:00',1.24),('9303','2013-11-10','13:00:00',1.04),('9303','2013-11-10','13:50:00',1.73),('9303','2013-11-10','13:55:00',1.58),('9303','2013-11-09','09:40:00',1.9),('9303','2013-11-09','09:45:00',1.38),('9303','2013-11-09','09:50:00',1.98),('9303','2013-11-09','09:55:00',1.98),('9303','2013-11-09','10:00:00',1.84),('9303','2013-11-09','10:05:00',1.76),('9303','2013-11-09','10:10:00',1.69),('9303','2013-11-09','10:15:00',1.66),('9303','2013-11-09','10:20:00',1.78),('9303','2013-11-09','10:25:00',2.04),('9303','2013-11-09','10:30:00',1.09),('9303','2013-11-09','10:35:00',1.26),('9303','2013-11-09','10:40:00',1.25),('9303','2013-11-09','10:45:00',1.26),('9303','2013-11-09','10:50:00',1.26),('9303','2013-11-09','10:55:00',1.95),('9303','2013-11-09','11:00:00',1.92),('9303','2013-11-09','11:05:00',2.81),('9303','2013-11-09','11:10:00',2.66),('9303','2013-11-09','11:15:00',2.94),('9303','2013-11-09','11:20:00',2.19),('9303','2013-11-09','11:25:00',1.22),('9303','2013-11-09','11:30:00',1.79),('9303','2013-11-09','11:35:00',1.82),('9303','2013-11-09','11:40:00',1.97),('9303','2013-11-09','11:45:00',1.35),('9303','2013-11-09','11:50:00',1.76),('9303','2013-11-09','11:55:00',2.06),('9303','2013-11-09','12:00:00',2.16),('9303','2013-11-09','12:05:00',2.55),('9303','2013-11-09','12:10:00',1.8),('9303','2013-11-09','12:15:00',1.8),('9303','2013-11-09','12:20:00',1.02),('9303','2013-11-09','12:25:00',1.35),('9303','2013-11-09','12:30:00',2.28),('9303','2013-11-09','12:35:00',2.66),('9303','2013-11-09','12:40:00',1.93),('9303','2013-11-09','12:45:00',1.44),('9303','2013-11-09','12:50:00',1.98),('9303','2013-11-09','12:55:00',1.71),('9303','2013-11-09','13:00:00',2.71),('9303','2013-11-09','13:05:00',2.31),('9303','2013-11-09','13:10:00',2.46),('9303','2013-11-09','13:15:00',2.32),('9303','2013-11-09','13:20:00',1.4),('9303','2013-11-09','13:25:00',1.94),('9303','2013-11-09','13:30:00',2.08),('9303','2013-11-09','13:35:00',1.98),('9303','2013-11-09','13:40:00',1.79),('9303','2013-11-09','13:45:00',1.71),('9303','2013-11-09','13:50:00',1.66),('9303','2013-11-09','13:55:00',1.59),('9303','2013-11-09','14:00:00',1.5),('9303','2013-11-09','14:05:00',1.33),('9303','2013-11-09','14:20:00',1.45),('9303','2013-11-09','14:25:00',1.08),('9303','2013-11-08','09:15:00',1.01),('9303','2013-11-08','09:20:00',1.6),('9303','2013-11-08','09:25:00',1.63),('9303','2013-11-08','09:30:00',1.89),('9303','2013-11-08','09:35:00',1.97),('9303','2013-11-08','09:40:00',1.08),('9303','2013-11-08','09:50:00',1.53),('9303','2013-11-08','10:00:00',1.22),('9303','2013-11-08','10:05:00',1.32),('9303','2013-11-08','10:10:00',1.62),('9303','2013-11-08','10:45:00',1.02),('9303','2013-11-08','10:50:00',2.25),('9303','2013-11-08','10:55:00',1.39),('9303','2013-11-08','11:20:00',1.09),('9303','2013-11-08','11:25:00',2.8),('9303','2013-11-08','11:30:00',2.95),('9303','2013-11-08','11:35:00',2.86),('9303','2013-11-08','11:40:00',2.82),('9303','2013-11-08','11:45:00',2.69),('9303','2013-11-08','11:50:00',2.89),('9303','2013-11-08','11:55:00',2.27),('9303','2013-11-08','12:00:00',2.34),('9303','2013-11-08','12:05:00',2.6),('9303','2013-11-08','12:10:00',2.59),('9303','2013-11-08','12:15:00',1.76),('9303','2013-11-08','12:20:00',1.47),('9303','2013-11-08','12:40:00',2.34),('9303','2013-11-08','12:45:00',1.01),('9303','2013-11-08','12:50:00',2.42),('9303','2013-11-08','12:55:00',2.52),('9303','2013-11-08','13:00:00',2.48),('9303','2013-11-08','13:05:00',2.28),('9303','2013-11-08','13:10:00',2.39),('9303','2013-11-08','13:15:00',2.39),('9303','2013-11-08','13:20:00',1.48),('9303','2013-11-08','13:25:00',1.7),('9303','2013-11-08','13:30:00',1.07),('9303','2013-11-08','13:35:00',1.94),('9303','2013-11-08','13:40:00',1.91),('9303','2013-11-08','13:45:00',1.75),('9303','2013-11-08','13:50:00',1.68),('9303','2013-11-08','13:55:00',1.61),('9303','2013-11-08','14:00:00',1.56),('9303','2013-11-08','14:05:00',1.41),('9303','2013-11-08','14:10:00',1.32),('9303','2013-11-08','14:25:00',1.05),('9303','2013-11-08','14:35:00',1.08),('9303','2014-04-18','08:05:00',1.46),('9303','2014-04-18','08:10:00',1.33),('9303','2014-04-18','08:40:00',1.41),('9303','2014-04-18','08:45:00',1.29),('9303','2014-04-18','08:50:00',1.01),('9303','2014-04-18','09:00:00',1.12),('9303','2014-04-18','09:05:00',2.38),('9303','2014-04-18','09:10:00',3.08),('9303','2014-04-18','09:15:00',2.83),('9303','2014-04-18','09:20:00',2.6),('9303','2014-04-18','09:25:00',1.83),('9303','2014-04-18','09:30:00',2.97),('9303','2014-04-18','09:35:00',1.65),('9303','2014-04-18','09:40:00',1.07),('9303','2014-04-18','09:45:00',1.72),('9303','2014-04-18','09:50:00',2.78),('9303','2014-04-18','09:55:00',2.89),('9303','2014-04-18','10:00:00',2.44),('9303','2014-04-18','10:05:00',1.54),('9303','2014-04-18','10:10:00',1.41),('9303','2014-04-18','10:15:00',1.57),('9303','2014-04-18','10:20:00',1.38),('9303','2014-04-18','10:25:00',1.44),('9303','2014-04-18','10:30:00',1.2),('9303','2014-04-18','10:35:00',1.09),('9303','2014-04-18','10:40:00',1.28),('9303','2014-04-18','10:45:00',2.49),('9303','2014-04-18','10:50:00',3),('9303','2014-04-18','10:55:00',2.85),('9303','2014-04-18','11:00:00',1.74),('9303','2014-04-18','11:05:00',1.55),('9303','2014-04-18','11:10:00',2.02),('9303','2014-04-18','11:15:00',2.52),('9303','2014-04-18','11:20:00',1.72),('9303','2014-04-18','11:25:00',1.3),('9303','2014-04-18','11:30:00',1.6),('9303','2014-04-18','11:35:00',1.5),('9303','2014-04-18','11:40:00',1.58),('9303','2014-04-18','11:45:00',1.5),('9303','2014-04-18','11:50:00',1.71),('9303','2014-04-18','11:55:00',1.67),('9303','2014-04-18','12:00:00',1.72),('9303','2014-04-18','12:05:00',2.69),('9303','2014-04-18','12:10:00',3.09),('9303','2014-04-18','12:15:00',3.1),('9303','2014-04-18','12:20:00',3.85),('9303','2014-04-18','12:25:00',2.81),('9303','2014-04-18','12:30:00',4.41),('9303','2014-04-18','12:35:00',4.16),('9303','2014-04-18','12:40:00',4.3),('9303','2014-04-18','12:45:00',3.67),('9303','2014-04-18','12:50:00',3.61),('9303','2014-04-18','12:55:00',2.64),('9303','2014-04-18','13:00:00',4.44),('9303','2014-04-18','13:05:00',2.84),('9303','2014-04-18','13:10:00',2.49),('9303','2014-04-18','13:15:00',2.37),('9303','2014-04-18','13:20:00',2.18),('9303','2014-04-18','13:25:00',1.56),('9303','2014-04-18','13:30:00',1.33),('9303','2014-04-18','13:35:00',1.32),('9303','2014-04-18','13:40:00',1.19),('9303','2014-04-18','13:45:00',1.02),('9303','2014-04-18','13:50:00',1.31),('9303','2014-04-18','13:55:00',2.15),('9303','2014-04-18','14:00:00',1.88),('9303','2014-04-18','14:05:00',1.55),('9303','2014-04-18','14:10:00',1.37),('9303','2014-04-18','14:15:00',1.23),('9303','2014-04-18','14:20:00',1.45),('9303','2014-04-18','14:25:00',1.89),('9303','2014-04-18','14:30:00',2.14),('9303','2014-04-18','14:35:00',2.43),('9303','2014-04-18','14:40:00',2.19),('9303','2014-04-18','14:45:00',2.74),('9303','2014-04-18','14:50:00',3.18),('9303','2014-04-18','14:55:00',2.23),('9303','2014-04-18','15:00:00',4.18),('9303','2014-04-18','15:05:00',2.32),('9303','2014-04-18','15:10:00',1.89),('9303','2014-04-18','15:15:00',2.2),('9303','2014-04-18','15:20:00',1.91),('9303','2014-04-18','15:25:00',2.16),('9303','2014-04-18','15:30:00',3.15),('9303','2014-04-18','15:35:00',3.29),('9303','2014-04-18','15:40:00',2.37),('9303','2014-04-18','15:45:00',2.26),('9303','2014-04-18','15:50:00',2.67),('9303','2014-04-18','15:55:00',2.51),('9303','2014-04-18','16:00:00',2.13),('9303','2014-04-18','16:05:00',1.67),('9303','2014-04-18','16:10:00',1.29),('9303','2014-04-18','16:15:00',1.14),('9303','2014-04-18','16:20:00',1.23),('9303','2014-04-18','16:25:00',1.78),('9303','2014-04-18','16:30:00',1.99),('9303','2014-04-18','16:35:00',2.01),('9303','2014-04-18','16:40:00',2.97),('9303','2014-04-18','16:45:00',2.72),('9303','2014-04-18','16:50:00',2.61),('9303','2014-04-18','16:55:00',1.84),('9303','2014-04-18','17:00:00',2.03),('9303','2014-04-18','17:05:00',2.5),('9303','2014-04-18','17:10:00',2.02),('9303','2014-04-18','17:15:00',1.78),('9303','2014-04-18','17:20:00',1.8),('9303','2014-04-18','17:25:00',1.85),('9303','2014-04-18','17:30:00',1.71),('9303','2014-04-18','17:35:00',1.6),('9303','2014-04-18','17:40:00',1.51),('9303','2014-04-18','17:45:00',1.42),('9303','2014-04-18','17:50:00',1.33),('9303','2014-04-18','17:55:00',1.25),('9303','2014-04-18','18:00:00',1.17),('9303','2014-04-18','18:05:00',1.03),('9303','2013-11-07','09:05:00',1),('9303','2013-11-07','09:10:00',1.1),('9303','2013-11-07','09:15:00',1.15),('9303','2013-11-07','09:20:00',1.27),('9303','2013-11-07','09:25:00',1.33),('9303','2013-11-07','09:30:00',1.41),('9303','2013-11-07','09:35:00',1.38),('9303','2013-11-07','09:40:00',1.47),('9303','2013-11-07','09:45:00',1.6),('9303','2013-11-07','09:50:00',1.59),('9303','2013-11-07','09:55:00',1.66),('9303','2013-11-07','10:00:00',1.75),('9303','2013-11-07','10:05:00',1.78),('9303','2013-11-07','10:10:00',1.86),('9303','2013-11-07','10:15:00',1.88),('9303','2013-11-07','10:20:00',1.98),('9303','2013-11-07','10:25:00',1.95),('9303','2013-11-07','10:30:00',2.06),('9303','2013-11-07','10:35:00',2.06),('9303','2013-11-07','10:40:00',2.12),('9303','2013-11-07','10:45:00',2.16),('9303','2013-11-07','10:50:00',2.2),('9303','2013-11-07','10:55:00',2.16),('9303','2013-11-07','11:00:00',2.23),('9303','2013-11-07','11:05:00',2.27),('9303','2013-11-07','11:10:00',2.27),('9303','2013-11-07','11:15:00',2.32),('9303','2013-11-07','11:20:00',2.32),('9303','2013-11-07','11:25:00',2.31),('9303','2013-11-07','11:30:00',2.27),('9303','2013-11-07','11:35:00',2.29),('9303','2013-11-07','11:40:00',2.33),('9303','2013-11-07','11:45:00',2.38),('9303','2013-11-07','11:50:00',2.36),('9303','2013-11-07','11:55:00',2.38),('9303','2013-11-07','12:00:00',2.41),('9303','2013-11-07','12:05:00',2.4),('9303','2013-11-07','12:10:00',2.42),('9303','2013-11-07','12:15:00',2.4),('9303','2013-11-07','12:20:00',2.4),('9303','2013-11-07','12:25:00',2.3),('9303','2013-11-07','12:30:00',2.22),('9303','2013-11-07','12:35:00',2.23),('9303','2013-11-07','12:40:00',2.16),('9303','2013-11-07','12:45:00',2.13),('9303','2013-11-07','12:50:00',2.09),('9303','2013-11-07','12:55:00',2),('9303','2013-11-07','13:00:00',2.14),('9303','2013-11-07','13:05:00',1.9),('9303','2013-11-07','13:15:00',1.33),('9303','2013-11-07','13:20:00',1.01),('9303','2013-11-07','13:35:00',1.64),('9303','2013-11-07','13:40:00',2.32),('9303','2013-11-07','13:45:00',1.63),('9303','2013-11-07','13:50:00',1.72),('9303','2013-11-07','13:55:00',1.65),('9303','2013-11-07','14:00:00',1.05),('9303','2013-11-07','14:05:00',1.47),('9303','2013-11-07','14:25:00',1.17),('9303','2013-11-06','09:20:00',1.27),('9303','2013-11-06','09:25:00',1.38),('9303','2013-11-06','09:30:00',1.53),('9303','2013-11-06','09:35:00',1.54),('9303','2013-11-06','09:40:00',1.6),('9303','2013-11-06','09:45:00',1.67),('9303','2013-11-06','09:50:00',1.71),('9303','2013-11-06','09:55:00',1.69),('9303','2013-11-06','10:00:00',1.84),('9303','2013-11-06','10:05:00',1.9),('9303','2013-11-06','10:10:00',1.98),('9303','2013-11-06','10:15:00',2.02),('9303','2013-11-06','10:20:00',2.12),('9303','2013-11-06','10:25:00',2.13),('9303','2013-11-06','10:30:00',2.25),('9303','2013-11-06','10:35:00',2.25),('9303','2013-11-06','10:40:00',2.33),('9303','2013-11-06','10:45:00',2.37),('9303','2013-11-06','10:50:00',2.4),('9303','2013-11-06','10:55:00',2.43),('9303','2013-11-06','11:00:00',2.49),('9303','2013-11-06','11:05:00',2.53),('9303','2013-11-06','11:10:00',2.52),('9303','2013-11-06','11:15:00',2.58),('9303','2013-11-06','11:20:00',2.61),('9303','2013-11-06','11:25:00',2.62),('9303','2013-11-06','11:30:00',2.62),('9303','2013-11-06','11:35:00',2.62),('9303','2013-11-06','11:40:00',2.74),('9303','2013-11-06','11:45:00',2.75),('9303','2013-11-06','11:50:00',2.75),('9303','2013-11-06','11:55:00',2.77),('9303','2013-11-06','12:00:00',2.78),('9303','2013-11-06','12:05:00',2.78),('9303','2013-11-06','12:10:00',2.77),('9303','2013-11-06','12:15:00',2.75),('9303','2013-11-06','12:20:00',2.68),('9303','2013-11-06','12:25:00',2.63),('9303','2013-11-06','12:30:00',2.57),('9303','2013-11-06','12:35:00',2.48),('9303','2013-11-06','12:40:00',2.45),('9303','2013-11-06','12:45:00',2.37),('9303','2013-11-06','12:50:00',2.37),('9303','2013-11-06','12:55:00',2.33),('9303','2013-11-06','13:00:00',2.3),('9303','2013-11-06','13:05:00',2.25),('9303','2013-11-06','13:10:00',2.16),('9303','2013-11-06','13:15:00',2.14),('9303','2013-11-06','13:20:00',2.07),('9303','2013-11-06','13:25:00',2.05),('9303','2013-11-06','13:30:00',1.97),('9303','2013-11-06','13:35:00',1.78),('9303','2013-11-06','13:40:00',1.79),('9303','2013-11-06','13:45:00',1.75),('9303','2013-11-06','13:50:00',1.72),('9303','2013-11-06','13:55:00',1.63),('9303','2013-11-06','14:00:00',1.6),('9303','2013-11-06','14:10:00',1.26),('9303','2013-11-06','14:15:00',1.3),('9303','2013-11-06','14:20:00',1.25),('9303','2013-11-06','14:25:00',1.18),('9303','2013-11-06','14:30:00',1.06),('9303','2013-11-05','08:35:00',1.05),('9303','2013-11-05','08:40:00',1.12),('9303','2013-11-05','10:20:00',1.21),('9303','2013-11-05','10:25:00',1.85),('9303','2013-11-05','10:30:00',1.56),('9303','2013-11-05','10:35:00',2.06),('9303','2013-11-05','10:40:00',1.64),('9303','2013-11-05','10:45:00',1.71),('9303','2013-11-05','10:50:00',1.53),('9303','2013-11-05','10:55:00',1.28),('9303','2013-11-05','11:00:00',1),('9303','2013-11-05','11:40:00',1.3),('9303','2013-11-05','11:45:00',1.35),('9303','2013-11-05','11:50:00',1.26),('9303','2013-11-05','11:55:00',1.08),('9303','2013-11-05','12:10:00',1.17),('9303','2013-11-05','12:15:00',1.3),('9303','2013-11-05','12:20:00',1.71),('9303','2013-11-05','12:25:00',1.72),('9303','2013-11-05','12:30:00',1.13),('9303','2013-11-05','13:35:00',1.89),('9303','2013-11-05','13:40:00',2.08),('9303','2013-11-05','13:45:00',2),('9303','2013-11-05','13:50:00',1.25),('9303','2013-11-05','13:55:00',1.22),('9303','2013-11-05','14:00:00',1.88),('9303','2013-11-05','14:05:00',2.12),('9303','2013-11-05','14:10:00',2.19),('9303','2013-11-05','14:15:00',1.33),('9303','2013-11-05','14:30:00',1.06),('9303','2013-11-05','14:35:00',1.12),('9303','2013-11-04','09:10:00',1.37),('9303','2013-11-04','09:15:00',1.69),('9303','2013-11-04','09:20:00',1.65),('9303','2013-11-04','09:25:00',2.22),('9303','2013-11-04','09:30:00',1.33),('9303','2013-11-04','10:05:00',2.08),('9303','2013-11-04','10:10:00',2.12),('9303','2013-11-04','10:15:00',2.24),('9303','2013-11-04','10:20:00',2.32),('9303','2013-11-04','10:25:00',2.52),('9303','2013-11-04','10:30:00',2.82),('9303','2013-11-04','10:35:00',2.27),('9303','2013-11-04','10:40:00',2.7),('9303','2013-11-04','10:45:00',2.17),('9303','2013-11-04','10:50:00',1.61),('9303','2013-11-04','10:55:00',1.62),('9303','2013-11-04','11:00:00',2.04),('9303','2013-11-04','11:05:00',3.31),('9303','2013-11-04','11:10:00',1.09),('9303','2013-11-04','11:15:00',2.29),('9303','2013-11-04','11:20:00',1.12),('9303','2013-11-04','11:30:00',2.03),('9303','2013-11-04','11:35:00',2.55),('9303','2013-11-04','11:40:00',1.83),('9303','2013-11-04','11:45:00',2.43),('9303','2013-11-04','11:50:00',3.65),('9303','2013-11-04','11:55:00',3.2),('9303','2013-11-04','12:00:00',2.96),('9303','2013-11-04','12:05:00',2.99),('9303','2013-11-04','12:10:00',2.98),('9303','2013-11-04','12:15:00',2.47),('9303','2013-11-04','12:20:00',2.58),('9303','2013-11-04','12:25:00',2.75),('9303','2013-11-04','12:30:00',2.73),('9303','2013-11-04','12:35:00',2.65),('9303','2013-11-04','12:40:00',2.62),('9303','2013-11-04','12:45:00',2.55),('9303','2013-11-04','12:50:00',2.49),('9303','2013-11-04','12:55:00',2.43),('9303','2013-11-04','13:00:00',2.4),('9303','2013-11-04','13:05:00',2.34),('9303','2013-11-04','13:10:00',2.32),('9303','2013-11-04','13:15:00',2.3),('9303','2013-11-04','13:20:00',1.87),('9303','2013-11-04','13:25:00',2.24),('9303','2013-11-04','13:30:00',2.14),('9303','2013-11-04','13:35:00',2.16),('9303','2013-11-04','13:40:00',1.82),('9303','2013-11-04','13:45:00',2.1),('9303','2013-11-04','13:50:00',1.98),('9303','2013-11-04','13:55:00',1.7),('9303','2013-11-04','14:00:00',1.42),('9303','2013-11-04','14:05:00',1.45),('9303','2013-11-04','14:10:00',1.75),('9303','2013-11-04','14:15:00',1.87),('9303','2013-11-04','14:20:00',1.74),('9303','2013-11-04','14:35:00',1.49),('9303','2013-11-04','14:40:00',1.24),('9303','2013-11-03','08:55:00',1.11),('9303','2013-11-03','09:40:00',1.97),('9303','2013-11-03','09:45:00',1.46),('9303','2013-11-03','10:10:00',1.57),('9303','2013-11-03','10:20:00',2.15),('9303','2013-11-03','10:25:00',2.17),('9303','2013-11-03','10:30:00',2.42),('9303','2013-11-03','10:35:00',1.88),('9303','2013-11-03','11:20:00',1.49),('9303','2013-11-03','11:25:00',1.74),('9303','2013-11-03','11:30:00',1.6),('9303','2013-11-03','11:35:00',2.62),('9303','2013-11-03','11:40:00',3.04),('9303','2013-11-03','11:45:00',3.19),('9303','2013-11-03','11:50:00',3.28),('9303','2013-11-03','11:55:00',2.57),('9303','2013-11-03','12:00:00',2.14),('9303','2013-11-03','12:05:00',2.46),('9303','2013-11-03','12:10:00',2.31),('9303','2013-11-03','12:15:00',1.16),('9303','2013-11-03','12:20:00',1.19),('9303','2013-11-03','12:25:00',1.54),('9303','2013-11-03','12:30:00',1.36),('9303','2013-11-03','12:40:00',1.3),('9303','2013-11-03','12:45:00',1.07),('9303','2013-11-03','13:40:00',1.25),('9303','2013-11-03','13:45:00',1.72),('9303','2013-11-03','13:50:00',1.03),('9303','2013-11-03','13:55:00',1.01),('9303','2013-11-03','14:00:00',1.06),('9303','2013-11-03','14:05:00',1.93),('9303','2013-11-03','14:10:00',1.69),('9303','2013-11-03','14:15:00',1.96),('9303','2013-11-03','14:20:00',1.54),('9303','2013-11-03','14:25:00',1.64),('9303','2013-11-03','14:30:00',1.03),('9303','2013-11-03','14:35:00',1.13),('9303','2013-11-03','14:40:00',1.42),('9303','2013-11-03','14:45:00',1.16),('9303','2013-11-02','08:50:00',1.07),('9303','2013-11-02','08:55:00',1.16),('9303','2013-11-02','09:00:00',1.27),('9303','2013-11-02','09:05:00',1.43),('9303','2013-11-02','09:10:00',1.56),('9303','2013-11-02','09:20:00',1.42),('9303','2013-11-02','09:25:00',1.72),('9303','2013-11-02','09:30:00',1.7),('9303','2013-11-02','09:35:00',1.68),('9303','2013-11-02','09:40:00',1.76),('9303','2013-11-02','09:45:00',1.45),('9303','2013-11-02','09:50:00',2.07),('9303','2013-11-02','09:55:00',2.06),('9303','2013-11-02','10:00:00',2.36),('9303','2013-11-02','10:05:00',2.4),('9303','2013-11-02','10:10:00',1.09),('9303','2013-11-02','10:15:00',1.03),('9303','2013-11-02','11:00:00',1.04),('9303','2013-11-02','11:05:00',1.25),('9303','2013-11-02','11:10:00',1.13),('9303','2013-11-02','11:55:00',1.53),('9303','2013-11-02','12:00:00',3.34),('9303','2013-11-02','12:05:00',3.33),('9303','2013-11-02','12:10:00',2.99),('9303','2013-11-02','12:15:00',3.17),('9303','2013-11-02','12:20:00',3.37),('9303','2013-11-02','12:25:00',3.24),('9303','2013-11-02','12:30:00',3.37),('9303','2013-11-02','12:35:00',3.18),('9303','2013-11-02','12:40:00',2.61),('9303','2013-11-02','12:45:00',2.06),('9303','2013-11-02','12:50:00',2.47),('9303','2013-11-02','12:55:00',2.81),('9303','2013-11-02','13:00:00',2.18),('9303','2013-11-02','13:05:00',2.58),('9303','2013-11-02','13:10:00',3.01),('9303','2013-11-02','13:15:00',1.69),('9303','2013-11-02','13:30:00',1.01),('9303','2013-11-02','13:35:00',1.66),('9303','2013-11-02','13:40:00',2.57),('9303','2013-11-02','13:45:00',2.25),('9303','2013-11-02','13:50:00',2.76),('9303','2013-11-02','13:55:00',2.57),('9303','2013-11-02','14:00:00',2.35),('9303','2013-11-02','14:05:00',2),('9303','2013-11-02','14:10:00',1.78),('9303','2013-11-02','14:15:00',1.67),('9303','2013-11-02','14:20:00',1.58),('9303','2013-11-02','14:25:00',1.48),('9303','2013-11-02','14:30:00',1.4),('9303','2013-11-02','14:35:00',1.28),('9303','2013-11-02','14:40:00',1.18),('9303','2013-11-02','14:45:00',1.06),('9303','2013-11-01','08:45:00',1.01),('9303','2013-11-01','08:50:00',1.02),('9303','2013-11-01','08:55:00',1.13),('9303','2013-11-01','09:00:00',1.23),('9303','2013-11-01','09:05:00',1.39),('9303','2013-11-01','09:10:00',1.49),('9303','2013-11-01','09:15:00',1.55),('9303','2013-11-01','09:20:00',1.63),('9303','2013-11-01','09:25:00',1.7),('9303','2013-11-01','09:30:00',1.77),('9303','2013-11-01','09:35:00',1.79),('9303','2013-11-01','09:40:00',1.85),('9303','2013-11-01','09:45:00',1.86),('9303','2013-11-01','09:50:00',1.99),('9303','2013-11-01','09:55:00',2.04),('9303','2013-11-01','10:00:00',2.17),('9303','2013-11-01','10:05:00',2.24),('9303','2013-11-01','10:10:00',2.29),('9303','2013-11-01','10:15:00',2.3),('9303','2013-11-01','10:20:00',2.4),('9303','2013-11-01','10:25:00',2.4),('9303','2013-11-01','10:30:00',2.4),('9303','2013-11-01','10:35:00',2.43),('9303','2013-11-01','10:40:00',2.48),('9303','2013-11-01','10:45:00',2.44),('9303','2013-11-01','10:50:00',2.47),('9303','2013-11-01','10:55:00',2.44),('9303','2013-11-01','11:00:00',2.53),('9303','2013-11-01','11:05:00',2.39),('9303','2013-11-01','11:10:00',2.12),('9303','2013-11-01','11:15:00',2.1),('9303','2013-11-01','11:20:00',2.59),('9303','2013-11-01','11:25:00',2.77),('9303','2013-11-01','11:30:00',2.77),('9303','2013-11-01','11:35:00',2.64),('9303','2013-11-01','11:40:00',2.46),('9303','2013-11-01','11:45:00',2.45),('9303','2013-11-01','11:50:00',2.81),('9303','2013-11-01','11:55:00',2.89),('9303','2013-11-01','12:00:00',2.93),('9303','2013-11-01','12:05:00',2.8),('9303','2013-11-01','12:10:00',2.61),('9303','2013-11-01','12:15:00',2.54),('9303','2013-11-01','12:20:00',2.09),('9303','2013-11-01','12:25:00',2.42),('9303','2013-11-01','12:30:00',2.41),('9303','2013-11-01','12:35:00',2.07),('9303','2013-11-01','13:20:00',1.14),('9303','2013-11-01','13:30:00',1.07),('9303','2013-11-01','13:35:00',1.11),('9303','2013-11-01','13:40:00',1.13),('9303','2013-11-01','13:45:00',1.06),('9303','2013-10-31','08:40:00',1.22),('9303','2013-10-31','08:45:00',1.24),('9303','2013-10-31','08:50:00',1.33),('9303','2013-10-31','08:55:00',1.06),('9303','2013-10-31','09:00:00',1.18),('9303','2013-10-31','09:05:00',1.24),('9303','2013-10-31','09:15:00',1.1),('9303','2013-10-31','09:20:00',1.12),('9303','2013-10-31','09:35:00',1.5),('9303','2013-10-31','09:40:00',1.39),('9303','2013-10-31','09:45:00',1.55),('9303','2013-10-31','09:50:00',1.61),('9303','2013-10-31','09:55:00',1.59),('9303','2013-10-31','10:00:00',1.63),('9303','2013-10-31','10:05:00',1.63),('9303','2013-10-31','10:10:00',1.39),('9303','2013-10-31','10:15:00',1.29),('9303','2013-10-31','10:20:00',1.33),('9303','2013-10-31','10:25:00',1.5),('9303','2013-10-31','10:30:00',1.5),('9303','2013-10-31','10:35:00',1.57),('9303','2013-10-31','10:40:00',1.75),('9303','2013-10-31','10:45:00',1.58),('9303','2013-10-31','10:50:00',1.61),('9303','2013-10-31','10:55:00',1.78),('9303','2013-10-31','11:00:00',2.21),('9303','2013-10-31','11:05:00',2.5),('9303','2013-10-31','11:10:00',2.48),('9303','2013-10-31','11:15:00',1.85),('9303','2013-10-31','11:20:00',2.44),('9303','2013-10-31','11:25:00',2.25),('9303','2013-10-31','11:30:00',2.3),('9303','2013-10-31','11:35:00',2.29),('9303','2013-10-31','11:40:00',2.49),('9303','2013-10-31','11:45:00',2.66),('9303','2013-10-31','11:50:00',2.65),('9303','2013-10-31','11:55:00',2.67),('9303','2013-10-31','12:00:00',2.64),('9303','2013-10-31','12:05:00',2.55),('9303','2013-10-31','12:10:00',2.63),('9303','2013-10-31','12:15:00',2.69),('9303','2013-10-31','12:20:00',2.54),('9303','2013-10-31','12:25:00',2.51),('9303','2013-10-31','12:30:00',2.44),('9303','2013-10-31','12:35:00',2.31),('9303','2013-10-31','12:40:00',2.44),('9303','2013-10-31','12:45:00',2.43),('9303','2013-10-31','12:50:00',2.51),('9303','2013-10-31','12:55:00',2.55),('9303','2013-10-31','13:00:00',2.48),('9303','2013-10-31','13:05:00',2.41),('9303','2013-10-31','13:10:00',2.34),('9303','2013-10-31','13:15:00',2.28),('9303','2013-10-31','13:20:00',2.26),('9303','2013-10-31','13:25:00',2.19),('9303','2013-10-31','13:30:00',2.13),('9303','2013-10-31','13:35:00',2.03),('9303','2013-10-31','13:40:00',1.83),('9303','2013-10-31','13:45:00',1.83),('9303','2013-10-31','13:50:00',1.48),('9303','2013-10-31','13:55:00',1.25),('9303','2013-10-31','14:00:00',1.79),('9303','2013-10-31','14:05:00',1.77),('9303','2013-10-31','14:10:00',1.68),('9303','2013-10-31','14:15:00',1.51),('9303','2013-10-31','14:20:00',1.34),('9303','2013-10-31','14:25:00',1.47),('9303','2013-10-31','14:30:00',1.12),('9303','2013-10-30','08:40:00',1.06),('9303','2013-10-30','08:45:00',1.16),('9303','2013-10-30','08:50:00',1.22),('9303','2013-10-30','08:55:00',1.23),('9303','2013-10-30','09:00:00',1.32),('9303','2013-10-30','09:05:00',1.42),('9303','2013-10-30','09:10:00',1.54),('9303','2013-10-30','09:15:00',1.61),('9303','2013-10-30','09:20:00',1.64),('9303','2013-10-30','09:25:00',1.68),('9303','2013-10-30','09:30:00',1.76),('9303','2013-10-30','09:35:00',1.84),('9303','2013-10-30','09:40:00',1.89),('9303','2013-10-30','09:45:00',1.88),('9303','2013-10-30','09:50:00',1.99),('9303','2013-10-30','09:55:00',1.88),('9303','2013-10-30','10:00:00',1.77),('9303','2013-10-30','10:05:00',1.85),('9303','2013-10-30','10:10:00',2.06),('9303','2013-10-30','10:15:00',2.22),('9303','2013-10-30','10:20:00',2.22),('9303','2013-10-30','10:25:00',2.05),('9303','2013-10-30','10:30:00',2.15),('9303','2013-10-30','10:35:00',2.18),('9303','2013-10-30','10:40:00',2.19),('9303','2013-10-30','10:45:00',1.98),('9303','2013-10-30','10:50:00',1.79),('9303','2013-10-30','10:55:00',1.07),('9303','2013-10-30','11:00:00',2.33),('9303','2013-10-30','11:05:00',2.03),('9303','2013-10-30','11:10:00',2.61),('9303','2013-10-30','11:15:00',2.61),('9303','2013-10-30','11:20:00',2.12),('9303','2013-10-30','11:30:00',1.09),('9303','2013-10-30','11:50:00',2.29),('9303','2013-10-30','11:55:00',1.42),('9303','2013-10-30','12:10:00',1.03),('9303','2013-10-30','12:15:00',1.3),('9303','2013-10-30','12:20:00',1.16),('9303','2013-10-30','12:25:00',2.35),('9303','2013-10-30','12:30:00',1.86),('9303','2013-10-30','12:35:00',1.2),('9303','2013-10-30','12:40:00',1.3),('9303','2013-10-30','12:45:00',1.77),('9303','2013-10-30','12:50:00',1.65),('9303','2013-10-30','12:55:00',2.37),('9303','2013-10-30','13:00:00',1.72),('9303','2013-10-30','13:15:00',1.23),('9303','2013-10-30','13:20:00',1.15),('9303','2013-10-30','13:25:00',1.37),('9303','2013-10-30','13:30:00',1.76),('9303','2013-10-30','13:40:00',1.32),('9303','2013-10-30','13:45:00',1.98),('9303','2013-10-30','13:50:00',1.32),('9303','2013-10-30','14:00:00',1.51),('9303','2013-10-30','14:05:00',1.94),('9303','2013-10-30','14:10:00',2.08),('9303','2013-10-30','14:15:00',1.35),('9303','2013-10-30','14:40:00',1.39),('9303','2013-10-30','14:45:00',1.23),('9303','2013-10-30','14:50:00',1.13),('9303','2013-10-29','08:50:00',1.33),('9303','2013-10-29','08:55:00',1.42),('9303','2013-10-29','09:00:00',1.49),('9303','2013-10-29','09:05:00',1.6),('9303','2013-10-29','09:10:00',1.56),('9303','2013-10-29','09:15:00',1.72),('9303','2013-10-29','09:20:00',1.77),('9303','2013-10-29','09:25:00',1.87),('9303','2013-10-29','09:30:00',1.92),('9303','2013-10-29','09:35:00',1.92),('9303','2013-10-29','09:40:00',1.99),('9303','2013-10-29','09:45:00',1.96),('9303','2013-10-29','09:50:00',1.98),('9303','2013-10-29','09:55:00',1.97),('9303','2013-10-29','10:00:00',2.09),('9303','2013-10-29','10:10:00',2.22),('9303','2013-10-29','10:15:00',2.13),('9303','2013-10-29','10:20:00',2.24),('9303','2013-10-29','10:25:00',2.61),('9303','2013-10-29','10:30:00',2.72),('9303','2013-10-29','10:35:00',2.67),('9303','2013-10-29','10:40:00',2.75),('9303','2013-10-29','10:45:00',2.8),('9303','2013-10-29','10:50:00',2.79),('9303','2013-10-29','10:55:00',2.13),('9303','2013-10-29','11:00:00',2.39),('9303','2013-10-29','11:05:00',1.63),('9303','2013-10-29','11:10:00',1.75),('9303','2013-10-29','11:15:00',1.93),('9303','2013-10-29','11:20:00',1.47),('9303','2013-10-29','11:25:00',2.47),('9303','2013-10-29','11:30:00',2.8),('9303','2013-10-29','11:35:00',2.8),('9303','2013-10-29','11:40:00',2.85),('9303','2013-10-29','11:45:00',2.77),('9303','2013-10-29','11:50:00',2.79),('9303','2013-10-29','11:55:00',2.77),('9303','2013-10-29','12:00:00',2.7),('9303','2013-10-29','12:05:00',2.77),('9303','2013-10-29','12:10:00',2.75),('9303','2013-10-29','12:15:00',2.75),('9303','2013-10-29','12:20:00',2.65),('9303','2013-10-29','12:25:00',2.61),('9303','2013-10-29','12:30:00',2.59),('9303','2013-10-29','12:35:00',2.48),('9303','2013-10-29','12:40:00',2.59),('9303','2013-10-29','12:45:00',2.59),('9303','2013-10-29','12:50:00',2.48),('9303','2013-10-29','12:55:00',2.47),('9303','2013-10-29','13:00:00',2.34),('9303','2013-10-29','13:05:00',2.24),('9303','2013-10-29','13:10:00',2.33),('9303','2013-10-29','13:15:00',2.28),('9303','2013-10-29','13:20:00',2.21),('9303','2013-10-29','13:25:00',2.14),('9303','2013-10-29','13:30:00',2.14),('9303','2013-10-29','13:35:00',2.14),('9303','2013-10-29','13:40:00',2.01),('9303','2013-10-29','13:45:00',1.91),('9303','2013-10-29','13:50:00',1.45),('9303','2013-10-29','13:55:00',1.76),('9303','2013-10-29','14:00:00',1.65),('9303','2013-10-29','14:05:00',1.83),('9303','2013-10-29','14:10:00',1.84),('9303','2013-10-29','14:15:00',1.77),('9303','2013-10-29','14:20:00',1.71),('9303','2013-10-29','14:25:00',1.6),('9303','2013-10-29','14:30:00',1.48),('9303','2013-10-29','14:35:00',1.43),('9303','2013-10-29','14:40:00',1.34),('9303','2013-10-29','14:45:00',1.27),('9303','2013-10-29','14:50:00',1.18),('9303','2013-10-29','14:55:00',1.08),('9303','2014-04-17','08:05:00',1.11),('9303','2014-04-17','08:10:00',1.22),('9303','2014-04-17','08:15:00',1.33),('9303','2014-04-17','08:20:00',1.37),('9303','2014-04-17','08:25:00',1.52),('9303','2014-04-17','08:30:00',1.63),('9303','2014-04-17','08:35:00',1.7),('9303','2014-04-17','08:40:00',1.81),('9303','2014-04-17','08:45:00',1.92),('9303','2014-04-17','08:50:00',2.04),('9303','2014-04-17','08:55:00',1.79),('9303','2014-04-17','09:00:00',1.82),('9303','2014-04-17','09:05:00',2.13),('9303','2014-04-17','09:10:00',2.33),('9303','2014-04-17','09:15:00',2.37),('9303','2014-04-17','09:20:00',2.56),('9303','2014-04-17','09:25:00',2.65),('9303','2014-04-17','09:30:00',2.73),('9303','2014-04-17','09:35:00',2.81),('9303','2014-04-17','09:40:00',2.9),('9303','2014-04-17','09:45:00',2.97),('9303','2014-04-17','09:50:00',3.04),('9303','2014-04-17','09:55:00',3.14),('9303','2014-04-17','10:00:00',3.28),('9303','2014-04-17','10:05:00',3.54),('9303','2014-04-17','10:10:00',3.34),('9303','2014-04-17','10:15:00',2.92),('9303','2014-04-17','10:20:00',3.5),('9303','2014-04-17','10:25:00',3.84),('9303','2014-04-17','10:30:00',4.04),('9303','2014-04-17','10:35:00',4.23),('9303','2014-04-17','10:40:00',3.88),('9303','2014-04-17','10:45:00',3.18),('9303','2014-04-17','10:50:00',2.47),('9303','2014-04-17','10:55:00',2.44),('9303','2014-04-17','11:00:00',2.45),('9303','2014-04-17','11:05:00',3.34),('9303','2014-04-17','11:10:00',3.05),('9303','2014-04-17','11:15:00',2.81),('9303','2014-04-17','11:20:00',3.31),('9303','2014-04-17','11:25:00',3.41),('9303','2014-04-17','11:30:00',2.32),('9303','2014-04-17','11:35:00',2.58),('9303','2014-04-17','11:40:00',2.63),('9303','2014-04-17','11:45:00',3.56),('9303','2014-04-17','11:50:00',2.51),('9303','2014-04-17','11:55:00',1.92),('9303','2014-04-17','12:00:00',2.33),('9303','2014-04-17','12:05:00',2.8),('9303','2014-04-17','12:10:00',2.63),('9303','2014-04-17','12:15:00',2.3),('9303','2014-04-17','12:20:00',2.19),('9303','2014-04-17','12:25:00',2.47),('9303','2014-04-17','12:30:00',3.06),('9303','2014-04-17','12:35:00',3.79),('9303','2014-04-17','12:40:00',4.26),('9303','2014-04-17','12:45:00',4.2),('9303','2014-04-17','12:50:00',4.37),('9303','2014-04-17','12:55:00',4.43),('9303','2014-04-17','13:00:00',3.69),('9303','2014-04-17','13:05:00',1.11),('9303','2014-04-17','13:10:00',1.62),('9303','2014-04-17','13:20:00',2.72),('9303','2014-04-17','13:25:00',4.98),('9303','2014-04-17','13:30:00',3.8),('9303','2014-04-17','13:50:00',1.05),('9303','2014-04-17','13:55:00',1.12),('9303','2014-04-17','14:00:00',1.02),('9303','2014-04-17','14:05:00',1.09),('9303','2014-04-17','14:10:00',2.9),('9303','2014-04-17','14:15:00',1.34),('9303','2014-04-17','14:20:00',1.4),('9303','2014-04-17','14:25:00',2.12),('9303','2014-04-17','14:30:00',1.48),('9303','2014-04-17','14:35:00',1.79),('9303','2014-04-17','14:40:00',3.43),('9303','2014-04-17','14:45:00',1.16),('9303','2014-04-17','15:25:00',1.08),('9303','2014-04-17','15:30:00',1.71),('9303','2014-04-17','15:35:00',2.1),('9303','2014-04-17','15:40:00',1.55),('9303','2014-04-17','15:45:00',1.15),('9303','2014-04-17','15:50:00',1.11),('9303','2014-04-17','15:55:00',1.29),('9303','2014-04-17','16:00:00',1.07),('9303','2014-04-17','16:15:00',1),('9303','2014-04-17','16:25:00',1.1),('9303','2014-04-17','16:30:00',1.13),('9303','2014-04-17','16:35:00',1.03),('9303','2014-04-17','16:40:00',1.18),('9303','2014-04-17','16:45:00',1.41),('9303','2014-04-17','16:50:00',1.38),('9303','2014-04-17','16:55:00',1.09),('9303','2013-10-28','08:50:00',1.05),('9303','2013-10-28','08:55:00',1.47),('9303','2013-10-28','09:00:00',1.63),('9303','2013-10-28','09:05:00',1.88),('9303','2013-10-28','09:10:00',1.95),('9303','2013-10-28','09:15:00',1.45),('9303','2013-10-28','09:20:00',1.14),('9303','2013-10-28','09:25:00',2.09),('9303','2013-10-28','09:30:00',2.18),('9303','2013-10-28','09:35:00',1.39),('9303','2013-10-28','09:40:00',1.22),('9303','2013-10-28','09:45:00',1.77),('9303','2013-10-28','09:50:00',2.15),('9303','2013-10-28','09:55:00',1.11),('9303','2013-10-28','10:50:00',2.67),('9303','2013-10-28','10:55:00',2.7),('9303','2013-10-28','11:00:00',2.73),('9303','2013-10-28','11:05:00',2.72),('9303','2013-10-28','11:10:00',2.73),('9303','2013-10-28','11:15:00',2.75),('9303','2013-10-28','11:20:00',2.78),('9303','2013-10-28','11:25:00',2.75),('9303','2013-10-28','11:30:00',2.77),('9303','2013-10-28','11:35:00',2.78),('9303','2013-10-28','11:40:00',2.77),('9303','2013-10-28','11:45:00',2.79),('9303','2013-10-28','11:50:00',2.81),('9303','2013-10-28','11:55:00',2.69),('9303','2013-10-28','12:00:00',2.45),('9303','2013-10-28','12:05:00',2.68),('9303','2013-10-28','12:10:00',2.04),('9303','2013-10-28','12:15:00',3),('9303','2013-10-28','12:20:00',3.01),('9303','2013-10-28','12:25:00',2.96),('9303','2013-10-28','12:30:00',2.82),('9303','2013-10-28','12:35:00',3.13),('9303','2013-10-28','12:40:00',2.99),('9303','2013-10-28','12:45:00',2.94),('9303','2013-10-28','12:50:00',2.98),('9303','2013-10-28','12:55:00',2.78),('9303','2013-10-28','13:00:00',2.65),('9303','2013-10-28','13:05:00',2.57),('9303','2013-10-28','13:10:00',2.56),('9303','2013-10-28','13:15:00',2.47),('9303','2013-10-28','13:20:00',2.35),('9303','2013-10-28','13:25:00',2.4),('9303','2013-10-28','13:30:00',2.34),('9303','2013-10-28','13:35:00',2.31),('9303','2013-10-28','13:40:00',2.18),('9303','2013-10-28','13:45:00',1.7),('9303','2013-10-28','13:50:00',2.16),('9303','2013-10-28','13:55:00',2.16),('9303','2013-10-28','14:00:00',2.17),('9303','2013-10-28','14:05:00',1.66),('9303','2013-10-28','14:10:00',2.11),('9303','2013-10-28','14:15:00',2.04),('9303','2013-10-28','14:20:00',1.98),('9303','2013-10-28','14:25:00',2.06),('9303','2013-10-28','14:30:00',1.78),('9303','2013-10-28','14:35:00',1.69),('9303','2013-10-28','14:40:00',1.25),('9303','2013-10-28','14:45:00',1.56),('9303','2013-10-28','14:50:00',1.39),('9303','2013-10-28','14:55:00',1.23),('9303','2013-10-28','15:00:00',1.09),('9303','2013-10-28','15:05:00',1.01),('9303','2013-10-27','10:10:00',1.01),('9303','2013-10-27','10:15:00',1.06),('9303','2013-10-27','10:20:00',1.16),('9303','2013-10-27','10:25:00',1.14),('9303','2013-10-27','10:30:00',1.13),('9303','2013-10-27','10:35:00',1.14),('9303','2013-10-27','10:40:00',1.14),('9303','2013-10-27','10:45:00',1.25),('9303','2013-10-27','10:50:00',1.36),('9303','2013-10-27','10:55:00',1.17),('9303','2013-10-27','11:00:00',1.15),('9303','2013-10-27','11:35:00',1.22),('9303','2013-10-27','11:40:00',2.24),('9303','2013-10-27','11:45:00',2.77),('9303','2013-10-27','11:50:00',1.59),('9303','2013-10-27','11:55:00',1.1),('9303','2013-10-27','12:00:00',1.09),('9303','2013-10-27','12:05:00',1.18),('9303','2013-10-27','12:10:00',1.09),('9303','2013-10-27','12:15:00',1.18),('9303','2013-10-27','12:20:00',2.28),('9303','2013-10-27','12:25:00',2.5),('9303','2013-10-27','12:30:00',2.11),('9303','2013-10-27','12:35:00',2.72),('9303','2013-10-27','12:40:00',1.72),('9303','2013-10-27','12:45:00',1.49),('9303','2013-10-27','12:50:00',1.54),('9303','2013-10-27','12:55:00',1.53),('9303','2013-10-27','13:00:00',1.55),('9303','2013-10-27','13:05:00',1),('9303','2013-10-27','13:10:00',2.06),('9303','2013-10-27','13:15:00',1.13),('9303','2013-10-27','13:20:00',1.02),('9303','2013-10-27','13:25:00',1.87),('9303','2013-10-27','13:30:00',2.37),('9303','2013-10-27','13:35:00',1.85),('9303','2013-10-27','13:40:00',1.75),('9303','2013-10-27','14:00:00',1.01),('9303','2013-10-27','14:05:00',1.04),('9303','2013-10-27','14:20:00',1.01),('9303','2013-10-27','14:30:00',1.55),('9303','2013-10-27','14:35:00',1.56),('9303','2013-10-27','14:40:00',1.69),('9303','2013-10-27','14:45:00',1.39),('9303','2013-10-27','14:50:00',1.03),('9303','2013-10-27','14:55:00',1.05),('9303','2013-10-27','15:00:00',1.09),('9303','2013-10-26','09:30:00',1.1),('9303','2013-10-26','09:35:00',1.22),('9303','2013-10-26','09:40:00',1.29),('9303','2013-10-26','09:45:00',1.39),('9303','2013-10-26','09:50:00',1.5),('9303','2013-10-26','09:55:00',1.62),('9303','2013-10-26','10:00:00',1.69),('9303','2013-10-26','10:05:00',1.79),('9303','2013-10-26','10:10:00',1.83),('9303','2013-10-26','10:15:00',1.89),('9303','2013-10-26','10:20:00',1.92),('9303','2013-10-26','10:25:00',2),('9303','2013-10-26','10:30:00',2.03),('9303','2013-10-26','10:35:00',2.06),('9303','2013-10-26','10:40:00',2.12),('9303','2013-10-26','10:45:00',2.15),('9303','2013-10-26','10:50:00',2.23),('9303','2013-10-26','10:55:00',2.29),('9303','2013-10-26','11:00:00',2.32),('9303','2013-10-26','11:05:00',2.39),('9303','2013-10-26','11:10:00',2.42),('9303','2013-10-26','11:15:00',2.42),('9303','2013-10-26','11:20:00',2.46),('9303','2013-10-26','11:25:00',2.51),('9303','2013-10-26','11:30:00',2.51),('9303','2013-10-26','11:35:00',2.53),('9303','2013-10-26','11:40:00',2.59),('9303','2013-10-26','11:45:00',2.59),('9303','2013-10-26','11:50:00',2.59),('9303','2013-10-26','11:55:00',2.63),('9303','2013-10-26','12:00:00',2.61),('9303','2013-10-26','12:05:00',2.65),('9303','2013-10-26','12:10:00',2.69),('9303','2013-10-26','12:15:00',2.69),('9303','2013-10-26','12:20:00',2.64),('9303','2013-10-26','12:25:00',2.64),('9303','2013-10-26','12:30:00',2.76),('9303','2013-10-26','12:35:00',2.69),('9303','2013-10-26','12:40:00',2.73),('9303','2013-10-26','12:45:00',2.77),('9303','2013-10-26','12:50:00',2.77),('9303','2013-10-26','12:55:00',2.71),('9303','2013-10-26','13:00:00',2.69),('9303','2013-10-26','13:05:00',2.62),('9303','2013-10-26','13:10:00',2.54),('9303','2013-10-26','13:15:00',2.49),('9303','2013-10-26','13:20:00',2.57),('9303','2013-10-26','13:25:00',2.6),('9303','2013-10-26','13:30:00',2.25),('9303','2013-10-26','13:35:00',2.67),('9303','2013-10-26','13:40:00',2.65),('9303','2013-10-26','13:45:00',2.51),('9303','2013-10-26','13:50:00',2.41),('9303','2013-10-26','13:55:00',2.5),('9303','2013-10-26','14:00:00',2.42),('9303','2013-10-26','14:05:00',2.11),('9303','2013-10-26','14:10:00',2.31),('9303','2013-10-26','14:15:00',2.18),('9303','2013-10-26','14:20:00',1.96),('9303','2013-10-26','14:25:00',1.04),('9303','2013-10-26','14:35:00',1.9),('9303','2013-10-26','14:40:00',1.97),('9303','2013-10-26','14:45:00',2.02),('9303','2013-10-26','14:50:00',2.01),('9303','2013-10-26','14:55:00',1.97),('9303','2013-10-26','15:00:00',1.86),('9303','2013-10-26','15:05:00',1.81),('9303','2013-10-26','15:10:00',1.77),('9303','2013-10-26','15:15:00',1.72),('9303','2013-10-26','15:20:00',1.15),('9303','2013-10-26','15:25:00',1.34),('9303','2013-10-26','15:30:00',1.5),('9303','2013-10-26','15:35:00',1.63),('9303','2013-10-26','15:40:00',1.56),('9303','2013-10-26','15:45:00',1.41),('9303','2013-10-26','15:50:00',1.43),('9303','2013-10-26','15:55:00',1.16),('9303','2013-10-26','16:00:00',1.01),('9303','2013-10-25','09:25:00',1.09),('9303','2013-10-25','09:30:00',1.16),('9303','2013-10-25','09:35:00',1.21),('9303','2013-10-25','09:40:00',1.29),('9303','2013-10-25','09:45:00',1.35),('9303','2013-10-25','09:50:00',1.4),('9303','2013-10-25','09:55:00',1.46),('9303','2013-10-25','10:00:00',1.68),('9303','2013-10-25','10:05:00',1.86),('9303','2013-10-25','10:10:00',1.9),('9303','2013-10-25','10:15:00',1.96),('9303','2013-10-25','10:20:00',1.97),('9303','2013-10-25','10:25:00',2.05),('9303','2013-10-25','10:30:00',2.13),('9303','2013-10-25','10:35:00',2.13),('9303','2013-10-25','10:40:00',2.17),('9303','2013-10-25','10:45:00',2.2),('9303','2013-10-25','10:50:00',2.26),('9303','2013-10-25','10:55:00',2.34),('9303','2013-10-25','11:00:00',2.32),('9303','2013-10-25','11:05:00',2.41),('9303','2013-10-25','11:10:00',2.46),('9303','2013-10-25','11:15:00',2.43),('9303','2013-10-25','11:20:00',2.5),('9303','2013-10-25','11:25:00',2.52),('9303','2013-10-25','11:30:00',2.58),('9303','2013-10-25','11:35:00',2.6),('9303','2013-10-25','11:40:00',2.6),('9303','2013-10-25','11:45:00',2.63),('9303','2013-10-25','11:50:00',2.71),('9303','2013-10-25','11:55:00',2.76),('9303','2013-10-25','12:00:00',2.79),('9303','2013-10-25','12:05:00',2.82),('9303','2013-10-25','12:10:00',2.79),('9303','2013-10-25','12:15:00',2.82),('9303','2013-10-25','12:20:00',2.84),('9303','2013-10-25','12:25:00',2.82),('9303','2013-10-25','12:30:00',2.83),('9303','2013-10-25','12:35:00',2.84),('9303','2013-10-25','12:40:00',2.88),('9303','2013-10-25','12:45:00',2.87),('9303','2013-10-25','12:50:00',2.86),('9303','2013-10-25','12:55:00',2.9),('9303','2013-10-25','13:00:00',2.92),('9303','2013-10-25','13:05:00',2.94),('9303','2013-10-25','13:10:00',2.94),('9303','2013-10-25','13:15:00',2.82),('9303','2013-10-25','13:20:00',2.66),('9303','2013-10-25','13:25:00',2.65),('9303','2013-10-25','13:30:00',2.68),('9303','2013-10-25','13:35:00',2.73),('9303','2013-10-25','13:40:00',2.72),('9303','2013-10-25','13:45:00',2.64),('9303','2013-10-25','13:50:00',2.67),('9303','2013-10-25','13:55:00',2.65),('9303','2013-10-25','14:00:00',2.63),('9303','2013-10-25','14:05:00',2.6),('9303','2013-10-25','14:10:00',2.57),('9303','2013-10-25','14:15:00',2.5),('9303','2013-10-25','14:20:00',2.43),('9303','2013-10-25','14:25:00',2.38),('9303','2013-10-25','14:30:00',2.36),('9303','2013-10-25','14:35:00',2.38),('9303','2013-10-25','14:40:00',2.3),('9303','2013-10-25','14:45:00',2.25),('9303','2013-10-25','14:50:00',2.19),('9303','2013-10-25','14:55:00',2.22),('9303','2013-10-25','15:00:00',2.16),('9303','2013-10-25','15:05:00',2.15),('9303','2013-10-25','15:10:00',2.1),('9303','2013-10-25','15:15:00',1.97),('9303','2013-10-25','15:20:00',1.94),('9303','2013-10-25','15:25:00',1.89),('9303','2013-10-25','15:30:00',1.77),('9303','2013-10-25','15:35:00',1.66),('9303','2013-10-25','15:40:00',1.62),('9303','2013-10-25','15:45:00',1.56),('9303','2013-10-25','15:50:00',1.46),('9303','2013-10-25','15:55:00',1.36),('9303','2013-10-25','16:00:00',1.23),('9303','2013-10-25','16:05:00',1.12),('9303','2013-10-25','16:10:00',1.03),('9303','2013-10-24','09:15:00',1.17),('9303','2013-10-24','09:20:00',1.07),('9303','2013-10-24','09:40:00',1.01),('9303','2013-10-24','09:45:00',1.04),('9303','2013-10-24','09:50:00',1.05),('9303','2013-10-24','09:55:00',1.01),('9303','2013-10-24','10:35:00',1.36),('9303','2013-10-24','10:40:00',1.27),('9303','2013-10-24','10:45:00',2.12),('9303','2013-10-24','10:50:00',1.71),('9303','2013-10-24','10:55:00',2.07),('9303','2013-10-24','11:00:00',2.52),('9303','2013-10-24','11:05:00',2.64),('9303','2013-10-24','11:10:00',2.61),('9303','2013-10-24','11:15:00',1.59),('9303','2013-10-24','11:20:00',1.32),('9303','2013-10-24','11:25:00',2.18),('9303','2013-10-24','11:30:00',1.6),('9303','2013-10-24','11:35:00',1.05),('9303','2013-10-24','11:40:00',1.04),('9303','2013-10-24','11:45:00',1.1),('9303','2013-10-24','11:50:00',1.68),('9303','2013-10-24','11:55:00',2.81),('9303','2013-10-24','12:00:00',1.63),('9303','2013-10-24','12:05:00',1.29),('9303','2013-10-24','12:10:00',1.21),('9303','2013-10-24','12:15:00',1.2),('9303','2013-10-24','12:20:00',1.25),('9303','2013-10-24','12:25:00',1.4),('9303','2013-10-24','12:30:00',1.47),('9303','2013-10-24','12:35:00',1.59),('9303','2013-10-24','12:40:00',1.82),('9303','2013-10-24','12:45:00',1.97),('9303','2013-10-24','12:50:00',1.91),('9303','2013-10-24','12:55:00',2.09),('9303','2013-10-24','13:00:00',2.68),('9303','2013-10-24','13:05:00',3.06),('9303','2013-10-24','13:10:00',2.74),('9303','2013-10-24','13:15:00',2.1),('9303','2013-10-24','13:20:00',2.35),('9303','2013-10-24','13:25:00',2.01),('9303','2013-10-24','13:30:00',1.26),('9303','2013-10-24','13:35:00',1.2),('9303','2013-10-24','13:40:00',1.2),('9303','2013-10-24','13:45:00',1.26),('9303','2013-10-24','13:50:00',1.45),('9303','2013-10-24','13:55:00',1.82),('9303','2013-10-24','14:00:00',2.04),('9303','2013-10-24','14:05:00',1.68),('9303','2013-10-24','14:10:00',1.29),('9303','2013-10-24','14:15:00',1.28),('9303','2013-10-24','14:20:00',1.34),('9303','2013-10-24','14:25:00',1.42),('9303','2013-10-24','14:30:00',1.41),('9303','2013-10-24','14:35:00',1.74),('9303','2013-10-24','14:40:00',1.78),('9303','2013-10-24','14:45:00',1.86),('9303','2013-10-24','14:50:00',1.96),('9303','2013-10-24','15:05:00',1.13),('9303','2013-10-24','15:10:00',2.17),('9303','2013-10-24','15:15:00',1.35),('9303','2013-10-24','15:20:00',1.04),('9303','2013-10-24','15:25:00',1.16),('9303','2013-10-24','15:30:00',1.02),('9303','2013-10-24','15:35:00',2.11),('9303','2013-10-24','15:40:00',2.14),('9303','2013-10-24','15:45:00',1.67),('9303','2013-10-24','15:50:00',1.19),('9303','2013-10-23','10:40:00',1.13),('9303','2013-10-23','10:45:00',1.03),('9303','2013-10-23','10:50:00',1.64),('9303','2013-10-23','10:55:00',1.21),('9303','2013-10-23','11:00:00',1.49),('9303','2013-10-23','11:05:00',1.43),('9303','2013-10-23','11:10:00',1.33),('9303','2013-10-23','11:15:00',1.42),('9303','2013-10-23','11:20:00',2.37),('9303','2013-10-23','11:25:00',2.51),('9303','2013-10-23','11:30:00',2.44),('9303','2013-10-23','11:35:00',2.47),('9303','2013-10-23','11:40:00',2.52),('9303','2013-10-23','11:45:00',2.59),('9303','2013-10-23','11:50:00',2.63),('9303','2013-10-23','11:55:00',2.69),('9303','2013-10-23','12:00:00',2.67),('9303','2013-10-23','12:05:00',2.61),('9303','2013-10-23','12:10:00',2.58),('9303','2013-10-23','12:15:00',2.43),('9303','2013-10-23','12:20:00',2.44),('9303','2013-10-23','12:25:00',2.62),('9303','2013-10-23','12:30:00',2.56),('9303','2013-10-23','12:35:00',2.6),('9303','2013-10-23','12:40:00',2.6),('9303','2013-10-23','12:45:00',2.41),('9303','2013-10-23','12:50:00',1.81),('9303','2013-10-23','12:55:00',2.09),('9303','2013-10-23','13:00:00',2.65),('9303','2013-10-23','13:05:00',2.58),('9303','2013-10-23','13:10:00',2.71),('9303','2013-10-23','13:15:00',2.71),('9303','2013-10-23','13:20:00',2.65),('9303','2013-10-23','13:25:00',2.55),('9303','2013-10-23','13:30:00',2.53),('9303','2013-10-23','13:35:00',2.48),('9303','2013-10-23','13:40:00',2.55),('9303','2013-10-23','13:45:00',2.47),('9303','2013-10-23','13:50:00',2.19),('9303','2013-10-23','13:55:00',2.08),('9303','2013-10-23','14:00:00',2.26),('9303','2013-10-23','14:05:00',2.27),('9303','2013-10-23','14:10:00',2.3),('9303','2013-10-23','14:15:00',2.36),('9303','2013-10-23','14:20:00',2.23),('9303','2013-10-23','14:25:00',2.19),('9303','2013-10-23','14:32:00',2.17),('9303','2013-10-23','14:35:00',2.19),('9303','2013-10-23','14:40:00',2.14),('9303','2013-10-23','14:45:00',1.91),('9303','2013-10-23','14:50:00',1.66),('9303','2013-10-23','14:55:00',1.73),('9303','2013-10-23','15:00:00',1.81),('9303','2013-10-23','15:05:00',2.06),('9303','2013-10-23','15:10:00',2.04),('9303','2013-10-23','15:15:00',2.01),('9303','2013-10-23','15:20:00',1.98),('9303','2013-10-23','15:25:00',1.99),('9303','2013-10-23','15:30:00',1.9),('9303','2013-10-23','15:35:00',1.76),('9303','2013-10-23','15:40:00',1.85),('9303','2013-10-23','15:45:00',1.77),('9303','2013-10-23','15:50:00',1.57),('9303','2013-10-23','15:55:00',1.1),('9303','2013-10-22','09:15:00',1),('9303','2013-10-22','09:20:00',1.09),('9303','2013-10-22','09:25:00',1.19),('9303','2013-10-22','09:30:00',1.28),('9303','2013-10-22','09:35:00',1.39),('9303','2013-10-22','09:40:00',1.5),('9303','2013-10-22','09:45:00',1.59),('9303','2013-10-22','09:50:00',1.68),('9303','2013-10-22','09:55:00',1.77),('9303','2013-10-22','10:00:00',1.81),('9303','2013-10-22','10:05:00',1.85),('9303','2013-10-22','10:10:00',1.89),('9303','2013-10-22','10:15:00',1.94),('9303','2013-10-22','10:20:00',1.97),('9303','2013-10-22','10:25:00',1.96),('9303','2013-10-22','10:30:00',2.08),('9303','2013-10-22','10:35:00',2.09),('9303','2013-10-22','10:40:00',2.13),('9303','2013-10-22','10:45:00',2.19),('9303','2013-10-22','10:50:00',2.21),('9303','2013-10-22','10:55:00',2.3),('9303','2013-10-22','11:00:00',2.3),('9303','2013-10-22','11:05:00',2.37),('9303','2013-10-22','11:10:00',2.39),('9303','2013-10-22','11:15:00',2.43),('9303','2013-10-22','11:20:00',2.41),('9303','2013-10-22','11:25:00',2.45),('9303','2013-10-22','11:30:00',2.48),('9303','2013-10-22','11:35:00',2.48),('9303','2013-10-22','11:40:00',2.47),('9303','2013-10-22','11:45:00',2.46),('9303','2013-10-22','11:50:00',2.51),('9303','2013-10-22','11:55:00',2.59),('9303','2013-10-22','12:00:00',2.6),('9303','2013-10-22','12:05:00',2.6),('9303','2013-10-22','12:10:00',2.53),('9303','2013-10-22','12:15:00',2.59),('9303','2013-10-22','12:20:00',2.68),('9303','2013-10-22','12:25:00',2.65),('9303','2013-10-22','12:30:00',2.63),('9303','2013-10-22','12:35:00',2.66),('9303','2013-10-22','12:40:00',2.73),('9303','2013-10-22','12:45:00',2.7),('9303','2013-10-22','12:50:00',2.61),('9303','2013-10-22','12:55:00',2.75),('9303','2013-10-22','13:00:00',2.74),('9303','2013-10-22','13:05:00',2.68),('9303','2013-10-22','13:10:00',2.65),('9303','2013-10-22','13:15:00',2.67),('9303','2013-10-22','13:20:00',2.64),('9303','2013-10-22','13:25:00',2.64),('9303','2013-10-22','13:30:00',2.55),('9303','2013-10-22','13:35:00',2.56),('9303','2013-10-22','13:40:00',2.56),('9303','2013-10-22','13:45:00',2.51),('9303','2013-10-22','13:50:00',2.48),('9303','2013-10-22','13:55:00',2.41),('9303','2013-10-22','14:00:00',2.34),('9303','2013-10-22','14:05:00',1.83),('9303','2013-10-22','14:10:00',2.31),('9303','2013-10-22','14:15:00',2.34),('9303','2013-10-22','14:20:00',2.34),('9303','2013-10-22','14:25:00',2.22),('9303','2013-10-22','14:30:00',1.41),('9303','2013-10-22','14:45:00',1.43),('9303','2013-10-22','14:50:00',2.01),('9303','2013-10-22','14:55:00',2.07),('9303','2013-10-22','15:00:00',1.91),('9303','2013-10-22','15:05:00',1.97),('9303','2013-10-22','15:10:00',1.96),('9303','2013-10-22','15:15:00',1.54),('9303','2013-10-22','15:20:00',1.75),('9303','2013-10-22','15:25:00',1.8),('9303','2013-10-22','15:30:00',1.77),('9303','2013-10-22','15:35:00',1.76),('9303','2013-10-22','15:40:00',1.76),('9303','2013-10-22','15:45:00',1.68),('9303','2013-10-22','15:50:00',1.59),('9303','2013-10-22','15:55:00',1.42),('9303','2013-10-22','16:00:00',1.31),('9303','2013-10-22','16:05:00',1.17),('9303','2013-10-22','16:10:00',1.15),('9303','2013-10-22','16:15:00',1.05),('9303','2013-10-21','09:15:00',1.04),('9303','2013-10-21','09:20:00',1.25),('9303','2013-10-21','09:25:00',1.35),('9303','2013-10-21','09:30:00',1.3),('9303','2013-10-21','09:35:00',1.26),('9303','2013-10-21','09:40:00',1.56),('9303','2013-10-21','09:45:00',1.38),('9303','2013-10-21','09:50:00',1.51),('9303','2013-10-21','09:55:00',1.68),('9303','2013-10-21','10:00:00',1.67),('9303','2013-10-21','10:05:00',1.87),('9303','2013-10-21','10:10:00',1.99),('9303','2013-10-21','10:15:00',2.05),('9303','2013-10-21','10:20:00',2.02),('9303','2013-10-21','10:25:00',1.97),('9303','2013-10-21','10:30:00',2.04),('9303','2013-10-21','10:35:00',2.06),('9303','2013-10-21','10:40:00',2.01),('9303','2013-10-21','10:45:00',2.13),('9303','2013-10-21','10:50:00',2.22),('9303','2013-10-21','10:55:00',2.26),('9303','2013-10-21','11:00:00',2.4),('9303','2013-10-21','11:05:00',2.2),('9303','2013-10-21','11:10:00',2.03),('9303','2013-10-21','11:15:00',2.51),('9303','2013-10-21','11:20:00',2.52),('9303','2013-10-21','11:25:00',2.5),('9303','2013-10-21','11:30:00',2.63),('9303','2013-10-21','11:35:00',2.67),('9303','2013-10-21','11:40:00',2.6),('9303','2013-10-21','11:45:00',2.71),('9303','2013-10-21','11:50:00',2.71),('9303','2013-10-21','11:55:00',2.74),('9303','2013-10-21','12:00:00',2.78),('9303','2013-10-21','12:05:00',2.81),('9303','2013-10-21','12:10:00',2.85),('9303','2013-10-21','12:15:00',2.85),('9303','2013-10-21','12:20:00',2.85),('9303','2013-10-21','12:25:00',2.87),('9303','2013-10-21','12:30:00',2.71),('9303','2013-10-21','12:35:00',2.76),('9303','2013-10-21','12:40:00',2.91),('9303','2013-10-21','12:45:00',2.92),('9303','2013-10-21','12:50:00',2.9),('9303','2013-10-21','12:55:00',2.95),('9303','2013-10-21','13:00:00',2.9),('9303','2013-10-21','13:05:00',2.83),('9303','2013-10-21','13:10:00',2.76),('9303','2013-10-21','13:15:00',2.81),('9303','2013-10-21','13:20:00',2.69),('9303','2013-10-21','13:25:00',2.68),('9303','2013-10-21','13:30:00',2.8),('9303','2013-10-21','13:35:00',2.79),('9303','2013-10-21','13:40:00',2.72),('9303','2013-10-21','13:45:00',2.72),('9303','2013-10-21','13:50:00',2.65),('9303','2013-10-21','13:55:00',2.57),('9303','2013-10-21','14:00:00',2.54),('9303','2013-10-21','14:05:00',2.62),('9303','2013-10-21','14:10:00',2.59),('9303','2013-10-21','14:15:00',2.54),('9303','2013-10-21','14:20:00',2.44),('9303','2013-10-21','14:25:00',2.36),('9303','2013-10-21','14:30:00',2.33),('9303','2013-10-21','14:35:00',2.38),('9303','2013-10-21','14:40:00',2.27),('9303','2013-10-21','14:45:00',2.2),('9303','2013-10-21','14:50:00',2.18),('9303','2013-10-21','14:55:00',2.17),('9303','2013-10-21','15:00:00',2.2),('9303','2013-10-21','15:05:00',2.15),('9303','2013-10-21','15:10:00',2.11),('9303','2013-10-21','15:15:00',2.09),('9303','2013-10-21','15:20:00',2.03),('9303','2013-10-21','15:25:00',2),('9303','2013-10-21','15:30:00',1.86),('9303','2013-10-21','15:35:00',1.81),('9303','2013-10-21','15:40:00',1.84),('9303','2013-10-21','15:45:00',1.78),('9303','2013-10-21','15:50:00',1.7),('9303','2013-10-21','15:55:00',1.58),('9303','2013-10-21','16:00:00',1.47),('9303','2013-10-21','16:05:00',1.36),('9303','2013-10-21','16:10:00',1.29),('9303','2013-10-21','16:15:00',1.18),('9303','2013-10-21','16:20:00',1.08),('9303','2013-10-20','09:15:00',1.07),('9303','2013-10-20','09:20:00',1.15),('9303','2013-10-20','09:25:00',1.23),('9303','2013-10-20','09:30:00',1.42),('9303','2013-10-20','09:35:00',1.59),('9303','2013-10-20','09:40:00',1.7),('9303','2013-10-20','09:45:00',1.79),('9303','2013-10-20','09:50:00',1.83),('9303','2013-10-20','09:55:00',1.9),('9303','2013-10-20','10:00:00',1.99),('9303','2013-10-20','10:05:00',2.04),('9303','2013-10-20','10:10:00',2.08),('9303','2013-10-20','10:15:00',2.12),('9303','2013-10-20','10:20:00',2.17),('9303','2013-10-20','10:25:00',2.2),('9303','2013-10-20','10:30:00',2.26),('9303','2013-10-20','10:35:00',2.28),('9303','2013-10-20','10:40:00',2.28),('9303','2013-10-20','10:45:00',2.36),('9303','2013-10-20','10:50:00',2.38),('9303','2013-10-20','10:55:00',2.47),('9303','2013-10-20','11:00:00',2.46),('9303','2013-10-20','11:05:00',2.53),('9303','2013-10-20','11:10:00',2.57),('9303','2013-10-20','11:15:00',2.59),('9303','2013-10-20','11:20:00',2.64),('9303','2013-10-20','11:25:00',2.65),('9303','2013-10-20','11:30:00',2.71),('9303','2013-10-20','11:35:00',2.74),('9303','2013-10-20','11:40:00',2.73),('9303','2013-10-20','11:45:00',2.77),('9303','2013-10-20','11:55:00',2.55),('9303','2013-10-20','12:00:00',2.87),('9303','2013-10-20','12:05:00',2.84),('9303','2013-10-20','12:10:00',2.7),('9303','2013-10-20','12:15:00',2.53),('9303','2013-10-20','12:20:00',2.33),('9303','2013-10-20','12:30:00',3),('9303','2013-10-20','12:35:00',2),('9303','2013-10-20','12:40:00',2.16),('9303','2013-10-20','12:45:00',1.51),('9303','2013-10-20','12:50:00',2.01),('9303','2013-10-20','12:55:00',2.04),('9303','2013-10-20','13:00:00',2.1),('9303','2013-10-20','13:05:00',2.89),('9303','2013-10-20','13:10:00',3.5),('9303','2013-10-20','13:15:00',1.43),('9303','2013-10-20','13:25:00',1.48),('9303','2013-10-20','13:30:00',1.67),('9303','2013-10-20','13:35:00',2.15),('9303','2013-10-20','13:40:00',1.13),('9303','2013-10-20','13:45:00',2.35),('9303','2013-10-20','13:50:00',1.17),('9303','2013-10-20','13:55:00',2.14),('9303','2013-10-20','14:00:00',1.08),('9303','2013-10-20','14:10:00',1.6),('9303','2013-10-19','09:10:00',1),('9303','2013-10-19','09:15:00',1.57),('9303','2013-10-19','09:20:00',1.68),('9303','2013-10-19','09:25:00',1.74),('9303','2013-10-19','09:30:00',1.79),('9303','2013-10-19','09:35:00',1.87),('9303','2013-10-19','09:40:00',1.95),('9303','2013-10-19','09:45:00',2.06),('9303','2013-10-19','09:50:00',2.18),('9303','2013-10-19','09:55:00',2.29),('9303','2013-10-19','10:00:00',2.26),('9303','2013-10-19','10:05:00',2.14),('9303','2013-10-19','10:10:00',2.29),('9303','2013-10-19','10:15:00',2.25),('9303','2013-10-19','10:20:00',2.42),('9303','2013-10-19','10:25:00',2.51),('9303','2013-10-19','10:30:00',2.55),('9303','2013-10-19','10:35:00',2.56),('9303','2013-10-19','10:40:00',2.55),('9303','2013-10-19','10:45:00',2.57),('9303','2013-10-19','10:50:00',2.61),('9303','2013-10-19','10:55:00',2.72),('9303','2013-10-19','11:00:00',2.68),('9303','2013-10-19','11:05:00',2.44),('9303','2013-10-19','11:10:00',1.4),('9303','2013-10-19','11:15:00',1.04),('9303','2013-10-19','11:20:00',2.09),('9303','2013-10-19','11:25:00',3.07),('9303','2013-10-19','11:30:00',3.03),('9303','2013-10-19','11:35:00',3.01),('9303','2013-10-19','11:40:00',2.87),('9303','2013-10-19','11:45:00',2.99),('9303','2013-10-19','11:50:00',2.96),('9303','2013-10-19','11:55:00',2.98),('9303','2013-10-19','12:00:00',3.15),('9303','2013-10-19','12:05:00',3.15),('9303','2013-10-19','12:10:00',3.11),('9303','2013-10-19','12:15:00',3.1),('9303','2013-10-19','12:20:00',3.15),('9303','2013-10-19','12:25:00',2.83),('9303','2013-10-19','12:30:00',3.09),('9303','2013-10-19','12:35:00',3.16),('9303','2013-10-19','12:40:00',3.28),('9303','2013-10-19','12:45:00',3.33),('9303','2013-10-19','12:50:00',3.38),('9303','2013-10-19','12:55:00',3.4),('9303','2013-10-19','13:00:00',3.58),('9303','2013-10-19','13:05:00',2.69),('9303','2013-10-19','13:10:00',3.1),('9303','2013-10-19','13:15:00',3.04),('9303','2013-10-19','13:20:00',2.91),('9303','2013-10-19','13:25:00',3.23),('9303','2013-10-19','13:30:00',3.27),('9303','2013-10-19','13:35:00',2.58),('9303','2013-10-19','13:40:00',2.22),('9303','2013-10-19','13:45:00',2.39),('9303','2013-10-19','13:50:00',2.52),('9303','2013-10-19','13:55:00',3.35),('9303','2013-10-19','14:00:00',2.53),('9303','2013-10-19','14:05:00',2.16),('9303','2013-10-19','14:10:00',1.69),('9303','2013-10-19','14:15:00',2.08),('9303','2013-10-19','14:20:00',1.87),('9303','2013-10-19','14:25:00',1.74),('9303','2013-10-19','14:30:00',2.09),('9303','2013-10-19','14:35:00',2.82),('9303','2013-10-19','14:40:00',2.14),('9303','2013-10-19','14:45:00',1.81),('9303','2013-10-19','14:50:00',2.74),('9303','2013-10-19','14:55:00',2.66),('9303','2013-10-19','15:00:00',2.57),('9303','2013-10-19','15:05:00',2.48),('9303','2013-10-19','15:10:00',2.46),('9303','2013-10-19','15:15:00',2.4),('9303','2013-10-19','15:20:00',2.24),('9303','2013-10-19','15:25:00',2.21),('9303','2013-10-19','15:30:00',2.1),('9303','2013-10-19','15:35:00',2.1),('9303','2013-10-19','15:40:00',1.93),('9303','2013-10-19','15:45:00',1.66),('9303','2013-10-19','15:50:00',1.79),('9303','2013-10-19','15:55:00',1.95),('9303','2013-10-19','16:00:00',1.57),('9303','2013-10-19','16:05:00',1.61),('9303','2013-10-19','16:10:00',1.52),('9303','2013-10-19','16:15:00',1.59),('9303','2013-10-19','16:20:00',1.41),('9303','2013-10-19','16:30:00',1.19),('9303','2013-10-19','16:35:00',1.17),('9303','2013-10-19','16:40:00',1.07),('9303','2014-05-04','07:50:00',1.09),('9303','2014-05-04','07:55:00',1.17),('9303','2014-05-04','08:00:00',1.28),('9303','2014-05-04','08:05:00',1.39),('9303','2014-05-04','08:10:00',1.49),('9303','2014-05-04','08:15:00',1.6),('9303','2014-05-04','08:20:00',1.74),('9303','2014-05-04','08:25:00',1.87),('9303','2014-05-04','08:30:00',2.08),('9303','2014-05-04','08:35:00',1.86),('9303','2014-05-04','08:40:00',1.68),('9303','2014-05-04','08:45:00',1.25),('9303','2014-05-04','08:50:00',1.66),('9303','2014-05-04','08:55:00',1.12),('9303','2014-05-04','09:00:00',1.25),('9303','2014-05-04','09:05:00',2.01),('9303','2014-05-04','09:10:00',1.95),('9303','2014-05-04','09:15:00',2.26),('9303','2014-05-04','09:20:00',3.52),('9303','2014-05-04','09:25:00',2.91),('9303','2014-05-04','09:30:00',1.26),('9303','2014-05-04','09:35:00',1.17),('9303','2014-05-04','09:40:00',1.52),('9303','2014-05-04','09:45:00',2.18),('9303','2014-05-04','09:50:00',2.39),('9303','2014-05-04','09:55:00',2.49),('9303','2014-05-04','10:00:00',3.7),('9303','2014-05-04','10:05:00',3.14),('9303','2014-05-04','10:10:00',3.55),('9303','2014-05-04','10:15:00',2.47),('9303','2014-05-04','10:20:00',1.83),('9303','2014-05-04','10:25:00',1.8),('9303','2014-05-04','10:30:00',1.86),('9303','2014-05-04','10:35:00',1.97),('9303','2014-05-04','10:40:00',2.05),('9303','2014-05-04','10:45:00',3.36),('9303','2014-05-04','10:50:00',3.81),('9303','2014-05-04','10:55:00',2.47),('9303','2014-05-04','11:00:00',2.37),('9303','2014-05-04','11:05:00',3.53),('9303','2014-05-04','11:10:00',4.6),('9303','2014-05-04','11:15:00',3.98),('9303','2014-05-04','11:20:00',4.27),('9303','2014-05-04','11:25:00',3.53),('9303','2014-05-04','11:30:00',4.03),('9303','2014-05-04','11:35:00',3.85),('9303','2014-05-04','11:40:00',2.7),('9303','2014-05-04','11:45:00',4.47),('9303','2014-05-04','11:50:00',2.78),('9303','2014-05-04','11:55:00',3.29),('9303','2014-05-04','12:00:00',3),('9303','2014-05-04','12:05:00',3.66),('9303','2014-05-04','12:10:00',2.37),('9303','2014-05-04','12:15:00',1.5),('9303','2014-05-04','12:20:00',1.63),('9303','2014-05-04','12:25:00',1.84),('9303','2014-05-04','12:30:00',4.91),('9303','2014-05-04','12:35:00',4.7),('9303','2014-05-04','12:40:00',4.04),('9303','2014-05-04','12:45:00',4.48),('9303','2014-05-04','12:50:00',2.67),('9303','2014-05-04','12:55:00',3.19),('9303','2014-05-04','13:00:00',2.13),('9303','2014-05-04','13:05:00',3.07),('9303','2014-05-04','13:10:00',3.67),('9303','2014-05-04','13:15:00',2.01),('9303','2014-05-04','13:20:00',1.67),('9303','2014-05-04','13:25:00',1.45),('9303','2014-05-04','13:30:00',1.51),('9303','2014-05-04','13:35:00',1.6),('9303','2014-05-04','13:40:00',1.54),('9303','2014-05-04','13:45:00',1.34),('9303','2014-05-04','13:50:00',1.3),('9303','2014-05-04','13:55:00',1.29),('9303','2014-05-04','14:00:00',1.34),('9303','2014-05-04','14:05:00',1.38),('9303','2014-05-04','14:10:00',1.33),('9303','2014-05-04','14:15:00',1.2),('9303','2014-05-04','14:50:00',1.13),('9303','2014-05-04','14:55:00',1.66),('9303','2014-05-04','15:00:00',1.8),('9303','2014-05-04','15:05:00',2.63),('9303','2014-05-04','15:10:00',3.3),('9303','2014-05-04','15:15:00',2.42),('9303','2014-05-04','15:20:00',1.52),('9303','2014-05-04','15:25:00',1.25),('9303','2014-05-04','15:50:00',1.09),('9303','2014-05-04','15:55:00',1.1),('9303','2014-05-04','16:10:00',1.19),('9303','2014-05-04','16:15:00',1.15),('9303','2014-04-16','08:05:00',1.05),('9303','2014-04-16','08:10:00',1.16),('9303','2014-04-16','08:15:00',1.3),('9303','2014-04-16','08:20:00',1.41),('9303','2014-04-16','08:25:00',1.5),('9303','2014-04-16','08:30:00',1.08),('9303','2014-04-16','08:40:00',1.1),('9303','2014-04-16','08:45:00',1.77),('9303','2014-04-16','08:50:00',1.99),('9303','2014-04-16','08:55:00',2.12),('9303','2014-04-16','09:00:00',2.19),('9303','2014-04-16','09:05:00',2.29),('9303','2014-04-16','09:10:00',2.38),('9303','2014-04-16','09:15:00',2.45),('9303','2014-04-16','09:20:00',2.54),('9303','2014-04-16','09:25:00',2.66),('9303','2014-04-16','09:30:00',1.44),('9303','2014-04-16','09:50:00',1.78),('9303','2014-04-16','09:55:00',3.34),('9303','2014-04-16','10:00:00',3.23),('9303','2014-04-16','10:05:00',3.31),('9303','2014-04-16','10:10:00',3.4),('9303','2014-04-16','10:15:00',3.48),('9303','2014-04-16','10:20:00',3.54),('9303','2014-04-16','10:25:00',3.6),('9303','2014-04-16','10:30:00',3.65),('9303','2014-04-16','10:35:00',3.7),('9303','2014-04-16','10:40:00',3.75),('9303','2014-04-16','10:45:00',3.84),('9303','2014-04-16','10:50:00',3.99),('9303','2014-04-16','10:55:00',3.69),('9303','2014-04-16','11:00:00',3.98),('9303','2014-04-16','11:05:00',2.74),('9303','2014-04-16','11:10:00',1.49),('9303','2014-04-16','11:15:00',2.24),('9303','2014-04-16','11:20:00',4.38),('9303','2014-04-16','11:25:00',2.6),('9303','2014-04-16','11:30:00',3.76),('9303','2014-04-16','11:35:00',2.38),('9303','2014-04-16','11:40:00',4.08),('9303','2014-04-16','11:45:00',4.12),('9303','2014-04-16','11:50:00',4.82),('9303','2014-04-16','11:55:00',4.68),('9303','2014-04-16','12:00:00',4.84),('9303','2014-04-16','12:05:00',2.31),('9303','2014-04-16','12:10:00',4.56),('9303','2014-04-16','12:15:00',4.48),('9303','2014-04-16','12:20:00',3.24),('9303','2014-04-16','12:25:00',1.51),('9303','2014-04-16','12:30:00',2.2),('9303','2014-04-16','12:35:00',4.65),('9303','2014-04-16','12:40:00',4.81),('9303','2014-04-16','12:45:00',4.67),('9303','2014-04-16','12:50:00',4.58),('9303','2014-04-16','12:55:00',1.36),('9303','2014-04-16','13:00:00',2.86),('9303','2014-04-16','13:05:00',1.32),('9303','2014-04-16','13:20:00',1.23),('9303','2014-04-16','13:35:00',1.5),('9303','2014-04-16','13:40:00',2.32),('9303','2014-04-16','13:45:00',4.91),('9303','2014-04-16','13:50:00',4.01),('9303','2014-04-16','13:55:00',2.65),('9303','2014-04-16','14:00:00',1.71),('9303','2014-04-16','14:05:00',3.64),('9303','2014-04-16','14:10:00',4.97),('9303','2014-04-16','14:15:00',4.97),('9303','2014-04-16','14:20:00',4.18),('9303','2014-04-16','14:25:00',4.18),('9303','2014-04-16','14:30:00',4.31),('9303','2014-04-16','14:35:00',4.35),('9303','2014-04-16','14:40:00',4.28),('9303','2014-04-16','14:45:00',3.82),('9303','2014-04-16','14:50:00',3.7),('9303','2014-04-16','14:55:00',1.08),('9303','2014-04-16','15:00:00',1.71),('9303','2014-04-16','15:05:00',3.88),('9303','2014-04-16','15:10:00',4.76),('9303','2014-04-16','15:15:00',2.49),('9303','2014-04-16','15:25:00',1.09),('9303','2014-04-16','15:30:00',3.05),('9303','2014-04-16','15:35:00',3.66),('9303','2014-04-16','15:40:00',3.92),('9303','2014-04-16','15:45:00',3.81),('9303','2014-04-16','15:50:00',3.72),('9303','2014-04-16','15:55:00',3.62),('9303','2014-04-16','16:00:00',3.48),('9303','2014-04-16','16:05:00',3.38),('9303','2014-04-16','16:10:00',3.3),('9303','2014-04-16','16:15:00',3.24),('9303','2014-04-16','16:20:00',3.19),('9303','2014-04-16','16:25:00',3.09),('9303','2014-04-16','16:30:00',3.04),('9303','2014-04-16','16:35:00',2.96),('9303','2014-04-16','16:40:00',2.87),('9303','2014-04-16','16:45:00',2.79),('9303','2014-04-16','16:50:00',2.63),('9303','2014-04-16','16:55:00',2.49),('9303','2014-04-16','17:00:00',2.4),('9303','2014-04-16','17:05:00',2.29),('9303','2014-04-16','17:10:00',2.21),('9303','2014-04-16','17:15:00',2.14),('9303','2014-04-16','17:20:00',2.03),('9303','2014-04-16','17:25:00',1.92),('9303','2014-04-16','17:30:00',1.85),('9303','2014-04-16','17:35:00',1.75),('9303','2014-04-16','17:40:00',1.62),('9303','2014-04-16','17:45:00',1.56),('9303','2014-04-16','17:50:00',1.51),('9303','2014-04-16','17:55:00',1.48),('9303','2014-04-16','18:00:00',1.34),('9303','2014-04-16','18:05:00',1.23),('9303','2014-04-16','18:10:00',1.07),('9303','2013-10-18','09:05:00',1.07),('9303','2013-10-18','09:10:00',1.24),('9303','2013-10-18','09:15:00',1.41),('9303','2013-10-18','09:20:00',1.61),('9303','2013-10-18','09:25:00',1.66),('9303','2013-10-18','09:30:00',1.79),('9303','2013-10-18','09:35:00',1.89),('9303','2013-10-18','09:40:00',1.97),('9303','2013-10-18','09:45:00',2.06),('9303','2013-10-18','09:50:00',2.13),('9303','2013-10-18','09:55:00',2.19),('9303','2013-10-18','10:00:00',2.24),('9303','2013-10-18','10:05:00',2.26),('9303','2013-10-18','10:10:00',2.32),('9303','2013-10-18','10:15:00',2.32),('9303','2013-10-18','10:20:00',2.38),('9303','2013-10-18','10:25:00',2.4),('9303','2013-10-18','10:30:00',2.45),('9303','2013-10-18','10:35:00',2.47),('9303','2013-10-18','10:40:00',2.52),('9303','2013-10-18','10:45:00',2.59),('9303','2013-10-18','10:50:00',2.6),('9303','2013-10-18','10:55:00',2.68),('9303','2013-10-18','11:00:00',2.63),('9303','2013-10-18','11:05:00',2.67),('9303','2013-10-18','11:10:00',2.62),('9303','2013-10-18','11:15:00',2.52),('9303','2013-10-18','11:20:00',2.79),('9303','2013-10-18','11:25:00',2.62),('9303','2013-10-18','11:30:00',2.88),('9303','2013-10-18','11:35:00',2.9),('9303','2013-10-18','11:40:00',2.98),('9303','2013-10-18','11:45:00',2.93),('9303','2013-10-18','11:50:00',2.94),('9303','2013-10-18','11:55:00',3.07),('9303','2013-10-18','12:00:00',2.9),('9303','2013-10-18','12:05:00',3.02),('9303','2013-10-18','12:10:00',3.06),('9303','2013-10-18','12:15:00',2.96),('9303','2013-10-18','12:20:00',2.97),('9303','2013-10-18','12:25:00',3.07),('9303','2013-10-18','12:30:00',3.04),('9303','2013-10-18','12:35:00',2.97),('9303','2013-10-18','12:40:00',3.08),('9303','2013-10-18','12:45:00',3.01),('9303','2013-10-18','12:50:00',3.03),('9303','2013-10-18','12:55:00',3.15),('9303','2013-10-18','13:00:00',3.13),('9303','2013-10-18','13:05:00',3.04),('9303','2013-10-18','13:10:00',3.01),('9303','2013-10-18','13:15:00',3.09),('9303','2013-10-18','13:20:00',3.07),('9303','2013-10-18','13:25:00',3.11),('9303','2013-10-18','13:30:00',3.08),('9303','2013-10-18','13:35:00',3.01),('9303','2013-10-18','13:40:00',3.06),('9303','2013-10-18','13:45:00',2.99),('9303','2013-10-18','13:50:00',2.92),('9303','2013-10-18','13:55:00',2.9),('9303','2013-10-18','14:00:00',2.67),('9303','2013-10-18','14:05:00',2.74),('9303','2013-10-18','14:10:00',2.74),('9303','2013-10-18','14:15:00',2.76),('9303','2013-10-18','14:20:00',2.63),('9303','2013-10-18','14:25:00',2.61),('9303','2013-10-18','14:30:00',2.58),('9303','2013-10-18','14:35:00',2.5),('9303','2013-10-18','14:40:00',2.53),('9303','2013-10-18','14:45:00',2.52),('9303','2013-10-18','14:50:00',2.42),('9303','2013-10-18','14:55:00',2.47),('9303','2013-10-18','15:00:00',2.16),('9303','2013-10-18','15:05:00',1.92),('9303','2013-10-18','15:10:00',2.12),('9303','2013-10-18','15:15:00',2.12),('9303','2013-10-18','15:20:00',2.23),('9303','2013-10-18','15:25:00',2.16),('9303','2013-10-18','15:30:00',2.07),('9303','2013-10-18','15:35:00',2.06),('9303','2013-10-18','15:40:00',1.98),('9303','2013-10-18','15:45:00',1.79),('9303','2013-10-18','15:50:00',1.8),('9303','2013-10-18','15:55:00',1.63),('9303','2013-10-18','16:00:00',1.66),('9303','2013-10-18','16:05:00',1.53),('9303','2013-10-18','16:10:00',1.45),('9303','2013-10-18','16:15:00',1.27),('9303','2013-10-18','16:20:00',1.17),('9303','2013-10-18','16:25:00',1),('9303','2013-10-17','09:00:00',1.03),('9303','2013-10-17','09:05:00',1.19),('9303','2013-10-17','09:10:00',1.42),('9303','2013-10-17','09:15:00',1.52),('9303','2013-10-17','09:20:00',1.62),('9303','2013-10-17','09:25:00',1.7),('9303','2013-10-17','09:30:00',1.79),('9303','2013-10-17','09:35:00',1.88),('9303','2013-10-17','09:40:00',1.96),('9303','2013-10-17','09:45:00',2.06),('9303','2013-10-17','09:50:00',2.14),('9303','2013-10-17','09:55:00',2.2),('9303','2013-10-17','10:00:00',2.27),('9303','2013-10-17','10:05:00',2.29),('9303','2013-10-17','10:10:00',2.34),('9303','2013-10-17','10:15:00',2.36),('9303','2013-10-17','10:20:00',2.41),('9303','2013-10-17','10:25:00',2.44),('9303','2013-10-17','10:30:00',2.5),('9303','2013-10-17','10:35:00',2.53),('9303','2013-10-17','10:40:00',2.57),('9303','2013-10-17','10:45:00',2.64),('9303','2013-10-17','10:50:00',2.65),('9303','2013-10-17','10:55:00',2.73),('9303','2013-10-17','11:00:00',2.74),('9303','2013-10-17','11:05:00',2.83),('9303','2013-10-17','11:10:00',2.84),('9303','2013-10-17','11:15:00',2.85),('9303','2013-10-17','11:20:00',2.91),('9303','2013-10-17','11:25:00',2.93),('9303','2013-10-17','11:30:00',3.02),('9303','2013-10-17','11:35:00',3.04),('9303','2013-10-17','11:40:00',3.06),('9303','2013-10-17','11:45:00',3.08),('9303','2013-10-17','11:50:00',3.09),('9303','2013-10-17','11:55:00',3.11),('9303','2013-10-17','12:00:00',3.1),('9303','2013-10-17','12:05:00',3.13),('9303','2013-10-17','12:10:00',3.17),('9303','2013-10-17','12:15:00',3.16),('9303','2013-10-17','12:20:00',3.18),('9303','2013-10-17','12:25:00',3.22),('9303','2013-10-17','12:30:00',3.15),('9303','2013-10-17','12:35:00',3.16),('9303','2013-10-17','12:40:00',3.24),('9303','2013-10-17','12:45:00',3.24),('9303','2013-10-17','12:50:00',3.25),('9303','2013-10-17','12:55:00',3.29),('9303','2013-10-17','13:00:00',3.28),('9303','2013-10-17','13:05:00',3.25),('9303','2013-10-17','13:10:00',3.31),('9303','2013-10-17','13:15:00',3.34),('9303','2013-10-17','13:20:00',3.26),('9303','2013-10-17','13:25:00',3.19),('9303','2013-10-17','13:30:00',3.18),('9303','2013-10-17','13:35:00',3.15),('9303','2013-10-17','13:40:00',3.13),('9303','2013-10-17','13:45:00',3.12),('9303','2013-10-17','13:50:00',3.12),('9303','2013-10-17','13:55:00',3.13),('9303','2013-10-17','14:00:00',3.05),('9303','2013-10-17','14:05:00',2.99),('9303','2013-10-17','14:10:00',2.97),('9303','2013-10-17','14:15:00',2.92),('9303','2013-10-17','14:20:00',2.82),('9303','2013-10-17','14:25:00',2.74),('9303','2013-10-17','14:30:00',2.72),('9303','2013-10-17','14:35:00',2.72),('9303','2013-10-17','14:40:00',2.72),('9303','2013-10-17','14:45:00',2.72),('9303','2013-10-17','14:50:00',2.67),('9303','2013-10-17','14:55:00',2.62),('9303','2013-10-17','15:00:00',2.56),('9303','2013-10-17','15:05:00',2.51),('9303','2013-10-17','15:10:00',2.47),('9303','2013-10-17','15:15:00',2.43),('9303','2013-10-17','15:20:00',2.36),('9303','2013-10-17','15:25:00',2.34),('9303','2013-10-17','15:30:00',2.32),('9303','2013-10-17','15:35:00',2.27),('9303','2013-10-17','15:40:00',2.22),('9303','2013-10-17','15:45:00',2.16),('9303','2013-10-17','15:50:00',2.08),('9303','2013-10-17','15:55:00',2.01),('9303','2013-10-17','16:00:00',1.88),('9303','2013-10-17','16:05:00',1.77),('9303','2013-10-17','16:10:00',1.7),('9303','2013-10-17','16:15:00',1.62),('9303','2013-10-17','16:20:00',1.54),('9303','2013-10-17','16:25:00',1.44),('9303','2013-10-17','16:30:00',1.31),('9303','2013-10-17','16:35:00',1.19),('9303','2013-10-17','16:40:00',1.08),('9303','2013-10-16','09:45:00',1.24),('9303','2013-10-16','09:50:00',1.34),('9303','2013-10-16','11:15:00',1.33),('9303','2013-10-16','11:55:00',1.04),('9303','2013-10-16','12:15:00',2.22),('9303','2013-10-16','12:20:00',2.53),('9303','2013-10-16','12:25:00',1.1),('9303','2013-10-16','12:35:00',1.48),('9303','2013-10-16','12:40:00',3.58),('9303','2013-10-16','12:45:00',3.28),('9303','2013-10-16','12:50:00',2.97),('9303','2013-10-16','12:55:00',2.69),('9303','2013-10-16','13:00:00',2.61),('9303','2013-10-16','13:05:00',3.29),('9303','2013-10-16','13:10:00',2.3),('9303','2013-10-16','13:15:00',2.56),('9303','2013-10-16','13:20:00',2.7),('9303','2013-10-16','13:25:00',3.34),('9303','2013-10-16','13:30:00',3.08),('9303','2013-10-16','13:35:00',3.2),('9303','2013-10-16','13:40:00',3.23),('9303','2013-10-16','13:45:00',3.14),('9303','2013-10-16','13:50:00',3.05),('9303','2013-10-16','13:55:00',3.3),('9303','2013-10-16','14:00:00',2.75),('9303','2013-10-16','14:05:00',2.09),('9303','2013-10-16','14:10:00',2.75),('9303','2013-10-16','14:15:00',2.65),('9303','2013-10-16','14:20:00',2.81),('9303','2013-10-16','14:25:00',1.74),('9303','2013-10-16','14:30:00',2.2),('9303','2013-10-16','14:35:00',1.88),('9303','2013-10-16','14:40:00',2.47),('9303','2013-10-16','14:45:00',2.83),('9303','2013-10-16','14:50:00',2.72),('9303','2013-10-16','14:55:00',2.32),('9303','2013-10-16','15:00:00',2.56),('9303','2013-10-16','15:05:00',2.57),('9303','2013-10-16','15:10:00',2.61),('9303','2013-10-16','15:15:00',2.49),('9303','2013-10-16','15:20:00',2.42),('9303','2013-10-16','15:25:00',1.75),('9303','2013-10-16','15:35:00',2.04),('9303','2013-10-16','15:40:00',2.38),('9303','2013-10-16','15:45:00',2.17),('9303','2013-10-16','15:50:00',2.1),('9303','2013-10-16','15:55:00',2.03),('9303','2013-10-16','16:00:00',1.92),('9303','2013-10-16','16:05:00',1.8),('9303','2013-10-16','16:10:00',1.68),('9303','2013-10-16','16:15:00',1.63),('9303','2013-10-16','16:20:00',1.55),('9303','2013-10-16','16:25:00',1.45),('9303','2013-10-16','16:30:00',1.31),('9303','2013-10-16','16:35:00',1.23),('9303','2013-10-16','16:40:00',1.14),('9303','2013-10-16','16:45:00',1),('9303','2013-10-15','09:25:00',1.03),('9303','2013-10-15','09:30:00',1.47),('9303','2013-10-15','09:40:00',1.34),('9303','2013-10-15','09:45:00',1.84),('9303','2013-10-15','09:50:00',2.06),('9303','2013-10-15','09:55:00',2.16),('9303','2013-10-15','10:00:00',2.15),('9303','2013-10-15','10:05:00',2.3),('9303','2013-10-15','10:10:00',1.78),('9303','2013-10-15','10:15:00',1.13),('9303','2013-10-15','10:20:00',1.08),('9303','2013-10-15','10:25:00',1.2),('9303','2013-10-15','10:30:00',1.7),('9303','2013-10-15','10:35:00',1.35),('9303','2013-10-15','10:40:00',1.77),('9303','2013-10-15','10:45:00',2.02),('9303','2013-10-15','10:50:00',1.96),('9303','2013-10-15','10:55:00',1.67),('9303','2013-10-15','11:00:00',1.7),('9303','2013-10-15','11:05:00',1.77),('9303','2013-10-15','11:10:00',2.4),('9303','2013-10-15','11:15:00',2.57),('9303','2013-10-15','11:20:00',2.62),('9303','2013-10-15','11:25:00',2.47),('9303','2013-10-15','11:30:00',2.52),('9303','2013-10-15','11:35:00',2.13),('9303','2013-10-15','11:40:00',1.71),('9303','2013-10-15','11:45:00',1.43),('9303','2013-10-15','11:50:00',1.37),('9303','2013-10-15','11:55:00',1.34),('9303','2013-10-15','12:00:00',1.39),('9303','2013-10-15','12:05:00',1.39),('9303','2013-10-15','12:10:00',1.4),('9303','2013-10-15','12:15:00',1.39),('9303','2013-10-15','12:20:00',1.46),('9303','2013-10-15','12:25:00',1.34),('9303','2013-10-15','12:30:00',1.21),('9303','2013-10-15','12:35:00',1.19),('9303','2013-10-15','12:40:00',1.16),('9303','2013-10-15','12:45:00',1.29),('9303','2013-10-15','12:50:00',1.21),('9303','2013-10-15','12:55:00',1.08),('9303','2013-10-15','13:00:00',1.08),('9303','2013-10-15','13:05:00',1.39),('9303','2013-10-15','13:10:00',1.73),('9303','2013-10-15','13:15:00',1.76),('9303','2013-10-15','13:20:00',2.49),('9303','2013-10-15','13:25:00',2.85),('9303','2013-10-15','13:30:00',1.78),('9303','2013-10-15','13:35:00',1.56),('9303','2013-10-15','13:40:00',1.43),('9303','2013-10-15','13:45:00',1.5),('9303','2013-10-15','13:50:00',1.34),('9303','2013-10-15','13:55:00',1.21),('9303','2013-10-15','14:00:00',1.09),('9303','2013-10-15','14:05:00',1.07),('9303','2013-10-15','14:10:00',1.18),('9303','2013-10-15','14:15:00',1.61),('9303','2013-10-15','14:20:00',1.87),('9303','2013-10-15','14:25:00',2.03),('9303','2013-10-15','14:30:00',1.94),('9303','2013-10-15','14:35:00',1.29),('9303','2013-10-15','14:40:00',1.82),('9303','2013-10-15','14:45:00',2),('9303','2013-10-15','14:50:00',2.16),('9303','2013-10-15','14:55:00',1.9),('9303','2013-10-15','15:00:00',1.23),('9303','2013-10-15','15:05:00',1.25),('9303','2013-10-15','15:10:00',1.32),('9303','2013-10-15','15:15:00',1.19),('9303','2013-10-15','15:20:00',1.06),('9303','2013-10-15','16:30:00',1.01),('9303','2013-10-15','16:35:00',1.06),('9303','2013-10-14','08:55:00',1.09),('9303','2013-10-14','09:05:00',1.03),('9303','2013-10-14','09:25:00',1.53),('9303','2013-10-14','09:30:00',1.74),('9303','2013-10-14','09:35:00',1.69),('9303','2013-10-14','09:40:00',1.45),('9303','2013-10-14','09:45:00',1.29),('9303','2013-10-14','09:50:00',1.6),('9303','2013-10-14','09:55:00',1.92),('9303','2013-10-14','10:00:00',1.87),('9303','2013-10-14','10:05:00',2.03),('9303','2013-10-14','10:10:00',2.14),('9303','2013-10-14','10:15:00',2.23),('9303','2013-10-14','10:20:00',2.26),('9303','2013-10-14','10:25:00',2.28),('9303','2013-10-14','10:30:00',2.32),('9303','2013-10-14','10:35:00',2.32),('9303','2013-10-14','10:40:00',2.28),('9303','2013-10-14','10:45:00',2.37),('9303','2013-10-14','10:50:00',2.47),('9303','2013-10-14','10:55:00',2.52),('9303','2013-10-14','11:00:00',2.57),('9303','2013-10-14','11:05:00',2.58),('9303','2013-10-14','11:10:00',2.68),('9303','2013-10-14','11:15:00',2.68),('9303','2013-10-14','11:20:00',2.69),('9303','2013-10-14','11:25:00',2.76),('9303','2013-10-14','11:30:00',2.84),('9303','2013-10-14','11:35:00',2.79),('9303','2013-10-14','11:40:00',2.82),('9303','2013-10-14','11:45:00',2.78),('9303','2013-10-14','11:50:00',2.81),('9303','2013-10-14','11:55:00',2.87),('9303','2013-10-14','12:00:00',2.86),('9303','2013-10-14','12:05:00',2.87),('9303','2013-10-14','12:10:00',2.97),('9303','2013-10-14','12:15:00',2.9),('9303','2013-10-14','12:20:00',2.73),('9303','2013-10-14','12:25:00',2.87),('9303','2013-10-14','12:30:00',2.99),('9303','2013-10-14','12:35:00',2.97),('9303','2013-10-14','12:40:00',3.03),('9303','2013-10-14','12:45:00',3.02),('9303','2013-10-14','12:50:00',2.99),('9303','2013-10-14','12:55:00',3.06),('9303','2013-10-14','13:00:00',3.08),('9303','2013-10-14','13:05:00',3.07),('9303','2013-10-14','13:10:00',3.11),('9303','2013-10-14','13:15:00',3.09),('9303','2013-10-14','13:20:00',3),('9303','2013-10-14','13:25:00',2.96),('9303','2013-10-14','13:30:00',2.94),('9303','2013-10-14','13:35:00',2.92),('9303','2013-10-14','13:40:00',2.92),('9303','2013-10-14','13:45:00',2.92),('9303','2013-10-14','13:50:00',2.91),('9303','2013-10-14','13:55:00',2.88),('9303','2013-10-14','14:00:00',2.85),('9303','2013-10-14','14:05:00',2.83),('9303','2013-10-14','14:10:00',2.8),('9303','2013-10-14','14:15:00',2.78),('9303','2013-10-14','14:20:00',2.69),('9303','2013-10-14','14:25:00',2.64),('9303','2013-10-14','14:30:00',2.57),('9303','2013-10-14','14:35:00',2.56),('9303','2013-10-14','14:40:00',2.61),('9303','2013-10-14','14:45:00',2.59),('9303','2013-10-14','14:50:00',2.53),('9303','2013-10-14','14:55:00',2.46),('9303','2013-10-14','15:00:00',2.39),('9303','2013-10-14','15:05:00',2.33),('9303','2013-10-14','15:10:00',2.28),('9303','2013-10-14','15:15:00',2.26),('9303','2013-10-14','15:20:00',2.21),('9303','2013-10-14','15:25:00',2.16),('9303','2013-10-14','15:30:00',2.1),('9303','2013-10-14','15:35:00',2.05),('9303','2013-10-14','15:40:00',1.79),('9303','2013-10-14','15:45:00',1.59),('9303','2013-10-14','15:50:00',1.4),('9303','2013-10-14','15:55:00',1.08),('9303','2013-10-14','16:00:00',1.33),('9303','2013-10-14','16:05:00',1.05),('9303','2013-10-13','09:00:00',1.01),('9303','2013-10-13','09:05:00',1.05),('9303','2013-10-13','09:15:00',1.53),('9303','2013-10-13','09:20:00',1.68),('9303','2013-10-13','09:25:00',1.56),('9303','2013-10-13','09:30:00',1.09),('9303','2013-10-13','09:35:00',1.35),('9303','2013-10-13','09:40:00',1.79),('9303','2013-10-13','09:45:00',2.58),('9303','2013-10-13','09:50:00',2.49),('9303','2013-10-13','09:55:00',2.57),('9303','2013-10-13','10:00:00',2.01),('9303','2013-10-13','10:05:00',1.43),('9303','2013-10-13','10:10:00',1.86),('9303','2013-10-13','10:15:00',2.14),('9303','2013-10-13','10:20:00',1.77),('9303','2013-10-13','10:25:00',1.89),('9303','2013-10-13','10:30:00',2.22),('9303','2013-10-13','10:35:00',2.74),('9303','2013-10-13','10:40:00',2.92),('9303','2013-10-13','10:45:00',2.97),('9303','2013-10-13','10:50:00',2.74),('9303','2013-10-13','10:55:00',1.98),('9303','2013-10-13','11:00:00',2.6),('9303','2013-10-13','11:05:00',2.71),('9303','2013-10-13','11:10:00',2.88),('9303','2013-10-13','11:15:00',2.96),('9303','2013-10-13','11:20:00',2.84),('9303','2013-10-13','11:25:00',2.78),('9303','2013-10-13','11:30:00',2.87),('9303','2013-10-13','11:35:00',2.84),('9303','2013-10-13','11:40:00',2.86),('9303','2013-10-13','11:45:00',2.88),('9303','2013-10-13','11:50:00',2.91),('9303','2013-10-13','11:55:00',2.94),('9303','2013-10-13','12:00:00',2.93),('9303','2013-10-13','12:05:00',2.95),('9303','2013-10-13','12:10:00',2.99),('9303','2013-10-13','12:15:00',2.99),('9303','2013-10-13','12:20:00',2.99),('9303','2013-10-13','12:25:00',2.92),('9303','2013-10-13','12:30:00',3.01),('9303','2013-10-13','12:35:00',3.05),('9303','2013-10-13','12:40:00',3.08),('9303','2013-10-13','12:45:00',3.03),('9303','2013-10-13','12:50:00',3),('9303','2013-10-13','12:55:00',3.07),('9303','2013-10-13','13:00:00',3.08),('9303','2013-10-13','13:05:00',3.06),('9303','2013-10-13','13:10:00',3.13),('9303','2013-10-13','13:15:00',3.17),('9303','2013-10-13','13:20:00',3.15),('9303','2013-10-13','13:25:00',2.76),('9303','2013-10-13','13:30:00',2.26),('9303','2013-10-13','13:35:00',2.75),('9303','2013-10-13','13:40:00',1.72),('9303','2013-10-13','13:45:00',1.94),('9303','2013-10-13','13:50:00',2.1),('9303','2013-10-13','13:55:00',2.23),('9303','2013-10-13','14:00:00',2.88),('9303','2013-10-13','14:05:00',2.94),('9303','2013-10-13','14:10:00',2.91),('9303','2013-10-13','14:15:00',2.7),('9303','2013-10-13','14:20:00',2.91),('9303','2013-10-13','14:25:00',2.88),('9303','2013-10-13','14:30:00',2.65),('9303','2013-10-13','14:35:00',1.93),('9303','2013-10-13','14:40:00',2.5),('9303','2013-10-13','14:45:00',2.08),('9303','2013-10-13','14:50:00',1.6),('9303','2013-10-13','14:55:00',1.92),('9303','2013-10-13','15:00:00',2.3),('9303','2013-10-13','15:05:00',2.22),('9303','2013-10-13','15:10:00',1.54),('9303','2013-10-13','15:15:00',1.64),('9303','2013-10-13','15:20:00',1.95),('9303','2013-10-13','15:25:00',2.08),('9303','2013-10-13','15:30:00',1.6),('9303','2013-10-13','15:35:00',1.44),('9303','2013-10-13','15:40:00',1.42),('9303','2013-10-13','15:45:00',1.32),('9303','2013-10-13','15:50:00',1.28),('9303','2013-10-13','15:55:00',1.21),('9303','2013-10-13','16:00:00',1.32),('9303','2013-10-13','16:05:00',1.58),('9303','2013-10-13','16:10:00',1.32),('9303','2013-10-13','16:15:00',1.12),('9303','2013-10-13','16:20:00',1.17),('9303','2013-10-13','16:25:00',1.56),('9303','2013-10-13','16:30:00',1.55),('9303','2013-10-13','16:35:00',1.26),('9303','2013-10-12','11:25:00',1.08),('9303','2013-10-12','11:30:00',1.26),('9303','2013-10-12','11:35:00',1.72),('9303','2013-10-12','11:40:00',2.79),('9303','2013-10-12','11:45:00',1.49),('9303','2013-10-12','11:50:00',1.33),('9303','2013-10-12','11:55:00',1.16),('9303','2013-10-12','12:20:00',1.67),('9303','2013-10-12','12:25:00',3.32),('9303','2013-10-12','12:30:00',2.41),('9303','2013-10-12','12:35:00',2.83),('9303','2013-10-12','12:40:00',2.87),('9303','2013-10-12','12:45:00',2.74),('9303','2013-10-12','12:50:00',2.78),('9303','2013-10-12','12:55:00',2.44),('9303','2013-10-12','13:00:00',2.11),('9303','2013-10-12','13:05:00',1.14),('9303','2013-10-12','13:20:00',1.27),('9303','2013-10-12','13:25:00',1.36),('9303','2013-10-12','13:30:00',3.11),('9303','2013-10-12','13:35:00',1.49),('9303','2013-10-12','16:00:00',1.05),('9303','2013-10-12','16:10:00',1.02),('9303','2013-10-12','16:15:00',1.62),('9303','2013-10-12','16:20:00',1.37),('9303','2013-10-11','09:20:00',1.06),('9303','2013-10-11','09:25:00',1.17),('9303','2013-10-11','09:35:00',1.33),('9303','2013-10-11','09:45:00',2.14),('9303','2013-10-11','09:50:00',2.19),('9303','2013-10-11','09:55:00',2.25),('9303','2013-10-11','10:00:00',2.29),('9303','2013-10-11','10:05:00',2.33),('9303','2013-10-11','10:10:00',2.38),('9303','2013-10-11','10:15:00',2.08),('9303','2013-10-11','10:20:00',2.13),('9303','2013-10-11','10:25:00',1.84),('9303','2013-10-11','10:30:00',2.56),('9303','2013-10-11','10:35:00',2.79),('9303','2013-10-11','10:40:00',1.54),('9303','2013-10-11','11:05:00',2.17),('9303','2013-10-11','11:10:00',2.13),('9303','2013-10-11','11:15:00',1),('9303','2013-10-11','11:35:00',1.16),('9303','2013-10-11','11:40:00',1.78),('9303','2013-10-11','11:45:00',1.64),('9303','2013-10-11','11:50:00',1.85),('9303','2013-10-11','11:55:00',1.71),('9303','2013-10-11','12:00:00',2.42),('9303','2013-10-11','12:05:00',3.76),('9303','2013-10-11','12:10:00',1.57),('9303','2013-10-11','12:15:00',1.09),('9303','2013-10-11','12:25:00',1.04),('9303','2013-10-11','12:30:00',1.76),('9303','2013-10-11','13:05:00',2.66),('9303','2013-10-11','13:10:00',1.43),('9303','2013-10-11','13:15:00',1.11),('9303','2013-10-11','13:20:00',1.4),('9303','2013-10-11','13:25:00',3.9),('9303','2013-10-11','13:30:00',1.46),('9303','2013-10-11','13:40:00',2.34),('9303','2013-10-11','13:45:00',3),('9303','2013-10-11','13:50:00',1.18),('9303','2013-10-11','15:40:00',1.17),('9303','2013-10-11','15:45:00',1.12),('9303','2013-10-11','16:00:00',2.14),('9303','2013-10-11','16:35:00',1.24),('9303','2013-10-10','08:50:00',1.16),('9303','2013-10-10','08:55:00',1.32),('9303','2013-10-10','09:00:00',1.1),('9303','2013-10-10','09:10:00',1.51),('9303','2013-10-10','09:15:00',1.67),('9303','2013-10-10','09:20:00',1.72),('9303','2013-10-10','09:25:00',1.74),('9303','2013-10-10','09:30:00',1.82),('9303','2013-10-10','09:35:00',1.51),('9303','2013-10-10','09:40:00',1.82),('9303','2013-10-10','09:45:00',1.41),('9303','2013-10-10','10:00:00',1.1),('9303','2013-10-10','10:10:00',1.14),('9303','2013-10-10','10:15:00',2.46),('9303','2013-10-10','10:20:00',2.42),('9303','2013-10-10','10:25:00',2.37),('9303','2013-10-10','10:30:00',2.21),('9303','2013-10-10','10:40:00',1.29),('9303','2013-10-10','10:45:00',1.57),('9303','2013-10-10','10:50:00',2.17),('9303','2013-10-10','10:55:00',1.5),('9303','2013-10-10','11:05:00',1.62),('9303','2013-10-10','11:25:00',2.65),('9303','2013-10-10','11:30:00',2.12),('9303','2013-10-10','11:50:00',1.25),('9303','2013-10-10','11:55:00',3.25),('9303','2013-10-10','12:00:00',3.43),('9303','2013-10-10','12:05:00',3.41),('9303','2013-10-10','12:10:00',1.6),('9303','2013-10-10','12:25:00',3.2),('9303','2013-10-10','12:35:00',2.58),('9303','2013-10-10','12:40:00',3.76),('9303','2013-10-10','12:45:00',3.08),('9303','2013-10-10','12:50:00',1.8),('9303','2013-10-10','12:55:00',1.41),('9303','2013-10-10','13:00:00',3.66),('9303','2013-10-10','13:05:00',3.89),('9303','2013-10-10','13:10:00',3.6),('9303','2013-10-10','13:15:00',3.04),('9303','2013-10-10','13:20:00',1.57),('9303','2013-10-10','13:25:00',2.21),('9303','2013-10-10','13:30:00',2.89),('9303','2013-10-10','13:35:00',1.69),('9303','2013-10-10','13:40:00',1.16),('9303','2013-10-10','13:45:00',3.95),('9303','2013-10-10','13:50:00',3.54),('9303','2013-10-10','13:55:00',3.43),('9303','2013-10-10','14:00:00',3.33),('9303','2013-10-10','14:05:00',2.93),('9303','2013-10-10','14:10:00',2.26),('9303','2013-10-10','14:15:00',1.88),('9303','2013-10-10','14:20:00',3.04),('9303','2013-10-10','14:25:00',3.31),('9303','2013-10-10','14:30:00',3.37),('9303','2013-10-10','14:35:00',2.86),('9303','2013-10-10','14:40:00',3.21),('9303','2013-10-10','14:45:00',3.04),('9303','2013-10-10','14:50:00',2.96),('9303','2013-10-10','14:55:00',2.92),('9303','2013-10-10','15:00:00',2.24),('9303','2013-10-10','15:05:00',3),('9303','2013-10-10','15:10:00',2.83),('9303','2013-10-10','15:15:00',2.29),('9303','2013-10-10','15:20:00',1.87),('9303','2013-10-10','15:25:00',1.7),('9303','2013-10-10','15:30:00',2.4),('9303','2013-10-10','15:35:00',1.55),('9303','2013-10-10','15:40:00',1.12),('9303','2013-10-10','15:45:00',1.01),('9303','2013-10-10','16:15:00',1.2),('9303','2013-10-10','16:20:00',1.33),('9303','2013-10-10','16:25:00',1.36),('9303','2013-10-10','16:30:00',1.34),('9303','2013-10-10','16:45:00',1.38),('9303','2013-10-10','16:50:00',1.22),('9303','2013-10-10','16:55:00',1.18),('9303','2013-10-10','17:00:00',1.08),('9303','2013-10-09','08:40:00',1.06),('9303','2013-10-09','08:45:00',1.11),('9303','2013-10-09','08:50:00',1.21),('9303','2013-10-09','08:55:00',1.29),('9303','2013-10-09','09:00:00',1.39),('9303','2013-10-09','09:05:00',1.49),('9303','2013-10-09','09:10:00',1.58),('9303','2013-10-09','09:15:00',1.55),('9303','2013-10-09','09:20:00',1.48),('9303','2013-10-09','09:25:00',1.85),('9303','2013-10-09','09:30:00',1.93),('9303','2013-10-09','09:35:00',2),('9303','2013-10-09','09:40:00',2.12),('9303','2013-10-09','09:45:00',2.2),('9303','2013-10-09','09:50:00',2.26),('9303','2013-10-09','09:55:00',2.36),('9303','2013-10-09','10:00:00',2.51),('9303','2013-10-09','10:05:00',2.51),('9303','2013-10-09','10:10:00',2.47),('9303','2013-10-09','10:15:00',1.27),('9303','2013-10-09','10:30:00',1.25),('9303','2013-10-09','10:35:00',1.56),('9303','2013-10-09','10:40:00',1.24),('9303','2013-10-09','10:45:00',1.77),('9303','2013-10-09','10:50:00',3.48),('9303','2013-10-09','10:55:00',2.45),('9303','2013-10-09','11:00:00',2.48),('9303','2013-10-09','11:05:00',3.34),('9303','2013-10-09','11:10:00',3.58),('9303','2013-10-09','11:15:00',3.54),('9303','2013-10-09','11:20:00',3.3),('9303','2013-10-09','11:25:00',2.75),('9303','2013-10-09','11:30:00',3.46),('9303','2013-10-09','11:35:00',3.68),('9303','2013-10-09','11:40:00',3.48),('9303','2013-10-09','11:45:00',3.02),('9303','2013-10-09','11:50:00',2.87),('9303','2013-10-09','11:55:00',3.15),('9303','2013-10-09','12:00:00',2.38),('9303','2013-10-09','12:05:00',1.09),('9303','2013-10-09','12:10:00',2.18),('9303','2013-10-09','12:15:00',3.69),('9303','2013-10-09','12:20:00',3.92),('9303','2013-10-09','12:25:00',3),('9303','2013-10-09','12:30:00',1.3),('9303','2013-10-09','12:35:00',1.5),('9303','2013-10-09','12:40:00',1.34),('9303','2013-10-09','13:15:00',1.43),('9303','2013-10-09','13:20:00',1.66),('9303','2013-10-09','13:25:00',2.38),('9303','2013-10-09','13:30:00',2.5),('9303','2013-10-09','13:35:00',1.75),('9303','2013-10-09','13:40:00',3.08),('9303','2013-10-09','13:45:00',2.57),('9303','2013-10-09','13:50:00',2.65),('9303','2013-10-09','13:55:00',2.81),('9303','2013-10-09','14:00:00',3.57),('9303','2013-10-09','14:05:00',1.63),('9303','2013-10-09','14:10:00',1.7),('9303','2013-10-09','14:55:00',2.56),('9303','2013-10-09','15:00:00',1.11),('9303','2013-10-09','15:05:00',3),('9303','2013-10-09','15:10:00',2.97),('9303','2013-10-09','15:15:00',2.78),('9303','2013-10-09','15:20:00',2.59),('9303','2013-10-09','15:25:00',2.56),('9303','2013-10-09','15:30:00',2.31),('9303','2013-10-09','15:35:00',1.4),('9303','2013-10-09','15:40:00',1.79),('9303','2013-10-09','15:45:00',1.2),('9303','2013-10-09','15:50:00',1.47),('9303','2013-10-09','16:15:00',1.22),('9303','2013-10-09','16:20:00',1.42),('9303','2013-10-09','16:25:00',1.47),('9303','2013-10-09','16:30:00',2.14),('9303','2013-10-09','16:35:00',1.22),('9303','2013-10-09','16:40:00',1.64),('9303','2014-04-15','09:00:00',1.79),('9303','2014-04-15','09:05:00',2.05),('9303','2014-04-15','09:10:00',1.11),('9303','2014-04-15','09:15:00',2.11),('9303','2014-04-15','09:20:00',2.24),('9303','2014-04-15','09:25:00',2.54),('9303','2014-04-15','09:30:00',2.19),('9303','2014-04-15','09:45:00',1.02),('9303','2014-04-15','09:50:00',2.84),('9303','2014-04-15','10:00:00',1.16),('9303','2014-04-15','10:05:00',1.24),('9303','2014-04-15','10:10:00',1.57),('9303','2014-04-15','10:15:00',1.96),('9303','2014-04-15','10:20:00',1.65),('9303','2014-04-15','10:25:00',1.34),('9303','2014-04-15','10:30:00',2.46),('9303','2014-04-15','10:35:00',2.6),('9303','2014-04-15','10:40:00',2.18),('9303','2014-04-15','10:45:00',2.99),('9303','2014-04-15','10:50:00',2.63),('9303','2014-04-15','10:55:00',1.5),('9303','2014-04-15','11:00:00',1.38),('9303','2014-04-15','11:05:00',3.55),('9303','2014-04-15','11:10:00',2.39),('9303','2014-04-15','11:15:00',1.34),('9303','2014-04-15','11:25:00',1.4),('9303','2014-04-15','11:30:00',1.05),('9303','2014-04-15','11:50:00',1.27),('9303','2014-04-15','12:15:00',1.56),('9303','2014-04-15','12:20:00',1.67),('9303','2014-04-15','13:10:00',1.41),('9303','2014-04-15','13:15:00',1.74),('9303','2014-04-15','13:20:00',2.55),('9303','2014-04-15','13:25:00',1.6),('9303','2014-04-15','13:30:00',2.73),('9303','2014-04-15','13:35:00',2.64),('9303','2014-04-15','13:40:00',1.99),('9303','2014-04-15','13:45:00',1.05),('9303','2014-04-15','14:00:00',2.22),('9303','2014-04-15','14:05:00',2.09),('9303','2014-04-15','14:10:00',1.57),('9303','2014-04-15','14:15:00',3.75),('9303','2014-04-15','14:20:00',3.01),('9303','2014-04-15','14:25:00',3.38),('9303','2014-04-15','14:30:00',2.29),('9303','2014-04-15','14:35:00',1.66),('9303','2014-04-15','14:40:00',1.68),('9303','2014-04-15','14:45:00',2.11),('9303','2014-04-15','14:50:00',2.07),('9303','2014-04-15','14:55:00',1.57),('9303','2014-04-15','15:10:00',1.03),('9303','2014-04-15','15:15:00',1.82),('9303','2014-04-15','15:20:00',1.65),('9303','2014-04-15','15:25:00',2.13),('9303','2014-04-15','15:30:00',1.48),('9303','2014-04-15','15:35:00',1.39),('9303','2014-04-15','15:40:00',1.38),('9303','2014-04-15','15:45:00',1.28),('9303','2014-04-15','15:50:00',1.33),('9303','2014-04-15','15:55:00',1.32),('9303','2014-04-15','16:00:00',1.3),('9303','2014-04-15','16:05:00',1.28),('9303','2013-10-08','08:20:00',1.01),('9303','2013-10-08','10:00:00',1.07),('9303','2013-10-08','11:00:00',1.87),('9303','2013-10-08','11:05:00',1.14),('9303','2013-10-08','11:10:00',1.94),('9303','2013-10-08','11:15:00',3.56),('9303','2013-10-08','11:20:00',3.48),('9303','2013-10-08','11:25:00',1.83),('9303','2013-10-08','11:30:00',3),('9303','2013-10-08','11:35:00',1.71),('9303','2013-10-08','11:40:00',1.47),('9303','2013-10-08','11:45:00',1.36),('9303','2013-10-08','12:20:00',1.04),('9303','2013-10-08','12:25:00',1.39),('9303','2013-10-08','12:30:00',2.87),('9303','2013-10-08','12:35:00',1.87),('9303','2013-10-08','12:40:00',3.8),('9303','2013-10-08','12:45:00',3.54),('9303','2013-10-08','12:50:00',3.56),('9303','2013-10-08','12:55:00',3.73),('9303','2013-10-08','13:00:00',3.54),('9303','2013-10-08','13:05:00',3.16),('9303','2013-10-08','13:10:00',1.9),('9303','2013-10-08','13:15:00',3.53),('9303','2013-10-08','13:20:00',1.59),('9303','2013-10-08','13:25:00',2.71),('9303','2013-10-08','13:30:00',1.55),('9303','2013-10-08','13:35:00',1.17),('9303','2013-10-08','13:40:00',1.08),('9303','2013-10-08','14:05:00',1.38),('9303','2013-10-08','14:10:00',1.96),('9303','2013-10-08','14:15:00',2.13),('9303','2013-10-08','14:20:00',2.56),('9303','2013-10-08','14:25:00',2.59),('9303','2013-10-08','14:30:00',2.53),('9303','2013-10-08','14:35:00',1.12),('9303','2013-10-08','14:40:00',1.34),('9303','2013-10-08','14:45:00',2.85),('9303','2013-10-08','14:50:00',2.95),('9303','2013-10-08','14:55:00',2.95),('9303','2013-10-08','15:00:00',2.84),('9303','2013-10-08','15:05:00',2.72),('9303','2013-10-08','15:10:00',2.6),('9303','2013-10-08','15:15:00',2.82),('9303','2013-10-08','15:20:00',2.02),('9303','2013-10-08','15:25:00',2.97),('9303','2013-10-08','15:30:00',3.29),('9303','2013-10-08','15:35:00',2.94),('9303','2013-10-08','15:40:00',2.29),('9303','2013-10-08','15:45:00',1.47),('9303','2013-10-08','15:50:00',2.16),('9303','2013-10-08','15:55:00',1.38),('9303','2013-10-07','08:35:00',1.07),('9303','2013-10-07','08:40:00',1.3),('9303','2013-10-07','09:00:00',1.77),('9303','2013-10-07','09:05:00',1.72),('9303','2013-10-07','09:10:00',1.66),('9303','2013-10-07','09:15:00',1.72),('9303','2013-10-07','09:20:00',1.78),('9303','2013-10-07','09:25:00',1.84),('9303','2013-10-07','09:30:00',1.93),('9303','2013-10-07','09:35:00',1.98),('9303','2013-10-07','09:40:00',2.08),('9303','2013-10-07','09:45:00',2.14),('9303','2013-10-07','09:50:00',2.22),('9303','2013-10-07','09:55:00',2.27),('9303','2013-10-07','10:00:00',2.33),('9303','2013-10-07','10:05:00',2.39),('9303','2013-10-07','10:10:00',2.3),('9303','2013-10-07','10:15:00',2.19),('9303','2013-10-07','10:20:00',2.38),('9303','2013-10-07','10:25:00',2.5),('9303','2013-10-07','10:30:00',2.55),('9303','2013-10-07','10:35:00',2.68),('9303','2013-10-07','10:40:00',2.68),('9303','2013-10-07','10:45:00',2.74),('9303','2013-10-07','10:50:00',2.73),('9303','2013-10-07','10:55:00',2.21),('9303','2013-10-07','11:00:00',2.65),('9303','2013-10-07','11:05:00',2.84),('9303','2013-10-07','11:10:00',1.99),('9303','2013-10-07','11:15:00',2.07),('9303','2013-10-07','11:20:00',2.94),('9303','2013-10-07','11:25:00',3.06),('9303','2013-10-07','11:30:00',3.03),('9303','2013-10-07','11:35:00',3.07),('9303','2013-10-07','11:40:00',3.13),('9303','2013-10-07','11:45:00',3.11),('9303','2013-10-07','11:50:00',3.13),('9303','2013-10-07','11:55:00',3.2),('9303','2013-10-07','12:00:00',3.16),('9303','2013-10-07','12:05:00',3.23),('9303','2013-10-07','12:10:00',2.5),('9303','2013-10-07','12:15:00',2.44),('9303','2013-10-07','12:20:00',2.84),('9303','2013-10-07','12:25:00',3.27),('9303','2013-10-07','12:30:00',3.63),('9303','2013-10-07','12:35:00',3.42),('9303','2013-10-07','12:40:00',3.48),('9303','2013-10-07','12:45:00',3.51),('9303','2013-10-07','12:50:00',3.48),('9303','2013-10-07','12:55:00',3.66),('9303','2013-10-07','13:00:00',3.64),('9303','2013-10-07','13:05:00',3.57),('9303','2013-10-07','13:10:00',3.67),('9303','2013-10-07','13:15:00',2.06),('9303','2013-10-07','13:20:00',3.89),('9303','2013-10-07','13:25:00',3.37),('9303','2013-10-07','13:30:00',1.98),('9303','2013-10-07','13:35:00',1.34),('9303','2013-10-07','13:40:00',2.14),('9303','2013-10-07','13:45:00',2.03),('9303','2013-10-07','13:50:00',1.18),('9303','2013-10-07','13:55:00',3.92),('9303','2013-10-07','14:00:00',3.99),('9303','2013-10-07','14:05:00',2.27),('9303','2013-10-07','14:10:00',1.68),('9303','2013-10-07','14:20:00',1.03),('9303','2013-10-07','14:25:00',2.53),('9303','2013-10-07','14:35:00',3.22),('9303','2013-10-07','14:40:00',2.42),('9303','2013-10-07','14:45:00',3.48),('9303','2013-10-07','14:50:00',2.92),('9303','2013-10-07','14:55:00',3.47),('9303','2013-10-07','15:00:00',3.15),('9303','2013-10-07','15:05:00',1.75),('9303','2013-10-07','15:10:00',2.76),('9303','2013-10-07','15:15:00',1.36),('9303','2013-10-07','15:20:00',1.34),('9303','2013-10-07','15:25:00',2.31),('9303','2013-10-07','15:30:00',1.95),('9303','2013-10-07','15:35:00',1.78),('9303','2013-10-07','15:40:00',1.28),('9303','2013-10-07','15:45:00',2.91),('9303','2013-10-07','15:50:00',2.66),('9303','2013-10-07','15:55:00',1.37),('9303','2013-10-07','16:00:00',1.31),('9303','2013-10-07','16:05:00',1.67),('9303','2013-10-07','16:10:00',2.27),('9303','2013-10-07','16:15:00',2.1),('9303','2013-10-07','16:20:00',1.88),('9303','2013-10-07','16:25:00',1.13),('9303','2013-10-07','16:30:00',1.85),('9303','2013-10-07','16:35:00',1.27),('9303','2013-10-07','16:40:00',1.49),('9303','2013-10-07','16:45:00',1.53),('9303','2013-10-07','16:50:00',1.41),('9303','2013-10-07','16:55:00',1.29),('9303','2013-10-07','17:00:00',1.12),('9303','2013-10-06','09:05:00',1.02),('9303','2013-10-06','09:30:00',1.1),('9303','2013-10-06','09:35:00',1.52),('9303','2013-10-06','09:40:00',1.34),('9303','2013-10-06','09:45:00',1.1),('9303','2013-10-06','09:50:00',2.01),('9303','2013-10-06','09:55:00',2.36),('9303','2013-10-06','10:00:00',2.76),('9303','2013-10-06','10:05:00',2.8),('9303','2013-10-06','10:10:00',2.67),('9303','2013-10-06','10:15:00',2.45),('9303','2013-10-06','10:20:00',2.49),('9303','2013-10-06','10:25:00',2.77),('9303','2013-10-06','10:30:00',2.67),('9303','2013-10-06','10:35:00',2.66),('9303','2013-10-06','10:40:00',2.26),('9303','2013-10-06','10:45:00',1.84),('9303','2013-10-06','10:50:00',2.02),('9303','2013-10-06','10:55:00',2.19),('9303','2013-10-06','11:00:00',2.29),('9303','2013-10-06','11:05:00',2.54),('9303','2013-10-06','11:10:00',2.66),('9303','2013-10-06','11:15:00',2.64),('9303','2013-10-06','11:20:00',2.62),('9303','2013-10-06','11:25:00',2.75),('9303','2013-10-06','11:30:00',2.67),('9303','2013-10-06','11:35:00',2.61),('9303','2013-10-06','11:40:00',2.58),('9303','2013-10-06','11:45:00',2.05),('9303','2013-10-06','11:50:00',1.77),('9303','2013-10-06','11:55:00',2.43),('9303','2013-10-06','12:00:00',2.41),('9303','2013-10-06','12:05:00',2.49),('9303','2013-10-06','12:10:00',3.15),('9303','2013-10-06','12:15:00',2.98),('9303','2013-10-06','12:20:00',2.95),('9303','2013-10-06','12:25:00',2.52),('9303','2013-10-06','12:30:00',2.38),('9303','2013-10-06','12:35:00',2.49),('9303','2013-10-06','12:40:00',2.4),('9303','2013-10-06','12:45:00',2.4),('9303','2013-10-06','12:50:00',2.66),('9303','2013-10-06','12:55:00',3.06),('9303','2013-10-06','13:00:00',2.91),('9303','2013-10-06','13:05:00',2.87),('9303','2013-10-06','13:10:00',2.66),('9303','2013-10-06','13:15:00',3.39),('9303','2013-10-06','13:20:00',3.02),('9303','2013-10-06','13:45:00',1.05),('9303','2013-10-06','13:50:00',3.06),('9303','2013-10-06','13:55:00',2.6),('9303','2013-10-06','14:00:00',1.92),('9303','2013-10-06','14:05:00',2.57),('9303','2013-10-06','14:10:00',2.98),('9303','2013-10-06','14:15:00',1.93),('9303','2013-10-06','14:20:00',1.66),('9303','2013-10-06','14:25:00',1.57),('9303','2013-10-06','14:30:00',1.77),('9303','2013-10-06','14:35:00',1.47),('9303','2013-10-06','14:40:00',1.29),('9303','2013-10-06','14:45:00',1.57),('9303','2013-10-06','14:50:00',1.62),('9303','2013-10-06','14:55:00',2.18),('9303','2013-10-06','15:00:00',1.91),('9303','2013-10-06','15:05:00',1.45),('9303','2013-10-06','15:10:00',1.17),('9303','2013-10-06','15:15:00',1.06),('9303','2013-10-05','16:05:00',1.12),('9303','2013-10-05','16:10:00',1.12),('9303','2013-10-04','09:40:00',1.02),('9303','2013-10-04','09:45:00',1.03),('9303','2013-10-04','09:50:00',1.26),('9303','2013-10-04','09:55:00',2.62),('9303','2013-10-04','10:00:00',1.96),('9303','2013-10-04','10:05:00',1.41),('9303','2013-10-04','10:10:00',1.45),('9303','2013-10-04','10:15:00',1.76),('9303','2013-10-04','10:20:00',1.39),('9303','2013-10-04','10:25:00',1.94),('9303','2013-10-04','10:30:00',1.99),('9303','2013-10-04','10:35:00',1.6),('9303','2013-10-04','10:40:00',2.5),('9303','2013-10-04','10:45:00',1.99),('9303','2013-10-04','10:50:00',1.74),('9303','2013-10-04','10:55:00',2.71),('9303','2013-10-04','11:00:00',2.24),('9303','2013-10-04','11:05:00',1.6),('9303','2013-10-04','11:10:00',1.61),('9303','2013-10-04','11:15:00',2.88),('9303','2013-10-04','11:20:00',2.91),('9303','2013-10-04','11:25:00',2.89),('9303','2013-10-04','11:30:00',3.49),('9303','2013-10-04','11:35:00',3.35),('9303','2013-10-04','11:40:00',3.42),('9303','2013-10-04','11:45:00',3.35),('9303','2013-10-04','11:50:00',3.3),('9303','2013-10-04','11:55:00',3.31),('9303','2013-10-04','12:00:00',3.35),('9303','2013-10-04','12:05:00',3.35),('9303','2013-10-04','12:10:00',3.4),('9303','2013-10-04','12:15:00',3.16),('9303','2013-10-04','12:20:00',3.34),('9303','2013-10-04','12:25:00',3.46),('9303','2013-10-04','12:30:00',3.37),('9303','2013-10-04','12:35:00',3.02),('9303','2013-10-04','12:40:00',3.37),('9303','2013-10-04','12:45:00',3.43),('9303','2013-10-04','12:50:00',3.32),('9303','2013-10-04','12:55:00',3.34),('9303','2013-10-04','13:00:00',3.44),('9303','2013-10-04','13:05:00',3.5),('9303','2013-10-04','13:10:00',3.52),('9303','2013-10-04','13:15:00',3.73),('9303','2013-10-04','13:20:00',3.62),('9303','2013-10-04','13:25:00',3.38),('9303','2013-10-04','13:30:00',3.61),('9303','2013-10-04','13:35:00',2.95),('9303','2013-10-04','13:40:00',3.42),('9303','2013-10-04','13:45:00',3.36),('9303','2013-10-04','13:50:00',3.31),('9303','2013-10-04','13:55:00',3.32),('9303','2013-10-04','14:00:00',3.34),('9303','2013-10-04','14:05:00',3.25),('9303','2013-10-04','14:10:00',2.94),('9303','2013-10-04','14:15:00',2.64),('9303','2013-10-04','14:20:00',2.92),('9303','2013-10-04','14:25:00',3.13),('9303','2013-10-04','14:30:00',2.74),('9303','2013-10-04','14:35:00',1.91),('9303','2013-10-04','14:40:00',1.59),('9303','2013-10-04','14:45:00',1.76),('9303','2013-10-04','14:50:00',2.35),('9303','2013-10-04','14:55:00',2.41),('9303','2013-10-04','15:00:00',2.09),('9303','2013-10-04','15:05:00',2.3),('9303','2013-10-04','15:10:00',2),('9303','2013-10-04','15:15:00',1.55),('9303','2013-10-04','15:20:00',1.39),('9303','2013-10-04','15:25:00',1.99),('9303','2013-10-04','15:30:00',2.54),('9303','2013-10-04','15:35:00',1.41),('9303','2013-10-04','16:05:00',1.01),('9303','2013-10-03','08:30:00',1),('9303','2013-10-03','08:35:00',1.11),('9303','2013-10-03','08:40:00',1.2),('9303','2013-10-03','08:45:00',1.3),('9303','2013-10-03','08:50:00',1.41),('9303','2013-10-03','08:55:00',1.5),('9303','2013-10-03','09:00:00',1.62),('9303','2013-10-03','09:05:00',1.7),('9303','2013-10-03','09:10:00',1.8),('9303','2013-10-03','09:15:00',1.89),('9303','2013-10-03','09:20:00',1.98),('9303','2013-10-03','09:25:00',2.06),('9303','2013-10-03','09:30:00',2.14),('9303','2013-10-03','09:35:00',2.23),('9303','2013-10-03','09:40:00',2.31),('9303','2013-10-03','09:45:00',2.39),('9303','2013-10-03','09:50:00',2.46),('9303','2013-10-03','09:55:00',2.52),('9303','2013-10-03','10:00:00',2.6),('9303','2013-10-03','10:05:00',2.68),('9303','2013-10-03','10:10:00',2.74),('9303','2013-10-03','10:15:00',2.76),('9303','2013-10-03','10:20:00',2.81),('9303','2013-10-03','10:25:00',2.83),('9303','2013-10-03','10:30:00',2.88),('9303','2013-10-03','10:35:00',2.9),('9303','2013-10-03','10:40:00',2.99),('9303','2013-10-03','10:45:00',3.01),('9303','2013-10-03','10:50:00',3.08),('9303','2013-10-03','10:55:00',3.09),('9303','2013-10-03','11:00:00',3.16),('9303','2013-10-03','11:05:00',3.17),('9303','2013-10-03','11:10:00',3.24),('9303','2013-10-03','11:15:00',3.3),('9303','2013-10-03','11:20:00',3.33),('9303','2013-10-03','11:25:00',3.37),('9303','2013-10-03','11:30:00',3.4),('9303','2013-10-03','11:35:00',3.45),('9303','2013-10-03','11:40:00',3.47),('9303','2013-10-03','11:45:00',3.49),('9303','2013-10-03','11:50:00',3.53),('9303','2013-10-03','11:55:00',3.57),('9303','2013-10-03','12:00:00',3.61),('9303','2013-10-03','12:05:00',3.58),('9303','2013-10-03','12:10:00',3.62),('9303','2013-10-03','12:15:00',3.63),('9303','2013-10-03','12:20:00',3.6),('9303','2013-10-03','12:25:00',3.62),('9303','2013-10-03','12:30:00',3.66),('9303','2013-10-03','12:35:00',3.65),('9303','2013-10-03','12:40:00',3.67),('9303','2013-10-03','12:45:00',3.71),('9303','2013-10-03','12:50:00',3.71),('9303','2013-10-03','12:55:00',3.73),('9303','2013-10-03','13:00:00',3.76),('9303','2013-10-03','13:05:00',3.69),('9303','2013-10-03','13:10:00',3.73),('9303','2013-10-03','13:15:00',3.73),('9303','2013-10-03','13:20:00',3.72),('9303','2013-10-03','13:25:00',3.7),('9303','2013-10-03','13:30:00',3.71),('9303','2013-10-03','13:35:00',3.69),('9303','2013-10-03','13:40:00',3.66),('9303','2013-10-03','13:45:00',3.65),('9303','2013-10-03','13:50:00',3.63),('9303','2013-10-03','13:55:00',3.62),('9303','2013-10-03','14:00:00',3.61),('9303','2013-10-03','14:05:00',3.59),('9303','2013-10-03','14:10:00',3.55),('9303','2013-10-03','14:15:00',3.51),('9303','2013-10-03','14:20:00',3.48),('9303','2013-10-03','14:25:00',3.45),('9303','2013-10-03','14:30:00',3.41),('9303','2013-10-03','14:35:00',3.34),('9303','2013-10-03','14:40:00',3.29),('9303','2013-10-03','14:45:00',3.23),('9303','2013-10-03','14:50:00',3.19),('9303','2013-10-03','14:55:00',3.14),('9303','2013-10-03','15:00:00',3.08),('9303','2013-10-03','15:05:00',3.03),('9303','2013-10-03','15:10:00',2.97),('9303','2013-10-03','15:15:00',2.92),('9303','2013-10-03','15:20:00',2.9),('9303','2013-10-03','15:25:00',2.87),('9303','2013-10-03','15:30:00',2.79),('9303','2013-10-03','15:35:00',2.72),('9303','2013-10-03','15:40:00',2.65),('9303','2013-10-03','15:45:00',2.59),('9303','2013-10-03','15:50:00',2.51),('9303','2013-10-03','15:55:00',2.45),('9303','2013-10-03','16:00:00',2.39),('9303','2013-10-03','16:05:00',2.3),('9303','2013-10-03','16:10:00',2.19),('9303','2013-10-03','16:15:00',2.07),('9303','2013-10-03','16:20:00',1.97),('9303','2013-10-03','16:25:00',1.87),('9303','2013-10-03','16:30:00',1.81),('9303','2013-10-03','16:35:00',1.72),('9303','2013-10-03','16:40:00',1.62),('9303','2013-10-03','16:45:00',1.53),('9303','2013-10-03','16:50:00',1.45),('9303','2013-10-03','16:55:00',1.36),('9303','2013-10-03','17:00:00',1.27),('9303','2013-10-03','17:05:00',1.18),('9303','2013-10-03','17:10:00',1.09),('9303','2013-10-02','08:35:00',1.03),('9303','2013-10-02','08:40:00',1.1),('9303','2013-10-02','08:45:00',1.19),('9303','2013-10-02','08:50:00',1.31),('9303','2013-10-02','08:55:00',1.41),('9303','2013-10-02','09:00:00',1.52),('9303','2013-10-02','09:05:00',1.59),('9303','2013-10-02','09:10:00',1.69),('9303','2013-10-02','09:15:00',1.79),('9303','2013-10-02','09:20:00',1.87),('9303','2013-10-02','09:25:00',1.95),('9303','2013-10-02','09:30:00',2.03),('9303','2013-10-02','09:35:00',2.11),('9303','2013-10-02','09:40:00',2.18),('9303','2013-10-02','09:45:00',2.25),('9303','2013-10-02','09:50:00',2.31),('9303','2013-10-02','09:55:00',2.38),('9303','2013-10-02','10:00:00',2.39),('9303','2013-10-02','10:05:00',2.49),('9303','2013-10-02','10:10:00',2.55),('9303','2013-10-02','10:15:00',2.57),('9303','2013-10-02','10:20:00',2.63),('9303','2013-10-02','10:25:00',2.65),('9303','2013-10-02','10:30:00',2.68),('9303','2013-10-02','10:35:00',2.76),('9303','2013-10-02','10:40:00',2.85),('9303','2013-10-02','10:45:00',2.9),('9303','2013-10-02','10:50:00',2.96),('9303','2013-10-02','10:55:00',3.01),('9303','2013-10-02','11:00:00',3.05),('9303','2013-10-02','11:05:00',3.1),('9303','2013-10-02','11:10:00',3.14),('9303','2013-10-02','11:15:00',3.2),('9303','2013-10-02','11:20:00',3.21),('9303','2013-10-02','11:25:00',3.24),('9303','2013-10-02','11:30:00',3.3),('9303','2013-10-02','11:35:00',3.29),('9303','2013-10-02','11:40:00',3.35),('9303','2013-10-02','11:45:00',3.37),('9303','2013-10-02','11:50:00',3.38),('9303','2013-10-02','11:55:00',3.45),('9303','2013-10-02','12:00:00',3.44),('9303','2013-10-02','12:05:00',3.43),('9303','2013-10-02','12:10:00',3.48),('9303','2013-10-02','12:15:00',3.47),('9303','2013-10-02','12:20:00',3.48),('9303','2013-10-02','12:25:00',3.52),('9303','2013-10-02','12:30:00',3.5),('9303','2013-10-02','12:35:00',3.49),('9303','2013-10-02','12:40:00',3.55),('9303','2013-10-02','12:45:00',3.56),('9303','2013-10-02','12:50:00',3.58),('9303','2013-10-02','12:55:00',3.63),('9303','2013-10-02','13:00:00',3.64),('9303','2013-10-02','13:05:00',3.64),('9303','2013-10-02','13:10:00',3.63),('9303','2013-10-02','13:15:00',3.63),('9303','2013-10-02','13:20:00',3.62),('9303','2013-10-02','13:25:00',3.63),('9303','2013-10-02','13:30:00',3.61),('9303','2013-10-02','13:35:00',3.6),('9303','2013-10-02','13:40:00',3.58),('9303','2013-10-02','13:45:00',3.54),('9303','2013-10-02','13:50:00',3.53),('9303','2013-10-02','13:55:00',3.49),('9303','2013-10-02','14:00:00',3.48),('9303','2013-10-02','14:05:00',3.45),('9303','2013-10-02','14:10:00',3.43),('9303','2013-10-02','14:15:00',3.41),('9303','2013-10-02','14:20:00',3.36),('9303','2013-10-02','14:25:00',3.35),('9303','2013-10-02','14:30:00',3.31),('9303','2013-10-02','14:35:00',3.27),('9303','2013-10-02','14:40:00',3.24),('9303','2013-10-02','14:45:00',3.2),('9303','2013-10-02','14:50:00',3.16),('9303','2013-10-02','14:55:00',3.13),('9303','2013-10-02','15:00:00',3.06),('9303','2013-10-02','15:05:00',2.98),('9303','2013-10-02','15:10:00',2.92),('9303','2013-10-02','15:15:00',2.89),('9303','2013-10-02','15:20:00',2.86),('9303','2013-10-02','15:25:00',2.78),('9303','2013-10-02','15:30:00',2.72),('9303','2013-10-02','15:35:00',2.67),('9303','2013-10-02','15:40:00',2.62),('9303','2013-10-02','15:45:00',2.55),('9303','2013-10-02','15:50:00',2.48),('9303','2013-10-02','15:55:00',2.39),('9303','2013-10-02','16:00:00',2.33),('9303','2013-10-02','16:05:00',2.26),('9303','2013-10-02','16:10:00',2.15),('9303','2013-10-02','16:15:00',2.03),('9303','2013-10-02','16:20:00',1.92),('9303','2013-10-02','16:25:00',1.83),('9303','2013-10-02','16:30:00',1.77),('9303','2013-10-02','16:35:00',1.69),('9303','2013-10-02','16:40:00',1.59),('9303','2013-10-02','16:45:00',1.49),('9303','2013-10-02','16:50:00',1.41),('9303','2013-10-02','16:55:00',1.33),('9303','2013-10-02','17:00:00',1.24),('9303','2013-10-02','17:05:00',1.16),('9303','2013-10-02','17:10:00',1.06),('9303','2013-10-01','08:40:00',1.1),('9303','2013-10-01','08:45:00',1.27),('9303','2013-10-01','08:50:00',1.37),('9303','2013-10-01','08:55:00',1.45),('9303','2013-10-01','09:00:00',1.55),('9303','2013-10-01','09:05:00',1.63),('9303','2013-10-01','09:10:00',1.71),('9303','2013-10-01','09:15:00',1.78),('9303','2013-10-01','09:20:00',1.86),('9303','2013-10-01','09:25:00',1.92),('9303','2013-10-01','09:30:00',2),('9303','2013-10-01','09:35:00',2.06),('9303','2013-10-01','09:40:00',2.13),('9303','2013-10-01','09:45:00',2.19),('9303','2013-10-01','09:50:00',2.25),('9303','2013-10-01','09:55:00',2.32),('9303','2013-10-01','10:00:00',2.4),('9303','2013-10-01','10:05:00',2.46),('9303','2013-10-01','10:10:00',2.52),('9303','2013-10-01','10:15:00',2.57),('9303','2013-10-01','10:20:00',2.62),('9303','2013-10-01','10:25:00',2.65),('9303','2013-10-01','10:30:00',2.69),('9303','2013-10-01','10:35:00',2.73),('9303','2013-10-01','10:40:00',2.82),('9303','2013-10-01','10:45:00',2.8),('9303','2013-10-01','10:50:00',2.87),('9303','2013-10-01','10:55:00',2.89),('9303','2013-10-01','11:00:00',3.02),('9303','2013-10-01','11:05:00',3.2),('9303','2013-10-01','11:10:00',2.26),('9303','2013-10-01','11:15:00',1.56),('9303','2013-10-01','11:20:00',2.64),('9303','2013-10-01','11:25:00',3.47),('9303','2013-10-01','11:30:00',2.55),('9303','2013-10-01','11:35:00',1.24),('9303','2013-10-01','11:40:00',3.63),('9303','2013-10-01','11:45:00',3.64),('9303','2013-10-01','11:50:00',3.6),('9303','2013-10-01','11:55:00',3.63),('9303','2013-10-01','12:00:00',3.54),('9303','2013-10-01','12:05:00',2.73),('9303','2013-10-01','12:10:00',3.46),('9303','2013-10-01','12:15:00',3.62),('9303','2013-10-01','12:20:00',3.72),('9303','2013-10-01','12:25:00',3.73),('9303','2013-10-01','12:30:00',3.82),('9303','2013-10-01','12:35:00',3.72),('9303','2013-10-01','12:40:00',1.36),('9303','2013-10-01','12:45:00',3.89),('9303','2013-10-01','12:50:00',3.65),('9303','2013-10-01','12:55:00',3.65),('9303','2013-10-01','13:00:00',3.68),('9303','2013-10-01','13:05:00',3.37),('9303','2013-10-01','13:15:00',2.49),('9303','2013-10-01','13:20:00',3.92),('9303','2013-10-01','13:25:00',3.94),('9303','2013-10-01','13:30:00',3.99),('9303','2013-10-01','13:35:00',2.97),('9303','2013-10-01','13:40:00',2.18),('9303','2013-10-01','13:45:00',3.21),('9303','2013-10-01','13:55:00',2.46),('9303','2013-10-01','14:00:00',3.49),('9303','2013-10-01','14:05:00',3.41),('9303','2013-10-01','14:10:00',3.35),('9303','2013-10-01','14:15:00',3.33),('9303','2013-10-01','14:20:00',3.33),('9303','2013-10-01','14:25:00',3.27),('9303','2013-10-01','14:30:00',3.23),('9303','2013-10-01','14:35:00',3.18),('9303','2013-10-01','14:40:00',3.21),('9303','2013-10-01','14:45:00',3.22),('9303','2013-10-01','14:50:00',3.22),('9303','2013-10-01','14:55:00',3.17),('9303','2013-10-01','15:00:00',3.15),('9303','2013-10-01','15:05:00',2.99),('9303','2013-10-01','15:10:00',2.91),('9303','2013-10-01','15:15:00',2.87),('9303','2013-10-01','15:20:00',2.83),('9303','2013-10-01','15:25:00',2.77),('9303','2013-10-01','15:30:00',2.72),('9303','2013-10-01','15:35:00',2.65),('9303','2013-10-01','15:40:00',2.59),('9303','2013-10-01','15:45:00',2.52),('9303','2013-10-01','15:50:00',2.46),('9303','2013-10-01','15:55:00',2.39),('9303','2013-10-01','16:00:00',2.32),('9303','2013-10-01','16:05:00',2.26),('9303','2013-10-01','16:10:00',2.15),('9303','2013-10-01','16:15:00',2.04),('9303','2013-10-01','16:20:00',1.94),('9303','2013-10-01','16:25:00',1.85),('9303','2013-10-01','16:30:00',1.76),('9303','2013-10-01','16:35:00',1.68),('9303','2013-10-01','16:40:00',1.59),('9303','2013-10-01','16:45:00',1.49),('9303','2013-10-01','16:50:00',1.41),('9303','2013-10-01','16:55:00',1.34),('9303','2013-10-01','17:00:00',1.26),('9303','2013-10-01','17:05:00',1.17),('9303','2013-10-01','17:10:00',1.08),('9303','2013-09-30','09:50:00',1.21),('9303','2013-09-30','09:55:00',1.01),('9303','2013-09-30','10:25:00',1.19),('9303','2013-09-30','10:30:00',1.39),('9303','2013-09-30','10:35:00',1.59),('9303','2013-09-30','10:40:00',2.02),('9303','2013-09-30','10:45:00',3.03),('9303','2013-09-30','10:50:00',3.15),('9303','2013-09-30','10:55:00',2.9),('9303','2013-09-30','11:00:00',2.49),('9303','2013-09-30','11:05:00',3.02),('9303','2013-09-30','11:10:00',3.07),('9303','2013-09-30','11:15:00',2.52),('9303','2013-09-30','11:20:00',2.92),('9303','2013-09-30','11:25:00',2.34),('9303','2013-09-30','11:30:00',1.91),('9303','2013-09-30','11:35:00',1.49),('9303','2013-09-30','11:40:00',3.57),('9303','2013-09-30','11:45:00',1.85),('9303','2013-09-30','11:50:00',1.65),('9303','2013-09-30','11:55:00',1.23),('9303','2013-09-30','12:00:00',1.86),('9303','2013-09-30','12:05:00',2.88),('9303','2013-09-30','12:10:00',2.72),('9303','2013-09-30','12:15:00',3.77),('9303','2013-09-30','12:20:00',3.9),('9303','2013-09-30','12:25:00',3.85),('9303','2013-09-30','12:30:00',3.66),('9303','2013-09-30','12:35:00',3.61),('9303','2013-09-30','12:40:00',3.43),('9303','2013-09-30','12:45:00',3.06),('9303','2013-09-30','12:50:00',3.79),('9303','2013-09-30','12:55:00',3.76),('9303','2013-09-30','13:00:00',3.43),('9303','2013-09-30','13:05:00',3.57),('9303','2013-09-30','13:10:00',3.84),('9303','2013-09-30','13:15:00',3.36),('9303','2013-09-30','13:20:00',4.2),('9303','2013-09-30','13:25:00',4.32),('9303','2013-09-30','13:30:00',4.18),('9303','2013-09-30','13:35:00',3.29),('9303','2013-09-30','13:40:00',2.53),('9303','2013-09-30','13:45:00',1.34),('9303','2013-09-30','13:50:00',3.22),('9303','2013-09-30','13:55:00',2.18),('9303','2013-09-30','14:00:00',1.28),('9303','2013-09-30','14:05:00',1.22),('9303','2013-09-30','14:10:00',1.22),('9303','2013-09-30','14:15:00',1.14),('9303','2013-09-30','14:25:00',1.07),('9303','2013-09-30','14:30:00',2.32),('9303','2013-09-30','14:35:00',2.75),('9303','2013-09-30','14:40:00',3.64),('9303','2013-09-30','14:45:00',2.58),('9303','2013-09-30','14:50:00',3.52),('9303','2013-09-30','14:55:00',1.65),('9303','2013-09-30','15:00:00',2.89),('9303','2013-09-30','15:05:00',2.48),('9303','2013-09-30','15:10:00',2.82),('9303','2013-09-30','15:15:00',1.52),('9303','2013-09-30','15:20:00',1.3),('9303','2013-09-30','15:25:00',3.04),('9303','2013-09-30','15:30:00',1.82),('9303','2013-09-30','15:35:00',2.23),('9303','2013-09-30','15:40:00',3.14),('9303','2013-09-30','15:45:00',1.66),('9303','2013-09-30','16:10:00',1.47),('9303','2013-09-30','16:15:00',1.75),('9303','2013-09-30','16:20:00',1.13),('9303','2013-09-29','08:50:00',1.11),('9303','2013-09-29','08:55:00',1.02),('9303','2013-09-29','09:15:00',1.18),('9303','2013-09-29','10:00:00',1.19),('9303','2013-09-29','10:05:00',1.62),('9303','2013-09-29','10:10:00',1.86),('9303','2013-09-29','10:15:00',2.36),('9303','2013-09-29','10:20:00',1.98),('9303','2013-09-29','10:25:00',1.86),('9303','2013-09-29','10:30:00',2.22),('9303','2013-09-29','10:35:00',2.41),('9303','2013-09-29','10:40:00',2.64),('9303','2013-09-29','10:45:00',2.53),('9303','2013-09-29','10:50:00',2.66),('9303','2013-09-29','10:55:00',2.67),('9303','2013-09-29','11:00:00',2.71),('9303','2013-09-29','11:05:00',2.59),('9303','2013-09-29','11:10:00',2.59),('9303','2013-09-29','11:15:00',2.82),('9303','2013-09-29','11:20:00',2.82),('9303','2013-09-29','11:25:00',2.66),('9303','2013-09-29','11:30:00',2.84),('9303','2013-09-29','11:35:00',2.87),('9303','2013-09-29','11:40:00',2.96),('9303','2013-09-29','11:45:00',2.95),('9303','2013-09-29','11:50:00',3.15),('9303','2013-09-29','11:55:00',3.1),('9303','2013-09-29','12:00:00',2.84),('9303','2013-09-29','12:05:00',3.14),('9303','2013-09-29','12:10:00',3.18),('9303','2013-09-29','12:15:00',3.53),('9303','2013-09-29','12:20:00',2.54),('9303','2013-09-29','12:25:00',1.85),('9303','2013-09-29','12:30:00',1.86),('9303','2013-09-29','12:35:00',1.76),('9303','2013-09-29','12:40:00',1.5),('9303','2013-09-29','12:45:00',1.31),('9303','2013-09-29','12:50:00',1.31),('9303','2013-09-29','12:55:00',1.14),('9303','2013-09-29','13:00:00',1.11),('9303','2013-09-29','13:25:00',1.22),('9303','2013-09-29','13:30:00',1.84),('9303','2013-09-29','13:35:00',1.61),('9303','2013-09-29','13:40:00',1.52),('9303','2013-09-29','13:45:00',1.41),('9303','2013-09-29','13:50:00',1.5),('9303','2013-09-29','13:55:00',2.05),('9303','2013-09-29','14:00:00',1.86),('9303','2013-09-29','14:05:00',2.34),('9303','2013-09-29','14:10:00',1.38),('9303','2013-09-29','14:15:00',1.59),('9303','2013-09-29','14:20:00',2.17),('9303','2013-09-29','14:25:00',1.24),('9303','2013-09-29','14:30:00',1.05),('9303','2013-09-29','14:35:00',1.05),('9303','2013-09-29','15:00:00',1.22),('9303','2014-04-14','08:10:00',1.08),('9303','2014-04-14','08:15:00',1.17),('9303','2014-04-14','08:20:00',1.26),('9303','2014-04-14','08:25:00',1.37),('9303','2014-04-14','08:30:00',1.5),('9303','2014-04-14','08:35:00',1.57),('9303','2014-04-14','08:40:00',1.67),('9303','2014-04-14','08:45:00',1.78),('9303','2014-04-14','08:50:00',1.87),('9303','2014-04-14','08:55:00',1.97),('9303','2014-04-14','09:00:00',2.06),('9303','2014-04-14','09:05:00',2.15),('9303','2014-04-14','09:10:00',2.22),('9303','2014-04-14','09:15:00',2.28),('9303','2014-04-14','09:20:00',2.37),('9303','2014-04-14','09:25:00',2.45),('9303','2014-04-14','09:30:00',2.52),('9303','2014-04-14','09:35:00',2.59),('9303','2014-04-14','09:40:00',2.64),('9303','2014-04-14','09:45:00',2.73),('9303','2014-04-14','09:50:00',2.82),('9303','2014-04-14','09:55:00',2.89),('9303','2014-04-14','10:00:00',2.96),('9303','2014-04-14','10:05:00',3.03),('9303','2014-04-14','10:10:00',3.11),('9303','2014-04-14','10:15:00',3.16),('9303','2014-04-14','10:20:00',3.24),('9303','2014-04-14','10:25:00',3.3),('9303','2014-04-14','10:30:00',3.36),('9303','2014-04-14','10:35:00',3.39),('9303','2014-04-14','10:40:00',3.45),('9303','2014-04-14','10:45:00',3.5),('9303','2014-04-14','10:50:00',3.56),('9303','2014-04-14','10:55:00',3.62),('9303','2014-04-14','11:00:00',3.64),('9303','2014-04-14','11:05:00',3.66),('9303','2014-04-14','11:10:00',3.73),('9303','2014-04-14','11:15:00',3.77),('9303','2014-04-14','11:20:00',3.77),('9303','2014-04-14','11:25:00',3.79),('9303','2014-04-14','11:30:00',3.84),('9303','2014-04-14','11:35:00',3.87),('9303','2014-04-14','11:40:00',3.88),('9303','2014-04-14','11:45:00',3.9),('9303','2014-04-14','11:50:00',3.94),('9303','2014-04-14','11:55:00',3.97),('9303','2014-04-14','12:00:00',3.97),('9303','2014-04-14','12:05:00',4.02),('9303','2014-04-14','12:10:00',4.07),('9303','2014-04-14','12:15:00',4.13),('9303','2014-04-14','12:20:00',4.13),('9303','2014-04-14','12:25:00',4.17),('9303','2014-04-14','12:30:00',4.18),('9303','2014-04-14','12:35:00',4.15),('9303','2014-04-14','12:40:00',4.18),('9303','2014-04-14','12:45:00',4.17),('9303','2014-04-14','12:50:00',4.16),('9303','2014-04-14','12:55:00',4.16),('9303','2014-04-14','13:00:00',4.17),('9303','2014-04-14','13:05:00',4.21),('9303','2014-04-14','13:10:00',4.21),('9303','2014-04-14','13:15:00',4.15),('9303','2014-04-14','13:20:00',4.21),('9303','2014-04-14','13:25:00',4.2),('9303','2014-04-14','13:30:00',4.2),('9303','2014-04-14','13:35:00',4.2),('9303','2014-04-14','13:40:00',4.19),('9303','2014-04-14','13:45:00',4.18),('9303','2014-04-14','13:50:00',4.16),('9303','2014-04-14','13:55:00',4.18),('9303','2014-04-14','14:00:00',4.18),('9303','2014-04-14','14:05:00',4.14),('9303','2014-04-14','14:10:00',4.15),('9303','2014-04-14','14:15:00',4.14),('9303','2014-04-14','14:20:00',4.09),('9303','2014-04-14','14:25:00',4.08),('9303','2014-04-14','14:30:00',4.05),('9303','2014-04-14','14:35:00',4.02),('9303','2014-04-14','14:40:00',3.99),('9303','2014-04-14','14:45:00',3.93),('9303','2014-04-14','14:50:00',3.89),('9303','2014-04-14','14:55:00',3.85),('9303','2014-04-14','15:00:00',3.81),('9303','2014-04-14','15:05:00',3.79),('9303','2014-04-14','15:10:00',3.73),('9303','2014-04-14','15:15:00',3.71),('9303','2014-04-14','15:20:00',3.64),('9303','2014-04-14','15:25:00',3.59),('9303','2014-04-14','15:30:00',3.56),('9303','2014-04-14','15:35:00',3.5),('9303','2014-04-14','15:40:00',3.45),('9303','2014-04-14','15:45:00',3.38),('9303','2014-04-14','15:50:00',3.32),('9303','2014-04-14','15:55:00',3.24),('9303','2014-04-14','16:00:00',3.18),('9303','2014-04-14','16:05:00',3.14),('9303','2014-04-14','16:10:00',3.06),('9303','2014-04-14','16:15:00',3),('9303','2014-04-14','16:20:00',2.92),('9303','2014-04-14','16:25:00',2.84),('9303','2014-04-14','16:30:00',2.76),('9303','2014-04-14','16:35:00',2.7),('9303','2014-04-14','16:40:00',2.63),('9303','2014-04-14','16:45:00',2.53),('9303','2014-04-14','16:50:00',2.39),('9303','2014-04-14','16:55:00',2.28),('9303','2014-04-14','17:00:00',2.19),('9303','2014-04-14','17:05:00',2.11),('9303','2014-04-14','17:10:00',2.02),('9303','2014-04-14','17:15:00',1.93),('9303','2014-04-14','17:20:00',1.85),('9303','2014-04-14','17:25:00',1.77),('9303','2014-04-14','17:30:00',1.67),('9303','2014-04-14','17:35:00',1.52),('9303','2014-04-14','17:40:00',1.46),('9303','2014-04-14','17:45:00',1.38),('9303','2014-04-14','17:50:00',1.24),('9303','2014-04-14','17:55:00',1.15),('9303','2014-04-14','18:00:00',1.04),('9303','2013-09-28','08:35:00',1),('9303','2013-09-28','08:40:00',1.07),('9303','2013-09-28','08:45:00',1.17),('9303','2013-09-28','08:50:00',1.23),('9303','2013-09-28','08:55:00',1.32),('9303','2013-09-28','09:00:00',1.39),('9303','2013-09-28','09:05:00',1.48),('9303','2013-09-28','09:10:00',1.59),('9303','2013-09-28','09:15:00',1.68),('9303','2013-09-28','09:20:00',1.74),('9303','2013-09-28','09:25:00',1.82),('9303','2013-09-28','09:30:00',1.92),('9303','2013-09-28','09:35:00',1.98),('9303','2013-09-28','09:40:00',2.04),('9303','2013-09-28','09:45:00',2.14),('9303','2013-09-28','09:50:00',2.25),('9303','2013-09-28','09:55:00',2.08),('9303','2013-09-28','10:00:00',1.66),('9303','2013-09-28','10:05:00',1.21),('9303','2013-09-28','10:15:00',1.27),('9303','2013-09-28','10:25:00',1.11),('9303','2013-09-28','10:30:00',1.63),('9303','2013-09-28','10:35:00',2.27),('9303','2013-09-28','10:40:00',1.99),('9303','2013-09-28','10:45:00',1.98),('9303','2013-09-28','10:50:00',3.19),('9303','2013-09-28','10:55:00',2.93),('9303','2013-09-28','11:15:00',1.36),('9303','2013-09-28','11:20:00',3.31),('9303','2013-09-28','11:25:00',3.61),('9303','2013-09-28','11:30:00',3.52),('9303','2013-09-28','11:35:00',2.31),('9303','2013-09-28','11:40:00',1.9),('9303','2013-09-28','11:50:00',1.37),('9303','2013-09-28','11:55:00',1.24),('9303','2013-09-28','12:00:00',1.98),('9303','2013-09-28','12:05:00',3.71),('9303','2013-09-28','12:10:00',3.59),('9303','2013-09-28','12:15:00',3.47),('9303','2013-09-28','12:20:00',2.88),('9303','2013-09-28','12:25:00',2.47),('9303','2013-09-28','12:30:00',2.3),('9303','2013-09-28','12:35:00',2.07),('9303','2013-09-28','12:40:00',2.68),('9303','2013-09-28','12:45:00',2.64),('9303','2013-09-28','12:50:00',3.02),('9303','2013-09-28','12:55:00',2.79),('9303','2013-09-28','13:00:00',3.96),('9303','2013-09-28','13:05:00',2.95),('9303','2013-09-28','13:10:00',1.01),('9303','2013-09-28','13:15:00',1.2),('9303','2013-09-28','13:20:00',1.33),('9303','2013-09-28','13:25:00',1.56),('9303','2013-09-28','13:30:00',3.83),('9303','2013-09-28','13:35:00',1.41),('9303','2013-09-28','13:40:00',1.32),('9303','2013-09-28','13:45:00',1.5),('9303','2013-09-28','13:50:00',1.52),('9303','2013-09-28','13:55:00',1.32),('9303','2013-09-28','14:00:00',1.31),('9303','2013-09-28','14:05:00',1.26),('9303','2013-09-28','14:10:00',1.54),('9303','2013-09-28','14:15:00',1.96),('9303','2013-09-28','14:20:00',1.89),('9303','2013-09-28','14:25:00',3.79),('9303','2013-09-28','14:30:00',2.69),('9303','2013-09-28','14:35:00',3.05),('9303','2013-09-28','14:40:00',3.63),('9303','2013-09-28','14:45:00',3.5),('9303','2013-09-28','14:50:00',2.47),('9303','2013-09-28','14:55:00',1.85),('9303','2013-09-28','15:00:00',3.32),('9303','2013-09-28','15:05:00',2.81),('9303','2013-09-28','15:10:00',2.65),('9303','2013-09-28','15:15:00',3.06),('9303','2013-09-28','15:20:00',3.11),('9303','2013-09-28','15:25:00',3.06),('9303','2013-09-28','15:30:00',3),('9303','2013-09-28','15:35:00',2.77),('9303','2013-09-28','15:40:00',2.73),('9303','2013-09-28','15:45:00',2.32),('9303','2013-09-28','15:50:00',2.19),('9303','2013-09-28','15:55:00',1.66),('9303','2013-09-28','16:00:00',2.44),('9303','2013-09-28','16:05:00',2.43),('9303','2013-09-28','16:10:00',2.43),('9303','2013-09-28','16:15:00',2.16),('9303','2013-09-28','16:20:00',1.17),('9303','2013-09-28','16:25:00',1.78),('9303','2013-09-28','16:30:00',1.69),('9303','2013-09-28','16:35:00',1.66),('9303','2013-09-28','16:40:00',1.58),('9303','2013-09-28','16:45:00',1.47),('9303','2013-09-28','16:50:00',1.4),('9303','2013-09-28','16:55:00',1.33),('9303','2013-09-28','17:00:00',1.23),('9303','2013-09-28','17:05:00',1.16),('9303','2013-09-28','17:10:00',1.07),('9303','2013-09-27','08:35:00',1.08),('9303','2013-09-27','08:40:00',1.11),('9303','2013-09-27','08:45:00',1.2),('9303','2013-09-27','08:50:00',1.18),('9303','2013-09-27','08:55:00',1.52),('9303','2013-09-27','09:00:00',1.16),('9303','2013-09-27','09:15:00',1.1),('9303','2013-09-27','09:50:00',1.08),('9303','2013-09-27','09:55:00',1.36),('9303','2013-09-27','10:00:00',1.46),('9303','2013-09-27','10:05:00',2.21),('9303','2013-09-27','10:10:00',1.85),('9303','2013-09-27','10:15:00',1.37),('9303','2013-09-27','10:20:00',2.22),('9303','2013-09-27','10:25:00',1.75),('9303','2013-09-27','10:30:00',1.74),('9303','2013-09-27','10:35:00',1.16),('9303','2013-09-27','10:45:00',1.71),('9303','2013-09-27','10:50:00',2.48),('9303','2013-09-27','10:55:00',2.83),('9303','2013-09-27','11:00:00',2.95),('9303','2013-09-27','11:05:00',2.87),('9303','2013-09-27','11:10:00',2.31),('9303','2013-09-27','11:15:00',3.04),('9303','2013-09-27','11:20:00',3.19),('9303','2013-09-27','11:25:00',2.87),('9303','2013-09-27','11:30:00',2.83),('9303','2013-09-27','11:35:00',1.2),('9303','2013-09-27','11:45:00',1.82),('9303','2013-09-27','11:50:00',1.13),('9303','2013-09-27','11:55:00',1.51),('9303','2013-09-27','12:00:00',2.89),('9303','2013-09-27','12:05:00',1.8),('9303','2013-09-27','12:10:00',2.92),('9303','2013-09-27','12:15:00',2.17),('9303','2013-09-27','12:45:00',2.94),('9303','2013-09-27','12:50:00',3.34),('9303','2013-09-27','12:55:00',3.48),('9303','2013-09-27','13:00:00',3.44),('9303','2013-09-27','13:05:00',3.35),('9303','2013-09-27','13:10:00',3.14),('9303','2013-09-27','13:15:00',1.56),('9303','2013-09-27','13:20:00',3.44),('9303','2013-09-27','13:25:00',2.35),('9303','2013-09-27','13:40:00',1.72),('9303','2013-09-27','13:45:00',2.9),('9303','2013-09-27','13:50:00',1.34),('9303','2013-09-27','13:55:00',1.05),('9303','2013-09-27','14:00:00',1.44),('9303','2013-09-27','14:05:00',3.74),('9303','2013-09-27','14:10:00',2.81),('9303','2013-09-27','14:15:00',2.85),('9303','2013-09-27','14:20:00',3.5),('9303','2013-09-27','14:25:00',3.38),('9303','2013-09-27','14:30:00',3.25),('9303','2013-09-27','14:35:00',3.23),('9303','2013-09-27','14:40:00',3.25),('9303','2013-09-27','14:45:00',3.11),('9303','2013-09-27','14:50:00',2.82),('9303','2013-09-27','14:55:00',3),('9303','2013-09-27','15:00:00',2.33),('9303','2013-09-27','15:05:00',2.02),('9303','2013-09-27','15:10:00',2.25),('9303','2013-09-27','15:15:00',2.92),('9303','2013-09-27','15:20:00',1.59),('9303','2013-09-27','15:25:00',2.39),('9303','2013-09-27','15:30:00',2.84),('9303','2013-09-27','15:35:00',2.38),('9303','2013-09-27','15:40:00',2.61),('9303','2013-09-27','15:45:00',1.23),('9303','2013-09-27','15:50:00',2.23),('9303','2013-09-27','15:55:00',2.47),('9303','2013-09-27','16:00:00',1.68),('9303','2013-09-27','16:05:00',1.8),('9303','2013-09-27','16:15:00',1.53),('9303','2013-09-27','16:20:00',2.01),('9303','2013-09-27','16:25:00',1.89),('9303','2013-09-27','16:30:00',1.54),('9303','2013-09-27','16:35:00',1.71),('9303','2013-09-27','16:40:00',1.6),('9303','2013-09-27','16:45:00',1.55),('9303','2013-09-27','16:50:00',1.44),('9303','2013-09-27','16:55:00',1.17),('9303','2013-09-27','17:10:00',1.12),('9303','2013-09-27','17:15:00',1.18),('9303','2013-09-27','17:20:00',1.02),('9303','2013-09-26','08:40:00',1.14),('9303','2013-09-26','08:45:00',1.27),('9303','2013-09-26','08:50:00',1.36),('9303','2013-09-26','08:55:00',1.47),('9303','2013-09-26','09:00:00',1.57),('9303','2013-09-26','09:05:00',1.65),('9303','2013-09-26','09:10:00',1.73),('9303','2013-09-26','09:15:00',1.81),('9303','2013-09-26','09:20:00',1.88),('9303','2013-09-26','09:25:00',1.96),('9303','2013-09-26','09:30:00',2.02),('9303','2013-09-26','09:35:00',2.09),('9303','2013-09-26','09:40:00',2.16),('9303','2013-09-26','09:45:00',2.23),('9303','2013-09-26','09:50:00',2.28),('9303','2013-09-26','09:55:00',2.33),('9303','2013-09-26','10:00:00',2.4),('9303','2013-09-26','10:05:00',2.48),('9303','2013-09-26','10:10:00',2.51),('9303','2013-09-26','10:15:00',2.54),('9303','2013-09-26','10:20:00',2.55),('9303','2013-09-26','10:25:00',2.63),('9303','2013-09-26','10:30:00',2.71),('9303','2013-09-26','10:35:00',2.76),('9303','2013-09-26','10:40:00',2.72),('9303','2013-09-26','10:45:00',2.6),('9303','2013-09-26','10:50:00',2.9),('9303','2013-09-26','10:55:00',2.95),('9303','2013-09-26','11:00:00',2.93),('9303','2013-09-26','11:05:00',2.91),('9303','2013-09-26','11:10:00',3.01),('9303','2013-09-26','11:15:00',3),('9303','2013-09-26','11:20:00',3.08),('9303','2013-09-26','11:25:00',3.19),('9303','2013-09-26','11:30:00',3.16),('9303','2013-09-26','11:35:00',2.98),('9303','2013-09-26','11:40:00',1.64),('9303','2013-09-26','11:45:00',3.11),('9303','2013-09-26','11:50:00',3.37),('9303','2013-09-26','11:55:00',1.5),('9303','2013-09-26','12:00:00',3.07),('9303','2013-09-26','12:05:00',2.47),('9303','2013-09-26','12:15:00',1.18),('9303','2013-09-26','12:20:00',1.73),('9303','2013-09-26','12:25:00',1.18),('9303','2013-09-26','12:30:00',1.34),('9303','2013-09-26','12:35:00',1.37),('9303','2013-09-26','12:40:00',1.5),('9303','2013-09-26','12:45:00',1.59),('9303','2013-09-26','12:50:00',1.49),('9303','2013-09-26','12:55:00',2.45),('9303','2013-09-26','13:00:00',3.23),('9303','2013-09-26','13:05:00',2.2),('9303','2013-09-26','13:10:00',1.55),('9303','2013-09-26','13:15:00',3.24),('9303','2013-09-26','13:20:00',3.9),('9303','2013-09-26','13:25:00',2.92),('9303','2013-09-26','13:30:00',1.99),('9303','2013-09-26','13:35:00',2.2),('9303','2013-09-26','13:40:00',1.86),('9303','2013-09-26','13:45:00',1.25),('9303','2013-09-26','13:50:00',1.25),('9303','2013-09-26','13:55:00',1.78),('9303','2013-09-26','14:00:00',2.39),('9303','2013-09-26','14:05:00',2.49),('9303','2013-09-26','14:10:00',3.71),('9303','2013-09-26','14:15:00',3.42),('9303','2013-09-26','14:20:00',3.49),('9303','2013-09-26','14:25:00',1.4),('9303','2013-09-26','14:30:00',1.6),('9303','2013-09-26','14:35:00',1.82),('9303','2013-09-26','14:40:00',1.75),('9303','2013-09-26','14:45:00',3.29),('9303','2013-09-26','14:50:00',3.61),('9303','2013-09-26','14:55:00',1.65),('9303','2013-09-26','15:00:00',1.06),('9303','2013-09-26','15:05:00',1.36),('9303','2013-09-26','15:10:00',1.28),('9303','2013-09-26','15:20:00',1.52),('9303','2013-09-26','15:25:00',2.35),('9303','2013-09-26','15:35:00',1.73),('9303','2013-09-26','15:45:00',2.54),('9303','2013-09-26','15:50:00',2.71),('9303','2013-09-26','15:55:00',2.46),('9303','2013-09-26','16:00:00',2.39),('9303','2013-09-26','16:05:00',2.27),('9303','2013-09-26','16:10:00',2.25),('9303','2013-09-26','16:15:00',2.1),('9303','2013-09-26','16:20:00',2.02),('9303','2013-09-26','16:25:00',1.96),('9303','2013-09-26','16:30:00',1.84),('9303','2013-09-26','16:35:00',1.74),('9303','2013-09-26','16:40:00',1.66),('9303','2013-09-26','16:45:00',1.57),('9303','2013-09-26','16:50:00',1.46),('9303','2013-09-26','16:55:00',1.4),('9303','2013-09-26','17:00:00',1.31),('9303','2013-09-26','17:05:00',1.25),('9303','2013-09-26','17:10:00',1.22),('9303','2013-09-26','17:15:00',1.08),('9303','2013-09-26','17:20:00',1.03),('9303','2013-09-25','08:45:00',1.13),('9303','2013-09-25','09:10:00',1.96),('9303','2013-09-25','09:15:00',1.63),('9303','2013-09-25','09:25:00',1.22),('9303','2013-09-25','09:30:00',1.84),('9303','2013-09-25','09:35:00',1.84),('9303','2013-09-25','09:40:00',2.14),('9303','2013-09-25','09:50:00',1.49),('9303','2013-09-25','09:55:00',1.11),('9303','2013-09-25','10:00:00',2.02),('9303','2013-09-25','10:40:00',1.28),('9303','2013-09-25','10:45:00',3.18),('9303','2013-09-25','10:50:00',3.53),('9303','2013-09-25','10:55:00',3.46),('9303','2013-09-25','11:00:00',2.36),('9303','2013-09-25','11:10:00',1.69),('9303','2013-09-25','11:15:00',2.14),('9303','2013-09-25','11:20:00',1.07),('9303','2013-09-25','11:25:00',2.89),('9303','2013-09-25','11:30:00',3.41),('9303','2013-09-25','11:35:00',2.91),('9303','2013-09-25','11:40:00',2.68),('9303','2013-09-25','11:45:00',3.48),('9303','2013-09-25','11:50:00',2.81),('9303','2013-09-25','11:55:00',2.08),('9303','2013-09-25','12:00:00',1.14),('9303','2013-09-25','12:15:00',3.56),('9303','2013-09-25','12:20:00',3.73),('9303','2013-09-25','12:25:00',2.54),('9303','2013-09-25','12:30:00',3.02),('9303','2013-09-25','12:35:00',3.13),('9303','2013-09-25','12:40:00',3.45),('9303','2013-09-25','13:00:00',1.48),('9303','2013-09-25','13:05:00',1.52),('9303','2013-09-25','13:10:00',1.73),('9303','2013-09-25','13:30:00',2.08),('9303','2013-09-25','13:35:00',2.78),('9303','2013-09-25','13:40:00',3.27),('9303','2013-09-25','13:45:00',4.02),('9303','2013-09-25','13:50:00',4.1),('9303','2013-09-25','13:55:00',3.58),('9303','2013-09-25','14:00:00',1.05),('9303','2013-09-25','14:10:00',1.06),('9303','2013-09-25','14:30:00',1.66),('9303','2013-09-25','14:35:00',1.25),('9303','2013-09-25','14:40:00',3.15),('9303','2013-09-25','14:45:00',2.53),('9303','2013-09-25','14:50:00',2.62),('9303','2013-09-25','14:55:00',3.42),('9303','2013-09-25','15:00:00',3.04),('9303','2013-09-25','15:05:00',3.45),('9303','2013-09-25','15:10:00',3.25),('9303','2013-09-25','15:15:00',3.17),('9303','2013-09-25','15:20:00',3.1),('9303','2013-09-25','15:25:00',2.91),('9303','2013-09-25','15:30:00',2.47),('9303','2013-09-25','15:35:00',2.9),('9303','2013-09-25','15:40:00',3.05),('9303','2013-09-25','15:45:00',2.72),('9303','2013-09-25','15:50:00',2.72),('9303','2013-09-25','15:55:00',2.64),('9303','2013-09-25','16:00:00',2.58),('9303','2013-09-25','16:05:00',2.49),('9303','2013-09-25','16:10:00',2.41),('9303','2013-09-25','16:15:00',2.31),('9303','2013-09-25','16:20:00',2.16),('9303','2013-09-25','16:30:00',1.95),('9303','2013-09-25','16:35:00',1.91),('9303','2013-09-25','16:40:00',1.58),('9303','2013-09-25','16:45:00',1.7),('9303','2013-09-25','16:50:00',1.59),('9303','2013-09-25','16:55:00',1.51),('9303','2013-09-25','17:00:00',1.43),('9303','2013-09-25','17:05:00',1.35),('9303','2013-09-25','17:10:00',1.26),('9303','2013-09-25','17:15:00',1.17),('9303','2013-09-25','17:20:00',1.08),('9303','2013-09-24','08:30:00',1.07),('9303','2013-09-24','08:35:00',1.18),('9303','2013-09-24','08:40:00',1.28),('9303','2013-09-24','08:45:00',1.37),('9303','2013-09-24','08:50:00',1.45),('9303','2013-09-24','08:55:00',1.56),('9303','2013-09-24','09:00:00',1.65),('9303','2013-09-24','09:05:00',1.72),('9303','2013-09-24','09:10:00',1.82),('9303','2013-09-24','09:15:00',1.89),('9303','2013-09-24','09:20:00',1.97),('9303','2013-09-24','09:25:00',2.05),('9303','2013-09-24','09:30:00',2.13),('9303','2013-09-24','09:35:00',2.2),('9303','2013-09-24','09:40:00',2.27),('9303','2013-09-24','09:45:00',2.33),('9303','2013-09-24','09:50:00',2.39),('9303','2013-09-24','09:55:00',2.44),('9303','2013-09-24','10:00:00',2.52),('9303','2013-09-24','10:05:00',2.59),('9303','2013-09-24','10:10:00',2.65),('9303','2013-09-24','10:15:00',2.71),('9303','2013-09-24','10:20:00',2.79),('9303','2013-09-24','10:25:00',2.83),('9303','2013-09-24','10:30:00',2.88),('9303','2013-09-24','10:35:00',2.92),('9303','2013-09-24','10:40:00',2.96),('9303','2013-09-24','10:45:00',3),('9303','2013-09-24','10:50:00',3.06),('9303','2013-09-24','10:55:00',3.13),('9303','2013-09-24','11:00:00',3.16),('9303','2013-09-24','11:05:00',3.19),('9303','2013-09-24','11:10:00',3.21),('9303','2013-09-24','11:15:00',3.2),('9303','2013-09-24','11:20:00',3.26),('9303','2013-09-24','11:25:00',3.32),('9303','2013-09-24','11:30:00',3.33),('9303','2013-09-24','11:35:00',3.37),('9303','2013-09-24','11:40:00',3.38),('9303','2013-09-24','11:45:00',3.41),('9303','2013-09-24','11:50:00',3.43),('9303','2013-09-24','11:55:00',3.42),('9303','2013-09-24','12:00:00',3.44),('9303','2013-09-24','12:05:00',3.45),('9303','2013-09-24','12:10:00',3.51),('9303','2013-09-24','12:15:00',3.52),('9303','2013-09-24','12:20:00',3.5),('9303','2013-09-24','12:25:00',3.5),('9303','2013-09-24','12:30:00',3.49),('9303','2013-09-24','12:35:00',3.57),('9303','2013-09-24','12:40:00',3.6),('9303','2013-09-24','12:45:00',3.59),('9303','2013-09-24','12:50:00',3.59),('9303','2013-09-24','12:55:00',3.56),('9303','2013-09-24','13:00:00',3.59),('9303','2013-09-24','13:05:00',3.58),('9303','2013-09-24','13:10:00',3.6),('9303','2013-09-24','13:15:00',3.61),('9303','2013-09-24','13:20:00',3.59),('9303','2013-09-24','13:25:00',3.6),('9303','2013-09-24','13:30:00',3.55),('9303','2013-09-24','13:35:00',3.52),('9303','2013-09-24','13:40:00',3.54),('9303','2013-09-24','13:45:00',3.56),('9303','2013-09-24','13:50:00',3.52),('9303','2013-09-24','13:55:00',3.51),('9303','2013-09-24','14:00:00',3.48),('9303','2013-09-24','14:05:00',3.48),('9303','2013-09-24','14:10:00',3.43),('9303','2013-09-24','14:15:00',3.41),('9303','2013-09-24','14:20:00',3.37),('9303','2013-09-24','14:25:00',3.34),('9303','2013-09-24','14:30:00',3.31),('9303','2013-09-24','14:35:00',3.28),('9303','2013-09-24','14:40:00',3.26),('9303','2013-09-24','14:45:00',3.24),('9303','2013-09-24','14:50:00',3.17),('9303','2013-09-24','14:55:00',3.14),('9303','2013-09-24','15:00:00',3.06),('9303','2013-09-24','15:05:00',3.05),('9303','2013-09-24','15:10:00',3.01),('9303','2013-09-24','15:15:00',2.96),('9303','2013-09-24','15:20:00',2.94),('9303','2013-09-24','15:25:00',2.91),('9303','2013-09-24','15:30:00',2.86),('9303','2013-09-24','15:35:00',2.8),('9303','2013-09-24','15:40:00',2.74),('9303','2013-09-24','15:45:00',2.68),('9303','2013-09-24','15:50:00',2.62),('9303','2013-09-24','15:55:00',2.54),('9303','2013-09-24','16:00:00',2.48),('9303','2013-09-24','16:05:00',2.4),('9303','2013-09-24','16:10:00',2.34),('9303','2013-09-24','16:15:00',2.28),('9303','2013-09-24','16:20:00',2.17),('9303','2013-09-24','16:25:00',2.05),('9303','2013-09-24','16:30:00',1.94),('9303','2013-09-24','16:35:00',1.86),('9303','2013-09-24','16:40:00',1.78),('9303','2013-09-24','16:45:00',1.7),('9303','2013-09-24','16:50:00',1.62),('9303','2013-09-24','16:55:00',1.54),('9303','2013-09-24','17:00:00',1.47),('9303','2013-09-24','17:05:00',1.38),('9303','2013-09-24','17:10:00',1.29),('9303','2013-09-24','17:15:00',1.2),('9303','2013-09-24','17:20:00',1.1),('9303','2013-09-24','17:25:00',1.01),('9303','2013-09-23','08:25:00',1.03),('9303','2013-09-23','08:30:00',1.13),('9303','2013-09-23','08:35:00',1.22),('9303','2013-09-23','08:40:00',1.32),('9303','2013-09-23','08:45:00',1.43),('9303','2013-09-23','08:50:00',1.49),('9303','2013-09-23','08:55:00',1.61),('9303','2013-09-23','09:00:00',1.7),('9303','2013-09-23','09:05:00',1.79),('9303','2013-09-23','09:10:00',1.88),('9303','2013-09-23','09:15:00',1.95),('9303','2013-09-23','09:20:00',2.03),('9303','2013-09-23','09:25:00',2.11),('9303','2013-09-23','09:30:00',2.18),('9303','2013-09-23','09:35:00',2.25),('9303','2013-09-23','09:40:00',2.32),('9303','2013-09-23','09:45:00',2.4),('9303','2013-09-23','09:50:00',2.46),('9303','2013-09-23','09:55:00',2.53),('9303','2013-09-23','10:00:00',2.6),('9303','2013-09-23','10:05:00',2.67),('9303','2013-09-23','10:10:00',2.72),('9303','2013-09-23','10:15:00',2.78),('9303','2013-09-23','10:20:00',2.83),('9303','2013-09-23','10:25:00',2.88),('9303','2013-09-23','10:30:00',2.91),('9303','2013-09-23','10:35:00',2.97),('9303','2013-09-23','10:40:00',3.02),('9303','2013-09-23','10:45:00',3.07),('9303','2013-09-23','10:50:00',3.15),('9303','2013-09-23','10:55:00',3.18),('9303','2013-09-23','11:00:00',3.2),('9303','2013-09-23','11:05:00',3.27),('9303','2013-09-23','11:10:00',3.34),('9303','2013-09-23','11:15:00',3.4),('9303','2013-09-23','11:20:00',3.43),('9303','2013-09-23','11:25:00',3.47),('9303','2013-09-23','11:30:00',3.49),('9303','2013-09-23','11:35:00',3.52),('9303','2013-09-23','11:40:00',3.52),('9303','2013-09-23','11:45:00',3.55),('9303','2013-09-23','11:50:00',3.58),('9303','2013-09-23','11:55:00',3.59),('9303','2013-09-23','12:00:00',3.63),('9303','2013-09-23','12:05:00',3.67),('9303','2013-09-23','12:10:00',3.71),('9303','2013-09-23','12:15:00',3.74),('9303','2013-09-23','12:20:00',3.73),('9303','2013-09-23','12:25:00',3.7),('9303','2013-09-23','12:30:00',3.69),('9303','2013-09-23','12:35:00',3.69),('9303','2013-09-23','12:40:00',3.68),('9303','2013-09-23','12:45:00',3.7),('9303','2013-09-23','12:50:00',3.7),('9303','2013-09-23','12:55:00',3.72),('9303','2013-09-23','13:00:00',3.74),('9303','2013-09-23','13:05:00',3.69),('9303','2013-09-23','13:10:00',3.7),('9303','2013-09-23','13:15:00',3.69),('9303','2013-09-23','13:20:00',3.65),('9303','2013-09-23','13:25:00',3.65),('9303','2013-09-23','13:30:00',3.63),('9303','2013-09-23','13:35:00',3.6),('9303','2013-09-23','13:40:00',3.61),('9303','2013-09-23','13:45:00',3.59),('9303','2013-09-23','13:50:00',3.57),('9303','2013-09-23','13:55:00',3.53),('9303','2013-09-23','14:00:00',3.46),('9303','2013-09-23','14:05:00',3.41),('9303','2013-09-23','14:10:00',3.4),('9303','2013-09-23','14:15:00',3.42),('9303','2013-09-23','14:20:00',3.4),('9303','2013-09-23','14:25:00',3.42),('9303','2013-09-23','14:30:00',3.46),('9303','2013-09-23','14:35:00',3.36),('9303','2013-09-23','14:40:00',3.31),('9303','2013-09-23','14:45:00',3.24),('9303','2013-09-23','14:50:00',3.16),('9303','2013-09-23','14:55:00',3.18),('9303','2013-09-23','15:00:00',3.18),('9303','2013-09-23','15:05:00',3.04),('9303','2013-09-23','15:10:00',2.01),('9303','2013-09-23','15:15:00',3.01),('9303','2013-09-23','15:20:00',2.93),('9303','2013-09-23','15:25:00',2.88),('9303','2013-09-23','15:30:00',2.83),('9303','2013-09-23','15:35:00',2.8),('9303','2013-09-23','15:40:00',2.73),('9303','2013-09-23','15:45:00',2.68),('9303','2013-09-23','15:50:00',2.47),('9303','2013-09-23','15:55:00',1.86),('9303','2013-09-23','16:00:00',2.32),('9303','2013-09-23','16:05:00',2.39),('9303','2013-09-23','16:10:00',2.21),('9303','2013-09-23','16:15:00',2.2),('9303','2013-09-23','16:20:00',1.92),('9303','2013-09-23','16:25:00',1.83),('9303','2013-09-23','16:30:00',1.81),('9303','2013-09-23','16:35:00',1.79),('9303','2013-09-23','16:40:00',1.75),('9303','2013-09-23','16:45:00',1.67),('9303','2013-09-23','16:50:00',1.58),('9303','2013-09-23','16:55:00',1.49),('9303','2013-09-23','17:00:00',1.42),('9303','2013-09-23','17:05:00',1.34),('9303','2013-09-23','17:10:00',1.27),('9303','2013-09-23','17:15:00',1.19),('9303','2013-09-23','17:20:00',1.09),('9303','2013-09-22','08:25:00',1.02),('9303','2013-09-22','08:30:00',1.09),('9303','2013-09-22','08:35:00',1.18),('9303','2013-09-22','08:40:00',1.27),('9303','2013-09-22','08:45:00',1.37),('9303','2013-09-22','08:50:00',1.45),('9303','2013-09-22','08:55:00',1.58),('9303','2013-09-22','09:00:00',1.66),('9303','2013-09-22','09:05:00',1.76),('9303','2013-09-22','09:10:00',1.86),('9303','2013-09-22','09:15:00',1.95),('9303','2013-09-22','09:20:00',2.02),('9303','2013-09-22','09:25:00',2.11),('9303','2013-09-22','09:30:00',2.18),('9303','2013-09-22','09:35:00',2.25),('9303','2013-09-22','09:40:00',2.3),('9303','2013-09-22','09:45:00',2.37),('9303','2013-09-22','09:50:00',2.44),('9303','2013-09-22','09:55:00',2.53),('9303','2013-09-22','10:00:00',2.6),('9303','2013-09-22','10:05:00',2.68),('9303','2013-09-22','10:10:00',2.75),('9303','2013-09-22','10:15:00',2.8),('9303','2013-09-22','10:20:00',2.87),('9303','2013-09-22','10:25:00',2.93),('9303','2013-09-22','10:30:00',3.01),('9303','2013-09-22','10:35:00',3.05),('9303','2013-09-22','10:40:00',3.09),('9303','2013-09-22','10:45:00',3.15),('9303','2013-09-22','10:50:00',3.17),('9303','2013-09-22','10:55:00',3.22),('9303','2013-09-22','11:00:00',3.26),('9303','2013-09-22','11:05:00',3.29),('9303','2013-09-22','11:10:00',3.32),('9303','2013-09-22','11:15:00',3.36),('9303','2013-09-22','11:20:00',3.42),('9303','2013-09-22','11:25:00',3.49),('9303','2013-09-22','11:30:00',3.52),('9303','2013-09-22','11:35:00',3.58),('9303','2013-09-22','11:40:00',3.61),('9303','2013-09-22','11:45:00',3.63),('9303','2013-09-22','11:50:00',3.66),('9303','2013-09-22','11:55:00',3.71),('9303','2013-09-22','12:00:00',3.73),('9303','2013-09-22','12:05:00',3.73),('9303','2013-09-22','12:10:00',3.73),('9303','2013-09-22','12:15:00',3.75),('9303','2013-09-22','12:20:00',3.77),('9303','2013-09-22','12:25:00',3.82),('9303','2013-09-22','12:30:00',3.8),('9303','2013-09-22','12:35:00',3.81),('9303','2013-09-22','12:40:00',3.83),('9303','2013-09-22','12:45:00',3.73),('9303','2013-09-22','12:50:00',3.87),('9303','2013-09-22','12:55:00',3.91),('9303','2013-09-22','13:00:00',3.86),('9303','2013-09-22','13:05:00',3.83),('9303','2013-09-22','13:10:00',3.85),('9303','2013-09-22','13:15:00',3.81),('9303','2013-09-22','13:20:00',3.78),('9303','2013-09-22','13:25:00',3.76),('9303','2013-09-22','13:30:00',3.76),('9303','2013-09-22','13:35:00',3.74),('9303','2013-09-22','13:40:00',3.73),('9303','2013-09-22','13:45:00',3.74),('9303','2013-09-22','13:50:00',3.75),('9303','2013-09-22','13:55:00',3.34),('9303','2013-09-22','14:00:00',3.68),('9303','2013-09-22','14:05:00',3.71),('9303','2013-09-22','14:10:00',3.63),('9303','2013-09-22','14:15:00',3.74),('9303','2013-09-22','14:20:00',2.08),('9303','2013-09-22','14:25:00',3.15),('9303','2013-09-22','14:30:00',2.27),('9303','2013-09-22','14:35:00',3.61),('9303','2013-09-22','14:40:00',2.59),('9303','2013-09-22','14:45:00',2.9),('9303','2013-09-22','14:50:00',3.41),('9303','2013-09-22','14:55:00',3.37),('9303','2013-09-22','15:00:00',3.41),('9303','2013-09-22','15:05:00',3.48),('9303','2013-09-22','15:10:00',3.34),('9303','2013-09-22','15:15:00',3.53),('9303','2013-09-22','15:20:00',3.49),('9303','2013-09-22','15:25:00',1.66),('9303','2013-09-22','15:40:00',2.61),('9303','2013-09-22','15:45:00',2.97),('9303','2013-09-22','15:50:00',2.81),('9303','2013-09-22','15:55:00',2.81),('9303','2013-09-22','16:00:00',3.02),('9303','2013-09-22','16:05:00',2.93),('9303','2013-09-22','16:10:00',3.23),('9303','2013-09-22','16:15:00',2.65),('9303','2013-09-22','16:20:00',1.73),('9303','2013-09-22','16:25:00',1.37),('9303','2013-09-22','16:30:00',1.01),('9303','2013-09-22','16:45:00',1.92),('9303','2013-09-22','16:50:00',1.66),('9303','2013-09-22','16:55:00',1.28),('9303','2013-09-22','17:05:00',1.59),('9303','2013-09-21','08:25:00',1.03),('9303','2013-09-21','08:30:00',1.12),('9303','2013-09-21','08:35:00',1.2),('9303','2013-09-21','08:40:00',1.29),('9303','2013-09-21','08:45:00',1.38),('9303','2013-09-21','08:50:00',1.46),('9303','2013-09-21','08:55:00',1.57),('9303','2013-09-21','09:00:00',1.65),('9303','2013-09-21','09:05:00',1.73),('9303','2013-09-21','09:10:00',1.81),('9303','2013-09-21','09:15:00',1.88),('9303','2013-09-21','09:20:00',1.97),('9303','2013-09-21','09:25:00',2.04),('9303','2013-09-21','09:30:00',2.11),('9303','2013-09-21','09:35:00',2.2),('9303','2013-09-21','09:40:00',2.27),('9303','2013-09-21','09:45:00',2.34),('9303','2013-09-21','09:50:00',2.4),('9303','2013-09-21','09:55:00',2.47),('9303','2013-09-21','10:00:00',2.54),('9303','2013-09-21','10:05:00',2.6),('9303','2013-09-21','10:10:00',2.66),('9303','2013-09-21','10:15:00',2.72),('9303','2013-09-21','10:20:00',2.78),('9303','2013-09-21','10:25:00',2.86),('9303','2013-09-21','10:30:00',2.89),('9303','2013-09-21','10:35:00',2.94),('9303','2013-09-21','10:40:00',2.99),('9303','2013-09-21','10:45:00',3.05),('9303','2013-09-21','10:50:00',3.09),('9303','2013-09-21','10:55:00',3.15),('9303','2013-09-21','11:00:00',3.18),('9303','2013-09-21','11:05:00',3.22),('9303','2013-09-21','11:10:00',3.28),('9303','2013-09-21','11:15:00',3.31),('9303','2013-09-21','11:20:00',3.33),('9303','2013-09-21','11:25:00',3.39),('9303','2013-09-21','11:30:00',3.39),('9303','2013-09-21','11:35:00',3.44),('9303','2013-09-21','11:40:00',3.49),('9303','2013-09-21','11:45:00',3.52),('9303','2013-09-21','11:50:00',3.54),('9303','2013-09-21','11:55:00',3.44),('9303','2013-09-21','12:00:00',3.57),('9303','2013-09-21','12:05:00',3.65),('9303','2013-09-21','12:10:00',3.66),('9303','2013-09-21','12:15:00',3.65),('9303','2013-09-21','12:20:00',3.64),('9303','2013-09-21','12:25:00',3.3),('9303','2013-09-21','12:30:00',3.76),('9303','2013-09-21','12:35:00',3.67),('9303','2013-09-21','12:40:00',3.32),('9303','2013-09-21','12:45:00',3.46),('9303','2013-09-21','12:50:00',3.71),('9303','2013-09-21','12:55:00',3.73),('9303','2013-09-21','13:00:00',3.71),('9303','2013-09-21','13:05:00',3.57),('9303','2013-09-21','13:10:00',3.73),('9303','2013-09-21','13:15:00',3.79),('9303','2013-09-21','13:20:00',3.05),('9303','2013-09-21','13:25:00',3.4),('9303','2013-09-21','13:30:00',3.48),('9303','2013-09-21','13:35:00',3.59),('9303','2013-09-21','13:40:00',3.16),('9303','2013-09-21','13:45:00',3.11),('9303','2013-09-21','13:50:00',3.25),('9303','2013-09-21','13:55:00',3.3),('9303','2013-09-21','14:00:00',3.28),('9303','2013-09-21','14:05:00',3.45),('9303','2013-09-21','14:10:00',3.31),('9303','2013-09-21','14:15:00',3.49),('9303','2013-09-21','14:20:00',3.54),('9303','2013-09-21','14:25:00',3.47),('9303','2013-09-21','14:30:00',3.41),('9303','2013-09-21','14:35:00',3.38),('9303','2013-09-21','14:40:00',3.34),('9303','2013-09-21','14:45:00',3.27),('9303','2013-09-21','14:50:00',3.25),('9303','2013-09-21','14:55:00',3.19),('9303','2013-09-21','15:00:00',3.15),('9303','2013-09-21','15:05:00',3.1),('9303','2013-09-21','15:10:00',2.97),('9303','2013-09-21','15:15:00',2.99),('9303','2013-09-21','15:20:00',2.97),('9303','2013-09-21','15:25:00',2.91),('9303','2013-09-21','15:30:00',2.87),('9303','2013-09-21','15:35:00',2.82),('9303','2013-09-21','15:40:00',2.56),('9303','2013-09-21','15:45:00',2.01),('9303','2013-09-21','15:50:00',2.32),('9303','2013-09-21','15:55:00',2.6),('9303','2013-09-21','16:00:00',2.04),('9303','2013-09-21','16:05:00',1.24),('9303','2013-09-21','16:10:00',1.6),('9303','2013-09-21','16:15:00',1.35),('9303','2013-09-21','16:20:00',1.64),('9303','2013-09-21','16:30:00',1.13),('9303','2013-09-21','16:35:00',1.33),('9303','2013-09-21','17:15:00',1.05),('9303','2013-09-20','08:35:00',1.24),('9303','2013-09-20','08:40:00',1.57),('9303','2013-09-20','08:45:00',1.38),('9303','2013-09-20','09:00:00',1.01),('9303','2013-09-20','09:05:00',1.2),('9303','2013-09-20','09:15:00',1.02),('9303','2013-09-20','09:20:00',1.48),('9303','2013-09-20','09:25:00',1.95),('9303','2013-09-20','09:30:00',1.2),('9303','2013-09-20','09:35:00',1.11),('9303','2013-09-20','09:40:00',1.13),('9303','2013-09-20','09:45:00',1.16),('9303','2013-09-20','09:50:00',1.19),('9303','2013-09-20','09:55:00',1.3),('9303','2013-09-20','10:00:00',1.43),('9303','2013-09-20','10:05:00',2.22),('9303','2013-09-20','10:10:00',2.48),('9303','2013-09-20','10:15:00',2.2),('9303','2013-09-20','10:20:00',3.01),('9303','2013-09-20','10:25:00',1.71),('9303','2013-09-20','10:30:00',1.87),('9303','2013-09-20','10:35:00',2.11),('9303','2013-09-20','10:40:00',2.04),('9303','2013-09-20','10:45:00',2.01),('9303','2013-09-20','10:50:00',2.5),('9303','2013-09-20','10:55:00',2.25),('9303','2013-09-20','11:00:00',2.18),('9303','2013-09-20','11:05:00',1.81),('9303','2013-09-20','11:10:00',1.96),('9303','2013-09-20','11:15:00',2.06),('9303','2013-09-20','11:20:00',2.54),('9303','2013-09-20','11:25:00',2.42),('9303','2013-09-20','11:30:00',2.69),('9303','2013-09-20','11:35:00',3.02),('9303','2013-09-20','11:40:00',2.69),('9303','2013-09-20','11:45:00',3.59),('9303','2013-09-20','11:50:00',3.81),('9303','2013-09-20','11:55:00',3.71),('9303','2013-09-20','12:00:00',3.59),('9303','2013-09-20','12:05:00',3.58),('9303','2013-09-20','12:10:00',3.62),('9303','2013-09-20','12:15:00',3.68),('9303','2013-09-20','12:20:00',3.77),('9303','2013-09-20','12:25:00',3.8),('9303','2013-09-20','12:30:00',3.13),('9303','2013-09-20','12:35:00',3.51),('9303','2013-09-20','12:40:00',3.03),('9303','2013-09-20','12:45:00',3.47),('9303','2013-09-20','12:50:00',3.37),('9303','2013-09-20','12:55:00',3.79),('9303','2013-09-20','13:00:00',3.28),('9303','2013-09-20','13:05:00',3.42),('9303','2013-09-20','13:10:00',3.82),('9303','2013-09-20','13:15:00',3.22),('9303','2013-09-20','13:20:00',3.54),('9303','2013-09-20','13:25:00',3.93),('9303','2013-09-20','13:30:00',3.74),('9303','2013-09-20','13:35:00',2.37),('9303','2013-09-20','13:40:00',3.17),('9303','2013-09-20','13:45:00',3.56),('9303','2013-09-20','13:50:00',3.64),('9303','2013-09-20','13:55:00',3.34),('9303','2013-09-20','14:00:00',3.6),('9303','2013-09-20','14:05:00',3.66),('9303','2013-09-20','14:10:00',3.65),('9303','2013-09-20','14:15:00',3.58),('9303','2013-09-20','14:20:00',1.62),('9303','2013-09-20','14:25:00',1.5),('9303','2013-09-20','14:30:00',3.49),('9303','2013-09-20','14:35:00',3.66),('9303','2013-09-20','14:40:00',3.06),('9303','2013-09-20','14:45:00',3.43),('9303','2013-09-20','14:50:00',3.52),('9303','2013-09-20','14:55:00',3.46),('9303','2013-09-20','15:00:00',2.96),('9303','2013-09-20','15:05:00',1.56),('9303','2013-09-20','15:10:00',2.92),('9303','2013-09-20','15:15:00',2.26),('9303','2013-09-20','15:20:00',1.28),('9303','2013-09-20','15:25:00',2.35),('9303','2013-09-20','15:30:00',1.62),('9303','2013-09-20','15:35:00',1.38),('9303','2013-09-20','15:40:00',1.04),('9303','2013-09-20','15:45:00',2.96),('9303','2013-09-20','15:50:00',2.87),('9303','2013-09-20','15:55:00',2.93),('9303','2013-09-20','16:00:00',2.27),('9303','2013-09-20','16:05:00',1.59),('9303','2013-09-20','16:10:00',2.42),('9303','2013-09-20','16:15:00',2.22),('9303','2013-09-20','16:20:00',1.06),('9303','2013-09-20','16:25:00',1.07),('9303','2013-09-20','16:45:00',1.01),('9303','2013-09-20','16:50:00',1.05),('9303','2013-09-20','16:55:00',1.02),('9303','2013-09-20','17:00:00',1.71),('9303','2013-09-20','17:05:00',2.01),('9303','2013-09-20','17:10:00',1.97),('9303','2013-09-20','17:15:00',1.81),('9303','2013-09-20','17:20:00',1.71),('9303','2013-09-20','17:25:00',1.39),('9303','2013-09-20','17:30:00',1.16),('9303','2013-09-20','17:35:00',1.01),('9303','2013-09-19','08:30:00',1.13),('9303','2013-09-19','08:35:00',1.18),('9303','2013-09-19','08:45:00',1.3),('9303','2013-09-19','08:50:00',1.14),('9303','2013-09-19','09:00:00',1.06),('9303','2013-09-19','09:10:00',1.26),('9303','2013-09-19','09:15:00',1.81),('9303','2013-09-19','09:20:00',1.08),('9303','2013-09-19','10:05:00',1.94),('9303','2013-09-19','10:10:00',2.22),('9303','2013-09-19','10:15:00',2.52),('9303','2013-09-19','10:25:00',1.11),('9303','2013-09-19','10:35:00',2.55),('9303','2013-09-19','10:40:00',3.31),('9303','2013-09-19','10:45:00',1.97),('9303','2013-09-19','10:50:00',1.41),('9303','2013-09-19','10:55:00',2.43),('9303','2013-09-19','11:00:00',3.44),('9303','2013-09-19','11:05:00',3.23),('9303','2013-09-19','11:10:00',1.59),('9303','2013-09-19','11:15:00',1.77),('9303','2013-09-19','11:20:00',2.32),('9303','2013-09-19','11:25:00',1.65),('9303','2013-09-19','11:30:00',4.5),('9303','2013-09-19','11:35:00',2.5),('9303','2013-09-19','11:40:00',3.16),('9303','2013-09-19','11:45:00',2.6),('9303','2013-09-19','11:50:00',3.63),('9303','2013-09-19','11:55:00',3.41),('9303','2013-09-19','12:00:00',3.05),('9303','2013-09-19','12:05:00',2.08),('9303','2013-09-19','12:10:00',3.17),('9303','2013-09-19','12:15:00',2.48),('9303','2013-09-19','12:20:00',3.65),('9303','2013-09-19','12:25:00',4.33),('9303','2013-09-19','12:30:00',4.14),('9303','2013-09-19','12:35:00',3.81),('9303','2013-09-19','12:40:00',3.43),('9303','2013-09-19','12:45:00',2.07),('9303','2013-09-19','12:50:00',4.11),('9303','2013-09-19','12:55:00',4),('9303','2013-09-19','13:00:00',4.04),('9303','2013-09-19','13:05:00',4.05),('9303','2013-09-19','13:10:00',4.21),('9303','2013-09-19','13:15:00',3.72),('9303','2013-09-19','13:20:00',3.62),('9303','2013-09-19','13:25:00',1.87),('9303','2013-09-19','13:30:00',4.06),('9303','2013-09-19','13:35:00',4.06),('9303','2013-09-19','13:40:00',4.02),('9303','2013-09-19','13:45:00',3.63),('9303','2013-09-19','13:50:00',1.21),('9303','2013-09-19','14:00:00',1.18),('9303','2013-09-19','14:05:00',2.83),('9303','2013-09-19','14:10:00',3.7),('9303','2013-09-19','14:15:00',3.72),('9303','2013-09-19','14:20:00',3.66),('9303','2013-09-19','14:25:00',3.33),('9303','2013-09-19','14:30:00',3.56),('9303','2013-09-19','14:35:00',3.49),('9303','2013-09-19','14:40:00',3.45),('9303','2013-09-19','14:45:00',3.31),('9303','2013-09-19','14:50:00',3.21),('9303','2013-09-19','14:55:00',3.05),('9303','2013-09-19','15:00:00',3.43),('9303','2013-09-19','15:05:00',3.31),('9303','2013-09-19','15:10:00',2.55),('9303','2013-09-19','15:15:00',3.19),('9303','2013-09-19','15:20:00',3.18),('9303','2013-09-19','15:25:00',2.61),('9303','2013-09-19','15:30:00',2.27),('9303','2013-09-19','15:35:00',1.5),('9303','2013-09-19','15:40:00',2.86),('9303','2013-09-19','15:45:00',2.65),('9303','2013-09-19','15:50:00',2.79),('9303','2013-09-19','15:55:00',2.55),('9303','2013-09-19','16:00:00',2.64),('9303','2013-09-19','16:05:00',2.46),('9303','2013-09-19','16:10:00',1.47),('9303','2013-09-19','16:15:00',2.04),('9303','2013-09-19','16:20:00',2.47),('9303','2013-09-19','16:25:00',2.16),('9303','2013-09-19','16:30:00',1.87),('9303','2013-09-19','16:35:00',1.12),('9303','2013-09-19','16:40:00',1.17),('9303','2013-09-19','16:45:00',1.1),('9303','2013-09-19','16:50:00',1.15),('9303','2013-09-19','16:55:00',1.39),('9303','2013-09-19','17:00:00',1.55),('9303','2013-09-19','17:05:00',1.5),('9303','2013-09-19','17:10:00',1.41),('9303','2013-09-19','17:15:00',1.32),('9303','2013-09-19','17:20:00',1.24),('9303','2013-09-19','17:25:00',1.07),('9303','2014-04-13','09:05:00',1.16),('9303','2014-04-13','09:10:00',1.44),('9303','2014-04-13','09:15:00',1.23),('9303','2014-04-13','09:20:00',1.45),('9303','2014-04-13','09:25:00',1.79),('9303','2014-04-13','09:30:00',1.73),('9303','2014-04-13','09:35:00',1.38),('9303','2014-04-13','09:40:00',2.26),('9303','2014-04-13','09:45:00',1.66),('9303','2014-04-13','09:50:00',1.49),('9303','2014-04-13','09:55:00',1.51),('9303','2014-04-13','10:00:00',2.62),('9303','2014-04-13','10:05:00',3.45),('9303','2014-04-13','10:10:00',1.99),('9303','2014-04-13','10:15:00',2.44),('9303','2014-04-13','10:20:00',3.3),('9303','2014-04-13','10:25:00',1.69),('9303','2014-04-13','10:30:00',3.69),('9303','2014-04-13','10:35:00',3.39),('9303','2014-04-13','10:40:00',3.29),('9303','2014-04-13','10:45:00',3.53),('9303','2014-04-13','10:50:00',3.56),('9303','2014-04-13','10:55:00',3.54),('9303','2014-04-13','11:00:00',3.59),('9303','2014-04-13','11:05:00',3.66),('9303','2014-04-13','11:10:00',3.56),('9303','2014-04-13','11:15:00',3.88),('9303','2014-04-13','11:20:00',4.52),('9303','2014-04-13','11:25:00',2.94),('9303','2014-04-13','11:30:00',1.96),('9303','2014-04-13','11:35:00',3.81),('9303','2014-04-13','11:40:00',3.93),('9303','2014-04-13','11:45:00',3.63),('9303','2014-04-13','11:50:00',3.75),('9303','2014-04-13','11:55:00',2.55),('9303','2014-04-13','12:00:00',2.61),('9303','2014-04-13','12:05:00',1.55),('9303','2014-04-13','12:10:00',1.39),('9303','2014-04-13','12:15:00',1.25),('9303','2014-04-13','12:20:00',1.06),('9303','2014-04-13','13:05:00',1.23),('9303','2014-04-13','13:10:00',1.87),('9303','2014-04-13','13:15:00',1.83),('9303','2014-04-13','13:20:00',2.27),('9303','2014-04-13','13:25:00',2.67),('9303','2014-04-13','13:30:00',4.21),('9303','2014-04-13','13:35:00',3.9),('9303','2014-04-13','13:40:00',3.62),('9303','2014-04-13','13:45:00',2),('9303','2014-04-13','13:50:00',2.93),('9303','2014-04-13','13:55:00',3.26),('9303','2014-04-13','14:00:00',4.02),('9303','2014-04-13','14:05:00',3.2),('9303','2014-04-13','14:10:00',3.82),('9303','2014-04-13','14:15:00',3.5),('9303','2014-04-13','14:20:00',1.91),('9303','2014-04-13','14:25:00',1.53),('9303','2014-04-13','14:30:00',1.51),('9303','2014-04-13','14:35:00',1.5),('9303','2014-04-13','14:40:00',1.28),('9303','2014-04-13','14:45:00',2.5),('9303','2014-04-13','14:50:00',2.73),('9303','2014-04-13','14:55:00',2.31),('9303','2014-04-13','15:00:00',3.12),('9303','2014-04-13','15:05:00',3.58),('9303','2014-04-13','15:10:00',3.71),('9303','2014-04-13','15:15:00',3.29),('9303','2014-04-13','15:20:00',3.28),('9303','2014-04-13','15:25:00',3.28),('9303','2014-04-13','15:30:00',3.18),('9303','2014-04-13','15:35:00',2.25),('9303','2014-04-13','15:40:00',1.24),('9303','2014-04-13','15:45:00',1.42),('9303','2014-04-13','15:50:00',1.63),('9303','2014-04-13','15:55:00',2.15),('9303','2014-04-13','16:00:00',3.36),('9303','2014-04-13','16:05:00',2.24),('9303','2014-04-13','16:10:00',1.26),('9303','2014-04-13','16:15:00',1.56),('9303','2014-04-13','16:20:00',1.36),('9303','2014-04-13','16:25:00',1.38),('9303','2014-04-13','16:30:00',1.29),('9303','2014-04-13','16:35:00',1.78),('9303','2014-04-13','16:40:00',2.74),('9303','2014-04-13','16:45:00',2.96),('9303','2014-04-13','16:50:00',1.71),('9303','2014-04-13','16:55:00',2.45),('9303','2014-04-13','17:00:00',2.22),('9303','2014-04-13','17:05:00',1.33),('9303','2014-04-13','17:15:00',1.12),('9303','2014-04-13','17:20:00',1.53),('9303','2014-04-13','17:25:00',1.1),('9303','2014-04-13','17:55:00',1.03),('9303','2013-09-18','08:45:00',1.03),('9303','2013-09-18','08:55:00',1),('9303','2013-09-18','09:00:00',1.06),('9303','2013-09-18','09:05:00',1.58),('9303','2013-09-18','09:15:00',1.18),('9303','2013-09-18','09:20:00',2.17),('9303','2013-09-18','09:25:00',1.84),('9303','2013-09-18','09:30:00',1.5),('9303','2013-09-18','09:35:00',1.48),('9303','2013-09-18','09:40:00',2.48),('9303','2013-09-18','09:45:00',1.29),('9303','2013-09-18','09:55:00',1.47),('9303','2013-09-18','10:00:00',2.06),('9303','2013-09-18','10:05:00',3.03),('9303','2013-09-18','10:10:00',2.85),('9303','2013-09-18','10:15:00',2.7),('9303','2013-09-18','10:20:00',2.7),('9303','2013-09-18','10:25:00',2.78),('9303','2013-09-18','10:30:00',2.82),('9303','2013-09-18','10:35:00',2.88),('9303','2013-09-18','10:40:00',2.93),('9303','2013-09-18','10:45:00',2.97),('9303','2013-09-18','10:50:00',2.77),('9303','2013-09-18','10:55:00',1.74),('9303','2013-09-18','11:00:00',3.42),('9303','2013-09-18','11:05:00',2.29),('9303','2013-09-18','11:10:00',2.96),('9303','2013-09-18','11:15:00',3.56),('9303','2013-09-18','11:20:00',2.47),('9303','2013-09-18','11:25:00',3.69),('9303','2013-09-18','11:30:00',3.78),('9303','2013-09-18','11:35:00',3.17),('9303','2013-09-18','11:40:00',2.13),('9303','2013-09-18','11:45:00',1.6),('9303','2013-09-18','11:50:00',3.76),('9303','2013-09-18','11:55:00',3.81),('9303','2013-09-18','12:00:00',3.63),('9303','2013-09-18','12:05:00',2.6),('9303','2013-09-18','12:10:00',3.96),('9303','2013-09-18','12:15:00',4),('9303','2013-09-18','12:20:00',3.87),('9303','2013-09-18','12:25:00',3.91),('9303','2013-09-18','12:30:00',2.46),('9303','2013-09-18','12:35:00',2.38),('9303','2013-09-18','12:40:00',4.03),('9303','2013-09-18','12:45:00',4.05),('9303','2013-09-18','12:50:00',4.02),('9303','2013-09-18','12:55:00',4.01),('9303','2013-09-18','13:00:00',3.25),('9303','2013-09-18','13:05:00',2.59),('9303','2013-09-18','13:10:00',4.05),('9303','2013-09-18','13:15:00',2.85),('9303','2013-09-18','13:20:00',3.99),('9303','2013-09-18','13:25:00',3.29),('9303','2013-09-18','13:30:00',3.94),('9303','2013-09-18','13:35:00',3.85),('9303','2013-09-18','13:40:00',3.81),('9303','2013-09-18','13:45:00',3.82),('9303','2013-09-18','13:50:00',2.92),('9303','2013-09-18','13:55:00',2.91),('9303','2013-09-18','14:00:00',3.9),('9303','2013-09-18','14:05:00',3.6),('9303','2013-09-18','14:10:00',3.74),('9303','2013-09-18','14:15:00',3.69),('9303','2013-09-18','14:20:00',3.67),('9303','2013-09-18','14:25:00',3.62),('9303','2013-09-18','14:30:00',3.53),('9303','2013-09-18','14:35:00',3.52),('9303','2013-09-18','14:40:00',3.51),('9303','2013-09-18','14:45:00',3.44),('9303','2013-09-18','14:50:00',3.48),('9303','2013-09-18','14:55:00',3.24),('9303','2013-09-18','15:00:00',3.33),('9303','2013-09-18','15:05:00',3.38),('9303','2013-09-18','15:10:00',1.7),('9303','2013-09-18','15:15:00',1.86),('9303','2013-09-18','15:20:00',3.3),('9303','2013-09-18','15:25:00',3.24),('9303','2013-09-18','15:30:00',3.18),('9303','2013-09-18','15:35:00',3.18),('9303','2013-09-18','15:40:00',3.06),('9303','2013-09-18','15:45:00',2.59),('9303','2013-09-18','15:50:00',2.27),('9303','2013-09-18','15:55:00',2.26),('9303','2013-09-18','16:00:00',2.14),('9303','2013-09-18','16:05:00',2.1),('9303','2013-09-18','16:10:00',2.81),('9303','2013-09-18','16:15:00',2.59),('9303','2013-09-18','16:20:00',2.4),('9303','2013-09-18','16:25:00',2.05),('9303','2013-09-18','16:30:00',1.91),('9303','2013-09-18','16:35:00',1.75),('9303','2013-09-18','16:40:00',1.77),('9303','2013-09-18','16:45:00',1.75),('9303','2013-09-18','16:50:00',1.58),('9303','2013-09-18','16:55:00',1.55),('9303','2013-09-18','17:00:00',1.59),('9303','2013-09-18','17:05:00',1.37),('9303','2013-09-18','17:10:00',1.36),('9303','2013-09-18','17:15:00',1.34),('9303','2013-09-18','17:20:00',1.27),('9303','2013-09-18','17:25:00',1.07),('9303','2013-09-18','17:30:00',1.1),('9303','2013-09-17','09:20:00',1.05),('9303','2013-09-17','09:40:00',1.28),('9303','2013-09-17','09:45:00',2.17),('9303','2013-09-17','09:50:00',1.29),('9303','2013-09-17','09:55:00',1.37),('9303','2013-09-17','10:00:00',1.97),('9303','2013-09-17','10:05:00',1.56),('9303','2013-09-17','10:10:00',1.79),('9303','2013-09-17','10:25:00',1.76),('9303','2013-09-17','10:30:00',2.7),('9303','2013-09-17','10:35:00',1.43),('9303','2013-09-17','10:40:00',1.62),('9303','2013-09-17','10:45:00',2.6),('9303','2013-09-17','10:50:00',3.68),('9303','2013-09-17','10:55:00',2.62),('9303','2013-09-17','11:00:00',1.99),('9303','2013-09-17','11:05:00',1.45),('9303','2013-09-17','11:10:00',3.2),('9303','2013-09-17','11:15:00',2.59),('9303','2013-09-17','11:20:00',2.22),('9303','2013-09-17','11:25:00',1.74),('9303','2013-09-17','11:30:00',1.65),('9303','2013-09-17','11:35:00',3.08),('9303','2013-09-17','11:40:00',3.3),('9303','2013-09-17','11:45:00',3.31),('9303','2013-09-17','11:50:00',3.24),('9303','2013-09-17','11:55:00',2.93),('9303','2013-09-17','12:00:00',3.35),('9303','2013-09-17','12:05:00',3.3),('9303','2013-09-17','12:10:00',1.71),('9303','2013-09-17','12:15:00',2.21),('9303','2013-09-17','12:20:00',2.08),('9303','2013-09-17','12:25:00',3.92),('9303','2013-09-17','12:30:00',3.35),('9303','2013-09-17','12:35:00',1.95),('9303','2013-09-17','12:40:00',3.31),('9303','2013-09-17','12:45:00',3.42),('9303','2013-09-17','12:50:00',2.76),('9303','2013-09-17','12:55:00',2.3),('9303','2013-09-17','13:00:00',2.33),('9303','2013-09-17','13:05:00',1.33),('9303','2013-09-17','13:10:00',2.2),('9303','2013-09-17','13:15:00',3.05),('9303','2013-09-17','13:20:00',2.14),('9303','2013-09-17','13:25:00',1.91),('9303','2013-09-17','13:30:00',1.67),('9303','2013-09-17','13:35:00',1.65),('9303','2013-09-17','13:40:00',2.54),('9303','2013-09-17','13:45:00',1.83),('9303','2013-09-17','13:55:00',1.13),('9303','2013-09-17','14:00:00',1.56),('9303','2013-09-17','14:05:00',1.06),('9303','2013-09-17','14:15:00',1.22),('9303','2013-09-17','14:25:00',1.82),('9303','2013-09-17','14:35:00',1.05),('9303','2013-09-17','14:55:00',3.05),('9303','2013-09-17','15:00:00',3.32),('9303','2013-09-17','15:05:00',2.67),('9303','2013-09-17','15:10:00',2.63),('9303','2013-09-17','15:15:00',2.45),('9303','2013-09-17','15:20:00',2.78),('9303','2013-09-17','15:25:00',2.71),('9303','2013-09-17','15:30:00',2.08),('9303','2013-09-17','15:45:00',1.33),('9303','2013-09-17','15:50:00',1.79),('9303','2013-09-17','15:55:00',2.17),('9303','2013-09-17','16:00:00',1.26),('9303','2013-09-17','16:05:00',1.68),('9303','2013-09-17','16:10:00',1.65),('9303','2013-09-17','16:15:00',1.75),('9303','2013-09-17','16:20:00',1.01),('9303','2013-09-17','16:40:00',1.03),('9303','2013-09-17','16:45:00',1.05),('9303','2013-09-17','16:50:00',1.06),('9303','2013-09-17','17:00:00',1.34),('9303','2013-09-17','17:05:00',1.43),('9303','2013-09-17','17:10:00',1.33),('9303','2013-09-17','17:15:00',1.41),('9303','2013-09-17','17:20:00',1.2),('9303','2013-09-17','17:25:00',1.12),('9303','2013-09-17','17:30:00',1.1),('9303','2013-09-16','08:25:00',1.05),('9303','2013-09-16','08:30:00',1.14),('9303','2013-09-16','08:35:00',1.23),('9303','2013-09-16','08:40:00',1.37),('9303','2013-09-16','08:50:00',1.34),('9303','2013-09-16','08:55:00',1.01),('9303','2013-09-16','09:05:00',1.69),('9303','2013-09-16','09:10:00',1.97),('9303','2013-09-16','09:15:00',1.66),('9303','2013-09-16','09:20:00',1.72),('9303','2013-09-16','09:25:00',1.94),('9303','2013-09-16','09:30:00',1.99),('9303','2013-09-16','09:35:00',2.19),('9303','2013-09-16','09:40:00',2.26),('9303','2013-09-16','09:45:00',2.33),('9303','2013-09-16','09:50:00',2.44),('9303','2013-09-16','09:55:00',2.53),('9303','2013-09-16','10:00:00',2.62),('9303','2013-09-16','10:05:00',2.69),('9303','2013-09-16','10:10:00',2.63),('9303','2013-09-16','10:15:00',1.34),('9303','2013-09-16','10:20:00',1.9),('9303','2013-09-16','10:25:00',1.72),('9303','2013-09-16','10:30:00',3.08),('9303','2013-09-16','10:35:00',3.42),('9303','2013-09-16','10:40:00',3.6),('9303','2013-09-16','10:45:00',3.77),('9303','2013-09-16','10:50:00',1.83),('9303','2013-09-16','11:05:00',2.76),('9303','2013-09-16','11:10:00',1.02),('9303','2013-09-16','11:15:00',2.36),('9303','2013-09-16','11:20:00',1.75),('9303','2013-09-16','11:25:00',1.49),('9303','2013-09-16','11:30:00',3.82),('9303','2013-09-16','11:35:00',3.73),('9303','2013-09-16','11:40:00',3.81),('9303','2013-09-16','11:45:00',2.23),('9303','2013-09-16','11:50:00',2.66),('9303','2013-09-16','11:55:00',3.87),('9303','2013-09-16','12:00:00',3.92),('9303','2013-09-16','12:05:00',3.81),('9303','2013-09-16','12:10:00',3.2),('9303','2013-09-16','12:15:00',4.04),('9303','2013-09-16','12:20:00',3.85),('9303','2013-09-16','12:25:00',3.83),('9303','2013-09-16','12:30:00',3.82),('9303','2013-09-16','12:35:00',3.84),('9303','2013-09-16','12:40:00',4),('9303','2013-09-16','12:45:00',4.16),('9303','2013-09-16','12:50:00',2.69),('9303','2013-09-16','12:55:00',2.6),('9303','2013-09-16','13:00:00',1.54),('9303','2013-09-16','13:05:00',3.95),('9303','2013-09-16','13:10:00',3.7),('9303','2013-09-16','13:15:00',4),('9303','2013-09-16','13:20:00',3.92),('9303','2013-09-16','13:25:00',3.87),('9303','2013-09-16','13:30:00',3.79),('9303','2013-09-16','13:35:00',3.88),('9303','2013-09-16','13:40:00',3.85),('9303','2013-09-16','13:45:00',3.79),('9303','2013-09-16','13:50:00',3.86),('9303','2013-09-16','13:55:00',3.99),('9303','2013-09-16','14:00:00',3.25),('9303','2013-09-16','14:05:00',3.73),('9303','2013-09-16','14:10:00',3.7),('9303','2013-09-16','14:15:00',3.63),('9303','2013-09-16','14:20:00',3.59),('9303','2013-09-16','14:25:00',3.6),('9303','2013-09-16','14:30:00',3.6),('9303','2013-09-16','14:35:00',3.55),('9303','2013-09-16','14:40:00',3.5),('9303','2013-09-16','14:45:00',3.47),('9303','2013-09-16','14:50:00',3.44),('9303','2013-09-16','14:55:00',3.4),('9303','2013-09-16','15:00:00',3.36),('9303','2013-09-16','15:05:00',3.32),('9303','2013-09-16','15:10:00',3.28),('9303','2013-09-16','15:15:00',3.24),('9303','2013-09-16','15:20:00',3.19),('9303','2013-09-16','15:25:00',3.13),('9303','2013-09-16','15:30:00',3.07),('9303','2013-09-16','15:35:00',3.02),('9303','2013-09-16','15:40:00',2.98),('9303','2013-09-16','15:45:00',2.91),('9303','2013-09-16','15:50:00',2.85),('9303','2013-09-16','15:55:00',2.77),('9303','2013-09-16','16:00:00',2.71),('9303','2013-09-16','16:05:00',1.01),('9303','2013-09-16','16:10:00',2.67),('9303','2013-09-16','16:15:00',2.54),('9303','2013-09-16','16:20:00',2.47),('9303','2013-09-16','16:25:00',2.38),('9303','2013-09-16','16:30:00',2.27),('9303','2013-09-16','16:35:00',2.14),('9303','2013-09-16','16:40:00',2.04),('9303','2013-09-16','16:45:00',1.97),('9303','2013-09-16','16:50:00',1.89),('9303','2013-09-16','16:55:00',1.8),('9303','2013-09-16','17:00:00',1.7),('9303','2013-09-16','17:05:00',1.6),('9303','2013-09-16','17:10:00',1.52),('9303','2013-09-16','17:15:00',1.43),('9303','2013-09-16','17:20:00',1.33),('9303','2013-09-16','17:25:00',1.24),('9303','2013-09-16','17:30:00',1.16),('9303','2013-09-16','17:35:00',1.05),('9303','2013-09-15','08:20:00',1.01),('9303','2013-09-15','08:25:00',1.11),('9303','2013-09-15','08:30:00',1.21),('9303','2013-09-15','08:35:00',1.32),('9303','2013-09-15','08:40:00',1.46),('9303','2013-09-15','08:45:00',1.54),('9303','2013-09-15','08:50:00',1.58),('9303','2013-09-15','08:55:00',1.53),('9303','2013-09-15','09:00:00',1.68),('9303','2013-09-15','09:05:00',1.72),('9303','2013-09-15','09:10:00',1.87),('9303','2013-09-15','09:15:00',2.06),('9303','2013-09-15','09:20:00',2),('9303','2013-09-15','09:25:00',2.09),('9303','2013-09-15','09:30:00',2.15),('9303','2013-09-15','09:35:00',2.28),('9303','2013-09-15','09:40:00',2.34),('9303','2013-09-15','09:45:00',2.38),('9303','2013-09-15','09:50:00',2.47),('9303','2013-09-15','09:55:00',2.49),('9303','2013-09-15','10:00:00',2.62),('9303','2013-09-15','10:05:00',2.66),('9303','2013-09-15','10:10:00',2.7),('9303','2013-09-15','10:15:00',2.59),('9303','2013-09-15','10:20:00',2.72),('9303','2013-09-15','10:25:00',2.81),('9303','2013-09-15','10:30:00',2.65),('9303','2013-09-15','10:35:00',2.34),('9303','2013-09-15','10:40:00',1.09),('9303','2013-09-15','10:55:00',2.42),('9303','2013-09-15','11:00:00',2.97),('9303','2013-09-15','11:05:00',3.61),('9303','2013-09-15','11:10:00',2.67),('9303','2013-09-15','11:15:00',1.73),('9303','2013-09-15','11:20:00',1.16),('9303','2013-09-15','11:25:00',1.15),('9303','2013-09-15','11:30:00',1.12),('9303','2013-09-15','11:35:00',2.54),('9303','2013-09-15','11:40:00',1.34),('9303','2013-09-15','11:45:00',1.34),('9303','2013-09-15','11:50:00',3.22),('9303','2013-09-15','11:55:00',1.41),('9303','2013-09-15','12:00:00',1.07),('9303','2013-09-15','12:05:00',1.03),('9303','2013-09-15','12:10:00',1),('9303','2013-09-15','12:15:00',1.04),('9303','2013-09-15','12:20:00',1.27),('9303','2013-09-15','12:25:00',1.56),('9303','2013-09-15','12:30:00',1.55),('9303','2013-09-15','12:35:00',1.41),('9303','2013-09-15','12:40:00',1.34),('9303','2013-09-15','12:45:00',1.01),('9303','2013-09-15','12:50:00',1.14),('9303','2013-09-15','12:55:00',1.25),('9303','2013-09-15','13:00:00',1.18),('9303','2013-09-15','13:05:00',1.05),('9303','2013-09-15','13:35:00',1.13),('9303','2013-09-15','13:40:00',1.3),('9303','2013-09-15','13:45:00',2.32),('9303','2013-09-15','13:50:00',2.61),('9303','2013-09-15','13:55:00',1.1),('9303','2013-09-15','14:00:00',1.6),('9303','2013-09-15','14:05:00',1.51),('9303','2013-09-15','14:10:00',1.42),('9303','2013-09-15','14:15:00',1.32),('9303','2013-09-15','14:20:00',1.21),('9303','2013-09-15','14:25:00',1.2),('9303','2013-09-15','14:30:00',1.18),('9303','2013-09-15','14:40:00',1.05),('9303','2013-09-15','15:00:00',1.02),('9303','2013-09-15','15:05:00',1.08),('9303','2013-09-15','15:10:00',1.2),('9303','2013-09-15','15:15:00',2.36),('9303','2013-09-15','15:20:00',1.96),('9303','2013-09-15','15:25:00',1.39),('9303','2013-09-15','15:30:00',1.03),('9303','2013-09-15','15:35:00',1),('9303','2013-09-14','08:25:00',1.06),('9303','2013-09-14','08:30:00',1.17),('9303','2013-09-14','08:35:00',1.27),('9303','2013-09-14','08:40:00',1.37),('9303','2013-09-14','08:45:00',1.45),('9303','2013-09-14','08:50:00',1.54),('9303','2013-09-14','08:55:00',1.63),('9303','2013-09-14','09:00:00',1.73),('9303','2013-09-14','09:05:00',1.81),('9303','2013-09-14','09:10:00',1.89),('9303','2013-09-14','09:15:00',1.96),('9303','2013-09-14','09:20:00',2.05),('9303','2013-09-14','09:25:00',2.12),('9303','2013-09-14','09:30:00',2.2),('9303','2013-09-14','09:35:00',2.27),('9303','2013-09-14','09:40:00',2.34),('9303','2013-09-14','09:45:00',2.4),('9303','2013-09-14','09:50:00',2.43),('9303','2013-09-14','09:55:00',2.54),('9303','2013-09-14','10:00:00',2.6),('9303','2013-09-14','10:05:00',2.39),('9303','2013-09-14','10:10:00',2.42),('9303','2013-09-14','10:15:00',2.47),('9303','2013-09-14','10:20:00',2.71),('9303','2013-09-14','10:25:00',2.85),('9303','2013-09-14','10:30:00',2.86),('9303','2013-09-14','10:35:00',2.98),('9303','2013-09-14','10:40:00',3.1),('9303','2013-09-14','10:45:00',3),('9303','2013-09-14','10:50:00',3.61),('9303','2013-09-14','10:55:00',3.66),('9303','2013-09-14','11:00:00',3.41),('9303','2013-09-14','11:05:00',1.08),('9303','2013-09-14','11:15:00',1.48),('9303','2013-09-14','11:20:00',1.54),('9303','2013-09-14','11:25:00',2.04),('9303','2013-09-14','11:30:00',3.69),('9303','2013-09-14','11:35:00',3.73),('9303','2013-09-14','11:40:00',3.81),('9303','2013-09-14','11:45:00',3.8),('9303','2013-09-14','11:50:00',3.82),('9303','2013-09-14','11:55:00',2.73),('9303','2013-09-14','12:00:00',1.01),('9303','2013-09-14','12:10:00',1.31),('9303','2013-09-14','12:15:00',1.92),('9303','2013-09-14','12:20:00',1.08),('9303','2013-09-14','12:35:00',1.38),('9303','2013-09-14','12:40:00',2.52),('9303','2013-09-14','13:10:00',1.04),('9303','2013-09-14','13:15:00',4.14),('9303','2013-09-14','13:20:00',4.06),('9303','2013-09-14','13:25:00',3.96),('9303','2013-09-14','13:30:00',4.1),('9303','2013-09-14','13:35:00',2.87),('9303','2013-09-14','13:40:00',1.68),('9303','2013-09-14','13:45:00',2.95),('9303','2013-09-14','13:50:00',2.57),('9303','2013-09-14','13:55:00',3.46),('9303','2013-09-14','14:00:00',4.06),('9303','2013-09-14','14:05:00',3.85),('9303','2013-09-14','14:10:00',3.75),('9303','2013-09-14','14:15:00',3.72),('9303','2013-09-14','14:20:00',3.67),('9303','2013-09-14','14:25:00',3.53),('9303','2013-09-14','14:30:00',3.61),('9303','2013-09-14','14:35:00',3.59),('9303','2013-09-14','14:40:00',3.52),('9303','2013-09-14','14:45:00',3.49),('9303','2013-09-14','14:50:00',3.43),('9303','2013-09-14','14:55:00',3.4),('9303','2013-09-14','15:00:00',3.25),('9303','2013-09-14','15:05:00',3.29),('9303','2013-09-14','15:10:00',3.23),('9303','2013-09-14','15:15:00',3.19),('9303','2013-09-14','15:20:00',3.14),('9303','2013-09-14','15:25:00',3.12),('9303','2013-09-14','15:30:00',3.09),('9303','2013-09-14','15:35:00',3),('9303','2013-09-14','15:40:00',2.98),('9303','2013-09-14','15:45:00',2.91),('9303','2013-09-14','15:50:00',2.81),('9303','2013-09-14','15:55:00',2.78),('9303','2013-09-14','16:00:00',2.7),('9303','2013-09-14','16:05:00',2.63),('9303','2013-09-14','16:10:00',2.54),('9303','2013-09-14','16:15:00',2.45),('9303','2013-09-14','16:20:00',2.41),('9303','2013-09-14','16:25:00',2.34),('9303','2013-09-14','16:30:00',2.26),('9303','2013-09-14','16:35:00',2.14),('9303','2013-09-14','16:40:00',2.04),('9303','2013-09-14','16:45:00',1.95),('9303','2013-09-14','16:50:00',1.88),('9303','2013-09-14','16:55:00',1.81),('9303','2013-09-14','17:00:00',1.73),('9303','2013-09-14','17:05:00',1.63),('9303','2013-09-14','17:10:00',1.56),('9303','2013-09-14','17:15:00',1.48),('9303','2013-09-14','17:20:00',1.25),('9303','2013-09-14','17:25:00',1.26),('9303','2013-09-14','17:30:00',1.16),('9303','2013-09-14','17:35:00',1.05),('9303','2013-09-13','09:25:00',1.01),('9303','2013-09-13','09:30:00',1.09),('9303','2013-09-13','09:35:00',1.21),('9303','2013-09-13','09:40:00',1.39),('9303','2013-09-13','09:45:00',1.24),('9303','2013-09-13','09:50:00',1.35),('9303','2013-09-13','09:55:00',1.73),('9303','2013-09-13','10:00:00',2.78),('9303','2013-09-13','10:05:00',1.3),('9303','2013-09-13','10:10:00',2.02),('9303','2013-09-13','10:15:00',3.43),('9303','2013-09-13','10:20:00',2.88),('9303','2013-09-13','10:25:00',1.41),('9303','2013-09-13','10:30:00',2.43),('9303','2013-09-13','10:35:00',3.3),('9303','2013-09-13','10:40:00',3.08),('9303','2013-09-13','10:45:00',3.14),('9303','2013-09-13','10:50:00',3.2),('9303','2013-09-13','10:55:00',3.24),('9303','2013-09-13','11:00:00',3.27),('9303','2013-09-13','11:05:00',3.3),('9303','2013-09-13','11:10:00',3.32),('9303','2013-09-13','11:15:00',3.37),('9303','2013-09-13','11:20:00',3.42),('9303','2013-09-13','11:25:00',3.43),('9303','2013-09-13','11:30:00',3.49),('9303','2013-09-13','11:35:00',3.52),('9303','2013-09-13','11:40:00',3.51),('9303','2013-09-13','11:45:00',3.56),('9303','2013-09-13','11:50:00',3.61),('9303','2013-09-13','11:55:00',3.63),('9303','2013-09-13','12:00:00',3.65),('9303','2013-09-13','12:05:00',3.69),('9303','2013-09-13','12:10:00',3.66),('9303','2013-09-13','12:15:00',3.66),('9303','2013-09-13','12:20:00',3.67),('9303','2013-09-13','12:25:00',1.63),('9303','2013-09-13','12:35:00',2.77),('9303','2013-09-13','12:40:00',3.99),('9303','2013-09-13','12:45:00',3.94),('9303','2013-09-13','12:50:00',3.92),('9303','2013-09-13','12:55:00',3.86),('9303','2013-09-13','13:00:00',3.83),('9303','2013-09-13','13:05:00',3.78),('9303','2013-09-13','13:10:00',3.74),('9303','2013-09-13','13:15:00',3.81),('9303','2013-09-13','13:20:00',3.83),('9303','2013-09-13','13:25:00',3.76),('9303','2013-09-13','13:30:00',3.73),('9303','2013-09-13','13:35:00',3.71),('9303','2013-09-13','13:40:00',3.71),('9303','2013-09-13','13:45:00',3.72),('9303','2013-09-13','13:50:00',3.67),('9303','2013-09-13','13:55:00',3.67),('9303','2013-09-13','14:00:00',3.69),('9303','2013-09-13','14:05:00',3.65),('9303','2013-09-13','14:10:00',3.59),('9303','2013-09-13','14:15:00',3.6),('9303','2013-09-13','14:20:00',3.59),('9303','2013-09-13','14:25:00',3.6),('9303','2013-09-13','14:30:00',3.55),('9303','2013-09-13','14:35:00',3.51),('9303','2013-09-13','14:40:00',3.41),('9303','2013-09-13','14:45:00',3.46),('9303','2013-09-13','14:50:00',3.44),('9303','2013-09-13','14:55:00',3.39),('9303','2013-09-13','15:00:00',3.09),('9303','2013-09-13','15:05:00',3.29),('9303','2013-09-13','15:10:00',3.28),('9303','2013-09-13','15:15:00',3.28),('9303','2013-09-13','15:20:00',3.18),('9303','2013-09-13','15:25:00',3.14),('9303','2013-09-13','15:30:00',3.07),('9303','2013-09-13','15:35:00',3.04),('9303','2013-09-13','15:40:00',2.96),('9303','2013-09-13','15:45:00',2.93),('9303','2013-09-13','15:50:00',2.86),('9303','2013-09-13','15:55:00',2.82),('9303','2013-09-13','16:00:00',2.75),('9303','2013-09-13','16:05:00',2.66),('9303','2013-09-13','16:10:00',2.58),('9303','2013-09-13','16:15:00',2.53),('9303','2013-09-13','16:20:00',2.47),('9303','2013-09-13','16:25:00',2.4),('9303','2013-09-13','16:30:00',2.28),('9303','2013-09-13','16:35:00',2.18),('9303','2013-09-13','16:40:00',2.06),('9303','2013-09-13','16:45:00',1.97),('9303','2013-09-13','16:50:00',1.9),('9303','2013-09-13','16:55:00',1.82),('9303','2013-09-13','17:00:00',1.72),('9303','2013-09-13','17:05:00',1.63),('9303','2013-09-13','17:10:00',1.53),('9303','2013-09-13','17:15:00',1.44),('9303','2013-09-13','17:20:00',1.35),('9303','2013-09-13','17:25:00',1.27),('9303','2013-09-13','17:30:00',1.18),('9303','2013-09-13','17:35:00',1.07),('9303','2013-09-13','17:40:00',1),('9303','2013-09-12','08:15:00',1.08),('9303','2013-09-12','08:20:00',1.1),('9303','2013-09-12','08:25:00',1.32),('9303','2013-09-12','08:30:00',1.48),('9303','2013-09-12','08:35:00',1.33),('9303','2013-09-12','08:55:00',1.38),('9303','2013-09-12','09:00:00',1.71),('9303','2013-09-12','09:05:00',1.64),('9303','2013-09-12','09:10:00',1.18),('9303','2013-09-12','09:15:00',1.85),('9303','2013-09-12','09:20:00',1.9),('9303','2013-09-12','09:25:00',2.15),('9303','2013-09-12','09:30:00',2.31),('9303','2013-09-12','09:35:00',2.16),('9303','2013-09-12','09:40:00',1.86),('9303','2013-09-12','09:45:00',2.23),('9303','2013-09-12','09:50:00',1.83),('9303','2013-09-12','09:55:00',1.2),('9303','2013-09-12','10:05:00',1.26),('9303','2013-09-12','10:10:00',1.57),('9303','2013-09-12','10:15:00',1.61),('9303','2013-09-12','10:20:00',1.23),('9303','2013-09-12','10:30:00',1.79),('9303','2013-09-12','10:35:00',1.67),('9303','2013-09-12','10:55:00',1.69),('9303','2013-09-12','11:00:00',2.31),('9303','2013-09-12','11:05:00',3.37),('9303','2013-09-12','11:10:00',2.57),('9303','2013-09-12','11:15:00',2.58),('9303','2013-09-12','11:40:00',1.04),('9303','2013-09-12','11:45:00',1.65),('9303','2013-09-12','11:50:00',1.48),('9303','2013-09-12','11:55:00',3.31),('9303','2013-09-12','12:00:00',3.15),('9303','2013-09-12','12:05:00',3.74),('9303','2013-09-12','12:10:00',3.43),('9303','2013-09-12','12:15:00',3.53),('9303','2013-09-12','12:20:00',1.4),('9303','2013-09-12','12:25:00',1.57),('9303','2013-09-12','12:30:00',1.54),('9303','2013-09-12','12:35:00',2.67),('9303','2013-09-12','12:40:00',3.64),('9303','2013-09-12','12:45:00',1.07),('9303','2013-09-12','12:50:00',3),('9303','2013-09-12','12:55:00',1.57),('9303','2013-09-12','13:00:00',4.31),('9303','2013-09-12','13:05:00',2.88),('9303','2013-09-12','13:10:00',2.73),('9303','2013-09-12','13:15:00',3.53),('9303','2013-09-12','13:20:00',4.12),('9303','2013-09-12','13:25:00',4.55),('9303','2013-09-12','13:30:00',3.88),('9303','2013-09-12','13:35:00',3.03),('9303','2013-09-12','13:40:00',3.07),('9303','2013-09-12','13:45:00',3.65),('9303','2013-09-12','13:50:00',4.01),('9303','2013-09-12','13:55:00',3.86),('9303','2013-09-12','14:00:00',3.88),('9303','2013-09-12','14:05:00',3.4),('9303','2013-09-12','14:10:00',2.67),('9303','2013-09-12','14:15:00',3.86),('9303','2013-09-12','14:20:00',3.74),('9303','2013-09-12','14:25:00',3.82),('9303','2013-09-12','14:30:00',3.83),('9303','2013-09-12','14:35:00',2.81),('9303','2013-09-12','14:40:00',2.91),('9303','2013-09-12','14:45:00',3.63),('9303','2013-09-12','14:50:00',3.54),('9303','2013-09-12','14:55:00',3.5),('9303','2013-09-12','15:00:00',3.42),('9303','2013-09-12','15:05:00',3.33),('9303','2013-09-12','15:10:00',2.37),('9303','2013-09-12','15:15:00',3.18),('9303','2013-09-12','15:20:00',3.24),('9303','2013-09-12','15:25:00',2.89),('9303','2013-09-12','15:30:00',3.16),('9303','2013-09-12','15:35:00',3.1),('9303','2013-09-12','15:40:00',2.96),('9303','2013-09-12','15:45:00',3.01),('9303','2013-09-12','15:50:00',2.78),('9303','2013-09-12','15:55:00',2.82),('9303','2013-09-12','16:00:00',2.87),('9303','2013-09-12','16:05:00',1.88),('9303','2013-09-12','16:10:00',2.49),('9303','2013-09-12','16:15:00',2.54),('9303','2013-09-12','16:20:00',1.87),('9303','2013-09-12','16:25:00',1.74),('9303','2013-09-12','16:30:00',1.19),('9303','2013-09-12','16:40:00',1.51),('9303','2013-09-12','16:45:00',2.25),('9303','2013-09-12','16:50:00',1.13),('9303','2013-09-12','16:55:00',1.57),('9303','2013-09-12','17:00:00',1.08),('9303','2013-09-12','17:05:00',1.78),('9303','2013-09-12','17:10:00',1.35),('9303','2013-09-12','17:15:00',1.66),('9303','2013-09-12','17:20:00',1.18),('9303','2013-09-12','17:25:00',1.02),('9303','2013-09-12','17:30:00',1.3),('9303','2013-09-12','17:35:00',1.22),('9303','2013-09-12','17:40:00',1.07),('9303','2013-09-12','17:45:00',1.03),('9303','2013-09-11','09:00:00',1.58),('9303','2013-09-11','09:05:00',1.99),('9303','2013-09-11','09:10:00',2.02),('9303','2013-09-11','09:15:00',1.9),('9303','2013-09-11','09:20:00',2.51),('9303','2013-09-11','09:25:00',1.71),('9303','2013-09-11','09:30:00',1.33),('9303','2013-09-11','09:35:00',1.33),('9303','2013-09-11','09:40:00',1.33),('9303','2013-09-11','10:05:00',1.9),('9303','2013-09-11','10:10:00',1.11),('9303','2013-09-11','10:15:00',1.95),('9303','2013-09-11','10:20:00',2.93),('9303','2013-09-11','10:25:00',2.15),('9303','2013-09-11','10:30:00',3.15),('9303','2013-09-11','10:35:00',2.84),('9303','2013-09-11','10:40:00',2.38),('9303','2013-09-11','10:45:00',1.36),('9303','2013-09-11','10:50:00',2.55),('9303','2013-09-11','10:55:00',1.61),('9303','2013-09-11','11:00:00',1.31),('9303','2013-09-11','11:05:00',1.98),('9303','2013-09-11','11:10:00',2.85),('9303','2013-09-11','11:15:00',2.68),('9303','2013-09-11','11:20:00',3.36),('9303','2013-09-11','11:25:00',2.75),('9303','2013-09-11','11:35:00',2.47),('9303','2013-09-11','11:40:00',3.01),('9303','2013-09-11','11:45:00',3.78),('9303','2013-09-11','11:50:00',3.83),('9303','2013-09-11','11:55:00',3.53),('9303','2013-09-11','12:00:00',2.12),('9303','2013-09-11','12:05:00',3.81),('9303','2013-09-11','12:10:00',2.89),('9303','2013-09-11','12:15:00',1.74),('9303','2013-09-11','12:20:00',2.99),('9303','2013-09-11','12:25:00',2.89),('9303','2013-09-11','12:30:00',3.39),('9303','2013-09-11','12:35:00',2.91),('9303','2013-09-11','12:45:00',1.61),('9303','2013-09-11','12:50:00',3.96),('9303','2013-09-11','12:55:00',1.89),('9303','2013-09-11','13:00:00',2.77),('9303','2013-09-11','13:05:00',4.07),('9303','2013-09-11','13:10:00',3.8),('9303','2013-09-11','13:15:00',3.91),('9303','2013-09-11','13:20:00',3.21),('9303','2013-09-11','13:25:00',3.78),('9303','2013-09-11','13:30:00',3.74),('9303','2013-09-11','13:35:00',1.67),('9303','2013-09-11','13:40:00',2.89),('9303','2013-09-11','13:45:00',2.22),('9303','2013-09-11','13:50:00',3.7),('9303','2013-09-11','13:55:00',2.62),('9303','2013-09-11','14:00:00',2.69),('9303','2013-09-11','14:05:00',3.98),('9303','2013-09-11','14:10:00',3.44),('9303','2013-09-11','14:15:00',3.84),('9303','2013-09-11','14:20:00',2.25),('9303','2013-09-11','14:25:00',3.45),('9303','2013-09-11','14:30:00',2.63),('9303','2013-09-11','14:35:00',3.47),('9303','2013-09-11','14:40:00',1.39),('9303','2013-09-11','14:45:00',3.13),('9303','2013-09-11','14:50:00',3.86),('9303','2013-09-11','14:55:00',3.46),('9303','2013-09-11','15:00:00',1.59),('9303','2013-09-11','15:05:00',3.73),('9303','2013-09-11','15:10:00',1.66),('9303','2013-09-11','15:15:00',3.55),('9303','2013-09-11','15:20:00',2.3),('9303','2013-09-11','15:25:00',3.22),('9303','2013-09-11','15:30:00',2.92),('9303','2013-09-11','15:35:00',1.35),('9303','2013-09-11','15:40:00',1.57),('9303','2013-09-11','15:45:00',2.57),('9303','2013-09-11','15:50:00',3.08),('9303','2013-09-11','15:55:00',1.91),('9303','2013-09-11','16:00:00',2.27),('9303','2013-09-11','16:05:00',2.98),('9303','2013-09-11','16:10:00',2.59),('9303','2013-09-11','16:15:00',2.66),('9303','2013-09-11','16:20:00',2.57),('9303','2013-09-11','16:25:00',2.4),('9303','2013-09-11','16:30:00',1.1),('9303','2013-09-11','16:35:00',2.07),('9303','2013-09-11','16:45:00',2.19),('9303','2013-09-11','16:50:00',1.94),('9303','2013-09-11','16:55:00',1.84),('9303','2013-09-11','17:00:00',1.72),('9303','2013-09-11','17:05:00',1.71),('9303','2013-09-11','17:10:00',1.63),('9303','2013-09-11','17:15:00',1.51),('9303','2013-09-11','17:20:00',1.41),('9303','2013-09-11','17:25:00',1.33),('9303','2013-09-11','17:30:00',1.24),('9303','2013-09-11','17:35:00',1.14),('9303','2013-09-11','17:40:00',1.07),('9303','2013-09-10','08:55:00',1.31),('9303','2013-09-10','09:00:00',1.65),('9303','2013-09-10','09:05:00',1.53),('9303','2013-09-10','09:10:00',2.13),('9303','2013-09-10','09:15:00',1.78),('9303','2013-09-10','09:20:00',1.44),('9303','2013-09-10','09:25:00',1.41),('9303','2013-09-10','09:30:00',2.33),('9303','2013-09-10','09:35:00',2.59),('9303','2013-09-10','09:40:00',1.45),('9303','2013-09-10','09:45:00',1.22),('9303','2013-09-10','09:50:00',1.11),('9303','2013-09-10','10:35:00',1.01),('9303','2013-09-10','10:40:00',1.35),('9303','2013-09-10','10:45:00',1.95),('9303','2013-09-10','10:50:00',1.17),('9303','2013-09-10','10:55:00',1.16),('9303','2013-09-10','11:00:00',1.47),('9303','2013-09-10','11:05:00',1.27),('9303','2013-09-10','11:10:00',1.29),('9303','2013-09-10','11:15:00',1.1),('9303','2013-09-10','11:20:00',1.17),('9303','2013-09-10','11:25:00',1.42),('9303','2013-09-10','11:30:00',1.01),('9303','2013-09-10','11:45:00',1.09),('9303','2013-09-10','11:50:00',1.17),('9303','2013-09-10','11:55:00',1.47),('9303','2013-09-10','12:00:00',1.31),('9303','2013-09-10','13:40:00',1.61),('9303','2013-09-10','13:45:00',2.59),('9303','2013-09-10','13:50:00',1.72),('9303','2013-09-10','13:55:00',1.47),('9303','2013-09-10','14:00:00',1.03),('9303','2013-09-10','14:05:00',1.21),('9303','2013-09-10','14:10:00',1.23),('9303','2013-09-10','14:15:00',1.5),('9303','2013-09-10','14:20:00',1.5),('9303','2013-09-10','14:25:00',2.06),('9303','2013-09-10','14:30:00',1.9),('9303','2013-09-10','14:35:00',1.34),('9303','2013-09-10','14:40:00',1.62),('9303','2013-09-10','14:45:00',1.7),('9303','2013-09-10','14:50:00',2.01),('9303','2013-09-10','14:55:00',1.84),('9303','2013-09-10','15:00:00',2.29),('9303','2013-09-10','15:05:00',2.17),('9303','2013-09-10','15:10:00',1.62),('9303','2013-09-10','15:15:00',1.44),('9303','2013-09-10','15:20:00',1.93),('9303','2013-09-10','15:25:00',1.69),('9303','2013-09-10','15:30:00',1.95),('9303','2013-09-10','15:35:00',1.79),('9303','2013-09-10','15:40:00',1.1),('9303','2013-09-10','16:05:00',1.03),('9303','2013-09-10','16:10:00',1.21),('9303','2013-09-10','16:15:00',1.36),('9303','2013-09-09','08:55:00',1.08),('9303','2013-09-09','09:00:00',1.14),('9303','2013-09-09','09:05:00',1.01),('9303','2013-09-09','10:00:00',1.06),('9303','2013-09-09','10:05:00',1.52),('9303','2013-09-09','10:10:00',1.59),('9303','2013-09-09','10:15:00',1.43),('9303','2013-09-09','10:20:00',1.25),('9303','2013-09-09','10:25:00',1.16),('9303','2013-09-09','10:30:00',1.3),('9303','2013-09-09','10:37:00',1.47),('9303','2013-09-09','10:40:00',1.65),('9303','2013-09-09','10:47:00',1.99),('9303','2013-09-09','10:50:00',2.55),('9303','2013-09-09','10:56:00',2.51),('9303','2013-09-09','11:00:00',2.57),('9303','2013-09-09','11:05:00',2.02),('9303','2013-09-09','11:10:00',1.51),('9303','2013-09-09','11:15:00',2),('9303','2013-09-09','11:20:00',2.32),('9303','2013-09-09','11:25:00',2.54),('9303','2013-09-09','11:30:00',2.01),('9303','2013-09-09','11:35:00',1.92),('9303','2013-09-09','11:40:00',2.89),('9303','2013-09-09','11:45:00',2.91),('9303','2013-09-09','11:50:00',2.21),('9303','2013-09-09','11:55:00',2.79),('9303','2013-09-09','12:00:00',2.19),('9303','2013-09-09','12:05:00',3.03),('9303','2013-09-09','12:10:00',2.81),('9303','2013-09-09','12:15:00',2.25),('9303','2013-09-09','12:20:00',1.59),('9303','2013-09-09','12:25:00',1.12),('9303','2013-09-09','12:40:00',1.11),('9303','2013-09-09','12:45:00',1.44),('9303','2013-09-09','12:50:00',1.14),('9303','2013-09-09','12:55:00',1.29),('9303','2013-09-09','13:00:00',1.25),('9303','2013-09-09','13:05:00',2.16),('9303','2013-09-09','13:10:00',2.06),('9303','2013-09-09','13:15:00',2.97),('9303','2013-09-09','13:20:00',2.83),('9303','2013-09-09','13:25:00',2.34),('9303','2013-09-09','13:30:00',3.01),('9303','2013-09-09','13:35:00',3.65),('9303','2013-09-09','13:40:00',3.21),('9303','2013-09-09','13:45:00',3.67),('9303','2013-09-09','13:50:00',3.64),('9303','2013-09-09','13:55:00',3.61),('9303','2013-09-09','14:00:00',3.46),('9303','2013-09-09','14:05:00',3.33),('9303','2013-09-09','14:10:00',3.77),('9303','2013-09-09','14:15:00',2.48),('9303','2013-09-09','14:20:00',1.97),('9303','2013-09-09','14:25:00',1.54),('9303','2013-09-09','14:30:00',1.49),('9303','2013-09-09','14:35:00',3.6),('9303','2013-09-09','14:40:00',3.53),('9303','2013-09-09','14:45:00',2.24),('9303','2013-09-09','14:50:00',2.78),('9303','2013-09-09','14:55:00',2.97),('9303','2013-09-09','15:00:00',2.43),('9303','2013-09-09','15:05:00',2.36),('9303','2013-09-09','15:10:00',2.69),('9303','2013-09-09','15:15:00',1.33),('9303','2013-09-09','15:20:00',1.93),('9303','2013-09-09','15:25:00',1.03),('9303','2013-09-09','15:30:00',2.78),('9303','2013-09-09','15:35:00',2.02),('9303','2013-09-09','15:40:00',2.51),('9303','2013-09-09','15:45:00',1.04),('9303','2013-09-09','15:50:00',1.09),('9303','2013-09-09','15:55:00',1.16),('9303','2013-09-09','16:00:00',1.36),('9303','2013-09-09','16:05:00',1.23),('9303','2013-09-09','16:10:00',1.44),('9303','2013-09-09','16:15:00',2.1),('9303','2013-09-09','16:20:00',1.57),('9303','2013-09-09','16:35:00',1.06),('9303','2013-09-09','16:40:00',1.23),('9303','2013-09-09','16:45:00',1.89),('9303','2014-04-12','09:15:00',1.3),('9303','2014-04-12','09:20:00',1.93),('9303','2014-04-12','09:25:00',2.37),('9303','2014-04-12','09:30:00',1.73),('9303','2014-04-12','09:35:00',1.51),('9303','2014-04-12','09:40:00',1.32),('9303','2014-04-12','09:45:00',1.22),('9303','2014-04-12','09:50:00',1.27),('9303','2014-04-12','09:55:00',1.29),('9303','2014-04-12','10:00:00',1.29),('9303','2014-04-12','10:05:00',1.31),('9303','2014-04-12','10:10:00',1.42),('9303','2014-04-12','10:15:00',1.51),('9303','2014-04-12','10:20:00',1.69),('9303','2014-04-12','10:25:00',1.87),('9303','2014-04-12','10:30:00',1.93),('9303','2014-04-12','10:35:00',2.23),('9303','2014-04-12','10:40:00',2.16),('9303','2014-04-12','10:45:00',2.35),('9303','2014-04-12','10:50:00',2.63),('9303','2014-04-12','10:55:00',1.83),('9303','2014-04-12','11:00:00',1.63),('9303','2014-04-12','11:05:00',3.09),('9303','2014-04-12','11:10:00',3.04),('9303','2014-04-12','11:15:00',4.07),('9303','2014-04-12','11:20:00',3.84),('9303','2014-04-12','11:25:00',2.76),('9303','2014-04-12','11:30:00',3.27),('9303','2014-04-12','11:35:00',3.45),('9303','2014-04-12','11:40:00',3.68),('9303','2014-04-12','11:45:00',3.69),('9303','2014-04-12','11:50:00',3.16),('9303','2014-04-12','11:55:00',3.04),('9303','2014-04-12','12:00:00',2.4),('9303','2014-04-12','12:05:00',1.78),('9303','2014-04-12','12:10:00',3.08),('9303','2014-04-12','12:15:00',2.36),('9303','2014-04-12','12:20:00',1.97),('9303','2014-04-12','12:25:00',2.77),('9303','2014-04-12','12:30:00',2.5),('9303','2014-04-12','12:35:00',2.59),('9303','2014-04-12','12:40:00',2.85),('9303','2014-04-12','12:45:00',3.28),('9303','2014-04-12','12:50:00',2.15),('9303','2014-04-12','12:55:00',1.53),('9303','2014-04-12','13:00:00',1.62),('9303','2014-04-12','13:05:00',2.68),('9303','2014-04-12','13:10:00',2.77),('9303','2014-04-12','13:15:00',3.76),('9303','2014-04-12','13:20:00',4.06),('9303','2014-04-12','13:25:00',2.61),('9303','2014-04-12','13:30:00',4.39),('9303','2014-04-12','13:35:00',3.01),('9303','2014-04-12','13:40:00',1.49),('9303','2014-04-12','13:45:00',1.85),('9303','2014-04-12','13:50:00',4.38),('9303','2014-04-12','13:55:00',2.11),('9303','2014-04-12','14:00:00',2.47),('9303','2014-04-12','14:05:00',2.71),('9303','2014-04-12','14:10:00',3.99),('9303','2014-04-12','14:15:00',4.13),('9303','2014-04-12','14:20:00',3.03),('9303','2014-04-12','14:25:00',3.74),('9303','2014-04-12','14:30:00',3.19),('9303','2014-04-12','14:35:00',1.76),('9303','2014-04-12','14:40:00',1.46),('9303','2014-04-12','14:45:00',1.91),('9303','2014-04-12','14:50:00',3.27),('9303','2014-04-12','14:55:00',3.06),('9303','2014-04-12','15:00:00',3),('9303','2014-04-12','15:05:00',3.48),('9303','2014-04-12','15:10:00',3.47),('9303','2014-04-12','15:15:00',3.29),('9303','2014-04-12','15:20:00',2.79),('9303','2014-04-12','15:25:00',2.53),('9303','2014-04-12','15:30:00',1.81),('9303','2014-04-12','15:35:00',2.46),('9303','2014-04-12','15:40:00',2.9),('9303','2014-04-12','15:45:00',3.08),('9303','2014-04-12','15:50:00',3.38),('9303','2014-04-12','15:55:00',3.3),('9303','2014-04-12','16:00:00',3.27),('9303','2014-04-12','16:05:00',3.21),('9303','2014-04-12','16:10:00',3.17),('9303','2014-04-12','16:15:00',2.96),('9303','2014-04-12','16:20:00',3.13),('9303','2014-04-12','16:25:00',2.84),('9303','2014-04-12','16:30:00',2.75),('9303','2014-04-12','16:35:00',2.62),('9303','2014-04-12','16:40:00',2.12),('9303','2014-04-12','16:45:00',2.04),('9303','2014-04-12','16:50:00',1.28),('9303','2014-04-12','16:55:00',1.89),('9303','2014-04-12','17:00:00',2.08),('9303','2014-04-12','17:05:00',1.98),('9303','2014-04-12','17:10:00',1.95),('9303','2014-04-12','17:15:00',1.83),('9303','2014-04-12','17:20:00',1.47),('9303','2014-04-12','17:25:00',1.4),('9303','2014-04-12','17:30:00',1.52),('9303','2014-04-12','17:35:00',1.3),('9303','2014-04-12','17:40:00',1.22),('9303','2014-04-12','17:45:00',1.55),('9303','2014-04-12','17:50:00',1.45),('9303','2014-04-12','17:55:00',1.18),('9303','2013-09-08','09:15:00',1.06),('9303','2013-09-08','09:20:00',1.62),('9303','2013-09-08','09:25:00',2.31),('9303','2013-09-08','09:30:00',2.36),('9303','2013-09-08','09:35:00',2.2),('9303','2013-09-08','09:40:00',2.2),('9303','2013-09-08','09:45:00',2.23),('9303','2013-09-08','09:50:00',2.24),('9303','2013-09-08','09:55:00',2.29),('9303','2013-09-08','10:00:00',2.36),('9303','2013-09-08','10:05:00',2.41),('9303','2013-09-08','10:10:00',2.53),('9303','2013-09-08','10:15:00',2.55),('9303','2013-09-08','10:20:00',2.58),('9303','2013-09-08','10:25:00',2.64),('9303','2013-09-08','10:30:00',2.66),('9303','2013-09-08','10:35:00',2.76),('9303','2013-09-08','10:40:00',2.79),('9303','2013-09-08','10:45:00',2.87),('9303','2013-09-08','10:50:00',2.93),('9303','2013-09-08','10:55:00',2.96),('9303','2013-09-08','11:00:00',3.02),('9303','2013-09-08','11:05:00',3),('9303','2013-09-08','11:10:00',2.98),('9303','2013-09-08','11:15:00',2.89),('9303','2013-09-08','11:20:00',3.01),('9303','2013-09-08','11:25:00',2.98),('9303','2013-09-08','11:30:00',3.12),('9303','2013-09-08','11:35:00',3.19),('9303','2013-09-08','11:40:00',3.16),('9303','2013-09-08','11:45:00',3.12),('9303','2013-09-08','11:50:00',3.19),('9303','2013-09-08','11:55:00',3.22),('9303','2013-09-08','12:00:00',3.21),('9303','2013-09-08','12:05:00',3.21),('9303','2013-09-08','12:10:00',3.21),('9303','2013-09-08','12:15:00',3.36),('9303','2013-09-08','12:20:00',3.37),('9303','2013-09-08','12:25:00',3.23),('9303','2013-09-08','12:30:00',3.43),('9303','2013-09-08','12:35:00',3.43),('9303','2013-09-08','12:40:00',3.31),('9303','2013-09-08','12:45:00',3.32),('9303','2013-09-08','12:50:00',3.35),('9303','2013-09-08','12:55:00',3.4),('9303','2013-09-08','13:00:00',3.36),('9303','2013-09-08','13:05:00',3.43),('9303','2013-09-08','13:10:00',3.45),('9303','2013-09-08','13:15:00',3.34),('9303','2013-09-08','13:20:00',3.33),('9303','2013-09-08','13:25:00',3.14),('9303','2013-09-08','13:30:00',3),('9303','2013-09-08','13:35:00',3.01),('9303','2013-09-08','13:40:00',2.3),('9303','2013-09-08','13:45:00',2),('9303','2013-09-08','13:50:00',2.33),('9303','2013-09-08','13:55:00',2.47),('9303','2013-09-08','14:00:00',3.07),('9303','2013-09-08','14:05:00',3.13),('9303','2013-09-08','14:10:00',3.27),('9303','2013-09-08','14:15:00',3.05),('9303','2013-09-08','14:20:00',2.92),('9303','2013-09-08','14:25:00',3.66),('9303','2013-09-08','14:30:00',3.21),('9303','2013-09-08','14:35:00',3.45),('9303','2013-09-08','14:40:00',3.33),('9303','2013-09-08','14:45:00',3.34),('9303','2013-09-08','14:50:00',3.28),('9303','2013-09-08','14:55:00',3.23),('9303','2013-09-08','15:00:00',3.21),('9303','2013-09-08','15:05:00',2.69),('9303','2013-09-08','15:10:00',1.71),('9303','2013-09-08','15:15:00',2.41),('9303','2013-09-08','15:20:00',3),('9303','2013-09-08','15:25:00',3.04),('9303','2013-09-08','15:30:00',3.06),('9303','2013-09-08','15:35:00',2.96),('9303','2013-09-08','15:40:00',2.75),('9303','2013-09-08','15:45:00',2.76),('9303','2013-09-08','15:50:00',2.77),('9303','2013-09-08','15:55:00',2.21),('9303','2013-09-08','16:00:00',2.3),('9303','2013-09-08','16:05:00',2.26),('9303','2013-09-08','16:10:00',2.07),('9303','2013-09-08','16:15:00',2.27),('9303','2013-09-08','16:20:00',2.18),('9303','2013-09-08','16:25:00',2.12),('9303','2013-09-08','16:30:00',2.11),('9303','2013-09-08','16:35:00',1.98),('9303','2013-09-08','16:40:00',1.64),('9303','2013-09-08','16:45:00',1.02),('9303','2013-09-08','16:50:00',1.09),('9303','2013-09-08','17:00:00',1.07),('9303','2013-09-08','17:05:00',1.74),('9303','2013-09-08','17:10:00',1.65),('9303','2013-09-08','17:15:00',1.5),('9303','2013-09-08','17:20:00',1.3),('9303','2013-09-08','17:25:00',1.24),('9303','2013-09-08','17:30:00',1.14),('9303','2013-09-07','08:25:00',1.06),('9303','2013-09-07','08:30:00',1.14),('9303','2013-09-07','08:35:00',1.23),('9303','2013-09-07','08:40:00',1.32),('9303','2013-09-07','08:45:00',1.39),('9303','2013-09-07','08:50:00',1.49),('9303','2013-09-07','08:55:00',1.57),('9303','2013-09-07','09:00:00',1.66),('9303','2013-09-07','09:05:00',1.74),('9303','2013-09-07','09:10:00',1.82),('9303','2013-09-07','09:15:00',1.9),('9303','2013-09-07','09:20:00',1.95),('9303','2013-09-07','09:25:00',2.04),('9303','2013-09-07','09:30:00',2.12),('9303','2013-09-07','09:35:00',2.17),('9303','2013-09-07','09:40:00',2.22),('9303','2013-09-07','09:45:00',2.29),('9303','2013-09-07','09:50:00',2.36),('9303','2013-09-07','09:55:00',2.42),('9303','2013-09-07','10:00:00',2.48),('9303','2013-09-07','10:05:00',2.55),('9303','2013-09-07','10:10:00',2.6),('9303','2013-09-07','10:15:00',2.61),('9303','2013-09-07','10:20:00',2.66),('9303','2013-09-07','10:25:00',2.72),('9303','2013-09-07','10:30:00',2.78),('9303','2013-09-07','10:35:00',2.84),('9303','2013-09-07','10:40:00',2.86),('9303','2013-09-07','10:45:00',2.91),('9303','2013-09-07','10:50:00',2.96),('9303','2013-09-07','10:55:00',3.01),('9303','2013-09-07','11:00:00',3.03),('9303','2013-09-07','11:05:00',3.07),('9303','2013-09-07','11:10:00',3.12),('9303','2013-09-07','11:15:00',3.12),('9303','2013-09-07','11:20:00',3.24),('9303','2013-09-07','11:25:00',3.3),('9303','2013-09-07','11:30:00',3.34),('9303','2013-09-07','11:35:00',3.34),('9303','2013-09-07','11:40:00',3.38),('9303','2013-09-07','11:45:00',3.43),('9303','2013-09-07','11:50:00',3.44),('9303','2013-09-07','11:55:00',3.43),('9303','2013-09-07','12:00:00',3.45),('9303','2013-09-07','12:05:00',3.45),('9303','2013-09-07','12:10:00',3.44),('9303','2013-09-07','12:15:00',3.46),('9303','2013-09-07','12:20:00',3.52),('9303','2013-09-07','12:25:00',3.53),('9303','2013-09-07','12:30:00',3.55),('9303','2013-09-07','12:35:00',3.57),('9303','2013-09-07','12:40:00',3.52),('9303','2013-09-07','12:45:00',3.54),('9303','2013-09-07','12:50:00',3.57),('9303','2013-09-07','12:55:00',3.57),('9303','2013-09-07','13:00:00',3.64),('9303','2013-09-07','13:05:00',3.56),('9303','2013-09-07','13:10:00',3.53),('9303','2013-09-07','13:15:00',3.56),('9303','2013-09-07','13:20:00',3.52),('9303','2013-09-07','13:25:00',3.43),('9303','2013-09-07','13:30:00',3.56),('9303','2013-09-07','13:35:00',3.61),('9303','2013-09-07','13:40:00',3.53),('9303','2013-09-07','13:45:00',3.59),('9303','2013-09-07','13:50:00',3.58),('9303','2013-09-07','13:55:00',3.17),('9303','2013-09-07','14:00:00',1.84),('9303','2013-09-07','14:05:00',3.63),('9303','2013-09-07','14:10:00',3.6),('9303','2013-09-07','14:15:00',3.55),('9303','2013-09-07','14:20:00',3.43),('9303','2013-09-07','14:25:00',3.39),('9303','2013-09-07','14:30:00',3.42),('9303','2013-09-07','14:35:00',3.42),('9303','2013-09-07','14:40:00',3.41),('9303','2013-09-07','14:45:00',3.37),('9303','2013-09-07','14:50:00',3.32),('9303','2013-09-07','14:55:00',3.3),('9303','2013-09-07','15:00:00',3.28),('9303','2013-09-07','15:05:00',3.25),('9303','2013-09-07','15:10:00',3.16),('9303','2013-09-07','15:15:00',3.15),('9303','2013-09-07','15:20:00',3.09),('9303','2013-09-07','15:25:00',3.05),('9303','2013-09-07','15:30:00',3),('9303','2013-09-07','15:35:00',2.95),('9303','2013-09-07','15:40:00',2.86),('9303','2013-09-07','15:45:00',2.81),('9303','2013-09-07','15:50:00',2.76),('9303','2013-09-07','15:55:00',2.7),('9303','2013-09-07','16:00:00',2.65),('9303','2013-09-07','16:05:00',2.58),('9303','2013-09-07','16:10:00',2.51),('9303','2013-09-07','16:15:00',2.45),('9303','2013-09-07','16:20:00',2.37),('9303','2013-09-07','16:25:00',2.28),('9303','2013-09-07','16:30:00',2.23),('9303','2013-09-07','16:35:00',2.14),('9303','2013-09-07','16:40:00',2.02),('9303','2013-09-07','16:45:00',1.92),('9303','2013-09-07','16:50:00',1.83),('9303','2013-09-07','16:55:00',1.76),('9303','2013-09-07','17:00:00',1.69),('9303','2013-09-07','17:05:00',1.62),('9303','2013-09-07','17:10:00',1.54),('9303','2013-09-07','17:15:00',1.46),('9303','2013-09-07','17:20:00',1.37),('9303','2013-09-07','17:25:00',1.27),('9303','2013-09-07','17:30:00',1.18),('9303','2013-09-07','17:35:00',1.13),('9303','2013-09-07','17:40:00',1.03),('9303','2013-09-06','08:20:00',1),('9303','2013-09-06','08:25:00',1.09),('9303','2013-09-06','08:30:00',1.17),('9303','2013-09-06','08:35:00',1.28),('9303','2013-09-06','08:40:00',1.37),('9303','2013-09-06','08:45:00',1.46),('9303','2013-09-06','08:50:00',1.55),('9303','2013-09-06','08:55:00',1.64),('9303','2013-09-06','09:00:00',1.73),('9303','2013-09-06','09:05:00',1.8),('9303','2013-09-06','09:10:00',1.86),('9303','2013-09-06','09:15:00',1.93),('9303','2013-09-06','09:20:00',2),('9303','2013-09-06','09:25:00',2.05),('9303','2013-09-06','09:30:00',2.13),('9303','2013-09-06','09:35:00',2.19),('9303','2013-09-06','09:40:00',2.25),('9303','2013-09-06','09:45:00',2.32),('9303','2013-09-06','09:50:00',2.4),('9303','2013-09-06','09:55:00',2.46),('9303','2013-09-06','10:00:00',2.52),('9303','2013-09-06','10:05:00',2.57),('9303','2013-09-06','10:10:00',2.62),('9303','2013-09-06','10:15:00',2.68),('9303','2013-09-06','10:20:00',2.75),('9303','2013-09-06','10:25:00',2.81),('9303','2013-09-06','10:30:00',2.87),('9303','2013-09-06','10:35:00',2.91),('9303','2013-09-06','10:40:00',2.97),('9303','2013-09-06','10:45:00',2.99),('9303','2013-09-06','10:50:00',3.05),('9303','2013-09-06','10:55:00',3.09),('9303','2013-09-06','11:00:00',3.15),('9303','2013-09-06','11:05:00',3.16),('9303','2013-09-06','11:10:00',3.19),('9303','2013-09-06','11:15:00',3.22),('9303','2013-09-06','11:20:00',3.26),('9303','2013-09-06','11:25:00',3.3),('9303','2013-09-06','11:30:00',3.32),('9303','2013-09-06','11:35:00',3.35),('9303','2013-09-06','11:40:00',3.36),('9303','2013-09-06','11:45:00',3.41),('9303','2013-09-06','11:50:00',3.42),('9303','2013-09-06','11:55:00',3.45),('9303','2013-09-06','12:00:00',3.47),('9303','2013-09-06','12:05:00',3.44),('9303','2013-09-06','12:10:00',3.48),('9303','2013-09-06','12:15:00',3.52),('9303','2013-09-06','12:20:00',3.55),('9303','2013-09-06','12:25:00',3.59),('9303','2013-09-06','12:30:00',3.58),('9303','2013-09-06','12:35:00',3.61),('9303','2013-09-06','12:40:00',3.58),('9303','2013-09-06','12:45:00',3.53),('9303','2013-09-06','12:50:00',3.55),('9303','2013-09-06','12:55:00',3.61),('9303','2013-09-06','13:00:00',3.63),('9303','2013-09-06','13:05:00',3.61),('9303','2013-09-06','13:10:00',3.58),('9303','2013-09-06','13:15:00',3.56),('9303','2013-09-06','13:20:00',3.57),('9303','2013-09-06','13:25:00',3.55),('9303','2013-09-06','13:30:00',3.54),('9303','2013-09-06','13:35:00',3.51),('9303','2013-09-06','13:40:00',3.49),('9303','2013-09-06','13:45:00',3.5),('9303','2013-09-06','13:50:00',3.5),('9303','2013-09-06','13:55:00',3.48),('9303','2013-09-06','14:00:00',3.46),('9303','2013-09-06','14:05:00',3.44),('9303','2013-09-06','14:10:00',3.42),('9303','2013-09-06','14:15:00',3.4),('9303','2013-09-06','14:20:00',3.37),('9303','2013-09-06','14:25:00',3.35),('9303','2013-09-06','14:30:00',3.34),('9303','2013-09-06','14:35:00',3.21),('9303','2013-09-06','14:40:00',3.19),('9303','2013-09-06','14:45:00',3.26),('9303','2013-09-06','14:50:00',3.29),('9303','2013-09-06','14:55:00',3.26),('9303','2013-09-06','15:00:00',3.22),('9303','2013-09-06','15:05:00',3.12),('9303','2013-09-06','15:10:00',3.09),('9303','2013-09-06','15:15:00',3.06),('9303','2013-09-06','15:20:00',3.03),('9303','2013-09-06','15:25:00',3),('9303','2013-09-06','15:30:00',2.95),('9303','2013-09-06','15:35:00',2.88),('9303','2013-09-06','15:40:00',2.84),('9303','2013-09-06','15:45:00',2.78),('9303','2013-09-06','15:50:00',2.73),('9303','2013-09-06','15:55:00',2.69),('9303','2013-09-06','16:00:00',2.63),('9303','2013-09-06','16:05:00',2.54),('9303','2013-09-06','16:10:00',2.48),('9303','2013-09-06','16:15:00',2.41),('9303','2013-09-06','16:20:00',2.35),('9303','2013-09-06','16:25:00',2.32),('9303','2013-09-06','16:30:00',2.24),('9303','2013-09-06','16:35:00',2.16),('9303','2013-09-06','16:40:00',2.05),('9303','2013-09-06','16:45:00',1.96),('9303','2013-09-06','16:50:00',1.85),('9303','2013-09-06','16:55:00',1.77),('9303','2013-09-06','17:00:00',1.72),('9303','2013-09-06','17:05:00',1.61),('9303','2013-09-06','17:10:00',1.56),('9303','2013-09-06','17:15:00',1.48),('9303','2013-09-06','17:20:00',1.39),('9303','2013-09-06','17:25:00',1.28),('9303','2013-09-06','17:30:00',1.17),('9303','2013-09-06','17:35:00',1.11),('9303','2013-09-06','17:40:00',1.04),('9303','2013-09-05','08:15:00',1.02),('9303','2013-09-05','08:20:00',1.11),('9303','2013-09-05','08:25:00',1.21),('9303','2013-09-05','08:30:00',1.31),('9303','2013-09-05','08:35:00',1.4),('9303','2013-09-05','08:40:00',1.49),('9303','2013-09-05','08:45:00',1.58),('9303','2013-09-05','08:50:00',1.67),('9303','2013-09-05','08:55:00',1.74),('9303','2013-09-05','09:00:00',1.83),('9303','2013-09-05','09:05:00',1.92),('9303','2013-09-05','09:10:00',2),('9303','2013-09-05','09:15:00',2.07),('9303','2013-09-05','09:20:00',2.14),('9303','2013-09-05','09:25:00',2.21),('9303','2013-09-05','09:30:00',2.29),('9303','2013-09-05','09:35:00',2.35),('9303','2013-09-05','09:40:00',2.4),('9303','2013-09-05','09:45:00',2.47),('9303','2013-09-05','09:50:00',2.54),('9303','2013-09-05','09:55:00',2.61),('9303','2013-09-05','10:00:00',2.67),('9303','2013-09-05','10:05:00',2.72),('9303','2013-09-05','10:10:00',2.75),('9303','2013-09-05','10:15:00',2.8),('9303','2013-09-05','10:20:00',2.86),('9303','2013-09-05','10:25:00',2.91),('9303','2013-09-05','10:30:00',2.95),('9303','2013-09-05','10:35:00',2.99),('9303','2013-09-05','10:40:00',3.05),('9303','2013-09-05','10:45:00',3.11),('9303','2013-09-05','10:50:00',3.14),('9303','2013-09-05','10:55:00',3.16),('9303','2013-09-05','11:00:00',3.24),('9303','2013-09-05','11:05:00',3.27),('9303','2013-09-05','11:10:00',3.29),('9303','2013-09-05','11:15:00',3.33),('9303','2013-09-05','11:20:00',3.37),('9303','2013-09-05','11:25:00',3.42),('9303','2013-09-05','11:30:00',3.43),('9303','2013-09-05','11:35:00',3.47),('9303','2013-09-05','11:40:00',3.45),('9303','2013-09-05','11:45:00',3.42),('9303','2013-09-05','11:50:00',3.51),('9303','2013-09-05','11:55:00',3.56),('9303','2013-09-05','12:00:00',3.56),('9303','2013-09-05','12:05:00',3.59),('9303','2013-09-05','12:10:00',3.61),('9303','2013-09-05','12:15:00',3.64),('9303','2013-09-05','12:20:00',3.65),('9303','2013-09-05','12:25:00',3.62),('9303','2013-09-05','12:30:00',3.62),('9303','2013-09-05','12:35:00',3.64),('9303','2013-09-05','12:40:00',3.68),('9303','2013-09-05','12:45:00',3.67),('9303','2013-09-05','12:50:00',3.68),('9303','2013-09-05','12:55:00',3.7),('9303','2013-09-05','13:00:00',3.72),('9303','2013-09-05','13:05:00',3.7),('9303','2013-09-05','13:10:00',3.69),('9303','2013-09-05','13:15:00',3.69),('9303','2013-09-05','13:20:00',3.69),('9303','2013-09-05','13:25:00',3.67),('9303','2013-09-05','13:30:00',3.68),('9303','2013-09-05','13:35:00',3.7),('9303','2013-09-05','13:40:00',3.67),('9303','2013-09-05','13:45:00',3.61),('9303','2013-09-05','13:50:00',3.63),('9303','2013-09-05','13:55:00',3.6),('9303','2013-09-05','14:00:00',3.59),('9303','2013-09-05','14:05:00',3.59),('9303','2013-09-05','14:10:00',3.55),('9303','2013-09-05','14:15:00',3.56),('9303','2013-09-05','14:20:00',3.54),('9303','2013-09-05','14:25:00',3.48),('9303','2013-09-05','14:30:00',3.44),('9303','2013-09-05','14:35:00',3.41),('9303','2013-09-05','14:40:00',3.32),('9303','2013-09-05','14:45:00',3.29),('9303','2013-09-05','14:50:00',3.28),('9303','2013-09-05','14:55:00',3.31),('9303','2013-09-05','15:00:00',3.29),('9303','2013-09-05','15:05:00',3.29),('9303','2013-09-05','15:10:00',3.25),('9303','2013-09-05','15:15:00',3.2),('9303','2013-09-05','15:20:00',3.15),('9303','2013-09-05','15:25:00',3.1),('9303','2013-09-05','15:30:00',3.05),('9303','2013-09-05','15:35:00',2.99),('9303','2013-09-05','15:40:00',2.95),('9303','2013-09-05','15:45:00',2.89),('9303','2013-09-05','15:50:00',2.81),('9303','2013-09-05','15:55:00',2.79),('9303','2013-09-05','16:00:00',2.74),('9303','2013-09-05','16:05:00',2.69),('9303','2013-09-05','16:10:00',2.63),('9303','2013-09-05','16:15:00',2.57),('9303','2013-09-05','16:20:00',2.51),('9303','2013-09-05','16:25:00',2.44),('9303','2013-09-05','16:30:00',2.37),('9303','2013-09-05','16:35:00',2.33),('9303','2013-09-05','16:40:00',2.24),('9303','2013-09-05','16:45:00',2.17),('9303','2013-09-05','16:50:00',1.88),('9303','2013-09-05','16:55:00',1.5),('9303','2013-09-05','17:00:00',1.14),('9303','2013-09-05','17:05:00',1.2),('9303','2013-09-05','17:10:00',1.27),('9303','2013-09-05','17:15:00',1.08),('9303','2013-09-05','17:20:00',1.21),('9303','2013-09-05','17:25:00',1.22),('9303','2013-09-05','17:30:00',1.17),('9303','2013-09-05','17:35:00',1.2),('9303','2013-09-05','17:40:00',1.29),('9303','2013-09-05','17:45:00',1.18),('9303','2013-09-05','17:50:00',1.03),('9303','2013-09-04','08:15:00',1),('9303','2013-09-04','08:20:00',1.11),('9303','2013-09-04','08:25:00',1.2),('9303','2013-09-04','08:30:00',1.3),('9303','2013-09-04','08:35:00',1.39),('9303','2013-09-04','08:40:00',1.48),('9303','2013-09-04','08:45:00',1.57),('9303','2013-09-04','08:50:00',1.67),('9303','2013-09-04','08:55:00',1.75),('9303','2013-09-04','09:00:00',1.84),('9303','2013-09-04','09:05:00',1.92),('9303','2013-09-04','09:10:00',2),('9303','2013-09-04','09:15:00',2.09),('9303','2013-09-04','09:20:00',2.17),('9303','2013-09-04','09:25:00',2.26),('9303','2013-09-04','09:30:00',2.33),('9303','2013-09-04','09:35:00',2.41),('9303','2013-09-04','09:40:00',2.47),('9303','2013-09-04','09:45:00',2.55),('9303','2013-09-04','09:50:00',2.61),('9303','2013-09-04','09:55:00',2.69),('9303','2013-09-04','10:00:00',2.76),('9303','2013-09-04','10:05:00',2.82),('9303','2013-09-04','10:10:00',2.87),('9303','2013-09-04','10:15:00',2.91),('9303','2013-09-04','10:20:00',2.96),('9303','2013-09-04','10:25:00',3),('9303','2013-09-04','10:30:00',3.06),('9303','2013-09-04','10:35:00',3.13),('9303','2013-09-04','10:40:00',3.16),('9303','2013-09-04','10:45:00',3.2),('9303','2013-09-04','10:50:00',3.25),('9303','2013-09-04','10:55:00',3.31),('9303','2013-09-04','11:00:00',3.35),('9303','2013-09-04','11:05:00',3.39),('9303','2013-09-04','11:10:00',3.43),('9303','2013-09-04','11:15:00',3.49),('9303','2013-09-04','11:20:00',3.51),('9303','2013-09-04','11:25:00',3.54),('9303','2013-09-04','11:30:00',3.54),('9303','2013-09-04','11:35:00',3.57),('9303','2013-09-04','11:40:00',3.63),('9303','2013-09-04','11:45:00',3.66),('9303','2013-09-04','11:50:00',3.7),('9303','2013-09-04','11:55:00',3.72),('9303','2013-09-04','12:00:00',3.76),('9303','2013-09-04','12:05:00',3.76),('9303','2013-09-04','12:10:00',3.79),('9303','2013-09-04','12:15:00',3.8),('9303','2013-09-04','12:20:00',3.82),('9303','2013-09-04','12:25:00',3.84),('9303','2013-09-04','12:30:00',3.84),('9303','2013-09-04','12:35:00',3.86),('9303','2013-09-04','12:40:00',3.84),('9303','2013-09-04','12:45:00',3.83),('9303','2013-09-04','12:50:00',3.85),('9303','2013-09-04','12:55:00',3.86),('9303','2013-09-04','13:00:00',3.84),('9303','2013-09-04','13:05:00',3.82),('9303','2013-09-04','13:10:00',3.84),('9303','2013-09-04','13:15:00',3.83),('9303','2013-09-04','13:20:00',3.82),('9303','2013-09-04','13:25:00',3.83),('9303','2013-09-04','13:30:00',3.83),('9303','2013-09-04','13:35:00',3.82),('9303','2013-09-04','13:40:00',3.82),('9303','2013-09-04','13:45:00',3.79),('9303','2013-09-04','13:50:00',3.78),('9303','2013-09-04','13:55:00',3.78),('9303','2013-09-04','14:00:00',3.75),('9303','2013-09-04','14:05:00',3.74),('9303','2013-09-04','14:10:00',3.71),('9303','2013-09-04','14:15:00',3.69),('9303','2013-09-04','14:20:00',3.66),('9303','2013-09-04','14:25:00',3.65),('9303','2013-09-04','14:30:00',3.63),('9303','2013-09-04','14:35:00',3.6),('9303','2013-09-04','14:40:00',3.56),('9303','2013-09-04','14:45:00',3.52),('9303','2013-09-04','14:50:00',3.49),('9303','2013-09-04','14:55:00',3.44),('9303','2013-09-04','15:00:00',3.4),('9303','2013-09-04','15:05:00',3.37),('9303','2013-09-04','15:10:00',3.33),('9303','2013-09-04','15:15:00',3.3),('9303','2013-09-04','15:20:00',3.25),('9303','2013-09-04','15:25:00',3.19),('9303','2013-09-04','15:30:00',3.14),('9303','2013-09-04','15:35:00',3.07),('9303','2013-09-04','15:40:00',3.02),('9303','2013-09-04','15:45:00',2.96),('9303','2013-09-04','15:50:00',2.91),('9303','2013-09-04','15:55:00',2.84),('9303','2013-09-04','16:00:00',2.78),('9303','2013-09-04','16:05:00',2.71),('9303','2013-09-04','16:10:00',2.65),('9303','2013-09-04','16:15:00',2.6),('9303','2013-09-04','16:20:00',2.53),('9303','2013-09-04','16:25:00',2.46),('9303','2013-09-04','16:30:00',2.41),('9303','2013-09-04','16:35:00',2.33),('9303','2013-09-04','16:40:00',2.23),('9303','2013-09-04','16:45:00',2.11),('9303','2013-09-04','16:50:00',2),('9303','2013-09-04','16:55:00',1.92),('9303','2013-09-04','17:00:00',1.84),('9303','2013-09-04','17:05:00',1.76),('9303','2013-09-04','17:10:00',1.68),('9303','2013-09-04','17:15:00',1.61),('9303','2013-09-04','17:20:00',1.54),('9303','2013-09-04','17:25:00',1.45),('9303','2013-09-04','17:30:00',1.35),('9303','2013-09-04','17:35:00',1.26),('9303','2013-09-04','17:40:00',1.17),('9303','2013-09-04','17:45:00',1.08),('9303','2013-09-03','08:25:00',1.07),('9303','2013-09-03','08:30:00',1.17),('9303','2013-09-03','08:35:00',1.27),('9303','2013-09-03','08:40:00',1.33),('9303','2013-09-03','08:45:00',1.44),('9303','2013-09-03','08:50:00',1.53),('9303','2013-09-03','08:55:00',1.61),('9303','2013-09-03','09:00:00',1.69),('9303','2013-09-03','09:05:00',1.77),('9303','2013-09-03','09:10:00',1.86),('9303','2013-09-03','09:15:00',1.92),('9303','2013-09-03','09:20:00',2.02),('9303','2013-09-03','09:25:00',2.1),('9303','2013-09-03','09:30:00',2.17),('9303','2013-09-03','09:35:00',2.24),('9303','2013-09-03','09:40:00',2.3),('9303','2013-09-03','09:45:00',2.36),('9303','2013-09-03','09:50:00',2.43),('9303','2013-09-03','09:55:00',2.5),('9303','2013-09-03','10:00:00',2.55),('9303','2013-09-03','10:05:00',2.62),('9303','2013-09-03','10:10:00',2.67),('9303','2013-09-03','10:15:00',2.74),('9303','2013-09-03','10:20:00',2.8),('9303','2013-09-03','10:25:00',2.85),('9303','2013-09-03','10:30:00',2.93),('9303','2013-09-03','10:35:00',3.01),('9303','2013-09-03','10:40:00',3.09),('9303','2013-09-03','10:45:00',3.13),('9303','2013-09-03','10:50:00',3.16),('9303','2013-09-03','10:55:00',3.17),('9303','2013-09-03','11:00:00',3.2),('9303','2013-09-03','11:05:00',3.23),('9303','2013-09-03','11:10:00',3.3),('9303','2013-09-03','11:15:00',3.34),('9303','2013-09-03','11:20:00',3.38),('9303','2013-09-03','11:25:00',3.42),('9303','2013-09-03','11:30:00',3.44),('9303','2013-09-03','11:35:00',3.46),('9303','2013-09-03','11:40:00',3.48),('9303','2013-09-03','11:45:00',3.51),('9303','2013-09-03','11:50:00',3.56),('9303','2013-09-03','11:55:00',3.58),('9303','2013-09-03','12:00:00',3.57),('9303','2013-09-03','12:05:00',3.62),('9303','2013-09-03','12:10:00',3.64),('9303','2013-09-03','12:15:00',3.68),('9303','2013-09-03','12:20:00',3.71),('9303','2013-09-03','12:25:00',3.73),('9303','2013-09-03','12:30:00',3.75),('9303','2013-09-03','12:35:00',3.75),('9303','2013-09-03','12:40:00',3.77),('9303','2013-09-03','12:45:00',3.75),('9303','2013-09-03','12:50:00',3.75),('9303','2013-09-03','12:55:00',3.78),('9303','2013-09-03','13:00:00',3.78),('9303','2013-09-03','13:05:00',3.81),('9303','2013-09-03','13:10:00',3.82),('9303','2013-09-03','13:15:00',3.8),('9303','2013-09-03','13:20:00',3.76),('9303','2013-09-03','13:25:00',3.73),('9303','2013-09-03','13:30:00',3.75),('9303','2013-09-03','13:35:00',3.77),('9303','2013-09-03','13:40:00',3.7),('9303','2013-09-03','13:45:00',3.74),('9303','2013-09-03','13:50:00',3.73),('9303','2013-09-03','13:55:00',3.68),('9303','2013-09-03','14:00:00',3.6),('9303','2013-09-03','14:05:00',3.58),('9303','2013-09-03','14:10:00',3.61),('9303','2013-09-03','14:15:00',3.57),('9303','2013-09-03','14:20:00',3.56),('9303','2013-09-03','14:25:00',3.56),('9303','2013-09-03','14:30:00',3.57),('9303','2013-09-03','14:35:00',3.56),('9303','2013-09-03','14:40:00',3.54),('9303','2013-09-03','14:45:00',3.5),('9303','2013-09-03','14:50:00',3.51),('9303','2013-09-03','14:55:00',3.45),('9303','2013-09-03','15:00:00',3.35),('9303','2013-09-03','15:05:00',3.31),('9303','2013-09-03','15:10:00',3.27),('9303','2013-09-03','15:15:00',3.25),('9303','2013-09-03','15:20:00',3.19),('9303','2013-09-03','15:25:00',3.15),('9303','2013-09-03','15:30:00',3.07),('9303','2013-09-03','15:35:00',3.02),('9303','2013-09-03','15:40:00',2.94),('9303','2013-09-03','15:45:00',2.89),('9303','2013-09-03','15:50:00',2.85),('9303','2013-09-03','15:55:00',2.8),('9303','2013-09-03','16:00:00',2.78),('9303','2013-09-03','16:05:00',2.71),('9303','2013-09-03','16:10:00',2.62),('9303','2013-09-03','16:15:00',2.54),('9303','2013-09-03','16:20:00',2.49),('9303','2013-09-03','16:25:00',2.43),('9303','2013-09-03','16:30:00',2.35),('9303','2013-09-03','16:35:00',2.29),('9303','2013-09-03','16:40:00',2.19),('9303','2013-09-03','16:45:00',2.09),('9303','2013-09-03','16:50:00',1.99),('9303','2013-09-03','16:55:00',1.91),('9303','2013-09-03','17:00:00',1.84),('9303','2013-09-03','17:05:00',1.77),('9303','2013-09-03','17:10:00',1.7),('9303','2013-09-03','17:15:00',1.62),('9303','2013-09-03','17:20:00',1.55),('9303','2013-09-03','17:25:00',1.47),('9303','2013-09-03','17:30:00',1.37),('9303','2013-09-03','17:35:00',1.29),('9303','2013-09-03','17:40:00',1.21),('9303','2013-09-03','17:45:00',1.11),('9303','2013-09-03','17:50:00',1.03),('9303','2013-09-02','08:20:00',1.05),('9303','2013-09-02','08:25:00',1.12),('9303','2013-09-02','08:30:00',1.21),('9303','2013-09-02','08:35:00',1.31),('9303','2013-09-02','08:40:00',1.4),('9303','2013-09-02','08:45:00',1.5),('9303','2013-09-02','08:50:00',1.59),('9303','2013-09-02','08:55:00',1.67),('9303','2013-09-02','09:00:00',1.75),('9303','2013-09-02','09:05:00',1.83),('9303','2013-09-02','09:10:00',1.92),('9303','2013-09-02','09:15:00',2),('9303','2013-09-02','09:20:00',2.07),('9303','2013-09-02','09:25:00',2.15),('9303','2013-09-02','09:30:00',2.23),('9303','2013-09-02','09:35:00',2.3),('9303','2013-09-02','09:40:00',2.36),('9303','2013-09-02','09:45:00',2.44),('9303','2013-09-02','09:50:00',2.49),('9303','2013-09-02','09:55:00',2.53),('9303','2013-09-02','10:00:00',2.6),('9303','2013-09-02','10:05:00',2.67),('9303','2013-09-02','10:10:00',2.75),('9303','2013-09-02','10:15:00',2.83),('9303','2013-09-02','10:20:00',2.86),('9303','2013-09-02','10:25:00',2.92),('9303','2013-09-02','10:30:00',2.97),('9303','2013-09-02','10:35:00',3.02),('9303','2013-09-02','10:40:00',3.06),('9303','2013-09-02','10:45:00',3.08),('9303','2013-09-02','10:50:00',3.11),('9303','2013-09-02','10:55:00',3.17),('9303','2013-09-02','11:00:00',3.22),('9303','2013-09-02','11:05:00',3.25),('9303','2013-09-02','11:10:00',3.3),('9303','2013-09-02','11:15:00',3.34),('9303','2013-09-02','11:20:00',3.39),('9303','2013-09-02','11:25:00',3.39),('9303','2013-09-02','11:30:00',3.41),('9303','2013-09-02','11:35:00',3.43),('9303','2013-09-02','11:40:00',3.47),('9303','2013-09-02','11:45:00',3.49),('9303','2013-09-02','11:50:00',3.5),('9303','2013-09-02','11:55:00',3.52),('9303','2013-09-02','12:00:00',3.58),('9303','2013-09-02','12:05:00',3.61),('9303','2013-09-02','12:10:00',3.69),('9303','2013-09-02','12:15:00',3.67),('9303','2013-09-02','12:20:00',3.65),('9303','2013-09-02','12:25:00',3.62),('9303','2013-09-02','12:30:00',3.64),('9303','2013-09-02','12:35:00',3.67),('9303','2013-09-02','12:40:00',3.65),('9303','2013-09-02','12:45:00',3.64),('9303','2013-09-02','12:50:00',3.67),('9303','2013-09-02','12:55:00',3.72),('9303','2013-09-02','13:00:00',3.72),('9303','2013-09-02','13:05:00',3.71),('9303','2013-09-02','13:10:00',3.71),('9303','2013-09-02','13:15:00',3.68),('9303','2013-09-02','13:20:00',3.68),('9303','2013-09-02','13:25:00',3.69),('9303','2013-09-02','13:30:00',3.65),('9303','2013-09-02','13:35:00',3.67),('9303','2013-09-02','13:40:00',3.6),('9303','2013-09-02','13:45:00',2.61),('9303','2013-09-02','13:50:00',1.49),('9303','2013-09-02','13:55:00',3.79),('9303','2013-09-02','14:00:00',3.72),('9303','2013-09-02','14:05:00',3.42),('9303','2013-09-02','14:10:00',3.65),('9303','2013-09-02','14:15:00',3.67),('9303','2013-09-02','14:20:00',3.62),('9303','2013-09-02','14:25:00',3.61),('9303','2013-09-02','14:30:00',3.55),('9303','2013-09-02','14:35:00',3.5),('9303','2013-09-02','14:40:00',3.57),('9303','2013-09-02','14:45:00',3.56),('9303','2013-09-02','14:50:00',3.42),('9303','2013-09-02','15:00:00',2.49),('9303','2013-09-02','15:05:00',3),('9303','2013-09-02','15:10:00',3.32),('9303','2013-09-02','15:15:00',2.97),('9303','2013-09-02','15:25:00',3.01),('9303','2013-09-02','15:30:00',2.36),('9303','2013-09-02','15:35:00',1.67),('9303','2013-09-02','15:40:00',2.99),('9303','2013-09-02','15:45:00',3),('9303','2013-09-02','15:50:00',2.98),('9303','2013-09-02','15:55:00',2.91),('9303','2013-09-02','16:00:00',2.81),('9303','2013-09-02','16:05:00',2.7),('9303','2013-09-02','16:10:00',2.66),('9303','2013-09-02','16:15:00',2.65),('9303','2013-09-02','16:20:00',2.62),('9303','2013-09-02','16:25:00',2.51),('9303','2013-09-02','16:30:00',2.43),('9303','2013-09-02','16:35:00',2.34),('9303','2013-09-02','16:40:00',2.22),('9303','2013-09-02','16:45:00',2.1),('9303','2013-09-02','16:50:00',1.97),('9303','2013-09-02','16:55:00',1.84),('9303','2013-09-02','17:00:00',1.77),('9303','2013-09-02','17:06:00',1.71),('9303','2013-09-02','17:10:00',1.63),('9303','2013-09-02','17:15:00',1.56),('9303','2013-09-02','17:20:00',1.49),('9303','2013-09-02','17:25:00',1.41),('9303','2013-09-02','17:30:00',1.3),('9303','2013-09-02','17:35:00',1.22),('9303','2013-09-02','17:40:00',1.15),('9303','2013-09-02','17:45:00',1.06),('9303','2013-09-01','08:15:00',1.01),('9303','2013-09-01','08:20:00',1.11),('9303','2013-09-01','08:25:00',1.19),('9303','2013-09-01','08:30:00',1.24),('9303','2013-09-01','08:35:00',1.37),('9303','2013-09-01','08:40:00',1.47),('9303','2013-09-01','08:45:00',1.57),('9303','2013-09-01','08:50:00',1.65),('9303','2013-09-01','08:55:00',1.75),('9303','2013-09-01','09:00:00',1.81),('9303','2013-09-01','09:05:00',1.88),('9303','2013-09-01','09:10:00',1.97),('9303','2013-09-01','09:15:00',2.05),('9303','2013-09-01','09:20:00',2.13),('9303','2013-09-01','09:25:00',2.2),('9303','2013-09-01','09:30:00',2.27),('9303','2013-09-01','09:35:00',2.35),('9303','2013-09-01','09:40:00',2.42),('9303','2013-09-01','09:45:00',2.48),('9303','2013-09-01','09:50:00',2.56),('9303','2013-09-01','09:55:00',2.6),('9303','2013-09-01','10:00:00',2.67),('9303','2013-09-01','10:05:00',2.72),('9303','2013-09-01','10:10:00',2.77),('9303','2013-09-01','10:15:00',2.82),('9303','2013-09-01','10:20:00',2.87),('9303','2013-09-01','10:25:00',2.91),('9303','2013-09-01','10:30:00',2.99),('9303','2013-09-01','10:35:00',3.02),('9303','2013-09-01','10:40:00',3.08),('9303','2013-09-01','10:45:00',3.14),('9303','2013-09-01','10:50:00',3.17),('9303','2013-09-01','10:55:00',3.22),('9303','2013-09-01','11:00:00',3.27),('9303','2013-09-01','11:05:00',3.32),('9303','2013-09-01','11:10:00',3.35),('9303','2013-09-01','11:15:00',3.36),('9303','2013-09-01','11:20:00',3.38),('9303','2013-09-01','11:25:00',3.4),('9303','2013-09-01','11:30:00',3.44),('9303','2013-09-01','11:35:00',3.46),('9303','2013-09-01','11:40:00',3.55),('9303','2013-09-01','11:45:00',3.57),('9303','2013-09-01','11:50:00',3.59),('9303','2013-09-01','11:55:00',3.62),('9303','2013-09-01','12:00:00',3.63),('9303','2013-09-01','12:05:00',3.6),('9303','2013-09-01','12:10:00',3.63),('9303','2013-09-01','12:15:00',3.67),('9303','2013-09-01','12:20:00',3.69),('9303','2013-09-01','12:25:00',3.61),('9303','2013-09-01','12:30:00',3.7),('9303','2013-09-01','12:35:00',3.66),('9303','2013-09-01','12:40:00',3.69),('9303','2013-09-01','12:45:00',3.68),('9303','2013-09-01','12:50:00',3.69),('9303','2013-09-01','12:55:00',3.69),('9303','2013-09-01','13:00:00',3.75),('9303','2013-09-01','13:05:00',3.7),('9303','2013-09-01','13:10:00',3.72),('9303','2013-09-01','13:15:00',3.63),('9303','2013-09-01','13:20:00',3.79),('9303','2013-09-01','13:25:00',3.81),('9303','2013-09-01','13:30:00',3.86),('9303','2013-09-01','13:35:00',3.77),('9303','2013-09-01','13:40:00',3.76),('9303','2013-09-01','13:45:00',3.59),('9303','2013-09-01','13:50:00',3.13),('9303','2013-09-01','13:55:00',3.38),('9303','2013-09-01','14:00:00',2.89),('9303','2013-09-01','14:05:00',2.94),('9303','2013-09-01','14:10:00',3.31),('9303','2013-09-01','14:15:00',3.33),('9303','2013-09-01','14:20:00',3.01),('9303','2013-09-01','14:25:00',3.11),('9303','2013-09-01','14:30:00',3.16),('9303','2013-09-01','14:35:00',3.14),('9303','2013-09-01','14:40:00',3.12),('9303','2013-09-01','14:45:00',3.16),('9303','2013-09-01','14:50:00',3.17),('9303','2013-09-01','14:55:00',3.02),('9303','2013-09-01','15:00:00',3.02),('9303','2013-09-01','15:05:00',3.02),('9303','2013-09-01','15:10:00',3),('9303','2013-09-01','15:15:00',2.95),('9303','2013-09-01','15:20:00',2.82),('9303','2013-09-01','15:25:00',2.56),('9303','2013-09-01','15:30:00',2.1),('9303','2013-09-01','15:35:00',2.29),('9303','2013-09-01','15:40:00',2.63),('9303','2013-09-01','15:45:00',2.42),('9303','2013-09-01','15:50:00',1.9),('9303','2013-09-01','15:55:00',1.94),('9303','2013-09-01','16:00:00',2.45),('9303','2013-09-01','16:05:00',2.52),('9303','2013-09-01','16:10:00',2.64),('9303','2013-09-01','16:15:00',2.5),('9303','2013-09-01','16:20:00',2.38),('9303','2013-09-01','16:25:00',2.34),('9303','2013-09-01','16:30:00',2.51),('9303','2013-09-01','16:35:00',2.39),('9303','2013-09-01','16:40:00',2.32),('9303','2013-09-01','16:45:00',2.13),('9303','2013-09-01','16:50:00',1.98),('9303','2013-09-01','16:55:00',1.77),('9303','2013-09-01','17:00:00',1.48),('9303','2013-09-01','17:05:00',1.42),('9303','2013-09-01','17:10:00',1.22),('9303','2013-09-01','17:15:00',1.22),('9303','2013-09-01','17:20:00',1.35),('9303','2013-09-01','17:25:00',1.3),('9303','2013-09-01','17:30:00',1.16),('9303','2013-09-01','17:35:00',1.11),('9303','2013-09-01','17:40:00',1.15),('9303','2013-08-31','08:25:00',1.07),('9303','2013-08-31','08:30:00',1.31),('9303','2013-08-31','08:35:00',1.39),('9303','2013-08-31','08:40:00',1.51),('9303','2013-08-31','08:45:00',1.64),('9303','2013-08-31','08:50:00',1.81),('9303','2013-08-31','08:55:00',1.95),('9303','2013-08-31','09:00:00',2.06),('9303','2013-08-31','09:05:00',1.88),('9303','2013-08-31','09:10:00',1.54),('9303','2013-08-31','09:15:00',1.88),('9303','2013-08-31','09:20:00',2.13),('9303','2013-08-31','09:25:00',2.34),('9303','2013-08-31','09:30:00',2.39),('9303','2013-08-31','09:35:00',2.48),('9303','2013-08-31','09:40:00',2.52),('9303','2013-08-31','09:45:00',2.37),('9303','2013-08-31','09:50:00',2.44),('9303','2013-08-31','09:55:00',2.64),('9303','2013-08-31','10:00:00',2.79),('9303','2013-08-31','10:05:00',2.76),('9303','2013-08-31','10:10:00',2.89),('9303','2013-08-31','10:15:00',2.91),('9303','2013-08-31','10:20:00',2.98),('9303','2013-08-31','10:25:00',3.03),('9303','2013-08-31','10:30:00',3.09),('9303','2013-08-31','10:35:00',3.15),('9303','2013-08-31','10:40:00',3.16),('9303','2013-08-31','10:45:00',3.24),('9303','2013-08-31','10:50:00',3.33),('9303','2013-08-31','10:55:00',3.38),('9303','2013-08-31','11:00:00',3.42),('9303','2013-08-31','11:05:00',3.46),('9303','2013-08-31','11:10:00',3.49),('9303','2013-08-31','11:15:00',3.52),('9303','2013-08-31','11:20:00',3.57),('9303','2013-08-31','11:25:00',3.6),('9303','2013-08-31','11:30:00',3.64),('9303','2013-08-31','11:35:00',3.69),('9303','2013-08-31','11:40:00',3.73),('9303','2013-08-31','11:45:00',3.73),('9303','2013-08-31','11:50:00',3.75),('9303','2013-08-31','11:55:00',3.79),('9303','2013-08-31','12:00:00',3.8),('9303','2013-08-31','12:05:00',3.56),('9303','2013-08-31','12:10:00',3.82),('9303','2013-08-31','12:15:00',3.76),('9303','2013-08-31','12:20:00',3.75),('9303','2013-08-31','12:25:00',3.83),('9303','2013-08-31','12:30:00',3.82),('9303','2013-08-31','12:35:00',3.81),('9303','2013-08-31','12:40:00',3.82),('9303','2013-08-31','12:45:00',3.78),('9303','2013-08-31','12:50:00',3.81),('9303','2013-08-31','12:55:00',3.88),('9303','2013-08-31','13:00:00',3.86),('9303','2013-08-31','13:05:00',3.9),('9303','2013-08-31','13:10:00',3.86),('9303','2013-08-31','13:15:00',3.86),('9303','2013-08-31','13:20:00',3.82),('9303','2013-08-31','13:25:00',3.81),('9303','2013-08-31','13:30:00',3.79),('9303','2013-08-31','13:35:00',3.79),('9303','2013-08-31','13:40:00',3.76),('9303','2013-08-31','13:45:00',3.76),('9303','2013-08-31','13:50:00',3.77),('9303','2013-08-31','13:55:00',3.71),('9303','2013-08-31','14:00:00',3.72),('9303','2013-08-31','14:05:00',3.7),('9303','2013-08-31','14:10:00',3.68),('9303','2013-08-31','14:15:00',3.64),('9303','2013-08-31','14:20:00',3.56),('9303','2013-08-31','14:25:00',3.55),('9303','2013-08-31','14:30:00',3.56),('9303','2013-08-31','14:35:00',3.37),('9303','2013-08-31','14:40:00',3.4),('9303','2013-08-31','14:45:00',3.38),('9303','2013-08-31','14:50:00',3.42),('9303','2013-08-31','14:55:00',3.3),('9303','2013-08-31','15:00:00',3.26),('9303','2013-08-31','15:05:00',3.26),('9303','2013-08-31','15:10:00',3.24),('9303','2013-08-31','15:15:00',3.21),('9303','2013-08-31','15:20:00',3.12),('9303','2013-08-31','15:25:00',3.07),('9303','2013-08-31','15:30:00',3.05),('9303','2013-08-31','15:35:00',2.95),('9303','2013-08-31','15:40:00',2.95),('9303','2013-08-31','15:45:00',2.91),('9303','2013-08-31','15:50:00',2.85),('9303','2013-08-31','15:55:00',2.77),('9303','2013-08-31','16:00:00',2.71),('9303','2013-08-31','16:05:00',2.67),('9303','2013-08-31','16:10:00',2.62),('9303','2013-08-31','16:15:00',2.57),('9303','2013-08-31','16:20:00',2.49),('9303','2013-08-31','16:25:00',2.45),('9303','2013-08-31','16:30:00',2.34),('9303','2013-08-31','16:35:00',2.34),('9303','2013-08-31','16:40:00',2.24),('9303','2013-08-31','16:45:00',2.08),('9303','2013-08-31','16:50:00',1.98),('9303','2013-08-31','16:55:00',1.9),('9303','2013-08-31','17:00:00',1.82),('9303','2013-08-31','17:05:00',1.8),('9303','2013-08-31','17:10:00',1.75),('9303','2013-08-31','17:15:00',1.63),('9303','2013-08-31','17:20:00',1.54),('9303','2013-08-31','17:25:00',1.47),('9303','2013-08-31','17:30:00',1.36),('9303','2013-08-31','17:35:00',1.23),('9303','2013-08-31','17:40:00',1.19),('9303','2013-08-31','17:45:00',1.06),('9303','2013-08-31','17:50:00',1.02),('9303','2013-08-30','08:10:00',1.11),('9303','2013-08-30','08:15:00',1.06),('9303','2013-08-30','08:20:00',1.17),('9303','2013-08-30','08:25:00',1.21),('9303','2013-08-30','08:30:00',1.27),('9303','2013-08-30','08:35:00',1.35),('9303','2013-08-30','08:40:00',1.4),('9303','2013-08-30','08:45:00',1.26),('9303','2013-08-30','08:50:00',1.16),('9303','2013-08-30','08:55:00',1.15),('9303','2013-08-30','09:00:00',1.35),('9303','2013-08-30','09:05:00',1.47),('9303','2013-08-30','09:10:00',1.3),('9303','2013-08-30','09:15:00',1.21),('9303','2013-08-30','09:20:00',1.1),('9303','2013-08-30','09:25:00',1.17),('9303','2013-08-30','09:30:00',1.53),('9303','2013-08-30','09:35:00',1.61),('9303','2013-08-30','09:40:00',1.66),('9303','2013-08-30','09:45:00',1.69),('9303','2013-08-30','09:50:00',1.7),('9303','2013-08-30','09:55:00',1.77),('9303','2013-08-30','10:00:00',1.82),('9303','2013-08-30','10:05:00',1.78),('9303','2013-08-30','10:10:00',1.8),('9303','2013-08-30','10:15:00',1.92),('9303','2013-08-30','10:20:00',2),('9303','2013-08-30','10:25:00',1.85),('9303','2013-08-30','10:30:00',2.07),('9303','2013-08-30','10:35:00',1.98),('9303','2013-08-30','10:40:00',1.87),('9303','2013-08-30','10:45:00',1.8),('9303','2013-08-30','10:50:00',1.92),('9303','2013-08-30','10:55:00',1.82),('9303','2013-08-30','11:00:00',1.88),('9303','2013-08-30','11:05:00',2.02),('9303','2013-08-30','11:10:00',2.16),('9303','2013-08-30','11:15:00',2.19),('9303','2013-08-30','11:20:00',2.2),('9303','2013-08-30','11:25:00',2.28),('9303','2013-08-30','11:30:00',2.41),('9303','2013-08-30','11:35:00',2.3),('9303','2013-08-30','11:40:00',2.51),('9303','2013-08-30','11:45:00',2.46),('9303','2013-08-30','11:50:00',2.88),('9303','2013-08-30','11:55:00',2.5),('9303','2013-08-30','12:00:00',2.24),('9303','2013-08-30','12:05:00',1.89),('9303','2013-08-30','12:10:00',2.1),('9303','2013-08-30','12:15:00',2.28),('9303','2013-08-30','12:20:00',2.45),('9303','2013-08-30','12:25:00',2.86),('9303','2013-08-30','12:30:00',3.1),('9303','2013-08-30','12:35:00',2.98),('9303','2013-08-30','12:40:00',2.89),('9303','2013-08-30','12:45:00',3),('9303','2013-08-30','12:50:00',2.92),('9303','2013-08-30','12:55:00',2.74),('9303','2013-08-30','13:00:00',2.66),('9303','2013-08-30','13:05:00',2.63),('9303','2013-08-30','13:10:00',2.66),('9303','2013-08-30','13:15:00',2.69),('9303','2013-08-30','13:20:00',2.98),('9303','2013-08-30','13:25:00',3.52),('9303','2013-08-30','13:30:00',3.81),('9303','2013-08-30','13:35:00',3.54),('9303','2013-08-30','13:40:00',3.75),('9303','2013-08-30','13:45:00',3.38),('9303','2013-08-30','13:50:00',3.39),('9303','2013-08-30','13:55:00',3.67),('9303','2013-08-30','14:00:00',3.8),('9303','2013-08-30','14:05:00',3.64),('9303','2013-08-30','14:10:00',3.69),('9303','2013-08-30','14:15:00',3.6),('9303','2013-08-30','14:20:00',3.7),('9303','2013-08-30','14:25:00',3.65),('9303','2013-08-30','14:30:00',3.62),('9303','2013-08-30','14:35:00',3.64),('9303','2013-08-30','14:40:00',3.48),('9303','2013-08-30','14:45:00',2.91),('9303','2013-08-30','14:50:00',2.43),('9303','2013-08-30','14:55:00',2.71),('9303','2013-08-30','15:00:00',2.38),('9303','2013-08-30','15:05:00',2.18),('9303','2013-08-30','15:10:00',2.15),('9303','2013-08-30','15:15:00',2.72),('9303','2013-08-30','15:20:00',2.35),('9303','2013-08-30','15:25:00',2.13),('9303','2013-08-30','15:30:00',1.92),('9303','2013-08-30','15:35:00',1.67),('9303','2013-08-30','15:40:00',1.78),('9303','2013-08-30','15:45:00',2.09),('9303','2013-08-30','15:50:00',2.24),('9303','2013-08-30','15:55:00',2.18),('9303','2013-08-30','16:00:00',2.05),('9303','2013-08-30','16:05:00',1.81),('9303','2013-08-30','16:10:00',1.48),('9303','2013-08-30','16:15:00',1.37),('9303','2013-08-30','16:20:00',1.54),('9303','2013-08-30','16:25:00',1.55),('9303','2013-08-30','16:30:00',1.62),('9303','2013-08-30','16:35:00',1.77),('9303','2013-08-30','16:40:00',1.88),('9303','2013-08-30','16:45:00',1.84),('9303','2013-08-30','16:50:00',2),('9303','2013-08-30','16:55:00',1.32),('9303','2013-08-30','17:00:00',1.31),('9303','2013-08-30','17:05:00',1.15),('9303','2013-08-30','17:10:00',1.45),('9303','2013-08-30','17:15:00',1.25),('9303','2013-08-30','17:20:00',1.09),('9303','2013-08-30','17:25:00',1.09),('9303','2013-08-30','17:30:00',1.16),('9303','2013-08-30','17:35:00',1.31),('9303','2013-08-30','17:40:00',1.03),('9303','2013-08-30','17:45:00',1.19),('9303','2013-08-30','17:55:00',1.18),('9303','2014-04-11','08:30:00',1.16),('9303','2014-04-11','08:35:00',1.44),('9303','2014-04-11','08:40:00',1.68),('9303','2014-04-11','08:45:00',1.8),('9303','2014-04-11','08:50:00',1.86),('9303','2014-04-11','08:55:00',1.93),('9303','2014-04-11','09:00:00',1.98),('9303','2014-04-11','09:05:00',2.03),('9303','2014-04-11','09:10:00',2.1),('9303','2014-04-11','09:15:00',2.16),('9303','2014-04-11','09:20:00',2.26),('9303','2014-04-11','09:25:00',2.37),('9303','2014-04-11','09:30:00',2.43),('9303','2014-04-11','09:35:00',2.51),('9303','2014-04-11','09:40:00',2.54),('9303','2014-04-11','09:45:00',2.64),('9303','2014-04-11','09:50:00',2.69),('9303','2014-04-11','09:55:00',2.78),('9303','2014-04-11','10:00:00',2.88),('9303','2014-04-11','10:05:00',2.94),('9303','2014-04-11','10:10:00',3.02),('9303','2014-04-11','10:15:00',3.1),('9303','2014-04-11','10:20:00',3.13),('9303','2014-04-11','10:25:00',3.2),('9303','2014-04-11','10:30:00',3.25),('9303','2014-04-11','10:35:00',3.27),('9303','2014-04-11','10:40:00',3.34),('9303','2014-04-11','10:45:00',3.41),('9303','2014-04-11','10:50:00',3.49),('9303','2014-04-11','10:55:00',3.56),('9303','2014-04-11','11:00:00',3.62),('9303','2014-04-11','11:05:00',3.64),('9303','2014-04-11','11:10:00',3.68),('9303','2014-04-11','11:15:00',3.67),('9303','2014-04-11','11:20:00',3.79),('9303','2014-04-11','11:25:00',3.84),('9303','2014-04-11','11:30:00',3.85),('9303','2014-04-11','11:35:00',3.92),('9303','2014-04-11','11:40:00',3.84),('9303','2014-04-11','11:45:00',3.95),('9303','2014-04-11','11:50:00',3.99),('9303','2014-04-11','11:55:00',4.1),('9303','2014-04-11','12:00:00',4.28),('9303','2014-04-11','12:05:00',3.55),('9303','2014-04-11','12:10:00',3.17),('9303','2014-04-11','12:15:00',4.36),('9303','2014-04-11','12:20:00',3.98),('9303','2014-04-11','12:25:00',3.04),('9303','2014-04-11','12:30:00',4.32),('9303','2014-04-11','12:35:00',4.36),('9303','2014-04-11','12:40:00',2.65),('9303','2014-04-11','12:45:00',4.72),('9303','2014-04-11','12:50:00',4.57),('9303','2014-04-11','12:55:00',4.35),('9303','2014-04-11','13:00:00',3.85),('9303','2014-04-11','13:05:00',1.84),('9303','2014-04-11','13:10:00',2.64),('9303','2014-04-11','13:15:00',4.24),('9303','2014-04-11','13:20:00',3.32),('9303','2014-04-11','13:25:00',4.6),('9303','2014-04-11','13:30:00',2.22),('9303','2014-04-11','13:35:00',4.27),('9303','2014-04-11','13:40:00',4.43),('9303','2014-04-11','13:45:00',4.12),('9303','2014-04-11','13:50:00',3.76),('9303','2014-04-11','13:55:00',3.69),('9303','2014-04-11','14:00:00',2.99),('9303','2014-04-11','14:05:00',3.82),('9303','2014-04-11','14:10:00',3.75),('9303','2014-04-11','14:15:00',3.84),('9303','2014-04-11','14:20:00',3.48),('9303','2014-04-11','14:25:00',3.23),('9303','2014-04-11','14:30:00',4.15),('9303','2014-04-11','14:35:00',3.45),('9303','2014-04-11','14:40:00',4.09),('9303','2014-04-11','14:45:00',3.5),('9303','2014-04-11','14:50:00',4.27),('9303','2014-04-11','14:55:00',3.5),('9303','2014-04-11','15:00:00',3.45),('9303','2014-04-11','15:05:00',4.16),('9303','2014-04-11','15:10:00',3.96),('9303','2014-04-11','15:15:00',3.35),('9303','2014-04-11','15:20:00',3.51),('9303','2014-04-11','15:25:00',3.71),('9303','2014-04-11','15:30:00',3.54),('9303','2014-04-11','15:35:00',3.16),('9303','2014-04-11','15:40:00',2.76),('9303','2014-04-11','15:45:00',3.31),('9303','2014-04-11','15:50:00',3.28),('9303','2014-04-11','15:55:00',3.28),('9303','2014-04-11','16:00:00',3.15),('9303','2014-04-11','16:05:00',3.07),('9303','2014-04-11','16:10:00',3.02),('9303','2014-04-11','16:15:00',2.91),('9303','2014-04-11','16:20:00',2.81),('9303','2014-04-11','16:25:00',2.78),('9303','2014-04-11','16:30:00',2.73),('9303','2014-04-11','16:35:00',2.35),('9303','2014-04-11','16:40:00',2.37),('9303','2014-04-11','16:45:00',2.31),('9303','2014-04-11','16:50:00',1.57),('9303','2014-04-11','16:55:00',1.05),('9303','2014-04-11','17:00:00',2.29),('9303','2014-04-11','17:05:00',1.88),('9303','2014-04-11','17:10:00',2.06),('9303','2014-04-11','17:15:00',1.82),('9303','2014-04-11','17:20:00',1.77),('9303','2014-04-11','17:25:00',1.73),('9303','2014-04-11','17:30:00',1.75),('9303','2014-04-11','17:35:00',1.69),('9303','2014-04-11','17:40:00',1.6),('9303','2014-04-11','17:45:00',1.4),('9303','2014-04-11','17:50:00',1.24),('9303','2014-04-11','17:55:00',1.13),('9303','2014-04-11','18:00:00',1.01),('9303','2013-08-29','08:10:00',1.02),('9303','2013-08-29','08:15:00',1.12),('9303','2013-08-29','08:20:00',1.29),('9303','2013-08-29','08:25:00',1.46),('9303','2013-08-29','08:30:00',1.69),('9303','2013-08-29','08:35:00',1.67),('9303','2013-08-29','08:40:00',1.29),('9303','2013-08-29','08:50:00',1.16),('9303','2013-08-29','08:55:00',1.45),('9303','2013-08-29','09:00:00',1.47),('9303','2013-08-29','09:05:00',1.42),('9303','2013-08-29','09:10:00',1.39),('9303','2013-08-29','09:15:00',1.5),('9303','2013-08-29','09:20:00',1.5),('9303','2013-08-29','09:25:00',1.39),('9303','2013-08-29','09:30:00',1.43),('9303','2013-08-29','09:35:00',1.58),('9303','2013-08-29','09:40:00',1.63),('9303','2013-08-29','09:45:00',1.4),('9303','2013-08-29','09:50:00',1.34),('9303','2013-08-29','09:55:00',1.4),('9303','2013-08-29','10:00:00',1.49),('9303','2013-08-29','10:05:00',1.43),('9303','2013-08-29','10:10:00',1.4),('9303','2013-08-29','10:15:00',1.4),('9303','2013-08-29','10:20:00',1.41),('9303','2013-08-29','10:25:00',1.41),('9303','2013-08-29','10:30:00',1.45),('9303','2013-08-29','10:35:00',1.36),('9303','2013-08-29','10:40:00',1.25),('9303','2013-08-29','10:45:00',1.17),('9303','2013-08-29','10:50:00',1.14),('9303','2013-08-29','10:55:00',1.27),('9303','2013-08-29','11:00:00',1.37),('9303','2013-08-29','11:05:00',1.37),('9303','2013-08-29','11:10:00',2.02),('9303','2013-08-29','11:15:00',2.32),('9303','2013-08-29','11:20:00',2.18),('9303','2013-08-29','11:25:00',1.65),('9303','2013-08-29','11:30:00',1.46),('9303','2013-08-29','11:35:00',1.28),('9303','2013-08-29','11:40:00',1.44),('9303','2013-08-29','11:45:00',1.68),('9303','2013-08-29','11:50:00',1.76),('9303','2013-08-29','11:55:00',1.68),('9303','2013-08-29','12:00:00',1.66),('9303','2013-08-29','12:05:00',1.89),('9303','2013-08-29','12:10:00',2.36),('9303','2013-08-29','12:15:00',2.82),('9303','2013-08-29','12:20:00',2.52),('9303','2013-08-29','12:25:00',2.59),('9303','2013-08-29','12:30:00',2.49),('9303','2013-08-29','12:35:00',3.08),('9303','2013-08-29','12:40:00',4.16),('9303','2013-08-29','12:45:00',4.41),('9303','2013-08-29','12:50:00',2.68),('9303','2013-08-29','12:55:00',3.1),('9303','2013-08-29','13:00:00',2.63),('9303','2013-08-29','13:05:00',2.37),('9303','2013-08-29','13:10:00',2.35),('9303','2013-08-29','13:15:00',2.24),('9303','2013-08-29','13:20:00',2.25),('9303','2013-08-29','13:25:00',1.92),('9303','2013-08-29','13:30:00',1.73),('9303','2013-08-29','13:35:00',1.63),('9303','2013-08-29','13:40:00',1.56),('9303','2013-08-29','13:45:00',1.45),('9303','2013-08-29','13:50:00',1.41),('9303','2013-08-29','13:55:00',1.63),('9303','2013-08-29','14:00:00',2.18),('9303','2013-08-29','14:05:00',1.57),('9303','2013-08-29','14:10:00',1.42),('9303','2013-08-29','14:15:00',1.19),('9303','2013-08-29','14:50:00',1.08),('9303','2013-08-29','14:55:00',1.26),('9303','2013-08-29','15:00:00',1.41),('9303','2013-08-29','15:05:00',1.6),('9303','2013-08-29','15:10:00',1.3),('9303','2013-08-29','15:15:00',1.08),('9303','2013-08-29','15:20:00',1.18),('9303','2013-08-29','15:25:00',1.38),('9303','2013-08-29','15:30:00',2.2),('9303','2013-08-29','15:35:00',2.22),('9303','2013-08-29','15:40:00',2.06),('9303','2013-08-29','15:45:00',2.17),('9303','2013-08-29','15:50:00',2.75),('9303','2013-08-29','15:55:00',3.24),('9303','2013-08-29','16:00:00',3.1),('9303','2013-08-29','16:05:00',3.19),('9303','2013-08-29','16:10:00',3.13),('9303','2013-08-29','16:15:00',2.87),('9303','2013-08-29','16:20:00',2.72),('9303','2013-08-29','16:25:00',2.61),('9303','2013-08-29','16:30:00',2.48),('9303','2013-08-29','16:35:00',2.47),('9303','2013-08-29','16:40:00',2.38),('9303','2013-08-29','16:45:00',2.28),('9303','2013-08-29','16:50:00',2.16),('9303','2013-08-29','16:55:00',2.06),('9303','2013-08-29','17:00:00',1.98),('9303','2013-08-29','17:05:00',1.91),('9303','2013-08-29','17:10:00',1.83),('9303','2013-08-29','17:15:00',1.74),('9303','2013-08-29','17:20:00',1.64),('9303','2013-08-29','17:25:00',1.58),('9303','2013-08-29','17:30:00',1.51),('9303','2013-08-29','17:35:00',1.39),('9303','2013-08-29','17:40:00',1.3),('9303','2013-08-29','17:45:00',1.2),('9303','2013-08-29','17:50:00',1.1),('9303','2013-08-29','17:55:00',1.03),('9303','2013-08-28','08:15:00',1.05),('9303','2013-08-28','08:20:00',1.14),('9303','2013-08-28','08:25:00',1.15),('9303','2013-08-28','08:30:00',1.31),('9303','2013-08-28','08:35:00',1.48),('9303','2013-08-28','08:40:00',1.44),('9303','2013-08-28','08:45:00',1.4),('9303','2013-08-28','08:50:00',1.07),('9303','2013-08-28','08:55:00',1.03),('9303','2013-08-28','09:00:00',1.35),('9303','2013-08-28','09:05:00',1.17),('9303','2013-08-28','09:10:00',1.18),('9303','2013-08-28','09:15:00',1.51),('9303','2013-08-28','09:20:00',1.1),('9303','2013-08-28','09:30:00',1.21),('9303','2013-08-28','09:35:00',2.45),('9303','2013-08-28','09:40:00',2.47),('9303','2013-08-28','09:45:00',2.5),('9303','2013-08-28','09:50:00',2.58),('9303','2013-08-28','09:55:00',2.6),('9303','2013-08-28','10:00:00',2.67),('9303','2013-08-28','10:05:00',2.35),('9303','2013-08-28','10:10:00',2.05),('9303','2013-08-28','10:15:00',2.58),('9303','2013-08-28','10:20:00',3.13),('9303','2013-08-28','10:25:00',2.08),('9303','2013-08-28','10:30:00',2.55),('9303','2013-08-28','10:35:00',1.96),('9303','2013-08-28','10:40:00',2.63),('9303','2013-08-28','10:45:00',2.87),('9303','2013-08-28','10:50:00',3.18),('9303','2013-08-28','10:55:00',3.44),('9303','2013-08-28','11:00:00',2.35),('9303','2013-08-28','11:05:00',2.99),('9303','2013-08-28','11:10:00',2.07),('9303','2013-08-28','11:15:00',2.68),('9303','2013-08-28','11:20:00',2.77),('9303','2013-08-28','11:25:00',3.79),('9303','2013-08-28','11:30:00',3.87),('9303','2013-08-28','11:35:00',3.59),('9303','2013-08-28','11:40:00',4),('9303','2013-08-28','11:45:00',2.88),('9303','2013-08-28','11:50:00',2.62),('9303','2013-08-28','11:55:00',3.03),('9303','2013-08-28','12:00:00',2.37),('9303','2013-08-28','12:05:00',2.87),('9303','2013-08-28','12:10:00',3.78),('9303','2013-08-28','12:15:00',4.06),('9303','2013-08-28','12:20:00',3.72),('9303','2013-08-28','12:25:00',3.9),('9303','2013-08-28','12:30:00',3.97),('9303','2013-08-28','12:35:00',3.95),('9303','2013-08-28','12:40:00',3.95),('9303','2013-08-28','12:45:00',4.11),('9303','2013-08-28','12:50:00',4.08),('9303','2013-08-28','12:55:00',4),('9303','2013-08-28','13:00:00',4.06),('9303','2013-08-28','13:05:00',3.18),('9303','2013-08-28','13:10:00',3.98),('9303','2013-08-28','13:15:00',4.2),('9303','2013-08-28','13:20:00',4.01),('9303','2013-08-28','13:25:00',4.05),('9303','2013-08-28','13:30:00',4.06),('9303','2013-08-28','13:35:00',3.94),('9303','2013-08-28','13:40:00',4.05),('9303','2013-08-28','13:45:00',3.43),('9303','2013-08-28','13:50:00',3.83),('9303','2013-08-28','13:55:00',3.63),('9303','2013-08-28','14:00:00',4.08),('9303','2013-08-28','14:05:00',3.97),('9303','2013-08-28','14:10:00',3.94),('9303','2013-08-28','14:15:00',3.96),('9303','2013-08-28','14:20:00',3.88),('9303','2013-08-28','14:25:00',3.84),('9303','2013-08-28','14:30:00',3.85),('9303','2013-08-28','14:35:00',3.26),('9303','2013-08-28','14:40:00',2.99),('9303','2013-08-28','14:45:00',3.84),('9303','2013-08-28','14:50:00',3.66),('9303','2013-08-28','14:55:00',3.66),('9303','2013-08-28','15:00:00',3.57),('9303','2013-08-28','15:05:00',3.54),('9303','2013-08-28','15:10:00',3.58),('9303','2013-08-28','15:15:00',3.53),('9303','2013-08-28','15:20:00',3.49),('9303','2013-08-28','15:25:00',3.34),('9303','2013-08-28','15:30:00',2.57),('9303','2013-08-28','15:35:00',2.15),('9303','2013-08-28','15:40:00',2.29),('9303','2013-08-28','15:45:00',2.17),('9303','2013-08-28','15:50:00',3.11),('9303','2013-08-28','15:55:00',2.25),('9303','2013-08-28','16:00:00',2.91),('9303','2013-08-28','16:05:00',3.23),('9303','2013-08-28','16:10:00',3.12),('9303','2013-08-28','16:15:00',2.8),('9303','2013-08-28','16:20:00',1.76),('9303','2013-08-28','16:25:00',2.96),('9303','2013-08-28','16:30:00',2.74),('9303','2013-08-28','16:35:00',2.3),('9303','2013-08-28','16:40:00',2.61),('9303','2013-08-28','16:45:00',2.42),('9303','2013-08-28','16:50:00',2.25),('9303','2013-08-28','16:55:00',2.06),('9303','2013-08-28','17:00:00',2.08),('9303','2013-08-28','17:05:00',1.95),('9303','2013-08-28','17:10:00',1.02),('9303','2013-08-28','17:15:00',1.24),('9303','2013-08-28','17:20:00',1.22),('9303','2013-08-28','17:25:00',1),('9303','2013-08-28','17:30:00',1.14),('9303','2013-08-28','17:35:00',1.12),('9303','2013-08-28','17:40:00',1.01),('9303','2013-08-27','08:20:00',1.02),('9303','2013-08-27','08:25:00',1.36),('9303','2013-08-27','08:30:00',1.36),('9303','2013-08-27','08:45:00',1.11),('9303','2013-08-27','09:10:00',1.06),('9303','2013-08-27','09:15:00',1.25),('9303','2013-08-27','09:20:00',1.44),('9303','2013-08-27','09:25:00',1.91),('9303','2013-08-27','09:30:00',2.14),('9303','2013-08-27','09:35:00',1.26),('9303','2013-08-27','09:45:00',1.01),('9303','2013-08-27','09:50:00',1.06),('9303','2013-08-27','09:55:00',1.37),('9303','2013-08-27','10:00:00',1.81),('9303','2013-08-27','10:05:00',2.19),('9303','2013-08-27','10:10:00',2.66),('9303','2013-08-27','10:15:00',2.74),('9303','2013-08-27','10:20:00',2.88),('9303','2013-08-27','10:25:00',2.91),('9303','2013-08-27','10:30:00',2.94),('9303','2013-08-27','10:35:00',3.01),('9303','2013-08-27','10:40:00',3),('9303','2013-08-27','10:45:00',3.09),('9303','2013-08-27','10:50:00',3.13),('9303','2013-08-27','10:55:00',3.16),('9303','2013-08-27','11:00:00',3.2),('9303','2013-08-27','11:05:00',3.09),('9303','2013-08-27','11:10:00',3.13),('9303','2013-08-27','11:15:00',3.25),('9303','2013-08-27','11:20:00',2.49),('9303','2013-08-27','11:25:00',3.31),('9303','2013-08-27','11:30:00',3.28),('9303','2013-08-27','11:35:00',3.36),('9303','2013-08-27','11:40:00',3.29),('9303','2013-08-27','11:45:00',3.82),('9303','2013-08-27','11:50:00',3.63),('9303','2013-08-27','11:55:00',3.71),('9303','2013-08-27','12:00:00',3.93),('9303','2013-08-27','12:05:00',3.9),('9303','2013-08-27','12:10:00',3.13),('9303','2013-08-27','12:15:00',3.36),('9303','2013-08-27','12:20:00',3.6),('9303','2013-08-27','12:25:00',3.7),('9303','2013-08-27','12:30:00',3.44),('9303','2013-08-27','12:35:00',3.85),('9303','2013-08-27','12:40:00',3.74),('9303','2013-08-27','12:45:00',2.96),('9303','2013-08-27','12:50:00',2.37),('9303','2013-08-27','12:55:00',1.93),('9303','2013-08-27','13:00:00',1.32),('9303','2013-08-27','13:05:00',1.54),('9303','2013-08-27','13:10:00',2.12),('9303','2013-08-27','13:15:00',1.56),('9303','2013-08-27','13:20:00',1.81),('9303','2013-08-27','13:25:00',1.88),('9303','2013-08-27','13:30:00',2.5),('9303','2013-08-27','13:35:00',1.81),('9303','2013-08-27','13:40:00',1.76),('9303','2013-08-27','13:45:00',1.85),('9303','2013-08-27','13:50:00',3.59),('9303','2013-08-27','13:55:00',2.97),('9303','2013-08-27','14:00:00',2.86),('9303','2013-08-27','14:05:00',2.45),('9303','2013-08-27','14:10:00',2.14),('9303','2013-08-27','14:15:00',3.33),('9303','2013-08-27','14:20:00',2.25),('9303','2013-08-27','14:25:00',1.36),('9303','2013-08-27','14:30:00',1.08),('9303','2013-08-27','14:35:00',1.05),('9303','2013-08-27','14:40:00',1.15),('9303','2013-08-27','14:45:00',1.2),('9303','2013-08-27','15:55:00',1.07),('9303','2013-08-27','16:00:00',1.35),('9303','2013-08-27','16:05:00',1.37),('9303','2013-08-27','16:10:00',3.07),('9303','2013-08-27','16:15:00',2.98),('9303','2013-08-27','16:20:00',1.34),('9303','2013-08-27','16:25:00',1.82),('9303','2013-08-27','16:35:00',1.19),('9303','2013-08-27','16:40:00',1.03),('9303','2013-08-27','16:45:00',1.11),('9303','2013-08-27','16:50:00',2.32),('9303','2013-08-27','16:55:00',1.3),('9303','2013-08-27','17:10:00',2.29),('9303','2013-08-27','17:15:00',1.27),('9303','2013-08-27','17:45:00',1.18),('9303','2013-08-27','17:50:00',1.28),('9303','2013-08-27','17:55:00',1.23),('9303','2013-08-27','18:00:00',1.05),('9303','2013-08-26','08:05:00',1.16),('9303','2013-08-26','08:10:00',1.12),('9303','2013-08-26','08:20:00',1.25),('9303','2013-08-26','08:25:00',1.04),('9303','2013-08-26','08:30:00',1.44),('9303','2013-08-26','08:35:00',1.23),('9303','2013-08-26','08:40:00',1.49),('9303','2013-08-26','08:45:00',1.58),('9303','2013-08-26','08:50:00',1.65),('9303','2013-08-26','08:55:00',1.73),('9303','2013-08-26','09:00:00',1.82),('9303','2013-08-26','09:05:00',1.89),('9303','2013-08-26','09:10:00',1.96),('9303','2013-08-26','09:15:00',2.03),('9303','2013-08-26','09:20:00',2.12),('9303','2013-08-26','09:25:00',2.17),('9303','2013-08-26','09:30:00',2.25),('9303','2013-08-26','09:35:00',2.31),('9303','2013-08-26','09:40:00',2.36),('9303','2013-08-26','09:45:00',2.43),('9303','2013-08-26','09:50:00',2.52),('9303','2013-08-26','09:55:00',2.57),('9303','2013-08-26','10:00:00',2.59),('9303','2013-08-26','10:05:00',2.68),('9303','2013-08-26','10:10:00',2.7),('9303','2013-08-26','10:15:00',2.76),('9303','2013-08-26','10:20:00',2.87),('9303','2013-08-26','10:25:00',2.96),('9303','2013-08-26','10:30:00',2.97),('9303','2013-08-26','10:35:00',3.02),('9303','2013-08-26','10:40:00',3.04),('9303','2013-08-26','10:45:00',3.08),('9303','2013-08-26','10:50:00',3.14),('9303','2013-08-26','10:55:00',3.2),('9303','2013-08-26','11:00:00',3.25),('9303','2013-08-26','11:05:00',3.29),('9303','2013-08-26','11:10:00',3.33),('9303','2013-08-26','11:15:00',3.37),('9303','2013-08-26','11:20:00',3.4),('9303','2013-08-26','11:25:00',3.39),('9303','2013-08-26','11:30:00',3.45),('9303','2013-08-26','11:35:00',3.53),('9303','2013-08-26','11:40:00',3.54),('9303','2013-08-26','11:45:00',3.53),('9303','2013-08-26','11:50:00',3.02),('9303','2013-08-26','11:55:00',3.57),('9303','2013-08-26','12:00:00',3.62),('9303','2013-08-26','12:05:00',3.66),('9303','2013-08-26','12:10:00',3.71),('9303','2013-08-26','12:15:00',3.71),('9303','2013-08-26','12:20:00',3.69),('9303','2013-08-26','12:25:00',3.66),('9303','2013-08-26','12:30:00',3.65),('9303','2013-08-26','12:35:00',3.68),('9303','2013-08-26','12:40:00',3.73),('9303','2013-08-26','12:45:00',3.74),('9303','2013-08-26','12:50:00',3.75),('9303','2013-08-26','12:55:00',3.74),('9303','2013-08-26','13:00:00',3.95),('9303','2013-08-26','13:05:00',4.37),('9303','2013-08-26','13:10:00',3.88),('9303','2013-08-26','13:15:00',3.38),('9303','2013-08-26','13:20:00',2.7),('9303','2013-08-26','13:25:00',2.75),('9303','2013-08-26','13:30:00',2.7),('9303','2013-08-26','13:35:00',3.58),('9303','2013-08-26','13:40:00',3.72),('9303','2013-08-26','13:45:00',3.75),('9303','2013-08-26','13:50:00',3.88),('9303','2013-08-26','13:55:00',3.24),('9303','2013-08-26','14:00:00',2.97),('9303','2013-08-26','14:05:00',3.72),('9303','2013-08-26','14:10:00',2.41),('9303','2013-08-26','14:15:00',3.8),('9303','2013-08-26','14:20:00',3.62),('9303','2013-08-26','14:25:00',3.55),('9303','2013-08-26','14:30:00',3.53),('9303','2013-08-26','14:35:00',3.43),('9303','2013-08-26','14:40:00',3.14),('9303','2013-08-26','14:45:00',2.44),('9303','2013-08-26','14:50:00',2),('9303','2013-08-26','14:55:00',1.83),('9303','2013-08-26','15:00:00',1.72),('9303','2013-08-26','15:05:00',1.33),('9303','2013-08-26','15:40:00',1.42),('9303','2013-08-26','15:45:00',1.55),('9303','2013-08-26','15:50:00',1.55),('9303','2013-08-26','15:55:00',1.44),('9303','2013-08-26','16:00:00',1.93),('9303','2013-08-26','16:05:00',3.12),('9303','2013-08-26','16:10:00',2.76),('9303','2013-08-26','16:15:00',2.57),('9303','2013-08-26','16:20:00',2.55),('9303','2013-08-26','16:25:00',2.44),('9303','2013-08-26','16:30:00',2.38),('9303','2013-08-26','16:35:00',2.32),('9303','2013-08-26','16:40:00',2.25),('9303','2013-08-26','16:45:00',2.2),('9303','2013-08-26','16:50:00',2),('9303','2013-08-26','16:55:00',1.91),('9303','2013-08-26','17:00:00',1.87),('9303','2013-08-26','17:05:00',1.7),('9303','2013-08-26','17:10:00',1.7),('9303','2013-08-26','17:15:00',1.63),('9303','2013-08-26','17:20:00',1.29),('9303','2013-08-26','17:30:00',1.17),('9303','2013-08-26','17:45:00',1.04),('9303','2013-08-26','17:50:00',1.2),('9303','2013-08-26','17:55:00',1.16),('9303','2013-08-26','18:00:00',1),('9303','2013-08-25','08:10:00',1.03),('9303','2013-08-25','08:15:00',1.03),('9303','2013-08-25','08:25:00',1.01),('9303','2013-08-25','08:30:00',1.06),('9303','2013-08-25','08:40:00',1.12),('9303','2013-08-25','08:45:00',1.56),('9303','2013-08-25','09:20:00',2.16),('9303','2013-08-25','09:25:00',1.85),('9303','2013-08-25','09:30:00',1.87),('9303','2013-08-25','09:35:00',1.47),('9303','2013-08-25','09:40:00',2.65),('9303','2013-08-25','09:45:00',3.01),('9303','2013-08-25','09:50:00',2.8),('9303','2013-08-25','09:55:00',3.11),('9303','2013-08-25','10:00:00',2.14),('9303','2013-08-25','10:05:00',1.49),('9303','2013-08-25','15:15:00',1.09),('9303','2013-08-25','15:20:00',1.3),('9303','2013-08-25','15:25:00',1.44),('9303','2013-08-25','15:30:00',2.04),('9303','2013-08-25','15:35:00',3.04),('9303','2013-08-25','15:40:00',3.37),('9303','2013-08-25','15:45:00',3.41),('9303','2013-08-25','15:50:00',2.63),('9303','2013-08-25','15:55:00',1.92),('9303','2013-08-25','16:00:00',3.26),('9303','2013-08-25','16:05:00',3.03),('9303','2013-08-25','16:10:00',2.87),('9303','2013-08-25','16:15:00',2.77),('9303','2013-08-25','16:20:00',2.69),('9303','2013-08-25','16:25:00',2.64),('9303','2013-08-25','16:30:00',2.58),('9303','2013-08-25','16:35:00',2.45),('9303','2013-08-25','16:40:00',1.92),('9303','2013-08-25','16:45:00',1.39),('9303','2013-08-25','16:50:00',1.75),('9303','2013-08-25','16:55:00',1.91),('9303','2013-08-25','17:00:00',2.15),('9303','2013-08-25','17:05:00',2.01),('9303','2013-08-25','17:10:00',1.92),('9303','2013-08-25','17:15:00',1.77),('9303','2013-08-25','17:20:00',1.66),('9303','2013-08-25','17:25:00',1.57),('9303','2013-08-25','17:30:00',1.49),('9303','2013-08-25','17:35:00',1.2),('9303','2013-08-25','17:40:00',1.05),('9303','2013-08-25','17:45:00',1.27),('9303','2013-08-25','17:50:00',1.12),('9303','2013-08-24','08:25:00',1.13),('9303','2013-08-24','08:30:00',1.19),('9303','2013-08-24','08:35:00',1.33),('9303','2013-08-24','08:40:00',1.44),('9303','2013-08-24','08:45:00',1.47),('9303','2013-08-24','08:50:00',1.59),('9303','2013-08-24','08:55:00',1.67),('9303','2013-08-24','09:00:00',1.76),('9303','2013-08-24','09:05:00',1.81),('9303','2013-08-24','09:10:00',1.72),('9303','2013-08-24','09:15:00',1.37),('9303','2013-08-24','09:20:00',1.9),('9303','2013-08-24','09:25:00',1.8),('9303','2013-08-24','09:30:00',2.05),('9303','2013-08-24','09:35:00',1.64),('9303','2013-08-24','09:40:00',2.01),('9303','2013-08-24','09:45:00',1.83),('9303','2013-08-24','09:50:00',2.02),('9303','2013-08-24','09:55:00',2.37),('9303','2013-08-24','10:00:00',2.7),('9303','2013-08-24','10:05:00',2.71),('9303','2013-08-24','10:10:00',2.77),('9303','2013-08-24','10:15:00',2.81),('9303','2013-08-24','10:20:00',2.86),('9303','2013-08-24','10:25:00',2.91),('9303','2013-08-24','10:30:00',2.94),('9303','2013-08-24','10:35:00',2.95),('9303','2013-08-24','10:40:00',3.03),('9303','2013-08-24','10:45:00',3.1),('9303','2013-08-24','10:50:00',2.14),('9303','2013-08-24','10:55:00',3.27),('9303','2013-08-24','11:00:00',3.25),('9303','2013-08-24','11:05:00',3.29),('9303','2013-08-24','11:10:00',3.33),('9303','2013-08-24','11:15:00',3.36),('9303','2013-08-24','11:20:00',3.42),('9303','2013-08-24','11:25:00',3.4),('9303','2013-08-24','11:30:00',3.37),('9303','2013-08-24','11:35:00',3.47),('9303','2013-08-24','11:40:00',3.48),('9303','2013-08-24','11:45:00',3.51),('9303','2013-08-24','11:50:00',3.6),('9303','2013-08-24','11:55:00',3.58),('9303','2013-08-24','12:00:00',3.59),('9303','2013-08-24','12:05:00',3.58),('9303','2013-08-24','12:10:00',3.6),('9303','2013-08-24','12:15:00',3.67),('9303','2013-08-24','12:20:00',3.67),('9303','2013-08-24','12:25:00',3.69),('9303','2013-08-24','12:30:00',3.67),('9303','2013-08-24','12:35:00',3.69),('9303','2013-08-24','12:40:00',3.74),('9303','2013-08-24','12:45:00',3.76),('9303','2013-08-24','12:50:00',3.75),('9303','2013-08-24','12:55:00',3.72),('9303','2013-08-24','13:00:00',3.63),('9303','2013-08-24','13:05:00',3.71),('9303','2013-08-24','13:10:00',3.76),('9303','2013-08-24','13:15:00',3.75),('9303','2013-08-24','13:20:00',3.75),('9303','2013-08-24','13:25:00',3.76),('9303','2013-08-24','13:30:00',3.76),('9303','2013-08-24','13:35:00',3.76),('9303','2013-08-24','13:40:00',3.77),('9303','2013-08-24','13:45:00',3.77),('9303','2013-08-24','13:50:00',3.77),('9303','2013-08-24','13:55:00',3.74),('9303','2013-08-24','14:00:00',3.68),('9303','2013-08-24','14:05:00',3.67),('9303','2013-08-24','14:10:00',3.65),('9303','2013-08-24','14:15:00',3.66),('9303','2013-08-24','14:20:00',3.65),('9303','2013-08-24','14:25:00',3.61),('9303','2013-08-24','14:30:00',3.59),('9303','2013-08-24','14:35:00',3.56),('9303','2013-08-24','14:40:00',3.5),('9303','2013-08-24','14:45:00',3.45),('9303','2013-08-24','14:50:00',3.45),('9303','2013-08-24','14:55:00',3.43),('9303','2013-08-24','15:00:00',3.39),('9303','2013-08-24','15:05:00',3.37),('9303','2013-08-24','15:10:00',3.32),('9303','2013-08-24','15:15:00',3.29),('9303','2013-08-24','15:20:00',3.23),('9303','2013-08-24','15:25:00',3.2),('9303','2013-08-24','15:30:00',3.15),('9303','2013-08-24','15:35:00',3.11),('9303','2013-08-24','15:40:00',3.05),('9303','2013-08-24','15:45:00',2.99),('9303','2013-08-24','15:50:00',2.93),('9303','2013-08-24','15:55:00',2.89),('9303','2013-08-24','16:00:00',2.83),('9303','2013-08-24','16:05:00',2.78),('9303','2013-08-24','16:10:00',2.72),('9303','2013-08-24','16:15:00',2.64),('9303','2013-08-24','16:20:00',2.61),('9303','2013-08-24','16:25:00',2.52),('9303','2013-08-24','16:30:00',2.45),('9303','2013-08-24','16:35:00',2.4),('9303','2013-08-24','16:40:00',2.33),('9303','2013-08-24','16:45:00',2.26),('9303','2013-08-24','16:50:00',2.16),('9303','2013-08-24','16:55:00',2.06),('9303','2013-08-24','17:00:00',1.91),('9303','2013-08-24','17:05:00',1.86),('9303','2013-08-24','17:10:00',1.79),('9303','2013-08-24','17:15:00',1.73),('9303','2013-08-24','17:20:00',1.66),('9303','2013-08-24','17:25:00',1.59),('9303','2013-08-24','17:30:00',1.51),('9303','2013-08-24','17:35:00',1.43),('9303','2013-08-24','17:40:00',1.32),('9303','2013-08-24','17:45:00',1.25),('9303','2013-08-24','17:50:00',1.17),('9303','2013-08-24','17:55:00',1.07),('9303','2013-08-23','08:25:00',1.08),('9303','2013-08-23','08:30:00',1.17),('9303','2013-08-23','08:35:00',1.23),('9303','2013-08-23','08:40:00',1.29),('9303','2013-08-23','08:45:00',1.42),('9303','2013-08-23','08:50:00',1.49),('9303','2013-08-23','08:55:00',1.54),('9303','2013-08-23','09:00:00',1.59),('9303','2013-08-23','09:05:00',1.66),('9303','2013-08-23','09:10:00',1.76),('9303','2013-08-23','09:15:00',1.84),('9303','2013-08-23','09:20:00',1.92),('9303','2013-08-23','09:25:00',1.98),('9303','2013-08-23','09:30:00',2.04),('9303','2013-08-23','09:35:00',2.09),('9303','2013-08-23','09:40:00',2.15),('9303','2013-08-23','09:45:00',2.22),('9303','2013-08-23','09:50:00',2.3),('9303','2013-08-23','09:55:00',2.34),('9303','2013-08-23','10:00:00',2.39),('9303','2013-08-23','10:05:00',2.45),('9303','2013-08-23','10:10:00',2.49),('9303','2013-08-23','10:15:00',2.56),('9303','2013-08-23','10:20:00',2.61),('9303','2013-08-23','10:25:00',2.67),('9303','2013-08-23','10:30:00',2.68),('9303','2013-08-23','10:35:00',2.74),('9303','2013-08-23','10:40:00',2.1),('9303','2013-08-23','10:45:00',2.25),('9303','2013-08-23','10:50:00',2.78),('9303','2013-08-23','10:55:00',2.82),('9303','2013-08-23','11:00:00',2.92),('9303','2013-08-23','11:05:00',3.15),('9303','2013-08-23','11:10:00',3.04),('9303','2013-08-23','11:15:00',1.32),('9303','2013-08-23','11:20:00',1.23),('9303','2013-08-23','11:25:00',2.33),('9303','2013-08-23','11:30:00',3.26),('9303','2013-08-23','11:35:00',2.93),('9303','2013-08-23','11:40:00',2.91),('9303','2013-08-23','11:45:00',3.4),('9303','2013-08-23','11:50:00',3.38),('9303','2013-08-23','11:55:00',2.8),('9303','2013-08-23','12:00:00',1.25),('9303','2013-08-23','12:05:00',1.4),('9303','2013-08-23','12:10:00',1.35),('9303','2013-08-23','12:15:00',2.83),('9303','2013-08-23','12:40:00',1.11),('9303','2013-08-23','12:45:00',1.34),('9303','2013-08-23','12:55:00',1.17),('9303','2013-08-23','13:00:00',1.08),('9303','2013-08-23','13:05:00',1.25),('9303','2013-08-23','13:10:00',1.57),('9303','2013-08-23','13:15:00',2.77),('9303','2013-08-23','13:20:00',1.23),('9303','2013-08-23','13:25:00',3.6),('9303','2013-08-23','13:30:00',2.9),('9303','2013-08-23','13:35:00',3.34),('9303','2013-08-23','13:40:00',2.68),('9303','2013-08-23','13:45:00',2.99),('9303','2013-08-23','13:50:00',1.99),('9303','2013-08-23','13:55:00',3.41),('9303','2013-08-23','14:00:00',4.03),('9303','2013-08-23','14:05:00',3.72),('9303','2013-08-23','14:10:00',3.73),('9303','2013-08-23','14:15:00',3.78),('9303','2013-08-23','14:20:00',3.39),('9303','2013-08-23','14:25:00',3.31),('9303','2013-08-23','14:30:00',3.68),('9303','2013-08-23','14:35:00',3.54),('9303','2013-08-23','14:40:00',3.6),('9303','2013-08-23','14:45:00',3.55),('9303','2013-08-23','14:50:00',3.46),('9303','2013-08-23','14:55:00',3.29),('9303','2013-08-23','15:00:00',3.28),('9303','2013-08-23','15:05:00',3.14),('9303','2013-08-23','15:10:00',3.23),('9303','2013-08-23','15:15:00',3.18),('9303','2013-08-23','15:20:00',3.16),('9303','2013-08-23','15:25:00',3.16),('9303','2013-08-23','15:30:00',3.25),('9303','2013-08-23','15:35:00',3),('9303','2013-08-23','15:40:00',2.96),('9303','2013-08-23','15:45:00',2.96),('9303','2013-08-23','15:50:00',2.74),('9303','2013-08-23','15:55:00',2.83),('9303','2013-08-23','16:00:00',2.71),('9303','2013-08-23','16:05:00',2.54),('9303','2013-08-23','16:10:00',2.26),('9303','2013-08-23','16:15:00',2.38),('9303','2013-08-23','16:20:00',2.72),('9303','2013-08-23','16:25:00',2.48),('9303','2013-08-23','16:30:00',2.4),('9303','2013-08-23','16:35:00',2.51),('9303','2013-08-23','16:40:00',2.45),('9303','2013-08-23','16:45:00',2.36),('9303','2013-08-23','16:50:00',2.25),('9303','2013-08-23','16:55:00',2.09),('9303','2013-08-23','17:00:00',1.97),('9303','2013-08-23','17:05:00',1.86),('9303','2013-08-23','17:10:00',1.77),('9303','2013-08-23','17:15:00',1.69),('9303','2013-08-23','17:20:00',1.61),('9303','2013-08-23','17:25:00',1.53),('9303','2013-08-23','17:30:00',1.45),('9303','2013-08-23','17:35:00',1.38),('9303','2013-08-23','17:40:00',1.29),('9303','2013-08-23','17:45:00',1.21),('9303','2013-08-23','17:50:00',1.13),('9303','2013-08-23','17:55:00',1.05),('9303','2013-08-22','08:20:00',1.06),('9303','2013-08-22','08:25:00',1.13),('9303','2013-08-22','08:30:00',1.23),('9303','2013-08-22','08:35:00',1.31),('9303','2013-08-22','08:40:00',1.39),('9303','2013-08-22','08:45:00',1.49),('9303','2013-08-22','08:50:00',1.57),('9303','2013-08-22','08:55:00',1.67),('9303','2013-08-22','09:00:00',1.76),('9303','2013-08-22','09:05:00',1.91),('9303','2013-08-22','09:10:00',2),('9303','2013-08-22','09:15:00',2.09),('9303','2013-08-22','09:20:00',2.24),('9303','2013-08-22','09:25:00',2.29),('9303','2013-08-22','09:30:00',1.87),('9303','2013-08-22','09:35:00',1.16),('9303','2013-08-22','09:40:00',1.34),('9303','2013-08-22','09:45:00',1.77),('9303','2013-08-22','09:50:00',2.34),('9303','2013-08-22','09:55:00',1.92),('9303','2013-08-22','10:00:00',2.78),('9303','2013-08-22','10:05:00',2.8),('9303','2013-08-22','10:10:00',2.83),('9303','2013-08-22','10:15:00',2.81),('9303','2013-08-22','10:20:00',2.81),('9303','2013-08-22','10:25:00',2.86),('9303','2013-08-22','10:30:00',2.93),('9303','2013-08-22','10:35:00',2.95),('9303','2013-08-22','10:40:00',3),('9303','2013-08-22','10:45:00',3.03),('9303','2013-08-22','10:50:00',3.07),('9303','2013-08-22','10:55:00',3.12),('9303','2013-08-22','11:00:00',3.16),('9303','2013-08-22','11:05:00',3.2),('9303','2013-08-22','11:10:00',3.24),('9303','2013-08-22','11:15:00',3.28),('9303','2013-08-22','11:20:00',3.28),('9303','2013-08-22','11:25:00',3.3),('9303','2013-08-22','11:30:00',3.35),('9303','2013-08-22','11:35:00',3.37),('9303','2013-08-22','11:40:00',3.39),('9303','2013-08-22','11:45:00',3.42),('9303','2013-08-22','11:50:00',3.47),('9303','2013-08-22','11:55:00',3.47),('9303','2013-08-22','12:00:00',3.5),('9303','2013-08-22','12:05:00',3.51),('9303','2013-08-22','12:10:00',3.51),('9303','2013-08-22','12:15:00',3.54),('9303','2013-08-22','12:20:00',3.57),('9303','2013-08-22','12:25:00',3.59),('9303','2013-08-22','12:30:00',3.59),('9303','2013-08-22','12:35:00',3.61),('9303','2013-08-22','12:40:00',3.62),('9303','2013-08-22','12:45:00',3.61),('9303','2013-08-22','12:50:00',3.61),('9303','2013-08-22','12:55:00',3.58),('9303','2013-08-22','13:00:00',3.51),('9303','2013-08-22','13:05:00',3.45),('9303','2013-08-22','13:10:00',3.49),('9303','2013-08-22','13:15:00',3.51),('9303','2013-08-22','13:20:00',3.57),('9303','2013-08-22','13:25:00',3.61),('9303','2013-08-22','13:30:00',3.62),('9303','2013-08-22','13:35:00',3.56),('9303','2013-08-22','13:40:00',3.59),('9303','2013-08-22','13:45:00',3.58),('9303','2013-08-22','13:50:00',3.58),('9303','2013-08-22','13:55:00',3.58),('9303','2013-08-22','14:00:00',3.54),('9303','2013-08-22','14:05:00',3.57),('9303','2013-08-22','14:10:00',3.55),('9303','2013-08-22','14:15:00',3.53),('9303','2013-08-22','14:20:00',3.51),('9303','2013-08-22','14:25:00',3.47),('9303','2013-08-22','14:30:00',2.72),('9303','2013-08-22','14:35:00',3.19),('9303','2013-08-22','14:40:00',3.49),('9303','2013-08-22','14:45:00',3.4),('9303','2013-08-22','14:50:00',3.29),('9303','2013-08-22','14:55:00',3.28),('9303','2013-08-22','15:00:00',3.24),('9303','2013-08-22','15:05:00',3.23),('9303','2013-08-22','15:10:00',3.21),('9303','2013-08-22','15:15:00',3.17),('9303','2013-08-22','15:20:00',3.11),('9303','2013-08-22','15:25:00',3.06),('9303','2013-08-22','15:30:00',3),('9303','2013-08-22','15:35:00',2.96),('9303','2013-08-22','15:40:00',2.95),('9303','2013-08-22','15:45:00',2.91),('9303','2013-08-22','15:50:00',2.86),('9303','2013-08-22','15:55:00',2.8),('9303','2013-08-22','16:00:00',2.76),('9303','2013-08-22','16:05:00',2.65),('9303','2013-08-22','16:10:00',2.61),('9303','2013-08-22','16:15:00',2.56),('9303','2013-08-22','16:20:00',2.49),('9303','2013-08-22','16:25:00',2.43),('9303','2013-08-22','16:30:00',2.36),('9303','2013-08-22','16:35:00',2.3),('9303','2013-08-22','16:40:00',2.23),('9303','2013-08-22','16:45:00',2.14),('9303','2013-08-22','16:50:00',2.05),('9303','2013-08-22','16:55:00',1.97),('9303','2013-08-22','17:00:00',1.86),('9303','2013-08-22','17:05:00',1.78),('9303','2013-08-22','17:10:00',1.69),('9303','2013-08-22','17:15:00',1.6),('9303','2013-08-22','17:20:00',1.54),('9303','2013-08-22','17:25:00',1.48),('9303','2013-08-22','17:30:00',1.41),('9303','2013-08-22','17:35:00',1.34),('9303','2013-08-22','17:40:00',1.25),('9303','2013-08-22','17:45:00',1.13),('9303','2013-08-22','17:50:00',1.07),('9303','2013-08-22','17:55:00',1.02),('9303','2013-08-21','09:05:00',1.28),('9303','2013-08-21','09:10:00',1.29),('9303','2013-08-21','09:15:00',2.19),('9303','2013-08-21','09:20:00',2.49),('9303','2013-08-21','09:25:00',1.25),('9303','2013-08-21','09:45:00',1.12),('9303','2013-08-21','09:50:00',2.57),('9303','2013-08-21','09:55:00',3.33),('9303','2013-08-21','10:00:00',3.1),('9303','2013-08-21','10:05:00',2.6),('9303','2013-08-21','10:10:00',2.13),('9303','2013-08-21','10:15:00',2.39),('9303','2013-08-21','10:20:00',1.94),('9303','2013-08-21','10:25:00',1.79),('9303','2013-08-21','10:30:00',1.79),('9303','2013-08-21','10:35:00',3.17),('9303','2013-08-21','10:40:00',2.82),('9303','2013-08-21','10:45:00',2.1),('9303','2013-08-21','10:50:00',2.07),('9303','2013-08-21','10:55:00',1.65),('9303','2013-08-21','11:00:00',2.13),('9303','2013-08-21','11:05:00',1.82),('9303','2013-08-21','11:10:00',1.58),('9303','2013-08-21','11:15:00',1.95),('9303','2013-08-21','11:20:00',3.32),('9303','2013-08-21','11:25:00',2.39),('9303','2013-08-21','11:30:00',2.47),('9303','2013-08-21','11:35:00',3.66),('9303','2013-08-21','11:40:00',3.9),('9303','2013-08-21','11:45:00',3.81),('9303','2013-08-21','11:50:00',3.25),('9303','2013-08-21','11:55:00',3.5),('9303','2013-08-21','12:00:00',3.86),('9303','2013-08-21','12:05:00',3.87),('9303','2013-08-21','12:10:00',3.86),('9303','2013-08-21','12:15:00',3.87),('9303','2013-08-21','12:20:00',3.76),('9303','2013-08-21','12:25:00',2.28),('9303','2013-08-21','12:30:00',3.05),('9303','2013-08-21','12:35:00',2.67),('9303','2013-08-21','12:40:00',3.1),('9303','2013-08-21','12:45:00',3.64),('9303','2013-08-21','12:50:00',3.61),('9303','2013-08-21','12:55:00',3.45),('9303','2013-08-21','13:00:00',3.61),('9303','2013-08-21','13:05:00',3.69),('9303','2013-08-21','13:10:00',3.71),('9303','2013-08-21','13:15:00',3.77),('9303','2013-08-21','13:20:00',3.8),('9303','2013-08-21','13:25:00',3.77),('9303','2013-08-21','13:30:00',3.79),('9303','2013-08-21','13:35:00',3.77),('9303','2013-08-21','13:40:00',3.67),('9303','2013-08-21','13:45:00',3.39),('9303','2013-08-21','13:50:00',3.61),('9303','2013-08-21','13:55:00',3.55),('9303','2013-08-21','14:00:00',3.63),('9303','2013-08-21','14:05:00',3.64),('9303','2013-08-21','14:10:00',3.69),('9303','2013-08-21','14:15:00',3.73),('9303','2013-08-21','14:20:00',3.44),('9303','2013-08-21','14:25:00',2.92),('9303','2013-08-21','14:30:00',3.23),('9303','2013-08-21','14:35:00',3.19),('9303','2013-08-21','14:40:00',3.25),('9303','2013-08-21','14:45:00',3.25),('9303','2013-08-21','14:50:00',3.13),('9303','2013-08-21','14:55:00',3.12),('9303','2013-08-21','15:00:00',3.19),('9303','2013-08-21','15:05:00',3.21),('9303','2013-08-21','15:10:00',3.08),('9303','2013-08-21','15:15:00',3.04),('9303','2013-08-21','15:20:00',2.99),('9303','2013-08-21','15:25:00',2.97),('9303','2013-08-21','15:30:00',2.84),('9303','2013-08-21','15:35:00',2.75),('9303','2013-08-21','15:40:00',2.57),('9303','2013-08-21','15:45:00',2.66),('9303','2013-08-21','15:50:00',2.71),('9303','2013-08-21','15:55:00',2.5),('9303','2013-08-21','16:00:00',2.37),('9303','2013-08-21','16:05:00',2.33),('9303','2013-08-21','16:10:00',2.27),('9303','2013-08-21','16:15:00',2.36),('9303','2013-08-21','16:20:00',2.43),('9303','2013-08-21','16:25:00',2.41),('9303','2013-08-21','16:30:00',2.5),('9303','2013-08-21','16:35:00',2.4),('9303','2013-08-21','16:40:00',2.32),('9303','2013-08-21','16:45:00',2.26),('9303','2013-08-21','16:50:00',2.18),('9303','2013-08-21','16:55:00',2.07),('9303','2013-08-21','17:00:00',1.99),('9303','2013-08-21','17:05:00',1.91),('9303','2013-08-21','17:10:00',1.89),('9303','2013-08-21','17:15:00',1.83),('9303','2013-08-21','17:20:00',1.81),('9303','2013-08-21','17:25:00',1.72),('9303','2013-08-21','17:30:00',1.64),('9303','2013-08-21','17:35:00',1.58),('9303','2013-08-21','17:40:00',1.51),('9303','2013-08-21','17:45:00',1.43),('9303','2013-08-21','17:50:00',1.39),('9303','2013-08-21','17:55:00',1.3),('9303','2013-08-21','18:00:00',1.22),('9303','2013-08-21','18:05:00',1.14),('9303','2013-08-21','18:10:00',1.03),('9303','2013-08-20','08:55:00',1.03),('9303','2013-08-20','09:00:00',1.03),('9303','2013-08-20','09:05:00',1.04),('9303','2013-08-20','09:20:00',1.11),('9303','2013-08-20','09:25:00',1.71),('9303','2013-08-20','09:30:00',2.33),('9303','2013-08-20','09:35:00',2.31),('9303','2013-08-20','09:40:00',2.43),('9303','2013-08-20','09:45:00',2.1),('9303','2013-08-20','09:50:00',2.52),('9303','2013-08-20','09:55:00',2.34),('9303','2013-08-20','10:00:00',3.43),('9303','2013-08-20','10:05:00',1.3),('9303','2013-08-20','10:10:00',1.12),('9303','2013-08-20','10:15:00',2.83),('9303','2013-08-20','10:20:00',2.63),('9303','2013-08-20','10:25:00',1.17),('9303','2013-08-20','10:45:00',1.06),('9303','2013-08-20','10:50:00',1.73),('9303','2013-08-20','10:55:00',2.5),('9303','2013-08-20','11:15:00',2),('9303','2013-08-20','11:20:00',3.79),('9303','2013-08-20','11:25:00',3.47),('9303','2013-08-20','11:30:00',1.69),('9303','2013-08-20','11:35:00',1.24),('9303','2013-08-20','11:40:00',3.9),('9303','2013-08-20','11:45:00',3.78),('9303','2013-08-20','11:50:00',4.24),('9303','2013-08-20','11:55:00',4.21),('9303','2013-08-20','12:00:00',1.98),('9303','2013-08-20','12:05:00',1.09),('9303','2013-08-20','12:10:00',1.08),('9303','2013-08-20','12:30:00',1.12),('9303','2013-08-20','12:35:00',1.35),('9303','2013-08-20','12:40:00',1.6),('9303','2013-08-20','12:45:00',1.64),('9303','2013-08-20','12:50:00',1.86),('9303','2013-08-20','12:55:00',1.72),('9303','2013-08-20','13:00:00',1.68),('9303','2013-08-20','13:05:00',1.52),('9303','2013-08-20','13:10:00',1.46),('9303','2013-08-20','13:15:00',1.48),('9303','2013-08-20','13:20:00',1.55),('9303','2013-08-20','13:25:00',1.63),('9303','2013-08-20','13:30:00',1.78),('9303','2013-08-20','13:35:00',2.37),('9303','2013-08-20','13:40:00',3.56),('9303','2013-08-20','13:45:00',3.4),('9303','2013-08-20','13:50:00',3.95),('9303','2013-08-20','13:55:00',3.95),('9303','2013-08-20','14:00:00',3.89),('9303','2013-08-20','14:05:00',3.84),('9303','2013-08-20','14:10:00',3.4),('9303','2013-08-20','14:15:00',3.77),('9303','2013-08-20','14:20:00',3.78),('9303','2013-08-20','14:25:00',3.39),('9303','2013-08-20','14:30:00',2.95),('9303','2013-08-20','14:35:00',3.09),('9303','2013-08-20','14:40:00',3.84),('9303','2013-08-20','14:45:00',3.64),('9303','2013-08-20','14:50:00',3.61),('9303','2013-08-20','14:55:00',3.46),('9303','2013-08-20','15:00:00',3.38),('9303','2013-08-20','15:05:00',3.83),('9303','2013-08-20','15:10:00',3.69),('9303','2013-08-20','15:15:00',3.69),('9303','2013-08-20','15:20:00',3.56),('9303','2013-08-20','15:25:00',3.54),('9303','2013-08-20','15:30:00',3.52),('9303','2013-08-20','15:35:00',3.49),('9303','2013-08-20','15:40:00',3.54),('9303','2013-08-20','15:45:00',3.66),('9303','2013-08-20','15:50:00',3.83),('9303','2013-08-20','15:55:00',3.9),('9303','2013-08-20','16:00:00',3.64),('9303','2013-08-20','16:05:00',3.56),('9303','2013-08-20','16:10:00',3.49),('9303','2013-08-20','16:15:00',3.45),('9303','2013-08-20','16:20:00',3.4),('9303','2013-08-20','16:25:00',3.18),('9303','2013-08-20','16:30:00',2.85),('9303','2013-08-20','16:35:00',2.94),('9303','2013-08-20','16:40:00',3.06),('9303','2013-08-20','16:45:00',2.89),('9303','2013-08-20','16:50:00',2.67),('9303','2013-08-20','16:55:00',2.48),('9303','2013-08-20','17:00:00',2.27),('9303','2013-08-20','17:05:00',2.1),('9303','2013-08-20','17:10:00',2),('9303','2013-08-20','17:15:00',1.86),('9303','2013-08-20','17:20:00',1.84),('9303','2013-08-20','17:25:00',1.74),('9303','2013-08-20','17:30:00',1.65),('9303','2013-08-20','17:35:00',1.58),('9303','2013-08-20','17:40:00',1.47),('9303','2013-08-20','17:45:00',1.42),('9303','2013-08-20','17:50:00',1.29),('9303','2013-08-20','17:55:00',1.15),('9303','2013-08-20','18:00:00',1.04),('9303','2013-08-20','18:05:00',1.04),('9303','2013-08-20','18:10:00',1.01),('9303','2014-04-10','08:10:00',1.04),('9303','2014-04-10','08:15:00',1.15),('9303','2014-04-10','08:20:00',1.26),('9303','2014-04-10','08:25:00',1.36),('9303','2014-04-10','08:30:00',1.47),('9303','2014-04-10','08:35:00',1.58),('9303','2014-04-10','08:40:00',1.7),('9303','2014-04-10','08:45:00',1.81),('9303','2014-04-10','08:50:00',1.91),('9303','2014-04-10','08:55:00',1.99),('9303','2014-04-10','09:00:00',2.06),('9303','2014-04-10','09:05:00',2.18),('9303','2014-04-10','09:10:00',2.25),('9303','2014-04-10','09:15:00',2.29),('9303','2014-04-10','09:20:00',2.31),('9303','2014-04-10','09:25:00',2.49),('9303','2014-04-10','09:30:00',2.6),('9303','2014-04-10','09:35:00',2.67),('9303','2014-04-10','09:40:00',2.71),('9303','2014-04-10','09:45:00',2.77),('9303','2014-04-10','09:50:00',2.87),('9303','2014-04-10','09:55:00',2.95),('9303','2014-04-10','10:00:00',3),('9303','2014-04-10','10:05:00',3.06),('9303','2014-04-10','10:10:00',3.14),('9303','2014-04-10','10:15:00',3.15),('9303','2014-04-10','10:20:00',3.21),('9303','2014-04-10','10:25:00',3.26),('9303','2014-04-10','10:30:00',3.31),('9303','2014-04-10','10:35:00',3.45),('9303','2014-04-10','10:40:00',3.48),('9303','2014-04-10','10:45:00',3.5),('9303','2014-04-10','10:50:00',3.47),('9303','2014-04-10','10:55:00',3.55),('9303','2014-04-10','11:00:00',3.61),('9303','2014-04-10','11:05:00',3.71),('9303','2014-04-10','11:10:00',3.64),('9303','2014-04-10','11:15:00',3.78),('9303','2014-04-10','11:20:00',3.9),('9303','2014-04-10','11:25:00',3.95),('9303','2014-04-10','11:30:00',3.94),('9303','2014-04-10','11:35:00',3.96),('9303','2014-04-10','11:40:00',3.86),('9303','2014-04-10','11:45:00',3.97),('9303','2014-04-10','11:50:00',3.87),('9303','2014-04-10','11:55:00',4.07),('9303','2014-04-10','12:00:00',4.02),('9303','2014-04-10','12:05:00',3.8),('9303','2014-04-10','12:10:00',3.97),('9303','2014-04-10','12:15:00',4.02),('9303','2014-04-10','12:20:00',4.1),('9303','2014-04-10','12:25:00',3.9),('9303','2014-04-10','12:30:00',3.97),('9303','2014-04-10','12:35:00',4.12),('9303','2014-04-10','12:40:00',4.05),('9303','2014-04-10','12:45:00',4.1),('9303','2014-04-10','12:50:00',4.01),('9303','2014-04-10','12:55:00',3.95),('9303','2014-04-10','13:00:00',3.93),('9303','2014-04-10','13:05:00',3.79),('9303','2014-04-10','13:10:00',3.87),('9303','2014-04-10','13:15:00',3.93),('9303','2014-04-10','13:20:00',3.82),('9303','2014-04-10','13:25:00',4.18),('9303','2014-04-10','13:30:00',4.06),('9303','2014-04-10','13:35:00',4.13),('9303','2014-04-10','13:40:00',4.04),('9303','2014-04-10','13:45:00',4.16),('9303','2014-04-10','13:50:00',4.09),('9303','2014-04-10','13:55:00',4.09),('9303','2014-04-10','14:00:00',4.1),('9303','2014-04-10','14:05:00',4.08),('9303','2014-04-10','14:10:00',4.05),('9303','2014-04-10','14:15:00',4.02),('9303','2014-04-10','14:20:00',4),('9303','2014-04-10','14:25:00',3.94),('9303','2014-04-10','14:30:00',3.89),('9303','2014-04-10','14:35:00',3.9),('9303','2014-04-10','14:40:00',3.88),('9303','2014-04-10','14:45:00',3.54),('9303','2014-04-10','14:50:00',3.87),('9303','2014-04-10','14:55:00',3.78),('9303','2014-04-10','15:00:00',3.73),('9303','2014-04-10','15:05:00',3.69),('9303','2014-04-10','15:10:00',3.62),('9303','2014-04-10','15:15:00',3.61),('9303','2014-04-10','15:20:00',3.6),('9303','2014-04-10','15:25:00',3.57),('9303','2014-04-10','15:30:00',3.23),('9303','2014-04-10','15:35:00',3.17),('9303','2014-04-10','15:40:00',3.19),('9303','2014-04-10','15:45:00',3.11),('9303','2014-04-10','15:50:00',3.15),('9303','2014-04-10','15:55:00',3.11),('9303','2014-04-10','16:00:00',3),('9303','2014-04-10','16:05:00',3.08),('9303','2014-04-10','16:10:00',3.05),('9303','2014-04-10','16:15:00',3.1),('9303','2014-04-10','16:20:00',2.89),('9303','2014-04-10','16:25:00',2.92),('9303','2014-04-10','16:30:00',2.83),('9303','2014-04-10','16:35:00',2.77),('9303','2014-04-10','16:40:00',2.73),('9303','2014-04-10','16:45:00',2.66),('9303','2014-04-10','16:50:00',2.47),('9303','2014-04-10','16:55:00',2.33),('9303','2014-04-10','17:00:00',2.22),('9303','2014-04-10','17:05:00',2.16),('9303','2014-04-10','17:10:00',2.03),('9303','2014-04-10','17:15:00',1.94),('9303','2014-04-10','17:20:00',1.88),('9303','2014-04-10','17:25:00',1.77),('9303','2014-04-10','17:30:00',1.65),('9303','2014-04-10','17:35:00',1.54),('9303','2014-04-10','17:40:00',1.45),('9303','2014-04-10','17:45:00',1.34),('9303','2014-04-10','17:50:00',1.24),('9303','2014-04-10','17:55:00',1.13),('9303','2014-04-10','18:00:00',1.02),('9303','2013-08-19','08:15:00',1.06),('9303','2013-08-19','08:20:00',1.14),('9303','2013-08-19','08:25:00',1.25),('9303','2013-08-19','08:30:00',1.31),('9303','2013-08-19','08:35:00',1.38),('9303','2013-08-19','08:40:00',1.48),('9303','2013-08-19','08:45:00',1.57),('9303','2013-08-19','08:50:00',1.67),('9303','2013-08-19','08:55:00',1.76),('9303','2013-08-19','09:00:00',1.84),('9303','2013-08-19','09:05:00',1.91),('9303','2013-08-19','09:10:00',1.99),('9303','2013-08-19','09:15:00',2.05),('9303','2013-08-19','09:20:00',2.13),('9303','2013-08-19','09:25:00',2.21),('9303','2013-08-19','09:30:00',2.25),('9303','2013-08-19','09:35:00',2.32),('9303','2013-08-19','09:40:00',2.4),('9303','2013-08-19','09:45:00',2.45),('9303','2013-08-19','09:50:00',2.53),('9303','2013-08-19','09:55:00',2.58),('9303','2013-08-19','10:00:00',2.64),('9303','2013-08-19','10:05:00',2.68),('9303','2013-08-19','10:10:00',2.74),('9303','2013-08-19','10:15:00',2.8),('9303','2013-08-19','10:20:00',2.88),('9303','2013-08-19','10:25:00',2.93),('9303','2013-08-19','10:30:00',2.99),('9303','2013-08-19','10:35:00',3.01),('9303','2013-08-19','10:40:00',3.05),('9303','2013-08-19','10:45:00',3.08),('9303','2013-08-19','10:50:00',3.11),('9303','2013-08-19','10:55:00',3.15),('9303','2013-08-19','11:00:00',3.17),('9303','2013-08-19','11:05:00',3.21),('9303','2013-08-19','11:10:00',3.25),('9303','2013-08-19','11:15:00',3.27),('9303','2013-08-19','11:20:00',3.3),('9303','2013-08-19','11:25:00',3.35),('9303','2013-08-19','11:30:00',3.38),('9303','2013-08-19','11:35:00',3.42),('9303','2013-08-19','11:40:00',3.43),('9303','2013-08-19','11:45:00',3.44),('9303','2013-08-19','11:50:00',3.48),('9303','2013-08-19','11:55:00',3.49),('9303','2013-08-19','12:00:00',3.41),('9303','2013-08-19','12:05:00',3.51),('9303','2013-08-19','12:10:00',3.6),('9303','2013-08-19','12:15:00',3.62),('9303','2013-08-19','12:20:00',3.64),('9303','2013-08-19','12:25:00',3.65),('9303','2013-08-19','12:30:00',3.66),('9303','2013-08-19','12:35:00',3.67),('9303','2013-08-19','12:40:00',3.68),('9303','2013-08-19','12:45:00',3.71),('9303','2013-08-19','12:50:00',3.73),('9303','2013-08-19','12:55:00',3.74),('9303','2013-08-19','13:00:00',3.73),('9303','2013-08-19','13:05:00',3.78),('9303','2013-08-19','13:10:00',3.77),('9303','2013-08-19','13:15:00',3.76),('9303','2013-08-19','13:20:00',3.77),('9303','2013-08-19','13:25:00',3.74),('9303','2013-08-19','13:30:00',3.77),('9303','2013-08-19','13:35:00',3.78),('9303','2013-08-19','13:40:00',3.76),('9303','2013-08-19','13:45:00',3.76),('9303','2013-08-19','13:50:00',3.74),('9303','2013-08-19','13:55:00',3.75),('9303','2013-08-19','14:00:00',3.73),('9303','2013-08-19','14:05:00',3.72),('9303','2013-08-19','14:10:00',3.71),('9303','2013-08-19','14:15:00',3.67),('9303','2013-08-19','14:20:00',3.63),('9303','2013-08-19','14:25:00',3.63),('9303','2013-08-19','14:30:00',3.63),('9303','2013-08-19','14:35:00',3.61),('9303','2013-08-19','14:40:00',3.57),('9303','2013-08-19','14:45:00',3.56),('9303','2013-08-19','14:50:00',3.51),('9303','2013-08-19','14:55:00',3.5),('9303','2013-08-19','15:00:00',3.47),('9303','2013-08-19','15:05:00',3.45),('9303','2013-08-19','15:10:00',3.43),('9303','2013-08-19','15:15:00',3.37),('9303','2013-08-19','15:20:00',3.3),('9303','2013-08-19','15:25:00',3.29),('9303','2013-08-19','15:30:00',3.23),('9303','2013-08-19','15:35:00',3.22),('9303','2013-08-19','15:40:00',3.15),('9303','2013-08-19','15:45:00',3.13),('9303','2013-08-19','15:50:00',3.08),('9303','2013-08-19','15:55:00',3.04),('9303','2013-08-19','16:00:00',2.98),('9303','2013-08-19','16:05:00',2.88),('9303','2013-08-19','16:10:00',2.81),('9303','2013-08-19','16:15:00',2.74),('9303','2013-08-19','16:20:00',2.73),('9303','2013-08-19','16:25:00',2.67),('9303','2013-08-19','16:30:00',2.6),('9303','2013-08-19','16:35:00',2.53),('9303','2013-08-19','16:40:00',2.46),('9303','2013-08-19','16:45:00',2.39),('9303','2013-08-19','16:50:00',2.32),('9303','2013-08-19','16:55:00',2.22),('9303','2013-08-19','17:00:00',2.11),('9303','2013-08-19','17:05:00',2),('9303','2013-08-19','17:10:00',1.91),('9303','2013-08-19','17:15:00',1.84),('9303','2013-08-19','17:20:00',1.77),('9303','2013-08-19','17:25:00',1.7),('9303','2013-08-19','17:30:00',1.61),('9303','2013-08-19','17:35:00',1.53),('9303','2013-08-19','17:40:00',1.47),('9303','2013-08-19','17:45:00',1.37),('9303','2013-08-19','17:50:00',1.29),('9303','2013-08-19','17:55:00',1.21),('9303','2013-08-19','18:00:00',1.11),('9303','2013-08-19','18:05:00',1.03),('9303','2013-08-18','08:10:00',1.03),('9303','2013-08-18','08:15:00',1.13),('9303','2013-08-18','08:20:00',1.21),('9303','2013-08-18','08:25:00',1.31),('9303','2013-08-18','08:30:00',1.39),('9303','2013-08-18','08:35:00',1.48),('9303','2013-08-18','08:40:00',1.58),('9303','2013-08-18','08:45:00',1.66),('9303','2013-08-18','08:50:00',1.73),('9303','2013-08-18','08:55:00',1.8),('9303','2013-08-18','09:00:00',1.88),('9303','2013-08-18','09:05:00',1.96),('9303','2013-08-18','09:10:00',2.03),('9303','2013-08-18','09:15:00',2.12),('9303','2013-08-18','09:20:00',2.19),('9303','2013-08-18','09:25:00',2.26),('9303','2013-08-18','09:30:00',2.34),('9303','2013-08-18','09:35:00',2.4),('9303','2013-08-18','09:40:00',2.52),('9303','2013-08-18','09:45:00',2.34),('9303','2013-08-18','09:50:00',2.58),('9303','2013-08-18','09:55:00',1.9),('9303','2013-08-18','10:00:00',2.66),('9303','2013-08-18','10:05:00',2.21),('9303','2013-08-18','10:10:00',2.49),('9303','2013-08-18','10:15:00',2.86),('9303','2013-08-18','10:20:00',2.9),('9303','2013-08-18','10:25:00',2.93),('9303','2013-08-18','10:30:00',2.97),('9303','2013-08-18','10:35:00',3.01),('9303','2013-08-18','10:40:00',3.06),('9303','2013-08-18','10:45:00',3.09),('9303','2013-08-18','10:50:00',3.12),('9303','2013-08-18','10:55:00',3.12),('9303','2013-08-18','11:00:00',3.12),('9303','2013-08-18','11:05:00',3.23),('9303','2013-08-18','11:10:00',3.28),('9303','2013-08-18','11:15:00',3.31),('9303','2013-08-18','11:20:00',3.35),('9303','2013-08-18','11:25:00',3.34),('9303','2013-08-18','11:30:00',3.37),('9303','2013-08-18','11:35:00',3.38),('9303','2013-08-18','11:40:00',3.41),('9303','2013-08-18','11:45:00',3.47),('9303','2013-08-18','11:50:00',3.49),('9303','2013-08-18','11:55:00',3.49),('9303','2013-08-18','12:00:00',3.48),('9303','2013-08-18','12:05:00',3.5),('9303','2013-08-18','12:10:00',3.45),('9303','2013-08-18','12:15:00',3.23),('9303','2013-08-18','12:20:00',3.72),('9303','2013-08-18','12:25:00',3.74),('9303','2013-08-18','12:30:00',3.61),('9303','2013-08-18','12:35:00',2.61),('9303','2013-08-18','12:40:00',3.38),('9303','2013-08-18','12:45:00',3.25),('9303','2013-08-18','12:50:00',3.52),('9303','2013-08-18','12:55:00',1.23),('9303','2013-08-18','13:00:00',1.06),('9303','2013-08-18','13:05:00',3.59),('9303','2013-08-18','13:10:00',3.97),('9303','2013-08-18','13:15:00',3.73),('9303','2013-08-18','13:20:00',3.76),('9303','2013-08-18','13:25:00',3.86),('9303','2013-08-18','13:30:00',3.49),('9303','2013-08-18','13:35:00',3.74),('9303','2013-08-18','13:40:00',3.81),('9303','2013-08-18','13:45:00',3.74),('9303','2013-08-18','13:50:00',3.76),('9303','2013-08-18','13:55:00',3.67),('9303','2013-08-18','14:00:00',3.79),('9303','2013-08-18','14:05:00',3.75),('9303','2013-08-18','14:10:00',3.72),('9303','2013-08-18','14:15:00',3.69),('9303','2013-08-18','14:20:00',3.68),('9303','2013-08-18','14:25:00',3.63),('9303','2013-08-18','14:30:00',3.64),('9303','2013-08-18','14:35:00',3.63),('9303','2013-08-18','14:40:00',3.61),('9303','2013-08-18','14:45:00',3.57),('9303','2013-08-18','14:50:00',3.53),('9303','2013-08-18','14:55:00',3.51),('9303','2013-08-18','15:00:00',3.47),('9303','2013-08-18','15:05:00',3.44),('9303','2013-08-18','15:10:00',3.4),('9303','2013-08-18','15:15:00',3.35),('9303','2013-08-18','15:20:00',3.29),('9303','2013-08-18','15:25:00',3.25),('9303','2013-08-18','15:30:00',3.22),('9303','2013-08-18','15:35:00',3.18),('9303','2013-08-18','15:40:00',3.14),('9303','2013-08-18','15:45:00',3.1),('9303','2013-08-18','15:50:00',3.05),('9303','2013-08-18','15:55:00',2.99),('9303','2013-08-18','16:00:00',2.95),('9303','2013-08-18','16:05:00',2.89),('9303','2013-08-18','16:10:00',2.81),('9303','2013-08-18','16:15:00',2.76),('9303','2013-08-18','16:20:00',2.71),('9303','2013-08-18','16:25:00',2.65),('9303','2013-08-18','16:30:00',2.58),('9303','2013-08-18','16:35:00',2.53),('9303','2013-08-18','16:40:00',2.45),('9303','2013-08-18','16:45:00',2.38),('9303','2013-08-18','16:50:00',2.32),('9303','2013-08-18','16:55:00',2.21),('9303','2013-08-18','17:00:00',2.12),('9303','2013-08-18','17:05:00',2.02),('9303','2013-08-18','17:10:00',1.93),('9303','2013-08-18','17:15:00',1.87),('9303','2013-08-18','17:20:00',1.79),('9303','2013-08-18','17:25:00',1.72),('9303','2013-08-18','17:30:00',1.64),('9303','2013-08-18','17:35:00',1.56),('9303','2013-08-18','17:40:00',1.48),('9303','2013-08-18','17:45:00',1.37),('9303','2013-08-18','17:50:00',1.29),('9303','2013-08-18','17:55:00',1.21),('9303','2013-08-18','18:00:00',1.11),('9303','2013-08-18','18:05:00',1.04),('9303','2013-08-17','08:15:00',1.06),('9303','2013-08-17','08:20:00',1.16),('9303','2013-08-17','08:25:00',1.25),('9303','2013-08-17','08:30:00',1.33),('9303','2013-08-17','08:35:00',1.43),('9303','2013-08-17','08:40:00',1.53),('9303','2013-08-17','08:45:00',1.62),('9303','2013-08-17','08:50:00',1.7),('9303','2013-08-17','08:55:00',1.79),('9303','2013-08-17','09:00:00',1.87),('9303','2013-08-17','09:05:00',1.95),('9303','2013-08-17','09:10:00',2.01),('9303','2013-08-17','09:15:00',2.07),('9303','2013-08-17','09:20:00',2.15),('9303','2013-08-17','09:25:00',2.24),('9303','2013-08-17','09:30:00',2.3),('9303','2013-08-17','09:35:00',2.37),('9303','2013-08-17','09:40:00',2.44),('9303','2013-08-17','09:45:00',2.51),('9303','2013-08-17','09:50:00',2.56),('9303','2013-08-17','09:55:00',2.62),('9303','2013-08-17','10:00:00',2.68),('9303','2013-08-17','10:05:00',2.73),('9303','2013-08-17','10:10:00',2.77),('9303','2013-08-17','10:15:00',2.81),('9303','2013-08-17','10:20:00',2.87),('9303','2013-08-17','10:25:00',2.94),('9303','2013-08-17','10:30:00',2.95),('9303','2013-08-17','10:35:00',3.02),('9303','2013-08-17','10:40:00',3.06),('9303','2013-08-17','10:45:00',3.11),('9303','2013-08-17','10:50:00',3.17),('9303','2013-08-17','10:55:00',3.2),('9303','2013-08-17','11:00:00',3.25),('9303','2013-08-17','11:05:00',3.27),('9303','2013-08-17','11:10:00',3.3),('9303','2013-08-17','11:15:00',3.32),('9303','2013-08-17','11:20:00',3.34),('9303','2013-08-17','11:25:00',3.39),('9303','2013-08-17','11:30:00',3.43),('9303','2013-08-17','11:35:00',3.45),('9303','2013-08-17','11:40:00',3.52),('9303','2013-08-17','11:45:00',3.53),('9303','2013-08-17','11:50:00',3.6),('9303','2013-08-17','11:55:00',3.59),('9303','2013-08-17','12:00:00',3.54),('9303','2013-08-17','12:05:00',3.6),('9303','2013-08-17','12:10:00',3.63),('9303','2013-08-17','12:15:00',3.59),('9303','2013-08-17','12:20:00',3.3),('9303','2013-08-17','12:25:00',3.67),('9303','2013-08-17','12:30:00',3.73),('9303','2013-08-17','12:35:00',2.58),('9303','2013-08-17','12:40:00',3.25),('9303','2013-08-17','12:45:00',3.75),('9303','2013-08-17','12:50:00',3.81),('9303','2013-08-17','12:55:00',3.76),('9303','2013-08-17','13:00:00',3.78),('9303','2013-08-17','13:05:00',3.75),('9303','2013-08-17','13:10:00',3.88),('9303','2013-08-17','13:15:00',3.84),('9303','2013-08-17','13:20:00',3.83),('9303','2013-08-17','13:25:00',3.87),('9303','2013-08-17','13:30:00',3.8),('9303','2013-08-17','13:35:00',3.29),('9303','2013-08-17','13:45:00',1.47),('9303','2013-08-17','13:50:00',1.26),('9303','2013-08-17','14:00:00',2.77),('9303','2013-08-17','14:05:00',3.29),('9303','2013-08-17','14:10:00',3.69),('9303','2013-08-17','14:15:00',3.66),('9303','2013-08-17','14:20:00',3.8),('9303','2013-08-17','14:25:00',3.74),('9303','2013-08-17','14:30:00',3.63),('9303','2013-08-17','14:35:00',3.63),('9303','2013-08-17','14:40:00',3.52),('9303','2013-08-17','14:45:00',3.57),('9303','2013-08-17','14:50:00',3.61),('9303','2013-08-17','14:55:00',3.5),('9303','2013-08-17','15:00:00',3.45),('9303','2013-08-17','15:05:00',3.42),('9303','2013-08-17','15:10:00',3.37),('9303','2013-08-17','15:15:00',3.33),('9303','2013-08-17','15:20:00',3.35),('9303','2013-08-17','15:25:00',3.28),('9303','2013-08-17','15:30:00',3.26),('9303','2013-08-17','15:35:00',3.23),('9303','2013-08-17','15:40:00',3.15),('9303','2013-08-17','15:45:00',3.09),('9303','2013-08-17','15:50:00',3.06),('9303','2013-08-17','15:55:00',3.01),('9303','2013-08-17','16:00:00',2.97),('9303','2013-08-17','16:05:00',2.89),('9303','2013-08-17','16:10:00',2.84),('9303','2013-08-17','16:15:00',2.79),('9303','2013-08-17','16:20:00',2.74),('9303','2013-08-17','16:25:00',2.68),('9303','2013-08-17','16:30:00',2.64),('9303','2013-08-17','16:35:00',2.58),('9303','2013-08-17','16:40:00',2.5),('9303','2013-08-17','16:45:00',2.41),('9303','2013-08-17','16:50:00',2.31),('9303','2013-08-17','16:55:00',2.29),('9303','2013-08-17','17:00:00',2.18),('9303','2013-08-17','17:05:00',2.06),('9303','2013-08-17','17:10:00',1.95),('9303','2013-08-17','17:15:00',1.67),('9303','2013-08-17','17:20:00',1.79),('9303','2013-08-17','17:25:00',1.77),('9303','2013-08-17','17:30:00',1.75),('9303','2013-08-17','17:35:00',1.67),('9303','2013-08-17','17:40:00',1.59),('9303','2013-08-17','17:45:00',1.49),('9303','2013-08-17','17:50:00',1.38),('9303','2013-08-17','17:55:00',1.31),('9303','2013-08-17','18:00:00',1.21),('9303','2013-08-17','18:05:00',1.12),('9303','2013-08-17','18:10:00',1.03),('9303','2013-08-16','08:10:00',1.02),('9303','2013-08-16','08:15:00',1.11),('9303','2013-08-16','08:20:00',1.21),('9303','2013-08-16','08:25:00',1.32),('9303','2013-08-16','08:30:00',1.4),('9303','2013-08-16','08:35:00',1.49),('9303','2013-08-16','08:40:00',1.59),('9303','2013-08-16','08:45:00',1.67),('9303','2013-08-16','08:50:00',1.75),('9303','2013-08-16','08:55:00',1.83),('9303','2013-08-16','09:00:00',1.92),('9303','2013-08-16','09:05:00',2),('9303','2013-08-16','09:10:00',2.09),('9303','2013-08-16','09:15:00',2.16),('9303','2013-08-16','09:20:00',2.25),('9303','2013-08-16','09:25:00',2.32),('9303','2013-08-16','09:30:00',2.4),('9303','2013-08-16','09:35:00',2.48),('9303','2013-08-16','09:40:00',2.53),('9303','2013-08-16','09:45:00',2.6),('9303','2013-08-16','09:50:00',2.67),('9303','2013-08-16','09:55:00',2.74),('9303','2013-08-16','10:00:00',2.79),('9303','2013-08-16','10:05:00',2.85),('9303','2013-08-16','10:10:00',2.91),('9303','2013-08-16','10:15:00',2.97),('9303','2013-08-16','10:20:00',3.01),('9303','2013-08-16','10:25:00',3.06),('9303','2013-08-16','10:30:00',3.12),('9303','2013-08-16','10:35:00',3.16),('9303','2013-08-16','10:40:00',3.22),('9303','2013-08-16','10:45:00',3.24),('9303','2013-08-16','10:50:00',3.3),('9303','2013-08-16','10:55:00',3.36),('9303','2013-08-16','11:00:00',3.4),('9303','2013-08-16','11:05:00',3.42),('9303','2013-08-16','11:10:00',3.45),('9303','2013-08-16','11:15:00',3.47),('9303','2013-08-16','11:20:00',3.49),('9303','2013-08-16','11:25:00',3.52),('9303','2013-08-16','11:30:00',3.54),('9303','2013-08-16','11:35:00',3.58),('9303','2013-08-16','11:40:00',3.57),('9303','2013-08-16','11:45:00',3.61),('9303','2013-08-16','11:50:00',3.63),('9303','2013-08-16','11:55:00',3.62),('9303','2013-08-16','12:00:00',3.69),('9303','2013-08-16','12:05:00',3.71),('9303','2013-08-16','12:10:00',3.75),('9303','2013-08-16','12:15:00',3.75),('9303','2013-08-16','12:20:00',3.8),('9303','2013-08-16','12:25:00',3.78),('9303','2013-08-16','12:30:00',3.78),('9303','2013-08-16','12:35:00',3.74),('9303','2013-08-16','12:40:00',3.76),('9303','2013-08-16','12:45:00',3.79),('9303','2013-08-16','12:50:00',3.75),('9303','2013-08-16','12:55:00',3.76),('9303','2013-08-16','13:00:00',3.75),('9303','2013-08-16','13:05:00',3.77),('9303','2013-08-16','13:10:00',3.76),('9303','2013-08-16','13:15:00',3.78),('9303','2013-08-16','13:20:00',3.78),('9303','2013-08-16','13:25:00',3.75),('9303','2013-08-16','13:30:00',3.75),('9303','2013-08-16','13:35:00',3.75),('9303','2013-08-16','13:40:00',3.76),('9303','2013-08-16','13:45:00',3.77),('9303','2013-08-16','13:50:00',3.78),('9303','2013-08-16','13:55:00',3.74),('9303','2013-08-16','14:00:00',3.72),('9303','2013-08-16','14:05:00',3.66),('9303','2013-08-16','14:10:00',3.68),('9303','2013-08-16','14:15:00',3.63),('9303','2013-08-16','14:20:00',3.63),('9303','2013-08-16','14:25:00',3.61),('9303','2013-08-16','14:30:00',3.58),('9303','2013-08-16','14:35:00',3.55),('9303','2013-08-16','14:40:00',3.51),('9303','2013-08-16','14:45:00',3.48),('9303','2013-08-16','14:50:00',3.5),('9303','2013-08-16','14:55:00',3.47),('9303','2013-08-16','15:00:00',3.42),('9303','2013-08-16','15:05:00',3.33),('9303','2013-08-16','15:10:00',3.33),('9303','2013-08-16','15:15:00',3.31),('9303','2013-08-16','15:20:00',3.25),('9303','2013-08-16','15:25:00',3.24),('9303','2013-08-16','15:30:00',3.24),('9303','2013-08-16','15:35:00',3.19),('9303','2013-08-16','15:40:00',3.13),('9303','2013-08-16','15:45:00',3.1),('9303','2013-08-16','15:50:00',3.03),('9303','2013-08-16','15:55:00',3),('9303','2013-08-16','16:00:00',2.95),('9303','2013-08-16','16:05:00',2.91),('9303','2013-08-16','16:10:00',2.85),('9303','2013-08-16','16:15:00',2.79),('9303','2013-08-16','16:20:00',2.72),('9303','2013-08-16','16:25:00',2.67),('9303','2013-08-16','16:30:00',2.6),('9303','2013-08-16','16:35:00',2.55),('9303','2013-08-16','16:40:00',2.49),('9303','2013-08-16','16:45:00',2.43),('9303','2013-08-16','16:50:00',2.35),('9303','2013-08-16','16:55:00',2.26),('9303','2013-08-16','17:00:00',2.15),('9303','2013-08-16','17:05:00',2.04),('9303','2013-08-16','17:10:00',1.94),('9303','2013-08-16','17:15:00',1.86),('9303','2013-08-16','17:20:00',1.78),('9303','2013-08-16','17:25:00',1.71),('9303','2013-08-16','17:30:00',1.63),('9303','2013-08-16','17:35:00',1.56),('9303','2013-08-16','17:40:00',1.48),('9303','2013-08-16','17:45:00',1.39),('9303','2013-08-16','17:50:00',1.3),('9303','2013-08-16','17:55:00',1.21),('9303','2013-08-16','18:00:00',1.13),('9303','2013-08-16','18:05:00',1.05),('9303','2013-08-15','08:10:00',1.01),('9303','2013-08-15','08:20:00',1.25),('9303','2013-08-15','08:25:00',1.37),('9303','2013-08-15','08:30:00',1.44),('9303','2013-08-15','08:35:00',1.53),('9303','2013-08-15','08:40:00',1.61),('9303','2013-08-15','08:45:00',1.71),('9303','2013-08-15','08:50:00',1.79),('9303','2013-08-15','08:55:00',1.87),('9303','2013-08-15','09:00:00',2.03),('9303','2013-08-15','09:05:00',1.92),('9303','2013-08-15','09:10:00',1.84),('9303','2013-08-15','09:15:00',1.57),('9303','2013-08-15','09:20:00',2.23),('9303','2013-08-15','09:25:00',2.25),('9303','2013-08-15','09:30:00',2.39),('9303','2013-08-15','09:35:00',2.46),('9303','2013-08-15','09:40:00',2.54),('9303','2013-08-15','09:45:00',2.61),('9303','2013-08-15','09:50:00',2.67),('9303','2013-08-15','09:55:00',2.74),('9303','2013-08-15','10:00:00',2.79),('9303','2013-08-15','10:05:00',2.85),('9303','2013-08-15','10:10:00',2.92),('9303','2013-08-15','10:15:00',2.97),('9303','2013-08-15','10:20:00',3.04),('9303','2013-08-15','10:25:00',3.08),('9303','2013-08-15','10:30:00',3.15),('9303','2013-08-15','10:35:00',3.18),('9303','2013-08-15','10:40:00',3.23),('9303','2013-08-15','10:45:00',3.29),('9303','2013-08-15','10:50:00',3.22),('9303','2013-08-15','10:55:00',2.93),('9303','2013-08-15','11:00:00',3.24),('9303','2013-08-15','11:05:00',3.11),('9303','2013-08-15','11:10:00',2.26),('9303','2013-08-15','11:15:00',2.46),('9303','2013-08-15','11:20:00',2.78),('9303','2013-08-15','11:25:00',3.15),('9303','2013-08-15','11:30:00',3.58),('9303','2013-08-15','11:35:00',3.76),('9303','2013-08-15','11:40:00',3.85),('9303','2013-08-15','11:45:00',3.92),('9303','2013-08-15','11:50:00',3.96),('9303','2013-08-15','11:55:00',3.98),('9303','2013-08-15','12:00:00',3.98),('9303','2013-08-15','12:05:00',3.95),('9303','2013-08-15','12:10:00',3.91),('9303','2013-08-15','12:15:00',3.94),('9303','2013-08-15','12:20:00',3.97),('9303','2013-08-15','12:25:00',3.96),('9303','2013-08-15','12:30:00',3.93),('9303','2013-08-15','12:35:00',3.99),('9303','2013-08-15','12:40:00',3.97),('9303','2013-08-15','12:45:00',3.97),('9303','2013-08-15','12:50:00',3.92),('9303','2013-08-15','12:55:00',3.73),('9303','2013-08-15','13:00:00',3.69),('9303','2013-08-15','13:05:00',3.78),('9303','2013-08-15','13:10:00',3.74),('9303','2013-08-15','13:15:00',3.69),('9303','2013-08-15','13:20:00',3.71),('9303','2013-08-15','13:25:00',3.77),('9303','2013-08-15','13:30:00',3.86),('9303','2013-08-15','13:35:00',3.88),('9303','2013-08-15','13:40:00',3.86),('9303','2013-08-15','13:45:00',3.84),('9303','2013-08-15','13:50:00',3.81),('9303','2013-08-15','13:55:00',3.71),('9303','2013-08-15','14:00:00',3.73),('9303','2013-08-15','14:05:00',3.74),('9303','2013-08-15','14:10:00',3.74),('9303','2013-08-15','14:15:00',3.75),('9303','2013-08-15','14:20:00',3.73),('9303','2013-08-15','14:25:00',3.64),('9303','2013-08-15','14:30:00',3.57),('9303','2013-08-15','14:35:00',3.64),('9303','2013-08-15','14:40:00',3.61),('9303','2013-08-15','14:45:00',3.55),('9303','2013-08-15','14:50:00',2.99),('9303','2013-08-15','14:55:00',3.45),('9303','2013-08-15','15:00:00',3.42),('9303','2013-08-15','15:05:00',3.38),('9303','2013-08-15','15:10:00',3.36),('9303','2013-08-15','15:15:00',3.31),('9303','2013-08-15','15:20:00',3.25),('9303','2013-08-15','15:25:00',3.19),('9303','2013-08-15','15:30:00',3.19),('9303','2013-08-15','15:35:00',3.14),('9303','2013-08-15','15:40:00',3.08),('9303','2013-08-15','15:45:00',3.02),('9303','2013-08-15','15:50:00',2.97),('9303','2013-08-15','15:55:00',2.95),('9303','2013-08-15','16:00:00',2.88),('9303','2013-08-15','16:05:00',2.78),('9303','2013-08-15','16:10:00',2.64),('9303','2013-08-15','16:15:00',2.69),('9303','2013-08-15','16:20:00',2.68),('9303','2013-08-15','16:25:00',2.56),('9303','2013-08-15','16:30:00',2.46),('9303','2013-08-15','16:35:00',2.43),('9303','2013-08-15','16:40:00',2.37),('9303','2013-08-15','16:45:00',2.31),('9303','2013-08-15','16:50:00',2.23),('9303','2013-08-15','16:55:00',2.12),('9303','2013-08-15','17:00:00',2.04),('9303','2013-08-15','17:05:00',1.96),('9303','2013-08-15','17:10:00',1.87),('9303','2013-08-15','17:15:00',1.82),('9303','2013-08-15','17:20:00',1.76),('9303','2013-08-15','17:25:00',1.63),('9303','2013-08-15','17:30:00',1.6),('9303','2013-08-15','17:35:00',1.52),('9303','2013-08-15','17:40:00',1.44),('9303','2013-08-15','17:45:00',1.37),('9303','2013-08-15','17:50:00',1.27),('9303','2013-08-15','17:55:00',1.2),('9303','2013-08-15','18:00:00',1.13),('9303','2013-08-15','18:05:00',1.04),('9303','2013-08-14','08:10:00',1),('9303','2013-08-14','08:15:00',1.11),('9303','2013-08-14','08:20:00',1.19),('9303','2013-08-14','08:25:00',1.21),('9303','2013-08-14','08:30:00',1.33),('9303','2013-08-14','08:35:00',1.45),('9303','2013-08-14','08:40:00',1.6),('9303','2013-08-14','08:45:00',1.76),('9303','2013-08-14','08:50:00',1.67),('9303','2013-08-14','08:55:00',1.72),('9303','2013-08-14','09:00:00',1.83),('9303','2013-08-14','09:05:00',1.93),('9303','2013-08-14','09:10:00',2.03),('9303','2013-08-14','09:15:00',2.13),('9303','2013-08-14','09:20:00',2.2),('9303','2013-08-14','09:25:00',2.14),('9303','2013-08-14','09:30:00',2.35),('9303','2013-08-14','09:35:00',2.49),('9303','2013-08-14','09:40:00',2.23),('9303','2013-08-14','09:55:00',1.05),('9303','2013-08-14','10:00:00',2.49),('9303','2013-08-14','10:05:00',2.73),('9303','2013-08-14','10:10:00',2.62),('9303','2013-08-14','10:15:00',2.01),('9303','2013-08-14','10:20:00',2.57),('9303','2013-08-14','10:25:00',2.74),('9303','2013-08-14','10:30:00',3.22),('9303','2013-08-14','10:35:00',3.34),('9303','2013-08-14','10:40:00',3.33),('9303','2013-08-14','10:45:00',2.06),('9303','2013-08-14','10:50:00',1.36),('9303','2013-08-14','10:55:00',1.12),('9303','2013-08-14','11:00:00',1.98),('9303','2013-08-14','11:05:00',2.76),('9303','2013-08-14','11:10:00',2.51),('9303','2013-08-14','11:15:00',3.29),('9303','2013-08-14','11:20:00',3.18),('9303','2013-08-14','11:25:00',3.02),('9303','2013-08-14','11:30:00',3.68),('9303','2013-08-14','11:35:00',3.6),('9303','2013-08-14','11:40:00',3.61),('9303','2013-08-14','11:45:00',2.21),('9303','2013-08-14','11:50:00',1.36),('9303','2013-08-14','11:55:00',1.74),('9303','2013-08-14','12:00:00',1.43),('9303','2013-08-14','12:05:00',2.95),('9303','2013-08-14','12:10:00',2.26),('9303','2013-08-14','12:15:00',1.28),('9303','2013-08-14','12:20:00',1.15),('9303','2013-08-14','12:25:00',3.11),('9303','2013-08-14','12:30:00',3.04),('9303','2013-08-14','12:35:00',1.93),('9303','2013-08-14','12:40:00',1.11),('9303','2013-08-14','12:45:00',1.03),('9303','2013-08-14','12:50:00',1.13),('9303','2013-08-14','12:55:00',1.95),('9303','2013-08-14','13:00:00',2.01),('9303','2013-08-14','13:25:00',1.23),('9303','2013-08-14','13:30:00',2.3),('9303','2013-08-14','13:35:00',1.78),('9303','2013-08-14','13:40:00',1.65),('9303','2013-08-14','13:45:00',4.18),('9303','2013-08-14','13:50:00',4.21),('9303','2013-08-14','13:55:00',2.38),('9303','2013-08-14','14:00:00',2.31),('9303','2013-08-14','14:05:00',4.1),('9303','2013-08-14','14:10:00',4.07),('9303','2013-08-14','14:15:00',3.93),('9303','2013-08-14','14:20:00',3.94),('9303','2013-08-14','14:25:00',3.86),('9303','2013-08-14','14:30:00',3.25),('9303','2013-08-14','14:35:00',3.82),('9303','2013-08-14','14:40:00',3.72),('9303','2013-08-14','14:45:00',3.68),('9303','2013-08-14','14:50:00',3.69),('9303','2013-08-14','14:55:00',3.49),('9303','2013-08-14','15:00:00',3.52),('9303','2013-08-14','15:05:00',3.47),('9303','2013-08-14','15:10:00',3.43),('9303','2013-08-14','15:15:00',3.06),('9303','2013-08-14','15:20:00',3.5),('9303','2013-08-14','15:25:00',3.4),('9303','2013-08-14','15:30:00',3.27),('9303','2013-08-14','15:35:00',3.2),('9303','2013-08-14','15:40:00',3.18),('9303','2013-08-14','15:45:00',3.13),('9303','2013-08-14','15:50:00',3.1),('9303','2013-08-14','15:55:00',3.04),('9303','2013-08-14','16:00:00',3),('9303','2013-08-14','16:05:00',2.96),('9303','2013-08-14','16:10:00',2.92),('9303','2013-08-14','16:15:00',2.86),('9303','2013-08-14','16:20:00',2.82),('9303','2013-08-14','16:25:00',2.73),('9303','2013-08-14','16:30:00',2.65),('9303','2013-08-14','16:35:00',2.61),('9303','2013-08-14','16:40:00',2.55),('9303','2013-08-14','16:45:00',2.47),('9303','2013-08-14','16:50:00',2.41),('9303','2013-08-14','16:55:00',2.34),('9303','2013-08-14','17:00:00',2.21),('9303','2013-08-14','17:05:00',2.09),('9303','2013-08-14','17:10:00',1.99),('9303','2013-08-14','17:15:00',1.93),('9303','2013-08-14','17:20:00',1.84),('9303','2013-08-14','17:25:00',1.78),('9303','2013-08-14','17:30:00',1.71),('9303','2013-08-14','17:35:00',1.62),('9303','2013-08-14','17:40:00',1.55),('9303','2013-08-14','17:45:00',1.47),('9303','2013-08-14','17:50:00',1.37),('9303','2013-08-14','17:55:00',1.28),('9303','2013-08-14','18:00:00',1.2),('9303','2013-08-14','18:05:00',1.1),('9303','2013-08-14','18:10:00',1.02),('9303','2013-08-13','08:10:00',1.02),('9303','2013-08-13','08:15:00',1.12),('9303','2013-08-13','08:20:00',1.22),('9303','2013-08-13','08:25:00',1.31),('9303','2013-08-13','08:30:00',1.4),('9303','2013-08-13','08:35:00',1.52),('9303','2013-08-13','08:40:00',1.59),('9303','2013-08-13','08:45:00',1.67),('9303','2013-08-13','08:50:00',1.75),('9303','2013-08-13','08:55:00',1.83),('9303','2013-08-13','09:00:00',1.9),('9303','2013-08-13','09:05:00',1.99),('9303','2013-08-13','09:10:00',2.07),('9303','2013-08-13','09:15:00',2.14),('9303','2013-08-13','09:20:00',2.17),('9303','2013-08-13','09:25:00',2.22),('9303','2013-08-13','09:30:00',1.3),('9303','2013-08-13','09:35:00',2.36),('9303','2013-08-13','09:40:00',2.5),('9303','2013-08-13','09:45:00',2.56),('9303','2013-08-13','09:50:00',2.62),('9303','2013-08-13','09:55:00',2.67),('9303','2013-08-13','10:00:00',2.65),('9303','2013-08-13','10:05:00',2.82),('9303','2013-08-13','10:10:00',2.87),('9303','2013-08-13','10:15:00',2.9),('9303','2013-08-13','10:20:00',2.96),('9303','2013-08-13','10:25:00',2.99),('9303','2013-08-13','10:30:00',3.1),('9303','2013-08-13','10:35:00',3.12),('9303','2013-08-13','10:40:00',3.12),('9303','2013-08-13','10:45:00',3.16),('9303','2013-08-13','10:50:00',3.18),('9303','2013-08-13','10:55:00',3.2),('9303','2013-08-13','11:00:00',3.27),('9303','2013-08-13','11:05:00',3.3),('9303','2013-08-13','11:10:00',3.35),('9303','2013-08-13','11:15:00',3.37),('9303','2013-08-13','11:20:00',3.39),('9303','2013-08-13','11:25:00',3.41),('9303','2013-08-13','11:30:00',3.44),('9303','2013-08-13','11:35:00',3.42),('9303','2013-08-13','11:40:00',3.43),('9303','2013-08-13','11:45:00',3.47),('9303','2013-08-13','11:50:00',3.54),('9303','2013-08-13','11:55:00',3.64),('9303','2013-08-13','12:00:00',3.7),('9303','2013-08-13','12:05:00',3.73),('9303','2013-08-13','12:10:00',3.76),('9303','2013-08-13','12:15:00',3.88),('9303','2013-08-13','12:20:00',3.84),('9303','2013-08-13','12:25:00',3.96),('9303','2013-08-13','12:30:00',2.97),('9303','2013-08-13','12:35:00',3.99),('9303','2013-08-13','12:40:00',4.03),('9303','2013-08-13','12:45:00',2.82),('9303','2013-08-13','12:50:00',4.17),('9303','2013-08-13','12:55:00',2.25),('9303','2013-08-13','13:00:00',1.1),('9303','2013-08-13','13:05:00',1.14),('9303','2013-08-13','13:10:00',1.28),('9303','2013-08-13','13:15:00',1.18),('9303','2013-08-13','13:20:00',3.69),('9303','2013-08-13','13:25:00',4.27),('9303','2013-08-13','13:30:00',4.17),('9303','2013-08-13','13:35:00',4.09),('9303','2013-08-13','13:40:00',4.08),('9303','2013-08-13','13:45:00',4.12),('9303','2013-08-13','13:50:00',3.69),('9303','2013-08-13','13:55:00',3.54),('9303','2013-08-13','14:00:00',3.5),('9303','2013-08-13','14:05:00',4.06),('9303','2013-08-13','14:10:00',4.05),('9303','2013-08-13','14:15:00',4.03),('9303','2013-08-13','14:20:00',3.82),('9303','2013-08-13','14:25:00',3.25),('9303','2013-08-13','14:30:00',1.47),('9303','2013-08-13','14:35:00',4.24),('9303','2013-08-13','14:40:00',2.71),('9303','2013-08-13','14:45:00',3.87),('9303','2013-08-13','14:50:00',3.89),('9303','2013-08-13','14:55:00',3.83),('9303','2013-08-13','15:00:00',3.52),('9303','2013-08-13','15:05:00',3.49),('9303','2013-08-13','15:10:00',2.51),('9303','2013-08-13','15:15:00',3),('9303','2013-08-13','15:20:00',3.46),('9303','2013-08-13','15:25:00',3.4),('9303','2013-08-13','15:30:00',3.31),('9303','2013-08-13','15:35:00',3.28),('9303','2013-08-13','15:40:00',3.22),('9303','2013-08-13','15:45:00',3.18),('9303','2013-08-13','15:50:00',3.1),('9303','2013-08-13','15:55:00',3.04),('9303','2013-08-13','16:00:00',3),('9303','2013-08-13','16:05:00',2.91),('9303','2013-08-13','16:10:00',2.85),('9303','2013-08-13','16:15:00',2.8),('9303','2013-08-13','16:20:00',2.78),('9303','2013-08-13','16:25:00',2.7),('9303','2013-08-13','16:30:00',2.63),('9303','2013-08-13','16:35:00',2.58),('9303','2013-08-13','16:40:00',2.52),('9303','2013-08-13','16:45:00',2.45),('9303','2013-08-13','16:50:00',2.39),('9303','2013-08-13','16:55:00',2.31),('9303','2013-08-13','17:00:00',2.2),('9303','2013-08-13','17:05:00',2.1),('9303','2013-08-13','17:10:00',2),('9303','2013-08-13','17:15:00',1.91),('9303','2013-08-13','17:20:00',1.83),('9303','2013-08-13','17:25:00',1.76),('9303','2013-08-13','17:30:00',1.68),('9303','2013-08-13','17:35:00',1.6),('9303','2013-08-13','17:40:00',1.54),('9303','2013-08-13','17:45:00',1.46),('9303','2013-08-13','17:50:00',1.36),('9303','2013-08-13','17:55:00',1.28),('9303','2013-08-13','18:00:00',1.2),('9303','2013-08-13','18:05:00',1.1),('9303','2013-08-13','18:10:00',1.02),('9303','2013-08-10','08:10:00',1.07),('9303','2013-08-10','08:15:00',1.17),('9303','2013-08-10','08:20:00',1.27),('9303','2013-08-10','08:25:00',1.38),('9303','2013-08-10','08:30:00',1.48),('9303','2013-08-10','08:35:00',1.58),('9303','2013-08-10','08:40:00',1.65),('9303','2013-08-10','08:45:00',1.72),('9303','2013-08-10','08:50:00',1.8),('9303','2013-08-10','08:55:00',1.88),('9303','2013-08-10','09:00:00',1.96),('9303','2013-08-10','09:05:00',2.04),('9303','2013-08-10','09:10:00',2.12),('9303','2013-08-10','09:15:00',2.21),('9303','2013-08-10','09:20:00',2.28),('9303','2013-08-10','09:25:00',2.35),('9303','2013-08-10','09:30:00',2.42),('9303','2013-08-10','09:35:00',2.47),('9303','2013-08-10','09:40:00',2.52),('9303','2013-08-10','09:45:00',2.59),('9303','2013-08-10','09:50:00',2.65),('9303','2013-08-10','09:55:00',2.71),('9303','2013-08-10','10:00:00',2.77),('9303','2013-08-10','10:05:00',2.82),('9303','2014-04-09','08:20:00',1.05),('9303','2014-04-09','09:50:00',1.7),('9303','2014-04-09','09:55:00',2.84),('9303','2014-04-09','10:00:00',2.81),('9303','2014-04-09','10:05:00',2.82),('9303','2014-04-09','10:10:00',2.96),('9303','2014-04-09','10:15:00',3.16),('9303','2014-04-09','10:20:00',3.18),('9303','2014-04-09','10:25:00',2.82),('9303','2014-04-09','10:30:00',2.16),('9303','2014-04-09','10:35:00',3.42),('9303','2014-04-09','10:40:00',1.79),('9303','2014-04-09','10:45:00',1.16),('9303','2014-04-09','10:50:00',1.09),('9303','2014-04-09','10:55:00',1.24),('9303','2014-04-09','11:00:00',2.77),('9303','2014-04-09','11:05:00',4.1),('9303','2014-04-09','11:10:00',4.19),('9303','2014-04-09','11:15:00',3.93),('9303','2014-04-09','11:20:00',2.25),('9303','2014-04-09','11:35:00',1.26),('9303','2014-04-09','11:40:00',4.27),('9303','2014-04-09','11:45:00',3.31),('9303','2014-04-09','11:50:00',2.09),('9303','2014-04-09','11:55:00',4.38),('9303','2014-04-09','12:00:00',3.87),('9303','2014-04-09','12:05:00',3.62),('9303','2014-04-09','12:10:00',1.71),('9303','2014-04-09','12:15:00',1.41),('9303','2014-04-09','12:20:00',1.13),('9303','2014-04-09','13:20:00',1.44),('9303','2014-04-09','13:25:00',1.63),('9303','2014-04-09','13:30:00',1.35),('9303','2014-04-09','13:35:00',1.31),('9303','2014-04-09','13:40:00',1.17),('9303','2014-04-09','13:45:00',1.01),('9303','2014-04-09','14:05:00',1.27),('9303','2014-04-09','14:10:00',2.84),('9303','2014-04-09','14:15:00',2.49),('9303','2014-04-09','14:20:00',1.86),('9303','2014-04-09','14:25:00',1.8),('9303','2014-04-09','14:30:00',2.67),('9303','2014-04-09','14:35:00',3.73),('9303','2014-04-09','14:40:00',2.08),('9303','2014-04-09','14:45:00',2.05),('9303','2014-04-09','14:50:00',1.93),('9303','2014-04-09','14:55:00',2.11),('9303','2014-04-09','15:00:00',1.92),('9303','2014-04-09','15:05:00',4.36),('9303','2014-04-09','15:10:00',3.24),('9303','2014-04-09','15:15:00',3.71),('9303','2014-04-09','15:20:00',3.75),('9303','2014-04-09','15:25:00',1.85),('9303','2014-04-09','15:30:00',2.87),('9303','2014-04-09','15:35:00',1.65),('9303','2014-04-09','15:40:00',2.23),('9303','2014-04-09','15:45:00',2.08),('9303','2014-04-09','15:50:00',1.36),('9303','2014-04-09','15:55:00',1.29),('9303','2014-04-09','16:00:00',1.1),('9303','2014-04-09','16:05:00',1.96),('9303','2014-04-09','16:10:00',3),('9303','2014-04-09','16:15:00',3),('9303','2014-04-09','16:20:00',3.02),('9303','2014-04-09','16:25:00',2.85),('9303','2014-04-09','16:30:00',1.94),('9303','2014-04-09','16:35:00',1.33),('9303','2014-04-09','16:40:00',1.4),('9303','2014-04-09','16:45:00',1.61),('9303','2014-04-09','16:50:00',1.4),('9303','2014-04-09','16:55:00',1.44),('9303','2014-04-09','17:00:00',1.86),('9303','2014-04-09','17:05:00',2.18),('9303','2014-04-09','17:10:00',2.05),('9303','2014-04-09','17:15:00',1.84),('9303','2014-04-09','17:20:00',1.78),('9303','2014-04-09','17:25:00',1.77),('9303','2014-04-09','17:30:00',1.11),('9303','2014-04-09','17:45:00',1.09),('9303','2014-04-09','17:55:00',1.05),('9303','2013-08-09','08:40:00',1.31),('9303','2013-08-09','08:45:00',1.51),('9303','2013-08-09','08:50:00',1.6),('9303','2013-08-09','08:55:00',1.68),('9303','2013-08-09','09:00:00',1.67),('9303','2013-08-09','09:05:00',1.84),('9303','2013-08-09','09:10:00',1.91),('9303','2013-08-09','09:15:00',1.79),('9303','2013-08-09','09:20:00',1.59),('9303','2013-08-09','09:25:00',1.64),('9303','2013-08-09','09:30:00',2.04),('9303','2013-08-09','09:35:00',2.36),('9303','2013-08-09','09:40:00',1.89),('9303','2013-08-09','09:45:00',2.45),('9303','2013-08-09','09:50:00',2.46),('9303','2013-08-09','09:55:00',1.46),('9303','2013-08-09','10:00:00',1.76),('9303','2013-08-09','10:05:00',1.81),('9303','2013-08-09','10:10:00',2.02),('9303','2013-08-09','10:15:00',2.64),('9303','2013-08-09','10:20:00',2.6),('9303','2013-08-09','10:25:00',2.7),('9303','2013-08-09','10:30:00',2.79),('9303','2013-08-09','10:35:00',2.78),('9303','2013-08-09','10:40:00',2.89),('9303','2013-08-09','10:45:00',2.89),('9303','2013-08-09','10:50:00',2.93),('9303','2013-08-09','10:55:00',2.99),('9303','2013-08-09','11:00:00',3.02),('9303','2013-08-09','11:05:00',3.06),('9303','2013-08-09','11:10:00',3.11),('9303','2013-08-09','11:15:00',3.18),('9303','2013-08-09','11:20:00',3.2),('9303','2013-08-09','11:25:00',3.22),('9303','2013-08-09','11:30:00',3.24),('9303','2013-08-09','11:35:00',3.22),('9303','2013-08-09','11:40:00',3.25),('9303','2013-08-09','11:45:00',3.28),('9303','2013-08-09','11:50:00',3.34),('9303','2013-08-09','11:55:00',3.38),('9303','2013-08-09','12:00:00',3.41),('9303','2013-08-09','12:05:00',3.41),('9303','2013-08-09','12:10:00',3.44),('9303','2013-08-09','12:15:00',3.51),('9303','2013-08-09','12:20:00',3.61),('9303','2013-08-09','12:25:00',3.16),('9303','2013-08-09','12:30:00',2.45),('9303','2013-08-09','12:35:00',3.15),('9303','2013-08-09','12:40:00',3.56),('9303','2013-08-09','12:45:00',2.69),('9303','2013-08-09','12:50:00',2.81),('9303','2013-08-09','12:55:00',2.52),('9303','2013-08-09','13:00:00',1.35),('9303','2013-08-09','13:20:00',1.27),('9303','2013-08-09','13:25:00',1.94),('9303','2013-08-09','13:30:00',1.92),('9303','2013-08-09','13:35:00',1.36),('9303','2013-08-09','13:40:00',1.38),('9303','2013-08-09','13:45:00',1.28),('9303','2013-08-09','13:50:00',1.35),('9303','2013-08-09','13:55:00',1.18),('9303','2013-08-09','14:00:00',1.1),('9303','2013-08-09','14:05:00',1.2),('9303','2013-08-09','14:10:00',1.41),('9303','2013-08-09','15:05:00',1.11),('9303','2013-08-09','15:10:00',2.47),('9303','2013-08-09','15:15:00',2.4),('9303','2013-08-09','15:20:00',1.37),('9303','2013-08-09','15:25:00',1.12),('9303','2013-08-09','15:30:00',1.03),('9303','2013-08-09','15:35:00',1.84),('9303','2013-08-09','15:40:00',1.42),('9303','2013-08-09','15:45:00',2.74),('9303','2013-08-09','15:50:00',1.84),('9303','2013-08-09','15:55:00',1.84),('9303','2013-08-09','16:00:00',1.05),('9303','2013-08-09','16:50:00',1.37),('9303','2013-08-09','16:55:00',2.13),('9303','2013-08-09','17:00:00',1.21),('9303','2013-08-09','17:05:00',1.7),('9303','2013-08-08','08:15:00',1.03),('9303','2013-08-08','08:20:00',1.12),('9303','2013-08-08','08:25:00',1.2),('9303','2013-08-08','08:30:00',1.3),('9303','2013-08-08','08:35:00',1.38),('9303','2013-08-08','08:40:00',1.45),('9303','2013-08-08','08:45:00',1.51),('9303','2013-08-08','08:50:00',1.61),('9303','2013-08-08','08:55:00',1.68),('9303','2013-08-08','09:00:00',1.76),('9303','2013-08-08','09:05:00',1.82),('9303','2013-08-08','09:10:00',1.9),('9303','2013-08-08','09:15:00',1.97),('9303','2013-08-08','09:20:00',2.03),('9303','2013-08-08','09:25:00',2.1),('9303','2013-08-08','09:30:00',2.17),('9303','2013-08-08','09:35:00',2.24),('9303','2013-08-08','09:40:00',2.31),('9303','2013-08-08','09:45:00',2.37),('9303','2013-08-08','09:50:00',2.42),('9303','2013-08-08','09:55:00',2.47),('9303','2013-08-08','10:00:00',2.52),('9303','2013-08-08','10:05:00',2.58),('9303','2013-08-08','10:10:00',2.63),('9303','2013-08-08','10:15:00',2.69),('9303','2013-08-08','10:20:00',2.73),('9303','2013-08-08','10:25:00',2.78),('9303','2013-08-08','10:30:00',2.82),('9303','2013-08-08','10:35:00',2.86),('9303','2013-08-08','10:40:00',2.92),('9303','2013-08-08','10:45:00',2.94),('9303','2013-08-08','10:50:00',2.99),('9303','2013-08-08','10:55:00',3.04),('9303','2013-08-08','11:00:00',3.06),('9303','2013-08-08','11:05:00',3.11),('9303','2013-08-08','11:10:00',3.13),('9303','2013-08-08','11:15:00',3.15),('9303','2013-08-08','11:20:00',3.17),('9303','2013-08-08','11:25:00',3.19),('9303','2013-08-08','11:30:00',3.19),('9303','2013-08-08','11:35:00',3.25),('9303','2013-08-08','11:40:00',3.28),('9303','2013-08-08','11:45:00',3.29),('9303','2013-08-08','11:50:00',3.3),('9303','2013-08-08','11:55:00',3.35),('9303','2013-08-08','12:00:00',3.41),('9303','2013-08-08','12:05:00',3.39),('9303','2013-08-08','12:10:00',3.42),('9303','2013-08-08','12:15:00',3.46),('9303','2013-08-08','12:20:00',3.46),('9303','2013-08-08','12:25:00',3.47),('9303','2013-08-08','12:30:00',3.46),('9303','2013-08-08','12:35:00',3.53),('9303','2013-08-08','12:40:00',3.52),('9303','2013-08-08','12:45:00',3.54),('9303','2013-08-08','12:50:00',3.59),('9303','2013-08-08','12:55:00',3.62),('9303','2013-08-08','13:00:00',3.58),('9303','2013-08-08','13:05:00',3.63),('9303','2013-08-08','13:10:00',3.62),('9303','2013-08-08','13:15:00',3.62),('9303','2013-08-08','13:20:00',3.63),('9303','2013-08-08','13:25:00',3.62),('9303','2013-08-08','13:30:00',3.61),('9303','2013-08-08','13:35:00',3.61),('9303','2013-08-08','13:40:00',3.56),('9303','2013-08-08','13:45:00',3.53),('9303','2013-08-08','13:50:00',3.58),('9303','2013-08-08','13:55:00',3.54),('9303','2013-08-08','14:00:00',3.56),('9303','2013-08-08','14:05:00',3.51),('9303','2013-08-08','14:10:00',3.47),('9303','2013-08-08','14:15:00',3.44),('9303','2013-08-08','14:20:00',3.43),('9303','2013-08-08','14:25:00',3.41),('9303','2013-08-08','14:30:00',3.41),('9303','2013-08-08','14:35:00',3.41),('9303','2013-08-08','14:40:00',3.37),('9303','2013-08-08','14:45:00',3.34),('9303','2013-08-08','14:50:00',3.3),('9303','2013-08-08','14:55:00',3.26),('9303','2013-08-08','15:00:00',3.23),('9303','2013-08-08','15:05:00',3.18),('9303','2013-08-08','15:10:00',3.15),('9303','2013-08-08','15:15:00',3.14),('9303','2013-08-08','15:20:00',3.07),('9303','2013-08-08','15:25:00',3.04),('9303','2013-08-08','15:30:00',2.98),('9303','2013-08-08','15:35:00',2.95),('9303','2013-08-08','15:40:00',2.92),('9303','2013-08-08','15:45:00',2.89),('9303','2013-08-08','15:50:00',2.84),('9303','2013-08-08','15:55:00',2.78),('9303','2013-08-08','16:00:00',2.74),('9303','2013-08-08','16:05:00',2.69),('9303','2013-08-08','16:10:00',2.65),('9303','2013-08-08','16:15:00',2.62),('9303','2013-08-08','16:20:00',2.58),('9303','2013-08-08','16:25:00',2.54),('9303','2013-08-08','16:30:00',2.48),('9303','2013-08-08','16:35:00',2.42),('9303','2013-08-08','16:40:00',2.37),('9303','2013-08-08','16:45:00',2.29),('9303','2013-08-08','16:50:00',2.22),('9303','2013-08-08','16:55:00',2.16),('9303','2013-08-08','17:00:00',2.09),('9303','2013-08-08','17:05:00',1.97),('9303','2013-08-08','17:10:00',1.87),('9303','2013-08-08','17:15:00',1.78),('9303','2013-08-08','17:20:00',1.71),('9303','2013-08-08','17:25:00',1.63),('9303','2013-08-08','17:30:00',1.56),('9303','2013-08-08','17:35:00',1.49),('9303','2013-08-08','17:40:00',1.42),('9303','2013-08-08','17:45:00',1.35),('9303','2013-08-08','17:50:00',1.3),('9303','2013-08-08','17:55:00',1.19),('9303','2013-08-08','18:00:00',1.13),('9303','2013-08-08','18:05:00',1.06),('9303','2013-08-07','08:10:00',1.01),('9303','2013-08-07','08:15:00',1.08),('9303','2013-08-07','08:20:00',1.17),('9303','2013-08-07','08:25:00',1.25),('9303','2013-08-07','08:30:00',1.35),('9303','2013-08-07','08:35:00',1.43),('9303','2013-08-07','08:40:00',1.52),('9303','2013-08-07','08:45:00',1.6),('9303','2013-08-07','08:50:00',1.67),('9303','2013-08-07','08:55:00',1.73),('9303','2013-08-07','09:00:00',1.8),('9303','2013-08-07','09:05:00',1.87),('9303','2013-08-07','09:10:00',1.95),('9303','2013-08-07','09:15:00',2.01),('9303','2013-08-07','09:20:00',2.08),('9303','2013-08-07','09:25:00',2.15),('9303','2013-08-07','09:30:00',2.21),('9303','2013-08-07','09:35:00',2.31),('9303','2013-08-07','09:40:00',2.36),('9303','2013-08-07','09:45:00',2.41),('9303','2013-08-07','09:50:00',2.45),('9303','2013-08-07','09:55:00',2.48),('9303','2013-08-07','10:00:00',2.57),('9303','2013-08-07','10:05:00',2.64),('9303','2013-08-07','10:10:00',2.67),('9303','2013-08-07','10:15:00',2.72),('9303','2013-08-07','10:20:00',2.78),('9303','2013-08-07','10:25:00',2.81),('9303','2013-08-07','10:30:00',2.83),('9303','2013-08-07','10:35:00',2.88),('9303','2013-08-07','10:40:00',2.96),('9303','2013-08-07','10:45:00',2.99),('9303','2013-08-07','10:50:00',3.03),('9303','2013-08-07','10:55:00',3.05),('9303','2013-08-07','11:00:00',3.09),('9303','2013-08-07','11:05:00',3.12),('9303','2013-08-07','11:10:00',3.17),('9303','2013-08-07','11:15:00',3.21),('9303','2013-08-07','11:20:00',3.25),('9303','2013-08-07','11:25:00',3.29),('9303','2013-08-07','11:30:00',3.29),('9303','2013-08-07','11:35:00',3.34),('9303','2013-08-07','11:40:00',3.33),('9303','2013-08-07','11:45:00',3.33),('9303','2013-08-07','11:50:00',3.35),('9303','2013-08-07','11:55:00',3.37),('9303','2013-08-07','12:00:00',3.42),('9303','2013-08-07','12:05:00',3.43),('9303','2013-08-07','12:10:00',3.48),('9303','2013-08-07','12:15:00',3.48),('9303','2013-08-07','12:20:00',3.47),('9303','2013-08-07','12:25:00',3.45),('9303','2013-08-07','12:30:00',3.48),('9303','2013-08-07','12:35:00',3.44),('9303','2013-08-07','12:40:00',3.46),('9303','2013-08-07','12:45:00',3.45),('9303','2013-08-07','12:50:00',3.5),('9303','2013-08-07','12:55:00',3.56),('9303','2013-08-07','13:00:00',3.55),('9303','2013-08-07','13:05:00',3.5),('9303','2013-08-07','13:10:00',3.51),('9303','2013-08-07','13:15:00',3.55),('9303','2013-08-07','13:20:00',3.54),('9303','2013-08-07','13:25:00',3.53),('9303','2013-08-07','13:30:00',3.58),('9303','2013-08-07','13:35:00',3.57),('9303','2013-08-07','13:40:00',3.62),('9303','2013-08-07','13:45:00',3.58),('9303','2013-08-07','13:50:00',3.55),('9303','2013-08-07','13:55:00',3.6),('9303','2013-08-07','14:00:00',3.54),('9303','2013-08-07','14:05:00',3.61),('9303','2013-08-07','14:10:00',3.53),('9303','2013-08-07','14:15:00',3.48),('9303','2013-08-07','14:20:00',3.46),('9303','2013-08-07','14:25:00',3.43),('9303','2013-08-07','14:30:00',3.4),('9303','2013-08-07','14:35:00',3.35),('9303','2013-08-07','14:40:00',3.39),('9303','2013-08-07','14:45:00',3.39),('9303','2013-08-07','14:50:00',3.38),('9303','2013-08-07','14:55:00',3.34),('9303','2013-08-07','15:00:00',3.31),('9303','2013-08-07','15:05:00',3.26),('9303','2013-08-07','15:10:00',3.24),('9303','2013-08-07','15:15:00',3.18),('9303','2013-08-07','15:20:00',3.18),('9303','2013-08-07','15:25:00',3.12),('9303','2013-08-07','15:30:00',3.1),('9303','2013-08-07','15:35:00',3.04),('9303','2013-08-07','15:40:00',2.97),('9303','2013-08-07','15:45:00',2.95),('9303','2013-08-07','15:50:00',2.89),('9303','2013-08-07','15:55:00',2.87),('9303','2013-08-07','16:00:00',2.76),('9303','2013-08-07','16:05:00',2.73),('9303','2013-08-07','16:10:00',2.68),('9303','2013-08-07','16:15:00',2.64),('9303','2013-08-07','16:20:00',2.62),('9303','2013-08-07','16:25:00',2.57),('9303','2013-08-07','16:30:00',2.51),('9303','2013-08-07','16:35:00',2.45),('9303','2013-08-07','16:40:00',2.39),('9303','2013-08-07','16:45:00',2.32),('9303','2013-08-07','16:50:00',2.28),('9303','2013-08-07','16:55:00',2.21),('9303','2013-08-07','17:00:00',2.12),('9303','2013-08-07','17:05:00',2.01),('9303','2013-08-07','17:10:00',1.9),('9303','2013-08-07','17:15:00',1.8),('9303','2013-08-07','17:20:00',1.74),('9303','2013-08-07','17:25:00',1.68),('9303','2013-08-07','17:30:00',1.61),('9303','2013-08-07','17:35:00',1.53),('9303','2013-08-07','17:40:00',1.44),('9303','2013-08-07','17:45:00',1.38),('9303','2013-08-07','17:50:00',1.32),('9303','2013-08-07','17:55:00',1.22),('9303','2013-08-07','18:00:00',1.16),('9303','2013-08-07','18:05:00',1.06),('9303','2013-08-06','08:15:00',1.07),('9303','2013-08-06','08:20:00',1.16),('9303','2013-08-06','08:25:00',1.23),('9303','2013-08-06','08:30:00',1.33),('9303','2013-08-06','08:35:00',1.42),('9303','2013-08-06','08:40:00',1.49),('9303','2013-08-06','08:45:00',1.57),('9303','2013-08-06','08:50:00',1.64),('9303','2013-08-06','08:55:00',1.71),('9303','2013-08-06','09:00:00',1.78),('9303','2013-08-06','09:05:00',1.86),('9303','2013-08-06','09:10:00',1.94),('9303','2013-08-06','09:15:00',1.99),('9303','2013-08-06','09:20:00',2.05),('9303','2013-08-06','09:25:00',2.13),('9303','2013-08-06','09:30:00',2.2),('9303','2013-08-06','09:35:00',2.24),('9303','2013-08-06','09:40:00',2.3),('9303','2013-08-06','09:45:00',2.37),('9303','2013-08-06','09:50:00',2.44),('9303','2013-08-06','09:55:00',2.5),('9303','2013-08-06','10:00:00',2.53),('9303','2013-08-06','10:05:00',2.59),('9303','2013-08-06','10:10:00',2.64),('9303','2013-08-06','10:15:00',2.7),('9303','2013-08-06','10:20:00',2.76),('9303','2013-08-06','10:25:00',2.8),('9303','2013-08-06','10:30:00',2.82),('9303','2013-08-06','10:35:00',2.87),('9303','2013-08-06','10:40:00',2.91),('9303','2013-08-06','10:45:00',2.96),('9303','2013-08-06','10:50:00',3.01),('9303','2013-08-06','10:55:00',3.03),('9303','2013-08-06','11:00:00',3.08),('9303','2013-08-06','11:05:00',3.12),('9303','2013-08-06','11:10:00',3.14),('9303','2013-08-06','11:15:00',3.24),('9303','2013-08-06','11:20:00',3.25),('9303','2013-08-06','11:25:00',3.28),('9303','2013-08-06','11:30:00',3.27),('9303','2013-08-06','11:35:00',3.32),('9303','2013-08-06','11:40:00',3.36),('9303','2013-08-06','11:45:00',3.35),('9303','2013-08-06','11:50:00',3.39),('9303','2013-08-06','11:55:00',3.42),('9303','2013-08-06','12:00:00',3.46),('9303','2013-08-06','12:05:00',3.46),('9303','2013-08-06','12:10:00',3.48),('9303','2013-08-06','12:15:00',3.49),('9303','2013-08-06','12:20:00',3.43),('9303','2013-08-06','12:25:00',3.42),('9303','2013-08-06','12:30:00',3.46),('9303','2013-08-06','12:35:00',3.5),('9303','2013-08-06','12:40:00',3.51),('9303','2013-08-06','12:45:00',3.48),('9303','2013-08-06','12:50:00',3.5),('9303','2013-08-06','12:55:00',3.54),('9303','2013-08-06','13:00:00',3.53),('9303','2013-08-06','13:05:00',3.55),('9303','2013-08-06','13:10:00',3.59),('9303','2013-08-06','13:15:00',3.6),('9303','2013-08-06','13:20:00',3.59),('9303','2013-08-06','13:25:00',3.61),('9303','2013-08-06','13:30:00',3.59),('9303','2013-08-06','13:35:00',3.64),('9303','2013-08-06','13:40:00',3.68),('9303','2013-08-06','13:45:00',3.65),('9303','2013-08-06','13:50:00',3.67),('9303','2013-08-06','13:55:00',3.66),('9303','2013-08-06','14:00:00',3.66),('9303','2013-08-06','14:05:00',3.64),('9303','2013-08-06','14:10:00',3.65),('9303','2013-08-06','14:15:00',3.65),('9303','2013-08-06','14:20:00',3.62),('9303','2013-08-06','14:25:00',3.6),('9303','2013-08-06','14:30:00',3.58),('9303','2013-08-06','14:35:00',3.56),('9303','2013-08-06','14:40:00',3.52),('9303','2013-08-06','14:45:00',3.48),('9303','2013-08-06','14:50:00',3.46),('9303','2013-08-06','14:55:00',3.45),('9303','2013-08-06','15:00:00',3.43),('9303','2013-08-06','15:05:00',3.39),('9303','2013-08-06','15:10:00',3.35),('9303','2013-08-06','15:15:00',3.31),('9303','2013-08-06','15:20:00',3.28),('9303','2013-08-06','15:25:00',3.23),('9303','2013-08-06','15:30:00',3.19),('9303','2013-08-06','15:35:00',3.15),('9303','2013-08-06','15:40:00',3.11),('9303','2013-08-06','15:45:00',3.07),('9303','2013-08-06','15:50:00',3.03),('9303','2013-08-06','15:55:00',2.97),('9303','2013-08-06','16:00:00',2.91),('9303','2013-08-06','16:05:00',2.84),('9303','2013-08-06','16:10:00',2.79),('9303','2013-08-06','16:15:00',2.75),('9303','2013-08-06','16:20:00',2.69),('9303','2013-08-06','16:25:00',2.64),('9303','2013-08-06','16:30:00',2.58),('9303','2013-08-06','16:35:00',2.51),('9303','2013-08-06','16:40:00',2.45),('9303','2013-08-06','16:45:00',2.4),('9303','2013-08-06','16:50:00',2.33),('9303','2013-08-06','16:55:00',2.27),('9303','2013-08-06','17:00:00',2.19),('9303','2013-08-06','17:05:00',2.1),('9303','2013-08-06','17:10:00',1.99),('9303','2013-08-06','17:15:00',1.87),('9303','2013-08-06','17:20:00',1.79),('9303','2013-08-06','17:25:00',1.71),('9303','2013-08-06','17:30:00',1.64),('9303','2013-08-06','17:35:00',1.58),('9303','2013-08-06','17:40:00',1.49),('9303','2013-08-06','17:45:00',1.42),('9303','2013-08-06','17:50:00',1.35),('9303','2013-08-06','17:55:00',1.27),('9303','2013-08-06','18:00:00',1.19),('9303','2013-08-06','18:05:00',1.1),('9303','2013-08-06','18:10:00',1.02),('9303','2013-08-05','08:10:00',1.04),('9303','2013-08-05','08:15:00',1.12),('9303','2013-08-05','08:20:00',1.2),('9303','2013-08-05','08:25:00',1.28),('9303','2013-08-05','08:30:00',1.37),('9303','2013-08-05','08:35:00',1.46),('9303','2013-08-05','08:40:00',1.55),('9303','2013-08-05','08:45:00',1.62),('9303','2013-08-05','08:50:00',1.7),('9303','2013-08-05','08:55:00',1.77),('9303','2013-08-05','09:00:00',1.84),('9303','2013-08-05','09:05:00',1.91),('9303','2013-08-05','09:10:00',1.97),('9303','2013-08-05','09:15:00',2.02),('9303','2013-08-05','09:20:00',2.09),('9303','2013-08-05','09:25:00',2.16),('9303','2013-08-05','09:30:00',2.22),('9303','2013-08-05','09:35:00',2.28),('9303','2013-08-05','09:40:00',2.33),('9303','2013-08-05','09:45:00',2.4),('9303','2013-08-05','09:50:00',2.47),('9303','2013-08-05','09:55:00',2.54),('9303','2013-08-05','10:00:00',2.6),('9303','2013-08-05','10:05:00',2.64),('9303','2013-08-05','10:10:00',2.7),('9303','2013-08-05','10:15:00',2.74),('9303','2013-08-05','10:20:00',2.83),('9303','2013-08-05','10:25:00',2.87),('9303','2013-08-05','10:30:00',2.9),('9303','2013-08-05','10:35:00',2.95),('9303','2013-08-05','10:40:00',2.99),('9303','2013-08-05','10:45:00',3.06),('9303','2013-08-05','10:50:00',3.12),('9303','2013-08-05','10:55:00',3.14),('9303','2013-08-05','11:00:00',3.19),('9303','2013-08-05','11:05:00',3.23),('9303','2013-08-05','11:10:00',3.26),('9303','2013-08-05','11:15:00',3.3),('9303','2013-08-05','11:20:00',3.37),('9303','2013-08-05','11:25:00',3.36),('9303','2013-08-05','11:30:00',3.38),('9303','2013-08-05','11:35:00',3.41),('9303','2013-08-05','11:40:00',3.42),('9303','2013-08-05','11:45:00',3.47),('9303','2013-08-05','11:50:00',3.49),('9303','2013-08-05','11:55:00',3.5),('9303','2013-08-05','12:00:00',3.54),('9303','2013-08-05','12:05:00',3.55),('9303','2013-08-05','12:10:00',3.57),('9303','2013-08-05','12:15:00',3.57),('9303','2013-08-05','12:20:00',3.59),('9303','2013-08-05','12:25:00',3.59),('9303','2013-08-05','12:30:00',3.56),('9303','2013-08-05','12:35:00',3.61),('9303','2013-08-05','12:40:00',3.65),('9303','2013-08-05','12:45:00',3.61),('9303','2013-08-05','12:50:00',3.62),('9303','2013-08-05','12:55:00',3.63),('9303','2013-08-05','13:00:00',3.66),('9303','2013-08-05','13:05:00',3.64),('9303','2013-08-05','13:10:00',3.61),('9303','2013-08-05','13:15:00',3.66),('9303','2013-08-05','13:20:00',3.65),('9303','2013-08-05','13:25:00',3.63),('9303','2013-08-05','13:30:00',3.67),('9303','2013-08-05','13:35:00',3.64),('9303','2013-08-05','13:40:00',3.63),('9303','2013-08-05','13:45:00',3.58),('9303','2013-08-05','13:50:00',3.5),('9303','2013-08-05','13:55:00',3.56),('9303','2013-08-05','14:00:00',3.59),('9303','2013-08-05','14:05:00',3.61),('9303','2013-08-05','14:10:00',3.55),('9303','2013-08-05','14:15:00',3.53),('9303','2013-08-05','14:20:00',3.51),('9303','2013-08-05','14:25:00',3.48),('9303','2013-08-05','14:30:00',3.49),('9303','2013-08-05','14:35:00',3.46),('9303','2013-08-05','14:40:00',3.46),('9303','2013-08-05','14:45:00',3.41),('9303','2013-08-05','14:50:00',3.39),('9303','2013-08-05','14:55:00',3.34),('9303','2013-08-05','15:00:00',3.32),('9303','2013-08-05','15:05:00',3.31),('9303','2013-08-05','15:10:00',3.3),('9303','2013-08-05','15:15:00',3.25),('9303','2013-08-05','15:20:00',3.2),('9303','2013-08-05','15:25:00',3.19),('9303','2013-08-05','15:30:00',3.17),('9303','2013-08-05','15:35:00',3.13),('9303','2013-08-05','15:40:00',3.07),('9303','2013-08-05','15:45:00',3),('9303','2013-08-05','15:50:00',2.95),('9303','2013-08-05','15:55:00',2.92),('9303','2013-08-05','16:00:00',2.88),('9303','2013-08-05','16:05:00',2.85),('9303','2013-08-05','16:10:00',2.79),('9303','2013-08-05','16:15:00',2.73),('9303','2013-08-05','16:20:00',2.66),('9303','2013-08-05','16:25:00',2.59),('9303','2013-08-05','16:30:00',2.55),('9303','2013-08-05','16:35:00',2.51),('9303','2013-08-05','16:40:00',2.44),('9303','2013-08-05','16:45:00',2.38),('9303','2013-08-05','16:50:00',2.31),('9303','2013-08-05','16:55:00',2.23),('9303','2013-08-05','17:00:00',2.16),('9303','2013-08-05','17:05:00',2.07),('9303','2013-08-05','17:10:00',1.96),('9303','2013-08-05','17:15:00',1.86),('9303','2013-08-05','17:20:00',1.79),('9303','2013-08-05','17:25:00',1.71),('9303','2013-08-05','17:30:00',1.64),('9303','2013-08-05','17:35:00',1.56),('9303','2013-08-05','17:40:00',1.5),('9303','2013-08-05','17:45:00',1.43),('9303','2013-08-05','17:50:00',1.36),('9303','2013-08-05','17:55:00',1.27),('9303','2013-08-05','18:00:00',1.17),('9303','2013-08-05','18:05:00',1.07),('9303','2013-08-04','08:05:00',1.01),('9303','2013-08-04','08:10:00',1.09),('9303','2013-08-04','08:15:00',1.19),('9303','2013-08-04','08:20:00',1.29),('9303','2013-08-04','08:25:00',1.36),('9303','2013-08-04','08:30:00',1.47),('9303','2013-08-04','08:35:00',1.57),('9303','2013-08-04','08:40:00',1.64),('9303','2013-08-04','08:45:00',1.73),('9303','2013-08-04','08:50:00',1.81),('9303','2013-08-04','08:55:00',1.88),('9303','2013-08-04','09:00:00',1.95),('9303','2013-08-04','09:05:00',2.02),('9303','2013-08-04','09:10:00',2.09),('9303','2013-08-04','09:15:00',2.16),('9303','2013-08-04','09:20:00',2.22),('9303','2013-08-04','09:25:00',2.3),('9303','2013-08-04','09:30:00',2.35),('9303','2013-08-04','09:35:00',2.43),('9303','2013-08-04','09:40:00',2.5),('9303','2013-08-04','09:45:00',2.55),('9303','2013-08-04','09:50:00',2.6),('9303','2013-08-04','09:55:00',2.67),('9303','2013-08-04','10:00:00',2.72),('9303','2013-08-04','10:05:00',2.77),('9303','2013-08-04','10:10:00',2.83),('9303','2013-08-04','10:15:00',2.87),('9303','2013-08-04','10:20:00',2.92),('9303','2013-08-04','10:25:00',2.97),('9303','2013-08-04','10:30:00',3.01),('9303','2013-08-04','10:35:00',3.05),('9303','2013-08-04','10:40:00',3.09),('9303','2013-08-04','10:45:00',3.13),('9303','2013-08-04','10:50:00',3.16),('9303','2013-08-04','10:55:00',3.18),('9303','2013-08-04','11:00:00',3.23),('9303','2013-08-04','11:05:00',3.29),('9303','2013-08-04','11:10:00',3.3),('9303','2013-08-04','11:15:00',3.32),('9303','2013-08-04','11:20:00',3.38),('9303','2013-08-04','11:25:00',3.45),('9303','2013-08-04','11:30:00',3.49),('9303','2013-08-04','11:35:00',3.51),('9303','2013-08-04','11:40:00',3.53),('9303','2013-08-04','11:45:00',3.53),('9303','2013-08-04','11:50:00',3.58),('9303','2013-08-04','11:55:00',3.61),('9303','2013-08-04','12:00:00',3.63),('9303','2013-08-04','12:05:00',3.65),('9303','2013-08-04','12:10:00',3.65),('9303','2013-08-04','12:15:00',3.64),('9303','2013-08-04','12:20:00',3.66),('9303','2013-08-04','12:25:00',3.68),('9303','2013-08-04','12:30:00',3.7),('9303','2013-08-04','12:35:00',3.71),('9303','2013-08-04','12:40:00',3.73),('9303','2013-08-04','12:45:00',3.74),('9303','2013-08-04','12:50:00',3.72),('9303','2013-08-04','12:55:00',3.72),('9303','2013-08-04','13:00:00',3.77),('9303','2013-08-04','13:05:00',3.72),('9303','2013-08-04','13:10:00',3.69),('9303','2013-08-04','13:15:00',3.73),('9303','2013-08-04','13:20:00',3.67),('9303','2013-08-04','13:25:00',3.66),('9303','2013-08-04','13:30:00',3.68),('9303','2013-08-04','13:35:00',3.76),('9303','2013-08-04','13:40:00',3.78),('9303','2013-08-04','13:45:00',3.8),('9303','2013-08-04','13:50:00',3.76),('9303','2013-08-04','13:55:00',3.76),('9303','2013-08-04','14:00:00',3.76),('9303','2013-08-04','14:05:00',3.75),('9303','2013-08-04','14:10:00',3.71),('9303','2013-08-04','14:15:00',3.69),('9303','2013-08-04','14:20:00',3.67),('9303','2013-08-04','14:25:00',3.65),('9303','2013-08-04','14:30:00',3.64),('9303','2013-08-04','14:35:00',3.64),('9303','2013-08-04','14:40:00',3.62),('9303','2013-08-04','14:45:00',3.55),('9303','2013-08-04','14:50:00',2.99),('9303','2013-08-04','14:55:00',3.53),('9303','2013-08-04','15:00:00',3.5),('9303','2013-08-04','15:05:00',3.45),('9303','2013-08-04','15:10:00',3.45),('9303','2013-08-04','15:15:00',3.4),('9303','2013-08-04','15:20:00',3.36),('9303','2013-08-04','15:25:00',3.29),('9303','2013-08-04','15:30:00',3.21),('9303','2013-08-04','15:35:00',3.24),('9303','2013-08-04','15:40:00',3.17),('9303','2013-08-04','15:45:00',3.14),('9303','2013-08-04','15:50:00',3.07),('9303','2013-08-04','15:55:00',3.01),('9303','2013-08-04','16:00:00',2.97),('9303','2013-08-04','16:05:00',2.91),('9303','2013-08-04','16:10:00',2.86),('9303','2013-08-04','16:15:00',2.82),('9303','2013-08-04','16:20:00',2.79),('9303','2013-08-04','16:25:00',2.72),('9303','2013-08-04','16:30:00',2.65),('9303','2013-08-04','16:35:00',2.58),('9303','2013-08-04','16:40:00',2.53),('9303','2013-08-04','16:45:00',2.44),('9303','2013-08-04','16:50:00',2.37),('9303','2013-08-04','16:55:00',2.32),('9303','2013-08-04','17:00:00',2.24),('9303','2013-08-04','17:05:00',2.17),('9303','2013-08-04','17:10:00',2.07),('9303','2013-08-04','17:15:00',1.95),('9303','2013-08-04','17:20:00',1.86),('9303','2013-08-04','17:25:00',1.78),('9303','2013-08-04','17:30:00',1.71),('9303','2013-08-04','17:35:00',1.63),('9303','2013-08-04','17:40:00',1.55),('9303','2013-08-04','17:45:00',1.48),('9303','2013-08-04','17:50:00',1.41),('9303','2013-08-04','17:55:00',1.31),('9303','2013-08-04','18:00:00',1.22),('9303','2013-08-04','18:05:00',1.12),('9303','2013-08-04','18:10:00',1.04),('9303','2013-08-03','08:05:00',1.01),('9303','2013-08-03','08:10:00',1.09),('9303','2013-08-03','08:15:00',1.17),('9303','2013-08-03','08:20:00',1.27),('9303','2013-08-03','08:25:00',1.35),('9303','2013-08-03','08:30:00',1.44),('9303','2013-08-03','08:35:00',1.54),('9303','2013-08-03','08:40:00',1.62),('9303','2013-08-03','08:45:00',1.7),('9303','2013-08-03','08:50:00',1.77),('9303','2013-08-03','08:55:00',1.85),('9303','2013-08-03','09:00:00',1.94),('9303','2013-08-03','09:05:00',2.01),('9303','2013-08-03','09:10:00',2.07),('9303','2013-08-03','09:15:00',2.15),('9303','2013-08-03','09:20:00',2.22),('9303','2013-08-03','09:25:00',2.28),('9303','2013-08-03','09:30:00',2.35),('9303','2013-08-03','09:35:00',2.41),('9303','2013-08-03','09:40:00',2.46),('9303','2013-08-03','09:45:00',2.53),('9303','2013-08-03','09:50:00',2.59),('9303','2013-08-03','09:55:00',2.65),('9303','2013-08-03','10:00:00',2.71),('9303','2013-08-03','10:05:00',2.76),('9303','2013-08-03','10:10:00',2.82),('9303','2013-08-03','10:15:00',2.84),('9303','2013-08-03','10:20:00',2.85),('9303','2013-08-03','10:25:00',2.94),('9303','2013-08-03','10:30:00',2.98),('9303','2013-08-03','10:35:00',3.06),('9303','2013-08-03','10:40:00',3.13),('9303','2013-08-03','10:45:00',3.14),('9303','2013-08-03','10:50:00',3.18),('9303','2013-08-03','10:55:00',3.23),('9303','2013-08-03','11:00:00',3.29),('9303','2013-08-03','11:05:00',3.3),('9303','2013-08-03','11:10:00',3.36),('9303','2013-08-03','11:15:00',3.36),('9303','2013-08-03','11:20:00',3.38),('9303','2013-08-03','11:25:00',3.43),('9303','2013-08-03','11:30:00',3.45),('9303','2013-08-03','11:35:00',3.46),('9303','2013-08-03','11:40:00',3.47),('9303','2013-08-03','11:45:00',3.5),('9303','2013-08-03','11:50:00',3.57),('9303','2013-08-03','11:55:00',3.58),('9303','2013-08-03','12:00:00',3.58),('9303','2013-08-03','12:05:00',3.61),('9303','2013-08-03','12:10:00',3.6),('9303','2013-08-03','12:15:00',3.65),('9303','2013-08-03','12:20:00',3.62),('9303','2013-08-03','12:25:00',3.63),('9303','2013-08-03','12:30:00',3.62),('9303','2013-08-03','12:35:00',3.62),('9303','2013-08-03','12:40:00',3.62),('9303','2013-08-03','12:45:00',3.67),('9303','2013-08-03','12:50:00',3.73),('9303','2013-08-03','12:55:00',3.69),('9303','2013-08-03','13:00:00',3.67),('9303','2013-08-03','13:05:00',3.63),('9303','2013-08-03','13:10:00',3.68),('9303','2013-08-03','13:15:00',3.64),('9303','2013-08-03','13:20:00',3.57),('9303','2013-08-03','13:25:00',3.61),('9303','2013-08-03','13:30:00',3.57),('9303','2013-08-03','13:35:00',3.53),('9303','2013-08-03','13:40:00',3.59),('9303','2013-08-03','13:45:00',3.63),('9303','2013-08-03','13:50:00',3.65),('9303','2013-08-03','13:55:00',3.69),('9303','2013-08-03','14:00:00',3.73),('9303','2013-08-03','14:05:00',3.71),('9303','2013-08-03','14:10:00',3.57),('9303','2013-08-03','14:15:00',3.45),('9303','2013-08-03','14:20:00',3.45),('9303','2013-08-03','14:25:00',3.41),('9303','2013-08-03','14:30:00',3.48),('9303','2013-08-03','14:35:00',3.57),('9303','2013-08-03','14:40:00',3.52),('9303','2013-08-03','14:45:00',3.53),('9303','2013-08-03','14:50:00',3.51),('9303','2013-08-03','14:55:00',3.5),('9303','2013-08-03','15:00:00',3.48),('9303','2013-08-03','15:05:00',3.42),('9303','2013-08-03','15:10:00',3.38),('9303','2013-08-03','15:15:00',3.32),('9303','2013-08-03','15:20:00',3.31),('9303','2013-08-03','15:25:00',3.31),('9303','2013-08-03','15:30:00',3.24),('9303','2013-08-03','15:35:00',3.22),('9303','2013-08-03','15:40:00',3.17),('9303','2013-08-03','15:45:00',3.12),('9303','2013-08-03','15:50:00',3.1),('9303','2013-08-03','15:55:00',3.03),('9303','2013-08-03','16:00:00',2.95),('9303','2013-08-03','16:05:00',2.91),('9303','2013-08-03','16:10:00',2.84),('9303','2013-08-03','16:15:00',2.76),('9303','2013-08-03','16:20:00',2.71),('9303','2013-08-03','16:25:00',2.66),('9303','2013-08-03','16:30:00',2.62),('9303','2013-08-03','16:35:00',2.55),('9303','2013-08-03','16:40:00',2.5),('9303','2013-08-03','16:45:00',2.44),('9303','2013-08-03','16:50:00',2.38),('9303','2013-08-03','16:55:00',2.32),('9303','2013-08-03','17:00:00',2.24),('9303','2013-08-03','17:05:00',2.16),('9303','2013-08-03','17:10:00',2.04),('9303','2013-08-03','17:15:00',1.94),('9303','2013-08-03','17:20:00',1.86),('9303','2013-08-03','17:25:00',1.79),('9303','2013-08-03','17:30:00',1.72),('9303','2013-08-03','17:35:00',1.66),('9303','2013-08-03','17:40:00',1.57),('9303','2013-08-03','17:45:00',1.5),('9303','2013-08-03','17:50:00',1.42),('9303','2013-08-03','17:55:00',1.34),('9303','2013-08-03','18:00:00',1.24),('9303','2013-08-03','18:05:00',1.14),('9303','2013-08-03','18:10:00',1.07),('9303','2013-08-02','08:05:00',1.07),('9303','2013-08-02','08:10:00',1.15),('9303','2013-08-02','08:15:00',1.25),('9303','2013-08-02','08:20:00',1.33),('9303','2013-08-02','08:25:00',1.42),('9303','2013-08-02','08:30:00',1.52),('9303','2013-08-02','08:35:00',1.61),('9303','2013-08-02','08:40:00',1.71),('9303','2013-08-02','08:45:00',1.79),('9303','2013-08-02','08:50:00',1.85),('9303','2013-08-02','08:55:00',1.93),('9303','2013-08-02','09:00:00',2.01),('9303','2013-08-02','09:05:00',2.08),('9303','2013-08-02','09:10:00',2.14),('9303','2013-08-02','09:15:00',2.23),('9303','2013-08-02','09:20:00',2.3),('9303','2013-08-02','09:25:00',2.36),('9303','2013-08-02','09:30:00',2.42),('9303','2013-08-02','09:35:00',2.49),('9303','2013-08-02','09:40:00',2.53),('9303','2013-08-02','09:45:00',2.59),('9303','2013-08-02','09:50:00',2.65),('9303','2013-08-02','09:55:00',2.7),('9303','2013-08-02','10:00:00',2.74),('9303','2013-08-02','10:05:00',2.8),('9303','2013-08-02','10:10:00',2.86),('9303','2013-08-02','10:15:00',2.92),('9303','2013-08-02','10:20:00',2.98),('9303','2013-08-02','10:25:00',3.02),('9303','2013-08-02','10:30:00',3.05),('9303','2013-08-02','10:35:00',3.11),('9303','2013-08-02','10:40:00',3.16),('9303','2013-08-02','10:45:00',3.19),('9303','2013-08-02','10:50:00',3.23),('9303','2013-08-02','10:55:00',3.28),('9303','2013-08-02','11:00:00',3.3),('9303','2013-08-02','11:05:00',3.34),('9303','2013-08-02','11:10:00',3.35),('9303','2013-08-02','11:15:00',3.39),('9303','2013-08-02','11:20:00',3.42),('9303','2013-08-02','11:25:00',3.5),('9303','2013-08-02','11:30:00',3.54),('9303','2013-08-02','11:35:00',3.54),('9303','2013-08-02','11:40:00',3.52),('9303','2013-08-02','11:45:00',3.61),('9303','2013-08-02','11:50:00',3.61),('9303','2013-08-02','11:55:00',3.69),('9303','2013-08-02','12:00:00',3.71),('9303','2013-08-02','12:05:00',3.72),('9303','2013-08-02','12:10:00',3.72),('9303','2013-08-02','12:15:00',3.69),('9303','2013-08-02','12:20:00',3.67),('9303','2013-08-02','12:25:00',3.69),('9303','2013-08-02','12:30:00',3.7),('9303','2013-08-02','12:35:00',3.71),('9303','2013-08-02','12:40:00',3.72),('9303','2013-08-02','12:45:00',3.72),('9303','2013-08-02','12:50:00',3.72),('9303','2013-08-02','12:55:00',3.7),('9303','2013-08-02','13:00:00',3.73),('9303','2013-08-02','13:05:00',3.78),('9303','2013-08-02','13:10:00',3.81),('9303','2013-08-02','13:15:00',3.8),('9303','2013-08-02','13:20:00',3.79),('9303','2013-08-02','13:25:00',3.78),('9303','2013-08-02','13:30:00',3.8),('9303','2013-08-02','13:35:00',3.8),('9303','2013-08-02','13:40:00',3.76),('9303','2013-08-02','13:45:00',3.71),('9303','2013-08-02','13:50:00',3.74),('9303','2013-08-02','13:55:00',3.74),('9303','2013-08-02','14:00:00',3.7),('9303','2013-08-02','14:05:00',3.67),('9303','2013-08-02','14:10:00',3.68),('9303','2013-08-02','14:15:00',3.64),('9303','2013-08-02','14:20:00',3.62),('9303','2013-08-02','14:25:00',3.57),('9303','2013-08-02','14:30:00',3.62),('9303','2013-08-02','14:35:00',3.64),('9303','2013-08-02','14:40:00',3.6),('9303','2013-08-02','14:45:00',3.6),('9303','2013-08-02','14:50:00',3.58),('9303','2013-08-02','14:55:00',3.55),('9303','2013-08-02','15:00:00',3.52),('9303','2013-08-02','15:05:00',3.51),('9303','2013-08-02','15:10:00',3.42),('9303','2013-08-02','15:15:00',3.34),('9303','2013-08-02','15:20:00',3.34),('9303','2013-08-02','15:25:00',3.33),('9303','2013-08-02','15:30:00',3.32),('9303','2013-08-02','15:35:00',3.28),('9303','2013-08-02','15:40:00',3.23),('9303','2013-08-02','15:45:00',3.2),('9303','2013-08-02','15:50:00',3.15),('9303','2013-08-02','15:55:00',3.06),('9303','2013-08-02','16:00:00',3),('9303','2013-08-02','16:05:00',2.96),('9303','2013-08-02','16:10:00',2.91),('9303','2013-08-02','16:15:00',2.84),('9303','2013-08-02','16:20:00',2.79),('9303','2013-08-02','16:25:00',2.72),('9303','2013-08-02','16:30:00',2.69),('9303','2013-08-02','16:35:00',2.64),('9303','2013-08-02','16:40:00',2.58),('9303','2013-08-02','16:45:00',2.52),('9303','2013-08-02','16:50:00',2.46),('9303','2013-08-02','16:55:00',2.37),('9303','2013-08-02','17:00:00',2.28),('9303','2013-08-02','17:05:00',2.19),('9303','2013-08-02','17:10:00',2.09),('9303','2013-08-02','17:15:00',2.01),('9303','2013-08-02','17:20:00',1.92),('9303','2013-08-02','17:25:00',1.86),('9303','2013-08-02','17:30:00',1.77),('9303','2013-08-02','17:35:00',1.69),('9303','2013-08-02','17:40:00',1.63),('9303','2013-08-02','17:45:00',1.54),('9303','2013-08-02','17:50:00',1.45),('9303','2013-08-02','17:55:00',1.38),('9303','2013-08-02','18:00:00',1.27),('9303','2013-08-02','18:05:00',1.19),('9303','2013-08-02','18:10:00',1.12),('9303','2013-08-02','18:15:00',1.02),('9303','2013-08-01','08:05:00',1.08),('9303','2013-08-01','08:10:00',1.16),('9303','2013-08-01','08:15:00',1.25),('9303','2013-08-01','08:20:00',1.35),('9303','2013-08-01','08:25:00',1.45),('9303','2013-08-01','08:30:00',1.55),('9303','2013-08-01','08:35:00',1.64),('9303','2013-08-01','08:40:00',1.75),('9303','2013-08-01','08:45:00',1.82),('9303','2013-08-01','08:50:00',1.91),('9303','2013-08-01','08:55:00',1.99),('9303','2013-08-01','09:00:00',2.06),('9303','2013-08-01','09:05:00',2.13),('9303','2013-08-01','09:10:00',2.21),('9303','2013-08-01','09:15:00',2.28),('9303','2013-08-01','09:20:00',2.36),('9303','2013-08-01','09:25:00',2.43),('9303','2013-08-01','09:30:00',2.49),('9303','2013-08-01','09:35:00',2.55),('9303','2013-08-01','09:40:00',2.62),('9303','2013-08-01','09:45:00',2.69),('9303','2013-08-01','09:50:00',2.76),('9303','2013-08-01','09:55:00',2.82),('9303','2013-08-01','10:00:00',2.9),('9303','2013-08-01','10:05:00',2.98),('9303','2013-08-01','10:10:00',3.05),('9303','2013-08-01','10:15:00',3.08),('9303','2013-08-01','10:20:00',3.12),('9303','2013-08-01','10:25:00',3.16),('9303','2013-08-01','10:30:00',3.22),('9303','2013-08-01','10:35:00',3.27),('9303','2013-08-01','10:40:00',3.31),('9303','2013-08-01','10:45:00',3.37),('9303','2013-08-01','10:50:00',3.43),('9303','2013-08-01','10:55:00',3.46),('9303','2013-08-01','11:00:00',3.5),('9303','2013-08-01','11:05:00',3.56),('9303','2013-08-01','11:10:00',3.6),('9303','2013-08-01','11:15:00',3.63),('9303','2013-08-01','11:20:00',3.66),('9303','2013-08-01','11:25:00',3.72),('9303','2013-08-01','11:30:00',3.73),('9303','2013-08-01','11:35:00',3.75),('9303','2013-08-01','11:40:00',3.8),('9303','2013-08-01','11:45:00',3.82),('9303','2013-08-01','11:50:00',3.85),('9303','2013-08-01','11:55:00',3.86),('9303','2013-08-01','12:00:00',3.9),('9303','2013-08-01','12:05:00',3.91),('9303','2013-08-01','12:10:00',3.91),('9303','2013-08-01','12:15:00',3.97),('9303','2013-08-01','12:20:00',3.96),('9303','2013-08-01','12:25:00',3.97),('9303','2013-08-01','12:30:00',3.97),('9303','2013-08-01','12:35:00',4.01),('9303','2013-08-01','12:40:00',4.02),('9303','2013-08-01','12:45:00',4.02),('9303','2013-08-01','12:50:00',4.05),('9303','2013-08-01','12:55:00',4.05),('9303','2013-08-01','13:00:00',4.03),('9303','2013-08-01','13:05:00',4.01),('9303','2013-08-01','13:10:00',4.01),('9303','2013-08-01','13:15:00',3.98),('9303','2013-08-01','13:20:00',4.02),('9303','2013-08-01','13:25:00',4.05),('9303','2013-08-01','13:30:00',3.92),('9303','2013-08-01','13:35:00',4.02),('9303','2013-08-01','13:40:00',4.06),('9303','2013-08-01','13:45:00',4.07),('9303','2013-08-01','13:50:00',4.08),('9303','2013-08-01','13:55:00',3.96),('9303','2013-08-01','14:00:00',4.02),('9303','2013-08-01','14:05:00',3.94),('9303','2013-08-01','14:10:00',3.9),('9303','2013-08-01','14:15:00',3.91),('9303','2013-08-01','14:20:00',3.86),('9303','2013-08-01','14:25:00',3.82),('9303','2013-08-01','14:30:00',3.78),('9303','2013-08-01','14:35:00',3.11),('9303','2013-08-01','14:40:00',3.16),('9303','2013-08-01','14:45:00',3.48),('9303','2013-08-01','14:50:00',2.27),('9303','2013-08-01','14:55:00',3.68),('9303','2013-08-01','15:00:00',3.62),('9303','2013-08-01','15:05:00',3.63),('9303','2013-08-01','15:10:00',3.36),('9303','2013-08-01','15:15:00',3.41),('9303','2013-08-01','15:20:00',3.6),('9303','2013-08-01','15:25:00',3.53),('9303','2013-08-01','15:30:00',3.43),('9303','2013-08-01','15:35:00',3.17),('9303','2013-08-01','15:40:00',2.04),('9303','2013-08-01','15:45:00',3.31),('9303','2013-08-01','15:50:00',3.26),('9303','2013-08-01','15:55:00',3.22),('9303','2013-08-01','16:00:00',3.19),('9303','2013-08-01','16:05:00',3.13),('9303','2013-08-01','16:10:00',3.03),('9303','2013-08-01','16:15:00',2.95),('9303','2013-08-01','16:20:00',2.93),('9303','2013-08-01','16:25:00',2.86),('9303','2013-08-01','16:30:00',2.78),('9303','2013-08-01','16:35:00',2.72),('9303','2013-08-01','16:40:00',2.64),('9303','2013-08-01','16:45:00',2.58),('9303','2013-08-01','16:50:00',2.51),('9303','2013-08-01','16:55:00',2.45),('9303','2013-08-01','17:00:00',2.37),('9303','2013-08-01','17:05:00',2.29),('9303','2013-08-01','17:10:00',2.17),('9303','2013-08-01','17:15:00',2.06),('9303','2013-08-01','17:20:00',1.96),('9303','2013-08-01','17:25:00',1.88),('9303','2013-08-01','17:30:00',1.83),('9303','2013-08-01','17:35:00',1.74),('9303','2013-08-01','17:40:00',1.67),('9303','2013-08-01','17:45:00',1.59),('9303','2013-08-01','17:50:00',1.52),('9303','2013-08-01','17:55:00',1.44),('9303','2013-08-01','18:00:00',1.3),('9303','2013-08-01','18:05:00',1.24),('9303','2013-08-01','18:10:00',1.15),('9303','2013-08-01','18:15:00',1.07),('9303','2013-07-31','08:00:00',1.01),('9303','2013-07-31','08:05:00',1.11),('9303','2013-07-31','08:10:00',1.2),('9303','2013-07-31','08:15:00',1.3),('9303','2013-07-31','08:20:00',1.39),('9303','2013-07-31','08:25:00',1.48),('9303','2013-07-31','08:30:00',1.57),('9303','2013-07-31','08:35:00',1.67),('9303','2013-07-31','08:40:00',1.77),('9303','2013-07-31','08:45:00',1.86),('9303','2013-07-31','08:50:00',1.93),('9303','2013-07-31','08:55:00',2.01),('9303','2013-07-31','09:00:00',2.09),('9303','2013-07-31','09:05:00',2.16),('9303','2013-07-31','09:10:00',2.25),('9303','2013-07-31','09:15:00',2.31),('9303','2013-07-31','09:20:00',2.38),('9303','2013-07-31','09:25:00',2.44),('9303','2013-07-31','09:30:00',2.51),('9303','2013-07-31','09:35:00',2.59),('9303','2013-07-31','09:40:00',2.64),('9303','2013-07-31','09:45:00',2.71),('9303','2013-07-31','09:50:00',2.77),('9303','2013-07-31','09:55:00',2.84),('9303','2013-07-31','10:00:00',2.88),('9303','2013-07-31','10:05:00',2.94),('9303','2013-07-31','10:10:00',2.99),('9303','2013-07-31','10:15:00',3.08),('9303','2013-07-31','10:20:00',3.11),('9303','2013-07-31','10:25:00',3.13),('9303','2013-07-31','10:30:00',3.19),('9303','2013-07-31','10:35:00',3.27),('9303','2013-07-31','10:40:00',3.34),('9303','2013-07-31','10:45:00',3.38),('9303','2013-07-31','10:50:00',3.43),('9303','2013-07-31','10:55:00',3.46),('9303','2013-07-31','11:00:00',3.52),('9303','2013-07-31','11:05:00',3.56),('9303','2013-07-31','11:10:00',3.61),('9303','2013-07-31','11:15:00',3.63),('9303','2013-07-31','11:20:00',3.66),('9303','2013-07-31','11:25:00',3.7),('9303','2013-07-31','11:30:00',3.72),('9303','2013-07-31','11:35:00',3.76),('9303','2013-07-31','11:40:00',3.8),('9303','2013-07-31','11:45:00',3.83),('9303','2013-07-31','11:50:00',3.89),('9303','2013-07-31','11:55:00',3.91),('9303','2013-07-31','12:00:00',3.9),('9303','2013-07-31','12:05:00',3.91),('9303','2013-07-31','12:10:00',3.9),('9303','2013-07-31','12:15:00',3.93),('9303','2013-07-31','12:20:00',3.95),('9303','2013-07-31','12:25:00',4.03),('9303','2013-07-31','12:30:00',4.03),('9303','2013-07-31','12:35:00',4.02),('9303','2013-07-31','12:40:00',4.05),('9303','2013-07-31','12:45:00',3.28),('9303','2013-07-31','12:50:00',2.59),('9303','2013-07-31','12:55:00',4.02),('9303','2013-07-31','13:00:00',1.86),('9303','2013-07-31','13:05:00',3.86),('9303','2013-07-31','13:10:00',3.99),('9303','2013-07-31','13:15:00',4.12),('9303','2013-07-31','13:20:00',4.02),('9303','2013-07-31','13:25:00',3.89),('9303','2013-07-31','13:30:00',4.08),('9303','2013-07-31','13:35:00',4.05),('9303','2013-07-31','13:40:00',4.13),('9303','2013-07-31','13:45:00',4.21),('9303','2013-07-31','13:50:00',3.64),('9303','2013-07-31','13:55:00',2.17),('9303','2013-07-31','14:00:00',3.68),('9303','2013-07-31','14:05:00',4.11),('9303','2013-07-31','14:10:00',3.41),('9303','2013-07-31','14:15:00',4.08),('9303','2013-07-31','14:20:00',3.43),('9303','2013-07-31','14:25:00',4.01),('9303','2013-07-31','14:30:00',3.89),('9303','2013-07-31','14:35:00',3.83),('9303','2013-07-31','14:40:00',3.86),('9303','2013-07-31','14:45:00',3.83),('9303','2013-07-31','14:50:00',3.35),('9303','2013-07-31','14:55:00',1.85),('9303','2013-07-31','15:00:00',1.62),('9303','2013-07-31','15:05:00',3.84),('9303','2013-07-31','15:10:00',3.13),('9303','2013-07-31','15:15:00',2.4),('9303','2013-07-31','15:20:00',3.28),('9303','2013-07-31','15:25:00',2.55),('9303','2013-07-31','15:30:00',3.5),('9303','2013-07-31','15:35:00',3.14),('9303','2013-07-31','15:40:00',3.43),('9303','2013-07-31','15:45:00',3.35),('9303','2013-07-31','15:50:00',3.26),('9303','2013-07-31','15:55:00',3.18),('9303','2013-07-31','16:00:00',3.11),('9303','2013-07-31','16:05:00',3.11),('9303','2013-07-31','16:10:00',3.1),('9303','2013-07-31','16:15:00',3.05),('9303','2013-07-31','16:20:00',3.03),('9303','2013-07-31','16:25:00',3),('9303','2013-07-31','16:30:00',2.42),('9303','2013-07-31','16:35:00',2.08),('9303','2013-07-31','16:40:00',2.65),('9303','2013-07-31','16:45:00',2.56),('9303','2013-07-31','16:50:00',2.53),('9303','2013-07-31','16:55:00',2.46),('9303','2013-07-31','17:00:00',2.23),('9303','2013-07-31','17:05:00',2.32),('9303','2013-07-31','17:10:00',2.15),('9303','2013-07-31','17:15:00',1.8),('9303','2013-07-31','17:20:00',1.88),('9303','2013-07-31','17:25:00',1.91),('9303','2013-07-31','17:30:00',1.79),('9303','2013-07-31','17:35:00',1.71),('9303','2013-07-31','17:40:00',1.67),('9303','2013-07-31','17:45:00',1.57),('9303','2013-07-31','17:50:00',1.52),('9303','2013-07-31','17:55:00',1.42),('9303','2013-07-31','18:00:00',1.3),('9303','2013-07-31','18:05:00',1.25),('9303','2013-07-31','18:10:00',1.17),('9303','2013-07-31','18:15:00',1.09),('9303','2013-07-31','18:20:00',1.02),('9303','2014-04-08','08:15:00',1.15),('9303','2014-04-08','08:20:00',1.23),('9303','2014-04-08','08:25:00',1.05),('9303','2014-04-08','08:35:00',1.19),('9303','2014-04-08','08:40:00',1.41),('9303','2014-04-08','08:45:00',1.53),('9303','2014-04-08','08:50:00',1.6),('9303','2014-04-08','08:55:00',1.72),('9303','2014-04-08','09:00:00',1.82),('9303','2014-04-08','09:05:00',1.88),('9303','2014-04-08','09:10:00',1.96),('9303','2014-04-08','09:15:00',2.05),('9303','2014-04-08','09:20:00',2.13),('9303','2014-04-08','09:25:00',2.21),('9303','2014-04-08','09:30:00',2.28),('9303','2014-04-08','09:35:00',2.36),('9303','2014-04-08','09:40:00',2.39),('9303','2014-04-08','09:45:00',2.46),('9303','2014-04-08','09:50:00',2.53),('9303','2014-04-08','09:55:00',2.55),('9303','2014-04-08','10:00:00',2.59),('9303','2014-04-08','10:05:00',2.62),('9303','2014-04-08','10:10:00',2.66),('9303','2014-04-08','10:15:00',2.87),('9303','2014-04-08','10:20:00',2.92),('9303','2014-04-08','10:25:00',2.99),('9303','2014-04-08','10:30:00',3.03),('9303','2014-04-08','10:35:00',3.05),('9303','2014-04-08','10:40:00',3.06),('9303','2014-04-08','10:45:00',3.16),('9303','2014-04-08','10:50:00',3.29),('9303','2014-04-08','10:55:00',3.27),('9303','2014-04-08','11:00:00',3.23),('9303','2014-04-08','11:05:00',3.33),('9303','2014-04-08','11:10:00',3.45),('9303','2014-04-08','11:15:00',3.39),('9303','2014-04-08','11:20:00',3.56),('9303','2014-04-08','11:25:00',3.63),('9303','2014-04-08','11:30:00',3.62),('9303','2014-04-08','11:35:00',3.39),('9303','2014-04-08','11:40:00',3.62),('9303','2014-04-08','11:45:00',3.7),('9303','2014-04-08','11:50:00',3.54),('9303','2014-04-08','11:55:00',3.67),('9303','2014-04-08','12:00:00',3.79),('9303','2014-04-08','12:05:00',3.66),('9303','2014-04-08','12:10:00',3.46),('9303','2014-04-08','12:15:00',3.43),('9303','2014-04-08','12:20:00',3.5),('9303','2014-04-08','12:25:00',3.41),('9303','2014-04-08','12:30:00',4.2),('9303','2014-04-08','12:35:00',3.93),('9303','2014-04-08','12:40:00',3.4),('9303','2014-04-08','12:45:00',2.97),('9303','2014-04-08','12:50:00',3.52),('9303','2014-04-08','12:55:00',3.91),('9303','2014-04-08','13:00:00',3.69),('9303','2014-04-08','13:05:00',4),('9303','2014-04-08','13:10:00',4.02),('9303','2014-04-08','13:15:00',4.08),('9303','2014-04-08','13:20:00',4.02),('9303','2014-04-08','13:25:00',4.02),('9303','2014-04-08','13:30:00',4.07),('9303','2014-04-08','13:35:00',4.04),('9303','2014-04-08','13:40:00',4.04),('9303','2014-04-08','13:45:00',3.97),('9303','2014-04-08','13:50:00',4.02),('9303','2014-04-08','13:55:00',4.02),('9303','2014-04-08','14:00:00',3.97),('9303','2014-04-08','14:05:00',3.93),('9303','2014-04-08','14:10:00',3.92),('9303','2014-04-08','14:15:00',3.95),('9303','2014-04-08','14:20:00',3.73),('9303','2014-04-08','14:25:00',3.77),('9303','2014-04-08','14:30:00',3.87),('9303','2014-04-08','14:35:00',3.59),('9303','2014-04-08','14:40:00',3.45),('9303','2014-04-08','14:45:00',3.2),('9303','2014-04-08','14:50:00',3.64),('9303','2014-04-08','14:55:00',3.74),('9303','2014-04-08','15:00:00',3.65),('9303','2014-04-08','15:05:00',3.56),('9303','2014-04-08','15:10:00',3.58),('9303','2014-04-08','15:15:00',3.51),('9303','2014-04-08','15:20:00',3.41),('9303','2014-04-08','15:25:00',3.39),('9303','2014-04-08','15:30:00',3.23),('9303','2014-04-08','15:35:00',3.27),('9303','2014-04-08','15:40:00',3.21),('9303','2014-04-08','15:45:00',3.01),('9303','2014-04-08','15:50:00',3.08),('9303','2014-04-08','15:55:00',3.05),('9303','2014-04-08','16:00:00',2.92),('9303','2014-04-08','16:05:00',2.85),('9303','2014-04-08','16:10:00',2.72),('9303','2014-04-08','16:15:00',2.59),('9303','2014-04-08','16:20:00',2.34),('9303','2014-04-08','16:25:00',2.57),('9303','2014-04-08','16:30:00',2.63),('9303','2014-04-08','16:35:00',2.6),('9303','2014-04-08','16:40:00',2.4),('9303','2014-04-08','16:45:00',2.24),('9303','2014-04-08','16:50:00',2.1),('9303','2014-04-08','16:55:00',1.96),('9303','2014-04-08','17:00:00',1.85),('9303','2014-04-08','17:05:00',1.95),('9303','2014-04-08','17:10:00',1.82),('9303','2014-04-08','17:15:00',1.76),('9303','2014-04-08','17:20:00',1.68),('9303','2014-04-08','17:25:00',1.56),('9303','2014-04-08','17:30:00',1.42),('9303','2014-04-08','17:35:00',1.23),('9303','2014-04-08','17:40:00',1.22),('9303','2014-04-08','17:45:00',1.1),('9303','2014-04-08','17:50:00',1.07),('9303','2013-07-30','08:05:00',1.08),('9303','2013-07-30','08:10:00',1.19),('9303','2013-07-30','08:15:00',1.27),('9303','2013-07-30','08:20:00',1.44),('9303','2013-07-30','08:25:00',1.52),('9303','2013-07-30','08:30:00',1.56),('9303','2013-07-30','08:35:00',1.64),('9303','2013-07-30','08:40:00',1.71),('9303','2013-07-30','08:45:00',1.8),('9303','2013-07-30','08:50:00',1.88),('9303','2013-07-30','08:55:00',1.97),('9303','2013-07-30','09:00:00',2.06),('9303','2013-07-30','09:05:00',2.16),('9303','2013-07-30','09:10:00',2.22),('9303','2013-07-30','09:15:00',2.34),('9303','2013-07-30','09:20:00',2.5),('9303','2013-07-30','09:25:00',2.55),('9303','2013-07-30','09:30:00',2.58),('9303','2013-07-30','09:35:00',2.66),('9303','2013-07-30','09:40:00',2.75),('9303','2013-07-30','09:45:00',2.7),('9303','2013-07-30','09:50:00',2.73),('9303','2013-07-30','09:55:00',2.89),('9303','2013-07-30','10:00:00',2.62),('9303','2013-07-30','10:05:00',2.94),('9303','2013-07-30','10:10:00',3.07),('9303','2013-07-30','10:15:00',2.95),('9303','2013-07-30','10:20:00',3.08),('9303','2013-07-30','10:25:00',3.23),('9303','2013-07-30','10:30:00',3.21),('9303','2013-07-30','10:35:00',3.26),('9303','2013-07-30','10:40:00',3.29),('9303','2013-07-30','10:45:00',3.35),('9303','2013-07-30','10:50:00',3.33),('9303','2013-07-30','10:55:00',3.34),('9303','2013-07-30','11:00:00',3.43),('9303','2013-07-30','11:05:00',3.53),('9303','2013-07-30','11:10:00',3.34),('9303','2013-07-30','11:15:00',2.5),('9303','2013-07-30','11:20:00',2.76),('9303','2013-07-30','11:25:00',3.55),('9303','2013-07-30','11:30:00',3.67),('9303','2013-07-30','11:35:00',1.76),('9303','2013-07-30','11:40:00',3.41),('9303','2013-07-30','11:45:00',3.79),('9303','2013-07-30','11:50:00',3.87),('9303','2013-07-30','11:55:00',3.86),('9303','2013-07-30','12:00:00',3.77),('9303','2013-07-30','12:05:00',3.75),('9303','2013-07-30','12:10:00',3.72),('9303','2013-07-30','12:15:00',3.69),('9303','2013-07-30','12:20:00',3.72),('9303','2013-07-30','12:25:00',3.79),('9303','2013-07-30','12:30:00',3.9),('9303','2013-07-30','12:35:00',3.99),('9303','2013-07-30','12:40:00',2.73),('9303','2013-07-30','12:45:00',3.01),('9303','2013-07-30','12:50:00',4.06),('9303','2013-07-30','12:55:00',4.16),('9303','2013-07-30','13:00:00',2.18),('9303','2013-07-30','13:05:00',4.24),('9303','2013-07-30','13:10:00',4.05),('9303','2013-07-30','13:15:00',4.19),('9303','2013-07-30','13:20:00',3.78),('9303','2013-07-30','13:25:00',2.79),('9303','2013-07-30','13:30:00',3.7),('9303','2013-07-30','13:35:00',4.01),('9303','2013-07-30','13:40:00',4.15),('9303','2013-07-30','13:45:00',4.01),('9303','2013-07-30','13:50:00',4.12),('9303','2013-07-30','13:55:00',3.81),('9303','2013-07-30','14:00:00',3.99),('9303','2013-07-30','14:05:00',3.89),('9303','2013-07-30','14:10:00',3.46),('9303','2013-07-30','14:15:00',3.84),('9303','2013-07-30','14:20:00',3.76),('9303','2013-07-30','14:25:00',3.87),('9303','2013-07-30','14:30:00',3.9),('9303','2013-07-30','14:35:00',3.74),('9303','2013-07-30','14:40:00',3.47),('9303','2013-07-30','14:45:00',3.67),('9303','2013-07-30','14:50:00',3.67),('9303','2013-07-30','14:55:00',3.62),('9303','2013-07-30','15:00:00',3.56),('9303','2013-07-30','15:05:00',3.51),('9303','2013-07-30','15:10:00',3.36),('9303','2013-07-30','15:15:00',3.4),('9303','2013-07-30','15:20:00',3.42),('9303','2013-07-30','15:25:00',3.25),('9303','2013-07-30','15:30:00',3.31),('9303','2013-07-30','15:35:00',3.28),('9303','2013-07-30','15:40:00',3.22),('9303','2013-07-30','15:45:00',3.15),('9303','2013-07-30','15:50:00',3.11),('9303','2013-07-30','15:55:00',3.06),('9303','2013-07-30','16:00:00',3.02),('9303','2013-07-30','16:05:00',2.97),('9303','2013-07-30','16:10:00',2.91),('9303','2013-07-30','16:15:00',2.86),('9303','2013-07-30','16:20:00',2.81),('9303','2013-07-30','16:25:00',2.75),('9303','2013-07-30','16:30:00',2.66),('9303','2013-07-30','16:35:00',2.63),('9303','2013-07-30','16:40:00',2.6),('9303','2013-07-30','16:45:00',2.51),('9303','2013-07-30','16:50:00',2.43),('9303','2013-07-30','16:55:00',2.37),('9303','2013-07-30','17:00:00',2.32),('9303','2013-07-30','17:05:00',2.23),('9303','2013-07-30','17:10:00',2.1),('9303','2013-07-30','17:15:00',2.01),('9303','2013-07-30','17:20:00',1.93),('9303','2013-07-30','17:25:00',1.86),('9303','2013-07-30','17:30:00',1.78),('9303','2013-07-30','17:35:00',1.71),('9303','2013-07-30','17:40:00',1.64),('9303','2013-07-30','17:45:00',1.57),('9303','2013-07-30','17:50:00',1.46),('9303','2013-07-30','17:55:00',1.35),('9303','2013-07-30','18:00:00',1.27),('9303','2013-07-30','18:05:00',1.2),('9303','2013-07-30','18:10:00',1.13),('9303','2013-07-30','18:15:00',1.03),('9303','2013-07-29','08:05:00',1),('9303','2013-07-29','08:10:00',1.07),('9303','2013-07-29','08:15:00',1.15),('9303','2013-07-29','08:20:00',1.21),('9303','2013-07-29','08:25:00',1.3),('9303','2013-07-29','08:30:00',1.37),('9303','2013-07-29','08:35:00',1.45),('9303','2013-07-29','08:40:00',1.54),('9303','2013-07-29','08:45:00',1.62),('9303','2013-07-29','08:50:00',1.69),('9303','2013-07-29','08:55:00',1.76),('9303','2013-07-29','09:00:00',1.84),('9303','2013-07-29','09:05:00',1.91),('9303','2013-07-29','09:10:00',1.99),('9303','2013-07-29','09:15:00',2.06),('9303','2013-07-29','09:20:00',2.12),('9303','2013-07-29','09:25:00',2.19),('9303','2013-07-29','09:30:00',2.25),('9303','2013-07-29','09:35:00',2.31),('9303','2013-07-29','09:40:00',2.4),('9303','2013-07-29','09:45:00',2.48),('9303','2013-07-29','09:50:00',2.53),('9303','2013-07-29','09:55:00',2.6),('9303','2013-07-29','10:00:00',2.65),('9303','2013-07-29','10:05:00',2.7),('9303','2013-07-29','10:10:00',2.78),('9303','2013-07-29','10:15:00',2.81),('9303','2013-07-29','10:20:00',2.86),('9303','2013-07-29','10:25:00',2.95),('9303','2013-07-29','10:30:00',2.95),('9303','2013-07-29','10:35:00',2.99),('9303','2013-07-29','10:40:00',3.03),('9303','2013-07-29','10:45:00',3.09),('9303','2013-07-29','10:50:00',3.13),('9303','2013-07-29','10:55:00',3.16),('9303','2013-07-29','11:00:00',3.21),('9303','2013-07-29','11:05:00',3.2),('9303','2013-07-29','11:10:00',3.23),('9303','2013-07-29','11:15:00',3.28),('9303','2013-07-29','11:20:00',3.3),('9303','2013-07-29','11:25:00',3.35),('9303','2013-07-29','11:30:00',3.36),('9303','2013-07-29','11:35:00',3.36),('9303','2013-07-29','11:40:00',3.38),('9303','2013-07-29','11:45:00',3.4),('9303','2013-07-29','11:50:00',3.41),('9303','2013-07-29','11:55:00',3.46),('9303','2013-07-29','12:00:00',3.44),('9303','2013-07-29','12:05:00',3.47),('9303','2013-07-29','12:10:00',3.54),('9303','2013-07-29','12:15:00',3.57),('9303','2013-07-29','12:20:00',3.61),('9303','2013-07-29','12:25:00',3.59),('9303','2013-07-29','12:30:00',3.58),('9303','2013-07-29','12:35:00',3.64),('9303','2013-07-29','12:40:00',3.65),('9303','2013-07-29','12:45:00',3.64),('9303','2013-07-29','12:50:00',3.63),('9303','2013-07-29','12:55:00',3.64),('9303','2013-07-29','13:00:00',3.62),('9303','2013-07-29','13:05:00',3.69),('9303','2013-07-29','13:10:00',3.75),('9303','2013-07-29','13:15:00',3.75),('9303','2013-07-29','13:20:00',3.78),('9303','2013-07-29','13:25:00',3.78),('9303','2013-07-29','13:30:00',3.78),('9303','2013-07-29','13:35:00',3.78),('9303','2013-07-29','13:40:00',3.81),('9303','2013-07-29','13:45:00',3.83),('9303','2013-07-29','13:50:00',3.79),('9303','2013-07-29','13:55:00',3.79),('9303','2013-07-29','14:00:00',3.78),('9303','2013-07-29','14:05:00',3.74),('9303','2013-07-29','14:10:00',3.72),('9303','2013-07-29','14:15:00',3.72),('9303','2013-07-29','14:20:00',3.72),('9303','2013-07-29','14:25:00',3.67),('9303','2013-07-29','14:30:00',3.64),('9303','2013-07-29','14:35:00',3.6),('9303','2013-07-29','14:40:00',3.58),('9303','2013-07-29','14:45:00',3.57),('9303','2013-07-29','14:50:00',3.55),('9303','2013-07-29','14:55:00',3.52),('9303','2013-07-29','15:00:00',3.49),('9303','2013-07-29','15:05:00',3.46),('9303','2013-07-29','15:10:00',3.39),('9303','2013-07-29','15:15:00',3.39),('9303','2013-07-29','15:20:00',3.35),('9303','2013-07-29','15:25:00',3.31),('9303','2013-07-29','15:30:00',3.26),('9303','2013-07-29','15:35:00',3.24),('9303','2013-07-29','15:40:00',3.26),('9303','2013-07-29','15:45:00',3.25),('9303','2013-07-29','15:50:00',2.8),('9303','2013-07-29','15:55:00',1.78),('9303','2013-07-29','16:00:00',1.57),('9303','2013-07-29','16:05:00',2.52),('9303','2013-07-29','16:10:00',2.59),('9303','2013-07-29','16:15:00',2.64),('9303','2013-07-29','16:20:00',2.38),('9303','2013-07-29','16:25:00',2.23),('9303','2013-07-29','16:30:00',2.84),('9303','2013-07-29','16:35:00',2.62),('9303','2013-07-29','16:40:00',2.16),('9303','2013-07-29','16:45:00',2.72),('9303','2013-07-29','16:50:00',2.53),('9303','2013-07-29','16:55:00',1.45),('9303','2013-07-29','17:00:00',1.15),('9303','2013-07-29','17:05:00',1.63),('9303','2013-07-29','17:10:00',1.24),('9303','2013-07-29','17:20:00',1.82),('9303','2013-07-29','17:25:00',1.78),('9303','2013-07-29','17:30:00',1.08),('9303','2013-07-29','17:45:00',1.61),('9303','2013-07-29','17:50:00',1.48),('9303','2013-07-29','17:55:00',1.32),('9303','2013-07-28','08:10:00',1.09),('9303','2013-07-28','08:15:00',1.18),('9303','2013-07-28','08:20:00',1.25),('9303','2013-07-28','08:25:00',1.35),('9303','2013-07-28','08:30:00',1.43),('9303','2013-07-28','08:35:00',1.52),('9303','2013-07-28','08:40:00',1.6),('9303','2013-07-28','08:45:00',1.68),('9303','2013-07-28','08:50:00',1.75),('9303','2013-07-28','08:55:00',1.83),('9303','2013-07-28','09:00:00',1.91),('9303','2013-07-28','09:05:00',1.98),('9303','2013-07-28','09:10:00',2.06),('9303','2013-07-28','09:15:00',2.14),('9303','2013-07-28','09:20:00',2.19),('9303','2013-07-28','09:25:00',2.25),('9303','2013-07-28','09:30:00',2.32),('9303','2013-07-28','09:35:00',2.37),('9303','2013-07-28','09:40:00',2.43),('9303','2013-07-28','09:45:00',2.5),('9303','2013-07-28','09:50:00',2.51),('9303','2013-07-28','09:55:00',2.59),('9303','2013-07-28','10:00:00',2.65),('9303','2013-07-28','10:05:00',2.69),('9303','2013-07-28','10:10:00',2.76),('9303','2013-07-28','10:15:00',2.82),('9303','2013-07-28','10:20:00',2.87),('9303','2013-07-28','10:25:00',2.93),('9303','2013-07-28','10:30:00',2.94),('9303','2013-07-28','10:35:00',2.96),('9303','2013-07-28','10:40:00',3.03),('9303','2013-07-28','10:45:00',3.07),('9303','2013-07-28','10:50:00',3.09),('9303','2013-07-28','10:55:00',3.09),('9303','2013-07-28','11:00:00',3.13),('9303','2013-07-28','11:05:00',3.2),('9303','2013-07-28','11:10:00',3.25),('9303','2013-07-28','11:15:00',3.32),('9303','2013-07-28','11:20:00',3.34),('9303','2013-07-28','11:25:00',3.36),('9303','2013-07-28','11:30:00',3.36),('9303','2013-07-28','11:35:00',3.39),('9303','2013-07-28','11:40:00',3.41),('9303','2013-07-28','11:45:00',3.42),('9303','2013-07-28','11:50:00',3.45),('9303','2013-07-28','11:55:00',3.5),('9303','2013-07-28','12:00:00',3.49),('9303','2013-07-28','12:05:00',3.49),('9303','2013-07-28','12:10:00',3.52),('9303','2013-07-28','12:15:00',3.49),('9303','2013-07-28','12:20:00',3.51),('9303','2013-07-28','12:25:00',3.54),('9303','2013-07-28','12:30:00',3.66),('9303','2013-07-28','12:35:00',3.71),('9303','2013-07-28','12:40:00',3.67),('9303','2013-07-28','12:45:00',3.64),('9303','2013-07-28','12:50:00',3.61),('9303','2013-07-28','12:55:00',3.66),('9303','2013-07-28','13:00:00',3.63),('9303','2013-07-28','13:05:00',3.62),('9303','2013-07-28','13:10:00',3.69),('9303','2013-07-28','13:15:00',3.78),('9303','2013-07-28','13:20:00',3.83),('9303','2013-07-28','13:25:00',3.79),('9303','2013-07-28','13:30:00',3.78),('9303','2013-07-28','13:35:00',3.7),('9303','2013-07-28','13:40:00',3.66),('9303','2013-07-28','13:45:00',3.78),('9303','2013-07-28','13:50:00',3.79),('9303','2013-07-28','13:55:00',3.79),('9303','2013-07-28','14:00:00',3.76),('9303','2013-07-28','14:05:00',3.74),('9303','2013-07-28','14:10:00',3.71),('9303','2013-07-28','14:15:00',3.67),('9303','2013-07-28','14:20:00',3.65),('9303','2013-07-28','14:25:00',3.61),('9303','2013-07-28','14:30:00',3.59),('9303','2013-07-28','14:35:00',3.59),('9303','2013-07-28','14:40:00',3.62),('9303','2013-07-28','14:45:00',3.56),('9303','2013-07-28','14:50:00',3.54),('9303','2013-07-28','14:55:00',3.5),('9303','2013-07-28','15:00:00',3.45),('9303','2013-07-28','15:05:00',3.39),('9303','2013-07-28','15:10:00',3.4),('9303','2013-07-28','15:15:00',3.38),('9303','2013-07-28','15:20:00',3.32),('9303','2013-07-28','15:25:00',3.25),('9303','2013-07-28','15:30:00',3.25),('9303','2013-07-28','15:35:00',3.2),('9303','2013-07-28','15:40:00',3.16),('9303','2013-07-28','15:45:00',3.12),('9303','2013-07-28','15:50:00',3.09),('9303','2013-07-28','15:55:00',3.03),('9303','2013-07-28','16:00:00',3),('9303','2013-07-28','16:05:00',2.98),('9303','2013-07-28','16:10:00',2.95),('9303','2013-07-28','16:15:00',2.9),('9303','2013-07-28','16:20:00',2.85),('9303','2013-07-28','16:25:00',2.8),('9303','2013-07-28','16:30:00',2.73),('9303','2013-07-28','16:35:00',2.68),('9303','2013-07-28','16:40:00',2.61),('9303','2013-07-28','16:45:00',2.54),('9303','2013-07-28','16:50:00',2.47),('9303','2013-07-28','16:55:00',2.42),('9303','2013-07-28','17:00:00',2.34),('9303','2013-07-28','17:05:00',2.27),('9303','2013-07-28','17:10:00',2.18),('9303','2013-07-28','17:15:00',2.07),('9303','2013-07-28','17:20:00',1.97),('9303','2013-07-28','17:25:00',1.89),('9303','2013-07-28','17:30:00',1.82),('9303','2013-07-28','17:35:00',1.75),('9303','2013-07-28','17:40:00',1.68),('9303','2013-07-28','17:45:00',1.6),('9303','2013-07-28','17:50:00',1.52),('9303','2013-07-28','17:55:00',1.41),('9303','2013-07-28','18:00:00',1.32),('9303','2013-07-28','18:05:00',1.24),('9303','2013-07-28','18:10:00',1.17),('9303','2013-07-28','18:15:00',1.09),('9303','2013-07-28','18:20:00',1),('9303','2013-07-27','08:05:00',1.02),('9303','2013-07-27','08:10:00',1.11),('9303','2013-07-27','08:15:00',1.2),('9303','2013-07-27','08:20:00',1.28),('9303','2013-07-27','08:25:00',1.38),('9303','2013-07-27','08:30:00',1.46),('9303','2013-07-27','08:35:00',1.54),('9303','2013-07-27','08:40:00',1.61),('9303','2013-07-27','08:45:00',1.7),('9303','2013-07-27','08:50:00',1.78),('9303','2013-07-27','08:55:00',1.85),('9303','2013-07-27','09:00:00',1.93),('9303','2013-07-27','09:05:00',1.99),('9303','2013-07-27','09:10:00',2.08),('9303','2013-07-27','09:15:00',2.16),('9303','2013-07-27','09:20:00',2.21),('9303','2013-07-27','09:25:00',2.3),('9303','2013-07-27','09:30:00',2.36),('9303','2013-07-27','09:35:00',2.44),('9303','2013-07-27','09:40:00',2.51),('9303','2013-07-27','09:45:00',2.55),('9303','2013-07-27','09:50:00',2.61),('9303','2013-07-27','09:55:00',2.68),('9303','2013-07-27','10:00:00',2.73),('9303','2013-07-27','10:05:00',2.78),('9303','2013-07-27','10:10:00',2.84),('9303','2013-07-27','10:15:00',2.91),('9303','2013-07-27','10:20:00',2.95),('9303','2013-07-27','10:25:00',3),('9303','2013-07-27','10:30:00',3.09),('9303','2013-07-27','10:35:00',3.12),('9303','2013-07-27','10:40:00',3.12),('9303','2013-07-27','10:45:00',3.17),('9303','2013-07-27','10:50:00',3.21),('9303','2013-07-27','10:55:00',3.23),('9303','2013-07-27','11:00:00',3.28),('9303','2013-07-27','11:05:00',3.32),('9303','2013-07-27','11:10:00',3.38),('9303','2013-07-27','11:15:00',3.38),('9303','2013-07-27','11:20:00',3.41),('9303','2013-07-27','11:25:00',3.5),('9303','2013-07-27','11:30:00',3.52),('9303','2013-07-27','11:35:00',3.52),('9303','2013-07-27','11:40:00',3.51),('9303','2013-07-27','11:45:00',3.57),('9303','2013-07-27','11:50:00',3.61),('9303','2013-07-27','11:55:00',3.62),('9303','2013-07-27','12:00:00',3.62),('9303','2013-07-27','12:05:00',3.69),('9303','2013-07-27','12:10:00',3.72),('9303','2013-07-27','12:15:00',3.65),('9303','2013-07-27','12:20:00',3.75),('9303','2013-07-27','12:25:00',3.76),('9303','2013-07-27','12:30:00',3.74),('9303','2013-07-27','12:35:00',3.76),('9303','2013-07-27','12:40:00',3.79),('9303','2013-07-27','12:45:00',3.71),('9303','2013-07-27','12:50:00',3.71),('9303','2013-07-27','12:55:00',3.77),('9303','2013-07-27','13:00:00',3.8),('9303','2013-07-27','13:05:00',3.87),('9303','2013-07-27','13:10:00',3.9),('9303','2013-07-27','13:15:00',3.8),('9303','2013-07-27','13:20:00',3.86),('9303','2013-07-27','13:25:00',3.92),('9303','2013-07-27','13:30:00',3.9),('9303','2013-07-27','13:35:00',3.81),('9303','2013-07-27','13:40:00',3.61),('9303','2013-07-27','13:45:00',3.85),('9303','2013-07-27','13:50:00',3.83),('9303','2013-07-27','13:55:00',3.84),('9303','2013-07-27','14:00:00',3.33),('9303','2013-07-27','14:05:00',3.38),('9303','2013-07-27','14:10:00',1.86),('9303','2013-07-27','14:15:00',3.79),('9303','2013-07-27','14:20:00',3.78),('9303','2013-07-27','14:25:00',3.67),('9303','2013-07-27','14:30:00',3.65),('9303','2013-07-27','14:35:00',3.65),('9303','2013-07-27','14:40:00',3.63),('9303','2013-07-27','14:45:00',3.55),('9303','2013-07-27','14:50:00',3.54),('9303','2013-07-27','14:55:00',3.52),('9303','2013-07-27','15:00:00',3.45),('9303','2013-07-27','15:05:00',3.41),('9303','2013-07-27','15:10:00',3.45),('9303','2013-07-27','15:15:00',3.37),('9303','2013-07-27','15:20:00',3.33),('9303','2013-07-27','15:25:00',3.31),('9303','2013-07-27','15:30:00',3.29),('9303','2013-07-27','15:35:00',3.26),('9303','2013-07-27','15:40:00',3.22),('9303','2013-07-27','15:45:00',3.17),('9303','2013-07-27','15:50:00',3.12),('9303','2013-07-27','15:55:00',3.05),('9303','2013-07-27','16:00:00',3.02),('9303','2013-07-27','16:05:00',2.99),('9303','2013-07-27','16:10:00',2.92),('9303','2013-07-27','16:15:00',2.86),('9303','2013-07-27','16:20:00',2.82),('9303','2013-07-27','16:25:00',2.77),('9303','2013-07-27','16:30:00',2.7),('9303','2013-07-27','16:35:00',2.65),('9303','2013-07-27','16:40:00',2.58),('9303','2013-07-27','16:45:00',2.52),('9303','2013-07-27','16:50:00',2.46),('9303','2013-07-27','16:55:00',2.4),('9303','2013-07-27','17:00:00',2.34),('9303','2013-07-27','17:05:00',2.27),('9303','2013-07-27','17:10:00',2.17),('9303','2013-07-27','17:15:00',2.06),('9303','2013-07-27','17:20:00',1.96),('9303','2013-07-27','17:25:00',1.89),('9303','2013-07-27','17:30:00',1.81),('9303','2013-07-27','17:35:00',1.74),('9303','2013-07-27','17:40:00',1.66),('9303','2013-07-27','17:45:00',1.58),('9303','2013-07-27','17:50:00',1.52),('9303','2013-07-27','17:55:00',1.41),('9303','2013-07-27','18:00:00',1.35),('9303','2013-07-27','18:05:00',1.27),('9303','2013-07-27','18:10:00',1.19),('9303','2013-07-27','18:15:00',1.1),('9303','2013-07-27','18:20:00',1.01),('9303','2013-07-26','08:10:00',1.1),('9303','2013-07-26','08:15:00',1.17),('9303','2013-07-26','08:20:00',1.22),('9303','2013-07-26','08:25:00',1.32),('9303','2013-07-26','08:30:00',1.43),('9303','2013-07-26','08:35:00',1.5),('9303','2013-07-26','08:40:00',1.56),('9303','2013-07-26','08:45:00',1.65),('9303','2013-07-26','08:50:00',1.74),('9303','2013-07-26','08:55:00',1.82),('9303','2013-07-26','09:00:00',1.9),('9303','2013-07-26','09:05:00',1.97),('9303','2013-07-26','09:10:00',2.04),('9303','2013-07-26','09:15:00',2.12),('9303','2013-07-26','09:20:00',2.22),('9303','2013-07-26','09:25:00',2.26),('9303','2013-07-26','09:30:00',2.32),('9303','2013-07-26','09:35:00',2.33),('9303','2013-07-26','09:40:00',2.44),('9303','2013-07-26','09:45:00',2.45),('9303','2013-07-26','09:50:00',2.56),('9303','2013-07-26','09:55:00',2.62),('9303','2013-07-26','10:00:00',2.65),('9303','2013-07-26','10:05:00',2.71),('9303','2013-07-26','10:10:00',2.76),('9303','2013-07-26','10:15:00',2.86),('9303','2013-07-26','10:20:00',2.87),('9303','2013-07-26','10:25:00',2.93),('9303','2013-07-26','10:30:00',2.96),('9303','2013-07-26','10:35:00',3.01),('9303','2013-07-26','10:40:00',3.04),('9303','2013-07-26','10:45:00',3.11),('9303','2013-07-26','10:50:00',3.14),('9303','2013-07-26','10:55:00',3.24),('9303','2013-07-26','11:00:00',3.27),('9303','2013-07-26','11:05:00',3.33),('9303','2013-07-26','11:10:00',3.38),('9303','2013-07-26','11:15:00',3.33),('9303','2013-07-26','11:20:00',3.38),('9303','2013-07-26','11:25:00',3.35),('9303','2013-07-26','11:30:00',3.05),('9303','2013-07-26','11:35:00',3.36),('9303','2013-07-26','11:40:00',3.58),('9303','2013-07-26','11:45:00',3.54),('9303','2013-07-26','11:50:00',3.54),('9303','2013-07-26','11:55:00',3.59),('9303','2013-07-26','12:00:00',3.57),('9303','2013-07-26','12:05:00',3.62),('9303','2013-07-26','12:10:00',2.93),('9303','2013-07-26','12:15:00',2.77),('9303','2013-07-26','12:20:00',3.82),('9303','2013-07-26','12:25:00',3.79),('9303','2013-07-26','12:30:00',3.84),('9303','2013-07-26','12:35:00',3.73),('9303','2013-07-26','12:40:00',3.89),('9303','2013-07-26','12:45:00',4.02),('9303','2013-07-26','12:50:00',3.97),('9303','2013-07-26','12:55:00',2.21),('9303','2013-07-26','13:00:00',1.59),('9303','2013-07-26','13:05:00',2.36),('9303','2013-07-26','13:10:00',1.43),('9303','2013-07-26','13:15:00',2.89),('9303','2013-07-26','13:20:00',4.1),('9303','2013-07-26','13:25:00',4.08),('9303','2013-07-26','13:30:00',4.11),('9303','2013-07-26','13:35:00',3.92),('9303','2013-07-26','13:40:00',3.91),('9303','2013-07-26','13:45:00',4.01),('9303','2013-07-26','13:50:00',2.43),('9303','2013-07-26','13:55:00',2.52),('9303','2013-07-26','14:00:00',4.08),('9303','2013-07-26','14:05:00',3.91),('9303','2013-07-26','14:10:00',3.72),('9303','2013-07-26','14:15:00',3.83),('9303','2013-07-26','14:20:00',3.83),('9303','2013-07-26','14:25:00',3.77),('9303','2013-07-26','14:30:00',3.73),('9303','2013-07-26','14:35:00',3.68),('9303','2013-07-26','14:40:00',3.68),('9303','2013-07-26','14:45:00',3.6),('9303','2013-07-26','14:50:00',3.62),('9303','2013-07-26','14:55:00',3.57),('9303','2013-07-26','15:00:00',3.58),('9303','2013-07-26','15:05:00',3.47),('9303','2013-07-26','15:10:00',3.45),('9303','2013-07-26','15:15:00',3.41),('9303','2013-07-26','15:20:00',3.35),('9303','2013-07-26','15:25:00',3.31),('9303','2013-07-26','15:30:00',3.29),('9303','2013-07-26','15:35:00',3.26),('9303','2013-07-26','15:40:00',3.24),('9303','2013-07-26','15:45:00',3.21),('9303','2013-07-26','15:50:00',3.17),('9303','2013-07-26','15:55:00',3.12),('9303','2013-07-26','16:00:00',3.06),('9303','2013-07-26','16:05:00',3.02),('9303','2013-07-26','16:10:00',2.94),('9303','2013-07-26','16:15:00',2.89),('9303','2013-07-26','16:20:00',2.83),('9303','2013-07-26','16:25:00',2.8),('9303','2013-07-26','16:30:00',2.73),('9303','2013-07-26','16:35:00',2.67),('9303','2013-07-26','16:40:00',2.61),('9303','2013-07-26','16:45:00',2.56),('9303','2013-07-26','16:50:00',2.48),('9303','2013-07-26','16:55:00',2.42),('9303','2013-07-26','17:00:00',2.35),('9303','2013-07-26','17:05:00',2.27),('9303','2013-07-26','17:10:00',2.19),('9303','2013-07-26','17:15:00',2.05),('9303','2013-07-26','17:20:00',1.97),('9303','2013-07-26','17:25:00',1.88),('9303','2013-07-26','17:30:00',1.77),('9303','2013-07-26','17:35:00',1.72),('9303','2013-07-26','17:40:00',1.65),('9303','2013-07-26','17:45:00',1.56),('9303','2013-07-26','17:50:00',1.45),('9303','2013-07-26','17:55:00',1.34),('9303','2013-07-26','18:00:00',1.26),('9303','2013-07-26','18:05:00',1.18),('9303','2013-07-26','18:10:00',1.14),('9303','2013-07-26','18:15:00',1.05),('9303','2013-07-25','08:05:00',1.03),('9303','2013-07-25','08:10:00',1.1),('9303','2013-07-25','08:15:00',1.18),('9303','2013-07-25','08:20:00',1.26),('9303','2013-07-25','08:25:00',1.35),('9303','2013-07-25','08:30:00',1.42),('9303','2013-07-25','08:35:00',1.48),('9303','2013-07-25','08:40:00',1.59),('9303','2013-07-25','08:45:00',1.66),('9303','2013-07-25','08:50:00',1.71),('9303','2013-07-25','08:55:00',1.81),('9303','2013-07-25','09:00:00',1.93),('9303','2013-07-25','09:05:00',2),('9303','2013-07-25','09:10:00',2.07),('9303','2013-07-25','09:15:00',2.24),('9303','2013-07-25','09:20:00',2.17),('9303','2013-07-25','09:25:00',1.59),('9303','2013-07-25','09:30:00',1.68),('9303','2013-07-25','09:35:00',1.69),('9303','2013-07-25','09:40:00',1.16),('9303','2013-07-25','09:45:00',1.25),('9303','2013-07-25','09:50:00',1.82),('9303','2013-07-25','09:55:00',1.03),('9303','2013-07-25','10:00:00',2.17),('9303','2013-07-25','10:05:00',2.2),('9303','2013-07-25','10:10:00',2.89),('9303','2013-07-25','10:15:00',2.92),('9303','2013-07-25','10:20:00',2.95),('9303','2013-07-25','10:25:00',2.93),('9303','2013-07-25','10:30:00',3),('9303','2013-07-25','10:35:00',1.67),('9303','2013-07-25','10:40:00',1.86),('9303','2013-07-25','10:45:00',2.53),('9303','2013-07-25','10:50:00',3.29),('9303','2013-07-25','10:55:00',3.4),('9303','2013-07-25','11:00:00',3.32),('9303','2013-07-25','11:05:00',3.15),('9303','2013-07-25','11:10:00',3.49),('9303','2013-07-25','11:15:00',3.2),('9303','2013-07-25','11:20:00',2.1),('9303','2013-07-25','11:25:00',3.42),('9303','2013-07-25','11:30:00',3.12),('9303','2013-07-25','11:35:00',3.44),('9303','2013-07-25','11:40:00',3.65),('9303','2013-07-25','11:45:00',3.94),('9303','2013-07-25','11:50:00',3.92),('9303','2013-07-25','11:55:00',2.05),('9303','2013-07-25','12:00:00',3.69),('9303','2013-07-25','12:05:00',3.78),('9303','2013-07-25','12:10:00',3.76),('9303','2013-07-25','12:15:00',2.21),('9303','2013-07-25','12:20:00',3.61),('9303','2013-07-25','12:25:00',2.38),('9303','2013-07-25','12:30:00',1.51),('9303','2013-07-25','12:35:00',1.78),('9303','2013-07-25','12:40:00',1.25),('9303','2013-07-25','12:45:00',1.13),('9303','2013-07-25','12:50:00',1.74),('9303','2013-07-25','12:55:00',1.53),('9303','2013-07-25','13:00:00',3.7),('9303','2013-07-25','13:05:00',2.89),('9303','2013-07-25','13:10:00',3.48),('9303','2013-07-25','13:15:00',4.15),('9303','2013-07-25','13:20:00',4.06),('9303','2013-07-25','13:25:00',4.08),('9303','2013-07-25','13:30:00',4.03),('9303','2013-07-25','13:35:00',3.84),('9303','2013-07-25','13:40:00',3.98),('9303','2013-07-25','13:45:00',3.92),('9303','2013-07-25','13:50:00',3.94),('9303','2013-07-25','13:55:00',3.95),('9303','2013-07-25','14:00:00',3.98),('9303','2013-07-25','14:05:00',3.96),('9303','2013-07-25','14:10:00',3.94),('9303','2013-07-25','14:15:00',3.92),('9303','2013-07-25','14:20:00',3.95),('9303','2013-07-25','14:25:00',3.92),('9303','2013-07-25','14:30:00',3.87),('9303','2013-07-25','14:35:00',3.84),('9303','2013-07-25','14:40:00',3.78),('9303','2013-07-25','14:45:00',3.72),('9303','2013-07-25','14:50:00',3.69),('9303','2013-07-25','14:55:00',3.7),('9303','2013-07-25','15:00:00',3.65),('9303','2013-07-25','15:05:00',3.63),('9303','2013-07-25','15:10:00',3.59),('9303','2013-07-25','15:15:00',3.57),('9303','2013-07-25','15:20:00',3.53),('9303','2013-07-25','15:25:00',3.48),('9303','2013-07-25','15:30:00',3.45),('9303','2013-07-25','15:35:00',3.41),('9303','2013-07-25','15:40:00',3.4),('9303','2013-07-25','15:45:00',3.35),('9303','2013-07-25','15:50:00',3.31),('9303','2013-07-25','15:55:00',3.26),('9303','2013-07-25','16:00:00',3.18),('9303','2013-07-25','16:05:00',3.11),('9303','2013-07-25','16:10:00',3.06),('9303','2013-07-25','16:15:00',2.99),('9303','2013-07-25','16:20:00',2.95),('9303','2013-07-25','16:25:00',2.89),('9303','2013-07-25','16:30:00',2.82),('9303','2013-07-25','16:35:00',2.8),('9303','2013-07-25','16:40:00',2.74),('9303','2013-07-25','16:45:00',2.66),('9303','2013-07-25','16:50:00',2.61),('9303','2013-07-25','16:55:00',2.54),('9303','2013-07-25','17:00:00',2.45),('9303','2013-07-25','17:05:00',2.4),('9303','2013-07-25','17:10:00',2.3),('9303','2013-07-25','17:15:00',2.17),('9303','2013-07-25','17:20:00',2.06),('9303','2013-07-25','17:25:00',1.96),('9303','2013-07-25','17:30:00',1.89),('9303','2013-07-25','17:35:00',1.82),('9303','2013-07-25','17:40:00',1.74),('9303','2013-07-25','17:45:00',1.68),('9303','2013-07-25','17:50:00',1.59),('9303','2013-07-25','17:55:00',1.47),('9303','2013-07-25','18:00:00',1.41),('9303','2013-07-25','18:05:00',1.31),('9303','2013-07-25','18:10:00',1.23),('9303','2013-07-25','18:15:00',1.15),('9303','2013-07-25','18:20:00',1.06),('9303','2013-07-24','08:20:00',1.32),('9303','2013-07-24','08:25:00',1.01),('9303','2013-07-24','08:45:00',1.01),('9303','2013-07-24','08:50:00',1.49),('9303','2013-07-24','08:55:00',1.23),('9303','2013-07-24','09:00:00',1.13),('9303','2013-07-24','09:05:00',1.44),('9303','2013-07-24','09:10:00',1.87),('9303','2013-07-24','09:15:00',2.1),('9303','2013-07-24','09:20:00',1.27),('9303','2013-07-24','09:25:00',1.54),('9303','2013-07-24','09:30:00',1.15),('9303','2013-07-24','09:35:00',2.09),('9303','2013-07-24','09:40:00',1.64),('9303','2013-07-24','09:45:00',1.48),('9303','2013-07-24','09:50:00',1.7),('9303','2013-07-24','09:55:00',1.25),('9303','2013-07-24','10:15:00',1.42),('9303','2013-07-24','10:20:00',1.2),('9303','2013-07-24','10:25:00',2.73),('9303','2013-07-24','10:30:00',3.05),('9303','2013-07-24','10:35:00',3.26),('9303','2013-07-24','10:40:00',3.5),('9303','2013-07-24','10:45:00',2.82),('9303','2013-07-24','10:50:00',1.72),('9303','2013-07-24','10:55:00',2.27),('9303','2013-07-24','11:00:00',1.3),('9303','2013-07-24','11:05:00',2.45),('9303','2013-07-24','11:10:00',3.44),('9303','2013-07-24','11:15:00',3.66),('9303','2013-07-24','11:20:00',3.66),('9303','2013-07-24','11:25:00',3.65),('9303','2013-07-24','11:30:00',3.53),('9303','2013-07-24','11:35:00',3.76),('9303','2013-07-24','11:40:00',3.68),('9303','2013-07-24','11:45:00',3.59),('9303','2013-07-24','11:50:00',3.62),('9303','2013-07-24','11:55:00',3.68),('9303','2013-07-24','12:00:00',3.93),('9303','2013-07-24','12:05:00',3.73),('9303','2013-07-24','12:10:00',1.86),('9303','2013-07-24','12:15:00',1.93),('9303','2013-07-24','12:20:00',4.07),('9303','2013-07-24','12:25:00',3.74),('9303','2013-07-24','12:30:00',2.44),('9303','2013-07-24','12:35:00',1.06),('9303','2013-07-24','12:40:00',3.43),('9303','2013-07-24','12:45:00',3.55),('9303','2013-07-24','12:50:00',1.31),('9303','2013-07-24','12:55:00',2.45),('9303','2013-07-24','13:00:00',3.87),('9303','2013-07-24','13:05:00',3.26),('9303','2013-07-24','13:10:00',2.3),('9303','2013-07-24','13:15:00',3.98),('9303','2013-07-24','13:20:00',2.7),('9303','2013-07-24','13:25:00',3.15),('9303','2013-07-24','13:30:00',2.74),('9303','2013-07-24','13:35:00',4.27),('9303','2013-07-24','13:40:00',4.11),('9303','2013-07-24','13:45:00',4.17),('9303','2013-07-24','13:50:00',2.73),('9303','2013-07-24','13:55:00',4.23),('9303','2013-07-24','14:00:00',4.17),('9303','2013-07-24','14:05:00',4.11),('9303','2013-07-24','14:10:00',4.1),('9303','2013-07-24','14:15:00',3.69),('9303','2013-07-24','14:20:00',4.08),('9303','2013-07-24','14:25:00',4.07),('9303','2013-07-24','14:30:00',4.14),('9303','2013-07-24','14:35:00',1.91),('9303','2013-07-24','14:40:00',3.77),('9303','2013-07-24','14:45:00',4),('9303','2013-07-24','14:50:00',3.93),('9303','2013-07-24','14:55:00',3.89),('9303','2013-07-24','15:00:00',3.76),('9303','2013-07-24','15:05:00',3.76),('9303','2013-07-24','15:10:00',3.69),('9303','2013-07-24','15:15:00',3.65),('9303','2013-07-24','15:20:00',3.6),('9303','2013-07-24','15:25:00',3.56),('9303','2013-07-24','15:30:00',3.38),('9303','2013-07-24','15:35:00',3.32),('9303','2013-07-24','15:40:00',3.39),('9303','2013-07-24','15:45:00',3.31),('9303','2013-07-24','15:50:00',3.23),('9303','2013-07-24','15:55:00',3.29),('9303','2013-07-24','16:00:00',3.18),('9303','2013-07-24','16:05:00',3.12),('9303','2013-07-24','16:10:00',2.99),('9303','2013-07-24','16:15:00',2.88),('9303','2013-07-24','16:20:00',3.06),('9303','2013-07-24','16:25:00',2.99),('9303','2013-07-24','16:30:00',2.98),('9303','2013-07-24','16:35:00',2.75),('9303','2013-07-24','16:40:00',2.82),('9303','2013-07-24','16:45:00',2.64),('9303','2013-07-24','16:50:00',2.66),('9303','2013-07-24','16:55:00',2.72),('9303','2013-07-24','17:00:00',2.63),('9303','2013-07-24','17:05:00',2.3),('9303','2013-07-24','17:10:00',1.58),('9303','2013-07-24','17:15:00',2.25),('9303','2013-07-24','17:20:00',2.13),('9303','2013-07-24','17:25:00',2.02),('9303','2013-07-24','17:30:00',1.9),('9303','2013-07-24','17:35:00',1.82),('9303','2013-07-24','17:40:00',1.74),('9303','2013-07-24','17:45:00',1.66),('9303','2013-07-24','17:50:00',1.55),('9303','2013-07-24','17:55:00',1.41),('9303','2013-07-24','18:00:00',1.37),('9303','2013-07-24','18:05:00',1.28),('9303','2013-07-24','18:10:00',1.22),('9303','2013-07-24','18:15:00',1.1),('9303','2013-07-24','18:20:00',1.03),('9303','2013-07-23','08:00:00',1.03),('9303','2013-07-23','08:05:00',1.16),('9303','2013-07-23','08:10:00',1.26),('9303','2013-07-23','08:15:00',1.33),('9303','2013-07-23','08:20:00',1.42),('9303','2013-07-23','08:25:00',1.51),('9303','2013-07-23','08:30:00',1.59),('9303','2013-07-23','08:35:00',1.67),('9303','2013-07-23','08:40:00',1.75),('9303','2013-07-23','08:45:00',1.82),('9303','2013-07-23','08:50:00',1.92),('9303','2013-07-23','08:55:00',2.02),('9303','2013-07-23','09:00:00',2.09),('9303','2013-07-23','09:05:00',2.16),('9303','2013-07-23','09:10:00',2.22),('9303','2013-07-23','09:15:00',2.28),('9303','2013-07-23','09:20:00',2.34),('9303','2013-07-23','09:25:00',2.39),('9303','2013-07-23','09:30:00',2.45),('9303','2013-07-23','09:35:00',2.51),('9303','2013-07-23','09:40:00',2.56),('9303','2013-07-23','09:45:00',2.6),('9303','2013-07-23','09:50:00',2.65),('9303','2013-07-23','09:55:00',2.67),('9303','2013-07-23','10:00:00',2.73),('9303','2013-07-23','10:05:00',2.81),('9303','2013-07-23','10:10:00',2.85),('9303','2013-07-23','10:15:00',2.89),('9303','2013-07-23','10:20:00',2.95),('9303','2013-07-23','10:25:00',3.05),('9303','2013-07-23','10:30:00',3.09),('9303','2013-07-23','10:35:00',3.17),('9303','2013-07-23','10:40:00',3.22),('9303','2013-07-23','10:45:00',3.26),('9303','2013-07-23','10:50:00',3.27),('9303','2013-07-23','10:55:00',3.32),('9303','2013-07-23','11:00:00',3.37),('9303','2013-07-23','11:05:00',3.39),('9303','2013-07-23','11:10:00',3.41),('9303','2013-07-23','11:15:00',3.5),('9303','2013-07-23','11:20:00',3.5),('9303','2013-07-23','11:25:00',3.54),('9303','2013-07-23','11:30:00',3.63),('9303','2013-07-23','11:35:00',3.62),('9303','2013-07-23','11:40:00',3.66),('9303','2013-07-23','11:45:00',3.66),('9303','2013-07-23','11:50:00',3.64),('9303','2013-07-23','11:55:00',3.7),('9303','2013-07-23','12:00:00',3.78),('9303','2013-07-23','12:05:00',3.8),('9303','2013-07-23','12:10:00',3.83),('9303','2013-07-23','12:15:00',3.85),('9303','2013-07-23','12:20:00',3.9),('9303','2013-07-23','12:25:00',3.92),('9303','2013-07-23','12:30:00',3.87),('9303','2013-07-23','12:35:00',3.89),('9303','2013-07-23','12:40:00',3.31),('9303','2013-07-23','12:45:00',2.84),('9303','2013-07-23','12:50:00',3.21),('9303','2013-07-23','12:55:00',3.09),('9303','2013-07-23','13:10:00',2.88),('9303','2013-07-23','13:15:00',2.62),('9303','2013-07-23','13:30:00',2.36),('9303','2013-07-23','13:35:00',4.18),('9303','2013-07-23','13:40:00',4.04),('9303','2013-07-23','13:55:00',2.22),('9303','2013-07-23','14:00:00',4.09),('9303','2013-07-23','14:05:00',3.18),('9303','2013-07-23','14:10:00',1.16),('9303','2013-07-23','14:35:00',2.61),('9303','2013-07-23','14:40:00',4.02),('9303','2013-07-23','14:45:00',4.1),('9303','2013-07-23','14:50:00',3.89),('9303','2013-07-23','14:55:00',4.12),('9303','2013-07-23','15:00:00',3.82),('9303','2013-07-23','15:05:00',4.08),('9303','2013-07-23','15:10:00',3.77),('9303','2013-07-23','15:15:00',3.57),('9303','2013-07-23','15:20:00',3.59),('9303','2013-07-23','15:25:00',3.5),('9303','2013-07-23','15:30:00',3.39),('9303','2013-07-23','15:35:00',3.06),('9303','2013-07-23','15:40:00',3.28),('9303','2013-07-23','15:45:00',3.23),('9303','2013-07-23','15:50:00',3.21),('9303','2013-07-23','15:55:00',3.18),('9303','2013-07-23','16:00:00',3.13),('9303','2013-07-23','16:05:00',3.07),('9303','2013-07-23','16:10:00',3.03),('9303','2013-07-23','16:15:00',2.94),('9303','2013-07-23','16:20:00',2.94),('9303','2013-07-23','16:25:00',2.85),('9303','2013-07-23','16:30:00',2.83),('9303','2013-07-23','16:35:00',2.73),('9303','2013-07-23','16:40:00',2.69),('9303','2013-07-23','16:45:00',2.59),('9303','2013-07-23','16:50:00',2.53),('9303','2013-07-23','16:55:00',2.48),('9303','2013-07-23','17:00:00',2.41),('9303','2013-07-23','17:05:00',2.34),('9303','2013-07-23','17:10:00',2.29),('9303','2013-07-23','17:15:00',2.19),('9303','2013-07-23','17:20:00',2.09),('9303','2013-07-23','17:25:00',2),('9303','2013-07-23','17:30:00',1.92),('9303','2013-07-23','17:35:00',1.86),('9303','2013-07-23','17:40:00',1.79),('9303','2013-07-23','17:45:00',1.7),('9303','2013-07-23','17:50:00',1.61),('9303','2013-07-23','17:55:00',1.53),('9303','2013-07-23','18:00:00',1.46),('9303','2013-07-23','18:05:00',1.35),('9303','2013-07-23','18:10:00',1.28),('9303','2013-07-23','18:15:00',1.22),('9303','2013-07-23','18:20:00',1.13),('9303','2013-07-23','18:25:00',1.03),('9303','2013-07-22','08:00:00',1.04),('9303','2013-07-22','08:05:00',1.13),('9303','2013-07-22','08:10:00',1.22),('9303','2013-07-22','08:15:00',1.3),('9303','2013-07-22','08:20:00',1.39),('9303','2013-07-22','08:25:00',1.49),('9303','2013-07-22','08:30:00',1.57),('9303','2013-07-22','08:35:00',1.65),('9303','2013-07-22','08:40:00',1.73),('9303','2013-07-22','08:45:00',1.81),('9303','2013-07-22','08:50:00',1.9),('9303','2013-07-22','08:55:00',1.99),('9303','2013-07-22','09:00:00',2.06),('9303','2013-07-22','09:05:00',2.13),('9303','2013-07-22','09:10:00',2.2),('9303','2013-07-22','09:15:00',2.27),('9303','2013-07-22','09:20:00',2.33),('9303','2013-07-22','09:25:00',2.38),('9303','2013-07-22','09:30:00',2.46),('9303','2013-07-22','09:35:00',2.52),('9303','2013-07-22','09:40:00',2.57),('9303','2013-07-22','09:45:00',2.64),('9303','2013-07-22','09:50:00',2.72),('9303','2013-07-22','09:55:00',2.81),('9303','2013-07-22','10:00:00',2.85),('9303','2013-07-22','10:05:00',2.9),('9303','2013-07-22','10:10:00',2.97),('9303','2013-07-22','10:15:00',3.02),('9303','2013-07-22','10:20:00',3.06),('9303','2013-07-22','10:25:00',3.12),('9303','2013-07-22','10:30:00',3.17),('9303','2013-07-22','10:35:00',3.23),('9303','2013-07-22','10:40:00',3.27),('9303','2013-07-22','10:45:00',3.31),('9303','2013-07-22','10:50:00',3.32),('9303','2013-07-22','10:55:00',3.37),('9303','2013-07-22','11:00:00',3.38),('9303','2013-07-22','11:05:00',3.4),('9303','2013-07-22','11:10:00',3.44),('9303','2013-07-22','11:15:00',3.45),('9303','2013-07-22','11:20:00',3.49),('9303','2013-07-22','11:25:00',3.52),('9303','2013-07-22','11:30:00',3.57),('9303','2013-07-22','11:35:00',3.59),('9303','2013-07-22','11:40:00',3.58),('9303','2013-07-22','11:45:00',3.58),('9303','2013-07-22','11:50:00',3.57),('9303','2013-07-22','11:55:00',3.6),('9303','2013-07-22','12:00:00',3.64),('9303','2013-07-22','12:05:00',3.71),('9303','2013-07-22','12:10:00',3.75),('9303','2013-07-22','12:15:00',3.77),('9303','2013-07-22','12:20:00',3.77),('9303','2013-07-22','12:25:00',3.86),('9303','2013-07-22','12:30:00',3.89),('9303','2013-07-22','12:35:00',3.85),('9303','2013-07-22','12:40:00',3.82),('9303','2013-07-22','12:45:00',3.83),('9303','2013-07-22','12:50:00',3.84),('9303','2013-07-22','12:55:00',3.85),('9303','2013-07-22','13:00:00',3.9),('9303','2013-07-22','13:05:00',3.9),('9303','2013-07-22','13:10:00',3.9),('9303','2013-07-22','13:15:00',3.9),('9303','2013-07-22','13:20:00',3.91),('9303','2013-07-22','13:25:00',3.89),('9303','2013-07-22','13:30:00',3.91),('9303','2013-07-22','13:35:00',3.91),('9303','2013-07-22','13:40:00',3.98),('9303','2013-07-22','13:45:00',3.97),('9303','2013-07-22','13:50:00',3.95),('9303','2013-07-22','13:55:00',3.88),('9303','2013-07-22','14:00:00',3.86),('9303','2013-07-22','14:05:00',3.78),('9303','2013-07-22','14:10:00',3.75),('9303','2013-07-22','14:15:00',3.74),('9303','2013-07-22','14:20:00',3.79),('9303','2013-07-22','14:25:00',3.78),('9303','2013-07-22','14:30:00',3.72),('9303','2013-07-22','14:35:00',3.7),('9303','2013-07-22','14:40:00',3.66),('9303','2013-07-22','14:45:00',3.63),('9303','2013-07-22','14:50:00',3.58),('9303','2013-07-22','14:55:00',3.51),('9303','2013-07-22','15:00:00',3.24),('9303','2013-07-22','15:05:00',3.01),('9303','2013-07-22','15:10:00',2.3),('9303','2013-07-22','15:15:00',3.47),('9303','2013-07-22','15:20:00',3.47),('9303','2013-07-22','15:25:00',3.04),('9303','2013-07-22','15:40:00',2.4),('9303','2013-07-22','15:45:00',3.5),('9303','2013-07-22','15:50:00',3.48),('9303','2013-07-22','15:55:00',3.54),('9303','2013-07-22','16:00:00',3.51),('9303','2013-07-22','16:05:00',2.95),('9303','2013-07-22','16:10:00',1.65),('9303','2013-07-22','16:15:00',3.15),('9303','2013-07-22','16:20:00',3.26),('9303','2013-07-22','16:25:00',3.09),('9303','2013-07-22','16:30:00',2.92),('9303','2013-07-22','16:35:00',2.83),('9303','2013-07-22','16:40:00',2.66),('9303','2013-07-22','16:45:00',2.59),('9303','2013-07-22','16:50:00',2.52),('9303','2013-07-22','16:55:00',2.43),('9303','2013-07-22','17:00:00',2.4),('9303','2013-07-22','17:05:00',2.37),('9303','2013-07-22','17:10:00',2.29),('9303','2013-07-22','17:15:00',2.15),('9303','2013-07-22','17:20:00',2.06),('9303','2013-07-22','17:25:00',1.92),('9303','2013-07-22','17:30:00',1.89),('9303','2013-07-22','17:35:00',1.84),('9303','2013-07-22','17:40:00',1.75),('9303','2013-07-22','17:45:00',1.5),('9303','2013-07-22','17:50:00',1.51),('9303','2013-07-22','17:55:00',1.45),('9303','2013-07-22','18:00:00',1.42),('9303','2013-07-22','18:05:00',1.31),('9303','2013-07-22','18:10:00',1.18),('9303','2013-07-22','18:15:00',1.09),('9303','2013-07-22','18:20:00',1.01),('9303','2013-07-21','08:05:00',1.04),('9303','2013-07-21','08:10:00',1.15),('9303','2013-07-21','08:15:00',1.22),('9303','2013-07-21','08:20:00',1.3),('9303','2013-07-21','08:25:00',1.39),('9303','2013-07-21','08:30:00',1.47),('9303','2013-07-21','08:35:00',1.55),('9303','2013-07-21','08:40:00',1.62),('9303','2013-07-21','08:45:00',1.68),('9303','2013-07-21','08:50:00',1.77),('9303','2013-07-21','08:55:00',1.87),('9303','2013-07-21','09:00:00',1.97),('9303','2013-07-21','09:05:00',2.03),('9303','2013-07-21','09:10:00',2.11),('9303','2013-07-21','09:15:00',2.16),('9303','2013-07-21','09:20:00',2.21),('9303','2013-07-21','09:25:00',2.29),('9303','2013-07-21','09:30:00',2.37),('9303','2013-07-21','09:35:00',2.42),('9303','2013-07-21','09:40:00',2.49),('9303','2013-07-21','09:45:00',2.55),('9303','2013-07-21','09:50:00',2.6),('9303','2013-07-21','09:55:00',2.67),('9303','2013-07-21','10:00:00',2.73),('9303','2013-07-21','10:05:00',2.79),('9303','2013-07-21','10:10:00',2.83),('9303','2013-07-21','10:15:00',2.88),('9303','2013-07-21','10:20:00',2.95),('9303','2013-07-21','10:25:00',3),('9303','2013-07-21','10:30:00',3.02),('9303','2013-07-21','10:35:00',3.06),('9303','2013-07-21','10:40:00',3.14),('9303','2013-07-21','10:45:00',3.2),('9303','2013-07-21','10:50:00',3.26),('9303','2013-07-21','10:55:00',3.28),('9303','2013-07-21','11:00:00',3.29),('9303','2013-07-21','11:05:00',3.3),('9303','2013-07-21','11:10:00',3.34),('9303','2013-07-21','11:15:00',3.39),('9303','2013-07-21','11:20:00',3.46),('9303','2013-07-21','11:25:00',3.49),('9303','2013-07-21','11:30:00',3.52),('9303','2013-07-21','11:35:00',3.57),('9303','2013-07-21','11:40:00',3.72),('9303','2013-07-21','11:45:00',3.48),('9303','2013-07-21','11:50:00',3.73),('9303','2013-07-21','11:55:00',3.72),('9303','2013-07-21','12:00:00',3.69),('9303','2013-07-21','12:05:00',3.77),('9303','2013-07-21','12:10:00',3.74),('9303','2013-07-21','12:15:00',3.99),('9303','2013-07-21','12:20:00',4.1),('9303','2013-07-21','12:25:00',4.22),('9303','2013-07-21','12:30:00',4.36),('9303','2013-07-21','12:35:00',4.44),('9303','2013-07-21','12:40:00',4.25),('9303','2013-07-21','12:45:00',3.37),('9303','2013-07-21','12:50:00',2.61),('9303','2013-07-21','12:55:00',4.68),('9303','2013-07-21','13:00:00',4.35),('9303','2013-07-21','13:05:00',4.48),('9303','2013-07-21','13:10:00',3.77),('9303','2013-07-21','13:15:00',3.23),('9303','2013-07-21','13:20:00',3.5),('9303','2013-07-21','13:25:00',4.22),('9303','2013-07-21','13:30:00',4.22),('9303','2013-07-21','13:35:00',2.98),('9303','2013-07-21','13:40:00',2.31),('9303','2013-07-21','13:45:00',1.79),('9303','2013-07-21','14:20:00',1.06),('9303','2013-07-21','14:25:00',1.17),('9303','2013-07-21','14:30:00',1.1),('9303','2013-07-21','14:35:00',1.18),('9303','2013-07-21','14:40:00',1.11),('9303','2013-07-21','14:45:00',2.15),('9303','2013-07-21','14:50:00',3.15),('9303','2013-07-21','14:55:00',1.53),('9303','2013-07-21','15:00:00',1.97),('9303','2013-07-21','15:05:00',1.37),('9303','2013-07-21','15:10:00',1.41),('9303','2013-07-21','15:15:00',2.81),('9303','2013-07-21','15:20:00',3.99),('9303','2013-07-21','15:25:00',1.44),('9303','2013-07-21','15:30:00',1.29),('9303','2013-07-21','15:35:00',1.45),('9303','2013-07-21','15:40:00',3.35),('9303','2013-07-21','15:45:00',2.23),('9303','2013-07-21','15:50:00',2.43),('9303','2013-07-21','15:55:00',1.97),('9303','2013-07-21','16:00:00',1.27),('9303','2013-07-21','17:00:00',1.05),('9303','2013-07-21','17:05:00',1.16),('9303','2013-07-21','17:10:00',1.13),('9303','2014-04-07','08:30:00',1.07),('9303','2014-04-07','08:35:00',1.48),('9303','2014-04-07','08:40:00',1.52),('9303','2014-04-07','08:45:00',1.58),('9303','2014-04-07','08:50:00',1.33),('9303','2014-04-07','08:55:00',1.09),('9303','2014-04-07','09:00:00',1.08),('9303','2014-04-07','09:05:00',1.12),('9303','2014-04-07','09:10:00',1.27),('9303','2014-04-07','09:15:00',1.36),('9303','2014-04-07','09:20:00',1.25),('9303','2014-04-07','11:00:00',1.11),('9303','2014-04-07','11:05:00',1.81),('9303','2014-04-07','11:10:00',2.09),('9303','2014-04-07','11:15:00',2.26),('9303','2014-04-07','11:20:00',2.05),('9303','2014-04-07','11:25:00',1.87),('9303','2014-04-07','11:30:00',1.92),('9303','2014-04-07','11:35:00',1.89),('9303','2014-04-07','11:40:00',1.8),('9303','2014-04-07','16:05:00',1.71),('9303','2014-04-07','16:10:00',3.03),('9303','2014-04-07','16:15:00',2.78),('9303','2014-04-07','16:20:00',2.59),('9303','2014-04-07','16:25:00',2.53),('9303','2014-04-07','16:30:00',2.43),('9303','2014-04-07','16:35:00',1.97),('9303','2014-04-07','16:40:00',1.02),('9303','2014-04-07','16:45:00',2.12),('9303','2014-04-07','16:50:00',2.24),('9303','2014-04-07','16:55:00',2.17),('9303','2014-04-07','17:00:00',2.32),('9303','2014-04-07','17:05:00',2.1),('9303','2014-04-07','17:10:00',1.31),('9303','2014-04-07','17:15:00',1.55),('9303','2013-07-20','08:00:00',1.03),('9303','2013-07-20','08:05:00',1.13),('9303','2013-07-20','08:10:00',1.22),('9303','2013-07-20','08:15:00',1.28),('9303','2013-07-20','08:20:00',1.38),('9303','2013-07-20','08:25:00',1.46),('9303','2013-07-20','08:30:00',1.55),('9303','2013-07-20','08:35:00',1.64),('9303','2013-07-20','08:40:00',1.71),('9303','2013-07-20','08:45:00',1.8),('9303','2013-07-20','08:50:00',1.91),('9303','2013-07-20','08:55:00',2.01),('9303','2013-07-20','09:00:00',2.09),('9303','2013-07-20','09:05:00',2.17),('9303','2013-07-20','09:10:00',2.29),('9303','2013-07-20','09:15:00',2.37),('9303','2013-07-20','09:20:00',2.42),('9303','2013-07-20','09:25:00',2.39),('9303','2013-07-20','09:30:00',2.41),('9303','2013-07-20','09:35:00',2.43),('9303','2013-07-20','09:40:00',2.43),('9303','2013-07-20','09:45:00',2.61),('9303','2013-07-20','09:50:00',2.58),('9303','2013-07-20','09:55:00',2.62),('9303','2013-07-20','10:00:00',2.77),('9303','2013-07-20','10:05:00',2.85),('9303','2013-07-20','10:10:00',2.89),('9303','2013-07-20','10:15:00',2.98),('9303','2013-07-20','10:20:00',3.04),('9303','2013-07-20','10:25:00',3.06),('9303','2013-07-20','10:30:00',3.07),('9303','2013-07-20','10:35:00',3.14),('9303','2013-07-20','10:40:00',3.18),('9303','2013-07-20','10:45:00',3.25),('9303','2013-07-20','10:50:00',3.29),('9303','2013-07-20','10:55:00',3.32),('9303','2013-07-20','11:00:00',3.36),('9303','2013-07-20','11:05:00',3.37),('9303','2013-07-20','11:10:00',3.42),('9303','2013-07-20','11:15:00',3.48),('9303','2013-07-20','11:20:00',3.47),('9303','2013-07-20','11:25:00',3.52),('9303','2013-07-20','11:30:00',3.56),('9303','2013-07-20','11:35:00',3.59),('9303','2013-07-20','11:40:00',3.61),('9303','2013-07-20','11:45:00',3.65),('9303','2013-07-20','11:50:00',3.68),('9303','2013-07-20','11:55:00',3.72),('9303','2013-07-20','12:00:00',3.83),('9303','2013-07-20','12:05:00',3.85),('9303','2013-07-20','12:10:00',3.88),('9303','2013-07-20','12:15:00',3.8),('9303','2013-07-20','12:20:00',3.17),('9303','2013-07-20','12:25:00',3.86),('9303','2013-07-20','12:30:00',3.85),('9303','2013-07-20','12:35:00',3.89),('9303','2013-07-20','12:40:00',3.97),('9303','2013-07-20','12:45:00',4.05),('9303','2013-07-20','12:50:00',4.04),('9303','2013-07-20','12:55:00',4.11),('9303','2013-07-20','13:00:00',4.06),('9303','2013-07-20','13:05:00',3.49),('9303','2013-07-20','13:10:00',2.54),('9303','2013-07-20','13:15:00',2.17),('9303','2013-07-20','13:20:00',2.76),('9303','2013-07-20','13:25:00',3.83),('9303','2013-07-20','13:30:00',4.14),('9303','2013-07-20','13:35:00',4.1),('9303','2013-07-20','13:40:00',4.2),('9303','2013-07-20','13:45:00',4.06),('9303','2013-07-20','13:50:00',1.62),('9303','2013-07-20','14:00:00',3.44),('9303','2013-07-20','14:05:00',4.22),('9303','2013-07-20','14:10:00',4.04),('9303','2013-07-20','14:15:00',3.16),('9303','2013-07-20','14:20:00',3.43),('9303','2013-07-20','14:25:00',4.05),('9303','2013-07-20','14:30:00',3.99),('9303','2013-07-20','14:35:00',4),('9303','2013-07-20','14:40:00',2.97),('9303','2013-07-20','14:45:00',1.9),('9303','2013-07-20','14:50:00',2.23),('9303','2013-07-20','14:55:00',1.06),('9303','2013-07-20','15:00:00',2.51),('9303','2013-07-20','15:05:00',3.84),('9303','2013-07-20','15:10:00',3.75),('9303','2013-07-20','15:15:00',3.63),('9303','2013-07-20','15:20:00',3.55),('9303','2013-07-20','15:25:00',3.49),('9303','2013-07-20','15:30:00',3.44),('9303','2013-07-20','15:35:00',3.41),('9303','2013-07-20','15:40:00',3.35),('9303','2013-07-20','15:45:00',3.28),('9303','2013-07-20','15:50:00',3.2),('9303','2013-07-20','15:55:00',3.19),('9303','2013-07-20','16:00:00',3.16),('9303','2013-07-20','16:05:00',3.08),('9303','2013-07-20','16:10:00',3.03),('9303','2013-07-20','16:15:00',3.01),('9303','2013-07-20','16:20:00',2.96),('9303','2013-07-20','16:25:00',2.89),('9303','2013-07-20','16:30:00',2.82),('9303','2013-07-20','16:35:00',2.76),('9303','2013-07-20','16:40:00',2.69),('9303','2013-07-20','16:45:00',2.61),('9303','2013-07-20','16:50:00',2.54),('9303','2013-07-20','16:55:00',2.46),('9303','2013-07-20','17:00:00',2.37),('9303','2013-07-20','17:05:00',2.33),('9303','2013-07-20','17:10:00',2.26),('9303','2013-07-20','17:15:00',2.15),('9303','2013-07-20','17:20:00',2.05),('9303','2013-07-20','17:25:00',1.95),('9303','2013-07-20','17:30:00',1.88),('9303','2013-07-20','17:35:00',1.83),('9303','2013-07-20','17:40:00',1.74),('9303','2013-07-20','17:45:00',1.64),('9303','2013-07-20','17:50:00',1.57),('9303','2013-07-20','17:55:00',1.49),('9303','2013-07-20','18:00:00',1.43),('9303','2013-07-20','18:05:00',1.32),('9303','2013-07-20','18:10:00',1.23),('9303','2013-07-20','18:15:00',1.16),('9303','2013-07-20','18:20:00',1.07),('9303','2013-07-19','08:00:00',1.01),('9303','2013-07-19','08:05:00',1.09),('9303','2013-07-19','08:10:00',1.18),('9303','2013-07-19','08:15:00',1.26),('9303','2013-07-19','08:20:00',1.35),('9303','2013-07-19','08:25:00',1.42),('9303','2013-07-19','08:30:00',1.48),('9303','2013-07-19','08:35:00',1.57),('9303','2013-07-19','08:40:00',1.65),('9303','2013-07-19','08:45:00',1.73),('9303','2013-07-19','08:50:00',1.82),('9303','2013-07-19','08:55:00',1.92),('9303','2013-07-19','09:00:00',1.97),('9303','2013-07-19','09:05:00',2.04),('9303','2013-07-19','09:10:00',2.1),('9303','2013-07-19','09:15:00',2.16),('9303','2013-07-19','09:20:00',2.22),('9303','2013-07-19','09:25:00',2.3),('9303','2013-07-19','09:30:00',2.36),('9303','2013-07-19','09:35:00',2.42),('9303','2013-07-19','09:40:00',2.47),('9303','2013-07-19','09:45:00',2.53),('9303','2013-07-19','09:50:00',2.59),('9303','2013-07-19','09:55:00',2.63),('9303','2013-07-19','10:00:00',2.69),('9303','2013-07-19','10:05:00',2.72),('9303','2013-07-19','10:10:00',2.78),('9303','2013-07-19','10:15:00',2.85),('9303','2013-07-19','10:20:00',2.88),('9303','2013-07-19','10:25:00',3),('9303','2013-07-19','10:30:00',2.97),('9303','2013-07-19','10:35:00',3.08),('9303','2013-07-19','10:40:00',3.12),('9303','2013-07-19','10:45:00',3.13),('9303','2013-07-19','10:50:00',3.16),('9303','2013-07-19','10:55:00',3.19),('9303','2013-07-19','11:00:00',3.22),('9303','2013-07-19','11:05:00',3.21),('9303','2013-07-19','11:10:00',3.23),('9303','2013-07-19','11:15:00',3.28),('9303','2013-07-19','11:20:00',3.3),('9303','2013-07-19','11:25:00',3.35),('9303','2013-07-19','11:30:00',3.39),('9303','2013-07-19','11:35:00',3.37),('9303','2013-07-19','11:40:00',3.49),('9303','2013-07-19','11:45:00',3.6),('9303','2013-07-19','11:50:00',3.51),('9303','2013-07-19','11:55:00',3.1),('9303','2013-07-19','12:00:00',2.54),('9303','2013-07-19','12:05:00',3.35),('9303','2013-07-19','12:10:00',3.66),('9303','2013-07-19','12:15:00',3.76),('9303','2013-07-19','12:20:00',3.75),('9303','2013-07-19','12:25:00',3.8),('9303','2013-07-19','12:30:00',3.74),('9303','2013-07-19','12:35:00',3.7),('9303','2013-07-19','12:40:00',3.69),('9303','2013-07-19','12:45:00',3.72),('9303','2013-07-19','12:50:00',3.78),('9303','2013-07-19','12:55:00',3.46),('9303','2013-07-19','13:00:00',3.57),('9303','2013-07-19','13:05:00',3.97),('9303','2013-07-19','13:10:00',4),('9303','2013-07-19','13:15:00',2.61),('9303','2013-07-19','13:20:00',4.1),('9303','2013-07-19','13:25:00',4.18),('9303','2013-07-19','13:30:00',4.04),('9303','2013-07-19','13:35:00',4.03),('9303','2013-07-19','13:40:00',4.01),('9303','2013-07-19','13:45:00',3.99),('9303','2013-07-19','13:50:00',4.03),('9303','2013-07-19','13:55:00',4.03),('9303','2013-07-19','14:00:00',4.03),('9303','2013-07-19','14:05:00',3.99),('9303','2013-07-19','14:10:00',3.33),('9303','2013-07-19','14:15:00',3.74),('9303','2013-07-19','14:20:00',3.86),('9303','2013-07-19','14:25:00',3.51),('9303','2013-07-19','14:30:00',3.86),('9303','2013-07-19','14:35:00',3.85),('9303','2013-07-19','14:40:00',3.8),('9303','2013-07-19','14:45:00',3.79),('9303','2013-07-19','14:50:00',3.77),('9303','2013-07-19','14:55:00',3.76),('9303','2013-07-19','15:00:00',3.37),('9303','2013-07-19','15:05:00',3.73),('9303','2013-07-19','15:10:00',3.61),('9303','2013-07-19','15:15:00',3.14),('9303','2013-07-19','15:20:00',2.61),('9303','2013-07-19','15:25:00',2.96),('9303','2013-07-19','15:30:00',3.66),('9303','2013-07-19','15:35:00',3.32),('9303','2013-07-19','15:40:00',2.72),('9303','2013-07-19','15:45:00',3.45),('9303','2013-07-19','15:50:00',3.12),('9303','2013-07-19','15:55:00',3.31),('9303','2013-07-19','16:00:00',3.22),('9303','2013-07-19','16:05:00',3.17),('9303','2013-07-19','16:10:00',3.1),('9303','2013-07-19','16:15:00',3.07),('9303','2013-07-19','16:20:00',3.05),('9303','2013-07-19','16:25:00',3.01),('9303','2013-07-19','16:30:00',2.97),('9303','2013-07-19','16:35:00',2.92),('9303','2013-07-19','16:40:00',2.87),('9303','2013-07-19','16:45:00',2.82),('9303','2013-07-19','16:50:00',2.62),('9303','2013-07-19','16:55:00',2.57),('9303','2013-07-19','17:00:00',2.16),('9303','2013-07-19','17:05:00',2.62),('9303','2013-07-19','17:10:00',2.64),('9303','2013-07-19','17:15:00',2.04),('9303','2013-07-19','17:20:00',1.85),('9303','2013-07-19','17:25:00',1.71),('9303','2013-07-19','17:30:00',1.71),('9303','2013-07-19','17:35:00',1.91),('9303','2013-07-19','17:40:00',1.44),('9303','2013-07-19','17:45:00',1.19),('9303','2013-07-18','07:55:00',1),('9303','2013-07-18','08:00:00',1.07),('9303','2013-07-18','08:05:00',1.17),('9303','2013-07-18','08:10:00',1.26),('9303','2013-07-18','08:15:00',1.34),('9303','2013-07-18','08:20:00',1.44),('9303','2013-07-18','08:25:00',1.51),('9303','2013-07-18','08:30:00',1.58),('9303','2013-07-18','08:35:00',1.67),('9303','2013-07-18','08:40:00',1.74),('9303','2013-07-18','08:45:00',1.81),('9303','2013-07-18','08:50:00',1.88),('9303','2013-07-18','08:55:00',2),('9303','2013-07-18','09:00:00',2.06),('9303','2013-07-18','09:05:00',2.13),('9303','2013-07-18','09:10:00',2.2),('9303','2013-07-18','09:15:00',2.26),('9303','2013-07-18','09:20:00',2.33),('9303','2013-07-18','09:25:00',2.4),('9303','2013-07-18','09:30:00',2.48),('9303','2013-07-18','09:35:00',2.54),('9303','2013-07-18','09:40:00',2.6),('9303','2013-07-18','09:45:00',2.66),('9303','2013-07-18','09:50:00',2.71),('9303','2013-07-18','09:55:00',2.76),('9303','2013-07-18','10:00:00',2.82),('9303','2013-07-18','10:05:00',2.88),('9303','2013-07-18','10:10:00',2.94),('9303','2013-07-18','10:15:00',2.96),('9303','2013-07-18','10:20:00',3.02),('9303','2013-07-18','10:25:00',3.05),('9303','2013-07-18','10:30:00',3.12),('9303','2013-07-18','10:35:00',3.2),('9303','2013-07-18','10:40:00',3.25),('9303','2013-07-18','10:45:00',3.3),('9303','2013-07-18','10:50:00',3.36),('9303','2013-07-18','10:55:00',3.38),('9303','2013-07-18','11:00:00',3.37),('9303','2013-07-18','11:05:00',3.39),('9303','2013-07-18','11:10:00',3.44),('9303','2013-07-18','11:15:00',3.49),('9303','2013-07-18','11:20:00',3.52),('9303','2013-07-18','11:25:00',3.53),('9303','2013-07-18','11:30:00',3.54),('9303','2013-07-18','11:35:00',3.58),('9303','2013-07-18','11:40:00',3.59),('9303','2013-07-18','11:45:00',3.64),('9303','2013-07-18','11:50:00',3.65),('9303','2013-07-18','11:55:00',3.73),('9303','2013-07-18','12:00:00',3.76),('9303','2013-07-18','12:05:00',3.68),('9303','2013-07-18','12:10:00',3.72),('9303','2013-07-18','12:15:00',3.74),('9303','2013-07-18','12:20:00',3.79),('9303','2013-07-18','12:25:00',3.74),('9303','2013-07-18','12:30:00',3.83),('9303','2013-07-18','12:35:00',3.94),('9303','2013-07-18','12:40:00',4.05),('9303','2013-07-18','12:45:00',2.14),('9303','2013-07-18','12:50:00',3.42),('9303','2013-07-18','12:55:00',3.99),('9303','2013-07-18','13:00:00',3.97),('9303','2013-07-18','13:05:00',3.99),('9303','2013-07-18','13:10:00',3.9),('9303','2013-07-18','13:15:00',3.82),('9303','2013-07-18','13:20:00',3.87),('9303','2013-07-18','13:25:00',4.07),('9303','2013-07-18','13:30:00',4.02),('9303','2013-07-18','13:35:00',3.98),('9303','2013-07-18','13:40:00',4.15),('9303','2013-07-18','13:45:00',4.07),('9303','2013-07-18','13:50:00',2.47),('9303','2013-07-18','13:55:00',3.68),('9303','2013-07-18','14:00:00',3.94),('9303','2013-07-18','14:05:00',3.85),('9303','2013-07-18','14:10:00',3.85),('9303','2013-07-18','14:15:00',3.92),('9303','2013-07-18','14:20:00',3.89),('9303','2013-07-18','14:25:00',3.85),('9303','2013-07-18','14:30:00',3.76),('9303','2013-07-18','14:35:00',3.79),('9303','2013-07-18','14:40:00',3.75),('9303','2013-07-18','14:45:00',3.72),('9303','2013-07-18','14:50:00',3.7),('9303','2013-07-18','14:55:00',3.6),('9303','2013-07-18','15:00:00',3.6),('9303','2013-07-18','15:05:00',3.61),('9303','2013-07-18','15:10:00',3.57),('9303','2013-07-18','15:15:00',3.49),('9303','2013-07-18','15:20:00',3.46),('9303','2013-07-18','15:25:00',3.45),('9303','2013-07-18','15:30:00',3.41),('9303','2013-07-18','15:35:00',3.35),('9303','2013-07-18','15:40:00',3.31),('9303','2013-07-18','15:45:00',3.25),('9303','2013-07-18','15:50:00',3.22),('9303','2013-07-18','15:55:00',3.16),('9303','2013-07-18','16:00:00',3.12),('9303','2013-07-18','16:05:00',3.05),('9303','2013-07-18','16:10:00',3.01),('9303','2013-07-18','16:15:00',2.94),('9303','2013-07-18','16:20:00',2.89),('9303','2013-07-18','16:25:00',2.82),('9303','2013-07-18','16:30:00',2.76),('9303','2013-07-18','16:35:00',2.72),('9303','2013-07-18','16:40:00',2.65),('9303','2013-07-18','16:45:00',2.58),('9303','2013-07-18','16:50:00',2.5),('9303','2013-07-18','16:55:00',2.43),('9303','2013-07-18','17:00:00',2.32),('9303','2013-07-18','17:05:00',2.27),('9303','2013-07-18','17:10:00',2.16),('9303','2013-07-18','17:15:00',2.04),('9303','2013-07-18','17:20:00',1.84),('9303','2013-07-18','17:25:00',1.9),('9303','2013-07-18','17:30:00',1.79),('9303','2013-07-18','17:35:00',1.73),('9303','2013-07-18','17:40:00',1.55),('9303','2013-07-18','17:45:00',1.4),('9303','2013-07-18','17:50:00',1.35),('9303','2013-07-18','17:55:00',1.43),('9303','2013-07-18','18:00:00',1.3),('9303','2013-07-18','18:05:00',1.22),('9303','2013-07-18','18:10:00',1.13),('9303','2013-07-18','18:15:00',1.07),('9303','2013-07-17','07:55:00',1.01),('9303','2013-07-17','08:00:00',1.09),('9303','2013-07-17','08:05:00',1.21),('9303','2013-07-17','08:10:00',1.31),('9303','2013-07-17','08:15:00',1.38),('9303','2013-07-17','08:20:00',1.49),('9303','2013-07-17','08:25:00',1.59),('9303','2013-07-17','08:30:00',1.66),('9303','2013-07-17','08:35:00',1.75),('9303','2013-07-17','08:40:00',1.83),('9303','2013-07-17','08:45:00',1.91),('9303','2013-07-17','08:50:00',1.99),('9303','2013-07-17','08:55:00',2.08),('9303','2013-07-17','09:00:00',2.17),('9303','2013-07-17','09:05:00',2.26),('9303','2013-07-17','09:10:00',2.34),('9303','2013-07-17','09:15:00',2.43),('9303','2013-07-17','09:20:00',2.49),('9303','2013-07-17','09:25:00',2.55),('9303','2013-07-17','09:30:00',2.6),('9303','2013-07-17','09:35:00',2.66),('9303','2013-07-17','09:40:00',2.72),('9303','2013-07-17','09:45:00',2.8),('9303','2013-07-17','09:50:00',2.84),('9303','2013-07-17','09:55:00',2.89),('9303','2013-07-17','10:00:00',2.93),('9303','2013-07-17','10:05:00',3),('9303','2013-07-17','10:10:00',3.05),('9303','2013-07-17','10:15:00',3.09),('9303','2013-07-17','10:20:00',3.14),('9303','2013-07-17','10:25:00',3.19),('9303','2013-07-17','10:30:00',3.24),('9303','2013-07-17','10:35:00',3.28),('9303','2013-07-17','10:40:00',3.32),('9303','2013-07-17','10:45:00',3.39),('9303','2013-07-17','10:50:00',3.44),('9303','2013-07-17','10:55:00',3.48),('9303','2013-07-17','11:00:00',3.53),('9303','2013-07-17','11:05:00',3.6),('9303','2013-07-17','11:10:00',3.61),('9303','2013-07-17','11:15:00',3.62),('9303','2013-07-17','11:20:00',3.67),('9303','2013-07-17','11:25:00',3.71),('9303','2013-07-17','11:30:00',3.72),('9303','2013-07-17','11:35:00',3.78),('9303','2013-07-17','11:40:00',3.79),('9303','2013-07-17','11:45:00',3.83),('9303','2013-07-17','11:50:00',3.84),('9303','2013-07-17','11:55:00',3.87),('9303','2013-07-17','12:00:00',3.92),('9303','2013-07-17','12:05:00',3.91),('9303','2013-07-17','12:10:00',3.95),('9303','2013-07-17','12:15:00',3.92),('9303','2013-07-17','12:20:00',3.91),('9303','2013-07-17','12:25:00',3.95),('9303','2013-07-17','12:30:00',3.94),('9303','2013-07-17','12:35:00',3.91),('9303','2013-07-17','12:40:00',3.9),('9303','2013-07-17','12:45:00',3.93),('9303','2013-07-17','12:50:00',3.96),('9303','2013-07-17','12:55:00',4.02),('9303','2013-07-17','13:00:00',4.03),('9303','2013-07-17','13:05:00',4.02),('9303','2013-07-17','13:10:00',4),('9303','2013-07-17','13:15:00',3.98),('9303','2013-07-17','13:20:00',3.95),('9303','2013-07-17','13:25:00',3.94),('9303','2013-07-17','13:30:00',3.95),('9303','2013-07-17','13:35:00',3.91),('9303','2013-07-17','13:40:00',3.91),('9303','2013-07-17','13:45:00',3.92),('9303','2013-07-17','13:50:00',3.91),('9303','2013-07-17','13:55:00',3.95),('9303','2013-07-17','14:00:00',3.96),('9303','2013-07-17','14:05:00',3.9),('9303','2013-07-17','14:10:00',3.86),('9303','2013-07-17','14:15:00',3.83),('9303','2013-07-17','14:20:00',3.8),('9303','2013-07-17','14:25:00',3.8),('9303','2013-07-17','14:30:00',3.77),('9303','2013-07-17','14:35:00',3.77),('9303','2013-07-17','14:40:00',3.92),('9303','2013-07-17','14:45:00',3.8),('9303','2013-07-17','14:50:00',3.71),('9303','2013-07-17','14:55:00',3.69),('9303','2013-07-17','15:00:00',3.56),('9303','2013-07-17','15:05:00',2.57),('9303','2013-07-17','15:10:00',2.81),('9303','2013-07-17','15:15:00',3.68),('9303','2013-07-17','15:20:00',3.61),('9303','2013-07-17','15:25:00',3.4),('9303','2013-07-17','15:30:00',3.46),('9303','2013-07-17','15:35:00',3.43),('9303','2013-07-17','15:40:00',2.56),('9303','2013-07-17','15:45:00',3.37),('9303','2013-07-17','15:50:00',3.08),('9303','2013-07-17','15:55:00',3.28),('9303','2013-07-17','16:00:00',3.2),('9303','2013-07-17','16:05:00',3.15),('9303','2013-07-17','16:10:00',3.11),('9303','2013-07-17','16:15:00',3.03),('9303','2013-07-17','16:20:00',2.97),('9303','2013-07-17','16:25:00',2.89),('9303','2013-07-17','16:30:00',2.81),('9303','2013-07-17','16:35:00',2.75),('9303','2013-07-17','16:40:00',2.73),('9303','2013-07-17','16:45:00',2.72),('9303','2013-07-17','16:50:00',2.6),('9303','2013-07-17','16:55:00',2.51),('9303','2013-07-17','17:00:00',2.13),('9303','2013-07-17','17:05:00',2.37),('9303','2013-07-17','17:10:00',2.4),('9303','2013-07-17','17:15:00',2.24),('9303','2013-07-17','17:20:00',2.11),('9303','2013-07-17','17:25:00',1.96),('9303','2013-07-17','17:30:00',1.88),('9303','2013-07-17','17:35:00',1.8),('9303','2013-07-17','17:40:00',1.7),('9303','2013-07-17','17:45:00',1.66),('9303','2013-07-17','17:50:00',1.59),('9303','2013-07-17','17:55:00',1.49),('9303','2013-07-17','18:00:00',1.43),('9303','2013-07-17','18:05:00',1.35),('9303','2013-07-17','18:10:00',1.27),('9303','2013-07-17','18:15:00',1.19),('9303','2013-07-17','18:20:00',1.1),('9303','2013-07-16','07:55:00',1.03),('9303','2013-07-16','08:00:00',1.08),('9303','2013-07-16','08:05:00',1.18),('9303','2013-07-16','08:10:00',1.27),('9303','2013-07-16','08:15:00',1.35),('9303','2013-07-16','08:20:00',1.44),('9303','2013-07-16','08:25:00',1.54),('9303','2013-07-16','08:30:00',1.61),('9303','2013-07-16','08:35:00',1.67),('9303','2013-07-16','08:40:00',1.7),('9303','2013-07-16','08:45:00',1.8),('9303','2013-07-16','08:50:00',1.89),('9303','2013-07-16','08:55:00',1.99),('9303','2013-07-16','09:00:00',2.06),('9303','2013-07-16','09:05:00',2.13),('9303','2013-07-16','09:10:00',2.21),('9303','2013-07-16','09:15:00',2.26),('9303','2013-07-16','09:20:00',2.33),('9303','2013-07-16','09:25:00',2.4),('9303','2013-07-16','09:30:00',2.47),('9303','2013-07-16','09:35:00',2.53),('9303','2013-07-16','09:40:00',2.6),('9303','2013-07-16','09:45:00',2.68),('9303','2013-07-16','09:50:00',2.77),('9303','2013-07-16','09:55:00',2.83),('9303','2013-07-16','10:00:00',2.89),('9303','2013-07-16','10:05:00',2.96),('9303','2013-07-16','10:10:00',3.02),('9303','2013-07-16','10:15:00',3.07),('9303','2013-07-16','10:20:00',3.1),('9303','2013-07-16','10:25:00',3.15),('9303','2013-07-16','10:30:00',3.18),('9303','2013-07-16','10:35:00',3.24),('9303','2013-07-16','10:40:00',3.31),('9303','2013-07-16','10:45:00',3.33),('9303','2013-07-16','10:50:00',3.35),('9303','2013-07-16','10:55:00',3.4),('9303','2013-07-16','11:00:00',3.43),('9303','2013-07-16','11:05:00',3.46),('9303','2013-07-16','11:10:00',3.53),('9303','2013-07-16','11:15:00',3.55),('9303','2013-07-16','11:20:00',3.59),('9303','2013-07-16','11:25:00',3.64),('9303','2013-07-16','11:30:00',3.65),('9303','2013-07-16','11:35:00',3.67),('9303','2013-07-16','11:40:00',3.72),('9303','2013-07-16','11:45:00',3.77),('9303','2013-07-16','11:50:00',3.84),('9303','2013-07-16','11:55:00',3.86),('9303','2013-07-16','12:00:00',3.88),('9303','2013-07-16','12:05:00',3.9),('9303','2013-07-16','12:10:00',3.93),('9303','2013-07-16','12:15:00',3.98),('9303','2013-07-16','12:20:00',3.96),('9303','2013-07-16','12:25:00',3.95),('9303','2013-07-16','12:30:00',3.93),('9303','2013-07-16','12:35:00',3.93),('9303','2013-07-16','12:40:00',3.93),('9303','2013-07-16','12:45:00',3.9),('9303','2013-07-16','12:50:00',3.9),('9303','2013-07-16','12:55:00',3.9),('9303','2013-07-16','13:00:00',3.95),('9303','2013-07-16','13:05:00',3.99),('9303','2013-07-16','13:10:00',3.96),('9303','2013-07-16','13:15:00',4.03),('9303','2013-07-16','13:20:00',3.98),('9303','2013-07-16','13:25:00',4),('9303','2013-07-16','13:30:00',3.97),('9303','2013-07-16','13:35:00',3.95),('9303','2013-07-16','13:40:00',3.98),('9303','2013-07-16','13:45:00',4.07),('9303','2013-07-16','13:50:00',3.99),('9303','2013-07-16','13:55:00',3.75),('9303','2013-07-16','14:00:00',3.9),('9303','2013-07-16','14:05:00',3.94),('9303','2013-07-16','14:10:00',3.25),('9303','2013-07-16','14:15:00',3.23),('9303','2013-07-16','14:20:00',1.98),('9303','2013-07-16','14:25:00',3.98),('9303','2013-07-16','14:30:00',3.9),('9303','2013-07-16','14:35:00',3.89),('9303','2013-07-16','14:40:00',3.84),('9303','2013-07-16','14:45:00',3.78),('9303','2013-07-16','14:50:00',3.78),('9303','2013-07-16','14:55:00',3.78),('9303','2013-07-16','15:00:00',3.71),('9303','2013-07-16','15:05:00',3.64),('9303','2013-07-16','15:10:00',3.54),('9303','2013-07-16','15:15:00',3.51),('9303','2013-07-16','15:20:00',3.54),('9303','2013-07-16','15:25:00',3.52),('9303','2013-07-16','15:30:00',3.5),('9303','2013-07-16','15:35:00',3.42),('9303','2013-07-16','15:40:00',2.98),('9303','2013-07-16','15:45:00',2.18),('9303','2013-07-16','15:50:00',3.33),('9303','2013-07-16','15:55:00',3.27),('9303','2013-07-16','16:00:00',1.87),('9303','2013-07-16','16:05:00',1.67),('9303','2013-07-16','16:10:00',3.12),('9303','2013-07-16','16:15:00',2.51),('9303','2013-07-16','16:20:00',1.71),('9303','2013-07-16','16:25:00',1.11),('9303','2013-07-16','16:30:00',1.02),('9303','2013-07-16','16:45:00',1.2),('9303','2013-07-16','16:50:00',1.16),('9303','2013-07-16','16:55:00',1.64),('9303','2013-07-16','17:00:00',2.64),('9303','2013-07-16','17:05:00',2.71),('9303','2013-07-16','17:10:00',2.57),('9303','2013-07-16','17:15:00',2.48),('9303','2013-07-16','17:20:00',1.56),('9303','2013-07-16','17:25:00',1.24),('9303','2013-07-16','17:30:00',1.31),('9303','2013-07-16','17:35:00',1.74),('9303','2013-07-16','17:40:00',1.73),('9303','2013-07-16','17:45:00',1.81),('9303','2013-07-16','17:50:00',1.7),('9303','2013-07-16','17:55:00',1.24),('9303','2013-07-16','18:15:00',1.17),('9303','2013-07-16','18:20:00',1.05),('9303','2013-07-15','07:55:00',1.04),('9303','2013-07-15','08:00:00',1.13),('9303','2013-07-15','08:05:00',1.23),('9303','2013-07-15','08:10:00',1.31),('9303','2013-07-15','08:15:00',1.4),('9303','2013-07-15','08:20:00',1.51),('9303','2013-07-15','08:25:00',1.58),('9303','2013-07-15','08:30:00',1.67),('9303','2013-07-15','08:35:00',1.75),('9303','2013-07-15','08:40:00',1.83),('9303','2013-07-15','08:45:00',1.91),('9303','2013-07-15','08:50:00',1.99),('9303','2013-07-15','08:55:00',2.07),('9303','2013-07-15','09:00:00',2.16),('9303','2013-07-15','09:05:00',2.24),('9303','2013-07-15','09:10:00',2.28),('9303','2013-07-15','09:15:00',2.39),('9303','2013-07-15','09:20:00',2.45),('9303','2013-07-15','09:25:00',2.53),('9303','2013-07-15','09:30:00',2.59),('9303','2013-07-15','09:35:00',2.65),('9303','2013-07-15','09:40:00',2.72),('9303','2013-07-15','09:45:00',2.76),('9303','2013-07-15','09:50:00',2.83),('9303','2013-07-15','09:55:00',2.9),('9303','2013-07-15','10:00:00',2.92),('9303','2013-07-15','10:05:00',2.96),('9303','2013-07-15','10:10:00',3.02),('9303','2013-07-15','10:15:00',3.07),('9303','2013-07-15','10:20:00',3.08),('9303','2013-07-15','10:25:00',3.16),('9303','2013-07-15','10:30:00',3.19),('9303','2013-07-15','10:35:00',3.23),('9303','2013-07-15','10:40:00',3.27),('9303','2013-07-15','10:45:00',3.31),('9303','2013-07-15','10:50:00',3.36),('9303','2013-07-15','10:55:00',3.41),('9303','2013-07-15','11:00:00',3.46),('9303','2013-07-15','11:05:00',3.46),('9303','2013-07-15','11:10:00',3.49),('9303','2013-07-15','11:15:00',3.52),('9303','2013-07-15','11:20:00',3.55),('9303','2013-07-15','11:25:00',3.61),('9303','2013-07-15','11:30:00',3.67),('9303','2013-07-15','11:35:00',3.72),('9303','2013-07-15','11:40:00',3.75),('9303','2013-07-15','11:45:00',3.75),('9303','2013-07-15','11:50:00',3.71),('9303','2013-07-15','11:55:00',3.81),('9303','2013-07-15','12:00:00',3.84),('9303','2013-07-15','12:05:00',3.79),('9303','2013-07-15','12:10:00',3.82),('9303','2013-07-15','12:15:00',3.92),('9303','2013-07-15','12:20:00',3.94),('9303','2013-07-15','12:25:00',3.95),('9303','2013-07-15','12:30:00',3.94),('9303','2013-07-15','12:35:00',3.9),('9303','2013-07-15','12:40:00',3.88),('9303','2013-07-15','12:45:00',3.84),('9303','2013-07-15','12:50:00',3.9),('9303','2013-07-15','12:55:00',3.95),('9303','2013-07-15','13:00:00',3.47),('9303','2013-07-15','13:05:00',2.32),('9303','2013-07-15','13:10:00',3.45),('9303','2013-07-15','13:15:00',4.05),('9303','2013-07-15','13:20:00',3.93),('9303','2013-07-15','13:25:00',4.14),('9303','2013-07-15','13:30:00',4.18),('9303','2013-07-15','13:35:00',3.07),('9303','2013-07-15','13:40:00',1.15),('9303','2013-07-15','13:45:00',3.96),('9303','2013-07-15','13:50:00',4.27),('9303','2013-07-15','13:55:00',4.26),('9303','2013-07-15','14:00:00',4.22),('9303','2013-07-15','14:05:00',3.79),('9303','2013-07-15','14:20:00',4.01),('9303','2013-07-15','14:25:00',4.07),('9303','2013-07-15','14:30:00',3.97),('9303','2013-07-15','14:35:00',3.94),('9303','2013-07-15','14:40:00',3.97),('9303','2013-07-15','14:45:00',3.91),('9303','2013-07-15','14:50:00',3.89),('9303','2013-07-15','14:55:00',3.89),('9303','2013-07-15','15:00:00',3.81),('9303','2013-07-15','15:05:00',3.74),('9303','2013-07-15','15:10:00',3.63),('9303','2013-07-15','15:15:00',3.58),('9303','2013-07-15','15:20:00',1.71),('9303','2013-07-15','15:25:00',2.62),('9303','2013-07-15','15:30:00',3.56),('9303','2013-07-15','15:35:00',3.48),('9303','2013-07-15','15:40:00',3.48),('9303','2013-07-15','15:45:00',3.26),('9303','2013-07-15','15:50:00',3.42),('9303','2013-07-15','15:55:00',3.22),('9303','2013-07-15','16:00:00',3.16),('9303','2013-07-15','16:05:00',3.13),('9303','2013-07-15','16:10:00',3.1),('9303','2013-07-15','16:15:00',3.05),('9303','2013-07-15','16:20:00',2.89),('9303','2013-07-15','16:25:00',2.8),('9303','2013-07-15','16:30:00',2.79),('9303','2013-07-15','16:35:00',2.76),('9303','2013-07-15','16:40:00',2.67),('9303','2013-07-15','16:45:00',2.61),('9303','2013-07-15','16:50:00',2.54),('9303','2013-07-15','16:55:00',2.49),('9303','2013-07-15','17:00:00',2.43),('9303','2013-07-15','17:05:00',2.36),('9303','2013-07-15','17:10:00',2.28),('9303','2013-07-15','17:15:00',2.17),('9303','2013-07-15','17:20:00',2.08),('9303','2013-07-15','17:25:00',2),('9303','2013-07-15','17:30:00',1.9),('9303','2013-07-15','17:35:00',1.82),('9303','2013-07-15','17:40:00',1.72),('9303','2013-07-15','17:45:00',1.63),('9303','2013-07-15','17:50:00',1.56),('9303','2013-07-15','17:55:00',1.48),('9303','2013-07-15','18:00:00',1.4),('9303','2013-07-15','18:05:00',1.32),('9303','2013-07-15','18:10:00',1.23),('9303','2013-07-15','18:15:00',1.14),('9303','2013-07-15','18:20:00',1.05),('9303','2013-07-14','07:55:00',1.16),('9303','2013-07-14','08:05:00',1.33),('9303','2013-07-14','08:10:00',1.56),('9303','2013-07-14','08:15:00',1.66),('9303','2013-07-14','08:20:00',1.94),('9303','2013-07-14','08:25:00',1.26),('9303','2013-07-14','08:35:00',1.07),('9303','2013-07-14','08:50:00',1.05),('9303','2013-07-14','08:55:00',1.12),('9303','2013-07-14','09:00:00',1.19),('9303','2013-07-14','09:05:00',1.4),('9303','2013-07-14','09:10:00',1.24),('9303','2013-07-14','09:15:00',1.32),('9303','2013-07-14','09:20:00',1.73),('9303','2013-07-14','09:25:00',2.2),('9303','2013-07-14','09:30:00',2),('9303','2013-07-14','09:35:00',1.69),('9303','2013-07-14','09:40:00',1.54),('9303','2013-07-14','09:45:00',1.54),('9303','2013-07-14','09:50:00',1.47),('9303','2013-07-14','09:55:00',1.62),('9303','2013-07-14','10:00:00',1.54),('9303','2013-07-14','10:05:00',1.62),('9303','2013-07-14','10:10:00',1.61),('9303','2013-07-14','10:15:00',1.65),('9303','2013-07-14','10:20:00',2.18),('9303','2013-07-14','10:25:00',2.45),('9303','2013-07-14','10:30:00',2.42),('9303','2013-07-14','10:35:00',3.18),('9303','2013-07-14','10:40:00',3.18),('9303','2013-07-14','10:45:00',3.09),('9303','2013-07-14','10:50:00',3.66),('9303','2013-07-14','10:55:00',3.01),('9303','2013-07-14','11:00:00',3.65),('9303','2013-07-14','11:05:00',3.57),('9303','2013-07-14','11:10:00',3.32),('9303','2013-07-14','11:15:00',1.74),('9303','2013-07-14','11:20:00',2.18),('9303','2013-07-14','11:25:00',3.1),('9303','2013-07-14','11:30:00',2.53),('9303','2013-07-14','11:35:00',2.97),('9303','2013-07-14','11:40:00',3.72),('9303','2013-07-14','11:45:00',4.06),('9303','2013-07-14','11:50:00',2.19),('9303','2013-07-14','11:55:00',4.05),('9303','2013-07-14','12:00:00',2.78),('9303','2013-07-14','12:05:00',3.68),('9303','2013-07-14','12:10:00',3.93),('9303','2013-07-14','12:15:00',3.2),('9303','2013-07-14','12:20:00',2.33),('9303','2013-07-14','12:25:00',3),('9303','2013-07-14','12:30:00',1.26),('9303','2013-07-14','12:35:00',2.01),('9303','2013-07-14','12:40:00',3.22),('9303','2013-07-14','12:45:00',3.79),('9303','2013-07-14','12:50:00',3.19),('9303','2013-07-14','12:55:00',3.61),('9303','2013-07-14','13:00:00',4.34),('9303','2013-07-14','13:05:00',4.38),('9303','2013-07-14','13:10:00',4.2),('9303','2013-07-14','13:15:00',4.18),('9303','2013-07-14','13:20:00',4.22),('9303','2013-07-14','13:25:00',4.15),('9303','2013-07-14','13:30:00',4.14),('9303','2013-07-14','13:35:00',4.11),('9303','2013-07-14','13:40:00',4.07),('9303','2013-07-14','13:45:00',4.08),('9303','2013-07-14','13:50:00',4.13),('9303','2013-07-14','13:55:00',4.1),('9303','2013-07-14','14:00:00',4.1),('9303','2013-07-14','14:05:00',4.09),('9303','2013-07-14','14:10:00',4.07),('9303','2013-07-14','14:15:00',4.03),('9303','2013-07-14','14:20:00',4),('9303','2013-07-14','14:25:00',3.98),('9303','2013-07-14','14:30:00',3.95),('9303','2013-07-14','14:35:00',3.85),('9303','2013-07-14','14:40:00',3.81),('9303','2013-07-14','14:45:00',3.77),('9303','2013-07-14','14:50:00',3.75),('9303','2013-07-14','14:55:00',3.75),('9303','2013-07-14','15:00:00',3.71),('9303','2013-07-14','15:05:00',3.67),('9303','2013-07-14','15:10:00',3.63),('9303','2013-07-14','15:15:00',3.58),('9303','2013-07-14','15:20:00',3.54),('9303','2013-07-14','15:25:00',3.51),('9303','2013-07-14','15:30:00',3.47),('9303','2013-07-14','15:35:00',3.43),('9303','2013-07-14','15:40:00',3.35),('9303','2013-07-14','15:45:00',3.3),('9303','2013-07-14','15:50:00',3.26),('9303','2013-07-14','15:55:00',3.26),('9303','2013-07-14','16:00:00',3.18),('9303','2013-07-14','16:05:00',3.1),('9303','2013-07-14','16:10:00',3.11),('9303','2013-07-14','16:15:00',3.07),('9303','2013-07-14','16:20:00',2.89),('9303','2013-07-14','16:25:00',2.54),('9303','2013-07-14','16:30:00',2.69),('9303','2013-07-14','16:35:00',2.36),('9303','2013-07-14','16:40:00',2.89),('9303','2013-07-14','16:45:00',2.5),('9303','2013-07-14','16:50:00',2.83),('9303','2013-07-14','16:55:00',2.7),('9303','2013-07-14','17:00:00',2.14),('9303','2013-07-14','17:05:00',1.76),('9303','2013-07-14','17:10:00',2.11),('9303','2013-07-14','17:15:00',1.34),('9303','2013-07-14','17:20:00',1.23),('9303','2013-07-14','17:25:00',1.44),('9303','2013-07-14','17:30:00',1.83),('9303','2013-07-14','17:35:00',1.95),('9303','2013-07-14','17:40:00',1.34),('9303','2013-07-14','17:55:00',1.63),('9303','2013-07-13','08:00:00',1),('9303','2013-07-13','08:05:00',1.09),('9303','2013-07-13','08:10:00',1.21),('9303','2013-07-13','08:15:00',1.32),('9303','2013-07-13','08:20:00',1.41),('9303','2013-07-13','08:25:00',1.5),('9303','2013-07-13','08:30:00',1.58),('9303','2013-07-13','08:35:00',1.65),('9303','2013-07-13','08:40:00',1.7),('9303','2013-07-13','08:45:00',1.78),('9303','2013-07-13','08:50:00',1.85),('9303','2013-07-13','08:55:00',1.95),('9303','2013-07-13','09:00:00',2.06),('9303','2013-07-13','09:05:00',2.14),('9303','2013-07-13','09:10:00',2.2),('9303','2013-07-13','09:15:00',2.28),('9303','2013-07-13','09:20:00',2.34),('9303','2013-07-13','09:25:00',2.37),('9303','2013-07-13','09:30:00',2.46),('9303','2013-07-13','09:35:00',2.46),('9303','2013-07-13','09:40:00',2.49),('9303','2013-07-13','09:45:00',2.53),('9303','2013-07-13','09:50:00',2.71),('9303','2013-07-13','09:55:00',2.74),('9303','2013-07-13','10:00:00',2.83),('9303','2013-07-13','10:05:00',2.86),('9303','2013-07-13','10:10:00',2.88),('9303','2013-07-13','10:15:00',2.9),('9303','2013-07-13','10:20:00',3.01),('9303','2013-07-13','10:25:00',3.22),('9303','2013-07-13','10:30:00',3.22),('9303','2013-07-13','10:35:00',3),('9303','2013-07-13','10:40:00',3.17),('9303','2013-07-13','10:45:00',3.33),('9303','2013-07-13','10:50:00',3.41),('9303','2013-07-13','10:55:00',3.27),('9303','2013-07-13','11:00:00',3.53),('9303','2013-07-13','11:05:00',3.54),('9303','2013-07-13','11:10:00',3.78),('9303','2013-07-13','11:15:00',3.01),('9303','2013-07-13','11:20:00',1.58),('9303','2013-07-13','11:25:00',2.86),('9303','2013-07-13','11:30:00',2.73),('9303','2013-07-13','11:35:00',3.37),('9303','2013-07-13','11:40:00',1.92),('9303','2013-07-13','11:45:00',2.27),('9303','2013-07-13','11:50:00',4.09),('9303','2013-07-13','11:55:00',3.42),('9303','2013-07-13','12:00:00',2.04),('9303','2013-07-13','12:05:00',3.55),('9303','2013-07-13','12:10:00',3.17),('9303','2013-07-13','12:15:00',1.15),('9303','2013-07-13','12:20:00',2.83),('9303','2013-07-13','12:25:00',1.86),('9303','2013-07-13','12:30:00',1.94),('9303','2013-07-13','12:35:00',4.3),('9303','2013-07-13','12:40:00',4.17),('9303','2013-07-13','12:45:00',2.27),('9303','2013-07-13','12:50:00',4.16),('9303','2013-07-13','12:55:00',4.06),('9303','2013-07-13','13:00:00',4.17),('9303','2013-07-13','13:05:00',4.09),('9303','2013-07-13','13:10:00',3.27),('9303','2013-07-13','13:15:00',4.15),('9303','2013-07-13','13:20:00',4.12),('9303','2013-07-13','13:25:00',4.05),('9303','2013-07-13','13:30:00',4.05),('9303','2013-07-13','13:35:00',4.05),('9303','2013-07-13','13:40:00',4.06),('9303','2013-07-13','13:45:00',4.02),('9303','2013-07-13','13:50:00',4.03),('9303','2013-07-13','13:55:00',4.02),('9303','2013-07-13','14:00:00',3.99),('9303','2013-07-13','14:05:00',4),('9303','2013-07-13','14:10:00',3.96),('9303','2013-07-13','14:15:00',3.96),('9303','2013-07-13','14:20:00',3.93),('9303','2013-07-13','14:25:00',3.91),('9303','2013-07-13','14:30:00',3.92),('9303','2013-07-13','14:35:00',3.9),('9303','2013-07-13','14:40:00',3.87),('9303','2013-07-13','14:45:00',3.85),('9303','2013-07-13','14:50:00',3.82),('9303','2013-07-13','14:55:00',3.81),('9303','2013-07-13','15:00:00',3.79),('9303','2013-07-13','15:05:00',3.76),('9303','2013-07-13','15:10:00',3.71),('9303','2013-07-13','15:15:00',3.7),('9303','2013-07-13','15:20:00',3.53),('9303','2013-07-13','15:25:00',3.7),('9303','2013-07-13','15:30:00',3.58),('9303','2013-07-13','15:35:00',3.58),('9303','2013-07-13','15:40:00',3.5),('9303','2013-07-13','15:45:00',3.46),('9303','2013-07-13','15:50:00',3.4),('9303','2013-07-13','15:55:00',3.36),('9303','2013-07-13','16:00:00',3.32),('9303','2013-07-13','16:05:00',3.27),('9303','2013-07-13','16:10:00',3.21),('9303','2013-07-13','16:15:00',3.12),('9303','2013-07-13','16:20:00',2.99),('9303','2013-07-13','16:25:00',3.05),('9303','2013-07-13','16:30:00',2.98),('9303','2013-07-13','16:35:00',2.92),('9303','2013-07-13','16:40:00',2.84),('9303','2013-07-13','16:45:00',2.76),('9303','2013-07-13','16:50:00',2.66),('9303','2013-07-13','16:55:00',2.6),('9303','2013-07-13','17:00:00',2.54),('9303','2013-07-13','17:05:00',2.42),('9303','2013-07-13','17:10:00',2.4),('9303','2013-07-13','17:15:00',2.3),('9303','2013-07-13','17:20:00',2.1),('9303','2013-07-13','17:25:00',2.09),('9303','2013-07-13','17:30:00',1.95),('9303','2013-07-13','17:35:00',1.86),('9303','2013-07-13','17:40:00',1.77),('9303','2013-07-13','17:45:00',1.71),('9303','2013-07-13','17:50:00',1.62),('9303','2013-07-13','17:55:00',1.64),('9303','2013-07-13','18:00:00',1.5),('9303','2013-07-13','18:05:00',1.41),('9303','2013-07-13','18:10:00',1.34),('9303','2013-07-13','18:15:00',1.25),('9303','2013-07-13','18:20:00',1.15),('9303','2013-07-13','18:25:00',1.02),('9303','2013-07-12','08:15:00',1.42),('9303','2013-07-12','08:20:00',1.65),('9303','2013-07-12','08:45:00',1.19),('9303','2013-07-12','09:10:00',1.38),('9303','2013-07-12','09:15:00',1.53),('9303','2013-07-12','09:20:00',2.12),('9303','2013-07-12','09:25:00',2.23),('9303','2013-07-12','09:30:00',1.53),('9303','2013-07-12','09:35:00',1.5),('9303','2013-07-12','09:40:00',1.74),('9303','2013-07-12','09:45:00',2.59),('9303','2013-07-12','09:50:00',2.73),('9303','2013-07-12','09:55:00',2.79),('9303','2013-07-12','10:00:00',2.85),('9303','2013-07-12','10:05:00',2.89),('9303','2013-07-12','10:10:00',2.36),('9303','2013-07-12','10:15:00',2.98),('9303','2013-07-12','10:20:00',1.88),('9303','2013-07-12','10:25:00',1.5),('9303','2013-07-12','10:30:00',1.91),('9303','2013-07-12','10:50:00',1.25),('9303','2013-07-12','10:55:00',2.5),('9303','2013-07-12','11:00:00',3.3),('9303','2013-07-12','11:05:00',1.03),('9303','2013-07-12','11:10:00',1.05),('9303','2013-07-12','11:15:00',2.49),('9303','2013-07-12','11:20:00',1.3),('9303','2013-07-12','11:25:00',3.4),('9303','2013-07-12','11:30:00',2.79),('9303','2013-07-12','11:35:00',4.04),('9303','2013-07-12','11:40:00',2.66),('9303','2013-07-12','11:45:00',3.39),('9303','2013-07-12','11:50:00',2.99),('9303','2013-07-12','11:55:00',4.11),('9303','2013-07-12','12:00:00',4.13),('9303','2013-07-12','12:05:00',2.62),('9303','2013-07-12','12:10:00',2.85),('9303','2013-07-12','12:15:00',3.27),('9303','2013-07-12','12:20:00',3.99),('9303','2013-07-12','12:25:00',3.78),('9303','2013-07-12','12:30:00',4.18),('9303','2013-07-12','12:35:00',3.45),('9303','2013-07-12','12:40:00',2.86),('9303','2013-07-12','12:45:00',3.02),('9303','2013-07-12','12:50:00',2.99),('9303','2013-07-12','12:55:00',4.26),('9303','2013-07-12','13:00:00',4.17),('9303','2013-07-12','13:05:00',4.14),('9303','2013-07-12','13:10:00',4.18),('9303','2013-07-12','13:15:00',4.15),('9303','2013-07-12','13:20:00',4.09),('9303','2013-07-12','13:25:00',4.13),('9303','2013-07-12','13:30:00',4.17),('9303','2013-07-12','13:35:00',4.13),('9303','2013-07-12','13:40:00',4.08),('9303','2013-07-12','13:45:00',4.05),('9303','2013-07-12','13:50:00',4.08),('9303','2013-07-12','13:55:00',4.11),('9303','2013-07-12','14:00:00',3.97),('9303','2013-07-12','14:05:00',3.49),('9303','2013-07-12','14:10:00',2.42),('9303','2013-07-12','14:15:00',4.42),('9303','2013-07-12','14:20:00',3.94),('9303','2013-07-12','14:25:00',3.94),('9303','2013-07-12','14:30:00',3.4),('9303','2013-07-12','14:35:00',3.95),('9303','2013-07-12','14:40:00',3.79),('9303','2013-07-12','14:45:00',3.82),('9303','2013-07-12','14:50:00',3.78),('9303','2013-07-12','14:55:00',3.77),('9303','2013-07-12','15:00:00',3.41),('9303','2013-07-12','15:05:00',3.68),('9303','2013-07-12','15:10:00',3.37),('9303','2013-07-12','15:15:00',3.46),('9303','2013-07-12','15:20:00',3.59),('9303','2013-07-12','15:25:00',3.52),('9303','2013-07-12','15:30:00',3.57),('9303','2013-07-12','15:35:00',3.34),('9303','2013-07-12','15:40:00',3.24),('9303','2013-07-12','15:45:00',3.02),('9303','2013-07-12','15:50:00',3.29),('9303','2013-07-12','15:55:00',3.24),('9303','2013-07-12','16:00:00',3.17),('9303','2013-07-12','16:05:00',3.12),('9303','2013-07-12','16:10:00',3.03),('9303','2013-07-12','16:15:00',3.01),('9303','2013-07-12','16:20:00',2.93),('9303','2013-07-12','16:25:00',2.91),('9303','2013-07-12','16:30:00',2.84),('9303','2013-07-12','16:35:00',2.76),('9303','2013-07-12','16:40:00',2.73),('9303','2013-07-12','16:45:00',2.67),('9303','2013-07-12','16:50:00',2.6),('9303','2013-07-12','16:55:00',2.53),('9303','2013-07-12','17:00:00',2.46),('9303','2013-07-12','17:05:00',2.41),('9303','2013-07-12','17:10:00',2.33),('9303','2013-07-12','17:15:00',2.2),('9303','2013-07-12','17:20:00',2.08),('9303','2013-07-12','17:25:00',1.97),('9303','2013-07-12','17:30:00',1.9),('9303','2013-07-12','17:35:00',1.81),('9303','2013-07-12','17:40:00',1.7),('9303','2013-07-12','17:45:00',1.65),('9303','2013-07-12','17:50:00',1.59),('9303','2013-07-12','17:55:00',1.52),('9303','2013-07-12','18:00:00',1.45),('9303','2013-07-12','18:05:00',1.37),('9303','2013-07-12','18:10:00',1.25),('9303','2013-07-12','18:15:00',1.16),('9303','2013-07-12','18:20:00',1.05),('9303','2013-07-11','07:55:00',1.01),('9303','2013-07-11','08:00:00',1.1),('9303','2013-07-11','08:05:00',1.17),('9303','2013-07-11','08:10:00',1.23),('9303','2013-07-11','08:15:00',1.34),('9303','2013-07-11','08:20:00',1.43),('9303','2013-07-11','08:25:00',1.52),('9303','2013-07-11','08:30:00',1.58),('9303','2013-07-11','08:35:00',1.65),('9303','2013-07-11','08:40:00',1.74),('9303','2013-07-11','08:45:00',1.82),('9303','2013-07-11','08:50:00',1.93),('9303','2013-07-11','08:55:00',1.98),('9303','2013-07-11','09:00:00',2.09),('9303','2013-07-11','09:05:00',2.13),('9303','2013-07-11','09:10:00',2.2),('9303','2013-07-11','09:15:00',2.34),('9303','2013-07-11','09:20:00',2.38),('9303','2013-07-11','09:25:00',2.6),('9303','2013-07-11','09:30:00',2.62),('9303','2013-07-11','09:35:00',2.41),('9303','2013-07-11','09:40:00',1.75),('9303','2013-07-11','09:45:00',2.7),('9303','2013-07-11','09:50:00',2.56),('9303','2013-07-11','09:55:00',1.68),('9303','2013-07-11','10:00:00',1.85),('9303','2013-07-11','10:10:00',1.55),('9303','2013-07-11','10:15:00',3.16),('9303','2013-07-11','10:20:00',3.21),('9303','2013-07-11','10:25:00',3.34),('9303','2013-07-11','10:30:00',2.9),('9303','2013-07-11','10:35:00',1.19),('9303','2013-07-11','10:40:00',1.19),('9303','2013-07-11','10:45:00',3.13),('9303','2013-07-11','10:50:00',3.5),('9303','2013-07-11','10:55:00',3.72),('9303','2013-07-11','11:00:00',3.23),('9303','2013-07-11','11:05:00',2.81),('9303','2013-07-11','11:10:00',3.31),('9303','2013-07-11','11:15:00',3.28),('9303','2013-07-11','11:20:00',3.1),('9303','2013-07-11','11:25:00',1.42),('9303','2013-07-11','11:30:00',2.97),('9303','2013-07-11','11:35:00',3.35),('9303','2013-07-11','11:40:00',4.18),('9303','2013-07-11','11:45:00',3.84),('9303','2013-07-11','11:50:00',1.98),('9303','2013-07-11','11:55:00',2.65),('9303','2013-07-11','12:00:00',2.31),('9303','2013-07-11','12:10:00',1.13),('9303','2013-07-11','12:15:00',3.19),('9303','2013-07-11','12:20:00',4.26),('9303','2013-07-11','12:25:00',4.29),('9303','2013-07-11','12:30:00',3.86),('9303','2013-07-11','12:35:00',4.1),('9303','2013-07-11','12:40:00',3.96),('9303','2013-07-11','12:45:00',2.23),('9303','2013-07-11','12:50:00',3.05),('9303','2013-07-11','12:55:00',3.32),('9303','2013-07-11','13:00:00',4.34),('9303','2013-07-11','13:05:00',4.27),('9303','2013-07-11','13:10:00',4.2),('9303','2013-07-11','13:15:00',4.21),('9303','2013-07-11','13:20:00',4.11),('9303','2013-07-11','13:25:00',4.17),('9303','2013-07-11','13:30:00',4.27),('9303','2013-07-11','13:35:00',3.88),('9303','2013-07-11','13:40:00',3.53),('9303','2013-07-11','13:45:00',3.11),('9303','2013-07-11','13:50:00',2.95),('9303','2013-07-11','13:55:00',2.9),('9303','2013-07-11','14:00:00',3.64),('9303','2013-07-11','14:05:00',4.11),('9303','2013-07-11','14:10:00',3.92),('9303','2013-07-11','14:15:00',4.11),('9303','2013-07-11','14:20:00',3.66),('9303','2013-07-11','14:25:00',3.95),('9303','2013-07-11','14:30:00',4.16),('9303','2013-07-11','14:35:00',3.96),('9303','2013-07-11','14:40:00',3.8),('9303','2013-07-11','14:45:00',3.91),('9303','2013-07-11','14:50:00',3.89),('9303','2013-07-11','14:55:00',3.2),('9303','2013-07-11','15:00:00',3.77),('9303','2013-07-11','15:05:00',2.19),('9303','2013-07-11','15:10:00',2.06),('9303','2013-07-11','15:15:00',3.45),('9303','2013-07-11','15:20:00',3.13),('9303','2013-07-11','15:25:00',3.09),('9303','2013-07-11','15:30:00',2.97),('9303','2013-07-11','15:35:00',3.59),('9303','2013-07-11','15:40:00',2.82),('9303','2013-07-11','15:45:00',3.28),('9303','2013-07-11','15:50:00',2.72),('9303','2013-07-11','15:55:00',2.45),('9303','2013-07-11','16:00:00',3.51),('9303','2013-07-11','16:05:00',1.68),('9303','2013-07-11','16:10:00',2.64),('9303','2013-07-11','16:15:00',1.6),('9303','2013-07-11','16:20:00',1.81),('9303','2013-07-11','16:25:00',2.77),('9303','2013-07-11','16:30:00',2.25),('9303','2013-07-11','16:35:00',1.73),('9303','2013-07-11','16:40:00',2.77),('9303','2013-07-11','16:45:00',2.65),('9303','2013-07-11','16:50:00',2.76),('9303','2013-07-11','16:55:00',2.7),('9303','2013-07-11','17:00:00',2.5),('9303','2013-07-11','17:05:00',2.02),('9303','2013-07-11','17:10:00',1.48),('9303','2013-07-11','17:15:00',1.21),('9303','2013-07-11','17:20:00',1.62),('9303','2013-07-11','17:25:00',1.69),('9303','2013-07-11','17:30:00',1.91),('9303','2013-07-11','17:35:00',1.94),('9303','2013-07-11','17:40:00',1.81),('9303','2013-07-11','17:45:00',1.58),('9303','2013-07-11','17:50:00',1.52),('9303','2013-07-11','17:55:00',1.23),('9303','2013-07-11','18:00:00',1.12),('9303','2013-07-11','18:05:00',1.71),('9303','2013-07-11','18:10:00',1.52),('9303','2013-07-11','18:15:00',1.24),('9303','2013-07-11','18:20:00',1.08),('9303','2013-07-11','18:25:00',1.24),('9303','2013-07-11','18:30:00',1.04),('9303','2014-05-03','07:50:00',1.06),('9303','2014-05-03','07:55:00',1.16),('9303','2014-05-03','08:00:00',1.3),('9303','2014-05-03','08:05:00',1.47),('9303','2014-05-03','08:10:00',1.76),('9303','2014-05-03','08:15:00',1.86),('9303','2014-05-03','08:20:00',1.27),('9303','2014-05-03','08:25:00',1.04),('9303','2014-05-03','08:30:00',1.28),('9303','2014-05-03','08:40:00',1),('9303','2014-05-03','08:45:00',1.46),('9303','2014-05-03','08:50:00',2.02),('9303','2014-05-03','08:55:00',2.63),('9303','2014-05-03','09:00:00',3.12),('9303','2014-05-03','09:05:00',2.92),('9303','2014-05-03','09:10:00',1.52),('9303','2014-05-03','09:15:00',1.82),('9303','2014-05-03','09:20:00',2.42),('9303','2014-05-03','09:25:00',3.26),('9303','2014-05-03','09:30:00',1.76),('9303','2014-05-03','09:35:00',2.38),('9303','2014-05-03','09:40:00',2.06),('9303','2014-05-03','09:45:00',3.13),('9303','2014-05-03','09:50:00',1.28),('9303','2014-05-03','09:55:00',2.61),('9303','2014-05-03','10:00:00',3.47),('9303','2014-05-03','10:05:00',3.49),('9303','2014-05-03','10:10:00',3.57),('9303','2014-05-03','10:15:00',3.86),('9303','2014-05-03','10:20:00',3.14),('9303','2014-05-03','10:25:00',4.35),('9303','2014-05-03','10:30:00',2.71),('9303','2014-05-03','10:35:00',1.01),('9303','2014-05-03','10:45:00',1.22),('9303','2014-05-03','10:50:00',1.04),('9303','2014-05-03','10:55:00',1.47),('9303','2014-05-03','11:00:00',1.12),('9303','2014-05-03','11:05:00',2.2),('9303','2014-05-03','11:10:00',3.69),('9303','2014-05-03','11:15:00',4.2),('9303','2014-05-03','11:20:00',3.02),('9303','2014-05-03','11:25:00',3.9),('9303','2014-05-03','11:30:00',4.57),('9303','2014-05-03','11:35:00',3.13),('9303','2014-05-03','11:40:00',2.73),('9303','2014-05-03','11:45:00',2.64),('9303','2014-05-03','11:50:00',2.25),('9303','2014-05-03','11:55:00',2.52),('9303','2014-05-03','12:00:00',2.02),('9303','2014-05-03','12:05:00',1.61),('9303','2014-05-03','12:10:00',1.46),('9303','2014-05-03','12:15:00',1.33),('9303','2014-05-03','12:20:00',1.19),('9303','2014-05-03','12:25:00',1.23),('9303','2014-05-03','12:30:00',1.59),('9303','2014-05-03','12:35:00',1.95),('9303','2014-05-03','12:40:00',1.78),('9303','2014-05-03','12:45:00',1.85),('9303','2014-05-03','12:50:00',1.82),('9303','2014-05-03','12:55:00',1.82),('9303','2014-05-03','13:00:00',1.91),('9303','2014-05-03','13:05:00',1.9),('9303','2014-05-03','13:10:00',3.19),('9303','2014-05-03','13:15:00',3.04),('9303','2014-05-03','13:20:00',2.19),('9303','2014-05-03','13:25:00',2.87),('9303','2014-05-03','13:30:00',3.09),('9303','2014-05-03','13:35:00',2.47),('9303','2014-05-03','13:40:00',1.84),('9303','2014-05-03','13:45:00',1.75),('9303','2014-05-03','13:50:00',1.74),('9303','2014-05-03','13:55:00',1.75),('9303','2014-05-03','14:00:00',1.7),('9303','2014-05-03','14:05:00',1.7),('9303','2014-05-03','14:10:00',1.84),('9303','2014-05-03','14:15:00',2.06),('9303','2014-05-03','14:20:00',2.39),('9303','2014-05-03','14:25:00',2.86),('9303','2014-05-03','14:30:00',2.24),('9303','2014-05-03','14:35:00',1.59),('9303','2014-05-03','14:40:00',1.32),('9303','2014-04-06','08:15:00',1.01),('9303','2014-04-06','08:20:00',1.12),('9303','2014-04-06','08:25:00',1.25),('9303','2014-04-06','08:30:00',1.33),('9303','2014-04-06','08:35:00',1.44),('9303','2014-04-06','08:40:00',1.57),('9303','2014-04-06','08:45:00',1.63),('9303','2014-04-06','08:50:00',1.45),('9303','2014-04-06','08:55:00',1.31),('9303','2014-04-06','09:05:00',1.65),('9303','2014-04-06','09:10:00',2.22),('9303','2014-04-06','09:15:00',2.3),('9303','2014-04-06','09:20:00',2.01),('9303','2014-04-06','09:25:00',1.85),('9303','2014-04-06','09:30:00',1.63),('9303','2014-04-06','09:35:00',2.36),('9303','2014-04-06','09:40:00',2.42),('9303','2014-04-06','09:45:00',3.23),('9303','2014-04-06','09:50:00',3.48),('9303','2014-04-06','09:55:00',3.49),('9303','2014-04-06','10:00:00',2.53),('9303','2014-04-06','10:05:00',3.13),('9303','2014-04-06','10:10:00',3.11),('9303','2014-04-06','10:15:00',3.64),('9303','2014-04-06','10:20:00',2.65),('9303','2014-04-06','10:25:00',1.19),('9303','2014-04-06','10:30:00',1.28),('9303','2014-04-06','10:35:00',1.41),('9303','2014-04-06','10:40:00',1.54),('9303','2014-04-06','10:45:00',2.53),('9303','2014-04-06','10:50:00',2.26),('9303','2014-04-06','10:55:00',1.61),('9303','2014-04-06','11:00:00',1.57),('9303','2014-04-06','11:05:00',1.74),('9303','2014-04-06','11:10:00',3.39),('9303','2014-04-06','11:15:00',3.75),('9303','2014-04-06','11:20:00',3.99),('9303','2014-04-06','11:25:00',3.98),('9303','2014-04-06','11:30:00',4.18),('9303','2014-04-06','11:35:00',4.48),('9303','2014-04-06','11:40:00',4.39),('9303','2014-04-06','11:45:00',4.28),('9303','2014-04-06','11:50:00',3.75),('9303','2014-04-06','11:55:00',4.35),('9303','2014-04-06','12:00:00',4.27),('9303','2014-04-06','12:05:00',4.09),('9303','2014-04-06','12:10:00',4.13),('9303','2014-04-06','12:15:00',4.28),('9303','2014-04-06','12:20:00',3.77),('9303','2014-04-06','12:25:00',2.79),('9303','2014-04-06','12:30:00',2.79),('9303','2014-04-06','12:35:00',2.98),('9303','2014-04-06','12:40:00',2.1),('9303','2014-04-06','12:45:00',2.04),('9303','2014-04-06','12:50:00',2.53),('9303','2014-04-06','12:55:00',4.48),('9303','2014-04-06','13:00:00',3.98),('9303','2014-04-06','13:05:00',3.54),('9303','2014-04-06','13:10:00',4.11),('9303','2014-04-06','13:15:00',4.19),('9303','2014-04-06','13:20:00',2.37),('9303','2014-04-06','13:25:00',1.36),('9303','2014-04-06','13:30:00',4.61),('9303','2014-04-06','13:35:00',2.16),('9303','2014-04-06','13:40:00',1.99),('9303','2014-04-06','13:45:00',4.61),('9303','2014-04-06','13:50:00',4.17),('9303','2014-04-06','13:55:00',4.31),('9303','2014-04-06','14:00:00',4.2),('9303','2014-04-06','14:05:00',4.04),('9303','2014-04-06','14:10:00',4.27),('9303','2014-04-06','14:15:00',3.4),('9303','2014-04-06','14:20:00',2.61),('9303','2014-04-06','14:25:00',1.62),('9303','2014-04-06','14:30:00',1.03),('9303','2014-04-06','14:35:00',1.24),('9303','2014-04-06','14:40:00',2.96),('9303','2014-04-06','14:45:00',4.81),('9303','2014-04-06','14:50:00',3.98),('9303','2014-04-06','14:55:00',2.27),('9303','2014-04-06','15:00:00',1.58),('9303','2014-04-06','15:05:00',1.26),('9303','2014-04-06','15:10:00',3.35),('9303','2014-04-06','15:15:00',2.34),('9303','2014-04-06','15:20:00',1.73),('9303','2014-04-06','15:50:00',1.62),('9303','2014-04-06','15:55:00',3.55),('9303','2014-04-06','16:00:00',3.05),('9303','2014-04-06','16:05:00',1.5),('9303','2014-04-06','16:10:00',1.95),('9303','2014-04-06','16:35:00',1.43),('9303','2014-04-06','16:40:00',2.49),('9303','2014-04-06','16:45:00',2.96),('9303','2014-04-06','16:50:00',2.67),('9303','2014-04-06','16:55:00',1.76),('9303','2014-04-06','17:25:00',1.76),('9303','2014-04-06','17:30:00',1.7),('9303','2014-04-06','17:35:00',1.09),('9303','2014-04-06','17:45:00',1.03),('9303','2014-04-06','17:50:00',1.32),('9303','2014-04-06','17:55:00',1.18),('9303','2014-04-06','18:00:00',1.05),('9303','2013-07-10','07:30:00',1.03),('9303','2013-07-10','07:35:00',1.15),('9303','2013-07-10','07:40:00',1.3),('9303','2013-07-10','07:45:00',1.41),('9303','2013-07-10','07:50:00',1.53),('9303','2013-07-10','07:55:00',1.64),('9303','2013-07-10','08:00:00',1.76),('9303','2013-07-10','08:05:00',1.36),('9303','2013-07-10','08:10:00',1.42),('9303','2013-07-10','08:15:00',1.5),('9303','2013-07-10','08:20:00',1.57),('9303','2013-07-10','08:25:00',2.07),('9303','2013-07-10','08:30:00',2.04),('9303','2013-07-10','08:35:00',2.22),('9303','2013-07-10','08:40:00',2.29),('9303','2013-07-10','08:45:00',2.1),('9303','2013-07-10','08:50:00',2.14),('9303','2013-07-10','08:55:00',2.11),('9303','2013-07-10','09:00:00',2.18),('9303','2013-07-10','09:05:00',2.27),('9303','2013-07-10','09:10:00',2.35),('9303','2013-07-10','09:15:00',2.51),('9303','2013-07-10','09:20:00',2.48),('9303','2013-07-10','09:25:00',2.51),('9303','2013-07-10','09:30:00',2.51),('9303','2013-07-10','09:35:00',2.63),('9303','2013-07-10','09:40:00',2.66),('9303','2013-07-10','09:45:00',2.71),('9303','2013-07-10','09:50:00',2.77),('9303','2013-07-10','09:55:00',2.62),('9303','2013-07-10','10:00:00',2.66),('9303','2013-07-10','10:05:00',2.96),('9303','2013-07-10','10:10:00',2.99),('9303','2013-07-10','10:15:00',3.01),('9303','2013-07-10','10:20:00',3.06),('9303','2013-07-10','10:25:00',3.12),('9303','2013-07-10','10:30:00',3.2),('9303','2013-07-10','10:35:00',3.21),('9303','2013-07-10','10:40:00',3.26),('9303','2013-07-10','10:45:00',3.3),('9303','2013-07-10','10:50:00',3.33),('9303','2013-07-10','10:55:00',3.4),('9303','2013-07-10','11:00:00',3.51),('9303','2013-07-10','11:05:00',3.53),('9303','2013-07-10','11:10:00',3.54),('9303','2013-07-10','11:15:00',3.56),('9303','2013-07-10','11:20:00',3.58),('9303','2013-07-10','11:25:00',3.59),('9303','2013-07-10','11:30:00',3.63),('9303','2013-07-10','11:35:00',3.6),('9303','2013-07-10','11:40:00',3.59),('9303','2013-07-10','11:45:00',3.64),('9303','2013-07-10','11:50:00',3.71),('9303','2013-07-10','11:55:00',3.74),('9303','2013-07-10','12:00:00',3.79),('9303','2013-07-10','12:05:00',3.81),('9303','2013-07-10','12:10:00',3.78),('9303','2013-07-10','12:15:00',3.84),('9303','2013-07-10','12:20:00',3.91),('9303','2013-07-10','12:25:00',3.94),('9303','2013-07-10','12:30:00',3.94),('9303','2013-07-10','12:35:00',3.9),('9303','2013-07-10','12:40:00',3.86),('9303','2013-07-10','12:45:00',3.98),('9303','2013-07-10','12:50:00',3.99),('9303','2013-07-10','12:55:00',3.99),('9303','2013-07-10','13:00:00',4),('9303','2013-07-10','13:05:00',4.04),('9303','2013-07-10','13:10:00',4.03),('9303','2013-07-10','13:15:00',4.01),('9303','2013-07-10','13:20:00',4.03),('9303','2013-07-10','13:25:00',4.04),('9303','2013-07-10','13:30:00',4.03),('9303','2013-07-10','13:35:00',3.99),('9303','2013-07-10','13:40:00',3.97),('9303','2013-07-10','13:45:00',4.02),('9303','2013-07-10','13:50:00',4.04),('9303','2013-07-10','13:55:00',3.99),('9303','2013-07-10','14:00:00',4),('9303','2013-07-10','14:05:00',3.99),('9303','2013-07-10','14:10:00',3.99),('9303','2013-07-10','14:15:00',3.96),('9303','2013-07-10','14:20:00',3.95),('9303','2013-07-10','14:25:00',3.91),('9303','2013-07-10','14:30:00',3.89),('9303','2013-07-10','14:35:00',3.91),('9303','2013-07-10','14:40:00',3.89),('9303','2013-07-10','14:45:00',3.84),('9303','2013-07-10','14:50:00',3.81),('9303','2013-07-10','14:55:00',3.82),('9303','2013-07-10','15:00:00',3.78),('9303','2013-07-10','15:05:00',3.74),('9303','2013-07-10','15:10:00',3.68),('9303','2013-07-10','15:15:00',3.65),('9303','2013-07-10','15:20:00',3.63),('9303','2013-07-10','15:25:00',3.61),('9303','2013-07-10','15:30:00',3.55),('9303','2013-07-10','15:35:00',3.51),('9303','2013-07-10','15:40:00',2.92),('9303','2013-07-10','15:45:00',3.37),('9303','2013-07-10','15:50:00',3.32),('9303','2013-07-10','15:55:00',3.27),('9303','2013-07-10','16:00:00',3.25),('9303','2013-07-10','16:05:00',3.21),('9303','2013-07-10','16:10:00',3.12),('9303','2013-07-10','16:15:00',3.01),('9303','2013-07-10','16:20:00',2.98),('9303','2013-07-10','16:25:00',2.94),('9303','2013-07-10','16:30:00',2.84),('9303','2013-07-10','16:35:00',2.79),('9303','2013-07-10','16:40:00',2.73),('9303','2013-07-10','16:45:00',2.67),('9303','2013-07-10','16:50:00',2.63),('9303','2013-07-10','16:55:00',2.64),('9303','2013-07-10','17:00:00',2.67),('9303','2013-07-10','17:05:00',2.44),('9303','2013-07-10','17:10:00',2.22),('9303','2013-07-10','17:15:00',1.39),('9303','2013-07-10','17:20:00',1.17),('9303','2013-07-10','17:35:00',2),('9303','2013-07-10','17:40:00',1.83),('9303','2013-07-10','17:45:00',1.22),('9303','2013-07-10','17:50:00',1.62),('9303','2013-07-10','17:55:00',1.48),('9303','2013-07-10','18:00:00',1.5),('9303','2013-07-09','07:50:00',1.01),('9303','2013-07-09','07:55:00',1.07),('9303','2013-07-09','08:00:00',1.15),('9303','2013-07-09','08:05:00',1.23),('9303','2013-07-09','08:10:00',1.3),('9303','2013-07-09','08:15:00',1.4),('9303','2013-07-09','08:20:00',1.48),('9303','2013-07-09','08:25:00',1.55),('9303','2013-07-09','08:30:00',1.63),('9303','2013-07-09','08:35:00',1.72),('9303','2013-07-09','08:40:00',1.79),('9303','2013-07-09','08:45:00',1.86),('9303','2013-07-09','08:50:00',1.93),('9303','2013-07-09','08:55:00',2.01),('9303','2013-07-09','09:00:00',2.09),('9303','2013-07-09','09:05:00',2.17),('9303','2013-07-09','09:10:00',2.21),('9303','2013-07-09','09:15:00',2.3),('9303','2013-07-09','09:20:00',2.38),('9303','2013-07-09','09:25:00',2.44),('9303','2013-07-09','09:30:00',2.52),('9303','2013-07-09','09:35:00',2.57),('9303','2013-07-09','09:40:00',2.63),('9303','2013-07-09','09:45:00',2.7),('9303','2013-07-09','09:50:00',2.75),('9303','2013-07-09','09:55:00',2.81),('9303','2013-07-09','10:00:00',2.84),('9303','2013-07-09','10:05:00',2.89),('9303','2013-07-09','10:10:00',2.98),('9303','2013-07-09','10:15:00',3.04),('9303','2013-07-09','10:20:00',3.1),('9303','2013-07-09','10:25:00',3.12),('9303','2013-07-09','10:30:00',3.16),('9303','2013-07-09','10:35:00',3.2),('9303','2013-07-09','10:40:00',3.23),('9303','2013-07-09','10:45:00',3.25),('9303','2013-07-09','10:50:00',3.33),('9303','2013-07-09','10:55:00',3.39),('9303','2013-07-09','11:00:00',3.43),('9303','2013-07-09','11:05:00',3.42),('9303','2013-07-09','11:10:00',3.29),('9303','2013-07-09','11:15:00',3.01),('9303','2013-07-09','11:20:00',3.13),('9303','2013-07-09','11:25:00',3.17),('9303','2013-07-09','11:30:00',2.06),('9303','2013-07-09','11:35:00',1.92),('9303','2013-07-09','11:40:00',2.46),('9303','2013-07-09','11:45:00',3.18),('9303','2013-07-09','11:50:00',4.22),('9303','2013-07-09','11:55:00',4.16),('9303','2013-07-09','12:00:00',4.15),('9303','2013-07-09','12:05:00',4.08),('9303','2013-07-09','12:10:00',3.3),('9303','2013-07-09','12:15:00',3.91),('9303','2013-07-09','12:20:00',3.89),('9303','2013-07-09','12:25:00',3.84),('9303','2013-07-09','12:30:00',3.79),('9303','2013-07-09','12:35:00',3.8),('9303','2013-07-09','12:40:00',3.84),('9303','2013-07-09','12:45:00',3.82),('9303','2013-07-09','12:50:00',3.88),('9303','2013-07-09','12:55:00',3.92),('9303','2013-07-09','13:00:00',3.97),('9303','2013-07-09','13:05:00',4.04),('9303','2013-07-09','13:10:00',4.01),('9303','2013-07-09','13:15:00',3.99),('9303','2013-07-09','13:20:00',4.02),('9303','2013-07-09','13:25:00',4.03),('9303','2013-07-09','13:30:00',4.18),('9303','2013-07-09','13:35:00',3.94),('9303','2013-07-09','13:40:00',3.92),('9303','2013-07-09','13:45:00',3.24),('9303','2013-07-09','13:50:00',3.01),('9303','2013-07-09','13:55:00',3.12),('9303','2013-07-09','14:00:00',3.02),('9303','2013-07-09','14:05:00',3),('9303','2013-07-09','14:10:00',3.3),('9303','2013-07-09','14:15:00',3.33),('9303','2013-07-09','14:20:00',2.42),('9303','2013-07-09','14:25:00',1.9),('9303','2013-07-09','14:30:00',1.26),('9303','2013-07-08','07:40:00',1.06),('9303','2013-07-08','07:45:00',1.01),('9303','2013-07-08','08:10:00',1.17),('9303','2013-07-08','08:15:00',1.35),('9303','2013-07-08','08:20:00',1.48),('9303','2013-07-08','08:25:00',1.56),('9303','2013-07-08','08:30:00',1.65),('9303','2013-07-08','08:35:00',1.72),('9303','2013-07-08','08:40:00',1.79),('9303','2013-07-08','08:45:00',1.84),('9303','2013-07-08','08:50:00',1.9),('9303','2013-07-08','08:55:00',1.99),('9303','2013-07-08','09:00:00',2.08),('9303','2013-07-08','09:05:00',2.17),('9303','2013-07-08','09:10:00',2.23),('9303','2013-07-08','09:15:00',2.29),('9303','2013-07-08','09:20:00',2.37),('9303','2013-07-08','09:25:00',2.39),('9303','2013-07-08','09:30:00',2.5),('9303','2013-07-08','09:35:00',2.64),('9303','2013-07-08','09:40:00',2.69),('9303','2013-07-08','09:45:00',2.72),('9303','2013-07-08','09:50:00',2.72),('9303','2013-07-08','09:55:00',2.81),('9303','2013-07-08','10:00:00',2.88),('9303','2013-07-08','10:05:00',2.92),('9303','2013-07-08','10:10:00',2.94),('9303','2013-07-08','10:15:00',3.03),('9303','2013-07-08','10:20:00',3.09),('9303','2013-07-08','10:25:00',3.15),('9303','2013-07-08','10:30:00',3.09),('9303','2013-07-08','10:35:00',3.27),('9303','2013-07-08','10:40:00',3.25),('9303','2013-07-08','10:45:00',3.25),('9303','2013-07-08','10:50:00',3.28),('9303','2013-07-08','10:55:00',3.3),('9303','2013-07-08','11:00:00',3.35),('9303','2013-07-08','11:05:00',3.39),('9303','2013-07-08','11:10:00',3.47),('9303','2013-07-08','11:15:00',3.55),('9303','2013-07-08','11:20:00',3.62),('9303','2013-07-08','11:25:00',3.65),('9303','2013-07-08','11:30:00',3.72),('9303','2013-07-08','11:35:00',3.74),('9303','2013-07-08','11:40:00',3.47),('9303','2013-07-08','11:45:00',3.78),('9303','2013-07-08','11:50:00',3.79),('9303','2013-07-08','11:55:00',3.77),('9303','2013-07-08','12:00:00',3.8),('9303','2013-07-08','12:05:00',3.88),('9303','2013-07-08','12:10:00',3.95),('9303','2013-07-08','12:15:00',3.98),('9303','2013-07-08','12:20:00',4.1),('9303','2013-07-08','12:25:00',4.02),('9303','2013-07-08','12:30:00',3.79),('9303','2013-07-08','12:35:00',3.98),('9303','2013-07-08','12:40:00',3.95),('9303','2013-07-08','12:45:00',3.98),('9303','2013-07-08','12:50:00',4),('9303','2013-07-08','12:55:00',4.11),('9303','2013-07-08','13:00:00',3.82),('9303','2013-07-08','13:05:00',3.9),('9303','2013-07-08','13:10:00',4.51),('9303','2013-07-08','13:15:00',3.97),('9303','2013-07-08','13:20:00',2.07),('9303','2013-07-08','13:25:00',1.08),('9303','2013-07-08','14:35:00',1.03),('9303','2013-07-08','14:40:00',1.04),('9303','2013-07-07','07:50:00',1.04),('9303','2013-07-07','07:55:00',1.14),('9303','2013-07-07','08:00:00',1.23),('9303','2013-07-07','08:05:00',1.32),('9303','2013-07-07','08:10:00',1.41),('9303','2013-07-07','08:15:00',1.33),('9303','2013-07-07','08:20:00',1.22),('9303','2013-07-07','08:25:00',1.3),('9303','2013-07-07','08:30:00',1.69),('9303','2013-07-07','08:35:00',1.76),('9303','2013-07-07','08:50:00',1.81),('9303','2013-07-07','08:55:00',2.24),('9303','2013-07-07','09:00:00',2.23),('9303','2013-07-07','09:05:00',2.02),('9303','2013-07-07','09:10:00',2.04),('9303','2013-07-07','09:15:00',2.08),('9303','2013-07-07','09:20:00',1.61),('9303','2013-07-07','09:25:00',2.07),('9303','2013-07-07','09:30:00',2.58),('9303','2013-07-07','09:35:00',2.65),('9303','2013-07-07','09:40:00',2.47),('9303','2013-07-07','09:45:00',2.97),('9303','2013-07-07','09:50:00',2.97),('9303','2013-07-07','09:55:00',3.07),('9303','2013-07-07','10:00:00',3.07),('9303','2013-07-07','10:05:00',2.9),('9303','2013-07-07','10:10:00',3.03),('9303','2013-07-07','10:15:00',2.85),('9303','2013-07-07','10:20:00',3.07),('9303','2013-07-07','10:25:00',3.08),('9303','2013-07-07','10:30:00',2.88),('9303','2013-07-07','10:35:00',3.45),('9303','2013-07-07','10:40:00',3.16),('9303','2013-07-07','10:45:00',3.42),('9303','2013-07-07','10:50:00',3.5),('9303','2013-07-07','10:55:00',3.49),('9303','2013-07-07','11:00:00',3.51),('9303','2013-07-07','11:05:00',3.56),('9303','2013-07-07','11:10:00',3.62),('9303','2013-07-07','11:15:00',3.53),('9303','2013-07-07','11:20:00',3.36),('9303','2013-07-07','11:25:00',3.08),('9303','2013-07-07','11:30:00',3.22),('9303','2013-07-07','11:35:00',3.16),('9303','2013-07-07','11:40:00',3.21),('9303','2013-07-07','11:45:00',2.78),('9303','2013-07-07','11:50:00',2.68),('9303','2013-07-07','11:55:00',1.96),('9303','2013-07-07','12:00:00',2.77),('9303','2013-07-07','12:05:00',3.72),('9303','2013-07-07','12:10:00',3.74),('9303','2013-07-07','12:15:00',3.99),('9303','2013-07-07','12:20:00',3.89),('9303','2013-07-07','12:25:00',3.66),('9303','2013-07-07','12:30:00',3.74),('9303','2013-07-07','12:35:00',3.91),('9303','2013-07-07','12:40:00',4.05),('9303','2013-07-07','12:45:00',4.05),('9303','2013-07-07','12:50:00',3.94),('9303','2013-07-07','12:55:00',4.14),('9303','2013-07-07','13:00:00',4.02),('9303','2013-07-07','13:05:00',4.03),('9303','2013-07-07','13:10:00',4.06),('9303','2013-07-07','13:15:00',4.04),('9303','2013-07-07','13:20:00',4.03),('9303','2013-07-07','13:25:00',3.97),('9303','2013-07-07','13:30:00',3.77),('9303','2013-07-07','13:35:00',4.1),('9303','2013-07-07','13:40:00',2.48),('9303','2013-07-07','13:45:00',4.39),('9303','2013-07-07','13:50:00',4.44),('9303','2013-07-07','13:55:00',3.56),('9303','2013-07-07','14:00:00',3.23),('9303','2013-07-07','14:05:00',3.53),('9303','2013-07-07','14:10:00',2.16),('9303','2013-07-07','14:15:00',1.91),('9303','2013-07-07','14:20:00',1.15),('9303','2013-07-07','15:05:00',1.02),('9303','2013-07-06','07:50:00',1),('9303','2013-07-06','07:55:00',1.1),('9303','2013-07-06','08:00:00',1.18),('9303','2013-07-06','08:05:00',1.27),('9303','2013-07-06','08:10:00',1.35),('9303','2013-07-06','08:15:00',1.45),('9303','2013-07-06','08:20:00',1.52),('9303','2013-07-06','08:25:00',1.61),('9303','2013-07-06','08:30:00',1.69),('9303','2013-07-06','08:35:00',1.77),('9303','2013-07-06','08:40:00',1.84),('9303','2013-07-06','08:45:00',1.9),('9303','2013-07-06','08:50:00',1.98),('9303','2013-07-06','08:55:00',2.05),('9303','2013-07-06','09:00:00',2.13),('9303','2013-07-06','09:05:00',2.23),('9303','2013-07-06','09:10:00',2.32),('9303','2013-07-06','09:15:00',2.38),('9303','2013-07-06','09:20:00',2.46),('9303','2013-07-06','09:25:00',2.51),('9303','2013-07-06','09:30:00',2.57),('9303','2013-07-06','09:35:00',2.61),('9303','2013-07-06','09:40:00',2.68),('9303','2013-07-06','09:45:00',2.74),('9303','2013-07-06','09:50:00',2.81),('9303','2013-07-06','09:55:00',2.91),('9303','2013-07-06','10:00:00',2.97),('9303','2013-07-06','10:05:00',3.03),('9303','2013-07-06','10:10:00',3.09),('9303','2013-07-06','10:15:00',3.12),('9303','2013-07-06','10:20:00',3.16),('9303','2013-07-06','10:25:00',3.21),('9303','2013-07-06','10:30:00',3.26),('9303','2013-07-06','10:35:00',3.28),('9303','2013-07-06','10:40:00',3.36),('9303','2013-07-06','10:45:00',3.41),('9303','2013-07-06','10:50:00',3.46),('9303','2013-07-06','10:55:00',3.51),('9303','2013-07-06','11:00:00',3.55),('9303','2013-07-06','11:05:00',3.57),('9303','2013-07-06','11:10:00',3.59),('9303','2013-07-06','11:15:00',3.57),('9303','2013-07-06','11:20:00',3.62),('9303','2013-07-06','11:25:00',3.67),('9303','2013-07-06','11:30:00',3.71),('9303','2013-07-06','11:35:00',3.75),('9303','2013-07-06','11:40:00',3.74),('9303','2013-07-06','11:45:00',3.78),('9303','2013-07-06','11:50:00',3.8),('9303','2013-07-06','11:55:00',3.82),('9303','2013-07-06','12:00:00',3.87),('9303','2013-07-06','12:05:00',3.92),('9303','2013-07-06','12:10:00',3.98),('9303','2013-07-06','12:15:00',3.96),('9303','2013-07-06','12:20:00',4),('9303','2013-07-06','12:25:00',3.98),('9303','2013-07-06','12:30:00',4.09),('9303','2013-07-06','12:35:00',4.01),('9303','2013-07-06','12:40:00',4.05),('9303','2013-07-06','12:45:00',4.05),('9303','2013-07-06','12:50:00',4.04),('9303','2013-07-06','12:55:00',4.07),('9303','2013-07-06','13:00:00',3.45),('9303','2013-07-06','13:05:00',4.08),('9303','2013-07-06','13:10:00',4.1),('9303','2013-07-06','13:15:00',4.1),('9303','2013-07-06','13:20:00',4.1),('9303','2013-07-06','13:25:00',4.09),('9303','2013-07-06','13:30:00',4.12),('9303','2013-07-06','13:35:00',3.76),('9303','2013-07-06','13:40:00',4.1),('9303','2013-07-06','13:45:00',4.13),('9303','2013-07-06','13:50:00',4.03),('9303','2013-07-06','13:55:00',4.03),('9303','2013-07-06','14:00:00',4.05),('9303','2013-07-06','14:05:00',4.08),('9303','2013-07-06','14:10:00',4),('9303','2013-07-06','14:15:00',4.07),('9303','2013-07-06','14:20:00',4.1),('9303','2013-07-06','14:25:00',3.99),('9303','2013-07-06','14:30:00',3.92),('9303','2013-07-06','14:35:00',3.93),('9303','2013-07-06','14:40:00',3.29),('9303','2013-07-06','14:45:00',3.85),('9303','2013-07-06','14:50:00',3.79),('9303','2013-07-06','14:55:00',3.36),('9303','2013-07-06','15:00:00',3.95),('9303','2013-07-06','15:05:00',3.9),('9303','2013-07-06','15:10:00',3.76),('9303','2013-07-06','15:15:00',3.68),('9303','2013-07-06','15:20:00',3.69),('9303','2013-07-06','15:25:00',3.68),('9303','2013-07-06','15:30:00',3.65),('9303','2013-07-06','15:35:00',1.66),('9303','2013-07-06','16:55:00',1.16),('9303','2013-07-06','17:15:00',1.07),('9303','2013-07-05','07:50:00',1.02),('9303','2013-07-05','07:55:00',1.11),('9303','2013-07-05','08:00:00',1.21),('9303','2013-07-05','08:05:00',1.3),('9303','2013-07-05','08:10:00',1.38),('9303','2013-07-05','08:15:00',1.47),('9303','2013-07-05','08:20:00',1.53),('9303','2013-07-05','08:25:00',1.61),('9303','2013-07-05','08:30:00',1.7),('9303','2013-07-05','08:35:00',1.78),('9303','2013-07-05','08:40:00',1.84),('9303','2013-07-05','08:45:00',1.9),('9303','2013-07-05','08:50:00',1.97),('9303','2013-07-05','08:55:00',2.05),('9303','2013-07-05','09:00:00',2.12),('9303','2013-07-05','09:05:00',2.21),('9303','2013-07-05','09:10:00',2.28),('9303','2013-07-05','09:15:00',2.35),('9303','2013-07-05','09:20:00',2.44),('9303','2013-07-05','09:25:00',2.52),('9303','2013-07-05','09:30:00',2.58),('9303','2013-07-05','09:35:00',2.65),('9303','2013-07-05','09:40:00',2.71),('9303','2013-07-05','09:45:00',2.76),('9303','2013-07-05','09:50:00',2.8),('9303','2013-07-05','09:55:00',2.87),('9303','2013-07-05','10:00:00',2.92),('9303','2013-07-05','10:05:00',2.96),('9303','2013-07-05','10:10:00',3.03),('9303','2013-07-05','10:15:00',3.08),('9303','2013-07-05','10:20:00',3.13),('9303','2013-07-05','10:25:00',3.17),('9303','2013-07-05','10:30:00',3.24),('9303','2013-07-05','10:35:00',3.26),('9303','2013-07-05','10:40:00',3.3),('9303','2013-07-05','10:45:00',3.34),('9303','2013-07-05','10:50:00',3.37),('9303','2013-07-05','10:55:00',3.42),('9303','2013-07-05','11:00:00',3.45),('9303','2013-07-05','11:05:00',3.5),('9303','2013-07-05','11:10:00',3.54),('9303','2013-07-05','11:15:00',3.56),('9303','2013-07-05','11:20:00',3.6),('9303','2013-07-05','11:25:00',3.64),('9303','2013-07-05','11:30:00',3.68),('9303','2013-07-05','11:35:00',3.7),('9303','2013-07-05','11:40:00',3.72),('9303','2013-07-05','11:45:00',3.7),('9303','2013-07-05','11:50:00',3.8),('9303','2013-07-05','11:55:00',3.77),('9303','2013-07-05','12:00:00',3.78),('9303','2013-07-05','12:05:00',3.85),('9303','2013-07-05','12:10:00',3.85),('9303','2013-07-05','12:15:00',3.89),('9303','2013-07-05','12:20:00',3.9),('9303','2013-07-05','12:25:00',2.7),('9303','2013-07-05','12:30:00',3.72),('9303','2013-07-05','12:35:00',2.94),('9303','2013-07-05','12:40:00',3.96),('9303','2013-07-05','12:45:00',4.04),('9303','2013-07-05','12:50:00',4.03),('9303','2013-07-05','12:55:00',3.92),('9303','2013-07-05','13:00:00',3.73),('9303','2013-07-05','13:05:00',2.92),('9303','2013-07-05','13:10:00',4.23),('9303','2013-07-05','13:15:00',3.93),('9303','2013-07-05','13:20:00',3.3),('9303','2013-07-05','13:25:00',4.07),('9303','2013-07-05','13:30:00',3.74),('9303','2013-07-05','13:35:00',4.05),('9303','2013-07-05','13:40:00',4.18),('9303','2013-07-05','13:45:00',4.12),('9303','2013-07-05','13:50:00',4.07),('9303','2013-07-05','13:55:00',4.09),('9303','2013-07-05','14:00:00',4.09),('9303','2013-07-05','14:05:00',3.35),('9303','2013-07-05','14:10:00',3.28),('9303','2013-07-05','14:15:00',4.03),('9303','2013-07-05','14:20:00',3.92),('9303','2013-07-05','14:25:00',3.93),('9303','2013-07-05','14:30:00',3.87),('9303','2013-07-05','14:35:00',3.85),('9303','2013-07-05','14:40:00',3.88),('9303','2013-07-05','14:45:00',3.04),('9303','2013-07-05','14:50:00',3.82),('9303','2013-07-05','14:55:00',3.79),('9303','2013-07-05','15:00:00',3.77),('9303','2013-07-05','15:05:00',3.15),('9303','2013-07-05','15:10:00',3.8),('9303','2013-07-05','15:15:00',3.71),('9303','2013-07-05','15:20:00',2.34),('9303','2013-07-05','15:25:00',3.37),('9303','2013-07-05','15:30:00',3.42),('9303','2013-07-05','15:35:00',3.6),('9303','2013-07-05','15:40:00',3.51),('9303','2013-07-05','15:45:00',3.5),('9303','2013-07-05','15:50:00',3.43),('9303','2013-07-05','15:55:00',3.3),('9303','2013-07-05','16:00:00',3.22),('9303','2013-07-05','16:05:00',3.2),('9303','2013-07-05','16:10:00',3.11),('9303','2013-07-05','16:15:00',3.07),('9303','2013-07-05','16:20:00',3.07),('9303','2013-07-05','16:25:00',3),('9303','2013-07-05','16:30:00',2.93),('9303','2013-07-05','16:35:00',2.84),('9303','2013-07-05','16:40:00',2.79),('9303','2013-07-05','16:45:00',2.76),('9303','2013-07-05','16:50:00',2.63),('9303','2013-07-05','16:55:00',2.52),('9303','2013-07-05','17:00:00',2.48),('9303','2013-07-05','17:05:00',2.42),('9303','2013-07-05','17:10:00',2.4),('9303','2013-07-05','17:15:00',2.34),('9303','2013-07-05','17:20:00',2.23),('9303','2013-07-05','17:25:00',2.1),('9303','2013-07-05','17:30:00',1.98),('9303','2013-07-05','17:35:00',1.8),('9303','2013-07-05','17:40:00',1.73),('9303','2013-07-05','17:45:00',1.65),('9303','2013-07-05','17:50:00',1.59),('9303','2013-07-05','17:55:00',1.53),('9303','2013-07-05','18:00:00',1.5),('9303','2013-07-05','18:05:00',1.39),('9303','2013-07-04','11:15:00',1.02),('9303','2013-07-04','11:30:00',1.06),('9303','2013-07-04','11:35:00',1.21),('9303','2013-07-04','11:40:00',1.37),('9303','2013-07-04','11:45:00',1.54),('9303','2013-07-04','11:50:00',1.62),('9303','2013-07-04','11:55:00',1.48),('9303','2013-07-04','12:00:00',1.46),('9303','2013-07-04','12:05:00',1.53),('9303','2013-07-04','12:10:00',2.09),('9303','2013-07-04','12:15:00',2.88),('9303','2013-07-04','12:20:00',2.34),('9303','2013-07-04','12:25:00',2.78),('9303','2013-07-04','12:30:00',2.61),('9303','2013-07-04','12:35:00',2.2),('9303','2013-07-04','12:40:00',1.54),('9303','2013-07-04','12:45:00',1.23),('9303','2013-07-04','13:05:00',1),('9303','2013-07-04','13:10:00',1.31),('9303','2013-07-04','13:15:00',1.53),('9303','2013-07-04','13:20:00',1.71),('9303','2013-07-04','13:25:00',2.03),('9303','2013-07-04','13:30:00',1.84),('9303','2013-07-04','13:35:00',1.97),('9303','2013-07-04','13:40:00',2.52),('9303','2013-07-04','13:45:00',2.1),('9303','2013-07-04','13:50:00',2.79),('9303','2013-07-04','13:55:00',2.52),('9303','2013-07-04','14:00:00',2.15),('9303','2013-07-04','14:05:00',2.08),('9303','2013-07-04','14:10:00',2.03),('9303','2013-07-04','14:15:00',2.04),('9303','2013-07-04','14:20:00',2.21),('9303','2013-07-04','14:25:00',1.78),('9303','2013-07-04','14:30:00',1.7),('9303','2013-07-04','14:35:00',1.74),('9303','2013-07-04','14:40:00',2.88),('9303','2013-07-04','14:45:00',3.23),('9303','2013-07-04','14:50:00',2.41),('9303','2013-07-04','14:55:00',2.09),('9303','2013-07-04','15:00:00',3.14),('9303','2013-07-04','15:05:00',4.02),('9303','2013-07-04','15:10:00',2.82),('9303','2013-07-04','15:15:00',4.29),('9303','2013-07-04','15:20:00',4.04),('9303','2013-07-04','15:25:00',3.89),('9303','2013-07-04','15:30:00',2.4),('9303','2013-07-04','15:35:00',2.97),('9303','2013-07-04','15:40:00',2.62),('9303','2013-07-04','15:45:00',2.93),('9303','2013-07-04','15:50:00',2.09),('9303','2013-07-04','15:55:00',2.14),('9303','2013-07-04','16:00:00',2.43),('9303','2013-07-04','16:05:00',2.2),('9303','2013-07-04','16:10:00',1.92),('9303','2013-07-04','16:15:00',1.6),('9303','2013-07-04','16:20:00',1.71),('9303','2013-07-04','16:25:00',1.79),('9303','2013-07-04','16:30:00',1.79),('9303','2013-07-04','16:35:00',1.75),('9303','2013-07-04','16:40:00',1.45),('9303','2013-07-04','16:45:00',1.35),('9303','2013-07-04','16:50:00',1.43),('9303','2013-07-04','16:55:00',1.36),('9303','2013-07-04','17:00:00',1.19),('9303','2013-07-04','17:05:00',1.13),('9303','2013-07-04','17:10:00',1.69),('9303','2013-07-04','17:15:00',2.39),('9303','2013-07-04','17:20:00',2.21),('9303','2013-07-04','17:25:00',2.39),('9303','2013-07-04','17:30:00',1.85),('9303','2013-07-04','17:35:00',1.3),('9303','2013-07-04','17:40:00',2.06),('9303','2013-07-04','17:45:00',1.94),('9303','2013-07-04','17:50:00',1.86),('9303','2013-07-04','17:55:00',1.8),('9303','2013-07-04','18:00:00',1.75),('9303','2013-07-04','18:05:00',1.7),('9303','2013-07-04','18:10:00',1.57),('9303','2013-07-04','18:15:00',1.43),('9303','2013-07-04','18:20:00',1.37),('9303','2013-07-04','18:25:00',1.19),('9303','2013-07-03','07:45:00',1),('9303','2013-07-03','07:50:00',1.08),('9303','2013-07-03','07:55:00',1.18),('9303','2013-07-03','08:00:00',1.27),('9303','2013-07-03','08:05:00',1.35),('9303','2013-07-03','08:10:00',1.44),('9303','2013-07-03','08:15:00',1.53),('9303','2013-07-03','08:20:00',1.6),('9303','2013-07-03','08:25:00',1.68),('9303','2013-07-03','08:30:00',1.76),('9303','2013-07-03','08:35:00',1.85),('9303','2013-07-03','08:40:00',1.94),('9303','2013-07-03','08:45:00',2.01),('9303','2013-07-03','08:50:00',2.07),('9303','2013-07-03','08:55:00',2.16),('9303','2013-07-03','09:00:00',2.24),('9303','2013-07-03','09:05:00',2.32),('9303','2013-07-03','09:10:00',2.36),('9303','2013-07-03','09:15:00',2.43),('9303','2013-07-03','09:20:00',2.5),('9303','2013-07-03','09:25:00',2.56),('9303','2013-07-03','09:30:00',2.6),('9303','2013-07-03','09:35:00',2.66),('9303','2013-07-03','09:40:00',2.77),('9303','2013-07-03','09:45:00',2.8),('9303','2013-07-03','09:50:00',2.83),('9303','2013-07-03','09:55:00',2.9),('9303','2013-07-03','10:00:00',2.96),('9303','2013-07-03','10:05:00',2.99),('9303','2013-07-03','10:10:00',3.07),('9303','2013-07-03','10:15:00',3.08),('9303','2013-07-03','10:20:00',3.13),('9303','2013-07-03','10:25:00',3.18),('9303','2013-07-03','10:30:00',3.24),('9303','2013-07-03','10:35:00',3.26),('9303','2013-07-03','10:40:00',3.35),('9303','2013-07-03','10:45:00',3.37),('9303','2013-07-03','10:50:00',3.41),('9303','2013-07-03','10:55:00',3.45),('9303','2013-07-03','11:00:00',3.47),('9303','2013-07-03','11:05:00',3.53),('9303','2013-07-03','11:10:00',3.51),('9303','2013-07-03','11:15:00',3.62),('9303','2013-07-03','11:20:00',3.7),('9303','2013-07-03','11:25:00',3.71),('9303','2013-07-03','11:30:00',3.7),('9303','2013-07-03','11:35:00',3.7),('9303','2013-07-03','11:40:00',3.75),('9303','2013-07-03','11:45:00',3.88),('9303','2013-07-03','11:50:00',3.88),('9303','2013-07-03','11:55:00',3.94),('9303','2013-07-03','12:00:00',3.98),('9303','2013-07-03','12:05:00',3.98),('9303','2013-07-03','12:10:00',3.98),('9303','2013-07-03','12:15:00',4.02),('9303','2013-07-03','12:20:00',4.02),('9303','2013-07-03','12:25:00',4.01),('9303','2013-07-03','12:30:00',4.05),('9303','2013-07-03','12:35:00',4.09),('9303','2013-07-03','12:40:00',4.08),('9303','2013-07-03','12:45:00',4.06),('9303','2013-07-03','12:50:00',4.11),('9303','2013-07-03','12:55:00',4.1),('9303','2013-07-03','13:00:00',4.13),('9303','2013-07-03','13:05:00',4.12),('9303','2013-07-03','13:10:00',4.14),('9303','2013-07-03','13:15:00',4.17),('9303','2013-07-03','13:20:00',4.13),('9303','2013-07-03','13:25:00',4.09),('9303','2013-07-03','13:30:00',4.08),('9303','2013-07-03','13:35:00',4.06),('9303','2013-07-03','13:40:00',4.05),('9303','2013-07-03','13:45:00',4.07),('9303','2013-07-03','13:50:00',4.08),('9303','2013-07-03','13:55:00',4.05),('9303','2013-07-03','14:00:00',4.05),('9303','2013-07-03','14:05:00',4.04),('9303','2013-07-03','14:10:00',4.04),('9303','2013-07-03','14:15:00',4.02),('9303','2013-07-03','14:20:00',4.03),('9303','2013-07-03','14:25:00',4.01),('9303','2013-07-03','14:30:00',4),('9303','2013-07-03','14:35:00',3.92),('9303','2013-07-03','14:40:00',3.92),('9303','2013-07-03','14:45:00',3.94),('9303','2013-07-03','14:50:00',3.9),('9303','2013-07-03','14:55:00',3.87),('9303','2013-07-03','15:00:00',3.84),('9303','2013-07-03','15:05:00',3.82),('9303','2013-07-03','15:10:00',3.77),('9303','2013-07-03','15:15:00',3.73),('9303','2013-07-03','15:20:00',3.67),('9303','2013-07-03','15:25:00',3.67),('9303','2013-07-03','15:30:00',3.64),('9303','2013-07-03','15:35:00',3.61),('9303','2013-07-03','15:40:00',3.56),('9303','2013-07-03','15:45:00',3.52),('9303','2013-07-03','15:50:00',3.45),('9303','2013-07-03','15:55:00',3.43),('9303','2013-07-03','16:00:00',3.34),('9303','2013-07-03','16:05:00',3.28),('9303','2013-07-03','16:10:00',3.24),('9303','2013-07-03','16:15:00',3.18),('9303','2013-07-03','16:20:00',3.13),('9303','2013-07-03','16:25:00',3.06),('9303','2013-07-03','16:30:00',3.01),('9303','2013-07-03','16:35:00',2.96),('9303','2013-07-03','16:40:00',2.89),('9303','2013-07-03','16:45:00',2.83),('9303','2013-07-03','16:50:00',2.75),('9303','2013-07-03','16:55:00',2.69),('9303','2013-07-03','17:00:00',2.61),('9303','2013-07-03','17:05:00',2.55),('9303','2013-07-03','17:10:00',2.48),('9303','2013-07-03','17:15:00',2.39),('9303','2013-07-03','17:20:00',2.28),('9303','2013-07-03','17:25:00',2.17),('9303','2013-07-03','17:30:00',2.05),('9303','2013-07-03','17:35:00',1.88),('9303','2013-07-03','17:40:00',1.88),('9303','2013-07-03','17:45:00',1.82),('9303','2013-07-03','17:50:00',1.74),('9303','2013-07-03','17:55:00',1.67),('9303','2013-07-03','18:00:00',1.6),('9303','2013-07-03','18:05:00',1.47),('9303','2013-07-03','18:10:00',1.37),('9303','2013-07-03','18:15:00',1.28),('9303','2013-07-03','18:20:00',1.17),('9303','2013-07-03','18:25:00',1.07),('9303','2013-07-02','07:50:00',1.06),('9303','2013-07-02','07:55:00',1.15),('9303','2013-07-02','08:00:00',1.23),('9303','2013-07-02','08:05:00',1.32),('9303','2013-07-02','08:10:00',1.42),('9303','2013-07-02','08:15:00',1.52),('9303','2013-07-02','08:20:00',1.6),('9303','2013-07-02','08:25:00',1.68),('9303','2013-07-02','08:30:00',1.76),('9303','2013-07-02','08:35:00',1.82),('9303','2013-07-02','08:40:00',1.89),('9303','2013-07-02','08:45:00',1.97),('9303','2013-07-02','08:50:00',2.05),('9303','2013-07-02','08:55:00',2.09),('9303','2013-07-02','09:00:00',2.17),('9303','2013-07-02','09:05:00',2.3),('9303','2013-07-02','09:10:00',2.37),('9303','2013-07-02','09:15:00',2.42),('9303','2013-07-02','09:20:00',2.49),('9303','2013-07-02','09:25:00',2.55),('9303','2013-07-02','09:30:00',2.62),('9303','2013-07-02','09:35:00',2.67),('9303','2013-07-02','09:40:00',2.75),('9303','2013-07-02','09:45:00',2.8),('9303','2013-07-02','09:50:00',2.84),('9303','2013-07-02','09:55:00',2.89),('9303','2013-07-02','10:00:00',2.95),('9303','2013-07-02','10:05:00',2.99),('9303','2013-07-02','10:10:00',3.04),('9303','2013-07-02','10:15:00',3.08),('9303','2013-07-02','10:20:00',3.14),('9303','2013-07-02','10:25:00',3.15),('9303','2013-07-02','10:30:00',3.2),('9303','2013-07-02','10:35:00',3.24),('9303','2013-07-02','10:40:00',3.28),('9303','2013-07-02','10:45:00',3.33),('9303','2013-07-02','10:50:00',3.39),('9303','2013-07-02','10:55:00',3.4),('9303','2013-07-02','11:00:00',3.4),('9303','2013-07-02','11:05:00',3.42),('9303','2013-07-02','11:10:00',3.5),('9303','2013-07-02','11:15:00',3.53),('9303','2013-07-02','11:20:00',3.53),('9303','2013-07-02','11:25:00',3.58),('9303','2013-07-02','11:30:00',3.6),('9303','2013-07-02','11:35:00',3.65),('9303','2013-07-02','11:40:00',3.64),('9303','2013-07-02','11:45:00',3.63),('9303','2013-07-02','11:50:00',3.65),('9303','2013-07-02','11:55:00',3.75),('9303','2013-07-02','12:00:00',3.68),('9303','2013-07-02','12:05:00',3.69),('9303','2013-07-02','12:10:00',3.84),('9303','2013-07-02','12:15:00',3.77),('9303','2013-07-02','12:20:00',3.81),('9303','2013-07-02','12:25:00',3.9),('9303','2013-07-02','12:30:00',3.94),('9303','2013-07-02','12:35:00',3.96),('9303','2013-07-02','12:40:00',3.93),('9303','2013-07-02','12:45:00',3.99),('9303','2013-07-02','12:50:00',3.92),('9303','2013-07-02','12:55:00',1.14),('9303','2013-07-02','13:00:00',3.09),('9303','2013-07-02','13:05:00',2.03),('9303','2013-07-02','13:10:00',3.24),('9303','2013-07-02','13:15:00',4.28),('9303','2013-07-02','13:20:00',4.16),('9303','2013-07-02','13:25:00',4.18),('9303','2013-07-02','13:30:00',4.18),('9303','2013-07-02','13:35:00',4.12),('9303','2013-07-02','13:40:00',4.09),('9303','2013-07-02','13:45:00',3.93),('9303','2013-07-02','13:50:00',3.91),('9303','2013-07-02','13:55:00',3.94),('9303','2013-07-02','14:00:00',3.91),('9303','2013-07-02','14:05:00',3.89),('9303','2013-07-02','14:10:00',3.87),('9303','2013-07-02','14:15:00',3.88),('9303','2013-07-02','14:20:00',3.92),('9303','2013-07-02','14:25:00',3.91),('9303','2013-07-02','14:30:00',3.87),('9303','2013-07-02','14:35:00',3.86),('9303','2013-07-02','14:40:00',3.81),('9303','2013-07-02','14:45:00',3.79),('9303','2013-07-02','14:50:00',3.74),('9303','2013-07-02','14:55:00',3.76),('9303','2013-07-02','15:00:00',3.75),('9303','2013-07-02','15:05:00',3.75),('9303','2013-07-02','15:10:00',3.69),('9303','2013-07-02','15:15:00',3.62),('9303','2013-07-02','15:20:00',3.62),('9303','2013-07-02','15:25:00',3.57),('9303','2013-07-02','15:30:00',3.54),('9303','2013-07-02','15:35:00',3.51),('9303','2013-07-02','15:40:00',3.46),('9303','2013-07-02','15:45:00',3.4),('9303','2013-07-02','15:50:00',3.34),('9303','2013-07-02','15:55:00',3.29),('9303','2013-07-02','16:00:00',3.26),('9303','2013-07-02','16:05:00',3.21),('9303','2013-07-02','16:10:00',3.14),('9303','2013-07-02','16:15:00',3.08),('9303','2013-07-02','16:20:00',3.03),('9303','2013-07-02','16:25:00',2.96),('9303','2013-07-02','16:30:00',2.88),('9303','2013-07-02','16:35:00',2.83),('9303','2013-07-02','16:40:00',2.78),('9303','2013-07-02','16:45:00',2.71),('9303','2013-07-02','16:50:00',2.66),('9303','2013-07-02','16:55:00',2.59),('9303','2013-07-02','17:00:00',2.55),('9303','2013-07-02','17:05:00',2.48),('9303','2013-07-02','17:10:00',2.39),('9303','2013-07-02','17:15:00',2.29),('9303','2013-07-02','17:20:00',2.18),('9303','2013-07-02','17:25:00',2.07),('9303','2013-07-02','17:30:00',1.95),('9303','2013-07-02','17:35:00',1.83),('9303','2013-07-02','17:40:00',1.81),('9303','2013-07-02','17:45:00',1.71),('9303','2013-07-02','17:50:00',1.64),('9303','2013-07-02','17:55:00',1.58),('9303','2013-07-02','18:00:00',1.5),('9303','2013-07-02','18:05:00',1.41),('9303','2013-07-02','18:10:00',1.31),('9303','2013-07-02','18:15:00',1.2),('9303','2013-07-02','18:20:00',1.1),('9303','2013-07-02','18:25:00',1.01),('9303','2013-07-01','07:50:00',1.07),('9303','2013-07-01','07:55:00',1.16),('9303','2013-07-01','08:00:00',1.25),('9303','2013-07-01','08:05:00',1.34),('9303','2013-07-01','08:10:00',1.43),('9303','2013-07-01','08:15:00',1.52),('9303','2013-07-01','08:20:00',1.61),('9303','2013-07-01','08:25:00',1.7),('9303','2013-07-01','08:30:00',1.77),('9303','2013-07-01','08:35:00',1.85),('9303','2013-07-01','08:40:00',1.93),('9303','2013-07-01','08:45:00',2),('9303','2013-07-01','08:50:00',2.07),('9303','2013-07-01','08:55:00',2.15),('9303','2013-07-01','09:00:00',2.22),('9303','2013-07-01','09:05:00',2.34),('9303','2013-07-01','09:10:00',2.43),('9303','2013-07-01','09:15:00',2.5),('9303','2013-07-01','09:20:00',2.59),('9303','2013-07-01','09:25:00',2.65),('9303','2013-07-01','09:30:00',2.71),('9303','2013-07-01','09:35:00',2.78),('9303','2013-07-01','09:40:00',2.82),('9303','2013-07-01','09:45:00',2.86),('9303','2013-07-01','09:50:00',2.91),('9303','2013-07-01','09:55:00',2.97),('9303','2013-07-01','10:00:00',3.03),('9303','2013-07-01','10:05:00',3.09),('9303','2013-07-01','10:10:00',3.13),('9303','2013-07-01','10:15:00',3.21),('9303','2013-07-01','10:20:00',3.26),('9303','2013-07-01','10:25:00',3.31),('9303','2013-07-01','10:30:00',3.36),('9303','2013-07-01','10:35:00',3.39),('9303','2013-07-01','10:40:00',3.44),('9303','2013-07-01','10:45:00',3.5),('9303','2013-07-01','10:50:00',3.57),('9303','2013-07-01','10:55:00',3.62),('9303','2013-07-01','11:00:00',3.65),('9303','2013-07-01','11:05:00',3.67),('9303','2013-07-01','11:10:00',3.71),('9303','2013-07-01','11:15:00',3.74),('9303','2013-07-01','11:20:00',3.74),('9303','2013-07-01','11:25:00',3.77),('9303','2013-07-01','11:30:00',3.79),('9303','2013-07-01','11:35:00',3.83),('9303','2013-07-01','11:40:00',3.83),('9303','2013-07-01','11:45:00',3.84),('9303','2013-07-01','11:50:00',3.85),('9303','2013-07-01','11:55:00',3.86),('9303','2013-07-01','12:00:00',3.88),('9303','2013-07-01','12:05:00',3.86),('9303','2013-07-01','12:10:00',3.88),('9303','2013-07-01','12:15:00',3.94),('9303','2013-07-01','12:20:00',4),('9303','2013-07-01','12:25:00',4.02),('9303','2013-07-01','12:30:00',4.02),('9303','2013-07-01','12:35:00',4.02),('9303','2013-07-01','12:40:00',3.99),('9303','2013-07-01','12:45:00',3.98),('9303','2013-07-01','12:50:00',4.01),('9303','2013-07-01','12:55:00',4.1),('9303','2013-07-01','13:00:00',4.13),('9303','2013-07-01','13:05:00',4.11),('9303','2013-07-01','13:10:00',4.14),('9303','2013-07-01','13:15:00',4.14),('9303','2013-07-01','13:20:00',4.13),('9303','2013-07-01','13:25:00',4.15),('9303','2013-07-01','13:30:00',4.13),('9303','2013-07-01','13:35:00',4.11),('9303','2013-07-01','13:40:00',4.04),('9303','2013-07-01','13:45:00',4.04),('9303','2013-07-01','13:50:00',4.05),('9303','2013-07-01','13:55:00',4.01),('9303','2013-07-01','14:00:00',3.97),('9303','2013-07-01','14:05:00',4.04),('9303','2013-07-01','14:10:00',4.02),('9303','2013-07-01','14:15:00',4.02),('9303','2013-07-01','14:20:00',3.99),('9303','2013-07-01','14:25:00',3.92),('9303','2013-07-01','14:30:00',3.88),('9303','2013-07-01','14:35:00',3.88),('9303','2013-07-01','14:40:00',3.86),('9303','2013-07-01','14:45:00',3.83),('9303','2013-07-01','14:50:00',3.78),('9303','2013-07-01','14:55:00',3.75),('9303','2013-07-01','15:00:00',3.71),('9303','2013-07-01','15:05:00',3.66),('9303','2013-07-01','15:10:00',3.64),('9303','2013-07-01','15:15:00',3.59),('9303','2013-07-01','15:20:00',3.59),('9303','2013-07-01','15:25:00',3.54),('9303','2013-07-01','15:30:00',3.49),('9303','2013-07-01','15:35:00',3.46),('9303','2013-07-01','15:40:00',3.41),('9303','2013-07-01','15:45:00',3.39),('9303','2013-07-01','15:50:00',3.34),('9303','2013-07-01','15:55:00',3.26),('9303','2013-07-01','16:00:00',3.23),('9303','2013-07-01','16:05:00',3.16),('9303','2013-07-01','16:10:00',3.14),('9303','2013-07-01','16:15:00',3.07),('9303','2013-07-01','16:20:00',2.98),('9303','2013-07-01','16:25:00',2.94),('9303','2013-07-01','16:30:00',2.86),('9303','2013-07-01','16:35:00',2.78),('9303','2013-07-01','16:40:00',2.73),('9303','2013-07-01','16:45:00',2.68),('9303','2013-07-01','16:50:00',2.64),('9303','2013-07-01','16:55:00',2.57),('9303','2013-07-01','17:00:00',2.52),('9303','2013-07-01','17:05:00',2.45),('9303','2013-07-01','17:10:00',2.38),('9303','2013-07-01','17:15:00',2.28),('9303','2013-07-01','17:20:00',2.16),('9303','2013-07-01','17:25:00',2.05),('9303','2013-07-01','17:30:00',1.91),('9303','2013-07-01','17:35:00',1.76),('9303','2013-07-01','17:40:00',1.78),('9303','2013-07-01','17:45:00',1.72),('9303','2013-07-01','17:50:00',1.65),('9303','2013-07-01','17:55:00',1.58),('9303','2013-07-01','18:00:00',1.39),('9303','2013-07-01','18:05:00',1.37),('9303','2013-07-01','18:10:00',1.29),('9303','2013-07-01','18:15:00',1.05),('9303','2013-07-01','18:20:00',1.07),('9303','2013-07-01','18:25:00',1.09),('9303','2013-07-01','18:30:00',1.03),('9303','2014-04-05','09:15:00',1.08),('9303','2014-04-05','09:20:00',1.47),('9303','2014-04-05','09:25:00',2.49),('9303','2014-04-05','09:30:00',3.44),('9303','2014-04-05','09:35:00',3.34),('9303','2014-04-05','09:40:00',3.2),('9303','2014-04-05','09:45:00',2.31),('9303','2014-04-05','09:50:00',1.47),('9303','2014-04-05','09:55:00',2.32),('9303','2014-04-05','10:00:00',2.05),('9303','2014-04-05','10:05:00',1.98),('9303','2014-04-05','10:10:00',2.04),('9303','2014-04-05','10:15:00',1.51),('9303','2014-04-05','10:20:00',2.47),('9303','2014-04-05','10:25:00',2.57),('9303','2014-04-05','10:30:00',2.49),('9303','2014-04-05','10:35:00',2.8),('9303','2014-04-05','10:40:00',2.97),('9303','2014-04-05','10:45:00',2.92),('9303','2014-04-05','10:50:00',2.59),('9303','2014-04-05','10:55:00',2.84),('9303','2014-04-05','11:00:00',3.28),('9303','2014-04-05','11:05:00',3.56),('9303','2014-04-05','11:10:00',3.83),('9303','2014-04-05','11:15:00',4.04),('9303','2014-04-05','11:20:00',4.05),('9303','2014-04-05','11:25:00',2.88),('9303','2014-04-05','11:30:00',2.2),('9303','2014-04-05','11:35:00',2.47),('9303','2014-04-05','11:40:00',3.43),('9303','2014-04-05','11:45:00',3.89),('9303','2014-04-05','11:50:00',4.18),('9303','2014-04-05','11:55:00',3.94),('9303','2014-04-05','12:00:00',3.33),('9303','2014-04-05','12:05:00',2.95),('9303','2014-04-05','12:10:00',3.06),('9303','2014-04-05','12:15:00',2.98),('9303','2014-04-05','12:20:00',3.47),('9303','2014-04-05','12:25:00',3),('9303','2014-04-05','12:30:00',2.43),('9303','2014-04-05','12:35:00',2.15),('9303','2014-04-05','12:40:00',3.64),('9303','2014-04-05','12:45:00',4.54),('9303','2014-04-05','12:50:00',4.63),('9303','2014-04-05','12:55:00',3.86),('9303','2014-04-05','13:00:00',3.34),('9303','2014-04-05','13:05:00',2.95),('9303','2014-04-05','13:10:00',3.71),('9303','2014-04-05','13:15:00',2.52),('9303','2014-04-05','13:20:00',4.39),('9303','2014-04-05','13:25:00',3.34),('9303','2014-04-05','13:30:00',3.88),('9303','2014-04-05','13:35:00',4.59),('9303','2014-04-05','13:40:00',4.61),('9303','2014-04-05','13:45:00',4.03),('9303','2014-04-05','13:50:00',4.45),('9303','2014-04-05','13:55:00',3.76),('9303','2014-04-05','14:00:00',3.45),('9303','2014-04-05','14:05:00',4.93),('9303','2014-04-05','14:10:00',2.33),('9303','2014-04-05','14:25:00',1.08),('9303','2014-04-05','14:30:00',1.23),('9303','2014-04-05','14:50:00',2.42),('9303','2014-04-05','14:55:00',4.24),('9303','2014-04-05','15:00:00',3.54),('9303','2014-04-05','15:05:00',3.95),('9303','2014-04-05','15:10:00',1.28),('9303','2014-04-05','15:15:00',2.88),('9303','2014-04-05','15:20:00',4.38),('9303','2014-04-05','15:25:00',2.66),('9303','2014-04-05','15:30:00',1.36),('9303','2014-04-05','15:35:00',1.57),('9303','2014-04-05','15:40:00',2.28),('9303','2014-04-05','15:45:00',2.01),('9303','2014-04-05','15:50:00',1.84),('9303','2014-04-05','15:55:00',1.14),('9303','2014-04-05','16:00:00',1.22),('9303','2014-04-05','16:05:00',1.27),('9303','2014-04-05','16:10:00',1.21),('9303','2014-04-05','16:15:00',2.13),('9303','2014-04-05','16:20:00',3.21),('9303','2014-04-05','16:25:00',3.39),('9303','2014-04-05','16:30:00',1.95),('9303','2014-04-05','16:35:00',2.28),('9303','2014-04-05','16:40:00',1.54),('9303','2014-04-05','16:45:00',1.72),('9303','2014-04-05','16:50:00',1.67),('9303','2014-04-05','16:55:00',2.07),('9303','2014-04-05','17:00:00',1.74),('9303','2014-04-05','17:05:00',1.98),('9303','2014-04-05','17:10:00',1.72),('9303','2014-04-05','17:15:00',1.1),('9303','2014-04-05','17:20:00',1.29),('9303','2014-04-05','17:25:00',1.32),('9303','2014-04-05','17:30:00',1.2),('9303','2014-04-05','17:50:00',1.03),('9303','2014-04-05','17:55:00',1.03),('9303','2014-04-05','18:00:00',1.02),('9303','2013-06-30','07:45:00',1.07),('9303','2013-06-30','07:50:00',1.15),('9303','2013-06-30','07:55:00',1.24),('9303','2013-06-30','08:00:00',1.32),('9303','2013-06-30','08:05:00',1.41),('9303','2013-06-30','08:10:00',1.5),('9303','2013-06-30','08:15:00',1.6),('9303','2013-06-30','08:20:00',1.68),('9303','2013-06-30','08:25:00',1.77),('9303','2013-06-30','08:30:00',1.86),('9303','2013-06-30','08:35:00',1.94),('9303','2013-06-30','08:40:00',2.02),('9303','2013-06-30','08:45:00',2.1),('9303','2013-06-30','08:50:00',2.17),('9303','2013-06-30','08:55:00',2.24),('9303','2013-06-30','09:00:00',2.31),('9303','2013-06-30','09:05:00',2.43),('9303','2013-06-30','09:10:00',2.5),('9303','2013-06-30','09:15:00',2.56),('9303','2013-06-30','09:20:00',2.62),('9303','2013-06-30','09:25:00',2.7),('9303','2013-06-30','09:30:00',2.77),('9303','2013-06-30','09:35:00',2.82),('9303','2013-06-30','09:40:00',2.89),('9303','2013-06-30','09:45:00',2.95),('9303','2013-06-30','09:50:00',3),('9303','2013-06-30','09:55:00',3.06),('9303','2013-06-30','10:00:00',3.12),('9303','2013-06-30','10:05:00',3.19),('9303','2013-06-30','10:10:00',3.24),('9303','2013-06-30','10:15:00',3.3),('9303','2013-06-30','10:20:00',3.32),('9303','2013-06-30','10:25:00',3.34),('9303','2013-06-30','10:30:00',3.43),('9303','2013-06-30','10:35:00',3.47),('9303','2013-06-30','10:40:00',3.56),('9303','2013-06-30','10:45:00',3.56),('9303','2013-06-30','10:50:00',3.58),('9303','2013-06-30','10:55:00',3.6),('9303','2013-06-30','11:00:00',3.62),('9303','2013-06-30','11:05:00',3.64),('9303','2013-06-30','11:10:00',3.67),('9303','2013-06-30','11:15:00',3.71),('9303','2013-06-30','11:20:00',3.75),('9303','2013-06-30','11:25:00',3.78),('9303','2013-06-30','11:30:00',3.8),('9303','2013-06-30','11:35:00',3.82),('9303','2013-06-30','11:40:00',3.84),('9303','2013-06-30','11:45:00',3.87),('9303','2013-06-30','11:50:00',3.89),('9303','2013-06-30','11:55:00',3.92),('9303','2013-06-30','12:00:00',3.92),('9303','2013-06-30','12:05:00',4.01),('9303','2013-06-30','12:10:00',4.03),('9303','2013-06-30','12:15:00',4.03),('9303','2013-06-30','12:20:00',4.03),('9303','2013-06-30','12:25:00',4.04),('9303','2013-06-30','12:30:00',4.07),('9303','2013-06-30','12:35:00',4.09),('9303','2013-06-30','12:40:00',4.11),('9303','2013-06-30','12:45:00',4.14),('9303','2013-06-30','12:50:00',4.2),('9303','2013-06-30','12:55:00',4.16),('9303','2013-06-30','13:00:00',4.15),('9303','2013-06-30','13:05:00',4.12),('9303','2013-06-30','13:10:00',4.11),('9303','2013-06-30','13:15:00',4.19),('9303','2013-06-30','13:20:00',4.22),('9303','2013-06-30','13:25:00',4.24),('9303','2013-06-30','13:30:00',4.19),('9303','2013-06-30','13:35:00',4.13),('9303','2013-06-30','13:40:00',4.06),('9303','2013-06-30','13:45:00',4.14),('9303','2013-06-30','13:50:00',4.18),('9303','2013-06-30','13:55:00',3.76),('9303','2013-06-30','14:00:00',4.23),('9303','2013-06-30','14:05:00',4.2),('9303','2013-06-30','14:10:00',4.16),('9303','2013-06-30','14:15:00',4.01),('9303','2013-06-30','14:20:00',4.02),('9303','2013-06-30','14:25:00',4.02),('9303','2013-06-30','14:30:00',4),('9303','2013-06-30','14:35:00',4.01),('9303','2013-06-30','14:40:00',4.01),('9303','2013-06-30','14:45:00',3.97),('9303','2013-06-30','14:50:00',3.94),('9303','2013-06-30','14:55:00',3.9),('9303','2013-06-30','15:00:00',3.83),('9303','2013-06-30','15:05:00',3.79),('9303','2013-06-30','15:10:00',3.76),('9303','2013-06-30','15:15:00',3.72),('9303','2013-06-30','15:20:00',3.75),('9303','2013-06-30','15:25:00',3.67),('9303','2013-06-30','15:30:00',3.65),('9303','2013-06-30','15:35:00',3.63),('9303','2013-06-30','15:40:00',3.58),('9303','2013-06-30','15:45:00',3.54),('9303','2013-06-30','15:50:00',3.51),('9303','2013-06-30','15:55:00',3.44),('9303','2013-06-30','16:00:00',3.39),('9303','2013-06-30','16:05:00',3.33),('9303','2013-06-30','16:10:00',3.32),('9303','2013-06-30','16:15:00',3.27),('9303','2013-06-30','16:20:00',3.3),('9303','2013-06-30','16:25:00',3.31),('9303','2013-06-30','16:30:00',2.78),('9303','2013-06-30','16:35:00',3.02),('9303','2013-06-30','16:40:00',2.83),('9303','2013-06-30','16:45:00',2.81),('9303','2013-06-30','16:50:00',2.75),('9303','2013-06-30','16:55:00',2.64),('9303','2013-06-30','17:00:00',2.53),('9303','2013-06-30','17:05:00',2.48),('9303','2013-06-30','17:10:00',2.44),('9303','2013-06-30','17:15:00',2.32),('9303','2013-06-30','17:20:00',2.19),('9303','2013-06-30','17:25:00',2.08),('9303','2013-06-30','17:30:00',1.91),('9303','2013-06-30','17:35:00',1.75),('9303','2013-06-30','17:40:00',1.71),('9303','2013-06-30','17:45:00',1.72),('9303','2013-06-30','17:50:00',1.66),('9303','2013-06-30','17:55:00',1.58),('9303','2013-06-30','18:00:00',1.5),('9303','2013-06-30','18:05:00',1.39),('9303','2013-06-30','18:10:00',1.3),('9303','2013-06-30','18:15:00',1.2),('9303','2013-06-30','18:20:00',1.11),('9303','2013-06-30','18:25:00',1.02),('9303','2013-06-29','07:35:00',1.22),('9303','2013-06-29','07:40:00',1.29),('9303','2013-06-29','07:45:00',1.32),('9303','2013-06-29','07:50:00',1.39),('9303','2013-06-29','07:55:00',1.47),('9303','2013-06-29','08:00:00',1.75),('9303','2013-06-29','08:05:00',1.9),('9303','2013-06-29','08:10:00',1.99),('9303','2013-06-29','08:15:00',1.79),('9303','2013-06-29','08:20:00',1.13),('9303','2013-06-29','08:25:00',1.56),('9303','2013-06-29','08:30:00',1.95),('9303','2013-06-29','08:35:00',2.02),('9303','2013-06-29','08:40:00',1.1),('9303','2013-06-29','08:45:00',2.02),('9303','2013-06-29','08:50:00',2.18),('9303','2013-06-29','08:55:00',2.24),('9303','2013-06-29','09:00:00',2.3),('9303','2013-06-29','09:05:00',2.4),('9303','2013-06-29','09:10:00',2.45),('9303','2013-06-29','09:15:00',2.52),('9303','2013-06-29','09:20:00',2.58),('9303','2013-06-29','09:25:00',2.64),('9303','2013-06-29','09:30:00',2.71),('9303','2013-06-29','09:35:00',2.8),('9303','2013-06-29','09:40:00',2.86),('9303','2013-06-29','09:45:00',2.88),('9303','2013-06-29','09:50:00',2.96),('9303','2013-06-29','09:55:00',3.02),('9303','2013-06-29','10:00:00',3.1),('9303','2013-06-29','10:05:00',3.16),('9303','2013-06-29','10:10:00',3.19),('9303','2013-06-29','10:15:00',3.2),('9303','2013-06-29','10:20:00',3.28),('9303','2013-06-29','10:25:00',3.34),('9303','2013-06-29','10:30:00',3.38),('9303','2013-06-29','10:35:00',3.42),('9303','2013-06-29','10:40:00',3.41),('9303','2013-06-29','10:45:00',3.49),('9303','2013-06-29','10:50:00',3.58),('9303','2013-06-29','10:55:00',2.87),('9303','2013-06-29','11:00:00',3.39),('9303','2013-06-29','11:05:00',3.82),('9303','2013-06-29','11:10:00',3.87),('9303','2013-06-29','11:15:00',3.34),('9303','2013-06-29','11:20:00',2.75),('9303','2013-06-29','11:25:00',4.22),('9303','2013-06-29','11:30:00',3.49),('9303','2013-06-29','11:35:00',3.15),('9303','2013-06-29','11:40:00',4.04),('9303','2013-06-29','11:45:00',1.19),('9303','2013-06-29','11:50:00',4.03),('9303','2013-06-29','11:55:00',3.71),('9303','2013-06-29','12:00:00',3.14),('9303','2013-06-29','12:05:00',4.27),('9303','2013-06-29','12:10:00',4.35),('9303','2013-06-29','12:15:00',2.39),('9303','2013-06-29','12:25:00',4.42),('9303','2013-06-29','12:30:00',4.37),('9303','2013-06-29','12:35:00',4.34),('9303','2013-06-29','12:40:00',4.41),('9303','2013-06-29','12:45:00',4.47),('9303','2013-06-29','12:50:00',1.58),('9303','2013-06-29','12:55:00',4.16),('9303','2013-06-29','13:00:00',3.82),('9303','2013-06-29','13:05:00',4.18),('9303','2013-06-29','13:10:00',4.48),('9303','2013-06-29','13:15:00',3.8),('9303','2013-06-29','13:20:00',1.69),('9303','2013-06-29','13:25:00',3.01),('9303','2013-06-29','13:30:00',1.79),('9303','2013-06-29','13:45:00',2.63),('9303','2013-06-29','13:50:00',2.53),('9303','2013-06-29','13:55:00',4.94),('9303','2013-06-29','14:00:00',4.55),('9303','2013-06-29','14:05:00',4.3),('9303','2013-06-29','14:10:00',4.63),('9303','2013-06-29','14:15:00',4.71),('9303','2013-06-29','14:20:00',3.6),('9303','2013-06-29','14:25:00',2.97),('9303','2013-06-29','14:30:00',4.71),('9303','2013-06-29','14:35:00',4.43),('9303','2013-06-29','14:40:00',4.41),('9303','2013-06-29','14:45:00',4.49),('9303','2013-06-29','14:50:00',4.56),('9303','2013-06-29','14:55:00',1.4),('9303','2013-06-29','15:00:00',2.56),('9303','2013-06-29','15:05:00',3.63),('9303','2013-06-29','15:10:00',2.31),('9303','2013-06-29','15:15:00',1.44),('9303','2013-06-29','16:40:00',1.11),('9303','2013-06-29','16:45:00',1.47),('9303','2013-06-29','16:50:00',2.27),('9303','2013-06-29','17:05:00',1.06),('9303','2013-06-29','17:20:00',1.04),('9303','2013-06-29','17:25:00',1.27),('9303','2013-06-29','17:30:00',2.19),('9303','2013-06-29','17:35:00',1.57),('9303','2013-06-29','17:45:00',1.82),('9303','2013-06-29','17:50:00',1.76),('9303','2013-06-29','17:55:00',1.68),('9303','2013-06-29','18:00:00',1.56),('9303','2013-06-29','18:05:00',1.46),('9303','2013-06-29','18:10:00',1.32),('9303','2013-06-29','18:15:00',1.24),('9303','2013-06-29','18:20:00',1.13),('9303','2013-06-29','18:25:00',1.11),('9303','2013-06-29','18:35:00',1.03),('9303','2013-06-28','07:45:00',1.09),('9303','2013-06-28','07:50:00',1.14),('9303','2013-06-28','07:55:00',1.22),('9303','2013-06-28','08:00:00',1.28),('9303','2013-06-28','08:05:00',1.33),('9303','2013-06-28','08:10:00',1.35),('9303','2013-06-28','08:15:00',1.53),('9303','2013-06-28','08:20:00',1.62),('9303','2013-06-28','08:25:00',1.57),('9303','2013-06-28','08:30:00',1.77),('9303','2013-06-28','08:35:00',1.88),('9303','2013-06-28','08:40:00',1.94),('9303','2013-06-28','08:45:00',2.01),('9303','2013-06-28','08:50:00',2.07),('9303','2013-06-28','08:55:00',2.16),('9303','2013-06-28','09:00:00',2.2),('9303','2013-06-28','09:05:00',2.31),('9303','2013-06-28','09:10:00',2.48),('9303','2013-06-28','09:15:00',2.37),('9303','2013-06-28','09:20:00',1.38),('9303','2013-06-28','09:30:00',1.29),('9303','2013-06-28','09:35:00',2.94),('9303','2013-06-28','09:40:00',2.96),('9303','2013-06-28','09:45:00',2.54),('9303','2013-06-28','09:50:00',3),('9303','2013-06-28','09:55:00',3.15),('9303','2013-06-28','10:00:00',2.05),('9303','2013-06-28','10:05:00',1.69),('9303','2013-06-28','10:10:00',3.44),('9303','2013-06-28','10:15:00',3.55),('9303','2013-06-28','10:20:00',2.88),('9303','2013-06-28','10:25:00',2.57),('9303','2013-06-28','10:30:00',1.26),('9303','2013-06-28','10:35:00',3.78),('9303','2013-06-28','10:40:00',4.16),('9303','2013-06-28','10:45:00',3.97),('9303','2013-06-28','10:50:00',3.16),('9303','2013-06-28','10:55:00',2.44),('9303','2013-06-28','11:00:00',2.81),('9303','2013-06-28','11:05:00',4.13),('9303','2013-06-28','11:10:00',1.72),('9303','2013-06-28','11:15:00',1.46),('9303','2013-06-28','11:20:00',1.87),('9303','2013-06-28','11:25:00',2.7),('9303','2013-06-28','11:30:00',4.18),('9303','2013-06-28','11:35:00',3.74),('9303','2013-06-28','11:40:00',4.07),('9303','2013-06-28','11:45:00',4.01),('9303','2013-06-28','11:50:00',4.43),('9303','2013-06-28','11:55:00',2.24),('9303','2013-06-28','12:00:00',2.61),('9303','2013-06-28','12:05:00',2.39),('9303','2013-06-28','12:10:00',2.63),('9303','2013-06-28','12:15:00',4.47),('9303','2013-06-28','12:20:00',4.27),('9303','2013-06-28','12:25:00',4.34),('9303','2013-06-28','12:30:00',4.22),('9303','2013-06-28','12:35:00',4.23),('9303','2013-06-28','12:40:00',2),('9303','2013-06-28','12:45:00',3.75),('9303','2013-06-28','12:50:00',4.43),('9303','2013-06-28','12:55:00',4.31),('9303','2013-06-28','13:00:00',4.31),('9303','2013-06-28','13:05:00',4.27),('9303','2013-06-28','13:10:00',4),('9303','2013-06-28','13:15:00',4.4),('9303','2013-06-28','13:20:00',4.3),('9303','2013-06-28','13:25:00',4.22),('9303','2013-06-28','13:30:00',4.3),('9303','2013-06-28','13:35:00',4.31),('9303','2013-06-28','13:40:00',4.31),('9303','2013-06-28','13:45:00',4.35),('9303','2013-06-28','13:50:00',4.19),('9303','2013-06-28','13:55:00',4.46),('9303','2013-06-28','14:00:00',3.95),('9303','2013-06-28','14:05:00',3.98),('9303','2013-06-28','14:10:00',3.83),('9303','2013-06-28','14:15:00',3.93),('9303','2013-06-28','14:20:00',4.37),('9303','2013-06-28','14:25:00',3.53),('9303','2013-06-28','14:30:00',3.12),('9303','2013-06-28','14:35:00',3.41),('9303','2013-06-28','14:40:00',4.04),('9303','2013-06-28','14:45:00',3.53),('9303','2013-06-28','14:50:00',4.03),('9303','2013-06-28','14:55:00',4.12),('9303','2013-06-28','15:00:00',2.85),('9303','2013-06-28','15:05:00',3.92),('9303','2013-06-28','15:10:00',3.71),('9303','2013-06-28','15:15:00',3.93),('9303','2013-06-28','15:20:00',4.01),('9303','2013-06-28','15:25:00',3.85),('9303','2013-06-28','15:30:00',2.11),('9303','2013-06-28','15:35:00',2.09),('9303','2013-06-28','15:40:00',3.65),('9303','2013-06-28','15:45:00',2.22),('9303','2013-06-28','15:50:00',3.98),('9303','2013-06-28','15:55:00',3.59),('9303','2013-06-28','16:00:00',3.13),('9303','2013-06-28','16:05:00',3.79),('9303','2013-06-28','16:10:00',2),('9303','2013-06-28','16:15:00',3.63),('9303','2013-06-28','16:20:00',3.23),('9303','2013-06-28','16:25:00',2.26),('9303','2013-06-28','16:30:00',1.64),('9303','2013-06-28','16:35:00',2.05),('9303','2013-06-28','16:40:00',2.22),('9303','2013-06-28','16:50:00',1.21),('9303','2013-06-28','16:55:00',2.23),('9303','2013-06-28','17:00:00',2.06),('9303','2013-06-28','17:05:00',2.58),('9303','2013-06-28','17:10:00',2.45),('9303','2013-06-28','17:15:00',2.32),('9303','2013-06-28','17:20:00',2.18),('9303','2013-06-28','17:25:00',2.05),('9303','2013-06-28','17:30:00',1.59),('9303','2013-06-28','17:35:00',1.76),('9303','2013-06-28','17:40:00',1.82),('9303','2013-06-28','17:45:00',1.76),('9303','2013-06-28','17:50:00',1.7),('9303','2013-06-28','17:55:00',1.62),('9303','2013-06-28','18:00:00',1.54),('9303','2013-06-28','18:05:00',1.45),('9303','2013-06-28','18:10:00',1.32),('9303','2013-06-28','18:15:00',1.22),('9303','2013-06-28','18:20:00',1.15),('9303','2013-06-28','18:25:00',1.08),('9303','2013-06-27','07:45:00',1.04),('9303','2013-06-27','07:50:00',1.14),('9303','2013-06-27','07:55:00',1.23),('9303','2013-06-27','08:00:00',1.31),('9303','2013-06-27','08:05:00',1.39),('9303','2013-06-27','08:10:00',1.51),('9303','2013-06-27','08:15:00',1.58),('9303','2013-06-27','08:20:00',1.66),('9303','2013-06-27','08:25:00',1.74),('9303','2013-06-27','08:30:00',1.8),('9303','2013-06-27','08:35:00',1.85),('9303','2013-06-27','08:40:00',1.94),('9303','2013-06-27','08:45:00',2.03),('9303','2013-06-27','08:50:00',2.08),('9303','2013-06-27','08:55:00',2.19),('9303','2013-06-27','09:00:00',2.28),('9303','2013-06-27','09:05:00',2.37),('9303','2013-06-27','09:10:00',2.43),('9303','2013-06-27','09:15:00',2.51),('9303','2013-06-27','09:20:00',2.6),('9303','2013-06-27','09:25:00',2.65),('9303','2013-06-27','09:30:00',2.73),('9303','2013-06-27','09:35:00',2.78),('9303','2013-06-27','09:40:00',2.85),('9303','2013-06-27','09:45:00',2.89),('9303','2013-06-27','09:50:00',3.01),('9303','2013-06-27','09:55:00',3.06),('9303','2013-06-27','10:00:00',3.13),('9303','2013-06-27','10:05:00',3.31),('9303','2013-06-27','10:10:00',2.83),('9303','2013-06-27','10:15:00',2.38),('9303','2013-06-27','10:20:00',2.4),('9303','2013-06-27','10:25:00',3.39),('9303','2013-06-27','10:30:00',3.45),('9303','2013-06-27','10:35:00',3.56),('9303','2013-06-27','10:40:00',3.67),('9303','2013-06-27','10:45:00',3.81),('9303','2013-06-27','10:50:00',3.84),('9303','2013-06-27','10:55:00',3.82),('9303','2013-06-27','11:00:00',3.82),('9303','2013-06-27','11:05:00',3.91),('9303','2013-06-27','11:10:00',3.97),('9303','2013-06-27','11:15:00',3.92),('9303','2013-06-27','11:20:00',3.89),('9303','2013-06-27','11:25:00',3.92),('9303','2013-06-27','11:30:00',3.95),('9303','2013-06-27','11:35:00',4.03),('9303','2013-06-27','11:40:00',3.01),('9303','2013-06-27','11:45:00',3.61),('9303','2013-06-27','11:50:00',2.81),('9303','2013-06-27','11:55:00',1.41),('9303','2013-06-27','12:00:00',2.5),('9303','2013-06-27','12:05:00',1.22),('9303','2013-06-27','12:10:00',1.59),('9303','2013-06-27','12:15:00',1.03),('9303','2013-06-27','12:20:00',1.09),('9303','2013-06-27','12:25:00',1.77),('9303','2013-06-27','12:30:00',1.72),('9303','2013-06-27','12:35:00',2.41),('9303','2013-06-27','12:40:00',2.16),('9303','2013-06-27','12:45:00',1.39),('9303','2013-06-27','12:50:00',1.14),('9303','2013-06-27','12:55:00',1.04),('9303','2013-06-27','13:05:00',1.05),('9303','2013-06-27','13:10:00',1.39),('9303','2013-06-27','13:15:00',2.89),('9303','2013-06-27','13:20:00',2.82),('9303','2013-06-27','13:25:00',2.46),('9303','2013-06-27','13:30:00',2.05),('9303','2013-06-27','13:35:00',3.14),('9303','2013-06-27','13:40:00',1.22),('9303','2013-06-27','13:45:00',1.12),('9303','2013-06-27','13:50:00',1.25),('9303','2013-06-27','13:55:00',1.48),('9303','2013-06-27','14:00:00',1.34),('9303','2013-06-27','14:05:00',1.24),('9303','2013-06-27','14:10:00',1.46),('9303','2013-06-27','14:15:00',2.91),('9303','2013-06-27','14:20:00',1.67),('9303','2013-06-27','14:25:00',2.32),('9303','2013-06-27','14:30:00',4.4),('9303','2013-06-27','14:35:00',4.12),('9303','2013-06-27','14:40:00',4.03),('9303','2013-06-27','14:45:00',2.5),('9303','2013-06-27','14:50:00',3.28),('9303','2013-06-27','14:55:00',3.9),('9303','2013-06-27','15:00:00',3.77),('9303','2013-06-27','15:05:00',3.72),('9303','2013-06-27','15:10:00',3.68),('9303','2013-06-27','15:15:00',3.64),('9303','2013-06-27','15:20:00',3.58),('9303','2013-06-27','15:25:00',3.6),('9303','2013-06-27','15:30:00',3.58),('9303','2013-06-27','15:35:00',3.53),('9303','2013-06-27','15:40:00',3.47),('9303','2013-06-27','15:45:00',3.42),('9303','2013-06-27','15:50:00',3.36),('9303','2013-06-27','15:55:00',3.29),('9303','2013-06-27','16:00:00',3.19),('9303','2013-06-27','16:05:00',3.12),('9303','2013-06-27','16:10:00',3.1),('9303','2013-06-27','16:15:00',3.03),('9303','2013-06-27','16:20:00',2.99),('9303','2013-06-27','16:25:00',2.95),('9303','2013-06-27','16:30:00',2.91),('9303','2013-06-27','16:35:00',2.63),('9303','2013-06-27','16:40:00',2.7),('9303','2013-06-27','16:45:00',2.7),('9303','2013-06-27','16:50:00',2.62),('9303','2013-06-27','16:55:00',2.56),('9303','2013-06-27','17:00:00',2.5),('9303','2013-06-27','17:05:00',2.43),('9303','2013-06-27','17:10:00',2.3),('9303','2013-06-27','17:15:00',2.16),('9303','2013-06-27','17:20:00',2.14),('9303','2013-06-27','17:25:00',2.07),('9303','2013-06-27','17:30:00',1.94),('9303','2013-06-27','17:35:00',1.84),('9303','2013-06-27','17:40:00',1.02),('9303','2013-06-27','17:50:00',1.57),('9303','2013-06-27','17:55:00',1.55),('9303','2013-06-27','18:00:00',1.45),('9303','2013-06-27','18:05:00',1.36),('9303','2013-06-27','18:10:00',1.23),('9303','2013-06-27','18:15:00',1.11),('9303','2013-06-27','18:20:00',1.03),('9303','2013-06-27','18:25:00',1.01),('9303','2013-06-26','07:45:00',1.07),('9303','2013-06-26','07:50:00',1.17),('9303','2013-06-26','07:55:00',1.24),('9303','2013-06-26','08:00:00',1.3),('9303','2013-06-26','08:05:00',1.39),('9303','2013-06-26','08:10:00',1.49),('9303','2013-06-26','08:15:00',1.58),('9303','2013-06-26','08:20:00',1.64),('9303','2013-06-26','08:25:00',1.72),('9303','2013-06-26','08:30:00',1.8),('9303','2013-06-26','08:35:00',1.87),('9303','2013-06-26','08:40:00',1.93),('9303','2013-06-26','08:45:00',2),('9303','2013-06-26','08:50:00',2.07),('9303','2013-06-26','08:55:00',2.15),('9303','2013-06-26','09:00:00',2.21),('9303','2013-06-26','09:05:00',2.32),('9303','2013-06-26','09:10:00',2.38),('9303','2013-06-26','09:15:00',2.45),('9303','2013-06-26','09:20:00',2.51),('9303','2013-06-26','09:25:00',2.59),('9303','2013-06-26','09:30:00',2.66),('9303','2013-06-26','09:35:00',2.72),('9303','2013-06-26','09:40:00',2.8),('9303','2013-06-26','09:45:00',2.83),('9303','2013-06-26','09:50:00',2.88),('9303','2013-06-26','09:55:00',2.94),('9303','2013-06-26','10:00:00',3.03),('9303','2013-06-26','10:05:00',3.11),('9303','2013-06-26','10:10:00',3.14),('9303','2013-06-26','10:15:00',3.19),('9303','2013-06-26','10:20:00',3.24),('9303','2013-06-26','10:25:00',3.23),('9303','2013-06-26','10:30:00',3.29),('9303','2013-06-26','10:35:00',3.33),('9303','2013-06-26','10:40:00',3.42),('9303','2013-06-26','10:45:00',3.46),('9303','2013-06-26','10:50:00',3.5),('9303','2013-06-26','10:55:00',3.52),('9303','2013-06-26','11:00:00',3.59),('9303','2013-06-26','11:05:00',3.62),('9303','2013-06-26','11:10:00',3.64),('9303','2013-06-26','11:15:00',3.65),('9303','2013-06-26','11:20:00',3.67),('9303','2013-06-26','11:25:00',3.66),('9303','2013-06-26','11:30:00',3.66),('9303','2013-06-26','11:35:00',3.71),('9303','2013-06-26','11:40:00',3.78),('9303','2013-06-26','11:45:00',3.87),('9303','2013-06-26','11:50:00',3.9),('9303','2013-06-26','11:55:00',3.89),('9303','2013-06-26','12:00:00',3.91),('9303','2013-06-26','12:05:00',3.95),('9303','2013-06-26','12:10:00',3.98),('9303','2013-06-26','12:15:00',3.94),('9303','2013-06-26','12:20:00',3.83),('9303','2013-06-26','12:25:00',3.84),('9303','2013-06-26','12:30:00',3.92),('9303','2013-06-26','12:35:00',4.09),('9303','2013-06-26','12:40:00',4.07),('9303','2013-06-26','12:45:00',4.15),('9303','2013-06-26','12:50:00',2.29),('9303','2013-06-26','13:10:00',1.06),('9303','2013-06-26','13:15:00',2.78),('9303','2013-06-26','13:20:00',4.57),('9303','2013-06-26','13:25:00',4.52),('9303','2013-06-26','13:30:00',1.66),('9303','2013-06-26','13:45:00',1.1),('9303','2013-06-26','13:50:00',1.41),('9303','2013-06-26','13:55:00',1.52),('9303','2013-06-26','14:00:00',2.91),('9303','2013-06-26','14:10:00',1.6),('9303','2013-06-26','14:15:00',4.42),('9303','2013-06-26','14:20:00',4.17),('9303','2013-06-26','14:25:00',4.06),('9303','2013-06-26','14:30:00',4.16),('9303','2013-06-26','14:35:00',4.15),('9303','2013-06-26','14:40:00',2.08),('9303','2013-06-26','14:45:00',3.25),('9303','2013-06-26','14:50:00',4.21),('9303','2013-06-26','14:55:00',4.02),('9303','2013-06-26','15:00:00',3.76),('9303','2013-06-26','15:05:00',3.76),('9303','2013-06-26','15:10:00',3.69),('9303','2013-06-26','15:15:00',3.68),('9303','2013-06-26','15:20:00',3.64),('9303','2013-06-26','15:25:00',3.59),('9303','2013-06-26','15:30:00',3.56),('9303','2013-06-26','15:35:00',3.55),('9303','2013-06-26','15:40:00',3.48),('9303','2013-06-26','15:45:00',3.46),('9303','2013-06-26','15:50:00',3.45),('9303','2013-06-26','15:55:00',3.31),('9303','2013-06-26','16:00:00',3.27),('9303','2013-06-26','16:05:00',3.22),('9303','2013-06-26','16:10:00',3.18),('9303','2013-06-26','16:15:00',3.13),('9303','2013-06-26','16:20:00',3.08),('9303','2013-06-26','16:25:00',3),('9303','2013-06-26','16:30:00',2.93),('9303','2013-06-26','16:35:00',2.86),('9303','2013-06-26','16:40:00',2.77),('9303','2013-06-26','16:45:00',2.72),('9303','2013-06-26','16:50:00',2.66),('9303','2013-06-26','16:55:00',2.6),('9303','2013-06-26','17:00:00',2.55),('9303','2013-06-26','17:05:00',2.48),('9303','2013-06-26','17:10:00',2.43),('9303','2013-06-26','17:15:00',2.3),('9303','2013-06-26','17:20:00',2.19),('9303','2013-06-26','17:25:00',2.06),('9303','2013-06-26','17:30:00',1.91),('9303','2013-06-26','17:35:00',1.72),('9303','2013-06-26','17:40:00',1.79),('9303','2013-06-26','17:45:00',1.73),('9303','2013-06-26','17:50:00',1.66),('9303','2013-06-26','17:55:00',1.58),('9303','2013-06-26','18:00:00',1.5),('9303','2013-06-26','18:05:00',1.51),('9303','2013-06-26','18:10:00',1.63),('9303','2013-06-26','18:15:00',1.04),('9303','2013-06-25','07:45:00',1.09),('9303','2013-06-25','08:05:00',1.45),('9303','2013-06-25','08:20:00',1.69),('9303','2013-06-25','08:30:00',1.53),('9303','2013-06-25','08:35:00',1.92),('9303','2013-06-25','08:40:00',1.98),('9303','2013-06-25','08:45:00',2.06),('9303','2013-06-25','08:50:00',2.14),('9303','2013-06-25','08:55:00',2.2),('9303','2013-06-25','09:00:00',2.3),('9303','2013-06-25','09:05:00',2.38),('9303','2013-06-25','09:10:00',2.43),('9303','2013-06-25','09:15:00',2.51),('9303','2013-06-25','09:20:00',2.63),('9303','2013-06-25','09:25:00',2.74),('9303','2013-06-25','09:30:00',2.77),('9303','2013-06-25','09:35:00',2.76),('9303','2013-06-25','09:40:00',2.28),('9303','2013-06-25','09:45:00',2.51),('9303','2013-06-25','09:50:00',3.26),('9303','2013-06-25','09:55:00',2.19),('9303','2013-06-25','10:00:00',3.22),('9303','2013-06-25','10:05:00',3.57),('9303','2013-06-25','10:10:00',3.28),('9303','2013-06-25','10:15:00',3.66),('9303','2013-06-25','10:20:00',3.65),('9303','2013-06-25','10:25:00',3.7),('9303','2013-06-25','10:30:00',3.71),('9303','2013-06-25','10:35:00',3.69),('9303','2013-06-25','10:40:00',3.77),('9303','2013-06-25','10:45:00',3.77),('9303','2013-06-25','10:50:00',3.64),('9303','2013-06-25','10:55:00',1.62),('9303','2013-06-25','11:10:00',1.52),('9303','2013-06-25','11:20:00',1.06),('9303','2013-06-25','11:25:00',1.03),('9303','2013-06-25','11:30:00',1.07),('9303','2013-06-25','11:35:00',2.52),('9303','2013-06-25','11:40:00',3.05),('9303','2013-06-25','11:45:00',3.97),('9303','2013-06-25','11:50:00',2.99),('9303','2013-06-25','11:55:00',3.62),('9303','2013-06-25','12:00:00',4.67),('9303','2013-06-25','12:05:00',1.91),('9303','2013-06-25','12:10:00',1.61),('9303','2013-06-25','12:15:00',1.43),('9303','2013-06-25','12:20:00',1.89),('9303','2013-06-25','12:25:00',1.02),('9303','2013-06-25','12:35:00',1),('9303','2013-06-25','12:40:00',1.31),('9303','2013-06-25','12:45:00',2.72),('9303','2013-06-25','12:50:00',1.16),('9303','2013-06-25','12:55:00',1.89),('9303','2013-06-25','13:00:00',4.56),('9303','2013-06-25','13:05:00',4.43),('9303','2013-06-25','13:10:00',4.49),('9303','2013-06-25','13:15:00',4.41),('9303','2013-06-25','13:20:00',4.31),('9303','2013-06-25','13:25:00',4.29),('9303','2013-06-25','13:30:00',4.38),('9303','2013-06-25','13:35:00',4.24),('9303','2013-06-25','13:40:00',4.01),('9303','2013-06-25','13:45:00',4.48),('9303','2013-06-25','13:50:00',4.08),('9303','2013-06-25','13:55:00',3.23),('9303','2013-06-25','14:00:00',3.47),('9303','2013-06-25','14:05:00',4.28),('9303','2013-06-25','14:10:00',4.31),('9303','2013-06-25','14:15:00',2.94),('9303','2013-06-25','14:20:00',3.69),('9303','2013-06-25','14:25:00',4.12),('9303','2013-06-25','14:30:00',4.04),('9303','2013-06-25','14:35:00',3.99),('9303','2013-06-25','14:40:00',4),('9303','2013-06-25','14:45:00',4.01),('9303','2013-06-25','14:50:00',3.97),('9303','2013-06-25','14:55:00',3.88),('9303','2013-06-25','15:00:00',3.85),('9303','2013-06-25','15:05:00',3.8),('9303','2013-06-25','15:10:00',3.76),('9303','2013-06-25','15:15:00',3.74),('9303','2013-06-25','15:20:00',3.68),('9303','2013-06-25','15:25:00',3.62),('9303','2013-06-25','15:30:00',3.56),('9303','2013-06-25','15:35:00',3.49),('9303','2013-06-25','15:40:00',3.44),('9303','2013-06-25','15:45:00',3.41),('9303','2013-06-25','15:50:00',3.34),('9303','2013-06-25','15:55:00',3.29),('9303','2013-06-25','16:00:00',3.26),('9303','2013-06-25','16:05:00',3.22),('9303','2013-06-25','16:10:00',3.15),('9303','2013-06-25','16:15:00',3.07),('9303','2013-06-25','16:20:00',3.03),('9303','2013-06-25','16:25:00',2.97),('9303','2013-06-25','16:30:00',2.9),('9303','2013-06-25','16:35:00',2.83),('9303','2013-06-25','16:40:00',2.77),('9303','2013-06-25','16:45:00',2.72),('9303','2013-06-25','16:50:00',2.66),('9303','2013-06-25','16:55:00',2.58),('9303','2013-06-25','17:00:00',2.51),('9303','2013-06-25','17:05:00',2.46),('9303','2013-06-25','17:10:00',2.37),('9303','2013-06-25','17:15:00',2.27),('9303','2013-06-25','17:20:00',2.18),('9303','2013-06-25','17:25:00',2.04),('9303','2013-06-25','17:30:00',1.88),('9303','2013-06-25','17:35:00',1.8),('9303','2013-06-25','17:40:00',1.79),('9303','2013-06-25','17:45:00',1.7),('9303','2013-06-25','17:50:00',1.63),('9303','2013-06-25','17:55:00',1.57),('9303','2013-06-25','18:00:00',1.48),('9303','2013-06-25','18:05:00',1.38),('9303','2013-06-25','18:10:00',1.25),('9303','2013-06-25','18:15:00',1.16),('9303','2013-06-25','18:20:00',1.12),('9303','2013-06-25','18:25:00',1.03),('9303','2013-06-24','08:45:00',1.97),('9303','2013-06-24','08:50:00',2.27),('9303','2013-06-24','08:55:00',2.39),('9303','2013-06-24','09:00:00',1.79),('9303','2013-06-24','09:05:00',2.14),('9303','2013-06-24','09:10:00',1.12),('9303','2013-06-24','09:15:00',2.16),('9303','2013-06-24','09:20:00',2.66),('9303','2013-06-24','09:25:00',2.84),('9303','2013-06-24','09:30:00',2.47),('9303','2013-06-24','09:40:00',2.74),('9303','2013-06-24','09:45:00',2.74),('9303','2013-06-24','09:50:00',2.31),('9303','2013-06-24','09:55:00',3.16),('9303','2013-06-24','10:00:00',3.23),('9303','2013-06-24','10:05:00',3.28),('9303','2013-06-24','10:10:00',3.44),('9303','2013-06-24','10:15:00',3.71),('9303','2013-06-24','10:20:00',2.86),('9303','2013-06-24','10:25:00',3.81),('9303','2013-06-24','10:30:00',1.77),('9303','2013-06-24','10:35:00',2.92),('9303','2013-06-24','10:40:00',1.73),('9303','2013-06-24','10:45:00',2.12),('9303','2013-06-24','10:50:00',3.77),('9303','2013-06-24','10:55:00',2.77),('9303','2013-06-24','11:00:00',4.26),('9303','2013-06-24','11:05:00',3.38),('9303','2013-06-24','11:10:00',3.16),('9303','2013-06-24','11:15:00',2.47),('9303','2013-06-24','11:20:00',3.28),('9303','2013-06-24','11:25:00',1.33),('9303','2013-06-24','11:30:00',1.74),('9303','2013-06-24','11:35:00',1.23),('9303','2013-06-24','11:40:00',1.26),('9303','2013-06-24','11:45:00',1.65),('9303','2013-06-24','11:50:00',2.27),('9303','2013-06-24','11:55:00',4.06),('9303','2013-06-24','12:00:00',3.05),('9303','2013-06-24','12:05:00',3.99),('9303','2013-06-24','12:10:00',4.19),('9303','2013-06-24','12:15:00',3.35),('9303','2013-06-24','12:20:00',3.71),('9303','2013-06-24','12:25:00',2.64),('9303','2013-06-24','12:30:00',2.71),('9303','2013-06-24','12:35:00',4.78),('9303','2013-06-24','12:40:00',4.7),('9303','2013-06-24','12:45:00',2.48),('9303','2013-06-24','12:50:00',4.82),('9303','2013-06-24','12:55:00',4.81),('9303','2013-06-24','13:00:00',4.7),('9303','2013-06-24','13:05:00',4.9),('9303','2013-06-24','13:10:00',3.66),('9303','2013-06-24','13:15:00',3.09),('9303','2013-06-24','13:20:00',3),('9303','2013-06-24','13:25:00',3.84),('9303','2013-06-24','13:30:00',4.19),('9303','2013-06-24','13:35:00',3.9),('9303','2013-06-24','13:40:00',4.33),('9303','2013-06-24','13:45:00',4.47),('9303','2013-06-24','13:50:00',4.35),('9303','2013-06-24','13:55:00',4.28),('9303','2013-06-24','14:00:00',4.28),('9303','2013-06-24','14:05:00',4.29),('9303','2013-06-24','14:10:00',4.24),('9303','2013-06-24','14:15:00',4.23),('9303','2013-06-24','14:20:00',4.22),('9303','2013-06-24','14:25:00',4.22),('9303','2013-06-24','14:30:00',4.19),('9303','2013-06-24','14:35:00',4.15),('9303','2013-06-24','14:40:00',4.16),('9303','2013-06-24','14:45:00',4.13),('9303','2013-06-24','14:50:00',4.14),('9303','2013-06-24','14:55:00',4.22),('9303','2013-06-24','15:00:00',4.35),('9303','2013-06-24','15:05:00',2.7),('9303','2013-06-24','15:10:00',1.77),('9303','2013-06-24','15:15:00',4.21),('9303','2013-06-24','15:20:00',4.02),('9303','2013-06-24','15:25:00',3.77),('9303','2013-06-24','15:30:00',2.96),('9303','2013-06-24','15:35:00',2.88),('9303','2013-06-24','15:40:00',2.31),('9303','2013-06-24','15:45:00',3.29),('9303','2013-06-24','15:50:00',2.62),('9303','2013-06-24','15:55:00',3.03),('9303','2013-06-24','16:00:00',3.42),('9303','2013-06-24','16:05:00',3.53),('9303','2013-06-24','16:10:00',3.64),('9303','2013-06-24','16:15:00',3.68),('9303','2013-06-24','16:20:00',2.53),('9303','2013-06-24','16:25:00',2.59),('9303','2013-06-24','16:30:00',2.93),('9303','2013-06-24','16:35:00',2.68),('9303','2013-06-24','16:40:00',2.09),('9303','2013-06-24','16:45:00',2.35),('9303','2013-06-24','16:50:00',1.88),('9303','2013-06-24','16:55:00',1.11),('9303','2013-06-24','17:00:00',1.51),('9303','2013-06-24','17:05:00',2.01),('9303','2013-06-24','17:10:00',2.23),('9303','2013-06-24','17:15:00',2.64),('9303','2013-06-24','17:20:00',2.31),('9303','2013-06-24','17:25:00',1.5),('9303','2013-06-24','17:30:00',1.96),('9303','2013-06-24','17:50:00',1.73),('9303','2013-06-24','18:00:00',1.78),('9303','2013-06-24','18:05:00',1.61),('9303','2013-06-24','18:10:00',1.05),('9303','2013-06-24','18:15:00',1.38),('9303','2013-06-24','18:20:00',1.33),('9303','2013-06-24','18:25:00',1.18),('9303','2013-06-24','18:35:00',1.04),('9303','2013-06-23','08:50:00',1.34),('9303','2013-06-23','09:00:00',1.53),('9303','2013-06-23','09:05:00',1.36),('9303','2013-06-23','09:20:00',1.41),('9303','2013-06-23','09:25:00',2.45),('9303','2013-06-23','09:30:00',2.77),('9303','2013-06-23','09:35:00',2.81),('9303','2013-06-23','09:40:00',3.22),('9303','2013-06-23','09:45:00',2),('9303','2013-06-23','09:50:00',1.06),('9303','2013-06-23','09:55:00',1.57),('9303','2013-06-23','10:00:00',2.97),('9303','2013-06-23','10:05:00',2.92),('9303','2013-06-23','10:10:00',1.47),('9303','2013-06-23','10:15:00',1.75),('9303','2013-06-23','10:20:00',1.66),('9303','2013-06-23','10:35:00',1.01),('9303','2013-06-23','10:40:00',2.3),('9303','2013-06-23','10:45:00',3.54),('9303','2013-06-23','10:50:00',3.57),('9303','2013-06-23','10:55:00',3.44),('9303','2013-06-23','11:00:00',3.27),('9303','2013-06-23','11:05:00',3.47),('9303','2013-06-23','11:10:00',3.6),('9303','2013-06-23','11:15:00',3.66),('9303','2013-06-23','11:20:00',3.64),('9303','2013-06-23','11:25:00',3.69),('9303','2013-06-23','11:30:00',3.7),('9303','2013-06-23','11:35:00',3.7),('9303','2013-06-23','11:40:00',3.72),('9303','2013-06-23','11:45:00',3.74),('9303','2013-06-23','11:50:00',3.87),('9303','2013-06-23','11:55:00',3.85),('9303','2013-06-23','12:00:00',2.76),('9303','2013-06-23','12:05:00',3.43),('9303','2013-06-23','12:10:00',4.06),('9303','2013-06-23','12:15:00',4.05),('9303','2013-06-23','12:20:00',4.05),('9303','2013-06-23','12:25:00',3.54),('9303','2013-06-23','12:30:00',4.09),('9303','2013-06-23','12:35:00',4.07),('9303','2013-06-23','12:40:00',4.09),('9303','2013-06-23','12:45:00',4.07),('9303','2013-06-23','12:50:00',4.08),('9303','2013-06-23','12:55:00',4.11),('9303','2013-06-23','13:00:00',4.14),('9303','2013-06-23','13:05:00',4.14),('9303','2013-06-23','13:10:00',4.12),('9303','2013-06-23','13:15:00',4.12),('9303','2013-06-23','13:20:00',4.09),('9303','2013-06-23','13:25:00',4.12),('9303','2013-06-23','13:30:00',4.11),('9303','2013-06-23','13:35:00',4.12),('9303','2013-06-23','13:40:00',4.12),('9303','2013-06-23','13:45:00',4.13),('9303','2013-06-23','13:50:00',4.11),('9303','2013-06-23','13:55:00',4.1),('9303','2013-06-23','14:00:00',4.09),('9303','2013-06-23','14:05:00',4.09),('9303','2013-06-23','14:10:00',4.05),('9303','2013-06-23','14:15:00',4.01),('9303','2013-06-23','14:20:00',4.01),('9303','2013-06-23','14:25:00',4.03),('9303','2013-06-23','14:30:00',4),('9303','2013-06-23','14:35:00',3.98),('9303','2013-06-23','14:40:00',3.96),('9303','2013-06-23','14:45:00',3.94),('9303','2013-06-23','14:50:00',3.91),('9303','2013-06-23','14:55:00',3.89),('9303','2013-06-23','15:00:00',3.88),('9303','2013-06-23','15:05:00',3.85),('9303','2013-06-23','15:10:00',3.81),('9303','2013-06-23','15:15:00',3.77),('9303','2013-06-23','15:20:00',3.73),('9303','2013-06-23','15:25:00',3.69),('9303','2013-06-23','15:30:00',3.6),('9303','2013-06-23','15:35:00',3.55),('9303','2013-06-23','15:40:00',3.51),('9303','2013-06-23','15:45:00',3.51),('9303','2013-06-23','15:50:00',3.46),('9303','2013-06-23','15:55:00',3.37),('9303','2013-06-23','16:00:00',3.3),('9303','2013-06-23','16:05:00',3.28),('9303','2013-06-23','16:10:00',3.19),('9303','2013-06-23','16:15:00',3.11),('9303','2013-06-23','16:20:00',3.05),('9303','2013-06-23','16:25:00',3),('9303','2013-06-23','16:30:00',2.96),('9303','2013-06-23','16:35:00',2.89),('9303','2013-06-23','16:40:00',2.86),('9303','2013-06-23','16:45:00',2.76),('9303','2013-06-23','16:50:00',2.71),('9303','2013-06-23','16:55:00',2.63),('9303','2013-06-23','17:00:00',2.57),('9303','2013-06-23','17:05:00',2.51),('9303','2013-06-23','17:10:00',2.45),('9303','2013-06-23','17:15:00',2.32),('9303','2013-06-23','17:20:00',2.06),('9303','2013-06-23','17:25:00',1.77),('9303','2013-06-23','17:30:00',1.91),('9303','2013-06-23','17:35:00',1.89),('9303','2013-06-23','17:40:00',1.84),('9303','2013-06-23','17:45:00',1.53),('9303','2013-06-23','17:50:00',1.73),('9303','2013-06-23','17:55:00',1.64),('9303','2013-06-23','18:00:00',1.53),('9303','2013-06-23','18:05:00',1.42),('9303','2013-06-23','18:10:00',1.32),('9303','2013-06-23','18:15:00',1.21),('9303','2013-06-23','18:20:00',1.12),('9303','2013-06-22','07:50:00',1.05),('9303','2013-06-22','07:55:00',1.12),('9303','2013-06-22','08:00:00',1.2),('9303','2013-06-22','08:05:00',1.27),('9303','2013-06-22','08:10:00',1.36),('9303','2013-06-22','08:15:00',1.43),('9303','2013-06-22','08:20:00',1.52),('9303','2013-06-22','08:25:00',1.61),('9303','2013-06-22','08:30:00',1.69),('9303','2013-06-22','08:35:00',1.78),('9303','2013-06-22','08:40:00',1.86),('9303','2013-06-22','08:45:00',1.92),('9303','2013-06-22','08:50:00',1.97),('9303','2013-06-22','08:55:00',2.06),('9303','2013-06-22','09:00:00',2.13),('9303','2013-06-22','09:05:00',2.21),('9303','2013-06-22','09:10:00',2.29),('9303','2013-06-22','09:15:00',2.36),('9303','2013-06-22','09:20:00',2.42),('9303','2013-06-22','09:25:00',2.46),('9303','2013-06-22','09:30:00',2.53),('9303','2013-06-22','09:35:00',2.6),('9303','2013-06-22','09:40:00',2.66),('9303','2013-06-22','09:45:00',2.7),('9303','2013-06-22','09:50:00',2.76),('9303','2013-06-22','09:55:00',2.82),('9303','2013-06-22','10:00:00',2.9),('9303','2013-06-22','10:05:00',2.97),('9303','2013-06-22','10:10:00',3.02),('9303','2013-06-22','10:15:00',3.07),('9303','2013-06-22','10:20:00',3.14),('9303','2013-06-22','10:25:00',3.18),('9303','2013-06-22','10:30:00',3.2),('9303','2013-06-22','10:35:00',3.24),('9303','2013-06-22','10:40:00',3.33),('9303','2013-06-22','10:45:00',3.4),('9303','2013-06-22','10:50:00',3.41),('9303','2013-06-22','10:55:00',3.45),('9303','2013-06-22','11:00:00',3.48),('9303','2013-06-22','11:05:00',3.52),('9303','2013-06-22','11:10:00',3.56),('9303','2013-06-22','11:15:00',3.61),('9303','2013-06-22','11:20:00',3.63),('9303','2013-06-22','11:25:00',3.65),('9303','2013-06-22','11:30:00',3.68),('9303','2013-06-22','11:35:00',3.7),('9303','2013-06-22','11:40:00',3.72),('9303','2013-06-22','11:45:00',3.73),('9303','2013-06-22','11:50:00',3.72),('9303','2013-06-22','11:55:00',3.75),('9303','2013-06-22','12:00:00',3.8),('9303','2013-06-22','12:05:00',3.75),('9303','2013-06-22','12:10:00',3.69),('9303','2013-06-22','12:15:00',3.86),('9303','2013-06-22','12:20:00',3.84),('9303','2013-06-22','12:25:00',3.79),('9303','2013-06-22','12:30:00',3.87),('9303','2013-06-22','12:35:00',3.89),('9303','2013-06-22','12:40:00',3.91),('9303','2013-06-22','12:45:00',3.86),('9303','2013-06-22','12:50:00',3.8),('9303','2013-06-22','12:55:00',3.8),('9303','2013-06-22','13:00:00',3.75),('9303','2013-06-22','13:05:00',3.78),('9303','2013-06-22','13:10:00',3.75),('9303','2013-06-22','13:15:00',3.73),('9303','2013-06-22','13:20:00',3.62),('9303','2013-06-22','13:25:00',3.83),('9303','2013-06-22','13:30:00',4.09),('9303','2013-06-22','13:35:00',4.12),('9303','2013-06-22','13:40:00',3.74),('9303','2013-06-22','13:45:00',3.86),('9303','2013-06-22','13:50:00',4.08),('9303','2013-06-22','13:55:00',3.08),('9303','2013-06-22','14:00:00',2.21),('9303','2013-06-22','14:05:00',4.36),('9303','2013-06-22','14:10:00',4.18),('9303','2013-06-22','14:15:00',4.1),('9303','2013-06-22','14:20:00',3.31),('9303','2013-06-22','14:25:00',4.07),('9303','2013-06-22','14:30:00',2.81),('9303','2013-06-22','14:35:00',2.23),('9303','2013-06-22','14:40:00',1.64),('9303','2013-06-22','14:45:00',1.98),('9303','2013-06-22','14:50:00',3.1),('9303','2013-06-22','14:55:00',3.84),('9303','2013-06-22','15:00:00',3.67),('9303','2013-06-22','15:05:00',3.16),('9303','2013-06-22','15:10:00',3.51),('9303','2013-06-22','15:15:00',3.86),('9303','2013-06-22','15:20:00',3.53),('9303','2013-06-22','15:25:00',3.33),('9303','2013-06-22','15:30:00',2.28),('9303','2013-06-22','15:35:00',1.96),('9303','2013-06-22','15:40:00',2.04),('9303','2013-06-22','15:45:00',2.6),('9303','2013-06-22','15:50:00',2.44),('9303','2013-06-22','15:55:00',2.33),('9303','2013-06-22','16:00:00',1.86),('9303','2013-06-22','16:05:00',1.17),('9303','2013-06-22','16:10:00',1.13),('9303','2013-06-22','16:15:00',1.41),('9303','2013-06-22','16:20:00',1.74),('9303','2013-06-22','16:25:00',1.22),('9303','2013-06-22','16:55:00',1.04),('9303','2013-06-22','17:00:00',1.38),('9303','2013-06-22','17:05:00',1.32),('9303','2013-06-22','17:10:00',1.7),('9303','2013-06-22','17:15:00',2.57),('9303','2013-06-22','17:20:00',2.45),('9303','2013-06-22','17:25:00',2.32),('9303','2013-06-22','17:30:00',2.01),('9303','2013-06-22','17:35:00',1.52),('9303','2013-06-22','17:40:00',1.82),('9303','2013-06-22','17:45:00',1.82),('9303','2013-06-22','17:50:00',1.66),('9303','2013-06-22','17:55:00',1.63),('9303','2013-06-22','18:00:00',1.5),('9303','2013-06-22','18:05:00',1.21),('9303','2013-06-21','07:50:00',1.06),('9303','2013-06-21','07:55:00',1.14),('9303','2013-06-21','08:00:00',1.21),('9303','2013-06-21','08:05:00',1.28),('9303','2013-06-21','08:10:00',1.38),('9303','2013-06-21','08:15:00',1.45),('9303','2013-06-21','08:20:00',1.52),('9303','2013-06-21','08:25:00',1.59),('9303','2013-06-21','08:30:00',1.67),('9303','2013-06-21','08:35:00',1.76),('9303','2013-06-21','08:40:00',1.83),('9303','2013-06-21','08:45:00',1.88),('9303','2013-06-21','08:50:00',1.94),('9303','2013-06-21','08:55:00',2.01),('9303','2013-06-21','09:00:00',2.07),('9303','2013-06-21','09:05:00',2.17),('9303','2013-06-21','09:10:00',2.23),('9303','2013-06-21','09:15:00',2.26),('9303','2013-06-21','09:20:00',2.32),('9303','2013-06-21','09:25:00',2.4),('9303','2013-06-21','09:30:00',2.44),('9303','2013-06-21','09:35:00',2.51),('9303','2013-06-21','09:40:00',2.53),('9303','2013-06-21','09:45:00',2.57),('9303','2013-06-21','09:50:00',2.63),('9303','2013-06-21','09:55:00',2.68),('9303','2013-06-21','10:00:00',2.68),('9303','2013-06-21','10:05:00',2.75),('9303','2013-06-21','10:10:00',2.8),('9303','2013-06-21','10:15:00',2.86),('9303','2013-06-21','10:20:00',2.95),('9303','2013-06-21','10:25:00',2.97),('9303','2013-06-21','10:30:00',3),('9303','2013-06-21','10:35:00',2.98),('9303','2013-06-21','10:40:00',3.02),('9303','2013-06-21','10:45:00',3.07),('9303','2013-06-21','10:50:00',3.15),('9303','2013-06-21','10:55:00',3.22),('9303','2013-06-21','11:00:00',3.22),('9303','2013-06-21','11:05:00',3.24),('9303','2013-06-21','11:10:00',3.24),('9303','2013-06-21','11:15:00',3.29),('9303','2013-06-21','11:20:00',3.37),('9303','2013-06-21','11:25:00',3.43),('9303','2013-06-21','11:30:00',3.44),('9303','2013-06-21','11:35:00',3.45),('9303','2013-06-21','11:40:00',3.5),('9303','2013-06-21','11:45:00',3.49),('9303','2013-06-21','11:50:00',3.54),('9303','2013-06-21','11:55:00',3.6),('9303','2013-06-21','12:00:00',3.61),('9303','2013-06-21','12:05:00',3.6),('9303','2013-06-21','12:10:00',3.59),('9303','2013-06-21','12:15:00',3.61),('9303','2013-06-21','12:20:00',3.57),('9303','2013-06-21','12:25:00',3.64),('9303','2013-06-21','12:30:00',3.65),('9303','2013-06-21','12:35:00',3.6),('9303','2013-06-21','12:40:00',3.58),('9303','2013-06-21','12:45:00',3.63),('9303','2013-06-21','12:50:00',3.59),('9303','2013-06-21','12:55:00',3.61),('9303','2013-06-21','13:00:00',3.61),('9303','2013-06-21','13:05:00',3.54),('9303','2013-06-21','13:10:00',3.61),('9303','2013-06-21','13:15:00',3.62),('9303','2013-06-21','13:20:00',3.62),('9303','2013-06-21','13:25:00',3.7),('9303','2013-06-21','13:30:00',3.71),('9303','2013-06-21','13:35:00',3.74),('9303','2013-06-21','13:40:00',3.7),('9303','2013-06-21','13:45:00',3.68),('9303','2013-06-21','13:50:00',3.73),('9303','2013-06-21','13:55:00',3.71),('9303','2013-06-21','14:00:00',3.69),('9303','2013-06-21','14:05:00',3.73),('9303','2013-06-21','14:10:00',3.75),('9303','2013-06-21','14:15:00',3.74),('9303','2013-06-21','14:20:00',3.74),('9303','2013-06-21','14:25:00',3.75),('9303','2013-06-21','14:30:00',3.75),('9303','2013-06-21','14:35:00',3.72),('9303','2013-06-21','14:40:00',3.7),('9303','2013-06-21','14:45:00',3.7),('9303','2013-06-21','14:50:00',3.67),('9303','2013-06-21','14:55:00',3.66),('9303','2013-06-21','15:00:00',3.63),('9303','2013-06-21','15:05:00',3.57),('9303','2013-06-21','15:10:00',3.52),('9303','2013-06-21','15:15:00',3.5),('9303','2013-06-21','15:20:00',3.47),('9303','2013-06-21','15:25:00',3.41),('9303','2013-06-21','15:30:00',3.4),('9303','2013-06-21','15:35:00',3.34),('9303','2013-06-21','15:40:00',3.3),('9303','2013-06-21','15:45:00',3.26),('9303','2013-06-21','15:50:00',3.21),('9303','2013-06-21','15:55:00',3.16),('9303','2013-06-21','16:00:00',3.11),('9303','2013-06-21','16:05:00',3.07),('9303','2013-06-21','16:10:00',3.02),('9303','2013-06-21','16:15:00',2.97),('9303','2013-06-21','16:20:00',2.91),('9303','2013-06-21','16:25:00',2.86),('9303','2013-06-21','16:30:00',2.8),('9303','2013-06-21','16:35:00',2.74),('9303','2013-06-21','16:40:00',2.67),('9303','2013-06-21','16:45:00',2.63),('9303','2013-06-21','16:50:00',2.56),('9303','2013-06-21','16:55:00',2.49),('9303','2013-06-21','17:00:00',2.42),('9303','2013-06-21','17:05:00',2.36),('9303','2013-06-21','17:10:00',2.3),('9303','2013-06-21','17:15:00',2.2),('9303','2013-06-21','17:20:00',2.09),('9303','2013-06-21','17:25:00',1.97),('9303','2013-06-21','17:30:00',1.8),('9303','2013-06-21','17:35:00',1.76),('9303','2013-06-21','17:40:00',1.74),('9303','2013-06-21','17:45:00',1.66),('9303','2013-06-21','17:50:00',1.59),('9303','2013-06-21','17:55:00',1.5),('9303','2013-06-21','18:00:00',1.41),('9303','2013-06-21','18:05:00',1.33),('9303','2013-06-21','18:10:00',1.25),('9303','2013-06-21','18:15:00',1.17),('9303','2013-06-21','18:20:00',1.08),('9303','2014-04-04','09:05:00',1.08),('9303','2014-04-04','09:10:00',1.41),('9303','2014-04-04','09:15:00',1.26),('9303','2014-04-04','13:20:00',1.61),('9303','2014-04-04','13:25:00',2.34),('9303','2014-04-04','13:30:00',1.81),('9303','2014-04-04','13:35:00',2.42),('9303','2014-04-04','13:40:00',2.64),('9303','2014-04-04','13:45:00',2.96),('9303','2014-04-04','13:50:00',3.18),('9303','2014-04-04','13:55:00',2.52),('9303','2014-04-04','14:00:00',1.99),('9303','2014-04-04','14:05:00',4.5),('9303','2014-04-04','14:10:00',3.46),('9303','2014-04-04','14:15:00',3.71),('9303','2014-04-04','14:20:00',3),('9303','2014-04-04','14:25:00',3.38),('9303','2014-04-04','14:30:00',1.19),('9303','2014-04-04','14:35:00',2.34),('9303','2014-04-04','14:40:00',1.96),('9303','2014-04-04','14:45:00',1.31),('9303','2014-04-04','14:50:00',2.59),('9303','2014-04-04','14:55:00',3.3),('9303','2014-04-04','15:00:00',4.02),('9303','2014-04-04','15:05:00',4.01),('9303','2014-04-04','15:10:00',3.69),('9303','2014-04-04','15:15:00',3.29),('9303','2014-04-04','15:20:00',2.35),('9303','2014-04-04','15:25:00',1.9),('9303','2014-04-04','15:30:00',1.31),('9303','2014-04-04','15:35:00',1.83),('9303','2014-04-04','15:40:00',2.06),('9303','2014-04-04','15:45:00',2.13),('9303','2014-04-04','15:50:00',1.67),('9303','2014-04-04','15:55:00',2.71),('9303','2014-04-04','16:00:00',3.14),('9303','2014-04-04','16:05:00',2.37),('9303','2014-04-04','16:10:00',3.25),('9303','2014-04-04','16:15:00',1.48),('9303','2014-04-04','16:20:00',1.04),('9303','2014-04-04','16:30:00',1.87),('9303','2014-04-04','16:35:00',1.49),('9303','2014-04-04','16:40:00',1.23),('9303','2014-04-04','16:45:00',2.47),('9303','2014-04-04','16:50:00',2.95),('9303','2014-04-04','16:55:00',1.81),('9303','2014-04-04','17:00:00',1.82),('9303','2014-04-04','17:05:00',1.87),('9303','2014-04-04','17:10:00',1.9),('9303','2014-04-04','17:15:00',1.83),('9303','2014-04-04','17:20:00',1.67),('9303','2014-04-04','17:25:00',1.78),('9303','2014-04-04','17:30:00',1.95),('9303','2014-04-04','17:35:00',1.76),('9303','2014-04-04','17:40:00',1.24),('9303','2014-04-04','17:45:00',1.4),('9303','2014-04-04','17:50:00',1.34),('9303','2014-04-04','17:55:00',1.16),('9303','2014-04-04','18:00:00',1.01),('9303','2013-06-20','07:55:00',1.07),('9303','2013-06-20','08:00:00',1.16),('9303','2013-06-20','08:05:00',1.25),('9303','2013-06-20','08:10:00',1.36),('9303','2013-06-20','08:15:00',1.45),('9303','2013-06-20','08:20:00',1.54),('9303','2013-06-20','08:25:00',1.6),('9303','2013-06-20','08:30:00',1.68),('9303','2013-06-20','08:35:00',1.77),('9303','2013-06-20','08:40:00',1.84),('9303','2013-06-20','08:45:00',1.91),('9303','2013-06-20','08:50:00',1.98),('9303','2013-06-20','08:55:00',2.04),('9303','2013-06-20','09:00:00',2.1),('9303','2013-06-20','09:05:00',2.2),('9303','2013-06-20','09:10:00',2.27),('9303','2013-06-20','09:15:00',2.33),('9303','2013-06-20','09:20:00',2.39),('9303','2013-06-20','09:25:00',2.46),('9303','2013-06-20','09:30:00',2.52),('9303','2013-06-20','09:35:00',2.59),('9303','2013-06-20','09:40:00',2.63),('9303','2013-06-20','09:45:00',2.68),('9303','2013-06-20','09:50:00',2.74),('9303','2013-06-20','09:55:00',2.79),('9303','2013-06-20','10:00:00',2.86),('9303','2013-06-20','10:05:00',2.89),('9303','2013-06-20','10:10:00',2.96),('9303','2013-06-20','10:15:00',3.01),('9303','2013-06-20','10:20:00',3.06),('9303','2013-06-20','10:25:00',3.11),('9303','2013-06-20','10:30:00',3.16),('9303','2013-06-20','10:35:00',3.16),('9303','2013-06-20','10:40:00',3.23),('9303','2013-06-20','10:45:00',3.24),('9303','2013-06-20','10:50:00',3.25),('9303','2013-06-20','10:55:00',3.27),('9303','2013-06-20','11:00:00',3.27),('9303','2013-06-20','11:05:00',3.32),('9303','2013-06-20','11:10:00',3.39),('9303','2013-06-20','11:15:00',3.39),('9303','2013-06-20','11:20:00',3.42),('9303','2013-06-20','11:25:00',3.42),('9303','2013-06-20','11:30:00',3.45),('9303','2013-06-20','11:35:00',3.46),('9303','2013-06-20','11:40:00',3.51),('9303','2013-06-20','11:45:00',3.58),('9303','2013-06-20','11:50:00',3.57),('9303','2013-06-20','11:55:00',3.51),('9303','2013-06-20','12:00:00',3.56),('9303','2013-06-20','12:05:00',3.56),('9303','2013-06-20','12:10:00',3.62),('9303','2013-06-20','12:15:00',3.55),('9303','2013-06-20','12:20:00',3.51),('9303','2013-06-20','12:25:00',3.59),('9303','2013-06-20','12:30:00',3.65),('9303','2013-06-20','12:35:00',3.87),('9303','2013-06-20','12:40:00',3.9),('9303','2013-06-20','12:45:00',3.83),('9303','2013-06-20','12:50:00',3.78),('9303','2013-06-20','12:55:00',3.2),('9303','2013-06-20','13:00:00',2.81),('9303','2013-06-20','13:05:00',3.65),('9303','2013-06-20','13:10:00',3.97),('9303','2013-06-20','13:15:00',3.82),('9303','2013-06-20','13:20:00',3.61),('9303','2013-06-20','13:25:00',3.51),('9303','2013-06-20','13:30:00',3.18),('9303','2013-06-20','13:35:00',3.83),('9303','2013-06-20','13:40:00',3.8),('9303','2013-06-20','13:45:00',3.79),('9303','2013-06-20','13:50:00',3.83),('9303','2013-06-20','13:55:00',3.82),('9303','2013-06-20','14:00:00',3.86),('9303','2013-06-20','14:05:00',3.91),('9303','2013-06-20','14:10:00',3.87),('9303','2013-06-20','14:15:00',3.87),('9303','2013-06-20','14:20:00',3.85),('9303','2013-06-20','14:25:00',3.83),('9303','2013-06-20','14:30:00',3.81),('9303','2013-06-20','14:35:00',3.86),('9303','2013-06-20','14:40:00',3.85),('9303','2013-06-20','14:45:00',3.81),('9303','2013-06-20','14:50:00',3.83),('9303','2013-06-20','14:55:00',3.76),('9303','2013-06-20','15:00:00',3.71),('9303','2013-06-20','15:05:00',3.68),('9303','2013-06-20','15:10:00',3.64),('9303','2013-06-20','15:15:00',3.59),('9303','2013-06-20','15:20:00',3.54),('9303','2013-06-20','15:25:00',3.51),('9303','2013-06-20','15:30:00',3.48),('9303','2013-06-20','15:35:00',3.42),('9303','2013-06-20','15:40:00',3.35),('9303','2013-06-20','15:45:00',3.32),('9303','2013-06-20','15:50:00',3.26),('9303','2013-06-20','15:55:00',3.22),('9303','2013-06-20','16:00:00',3.18),('9303','2013-06-20','16:05:00',3.13),('9303','2013-06-20','16:10:00',3.08),('9303','2013-06-20','16:15:00',3.01),('9303','2013-06-20','16:20:00',2.95),('9303','2013-06-20','16:25:00',2.9),('9303','2013-06-20','16:30:00',2.85),('9303','2013-06-20','16:35:00',2.78),('9303','2013-06-20','16:40:00',2.71),('9303','2013-06-20','16:45:00',2.62),('9303','2013-06-20','16:50:00',2.58),('9303','2013-06-20','16:55:00',2.53),('9303','2013-06-20','17:00:00',2.48),('9303','2013-06-20','17:05:00',2.41),('9303','2013-06-20','17:10:00',2.33),('9303','2013-06-20','17:15:00',2.22),('9303','2013-06-20','17:20:00',2.12),('9303','2013-06-20','17:25:00',2),('9303','2013-06-20','17:30:00',1.87),('9303','2013-06-20','17:35:00',1.84),('9303','2013-06-20','17:40:00',1.77),('9303','2013-06-20','17:45:00',1.69),('9303','2013-06-20','17:50:00',1.61),('9303','2013-06-20','17:55:00',1.54),('9303','2013-06-20','18:00:00',1.46),('9303','2013-06-20','18:05:00',1.37),('9303','2013-06-20','18:10:00',1.25),('9303','2013-06-20','18:15:00',1.15),('9303','2013-06-20','18:20:00',1.05),('9303','2013-06-19','07:50:00',1.02),('9303','2013-06-19','07:55:00',1.09),('9303','2013-06-19','08:00:00',1.18),('9303','2013-06-19','08:05:00',1.26),('9303','2013-06-19','08:10:00',1.36),('9303','2013-06-19','08:15:00',1.42),('9303','2013-06-19','08:20:00',1.5),('9303','2013-06-19','08:25:00',1.58),('9303','2013-06-19','08:30:00',1.65),('9303','2013-06-19','08:35:00',1.72),('9303','2013-06-19','08:40:00',1.78),('9303','2013-06-19','08:45:00',1.85),('9303','2013-06-19','08:50:00',1.93),('9303','2013-06-19','08:55:00',2.01),('9303','2013-06-19','09:00:00',2.07),('9303','2013-06-19','09:05:00',2.16),('9303','2013-06-19','09:10:00',2.24),('9303','2013-06-19','09:15:00',2.3),('9303','2013-06-19','09:20:00',2.36),('9303','2013-06-19','09:25:00',2.43),('9303','2013-06-19','09:30:00',2.48),('9303','2013-06-19','09:35:00',2.54),('9303','2013-06-19','09:40:00',2.57),('9303','2013-06-19','09:45:00',2.63),('9303','2013-06-19','09:50:00',2.68),('9303','2013-06-19','09:55:00',2.73),('9303','2013-06-19','10:00:00',2.78),('9303','2013-06-19','10:05:00',2.83),('9303','2013-06-19','10:10:00',2.88),('9303','2013-06-19','10:15:00',2.93),('9303','2013-06-19','10:20:00',2.97),('9303','2013-06-19','10:25:00',2.99),('9303','2013-06-19','10:30:00',3.02),('9303','2013-06-19','10:35:00',3.06),('9303','2013-06-19','10:40:00',3.11),('9303','2013-06-19','10:45:00',3.15),('9303','2013-06-19','10:50:00',3.17),('9303','2013-06-19','10:55:00',3.21),('9303','2013-06-19','11:00:00',3.25),('9303','2013-06-19','11:05:00',3.27),('9303','2013-06-19','11:10:00',3.27),('9303','2013-06-19','11:15:00',3.34),('9303','2013-06-19','11:20:00',3.33),('9303','2013-06-19','11:25:00',3.41),('9303','2013-06-19','11:30:00',3.42),('9303','2013-06-19','11:35:00',3.41),('9303','2013-06-19','11:40:00',3.43),('9303','2013-06-19','11:45:00',3.45),('9303','2013-06-19','11:50:00',3.48),('9303','2013-06-19','11:55:00',3.52),('9303','2013-06-19','12:00:00',3.51),('9303','2013-06-19','12:05:00',3.54),('9303','2013-06-19','12:10:00',3.58),('9303','2013-06-19','12:15:00',3.54),('9303','2013-06-19','12:20:00',3.52),('9303','2013-06-19','12:25:00',3.56),('9303','2013-06-19','12:30:00',3.67),('9303','2013-06-19','12:35:00',3.67),('9303','2013-06-19','12:40:00',3.66),('9303','2013-06-19','12:45:00',3.74),('9303','2013-06-19','12:50:00',3.78),('9303','2013-06-19','12:55:00',3.73),('9303','2013-06-19','13:00:00',3.7),('9303','2013-06-19','13:05:00',3.7),('9303','2013-06-19','13:10:00',3.7),('9303','2013-06-19','13:15:00',3.66),('9303','2013-06-19','13:20:00',3.7),('9303','2013-06-19','13:25:00',3.79),('9303','2013-06-19','13:30:00',3.78),('9303','2013-06-19','13:35:00',3.79),('9303','2013-06-19','13:40:00',3.79),('9303','2013-06-19','13:45:00',3.78),('9303','2013-06-19','13:50:00',3.74),('9303','2013-06-19','13:55:00',3.8),('9303','2013-06-19','14:00:00',3.8),('9303','2013-06-19','14:05:00',3.79),('9303','2013-06-19','14:10:00',3.75),('9303','2013-06-19','14:15:00',3.71),('9303','2013-06-19','14:20:00',3.7),('9303','2013-06-19','14:25:00',3.67),('9303','2013-06-19','14:30:00',3.64),('9303','2013-06-19','14:35:00',3.62),('9303','2013-06-19','14:40:00',3.59),('9303','2013-06-19','14:45:00',3.55),('9303','2013-06-19','14:50:00',3.52),('9303','2013-06-19','14:55:00',3.51),('9303','2013-06-19','15:00:00',3.49),('9303','2013-06-19','15:05:00',3.47),('9303','2013-06-19','15:10:00',3.44),('9303','2013-06-19','15:15:00',3.42),('9303','2013-06-19','15:20:00',3.39),('9303','2013-06-19','15:25:00',3.32),('9303','2013-06-19','15:30:00',3.29),('9303','2013-06-19','15:35:00',3.23),('9303','2013-06-19','15:40:00',3.2),('9303','2013-06-19','15:45:00',3.15),('9303','2013-06-19','15:50:00',3.08),('9303','2013-06-19','15:55:00',3.01),('9303','2013-06-19','16:00:00',2.98),('9303','2013-06-19','16:05:00',2.93),('9303','2013-06-19','16:10:00',2.88),('9303','2013-06-19','16:15:00',2.83),('9303','2013-06-19','16:20:00',2.79),('9303','2013-06-19','16:25:00',2.72),('9303','2013-06-19','16:30:00',2.67),('9303','2013-06-19','16:35:00',2.6),('9303','2013-06-19','16:40:00',2.55),('9303','2013-06-19','16:45:00',2.49),('9303','2013-06-19','16:50:00',2.46),('9303','2013-06-19','16:55:00',2.39),('9303','2013-06-19','17:00:00',2.33),('9303','2013-06-19','17:05:00',2.28),('9303','2013-06-19','17:10:00',2.23),('9303','2013-06-19','17:15:00',2.14),('9303','2013-06-19','17:20:00',2.05),('9303','2013-06-19','17:25:00',1.94),('9303','2013-06-19','17:30:00',1.79),('9303','2013-06-19','17:35:00',1.76),('9303','2013-06-19','17:40:00',1.7),('9303','2013-06-19','17:45:00',1.62),('9303','2013-06-19','17:50:00',1.55),('9303','2013-06-19','17:55:00',1.48),('9303','2013-06-19','18:00:00',1.38),('9303','2013-06-19','18:05:00',1.29),('9303','2013-06-19','18:10:00',1.17),('9303','2013-06-19','18:15:00',1.08),('9303','2013-06-18','07:50:00',1.02),('9303','2013-06-18','07:55:00',1.09),('9303','2013-06-18','08:00:00',1.17),('9303','2013-06-18','08:05:00',1.25),('9303','2013-06-18','08:10:00',1.34),('9303','2013-06-18','08:15:00',1.42),('9303','2013-06-18','08:20:00',1.48),('9303','2013-06-18','08:25:00',1.55),('9303','2013-06-18','08:30:00',1.63),('9303','2013-06-18','08:35:00',1.71),('9303','2013-06-18','08:40:00',1.77),('9303','2013-06-18','08:45:00',1.83),('9303','2013-06-18','08:50:00',1.91),('9303','2013-06-18','08:55:00',1.97),('9303','2013-06-18','09:00:00',2.05),('9303','2013-06-18','09:05:00',2.13),('9303','2013-06-18','09:10:00',2.2),('9303','2013-06-18','09:15:00',2.27),('9303','2013-06-18','09:20:00',2.32),('9303','2013-06-18','09:25:00',2.38),('9303','2013-06-18','09:30:00',2.44),('9303','2013-06-18','09:35:00',2.5),('9303','2013-06-18','09:40:00',2.56),('9303','2013-06-18','09:45:00',2.62),('9303','2013-06-18','09:50:00',2.65),('9303','2013-06-18','09:55:00',2.7),('9303','2013-06-18','10:00:00',2.79),('9303','2013-06-18','10:05:00',2.81),('9303','2013-06-18','10:10:00',2.88),('9303','2013-06-18','10:15:00',2.92),('9303','2013-06-18','10:20:00',2.95),('9303','2013-06-18','10:25:00',2.97),('9303','2013-06-18','10:30:00',2.99),('9303','2013-06-18','10:35:00',3.01),('9303','2013-06-18','10:40:00',3.04),('9303','2013-06-18','10:45:00',3.1),('9303','2013-06-18','10:50:00',3.2),('9303','2013-06-18','10:55:00',3.24),('9303','2013-06-18','11:00:00',3.24),('9303','2013-06-18','11:05:00',3.31),('9303','2013-06-18','11:10:00',3.3),('9303','2013-06-18','11:15:00',3.31),('9303','2013-06-18','11:20:00',3.36),('9303','2013-06-18','11:25:00',3.44),('9303','2013-06-18','11:30:00',3.43),('9303','2013-06-18','11:35:00',3.45),('9303','2013-06-18','11:40:00',3.43),('9303','2013-06-18','11:45:00',3.45),('9303','2013-06-18','11:50:00',3.48),('9303','2013-06-18','11:55:00',3.48),('9303','2013-06-18','12:00:00',3.51),('9303','2013-06-18','12:05:00',3.55),('9303','2013-06-18','12:10:00',3.57),('9303','2013-06-18','12:15:00',3.49),('9303','2013-06-18','12:20:00',3.53),('9303','2013-06-18','12:25:00',3.52),('9303','2013-06-18','12:30:00',3.47),('9303','2013-06-18','12:35:00',3.58),('9303','2013-06-18','12:40:00',3.3),('9303','2013-06-18','12:45:00',2.6),('9303','2013-06-18','12:55:00',2.34),('9303','2013-06-18','13:00:00',3.29),('9303','2013-06-18','13:05:00',3.02),('9303','2013-06-18','13:10:00',2.52),('9303','2013-06-18','13:15:00',3.83),('9303','2013-06-18','13:20:00',3.88),('9303','2013-06-18','13:25:00',3.76),('9303','2013-06-18','13:30:00',3.26),('9303','2013-06-18','13:35:00',3.55),('9303','2013-06-18','13:40:00',3.78),('9303','2013-06-18','13:45:00',3.76),('9303','2013-06-18','13:50:00',3.81),('9303','2013-06-18','13:55:00',3.84),('9303','2013-06-18','14:00:00',3.79),('9303','2013-06-18','14:05:00',3.78),('9303','2013-06-18','14:10:00',3.75),('9303','2013-06-18','14:15:00',3.74),('9303','2013-06-18','14:20:00',3.69),('9303','2013-06-18','14:25:00',3.63),('9303','2013-06-18','14:30:00',3.67),('9303','2013-06-18','14:35:00',3.66),('9303','2013-06-18','14:40:00',3.75),('9303','2013-06-18','14:45:00',3.72),('9303','2013-06-18','14:50:00',3.69),('9303','2013-06-18','14:55:00',3.65),('9303','2013-06-18','15:00:00',3.63),('9303','2013-06-18','15:05:00',3.53),('9303','2013-06-18','15:10:00',3.53),('9303','2013-06-18','15:15:00',3.46),('9303','2013-06-18','15:20:00',3.42),('9303','2013-06-18','15:25:00',3.38),('9303','2013-06-18','15:30:00',3.33),('9303','2013-06-18','15:35:00',3.31),('9303','2013-06-18','15:40:00',3.3),('9303','2013-06-18','15:45:00',3.26),('9303','2013-06-18','15:50:00',3.22),('9303','2013-06-18','15:55:00',3.19),('9303','2013-06-18','16:00:00',3.16),('9303','2013-06-18','16:05:00',3.12),('9303','2013-06-18','16:10:00',3.09),('9303','2013-06-18','16:15:00',3.06),('9303','2013-06-18','16:20:00',3.01),('9303','2013-06-18','16:25:00',2.86),('9303','2013-06-18','16:30:00',2.72),('9303','2013-06-18','16:35:00',2.68),('9303','2013-06-18','16:40:00',2.67),('9303','2013-06-18','16:45:00',2.57),('9303','2013-06-18','16:50:00',2.51),('9303','2013-06-18','16:55:00',2.45),('9303','2013-06-18','17:00:00',2.39),('9303','2013-06-18','17:05:00',2.33),('9303','2013-06-18','17:10:00',2.26),('9303','2013-06-18','17:15:00',2.15),('9303','2013-06-18','17:20:00',2.05),('9303','2013-06-18','17:25:00',1.91),('9303','2013-06-18','17:30:00',1.73),('9303','2013-06-18','17:35:00',1.69),('9303','2013-06-18','17:40:00',1.69),('9303','2013-06-18','17:45:00',1.63),('9303','2013-06-18','17:50:00',1.57),('9303','2013-06-18','17:55:00',1.49),('9303','2013-06-18','18:00:00',1.4),('9303','2013-06-18','18:05:00',1.32),('9303','2013-06-18','18:10:00',1.2),('9303','2013-06-18','18:15:00',1.11),('9303','2013-06-18','18:20:00',1.05),('9303','2013-06-17','07:50:00',1.07),('9303','2013-06-17','07:55:00',1.15),('9303','2013-06-17','08:00:00',1.23),('9303','2013-06-17','08:05:00',1.31),('9303','2013-06-17','08:10:00',1.41),('9303','2013-06-17','08:15:00',1.48),('9303','2013-06-17','08:20:00',1.56),('9303','2013-06-17','08:25:00',1.64),('9303','2013-06-17','08:30:00',1.72),('9303','2013-06-17','08:35:00',1.79),('9303','2013-06-17','08:40:00',1.87),('9303','2013-06-17','08:45:00',1.94),('9303','2013-06-17','08:50:00',2.01),('9303','2013-06-17','08:55:00',2.09),('9303','2013-06-17','09:00:00',2.16),('9303','2013-06-17','09:05:00',2.25),('9303','2013-06-17','09:10:00',2.31),('9303','2013-06-17','09:15:00',2.38),('9303','2013-06-17','09:20:00',2.45),('9303','2013-06-17','09:25:00',2.49),('9303','2013-06-17','09:30:00',2.57),('9303','2013-06-17','09:35:00',2.63),('9303','2013-06-17','09:40:00',2.7),('9303','2013-06-17','09:45:00',2.74),('9303','2013-06-17','09:50:00',2.79),('9303','2013-06-17','09:55:00',2.84),('9303','2013-06-17','10:00:00',2.88),('9303','2013-06-17','10:05:00',2.89),('9303','2013-06-17','10:10:00',2.96),('9303','2013-06-17','10:15:00',3.02),('9303','2013-06-17','10:20:00',3.05),('9303','2013-06-17','10:25:00',3.09),('9303','2013-06-17','10:30:00',3.15),('9303','2013-06-17','10:35:00',3.21),('9303','2013-06-17','10:40:00',3.27),('9303','2013-06-17','10:45:00',3.34),('9303','2013-06-17','10:50:00',3.33),('9303','2013-06-17','10:55:00',3.35),('9303','2013-06-17','11:00:00',3.38),('9303','2013-06-17','11:05:00',3.42),('9303','2013-06-17','11:10:00',3.45),('9303','2013-06-17','11:15:00',3.47),('9303','2013-06-17','11:20:00',3.51),('9303','2013-06-17','11:25:00',3.51),('9303','2013-06-17','11:30:00',3.54),('9303','2013-06-17','11:35:00',3.59),('9303','2013-06-17','11:40:00',3.6),('9303','2013-06-17','11:45:00',3.56),('9303','2013-06-17','11:50:00',3.59),('9303','2013-06-17','11:55:00',3.57),('9303','2013-06-17','12:00:00',3.62),('9303','2013-06-17','12:05:00',3.61),('9303','2013-06-17','12:10:00',3.63),('9303','2013-06-17','12:15:00',3.64),('9303','2013-06-17','12:20:00',3.64),('9303','2013-06-17','12:25:00',3.66),('9303','2013-06-17','12:30:00',3.66),('9303','2013-06-17','12:35:00',3.67),('9303','2013-06-17','12:40:00',3.71),('9303','2013-06-17','12:45:00',3.72),('9303','2013-06-17','12:50:00',3.8),('9303','2013-06-17','12:55:00',3.81),('9303','2013-06-17','13:00:00',3.89),('9303','2013-06-17','13:05:00',3.93),('9303','2013-06-17','13:10:00',3.9),('9303','2013-06-17','13:15:00',3.9),('9303','2013-06-17','13:20:00',3.87),('9303','2013-06-17','13:25:00',3.86),('9303','2013-06-17','13:30:00',3.88),('9303','2013-06-17','13:35:00',3.86),('9303','2013-06-17','13:40:00',3.84),('9303','2013-06-17','13:45:00',3.82),('9303','2013-06-17','13:50:00',3.81),('9303','2013-06-17','13:55:00',3.81),('9303','2013-06-17','14:00:00',3.79),('9303','2013-06-17','14:05:00',3.77),('9303','2013-06-17','14:10:00',3.8),('9303','2013-06-17','14:15:00',3.75),('9303','2013-06-17','14:20:00',3.78),('9303','2013-06-17','14:25:00',3.74),('9303','2013-06-17','14:30:00',3.72),('9303','2013-06-17','14:35:00',3.71),('9303','2013-06-17','14:40:00',3.69),('9303','2013-06-17','14:45:00',3.65),('9303','2013-06-17','14:50:00',3.6),('9303','2013-06-17','14:55:00',3.58),('9303','2013-06-17','15:00:00',3.55),('9303','2013-06-17','15:05:00',3.5),('9303','2013-06-17','15:10:00',3.47),('9303','2013-06-17','15:15:00',3.43),('9303','2013-06-17','15:20:00',3.41),('9303','2013-06-17','15:25:00',3.37),('9303','2013-06-17','15:30:00',3.33),('9303','2013-06-17','15:35:00',3.31),('9303','2013-06-17','15:40:00',3.27),('9303','2013-06-17','15:45:00',3.21),('9303','2013-06-17','15:50:00',3.16),('9303','2013-06-17','15:55:00',3.11),('9303','2013-06-17','16:00:00',3.08),('9303','2013-06-17','16:05:00',3.03),('9303','2013-06-17','16:10:00',2.98),('9303','2013-06-17','16:15:00',2.93),('9303','2013-06-17','16:20:00',2.88),('9303','2013-06-17','16:25:00',2.82),('9303','2013-06-17','16:30:00',2.78),('9303','2013-06-17','16:35:00',2.73),('9303','2013-06-17','16:40:00',2.66),('9303','2013-06-17','16:45:00',2.59),('9303','2013-06-17','16:50:00',2.54),('9303','2013-06-17','16:55:00',2.47),('9303','2013-06-17','17:00:00',2.42),('9303','2013-06-17','17:05:00',2.36),('9303','2013-06-17','17:10:00',2.28),('9303','2013-06-17','17:15:00',2.18),('9303','2013-06-17','17:20:00',2.08),('9303','2013-06-17','17:25:00',1.96),('9303','2013-06-17','17:30:00',1.81),('9303','2013-06-17','17:35:00',1.8),('9303','2013-06-17','17:40:00',1.75),('9303','2013-06-17','17:45:00',1.69),('9303','2013-06-17','17:50:00',1.61),('9303','2013-06-17','17:55:00',1.53),('9303','2013-06-17','18:00:00',1.45),('9303','2013-06-17','18:05:00',1.36),('9303','2013-06-17','18:10:00',1.23),('9303','2013-06-17','18:15:00',1.15),('9303','2013-06-17','18:20:00',1.07),('9303','2013-06-16','07:45:00',1.03),('9303','2013-06-16','07:50:00',1.11),('9303','2013-06-16','07:55:00',1.19),('9303','2013-06-16','08:00:00',1.26),('9303','2013-06-16','08:05:00',1.35),('9303','2013-06-16','08:10:00',1.45),('9303','2013-06-16','08:15:00',1.52),('9303','2013-06-16','08:20:00',1.59),('9303','2013-06-16','08:25:00',1.67),('9303','2013-06-16','08:30:00',1.76),('9303','2013-06-16','08:35:00',1.84),('9303','2013-06-16','08:40:00',1.9),('9303','2013-06-16','08:45:00',1.98),('9303','2013-06-16','08:50:00',2.06),('9303','2013-06-16','08:55:00',2.14),('9303','2013-06-16','09:00:00',2.22),('9303','2013-06-16','09:05:00',2.32),('9303','2013-06-16','09:10:00',2.36),('9303','2013-06-16','09:15:00',2.44),('9303','2013-06-16','09:20:00',2.51),('9303','2013-06-16','09:25:00',2.58),('9303','2013-06-16','09:30:00',2.62),('9303','2013-06-16','09:35:00',2.69),('9303','2013-06-16','09:40:00',2.73),('9303','2013-06-16','09:45:00',2.77),('9303','2013-06-16','09:50:00',2.82),('9303','2013-06-16','09:55:00',2.83),('9303','2013-06-16','10:00:00',2.91),('9303','2013-06-16','10:05:00',2.96),('9303','2013-06-16','10:10:00',3.01),('9303','2013-06-16','10:15:00',3.08),('9303','2013-06-16','10:20:00',3.15),('9303','2013-06-16','10:25:00',3.18),('9303','2013-06-16','10:30:00',3.23),('9303','2013-06-16','10:35:00',3.27),('9303','2013-06-16','10:40:00',3.33),('9303','2013-06-16','10:45:00',3.38),('9303','2013-06-16','10:50:00',3.4),('9303','2013-06-16','10:55:00',3.41),('9303','2013-06-16','11:00:00',3.43),('9303','2013-06-16','11:05:00',3.48),('9303','2013-06-16','11:10:00',3.51),('9303','2013-06-16','11:15:00',3.56),('9303','2013-06-16','11:20:00',3.59),('9303','2013-06-16','11:25:00',3.6),('9303','2013-06-16','11:30:00',3.6),('9303','2013-06-16','11:35:00',3.65),('9303','2013-06-16','11:40:00',3.7),('9303','2013-06-16','11:45:00',3.75),('9303','2013-06-16','11:50:00',3.79),('9303','2013-06-16','11:55:00',3.82),('9303','2013-06-16','12:00:00',3.82),('9303','2013-06-16','12:05:00',3.81),('9303','2013-06-16','12:10:00',3.82),('9303','2013-06-16','12:15:00',3.82),('9303','2013-06-16','12:20:00',3.85),('9303','2013-06-16','12:25:00',3.86),('9303','2013-06-16','12:30:00',3.87),('9303','2013-06-16','12:35:00',3.83),('9303','2013-06-16','12:40:00',3.82),('9303','2013-06-16','12:45:00',3.82),('9303','2013-06-16','12:50:00',3.89),('9303','2013-06-16','12:55:00',3.95),('9303','2013-06-16','13:00:00',3.97),('9303','2013-06-16','13:05:00',4),('9303','2013-06-16','13:10:00',4),('9303','2013-06-16','13:15:00',4),('9303','2013-06-16','13:20:00',3.97),('9303','2013-06-16','13:25:00',3.99),('9303','2013-06-16','13:30:00',3.98),('9303','2013-06-16','13:35:00',4.01),('9303','2013-06-16','13:40:00',3.98),('9303','2013-06-16','13:45:00',3.97),('9303','2013-06-16','13:50:00',3.97),('9303','2013-06-16','13:55:00',3.96),('9303','2013-06-16','14:00:00',3.98),('9303','2013-06-16','14:05:00',3.95),('9303','2013-06-16','14:10:00',3.93),('9303','2013-06-16','14:15:00',3.92),('9303','2013-06-16','14:20:00',3.87),('9303','2013-06-16','14:25:00',3.87),('9303','2013-06-16','14:30:00',3.82),('9303','2013-06-16','14:35:00',3.79),('9303','2013-06-16','14:40:00',3.73),('9303','2013-06-16','14:45:00',3.72),('9303','2013-06-16','14:50:00',3.69),('9303','2013-06-16','14:55:00',3.67),('9303','2013-06-16','15:00:00',3.63),('9303','2013-06-16','15:05:00',3.63),('9303','2013-06-16','15:10:00',3.6),('9303','2013-06-16','15:15:00',3.57),('9303','2013-06-16','15:20:00',3.54),('9303','2013-06-16','15:25:00',3.49),('9303','2013-06-16','15:30:00',3.45),('9303','2013-06-16','15:35:00',3.41),('9303','2013-06-16','15:40:00',3.37),('9303','2013-06-16','15:45:00',3.31),('9303','2013-06-16','15:50:00',3.26),('9303','2013-06-16','15:55:00',3.21),('9303','2013-06-16','16:00:00',3.15),('9303','2013-06-16','16:05:00',3.1),('9303','2013-06-16','16:10:00',3.06),('9303','2013-06-16','16:15:00',2.99),('9303','2013-06-16','16:20:00',2.95),('9303','2013-06-16','16:25:00',2.89),('9303','2013-06-16','16:30:00',2.83),('9303','2013-06-16','16:35:00',2.77),('9303','2013-06-16','16:40:00',2.72),('9303','2013-06-16','16:45:00',2.65),('9303','2013-06-16','16:50:00',2.59),('9303','2013-06-16','16:55:00',2.52),('9303','2013-06-16','17:00:00',2.44),('9303','2013-06-16','17:05:00',2.38),('9303','2013-06-16','17:10:00',2.31),('9303','2013-06-16','17:15:00',2.19),('9303','2013-06-16','17:20:00',2.08),('9303','2013-06-16','17:25:00',1.94),('9303','2013-06-16','17:30:00',1.79),('9303','2013-06-16','17:35:00',1.8),('9303','2013-06-16','17:40:00',1.73),('9303','2013-06-16','17:45:00',1.66),('9303','2013-06-16','17:50:00',1.58),('9303','2013-06-16','17:55:00',1.5),('9303','2013-06-16','18:00:00',1.41),('9303','2013-06-16','18:05:00',1.32),('9303','2013-06-16','18:10:00',1.2),('9303','2013-06-16','18:15:00',1.1),('9303','2013-06-16','18:20:00',1.01),('9303','2013-06-15','07:50:00',1.07),('9303','2013-06-15','07:55:00',1.13),('9303','2013-06-15','08:00:00',1.21),('9303','2013-06-15','08:05:00',1.3),('9303','2013-06-15','08:10:00',1.4),('9303','2013-06-15','08:15:00',1.49),('9303','2013-06-15','08:20:00',1.57),('9303','2013-06-15','08:25:00',1.68),('9303','2013-06-15','08:30:00',1.77),('9303','2013-06-15','08:35:00',1.8),('9303','2013-06-15','08:40:00',1.85),('9303','2013-06-15','08:45:00',1.94),('9303','2013-06-15','08:50:00',1.76),('9303','2013-06-15','08:55:00',1.96),('9303','2013-06-15','09:00:00',2.06),('9303','2013-06-15','09:05:00',2.29),('9303','2013-06-15','09:10:00',2.3),('9303','2013-06-15','09:15:00',2.29),('9303','2013-06-15','09:20:00',1.96),('9303','2013-06-15','09:25:00',2.51),('9303','2013-06-15','09:30:00',2.57),('9303','2013-06-15','09:35:00',1.82),('9303','2013-06-15','09:40:00',2.69),('9303','2013-06-15','09:45:00',2.82),('9303','2013-06-15','09:50:00',2.84),('9303','2013-06-15','09:55:00',2.83),('9303','2013-06-15','10:00:00',1.96),('9303','2013-06-15','10:10:00',2.56),('9303','2013-06-15','10:15:00',3.07),('9303','2013-06-15','10:20:00',3.23),('9303','2013-06-15','10:25:00',3.13),('9303','2013-06-15','10:30:00',3.23),('9303','2013-06-15','10:35:00',3.22),('9303','2013-06-15','10:40:00',3.18),('9303','2013-06-15','10:45:00',3.48),('9303','2013-06-15','10:50:00',3.5),('9303','2013-06-15','10:55:00',3.18),('9303','2013-06-15','11:00:00',1.72),('9303','2013-06-15','11:05:00',2.52),('9303','2013-06-15','11:10:00',1.65),('9303','2013-06-15','11:15:00',2.97),('9303','2013-06-15','11:20:00',3.49),('9303','2013-06-15','11:25:00',2.77),('9303','2013-06-15','11:30:00',3.41),('9303','2013-06-15','11:35:00',3.74),('9303','2013-06-15','11:40:00',2.61),('9303','2013-06-15','11:45:00',2.88),('9303','2013-06-15','11:50:00',4.08),('9303','2013-06-15','11:55:00',3.94),('9303','2013-06-15','12:00:00',3.08),('9303','2013-06-15','12:05:00',3.94),('9303','2013-06-15','12:10:00',4.03),('9303','2013-06-15','12:15:00',4.02),('9303','2013-06-15','12:20:00',3.99),('9303','2013-06-15','12:25:00',3.99),('9303','2013-06-15','12:30:00',3.96),('9303','2013-06-15','12:35:00',4.02),('9303','2013-06-15','12:40:00',3.99),('9303','2013-06-15','12:45:00',3.98),('9303','2013-06-15','12:50:00',3.99),('9303','2013-06-15','12:55:00',3.99),('9303','2013-06-15','13:00:00',4.02),('9303','2013-06-15','13:05:00',4),('9303','2013-06-15','13:10:00',4.02),('9303','2013-06-15','13:15:00',4.05),('9303','2013-06-15','13:20:00',4),('9303','2013-06-15','13:25:00',3.97),('9303','2013-06-15','13:30:00',3.98),('9303','2013-06-15','13:35:00',3.95),('9303','2013-06-15','13:40:00',3.99),('9303','2013-06-15','13:45:00',4),('9303','2013-06-15','13:50:00',3.98),('9303','2013-06-15','13:55:00',3.95),('9303','2013-06-15','14:00:00',3.92),('9303','2013-06-15','14:05:00',3.88),('9303','2013-06-15','14:10:00',3.88),('9303','2013-06-15','14:15:00',3.87),('9303','2013-06-15','14:20:00',3.86),('9303','2013-06-15','14:25:00',3.83),('9303','2013-06-15','14:30:00',3.76),('9303','2013-06-15','14:35:00',3.68),('9303','2013-06-15','14:40:00',3.73),('9303','2013-06-15','14:45:00',3.71),('9303','2013-06-15','14:50:00',3.62),('9303','2013-06-15','14:55:00',3.66),('9303','2013-06-15','15:00:00',3.63),('9303','2013-06-15','15:05:00',3.63),('9303','2013-06-15','15:10:00',3.61),('9303','2013-06-15','15:15:00',3.57),('9303','2013-06-15','15:20:00',3.53),('9303','2013-06-15','15:25:00',3.51),('9303','2013-06-15','15:30:00',3.48),('9303','2013-06-15','15:35:00',3.43),('9303','2013-06-15','15:40:00',3.37),('9303','2013-06-15','15:45:00',3.33),('9303','2013-06-15','15:50:00',3.24),('9303','2013-06-15','15:55:00',3.21),('9303','2013-06-15','16:00:00',3.16),('9303','2013-06-15','16:05:00',3.11),('9303','2013-06-15','16:10:00',3.05),('9303','2013-06-15','16:15:00',2.99),('9303','2013-06-15','16:20:00',2.94),('9303','2013-06-15','16:25:00',2.88),('9303','2013-06-15','16:30:00',2.81),('9303','2013-06-15','16:35:00',2.76),('9303','2013-06-15','16:40:00',2.68),('9303','2013-06-15','16:45:00',2.63),('9303','2013-06-15','16:50:00',2.56),('9303','2013-06-15','16:55:00',2.5),('9303','2013-06-15','17:00:00',2.43),('9303','2013-06-15','17:05:00',2.36),('9303','2013-06-15','17:10:00',2.27),('9303','2013-06-15','17:15:00',2.15),('9303','2013-06-15','17:20:00',2.04),('9303','2013-06-15','17:25:00',1.91),('9303','2013-06-15','17:30:00',1.74),('9303','2013-06-15','17:35:00',1.77),('9303','2013-06-15','17:40:00',1.7),('9303','2013-06-15','17:45:00',1.61),('9303','2013-06-15','17:50:00',1.54),('9303','2013-06-15','17:55:00',1.45),('9303','2013-06-15','18:00:00',1.37),('9303','2013-06-15','18:05:00',1.28),('9303','2013-06-15','18:10:00',1.15),('9303','2013-06-15','18:15:00',1.08),('9303','2013-06-14','07:40:00',1.02),('9303','2013-06-14','07:45:00',1.1),('9303','2013-06-14','07:50:00',1.18),('9303','2013-06-14','07:55:00',1.27),('9303','2013-06-14','08:00:00',1.35),('9303','2013-06-14','08:05:00',1.44),('9303','2013-06-14','08:10:00',1.55),('9303','2013-06-14','08:15:00',1.62),('9303','2013-06-14','08:20:00',1.7),('9303','2013-06-14','08:25:00',1.77),('9303','2013-06-14','08:30:00',1.85),('9303','2013-06-14','08:35:00',1.93),('9303','2013-06-14','08:40:00',2.01),('9303','2013-06-14','08:45:00',2.09),('9303','2013-06-14','08:50:00',2.16),('9303','2013-06-14','08:55:00',2.23),('9303','2013-06-14','09:00:00',2.31),('9303','2013-06-14','09:05:00',2.39),('9303','2013-06-14','09:10:00',2.47),('9303','2013-06-14','09:15:00',2.53),('9303','2013-06-14','09:20:00',2.59),('9303','2013-06-14','09:25:00',2.67),('9303','2013-06-14','09:30:00',2.73),('9303','2013-06-14','09:35:00',2.81),('9303','2013-06-14','09:40:00',2.87),('9303','2013-06-14','09:45:00',2.93),('9303','2013-06-14','09:50:00',3.01),('9303','2013-06-14','09:55:00',3.07),('9303','2013-06-14','10:00:00',3.12),('9303','2013-06-14','10:05:00',3.12),('9303','2013-06-14','10:10:00',3.14),('9303','2013-06-14','10:15:00',3.19),('9303','2013-06-14','10:20:00',3.26),('9303','2013-06-14','10:25:00',3.28),('9303','2013-06-14','10:30:00',3.34),('9303','2013-06-14','10:35:00',3.45),('9303','2013-06-14','10:40:00',3.46),('9303','2013-06-14','10:45:00',3.48),('9303','2013-06-14','10:50:00',3.51),('9303','2013-06-14','10:55:00',3.51),('9303','2013-06-14','11:00:00',3.5),('9303','2013-06-14','11:05:00',3.54),('9303','2013-06-14','11:10:00',3.63),('9303','2013-06-14','11:15:00',3.69),('9303','2013-06-14','11:20:00',3.66),('9303','2013-06-14','11:25:00',3.62),('9303','2013-06-14','11:30:00',3.79),('9303','2013-06-14','11:35:00',3.81),('9303','2013-06-14','11:40:00',3.85),('9303','2013-06-14','11:45:00',3.84),('9303','2013-06-14','11:50:00',3.83),('9303','2013-06-14','11:55:00',3.83),('9303','2013-06-14','12:00:00',3.82),('9303','2013-06-14','12:05:00',3.82),('9303','2013-06-14','12:10:00',3.87),('9303','2013-06-14','12:15:00',3.9),('9303','2013-06-14','12:20:00',3.95),('9303','2013-06-14','12:25:00',3.94),('9303','2013-06-14','12:30:00',3.98),('9303','2013-06-14','12:35:00',3.92),('9303','2013-06-14','12:40:00',3.87),('9303','2013-06-14','12:45:00',3.94),('9303','2013-06-14','12:50:00',3.88),('9303','2013-06-14','12:55:00',3.89),('9303','2013-06-14','13:00:00',3.9),('9303','2013-06-14','13:05:00',3.91),('9303','2013-06-14','13:10:00',3.16),('9303','2013-06-14','13:15:00',3.29),('9303','2013-06-14','13:20:00',3.92),('9303','2013-06-14','13:25:00',1.97),('9303','2013-06-14','13:30:00',3.79),('9303','2013-06-14','13:35:00',3.97),('9303','2013-06-14','13:40:00',3.93),('9303','2013-06-14','13:45:00',3.92),('9303','2013-06-14','13:50:00',3.94),('9303','2013-06-14','13:55:00',3.93),('9303','2013-06-14','14:00:00',3.86),('9303','2013-06-14','14:05:00',4),('9303','2013-06-14','14:10:00',3.99),('9303','2013-06-14','14:15:00',3.92),('9303','2013-06-14','14:20:00',3.89),('9303','2013-06-14','14:25:00',3.87),('9303','2013-06-14','14:30:00',3.85),('9303','2013-06-14','14:35:00',3.85),('9303','2013-06-14','14:40:00',3.8),('9303','2013-06-14','14:45:00',3.75),('9303','2013-06-14','14:50:00',3.74),('9303','2013-06-14','14:55:00',3.72),('9303','2013-06-14','15:00:00',3.68),('9303','2013-06-14','15:05:00',3.66),('9303','2013-06-14','15:10:00',3.68),('9303','2013-06-14','15:15:00',3.63),('9303','2013-06-14','15:20:00',3.59),('9303','2013-06-14','15:25:00',3.56),('9303','2013-06-14','15:30:00',3.51),('9303','2013-06-14','15:35:00',3.48),('9303','2013-06-14','15:40:00',3.44),('9303','2013-06-14','15:45:00',3.42),('9303','2013-06-14','15:50:00',3.35),('9303','2013-06-14','15:55:00',3.29),('9303','2013-06-14','16:00:00',3.21),('9303','2013-06-14','16:05:00',3.17),('9303','2013-06-14','16:10:00',3.12),('9303','2013-06-14','16:15:00',3.06),('9303','2013-06-14','16:20:00',3),('9303','2013-06-14','16:25:00',2.93),('9303','2013-06-14','16:30:00',2.87),('9303','2013-06-14','16:35:00',2.81),('9303','2013-06-14','16:40:00',2.73),('9303','2013-06-14','16:45:00',2.68),('9303','2013-06-14','16:50:00',2.62),('9303','2013-06-14','16:55:00',2.54),('9303','2013-06-14','17:00:00',2.5),('9303','2013-06-14','17:05:00',2.36),('9303','2013-06-14','17:10:00',2.31),('9303','2013-06-14','17:15:00',2.26),('9303','2013-06-14','17:20:00',2.11),('9303','2013-06-14','17:25:00',1.96),('9303','2013-06-14','17:30:00',1.77),('9303','2013-06-14','17:35:00',1.54),('9303','2013-06-14','17:40:00',1.66),('9303','2013-06-14','17:45:00',1.7),('9303','2013-06-14','17:50:00',1.63),('9303','2013-06-14','17:55:00',1.54),('9303','2013-06-14','18:00:00',1.45),('9303','2013-06-14','18:05:00',1.35),('9303','2013-06-14','18:10:00',1.23),('9303','2013-06-14','18:15:00',1.14),('9303','2013-06-14','18:20:00',1.05),('9303','2013-06-13','07:40:00',1.03),('9303','2013-06-13','07:45:00',1.11),('9303','2013-06-13','07:50:00',1.2),('9303','2013-06-13','07:55:00',1.29),('9303','2013-06-13','08:00:00',1.38),('9303','2013-06-13','08:05:00',1.47),('9303','2013-06-13','08:10:00',1.57),('9303','2013-06-13','08:15:00',1.65),('9303','2013-06-13','08:20:00',1.72),('9303','2013-06-13','08:25:00',1.79),('9303','2013-06-13','08:30:00',1.86),('9303','2013-06-13','08:35:00',1.93),('9303','2013-06-13','08:40:00',2.01),('9303','2013-06-13','08:45:00',2.09),('9303','2013-06-13','08:50:00',2.16),('9303','2013-06-13','08:55:00',2.23),('9303','2013-06-13','09:00:00',2.32),('9303','2013-06-13','09:05:00',2.42),('9303','2013-06-13','09:10:00',2.49),('9303','2013-06-13','09:15:00',2.56),('9303','2013-06-13','09:20:00',2.66),('9303','2013-06-13','09:25:00',2.75),('9303','2013-06-13','09:30:00',2.83),('9303','2013-06-13','09:35:00',2.9),('9303','2013-06-13','09:40:00',2.96),('9303','2013-06-13','09:45:00',3.02),('9303','2013-06-13','09:50:00',3.08),('9303','2013-06-13','09:55:00',3.14),('9303','2013-06-13','10:00:00',3.18),('9303','2013-06-13','10:05:00',3.25),('9303','2013-06-13','10:10:00',3.29),('9303','2013-06-13','10:15:00',3.34),('9303','2013-06-13','10:20:00',3.38),('9303','2013-06-13','10:25:00',3.44),('9303','2013-06-13','10:30:00',3.48),('9303','2013-06-13','10:35:00',3.51),('9303','2013-06-13','10:40:00',3.53),('9303','2013-06-13','10:45:00',3.6),('9303','2013-06-13','10:50:00',3.65),('9303','2013-06-13','10:55:00',3.7),('9303','2013-06-13','11:00:00',3.74),('9303','2013-06-13','11:05:00',3.74),('9303','2013-06-13','11:10:00',3.75),('9303','2013-06-13','11:15:00',3.79),('9303','2013-06-13','11:20:00',3.84),('9303','2013-06-13','11:25:00',3.89),('9303','2013-06-13','11:30:00',3.92),('9303','2013-06-13','11:35:00',3.96),('9303','2013-06-13','11:40:00',3.96),('9303','2013-06-13','11:45:00',4.02),('9303','2013-06-13','11:50:00',4.03),('9303','2013-06-13','11:55:00',4.04),('9303','2013-06-13','12:00:00',4.05),('9303','2013-06-13','12:05:00',4.09),('9303','2013-06-13','12:10:00',4.1),('9303','2013-06-13','12:15:00',4.1),('9303','2013-06-13','12:20:00',4.11),('9303','2013-06-13','12:25:00',4.1),('9303','2013-06-13','12:30:00',4.14),('9303','2013-06-13','12:35:00',4.13),('9303','2013-06-13','12:40:00',4.15),('9303','2013-06-13','12:45:00',4.16),('9303','2013-06-13','12:50:00',4.17),('9303','2013-06-13','12:55:00',4.18),('9303','2013-06-13','13:00:00',4.16),('9303','2013-06-13','13:05:00',4.15),('9303','2013-06-13','13:10:00',4.16),('9303','2013-06-13','13:15:00',4.22),('9303','2013-06-13','13:20:00',4.19),('9303','2013-06-13','13:25:00',4.15),('9303','2013-06-13','13:30:00',4.16),('9303','2013-06-13','13:35:00',4.16),('9303','2013-06-13','13:40:00',4.17),('9303','2013-06-13','13:45:00',4.14),('9303','2013-06-13','13:50:00',4.13),('9303','2013-06-13','13:55:00',4.11),('9303','2013-06-13','14:00:00',4.08),('9303','2013-06-13','14:05:00',4.09),('9303','2013-06-13','14:10:00',4.12),('9303','2013-06-13','14:15:00',4.14),('9303','2013-06-13','14:20:00',4.07),('9303','2013-06-13','14:25:00',4.11),('9303','2013-06-13','14:30:00',2.39),('9303','2013-06-13','14:35:00',3.33),('9303','2013-06-13','14:40:00',4.05),('9303','2013-06-13','14:45:00',3.95),('9303','2013-06-13','14:50:00',3.86),('9303','2013-06-13','14:55:00',3.81),('9303','2013-06-13','15:00:00',3.77),('9303','2013-06-13','15:05:00',3.72),('9303','2013-06-13','15:10:00',3.66),('9303','2013-06-13','15:15:00',3.63),('9303','2013-06-13','15:20:00',3.58),('9303','2013-06-13','15:25:00',3.56),('9303','2013-06-13','15:30:00',3.51),('9303','2013-06-13','15:35:00',3.47),('9303','2013-06-13','15:40:00',3.44),('9303','2013-06-13','15:45:00',3.38),('9303','2013-06-13','15:50:00',3.35),('9303','2013-06-13','15:55:00',3.3),('9303','2013-06-13','16:00:00',3.24),('9303','2013-06-13','16:05:00',3.16),('9303','2013-06-13','16:10:00',3.11),('9303','2013-06-13','16:15:00',3.04),('9303','2013-06-13','16:20:00',2.97),('9303','2013-06-13','16:25:00',2.9),('9303','2013-06-13','16:30:00',2.88),('9303','2013-06-13','16:35:00',2.79),('9303','2013-06-13','16:40:00',2.75),('9303','2013-06-13','16:45:00',2.69),('9303','2013-06-13','16:50:00',2.6),('9303','2013-06-13','16:55:00',2.55),('9303','2013-06-13','17:00:00',2.45),('9303','2013-06-13','17:05:00',2.39),('9303','2013-06-13','17:10:00',2.32),('9303','2013-06-13','17:15:00',2.23),('9303','2013-06-13','17:20:00',2.13),('9303','2013-06-13','17:25:00',1.98),('9303','2013-06-13','17:30:00',1.91),('9303','2013-06-13','17:35:00',1.85),('9303','2013-06-13','17:40:00',1.76),('9303','2013-06-13','17:45:00',1.67),('9303','2013-06-13','17:50:00',1.61),('9303','2013-06-13','17:55:00',1.51),('9303','2013-06-13','18:00:00',1.41),('9303','2013-06-13','18:05:00',1.32),('9303','2013-06-13','18:10:00',1.21),('9303','2013-06-13','18:15:00',1.12),('9303','2013-06-13','18:20:00',1.04),('9303','2013-06-12','07:40:00',1.03),('9303','2013-06-12','07:45:00',1.12),('9303','2013-06-12','07:50:00',1.21),('9303','2013-06-12','07:55:00',1.3),('9303','2013-06-12','08:00:00',1.39),('9303','2013-06-12','08:05:00',1.49),('9303','2013-06-12','08:10:00',1.59),('9303','2013-06-12','08:15:00',1.67),('9303','2013-06-12','08:20:00',1.75),('9303','2013-06-12','08:25:00',1.83),('9303','2013-06-12','08:30:00',1.92),('9303','2013-06-12','08:35:00',2),('9303','2013-06-12','08:40:00',2.08),('9303','2013-06-12','08:45:00',2.14),('9303','2013-06-12','08:50:00',2.24),('9303','2013-06-12','08:55:00',2.31),('9303','2013-06-12','09:00:00',2.41),('9303','2013-06-12','09:05:00',2.5),('9303','2013-06-12','09:10:00',2.58),('9303','2013-06-12','09:15:00',2.66),('9303','2013-06-12','09:20:00',2.71),('9303','2013-06-12','09:25:00',2.77),('9303','2013-06-12','09:30:00',2.84),('9303','2013-06-12','09:35:00',2.9),('9303','2013-06-12','09:40:00',2.97),('9303','2013-06-12','09:45:00',3.02),('9303','2013-06-12','09:50:00',3.08),('9303','2013-06-12','09:55:00',3.14),('9303','2013-06-12','10:00:00',3.16),('9303','2013-06-12','10:05:00',3.22),('9303','2013-06-12','10:10:00',3.26),('9303','2013-06-12','10:15:00',3.33),('9303','2013-06-12','10:20:00',3.42),('9303','2013-06-12','10:25:00',3.45),('9303','2013-06-12','10:30:00',3.48),('9303','2013-06-12','10:35:00',3.49),('9303','2013-06-12','10:40:00',3.54),('9303','2013-06-12','10:45:00',3.62),('9303','2013-06-12','10:50:00',3.69),('9303','2013-06-12','10:55:00',3.77),('9303','2013-06-12','11:00:00',3.8),('9303','2013-06-12','11:05:00',3.84),('9303','2013-06-12','11:10:00',3.9),('9303','2013-06-12','11:15:00',3.92),('9303','2013-06-12','11:20:00',3.91),('9303','2013-06-12','11:25:00',3.92),('9303','2013-06-12','11:30:00',3.95),('9303','2013-06-12','11:35:00',4),('9303','2013-06-12','11:40:00',4.01),('9303','2013-06-12','11:45:00',4.02),('9303','2013-06-12','11:50:00',4.03),('9303','2013-06-12','11:55:00',4.09),('9303','2013-06-12','12:00:00',4.09),('9303','2013-06-12','12:05:00',4.1),('9303','2013-06-12','12:10:00',4.12),('9303','2013-06-12','12:15:00',4.2),('9303','2013-06-12','12:20:00',4.21),('9303','2013-06-12','12:25:00',3.14),('9303','2013-06-12','12:30:00',3.55),('9303','2013-06-12','12:35:00',4.08),('9303','2013-06-12','12:40:00',1.76),('9303','2013-06-12','12:45:00',2.91),('9303','2013-06-12','12:50:00',4.49),('9303','2013-06-12','12:55:00',4.04),('9303','2013-06-12','13:00:00',3.08),('9303','2013-06-12','13:05:00',3.83),('9303','2013-06-12','13:10:00',4.25),('9303','2013-06-12','13:15:00',4.16),('9303','2013-06-12','13:20:00',4.12),('9303','2013-06-12','13:25:00',4.09),('9303','2013-06-12','13:30:00',4.18),('9303','2013-06-12','13:35:00',4.21),('9303','2013-06-12','13:40:00',4.19),('9303','2013-06-12','13:45:00',4.19),('9303','2013-06-12','13:50:00',4.16),('9303','2013-06-12','13:55:00',4.27),('9303','2013-06-12','14:00:00',4.04),('9303','2013-06-12','14:05:00',2.04),('9303','2013-06-12','14:10:00',3.25),('9303','2013-06-12','14:15:00',4.35),('9303','2013-06-12','14:20:00',2.01),('9303','2013-06-12','14:25:00',1.96),('9303','2013-06-12','14:30:00',4.27),('9303','2013-06-12','14:35:00',3.01),('9303','2013-06-12','14:40:00',3.88),('9303','2013-06-12','14:45:00',3.62),('9303','2013-06-12','14:50:00',4.13),('9303','2013-06-12','14:55:00',4.11),('9303','2013-06-12','15:00:00',4),('9303','2013-06-12','15:05:00',3.95),('9303','2013-06-12','15:10:00',3.89),('9303','2013-06-12','15:15:00',3.44),('9303','2013-06-12','15:20:00',3.83),('9303','2013-06-12','15:25:00',3.66),('9303','2013-06-12','15:30:00',3.62),('9303','2013-06-12','15:35:00',3.63),('9303','2013-06-12','15:40:00',3.58),('9303','2013-06-12','15:45:00',3.52),('9303','2013-06-12','15:50:00',3.44),('9303','2013-06-12','15:55:00',3.47),('9303','2013-06-12','16:00:00',3.36),('9303','2013-06-12','16:05:00',3.21),('9303','2013-06-12','16:10:00',3.28),('9303','2013-06-12','16:15:00',3.21),('9303','2013-06-12','16:20:00',3.1),('9303','2013-06-12','16:25:00',3.08),('9303','2013-06-12','16:30:00',3.02),('9303','2013-06-12','16:35:00',2.93),('9303','2013-06-12','16:40:00',2.86),('9303','2013-06-12','16:45:00',2.78),('9303','2013-06-12','16:50:00',2.74),('9303','2013-06-12','16:55:00',2.47),('9303','2013-06-12','17:00:00',2.53),('9303','2013-06-12','17:05:00',2.5),('9303','2013-06-12','17:10:00',2.41),('9303','2013-06-12','17:15:00',2.28),('9303','2013-06-12','17:20:00',2.15),('9303','2013-06-12','17:25:00',2.01),('9303','2013-06-12','17:30:00',1.85),('9303','2013-06-12','17:35:00',1.78),('9303','2013-06-12','17:40:00',1.85),('9303','2013-06-12','17:45:00',1.35),('9303','2013-06-12','18:05:00',1.44),('9303','2013-06-12','18:10:00',1.33),('9303','2013-06-12','18:15:00',1.28),('9303','2013-06-12','18:20:00',1.17),('9303','2013-06-11','08:10:00',1.04),('9303','2013-06-11','08:15:00',1.85),('9303','2013-06-11','08:20:00',1.95),('9303','2013-06-11','08:25:00',1.96),('9303','2013-06-11','08:30:00',2.01),('9303','2013-06-11','08:35:00',1.99),('9303','2013-06-11','08:40:00',2.22),('9303','2013-06-11','08:45:00',2.2),('9303','2013-06-11','08:50:00',2.35),('9303','2013-06-11','08:55:00',2.47),('9303','2013-06-11','09:00:00',2.52),('9303','2013-06-11','09:05:00',2.61),('9303','2013-06-11','09:10:00',2.68),('9303','2013-06-11','09:15:00',2.76),('9303','2013-06-11','09:20:00',2.84),('9303','2013-06-11','09:25:00',3.02),('9303','2013-06-11','09:30:00',2.46),('9303','2013-06-11','09:35:00',1.75),('9303','2013-06-11','09:40:00',1.25),('9303','2013-06-11','09:45:00',1.46),('9303','2013-06-11','09:50:00',3.09),('9303','2013-06-11','09:55:00',2.99),('9303','2013-06-11','10:00:00',2.54),('9303','2013-06-11','10:05:00',3.06),('9303','2013-06-11','10:10:00',2.61),('9303','2013-06-11','10:15:00',3.46),('9303','2013-06-11','10:20:00',3.52),('9303','2013-06-11','10:25:00',2.59),('9303','2013-06-11','10:30:00',3.67),('9303','2013-06-11','10:35:00',2.38),('9303','2013-06-11','10:40:00',2.25),('9303','2013-06-11','10:45:00',2.61),('9303','2013-06-11','10:50:00',3.88),('9303','2013-06-11','10:55:00',3.91),('9303','2013-06-11','11:00:00',4.01),('9303','2013-06-11','11:05:00',3.95),('9303','2013-06-11','11:10:00',3.39),('9303','2013-06-11','11:15:00',4.18),('9303','2013-06-11','11:20:00',4),('9303','2013-06-11','11:25:00',3.07),('9303','2013-06-11','11:30:00',3.97),('9303','2013-06-11','11:35:00',4.02),('9303','2013-06-11','11:40:00',4.05),('9303','2013-06-11','11:45:00',4.09),('9303','2013-06-11','11:50:00',4.12),('9303','2013-06-11','11:55:00',4.15),('9303','2013-06-11','12:00:00',3.76),('9303','2013-06-11','12:05:00',3.64),('9303','2013-06-11','12:10:00',4.26),('9303','2013-06-11','12:15:00',4.19),('9303','2013-06-11','12:20:00',4.03),('9303','2013-06-11','12:25:00',4.28),('9303','2013-06-11','12:30:00',4.3),('9303','2013-06-11','12:35:00',4.29),('9303','2013-06-11','12:40:00',4.27),('9303','2013-06-11','12:45:00',4.28),('9303','2013-06-11','12:50:00',4.32),('9303','2013-06-11','12:55:00',4.35),('9303','2013-06-11','13:00:00',4.36),('9303','2013-06-11','13:05:00',4.35),('9303','2013-06-11','13:10:00',4.36),('9303','2013-06-11','13:15:00',4.38),('9303','2013-06-11','13:20:00',4.34),('9303','2013-06-11','13:25:00',4.34),('9303','2013-06-11','13:30:00',4.36),('9303','2013-06-11','13:35:00',4.36),('9303','2013-06-11','13:40:00',4.31),('9303','2013-06-11','13:45:00',4.39),('9303','2013-06-11','13:50:00',4.35),('9303','2013-06-11','13:55:00',4.22),('9303','2013-06-11','14:00:00',4.32),('9303','2013-06-11','14:05:00',4.26),('9303','2013-06-11','14:10:00',4.2),('9303','2013-06-11','14:15:00',4.17),('9303','2013-06-11','14:20:00',4.14),('9303','2013-06-11','14:25:00',4.1),('9303','2013-06-11','14:30:00',4.08),('9303','2013-06-11','14:35:00',4.06),('9303','2013-06-11','14:40:00',4.05),('9303','2013-06-11','14:45:00',4),('9303','2013-06-11','14:50:00',3.97),('9303','2013-06-11','14:55:00',3.95),('9303','2013-06-11','15:00:00',3.91),('9303','2013-06-11','15:05:00',3.85),('9303','2013-06-11','15:10:00',3.82),('9303','2013-06-11','15:15:00',3.77),('9303','2013-06-11','15:20:00',3.75),('9303','2013-06-11','15:25:00',3.67),('9303','2013-06-11','15:30:00',3.64),('9303','2013-06-11','15:35:00',3.62),('9303','2013-06-11','15:40:00',3.7),('9303','2013-06-11','15:45:00',2.57),('9303','2013-06-11','15:50:00',3.17),('9303','2013-06-11','15:55:00',3.25),('9303','2013-06-11','16:00:00',3.45),('9303','2013-06-11','16:05:00',3.36),('9303','2013-06-11','16:10:00',3.3),('9303','2013-06-11','16:15:00',3.22),('9303','2013-06-11','16:20:00',3.15),('9303','2013-06-11','16:25:00',3.08),('9303','2013-06-11','16:30:00',3.04),('9303','2013-06-11','16:35:00',3),('9303','2013-06-11','16:40:00',3.04),('9303','2013-06-11','16:45:00',3.15),('9303','2013-06-11','16:50:00',3.16),('9303','2013-06-11','16:55:00',3.03),('9303','2013-06-11','17:00:00',2.8),('9303','2013-06-11','17:05:00',2.01),('9303','2014-04-03','08:55:00',1.02),('9303','2014-04-03','09:00:00',1.13),('9303','2014-04-03','09:05:00',1.23),('9303','2014-04-03','09:10:00',1.2),('9303','2014-04-03','09:15:00',1.09),('9303','2014-04-03','09:20:00',1.09),('9303','2014-04-03','09:25:00',1.17),('9303','2014-04-03','09:30:00',1.32),('9303','2014-04-03','09:35:00',1.65),('9303','2014-04-03','09:40:00',1.77),('9303','2014-04-03','09:45:00',1.73),('9303','2014-04-03','09:50:00',1.65),('9303','2014-04-03','09:55:00',1.72),('9303','2014-04-03','10:00:00',2.11),('9303','2014-04-03','10:05:00',2.47),('9303','2014-04-03','10:10:00',2.63),('9303','2014-04-03','10:15:00',3.01),('9303','2014-04-03','10:20:00',3.08),('9303','2014-04-03','10:25:00',2.85),('9303','2014-04-03','10:30:00',2.52),('9303','2014-04-03','10:35:00',2.86),('9303','2014-04-03','10:40:00',2.2),('9303','2014-04-03','10:45:00',2.37),('9303','2014-04-03','10:50:00',2),('9303','2014-04-03','10:55:00',2.08),('9303','2014-04-03','11:00:00',1.94),('9303','2014-04-03','11:05:00',1.59),('9303','2014-04-03','11:10:00',1.53),('9303','2014-04-03','11:15:00',1.41),('9303','2014-04-03','11:20:00',1.34),('9303','2014-04-03','11:25:00',1.23),('9303','2014-04-03','11:30:00',1.21),('9303','2014-04-03','11:35:00',1.29),('9303','2014-04-03','11:40:00',1.43),('9303','2014-04-03','11:45:00',1.62),('9303','2014-04-03','11:50:00',1.99),('9303','2014-04-03','11:55:00',2.25),('9303','2014-04-03','12:00:00',2.14),('9303','2014-04-03','12:05:00',2.17),('9303','2014-04-03','12:10:00',2.09),('9303','2014-04-03','12:15:00',2.04),('9303','2014-04-03','12:20:00',2.25),('9303','2014-04-03','12:25:00',2.8),('9303','2014-04-03','12:30:00',3.68),('9303','2014-04-03','12:35:00',3.55),('9303','2014-04-03','12:40:00',3.94),('9303','2014-04-03','12:45:00',2.32),('9303','2014-04-03','12:50:00',2.55),('9303','2014-04-03','12:55:00',2.61),('9303','2014-04-03','13:00:00',2.41),('9303','2014-04-03','13:05:00',3),('9303','2014-04-03','13:10:00',2.17),('9303','2014-04-03','13:15:00',4.1),('9303','2014-04-03','13:20:00',2.82),('9303','2014-04-03','13:25:00',2.69),('9303','2014-04-03','13:30:00',2.71),('9303','2014-04-03','13:35:00',4.44),('9303','2014-04-03','13:40:00',4.05),('9303','2014-04-03','13:45:00',2.15),('9303','2014-04-03','13:50:00',2.05),('9303','2014-04-03','13:55:00',2.36),('9303','2014-04-03','14:00:00',3.59),('9303','2014-04-03','14:05:00',3.56),('9303','2014-04-03','14:10:00',2.74),('9303','2014-04-03','14:15:00',3.37),('9303','2014-04-03','14:20:00',3.66),('9303','2014-04-03','14:25:00',3.73),('9303','2014-04-03','14:30:00',3.75),('9303','2014-04-03','14:35:00',3.87),('9303','2014-04-03','14:40:00',3.75),('9303','2014-04-03','14:45:00',3.65),('9303','2014-04-03','14:50:00',3.59),('9303','2014-04-03','14:55:00',3.53),('9303','2014-04-03','15:00:00',3.48),('9303','2014-04-03','15:05:00',3.48),('9303','2014-04-03','15:10:00',3.4),('9303','2014-04-03','15:15:00',3.38),('9303','2014-04-03','15:20:00',3.39),('9303','2014-04-03','15:25:00',3.37),('9303','2014-04-03','15:30:00',3.33),('9303','2014-04-03','15:35:00',3.28),('9303','2014-04-03','15:40:00',3.21),('9303','2014-04-03','15:45:00',3.16),('9303','2014-04-03','15:50:00',3.12),('9303','2014-04-03','15:55:00',3.09),('9303','2014-04-03','16:00:00',3.08),('9303','2014-04-03','16:05:00',2.97),('9303','2014-04-03','16:10:00',2.97),('9303','2014-04-03','16:15:00',2.85),('9303','2014-04-03','16:20:00',2.8),('9303','2014-04-03','16:25:00',2.69),('9303','2014-04-03','16:30:00',2.61),('9303','2014-04-03','16:35:00',2.56),('9303','2014-04-03','16:40:00',2.45),('9303','2014-04-03','16:45:00',2.2),('9303','2014-04-03','16:50:00',1.7),('9303','2014-04-03','16:55:00',1.39),('9303','2014-04-03','17:50:00',1.17),('9303','2014-04-03','17:55:00',1.01),('9303','2013-06-10','07:35:00',1.31),('9303','2013-06-10','08:05:00',1.35),('9303','2013-06-10','08:10:00',1.71),('9303','2013-06-10','08:15:00',1.66),('9303','2013-06-10','08:20:00',1.77),('9303','2013-06-10','08:25:00',1.12),('9303','2013-06-10','08:30:00',1.17),('9303','2013-06-10','09:00:00',1.12),('9303','2013-06-10','09:10:00',1.47),('9303','2013-06-10','09:20:00',1.79),('9303','2013-06-10','09:25:00',2.06),('9303','2013-06-10','09:30:00',2.25),('9303','2013-06-10','09:35:00',3.08),('9303','2013-06-10','09:40:00',2.22),('9303','2013-06-10','09:45:00',3.56),('9303','2013-06-10','09:50:00',1.9),('9303','2013-06-10','09:55:00',1.66),('9303','2013-06-10','10:00:00',2.01),('9303','2013-06-10','10:05:00',2.38),('9303','2013-06-10','10:10:00',2.87),('9303','2013-06-10','10:15:00',2.75),('9303','2013-06-10','10:20:00',1.73),('9303','2013-06-10','10:25:00',1.46),('9303','2013-06-10','10:30:00',1.59),('9303','2013-06-10','10:35:00',1.54),('9303','2013-06-10','10:40:00',1.59),('9303','2013-06-10','10:45:00',1.16),('9303','2013-06-10','10:50:00',2),('9303','2013-06-10','10:55:00',2.53),('9303','2013-06-10','11:00:00',3.4),('9303','2013-06-10','11:05:00',2.77),('9303','2013-06-10','11:10:00',2.12),('9303','2013-06-10','11:15:00',3.88),('9303','2013-06-10','11:20:00',4.07),('9303','2013-06-10','11:25:00',4.26),('9303','2013-06-10','11:30:00',4.06),('9303','2013-06-10','11:35:00',4.28),('9303','2013-06-10','11:40:00',2.32),('9303','2013-06-10','11:45:00',3.23),('9303','2013-06-10','11:50:00',2.36),('9303','2013-06-10','11:55:00',3.45),('9303','2013-06-10','12:00:00',4.51),('9303','2013-06-10','12:05:00',1.36),('9303','2013-06-10','12:10:00',2.46),('9303','2013-06-10','12:15:00',2.89),('9303','2013-06-10','12:20:00',3.45),('9303','2013-06-10','12:25:00',4.64),('9303','2013-06-10','12:30:00',4.6),('9303','2013-06-10','12:35:00',4.26),('9303','2013-06-10','12:40:00',4.2),('9303','2013-06-10','12:45:00',4.2),('9303','2013-06-10','12:50:00',2.58),('9303','2013-06-10','12:55:00',3.64),('9303','2013-06-10','13:00:00',4.95),('9303','2013-06-10','13:05:00',3.68),('9303','2013-06-10','13:10:00',3.64),('9303','2013-06-10','13:15:00',3.16),('9303','2013-06-10','13:20:00',1.61),('9303','2013-06-10','13:25:00',2.27),('9303','2013-06-10','13:30:00',1.7),('9303','2013-06-10','13:35:00',3.81),('9303','2013-06-10','13:40:00',3.87),('9303','2013-06-10','13:45:00',4.78),('9303','2013-06-10','13:50:00',4.86),('9303','2013-06-10','13:55:00',3.79),('9303','2013-06-10','14:00:00',4.47),('9303','2013-06-10','14:05:00',4.42),('9303','2013-06-10','14:10:00',4.31),('9303','2013-06-10','14:15:00',4.33),('9303','2013-06-10','14:20:00',3.74),('9303','2013-06-10','14:25:00',4.06),('9303','2013-06-10','14:30:00',4.12),('9303','2013-06-10','14:35:00',4.11),('9303','2013-06-10','14:40:00',4.08),('9303','2013-06-10','14:45:00',4.09),('9303','2013-06-10','14:50:00',4.02),('9303','2013-06-10','14:55:00',3.97),('9303','2013-06-10','15:00:00',3.92),('9303','2013-06-10','15:05:00',3.89),('9303','2013-06-10','15:10:00',3.86),('9303','2013-06-10','15:15:00',3.84),('9303','2013-06-10','15:20:00',3.83),('9303','2013-06-10','15:25:00',3.75),('9303','2013-06-10','15:30:00',3.69),('9303','2013-06-10','15:35:00',3.7),('9303','2013-06-10','15:40:00',3.68),('9303','2013-06-10','15:45:00',3.62),('9303','2013-06-10','15:50:00',3.54),('9303','2013-06-10','15:55:00',3.51),('9303','2013-06-10','16:00:00',3.45),('9303','2013-06-10','16:05:00',3.38),('9303','2013-06-10','16:10:00',3.31),('9303','2013-06-10','16:15:00',3.26),('9303','2013-06-10','16:20:00',3.2),('9303','2013-06-10','16:25:00',3.12),('9303','2013-06-10','16:30:00',3.08),('9303','2013-06-10','16:35:00',3.02),('9303','2013-06-10','16:40:00',2.93),('9303','2013-06-10','16:45:00',2.85),('9303','2013-06-10','16:50:00',2.8),('9303','2013-06-10','16:55:00',2.74),('9303','2013-06-10','17:00:00',2.67),('9303','2013-06-10','17:05:00',2.57),('9303','2013-06-10','17:10:00',2.48),('9303','2013-06-10','17:15:00',2.37),('9303','2013-06-10','17:20:00',2.26),('9303','2013-06-10','17:25:00',2.13),('9303','2013-06-10','17:30:00',2.03),('9303','2013-06-10','17:35:00',1.97),('9303','2013-06-10','17:40:00',1.89),('9303','2013-06-10','17:45:00',1.81),('9303','2013-06-10','17:50:00',1.74),('9303','2013-06-10','17:55:00',1.64),('9303','2013-06-10','18:00:00',1.55),('9303','2013-06-10','18:05:00',1.42),('9303','2013-06-10','18:10:00',1.32),('9303','2013-06-10','18:15:00',1.21),('9303','2013-06-10','18:20:00',1.1),('9303','2013-06-09','07:35:00',1.07),('9303','2013-06-09','07:55:00',1.3),('9303','2013-06-09','08:00:00',1.36),('9303','2013-06-09','08:05:00',1.45),('9303','2013-06-09','08:10:00',1.45),('9303','2013-06-09','08:15:00',1.66),('9303','2013-06-09','08:20:00',1.64),('9303','2013-06-09','08:25:00',1.76),('9303','2013-06-09','08:30:00',1.81),('9303','2013-06-09','08:35:00',1.89),('9303','2013-06-09','08:40:00',1.95),('9303','2013-06-09','08:45:00',1.99),('9303','2013-06-09','08:50:00',2.11),('9303','2013-06-09','08:55:00',2.17),('9303','2013-06-09','09:00:00',2.26),('9303','2013-06-09','09:05:00',2.36),('9303','2013-06-09','09:10:00',2.41),('9303','2013-06-09','09:15:00',2.49),('9303','2013-06-09','09:20:00',2.58),('9303','2013-06-09','09:25:00',2.61),('9303','2013-06-09','09:30:00',2.64),('9303','2013-06-09','09:35:00',2.72),('9303','2013-06-09','09:40:00',2.82),('9303','2013-06-09','09:45:00',2.88),('9303','2013-06-09','09:50:00',2.93),('9303','2013-06-09','09:55:00',2.94),('9303','2013-06-09','10:00:00',2.98),('9303','2013-06-09','10:05:00',3.05),('9303','2013-06-09','10:10:00',3.07),('9303','2013-06-09','10:15:00',3.13),('9303','2013-06-09','10:20:00',3.2),('9303','2013-06-09','10:25:00',3.23),('9303','2013-06-09','10:30:00',3.24),('9303','2013-06-09','10:35:00',3.37),('9303','2013-06-09','10:40:00',3.37),('9303','2013-06-09','10:45:00',3.39),('9303','2013-06-09','10:50:00',3.45),('9303','2013-06-09','10:55:00',3.47),('9303','2013-06-09','11:00:00',3.52),('9303','2013-06-09','11:05:00',3.57),('9303','2013-06-09','11:10:00',3.58),('9303','2013-06-09','11:15:00',3.55),('9303','2013-06-09','11:20:00',3.62),('9303','2013-06-09','11:25:00',3.66),('9303','2013-06-09','11:30:00',3.68),('9303','2013-06-09','11:35:00',3.67),('9303','2013-06-09','11:40:00',3.69),('9303','2013-06-09','11:45:00',3.77),('9303','2013-06-09','11:50:00',3.83),('9303','2013-06-09','11:55:00',3.83),('9303','2013-06-09','12:00:00',3.82),('9303','2013-06-09','12:05:00',3.85),('9303','2013-06-09','12:10:00',3.7),('9303','2013-06-09','12:15:00',3.63),('9303','2013-06-09','12:20:00',3.89),('9303','2013-06-09','12:25:00',3.89),('9303','2013-06-09','12:30:00',3.94),('9303','2013-06-09','12:35:00',3.94),('9303','2013-06-09','12:40:00',3.96),('9303','2013-06-09','12:45:00',3.86),('9303','2013-06-09','12:50:00',3.36),('9303','2013-06-09','12:55:00',3.55),('9303','2013-06-09','13:00:00',3.86),('9303','2013-06-09','13:05:00',3.48),('9303','2013-06-09','13:10:00',4.37),('9303','2013-06-09','13:15:00',3.35),('9303','2013-06-09','13:20:00',3.81),('9303','2013-06-09','13:25:00',4.38),('9303','2013-06-09','13:30:00',4.22),('9303','2013-06-09','13:35:00',4.16),('9303','2013-06-09','13:40:00',4.24),('9303','2013-06-09','13:45:00',4.29),('9303','2013-06-09','13:50:00',4.46),('9303','2013-06-09','13:55:00',4.01),('9303','2013-06-09','14:00:00',4.39),('9303','2013-06-09','14:05:00',4.22),('9303','2013-06-09','14:10:00',4.33),('9303','2013-06-09','14:15:00',2.86),('9303','2013-06-09','14:20:00',2.02),('9303','2013-06-09','14:25:00',1.09),('9303','2013-06-09','14:30:00',1.28),('9303','2013-06-09','14:35:00',3.34),('9303','2013-06-09','14:40:00',3.65),('9303','2013-06-09','14:45:00',3.61),('9303','2013-06-09','14:50:00',3.8),('9303','2013-06-09','14:55:00',3.89),('9303','2013-06-09','15:00:00',3.84),('9303','2013-06-09','15:05:00',3.68),('9303','2013-06-09','15:10:00',3.71),('9303','2013-06-09','15:15:00',3.58),('9303','2013-06-09','15:20:00',3.57),('9303','2013-06-09','15:25:00',3.6),('9303','2013-06-09','15:30:00',3.45),('9303','2013-06-09','15:35:00',3.58),('9303','2013-06-09','15:40:00',2.83),('9303','2013-06-09','15:45:00',2.84),('9303','2013-06-09','15:50:00',3.12),('9303','2013-06-09','15:55:00',3.48),('9303','2013-06-09','16:00:00',2.39),('9303','2013-06-09','16:05:00',3.01),('9303','2013-06-09','16:10:00',3.09),('9303','2013-06-09','16:15:00',1.72),('9303','2013-06-09','16:20:00',1.39),('9303','2013-06-09','16:25:00',2.12),('9303','2013-06-09','16:30:00',1.33),('9303','2013-06-09','18:10:00',1.01),('9303','2013-06-08','07:45:00',1.07),('9303','2013-06-08','07:50:00',1.15),('9303','2013-06-08','07:55:00',1.22),('9303','2013-06-08','08:00:00',1.3),('9303','2013-06-08','08:05:00',1.39),('9303','2013-06-08','08:10:00',1.48),('9303','2013-06-08','08:15:00',1.58),('9303','2013-06-08','08:20:00',1.66),('9303','2013-06-08','08:25:00',1.73),('9303','2013-06-08','08:30:00',1.82),('9303','2013-06-08','08:35:00',1.9),('9303','2013-06-08','08:40:00',1.97),('9303','2013-06-08','08:45:00',2.06),('9303','2013-06-08','08:50:00',2.13),('9303','2013-06-08','08:55:00',2.19),('9303','2013-06-08','09:00:00',2.29),('9303','2013-06-08','09:05:00',2.38),('9303','2013-06-08','09:10:00',2.47),('9303','2013-06-08','09:15:00',2.54),('9303','2013-06-08','09:20:00',2.55),('9303','2013-06-08','09:25:00',2.6),('9303','2013-06-08','09:30:00',2.69),('9303','2013-06-08','09:35:00',2.78),('9303','2013-06-08','09:40:00',2.83),('9303','2013-06-08','09:45:00',2.85),('9303','2013-06-08','09:50:00',2.88),('9303','2013-06-08','09:55:00',2.93),('9303','2013-06-08','10:00:00',3.01),('9303','2013-06-08','10:05:00',3.15),('9303','2013-06-08','10:10:00',3.24),('9303','2013-06-08','10:15:00',3.29),('9303','2013-06-08','10:20:00',3.28),('9303','2013-06-08','10:25:00',3.28),('9303','2013-06-08','10:30:00',3.33),('9303','2013-06-08','10:35:00',3.33),('9303','2013-06-08','10:40:00',3.04),('9303','2013-06-08','10:45:00',2.91),('9303','2013-06-08','10:50:00',3.42),('9303','2013-06-08','10:55:00',3.67),('9303','2013-06-08','11:00:00',3.27),('9303','2013-06-08','11:05:00',2.13),('9303','2013-06-08','11:10:00',4.04),('9303','2013-06-08','11:15:00',4.18),('9303','2013-06-08','11:20:00',4.17),('9303','2013-06-08','11:25:00',4.21),('9303','2013-06-08','11:30:00',2.34),('9303','2013-06-08','11:35:00',3.57),('9303','2013-06-08','11:40:00',4.12),('9303','2013-06-08','11:45:00',4.08),('9303','2013-06-08','11:50:00',4.19),('9303','2013-06-08','11:55:00',2.74),('9303','2013-06-08','12:00:00',1.92),('9303','2013-06-08','12:05:00',2.09),('9303','2013-06-08','12:15:00',4.04),('9303','2013-06-08','12:20:00',2.94),('9303','2013-06-08','12:25:00',2.56),('9303','2013-06-08','12:30:00',3.66),('9303','2013-06-08','12:35:00',3.91),('9303','2013-06-08','12:40:00',4.15),('9303','2013-06-08','12:45:00',4.26),('9303','2013-06-08','12:50:00',4.24),('9303','2013-06-08','12:55:00',3.55),('9303','2013-06-08','13:00:00',2.56),('9303','2013-06-08','13:05:00',4.31),('9303','2013-06-08','13:10:00',4.39),('9303','2013-06-08','13:15:00',4.39),('9303','2013-06-08','13:20:00',4.15),('9303','2013-06-08','13:25:00',4.26),('9303','2013-06-08','13:30:00',4.45),('9303','2013-06-08','13:35:00',4.33),('9303','2013-06-08','13:40:00',4.29),('9303','2013-06-08','13:45:00',4.18),('9303','2013-06-08','13:50:00',4.22),('9303','2013-06-08','13:55:00',4.19),('9303','2013-06-08','14:00:00',4.13),('9303','2013-06-08','14:05:00',4.13),('9303','2013-06-08','14:10:00',4.15),('9303','2013-06-08','14:15:00',4.11),('9303','2013-06-08','14:20:00',4.06),('9303','2013-06-08','14:25:00',4.06),('9303','2013-06-08','14:30:00',4.02),('9303','2013-06-08','14:35:00',3.97),('9303','2013-06-08','14:40:00',4),('9303','2013-06-08','14:45:00',3.96),('9303','2013-06-08','14:50:00',3.98),('9303','2013-06-08','14:55:00',3.89),('9303','2013-06-08','15:00:00',3.91),('9303','2013-06-08','15:05:00',3.77),('9303','2013-06-08','15:10:00',3.5),('9303','2013-06-08','15:15:00',3.65),('9303','2013-06-08','15:20:00',3.76),('9303','2013-06-08','15:25:00',3.51),('9303','2013-06-08','15:30:00',3.6),('9303','2013-06-08','15:35:00',3.73),('9303','2013-06-08','15:40:00',3.62),('9303','2013-06-08','15:45:00',3.34),('9303','2013-06-08','15:50:00',3.5),('9303','2013-06-08','15:55:00',3.34),('9303','2013-06-08','16:00:00',3.41),('9303','2013-06-08','16:05:00',3.37),('9303','2013-06-08','16:10:00',3.3),('9303','2013-06-08','16:15:00',3.38),('9303','2013-06-08','16:20:00',3.26),('9303','2013-06-08','16:25:00',3.13),('9303','2013-06-08','16:30:00',2.97),('9303','2013-06-08','16:35:00',2.87),('9303','2013-06-08','16:40:00',2.81),('9303','2013-06-08','16:45:00',2.77),('9303','2013-06-08','16:50:00',2.35),('9303','2013-06-08','16:55:00',2.43),('9303','2013-06-08','17:00:00',2.55),('9303','2013-06-08','17:05:00',1.95),('9303','2013-06-08','17:10:00',2.64),('9303','2013-06-08','17:15:00',2.55),('9303','2013-06-08','17:20:00',2.37),('9303','2013-06-08','17:25:00',2.15),('9303','2013-06-08','17:30:00',1.32),('9303','2013-06-08','17:40:00',1.64),('9303','2013-06-08','17:45:00',1.82),('9303','2013-06-08','17:50:00',1.63),('9303','2013-06-08','17:55:00',1.73),('9303','2013-06-08','18:00:00',1.34),('9303','2013-06-08','18:05:00',1.24),('9303','2013-06-07','07:40:00',1.03),('9303','2013-06-07','07:45:00',1.12),('9303','2013-06-07','07:50:00',1.22),('9303','2013-06-07','07:55:00',1.31),('9303','2013-06-07','08:00:00',1.39),('9303','2013-06-07','08:05:00',1.46),('9303','2013-06-07','08:10:00',1.59),('9303','2013-06-07','08:15:00',1.68),('9303','2013-06-07','08:20:00',1.77),('9303','2013-06-07','08:25:00',1.85),('9303','2013-06-07','08:30:00',1.94),('9303','2013-06-07','08:35:00',2.01),('9303','2013-06-07','08:40:00',2.11),('9303','2013-06-07','08:45:00',2.19),('9303','2013-06-07','08:50:00',2.27),('9303','2013-06-07','08:55:00',2.35),('9303','2013-06-07','09:00:00',2.43),('9303','2013-06-07','09:05:00',2.53),('9303','2013-06-07','09:10:00',2.61),('9303','2013-06-07','09:15:00',2.68),('9303','2013-06-07','09:20:00',2.74),('9303','2013-06-07','09:25:00',2.82),('9303','2013-06-07','09:30:00',2.89),('9303','2013-06-07','09:35:00',2.95),('9303','2013-06-07','09:40:00',3.04),('9303','2013-06-07','09:45:00',3.11),('9303','2013-06-07','09:50:00',3.17),('9303','2013-06-07','09:55:00',3.23),('9303','2013-06-07','10:00:00',3.26),('9303','2013-06-07','10:05:00',3.3),('9303','2013-06-07','10:10:00',3.37),('9303','2013-06-07','10:15:00',3.44),('9303','2013-06-07','10:20:00',3.49),('9303','2013-06-07','10:25:00',3.54),('9303','2013-06-07','10:30:00',3.57),('9303','2013-06-07','10:35:00',3.59),('9303','2013-06-07','10:40:00',3.66),('9303','2013-06-07','10:45:00',3.69),('9303','2013-06-07','10:50:00',3.73),('9303','2013-06-07','10:55:00',3.76),('9303','2013-06-07','11:00:00',3.8),('9303','2013-06-07','11:05:00',3.83),('9303','2013-06-07','11:10:00',3.88),('9303','2013-06-07','11:15:00',3.9),('9303','2013-06-07','11:20:00',3.96),('9303','2013-06-07','11:25:00',3.99),('9303','2013-06-07','11:30:00',4),('9303','2013-06-07','11:35:00',4.03),('9303','2013-06-07','11:40:00',4.07),('9303','2013-06-07','11:45:00',4.08),('9303','2013-06-07','11:50:00',4.07),('9303','2013-06-07','11:55:00',4.11),('9303','2013-06-07','12:00:00',4.15),('9303','2013-06-07','12:05:00',4.16),('9303','2013-06-07','12:10:00',4.17),('9303','2013-06-07','12:15:00',4.2),('9303','2013-06-07','12:20:00',4.19),('9303','2013-06-07','12:25:00',4.22),('9303','2013-06-07','12:30:00',4.25),('9303','2013-06-07','12:35:00',4.27),('9303','2013-06-07','12:40:00',4.28),('9303','2013-06-07','12:45:00',4.24),('9303','2013-06-07','12:50:00',4.23),('9303','2013-06-07','12:55:00',4.21),('9303','2013-06-07','13:00:00',4.21),('9303','2013-06-07','13:05:00',4.21),('9303','2013-06-07','13:10:00',4.19),('9303','2013-06-07','13:15:00',4.17),('9303','2013-06-07','13:20:00',4.19),('9303','2013-06-07','13:25:00',4.17),('9303','2013-06-07','13:30:00',4.19),('9303','2013-06-07','13:35:00',4.15),('9303','2013-06-07','13:40:00',4.11),('9303','2013-06-07','13:45:00',4.09),('9303','2013-06-07','13:50:00',4.1),('9303','2013-06-07','13:55:00',4.07),('9303','2013-06-07','14:00:00',4.07),('9303','2013-06-07','14:05:00',4.05),('9303','2013-06-07','14:10:00',3.99),('9303','2013-06-07','14:15:00',3.95),('9303','2013-06-07','14:20:00',3.92),('9303','2013-06-07','14:25:00',3.92),('9303','2013-06-07','14:30:00',3.95),('9303','2013-06-07','14:35:00',3.96),('9303','2013-06-07','14:40:00',3.94),('9303','2013-06-07','14:45:00',3.91),('9303','2013-06-07','14:50:00',3.88),('9303','2013-06-07','14:55:00',3.8),('9303','2013-06-07','15:00:00',3.78),('9303','2013-06-07','15:05:00',3.78),('9303','2013-06-07','15:10:00',3.77),('9303','2013-06-07','15:15:00',3.7),('9303','2013-06-07','15:20:00',3.6),('9303','2013-06-07','15:25:00',3.62),('9303','2013-06-07','15:30:00',3.62),('9303','2013-06-07','15:35:00',3.59),('9303','2013-06-07','15:40:00',3.5),('9303','2013-06-07','15:45:00',3.45),('9303','2013-06-07','15:50:00',3.41),('9303','2013-06-07','15:55:00',3.37),('9303','2013-06-07','16:00:00',3.32),('9303','2013-06-07','16:05:00',3.25),('9303','2013-06-07','16:10:00',3.16),('9303','2013-06-07','16:15:00',3.01),('9303','2013-06-07','16:20:00',2.99),('9303','2013-06-07','16:25:00',2.97),('9303','2013-06-07','16:30:00',2.89),('9303','2013-06-07','16:35:00',2.86),('9303','2013-06-07','16:40:00',2.82),('9303','2013-06-07','16:45:00',2.77),('9303','2013-06-07','16:50:00',2.67),('9303','2013-06-07','16:55:00',2.63),('9303','2013-06-07','17:00:00',2.56),('9303','2013-06-07','17:05:00',2.46),('9303','2013-06-07','17:10:00',2.35),('9303','2013-06-07','17:15:00',2.22),('9303','2013-06-07','17:20:00',2.1),('9303','2013-06-07','17:25:00',2.01),('9303','2013-06-07','17:30:00',1.87),('9303','2013-06-07','17:35:00',1.84),('9303','2013-06-07','17:40:00',1.85),('9303','2013-06-07','17:45:00',1.82),('9303','2013-06-07','17:50:00',1.73),('9303','2013-06-07','17:55:00',1.62),('9303','2013-06-07','18:00:00',1.49),('9303','2013-06-07','18:05:00',1.37),('9303','2013-06-07','18:10:00',1.26),('9303','2013-06-07','18:15:00',1.15),('9303','2013-06-07','18:20:00',1.04),('9303','2013-06-06','07:50:00',1.11),('9303','2013-06-06','07:55:00',1.37),('9303','2013-06-06','08:00:00',1.52),('9303','2013-06-06','08:05:00',1.19),('9303','2013-06-06','08:10:00',1.39),('9303','2013-06-06','08:15:00',1.28),('9303','2013-06-06','08:20:00',1.54),('9303','2013-06-06','08:25:00',1.85),('9303','2013-06-06','08:30:00',1.9),('9303','2013-06-06','08:35:00',1.96),('9303','2013-06-06','08:40:00',2.02),('9303','2013-06-06','08:45:00',2.08),('9303','2013-06-06','08:50:00',2.19),('9303','2013-06-06','08:55:00',2.27),('9303','2013-06-06','09:00:00',2.38),('9303','2013-06-06','09:05:00',2.46),('9303','2013-06-06','09:10:00',2.52),('9303','2013-06-06','09:15:00',2.58),('9303','2013-06-06','09:20:00',2.67),('9303','2013-06-06','09:25:00',2.73),('9303','2013-06-06','09:30:00',2.81),('9303','2013-06-06','09:35:00',2.89),('9303','2013-06-06','09:40:00',2.95),('9303','2013-06-06','09:45:00',3),('9303','2013-06-06','09:50:00',3.02),('9303','2013-06-06','09:55:00',3.06),('9303','2013-06-06','10:00:00',3.13),('9303','2013-06-06','10:05:00',3.21),('9303','2013-06-06','10:10:00',3.31),('9303','2013-06-06','10:15:00',3.34),('9303','2013-06-06','10:20:00',3.37),('9303','2013-06-06','10:25:00',3.4),('9303','2013-06-06','10:30:00',3.5),('9303','2013-06-06','10:35:00',3.5),('9303','2013-06-06','10:40:00',3.53),('9303','2013-06-06','10:45:00',3.64),('9303','2013-06-06','10:50:00',3.6),('9303','2013-06-06','10:55:00',3.62),('9303','2013-06-06','11:00:00',3.69),('9303','2013-06-06','11:05:00',3.75),('9303','2013-06-06','11:10:00',3.75),('9303','2013-06-06','11:15:00',3.81),('9303','2013-06-06','11:20:00',3.85),('9303','2013-06-06','11:25:00',3.87),('9303','2013-06-06','11:30:00',3.83),('9303','2013-06-06','11:35:00',3.88),('9303','2013-06-06','11:40:00',3.97),('9303','2013-06-06','11:45:00',4.02),('9303','2013-06-06','11:50:00',3.97),('9303','2013-06-06','11:55:00',4),('9303','2013-06-06','12:00:00',3.69),('9303','2013-06-06','12:05:00',3.76),('9303','2013-06-06','12:10:00',4.05),('9303','2013-06-06','12:15:00',4.02),('9303','2013-06-06','12:20:00',4.04),('9303','2013-06-06','12:25:00',4.07),('9303','2013-06-06','12:30:00',4.13),('9303','2013-06-06','12:35:00',4.13),('9303','2013-06-06','12:40:00',4.12),('9303','2013-06-06','12:45:00',4.12),('9303','2013-06-06','12:50:00',4.13),('9303','2013-06-06','12:55:00',4.14),('9303','2013-06-06','13:00:00',4.18),('9303','2013-06-06','13:05:00',4.16),('9303','2013-06-06','13:10:00',4.18),('9303','2013-06-06','13:15:00',4.18),('9303','2013-06-06','13:20:00',4.19),('9303','2013-06-06','13:25:00',4.15),('9303','2013-06-06','13:30:00',4.16),('9303','2013-06-06','13:35:00',4.1),('9303','2013-06-06','13:40:00',4.15),('9303','2013-06-06','13:45:00',3.46),('9303','2013-06-06','13:50:00',2.8),('9303','2013-06-06','13:55:00',3.49),('9303','2013-06-06','14:00:00',4.16),('9303','2013-06-06','14:05:00',4.29),('9303','2013-06-06','14:10:00',4.31),('9303','2013-06-06','14:15:00',4.21),('9303','2013-06-06','14:20:00',4.3),('9303','2013-06-06','14:25:00',3.17),('9303','2013-06-06','14:30:00',4.24),('9303','2013-06-06','14:35:00',4.04),('9303','2013-06-06','14:40:00',3.6),('9303','2013-06-06','14:45:00',3.3),('9303','2013-06-06','14:50:00',4),('9303','2013-06-06','14:55:00',4.12),('9303','2013-06-06','15:00:00',3.96),('9303','2013-06-06','15:05:00',3.94),('9303','2013-06-06','15:10:00',3.84),('9303','2013-06-06','15:15:00',3.67),('9303','2013-06-06','15:20:00',3.76),('9303','2013-06-06','15:25:00',3.61),('9303','2013-06-06','15:30:00',3.52),('9303','2013-06-06','15:35:00',3.55),('9303','2013-06-06','15:40:00',3.48),('9303','2013-06-06','15:45:00',3.44),('9303','2013-06-06','15:50:00',3.38),('9303','2013-06-06','15:55:00',3.24),('9303','2013-06-06','16:00:00',3.15),('9303','2013-06-06','16:05:00',3.24),('9303','2013-06-06','16:10:00',3.1),('9303','2013-06-06','16:15:00',2.97),('9303','2013-06-06','16:20:00',2.9),('9303','2013-06-06','16:25:00',2.93),('9303','2013-06-06','16:30:00',2.92),('9303','2013-06-06','16:35:00',2.9),('9303','2013-06-06','16:40:00',2.82),('9303','2013-06-06','16:45:00',2.68),('9303','2013-06-06','16:50:00',2.61),('9303','2013-06-06','16:55:00',2.53),('9303','2013-06-06','17:00:00',2.44),('9303','2013-06-06','17:05:00',2.36),('9303','2013-06-06','17:10:00',2.26),('9303','2013-06-06','17:15:00',2.13),('9303','2013-06-06','17:20:00',2.06),('9303','2013-06-06','17:25:00',1.95),('9303','2013-06-06','17:30:00',1.82),('9303','2013-06-06','17:35:00',1.81),('9303','2013-06-06','17:40:00',1.73),('9303','2013-06-06','17:45:00',1.64),('9303','2013-06-06','17:50:00',1.56),('9303','2013-06-06','17:55:00',1.46),('9303','2013-06-06','18:00:00',1.39),('9303','2013-06-06','18:05:00',1.28),('9303','2013-06-06','18:10:00',1.19),('9303','2013-06-06','18:15:00',1.08),('9303','2013-06-05','07:50:00',1.16),('9303','2013-06-05','07:55:00',1.47),('9303','2013-06-05','08:00:00',1.1),('9303','2013-06-05','08:10:00',1.23),('9303','2013-06-05','08:15:00',1.52),('9303','2013-06-05','08:20:00',1.72),('9303','2013-06-05','08:25:00',1.82),('9303','2013-06-05','08:30:00',1.89),('9303','2013-06-05','08:35:00',1.97),('9303','2013-06-05','08:40:00',2.07),('9303','2013-06-05','08:45:00',2.14),('9303','2013-06-05','08:50:00',2.17),('9303','2013-06-05','08:55:00',2.26),('9303','2013-06-05','09:00:00',2.4),('9303','2013-06-05','09:05:00',2.02),('9303','2013-06-05','09:10:00',2.45),('9303','2013-06-05','09:15:00',2.73),('9303','2013-06-05','09:20:00',2.95),('9303','2013-06-05','09:25:00',2.84),('9303','2013-06-05','09:30:00',2.94),('9303','2013-06-05','09:35:00',3.19),('9303','2013-06-05','09:40:00',3.46),('9303','2013-06-05','09:45:00',3.1),('9303','2013-06-05','09:50:00',2.38),('9303','2013-06-05','09:55:00',1.19),('9303','2013-06-05','10:00:00',3.04),('9303','2013-06-05','10:05:00',2.88),('9303','2013-06-05','10:10:00',1.28),('9303','2013-06-05','10:15:00',1.26),('9303','2013-06-05','10:20:00',1.71),('9303','2013-06-05','10:25:00',3.18),('9303','2013-06-05','10:30:00',1.93),('9303','2013-06-05','10:35:00',1.96),('9303','2013-06-05','10:40:00',3.17),('9303','2013-06-05','10:45:00',3.52),('9303','2013-06-05','10:50:00',3.87),('9303','2013-06-05','10:55:00',3.89),('9303','2013-06-05','11:00:00',3.98),('9303','2013-06-05','11:05:00',4.14),('9303','2013-06-05','11:10:00',1.26),('9303','2013-06-05','11:15:00',1.23),('9303','2013-06-05','11:20:00',1.23),('9303','2013-06-05','11:25:00',1.02),('9303','2013-06-05','11:30:00',1.13),('9303','2013-06-05','11:35:00',2.2),('9303','2013-06-05','11:40:00',4.4),('9303','2013-06-05','11:45:00',4.29),('9303','2013-06-05','11:50:00',2.09),('9303','2013-06-05','11:55:00',3.42),('9303','2013-06-05','12:00:00',1.42),('9303','2013-06-05','12:05:00',3.72),('9303','2013-06-05','12:10:00',4.71),('9303','2013-06-05','12:15:00',4.72),('9303','2013-06-05','12:20:00',4.81),('9303','2013-06-05','12:25:00',4.71),('9303','2013-06-05','12:30:00',4.82),('9303','2013-06-05','12:35:00',4.54),('9303','2013-06-05','12:40:00',4.91),('9303','2013-06-05','12:45:00',4.91),('9303','2013-06-05','12:50:00',2.45),('9303','2013-06-05','12:55:00',1.53),('9303','2013-06-05','13:00:00',2.17),('9303','2013-06-05','13:05:00',3.17),('9303','2013-06-05','13:10:00',2.46),('9303','2013-06-05','13:15:00',3.37),('9303','2013-06-05','13:20:00',3.03),('9303','2013-06-05','13:25:00',3.84),('9303','2013-06-05','13:30:00',1.91),('9303','2013-06-05','13:35:00',4.44),('9303','2013-06-05','13:40:00',4.7),('9303','2013-06-05','13:45:00',4.54),('9303','2013-06-05','13:50:00',4.4),('9303','2013-06-05','13:55:00',4.36),('9303','2013-06-05','14:00:00',4.32),('9303','2013-06-05','14:05:00',4.29),('9303','2013-06-05','14:10:00',4.25),('9303','2013-06-05','14:15:00',4.23),('9303','2013-06-05','14:20:00',4.23),('9303','2013-06-05','14:25:00',4.13),('9303','2013-06-05','14:30:00',4.14),('9303','2013-06-05','14:35:00',3.93),('9303','2013-06-05','14:40:00',4.08),('9303','2013-06-05','14:45:00',4.09),('9303','2013-06-05','14:50:00',4.04),('9303','2013-06-05','14:55:00',4),('9303','2013-06-05','15:00:00',3.9),('9303','2013-06-05','15:05:00',3.85),('9303','2013-06-05','15:10:00',3.79),('9303','2013-06-05','15:15:00',3.7),('9303','2013-06-05','15:20:00',3.78),('9303','2013-06-05','15:25:00',3.77),('9303','2013-06-05','15:30:00',3.77),('9303','2013-06-05','15:35:00',3.71),('9303','2013-06-05','15:40:00',3.73),('9303','2013-06-05','15:45:00',3.64),('9303','2013-06-05','15:50:00',3.57),('9303','2013-06-05','15:55:00',3.48),('9303','2013-06-05','16:00:00',3.39),('9303','2013-06-05','16:05:00',3.16),('9303','2013-06-05','16:10:00',3.3),('9303','2013-06-05','16:15:00',3.25),('9303','2013-06-05','16:20:00',3.17),('9303','2013-06-05','16:25:00',3.05),('9303','2013-06-05','16:30:00',2.91),('9303','2013-06-05','16:35:00',2.96),('9303','2013-06-05','16:40:00',2.9),('9303','2013-06-05','16:45:00',2.83),('9303','2013-06-05','16:50:00',2.77),('9303','2013-06-05','16:55:00',2.71),('9303','2013-06-05','17:00:00',2.38),('9303','2013-06-05','17:05:00',1.71),('9303','2013-06-05','17:10:00',1.62),('9303','2013-06-05','17:15:00',2.07),('9303','2013-06-05','17:25:00',1.92),('9303','2013-06-05','17:30:00',2.02),('9303','2013-06-05','17:35:00',1.79),('9303','2013-06-05','17:40:00',1.54),('9303','2013-06-05','17:45:00',1.6),('9303','2013-06-05','17:50:00',1.49),('9303','2013-06-05','17:55:00',1.56),('9303','2013-06-05','18:00:00',1.46),('9303','2013-06-05','18:05:00',1.34),('9303','2013-06-04','07:40:00',1.12),('9303','2013-06-04','07:45:00',1.29),('9303','2013-06-04','07:50:00',1.45),('9303','2013-06-04','07:55:00',1.58),('9303','2013-06-04','08:00:00',1.75),('9303','2013-06-04','08:05:00',1.88),('9303','2013-06-04','08:10:00',1.96),('9303','2013-06-04','08:15:00',2.02),('9303','2013-06-04','08:20:00',2),('9303','2013-06-04','08:25:00',1.89),('9303','2013-06-04','08:30:00',1.88),('9303','2013-06-04','08:35:00',2.12),('9303','2013-06-04','08:40:00',1.95),('9303','2013-06-04','08:45:00',1.77),('9303','2013-06-04','08:50:00',1.27),('9303','2013-06-04','08:55:00',1.34),('9303','2013-06-04','09:00:00',1.56),('9303','2013-06-04','09:05:00',2.03),('9303','2013-06-04','09:10:00',1.96),('9303','2013-06-04','09:15:00',2.77),('9303','2013-06-04','09:20:00',3.11),('9303','2013-06-04','09:25:00',3.5),('9303','2013-06-04','09:30:00',2.78),('9303','2013-06-04','09:35:00',2.39),('9303','2013-06-04','09:40:00',1.53),('9303','2013-06-04','09:45:00',1.56),('9303','2013-06-04','09:50:00',1.6),('9303','2013-06-04','09:55:00',1.5),('9303','2013-06-04','10:00:00',1.88),('9303','2013-06-04','10:05:00',2.07),('9303','2013-06-04','10:10:00',2.74),('9303','2013-06-04','10:15:00',2.29),('9303','2013-06-04','10:20:00',1.77),('9303','2013-06-04','10:25:00',1.68),('9303','2013-06-04','10:30:00',1.57),('9303','2013-06-04','10:35:00',1.61),('9303','2013-06-04','10:40:00',1.71),('9303','2013-06-04','10:45:00',2.02),('9303','2013-06-04','10:50:00',2.6),('9303','2013-06-04','10:55:00',3.16),('9303','2013-06-04','11:00:00',1.98),('9303','2013-06-04','11:05:00',2.51),('9303','2013-06-04','11:10:00',3.3),('9303','2013-06-04','11:15:00',2.98),('9303','2013-06-04','11:20:00',2.03),('9303','2013-06-04','11:25:00',2.75),('9303','2013-06-04','11:30:00',3.23),('9303','2013-06-04','11:35:00',2.91),('9303','2013-06-04','11:40:00',3.1),('9303','2013-06-04','11:45:00',3.9),('9303','2013-06-04','11:50:00',4.4),('9303','2013-06-04','11:55:00',4),('9303','2013-06-04','12:00:00',2.34),('9303','2013-06-04','12:05:00',2.48),('9303','2013-06-04','12:10:00',2.44),('9303','2013-06-04','12:15:00',2.23),('9303','2013-06-04','12:20:00',1.61),('9303','2013-06-04','12:25:00',1.77),('9303','2013-06-04','12:30:00',2.42),('9303','2013-06-04','12:35:00',3.73),('9303','2013-06-04','12:40:00',2.42),('9303','2013-06-04','12:45:00',2.65),('9303','2013-06-04','12:50:00',1.86),('9303','2013-06-04','12:55:00',1.9),('9303','2013-06-04','13:00:00',2.07),('9303','2013-06-04','13:05:00',1.37),('9303','2013-06-04','13:10:00',1.27),('9303','2013-06-04','13:15:00',1.19),('9303','2013-06-04','13:20:00',1.09),('9303','2013-06-04','13:25:00',1.43),('9303','2013-06-04','13:30:00',1.83),('9303','2013-06-04','13:35:00',4.45),('9303','2013-06-04','13:40:00',4.37),('9303','2013-06-04','13:45:00',4.45),('9303','2013-06-04','13:50:00',4.65),('9303','2013-06-04','13:55:00',2.15),('9303','2013-06-04','14:00:00',2.04),('9303','2013-06-04','14:05:00',3.31),('9303','2013-06-04','14:10:00',4.87),('9303','2013-06-04','14:15:00',3.45),('9303','2013-06-04','14:20:00',3.64),('9303','2013-06-04','14:25:00',1.83),('9303','2013-06-04','14:30:00',1.25),('9303','2013-06-04','14:35:00',1.66),('9303','2013-06-04','14:40:00',2.27),('9303','2013-06-04','14:45:00',1.06),('9303','2013-06-04','14:50:00',1),('9303','2013-06-04','14:55:00',3.83),('9303','2013-06-04','15:00:00',5),('9303','2013-06-04','15:05:00',4.86),('9303','2013-06-04','15:10:00',1.46),('9303','2013-06-04','15:15:00',1.05),('9303','2013-06-03','07:45:00',1.13),('9303','2013-06-03','07:50:00',1.21),('9303','2013-06-03','07:55:00',1.34),('9303','2013-06-03','08:00:00',1.42),('9303','2013-06-03','08:05:00',1.48),('9303','2013-06-03','08:10:00',1.58),('9303','2013-06-03','08:15:00',1.66),('9303','2013-06-03','08:20:00',1.73),('9303','2013-06-03','08:25:00',1.82),('9303','2013-06-03','08:30:00',1.91),('9303','2013-06-03','08:35:00',1.98),('9303','2013-06-03','08:40:00',2.05),('9303','2013-06-03','08:45:00',2.12),('9303','2013-06-03','08:50:00',2.21),('9303','2013-06-03','08:55:00',2.27),('9303','2013-06-03','09:00:00',2.33),('9303','2013-06-03','09:05:00',2.33),('9303','2013-06-03','09:10:00',2.59),('9303','2013-06-03','09:15:00',2.62),('9303','2013-06-03','09:20:00',2.44),('9303','2013-06-03','09:25:00',2.37),('9303','2013-06-03','09:30:00',2.07),('9303','2013-06-03','09:35:00',1.71),('9303','2013-06-03','09:40:00',2.31),('9303','2013-06-03','09:45:00',2.24),('9303','2013-06-03','09:50:00',3.19),('9303','2013-06-03','09:55:00',3.45),('9303','2013-06-03','10:00:00',3.77),('9303','2013-06-03','10:05:00',3.96),('9303','2013-06-03','10:10:00',3.94),('9303','2013-06-03','10:15:00',1.89),('9303','2013-06-03','10:20:00',1.06),('9303','2013-06-03','10:25:00',1.01),('9303','2013-06-03','10:30:00',1.03),('9303','2013-06-03','10:35:00',1.07),('9303','2013-06-03','10:40:00',1.23),('9303','2013-06-03','10:45:00',1.42),('9303','2013-06-03','10:50:00',1.63),('9303','2013-06-03','10:55:00',2.56),('9303','2013-06-03','11:00:00',2.7),('9303','2013-06-03','11:05:00',2.26),('9303','2013-06-03','11:10:00',1.42),('9303','2013-06-03','11:15:00',1.23),('9303','2013-06-03','11:20:00',1.52),('9303','2013-06-03','11:25:00',1.54),('9303','2013-06-03','11:30:00',1.35),('9303','2013-06-03','11:35:00',1.23),('9303','2013-06-03','11:40:00',1.28),('9303','2013-06-03','11:45:00',2.94),('9303','2013-06-03','11:50:00',1.47),('9303','2013-06-03','11:55:00',1.46),('9303','2013-06-03','12:00:00',1.51),('9303','2013-06-03','12:05:00',1.64),('9303','2013-06-03','12:10:00',1.68),('9303','2013-06-03','12:15:00',1.36),('9303','2013-06-03','12:20:00',1.45),('9303','2013-06-03','12:25:00',1.32),('9303','2013-06-03','12:30:00',1.76),('9303','2013-06-03','12:35:00',1.62),('9303','2013-06-03','12:40:00',3.41),('9303','2013-06-03','12:45:00',2.19),('9303','2013-06-03','12:50:00',2.4),('9303','2013-06-03','12:55:00',3.15),('9303','2013-06-03','13:00:00',2.06),('9303','2013-06-03','13:05:00',1.73),('9303','2013-06-03','13:10:00',1.79),('9303','2013-06-03','13:15:00',2.3),('9303','2013-06-03','13:20:00',3.86),('9303','2013-06-03','13:25:00',3.2),('9303','2013-06-03','13:30:00',3.43),('9303','2013-06-03','13:35:00',2.99),('9303','2013-06-03','13:40:00',4.72),('9303','2013-06-03','13:45:00',2.44),('9303','2013-06-03','13:50:00',3.84),('9303','2013-06-03','13:55:00',3.01),('9303','2013-06-03','14:00:00',4.02),('9303','2013-06-03','14:05:00',4.11),('9303','2013-06-03','14:10:00',2.38),('9303','2013-06-03','14:15:00',2.07),('9303','2013-06-03','14:20:00',2.18),('9303','2013-06-03','14:25:00',2.44),('9303','2013-06-03','14:30:00',4.49),('9303','2013-06-03','14:35:00',4.6),('9303','2013-06-03','14:40:00',3.49),('9303','2013-06-03','14:45:00',3.26),('9303','2013-06-03','14:50:00',3.37),('9303','2013-06-03','14:55:00',3.38),('9303','2013-06-03','15:00:00',3.69),('9303','2013-06-03','15:05:00',2.99),('9303','2013-06-03','15:10:00',3.88),('9303','2013-06-03','15:15:00',3.17),('9303','2013-06-03','15:20:00',2.93),('9303','2013-06-03','15:25:00',3.83),('9303','2013-06-03','15:30:00',3.71),('9303','2013-06-03','15:35:00',3.68),('9303','2013-06-03','15:40:00',3.6),('9303','2013-06-03','15:45:00',3.55),('9303','2013-06-03','15:50:00',3.51),('9303','2013-06-03','15:55:00',3.45),('9303','2013-06-03','16:00:00',3.39),('9303','2013-06-03','16:05:00',3.34),('9303','2013-06-03','16:10:00',3.34),('9303','2013-06-03','16:15:00',3.16),('9303','2013-06-03','16:20:00',3.08),('9303','2013-06-03','16:25:00',3.05),('9303','2013-06-03','16:30:00',3.21),('9303','2013-06-03','16:35:00',2.97),('9303','2013-06-03','16:40:00',3.02),('9303','2013-06-03','16:45:00',2.51),('9303','2013-06-03','16:50:00',1.88),('9303','2013-06-03','16:55:00',1.69),('9303','2013-06-03','17:00:00',2.35),('9303','2013-06-03','17:05:00',2.54),('9303','2013-06-03','17:10:00',2.62),('9303','2013-06-03','17:15:00',2.14),('9303','2013-06-03','17:20:00',1.85),('9303','2013-06-03','17:25:00',1.25),('9303','2013-06-02','08:50:00',1.03),('9303','2013-06-02','09:10:00',1.06),('9303','2013-06-02','09:15:00',1.1),('9303','2013-06-02','09:20:00',2.22),('9303','2013-06-02','09:25:00',3.15),('9303','2013-06-02','09:30:00',3.05),('9303','2013-06-02','09:35:00',3.03),('9303','2013-06-02','09:40:00',3.03),('9303','2013-06-02','09:45:00',3.06),('9303','2013-06-02','09:50:00',3.12),('9303','2013-06-02','09:55:00',3.07),('9303','2013-06-02','10:00:00',3.22),('9303','2013-06-02','10:05:00',3.31),('9303','2013-06-02','10:10:00',3.37),('9303','2013-06-02','10:15:00',3.42),('9303','2013-06-02','10:20:00',3.47),('9303','2013-06-02','10:25:00',3.57),('9303','2013-06-02','10:30:00',3.69),('9303','2013-06-02','10:35:00',3.98),('9303','2013-06-02','10:40:00',4.12),('9303','2013-06-02','10:45:00',1.86),('9303','2013-06-02','10:50:00',2.22),('9303','2013-06-02','10:55:00',2.41),('9303','2013-06-02','11:00:00',4.09),('9303','2013-06-02','11:05:00',4.22),('9303','2013-06-02','11:10:00',4.12),('9303','2013-06-02','11:15:00',2.2),('9303','2013-06-02','11:20:00',3.3),('9303','2013-06-02','11:25:00',3.25),('9303','2013-06-02','11:30:00',4.31),('9303','2013-06-02','11:35:00',1.56),('9303','2013-06-02','11:40:00',1.52),('9303','2013-06-02','11:45:00',1.19),('9303','2013-06-02','11:50:00',2.49),('9303','2013-06-02','11:55:00',4.16),('9303','2013-06-02','12:00:00',2.62),('9303','2013-06-02','12:05:00',1.94),('9303','2013-06-02','12:10:00',2.75),('9303','2013-06-02','12:15:00',4.05),('9303','2013-06-02','12:20:00',2.74),('9303','2013-06-02','12:25:00',2.13),('9303','2013-06-02','12:30:00',4.87),('9303','2013-06-02','12:35:00',4.76),('9303','2013-06-02','12:40:00',2.74),('9303','2013-06-02','12:45:00',4.4),('9303','2013-06-02','12:50:00',1.46),('9303','2013-06-02','12:55:00',1.87),('9303','2013-06-02','13:00:00',2.94),('9303','2013-06-02','13:05:00',3.64),('9303','2013-06-02','13:10:00',2.75),('9303','2013-06-02','13:15:00',4.72),('9303','2013-06-02','13:20:00',4.51),('9303','2013-06-02','13:25:00',4.4),('9303','2013-06-02','13:30:00',4.33),('9303','2013-06-02','13:35:00',4.32),('9303','2013-06-02','13:40:00',4.31),('9303','2013-06-02','13:45:00',4.3),('9303','2013-06-02','13:50:00',4.29),('9303','2013-06-02','13:55:00',4.28),('9303','2013-06-02','14:00:00',4.26),('9303','2013-06-02','14:05:00',4.23),('9303','2013-06-02','14:10:00',4.24),('9303','2013-06-02','14:15:00',4.22),('9303','2013-06-02','14:20:00',4.08),('9303','2013-06-02','14:25:00',4.18),('9303','2013-06-02','14:30:00',4.15),('9303','2013-06-02','14:35:00',4.07),('9303','2013-06-02','14:40:00',4.07),('9303','2013-06-02','14:45:00',4.02),('9303','2013-06-02','14:50:00',3.98),('9303','2013-06-02','14:55:00',3.98),('9303','2013-06-02','15:00:00',3.94),('9303','2013-06-02','15:05:00',3.91),('9303','2013-06-02','15:10:00',3.89),('9303','2013-06-02','15:15:00',3.85),('9303','2013-06-02','15:20:00',3.84),('9303','2013-06-02','15:25:00',3.31),('9303','2013-06-02','15:30:00',3.86),('9303','2013-06-02','15:35:00',3.07),('9303','2013-06-02','15:40:00',2.32),('9303','2013-06-02','15:45:00',2.66),('9303','2013-06-02','15:50:00',3.54),('9303','2013-06-02','15:55:00',2.68),('9303','2013-06-02','16:00:00',3.47),('9303','2013-06-02','16:05:00',3.37),('9303','2013-06-02','16:10:00',3.43),('9303','2013-06-02','16:15:00',3.43),('9303','2013-06-02','16:20:00',3.05),('9303','2013-06-02','16:25:00',3.25),('9303','2013-06-02','16:30:00',3.08),('9303','2013-06-02','16:35:00',3.02),('9303','2013-06-02','16:40:00',3.01),('9303','2013-06-02','16:45:00',2.73),('9303','2013-06-02','16:50:00',2.82),('9303','2013-06-02','16:55:00',2.72),('9303','2013-06-02','17:00:00',2.65),('9303','2013-06-02','17:05:00',2.04),('9303','2013-06-02','17:10:00',2.46),('9303','2013-06-02','17:15:00',2.01),('9303','2013-06-02','17:20:00',2.18),('9303','2013-06-02','17:25:00',2.1),('9303','2013-06-02','17:30:00',1.88),('9303','2013-06-02','17:35:00',1.85),('9303','2013-06-02','17:40:00',1.2),('9303','2013-06-01','07:40:00',1.07),('9303','2013-06-01','07:45:00',1.19),('9303','2013-06-01','07:55:00',1.3),('9303','2013-06-01','08:15:00',1.16),('9303','2013-06-01','08:20:00',1.1),('9303','2013-06-01','08:35:00',1.69),('9303','2013-06-01','10:35:00',1.07),('9303','2013-06-01','10:40:00',1.13),('9303','2013-06-01','10:50:00',1.92),('9303','2013-06-01','10:55:00',1.9),('9303','2013-06-01','11:50:00',1.22),('9303','2013-06-01','11:55:00',1.65),('9303','2013-06-01','12:00:00',2.08),('9303','2013-06-01','12:05:00',2.97),('9303','2013-06-01','12:10:00',3.19),('9303','2013-06-01','12:15:00',1.4),('9303','2013-06-01','12:25:00',1.1),('9303','2013-06-01','12:30:00',1.1),('9303','2013-06-01','12:45:00',1.48),('9303','2013-06-01','12:50:00',1.81),('9303','2013-06-01','12:55:00',1.79),('9303','2013-06-01','13:00:00',1.98),('9303','2013-06-01','13:05:00',2.15),('9303','2013-06-01','13:10:00',2.35),('9303','2013-06-01','13:15:00',2.42),('9303','2013-06-01','13:20:00',2.16),('9303','2013-06-01','13:25:00',1.71),('9303','2013-06-01','13:30:00',1.53),('9303','2013-06-01','13:35:00',1.18),('9303','2013-06-01','13:40:00',1.02),('9303','2013-06-01','13:45:00',1.1),('9303','2013-06-01','13:50:00',1.2),('9303','2013-06-01','13:55:00',1.37),('9303','2013-06-01','14:00:00',1.73),('9303','2013-06-01','14:05:00',2.25),('9303','2013-06-01','14:10:00',2.27),('9303','2013-06-01','14:15:00',2.38),('9303','2013-06-01','14:20:00',2.64),('9303','2013-06-01','14:25:00',1.62),('9303','2013-06-01','14:30:00',1.28),('9303','2013-06-01','14:35:00',1.32),('9303','2013-06-01','14:40:00',1.24),('9303','2013-06-01','14:45:00',1.15),('9303','2013-06-01','14:50:00',1.05),('9303','2014-04-02','08:50:00',1.03),('9303','2014-04-02','08:55:00',1.93),('9303','2014-04-02','09:55:00',2.25),('9303','2014-04-02','10:00:00',2.35),('9303','2014-04-02','10:05:00',2.56),('9303','2014-04-02','10:10:00',3.06),('9303','2014-04-02','10:15:00',3.24),('9303','2014-04-02','10:20:00',3.33),('9303','2014-04-02','10:25:00',3.23),('9303','2014-04-02','10:30:00',1.27),('9303','2014-04-02','10:45:00',1.31),('9303','2014-04-02','10:50:00',2.83),('9303','2014-04-02','10:55:00',3.7),('9303','2014-04-02','11:00:00',3.54),('9303','2014-04-02','11:05:00',2.92),('9303','2014-04-02','11:10:00',1.33),('9303','2014-04-02','11:15:00',2.91),('9303','2014-04-02','11:20:00',3),('9303','2014-04-02','11:25:00',4.03),('9303','2014-04-02','11:30:00',3.02),('9303','2014-04-02','11:35:00',2.52),('9303','2014-04-02','11:40:00',1.85),('9303','2014-04-02','11:45:00',3.03),('9303','2014-04-02','11:50:00',4.13),('9303','2014-04-02','11:55:00',4.09),('9303','2014-04-02','12:00:00',4.24),('9303','2014-04-02','12:05:00',2.36),('9303','2014-04-02','12:10:00',1.62),('9303','2014-04-02','12:15:00',3.3),('9303','2014-04-02','12:20:00',4.36),('9303','2014-04-02','12:25:00',4.16),('9303','2014-04-02','12:30:00',4.32),('9303','2014-04-02','12:35:00',4.04),('9303','2014-04-02','12:40:00',3.47),('9303','2014-04-02','12:45:00',3.43),('9303','2014-04-02','12:50:00',3.58),('9303','2014-04-02','12:55:00',2.56),('9303','2014-04-02','13:00:00',4.39),('9303','2014-04-02','13:05:00',1.47),('9303','2014-04-02','13:10:00',3.44),('9303','2014-04-02','13:15:00',1.92),('9303','2014-04-02','13:20:00',2.55),('9303','2014-04-02','13:25:00',2.94),('9303','2014-04-02','13:30:00',3.01),('9303','2014-04-02','13:35:00',4.42),('9303','2014-04-02','13:40:00',4.23),('9303','2014-04-02','13:45:00',4.31),('9303','2014-04-02','13:50:00',4.14),('9303','2014-04-02','13:55:00',4.26),('9303','2014-04-02','14:00:00',4.2),('9303','2014-04-02','14:05:00',4.04),('9303','2014-04-02','14:10:00',4.19),('9303','2014-04-02','14:15:00',4.08),('9303','2014-04-02','14:20:00',4.04),('9303','2014-04-02','14:25:00',4.08),('9303','2014-04-02','14:30:00',3.93),('9303','2014-04-02','14:35:00',3.87),('9303','2014-04-02','14:40:00',3.94),('9303','2014-04-02','14:45:00',3.89),('9303','2014-04-02','14:50:00',3.36),('9303','2014-04-02','14:55:00',3.09),('9303','2014-04-02','15:00:00',3.61),('9303','2014-04-02','15:05:00',3.61),('9303','2014-04-02','15:10:00',3.38),('9303','2014-04-02','15:15:00',3.38),('9303','2014-04-02','15:20:00',3.39),('9303','2014-04-02','15:25:00',3.31),('9303','2014-04-02','15:30:00',3.12),('9303','2014-04-02','15:35:00',3.03),('9303','2014-04-02','15:40:00',3.23),('9303','2014-04-02','15:45:00',3.24),('9303','2014-04-02','15:50:00',3.18),('9303','2014-04-02','15:55:00',2.79),('9303','2014-04-02','16:00:00',2.92),('9303','2014-04-02','16:05:00',2.9),('9303','2014-04-02','16:10:00',2.82),('9303','2014-04-02','16:15:00',2.78),('9303','2014-04-02','16:20:00',2.65),('9303','2014-04-02','16:25:00',2.62),('9303','2014-04-02','16:30:00',2.59),('9303','2014-04-02','16:35:00',2.46),('9303','2014-04-02','16:40:00',2.38),('9303','2014-04-02','16:45:00',2.26),('9303','2014-04-02','16:50:00',2.03),('9303','2014-04-02','16:55:00',1.98),('9303','2014-04-02','17:00:00',2.07),('9303','2014-04-02','17:05:00',1.86),('9303','2014-04-02','17:10:00',1.77),('9303','2014-04-02','17:15:00',1.58),('9303','2014-04-02','17:20:00',1.58),('9303','2014-04-02','17:25:00',1.48),('9303','2014-04-02','17:30:00',1.3),('9303','2014-04-02','17:35:00',1.28),('9303','2014-04-02','17:50:00',1.11),('9303','2013-05-31','07:40:00',1.09),('9303','2013-05-31','07:45:00',1.16),('9303','2013-05-31','07:50:00',1.26),('9303','2013-05-31','07:55:00',1.39),('9303','2013-05-31','08:00:00',1.5),('9303','2013-05-31','08:05:00',1.55),('9303','2013-05-31','08:10:00',1.65),('9303','2013-05-31','08:15:00',1.73),('9303','2013-05-31','08:20:00',1.8),('9303','2013-05-31','08:25:00',1.93),('9303','2013-05-31','08:30:00',1.79),('9303','2013-05-31','08:35:00',1.46),('9303','2013-05-31','08:40:00',2.47),('9303','2013-05-31','08:45:00',2.45),('9303','2013-05-31','08:50:00',2.89),('9303','2013-05-31','08:55:00',1.53),('9303','2013-05-31','09:10:00',1.17),('9303','2013-05-31','09:15:00',1.91),('9303','2013-05-31','09:30:00',1.04),('9303','2013-05-31','09:35:00',1.69),('9303','2013-05-31','09:40:00',1.89),('9303','2013-05-31','09:45:00',3.36),('9303','2013-05-31','09:50:00',3.51),('9303','2013-05-31','09:55:00',3.65),('9303','2013-05-31','10:00:00',3.37),('9303','2013-05-31','10:05:00',2.97),('9303','2013-05-31','10:10:00',2.11),('9303','2013-05-31','10:15:00',2.37),('9303','2013-05-31','10:20:00',3.1),('9303','2013-05-31','10:25:00',1.01),('9303','2013-05-31','10:30:00',1.27),('9303','2013-05-31','10:35:00',2.09),('9303','2013-05-31','10:40:00',3.56),('9303','2013-05-31','10:45:00',4.33),('9303','2013-05-31','10:50:00',2.27),('9303','2013-05-31','10:55:00',3.12),('9303','2013-05-31','11:00:00',1.52),('9303','2013-05-31','11:05:00',1.92),('9303','2013-05-31','11:10:00',4.1),('9303','2013-05-31','11:15:00',3.77),('9303','2013-05-31','11:20:00',1.39),('9303','2013-05-31','11:25:00',3.21),('9303','2013-05-31','11:30:00',4.69),('9303','2013-05-31','11:35:00',1.74),('9303','2013-05-31','11:45:00',3.76),('9303','2013-05-31','11:50:00',3.61),('9303','2013-05-31','11:55:00',2.72),('9303','2013-05-31','12:00:00',2.56),('9303','2013-05-31','12:05:00',4.65),('9303','2013-05-31','12:10:00',3.82),('9303','2013-05-31','12:15:00',1.52),('9303','2013-05-31','12:20:00',1.6),('9303','2013-05-31','12:25:00',3.73),('9303','2013-05-31','12:30:00',1.64),('9303','2013-05-31','12:35:00',1.57),('9303','2013-05-31','12:40:00',4.6),('9303','2013-05-31','12:45:00',2.39),('9303','2013-05-31','12:55:00',1.5),('9303','2013-05-31','13:00:00',4.67),('9303','2013-05-31','13:05:00',2.08),('9303','2013-05-31','13:20:00',1.09),('9303','2013-05-31','13:25:00',1.84),('9303','2013-05-31','13:30:00',3.39),('9303','2013-05-31','13:35:00',4.45),('9303','2013-05-31','13:40:00',2.65),('9303','2013-05-31','13:45:00',1.53),('9303','2013-05-31','14:00:00',2.27),('9303','2013-05-31','15:05:00',1.54),('9303','2013-05-31','15:10:00',1.66),('9303','2013-05-31','15:15:00',2.45),('9303','2013-05-31','15:20:00',4.16),('9303','2013-05-31','15:25:00',3.49),('9303','2013-05-31','15:30:00',2.8),('9303','2013-05-31','15:35:00',2.03),('9303','2013-05-31','15:40:00',1.69),('9303','2013-05-31','15:45:00',1.51),('9303','2013-05-31','15:50:00',2.18),('9303','2013-05-31','15:55:00',2.17),('9303','2013-05-31','16:00:00',1.5),('9303','2013-05-31','16:05:00',1.22),('9303','2013-05-31','16:25:00',1.2),('9303','2013-05-31','16:30:00',1.11),('9303','2013-05-31','16:40:00',1.06),('9303','2013-05-31','16:45:00',1.14),('9303','2013-05-30','08:25:00',1.07),('9303','2013-05-30','08:40:00',2.26),('9303','2013-05-30','08:45:00',2.33),('9303','2013-05-30','08:50:00',2.4),('9303','2013-05-30','08:55:00',2.47),('9303','2013-05-30','09:00:00',2.57),('9303','2013-05-30','09:05:00',2.6),('9303','2013-05-30','09:10:00',2.71),('9303','2013-05-30','09:15:00',2.76),('9303','2013-05-30','09:20:00',2.9),('9303','2013-05-30','09:25:00',2.92),('9303','2013-05-30','09:30:00',3.19),('9303','2013-05-30','09:35:00',3.15),('9303','2013-05-30','09:40:00',3.28),('9303','2013-05-30','09:45:00',3.05),('9303','2013-05-30','09:50:00',3.79),('9303','2013-05-30','09:55:00',2.33),('9303','2013-05-30','10:05:00',1.44),('9303','2013-05-30','10:10:00',3.52),('9303','2013-05-30','10:15:00',1.16),('9303','2013-05-30','10:20:00',3.96),('9303','2013-05-30','10:25:00',1.25),('9303','2013-05-30','10:40:00',1.54),('9303','2013-05-30','10:45:00',4.14),('9303','2013-05-30','10:50:00',4.43),('9303','2013-05-30','10:55:00',4.46),('9303','2013-05-30','11:00:00',4.13),('9303','2013-05-30','11:05:00',3.75),('9303','2013-05-30','11:10:00',1.85),('9303','2013-05-30','11:15:00',1.88),('9303','2013-05-30','11:20:00',4.11),('9303','2013-05-30','11:25:00',2.36),('9303','2013-05-30','11:30:00',2.74),('9303','2013-05-30','11:35:00',4.15),('9303','2013-05-30','11:40:00',4.7),('9303','2013-05-30','11:45:00',3.22),('9303','2013-05-30','11:50:00',4.9),('9303','2013-05-30','12:00:00',3.23),('9303','2013-05-30','12:05:00',4.96),('9303','2013-05-30','12:10:00',3.67),('9303','2013-05-30','12:15:00',3.65),('9303','2013-05-30','12:20:00',4.93),('9303','2013-05-30','12:25:00',3.95),('9303','2013-05-30','12:30:00',3.34),('9303','2013-05-30','12:35:00',3.25),('9303','2013-05-30','12:40:00',4.01),('9303','2013-05-30','12:45:00',2.07),('9303','2013-05-30','12:50:00',3.1),('9303','2013-05-30','12:55:00',4.63),('9303','2013-05-30','13:00:00',3.71),('9303','2013-05-30','13:05:00',2.06),('9303','2013-05-30','13:10:00',1.85),('9303','2013-05-30','13:15:00',2.46),('9303','2013-05-30','13:20:00',2.48),('9303','2013-05-30','13:25:00',1.71),('9303','2013-05-30','13:30:00',2.41),('9303','2013-05-30','13:35:00',1.54),('9303','2013-05-30','13:40:00',3.98),('9303','2013-05-30','13:45:00',3.73),('9303','2013-05-30','13:50:00',1.8),('9303','2013-05-30','13:55:00',1.53),('9303','2013-05-30','14:00:00',4.63),('9303','2013-05-30','14:05:00',4.97),('9303','2013-05-30','14:10:00',3.82),('9303','2013-05-30','14:15:00',1.78),('9303','2013-05-30','14:20:00',3.93),('9303','2013-05-30','14:25:00',2.53),('9303','2013-05-30','14:30:00',4.54),('9303','2013-05-30','14:35:00',3.55),('9303','2013-05-30','14:40:00',4.54),('9303','2013-05-30','14:45:00',4.46),('9303','2013-05-30','14:50:00',4.33),('9303','2013-05-30','14:55:00',4.35),('9303','2013-05-30','15:00:00',4.34),('9303','2013-05-30','15:05:00',4.38),('9303','2013-05-30','15:10:00',1.14),('9303','2013-05-30','15:15:00',4.42),('9303','2013-05-30','15:20:00',4.25),('9303','2013-05-30','15:25:00',4.16),('9303','2013-05-30','15:30:00',4.2),('9303','2013-05-30','15:35:00',4.27),('9303','2013-05-30','15:40:00',4.17),('9303','2013-05-30','15:45:00',3.28),('9303','2013-05-30','15:50:00',3.8),('9303','2013-05-30','15:55:00',3.05),('9303','2013-05-30','16:00:00',3.56),('9303','2013-05-30','16:05:00',3.68),('9303','2013-05-30','16:10:00',3.75),('9303','2013-05-30','16:15:00',3.56),('9303','2013-05-30','16:20:00',3.19),('9303','2013-05-30','16:25:00',2.41),('9303','2013-05-30','16:30:00',1.38),('9303','2013-05-30','16:35:00',1.35),('9303','2013-05-30','16:45:00',2),('9303','2013-05-30','16:50:00',2.46),('9303','2013-05-30','16:55:00',2.39),('9303','2013-05-30','17:00:00',1.15),('9303','2013-05-30','17:05:00',1.77),('9303','2013-05-30','18:45:00',1.06),('9303','2013-05-29','07:40:00',1.03),('9303','2013-05-29','07:45:00',1.11),('9303','2013-05-29','07:50:00',1.2),('9303','2013-05-29','07:55:00',1.31),('9303','2013-05-29','08:00:00',1.4),('9303','2013-05-29','08:05:00',1.5),('9303','2013-05-29','08:10:00',1.61),('9303','2013-05-29','08:15:00',1.69),('9303','2013-05-29','08:20:00',1.77),('9303','2013-05-29','08:25:00',1.85),('9303','2013-05-29','08:30:00',1.97),('9303','2013-05-29','08:35:00',2.05),('9303','2013-05-29','08:40:00',2.11),('9303','2013-05-29','08:45:00',2.2),('9303','2013-05-29','08:50:00',2.32),('9303','2013-05-29','08:55:00',2.4),('9303','2013-05-29','09:00:00',2.5),('9303','2013-05-29','09:05:00',2.58),('9303','2013-05-29','09:10:00',2.66),('9303','2013-05-29','09:15:00',2.74),('9303','2013-05-29','09:20:00',2.78),('9303','2013-05-29','09:25:00',2.85),('9303','2013-05-29','09:30:00',2.91),('9303','2013-05-29','09:35:00',2.99),('9303','2013-05-29','09:40:00',3.06),('9303','2013-05-29','09:45:00',3.13),('9303','2013-05-29','09:50:00',3.2),('9303','2013-05-29','09:55:00',3.24),('9303','2013-05-29','10:00:00',3.28),('9303','2013-05-29','10:05:00',3.37),('9303','2013-05-29','10:10:00',3.39),('9303','2013-05-29','10:15:00',3.44),('9303','2013-05-29','10:20:00',3.53),('9303','2013-05-29','10:25:00',3.6),('9303','2013-05-29','10:30:00',3.67),('9303','2013-05-29','10:35:00',3.74),('9303','2013-05-29','10:40:00',3.77),('9303','2013-05-29','10:45:00',3.85),('9303','2013-05-29','10:50:00',3.87),('9303','2013-05-29','10:55:00',3.96),('9303','2013-05-29','11:00:00',3.98),('9303','2013-05-29','11:05:00',4.05),('9303','2013-05-29','11:10:00',4.14),('9303','2013-05-29','11:15:00',2.79),('9303','2013-05-29','11:20:00',3.79),('9303','2013-05-29','11:25:00',2.93),('9303','2013-05-29','11:30:00',4.72),('9303','2013-05-29','11:35:00',4.58),('9303','2013-05-29','11:40:00',3.37),('9303','2013-05-29','11:45:00',3.8),('9303','2013-05-29','11:50:00',3.94),('9303','2013-05-29','11:55:00',3.88),('9303','2013-05-29','12:00:00',4.58),('9303','2013-05-29','12:05:00',3.44),('9303','2013-05-29','12:10:00',3.7),('9303','2013-05-29','12:15:00',3.91),('9303','2013-05-29','12:20:00',4.58),('9303','2013-05-29','12:25:00',4.44),('9303','2013-05-29','12:30:00',4.49),('9303','2013-05-29','12:35:00',4.49),('9303','2013-05-29','12:40:00',4.42),('9303','2013-05-29','12:45:00',4.49),('9303','2013-05-29','12:50:00',4.3),('9303','2013-05-29','12:55:00',4.42),('9303','2013-05-29','13:00:00',4.53),('9303','2013-05-29','13:05:00',4.64),('9303','2013-05-29','13:10:00',4.11),('9303','2013-05-29','13:15:00',4.64),('9303','2013-05-29','13:20:00',4.92),('9303','2013-05-29','13:25:00',4.97),('9303','2013-05-29','13:30:00',4.81),('9303','2013-05-29','13:35:00',3.81),('9303','2013-05-29','13:40:00',4.4),('9303','2013-05-29','13:45:00',4.27),('9303','2013-05-29','13:50:00',3.9),('9303','2013-05-29','13:55:00',3.72),('9303','2013-05-29','14:00:00',4.44),('9303','2013-05-29','14:05:00',4.29),('9303','2013-05-29','14:10:00',4.22),('9303','2013-05-29','14:15:00',4.34),('9303','2013-05-29','14:20:00',4.37),('9303','2013-05-29','14:25:00',3.68),('9303','2013-05-29','14:30:00',4.36),('9303','2013-05-29','14:35:00',3.96),('9303','2013-05-29','14:40:00',4.48),('9303','2013-05-29','14:45:00',4.36),('9303','2013-05-29','14:50:00',3.85),('9303','2013-05-29','14:55:00',4.03),('9303','2013-05-29','15:00:00',4.36),('9303','2013-05-29','15:05:00',4.39),('9303','2013-05-29','15:10:00',3.99),('9303','2013-05-29','15:15:00',2.65),('9303','2013-05-29','15:20:00',3),('9303','2013-05-29','15:25:00',2.54),('9303','2013-05-29','15:30:00',2.77),('9303','2013-05-29','15:35:00',3.03),('9303','2013-05-29','15:40:00',2.87),('9303','2013-05-29','15:45:00',2.83),('9303','2013-05-29','15:50:00',2.72),('9303','2013-05-29','15:55:00',2.81),('9303','2013-05-29','16:00:00',2.51),('9303','2013-05-29','16:05:00',2.5),('9303','2013-05-29','16:10:00',2.09),('9303','2013-05-29','16:15:00',1.98),('9303','2013-05-29','16:20:00',1.91),('9303','2013-05-29','16:25:00',2.05),('9303','2013-05-29','16:30:00',1.8),('9303','2013-05-29','16:35:00',1.72),('9303','2013-05-29','16:40:00',2.04),('9303','2013-05-29','16:45:00',1.78),('9303','2013-05-29','16:50:00',1.45),('9303','2013-05-29','16:55:00',1.37),('9303','2013-05-29','17:00:00',1.29),('9303','2013-05-29','17:40:00',1.44),('9303','2013-05-29','17:45:00',1.04),('9303','2013-05-29','18:05:00',1.03),('9303','2013-05-29','18:10:00',1),('9303','2013-05-29','18:15:00',1.61),('9303','2013-05-29','18:20:00',1.25),('9303','2013-05-28','07:45:00',1.04),('9303','2013-05-28','07:50:00',1.05),('9303','2013-05-28','07:55:00',1.03),('9303','2013-05-28','08:00:00',1.09),('9303','2013-05-28','08:05:00',1.17),('9303','2013-05-28','08:10:00',1.32),('9303','2013-05-28','08:15:00',1.59),('9303','2013-05-28','08:20:00',1.69),('9303','2013-05-28','08:25:00',1.5),('9303','2013-05-28','08:30:00',1.7),('9303','2013-05-28','08:35:00',1.57),('9303','2013-05-28','08:40:00',1.4),('9303','2013-05-28','08:45:00',1.33),('9303','2013-05-28','08:50:00',1.58),('9303','2013-05-28','08:55:00',1.41),('9303','2013-05-28','09:00:00',1.53),('9303','2013-05-28','09:05:00',1.7),('9303','2013-05-28','09:10:00',1.56),('9303','2013-05-28','09:15:00',1.48),('9303','2013-05-28','09:20:00',1.71),('9303','2013-05-28','09:25:00',1.98),('9303','2013-05-28','09:30:00',2.12),('9303','2013-05-28','09:35:00',2.21),('9303','2013-05-28','09:40:00',2.14),('9303','2013-05-28','09:45:00',1.97),('9303','2013-05-28','09:50:00',2),('9303','2013-05-28','09:55:00',2.1),('9303','2013-05-28','10:00:00',1.94),('9303','2013-05-28','10:05:00',2.1),('9303','2013-05-28','10:10:00',2.36),('9303','2013-05-28','10:15:00',2.45),('9303','2013-05-28','10:20:00',2.58),('9303','2013-05-28','10:25:00',2.54),('9303','2013-05-28','10:30:00',2.84),('9303','2013-05-28','10:35:00',2.91),('9303','2013-05-28','10:40:00',2.72),('9303','2013-05-28','10:45:00',2.44),('9303','2013-05-28','10:50:00',2.68),('9303','2013-05-28','10:55:00',2.29),('9303','2013-05-28','11:00:00',2.33),('9303','2013-05-28','11:05:00',2.2),('9303','2013-05-28','11:10:00',2.37),('9303','2013-05-28','11:15:00',1.95),('9303','2013-05-28','11:20:00',2.11),('9303','2013-05-28','11:25:00',1.98),('9303','2013-05-28','11:30:00',3.86),('9303','2013-05-28','11:35:00',3.09),('9303','2013-05-28','11:40:00',3.57),('9303','2013-05-28','11:45:00',3.44),('9303','2013-05-28','11:50:00',1.07),('9303','2013-05-28','11:55:00',1.54),('9303','2013-05-28','12:00:00',1.49),('9303','2013-05-28','12:05:00',1.72),('9303','2013-05-28','12:10:00',2.44),('9303','2013-05-28','12:15:00',2.49),('9303','2013-05-28','12:20:00',2.14),('9303','2013-05-28','12:25:00',2.19),('9303','2013-05-28','12:30:00',2.51),('9303','2013-05-28','12:35:00',2.45),('9303','2013-05-28','12:40:00',2.46),('9303','2013-05-28','12:45:00',2.8),('9303','2013-05-28','12:50:00',2.5),('9303','2013-05-28','12:55:00',2.53),('9303','2013-05-28','13:00:00',2.61),('9303','2013-05-28','13:05:00',2.8),('9303','2013-05-28','13:10:00',2.95),('9303','2013-05-28','13:15:00',2.47),('9303','2013-05-28','13:20:00',3.27),('9303','2013-05-28','13:25:00',1.73),('9303','2013-05-28','13:30:00',2),('9303','2013-05-28','13:35:00',1.67),('9303','2013-05-28','13:40:00',1.86),('9303','2013-05-28','13:45:00',1.77),('9303','2013-05-28','13:50:00',2.49),('9303','2013-05-28','13:55:00',2.47),('9303','2013-05-28','14:00:00',2.51),('9303','2013-05-28','14:05:00',2.61),('9303','2013-05-28','14:10:00',3.85),('9303','2013-05-28','14:15:00',3.96),('9303','2013-05-28','14:20:00',2.35),('9303','2013-05-28','14:25:00',2.69),('9303','2013-05-28','14:30:00',3.34),('9303','2013-05-28','14:35:00',2.73),('9303','2013-05-28','14:40:00',3.03),('9303','2013-05-28','14:45:00',3.73),('9303','2013-05-28','14:50:00',2.85),('9303','2013-05-28','14:55:00',2.49),('9303','2013-05-28','15:00:00',2.19),('9303','2013-05-28','15:05:00',3.59),('9303','2013-05-28','15:10:00',1.66),('9303','2013-05-28','15:15:00',2.29),('9303','2013-05-28','15:20:00',3.02),('9303','2013-05-28','15:25:00',2.11),('9303','2013-05-28','15:30:00',1.41),('9303','2013-05-28','15:35:00',1.42),('9303','2013-05-28','15:40:00',2.07),('9303','2013-05-28','15:45:00',3.56),('9303','2013-05-28','15:50:00',3.04),('9303','2013-05-28','15:55:00',2.33),('9303','2013-05-28','16:00:00',1.52),('9303','2013-05-28','16:05:00',1.19),('9303','2013-05-28','16:10:00',1.31),('9303','2013-05-28','16:15:00',1.39),('9303','2013-05-28','16:20:00',2.12),('9303','2013-05-28','16:25:00',2.09),('9303','2013-05-28','16:30:00',2.06),('9303','2013-05-28','16:35:00',2.95),('9303','2013-05-28','16:40:00',2.73),('9303','2013-05-28','16:45:00',2.65),('9303','2013-05-28','16:50:00',2.57),('9303','2013-05-28','16:55:00',2.48),('9303','2013-05-28','17:00:00',2.42),('9303','2013-05-28','17:05:00',2.32),('9303','2013-05-28','17:10:00',2.18),('9303','2013-05-28','17:15:00',2.1),('9303','2013-05-28','17:20:00',2.01),('9303','2013-05-28','17:25:00',1.91),('9303','2013-05-28','17:30:00',1.8),('9303','2013-05-28','17:35:00',1.7),('9303','2013-05-28','17:40:00',1.61),('9303','2013-05-28','17:45:00',1.56),('9303','2013-05-28','17:50:00',1.5),('9303','2013-05-28','17:55:00',1.43),('9303','2013-05-28','18:00:00',1.39),('9303','2013-05-28','18:05:00',1.3),('9303','2013-05-27','07:35:00',1.01),('9303','2013-05-27','07:40:00',1.06),('9303','2013-05-27','07:45:00',1.18),('9303','2013-05-27','07:50:00',1.04),('9303','2013-05-27','08:00:00',1.28),('9303','2013-05-27','08:05:00',1.55),('9303','2013-05-27','08:10:00',1.8),('9303','2013-05-27','08:15:00',1.48),('9303','2013-05-27','08:20:00',1.69),('9303','2013-05-27','08:25:00',1.84),('9303','2013-05-27','08:30:00',1.97),('9303','2013-05-27','08:35:00',2.07),('9303','2013-05-27','08:40:00',2.15),('9303','2013-05-27','08:45:00',2.43),('9303','2013-05-27','08:50:00',2.48),('9303','2013-05-27','08:55:00',1.81),('9303','2013-05-27','09:00:00',2.54),('9303','2013-05-27','09:05:00',2.97),('9303','2013-05-27','09:10:00',2.79),('9303','2013-05-27','09:15:00',1.74),('9303','2013-05-27','09:20:00',2.06),('9303','2013-05-27','09:25:00',2.85),('9303','2013-05-27','09:30:00',3.11),('9303','2013-05-27','09:35:00',3.11),('9303','2013-05-27','09:40:00',3.17),('9303','2013-05-27','09:45:00',3.26),('9303','2013-05-27','09:50:00',2.27),('9303','2013-05-27','09:55:00',2.7),('9303','2013-05-27','10:00:00',3.57),('9303','2013-05-27','10:05:00',3.52),('9303','2013-05-27','10:10:00',3.61),('9303','2013-05-27','10:15:00',3.71),('9303','2013-05-27','10:20:00',2.66),('9303','2013-05-27','10:25:00',2.14),('9303','2013-05-27','10:30:00',2.45),('9303','2013-05-27','10:35:00',1.01),('9303','2013-05-27','10:40:00',1.58),('9303','2013-05-27','10:45:00',2.45),('9303','2013-05-27','10:50:00',2.07),('9303','2013-05-27','10:55:00',2.93),('9303','2013-05-27','11:00:00',2.93),('9303','2013-05-27','11:05:00',3.3),('9303','2013-05-27','11:10:00',2.57),('9303','2013-05-27','11:15:00',1.71),('9303','2013-05-27','11:20:00',3.16),('9303','2013-05-27','11:25:00',3.65),('9303','2013-05-27','11:30:00',2.24),('9303','2013-05-27','11:35:00',2.89),('9303','2013-05-27','11:40:00',3.29),('9303','2013-05-27','11:45:00',4.1),('9303','2013-05-27','11:50:00',1.89),('9303','2013-05-27','11:55:00',1.73),('9303','2013-05-27','12:00:00',4.79),('9303','2013-05-27','12:05:00',3.6),('9303','2013-05-27','12:10:00',2.95),('9303','2013-05-27','12:15:00',2.94),('9303','2013-05-27','12:20:00',3.28),('9303','2013-05-27','12:25:00',3.71),('9303','2013-05-27','12:30:00',4.41),('9303','2013-05-27','12:35:00',1.98),('9303','2013-05-27','12:40:00',3.69),('9303','2013-05-27','12:45:00',4.75),('9303','2013-05-27','12:50:00',4.74),('9303','2013-05-27','12:55:00',4.07),('9303','2013-05-27','13:00:00',3.43),('9303','2013-05-27','13:05:00',2.95),('9303','2013-05-27','13:10:00',4.76),('9303','2013-05-27','13:15:00',3.64),('9303','2013-05-27','13:20:00',4.55),('9303','2013-05-27','13:25:00',3.89),('9303','2013-05-27','13:30:00',4.72),('9303','2013-05-27','13:35:00',3.22),('9303','2013-05-27','13:40:00',4.91),('9303','2013-05-27','13:45:00',4.72),('9303','2013-05-27','13:50:00',3.28),('9303','2013-05-27','13:55:00',4.01),('9303','2013-05-27','14:00:00',4.39),('9303','2013-05-27','14:05:00',4.43),('9303','2013-05-27','14:10:00',4.3),('9303','2013-05-27','14:15:00',3.53),('9303','2013-05-27','14:20:00',3.61),('9303','2013-05-27','14:25:00',4),('9303','2013-05-27','14:30:00',4.25),('9303','2013-05-27','14:35:00',4.06),('9303','2013-05-27','14:40:00',1.15),('9303','2013-05-27','14:45:00',4.75),('9303','2013-05-27','14:50:00',4.42),('9303','2013-05-27','14:55:00',3.24),('9303','2013-05-27','15:00:00',2.69),('9303','2013-05-27','15:05:00',2.6),('9303','2013-05-27','15:10:00',4.12),('9303','2013-05-27','15:15:00',2.9),('9303','2013-05-27','15:20:00',3.32),('9303','2013-05-27','15:25:00',3.22),('9303','2013-05-27','15:30:00',3.46),('9303','2013-05-27','15:35:00',3.94),('9303','2013-05-27','15:40:00',3.18),('9303','2013-05-27','15:45:00',2.88),('9303','2013-05-27','15:50:00',3.54),('9303','2013-05-27','15:55:00',2.36),('9303','2013-05-27','16:00:00',2.98),('9303','2013-05-27','16:05:00',2.13),('9303','2013-05-27','16:10:00',2.52),('9303','2013-05-27','16:15:00',2.2),('9303','2013-05-27','16:20:00',3.56),('9303','2013-05-27','16:25:00',3.44),('9303','2013-05-27','16:30:00',3.14),('9303','2013-05-27','16:35:00',2.89),('9303','2013-05-27','16:40:00',1.34),('9303','2013-05-27','16:45:00',1.16),('9303','2013-05-27','16:50:00',1.16),('9303','2013-05-27','16:55:00',1.26),('9303','2013-05-27','17:00:00',1.32),('9303','2013-05-27','17:05:00',1.37),('9303','2013-05-27','17:10:00',1.67),('9303','2013-05-27','17:15:00',1.37),('9303','2013-05-27','17:20:00',1.19),('9303','2013-05-27','17:25:00',1.08),('9303','2013-05-27','17:30:00',1.06),('9303','2013-05-27','18:25:00',1.27),('9303','2013-05-27','18:30:00',1.11),('9303','2013-05-26','07:40:00',1.02),('9303','2013-05-26','07:45:00',1.24),('9303','2013-05-26','07:50:00',1.72),('9303','2013-05-26','08:05:00',1.92),('9303','2013-05-26','08:10:00',1.78),('9303','2013-05-26','08:20:00',1.13),('9303','2013-05-26','08:25:00',1.48),('9303','2013-05-26','08:30:00',2.08),('9303','2013-05-26','08:35:00',2.16),('9303','2013-05-26','08:40:00',2.31),('9303','2013-05-26','08:45:00',2.18),('9303','2013-05-26','08:50:00',2.13),('9303','2013-05-26','09:00:00',2.3),('9303','2013-05-26','09:10:00',1.83),('9303','2013-05-26','09:15:00',2.37),('9303','2013-05-26','09:25:00',1.27),('9303','2013-05-26','09:45:00',2),('9303','2013-05-26','10:00:00',1.08),('9303','2013-05-26','10:05:00',3.19),('9303','2013-05-26','10:10:00',3.89),('9303','2013-05-26','10:15:00',2.56),('9303','2013-05-26','10:20:00',3.34),('9303','2013-05-26','10:25:00',3.06),('9303','2013-05-26','10:30:00',3.32),('9303','2013-05-26','10:35:00',3.11),('9303','2013-05-26','10:40:00',3.92),('9303','2013-05-26','10:45:00',3.96),('9303','2013-05-26','10:50:00',4.11),('9303','2013-05-26','10:55:00',4.06),('9303','2013-05-26','11:00:00',3.99),('9303','2013-05-26','11:05:00',4.21),('9303','2013-05-26','11:10:00',4.23),('9303','2013-05-26','11:15:00',4.23),('9303','2013-05-26','11:20:00',4.3),('9303','2013-05-26','11:25:00',4.33),('9303','2013-05-26','11:30:00',4.5),('9303','2013-05-26','11:35:00',3.91),('9303','2013-05-26','11:40:00',4.48),('9303','2013-05-26','11:45:00',4.53),('9303','2013-05-26','11:50:00',4.55),('9303','2013-05-26','11:55:00',4.48),('9303','2013-05-26','12:00:00',4.5),('9303','2013-05-26','12:05:00',4.61),('9303','2013-05-26','12:10:00',4.55),('9303','2013-05-26','12:15:00',3.81),('9303','2013-05-26','12:20:00',4.23),('9303','2013-05-26','12:25:00',4.24),('9303','2013-05-26','12:30:00',4.78),('9303','2013-05-26','12:35:00',4.73),('9303','2013-05-26','12:40:00',4.25),('9303','2013-05-26','12:45:00',3.3),('9303','2013-05-26','12:50:00',4.77),('9303','2013-05-26','12:55:00',4.76),('9303','2013-05-26','13:00:00',4.79),('9303','2013-05-26','13:05:00',4.72),('9303','2013-05-26','13:10:00',4.67),('9303','2013-05-26','13:15:00',4.46),('9303','2013-05-26','13:20:00',4.79),('9303','2013-05-26','13:25:00',4.67),('9303','2013-05-26','13:30:00',4.67),('9303','2013-05-26','13:35:00',4.65),('9303','2013-05-26','13:40:00',4.62),('9303','2013-05-26','13:45:00',4.65),('9303','2013-05-26','13:50:00',4.08),('9303','2013-05-26','13:55:00',4.58),('9303','2013-05-26','14:00:00',4.54),('9303','2013-05-26','14:05:00',4.53),('9303','2013-05-26','14:10:00',4.45),('9303','2013-05-26','14:15:00',4.42),('9303','2013-05-26','14:20:00',4.42),('9303','2013-05-26','14:25:00',4.38),('9303','2013-05-26','14:30:00',4.38),('9303','2013-05-26','14:35:00',4.37),('9303','2013-05-26','14:40:00',4.3),('9303','2013-05-26','14:45:00',4.27),('9303','2013-05-26','14:50:00',4.27),('9303','2013-05-26','14:55:00',4.23),('9303','2013-05-26','15:00:00',4.16),('9303','2013-05-26','15:05:00',4.14),('9303','2013-05-26','15:10:00',4.12),('9303','2013-05-26','15:15:00',4.08),('9303','2013-05-26','15:20:00',4.03),('9303','2013-05-26','15:25:00',3.95),('9303','2013-05-26','15:30:00',3.89),('9303','2013-05-26','15:35:00',3.83),('9303','2013-05-26','15:40:00',3.81),('9303','2013-05-26','15:45:00',3.75),('9303','2013-05-26','15:50:00',3.69),('9303','2013-05-26','15:55:00',3.63),('9303','2013-05-26','16:00:00',3.6),('9303','2013-05-26','16:05:00',3.54),('9303','2013-05-26','16:10:00',3.49),('9303','2013-05-26','16:15:00',3.41),('9303','2013-05-26','16:20:00',3.34),('9303','2013-05-26','16:25:00',3.26),('9303','2013-05-26','16:30:00',3.19),('9303','2013-05-26','16:35:00',3.1),('9303','2013-05-26','16:40:00',3.04),('9303','2013-05-26','16:45:00',2.96),('9303','2013-05-26','16:50:00',2.89),('9303','2013-05-26','16:55:00',2.8),('9303','2013-05-26','17:00:00',2.73),('9303','2013-05-26','17:05:00',2.63),('9303','2013-05-26','17:10:00',2.5),('9303','2013-05-26','17:15:00',2.39),('9303','2013-05-26','17:20:00',2.27),('9303','2013-05-26','17:25:00',2.19),('9303','2013-05-26','17:30:00',2.09),('9303','2013-05-26','17:35:00',1.96),('9303','2013-05-26','17:40:00',1.91),('9303','2013-05-26','17:45:00',1.83),('9303','2013-05-26','17:50:00',1.75),('9303','2013-05-26','17:55:00',1.66),('9303','2013-05-26','18:00:00',1.54),('9303','2013-05-26','18:05:00',1.45),('9303','2013-05-26','18:10:00',1.35),('9303','2013-05-26','18:15:00',1.21),('9303','2013-05-26','18:20:00',1.1),('9303','2013-05-26','18:25:00',1.01),('9303','2013-05-25','07:35:00',1.29),('9303','2013-05-25','07:40:00',1.1),('9303','2013-05-25','07:55:00',1.48),('9303','2013-05-25','08:00:00',1.86),('9303','2013-05-25','08:05:00',1.92),('9303','2013-05-25','08:10:00',1.49),('9303','2013-05-25','08:20:00',1.21),('9303','2013-05-25','08:25:00',2.27),('9303','2013-05-25','08:30:00',2.34),('9303','2013-05-25','08:35:00',1.24),('9303','2013-05-25','08:40:00',1.43),('9303','2013-05-25','08:45:00',1.25),('9303','2013-05-25','08:50:00',1.78),('9303','2013-05-25','08:55:00',2.54),('9303','2013-05-25','09:00:00',2.08),('9303','2013-05-25','09:05:00',2.9),('9303','2013-05-25','09:10:00',2.01),('9303','2013-05-25','09:15:00',3.08),('9303','2013-05-25','09:20:00',1.51),('9303','2013-05-25','09:25:00',1.53),('9303','2013-05-25','09:30:00',1.14),('9303','2013-05-25','09:35:00',2.24),('9303','2013-05-25','09:40:00',3.5),('9303','2013-05-25','09:45:00',2.79),('9303','2013-05-25','09:50:00',3.31),('9303','2013-05-25','09:55:00',2.25),('9303','2013-05-25','10:15:00',1.19),('9303','2013-05-25','10:40:00',1.3),('9303','2013-05-25','10:45:00',1.33),('9303','2013-05-25','10:50:00',1.32),('9303','2013-05-25','11:05:00',1.79),('9303','2013-05-25','11:10:00',3.86),('9303','2013-05-25','11:15:00',3.54),('9303','2013-05-25','11:20:00',3.24),('9303','2013-05-25','11:35:00',1.44),('9303','2013-05-25','11:40:00',2.32),('9303','2013-05-25','11:45:00',2.21),('9303','2013-05-25','11:50:00',1.66),('9303','2013-05-25','11:55:00',1.9),('9303','2013-05-25','12:00:00',1.43),('9303','2013-05-25','12:05:00',1.25),('9303','2013-05-25','12:10:00',1.58),('9303','2013-05-25','12:15:00',1.04),('9303','2013-05-25','12:20:00',1.25),('9303','2013-05-25','12:25:00',1.83),('9303','2013-05-25','12:30:00',1.29),('9303','2013-05-25','12:35:00',1.38),('9303','2013-05-25','12:40:00',1.69),('9303','2013-05-25','12:45:00',1.74),('9303','2013-05-25','12:50:00',1.24),('9303','2013-05-25','12:55:00',1.7),('9303','2013-05-25','13:05:00',1.9),('9303','2013-05-25','13:10:00',1.33),('9303','2013-05-25','13:15:00',1.73),('9303','2013-05-25','13:20:00',2.58),('9303','2013-05-25','13:25:00',2.56),('9303','2013-05-25','13:30:00',1.96),('9303','2013-05-25','13:35:00',1.24),('9303','2013-05-25','13:40:00',1.94),('9303','2013-05-25','13:45:00',2.15),('9303','2013-05-25','13:50:00',2.27),('9303','2013-05-25','13:55:00',3.59),('9303','2013-05-25','14:00:00',3.98),('9303','2013-05-25','14:05:00',4.07),('9303','2013-05-25','14:10:00',4.41),('9303','2013-05-25','14:15:00',4.42),('9303','2013-05-25','14:20:00',3.71),('9303','2013-05-25','14:25:00',1.85),('9303','2013-05-25','14:30:00',2.58),('9303','2013-05-25','14:35:00',2.3),('9303','2013-05-25','14:40:00',2.17),('9303','2013-05-25','14:45:00',2.18),('9303','2013-05-25','14:50:00',2.85),('9303','2013-05-25','14:55:00',1.99),('9303','2013-05-25','15:00:00',3.55),('9303','2013-05-25','15:05:00',3.41),('9303','2013-05-25','15:10:00',1.85),('9303','2013-05-25','15:15:00',2.47),('9303','2013-05-25','15:20:00',1.61),('9303','2013-05-25','15:25:00',2.59),('9303','2013-05-25','15:30:00',3.43),('9303','2013-05-25','15:35:00',4.17),('9303','2013-05-25','15:40:00',4.15),('9303','2013-05-25','15:45:00',3.72),('9303','2013-05-25','15:50:00',3.68),('9303','2013-05-25','15:55:00',3.42),('9303','2013-05-25','16:00:00',2.95),('9303','2013-05-25','16:05:00',1.81),('9303','2013-05-25','16:10:00',1.75),('9303','2013-05-25','16:15:00',1.39),('9303','2013-05-25','16:20:00',1.9),('9303','2013-05-25','16:25:00',1.45),('9303','2013-05-25','16:30:00',3.15),('9303','2013-05-25','16:35:00',2.99),('9303','2013-05-25','16:40:00',3.29),('9303','2013-05-25','16:45:00',1.71),('9303','2013-05-25','16:50:00',1.47),('9303','2013-05-25','17:05:00',1.06),('9303','2013-05-25','17:10:00',2.72),('9303','2013-05-25','17:15:00',2.47),('9303','2013-05-25','17:20:00',2.05),('9303','2013-05-25','17:35:00',1.41),('9303','2013-05-25','17:40:00',1.43),('9303','2013-05-25','17:50:00',1.12),('9303','2013-05-24','08:05:00',1.66),('9303','2013-05-24','08:10:00',1.77),('9303','2013-05-24','08:15:00',1.78),('9303','2013-05-24','08:25:00',1.26),('9303','2013-05-24','08:30:00',2),('9303','2013-05-24','08:35:00',1.67),('9303','2013-05-24','08:45:00',2.33),('9303','2013-05-24','08:50:00',2.38),('9303','2013-05-24','08:55:00',2.48),('9303','2013-05-24','09:00:00',2.63),('9303','2013-05-24','09:05:00',2.91),('9303','2013-05-24','09:20:00',1.68),('9303','2013-05-24','09:25:00',1.37),('9303','2013-05-24','09:30:00',2.63),('9303','2013-05-24','09:40:00',1.42),('9303','2013-05-24','09:50:00',1.25),('9303','2013-05-24','09:55:00',2.36),('9303','2013-05-24','10:00:00',2.81),('9303','2013-05-24','10:25:00',1.85),('9303','2013-05-24','10:30:00',3.52),('9303','2013-05-24','10:35:00',3.8),('9303','2013-05-24','10:40:00',4.03),('9303','2013-05-24','10:45:00',3.81),('9303','2013-05-24','10:50:00',3.68),('9303','2013-05-24','10:55:00',4.43),('9303','2013-05-24','11:00:00',3.87),('9303','2013-05-24','11:05:00',3.65),('9303','2013-05-24','11:10:00',3.86),('9303','2013-05-24','11:15:00',3.69),('9303','2013-05-24','11:20:00',4.39),('9303','2013-05-24','11:25:00',4.51),('9303','2013-05-24','11:30:00',3.41),('9303','2013-05-24','11:35:00',1.54),('9303','2013-05-24','11:45:00',2.63),('9303','2013-05-24','11:50:00',4.7),('9303','2013-05-24','11:55:00',3.61),('9303','2013-05-24','12:00:00',1.99),('9303','2013-05-24','12:05:00',2.48),('9303','2013-05-24','12:10:00',4.28),('9303','2013-05-24','12:15:00',2.97),('9303','2013-05-24','12:20:00',2.02),('9303','2013-05-24','12:25:00',3.49),('9303','2013-05-24','12:30:00',4.52),('9303','2013-05-24','12:35:00',1.98),('9303','2013-05-24','12:40:00',2.55),('9303','2013-05-24','12:45:00',2.6),('9303','2013-05-24','12:50:00',3.17),('9303','2013-05-24','12:55:00',2.63),('9303','2013-05-24','13:00:00',2.42),('9303','2013-05-24','13:05:00',1.94),('9303','2013-05-24','13:10:00',2.3),('9303','2013-05-24','13:15:00',2.9),('9303','2013-05-24','13:20:00',3.23),('9303','2013-05-24','13:25:00',2.33),('9303','2013-05-24','13:30:00',1.74),('9303','2013-05-24','13:35:00',3.33),('9303','2013-05-24','13:40:00',2.4),('9303','2013-05-24','13:45:00',1.16),('9303','2013-05-24','13:50:00',1.04),('9303','2013-05-24','13:55:00',2.44),('9303','2013-05-24','14:00:00',2.23),('9303','2013-05-24','14:05:00',2.07),('9303','2013-05-24','14:10:00',1.29),('9303','2013-05-24','14:15:00',4.08),('9303','2013-05-24','14:20:00',3.21),('9303','2013-05-24','14:25:00',2.39),('9303','2013-05-24','14:30:00',2.7),('9303','2013-05-24','14:35:00',3.3),('9303','2013-05-24','14:40:00',2.83),('9303','2013-05-24','14:45:00',2.63),('9303','2013-05-24','14:50:00',1.4),('9303','2013-05-24','14:55:00',1.76),('9303','2013-05-24','15:00:00',2.31),('9303','2013-05-24','15:05:00',3.23),('9303','2013-05-24','15:10:00',2.52),('9303','2013-05-24','15:15:00',2.45),('9303','2013-05-24','15:20:00',4.78),('9303','2013-05-24','15:25:00',3.31),('9303','2013-05-24','15:30:00',3.73),('9303','2013-05-24','15:35:00',3.05),('9303','2013-05-24','15:40:00',3.16),('9303','2013-05-24','15:45:00',4.04),('9303','2013-05-24','15:50:00',4.64),('9303','2013-05-24','15:55:00',4.22),('9303','2013-05-24','16:00:00',2.39),('9303','2013-05-24','16:05:00',2.01),('9303','2013-05-24','16:10:00',2.17),('9303','2013-05-24','16:15:00',2.61),('9303','2013-05-24','16:20:00',2.14),('9303','2013-05-24','16:25:00',2.86),('9303','2013-05-24','16:30:00',3.14),('9303','2013-05-24','16:35:00',1.69),('9303','2013-05-24','16:50:00',1.14),('9303','2013-05-24','16:55:00',1.46),('9303','2013-05-24','17:00:00',1.25),('9303','2013-05-24','17:30:00',1.01),('9303','2013-05-24','17:35:00',1.01),('9303','2013-05-23','08:05:00',1.46),('9303','2013-05-23','08:10:00',1.47),('9303','2013-05-23','08:30:00',1.33),('9303','2013-05-23','08:35:00',1.72),('9303','2013-05-23','08:40:00',2.22),('9303','2013-05-23','08:45:00',2.26),('9303','2013-05-23','08:50:00',1.64),('9303','2013-05-23','09:00:00',2.69),('9303','2013-05-23','09:05:00',1.37),('9303','2013-05-23','09:20:00',2.3),('9303','2013-05-23','09:25:00',3.04),('9303','2013-05-23','09:30:00',3.49),('9303','2013-05-23','09:35:00',2.13),('9303','2013-05-23','09:40:00',2.31),('9303','2013-05-23','09:45:00',1.51),('9303','2013-05-23','09:50:00',3.4),('9303','2013-05-23','09:55:00',1.72),('9303','2013-05-23','10:00:00',1.23),('9303','2013-05-23','10:05:00',3.85),('9303','2013-05-23','10:10:00',2.59),('9303','2013-05-23','10:15:00',3.78),('9303','2013-05-23','10:20:00',2.31),('9303','2013-05-23','10:25:00',3.72),('9303','2013-05-23','10:30:00',3.29),('9303','2013-05-23','10:35:00',3.89),('9303','2013-05-23','10:40:00',3.77),('9303','2013-05-23','10:45:00',4.15),('9303','2013-05-23','10:50:00',3.44),('9303','2013-05-23','10:55:00',3.11),('9303','2013-05-23','11:00:00',2.49),('9303','2013-05-23','11:05:00',2.95),('9303','2013-05-23','11:10:00',3.21),('9303','2013-05-23','11:15:00',2.69),('9303','2013-05-23','11:20:00',2.27),('9303','2013-05-23','11:25:00',2.86),('9303','2013-05-23','11:30:00',2.74),('9303','2013-05-23','11:35:00',3.36),('9303','2013-05-23','11:40:00',4.55),('9303','2013-05-23','11:45:00',3.46),('9303','2013-05-23','11:50:00',2.31),('9303','2013-05-23','11:55:00',3.61),('9303','2013-05-23','12:00:00',4.33),('9303','2013-05-23','12:05:00',4.6),('9303','2013-05-23','12:10:00',4.67),('9303','2013-05-23','12:15:00',4.22),('9303','2013-05-23','12:20:00',3.22),('9303','2013-05-23','12:25:00',3.16),('9303','2013-05-23','12:30:00',3.69),('9303','2013-05-23','12:35:00',2.11),('9303','2013-05-23','12:40:00',4.28),('9303','2013-05-23','12:45:00',3.05),('9303','2013-05-23','12:50:00',3.62),('9303','2013-05-23','12:55:00',3.59),('9303','2013-05-23','13:00:00',4.73),('9303','2013-05-23','13:05:00',3.13),('9303','2013-05-23','13:10:00',4.51),('9303','2013-05-23','13:15:00',4.28),('9303','2013-05-23','13:20:00',3.38),('9303','2013-05-23','13:25:00',4.48),('9303','2013-05-23','13:30:00',4.15),('9303','2013-05-23','13:35:00',2.35),('9303','2013-05-23','13:40:00',2.05),('9303','2013-05-23','13:45:00',2.81),('9303','2013-05-23','13:50:00',3.36),('9303','2013-05-23','13:55:00',3.97),('9303','2013-05-23','14:00:00',4.34),('9303','2013-05-23','14:05:00',4.49),('9303','2013-05-23','14:10:00',3.05),('9303','2013-05-23','14:15:00',3.92),('9303','2013-05-23','14:20:00',4.38),('9303','2013-05-23','14:25:00',2.39),('9303','2013-05-23','14:30:00',1.84),('9303','2013-05-23','14:35:00',4.83),('9303','2013-05-23','14:40:00',3.27),('9303','2013-05-23','14:45:00',2.25),('9303','2013-05-23','14:50:00',2.18),('9303','2013-05-23','14:55:00',3.72),('9303','2013-05-23','15:00:00',4.27),('9303','2013-05-23','15:05:00',3.77),('9303','2013-05-23','15:10:00',1.27),('9303','2013-05-23','15:15:00',1.48),('9303','2013-05-23','15:20:00',3.31),('9303','2013-05-23','15:25:00',1.71),('9303','2013-05-23','15:30:00',2.54),('9303','2013-05-23','15:35:00',3.47),('9303','2013-05-23','15:40:00',1.74),('9303','2013-05-23','15:45:00',2.93),('9303','2013-05-23','15:50:00',1.18),('9303','2013-05-23','15:55:00',1.33),('9303','2013-05-23','16:00:00',3),('9303','2013-05-23','16:05:00',4.01),('9303','2013-05-23','16:10:00',2.58),('9303','2013-05-23','16:15:00',2.1),('9303','2013-05-23','16:20:00',3.13),('9303','2013-05-23','16:25:00',1.98),('9303','2013-05-23','16:30:00',2.99),('9303','2013-05-23','16:35:00',1.12),('9303','2013-05-23','16:40:00',1.31),('9303','2013-05-23','16:45:00',2),('9303','2013-05-23','17:10:00',2.15),('9303','2013-05-23','17:15:00',1.57),('9303','2013-05-23','17:35:00',1.26),('9303','2013-05-23','17:40:00',1.03),('9303','2013-05-23','17:55:00',1.14),('9303','2013-05-23','18:00:00',1.5),('9303','2013-05-23','18:05:00',1.99),('9303','2013-05-22','08:05:00',1.38),('9303','2013-05-22','08:10:00',1.04),('9303','2013-05-22','08:15:00',1.94),('9303','2013-05-22','08:20:00',1.9),('9303','2013-05-22','08:25:00',1.64),('9303','2013-05-22','08:30:00',2.06),('9303','2013-05-22','08:35:00',2.44),('9303','2013-05-22','08:40:00',1.48),('9303','2013-05-22','08:45:00',1.5),('9303','2013-05-22','09:30:00',2.77),('9303','2013-05-22','09:35:00',2.86),('9303','2013-05-22','09:40:00',2.84),('9303','2013-05-22','09:45:00',2.86),('9303','2013-05-22','09:50:00',2.93),('9303','2013-05-22','09:55:00',3.01),('9303','2013-05-22','10:00:00',3.08),('9303','2013-05-22','10:05:00',3.12),('9303','2013-05-22','10:10:00',3.2),('9303','2013-05-22','10:15:00',3.24),('9303','2013-05-22','10:20:00',3.14),('9303','2013-05-22','10:25:00',3.34),('9303','2013-05-22','10:30:00',3.4),('9303','2013-05-22','10:35:00',3.44),('9303','2013-05-22','10:40:00',3.62),('9303','2013-05-22','10:45:00',3.6),('9303','2013-05-22','10:50:00',3.56),('9303','2013-05-22','10:55:00',3.58),('9303','2013-05-22','11:00:00',3.65),('9303','2013-05-22','11:05:00',3.75),('9303','2013-05-22','11:10:00',3.19),('9303','2013-05-22','11:15:00',3.54),('9303','2013-05-22','11:20:00',3.9),('9303','2013-05-22','11:25:00',4.06),('9303','2013-05-22','11:30:00',3.15),('9303','2013-05-22','11:35:00',3.38),('9303','2013-05-22','11:40:00',3.08),('9303','2013-05-22','11:45:00',4.19),('9303','2013-05-22','11:50:00',2.71),('9303','2013-05-22','11:55:00',1.91),('9303','2013-05-22','12:00:00',2.73),('9303','2013-05-22','12:05:00',2.18),('9303','2013-05-22','12:10:00',2.09),('9303','2013-05-22','12:15:00',2.7),('9303','2013-05-22','12:20:00',3.59),('9303','2013-05-22','12:25:00',3.24),('9303','2013-05-22','12:30:00',2.2),('9303','2013-05-22','12:35:00',2.2),('9303','2013-05-22','12:40:00',1.61),('9303','2013-05-22','13:05:00',3.81),('9303','2013-05-22','13:10:00',2.41),('9303','2013-05-22','13:15:00',2.34),('9303','2013-05-22','13:20:00',2.55),('9303','2013-05-22','13:25:00',1.04),('9303','2013-05-22','13:30:00',1.58),('9303','2013-05-22','13:35:00',3.59),('9303','2013-05-22','13:40:00',2.93),('9303','2013-05-22','13:45:00',2.4),('9303','2013-05-22','13:50:00',2.01),('9303','2013-05-22','13:55:00',1.86),('9303','2013-05-22','14:00:00',2.65),('9303','2013-05-22','14:05:00',3.79),('9303','2013-05-22','14:10:00',4.18),('9303','2013-05-22','14:15:00',4.18),('9303','2013-05-22','14:20:00',4.07),('9303','2013-05-22','14:25:00',3.99),('9303','2013-05-22','14:30:00',3.96),('9303','2013-05-22','14:35:00',3.97),('9303','2013-05-22','14:40:00',3.93),('9303','2013-05-22','14:45:00',3.88),('9303','2013-05-22','14:50:00',3.85),('9303','2013-05-22','14:55:00',3.81),('9303','2013-05-22','15:00:00',3.76),('9303','2013-05-22','15:05:00',3.72),('9303','2013-05-22','15:10:00',3.67),('9303','2013-05-22','15:15:00',3.58),('9303','2013-05-22','15:20:00',3.16),('9303','2013-05-22','15:25:00',2.22),('9303','2013-05-22','15:30:00',1.56),('9303','2013-05-22','15:35:00',2.12),('9303','2013-05-22','15:40:00',2.15),('9303','2013-05-22','15:45:00',2.49),('9303','2013-05-22','15:50:00',3.33),('9303','2013-05-22','15:55:00',3.25),('9303','2013-05-22','16:00:00',3.17),('9303','2013-05-22','16:05:00',3.08),('9303','2013-05-22','16:10:00',3),('9303','2013-05-22','16:15:00',2.99),('9303','2013-05-22','16:20:00',2.89),('9303','2013-05-22','16:25:00',2.83),('9303','2013-05-22','16:30:00',2.76),('9303','2013-05-22','16:35:00',2.67),('9303','2013-05-22','16:40:00',2.62),('9303','2013-05-22','16:45:00',1.95),('9303','2013-05-22','16:50:00',1.3),('9303','2013-05-22','17:20:00',1.23),('9303','2013-05-22','17:25:00',1.63),('9303','2013-05-22','17:30:00',1.26),('9303','2013-05-22','17:35:00',1.32),('9303','2013-05-22','17:55:00',1.08),('9303','2013-05-22','18:00:00',1.34),('9303','2014-04-01','08:25:00',1.05),('9303','2014-04-01','08:30:00',1.14),('9303','2014-04-01','08:35:00',1.24),('9303','2014-04-01','08:40:00',1.34),('9303','2014-04-01','08:45:00',1.45),('9303','2014-04-01','08:50:00',1.54),('9303','2014-04-01','08:55:00',1.65),('9303','2014-04-01','09:00:00',1.76),('9303','2014-04-01','09:05:00',1.86),('9303','2014-04-01','09:10:00',1.95),('9303','2014-04-01','09:15:00',2.02),('9303','2014-04-01','09:20:00',2.09),('9303','2014-04-01','09:25:00',2.16),('9303','2014-04-01','09:30:00',2.24),('9303','2014-04-01','09:35:00',2.32),('9303','2014-04-01','09:40:00',2.39),('9303','2014-04-01','09:45:00',2.49),('9303','2014-04-01','09:50:00',2.54),('9303','2014-04-01','09:55:00',2.62),('9303','2014-04-01','10:00:00',2.71),('9303','2014-04-01','10:05:00',2.73),('9303','2014-04-01','10:10:00',2.76),('9303','2014-04-01','10:15:00',2.94),('9303','2014-04-01','10:20:00',3.07),('9303','2014-04-01','10:25:00',3.18),('9303','2014-04-01','10:30:00',2.74),('9303','2014-04-01','10:35:00',3.05),('9303','2014-04-01','10:40:00',2.99),('9303','2014-04-01','10:45:00',1.72),('9303','2014-04-01','10:50:00',3.33),('9303','2014-04-01','10:55:00',3.51),('9303','2014-04-01','11:00:00',3.49),('9303','2014-04-01','11:05:00',3.54),('9303','2014-04-01','11:10:00',3.52),('9303','2014-04-01','11:15:00',3.57),('9303','2014-04-01','11:20:00',3.6),('9303','2014-04-01','11:25:00',3.59),('9303','2014-04-01','11:30:00',3.76),('9303','2014-04-01','11:35:00',3.77),('9303','2014-04-01','11:40:00',3.8),('9303','2014-04-01','11:45:00',3.85),('9303','2014-04-01','11:50:00',3.92),('9303','2014-04-01','11:55:00',3.9),('9303','2014-04-01','12:00:00',3.97),('9303','2014-04-01','12:05:00',3.92),('9303','2014-04-01','12:10:00',3.99),('9303','2014-04-01','12:15:00',4),('9303','2014-04-01','12:20:00',4.05),('9303','2014-04-01','12:25:00',4.1),('9303','2014-04-01','12:30:00',4.13),('9303','2014-04-01','12:35:00',4.16),('9303','2014-04-01','12:40:00',4.15),('9303','2014-04-01','12:45:00',4.19),('9303','2014-04-01','12:50:00',4.22),('9303','2014-04-01','12:55:00',4.2),('9303','2014-04-01','13:00:00',4.23),('9303','2014-04-01','13:05:00',4.36),('9303','2014-04-01','13:10:00',4.19),('9303','2014-04-01','13:15:00',3.41),('9303','2014-04-01','13:20:00',4.26),('9303','2014-04-01','13:25:00',4.18),('9303','2014-04-01','13:30:00',4.21),('9303','2014-04-01','13:35:00',4.21),('9303','2014-04-01','13:40:00',4.23),('9303','2014-04-01','13:45:00',4.04),('9303','2014-04-01','13:50:00',4.06),('9303','2014-04-01','13:55:00',4.08),('9303','2014-04-01','14:00:00',4.16),('9303','2014-04-01','14:05:00',4.14),('9303','2014-04-01','14:10:00',4.11),('9303','2014-04-01','14:15:00',4.11),('9303','2014-04-01','14:20:00',4.03),('9303','2014-04-01','14:25:00',3.93),('9303','2014-04-01','14:30:00',3.07),('9303','2014-04-01','14:35:00',3.6),('9303','2014-04-01','14:40:00',4.09),('9303','2014-04-01','14:45:00',4.12),('9303','2014-04-01','14:50:00',3.27),('9303','2014-04-01','14:55:00',3.87),('9303','2014-04-01','15:00:00',3.47),('9303','2014-04-01','15:05:00',3.47),('9303','2014-04-01','15:10:00',3.77),('9303','2014-04-01','15:15:00',2.95),('9303','2014-04-01','15:20:00',3.12),('9303','2014-04-01','15:25:00',3.76),('9303','2014-04-01','15:30:00',3.72),('9303','2014-04-01','15:35:00',2.8),('9303','2014-04-01','15:40:00',2.44),('9303','2014-04-01','15:45:00',3.56),('9303','2014-04-01','15:50:00',3.33),('9303','2014-04-01','15:55:00',2.18),('9303','2014-04-01','16:00:00',2.77),('9303','2014-04-01','16:05:00',2.53),('9303','2014-04-01','16:10:00',2.64),('9303','2014-04-01','16:15:00',2.64),('9303','2014-04-01','16:20:00',2.63),('9303','2014-04-01','16:25:00',1.49),('9303','2014-04-01','16:30:00',2.49),('9303','2014-04-01','16:35:00',2.18),('9303','2014-04-01','16:40:00',1.42),('9303','2014-04-01','16:45:00',2.08),('9303','2014-04-01','16:50:00',1.9),('9303','2014-04-01','16:55:00',1.8),('9303','2014-04-01','17:00:00',2.12),('9303','2014-04-01','17:05:00',1.95),('9303','2014-04-01','17:10:00',1.96),('9303','2014-04-01','17:15:00',1.75),('9303','2014-04-01','17:20:00',1.74),('9303','2014-04-01','17:25:00',1.56),('9303','2014-04-01','17:30:00',1.55),('9303','2014-04-01','17:35:00',1.43),('9303','2014-04-01','17:40:00',1.3),('9303','2014-04-01','17:45:00',1.2),('9303','2014-04-01','17:50:00',1.12),('9303','2014-04-01','17:55:00',1.01),('9303','2013-05-21','07:35:00',1.14),('9303','2013-05-21','07:40:00',1.32),('9303','2013-05-21','07:45:00',1.14),('9303','2013-05-21','08:00:00',1.12),('9303','2013-05-21','08:10:00',1.35),('9303','2013-05-21','08:15:00',1.76),('9303','2013-05-21','08:20:00',1.34),('9303','2013-05-21','08:25:00',1.82),('9303','2013-05-21','08:30:00',1.27),('9303','2013-05-21','08:35:00',1.19),('9303','2013-05-21','08:40:00',1.38),('9303','2013-05-21','08:45:00',1.19),('9303','2013-05-21','08:50:00',1.25),('9303','2013-05-21','08:55:00',1.65),('9303','2013-05-21','09:00:00',1.39),('9303','2013-05-21','09:05:00',1.24),('9303','2013-05-21','09:10:00',1.39),('9303','2013-05-21','09:15:00',1.55),('9303','2013-05-21','09:20:00',1.99),('9303','2013-05-21','09:25:00',2.34),('9303','2013-05-21','09:30:00',1.86),('9303','2013-05-21','09:35:00',1.8),('9303','2013-05-21','09:40:00',1.84),('9303','2013-05-21','09:45:00',1.61),('9303','2013-05-21','09:50:00',1.54),('9303','2013-05-21','09:55:00',1.76),('9303','2013-05-21','10:00:00',1.88),('9303','2013-05-21','10:05:00',1.93),('9303','2013-05-21','10:10:00',2.16),('9303','2013-05-21','10:15:00',2.22),('9303','2013-05-21','10:20:00',2.02),('9303','2013-05-21','10:25:00',1.86),('9303','2013-05-21','10:30:00',1.71),('9303','2013-05-21','10:35:00',1.73),('9303','2013-05-21','10:40:00',1.92),('9303','2013-05-21','10:45:00',2.96),('9303','2013-05-21','10:50:00',2.05),('9303','2013-05-21','10:55:00',1.55),('9303','2013-05-21','11:00:00',1.74),('9303','2013-05-21','11:05:00',1.63),('9303','2013-05-21','11:10:00',2.66),('9303','2013-05-21','11:15:00',3.85),('9303','2013-05-21','11:20:00',3.06),('9303','2013-05-21','11:25:00',3.93),('9303','2013-05-21','11:30:00',2.9),('9303','2013-05-21','11:35:00',2.32),('9303','2013-05-21','11:40:00',2.51),('9303','2013-05-21','11:45:00',3.42),('9303','2013-05-21','11:50:00',2.79),('9303','2013-05-21','11:55:00',3.59),('9303','2013-05-21','12:00:00',2.81),('9303','2013-05-21','12:05:00',3.6),('9303','2013-05-21','12:10:00',2.79),('9303','2013-05-21','12:15:00',2.93),('9303','2013-05-21','12:20:00',2.17),('9303','2013-05-21','12:25:00',2.92),('9303','2013-05-21','12:30:00',4.08),('9303','2013-05-21','12:35:00',2.38),('9303','2013-05-21','12:40:00',3.88),('9303','2013-05-21','12:45:00',3.9),('9303','2013-05-21','12:50:00',2.45),('9303','2013-05-21','12:55:00',4.48),('9303','2013-05-21','13:00:00',3.83),('9303','2013-05-21','13:05:00',4.22),('9303','2013-05-21','13:10:00',2.45),('9303','2013-05-21','13:15:00',3.59),('9303','2013-05-21','13:20:00',2.9),('9303','2013-05-21','13:25:00',3.03),('9303','2013-05-21','13:30:00',2.88),('9303','2013-05-21','13:35:00',1.43),('9303','2013-05-21','14:10:00',1.62),('9303','2013-05-21','14:15:00',1.86),('9303','2013-05-21','14:20:00',1.66),('9303','2013-05-21','14:25:00',2.31),('9303','2013-05-21','14:30:00',2.43),('9303','2013-05-21','14:35:00',1.92),('9303','2013-05-21','14:40:00',1.79),('9303','2013-05-21','14:45:00',1.54),('9303','2013-05-21','15:20:00',1.41),('9303','2013-05-21','15:25:00',1.45),('9303','2013-05-21','15:30:00',2.16),('9303','2013-05-21','15:35:00',1.5),('9303','2013-05-21','15:40:00',1.22),('9303','2013-05-21','15:45:00',1.3),('9303','2013-05-21','15:50:00',1.17),('9303','2013-05-21','15:55:00',1.15),('9303','2013-05-21','16:00:00',1.12),('9303','2013-05-21','16:05:00',1.1),('9303','2013-05-21','16:10:00',1.24),('9303','2013-05-21','16:15:00',1.06),('9303','2013-05-21','16:25:00',1.15),('9303','2013-05-21','16:30:00',1.7),('9303','2013-05-21','16:35:00',1.93),('9303','2013-05-21','16:40:00',1.87),('9303','2013-05-21','16:45:00',1.79),('9303','2013-05-21','16:50:00',1.06),('9303','2013-05-20','07:40:00',1.02),('9303','2013-05-20','07:45:00',1.14),('9303','2013-05-20','07:50:00',1.16),('9303','2013-05-20','07:55:00',1.25),('9303','2013-05-20','08:00:00',1.43),('9303','2013-05-20','08:05:00',1.2),('9303','2013-05-20','08:10:00',1.47),('9303','2013-05-20','08:15:00',1.25),('9303','2013-05-20','08:20:00',1.24),('9303','2013-05-20','08:45:00',1.25),('9303','2013-05-20','08:50:00',2.97),('9303','2013-05-20','08:55:00',2.72),('9303','2013-05-20','09:00:00',2.83),('9303','2013-05-20','09:05:00',2.3),('9303','2013-05-20','09:10:00',3.13),('9303','2013-05-20','09:15:00',2.11),('9303','2013-05-20','09:20:00',1.64),('9303','2013-05-20','09:25:00',1.52),('9303','2013-05-20','09:30:00',1.16),('9303','2013-05-20','09:35:00',1.85),('9303','2013-05-20','09:40:00',1.13),('9303','2013-05-20','09:45:00',1.17),('9303','2013-05-20','09:50:00',3.12),('9303','2013-05-20','10:05:00',1.07),('9303','2013-05-20','10:10:00',1.42),('9303','2013-05-20','10:15:00',1.13),('9303','2013-05-20','10:25:00',1.35),('9303','2013-05-20','10:30:00',2.78),('9303','2013-05-20','10:35:00',2.97),('9303','2013-05-20','10:45:00',1.54),('9303','2013-05-20','10:50:00',1.48),('9303','2013-05-20','10:55:00',1.62),('9303','2013-05-20','11:00:00',3.12),('9303','2013-05-20','11:05:00',3.55),('9303','2013-05-20','11:10:00',4.06),('9303','2013-05-20','11:15:00',2.48),('9303','2013-05-20','11:20:00',3.01),('9303','2013-05-20','11:25:00',3.24),('9303','2013-05-20','11:30:00',3.35),('9303','2013-05-20','11:35:00',4.09),('9303','2013-05-20','11:40:00',1.45),('9303','2013-05-20','11:45:00',2.11),('9303','2013-05-20','11:50:00',1.96),('9303','2013-05-20','11:55:00',3.94),('9303','2013-05-20','12:00:00',2.6),('9303','2013-05-20','12:05:00',3.78),('9303','2013-05-20','12:10:00',3.23),('9303','2013-05-20','12:15:00',2.29),('9303','2013-05-20','12:20:00',3.44),('9303','2013-05-20','12:25:00',1.59),('9303','2013-05-20','12:30:00',2.27),('9303','2013-05-20','12:35:00',2.83),('9303','2013-05-20','12:40:00',2.77),('9303','2013-05-20','12:45:00',4.21),('9303','2013-05-20','12:50:00',1.97),('9303','2013-05-20','12:55:00',1.89),('9303','2013-05-20','13:00:00',1.77),('9303','2013-05-20','13:05:00',3.72),('9303','2013-05-20','13:10:00',2.74),('9303','2013-05-20','13:15:00',2.38),('9303','2013-05-20','13:20:00',4.56),('9303','2013-05-20','13:25:00',4.01),('9303','2013-05-20','13:30:00',3.14),('9303','2013-05-20','13:35:00',2.89),('9303','2013-05-20','13:40:00',2.36),('9303','2013-05-20','13:45:00',2.6),('9303','2013-05-20','13:50:00',4.89),('9303','2013-05-20','13:55:00',3.31),('9303','2013-05-20','14:00:00',4.66),('9303','2013-05-20','14:05:00',2.5),('9303','2013-05-20','14:10:00',1.37),('9303','2013-05-20','14:15:00',4.11),('9303','2013-05-20','14:20:00',3.04),('9303','2013-05-20','14:25:00',2.49),('9303','2013-05-20','14:30:00',4.53),('9303','2013-05-20','14:35:00',3.43),('9303','2013-05-20','14:40:00',1.76),('9303','2013-05-20','14:45:00',3.79),('9303','2013-05-20','14:50:00',4.53),('9303','2013-05-20','14:55:00',4.23),('9303','2013-05-20','15:00:00',3.27),('9303','2013-05-20','15:05:00',1.18),('9303','2013-05-20','15:10:00',4.24),('9303','2013-05-20','15:15:00',3.35),('9303','2013-05-20','15:20:00',3.05),('9303','2013-05-20','15:25:00',4.25),('9303','2013-05-20','15:30:00',4.09),('9303','2013-05-20','15:35:00',4.2),('9303','2013-05-20','15:40:00',2.26),('9303','2013-05-20','15:45:00',2.05),('9303','2013-05-20','15:50:00',2.82),('9303','2013-05-20','15:55:00',1.64),('9303','2013-05-20','16:00:00',2.1),('9303','2013-05-20','16:05:00',3.49),('9303','2013-05-20','16:10:00',3.61),('9303','2013-05-20','16:15:00',3.59),('9303','2013-05-20','16:20:00',3.31),('9303','2013-05-20','16:25:00',3.25),('9303','2013-05-20','16:30:00',3.14),('9303','2013-05-20','16:35:00',3.02),('9303','2013-05-20','16:40:00',2.96),('9303','2013-05-20','16:45:00',2.71),('9303','2013-05-20','16:50:00',2.68),('9303','2013-05-20','16:55:00',2.62),('9303','2013-05-20','17:00:00',2.45),('9303','2013-05-20','17:05:00',2.45),('9303','2013-05-20','17:10:00',1.85),('9303','2013-05-20','17:15:00',1.13),('9303','2013-05-20','17:20:00',1.86),('9303','2013-05-20','17:25:00',2.37),('9303','2013-05-20','17:30:00',2.34),('9303','2013-05-20','17:35:00',1.93),('9303','2013-05-20','17:40:00',1.71),('9303','2013-05-20','17:45:00',1.62),('9303','2013-05-20','17:50:00',1.58),('9303','2013-05-20','17:55:00',1.47),('9303','2013-05-20','18:00:00',1.42),('9303','2013-05-20','18:05:00',1.41),('9303','2013-05-20','18:10:00',1.05),('9303','2013-05-20','18:15:00',1.31),('9303','2013-05-20','18:20:00',1.08),('9303','2013-05-19','08:35:00',1.1),('9303','2013-05-19','08:50:00',1.13),('9303','2013-05-19','08:55:00',1.52),('9303','2013-05-19','09:00:00',1.39),('9303','2013-05-19','09:05:00',1.09),('9303','2013-05-19','09:10:00',1.2),('9303','2013-05-19','09:15:00',1.28),('9303','2013-05-19','09:20:00',1.02),('9303','2013-05-19','09:45:00',1.11),('9303','2013-05-19','10:00:00',1.32),('9303','2013-05-19','10:05:00',1.44),('9303','2013-05-19','10:10:00',1.91),('9303','2013-05-19','10:15:00',2.89),('9303','2013-05-19','10:20:00',3.14),('9303','2013-05-19','10:25:00',2.2),('9303','2013-05-19','10:30:00',2.78),('9303','2013-05-19','10:35:00',2.37),('9303','2013-05-19','10:40:00',2.32),('9303','2013-05-19','10:45:00',3.39),('9303','2013-05-19','10:50:00',2.1),('9303','2013-05-19','10:55:00',3.07),('9303','2013-05-19','11:00:00',2.05),('9303','2013-05-19','11:05:00',2.49),('9303','2013-05-19','11:10:00',2.04),('9303','2013-05-19','11:15:00',4.24),('9303','2013-05-19','11:20:00',4.4),('9303','2013-05-19','11:25:00',4.3),('9303','2013-05-19','11:30:00',4.31),('9303','2013-05-19','11:35:00',4.28),('9303','2013-05-19','11:40:00',4.39),('9303','2013-05-19','11:45:00',4.42),('9303','2013-05-19','11:50:00',4.4),('9303','2013-05-19','11:55:00',4.47),('9303','2013-05-19','12:00:00',4.48),('9303','2013-05-19','12:05:00',4.43),('9303','2013-05-19','12:10:00',4.48),('9303','2013-05-19','12:15:00',4.53),('9303','2013-05-19','12:20:00',4.77),('9303','2013-05-19','12:25:00',4.58),('9303','2013-05-19','12:30:00',3.83),('9303','2013-05-19','12:35:00',4.54),('9303','2013-05-19','12:40:00',4.53),('9303','2013-05-19','12:45:00',4.68),('9303','2013-05-19','12:50:00',3.46),('9303','2013-05-19','12:55:00',2.72),('9303','2013-05-19','13:00:00',4.33),('9303','2013-05-19','13:05:00',4.33),('9303','2013-05-19','13:10:00',4.03),('9303','2013-05-19','13:15:00',3.81),('9303','2013-05-19','13:20:00',4.25),('9303','2013-05-19','13:25:00',4.03),('9303','2013-05-19','13:30:00',4.43),('9303','2013-05-19','13:35:00',4.47),('9303','2013-05-19','13:40:00',4.43),('9303','2013-05-19','13:45:00',4.37),('9303','2013-05-19','13:50:00',4.37),('9303','2013-05-19','13:55:00',4.42),('9303','2013-05-19','14:00:00',4.38),('9303','2013-05-19','14:05:00',4.37),('9303','2013-05-19','14:10:00',4.33),('9303','2013-05-19','14:15:00',4.29),('9303','2013-05-19','14:20:00',4.29),('9303','2013-05-19','14:25:00',4.26),('9303','2013-05-19','14:30:00',4.25),('9303','2013-05-19','14:35:00',4.21),('9303','2013-05-19','14:40:00',4.21),('9303','2013-05-19','14:45:00',4.17),('9303','2013-05-19','14:50:00',4.12),('9303','2013-05-19','14:55:00',4.08),('9303','2013-05-19','15:00:00',4.08),('9303','2013-05-19','15:05:00',4.04),('9303','2013-05-19','15:10:00',4),('9303','2013-05-19','15:15:00',3.97),('9303','2013-05-19','15:20:00',3.89),('9303','2013-05-19','15:25:00',3.84),('9303','2013-05-19','15:30:00',3.79),('9303','2013-05-19','15:35:00',3.75),('9303','2013-05-19','15:40:00',3.69),('9303','2013-05-19','15:45:00',3.65),('9303','2013-05-19','15:50:00',3.59),('9303','2013-05-19','15:55:00',3.55),('9303','2013-05-19','16:00:00',3.48),('9303','2013-05-19','16:05:00',3.38),('9303','2013-05-19','16:10:00',3.33),('9303','2013-05-19','16:15:00',3.26),('9303','2013-05-19','16:20:00',3.2),('9303','2013-05-19','16:25:00',3.15),('9303','2013-05-19','16:30:00',3.07),('9303','2013-05-19','16:35:00',3.02),('9303','2013-05-19','16:40:00',2.96),('9303','2013-05-19','16:45:00',2.9),('9303','2013-05-19','16:50:00',2.81),('9303','2013-05-19','16:55:00',2.75),('9303','2013-05-19','17:00:00',2.64),('9303','2013-05-19','17:05:00',2.53),('9303','2013-05-19','17:10:00',2.42),('9303','2013-05-19','17:15:00',2.3),('9303','2013-05-19','17:20:00',2.22),('9303','2013-05-19','17:25:00',2.13),('9303','2013-05-19','17:30:00',2.03),('9303','2013-05-19','17:35:00',1.96),('9303','2013-05-19','17:40:00',1.84),('9303','2013-05-19','17:45:00',1.76),('9303','2013-05-19','17:50:00',1.69),('9303','2013-05-19','17:55:00',1.57),('9303','2013-05-19','18:00:00',1.49),('9303','2013-05-19','18:05:00',1.4),('9303','2013-05-19','18:10:00',1.3),('9303','2013-05-19','18:15:00',1.2),('9303','2013-05-19','18:20:00',1.1),('9303','2013-05-18','07:40:00',1.02),('9303','2013-05-18','07:45:00',1.11),('9303','2013-05-18','07:50:00',1),('9303','2013-05-18','07:55:00',1.46),('9303','2013-05-18','08:00:00',1.73),('9303','2013-05-18','08:05:00',1.75),('9303','2013-05-18','08:20:00',1.16),('9303','2013-05-18','08:25:00',2.29),('9303','2013-05-18','08:30:00',2.06),('9303','2013-05-18','08:35:00',1.89),('9303','2013-05-18','08:40:00',2.11),('9303','2013-05-18','08:45:00',2.16),('9303','2013-05-18','08:50:00',2.24),('9303','2013-05-18','08:55:00',2.32),('9303','2013-05-18','09:00:00',2.4),('9303','2013-05-18','09:05:00',2.4),('9303','2013-05-18','09:10:00',2.57),('9303','2013-05-18','09:15:00',2.65),('9303','2013-05-18','09:20:00',2.71),('9303','2013-05-18','09:25:00',2.76),('9303','2013-05-18','09:30:00',2.83),('9303','2013-05-18','09:35:00',2.88),('9303','2013-05-18','09:40:00',2.92),('9303','2013-05-18','09:45:00',2.98),('9303','2013-05-18','09:50:00',3.07),('9303','2013-05-18','09:55:00',3.14),('9303','2013-05-18','10:00:00',3.18),('9303','2013-05-18','10:05:00',3.22),('9303','2013-05-18','10:10:00',3.31),('9303','2013-05-18','10:15:00',3.34),('9303','2013-05-18','10:20:00',3.42),('9303','2013-05-18','10:25:00',3.47),('9303','2013-05-18','10:30:00',3.51),('9303','2013-05-18','10:35:00',3.51),('9303','2013-05-18','10:40:00',3.57),('9303','2013-05-18','10:45:00',3.6),('9303','2013-05-18','10:50:00',3.65),('9303','2013-05-18','10:55:00',3.51),('9303','2013-05-18','11:00:00',3.88),('9303','2013-05-18','11:05:00',3.65),('9303','2013-05-18','11:10:00',3.18),('9303','2013-05-18','11:15:00',4.18),('9303','2013-05-18','11:20:00',4),('9303','2013-05-18','11:25:00',4.02),('9303','2013-05-18','11:30:00',3.92),('9303','2013-05-18','11:35:00',3.73),('9303','2013-05-18','11:40:00',3.96),('9303','2013-05-18','11:45:00',3.91),('9303','2013-05-18','11:50:00',3.86),('9303','2013-05-18','11:55:00',3.95),('9303','2013-05-18','12:00:00',3.8),('9303','2013-05-18','12:05:00',3.98),('9303','2013-05-18','12:10:00',3.98),('9303','2013-05-18','12:15:00',3.97),('9303','2013-05-18','12:20:00',3.99),('9303','2013-05-18','12:25:00',4.04),('9303','2013-05-18','12:30:00',3.21),('9303','2013-05-18','12:35:00',4.11),('9303','2013-05-18','12:40:00',4.08),('9303','2013-05-18','12:45:00',3.9),('9303','2013-05-18','12:50:00',4.1),('9303','2013-05-18','12:55:00',4.09),('9303','2013-05-18','13:00:00',4.08),('9303','2013-05-18','13:05:00',4.08),('9303','2013-05-17','07:45:00',1.06),('9303','2013-05-17','07:50:00',1.09),('9303','2013-05-17','08:00:00',1.2),('9303','2013-05-17','08:15:00',1.46),('9303','2013-05-17','08:20:00',2.11),('9303','2013-05-17','08:25:00',1.43),('9303','2013-05-17','08:30:00',1.08),('9303','2013-05-17','09:25:00',1.06),('9303','2013-05-17','10:25:00',1.18),('9303','2013-05-17','10:30:00',1.51),('9303','2013-05-17','10:35:00',1.19),('9303','2013-05-17','10:40:00',1.29),('9303','2013-05-17','10:45:00',1.44),('9303','2013-05-17','10:50:00',2.63),('9303','2013-05-17','10:55:00',3.41),('9303','2013-05-17','11:00:00',2.31),('9303','2013-05-17','11:05:00',1.96),('9303','2013-05-17','11:10:00',1.33),('9303','2013-05-17','11:15:00',2.14),('9303','2013-05-17','11:20:00',1.99),('9303','2013-05-17','11:25:00',1.64),('9303','2013-05-17','11:30:00',1.53),('9303','2013-05-17','11:35:00',2.27),('9303','2013-05-17','11:40:00',1.43),('9303','2013-05-17','11:45:00',1.51),('9303','2013-05-17','11:50:00',3.63),('9303','2013-05-17','11:55:00',2.13),('9303','2013-05-17','12:00:00',3.09),('9303','2013-05-17','12:05:00',2.86),('9303','2013-05-17','12:10:00',3.56),('9303','2013-05-17','12:15:00',2.45),('9303','2013-05-17','12:20:00',2.59),('9303','2013-05-17','12:25:00',2.8),('9303','2013-05-17','12:30:00',2.1),('9303','2013-05-17','12:35:00',2.95),('9303','2013-05-17','12:40:00',4.15),('9303','2013-05-17','12:45:00',4.82),('9303','2013-05-17','12:50:00',4.69),('9303','2013-05-17','12:55:00',4.33),('9303','2013-05-17','13:00:00',3.29),('9303','2013-05-17','13:05:00',4.19),('9303','2013-05-17','13:10:00',3.59),('9303','2013-05-17','13:15:00',3.83),('9303','2013-05-17','13:20:00',4.57),('9303','2013-05-17','13:25:00',4.29),('9303','2013-05-17','13:30:00',3.03),('9303','2013-05-17','13:35:00',4.54),('9303','2013-05-17','13:40:00',3.81),('9303','2013-05-17','13:45:00',3.92),('9303','2013-05-17','13:50:00',4.02),('9303','2013-05-17','13:55:00',4.64),('9303','2013-05-17','14:00:00',2.84),('9303','2013-05-17','14:05:00',2.93),('9303','2013-05-17','14:10:00',4.14),('9303','2013-05-17','14:15:00',4.11),('9303','2013-05-17','14:20:00',4.24),('9303','2013-05-17','14:25:00',3.83),('9303','2013-05-17','14:30:00',3.8),('9303','2013-05-17','14:35:00',3.88),('9303','2013-05-17','14:40:00',2.76),('9303','2013-05-17','14:45:00',3.07),('9303','2013-05-17','14:50:00',3.47),('9303','2013-05-17','14:55:00',2.1),('9303','2013-05-17','15:00:00',4.27),('9303','2013-05-17','15:05:00',2.85),('9303','2013-05-17','15:10:00',1.44),('9303','2013-05-17','15:15:00',2.61),('9303','2013-05-17','15:20:00',3.54),('9303','2013-05-17','15:25:00',3.18),('9303','2013-05-17','15:30:00',1.54),('9303','2013-05-17','15:35:00',2.1),('9303','2013-05-17','15:40:00',3.72),('9303','2013-05-17','15:45:00',1.36),('9303','2013-05-17','15:50:00',2.6),('9303','2013-05-17','15:55:00',3.11),('9303','2013-05-17','16:00:00',4.11),('9303','2013-05-17','16:05:00',1.65),('9303','2013-05-17','16:10:00',1.94),('9303','2013-05-17','16:15:00',2.8),('9303','2013-05-17','16:20:00',2.66),('9303','2013-05-17','16:25:00',3.13),('9303','2013-05-17','16:30:00',3.26),('9303','2013-05-17','16:35:00',2.78),('9303','2013-05-17','16:40:00',3.1),('9303','2013-05-17','16:45:00',2.99),('9303','2013-05-17','16:50:00',2.73),('9303','2013-05-17','16:55:00',2.59),('9303','2013-05-17','17:00:00',2.49),('9303','2013-05-17','17:05:00',2.36),('9303','2013-05-17','17:10:00',2.24),('9303','2013-05-17','17:15:00',2.16),('9303','2013-05-17','17:20:00',2.09),('9303','2013-05-17','17:25:00',2.02),('9303','2013-05-17','17:30:00',1.96),('9303','2013-05-17','17:35:00',1.87),('9303','2013-05-17','17:40:00',1.78),('9303','2013-05-17','17:45:00',1.68),('9303','2013-05-17','17:50:00',1.61),('9303','2013-05-17','17:55:00',1.51),('9303','2013-05-17','18:00:00',1.42),('9303','2013-05-17','18:05:00',1.36),('9303','2013-05-17','18:10:00',1.24),('9303','2013-05-17','18:15:00',1.15),('9303','2013-05-17','18:20:00',1.04),('9303','2013-05-16','09:20:00',1.03),('9303','2013-05-16','09:25:00',1.46),('9303','2013-05-16','09:30:00',1.48),('9303','2013-05-16','09:35:00',1.69),('9303','2013-05-16','09:40:00',1.94),('9303','2013-05-16','09:45:00',2.39),('9303','2013-05-16','09:50:00',1.24),('9303','2013-05-16','09:55:00',1.07),('9303','2013-05-16','10:00:00',1.39),('9303','2013-05-16','10:05:00',1.19),('9303','2013-05-16','10:10:00',1.07),('9303','2013-05-16','10:15:00',1.39),('9303','2013-05-16','10:20:00',1.84),('9303','2013-05-16','10:25:00',1.85),('9303','2013-05-16','10:30:00',1.76),('9303','2013-05-16','10:35:00',1.26),('9303','2013-05-16','10:40:00',1.29),('9303','2013-05-16','10:45:00',1.21),('9303','2013-05-16','10:50:00',1.4),('9303','2013-05-16','10:55:00',1.57),('9303','2013-05-16','11:00:00',4.04),('9303','2013-05-16','11:05:00',3.53),('9303','2013-05-16','11:10:00',3.13),('9303','2013-05-16','11:15:00',2.17),('9303','2013-05-16','11:20:00',1.08),('9303','2013-05-16','11:25:00',1.17),('9303','2013-05-16','11:30:00',1.4),('9303','2013-05-16','11:35:00',2.84),('9303','2013-05-16','11:40:00',3.6),('9303','2013-05-16','11:45:00',3.5),('9303','2013-05-16','11:50:00',3.66),('9303','2013-05-16','11:55:00',2.51),('9303','2013-05-16','12:00:00',1.68),('9303','2013-05-16','12:05:00',1.51),('9303','2013-05-16','12:10:00',1.56),('9303','2013-05-16','12:15:00',2.68),('9303','2013-05-16','12:20:00',1.83),('9303','2013-05-16','12:25:00',2.02),('9303','2013-05-16','12:30:00',3.15),('9303','2013-05-16','12:35:00',3.23),('9303','2013-05-16','12:40:00',4.01),('9303','2013-05-16','12:45:00',3.57),('9303','2013-05-16','12:50:00',2.7),('9303','2013-05-16','12:55:00',4.13),('9303','2013-05-16','13:00:00',4.12),('9303','2013-05-16','13:05:00',3.92),('9303','2013-05-16','13:10:00',4),('9303','2013-05-16','13:15:00',3.61),('9303','2013-05-16','13:20:00',3.06),('9303','2013-05-16','13:25:00',4.04),('9303','2013-05-16','13:30:00',3.95),('9303','2013-05-16','13:35:00',3.95),('9303','2013-05-16','13:40:00',3.9),('9303','2013-05-16','13:45:00',3.87),('9303','2013-05-16','13:50:00',3.9),('9303','2013-05-16','13:55:00',3.86),('9303','2013-05-16','14:00:00',3.83),('9303','2013-05-16','14:05:00',3.8),('9303','2013-05-16','14:10:00',3.79),('9303','2013-05-16','14:20:00',3.4),('9303','2013-05-16','14:25:00',3.65),('9303','2013-05-16','14:30:00',3.69),('9303','2013-05-16','14:35:00',3.62),('9303','2013-05-16','14:40:00',3.6),('9303','2013-05-16','14:45:00',3.57),('9303','2013-05-16','14:50:00',3.37),('9303','2013-05-16','14:55:00',2.98),('9303','2013-05-16','15:00:00',3.47),('9303','2013-05-16','15:05:00',3.42),('9303','2013-05-16','15:10:00',3.43),('9303','2013-05-16','15:15:00',3.05),('9303','2013-05-16','15:20:00',3.19),('9303','2013-05-16','15:25:00',3.25),('9303','2013-05-16','15:30:00',3.16),('9303','2013-05-16','15:35:00',3.07),('9303','2013-05-16','15:40:00',3.14),('9303','2013-05-16','15:45:00',3.01),('9303','2013-05-16','15:50:00',3.02),('9303','2013-05-16','15:55:00',3),('9303','2013-05-16','16:00:00',2.96),('9303','2013-05-16','16:05:00',2.78),('9303','2013-05-16','16:10:00',2.77),('9303','2013-05-16','16:15:00',2.58),('9303','2013-05-16','16:20:00',2.77),('9303','2013-05-16','16:25:00',2.63),('9303','2013-05-16','16:30:00',2.61),('9303','2013-05-16','16:35:00',2.51),('9303','2013-05-16','16:40:00',1.52),('9303','2013-05-16','16:45:00',1.3),('9303','2013-05-16','16:50:00',1.67),('9303','2013-05-16','16:55:00',1.46),('9303','2013-05-16','17:00:00',1.51),('9303','2013-05-16','17:15:00',1.1),('9303','2013-05-16','17:20:00',1.26),('9303','2013-05-16','17:25:00',1.2),('9303','2013-05-16','17:30:00',1.42),('9303','2013-05-16','17:35:00',1.52),('9303','2013-05-16','17:40:00',1.22),('9303','2013-05-15','07:45:00',1.14),('9303','2013-05-15','07:50:00',1.2),('9303','2013-05-15','07:55:00',1.17),('9303','2013-05-15','08:00:00',1.23),('9303','2013-05-15','08:05:00',1.23),('9303','2013-05-15','08:10:00',1.46),('9303','2013-05-15','08:15:00',1.6),('9303','2013-05-15','08:20:00',1.66),('9303','2013-05-15','08:25:00',1.72),('9303','2013-05-15','08:30:00',1.75),('9303','2013-05-15','08:35:00',1.93),('9303','2013-05-15','08:40:00',2.04),('9303','2013-05-15','08:45:00',2.11),('9303','2013-05-15','08:50:00',2.19),('9303','2013-05-15','08:55:00',2.28),('9303','2013-05-15','09:00:00',2.23),('9303','2013-05-15','09:05:00',2.39),('9303','2013-05-15','09:10:00',2.39),('9303','2013-05-15','09:15:00',2.46),('9303','2013-05-15','09:20:00',2.43),('9303','2013-05-15','09:25:00',2.54),('9303','2013-05-15','09:30:00',2.71),('9303','2013-05-15','09:35:00',2.76),('9303','2013-05-15','09:40:00',2.77),('9303','2013-05-15','09:45:00',2.89),('9303','2013-05-15','09:50:00',2.96),('9303','2013-05-15','09:55:00',2.97),('9303','2013-05-15','10:00:00',3.08),('9303','2013-05-15','10:05:00',3.15),('9303','2013-05-15','10:10:00',3.2),('9303','2013-05-15','10:15:00',3.17),('9303','2013-05-15','10:20:00',3.3),('9303','2013-05-15','10:25:00',3.39),('9303','2013-05-15','10:30:00',3.32),('9303','2013-05-15','10:35:00',3.4),('9303','2013-05-15','10:40:00',3.44),('9303','2013-05-15','10:45:00',3.52),('9303','2013-05-15','10:50:00',3.54),('9303','2013-05-15','10:55:00',3.47),('9303','2013-05-15','11:00:00',3.47),('9303','2013-05-15','11:05:00',3.49),('9303','2013-05-15','11:10:00',3.68),('9303','2013-05-15','11:15:00',3.76),('9303','2013-05-15','11:20:00',3.59),('9303','2013-05-15','11:25:00',3.77),('9303','2013-05-15','11:30:00',3.63),('9303','2013-05-15','11:35:00',3.57),('9303','2013-05-15','11:40:00',3.17),('9303','2013-05-15','11:45:00',2.89),('9303','2013-05-15','11:50:00',2.48),('9303','2013-05-15','11:55:00',1.86),('9303','2013-05-15','12:00:00',2.04),('9303','2013-05-15','12:05:00',2.99),('9303','2013-05-15','12:10:00',4.22),('9303','2013-05-15','12:15:00',4.41),('9303','2013-05-15','12:20:00',3.13),('9303','2013-05-15','12:25:00',3.45),('9303','2013-05-15','12:30:00',2.51),('9303','2013-05-15','12:35:00',2.79),('9303','2013-05-15','12:40:00',4.39),('9303','2013-05-15','12:45:00',2.29),('9303','2013-05-15','12:50:00',2.29),('9303','2013-05-15','12:55:00',2.52),('9303','2013-05-15','13:00:00',2.59),('9303','2013-05-15','13:05:00',3.21),('9303','2013-05-15','13:10:00',2.8),('9303','2013-05-15','13:15:00',2.22),('9303','2013-05-15','13:20:00',2.55),('9303','2013-05-15','13:25:00',2.49),('9303','2013-05-15','13:30:00',2.52),('9303','2013-05-15','13:35:00',2.22),('9303','2013-05-15','13:40:00',2.31),('9303','2013-05-15','13:45:00',2.43),('9303','2013-05-15','13:50:00',1.97),('9303','2013-05-15','13:55:00',1.94),('9303','2013-05-15','14:00:00',1.71),('9303','2013-05-15','14:05:00',1.51),('9303','2013-05-15','14:10:00',1.55),('9303','2013-05-15','14:15:00',1.55),('9303','2013-05-15','14:20:00',1.6),('9303','2013-05-15','14:25:00',1.54),('9303','2013-05-15','14:30:00',1.36),('9303','2013-05-15','14:35:00',1.32),('9303','2013-05-15','14:40:00',1.43),('9303','2013-05-15','14:45:00',1.34),('9303','2013-05-15','14:50:00',1.37),('9303','2013-05-15','14:55:00',1.36),('9303','2013-05-15','15:00:00',1.36),('9303','2013-05-15','15:05:00',1.06),('9303','2013-05-15','15:50:00',1.29),('9303','2013-05-15','15:55:00',1.76),('9303','2013-05-15','16:00:00',1.78),('9303','2013-05-15','16:05:00',1.67),('9303','2013-05-15','16:10:00',1.52),('9303','2013-05-15','16:15:00',1.35),('9303','2013-05-15','16:20:00',1.46),('9303','2013-05-15','16:25:00',1.5),('9303','2013-05-15','16:30:00',1.34),('9303','2013-05-15','16:35:00',1.23),('9303','2013-05-15','16:40:00',1.14),('9303','2013-05-15','16:45:00',1.09),('9303','2013-05-15','16:50:00',1.1),('9303','2013-05-15','16:55:00',1.25),('9303','2013-05-15','17:00:00',1.51),('9303','2013-05-15','17:05:00',1.81),('9303','2013-05-15','17:10:00',1.93),('9303','2013-05-15','17:15:00',2.44),('9303','2013-05-15','17:20:00',1.45),('9303','2013-05-14','07:45:00',1.07),('9303','2013-05-14','07:50:00',1.18),('9303','2013-05-14','07:55:00',1.28),('9303','2013-05-14','08:00:00',1.38),('9303','2013-05-14','08:05:00',1.48),('9303','2013-05-14','08:10:00',1.57),('9303','2013-05-14','08:15:00',1.68),('9303','2013-05-14','08:20:00',1.79),('9303','2013-05-14','08:25:00',1.88),('9303','2013-05-14','08:30:00',1.99),('9303','2013-05-14','08:35:00',2.09),('9303','2013-05-14','08:40:00',2.17),('9303','2013-05-14','08:45:00',2.25),('9303','2013-05-14','08:50:00',2.32),('9303','2013-05-14','08:55:00',2.41),('9303','2013-05-14','09:00:00',2.5),('9303','2013-05-14','09:05:00',2.58),('9303','2013-05-14','09:10:00',2.65),('9303','2013-05-14','09:15:00',2.7),('9303','2013-05-14','09:20:00',2.78),('9303','2013-05-14','09:25:00',2.84),('9303','2013-05-14','09:30:00',2.9),('9303','2013-05-14','09:35:00',2.97),('9303','2013-05-14','09:40:00',3),('9303','2013-05-14','09:45:00',3.05),('9303','2013-05-14','09:50:00',3.12),('9303','2013-05-14','09:55:00',3.22),('9303','2013-05-14','10:00:00',3.27),('9303','2013-05-14','10:05:00',3.33),('9303','2013-05-14','10:10:00',3.4),('9303','2013-05-14','10:15:00',3.46),('9303','2013-05-14','10:20:00',3.47),('9303','2013-05-14','10:25:00',3.51),('9303','2013-05-14','10:30:00',3.59),('9303','2013-05-14','10:35:00',3.63),('9303','2013-05-14','10:40:00',3.68),('9303','2013-05-14','10:45:00',3.7),('9303','2013-05-14','10:50:00',3.73),('9303','2013-05-14','10:55:00',3.75),('9303','2013-05-14','11:00:00',3.8),('9303','2013-05-14','11:05:00',3.85),('9303','2013-05-14','11:10:00',3.9),('9303','2013-05-14','11:15:00',3.89),('9303','2013-05-14','11:20:00',3.91),('9303','2013-05-14','11:25:00',3.9),('9303','2013-05-14','11:30:00',3.95),('9303','2013-05-14','11:35:00',3.96),('9303','2013-05-14','11:40:00',3.99),('9303','2013-05-14','11:45:00',4),('9303','2013-05-14','11:50:00',4),('9303','2013-05-14','11:55:00',4.01),('9303','2013-05-14','12:00:00',4.05),('9303','2013-05-14','12:05:00',4.07),('9303','2013-05-14','12:10:00',4.09),('9303','2013-05-14','12:15:00',4.16),('9303','2013-05-14','12:20:00',4.26),('9303','2013-05-14','12:25:00',4.23),('9303','2013-05-14','12:30:00',4.23),('9303','2013-05-14','12:35:00',4.19),('9303','2013-05-14','12:40:00',4.18),('9303','2013-05-14','12:45:00',4.16),('9303','2013-05-14','12:50:00',4.23),('9303','2013-05-14','12:55:00',4.21),('9303','2013-05-14','13:00:00',4.17),('9303','2013-05-14','13:05:00',4.17),('9303','2013-05-14','13:10:00',4.26),('9303','2013-05-14','13:15:00',4.22),('9303','2013-05-14','13:20:00',4.17),('9303','2013-05-14','13:25:00',4.15),('9303','2013-05-14','13:30:00',4.21),('9303','2013-05-14','13:35:00',4.24),('9303','2013-05-14','13:40:00',4.2),('9303','2013-05-14','13:45:00',4.12),('9303','2013-05-14','13:50:00',4.14),('9303','2013-05-14','13:55:00',4.13),('9303','2013-05-14','14:00:00',4.11),('9303','2013-05-14','14:05:00',4.06),('9303','2013-05-14','14:10:00',4.05),('9303','2013-05-14','14:15:00',4.02),('9303','2013-05-14','14:20:00',3.95),('9303','2013-05-14','14:25:00',3.92),('9303','2013-05-14','14:30:00',3.91),('9303','2013-05-14','14:35:00',3.83),('9303','2013-05-14','14:40:00',3.82),('9303','2013-05-14','14:45:00',3.84),('9303','2013-05-14','14:50:00',3.87),('9303','2013-05-14','14:55:00',3.91),('9303','2013-05-14','15:00:00',3.89),('9303','2013-05-14','15:05:00',3.86),('9303','2013-05-14','15:10:00',3.82),('9303','2013-05-14','15:15:00',3.78),('9303','2013-05-14','15:20:00',3.73),('9303','2013-05-14','15:25:00',3.71),('9303','2013-05-14','15:30:00',3.66),('9303','2013-05-14','15:35:00',3.61),('9303','2013-05-14','15:40:00',3.55),('9303','2013-05-14','15:45:00',3.48),('9303','2013-05-14','15:50:00',3.44),('9303','2013-05-14','15:55:00',3.4),('9303','2013-05-14','16:00:00',3.34),('9303','2013-05-14','16:05:00',3.27),('9303','2013-05-14','16:10:00',3.21),('9303','2013-05-14','16:15:00',3.15),('9303','2013-05-14','16:20:00',3.08),('9303','2013-05-14','16:25:00',3.03),('9303','2013-05-14','16:30:00',2.95),('9303','2013-05-14','16:35:00',2.87),('9303','2013-05-14','16:40:00',2.8),('9303','2013-05-14','16:45:00',2.73),('9303','2013-05-14','16:50:00',2.65),('9303','2013-05-14','16:55:00',2.55),('9303','2013-05-14','17:00:00',2.45),('9303','2013-05-14','17:05:00',2.33),('9303','2013-05-14','17:10:00',2.23),('9303','2013-05-14','17:15:00',2.14),('9303','2013-05-14','17:20:00',2.05),('9303','2013-05-14','17:25:00',1.97),('9303','2013-05-14','17:30:00',1.9),('9303','2013-05-14','17:35:00',1.81),('9303','2013-05-14','17:40:00',1.73),('9303','2013-05-14','17:45:00',1.62),('9303','2013-05-14','17:50:00',1.51),('9303','2013-05-14','17:55:00',1.42),('9303','2013-05-14','18:00:00',1.34),('9303','2013-05-14','18:05:00',1.24),('9303','2013-05-14','18:10:00',1.16),('9303','2013-05-14','18:15:00',1.08),('9303','2013-05-13','08:00:00',1.22),('9303','2013-05-13','08:05:00',1.33),('9303','2013-05-13','08:10:00',1.43),('9303','2013-05-13','08:15:00',1.55),('9303','2013-05-13','08:20:00',1.65),('9303','2013-05-13','08:25:00',1.71),('9303','2013-05-13','08:30:00',1.8),('9303','2013-05-13','08:35:00',1.9),('9303','2013-05-13','08:40:00',2),('9303','2013-05-13','08:45:00',2.06),('9303','2013-05-13','08:50:00',2.13),('9303','2013-05-13','08:55:00',2.23),('9303','2013-05-13','09:00:00',2.29),('9303','2013-05-13','09:05:00',2.36),('9303','2013-05-13','09:10:00',2.46),('9303','2013-05-13','09:15:00',2.52),('9303','2013-05-13','09:20:00',2.49),('9303','2013-05-13','09:25:00',2.67),('9303','2013-05-13','09:30:00',2.72),('9303','2013-05-13','09:35:00',2.81),('9303','2013-05-13','09:40:00',2.86),('9303','2013-05-13','09:45:00',2.97),('9303','2013-05-13','09:50:00',2.49),('9303','2013-05-13','09:55:00',3.23),('9303','2013-05-13','10:00:00',3.18),('9303','2013-05-13','10:05:00',2.95),('9303','2013-05-13','10:10:00',3.23),('9303','2013-05-13','10:15:00',3.5),('9303','2013-05-13','10:20:00',2.58),('9303','2013-05-13','10:25:00',2.19),('9303','2013-05-13','10:30:00',2.97),('9303','2013-05-13','10:45:00',2.91),('9303','2013-05-13','10:50:00',4.04),('9303','2013-05-13','10:55:00',2.67),('9303','2013-05-13','11:00:00',2.14),('9303','2013-05-13','11:05:00',2.27),('9303','2013-05-13','11:10:00',1.82),('9303','2013-05-13','11:15:00',1.85),('9303','2013-05-13','11:20:00',1.42),('9303','2013-05-13','11:25:00',1.95),('9303','2013-05-13','11:30:00',1.73),('9303','2013-05-13','11:35:00',1.75),('9303','2013-05-13','11:40:00',2.43),('9303','2013-05-13','11:45:00',2.91),('9303','2013-05-13','11:50:00',1.68),('9303','2013-05-13','11:55:00',1.8),('9303','2013-05-13','12:00:00',1.62),('9303','2013-05-13','12:05:00',1.59),('9303','2013-05-13','12:10:00',3.04),('9303','2013-05-13','12:15:00',2.3),('9303','2013-05-13','12:20:00',1.21),('9303','2013-05-13','12:25:00',1.54),('9303','2013-05-13','12:30:00',2.45),('9303','2013-05-13','12:35:00',3.9),('9303','2013-05-13','12:40:00',3.73),('9303','2013-05-13','12:45:00',1.39),('9303','2013-05-13','12:50:00',4.1),('9303','2013-05-13','12:55:00',4.55),('9303','2013-05-13','13:00:00',4.78),('9303','2013-05-13','13:05:00',4.83),('9303','2013-05-13','13:10:00',4.07),('9303','2013-05-13','13:15:00',4.5),('9303','2013-05-13','13:20:00',4.7),('9303','2013-05-13','13:25:00',4.74),('9303','2013-05-13','13:30:00',4.8),('9303','2013-05-13','13:35:00',4.66),('9303','2013-05-13','13:40:00',3.3),('9303','2013-05-13','13:45:00',2.85),('9303','2013-05-13','13:50:00',1.22),('9303','2013-05-13','13:55:00',1.17),('9303','2013-05-13','14:00:00',1.58),('9303','2013-05-13','14:05:00',4.62),('9303','2013-05-13','14:10:00',4.69),('9303','2013-05-13','14:15:00',4.54),('9303','2013-05-13','14:20:00',4.2),('9303','2013-05-13','14:25:00',2.68),('9303','2013-05-13','14:30:00',3.46),('9303','2013-05-13','14:35:00',4.15),('9303','2013-05-13','14:40:00',4.23),('9303','2013-05-13','14:45:00',2.54),('9303','2013-05-13','14:50:00',2.1),('9303','2013-05-13','14:55:00',4.47),('9303','2013-05-13','15:00:00',2.21),('9303','2013-05-13','15:05:00',1.97),('9303','2013-05-13','15:10:00',1.05),('9303','2013-05-13','15:20:00',1.16),('9303','2013-05-13','16:00:00',1.31),('9303','2013-05-13','16:05:00',1.48),('9303','2013-05-13','16:10:00',1.49),('9303','2013-05-13','16:15:00',1.11),('9303','2013-05-13','16:20:00',1.24),('9303','2013-05-13','16:25:00',1.21),('9303','2013-05-13','16:30:00',1.76),('9303','2013-05-13','16:35:00',1.33),('9303','2013-05-13','16:40:00',1.84),('9303','2013-05-13','16:45:00',2.14),('9303','2013-05-13','16:50:00',3.27),('9303','2013-05-13','16:55:00',2.97),('9303','2013-05-13','17:00:00',2.75),('9303','2013-05-13','17:05:00',2.39),('9303','2013-05-13','17:10:00',1.69),('9303','2013-05-13','17:15:00',2.79),('9303','2013-05-13','17:20:00',2.8),('9303','2013-05-13','17:25:00',2.59),('9303','2013-05-13','17:30:00',2.36),('9303','2013-05-13','17:35:00',2.23),('9303','2013-05-13','17:40:00',2.03),('9303','2013-05-13','17:45:00',1.98),('9303','2013-05-13','17:50:00',1.44),('9303','2013-05-12','08:10:00',1.11),('9303','2013-05-12','08:15:00',1.55),('9303','2013-05-12','08:20:00',1.32),('9303','2013-05-12','08:25:00',1.4),('9303','2013-05-12','08:40:00',1.03),('9303','2013-05-12','08:45:00',1.39),('9303','2013-05-12','08:50:00',1.61),('9303','2013-05-12','09:00:00',1.08),('9303','2013-05-12','09:05:00',1.06),('9303','2013-05-12','09:15:00',1.14),('9303','2013-05-12','09:20:00',1.17),('9303','2013-05-12','09:25:00',1.11),('9303','2013-05-12','09:30:00',1.88),('9303','2013-05-12','09:35:00',2.06),('9303','2013-05-12','09:40:00',1.24),('9303','2013-05-12','09:45:00',2.76),('9303','2013-05-12','09:50:00',3.12),('9303','2013-05-12','09:55:00',3.54),('9303','2013-05-12','10:00:00',3.46),('9303','2013-05-12','10:05:00',1.93),('9303','2013-05-12','10:10:00',1.32),('9303','2013-05-12','10:30:00',2.6),('9303','2013-05-12','10:35:00',1.21),('9303','2013-05-12','10:40:00',2.34),('9303','2013-05-12','10:45:00',3.5),('9303','2013-05-12','10:50:00',2.39),('9303','2013-05-12','10:55:00',3.15),('9303','2013-05-12','11:00:00',4.04),('9303','2013-05-12','11:05:00',1.05),('9303','2013-05-12','11:10:00',2.72),('9303','2013-05-12','11:15:00',4.29),('9303','2013-05-12','11:20:00',4.28),('9303','2013-05-12','11:25:00',4.41),('9303','2013-05-12','11:30:00',4.55),('9303','2013-05-12','11:35:00',4.35),('9303','2013-05-12','11:40:00',3.7),('9303','2013-05-12','11:45:00',3.92),('9303','2013-05-12','11:50:00',2.4),('9303','2013-05-12','11:55:00',3.8),('9303','2013-05-12','12:00:00',3.25),('9303','2013-05-12','12:05:00',3.93),('9303','2013-05-12','12:10:00',4.24),('9303','2013-05-12','12:15:00',1.86),('9303','2013-05-12','12:20:00',1),('9303','2013-05-12','12:25:00',1.02),('9303','2013-05-12','12:30:00',1.22),('9303','2013-05-12','12:35:00',2.28),('9303','2013-05-12','12:40:00',2.3),('9303','2013-05-12','12:45:00',3.43),('9303','2013-05-12','12:50:00',4.32),('9303','2013-05-12','12:55:00',4.5),('9303','2013-05-12','13:00:00',1.98),('9303','2013-05-12','13:05:00',1.69),('9303','2013-05-12','13:10:00',3.93),('9303','2013-05-12','13:15:00',3.32),('9303','2013-05-12','13:20:00',2.59),('9303','2013-05-12','13:25:00',2.7),('9303','2013-05-12','13:30:00',4.36),('9303','2013-05-12','13:35:00',3.85),('9303','2013-05-12','13:40:00',4.53),('9303','2013-05-12','13:45:00',3.99),('9303','2013-05-12','13:50:00',4.03),('9303','2013-05-12','13:55:00',3.31),('9303','2013-05-12','14:00:00',3.74),('9303','2013-05-12','14:05:00',3.85),('9303','2013-05-12','14:10:00',2.97),('9303','2013-05-12','14:15:00',4.59),('9303','2013-05-12','14:20:00',4.25),('9303','2013-05-12','14:25:00',4.01),('9303','2013-05-12','14:30:00',4.39),('9303','2013-05-12','14:35:00',4.32),('9303','2013-05-12','14:40:00',4.25),('9303','2013-05-12','14:45:00',4.14),('9303','2013-05-12','14:50:00',4.18),('9303','2013-05-12','14:55:00',4.13),('9303','2013-05-12','15:00:00',3.63),('9303','2013-05-12','15:05:00',4.1),('9303','2013-05-12','15:10:00',3.91),('9303','2013-05-12','15:15:00',2.94),('9303','2013-05-12','15:20:00',3.29),('9303','2013-05-12','15:25:00',3.53),('9303','2013-05-12','15:30:00',3.71),('9303','2013-05-12','15:35:00',3.65),('9303','2013-05-12','15:40:00',3.6),('9303','2013-05-12','15:45:00',3.52),('9303','2013-05-12','15:50:00',3.44),('9303','2013-05-12','15:55:00',3.34),('9303','2013-05-12','16:00:00',3.28),('9303','2013-05-12','16:05:00',3.15),('9303','2013-05-12','16:10:00',3.14),('9303','2013-05-12','16:15:00',3.08),('9303','2013-05-12','16:20:00',3.02),('9303','2013-05-12','16:25:00',2.93),('9303','2013-05-12','16:30:00',2.89),('9303','2013-05-12','16:35:00',2.87),('9303','2013-05-12','16:40:00',2.92),('9303','2013-05-12','16:45:00',3.09),('9303','2013-05-12','16:50:00',2.73),('9303','2013-05-12','16:55:00',2.94),('9303','2013-05-12','17:00:00',3.18),('9303','2013-05-12','17:05:00',2.57),('9303','2013-05-12','17:10:00',2.7),('9303','2013-05-12','17:15:00',2.67),('9303','2013-05-12','17:20:00',2.55),('9303','2013-05-12','17:25:00',2.06),('9303','2013-05-12','17:30:00',2.08),('9303','2013-05-12','17:35:00',1.79),('9303','2013-05-12','17:40:00',1.3),('9303','2013-05-12','17:45:00',1.27),('9303','2013-05-12','18:00:00',1.16),('9303','2013-05-12','18:05:00',1.5),('9303','2013-05-12','18:10:00',1.54),('9303','2013-05-12','18:15:00',1.18),('9303','2013-05-12','18:25:00',1.13),('9303','2013-05-12','18:30:00',1.11),('9303','2013-05-12','18:35:00',1.13),('9303','2014-03-31','08:25:00',1.08),('9303','2014-03-31','08:30:00',1.17),('9303','2014-03-31','08:35:00',1.28),('9303','2014-03-31','08:40:00',1.36),('9303','2014-03-31','08:45:00',1.48),('9303','2014-03-31','08:50:00',1.56),('9303','2014-03-31','08:55:00',1.66),('9303','2014-03-31','09:00:00',1.77),('9303','2014-03-31','09:05:00',1.86),('9303','2014-03-31','09:10:00',1.94),('9303','2014-03-31','09:15:00',2.02),('9303','2014-03-31','09:20:00',2.1),('9303','2014-03-31','09:25:00',2.19),('9303','2014-03-31','09:30:00',2.28),('9303','2014-03-31','09:35:00',2.35),('9303','2014-03-31','09:40:00',2.4),('9303','2014-03-31','09:45:00',2.48),('9303','2014-03-31','09:50:00',2.54),('9303','2014-03-31','09:55:00',2.6),('9303','2014-03-31','10:00:00',2.68),('9303','2014-03-31','10:05:00',2.74),('9303','2014-03-31','10:10:00',2.8),('9303','2014-03-31','10:15:00',2.85),('9303','2014-03-31','10:20:00',2.94),('9303','2014-03-31','10:25:00',2.99),('9303','2014-03-31','10:30:00',3.04),('9303','2014-03-31','10:35:00',3.13),('9303','2014-03-31','10:40:00',3.16),('9303','2014-03-31','10:45:00',3.2),('9303','2014-03-31','10:50:00',3.25),('9303','2014-03-31','10:55:00',3.33),('9303','2014-03-31','11:00:00',3.39),('9303','2014-03-31','11:05:00',3.41),('9303','2014-03-31','11:10:00',3.44),('9303','2014-03-31','11:15:00',3.51),('9303','2014-03-31','11:20:00',3.51),('9303','2014-03-31','11:25:00',3.57),('9303','2014-03-31','11:30:00',3.62),('9303','2014-03-31','11:35:00',3.65),('9303','2014-03-31','11:40:00',3.64),('9303','2014-03-31','11:45:00',3.66),('9303','2014-03-31','11:50:00',3.71),('9303','2014-03-31','11:55:00',3.76),('9303','2014-03-31','12:00:00',3.79),('9303','2014-03-31','12:05:00',3.76),('9303','2014-03-31','12:10:00',3.77),('9303','2014-03-31','12:15:00',3.82),('9303','2014-03-31','12:20:00',3.9),('9303','2014-03-31','12:25:00',3.89),('9303','2014-03-31','12:30:00',3.88),('9303','2014-03-31','12:35:00',3.88),('9303','2014-03-31','12:40:00',3.89),('9303','2014-03-31','12:45:00',3.9),('9303','2014-03-31','12:50:00',3.84),('9303','2014-03-31','12:55:00',3.84),('9303','2014-03-31','13:00:00',3.88),('9303','2014-03-31','13:05:00',3.92),('9303','2014-03-31','13:10:00',3.95),('9303','2014-03-31','13:15:00',3.95),('9303','2014-03-31','13:20:00',3.96),('9303','2014-03-31','13:25:00',3.98),('9303','2014-03-31','13:30:00',3.94),('9303','2014-03-31','13:35:00',3.99),('9303','2014-03-31','13:40:00',3.99),('9303','2014-03-31','13:45:00',4),('9303','2014-03-31','13:50:00',3.98),('9303','2014-03-31','13:55:00',3.97),('9303','2014-03-31','14:00:00',3.97),('9303','2014-03-31','14:05:00',3.97),('9303','2014-03-31','14:10:00',3.93),('9303','2014-03-31','14:15:00',3.93),('9303','2014-03-31','14:20:00',3.91),('9303','2014-03-31','14:25:00',3.88),('9303','2014-03-31','14:30:00',3.84),('9303','2014-03-31','14:35:00',3.81),('9303','2014-03-31','14:40:00',3.8),('9303','2014-03-31','14:45:00',3.76),('9303','2014-03-31','14:50:00',3.7),('9303','2014-03-31','14:55:00',3.68),('9303','2014-03-31','15:00:00',3.62),('9303','2014-03-31','15:05:00',3.59),('9303','2014-03-31','15:10:00',3.57),('9303','2014-03-31','15:15:00',3.49),('9303','2014-03-31','15:20:00',3.45),('9303','2014-03-31','15:25:00',3.41),('9303','2014-03-31','15:30:00',3.36),('9303','2014-03-31','15:35:00',3.28),('9303','2014-03-31','15:40:00',3.22),('9303','2014-03-31','15:45:00',3.17),('9303','2014-03-31','15:50:00',3.09),('9303','2014-03-31','15:55:00',3.04),('9303','2014-03-31','16:00:00',2.96),('9303','2014-03-31','16:05:00',2.9),('9303','2014-03-31','16:10:00',2.82),('9303','2014-03-31','16:15:00',2.75),('9303','2014-03-31','16:20:00',2.68),('9303','2014-03-31','16:25:00',2.6),('9303','2014-03-31','16:30:00',2.53),('9303','2014-03-31','16:35:00',2.46),('9303','2014-03-31','16:40:00',2.34),('9303','2014-03-31','16:45:00',2.21),('9303','2014-03-31','16:50:00',2.11),('9303','2014-03-31','16:55:00',2.03),('9303','2014-03-31','17:00:00',1.94),('9303','2014-03-31','17:05:00',1.87),('9303','2014-03-31','17:10:00',1.79),('9303','2014-03-31','17:15:00',1.7),('9303','2014-03-31','17:20:00',1.6),('9303','2014-03-31','17:25:00',1.49),('9303','2014-03-31','17:30:00',1.39),('9303','2014-03-31','17:35:00',1.32),('9303','2014-03-31','17:40:00',1.23),('9303','2014-03-31','17:45:00',1.14),('9303','2014-03-31','17:50:00',1.04),('9303','2013-05-11','07:50:00',1.15),('9303','2013-05-11','07:55:00',1.31),('9303','2013-05-11','08:00:00',1.23),('9303','2013-05-11','08:05:00',1.3),('9303','2013-05-11','08:15:00',1.16),('9303','2013-05-11','08:20:00',1.17),('9303','2013-05-11','09:10:00',1.23),('9303','2013-05-11','09:15:00',1.22),('9303','2013-05-11','09:20:00',1.81),('9303','2013-05-11','09:25:00',1.28),('9303','2013-05-11','09:30:00',2.31),('9303','2013-05-11','09:35:00',1.95),('9303','2013-05-11','09:40:00',1.43),('9303','2013-05-11','09:45:00',1.91),('9303','2013-05-11','09:50:00',1.56),('9303','2013-05-11','09:55:00',2.12),('9303','2013-05-11','10:00:00',1.62),('9303','2013-05-11','10:05:00',1.55),('9303','2013-05-11','10:30:00',1.06),('9303','2013-05-11','10:35:00',1.13),('9303','2013-05-11','10:50:00',1.09),('9303','2013-05-11','10:55:00',2.54),('9303','2013-05-11','11:00:00',3.74),('9303','2013-05-11','11:05:00',2.67),('9303','2013-05-11','11:10:00',1.21),('9303','2013-05-11','11:30:00',1.3),('9303','2013-05-11','11:35:00',2.8),('9303','2013-05-11','11:40:00',1.87),('9303','2013-05-11','11:45:00',3.7),('9303','2013-05-11','11:50:00',2.52),('9303','2013-05-11','12:00:00',1.17),('9303','2013-05-11','12:05:00',1.8),('9303','2013-05-11','12:10:00',1.41),('9303','2013-05-11','12:15:00',1.41),('9303','2013-05-11','12:20:00',2.06),('9303','2013-05-11','12:25:00',4.78),('9303','2013-05-11','12:30:00',3.19),('9303','2013-05-11','12:35:00',2.23),('9303','2013-05-11','12:40:00',1.91),('9303','2013-05-11','12:45:00',1.76),('9303','2013-05-11','12:50:00',1.59),('9303','2013-05-11','12:55:00',1.46),('9303','2013-05-11','13:00:00',1.33),('9303','2013-05-11','13:05:00',1.4),('9303','2013-05-11','13:10:00',1.02),('9303','2013-05-11','13:35:00',1.11),('9303','2013-05-11','14:00:00',1.92),('9303','2013-05-11','14:05:00',3.21),('9303','2013-05-11','14:10:00',2.7),('9303','2013-05-11','14:15:00',2.82),('9303','2013-05-11','14:20:00',4.45),('9303','2013-05-11','14:25:00',3.26),('9303','2013-05-11','14:30:00',2.72),('9303','2013-05-11','14:35:00',2.88),('9303','2013-05-11','14:40:00',2.22),('9303','2013-05-11','14:45:00',3.82),('9303','2013-05-11','14:50:00',4.41),('9303','2013-05-11','14:55:00',4.26),('9303','2013-05-11','15:00:00',4.04),('9303','2013-05-11','15:05:00',3.85),('9303','2013-05-11','15:10:00',4.1),('9303','2013-05-11','15:15:00',3.95),('9303','2013-05-11','15:20:00',3.92),('9303','2013-05-11','15:25:00',3.79),('9303','2013-05-11','15:30:00',3.78),('9303','2013-05-11','15:35:00',3.46),('9303','2013-05-11','15:40:00',3.73),('9303','2013-05-11','15:45:00',3.64),('9303','2013-05-11','15:50:00',2.82),('9303','2013-05-11','15:55:00',3.48),('9303','2013-05-11','16:00:00',3.54),('9303','2013-05-11','16:05:00',3.39),('9303','2013-05-11','16:10:00',3.31),('9303','2013-05-11','16:15:00',2.85),('9303','2013-05-11','16:20:00',3.29),('9303','2013-05-11','16:25:00',3.18),('9303','2013-05-11','16:30:00',2.84),('9303','2013-05-11','16:35:00',2.64),('9303','2013-05-11','16:40:00',2.88),('9303','2013-05-11','16:45:00',2.79),('9303','2013-05-11','16:50:00',1.94),('9303','2013-05-11','16:55:00',2.7),('9303','2013-05-11','17:00:00',2.55),('9303','2013-05-11','17:05:00',2.2),('9303','2013-05-11','17:10:00',2.26),('9303','2013-05-11','17:15:00',1.72),('9303','2013-05-11','17:20:00',1.98),('9303','2013-05-11','17:25:00',2.06),('9303','2013-05-11','17:30:00',1.76),('9303','2013-05-11','17:35:00',1.65),('9303','2013-05-11','17:40:00',1.55),('9303','2013-05-11','17:45:00',1.86),('9303','2013-05-11','17:50:00',1.14),('9303','2013-05-11','17:55:00',1.37),('9303','2013-05-11','18:05:00',1.04),('9303','2013-05-11','18:10:00',1.34),('9303','2013-05-11','18:15:00',1.01),('9303','2013-05-11','18:25:00',1.06),('9303','2013-05-10','07:55:00',1.16),('9303','2013-05-10','08:00:00',1.22),('9303','2013-05-10','08:05:00',1.81),('9303','2013-05-10','08:10:00',1.85),('9303','2013-05-10','08:15:00',1.92),('9303','2013-05-10','08:20:00',1.79),('9303','2013-05-10','08:25:00',1.71),('9303','2013-05-10','08:30:00',1.8),('9303','2013-05-10','08:35:00',1.81),('9303','2013-05-10','09:00:00',1.36),('9303','2013-05-10','09:05:00',2.25),('9303','2013-05-10','09:10:00',2.53),('9303','2013-05-10','09:15:00',2.63),('9303','2013-05-10','09:20:00',2.53),('9303','2013-05-10','09:25:00',2.21),('9303','2013-05-10','09:30:00',2.32),('9303','2013-05-10','09:35:00',2.85),('9303','2013-05-10','09:40:00',2.53),('9303','2013-05-10','09:45:00',2.78),('9303','2013-05-10','09:50:00',2.84),('9303','2013-05-10','09:55:00',2.12),('9303','2013-05-10','10:00:00',1.42),('9303','2013-05-10','10:05:00',2.34),('9303','2013-05-10','10:10:00',1.35),('9303','2013-05-10','10:15:00',1.98),('9303','2013-05-10','10:20:00',1.29),('9303','2013-05-10','10:25:00',2.38),('9303','2013-05-10','10:30:00',1.77),('9303','2013-05-10','10:35:00',1.79),('9303','2013-05-10','10:40:00',2.75),('9303','2013-05-10','10:45:00',3.86),('9303','2013-05-10','10:50:00',3.55),('9303','2013-05-10','10:55:00',3.25),('9303','2013-05-10','11:00:00',3.92),('9303','2013-05-10','11:05:00',3.94),('9303','2013-05-10','11:10:00',3.89),('9303','2013-05-10','11:15:00',3.59),('9303','2013-05-10','11:20:00',4.19),('9303','2013-05-10','11:25:00',3.81),('9303','2013-05-10','11:30:00',3.54),('9303','2013-05-10','11:35:00',3.4),('9303','2013-05-10','11:40:00',3.47),('9303','2013-05-10','11:45:00',2.17),('9303','2013-05-10','11:50:00',3.39),('9303','2013-05-10','11:55:00',4.19),('9303','2013-05-10','12:00:00',3.52),('9303','2013-05-10','12:05:00',2.55),('9303','2013-05-10','12:10:00',1.88),('9303','2013-05-10','12:15:00',2.08),('9303','2013-05-10','12:20:00',2.26),('9303','2013-05-10','12:25:00',2.18),('9303','2013-05-10','12:30:00',2.32),('9303','2013-05-10','12:35:00',2.59),('9303','2013-05-10','12:40:00',2.66),('9303','2013-05-10','12:45:00',4.46),('9303','2013-05-10','12:50:00',3.68),('9303','2013-05-10','12:55:00',3.1),('9303','2013-05-10','13:00:00',4.05),('9303','2013-05-10','13:05:00',3.65),('9303','2013-05-10','13:10:00',4.47),('9303','2013-05-10','13:15:00',4.61),('9303','2013-05-10','13:20:00',3.12),('9303','2013-05-10','13:25:00',2.84),('9303','2013-05-10','13:30:00',3.14),('9303','2013-05-10','13:35:00',3.56),('9303','2013-05-10','13:40:00',4.3),('9303','2013-05-10','13:45:00',3.88),('9303','2013-05-10','13:50:00',2.28),('9303','2013-05-10','13:55:00',2.02),('9303','2013-05-10','14:00:00',1.83),('9303','2013-05-10','14:05:00',1.9),('9303','2013-05-10','14:10:00',2.33),('9303','2013-05-10','14:15:00',2.42),('9303','2013-05-10','14:20:00',2.44),('9303','2013-05-10','14:25:00',2.45),('9303','2013-05-10','14:30:00',2.45),('9303','2013-05-10','14:35:00',3.05),('9303','2013-05-10','14:40:00',2.64),('9303','2013-05-10','14:45:00',1.91),('9303','2013-05-10','14:50:00',1.41),('9303','2013-05-10','14:55:00',1.22),('9303','2013-05-10','15:00:00',1.15),('9303','2013-05-10','15:05:00',1.25),('9303','2013-05-10','15:10:00',1.71),('9303','2013-05-10','15:15:00',3.17),('9303','2013-05-10','15:20:00',2.6),('9303','2013-05-10','15:25:00',1.9),('9303','2013-05-10','15:30:00',1.8),('9303','2013-05-10','15:35:00',1.84),('9303','2013-05-10','15:40:00',1.91),('9303','2013-05-10','15:45:00',1.82),('9303','2013-05-10','15:50:00',1.67),('9303','2013-05-10','15:55:00',1.58),('9303','2013-05-10','16:00:00',1.52),('9303','2013-05-10','16:05:00',1.49),('9303','2013-05-10','16:10:00',1.47),('9303','2013-05-10','16:15:00',1.36),('9303','2013-05-10','16:20:00',1.22),('9303','2013-05-10','16:25:00',1.22),('9303','2013-05-10','16:30:00',1.29),('9303','2013-05-10','16:35:00',1.37),('9303','2013-05-10','16:40:00',1.3),('9303','2013-05-10','16:45:00',1.32),('9303','2013-05-10','16:50:00',1.27),('9303','2013-05-10','16:55:00',1.07),('9303','2013-05-10','17:10:00',1.04),('9303','2013-05-10','17:15:00',1.33),('9303','2013-05-10','17:20:00',1.78),('9303','2013-05-10','17:25:00',1.71),('9303','2013-05-10','17:30:00',1.52),('9303','2013-05-10','17:35:00',1.49),('9303','2013-05-10','17:40:00',1.23),('9303','2013-05-10','17:45:00',1.1),('9303','2013-05-09','07:50:00',1.06),('9303','2013-05-09','07:55:00',1.16),('9303','2013-05-09','08:00:00',1.25),('9303','2013-05-09','08:05:00',1.35),('9303','2013-05-09','08:10:00',1.45),('9303','2013-05-09','08:15:00',1.53),('9303','2013-05-09','08:20:00',1.64),('9303','2013-05-09','08:25:00',1.73),('9303','2013-05-09','08:30:00',1.83),('9303','2013-05-09','08:35:00',1.92),('9303','2013-05-09','08:40:00',2),('9303','2013-05-09','08:45:00',2.1),('9303','2013-05-09','08:50:00',2.16),('9303','2013-05-09','08:55:00',2.24),('9303','2013-05-09','09:00:00',2.32),('9303','2013-05-09','09:05:00',2.41),('9303','2013-05-09','09:10:00',2.49),('9303','2013-05-09','09:15:00',2.57),('9303','2013-05-09','09:20:00',2.63),('9303','2013-05-09','09:25:00',2.73),('9303','2013-05-09','09:30:00',2.8),('9303','2013-05-09','09:35:00',2.87),('9303','2013-05-09','09:40:00',2.91),('9303','2013-05-09','09:45:00',2.98),('9303','2013-05-09','09:50:00',3.06),('9303','2013-05-09','09:55:00',3.13),('9303','2013-05-09','10:00:00',3.19),('9303','2013-05-09','10:05:00',3.24),('9303','2013-05-09','10:10:00',3.3),('9303','2013-05-09','10:15:00',3.35),('9303','2013-05-09','10:20:00',3.39),('9303','2013-05-09','10:25:00',3.44),('9303','2013-05-09','10:30:00',3.49),('9303','2013-05-09','10:35:00',3.51),('9303','2013-05-09','10:40:00',3.55),('9303','2013-05-09','10:45:00',3.6),('9303','2013-05-09','10:50:00',3.65),('9303','2013-05-09','10:55:00',3.71),('9303','2013-05-09','11:00:00',3.72),('9303','2013-05-09','11:05:00',3.76),('9303','2013-05-09','11:10:00',3.78),('9303','2013-05-09','11:15:00',3.8),('9303','2013-05-09','11:20:00',3.83),('9303','2013-05-09','11:25:00',3.82),('9303','2013-05-09','11:30:00',3.84),('9303','2013-05-09','11:35:00',3.91),('9303','2013-05-09','11:40:00',3.91),('9303','2013-05-09','11:45:00',3.88),('9303','2013-05-09','11:50:00',3.88),('9303','2013-05-09','11:55:00',4),('9303','2013-05-09','12:00:00',4.02),('9303','2013-05-09','12:05:00',4.07),('9303','2013-05-09','12:10:00',4.1),('9303','2013-05-09','12:15:00',4.08),('9303','2013-05-09','12:20:00',4.05),('9303','2013-05-09','12:25:00',4.08),('9303','2013-05-09','12:30:00',4.13),('9303','2013-05-09','12:35:00',4.03),('9303','2013-05-09','12:40:00',4.22),('9303','2013-05-09','12:45:00',4.22),('9303','2013-05-09','12:50:00',4.28),('9303','2013-05-09','12:55:00',4.2),('9303','2013-05-09','13:00:00',4.14),('9303','2013-05-09','13:05:00',4.15),('9303','2013-05-09','13:10:00',4.17),('9303','2013-05-09','13:15:00',4.19),('9303','2013-05-09','13:20:00',4.22),('9303','2013-05-09','13:25:00',4.17),('9303','2013-05-09','13:30:00',4.2),('9303','2013-05-09','13:35:00',4.22),('9303','2013-05-09','13:40:00',4.21),('9303','2013-05-09','13:45:00',4.21),('9303','2013-05-09','13:50:00',4.18),('9303','2013-05-09','13:55:00',4.17),('9303','2013-05-09','14:00:00',2.54),('9303','2013-05-09','14:05:00',4.16),('9303','2013-05-09','14:10:00',3.11),('9303','2013-05-09','14:15:00',2.39),('9303','2013-05-09','14:20:00',2.49),('9303','2013-05-09','14:25:00',4.21),('9303','2013-05-09','14:30:00',3.73),('9303','2013-05-09','14:35:00',3.93),('9303','2013-05-09','14:40:00',3.93),('9303','2013-05-09','14:45:00',3.9),('9303','2013-05-09','14:50:00',3.82),('9303','2013-05-09','14:55:00',3.84),('9303','2013-05-09','15:00:00',3.84),('9303','2013-05-09','15:05:00',3.76),('9303','2013-05-09','15:10:00',3.71),('9303','2013-05-09','15:15:00',3.67),('9303','2013-05-09','15:20:00',3.6),('9303','2013-05-09','15:25:00',3.55),('9303','2013-05-09','15:30:00',3.54),('9303','2013-05-09','15:35:00',3.5),('9303','2013-05-09','15:40:00',3.44),('9303','2013-05-09','15:45:00',3.41),('9303','2013-05-09','15:50:00',3.36),('9303','2013-05-09','15:55:00',3.3),('9303','2013-05-09','16:00:00',3.23),('9303','2013-05-09','16:05:00',3.17),('9303','2013-05-09','16:10:00',3.13),('9303','2013-05-09','16:15:00',3.06),('9303','2013-05-09','16:20:00',2.98),('9303','2013-05-09','16:25:00',2.89),('9303','2013-05-09','16:30:00',2.84),('9303','2013-05-09','16:35:00',2.76),('9303','2013-05-09','16:40:00',2.7),('9303','2013-05-09','16:45:00',2.62),('9303','2013-05-09','16:50:00',2.54),('9303','2013-05-09','16:55:00',2.44),('9303','2013-05-09','17:00:00',2.33),('9303','2013-05-09','17:05:00',2.22),('9303','2013-05-09','17:10:00',2.12),('9303','2013-05-09','17:15:00',2.03),('9303','2013-05-09','17:20:00',1.98),('9303','2013-05-09','17:25:00',1.91),('9303','2013-05-09','17:30:00',1.82),('9303','2013-05-09','17:35:00',1.73),('9303','2013-05-09','17:40:00',1.63),('9303','2013-05-09','17:45:00',1.54),('9303','2013-05-09','17:50:00',1.43),('9303','2013-05-09','17:55:00',1.34),('9303','2013-05-09','18:00:00',1.25),('9303','2013-05-09','18:05:00',1.16),('9303','2013-05-09','18:10:00',1.07),('9303','2013-05-08','08:05:00',1.4),('9303','2013-05-08','08:10:00',1.56),('9303','2013-05-08','08:15:00',1.61),('9303','2013-05-08','08:20:00',1.67),('9303','2013-05-08','08:25:00',1.76),('9303','2013-05-08','08:30:00',1.8),('9303','2013-05-08','08:35:00',1.86),('9303','2013-05-08','08:40:00',2.02),('9303','2013-05-08','08:45:00',2.24),('9303','2013-05-08','08:50:00',2.15),('9303','2013-05-08','08:55:00',2.17),('9303','2013-05-08','09:00:00',1.98),('9303','2013-05-08','09:05:00',1.62),('9303','2013-05-08','09:10:00',2.05),('9303','2013-05-08','09:15:00',1.05),('9303','2013-05-08','09:40:00',2.38),('9303','2013-05-08','09:45:00',1.89),('9303','2013-05-08','09:50:00',1.56),('9303','2013-05-08','09:55:00',2.26),('9303','2013-05-08','10:05:00',1.82),('9303','2013-05-08','10:10:00',2.57),('9303','2013-05-08','10:15:00',1.24),('9303','2013-05-08','11:00:00',1.63),('9303','2013-05-08','11:05:00',4.33),('9303','2013-05-08','11:10:00',4.21),('9303','2013-05-08','11:15:00',4.09),('9303','2013-05-08','11:20:00',3.98),('9303','2013-05-08','11:25:00',4.09),('9303','2013-05-08','11:30:00',4.22),('9303','2013-05-08','11:35:00',2.88),('9303','2013-05-08','11:40:00',4.02),('9303','2013-05-08','11:45:00',1.63),('9303','2013-05-08','11:50:00',1.52),('9303','2013-05-08','11:55:00',1.5),('9303','2013-05-08','12:00:00',2.76),('9303','2013-05-08','12:05:00',2.81),('9303','2013-05-08','12:20:00',2.67),('9303','2013-05-08','12:25:00',4.42),('9303','2013-05-08','12:30:00',2.31),('9303','2013-05-08','12:35:00',1.01),('9303','2013-05-08','12:40:00',1.1),('9303','2013-05-08','12:45:00',1.34),('9303','2013-05-08','12:50:00',1.35),('9303','2013-05-08','12:55:00',3.15),('9303','2013-05-08','13:00:00',3.33),('9303','2013-05-08','13:05:00',4.97),('9303','2013-05-08','13:10:00',4.9),('9303','2013-05-08','13:15:00',2.56),('9303','2013-05-08','13:20:00',1),('9303','2013-05-08','13:25:00',1.26),('9303','2013-05-08','13:40:00',1.59),('9303','2013-05-08','13:45:00',4.79),('9303','2013-05-08','13:50:00',4.67),('9303','2013-05-08','13:55:00',4.59),('9303','2013-05-08','14:00:00',3.11),('9303','2013-05-08','14:05:00',4.51),('9303','2013-05-08','14:10:00',2.84),('9303','2013-05-08','14:15:00',1.35),('9303','2013-05-08','14:20:00',1.68),('9303','2013-05-08','14:25:00',1.34),('9303','2013-05-08','14:30:00',1.54),('9303','2013-05-08','14:35:00',2.04),('9303','2013-05-08','14:40:00',4.67),('9303','2013-05-08','14:45:00',1.83),('9303','2013-05-08','14:50:00',3.5),('9303','2013-05-08','14:55:00',3.84),('9303','2013-05-08','15:00:00',2.83),('9303','2013-05-08','15:05:00',3.92),('9303','2013-05-08','15:10:00',3.92),('9303','2013-05-08','15:15:00',3.84),('9303','2013-05-08','15:20:00',3.75),('9303','2013-05-08','15:25:00',3.71),('9303','2013-05-08','15:30:00',3.64),('9303','2013-05-08','15:35:00',3.53),('9303','2013-05-08','15:40:00',3.45),('9303','2013-05-08','15:45:00',3.44),('9303','2013-05-08','15:50:00',3.36),('9303','2013-05-08','15:55:00',3.34),('9303','2013-05-08','16:00:00',3.31),('9303','2013-05-08','16:05:00',3.23),('9303','2013-05-08','16:10:00',3.19),('9303','2013-05-08','16:15:00',3.12),('9303','2013-05-08','16:20:00',3.02),('9303','2013-05-08','16:25:00',2.95),('9303','2013-05-08','16:30:00',3.02),('9303','2013-05-08','16:35:00',2.95),('9303','2013-05-08','16:40:00',2.52),('9303','2013-05-08','16:45:00',1.26),('9303','2013-05-08','16:50:00',2.7),('9303','2013-05-08','16:55:00',2.62),('9303','2013-05-08','17:00:00',2.61),('9303','2013-05-08','17:05:00',2.3),('9303','2013-05-08','17:10:00',2.47),('9303','2013-05-08','17:15:00',2.34),('9303','2013-05-08','17:20:00',1.98),('9303','2013-05-08','17:25:00',2.07),('9303','2013-05-08','17:30:00',2.17),('9303','2013-05-08','17:35:00',2.1),('9303','2013-05-08','17:40:00',2.07),('9303','2013-05-08','17:45:00',2.06),('9303','2013-05-08','17:50:00',2),('9303','2013-05-08','17:55:00',1.49),('9303','2013-05-08','18:15:00',1.29),('9303','2013-05-08','18:20:00',1.22),('9303','2013-05-08','18:25:00',1.09),('9303','2013-05-07','07:50:00',1.03),('9303','2013-05-07','07:55:00',1.13),('9303','2013-05-07','08:00:00',1.22),('9303','2013-05-07','08:05:00',1.33),('9303','2013-05-07','08:10:00',1.42),('9303','2013-05-07','08:15:00',1.52),('9303','2013-05-07','08:20:00',1.62),('9303','2013-05-07','08:25:00',1.74),('9303','2013-05-07','08:30:00',1.84),('9303','2013-05-07','08:35:00',1.92),('9303','2013-05-07','08:40:00',2),('9303','2013-05-07','08:45:00',1.74),('9303','2013-05-07','08:50:00',2.27),('9303','2013-05-07','08:55:00',2.42),('9303','2013-05-07','09:00:00',2.42),('9303','2013-05-07','09:05:00',2.39),('9303','2013-05-07','09:10:00',1.38),('9303','2013-05-07','09:15:00',1.54),('9303','2013-05-07','09:20:00',1.42),('9303','2013-05-07','09:35:00',1.2),('9303','2013-05-07','09:40:00',1.29),('9303','2013-05-07','09:45:00',1.61),('9303','2013-05-07','09:50:00',1.91),('9303','2013-05-07','09:55:00',1.09),('9303','2013-05-07','11:00:00',1.05),('9303','2013-05-07','11:05:00',1.2),('9303','2013-05-07','11:10:00',1.21),('9303','2013-05-07','11:15:00',1.24),('9303','2013-05-07','11:20:00',1.67),('9303','2013-05-07','11:25:00',2.58),('9303','2013-05-07','11:30:00',1.06),('9303','2013-05-07','12:00:00',1.77),('9303','2013-05-07','12:05:00',4.53),('9303','2013-05-07','12:10:00',2.2),('9303','2013-05-07','12:15:00',4.84),('9303','2013-05-07','12:20:00',3.06),('9303','2013-05-07','12:25:00',4.43),('9303','2013-05-07','12:30:00',3.34),('9303','2013-05-07','13:25:00',1.09),('9303','2013-05-07','13:30:00',1.4),('9303','2013-05-07','13:35:00',2.26),('9303','2013-05-07','13:40:00',3.32),('9303','2013-05-07','13:45:00',4.48),('9303','2013-05-07','13:50:00',4.6),('9303','2013-05-07','13:55:00',4.52),('9303','2013-05-07','14:00:00',4.54),('9303','2013-05-07','14:05:00',3.95),('9303','2013-05-07','14:10:00',4.41),('9303','2013-05-07','14:15:00',4.5),('9303','2013-05-07','14:20:00',4.05),('9303','2013-05-07','14:25:00',1.02),('9303','2013-05-07','14:30:00',3.47),('9303','2013-05-07','14:35:00',2.32),('9303','2013-05-07','14:40:00',4.81),('9303','2013-05-07','14:45:00',3.54),('9303','2013-05-07','14:50:00',3.68),('9303','2013-05-07','14:55:00',3.55),('9303','2013-05-07','15:00:00',2.8),('9303','2013-05-07','15:05:00',4.21),('9303','2013-05-07','15:10:00',3.08),('9303','2013-05-07','15:15:00',3.81),('9303','2013-05-07','15:20:00',3.55),('9303','2013-05-07','15:25:00',2.41),('9303','2013-05-07','15:30:00',2.01),('9303','2013-05-07','15:35:00',2.86),('9303','2013-05-07','15:40:00',2.3),('9303','2013-05-07','15:45:00',2.14),('9303','2013-05-07','15:50:00',1.79),('9303','2013-05-07','15:55:00',1.88),('9303','2013-05-07','16:00:00',3.14),('9303','2013-05-07','16:05:00',1.91),('9303','2013-05-07','16:10:00',1.12),('9303','2013-05-07','16:15:00',2.2),('9303','2013-05-07','16:20:00',4.11),('9303','2013-05-07','16:25:00',3.83),('9303','2013-05-07','16:30:00',3.61),('9303','2013-05-07','16:35:00',3.5),('9303','2013-05-07','16:40:00',3.6),('9303','2013-05-07','16:45:00',2.5),('9303','2013-05-07','16:50:00',2.56),('9303','2013-05-07','16:55:00',2.36),('9303','2013-05-07','17:00:00',2.69),('9303','2013-05-07','17:05:00',2.63),('9303','2013-05-07','17:10:00',1.89),('9303','2013-05-07','17:15:00',1.13),('9303','2013-05-07','17:20:00',1.08),('9303','2013-05-07','17:25:00',1.12),('9303','2013-05-06','08:25:00',1.02),('9303','2013-05-06','08:30:00',1.19),('9303','2013-05-06','08:35:00',1.03),('9303','2013-05-06','08:55:00',1.74),('9303','2013-05-06','09:00:00',2.06),('9303','2013-05-06','09:05:00',1.34),('9303','2013-05-06','09:10:00',1.39),('9303','2013-05-06','09:15:00',1.31),('9303','2013-05-06','09:20:00',1.19),('9303','2013-05-06','09:25:00',1.03),('9303','2013-05-06','10:00:00',1.59),('9303','2013-05-06','10:05:00',1.11),('9303','2013-05-06','10:10:00',1.06),('9303','2013-05-06','10:15:00',1.28),('9303','2013-05-06','10:20:00',1.92),('9303','2013-05-06','10:25:00',1.59),('9303','2013-05-06','10:30:00',1.62),('9303','2013-05-06','10:35:00',1.63),('9303','2013-05-06','10:40:00',1.57),('9303','2013-05-06','10:45:00',2.13),('9303','2013-05-06','10:50:00',2.47),('9303','2013-05-06','10:55:00',1.88),('9303','2013-05-06','11:00:00',1.77),('9303','2013-05-06','11:05:00',1.89),('9303','2013-05-06','11:10:00',1.79),('9303','2013-05-06','11:15:00',1.61),('9303','2013-05-06','11:20:00',1.93),('9303','2013-05-06','11:25:00',1.99),('9303','2013-05-06','11:30:00',1.72),('9303','2013-05-06','11:35:00',1.35),('9303','2013-05-06','11:40:00',2.42),('9303','2013-05-06','11:45:00',4.18),('9303','2013-05-06','11:50:00',2.6),('9303','2013-05-06','11:55:00',1.61),('9303','2013-05-06','12:00:00',1.64),('9303','2013-05-06','12:05:00',1.82),('9303','2013-05-06','12:10:00',4.24),('9303','2013-05-06','12:15:00',2.9),('9303','2013-05-06','12:20:00',2.39),('9303','2013-05-06','12:25:00',2.89),('9303','2013-05-06','12:30:00',3.93),('9303','2013-05-06','12:35:00',4.28),('9303','2013-05-06','12:40:00',2.71),('9303','2013-05-06','12:45:00',2.02),('9303','2013-05-06','12:50:00',2.7),('9303','2013-05-06','12:55:00',3.51),('9303','2013-05-06','13:00:00',2.05),('9303','2013-05-06','13:05:00',3.03),('9303','2013-05-06','13:10:00',3.94),('9303','2013-05-06','13:15:00',3.62),('9303','2013-05-06','13:20:00',3.43),('9303','2013-05-06','13:25:00',2.63),('9303','2013-05-06','13:30:00',3.46),('9303','2013-05-06','13:35:00',2.79),('9303','2013-05-06','13:40:00',3.48),('9303','2013-05-06','13:45:00',4.59),('9303','2013-05-06','13:50:00',3.64),('9303','2013-05-06','13:55:00',4.52),('9303','2013-05-06','14:00:00',3.07),('9303','2013-05-06','14:05:00',4.4),('9303','2013-05-06','14:10:00',2.54),('9303','2013-05-06','14:15:00',3.09),('9303','2013-05-06','14:20:00',4.12),('9303','2013-05-06','14:25:00',2.22),('9303','2013-05-06','14:30:00',3.53),('9303','2013-05-06','14:35:00',3.58),('9303','2013-05-06','14:40:00',1.92),('9303','2013-05-06','14:45:00',3.32),('9303','2013-05-06','14:50:00',1.93),('9303','2013-05-06','14:55:00',3.49),('9303','2013-05-06','15:00:00',3.91),('9303','2013-05-06','15:05:00',3.08),('9303','2013-05-06','15:10:00',3.65),('9303','2013-05-06','15:15:00',2.1),('9303','2013-05-06','15:20:00',1.88),('9303','2013-05-06','15:25:00',3.14),('9303','2013-05-06','15:30:00',1.66),('9303','2013-05-06','15:35:00',1.5),('9303','2013-05-06','15:40:00',1.52),('9303','2013-05-06','15:45:00',1.27),('9303','2013-05-06','15:50:00',2.08),('9303','2013-05-06','15:55:00',1.8),('9303','2013-05-06','16:00:00',2.12),('9303','2013-05-06','16:05:00',1.37),('9303','2013-05-06','16:10:00',1.24),('9303','2013-05-06','16:15:00',1.68),('9303','2013-05-06','16:20:00',1.54),('9303','2013-05-06','16:25:00',1.65),('9303','2013-05-06','16:30:00',2.06),('9303','2013-05-06','16:35:00',1.47),('9303','2013-05-06','16:40:00',2.46),('9303','2013-05-06','16:45:00',2.82),('9303','2013-05-06','16:50:00',2.3),('9303','2013-05-06','16:55:00',2.73),('9303','2013-05-06','17:00:00',1.17),('9303','2013-05-06','17:35:00',1.09),('9303','2013-05-06','17:40:00',1.38),('9303','2013-05-06','17:50:00',1.06),('9303','2013-05-06','18:00:00',1.31),('9303','2013-05-06','18:05:00',1.42),('9303','2013-05-06','18:20:00',1.24),('9303','2013-05-06','18:25:00',1.01),('9303','2013-05-05','08:00:00',1.04),('9303','2013-05-05','08:05:00',1.19),('9303','2013-05-05','08:10:00',1.31),('9303','2013-05-05','08:15:00',1.43),('9303','2013-05-05','08:20:00',1.67),('9303','2013-05-05','08:25:00',2.03),('9303','2013-05-05','08:30:00',2.13),('9303','2013-05-05','08:35:00',1.83),('9303','2013-05-05','08:40:00',2.01),('9303','2013-05-05','08:45:00',1.64),('9303','2013-05-05','08:50:00',1.28),('9303','2013-05-05','08:55:00',1.17),('9303','2013-05-05','09:00:00',1.32),('9303','2013-05-05','09:05:00',1.46),('9303','2013-05-05','09:10:00',1.51),('9303','2013-05-05','09:15:00',1.63),('9303','2013-05-05','09:20:00',1.23),('9303','2013-05-05','09:25:00',1.4),('9303','2013-05-05','09:30:00',1.76),('9303','2013-05-05','09:35:00',1.31),('9303','2013-05-05','09:40:00',2.07),('9303','2013-05-05','09:45:00',2.67),('9303','2013-05-05','09:50:00',2.6),('9303','2013-05-05','09:55:00',3.23),('9303','2013-05-05','10:00:00',2.56),('9303','2013-05-05','10:05:00',2.47),('9303','2013-05-05','10:10:00',2.23),('9303','2013-05-05','10:15:00',2.2),('9303','2013-05-05','10:20:00',3.66),('9303','2013-05-05','10:25:00',2.24),('9303','2013-05-05','10:30:00',2.46),('9303','2013-05-05','10:35:00',2.52),('9303','2013-05-05','10:40:00',2.23),('9303','2013-05-05','10:45:00',2.35),('9303','2013-05-05','10:50:00',1.69),('9303','2013-05-05','10:55:00',1.47),('9303','2013-05-05','11:00:00',1.38),('9303','2013-05-05','11:05:00',1.63),('9303','2013-05-05','11:10:00',1.53),('9303','2013-05-05','11:15:00',1.55),('9303','2013-05-05','11:20:00',2.26),('9303','2013-05-05','11:25:00',3.33),('9303','2013-05-05','11:30:00',2.55),('9303','2013-05-05','11:35:00',3.72),('9303','2013-05-05','11:40:00',2.67),('9303','2013-05-05','11:45:00',2.64),('9303','2013-05-05','11:50:00',2.73),('9303','2013-05-05','11:55:00',3.42),('9303','2013-05-05','12:00:00',2.67),('9303','2013-05-05','12:05:00',2.34),('9303','2013-05-05','12:10:00',2.4),('9303','2013-05-05','12:15:00',2.94),('9303','2013-05-05','12:20:00',2.69),('9303','2013-05-05','12:25:00',4.05),('9303','2013-05-05','12:30:00',3.88),('9303','2013-05-05','12:35:00',3.39),('9303','2013-05-05','12:40:00',3.82),('9303','2013-05-05','12:45:00',3.96),('9303','2013-05-05','12:50:00',3.91),('9303','2013-05-05','12:55:00',4.08),('9303','2013-05-05','13:00:00',4.26),('9303','2013-05-05','13:05:00',4.23),('9303','2013-05-05','13:10:00',4.33),('9303','2013-05-05','13:15:00',4.35),('9303','2013-05-05','13:20:00',3.38),('9303','2013-05-05','13:25:00',1.84),('9303','2013-05-05','13:30:00',1.53),('9303','2013-05-05','13:35:00',3.58),('9303','2013-05-05','13:40:00',4.27),('9303','2013-05-05','13:45:00',4.22),('9303','2013-05-05','13:50:00',4.26),('9303','2013-05-05','13:55:00',4.28),('9303','2013-05-05','14:00:00',4.35),('9303','2013-05-05','14:05:00',4.24),('9303','2013-05-05','14:10:00',3.28),('9303','2013-05-05','14:15:00',3.17),('9303','2013-05-05','14:20:00',3.84),('9303','2013-05-05','14:25:00',3.86),('9303','2013-05-05','14:30:00',3.76),('9303','2013-05-05','14:35:00',3.73),('9303','2013-05-05','14:40:00',3.64),('9303','2013-05-05','14:45:00',3.6),('9303','2013-05-05','14:50:00',3.56),('9303','2013-05-05','14:55:00',3.56),('9303','2013-05-05','15:00:00',3.52),('9303','2013-05-05','15:05:00',3.49),('9303','2013-05-05','15:10:00',3.45),('9303','2013-05-05','15:15:00',3.44),('9303','2013-05-05','15:20:00',3.37),('9303','2013-05-05','15:25:00',3.34),('9303','2013-05-05','15:30:00',3.28),('9303','2013-05-05','15:35:00',3.23),('9303','2013-05-05','15:40:00',3.2),('9303','2013-05-05','15:45:00',3.17),('9303','2013-05-05','15:50:00',3.11),('9303','2013-05-05','15:55:00',3.06),('9303','2013-05-05','16:00:00',3),('9303','2013-05-05','16:05:00',2.94),('9303','2013-05-05','16:10:00',2.89),('9303','2013-05-05','16:15:00',2.84),('9303','2013-05-05','16:20:00',2.78),('9303','2013-05-05','16:25:00',2.71),('9303','2013-05-05','16:30:00',2.65),('9303','2013-05-05','16:35:00',2.56),('9303','2013-05-05','16:40:00',2.5),('9303','2013-05-05','16:45:00',2.43),('9303','2013-05-05','16:50:00',2.36),('9303','2013-05-05','16:55:00',2.24),('9303','2013-05-05','17:00:00',2.11),('9303','2013-05-05','17:05:00',2.02),('9303','2013-05-05','17:10:00',1.94),('9303','2013-05-05','17:15:00',1.88),('9303','2013-05-05','17:20:00',1.8),('9303','2013-05-05','17:25:00',1.71),('9303','2013-05-05','17:30:00',1.63),('9303','2013-05-05','17:35:00',1.56),('9303','2013-05-05','17:40:00',1.48),('9303','2013-05-05','17:45:00',1.4),('9303','2013-05-05','17:50:00',1.3),('9303','2013-05-05','17:55:00',1.21),('9303','2013-05-05','18:00:00',1.11),('9303','2013-05-05','18:05:00',1.03),('9303','2013-05-04','08:00:00',1.12),('9303','2013-05-04','08:05:00',1.19),('9303','2013-05-04','08:10:00',1.28),('9303','2013-05-04','08:15:00',1.36),('9303','2013-05-04','08:20:00',1.46),('9303','2013-05-04','08:25:00',1.53),('9303','2013-05-04','08:30:00',1.61),('9303','2013-05-04','08:35:00',1.69),('9303','2013-05-04','08:40:00',1.75),('9303','2013-05-04','08:45:00',1.85),('9303','2013-05-04','08:50:00',1.92),('9303','2013-05-04','08:55:00',2),('9303','2013-05-04','09:00:00',2.06),('9303','2013-05-04','09:05:00',2.15),('9303','2013-05-04','09:10:00',2.23),('9303','2013-05-04','09:15:00',2.24),('9303','2013-05-04','09:20:00',2.35),('9303','2013-05-04','09:25:00',2.41),('9303','2013-05-04','09:30:00',2.45),('9303','2013-05-04','09:35:00',2.55),('9303','2013-05-04','09:40:00',2.65),('9303','2013-05-04','09:45:00',2.71),('9303','2013-05-04','09:50:00',2.76),('9303','2013-05-04','09:55:00',2.83),('9303','2013-05-04','10:00:00',2.91),('9303','2013-05-04','10:05:00',2.95),('9303','2013-05-04','10:10:00',3.01),('9303','2013-05-04','10:15:00',3.06),('9303','2013-05-04','10:20:00',3.14),('9303','2013-05-04','10:25:00',3.19),('9303','2013-05-04','10:30:00',3.22),('9303','2013-05-04','10:35:00',3.26),('9303','2013-05-04','10:40:00',3.23),('9303','2013-05-04','10:45:00',3.27),('9303','2013-05-04','10:50:00',3.21),('9303','2013-05-04','10:55:00',3.23),('9303','2013-05-04','11:00:00',3.26),('9303','2013-05-04','11:05:00',3.29),('9303','2013-05-04','11:10:00',3.14),('9303','2013-05-04','11:15:00',3.02),('9303','2013-05-04','11:20:00',3.24),('9303','2013-05-04','11:25:00',3.32),('9303','2013-05-04','11:30:00',3.16),('9303','2013-05-04','11:35:00',3.28),('9303','2013-05-04','11:40:00',3.19),('9303','2013-05-04','11:45:00',3.26),('9303','2013-05-04','11:50:00',3.31),('9303','2013-05-04','11:55:00',3.3),('9303','2013-05-04','12:00:00',3.27),('9303','2013-05-04','12:05:00',3.36),('9303','2013-05-04','12:10:00',3.41),('9303','2013-05-04','12:15:00',3.51),('9303','2013-05-04','12:20:00',3.55),('9303','2013-05-04','12:25:00',3.64),('9303','2013-05-04','12:30:00',3.67),('9303','2013-05-04','12:35:00',3.68),('9303','2013-05-04','12:40:00',3.64),('9303','2013-05-04','12:45:00',3.69),('9303','2013-05-04','12:50:00',3.6),('9303','2013-05-04','12:55:00',3.55),('9303','2013-05-04','13:00:00',3.53),('9303','2013-05-04','13:05:00',3.18),('9303','2013-05-04','13:10:00',3.35),('9303','2013-05-04','13:15:00',3.82),('9303','2013-05-04','13:20:00',3.88),('9303','2013-05-04','13:25:00',3.65),('9303','2013-05-04','13:30:00',3.65),('9303','2013-05-04','13:35:00',3.48),('9303','2013-05-04','13:40:00',3.59),('9303','2013-05-04','13:45:00',3.61),('9303','2013-05-04','13:50:00',3.16),('9303','2013-05-04','13:55:00',3.32),('9303','2013-05-04','14:00:00',3.46),('9303','2013-05-04','14:05:00',3.48),('9303','2013-05-04','14:10:00',3.35),('9303','2013-05-04','14:15:00',3.39),('9303','2013-05-04','14:20:00',3.43),('9303','2013-05-04','14:25:00',3.14),('9303','2013-05-04','14:30:00',3.34),('9303','2013-05-04','14:35:00',3.13),('9303','2013-05-04','14:40:00',3.25),('9303','2013-05-04','14:45:00',3.21),('9303','2013-05-04','14:50:00',3.03),('9303','2013-05-04','14:55:00',3.18),('9303','2013-05-04','15:00:00',3.19),('9303','2013-05-04','15:05:00',3.27),('9303','2013-05-04','15:10:00',3.08),('9303','2013-05-04','15:15:00',3.16),('9303','2013-05-04','15:20:00',3.19),('9303','2013-05-04','15:25:00',3.19),('9303','2013-05-04','15:30:00',3.14),('9303','2013-05-04','15:35:00',3),('9303','2013-05-04','15:40:00',2.99),('9303','2013-05-04','15:45:00',3.05),('9303','2013-05-04','15:50:00',2.98),('9303','2013-05-04','15:55:00',2.94),('9303','2013-05-04','16:00:00',2.89),('9303','2013-05-04','16:05:00',2.83),('9303','2013-05-04','16:10:00',2.75),('9303','2013-05-04','16:15:00',2.7),('9303','2013-05-04','16:20:00',2.62),('9303','2013-05-04','16:25:00',2.58),('9303','2013-05-04','16:30:00',2.51),('9303','2013-05-04','16:35:00',2.45),('9303','2013-05-04','16:40:00',2.37),('9303','2013-05-04','16:45:00',2.29),('9303','2013-05-04','16:50:00',2.21),('9303','2013-05-04','16:55:00',2.12),('9303','2013-05-04','17:00:00',2.02),('9303','2013-05-04','17:05:00',1.88),('9303','2013-05-04','17:10:00',1.44),('9303','2013-05-04','17:15:00',1.64),('9303','2013-05-04','17:20:00',1.72),('9303','2013-05-04','17:25:00',1.65),('9303','2013-05-04','17:30:00',1.56),('9303','2013-05-04','17:35:00',1.43),('9303','2013-05-04','17:40:00',1.33),('9303','2013-05-04','17:45:00',1.26),('9303','2013-05-04','17:50:00',1.26),('9303','2013-05-04','17:55:00',1.19),('9303','2013-05-04','18:00:00',1.09),('9303','2013-05-04','18:05:00',1.01),('9303','2013-05-03','08:05:00',1.16),('9303','2013-05-03','08:10:00',1.37),('9303','2013-05-03','08:15:00',1.59),('9303','2013-05-03','08:20:00',1.57),('9303','2013-05-03','08:25:00',1.73),('9303','2013-05-03','08:30:00',1.81),('9303','2013-05-03','08:35:00',1.86),('9303','2013-05-03','08:40:00',1.89),('9303','2013-05-03','08:45:00',1.97),('9303','2013-05-03','08:50:00',1.94),('9303','2013-05-03','08:55:00',1.96),('9303','2013-05-03','09:00:00',2.1),('9303','2013-05-03','09:05:00',2.21),('9303','2013-05-03','09:10:00',2.27),('9303','2013-05-03','09:15:00',2.35),('9303','2013-05-03','09:20:00',2.41),('9303','2013-05-03','09:25:00',2.48),('9303','2013-05-03','09:30:00',2.57),('9303','2013-05-03','09:35:00',2.66),('9303','2013-05-03','09:40:00',2.74),('9303','2013-05-03','09:45:00',2.81),('9303','2013-05-03','09:50:00',2.87),('9303','2013-05-03','09:55:00',2.93),('9303','2013-05-03','10:00:00',2.99),('9303','2013-05-03','10:05:00',3.05),('9303','2013-05-03','10:10:00',3.1),('9303','2013-05-03','10:15:00',3.14),('9303','2013-05-03','10:20:00',3.2),('9303','2013-05-03','10:25:00',3.26),('9303','2013-05-03','10:30:00',3.32),('9303','2013-05-03','10:35:00',3.34),('9303','2013-05-03','10:40:00',3.36),('9303','2013-05-03','10:45:00',3.37),('9303','2013-05-03','10:50:00',3.4),('9303','2013-05-03','10:55:00',3.45),('9303','2013-05-03','11:00:00',3.5),('9303','2013-05-03','11:05:00',3.54),('9303','2013-05-03','11:10:00',3.61),('9303','2013-05-03','11:15:00',3.65),('9303','2013-05-03','11:20:00',3.65),('9303','2013-05-03','11:25:00',3.68),('9303','2013-05-03','11:30:00',3.73),('9303','2013-05-03','11:35:00',3.76),('9303','2013-05-03','11:40:00',3.83),('9303','2013-05-03','11:45:00',3.8),('9303','2013-05-03','11:50:00',3.8),('9303','2013-05-03','11:55:00',3.81),('9303','2013-05-03','12:00:00',3.82),('9303','2013-05-03','12:05:00',3.83),('9303','2013-05-03','12:10:00',3.86),('9303','2013-05-03','12:15:00',3.88),('9303','2013-05-03','12:20:00',3.88),('9303','2013-05-03','12:25:00',3.91),('9303','2013-05-03','12:30:00',3.89),('9303','2013-05-03','12:35:00',3.9),('9303','2013-05-03','12:40:00',3.87),('9303','2013-05-03','12:45:00',3.85),('9303','2013-05-03','12:50:00',3.9),('9303','2013-05-03','12:55:00',3.95),('9303','2013-05-03','13:00:00',3.95),('9303','2013-05-03','13:05:00',3.92),('9303','2013-05-03','13:10:00',3.9),('9303','2013-05-03','13:15:00',3.92),('9303','2013-05-03','13:20:00',3.94),('9303','2013-05-03','13:25:00',3.94),('9303','2013-05-03','13:30:00',3.9),('9303','2013-05-03','13:35:00',3.83),('9303','2013-05-03','13:40:00',3.67),('9303','2013-05-03','13:45:00',3.73),('9303','2013-05-03','13:50:00',3.71),('9303','2013-05-03','13:55:00',3.72),('9303','2013-05-03','14:00:00',3.71),('9303','2013-05-03','14:05:00',3.54),('9303','2013-05-03','14:10:00',3.62),('9303','2013-05-03','14:15:00',3.54),('9303','2013-05-03','14:20:00',3.61),('9303','2013-05-03','14:25:00',3.58),('9303','2013-05-03','14:30:00',3.61),('9303','2013-05-03','14:35:00',3.65),('9303','2013-05-03','14:40:00',3.57),('9303','2013-05-03','14:45:00',3.53),('9303','2013-05-03','14:50:00',3.49),('9303','2013-05-03','14:55:00',3.48),('9303','2013-05-03','15:00:00',3.45),('9303','2013-05-03','15:05:00',3.43),('9303','2013-05-03','15:10:00',3.44),('9303','2013-05-03','15:15:00',3.43),('9303','2013-05-03','15:20:00',3.36),('9303','2013-05-03','15:25:00',3.31),('9303','2013-05-03','15:30:00',3.28),('9303','2013-05-03','15:35:00',3.26),('9303','2013-05-03','15:40:00',3.19),('9303','2013-05-03','15:45:00',3.15),('9303','2013-05-03','15:50:00',3.07),('9303','2013-05-03','15:55:00',3.01),('9303','2013-05-03','16:00:00',2.97),('9303','2013-05-03','16:05:00',2.92),('9303','2013-05-03','16:10:00',2.87),('9303','2013-05-03','16:15:00',2.78),('9303','2013-05-03','16:20:00',2.68),('9303','2013-05-03','16:25:00',2.61),('9303','2013-05-03','16:30:00',2.6),('9303','2013-05-03','16:35:00',2.52),('9303','2013-05-03','16:40:00',2.46),('9303','2013-05-03','16:45:00',2.38),('9303','2013-05-03','16:50:00',2.31),('9303','2013-05-03','16:55:00',2.19),('9303','2013-05-03','17:00:00',2.09),('9303','2013-05-03','17:05:00',1.99),('9303','2013-05-03','17:10:00',1.91),('9303','2013-05-03','17:15:00',1.83),('9303','2013-05-03','17:20:00',1.71),('9303','2013-05-03','17:25:00',1.6),('9303','2013-05-03','17:30:00',1.53),('9303','2013-05-03','17:35:00',1.46),('9303','2013-05-03','17:40:00',1.37),('9303','2013-05-03','17:45:00',1.27),('9303','2013-05-03','17:50:00',1.2),('9303','2013-05-03','17:55:00',1.13),('9303','2013-05-03','18:00:00',1.05),('9303','2013-05-02','08:55:00',1.05),('9303','2013-05-02','09:00:00',1.75),('9303','2013-05-02','09:05:00',1.61),('9303','2013-05-02','09:25:00',1.66),('9303','2013-05-02','09:30:00',2.09),('9303','2013-05-02','09:35:00',1.88),('9303','2013-05-02','09:40:00',1.36),('9303','2013-05-02','09:45:00',2.45),('9303','2013-05-02','09:50:00',1.23),('9303','2013-05-02','10:05:00',1.38),('9303','2013-05-02','10:10:00',1.34),('9303','2013-05-02','10:15:00',1.35),('9303','2013-05-02','10:20:00',1.39),('9303','2013-05-02','10:25:00',1.63),('9303','2013-05-02','10:30:00',2.69),('9303','2013-05-02','10:35:00',2.53),('9303','2013-05-02','10:40:00',3.09),('9303','2013-05-02','10:45:00',2.96),('9303','2013-05-02','10:50:00',3.27),('9303','2013-05-02','10:55:00',3.76),('9303','2013-05-02','11:00:00',3.8),('9303','2013-05-02','11:05:00',3.39),('9303','2013-05-02','11:10:00',2.85),('9303','2013-05-02','11:15:00',2.68),('9303','2013-05-02','11:20:00',2.41),('9303','2013-05-02','11:25:00',3.69),('9303','2013-05-02','11:30:00',3.86),('9303','2013-05-02','11:35:00',3.79),('9303','2013-05-02','11:40:00',3.74),('9303','2013-05-02','11:45:00',3.76),('9303','2013-05-02','11:50:00',3.76),('9303','2013-05-02','11:55:00',3.74),('9303','2013-05-02','12:00:00',3.75),('9303','2013-05-02','12:05:00',3.72),('9303','2013-05-02','12:10:00',3.72),('9303','2013-05-02','12:15:00',3.74),('9303','2013-05-02','12:20:00',3.78),('9303','2013-05-02','12:25:00',3.76),('9303','2013-05-02','12:30:00',3.8),('9303','2013-05-02','12:35:00',3.84),('9303','2013-05-02','12:40:00',3.88),('9303','2013-05-02','12:45:00',3.9),('9303','2013-05-02','12:50:00',3.93),('9303','2013-05-02','12:55:00',3.94),('9303','2013-05-02','13:00:00',3.98),('9303','2013-05-02','13:05:00',4.02),('9303','2013-05-02','13:10:00',4),('9303','2013-05-02','13:15:00',4.04),('9303','2013-05-02','13:20:00',4.03),('9303','2013-05-02','13:25:00',4.03),('9303','2013-05-02','13:30:00',4.02),('9303','2013-05-02','13:35:00',4.05),('9303','2013-05-02','13:40:00',4.04),('9303','2013-05-02','13:45:00',4.03),('9303','2013-05-02','13:50:00',3.99),('9303','2013-05-02','13:55:00',3.98),('9303','2013-05-02','14:00:00',3.96),('9303','2013-05-02','14:05:00',3.88),('9303','2013-05-02','14:10:00',3.85),('9303','2013-05-02','14:15:00',3.84),('9303','2013-05-02','14:20:00',3.83),('9303','2013-05-02','14:25:00',3.79),('9303','2013-05-02','14:30:00',3.76),('9303','2013-05-02','14:35:00',3.73),('9303','2013-05-02','14:40:00',3.69),('9303','2013-05-02','14:45:00',3.66),('9303','2013-05-02','14:50:00',3.64),('9303','2013-05-02','14:55:00',3.58),('9303','2013-05-02','15:00:00',3.57),('9303','2013-05-02','15:05:00',3.51),('9303','2013-05-02','15:10:00',3.46),('9303','2013-05-02','15:15:00',3.42),('9303','2013-05-02','15:20:00',3.35),('9303','2013-05-02','15:25:00',3.3),('9303','2013-05-02','15:30:00',3.24),('9303','2013-05-02','15:35:00',3.16),('9303','2013-05-02','15:40:00',3.14),('9303','2013-05-02','15:45:00',3.07),('9303','2013-05-02','15:50:00',3.08),('9303','2013-05-02','15:55:00',3.02),('9303','2013-05-02','16:00:00',2.96),('9303','2013-05-02','16:05:00',2.92),('9303','2013-05-02','16:10:00',2.86),('9303','2013-05-02','16:15:00',2.8),('9303','2013-05-02','16:20:00',2.73),('9303','2013-05-02','16:25:00',2.64),('9303','2013-05-02','16:30:00',2.57),('9303','2013-05-02','16:35:00',2.5),('9303','2013-05-02','16:40:00',2.44),('9303','2013-05-02','16:45:00',2.36),('9303','2013-05-02','16:50:00',2.29),('9303','2013-05-02','16:55:00',2.18),('9303','2013-05-02','17:00:00',2.07),('9303','2013-05-02','17:05:00',1.98),('9303','2013-05-02','17:10:00',1.91),('9303','2013-05-02','17:15:00',1.85),('9303','2013-05-02','17:20:00',1.78),('9303','2013-05-02','17:25:00',1.71),('9303','2013-05-02','17:30:00',1.63),('9303','2013-05-02','17:35:00',1.55),('9303','2013-05-02','17:40:00',1.48),('9303','2013-05-02','17:45:00',1.38),('9303','2013-05-02','17:50:00',1.3),('9303','2013-05-02','17:55:00',1.22),('9303','2013-05-02','18:00:00',1.12),('9303','2013-05-02','18:05:00',1.03),('9303','2014-03-30','08:25:00',1.1),('9303','2014-03-30','08:30:00',1.18),('9303','2014-03-30','08:35:00',1.26),('9303','2014-03-30','08:40:00',1.28),('9303','2014-03-30','08:45:00',1.3),('9303','2014-03-30','08:50:00',1.28),('9303','2014-03-30','08:55:00',1.35),('9303','2014-03-30','09:00:00',1.44),('9303','2014-03-30','09:05:00',1.41),('9303','2014-03-30','09:10:00',1.42),('9303','2014-03-30','09:15:00',1.33),('9303','2014-03-30','09:20:00',1.58),('9303','2014-03-30','09:25:00',1.73),('9303','2014-03-30','09:30:00',1.93),('9303','2014-03-30','09:35:00',2.12),('9303','2014-03-30','09:40:00',2.17),('9303','2014-03-30','09:45:00',2.29),('9303','2014-03-30','09:50:00',2.32),('9303','2014-03-30','09:55:00',2.35),('9303','2014-03-30','10:00:00',2.27),('9303','2014-03-30','10:05:00',2.52),('9303','2014-03-30','10:10:00',2.65),('9303','2014-03-30','10:15:00',2.67),('9303','2014-03-30','10:20:00',2.59),('9303','2014-03-30','10:25:00',2.72),('9303','2014-03-30','10:30:00',2.91),('9303','2014-03-30','10:35:00',2.99),('9303','2014-03-30','10:40:00',3.04),('9303','2014-03-30','10:45:00',3.03),('9303','2014-03-30','10:50:00',3.04),('9303','2014-03-30','10:55:00',3.07),('9303','2014-03-30','11:00:00',3.07),('9303','2014-03-30','11:05:00',3.07),('9303','2014-03-30','11:10:00',3.09),('9303','2014-03-30','11:15:00',2.97),('9303','2014-03-30','11:20:00',2.88),('9303','2014-03-30','11:25:00',2.98),('9303','2014-03-30','11:30:00',3.27),('9303','2014-03-30','11:35:00',3.29),('9303','2014-03-30','11:40:00',3.48),('9303','2014-03-30','11:45:00',3.57),('9303','2014-03-30','11:50:00',3.61),('9303','2014-03-30','11:55:00',3.67),('9303','2014-03-30','12:00:00',3.73),('9303','2014-03-30','12:05:00',3.91),('9303','2014-03-30','12:10:00',3.95),('9303','2014-03-30','12:15:00',4.06),('9303','2014-03-30','12:20:00',4),('9303','2014-03-30','12:25:00',3.96),('9303','2014-03-30','12:30:00',3.8),('9303','2014-03-30','12:35:00',3.67),('9303','2014-03-30','12:40:00',3.89),('9303','2014-03-30','12:45:00',3.85),('9303','2014-03-30','12:50:00',3.88),('9303','2014-03-30','12:55:00',3.88),('9303','2014-03-30','13:00:00',3.99),('9303','2014-03-30','13:05:00',4.06),('9303','2014-03-30','13:10:00',4.09),('9303','2014-03-30','13:15:00',4.06),('9303','2014-03-30','13:20:00',4.05),('9303','2014-03-30','13:25:00',4.04),('9303','2014-03-30','13:30:00',4.11),('9303','2014-03-30','13:35:00',4.15),('9303','2014-03-30','13:40:00',4.08),('9303','2014-03-30','13:45:00',4.08),('9303','2014-03-30','13:50:00',4.08),('9303','2014-03-30','13:55:00',4.01),('9303','2014-03-30','14:00:00',3.98),('9303','2014-03-30','14:05:00',3.98),('9303','2014-03-30','14:10:00',3.93),('9303','2014-03-30','14:15:00',3.78),('9303','2014-03-30','14:20:00',3.89),('9303','2014-03-30','14:25:00',3.96),('9303','2014-03-30','14:30:00',4),('9303','2014-03-30','14:35:00',3.85),('9303','2014-03-30','14:40:00',3.48),('9303','2014-03-30','14:45:00',3.34),('9303','2014-03-30','14:50:00',2.99),('9303','2014-03-30','14:55:00',2.45),('9303','2014-03-30','15:00:00',1.69),('9303','2014-03-30','15:05:00',1.58),('9303','2014-03-30','15:10:00',1.54),('9303','2014-03-30','15:15:00',1.64),('9303','2014-03-30','15:20:00',1.84),('9303','2014-03-30','15:25:00',2.91),('9303','2014-03-30','15:30:00',3.17),('9303','2014-03-30','15:35:00',3.13),('9303','2014-03-30','15:40:00',3.15),('9303','2014-03-30','15:45:00',3.13),('9303','2014-03-30','15:50:00',3.11),('9303','2014-03-30','15:55:00',3),('9303','2014-03-30','16:00:00',2.82),('9303','2014-03-30','16:05:00',2.44),('9303','2014-03-30','16:10:00',2.43),('9303','2014-03-30','16:15:00',2.32),('9303','2014-03-30','16:20:00',2.67),('9303','2014-03-30','16:25:00',2.72),('9303','2014-03-30','16:30:00',2.6),('9303','2014-03-30','16:35:00',2.64),('9303','2014-03-30','16:40:00',2.38),('9303','2014-03-30','16:45:00',2.2),('9303','2014-03-30','16:50:00',1.93),('9303','2014-03-30','16:55:00',1.71),('9303','2014-03-30','17:00:00',1.7),('9303','2014-03-30','17:05:00',1.89),('9303','2014-03-30','17:10:00',1.92),('9303','2014-03-30','17:15:00',1.91),('9303','2014-03-30','17:20:00',1.75),('9303','2014-03-30','17:25:00',1.53),('9303','2014-03-30','17:30:00',1.48),('9303','2014-03-30','17:35:00',1.44),('9303','2014-03-30','17:40:00',1.25),('9303','2014-03-30','17:45:00',1.23),('9303','2014-03-30','17:50:00',1.09),('9303','2013-05-01','08:05:00',1.03),('9303','2013-05-01','08:10:00',1.08),('9303','2013-05-01','08:15:00',1.18),('9303','2013-05-01','08:20:00',1.29),('9303','2013-05-01','08:25:00',1.41),('9303','2013-05-01','08:30:00',1.49),('9303','2013-05-01','08:35:00',1.59),('9303','2013-05-01','08:40:00',1.66),('9303','2013-05-01','08:45:00',1.74),('9303','2013-05-01','08:50:00',1.84),('9303','2013-05-01','08:55:00',1.91),('9303','2013-05-01','09:00:00',2.02),('9303','2013-05-01','09:05:00',2.09),('9303','2013-05-01','09:10:00',2.15),('9303','2013-05-01','09:15:00',2.2),('9303','2013-05-01','09:20:00',2.24),('9303','2013-05-01','09:25:00',2.29),('9303','2013-05-01','09:30:00',2.33),('9303','2013-05-01','09:35:00',2.39),('9303','2013-05-01','09:40:00',2.46),('9303','2013-05-01','09:45:00',2.52),('9303','2013-05-01','09:50:00',2.58),('9303','2013-05-01','09:55:00',2.63),('9303','2013-05-01','10:00:00',2.66),('9303','2013-05-01','10:05:00',2.69),('9303','2013-05-01','10:10:00',2.78),('9303','2013-05-01','10:15:00',2.88),('9303','2013-05-01','10:20:00',2.91),('9303','2013-05-01','10:25:00',2.96),('9303','2013-05-01','10:30:00',3.03),('9303','2013-05-01','10:35:00',3.06),('9303','2013-05-01','10:40:00',3.22),('9303','2013-05-01','10:45:00',3.36),('9303','2013-05-01','10:50:00',3.4),('9303','2013-05-01','10:55:00',3.4),('9303','2013-05-01','11:00:00',3.43),('9303','2013-05-01','11:05:00',3.49),('9303','2013-05-01','11:10:00',3.48),('9303','2013-05-01','11:15:00',3.27),('9303','2013-05-01','11:20:00',3.34),('9303','2013-05-01','11:25:00',3.31),('9303','2013-05-01','11:30:00',3.25),('9303','2013-05-01','11:35:00',3.3),('9303','2013-05-01','11:40:00',2.65),('9303','2013-05-01','11:45:00',2.42),('9303','2013-05-01','11:50:00',3.05),('9303','2013-05-01','11:55:00',3.75),('9303','2013-05-01','12:00:00',3.7),('9303','2013-05-01','12:05:00',3.67),('9303','2013-05-01','12:10:00',3.69),('9303','2013-05-01','12:15:00',3.69),('9303','2013-05-01','12:20:00',3.7),('9303','2013-05-01','12:25:00',3.76),('9303','2013-05-01','12:30:00',3.77),('9303','2013-05-01','12:35:00',3.8),('9303','2013-05-01','12:40:00',3.9),('9303','2013-05-01','12:45:00',3.57),('9303','2013-05-01','12:50:00',2.95),('9303','2013-05-01','12:55:00',1.5),('9303','2013-05-01','13:00:00',1.42),('9303','2013-05-01','13:05:00',1.65),('9303','2013-05-01','13:10:00',1.99),('9303','2013-05-01','13:15:00',3.31),('9303','2013-05-01','13:20:00',4.5),('9303','2013-05-01','13:25:00',3.79),('9303','2013-05-01','13:30:00',2.45),('9303','2013-05-01','13:35:00',3.17),('9303','2013-05-01','13:40:00',3.92),('9303','2013-05-01','13:45:00',4.21),('9303','2013-05-01','13:50:00',3.96),('9303','2013-05-01','13:55:00',3.81),('9303','2013-05-01','14:00:00',3.72),('9303','2013-05-01','14:05:00',3.65),('9303','2013-05-01','14:10:00',3.66),('9303','2013-05-01','14:15:00',3.16),('9303','2013-05-01','14:20:00',3.83),('9303','2013-05-01','14:25:00',3.83),('9303','2013-05-01','14:30:00',3.85),('9303','2013-05-01','14:35:00',3.73),('9303','2013-05-01','14:40:00',3.33),('9303','2013-05-01','14:45:00',3.46),('9303','2013-05-01','14:50:00',3),('9303','2013-05-01','14:55:00',2.77),('9303','2013-05-01','15:00:00',2.84),('9303','2013-05-01','15:05:00',3.31),('9303','2013-05-01','15:10:00',3.34),('9303','2013-05-01','15:15:00',3.2),('9303','2013-05-01','15:20:00',3.07),('9303','2013-05-01','15:25:00',3.11),('9303','2013-05-01','15:30:00',2.61),('9303','2013-05-01','15:35:00',2.24),('9303','2013-05-01','15:40:00',2.24),('9303','2013-05-01','15:45:00',2.18),('9303','2013-05-01','15:50:00',1.64),('9303','2013-05-01','15:55:00',1.54),('9303','2013-05-01','16:00:00',1.89),('9303','2013-05-01','16:05:00',1.84),('9303','2013-05-01','16:10:00',1.65),('9303','2013-05-01','16:15:00',1.5),('9303','2013-05-01','16:20:00',1.33),('9303','2013-05-01','16:25:00',1.03),('9303','2013-05-01','16:35:00',1),('9303','2013-05-01','16:40:00',1.09),('9303','2013-05-01','16:45:00',1.02),('9303','2013-04-30','08:55:00',1.4),('9303','2013-04-30','09:00:00',1.66),('9303','2013-04-30','09:05:00',1.43),('9303','2013-04-30','09:10:00',1.95),('9303','2013-04-30','09:15:00',2.45),('9303','2013-04-30','09:20:00',2.45),('9303','2013-04-30','09:25:00',2.66),('9303','2013-04-30','09:30:00',2.59),('9303','2013-04-30','09:35:00',2.19),('9303','2013-04-30','09:40:00',1.56),('9303','2013-04-30','09:45:00',1.82),('9303','2013-04-30','09:50:00',2.42),('9303','2013-04-30','09:55:00',2.74),('9303','2013-04-30','10:00:00',3.14),('9303','2013-04-30','10:05:00',3.25),('9303','2013-04-30','10:10:00',2.67),('9303','2013-04-30','10:15:00',2.17),('9303','2013-04-30','10:20:00',1.99),('9303','2013-04-30','10:25:00',2.42),('9303','2013-04-30','10:30:00',1.94),('9303','2013-04-30','10:35:00',1.78),('9303','2013-04-30','10:40:00',1.54),('9303','2013-04-30','10:45:00',1.22),('9303','2013-04-30','10:50:00',1.32),('9303','2013-04-30','10:55:00',1.41),('9303','2013-04-30','11:00:00',1.44),('9303','2013-04-30','11:05:00',1.62),('9303','2013-04-30','11:10:00',1.67),('9303','2013-04-30','11:15:00',1.71),('9303','2013-04-30','11:20:00',2.02),('9303','2013-04-30','11:25:00',1.82),('9303','2013-04-30','11:30:00',1.81),('9303','2013-04-30','11:35:00',1.92),('9303','2013-04-30','11:40:00',1.88),('9303','2013-04-30','11:45:00',1.54),('9303','2013-04-30','11:50:00',1.57),('9303','2013-04-30','11:55:00',1.6),('9303','2013-04-30','12:00:00',1.63),('9303','2013-04-30','12:05:00',1.66),('9303','2013-04-30','12:10:00',1.61),('9303','2013-04-30','12:15:00',1.48),('9303','2013-04-30','12:20:00',1.33),('9303','2013-04-30','12:25:00',1.22),('9303','2013-04-30','12:30:00',1.23),('9303','2013-04-30','12:35:00',2.13),('9303','2013-04-30','12:40:00',4.04),('9303','2013-04-30','12:45:00',4.34),('9303','2013-04-30','12:50:00',4.17),('9303','2013-04-30','12:55:00',3.65),('9303','2013-04-30','13:00:00',4),('9303','2013-04-30','13:05:00',3.93),('9303','2013-04-30','13:10:00',3.97),('9303','2013-04-30','13:15:00',3.9),('9303','2013-04-30','13:20:00',3.88),('9303','2013-04-30','13:25:00',3.86),('9303','2013-04-30','13:30:00',3.82),('9303','2013-04-30','13:35:00',3.8),('9303','2013-04-30','13:40:00',3.77),('9303','2013-04-30','13:45:00',3.76),('9303','2013-04-30','13:50:00',3.71),('9303','2013-04-30','13:55:00',3.72),('9303','2013-04-30','14:00:00',3.69),('9303','2013-04-30','14:05:00',3.66),('9303','2013-04-30','14:10:00',3.65),('9303','2013-04-30','14:15:00',3.6),('9303','2013-04-30','14:20:00',3.58),('9303','2013-04-30','14:25:00',3.59),('9303','2013-04-30','14:30:00',3.55),('9303','2013-04-30','14:35:00',3.55),('9303','2013-04-30','14:40:00',3.49),('9303','2013-04-30','14:45:00',3.44),('9303','2013-04-30','14:50:00',3.37),('9303','2013-04-30','14:55:00',3.32),('9303','2013-04-30','15:00:00',3.26),('9303','2013-04-30','15:05:00',3.18),('9303','2013-04-30','15:10:00',3.12),('9303','2013-04-30','15:15:00',3.07),('9303','2013-04-30','15:20:00',3.07),('9303','2013-04-30','15:25:00',3.03),('9303','2013-04-30','15:30:00',2.98),('9303','2013-04-30','15:35:00',2.98),('9303','2013-04-30','15:40:00',2.95),('9303','2013-04-30','15:45:00',2.89),('9303','2013-04-30','15:50:00',2.8),('9303','2013-04-30','15:55:00',2.73),('9303','2013-04-30','16:00:00',2.69),('9303','2013-04-30','16:05:00',2.63),('9303','2013-04-30','16:10:00',2.58),('9303','2013-04-30','16:15:00',2.52),('9303','2013-04-30','16:20:00',2.45),('9303','2013-04-30','16:25:00',2.39),('9303','2013-04-30','16:30:00',2.33),('9303','2013-04-30','16:35:00',2.21),('9303','2013-04-30','16:40:00',1.87),('9303','2013-04-30','16:45:00',2.05),('9303','2013-04-30','16:50:00',1.57),('9303','2013-04-30','16:55:00',1.8),('9303','2013-04-30','17:00:00',1.72),('9303','2013-04-30','17:05:00',1.7),('9303','2013-04-30','17:10:00',1.51),('9303','2013-04-30','17:20:00',1.2),('9303','2013-04-30','17:25:00',1.41),('9303','2013-04-30','17:30:00',1.34),('9303','2013-04-30','17:35:00',1.3),('9303','2013-04-30','17:40:00',1.24),('9303','2013-04-30','17:45:00',1.14),('9303','2013-04-30','17:50:00',1.05),('9303','2013-04-29','08:00:00',1.1),('9303','2013-04-29','08:05:00',1.17),('9303','2013-04-29','08:10:00',1.12),('9303','2013-04-29','08:15:00',1.16),('9303','2013-04-29','08:20:00',1.26),('9303','2013-04-29','08:25:00',1.47),('9303','2013-04-29','08:30:00',1.68),('9303','2013-04-29','08:35:00',1.89),('9303','2013-04-29','08:40:00',1.92),('9303','2013-04-29','08:45:00',1.87),('9303','2013-04-29','08:50:00',2.01),('9303','2013-04-29','08:55:00',2.02),('9303','2013-04-29','09:00:00',1.54),('9303','2013-04-29','09:05:00',2.1),('9303','2013-04-29','09:10:00',2.35),('9303','2013-04-29','09:15:00',2.48),('9303','2013-04-29','09:20:00',2.36),('9303','2013-04-29','09:25:00',2.28),('9303','2013-04-29','09:30:00',2.31),('9303','2013-04-29','09:35:00',2.46),('9303','2013-04-29','09:40:00',2.47),('9303','2013-04-29','09:45:00',2.55),('9303','2013-04-29','09:50:00',2.72),('9303','2013-04-29','09:55:00',2.54),('9303','2013-04-29','10:00:00',2.65),('9303','2013-04-29','10:05:00',2.65),('9303','2013-04-29','10:10:00',2.66),('9303','2013-04-29','10:15:00',2.18),('9303','2013-04-29','10:20:00',2.17),('9303','2013-04-29','10:25:00',2.63),('9303','2013-04-29','10:30:00',2.61),('9303','2013-04-29','10:35:00',3.07),('9303','2013-04-29','10:40:00',3.11),('9303','2013-04-29','10:45:00',3.2),('9303','2013-04-29','10:50:00',3.07),('9303','2013-04-29','10:55:00',2.84),('9303','2013-04-29','11:00:00',3.19),('9303','2013-04-29','11:05:00',3.11),('9303','2013-04-29','11:10:00',2.97),('9303','2013-04-29','11:15:00',2.79),('9303','2013-04-29','11:20:00',3.29),('9303','2013-04-29','11:25:00',3.34),('9303','2013-04-29','11:30:00',3.49),('9303','2013-04-29','11:35:00',3.33),('9303','2013-04-29','11:40:00',3.39),('9303','2013-04-29','11:45:00',3.28),('9303','2013-04-29','11:50:00',3.61),('9303','2013-04-29','11:55:00',3.61),('9303','2013-04-29','12:00:00',3.71),('9303','2013-04-29','12:05:00',3.72),('9303','2013-04-29','12:10:00',3.61),('9303','2013-04-29','12:15:00',3.65),('9303','2013-04-29','12:20:00',3.71),('9303','2013-04-29','12:25:00',3.57),('9303','2013-04-29','12:30:00',3.65),('9303','2013-04-29','12:35:00',3.73),('9303','2013-04-29','12:40:00',3.81),('9303','2013-04-29','12:45:00',3.83),('9303','2013-04-29','12:50:00',3.8),('9303','2013-04-29','12:55:00',3.71),('9303','2013-04-29','13:00:00',3.82),('9303','2013-04-29','13:05:00',3.76),('9303','2013-04-29','13:10:00',3.67),('9303','2013-04-29','13:15:00',3.41),('9303','2013-04-29','13:20:00',3.66),('9303','2013-04-29','13:25:00',3.86),('9303','2013-04-29','13:30:00',3.78),('9303','2013-04-29','13:35:00',3.65),('9303','2013-04-29','13:40:00',3.8),('9303','2013-04-29','13:45:00',3.75),('9303','2013-04-29','13:50:00',3.51),('9303','2013-04-29','13:55:00',3.98),('9303','2013-04-29','14:00:00',3.61),('9303','2013-04-29','14:05:00',3.56),('9303','2013-04-29','14:10:00',3.7),('9303','2013-04-29','14:15:00',3.79),('9303','2013-04-29','14:20:00',3.78),('9303','2013-04-29','14:25:00',3.62),('9303','2013-04-29','14:30:00',3.45),('9303','2013-04-29','14:35:00',3.39),('9303','2013-04-29','14:40:00',3.22),('9303','2013-04-29','14:45:00',3.46),('9303','2013-04-29','14:50:00',3.36),('9303','2013-04-29','14:55:00',3.4),('9303','2013-04-29','15:00:00',3.27),('9303','2013-04-29','15:05:00',3.46),('9303','2013-04-29','15:10:00',3.07),('9303','2013-04-29','15:15:00',2.99),('9303','2013-04-29','15:20:00',3.12),('9303','2013-04-29','15:25:00',3.31),('9303','2013-04-29','15:30:00',3.22),('9303','2013-04-29','15:35:00',2.84),('9303','2013-04-29','15:40:00',2.6),('9303','2013-04-29','15:45:00',2.52),('9303','2013-04-29','15:50:00',2.57),('9303','2013-04-29','15:55:00',2.73),('9303','2013-04-29','16:00:00',2.64),('9303','2013-04-29','16:05:00',2.85),('9303','2013-04-29','16:10:00',2.69),('9303','2013-04-29','16:15:00',3.09),('9303','2013-04-29','16:20:00',3.01),('9303','2013-04-29','16:25:00',2.3),('9303','2013-04-29','16:30:00',2.39),('9303','2013-04-29','16:35:00',2.4),('9303','2013-04-29','16:40:00',2.56),('9303','2013-04-29','16:45:00',2.5),('9303','2013-04-29','16:50:00',2.57),('9303','2013-04-29','16:55:00',2.52),('9303','2013-04-29','17:00:00',2.35),('9303','2013-04-29','17:05:00',1.98),('9303','2013-04-29','17:10:00',2.07),('9303','2013-04-29','17:15:00',1.76),('9303','2013-04-29','17:20:00',1.43),('9303','2013-04-29','17:25:00',1.42),('9303','2013-04-29','17:30:00',1.32),('9303','2013-04-29','17:35:00',1.24),('9303','2013-04-29','17:40:00',1.04),('9303','2013-04-29','17:50:00',1.11),('9303','2013-04-29','17:55:00',1.26),('9303','2013-04-29','18:00:00',1.21),('9303','2013-04-29','18:05:00',1.31),('9303','2013-04-29','18:10:00',1.16),('9303','2013-04-29','18:15:00',1.09),('9303','2013-04-28','08:00:00',1.05),('9303','2013-04-28','08:05:00',1.18),('9303','2013-04-28','08:10:00',1.29),('9303','2013-04-28','08:15:00',1.39),('9303','2013-04-28','08:20:00',1.5),('9303','2013-04-28','08:25:00',1.6),('9303','2013-04-28','08:30:00',1.69),('9303','2013-04-28','08:35:00',1.76),('9303','2013-04-28','08:40:00',1.84),('9303','2013-04-28','08:45:00',1.93),('9303','2013-04-28','08:50:00',2),('9303','2013-04-28','08:55:00',2.08),('9303','2013-04-28','09:00:00',2.15),('9303','2013-04-28','09:05:00',2.24),('9303','2013-04-28','09:10:00',2.32),('9303','2013-04-28','09:15:00',2.4),('9303','2013-04-28','09:20:00',2.48),('9303','2013-04-28','09:25:00',2.16),('9303','2013-04-28','09:30:00',2.61),('9303','2013-04-28','09:35:00',2.67),('9303','2013-04-28','09:40:00',2.75),('9303','2013-04-28','09:45:00',2.82),('9303','2013-04-28','09:50:00',2.89),('9303','2013-04-28','09:55:00',2.93),('9303','2013-04-28','10:00:00',3.01),('9303','2013-04-28','10:05:00',3.01),('9303','2013-04-28','10:10:00',3.1),('9303','2013-04-28','10:15:00',3.07),('9303','2013-04-28','10:20:00',3.18),('9303','2013-04-28','10:25:00',3.31),('9303','2013-04-28','10:30:00',3.24),('9303','2013-04-28','10:35:00',3.3),('9303','2013-04-28','10:40:00',3.07),('9303','2013-04-28','10:45:00',3.47),('9303','2013-04-28','10:50:00',3.49),('9303','2013-04-28','10:55:00',3.49),('9303','2013-04-28','11:00:00',3.52),('9303','2013-04-28','11:05:00',3.57),('9303','2013-04-28','11:10:00',3.65),('9303','2013-04-28','11:15:00',3.7),('9303','2013-04-28','11:20:00',3.71),('9303','2013-04-28','11:25:00',3.78),('9303','2013-04-28','11:30:00',3.78),('9303','2013-04-28','11:35:00',3.7),('9303','2013-04-28','11:40:00',3.74),('9303','2013-04-28','11:45:00',3.61),('9303','2013-04-28','11:50:00',3.63),('9303','2013-04-28','11:55:00',3.76),('9303','2013-04-28','12:00:00',3.33),('9303','2013-04-28','12:05:00',3.27),('9303','2013-04-28','12:10:00',3.6),('9303','2013-04-28','12:15:00',3.76),('9303','2013-04-28','12:20:00',3.71),('9303','2013-04-28','12:25:00',3.35),('9303','2013-04-28','12:30:00',3.17),('9303','2013-04-28','12:35:00',2.93),('9303','2013-04-28','12:40:00',2.83),('9303','2013-04-28','12:45:00',3.59),('9303','2013-04-28','12:50:00',3.86),('9303','2013-04-28','12:55:00',3.66),('9303','2013-04-28','13:00:00',3.77),('9303','2013-04-28','13:05:00',4.02),('9303','2013-04-28','13:10:00',3.98),('9303','2013-04-28','13:15:00',3.67),('9303','2013-04-28','13:20:00',3.68),('9303','2013-04-28','13:25:00',3.61),('9303','2013-04-28','13:30:00',3.89),('9303','2013-04-28','13:35:00',3.85),('9303','2013-04-28','13:40:00',4.03),('9303','2013-04-28','13:45:00',3.96),('9303','2013-04-28','13:50:00',3.21),('9303','2013-04-28','13:55:00',1.83),('9303','2013-04-28','14:00:00',3.91),('9303','2013-04-28','14:05:00',3.96),('9303','2013-04-28','14:10:00',3.81),('9303','2013-04-28','14:15:00',3.86),('9303','2013-04-28','14:20:00',2.91),('9303','2013-04-28','14:25:00',3.15),('9303','2013-04-28','14:30:00',3.71),('9303','2013-04-28','14:35:00',3.7),('9303','2013-04-28','14:40:00',3.65),('9303','2013-04-28','14:45:00',3.59),('9303','2013-04-28','14:50:00',3.55),('9303','2013-04-28','14:55:00',3.5),('9303','2013-04-28','15:00:00',3.49),('9303','2013-04-28','15:05:00',3.46),('9303','2013-04-28','15:10:00',3.43),('9303','2013-04-28','15:15:00',3.39),('9303','2013-04-28','15:20:00',3.34),('9303','2013-04-28','15:25:00',3.27),('9303','2013-04-28','15:30:00',3.23),('9303','2013-04-28','15:35:00',3.21),('9303','2013-04-28','15:40:00',3.15),('9303','2013-04-28','15:45:00',3.1),('9303','2013-04-28','15:50:00',3.05),('9303','2013-04-28','15:55:00',2.99),('9303','2013-04-28','16:00:00',2.93),('9303','2013-04-28','16:05:00',2.88),('9303','2013-04-28','16:10:00',2.83),('9303','2013-04-28','16:15:00',2.76),('9303','2013-04-28','16:20:00',2.68),('9303','2013-04-28','16:25:00',2.62),('9303','2013-04-28','16:30:00',2.57),('9303','2013-04-28','16:35:00',2.51),('9303','2013-04-28','16:40:00',2.43),('9303','2013-04-28','16:45:00',2.37),('9303','2013-04-28','16:50:00',2.28),('9303','2013-04-28','16:55:00',2.18),('9303','2013-04-28','17:00:00',2.07),('9303','2013-04-28','17:05:00',1.92),('9303','2013-04-28','17:10:00',1.8),('9303','2013-04-28','17:15:00',1.86),('9303','2013-04-28','17:20:00',1.75),('9303','2013-04-28','17:25:00',1.71),('9303','2013-04-28','17:30:00',1.46),('9303','2013-04-28','17:35:00',1.44),('9303','2013-04-28','17:40:00',1.32),('9303','2013-04-28','17:45:00',1.32),('9303','2013-04-28','17:50:00',1.27),('9303','2013-04-28','17:55:00',1.08),('9303','2013-04-28','18:00:00',1.05),('9303','2013-04-27','12:55:00',1.21),('9303','2013-04-27','13:00:00',1.37),('9303','2013-04-27','13:05:00',1.05),('9303','2013-04-27','13:10:00',1.08),('9303','2013-04-27','13:15:00',1.3),('9303','2013-04-27','13:20:00',1.37),('9303','2013-04-27','13:25:00',1.08),('9303','2013-04-27','13:30:00',1.05),('9303','2013-04-27','13:35:00',1.32),('9303','2013-04-27','13:40:00',1.55),('9303','2013-04-27','13:45:00',1.01),('9303','2013-04-27','13:50:00',1),('9303','2013-04-27','14:25:00',1.09),('9303','2013-04-27','14:30:00',2.02),('9303','2013-04-27','14:35:00',1.86),('9303','2013-04-27','14:40:00',1.19),('9303','2013-04-27','14:45:00',1.15),('9303','2013-04-27','15:05:00',1.2),('9303','2013-04-27','15:10:00',1.11),('9303','2013-04-27','15:15:00',1.01),('9303','2013-04-27','16:45:00',1.08),('9303','2013-04-27','16:50:00',1.98),('9303','2013-04-27','16:55:00',1.67),('9303','2013-04-27','17:00:00',2.18),('9303','2013-04-27','17:05:00',1.61),('9303','2013-04-26','08:10:00',1.09),('9303','2013-04-26','08:15:00',1.21),('9303','2013-04-26','08:20:00',1.25),('9303','2013-04-26','08:25:00',1.34),('9303','2013-04-26','08:30:00',1.41),('9303','2013-04-26','08:35:00',1.54),('9303','2013-04-26','08:40:00',1.6),('9303','2013-04-26','08:45:00',1.69),('9303','2013-04-26','08:50:00',1.65),('9303','2013-04-26','08:55:00',1.43),('9303','2013-04-26','09:00:00',1.1),('9303','2013-04-26','09:05:00',1.56),('9303','2013-04-26','09:10:00',1.83),('9303','2013-04-26','09:15:00',1.11),('9303','2013-04-26','09:20:00',1.05),('9303','2013-04-26','09:25:00',1.21),('9303','2013-04-26','09:30:00',1.56),('9303','2013-04-26','09:35:00',1.75),('9303','2013-04-26','09:40:00',1.86),('9303','2013-04-26','09:45:00',2.51),('9303','2013-04-26','09:50:00',2.16),('9303','2013-04-26','09:55:00',1.57),('9303','2013-04-26','10:00:00',1.79),('9303','2013-04-26','10:05:00',2.2),('9303','2013-04-26','10:10:00',2.81),('9303','2013-04-26','10:15:00',3.05),('9303','2013-04-26','10:20:00',3.07),('9303','2013-04-26','10:25:00',2.45),('9303','2013-04-26','10:30:00',3.15),('9303','2013-04-26','10:35:00',3.33),('9303','2013-04-26','10:40:00',3.18),('9303','2013-04-26','10:45:00',2.98),('9303','2013-04-26','10:50:00',2.12),('9303','2013-04-26','10:55:00',2.23),('9303','2013-04-26','11:00:00',3.03),('9303','2013-04-26','11:05:00',3.26),('9303','2013-04-26','11:10:00',3.05),('9303','2013-04-26','11:15:00',3.45),('9303','2013-04-26','11:20:00',2.49),('9303','2013-04-26','11:25:00',2.8),('9303','2013-04-26','11:30:00',2.91),('9303','2013-04-26','11:35:00',3.17),('9303','2013-04-26','11:40:00',3.36),('9303','2013-04-26','11:45:00',3.1),('9303','2013-04-26','11:50:00',2.36),('9303','2013-04-26','11:55:00',2.57),('9303','2013-04-26','12:00:00',2.68),('9303','2013-04-26','12:05:00',2.64),('9303','2013-04-26','12:10:00',2.12),('9303','2013-04-26','12:15:00',2.5),('9303','2013-04-26','12:20:00',2.21),('9303','2013-04-26','12:25:00',1.78),('9303','2013-04-26','12:30:00',1.69),('9303','2013-04-26','12:35:00',2.05),('9303','2013-04-26','12:40:00',3.07),('9303','2013-04-26','12:45:00',3.33),('9303','2013-04-26','12:50:00',2.02),('9303','2013-04-26','12:55:00',1.85),('9303','2013-04-26','13:00:00',1.31),('9303','2013-04-26','13:05:00',1.22),('9303','2013-04-26','13:10:00',1.47),('9303','2013-04-26','13:15:00',2.08),('9303','2013-04-26','13:20:00',1.52),('9303','2013-04-26','13:25:00',1.82),('9303','2013-04-26','13:30:00',2.29),('9303','2013-04-26','13:35:00',2.13),('9303','2013-04-26','13:40:00',2.42),('9303','2013-04-26','13:45:00',1.95),('9303','2013-04-26','13:50:00',2.95),('9303','2013-04-26','13:55:00',2.31),('9303','2013-04-26','14:00:00',2.82),('9303','2013-04-26','14:05:00',3.62),('9303','2013-04-26','14:10:00',2.93),('9303','2013-04-26','14:15:00',3.4),('9303','2013-04-26','14:20:00',3.45),('9303','2013-04-26','14:25:00',3.3),('9303','2013-04-26','14:30:00',3.75),('9303','2013-04-26','14:35:00',2.76),('9303','2013-04-26','14:40:00',1.7),('9303','2013-04-26','14:45:00',1.52),('9303','2013-04-26','14:50:00',3.4),('9303','2013-04-26','14:55:00',3.88),('9303','2013-04-26','15:00:00',3.67),('9303','2013-04-26','15:05:00',2.79),('9303','2013-04-26','15:10:00',1.27),('9303','2013-04-26','15:15:00',1.9),('9303','2013-04-26','15:20:00',1.33),('9303','2013-04-26','15:25:00',1.43),('9303','2013-04-26','15:30:00',2.01),('9303','2013-04-26','15:35:00',1.73),('9303','2013-04-26','15:40:00',1.82),('9303','2013-04-26','15:45:00',2.01),('9303','2013-04-26','15:50:00',1.63),('9303','2013-04-25','08:10:00',1.01),('9303','2013-04-25','08:15:00',1.25),('9303','2013-04-25','08:20:00',1.01),('9303','2013-04-25','08:40:00',1.04),('9303','2013-04-25','08:45:00',1.2),('9303','2013-04-25','08:50:00',1.82),('9303','2013-04-25','08:55:00',2.25),('9303','2013-04-25','09:00:00',1.89),('9303','2013-04-25','09:05:00',1.35),('9303','2013-04-25','09:10:00',1.23),('9303','2013-04-25','09:15:00',1.15),('9303','2013-04-25','09:20:00',1.2),('9303','2013-04-25','09:25:00',1.42),('9303','2013-04-25','09:30:00',1.34),('9303','2013-04-25','09:35:00',1.48),('9303','2013-04-25','09:40:00',2.16),('9303','2013-04-25','09:45:00',2.56),('9303','2013-04-25','09:50:00',2.93),('9303','2013-04-25','09:55:00',2.96),('9303','2013-04-25','10:00:00',2.98),('9303','2013-04-25','10:05:00',2.81),('9303','2013-04-25','10:10:00',2.57),('9303','2013-04-25','10:15:00',2.72),('9303','2013-04-25','10:20:00',3.1),('9303','2013-04-25','10:25:00',3.2),('9303','2013-04-25','10:30:00',3.31),('9303','2013-04-25','10:35:00',3.34),('9303','2013-04-25','10:40:00',3.36),('9303','2013-04-25','10:45:00',3.23),('9303','2013-04-25','10:50:00',3.47),('9303','2013-04-25','10:55:00',3.47),('9303','2013-04-25','11:00:00',3.57),('9303','2013-04-25','11:05:00',3.61),('9303','2013-04-25','11:10:00',3.64),('9303','2013-04-25','11:15:00',3.66),('9303','2013-04-25','11:20:00',3.68),('9303','2013-04-25','11:25:00',3.71),('9303','2013-04-25','11:30:00',3.74),('9303','2013-04-25','11:35:00',3.81),('9303','2013-04-25','11:40:00',3.85),('9303','2013-04-25','11:45:00',3.89),('9303','2013-04-25','11:50:00',3.92),('9303','2013-04-25','11:55:00',3.87),('9303','2013-04-25','12:00:00',3.78),('9303','2013-04-25','12:05:00',3.81),('9303','2013-04-25','12:10:00',3.86),('9303','2013-04-25','12:15:00',3.92),('9303','2013-04-25','12:20:00',3.97),('9303','2013-04-25','12:25:00',3.97),('9303','2013-04-25','12:30:00',3.96),('9303','2013-04-25','12:35:00',3.97),('9303','2013-04-25','12:40:00',3.93),('9303','2013-04-25','12:45:00',3.93),('9303','2013-04-25','12:50:00',3.95),('9303','2013-04-25','12:55:00',3.98),('9303','2013-04-25','13:00:00',4.01),('9303','2013-04-25','13:05:00',4.09),('9303','2013-04-25','13:10:00',3.73),('9303','2013-04-25','13:15:00',3.76),('9303','2013-04-25','13:20:00',3.84),('9303','2013-04-25','13:25:00',3.86),('9303','2013-04-25','13:30:00',2.88),('9303','2013-04-25','13:35:00',2.62),('9303','2013-04-25','13:40:00',2.23),('9303','2013-04-25','13:45:00',2.06),('9303','2013-04-25','13:50:00',1.92),('9303','2013-04-25','13:55:00',2.01),('9303','2013-04-25','14:00:00',2.13),('9303','2013-04-25','14:05:00',1.98),('9303','2013-04-25','14:10:00',2.14),('9303','2013-04-25','14:15:00',2.28),('9303','2013-04-25','14:20:00',2.35),('9303','2013-04-25','14:25:00',2.45),('9303','2013-04-25','14:30:00',2.85),('9303','2013-04-25','14:35:00',3.49),('9303','2013-04-25','14:40:00',3.19),('9303','2013-04-25','14:45:00',3.26),('9303','2013-04-25','14:50:00',3.03),('9303','2013-04-25','14:55:00',3.17),('9303','2013-04-25','15:00:00',3.04),('9303','2013-04-25','15:05:00',2.77),('9303','2013-04-25','15:10:00',2.71),('9303','2013-04-25','15:15:00',3.09),('9303','2013-04-25','15:20:00',3.29),('9303','2013-04-25','15:25:00',3.35),('9303','2013-04-25','15:30:00',3.29),('9303','2013-04-25','15:35:00',3.12),('9303','2013-04-25','15:40:00',2.91),('9303','2013-04-25','15:45:00',2.76),('9303','2013-04-25','15:50:00',2.61),('9303','2013-04-25','15:55:00',2.52),('9303','2013-04-25','16:00:00',2.54),('9303','2013-04-25','16:05:00',2.17),('9303','2013-04-25','16:10:00',2.14),('9303','2013-04-25','16:15:00',2.07),('9303','2013-04-25','16:20:00',2.18),('9303','2013-04-25','16:25:00',1.99),('9303','2013-04-25','16:30:00',1.82),('9303','2013-04-25','16:35:00',2.3),('9303','2013-04-25','16:40:00',1.92),('9303','2013-04-25','16:45:00',2.07),('9303','2013-04-25','16:50:00',1.71),('9303','2013-04-25','16:55:00',1.7),('9303','2013-04-25','17:00:00',1.64),('9303','2013-04-25','17:05:00',1.88),('9303','2013-04-25','17:10:00',2.07),('9303','2013-04-25','17:15:00',1.88),('9303','2013-04-25','17:20:00',1.89),('9303','2013-04-25','17:25:00',1.58),('9303','2013-04-25','17:30:00',1.31),('9303','2013-04-25','17:35:00',1.19),('9303','2013-04-25','17:40:00',1.22),('9303','2013-04-25','17:45:00',1.02),('9303','2013-04-24','08:05:00',1.01),('9303','2013-04-24','08:10:00',1.17),('9303','2013-04-24','08:15:00',1.35),('9303','2013-04-24','08:20:00',1.43),('9303','2013-04-24','08:25:00',1.56),('9303','2013-04-24','08:30:00',1.59),('9303','2013-04-24','08:35:00',1.54),('9303','2013-04-24','08:40:00',1.61),('9303','2013-04-24','08:45:00',1.67),('9303','2013-04-24','08:50:00',1.73),('9303','2013-04-24','08:55:00',1.88),('9303','2013-04-24','09:00:00',2.05),('9303','2013-04-24','09:05:00',2.28),('9303','2013-04-24','09:10:00',2.38),('9303','2013-04-24','09:15:00',2.2),('9303','2013-04-24','09:20:00',1.79),('9303','2013-04-24','09:25:00',2.08),('9303','2013-04-24','09:30:00',2.49),('9303','2013-04-24','09:35:00',2.59),('9303','2013-04-24','09:40:00',2.61),('9303','2013-04-24','09:45:00',2.52),('9303','2013-04-24','09:50:00',2.72),('9303','2013-04-24','09:55:00',3.09),('9303','2013-04-24','10:00:00',3.1),('9303','2013-04-24','10:05:00',3.18),('9303','2013-04-24','10:10:00',3.21),('9303','2013-04-24','10:15:00',3.2),('9303','2013-04-24','10:20:00',3.18),('9303','2013-04-24','10:25:00',3.16),('9303','2013-04-24','10:30:00',3.14),('9303','2013-04-24','10:35:00',3.09),('9303','2013-04-24','10:40:00',3.41),('9303','2013-04-24','10:45:00',3.53),('9303','2013-04-24','10:50:00',3.55),('9303','2013-04-24','10:55:00',3.64),('9303','2013-04-24','11:00:00',3.7),('9303','2013-04-24','11:05:00',3.59),('9303','2013-04-24','11:10:00',3.84),('9303','2013-04-24','11:15:00',3.94),('9303','2013-04-24','11:20:00',4.01),('9303','2013-04-24','11:25:00',4.1),('9303','2013-04-24','11:30:00',3.92),('9303','2013-04-24','11:35:00',3.25),('9303','2013-04-24','11:40:00',2.3),('9303','2013-04-24','11:45:00',2.61),('9303','2013-04-24','11:50:00',1.92),('9303','2013-04-24','11:55:00',2.54),('9303','2013-04-24','12:00:00',3.2),('9303','2013-04-24','12:05:00',2.3),('9303','2013-04-24','12:10:00',2.75),('9303','2013-04-24','12:15:00',3.67),('9303','2013-04-24','12:20:00',4.46),('9303','2013-04-24','12:25:00',3.77),('9303','2013-04-24','12:30:00',3.73),('9303','2013-04-24','12:35:00',3.78),('9303','2013-04-24','12:40:00',3.49),('9303','2013-04-24','12:45:00',3.75),('9303','2013-04-24','12:50:00',4.03),('9303','2013-04-24','12:55:00',3.86),('9303','2013-04-24','13:00:00',3.67),('9303','2013-04-24','13:05:00',3.23),('9303','2013-04-24','13:10:00',4.3),('9303','2013-04-24','13:15:00',3.68),('9303','2013-04-24','13:20:00',3.68),('9303','2013-04-24','13:25:00',3.74),('9303','2013-04-24','13:30:00',3.49),('9303','2013-04-24','13:35:00',3.37),('9303','2013-04-24','13:40:00',4.26),('9303','2013-04-24','13:45:00',3.4),('9303','2013-04-24','13:50:00',2.6),('9303','2013-04-24','13:55:00',3.9),('9303','2013-04-24','14:00:00',3.81),('9303','2013-04-24','14:05:00',2.77),('9303','2013-04-24','14:10:00',2.7),('9303','2013-04-24','14:15:00',3.93),('9303','2013-04-24','14:20:00',3.46),('9303','2013-04-24','14:25:00',3.67),('9303','2013-04-24','14:30:00',3.48),('9303','2013-04-24','14:35:00',3.05),('9303','2013-04-24','14:40:00',2.84),('9303','2013-04-24','14:45:00',2.82),('9303','2013-04-24','14:50:00',2.44),('9303','2013-04-24','14:55:00',2.2),('9303','2013-04-24','15:00:00',2.47),('9303','2013-04-24','15:05:00',2.27),('9303','2013-04-24','15:10:00',2.08),('9303','2013-04-24','15:15:00',2.21),('9303','2013-04-24','15:20:00',2.31),('9303','2013-04-24','15:25:00',1.93),('9303','2013-04-24','15:30:00',1.67),('9303','2013-04-24','15:35:00',1.61),('9303','2013-04-24','15:40:00',1.59),('9303','2013-04-24','15:45:00',1.6),('9303','2013-04-24','15:50:00',1.63),('9303','2013-04-24','15:55:00',2.02),('9303','2013-04-24','16:00:00',2.48),('9303','2013-04-24','16:05:00',2.61),('9303','2013-04-24','16:10:00',2.59),('9303','2013-04-24','16:15:00',2.47),('9303','2013-04-24','16:20:00',3.35),('9303','2013-04-24','16:25:00',2.4),('9303','2013-04-24','16:30:00',2),('9303','2013-04-24','16:35:00',1.67),('9303','2013-04-24','16:40:00',2.27),('9303','2013-04-24','16:45:00',2.41),('9303','2013-04-24','16:50:00',2.12),('9303','2013-04-24','16:55:00',2.49),('9303','2013-04-24','17:00:00',2.43),('9303','2013-04-24','17:05:00',2.29),('9303','2013-04-24','17:10:00',2.21),('9303','2013-04-24','17:15:00',1.61),('9303','2013-04-24','17:20:00',1.53),('9303','2013-04-24','17:25:00',1.43),('9303','2013-04-24','17:55:00',1.2),('9303','2013-04-23','07:55:00',1),('9303','2013-04-23','08:00:00',1.11),('9303','2013-04-23','08:05:00',1.21),('9303','2013-04-23','08:10:00',1.32),('9303','2013-04-23','08:15:00',1.41),('9303','2013-04-23','08:20:00',1.53),('9303','2013-04-23','08:25:00',1.62),('9303','2013-04-23','08:30:00',1.72),('9303','2013-04-23','08:35:00',1.83),('9303','2013-04-23','08:40:00',1.91),('9303','2013-04-23','08:45:00',1.99),('9303','2013-04-23','08:50:00',2.08),('9303','2013-04-23','08:55:00',2.17),('9303','2013-04-23','09:00:00',2.24),('9303','2013-04-23','09:05:00',2.33),('9303','2013-04-23','09:10:00',2.4),('9303','2013-04-23','09:15:00',2.51),('9303','2013-04-23','09:20:00',2.59),('9303','2013-04-23','09:25:00',2.67),('9303','2013-04-23','09:30:00',2.73),('9303','2013-04-23','09:35:00',2.8),('9303','2013-04-23','09:40:00',2.68),('9303','2013-04-23','09:45:00',2.53),('9303','2013-04-23','09:50:00',3.06),('9303','2013-04-23','09:55:00',3.12),('9303','2013-04-23','10:00:00',3.16),('9303','2013-04-23','10:05:00',3.21),('9303','2013-04-23','10:10:00',3.27),('9303','2013-04-23','10:15:00',3.3),('9303','2013-04-23','10:20:00',3.37),('9303','2013-04-23','10:25:00',3.43),('9303','2013-04-23','10:30:00',3.48),('9303','2013-04-23','10:35:00',3.54),('9303','2013-04-23','10:40:00',3.54),('9303','2013-04-23','10:45:00',3.49),('9303','2013-04-23','10:50:00',3.57),('9303','2013-04-23','10:55:00',3.65),('9303','2013-04-23','11:00:00',3.68),('9303','2013-04-23','11:05:00',3.72),('9303','2013-04-23','11:10:00',3.77),('9303','2013-04-23','11:15:00',3.83),('9303','2013-04-23','11:20:00',3.88),('9303','2013-04-23','11:25:00',3.91),('9303','2013-04-23','11:30:00',3.94),('9303','2013-04-23','11:35:00',3.94),('9303','2013-04-23','11:40:00',3.95),('9303','2013-04-23','11:45:00',3.97),('9303','2013-04-23','11:50:00',3.99),('9303','2013-04-23','11:55:00',4.01),('9303','2013-04-23','12:00:00',4.04),('9303','2013-04-23','12:05:00',4.05),('9303','2013-04-23','12:10:00',4.05),('9303','2013-04-23','12:15:00',4.01),('9303','2013-04-23','12:20:00',4.01),('9303','2013-04-23','12:25:00',4.02),('9303','2013-04-23','12:30:00',2.87),('9303','2013-04-23','12:35:00',1.91),('9303','2013-04-23','12:40:00',4.21),('9303','2013-04-23','12:45:00',3.12),('9303','2013-04-23','12:50:00',1.71),('9303','2013-04-23','12:55:00',3.42),('9303','2013-04-23','13:00:00',3.13),('9303','2013-04-23','13:05:00',3.54),('9303','2013-04-23','13:10:00',2.07),('9303','2013-04-23','13:15:00',2.65),('9303','2013-04-23','13:20:00',4.38),('9303','2013-04-23','13:25:00',4.32),('9303','2013-04-23','13:30:00',4.16),('9303','2013-04-23','13:35:00',4.22),('9303','2013-04-23','13:40:00',4.38),('9303','2013-04-23','13:45:00',3.08),('9303','2013-04-23','13:50:00',3.75),('9303','2013-04-23','13:55:00',4.19),('9303','2013-04-23','14:00:00',2.81),('9303','2013-04-23','14:05:00',3.54),('9303','2013-04-23','14:10:00',2.72),('9303','2013-04-23','14:15:00',3.31),('9303','2013-04-23','14:20:00',3.77),('9303','2013-04-23','14:25:00',3.44),('9303','2013-04-23','14:30:00',3.99),('9303','2013-04-23','14:35:00',3.87),('9303','2013-04-23','14:40:00',3.83),('9303','2013-04-23','14:45:00',3.33),('9303','2013-04-23','14:50:00',2.11),('9303','2013-04-23','14:55:00',2.17),('9303','2013-04-23','15:00:00',2.19),('9303','2013-04-23','15:05:00',2.27),('9303','2013-04-23','15:10:00',2.79),('9303','2013-04-23','15:15:00',2.86),('9303','2013-04-23','15:20:00',2.61),('9303','2013-04-23','15:25:00',2.38),('9303','2013-04-23','15:30:00',2.33),('9303','2013-04-23','15:35:00',2.25),('9303','2013-04-23','15:40:00',1.94),('9303','2013-04-23','15:45:00',2.34),('9303','2013-04-23','15:50:00',1.81),('9303','2013-04-23','15:55:00',1.49),('9303','2013-04-23','16:00:00',1.55),('9303','2013-04-23','16:05:00',1.65),('9303','2013-04-23','16:10:00',1.67),('9303','2013-04-23','16:15:00',1.87),('9303','2013-04-23','16:20:00',1.25),('9303','2013-04-23','16:25:00',1.23),('9303','2013-04-23','16:30:00',1.12),('9303','2013-04-23','16:35:00',1.04),('9303','2013-04-23','16:40:00',1),('9303','2013-04-23','16:45:00',1.12),('9303','2013-04-23','17:05:00',1.02),('9303','2013-04-23','17:10:00',1.39),('9303','2013-04-23','17:15:00',1.45),('9303','2013-04-23','17:25:00',1.15),('9303','2013-04-23','17:30:00',1.3),('9303','2013-04-23','17:35:00',1.1),('9303','2013-04-23','17:45:00',1.14),('9303','2013-04-22','09:30:00',1.08),('9303','2013-04-22','10:35:00',1.46),('9303','2013-04-22','10:40:00',2.68),('9303','2013-04-22','10:45:00',4.58),('9303','2013-04-22','10:50:00',2.03),('9303','2013-04-22','10:55:00',2.1),('9303','2013-04-22','11:00:00',2.02),('9303','2013-04-22','11:05:00',1.67),('9303','2013-04-22','11:10:00',2.38),('9303','2013-04-22','11:15:00',1.35),('9303','2013-04-22','11:20:00',1.3),('9303','2013-04-22','11:25:00',1.76),('9303','2013-04-22','11:30:00',2.75),('9303','2013-04-22','11:35:00',3.37),('9303','2013-04-22','11:40:00',4.11),('9303','2013-04-22','11:45:00',1.87),('9303','2013-04-22','11:50:00',1.58),('9303','2013-04-22','11:55:00',2.7),('9303','2013-04-22','12:00:00',3.6),('9303','2013-04-22','12:05:00',4.17),('9303','2013-04-22','12:10:00',2.61),('9303','2013-04-22','12:15:00',3),('9303','2013-04-22','12:20:00',3.44),('9303','2013-04-22','12:25:00',2.72),('9303','2013-04-22','12:30:00',2.31),('9303','2013-04-22','12:35:00',1.78),('9303','2013-04-22','12:40:00',3.56),('9303','2013-04-22','12:45:00',3.74),('9303','2013-04-22','12:50:00',4.55),('9303','2013-04-22','12:55:00',4.5),('9303','2013-04-22','13:00:00',4.5),('9303','2013-04-22','13:05:00',3.81),('9303','2013-04-22','13:10:00',2.89),('9303','2013-04-22','13:15:00',3.6),('9303','2013-04-22','13:20:00',4.76),('9303','2013-04-22','13:25:00',3.34),('9303','2013-04-22','13:30:00',1.68),('9303','2013-04-22','13:35:00',2.15),('9303','2013-04-22','13:40:00',2.03),('9303','2013-04-22','13:45:00',2.04),('9303','2013-04-22','13:50:00',1.05),('9303','2013-04-22','13:55:00',2.71),('9303','2013-04-22','14:00:00',1.32),('9303','2013-04-22','14:05:00',1.49),('9303','2013-04-22','14:10:00',2.56),('9303','2013-04-22','14:15:00',2.27),('9303','2013-04-22','14:20:00',3.51),('9303','2013-04-22','14:25:00',2.39),('9303','2013-04-22','14:30:00',4.58),('9303','2013-04-22','14:35:00',2.38),('9303','2013-04-22','14:40:00',4.52),('9303','2013-04-22','14:45:00',4.32),('9303','2013-04-22','14:50:00',4.29),('9303','2013-04-22','14:55:00',4.38),('9303','2013-04-22','15:00:00',1.18),('9303','2013-04-22','15:05:00',2.22),('9303','2013-04-22','15:10:00',1.48),('9303','2013-04-22','15:15:00',1.22),('9303','2013-04-22','15:25:00',2.34),('9303','2013-04-22','15:30:00',2.08),('9303','2013-04-22','15:35:00',1.38),('9303','2013-04-22','15:40:00',1.56),('9303','2013-04-22','15:45:00',3.14),('9303','2013-04-22','15:50:00',2.98),('9303','2013-04-22','15:55:00',1.55),('9303','2013-04-22','16:45:00',1.37),('9303','2014-03-29','07:30:00',1.05),('9303','2014-03-29','07:35:00',1.14),('9303','2014-03-29','07:40:00',1.26),('9303','2014-03-29','07:45:00',1.35),('9303','2014-03-29','07:50:00',1.46),('9303','2014-03-29','07:55:00',1.56),('9303','2014-03-29','08:00:00',1.69),('9303','2014-03-29','08:05:00',1.79),('9303','2014-03-29','08:10:00',1.89),('9303','2014-03-29','08:15:00',1.95),('9303','2014-03-29','08:20:00',2.04),('9303','2014-03-29','08:25:00',2.13),('9303','2014-03-29','08:30:00',2.2),('9303','2014-03-29','08:35:00',2.28),('9303','2014-03-29','08:40:00',2.35),('9303','2014-03-29','08:45:00',2.42),('9303','2014-03-29','08:50:00',2.51),('9303','2014-03-29','08:55:00',2.55),('9303','2014-03-29','09:00:00',2.59),('9303','2014-03-29','09:05:00',2.64),('9303','2014-03-29','09:10:00',2.71),('9303','2014-03-29','09:15:00',2.8),('9303','2014-03-29','09:20:00',2.88),('9303','2014-03-29','09:25:00',2.96),('9303','2014-03-29','09:30:00',3),('9303','2014-03-29','09:35:00',3.07),('9303','2014-03-29','09:40:00',3.14),('9303','2014-03-29','09:45:00',3.19),('9303','2014-03-29','09:50:00',3.27),('9303','2014-03-29','09:55:00',3.37),('9303','2014-03-29','10:00:00',3.42),('9303','2014-03-29','10:05:00',3.45),('9303','2014-03-29','10:10:00',3.52),('9303','2014-03-29','10:15:00',3.57),('9303','2014-03-29','10:20:00',3.61),('9303','2014-03-29','10:25:00',3.67),('9303','2014-03-29','10:30:00',3.68),('9303','2014-03-29','10:35:00',3.72),('9303','2014-03-29','10:40:00',3.76),('9303','2014-03-29','10:45:00',3.8),('9303','2014-03-29','10:50:00',3.83),('9303','2014-03-29','10:55:00',3.84),('9303','2014-03-29','11:00:00',3.87),('9303','2014-03-29','11:05:00',3.85),('9303','2014-03-29','11:10:00',3.87),('9303','2014-03-29','11:15:00',3.9),('9303','2014-03-29','11:20:00',3.91),('9303','2014-03-29','11:25:00',3.96),('9303','2014-03-29','11:30:00',3.98),('9303','2014-03-29','11:35:00',3.93),('9303','2014-03-29','11:40:00',3.85),('9303','2014-03-29','11:45:00',4.01),('9303','2014-03-29','11:50:00',4),('9303','2014-03-29','11:55:00',3.98),('9303','2014-03-29','12:00:00',3.99),('9303','2014-03-29','12:05:00',3.97),('9303','2014-03-29','12:10:00',3.97),('9303','2014-03-29','12:15:00',4.02),('9303','2014-03-29','12:20:00',4.05),('9303','2014-03-29','12:25:00',4.02),('9303','2014-03-29','12:30:00',4.03),('9303','2014-03-29','12:35:00',4.05),('9303','2014-03-29','12:40:00',4.01),('9303','2014-03-29','12:45:00',4.01),('9303','2014-03-29','12:50:00',3.98),('9303','2014-03-29','12:55:00',3.96),('9303','2014-03-29','13:00:00',3.91),('9303','2014-03-29','13:05:00',3.96),('9303','2014-03-29','13:10:00',3.89),('9303','2014-03-29','13:15:00',3.87),('9303','2014-03-29','13:20:00',3.83),('9303','2014-03-29','13:25:00',3.79),('9303','2014-03-29','13:30:00',3.75),('9303','2014-03-29','13:35:00',3.71),('9303','2014-03-29','13:40:00',3.64),('9303','2014-03-29','13:45:00',3.6),('9303','2014-03-29','13:50:00',3.56),('9303','2014-03-29','13:55:00',3.52),('9303','2014-03-29','14:00:00',3.49),('9303','2014-03-29','14:05:00',3.45),('9303','2014-03-29','14:10:00',3.42),('9303','2014-03-29','14:15:00',3.38),('9303','2014-03-29','14:20:00',3.32),('9303','2014-03-29','14:25:00',3.24),('9303','2014-03-29','14:30:00',3.18),('9303','2014-03-29','14:35:00',2.78),('9303','2014-03-29','14:40:00',2.41),('9303','2014-03-29','14:45:00',2.8),('9303','2014-03-29','14:50:00',3),('9303','2014-03-29','14:55:00',3),('9303','2014-03-29','15:00:00',2.91),('9303','2014-03-29','15:05:00',2.82),('9303','2014-03-29','15:10:00',2.71),('9303','2014-03-29','15:15:00',2.66),('9303','2014-03-29','15:20:00',2.62),('9303','2014-03-29','15:25:00',2.52),('9303','2014-03-29','15:30:00',2.42),('9303','2014-03-29','15:35:00',2.31),('9303','2014-03-29','15:40:00',2.24),('9303','2014-03-29','15:45:00',2.13),('9303','2014-03-29','15:50:00',2),('9303','2014-03-29','15:55:00',1.93),('9303','2014-03-29','16:00:00',1.86),('9303','2014-03-29','16:05:00',1.77),('9303','2014-03-29','16:10:00',1.67),('9303','2014-03-29','16:15:00',1.6),('9303','2014-03-29','16:20:00',1.39),('9303','2014-03-29','16:25:00',1.38),('9303','2014-03-29','16:30:00',1.31),('9303','2014-03-29','16:35:00',1.18),('9303','2013-04-21','08:15:00',1.06),('9303','2013-04-21','08:20:00',1),('9303','2013-04-21','08:25:00',1.01),('9303','2013-04-21','08:30:00',1.01),('9303','2013-04-21','08:35:00',1.29),('9303','2013-04-21','08:40:00',1.32),('9303','2013-04-21','08:45:00',1.25),('9303','2013-04-21','08:50:00',2.15),('9303','2013-04-21','08:55:00',2.07),('9303','2013-04-21','09:00:00',1.74),('9303','2013-04-21','09:05:00',1.97),('9303','2013-04-21','09:10:00',1.85),('9303','2013-04-21','09:15:00',1.89),('9303','2013-04-21','09:20:00',1.7),('9303','2013-04-21','09:25:00',2.02),('9303','2013-04-21','09:30:00',2.72),('9303','2013-04-21','09:35:00',2.78),('9303','2013-04-21','09:40:00',2.82),('9303','2013-04-21','09:45:00',2.75),('9303','2013-04-21','09:50:00',3.31),('9303','2013-04-21','09:55:00',3.51),('9303','2013-04-21','10:00:00',3.05),('9303','2013-04-21','10:05:00',1.98),('9303','2013-04-21','10:10:00',1.76),('9303','2013-04-21','10:15:00',1.84),('9303','2013-04-21','10:20:00',3.28),('9303','2013-04-21','10:25:00',3.14),('9303','2013-04-21','10:30:00',2.7),('9303','2013-04-21','10:35:00',1.77),('9303','2013-04-21','10:40:00',2.45),('9303','2013-04-21','10:45:00',2.35),('9303','2013-04-21','10:50:00',3.41),('9303','2013-04-21','10:55:00',2.64),('9303','2013-04-21','11:00:00',3.6),('9303','2013-04-21','11:05:00',3.45),('9303','2013-04-21','11:10:00',3.99),('9303','2013-04-21','11:15:00',3.02),('9303','2013-04-21','11:20:00',2.6),('9303','2013-04-21','11:25:00',2.75),('9303','2013-04-21','11:30:00',2.62),('9303','2013-04-21','11:35:00',2.57),('9303','2013-04-21','11:40:00',2.62),('9303','2013-04-21','11:45:00',2.95),('9303','2013-04-21','11:50:00',3.07),('9303','2013-04-21','11:55:00',2.8),('9303','2013-04-21','12:00:00',2.26),('9303','2013-04-21','12:05:00',2.37),('9303','2013-04-21','12:10:00',2.33),('9303','2013-04-21','12:15:00',2.03),('9303','2013-04-21','12:20:00',1.83),('9303','2013-04-21','12:25:00',1.73),('9303','2013-04-21','12:30:00',1.88),('9303','2013-04-21','12:35:00',1.94),('9303','2013-04-21','12:40:00',1.98),('9303','2013-04-21','12:45:00',1.99),('9303','2013-04-21','12:50:00',1.87),('9303','2013-04-21','12:55:00',1.79),('9303','2013-04-21','13:00:00',2.04),('9303','2013-04-21','13:05:00',2.42),('9303','2013-04-21','13:10:00',2.51),('9303','2013-04-21','13:15:00',2.29),('9303','2013-04-21','13:20:00',2.15),('9303','2013-04-21','13:25:00',2.02),('9303','2013-04-21','13:30:00',2.97),('9303','2013-04-21','13:35:00',3.6),('9303','2013-04-21','13:40:00',2.51),('9303','2013-04-21','13:45:00',2.83),('9303','2013-04-21','13:50:00',2.57),('9303','2013-04-21','13:55:00',3.56),('9303','2013-04-21','14:00:00',4.08),('9303','2013-04-21','14:05:00',4.14),('9303','2013-04-21','14:10:00',3.86),('9303','2013-04-21','14:15:00',3.76),('9303','2013-04-21','14:20:00',4.5),('9303','2013-04-21','14:25:00',3.94),('9303','2013-04-21','14:30:00',4),('9303','2013-04-21','14:35:00',4.1),('9303','2013-04-21','14:40:00',4.46),('9303','2013-04-21','14:45:00',3.55),('9303','2013-04-21','14:50:00',2.02),('9303','2013-04-21','14:55:00',1.87),('9303','2013-04-21','15:00:00',2.09),('9303','2013-04-21','15:05:00',3.72),('9303','2013-04-21','15:10:00',3.85),('9303','2013-04-21','15:15:00',3),('9303','2013-04-21','15:20:00',1.9),('9303','2013-04-21','15:25:00',1.85),('9303','2013-04-21','15:30:00',1.58),('9303','2013-04-21','15:35:00',1.29),('9303','2013-04-21','15:40:00',1.39),('9303','2013-04-21','15:45:00',1.17),('9303','2013-04-20','08:05:00',1.03),('9303','2013-04-20','08:10:00',1.16),('9303','2013-04-20','08:15:00',1.03),('9303','2013-04-20','08:25:00',1.15),('9303','2013-04-20','08:30:00',1.34),('9303','2013-04-20','08:35:00',1.51),('9303','2013-04-20','08:40:00',1.64),('9303','2013-04-20','08:45:00',1.7),('9303','2013-04-20','08:50:00',1.68),('9303','2013-04-20','08:55:00',1.67),('9303','2013-04-20','09:00:00',1.95),('9303','2013-04-20','09:05:00',2.08),('9303','2013-04-20','09:10:00',1.95),('9303','2013-04-20','09:15:00',1.93),('9303','2013-04-20','09:20:00',2.42),('9303','2013-04-20','09:25:00',2.25),('9303','2013-04-20','09:30:00',2.01),('9303','2013-04-20','09:35:00',1.49),('9303','2013-04-20','09:45:00',1.04),('9303','2013-04-20','09:50:00',1.13),('9303','2013-04-20','10:40:00',1.04),('9303','2013-04-20','10:45:00',3.13),('9303','2013-04-20','10:50:00',3.28),('9303','2013-04-20','10:55:00',1.78),('9303','2013-04-20','11:00:00',2.76),('9303','2013-04-20','11:05:00',2.91),('9303','2013-04-20','11:10:00',3.06),('9303','2013-04-20','11:15:00',4.14),('9303','2013-04-20','11:20:00',3.08),('9303','2013-04-20','11:25:00',1.87),('9303','2013-04-20','11:30:00',4.19),('9303','2013-04-20','11:35:00',3.33),('9303','2013-04-20','11:40:00',1.24),('9303','2013-04-20','11:45:00',2.59),('9303','2013-04-20','11:50:00',3.98),('9303','2013-04-20','11:55:00',4.17),('9303','2013-04-20','12:00:00',4.21),('9303','2013-04-20','12:05:00',3.97),('9303','2013-04-20','12:10:00',4.08),('9303','2013-04-20','12:15:00',3.68),('9303','2013-04-20','12:20:00',3.05),('9303','2013-04-20','12:25:00',2.91),('9303','2013-04-20','12:30:00',3.2),('9303','2013-04-20','12:35:00',2.45),('9303','2013-04-20','12:40:00',1.55),('9303','2013-04-20','12:45:00',3.85),('9303','2013-04-20','12:50:00',4.32),('9303','2013-04-20','12:55:00',4.41),('9303','2013-04-20','13:00:00',3.86),('9303','2013-04-20','13:05:00',3.29),('9303','2013-04-20','13:10:00',4.19),('9303','2013-04-20','13:15:00',3.85),('9303','2013-04-20','13:20:00',2.67),('9303','2013-04-20','13:25:00',3.81),('9303','2013-04-20','13:30:00',2.09),('9303','2013-04-20','13:35:00',1.78),('9303','2013-04-20','13:40:00',3.65),('9303','2013-04-20','13:45:00',2.1),('9303','2013-04-20','13:50:00',1.87),('9303','2013-04-20','13:55:00',2.63),('9303','2013-04-20','14:00:00',2.81),('9303','2013-04-20','14:05:00',3.96),('9303','2013-04-20','14:10:00',3.43),('9303','2013-04-20','14:15:00',4.04),('9303','2013-04-20','14:20:00',3.89),('9303','2013-04-20','14:25:00',3.86),('9303','2013-04-20','14:30:00',3.74),('9303','2013-04-20','14:35:00',3.67),('9303','2013-04-20','14:40:00',3.64),('9303','2013-04-20','14:45:00',3.64),('9303','2013-04-20','14:50:00',3.64),('9303','2013-04-20','14:55:00',3.65),('9303','2013-04-20','15:00:00',3.63),('9303','2013-04-20','15:05:00',3.58),('9303','2013-04-20','15:10:00',2.33),('9303','2013-04-20','15:15:00',2.5),('9303','2013-04-20','15:20:00',1.99),('9303','2013-04-20','15:25:00',3.07),('9303','2013-04-20','15:30:00',1.91),('9303','2013-04-20','16:10:00',1.28),('9303','2013-04-20','16:15:00',2.02),('9303','2013-04-20','16:20:00',2.02),('9303','2013-04-20','16:25:00',2.21),('9303','2013-04-20','16:30:00',2.64),('9303','2013-04-20','16:35:00',2.58),('9303','2013-04-20','16:40:00',2.43),('9303','2013-04-20','16:45:00',2.64),('9303','2013-04-20','16:50:00',2.39),('9303','2013-04-20','16:55:00',2.26),('9303','2013-04-20','17:00:00',2.1),('9303','2013-04-20','17:05:00',1.99),('9303','2013-04-20','17:10:00',1.92),('9303','2013-04-20','17:15:00',1.72),('9303','2013-04-20','17:20:00',1.52),('9303','2013-04-20','17:25:00',1.66),('9303','2013-04-20','17:30:00',1.73),('9303','2013-04-20','17:35:00',1.75),('9303','2013-04-20','17:40:00',1.56),('9303','2013-04-20','17:55:00',1.35),('9303','2013-04-20','18:00:00',1.01),('9303','2013-04-20','18:05:00',1.09),('9303','2013-04-20','18:10:00',1.05),('9303','2013-04-19','08:20:00',1.19),('9303','2013-04-19','08:25:00',1.26),('9303','2013-04-19','08:30:00',1.11),('9303','2013-04-19','08:35:00',1.49),('9303','2013-04-19','08:40:00',1.58),('9303','2013-04-19','08:45:00',1.66),('9303','2013-04-19','08:50:00',1.75),('9303','2013-04-19','08:55:00',1.83),('9303','2013-04-19','09:00:00',1.89),('9303','2013-04-19','09:05:00',1.96),('9303','2013-04-19','09:10:00',2.02),('9303','2013-04-19','09:15:00',2.08),('9303','2013-04-19','09:20:00',2.16),('9303','2013-04-19','09:25:00',2.24),('9303','2013-04-19','09:30:00',2.31),('9303','2013-04-19','09:35:00',2.4),('9303','2013-04-19','09:40:00',2.46),('9303','2013-04-19','09:45:00',2.49),('9303','2013-04-19','09:50:00',2.55),('9303','2013-04-19','09:55:00',2.61),('9303','2013-04-19','10:00:00',2.66),('9303','2013-04-19','10:05:00',2.74),('9303','2013-04-19','10:10:00',2.78),('9303','2013-04-19','10:15:00',2.91),('9303','2013-04-19','10:20:00',2.78),('9303','2013-04-19','10:25:00',2.98),('9303','2013-04-19','10:30:00',2.27),('9303','2013-04-19','10:35:00',2.18),('9303','2013-04-19','10:40:00',3.16),('9303','2013-04-19','10:45:00',3.22),('9303','2013-04-19','10:50:00',3.2),('9303','2013-04-19','10:55:00',3.19),('9303','2013-04-19','11:00:00',3.21),('9303','2013-04-19','11:05:00',3.26),('9303','2013-04-19','11:10:00',3.3),('9303','2013-04-19','11:15:00',3.31),('9303','2013-04-19','11:20:00',3.38),('9303','2013-04-19','11:25:00',3.42),('9303','2013-04-19','11:30:00',3.48),('9303','2013-04-19','11:35:00',3.5),('9303','2013-04-19','11:40:00',3.55),('9303','2013-04-19','11:45:00',3.57),('9303','2013-04-19','11:50:00',3.59),('9303','2013-04-19','11:55:00',3.61),('9303','2013-04-19','12:00:00',3.63),('9303','2013-04-19','12:05:00',3.63),('9303','2013-04-19','12:10:00',3.68),('9303','2013-04-19','12:15:00',3.76),('9303','2013-04-19','12:20:00',3.75),('9303','2013-04-19','12:25:00',3.7),('9303','2013-04-19','12:30:00',3.68),('9303','2013-04-19','12:35:00',3.76),('9303','2013-04-19','12:40:00',3.73),('9303','2013-04-19','12:45:00',3.8),('9303','2013-04-19','12:50:00',3.76),('9303','2013-04-19','12:55:00',3.74),('9303','2013-04-19','13:00:00',3.75),('9303','2013-04-19','13:05:00',3.81),('9303','2013-04-19','13:10:00',3.84),('9303','2013-04-19','13:15:00',3.83),('9303','2013-04-19','13:20:00',3.79),('9303','2013-04-19','13:25:00',3.84),('9303','2013-04-19','13:30:00',3.89),('9303','2013-04-19','13:35:00',3.8),('9303','2013-04-19','13:40:00',3.85),('9303','2013-04-19','13:45:00',3.81),('9303','2013-04-19','13:50:00',3.74),('9303','2013-04-19','13:55:00',3.7),('9303','2013-04-19','14:00:00',3.72),('9303','2013-04-19','14:05:00',3.64),('9303','2013-04-19','14:10:00',3.67),('9303','2013-04-19','14:15:00',3.58),('9303','2013-04-19','14:20:00',3.58),('9303','2013-04-19','14:25:00',3.58),('9303','2013-04-19','14:30:00',3.52),('9303','2013-04-19','14:35:00',3.5),('9303','2013-04-19','14:40:00',3.46),('9303','2013-04-19','14:45:00',3.46),('9303','2013-04-19','14:50:00',3.47),('9303','2013-04-19','14:55:00',3.41),('9303','2013-04-19','15:00:00',3.43),('9303','2013-04-19','15:05:00',3.37),('9303','2013-04-19','15:10:00',3.3),('9303','2013-04-19','15:15:00',3.22),('9303','2013-04-19','15:20:00',3.15),('9303','2013-04-19','15:25:00',3.14),('9303','2013-04-19','15:30:00',3.08),('9303','2013-04-19','15:35:00',3),('9303','2013-04-19','15:40:00',2.98),('9303','2013-04-19','15:45:00',2.93),('9303','2013-04-19','15:50:00',2.88),('9303','2013-04-19','15:55:00',2.82),('9303','2013-04-19','16:00:00',2.76),('9303','2013-04-19','16:05:00',2.7),('9303','2013-04-19','16:10:00',2.62),('9303','2013-04-19','16:15:00',2.54),('9303','2013-04-19','16:20:00',2.49),('9303','2013-04-19','16:25:00',2.45),('9303','2013-04-19','16:30:00',2.36),('9303','2013-04-19','16:35:00',2.28),('9303','2013-04-19','16:40:00',2.21),('9303','2013-04-19','16:45:00',2.14),('9303','2013-04-19','16:50:00',2.02),('9303','2013-04-19','16:55:00',1.91),('9303','2013-04-19','17:00:00',1.81),('9303','2013-04-19','17:05:00',1.72),('9303','2013-04-19','17:10:00',1.63),('9303','2013-04-19','17:15:00',1.57),('9303','2013-04-19','17:20:00',1.48),('9303','2013-04-19','17:25:00',1.42),('9303','2013-04-19','17:30:00',1.36),('9303','2013-04-19','17:35:00',1.27),('9303','2013-04-19','17:40:00',1.18),('9303','2013-04-19','17:45:00',1.1),('9303','2013-04-18','08:15:00',1.02),('9303','2013-04-18','08:20:00',1.06),('9303','2013-04-18','08:25:00',1.07),('9303','2013-04-18','08:30:00',1.22),('9303','2013-04-18','08:35:00',1.25),('9303','2013-04-18','08:40:00',1.24),('9303','2013-04-18','08:45:00',1.29),('9303','2013-04-18','08:50:00',1.42),('9303','2013-04-18','08:55:00',1.63),('9303','2013-04-18','09:00:00',1.58),('9303','2013-04-18','09:05:00',1.77),('9303','2013-04-18','09:10:00',1.87),('9303','2013-04-18','09:15:00',1.9),('9303','2013-04-18','09:20:00',1.99),('9303','2013-04-18','09:25:00',2.05),('9303','2013-04-18','09:30:00',2.14),('9303','2013-04-18','09:35:00',2.31),('9303','2013-04-18','09:40:00',2.74),('9303','2013-04-18','09:45:00',2.48),('9303','2013-04-18','09:50:00',2.14),('9303','2013-04-18','09:55:00',2.13),('9303','2013-04-18','10:00:00',2.56),('9303','2013-04-18','10:05:00',2.83),('9303','2013-04-18','10:10:00',2.9),('9303','2013-04-18','10:15:00',2.59),('9303','2013-04-18','10:20:00',3.07),('9303','2013-04-18','10:25:00',3.06),('9303','2013-04-18','10:30:00',3.18),('9303','2013-04-18','10:35:00',3.2),('9303','2013-04-18','10:40:00',3.27),('9303','2013-04-18','10:45:00',3.31),('9303','2013-04-18','10:50:00',3.37),('9303','2013-04-18','10:55:00',3.41),('9303','2013-04-18','11:00:00',3.45),('9303','2013-04-18','11:05:00',3.51),('9303','2013-04-18','11:10:00',3.56),('9303','2013-04-18','11:15:00',3.61),('9303','2013-04-18','11:20:00',3.64),('9303','2013-04-18','11:25:00',3.64),('9303','2013-04-18','11:30:00',3.67),('9303','2013-04-18','11:35:00',3.68),('9303','2013-04-18','11:40:00',3.71),('9303','2013-04-18','11:45:00',3.71),('9303','2013-04-18','11:50:00',3.75),('9303','2013-04-18','11:55:00',3.81),('9303','2013-04-18','12:00:00',3.79),('9303','2013-04-18','12:05:00',3.9),('9303','2013-04-18','12:10:00',3.92),('9303','2013-04-18','12:15:00',3.91),('9303','2013-04-18','12:20:00',3.95),('9303','2013-04-18','12:25:00',3.94),('9303','2013-04-18','12:30:00',3.93),('9303','2013-04-18','12:35:00',3.95),('9303','2013-04-18','12:40:00',3.99),('9303','2013-04-18','12:45:00',3.96),('9303','2013-04-18','12:50:00',4),('9303','2013-04-18','12:55:00',4.01),('9303','2013-04-18','13:00:00',4.02),('9303','2013-04-18','13:05:00',4.02),('9303','2013-04-18','13:10:00',4.05),('9303','2013-04-18','13:15:00',4.04),('9303','2013-04-18','13:20:00',4.06),('9303','2013-04-18','13:25:00',4.05),('9303','2013-04-18','13:30:00',4.03),('9303','2013-04-18','13:35:00',4.01),('9303','2013-04-18','13:40:00',3.94),('9303','2013-04-18','13:45:00',3.94),('9303','2013-04-18','13:50:00',3.97),('9303','2013-04-18','13:55:00',3.97),('9303','2013-04-18','14:00:00',3.92),('9303','2013-04-18','14:05:00',3.92),('9303','2013-04-18','14:10:00',3.87),('9303','2013-04-18','14:15:00',3.86),('9303','2013-04-18','14:20:00',3.85),('9303','2013-04-18','14:25:00',3.83),('9303','2013-04-18','14:30:00',3.79),('9303','2013-04-18','14:35:00',3.75),('9303','2013-04-18','14:40:00',3.72),('9303','2013-04-18','14:45:00',3.68),('9303','2013-04-18','14:50:00',3.64),('9303','2013-04-18','14:55:00',3.59),('9303','2013-04-18','15:00:00',3.54),('9303','2013-04-18','15:05:00',3.51),('9303','2013-04-18','15:10:00',3.47),('9303','2013-04-18','15:15:00',3.42),('9303','2013-04-18','15:20:00',3.36),('9303','2013-04-18','15:25:00',3.31),('9303','2013-04-18','15:30:00',3.25),('9303','2013-04-18','15:35:00',3.22),('9303','2013-04-18','15:40:00',3.16),('9303','2013-04-18','15:45:00',3.08),('9303','2013-04-18','15:50:00',3.03),('9303','2013-04-18','15:55:00',2.96),('9303','2013-04-18','16:00:00',2.9),('9303','2013-04-18','16:05:00',2.81),('9303','2013-04-18','16:10:00',2.78),('9303','2013-04-18','16:15:00',2.71),('9303','2013-04-18','16:20:00',2.62),('9303','2013-04-18','16:25:00',2.55),('9303','2013-04-18','16:30:00',2.49),('9303','2013-04-18','16:35:00',2.4),('9303','2013-04-18','16:40:00',2.34),('9303','2013-04-18','16:45:00',2.26),('9303','2013-04-18','16:50:00',2.16),('9303','2013-04-18','16:55:00',2.05),('9303','2013-04-18','17:00:00',1.92),('9303','2013-04-18','17:05:00',1.83),('9303','2013-04-18','17:10:00',1.77),('9303','2013-04-18','17:15:00',1.7),('9303','2013-04-18','17:20:00',1.61),('9303','2013-04-18','17:25:00',1.53),('9303','2013-04-18','17:30:00',1.46),('9303','2013-04-18','17:35:00',1.38),('9303','2013-04-18','17:40:00',1.27),('9303','2013-04-18','17:45:00',1.21),('9303','2013-04-18','17:50:00',1.14),('9303','2013-04-18','17:55:00',1.05),('9303','2013-04-17','08:10:00',1.07),('9303','2013-04-17','08:15:00',1.17),('9303','2013-04-17','08:20:00',1.26),('9303','2013-04-17','08:25:00',1.36),('9303','2013-04-17','08:30:00',1.45),('9303','2013-04-17','08:35:00',1.54),('9303','2013-04-17','08:40:00',1.64),('9303','2013-04-17','08:45:00',1.72),('9303','2013-04-17','08:50:00',1.81),('9303','2013-04-17','08:55:00',1.89),('9303','2013-04-17','09:00:00',1.97),('9303','2013-04-17','09:05:00',2.05),('9303','2013-04-17','09:10:00',2.12),('9303','2013-04-17','09:15:00',2.21),('9303','2013-04-17','09:20:00',2.29),('9303','2013-04-17','09:25:00',2.37),('9303','2013-04-17','09:30:00',2.44),('9303','2013-04-17','09:35:00',2.51),('9303','2013-04-17','09:40:00',2.58),('9303','2013-04-17','09:45:00',2.64),('9303','2013-04-17','09:50:00',2.72),('9303','2013-04-17','09:55:00',2.78),('9303','2013-04-17','10:00:00',2.86),('9303','2013-04-17','10:05:00',2.94),('9303','2013-04-17','10:10:00',3),('9303','2013-04-17','10:15:00',3.04),('9303','2013-04-17','10:20:00',3.09),('9303','2013-04-17','10:25:00',3.18),('9303','2013-04-17','10:30:00',3.21),('9303','2013-04-17','10:35:00',3.27),('9303','2013-04-17','10:40:00',3.32),('9303','2013-04-17','10:45:00',3.36),('9303','2013-04-17','10:50:00',3.39),('9303','2013-04-17','10:55:00',3.46),('9303','2013-04-17','11:00:00',3.52),('9303','2013-04-17','11:05:00',3.55),('9303','2013-04-17','11:10:00',3.58),('9303','2013-04-17','11:15:00',3.58),('9303','2013-04-17','11:20:00',3.65),('9303','2013-04-17','11:25:00',3.71),('9303','2013-04-17','11:30:00',3.71),('9303','2013-04-17','11:35:00',3.74),('9303','2013-04-17','11:40:00',3.75),('9303','2013-04-17','11:45:00',3.75),('9303','2013-04-17','11:50:00',3.83),('9303','2013-04-17','11:55:00',3.83),('9303','2013-04-17','12:00:00',3.84),('9303','2013-04-17','12:05:00',3.83),('9303','2013-04-17','12:10:00',3.89),('9303','2013-04-17','12:15:00',3.91),('9303','2013-04-17','12:20:00',3.89),('9303','2013-04-17','12:25:00',3.94),('9303','2013-04-17','12:30:00',3.96),('9303','2013-04-17','12:35:00',3.96),('9303','2013-04-17','12:40:00',3.95),('9303','2013-04-17','12:45:00',4),('9303','2013-04-17','12:50:00',4.01),('9303','2013-04-17','12:55:00',4.02),('9303','2013-04-17','13:00:00',3.97),('9303','2013-04-17','13:05:00',3.94),('9303','2013-04-17','13:10:00',3.98),('9303','2013-04-17','13:15:00',4.02),('9303','2013-04-17','13:20:00',4.06),('9303','2013-04-17','13:25:00',4.03),('9303','2013-04-17','13:30:00',4.04),('9303','2013-04-17','13:35:00',3.98),('9303','2013-04-17','13:40:00',4.06),('9303','2013-04-17','13:45:00',3.81),('9303','2013-04-17','13:50:00',3.79),('9303','2013-04-17','13:55:00',4.05),('9303','2013-04-17','14:00:00',3.83),('9303','2013-04-17','14:05:00',4.22),('9303','2013-04-17','14:10:00',4.14),('9303','2013-04-17','14:15:00',3.7),('9303','2013-04-17','14:20:00',3.61),('9303','2013-04-17','14:25:00',3.49),('9303','2013-04-17','14:30:00',3.57),('9303','2013-04-17','14:35:00',4.09),('9303','2013-04-17','14:40:00',3.85),('9303','2013-04-17','14:45:00',3.41),('9303','2013-04-17','14:50:00',3.81),('9303','2013-04-17','14:55:00',3.94),('9303','2013-04-17','15:00:00',3.87),('9303','2013-04-17','15:05:00',3.98),('9303','2013-04-17','15:10:00',4.1),('9303','2013-04-17','15:15:00',3.76),('9303','2013-04-17','15:20:00',1.92),('9303','2013-04-17','15:25:00',2),('9303','2013-04-17','15:30:00',3.13),('9303','2013-04-17','15:35:00',3.39),('9303','2013-04-17','15:40:00',3.4),('9303','2013-04-17','15:45:00',3.39),('9303','2013-04-17','15:50:00',3.38),('9303','2013-04-17','15:55:00',3.35),('9303','2013-04-17','16:00:00',3.18),('9303','2013-04-17','16:05:00',2.29),('9303','2013-04-17','16:10:00',3.03),('9303','2013-04-17','16:15:00',2.92),('9303','2013-04-17','16:20:00',2.8),('9303','2013-04-17','16:25:00',2.73),('9303','2013-04-17','16:30:00',2.65),('9303','2013-04-17','16:35:00',2.63),('9303','2013-04-17','16:40:00',2.37),('9303','2013-04-17','16:45:00',2.49),('9303','2013-04-17','16:50:00',2.24),('9303','2013-04-17','16:55:00',2.11),('9303','2013-04-17','17:00:00',1.98),('9303','2013-04-17','17:05:00',1.89),('9303','2013-04-17','17:10:00',1.81),('9303','2013-04-17','17:15:00',1.73),('9303','2013-04-17','17:20:00',1.65),('9303','2013-04-17','17:25:00',1.57),('9303','2013-04-17','17:30:00',1.49),('9303','2013-04-17','17:35:00',1.39),('9303','2013-04-17','17:40:00',1.3),('9303','2013-04-17','17:45:00',1.22),('9303','2013-04-17','17:50:00',1.13),('9303','2013-04-17','17:55:00',1.05),('9303','2013-04-16','08:55:00',1.03),('9303','2013-04-16','09:00:00',1.01),('9303','2013-04-16','09:10:00',1.13),('9303','2013-04-16','09:15:00',1.2),('9303','2013-04-16','09:20:00',1.16),('9303','2013-04-16','09:25:00',1.58),('9303','2013-04-16','09:30:00',1.55),('9303','2013-04-16','09:35:00',1.5),('9303','2013-04-16','09:40:00',1.25),('9303','2013-04-16','09:45:00',1.28),('9303','2013-04-16','09:50:00',1.24),('9303','2013-04-16','09:55:00',1.19),('9303','2013-04-16','10:00:00',1.13),('9303','2013-04-16','10:05:00',1.13),('9303','2013-04-16','10:10:00',1.22),('9303','2013-04-16','10:15:00',1.31),('9303','2013-04-16','10:20:00',1.36),('9303','2013-04-16','10:25:00',1.39),('9303','2013-04-16','10:30:00',1.41),('9303','2013-04-16','10:35:00',1.44),('9303','2013-04-16','10:40:00',1.4),('9303','2013-04-16','10:45:00',1.34),('9303','2013-04-16','10:50:00',1.35),('9303','2013-04-16','10:55:00',1.45),('9303','2013-04-16','11:00:00',1.58),('9303','2013-04-16','11:05:00',1.62),('9303','2013-04-16','11:10:00',1.62),('9303','2013-04-16','11:15:00',1.67),('9303','2013-04-16','11:20:00',1.72),('9303','2013-04-16','11:25:00',1.69),('9303','2013-04-16','11:30:00',1.65),('9303','2013-04-16','11:35:00',1.61),('9303','2013-04-16','11:40:00',1.8),('9303','2013-04-16','11:45:00',2.1),('9303','2013-04-16','11:50:00',2.26),('9303','2013-04-16','11:55:00',2.33),('9303','2013-04-16','12:00:00',2.37),('9303','2013-04-16','12:05:00',2.64),('9303','2013-04-16','12:10:00',2.69),('9303','2013-04-16','12:15:00',2.99),('9303','2013-04-16','12:20:00',2.88),('9303','2013-04-16','12:25:00',2.85),('9303','2013-04-16','12:30:00',3.09),('9303','2013-04-16','12:35:00',3.96),('9303','2013-04-16','12:40:00',3.75),('9303','2013-04-16','12:45:00',3.62),('9303','2013-04-16','12:50:00',2.76),('9303','2013-04-16','12:55:00',3.83),('9303','2013-04-16','13:00:00',3.92),('9303','2013-04-16','13:05:00',3.78),('9303','2013-04-16','13:10:00',3.8),('9303','2013-04-16','13:15:00',3.85),('9303','2013-04-16','13:20:00',3.88),('9303','2013-04-16','13:25:00',3.92),('9303','2013-04-16','13:30:00',3.88),('9303','2013-04-16','13:35:00',3.87),('9303','2013-04-16','13:40:00',3.84),('9303','2013-04-16','13:45:00',3.75),('9303','2013-04-16','13:50:00',3.74),('9303','2013-04-16','13:55:00',3.61),('9303','2013-04-16','14:00:00',3.71),('9303','2013-04-16','14:05:00',3.78),('9303','2013-04-16','14:10:00',3.8),('9303','2013-04-16','14:15:00',3.77),('9303','2013-04-16','14:20:00',3.72),('9303','2013-04-16','14:25:00',2.87),('9303','2013-04-16','14:30:00',3.15),('9303','2013-04-16','14:35:00',3.01),('9303','2013-04-16','14:40:00',3.47),('9303','2013-04-16','14:45:00',3.64),('9303','2013-04-16','14:50:00',3.46),('9303','2013-04-16','14:55:00',3.36),('9303','2013-04-16','15:00:00',3.49),('9303','2013-04-16','15:05:00',3.46),('9303','2013-04-16','15:10:00',3.43),('9303','2013-04-16','15:15:00',3.38),('9303','2013-04-16','15:20:00',3.33),('9303','2013-04-16','15:25:00',3.21),('9303','2013-04-16','15:30:00',3.11),('9303','2013-04-16','15:35:00',3.12),('9303','2013-04-16','15:40:00',3.08),('9303','2013-04-16','15:45:00',3.03),('9303','2013-04-16','15:50:00',3.01),('9303','2013-04-16','15:55:00',2.93),('9303','2013-04-16','16:00:00',2.77),('9303','2013-04-16','16:05:00',2.79),('9303','2013-04-16','16:10:00',2.71),('9303','2013-04-16','16:15:00',2.63),('9303','2013-04-16','16:20:00',2.63),('9303','2013-04-16','16:25:00',2.55),('9303','2013-04-16','16:30:00',2.5),('9303','2013-04-16','16:35:00',2.47),('9303','2013-04-16','16:40:00',2.6),('9303','2013-04-16','16:45:00',2.63),('9303','2013-04-16','16:50:00',2.3),('9303','2013-04-16','16:55:00',1.93),('9303','2013-04-16','17:00:00',1.97),('9303','2013-04-16','17:05:00',1.98),('9303','2013-04-16','17:10:00',2),('9303','2013-04-16','17:15:00',1.92),('9303','2013-04-16','17:20:00',1.84),('9303','2013-04-16','17:25:00',1.81),('9303','2013-04-16','17:30:00',1.73),('9303','2013-04-16','17:35:00',1.69),('9303','2013-04-16','17:40:00',1.56),('9303','2013-04-16','17:45:00',1.43),('9303','2013-04-16','17:50:00',1.28),('9303','2013-04-16','17:55:00',1.08),('9303','2013-04-15','08:10:00',1.08),('9303','2013-04-15','08:15:00',1.16),('9303','2013-04-15','08:20:00',1.26),('9303','2013-04-15','08:25:00',1.35),('9303','2013-04-15','08:30:00',1.46),('9303','2013-04-15','08:35:00',1.53),('9303','2013-04-15','08:40:00',1.66),('9303','2013-04-15','08:45:00',1.73),('9303','2013-04-15','08:50:00',1.83),('9303','2013-04-15','08:55:00',1.91),('9303','2013-04-15','09:00:00',1.99),('9303','2013-04-15','09:05:00',2.09),('9303','2013-04-15','09:10:00',2.16),('9303','2013-04-15','09:15:00',2.24),('9303','2013-04-15','09:20:00',2.32),('9303','2013-04-15','09:25:00',2.39),('9303','2013-04-15','09:30:00',2.46),('9303','2013-04-15','09:35:00',2.52),('9303','2013-04-15','09:40:00',2.59),('9303','2013-04-15','09:45:00',2.66),('9303','2013-04-15','09:50:00',2.73),('9303','2013-04-15','09:55:00',2.8),('9303','2013-04-15','10:00:00',2.87),('9303','2013-04-15','10:05:00',2.94),('9303','2013-04-15','10:10:00',3.01),('9303','2013-04-15','10:15:00',3.07),('9303','2013-04-15','10:20:00',3.12),('9303','2013-04-15','10:25:00',3.16),('9303','2013-04-15','10:30:00',3.23),('9303','2013-04-15','10:35:00',3.28),('9303','2013-04-15','10:40:00',3.33),('9303','2013-04-15','10:45:00',3.38),('9303','2013-04-15','10:50:00',3.42),('9303','2013-04-15','10:55:00',3.48),('9303','2013-04-15','11:00:00',3.51),('9303','2013-04-15','11:05:00',3.54),('9303','2013-04-15','11:10:00',3.59),('9303','2013-04-15','11:15:00',3.62),('9303','2013-04-15','11:20:00',3.65),('9303','2013-04-15','11:25:00',3.7),('9303','2013-04-15','11:30:00',3.74),('9303','2013-04-15','11:35:00',3.76),('9303','2013-04-15','11:40:00',3.77),('9303','2013-04-15','11:45:00',3.77),('9303','2013-04-15','11:50:00',3.78),('9303','2013-04-15','11:55:00',3.8),('9303','2013-04-15','12:00:00',3.81),('9303','2013-04-15','12:05:00',3.82),('9303','2013-04-15','12:10:00',3.82),('9303','2013-04-15','12:15:00',3.88),('9303','2013-04-15','12:20:00',3.9),('9303','2013-04-15','12:25:00',3.91),('9303','2013-04-15','12:30:00',3.94),('9303','2013-04-15','12:35:00',3.95),('9303','2013-04-15','12:40:00',3.91),('9303','2013-04-15','12:45:00',3.91),('9303','2013-04-15','12:50:00',3.88),('9303','2013-04-15','12:55:00',3.88),('9303','2013-04-15','13:00:00',3.91),('9303','2013-04-15','13:05:00',3.99),('9303','2013-04-15','13:10:00',4.01),('9303','2013-04-15','13:15:00',3.99),('9303','2013-04-15','13:20:00',3.96),('9303','2013-04-15','13:25:00',3.92),('9303','2013-04-15','13:30:00',3.93),('9303','2013-04-15','13:35:00',3.96),('9303','2013-04-15','13:40:00',3.92),('9303','2013-04-15','13:45:00',3.83),('9303','2013-04-15','13:50:00',3.86),('9303','2013-04-15','13:55:00',3.96),('9303','2013-04-15','14:00:00',3.95),('9303','2013-04-15','14:05:00',3.91),('9303','2013-04-15','14:10:00',3.9),('9303','2013-04-15','14:15:00',3.9),('9303','2013-04-15','14:20:00',3.9),('9303','2013-04-15','14:25:00',3.88),('9303','2013-04-15','14:30:00',3.82),('9303','2013-04-15','14:35:00',3.79),('9303','2013-04-15','14:40:00',3.76),('9303','2013-04-15','14:45:00',3.72),('9303','2013-04-15','14:50:00',3.69),('9303','2013-04-15','14:55:00',3.64),('9303','2013-04-15','15:00:00',3.61),('9303','2013-04-15','15:05:00',3.56),('9303','2013-04-15','15:10:00',3.53),('9303','2013-04-15','15:15:00',3.49),('9303','2013-04-15','15:20:00',3.45),('9303','2013-04-15','15:25:00',3.41),('9303','2013-04-15','15:30:00',3.35),('9303','2013-04-15','15:35:00',3.3),('9303','2013-04-15','15:40:00',3.23),('9303','2013-04-15','15:45:00',3.17),('9303','2013-04-15','15:50:00',3.1),('9303','2013-04-15','15:55:00',3.05),('9303','2013-04-15','16:00:00',2.99),('9303','2013-04-15','16:05:00',2.92),('9303','2013-04-15','16:10:00',2.84),('9303','2013-04-15','16:15:00',2.77),('9303','2013-04-15','16:20:00',2.7),('9303','2013-04-15','16:25:00',2.63),('9303','2013-04-15','16:30:00',2.56),('9303','2013-04-15','16:35:00',2.48),('9303','2013-04-15','16:40:00',2.4),('9303','2013-04-15','16:45:00',2.28),('9303','2013-04-15','16:50:00',2.18),('9303','2013-04-15','16:55:00',2.07),('9303','2013-04-15','17:00:00',1.96),('9303','2013-04-15','17:05:00',1.89),('9303','2013-04-15','17:10:00',1.82),('9303','2013-04-15','17:15:00',1.73),('9303','2013-04-15','17:20:00',1.65),('9303','2013-04-15','17:25:00',1.58),('9303','2013-04-15','17:30:00',1.49),('9303','2013-04-15','17:35:00',1.39),('9303','2013-04-15','17:40:00',1.31),('9303','2013-04-15','17:45:00',1.23),('9303','2013-04-15','17:50:00',1.13),('9303','2013-04-15','17:55:00',1.05),('9303','2013-04-14','08:15:00',1.09),('9303','2013-04-14','08:20:00',1.18),('9303','2013-04-14','08:25:00',1.27),('9303','2013-04-14','08:30:00',1.37),('9303','2013-04-14','08:35:00',1.45),('9303','2013-04-14','08:40:00',1.53),('9303','2013-04-14','08:45:00',1.63),('9303','2013-04-14','08:50:00',1.73),('9303','2013-04-14','08:55:00',1.82),('9303','2013-04-14','09:00:00',1.89),('9303','2013-04-14','09:05:00',1.98),('9303','2013-04-14','09:10:00',2.03),('9303','2013-04-14','09:15:00',2.11),('9303','2013-04-14','09:20:00',2.19),('9303','2013-04-14','09:25:00',2.25),('9303','2013-04-14','09:30:00',2.32),('9303','2013-04-14','09:35:00',2.41),('9303','2013-04-14','09:40:00',2.48),('9303','2013-04-14','09:45:00',2.54),('9303','2013-04-14','09:50:00',2.62),('9303','2013-04-14','09:55:00',2.7),('9303','2013-04-14','10:00:00',2.74),('9303','2013-04-14','10:05:00',2.82),('9303','2013-04-14','10:10:00',2.88),('9303','2013-04-14','10:15:00',2.94),('9303','2013-04-14','10:20:00',3.01),('9303','2013-04-14','10:25:00',3.08),('9303','2013-04-14','10:30:00',3.12),('9303','2013-04-14','10:35:00',3.16),('9303','2013-04-14','10:40:00',3.18),('9303','2013-04-14','10:45:00',3.24),('9303','2013-04-14','10:50:00',3.31),('9303','2013-04-14','10:55:00',3.36),('9303','2013-04-14','11:00:00',3.42),('9303','2013-04-14','11:05:00',3.47),('9303','2013-04-14','11:10:00',3.52),('9303','2013-04-14','11:15:00',3.55),('9303','2013-04-14','11:20:00',3.55),('9303','2013-04-14','11:25:00',3.56),('9303','2013-04-14','11:30:00',3.59),('9303','2013-04-14','11:35:00',3.63),('9303','2013-04-14','11:40:00',3.72),('9303','2013-04-14','11:45:00',3.7),('9303','2013-04-14','11:50:00',3.69),('9303','2013-04-14','11:55:00',3.71),('9303','2013-04-14','12:00:00',3.72),('9303','2013-04-14','12:05:00',3.73),('9303','2013-04-14','12:10:00',3.77),('9303','2013-04-14','12:15:00',3.8),('9303','2013-04-14','12:20:00',3.85),('9303','2013-04-14','12:25:00',3.84),('9303','2013-04-14','12:30:00',3.82),('9303','2013-04-14','12:35:00',3.82),('9303','2013-04-14','12:40:00',3.92),('9303','2013-04-14','12:45:00',4.01),('9303','2013-04-14','12:50:00',4.03),('9303','2013-04-14','12:55:00',4.1),('9303','2013-04-14','13:00:00',4.15),('9303','2013-04-14','13:05:00',3.96),('9303','2013-04-14','13:10:00',4.06),('9303','2013-04-14','13:15:00',4.03),('9303','2013-04-14','13:20:00',4.05),('9303','2013-04-14','13:25:00',4.05),('9303','2013-04-14','13:30:00',3.96),('9303','2013-04-14','13:35:00',3.91),('9303','2013-04-14','13:40:00',3.88),('9303','2013-04-14','13:45:00',3.86),('9303','2013-04-14','13:50:00',3.8),('9303','2013-04-14','13:55:00',3.79),('9303','2013-04-14','14:00:00',3.84),('9303','2013-04-14','14:05:00',3.86),('9303','2013-04-14','14:10:00',3.85),('9303','2013-04-14','14:15:00',3.8),('9303','2013-04-14','14:20:00',3.75),('9303','2013-04-14','14:25:00',3.71),('9303','2013-04-14','14:30:00',3.67),('9303','2013-04-14','14:35:00',3.72),('9303','2013-04-14','14:40:00',3.82),('9303','2013-04-14','14:45:00',3.89),('9303','2013-04-14','14:50:00',3.86),('9303','2013-04-14','14:55:00',3.71),('9303','2013-04-14','15:00:00',3.58),('9303','2013-04-14','15:05:00',3.63),('9303','2013-04-14','15:10:00',3.61),('9303','2013-04-14','15:15:00',3.44),('9303','2013-04-14','15:20:00',3.2),('9303','2013-04-14','15:25:00',2.34),('9303','2013-04-14','15:30:00',3.3),('9303','2013-04-14','15:35:00',3.36),('9303','2013-04-14','15:40:00',3.36),('9303','2013-04-14','15:45:00',3.31),('9303','2013-04-14','15:50:00',3.17),('9303','2013-04-14','15:55:00',2.43),('9303','2013-04-14','16:00:00',2.67),('9303','2013-04-14','16:05:00',2.82),('9303','2013-04-14','16:10:00',2.82),('9303','2013-04-14','16:15:00',2.65),('9303','2013-04-14','16:20:00',2.58),('9303','2013-04-14','16:25:00',2.6),('9303','2013-04-14','16:30:00',2.51),('9303','2013-04-14','16:35:00',2.4),('9303','2013-04-14','16:40:00',2.3),('9303','2013-04-14','16:45:00',2.19),('9303','2013-04-14','16:50:00',2.13),('9303','2013-04-14','16:55:00',1.99),('9303','2013-04-14','17:00:00',1.89),('9303','2013-04-14','17:05:00',1.83),('9303','2013-04-14','17:10:00',1.76),('9303','2013-04-14','17:15:00',1.67),('9303','2013-04-14','17:20:00',1.6),('9303','2013-04-14','17:25:00',1.51),('9303','2013-04-14','17:30:00',1.44),('9303','2013-04-14','17:35:00',1.34),('9303','2013-04-14','17:40:00',1.25),('9303','2013-04-14','17:45:00',1.18),('9303','2013-04-14','17:50:00',1.09),('9303','2013-04-14','17:55:00',1),('9303','2013-04-13','08:55:00',1.05),('9303','2013-04-13','09:05:00',1.5),('9303','2013-04-13','09:10:00',1.56),('9303','2013-04-13','09:15:00',1.94),('9303','2013-04-13','09:20:00',1.66),('9303','2013-04-13','09:25:00',1.68),('9303','2013-04-13','09:30:00',2.44),('9303','2013-04-13','09:35:00',2.32),('9303','2013-04-13','09:40:00',2.19),('9303','2013-04-13','09:45:00',2.59),('9303','2013-04-13','09:50:00',2.6),('9303','2013-04-13','09:55:00',2.66),('9303','2013-04-13','10:00:00',2.78),('9303','2013-04-13','10:05:00',2.87),('9303','2013-04-13','10:10:00',3.03),('9303','2013-04-13','10:15:00',3.15),('9303','2013-04-13','10:20:00',2.75),('9303','2013-04-13','10:25:00',1.19),('9303','2013-04-13','10:30:00',3.38),('9303','2013-04-13','10:35:00',2.06),('9303','2013-04-13','10:40:00',2.46),('9303','2013-04-13','10:45:00',3.23),('9303','2013-04-13','10:50:00',1.5),('9303','2013-04-13','10:55:00',3.39),('9303','2013-04-13','11:00:00',1.88),('9303','2013-04-13','11:05:00',3.1),('9303','2013-04-13','11:10:00',1.88),('9303','2013-04-13','11:15:00',2.14),('9303','2013-04-13','11:20:00',2.91),('9303','2013-04-13','11:25:00',1.4),('9303','2013-04-13','11:30:00',2.72),('9303','2013-04-13','11:35:00',3.97),('9303','2013-04-13','11:40:00',3.17),('9303','2013-04-13','11:45:00',4.12),('9303','2013-04-13','11:50:00',3.11),('9303','2013-04-13','11:55:00',2.95),('9303','2013-04-13','12:00:00',4.21),('9303','2013-04-13','12:05:00',4.09),('9303','2013-04-13','12:10:00',4.15),('9303','2013-04-13','12:15:00',4.09),('9303','2013-04-13','12:20:00',3.59),('9303','2013-04-13','12:25:00',2.84),('9303','2013-04-13','12:30:00',3.47),('9303','2013-04-13','12:35:00',4.1),('9303','2013-04-13','12:40:00',4.14),('9303','2013-04-13','12:45:00',4.01),('9303','2013-04-13','12:50:00',3.97),('9303','2013-04-13','12:55:00',3.96),('9303','2013-04-13','13:00:00',3.82),('9303','2013-04-13','13:05:00',4.06),('9303','2013-04-13','13:10:00',4.17),('9303','2013-04-13','13:15:00',4.03),('9303','2013-04-13','13:20:00',3.96),('9303','2013-04-13','13:25:00',4.03),('9303','2013-04-13','13:30:00',3.71),('9303','2013-04-13','13:35:00',2.92),('9303','2013-04-13','13:40:00',2.01),('9303','2013-04-13','13:45:00',3.47),('9303','2013-04-13','13:50:00',2.52),('9303','2013-04-13','13:55:00',1.74),('9303','2013-04-13','14:00:00',1.95),('9303','2013-04-13','14:05:00',2.29),('9303','2013-04-13','14:10:00',1.48),('9303','2013-04-13','14:15:00',1.91),('9303','2013-04-13','14:20:00',3.29),('9303','2013-04-13','14:25:00',3.42),('9303','2013-04-13','14:30:00',3.5),('9303','2013-04-13','14:35:00',3.58),('9303','2013-04-13','14:40:00',3.44),('9303','2013-04-13','14:45:00',3.47),('9303','2013-04-13','14:50:00',3.31),('9303','2013-04-13','14:55:00',3.37),('9303','2013-04-13','15:00:00',3.1),('9303','2013-04-13','15:05:00',2.65),('9303','2013-04-13','15:10:00',2.77),('9303','2013-04-13','15:15:00',2.82),('9303','2013-04-13','15:20:00',2.68),('9303','2013-04-13','15:25:00',2.49),('9303','2013-04-13','15:30:00',2.56),('9303','2013-04-13','15:35:00',2.47),('9303','2013-04-13','15:40:00',2.59),('9303','2013-04-13','15:45:00',2.63),('9303','2013-04-13','15:50:00',2.57),('9303','2013-04-13','15:55:00',2.5),('9303','2013-04-13','16:00:00',2.49),('9303','2013-04-13','16:05:00',2.36),('9303','2013-04-13','16:10:00',2.17),('9303','2013-04-13','16:15:00',2.2),('9303','2013-04-13','16:20:00',2.12),('9303','2013-04-13','16:25:00',1.95),('9303','2013-04-13','16:30:00',1.92),('9303','2013-04-13','16:35:00',1.77),('9303','2013-04-13','16:40:00',1.68),('9303','2013-04-13','16:45:00',1.6),('9303','2013-04-13','16:50:00',1.62),('9303','2013-04-13','16:55:00',1.32),('9303','2013-04-13','17:00:00',1.11),('9303','2013-04-13','17:05:00',1.07),('9303','2013-04-13','17:10:00',1.52),('9303','2013-04-13','17:15:00',1.71),('9303','2013-04-13','17:20:00',1.42),('9303','2013-04-13','17:25:00',1.62),('9303','2013-04-13','17:30:00',1.38),('9303','2013-04-13','17:35:00',1.39),('9303','2013-04-13','17:40:00',1.26),('9303','2013-04-13','17:45:00',1.12),('9303','2013-04-13','17:55:00',1.05),('9303','2013-04-12','08:10:00',1.06),('9303','2013-04-12','08:35:00',1.11),('9303','2013-04-12','08:40:00',1.04),('9303','2013-04-12','08:45:00',1.08),('9303','2013-04-12','08:55:00',1.08),('9303','2013-04-12','09:00:00',2.02),('9303','2013-04-12','09:05:00',1.27),('9303','2013-04-12','09:10:00',1.2),('9303','2013-04-12','09:15:00',1.81),('9303','2013-04-12','09:20:00',1.86),('9303','2013-04-12','09:25:00',1.97),('9303','2013-04-12','09:30:00',1.74),('9303','2013-04-12','09:40:00',1.25),('9303','2013-04-12','09:45:00',1.92),('9303','2013-04-12','09:50:00',1.3),('9303','2013-04-12','10:20:00',1.83),('9303','2013-04-12','10:25:00',2.29),('9303','2013-04-12','10:30:00',1.22),('9303','2013-04-12','10:35:00',1.62),('9303','2013-04-12','10:40:00',3.55),('9303','2013-04-12','10:45:00',3.9),('9303','2013-04-12','10:50:00',4.18),('9303','2013-04-12','10:55:00',2.67),('9303','2013-04-12','11:00:00',1.2),('9303','2013-04-12','11:05:00',1.32),('9303','2013-04-12','11:10:00',1.68),('9303','2013-04-12','11:15:00',2.78),('9303','2013-04-12','11:20:00',3.66),('9303','2013-04-12','11:25:00',3.89),('9303','2013-04-12','11:30:00',3.32),('9303','2013-04-12','11:35:00',4.05),('9303','2013-04-12','11:40:00',3.08),('9303','2013-04-12','11:45:00',3.37),('9303','2013-04-12','11:50:00',2.86),('9303','2013-04-12','11:55:00',3.91),('9303','2013-04-12','12:00:00',4.08),('9303','2013-04-12','12:05:00',3.85),('9303','2013-04-12','12:10:00',3.83),('9303','2013-04-12','12:15:00',3.96),('9303','2013-04-12','12:20:00',4.11),('9303','2013-04-12','12:25:00',4.06),('9303','2013-04-12','12:30:00',3.82),('9303','2013-04-12','12:35:00',4.01),('9303','2013-04-12','12:40:00',3.87),('9303','2013-04-12','12:45:00',3.89),('9303','2013-04-12','12:50:00',3.74),('9303','2013-04-12','12:55:00',3.27),('9303','2013-04-12','13:00:00',4.11),('9303','2013-04-12','13:05:00',4.06),('9303','2013-04-12','13:10:00',4.07),('9303','2013-04-12','13:15:00',4.04),('9303','2013-04-12','13:20:00',4.04),('9303','2013-04-12','13:25:00',4),('9303','2013-04-12','13:30:00',4.01),('9303','2013-04-12','13:35:00',4.05),('9303','2013-04-12','13:40:00',3.95),('9303','2013-04-12','13:45:00',3.98),('9303','2013-04-12','13:50:00',3.97),('9303','2013-04-12','13:55:00',3.96),('9303','2013-04-12','14:00:00',3.96),('9303','2013-04-12','14:05:00',3.93),('9303','2013-04-12','14:10:00',3.9),('9303','2013-04-12','14:15:00',3.86),('9303','2013-04-12','14:20:00',3.84),('9303','2013-04-12','14:25:00',3.81),('9303','2013-04-12','14:30:00',3.76),('9303','2013-04-12','14:35:00',3.74),('9303','2013-04-12','14:40:00',3.7),('9303','2013-04-12','14:45:00',3.66),('9303','2013-04-12','14:50:00',3.64),('9303','2013-04-12','14:55:00',3.58),('9303','2013-04-12','15:00:00',3.54),('9303','2013-04-12','15:05:00',3.5),('9303','2013-04-12','15:10:00',3.43),('9303','2013-04-12','15:15:00',3.36),('9303','2013-04-12','15:20:00',3.35),('9303','2013-04-12','15:25:00',3.3),('9303','2013-04-12','15:30:00',3.25),('9303','2013-04-12','15:35:00',3.19),('9303','2013-04-12','15:40:00',3.15),('9303','2013-04-12','15:45:00',3.12),('9303','2013-04-12','15:50:00',3.06),('9303','2013-04-12','15:55:00',2.98),('9303','2013-04-12','16:00:00',2.92),('9303','2013-04-12','16:05:00',2.87),('9303','2013-04-12','16:10:00',2.82),('9303','2013-04-12','16:15:00',2.46),('9303','2013-04-12','16:20:00',2.6),('9303','2013-04-12','16:25:00',2.6),('9303','2013-04-12','16:30:00',1.57),('9303','2013-04-12','16:35:00',1.25),('9303','2013-04-12','16:40:00',1.43),('9303','2013-04-12','16:45:00',2.32),('9303','2013-04-12','16:50:00',2.12),('9303','2013-04-12','16:55:00',2.03),('9303','2013-04-12','17:00:00',1.93),('9303','2013-04-12','17:05:00',1.86),('9303','2013-04-12','17:10:00',1.76),('9303','2013-04-12','17:15:00',1.7),('9303','2013-04-12','17:20:00',1.62),('9303','2013-04-12','17:25:00',1.53),('9303','2013-04-12','17:30:00',1.47),('9303','2013-04-12','17:35:00',1.36),('9303','2013-04-12','17:40:00',1.28),('9303','2013-04-12','17:45:00',1.18),('9303','2013-04-12','17:50:00',1.08),('9303','2013-04-12','17:55:00',1.01),('9303','2014-03-28','07:30:00',1.06),('9303','2014-03-28','07:35:00',1.2),('9303','2014-03-28','07:40:00',1.27),('9303','2014-03-28','07:45:00',1.43),('9303','2014-03-28','07:50:00',1.54),('9303','2014-03-28','07:55:00',1.6),('9303','2014-03-28','08:00:00',1.7),('9303','2014-03-28','08:05:00',1.82),('9303','2014-03-28','08:10:00',1.93),('9303','2014-03-28','08:15:00',2.03),('9303','2014-03-28','08:20:00',2.14),('9303','2014-03-28','08:25:00',2.21),('9303','2014-03-28','08:30:00',2.29),('9303','2014-03-28','08:35:00',2.37),('9303','2014-03-28','08:40:00',2.45),('9303','2014-03-28','08:45:00',2.52),('9303','2014-03-28','08:50:00',2.63),('9303','2014-03-28','08:55:00',2.73),('9303','2014-03-28','09:00:00',2.73),('9303','2014-03-28','09:05:00',2.93),('9303','2014-03-28','09:10:00',3.07),('9303','2014-03-28','09:15:00',3),('9303','2014-03-28','09:20:00',2.68),('9303','2014-03-28','09:25:00',3.14),('9303','2014-03-28','09:30:00',3.35),('9303','2014-03-28','09:35:00',2.72),('9303','2014-03-28','09:40:00',1.99),('9303','2014-03-28','09:45:00',1.75),('9303','2014-03-28','09:50:00',2.12),('9303','2014-03-28','09:55:00',3.49),('9303','2014-03-28','10:00:00',3.66),('9303','2014-03-28','10:05:00',3.56),('9303','2014-03-28','10:10:00',2.79),('9303','2014-03-28','10:15:00',2.76),('9303','2014-03-28','10:20:00',2.62),('9303','2014-03-28','10:25:00',3.69),('9303','2014-03-28','10:30:00',3.7),('9303','2014-03-28','10:35:00',3.51),('9303','2014-03-28','10:40:00',3.44),('9303','2014-03-28','10:45:00',2.61),('9303','2014-03-28','10:50:00',3.9),('9303','2014-03-28','10:55:00',3.99),('9303','2014-03-28','11:00:00',3.42),('9303','2014-03-28','11:05:00',4.02),('9303','2014-03-28','11:10:00',4.06),('9303','2014-03-28','11:15:00',3.29),('9303','2014-03-28','11:20:00',2.63),('9303','2014-03-28','11:25:00',2.95),('9303','2014-03-28','11:30:00',2.01),('9303','2014-03-28','11:35:00',1.73),('9303','2014-03-28','11:40:00',1.36),('9303','2014-03-28','11:45:00',2.17),('9303','2014-03-28','11:50:00',1.32),('9303','2014-03-28','11:55:00',1.19),('9303','2014-03-28','12:00:00',3.32),('9303','2014-03-28','12:05:00',4.44),('9303','2014-03-28','12:10:00',4.41),('9303','2014-03-28','12:15:00',4.61),('9303','2014-03-28','12:20:00',3.27),('9303','2014-03-28','12:35:00',4.22),('9303','2014-03-28','12:40:00',3.83),('9303','2014-03-28','12:45:00',4.26),('9303','2014-03-28','12:50:00',4.29),('9303','2014-03-28','12:55:00',4.59),('9303','2014-03-28','13:00:00',4.17),('9303','2014-03-28','13:05:00',3.16),('9303','2014-03-28','13:10:00',1.49),('9303','2014-03-28','13:15:00',2.75),('9303','2014-03-28','13:20:00',2.65),('9303','2014-03-28','13:25:00',1.69),('9303','2014-03-28','13:30:00',3.51),('9303','2014-03-28','13:35:00',3.73),('9303','2014-03-28','13:40:00',3.77),('9303','2014-03-28','13:45:00',3.99),('9303','2014-03-28','13:50:00',3.8),('9303','2014-03-28','13:55:00',3.72),('9303','2014-03-28','14:00:00',3.78),('9303','2014-03-28','14:05:00',3.73),('9303','2014-03-28','14:10:00',3.56),('9303','2014-03-28','14:15:00',3.61),('9303','2014-03-28','14:20:00',3.56),('9303','2014-03-28','14:25:00',3.51),('9303','2014-03-28','14:30:00',3.46),('9303','2014-03-28','14:35:00',3.41),('9303','2014-03-28','14:40:00',3.36),('9303','2014-03-28','14:45:00',3.27),('9303','2014-03-28','14:50:00',3.23),('9303','2014-03-28','14:55:00',3.19),('9303','2014-03-28','15:00:00',3.18),('9303','2014-03-28','15:05:00',3.08),('9303','2014-03-28','15:10:00',2.99),('9303','2014-03-28','15:15:00',2.9),('9303','2014-03-28','15:20:00',2.83),('9303','2014-03-28','15:25:00',2.74),('9303','2014-03-28','15:30:00',2.7),('9303','2014-03-28','15:35:00',2.63),('9303','2014-03-28','15:40:00',2.51),('9303','2014-03-28','15:45:00',2.47),('9303','2014-03-28','15:50:00',2.35),('9303','2014-03-28','15:55:00',2.3),('9303','2014-03-28','16:00:00',2.36),('9303','2014-03-28','16:05:00',2.4),('9303','2014-03-28','16:10:00',2.3),('9303','2014-03-28','16:15:00',2.15),('9303','2014-03-28','16:20:00',1.84),('9303','2014-03-28','16:25:00',1.6),('9303','2014-03-28','16:30:00',1.26),('9303','2014-03-28','16:45:00',1.01),('9303','2013-04-11','08:15:00',1.05),('9303','2013-04-11','08:20:00',1.14),('9303','2013-04-11','08:25:00',1.25),('9303','2013-04-11','08:30:00',1.34),('9303','2013-04-11','08:35:00',1.44),('9303','2013-04-11','08:40:00',1.51),('9303','2013-04-11','08:45:00',1.62),('9303','2013-04-11','08:50:00',1.7),('9303','2013-04-11','08:55:00',1.79),('9303','2013-04-11','09:00:00',1.88),('9303','2013-04-11','09:05:00',1.96),('9303','2013-04-11','09:10:00',2.03),('9303','2013-04-11','09:15:00',2.1),('9303','2013-04-11','09:20:00',2.17),('9303','2013-04-11','09:25:00',2.25),('9303','2013-04-11','09:30:00',2.3),('9303','2013-04-11','09:35:00',2.37),('9303','2013-04-11','09:40:00',2.46),('9303','2013-04-11','09:45:00',2.6),('9303','2013-04-11','09:50:00',2.64),('9303','2013-04-11','09:55:00',1.82),('9303','2013-04-11','10:00:00',1.45),('9303','2013-04-11','10:05:00',1.62),('9303','2013-04-11','10:10:00',1.6),('9303','2013-04-11','10:15:00',2.92),('9303','2013-04-11','10:20:00',3),('9303','2013-04-11','10:25:00',3.14),('9303','2013-04-11','10:30:00',3.28),('9303','2013-04-11','10:35:00',3.51),('9303','2013-04-11','10:40:00',3.43),('9303','2013-04-11','10:45:00',3.11),('9303','2013-04-11','10:50:00',1.77),('9303','2013-04-11','11:05:00',2.81),('9303','2013-04-11','11:10:00',3.64),('9303','2013-04-11','11:15:00',3.84),('9303','2013-04-11','11:20:00',2.48),('9303','2013-04-11','11:25:00',1.91),('9303','2013-04-11','11:30:00',4.31),('9303','2013-04-11','11:35:00',3.35),('9303','2013-04-11','11:40:00',1.1),('9303','2013-04-11','11:45:00',1.11),('9303','2013-04-11','11:55:00',3.21),('9303','2013-04-11','12:00:00',3.97),('9303','2013-04-11','12:05:00',4.3),('9303','2013-04-11','12:10:00',3.26),('9303','2013-04-11','12:15:00',2.16),('9303','2013-04-11','12:20:00',1.79),('9303','2013-04-11','12:25:00',4.38),('9303','2013-04-11','12:30:00',4.31),('9303','2013-04-11','12:35:00',3.65),('9303','2013-04-11','12:40:00',4.35),('9303','2013-04-11','12:45:00',4.36),('9303','2013-04-11','12:50:00',4.25),('9303','2013-04-11','12:55:00',3.2),('9303','2013-04-11','13:00:00',4.35),('9303','2013-04-11','13:05:00',3.67),('9303','2013-04-11','13:10:00',4.13),('9303','2013-04-11','13:15:00',4.03),('9303','2013-04-11','13:20:00',2.23),('9303','2013-04-11','13:25:00',4.29),('9303','2013-04-11','13:30:00',4.17),('9303','2013-04-11','13:35:00',3.96),('9303','2013-04-11','13:40:00',4.04),('9303','2013-04-11','13:45:00',4.07),('9303','2013-04-11','13:50:00',3.98),('9303','2013-04-11','13:55:00',4.03),('9303','2013-04-11','14:00:00',4.04),('9303','2013-04-11','14:05:00',4.07),('9303','2013-04-11','14:10:00',4.08),('9303','2013-04-11','14:15:00',4.03),('9303','2013-04-11','14:20:00',3.97),('9303','2013-04-11','14:25:00',3.91),('9303','2013-04-11','14:30:00',3.85),('9303','2013-04-11','14:35:00',3.15),('9303','2013-04-11','14:40:00',3.56),('9303','2013-04-11','14:45:00',3.86),('9303','2013-04-11','14:50:00',3.74),('9303','2013-04-11','14:55:00',3.69),('9303','2013-04-11','15:00:00',3.65),('9303','2013-04-11','15:05:00',3.56),('9303','2013-04-11','15:10:00',3.5),('9303','2013-04-11','15:15:00',3.46),('9303','2013-04-11','15:20:00',3.43),('9303','2013-04-11','15:25:00',3.39),('9303','2013-04-11','15:30:00',3.32),('9303','2013-04-11','15:35:00',3.27),('9303','2013-04-11','15:40:00',3.22),('9303','2013-04-11','15:45:00',3.14),('9303','2013-04-11','15:50:00',3.08),('9303','2013-04-11','15:55:00',3.03),('9303','2013-04-11','16:00:00',2.97),('9303','2013-04-11','16:05:00',2.9),('9303','2013-04-11','16:10:00',2.85),('9303','2013-04-11','16:15:00',2.77),('9303','2013-04-11','16:20:00',2.71),('9303','2013-04-11','16:25:00',2.64),('9303','2013-04-11','16:30:00',2.58),('9303','2013-04-11','16:35:00',2.5),('9303','2013-04-11','16:40:00',2.42),('9303','2013-04-11','16:45:00',2.32),('9303','2013-04-11','16:50:00',2.18),('9303','2013-04-11','16:55:00',2.09),('9303','2013-04-11','17:00:00',1.99),('9303','2013-04-11','17:05:00',1.9),('9303','2013-04-11','17:10:00',1.83),('9303','2013-04-11','17:15:00',1.75),('9303','2013-04-11','17:20:00',1.66),('9303','2013-04-11','17:25:00',1.58),('9303','2013-04-11','17:30:00',1.5),('9303','2013-04-11','17:35:00',1.4),('9303','2013-04-11','17:40:00',1.32),('9303','2013-04-11','17:45:00',1.23),('9303','2013-04-11','17:50:00',1.14),('9303','2013-04-11','17:55:00',1.05),('9303','2013-04-10','08:55:00',1.61),('9303','2013-04-10','09:00:00',1.86),('9303','2013-04-10','09:05:00',2),('9303','2013-04-10','09:10:00',2.08),('9303','2013-04-10','09:15:00',2.13),('9303','2013-04-10','09:20:00',2.11),('9303','2013-04-10','09:25:00',2.08),('9303','2013-04-10','09:30:00',2.2),('9303','2013-04-10','09:35:00',2.44),('9303','2013-04-10','09:40:00',2.53),('9303','2013-04-10','09:45:00',2.59),('9303','2013-04-10','09:50:00',2.7),('9303','2013-04-10','09:55:00',2.8),('9303','2013-04-10','10:00:00',2.84),('9303','2013-04-10','10:05:00',2.96),('9303','2013-04-10','10:10:00',3.14),('9303','2013-04-10','10:15:00',2.91),('9303','2013-04-10','10:20:00',3.25),('9303','2013-04-10','10:25:00',3.31),('9303','2013-04-10','10:30:00',3.33),('9303','2013-04-10','10:35:00',3.36),('9303','2013-04-10','10:40:00',3.4),('9303','2013-04-10','10:45:00',3.51),('9303','2013-04-10','10:50:00',3.35),('9303','2013-04-10','10:55:00',3.33),('9303','2013-04-10','11:00:00',3.25),('9303','2013-04-10','11:05:00',3.31),('9303','2013-04-10','11:10:00',3.39),('9303','2013-04-10','11:15:00',3.33),('9303','2013-04-10','11:20:00',3.58),('9303','2013-04-10','11:25:00',3.76),('9303','2013-04-10','11:30:00',3.71),('9303','2013-04-10','11:35:00',3.8),('9303','2013-04-10','11:40:00',3.81),('9303','2013-04-10','11:45:00',3.86),('9303','2013-04-10','11:50:00',3.92),('9303','2013-04-10','11:55:00',3.94),('9303','2013-04-10','12:00:00',3.97),('9303','2013-04-10','12:05:00',4.01),('9303','2013-04-10','12:10:00',4.01),('9303','2013-04-10','12:15:00',4.04),('9303','2013-04-10','12:20:00',4.1),('9303','2013-04-10','12:25:00',4.13),('9303','2013-04-10','12:30:00',4.19),('9303','2013-04-10','12:35:00',4.16),('9303','2013-04-10','12:40:00',4.12),('9303','2013-04-10','12:45:00',4.13),('9303','2013-04-10','12:50:00',3.67),('9303','2013-04-10','12:55:00',3.7),('9303','2013-04-10','13:00:00',3.61),('9303','2013-04-10','13:05:00',3.04),('9303','2013-04-10','13:10:00',2.5),('9303','2013-04-10','13:15:00',2.29),('9303','2013-04-10','13:20:00',3.32),('9303','2013-04-10','13:25:00',3.49),('9303','2013-04-10','13:30:00',3.13),('9303','2013-04-10','13:35:00',4.64),('9303','2013-04-10','13:40:00',2.68),('9303','2013-04-10','13:45:00',2.97),('9303','2013-04-10','13:50:00',3.51),('9303','2013-04-10','13:55:00',4.19),('9303','2013-04-10','14:00:00',3.89),('9303','2013-04-10','14:05:00',4.01),('9303','2013-04-10','14:10:00',4.08),('9303','2013-04-10','14:15:00',4.05),('9303','2013-04-10','14:20:00',4.02),('9303','2013-04-10','14:25:00',4.05),('9303','2013-04-10','14:30:00',4.03),('9303','2013-04-10','14:35:00',3.98),('9303','2013-04-10','14:40:00',3.94),('9303','2013-04-10','14:45:00',3.97),('9303','2013-04-10','14:50:00',3.99),('9303','2013-04-10','14:55:00',3.86),('9303','2013-04-10','15:00:00',3.87),('9303','2013-04-10','15:05:00',3.88),('9303','2013-04-10','15:10:00',3.09),('9303','2013-04-10','15:15:00',3.64),('9303','2013-04-10','15:20:00',3.58),('9303','2013-04-10','15:25:00',3.54),('9303','2013-04-10','15:30:00',3.38),('9303','2013-04-10','15:35:00',3.32),('9303','2013-04-10','15:40:00',2.97),('9303','2013-04-10','15:45:00',3.23),('9303','2013-04-10','15:50:00',3.34),('9303','2013-04-10','15:55:00',2.7),('9303','2013-04-10','16:00:00',3.04),('9303','2013-04-10','16:05:00',1.99),('9303','2013-04-10','16:10:00',2.99),('9303','2013-04-10','16:15:00',2.49),('9303','2013-04-10','16:20:00',2.58),('9303','2013-04-10','16:25:00',2.41),('9303','2013-04-10','16:30:00',2.35),('9303','2013-04-10','16:35:00',1.18),('9303','2013-04-10','16:40:00',2.43),('9303','2013-04-10','16:45:00',2.11),('9303','2013-04-10','16:50:00',2.22),('9303','2013-04-10','16:55:00',1.18),('9303','2013-04-10','17:00:00',2.14),('9303','2013-04-10','17:05:00',1.2),('9303','2013-04-10','17:10:00',1.35),('9303','2013-04-10','17:15:00',1.93),('9303','2013-04-10','17:20:00',1.78),('9303','2013-04-10','17:25:00',1.64),('9303','2013-04-10','17:30:00',1.5),('9303','2013-04-10','17:35:00',1.35),('9303','2013-04-10','17:45:00',1.09),('9303','2013-04-10','17:55:00',1.06),('9303','2013-04-09','08:20:00',1.26),('9303','2013-04-09','09:15:00',1.03),('9303','2013-04-09','09:30:00',1.17),('9303','2013-04-09','09:50:00',2.03),('9303','2013-04-09','09:55:00',3.18),('9303','2013-04-09','10:00:00',1.62),('9303','2013-04-09','10:10:00',1.47),('9303','2013-04-09','10:15:00',2.19),('9303','2013-04-09','10:20:00',1.36),('9303','2013-04-09','10:35:00',2.75),('9303','2013-04-09','10:40:00',2.13),('9303','2013-04-09','10:45:00',2.91),('9303','2013-04-09','10:50:00',4),('9303','2013-04-09','10:55:00',3.04),('9303','2013-04-09','11:00:00',3.45),('9303','2013-04-09','11:05:00',3.32),('9303','2013-04-09','11:10:00',4.03),('9303','2013-04-09','11:15:00',1.71),('9303','2013-04-09','11:25:00',4.2),('9303','2013-04-09','11:30:00',4.04),('9303','2013-04-09','11:35:00',2.99),('9303','2013-04-09','11:45:00',2.75),('9303','2013-04-09','11:50:00',4.52),('9303','2013-04-09','11:55:00',2.21),('9303','2013-04-09','12:00:00',4.51),('9303','2013-04-09','12:05:00',4.31),('9303','2013-04-09','12:10:00',4.33),('9303','2013-04-09','12:15:00',4.37),('9303','2013-04-09','12:20:00',2.78),('9303','2013-04-09','12:25:00',4.27),('9303','2013-04-09','12:30:00',4.19),('9303','2013-04-09','12:35:00',4.01),('9303','2013-04-09','12:40:00',4.35),('9303','2013-04-09','12:45:00',4),('9303','2013-04-09','12:50:00',4.45),('9303','2013-04-09','12:55:00',4.41),('9303','2013-04-09','13:00:00',4.4),('9303','2013-04-09','13:05:00',4.52),('9303','2013-04-09','13:10:00',4.61),('9303','2013-04-09','13:15:00',4.54),('9303','2013-04-09','13:20:00',3.15),('9303','2013-04-09','13:25:00',4.54),('9303','2013-04-09','13:30:00',3.24),('9303','2013-04-09','13:35:00',1.24),('9303','2013-04-09','13:40:00',2.2),('9303','2013-04-09','13:45:00',1.42),('9303','2013-04-09','13:50:00',3.57),('9303','2013-04-09','13:55:00',4.13),('9303','2013-04-09','14:00:00',3.92),('9303','2013-04-09','14:05:00',3.15),('9303','2013-04-09','14:10:00',3.02),('9303','2013-04-09','14:15:00',3.87),('9303','2013-04-09','14:20:00',1.74),('9303','2013-04-09','14:25:00',2.99),('9303','2013-04-09','14:30:00',3.78),('9303','2013-04-09','14:35:00',3.65),('9303','2013-04-09','14:40:00',3.76),('9303','2013-04-09','14:45:00',3.49),('9303','2013-04-09','14:50:00',3.39),('9303','2013-04-09','14:55:00',3.06),('9303','2013-04-09','15:00:00',2.77),('9303','2013-04-09','15:05:00',3.43),('9303','2013-04-09','15:10:00',3.8),('9303','2013-04-09','15:15:00',2.83),('9303','2013-04-09','15:20:00',3.69),('9303','2013-04-09','15:25:00',3.69),('9303','2013-04-09','15:30:00',3.01),('9303','2013-04-09','15:35:00',2.65),('9303','2013-04-09','15:40:00',3.51),('9303','2013-04-09','15:45:00',2.69),('9303','2013-04-09','15:50:00',3.17),('9303','2013-04-09','15:55:00',2.78),('9303','2013-04-09','16:00:00',2.56),('9303','2013-04-09','16:05:00',2.63),('9303','2013-04-09','16:10:00',2.9),('9303','2013-04-09','16:15:00',2.26),('9303','2013-04-09','16:20:00',1.56),('9303','2013-04-09','16:35:00',1.21),('9303','2013-04-09','16:40:00',1.27),('9303','2013-04-09','16:50:00',1.95),('9303','2013-04-09','16:55:00',1.93),('9303','2013-04-09','17:30:00',1.14),('9303','2013-04-08','08:40:00',1.07),('9303','2013-04-08','08:45:00',1.28),('9303','2013-04-08','08:50:00',1.18),('9303','2013-04-08','08:55:00',1.18),('9303','2013-04-08','09:00:00',1.19),('9303','2013-04-08','09:05:00',1.39),('9303','2013-04-08','09:10:00',1.91),('9303','2013-04-08','09:15:00',2.01),('9303','2013-04-08','09:20:00',1.97),('9303','2013-04-08','09:25:00',1.66),('9303','2013-04-08','09:30:00',2.52),('9303','2013-04-08','09:35:00',2.61),('9303','2013-04-08','09:40:00',2.7),('9303','2013-04-08','09:45:00',2.74),('9303','2013-04-08','09:50:00',1.84),('9303','2013-04-08','09:55:00',1.48),('9303','2013-04-08','10:00:00',2.9),('9303','2013-04-08','10:05:00',3.08),('9303','2013-04-08','10:10:00',2.99),('9303','2013-04-08','10:15:00',3.07),('9303','2013-04-08','10:20:00',3.09),('9303','2013-04-08','10:25:00',3.09),('9303','2013-04-08','10:30:00',3.11),('9303','2013-04-08','10:35:00',2.96),('9303','2013-04-08','10:40:00',3.27),('9303','2013-04-08','10:45:00',3.43),('9303','2013-04-08','10:50:00',3.47),('9303','2013-04-08','10:55:00',3.34),('9303','2013-04-08','11:00:00',3.52),('9303','2013-04-08','11:05:00',3.12),('9303','2013-04-08','11:10:00',2.71),('9303','2013-04-08','11:15:00',2.75),('9303','2013-04-08','11:20:00',2.25),('9303','2013-04-08','11:25:00',1.91),('9303','2013-04-08','11:30:00',2.1),('9303','2013-04-08','11:35:00',2.74),('9303','2013-04-08','11:40:00',2.96),('9303','2013-04-08','11:45:00',2.74),('9303','2013-04-08','11:50:00',2.57),('9303','2013-04-08','11:55:00',2.2),('9303','2013-04-08','12:00:00',2.09),('9303','2013-04-08','12:05:00',1.96),('9303','2013-04-08','12:10:00',2.1),('9303','2013-04-08','12:15:00',2.53),('9303','2013-04-08','12:20:00',2.55),('9303','2013-04-08','12:25:00',2.62),('9303','2013-04-08','12:30:00',2.85),('9303','2013-04-08','12:35:00',2.76),('9303','2013-04-08','12:40:00',2.24),('9303','2013-04-08','12:45:00',3.32),('9303','2013-04-08','12:50:00',3.07),('9303','2013-04-08','12:55:00',3.09),('9303','2013-04-08','13:00:00',1.81),('9303','2013-04-08','13:05:00',2.41),('9303','2013-04-08','13:10:00',2.66),('9303','2013-04-08','13:15:00',2.67),('9303','2013-04-08','13:20:00',3.48),('9303','2013-04-08','13:25:00',3.08),('9303','2013-04-08','13:30:00',2.68),('9303','2013-04-08','13:35:00',2.96),('9303','2013-04-08','13:40:00',2.95),('9303','2013-04-08','13:45:00',2.86),('9303','2013-04-08','13:50:00',2.87),('9303','2013-04-08','13:55:00',3.76),('9303','2013-04-08','14:00:00',3.67),('9303','2013-04-08','14:05:00',3.07),('9303','2013-04-08','14:10:00',3.18),('9303','2013-04-08','14:15:00',3.62),('9303','2013-04-08','14:20:00',3.22),('9303','2013-04-08','14:25:00',3.82),('9303','2013-04-08','14:30:00',3.67),('9303','2013-04-08','14:35:00',3.45),('9303','2013-04-08','14:40:00',3.43),('9303','2013-04-08','14:45:00',3.52),('9303','2013-04-08','14:50:00',3.52),('9303','2013-04-08','14:55:00',3.69),('9303','2013-04-08','15:00:00',2.88),('9303','2013-04-08','15:05:00',2.81),('9303','2013-04-08','15:10:00',2.7),('9303','2013-04-08','15:15:00',2.86),('9303','2013-04-08','15:20:00',2.44),('9303','2013-04-08','15:25:00',3.37),('9303','2013-04-08','15:30:00',3.5),('9303','2013-04-08','15:35:00',3.36),('9303','2013-04-08','15:40:00',3.29),('9303','2013-04-08','15:45:00',3.17),('9303','2013-04-08','15:50:00',3.15),('9303','2013-04-08','15:55:00',3.07),('9303','2013-04-08','16:00:00',3),('9303','2013-04-08','16:05:00',2.83),('9303','2013-04-08','16:10:00',2.62),('9303','2013-04-08','16:15:00',2.8),('9303','2013-04-08','16:20:00',2.8),('9303','2013-04-08','16:25:00',2.66),('9303','2013-04-08','16:30:00',2.57),('9303','2013-04-08','16:35:00',2.5),('9303','2013-04-08','16:40:00',2.43),('9303','2013-04-08','16:45:00',2.33),('9303','2013-04-08','16:50:00',2.23),('9303','2013-04-08','16:55:00',2.11),('9303','2013-04-08','17:00:00',2.03),('9303','2013-04-08','17:05:00',1.96),('9303','2013-04-08','17:10:00',1.83),('9303','2013-04-08','17:15:00',1.78),('9303','2013-04-08','17:20:00',1.64),('9303','2013-04-08','17:25:00',1.66),('9303','2013-04-08','17:30:00',1.53),('9303','2013-04-08','17:35:00',1.4),('9303','2013-04-08','17:40:00',1.24),('9303','2013-04-08','17:45:00',1.13),('9303','2013-04-07','08:35:00',1.08),('9303','2013-04-07','08:40:00',1.16),('9303','2013-04-07','08:45:00',1.21),('9303','2013-04-07','08:50:00',1.22),('9303','2013-04-07','08:55:00',1.28),('9303','2013-04-07','09:00:00',1.28),('9303','2013-04-07','09:05:00',1.3),('9303','2013-04-07','09:10:00',1.41),('9303','2013-04-07','09:15:00',1.42),('9303','2013-04-07','09:20:00',1.47),('9303','2013-04-07','09:25:00',1.48),('9303','2013-04-07','09:30:00',1.42),('9303','2013-04-07','09:35:00',1.32),('9303','2013-04-07','09:40:00',1.35),('9303','2013-04-07','09:45:00',1.7),('9303','2013-04-07','09:50:00',1.94),('9303','2013-04-07','09:55:00',2.09),('9303','2013-04-07','10:00:00',2.46),('9303','2013-04-07','10:05:00',2.57),('9303','2013-04-07','10:10:00',2.56),('9303','2013-04-07','10:15:00',2.68),('9303','2013-04-07','10:20:00',2.69),('9303','2013-04-07','10:25:00',2.74),('9303','2013-04-07','10:30:00',2.37),('9303','2013-04-07','10:35:00',2.58),('9303','2013-04-07','10:40:00',2.59),('9303','2013-04-07','10:45:00',2.53),('9303','2013-04-07','10:50:00',2.47),('9303','2013-04-07','10:55:00',2.19),('9303','2013-04-07','11:00:00',2.01),('9303','2013-04-07','11:05:00',1.71),('9303','2013-04-07','11:10:00',1.98),('9303','2013-04-07','11:15:00',2.72),('9303','2013-04-07','11:20:00',3.21),('9303','2013-04-07','11:25:00',3.59),('9303','2013-04-07','11:30:00',3.49),('9303','2013-04-07','11:35:00',3.26),('9303','2013-04-07','11:40:00',2.96),('9303','2013-04-07','11:45:00',2.35),('9303','2013-04-07','11:50:00',2.14),('9303','2013-04-07','11:55:00',2.31),('9303','2013-04-07','12:00:00',2.36),('9303','2013-04-07','12:05:00',2.3),('9303','2013-04-07','12:10:00',2.49),('9303','2013-04-07','12:15:00',2.42),('9303','2013-04-07','12:20:00',2.62),('9303','2013-04-07','12:25:00',2.91),('9303','2013-04-07','12:30:00',2.58),('9303','2013-04-07','12:35:00',2.72),('9303','2013-04-07','12:40:00',2.69),('9303','2013-04-07','12:45:00',2.29),('9303','2013-04-07','12:50:00',2.46),('9303','2013-04-07','12:55:00',2.52),('9303','2013-04-07','13:00:00',2.99),('9303','2013-04-07','13:05:00',3.39),('9303','2013-04-07','13:10:00',3.27),('9303','2013-04-07','13:15:00',2.91),('9303','2013-04-07','13:20:00',2.69),('9303','2013-04-07','13:25:00',3.08),('9303','2013-04-07','13:30:00',3.16),('9303','2013-04-07','13:35:00',2.92),('9303','2013-04-07','13:40:00',3.16),('9303','2013-04-07','13:45:00',3.27),('9303','2013-04-07','13:50:00',2.98),('9303','2013-04-07','13:55:00',2.75),('9303','2013-04-07','14:00:00',3.48),('9303','2013-04-07','14:05:00',3.24),('9303','2013-04-07','14:10:00',2.05),('9303','2013-04-07','14:15:00',2.33),('9303','2013-04-07','14:20:00',2.16),('9303','2013-04-07','14:25:00',2.08),('9303','2013-04-07','14:30:00',1.91),('9303','2013-04-07','14:35:00',2.26),('9303','2013-04-07','14:40:00',1.97),('9303','2013-04-07','14:45:00',1.94),('9303','2013-04-07','14:50:00',2.32),('9303','2013-04-07','14:55:00',2.15),('9303','2013-04-07','15:00:00',2.13),('9303','2013-04-07','15:05:00',2.77),('9303','2013-04-07','15:10:00',2.74),('9303','2013-04-07','15:15:00',2.79),('9303','2013-04-07','15:20:00',2.77),('9303','2013-04-07','15:25:00',2.85),('9303','2013-04-07','15:30:00',2.86),('9303','2013-04-07','15:35:00',2.83),('9303','2013-04-07','15:40:00',2.74),('9303','2013-04-07','15:45:00',2.56),('9303','2013-04-07','15:50:00',2.38),('9303','2013-04-07','15:55:00',2.36),('9303','2013-04-07','16:00:00',2.29),('9303','2013-04-07','16:05:00',1.98),('9303','2013-04-07','16:10:00',1.66),('9303','2013-04-07','16:15:00',1.48),('9303','2013-04-07','16:20:00',1.43),('9303','2013-04-07','16:25:00',1.27),('9303','2013-04-07','16:30:00',1.32),('9303','2013-04-07','16:35:00',1.57),('9303','2013-04-07','16:40:00',1.65),('9303','2013-04-07','16:45:00',1.98),('9303','2013-04-07','16:50:00',2.03),('9303','2013-04-07','16:55:00',1.96),('9303','2013-04-07','17:00:00',1.77),('9303','2013-04-07','17:05:00',1.59),('9303','2013-04-07','17:20:00',1.58),('9303','2013-04-07','17:25:00',1.73),('9303','2013-04-07','17:30:00',1.6),('9303','2013-04-07','17:35:00',1.49),('9303','2013-04-07','17:40:00',1.48),('9303','2013-04-07','17:45:00',1.38),('9303','2013-04-07','17:50:00',1.24),('9303','2013-04-07','17:55:00',1),('9303','2013-04-06','08:20:00',1.07),('9303','2013-04-06','08:25:00',1.17),('9303','2013-04-06','08:30:00',1.26),('9303','2013-04-06','08:35:00',1.36),('9303','2013-04-06','08:40:00',1.47),('9303','2013-04-06','08:45:00',1.54),('9303','2013-04-06','08:50:00',1.65),('9303','2013-04-06','08:55:00',1.76),('9303','2013-04-06','09:00:00',1.83),('9303','2013-04-06','09:05:00',1.92),('9303','2013-04-06','09:10:00',1.99),('9303','2013-04-06','09:15:00',2.08),('9303','2013-04-06','09:20:00',2.18),('9303','2013-04-06','09:25:00',2.25),('9303','2013-04-06','09:30:00',2.33),('9303','2013-04-06','09:35:00',2.34),('9303','2013-04-06','09:40:00',2.46),('9303','2013-04-06','09:45:00',2.54),('9303','2013-04-06','09:50:00',2.59),('9303','2013-04-06','09:55:00',2.68),('9303','2013-04-06','10:00:00',2.73),('9303','2013-04-06','10:05:00',2.82),('9303','2013-04-06','10:10:00',2.84),('9303','2013-04-06','10:15:00',2.94),('9303','2013-04-06','10:20:00',3.01),('9303','2013-04-06','10:25:00',3.03),('9303','2013-04-06','10:30:00',3.07),('9303','2013-04-06','10:35:00',3.14),('9303','2013-04-06','10:40:00',3.17),('9303','2013-04-06','10:45:00',3.21),('9303','2013-04-06','10:50:00',3.27),('9303','2013-04-06','10:55:00',3.31),('9303','2013-04-06','11:00:00',3.39),('9303','2013-04-06','11:05:00',3.42),('9303','2013-04-06','11:10:00',2.95),('9303','2013-04-06','11:15:00',3.52),('9303','2013-04-06','11:20:00',3.2),('9303','2013-04-06','11:25:00',3.6),('9303','2013-04-06','11:30:00',3.6),('9303','2013-04-06','11:35:00',3.64),('9303','2013-04-06','11:40:00',3.67),('9303','2013-04-06','11:45:00',3.7),('9303','2013-04-06','11:50:00',3.72),('9303','2013-04-06','11:55:00',3.77),('9303','2013-04-06','12:00:00',3.74),('9303','2013-04-06','12:05:00',3.77),('9303','2013-04-06','12:10:00',3.79),('9303','2013-04-06','12:15:00',3.86),('9303','2013-04-06','12:20:00',3.77),('9303','2013-04-06','12:25:00',3.8),('9303','2013-04-06','12:30:00',3.97),('9303','2013-04-06','12:35:00',4.02),('9303','2013-04-06','12:40:00',4),('9303','2013-04-06','12:45:00',4.02),('9303','2013-04-06','12:50:00',3.99),('9303','2013-04-06','12:55:00',4.01),('9303','2013-04-06','13:00:00',4.06),('9303','2013-04-06','13:05:00',3.58),('9303','2013-04-06','13:10:00',3.21),('9303','2013-04-06','13:15:00',4.3),('9303','2013-04-06','13:20:00',2.27),('9303','2013-04-06','13:30:00',2.29),('9303','2013-04-06','13:35:00',4.39),('9303','2013-04-06','13:40:00',4.6),('9303','2013-04-06','13:45:00',4.57),('9303','2013-04-06','13:50:00',4.29),('9303','2013-04-06','13:55:00',2.75),('9303','2013-04-06','14:00:00',1.04),('9303','2013-04-06','14:05:00',1.94),('9303','2013-04-06','14:10:00',1.05),('9303','2013-04-06','14:15:00',4.21),('9303','2013-04-06','14:20:00',2.68),('9303','2013-04-06','14:25:00',1.51),('9303','2013-04-06','14:30:00',2.62),('9303','2013-04-06','14:35:00',2.41),('9303','2013-04-06','14:40:00',3.98),('9303','2013-04-06','14:45:00',3.79),('9303','2013-04-06','14:50:00',3.72),('9303','2013-04-06','14:55:00',3.82),('9303','2013-04-06','15:00:00',3.7),('9303','2013-04-06','15:05:00',3.62),('9303','2013-04-06','15:10:00',3.4),('9303','2013-04-06','15:15:00',3.4),('9303','2013-04-06','15:20:00',3.36),('9303','2013-04-06','15:25:00',3.32),('9303','2013-04-06','15:30:00',3.15),('9303','2013-04-06','15:35:00',3.13),('9303','2013-04-06','15:40:00',3.11),('9303','2013-04-06','15:45:00',2.81),('9303','2013-04-06','15:50:00',2.81),('9303','2013-04-06','15:55:00',3),('9303','2013-04-06','16:00:00',2.74),('9303','2013-04-06','16:05:00',2.91),('9303','2013-04-06','16:10:00',2.86),('9303','2013-04-06','16:15:00',2.63),('9303','2013-04-06','16:20:00',2.15),('9303','2013-04-06','16:25:00',1.76),('9303','2013-04-06','16:30:00',2.16),('9303','2013-04-06','16:35:00',2.09),('9303','2013-04-06','16:40:00',1.65),('9303','2013-04-06','16:45:00',2.17),('9303','2013-04-06','16:50:00',2.03),('9303','2013-04-06','16:55:00',1.8),('9303','2013-04-06','17:00:00',1.78),('9303','2013-04-06','17:05:00',1.56),('9303','2013-04-06','17:10:00',1.32),('9303','2013-04-06','17:15:00',1.03),('9303','2013-04-05','08:20:00',1.14),('9303','2013-04-05','08:55:00',1.16),('9303','2013-04-05','09:05:00',2.27),('9303','2013-04-05','09:10:00',1.13),('9303','2013-04-05','09:15:00',2.35),('9303','2013-04-05','09:20:00',2.02),('9303','2013-04-05','09:35:00',1.13),('9303','2013-04-05','09:40:00',2.26),('9303','2013-04-05','09:45:00',2.02),('9303','2013-04-05','09:50:00',1.14),('9303','2013-04-05','10:00:00',1.22),('9303','2013-04-05','10:10:00',2.25),('9303','2013-04-05','10:15:00',3.18),('9303','2013-04-05','10:20:00',1.31),('9303','2013-04-05','10:25:00',2.63),('9303','2013-04-05','10:30:00',2.43),('9303','2013-04-05','10:35:00',2.16),('9303','2013-04-05','10:40:00',3.83),('9303','2013-04-05','10:45:00',1.93),('9303','2013-04-05','10:50:00',1.73),('9303','2013-04-05','10:55:00',2.69),('9303','2013-04-05','11:00:00',2.63),('9303','2013-04-05','11:05:00',3.07),('9303','2013-04-05','11:10:00',3.58),('9303','2013-04-05','11:15:00',3.7),('9303','2013-04-05','11:20:00',2.97),('9303','2013-04-05','11:25:00',2.99),('9303','2013-04-05','11:30:00',3.08),('9303','2013-04-05','11:35:00',3.16),('9303','2013-04-05','11:40:00',3.63),('9303','2013-04-05','11:45:00',3.23),('9303','2013-04-05','11:50:00',3.34),('9303','2013-04-05','11:55:00',3.62),('9303','2013-04-05','12:00:00',4),('9303','2013-04-05','12:05:00',3.31),('9303','2013-04-05','12:10:00',2.62),('9303','2013-04-05','12:15:00',1.8),('9303','2013-04-05','12:20:00',1.38),('9303','2013-04-05','12:25:00',2.02),('9303','2013-04-05','12:30:00',1.17),('9303','2013-04-05','12:35:00',1.19),('9303','2013-04-05','12:40:00',1.52),('9303','2013-04-05','12:45:00',3.2),('9303','2013-04-05','12:50:00',4.22),('9303','2013-04-05','12:55:00',4.49),('9303','2013-04-05','13:00:00',2.68),('9303','2013-04-05','13:05:00',3.92),('9303','2013-04-05','13:10:00',2.11),('9303','2013-04-05','13:15:00',2.59),('9303','2013-04-05','13:20:00',2.42),('9303','2013-04-05','13:25:00',2.82),('9303','2013-04-05','13:30:00',2.89),('9303','2013-04-05','13:35:00',3.04),('9303','2013-04-05','13:40:00',4.12),('9303','2013-04-05','13:45:00',3.03),('9303','2013-04-05','13:50:00',4.52),('9303','2013-04-05','13:55:00',3.68),('9303','2013-04-05','14:00:00',2.61),('9303','2013-04-05','14:05:00',4.55),('9303','2013-04-05','14:10:00',3.48),('9303','2013-04-05','14:15:00',3.64),('9303','2013-04-05','14:20:00',4.07),('9303','2013-04-05','14:25:00',3.52),('9303','2013-04-05','14:30:00',3.86),('9303','2013-04-05','14:35:00',4.03),('9303','2013-04-05','14:40:00',4.11),('9303','2013-04-05','14:45:00',3.31),('9303','2013-04-05','14:50:00',2.09),('9303','2013-04-05','14:55:00',4.15),('9303','2013-04-05','15:00:00',3.37),('9303','2013-04-05','15:05:00',3.44),('9303','2013-04-05','15:10:00',2.66),('9303','2013-04-05','15:15:00',1.54),('9303','2013-04-05','15:20:00',1.6),('9303','2013-04-05','15:25:00',1.79),('9303','2013-04-05','15:30:00',1.55),('9303','2013-04-05','15:35:00',1.27),('9303','2013-04-05','15:40:00',1.04),('9303','2013-04-05','15:45:00',1.29),('9303','2013-04-05','15:50:00',1.61),('9303','2013-04-05','15:55:00',1.51),('9303','2013-04-05','16:00:00',1.62),('9303','2013-04-05','16:05:00',1.48),('9303','2013-04-05','16:10:00',1.42),('9303','2013-04-05','16:15:00',2.08),('9303','2013-04-05','16:20:00',1.8),('9303','2013-04-05','16:25:00',1.51),('9303','2013-04-05','16:30:00',1.39),('9303','2013-04-05','16:35:00',1.54),('9303','2013-04-05','16:40:00',1.36),('9303','2013-04-05','16:45:00',2.03),('9303','2013-04-05','16:50:00',2.65),('9303','2013-04-05','16:55:00',1.44),('9303','2013-04-05','17:00:00',1.42),('9303','2013-04-05','17:05:00',1.02),('9303','2013-04-05','17:10:00',1.75),('9303','2013-04-05','17:15:00',1.5),('9303','2013-04-05','17:20:00',1.21),('9303','2013-04-05','17:25:00',1.04),('9303','2013-04-05','17:30:00',1.87),('9303','2013-04-05','17:35:00',1.16),('9303','2013-04-05','17:55:00',1.37),('9303','2013-04-05','18:00:00',1.15),('9303','2013-04-04','08:55:00',1.19),('9303','2013-04-04','09:00:00',1.82),('9303','2013-04-04','09:05:00',1.32),('9303','2013-04-04','09:10:00',1.17),('9303','2013-04-04','09:15:00',1.12),('9303','2013-04-04','09:20:00',1.25),('9303','2013-04-04','09:30:00',1.38),('9303','2013-04-04','09:35:00',2.33),('9303','2013-04-04','09:40:00',2.19),('9303','2013-04-04','09:45:00',1.87),('9303','2013-04-04','09:50:00',1.03),('9303','2013-04-04','09:55:00',1.1),('9303','2013-04-04','10:00:00',1.67),('9303','2013-04-04','10:05:00',2.28),('9303','2013-04-04','10:10:00',2.11),('9303','2013-04-04','10:15:00',1.49),('9303','2013-04-04','10:20:00',1.53),('9303','2013-04-04','10:25:00',2.99),('9303','2013-04-04','10:30:00',3.02),('9303','2013-04-04','10:35:00',1.85),('9303','2013-04-04','10:40:00',3.68),('9303','2013-04-04','10:45:00',2.01),('9303','2013-04-04','10:50:00',2.26),('9303','2013-04-04','10:55:00',3.39),('9303','2013-04-04','11:00:00',2.01),('9303','2013-04-04','11:05:00',1.12),('9303','2013-04-04','11:15:00',1.31),('9303','2013-04-04','11:20:00',1.27),('9303','2013-04-04','11:30:00',1.05),('9303','2013-04-04','11:35:00',1.5),('9303','2013-04-04','11:40:00',2.62),('9303','2013-04-04','11:45:00',3.21),('9303','2013-04-04','11:50:00',3.66),('9303','2013-04-04','11:55:00',3.87),('9303','2013-04-04','12:00:00',3.88),('9303','2013-04-04','12:05:00',3.76),('9303','2013-04-04','12:10:00',3.81),('9303','2013-04-04','12:15:00',3.72),('9303','2013-04-04','12:20:00',3.33),('9303','2013-04-04','12:25:00',2.94),('9303','2013-04-04','12:30:00',3.04),('9303','2013-04-04','12:35:00',1.96),('9303','2013-04-04','12:40:00',3.86),('9303','2013-04-04','12:45:00',3),('9303','2013-04-04','12:50:00',3.97),('9303','2013-04-04','12:55:00',3.67),('9303','2013-04-04','13:00:00',3.63),('9303','2013-04-04','13:05:00',3.7),('9303','2013-04-04','13:10:00',3.83),('9303','2013-04-04','13:15:00',3.98),('9303','2013-04-04','13:20:00',3.86),('9303','2013-04-04','13:25:00',3.97),('9303','2013-04-04','13:30:00',3.89),('9303','2013-04-04','13:35:00',3.59),('9303','2013-04-04','13:40:00',3.05),('9303','2013-04-04','13:45:00',3.1),('9303','2013-04-04','13:50:00',2.99),('9303','2013-04-04','13:55:00',2.31),('9303','2013-04-04','14:00:00',2.42),('9303','2013-04-04','14:05:00',3.2),('9303','2013-04-04','14:10:00',3.73),('9303','2013-04-04','14:15:00',3.71),('9303','2013-04-04','14:20:00',3.65),('9303','2013-04-04','14:25:00',3.59),('9303','2013-04-04','14:30:00',3.57),('9303','2013-04-04','14:35:00',3.53),('9303','2013-04-04','14:40:00',3.54),('9303','2013-04-04','14:45:00',3.51),('9303','2013-04-04','14:50:00',3.46),('9303','2013-04-04','14:55:00',3.43),('9303','2013-04-04','15:00:00',3.36),('9303','2013-04-04','15:05:00',3.26),('9303','2013-04-04','15:10:00',3.11),('9303','2013-04-04','15:15:00',3.06),('9303','2013-04-04','15:20:00',3.13),('9303','2013-04-04','15:25:00',3.14),('9303','2013-04-04','15:30:00',3.12),('9303','2013-04-04','15:35:00',3.04),('9303','2013-04-04','15:40:00',2.95),('9303','2013-04-04','15:45:00',2.91),('9303','2013-04-04','15:50:00',2.79),('9303','2013-04-04','15:55:00',2.74),('9303','2013-04-04','16:00:00',2.69),('9303','2013-04-04','16:05:00',2.61),('9303','2013-04-04','16:10:00',2.45),('9303','2013-04-04','16:15:00',2.35),('9303','2013-04-04','16:20:00',2.18),('9303','2013-04-04','16:25:00',2.15),('9303','2013-04-04','16:30:00',1.67),('9303','2013-04-04','16:35:00',1.78),('9303','2013-04-04','16:40:00',1.73),('9303','2013-04-04','16:45:00',1.63),('9303','2013-04-04','16:50:00',1.4),('9303','2013-04-04','16:55:00',1.67),('9303','2013-04-04','17:00:00',1.53),('9303','2013-04-04','17:05:00',1.51),('9303','2013-04-04','17:10:00',1.44),('9303','2013-04-04','17:15:00',1.27),('9303','2013-04-03','08:20:00',1.01),('9303','2013-04-03','08:25:00',1.14),('9303','2013-04-03','08:30:00',1.35),('9303','2013-04-03','08:35:00',1.58),('9303','2013-04-03','08:40:00',1.28),('9303','2013-04-03','08:45:00',1.54),('9303','2013-04-03','08:55:00',1.41),('9303','2013-04-03','09:00:00',1.76),('9303','2013-04-03','09:05:00',1.69),('9303','2013-04-03','09:10:00',2.19),('9303','2013-04-03','09:15:00',2.32),('9303','2013-04-03','09:20:00',1.81),('9303','2013-04-03','09:25:00',1.35),('9303','2013-04-03','09:30:00',2.04),('9303','2013-04-03','09:35:00',2.16),('9303','2013-04-03','09:40:00',2.6),('9303','2013-04-03','09:47:00',2.29),('9303','2013-04-03','09:50:00',3.05),('9303','2013-04-03','09:55:00',3.22),('9303','2013-04-03','10:00:00',3.03),('9303','2013-04-03','10:05:00',1.13),('9303','2013-04-03','10:10:00',1.19),('9303','2013-04-03','10:15:00',1.48),('9303','2013-04-03','10:20:00',3.12),('9303','2013-04-03','10:25:00',3.07),('9303','2013-04-03','10:30:00',2.39),('9303','2013-04-03','10:35:00',2.07),('9303','2013-04-03','10:40:00',1.64),('9303','2013-04-03','10:45:00',1.4),('9303','2013-04-03','10:50:00',1.84),('9303','2013-04-03','10:55:00',2.67),('9303','2013-04-03','11:00:00',2.41),('9303','2013-04-03','11:05:00',4.66),('9303','2013-04-03','11:10:00',1.87),('9303','2013-04-03','11:15:00',2.97),('9303','2013-04-03','11:20:00',2.73),('9303','2013-04-03','11:25:00',2.35),('9303','2013-04-03','11:30:00',1.57),('9303','2013-04-03','11:35:00',1.58),('9303','2013-04-03','11:40:00',1.87),('9303','2013-04-03','11:45:00',1.38),('9303','2013-04-03','11:50:00',2.81),('9303','2013-04-03','11:55:00',2.15),('9303','2013-04-03','12:00:00',3.73),('9303','2013-04-03','12:05:00',3.58),('9303','2013-04-03','12:10:00',3.11),('9303','2013-04-03','12:15:00',2.05),('9303','2013-04-03','12:20:00',3.57),('9303','2013-04-03','12:25:00',3.44),('9303','2013-04-03','12:30:00',3.28),('9303','2013-04-03','12:35:00',3.59),('9303','2013-04-03','12:40:00',3.23),('9303','2013-04-03','12:45:00',3.6),('9303','2013-04-03','12:50:00',4.69),('9303','2013-04-03','12:55:00',3.57),('9303','2013-04-03','13:00:00',3.87),('9303','2013-04-03','13:05:00',3.38),('9303','2013-04-03','13:10:00',2.39),('9303','2013-04-03','13:15:00',4.28),('9303','2013-04-03','13:20:00',3.04),('9303','2013-04-03','13:25:00',2.56),('9303','2013-04-03','13:30:00',2.34),('9303','2013-04-03','13:35:00',3.62),('9303','2013-04-03','13:40:00',3.42),('9303','2013-04-03','13:45:00',3.64),('9303','2013-04-03','13:50:00',2.94),('9303','2013-04-03','13:55:00',3.84),('9303','2013-04-03','14:00:00',4.29),('9303','2013-04-03','14:05:00',3.55),('9303','2013-04-03','14:10:00',2.64),('9303','2013-04-03','14:15:00',3.14),('9303','2013-04-03','14:20:00',1.98),('9303','2013-04-03','14:25:00',3.34),('9303','2013-04-03','14:30:00',3.58),('9303','2013-04-03','14:35:00',3.87),('9303','2013-04-03','14:40:00',3.83),('9303','2013-04-03','14:45:00',3.34),('9303','2013-04-03','14:50:00',1.54),('9303','2013-04-03','14:55:00',2.72),('9303','2013-04-03','15:00:00',4.09),('9303','2013-04-03','15:05:00',4.09),('9303','2013-04-03','15:10:00',3.86),('9303','2013-04-03','15:15:00',4),('9303','2013-04-03','15:20:00',3.77),('9303','2013-04-03','15:25:00',3.85),('9303','2013-04-03','15:30:00',3.61),('9303','2013-04-03','15:35:00',3.44),('9303','2013-04-03','15:40:00',3.72),('9303','2013-04-03','15:45:00',3.09),('9303','2013-04-03','15:50:00',3.35),('9303','2013-04-03','15:55:00',3.12),('9303','2013-04-03','16:00:00',3.37),('9303','2013-04-03','16:05:00',3.19),('9303','2013-04-03','16:10:00',3.07),('9303','2013-04-03','16:15:00',3.04),('9303','2013-04-03','16:20:00',2.95),('9303','2013-04-03','16:25:00',2.88),('9303','2013-04-03','16:30:00',2.66),('9303','2013-04-03','16:35:00',2.46),('9303','2013-04-03','16:40:00',2.62),('9303','2013-04-03','16:45:00',2.45),('9303','2013-04-03','16:50:00',2.33),('9303','2013-04-03','16:55:00',2.24),('9303','2013-04-03','17:00:00',2.16),('9303','2013-04-03','17:05:00',2.06),('9303','2013-04-03','17:10:00',1.97),('9303','2013-04-03','17:15:00',1.89),('9303','2013-04-03','17:20:00',1.78),('9303','2013-04-03','17:25:00',1.7),('9303','2013-04-03','17:30:00',1.57),('9303','2013-04-03','17:35:00',1.49),('9303','2013-04-03','17:40:00',1.38),('9303','2013-04-03','17:45:00',1.27),('9303','2013-04-03','17:50:00',1.18),('9303','2013-04-03','17:55:00',1.06),('9303','2013-04-02','08:40:00',1.45),('9303','2013-04-02','08:45:00',1.64),('9303','2013-04-02','08:50:00',1.48),('9303','2013-04-02','09:00:00',1.85),('9303','2013-04-02','09:05:00',1.92),('9303','2013-04-02','09:10:00',2.05),('9303','2013-04-02','09:15:00',1.89),('9303','2013-04-02','09:20:00',1.96),('9303','2013-04-02','09:30:00',2.17),('9303','2013-04-02','09:35:00',2.62),('9303','2013-04-02','09:40:00',2.26),('9303','2013-04-02','09:45:00',2.47),('9303','2013-04-02','09:50:00',2.19),('9303','2013-04-02','09:55:00',1.63),('9303','2013-04-02','10:00:00',2.17),('9303','2013-04-02','10:05:00',1.01),('9303','2013-04-02','10:10:00',1.32),('9303','2013-04-02','10:15:00',1.19),('9303','2013-04-02','10:20:00',1.84),('9303','2013-04-02','10:25:00',1.6),('9303','2013-04-02','10:35:00',2.09),('9303','2013-04-02','10:40:00',1.97),('9303','2013-04-02','10:45:00',2.67),('9303','2013-04-02','10:50:00',3.86),('9303','2013-04-02','10:55:00',1.56),('9303','2013-04-02','11:05:00',3.1),('9303','2013-04-02','11:10:00',1.82),('9303','2013-04-02','11:35:00',1.49),('9303','2013-04-02','11:45:00',1.9),('9303','2013-04-02','11:50:00',1.91),('9303','2013-04-02','11:55:00',1.29),('9303','2013-04-02','12:05:00',2.2),('9303','2013-04-02','12:10:00',1.68),('9303','2013-04-02','12:15:00',2.23),('9303','2013-04-02','12:35:00',1.52),('9303','2013-04-02','12:40:00',2.03),('9303','2013-04-02','12:45:00',1.91),('9303','2013-04-02','12:50:00',2.2),('9303','2013-04-02','12:55:00',2.18),('9303','2013-04-02','13:00:00',2.06),('9303','2013-04-02','13:05:00',2.33),('9303','2013-04-02','13:10:00',3.15),('9303','2013-04-02','13:15:00',2.39),('9303','2013-04-02','13:20:00',1.85),('9303','2013-04-02','13:25:00',3.08),('9303','2013-04-02','13:30:00',2.59),('9303','2013-04-02','13:35:00',1.8),('9303','2013-04-02','13:40:00',2.49),('9303','2013-04-02','13:45:00',2.4),('9303','2013-04-02','13:50:00',2.15),('9303','2013-04-02','13:55:00',1.54),('9303','2013-04-02','14:00:00',2.43),('9303','2013-04-02','14:05:00',2.02),('9303','2013-04-02','14:10:00',2.38),('9303','2013-04-02','14:15:00',2.14),('9303','2013-04-02','14:20:00',3.97),('9303','2013-04-02','14:25:00',4.48),('9303','2013-04-02','14:30:00',2.73),('9303','2013-04-02','14:35:00',1.73),('9303','2013-04-02','14:40:00',2.13),('9303','2013-04-02','14:45:00',2.34),('9303','2013-04-02','14:50:00',2.08),('9303','2013-04-02','14:55:00',1.61),('9303','2013-04-02','15:00:00',1.56),('9303','2013-04-02','15:45:00',1.02),('9303','2013-04-02','16:05:00',1.08),('9303','2013-04-02','16:20:00',1),('9303','2014-05-02','07:50:00',1.02),('9303','2014-05-02','07:55:00',1.03),('9303','2014-05-02','08:00:00',1.4),('9303','2014-05-02','08:05:00',1.43),('9303','2014-05-02','08:15:00',1.25),('9303','2014-05-02','08:20:00',2.3),('9303','2014-05-02','08:25:00',1.14),('9303','2014-05-02','08:50:00',1.1),('9303','2014-05-02','09:15:00',1.05),('9303','2014-05-02','09:20:00',1.29),('9303','2014-05-02','09:25:00',1.48),('9303','2014-05-02','09:30:00',1.91),('9303','2014-05-02','09:35:00',1.72),('9303','2014-05-02','09:40:00',1.44),('9303','2014-05-02','09:45:00',1.47),('9303','2014-05-02','09:50:00',1.53),('9303','2014-05-02','09:55:00',1.36),('9303','2014-05-02','10:00:00',1.78),('9303','2014-05-02','10:05:00',1.69),('9303','2014-05-02','10:10:00',1.84),('9303','2014-05-02','10:15:00',1.51),('9303','2014-05-02','10:20:00',1.47),('9303','2014-05-02','10:25:00',1.11),('9303','2014-05-02','10:45:00',1.09),('9303','2014-05-02','10:50:00',1.15),('9303','2014-05-02','12:35:00',1.17),('9303','2014-05-02','12:40:00',1.07),('9303','2014-05-02','12:45:00',1.2),('9303','2014-05-02','12:50:00',1.63),('9303','2014-05-02','12:55:00',1.5),('9303','2014-05-02','13:00:00',1.31),('9303','2014-05-02','13:05:00',1.54),('9303','2014-05-02','13:10:00',1.76),('9303','2014-05-02','13:15:00',2.06),('9303','2014-05-02','13:20:00',3.1),('9303','2014-05-02','13:25:00',2.92),('9303','2014-05-02','13:30:00',2.31),('9303','2014-05-02','13:35:00',2.52),('9303','2014-05-02','13:40:00',2.5),('9303','2014-05-02','13:45:00',1.97),('9303','2014-05-02','13:50:00',1.53),('9303','2014-05-02','13:55:00',1.24),('9303','2014-05-02','14:00:00',1.3),('9303','2014-05-02','14:05:00',1.41),('9303','2014-05-02','14:10:00',1.41),('9303','2014-05-02','14:35:00',1.2),('9303','2014-05-02','14:40:00',3.15),('9303','2014-05-02','14:45:00',1.9),('9303','2014-05-02','14:50:00',1.3),('9303','2014-05-02','14:55:00',1.72),('9303','2014-05-02','15:00:00',2.16),('9303','2014-05-02','15:05:00',1.89),('9303','2014-05-02','15:10:00',3.56),('9303','2014-05-02','15:15:00',3.57),('9303','2014-05-02','15:20:00',1.93),('9303','2014-05-02','15:25:00',2.18),('9303','2014-05-02','15:30:00',1.13),('9303','2014-05-02','15:35:00',2.29),('9303','2014-05-02','15:40:00',3.54),('9303','2014-05-02','15:45:00',1.23),('9303','2014-05-02','16:00:00',1.16),('9303','2014-05-02','16:05:00',1.83),('9303','2014-05-02','16:10:00',1.08),('9303','2014-05-02','16:20:00',2.73),('9303','2014-05-02','17:25:00',1.11),('9303','2014-03-27','07:55:00',1.02),('9303','2014-03-27','08:00:00',1.24),('9303','2014-03-27','08:05:00',1.31),('9303','2014-03-27','10:10:00',1.24),('9303','2014-03-27','10:15:00',1.03),('9303','2014-03-27','10:20:00',1.46),('9303','2014-03-27','10:25:00',1.88),('9303','2014-03-27','10:30:00',1.96),('9303','2014-03-27','10:35:00',1.63),('9303','2014-03-27','10:40:00',2.11),('9303','2014-03-27','10:45:00',1.34),('9303','2014-03-27','11:10:00',2.49),('9303','2014-03-27','11:15:00',2.64),('9303','2014-03-27','11:20:00',1.69),('9303','2014-03-27','11:55:00',1.19),('9303','2014-03-27','12:00:00',1.17),('9303','2014-03-27','12:10:00',1.36),('9303','2014-03-27','12:15:00',1),('9303','2014-03-27','13:10:00',1.36),('9303','2014-03-27','13:15:00',1.98),('9303','2014-03-27','13:20:00',2.15),('9303','2014-03-27','13:25:00',2.34),('9303','2014-03-27','13:30:00',2.02),('9303','2014-03-27','13:35:00',1.81),('9303','2014-03-27','13:40:00',1.71),('9303','2014-03-27','13:45:00',1.55),('9303','2014-03-27','13:50:00',1.88),('9303','2014-03-27','13:55:00',2.62),('9303','2014-03-27','14:00:00',1.98),('9303','2014-03-27','14:05:00',1.13),('9303','2014-03-27','14:15:00',1.81),('9303','2014-03-27','14:20:00',3.5),('9303','2014-03-27','14:25:00',3.22),('9303','2014-03-27','14:30:00',3.81),('9303','2014-03-27','14:35:00',2.06),('9303','2014-03-27','14:40:00',1.71),('9303','2014-03-27','14:45:00',1.56),('9303','2014-03-27','14:50:00',2.27),('9303','2014-03-27','14:55:00',1.91),('9303','2014-03-27','15:00:00',3.41),('9303','2014-03-27','15:05:00',1.73),('9303','2014-03-27','15:25:00',2.08),('9303','2014-03-27','15:30:00',2.56),('9303','2014-03-27','15:35:00',1.87),('9303','2014-03-27','15:40:00',1.02),('9303','2014-03-27','16:10:00',1.06),('9303','2014-03-27','16:15:00',1.06),('9303','2013-04-01','08:30:00',1.14),('9303','2013-04-01','08:35:00',1.39),('9303','2013-04-01','08:40:00',1.6),('9303','2013-04-01','08:50:00',1.06),('9303','2013-04-01','08:55:00',1.46),('9303','2013-04-01','09:00:00',1.83),('9303','2013-04-01','09:05:00',1.96),('9303','2013-04-01','09:10:00',2.12),('9303','2013-04-01','09:15:00',2.15),('9303','2013-04-01','09:20:00',1.52),('9303','2013-04-01','09:25:00',2.02),('9303','2013-04-01','09:30:00',2.48),('9303','2013-04-01','09:35:00',1.36),('9303','2013-04-01','09:40:00',2.38),('9303','2013-04-01','09:45:00',1.57),('9303','2013-04-01','09:50:00',2.72),('9303','2013-04-01','09:55:00',2.58),('9303','2013-04-01','10:00:00',2.79),('9303','2013-04-01','10:05:00',2.95),('9303','2013-04-01','10:10:00',2.27),('9303','2013-04-01','10:15:00',2.51),('9303','2013-04-01','10:20:00',2.4),('9303','2013-04-01','10:25:00',2.51),('9303','2013-04-01','10:30:00',2.12),('9303','2013-04-01','10:35:00',1.56),('9303','2013-04-01','10:40:00',1.99),('9303','2013-04-01','10:45:00',3.47),('9303','2013-04-01','10:50:00',2.52),('9303','2013-04-01','11:00:00',1.66),('9303','2013-04-01','11:05:00',1.21),('9303','2013-04-01','11:10:00',2.15),('9303','2013-04-01','11:15:00',3.4),('9303','2013-04-01','11:20:00',2.52),('9303','2013-04-01','11:25:00',2.24),('9303','2013-04-01','11:30:00',1.42),('9303','2013-04-01','11:35:00',1.71),('9303','2013-04-01','11:40:00',2.5),('9303','2013-04-01','11:45:00',3.01),('9303','2013-04-01','11:50:00',2.44),('9303','2013-04-01','11:55:00',2.05),('9303','2013-04-01','12:00:00',2.84),('9303','2013-04-01','12:05:00',1.76),('9303','2013-04-01','12:10:00',2.09),('9303','2013-04-01','12:15:00',1.91),('9303','2013-04-01','12:20:00',1.55),('9303','2013-04-01','12:25:00',1.68),('9303','2013-04-01','12:30:00',2.37),('9303','2013-04-01','12:35:00',2.2),('9303','2013-04-01','12:40:00',2.19),('9303','2013-04-01','12:45:00',2.47),('9303','2013-04-01','12:50:00',2.61),('9303','2013-04-01','12:55:00',2.9),('9303','2013-04-01','13:00:00',2.77),('9303','2013-04-01','13:05:00',3.05),('9303','2013-04-01','13:10:00',2.83),('9303','2013-04-01','13:15:00',2.75),('9303','2013-04-01','13:20:00',2.66),('9303','2013-04-01','13:25:00',2.47),('9303','2013-04-01','13:30:00',2.91),('9303','2013-04-01','13:35:00',2.47),('9303','2013-04-01','13:40:00',3.03),('9303','2013-04-01','13:45:00',3.45),('9303','2013-04-01','13:50:00',3.93),('9303','2013-04-01','13:55:00',4.12),('9303','2013-04-01','14:00:00',2.21),('9303','2013-04-01','14:05:00',1.67),('9303','2013-04-01','14:10:00',2.12),('9303','2013-04-01','14:15:00',2.41),('9303','2013-04-01','14:20:00',2.45),('9303','2013-04-01','14:25:00',4.01),('9303','2013-04-01','14:30:00',2.85),('9303','2013-04-01','14:35:00',2.12),('9303','2013-04-01','14:40:00',1.91),('9303','2013-04-01','14:45:00',1.81),('9303','2013-04-01','14:50:00',1.96),('9303','2013-04-01','14:55:00',2.12),('9303','2013-04-01','15:00:00',1.86),('9303','2013-04-01','15:05:00',1.84),('9303','2013-04-01','15:10:00',1.87),('9303','2013-04-01','15:15:00',2.03),('9303','2013-04-01','15:20:00',2.09),('9303','2013-04-01','15:25:00',2.13),('9303','2013-04-01','15:30:00',1.86),('9303','2013-04-01','15:35:00',2.38),('9303','2013-04-01','15:40:00',2.21),('9303','2013-04-01','15:45:00',2.24),('9303','2013-04-01','15:50:00',2.62),('9303','2013-04-01','15:55:00',2.04),('9303','2013-04-01','16:00:00',1.79),('9303','2013-04-01','16:05:00',1.48),('9303','2013-04-01','16:10:00',1.24),('9303','2013-03-31','08:35:00',1.03),('9303','2013-03-31','08:45:00',1.22),('9303','2013-03-31','08:55:00',1.13),('9303','2013-03-31','09:00:00',1.01),('9303','2013-03-31','09:15:00',1.03),('9303','2013-03-31','09:20:00',2.15),('9303','2013-03-31','09:25:00',2.7),('9303','2013-03-31','09:30:00',2.35),('9303','2013-03-31','09:35:00',2.2),('9303','2013-03-31','09:40:00',1.44),('9303','2013-03-31','09:45:00',2.65),('9303','2013-03-31','09:50:00',1.53),('9303','2013-03-31','09:55:00',1.79),('9303','2013-03-31','10:00:00',2.32),('9303','2013-03-31','10:20:00',1.96),('9303','2013-03-31','10:25:00',2.66),('9303','2013-03-31','10:30:00',2.3),('9303','2013-03-31','10:35:00',2.62),('9303','2013-03-31','10:50:00',1.93),('9303','2013-03-31','10:55:00',1.09),('9303','2013-03-31','11:10:00',1.22),('9303','2013-03-31','11:15:00',1.17),('9303','2013-03-31','11:20:00',1.03),('9303','2013-03-31','11:25:00',1.41),('9303','2013-03-31','11:30:00',1.09),('9303','2013-03-31','11:35:00',1.42),('9303','2013-03-31','11:40:00',1.57),('9303','2013-03-31','11:45:00',1.39),('9303','2013-03-31','11:50:00',1.44),('9303','2013-03-31','11:55:00',1.48),('9303','2013-03-31','12:00:00',1.4),('9303','2013-03-31','12:05:00',1.31),('9303','2013-03-31','12:10:00',1.16),('9303','2013-03-31','12:15:00',1.14),('9303','2013-03-31','12:20:00',1.17),('9303','2013-03-31','12:25:00',1.27),('9303','2013-03-31','12:30:00',1.63),('9303','2013-03-31','12:35:00',2.54),('9303','2013-03-31','12:40:00',3.39),('9303','2013-03-31','12:45:00',1.71),('9303','2013-03-31','12:50:00',1.53),('9303','2013-03-31','12:55:00',1.78),('9303','2013-03-31','13:00:00',2.17),('9303','2013-03-31','13:05:00',1.75),('9303','2013-03-31','13:10:00',2.54),('9303','2013-03-31','13:15:00',3.01),('9303','2013-03-31','13:20:00',3.81),('9303','2013-03-31','13:25:00',3.12),('9303','2013-03-31','13:40:00',1.15),('9303','2013-03-31','13:45:00',1.77),('9303','2013-03-31','13:50:00',1.77),('9303','2013-03-31','13:55:00',1.34),('9303','2013-03-31','14:00:00',2.14),('9303','2013-03-31','14:05:00',3.16),('9303','2013-03-31','14:10:00',2.15),('9303','2013-03-31','14:15:00',2.61),('9303','2013-03-31','14:20:00',1.92),('9303','2013-03-31','14:25:00',1.65),('9303','2013-03-31','14:30:00',1.99),('9303','2013-03-31','14:35:00',3.83),('9303','2013-03-31','14:40:00',4.33),('9303','2013-03-31','14:45:00',3.65),('9303','2013-03-31','14:50:00',3.57),('9303','2013-03-31','14:55:00',2.71),('9303','2013-03-31','15:00:00',2.98),('9303','2013-03-31','15:05:00',1.95),('9303','2013-03-31','15:10:00',3.07),('9303','2013-03-31','15:15:00',2.61),('9303','2013-03-31','15:20:00',3.67),('9303','2013-03-31','15:25:00',3.28),('9303','2013-03-31','15:30:00',2.93),('9303','2013-03-31','15:35:00',2.5),('9303','2013-03-31','15:40:00',3.76),('9303','2013-03-31','15:45:00',2.6),('9303','2013-03-31','16:00:00',2.25),('9303','2013-03-31','16:05:00',1.25),('9303','2013-03-31','16:10:00',1.19),('9303','2013-03-31','16:15:00',2.09),('9303','2013-03-31','16:20:00',1.67),('9303','2013-03-31','16:25:00',1.26),('9303','2013-03-31','16:30:00',1),('9303','2013-03-31','16:35:00',1.07),('9303','2013-03-31','16:40:00',1.05),('9303','2013-03-31','17:00:00',1.18),('9303','2013-03-31','17:05:00',2.07),('9303','2013-03-31','17:10:00',1.35),('9303','2013-03-31','17:25:00',1.08),('9303','2013-03-31','17:30:00',1.18),('9303','2013-03-31','17:35:00',1.15),('9303','2013-03-31','17:55:00',1.11),('9303','2013-03-30','08:35:00',1.02),('9303','2013-03-30','09:05:00',1.67),('9303','2013-03-30','09:10:00',1.6),('9303','2013-03-30','09:16:00',1.61),('9303','2013-03-30','09:20:00',3.09),('9303','2013-03-30','09:25:00',1.99),('9303','2013-03-30','09:30:00',1.34),('9303','2013-03-30','09:35:00',1.76),('9303','2013-03-30','09:40:00',1.43),('9303','2013-03-30','09:45:00',1.17),('9303','2013-03-30','09:55:00',1.06),('9303','2013-03-30','10:00:00',1.43),('9303','2013-03-30','10:05:00',1.46),('9303','2013-03-30','10:10:00',1.7),('9303','2013-03-30','10:15:00',1.58),('9303','2013-03-30','10:20:00',1.36),('9303','2013-03-30','10:25:00',1.31),('9303','2013-03-30','10:30:00',1.51),('9303','2013-03-30','10:35:00',1.81),('9303','2013-03-30','10:40:00',2.25),('9303','2013-03-30','10:45:00',3.24),('9303','2013-03-30','10:50:00',3.12),('9303','2013-03-30','10:55:00',2.11),('9303','2013-03-30','11:00:00',3.5),('9303','2013-03-30','11:05:00',3.83),('9303','2013-03-30','11:10:00',4.47),('9303','2013-03-30','11:15:00',4.14),('9303','2013-03-30','11:20:00',4.84),('9303','2013-03-30','11:25:00',4.31),('9303','2013-03-30','11:30:00',2.25),('9303','2013-03-30','11:35:00',2.64),('9303','2013-03-30','11:40:00',2.09),('9303','2013-03-30','11:45:00',3.18),('9303','2013-03-30','11:50:00',3.51),('9303','2013-03-30','11:55:00',3.96),('9303','2013-03-30','12:00:00',4.28),('9303','2013-03-30','12:05:00',2.63),('9303','2013-03-30','12:10:00',1.93),('9303','2013-03-30','12:15:00',1.8),('9303','2013-03-30','12:20:00',1.85),('9303','2013-03-30','12:25:00',1.18),('9303','2013-03-30','12:35:00',1.01),('9303','2013-03-30','13:10:00',1.07),('9303','2013-03-30','13:15:00',3.46),('9303','2013-03-30','13:20:00',2.92),('9303','2013-03-30','13:25:00',1.41),('9303','2013-03-30','13:45:00',1.55),('9303','2013-03-30','13:50:00',3.63),('9303','2013-03-30','13:55:00',2.34),('9303','2013-03-30','14:00:00',2.75),('9303','2013-03-30','14:05:00',2.36),('9303','2013-03-30','14:10:00',1.08),('9303','2013-03-30','14:15:00',1.18),('9303','2013-03-30','14:20:00',2.03),('9303','2013-03-30','14:25:00',1.24),('9303','2013-03-30','14:30:00',1.62),('9303','2013-03-30','14:35:00',1.77),('9303','2013-03-30','14:40:00',1.09),('9303','2013-03-30','14:45:00',1.04),('9303','2013-03-30','14:50:00',1.36),('9303','2013-03-29','07:25:00',1.05),('9303','2013-03-29','07:30:00',1.19),('9303','2013-03-29','07:35:00',1.21),('9303','2013-03-29','07:40:00',1.3),('9303','2013-03-29','07:45:00',1.42),('9303','2013-03-29','07:50:00',1.21),('9303','2013-03-29','08:00:00',1.25),('9303','2013-03-29','08:05:00',1.68),('9303','2013-03-29','08:10:00',1.97),('9303','2013-03-29','08:15:00',1.95),('9303','2013-03-29','08:20:00',2.03),('9303','2013-03-29','08:25:00',2.11),('9303','2013-03-29','08:30:00',2.22),('9303','2013-03-29','08:35:00',2.27),('9303','2013-03-29','08:40:00',2.38),('9303','2013-03-29','08:45:00',2.39),('9303','2013-03-29','08:50:00',2.33),('9303','2013-03-29','08:55:00',2.28),('9303','2013-03-29','09:00:00',2.3),('9303','2013-03-29','09:05:00',2.46),('9303','2013-03-29','09:10:00',2.6),('9303','2013-03-29','09:15:00',2.93),('9303','2013-03-29','09:20:00',3.09),('9303','2013-03-29','09:25:00',2.84),('9303','2013-03-29','09:30:00',3.28),('9303','2013-03-29','09:35:00',3.38),('9303','2013-03-29','09:40:00',3.31),('9303','2013-03-29','09:45:00',2.99),('9303','2013-03-29','09:50:00',3.27),('9303','2013-03-29','09:55:00',3.22),('9303','2013-03-29','10:00:00',3.23),('9303','2013-03-29','10:05:00',2.9),('9303','2013-03-29','10:10:00',2.58),('9303','2013-03-29','10:15:00',3.22),('9303','2013-03-29','10:20:00',2.97),('9303','2013-03-29','10:25:00',2.86),('9303','2013-03-29','10:30:00',2.99),('9303','2013-03-29','10:35:00',2.32),('9303','2013-03-29','10:40:00',3.14),('9303','2013-03-29','10:45:00',2.31),('9303','2013-03-29','10:50:00',2.48),('9303','2013-03-29','10:55:00',2.87),('9303','2013-03-29','11:00:00',3.43),('9303','2013-03-29','11:05:00',3.85),('9303','2013-03-29','11:10:00',4.34),('9303','2013-03-29','11:15:00',2.25),('9303','2013-03-29','11:20:00',2.31),('9303','2013-03-29','11:25:00',3.33),('9303','2013-03-29','11:30:00',4.33),('9303','2013-03-29','11:35:00',4.17),('9303','2013-03-29','11:40:00',4.12),('9303','2013-03-29','11:45:00',4.11),('9303','2013-03-29','11:50:00',4.14),('9303','2013-03-29','11:55:00',4.14),('9303','2013-03-29','12:00:00',4.14),('9303','2013-03-29','12:05:00',4.24),('9303','2013-03-29','12:10:00',4.17),('9303','2013-03-29','12:15:00',3.86),('9303','2013-03-29','12:20:00',4.15),('9303','2013-03-29','12:25:00',3.96),('9303','2013-03-29','12:30:00',3.7),('9303','2013-03-29','12:35:00',3.85),('9303','2013-03-29','12:40:00',3.96),('9303','2013-03-29','12:45:00',3.26),('9303','2013-03-29','12:50:00',3.64),('9303','2013-03-29','12:55:00',3.1),('9303','2013-03-29','13:00:00',3.75),('9303','2013-03-29','13:05:00',3.23),('9303','2013-03-29','13:10:00',3.72),('9303','2013-03-29','13:15:00',3.29),('9303','2013-03-29','13:20:00',3.2),('9303','2013-03-29','13:25:00',4.16),('9303','2013-03-29','13:30:00',3.6),('9303','2013-03-29','13:35:00',3.21),('9303','2013-03-29','13:40:00',3.27),('9303','2013-03-29','13:45:00',3.23),('9303','2013-03-29','13:50:00',3.25),('9303','2013-03-29','13:55:00',3.29),('9303','2013-03-29','14:00:00',3.4),('9303','2013-03-29','14:05:00',2.91),('9303','2013-03-29','14:10:00',2.36),('9303','2013-03-29','14:15:00',2.32),('9303','2013-03-29','14:20:00',2.32),('9303','2013-03-29','14:25:00',2.34),('9303','2013-03-29','14:30:00',1.97),('9303','2013-03-29','14:35:00',1.97),('9303','2013-03-29','14:40:00',1.88),('9303','2013-03-29','14:45:00',1.76),('9303','2013-03-29','14:50:00',1.67),('9303','2013-03-29','14:55:00',1.6),('9303','2013-03-29','15:00:00',1.44),('9303','2013-03-29','15:05:00',1.49),('9303','2013-03-29','15:10:00',1.39),('9303','2013-03-29','15:15:00',1.35),('9303','2013-03-29','15:20:00',1.29),('9303','2013-03-29','15:25:00',1.15),('9303','2013-03-29','15:30:00',1.06),('9303','2013-03-29','15:35:00',1),('9303','2013-03-29','15:55:00',1.11),('9303','2013-03-29','16:00:00',1.32),('9303','2013-03-29','16:05:00',1.28),('9303','2013-03-29','16:10:00',1),('9303','2013-03-28','09:10:00',1.26),('9303','2013-03-28','09:16:00',2.79),('9303','2013-03-28','09:20:00',1.47),('9303','2013-03-28','09:25:00',1.37),('9303','2013-03-28','09:30:00',1.11),('9303','2013-03-28','10:00:00',1.1),('9303','2013-03-28','11:40:00',1.49),('9303','2013-03-28','11:45:00',1.22),('9303','2013-03-28','11:55:00',1.81),('9303','2013-03-28','12:00:00',1.51),('9303','2013-03-28','12:20:00',1.05),('9303','2013-03-28','12:40:00',1.16),('9303','2013-03-28','12:45:00',1.45),('9303','2013-03-28','12:50:00',2.83),('9303','2013-03-28','12:55:00',3.31),('9303','2013-03-28','13:00:00',3.21),('9303','2013-03-28','13:05:00',4.24),('9303','2013-03-28','13:10:00',3.46),('9303','2013-03-28','13:15:00',3.88),('9303','2013-03-28','13:20:00',2.82),('9303','2013-03-28','13:25:00',3.3),('9303','2013-03-28','13:30:00',3.23),('9303','2013-03-28','13:35:00',2.55),('9303','2013-03-28','13:40:00',2.9),('9303','2013-03-28','13:45:00',2.26),('9303','2013-03-28','13:50:00',3.5),('9303','2013-03-28','13:55:00',1.47),('9303','2013-03-28','14:00:00',1.71),('9303','2013-03-28','14:05:00',2.47),('9303','2013-03-28','14:10:00',1.55),('9303','2013-03-28','14:15:00',1.33),('9303','2013-03-28','14:20:00',1.4),('9303','2013-03-28','14:25:00',1.29),('9303','2013-03-28','14:30:00',1.61),('9303','2013-03-28','14:35:00',1.57),('9303','2013-03-28','14:40:00',1.06),('9303','2013-03-28','14:45:00',1.01),('9303','2013-03-28','15:00:00',1.05),('9303','2013-03-28','15:05:00',1.15),('9303','2013-03-28','15:10:00',2.14),('9303','2013-03-28','15:15:00',2.14),('9303','2013-03-28','15:20:00',1.61),('9303','2013-03-28','15:25:00',1.52),('9303','2013-03-28','15:30:00',1.53),('9303','2013-03-28','15:35:00',2.06),('9303','2013-03-28','15:40:00',1.68),('9303','2013-03-28','15:45:00',2.02),('9303','2013-03-28','15:50:00',1.2),('9303','2013-03-28','15:55:00',2.5),('9303','2013-03-28','16:00:00',1.29),('9303','2013-03-28','16:10:00',1.35),('9303','2013-03-28','16:35:00',1.31),('9303','2013-03-28','17:00:00',1.11),('9303','2013-03-27','07:30:00',1.04),('9303','2013-03-27','07:40:00',1.15),('9303','2013-03-27','07:45:00',1.06),('9303','2013-03-27','07:55:00',1.17),('9303','2013-03-27','08:00:00',1.29),('9303','2013-03-27','08:05:00',1.43),('9303','2013-03-27','08:10:00',1.24),('9303','2013-03-27','08:15:00',1.36),('9303','2013-03-27','08:20:00',1.2),('9303','2013-03-27','08:25:00',1.38),('9303','2013-03-27','08:30:00',1.8),('9303','2013-03-27','08:35:00',1.74),('9303','2013-03-27','08:40:00',1.34),('9303','2013-03-27','08:45:00',1.2),('9303','2013-03-27','08:50:00',1.65),('9303','2013-03-27','08:55:00',1.28),('9303','2013-03-27','09:00:00',1.32),('9303','2013-03-27','09:05:00',1.01),('9303','2013-03-27','09:15:00',1.31),('9303','2013-03-27','09:20:00',1.53),('9303','2013-03-27','09:25:00',1.01),('9303','2013-03-27','09:45:00',1.28),('9303','2013-03-27','09:50:00',2.13),('9303','2013-03-27','09:55:00',1.44),('9303','2013-03-27','10:00:00',1.24),('9303','2013-03-27','10:10:00',1.15),('9303','2013-03-27','10:15:00',1.63),('9303','2013-03-27','10:20:00',1.39),('9303','2013-03-27','10:25:00',1.65),('9303','2013-03-27','10:30:00',2.18),('9303','2013-03-27','10:35:00',1.71),('9303','2013-03-27','10:40:00',1.91),('9303','2013-03-27','10:45:00',2.08),('9303','2013-03-27','10:50:00',1.94),('9303','2013-03-27','10:55:00',1.85),('9303','2013-03-27','11:00:00',1.56),('9303','2013-03-27','11:05:00',1.45),('9303','2013-03-27','11:10:00',1.59),('9303','2013-03-27','11:15:00',1.66),('9303','2013-03-27','11:20:00',1.73),('9303','2013-03-27','11:25:00',1.63),('9303','2013-03-27','11:30:00',1.85),('9303','2013-03-27','11:35:00',1.76),('9303','2013-03-27','11:40:00',1.65),('9303','2013-03-27','11:45:00',1.6),('9303','2013-03-27','11:50:00',1.56),('9303','2013-03-27','11:55:00',2.2),('9303','2013-03-27','12:00:00',2.66),('9303','2013-03-27','12:05:00',2.55),('9303','2013-03-27','12:10:00',2.16),('9303','2013-03-27','12:15:00',1.63),('9303','2013-03-27','12:20:00',1.66),('9303','2013-03-27','12:25:00',1.57),('9303','2013-03-27','12:30:00',3.14),('9303','2013-03-27','12:35:00',4.36),('9303','2013-03-27','12:40:00',3.14),('9303','2013-03-27','12:45:00',4.3),('9303','2013-03-27','12:50:00',2.73),('9303','2013-03-27','12:55:00',2.32),('9303','2013-03-27','13:00:00',1.5),('9303','2013-03-27','13:05:00',1.45),('9303','2013-03-27','13:10:00',2.18),('9303','2013-03-27','13:15:00',1.64),('9303','2013-03-27','13:20:00',1.28),('9303','2013-03-27','13:25:00',1.2),('9303','2013-03-27','13:30:00',1.6),('9303','2013-03-27','13:35:00',2.02),('9303','2013-03-27','13:40:00',1.7),('9303','2013-03-27','13:45:00',1.92),('9303','2013-03-27','13:50:00',2.27),('9303','2013-03-27','13:55:00',2.19),('9303','2013-03-27','14:00:00',1.6),('9303','2013-03-27','14:05:00',1.41),('9303','2013-03-27','14:10:00',1.47),('9303','2013-03-27','14:15:00',1.69),('9303','2013-03-27','14:20:00',2.14),('9303','2013-03-27','14:25:00',1.61),('9303','2013-03-27','14:30:00',1.35),('9303','2013-03-27','14:35:00',1.58),('9303','2013-03-27','14:40:00',2.08),('9303','2013-03-27','14:45:00',2.07),('9303','2013-03-27','14:50:00',1.49),('9303','2013-03-27','14:55:00',1.2),('9303','2013-03-27','15:00:00',1.09),('9303','2013-03-27','15:05:00',1.51),('9303','2013-03-27','15:10:00',1.46),('9303','2013-03-27','15:20:00',1.03),('9303','2013-03-27','15:25:00',1.06),('9303','2013-03-27','17:00:00',1.03),('9303','2013-03-27','17:05:00',1.19),('9303','2013-03-26','07:50:00',1.5),('9303','2013-03-26','07:55:00',1.95),('9303','2013-03-26','08:35:00',1.25),('9303','2013-03-26','08:40:00',1.36),('9303','2013-03-26','09:15:00',1.35),('9303','2013-03-26','09:20:00',1.01),('9303','2013-03-26','09:55:00',2.59),('9303','2013-03-26','10:00:00',1.28),('9303','2013-03-26','11:50:00',1.08),('9303','2013-03-26','12:00:00',1.13),('9303','2013-03-26','12:05:00',1.07),('9303','2013-03-26','12:12:00',1.17),('9303','2013-03-26','12:15:00',1.33),('9303','2013-03-26','12:22:00',1.74),('9303','2013-03-26','12:25:00',2.4),('9303','2013-03-26','12:35:00',2.37),('9303','2013-03-26','12:40:00',1.48),('9303','2013-03-26','12:47:00',2.13),('9303','2013-03-26','12:50:00',1.66),('9303','2013-03-26','12:57:00',1.21),('9303','2013-03-26','13:00:00',1.7),('9303','2013-03-26','13:10:00',2.38),('9303','2013-03-26','13:15:00',1.82),('9303','2013-03-26','13:22:00',1.58),('9303','2013-03-26','13:25:00',1.72),('9303','2013-03-26','13:32:00',1.58),('9303','2013-03-26','13:35:00',1.99),('9303','2013-03-26','13:45:00',2.21),('9303','2013-03-26','13:50:00',1.66),('9303','2013-03-26','13:57:00',1.51),('9303','2013-03-26','14:00:00',1.44),('9303','2013-03-26','14:07:00',1.43),('9303','2013-03-26','14:10:00',1.47),('9303','2013-03-26','14:20:00',1.3),('9303','2013-03-26','14:25:00',1.04),('9303','2013-03-25','08:25:00',1.87),('9303','2013-03-25','08:30:00',1.27),('9303','2013-03-25','08:55:00',1.04),('9303','2013-03-25','09:00:00',1.05),('9303','2013-03-25','09:05:00',1.01),('9303','2013-03-25','09:10:00',1.09),('9303','2013-03-25','09:15:00',1.05),('9303','2013-03-25','09:20:00',2.39),('9303','2013-03-25','09:25:00',2.82),('9303','2013-03-25','09:30:00',1.67),('9303','2013-03-25','09:50:00',3.12),('9303','2013-03-25','09:55:00',3.98),('9303','2013-03-25','10:00:00',2.11),('9303','2013-03-25','10:20:00',1.32),('9303','2013-03-25','10:25:00',2.07),('9303','2013-03-25','10:30:00',2.42),('9303','2013-03-25','10:35:00',1.29),('9303','2013-03-25','10:40:00',1.5),('9303','2013-03-25','10:45:00',2.63),('9303','2013-03-25','10:50:00',1.95),('9303','2013-03-25','10:55:00',2.48),('9303','2013-03-25','11:00:00',2.1),('9303','2013-03-25','11:05:00',1.87),('9303','2013-03-25','11:10:00',1.73),('9303','2013-03-25','11:15:00',1.83),('9303','2013-03-25','11:20:00',3.67),('9303','2013-03-25','11:25:00',3.26),('9303','2013-03-25','11:30:00',3.75),('9303','2013-03-25','11:35:00',2.96),('9303','2013-03-25','11:40:00',1.25),('9303','2013-03-25','11:45:00',1.42),('9303','2013-03-25','11:50:00',1.63),('9303','2013-03-25','11:55:00',2.57),('9303','2013-03-25','12:00:00',3.23),('9303','2013-03-25','12:05:00',3.5),('9303','2013-03-25','12:10:00',3.59),('9303','2013-03-25','12:15:00',3.17),('9303','2013-03-25','12:20:00',3),('9303','2013-03-25','12:25:00',4.31),('9303','2013-03-25','12:30:00',3.41),('9303','2013-03-25','12:35:00',3.08),('9303','2013-03-25','12:40:00',2.3),('9303','2013-03-25','12:45:00',2.36),('9303','2013-03-25','12:50:00',2.75),('9303','2013-03-25','12:55:00',3.02),('9303','2013-03-25','13:00:00',2.66),('9303','2013-03-25','13:05:00',4.17),('9303','2013-03-25','13:10:00',4.1),('9303','2013-03-25','13:15:00',4.61),('9303','2013-03-25','13:20:00',3.89),('9303','2013-03-25','13:25:00',2.22),('9303','2013-03-25','13:30:00',2.04),('9303','2013-03-25','13:35:00',1.09),('9303','2013-03-25','13:40:00',1.1),('9303','2013-03-25','13:45:00',1.93),('9303','2013-03-25','13:50:00',1.8),('9303','2013-03-25','13:55:00',1.67),('9303','2013-03-25','14:10:00',2.61),('9303','2013-03-25','14:15:00',2.18),('9303','2013-03-25','14:20:00',2.49),('9303','2013-03-25','14:25:00',3.28),('9303','2013-03-25','14:30:00',2.5),('9303','2013-03-25','14:35:00',2.11),('9303','2013-03-25','14:40:00',1.29),('9303','2013-03-25','14:45:00',2.06),('9303','2013-03-25','14:50:00',1.89),('9303','2013-03-25','14:55:00',2.73),('9303','2013-03-25','15:00:00',2.45),('9303','2013-03-25','15:05:00',2.3),('9303','2013-03-25','15:10:00',2.1),('9303','2013-03-25','15:15:00',1.98),('9303','2013-03-25','15:20:00',2.58),('9303','2013-03-25','15:25:00',3.01),('9303','2013-03-25','15:30:00',2.2),('9303','2013-03-25','15:35:00',2.56),('9303','2013-03-25','15:40:00',1.86),('9303','2013-03-25','15:45:00',1.47),('9303','2013-03-25','15:55:00',1.01),('9303','2013-03-25','16:00:00',1.53),('9303','2013-03-25','16:05:00',1.07),('9303','2013-03-25','16:10:00',1.17),('9303','2013-03-25','16:15:00',1.3),('9303','2013-03-25','16:30:00',1.02),('9303','2013-03-25','16:35:00',1.51),('9303','2013-03-25','16:40:00',1.67),('9303','2013-03-24','07:50:00',1.14),('9303','2013-03-24','07:55:00',1.3),('9303','2013-03-24','08:00:00',1.53),('9303','2013-03-24','08:05:00',1.7),('9303','2013-03-24','08:10:00',1.74),('9303','2013-03-24','08:15:00',1.87),('9303','2013-03-24','08:20:00',1.96),('9303','2013-03-24','08:25:00',2.04),('9303','2013-03-24','08:30:00',2.12),('9303','2013-03-24','08:35:00',2.19),('9303','2013-03-24','08:40:00',2.26),('9303','2013-03-24','08:45:00',2.33),('9303','2013-03-24','08:50:00',2.37),('9303','2013-03-24','08:55:00',2.43),('9303','2013-03-24','09:00:00',2.5),('9303','2013-03-24','09:05:00',2.59),('9303','2013-03-24','09:10:00',2.66),('9303','2013-03-24','09:15:00',2.72),('9303','2013-03-24','09:20:00',2.79),('9303','2013-03-24','09:25:00',2.85),('9303','2013-03-24','09:30:00',2.92),('9303','2013-03-24','09:35:00',2.98),('9303','2013-03-24','09:40:00',3),('9303','2013-03-24','09:45:00',3.07),('9303','2013-03-24','09:50:00',3.1),('9303','2013-03-24','09:55:00',3.14),('9303','2013-03-24','10:00:00',3.21),('9303','2013-03-24','10:05:00',3.27),('9303','2013-03-24','10:10:00',3.34),('9303','2013-03-24','10:15:00',3.38),('9303','2013-03-24','10:20:00',3.39),('9303','2013-03-24','10:25:00',3.44),('9303','2013-03-24','10:30:00',3.46),('9303','2013-03-24','10:35:00',3.49),('9303','2013-03-24','10:40:00',3.52),('9303','2013-03-24','10:45:00',3.51),('9303','2013-03-24','10:50:00',3.53),('9303','2013-03-24','10:55:00',3.56),('9303','2013-03-24','11:00:00',3.59),('9303','2013-03-24','11:05:00',3.62),('9303','2013-03-24','11:10:00',3.65),('9303','2013-03-24','11:15:00',3.66),('9303','2013-03-24','11:20:00',3.69),('9303','2013-03-24','11:25:00',3.7),('9303','2013-03-24','11:30:00',3.72),('9303','2013-03-24','11:35:00',3.74),('9303','2013-03-24','11:40:00',3.73),('9303','2013-03-24','11:45:00',3.74),('9303','2013-03-24','11:50:00',3.75),('9303','2013-03-24','11:55:00',3.76),('9303','2013-03-24','12:00:00',3.79),('9303','2013-03-24','12:05:00',3.79),('9303','2013-03-24','12:10:00',3.8),('9303','2013-03-24','12:15:00',3.82),('9303','2013-03-24','12:20:00',3.89),('9303','2013-03-24','12:25:00',3.93),('9303','2013-03-24','12:30:00',3.92),('9303','2013-03-24','12:35:00',3.94),('9303','2013-03-24','12:40:00',3.9),('9303','2013-03-24','12:45:00',3.91),('9303','2013-03-24','12:50:00',3.9),('9303','2013-03-24','12:55:00',3.88),('9303','2013-03-24','13:00:00',3.85),('9303','2013-03-24','13:05:00',3.85),('9303','2013-03-24','13:10:00',3.82),('9303','2013-03-24','13:15:00',3.79),('9303','2013-03-24','13:20:00',3.8),('9303','2013-03-24','13:25:00',3.73),('9303','2013-03-24','13:30:00',3.68),('9303','2013-03-24','13:35:00',3.68),('9303','2013-03-24','13:40:00',3.67),('9303','2013-03-24','13:45:00',3.63),('9303','2013-03-24','13:50:00',3.59),('9303','2013-03-24','13:55:00',3.56),('9303','2013-03-24','14:00:00',3.52),('9303','2013-03-24','14:05:00',3.46),('9303','2013-03-24','14:10:00',3.39),('9303','2013-03-24','14:15:00',3.34),('9303','2013-03-24','14:20:00',3.29),('9303','2013-03-24','14:25:00',3.24),('9303','2013-03-24','14:30:00',3.13),('9303','2013-03-24','14:35:00',3.02),('9303','2013-03-24','14:40:00',2.99),('9303','2013-03-24','14:45:00',2.94),('9303','2013-03-24','14:50:00',2.8),('9303','2013-03-24','14:55:00',2.81),('9303','2013-03-24','15:00:00',2.71),('9303','2013-03-24','15:05:00',2.64),('9303','2013-03-24','15:10:00',2.5),('9303','2013-03-24','15:15:00',2.71),('9303','2013-03-24','15:20:00',2.61),('9303','2013-03-24','15:25:00',2.44),('9303','2013-03-24','15:30:00',2.2),('9303','2013-03-24','15:35:00',2.11),('9303','2013-03-24','15:40:00',2.07),('9303','2013-03-24','15:45:00',1.73),('9303','2013-03-24','15:50:00',1.15),('9303','2013-03-24','15:55:00',1.1),('9303','2013-03-24','16:00:00',1.07),('9303','2013-03-24','16:05:00',1.16),('9303','2013-03-24','16:15:00',1.14),('9303','2013-03-24','16:20:00',1.05),('9303','2013-03-23','07:40:00',1.06),('9303','2013-03-23','07:45:00',1.1),('9303','2013-03-23','07:50:00',1.21),('9303','2013-03-23','07:55:00',1.38),('9303','2013-03-23','08:00:00',1.53),('9303','2013-03-23','08:05:00',1.71),('9303','2013-03-23','08:10:00',1.8),('9303','2013-03-23','08:15:00',1.89),('9303','2013-03-23','08:20:00',1.97),('9303','2013-03-23','08:25:00',2.04),('9303','2013-03-23','08:30:00',2.07),('9303','2013-03-23','08:35:00',2.16),('9303','2013-03-23','08:40:00',2.28),('9303','2013-03-23','08:45:00',2.35),('9303','2013-03-23','08:50:00',2.42),('9303','2013-03-23','08:55:00',2.57),('9303','2013-03-23','09:00:00',2.62),('9303','2013-03-23','09:05:00',2.7),('9303','2013-03-23','09:10:00',2.69),('9303','2013-03-23','09:15:00',2.78),('9303','2013-03-23','09:20:00',2.89),('9303','2013-03-23','09:25:00',2.89),('9303','2013-03-23','09:30:00',3.07),('9303','2013-03-23','09:35:00',3.18),('9303','2013-03-23','09:40:00',3.01),('9303','2013-03-23','09:45:00',3.16),('9303','2013-03-23','09:50:00',3.22),('9303','2013-03-23','09:55:00',3.3),('9303','2013-03-23','10:00:00',3.29),('9303','2013-03-23','10:05:00',3.33),('9303','2013-03-23','10:10:00',3.38),('9303','2013-03-23','10:15:00',3.39),('9303','2013-03-23','10:20:00',3.38),('9303','2013-03-23','10:25:00',3.42),('9303','2013-03-23','10:30:00',3.57),('9303','2013-03-23','10:35:00',3.61),('9303','2013-03-23','10:40:00',3.61),('9303','2013-03-23','10:45:00',3.61),('9303','2013-03-23','10:50:00',3.61),('9303','2013-03-23','10:55:00',3.49),('9303','2013-03-23','11:00:00',3.36),('9303','2013-03-23','11:05:00',3.26),('9303','2013-03-23','11:10:00',2.61),('9303','2013-03-23','11:15:00',2.78),('9303','2013-03-23','11:20:00',3.56),('9303','2013-03-23','11:25:00',3.58),('9303','2013-03-23','11:30:00',3.63),('9303','2013-03-23','11:35:00',3.78),('9303','2013-03-23','11:40:00',3.77),('9303','2013-03-23','11:45:00',3.78),('9303','2013-03-23','11:50:00',3.65),('9303','2013-03-23','11:55:00',3.83),('9303','2013-03-23','12:00:00',3.83),('9303','2013-03-23','12:05:00',3.78),('9303','2013-03-23','12:10:00',3.77),('9303','2013-03-23','12:15:00',3.84),('9303','2013-03-23','12:20:00',3.9),('9303','2013-03-23','12:25:00',3.85),('9303','2013-03-23','12:30:00',3.91),('9303','2013-03-23','12:35:00',3.87),('9303','2013-03-23','12:40:00',3.66),('9303','2013-03-23','12:45:00',3.77),('9303','2013-03-23','12:50:00',3.84),('9303','2013-03-23','12:55:00',3.8),('9303','2013-03-23','13:00:00',2.9),('9303','2013-03-23','13:05:00',3.73),('9303','2013-03-23','13:10:00',3.83),('9303','2013-03-23','13:15:00',3.68),('9303','2013-03-23','13:20:00',3.76),('9303','2013-03-23','13:25:00',3.71),('9303','2013-03-23','13:30:00',3.43),('9303','2013-03-23','13:35:00',3.16),('9303','2013-03-23','13:40:00',3.17),('9303','2013-03-23','13:45:00',3.17),('9303','2013-03-23','13:50:00',3.65),('9303','2013-03-23','13:55:00',3.5),('9303','2013-03-23','14:00:00',3.47),('9303','2013-03-23','14:05:00',3.48),('9303','2013-03-23','14:10:00',3.42),('9303','2013-03-23','14:15:00',3.29),('9303','2013-03-23','14:20:00',3.4),('9303','2013-03-23','14:25:00',3.31),('9303','2013-03-23','14:30:00',3.31),('9303','2013-03-23','14:35:00',3.23),('9303','2013-03-23','14:40:00',3.14),('9303','2013-03-23','14:45:00',2.92),('9303','2013-03-23','14:50:00',2.86),('9303','2013-03-23','14:55:00',2.91),('9303','2013-03-23','15:00:00',2.78),('9303','2013-03-23','15:05:00',2.65),('9303','2013-03-23','15:10:00',2.74),('9303','2013-03-23','15:15:00',2.54),('9303','2013-03-23','15:20:00',2.55),('9303','2013-03-23','15:25:00',2.54),('9303','2013-03-23','15:30:00',2.25),('9303','2013-03-23','15:35:00',2.26),('9303','2013-03-23','15:40:00',2.06),('9303','2013-03-23','15:45:00',1.89),('9303','2013-03-23','15:50:00',1.76),('9303','2013-03-23','15:55:00',1.71),('9303','2013-03-23','16:00:00',1.6),('9303','2013-03-23','16:05:00',1.4),('9303','2013-03-23','16:10:00',1.78),('9303','2013-03-23','16:15:00',1.62),('9303','2013-03-23','16:20:00',1.35),('9303','2013-03-23','16:25:00',1.33),('9303','2013-03-23','16:30:00',1.07),('9303','2013-03-23','16:35:00',1.11),('9303','2014-03-26','07:30:00',1.08),('9303','2014-03-26','07:35:00',1.18),('9303','2014-03-26','07:40:00',1.26),('9303','2014-03-26','07:45:00',1.37),('9303','2014-03-26','07:50:00',1.45),('9303','2014-03-26','07:55:00',1.57),('9303','2014-03-26','08:00:00',1.7),('9303','2014-03-26','08:05:00',1.84),('9303','2014-03-26','08:10:00',1.96),('9303','2014-03-26','08:15:00',2.12),('9303','2014-03-26','08:20:00',2.45),('9303','2014-03-26','08:25:00',1.54),('9303','2014-03-26','08:30:00',1.05),('9303','2014-03-26','08:45:00',1.06),('9303','2014-03-26','08:50:00',1.28),('9303','2014-03-26','08:55:00',1.13),('9303','2014-03-26','09:00:00',1.26),('9303','2014-03-26','09:05:00',1.22),('9303','2014-03-26','09:10:00',1.45),('9303','2014-03-26','09:15:00',1.17),('9303','2014-03-26','09:25:00',1.11),('9303','2014-03-26','09:30:00',3.08),('9303','2014-03-26','09:35:00',3.25),('9303','2014-03-26','09:40:00',3.29),('9303','2014-03-26','09:45:00',3.3),('9303','2014-03-26','09:50:00',3.36),('9303','2014-03-26','09:55:00',3.25),('9303','2014-03-26','10:00:00',3.6),('9303','2014-03-26','10:05:00',2.9),('9303','2014-03-26','10:10:00',3.22),('9303','2014-03-26','10:15:00',3.76),('9303','2014-03-26','10:20:00',3.44),('9303','2014-03-26','10:25:00',3.95),('9303','2014-03-26','10:30:00',3.96),('9303','2014-03-26','10:35:00',2.49),('9303','2014-03-26','10:45:00',2.08),('9303','2014-03-26','10:50:00',3.46),('9303','2014-03-26','10:55:00',3.64),('9303','2014-03-26','11:00:00',4.21),('9303','2014-03-26','11:05:00',1.11),('9303','2014-03-26','11:10:00',2.27),('9303','2014-03-26','11:15:00',3.23),('9303','2014-03-26','11:20:00',2.92),('9303','2014-03-26','11:25:00',1.23),('9303','2014-03-26','11:30:00',1.51),('9303','2014-03-26','11:35:00',1.73),('9303','2014-03-26','11:40:00',2.06),('9303','2014-03-26','11:45:00',1.8),('9303','2014-03-26','11:50:00',3.97),('9303','2014-03-26','11:55:00',4.14),('9303','2014-03-26','12:00:00',4.74),('9303','2014-03-26','12:05:00',3.48),('9303','2014-03-26','12:10:00',4.54),('9303','2014-03-26','12:15:00',1.5),('9303','2014-03-26','12:20:00',1.68),('9303','2014-03-26','12:25:00',1.67),('9303','2014-03-26','12:30:00',1.59),('9303','2014-03-26','12:35:00',1.58),('9303','2014-03-26','12:40:00',1.73),('9303','2014-03-26','12:45:00',1.93),('9303','2014-03-26','12:50:00',1.52),('9303','2014-03-26','12:55:00',1.2),('9303','2014-03-26','13:00:00',1.18),('9303','2014-03-26','13:05:00',1.23),('9303','2014-03-26','13:10:00',1.04),('9303','2014-03-26','13:25:00',4.35),('9303','2014-03-26','13:30:00',3),('9303','2014-03-26','13:35:00',1.52),('9303','2014-03-26','13:40:00',1.25),('9303','2014-03-26','13:55:00',1.02),('9303','2014-03-26','14:00:00',1.41),('9303','2014-03-26','14:05:00',2.48),('9303','2014-03-26','14:10:00',4.53),('9303','2014-03-26','14:15:00',2.28),('9303','2014-03-26','14:45:00',1.73),('9303','2014-03-26','14:50:00',3.13),('9303','2014-03-26','14:55:00',3.3),('9303','2014-03-26','15:00:00',2.96),('9303','2014-03-26','15:05:00',3),('9303','2014-03-26','15:10:00',3.1),('9303','2014-03-26','15:15:00',3.29),('9303','2014-03-26','15:20:00',3.1),('9303','2014-03-26','15:25:00',2.89),('9303','2014-03-26','15:30:00',3.05),('9303','2014-03-26','15:35:00',2.96),('9303','2014-03-26','15:40:00',2.34),('9303','2014-03-26','15:45:00',2.42),('9303','2014-03-26','15:50:00',2.07),('9303','2014-03-26','15:55:00',1.7),('9303','2014-03-26','16:00:00',1.26),('9303','2014-03-26','16:05:00',1.44),('9303','2014-03-26','16:10:00',1.4),('9303','2014-03-26','16:15:00',1.22),('9303','2013-03-22','07:35:00',1.05),('9303','2013-03-22','07:40:00',1.15),('9303','2013-03-22','07:45:00',1.26),('9303','2013-03-22','07:50:00',1.35),('9303','2013-03-22','07:55:00',1.45),('9303','2013-03-22','08:00:00',1.55),('9303','2013-03-22','08:05:00',1.65),('9303','2013-03-22','08:10:00',1.77),('9303','2013-03-22','08:15:00',1.87),('9303','2013-03-22','08:20:00',1.96),('9303','2013-03-22','08:25:00',2.05),('9303','2013-03-22','08:30:00',2.13),('9303','2013-03-22','08:35:00',2.22),('9303','2013-03-22','08:40:00',2.3),('9303','2013-03-22','08:45:00',2.38),('9303','2013-03-22','08:50:00',2.45),('9303','2013-03-22','08:55:00',2.51),('9303','2013-03-22','09:00:00',2.58),('9303','2013-03-22','09:05:00',2.64),('9303','2013-03-22','09:10:00',2.71),('9303','2013-03-22','09:15:00',2.77),('9303','2013-03-22','09:20:00',2.83),('9303','2013-03-22','09:25:00',2.88),('9303','2013-03-22','09:30:00',2.93),('9303','2013-03-22','09:35:00',3.04),('9303','2013-03-22','09:40:00',3.08),('9303','2013-03-22','09:45:00',3.19),('9303','2013-03-22','09:50:00',3.25),('9303','2013-03-22','09:55:00',3.26),('9303','2013-03-22','10:00:00',3.31),('9303','2013-03-22','10:05:00',3.33),('9303','2013-03-22','10:10:00',3.41),('9303','2013-03-22','10:15:00',3.46),('9303','2013-03-22','10:20:00',3.41),('9303','2013-03-22','10:25:00',3.54),('9303','2013-03-22','10:30:00',3.62),('9303','2013-03-22','10:35:00',3.68),('9303','2013-03-22','10:40:00',3.74),('9303','2013-03-22','10:45:00',3.77),('9303','2013-03-22','10:50:00',3.8),('9303','2013-03-22','10:55:00',3.82),('9303','2013-03-22','11:00:00',3.81),('9303','2013-03-22','11:05:00',3.87),('9303','2013-03-22','11:10:00',3.88),('9303','2013-03-22','11:15:00',3.91),('9303','2013-03-22','11:20:00',3.95),('9303','2013-03-22','11:25:00',3.92),('9303','2013-03-22','11:30:00',3.93),('9303','2013-03-22','11:35:00',4),('9303','2013-03-22','11:40:00',4.01),('9303','2013-03-22','11:45:00',4.04),('9303','2013-03-22','11:50:00',4),('9303','2013-03-22','11:55:00',4.07),('9303','2013-03-22','12:00:00',4.07),('9303','2013-03-22','12:05:00',4.09),('9303','2013-03-22','12:10:00',4.06),('9303','2013-03-22','12:15:00',4.1),('9303','2013-03-22','12:20:00',4.09),('9303','2013-03-22','12:25:00',4.07),('9303','2013-03-22','12:30:00',4.11),('9303','2013-03-22','12:35:00',4.07),('9303','2013-03-22','12:40:00',4.1),('9303','2013-03-22','12:45:00',4.06),('9303','2013-03-22','12:50:00',3.94),('9303','2013-03-22','12:55:00',3.74),('9303','2013-03-22','13:00:00',4.05),('9303','2013-03-22','13:05:00',3.9),('9303','2013-03-22','13:10:00',4.06),('9303','2013-03-22','13:15:00',4.02),('9303','2013-03-22','13:20:00',3.94),('9303','2013-03-22','13:25:00',3.76),('9303','2013-03-22','13:30:00',3.73),('9303','2013-03-22','13:35:00',3.8),('9303','2013-03-22','13:40:00',3.2),('9303','2013-03-22','13:45:00',3.33),('9303','2013-03-22','13:50:00',3.83),('9303','2013-03-22','13:55:00',3.77),('9303','2013-03-22','14:00:00',3.7),('9303','2013-03-22','14:05:00',3.67),('9303','2013-03-22','14:10:00',3.62),('9303','2013-03-22','14:15:00',3.57),('9303','2013-03-22','14:20:00',3.52),('9303','2013-03-22','14:25:00',3.46),('9303','2013-03-22','14:30:00',3.4),('9303','2013-03-22','14:35:00',3.34),('9303','2013-03-22','14:40:00',3.26),('9303','2013-03-22','14:45:00',3.21),('9303','2013-03-22','14:50:00',3.16),('9303','2013-03-22','14:55:00',3.12),('9303','2013-03-22','15:00:00',3.06),('9303','2013-03-22','15:05:00',2.97),('9303','2013-03-22','15:10:00',2.63),('9303','2013-03-22','15:15:00',2.17),('9303','2013-03-22','15:20:00',2.14),('9303','2013-03-22','15:25:00',2.3),('9303','2013-03-22','15:30:00',2.11),('9303','2013-03-22','15:35:00',2.31),('9303','2013-03-22','15:40:00',2.19),('9303','2013-03-22','15:45:00',1.89),('9303','2013-03-22','15:50:00',2.02),('9303','2013-03-22','15:55:00',1.68),('9303','2013-03-22','16:00:00',1.23),('9303','2013-03-22','16:05:00',1.26),('9303','2013-03-22','16:10:00',1.46),('9303','2013-03-22','16:15:00',1.71),('9303','2013-03-22','16:20:00',1.36),('9303','2013-03-22','16:25:00',1.33),('9303','2013-03-22','16:30:00',1.48),('9303','2013-03-22','16:35:00',1.4),('9303','2013-03-22','16:40:00',1.33),('9303','2013-03-22','16:45:00',1.25),('9303','2013-03-22','16:50:00',1.13),('9303','2013-03-22','16:55:00',1.05),('9303','2013-03-21','07:45:00',1.2),('9303','2013-03-21','07:50:00',1.47),('9303','2013-03-21','08:10:00',1.21),('9303','2013-03-21','08:15:00',1.99),('9303','2013-03-21','08:20:00',2.09),('9303','2013-03-21','08:25:00',2.11),('9303','2013-03-21','08:30:00',2.12),('9303','2013-03-21','08:35:00',2.32),('9303','2013-03-21','08:40:00',2.51),('9303','2013-03-21','08:45:00',2.41),('9303','2013-03-21','08:50:00',2.45),('9303','2013-03-21','08:55:00',2.29),('9303','2013-03-21','09:00:00',2.79),('9303','2013-03-21','09:05:00',2.98),('9303','2013-03-21','09:10:00',3.23),('9303','2013-03-21','09:15:00',2.11),('9303','2013-03-21','09:20:00',2.7),('9303','2013-03-21','09:25:00',3.28),('9303','2013-03-21','09:30:00',3.26),('9303','2013-03-21','09:35:00',3.26),('9303','2013-03-21','09:40:00',3.33),('9303','2013-03-21','09:45:00',3.35),('9303','2013-03-21','09:50:00',3.49),('9303','2013-03-21','09:55:00',3.55),('9303','2013-03-21','10:00:00',3.62),('9303','2013-03-21','10:05:00',3.66),('9303','2013-03-21','10:10:00',3.69),('9303','2013-03-21','10:15:00',3.7),('9303','2013-03-21','10:20:00',3.76),('9303','2013-03-21','10:25:00',3.77),('9303','2013-03-21','10:30:00',3.81),('9303','2013-03-21','10:35:00',3.88),('9303','2013-03-21','10:40:00',3.9),('9303','2013-03-21','10:45:00',3.89),('9303','2013-03-21','10:50:00',3.89),('9303','2013-03-21','10:55:00',2.93),('9303','2013-03-21','11:00:00',4.08),('9303','2013-03-21','11:05:00',4.07),('9303','2013-03-21','11:10:00',4.09),('9303','2013-03-21','11:15:00',4.13),('9303','2013-03-21','11:20:00',4.14),('9303','2013-03-21','11:25:00',4.18),('9303','2013-03-21','11:30:00',4.2),('9303','2013-03-21','11:35:00',4.22),('9303','2013-03-21','11:40:00',4.23),('9303','2013-03-21','11:45:00',4.26),('9303','2013-03-21','11:50:00',4.28),('9303','2013-03-21','11:55:00',4.3),('9303','2013-03-21','12:00:00',4.29),('9303','2013-03-21','12:05:00',4.29),('9303','2013-03-21','12:10:00',4.3),('9303','2013-03-21','12:15:00',4.3),('9303','2013-03-21','12:20:00',4.28),('9303','2013-03-21','12:25:00',4.27),('9303','2013-03-21','12:30:00',4.26),('9303','2013-03-21','12:35:00',4.29),('9303','2013-03-21','12:40:00',4.29),('9303','2013-03-21','12:45:00',4.25),('9303','2013-03-21','12:50:00',4.22),('9303','2013-03-21','12:55:00',4.19),('9303','2013-03-21','13:00:00',4.17),('9303','2013-03-21','13:05:00',4.13),('9303','2013-03-21','13:10:00',4.1),('9303','2013-03-21','13:15:00',4.07),('9303','2013-03-21','13:20:00',4.05),('9303','2013-03-21','13:25:00',4.03),('9303','2013-03-21','13:30:00',4.01),('9303','2013-03-21','13:35:00',3.98),('9303','2013-03-21','13:40:00',3.96),('9303','2013-03-21','13:45:00',3.92),('9303','2013-03-21','13:50:00',3.89),('9303','2013-03-21','13:55:00',3.83),('9303','2013-03-21','14:00:00',3.81),('9303','2013-03-21','14:05:00',3.74),('9303','2013-03-21','14:10:00',3.66),('9303','2013-03-21','14:15:00',3.58),('9303','2013-03-21','14:20:00',3.55),('9303','2013-03-21','14:25:00',3.52),('9303','2013-03-21','14:30:00',3.43),('9303','2013-03-21','14:35:00',3.38),('9303','2013-03-21','14:40:00',3.3),('9303','2013-03-21','14:45:00',3.25),('9303','2013-03-21','14:50:00',3.2),('9303','2013-03-21','14:55:00',3.15),('9303','2013-03-21','15:00:00',3.08),('9303','2013-03-21','15:05:00',3.02),('9303','2013-03-21','15:10:00',2.94),('9303','2013-03-21','15:15:00',2.87),('9303','2013-03-21','15:20:00',2.78),('9303','2013-03-21','15:25:00',2.69),('9303','2013-03-21','15:30:00',2.62),('9303','2013-03-21','15:35:00',2.52),('9303','2013-03-21','15:40:00',2.39),('9303','2013-03-21','15:45:00',2.25),('9303','2013-03-21','15:50:00',2.16),('9303','2013-03-21','15:55:00',2.07),('9303','2013-03-21','16:00:00',1.99),('9303','2013-03-21','16:05:00',1.91),('9303','2013-03-21','16:10:00',1.78),('9303','2013-03-21','16:15:00',1.7),('9303','2013-03-21','16:20:00',1.61),('9303','2013-03-21','16:25:00',1.51),('9303','2013-03-21','16:30:00',1.4),('9303','2013-03-21','16:35:00',1.27),('9303','2013-03-21','16:40:00',1.15),('9303','2013-03-21','16:45:00',1.09),('9303','2013-03-20','07:35:00',1.09),('9303','2013-03-20','07:40:00',1.14),('9303','2013-03-20','07:45:00',1.2),('9303','2013-03-20','07:50:00',1.24),('9303','2013-03-20','07:55:00',1.47),('9303','2013-03-20','08:00:00',1.42),('9303','2013-03-20','08:05:00',1.47),('9303','2013-03-20','08:10:00',1.71),('9303','2013-03-20','08:15:00',1.79),('9303','2013-03-20','08:20:00',1.88),('9303','2013-03-20','08:25:00',2.01),('9303','2013-03-20','08:30:00',2.11),('9303','2013-03-20','08:35:00',2.17),('9303','2013-03-20','08:40:00',2.02),('9303','2013-03-20','08:45:00',2.23),('9303','2013-03-20','08:50:00',2.34),('9303','2013-03-20','08:55:00',2.29),('9303','2013-03-20','09:00:00',2.25),('9303','2013-03-20','09:05:00',3.01),('9303','2013-03-20','09:10:00',2.38),('9303','2013-03-20','09:15:00',2.72),('9303','2013-03-20','09:20:00',2.7),('9303','2013-03-20','09:25:00',2.65),('9303','2013-03-20','09:30:00',3.01),('9303','2013-03-20','09:35:00',2.89),('9303','2013-03-20','09:40:00',3.06),('9303','2013-03-20','09:45:00',3.14),('9303','2013-03-20','09:50:00',3.17),('9303','2013-03-20','09:55:00',3.18),('9303','2013-03-20','10:00:00',3.26),('9303','2013-03-20','10:05:00',3.2),('9303','2013-03-20','10:10:00',3.35),('9303','2013-03-20','10:15:00',2.45),('9303','2013-03-20','10:20:00',2.41),('9303','2013-03-20','10:25:00',2.29),('9303','2013-03-20','10:30:00',2.88),('9303','2013-03-20','10:35:00',3.38),('9303','2013-03-20','10:40:00',2.98),('9303','2013-03-20','10:45:00',2.25),('9303','2013-03-20','10:50:00',3.15),('9303','2013-03-20','10:55:00',2.83),('9303','2013-03-20','11:00:00',2.71),('9303','2013-03-20','11:05:00',3.1),('9303','2013-03-20','11:10:00',2.59),('9303','2013-03-20','11:15:00',2.32),('9303','2013-03-20','11:20:00',2.58),('9303','2013-03-20','11:25:00',2.55),('9303','2013-03-20','11:30:00',2.35),('9303','2013-03-20','11:35:00',2.59),('9303','2013-03-20','11:40:00',2.08),('9303','2013-03-20','11:45:00',1.96),('9303','2013-03-20','11:50:00',1.85),('9303','2013-03-20','11:55:00',2.1),('9303','2013-03-20','12:00:00',2.02),('9303','2013-03-20','12:05:00',2.27),('9303','2013-03-20','12:10:00',1.86),('9303','2013-03-20','12:15:00',1.6),('9303','2013-03-20','12:20:00',1.48),('9303','2013-03-20','12:25:00',1.24),('9303','2013-03-20','12:35:00',1.2),('9303','2013-03-20','12:50:00',1.32),('9303','2013-03-20','12:55:00',1.52),('9303','2013-03-20','13:00:00',1.73),('9303','2013-03-20','13:05:00',1.25),('9303','2013-03-20','13:10:00',1.33),('9303','2013-03-20','13:15:00',1.06),('9303','2013-03-20','13:20:00',1.16),('9303','2013-03-20','13:25:00',1.25),('9303','2013-03-20','13:30:00',1.38),('9303','2013-03-20','13:35:00',1.3),('9303','2013-03-20','13:40:00',1.61),('9303','2013-03-20','13:45:00',1.92),('9303','2013-03-20','13:50:00',1.62),('9303','2013-03-20','13:55:00',1.5),('9303','2013-03-20','14:00:00',1.51),('9303','2013-03-20','14:05:00',1.28),('9303','2013-03-20','14:10:00',1.19),('9303','2013-03-20','14:15:00',1.57),('9303','2013-03-20','14:20:00',2.01),('9303','2013-03-20','14:25:00',1.85),('9303','2013-03-20','14:30:00',1.61),('9303','2013-03-20','14:35:00',1.31),('9303','2013-03-20','14:40:00',1.04),('9303','2013-03-20','14:45:00',1.02),('9303','2013-03-19','07:40:00',1.06),('9303','2013-03-19','07:45:00',1.16),('9303','2013-03-19','07:50:00',1.29),('9303','2013-03-19','07:55:00',1.32),('9303','2013-03-19','08:05:00',1.3),('9303','2013-03-19','08:10:00',1.59),('9303','2013-03-19','08:15:00',1.79),('9303','2013-03-19','08:20:00',1.87),('9303','2013-03-19','08:25:00',1.94),('9303','2013-03-19','08:30:00',1.87),('9303','2013-03-19','08:35:00',2.13),('9303','2013-03-19','08:40:00',2.23),('9303','2013-03-19','08:45:00',2.34),('9303','2013-03-19','08:50:00',2.44),('9303','2013-03-19','08:55:00',2.5),('9303','2013-03-19','09:00:00',2.58),('9303','2013-03-19','09:05:00',2.55),('9303','2013-03-19','09:10:00',2.75),('9303','2013-03-19','09:15:00',2.43),('9303','2013-03-19','09:20:00',2.57),('9303','2013-03-19','09:25:00',2.78),('9303','2013-03-19','09:30:00',3.05),('9303','2013-03-19','09:35:00',3.12),('9303','2013-03-19','09:40:00',3.24),('9303','2013-03-19','09:45:00',3.33),('9303','2013-03-19','09:50:00',3.4),('9303','2013-03-19','09:55:00',2.78),('9303','2013-03-19','10:00:00',3.54),('9303','2013-03-19','10:05:00',2.98),('9303','2013-03-19','10:10:00',3.28),('9303','2013-03-19','10:15:00',3.6),('9303','2013-03-19','10:20:00',3.65),('9303','2013-03-19','10:25:00',3.76),('9303','2013-03-19','10:30:00',3.77),('9303','2013-03-19','10:35:00',3.8),('9303','2013-03-19','10:40:00',3.84),('9303','2013-03-19','10:45:00',3.77),('9303','2013-03-19','10:50:00',3.93),('9303','2013-03-19','10:55:00',3.86),('9303','2013-03-19','11:00:00',4.01),('9303','2013-03-19','11:05:00',4.02),('9303','2013-03-19','11:10:00',3.96),('9303','2013-03-19','11:15:00',4.1),('9303','2013-03-19','11:20:00',4.11),('9303','2013-03-19','11:25:00',4.09),('9303','2013-03-19','11:30:00',4.11),('9303','2013-03-19','11:35:00',2.64),('9303','2013-03-19','11:40:00',3.61),('9303','2013-03-19','11:45:00',3.83),('9303','2013-03-19','11:50:00',4.16),('9303','2013-03-19','11:55:00',4.25),('9303','2013-03-19','12:00:00',4.21),('9303','2013-03-19','12:05:00',4.15),('9303','2013-03-19','12:10:00',4.16),('9303','2013-03-19','12:15:00',3.97),('9303','2013-03-19','12:20:00',4.17),('9303','2013-03-19','12:25:00',4.14),('9303','2013-03-19','12:30:00',4.15),('9303','2013-03-19','12:35:00',4.13),('9303','2013-03-19','12:40:00',4.12),('9303','2013-03-19','12:45:00',4.15),('9303','2013-03-19','12:50:00',3.97),('9303','2013-03-19','12:55:00',3.98),('9303','2013-03-19','13:00:00',4.08),('9303','2013-03-19','13:05:00',4.05),('9303','2013-03-19','13:10:00',3.99),('9303','2013-03-19','13:15:00',3.99),('9303','2013-03-19','13:20:00',3.93),('9303','2013-03-19','13:25:00',3.92),('9303','2013-03-19','13:30:00',3.92),('9303','2013-03-19','13:35:00',3.87),('9303','2013-03-19','13:40:00',3.8),('9303','2013-03-19','13:45:00',3.79),('9303','2013-03-19','13:50:00',3.76),('9303','2013-03-19','13:55:00',3.71),('9303','2013-03-19','14:00:00',3.69),('9303','2013-03-19','14:05:00',3.64),('9303','2013-03-19','14:10:00',3.63),('9303','2013-03-19','14:15:00',3.59),('9303','2013-03-19','14:20:00',3.53),('9303','2013-03-19','14:25:00',3.46),('9303','2013-03-19','14:30:00',3.38),('9303','2013-03-19','14:35:00',3.31),('9303','2013-03-19','14:40:00',3.27),('9303','2013-03-19','14:45:00',3.22),('9303','2013-03-19','14:50:00',3.13),('9303','2013-03-19','14:55:00',3.05),('9303','2013-03-19','15:00:00',2.98),('9303','2013-03-19','15:05:00',2.93),('9303','2013-03-19','15:10:00',2.86),('9303','2013-03-19','15:15:00',2.78),('9303','2013-03-19','15:20:00',2.73),('9303','2013-03-19','15:25:00',2.64),('9303','2013-03-19','15:30:00',2.56),('9303','2013-03-19','15:35:00',2.46),('9303','2013-03-19','15:40:00',2.34),('9303','2013-03-19','15:45:00',2.21),('9303','2013-03-19','15:50:00',2.13),('9303','2013-03-19','15:55:00',2.05),('9303','2013-03-19','16:00:00',1.95),('9303','2013-03-19','16:05:00',1.85),('9303','2013-03-19','16:10:00',1.73),('9303','2013-03-19','16:15:00',1.65),('9303','2013-03-19','16:20:00',1.56),('9303','2013-03-19','16:25:00',1.49),('9303','2013-03-19','16:30:00',1.4),('9303','2013-03-19','16:35:00',1.27),('9303','2013-03-19','16:40:00',1.18),('9303','2013-03-18','10:00:00',1.1),('9303','2013-03-18','10:05:00',1.36),('9303','2013-03-18','10:10:00',1.36),('9303','2013-03-18','10:15:00',1.17),('9303','2013-03-18','10:20:00',1.4),('9303','2013-03-18','10:25:00',1.8),('9303','2013-03-18','10:30:00',1.71),('9303','2013-03-18','10:35:00',1.39),('9303','2013-03-18','10:40:00',1.28),('9303','2013-03-18','10:45:00',1.33),('9303','2013-03-18','10:50:00',1.3),('9303','2013-03-18','10:55:00',1.07),('9303','2013-03-18','11:00:00',1.16),('9303','2013-03-18','11:05:00',1.29),('9303','2013-03-18','11:10:00',1.45),('9303','2013-03-18','11:15:00',1.58),('9303','2013-03-18','11:20:00',1.63),('9303','2013-03-18','11:25:00',1.71),('9303','2013-03-18','11:30:00',2.18),('9303','2013-03-18','11:35:00',1.81),('9303','2013-03-18','11:40:00',1.59),('9303','2013-03-18','11:45:00',1.33),('9303','2013-03-18','11:50:00',1.08),('9303','2013-03-18','11:55:00',1.32),('9303','2013-03-18','12:00:00',1.38),('9303','2013-03-18','12:05:00',2.37),('9303','2013-03-18','12:10:00',2.27),('9303','2013-03-18','12:15:00',2.71),('9303','2013-03-18','12:20:00',2.63),('9303','2013-03-18','12:25:00',1.81),('9303','2013-03-18','12:30:00',3.24),('9303','2013-03-18','12:35:00',3.5),('9303','2013-03-18','12:40:00',2.86),('9303','2013-03-18','12:45:00',2.46),('9303','2013-03-18','12:50:00',3.51),('9303','2013-03-18','12:55:00',3.7),('9303','2013-03-18','13:00:00',2.53),('9303','2013-03-18','13:05:00',1.39),('9303','2013-03-18','13:10:00',1.03),('9303','2013-03-18','13:25:00',1.57),('9303','2013-03-18','13:30:00',1.26),('9303','2013-03-18','13:35:00',1.05),('9303','2013-03-18','13:40:00',1.7),('9303','2013-03-18','13:45:00',1.63),('9303','2013-03-18','13:50:00',1.56),('9303','2013-03-18','13:55:00',1.42),('9303','2013-03-18','14:00:00',1.54),('9303','2013-03-18','14:05:00',2.42),('9303','2013-03-18','14:10:00',2.28),('9303','2013-03-18','14:15:00',1.12),('9303','2013-03-18','14:20:00',1.03),('9303','2013-03-18','14:25:00',1.43),('9303','2013-03-18','14:35:00',1.02),('9303','2013-03-18','14:40:00',1.1),('9303','2013-03-18','14:45:00',1),('9303','2013-03-17','08:15:00',1.11),('9303','2013-03-17','08:20:00',1.26),('9303','2013-03-17','08:25:00',1.51),('9303','2013-03-17','08:30:00',1.34),('9303','2013-03-17','08:35:00',1.12),('9303','2013-03-17','08:40:00',1.15),('9303','2013-03-17','08:45:00',1.36),('9303','2013-03-17','08:50:00',1.34),('9303','2013-03-17','08:55:00',1.25),('9303','2013-03-17','09:00:00',1.21),('9303','2013-03-17','09:05:00',1.42),('9303','2013-03-17','09:10:00',1.62),('9303','2013-03-17','09:15:00',1.76),('9303','2013-03-17','09:20:00',1.5),('9303','2013-03-17','09:25:00',1.25),('9303','2013-03-17','09:30:00',1.36),('9303','2013-03-17','09:35:00',1.57),('9303','2013-03-17','09:40:00',1.45),('9303','2013-03-17','09:45:00',1.47),('9303','2013-03-17','09:50:00',1.65),('9303','2013-03-17','09:55:00',1.79),('9303','2013-03-17','10:00:00',1.97),('9303','2013-03-17','10:05:00',1.65),('9303','2013-03-17','10:10:00',1.61),('9303','2013-03-17','10:15:00',1.76),('9303','2013-03-17','10:20:00',1.77),('9303','2013-03-17','10:25:00',1.86),('9303','2013-03-17','10:30:00',1.82),('9303','2013-03-17','10:35:00',1.73),('9303','2013-03-17','10:40:00',1.64),('9303','2013-03-17','10:45:00',1.73),('9303','2013-03-17','10:50:00',1.66),('9303','2013-03-17','10:55:00',1.48),('9303','2013-03-17','11:00:00',1.52),('9303','2013-03-17','11:05:00',1.32),('9303','2013-03-17','11:10:00',1.24),('9303','2013-03-17','11:15:00',1.33),('9303','2013-03-17','11:20:00',1.55),('9303','2013-03-17','11:25:00',1.62),('9303','2013-03-17','11:30:00',1.43),('9303','2013-03-17','11:35:00',1.41),('9303','2013-03-17','11:40:00',1.34),('9303','2013-03-17','11:45:00',1.23),('9303','2013-03-17','11:50:00',1.14),('9303','2013-03-17','11:55:00',1.02),('9303','2013-03-17','12:10:00',1.25),('9303','2013-03-17','12:15:00',1.72),('9303','2013-03-17','12:20:00',2.13),('9303','2013-03-17','12:25:00',3.3),('9303','2013-03-17','12:30:00',3.67),('9303','2013-03-17','12:35:00',2.36),('9303','2013-03-17','12:40:00',2.61),('9303','2013-03-17','12:45:00',2.38),('9303','2013-03-17','12:50:00',2.08),('9303','2013-03-17','12:55:00',1.59),('9303','2013-03-17','13:00:00',1.84),('9303','2013-03-17','13:05:00',2.07),('9303','2013-03-17','13:10:00',2.27),('9303','2013-03-17','13:15:00',2.21),('9303','2013-03-17','13:20:00',1.83),('9303','2013-03-17','13:25:00',1.63),('9303','2013-03-17','13:30:00',2.48),('9303','2013-03-17','13:35:00',2.87),('9303','2013-03-17','13:40:00',1.89),('9303','2013-03-17','13:45:00',1.71),('9303','2013-03-17','13:50:00',1.31),('9303','2013-03-17','13:55:00',1.92),('9303','2013-03-17','14:00:00',1.98),('9303','2013-03-17','14:05:00',1.92),('9303','2013-03-17','14:10:00',2.33),('9303','2013-03-17','14:15:00',2.62),('9303','2013-03-17','14:20:00',2.46),('9303','2013-03-17','14:25:00',2.41),('9303','2013-03-17','14:30:00',2.2),('9303','2013-03-17','14:35:00',1.83),('9303','2013-03-17','14:40:00',1.43),('9303','2013-03-17','14:45:00',1.26),('9303','2013-03-17','14:50:00',1.06),('9303','2013-03-17','14:55:00',1.11),('9303','2013-03-17','15:00:00',1.38),('9303','2013-03-17','15:05:00',1.54),('9303','2013-03-17','15:10:00',2),('9303','2013-03-17','15:15:00',1.83),('9303','2013-03-17','15:20:00',1.98),('9303','2013-03-17','15:25:00',1.81),('9303','2013-03-17','15:30:00',1.19),('9303','2013-03-17','15:35:00',1.49),('9303','2013-03-17','15:40:00',1.33),('9303','2013-03-17','15:45:00',1.43),('9303','2013-03-16','08:05:00',1.07),('9303','2013-03-16','08:15:00',1.49),('9303','2013-03-16','08:20:00',2.03),('9303','2013-03-16','08:25:00',2.18),('9303','2013-03-16','08:30:00',2.16),('9303','2013-03-16','08:35:00',2.25),('9303','2013-03-16','08:40:00',2.34),('9303','2013-03-16','08:45:00',2.21),('9303','2013-03-16','08:50:00',2.52),('9303','2013-03-16','08:55:00',2.71),('9303','2013-03-16','09:00:00',2.64),('9303','2013-03-16','09:05:00',1.83),('9303','2013-03-16','09:10:00',2.41),('9303','2013-03-16','09:15:00',2.93),('9303','2013-03-16','09:20:00',2.99),('9303','2013-03-16','09:25:00',2.85),('9303','2013-03-16','09:30:00',3.11),('9303','2013-03-16','09:35:00',3.32),('9303','2013-03-16','09:40:00',3.38),('9303','2013-03-16','09:45:00',3.56),('9303','2013-03-16','09:50:00',3.46),('9303','2013-03-16','09:55:00',3.57),('9303','2013-03-16','10:00:00',2.85),('9303','2013-03-16','10:05:00',1.76),('9303','2013-03-16','10:10:00',2.54),('9303','2013-03-16','10:15:00',2.49),('9303','2013-03-16','10:20:00',1.71),('9303','2013-03-16','10:25:00',2.2),('9303','2013-03-16','10:30:00',1.98),('9303','2013-03-16','10:35:00',1.69),('9303','2013-03-16','10:40:00',2.97),('9303','2013-03-16','10:45:00',3.95),('9303','2013-03-16','10:50:00',3.93),('9303','2013-03-16','10:55:00',3.81),('9303','2013-03-16','11:00:00',3.99),('9303','2013-03-16','11:05:00',4),('9303','2013-03-16','11:10:00',4.02),('9303','2013-03-16','11:15:00',4.04),('9303','2013-03-16','11:20:00',4.03),('9303','2013-03-16','11:25:00',4.05),('9303','2013-03-16','11:30:00',4.07),('9303','2013-03-16','11:35:00',4.08),('9303','2013-03-16','11:40:00',4.12),('9303','2013-03-16','11:45:00',4.13),('9303','2013-03-16','11:50:00',4.11),('9303','2013-03-16','11:55:00',4.12),('9303','2013-03-16','12:00:00',4.11),('9303','2013-03-16','12:05:00',4.09),('9303','2013-03-16','12:10:00',4.13),('9303','2013-03-16','12:15:00',4.14),('9303','2013-03-16','12:20:00',4.11),('9303','2013-03-16','12:25:00',4.12),('9303','2013-03-16','12:30:00',4.11),('9303','2013-03-16','12:35:00',4.09),('9303','2013-03-16','12:40:00',4.04),('9303','2013-03-16','12:45:00',4.03),('9303','2013-03-16','12:50:00',4.01),('9303','2013-03-16','12:55:00',3.95),('9303','2013-03-16','13:00:00',3.92),('9303','2013-03-16','13:05:00',3.92),('9303','2013-03-16','13:10:00',3.91),('9303','2013-03-16','13:15:00',3.92),('9303','2013-03-16','13:20:00',1.84),('9303','2013-03-16','13:30:00',1.22),('9303','2013-03-16','13:35:00',3.51),('9303','2013-03-16','13:40:00',3.95),('9303','2013-03-16','13:45:00',3.89),('9303','2013-03-16','13:50:00',3.81),('9303','2013-03-16','13:55:00',3.26),('9303','2013-03-16','14:00:00',3.88),('9303','2013-03-16','14:05:00',3.75),('9303','2013-03-16','14:10:00',1.16),('9303','2013-03-16','14:15:00',3.24),('9303','2013-03-16','14:20:00',1.78),('9303','2013-03-16','14:25:00',1.56),('9303','2013-03-16','14:30:00',3.65),('9303','2013-03-16','14:35:00',3.38),('9303','2013-03-16','14:40:00',1.29),('9303','2013-03-16','16:05:00',1.58),('9303','2013-03-16','16:10:00',1.45),('9303','2013-03-16','16:15:00',1.39),('9303','2013-03-15','10:40:00',1.1),('9303','2013-03-15','10:45:00',1.31),('9303','2013-03-15','10:50:00',1.32),('9303','2013-03-15','10:55:00',1.41),('9303','2013-03-15','11:00:00',1.37),('9303','2013-03-15','11:05:00',1.22),('9303','2013-03-15','11:10:00',1.15),('9303','2013-03-15','11:20:00',1.16),('9303','2013-03-15','11:25:00',1.39),('9303','2013-03-15','11:30:00',1.56),('9303','2013-03-15','11:35:00',1.88),('9303','2013-03-15','11:40:00',2.28),('9303','2013-03-15','11:45:00',2.04),('9303','2013-03-15','11:50:00',1.91),('9303','2013-03-15','11:55:00',1.97),('9303','2013-03-15','12:00:00',1.75),('9303','2013-03-15','12:05:00',1.75),('9303','2013-03-15','12:10:00',1.86),('9303','2013-03-15','12:15:00',1.64),('9303','2013-03-15','12:20:00',1.61),('9303','2013-03-15','12:25:00',1.66),('9303','2013-03-15','12:30:00',1.71),('9303','2013-03-15','12:35:00',1.93),('9303','2013-03-15','12:40:00',1.71),('9303','2013-03-15','12:45:00',1.44),('9303','2013-03-15','12:50:00',1.36),('9303','2013-03-15','12:55:00',1.3),('9303','2013-03-15','13:00:00',1.22),('9303','2013-03-15','13:05:00',1.12),('9303','2013-03-15','13:10:00',1.17),('9303','2013-03-15','13:15:00',1.29),('9303','2013-03-15','13:20:00',1.37),('9303','2013-03-15','13:25:00',1.53),('9303','2013-03-15','13:30:00',1.48),('9303','2013-03-15','13:35:00',1.36),('9303','2013-03-15','13:40:00',1.41),('9303','2013-03-15','13:45:00',1.5),('9303','2013-03-15','13:50:00',1.24),('9303','2013-03-15','13:55:00',1.07),('9303','2013-03-15','14:55:00',1.06),('9303','2013-03-15','15:00:00',1.1);
INSERT INTO `solarlogmod` VALUES ('9303','2013-03-15','15:05:00',1.07),('9303','2013-03-15','15:10:00',1.07),('9303','2013-03-15','15:15:00',1.16),('9303','2013-03-15','15:20:00',1.17),('9303','2013-03-15','15:25:00',1.26),('9303','2013-03-15','15:30:00',1.13),('9303','2013-03-14','13:05:00',1.07),('9303','2013-03-14','13:10:00',1.06),('9303','2013-03-14','13:15:00',1.04),('9303','2013-03-14','13:20:00',1.13),('9303','2013-03-14','13:25:00',1.12),('9303','2013-03-14','13:30:00',1.06),('9303','2013-03-14','13:35:00',1.05),('9303','2013-03-14','13:40:00',1.09),('9303','2013-03-14','13:45:00',1.5),('9303','2013-03-14','13:50:00',1.86),('9303','2013-03-14','13:55:00',2.23),('9303','2013-03-14','14:00:00',1.84),('9303','2013-03-14','14:05:00',1.93),('9303','2013-03-14','14:10:00',1.18),('9303','2013-03-14','14:15:00',1.2),('9303','2013-03-14','14:20:00',1.06),('9303','2013-03-14','14:25:00',1.05),('9303','2013-03-14','14:30:00',1),('9303','2013-03-14','15:10:00',1.2),('9303','2013-03-14','15:15:00',1.23),('9303','2013-03-14','15:20:00',1.13),('9303','2013-03-14','15:25:00',1.15),('9303','2013-03-14','15:30:00',1.12),('9303','2013-03-13','08:50:00',1.06),('9303','2013-03-13','08:55:00',1.05),('9303','2013-03-13','09:10:00',1.12),('9303','2013-03-13','10:10:00',1.02),('9303','2013-03-13','10:15:00',2.07),('9303','2013-03-13','10:20:00',1.48),('9303','2013-03-13','10:25:00',1.78),('9303','2013-03-13','10:30:00',3.41),('9303','2013-03-13','10:35:00',2.6),('9303','2013-03-13','10:40:00',3.04),('9303','2013-03-13','10:45:00',1.4),('9303','2013-03-13','10:50:00',1.16),('9303','2013-03-13','10:55:00',1.01),('9303','2013-03-13','11:00:00',1.16),('9303','2013-03-13','11:30:00',1.05),('9303','2013-03-13','11:35:00',1.09),('9303','2013-03-13','11:40:00',1.09),('9303','2013-03-13','11:45:00',1.19),('9303','2013-03-13','11:50:00',1.09),('9303','2013-03-13','12:45:00',1.02),('9303','2013-03-13','12:50:00',1.22),('9303','2013-03-13','12:55:00',1.09),('9303','2013-03-13','13:00:00',1.04),('9303','2013-03-13','13:05:00',1.02),('9303','2014-03-25','07:20:00',1.12),('9303','2014-03-25','07:25:00',1.25),('9303','2014-03-25','07:30:00',1.38),('9303','2014-03-25','07:35:00',1.1),('9303','2014-03-25','07:40:00',1.01),('9303','2014-03-25','07:45:00',1.12),('9303','2014-03-25','07:50:00',1.18),('9303','2014-03-25','07:55:00',1.22),('9303','2014-03-25','08:00:00',1.14),('9303','2014-03-25','08:05:00',1.18),('9303','2014-03-25','08:10:00',1.27),('9303','2014-03-25','08:15:00',1.35),('9303','2014-03-25','08:20:00',1.21),('9303','2014-03-25','08:25:00',1.09),('9303','2014-03-25','08:35:00',1.01),('9303','2014-03-25','08:40:00',1.22),('9303','2014-03-25','08:45:00',1.75),('9303','2014-03-25','08:50:00',1.79),('9303','2014-03-25','08:55:00',1.9),('9303','2014-03-25','09:00:00',1.71),('9303','2014-03-25','09:05:00',1.67),('9303','2014-03-25','09:10:00',1.67),('9303','2014-03-25','09:15:00',2.21),('9303','2014-03-25','09:20:00',2.38),('9303','2014-03-25','09:25:00',2.08),('9303','2014-03-25','09:30:00',1.85),('9303','2014-03-25','09:35:00',1.69),('9303','2014-03-25','09:40:00',1.73),('9303','2014-03-25','09:45:00',1.64),('9303','2014-03-25','09:50:00',1.73),('9303','2014-03-25','09:55:00',1.95),('9303','2014-03-25','10:00:00',2.28),('9303','2014-03-25','10:05:00',2.43),('9303','2014-03-25','10:10:00',2.56),('9303','2014-03-25','10:15:00',2.75),('9303','2014-03-25','10:20:00',2.51),('9303','2014-03-25','10:25:00',2.56),('9303','2014-03-25','10:30:00',2.87),('9303','2014-03-25','10:35:00',2.41),('9303','2014-03-25','10:40:00',1.96),('9303','2014-03-25','10:45:00',1.78),('9303','2014-03-25','10:50:00',1.7),('9303','2014-03-25','10:55:00',1.71),('9303','2014-03-25','11:00:00',1.9),('9303','2014-03-25','11:05:00',2.18),('9303','2014-03-25','11:10:00',2.5),('9303','2014-03-25','11:15:00',2.87),('9303','2014-03-25','11:20:00',2.67),('9303','2014-03-25','11:25:00',2.74),('9303','2014-03-25','11:30:00',2.94),('9303','2014-03-25','11:35:00',2.35),('9303','2014-03-25','11:40:00',2.2),('9303','2014-03-25','11:45:00',1.96),('9303','2014-03-25','11:50:00',2.23),('9303','2014-03-25','11:55:00',1.8),('9303','2014-03-25','12:00:00',1.19),('9303','2014-03-25','12:20:00',1.06),('9303','2014-03-25','12:25:00',1.23),('9303','2013-03-12','08:20:00',1.7),('9303','2013-03-12','08:25:00',1.79),('9303','2013-03-12','08:30:00',1.86),('9303','2013-03-12','08:35:00',1.78),('9303','2013-03-12','08:40:00',1.86),('9303','2013-03-12','08:45:00',2.32),('9303','2013-03-12','08:50:00',1.48),('9303','2013-03-12','09:00:00',1.47),('9303','2013-03-12','09:05:00',2.48),('9303','2013-03-12','09:10:00',2.55),('9303','2013-03-12','09:15:00',2.6),('9303','2013-03-12','09:20:00',2.66),('9303','2013-03-12','09:25:00',2.74),('9303','2013-03-12','09:30:00',2.83),('9303','2013-03-12','09:35:00',2.9),('9303','2013-03-12','09:40:00',2.88),('9303','2013-03-12','09:45:00',2.94),('9303','2013-03-12','09:50:00',2.49),('9303','2013-03-12','09:55:00',3.33),('9303','2013-03-12','10:00:00',3.37),('9303','2013-03-12','10:05:00',3.05),('9303','2013-03-12','10:10:00',2.57),('9303','2013-03-12','10:15:00',3.11),('9303','2013-03-12','10:20:00',3.08),('9303','2013-03-12','10:25:00',3.79),('9303','2013-03-12','10:30:00',3.53),('9303','2013-03-12','10:35:00',2.4),('9303','2013-03-12','10:40:00',3.24),('9303','2013-03-12','10:45:00',1.43),('9303','2013-03-12','10:50:00',3.94),('9303','2013-03-12','10:55:00',3.85),('9303','2013-03-12','11:00:00',3.45),('9303','2013-03-12','11:05:00',4.29),('9303','2013-03-12','11:10:00',3.02),('9303','2013-03-12','11:15:00',3.17),('9303','2013-03-12','11:20:00',4.45),('9303','2013-03-12','11:25:00',1.6),('9303','2013-03-12','11:30:00',1.66),('9303','2013-03-12','11:35:00',1.69),('9303','2013-03-12','11:40:00',2),('9303','2013-03-12','11:45:00',2.23),('9303','2013-03-12','11:50:00',2.61),('9303','2013-03-12','11:55:00',3.7),('9303','2013-03-12','12:05:00',1.22),('9303','2013-03-12','12:10:00',3.93),('9303','2013-03-12','12:15:00',3.56),('9303','2013-03-12','12:20:00',1.84),('9303','2013-03-12','12:25:00',4.07),('9303','2013-03-12','12:30:00',5),('9303','2013-03-12','12:35:00',3.05),('9303','2013-03-12','12:40:00',3.79),('9303','2013-03-12','12:50:00',1.66),('9303','2013-03-12','12:55:00',1.96),('9303','2013-03-12','13:00:00',3.97),('9303','2013-03-12','13:05:00',2.11),('9303','2013-03-12','13:10:00',2.42),('9303','2013-03-12','13:15:00',2.38),('9303','2013-03-12','13:20:00',3.06),('9303','2013-03-12','13:25:00',1.91),('9303','2013-03-12','13:30:00',1.43),('9303','2013-03-12','13:35:00',1.64),('9303','2013-03-12','13:40:00',1.61),('9303','2013-03-12','13:45:00',1.1),('9303','2013-03-12','13:50:00',1.07),('9303','2013-03-12','13:55:00',1.77),('9303','2013-03-12','14:00:00',2.53),('9303','2013-03-12','14:05:00',1.95),('9303','2013-03-12','14:10:00',2.39),('9303','2013-03-11','08:15:00',1.31),('9303','2013-03-11','08:20:00',1.39),('9303','2013-03-11','08:25:00',1.5),('9303','2013-03-11','08:30:00',1.58),('9303','2013-03-11','08:35:00',1.67),('9303','2013-03-11','08:40:00',1.76),('9303','2013-03-11','08:45:00',1.84),('9303','2013-03-11','08:50:00',1.92),('9303','2013-03-11','08:55:00',1.98),('9303','2013-03-11','09:00:00',2.03),('9303','2013-03-11','09:05:00',2.09),('9303','2013-03-11','09:10:00',2.12),('9303','2013-03-11','09:15:00',2.25),('9303','2013-03-11','09:20:00',2.02),('9303','2013-03-11','09:25:00',1.7),('9303','2013-03-11','09:35:00',2.2),('9303','2013-03-11','09:40:00',2.7),('9303','2013-03-11','09:45:00',2.51),('9303','2013-03-11','10:10:00',1.03),('9303','2013-03-11','10:15:00',1.08),('9303','2013-03-11','10:20:00',1.2),('9303','2013-03-11','10:25:00',1.31),('9303','2013-03-11','10:30:00',1.19),('9303','2013-03-11','10:35:00',1.33),('9303','2013-03-11','10:40:00',1.83),('9303','2013-03-11','10:45:00',2.1),('9303','2013-03-11','10:50:00',2.8),('9303','2013-03-11','10:55:00',1.57),('9303','2013-03-11','11:00:00',1.4),('9303','2013-03-11','11:05:00',1.18),('9303','2013-03-11','11:10:00',1.35),('9303','2013-03-11','11:15:00',1.46),('9303','2013-03-11','11:20:00',1.28),('9303','2013-03-11','11:25:00',1.15),('9303','2013-03-11','11:30:00',2.17),('9303','2013-03-11','11:35:00',2.11),('9303','2013-03-11','11:40:00',1.81),('9303','2013-03-11','11:45:00',2.4),('9303','2013-03-11','11:50:00',2.04),('9303','2013-03-11','11:55:00',1.81),('9303','2013-03-11','12:00:00',1.61),('9303','2013-03-11','12:05:00',1.6),('9303','2013-03-11','12:10:00',2.1),('9303','2013-03-11','12:35:00',1.26),('9303','2013-03-11','12:40:00',1.14),('9303','2013-03-11','12:45:00',1.15),('9303','2013-03-11','12:50:00',1.95),('9303','2013-03-11','12:55:00',3.26),('9303','2013-03-11','13:00:00',2.61),('9303','2013-03-11','13:05:00',1.8),('9303','2013-03-11','13:10:00',2.47),('9303','2013-03-11','13:15:00',3.32),('9303','2013-03-11','13:20:00',3.22),('9303','2013-03-11','13:25:00',3.48),('9303','2013-03-11','13:30:00',3.32),('9303','2013-03-11','13:35:00',3.56),('9303','2013-03-11','13:40:00',3.22),('9303','2013-03-11','13:45:00',2.43),('9303','2013-03-11','13:50:00',1.53),('9303','2013-03-11','13:55:00',1.73),('9303','2013-03-11','14:25:00',1.69),('9303','2013-03-11','14:30:00',1.1),('9303','2013-03-11','14:40:00',1.38),('9303','2013-03-11','15:25:00',1.27),('9303','2013-03-11','15:30:00',2.01),('9303','2013-03-11','15:35:00',1.47),('9303','2013-03-11','15:40:00',1.31),('9303','2013-03-11','15:45:00',2.19),('9303','2013-03-11','15:50:00',1.8),('9303','2013-03-11','15:55:00',1.7),('9303','2013-03-11','16:00:00',1.43),('9303','2013-03-11','16:05:00',1.43),('9303','2013-03-11','16:10:00',1.16),('9303','2013-03-11','16:25:00',1.02),('9303','2013-03-11','16:30:00',1),('9303','2013-03-11','16:35:00',1.01),('9303','2013-03-11','16:45:00',1.18),('9303','2013-03-10','07:55:00',1.01),('9303','2013-03-10','08:00:00',1.07),('9303','2013-03-10','08:05:00',1.14),('9303','2013-03-10','08:10:00',1.26),('9303','2013-03-10','08:15:00',1.17),('9303','2013-03-10','08:20:00',1.39),('9303','2013-03-10','08:25:00',1.44),('9303','2013-03-10','08:30:00',1.51),('9303','2013-03-10','08:35:00',1.59),('9303','2013-03-10','08:40:00',1.66),('9303','2013-03-10','08:45:00',1.72),('9303','2013-03-10','08:50:00',1.79),('9303','2013-03-10','08:55:00',1.89),('9303','2013-03-10','09:00:00',1.96),('9303','2013-03-10','09:05:00',2.03),('9303','2013-03-10','09:10:00',2.09),('9303','2013-03-10','09:15:00',2.15),('9303','2013-03-10','09:20:00',2.21),('9303','2013-03-10','09:25:00',2.27),('9303','2013-03-10','09:30:00',2.34),('9303','2013-03-10','09:35:00',2.41),('9303','2013-03-10','09:40:00',2.51),('9303','2013-03-10','09:45:00',2.22),('9303','2013-03-10','09:50:00',1.83),('9303','2013-03-10','09:55:00',2.89),('9303','2013-03-10','10:00:00',1.56),('9303','2013-03-10','10:05:00',2.26),('9303','2013-03-10','10:10:00',2.53),('9303','2013-03-10','10:15:00',2.08),('9303','2013-03-10','10:20:00',2.31),('9303','2013-03-10','10:25:00',2.95),('9303','2013-03-10','10:30:00',2.55),('9303','2013-03-10','10:35:00',2.88),('9303','2013-03-10','10:40:00',2.64),('9303','2013-03-10','10:45:00',3.13),('9303','2013-03-10','10:50:00',2.86),('9303','2013-03-10','10:55:00',2.09),('9303','2013-03-10','11:00:00',2.55),('9303','2013-03-10','11:05:00',1.69),('9303','2013-03-10','11:10:00',2.67),('9303','2013-03-10','11:15:00',2.48),('9303','2013-03-10','11:20:00',1.25),('9303','2013-03-10','11:25:00',2.69),('9303','2013-03-10','11:30:00',1.68),('9303','2013-03-10','11:35:00',1.46),('9303','2013-03-10','11:40:00',1.25),('9303','2013-03-10','11:45:00',1.32),('9303','2013-03-10','11:50:00',1.94),('9303','2013-03-10','11:55:00',3.55),('9303','2013-03-10','12:00:00',3.2),('9303','2013-03-10','12:05:00',3.35),('9303','2013-03-10','12:10:00',3.47),('9303','2013-03-10','12:15:00',2.65),('9303','2013-03-10','12:20:00',2.63),('9303','2013-03-10','12:25:00',3.02),('9303','2013-03-10','12:30:00',1.27),('9303','2013-03-10','12:35:00',1.67),('9303','2013-03-10','12:40:00',1.55),('9303','2013-03-10','12:45:00',3.66),('9303','2013-03-10','12:50:00',3.54),('9303','2013-03-10','12:55:00',3.5),('9303','2013-03-10','13:00:00',3.36),('9303','2013-03-10','13:05:00',3.25),('9303','2013-03-10','13:10:00',3.09),('9303','2013-03-10','13:15:00',3.3),('9303','2013-03-10','13:20:00',3.35),('9303','2013-03-10','13:25:00',3.07),('9303','2013-03-10','13:30:00',3),('9303','2013-03-10','13:35:00',2.79),('9303','2013-03-10','13:40:00',1.62),('9303','2013-03-10','13:45:00',1.8),('9303','2013-03-10','13:50:00',1.6),('9303','2013-03-10','13:55:00',1.56),('9303','2013-03-10','14:00:00',1.35),('9303','2013-03-10','14:05:00',1.62),('9303','2013-03-10','14:10:00',1.77),('9303','2013-03-10','14:15:00',2.41),('9303','2013-03-10','14:20:00',2.4),('9303','2013-03-10','14:25:00',1.5),('9303','2013-03-10','14:30:00',1.59),('9303','2013-03-10','14:35:00',2.55),('9303','2013-03-10','14:40:00',2.22),('9303','2013-03-10','14:45:00',1.45),('9303','2013-03-10','14:50:00',1.44),('9303','2013-03-10','14:55:00',1.34),('9303','2013-03-10','15:00:00',1.02),('9303','2013-03-10','15:05:00',1.17),('9303','2013-03-10','15:10:00',1.2),('9303','2013-03-09','08:05:00',1.31),('9303','2013-03-09','08:10:00',1.25),('9303','2013-03-09','08:15:00',1.3),('9303','2013-03-09','08:20:00',1.34),('9303','2013-03-09','08:25:00',1.44),('9303','2013-03-09','08:30:00',1.52),('9303','2013-03-09','08:35:00',1.61),('9303','2013-03-09','08:40:00',1.71),('9303','2013-03-09','08:45:00',1.16),('9303','2013-03-09','08:50:00',1.12),('9303','2013-03-09','08:55:00',1.61),('9303','2013-03-09','09:00:00',1.21),('9303','2013-03-09','09:30:00',1.62),('9303','2013-03-09','09:35:00',1.99),('9303','2013-03-09','09:40:00',2.9),('9303','2013-03-09','09:45:00',3.16),('9303','2013-03-09','09:50:00',2.04),('9303','2013-03-09','09:55:00',2.31),('9303','2013-03-09','10:00:00',1),('9303','2013-03-09','10:05:00',1.03),('9303','2013-03-09','10:10:00',1.13),('9303','2013-03-09','10:20:00',1.22),('9303','2013-03-09','10:35:00',1.2),('9303','2013-03-09','10:40:00',1.77),('9303','2013-03-09','10:45:00',1.76),('9303','2013-03-09','10:50:00',3.44),('9303','2013-03-09','10:55:00',3),('9303','2013-03-09','11:00:00',2.78),('9303','2013-03-09','11:05:00',3.41),('9303','2013-03-09','11:10:00',3.31),('9303','2013-03-09','11:15:00',3.48),('9303','2013-03-09','11:20:00',3.49),('9303','2013-03-09','11:25:00',3.25),('9303','2013-03-09','11:30:00',3.4),('9303','2013-03-09','11:35:00',3.34),('9303','2013-03-09','11:40:00',3.37),('9303','2013-03-09','11:45:00',3.41),('9303','2013-03-09','11:50:00',3.32),('9303','2013-03-09','11:55:00',3.33),('9303','2013-03-09','12:00:00',3.13),('9303','2013-03-09','12:05:00',1.67),('9303','2013-03-09','12:10:00',1.53),('9303','2013-03-09','12:20:00',1.08),('9303','2013-03-09','12:25:00',1.71),('9303','2013-03-09','12:30:00',1.28),('9303','2013-03-09','12:35:00',1.37),('9303','2013-03-09','12:40:00',1.36),('9303','2013-03-09','12:45:00',1.8),('9303','2013-03-09','12:50:00',1.69),('9303','2013-03-09','12:55:00',2.54),('9303','2013-03-09','13:00:00',3.38),('9303','2013-03-09','13:05:00',3.27),('9303','2013-03-09','13:10:00',3.25),('9303','2013-03-09','13:15:00',3.29),('9303','2013-03-09','13:20:00',3.11),('9303','2013-03-09','13:25:00',2.3),('9303','2013-03-09','13:30:00',2.95),('9303','2013-03-09','13:35:00',2.86),('9303','2013-03-09','13:40:00',3.33),('9303','2013-03-09','13:45:00',3.17),('9303','2013-03-09','13:50:00',3.12),('9303','2013-03-09','13:55:00',1.22),('9303','2013-03-09','14:00:00',1),('9303','2013-03-09','14:05:00',1.03),('9303','2013-03-09','14:10:00',3.23),('9303','2013-03-09','14:15:00',2.14),('9303','2013-03-09','14:20:00',2.79),('9303','2013-03-09','14:25:00',2.69),('9303','2013-03-09','14:30:00',2.65),('9303','2013-03-09','14:35:00',2.59),('9303','2013-03-09','14:40:00',2.52),('9303','2013-03-09','14:45:00',2.48),('9303','2013-03-09','14:50:00',2.42),('9303','2013-03-09','14:55:00',2.37),('9303','2013-03-09','15:00:00',2.32),('9303','2013-03-09','15:05:00',2.25),('9303','2013-03-09','15:10:00',2.19),('9303','2013-03-09','15:15:00',2.13),('9303','2013-03-09','15:20:00',2.06),('9303','2013-03-09','15:25:00',1.97),('9303','2013-03-09','15:30:00',1.9),('9303','2013-03-09','15:35:00',1.84),('9303','2013-03-09','15:40:00',1.75),('9303','2013-03-09','15:45:00',1.7),('9303','2013-03-09','15:50:00',1.63),('9303','2013-03-09','15:55:00',1.46),('9303','2013-03-09','16:00:00',1.31),('9303','2013-03-09','16:05:00',1.31),('9303','2013-03-09','16:10:00',1.02),('9303','2013-03-09','16:15:00',1.16),('9303','2013-03-09','16:25:00',1.09),('9303','2013-03-08','08:30:00',1.2),('9303','2013-03-08','08:35:00',1.46),('9303','2013-03-08','09:30:00',1.34),('9303','2013-03-08','09:35:00',1.61),('9303','2013-03-08','09:45:00',1.41),('9303','2013-03-08','09:50:00',1.81),('9303','2013-03-08','09:55:00',1.53),('9303','2013-03-08','10:05:00',1.03),('9303','2013-03-08','10:10:00',1.36),('9303','2013-03-08','10:15:00',2.03),('9303','2013-03-08','10:20:00',1.69),('9303','2013-03-08','10:25:00',1.16),('9303','2013-03-08','10:30:00',1.34),('9303','2013-03-08','10:35:00',1.76),('9303','2013-03-08','10:40:00',1.38),('9303','2013-03-08','10:50:00',1.02),('9303','2013-03-08','10:55:00',1.04),('9303','2013-03-08','11:00:00',1.02),('9303','2013-03-08','11:35:00',1.11),('9303','2013-03-08','11:40:00',1.54),('9303','2013-03-08','11:45:00',1.28),('9303','2013-03-08','11:50:00',1.11),('9303','2013-03-08','11:55:00',1.18),('9303','2013-03-08','12:00:00',1.74),('9303','2013-03-08','12:05:00',1.21),('9303','2013-03-08','12:20:00',1.12),('9303','2013-03-08','12:35:00',1.27),('9303','2013-03-08','12:40:00',1.62),('9303','2013-03-08','12:45:00',1.82),('9303','2013-03-08','12:50:00',1.9),('9303','2013-03-08','12:55:00',1.6),('9303','2013-03-08','13:00:00',1.7),('9303','2013-03-08','13:05:00',1.68),('9303','2013-03-08','13:10:00',1.2),('9303','2013-03-08','13:25:00',1.18),('9303','2013-03-08','13:30:00',1.5),('9303','2013-03-08','13:35:00',1.12),('9303','2013-03-08','13:40:00',1.03),('9303','2013-03-07','10:55:00',1.08),('9303','2013-03-07','11:05:00',1.42),('9303','2013-03-07','11:10:00',1.02),('9303','2013-03-07','11:30:00',1.24),('9303','2013-03-07','11:35:00',1.77),('9303','2013-03-07','11:40:00',1.77),('9303','2013-03-07','11:45:00',2.12),('9303','2013-03-07','11:50:00',2.13),('9303','2013-03-07','11:55:00',1.42),('9303','2013-03-07','12:00:00',1.15),('9303','2013-03-07','12:40:00',1.2),('9303','2013-03-07','12:45:00',1.69),('9303','2013-03-07','12:50:00',1.6),('9303','2013-03-07','12:55:00',1.41),('9303','2013-03-07','13:00:00',1.49),('9303','2013-03-07','13:05:00',1.57),('9303','2013-03-07','13:10:00',1.36),('9303','2013-03-07','13:15:00',1.5),('9303','2013-03-07','13:20:00',1.86),('9303','2013-03-07','13:25:00',1.65),('9303','2013-03-07','13:30:00',1.36),('9303','2013-03-07','13:35:00',1.22),('9303','2013-03-05','08:15:00',1.16),('9303','2013-03-05','08:20:00',1.11),('9303','2013-03-05','08:25:00',1.26),('9303','2013-03-05','08:30:00',1.79),('9303','2013-03-05','08:35:00',1.62),('9303','2013-03-05','08:40:00',1.68),('9303','2013-03-05','08:45:00',1.35),('9303','2013-03-05','08:50:00',1.41),('9303','2013-03-05','08:55:00',1.38),('9303','2013-03-05','09:00:00',1.51),('9303','2013-03-05','09:05:00',1.52),('9303','2013-03-05','09:10:00',1.44),('9303','2013-03-05','09:15:00',1.36),('9303','2013-03-05','09:20:00',1.37),('9303','2013-03-05','09:25:00',1.34),('9303','2013-03-05','09:30:00',1.41),('9303','2013-03-05','09:35:00',1.54),('9303','2013-03-05','09:40:00',1.61),('9303','2013-03-05','09:45:00',1.63),('9303','2013-03-05','09:50:00',1.65),('9303','2013-03-05','09:55:00',1.55),('9303','2013-03-05','10:00:00',1.51),('9303','2013-03-05','10:05:00',1.67),('9303','2013-03-05','10:10:00',1.75),('9303','2013-03-05','10:15:00',1.72),('9303','2013-03-05','10:20:00',1.9),('9303','2013-03-05','10:25:00',1.81),('9303','2013-03-05','10:30:00',1.7),('9303','2013-03-05','10:35:00',1.94),('9303','2013-03-05','10:40:00',2.01),('9303','2013-03-05','10:45:00',2.12),('9303','2013-03-05','10:50:00',2.26),('9303','2013-03-05','10:55:00',2.32),('9303','2013-03-05','11:00:00',2.23),('9303','2013-03-05','11:05:00',2.33),('9303','2013-03-05','11:10:00',2.38),('9303','2013-03-05','11:15:00',2.34),('9303','2013-03-05','11:20:00',2.31),('9303','2013-03-05','11:25:00',2.26),('9303','2013-03-05','11:30:00',2.31),('9303','2013-03-05','11:35:00',2.53),('9303','2013-03-05','11:40:00',2.73),('9303','2013-03-05','11:45:00',2.63),('9303','2013-03-05','11:50:00',2.7),('9303','2013-03-05','11:55:00',2.74),('9303','2013-03-05','12:00:00',2.77),('9303','2013-03-05','12:05:00',2.82),('9303','2013-03-05','12:10:00',2.96),('9303','2013-03-05','12:15:00',2.42),('9303','2013-03-05','12:20:00',2.69),('9303','2013-03-05','12:25:00',2.76),('9303','2013-03-05','12:30:00',2.32),('9303','2013-03-05','12:35:00',2.44),('9303','2013-03-05','12:40:00',2.37),('9303','2013-03-05','12:45:00',2.41),('9303','2013-03-05','12:50:00',2.12),('9303','2013-03-05','12:55:00',1.95),('9303','2013-03-05','13:00:00',1.59),('9303','2013-03-05','13:05:00',1.53),('9303','2013-03-05','13:10:00',1.62),('9303','2013-03-05','13:15:00',1.72),('9303','2013-03-05','13:20:00',1.68),('9303','2013-03-05','13:25:00',1.51),('9303','2013-03-05','13:30:00',1.38),('9303','2013-03-05','13:35:00',1.3),('9303','2013-03-05','13:40:00',1.23),('9303','2013-03-05','13:45:00',1.12),('9303','2013-03-05','13:50:00',1.02),('9303','2013-03-05','14:10:00',1.02),('9303','2013-03-05','15:45:00',1.04),('9303','2013-03-05','15:50:00',1.02),('9303','2013-03-04','08:10:00',1.06),('9303','2013-03-04','08:15:00',1.18),('9303','2013-03-04','08:20:00',1.24),('9303','2013-03-04','08:25:00',1.33),('9303','2013-03-04','08:30:00',1.44),('9303','2013-03-04','08:35:00',1.49),('9303','2013-03-04','08:40:00',1.6),('9303','2013-03-04','08:45:00',1.68),('9303','2013-03-04','08:50:00',1.75),('9303','2013-03-04','08:55:00',1.82),('9303','2013-03-04','09:00:00',1.88),('9303','2013-03-04','09:05:00',1.96),('9303','2013-03-04','09:10:00',2.03),('9303','2013-03-04','09:15:00',2.09),('9303','2013-03-04','09:20:00',2.15),('9303','2013-03-04','09:25:00',2.22),('9303','2013-03-04','09:30:00',2.31),('9303','2013-03-04','09:35:00',2.38),('9303','2013-03-04','09:40:00',2.44),('9303','2013-03-04','09:45:00',2.49),('9303','2013-03-04','09:50:00',2.5),('9303','2013-03-04','09:55:00',2.57),('9303','2013-03-04','10:00:00',2.56),('9303','2013-03-04','10:05:00',2.62),('9303','2013-03-04','10:10:00',2.61),('9303','2013-03-04','10:15:00',2.63),('9303','2013-03-04','10:20:00',2.67),('9303','2013-03-04','10:25:00',2.72),('9303','2013-03-04','10:30:00',2.79),('9303','2013-03-04','10:35:00',2.79),('9303','2013-03-04','10:40:00',2.86),('9303','2013-03-04','10:45:00',2.88),('9303','2013-03-04','10:50:00',2.87),('9303','2013-03-04','10:55:00',2.91),('9303','2013-03-04','11:00:00',2.96),('9303','2013-03-04','11:05:00',3.04),('9303','2013-03-04','11:10:00',3.07),('9303','2013-03-04','11:15:00',3.05),('9303','2013-03-04','11:20:00',3.03),('9303','2013-03-04','11:25:00',3.03),('9303','2013-03-04','11:30:00',3.08),('9303','2013-03-04','11:35:00',3.16),('9303','2013-03-04','11:40:00',3.16),('9303','2013-03-04','11:45:00',3.15),('9303','2013-03-04','11:50:00',3.05),('9303','2013-03-04','11:55:00',3.08),('9303','2013-03-04','12:00:00',3.07),('9303','2013-03-04','12:05:00',3.05),('9303','2013-03-04','12:10:00',3.16),('9303','2013-03-04','12:15:00',3.18),('9303','2013-03-04','12:20:00',3.19),('9303','2013-03-04','12:25:00',3.21),('9303','2013-03-04','12:30:00',3.21),('9303','2013-03-04','12:35:00',3.2),('9303','2013-03-04','12:40:00',3.2),('9303','2013-03-04','12:45:00',3.26),('9303','2013-03-04','12:50:00',3.23),('9303','2013-03-04','12:55:00',3.21),('9303','2013-03-04','13:00:00',3.23),('9303','2013-03-04','13:05:00',3.19),('9303','2013-03-04','13:10:00',3.11),('9303','2013-03-04','13:15:00',3.17),('9303','2013-03-04','13:20:00',3.15),('9303','2013-03-04','13:25:00',3.16),('9303','2013-03-04','13:30:00',1.58),('9303','2013-03-04','13:35:00',2.7),('9303','2013-03-04','13:40:00',2.52),('9303','2013-03-04','13:45:00',2.44),('9303','2013-03-04','13:50:00',2.85),('9303','2013-03-04','13:55:00',2.84),('9303','2013-03-04','14:00:00',2.74),('9303','2013-03-04','14:05:00',2.74),('9303','2013-03-04','14:10:00',2.66),('9303','2013-03-04','14:15:00',2.61),('9303','2013-03-04','14:20:00',2.56),('9303','2013-03-04','14:25:00',2.51),('9303','2013-03-04','14:30:00',2.35),('9303','2013-03-04','14:35:00',2.46),('9303','2013-03-04','14:40:00',2.41),('9303','2013-03-04','14:45:00',2.35),('9303','2013-03-04','14:50:00',2.3),('9303','2013-03-04','14:55:00',2.25),('9303','2013-03-04','15:00:00',2.19),('9303','2013-03-04','15:05:00',2.14),('9303','2013-03-04','15:10:00',2.04),('9303','2013-03-04','15:15:00',1.98),('9303','2013-03-04','15:20:00',1.94),('9303','2013-03-04','15:25:00',1.84),('9303','2013-03-04','15:30:00',1.8),('9303','2013-03-04','15:35:00',1.69),('9303','2013-03-04','15:40:00',1.62),('9303','2013-03-04','15:45:00',1.57),('9303','2013-03-04','15:50:00',1.45),('9303','2013-03-04','15:55:00',1.41),('9303','2013-03-04','16:00:00',1.34),('9303','2013-03-04','16:05:00',1.23),('9303','2013-03-04','16:10:00',1.16),('9303','2013-03-04','16:15:00',1.1),('9303','2013-03-04','16:20:00',1.03),('9303','2013-03-03','08:10:00',1.06),('9303','2013-03-03','08:15:00',1.18),('9303','2013-03-03','08:20:00',1.25),('9303','2013-03-03','08:25:00',1.35),('9303','2013-03-03','08:30:00',1.45),('9303','2013-03-03','08:35:00',1.5),('9303','2013-03-03','08:40:00',1.62),('9303','2013-03-03','08:45:00',1.69),('9303','2013-03-03','08:50:00',1.8),('9303','2013-03-03','08:55:00',1.87),('9303','2013-03-03','09:00:00',1.95),('9303','2013-03-03','09:05:00',2.03),('9303','2013-03-03','09:10:00',2.1),('9303','2013-03-03','09:15:00',2.15),('9303','2013-03-03','09:20:00',2.23),('9303','2013-03-03','09:25:00',2.3),('9303','2013-03-03','09:30:00',2.35),('9303','2013-03-03','09:35:00',2.42),('9303','2013-03-03','09:40:00',2.47),('9303','2013-03-03','09:45:00',2.53),('9303','2013-03-03','09:50:00',2.6),('9303','2013-03-03','09:55:00',2.67),('9303','2013-03-03','10:00:00',2.68),('9303','2013-03-03','10:05:00',2.72),('9303','2013-03-03','10:10:00',2.73),('9303','2013-03-03','10:15:00',2.78),('9303','2013-03-03','10:20:00',2.83),('9303','2013-03-03','10:25:00',2.87),('9303','2013-03-03','10:30:00',2.93),('9303','2013-03-03','10:35:00',2.94),('9303','2013-03-03','10:40:00',2.98),('9303','2013-03-03','10:45:00',3.01),('9303','2013-03-03','10:50:00',3.01),('9303','2013-03-03','10:55:00',3.05),('9303','2013-03-03','11:00:00',3.06),('9303','2013-03-03','11:05:00',3.1),('9303','2013-03-03','11:10:00',3.15),('9303','2013-03-03','11:15:00',3.09),('9303','2013-03-03','11:20:00',3.16),('9303','2013-03-03','11:25:00',3.18),('9303','2013-03-03','11:30:00',3.15),('9303','2013-03-03','11:35:00',3.21),('9303','2013-03-03','11:40:00',3.27),('9303','2013-03-03','11:45:00',3.22),('9303','2013-03-03','11:50:00',3.28),('9303','2013-03-03','11:55:00',3.26),('9303','2013-03-03','12:00:00',3.25),('9303','2013-03-03','12:05:00',3.28),('9303','2013-03-03','12:10:00',3.25),('9303','2013-03-03','12:15:00',3.25),('9303','2013-03-03','12:20:00',3.28),('9303','2013-03-03','12:25:00',3.29),('9303','2013-03-03','12:30:00',3.33),('9303','2013-03-03','12:35:00',3.34),('9303','2013-03-03','12:40:00',3.34),('9303','2013-03-03','12:45:00',3.36),('9303','2013-03-03','12:50:00',3.36),('9303','2013-03-03','12:55:00',3.34),('9303','2013-03-03','13:00:00',3.31),('9303','2013-03-03','13:05:00',3.31),('9303','2013-03-03','13:10:00',3.27),('9303','2013-03-03','13:15:00',3.21),('9303','2013-03-03','13:20:00',3.22),('9303','2013-03-03','13:25:00',3.19),('9303','2013-03-03','13:30:00',3.14),('9303','2013-03-03','13:35:00',3.12),('9303','2013-03-03','13:40:00',3.07),('9303','2013-03-03','13:45:00',3.02),('9303','2013-03-03','13:50:00',3.01),('9303','2013-03-03','13:55:00',2.94),('9303','2013-03-03','14:00:00',2.89),('9303','2013-03-03','14:05:00',2.88),('9303','2013-03-03','14:10:00',2.88),('9303','2013-03-03','14:15:00',2.84),('9303','2013-03-03','14:20:00',2.78),('9303','2013-03-03','14:25:00',2.74),('9303','2013-03-03','14:30:00',2.67),('9303','2013-03-03','14:35:00',2.64),('9303','2013-03-03','14:40:00',2.58),('9303','2013-03-03','14:45:00',2.52),('9303','2013-03-03','14:50:00',2.45),('9303','2013-03-03','14:55:00',2.36),('9303','2013-03-03','15:00:00',2.37),('9303','2013-03-03','15:05:00',2.31),('9303','2013-03-03','15:10:00',2.24),('9303','2013-03-03','15:15:00',2.18),('9303','2013-03-03','15:20:00',2.12),('9303','2013-03-03','15:25:00',2.05),('9303','2013-03-03','15:30:00',1.99),('9303','2013-03-03','15:35:00',1.88),('9303','2013-03-03','15:40:00',1.8),('9303','2013-03-03','15:45:00',1.71),('9303','2013-03-03','15:50:00',1.61),('9303','2013-03-03','15:55:00',1.54),('9303','2013-03-03','16:00:00',1.44),('9303','2013-03-03','16:05:00',1.34),('9303','2013-03-03','16:10:00',1.27),('9303','2013-03-03','16:15:00',1.19),('9303','2013-03-03','16:20:00',1.11),('9303','2013-03-03','16:25:00',1.03),('9303','2014-03-24','07:45:00',1.14),('9303','2014-03-24','08:55:00',1.41),('9303','2014-03-24','09:00:00',1.76),('9303','2014-03-24','09:20:00',1.65),('9303','2014-03-24','09:30:00',1.33),('9303','2014-03-24','09:40:00',1.29),('9303','2014-03-24','09:45:00',1.1),('9303','2014-03-24','10:00:00',1.94),('9303','2014-03-24','10:05:00',2.56),('9303','2014-03-24','10:10:00',3.17),('9303','2014-03-24','10:15:00',2.93),('9303','2014-03-24','10:35:00',1.15),('9303','2014-03-24','10:40:00',1.01),('9303','2014-03-24','10:45:00',1.35),('9303','2014-03-24','10:50:00',4.68),('9303','2014-03-24','10:55:00',4.17),('9303','2014-03-24','11:00:00',1.76),('9303','2014-03-24','11:05:00',2.54),('9303','2014-03-24','11:10:00',2.44),('9303','2014-03-24','11:15:00',3.13),('9303','2014-03-24','11:20:00',2.74),('9303','2014-03-24','11:25:00',2.74),('9303','2014-03-24','11:30:00',3.78),('9303','2014-03-24','11:35:00',1.51),('9303','2014-03-24','12:35:00',1.78),('9303','2014-03-24','12:40:00',1.93),('9303','2014-03-24','12:45:00',1.69),('9303','2014-03-24','12:50:00',1.41),('9303','2014-03-24','12:55:00',1.35),('9303','2014-03-24','13:00:00',1.36),('9303','2014-03-24','13:05:00',1.36),('9303','2014-03-24','13:10:00',1.18),('9303','2014-03-24','13:20:00',1.01),('9303','2014-03-24','13:25:00',1.2),('9303','2014-03-24','13:30:00',1.38),('9303','2014-03-24','13:35:00',1.12),('9303','2014-03-24','13:50:00',1.21),('9303','2014-03-24','13:55:00',1.25),('9303','2014-03-24','14:00:00',1.13),('9303','2014-03-24','14:05:00',1.01),('9303','2014-03-24','14:10:00',1.17),('9303','2014-03-24','14:15:00',1.48),('9303','2014-03-24','14:20:00',1.99),('9303','2014-03-24','14:25:00',1.92),('9303','2014-03-24','14:30:00',1.7),('9303','2014-03-24','14:35:00',2),('9303','2014-03-24','14:40:00',2.93),('9303','2014-03-24','14:45:00',3.15),('9303','2014-03-24','14:50:00',3.48),('9303','2014-03-24','14:55:00',3.03),('9303','2014-03-24','15:00:00',2.62),('9303','2014-03-24','15:05:00',2.31),('9303','2014-03-24','15:10:00',2.09),('9303','2014-03-24','15:15:00',1.27),('9303','2014-03-24','15:20:00',1.53),('9303','2014-03-24','15:25:00',1.31),('9303','2014-03-24','15:30:00',1.7),('9303','2014-03-24','15:35:00',1.39),('9303','2014-03-24','15:40:00',1.21),('9303','2014-03-24','15:45:00',1.11),('9303','2014-03-24','15:50:00',1.22),('9303','2014-03-24','15:55:00',1.12),('9303','2014-03-24','16:00:00',2.16),('9303','2014-03-24','16:05:00',1.16),('9303','2014-03-24','16:10:00',1.03),('9303','2013-03-02','10:50:00',1.01),('9303','2013-03-02','10:55:00',1.05),('9303','2013-03-02','11:00:00',1.13),('9303','2013-03-02','11:05:00',1.17),('9303','2013-03-02','11:10:00',1.23),('9303','2013-03-02','11:15:00',1.39),('9303','2013-03-02','11:20:00',1.23),('9303','2013-03-02','11:25:00',1.09),('9303','2013-03-02','11:30:00',1.03),('9303','2013-03-02','11:35:00',1.06),('9303','2013-03-02','11:40:00',1.21),('9303','2013-03-02','11:45:00',1.09),('9303','2013-03-02','11:50:00',1.09),('9303','2013-03-02','11:55:00',1.02),('9303','2013-03-02','12:05:00',1.12),('9303','2013-03-02','12:10:00',1.11),('9303','2013-03-02','12:15:00',1.12),('9303','2013-03-02','12:20:00',1.05),('9303','2013-03-02','12:25:00',1.13),('9303','2013-03-02','12:30:00',1.16),('9303','2013-03-02','12:35:00',1.3),('9303','2013-03-02','12:40:00',1.39),('9303','2013-03-02','12:45:00',1.37),('9303','2013-03-02','12:50:00',1.22),('9303','2013-03-02','12:55:00',1.33),('9303','2013-03-02','13:00:00',1.35),('9303','2013-03-02','13:05:00',1.16),('9303','2013-03-02','13:45:00',1.07),('9303','2013-03-02','13:50:00',1.04),('9303','2013-03-02','13:55:00',1.11),('9303','2013-03-02','14:00:00',1.24),('9303','2013-03-02','14:05:00',1.21),('9303','2013-03-02','14:10:00',1.01),('9303','2013-03-01','08:20:00',1.03),('9303','2013-03-01','08:25:00',1.04),('9303','2013-03-01','08:30:00',1.13),('9303','2013-03-01','08:35:00',1.2),('9303','2013-03-01','08:40:00',1.27),('9303','2013-03-01','08:45:00',1.39),('9303','2013-03-01','08:50:00',1.46),('9303','2013-03-01','08:55:00',1.54),('9303','2013-03-01','09:00:00',1.63),('9303','2013-03-01','09:05:00',1.82),('9303','2013-03-01','09:10:00',1.82),('9303','2013-03-01','09:15:00',1.83),('9303','2013-03-01','09:20:00',1.88),('9303','2013-03-01','09:25:00',1.91),('9303','2013-03-01','09:30:00',2.11),('9303','2013-03-01','09:35:00',1.99),('9303','2013-03-01','09:40:00',2.04),('9303','2013-03-01','09:45:00',2.18),('9303','2013-03-01','09:50:00',2.17),('9303','2013-03-01','09:55:00',2.13),('9303','2013-03-01','10:00:00',2.15),('9303','2013-03-01','10:05:00',2.14),('9303','2013-03-01','10:10:00',2.14),('9303','2013-03-01','10:15:00',1.93),('9303','2013-03-01','10:20:00',1.81),('9303','2013-03-01','10:25:00',1.9),('9303','2013-03-01','10:30:00',2.09),('9303','2013-03-01','10:35:00',2.37),('9303','2013-03-01','10:40:00',2.12),('9303','2013-03-01','10:45:00',2.02),('9303','2013-03-01','10:50:00',1.95),('9303','2013-03-01','10:55:00',1.85),('9303','2013-03-01','11:00:00',1.67),('9303','2013-03-01','11:05:00',1.47),('9303','2013-03-01','11:10:00',1.4),('9303','2013-03-01','11:15:00',1.52),('9303','2013-03-01','11:20:00',1.61),('9303','2013-03-01','11:25:00',1.61),('9303','2013-03-01','11:30:00',1.63),('9303','2013-03-01','11:35:00',1.66),('9303','2013-03-01','11:40:00',1.6),('9303','2013-03-01','11:45:00',1.53),('9303','2013-03-01','11:50:00',1.51),('9303','2013-03-01','11:55:00',1.45),('9303','2013-03-01','12:00:00',1.38),('9303','2013-03-01','12:05:00',1.31),('9303','2013-03-01','12:10:00',1.23),('9303','2013-03-01','12:15:00',1.12),('9303','2013-03-01','12:20:00',1.05),('9303','2013-03-01','12:25:00',1.04),('9303','2013-03-01','12:30:00',1.08),('9303','2013-03-01','12:35:00',1.07),('9303','2013-03-01','12:40:00',1.03),('9303','2013-03-01','12:45:00',1.03),('9303','2013-03-01','12:50:00',1.05),('9303','2013-03-01','12:55:00',1.11),('9303','2013-03-01','13:00:00',1.17),('9303','2013-03-01','13:05:00',1.19),('9303','2013-03-01','13:10:00',1.23),('9303','2013-03-01','13:15:00',1.31),('9303','2013-03-01','13:20:00',1.41),('9303','2013-03-01','13:25:00',1.55),('9303','2013-03-01','13:30:00',1.53),('9303','2013-03-01','13:35:00',1.42),('9303','2013-03-01','13:40:00',1.35),('9303','2013-03-01','13:45:00',1.33),('9303','2013-03-01','13:50:00',1.33),('9303','2013-03-01','13:55:00',1.28),('9303','2013-03-01','14:00:00',1.25),('9303','2013-03-01','14:05:00',1.19),('9303','2013-03-01','14:10:00',1.12),('9303','2013-03-01','14:15:00',1.05),('9303','2013-03-01','14:20:00',1.01),('9303','2013-03-01','14:25:00',1.01),('9303','2013-03-01','14:30:00',1.04),('9303','2013-03-01','14:35:00',1.05),('9303','2013-03-01','14:40:00',1.01),('9303','2013-02-28','08:20:00',1.08),('9303','2013-02-28','08:25:00',1.17),('9303','2013-02-28','08:30:00',1.25),('9303','2013-02-28','08:35:00',1.31),('9303','2013-02-28','08:40:00',1.42),('9303','2013-02-28','08:45:00',1.52),('9303','2013-02-28','08:50:00',1.61),('9303','2013-02-28','08:55:00',1.71),('9303','2013-02-28','09:00:00',1.79),('9303','2013-02-28','09:05:00',1.85),('9303','2013-02-28','09:10:00',1.91),('9303','2013-02-28','09:15:00',1.95),('9303','2013-02-28','09:20:00',2.04),('9303','2013-02-28','09:25:00',2.09),('9303','2013-02-28','09:30:00',2.14),('9303','2013-02-28','09:35:00',2.17),('9303','2013-02-28','09:40:00',2.2),('9303','2013-02-28','09:45:00',2.24),('9303','2013-02-28','09:50:00',2.09),('9303','2013-02-28','09:55:00',2.29),('9303','2013-02-28','10:00:00',2.33),('9303','2013-02-28','10:05:00',2.36),('9303','2013-02-28','10:10:00',2.4),('9303','2013-02-28','10:15:00',2.41),('9303','2013-02-28','10:20:00',2.53),('9303','2013-02-28','10:25:00',2.5),('9303','2013-02-28','10:30:00',2.53),('9303','2013-02-28','10:35:00',2.59),('9303','2013-02-28','10:40:00',2.64),('9303','2013-02-28','10:45:00',2.66),('9303','2013-02-28','10:50:00',2.69),('9303','2013-02-28','10:55:00',2.66),('9303','2013-02-28','11:00:00',2.78),('9303','2013-02-28','11:05:00',2.84),('9303','2013-02-28','11:10:00',2.86),('9303','2013-02-28','11:15:00',2.87),('9303','2013-02-28','11:20:00',2.96),('9303','2013-02-28','11:25:00',2.96),('9303','2013-02-28','11:30:00',2.97),('9303','2013-02-28','11:35:00',3.03),('9303','2013-02-28','11:40:00',3.01),('9303','2013-02-28','11:45:00',3.03),('9303','2013-02-28','11:50:00',3.11),('9303','2013-02-28','11:55:00',3.09),('9303','2013-02-28','12:00:00',3),('9303','2013-02-28','12:05:00',2.85),('9303','2013-02-28','12:10:00',3.05),('9303','2013-02-28','12:15:00',3.08),('9303','2013-02-28','12:20:00',3.12),('9303','2013-02-28','12:25:00',3.12),('9303','2013-02-28','12:30:00',3.15),('9303','2013-02-28','12:35:00',3.21),('9303','2013-02-28','12:40:00',3.18),('9303','2013-02-28','12:45:00',3.14),('9303','2013-02-28','12:50:00',3.05),('9303','2013-02-28','12:55:00',3),('9303','2013-02-28','13:00:00',2.88),('9303','2013-02-28','13:05:00',2.99),('9303','2013-02-28','13:10:00',2.97),('9303','2013-02-28','13:15:00',2.99),('9303','2013-02-28','13:20:00',2.99),('9303','2013-02-28','13:25:00',2.77),('9303','2013-02-28','13:30:00',2.94),('9303','2013-02-28','13:35:00',2.83),('9303','2013-02-28','13:40:00',2.82),('9303','2013-02-28','13:45:00',2.82),('9303','2013-02-28','13:50:00',2.92),('9303','2013-02-28','13:55:00',2.85),('9303','2013-02-28','14:00:00',2.84),('9303','2013-02-28','14:05:00',2.82),('9303','2013-02-28','14:10:00',2.71),('9303','2013-02-28','14:15:00',2.65),('9303','2013-02-28','14:20:00',2.5),('9303','2013-02-28','14:25:00',2.38),('9303','2013-02-28','14:30:00',2.34),('9303','2013-02-28','14:35:00',2.21),('9303','2013-02-28','14:40:00',2.27),('9303','2013-02-28','14:45:00',2.25),('9303','2013-02-28','14:50:00',2.25),('9303','2013-02-28','14:55:00',2.23),('9303','2013-02-28','15:00:00',2.14),('9303','2013-02-28','15:05:00',2.05),('9303','2013-02-28','15:10:00',1.98),('9303','2013-02-28','15:15:00',1.91),('9303','2013-02-28','15:20:00',1.87),('9303','2013-02-28','15:25:00',1.73),('9303','2013-02-28','15:30:00',1.6),('9303','2013-02-28','15:35:00',1.56),('9303','2013-02-28','15:40:00',1.5),('9303','2013-02-28','15:45:00',1.44),('9303','2013-02-28','15:50:00',1.37),('9303','2013-02-28','15:55:00',1.29),('9303','2013-02-28','16:00:00',1.21),('9303','2013-02-28','16:05:00',1.12),('9303','2013-02-28','16:10:00',1.05),('9303','2013-02-27','08:20:00',1.03),('9303','2013-02-27','08:25:00',1.11),('9303','2013-02-27','08:30:00',1.22),('9303','2013-02-27','08:35:00',1.3),('9303','2013-02-27','08:40:00',1.35),('9303','2013-02-27','08:45:00',1.43),('9303','2013-02-27','08:50:00',1.51),('9303','2013-02-27','08:55:00',1.58),('9303','2013-02-27','09:00:00',1.69),('9303','2013-02-27','09:05:00',1.76),('9303','2013-02-27','09:10:00',1.83),('9303','2013-02-27','09:15:00',1.9),('9303','2013-02-27','09:20:00',1.96),('9303','2013-02-27','09:25:00',2.03),('9303','2013-02-27','09:30:00',2.08),('9303','2013-02-27','09:35:00',2.11),('9303','2013-02-27','09:40:00',2.16),('9303','2013-02-27','09:45:00',2.19),('9303','2013-02-27','09:50:00',2.24),('9303','2013-02-27','09:55:00',2.26),('9303','2013-02-27','10:00:00',2.31),('9303','2013-02-27','10:05:00',2.33),('9303','2013-02-27','10:10:00',2.4),('9303','2013-02-27','10:15:00',2.42),('9303','2013-02-27','10:20:00',2.51),('9303','2013-02-27','10:25:00',2.51),('9303','2013-02-27','10:30:00',2.57),('9303','2013-02-27','10:35:00',2.6),('9303','2013-02-27','10:40:00',2.69),('9303','2013-02-27','10:45:00',2.74),('9303','2013-02-27','10:50:00',2.75),('9303','2013-02-27','10:55:00',2.79),('9303','2013-02-27','11:00:00',2.81),('9303','2013-02-27','11:05:00',2.84),('9303','2013-02-27','11:10:00',2.81),('9303','2013-02-27','11:15:00',2.83),('9303','2013-02-27','11:20:00',2.95),('9303','2013-02-27','11:25:00',2.94),('9303','2013-02-27','11:30:00',2.31),('9303','2013-02-27','11:35:00',1.49),('9303','2013-02-27','11:40:00',1.39),('9303','2013-02-27','11:45:00',2.2),('9303','2013-02-27','11:50:00',2.78),('9303','2013-02-27','11:55:00',3.2),('9303','2013-02-27','12:00:00',3.13),('9303','2013-02-27','12:05:00',3.15),('9303','2013-02-27','12:10:00',3.21),('9303','2013-02-27','12:15:00',3.32),('9303','2013-02-27','12:20:00',3.32),('9303','2013-02-27','12:25:00',3.21),('9303','2013-02-27','12:30:00',3.2),('9303','2013-02-27','12:35:00',3.23),('9303','2013-02-27','12:40:00',3.32),('9303','2013-02-27','12:45:00',3.23),('9303','2013-02-27','12:50:00',3.13),('9303','2013-02-27','12:55:00',2.99),('9303','2013-02-27','13:00:00',3.03),('9303','2013-02-27','13:05:00',3.14),('9303','2013-02-27','13:10:00',2.35),('9303','2013-02-27','13:15:00',2.76),('9303','2013-02-27','13:25:00',2.16),('9303','2013-02-27','13:30:00',3.13),('9303','2013-02-27','13:35:00',3.01),('9303','2013-02-27','13:40:00',2.99),('9303','2013-02-27','13:45:00',2.67),('9303','2013-02-27','13:50:00',2.12),('9303','2013-02-27','13:55:00',2.01),('9303','2013-02-27','14:00:00',2.05),('9303','2013-02-27','14:05:00',1.91),('9303','2013-02-27','14:10:00',1.68),('9303','2013-02-27','14:15:00',1.59),('9303','2013-02-27','14:20:00',2.29),('9303','2013-02-27','14:25:00',1.68),('9303','2013-02-27','14:30:00',2.39),('9303','2013-02-27','14:35:00',2.47),('9303','2013-02-27','14:40:00',2.46),('9303','2013-02-27','14:45:00',2.37),('9303','2013-02-27','14:50:00',2.18),('9303','2013-02-27','14:55:00',2.17),('9303','2013-02-27','15:00:00',2.25),('9303','2013-02-27','15:05:00',2.25),('9303','2013-02-27','15:10:00',2.06),('9303','2013-02-27','15:15:00',1.92),('9303','2013-02-27','15:20:00',1.94),('9303','2013-02-27','15:25:00',1.89),('9303','2013-02-27','15:30:00',1.78),('9303','2013-02-27','15:35:00',1.7),('9303','2013-02-27','15:40:00',1.57),('9303','2013-02-27','15:45:00',1.51),('9303','2013-02-27','15:50:00',1.45),('9303','2013-02-27','15:55:00',1.39),('9303','2013-02-27','16:00:00',1.29),('9303','2013-02-27','16:05:00',1.21),('9303','2013-02-27','16:10:00',1.14),('9303','2013-02-27','16:15:00',1.06),('9303','2013-02-26','09:25:00',1.01),('9303','2013-02-26','09:30:00',1.2),('9303','2013-02-26','09:35:00',1.5),('9303','2013-02-26','09:40:00',1.67),('9303','2013-02-26','09:45:00',1.65),('9303','2013-02-26','09:50:00',1.64),('9303','2013-02-26','09:55:00',1.77),('9303','2013-02-26','10:00:00',1.63),('9303','2013-02-26','10:05:00',1.6),('9303','2013-02-26','10:10:00',1.86),('9303','2013-02-26','10:15:00',2.21),('9303','2013-02-26','10:20:00',2.63),('9303','2013-02-26','10:25:00',2.89),('9303','2013-02-26','10:30:00',2.68),('9303','2013-02-26','10:35:00',2.27),('9303','2013-02-26','10:40:00',2.16),('9303','2013-02-26','10:45:00',1.33),('9303','2013-02-26','10:50:00',1.56),('9303','2013-02-26','10:55:00',1.66),('9303','2013-02-26','11:00:00',1.81),('9303','2013-02-26','11:05:00',1.8),('9303','2013-02-26','11:10:00',2.03),('9303','2013-02-26','11:15:00',1.67),('9303','2013-02-26','11:20:00',1.55),('9303','2013-02-26','11:25:00',1.47),('9303','2013-02-26','11:30:00',1.45),('9303','2013-02-26','11:35:00',1.4),('9303','2013-02-26','11:40:00',1.46),('9303','2013-02-26','11:45:00',1.42),('9303','2013-02-26','11:50:00',1.7),('9303','2013-02-26','11:55:00',1.59),('9303','2013-02-26','12:00:00',1.62),('9303','2013-02-26','12:05:00',1.58),('9303','2013-02-26','12:10:00',1.58),('9303','2013-02-26','12:15:00',1.37),('9303','2013-02-26','12:20:00',1.41),('9303','2013-02-26','12:25:00',1.29),('9303','2013-02-26','12:30:00',1.29),('9303','2013-02-26','12:35:00',1.18),('9303','2013-02-26','12:40:00',1.07),('9303','2013-02-25','08:50:00',1.06),('9303','2013-02-25','09:00:00',1.03),('9303','2013-02-25','09:25:00',1.26),('9303','2013-02-25','09:30:00',1.42),('9303','2013-02-25','09:35:00',1.41),('9303','2013-02-25','09:40:00',1.11),('9303','2013-02-25','10:45:00',1.47),('9303','2013-02-25','10:50:00',2.55),('9303','2013-02-25','10:55:00',3.53),('9303','2013-02-25','11:00:00',3.71),('9303','2013-02-25','11:05:00',1.9),('9303','2013-02-25','11:10:00',1.59),('9303','2013-02-25','11:15:00',1.58),('9303','2013-02-25','11:20:00',1.07),('9303','2013-02-25','11:30:00',1.34),('9303','2013-02-25','11:35:00',1.21),('9303','2013-02-25','11:40:00',1.3),('9303','2013-02-25','11:45:00',1.52),('9303','2013-02-25','11:50:00',1.89),('9303','2013-02-25','11:55:00',3.59),('9303','2013-02-25','12:00:00',2.73),('9303','2013-02-25','12:05:00',1.94),('9303','2013-02-25','12:10:00',1.7),('9303','2013-02-25','12:15:00',1.87),('9303','2013-02-25','12:20:00',3.01),('9303','2013-02-25','12:25:00',3.8),('9303','2013-02-25','12:30:00',3.23),('9303','2013-02-25','12:35:00',2.3),('9303','2013-02-25','12:40:00',3.55),('9303','2013-02-25','12:45:00',3.46),('9303','2013-02-25','12:50:00',3.23),('9303','2013-02-25','12:55:00',3.14),('9303','2013-02-25','13:00:00',3.18),('9303','2013-02-25','13:05:00',3.23),('9303','2013-02-25','13:10:00',2),('9303','2013-02-25','13:15:00',2.21),('9303','2013-02-25','13:20:00',1.71),('9303','2013-02-25','13:25:00',1.25),('9303','2013-02-25','13:30:00',1.47),('9303','2013-02-25','13:35:00',1.63),('9303','2013-02-24','10:50:00',1.15),('9303','2013-02-24','10:55:00',1.12),('9303','2013-02-24','12:40:00',1.04),('9303','2013-02-24','12:45:00',1.21),('9303','2013-02-24','12:50:00',1.02),('9303','2013-02-24','13:00:00',1.01),('9303','2013-02-24','13:05:00',1.42),('9303','2013-02-24','13:10:00',1.43),('9303','2013-02-24','13:15:00',1.18),('9303','2013-02-24','13:20:00',1.42),('9303','2013-02-24','13:35:00',1.23),('9303','2013-02-24','13:40:00',1.15),('9303','2013-02-24','13:45:00',1.22),('9303','2013-02-24','13:50:00',1.08),('9303','2013-02-24','14:00:00',1.06),('9303','2013-02-24','14:05:00',1.62),('9303','2013-02-24','14:10:00',1.63),('9303','2013-02-24','14:15:00',1.09),('9303','2013-02-24','14:30:00',1.1),('9303','2013-02-24','14:35:00',1.14),('9303','2013-02-24','15:10:00',1.85),('9303','2013-02-24','15:15:00',1.03),('9303','2013-02-24','15:20:00',1.17),('9303','2013-02-24','15:25:00',1.55),('9303','2013-02-24','15:35:00',1.23),('9303','2013-02-24','15:40:00',1.24),('9303','2013-02-24','15:45:00',1.2),('9303','2013-02-24','15:50:00',1.01),('9303','2013-02-24','15:55:00',1.22),('9303','2013-02-24','16:00:00',1.5),('9303','2013-02-24','16:05:00',1.02),('9303','2013-02-23','08:10:00',1.11),('9303','2013-02-23','08:15:00',1.37),('9303','2013-02-23','09:00:00',1.22),('9303','2013-02-23','09:05:00',1.21),('9303','2013-02-23','09:45:00',1.21),('9303','2013-02-23','09:50:00',1.27),('9303','2013-02-23','09:55:00',1.25),('9303','2013-02-23','14:05:00',1.47),('9303','2013-02-23','14:10:00',1.22),('9303','2013-02-22','14:35:00',1.2),('9303','2013-02-22','14:40:00',1.34),('9303','2013-02-22','14:45:00',1.04),('9303','2013-02-22','14:55:00',1.33),('9303','2013-02-21','11:50:00',1.07),('9303','2013-02-21','11:55:00',1.1),('9303','2013-02-21','12:00:00',1.08),('9303','2013-02-21','12:05:00',1.08),('9303','2013-02-21','12:10:00',1.13),('9303','2013-02-21','12:15:00',1.19),('9303','2013-02-21','12:20:00',1.28),('9303','2013-02-21','12:25:00',1.25),('9303','2013-02-21','12:30:00',1.17),('9303','2013-02-21','12:35:00',1.11),('9303','2013-02-21','12:40:00',1.08),('9303','2013-02-21','12:45:00',1.1),('9303','2013-02-21','12:50:00',1.1),('9303','2013-02-21','12:55:00',1.18),('9303','2013-02-21','13:00:00',1.19),('9303','2013-02-21','13:05:00',1.11),('9303','2013-02-21','13:10:00',1.07),('9303','2013-02-21','13:15:00',1.09),('9303','2013-02-21','13:20:00',1.14),('9303','2013-02-21','13:25:00',1.17),('9303','2013-02-21','13:30:00',1.19),('9303','2013-02-21','13:35:00',1.19),('9303','2013-02-21','13:40:00',1.15),('9303','2013-02-21','13:45:00',1.09),('9303','2013-02-21','13:50:00',1.09),('9303','2013-02-21','13:55:00',1.09),('9303','2013-02-21','14:00:00',1.1),('9303','2013-02-21','14:05:00',1.06),('9303','2014-03-23','08:35:00',1.07),('9303','2014-03-23','08:50:00',1.14),('9303','2014-03-23','08:55:00',1.52),('9303','2014-03-23','09:05:00',1.43),('9303','2014-03-23','09:10:00',2.45),('9303','2014-03-23','09:15:00',2.48),('9303','2014-03-23','09:20:00',1.74),('9303','2014-03-23','09:30:00',1.23),('9303','2014-03-23','09:35:00',1.29),('9303','2014-03-23','09:40:00',1.1),('9303','2014-03-23','10:25:00',1.01),('9303','2014-03-23','10:40:00',1.01),('9303','2014-03-23','10:55:00',1.39),('9303','2014-03-23','11:00:00',1.06),('9303','2014-03-23','11:10:00',1.12),('9303','2014-03-23','11:35:00',1.28),('9303','2014-03-23','11:40:00',3.46),('9303','2014-03-23','13:45:00',2.3),('9303','2014-03-23','13:50:00',1.51),('9303','2014-03-23','13:55:00',1.17),('9303','2014-03-23','14:00:00',1.01),('9303','2014-03-23','15:10:00',1.12),('9303','2014-03-23','15:15:00',1.96),('9303','2014-03-23','15:20:00',1.47),('9303','2014-03-23','15:25:00',2.13),('9303','2014-03-23','15:30:00',1.06),('9303','2013-02-20','08:25:00',1.01),('9303','2013-02-20','08:30:00',1.08),('9303','2013-02-20','08:35:00',1.19),('9303','2013-02-20','08:40:00',1.28),('9303','2013-02-20','08:45:00',1.38),('9303','2013-02-20','08:50:00',1.45),('9303','2013-02-20','08:55:00',1.54),('9303','2013-02-20','09:00:00',1.64),('9303','2013-02-20','09:05:00',1.39),('9303','2013-02-20','09:10:00',1.08),('9303','2013-02-20','09:15:00',1.43),('9303','2013-02-20','09:20:00',1.13),('9303','2013-02-20','09:25:00',1.5),('9303','2013-02-20','09:30:00',1.92),('9303','2013-02-20','09:35:00',1.32),('9303','2013-02-20','09:45:00',1.11),('9303','2013-02-20','09:50:00',1.22),('9303','2013-02-20','09:55:00',1.64),('9303','2013-02-20','10:00:00',1.31),('9303','2013-02-20','10:05:00',1),('9303','2013-02-20','10:10:00',2.06),('9303','2013-02-20','10:15:00',1.13),('9303','2013-02-20','10:50:00',2.86),('9303','2013-02-20','10:55:00',2.49),('9303','2013-02-20','11:10:00',3.41),('9303','2013-02-20','11:15:00',3.28),('9303','2013-02-20','11:20:00',2.47),('9303','2013-02-20','11:25:00',2.16),('9303','2013-02-20','11:30:00',1.18),('9303','2013-02-20','11:35:00',2.49),('9303','2013-02-20','11:40:00',3.39),('9303','2013-02-20','11:45:00',3.68),('9303','2013-02-20','11:50:00',3.66),('9303','2013-02-20','11:55:00',2.62),('9303','2013-02-20','12:00:00',2.84),('9303','2013-02-20','12:10:00',1.41),('9303','2013-02-20','12:15:00',2.73),('9303','2013-02-20','12:20:00',1.47),('9303','2013-02-20','12:25:00',2.35),('9303','2013-02-20','12:30:00',3.99),('9303','2013-02-20','12:35:00',3.25),('9303','2013-02-20','12:40:00',1.1),('9303','2013-02-20','12:45:00',1.16),('9303','2013-02-20','12:50:00',1.03),('9303','2013-02-20','12:55:00',1.1),('9303','2013-02-20','13:00:00',2.01),('9303','2013-02-20','13:05:00',2.29),('9303','2013-02-20','13:10:00',2.36),('9303','2013-02-20','13:15:00',3.48),('9303','2013-02-20','13:20:00',2.05),('9303','2013-02-20','13:25:00',3.21),('9303','2013-02-20','13:30:00',2.11),('9303','2013-02-20','13:35:00',1.22),('9303','2013-02-20','13:40:00',1.28),('9303','2013-02-20','13:45:00',1.12),('9303','2013-02-20','13:50:00',1.07),('9303','2013-02-20','13:55:00',1.06),('9303','2013-02-20','15:10:00',1.28),('9303','2013-02-20','15:15:00',1.34),('9303','2013-02-20','15:20:00',1.88),('9303','2013-02-20','15:25:00',2.2),('9303','2013-02-20','15:30:00',1.64),('9303','2013-02-20','15:35:00',1.09),('9303','2013-02-20','16:00:00',1.01),('9303','2013-02-20','16:05:00',1.42),('9303','2013-02-20','16:10:00',1.32),('9303','2013-02-20','16:15:00',1.32),('9303','2013-02-20','16:20:00',1.2),('9303','2013-02-19','08:30:00',1.07),('9303','2013-02-19','08:35:00',1.16),('9303','2013-02-19','08:40:00',1.24),('9303','2013-02-19','08:45:00',1.32),('9303','2013-02-19','08:50:00',1.4),('9303','2013-02-19','08:55:00',1.48),('9303','2013-02-19','09:00:00',1.55),('9303','2013-02-19','09:05:00',1.64),('9303','2013-02-19','09:10:00',1.72),('9303','2013-02-19','09:15:00',1.79),('9303','2013-02-19','09:20:00',1.89),('9303','2013-02-19','09:25:00',1.95),('9303','2013-02-19','09:30:00',1.96),('9303','2013-02-19','09:35:00',2.04),('9303','2013-02-19','09:40:00',2.06),('9303','2013-02-19','09:45:00',2.11),('9303','2013-02-19','09:50:00',2.11),('9303','2013-02-19','09:55:00',2.19),('9303','2013-02-19','10:00:00',2.24),('9303','2013-02-19','10:05:00',2.21),('9303','2013-02-19','10:10:00',2.31),('9303','2013-02-19','10:15:00',2.38),('9303','2013-02-19','10:20:00',2.42),('9303','2013-02-19','10:25:00',2.49),('9303','2013-02-19','10:30:00',2.47),('9303','2013-02-19','10:35:00',2.56),('9303','2013-02-19','10:40:00',2.59),('9303','2013-02-19','10:45:00',2.6),('9303','2013-02-19','10:50:00',2.66),('9303','2013-02-19','10:55:00',2.66),('9303','2013-02-19','11:00:00',2.73),('9303','2013-02-19','11:05:00',2.76),('9303','2013-02-19','11:10:00',2.78),('9303','2013-02-19','11:15:00',2.84),('9303','2013-02-19','11:20:00',2.85),('9303','2013-02-19','11:25:00',2.86),('9303','2013-02-19','11:30:00',2.87),('9303','2013-02-19','11:35:00',2.83),('9303','2013-02-19','11:40:00',2.9),('9303','2013-02-19','11:45:00',2.92),('9303','2013-02-19','11:50:00',2.92),('9303','2013-02-19','11:55:00',2.93),('9303','2013-02-19','12:00:00',2.92),('9303','2013-02-19','12:05:00',2.94),('9303','2013-02-19','12:10:00',3.02),('9303','2013-02-19','12:15:00',2.99),('9303','2013-02-19','12:20:00',3),('9303','2013-02-19','12:25:00',3.07),('9303','2013-02-19','12:30:00',3.06),('9303','2013-02-19','12:35:00',3.08),('9303','2013-02-19','12:40:00',3.12),('9303','2013-02-19','12:45:00',3.07),('9303','2013-02-19','12:50:00',2.99),('9303','2013-02-19','12:55:00',2.92),('9303','2013-02-19','13:00:00',2.91),('9303','2013-02-19','13:05:00',2.92),('9303','2013-02-19','13:10:00',2.91),('9303','2013-02-19','13:15:00',2.91),('9303','2013-02-19','13:20:00',2.87),('9303','2013-02-19','13:25:00',2.84),('9303','2013-02-19','13:30:00',2.82),('9303','2013-02-19','13:35:00',2.79),('9303','2013-02-19','13:40:00',2.72),('9303','2013-02-19','13:45:00',2.63),('9303','2013-02-19','13:50:00',2.57),('9303','2013-02-19','13:55:00',2.5),('9303','2013-02-19','14:00:00',2.46),('9303','2013-02-19','14:05:00',2.44),('9303','2013-02-19','14:10:00',2.44),('9303','2013-02-19','14:15:00',2.42),('9303','2013-02-19','14:20:00',2.35),('9303','2013-02-19','14:25:00',2.29),('9303','2013-02-19','14:30:00',2.28),('9303','2013-02-19','14:35:00',2.22),('9303','2013-02-19','14:40:00',2.08),('9303','2013-02-19','14:45:00',2.09),('9303','2013-02-19','14:50:00',2.1),('9303','2013-02-19','14:55:00',2.06),('9303','2013-02-19','15:00:00',2.03),('9303','2013-02-19','15:05:00',1.98),('9303','2013-02-19','15:10:00',1.94),('9303','2013-02-19','15:15:00',1.89),('9303','2013-02-19','15:20:00',1.83),('9303','2013-02-19','15:25:00',1.75),('9303','2013-02-19','15:30:00',1.61),('9303','2013-02-19','15:35:00',1.52),('9303','2013-02-19','15:40:00',1.46),('9303','2013-02-19','15:45:00',1.39),('9303','2013-02-19','15:50:00',1.3),('9303','2013-02-19','15:55:00',1.23),('9303','2013-02-19','16:00:00',1.14),('9303','2013-02-19','16:05:00',1.07),('9303','2013-02-18','08:35:00',1.05),('9303','2013-02-18','08:40:00',1.16),('9303','2013-02-18','08:45:00',1.21),('9303','2013-02-18','08:50:00',1.28),('9303','2013-02-18','08:55:00',1.37),('9303','2013-02-18','09:00:00',1.44),('9303','2013-02-18','09:05:00',1.54),('9303','2013-02-18','09:10:00',1.63),('9303','2013-02-18','09:15:00',1.71),('9303','2013-02-18','09:20:00',1.98),('9303','2013-02-18','09:25:00',2.15),('9303','2013-02-18','09:30:00',1.8),('9303','2013-02-18','09:35:00',1.16),('9303','2013-02-18','09:50:00',1.34),('9303','2013-02-18','11:00:00',1.13),('9303','2013-02-18','11:05:00',1.15),('9303','2013-02-18','11:10:00',1.29),('9303','2013-02-18','11:15:00',1.14),('9303','2013-02-18','11:20:00',1.32),('9303','2013-02-18','11:25:00',1.41),('9303','2013-02-18','11:30:00',1.3),('9303','2013-02-18','11:35:00',1.33),('9303','2013-02-18','11:40:00',1.31),('9303','2013-02-18','11:45:00',1.21),('9303','2013-02-18','11:50:00',1.29),('9303','2013-02-18','11:55:00',1.48),('9303','2013-02-18','12:00:00',1.59),('9303','2013-02-18','12:05:00',1.47),('9303','2013-02-18','12:10:00',1.35),('9303','2013-02-18','12:15:00',1.34),('9303','2013-02-18','12:20:00',1.29),('9303','2013-02-18','12:25:00',1.28),('9303','2013-02-18','12:30:00',1.23),('9303','2013-02-18','12:35:00',1.15),('9303','2013-02-18','12:40:00',1.19),('9303','2013-02-18','12:45:00',1.43),('9303','2013-02-18','12:50:00',1.47),('9303','2013-02-18','12:55:00',1.34),('9303','2013-02-18','13:00:00',1.35),('9303','2013-02-18','13:05:00',1.4),('9303','2013-02-18','13:10:00',1.37),('9303','2013-02-18','13:15:00',1.7),('9303','2013-02-18','13:20:00',1.41),('9303','2013-02-18','13:25:00',1.76),('9303','2013-02-18','13:30:00',1.5),('9303','2013-02-18','13:35:00',1.23),('9303','2013-02-18','13:40:00',1.17),('9303','2013-02-18','13:45:00',1.11),('9303','2013-02-18','13:50:00',1.13),('9303','2013-02-18','13:55:00',1.42),('9303','2013-02-18','14:00:00',1.43),('9303','2013-02-18','14:05:00',1.4),('9303','2013-02-18','14:10:00',1.2),('9303','2013-02-18','14:15:00',1.01),('9303','2013-02-18','14:20:00',1.13),('9303','2013-02-17','08:35:00',1.13),('9303','2013-02-17','08:40:00',1.26),('9303','2013-02-17','08:45:00',1.21),('9303','2013-02-17','08:50:00',1.09),('9303','2013-02-17','08:55:00',1.26),('9303','2013-02-17','09:00:00',1.4),('9303','2013-02-17','09:05:00',1.44),('9303','2013-02-17','09:10:00',1.53),('9303','2013-02-17','09:15:00',1.65),('9303','2013-02-17','09:20:00',1.76),('9303','2013-02-17','09:25:00',1.82),('9303','2013-02-17','09:30:00',1.83),('9303','2013-02-17','09:35:00',1.87),('9303','2013-02-17','09:40:00',1.91),('9303','2013-02-17','09:45:00',1.98),('9303','2013-02-17','09:50:00',2),('9303','2013-02-17','09:55:00',2.07),('9303','2013-02-17','10:00:00',2.11),('9303','2013-02-17','10:05:00',2.14),('9303','2013-02-17','10:10:00',2.17),('9303','2013-02-17','10:15:00',2.2),('9303','2013-02-17','10:20:00',2.27),('9303','2013-02-17','10:25:00',2.31),('9303','2013-02-17','10:30:00',2.31),('9303','2013-02-17','10:35:00',2.43),('9303','2013-02-17','10:40:00',2.48),('9303','2013-02-17','10:45:00',2.46),('9303','2013-02-17','10:50:00',2.52),('9303','2013-02-17','10:55:00',2.54),('9303','2013-02-17','11:00:00',2.57),('9303','2013-02-17','11:05:00',2.63),('9303','2013-02-17','11:10:00',2.61),('9303','2013-02-17','11:15:00',2.68),('9303','2013-02-17','11:20:00',2.71),('9303','2013-02-17','11:25:00',2.7),('9303','2013-02-17','11:30:00',2.71),('9303','2013-02-17','11:35:00',2.71),('9303','2013-02-17','11:40:00',2.75),('9303','2013-02-17','11:45:00',2.77),('9303','2013-02-17','11:50:00',2.78),('9303','2013-02-17','11:55:00',2.79),('9303','2013-02-17','12:00:00',2.79),('9303','2013-02-17','12:05:00',2.81),('9303','2013-02-17','12:10:00',2.87),('9303','2013-02-17','12:15:00',2.88),('9303','2013-02-17','12:20:00',2.9),('9303','2013-02-17','12:25:00',2.93),('9303','2013-02-17','12:30:00',2.95),('9303','2013-02-17','12:35:00',2.94),('9303','2013-02-17','12:40:00',2.95),('9303','2013-02-17','12:45:00',2.81),('9303','2013-02-17','12:50:00',2.69),('9303','2013-02-17','12:55:00',2.73),('9303','2013-02-17','13:00:00',2.74),('9303','2013-02-17','13:05:00',2.74),('9303','2013-02-17','13:10:00',2.68),('9303','2013-02-17','13:15:00',2.67),('9303','2013-02-17','13:20:00',2.42),('9303','2013-02-17','13:25:00',1.93),('9303','2013-02-17','13:30:00',2.45),('9303','2013-02-17','13:35:00',2.53),('9303','2013-02-17','13:40:00',2.48),('9303','2013-02-17','13:45:00',2.43),('9303','2013-02-17','13:50:00',2.23),('9303','2013-02-17','13:55:00',2.28),('9303','2013-02-17','14:10:00',2),('9303','2013-02-17','14:15:00',2.33),('9303','2013-02-17','14:20:00',1.21),('9303','2013-02-17','14:25:00',1.05),('9303','2013-02-17','14:30:00',2.07),('9303','2013-02-17','14:35:00',2.2),('9303','2013-02-17','14:40:00',1.98),('9303','2013-02-17','15:05:00',1.33),('9303','2013-02-17','15:10:00',2.13),('9303','2013-02-17','15:15:00',2.11),('9303','2013-02-17','15:20:00',2.08),('9303','2013-02-17','15:25:00',1.96),('9303','2013-02-17','15:30:00',1.77),('9303','2013-02-17','15:35:00',1.68),('9303','2013-02-17','15:40:00',1.68),('9303','2013-02-17','15:45:00',1.55),('9303','2013-02-17','15:50:00',1.44),('9303','2013-02-17','15:55:00',1.35),('9303','2013-02-17','16:00:00',1.24),('9303','2013-02-17','16:05:00',1.15),('9303','2013-02-16','08:35:00',1),('9303','2013-02-16','08:40:00',1.11),('9303','2013-02-16','09:15:00',1.65),('9303','2013-02-16','09:20:00',1.82),('9303','2013-02-16','09:25:00',1.88),('9303','2013-02-16','09:30:00',1.91),('9303','2013-02-16','09:35:00',1.96),('9303','2013-02-16','09:40:00',1.98),('9303','2013-02-16','09:45:00',2.01),('9303','2013-02-16','09:50:00',2.05),('9303','2013-02-16','09:55:00',2.12),('9303','2013-02-16','10:00:00',2.12),('9303','2013-02-16','10:05:00',2.15),('9303','2013-02-16','10:10:00',2.24),('9303','2013-02-16','10:15:00',2.23),('9303','2013-02-16','10:20:00',2.32),('9303','2013-02-16','10:25:00',2.35),('9303','2013-02-16','10:30:00',2.41),('9303','2013-02-16','10:35:00',2.46),('9303','2013-02-16','10:40:00',2.63),('9303','2013-02-16','10:45:00',2.62),('9303','2013-02-16','10:50:00',2.67),('9303','2013-02-16','10:55:00',2.67),('9303','2013-02-16','11:00:00',2.68),('9303','2013-02-16','11:05:00',2.6),('9303','2013-02-16','11:10:00',2.67),('9303','2013-02-16','11:15:00',2.78),('9303','2013-02-16','11:20:00',2.79),('9303','2013-02-16','11:25:00',2.75),('9303','2013-02-16','11:30:00',2.81),('9303','2013-02-16','11:35:00',2.83),('9303','2013-02-16','11:40:00',2.84),('9303','2013-02-16','11:45:00',2.89),('9303','2013-02-16','11:50:00',2.89),('9303','2013-02-16','11:55:00',2.92),('9303','2013-02-16','12:00:00',2.92),('9303','2013-02-16','12:05:00',2.9),('9303','2013-02-16','12:10:00',2.95),('9303','2013-02-16','12:15:00',2.95),('9303','2013-02-16','12:20:00',2.96),('9303','2013-02-16','12:25:00',3),('9303','2013-02-16','12:30:00',3.01),('9303','2013-02-16','12:35:00',3),('9303','2013-02-16','12:40:00',3.05),('9303','2013-02-16','12:45:00',3.01),('9303','2013-02-16','12:50:00',2.99),('9303','2013-02-16','12:55:00',2.92),('9303','2013-02-16','13:00:00',2.9),('9303','2013-02-16','13:05:00',2.85),('9303','2013-02-16','13:10:00',2.82),('9303','2013-02-16','13:15:00',2.81),('9303','2013-02-16','13:20:00',2.77),('9303','2013-02-16','13:25:00',2.74),('9303','2013-02-16','13:30:00',2.72),('9303','2013-02-16','13:35:00',2.71),('9303','2013-02-16','13:40:00',2.71),('9303','2013-02-16','13:45:00',2.66),('9303','2013-02-16','13:50:00',2.62),('9303','2013-02-16','13:55:00',2.54),('9303','2013-02-16','14:00:00',2.5),('9303','2013-02-16','14:05:00',2.48),('9303','2013-02-16','14:10:00',2.37),('9303','2013-02-16','14:15:00',2.3),('9303','2013-02-16','14:20:00',2.36),('9303','2013-02-16','14:25:00',1.75),('9303','2013-02-16','15:20:00',1.04),('9303','2013-02-16','15:25:00',1.04),('9303','2013-02-16','15:30:00',1.94),('9303','2013-02-16','15:35:00',1.89),('9303','2013-02-16','15:40:00',1.75),('9303','2013-02-16','15:45:00',1.83),('9303','2013-02-16','15:50:00',1.75),('9303','2013-02-16','15:55:00',1.16),('9303','2013-02-16','16:05:00',1.19),('9303','2013-02-15','09:20:00',1.11),('9303','2013-02-15','09:25:00',1.57),('9303','2013-02-15','09:30:00',1.31),('9303','2013-02-15','09:50:00',1.03),('9303','2013-02-15','09:55:00',1.12),('9303','2013-02-15','10:00:00',1.42),('9303','2013-02-15','10:05:00',1.41),('9303','2013-02-15','10:10:00',1.13),('9303','2013-02-15','10:15:00',1.1),('9303','2013-02-15','10:20:00',1.26),('9303','2013-02-15','10:25:00',1.86),('9303','2013-02-15','10:30:00',1.51),('9303','2013-02-15','10:35:00',2.32),('9303','2013-02-15','10:40:00',2.42),('9303','2013-02-15','10:45:00',2.41),('9303','2013-02-15','10:50:00',2.14),('9303','2013-02-15','10:55:00',1.63),('9303','2013-02-15','11:00:00',1.51),('9303','2013-02-15','11:05:00',1.61),('9303','2013-02-15','11:10:00',1.75),('9303','2013-02-15','11:15:00',2.16),('9303','2013-02-15','11:20:00',2.81),('9303','2013-02-15','11:25:00',2.83),('9303','2013-02-15','11:30:00',2.82),('9303','2013-02-15','11:35:00',2.37),('9303','2013-02-15','11:40:00',1.66),('9303','2013-02-15','11:45:00',1.78),('9303','2013-02-15','11:50:00',3.07),('9303','2013-02-15','11:55:00',2.83),('9303','2013-02-15','12:00:00',2.46),('9303','2013-02-15','12:05:00',2.38),('9303','2013-02-15','12:10:00',2.61),('9303','2013-02-15','12:15:00',2.66),('9303','2013-02-15','12:20:00',3.23),('9303','2013-02-15','12:25:00',2.9),('9303','2013-02-15','12:30:00',3.05),('9303','2013-02-15','12:35:00',3.03),('9303','2013-02-15','12:40:00',3.05),('9303','2013-02-15','12:45:00',3.04),('9303','2013-02-15','12:50:00',2.98),('9303','2013-02-15','12:55:00',2.93),('9303','2013-02-15','13:00:00',2.89),('9303','2013-02-15','13:05:00',2.84),('9303','2013-02-15','13:10:00',2.78),('9303','2013-02-15','13:15:00',2.83),('9303','2013-02-15','13:20:00',2.56),('9303','2013-02-15','13:25:00',2.38),('9303','2013-02-15','13:30:00',1.88),('9303','2013-02-15','13:35:00',2.1),('9303','2013-02-15','13:40:00',2.73),('9303','2013-02-15','13:45:00',2.21),('9303','2013-02-15','13:50:00',2.28),('9303','2013-02-15','13:55:00',2.3),('9303','2013-02-15','14:00:00',1.78),('9303','2013-02-15','14:05:00',2.19),('9303','2013-02-15','14:10:00',2.68),('9303','2013-02-15','14:15:00',1.89),('9303','2013-02-15','14:20:00',2.03),('9303','2013-02-15','14:25:00',1.49),('9303','2013-02-15','14:30:00',1.5),('9303','2013-02-15','14:35:00',2.02),('9303','2013-02-15','14:40:00',2.15),('9303','2013-02-15','14:45:00',1.8),('9303','2013-02-15','14:50:00',1.08),('9303','2013-02-15','14:55:00',1.13),('9303','2013-02-15','15:00:00',1.55),('9303','2013-02-15','15:05:00',1.06),('9303','2013-02-15','15:10:00',1.28),('9303','2013-02-15','15:15:00',1.46),('9303','2013-02-15','15:20:00',1.18),('9303','2013-02-15','15:25:00',1.41),('9303','2013-02-15','15:30:00',1.57),('9303','2013-02-15','15:35:00',1.2),('9303','2013-02-15','15:40:00',1.03),('9303','2013-02-15','15:45:00',1.01),('9303','2013-02-14','08:35:00',1.02),('9303','2013-02-14','08:40:00',1.12),('9303','2013-02-14','08:45:00',1.2),('9303','2013-02-14','08:50:00',1.29),('9303','2013-02-14','08:55:00',1.37),('9303','2013-02-14','09:00:00',1.46),('9303','2013-02-14','09:05:00',1.54),('9303','2013-02-14','09:10:00',1.62),('9303','2013-02-14','09:15:00',1.71),('9303','2013-02-14','09:20:00',1.78),('9303','2013-02-14','09:25:00',1.87),('9303','2013-02-14','09:30:00',1.93),('9303','2013-02-14','09:35:00',1.97),('9303','2013-02-14','09:40:00',2.03),('9303','2013-02-14','09:45:00',2.08),('9303','2013-02-14','09:50:00',2.12),('9303','2013-02-14','09:55:00',2.17),('9303','2013-02-14','10:00:00',2.2),('9303','2013-02-14','10:05:00',2.25),('9303','2013-02-14','10:10:00',2.3),('9303','2013-02-14','10:15:00',2.31),('9303','2013-02-14','10:20:00',2.39),('9303','2013-02-14','10:25:00',2.4),('9303','2013-02-14','10:30:00',2.47),('9303','2013-02-14','10:35:00',2.52),('9303','2013-02-14','10:40:00',2.6),('9303','2013-02-14','10:45:00',2.58),('9303','2013-02-14','10:50:00',2.67),('9303','2013-02-14','10:55:00',2.72),('9303','2013-02-14','11:00:00',2.72),('9303','2013-02-14','11:05:00',2.79),('9303','2013-02-14','11:10:00',2.77),('9303','2013-02-14','11:15:00',2.83),('9303','2013-02-14','11:20:00',2.86),('9303','2013-02-14','11:25:00',2.85),('9303','2013-02-14','11:30:00',2.89),('9303','2013-02-14','11:35:00',2.89),('9303','2013-02-14','11:40:00',2.89),('9303','2013-02-14','11:45:00',2.93),('9303','2013-02-14','11:50:00',2.92),('9303','2013-02-14','11:55:00',2.95),('9303','2013-02-14','12:00:00',2.96),('9303','2013-02-14','12:05:00',2.99),('9303','2013-02-14','12:10:00',3.03),('9303','2013-02-14','12:15:00',3.02),('9303','2013-02-14','12:20:00',3.01),('9303','2013-02-14','12:25:00',3.05),('9303','2013-02-14','12:30:00',3.06),('9303','2013-02-14','12:35:00',3.05),('9303','2013-02-14','12:40:00',3.07),('9303','2013-02-14','12:45:00',3.03),('9303','2013-02-14','12:50:00',3.01),('9303','2013-02-14','12:55:00',2.96),('9303','2013-02-14','13:00:00',2.94),('9303','2013-02-14','13:05:00',2.9),('9303','2013-02-14','13:10:00',2.87),('9303','2013-02-14','13:15:00',2.85),('9303','2013-02-14','13:20:00',2.82),('9303','2013-02-14','13:25:00',2.78),('9303','2013-02-14','13:30:00',2.75),('9303','2013-02-14','13:35:00',2.72),('9303','2013-02-14','13:40:00',2.64),('9303','2013-02-14','13:45:00',2.57),('9303','2013-02-14','13:50:00',2.49),('9303','2013-02-14','13:55:00',2.45),('9303','2013-02-14','14:00:00',2.41),('9303','2013-02-14','14:05:00',2.41),('9303','2013-02-14','14:10:00',2.32),('9303','2013-02-14','14:15:00',2.27),('9303','2013-02-14','14:20:00',2.19),('9303','2013-02-14','14:25:00',2.23),('9303','2013-02-14','14:30:00',2.18),('9303','2013-02-14','14:35:00',2.16),('9303','2013-02-14','14:40:00',2.11),('9303','2013-02-14','14:45:00',2.09),('9303','2013-02-14','14:50:00',2.04),('9303','2013-02-14','14:55:00',2.01),('9303','2013-02-14','15:00:00',1.94),('9303','2013-02-14','15:05:00',1.88),('9303','2013-02-14','15:10:00',1.84),('9303','2013-02-14','15:15:00',1.78),('9303','2013-02-14','15:20:00',1.74),('9303','2013-02-14','15:25:00',1.64),('9303','2013-02-14','15:30:00',1.57),('9303','2013-02-14','15:35:00',1.45),('9303','2013-02-14','15:40:00',1.38),('9303','2013-02-14','15:45:00',1.3),('9303','2013-02-14','15:50:00',1.22),('9303','2013-02-14','15:55:00',1.14),('9303','2013-02-14','16:00:00',1.05),('9303','2013-02-13','09:00:00',1.01),('9303','2013-02-13','09:05:00',1.16),('9303','2013-02-13','09:10:00',1.2),('9303','2013-02-13','09:15:00',1.14),('9303','2013-02-13','09:20:00',1.14),('9303','2013-02-13','09:25:00',1.15),('9303','2013-02-13','09:30:00',1.21),('9303','2013-02-13','09:35:00',1.41),('9303','2013-02-13','09:40:00',1.91),('9303','2013-02-13','09:45:00',2.04),('9303','2013-02-13','09:50:00',2.04),('9303','2013-02-13','09:55:00',1.95),('9303','2013-02-13','10:00:00',1.85),('9303','2013-02-13','10:05:00',2.06),('9303','2013-02-13','10:10:00',2.14),('9303','2013-02-13','10:15:00',2.25),('9303','2013-02-13','10:20:00',2.34),('9303','2013-02-13','10:25:00',2.4),('9303','2013-02-13','10:30:00',2.53),('9303','2013-02-13','10:35:00',2.48),('9303','2013-02-13','10:40:00',2.66),('9303','2013-02-13','10:45:00',2.74),('9303','2013-02-13','10:50:00',2.8),('9303','2013-02-13','10:55:00',2.81),('9303','2013-02-13','11:00:00',2.79),('9303','2013-02-13','11:05:00',2.79),('9303','2013-02-13','11:10:00',2.58),('9303','2013-02-13','11:15:00',2.72),('9303','2013-02-13','11:20:00',2.79),('9303','2013-02-13','11:25:00',2.29),('9303','2013-02-13','11:30:00',2.39),('9303','2013-02-13','11:35:00',1.54),('9303','2013-02-13','11:40:00',1.29),('9303','2013-02-13','11:45:00',1.23),('9303','2013-02-13','11:50:00',1.11),('9303','2013-02-13','12:10:00',1.24),('9303','2013-02-13','12:15:00',2.09),('9303','2013-02-13','12:20:00',1.48),('9303','2013-02-13','12:25:00',2.06),('9303','2013-02-13','12:35:00',1.14),('9303','2013-02-13','12:45:00',1.31),('9303','2013-02-13','12:50:00',2.18),('9303','2013-02-13','12:55:00',2.27),('9303','2013-02-13','13:00:00',2.16),('9303','2013-02-13','13:05:00',2.18),('9303','2013-02-13','13:10:00',2.13),('9303','2013-02-13','13:15:00',1.65),('9303','2013-02-13','13:20:00',2.89),('9303','2013-02-13','13:25:00',2.86),('9303','2013-02-13','13:30:00',2.89),('9303','2013-02-13','13:35:00',2.84),('9303','2013-02-13','13:40:00',2.58),('9303','2013-02-13','13:45:00',2.44),('9303','2013-02-13','13:50:00',2.03),('9303','2013-02-13','13:55:00',2.08),('9303','2013-02-13','14:00:00',2.41),('9303','2013-02-13','14:05:00',2.61),('9303','2013-02-13','14:10:00',2.05),('9303','2013-02-13','14:15:00',2.14),('9303','2013-02-13','14:20:00',1.91),('9303','2013-02-13','14:25:00',1.96),('9303','2013-02-13','14:30:00',2.1),('9303','2013-02-13','14:35:00',2.22),('9303','2013-02-13','14:40:00',2.16),('9303','2013-02-13','14:45:00',2.04),('9303','2013-02-13','14:50:00',2.07),('9303','2013-02-13','14:55:00',2.02),('9303','2013-02-13','15:00:00',1.92),('9303','2013-02-13','15:05:00',1.87),('9303','2013-02-13','15:10:00',1.82),('9303','2013-02-13','15:15:00',1.77),('9303','2013-02-13','15:20:00',1.7),('9303','2013-02-13','15:25:00',1.65),('9303','2013-02-13','15:30:00',1.56),('9303','2013-02-13','15:35:00',1.48),('9303','2013-02-13','15:40:00',1.42),('9303','2013-02-13','15:45:00',1.33),('9303','2013-02-13','15:50:00',1.22),('9303','2013-02-13','15:55:00',1.15),('9303','2013-02-13','16:00:00',1.08),('9303','2013-02-11','10:35:00',1.17),('9303','2013-02-11','10:40:00',1.06),('9303','2013-02-11','11:05:00',1.05),('9303','2013-02-11','11:10:00',1.2),('9303','2013-02-11','11:15:00',1.29),('9303','2013-02-11','11:20:00',1.04),('9303','2013-02-11','12:45:00',1),('9303','2013-02-11','14:10:00',1.11),('9303','2013-02-11','14:25:00',1.3),('9303','2013-02-11','14:30:00',1.84),('9303','2013-02-11','14:40:00',1.45),('9303','2013-02-11','14:45:00',1.14),('9303','2014-03-22','07:40:00',1.18),('9303','2014-03-22','07:45:00',1.12),('9303','2014-03-22','07:50:00',1.07),('9303','2014-03-22','08:10:00',1.09),('9303','2014-03-22','08:15:00',1.4),('9303','2014-03-22','08:20:00',1.68),('9303','2014-03-22','08:25:00',1.62),('9303','2014-03-22','08:30:00',1.78),('9303','2014-03-22','08:40:00',2.06),('9303','2014-03-22','08:45:00',2.18),('9303','2014-03-22','08:50:00',1.61),('9303','2014-03-22','08:55:00',1.39),('9303','2014-03-22','09:00:00',2.04),('9303','2014-03-22','09:05:00',1.26),('9303','2014-03-22','09:10:00',1.33),('9303','2014-03-22','09:15:00',1.15),('9303','2014-03-22','09:20:00',1.24),('9303','2014-03-22','09:25:00',1.57),('9303','2014-03-22','09:30:00',2.59),('9303','2014-03-22','09:35:00',1.9),('9303','2014-03-22','09:40:00',2.55),('9303','2014-03-22','09:45:00',2.89),('9303','2014-03-22','09:50:00',2.87),('9303','2014-03-22','09:55:00',3.01),('9303','2014-03-22','10:00:00',3.11),('9303','2014-03-22','10:05:00',3.36),('9303','2014-03-22','10:10:00',2.96),('9303','2014-03-22','10:15:00',1.64),('9303','2014-03-22','10:20:00',1.04),('9303','2014-03-22','10:35:00',1.32),('9303','2014-03-22','10:40:00',2),('9303','2014-03-22','10:45:00',2.37),('9303','2014-03-22','10:50:00',3.66),('9303','2014-03-22','10:55:00',1.29),('9303','2014-03-22','11:00:00',1.12),('9303','2014-03-22','11:10:00',1.08),('9303','2014-03-22','11:15:00',1.49),('9303','2014-03-22','11:20:00',3.55),('9303','2014-03-22','11:25:00',3.75),('9303','2014-03-22','11:30:00',3.78),('9303','2014-03-22','11:35:00',1.45),('9303','2014-03-22','11:40:00',2.7),('9303','2014-03-22','11:45:00',1.65),('9303','2014-03-22','11:50:00',2.4),('9303','2014-03-22','11:55:00',3.56),('9303','2014-03-22','12:00:00',3.11),('9303','2014-03-22','12:05:00',1.8),('9303','2014-03-22','12:10:00',1.14),('9303','2014-03-22','12:15:00',1.5),('9303','2014-03-22','12:20:00',3.49),('9303','2014-03-22','12:25:00',3.21),('9303','2014-03-22','12:30:00',1.75),('9303','2014-03-22','12:35:00',3.1),('9303','2014-03-22','12:40:00',2.75),('9303','2014-03-22','12:45:00',4.1),('9303','2014-03-22','12:50:00',2.12),('9303','2014-03-22','12:55:00',2.52),('9303','2014-03-22','13:00:00',1.87),('9303','2014-03-22','13:05:00',1.65),('9303','2014-03-22','13:10:00',4.09),('9303','2014-03-22','13:15:00',2.53),('9303','2014-03-22','13:20:00',3.18),('9303','2014-03-22','13:25:00',3.6),('9303','2014-03-22','13:30:00',2.06),('9303','2014-03-22','13:35:00',3.22),('9303','2014-03-22','13:40:00',2.44),('9303','2014-03-22','13:45:00',4.06),('9303','2014-03-22','13:50:00',3.24),('9303','2014-03-22','13:55:00',1.91),('9303','2014-03-22','14:00:00',2.12),('9303','2014-03-22','14:05:00',1.65),('9303','2014-03-22','14:10:00',3.57),('9303','2014-03-22','14:15:00',2.74),('9303','2014-03-22','14:20:00',3.06),('9303','2014-03-22','14:25:00',3.23),('9303','2014-03-22','14:30:00',3.12),('9303','2014-03-22','14:35:00',3.06),('9303','2014-03-22','14:40:00',3),('9303','2014-03-22','14:45:00',2.87),('9303','2014-03-22','14:50:00',2.86),('9303','2014-03-22','14:55:00',2.82),('9303','2014-03-22','15:00:00',2.75),('9303','2014-03-22','15:05:00',2.69),('9303','2014-03-22','15:10:00',2.55),('9303','2014-03-22','15:15:00',2.46),('9303','2014-03-22','15:20:00',2.53),('9303','2014-03-22','15:25:00',2.11),('9303','2014-03-22','15:30:00',1.28),('9303','2014-03-22','15:35:00',2.03),('9303','2014-03-22','15:40:00',2.41),('9303','2014-03-22','15:45:00',2.22),('9303','2014-03-22','15:50:00',2.42),('9303','2014-03-22','15:55:00',2.28),('9303','2014-03-22','16:00:00',2.05),('9303','2014-03-22','16:05:00',1.83),('9303','2014-03-22','16:10:00',1.64),('9303','2014-03-22','16:15:00',1.39),('9303','2014-03-22','16:20:00',1.49),('9303','2014-03-22','16:25:00',1.36),('9303','2013-02-10','09:50:00',1.08),('9303','2013-02-10','10:00:00',2.03),('9303','2013-02-10','10:05:00',2.19),('9303','2013-02-10','10:10:00',2.12),('9303','2013-02-10','10:15:00',2.17),('9303','2013-02-10','10:20:00',2.23),('9303','2013-02-10','10:25:00',2.33),('9303','2013-02-10','10:30:00',2.41),('9303','2013-02-10','10:35:00',2.47),('9303','2013-02-10','10:40:00',2.49),('9303','2013-02-10','10:45:00',2.54),('9303','2013-02-10','10:50:00',2.57),('9303','2013-02-10','10:55:00',2.6),('9303','2013-02-10','11:00:00',2.63),('9303','2013-02-10','11:05:00',2.71),('9303','2013-02-10','11:10:00',2.71),('9303','2013-02-10','11:15:00',2.75),('9303','2013-02-10','11:20:00',2.78),('9303','2013-02-10','11:25:00',2.75),('9303','2013-02-10','11:30:00',2.81),('9303','2013-02-10','11:35:00',2.84),('9303','2013-02-10','11:40:00',2.84),('9303','2013-02-10','11:45:00',2.87),('9303','2013-02-10','11:50:00',2.85),('9303','2013-02-10','11:55:00',2.89),('9303','2013-02-10','12:00:00',2.93),('9303','2013-02-10','12:05:00',2.94),('9303','2013-02-10','12:10:00',2.98),('9303','2013-02-10','12:15:00',3),('9303','2013-02-10','12:20:00',3),('9303','2013-02-10','12:25:00',3),('9303','2013-02-10','12:30:00',3.03),('9303','2013-02-10','12:35:00',3.01),('9303','2013-02-10','12:40:00',3.01),('9303','2013-02-10','12:45:00',2.99),('9303','2013-02-10','12:50:00',2.93),('9303','2013-02-10','12:55:00',2.88),('9303','2013-02-10','13:00:00',2.79),('9303','2013-02-10','13:05:00',2.67),('9303','2013-02-10','13:10:00',2.7),('9303','2013-02-10','13:15:00',2.64),('9303','2013-02-10','13:20:00',2.63),('9303','2013-02-10','13:25:00',2.62),('9303','2013-02-10','13:30:00',2.57),('9303','2013-02-10','13:35:00',2.51),('9303','2013-02-10','13:40:00',2.46),('9303','2013-02-10','13:45:00',2.39),('9303','2013-02-10','13:50:00',2.36),('9303','2013-02-10','13:55:00',2.31),('9303','2013-02-10','14:00:00',2.23),('9303','2013-02-10','14:05:00',2.19),('9303','2013-02-10','14:10:00',2.12),('9303','2013-02-10','14:15:00',2.13),('9303','2013-02-10','14:20:00',2.11),('9303','2013-02-10','14:25:00',2.07),('9303','2013-02-10','14:30:00',2.09),('9303','2013-02-10','14:35:00',1.85),('9303','2013-02-10','14:40:00',1.97),('9303','2013-02-10','14:45:00',2.02),('9303','2013-02-10','14:50:00',1.95),('9303','2013-02-10','14:55:00',1.9),('9303','2013-02-10','15:00:00',1.25),('9303','2013-02-10','15:05:00',1.16),('9303','2013-02-10','15:10:00',1.78),('9303','2013-02-10','15:20:00',1.45),('9303','2013-02-10','15:25:00',1.85),('9303','2013-02-10','15:30:00',1.15),('9303','2013-02-10','15:35:00',1.53),('9303','2013-02-09','11:05:00',1),('9303','2013-02-09','11:10:00',1.03),('9303','2013-02-09','11:15:00',1.07),('9303','2013-02-09','11:20:00',1.1),('9303','2013-02-09','11:25:00',1.12),('9303','2013-02-09','11:30:00',1.13),('9303','2013-02-09','11:35:00',1.1),('9303','2013-02-09','11:40:00',1.07),('9303','2013-02-09','11:45:00',1.08),('9303','2013-02-09','11:50:00',1.08),('9303','2013-02-09','11:55:00',1.05),('9303','2013-02-09','12:00:00',1.06),('9303','2013-02-09','12:05:00',1.06),('9303','2013-02-09','12:10:00',1.04),('9303','2013-02-09','12:15:00',1.04),('9303','2013-02-09','12:20:00',1.06),('9303','2013-02-09','12:25:00',1.07),('9303','2013-02-09','12:30:00',1.08),('9303','2013-02-09','12:35:00',1.14),('9303','2013-02-09','12:40:00',1.17),('9303','2013-02-09','12:45:00',1.18),('9303','2013-02-09','12:50:00',1.2),('9303','2013-02-09','12:55:00',1.18),('9303','2013-02-09','13:00:00',1.25),('9303','2013-02-09','13:05:00',1.42),('9303','2013-02-09','13:10:00',1.58),('9303','2013-02-09','13:15:00',1.74),('9303','2013-02-09','13:20:00',1.9),('9303','2013-02-09','13:25:00',1.97),('9303','2013-02-09','13:30:00',2.18),('9303','2013-02-09','13:35:00',2.19),('9303','2013-02-09','13:40:00',2.23),('9303','2013-02-09','13:45:00',2.26),('9303','2013-02-09','13:50:00',2.37),('9303','2013-02-09','13:55:00',2.32),('9303','2013-02-09','14:00:00',2.41),('9303','2013-02-09','14:05:00',2.23),('9303','2013-02-09','14:10:00',1.81),('9303','2013-02-09','14:15:00',2.29),('9303','2013-02-09','14:20:00',2.5),('9303','2013-02-09','14:25:00',2.72),('9303','2013-02-09','14:30:00',2.45),('9303','2013-02-09','14:35:00',2.24),('9303','2013-02-09','14:40:00',2.06),('9303','2013-02-09','14:45:00',1.96),('9303','2013-02-09','14:50:00',1.9),('9303','2013-02-09','14:55:00',1.91),('9303','2013-02-09','15:00:00',1.81),('9303','2013-02-09','15:05:00',1.75),('9303','2013-02-09','15:10:00',1.71),('9303','2013-02-09','15:15:00',1.64),('9303','2013-02-09','15:20:00',1.6),('9303','2013-02-09','15:25:00',1.42),('9303','2013-02-09','15:30:00',1.38),('9303','2013-02-09','15:35:00',1.32),('9303','2013-02-09','15:40:00',1.21),('9303','2013-02-09','15:45:00',1.04),('9303','2013-02-09','15:50:00',1.06),('9303','2013-02-08','09:35:00',2.29),('9303','2013-02-08','09:40:00',2.18),('9303','2013-02-08','09:45:00',1.66),('9303','2013-02-08','09:50:00',2.32),('9303','2013-02-08','09:55:00',2.4),('9303','2013-02-08','10:00:00',2.53),('9303','2013-02-08','10:05:00',2.63),('9303','2013-02-08','10:10:00',2.59),('9303','2013-02-08','10:15:00',2.57),('9303','2013-02-08','10:20:00',2.58),('9303','2013-02-08','10:25:00',2.57),('9303','2013-02-08','10:30:00',2.63),('9303','2013-02-08','10:35:00',1.44),('9303','2013-02-08','10:40:00',1.82),('9303','2013-02-08','10:45:00',2.53),('9303','2013-02-08','10:50:00',2.86),('9303','2013-02-08','10:55:00',2.83),('9303','2013-02-08','11:00:00',2.76),('9303','2013-02-08','11:05:00',2.75),('9303','2013-02-08','11:10:00',2.73),('9303','2013-02-08','11:15:00',2.76),('9303','2013-02-08','11:20:00',2.78),('9303','2013-02-08','11:25:00',2.77),('9303','2013-02-08','11:30:00',2.79),('9303','2013-02-08','11:35:00',2.81),('9303','2013-02-08','11:40:00',2.81),('9303','2013-02-08','11:45:00',2.84),('9303','2013-02-08','11:50:00',2.83),('9303','2013-02-08','11:55:00',2.86),('9303','2013-02-08','12:00:00',2.86),('9303','2013-02-08','12:05:00',2.85),('9303','2013-02-08','12:10:00',2.89),('9303','2013-02-08','12:15:00',2.93),('9303','2013-02-08','12:20:00',2.93),('9303','2013-02-08','12:25:00',2.95),('9303','2013-02-08','12:30:00',2.99),('9303','2013-02-08','12:35:00',3),('9303','2013-02-08','12:40:00',3.01),('9303','2013-02-08','12:45:00',3.24),('9303','2013-02-08','12:50:00',2.31),('9303','2013-02-08','12:55:00',1.9),('9303','2013-02-08','13:00:00',1.75),('9303','2013-02-08','13:05:00',1.6),('9303','2013-02-08','13:10:00',1.78),('9303','2013-02-08','13:15:00',1.7),('9303','2013-02-08','13:20:00',1.79),('9303','2013-02-08','13:25:00',1.66),('9303','2013-02-08','13:30:00',1.63),('9303','2013-02-08','13:35:00',2.24),('9303','2013-02-08','13:40:00',1.79),('9303','2013-02-08','13:45:00',1.41),('9303','2013-02-08','13:50:00',1.44),('9303','2013-02-08','13:55:00',1.48),('9303','2013-02-08','14:00:00',1.39),('9303','2013-02-08','14:05:00',1.36),('9303','2013-02-08','14:10:00',1.25),('9303','2013-02-08','14:15:00',1.12),('9303','2013-02-08','14:20:00',1.13),('9303','2013-02-08','14:25:00',1.33),('9303','2013-02-08','14:30:00',1.75),('9303','2013-02-08','14:35:00',1.65),('9303','2013-02-08','14:40:00',2.91),('9303','2013-02-08','14:45:00',2.69),('9303','2013-02-08','14:50:00',1.84),('9303','2013-02-08','14:55:00',2.18),('9303','2013-02-08','15:00:00',2.2),('9303','2013-02-08','15:05:00',2.48),('9303','2013-02-08','15:10:00',2.42),('9303','2013-02-08','15:15:00',2),('9303','2013-02-08','15:20:00',1.32),('9303','2013-02-08','15:25:00',1.7),('9303','2013-02-08','15:30:00',1.54),('9303','2013-02-08','15:35:00',1.43),('9303','2013-02-08','15:40:00',1.34),('9303','2013-02-08','15:45:00',1.25),('9303','2013-02-08','15:50:00',1.16),('9303','2013-02-08','15:55:00',1.07),('9303','2013-02-07','10:40:00',1.12),('9303','2013-02-07','10:45:00',1.25),('9303','2013-02-07','10:55:00',1.16),('9303','2013-02-07','11:00:00',1.77),('9303','2013-02-07','11:05:00',1.13),('9303','2013-02-07','12:25:00',2.34),('9303','2013-02-07','12:30:00',1.86),('9303','2013-02-07','13:15:00',1.33),('9303','2013-02-07','13:20:00',1.36),('9303','2013-02-07','13:25:00',1.18),('9303','2013-02-07','14:00:00',1.2),('9303','2013-02-07','14:05:00',1.63),('9303','2013-02-07','14:10:00',2.48),('9303','2013-02-07','14:15:00',2.34),('9303','2013-02-07','14:20:00',2.16),('9303','2013-02-07','14:25:00',1.22),('9303','2013-02-07','14:30:00',1.01),('9303','2013-02-07','14:35:00',1.55),('9303','2013-02-07','14:40:00',1.38),('9303','2013-02-07','14:45:00',1.92),('9303','2013-02-07','14:50:00',1.3),('9303','2013-02-07','15:00:00',1.44),('9303','2013-02-07','15:05:00',2.1),('9303','2013-02-07','15:10:00',2.21),('9303','2013-02-07','15:15:00',1.56),('9303','2013-02-06','08:50:00',1.15),('9303','2013-02-06','09:00:00',1.02),('9303','2013-02-06','09:05:00',1.12),('9303','2013-02-06','09:10:00',1.32),('9303','2013-02-06','09:25:00',1.03),('9303','2013-02-06','09:30:00',1.36),('9303','2013-02-06','09:35:00',1.04),('9303','2013-02-06','09:40:00',1.47),('9303','2013-02-06','09:45:00',1.1),('9303','2013-02-06','09:50:00',1.14),('9303','2013-02-06','09:55:00',1.39),('9303','2013-02-06','10:00:00',1.18),('9303','2013-02-06','10:05:00',1.46),('9303','2013-02-06','10:10:00',1.29),('9303','2013-02-06','10:15:00',1.21),('9303','2013-02-06','10:20:00',1.06),('9303','2013-02-06','10:25:00',1.31),('9303','2013-02-06','10:30:00',1.32),('9303','2013-02-06','10:35:00',1.6),('9303','2013-02-06','10:40:00',1.17),('9303','2013-02-06','10:50:00',1.41),('9303','2013-02-06','10:55:00',1.86),('9303','2013-02-06','11:00:00',1.58),('9303','2013-02-06','11:05:00',1.25),('9303','2013-02-06','11:10:00',1.45),('9303','2013-02-06','11:15:00',1.31),('9303','2013-02-06','11:20:00',1.53),('9303','2013-02-06','11:25:00',2.14),('9303','2013-02-06','11:30:00',1.44),('9303','2013-02-06','11:35:00',1.34),('9303','2013-02-06','11:40:00',1.48),('9303','2013-02-06','11:45:00',1.51),('9303','2013-02-06','11:50:00',1.55),('9303','2013-02-06','11:55:00',1.48),('9303','2013-02-06','12:00:00',1.27),('9303','2013-02-06','12:05:00',1.03),('9303','2013-02-06','12:20:00',1),('9303','2013-02-06','13:30:00',1.13),('9303','2013-02-06','13:35:00',1.26),('9303','2013-02-06','13:40:00',1.01),('9303','2013-02-06','13:50:00',1.53),('9303','2013-02-06','13:55:00',1.2),('9303','2013-02-06','14:00:00',1.32),('9303','2013-02-06','14:05:00',1.25),('9303','2013-02-06','14:30:00',1.25),('9303','2013-02-06','14:35:00',2),('9303','2013-02-06','14:40:00',1.17),('9303','2013-02-05','08:55:00',1.1),('9303','2013-02-05','09:00:00',1.2),('9303','2013-02-05','09:05:00',1.28),('9303','2013-02-05','09:10:00',1.37),('9303','2013-02-05','09:15:00',1.46),('9303','2013-02-05','09:20:00',1.53),('9303','2013-02-05','09:25:00',1.59),('9303','2013-02-05','09:30:00',1.64),('9303','2013-02-05','09:35:00',1.7),('9303','2013-02-05','09:40:00',1.77),('9303','2013-02-05','09:45:00',1.81),('9303','2013-02-05','09:50:00',1.85),('9303','2013-02-05','09:55:00',1.9),('9303','2013-02-05','10:00:00',1.9),('9303','2013-02-05','10:05:00',1.88),('9303','2013-02-05','10:10:00',1.75),('9303','2013-02-05','10:15:00',1.75),('9303','2013-02-05','10:20:00',1.94),('9303','2013-02-05','10:25:00',1.94),('9303','2013-02-05','10:30:00',2.02),('9303','2013-02-05','10:35:00',2.06),('9303','2013-02-05','10:40:00',2.11),('9303','2013-02-05','10:45:00',2.14),('9303','2013-02-05','10:50:00',2.13),('9303','2013-02-05','10:55:00',2.19),('9303','2013-02-05','11:00:00',2.21),('9303','2013-02-05','11:05:00',2.24),('9303','2013-02-05','11:10:00',2.32),('9303','2013-02-05','11:15:00',2.34),('9303','2013-02-05','11:20:00',2.34),('9303','2013-02-05','11:25:00',2.39),('9303','2013-02-05','11:30:00',2.39),('9303','2013-02-05','11:35:00',2.29),('9303','2013-02-05','11:40:00',2.11),('9303','2013-02-05','11:45:00',2),('9303','2013-02-05','11:50:00',1.53),('9303','2013-02-05','11:55:00',1.35),('9303','2013-02-05','12:00:00',1.07),('9303','2013-02-05','12:05:00',1.26),('9303','2013-02-05','12:10:00',1.56),('9303','2013-02-05','12:15:00',1.33),('9303','2013-02-05','12:20:00',1.06),('9303','2013-02-05','12:30:00',1.03),('9303','2013-02-05','12:35:00',1.17),('9303','2013-02-05','12:40:00',1.67),('9303','2013-02-05','12:45:00',1.73),('9303','2013-02-05','12:50:00',1.86),('9303','2013-02-05','13:15:00',1.2),('9303','2013-02-05','13:20:00',1.24),('9303','2013-02-05','13:25:00',1.2),('9303','2013-02-05','13:30:00',1.18),('9303','2013-02-05','13:45:00',1.2),('9303','2013-02-05','13:50:00',1.28),('9303','2013-02-05','13:55:00',1.09),('9303','2013-02-05','14:00:00',1.13),('9303','2013-02-05','14:05:00',1.17),('9303','2013-02-05','14:20:00',1.05),('9303','2013-02-05','14:25:00',1.56),('9303','2013-02-05','14:30:00',1.55),('9303','2013-02-05','14:35:00',1.41),('9303','2013-02-05','14:40:00',1.46),('9303','2013-02-04','08:50:00',1.01),('9303','2013-02-04','09:00:00',1.25),('9303','2013-02-04','09:05:00',1.37),('9303','2013-02-04','09:10:00',1.49),('9303','2013-02-04','09:15:00',1.58),('9303','2013-02-04','09:20:00',1.56),('9303','2013-02-04','09:25:00',1.58),('9303','2013-02-04','09:30:00',1.71),('9303','2013-02-04','09:35:00',1.72),('9303','2013-02-04','09:40:00',1.74),('9303','2013-02-04','09:45:00',1.54),('9303','2013-02-04','09:50:00',1.89),('9303','2013-02-04','09:55:00',2.04),('9303','2013-02-04','10:00:00',2.1),('9303','2013-02-04','10:05:00',2.07),('9303','2013-02-04','10:10:00',2.14),('9303','2013-02-04','10:15:00',2.16),('9303','2013-02-04','10:20:00',2),('9303','2013-02-04','10:25:00',2.1),('9303','2013-02-04','10:30:00',2.01),('9303','2013-02-04','10:35:00',1.92),('9303','2013-02-04','10:40:00',2.03),('9303','2013-02-04','10:45:00',2.26),('9303','2013-02-04','10:50:00',2.31),('9303','2013-02-04','10:55:00',2.31),('9303','2013-02-04','11:00:00',2.35),('9303','2013-02-04','11:05:00',2.41),('9303','2013-02-04','11:10:00',2.46),('9303','2013-02-04','11:15:00',2.51),('9303','2013-02-04','11:20:00',2.49),('9303','2013-02-04','11:25:00',2.52),('9303','2013-02-04','11:30:00',2.58),('9303','2013-02-04','11:35:00',2.59),('9303','2013-02-04','11:40:00',2.59),('9303','2013-02-04','11:45:00',2.66),('9303','2013-02-04','11:50:00',2.64),('9303','2013-02-04','11:55:00',2.67),('9303','2013-02-04','12:00:00',2.67),('9303','2013-02-04','12:05:00',2.68),('9303','2013-02-04','12:10:00',2.75),('9303','2013-02-04','12:15:00',2.78),('9303','2013-02-04','12:20:00',2.78),('9303','2013-02-04','12:25:00',2.77),('9303','2013-02-04','12:30:00',2.82),('9303','2013-02-04','12:35:00',2.79),('9303','2013-02-04','12:40:00',2.81),('9303','2013-02-04','12:45:00',2.78),('9303','2013-02-04','12:50:00',2.68),('9303','2013-02-04','12:55:00',2.71),('9303','2013-02-04','13:00:00',2.66),('9303','2013-02-04','13:05:00',2.57),('9303','2013-02-04','13:10:00',2.52),('9303','2013-02-04','13:15:00',2.47),('9303','2013-02-04','13:20:00',2.47),('9303','2013-02-04','13:25:00',2.42),('9303','2013-02-04','13:30:00',2.41),('9303','2013-02-04','13:35:00',2.38),('9303','2013-02-04','13:40:00',2.33),('9303','2013-02-04','13:45:00',2.3),('9303','2013-02-04','13:50:00',2.29),('9303','2013-02-04','13:55:00',2.23),('9303','2013-02-04','14:00:00',2.17),('9303','2013-02-04','14:05:00',2.06),('9303','2013-02-04','14:10:00',2.06),('9303','2013-02-04','14:15:00',2.03),('9303','2013-02-04','14:20:00',2.05),('9303','2013-02-04','14:25:00',2.04),('9303','2013-02-04','14:30:00',1.99),('9303','2013-02-04','14:35:00',1.96),('9303','2013-02-04','14:40:00',1.92),('9303','2013-02-04','14:45:00',1.89),('9303','2013-02-04','14:50:00',1.84),('9303','2013-02-04','14:55:00',1.79),('9303','2013-02-04','15:00:00',1.74),('9303','2013-02-04','15:05:00',1.68),('9303','2013-02-04','15:10:00',1.63),('9303','2013-02-04','15:15:00',1.57),('9303','2013-02-04','15:20:00',1.5),('9303','2013-02-04','15:25:00',1.41),('9303','2013-02-04','15:30:00',1.35),('9303','2013-02-04','15:35:00',1.27),('9303','2013-02-04','15:40:00',1.17),('9303','2013-02-04','15:45:00',1.1),('9303','2013-02-04','15:50:00',1.02),('9303','2013-02-03','09:25:00',1.18),('9303','2013-02-03','09:40:00',1.1),('9303','2013-02-03','09:45:00',1.35),('9303','2013-02-03','09:50:00',1.34),('9303','2013-02-03','09:55:00',1.15),('9303','2013-02-03','10:00:00',1.67),('9303','2013-02-03','11:20:00',1.21),('9303','2013-02-03','11:55:00',1.13),('9303','2013-02-03','12:00:00',1.19),('9303','2013-02-03','12:05:00',1.13),('9303','2013-02-03','12:10:00',1.1),('9303','2013-02-02','10:30:00',1.05),('9303','2013-02-02','10:35:00',1.18),('9303','2013-02-02','10:40:00',1.28),('9303','2013-02-02','10:45:00',1.38),('9303','2013-02-02','10:50:00',1.09),('9303','2013-02-02','10:55:00',1.52),('9303','2013-02-02','11:00:00',1.68),('9303','2013-02-02','11:05:00',1.56),('9303','2013-02-02','11:10:00',1.66),('9303','2013-02-02','11:15:00',1.6),('9303','2013-02-02','11:20:00',1.64),('9303','2013-02-02','11:25:00',1.78),('9303','2013-02-02','11:30:00',1.72),('9303','2013-02-02','11:35:00',1.62),('9303','2013-02-02','11:40:00',1.59),('9303','2013-02-02','11:45:00',1.1),('9303','2013-02-02','11:55:00',1.06),('9303','2013-02-02','12:55:00',1.74),('9303','2013-02-02','13:00:00',1.44),('9303','2013-02-02','13:05:00',1.61),('9303','2013-02-02','13:10:00',1.64),('9303','2013-02-02','13:15:00',1.94),('9303','2013-02-02','13:20:00',1.59),('9303','2013-02-02','13:25:00',1.62),('9303','2013-02-02','13:30:00',1.17),('9303','2013-02-02','13:35:00',1.73),('9303','2013-02-02','13:40:00',2.17),('9303','2013-02-02','13:45:00',1.74),('9303','2013-02-02','13:50:00',1.72),('9303','2013-02-02','13:55:00',1),('9303','2013-02-01','09:00:00',1.02),('9303','2013-02-01','09:05:00',1.26),('9303','2013-02-01','09:10:00',1.46),('9303','2013-02-01','09:25:00',1.46),('9303','2013-02-01','09:30:00',1.2),('9303','2013-02-01','09:35:00',1.34),('9303','2013-02-01','09:40:00',1.9),('9303','2013-02-01','09:45:00',1.65),('9303','2013-02-01','09:50:00',1.05),('9303','2013-02-01','09:55:00',1.33),('9303','2013-02-01','10:00:00',1.53),('9303','2013-02-01','10:05:00',1.12),('9303','2013-02-01','10:20:00',1.38),('9303','2013-02-01','10:25:00',1.15),('9303','2013-02-01','10:30:00',1.03),('9303','2013-02-01','10:50:00',1.99),('9303','2013-02-01','10:55:00',2.53),('9303','2013-02-01','11:00:00',2.44),('9303','2013-02-01','11:05:00',2.29),('9303','2013-02-01','11:10:00',1.99),('9303','2013-02-01','11:15:00',1.41),('9303','2013-02-01','11:20:00',1.91),('9303','2013-02-01','11:25:00',1.06),('9303','2013-02-01','11:35:00',1.86),('9303','2013-02-01','11:40:00',1.72),('9303','2013-02-01','11:45:00',1.71),('9303','2013-02-01','11:50:00',1.21),('9303','2013-02-01','12:00:00',1.08),('9303','2013-02-01','12:05:00',1.35),('9303','2013-02-01','12:10:00',1.45),('9303','2013-02-01','12:15:00',1.93),('9303','2013-02-01','12:20:00',2.64),('9303','2013-02-01','12:25:00',2.45),('9303','2013-02-01','12:30:00',1.12),('9303','2013-02-01','12:35:00',2.45),('9303','2013-02-01','12:40:00',2.99),('9303','2013-02-01','12:45:00',2.77),('9303','2013-02-01','12:50:00',2.82),('9303','2013-02-01','12:55:00',2.17),('9303','2013-02-01','13:00:00',2.25),('9303','2013-02-01','13:05:00',1.72),('9303','2013-02-01','13:10:00',2.6),('9303','2013-02-01','13:15:00',2.36),('9303','2013-02-01','13:20:00',2.34),('9303','2013-02-01','13:25:00',2.16),('9303','2013-02-01','13:30:00',1.58),('9303','2013-02-01','13:35:00',1.9),('9303','2013-02-01','13:40:00',1.95),('9303','2013-02-01','13:45:00',1.85),('9303','2013-02-01','13:50:00',1.46),('9303','2013-02-01','14:10:00',1.05),('9303','2013-02-01','14:15:00',2.08),('9303','2013-02-01','14:20:00',2.14),('9303','2013-02-01','14:25:00',1.89),('9303','2013-02-01','14:30:00',1.88),('9303','2013-02-01','14:35:00',1.84),('9303','2013-02-01','14:40:00',1.64),('9303','2013-02-01','15:05:00',1.04),('9303','2013-02-01','15:10:00',1.47),('9303','2013-02-01','15:15:00',1.27),('9303','2013-02-01','15:20:00',1.31),('9303','2013-02-01','15:25:00',1.22),('9303','2014-03-21','07:45:00',1.05),('9303','2014-03-21','07:50:00',1.16),('9303','2014-03-21','07:55:00',1.26),('9303','2014-03-21','08:00:00',1.33),('9303','2014-03-21','08:05:00',1.39),('9303','2014-03-21','08:10:00',1.52),('9303','2014-03-21','08:15:00',1.62),('9303','2014-03-21','08:20:00',1.67),('9303','2014-03-21','08:25:00',1.77),('9303','2014-03-21','08:30:00',1.87),('9303','2014-03-21','08:35:00',1.98),('9303','2014-03-21','08:40:00',2.06),('9303','2014-03-21','08:45:00',2.09),('9303','2014-03-21','08:50:00',2.19),('9303','2014-03-21','08:55:00',2.28),('9303','2014-03-21','09:00:00',2.34),('9303','2014-03-21','09:05:00',2.36),('9303','2014-03-21','09:10:00',2.51),('9303','2014-03-21','09:15:00',2.56),('9303','2014-03-21','09:20:00',2.68),('9303','2014-03-21','09:25:00',2.6),('9303','2014-03-21','09:30:00',2.78),('9303','2014-03-21','09:35:00',2.8),('9303','2014-03-21','09:40:00',2.86),('9303','2014-03-21','09:45:00',2.92),('9303','2014-03-21','09:50:00',2.97),('9303','2014-03-21','09:55:00',3.01),('9303','2014-03-21','10:00:00',3.06),('9303','2014-03-21','10:05:00',3.06),('9303','2014-03-21','10:10:00',3.01),('9303','2014-03-21','10:15:00',3.09),('9303','2014-03-21','10:20:00',3.14),('9303','2014-03-21','10:25:00',3.26),('9303','2014-03-21','10:30:00',3.29),('9303','2014-03-21','10:35:00',3.31),('9303','2014-03-21','10:40:00',3.38),('9303','2014-03-21','10:45:00',3.32),('9303','2014-03-21','10:50:00',3.31),('9303','2014-03-21','10:55:00',3.35),('9303','2014-03-21','11:00:00',3.37),('9303','2014-03-21','11:05:00',3.42),('9303','2014-03-21','11:10:00',3.35),('9303','2014-03-21','11:15:00',3.41),('9303','2014-03-21','11:20:00',3.41),('9303','2014-03-21','11:25:00',3.61),('9303','2014-03-21','11:30:00',2.75),('9303','2014-03-21','11:35:00',1.27),('9303','2014-03-21','11:40:00',1.61),('9303','2014-03-21','11:45:00',1.55),('9303','2014-03-21','11:50:00',1.91),('9303','2014-03-21','11:55:00',4.11),('9303','2014-03-21','12:00:00',3.43),('9303','2014-03-21','12:05:00',3.78),('9303','2014-03-21','12:10:00',3.76),('9303','2014-03-21','12:15:00',3.76),('9303','2014-03-21','12:20:00',3.76),('9303','2014-03-21','12:25:00',3.76),('9303','2014-03-21','12:30:00',3.76),('9303','2014-03-21','12:35:00',3.69),('9303','2014-03-21','12:40:00',3.7),('9303','2014-03-21','12:45:00',3.72),('9303','2014-03-21','12:50:00',3.69),('9303','2014-03-21','12:55:00',3.68),('9303','2014-03-21','13:00:00',3.63),('9303','2014-03-21','13:05:00',3.64),('9303','2014-03-21','13:10:00',3.63),('9303','2014-03-21','13:15:00',3.61),('9303','2014-03-21','13:20:00',3.6),('9303','2014-03-21','13:25:00',3.56),('9303','2014-03-21','13:30:00',3.54),('9303','2014-03-21','13:35:00',3.47),('9303','2014-03-21','13:40:00',3.46),('9303','2014-03-21','13:45:00',3.45),('9303','2014-03-21','13:50:00',3.43),('9303','2014-03-21','13:55:00',3.4),('9303','2014-03-21','14:00:00',3.4),('9303','2014-03-21','14:05:00',3.37),('9303','2014-03-21','14:10:00',3.35),('9303','2014-03-21','14:15:00',3.3),('9303','2014-03-21','14:20:00',3.27),('9303','2014-03-21','14:25:00',3.23),('9303','2014-03-21','14:30:00',3.03),('9303','2014-03-21','14:35:00',2.95),('9303','2014-03-21','14:40:00',2.98),('9303','2014-03-21','14:45:00',2.89),('9303','2014-03-21','14:50:00',2.34),('9303','2014-03-21','14:55:00',1.4),('9303','2014-03-21','15:05:00',1.32),('9303','2014-03-21','15:10:00',2.9),('9303','2014-03-21','15:15:00',3.09),('9303','2014-03-21','15:20:00',2.84),('9303','2014-03-21','15:25:00',2.78),('9303','2014-03-21','15:30:00',2.89),('9303','2014-03-21','15:35:00',2.6),('9303','2014-03-21','15:40:00',2.58),('9303','2014-03-21','15:45:00',2.45),('9303','2014-03-21','15:50:00',2.39),('9303','2014-03-21','15:55:00',2.31),('9303','2014-03-21','16:00:00',2.18),('9303','2014-03-21','16:05:00',1.99),('9303','2014-03-21','16:10:00',1.82),('9303','2014-03-21','16:15:00',1.68),('9303','2014-03-21','16:20:00',1.53),('9303','2014-03-21','16:25:00',1.4),('9303','2014-03-21','16:30:00',1.3),('9303','2014-03-21','16:35:00',1.19),('9303','2014-03-21','16:40:00',1.07),('9303','2013-01-31','09:20:00',1.07),('9303','2013-01-31','09:25:00',1.51),('9303','2013-01-31','09:30:00',1.65),('9303','2013-01-31','09:35:00',1.54),('9303','2013-01-31','09:40:00',1.6),('9303','2013-01-31','09:45:00',1.51),('9303','2013-01-31','09:50:00',1.65),('9303','2013-01-31','09:55:00',1.74),('9303','2013-01-31','10:00:00',1.71),('9303','2013-01-31','10:05:00',1.74),('9303','2013-01-31','10:10:00',1.62),('9303','2013-01-31','10:15:00',1.7),('9303','2013-01-31','10:20:00',1.75),('9303','2013-01-31','10:25:00',1.47),('9303','2013-01-31','10:30:00',1.51),('9303','2013-01-31','10:35:00',2.09),('9303','2013-01-31','10:40:00',2.17),('9303','2013-01-31','10:45:00',2.25),('9303','2013-01-31','10:50:00',2.29),('9303','2013-01-31','10:55:00',2.31),('9303','2013-01-31','11:00:00',1.95),('9303','2013-01-31','11:05:00',2.38),('9303','2013-01-31','11:10:00',2.53),('9303','2013-01-31','11:15:00',2.62),('9303','2013-01-31','11:20:00',2.59),('9303','2013-01-31','11:25:00',2.4),('9303','2013-01-31','11:30:00',2.3),('9303','2013-01-31','11:35:00',2.32),('9303','2013-01-31','11:40:00',2.34),('9303','2013-01-31','11:45:00',2.37),('9303','2013-01-31','11:50:00',2.35),('9303','2013-01-31','11:55:00',2.35),('9303','2013-01-31','12:00:00',2.35),('9303','2013-01-31','12:05:00',2.35),('9303','2013-01-31','12:10:00',2.28),('9303','2013-01-31','12:15:00',2.14),('9303','2013-01-31','12:20:00',2.42),('9303','2013-01-31','12:25:00',2.49),('9303','2013-01-31','12:30:00',2.51),('9303','2013-01-31','12:35:00',2.55),('9303','2013-01-31','12:40:00',2.53),('9303','2013-01-31','12:45:00',2.54),('9303','2013-01-31','12:50:00',2.48),('9303','2013-01-31','12:55:00',2.45),('9303','2013-01-31','13:00:00',2.4),('9303','2013-01-31','13:05:00',2.34),('9303','2013-01-31','13:10:00',2.32),('9303','2013-01-31','13:15:00',2.23),('9303','2013-01-31','13:20:00',2.15),('9303','2013-01-31','13:25:00',2.13),('9303','2013-01-31','13:30:00',2.1),('9303','2013-01-31','13:35:00',2.07),('9303','2013-01-31','13:40:00',2.01),('9303','2013-01-31','13:45:00',1.98),('9303','2013-01-31','13:50:00',2.06),('9303','2013-01-31','13:55:00',2),('9303','2013-01-31','14:00:00',1.98),('9303','2013-01-31','14:05:00',1.84),('9303','2013-01-31','14:10:00',1.75),('9303','2013-01-31','14:15:00',1.75),('9303','2013-01-31','14:20:00',1.78),('9303','2013-01-31','14:25:00',1.75),('9303','2013-01-31','14:30:00',1.68),('9303','2013-01-31','14:35:00',1.67),('9303','2013-01-31','14:40:00',1.64),('9303','2013-01-31','14:45:00',1.61),('9303','2013-01-31','14:50:00',1.54),('9303','2013-01-31','14:55:00',1.52),('9303','2013-01-31','15:00:00',1.48),('9303','2013-01-31','15:05:00',1.44),('9303','2013-01-31','15:10:00',1.4),('9303','2013-01-31','15:15:00',1.38),('9303','2013-01-31','15:20:00',1.3),('9303','2013-01-31','15:25:00',1.19),('9303','2013-01-31','15:30:00',1.17),('9303','2013-01-31','15:35:00',1.12),('9303','2013-01-31','15:40:00',1.04),('9303','2013-01-30','10:10:00',1.3),('9303','2013-01-30','10:15:00',1.06),('9303','2013-01-30','10:20:00',1.43),('9303','2013-01-30','10:25:00',1.46),('9303','2013-01-30','10:30:00',1.32),('9303','2013-01-30','10:35:00',1.21),('9303','2013-01-30','10:40:00',1.27),('9303','2013-01-30','10:45:00',1.52),('9303','2013-01-30','10:50:00',1.69),('9303','2013-01-30','10:55:00',1.81),('9303','2013-01-30','11:00:00',2.05),('9303','2013-01-30','11:05:00',1.98),('9303','2013-01-30','11:10:00',2.07),('9303','2013-01-30','11:15:00',2.04),('9303','2013-01-30','11:20:00',2.11),('9303','2013-01-30','11:25:00',2.21),('9303','2013-01-30','11:30:00',2.21),('9303','2013-01-30','11:35:00',2.22),('9303','2013-01-30','11:40:00',1.9),('9303','2013-01-30','11:45:00',2.24),('9303','2013-01-30','11:50:00',1.99),('9303','2013-01-30','11:55:00',2.3),('9303','2013-01-30','12:00:00',2.32),('9303','2013-01-30','12:05:00',1.91),('9303','2013-01-30','12:10:00',1.28),('9303','2013-01-30','12:15:00',1.61),('9303','2013-01-30','12:20:00',1.21),('9303','2013-01-30','12:40:00',1.32),('9303','2013-01-30','12:50:00',1.68),('9303','2013-01-30','12:55:00',2.98),('9303','2013-01-30','13:00:00',2.79),('9303','2013-01-30','13:05:00',2.33),('9303','2013-01-30','13:10:00',2.52),('9303','2013-01-30','13:15:00',2.49),('9303','2013-01-30','13:20:00',2.5),('9303','2013-01-30','13:25:00',2.5),('9303','2013-01-30','13:30:00',2.18),('9303','2013-01-30','13:35:00',1.98),('9303','2013-01-30','13:40:00',1.93),('9303','2013-01-30','13:45:00',1.1),('9303','2013-01-30','13:50:00',1.98),('9303','2013-01-30','13:55:00',1.98),('9303','2013-01-30','14:00:00',1.96),('9303','2013-01-30','14:05:00',1.9),('9303','2013-01-30','14:10:00',2.34),('9303','2013-01-30','14:15:00',1.8),('9303','2013-01-30','14:20:00',1.57),('9303','2013-01-30','14:25:00',1.98),('9303','2013-01-30','14:30:00',1.36),('9303','2013-01-30','14:35:00',1.67),('9303','2013-01-30','14:40:00',1.83),('9303','2013-01-30','14:45:00',1.52),('9303','2013-01-29','09:10:00',1.1),('9303','2013-01-29','09:15:00',1.17),('9303','2013-01-29','09:20:00',1.23),('9303','2013-01-29','09:25:00',1.33),('9303','2013-01-29','09:30:00',1.4),('9303','2013-01-29','09:35:00',1.47),('9303','2013-01-29','09:40:00',1.55),('9303','2013-01-29','09:45:00',1.61),('9303','2013-01-29','09:50:00',1.67),('9303','2013-01-29','09:55:00',1.72),('9303','2013-01-29','10:00:00',1.74),('9303','2013-01-29','10:05:00',1.79),('9303','2013-01-29','10:10:00',1.81),('9303','2013-01-29','10:15:00',1.84),('9303','2013-01-29','10:20:00',1.87),('9303','2013-01-29','10:25:00',1.91),('9303','2013-01-29','10:30:00',1.95),('9303','2013-01-29','10:35:00',2.01),('9303','2013-01-29','10:40:00',2.04),('9303','2013-01-29','10:45:00',2.07),('9303','2013-01-29','10:50:00',2.11),('9303','2013-01-29','10:55:00',2.12),('9303','2013-01-29','11:00:00',2.15),('9303','2013-01-29','11:05:00',2.15),('9303','2013-01-29','11:10:00',2.17),('9303','2013-01-29','11:15:00',2.25),('9303','2013-01-29','11:20:00',2.27),('9303','2013-01-29','11:25:00',2.23),('9303','2013-01-29','11:30:00',2.24),('9303','2013-01-29','11:35:00',2.34),('9303','2013-01-29','11:40:00',2.36),('9303','2013-01-29','11:45:00',2.39),('9303','2013-01-29','11:50:00',2.38),('9303','2013-01-29','11:55:00',2.39),('9303','2013-01-29','12:00:00',2.37),('9303','2013-01-29','12:05:00',2.35),('9303','2013-01-29','12:10:00',2.47),('9303','2013-01-29','12:15:00',2.44),('9303','2013-01-29','12:20:00',2.5),('9303','2013-01-29','12:25:00',2.54),('9303','2013-01-29','12:30:00',2.57),('9303','2013-01-29','12:35:00',2.57),('9303','2013-01-29','12:40:00',2.59),('9303','2013-01-29','12:45:00',2.57),('9303','2013-01-29','12:50:00',2.5),('9303','2013-01-29','12:55:00',2.47),('9303','2013-01-29','13:00:00',2.44),('9303','2013-01-29','13:05:00',2.38),('9303','2013-01-29','13:10:00',2.31),('9303','2013-01-29','13:15:00',2.26),('9303','2013-01-29','13:20:00',2.16),('9303','2013-01-29','13:25:00',2.21),('9303','2013-01-29','13:30:00',2.16),('9303','2013-01-29','13:35:00',2.13),('9303','2013-01-29','13:40:00',2.08),('9303','2013-01-29','13:45:00',2.08),('9303','2013-01-29','13:50:00',2.03),('9303','2013-01-29','13:55:00',1.96),('9303','2013-01-29','14:00:00',1.91),('9303','2013-01-29','14:05:00',1.8),('9303','2013-01-29','14:10:00',1.72),('9303','2013-01-29','14:15:00',1.78),('9303','2013-01-29','14:20:00',1.85),('9303','2013-01-29','14:25:00',1.81),('9303','2013-01-29','14:30:00',1.76),('9303','2013-01-29','14:35:00',1.71),('9303','2013-01-29','14:40:00',1.68),('9303','2013-01-29','14:45:00',1.67),('9303','2013-01-29','14:50:00',1.62),('9303','2013-01-29','14:55:00',1.58),('9303','2013-01-29','15:00:00',1.54),('9303','2013-01-29','15:05:00',1.47),('9303','2013-01-29','15:10:00',1.4),('9303','2013-01-29','15:15:00',1.35),('9303','2013-01-29','15:20:00',1.23),('9303','2013-01-29','15:25:00',1.17),('9303','2013-01-29','15:30:00',1.1),('9303','2013-01-29','15:35:00',1.02),('9303','2013-01-28','12:50:00',1.15),('9303','2013-01-28','12:55:00',1.11),('9303','2013-01-28','13:00:00',1.02),('9303','2013-01-28','13:05:00',1),('9303','2013-01-27','09:10:00',1.02),('9303','2013-01-27','09:15:00',1.08),('9303','2013-01-27','09:20:00',1.18),('9303','2013-01-27','09:25:00',1.29),('9303','2013-01-27','09:30:00',1.36),('9303','2013-01-27','09:35:00',1.46),('9303','2013-01-27','09:40:00',1.52),('9303','2013-01-27','09:45:00',1.59),('9303','2013-01-27','09:50:00',1.66),('9303','2013-01-27','09:55:00',1.72),('9303','2013-01-27','10:00:00',1.72),('9303','2013-01-27','10:05:00',1.75),('9303','2013-01-27','10:10:00',1.75),('9303','2013-01-27','10:15:00',1.79),('9303','2013-01-27','10:20:00',1.81),('9303','2013-01-27','10:25:00',1.84),('9303','2013-01-27','10:30:00',1.85),('9303','2013-01-27','10:35:00',1.63),('9303','2013-01-27','10:40:00',1.93),('9303','2013-01-27','10:45:00',2),('9303','2013-01-27','10:50:00',2.05),('9303','2013-01-27','10:55:00',2.05),('9303','2013-01-27','11:00:00',2.13),('9303','2013-01-27','11:05:00',2.15),('9303','2013-01-27','11:10:00',2.19),('9303','2013-01-27','11:15:00',2.21),('9303','2013-01-27','11:20:00',2.24),('9303','2013-01-27','11:25:00',2.23),('9303','2013-01-27','11:30:00',2.25),('9303','2013-01-27','11:35:00',2.27),('9303','2013-01-27','11:40:00',2.27),('9303','2013-01-27','11:45:00',2.32),('9303','2013-01-27','11:50:00',2.31),('9303','2013-01-27','11:55:00',2.36),('9303','2013-01-27','12:00:00',2.36),('9303','2013-01-27','12:05:00',2.36),('9303','2013-01-27','12:10:00',2.42),('9303','2013-01-27','12:15:00',2.44),('9303','2013-01-27','12:20:00',2.46),('9303','2013-01-27','12:25:00',2.5),('9303','2013-01-27','12:30:00',2.5),('9303','2013-01-27','12:35:00',2.55),('9303','2013-01-27','12:40:00',2.51),('9303','2013-01-27','12:45:00',2.53),('9303','2013-01-27','12:50:00',2.47),('9303','2013-01-27','12:55:00',2.47),('9303','2013-01-27','13:00:00',2.42),('9303','2013-01-27','13:05:00',2.37),('9303','2013-01-27','13:10:00',2.31),('9303','2013-01-27','13:15:00',2.27),('9303','2013-01-27','13:20:00',2.14),('9303','2013-01-27','13:25:00',2.14),('9303','2013-01-27','13:30:00',2.07),('9303','2013-01-27','13:35:00',2.06),('9303','2013-01-27','13:40:00',2.01),('9303','2013-01-27','13:45:00',1.97),('9303','2013-01-27','13:50:00',1.91),('9303','2013-01-27','13:55:00',1.87),('9303','2013-01-27','14:00:00',1.84),('9303','2013-01-27','14:05:00',1.79),('9303','2013-01-27','14:10:00',1.78),('9303','2013-01-27','14:15:00',1.74),('9303','2013-01-27','14:20:00',1.71),('9303','2013-01-27','14:25:00',1.69),('9303','2013-01-27','14:30:00',1.63),('9303','2013-01-27','14:35:00',1.63),('9303','2013-01-27','14:40:00',1.58),('9303','2013-01-27','14:45:00',1.55),('9303','2013-01-27','14:50:00',1.57),('9303','2013-01-27','14:55:00',1.52),('9303','2013-01-27','15:00:00',1.47),('9303','2013-01-27','15:05:00',1.4),('9303','2013-01-27','15:10:00',1.32),('9303','2013-01-27','15:15:00',1.25),('9303','2013-01-27','15:20:00',1.16),('9303','2013-01-27','15:25:00',1.1),('9303','2013-01-27','15:30:00',1.04),('9303','2013-01-26','10:20:00',1.11),('9303','2013-01-26','10:25:00',1.21),('9303','2013-01-26','10:50:00',1.04),('9303','2013-01-25','09:15:00',1.07),('9303','2013-01-25','09:20:00',1.17),('9303','2013-01-25','09:25:00',1.29),('9303','2013-01-25','09:30:00',1.46),('9303','2013-01-25','09:35:00',1.48),('9303','2013-01-25','09:40:00',1.36),('9303','2013-01-25','09:45:00',1.49),('9303','2013-01-25','09:50:00',1.84),('9303','2013-01-25','09:55:00',1.9),('9303','2013-01-25','10:00:00',1.9),('9303','2013-01-25','10:05:00',1.92),('9303','2013-01-25','10:10:00',1.87),('9303','2013-01-25','10:15:00',1.86),('9303','2013-01-25','10:20:00',1.86),('9303','2013-01-25','10:25:00',1.96),('9303','2013-01-25','10:30:00',1.9),('9303','2013-01-25','10:35:00',1.5),('9303','2013-01-25','10:40:00',2.12),('9303','2013-01-25','10:45:00',1.8),('9303','2013-01-25','10:50:00',1.51),('9303','2013-01-25','10:55:00',2.29),('9303','2013-01-25','11:00:00',1.18),('9303','2013-01-25','11:05:00',1.98),('9303','2013-01-25','11:10:00',2.07),('9303','2013-01-25','11:15:00',2.3),('9303','2013-01-25','11:20:00',2.29),('9303','2013-01-25','11:25:00',2.27),('9303','2013-01-25','11:30:00',2.31),('9303','2013-01-25','11:35:00',2.37),('9303','2013-01-25','11:40:00',2.35),('9303','2013-01-25','11:45:00',2.4),('9303','2013-01-25','11:50:00',2.43),('9303','2013-01-25','11:55:00',2.41),('9303','2013-01-25','12:00:00',2.39),('9303','2013-01-25','12:05:00',2.36),('9303','2013-01-25','12:10:00',2.46),('9303','2013-01-25','12:15:00',2.5),('9303','2013-01-25','12:20:00',2.52),('9303','2013-01-25','12:25:00',2.58),('9303','2013-01-25','12:30:00',2.59),('9303','2013-01-25','12:35:00',2.21),('9303','2013-01-25','12:40:00',2.32),('9303','2013-01-25','12:45:00',2.49),('9303','2013-01-25','12:50:00',2.51),('9303','2013-01-25','12:55:00',2.42),('9303','2013-01-25','13:00:00',2.39),('9303','2013-01-25','13:05:00',2.31),('9303','2013-01-25','13:10:00',2.29),('9303','2013-01-25','13:15:00',2.3),('9303','2013-01-25','13:20:00',2.2),('9303','2013-01-25','13:25:00',2.26),('9303','2013-01-25','13:30:00',2.24),('9303','2013-01-25','13:35:00',2.24),('9303','2013-01-25','13:40:00',2.15),('9303','2013-01-25','13:45:00',2.11),('9303','2013-01-25','13:50:00',2.06),('9303','2013-01-25','13:55:00',1.99),('9303','2013-01-25','14:00:00',1.92),('9303','2013-01-25','14:05:00',1.87),('9303','2013-01-25','14:10:00',1.74),('9303','2013-01-25','14:15:00',1.68),('9303','2013-01-25','14:20:00',1.61),('9303','2013-01-25','14:25:00',1.63),('9303','2013-01-25','14:30:00',1.55),('9303','2013-01-25','14:35:00',1.49),('9303','2013-01-25','14:40:00',1.48),('9303','2013-01-25','14:45:00',1.4),('9303','2013-01-25','14:50:00',1.41),('9303','2013-01-25','14:55:00',1.39),('9303','2013-01-25','15:00:00',1.3),('9303','2013-01-25','15:05:00',1.23),('9303','2013-01-25','15:10:00',1.2),('9303','2013-01-25','15:15:00',1.14),('9303','2013-01-25','15:20:00',1.09),('9303','2013-01-25','15:25:00',1.08),('9303','2013-01-25','15:30:00',1.05),('9303','2013-01-25','15:35:00',1.07),('9303','2013-01-25','15:40:00',1.03),('9303','2013-01-24','09:45:00',1.17),('9303','2013-01-24','09:50:00',1.48),('9303','2013-01-24','09:55:00',1.77),('9303','2013-01-24','10:00:00',1.77),('9303','2013-01-24','10:05:00',1.74),('9303','2013-01-24','10:10:00',1.94),('9303','2013-01-24','10:15:00',1.92),('9303','2013-01-24','10:20:00',1.94),('9303','2013-01-24','10:25:00',1.95),('9303','2013-01-24','10:30:00',1.94),('9303','2013-01-24','10:35:00',1.99),('9303','2013-01-24','10:40:00',2.01),('9303','2013-01-24','10:45:00',2.06),('9303','2013-01-24','10:50:00',2.11),('9303','2013-01-24','10:55:00',2.02),('9303','2013-01-24','11:00:00',1.2),('9303','2013-01-24','14:00:00',1.05),('9303','2013-01-24','14:05:00',1.08),('9303','2013-01-24','14:10:00',1.03),('9303','2013-01-24','14:15:00',1.17),('9303','2013-01-24','14:20:00',1.5),('9303','2013-01-24','14:25:00',2.43),('9303','2013-01-24','14:30:00',2.32),('9303','2013-01-24','14:35:00',1.73),('9303','2013-01-24','14:40:00',1.17),('9303','2013-01-24','14:45:00',1.62),('9303','2013-01-24','14:50:00',1.68),('9303','2013-01-24','14:55:00',1.68),('9303','2013-01-24','15:00:00',1.26),('9303','2013-01-24','15:20:00',1.06),('9303','2013-01-24','15:25:00',1.04),('9303','2013-01-24','15:30:00',1.07),('9303','2013-01-23','09:55:00',1.16),('9303','2013-01-23','10:30:00',1.89),('9303','2013-01-23','10:35:00',2.16),('9303','2013-01-23','10:40:00',1.3),('9303','2013-01-23','10:45:00',1.44),('9303','2013-01-23','10:50:00',1.78),('9303','2013-01-23','10:55:00',1.48),('9303','2013-01-22','09:00:00',1.08),('9303','2013-01-22','09:30:00',1.28),('9303','2013-01-22','09:35:00',1.5),('9303','2013-01-22','09:40:00',1.27),('9303','2013-01-22','09:45:00',2.09),('9303','2013-01-22','09:50:00',1.27),('9303','2013-01-22','09:55:00',1.45),('9303','2013-01-22','10:00:00',1),('9303','2013-01-22','10:05:00',1.72),('9303','2013-01-22','10:10:00',1.94),('9303','2013-01-22','10:15:00',1.77),('9303','2013-01-22','10:20:00',1.75),('9303','2013-01-22','10:25:00',1.83),('9303','2013-01-22','10:30:00',1.91),('9303','2013-01-22','10:35:00',2.17),('9303','2013-01-22','10:40:00',2.52),('9303','2013-01-22','10:45:00',1.97),('9303','2013-01-22','10:50:00',1.73),('9303','2013-01-22','10:55:00',1.12),('9303','2013-01-22','11:15:00',1.49),('9303','2013-01-22','11:20:00',1.44),('9303','2013-01-22','11:45:00',1.15),('9303','2013-01-22','11:50:00',1.78),('9303','2013-01-22','12:10:00',2.11),('9303','2013-01-22','12:15:00',2.1),('9303','2013-01-22','12:20:00',1.42),('9303','2013-01-22','12:25:00',2.33),('9303','2013-01-22','12:40:00',2.86),('9303','2013-01-22','13:00:00',2.32),('9303','2013-01-22','13:05:00',2.28),('9303','2013-01-22','13:10:00',1.64),('9303','2013-01-22','13:15:00',1.09),('9303','2013-01-22','13:20:00',1.88),('9303','2013-01-22','13:50:00',1.14),('9303','2013-01-22','14:10:00',1.07),('9303','2013-01-22','14:15:00',1.32),('9303','2013-01-22','14:25:00',1.64),('9303','2013-01-22','14:35:00',1.03),('9303','2013-01-22','14:40:00',1.05),('9303','2013-01-22','14:45:00',1.38),('9303','2014-03-20','07:40:00',1.03),('9303','2014-03-20','07:45:00',1.15),('9303','2014-03-20','07:50:00',1.22),('9303','2014-03-20','07:55:00',1.32),('9303','2014-03-20','08:00:00',1.41),('9303','2014-03-20','08:05:00',1.5),('9303','2014-03-20','08:10:00',1.58),('9303','2014-03-20','08:15:00',1.61),('9303','2014-03-20','08:20:00',1.68),('9303','2014-03-20','08:25:00',1.75),('9303','2014-03-20','08:30:00',1.85),('9303','2014-03-20','08:35:00',1.96),('9303','2014-03-20','08:40:00',2.09),('9303','2014-03-20','08:45:00',2.2),('9303','2014-03-20','08:50:00',2.25),('9303','2014-03-20','08:55:00',2.3),('9303','2014-03-20','09:00:00',2.34),('9303','2014-03-20','09:05:00',2.45),('9303','2014-03-20','09:10:00',2.53),('9303','2014-03-20','09:15:00',2.55),('9303','2014-03-20','09:20:00',2.65),('9303','2014-03-20','09:25:00',2.69),('9303','2014-03-20','09:30:00',2.75),('9303','2014-03-20','09:35:00',2.82),('9303','2014-03-20','09:40:00',2.87),('9303','2014-03-20','09:45:00',2.89),('9303','2014-03-20','09:50:00',2.88),('9303','2014-03-20','09:55:00',2.96),('9303','2014-03-20','10:00:00',3.07),('9303','2014-03-20','10:05:00',3.18),('9303','2014-03-20','10:10:00',3.22),('9303','2014-03-20','10:15:00',3.18),('9303','2014-03-20','10:20:00',3.21),('9303','2014-03-20','10:25:00',3.23),('9303','2014-03-20','10:30:00',3.3),('9303','2014-03-20','10:35:00',3.22),('9303','2014-03-20','10:40:00',3.18),('9303','2014-03-20','10:45:00',3.18),('9303','2014-03-20','10:50:00',3.38),('9303','2014-03-20','10:55:00',3.54),('9303','2014-03-20','11:00:00',3.59),('9303','2014-03-20','11:05:00',3.59),('9303','2014-03-20','11:10:00',3.54),('9303','2014-03-20','11:15:00',3.37),('9303','2014-03-20','11:20:00',3.49),('9303','2014-03-20','11:25:00',3.57),('9303','2014-03-20','11:30:00',3.65),('9303','2014-03-20','11:35:00',3.77),('9303','2014-03-20','11:40:00',3.7),('9303','2014-03-20','11:45:00',3.72),('9303','2014-03-20','11:50:00',3.62),('9303','2014-03-20','11:55:00',3.61),('9303','2014-03-20','12:00:00',3.24),('9303','2014-03-20','12:05:00',3.46),('9303','2014-03-20','12:10:00',3.73),('9303','2014-03-20','12:15:00',3.81),('9303','2014-03-20','12:20:00',3.7),('9303','2014-03-20','12:25:00',3.49),('9303','2014-03-20','12:30:00',3.59),('9303','2014-03-20','12:35:00',3.65),('9303','2014-03-20','12:40:00',3.63),('9303','2014-03-20','12:45:00',3.71),('9303','2014-03-20','12:50:00',3.71),('9303','2014-03-20','12:55:00',3.67),('9303','2014-03-20','13:00:00',3.68),('9303','2014-03-20','13:05:00',3.66),('9303','2014-03-20','13:10:00',3.55),('9303','2014-03-20','13:15:00',3.56),('9303','2014-03-20','13:20:00',3.57),('9303','2014-03-20','13:25:00',3.44),('9303','2014-03-20','13:30:00',3.48),('9303','2014-03-20','13:35:00',3.41),('9303','2014-03-20','13:40:00',3.22),('9303','2014-03-20','13:45:00',3.07),('9303','2014-03-20','13:50:00',2.95),('9303','2014-03-20','13:55:00',2.82),('9303','2014-03-20','14:00:00',2.81),('9303','2014-03-20','14:05:00',3.01),('9303','2014-03-20','14:10:00',2.96),('9303','2014-03-20','14:15:00',2.85),('9303','2014-03-20','14:20:00',2.83),('9303','2014-03-20','14:25:00',2.85),('9303','2014-03-20','14:30:00',2.46),('9303','2014-03-20','14:35:00',2.2),('9303','2014-03-20','14:40:00',2.45),('9303','2014-03-20','14:45:00',2.44),('9303','2014-03-20','14:50:00',2.33),('9303','2014-03-20','14:55:00',2.26),('9303','2014-03-20','15:00:00',2.06),('9303','2014-03-20','15:05:00',2.01),('9303','2014-03-20','15:10:00',2.06),('9303','2014-03-20','15:15:00',1.92),('9303','2014-03-20','15:20:00',2.03),('9303','2014-03-20','15:25:00',1.87),('9303','2014-03-20','15:30:00',1.82),('9303','2014-03-20','15:35:00',1.7),('9303','2014-03-20','15:40:00',1.52),('9303','2014-03-20','15:45:00',1.4),('9303','2014-03-20','15:50:00',1.29),('9303','2014-03-20','15:55:00',1.2),('9303','2014-03-20','16:00:00',1.03),('9303','2013-01-21','11:15:00',1.07),('9303','2013-01-21','11:50:00',1.07),('9303','2013-01-21','11:55:00',2.41),('9303','2013-01-21','12:00:00',2.01),('9303','2013-01-21','12:05:00',2.19),('9303','2013-01-21','12:10:00',2.42),('9303','2013-01-21','12:15:00',1.86),('9303','2013-01-21','12:25:00',1.21),('9303','2013-01-21','12:40:00',1.12),('9303','2013-01-21','13:05:00',1.78),('9303','2013-01-21','13:10:00',1.41),('9303','2013-01-21','13:30:00',2.11),('9303','2013-01-21','13:35:00',2.46),('9303','2013-01-21','13:40:00',1.92),('9303','2013-01-21','13:50:00',1.22),('9303','2013-01-21','13:55:00',1.85),('9303','2013-01-21','14:00:00',2.17),('9303','2013-01-21','14:05:00',2.25),('9303','2013-01-21','14:10:00',1.89),('9303','2013-01-21','14:15:00',1.53),('9303','2013-01-21','14:20:00',1.85),('9303','2013-01-21','14:25:00',2.18),('9303','2013-01-21','14:30:00',1.1),('9303','2013-01-20','11:00:00',1.05),('9303','2013-01-20','11:05:00',1.07),('9303','2013-01-20','11:10:00',1.07),('9303','2013-01-20','11:15:00',1.49),('9303','2013-01-20','11:20:00',1.22),('9303','2013-01-20','11:25:00',1.5),('9303','2013-01-20','11:30:00',1.98),('9303','2013-01-20','11:35:00',1.6),('9303','2013-01-19','09:15:00',1.01),('9303','2013-01-19','09:20:00',1.06),('9303','2013-01-19','09:55:00',1.41),('9303','2013-01-19','10:00:00',1.25),('9303','2013-01-19','10:45:00',1.15),('9303','2013-01-19','10:50:00',1.24),('9303','2013-01-19','11:20:00',1.02),('9303','2013-01-19','11:25:00',1.07),('9303','2013-01-18','10:15:00',1.77),('9303','2013-01-18','10:20:00',1.59),('9303','2013-01-18','10:25:00',1.28),('9303','2013-01-18','10:30:00',1.16),('9303','2013-01-18','11:35:00',1.08),('9303','2013-01-18','11:40:00',1.04),('9303','2013-01-18','12:35:00',1.16),('9303','2013-01-18','12:40:00',1.28),('9303','2013-01-18','12:45:00',1.4),('9303','2013-01-18','12:50:00',1.92),('9303','2013-01-18','12:55:00',1.91),('9303','2013-01-18','13:00:00',2.13),('9303','2013-01-18','13:05:00',1.93),('9303','2013-01-18','13:10:00',1.84),('9303','2013-01-18','13:15:00',2.13),('9303','2013-01-18','13:20:00',1.7),('9303','2013-01-18','13:25:00',1.43),('9303','2013-01-18','13:30:00',1.38),('9303','2013-01-18','13:35:00',1.46),('9303','2013-01-18','13:40:00',1.53),('9303','2013-01-18','13:45:00',2.18),('9303','2013-01-18','13:50:00',2.5),('9303','2013-01-18','13:55:00',2.38),('9303','2013-01-18','14:00:00',1.68),('9303','2013-01-18','14:05:00',1.78),('9303','2013-01-18','14:10:00',1.93),('9303','2013-01-18','14:15:00',1.65),('9303','2013-01-18','14:20:00',1.41),('9303','2013-01-18','14:25:00',1.33),('9303','2013-01-18','14:30:00',1.02),('9303','2013-01-17','09:50:00',1.18),('9303','2013-01-17','09:55:00',1.06),('9303','2013-01-17','10:10:00',1.01),('9303','2013-01-17','10:15:00',1.19),('9303','2013-01-17','10:20:00',1.14),('9303','2013-01-17','10:25:00',1.34),('9303','2013-01-17','10:30:00',1.4),('9303','2013-01-17','10:35:00',1.33),('9303','2013-01-17','10:40:00',1.33),('9303','2013-01-17','10:45:00',1.39),('9303','2013-01-17','10:50:00',1.3),('9303','2013-01-17','10:55:00',1.47),('9303','2013-01-17','11:00:00',1.37),('9303','2013-01-17','11:05:00',1.37),('9303','2013-01-17','11:10:00',1.52),('9303','2013-01-17','11:15:00',1.5),('9303','2013-01-17','11:20:00',1.45),('9303','2013-01-17','11:25:00',1.26),('9303','2013-01-17','11:30:00',1.14),('9303','2013-01-17','11:35:00',1.22),('9303','2013-01-17','11:40:00',1.31),('9303','2013-01-17','11:45:00',1.25),('9303','2013-01-17','11:50:00',1.31),('9303','2013-01-17','11:55:00',1.41),('9303','2013-01-17','12:00:00',1.55),('9303','2013-01-17','12:05:00',1.51),('9303','2013-01-17','12:10:00',1.47),('9303','2013-01-17','12:15:00',1.67),('9303','2013-01-17','12:20:00',1.37),('9303','2013-01-17','12:25:00',1.48),('9303','2013-01-17','12:30:00',1.25),('9303','2013-01-17','12:35:00',1.5),('9303','2013-01-17','12:40:00',1.65),('9303','2013-01-17','12:45:00',1.29),('9303','2013-01-17','13:00:00',1.4),('9303','2013-01-17','13:05:00',1.36),('9303','2013-01-17','13:15:00',1.29),('9303','2013-01-17','13:20:00',1.32),('9303','2013-01-17','13:25:00',1.17),('9303','2013-01-17','13:30:00',1.1),('9303','2013-01-17','13:35:00',1.41),('9303','2013-01-17','13:40:00',1.69),('9303','2013-01-17','13:45:00',1.85),('9303','2013-01-17','13:50:00',1.65),('9303','2013-01-17','14:00:00',1.17),('9303','2013-01-17','14:30:00',1.1),('9303','2013-01-17','14:35:00',1.47),('9303','2013-01-16','09:30:00',1.06),('9303','2013-01-16','09:35:00',1.18),('9303','2013-01-16','09:40:00',1.26),('9303','2013-01-16','10:35:00',1.39),('9303','2013-01-16','10:40:00',1.55),('9303','2013-01-16','10:45:00',1.47),('9303','2013-01-16','10:55:00',1.68),('9303','2013-01-16','11:25:00',1.11),('9303','2013-01-16','12:00:00',1.3),('9303','2013-01-16','12:05:00',1.21),('9303','2013-01-16','12:10:00',1.47),('9303','2013-01-16','12:15:00',2.83),('9303','2013-01-16','12:20:00',2.67),('9303','2013-01-16','12:25:00',1.1),('9303','2013-01-16','13:05:00',1.45),('9303','2013-01-16','13:10:00',2.94),('9303','2013-01-16','13:15:00',3.13),('9303','2013-01-16','13:20:00',2.41),('9303','2013-01-16','13:25:00',1.59),('9303','2013-01-16','13:55:00',1.93),('9303','2013-01-16','14:00:00',1.6),('9303','2013-01-16','14:05:00',1.06),('9303','2013-01-15','10:00:00',1.06),('9303','2013-01-15','10:50:00',1.22),('9303','2013-01-15','10:55:00',1.34),('9303','2013-01-15','11:00:00',1.31),('9303','2013-01-15','11:05:00',1.35),('9303','2013-01-15','11:10:00',1.39),('9303','2013-01-15','11:15:00',1.3),('9303','2013-01-15','11:20:00',1.32),('9303','2013-01-15','11:25:00',1.33),('9303','2013-01-15','11:30:00',1.31),('9303','2013-01-15','11:35:00',1.25),('9303','2013-01-15','11:40:00',1.09),('9303','2013-01-15','11:55:00',1.03),('9303','2013-01-15','12:20:00',1.15),('9303','2013-01-15','12:25:00',1.14),('9303','2013-01-15','12:30:00',1.08),('9303','2013-01-15','12:35:00',1.1),('9303','2013-01-15','12:40:00',1.21),('9303','2013-01-15','12:45:00',1.25),('9303','2013-01-15','12:50:00',1.29),('9303','2013-01-15','12:55:00',1.08),('9303','2013-01-15','13:30:00',1.02),('9303','2013-01-15','13:35:00',1.04),('9303','2013-01-15','13:40:00',1.17),('9303','2013-01-15','13:45:00',1.09),('9303','2013-01-15','13:50:00',1.06),('9303','2013-01-15','13:55:00',1.18),('9303','2013-01-15','14:00:00',1.6),('9303','2013-01-15','14:05:00',1.55),('9303','2013-01-15','14:10:00',1.56),('9303','2013-01-15','14:15:00',2.15),('9303','2013-01-15','14:20:00',2.31),('9303','2013-01-15','14:25:00',1.21),('9303','2013-01-15','14:30:00',1.52),('9303','2013-01-15','14:35:00',1.75),('9303','2013-01-15','14:40:00',1.03),('9303','2013-01-15','14:45:00',1.46),('9303','2013-01-15','14:50:00',1.43),('9303','2013-01-15','14:55:00',1.51),('9303','2013-01-15','15:00:00',1.46),('9303','2013-01-15','15:05:00',1.33),('9303','2013-01-15','15:10:00',1.14),('9303','2013-01-15','15:15:00',1.11),('9303','2013-01-14','12:50:00',1.04),('9303','2013-01-14','12:55:00',1.01),('9303','2013-01-14','13:00:00',1.08),('9303','2013-01-14','13:05:00',1.08),('9303','2013-01-13','09:15:00',1.02),('9303','2013-01-13','09:20:00',1.18),('9303','2013-01-13','09:25:00',1.14),('9303','2013-01-13','09:30:00',1.26),('9303','2013-01-13','09:35:00',1.35),('9303','2013-01-13','09:40:00',1.01),('9303','2013-01-13','09:50:00',1.19),('9303','2013-01-13','09:55:00',1.37),('9303','2013-01-13','10:00:00',1.41),('9303','2013-01-13','10:05:00',1.53),('9303','2013-01-13','10:10:00',1.16),('9303','2013-01-13','10:20:00',1.2),('9303','2013-01-13','10:25:00',1.17),('9303','2013-01-13','10:30:00',1.56),('9303','2013-01-12','09:40:00',1.11),('9303','2013-01-12','09:45:00',1.21),('9303','2013-01-12','09:50:00',1.34),('9303','2013-01-12','09:55:00',1.41),('9303','2013-01-12','10:00:00',1.43),('9303','2013-01-12','10:05:00',1.45),('9303','2013-01-12','10:10:00',1.49),('9303','2013-01-12','10:15:00',1.58),('9303','2013-01-12','10:20:00',1.55),('9303','2013-01-12','10:25:00',1.6),('9303','2013-01-12','10:30:00',1.64),('9303','2013-01-12','10:35:00',1.65),('9303','2013-01-12','10:40:00',1.66),('9303','2013-01-12','10:45:00',1.72),('9303','2013-01-12','10:50:00',1.78),('9303','2013-01-12','10:55:00',1.83),('9303','2013-01-12','11:00:00',1.84),('9303','2013-01-12','11:05:00',1.84),('9303','2013-01-12','11:10:00',1.91),('9303','2013-01-12','11:15:00',1.88),('9303','2013-01-12','11:20:00',1.93),('9303','2013-01-12','11:25:00',1.93),('9303','2013-01-12','11:30:00',2),('9303','2013-01-12','11:35:00',2.01),('9303','2013-01-12','11:40:00',1.99),('9303','2013-01-12','11:45:00',2.02),('9303','2013-01-12','11:50:00',2.03),('9303','2013-01-12','11:55:00',2.05),('9303','2013-01-12','12:00:00',2.04),('9303','2013-01-12','12:05:00',2.03),('9303','2013-01-12','12:10:00',2.01),('9303','2013-01-12','12:15:00',2.06),('9303','2013-01-12','12:20:00',2.07),('9303','2013-01-12','12:25:00',2.04),('9303','2013-01-12','12:30:00',2.06),('9303','2013-01-12','12:35:00',2.12),('9303','2013-01-12','12:40:00',1.61),('9303','2013-01-12','12:50:00',2.14),('9303','2013-01-12','12:55:00',1.76),('9303','2013-01-12','13:00:00',1.29),('9303','2013-01-12','13:05:00',1.92),('9303','2013-01-12','13:10:00',1.62),('9303','2013-01-12','13:15:00',1.2),('9303','2013-01-12','13:25:00',1.49),('9303','2013-01-12','13:30:00',1.83),('9303','2013-01-12','13:35:00',1.58),('9303','2013-01-12','13:50:00',1.14),('9303','2013-01-12','13:55:00',1.96),('9303','2013-01-12','14:00:00',1.41),('9303','2013-01-12','14:05:00',1.23),('9303','2013-01-12','14:10:00',1.41),('9303','2013-01-12','14:15:00',1.58),('9303','2013-01-12','14:20:00',1.5),('9303','2013-01-12','14:25:00',1.47),('9303','2013-01-12','14:30:00',1.42),('9303','2013-01-12','14:35:00',1.37),('9303','2013-01-12','14:40:00',1.34),('9303','2013-01-12','14:45:00',1.28),('9303','2013-01-12','14:50:00',1.23),('9303','2013-01-12','14:55:00',1.18),('9303','2013-01-12','15:00:00',1.11),('9303','2013-01-12','15:05:00',1.06),('9303','2014-03-19','09:05:00',1.06),('9303','2014-03-19','09:10:00',1.24),('9303','2014-03-19','09:15:00',1.45),('9303','2014-03-19','09:20:00',1.59),('9303','2014-03-19','09:25:00',1.79),('9303','2014-03-19','09:30:00',3.06),('9303','2014-03-19','09:35:00',2.78),('9303','2014-03-19','09:40:00',3.11),('9303','2014-03-19','09:45:00',3.21),('9303','2014-03-19','09:50:00',2.41),('9303','2014-03-19','09:55:00',2.62),('9303','2014-03-19','10:00:00',1.37),('9303','2014-03-19','10:05:00',1.07),('9303','2014-03-19','10:30:00',1.09),('9303','2014-03-19','10:35:00',1.81),('9303','2014-03-19','10:40:00',2.85),('9303','2014-03-19','10:45:00',1.76),('9303','2014-03-19','10:50:00',1.85),('9303','2014-03-19','10:55:00',1.66),('9303','2014-03-19','11:00:00',1.67),('9303','2014-03-19','11:05:00',3.08),('9303','2014-03-19','11:10:00',1.7),('9303','2014-03-19','11:15:00',1.52),('9303','2014-03-19','11:20:00',1.59),('9303','2014-03-19','11:25:00',1.64),('9303','2014-03-19','11:30:00',1.85),('9303','2014-03-19','11:35:00',1.88),('9303','2014-03-19','11:40:00',1.59),('9303','2014-03-19','11:45:00',1.53),('9303','2014-03-19','11:50:00',1.56),('9303','2014-03-19','11:55:00',1.71),('9303','2014-03-19','12:00:00',4.08),('9303','2014-03-19','12:05:00',4.21),('9303','2014-03-19','12:10:00',4),('9303','2014-03-19','12:15:00',4.13),('9303','2014-03-19','12:20:00',4.07),('9303','2014-03-19','12:25:00',2.34),('9303','2014-03-19','12:30:00',1.85),('9303','2014-03-19','12:35:00',2.61),('9303','2014-03-19','12:40:00',4.11),('9303','2014-03-19','12:45:00',3.92),('9303','2014-03-19','12:50:00',1.6),('9303','2014-03-19','12:55:00',2.28),('9303','2014-03-19','13:00:00',3.92),('9303','2014-03-19','13:05:00',3.66),('9303','2014-03-19','13:10:00',3.7),('9303','2014-03-19','13:15:00',3.67),('9303','2014-03-19','13:20:00',3.34),('9303','2014-03-19','13:25:00',3.13),('9303','2014-03-19','13:30:00',3.5),('9303','2014-03-19','13:35:00',3.53),('9303','2014-03-19','13:40:00',3.56),('9303','2014-03-19','13:45:00',3.47),('9303','2014-03-19','13:50:00',3.42),('9303','2014-03-19','13:55:00',3.37),('9303','2014-03-19','14:00:00',3.38),('9303','2014-03-19','14:05:00',3.34),('9303','2014-03-19','14:10:00',3.22),('9303','2014-03-19','14:15:00',3.17),('9303','2014-03-19','14:20:00',3.1),('9303','2014-03-19','14:25:00',3.07),('9303','2014-03-19','14:30:00',2.99),('9303','2014-03-19','14:35:00',3.04),('9303','2014-03-19','14:40:00',2.96),('9303','2014-03-19','14:45:00',2.9),('9303','2014-03-19','14:50:00',2.86),('9303','2014-03-19','14:55:00',2.78),('9303','2014-03-19','15:00:00',2.71),('9303','2014-03-19','15:05:00',2.62),('9303','2014-03-19','15:10:00',2.57),('9303','2014-03-19','15:15:00',2.57),('9303','2014-03-19','15:20:00',2.46),('9303','2014-03-19','15:25:00',2.41),('9303','2014-03-19','15:30:00',2.35),('9303','2014-03-19','15:35:00',2.17),('9303','2014-03-19','15:40:00',2.11),('9303','2014-03-19','15:45:00',2.01),('9303','2014-03-19','15:50:00',1.91),('9303','2014-03-19','15:55:00',1.84),('9303','2014-03-19','16:00:00',1.75),('9303','2014-03-19','16:05:00',1.68),('9303','2014-03-19','16:10:00',1.6),('9303','2014-03-19','16:15:00',1.5),('9303','2014-03-19','16:20:00',1.39),('9303','2014-03-19','16:25:00',1.28),('9303','2014-03-19','16:30:00',1.21),('9303','2014-03-19','16:35:00',1.03),('9303','2013-01-11','10:05:00',1.3),('9303','2013-01-11','10:10:00',1.13),('9303','2013-01-11','10:15:00',1.48),('9303','2013-01-11','10:20:00',1.12),('9303','2013-01-11','10:25:00',1.56),('9303','2013-01-11','10:30:00',1.54),('9303','2013-01-11','10:35:00',1.61),('9303','2013-01-11','10:40:00',1.62),('9303','2013-01-11','10:45:00',1.66),('9303','2013-01-11','10:50:00',1.68),('9303','2013-01-11','10:55:00',1.74),('9303','2013-01-11','11:00:00',1.74),('9303','2013-01-11','11:05:00',1.79),('9303','2013-01-11','11:10:00',1.78),('9303','2013-01-11','11:15:00',1.76),('9303','2013-01-11','11:20:00',1.78),('9303','2013-01-11','11:25:00',1.34),('9303','2013-01-11','11:30:00',1.01),('9303','2013-01-11','11:35:00',1.3),('9303','2013-01-11','11:40:00',1.25),('9303','2013-01-11','11:45:00',1.33),('9303','2013-01-11','11:50:00',1.32),('9303','2013-01-11','11:55:00',1.13),('9303','2013-01-11','12:55:00',1.28),('9303','2013-01-11','13:00:00',1.2),('9303','2013-01-11','13:10:00',1.39),('9303','2013-01-11','13:15:00',1),('9303','2013-01-11','13:35:00',1.79),('9303','2013-01-11','13:40:00',1.38),('9303','2013-01-11','13:45:00',1.71),('9303','2013-01-11','14:20:00',1.01),('9303','2013-01-11','14:25:00',1.04),('9303','2013-01-11','14:45:00',1.16),('9303','2013-01-11','14:50:00',1.47),('9303','2013-01-11','14:55:00',1.23),('9303','2013-01-11','15:00:00',1.27),('9303','2013-01-11','15:05:00',1.18),('9303','2013-01-10','11:55:00',1.07),('9303','2013-01-10','12:00:00',1.13),('9303','2013-01-10','12:05:00',1.1),('9303','2013-01-09','10:50:00',1.09),('9303','2013-01-09','10:55:00',1.2),('9303','2013-01-09','11:10:00',1.16),('9303','2013-01-09','11:15:00',1.42),('9303','2013-01-09','11:20:00',1.23),('9303','2013-01-09','11:25:00',1.12),('9303','2013-01-09','11:30:00',1.06),('9303','2013-01-09','11:35:00',1.17),('9303','2013-01-09','11:40:00',1.1),('9303','2013-01-09','11:45:00',1.04),('9303','2013-01-09','11:50:00',1.09),('9303','2013-01-09','11:55:00',1.35),('9303','2013-01-09','12:00:00',1),('9303','2013-01-09','12:05:00',1.07),('9303','2013-01-09','12:10:00',1.05),('9303','2013-01-09','12:15:00',1.03),('9303','2013-01-09','12:20:00',1.06),('9303','2013-01-09','12:55:00',1.03),('9303','2013-01-09','13:00:00',1.11),('9303','2013-01-09','13:05:00',1.21),('9303','2013-01-09','13:10:00',1.38),('9303','2013-01-09','13:15:00',1.19),('9303','2013-01-09','13:20:00',1.01),('9303','2013-01-08','09:45:00',1.37),('9303','2013-01-08','09:50:00',1.51),('9303','2013-01-08','09:55:00',1.51),('9303','2013-01-08','10:00:00',1.38),('9303','2013-01-08','10:05:00',1.35),('9303','2013-01-08','10:10:00',1.41),('9303','2013-01-08','10:15:00',1.48),('9303','2013-01-08','10:20:00',1.33),('9303','2013-01-08','10:25:00',1.48),('9303','2013-01-08','10:30:00',1.49),('9303','2013-01-08','10:35:00',1.62),('9303','2013-01-08','10:40:00',1.72),('9303','2013-01-08','10:45:00',1.72),('9303','2013-01-08','10:50:00',1.73),('9303','2013-01-08','10:55:00',1.77),('9303','2013-01-08','11:00:00',1.73),('9303','2013-01-08','11:05:00',1.83),('9303','2013-01-08','11:10:00',1.87),('9303','2013-01-08','11:15:00',1.85),('9303','2013-01-08','11:20:00',1.9),('9303','2013-01-08','11:25:00',1.93),('9303','2013-01-08','11:30:00',1.99),('9303','2013-01-08','11:35:00',1.98),('9303','2013-01-08','11:40:00',1.98),('9303','2013-01-08','11:45:00',2.43),('9303','2013-01-08','11:50:00',1.82),('9303','2013-01-08','11:55:00',1.52),('9303','2013-01-08','12:00:00',1.42),('9303','2013-01-08','12:05:00',1.37),('9303','2013-01-08','12:10:00',1.46),('9303','2013-01-08','12:15:00',1.33),('9303','2013-01-08','12:20:00',1.19),('9303','2013-01-08','12:25:00',1.16),('9303','2013-01-08','12:30:00',1.11),('9303','2013-01-08','12:35:00',1.07),('9303','2013-01-08','12:40:00',1.3),('9303','2013-01-08','12:45:00',1.58),('9303','2013-01-08','12:50:00',1.97),('9303','2013-01-08','12:55:00',1.2),('9303','2013-01-08','13:45:00',1.32),('9303','2013-01-08','13:50:00',1.23),('9303','2013-01-08','13:55:00',1.24),('9303','2013-01-07','09:45:00',1.08),('9303','2013-01-07','09:50:00',1.19),('9303','2013-01-07','09:55:00',1.23),('9303','2013-01-07','10:00:00',1.26),('9303','2013-01-07','10:05:00',1.47),('9303','2013-01-07','10:10:00',1.57),('9303','2013-01-07','10:15:00',1.61),('9303','2013-01-07','10:20:00',1.56),('9303','2013-01-07','10:25:00',1.66),('9303','2013-01-07','10:30:00',1.66),('9303','2013-01-07','10:35:00',1.65),('9303','2013-01-07','10:40:00',1.68),('9303','2013-01-07','10:45:00',1.73),('9303','2013-01-07','10:50:00',1.73),('9303','2013-01-07','10:55:00',1.75),('9303','2013-01-07','11:00:00',1.77),('9303','2013-01-07','11:05:00',1.79),('9303','2013-01-07','11:10:00',1.83),('9303','2013-01-07','11:15:00',1.84),('9303','2013-01-07','11:20:00',1.88),('9303','2013-01-07','11:25:00',1.9),('9303','2013-01-07','11:30:00',1.93),('9303','2013-01-07','11:35:00',1.94),('9303','2013-01-07','11:40:00',1.95),('9303','2013-01-07','11:45:00',1.96),('9303','2013-01-07','11:50:00',1.99),('9303','2013-01-07','11:55:00',1.99),('9303','2013-01-07','12:00:00',1.99),('9303','2013-01-07','12:05:00',2),('9303','2013-01-07','12:10:00',2),('9303','2013-01-07','12:15:00',2.04),('9303','2013-01-07','12:20:00',2.07),('9303','2013-01-07','12:25:00',2.09),('9303','2013-01-07','12:30:00',2.08),('9303','2013-01-07','12:35:00',2.12),('9303','2013-01-07','12:40:00',2.14),('9303','2013-01-07','12:45:00',2.09),('9303','2013-01-07','12:50:00',2.06),('9303','2013-01-07','12:55:00',2.03),('9303','2013-01-07','13:00:00',2.02),('9303','2013-01-07','13:05:00',1.99),('9303','2013-01-07','13:10:00',1.92),('9303','2013-01-07','13:15:00',1.87),('9303','2013-01-07','13:20:00',1.83),('9303','2013-01-07','13:25:00',1.83),('9303','2013-01-07','13:30:00',1.78),('9303','2013-01-07','13:35:00',1.73),('9303','2013-01-07','13:40:00',1.72),('9303','2013-01-07','13:45:00',1.68),('9303','2013-01-07','13:50:00',1.64),('9303','2013-01-07','13:55:00',1.59),('9303','2013-01-07','14:00:00',1.56),('9303','2013-01-07','14:05:00',1.52),('9303','2013-01-07','14:10:00',1.45),('9303','2013-01-07','14:15:00',1.47),('9303','2013-01-07','14:20:00',1.43),('9303','2013-01-07','14:25:00',1.37),('9303','2013-01-07','14:30:00',1.36),('9303','2013-01-07','14:35:00',1.29),('9303','2013-01-07','14:40:00',1.27),('9303','2013-01-07','14:45:00',1.22),('9303','2013-01-07','14:50:00',1.2),('9303','2013-01-07','14:55:00',1.11),('9303','2013-01-07','15:00:00',1.06),('9303','2013-01-06','09:40:00',1.05),('9303','2013-01-06','09:45:00',1.11),('9303','2013-01-06','09:50:00',1.29),('9303','2013-01-06','09:55:00',1.34),('9303','2013-01-06','10:00:00',1.37),('9303','2013-01-06','10:05:00',1.44),('9303','2013-01-06','10:10:00',1.5),('9303','2013-01-06','10:15:00',1.53),('9303','2013-01-06','10:20:00',1.49),('9303','2013-01-06','10:25:00',1.63),('9303','2013-01-06','10:30:00',1.65),('9303','2013-01-06','10:35:00',1.67),('9303','2013-01-06','10:40:00',1.69),('9303','2013-01-06','10:45:00',1.75),('9303','2013-01-06','10:50:00',1.77),('9303','2013-01-06','10:55:00',1.79),('9303','2013-01-06','11:00:00',1.43),('9303','2013-01-06','11:05:00',1.84),('9303','2013-01-06','11:10:00',1.87),('9303','2013-01-06','11:15:00',1.85),('9303','2013-01-06','11:20:00',1.91),('9303','2013-01-06','11:25:00',1.93),('9303','2013-01-06','11:30:00',1.97),('9303','2013-01-06','11:35:00',1.96),('9303','2013-01-06','11:40:00',1.98),('9303','2013-01-06','11:45:00',1.97),('9303','2013-01-06','11:50:00',2),('9303','2013-01-06','11:55:00',2.01),('9303','2013-01-06','12:00:00',2.02),('9303','2013-01-06','12:05:00',2.02),('9303','2013-01-06','12:10:00',2.04),('9303','2013-01-06','12:15:00',2.06),('9303','2013-01-06','12:20:00',2.07),('9303','2013-01-06','12:25:00',2.08),('9303','2013-01-06','12:30:00',2.1),('9303','2013-01-06','12:35:00',2.09),('9303','2013-01-06','12:40:00',2.13),('9303','2013-01-06','12:45:00',2.11),('9303','2013-01-06','12:50:00',2.1),('9303','2013-01-06','12:55:00',2.08),('9303','2013-01-06','13:00:00',2.06),('9303','2013-01-06','13:05:00',2.01),('9303','2013-01-06','13:10:00',1.99),('9303','2013-01-06','13:15:00',1.93),('9303','2013-01-06','13:20:00',1.89),('9303','2013-01-06','13:25:00',1.87),('9303','2013-01-06','13:30:00',1.84),('9303','2013-01-06','13:35:00',1.81),('9303','2013-01-06','13:40:00',1.77),('9303','2013-01-06','13:45:00',1.73),('9303','2013-01-06','13:50:00',1.69),('9303','2013-01-06','13:55:00',1.62),('9303','2013-01-06','14:00:00',1.61),('9303','2013-01-06','14:05:00',1.6),('9303','2013-01-06','14:10:00',1.44),('9303','2013-01-06','14:15:00',1.39),('9303','2013-01-06','14:20:00',1.41),('9303','2013-01-06','14:25:00',1.32),('9303','2013-01-06','14:30:00',1.35),('9303','2013-01-06','14:35:00',1.28),('9303','2013-01-06','14:40:00',1.22),('9303','2013-01-06','14:45:00',1.19),('9303','2013-01-06','14:50:00',1.14),('9303','2013-01-06','14:55:00',1.08),('9303','2013-01-06','15:00:00',1.02),('9303','2013-01-05','10:15:00',1.05),('9303','2013-01-05','10:40:00',1.02),('9303','2013-01-05','10:50:00',1.07),('9303','2013-01-05','10:55:00',1.57),('9303','2013-01-05','11:00:00',1.35),('9303','2013-01-05','11:05:00',1.57),('9303','2013-01-05','11:10:00',1.56),('9303','2013-01-05','11:15:00',1.33),('9303','2013-01-05','11:20:00',1.79),('9303','2013-01-05','11:25:00',1.88),('9303','2013-01-05','11:30:00',1.94),('9303','2013-01-05','11:35:00',1.8),('9303','2013-01-05','11:40:00',1.68),('9303','2013-01-05','11:45:00',1.72),('9303','2013-01-05','11:50:00',1.55),('9303','2013-01-05','11:55:00',1.43),('9303','2013-01-05','12:00:00',1.37),('9303','2013-01-05','12:05:00',1.35),('9303','2013-01-05','12:10:00',1.35),('9303','2013-01-05','12:15:00',1.36),('9303','2013-01-05','12:20:00',1.24),('9303','2013-01-05','12:25:00',1.07),('9303','2013-01-05','12:30:00',1.1),('9303','2013-01-05','12:35:00',1.48),('9303','2013-01-05','12:40:00',1.83),('9303','2013-01-05','12:45:00',2),('9303','2013-01-05','12:50:00',1.3),('9303','2013-01-05','12:55:00',1.12),('9303','2013-01-05','13:00:00',1.18),('9303','2013-01-05','13:05:00',1.09),('9303','2013-01-05','13:10:00',1.05),('9303','2013-01-05','13:30:00',1.48),('9303','2013-01-05','13:35:00',1.33),('9303','2013-01-05','13:40:00',1.01),('9303','2013-01-05','13:55:00',1.06),('9303','2013-01-05','14:05:00',1.4),('9303','2013-01-05','14:10:00',1.28),('9303','2013-01-05','14:30:00',1.03),('9303','2013-01-05','14:35:00',1.02),('9303','2013-01-05','14:40:00',1.08),('9303','2013-01-05','14:45:00',1.11),('9303','2013-01-04','09:55:00',1.22),('9303','2013-01-04','10:00:00',1.47),('9303','2013-01-04','10:05:00',1.58),('9303','2013-01-04','10:10:00',1.39),('9303','2013-01-04','10:15:00',1.58),('9303','2013-01-04','10:20:00',1.25),('9303','2013-01-04','10:25:00',1.58),('9303','2013-01-04','10:30:00',1.64),('9303','2013-01-04','10:35:00',1.69),('9303','2013-01-04','10:40:00',1.76),('9303','2013-01-04','10:45:00',1.89),('9303','2013-01-04','10:50:00',2.01),('9303','2013-01-04','10:55:00',2.05),('9303','2013-01-04','11:00:00',1.84),('9303','2013-01-04','11:05:00',1.15),('9303','2013-01-04','11:35:00',1),('9303','2013-01-04','11:45:00',1.25),('9303','2013-01-04','11:50:00',1.93),('9303','2013-01-04','11:55:00',2.36),('9303','2013-01-04','12:00:00',2.39),('9303','2013-01-04','12:05:00',2.03),('9303','2013-01-04','12:10:00',1.61),('9303','2013-01-04','12:15:00',1.14),('9303','2013-01-04','12:25:00',1.04),('9303','2013-01-04','12:30:00',1.55),('9303','2013-01-04','12:35:00',1.44),('9303','2013-01-04','12:40:00',2.19),('9303','2013-01-04','12:45:00',2.22),('9303','2013-01-04','12:50:00',2.23),('9303','2013-01-04','12:55:00',2.15),('9303','2013-01-04','13:00:00',2.07),('9303','2013-01-04','13:05:00',1.93),('9303','2013-01-04','13:10:00',1.82),('9303','2013-01-04','13:15:00',1.67),('9303','2013-01-04','13:20:00',1.83),('9303','2013-01-04','13:25:00',1.79),('9303','2013-01-04','13:30:00',1.73),('9303','2013-01-04','13:35:00',1.68),('9303','2013-01-04','13:40:00',1.64),('9303','2013-01-04','13:45:00',1.59),('9303','2013-01-04','13:50:00',1.56),('9303','2013-01-04','13:55:00',1.49),('9303','2013-01-04','14:00:00',1.43),('9303','2013-01-04','14:05:00',1.45),('9303','2013-01-04','14:10:00',1.39),('9303','2013-01-04','14:15:00',1.38),('9303','2013-01-04','14:20:00',1.32),('9303','2013-01-04','14:25:00',1.28),('9303','2013-01-04','14:30:00',1.25),('9303','2013-01-04','14:35:00',1.23),('9303','2013-01-04','14:40:00',1.18),('9303','2013-01-04','14:45:00',1.12),('9303','2013-01-04','14:50:00',1.09),('9303','2013-01-04','14:55:00',1.05),('9303','2013-01-03','09:45:00',1.27),('9303','2013-01-03','09:50:00',1.49),('9303','2013-01-03','09:55:00',1.63),('9303','2013-01-03','10:00:00',1.71),('9303','2013-01-03','10:05:00',1.81),('9303','2013-01-03','10:10:00',1.78),('9303','2013-01-03','10:15:00',2.06),('9303','2013-01-03','10:20:00',1.62),('9303','2013-01-03','10:25:00',1.59),('9303','2013-01-03','10:30:00',1.63),('9303','2013-01-03','10:35:00',1.56),('9303','2013-01-03','10:40:00',1.52),('9303','2013-01-03','10:45:00',1.44),('9303','2013-01-03','10:50:00',1.43),('9303','2013-01-03','10:55:00',1.35),('9303','2013-01-03','11:00:00',1.47),('9303','2013-01-03','11:05:00',1.39),('9303','2013-01-03','11:10:00',1.28),('9303','2013-01-03','11:15:00',1.3),('9303','2013-01-03','11:20:00',1.07),('9303','2013-01-03','11:35:00',1.58),('9303','2013-01-03','11:40:00',1.96),('9303','2013-01-03','11:45:00',2.07),('9303','2013-01-03','11:50:00',2.05),('9303','2013-01-03','11:55:00',2.01),('9303','2013-01-03','12:00:00',2.02),('9303','2013-01-03','12:05:00',2.02),('9303','2013-01-03','12:10:00',2.03),('9303','2013-01-03','12:15:00',2.06),('9303','2013-01-03','12:20:00',2.09),('9303','2013-01-03','12:25:00',2.12),('9303','2013-01-03','12:30:00',2.12),('9303','2013-01-03','12:35:00',2.15),('9303','2013-01-03','12:40:00',2.17),('9303','2013-01-03','12:45:00',2.12),('9303','2013-01-03','12:50:00',2.09),('9303','2013-01-03','12:55:00',2.04),('9303','2013-01-03','13:00:00',2.02),('9303','2013-01-03','13:05:00',1.96),('9303','2013-01-03','13:10:00',1.95),('9303','2013-01-03','13:15:00',1.89),('9303','2013-01-03','13:20:00',1.84),('9303','2013-01-03','13:25:00',1.82),('9303','2013-01-03','13:30:00',1.78),('9303','2013-01-03','13:35:00',1.76),('9303','2013-01-03','13:40:00',1.73),('9303','2013-01-03','13:45:00',1.68),('9303','2013-01-03','13:50:00',1.65),('9303','2013-01-03','13:55:00',1.58),('9303','2013-01-03','14:00:00',1.53),('9303','2013-01-03','14:05:00',1.52),('9303','2013-01-03','14:10:00',1.48),('9303','2013-01-03','14:15:00',1.46),('9303','2013-01-03','14:20:00',1.41),('9303','2013-01-03','14:25:00',1.37),('9303','2013-01-03','14:30:00',1.34),('9303','2013-01-03','14:35:00',1.28),('9303','2013-01-03','14:40:00',1.24),('9303','2013-01-03','14:45:00',1.2),('9303','2013-01-03','14:50:00',1.15),('9303','2013-01-03','14:55:00',1.1),('9303','2013-01-03','15:00:00',1.04),('9303','2014-03-18','07:55:00',1.17),('9303','2014-03-18','08:00:00',1.43),('9303','2014-03-18','08:05:00',1.19),('9303','2014-03-18','08:10:00',1.1),('9303','2014-03-18','08:20:00',1.07),('9303','2014-03-18','08:25:00',1.18),('9303','2014-03-18','08:55:00',2.39),('9303','2014-03-18','09:00:00',2.34),('9303','2014-03-18','09:05:00',1.65),('9303','2014-03-18','09:10:00',1.38),('9303','2014-03-18','09:15:00',1.63),('9303','2014-03-18','09:20:00',2.68),('9303','2014-03-18','09:25:00',3.01),('9303','2014-03-18','09:30:00',1.62),('9303','2014-03-18','09:35:00',1.85),('9303','2014-03-18','09:40:00',1.88),('9303','2014-03-18','09:45:00',1.58),('9303','2014-03-18','09:50:00',2.48),('9303','2014-03-18','09:55:00',1.12),('9303','2014-03-18','10:00:00',2.28),('9303','2014-03-18','10:05:00',2.52),('9303','2014-03-18','10:10:00',2.72),('9303','2014-03-18','10:15:00',3.62),('9303','2014-03-18','10:20:00',2.63),('9303','2014-03-18','10:25:00',2.45),('9303','2014-03-18','10:30:00',1.68),('9303','2014-03-18','10:35:00',3.61),('9303','2014-03-18','10:40:00',2.54),('9303','2014-03-18','10:45:00',2.18),('9303','2014-03-18','10:50:00',1.81),('9303','2014-03-18','10:55:00',2.1),('9303','2014-03-18','11:00:00',4.44),('9303','2014-03-18','11:05:00',2.13),('9303','2014-03-18','11:10:00',2.19),('9303','2014-03-18','11:15:00',1.39),('9303','2014-03-18','11:20:00',1.3),('9303','2014-03-18','11:25:00',1.56),('9303','2014-03-18','11:30:00',2.44),('9303','2014-03-18','11:35:00',2.79),('9303','2014-03-18','11:40:00',2.76),('9303','2014-03-18','11:45:00',2.95),('9303','2014-03-18','11:50:00',2.71),('9303','2014-03-18','11:55:00',1.5),('9303','2014-03-18','12:00:00',1.56),('9303','2014-03-18','12:05:00',1.71),('9303','2014-03-18','12:10:00',2.29),('9303','2014-03-18','12:15:00',3.68),('9303','2014-03-18','12:20:00',2.81),('9303','2014-03-18','12:25:00',2.2),('9303','2014-03-18','12:30:00',3.92),('9303','2014-03-18','12:35:00',4.08),('9303','2014-03-18','12:40:00',3.2),('9303','2014-03-18','12:45:00',3.34),('9303','2014-03-18','12:50:00',3.11),('9303','2014-03-18','12:55:00',3.83),('9303','2014-03-18','13:00:00',3.82),('9303','2014-03-18','13:05:00',3.75),('9303','2014-03-18','13:10:00',3.83),('9303','2014-03-18','13:15:00',3.75),('9303','2014-03-18','13:20:00',3.72),('9303','2014-03-18','13:25:00',3.53),('9303','2014-03-18','13:30:00',3.41),('9303','2014-03-18','13:35:00',3.57),('9303','2014-03-18','13:40:00',3.51),('9303','2014-03-18','13:45:00',3.48),('9303','2014-03-18','13:50:00',3.45),('9303','2014-03-18','13:55:00',3.46),('9303','2014-03-18','14:00:00',3.44),('9303','2014-03-18','14:05:00',3.42),('9303','2014-03-18','14:10:00',3.35),('9303','2014-03-18','14:15:00',3.32),('9303','2014-03-18','14:20:00',3.27),('9303','2014-03-18','14:25:00',3.23),('9303','2014-03-18','14:30:00',3.13),('9303','2014-03-18','14:35:00',3.08),('9303','2014-03-18','14:40:00',3.04),('9303','2014-03-18','14:45:00',2.97),('9303','2014-03-18','14:50:00',2.91),('9303','2014-03-18','14:55:00',2.84),('9303','2014-03-18','15:00:00',2.76),('9303','2014-03-18','15:05:00',2.7),('9303','2014-03-18','15:10:00',2.67),('9303','2014-03-18','15:15:00',2.61),('9303','2014-03-18','15:20:00',2.51),('9303','2014-03-18','15:25:00',2.45),('9303','2014-03-18','15:30:00',2.36),('9303','2014-03-18','15:35:00',2.25),('9303','2014-03-18','15:40:00',2.11),('9303','2014-03-18','15:45:00',1.99),('9303','2014-03-18','15:50:00',1.88),('9303','2014-03-18','15:55:00',1.81),('9303','2014-03-18','16:00:00',1.78),('9303','2014-03-18','16:05:00',1.65),('9303','2014-03-18','16:10:00',1.54),('9303','2014-03-18','16:15:00',1.51),('9303','2014-03-18','16:20:00',1.42),('9303','2014-03-18','16:25:00',1.32),('9303','2014-03-18','16:30:00',1.25),('9303','2014-03-18','16:35:00',1.11),('9303','2014-03-18','16:40:00',1.04),('9303','2013-01-01','09:45:00',1.07),('9303','2013-01-01','09:50:00',1.2),('9303','2013-01-01','09:55:00',1.29),('9303','2013-01-01','10:00:00',1.33),('9303','2013-01-01','10:05:00',1.37),('9303','2013-01-01','10:10:00',1.44),('9303','2013-01-01','10:15:00',1.43),('9303','2013-01-01','10:20:00',1.47),('9303','2013-01-01','10:25:00',1.48),('9303','2013-01-01','10:30:00',1.48),('9303','2013-01-01','10:35:00',1.51),('9303','2013-01-01','10:40:00',1.59),('9303','2013-01-01','10:45:00',1.53),('9303','2013-01-01','10:50:00',1.91),('9303','2013-01-01','10:55:00',1.08),('9303','2013-01-01','11:05:00',1.75),('9303','2013-01-01','11:10:00',1.86),('9303','2013-01-01','11:15:00',1.87),('9303','2013-01-01','11:20:00',1.22),('9303','2013-01-01','11:25:00',1.87),('9303','2013-01-01','11:30:00',2.16),('9303','2013-01-01','11:35:00',1.21),('9303','2013-01-01','11:40:00',1.25),('9303','2013-01-01','11:45:00',1.88),('9303','2013-01-01','11:50:00',1.93),('9303','2013-01-01','11:55:00',1.69),('9303','2013-01-01','12:00:00',1.23),('9303','2013-01-01','12:05:00',1.04),('9303','2013-01-01','12:10:00',1.22),('9303','2013-01-01','12:15:00',1.15),('9303','2013-01-01','12:20:00',1.3),('9303','2013-01-01','12:25:00',1.11),('9303','2013-01-01','12:40:00',1.03),('9303','2013-01-01','12:45:00',1.18),('9303','2013-01-01','12:50:00',1.01),('9303','2013-01-01','12:55:00',1.01),('9303','2012-12-31','10:10:00',1.17),('9303','2012-12-31','10:15:00',1.57),('9303','2012-12-31','10:20:00',1.66),('9303','2012-12-31','10:25:00',1.64),('9303','2012-12-31','10:30:00',1.62),('9303','2012-12-31','10:35:00',1.63),('9303','2012-12-31','10:40:00',1.69),('9303','2012-12-31','10:45:00',1.72),('9303','2012-12-31','10:50:00',1.75),('9303','2012-12-31','10:55:00',1.78),('9303','2012-12-31','11:00:00',1.81),('9303','2012-12-31','11:05:00',1.84),('9303','2012-12-31','11:10:00',1.77),('9303','2012-12-31','11:15:00',1.83),('9303','2012-12-31','11:20:00',1.91),('9303','2012-12-31','11:25:00',1.94),('9303','2012-12-31','11:30:00',2),('9303','2012-12-31','11:35:00',1.98),('9303','2012-12-31','11:40:00',2.01),('9303','2012-12-31','11:45:00',2.01),('9303','2012-12-31','11:50:00',2.02),('9303','2012-12-31','11:55:00',2.01),('9303','2012-12-31','12:00:00',2.05),('9303','2012-12-31','12:05:00',2.08),('9303','2012-12-31','12:10:00',2.11),('9303','2012-12-31','12:15:00',2.13),('9303','2012-12-31','12:20:00',2.17),('9303','2012-12-31','12:25:00',2.17),('9303','2012-12-31','12:30:00',2.16),('9303','2012-12-31','12:35:00',2.21),('9303','2012-12-31','12:40:00',2.19),('9303','2012-12-31','12:45:00',2.15),('9303','2012-12-31','12:50:00',2.12),('9303','2012-12-31','12:55:00',2.06),('9303','2012-12-31','13:00:00',2.03),('9303','2012-12-31','13:05:00',2),('9303','2012-12-31','13:10:00',1.97),('9303','2012-12-31','13:15:00',1.91),('9303','2012-12-31','13:20:00',1.89),('9303','2012-12-31','13:25:00',1.87),('9303','2012-12-31','13:30:00',1.83),('9303','2012-12-31','13:35:00',1.78),('9303','2012-12-31','13:40:00',1.76),('9303','2012-12-31','13:45:00',1.69),('9303','2012-12-31','13:50:00',1.65),('9303','2012-12-31','13:55:00',1.58),('9303','2012-12-31','14:00:00',1.56),('9303','2012-12-31','14:05:00',1.56),('9303','2012-12-31','14:10:00',1.48),('9303','2012-12-31','14:15:00',1.45),('9303','2012-12-31','14:20:00',1.39),('9303','2012-12-31','14:25:00',1.37),('9303','2012-12-31','14:30:00',1.34),('9303','2012-12-31','14:35:00',1.28),('9303','2012-12-31','14:40:00',1.25),('9303','2012-12-31','14:45:00',1.2),('9303','2012-12-31','14:50:00',1.16),('9303','2012-12-31','14:55:00',1.09),('9303','2012-12-31','15:00:00',1.01),('9303','2012-12-30','09:45:00',1.05),('9303','2012-12-30','09:50:00',1.2),('9303','2012-12-30','09:55:00',1.26),('9303','2012-12-30','10:00:00',1.35),('9303','2012-12-30','10:05:00',1.44),('9303','2012-12-30','10:10:00',1.51),('9303','2012-12-30','10:15:00',1.46),('9303','2012-12-30','10:20:00',1.54),('9303','2012-12-30','10:25:00',1.54),('9303','2012-12-30','10:30:00',1.54),('9303','2012-12-30','10:35:00',1.57),('9303','2012-12-30','10:40:00',1.6),('9303','2012-12-30','10:45:00',1.7),('9303','2012-12-30','10:50:00',1.75),('9303','2012-12-30','10:55:00',1.77),('9303','2012-12-30','11:00:00',1.81),('9303','2012-12-30','11:05:00',1.85),('9303','2012-12-30','11:10:00',1.82),('9303','2012-12-30','11:15:00',1.87),('9303','2012-12-30','11:20:00',1.91),('9303','2012-12-30','11:25:00',1.92),('9303','2012-12-30','11:30:00',1.97),('9303','2012-12-30','11:35:00',1.94),('9303','2012-12-30','11:40:00',1.98),('9303','2012-12-30','11:45:00',2),('9303','2012-12-30','11:50:00',2),('9303','2012-12-30','11:55:00',1.99),('9303','2012-12-30','12:00:00',2.01),('9303','2012-12-30','12:05:00',1.99),('9303','2012-12-30','12:10:00',2.02),('9303','2012-12-30','12:15:00',2.06),('9303','2012-12-30','12:20:00',2.1),('9303','2012-12-30','12:25:00',2.11),('9303','2012-12-30','12:30:00',2.08),('9303','2012-12-30','12:35:00',2.12),('9303','2012-12-30','12:40:00',2.1),('9303','2012-12-30','12:45:00',2.05),('9303','2012-12-30','12:50:00',2.04),('9303','2012-12-30','12:55:00',2),('9303','2012-12-30','13:00:00',1.99),('9303','2012-12-30','13:05:00',1.96),('9303','2012-12-30','13:10:00',1.95),('9303','2012-12-30','13:15:00',1.92),('9303','2012-12-30','13:20:00',1.87),('9303','2012-12-30','13:25:00',1.85),('9303','2012-12-30','13:30:00',1.81),('9303','2012-12-30','13:35:00',1.79),('9303','2012-12-30','13:40:00',1.75),('9303','2012-12-30','13:45:00',1.69),('9303','2012-12-30','13:50:00',1.64),('9303','2012-12-30','13:55:00',1.62),('9303','2012-12-30','14:00:00',1.6),('9303','2012-12-30','14:05:00',1.58),('9303','2012-12-30','14:10:00',1.51),('9303','2012-12-30','14:15:00',1.48),('9303','2012-12-30','14:20:00',1.41),('9303','2012-12-30','14:25:00',1.39),('9303','2012-12-30','14:30:00',1.33),('9303','2012-12-30','14:35:00',1.29),('9303','2012-12-30','14:40:00',1.25),('9303','2012-12-30','14:45:00',1.2),('9303','2012-12-30','14:50:00',1.14),('9303','2012-12-30','14:55:00',1.08),('9303','2012-12-29','09:45:00',1.06),('9303','2012-12-29','09:50:00',1.21),('9303','2012-12-29','09:55:00',1.29),('9303','2012-12-29','10:00:00',1.37),('9303','2012-12-29','10:05:00',1.47),('9303','2012-12-29','10:10:00',1.51),('9303','2012-12-29','10:15:00',1.48),('9303','2012-12-29','10:20:00',1.57),('9303','2012-12-29','10:25:00',1.57),('9303','2012-12-29','10:30:00',1.58),('9303','2012-12-29','10:35:00',1.57),('9303','2012-12-29','10:40:00',1.62),('9303','2012-12-29','10:45:00',1.72),('9303','2012-12-29','10:50:00',1.77),('9303','2012-12-29','10:55:00',1.82),('9303','2012-12-29','11:00:00',1.84),('9303','2012-12-29','11:05:00',1.89),('9303','2012-12-29','11:10:00',1.87),('9303','2012-12-29','11:15:00',1.93),('9303','2012-12-29','11:20:00',1.95),('9303','2012-12-29','11:25:00',1.99),('9303','2012-12-29','11:30:00',2.02),('9303','2012-12-29','11:35:00',2),('9303','2012-12-29','11:40:00',2.01),('9303','2012-12-29','11:45:00',2.02),('9303','2012-12-29','11:50:00',2.03),('9303','2012-12-29','11:55:00',2.02),('9303','2012-12-29','12:00:00',2.06),('9303','2012-12-29','12:05:00',2.07),('9303','2012-12-29','12:10:00',2.12),('9303','2012-12-29','12:15:00',2.12),('9303','2012-12-29','12:20:00',2.14),('9303','2012-12-29','12:25:00',2.11),('9303','2012-12-29','12:30:00',2.13),('9303','2012-12-29','12:35:00',2.18),('9303','2012-12-29','12:40:00',2.18),('9303','2012-12-29','12:45:00',2.12),('9303','2012-12-29','12:50:00',2.07),('9303','2012-12-29','12:55:00',2.05),('9303','2012-12-29','13:00:00',2.03),('9303','2012-12-29','13:05:00',2),('9303','2012-12-29','13:10:00',1.98),('9303','2012-12-29','13:15:00',1.94),('9303','2012-12-29','13:20:00',1.91),('9303','2012-12-29','13:25:00',1.86),('9303','2012-12-29','13:30:00',1.82),('9303','2012-12-29','13:35:00',1.78),('9303','2012-12-29','13:40:00',1.76),('9303','2012-12-29','13:45:00',1.7),('9303','2012-12-29','13:50:00',1.65),('9303','2012-12-29','13:55:00',1.65),('9303','2012-12-29','14:00:00',1.59),('9303','2012-12-29','14:05:00',1.57),('9303','2012-12-29','14:10:00',1.51),('9303','2012-12-29','14:15:00',1.48),('9303','2012-12-29','14:20:00',1.43),('9303','2012-12-29','14:25:00',1.41),('9303','2012-12-29','14:30:00',1.34),('9303','2012-12-29','14:35:00',1.29),('9303','2012-12-29','14:40:00',1.27),('9303','2012-12-29','14:45:00',1.21),('9303','2012-12-29','14:50:00',1.17),('9303','2012-12-29','14:55:00',1.09),('9303','2012-12-29','15:00:00',1.01),('9303','2012-12-28','09:45:00',1.03),('9303','2012-12-28','09:50:00',1.09),('9303','2012-12-28','09:55:00',1.13),('9303','2012-12-28','10:00:00',1.23),('9303','2012-12-28','10:05:00',1.26),('9303','2012-12-28','10:10:00',1.28),('9303','2012-12-28','10:15:00',1.36),('9303','2012-12-28','10:20:00',1.45),('9303','2012-12-28','10:25:00',1.47),('9303','2012-12-28','10:30:00',1.47),('9303','2012-12-28','10:35:00',1.47),('9303','2012-12-28','10:40:00',1.52),('9303','2012-12-28','10:45:00',1.59),('9303','2012-12-28','10:50:00',1.65),('9303','2012-12-28','10:55:00',1.6),('9303','2012-12-28','11:00:00',1.73),('9303','2012-12-28','11:05:00',1.8),('9303','2012-12-28','11:10:00',1.78),('9303','2012-12-28','11:15:00',1.85),('9303','2012-12-28','11:20:00',1.85),('9303','2012-12-28','11:25:00',1.89),('9303','2012-12-28','11:30:00',1.93),('9303','2012-12-28','11:35:00',1.91),('9303','2012-12-28','11:40:00',1.96),('9303','2012-12-28','11:45:00',1.92),('9303','2012-12-28','11:50:00',1.98),('9303','2012-12-28','11:55:00',1.97),('9303','2012-12-28','12:00:00',1.72),('9303','2012-12-28','12:05:00',1.98),('9303','2012-12-28','12:10:00',2.01),('9303','2012-12-28','12:15:00',2.05),('9303','2012-12-28','12:20:00',2.06),('9303','2012-12-28','12:25:00',2.05),('9303','2012-12-28','12:30:00',2.04),('9303','2012-12-28','12:35:00',2.03),('9303','2012-12-28','12:40:00',1.75),('9303','2012-12-28','12:45:00',2.05),('9303','2012-12-28','12:50:00',2.01),('9303','2012-12-28','12:55:00',1.97),('9303','2012-12-28','13:00:00',1.92),('9303','2012-12-28','13:05:00',1.88),('9303','2012-12-28','13:10:00',1.83),('9303','2012-12-28','13:15:00',1.78),('9303','2012-12-28','13:20:00',1.76),('9303','2012-12-28','13:25:00',1.74),('9303','2012-12-28','13:30:00',1.69),('9303','2012-12-28','13:35:00',1.64),('9303','2012-12-28','13:40:00',1.61),('9303','2012-12-28','13:45:00',1.58),('9303','2012-12-28','13:50:00',1.54),('9303','2012-12-28','13:55:00',1.53),('9303','2012-12-28','14:00:00',1.43),('9303','2012-12-28','14:05:00',1.44),('9303','2012-12-28','14:10:00',1.35),('9303','2012-12-28','14:15:00',1.3),('9303','2012-12-28','14:20:00',1.28),('9303','2012-12-28','14:25:00',1.25),('9303','2012-12-28','14:30:00',1.08),('9303','2012-12-28','14:35:00',1.12),('9303','2012-12-28','14:45:00',1.07),('9303','2012-12-28','14:50:00',1.03),('9303','2012-12-27','09:35:00',1.02),('9303','2012-12-27','09:45:00',1.12),('9303','2012-12-27','09:50:00',1.32),('9303','2012-12-27','10:15:00',1.17),('9303','2012-12-27','10:20:00',1.26),('9303','2012-12-27','10:25:00',1.25),('9303','2012-12-27','10:30:00',1.27),('9303','2012-12-27','10:35:00',1.34),('9303','2012-12-27','10:40:00',1.35),('9303','2012-12-27','10:45:00',1.56),('9303','2012-12-27','10:50:00',1.55),('9303','2012-12-27','10:55:00',1.52),('9303','2012-12-27','11:00:00',1.48),('9303','2012-12-27','11:05:00',1.02),('9303','2012-12-27','11:10:00',1.23),('9303','2012-12-27','11:50:00',1.42),('9303','2012-12-27','11:55:00',1.83),('9303','2012-12-27','12:00:00',1.91),('9303','2012-12-27','12:05:00',2.16),('9303','2012-12-27','12:10:00',2.26),('9303','2012-12-27','12:15:00',1.67),('9303','2012-12-27','12:20:00',1.13),('9303','2012-12-27','12:25:00',1.87),('9303','2012-12-27','12:30:00',2.06),('9303','2012-12-27','12:35:00',2.07),('9303','2012-12-27','12:40:00',2.08),('9303','2012-12-27','12:45:00',1.84),('9303','2012-12-27','12:50:00',1.31),('9303','2012-12-27','12:55:00',2.04),('9303','2012-12-27','13:00:00',1.89),('9303','2012-12-27','13:05:00',1.48),('9303','2012-12-27','13:10:00',1.22),('9303','2012-12-27','13:15:00',1.41),('9303','2012-12-27','13:30:00',1.26),('9303','2012-12-27','14:05:00',1.08),('9303','2012-12-27','14:10:00',1.25),('9303','2012-12-27','14:15:00',1.26),('9303','2012-12-27','14:20:00',1.3),('9303','2012-12-27','14:25:00',1.27),('9303','2012-12-27','14:30:00',1.22),('9303','2012-12-27','14:35:00',1.19),('9303','2012-12-27','14:40:00',1.12),('9303','2012-12-26','09:45:00',1.03),('9303','2012-12-26','09:50:00',1.16),('9303','2012-12-26','09:55:00',1.21),('9303','2012-12-26','10:00:00',1.29),('9303','2012-12-26','10:05:00',1.38),('9303','2012-12-26','10:10:00',1.37),('9303','2012-12-26','10:15:00',1.41),('9303','2012-12-26','10:20:00',1.44),('9303','2012-12-26','10:25:00',1.4),('9303','2012-12-26','10:30:00',1.43),('9303','2012-12-26','10:35:00',1.41),('9303','2012-12-26','10:40:00',1.5),('9303','2012-12-26','10:45:00',1.55),('9303','2012-12-26','10:50:00',1.58),('9303','2012-12-26','10:55:00',1.63),('9303','2012-12-26','11:00:00',1.66),('9303','2012-12-26','11:05:00',1.7),('9303','2012-12-26','11:10:00',1.67),('9303','2012-12-26','11:15:00',1.72),('9303','2012-12-26','11:20:00',1.74),('9303','2012-12-26','11:25:00',1.78),('9303','2012-12-26','11:30:00',1.76),('9303','2012-12-26','11:35:00',1.78),('9303','2012-12-26','11:40:00',1.81),('9303','2012-12-26','11:45:00',1.83),('9303','2012-12-26','11:50:00',1.86),('9303','2012-12-26','11:55:00',1.89),('9303','2012-12-26','12:00:00',1.94),('9303','2012-12-26','12:05:00',1.99),('9303','2012-12-26','12:10:00',1.99),('9303','2012-12-26','12:15:00',2.05),('9303','2012-12-26','12:20:00',2.07),('9303','2012-12-26','12:25:00',2.1),('9303','2012-12-26','12:30:00',2.11),('9303','2012-12-26','12:35:00',2.13),('9303','2012-12-26','12:40:00',2.14),('9303','2012-12-26','12:45:00',2.08),('9303','2012-12-26','12:50:00',1.99),('9303','2012-12-26','12:55:00',1.91),('9303','2012-12-26','13:00:00',2.03),('9303','2012-12-26','13:05:00',1.8),('9303','2012-12-26','13:10:00',2.02),('9303','2012-12-26','13:15:00',1.98),('9303','2012-12-26','13:20:00',2.09),('9303','2012-12-26','13:25:00',2.09),('9303','2012-12-26','13:30:00',2.26),('9303','2012-12-26','13:35:00',2.15),('9303','2012-12-26','13:40:00',2.11),('9303','2012-12-26','13:45:00',2.02),('9303','2012-12-26','13:50:00',1.86),('9303','2012-12-26','13:55:00',1.64),('9303','2012-12-26','14:00:00',1.55),('9303','2012-12-26','14:05:00',1.67),('9303','2012-12-23','09:45:00',1.11),('9303','2012-12-23','09:50:00',1.22),('9303','2012-12-23','09:55:00',1.27),('9303','2012-12-23','10:00:00',1.36),('9303','2012-12-23','10:05:00',1.45),('9303','2012-12-23','10:10:00',1.42),('9303','2012-12-23','10:15:00',1.45),('9303','2012-12-23','10:20:00',1.48),('9303','2012-12-23','10:25:00',1.4),('9303','2012-12-23','10:30:00',1.42),('9303','2012-12-23','10:35:00',1.43),('9303','2012-12-23','10:40:00',1.54),('9303','2012-12-23','10:45:00',1.59),('9303','2012-12-23','10:50:00',1.54),('9303','2012-12-23','10:55:00',1.57),('9303','2012-12-23','11:00:00',1.71),('9303','2012-12-23','11:05:00',1.7),('9303','2012-12-23','11:10:00',1.7),('9303','2012-12-23','11:15:00',1.77),('9303','2012-12-23','11:20:00',1.84),('9303','2012-12-23','11:25:00',1.68),('9303','2012-12-23','11:30:00',1.77),('9303','2012-12-23','11:35:00',1.93),('9303','2012-12-23','11:40:00',1.91),('9303','2012-12-23','11:45:00',1.86),('9303','2012-12-23','11:50:00',1.93),('9303','2012-12-23','11:55:00',1.82),('9303','2012-12-23','12:00:00',1.69),('9303','2012-12-23','12:05:00',1.74),('9303','2012-12-23','12:10:00',1.78),('9303','2012-12-23','12:15:00',1.48),('9303','2012-12-23','12:20:00',1.23),('9303','2012-12-23','12:30:00',1.31),('9303','2012-12-23','12:35:00',1.17),('9303','2012-12-23','12:40:00',1.23),('9303','2012-12-23','12:50:00',1.29),('9303','2012-12-23','12:55:00',1.72),('9303','2012-12-23','13:00:00',1.87),('9303','2012-12-23','13:05:00',1.5),('9303','2012-12-23','13:10:00',1.72),('9303','2012-12-23','13:15:00',1.18),('9303','2012-12-23','13:40:00',1.29),('9303','2012-12-23','13:45:00',1.26),('9303','2012-12-23','13:50:00',1.16),('9303','2012-12-23','13:55:00',1.11),('9303','2012-12-23','14:00:00',1.5),('9303','2012-12-23','14:05:00',1.3),('9303','2012-12-23','14:10:00',1.23),('9303','2012-12-23','14:15:00',1.24),('9303','2012-12-23','14:20:00',1),('9303','2012-12-23','14:40:00',1.07),('9303','2012-12-23','14:45:00',1.1),('9303','2014-05-01','07:55:00',1.11),('9303','2014-05-01','08:00:00',1.23),('9303','2014-05-01','08:05:00',1.21),('9303','2014-05-01','08:10:00',1.35),('9303','2014-05-01','08:15:00',1.5),('9303','2014-05-01','08:20:00',1.6),('9303','2014-05-01','08:25:00',1.72),('9303','2014-05-01','08:30:00',1.82),('9303','2014-05-01','08:35:00',1.9),('9303','2014-05-01','08:40:00',1.99),('9303','2014-05-01','08:45:00',2.09),('9303','2014-05-01','08:50:00',2.26),('9303','2014-05-01','08:55:00',2.25),('9303','2014-05-01','09:00:00',1.49),('9303','2014-05-01','09:05:00',1.21),('9303','2014-05-01','09:10:00',2.01),('9303','2014-05-01','09:15:00',1.71),('9303','2014-05-01','09:20:00',1.2),('9303','2014-05-01','09:25:00',2.71),('9303','2014-05-01','09:30:00',2.65),('9303','2014-05-01','09:35:00',3.02),('9303','2014-05-01','09:40:00',3.17),('9303','2014-05-01','09:45:00',2.16),('9303','2014-05-01','09:50:00',2.21),('9303','2014-05-01','09:55:00',1.93),('9303','2014-05-01','10:00:00',1.91),('9303','2014-05-01','10:05:00',3.19),('9303','2014-05-01','10:10:00',3.46),('9303','2014-05-01','10:15:00',2.6),('9303','2014-05-01','10:20:00',2.85),('9303','2014-05-01','10:25:00',2.93),('9303','2014-05-01','10:30:00',1.69),('9303','2014-05-01','10:35:00',1.37),('9303','2014-05-01','10:40:00',1.69),('9303','2014-05-01','10:45:00',4.05),('9303','2014-05-01','10:50:00',3.73),('9303','2014-05-01','10:55:00',2.64),('9303','2014-05-01','11:00:00',2.71),('9303','2014-05-01','11:05:00',1.27),('9303','2014-05-01','11:10:00',1.24),('9303','2014-05-01','11:15:00',3.73),('9303','2014-05-01','11:20:00',4.57),('9303','2014-05-01','11:25:00',2.16),('9303','2014-05-01','11:30:00',4.36),('9303','2014-05-01','11:35:00',4.35),('9303','2014-05-01','11:40:00',4.54),('9303','2014-05-01','11:45:00',2.94),('9303','2014-05-01','11:50:00',3.01),('9303','2014-05-01','11:55:00',4.35),('9303','2014-05-01','12:00:00',4.29),('9303','2014-05-01','12:05:00',3.69),('9303','2014-05-01','12:10:00',2.55),('9303','2014-05-01','12:15:00',1.64),('9303','2014-05-01','12:20:00',3.12),('9303','2014-05-01','12:25:00',3.28),('9303','2014-05-01','12:30:00',3.51),('9303','2014-05-01','12:35:00',4.76),('9303','2014-05-01','12:40:00',4.66),('9303','2014-05-01','12:45:00',4.66),('9303','2014-05-01','12:50:00',3.39),('9303','2014-05-01','12:55:00',4.77),('9303','2014-05-01','13:00:00',4.8),('9303','2014-05-01','13:05:00',4.61),('9303','2014-05-01','13:10:00',4.66),('9303','2014-05-01','13:15:00',4.05),('9303','2014-05-01','13:20:00',3.21),('9303','2014-05-01','13:25:00',4.46),('9303','2014-05-01','13:30:00',4.77),('9303','2014-05-01','13:35:00',2.9),('9303','2014-05-01','13:40:00',4.73),('9303','2014-05-01','13:45:00',4.76),('9303','2014-05-01','13:50:00',4.37),('9303','2014-05-01','13:55:00',1.68),('9303','2014-05-01','14:00:00',1.23),('9303','2014-05-01','14:05:00',2.76),('9303','2014-05-01','14:10:00',4.49),('9303','2014-05-01','14:15:00',4.58),('9303','2014-05-01','14:20:00',4.34),('9303','2014-05-01','14:25:00',4.42),('9303','2014-05-01','14:30:00',4.22),('9303','2014-05-01','14:35:00',3.56),('9303','2014-05-01','14:40:00',3.22),('9303','2014-05-01','14:45:00',3.76),('9303','2014-05-01','14:50:00',4.23),('9303','2014-05-01','14:55:00',3.66),('9303','2014-05-01','15:00:00',4.17),('9303','2014-05-01','15:05:00',4.34),('9303','2014-05-01','15:10:00',3.79),('9303','2014-05-01','15:15:00',3.87),('9303','2014-05-01','15:20:00',3.94),('9303','2014-05-01','15:25:00',3.84),('9303','2014-05-01','15:30:00',3.72),('9303','2014-05-01','15:35:00',3.63),('9303','2014-05-01','15:40:00',3.58),('9303','2014-05-01','15:45:00',3.54),('9303','2014-05-01','15:50:00',3.38),('9303','2014-05-01','15:55:00',3.36),('9303','2014-05-01','16:00:00',3.32),('9303','2014-05-01','16:05:00',3.33),('9303','2014-05-01','16:10:00',3.16),('9303','2014-05-01','16:15:00',3.13),('9303','2014-05-01','16:20:00',3.01),('9303','2014-05-01','16:25:00',2.69),('9303','2014-05-01','16:30:00',2.84),('9303','2014-05-01','16:35:00',2.81),('9303','2014-05-01','16:40:00',2.66),('9303','2014-05-01','16:45:00',2.26),('9303','2014-05-01','16:50:00',2.19),('9303','2014-05-01','16:55:00',2.27),('9303','2014-05-01','17:00:00',1.99),('9303','2014-05-01','17:05:00',2.17),('9303','2014-05-01','17:10:00',2.24),('9303','2014-05-01','17:15:00',2.08),('9303','2014-05-01','17:20:00',2.01),('9303','2014-05-01','17:25:00',1.91),('9303','2014-05-01','17:30:00',1.81),('9303','2014-05-01','17:35:00',1.75),('9303','2014-05-01','17:40:00',1.65),('9303','2014-05-01','17:45:00',1.54),('9303','2014-05-01','17:50:00',1.47),('9303','2014-05-01','17:55:00',1.41),('9303','2014-05-01','18:00:00',1.39),('9303','2014-05-01','18:05:00',1.23),('9303','2014-05-01','18:10:00',1.09),('9303','2014-03-17','09:20:00',1.07),('9303','2014-03-17','09:25:00',1.28),('9303','2014-03-17','09:30:00',1.46),('9303','2014-03-17','09:35:00',1.47),('9303','2014-03-17','09:40:00',1.21),('9303','2014-03-17','09:45:00',1.14),('9303','2014-03-17','09:50:00',1.54),('9303','2014-03-17','09:55:00',1.74),('9303','2014-03-17','10:00:00',1.78),('9303','2014-03-17','10:05:00',1.7),('9303','2014-03-17','10:10:00',1.56),('9303','2014-03-17','10:15:00',1.59),('9303','2014-03-17','10:20:00',2.01),('9303','2014-03-17','10:25:00',1.75),('9303','2014-03-17','10:30:00',1.3),('9303','2014-03-17','10:35:00',1.39),('9303','2014-03-17','10:40:00',1.35),('9303','2014-03-17','10:45:00',1.63),('9303','2014-03-17','10:50:00',1.44),('9303','2014-03-17','10:55:00',1.22),('9303','2014-03-17','11:00:00',1.37),('9303','2014-03-17','11:05:00',1.4),('9303','2014-03-17','11:10:00',1.41),('9303','2014-03-17','11:15:00',1.83),('9303','2014-03-17','11:20:00',1.44),('9303','2014-03-17','11:25:00',1.23),('9303','2014-03-17','11:30:00',1.33),('9303','2014-03-17','11:35:00',1.25),('9303','2014-03-17','11:40:00',1.15),('9303','2014-03-17','11:45:00',1.23),('9303','2014-03-17','11:50:00',1.43),('9303','2014-03-17','11:55:00',1.52),('9303','2014-03-17','12:00:00',2.59),('9303','2014-03-17','12:05:00',1.66),('9303','2014-03-17','12:10:00',1.7),('9303','2014-03-17','12:15:00',1.54),('9303','2014-03-17','12:20:00',1.81),('9303','2014-03-17','12:25:00',2.34),('9303','2014-03-17','12:30:00',1.4),('9303','2014-03-17','12:35:00',2.28),('9303','2014-03-17','12:40:00',2.93),('9303','2014-03-17','12:45:00',3.85),('9303','2014-03-17','12:50:00',4.05),('9303','2014-03-17','12:55:00',3.96),('9303','2014-03-17','13:00:00',3.77),('9303','2014-03-17','13:05:00',1.86),('9303','2014-03-17','13:10:00',3.22),('9303','2014-03-17','13:15:00',3.71),('9303','2014-03-17','13:20:00',3.68),('9303','2014-03-17','13:25:00',3.63),('9303','2014-03-17','13:30:00',3.58),('9303','2014-03-17','13:35:00',3.63),('9303','2014-03-17','13:40:00',3.79),('9303','2014-03-17','13:45:00',3.36),('9303','2014-03-17','13:50:00',3.12),('9303','2014-03-17','13:55:00',3.27),('9303','2014-03-17','14:00:00',2.97),('9303','2014-03-17','14:05:00',3.28),('9303','2014-03-17','14:10:00',2.57),('9303','2014-03-17','14:15:00',1.28),('9303','2014-03-17','14:20:00',3.3),('9303','2014-03-17','14:25:00',2.12),('9303','2014-03-17','14:30:00',1.21),('9303','2014-03-17','14:35:00',2),('9303','2014-03-17','14:40:00',2.96),('9303','2014-03-17','14:45:00',2.58),('9303','2014-03-17','14:50:00',1.58),('9303','2014-03-17','14:55:00',2.77),('9303','2014-03-17','15:00:00',2.17),('9303','2014-03-17','15:05:00',2.62),('9303','2014-03-17','15:10:00',2.37),('9303','2014-03-17','15:15:00',2.48),('9303','2014-03-17','15:20:00',2.4),('9303','2014-03-17','15:25:00',2.22),('9303','2014-03-17','15:30:00',2.23),('9303','2014-03-17','15:35:00',2.17),('9303','2014-03-17','15:40:00',1.86),('9303','2014-03-17','15:45:00',1.89),('9303','2014-03-17','15:50:00',1.8),('9303','2014-03-17','15:55:00',1.66),('9303','2014-03-17','16:00:00',1.56),('9303','2014-03-17','16:05:00',1.57),('9303','2014-03-17','16:15:00',1.2),('9303','2014-03-17','16:20:00',1.53),('9303','2014-03-17','16:25:00',1.5),('9303','2014-03-17','16:30:00',1.19),('9303','2014-03-17','16:35:00',1.11),('9303','2014-03-17','16:40:00',1.03),('9303','2012-12-22','10:25:00',1.46),('9303','2012-12-22','10:30:00',1.65),('9303','2012-12-22','10:35:00',1.81),('9303','2012-12-22','10:40:00',1.84),('9303','2012-12-22','10:45:00',1.86),('9303','2012-12-22','10:50:00',1.87),('9303','2012-12-22','10:55:00',1.99),('9303','2012-12-22','11:00:00',1.14),('9303','2012-12-22','11:40:00',1.24),('9303','2012-12-22','11:45:00',1.31),('9303','2012-12-22','11:50:00',1.7),('9303','2012-12-22','11:55:00',1.09),('9303','2012-12-22','12:00:00',1.25),('9303','2012-12-22','12:45:00',1.44),('9303','2012-12-22','12:50:00',1.65),('9303','2012-12-22','12:55:00',1.5),('9303','2012-12-22','13:00:00',1.93),('9303','2012-12-22','13:05:00',2.3),('9303','2012-12-22','13:10:00',2.45),('9303','2012-12-22','13:15:00',2.41),('9303','2012-12-22','13:20:00',2.39),('9303','2012-12-22','13:25:00',2.29),('9303','2012-12-22','13:30:00',1.99),('9303','2012-12-22','13:35:00',2.1),('9303','2012-12-22','13:40:00',1.65),('9303','2012-12-22','14:00:00',1.41),('9303','2012-12-22','14:15:00',1.17),('9303','2012-12-22','14:20:00',1.04),('9303','2012-12-22','15:00:00',1.06),('9303','2014-03-16','07:55:00',1.04),('9303','2014-03-16','08:00:00',1.17),('9303','2014-03-16','08:05:00',1.24),('9303','2014-03-16','08:10:00',1.27),('9303','2014-03-16','08:15:00',1.34),('9303','2014-03-16','08:20:00',1.44),('9303','2014-03-16','08:25:00',1.52),('9303','2014-03-16','08:30:00',1.61),('9303','2014-03-16','08:35:00',1.68),('9303','2014-03-16','08:40:00',1.73),('9303','2014-03-16','08:45:00',1.83),('9303','2014-03-16','08:50:00',1.91),('9303','2014-03-16','08:55:00',1.96),('9303','2014-03-16','09:00:00',1.93),('9303','2014-03-16','09:05:00',2.03),('9303','2014-03-16','09:10:00',2.15),('9303','2014-03-16','09:15:00',2.31),('9303','2014-03-16','09:20:00',2.36),('9303','2014-03-16','09:25:00',2.35),('9303','2014-03-16','09:30:00',2.4),('9303','2014-03-16','09:35:00',2.43),('9303','2014-03-16','09:40:00',2.48),('9303','2014-03-16','09:45:00',2.62),('9303','2014-03-16','09:50:00',2.74),('9303','2014-03-16','09:55:00',2.8),('9303','2014-03-16','10:00:00',2.83),('9303','2014-03-16','10:05:00',2.81),('9303','2014-03-16','10:10:00',2.92),('9303','2014-03-16','10:15:00',3.01),('9303','2014-03-16','10:20:00',2.99),('9303','2014-03-16','10:25:00',3.03),('9303','2014-03-16','10:30:00',3.05),('9303','2014-03-16','10:35:00',3.12),('9303','2014-03-16','10:40:00',3.2),('9303','2014-03-16','10:45:00',3.23),('9303','2014-03-16','10:50:00',3.3),('9303','2014-03-16','10:55:00',3.27),('9303','2014-03-16','11:00:00',3.21),('9303','2014-03-16','11:05:00',3.06),('9303','2014-03-16','11:10:00',2.96),('9303','2014-03-16','11:15:00',3.35),('9303','2014-03-16','11:20:00',3.44),('9303','2014-03-16','11:25:00',3.41),('9303','2014-03-16','11:30:00',3.46),('9303','2014-03-16','11:35:00',3.5),('9303','2014-03-16','11:40:00',3.55),('9303','2014-03-16','11:45:00',3.53),('9303','2014-03-16','11:50:00',3.52),('9303','2014-03-16','11:55:00',3.45),('9303','2014-03-16','12:00:00',3.49),('9303','2014-03-16','12:05:00',3.49),('9303','2014-03-16','12:10:00',3.55),('9303','2014-03-16','12:15:00',3.56),('9303','2014-03-16','12:20:00',3.42),('9303','2014-03-16','12:25:00',3.33),('9303','2014-03-16','12:30:00',3.44),('9303','2014-03-16','12:35:00',3.43),('9303','2014-03-16','12:40:00',3.48),('9303','2014-03-16','12:45:00',3.51),('9303','2014-03-16','12:50:00',3.47),('9303','2014-03-16','12:55:00',3.38),('9303','2014-03-16','13:00:00',3.33),('9303','2014-03-16','13:05:00',3.45),('9303','2014-03-16','13:10:00',3.37),('9303','2014-03-16','13:15:00',3.39),('9303','2014-03-16','13:20:00',3.31),('9303','2014-03-16','13:25:00',3.36),('9303','2014-03-16','13:30:00',3.35),('9303','2014-03-16','13:35:00',3.32),('9303','2014-03-16','13:40:00',3.39),('9303','2014-03-16','13:45:00',3.3),('9303','2014-03-16','13:50:00',3.24),('9303','2014-03-16','13:55:00',3.29),('9303','2014-03-16','14:00:00',3.17),('9303','2014-03-16','14:05:00',3.16),('9303','2014-03-16','14:10:00',3.06),('9303','2014-03-16','14:15:00',3.02),('9303','2014-03-16','14:20:00',2.98),('9303','2014-03-16','14:25:00',2.94),('9303','2014-03-16','14:30:00',2.87),('9303','2014-03-16','14:35:00',2.79),('9303','2014-03-16','14:40:00',2.75),('9303','2014-03-16','14:45:00',2.63),('9303','2014-03-16','14:50:00',2.52),('9303','2014-03-16','14:55:00',2.47),('9303','2014-03-16','15:00:00',2.63),('9303','2014-03-16','15:05:00',2.44),('9303','2014-03-16','15:10:00',2.25),('9303','2014-03-16','15:15:00',2.14),('9303','2014-03-16','15:20:00',1.79),('9303','2014-03-16','15:25:00',2.01),('9303','2014-03-16','15:30:00',1.88),('9303','2014-03-16','15:35:00',1.64),('9303','2014-03-16','15:40:00',1.29),('9303','2014-03-16','15:45:00',1.27),('9303','2014-03-16','15:50:00',1.43),('9303','2014-03-16','15:55:00',1.31),('9303','2014-03-16','16:00:00',1.16),('9303','2014-03-16','16:05:00',1.35),('9303','2014-03-16','16:10:00',1.39),('9303','2014-03-16','16:15:00',1.34),('9303','2014-03-16','16:20:00',1.2),('9303','2014-03-16','16:25:00',1.23),('9303','2014-03-16','16:30:00',1.2),('9303','2014-03-16','16:35:00',1.08),('9303','2014-03-15','08:00:00',1.03),('9303','2014-03-15','08:05:00',1.13),('9303','2014-03-15','08:10:00',1.2),('9303','2014-03-15','08:15:00',1.3),('9303','2014-03-15','08:20:00',1.38),('9303','2014-03-15','08:25:00',1.46),('9303','2014-03-15','08:30:00',1.53),('9303','2014-03-15','08:35:00',1.6),('9303','2014-03-15','08:40:00',1.66),('9303','2014-03-15','08:45:00',1.73),('9303','2014-03-15','08:50:00',1.82),('9303','2014-03-15','08:55:00',1.88),('9303','2014-03-15','09:00:00',1.95),('9303','2014-03-15','09:05:00',2.04),('9303','2014-03-15','09:10:00',2.12),('9303','2014-03-15','09:15:00',2.2),('9303','2014-03-15','09:20:00',2.27),('9303','2014-03-15','09:25:00',2.34),('9303','2014-03-15','09:30:00',2.39),('9303','2014-03-15','09:35:00',2.44),('9303','2014-03-15','09:40:00',2.5),('9303','2014-03-15','09:45:00',2.53),('9303','2014-03-15','09:50:00',2.58),('9303','2014-03-15','09:55:00',2.62),('9303','2014-03-15','10:00:00',2.68),('9303','2014-03-15','10:05:00',2.72),('9303','2014-03-15','10:10:00',2.78),('9303','2014-03-15','10:15:00',2.85),('9303','2014-03-15','10:20:00',2.9),('9303','2014-03-15','10:25:00',2.99),('9303','2014-03-15','10:30:00',3.02),('9303','2014-03-15','10:35:00',3.02),('9303','2014-03-15','10:40:00',3.06),('9303','2014-03-15','10:45:00',3.09),('9303','2014-03-15','10:50:00',3.05),('9303','2014-03-15','10:55:00',3.09),('9303','2014-03-15','11:00:00',3.07),('9303','2014-03-15','11:05:00',3.13),('9303','2014-03-15','11:10:00',3.18),('9303','2014-03-15','11:15:00',3.3),('9303','2014-03-15','11:20:00',3.39),('9303','2014-03-15','11:25:00',3.35),('9303','2014-03-15','11:30:00',3.44),('9303','2014-03-15','11:35:00',3.42),('9303','2014-03-15','11:40:00',3.44),('9303','2014-03-15','11:45:00',3.46),('9303','2014-03-15','11:50:00',3.46),('9303','2014-03-15','11:55:00',3.51),('9303','2014-03-15','12:00:00',3.52),('9303','2014-03-15','12:05:00',3.47),('9303','2014-03-15','12:10:00',3.49),('9303','2014-03-15','12:15:00',3.54),('9303','2014-03-15','12:20:00',3.47),('9303','2014-03-15','12:25:00',3.46),('9303','2014-03-15','12:30:00',3.49),('9303','2014-03-15','12:35:00',3.57),('9303','2014-03-15','12:40:00',3.6),('9303','2014-03-15','12:45:00',3.56),('9303','2014-03-15','12:50:00',3.53),('9303','2014-03-15','12:55:00',3.5),('9303','2014-03-15','13:00:00',3.49),('9303','2014-03-15','13:05:00',3.52),('9303','2014-03-15','13:10:00',3.52),('9303','2014-03-15','13:15:00',3.48),('9303','2014-03-15','13:20:00',3.45),('9303','2014-03-15','13:25:00',3.45),('9303','2014-03-15','13:30:00',3.45),('9303','2014-03-15','13:35:00',3.42),('9303','2014-03-15','13:40:00',3.41),('9303','2014-03-15','13:45:00',3.36),('9303','2014-03-15','13:50:00',3.35),('9303','2014-03-15','13:55:00',3.3),('9303','2014-03-15','14:00:00',3.28),('9303','2014-03-15','14:05:00',3.27),('9303','2014-03-15','14:10:00',3.22),('9303','2014-03-15','14:15:00',3.17),('9303','2014-03-15','14:20:00',3.11),('9303','2014-03-15','14:25:00',3.05),('9303','2014-03-15','14:30:00',3.01),('9303','2014-03-15','14:35:00',2.94),('9303','2014-03-15','14:40:00',2.87),('9303','2014-03-15','14:45:00',2.82),('9303','2014-03-15','14:50:00',2.74),('9303','2014-03-15','14:55:00',2.69),('9303','2014-03-15','15:00:00',2.62),('9303','2014-03-15','15:05:00',2.56),('9303','2014-03-15','15:10:00',2.49),('9303','2014-03-15','15:15:00',2.41),('9303','2014-03-15','15:20:00',2.32),('9303','2014-03-15','15:25:00',2.24),('9303','2014-03-15','15:30:00',2.17),('9303','2014-03-15','15:35:00',2.05),('9303','2014-03-15','15:40:00',1.93),('9303','2014-03-15','15:45:00',1.84),('9303','2014-03-15','15:50:00',1.77),('9303','2014-03-15','15:55:00',1.69),('9303','2014-03-15','16:00:00',1.58),('9303','2014-03-15','16:05:00',1.45),('9303','2014-03-15','16:10:00',1.34),('9303','2014-03-15','16:15:00',1.25),('9303','2014-03-15','16:20:00',1.17),('9303','2014-03-15','16:25:00',1.09),('9303','2014-03-15','16:30:00',1.01),('9303','2014-03-14','08:20:00',1.09),('9303','2014-03-14','08:25:00',1.13),('9303','2014-03-14','08:30:00',1.22),('9303','2014-03-14','08:35:00',1.23),('9303','2014-03-14','08:40:00',1.21),('9303','2014-03-14','08:45:00',1.04),('9303','2014-03-14','09:00:00',1.05),('9303','2014-03-14','09:05:00',1.2),('9303','2014-03-14','09:10:00',1.38),('9303','2014-03-14','09:15:00',1.42),('9303','2014-03-14','09:20:00',1.38),('9303','2014-03-14','09:25:00',1.46),('9303','2014-03-14','09:30:00',1.46),('9303','2014-03-14','09:35:00',1.71),('9303','2014-03-14','09:40:00',2.19),('9303','2014-03-14','09:45:00',2.53),('9303','2014-03-14','09:50:00',2.98),('9303','2014-03-14','09:55:00',3.19),('9303','2014-03-14','10:00:00',3.32),('9303','2014-03-14','10:05:00',3.37),('9303','2014-03-14','10:10:00',3.32),('9303','2014-03-14','10:15:00',3.24),('9303','2014-03-14','10:20:00',3.17),('9303','2014-03-14','10:25:00',3.09),('9303','2014-03-14','10:30:00',3.04),('9303','2014-03-14','10:35:00',3.16),('9303','2014-03-14','10:40:00',3.32),('9303','2014-03-14','10:45:00',3.02),('9303','2014-03-14','10:50:00',1.93),('9303','2014-03-14','10:55:00',2.35),('9303','2014-03-14','11:00:00',3.19),('9303','2014-03-14','11:05:00',3.27),('9303','2014-03-14','11:10:00',3.54),('9303','2014-03-14','11:15:00',3.66),('9303','2014-03-14','11:20:00',3.54),('9303','2014-03-14','11:25:00',3.48),('9303','2014-03-14','11:30:00',3.46),('9303','2014-03-14','11:35:00',3.54),('9303','2014-03-14','11:40:00',3.47),('9303','2014-03-14','11:45:00',3.48),('9303','2014-03-14','11:50:00',3.55),('9303','2014-03-14','11:55:00',3.61),('9303','2014-03-14','12:00:00',3.64),('9303','2014-03-14','12:05:00',3.57),('9303','2014-03-14','12:10:00',3.36),('9303','2014-03-14','12:15:00',3.3),('9303','2014-03-14','12:20:00',2.97),('9303','2014-03-14','12:25:00',2.37),('9303','2014-03-14','12:30:00',2.21),('9303','2014-03-14','12:35:00',1.83),('9303','2014-03-14','12:40:00',2.18),('9303','2014-03-14','12:45:00',2.25),('9303','2014-03-14','12:50:00',2.79),('9303','2014-03-14','12:55:00',2.85),('9303','2014-03-14','13:00:00',2.08),('9303','2014-03-14','13:05:00',1.74),('9303','2014-03-14','13:10:00',2.16),('9303','2014-03-14','13:15:00',2.5),('9303','2014-03-14','13:20:00',2.78),('9303','2014-03-14','13:25:00',2.58),('9303','2014-03-14','13:30:00',2.32),('9303','2014-03-14','13:35:00',2.09),('9303','2014-03-14','13:40:00',1.89),('9303','2014-03-14','13:45:00',1.98),('9303','2014-03-14','13:50:00',1.82),('9303','2014-03-14','13:55:00',1.88),('9303','2014-03-14','14:00:00',2.18),('9303','2014-03-14','14:05:00',2.45),('9303','2014-03-14','14:10:00',2.53),('9303','2014-03-14','14:15:00',2.68),('9303','2014-03-14','14:20:00',2.68),('9303','2014-03-14','14:25:00',2.76),('9303','2014-03-14','14:30:00',2.56),('9303','2014-03-14','14:35:00',2.38),('9303','2014-03-14','14:40:00',2.03),('9303','2014-03-14','14:45:00',1.62),('9303','2014-03-14','14:50:00',1.37),('9303','2014-03-14','14:55:00',1.26),('9303','2014-03-14','15:00:00',1.14),('9303','2014-03-14','15:05:00',1.13),('9303','2014-03-14','15:10:00',1.09),('9303','2014-03-14','15:15:00',1.1),('9303','2014-03-14','15:20:00',1.2),('9303','2014-03-14','15:25:00',1.3),('9303','2014-03-14','15:30:00',1.36),('9303','2014-03-14','15:35:00',1.47),('9303','2014-03-14','15:40:00',1.3),('9303','2014-03-14','15:45:00',1.14),('9303','2014-03-14','15:50:00',1.02),('9303','2014-03-14','15:55:00',1.04),('9303','2014-03-13','07:50:00',1.11),('9303','2014-03-13','07:55:00',1.22),('9303','2014-03-13','08:00:00',1.31),('9303','2014-03-13','08:05:00',1.42),('9303','2014-03-13','08:10:00',1.5),('9303','2014-03-13','08:15:00',1.58),('9303','2014-03-13','08:20:00',1.7),('9303','2014-03-13','08:25:00',1.78),('9303','2014-03-13','08:30:00',1.85),('9303','2014-03-13','08:35:00',1.95),('9303','2014-03-13','08:40:00',2.04),('9303','2014-03-13','08:45:00',2.12),('9303','2014-03-13','08:50:00',2.2),('9303','2014-03-13','08:55:00',2.28),('9303','2014-03-13','09:00:00',2.37),('9303','2014-03-13','09:05:00',2.43),('9303','2014-03-13','09:10:00',2.51),('9303','2014-03-13','09:15:00',2.57),('9303','2014-03-13','09:20:00',2.63),('9303','2014-03-13','09:25:00',2.7),('9303','2014-03-13','09:30:00',2.77),('9303','2014-03-13','09:35:00',2.82),('9303','2014-03-13','09:40:00',2.89),('9303','2014-03-13','09:45:00',2.96),('9303','2014-03-13','09:50:00',3.03),('9303','2014-03-13','09:55:00',3.09),('9303','2014-03-13','10:00:00',3.15),('9303','2014-03-13','10:05:00',3.18),('9303','2014-03-13','10:10:00',3.25),('9303','2014-03-13','10:15:00',3.28),('9303','2014-03-13','10:20:00',3.31),('9303','2014-03-13','10:25:00',3.34),('9303','2014-03-13','10:30:00',3.39),('9303','2014-03-13','10:35:00',3.42),('9303','2014-03-13','10:40:00',3.45),('9303','2014-03-13','10:45:00',3.48),('9303','2014-03-13','10:50:00',3.5),('9303','2014-03-13','10:55:00',3.53),('9303','2014-03-13','11:00:00',3.53),('9303','2014-03-13','11:05:00',3.58),('9303','2014-03-13','11:10:00',3.59),('9303','2014-03-13','11:15:00',3.63),('9303','2014-03-13','11:20:00',3.67),('9303','2014-03-13','11:25:00',3.67),('9303','2014-03-13','11:30:00',3.67),('9303','2014-03-13','11:35:00',3.66),('9303','2014-03-13','11:40:00',3.69),('9303','2014-03-13','11:45:00',3.71),('9303','2014-03-13','11:50:00',3.75),('9303','2014-03-13','11:55:00',3.78),('9303','2014-03-13','12:00:00',3.73),('9303','2014-03-13','12:05:00',3.74),('9303','2014-03-13','12:10:00',3.79),('9303','2014-03-13','12:15:00',3.75),('9303','2014-03-13','12:20:00',3.74),('9303','2014-03-13','12:25:00',3.73),('9303','2014-03-13','12:30:00',3.7),('9303','2014-03-13','12:35:00',3.69),('9303','2014-03-13','12:40:00',3.65),('9303','2014-03-13','12:45:00',3.65),('9303','2014-03-13','12:50:00',3.66),('9303','2014-03-13','12:55:00',3.6),('9303','2014-03-13','13:00:00',3.56),('9303','2014-03-13','13:05:00',3.56),('9303','2014-03-13','13:10:00',3.45),('9303','2014-03-13','13:15:00',3.5),('9303','2014-03-13','13:20:00',3.5),('9303','2014-03-13','13:25:00',3.5),('9303','2014-03-13','13:30:00',3.53),('9303','2014-03-13','13:35:00',3.5),('9303','2014-03-13','13:40:00',3.44),('9303','2014-03-13','13:45:00',3.39),('9303','2014-03-13','13:50:00',3.36),('9303','2014-03-13','13:55:00',3.3),('9303','2014-03-13','14:00:00',3.25),('9303','2014-03-13','14:05:00',3.2),('9303','2014-03-13','14:10:00',3.18),('9303','2014-03-13','14:15:00',3.14),('9303','2014-03-13','14:20:00',3.07),('9303','2014-03-13','14:25:00',3.02),('9303','2014-03-13','14:30:00',2.98),('9303','2014-03-13','14:35:00',2.94),('9303','2014-03-13','14:40:00',2.87),('9303','2014-03-13','14:45:00',2.81),('9303','2014-03-13','14:50:00',2.75),('9303','2014-03-13','14:55:00',2.67),('9303','2014-03-13','15:00:00',2.63),('9303','2014-03-13','15:05:00',2.55),('9303','2014-03-13','15:10:00',2.49),('9303','2014-03-13','15:15:00',2.43),('9303','2014-03-13','15:20:00',2.36),('9303','2014-03-13','15:25:00',2.29),('9303','2014-03-13','15:30:00',2.19),('9303','2014-03-13','15:35:00',2.06),('9303','2014-03-13','15:40:00',1.95),('9303','2014-03-13','15:45:00',1.87),('9303','2014-03-13','15:50:00',1.8),('9303','2014-03-13','15:55:00',1.72),('9303','2014-03-13','16:00:00',1.62),('9303','2014-03-13','16:05:00',1.51),('9303','2014-03-13','16:10:00',1.42),('9303','2014-03-13','16:15:00',1.33),('9303','2014-03-13','16:20:00',1.26),('9303','2014-03-13','16:25:00',1.19),('9303','2014-03-13','16:30:00',1.1),('9303','2014-03-13','16:35:00',1.02),('9303','2014-03-12','07:50:00',1.02),('9303','2014-03-12','07:55:00',1.13),('9303','2014-03-12','08:00:00',1.23),('9303','2014-03-12','08:05:00',1.32),('9303','2014-03-12','08:10:00',1.44),('9303','2014-03-12','08:15:00',1.54),('9303','2014-03-12','08:20:00',1.64),('9303','2014-03-12','08:25:00',1.75),('9303','2014-03-12','08:30:00',1.83),('9303','2014-03-12','08:35:00',1.93),('9303','2014-03-12','08:40:00',2.02),('9303','2014-03-12','08:45:00',2.1),('9303','2014-03-12','08:50:00',2.19),('9303','2014-03-12','08:55:00',2.25),('9303','2014-03-12','09:00:00',2.32),('9303','2014-03-12','09:05:00',2.4),('9303','2014-03-12','09:10:00',2.49),('9303','2014-03-12','09:15:00',2.56),('9303','2014-03-12','09:20:00',2.63),('9303','2014-03-12','09:25:00',2.69),('9303','2014-03-12','09:30:00',2.74),('9303','2014-03-12','09:35:00',2.82),('9303','2014-03-12','09:40:00',2.87),('9303','2014-03-12','09:45:00',2.92),('9303','2014-03-12','09:50:00',2.98),('9303','2014-03-12','09:55:00',3.05),('9303','2014-03-12','10:00:00',3.1),('9303','2014-03-12','10:05:00',3.16),('9303','2014-03-12','10:10:00',3.19),('9303','2014-03-12','10:15:00',3.25),('9303','2014-03-12','10:20:00',3.3),('9303','2014-03-12','10:25:00',3.34),('9303','2014-03-12','10:30:00',3.38),('9303','2014-03-12','10:35:00',3.44),('9303','2014-03-12','10:40:00',3.5),('9303','2014-03-12','10:45:00',3.56),('9303','2014-03-12','10:50:00',3.59),('9303','2014-03-12','10:55:00',3.62),('9303','2014-03-12','11:00:00',3.67),('9303','2014-03-12','11:05:00',3.7),('9303','2014-03-12','11:10:00',3.74),('9303','2014-03-12','11:15:00',3.76),('9303','2014-03-12','11:20:00',3.78),('9303','2014-03-12','11:25:00',3.78),('9303','2014-03-12','11:30:00',3.79),('9303','2014-03-12','11:35:00',3.82),('9303','2014-03-12','11:40:00',3.85),('9303','2014-03-12','11:45:00',3.85),('9303','2014-03-12','11:50:00',3.87),('9303','2014-03-12','11:55:00',3.87),('9303','2014-03-12','12:00:00',3.86),('9303','2014-03-12','12:05:00',3.86),('9303','2014-03-12','12:10:00',3.86),('9303','2014-03-12','12:15:00',3.86),('9303','2014-03-12','12:20:00',3.83),('9303','2014-03-12','12:25:00',3.83),('9303','2014-03-12','12:30:00',3.84),('9303','2014-03-12','12:35:00',3.82),('9303','2014-03-12','12:40:00',3.78),('9303','2014-03-12','12:45:00',3.81),('9303','2014-03-12','12:50:00',3.78),('9303','2014-03-12','12:55:00',3.74),('9303','2014-03-12','13:00:00',3.78),('9303','2014-03-12','13:05:00',3.71),('9303','2014-03-12','13:10:00',3.69),('9303','2014-03-12','13:15:00',3.69),('9303','2014-03-12','13:20:00',3.67),('9303','2014-03-12','13:25:00',3.61),('9303','2014-03-12','13:30:00',3.57),('9303','2014-03-12','13:35:00',3.54),('9303','2014-03-12','13:40:00',3.51),('9303','2014-03-12','13:45:00',3.47),('9303','2014-03-12','13:50:00',3.43),('9303','2014-03-12','13:55:00',3.38),('9303','2014-03-12','14:00:00',3.38),('9303','2014-03-12','14:05:00',3.35),('9303','2014-03-12','14:10:00',3.31),('9303','2014-03-12','14:15:00',3.24),('9303','2014-03-12','14:20:00',3.18),('9303','2014-03-12','14:25:00',3.11),('9303','2014-03-12','14:30:00',3.06),('9303','2014-03-12','14:35:00',2.97),('9303','2014-03-12','14:40:00',2.92),('9303','2014-03-12','14:45:00',2.79),('9303','2014-03-12','14:50:00',2.79),('9303','2014-03-12','14:55:00',2.62),('9303','2014-03-12','15:00:00',2.57),('9303','2014-03-12','15:05:00',2.52),('9303','2014-03-12','15:10:00',2.48),('9303','2014-03-12','15:15:00',2.36),('9303','2014-03-12','15:20:00',2.36),('9303','2014-03-12','15:25:00',2.25),('9303','2014-03-12','15:30:00',2.12),('9303','2014-03-12','15:35:00',2.03),('9303','2014-03-12','15:40:00',1.93),('9303','2014-03-12','15:45:00',1.86),('9303','2014-03-12','15:50:00',1.8),('9303','2014-03-12','15:55:00',1.72),('9303','2014-03-12','16:00:00',1.65),('9303','2014-03-12','16:05:00',1.52),('9303','2014-03-12','16:10:00',1.42),('9303','2014-03-12','16:15:00',1.35),('9303','2014-03-12','16:20:00',1.27),('9303','2014-03-12','16:25:00',1.18),('9303','2014-03-12','16:30:00',1.08),('9303','2014-03-12','16:35:00',1.01),('9303','2014-03-11','12:10:00',1.03),('9303','2014-03-11','12:15:00',1.15),('9303','2014-03-11','12:20:00',1.23),('9303','2014-03-11','12:25:00',1.11),('9303','2014-03-11','12:30:00',1.08),('9303','2014-03-11','12:35:00',1.15),('9303','2014-03-11','12:40:00',1.28),('9303','2014-03-11','12:45:00',1.24),('9303','2014-03-11','12:50:00',1.18),('9303','2014-03-11','12:55:00',1.07),('9303','2014-03-11','13:00:00',1),('9303','2014-03-11','13:05:00',1.16),('9303','2014-03-11','13:10:00',1.19),('9303','2014-03-11','13:15:00',1.18),('9303','2014-03-11','13:20:00',1.21),('9303','2014-03-11','13:25:00',1.02),('9303','2014-03-11','13:45:00',1.24),('9303','2014-03-11','13:50:00',1.47),('9303','2014-03-11','13:55:00',1.8),('9303','2014-03-11','14:00:00',1.84),('9303','2014-03-11','14:05:00',1.95),('9303','2014-03-11','14:10:00',2.31),('9303','2014-03-11','14:15:00',2.2),('9303','2014-03-11','14:20:00',1.91),('9303','2014-03-11','14:25:00',1.63),('9303','2014-03-11','14:30:00',1.26),('9303','2014-03-11','14:35:00',1.37),('9303','2014-03-11','14:40:00',1.35),('9303','2014-03-11','14:45:00',1.46),('9303','2014-03-11','14:50:00',1.3),('9303','2014-03-11','14:55:00',1.3),('9303','2014-03-11','15:00:00',1.5),('9303','2014-03-11','15:05:00',1.66),('9303','2014-03-11','15:10:00',1.71),('9303','2014-03-11','15:15:00',1.47),('9303','2014-03-11','15:20:00',1.48),('9303','2014-03-11','15:25:00',1.31),('9303','2014-03-11','15:30:00',1.23),('9303','2014-03-11','15:35:00',1.08),('9303','2014-03-11','15:40:00',1.06),('9303','2014-03-10','10:15:00',1.08),('9303','2014-03-10','10:30:00',1.04),('9303','2014-03-10','10:35:00',1.12),('9303','2014-03-10','12:50:00',1.05),('9303','2014-03-10','12:55:00',1.12),('9303','2014-03-10','13:00:00',1.17),('9303','2014-03-10','13:05:00',1.21),('9303','2014-03-10','13:10:00',1.34),('9303','2014-03-10','13:15:00',1.47),('9303','2014-03-10','13:20:00',1.43),('9303','2014-03-10','13:25:00',1.23),('9303','2014-03-10','13:30:00',1.02),('9303','2014-03-10','13:50:00',1.14),('9303','2014-03-10','13:55:00',1.06),('9303','2014-03-10','14:00:00',1.1),('9303','2014-03-10','14:05:00',1.51),('9303','2014-03-10','14:10:00',2.28),('9303','2014-03-10','14:15:00',3.13),('9303','2014-03-10','14:20:00',2.12),('9303','2014-03-10','14:25:00',1.59),('9303','2014-03-10','14:30:00',1.21),('9303','2014-03-10','14:35:00',2.03),('9303','2014-03-10','14:40:00',2.5),('9303','2014-03-10','14:45:00',2.39),('9303','2014-03-10','14:50:00',2.3),('9303','2014-03-10','14:55:00',1.34),('9303','2014-03-10','15:00:00',1.43),('9303','2014-03-10','15:05:00',1.17),('9303','2014-03-10','15:15:00',1.25),('9303','2014-03-10','15:20:00',2.13),('9303','2014-03-10','15:25:00',1.92),('9303','2014-03-10','15:30:00',1.47),('9303','2014-03-10','16:25:00',1.01),('9303','2014-03-10','16:30:00',1.11),('9303','2014-03-09','07:55:00',1.01),('9303','2014-03-09','08:00:00',1.12),('9303','2014-03-09','08:05:00',1.22),('9303','2014-03-09','08:10:00',1.36),('9303','2014-03-09','08:15:00',1.46),('9303','2014-03-09','08:20:00',1.48),('9303','2014-03-09','08:25:00',1.33),('9303','2014-03-09','08:30:00',1.32),('9303','2014-03-09','08:35:00',1.14),('9303','2014-03-09','08:40:00',1.35),('9303','2014-03-09','08:45:00',1.15),('9303','2014-03-09','08:50:00',1.09),('9303','2014-03-09','08:55:00',1.64),('9303','2014-03-09','09:00:00',2.08),('9303','2014-03-09','09:05:00',1.32),('9303','2014-03-09','09:15:00',2.12),('9303','2014-03-09','09:20:00',2.54),('9303','2014-03-09','09:25:00',2.76),('9303','2014-03-09','09:30:00',2.73),('9303','2014-03-09','09:35:00',3.03),('9303','2014-03-09','09:40:00',3.13),('9303','2014-03-09','09:45:00',3.2),('9303','2014-03-09','09:50:00',3.21),('9303','2014-03-09','09:55:00',3.16),('9303','2014-03-09','10:00:00',3.19),('9303','2014-03-09','10:05:00',3.24),('9303','2014-03-09','10:10:00',3.33),('9303','2014-03-09','10:15:00',3.33),('9303','2014-03-09','10:20:00',3.22),('9303','2014-03-09','10:25:00',3.11),('9303','2014-03-09','10:30:00',3.45),('9303','2014-03-09','10:35:00',3.49),('9303','2014-03-09','10:40:00',3.55),('9303','2014-03-09','10:45:00',3.59),('9303','2014-03-09','10:50:00',3.67),('9303','2014-03-09','10:55:00',3.78),('9303','2014-03-09','11:00:00',4.04),('9303','2014-03-09','11:05:00',4.09),('9303','2014-03-09','11:10:00',4.25),('9303','2014-03-09','11:15:00',3.69),('9303','2014-03-09','11:20:00',3.3),('9303','2014-03-09','11:25:00',3.65),('9303','2014-03-09','11:30:00',2.32),('9303','2014-03-09','11:35:00',2.51),('9303','2014-03-09','11:40:00',3.28),('9303','2014-03-09','11:45:00',2.89),('9303','2014-03-09','11:50:00',3.06),('9303','2014-03-09','11:55:00',4.23),('9303','2014-03-09','12:00:00',4.52),('9303','2014-03-09','12:05:00',4.52),('9303','2014-03-09','12:10:00',4.48),('9303','2014-03-09','12:15:00',4.45),('9303','2014-03-09','12:20:00',4.41),('9303','2014-03-09','12:25:00',4.34),('9303','2014-03-09','12:30:00',4.37),('9303','2014-03-09','12:35:00',4.43),('9303','2014-03-09','12:40:00',4.2),('9303','2014-03-09','12:45:00',4.11),('9303','2014-03-09','12:50:00',4.15),('9303','2014-03-09','12:55:00',4.21),('9303','2014-03-09','13:00:00',4.27),('9303','2014-03-09','13:05:00',4.29),('9303','2014-03-09','13:10:00',4.25),('9303','2014-03-09','13:15:00',3.97),('9303','2014-03-09','13:20:00',3.88),('9303','2014-03-09','13:25:00',3.95),('9303','2014-03-09','13:30:00',3.73),('9303','2014-03-09','13:35:00',3.05),('9303','2014-03-09','13:45:00',2),('9303','2014-03-09','13:50:00',3.9),('9303','2014-03-09','13:55:00',2.31),('9303','2014-03-09','14:00:00',3.74),('9303','2014-03-09','14:05:00',3.58),('9303','2014-03-09','14:10:00',3.52),('9303','2014-03-09','14:15:00',3.39),('9303','2014-03-09','14:20:00',2.34),('9303','2014-03-09','14:25:00',2),('9303','2014-03-09','14:35:00',1.08),('9303','2014-03-09','14:40:00',1.59),('9303','2014-03-09','14:45:00',2.98),('9303','2014-03-09','14:50:00',2.78),('9303','2014-03-09','14:55:00',2.98),('9303','2014-03-09','15:00:00',2.89),('9303','2014-03-09','15:05:00',1.97),('9303','2014-03-09','15:10:00',2.73),('9303','2014-03-09','15:15:00',2.61),('9303','2014-03-09','15:20:00',2.57),('9303','2014-03-09','15:25:00',2.54),('9303','2014-03-09','15:30:00',2.45),('9303','2014-03-09','15:35:00',2.28),('9303','2014-03-09','15:40:00',2.1),('9303','2014-03-09','15:45:00',1.65),('9303','2014-03-09','15:55:00',1.63),('9303','2014-03-09','16:00:00',1.79),('9303','2014-03-09','16:05:00',1.58),('9303','2014-03-09','16:10:00',1.29),('9303','2014-03-09','16:20:00',1.14),('9303','2014-03-09','16:25:00',1.2),('9303','2014-03-09','16:30:00',1.11),('9303','2014-03-09','16:35:00',1.06),('9303','2014-03-09','16:40:00',1.03),('9303','2014-03-08','08:00:00',1.09),('9303','2014-03-08','08:05:00',1.2),('9303','2014-03-08','08:10:00',1.3),('9303','2014-03-08','08:15:00',1.41),('9303','2014-03-08','08:20:00',1.53),('9303','2014-03-08','08:25:00',1.64),('9303','2014-03-08','08:30:00',1.72),('9303','2014-03-08','08:35:00',1.83),('9303','2014-03-08','08:40:00',1.92),('9303','2014-03-08','08:45:00',1.99),('9303','2014-03-08','08:50:00',2.09),('9303','2014-03-08','08:55:00',2.19),('9303','2014-03-08','09:00:00',2.27),('9303','2014-03-08','09:05:00',2.35),('9303','2014-03-08','09:10:00',2.42),('9303','2014-03-08','09:15:00',2.49),('9303','2014-03-08','09:20:00',2.58),('9303','2014-03-08','09:25:00',2.65),('9303','2014-03-08','09:30:00',2.71),('9303','2014-03-08','09:35:00',2.78),('9303','2014-03-08','09:40:00',2.84),('9303','2014-03-08','09:45:00',2.9),('9303','2014-03-08','09:50:00',2.93),('9303','2014-03-08','09:55:00',2.99),('9303','2014-03-08','10:00:00',2.99),('9303','2014-03-08','10:05:00',3.03),('9303','2014-03-08','10:10:00',3.11),('9303','2014-03-08','10:15:00',3.16),('9303','2014-03-08','10:20:00',3.24),('9303','2014-03-08','10:25:00',3.27),('9303','2014-03-08','10:30:00',3.35),('9303','2014-03-08','10:35:00',3.4),('9303','2014-03-08','10:40:00',3.44),('9303','2014-03-08','10:45:00',3.48),('9303','2014-03-08','10:50:00',3.51),('9303','2014-03-08','10:55:00',3.52),('9303','2014-03-08','11:00:00',3.57),('9303','2014-03-08','11:05:00',3.61),('9303','2014-03-08','11:10:00',3.62),('9303','2014-03-08','11:15:00',3.65),('9303','2014-03-08','11:20:00',3.74),('9303','2014-03-08','11:25:00',3.86),('9303','2014-03-08','11:30:00',3.92),('9303','2014-03-08','11:35:00',2.14),('9303','2014-03-08','11:40:00',1.96),('9303','2014-03-08','11:45:00',1.27),('9303','2014-03-08','11:50:00',1.42),('9303','2014-03-08','11:55:00',3.88),('9303','2014-03-08','12:00:00',1.91),('9303','2014-03-08','12:10:00',1.06),('9303','2014-03-08','12:15:00',1.13),('9303','2014-03-08','12:20:00',1.29),('9303','2014-03-08','12:25:00',1.4),('9303','2014-03-08','12:30:00',1.56),('9303','2014-03-08','12:35:00',3.41),('9303','2014-03-08','12:40:00',1.83),('9303','2014-03-08','12:45:00',1.73),('9303','2014-03-08','12:50:00',1.73),('9303','2014-03-08','12:55:00',3.03),('9303','2014-03-08','13:00:00',1.75),('9303','2014-03-08','13:05:00',1.51),('9303','2014-03-08','13:10:00',1.28),('9303','2014-03-08','13:30:00',1.71),('9303','2014-03-08','13:35:00',1.52),('9303','2014-03-08','13:40:00',2.33),('9303','2014-03-08','13:45:00',2.68),('9303','2014-03-08','13:50:00',1.8),('9303','2014-03-08','13:55:00',1.28),('9303','2014-03-08','14:00:00',1.01),('9303','2014-03-08','15:20:00',1.51),('9303','2014-03-08','15:25:00',1.76),('9303','2014-03-08','15:30:00',1.08),('9303','2014-03-08','16:05:00',1.23),('9303','2014-03-08','16:35:00',1.14),('9303','2014-04-30','07:55:00',1.03),('9303','2014-04-30','08:00:00',1.13),('9303','2014-04-30','08:05:00',1.21),('9303','2014-04-30','08:10:00',1.36),('9303','2014-04-30','08:15:00',1.46),('9303','2014-04-30','08:20:00',1.54),('9303','2014-04-30','08:25:00',1.64),('9303','2014-04-30','08:30:00',1.73),('9303','2014-04-30','08:35:00',1.81),('9303','2014-04-30','08:40:00',1.89),('9303','2014-04-30','08:45:00',1.97),('9303','2014-04-30','08:50:00',1.79),('9303','2014-04-30','08:55:00',2.12),('9303','2014-04-30','09:00:00',2.32),('9303','2014-04-30','09:05:00',2.46),('9303','2014-04-30','09:10:00',2.75),('9303','2014-04-30','09:15:00',2.81),('9303','2014-04-30','09:20:00',1.14),('9303','2014-04-30','09:25:00',1.38),('9303','2014-04-30','09:30:00',1.95),('9303','2014-04-30','09:35:00',2.46),('9303','2014-04-30','09:40:00',2.37),('9303','2014-04-30','09:45:00',3.12),('9303','2014-04-30','09:50:00',1.72),('9303','2014-04-30','09:55:00',2.66),('9303','2014-04-30','10:00:00',3.44),('9303','2014-04-30','10:05:00',3.54),('9303','2014-04-30','10:10:00',2.2),('9303','2014-04-30','10:15:00',3.41),('9303','2014-04-30','10:20:00',1.83),('9303','2014-04-30','10:25:00',1.59),('9303','2014-04-30','10:30:00',1.57),('9303','2014-04-30','10:35:00',2.16),('9303','2014-04-30','10:40:00',1.98),('9303','2014-04-30','10:45:00',1.6),('9303','2014-04-30','10:50:00',1.32),('9303','2014-04-30','10:55:00',3.58),('9303','2014-04-30','11:00:00',2.63),('9303','2014-04-30','11:05:00',4.08),('9303','2014-04-30','11:10:00',2.82),('9303','2014-04-30','11:15:00',2.82),('9303','2014-04-30','11:20:00',1.62),('9303','2014-04-30','11:25:00',2.51),('9303','2014-04-30','11:30:00',1.94),('9303','2014-04-30','11:35:00',2.02),('9303','2014-04-30','11:40:00',1.91),('9303','2014-04-30','11:45:00',2.33),('9303','2014-04-30','11:50:00',3.58),('9303','2014-04-30','11:55:00',2.45),('9303','2014-04-30','12:00:00',2.54),('9303','2014-04-30','12:05:00',1.39),('9303','2014-04-30','12:10:00',1.27),('9303','2014-04-30','12:15:00',1.79),('9303','2014-04-30','12:20:00',1.95),('9303','2014-04-30','12:25:00',1.36),('9303','2014-04-30','12:30:00',1.28),('9303','2014-04-30','12:35:00',1.32),('9303','2014-04-30','12:40:00',1.19),('9303','2014-04-30','12:45:00',1.75),('9303','2014-04-30','12:50:00',1.54),('9303','2014-04-30','12:55:00',3.97),('9303','2014-04-30','13:00:00',3.92),('9303','2014-04-30','13:05:00',3.97),('9303','2014-04-30','13:10:00',4.45),('9303','2014-04-30','13:15:00',1.87),('9303','2014-04-30','13:20:00',1.83),('9303','2014-04-30','13:25:00',2.31),('9303','2014-04-30','13:30:00',1.79),('9303','2014-04-30','13:35:00',1.79),('9303','2014-04-30','13:40:00',3.53),('9303','2014-04-30','13:45:00',2.95),('9303','2014-04-30','13:50:00',4.06),('9303','2014-04-30','13:55:00',4.65),('9303','2014-04-30','14:00:00',1.84),('9303','2014-04-30','14:05:00',1.73),('9303','2014-04-30','14:10:00',1.55),('9303','2014-04-30','14:15:00',1.8),('9303','2014-04-30','14:20:00',2.95),('9303','2014-04-30','14:25:00',3.02),('9303','2014-04-30','14:30:00',3.86),('9303','2014-04-30','14:35:00',3.88),('9303','2014-04-30','14:40:00',2.02),('9303','2014-04-30','14:45:00',1.32),('9303','2014-04-30','14:50:00',1.58),('9303','2014-04-30','14:55:00',1.77),('9303','2014-04-30','15:00:00',1.43),('9303','2014-04-30','15:05:00',1.4),('9303','2014-04-30','15:10:00',1.35),('9303','2014-04-30','15:15:00',1.23),('9303','2014-04-30','15:20:00',1.19),('9303','2014-04-30','15:25:00',1.37),('9303','2014-04-30','15:30:00',1.71),('9303','2014-04-30','15:35:00',2.36),('9303','2014-04-30','15:40:00',3.91),('9303','2014-04-30','15:45:00',3.9),('9303','2014-04-30','15:50:00',2.51),('9303','2014-04-30','15:55:00',2.63),('9303','2014-04-30','16:00:00',1.33),('9303','2014-04-30','16:05:00',2.03),('9303','2014-04-30','16:10:00',1.74),('9303','2014-04-30','16:15:00',1.85),('9303','2014-04-30','16:20:00',1.37),('9303','2014-04-30','16:25:00',1.57),('9303','2014-04-30','16:30:00',2.06),('9303','2014-04-30','16:35:00',1.32),('9303','2014-04-30','16:40:00',1.98),('9303','2014-04-30','16:45:00',2.64),('9303','2014-04-30','16:50:00',2.9),('9303','2014-04-30','16:55:00',2.43),('9303','2014-04-30','17:00:00',1.29),('9303','2014-04-30','17:05:00',2.39),('9303','2014-04-30','17:10:00',1.33),('9303','2014-04-30','17:40:00',1.01),('9303','2014-03-07','11:45:00',1.61),('9303','2014-03-07','11:50:00',1.65),('9303','2014-03-07','11:55:00',3.6),('9303','2014-03-07','12:00:00',4.65),('9303','2014-03-07','12:05:00',2.86),('9303','2014-03-07','12:10:00',4.38),('9303','2014-03-07','12:15:00',4.19),('9303','2014-03-07','12:20:00',4.23),('9303','2014-03-07','12:25:00',4.17),('9303','2014-03-07','12:30:00',4.18),('9303','2014-03-07','12:35:00',4.1),('9303','2014-03-07','12:40:00',2.77),('9303','2014-03-07','12:45:00',1.88),('9303','2014-03-07','12:50:00',1.77),('9303','2014-03-07','13:05:00',1.61),('9303','2014-03-07','13:15:00',1.21),('9303','2014-03-07','13:20:00',1.89),('9303','2014-03-07','13:25:00',2.34),('9303','2014-03-07','13:30:00',1.97),('9303','2014-03-07','13:35:00',2.61),('9303','2014-03-07','13:40:00',2.85),('9303','2014-03-07','13:45:00',2.07),('9303','2014-03-07','13:50:00',1.36),('9303','2014-03-07','13:55:00',1.1),('9303','2014-03-07','14:00:00',1.05),('9303','2014-03-07','14:10:00',1.02),('9303','2014-03-07','14:15:00',1.01),('9303','2014-03-07','14:30:00',1),('9303','2014-03-07','14:35:00',1.03),('9303','2014-03-07','14:40:00',1.08),('9303','2014-03-07','14:45:00',1.05),('9303','2014-03-07','14:50:00',1.36),('9303','2014-03-07','14:55:00',2.15),('9303','2014-03-07','15:00:00',2.62),('9303','2014-03-07','15:05:00',2.91),('9303','2014-03-07','15:10:00',2.98),('9303','2014-03-07','15:15:00',3.04),('9303','2014-03-07','15:20:00',3.16),('9303','2014-03-07','15:25:00',3.11),('9303','2014-03-07','15:30:00',2.97),('9303','2014-03-07','15:35:00',2.74),('9303','2014-03-07','15:40:00',2.51),('9303','2014-03-07','15:45:00',2.31),('9303','2014-03-07','15:50:00',1.46),('9303','2014-03-07','16:05:00',1.66),('9303','2014-03-07','16:10:00',1.67),('9303','2014-03-07','16:15:00',1.67),('9303','2014-03-07','16:20:00',1.53),('9303','2014-03-07','16:25:00',1.43),('9303','2014-03-07','16:30:00',1.28),('9303','2014-03-07','16:35:00',1.2),('9303','2014-03-07','16:40:00',1.21),('9303','2014-03-07','16:45:00',1.12),('9303','2014-03-07','16:50:00',1.03),('9303','2014-03-06','08:00:00',1.03),('9303','2014-03-06','08:10:00',1.18),('9303','2014-03-06','08:15:00',1.69),('9303','2014-03-06','08:20:00',1.34),('9303','2014-03-06','08:25:00',1.25),('9303','2014-03-06','08:45:00',1.01),('9303','2014-03-06','09:20:00',1.02),('9303','2014-03-06','09:35:00',1.12),('9303','2014-03-06','09:40:00',1.31),('9303','2014-03-06','09:45:00',1.58),('9303','2014-03-06','09:50:00',1.65),('9303','2014-03-06','09:55:00',1.8),('9303','2014-03-06','10:00:00',1.81),('9303','2014-03-06','10:05:00',2.24),('9303','2014-03-06','10:10:00',2.62),('9303','2014-03-06','10:15:00',3.01),('9303','2014-03-06','10:20:00',2.89),('9303','2014-03-06','10:25:00',1.96),('9303','2014-03-06','10:30:00',1.08),('9303','2014-03-06','10:35:00',1.27),('9303','2014-03-06','10:40:00',1.62),('9303','2014-03-06','10:45:00',1.13),('9303','2014-03-06','10:50:00',1.21),('9303','2014-03-06','10:55:00',1.58),('9303','2014-03-06','11:00:00',2.35),('9303','2014-03-06','11:05:00',3.3),('9303','2014-03-06','11:10:00',1.95),('9303','2014-03-06','11:15:00',2.55),('9303','2014-03-06','11:20:00',1.66),('9303','2014-03-06','11:25:00',1.61),('9303','2014-03-06','11:30:00',1.54),('9303','2014-03-06','11:35:00',1.18),('9303','2014-03-06','11:40:00',1.58),('9303','2014-03-06','11:45:00',3.86),('9303','2014-03-06','11:50:00',2.29),('9303','2014-03-06','11:55:00',2.84),('9303','2014-03-06','12:00:00',1.34),('9303','2014-03-06','12:05:00',3.08),('9303','2014-03-06','12:10:00',4.64),('9303','2014-03-06','12:15:00',4.43),('9303','2014-03-06','12:20:00',2.13),('9303','2014-03-06','12:25:00',4.25),('9303','2014-03-06','12:30:00',4.53),('9303','2014-03-06','12:35:00',3.36),('9303','2014-03-06','12:40:00',1.45),('9303','2014-03-06','12:45:00',1.07),('9303','2014-03-06','12:50:00',1.01),('9303','2014-03-06','12:55:00',1.19),('9303','2014-03-06','13:00:00',1.24),('9303','2014-03-06','13:05:00',1.27),('9303','2014-03-06','13:10:00',1.2),('9303','2014-03-06','13:15:00',1.41),('9303','2014-03-06','13:30:00',1.05),('9303','2014-03-06','13:35:00',1.04),('9303','2014-03-06','13:40:00',1.16),('9303','2014-03-06','14:20:00',1.08),('9303','2014-03-06','14:25:00',1.02),('9303','2014-03-06','14:35:00',1.47),('9303','2014-03-06','15:05:00',1.05),('9303','2014-03-06','15:10:00',1.19),('9303','2014-03-06','16:25:00',1.13),('9303','2014-03-06','16:30:00',1.03),('9303','2014-03-05','07:45:00',1.05),('9303','2014-03-05','07:50:00',1.14),('9303','2014-03-05','07:55:00',1.25),('9303','2014-03-05','08:00:00',1.24),('9303','2014-03-05','08:05:00',1.34),('9303','2014-03-05','08:10:00',1.32),('9303','2014-03-05','08:15:00',1.18),('9303','2014-03-05','08:30:00',1.66),('9303','2014-03-05','08:35:00',2.18),('9303','2014-03-05','08:40:00',2.16),('9303','2014-03-05','08:45:00',1.94),('9303','2014-03-05','09:00:00',2.5),('9303','2014-03-05','09:05:00',1.06),('9303','2014-03-05','09:10:00',1.29),('9303','2014-03-05','09:15:00',2.32),('9303','2014-03-05','09:20:00',2.7),('9303','2014-03-05','09:25:00',2.7),('9303','2014-03-05','09:30:00',2.75),('9303','2014-03-05','09:35:00',2.83),('9303','2014-03-05','09:40:00',2.9),('9303','2014-03-05','09:45:00',2.94),('9303','2014-03-05','09:50:00',2.93),('9303','2014-03-05','09:55:00',3),('9303','2014-03-05','10:00:00',3),('9303','2014-03-05','10:05:00',3.05),('9303','2014-03-05','10:10:00',3.08),('9303','2014-03-05','10:15:00',3.11),('9303','2014-03-05','10:20:00',3.17),('9303','2014-03-05','10:25:00',3.18),('9303','2014-03-05','10:30:00',3.24),('9303','2014-03-05','10:35:00',3.24),('9303','2014-03-05','10:40:00',3.32),('9303','2014-03-05','10:45:00',3.35),('9303','2014-03-05','10:50:00',3.37),('9303','2014-03-05','10:55:00',3.42),('9303','2014-03-05','11:00:00',3.48),('9303','2014-03-05','11:05:00',3.57),('9303','2014-03-05','11:10:00',3.58),('9303','2014-03-05','11:15:00',3.66),('9303','2014-03-05','11:20:00',3.68),('9303','2014-03-05','11:25:00',3.71),('9303','2014-03-05','11:30:00',3.81),('9303','2014-03-05','11:35:00',3.94),('9303','2014-03-05','11:40:00',3.89),('9303','2014-03-05','11:45:00',3.93),('9303','2014-03-05','11:50:00',3.82),('9303','2014-03-05','11:55:00',3.37),('9303','2014-03-05','12:00:00',3.39),('9303','2014-03-05','12:05:00',2.59),('9303','2014-03-05','12:10:00',1.47),('9303','2014-03-05','12:30:00',1.16),('9303','2014-03-05','12:35:00',1.33),('9303','2014-03-05','12:40:00',1.31),('9303','2014-03-05','12:45:00',1.23),('9303','2014-03-05','12:50:00',1.54),('9303','2014-03-05','12:55:00',2.06),('9303','2014-03-05','13:00:00',2.05),('9303','2014-03-05','13:05:00',3.09),('9303','2014-03-05','13:10:00',3.76),('9303','2014-03-05','13:15:00',2.43),('9303','2014-03-05','13:20:00',2.5),('9303','2014-03-05','13:25:00',2.12),('9303','2014-03-05','13:30:00',1.15),('9303','2014-03-05','13:35:00',1.26),('9303','2014-03-05','13:40:00',1.45),('9303','2014-03-05','13:45:00',1.33),('9303','2014-03-05','13:50:00',1.13),('9303','2014-03-05','13:55:00',1.07),('9303','2014-03-05','14:05:00',1),('9303','2014-03-05','14:10:00',1.03),('9303','2014-03-05','14:15:00',1.14),('9303','2014-03-05','14:20:00',1.19),('9303','2014-03-05','14:25:00',1.3),('9303','2014-03-05','14:30:00',1.39),('9303','2014-03-05','14:35:00',1.15),('9303','2014-03-05','14:40:00',1.37),('9303','2014-03-05','14:45:00',1.75),('9303','2014-03-05','14:50:00',1.45),('9303','2014-03-05','14:55:00',1.23),('9303','2014-03-05','15:35:00',1.11),('9303','2014-03-05','15:40:00',1.7),('9303','2014-03-05','15:45:00',1.79),('9303','2014-03-05','15:50:00',1.17),('9303','2014-03-05','15:55:00',2.07),('9303','2014-03-05','16:00:00',2.59),('9303','2014-03-05','16:05:00',2.31),('9303','2014-03-05','16:10:00',1.8),('9303','2014-03-05','16:15:00',1.11),('9303','2014-03-04','09:10:00',1.49),('9303','2014-03-04','09:15:00',2),('9303','2014-03-04','09:20:00',2.54),('9303','2014-03-04','09:40:00',1.06),('9303','2014-03-04','09:45:00',1.26),('9303','2014-03-04','09:55:00',1.36),('9303','2014-03-04','10:00:00',1.33),('9303','2014-03-04','10:25:00',2.04),('9303','2014-03-04','10:30:00',1.89),('9303','2014-03-04','10:35:00',2.73),('9303','2014-03-04','10:40:00',3.9),('9303','2014-03-04','10:45:00',3.88),('9303','2014-03-04','10:50:00',1.46),('9303','2014-03-04','10:55:00',2.59),('9303','2014-03-04','11:00:00',3.03),('9303','2014-03-04','11:05:00',1.98),('9303','2014-03-04','11:10:00',3.4),('9303','2014-03-04','11:15:00',4.49),('9303','2014-03-04','11:20:00',3.14),('9303','2014-03-04','11:45:00',1.58),('9303','2014-03-04','11:50:00',3.74),('9303','2014-03-04','11:55:00',3.75),('9303','2014-03-04','12:00:00',3.86),('9303','2014-03-04','12:05:00',3.83),('9303','2014-03-04','12:10:00',3.78),('9303','2014-03-04','12:15:00',3.75),('9303','2014-03-04','12:20:00',3.8),('9303','2014-03-04','12:25:00',3.83),('9303','2014-03-04','12:30:00',3.8),('9303','2014-03-04','12:35:00',3.77),('9303','2014-03-04','12:40:00',3.78),('9303','2014-03-04','12:45:00',2.89),('9303','2014-03-04','12:50:00',3.74),('9303','2014-03-04','12:55:00',2.56),('9303','2014-03-04','13:00:00',3.57),('9303','2014-03-04','13:05:00',2.97),('9303','2014-03-04','13:10:00',3.92),('9303','2014-03-04','13:15:00',3.16),('9303','2014-03-04','13:20:00',1.53),('9303','2014-03-04','13:50:00',1.04),('9303','2014-03-04','13:55:00',1.15),('9303','2014-03-04','14:05:00',1.37),('9303','2014-03-04','14:10:00',3.11),('9303','2014-03-04','14:15:00',3),('9303','2014-03-04','14:20:00',2.1),('9303','2014-03-04','14:25:00',3.57),('9303','2014-03-04','14:30:00',3.24),('9303','2014-03-04','14:35:00',3.12),('9303','2014-03-04','14:40:00',3.05),('9303','2014-03-04','14:45:00',2.82),('9303','2014-03-04','14:50:00',3.1),('9303','2014-03-04','14:55:00',2.11),('9303','2014-03-04','15:00:00',3.14),('9303','2014-03-04','15:05:00',2.85),('9303','2014-03-04','15:10:00',2.69),('9303','2014-03-04','15:15:00',2.44),('9303','2014-03-04','15:20:00',1.68),('9303','2014-03-04','15:25:00',1.89),('9303','2014-03-04','15:35:00',2.45),('9303','2014-03-04','15:40:00',2.34),('9303','2014-03-04','15:45:00',2.14),('9303','2014-03-04','16:25:00',1.1),('9303','2014-03-03','08:10:00',1.24),('9303','2014-03-03','08:15:00',1.38),('9303','2014-03-03','08:20:00',1.46),('9303','2014-03-03','08:25:00',1.55),('9303','2014-03-03','08:30:00',1.66),('9303','2014-03-03','08:35:00',1.73),('9303','2014-03-03','08:40:00',1.87),('9303','2014-03-03','08:45:00',1.94),('9303','2014-03-03','08:50:00',1.91),('9303','2014-03-03','08:55:00',2.21),('9303','2014-03-03','09:00:00',2.26),('9303','2014-03-03','09:05:00',2.3),('9303','2014-03-03','09:10:00',2.2),('9303','2014-03-03','09:15:00',2.23),('9303','2014-03-03','09:20:00',2.43),('9303','2014-03-03','09:25:00',2.58),('9303','2014-03-03','09:30:00',2.48),('9303','2014-03-03','09:35:00',2.22),('9303','2014-03-03','09:40:00',2.12),('9303','2014-03-03','09:45:00',2.12),('9303','2014-03-03','09:50:00',2.17),('9303','2014-03-03','09:55:00',2.52),('9303','2014-03-03','10:00:00',2.78),('9303','2014-03-03','10:05:00',2.94),('9303','2014-03-03','10:10:00',2.89),('9303','2014-03-03','10:15:00',2.95),('9303','2014-03-03','10:20:00',3),('9303','2014-03-03','10:25:00',3.03),('9303','2014-03-03','10:30:00',3.09),('9303','2014-03-03','10:35:00',3.12),('9303','2014-03-03','10:40:00',3.14),('9303','2014-03-03','10:45:00',3.17),('9303','2014-03-03','10:50:00',3.18),('9303','2014-03-03','10:55:00',3.25),('9303','2014-03-03','11:00:00',3.25),('9303','2014-03-03','11:05:00',3.3),('9303','2014-03-03','11:10:00',3.39),('9303','2014-03-03','11:15:00',3.34),('9303','2014-03-03','11:20:00',3.42),('9303','2014-03-03','11:25:00',3.46),('9303','2014-03-03','11:30:00',3.48),('9303','2014-03-03','11:35:00',3.47),('9303','2014-03-03','11:40:00',3.53),('9303','2014-03-03','11:45:00',3.59),('9303','2014-03-03','11:50:00',3.69),('9303','2014-03-03','11:55:00',3.67),('9303','2014-03-03','12:00:00',3.66),('9303','2014-03-03','12:05:00',3.72),('9303','2014-03-03','12:10:00',3.65),('9303','2014-03-03','12:15:00',3.65),('9303','2014-03-03','12:20:00',3.72),('9303','2014-03-03','12:25:00',3.72),('9303','2014-03-03','12:30:00',3.72),('9303','2014-03-03','12:35:00',3.76),('9303','2014-03-03','12:40:00',3.78),('9303','2014-03-03','12:45:00',3.75),('9303','2014-03-03','12:50:00',3.83),('9303','2014-03-03','12:55:00',3.81),('9303','2014-03-03','13:00:00',3.78),('9303','2014-03-03','13:05:00',3.69),('9303','2014-03-03','13:10:00',3.69),('9303','2014-03-03','13:15:00',3.66),('9303','2014-03-03','13:20:00',3.64),('9303','2014-03-03','13:25:00',3.63),('9303','2014-03-03','13:30:00',3.63),('9303','2014-03-03','13:35:00',3.59),('9303','2014-03-03','13:40:00',3.52),('9303','2014-03-03','13:45:00',3.51),('9303','2014-03-03','13:50:00',3.49),('9303','2014-03-03','13:55:00',3.4),('9303','2014-03-03','14:00:00',3.35),('9303','2014-03-03','14:05:00',3.33),('9303','2014-03-03','14:10:00',3.41),('9303','2014-03-03','14:15:00',3.36),('9303','2014-03-03','14:20:00',3.26),('9303','2014-03-03','14:25:00',3.03),('9303','2014-03-03','14:30:00',3.12),('9303','2014-03-03','14:35:00',3.06),('9303','2014-03-03','14:40:00',2.99),('9303','2014-03-03','14:45:00',2.89),('9303','2014-03-03','14:50:00',2.86),('9303','2014-03-03','14:55:00',2.79),('9303','2014-03-03','15:00:00',2.8),('9303','2014-03-03','15:05:00',2.68),('9303','2014-03-03','15:10:00',2.65),('9303','2014-03-03','15:15:00',2.54),('9303','2014-03-03','15:20:00',2.5),('9303','2014-03-03','15:25:00',2.42),('9303','2014-03-03','15:30:00',2.28),('9303','2014-03-03','15:35:00',2.17),('9303','2014-03-03','15:40:00',2.05),('9303','2014-03-03','15:45:00',1.97),('9303','2014-03-03','15:50:00',1.89),('9303','2014-03-03','15:55:00',1.8),('9303','2014-03-03','16:00:00',1.67),('9303','2014-03-03','16:05:00',1.58),('9303','2014-03-03','16:10:00',1.49),('9303','2014-03-03','16:15:00',1.4),('9303','2014-03-03','16:20:00',1.33),('9303','2014-03-03','16:25:00',1.22),('9303','2014-03-03','16:30:00',1.11),('9303','2014-03-03','16:35:00',1.01),('9303','2014-03-02','08:00:00',1.12),('9303','2014-03-02','08:05:00',1.23),('9303','2014-03-02','08:10:00',1.76),('9303','2014-03-02','08:15:00',1.79),('9303','2014-03-02','08:20:00',1.73),('9303','2014-03-02','08:25:00',1.6),('9303','2014-03-02','08:30:00',1.53),('9303','2014-03-02','08:35:00',1.7),('9303','2014-03-02','08:40:00',1.83),('9303','2014-03-02','08:45:00',1.94),('9303','2014-03-02','08:50:00',2.05),('9303','2014-03-02','08:55:00',2.15),('9303','2014-03-02','09:00:00',2.24),('9303','2014-03-02','09:05:00',2.32),('9303','2014-03-02','09:10:00',2.44),('9303','2014-03-02','09:15:00',2.54),('9303','2014-03-02','09:20:00',1.91),('9303','2014-03-02','09:25:00',2.5),('9303','2014-03-02','09:30:00',2.87),('9303','2014-03-02','09:35:00',2.88),('9303','2014-03-02','09:40:00',2.43),('9303','2014-03-02','09:45:00',1.19),('9303','2014-03-02','10:00:00',1.28),('9303','2014-03-02','10:05:00',1.42),('9303','2014-03-02','10:10:00',1.38),('9303','2014-03-02','10:15:00',1.15),('9303','2014-03-02','10:20:00',1.16),('9303','2014-03-02','10:25:00',1.29),('9303','2014-03-02','10:30:00',1.42),('9303','2014-03-02','10:35:00',1.88),('9303','2014-03-02','10:40:00',3.27),('9303','2014-03-02','10:45:00',1.4),('9303','2014-03-02','10:50:00',1.01),('9303','2014-03-02','10:55:00',1.16),('9303','2014-03-02','11:00:00',1.79),('9303','2014-03-02','11:05:00',3.62),('9303','2014-03-02','11:10:00',1.52),('9303','2014-03-02','11:15:00',1.13),('9303','2014-03-02','11:20:00',1.45),('9303','2014-03-02','11:25:00',1.87),('9303','2014-03-02','11:30:00',1.88),('9303','2014-03-02','11:35:00',2.62),('9303','2014-03-02','11:40:00',3.04),('9303','2014-03-02','11:45:00',3.14),('9303','2014-03-02','11:50:00',4.44),('9303','2014-03-02','11:55:00',4.27),('9303','2014-03-02','12:00:00',3.04),('9303','2014-03-02','12:05:00',1.96),('9303','2014-03-02','12:10:00',1.61),('9303','2014-03-02','12:15:00',2.9),('9303','2014-03-02','12:20:00',2.25),('9303','2014-03-02','12:25:00',1.85),('9303','2014-03-02','12:30:00',1.38),('9303','2014-03-02','12:35:00',1.08),('9303','2014-03-02','12:55:00',1.15),('9303','2014-03-02','13:00:00',1.37),('9303','2014-03-02','13:05:00',1.46),('9303','2014-03-02','13:10:00',1.47),('9303','2014-03-02','13:15:00',1.41),('9303','2014-03-02','13:20:00',1.34),('9303','2014-03-02','13:25:00',1.2),('9303','2014-03-02','13:30:00',1.06),('9303','2014-03-02','14:00:00',1.12),('9303','2014-03-02','14:05:00',1.27),('9303','2014-03-02','14:10:00',1.24),('9303','2014-03-02','14:15:00',1.2),('9303','2014-03-02','14:20:00',1.12),('9303','2014-03-02','14:25:00',1.12),('9303','2014-03-02','14:30:00',1.18),('9303','2014-03-02','14:35:00',1.18),('9303','2014-03-02','14:40:00',1.18),('9303','2014-03-02','14:45:00',1.24),('9303','2014-03-02','14:50:00',1.23),('9303','2014-03-02','14:55:00',1.2),('9303','2014-03-02','15:00:00',1.29),('9303','2014-03-02','15:05:00',1.34),('9303','2014-03-02','15:10:00',1.4),('9303','2014-03-02','15:15:00',1.33),('9303','2014-03-02','15:20:00',1.16),('9303','2014-03-02','15:25:00',1.4),('9303','2014-03-02','15:30:00',1.33),('9303','2014-03-02','15:35:00',1.24),('9303','2014-03-02','15:40:00',1.3),('9303','2014-03-02','15:45:00',1.16),('9303','2014-03-02','15:50:00',1.02),('9303','2014-02-28','08:00:00',1.15),('9303','2014-02-28','08:15:00',1.1),('9303','2014-02-28','08:20:00',1.75),('9303','2014-02-28','08:25:00',1.35),('9303','2014-02-28','08:35:00',1.44),('9303','2014-02-28','09:15:00',1),('9303','2014-02-28','09:20:00',1.02),('9303','2014-02-28','09:25:00',1.13),('9303','2014-02-28','09:30:00',1.73),('9303','2014-02-28','09:35:00',1.01),('9303','2014-02-28','09:40:00',2.11),('9303','2014-02-28','09:45:00',2.78),('9303','2014-02-28','09:50:00',3.39),('9303','2014-02-28','09:55:00',2.58),('9303','2014-02-28','10:00:00',1.17),('9303','2014-02-28','10:10:00',1.4),('9303','2014-02-28','10:15:00',1.14),('9303','2014-02-28','10:20:00',1.56),('9303','2014-02-28','10:25:00',2.72),('9303','2014-02-28','10:30:00',3.43),('9303','2014-02-28','10:35:00',2.18),('9303','2014-02-28','10:40:00',1.16),('9303','2014-02-28','11:20:00',1.23),('9303','2014-02-28','11:25:00',1.3),('9303','2014-02-28','11:30:00',1.16),('9303','2014-02-28','11:55:00',1),('9303','2014-02-28','12:00:00',1.25),('9303','2014-02-28','12:05:00',1.74),('9303','2014-02-28','12:10:00',1.87),('9303','2014-02-28','12:25:00',1.84),('9303','2014-02-28','12:30:00',2.1),('9303','2014-02-28','12:35:00',3.16),('9303','2014-02-28','12:40:00',3.21),('9303','2014-02-28','12:45:00',1.18),('9303','2014-02-28','12:50:00',3.03),('9303','2014-02-28','12:55:00',2.37),('9303','2014-02-28','13:00:00',2.5),('9303','2014-02-28','13:05:00',1.57),('9303','2014-02-28','13:10:00',1.47),('9303','2014-02-28','13:15:00',1.06),('9303','2014-02-28','13:50:00',2.81),('9303','2014-02-28','13:55:00',2.46),('9303','2014-02-28','14:00:00',1.11),('9303','2014-02-28','14:20:00',1.23),('9303','2014-02-28','14:25:00',1.64),('9303','2014-02-28','14:30:00',1.69),('9303','2014-02-28','14:35:00',1.4),('9303','2014-02-28','14:40:00',1.21),('9303','2014-02-28','14:45:00',1.21),('9303','2014-02-28','14:50:00',1.28),('9303','2014-02-28','14:55:00',1.39),('9303','2014-02-28','15:00:00',2.14),('9303','2014-02-28','15:05:00',1.55),('9303','2014-02-28','15:25:00',2.47),('9303','2014-02-28','15:30:00',1.68),('9303','2014-02-28','15:35:00',1.93),('9303','2014-02-28','15:40:00',1.86),('9303','2014-02-28','16:15:00',1.65),('9303','2014-02-28','16:20:00',1.5),('9303','2014-02-28','16:40:00',1),('9303','2014-02-28','16:45:00',1.12),('9303','2014-02-27','10:40:00',1.08),('9303','2014-02-27','10:45:00',1.19),('9303','2014-02-27','10:50:00',1.23),('9303','2014-02-27','10:55:00',1.32),('9303','2014-02-27','11:00:00',1.52),('9303','2014-02-27','11:05:00',1.66),('9303','2014-02-27','11:10:00',1.52),('9303','2014-02-27','11:15:00',1.47),('9303','2014-02-27','11:20:00',1.36),('9303','2014-02-27','11:25:00',1.45),('9303','2014-02-27','11:30:00',1.83),('9303','2014-02-27','11:35:00',1.76),('9303','2014-02-27','11:40:00',1.44),('9303','2014-02-27','11:45:00',1.24),('9303','2014-02-27','11:50:00',1.17),('9303','2014-02-27','11:55:00',1.21),('9303','2014-02-27','12:00:00',1.19),('9303','2014-02-27','12:05:00',1.19),('9303','2014-02-27','12:10:00',1.09),('9303','2014-02-27','12:15:00',1.15),('9303','2014-02-27','12:20:00',1.22),('9303','2014-02-27','12:25:00',1.25),('9303','2014-02-27','12:30:00',1.17),('9303','2014-02-27','12:35:00',1.14),('9303','2014-02-27','12:40:00',1.1),('9303','2014-02-27','12:45:00',1.08),('9303','2014-02-27','12:50:00',1.06),('9303','2014-02-27','12:55:00',1.08),('9303','2014-02-27','13:00:00',1.14),('9303','2014-02-27','13:10:00',1.02),('9303','2014-02-27','13:15:00',1.16),('9303','2014-02-27','13:20:00',1.18),('9303','2014-02-27','13:25:00',1.27),('9303','2014-02-27','13:30:00',1.44),('9303','2014-02-27','13:35:00',1.58),('9303','2014-02-27','13:40:00',1.61),('9303','2014-02-27','13:45:00',1.6),('9303','2014-02-27','13:50:00',1.66),('9303','2014-02-27','13:55:00',1.84),('9303','2014-02-27','14:00:00',1.88),('9303','2014-02-27','14:05:00',1.64),('9303','2014-02-27','14:10:00',1.48),('9303','2014-02-27','14:15:00',1.31),('9303','2014-02-27','14:20:00',1.33),('9303','2014-02-27','14:25:00',1.34),('9303','2014-02-27','14:30:00',1.46),('9303','2014-02-27','14:35:00',1.42),('9303','2014-02-27','14:40:00',1.2),('9303','2014-02-27','14:45:00',1.24),('9303','2014-02-27','14:50:00',1.17),('9303','2014-02-27','14:55:00',1.04),('9303','2014-02-27','15:00:00',1.1),('9303','2014-02-27','15:05:00',1.06),('9303','2014-02-27','15:10:00',1.08),('9303','2014-02-27','15:15:00',1.25),('9303','2014-02-27','15:20:00',1.25),('9303','2014-02-27','15:25:00',1.25),('9303','2014-02-27','15:30:00',1.22),('9303','2014-02-27','15:35:00',1.22),('9303','2014-02-26','08:15:00',1),('9303','2014-02-26','08:20:00',1.11),('9303','2014-02-26','08:25:00',1.32),('9303','2014-02-26','08:30:00',1.43),('9303','2014-02-26','08:35:00',1.58),('9303','2014-02-26','08:40:00',1.69),('9303','2014-02-26','08:45:00',1.91),('9303','2014-02-26','08:50:00',1.75),('9303','2014-02-26','08:55:00',1.69),('9303','2014-02-26','09:00:00',1.97),('9303','2014-02-26','09:05:00',1.99),('9303','2014-02-26','09:10:00',2.09),('9303','2014-02-26','09:15:00',2.25),('9303','2014-02-26','09:20:00',2.32),('9303','2014-02-26','09:25:00',2.42),('9303','2014-02-26','09:30:00',2.02),('9303','2014-02-26','09:35:00',1.93),('9303','2014-02-26','09:40:00',1.81),('9303','2014-02-26','09:45:00',1.92),('9303','2014-02-26','09:50:00',1.47),('9303','2014-02-26','09:55:00',1.49),('9303','2014-02-26','10:00:00',1.28),('9303','2014-02-26','10:05:00',1.04),('9303','2014-02-26','12:00:00',1.08),('9303','2014-02-26','12:05:00',1.42),('9303','2014-02-26','12:10:00',1.33),('9303','2014-02-26','12:15:00',1.16),('9303','2014-02-26','12:25:00',1.2),('9303','2014-02-26','12:30:00',1.69),('9303','2014-02-26','12:35:00',2.22),('9303','2014-02-26','12:40:00',2.04),('9303','2014-02-26','12:45:00',3.05),('9303','2014-02-26','12:50:00',3.77),('9303','2014-02-26','12:55:00',3.61),('9303','2014-02-26','13:00:00',3.46),('9303','2014-02-26','13:05:00',2.37),('9303','2014-02-26','13:10:00',2.92),('9303','2014-02-26','13:15:00',2.86),('9303','2014-02-26','13:20:00',2.45),('9303','2014-02-26','13:25:00',2.07),('9303','2014-02-26','13:30:00',2.32),('9303','2014-02-26','13:35:00',1.79),('9303','2014-02-26','13:40:00',1.66),('9303','2014-02-26','13:45:00',1.79),('9303','2014-02-26','13:50:00',1.46),('9303','2014-02-26','13:55:00',1.2),('9303','2014-02-26','14:00:00',3.31),('9303','2014-02-26','14:05:00',2.32),('9303','2014-02-26','14:10:00',1.03),('9303','2014-02-26','14:15:00',1.06),('9303','2014-02-26','14:20:00',3.25),('9303','2014-02-26','14:25:00',3.1),('9303','2014-02-26','14:30:00',1.68),('9303','2014-02-26','14:35:00',1.31),('9303','2014-02-26','14:40:00',3.01),('9303','2014-02-26','14:45:00',2.74),('9303','2014-02-26','14:50:00',2.54),('9303','2014-02-26','14:55:00',2.95),('9303','2014-02-26','15:00:00',2.73),('9303','2014-02-26','15:05:00',2.56),('9303','2014-02-26','15:10:00',2.57),('9303','2014-02-26','15:15:00',2.25),('9303','2014-02-26','15:20:00',1.6),('9303','2014-02-26','15:35:00',1.55),('9303','2014-02-26','15:40:00',1.54),('9303','2014-02-26','15:45:00',1.28),('9303','2014-02-26','15:50:00',1.15),('9303','2014-02-26','15:55:00',1.34),('9303','2014-02-26','16:00:00',1.48),('9303','2014-02-26','16:05:00',1.06),('9303','2014-02-26','16:10:00',1.05),('9303','2014-04-29','09:55:00',1.05),('9303','2014-04-29','10:00:00',1.06),('9303','2014-04-29','10:05:00',1.51),('9303','2014-04-29','10:10:00',2.96),('9303','2014-04-29','10:15:00',3.48),('9303','2014-04-29','10:20:00',3.29),('9303','2014-04-29','10:25:00',3.74),('9303','2014-04-29','10:30:00',3.81),('9303','2014-04-29','10:35:00',3.77),('9303','2014-04-29','10:40:00',3.74),('9303','2014-04-29','10:45:00',3.73),('9303','2014-04-29','10:50:00',3.82),('9303','2014-04-29','10:55:00',3.63),('9303','2014-04-29','11:00:00',3.86),('9303','2014-04-29','11:05:00',3.82),('9303','2014-04-29','11:10:00',3.99),('9303','2014-04-29','11:15:00',3.78),('9303','2014-04-29','11:20:00',4.15),('9303','2014-04-29','11:25:00',4.19),('9303','2014-04-29','11:30:00',4.03),('9303','2014-04-29','11:35:00',3.69),('9303','2014-04-29','11:40:00',2.93),('9303','2014-04-29','11:45:00',1.72),('9303','2014-04-29','11:50:00',1.6),('9303','2014-04-29','11:55:00',1.09),('9303','2014-04-29','12:00:00',1.31),('9303','2014-04-29','12:05:00',1.85),('9303','2014-04-29','12:10:00',1.74),('9303','2014-04-29','12:15:00',1.74),('9303','2014-04-29','12:20:00',2.18),('9303','2014-04-29','12:25:00',3.07),('9303','2014-04-29','12:30:00',2.36),('9303','2014-04-29','12:35:00',1.52),('9303','2014-04-29','12:40:00',1.82),('9303','2014-04-29','12:45:00',2.76),('9303','2014-04-29','12:50:00',3.61),('9303','2014-04-29','12:55:00',1.7),('9303','2014-04-29','13:00:00',1.83),('9303','2014-04-29','13:05:00',1.74),('9303','2014-04-29','13:10:00',1.81),('9303','2014-04-29','13:15:00',2.98),('9303','2014-04-29','13:20:00',2.03),('9303','2014-04-29','13:25:00',3.28),('9303','2014-04-29','13:30:00',1.93),('9303','2014-04-29','13:35:00',2.33),('9303','2014-04-29','13:40:00',1.54),('9303','2014-04-29','13:45:00',1.96),('9303','2014-04-29','13:50:00',1.38),('9303','2014-04-29','16:20:00',1.01),('9303','2014-04-29','16:25:00',1.07),('9303','2014-04-29','17:05:00',1.14),('9303','2014-04-29','17:10:00',1.08),('9303','2014-04-29','17:25:00',1.66),('9303','2014-04-29','17:30:00',1.91),('9303','2014-04-29','17:35:00',1.34),('9303','2014-04-29','17:40:00',1.03),('9303','2014-04-29','17:45:00',1.71),('9303','2014-02-25','08:25:00',1.13),('9303','2014-02-25','08:30:00',1.36),('9303','2014-02-25','08:35:00',1.47),('9303','2014-02-25','08:40:00',1.58),('9303','2014-02-25','08:45:00',1.66),('9303','2014-02-25','08:50:00',1.76),('9303','2014-02-25','08:55:00',1.86),('9303','2014-02-25','09:00:00',1.96),('9303','2014-02-25','09:05:00',2.04),('9303','2014-02-25','09:10:00',2.13),('9303','2014-02-25','09:15:00',2.22),('9303','2014-02-25','09:20:00',2.29),('9303','2014-02-25','09:25:00',2.37),('9303','2014-02-25','09:30:00',2.43),('9303','2014-02-25','09:35:00',2.47),('9303','2014-02-25','09:40:00',2.53),('9303','2014-02-25','09:45:00',2.55),('9303','2014-02-25','09:50:00',2.58),('9303','2014-02-25','09:55:00',2.63),('9303','2014-02-25','10:00:00',2.67),('9303','2014-02-25','10:05:00',2.68),('9303','2014-02-25','10:10:00',2.72),('9303','2014-02-25','10:15:00',2.77),('9303','2014-02-25','10:20:00',2.79),('9303','2014-02-25','10:25:00',2.87),('9303','2014-02-25','10:30:00',2.89),('9303','2014-02-25','10:35:00',2.98),('9303','2014-02-25','10:40:00',2.96),('9303','2014-02-25','10:45:00',2.96),('9303','2014-02-25','10:50:00',3.03),('9303','2014-02-25','10:55:00',3.02),('9303','2014-02-25','11:00:00',3.08),('9303','2014-02-25','11:05:00',3.12),('9303','2014-02-25','11:10:00',3.09),('9303','2014-02-25','11:15:00',3.15),('9303','2014-02-25','11:20:00',3.12),('9303','2014-02-25','11:25:00',3.19),('9303','2014-02-25','11:30:00',3.21),('9303','2014-02-25','11:35:00',3.21),('9303','2014-02-25','11:40:00',3.15),('9303','2014-02-25','11:45:00',3.23),('9303','2014-02-25','11:50:00',3.23),('9303','2014-02-25','11:55:00',3.26),('9303','2014-02-25','12:00:00',3.28),('9303','2014-02-25','12:05:00',3.29),('9303','2014-02-25','12:10:00',3.31),('9303','2014-02-25','12:15:00',3.3),('9303','2014-02-25','12:20:00',3.27),('9303','2014-02-25','12:25:00',3.38),('9303','2014-02-25','12:30:00',3.39),('9303','2014-02-25','12:35:00',3.43),('9303','2014-02-25','12:40:00',3.47),('9303','2014-02-25','12:45:00',3.5),('9303','2014-02-25','12:50:00',3.44),('9303','2014-02-25','12:55:00',3.44),('9303','2014-02-25','13:00:00',3.45),('9303','2014-02-25','13:05:00',3.33),('9303','2014-02-25','13:10:00',3.27),('9303','2014-02-25','13:15:00',3.07),('9303','2014-02-25','13:20:00',2.24),('9303','2014-02-25','13:40:00',1.41),('9303','2014-02-25','13:45:00',1.23),('9303','2014-02-25','13:50:00',1.03),('9303','2014-02-25','13:55:00',1.13),('9303','2014-02-25','14:00:00',1.27),('9303','2014-02-25','14:05:00',1.22),('9303','2014-02-25','14:10:00',1.02),('9303','2014-02-25','14:15:00',1.09),('9303','2014-02-25','14:20:00',1.11),('9303','2014-02-25','14:25:00',1.77),('9303','2014-02-25','14:30:00',2.58),('9303','2014-02-25','14:35:00',2.13),('9303','2014-02-25','14:40:00',2.81),('9303','2014-02-25','14:45:00',2.82),('9303','2014-02-25','14:50:00',2.64),('9303','2014-02-25','14:55:00',2.47),('9303','2014-02-25','15:00:00',2.4),('9303','2014-02-25','15:05:00',2.36),('9303','2014-02-25','15:10:00',2.3),('9303','2014-02-25','15:15:00',2.26),('9303','2014-02-25','15:20:00',2.16),('9303','2014-02-25','15:25:00',1.82),('9303','2014-02-25','15:30:00',1.61),('9303','2014-02-25','15:35:00',1.47),('9303','2014-02-25','15:40:00',1.56),('9303','2014-02-24','08:10:00',1.04),('9303','2014-02-24','08:15:00',1.19),('9303','2014-02-24','08:20:00',1.34),('9303','2014-02-24','08:25:00',1.49),('9303','2014-02-24','08:30:00',1.49),('9303','2014-02-24','08:35:00',1.8),('9303','2014-02-24','08:40:00',1.78),('9303','2014-02-24','08:45:00',1.69),('9303','2014-02-24','08:50:00',1.91),('9303','2014-02-24','08:55:00',1.88),('9303','2014-02-24','09:00:00',1.94),('9303','2014-02-24','09:05:00',2.01),('9303','2014-02-24','09:10:00',2.09),('9303','2014-02-24','09:15:00',2.17),('9303','2014-02-24','09:20:00',2.25),('9303','2014-02-24','09:25:00',2.38),('9303','2014-02-24','09:30:00',2.45),('9303','2014-02-24','09:35:00',2.51),('9303','2014-02-24','09:40:00',2.54),('9303','2014-02-24','09:45:00',2.58),('9303','2014-02-24','09:50:00',2.61),('9303','2014-02-24','09:55:00',2.66),('9303','2014-02-24','10:00:00',2.69),('9303','2014-02-24','10:05:00',2.74),('9303','2014-02-24','10:10:00',2.8),('9303','2014-02-24','10:15:00',2.82),('9303','2014-02-24','10:20:00',2.84),('9303','2014-02-24','10:25:00',2.91),('9303','2014-02-24','10:30:00',2.94),('9303','2014-02-24','10:35:00',3),('9303','2014-02-24','10:40:00',3.04),('9303','2014-02-24','10:45:00',3.07),('9303','2014-02-24','10:50:00',3.14),('9303','2014-02-24','10:55:00',3.12),('9303','2014-02-24','11:00:00',3.16),('9303','2014-02-24','11:05:00',3.21),('9303','2014-02-24','11:10:00',3.23),('9303','2014-02-24','11:15:00',3.27),('9303','2014-02-24','11:20:00',3.3),('9303','2014-02-24','11:25:00',3.46),('9303','2014-02-24','11:30:00',3.65),('9303','2014-02-24','11:35:00',2.69),('9303','2014-02-24','11:40:00',2.44),('9303','2014-02-24','11:45:00',3.15),('9303','2014-02-24','11:50:00',3.05),('9303','2014-02-24','11:55:00',2.96),('9303','2014-02-24','12:00:00',3.2),('9303','2014-02-24','12:05:00',3.35),('9303','2014-02-24','12:10:00',2.21),('9303','2014-02-24','12:15:00',2.13),('9303','2014-02-24','12:20:00',2.17),('9303','2014-02-24','12:25:00',3.64),('9303','2014-02-24','12:30:00',3.76),('9303','2014-02-24','12:35:00',3.29),('9303','2014-02-24','12:40:00',3.94),('9303','2014-02-24','12:45:00',3.79),('9303','2014-02-24','12:50:00',3.67),('9303','2014-02-24','12:55:00',3.45),('9303','2014-02-24','13:00:00',3.73),('9303','2014-02-24','13:05:00',2.9),('9303','2014-02-24','13:10:00',4.14),('9303','2014-02-24','13:15:00',2.41),('9303','2014-02-24','13:20:00',1.01),('9303','2014-02-24','14:45:00',1),('9303','2014-02-24','15:20:00',1.08),('9303','2014-02-24','15:25:00',1.23),('9303','2014-02-24','15:30:00',1.12),('9303','2014-02-24','15:35:00',1.94),('9303','2014-02-24','15:40:00',2.43),('9303','2014-02-24','15:45:00',2.3),('9303','2014-02-24','15:50:00',1.57),('9303','2014-02-24','15:55:00',1.82),('9303','2014-02-24','16:00:00',1.96),('9303','2014-02-24','16:05:00',1.81),('9303','2014-02-24','16:10:00',1.63),('9303','2014-02-24','16:15:00',1.42),('9303','2014-02-24','16:20:00',1.12),('9303','2014-02-23','08:25:00',1.02),('9303','2014-02-23','08:30:00',1.09),('9303','2014-02-23','08:35:00',1.17),('9303','2014-02-23','08:40:00',1.31),('9303','2014-02-23','08:45:00',1.58),('9303','2014-02-23','08:50:00',1.71),('9303','2014-02-23','08:55:00',1.8),('9303','2014-02-23','09:00:00',1.89),('9303','2014-02-23','09:05:00',2),('9303','2014-02-23','09:10:00',2.09),('9303','2014-02-23','09:15:00',2.2),('9303','2014-02-23','09:20:00',2.29),('9303','2014-02-23','09:25:00',2.3),('9303','2014-02-23','09:30:00',2.18),('9303','2014-02-23','09:35:00',2.48),('9303','2014-02-23','09:40:00',2.51),('9303','2014-02-23','09:45:00',2.55),('9303','2014-02-23','09:50:00',2.55),('9303','2014-02-23','09:55:00',2.6),('9303','2014-02-23','10:00:00',2.6),('9303','2014-02-23','10:05:00',2.63),('9303','2014-02-23','10:10:00',2.65),('9303','2014-02-23','10:15:00',2.67),('9303','2014-02-23','10:20:00',2.75),('9303','2014-02-23','10:25:00',2.8),('9303','2014-02-23','10:30:00',2.84),('9303','2014-02-23','10:35:00',2.92),('9303','2014-02-23','10:40:00',2.95),('9303','2014-02-23','10:45:00',2.91),('9303','2014-02-23','10:50:00',3.02),('9303','2014-02-23','10:55:00',3.02),('9303','2014-02-23','11:00:00',2.21),('9303','2014-02-23','11:05:00',2.44),('9303','2014-02-23','11:10:00',3.2),('9303','2014-02-23','11:15:00',3.18),('9303','2014-02-23','11:20:00',3.04),('9303','2014-02-23','11:25:00',3.31),('9303','2014-02-23','11:30:00',3.42),('9303','2014-02-23','11:35:00',3.4),('9303','2014-02-23','11:40:00',3.46),('9303','2014-02-23','11:45:00',3.5),('9303','2014-02-23','11:50:00',3.31),('9303','2014-02-23','11:55:00',2.53),('9303','2014-02-23','12:00:00',3.25),('9303','2014-02-23','12:05:00',3.63),('9303','2014-02-23','12:10:00',3.43),('9303','2014-02-23','12:15:00',3.73),('9303','2014-02-23','12:20:00',3.23),('9303','2014-02-23','12:25:00',2.02),('9303','2014-02-23','12:30:00',2.62),('9303','2014-02-23','12:35:00',3.88),('9303','2014-02-23','12:40:00',2.21),('9303','2014-02-23','12:45:00',2.14),('9303','2014-02-23','12:50:00',1.7),('9303','2014-02-23','12:55:00',2.26),('9303','2014-02-23','13:00:00',2.49),('9303','2014-02-23','13:05:00',3.52),('9303','2014-02-23','13:10:00',3.54),('9303','2014-02-23','13:15:00',3.47),('9303','2014-02-23','13:20:00',3.48),('9303','2014-02-23','13:25:00',3.45),('9303','2014-02-23','13:30:00',3.36),('9303','2014-02-23','13:35:00',2.63),('9303','2014-02-23','13:40:00',3.11),('9303','2014-02-23','13:45:00',2.75),('9303','2014-02-23','13:50:00',1.48),('9303','2014-02-23','14:00:00',2.81),('9303','2014-02-23','14:05:00',2.78),('9303','2014-02-23','14:10:00',3.22),('9303','2014-02-23','14:15:00',2.21),('9303','2014-02-23','14:20:00',2.14),('9303','2014-02-23','14:25:00',2.8),('9303','2014-02-23','14:30:00',2.93),('9303','2014-02-23','14:35:00',1.6),('9303','2014-02-23','14:45:00',1.01),('9303','2014-02-23','14:50:00',1.05),('9303','2014-02-22','09:50:00',1.03),('9303','2014-02-22','10:00:00',1.34),('9303','2014-02-22','10:05:00',1.84),('9303','2014-02-22','10:10:00',1.9),('9303','2014-02-22','10:15:00',1.92),('9303','2014-02-22','10:20:00',1.2),('9303','2014-02-22','10:25:00',1.72),('9303','2014-02-22','10:30:00',2.33),('9303','2014-02-22','10:35:00',1.63),('9303','2014-02-22','10:40:00',1.7),('9303','2014-02-22','10:45:00',3.11),('9303','2014-02-22','10:50:00',3.46),('9303','2014-02-22','10:55:00',1.08),('9303','2014-02-22','12:05:00',1.13),('9303','2014-02-22','12:10:00',1.47),('9303','2014-02-22','12:15:00',1.78),('9303','2014-02-22','12:20:00',1.49),('9303','2014-02-22','12:25:00',1.64),('9303','2014-02-22','12:30:00',1.01),('9303','2014-02-22','12:35:00',1.09),('9303','2014-02-22','12:40:00',1.27),('9303','2014-02-22','12:45:00',3.35),('9303','2014-02-22','12:50:00',2.81),('9303','2014-02-22','12:55:00',1.46),('9303','2014-02-22','13:00:00',1.35),('9303','2014-02-22','13:05:00',1.91),('9303','2014-02-22','13:10:00',4.44),('9303','2014-02-22','13:15:00',2.38),('9303','2014-02-22','13:20:00',1.57),('9303','2014-02-22','13:30:00',1.21),('9303','2014-02-22','13:35:00',1.85),('9303','2014-02-22','13:40:00',1.69),('9303','2014-02-22','13:45:00',1.98),('9303','2014-02-22','13:50:00',1.95),('9303','2014-02-22','13:55:00',2.73),('9303','2014-02-22','14:00:00',3.23),('9303','2014-02-22','14:05:00',3.25),('9303','2014-02-22','14:10:00',3.17),('9303','2014-02-22','14:15:00',3.09),('9303','2014-02-22','14:20:00',2.99),('9303','2014-02-22','14:25:00',2.54),('9303','2014-02-22','14:30:00',2.97),('9303','2014-02-22','14:35:00',2.83),('9303','2014-02-22','14:40:00',2.34),('9303','2014-02-22','14:45:00',2.87),('9303','2014-02-22','14:50:00',2.58),('9303','2014-02-22','15:00:00',1.62),('9303','2014-02-22','15:05:00',2.46),('9303','2014-02-22','15:10:00',1.99),('9303','2014-02-22','15:15:00',1.83),('9303','2014-02-22','15:20:00',1.98),('9303','2014-02-22','15:25:00',2.22),('9303','2014-02-22','15:30:00',1.18),('9303','2014-02-22','15:35:00',1.55),('9303','2014-02-22','15:45:00',1.62),('9303','2014-02-22','15:50:00',1.52),('9303','2014-02-21','09:50:00',1.11),('9303','2014-02-21','09:55:00',1.13),('9303','2014-02-21','10:00:00',1.13),('9303','2014-02-21','10:05:00',1.37),('9303','2014-02-21','10:10:00',1.28),('9303','2014-02-21','10:15:00',1.38),('9303','2014-02-21','10:20:00',1.82),('9303','2014-02-21','10:25:00',2.25),('9303','2014-02-21','10:30:00',2.58),('9303','2014-02-21','10:35:00',1.99),('9303','2014-02-21','10:40:00',1.69),('9303','2014-02-21','10:45:00',1.66),('9303','2014-02-21','10:50:00',1.43),('9303','2014-02-21','10:55:00',1.97),('9303','2014-02-21','11:00:00',1.83),('9303','2014-02-21','11:05:00',1.53),('9303','2014-02-21','11:10:00',1.39),('9303','2014-02-21','11:15:00',1.55),('9303','2014-02-21','11:20:00',1.47),('9303','2014-02-21','11:25:00',1.64),('9303','2014-02-21','11:30:00',3.25),('9303','2014-02-21','11:35:00',3.03),('9303','2014-02-21','11:40:00',2.34),('9303','2014-02-21','11:45:00',3.44),('9303','2014-02-21','11:50:00',3.43),('9303','2014-02-21','11:55:00',2.06),('9303','2014-02-21','12:00:00',3.55),('9303','2014-02-21','12:05:00',3.98),('9303','2014-02-21','12:10:00',3.78),('9303','2014-02-21','12:15:00',2.9),('9303','2014-02-21','12:20:00',1.52),('9303','2014-02-21','12:25:00',1.49),('9303','2014-02-21','12:30:00',1.46),('9303','2014-02-21','12:35:00',1.35),('9303','2014-02-21','12:40:00',1.09),('9303','2014-02-21','15:25:00',1.23),('9303','2014-02-21','15:30:00',1.82),('9303','2014-02-21','15:35:00',1.73),('9303','2014-02-21','15:40:00',1.61),('9303','2014-02-21','15:45:00',1.52),('9303','2014-02-21','15:50:00',1.38),('9303','2014-02-21','15:55:00',1.23),('9303','2014-02-21','16:00:00',1.12),('9303','2014-02-21','16:05:00',1.01),('9303','2014-02-20','11:25:00',1.08),('9303','2014-02-20','11:30:00',1.07),('9303','2014-02-20','12:40:00',1.01),('9303','2014-02-20','12:55:00',1.05),('9303','2014-02-20','13:00:00',1.33),('9303','2014-02-20','13:15:00',1.1),('9303','2014-02-20','13:20:00',1.01),('9303','2014-02-20','13:30:00',1.06),('9303','2014-02-19','09:35:00',1.12),('9303','2014-02-19','09:40:00',1.19),('9303','2014-02-19','09:45:00',1.45),('9303','2014-02-19','09:50:00',1.35),('9303','2014-02-19','09:55:00',1.24),('9303','2014-02-19','10:00:00',1.2),('9303','2014-02-19','10:05:00',1.19),('9303','2014-02-19','10:10:00',1.29),('9303','2014-02-19','10:15:00',1.35),('9303','2014-02-19','10:20:00',1.23),('9303','2014-02-19','10:25:00',1.25),('9303','2014-02-19','10:30:00',1.36),('9303','2014-02-19','10:35:00',1.42),('9303','2014-02-19','10:40:00',1.64),('9303','2014-02-19','10:45:00',1.82),('9303','2014-02-19','10:50:00',1.68),('9303','2014-02-19','10:55:00',1.48),('9303','2014-02-19','11:00:00',1.35),('9303','2014-02-19','11:05:00',1.37),('9303','2014-02-19','11:10:00',1.56),('9303','2014-02-19','11:15:00',1.56),('9303','2014-02-19','11:20:00',1.68),('9303','2014-02-19','11:25:00',1.56),('9303','2014-02-19','11:30:00',1.45),('9303','2014-02-19','11:35:00',1.37),('9303','2014-02-19','11:40:00',1.34),('9303','2014-02-19','11:45:00',1.24),('9303','2014-02-19','11:50:00',1.27),('9303','2014-02-19','11:55:00',1.14),('9303','2014-02-19','12:00:00',1.24),('9303','2014-02-19','12:05:00',1.41),('9303','2014-02-19','12:10:00',1.39),('9303','2014-02-19','12:15:00',1.35),('9303','2014-02-19','12:20:00',1.15),('9303','2014-02-19','12:25:00',1.33),('9303','2014-02-19','12:30:00',1.52),('9303','2014-02-19','12:35:00',1.3),('9303','2014-02-19','12:40:00',1.2),('9303','2014-02-19','12:45:00',1.21),('9303','2014-02-19','13:05:00',1.1),('9303','2014-02-19','13:10:00',1.02),('9303','2014-02-19','13:15:00',1.17),('9303','2014-02-19','13:20:00',1.24),('9303','2014-02-19','13:25:00',1.31),('9303','2014-02-19','13:30:00',1.34),('9303','2014-02-19','13:35:00',1.64),('9303','2014-02-19','13:40:00',1.56),('9303','2014-02-19','13:45:00',1.76),('9303','2014-02-19','13:50:00',2.02),('9303','2014-02-19','13:55:00',1.81),('9303','2014-02-19','14:00:00',1.66),('9303','2014-02-19','14:05:00',1.79),('9303','2014-02-19','14:10:00',1.44),('9303','2014-02-19','14:15:00',1.23),('9303','2014-02-19','14:20:00',1.96),('9303','2014-02-19','14:25:00',1.55),('9303','2014-02-19','14:30:00',1.5),('9303','2014-02-19','14:35:00',1.57),('9303','2014-02-19','14:40:00',1.33),('9303','2014-02-19','14:45:00',1.22),('9303','2014-02-19','14:50:00',1.62),('9303','2014-02-19','14:55:00',1.45),('9303','2014-02-19','15:00:00',1.09),('9303','2014-02-19','15:05:00',1.06),('9303','2014-02-19','15:10:00',1.11),('9303','2014-02-19','15:15:00',1.24),('9303','2014-02-19','15:25:00',1.09),('9303','2014-02-19','15:50:00',1.08),('9303','2014-02-18','08:40:00',1.1),('9303','2014-02-18','08:45:00',1.19),('9303','2014-02-18','08:50:00',1.23),('9303','2014-02-18','08:55:00',1.36),('9303','2014-02-18','09:00:00',1.42),('9303','2014-02-18','09:05:00',1.48),('9303','2014-02-18','09:10:00',1.57),('9303','2014-02-18','09:15:00',1.74),('9303','2014-02-18','09:20:00',2.02),('9303','2014-02-18','09:25:00',2.14),('9303','2014-02-18','09:30:00',2.24),('9303','2014-02-18','09:35:00',2.26),('9303','2014-02-18','09:40:00',2.32),('9303','2014-02-18','09:45:00',2.36),('9303','2014-02-18','09:50:00',2.41),('9303','2014-02-18','09:55:00',2.46),('9303','2014-02-18','10:00:00',2.48),('9303','2014-02-18','10:05:00',2.54),('9303','2014-02-18','10:10:00',2.58),('9303','2014-02-18','10:15:00',2.58),('9303','2014-02-18','10:20:00',2.6),('9303','2014-02-18','10:25:00',2.62),('9303','2014-02-18','10:30:00',2.69),('9303','2014-02-18','10:35:00',2.72),('9303','2014-02-18','10:40:00',2.76),('9303','2014-02-18','10:45:00',2.8),('9303','2014-02-18','10:50:00',2.85),('9303','2014-02-18','10:55:00',2.85),('9303','2014-02-18','11:00:00',2.92),('9303','2014-02-18','11:05:00',2.53),('9303','2014-02-18','11:10:00',2.42),('9303','2014-02-18','11:15:00',2.39),('9303','2014-02-18','11:20:00',2.58),('9303','2014-02-18','11:25:00',2.91),('9303','2014-02-18','11:30:00',2.67),('9303','2014-02-18','11:35:00',2.56),('9303','2014-02-18','11:40:00',1.99),('9303','2014-02-18','11:45:00',1.94),('9303','2014-02-18','11:50:00',1.71),('9303','2014-02-18','11:55:00',1.48),('9303','2014-02-18','12:00:00',1.41),('9303','2014-02-18','12:05:00',1.39),('9303','2014-02-18','12:10:00',1.61),('9303','2014-02-18','12:15:00',1.78),('9303','2014-02-18','12:20:00',1.74),('9303','2014-02-18','12:25:00',2.02),('9303','2014-02-18','12:30:00',2.2),('9303','2014-02-18','12:35:00',1.72),('9303','2014-02-18','12:40:00',1.52),('9303','2014-02-18','12:45:00',1.43),('9303','2014-02-18','12:50:00',1.54),('9303','2014-02-18','12:55:00',1.75),('9303','2014-02-18','13:00:00',1.34),('9303','2014-02-18','13:05:00',1.25),('9303','2014-02-18','13:10:00',1.32),('9303','2014-02-18','13:15:00',1.76),('9303','2014-02-18','13:20:00',1.96),('9303','2014-02-18','13:25:00',2.31),('9303','2014-02-18','13:30:00',1.74),('9303','2014-02-18','13:35:00',1.42),('9303','2014-02-18','13:40:00',1.78),('9303','2014-02-18','13:45:00',2.05),('9303','2014-02-18','13:50:00',1.64),('9303','2014-02-18','13:55:00',1.6),('9303','2014-02-18','14:00:00',1.8),('9303','2014-02-18','14:05:00',2.4),('9303','2014-02-18','14:10:00',1.57),('9303','2014-02-18','14:15:00',1.21),('9303','2014-02-18','14:20:00',1.07),('9303','2014-02-18','14:25:00',1.07),('9303','2014-02-18','14:30:00',1.36),('9303','2014-02-18','14:35:00',1.32),('9303','2014-02-18','14:40:00',1.07),('9303','2014-02-18','15:40:00',1.08),('9303','2014-02-18','15:45:00',1.21),('9303','2014-02-17','08:40:00',1.03),('9303','2014-02-17','08:45:00',1.1),('9303','2014-02-17','08:50:00',1.15),('9303','2014-02-17','08:55:00',1.21),('9303','2014-02-17','09:00:00',1.26),('9303','2014-02-17','09:05:00',1.34),('9303','2014-02-17','09:10:00',1.4),('9303','2014-02-17','09:15:00',1.47),('9303','2014-02-17','09:20:00',1.52),('9303','2014-02-17','09:25:00',1.6),('9303','2014-02-17','09:30:00',1.67),('9303','2014-02-17','09:35:00',1.69),('9303','2014-02-17','09:40:00',1.74),('9303','2014-02-17','09:45:00',1.76),('9303','2014-02-17','09:50:00',1.78),('9303','2014-02-17','09:55:00',1.83),('9303','2014-02-17','10:00:00',1.84),('9303','2014-02-17','10:05:00',1.89),('9303','2014-02-17','10:10:00',1.92),('9303','2014-02-17','10:15:00',1.91),('9303','2014-02-17','10:20:00',1.94),('9303','2014-02-17','10:25:00',1.96),('9303','2014-02-17','10:30:00',2),('9303','2014-02-17','10:35:00',2.03),('9303','2014-02-17','10:40:00',2.02),('9303','2014-02-17','10:45:00',2.06),('9303','2014-02-17','10:50:00',2.1),('9303','2014-02-17','10:55:00',2.12),('9303','2014-02-17','11:00:00',2.05),('9303','2014-02-17','11:05:00',2.01),('9303','2014-02-17','11:10:00',2.09),('9303','2014-02-17','11:15:00',2.18),('9303','2014-02-17','11:20:00',2.22),('9303','2014-02-17','11:25:00',2.26),('9303','2014-02-17','11:30:00',2.34),('9303','2014-02-17','11:35:00',2.4),('9303','2014-02-17','11:40:00',2.4),('9303','2014-02-17','11:45:00',2.45),('9303','2014-02-17','11:50:00',2.45),('9303','2014-02-17','11:55:00',2.45),('9303','2014-02-17','12:00:00',2.47),('9303','2014-02-17','12:05:00',2.47),('9303','2014-02-17','12:10:00',2.48),('9303','2014-02-17','12:15:00',2.46),('9303','2014-02-17','12:20:00',2.46),('9303','2014-02-17','12:25:00',2.51),('9303','2014-02-17','12:30:00',2.52),('9303','2014-02-17','12:35:00',2.52),('9303','2014-02-17','12:40:00',2.54),('9303','2014-02-17','12:45:00',2.54),('9303','2014-02-17','12:50:00',2.53),('9303','2014-02-17','12:55:00',2.55),('9303','2014-02-17','13:00:00',2.54),('9303','2014-02-17','13:05:00',2.47),('9303','2014-02-17','13:10:00',2.37),('9303','2014-02-17','13:15:00',2.34),('9303','2014-02-17','13:20:00',2.32),('9303','2014-02-17','13:25:00',2.31),('9303','2014-02-17','13:30:00',2.3),('9303','2014-02-17','13:35:00',2.28),('9303','2014-02-17','13:40:00',2.26),('9303','2014-02-17','13:45:00',2.2),('9303','2014-02-17','13:50:00',2.12),('9303','2014-02-17','13:55:00',2.1),('9303','2014-02-17','14:00:00',2.04),('9303','2014-02-17','14:05:00',2.05),('9303','2014-02-17','14:10:00',1.9),('9303','2014-02-17','14:15:00',1.92),('9303','2014-02-17','14:20:00',2.15),('9303','2014-02-17','14:25:00',2.06),('9303','2014-02-17','14:30:00',1.93),('9303','2014-02-17','14:35:00',1.6),('9303','2014-02-17','14:40:00',1.62),('9303','2014-02-17','14:45:00',1.76),('9303','2014-02-17','14:50:00',1.74),('9303','2014-02-17','14:55:00',1.74),('9303','2014-02-17','15:00:00',1.76),('9303','2014-02-17','15:05:00',1.66),('9303','2014-02-17','15:10:00',1.63),('9303','2014-02-17','15:15:00',1.61),('9303','2014-02-17','15:20:00',1.57),('9303','2014-02-17','15:25:00',1.51),('9303','2014-02-17','15:30:00',1.46),('9303','2014-02-17','15:35:00',1.33),('9303','2014-02-17','15:40:00',1.18),('9303','2014-02-17','15:45:00',1.14),('9303','2014-02-17','15:50:00',1.04),('9303','2014-02-16','08:35:00',1.07),('9303','2014-02-16','08:40:00',1.08),('9303','2014-02-16','08:45:00',1.24),('9303','2014-02-16','08:50:00',1.19),('9303','2014-02-16','08:55:00',1.38),('9303','2014-02-16','09:00:00',1.47),('9303','2014-02-16','09:05:00',1.54),('9303','2014-02-16','09:10:00',1.51),('9303','2014-02-16','09:15:00',1.29),('9303','2014-02-16','09:20:00',1.61),('9303','2014-02-16','09:25:00',1.66),('9303','2014-02-16','09:30:00',1.72),('9303','2014-02-16','09:35:00',1.46),('9303','2014-02-16','09:40:00',1.82),('9303','2014-02-16','09:45:00',1.94),('9303','2014-02-16','09:50:00',1.98),('9303','2014-02-16','09:55:00',1.9),('9303','2014-02-16','10:00:00',1.84),('9303','2014-02-16','10:05:00',2.06),('9303','2014-02-16','10:10:00',2.11),('9303','2014-02-16','10:15:00',2.11),('9303','2014-02-16','10:20:00',2.13),('9303','2014-02-16','10:25:00',2.17),('9303','2014-02-16','10:30:00',2.22),('9303','2014-02-16','10:35:00',2.28),('9303','2014-02-16','10:40:00',2.34),('9303','2014-02-16','10:45:00',2.38),('9303','2014-02-16','10:50:00',2.15),('9303','2014-02-16','10:55:00',2.04),('9303','2014-02-16','11:00:00',2.38),('9303','2014-02-16','11:05:00',2.45),('9303','2014-02-16','11:10:00',2.35),('9303','2014-02-16','11:15:00',2.43),('9303','2014-02-16','11:20:00',2.43),('9303','2014-02-16','11:25:00',2.26),('9303','2014-02-16','11:30:00',2.36),('9303','2014-02-16','11:35:00',2.55),('9303','2014-02-16','11:40:00',2.5),('9303','2014-02-16','11:45:00',2.26),('9303','2014-02-16','11:50:00',2.51),('9303','2014-02-16','11:55:00',2.21),('9303','2014-02-16','12:00:00',2.6),('9303','2014-02-16','12:05:00',2.57),('9303','2014-02-16','12:10:00',2.61),('9303','2014-02-16','12:15:00',2.59),('9303','2014-02-16','12:20:00',2.58),('9303','2014-02-16','12:25:00',2.52),('9303','2014-02-16','12:30:00',2.61),('9303','2014-02-16','12:35:00',2.61),('9303','2014-02-16','12:40:00',2.66),('9303','2014-02-16','12:45:00',2.63),('9303','2014-02-16','12:50:00',2.61),('9303','2014-02-16','12:55:00',2.61),('9303','2014-02-16','13:00:00',2.61),('9303','2014-02-16','13:05:00',2.55),('9303','2014-02-16','13:10:00',2.43),('9303','2014-02-16','13:15:00',2.48),('9303','2014-02-16','13:20:00',2.46),('9303','2014-02-16','13:25:00',2.43),('9303','2014-02-16','13:30:00',2.39),('9303','2014-02-16','13:35:00',2.36),('9303','2014-02-16','13:40:00',2.33),('9303','2014-02-16','13:45:00',2.33),('9303','2014-02-16','13:50:00',2.3),('9303','2014-02-16','13:55:00',2.27),('9303','2014-02-16','14:00:00',2.24),('9303','2014-02-16','14:05:00',2.17),('9303','2014-02-16','14:10:00',2.17),('9303','2014-02-16','14:15:00',2.16),('9303','2014-02-16','14:20:00',2.12),('9303','2014-02-16','14:25:00',2.12),('9303','2014-02-16','14:30:00',2.07),('9303','2014-02-16','14:35:00',2.01),('9303','2014-02-16','14:40:00',1.92),('9303','2014-02-16','14:45:00',1.9),('9303','2014-02-16','14:50:00',1.84),('9303','2014-02-16','14:55:00',1.78),('9303','2014-02-16','15:00:00',1.71),('9303','2014-02-16','15:05:00',1.72),('9303','2014-02-16','15:10:00',1.71),('9303','2014-02-16','15:15:00',1.66),('9303','2014-02-16','15:20:00',1.58),('9303','2014-02-16','15:25:00',1.48),('9303','2014-02-16','15:30:00',1.41),('9303','2014-02-16','15:35:00',1.24),('9303','2014-02-16','15:40:00',1.03),('9303','2014-02-16','15:45:00',1.18),('9303','2014-04-28','08:15:00',1.5),('9303','2014-04-28','08:20:00',1.69),('9303','2014-04-28','08:25:00',1.52),('9303','2014-04-28','08:30:00',1.16),('9303','2014-04-28','08:35:00',1.12),('9303','2014-04-28','08:40:00',1.05),('9303','2014-04-28','08:45:00',1.4),('9303','2014-04-28','08:50:00',1.15),('9303','2014-04-28','08:55:00',1.23),('9303','2014-04-28','09:00:00',1.03),('9303','2014-04-28','09:10:00',1.66),('9303','2014-04-28','09:15:00',2.7),('9303','2014-04-28','09:20:00',2.1),('9303','2014-04-28','09:25:00',1.41),('9303','2014-04-28','09:30:00',3.09),('9303','2014-04-28','09:35:00',1.91),('9303','2014-04-28','09:40:00',1.61),('9303','2014-04-28','09:45:00',2.43),('9303','2014-04-28','09:50:00',3.57),('9303','2014-04-28','09:55:00',1.24),('9303','2014-04-28','10:00:00',1.48),('9303','2014-04-28','10:05:00',1.94),('9303','2014-04-28','10:10:00',2.13),('9303','2014-04-28','10:15:00',2.02),('9303','2014-04-28','10:20:00',1.81),('9303','2014-04-28','10:25:00',1.2),('9303','2014-04-28','10:45:00',1.39),('9303','2014-04-28','10:50:00',1.89),('9303','2014-04-28','10:55:00',1.77),('9303','2014-04-28','11:00:00',1.71),('9303','2014-04-28','11:05:00',2.18),('9303','2014-04-28','11:10:00',2.43),('9303','2014-04-28','11:15:00',2.29),('9303','2014-04-28','11:20:00',2.32),('9303','2014-04-28','11:25:00',1.64),('9303','2014-04-28','11:30:00',1.74),('9303','2014-04-28','11:35:00',1.63),('9303','2014-04-28','11:40:00',1.43),('9303','2014-04-28','11:45:00',1.57),('9303','2014-04-28','11:50:00',1.73),('9303','2014-04-28','11:55:00',1.81),('9303','2014-04-28','12:00:00',1.68),('9303','2014-04-28','12:05:00',1.32),('9303','2014-04-28','12:10:00',1.75),('9303','2014-04-28','12:15:00',2.58),('9303','2014-04-28','12:20:00',2.73),('9303','2014-04-28','12:25:00',2.69),('9303','2014-04-28','12:30:00',2.57),('9303','2014-04-28','12:35:00',2.31),('9303','2014-04-28','12:40:00',2.04),('9303','2014-04-28','12:45:00',1.8),('9303','2014-04-28','12:50:00',2.11),('9303','2014-04-28','12:55:00',2.14),('9303','2014-04-28','13:00:00',2.24),('9303','2014-04-28','13:05:00',2.68),('9303','2014-04-28','13:10:00',3.31),('9303','2014-04-28','13:15:00',2.16),('9303','2014-04-28','13:20:00',2.22),('9303','2014-04-28','13:25:00',2.74),('9303','2014-04-28','13:30:00',4.18),('9303','2014-04-28','13:35:00',3.41),('9303','2014-04-28','13:40:00',4.25),('9303','2014-04-28','13:45:00',2.82),('9303','2014-04-28','13:50:00',4.11),('9303','2014-04-28','13:55:00',3.29),('9303','2014-04-28','14:00:00',2.97),('9303','2014-04-28','14:05:00',2.4),('9303','2014-04-28','14:10:00',4.49),('9303','2014-04-28','14:15:00',3.32),('9303','2014-04-28','14:20:00',3.55),('9303','2014-04-28','14:25:00',3.04),('9303','2014-04-28','14:30:00',3.52),('9303','2014-04-28','14:35:00',3.71),('9303','2014-04-28','14:40:00',3.22),('9303','2014-04-28','14:45:00',2.55),('9303','2014-04-28','14:50:00',1.92),('9303','2014-04-28','14:55:00',3.23),('9303','2014-04-28','15:00:00',1.92),('9303','2014-04-28','15:05:00',3.36),('9303','2014-04-28','15:10:00',2.16),('9303','2014-04-28','15:15:00',3.23),('9303','2014-04-28','15:20:00',2.92),('9303','2014-04-28','15:25:00',1.86),('9303','2014-04-28','15:30:00',1.56),('9303','2014-04-28','15:35:00',2.33),('9303','2014-04-28','15:40:00',2.2),('9303','2014-04-28','15:45:00',2.08),('9303','2014-04-28','15:50:00',3.2),('9303','2014-04-28','15:55:00',1.39),('9303','2014-04-28','16:00:00',3.49),('9303','2014-04-28','16:05:00',3.77),('9303','2014-04-28','16:10:00',3.34),('9303','2014-04-28','16:15:00',1.46),('9303','2014-04-28','16:20:00',2.66),('9303','2014-04-28','16:25:00',2.1),('9303','2014-04-28','16:30:00',2.29),('9303','2014-04-28','16:35:00',2.09),('9303','2014-04-28','16:55:00',2.59),('9303','2014-04-28','17:40:00',1.24),('9303','2014-02-15','08:40:00',1.02),('9303','2014-02-15','08:45:00',1.09),('9303','2014-02-15','08:50:00',1.16),('9303','2014-02-15','08:55:00',1.21),('9303','2014-02-15','09:00:00',1.29),('9303','2014-02-15','09:05:00',1.36),('9303','2014-02-15','09:10:00',1.43),('9303','2014-02-15','09:15:00',1.47),('9303','2014-02-15','09:20:00',1.52),('9303','2014-02-15','09:25:00',1.6),('9303','2014-02-15','09:30:00',1.66),('9303','2014-02-15','09:35:00',1.7),('9303','2014-02-15','09:40:00',1.76),('9303','2014-02-15','09:45:00',1.79),('9303','2014-02-15','09:50:00',1.82),('9303','2014-02-15','09:55:00',1.84),('9303','2014-02-15','10:00:00',1.89),('9303','2014-02-15','10:05:00',1.93),('9303','2014-02-15','10:10:00',1.95),('9303','2014-02-15','10:15:00',1.97),('9303','2014-02-15','10:20:00',2),('9303','2014-02-15','10:25:00',2.01),('9303','2014-02-15','10:30:00',2.03),('9303','2014-02-15','10:35:00',2.09),('9303','2014-02-15','10:40:00',2.1),('9303','2014-02-15','10:45:00',2.17),('9303','2014-02-15','10:50:00',2.14),('9303','2014-02-15','10:55:00',2.17),('9303','2014-02-15','11:00:00',2.2),('9303','2014-02-15','11:05:00',2.37),('9303','2014-02-15','11:10:00',1.63),('9303','2014-02-15','11:15:00',2.39),('9303','2014-02-15','11:20:00',2.49),('9303','2014-02-15','11:25:00',1.38),('9303','2014-02-15','11:30:00',1.41),('9303','2014-02-15','11:35:00',1.43),('9303','2014-02-15','11:40:00',1.86),('9303','2014-02-15','11:45:00',2.88),('9303','2014-02-15','11:50:00',2.71),('9303','2014-02-15','11:55:00',2.76),('9303','2014-02-15','12:00:00',1.86),('9303','2014-02-15','12:05:00',1.3),('9303','2014-02-15','12:15:00',2.39),('9303','2014-02-15','12:20:00',3.14),('9303','2014-02-15','12:25:00',2.75),('9303','2014-02-15','12:30:00',1.47),('9303','2014-02-15','12:35:00',2.52),('9303','2014-02-15','12:45:00',2.34),('9303','2014-02-15','12:50:00',3),('9303','2014-02-15','12:55:00',3.19),('9303','2014-02-15','13:00:00',2.77),('9303','2014-02-15','13:05:00',2.95),('9303','2014-02-15','13:10:00',2.89),('9303','2014-02-15','13:15:00',2.69),('9303','2014-02-15','13:20:00',2.49),('9303','2014-02-15','13:25:00',2.49),('9303','2014-02-15','13:30:00',2.45),('9303','2014-02-15','13:35:00',2.42),('9303','2014-02-15','13:40:00',2.35),('9303','2014-02-15','13:45:00',2.3),('9303','2014-02-15','13:50:00',2.24),('9303','2014-02-15','13:55:00',2.26),('9303','2014-02-15','14:00:00',2.14),('9303','2014-02-15','14:05:00',2.1),('9303','2014-02-15','14:10:00',2.12),('9303','2014-02-15','14:15:00',2.06),('9303','2014-02-15','14:20:00',1.99),('9303','2014-02-15','14:25:00',2.02),('9303','2014-02-15','14:30:00',1.96),('9303','2014-02-15','14:35:00',1.89),('9303','2014-02-15','14:40:00',1.88),('9303','2014-02-15','14:45:00',1.81),('9303','2014-02-15','14:50:00',1.73),('9303','2014-02-15','14:55:00',1.63),('9303','2014-02-15','15:00:00',1.64),('9303','2014-02-15','15:05:00',1.6),('9303','2014-02-15','15:10:00',1.6),('9303','2014-02-15','15:15:00',1.58),('9303','2014-02-15','15:20:00',1.53),('9303','2014-02-15','15:25:00',1.46),('9303','2014-02-15','15:30:00',1.39),('9303','2014-02-15','15:35:00',1.3),('9303','2014-02-15','15:40:00',1.24),('9303','2014-02-15','15:45:00',1.17),('9303','2014-02-15','15:50:00',1.08),('9303','2014-02-15','15:55:00',1.02),('9303','2014-02-14','08:50:00',1.17),('9303','2014-02-14','08:55:00',1.22),('9303','2014-02-14','09:00:00',1.28),('9303','2014-02-14','09:05:00',1.4),('9303','2014-02-14','09:10:00',1.24),('9303','2014-02-14','09:25:00',1.57),('9303','2014-02-14','09:30:00',1.55),('9303','2014-02-14','09:50:00',2.01),('9303','2014-02-14','09:55:00',1.22),('9303','2014-02-14','10:00:00',1.85),('9303','2014-02-14','10:05:00',2.13),('9303','2014-02-14','10:10:00',1.87),('9303','2014-02-14','10:15:00',1.58),('9303','2014-02-14','10:20:00',2.08),('9303','2014-02-14','10:25:00',1.67),('9303','2014-02-14','10:30:00',2.19),('9303','2014-02-14','10:35:00',2.1),('9303','2014-02-14','10:40:00',2),('9303','2014-02-14','10:45:00',2.35),('9303','2014-02-14','10:50:00',2.3),('9303','2014-02-14','10:55:00',2.38),('9303','2014-02-14','11:00:00',2.37),('9303','2014-02-14','11:05:00',2.44),('9303','2014-02-14','11:10:00',2.43),('9303','2014-02-14','11:15:00',2.45),('9303','2014-02-14','11:20:00',2.51),('9303','2014-02-14','11:25:00',2.52),('9303','2014-02-14','11:30:00',2.58),('9303','2014-02-14','11:35:00',2.62),('9303','2014-02-14','11:40:00',2.61),('9303','2014-02-14','11:45:00',2.64),('9303','2014-02-14','11:50:00',2.62),('9303','2014-02-14','11:55:00',2.63),('9303','2014-02-14','12:00:00',2.66),('9303','2014-02-14','12:05:00',2.66),('9303','2014-02-14','12:10:00',2.52),('9303','2014-02-14','12:15:00',2.66),('9303','2014-02-14','12:20:00',2.67),('9303','2014-02-14','12:25:00',2.71),('9303','2014-02-14','12:30:00',2.71),('9303','2014-02-14','12:35:00',2.72),('9303','2014-02-14','12:40:00',2.74),('9303','2014-02-14','12:45:00',2.72),('9303','2014-02-14','12:50:00',2.72),('9303','2014-02-14','12:55:00',2.74),('9303','2014-02-14','13:00:00',2.72),('9303','2014-02-14','13:05:00',2.62),('9303','2014-02-14','13:10:00',2.56),('9303','2014-02-14','13:15:00',2.55),('9303','2014-02-14','13:20:00',2.51),('9303','2014-02-14','13:25:00',2.49),('9303','2014-02-14','13:30:00',2.47),('9303','2014-02-14','13:35:00',2.43),('9303','2014-02-14','13:40:00',2.41),('9303','2014-02-14','13:45:00',2.37),('9303','2014-02-14','13:50:00',2.36),('9303','2014-02-14','13:55:00',2.33),('9303','2014-02-14','14:00:00',2.22),('9303','2014-02-14','14:05:00',2.18),('9303','2014-02-14','14:10:00',2.19),('9303','2014-02-14','14:15:00',2.14),('9303','2014-02-14','14:20:00',2.09),('9303','2014-02-14','14:25:00',2.08),('9303','2014-02-14','14:30:00',2.02),('9303','2014-02-14','14:35:00',1.94),('9303','2014-02-14','14:40:00',1.9),('9303','2014-02-14','14:45:00',1.87),('9303','2014-02-14','14:50:00',1.81),('9303','2014-02-14','14:55:00',1.77),('9303','2014-02-14','15:00:00',1.72),('9303','2014-02-14','15:05:00',1.67),('9303','2014-02-14','15:10:00',1.65),('9303','2014-02-14','15:15:00',1.61),('9303','2014-02-14','15:20:00',1.54),('9303','2014-02-14','15:25:00',1.48),('9303','2014-02-14','15:30:00',1.4),('9303','2014-02-14','15:35:00',1.3),('9303','2014-02-14','15:40:00',1.24),('9303','2014-02-14','15:45:00',1.16),('9303','2014-02-14','15:50:00',1.06),('9303','2014-02-14','15:55:00',1),('9303','2014-02-13','08:45:00',1.06),('9303','2014-02-13','08:50:00',1.18),('9303','2014-02-13','08:55:00',1.26),('9303','2014-02-13','09:00:00',1.34),('9303','2014-02-13','09:05:00',1.41),('9303','2014-02-13','09:10:00',1.5),('9303','2014-02-13','09:15:00',1.55),('9303','2014-02-13','09:20:00',1.62),('9303','2014-02-13','09:25:00',1.7),('9303','2014-02-13','09:30:00',1.74),('9303','2014-02-13','09:35:00',1.8),('9303','2014-02-13','09:40:00',1.83),('9303','2014-02-13','09:45:00',1.87),('9303','2014-02-13','09:50:00',1.92),('9303','2014-02-13','09:55:00',1.93),('9303','2014-02-13','10:00:00',1.99),('9303','2014-02-13','10:05:00',2.02),('9303','2014-02-13','10:10:00',2.04),('9303','2014-02-13','10:15:00',2.05),('9303','2014-02-13','10:20:00',2.07),('9303','2014-02-13','10:25:00',2.06),('9303','2014-02-13','10:30:00',2.08),('9303','2014-02-13','10:35:00',2.15),('9303','2014-02-13','10:40:00',2.13),('9303','2014-02-13','10:45:00',2.19),('9303','2014-02-13','10:50:00',2.22),('9303','2014-02-13','10:55:00',2.25),('9303','2014-02-13','11:00:00',2.31),('9303','2014-02-13','11:05:00',2.32),('9303','2014-02-13','11:10:00',2.37),('9303','2014-02-13','11:15:00',2.38),('9303','2014-02-13','11:20:00',2.55),('9303','2014-02-13','11:25:00',2.69),('9303','2014-02-13','11:30:00',1.97),('9303','2014-02-13','11:35:00',1.64),('9303','2014-02-13','11:40:00',2.09),('9303','2014-02-13','11:45:00',1.72),('9303','2014-02-13','11:55:00',1.22),('9303','2014-02-13','12:00:00',1.25),('9303','2014-02-13','12:05:00',1.04),('9303','2014-02-13','12:20:00',1.42),('9303','2014-02-13','12:25:00',1.23),('9303','2014-02-13','12:30:00',3.21),('9303','2014-02-13','12:35:00',3.15),('9303','2014-02-13','12:40:00',3.21),('9303','2014-02-13','12:45:00',1.51),('9303','2014-02-13','12:50:00',2.91),('9303','2014-02-13','12:55:00',2.68),('9303','2014-02-13','13:00:00',2.85),('9303','2014-02-13','13:05:00',2.71),('9303','2014-02-13','13:10:00',2.64),('9303','2014-02-13','13:15:00',2.57),('9303','2014-02-13','13:20:00',2.53),('9303','2014-02-13','13:25:00',2.51),('9303','2014-02-13','13:30:00',2.49),('9303','2014-02-13','13:35:00',2.45),('9303','2014-02-13','13:40:00',2.44),('9303','2014-02-13','13:45:00',2.41),('9303','2014-02-13','13:50:00',2.37),('9303','2014-02-13','13:55:00',2.35),('9303','2014-02-13','14:00:00',2.27),('9303','2014-02-13','14:05:00',2.21),('9303','2014-02-13','14:10:00',2.19),('9303','2014-02-13','14:15:00',2.16),('9303','2014-02-13','14:20:00',2.11),('9303','2014-02-13','14:25:00',2.03),('9303','2014-02-13','14:30:00',1.95),('9303','2014-02-13','14:35:00',1.97),('9303','2014-02-13','14:40:00',1.98),('9303','2014-02-13','14:45:00',1.95),('9303','2014-02-13','14:50:00',1.53),('9303','2014-02-13','14:55:00',1.21),('9303','2014-02-13','15:00:00',1.7),('9303','2014-02-13','15:05:00',1.56),('9303','2014-02-13','15:10:00',1.83),('9303','2014-02-13','15:15:00',1.62),('9303','2014-02-13','15:20:00',1.69),('9303','2014-02-13','15:25:00',1.18),('9303','2014-02-13','15:40:00',1.43),('9303','2014-02-13','15:45:00',1.27),('9303','2014-02-13','15:50:00',1.12),('9303','2014-02-12','08:50:00',1.09),('9303','2014-02-12','08:55:00',1.23),('9303','2014-02-12','09:15:00',1.52),('9303','2014-02-12','09:20:00',1.61),('9303','2014-02-12','09:25:00',1.41),('9303','2014-02-12','09:40:00',1.35),('9303','2014-02-12','09:45:00',1.75),('9303','2014-02-12','09:50:00',1.48),('9303','2014-02-12','09:55:00',1.25),('9303','2014-02-12','10:05:00',1.4),('9303','2014-02-12','10:10:00',1.18),('9303','2014-02-12','10:30:00',1.22),('9303','2014-02-12','10:35:00',1.3),('9303','2014-02-12','10:40:00',1.04),('9303','2014-02-12','10:45:00',1.42),('9303','2014-02-12','10:50:00',1.22),('9303','2014-02-12','10:55:00',1.26),('9303','2014-02-12','11:00:00',1.25),('9303','2014-02-12','11:05:00',1.96),('9303','2014-02-12','11:10:00',1.43),('9303','2014-02-12','11:15:00',1.38),('9303','2014-02-12','11:20:00',1.43),('9303','2014-02-12','11:25:00',1.38),('9303','2014-02-12','11:30:00',1.64),('9303','2014-02-12','11:35:00',1.91),('9303','2014-02-12','11:40:00',1.04),('9303','2014-02-12','12:15:00',1.07),('9303','2014-02-12','12:20:00',1.11),('9303','2014-02-12','12:25:00',1.19),('9303','2014-02-12','12:30:00',1.27),('9303','2014-02-12','12:35:00',1.23),('9303','2014-02-12','12:40:00',1.19),('9303','2014-02-12','12:45:00',1.33),('9303','2014-02-12','12:50:00',1.49),('9303','2014-02-12','12:55:00',1.54),('9303','2014-02-12','13:00:00',1.6),('9303','2014-02-12','13:05:00',1.4),('9303','2014-02-12','13:10:00',1.95),('9303','2014-02-12','13:15:00',1.23),('9303','2014-02-12','13:20:00',1.15),('9303','2014-02-12','13:25:00',1.32),('9303','2014-02-12','13:30:00',2.05),('9303','2014-02-12','13:35:00',2.2),('9303','2014-02-12','13:40:00',3.22),('9303','2014-02-12','13:45:00',2.18),('9303','2014-02-12','13:50:00',2.19),('9303','2014-02-12','13:55:00',2.14),('9303','2014-02-12','14:00:00',2.74),('9303','2014-02-12','14:05:00',2.58),('9303','2014-02-12','14:10:00',2.36),('9303','2014-02-12','14:15:00',2.4),('9303','2014-02-12','14:20:00',2.04),('9303','2014-02-12','14:25:00',1.56),('9303','2014-02-12','14:30:00',1.22),('9303','2014-02-12','14:35:00',2.1),('9303','2014-02-12','14:40:00',1.75),('9303','2014-02-12','14:45:00',1.98),('9303','2014-02-12','14:50:00',2.18),('9303','2014-02-12','14:55:00',2),('9303','2014-02-12','15:00:00',1.34),('9303','2014-02-12','15:15:00',1.05),('9303','2014-02-12','15:20:00',1.42),('9303','2014-02-12','15:25:00',1.3),('9303','2014-02-12','15:30:00',1.11),('9303','2014-02-12','15:35:00',1),('9303','2014-02-12','15:40:00',1.45),('9303','2014-02-12','15:50:00',1.43),('9303','2014-02-11','09:25:00',1.1),('9303','2014-02-11','09:30:00',1.1),('9303','2014-02-11','09:35:00',1.11),('9303','2014-02-11','09:40:00',1.09),('9303','2014-02-11','09:45:00',1.06),('9303','2014-02-11','09:50:00',1.14),('9303','2014-02-11','09:55:00',1.14),('9303','2014-02-11','10:00:00',1.01),('9303','2014-02-11','10:10:00',1.19),('9303','2014-02-11','10:15:00',1.38),('9303','2014-02-11','10:20:00',1.56),('9303','2014-02-11','10:25:00',1.62),('9303','2014-02-11','10:30:00',1.73),('9303','2014-02-11','10:35:00',1.96),('9303','2014-02-11','10:40:00',1.98),('9303','2014-02-11','10:45:00',1.86),('9303','2014-02-11','10:50:00',2),('9303','2014-02-11','10:55:00',1.8),('9303','2014-02-11','11:00:00',1.93),('9303','2014-02-11','11:05:00',1.95),('9303','2014-02-11','11:10:00',1.83),('9303','2014-02-11','11:15:00',1.95),('9303','2014-02-11','11:20:00',1.96),('9303','2014-02-11','11:25:00',1.89),('9303','2014-02-11','11:30:00',1.61),('9303','2014-02-11','11:35:00',1.44),('9303','2014-02-11','11:40:00',1.44),('9303','2014-02-11','11:45:00',1.73),('9303','2014-02-11','11:50:00',1.66),('9303','2014-02-11','11:55:00',1.2),('9303','2014-02-11','12:00:00',1.17),('9303','2014-02-11','12:05:00',1.46),('9303','2014-02-11','12:10:00',1.72),('9303','2014-02-11','12:15:00',1.46),('9303','2014-02-11','12:20:00',1.52),('9303','2014-02-11','12:25:00',2.05),('9303','2014-02-11','12:30:00',1.92),('9303','2014-02-11','12:35:00',1.72),('9303','2014-02-11','12:40:00',1.3),('9303','2014-02-11','12:45:00',1.52),('9303','2014-02-11','12:50:00',1.23),('9303','2014-02-11','12:55:00',1.49),('9303','2014-02-11','13:00:00',1.6),('9303','2014-02-11','13:05:00',1.92),('9303','2014-02-11','13:10:00',2.27),('9303','2014-02-11','13:15:00',2.15),('9303','2014-02-11','13:20:00',2.41),('9303','2014-02-11','13:25:00',2.25),('9303','2014-02-11','13:30:00',2.07),('9303','2014-02-11','13:35:00',2.02),('9303','2014-02-11','13:40:00',2.31),('9303','2014-02-11','13:45:00',1.85),('9303','2014-02-11','13:50:00',1.42),('9303','2014-02-11','13:55:00',1.23),('9303','2014-02-11','14:00:00',1.57),('9303','2014-02-11','14:05:00',1.81),('9303','2014-02-11','14:10:00',1.42),('9303','2014-02-11','14:15:00',1.89),('9303','2014-02-11','14:20:00',1.28),('9303','2014-02-11','14:25:00',1.15),('9303','2014-02-11','14:30:00',1.31),('9303','2014-02-11','14:35:00',1.24),('9303','2014-02-11','15:15:00',1.08),('9303','2014-02-11','15:20:00',1.3),('9303','2014-02-10','13:00:00',1.17),('9303','2014-02-10','14:40:00',1.02),('9303','2014-02-09','11:30:00',1.06),('9303','2014-02-09','11:35:00',1.29),('9303','2014-02-09','12:25:00',1.16),('9303','2014-02-09','12:30:00',1.29),('9303','2014-02-09','12:45:00',1.31),('9303','2014-02-09','12:55:00',1.46),('9303','2014-02-09','13:00:00',2.6),('9303','2014-02-09','13:05:00',2.11),('9303','2014-02-09','13:10:00',1.98),('9303','2014-02-09','13:15:00',1.5),('9303','2014-02-09','13:40:00',1.43),('9303','2014-02-09','13:45:00',2.46),('9303','2014-02-09','13:50:00',1.46),('9303','2014-02-09','13:55:00',1.93),('9303','2014-02-09','14:00:00',1.65),('9303','2014-02-09','14:05:00',1.97),('9303','2014-02-09','14:10:00',1.33),('9303','2014-02-09','14:15:00',1.24),('9303','2014-02-09','14:20:00',1.13),('9303','2014-02-09','14:25:00',1.51),('9303','2014-02-09','14:30:00',1.76),('9303','2014-02-09','14:35:00',1.54),('9303','2014-02-09','14:50:00',1.36),('9303','2014-02-09','15:10:00',1.39),('9303','2014-02-09','15:15:00',1.04),('9303','2014-02-09','15:20:00',1.25),('9303','2014-02-09','15:25:00',1.17),('9303','2014-02-09','15:40:00',1.05),('9303','2014-02-08','09:50:00',1.48),('9303','2014-02-08','09:55:00',1.12),('9303','2014-02-08','10:15:00',1.3),('9303','2014-02-08','10:20:00',1.13),('9303','2014-02-08','10:30:00',1.42),('9303','2014-02-08','10:35:00',1.69),('9303','2014-02-08','10:40:00',1.34),('9303','2014-02-08','10:45:00',1.48),('9303','2014-02-08','10:50:00',1.57),('9303','2014-02-08','10:55:00',2.11),('9303','2014-02-08','11:00:00',1.92),('9303','2014-02-08','11:05:00',2.54),('9303','2014-02-08','11:10:00',1.89),('9303','2014-02-08','11:15:00',1.91),('9303','2014-02-08','11:20:00',2.46),('9303','2014-02-08','11:25:00',1.02),('9303','2014-02-08','11:30:00',1.6),('9303','2014-02-08','11:35:00',2.86),('9303','2014-02-08','11:40:00',1.83),('9303','2014-02-08','11:50:00',1.21),('9303','2014-02-08','11:55:00',3.11),('9303','2014-02-08','12:00:00',1.07),('9303','2014-02-08','12:05:00',1.06),('9303','2014-02-08','12:10:00',1.64),('9303','2014-02-08','12:15:00',2.8),('9303','2014-02-08','12:25:00',1.92),('9303','2014-02-08','12:30:00',3.14),('9303','2014-02-08','12:35:00',2.58),('9303','2014-02-08','12:40:00',1.63),('9303','2014-02-08','12:45:00',2.86),('9303','2014-02-08','12:50:00',3.43),('9303','2014-02-08','12:55:00',2.89),('9303','2014-02-08','13:00:00',2.11),('9303','2014-02-08','13:10:00',1.48),('9303','2014-02-08','13:15:00',2.86),('9303','2014-02-08','13:20:00',2.8),('9303','2014-02-08','13:25:00',2.13),('9303','2014-02-08','13:30:00',2.43),('9303','2014-02-08','13:35:00',2.31),('9303','2014-02-08','13:40:00',2.32),('9303','2014-02-08','13:45:00',2.64),('9303','2014-02-08','13:50:00',2.29),('9303','2014-02-08','13:55:00',2.26),('9303','2014-02-08','14:00:00',2.22),('9303','2014-02-08','14:05:00',2.15),('9303','2014-02-08','14:10:00',2.2),('9303','2014-02-08','14:15:00',1.57),('9303','2014-02-08','14:20:00',2.04),('9303','2014-02-08','14:25:00',1.39),('9303','2014-02-08','14:30:00',1.34),('9303','2014-02-08','14:40:00',1.56),('9303','2014-02-08','14:50:00',1.43),('9303','2014-02-08','14:55:00',1.83),('9303','2014-02-08','15:00:00',1.34),('9303','2014-02-08','15:20:00',1.28),('9303','2014-02-08','15:45:00',1.13),('9303','2014-02-08','15:50:00',1.02),('9303','2014-02-07','08:55:00',1.08),('9303','2014-02-07','09:00:00',1.19),('9303','2014-02-07','09:05:00',1.26),('9303','2014-02-07','09:10:00',1.35),('9303','2014-02-07','09:15:00',1.45),('9303','2014-02-07','09:20:00',1.52),('9303','2014-02-07','09:25:00',1.54),('9303','2014-02-07','09:30:00',1.62),('9303','2014-02-07','09:35:00',1.67),('9303','2014-02-07','09:40:00',1.71),('9303','2014-02-07','09:45:00',1.75),('9303','2014-02-07','09:50:00',1.76),('9303','2014-02-07','09:55:00',1.8),('9303','2014-02-07','10:00:00',1.83),('9303','2014-02-07','10:05:00',1.86),('9303','2014-02-07','10:10:00',1.9),('9303','2014-02-07','10:15:00',1.96),('9303','2014-02-07','10:20:00',2.01),('9303','2014-02-07','10:25:00',1.94),('9303','2014-02-07','10:30:00',2.05),('9303','2014-02-07','10:35:00',2.11),('9303','2014-02-07','10:40:00',2.22),('9303','2014-02-07','10:45:00',2.33),('9303','2014-02-07','10:50:00',2.38),('9303','2014-02-07','10:55:00',2.41),('9303','2014-02-07','11:00:00',1.84),('9303','2014-02-07','11:05:00',2.68),('9303','2014-02-07','11:10:00',1.98),('9303','2014-02-07','11:15:00',2.4),('9303','2014-02-07','11:20:00',2.01),('9303','2014-02-07','11:25:00',2.74),('9303','2014-02-07','11:30:00',2.3),('9303','2014-02-07','11:35:00',2.61),('9303','2014-02-07','11:40:00',1.18),('9303','2014-02-07','11:45:00',2.31),('9303','2014-02-07','11:50:00',1.85),('9303','2014-02-07','11:55:00',2.95),('9303','2014-02-07','12:00:00',2.45),('9303','2014-02-07','12:05:00',2.78),('9303','2014-02-07','12:10:00',2.1),('9303','2014-02-07','12:15:00',1.91),('9303','2014-02-07','12:20:00',1.29),('9303','2014-02-07','12:25:00',2.31),('9303','2014-02-07','12:30:00',1.47),('9303','2014-02-07','12:45:00',1.08),('9303','2014-02-07','12:50:00',1.3),('9303','2014-02-07','12:55:00',2.56),('9303','2014-02-07','13:00:00',2.48),('9303','2014-02-07','13:05:00',1.72),('9303','2014-02-07','13:10:00',3),('9303','2014-02-07','13:15:00',1.18),('9303','2014-02-07','13:20:00',1.72),('9303','2014-02-07','13:25:00',1.04),('9303','2014-02-07','13:35:00',2.03),('9303','2014-02-07','13:45:00',1.33),('9303','2014-02-07','13:50:00',1.61),('9303','2014-02-07','13:55:00',1.92),('9303','2014-02-07','14:00:00',1.64),('9303','2014-02-07','14:05:00',1.36),('9303','2014-02-07','14:10:00',2.2),('9303','2014-02-07','14:15:00',2.02),('9303','2014-02-07','14:20:00',2.18),('9303','2014-02-07','14:25:00',1.3),('9303','2014-02-07','14:30:00',1.02),('9303','2014-02-07','14:35:00',1.54),('9303','2014-02-07','14:40:00',2.12),('9303','2014-02-07','14:45:00',1.88),('9303','2014-02-07','14:50:00',1.84),('9303','2014-02-07','14:55:00',1.77),('9303','2014-02-07','15:00:00',1.65),('9303','2014-02-07','15:05:00',1.6),('9303','2014-02-07','15:10:00',1.57),('9303','2014-02-07','15:15:00',1.5),('9303','2014-02-07','15:20:00',1.44),('9303','2014-02-07','15:25:00',1.39),('9303','2014-02-07','15:30:00',1.27),('9303','2014-02-07','15:35:00',1.2),('9303','2014-02-07','15:40:00',1.13),('9303','2014-02-07','15:45:00',1.05),('9303','2014-02-06','08:55:00',1.09),('9303','2014-02-06','09:00:00',1.57),('9303','2014-02-06','09:05:00',1.65),('9303','2014-02-06','09:10:00',1.27),('9303','2014-02-06','09:15:00',1.29),('9303','2014-02-06','09:30:00',1.5),('9303','2014-02-06','09:35:00',1.67),('9303','2014-02-06','09:40:00',1.71),('9303','2014-02-06','09:45:00',1.73),('9303','2014-02-06','09:50:00',1.74),('9303','2014-02-06','09:55:00',1.78),('9303','2014-02-06','10:00:00',1.83),('9303','2014-02-06','10:05:00',1.86),('9303','2014-02-06','10:10:00',1.89),('9303','2014-02-06','10:15:00',1.93),('9303','2014-02-06','10:20:00',1.95),('9303','2014-02-06','10:25:00',1.9),('9303','2014-02-06','10:30:00',1.97),('9303','2014-02-06','10:35:00',2.11),('9303','2014-02-06','10:40:00',1.34),('9303','2014-02-06','10:45:00',1.56),('9303','2014-02-06','10:50:00',1.67),('9303','2014-02-06','10:55:00',1.87),('9303','2014-02-06','11:00:00',2.32),('9303','2014-02-06','11:10:00',1.97),('9303','2014-02-06','11:15:00',1.72),('9303','2014-02-06','11:20:00',1.4),('9303','2014-02-06','11:25:00',2.25),('9303','2014-02-06','11:30:00',2.45),('9303','2014-02-06','11:35:00',2.6),('9303','2014-02-06','11:40:00',2.49),('9303','2014-02-06','11:45:00',2.5),('9303','2014-02-06','11:50:00',2.54),('9303','2014-02-06','11:55:00',2.52),('9303','2014-02-06','12:00:00',2.59),('9303','2014-02-06','12:05:00',2.71),('9303','2014-02-06','12:10:00',2.67),('9303','2014-02-06','12:15:00',2.63),('9303','2014-02-06','12:20:00',2.61),('9303','2014-02-06','12:25:00',2.64),('9303','2014-02-06','12:30:00',2.64),('9303','2014-02-06','12:35:00',2.47),('9303','2014-02-06','12:40:00',2.23),('9303','2014-02-06','12:45:00',2.52),('9303','2014-02-06','12:50:00',2.64),('9303','2014-02-06','12:55:00',2.65),('9303','2014-02-06','13:00:00',2.63),('9303','2014-02-06','13:05:00',2.48),('9303','2014-02-06','13:10:00',2.63),('9303','2014-02-06','13:15:00',2.51),('9303','2014-02-06','13:20:00',2.55),('9303','2014-02-06','13:25:00',2.57),('9303','2014-02-06','13:30:00',1.7),('9303','2014-02-06','13:35:00',1.86),('9303','2014-02-06','13:40:00',2.24),('9303','2014-02-06','13:45:00',2.02),('9303','2014-02-06','13:50:00',1.63),('9303','2014-02-06','13:55:00',1.65),('9303','2014-02-06','14:00:00',2.14),('9303','2014-02-06','14:05:00',1.84),('9303','2014-02-06','14:10:00',2.09),('9303','2014-02-06','14:15:00',1.95),('9303','2014-02-06','14:20:00',1.91),('9303','2014-02-06','14:25:00',1.66),('9303','2014-02-06','14:30:00',1.09),('9303','2014-02-06','14:35:00',1.95),('9303','2014-02-06','14:40:00',1.91),('9303','2014-02-06','14:45:00',1.38),('9303','2014-02-06','14:50:00',1.09),('9303','2014-02-06','14:55:00',1.69),('9303','2014-02-06','15:00:00',1.6),('9303','2014-02-06','15:05:00',1.66),('9303','2014-02-06','15:10:00',1.58),('9303','2014-02-06','15:15:00',1.54),('9303','2014-02-06','15:20:00',1.48),('9303','2014-02-06','15:25:00',1.33),('9303','2014-02-06','15:30:00',1.23),('9303','2014-02-06','15:35:00',1.17),('9303','2014-02-06','15:40:00',1.09),('9303','2014-02-06','15:45:00',1.01),('9303','2014-04-27','10:05:00',1.05),('9303','2014-04-27','10:10:00',1.13),('9303','2014-04-27','10:20:00',1.07),('9303','2014-04-27','11:05:00',1.21),('9303','2014-04-27','11:10:00',1.27),('9303','2014-04-27','11:15:00',1.19),('9303','2014-04-27','11:35:00',1.21),('9303','2014-04-27','11:40:00',1.39),('9303','2014-04-27','11:45:00',2.66),('9303','2014-04-27','11:50:00',2.96),('9303','2014-04-27','11:55:00',2.38),('9303','2014-04-27','12:00:00',2.39),('9303','2014-04-27','12:05:00',2.55),('9303','2014-04-27','12:10:00',2.87),('9303','2014-04-27','12:15:00',2.62),('9303','2014-04-27','12:20:00',2.83),('9303','2014-04-27','12:25:00',2.67),('9303','2014-04-27','12:30:00',2.41),('9303','2014-04-27','12:35:00',2.45),('9303','2014-04-27','12:40:00',2.17),('9303','2014-04-27','12:45:00',2.35),('9303','2014-04-27','12:50:00',2.11),('9303','2014-04-27','12:55:00',1.56),('9303','2014-04-27','13:00:00',1.86),('9303','2014-04-27','13:05:00',2.04),('9303','2014-04-27','13:10:00',1.71),('9303','2014-04-27','13:15:00',1.75),('9303','2014-04-27','13:20:00',2.27),('9303','2014-04-27','13:25:00',2.11),('9303','2014-04-27','13:30:00',1.87),('9303','2014-04-27','13:35:00',1.68),('9303','2014-04-27','13:40:00',1.52),('9303','2014-04-27','13:45:00',1.53),('9303','2014-04-27','13:50:00',1.46),('9303','2014-04-27','13:55:00',1.4),('9303','2014-04-27','14:00:00',1.72),('9303','2014-04-27','14:05:00',2.2),('9303','2014-04-27','14:10:00',1.61),('9303','2014-04-27','14:15:00',1.36),('9303','2014-04-27','14:20:00',1.63),('9303','2014-04-27','14:25:00',2.05),('9303','2014-04-27','14:30:00',2.17),('9303','2014-04-27','14:35:00',2.12),('9303','2014-04-27','14:40:00',2.21),('9303','2014-04-27','14:45:00',1.94),('9303','2014-04-27','14:50:00',1.8),('9303','2014-04-27','14:55:00',1.93),('9303','2014-04-27','15:00:00',2.05),('9303','2014-04-27','15:05:00',2.86),('9303','2014-04-27','15:10:00',3.63),('9303','2014-04-27','15:15:00',2.97),('9303','2014-04-27','15:20:00',1.8),('9303','2014-04-27','15:25:00',1.12),('9303','2014-04-27','15:40:00',1.04),('9303','2014-02-05','10:15:00',1.19),('9303','2014-02-05','10:20:00',2.01),('9303','2014-02-05','10:25:00',2.23),('9303','2014-02-05','10:35:00',1.08),('9303','2014-02-05','10:40:00',1.12),('9303','2014-02-05','11:15:00',1.87),('9303','2014-02-05','11:20:00',2.88),('9303','2014-02-05','11:25:00',2.54),('9303','2014-02-05','11:30:00',1.23),('9303','2014-02-05','12:55:00',1.15),('9303','2014-02-05','13:05:00',1.01),('9303','2014-02-05','13:10:00',1.09),('9303','2014-02-05','13:15:00',1.06),('9303','2014-02-05','13:20:00',1.14),('9303','2014-02-05','13:25:00',1.55),('9303','2014-02-05','13:30:00',1.55),('9303','2014-02-05','13:35:00',1.86),('9303','2014-02-05','13:40:00',1.86),('9303','2014-02-05','13:45:00',1.91),('9303','2014-02-05','13:50:00',1.47),('9303','2014-02-05','13:55:00',1.06),('9303','2014-02-05','14:30:00',1.44),('9303','2014-02-05','14:35:00',1.72),('9303','2014-02-04','09:20:00',1.32),('9303','2014-02-04','09:25:00',1.22),('9303','2014-02-04','09:30:00',1.59),('9303','2014-02-04','09:35:00',1.98),('9303','2014-02-04','09:40:00',1.89),('9303','2014-02-04','09:45:00',1.73),('9303','2014-02-04','09:50:00',1.5),('9303','2014-02-04','09:55:00',1.73),('9303','2014-02-04','10:00:00',1.8),('9303','2014-02-04','10:05:00',1.88),('9303','2014-02-04','10:15:00',1.46),('9303','2014-02-04','10:45:00',1.09),('9303','2014-02-04','10:50:00',1.35),('9303','2014-02-04','10:55:00',1.86),('9303','2014-02-04','11:00:00',1.65),('9303','2014-02-04','11:55:00',1.98),('9303','2014-02-04','12:00:00',2.58),('9303','2014-02-04','12:05:00',1.13),('9303','2014-02-04','12:10:00',1.32),('9303','2014-02-04','12:15:00',1.36),('9303','2014-02-04','12:20:00',1.27),('9303','2014-02-04','12:25:00',1.22),('9303','2014-02-04','12:30:00',1.03),('9303','2014-02-04','13:00:00',1.02),('9303','2014-02-04','13:05:00',1.15),('9303','2014-02-04','13:20:00',1.28),('9303','2014-02-04','13:25:00',1.16),('9303','2014-02-03','10:40:00',1.02),('9303','2014-02-03','10:45:00',1.02),('9303','2014-02-03','10:50:00',1.02),('9303','2014-02-03','10:55:00',1.03),('9303','2014-02-03','11:25:00',1.03),('9303','2014-02-03','11:30:00',1.12),('9303','2014-02-03','11:35:00',1.18),('9303','2014-02-03','11:40:00',1.16),('9303','2014-02-03','11:45:00',1.14),('9303','2014-02-03','11:50:00',1.09),('9303','2014-02-01','11:00:00',1.02),('9303','2014-02-01','11:20:00',1.71),('9303','2014-02-01','11:25:00',1.09),('9303','2014-02-01','11:30:00',1.53),('9303','2014-02-01','11:35:00',1.52),('9303','2014-02-01','11:55:00',1.49),('9303','2014-02-01','12:00:00',1.39),('9303','2014-02-01','12:05:00',1.15),('9303','2014-02-01','12:10:00',1.67),('9303','2014-02-01','12:15:00',1.01),('9303','2014-02-01','12:20:00',1.7),('9303','2014-02-01','12:25:00',1.35),('9303','2014-02-01','12:40:00',1.05),('9303','2014-02-01','12:45:00',1.77),('9303','2014-02-01','12:50:00',1.71),('9303','2014-02-01','12:55:00',1.33),('9303','2014-02-01','13:00:00',1.37),('9303','2014-02-01','13:05:00',1.06),('9303','2014-01-30','09:50:00',1.12),('9303','2014-01-30','09:55:00',1.76),('9303','2014-01-30','10:00:00',1.7),('9303','2014-01-30','10:05:00',1.46),('9303','2014-01-30','10:10:00',1.61),('9303','2014-01-30','10:15:00',1.92),('9303','2014-01-30','10:20:00',1.62),('9303','2014-01-30','10:25:00',1.72),('9303','2014-01-30','10:30:00',1.95),('9303','2014-01-30','10:35:00',1.96),('9303','2014-01-30','10:40:00',1.98),('9303','2014-01-30','10:45:00',1.75),('9303','2014-01-30','10:50:00',2.01),('9303','2014-01-30','10:55:00',2.49),('9303','2014-01-30','11:00:00',2.5),('9303','2014-01-30','11:05:00',2.41),('9303','2014-01-30','11:10:00',2.29),('9303','2014-01-30','11:15:00',2.15),('9303','2014-01-30','11:20:00',1.84),('9303','2014-01-30','11:25:00',1.92),('9303','2014-01-30','11:30:00',1.95),('9303','2014-01-30','11:35:00',2.09),('9303','2014-01-30','11:40:00',1.06),('9303','2014-01-30','11:45:00',2.02),('9303','2014-01-30','11:50:00',1.49),('9303','2014-01-30','11:55:00',2.63),('9303','2014-01-30','12:00:00',1.54),('9303','2014-01-30','12:05:00',2.52),('9303','2014-01-30','12:10:00',1.76),('9303','2014-01-30','12:15:00',1.99),('9303','2014-01-30','12:20:00',2.24),('9303','2014-01-30','12:25:00',2.31),('9303','2014-01-30','12:30:00',1.93),('9303','2014-01-30','12:35:00',2.21),('9303','2014-01-30','12:40:00',2.09),('9303','2014-01-30','12:45:00',2.33),('9303','2014-01-30','12:50:00',2.62),('9303','2014-01-30','12:55:00',2.55),('9303','2014-01-30','13:00:00',1.69),('9303','2014-01-30','13:05:00',2.55),('9303','2014-01-30','13:10:00',2.1),('9303','2014-01-30','13:15:00',2.13),('9303','2014-01-30','13:20:00',1.76),('9303','2014-01-30','13:25:00',2.33),('9303','2014-01-30','13:30:00',1.94),('9303','2014-01-30','13:35:00',1.71),('9303','2014-01-30','13:40:00',1.97),('9303','2014-01-30','13:45:00',2.33),('9303','2014-01-30','13:50:00',2.2),('9303','2014-01-30','13:55:00',1.93),('9303','2014-01-30','14:00:00',1.83),('9303','2014-01-30','14:05:00',1.78),('9303','2014-01-30','14:10:00',1.78),('9303','2014-01-30','14:15:00',1.59),('9303','2014-01-30','14:20:00',1.45),('9303','2014-01-30','14:25:00',1.52),('9303','2014-01-30','14:30:00',1.61),('9303','2014-01-30','14:35:00',1.54),('9303','2014-01-30','14:40:00',1.76),('9303','2014-01-30','14:45:00',1.66),('9303','2014-01-30','14:50:00',1.72),('9303','2014-01-30','14:55:00',1.66),('9303','2014-01-30','15:00:00',1.6),('9303','2014-01-30','15:05:00',1.56),('9303','2014-01-30','15:10:00',1.48),('9303','2014-01-30','15:15:00',1.32),('9303','2014-01-30','15:20:00',1.34),('9303','2014-01-30','15:25:00',1.37),('9303','2014-01-30','15:30:00',1.21),('9303','2014-01-30','15:35:00',1.17),('9303','2014-01-30','15:40:00',1.11),('9303','2014-01-29','09:20:00',1.2),('9303','2014-01-29','09:30:00',1.15),('9303','2014-01-29','09:35:00',1.5),('9303','2014-01-29','09:40:00',1.49),('9303','2014-01-29','09:45:00',1.59),('9303','2014-01-29','09:50:00',1.43),('9303','2014-01-29','09:55:00',1.52),('9303','2014-01-29','10:00:00',1.32),('9303','2014-01-29','10:05:00',1.25),('9303','2014-01-29','10:10:00',1.51),('9303','2014-01-29','10:15:00',1.51),('9303','2014-01-29','10:20:00',1.11),('9303','2014-01-29','10:25:00',1.79),('9303','2014-01-29','10:30:00',1.91),('9303','2014-01-29','10:35:00',1.84),('9303','2014-01-29','10:40:00',1.75),('9303','2014-01-29','10:45:00',1.74),('9303','2014-01-29','10:50:00',1.69),('9303','2014-01-29','10:55:00',1.63),('9303','2014-01-29','11:00:00',1.64),('9303','2014-01-29','11:05:00',1.79),('9303','2014-01-29','11:10:00',1.63),('9303','2014-01-29','11:15:00',1.67),('9303','2014-01-29','11:20:00',1.78),('9303','2014-01-29','11:25:00',1.76),('9303','2014-01-29','11:30:00',2.21),('9303','2014-01-29','11:35:00',1.9),('9303','2014-01-29','11:40:00',1.44),('9303','2014-01-29','11:45:00',1.1),('9303','2014-01-29','12:50:00',2.29),('9303','2014-01-29','12:55:00',2.81),('9303','2014-01-29','13:00:00',1.91),('9303','2014-01-29','13:05:00',1.23),('9303','2014-01-29','13:35:00',1.61),('9303','2014-01-29','13:40:00',2.2),('9303','2014-01-29','13:45:00',1.42),('9303','2014-01-29','13:50:00',1.63),('9303','2014-01-29','13:55:00',1.6),('9303','2014-01-29','14:00:00',1.28),('9303','2014-01-29','15:15:00',1.18),('9303','2014-01-28','09:15:00',1.03),('9303','2014-01-28','09:20:00',1.08),('9303','2014-01-28','09:25:00',1.13),('9303','2014-01-28','09:30:00',1.13),('9303','2014-01-28','09:35:00',1.24),('9303','2014-01-28','09:40:00',1.15),('9303','2014-01-28','09:45:00',1.21),('9303','2014-01-28','09:50:00',1.57),('9303','2014-01-28','09:55:00',1.65),('9303','2014-01-28','10:00:00',1.76),('9303','2014-01-28','10:05:00',1.71),('9303','2014-01-28','10:10:00',1.71),('9303','2014-01-28','10:15:00',1.67),('9303','2014-01-28','10:20:00',1.77),('9303','2014-01-28','10:25:00',1.87),('9303','2014-01-28','10:30:00',1.85),('9303','2014-01-28','10:35:00',1.94),('9303','2014-01-28','10:40:00',2),('9303','2014-01-28','10:45:00',1.7),('9303','2014-01-28','10:50:00',2),('9303','2014-01-28','10:55:00',2.04),('9303','2014-01-28','11:00:00',2.07),('9303','2014-01-28','11:05:00',1.07),('9303','2014-01-28','11:10:00',1.61),('9303','2014-01-28','11:15:00',1.41),('9303','2014-01-28','11:25:00',1.38),('9303','2014-01-28','11:30:00',1.82),('9303','2014-01-28','11:35:00',1.59),('9303','2014-01-28','11:40:00',2.55),('9303','2014-01-28','11:45:00',1.43),('9303','2014-01-28','12:00:00',2.24),('9303','2014-01-28','12:05:00',1.66),('9303','2014-01-28','12:10:00',1.69),('9303','2014-01-28','12:15:00',2.05),('9303','2014-01-28','12:20:00',1.67),('9303','2014-01-28','12:25:00',1.09),('9303','2014-01-28','12:30:00',1.07),('9303','2014-01-28','12:35:00',1.2),('9303','2014-01-28','12:40:00',1.66),('9303','2014-01-28','12:45:00',1.72),('9303','2014-01-28','12:50:00',2.78),('9303','2014-01-28','12:55:00',2.58),('9303','2014-01-28','13:00:00',2.94),('9303','2014-01-28','13:05:00',3.13),('9303','2014-01-28','13:10:00',2.28),('9303','2014-01-28','13:15:00',1.95),('9303','2014-01-28','13:20:00',2.03),('9303','2014-01-28','13:25:00',2.38),('9303','2014-01-28','13:30:00',2.22),('9303','2014-01-28','13:35:00',2.5),('9303','2014-01-28','13:40:00',2.4),('9303','2014-01-28','13:45:00',2.27),('9303','2014-01-28','13:50:00',2.19),('9303','2014-01-28','13:55:00',2.15),('9303','2014-01-28','14:00:00',2.1),('9303','2014-01-28','14:05:00',2.05),('9303','2014-01-28','14:10:00',1.97),('9303','2014-01-28','14:15:00',1.94),('9303','2014-01-28','14:20:00',1.74),('9303','2014-01-28','14:25:00',1.96),('9303','2014-01-28','14:30:00',1.96),('9303','2014-01-28','14:35:00',1.77),('9303','2014-01-28','14:40:00',1.64),('9303','2014-01-28','14:45:00',1.75),('9303','2014-01-28','14:50:00',1.58),('9303','2014-01-28','14:55:00',1.64),('9303','2014-01-28','15:00:00',1.61),('9303','2014-01-28','15:05:00',1.54),('9303','2014-01-28','15:10:00',1.48),('9303','2014-01-28','15:15:00',1.39),('9303','2014-01-28','15:20:00',1.28),('9303','2014-01-28','15:25:00',1.21),('9303','2014-01-28','15:30:00',1.13),('9303','2014-01-28','15:35:00',1.06),('9650','2014-05-04','08:20:00',1.02),('9650','2014-05-04','08:25:00',1.12),('9650','2014-05-04','08:30:00',1.22),('9650','2014-05-04','08:35:00',1.28),('9650','2014-05-04','08:40:00',1.32),('9650','2014-05-04','08:45:00',1.44),('9650','2014-05-04','08:50:00',1.87),('9650','2014-05-04','08:55:00',2.04),('9650','2014-05-04','09:00:00',2.15),('9650','2014-05-04','09:05:00',2.27),('9650','2014-05-04','09:10:00',2.44),('9650','2014-05-04','09:15:00',2.64),('9650','2014-05-04','09:20:00',2.78),('9650','2014-05-04','09:25:00',2.92),('9650','2014-05-04','09:30:00',3.13),('9650','2014-05-04','09:35:00',3.26),('9650','2014-05-04','09:40:00',3.38),('9650','2014-05-04','09:45:00',3.52),('9650','2014-05-04','09:50:00',3.66),('9650','2014-05-04','09:55:00',3.81),('9650','2014-05-04','10:00:00',3.92),('9650','2014-05-04','10:05:00',4.08),('9650','2014-05-04','10:10:00',4.2),('9650','2014-05-04','10:15:00',4.32),('9650','2014-05-04','10:20:00',4.41),('9650','2014-05-04','10:25:00',4.56),('9650','2014-05-04','10:30:00',4.69),('9650','2014-05-04','10:35:00',4.84),('9650','2014-05-04','10:40:00',4.92),('9650','2014-05-04','10:45:00',5.06),('9650','2014-05-04','10:50:00',5.17),('9650','2014-05-04','10:55:00',5.25),('9650','2014-05-04','11:00:00',5.38),('9650','2014-05-04','11:05:00',5.47),('9650','2014-05-04','11:10:00',5.6),('9650','2014-05-04','11:15:00',5.79),('9650','2014-05-04','11:20:00',5.77),('9650','2014-05-04','11:25:00',5.6),('9650','2014-05-04','11:30:00',5.91),('9650','2014-05-04','11:35:00',5.99),('9650','2014-05-04','11:40:00',6.1),('9650','2014-05-04','11:45:00',6.27),('9650','2014-05-04','11:50:00',6.36),('9650','2014-05-04','11:55:00',6.67),('9650','2014-05-04','12:00:00',6.68),('9650','2014-05-04','12:05:00',4.57),('9650','2014-05-04','12:10:00',1.9),('9650','2014-05-04','12:15:00',3.96),('9650','2014-05-04','12:20:00',3.11),('9650','2014-05-04','12:25:00',3.36),('9650','2014-05-04','12:30:00',5.74),('9650','2014-05-04','12:35:00',4.25),('9650','2014-05-04','12:40:00',3.52),('9650','2014-05-04','12:45:00',4.37),('9650','2014-05-04','12:50:00',7.74),('9650','2014-05-04','12:55:00',2.58),('9650','2014-05-04','13:00:00',2.18),('9650','2014-05-04','13:05:00',4.88),('9650','2014-05-04','13:10:00',7.87),('9650','2014-05-04','13:15:00',7.6),('9650','2014-05-04','13:20:00',7.49),('9650','2014-05-04','13:25:00',7.41),('9650','2014-05-04','13:30:00',7.5),('9650','2014-05-04','13:35:00',7.48),('9650','2014-05-04','13:40:00',7.58),('9650','2014-05-04','13:45:00',7.68),('9650','2014-05-04','13:50:00',7.71),('9650','2014-05-04','13:55:00',7.72),('9650','2014-05-04','14:00:00',7.66),('9650','2014-05-04','14:05:00',6.7),('9650','2014-05-04','14:10:00',6.37),('9650','2014-05-04','14:15:00',6.14),('9650','2014-05-04','14:20:00',8.64),('9650','2014-05-04','14:25:00',8.28),('9650','2014-05-04','14:30:00',6.01),('9650','2014-05-04','14:35:00',4.36),('9650','2014-05-04','14:40:00',3.75),('9650','2014-05-04','14:45:00',2.51),('9650','2014-05-04','14:50:00',2.51),('9650','2014-05-04','14:55:00',2.91),('9650','2014-05-04','15:00:00',4.18),('9650','2014-05-04','15:05:00',6.12),('9650','2014-05-04','15:10:00',4.07),('9650','2014-05-04','15:15:00',2.26),('9650','2014-05-04','15:20:00',2.32),('9650','2014-05-04','15:25:00',3.35),('9650','2014-05-04','15:30:00',4.54),('9650','2014-05-04','15:35:00',4.44),('9650','2014-05-04','15:40:00',5.83),('9650','2014-05-04','15:45:00',5.7),('9650','2014-05-04','15:50:00',2.13),('9650','2014-05-04','15:55:00',2.18),('9650','2014-05-04','16:00:00',2.37),('9650','2014-05-04','16:05:00',5.66),('9650','2014-05-04','16:10:00',2.54),('9650','2014-05-04','16:15:00',2.51),('9650','2014-05-04','16:20:00',3.27),('9650','2014-05-04','16:25:00',2.11),('9650','2014-05-04','16:30:00',2.31),('9650','2014-05-04','16:35:00',5.28),('9650','2014-05-04','16:40:00',4.13),('9650','2014-05-04','16:45:00',5.37),('9650','2014-05-04','16:50:00',6.64),('9650','2014-05-04','16:55:00',6.23),('9650','2014-05-04','17:00:00',5.75),('9650','2014-05-04','17:05:00',5.55),('9650','2014-05-04','17:10:00',5.63),('9650','2014-05-04','17:15:00',5.53),('9650','2014-05-04','17:20:00',5.4),('9650','2014-05-04','17:25:00',5.2),('9650','2014-05-04','17:30:00',4.99),('9650','2014-05-04','17:35:00',4.85),('9650','2014-05-04','17:40:00',4.79),('9650','2014-05-04','17:45:00',4.63),('9650','2014-05-04','17:50:00',4.47),('9650','2014-05-04','17:55:00',4.35),('9650','2014-05-04','18:00:00',4.16),('9650','2014-05-04','18:05:00',4.01),('9650','2014-05-04','18:10:00',3.93),('9650','2014-05-04','18:15:00',3.78),('9650','2014-05-04','18:20:00',3.59),('9650','2014-05-04','18:25:00',3.41),('9650','2014-05-04','18:30:00',3.23),('9650','2014-05-04','18:35:00',3.09),('9650','2014-05-04','18:40:00',2.91),('9650','2014-05-04','18:45:00',2.73),('9650','2014-05-04','18:50:00',2.54),('9650','2014-05-04','18:55:00',2.36),('9650','2014-05-04','19:00:00',2.13),('9650','2014-05-04','19:05:00',1.91),('9650','2014-05-04','19:10:00',1.71),('9650','2014-05-04','19:15:00',1.52),('9650','2014-05-04','19:20:00',1.29),('9650','2014-05-04','19:25:00',1.12),('9650','2014-04-25','08:05:00',1.02),('9650','2014-04-25','08:10:00',1.12),('9650','2014-04-25','08:15:00',1.15),('9650','2014-04-25','08:20:00',1.17),('9650','2014-04-25','08:25:00',1.19),('9650','2014-04-25','08:30:00',1.13),('9650','2014-04-25','08:35:00',1.17),('9650','2014-04-25','08:40:00',1.24),('9650','2014-04-25','08:45:00',1.28),('9650','2014-04-25','08:50:00',1.3),('9650','2014-04-25','08:55:00',1.31),('9650','2014-04-25','09:00:00',1.31),('9650','2014-04-25','09:05:00',1.79),('9650','2014-04-25','09:10:00',1.6),('9650','2014-04-25','09:15:00',1.41),('9650','2014-04-25','09:20:00',1.43),('9650','2014-04-25','09:25:00',1.44),('9650','2014-04-25','09:30:00',1.43),('9650','2014-04-25','09:35:00',1.55),('9650','2014-04-25','09:40:00',1.64),('9650','2014-04-25','09:45:00',1.46),('9650','2014-04-25','09:50:00',1.66),('9650','2014-04-25','09:55:00',2.35),('9650','2014-04-25','10:00:00',2.51),('9650','2014-04-25','10:05:00',2.29),('9650','2014-04-25','10:10:00',2.21),('9650','2014-04-25','10:15:00',2.31),('9650','2014-04-25','10:20:00',2.53),('9650','2014-04-25','10:25:00',2.76),('9650','2014-04-25','10:30:00',3.07),('9650','2014-04-25','10:35:00',3.41),('9650','2014-04-25','10:40:00',3.49),('9650','2014-04-25','10:45:00',3.39),('9650','2014-04-25','10:50:00',3.99),('9650','2014-04-25','10:55:00',5.2),('9650','2014-04-25','11:00:00',5.19),('9650','2014-04-25','11:05:00',4.91),('9650','2014-04-25','11:10:00',4.67),('9650','2014-04-25','11:15:00',4.61),('9650','2014-04-25','11:20:00',4.33),('9650','2014-04-25','11:25:00',4.34),('9650','2014-04-25','11:30:00',4.54),('9650','2014-04-25','11:35:00',4.43),('9650','2014-04-25','11:40:00',4.14),('9650','2014-04-25','11:45:00',4.55),('9650','2014-04-25','11:50:00',4.57),('9650','2014-04-25','11:55:00',4.3),('9650','2014-04-25','12:00:00',4.59),('9650','2014-04-25','12:05:00',4.95),('9650','2014-04-25','12:10:00',5),('9650','2014-04-25','12:15:00',4.69),('9650','2014-04-25','12:20:00',4.61),('9650','2014-04-25','12:25:00',3.9),('9650','2014-04-25','12:30:00',3.81),('9650','2014-04-25','12:35:00',5.74),('9650','2014-04-25','12:40:00',5.66),('9650','2014-04-25','12:45:00',5.98),('9650','2014-04-25','12:50:00',6.84),('9650','2014-04-25','12:55:00',6.68),('9650','2014-04-25','13:00:00',5.98),('9650','2014-04-25','13:05:00',4.94),('9650','2014-04-25','13:10:00',5.66),('9650','2014-04-25','13:15:00',7.16),('9650','2014-04-25','13:20:00',7.82),('9650','2014-04-25','13:25:00',6.37),('9650','2014-04-25','13:30:00',2.59),('9650','2014-04-25','13:35:00',3.49),('9650','2014-04-25','13:40:00',7.86),('9650','2014-04-25','13:45:00',7.29),('9650','2014-04-25','13:50:00',7.24),('9650','2014-04-25','13:55:00',7.6),('9650','2014-04-25','14:00:00',5.51),('9650','2014-04-25','14:05:00',1.26),('9650','2014-04-25','14:10:00',3.72),('9650','2014-04-25','14:15:00',3.29),('9650','2014-04-25','14:20:00',1.06),('9650','2014-04-25','14:25:00',1.68),('9650','2014-04-25','14:30:00',1.71),('9650','2014-04-25','14:35:00',2.57),('9650','2014-04-25','14:40:00',4.36),('9650','2014-04-25','14:45:00',1.44),('9650','2014-04-25','17:40:00',1.13),('9650','2014-04-25','17:45:00',1.32),('9650','2014-04-25','17:50:00',1.6),('9650','2014-04-25','17:55:00',1.48),('9650','2014-04-25','18:30:00',1.13),('9650','2014-04-25','18:35:00',1.37),('9650','2014-04-25','18:40:00',2.08),('9650','2014-04-25','18:45:00',2.59),('9650','2014-04-25','18:50:00',2.37),('9650','2014-04-25','18:55:00',1.25),('9650','2014-04-24','08:25:00',1.02),('9650','2014-04-24','08:30:00',1.11),('9650','2014-04-24','08:35:00',1.2),('9650','2014-04-24','08:40:00',1.28),('9650','2014-04-24','08:45:00',1.42),('9650','2014-04-24','08:50:00',1.6),('9650','2014-04-24','08:55:00',1.72),('9650','2014-04-24','09:00:00',1.52),('9650','2014-04-24','09:05:00',1.54),('9650','2014-04-24','09:10:00',1.88),('9650','2014-04-24','09:15:00',1.73),('9650','2014-04-24','09:20:00',1.47),('9650','2014-04-24','09:25:00',1.77),('9650','2014-04-24','09:30:00',1.69),('9650','2014-04-24','09:35:00',1.72),('9650','2014-04-24','09:40:00',1.6),('9650','2014-04-24','09:45:00',1.69),('9650','2014-04-24','09:50:00',1.68),('9650','2014-04-24','09:55:00',1.83),('9650','2014-04-24','10:00:00',2.15),('9650','2014-04-24','10:05:00',2.06),('9650','2014-04-24','10:10:00',2.17),('9650','2014-04-24','10:15:00',2.16),('9650','2014-04-24','10:20:00',2.26),('9650','2014-04-24','10:25:00',2.35),('9650','2014-04-24','10:30:00',2.51),('9650','2014-04-24','10:35:00',4.43),('9650','2014-04-24','10:40:00',3.51),('9650','2014-04-24','10:45:00',4.95),('9650','2014-04-24','10:50:00',3.48),('9650','2014-04-24','10:55:00',4.61),('9650','2014-04-24','11:00:00',4.62),('9650','2014-04-24','11:05:00',3.18),('9650','2014-04-24','11:10:00',4.04),('9650','2014-04-24','11:15:00',5.37),('9650','2014-04-24','11:20:00',4.37),('9650','2014-04-24','11:25:00',3.52),('9650','2014-04-24','11:30:00',2.49),('9650','2014-04-24','11:35:00',4.38),('9650','2014-04-24','11:40:00',4.9),('9650','2014-04-24','11:45:00',2.16),('9650','2014-04-24','11:50:00',2.4),('9650','2014-04-24','11:55:00',5.05),('9650','2014-04-24','12:00:00',4.43),('9650','2014-04-24','12:05:00',6.04),('9650','2014-04-24','12:10:00',7.11),('9650','2014-04-24','12:15:00',4.17),('9650','2014-04-24','12:20:00',5.58),('9650','2014-04-24','12:25:00',4.26),('9650','2014-04-24','12:30:00',6.27),('9650','2014-04-24','12:35:00',7.07),('9650','2014-04-24','12:40:00',7.45),('9650','2014-04-24','12:45:00',7.65),('9650','2014-04-24','12:50:00',4.06),('9650','2014-04-24','12:55:00',3.41),('9650','2014-04-24','13:00:00',4.44),('9650','2014-04-24','13:05:00',3.33),('9650','2014-04-24','13:10:00',5.72),('9650','2014-04-24','13:15:00',2.6),('9650','2014-04-24','13:20:00',2.02),('9650','2014-04-24','13:25:00',5.11),('9650','2014-04-24','13:30:00',2.2),('9650','2014-04-24','13:35:00',1.89),('9650','2014-04-24','13:40:00',2.55),('9650','2014-04-24','13:45:00',2.79),('9650','2014-04-24','13:50:00',2.19),('9650','2014-04-24','13:55:00',4.48),('9650','2014-04-24','14:00:00',2.52),('9650','2014-04-24','14:05:00',2.6),('9650','2014-04-24','14:10:00',2.13),('9650','2014-04-24','14:15:00',2.27),('9650','2014-04-24','14:20:00',6.77),('9650','2014-04-24','14:25:00',5.81),('9650','2014-04-24','14:30:00',4.58),('9650','2014-04-24','14:35:00',5.16),('9650','2014-04-24','14:40:00',7),('9650','2014-04-24','14:45:00',7.03),('9650','2014-04-24','14:50:00',7),('9650','2014-04-24','14:55:00',6.96),('9650','2014-04-24','15:00:00',6.81),('9650','2014-04-24','15:05:00',6.79),('9650','2014-04-24','15:10:00',6.77),('9650','2014-04-24','15:15:00',6.71),('9650','2014-04-24','15:20:00',6.48),('9650','2014-04-24','15:25:00',6.48),('9650','2014-04-24','15:30:00',6.36),('9650','2014-04-24','15:35:00',6.62),('9650','2014-04-24','15:40:00',6.47),('9650','2014-04-24','15:45:00',6.32),('9650','2014-04-24','15:50:00',6.28),('9650','2014-04-24','15:55:00',6.26),('9650','2014-04-24','16:00:00',6.26),('9650','2014-04-24','16:05:00',6.03),('9650','2014-04-24','16:10:00',5.86),('9650','2014-04-24','16:15:00',5.7),('9650','2014-04-24','16:20:00',5.3),('9650','2014-04-24','16:25:00',5.49),('9650','2014-04-24','16:30:00',5.75),('9650','2014-04-24','16:35:00',5.84),('9650','2014-04-24','16:40:00',5.92),('9650','2014-04-24','16:45:00',5.7),('9650','2014-04-24','16:50:00',5.22),('9650','2014-04-24','16:55:00',4.49),('9650','2014-04-24','17:00:00',4.39),('9650','2014-04-24','17:05:00',4.87),('9650','2014-04-24','17:10:00',4.17),('9650','2014-04-24','17:15:00',4.42),('9650','2014-04-24','17:20:00',3.06),('9650','2014-04-24','17:25:00',2.28),('9650','2014-04-24','17:30:00',2.41),('9650','2014-04-24','17:35:00',2.42),('9650','2014-04-24','17:40:00',2.33),('9650','2014-04-24','17:45:00',2.03),('9650','2014-04-24','17:50:00',1.78),('9650','2014-04-24','17:55:00',1.67),('9650','2014-04-24','18:00:00',1.62),('9650','2014-04-24','18:05:00',1.73),('9650','2014-04-24','18:10:00',1.76),('9650','2014-04-24','18:15:00',1.39),('9650','2014-04-24','18:20:00',1.44),('9650','2014-04-24','18:25:00',1.5),('9650','2014-04-24','18:30:00',1.4),('9650','2014-04-24','18:35:00',1.35),('9650','2014-04-24','18:40:00',1.26),('9650','2014-04-24','18:45:00',1.09),('9650','2014-04-24','18:50:00',1),('9650','2014-04-24','19:05:00',1.24),('9650','2014-04-24','19:10:00',1.76),('9650','2014-04-24','19:15:00',1.62),('9650','2014-04-24','19:20:00',1.34),('9650','2014-04-23','08:30:00',1.04),('9650','2014-04-23','08:35:00',1.14),('9650','2014-04-23','08:40:00',1.25),('9650','2014-04-23','08:45:00',1.35),('9650','2014-04-23','08:50:00',1.47),('9650','2014-04-23','08:55:00',1.59),('9650','2014-04-23','09:00:00',1.72),('9650','2014-04-23','09:05:00',1.84),('9650','2014-04-23','09:10:00',1.97),('9650','2014-04-23','09:15:00',2.11),('9650','2014-04-23','09:20:00',2.25),('9650','2014-04-23','09:25:00',2.37),('9650','2014-04-23','09:30:00',2.5),('9650','2014-04-23','09:35:00',2.63),('9650','2014-04-23','09:40:00',2.76),('9650','2014-04-23','09:45:00',2.9),('9650','2014-04-23','09:50:00',3.02),('9650','2014-04-23','09:55:00',3.15),('9650','2014-04-23','10:00:00',3.27),('9650','2014-04-23','10:05:00',3.37),('9650','2014-04-23','10:10:00',3.49),('9650','2014-04-23','10:15:00',3.6),('9650','2014-04-23','10:20:00',3.72),('9650','2014-04-23','10:25:00',3.88),('9650','2014-04-23','10:30:00',3.99),('9650','2014-04-23','10:35:00',4.09),('9650','2014-04-23','10:40:00',4.21),('9650','2014-04-23','10:45:00',4.32),('9650','2014-04-23','10:50:00',4.44),('9650','2014-04-23','10:55:00',4.56),('9650','2014-04-23','11:00:00',4.63),('9650','2014-04-23','11:05:00',4.7),('9650','2014-04-23','11:10:00',4.83),('9650','2014-04-23','11:15:00',4.91),('9650','2014-04-23','11:20:00',4.98),('9650','2014-04-23','11:25:00',5.11),('9650','2014-04-23','11:30:00',5.18),('9650','2014-04-23','11:35:00',5.24),('9650','2014-04-23','11:40:00',5.38),('9650','2014-04-23','11:45:00',5.46),('9650','2014-04-23','11:50:00',5.41),('9650','2014-04-23','11:55:00',5.44),('9650','2014-04-23','12:00:00',5.61),('9650','2014-04-23','12:05:00',5.81),('9650','2014-04-23','12:10:00',5.86),('9650','2014-04-23','12:15:00',6.05),('9650','2014-04-23','12:20:00',5.46),('9650','2014-04-23','12:25:00',6.09),('9650','2014-04-23','12:30:00',6.21),('9650','2014-04-23','12:35:00',6.33),('9650','2014-04-23','12:40:00',6.26),('9650','2014-04-23','12:45:00',6.25),('9650','2014-04-23','12:50:00',6.36),('9650','2014-04-23','12:55:00',6.52),('9650','2014-04-23','13:00:00',6.54),('9650','2014-04-23','13:05:00',6.43),('9650','2014-04-23','13:10:00',6.67),('9650','2014-04-23','13:15:00',6.87),('9650','2014-04-23','13:20:00',6.84),('9650','2014-04-23','13:25:00',6.79),('9650','2014-04-23','13:30:00',5.98),('9650','2014-04-23','13:35:00',3.66),('9650','2014-04-23','13:40:00',1.81),('9650','2014-04-23','13:45:00',1.97),('9650','2014-04-23','13:50:00',7.36),('9650','2014-04-23','13:55:00',7.43),('9650','2014-04-23','14:00:00',6.09),('9650','2014-04-23','14:05:00',7.7),('9650','2014-04-23','14:10:00',8.09),('9650','2014-04-23','14:15:00',4.91),('9650','2014-04-23','14:20:00',6.01),('9650','2014-04-23','14:25:00',6.93),('9650','2014-04-23','14:30:00',6.66),('9650','2014-04-23','14:35:00',7.53),('9650','2014-04-23','14:40:00',5.42),('9650','2014-04-23','14:45:00',3.94),('9650','2014-04-23','14:50:00',3.6),('9650','2014-04-23','14:55:00',7.86),('9650','2014-04-23','15:00:00',8.08),('9650','2014-04-23','15:05:00',7.99),('9650','2014-04-23','15:10:00',8.06),('9650','2014-04-23','15:15:00',7.87),('9650','2014-04-23','15:20:00',4.65),('9650','2014-04-23','15:25:00',3.89),('9650','2014-04-23','15:30:00',4.83),('9650','2014-04-23','15:35:00',4.71),('9650','2014-04-23','15:40:00',4.25),('9650','2014-04-23','15:45:00',3.86),('9650','2014-04-23','15:50:00',4.11),('9650','2014-04-23','15:55:00',4.65),('9650','2014-04-23','16:00:00',7.7),('9650','2014-04-23','16:05:00',7.17),('9650','2014-04-23','16:10:00',6.28),('9650','2014-04-23','16:15:00',6.8),('9650','2014-04-23','16:20:00',6.2),('9650','2014-04-23','16:25:00',6.49),('9650','2014-04-23','16:30:00',5.51),('9650','2014-04-23','16:35:00',3.5),('9650','2014-04-23','16:40:00',3.9),('9650','2014-04-23','16:45:00',3.19),('9650','2014-04-23','16:50:00',2.71),('9650','2014-04-23','16:55:00',2.73),('9650','2014-04-23','17:00:00',2.64),('9650','2014-04-23','17:05:00',2.39),('9650','2014-04-23','17:10:00',2.28),('9650','2014-04-23','17:15:00',2.04),('9650','2014-04-23','17:20:00',2.03),('9650','2014-04-23','17:25:00',2.01),('9650','2014-04-23','17:30:00',1.96),('9650','2014-04-23','17:35:00',1.77),('9650','2014-04-23','17:40:00',1.46),('9650','2014-04-22','10:40:00',1.08),('9650','2014-04-22','10:45:00',1.1),('9650','2014-04-22','10:50:00',1.04),('9650','2014-04-22','11:15:00',1.04),('9650','2014-04-22','11:20:00',1.01),('9650','2014-04-22','11:35:00',1.03),('9650','2014-04-22','11:40:00',1.12),('9650','2014-04-22','11:45:00',1.21),('9650','2014-04-22','12:50:00',1.01),('9650','2014-04-22','12:55:00',1.06),('9650','2014-04-22','13:00:00',1.13),('9650','2014-04-22','13:05:00',1.33),('9650','2014-04-22','13:10:00',1.66),('9650','2014-04-22','13:15:00',1.93),('9650','2014-04-22','13:20:00',2.14),('9650','2014-04-22','13:25:00',2.27),('9650','2014-04-22','13:30:00',2.44),('9650','2014-04-22','13:35:00',2.56),('9650','2014-04-22','13:40:00',2.75),('9650','2014-04-22','13:45:00',2.86),('9650','2014-04-22','13:50:00',2.84),('9650','2014-04-22','13:55:00',2.86),('9650','2014-04-22','14:00:00',2.7),('9650','2014-04-22','14:05:00',2.72),('9650','2014-04-22','14:10:00',2.66),('9650','2014-04-22','14:15:00',2.26),('9650','2014-04-22','14:20:00',1.96),('9650','2014-04-22','14:25:00',1.77),('9650','2014-04-22','14:30:00',1.65),('9650','2014-04-22','14:35:00',1.54),('9650','2014-04-22','14:40:00',1.54),('9650','2014-04-22','14:45:00',1.76),('9650','2014-04-22','14:50:00',2.14),('9650','2014-04-22','14:55:00',2.49),('9650','2014-04-22','15:00:00',2.84),('9650','2014-04-22','15:05:00',3.07),('9650','2014-04-22','15:10:00',2.93),('9650','2014-04-22','15:15:00',3.1),('9650','2014-04-22','15:20:00',2.56),('9650','2014-04-22','15:25:00',2.37),('9650','2014-04-22','15:30:00',2.32),('9650','2014-04-22','15:35:00',2.2),('9650','2014-04-22','15:40:00',2.17),('9650','2014-04-22','15:45:00',2.34),('9650','2014-04-22','15:50:00',1.77),('9650','2014-04-22','15:55:00',1.73),('9650','2014-04-22','16:00:00',1.45),('9650','2014-04-22','16:05:00',1.37),('9650','2014-04-22','16:10:00',1.21),('9650','2014-04-22','16:15:00',1.05),('9650','2014-04-21','08:25:00',1.05),('9650','2014-04-21','08:30:00',1.14),('9650','2014-04-21','08:35:00',1.23),('9650','2014-04-21','08:40:00',1.38),('9650','2014-04-21','08:45:00',1.55),('9650','2014-04-21','08:50:00',1.72),('9650','2014-04-21','08:55:00',1.8),('9650','2014-04-21','09:00:00',1.86),('9650','2014-04-21','09:05:00',2.18),('9650','2014-04-21','09:10:00',1.94),('9650','2014-04-21','09:15:00',2.12),('9650','2014-04-21','09:20:00',2.34),('9650','2014-04-21','09:25:00',2.46),('9650','2014-04-21','09:30:00',2.72),('9650','2014-04-21','09:35:00',2.98),('9650','2014-04-21','09:40:00',3),('9650','2014-04-21','09:45:00',3.37),('9650','2014-04-21','09:50:00',2.95),('9650','2014-04-21','09:55:00',2.21),('9650','2014-04-21','10:00:00',2.2),('9650','2014-04-21','10:05:00',2.4),('9650','2014-04-21','10:10:00',3.02),('9650','2014-04-21','10:15:00',3.06),('9650','2014-04-21','10:20:00',4.23),('9650','2014-04-21','10:25:00',3.33),('9650','2014-04-21','10:30:00',4.95),('9650','2014-04-21','10:35:00',5.03),('9650','2014-04-21','10:40:00',4.68),('9650','2014-04-21','10:45:00',5),('9650','2014-04-21','10:50:00',5.46),('9650','2014-04-21','10:55:00',4.09),('9650','2014-04-21','11:00:00',3.07),('9650','2014-04-21','11:05:00',3.44),('9650','2014-04-21','11:10:00',2.83),('9650','2014-04-21','11:15:00',2.49),('9650','2014-04-21','11:20:00',2.16),('9650','2014-04-21','11:25:00',2.05),('9650','2014-04-21','11:30:00',1.89),('9650','2014-04-21','11:35:00',1.98),('9650','2014-04-21','11:40:00',1.83),('9650','2014-04-21','11:45:00',1.59),('9650','2014-04-21','11:50:00',1.68),('9650','2014-04-21','11:55:00',1.62),('9650','2014-04-21','12:00:00',1.77),('9650','2014-04-21','12:05:00',2.14),('9650','2014-04-21','12:10:00',2.12),('9650','2014-04-21','12:15:00',2.13),('9650','2014-04-21','12:20:00',2.19),('9650','2014-04-21','12:25:00',2.35),('9650','2014-04-21','12:30:00',2.68),('9650','2014-04-21','12:35:00',2.27),('9650','2014-04-21','12:40:00',1.75),('9650','2014-04-21','12:45:00',1.48),('9650','2014-04-21','12:50:00',1.31),('9650','2014-04-21','12:55:00',1.28),('9650','2014-04-21','13:00:00',1.33),('9650','2014-04-21','13:05:00',1.46),('9650','2014-04-21','13:10:00',1.72),('9650','2014-04-21','13:15:00',2.54),('9650','2014-04-21','13:20:00',3.83),('9650','2014-04-21','13:25:00',4.38),('9650','2014-04-21','13:30:00',4.72),('9650','2014-04-21','13:35:00',4.48),('9650','2014-04-21','13:40:00',5.37),('9650','2014-04-21','13:45:00',5.44),('9650','2014-04-21','13:50:00',4.6),('9650','2014-04-21','13:55:00',2.69),('9650','2014-04-21','14:00:00',2.39),('9650','2014-04-21','14:05:00',3.17),('9650','2014-04-21','14:10:00',5.74),('9650','2014-04-21','14:15:00',5.64),('9650','2014-04-21','14:20:00',6.65),('9650','2014-04-21','14:25:00',4.24),('9650','2014-04-21','14:30:00',3.52),('9650','2014-04-21','14:35:00',4.23),('9650','2014-04-21','14:40:00',5.82),('9650','2014-04-21','14:45:00',7.24),('9650','2014-04-21','14:50:00',6.63),('9650','2014-04-21','14:55:00',5.08),('9650','2014-04-21','15:00:00',2.29),('9650','2014-04-21','15:05:00',2.23),('9650','2014-04-21','15:10:00',2.15),('9650','2014-04-21','15:15:00',2.13),('9650','2014-04-21','15:20:00',2.38),('9650','2014-04-21','15:25:00',2.56),('9650','2014-04-21','15:30:00',3.18),('9650','2014-04-21','15:35:00',4.57),('9650','2014-04-21','15:40:00',3.93),('9650','2014-04-21','15:45:00',3.56),('9650','2014-04-21','15:50:00',4.06),('9650','2014-04-21','15:55:00',3.34),('9650','2014-04-21','16:00:00',3.96),('9650','2014-04-21','16:05:00',2.69),('9650','2014-04-21','16:10:00',2.66),('9650','2014-04-21','16:15:00',2.51),('9650','2014-04-21','16:20:00',2.94),('9650','2014-04-21','16:25:00',2.78),('9650','2014-04-21','16:30:00',2.35),('9650','2014-04-21','16:35:00',2.72),('9650','2014-04-21','16:40:00',3.6),('9650','2014-04-21','16:45:00',3.14),('9650','2014-04-21','16:50:00',2.37),('9650','2014-04-21','16:55:00',2.06),('9650','2014-04-21','17:00:00',2.42),('9650','2014-04-21','17:05:00',2.64),('9650','2014-04-21','17:10:00',2.03),('9650','2014-04-21','17:15:00',1.82),('9650','2014-04-21','17:20:00',1.38),('9650','2014-04-21','17:25:00',1.16),('9650','2014-04-21','17:30:00',1.09),('9650','2014-04-21','17:35:00',1.28),('9650','2014-04-21','17:40:00',1.3),('9650','2014-04-21','17:45:00',1.11),('9650','2014-04-20','08:25:00',1.05),('9650','2014-04-20','08:30:00',1.46),('9650','2014-04-20','08:35:00',1.41),('9650','2014-04-20','08:40:00',1.57),('9650','2014-04-20','08:45:00',1.56),('9650','2014-04-20','08:50:00',1.51),('9650','2014-04-20','08:55:00',1.5),('9650','2014-04-20','09:00:00',1.71),('9650','2014-04-20','09:05:00',1.71),('9650','2014-04-20','09:10:00',1.68),('9650','2014-04-20','09:15:00',1.65),('9650','2014-04-20','09:20:00',2.11),('9650','2014-04-20','09:25:00',1.73),('9650','2014-04-20','09:35:00',1.02),('9650','2014-04-20','09:40:00',1.52),('9650','2014-04-20','09:45:00',1.66),('9650','2014-04-20','09:50:00',1.67),('9650','2014-04-20','09:55:00',1.7),('9650','2014-04-20','10:00:00',2),('9650','2014-04-20','10:05:00',3.71),('9650','2014-04-20','10:10:00',4.09),('9650','2014-04-20','10:15:00',4.07),('9650','2014-04-20','10:20:00',3.87),('9650','2014-04-20','10:25:00',3.95),('9650','2014-04-20','10:30:00',3.97),('9650','2014-04-20','10:35:00',4.04),('9650','2014-04-20','10:40:00',4.14),('9650','2014-04-20','10:45:00',4.26),('9650','2014-04-20','10:50:00',4.36),('9650','2014-04-20','10:55:00',4.46),('9650','2014-04-20','11:00:00',4.56),('9650','2014-04-20','11:05:00',4.66),('9650','2014-04-20','11:10:00',4.76),('9650','2014-04-20','11:15:00',4.82),('9650','2014-04-20','11:20:00',4.93),('9650','2014-04-20','11:25:00',5.06),('9650','2014-04-20','11:30:00',5.15),('9650','2014-04-20','11:35:00',5.22),('9650','2014-04-20','11:40:00',5.32),('9650','2014-04-20','11:45:00',5.41),('9650','2014-04-20','11:50:00',5.47),('9650','2014-04-20','11:55:00',5.55),('9650','2014-04-20','12:00:00',5.66),('9650','2014-04-20','12:05:00',5.74),('9650','2014-04-20','12:10:00',5.82),('9650','2014-04-20','12:15:00',5.94),('9650','2014-04-20','12:20:00',6.02),('9650','2014-04-20','12:25:00',6.08),('9650','2014-04-20','12:30:00',6.16),('9650','2014-04-20','12:35:00',6.2),('9650','2014-04-20','12:40:00',6.25),('9650','2014-04-20','12:45:00',6.31),('9650','2014-04-20','12:50:00',6.37),('9650','2014-04-20','12:55:00',6.42),('9650','2014-04-20','13:00:00',6.47),('9650','2014-04-20','13:05:00',6.5),('9650','2014-04-20','13:10:00',6.53),('9650','2014-04-20','13:15:00',6.59),('9650','2014-04-20','13:20:00',6.62),('9650','2014-04-20','13:25:00',6.67),('9650','2014-04-20','13:30:00',6.7),('9650','2014-04-20','13:35:00',6.67),('9650','2014-04-20','13:40:00',6.75),('9650','2014-04-20','13:45:00',6.83),('9650','2014-04-20','13:50:00',6.87),('9650','2014-04-20','13:55:00',6.89),('9650','2014-04-20','14:00:00',6.93),('9650','2014-04-20','14:05:00',6.95),('9650','2014-04-20','14:10:00',6.98),('9650','2014-04-20','14:15:00',6.99),('9650','2014-04-20','14:20:00',6.97),('9650','2014-04-20','14:25:00',6.96),('9650','2014-04-20','14:30:00',6.96),('9650','2014-04-20','14:35:00',6.96),('9650','2014-04-20','14:40:00',6.93),('9650','2014-04-20','14:45:00',6.92),('9650','2014-04-20','14:50:00',6.92),('9650','2014-04-20','14:55:00',6.91),('9650','2014-04-20','15:00:00',6.9),('9650','2014-04-20','15:05:00',6.89),('9650','2014-04-20','15:10:00',6.83),('9650','2014-04-20','15:15:00',6.79),('9650','2014-04-20','15:20:00',6.76),('9650','2014-04-20','15:25:00',6.7),('9650','2014-04-20','15:30:00',6.66),('9650','2014-04-20','15:35:00',6.61),('9650','2014-04-20','15:40:00',6.56),('9650','2014-04-20','15:45:00',6.46),('9650','2014-04-20','15:50:00',6.39),('9650','2014-04-20','15:55:00',6.32),('9650','2014-04-20','16:00:00',6.31),('9650','2014-04-20','16:05:00',6.23),('9650','2014-04-20','16:10:00',6.17),('9650','2014-04-20','16:15:00',5.77),('9650','2014-04-20','16:20:00',6.04),('9650','2014-04-20','16:25:00',5.6),('9650','2014-04-20','16:30:00',5.81),('9650','2014-04-20','16:35:00',5.83),('9650','2014-04-20','16:40:00',5.73),('9650','2014-04-20','16:45:00',5.66),('9650','2014-04-20','16:50:00',5.55),('9650','2014-04-20','16:55:00',5.39),('9650','2014-04-20','17:00:00',5.26),('9650','2014-04-20','17:05:00',5.17),('9650','2014-04-20','17:10:00',5.02),('9650','2014-04-20','17:15:00',4.92),('9650','2014-04-20','17:20:00',4.83),('9650','2014-04-20','17:25:00',4.75),('9650','2014-04-20','17:30:00',4.69),('9650','2014-04-20','17:35:00',4.62),('9650','2014-04-20','17:40:00',4.21),('9650','2014-04-20','17:45:00',4.34),('9650','2014-04-20','17:50:00',4.22),('9650','2014-04-20','17:55:00',4.08),('9650','2014-04-20','18:00:00',3.93),('9650','2014-04-20','18:05:00',3.77),('9650','2014-04-20','18:10:00',3.6),('9650','2014-04-20','18:15:00',3.46),('9650','2014-04-20','18:20:00',3.31),('9650','2014-04-20','18:25:00',3.16),('9650','2014-04-20','18:30:00',2.97),('9650','2014-04-20','18:35:00',2.74),('9650','2014-04-20','18:40:00',2.56),('9650','2014-04-20','18:45:00',2.34),('9650','2014-04-20','18:50:00',2.17),('9650','2014-04-20','18:55:00',2.02),('9650','2014-04-20','19:00:00',1.91),('9650','2014-04-20','19:05:00',1.74),('9650','2014-04-20','19:10:00',1.48),('9650','2014-04-20','19:15:00',1.21),('9650','2014-04-19','08:20:00',1.33),('9650','2014-04-19','08:25:00',2.04),('9650','2014-04-19','08:30:00',2.12),('9650','2014-04-19','08:35:00',1.85),('9650','2014-04-19','08:40:00',1.28),('9650','2014-04-19','08:45:00',1.92),('9650','2014-04-19','08:50:00',1.72),('9650','2014-04-19','08:55:00',1.37),('9650','2014-04-19','09:00:00',1.65),('9650','2014-04-19','09:05:00',1.41),('9650','2014-04-19','09:10:00',2.28),('9650','2014-04-19','09:15:00',2.27),('9650','2014-04-19','09:20:00',2.43),('9650','2014-04-19','09:25:00',2.95),('9650','2014-04-19','09:30:00',3.8),('9650','2014-04-19','09:35:00',3.52),('9650','2014-04-19','09:40:00',2.34),('9650','2014-04-19','09:45:00',1.96),('9650','2014-04-19','09:50:00',2.29),('9650','2014-04-19','09:55:00',2.57),('9650','2014-04-19','10:00:00',3.08),('9650','2014-04-19','10:05:00',3.66),('9650','2014-04-19','10:10:00',3.4),('9650','2014-04-19','10:15:00',3.95),('9650','2014-04-19','10:20:00',4.02),('9650','2014-04-19','10:25:00',3.86),('9650','2014-04-19','10:30:00',3.79),('9650','2014-04-19','10:35:00',4.03),('9650','2014-04-19','10:40:00',3.78),('9650','2014-04-19','10:45:00',3.78),('9650','2014-04-19','10:50:00',3.94),('9650','2014-04-19','10:55:00',3.79),('9650','2014-04-19','11:00:00',4.41),('9650','2014-04-19','11:05:00',4.51),('9650','2014-04-19','11:10:00',4.68),('9650','2014-04-19','11:15:00',3.93),('9650','2014-04-19','11:20:00',2.97),('9650','2014-04-19','11:25:00',5.49),('9650','2014-04-19','11:30:00',5.71),('9650','2014-04-19','11:35:00',5.64),('9650','2014-04-19','11:40:00',4.13),('9650','2014-04-19','11:45:00',2.09),('9650','2014-04-19','11:50:00',2.91),('9650','2014-04-19','11:55:00',4.23),('9650','2014-04-19','12:00:00',6.3),('9650','2014-04-19','12:05:00',6.34),('9650','2014-04-19','12:10:00',4.03),('9650','2014-04-19','12:15:00',2.07),('9650','2014-04-19','12:20:00',3.9),('9650','2014-04-19','12:25:00',6.52),('9650','2014-04-19','12:30:00',5.03),('9650','2014-04-19','12:35:00',6.69),('9650','2014-04-19','12:40:00',6.7),('9650','2014-04-19','12:45:00',6.68),('9650','2014-04-19','12:50:00',6.77),('9650','2014-04-19','12:55:00',6.76),('9650','2014-04-19','13:00:00',6.77),('9650','2014-04-19','13:05:00',6.8),('9650','2014-04-19','13:10:00',6.94),('9650','2014-04-19','13:15:00',7.09),('9650','2014-04-19','13:20:00',6.84),('9650','2014-04-19','13:25:00',6.87),('9650','2014-04-19','13:30:00',6.93),('9650','2014-04-19','13:35:00',6.97),('9650','2014-04-19','13:40:00',6.99),('9650','2014-04-19','13:45:00',6.99),('9650','2014-04-19','13:50:00',7.02),('9650','2014-04-19','13:55:00',7.05),('9650','2014-04-19','14:00:00',7.04),('9650','2014-04-19','14:05:00',7.09),('9650','2014-04-19','14:10:00',7.17),('9650','2014-04-19','14:15:00',7.61),('9650','2014-04-19','14:20:00',5.64),('9650','2014-04-19','14:25:00',5.78),('9650','2014-04-19','14:30:00',5.2),('9650','2014-04-19','14:35:00',4.31),('9650','2014-04-19','14:40:00',4.25),('9650','2014-04-19','14:45:00',4.71),('9650','2014-04-19','14:50:00',4.59),('9650','2014-04-19','14:55:00',5.21),('9650','2014-04-19','15:00:00',6.81),('9650','2014-04-19','15:05:00',6.47),('9650','2014-04-19','15:10:00',7.04),('9650','2014-04-19','15:15:00',7.06),('9650','2014-04-19','15:20:00',6.86),('9650','2014-04-19','15:25:00',6.85),('9650','2014-04-19','15:30:00',6.81),('9650','2014-04-19','15:35:00',6.67),('9650','2014-04-19','15:40:00',6.88),('9650','2014-04-19','15:45:00',5.95),('9650','2014-04-19','15:50:00',5.19),('9650','2014-04-19','15:55:00',6.61),('9650','2014-04-19','16:00:00',6.36),('9650','2014-04-19','16:05:00',6.27),('9650','2014-04-19','16:10:00',6.23),('9650','2014-04-19','16:15:00',6.21),('9650','2014-04-19','16:20:00',6.16),('9650','2014-04-19','16:25:00',5.46),('9650','2014-04-19','16:30:00',6.25),('9650','2014-04-19','16:35:00',5.91),('9650','2014-04-19','16:40:00',5.05),('9650','2014-04-19','16:45:00',4.58),('9650','2014-04-19','16:50:00',5.61),('9650','2014-04-19','16:55:00',5.64),('9650','2014-04-19','17:00:00',5.34),('9650','2014-04-19','17:05:00',5.14),('9650','2014-04-19','17:10:00',4.96),('9650','2014-04-19','17:15:00',4.86),('9650','2014-04-19','17:20:00',4.82),('9650','2014-04-19','17:25:00',4.72),('9650','2014-04-19','17:30:00',4.61),('9650','2014-04-19','17:35:00',4.55),('9650','2014-04-19','17:40:00',4.41),('9650','2014-04-19','17:45:00',4.28),('9650','2014-04-19','17:50:00',4.16),('9650','2014-04-19','17:55:00',4.02),('9650','2014-04-19','18:00:00',3.9),('9650','2014-04-19','18:05:00',3.72),('9650','2014-04-19','18:10:00',3.57),('9650','2014-04-19','18:15:00',3.27),('9650','2014-04-19','18:20:00',2.25),('9650','2014-04-19','18:25:00',1.82),('9650','2014-04-19','18:30:00',2.79),('9650','2014-04-19','18:35:00',2.8),('9650','2014-04-19','18:40:00',2.38),('9650','2014-04-19','18:45:00',1.24),('9650','2014-04-18','07:50:00',1.17),('9650','2014-04-18','07:55:00',1.71),('9650','2014-04-18','08:00:00',1.61),('9650','2014-04-18','08:05:00',1.47),('9650','2014-04-18','08:10:00',1.61),('9650','2014-04-18','08:15:00',1.61),('9650','2014-04-18','08:20:00',1.84),('9650','2014-04-18','08:25:00',2.06),('9650','2014-04-18','08:30:00',2.25),('9650','2014-04-18','08:35:00',2.3),('9650','2014-04-18','08:40:00',2.43),('9650','2014-04-18','08:45:00',2.56),('9650','2014-04-18','08:50:00',2.24),('9650','2014-04-18','08:55:00',1.47),('9650','2014-04-18','09:10:00',1.12),('9650','2014-04-18','09:15:00',1.29),('9650','2014-04-18','09:20:00',1.79),('9650','2014-04-18','09:25:00',2.41),('9650','2014-04-18','09:30:00',3.12),('9650','2014-04-18','09:35:00',2.98),('9650','2014-04-18','09:40:00',1.96),('9650','2014-04-18','09:45:00',1.48),('9650','2014-04-18','09:50:00',1.28),('9650','2014-04-18','09:55:00',1.21),('9650','2014-04-18','10:00:00',1.26),('9650','2014-04-18','10:15:00',1.11),('9650','2014-04-18','10:20:00',1.25),('9650','2014-04-18','10:25:00',1.23),('9650','2014-04-18','10:30:00',1.25),('9650','2014-04-18','10:35:00',1.63),('9650','2014-04-18','10:40:00',2.2),('9650','2014-04-18','10:45:00',2.11),('9650','2014-04-18','10:50:00',2.27),('9650','2014-04-18','10:55:00',2.88),('9650','2014-04-18','11:00:00',2.8),('9650','2014-04-18','11:05:00',2.24),('9650','2014-04-18','11:10:00',2.29),('9650','2014-04-18','11:15:00',3.24),('9650','2014-04-18','11:20:00',4.63),('9650','2014-04-18','11:25:00',3.95),('9650','2014-04-18','11:30:00',4.21),('9650','2014-04-18','11:35:00',4.37),('9650','2014-04-18','11:40:00',4.07),('9650','2014-04-18','11:45:00',3.53),('9650','2014-04-18','11:50:00',2.75),('9650','2014-04-18','11:55:00',1.8),('9650','2014-04-18','12:00:00',1.47),('9650','2014-04-18','12:05:00',1.19),('9650','2014-04-18','13:05:00',1.21),('9650','2014-04-18','13:10:00',1.13),('9650','2014-04-18','13:15:00',2.59),('9650','2014-04-18','13:20:00',2.33),('9650','2014-04-18','13:25:00',1.27),('9650','2014-04-18','13:35:00',1.54),('9650','2014-04-18','13:40:00',1.37),('9650','2014-04-18','13:45:00',1.03),('9650','2014-04-18','13:50:00',1.45),('9650','2014-04-18','13:55:00',1.6),('9650','2014-04-18','14:25:00',1.13),('9650','2014-04-18','14:30:00',2.47),('9650','2014-04-18','14:35:00',2.55),('9650','2014-04-18','14:40:00',3.05),('9650','2014-04-18','14:45:00',3.17),('9650','2014-04-18','14:50:00',1.96),('9650','2014-04-18','14:55:00',1.77),('9650','2014-04-18','15:00:00',2.46),('9650','2014-04-18','15:05:00',2.12),('9650','2014-04-18','15:10:00',1.02),('9650','2014-04-18','15:20:00',1.18),('9650','2014-04-18','15:25:00',1.92),('9650','2014-04-18','15:30:00',1.8),('9650','2014-04-18','15:35:00',1.06),('9650','2014-04-18','15:45:00',1.99),('9650','2014-04-18','15:50:00',6.53),('9650','2014-04-18','15:55:00',5.26),('9650','2014-04-18','16:00:00',4.07),('9650','2014-04-18','16:05:00',4.02),('9650','2014-04-18','16:10:00',3.41),('9650','2014-04-18','16:15:00',3.14),('9650','2014-04-18','16:20:00',3.6),('9650','2014-04-18','16:25:00',3.66),('9650','2014-04-18','16:30:00',5.69),('9650','2014-04-18','16:35:00',2.8),('9650','2014-04-18','16:40:00',2.05),('9650','2014-04-18','16:45:00',1.85),('9650','2014-04-18','16:50:00',1.33),('9650','2014-04-18','17:00:00',1.13),('9650','2014-04-18','17:05:00',1.65),('9650','2014-04-18','17:10:00',1.78),('9650','2014-04-18','17:15:00',2.1),('9650','2014-04-18','17:20:00',3.58),('9650','2014-04-18','17:25:00',2.64),('9650','2014-04-18','17:30:00',2.33),('9650','2014-04-18','17:35:00',1.86),('9650','2014-04-18','17:40:00',1.11),('9650','2013-11-08','09:15:00',1.01),('9650','2013-11-08','09:30:00',1),('9650','2013-11-08','09:35:00',1.06),('9650','2013-11-08','09:40:00',1.82),('9650','2013-11-08','09:45:00',1.65),('9650','2013-11-08','09:50:00',2.22),('9650','2013-11-08','09:55:00',2.07),('9650','2013-11-08','10:00:00',1.89),('9650','2013-11-08','10:05:00',1.9),('9650','2013-11-08','10:10:00',1.79),('9650','2013-11-08','10:15:00',1.84),('9650','2013-11-08','10:20:00',1.85),('9650','2013-11-08','10:25:00',1.77),('9650','2013-11-08','10:30:00',1.82),('9650','2013-11-08','10:35:00',2.14),('9650','2013-11-08','10:40:00',2.08),('9650','2013-11-08','10:45:00',2.1),('9650','2013-11-08','10:50:00',2.37),('9650','2013-11-08','10:55:00',2.83),('9650','2013-11-08','11:00:00',2.7),('9650','2013-11-08','11:05:00',3.53),('9650','2013-11-08','11:10:00',3.85),('9650','2013-11-08','11:15:00',4.29),('9650','2013-11-07','09:05:00',1.14),('9650','2013-11-07','09:10:00',1.42),('9650','2013-11-07','09:15:00',1.3),('9650','2013-11-07','09:20:00',1.26),('9650','2013-11-07','09:25:00',1.55),('9650','2013-11-07','09:30:00',1.85),('9650','2013-11-07','09:35:00',2.13),('9650','2013-11-07','09:40:00',1.51),('9650','2013-11-07','09:45:00',1.2),('9650','2013-11-07','09:50:00',1.83),('9650','2013-11-07','09:55:00',1.49),('9650','2013-11-07','10:00:00',1.95),('9650','2013-11-07','10:05:00',1.78),('9650','2013-11-07','10:10:00',1.68),('9650','2013-11-07','10:25:00',1.05),('9650','2013-11-07','10:40:00',1.18),('9650','2013-11-07','10:45:00',1.48),('9650','2013-11-07','10:50:00',2.59),('9650','2013-11-07','10:55:00',1.49),('9650','2013-11-07','11:00:00',1.2),('9650','2013-11-07','11:05:00',1.28),('9650','2013-11-07','11:10:00',1.28),('9650','2013-11-07','11:15:00',1.5),('9650','2013-11-07','11:20:00',1.81),('9650','2013-11-07','11:25:00',1.71),('9650','2013-11-07','11:30:00',1.75),('9650','2013-11-07','11:35:00',2.57),('9650','2013-11-07','11:40:00',3.7),('9650','2013-11-07','11:45:00',3.72),('9650','2013-11-07','11:50:00',3.69),('9650','2013-11-07','11:55:00',3.67),('9650','2013-11-07','12:00:00',2.78),('9650','2013-11-07','12:05:00',3.1),('9650','2013-11-07','12:10:00',3.25),('9650','2013-11-07','12:20:00',1.23),('9650','2013-11-07','12:35:00',2.83),('9650','2013-11-07','12:40:00',3.85),('9650','2013-11-07','12:45:00',3.91),('9650','2013-11-07','12:50:00',4.06),('9650','2013-11-07','12:55:00',4.1),('9650','2013-11-07','13:00:00',3.92),('9650','2013-11-07','13:05:00',3.85),('9650','2013-11-07','13:10:00',4.03),('9650','2013-11-07','13:15:00',2.34),('9650','2013-11-07','13:20:00',3.44),('9650','2013-11-07','13:25:00',1.94),('9650','2013-11-07','13:30:00',1.38),('9650','2013-11-07','13:35:00',3.29),('9650','2013-11-07','13:40:00',3.24),('9650','2013-11-07','13:45:00',3.12),('9650','2013-11-07','13:50:00',2.41),('9650','2013-11-07','13:55:00',3.14),('9650','2013-11-07','14:00:00',2.98),('9650','2013-11-07','14:05:00',2.85),('9650','2013-11-07','14:10:00',2.79),('9650','2013-11-07','14:15:00',2.7),('9650','2013-11-07','14:20:00',2.37),('9650','2013-11-07','14:25:00',2.51),('9650','2013-11-07','14:30:00',2.49),('9650','2013-11-07','14:35:00',2.39),('9650','2013-11-07','14:40:00',2.04),('9650','2013-11-07','14:45:00',1.97),('9650','2013-11-07','14:50:00',1.75),('9650','2013-11-07','14:55:00',1.05),('9650','2013-11-07','15:00:00',1.62),('9650','2013-11-07','15:05:00',1.71),('9650','2013-11-07','15:10:00',1.75),('9650','2013-11-07','15:15:00',1.27),('9650','2013-11-07','15:25:00',1.04),('9650','2013-11-07','15:30:00',1.13),('9650','2014-04-17','08:05:00',1.28),('9650','2014-04-17','08:10:00',1.29),('9650','2014-04-17','08:35:00',1.06),('9650','2014-04-17','08:40:00',1.59),('9650','2014-04-17','08:45:00',1.82),('9650','2014-04-17','08:50:00',1.62),('9650','2014-04-17','08:55:00',1.68),('9650','2014-04-17','09:00:00',1.84),('9650','2014-04-17','09:05:00',2.63),('9650','2014-04-17','09:10:00',3.31),('9650','2014-04-17','09:15:00',2.84),('9650','2014-04-17','09:20:00',2.73),('9650','2014-04-17','09:25:00',2.07),('9650','2014-04-17','09:30:00',3.35),('9650','2014-04-17','09:35:00',2.19),('9650','2014-04-17','09:40:00',1.53),('9650','2014-04-17','09:45:00',2.33),('9650','2014-04-17','09:50:00',3.67),('9650','2014-04-17','09:55:00',4.11),('9650','2014-04-17','10:00:00',3.64),('9650','2014-04-17','10:05:00',2.67),('9650','2014-04-17','10:10:00',2.48),('9650','2014-04-17','10:15:00',2.62),('9650','2014-04-17','10:20:00',2.53),('9650','2014-04-17','10:25:00',2.63),('9650','2014-04-17','10:30:00',2.27),('9650','2014-04-17','10:35:00',2.13),('9650','2014-04-17','10:40:00',2.38),('9650','2014-04-17','10:45:00',3.37),('9650','2014-04-17','10:50:00',3.85),('9650','2014-04-17','10:55:00',4.24),('9650','2014-04-17','11:00:00',3.1),('9650','2014-04-17','11:05:00',2.91),('9650','2014-04-17','11:10:00',3.13),('9650','2014-04-17','11:15:00',4.61),('9650','2014-04-17','11:20:00',3.15),('9650','2014-04-17','11:25:00',2.5),('9650','2014-04-17','11:30:00',2.94),('9650','2014-04-17','11:35:00',2.94),('9650','2014-04-17','11:40:00',3.07),('9650','2014-04-17','11:45:00',2.99),('9650','2014-04-17','11:50:00',3.56),('9650','2014-04-17','11:55:00',3.03),('9650','2014-04-17','12:00:00',3.21),('9650','2014-04-17','12:05:00',5.55),('9650','2014-04-17','12:10:00',5.47),('9650','2014-04-17','12:15:00',5.27),('9650','2014-04-17','12:20:00',5.77),('9650','2014-04-17','12:25:00',4.38),('9650','2014-04-17','12:30:00',6.66),('9650','2014-04-17','12:35:00',6.36),('9650','2014-04-17','12:40:00',6.78),('9650','2014-04-17','12:45:00',5.56),('9650','2014-04-17','12:50:00',5.62),('9650','2014-04-17','12:55:00',4.12),('9650','2014-04-17','13:00:00',6.92),('9650','2014-04-17','13:05:00',4.28),('9650','2014-04-17','13:10:00',4.15),('9650','2014-04-17','13:15:00',4.09),('9650','2014-04-17','13:20:00',3.97),('9650','2014-04-17','13:25:00',2.99),('9650','2014-04-17','13:30:00',2.4),('9650','2014-04-17','13:35:00',2.44),('9650','2014-04-17','13:40:00',2.38),('9650','2014-04-17','13:45:00',2.09),('9650','2014-04-17','13:50:00',2.43),('9650','2014-04-17','13:55:00',4.19),('9650','2014-04-17','14:00:00',3.63),('9650','2014-04-17','14:05:00',3.06),('9650','2014-04-17','14:10:00',2.69),('9650','2014-04-17','14:15:00',2.41),('9650','2014-04-17','14:20:00',2.8),('9650','2014-04-17','14:25:00',3.56),('9650','2014-04-17','14:30:00',3.97),('9650','2014-04-17','14:35:00',4.57),('9650','2014-04-17','14:40:00',3.96),('9650','2014-04-17','14:45:00',4.73),('9650','2014-04-17','14:50:00',5.25),('9650','2014-04-17','14:55:00',4.03),('9650','2014-04-17','15:00:00',7.75),('9650','2014-04-17','15:05:00',4.49),('9650','2014-04-17','15:10:00',3.21),('9650','2014-04-17','15:15:00',3.69),('9650','2014-04-17','15:20:00',3.22),('9650','2014-04-17','15:25:00',3.8),('9650','2014-04-17','15:30:00',6.42),('9650','2014-04-17','15:35:00',6.76),('9650','2014-04-17','15:40:00',5.88),('9650','2014-04-17','15:45:00',4.31),('9650','2014-04-17','15:50:00',5.35),('9650','2014-04-17','15:55:00',5.12),('9650','2014-04-17','16:00:00',4.36),('9650','2014-04-17','16:05:00',3.39),('9650','2014-04-17','16:10:00',2.69),('9650','2014-04-17','16:15:00',2.33),('9650','2014-04-17','16:20:00',2.46),('9650','2014-04-17','16:25:00',4.32),('9650','2014-04-17','16:30:00',4.31),('9650','2014-04-17','16:35:00',5.34),('9650','2014-04-17','16:40:00',6.18),('9650','2014-04-17','16:45:00',5.83),('9650','2014-04-17','16:50:00',5.85),('9650','2014-04-17','16:55:00',4.78),('9650','2014-04-17','17:00:00',5.28),('9650','2014-04-17','17:05:00',5.9),('9650','2014-04-17','17:10:00',5.18),('9650','2014-04-17','17:15:00',4.57),('9650','2014-04-17','17:20:00',4.66),('9650','2014-04-17','17:25:00',4.78),('9650','2014-04-17','17:30:00',4.51),('9650','2014-04-17','17:35:00',4.34),('9650','2014-04-17','17:40:00',4.37),('9650','2014-04-17','17:45:00',4.23),('9650','2014-04-17','17:50:00',4.14),('9650','2014-04-17','17:55:00',4.03),('9650','2014-04-17','18:00:00',3.93),('9650','2014-04-17','18:05:00',3.59),('9650','2014-04-17','18:10:00',3.4),('9650','2014-04-17','18:15:00',2.95),('9650','2014-04-17','18:20:00',3.08),('9650','2014-04-17','18:25:00',2.81),('9650','2014-04-17','18:30:00',2.03),('9650','2014-04-17','18:35:00',2.48),('9650','2014-04-17','18:40:00',2.3),('9650','2014-04-17','18:45:00',2.28),('9650','2014-04-17','18:50:00',2),('9650','2014-04-17','18:55:00',1.82),('9650','2014-04-17','19:00:00',1.57),('9650','2014-04-17','19:05:00',1.31),('9650','2013-11-06','09:40:00',1.05),('9650','2013-11-06','09:45:00',1.13),('9650','2013-11-06','09:50:00',1.22),('9650','2013-11-06','09:55:00',1.32),('9650','2013-11-06','10:00:00',1.4),('9650','2013-11-06','10:05:00',1.5),('9650','2013-11-06','10:10:00',1.58),('9650','2013-11-06','10:15:00',1.68),('9650','2013-11-06','10:20:00',1.76),('9650','2013-11-06','10:25:00',1.86),('9650','2013-11-06','10:30:00',1.94),('9650','2013-11-06','10:35:00',2.02),('9650','2013-11-06','10:40:00',2.11),('9650','2013-11-06','10:45:00',2.2),('9650','2013-11-06','10:50:00',2.26),('9650','2013-11-06','10:55:00',2.33),('9650','2013-11-06','11:00:00',2.4),('9650','2013-11-06','11:05:00',2.48),('9650','2013-11-06','11:10:00',2.53),('9650','2013-11-06','11:15:00',2.58),('9650','2013-11-06','11:20:00',2.64),('9650','2013-11-06','11:25:00',2.7),('9650','2013-11-06','11:30:00',2.79),('9650','2013-11-06','11:35:00',2.85),('9650','2013-11-06','11:40:00',2.87),('9650','2013-11-06','11:45:00',2.93),('9650','2013-11-06','11:50:00',2.98),('9650','2013-11-06','11:55:00',3.02),('9650','2013-11-06','12:00:00',3.02),('9650','2013-11-06','12:05:00',3.04),('9650','2013-11-06','12:10:00',3.07),('9650','2013-11-06','12:15:00',3.15),('9650','2013-11-06','12:20:00',3.17),('9650','2013-11-06','12:25:00',3.2),('9650','2013-11-06','12:30:00',3.27),('9650','2013-11-06','12:35:00',3.31),('9650','2013-11-06','12:40:00',3.3),('9650','2013-11-06','12:45:00',3.36),('9650','2013-11-06','12:50:00',3.38),('9650','2013-11-06','12:55:00',3.32),('9650','2013-11-06','13:00:00',3.84),('9650','2013-11-06','13:05:00',3.78),('9650','2013-11-06','13:10:00',3.42),('9650','2013-11-06','13:15:00',1.75),('9650','2013-11-06','13:20:00',1.66),('9650','2013-11-06','13:25:00',1.84),('9650','2013-11-06','13:30:00',2.25),('9650','2013-11-06','13:35:00',3.89),('9650','2013-11-06','13:40:00',2.85),('9650','2013-11-06','13:45:00',2.33),('9650','2013-11-06','13:50:00',3.58),('9650','2013-11-06','13:55:00',2.34),('9650','2013-11-06','14:00:00',1.8),('9650','2013-11-06','14:05:00',1.85),('9650','2013-11-06','14:10:00',2.09),('9650','2013-11-06','14:15:00',2.09),('9650','2013-11-06','14:20:00',1.97),('9650','2013-11-06','14:25:00',1.94),('9650','2013-11-06','14:30:00',2.28),('9650','2013-11-06','14:35:00',1.76),('9650','2013-11-06','14:40:00',2.01),('9650','2013-11-06','14:45:00',1.9),('9650','2013-11-06','14:50:00',1.92),('9650','2013-11-06','14:55:00',1.85),('9650','2013-11-06','15:00:00',1.79),('9650','2013-11-06','15:05:00',1.74),('9650','2013-11-06','15:10:00',1.7),('9650','2013-11-06','15:15:00',1.67),('9650','2013-11-06','15:20:00',1.58),('9650','2013-11-06','15:25:00',1.5),('9650','2013-11-06','15:30:00',1.44),('9650','2013-11-06','15:35:00',1.29),('9650','2013-11-06','15:40:00',1.22),('9650','2013-11-06','15:45:00',1.12),('9650','2013-11-05','09:40:00',1.1),('9650','2013-11-05','09:45:00',1.18),('9650','2013-11-05','09:50:00',1.24),('9650','2013-11-05','09:55:00',1.27),('9650','2013-11-05','10:00:00',1.3),('9650','2013-11-05','10:05:00',1.43),('9650','2013-11-05','10:10:00',1.67),('9650','2013-11-05','10:15:00',1.77),('9650','2013-11-05','10:20:00',1.86),('9650','2013-11-05','10:25:00',1.97),('9650','2013-11-05','10:30:00',2.06),('9650','2013-11-05','10:35:00',2.14),('9650','2013-11-05','10:40:00',2.24),('9650','2013-11-05','10:45:00',2.33),('9650','2013-11-05','10:50:00',2.42),('9650','2013-11-05','10:55:00',2.49),('9650','2013-11-05','11:00:00',2.6),('9650','2013-11-05','11:05:00',2.67),('9650','2013-11-05','11:10:00',2.74),('9650','2013-11-05','11:15:00',2.82),('9650','2013-11-05','11:20:00',2.88),('9650','2013-11-05','11:25:00',2.95),('9650','2013-11-05','11:30:00',3.02),('9650','2013-11-05','11:35:00',3.06),('9650','2013-11-05','11:40:00',3.11),('9650','2013-11-05','11:45:00',3.14),('9650','2013-11-05','11:50:00',3.19),('9650','2013-11-05','11:55:00',3.22),('9650','2013-11-05','12:00:00',3.28),('9650','2013-11-05','12:05:00',3.34),('9650','2013-11-05','12:10:00',3.35),('9650','2013-11-05','12:15:00',3.39),('9650','2013-11-05','12:20:00',3.43),('9650','2013-11-05','12:25:00',3.46),('9650','2013-11-05','12:30:00',3.48),('9650','2013-11-05','12:35:00',3.51),('9650','2013-11-05','12:40:00',3.52),('9650','2013-11-05','12:45:00',3.55),('9650','2013-11-05','12:50:00',3.56),('9650','2013-11-05','12:55:00',3.56),('9650','2013-11-05','13:00:00',3.55),('9650','2013-11-05','13:05:00',3.47),('9650','2013-11-05','13:10:00',3.37),('9650','2013-11-05','13:15:00',3.31),('9650','2013-11-05','13:20:00',3.24),('9650','2013-11-05','13:25:00',3.21),('9650','2013-11-05','13:30:00',3.16),('9650','2013-11-05','13:35:00',3.1),('9650','2013-11-05','13:40:00',3.1),('9650','2013-11-05','13:45:00',3.08),('9650','2013-11-05','13:50:00',3.1),('9650','2013-11-05','13:55:00',3.05),('9650','2013-11-05','14:00:00',2.88),('9650','2013-11-05','14:05:00',2.81),('9650','2013-11-05','14:10:00',2.83),('9650','2013-11-05','14:15:00',2.75),('9650','2013-11-05','14:20:00',2.65),('9650','2013-11-05','14:25:00',2.6),('9650','2013-11-05','14:30:00',2.39),('9650','2013-11-05','14:35:00',2.18),('9650','2013-11-05','14:40:00',2.05),('9650','2013-11-05','14:45:00',2.05),('9650','2013-11-05','14:50:00',2.03),('9650','2013-11-05','14:55:00',1.88),('9650','2013-11-05','15:00:00',1.86),('9650','2013-11-05','15:05:00',1.82),('9650','2013-11-05','15:10:00',1.79),('9650','2013-11-05','15:15:00',1.76),('9650','2013-11-05','15:20:00',1.67),('9650','2013-11-05','15:25:00',1.59),('9650','2013-11-05','15:30:00',1.45),('9650','2013-11-05','15:35:00',1.37),('9650','2013-11-05','15:40:00',1.26),('9650','2013-11-05','15:45:00',1.2),('9650','2013-11-05','15:50:00',1.07),('9650','2013-11-04','08:25:00',1.07),('9650','2013-11-04','08:30:00',1.1),('9650','2013-11-04','08:35:00',1.21),('9650','2013-11-04','08:40:00',1.26),('9650','2013-11-04','08:45:00',1.23),('9650','2013-11-04','08:50:00',1.21),('9650','2013-11-04','09:55:00',1.02),('9650','2013-11-04','10:00:00',1.31),('9650','2013-11-04','10:05:00',1.23),('9650','2013-11-04','10:10:00',1.12),('9650','2013-11-04','10:15:00',1.45),('9650','2013-11-04','10:20:00',2.18),('9650','2013-11-04','10:25:00',2.72),('9650','2013-11-04','10:30:00',2.36),('9650','2013-11-04','10:35:00',2.94),('9650','2013-11-04','10:40:00',2.34),('9650','2013-11-04','10:45:00',2.48),('9650','2013-11-04','10:50:00',2.27),('9650','2013-11-04','10:55:00',2.02),('9650','2013-11-04','11:00:00',1.71),('9650','2013-11-04','11:05:00',1.31),('9650','2013-11-04','11:10:00',1.03),('9650','2013-11-04','11:20:00',1.12),('9650','2013-11-04','11:25:00',1.34),('9650','2013-11-04','11:30:00',1.52),('9650','2013-11-04','11:35:00',1.95),('9650','2013-11-04','11:40:00',2.48),('9650','2013-11-04','11:45:00',2.4),('9650','2013-11-04','11:50:00',2.23),('9650','2013-11-04','11:55:00',1.95),('9650','2013-11-04','12:00:00',1.67),('9650','2013-11-04','12:05:00',1.9),('9650','2013-11-04','12:10:00',2.41),('9650','2013-11-04','12:15:00',2.41),('9650','2013-11-04','12:20:00',2.75),('9650','2013-11-04','12:25:00',2.51),('9650','2013-11-04','12:30:00',2.11),('9650','2013-11-04','12:35:00',1.69),('9650','2013-11-04','12:40:00',1.38),('9650','2013-11-04','12:45:00',1.18),('9650','2013-11-04','12:50:00',1.21),('9650','2013-11-04','12:55:00',1.49),('9650','2013-11-04','13:00:00',1.59),('9650','2013-11-04','13:05:00',1.27),('9650','2013-11-04','13:10:00',1.31),('9650','2013-11-04','13:20:00',1.02),('9650','2013-11-04','13:25:00',1.4),('9650','2013-11-04','13:30:00',2),('9650','2013-11-04','13:35:00',3.59),('9650','2013-11-04','13:40:00',3.63),('9650','2013-11-04','13:45:00',3.49),('9650','2013-11-04','13:50:00',1.99),('9650','2013-11-04','13:55:00',1.97),('9650','2013-11-04','14:00:00',2.75),('9650','2013-11-04','14:05:00',2.92),('9650','2013-11-04','14:10:00',4.01),('9650','2013-11-04','14:15:00',1.42),('9650','2013-11-04','14:20:00',2.62),('9650','2013-11-04','14:25:00',2.46),('9650','2013-11-04','14:30:00',2.58),('9650','2013-11-04','14:35:00',2.64),('9650','2013-11-04','14:40:00',1.1),('9650','2013-11-04','14:45:00',1.78),('9650','2013-11-04','14:50:00',1.21),('9650','2013-11-04','15:05:00',1.27),('9650','2013-11-04','15:15:00',1.26),('9650','2013-11-04','15:30:00',1.56),('9650','2013-11-04','15:35:00',1.79),('9650','2013-11-04','16:05:00',1.09),('9650','2013-11-03','09:15:00',1.33),('9650','2013-11-03','09:20:00',1.72),('9650','2013-11-03','09:25:00',2.23),('9650','2013-11-03','09:30:00',1.41),('9650','2013-11-03','10:00:00',1.2),('9650','2013-11-03','10:05:00',1.94),('9650','2013-11-03','10:10:00',2.04),('9650','2013-11-03','10:15:00',2.24),('9650','2013-11-03','10:20:00',2.35),('9650','2013-11-03','10:25:00',2.83),('9650','2013-11-03','10:30:00',3.17),('9650','2013-11-03','10:35:00',2.87),('9650','2013-11-03','10:40:00',3.29),('9650','2013-11-03','10:45:00',2.75),('9650','2013-11-03','10:50:00',2.58),('9650','2013-11-03','10:55:00',3.3),('9650','2013-11-03','11:00:00',3.3),('9650','2013-11-03','11:05:00',3.44),('9650','2013-11-03','11:10:00',1.98),('9650','2013-11-03','11:15:00',3.03),('9650','2013-11-03','11:20:00',2.03),('9650','2013-11-03','11:25:00',1.84),('9650','2013-11-03','11:30:00',3.23),('9650','2013-11-03','11:35:00',3.76),('9650','2013-11-03','11:40:00',2.96),('9650','2013-11-03','11:45:00',3.61),('9650','2013-11-03','11:50:00',4.93),('9650','2013-11-03','11:55:00',4.15),('9650','2013-11-03','12:00:00',3.91),('9650','2013-11-03','12:05:00',3.63),('9650','2013-11-03','12:10:00',3.67),('9650','2013-11-03','12:15:00',3.63),('9650','2013-11-03','12:20:00',3.24),('9650','2013-11-03','12:25:00',3.67),('9650','2013-11-03','12:30:00',3.71),('9650','2013-11-03','12:35:00',3.62),('9650','2013-11-03','12:40:00',3.77),('9650','2013-11-03','12:45:00',3.77),('9650','2013-11-03','12:50:00',3.69),('9650','2013-11-03','12:55:00',3.68),('9650','2013-11-03','13:00:00',3.65),('9650','2013-11-03','13:05:00',3.63),('9650','2013-11-03','13:10:00',3.46),('9650','2013-11-03','13:15:00',3.63),('9650','2013-11-03','13:20:00',2.71),('9650','2013-11-03','13:25:00',3.46),('9650','2013-11-03','13:30:00',3.45),('9650','2013-11-03','13:35:00',3.65),('9650','2013-11-03','13:40:00',2.94),('9650','2013-11-03','13:45:00',3.75),('9650','2013-11-03','13:50:00',3.59),('9650','2013-11-03','13:55:00',2.61),('9650','2013-11-03','14:00:00',2.14),('9650','2013-11-03','14:05:00',2.75),('9650','2013-11-03','14:10:00',3.4),('9650','2013-11-03','14:15:00',3.51),('9650','2013-11-03','14:20:00',3.41),('9650','2013-11-03','14:25:00',2.2),('9650','2013-11-03','14:30:00',2.28),('9650','2013-11-03','14:35:00',3.09),('9650','2013-11-03','14:40:00',2.61),('9650','2013-11-03','14:45:00',2.4),('9650','2013-11-03','14:50:00',2.48),('9650','2013-11-03','14:55:00',2.18),('9650','2013-11-03','15:00:00',2.18),('9650','2013-11-03','15:05:00',1.45),('9650','2013-11-03','15:10:00',1.71),('9650','2013-11-03','15:15:00',1.78),('9650','2013-11-03','15:20:00',1.82),('9650','2013-11-03','15:25:00',1.83),('9650','2013-11-03','15:30:00',1.67),('9650','2013-11-03','15:35:00',1.91),('9650','2013-11-03','15:40:00',1.84),('9650','2013-11-03','15:45:00',1.8),('9650','2013-11-03','15:50:00',1.44),('9650','2013-11-02','08:50:00',1.02),('9650','2013-11-02','08:55:00',1.13),('9650','2013-11-02','09:40:00',1.87),('9650','2013-11-02','09:45:00',1.79),('9650','2013-11-02','09:50:00',1.48),('9650','2013-11-02','10:05:00',1.12),('9650','2013-11-02','10:10:00',1.52),('9650','2013-11-02','10:20:00',2.07),('9650','2013-11-02','10:25:00',1.86),('9650','2013-11-02','10:30:00',2.22),('9650','2013-11-02','10:35:00',1.7),('9650','2013-11-02','11:10:00',1.15),('9650','2013-11-02','11:15:00',1.56),('9650','2013-11-02','11:20:00',2.3),('9650','2013-11-02','11:25:00',1.58),('9650','2013-11-02','11:30:00',2.63),('9650','2013-11-02','11:35:00',3.2),('9650','2013-11-02','11:40:00',3.83),('9650','2013-11-02','11:45:00',4.06),('9650','2013-11-02','11:50:00',4.37),('9650','2013-11-02','11:55:00',3.4),('9650','2013-11-02','12:00:00',4.46),('9650','2013-11-02','12:05:00',4.59),('9650','2013-11-02','12:10:00',4.55),('9650','2013-11-02','12:15:00',2.59),('9650','2013-11-02','12:20:00',1.37),('9650','2013-11-02','12:25:00',2.35),('9650','2013-11-02','12:30:00',1.66),('9650','2013-11-02','12:35:00',1.79),('9650','2013-11-02','12:40:00',2.2),('9650','2013-11-02','12:45:00',1.86),('9650','2013-11-02','12:50:00',1.9),('9650','2013-11-02','12:55:00',1.6),('9650','2013-11-02','13:00:00',1.45),('9650','2013-11-02','13:05:00',1.57),('9650','2013-11-02','13:10:00',1.71),('9650','2013-11-02','13:15:00',1.52),('9650','2013-11-02','13:20:00',1.64),('9650','2013-11-02','13:25:00',1.71),('9650','2013-11-02','13:30:00',1.65),('9650','2013-11-02','13:35:00',1.8),('9650','2013-11-02','13:40:00',2.3),('9650','2013-11-02','13:45:00',3.56),('9650','2013-11-02','13:50:00',1.7),('9650','2013-11-02','13:55:00',1.94),('9650','2013-11-02','14:00:00',2.33),('9650','2013-11-02','14:05:00',3.48),('9650','2013-11-02','14:10:00',3.52),('9650','2013-11-02','14:15:00',3.18),('9650','2013-11-02','14:20:00',2.92),('9650','2013-11-02','14:25:00',3.09),('9650','2013-11-02','14:30:00',2.1),('9650','2013-11-02','14:35:00',1.94),('9650','2013-11-02','14:40:00',2.73),('9650','2013-11-02','14:45:00',2.37),('9650','2013-11-02','14:50:00',1.85),('9650','2013-11-02','14:55:00',1.53),('9650','2013-11-02','15:05:00',1.25),('9650','2013-11-02','15:20:00',1.04),('9650','2013-11-01','09:10:00',1.02),('9650','2013-11-01','09:25:00',1.05),('9650','2013-11-01','09:30:00',1.11),('9650','2013-11-01','09:35:00',1.18),('9650','2013-11-01','09:40:00',1.3),('9650','2013-11-01','09:45:00',1.41),('9650','2013-11-01','09:50:00',1.8),('9650','2013-11-01','09:55:00',1.78),('9650','2013-11-01','10:00:00',2.32),('9650','2013-11-01','10:05:00',2.11),('9650','2013-11-01','10:10:00',1.91),('9650','2013-11-01','10:15:00',1.85),('9650','2013-11-01','10:20:00',1.41),('9650','2013-11-01','10:25:00',1.15),('9650','2013-11-01','10:40:00',1.11),('9650','2013-11-01','10:45:00',1.36),('9650','2013-11-01','10:50:00',1.24),('9650','2013-11-01','10:55:00',1.51),('9650','2013-11-01','11:00:00',2.02),('9650','2013-11-01','11:05:00',2.33),('9650','2013-11-01','11:10:00',2.1),('9650','2013-11-01','11:15:00',1.6),('9650','2013-11-01','11:20:00',1.16),('9650','2013-11-01','11:25:00',1.24),('9650','2013-11-01','11:30:00',1.26),('9650','2013-11-01','11:35:00',1.26),('9650','2013-11-01','11:40:00',1.49),('9650','2013-11-01','11:45:00',1.55),('9650','2013-11-01','11:50:00',1.79),('9650','2013-11-01','11:55:00',2.65),('9650','2013-11-01','12:00:00',4),('9650','2013-11-01','12:05:00',4.16),('9650','2013-11-01','12:10:00',4.18),('9650','2013-11-01','12:15:00',4.09),('9650','2013-11-01','12:20:00',4.43),('9650','2013-11-01','12:25:00',4.96),('9650','2013-11-01','12:30:00',5.29),('9650','2013-11-01','12:35:00',4.68),('9650','2013-11-01','12:40:00',4.18),('9650','2013-11-01','12:45:00',3.09),('9650','2013-11-01','12:50:00',4.23),('9650','2013-11-01','12:55:00',4.69),('9650','2013-11-01','13:00:00',3.85),('9650','2013-11-01','13:05:00',4.74),('9650','2013-11-01','13:10:00',4.93),('9650','2013-11-01','13:15:00',2.89),('9650','2013-11-01','13:20:00',1.84),('9650','2013-11-01','13:25:00',1.75),('9650','2013-11-01','13:30:00',2.47),('9650','2013-11-01','13:35:00',4.01),('9650','2013-11-01','13:40:00',4.55),('9650','2013-11-01','13:45:00',4.48),('9650','2013-11-01','13:50:00',4.76),('9650','2013-11-01','13:55:00',4.48),('9650','2013-11-01','14:00:00',3.93),('9650','2013-11-01','14:05:00',3.38),('9650','2013-11-01','14:10:00',3.08),('9650','2013-11-01','14:15:00',2.98),('9650','2013-11-01','14:20:00',2.79),('9650','2013-11-01','14:25:00',2.76),('9650','2013-11-01','14:30:00',2.67),('9650','2013-11-01','14:35:00',2.5),('9650','2013-11-01','14:40:00',2.35),('9650','2013-11-01','14:45:00',2.28),('9650','2013-11-01','14:50:00',2.32),('9650','2013-11-01','14:55:00',2.27),('9650','2013-11-01','15:00:00',2.19),('9650','2013-11-01','15:05:00',1.63),('9650','2013-11-01','15:10:00',2.11),('9650','2013-11-01','15:15:00',1.43),('9650','2013-11-01','15:40:00',1.16),('9650','2013-11-01','15:45:00',1.33),('9650','2013-11-01','15:50:00',1.35),('9650','2013-11-01','15:55:00',1.25),('9650','2014-04-16','08:45:00',1.09),('9650','2014-04-16','08:50:00',1.19),('9650','2014-04-16','08:55:00',1.15),('9650','2014-04-16','09:00:00',1.22),('9650','2014-04-16','09:05:00',1.52),('9650','2014-04-16','09:10:00',1.74),('9650','2014-04-16','09:15:00',1.88),('9650','2014-04-16','09:20:00',2.1),('9650','2014-04-16','09:25:00',2.24),('9650','2014-04-16','09:30:00',2.4),('9650','2014-04-16','09:35:00',2.57),('9650','2014-04-16','09:40:00',2.72),('9650','2014-04-16','09:45:00',2.87),('9650','2014-04-16','09:50:00',3.02),('9650','2014-04-16','09:55:00',3.19),('9650','2014-04-16','10:00:00',3.44),('9650','2014-04-16','10:05:00',3.92),('9650','2014-04-16','10:10:00',3.9),('9650','2014-04-16','10:15:00',3.2),('9650','2014-04-16','10:20:00',4.45),('9650','2014-04-16','10:25:00',4.78),('9650','2014-04-16','10:30:00',5.06),('9650','2014-04-16','10:35:00',5.45),('9650','2014-04-16','10:40:00',4.97),('9650','2014-04-16','10:45:00',4.63),('9650','2014-04-16','10:50:00',3.61),('9650','2014-04-16','10:55:00',3.5),('9650','2014-04-16','11:00:00',3.82),('9650','2014-04-16','11:05:00',4.4),('9650','2014-04-16','11:10:00',4.53),('9650','2014-04-16','11:15:00',3.82),('9650','2014-04-16','11:20:00',4.76),('9650','2014-04-16','11:25:00',5.78),('9650','2014-04-16','11:30:00',3.92),('9650','2014-04-16','11:35:00',3.82),('9650','2014-04-16','11:40:00',3.78),('9650','2014-04-16','11:45:00',5.74),('9650','2014-04-16','11:50:00',4.56),('9650','2014-04-16','11:55:00',3.57),('9650','2014-04-16','12:00:00',4.38),('9650','2014-04-16','12:05:00',4.82),('9650','2014-04-16','12:10:00',4.33),('9650','2014-04-16','12:15:00',3.73),('9650','2014-04-16','12:20:00',3.72),('9650','2014-04-16','12:25:00',3.9),('9650','2014-04-16','12:30:00',5.04),('9650','2014-04-16','12:35:00',5.49),('9650','2014-04-16','12:40:00',6.51),('9650','2014-04-16','12:45:00',6.31),('9650','2014-04-16','12:50:00',4.76),('9650','2014-04-16','12:55:00',7.09),('9650','2014-04-16','13:00:00',7.08),('9650','2014-04-16','13:05:00',5.23),('9650','2014-04-16','13:10:00',4.78),('9650','2014-04-16','13:15:00',2.95),('9650','2014-04-16','13:20:00',2.41),('9650','2014-04-16','13:25:00',7.59),('9650','2014-04-16','13:30:00',8.2),('9650','2014-04-16','13:35:00',2.61),('9650','2014-04-16','13:40:00',1.62),('9650','2014-04-16','13:45:00',1.68),('9650','2014-04-16','13:50:00',2.13),('9650','2014-04-16','13:55:00',2.29),('9650','2014-04-16','14:00:00',1.87),('9650','2014-04-16','14:05:00',2.06),('9650','2014-04-16','14:10:00',4.13),('9650','2014-04-16','14:15:00',6.16),('9650','2014-04-16','14:20:00',2.82),('9650','2014-04-16','14:25:00',3.53),('9650','2014-04-16','14:30:00',3.44),('9650','2014-04-16','14:35:00',4.41),('9650','2014-04-16','14:40:00',6.85),('9650','2014-04-16','14:45:00',2.51),('9650','2014-04-16','14:50:00',1.35),('9650','2014-04-16','14:55:00',1.22),('9650','2014-04-16','15:00:00',1.32),('9650','2014-04-16','15:05:00',1.43),('9650','2014-04-16','15:10:00',1.36),('9650','2014-04-16','15:15:00',1.4),('9650','2014-04-16','15:20:00',1.7),('9650','2014-04-16','15:25:00',2.24),('9650','2014-04-16','15:30:00',3.38),('9650','2014-04-16','15:35:00',4.49),('9650','2014-04-16','15:40:00',3.15),('9650','2014-04-16','15:45:00',2.31),('9650','2014-04-16','15:50:00',2.18),('9650','2014-04-16','15:55:00',2.45),('9650','2014-04-16','16:00:00',1.98),('9650','2014-04-16','16:05:00',1.61),('9650','2014-04-16','16:10:00',1.83),('9650','2014-04-16','16:15:00',1.84),('9650','2014-04-16','16:20:00',1.81),('9650','2014-04-16','16:25:00',2.07),('9650','2014-04-16','16:30:00',2.11),('9650','2014-04-16','16:35:00',1.9),('9650','2014-04-16','16:40:00',2.26),('9650','2014-04-16','16:45:00',3.07),('9650','2014-04-16','16:50:00',2.9),('9650','2014-04-16','16:55:00',2.18),('9650','2014-04-16','17:00:00',1.81),('9650','2014-04-16','17:05:00',1.55),('9650','2014-04-16','17:10:00',1.55),('9650','2014-04-16','17:15:00',1.87),('9650','2014-04-16','17:20:00',2.13),('9650','2014-04-16','17:25:00',1.78),('9650','2014-04-16','17:30:00',1.86),('9650','2014-04-16','17:35:00',2),('9650','2014-04-16','17:40:00',1.86),('9650','2014-04-16','17:45:00',1.71),('9650','2014-04-16','17:50:00',1.32),('9650','2014-04-16','17:55:00',1.23),('9650','2014-05-03','08:15:00',1.01),('9650','2014-05-03','08:20:00',1.16),('9650','2014-05-03','08:25:00',1.27),('9650','2014-05-03','08:30:00',1.57),('9650','2014-05-03','08:35:00',2.01),('9650','2014-05-03','08:40:00',1.79),('9650','2014-05-03','08:45:00',1.44),('9650','2014-05-03','08:50:00',1.83),('9650','2014-05-03','08:55:00',1.85),('9650','2014-05-03','09:00:00',2.08),('9650','2014-05-03','09:05:00',2.93),('9650','2014-05-03','09:10:00',3.2),('9650','2014-05-03','09:15:00',2.89),('9650','2014-05-03','09:20:00',4.3),('9650','2014-05-03','09:25:00',4),('9650','2014-05-03','09:30:00',2.31),('9650','2014-05-03','09:35:00',1.88),('9650','2014-05-03','09:40:00',2.19),('9650','2014-05-03','09:45:00',2.81),('9650','2014-05-03','09:50:00',2.71),('9650','2014-05-03','09:55:00',2.54),('9650','2014-05-03','10:00:00',4.36),('9650','2014-05-03','10:05:00',4.64),('9650','2014-05-03','10:10:00',4.61),('9650','2014-05-03','10:15:00',3.77),('9650','2014-05-03','10:20:00',3.12),('9650','2014-05-03','10:25:00',3.17),('9650','2014-05-03','10:30:00',3.38),('9650','2014-05-03','10:35:00',3.52),('9650','2014-05-03','10:40:00',3.65),('9650','2014-05-03','10:45:00',4.69),('9650','2014-05-03','10:50:00',5.34),('9650','2014-05-03','10:55:00',3.8),('9650','2014-05-03','11:00:00',3.64),('9650','2014-05-03','11:05:00',4.37),('9650','2014-05-03','11:10:00',6.61),('9650','2014-05-03','11:15:00',5.57),('9650','2014-05-03','11:20:00',6.42),('9650','2014-05-03','11:25:00',5.77),('9650','2014-05-03','11:30:00',5.37),('9650','2014-05-03','11:35:00',5.18),('9650','2014-05-03','11:40:00',4.16),('9650','2014-05-03','11:45:00',6.79),('9650','2014-05-03','11:50:00',4.37),('9650','2014-05-03','11:55:00',6.37),('9650','2014-05-03','12:00:00',4.3),('9650','2014-05-03','12:05:00',4.11),('9650','2014-05-03','12:10:00',3.23),('9650','2014-05-03','12:15:00',2.76),('9650','2014-05-03','12:20:00',2.76),('9650','2014-05-03','12:25:00',3.16),('9650','2014-05-03','12:30:00',6),('9650','2014-05-03','12:35:00',7.92),('9650','2014-05-03','12:40:00',6.49),('9650','2014-05-03','12:45:00',6.04),('9650','2014-05-03','12:50:00',5.21),('9650','2014-05-03','12:55:00',3.41),('9650','2014-05-03','13:00:00',4.71),('9650','2014-05-03','13:05:00',3.12),('9650','2014-05-03','13:10:00',3.57),('9650','2014-05-03','13:15:00',3.09),('9650','2014-05-03','13:20:00',2.85),('9650','2014-05-03','13:25:00',2.7),('9650','2014-05-03','13:30:00',2.67),('9650','2014-05-03','13:35:00',2.95),('9650','2014-05-03','13:40:00',2.9),('9650','2014-05-03','13:45:00',2.56),('9650','2014-05-03','13:50:00',2.46),('9650','2014-05-03','13:55:00',2.57),('9650','2014-05-03','14:00:00',2.63),('9650','2014-05-03','14:05:00',2.65),('9650','2014-05-03','14:10:00',2.49),('9650','2014-05-03','14:15:00',2.21),('9650','2014-05-03','14:20:00',1.66),('9650','2014-05-03','14:25:00',1.2),('9650','2014-05-03','14:30:00',1.12),('9650','2014-05-03','14:35:00',1.23),('9650','2014-05-03','14:40:00',1.46),('9650','2014-05-03','14:45:00',1.74),('9650','2014-05-03','14:50:00',2.37),('9650','2014-05-03','14:55:00',3.33),('9650','2014-05-03','15:00:00',3.61),('9650','2014-05-03','15:05:00',4.41),('9650','2014-05-03','15:10:00',5.71),('9650','2014-05-03','15:15:00',4.64),('9650','2014-05-03','15:20:00',3.4),('9650','2014-05-03','15:25:00',2.62),('9650','2014-05-03','15:30:00',2.18),('9650','2014-05-03','15:35:00',1.57),('9650','2014-05-03','15:40:00',1.41),('9650','2014-05-03','15:45:00',1.68),('9650','2014-05-03','15:50:00',2.01),('9650','2014-05-03','15:55:00',2.02),('9650','2014-05-03','16:00:00',1.73),('9650','2014-05-03','16:05:00',1.82),('9650','2014-05-03','16:10:00',2.17),('9650','2014-05-03','16:15:00',2.02),('9650','2014-05-03','16:20:00',1.66),('9650','2014-05-03','16:25:00',1.24),('9650','2014-05-03','17:20:00',1.14),('9650','2014-05-03','17:25:00',1.7),('9650','2014-05-03','17:30:00',1.82),('9650','2014-05-03','17:35:00',2.01),('9650','2014-05-03','17:40:00',2.14),('9650','2014-05-03','17:45:00',1.45),('9650','2014-05-03','17:50:00',1.12),('9650','2014-05-03','18:05:00',1.21),('9650','2014-05-03','18:10:00',1),('9650','2014-04-15','08:50:00',1.06),('9650','2014-04-15','08:55:00',1.3),('9650','2014-04-15','09:00:00',1.42),('9650','2014-04-15','09:05:00',1.56),('9650','2014-04-15','09:10:00',1.71),('9650','2014-04-15','09:15:00',1.87),('9650','2014-04-15','09:20:00',2.02),('9650','2014-04-15','09:25:00',2.25),('9650','2014-04-15','09:30:00',1.8),('9650','2014-04-15','09:35:00',1.3),('9650','2014-04-15','09:40:00',1.49),('9650','2014-04-15','09:45:00',1.46),('9650','2014-04-15','09:50:00',1.49),('9650','2014-04-15','09:55:00',3.22),('9650','2014-04-15','10:00:00',3.32),('9650','2014-04-15','10:05:00',3.44),('9650','2014-04-15','10:10:00',3.59),('9650','2014-04-15','10:15:00',3.73),('9650','2014-04-15','10:20:00',3.88),('9650','2014-04-15','10:25:00',4.02),('9650','2014-04-15','10:30:00',4.16),('9650','2014-04-15','10:35:00',4.3),('9650','2014-04-15','10:40:00',4.45),('9650','2014-04-15','10:45:00',4.66),('9650','2014-04-15','10:50:00',5.06),('9650','2014-04-15','10:55:00',4.74),('9650','2014-04-15','11:00:00',5.02),('9650','2014-04-15','11:05:00',2.97),('9650','2014-04-15','11:10:00',2.28),('9650','2014-04-15','11:15:00',3.17),('9650','2014-04-15','11:20:00',5.24),('9650','2014-04-15','11:25:00',4.64),('9650','2014-04-15','11:30:00',5.25),('9650','2014-04-15','11:35:00',4.15),('9650','2014-04-15','11:40:00',4.25),('9650','2014-04-15','11:45:00',5.61),('9650','2014-04-15','11:50:00',6.3),('9650','2014-04-15','11:55:00',7.05),('9650','2014-04-15','12:00:00',7.12),('9650','2014-04-15','12:05:00',4.59),('9650','2014-04-15','12:10:00',5.82),('9650','2014-04-15','12:15:00',6.43),('9650','2014-04-15','12:20:00',4.41),('9650','2014-04-15','12:25:00',2.23),('9650','2014-04-15','12:30:00',2.79),('9650','2014-04-15','12:35:00',7.29),('9650','2014-04-15','12:40:00',7.68),('9650','2014-04-15','12:45:00',7.42),('9650','2014-04-15','12:50:00',6.6),('9650','2014-04-15','12:55:00',1.89),('9650','2014-04-15','13:00:00',4.9),('9650','2014-04-15','13:05:00',2.61),('9650','2014-04-15','13:10:00',1.63),('9650','2014-04-15','13:15:00',1.68),('9650','2014-04-15','13:20:00',2.5),('9650','2014-04-15','13:25:00',2.09),('9650','2014-04-15','13:30:00',1.76),('9650','2014-04-15','13:35:00',3.14),('9650','2014-04-15','13:40:00',4.38),('9650','2014-04-15','13:45:00',8.54),('9650','2014-04-15','13:50:00',7.49),('9650','2014-04-15','13:55:00',5.6),('9650','2014-04-15','14:00:00',2.86),('9650','2014-04-15','14:05:00',5.45),('9650','2014-04-15','14:10:00',8.14),('9650','2014-04-15','14:15:00',8.8),('9650','2014-04-15','14:20:00',7.83),('9650','2014-04-15','14:25:00',7.44),('9650','2014-04-15','14:30:00',7.93),('9650','2014-04-15','14:35:00',7.65),('9650','2014-04-15','14:40:00',7.49),('9650','2014-04-15','14:45:00',7.72),('9650','2014-04-15','14:50:00',7.73),('9650','2014-04-15','14:55:00',2.93),('9650','2014-04-15','15:00:00',2.43),('9650','2014-04-15','15:05:00',6.39),('9650','2014-04-15','15:10:00',8.52),('9650','2014-04-15','15:15:00',4.89),('9650','2014-04-15','15:20:00',1.11),('9650','2014-04-15','15:25:00',2.21),('9650','2014-04-15','15:30:00',5.84),('9650','2014-04-15','15:35:00',7.72),('9650','2014-04-15','15:40:00',7.56),('9650','2014-04-15','15:45:00',7.41),('9650','2014-04-15','15:50:00',7.19),('9650','2014-04-15','15:55:00',7.02),('9650','2014-04-15','16:00:00',6.84),('9650','2014-04-15','16:05:00',6.68),('9650','2014-04-15','16:10:00',6.58),('9650','2014-04-15','16:15:00',6.49),('9650','2014-04-15','16:20:00',6.5),('9650','2014-04-15','16:25:00',6.34),('9650','2014-04-15','16:30:00',6.27),('9650','2014-04-15','16:35:00',6.19),('9650','2014-04-15','16:40:00',6.13),('9650','2014-04-15','16:45:00',6.03),('9650','2014-04-15','16:50:00',5.83),('9650','2014-04-15','16:55:00',5.69),('9650','2014-04-15','17:00:00',5.55),('9650','2014-04-15','17:05:00',5.35),('9650','2014-04-15','17:10:00',5.19),('9650','2014-04-15','17:15:00',5.07),('9650','2014-04-15','17:20:00',4.96),('9650','2014-04-15','17:25:00',4.91),('9650','2014-04-15','17:30:00',4.84),('9650','2014-04-15','17:35:00',4.79),('9650','2014-04-15','17:40:00',4.58),('9650','2014-04-15','17:45:00',4.49),('9650','2014-04-15','17:50:00',4.45),('9650','2014-04-15','17:55:00',4.47),('9650','2014-04-15','18:00:00',4.24),('9650','2014-04-15','18:05:00',4.08),('9650','2014-04-15','18:10:00',3.76),('9650','2014-04-15','18:15:00',3.28),('9650','2014-04-15','18:20:00',3.66),('9650','2014-04-15','18:25:00',3.27),('9650','2014-04-15','18:30:00',3.1),('9650','2014-04-15','18:35:00',2.81),('9650','2014-04-15','18:40:00',2.91),('9650','2014-04-15','18:45:00',2.94),('9650','2014-04-15','18:50:00',2.86),('9650','2014-04-15','18:55:00',2.15),('9650','2014-04-15','19:05:00',1.84),('9650','2014-04-15','19:10:00',1.55),('9650','2014-04-14','08:55:00',1.05),('9650','2014-04-14','09:00:00',1.51),('9650','2014-04-14','09:05:00',1.6),('9650','2014-04-14','09:10:00',1.52),('9650','2014-04-14','09:15:00',2.2),('9650','2014-04-14','09:20:00',2.81),('9650','2014-04-14','09:25:00',3.17),('9650','2014-04-14','09:30:00',2.54),('9650','2014-04-14','09:35:00',1.62),('9650','2014-04-14','09:40:00',1.03),('9650','2014-04-14','09:45:00',1.84),('9650','2014-04-14','09:50:00',3.24),('9650','2014-04-14','10:00:00',1.13),('9650','2014-04-14','10:05:00',2.57),('9650','2014-04-14','10:10:00',2.8),('9650','2014-04-14','10:15:00',2.74),('9650','2014-04-14','10:20:00',2.98),('9650','2014-04-14','10:25:00',3.09),('9650','2014-04-14','10:30:00',4.57),('9650','2014-04-14','10:35:00',3.07),('9650','2014-04-14','10:40:00',3.54),('9650','2014-04-14','10:45:00',3.69),('9650','2014-04-14','10:50:00',3.44),('9650','2014-04-14','10:55:00',2.81),('9650','2014-04-14','11:00:00',3.18),('9650','2014-04-14','11:05:00',5.11),('9650','2014-04-14','11:10:00',3.12),('9650','2014-04-14','11:15:00',2.25),('9650','2014-04-14','11:20:00',1.76),('9650','2014-04-14','11:25:00',2.44),('9650','2014-04-14','11:30:00',2.1),('9650','2014-04-14','11:35:00',1.73),('9650','2014-04-14','11:40:00',1.07),('9650','2014-04-14','11:45:00',1.7),('9650','2014-04-14','11:50:00',2.34),('9650','2014-04-14','11:55:00',1.78),('9650','2014-04-14','12:00:00',1.19),('9650','2014-04-14','12:05:00',1.39),('9650','2014-04-14','12:10:00',1.75),('9650','2014-04-14','12:15:00',2.8),('9650','2014-04-14','12:20:00',2.87),('9650','2014-04-14','12:25:00',1.57),('9650','2014-04-14','12:35:00',1.29),('9650','2014-04-14','12:40:00',1.04),('9650','2014-04-14','13:05:00',1.67),('9650','2014-04-14','13:10:00',2.47),('9650','2014-04-14','13:15:00',3.71),('9650','2014-04-14','13:20:00',4.37),('9650','2014-04-14','13:25:00',3.54),('9650','2014-04-14','13:30:00',4.93),('9650','2014-04-14','13:35:00',5.61),('9650','2014-04-14','13:40:00',3.14),('9650','2014-04-14','13:45:00',1.37),('9650','2014-04-14','13:50:00',1.25),('9650','2014-04-14','13:55:00',1.54),('9650','2014-04-14','14:00:00',5.62),('9650','2014-04-14','14:05:00',2.69),('9650','2014-04-14','14:10:00',5.61),('9650','2014-04-14','14:15:00',5.01),('9650','2014-04-14','14:20:00',6.38),('9650','2014-04-14','14:25:00',5.81),('9650','2014-04-14','14:30:00',4.21),('9650','2014-04-14','14:35:00',2.88),('9650','2014-04-14','14:40:00',3.64),('9650','2014-04-14','14:45:00',3.46),('9650','2014-04-14','14:50:00',3.8),('9650','2014-04-14','14:55:00',2.55),('9650','2014-04-14','15:00:00',1.59),('9650','2014-04-14','15:05:00',1.86),('9650','2014-04-14','15:10:00',2.12),('9650','2014-04-14','15:15:00',2.96),('9650','2014-04-14','15:20:00',4.11),('9650','2014-04-14','15:25:00',3.61),('9650','2014-04-14','15:30:00',2.95),('9650','2014-04-14','15:35:00',2.74),('9650','2014-04-14','15:40:00',2.7),('9650','2014-04-14','15:45:00',2.53),('9650','2014-04-14','15:50:00',2.59),('9650','2014-04-14','15:55:00',2.55),('9650','2014-04-14','16:00:00',2.83),('9650','2014-04-14','16:05:00',2.96),('9650','2014-04-14','16:10:00',1.53),('9650','2014-04-14','16:15:00',1.16),('9650','2014-04-13','08:45:00',1.04),('9650','2014-04-13','08:50:00',1.15),('9650','2014-04-13','08:55:00',1.26),('9650','2014-04-13','09:00:00',1.37),('9650','2014-04-13','09:05:00',1.48),('9650','2014-04-13','09:10:00',1.62),('9650','2014-04-13','09:15:00',1.76),('9650','2014-04-13','09:20:00',1.91),('9650','2014-04-13','09:25:00',2.04),('9650','2014-04-13','09:30:00',2.19),('9650','2014-04-13','09:35:00',2.33),('9650','2014-04-13','09:40:00',2.47),('9650','2014-04-13','09:45:00',2.62),('9650','2014-04-13','09:50:00',2.76),('9650','2014-04-13','09:55:00',2.9),('9650','2014-04-13','10:00:00',3.05),('9650','2014-04-13','10:05:00',3.18),('9650','2014-04-13','10:10:00',3.31),('9650','2014-04-13','10:15:00',3.43),('9650','2014-04-13','10:20:00',3.57),('9650','2014-04-13','10:25:00',3.71),('9650','2014-04-13','10:30:00',3.83),('9650','2014-04-13','10:35:00',3.95),('9650','2014-04-13','10:40:00',4.06),('9650','2014-04-13','10:45:00',4.19),('9650','2014-04-13','10:50:00',4.31),('9650','2014-04-13','10:55:00',4.43),('9650','2014-04-13','11:00:00',4.53),('9650','2014-04-13','11:05:00',4.6),('9650','2014-04-13','11:10:00',4.74),('9650','2014-04-13','11:15:00',4.85),('9650','2014-04-13','11:20:00',4.96),('9650','2014-04-13','11:25:00',5.07),('9650','2014-04-13','11:30:00',5.19),('9650','2014-04-13','11:35:00',5.27),('9650','2014-04-13','11:40:00',5.36),('9650','2014-04-13','11:45:00',5.46),('9650','2014-04-13','11:50:00',5.54),('9650','2014-04-13','11:55:00',5.61),('9650','2014-04-13','12:00:00',5.7),('9650','2014-04-13','12:05:00',5.79),('9650','2014-04-13','12:10:00',5.87),('9650','2014-04-13','12:15:00',5.94),('9650','2014-04-13','12:20:00',6.01),('9650','2014-04-13','12:25:00',6.11),('9650','2014-04-13','12:30:00',6.13),('9650','2014-04-13','12:35:00',6.19),('9650','2014-04-13','12:40:00',6.28),('9650','2014-04-13','12:45:00',6.34),('9650','2014-04-13','12:50:00',6.35),('9650','2014-04-13','12:55:00',6.45),('9650','2014-04-13','13:00:00',6.47),('9650','2014-04-13','13:05:00',6.5),('9650','2014-04-13','13:10:00',6.49),('9650','2014-04-13','13:15:00',6.61),('9650','2014-04-13','13:20:00',6.66),('9650','2014-04-13','13:25:00',6.67),('9650','2014-04-13','13:30:00',6.73),('9650','2014-04-13','13:35:00',6.8),('9650','2014-04-13','13:40:00',6.83),('9650','2014-04-13','13:45:00',6.85),('9650','2014-04-13','13:50:00',6.87),('9650','2014-04-13','13:55:00',6.9),('9650','2014-04-13','14:00:00',6.92),('9650','2014-04-13','14:05:00',6.95),('9650','2014-04-13','14:10:00',6.97),('9650','2014-04-13','14:15:00',6.96),('9650','2014-04-13','14:20:00',7),('9650','2014-04-13','14:25:00',7.04),('9650','2014-04-13','14:30:00',7.02),('9650','2014-04-13','14:35:00',7),('9650','2014-04-13','14:40:00',7.02),('9650','2014-04-13','14:45:00',7.02),('9650','2014-04-13','14:50:00',7),('9650','2014-04-13','14:55:00',6.99),('9650','2014-04-13','15:00:00',6.96),('9650','2014-04-13','15:05:00',6.91),('9650','2014-04-13','15:10:00',6.84),('9650','2014-04-13','15:15:00',6.75),('9650','2014-04-13','15:20:00',6.72),('9650','2014-04-13','15:25:00',6.71),('9650','2014-04-13','15:30:00',6.68),('9650','2014-04-13','15:35:00',6.62),('9650','2014-04-13','15:40:00',6.58),('9650','2014-04-13','15:45:00',6.52),('9650','2014-04-13','15:50:00',6.44),('9650','2014-04-13','15:55:00',6.3),('9650','2014-04-13','16:00:00',6.2),('9650','2014-04-13','16:05:00',6.1),('9650','2014-04-13','16:10:00',6.02),('9650','2014-04-13','16:15:00',5.95),('9650','2014-04-13','16:20:00',5.86),('9650','2014-04-13','16:25:00',5.87),('9650','2014-04-13','16:30:00',5.77),('9650','2014-04-13','16:35:00',5.72),('9650','2014-04-13','16:40:00',5.56),('9650','2014-04-13','16:45:00',5.42),('9650','2014-04-13','16:50:00',5.28),('9650','2014-04-13','16:55:00',5.17),('9650','2014-04-13','17:00:00',4.99),('9650','2014-04-13','17:05:00',4.82),('9650','2014-04-13','17:10:00',4.7),('9650','2014-04-13','17:15:00',4.61),('9650','2014-04-13','17:20:00',4.53),('9650','2014-04-13','17:25:00',4.5),('9650','2014-04-13','17:30:00',4.43),('9650','2014-04-13','17:35:00',4.27),('9650','2014-04-13','17:40:00',4.12),('9650','2014-04-13','17:45:00',4),('9650','2014-04-13','17:50:00',3.87),('9650','2014-04-13','17:55:00',3.75),('9650','2014-04-13','18:00:00',3.58),('9650','2014-04-13','18:05:00',3.41),('9650','2014-04-13','18:10:00',3.25),('9650','2014-04-13','18:15:00',3.09),('9650','2014-04-13','18:20:00',2.96),('9650','2014-04-13','18:25:00',2.84),('9650','2014-04-13','18:30:00',2.68),('9650','2014-04-13','18:35:00',2.46),('9650','2014-04-13','18:40:00',2.26),('9650','2014-04-13','18:45:00',2.03),('9650','2014-04-13','18:50:00',1.84),('9650','2014-04-13','18:55:00',1.68),('9650','2014-04-13','19:00:00',1.44),('9650','2014-04-13','19:05:00',1.22),('9650','2014-04-13','19:10:00',1.01),('9650','2014-04-12','08:30:00',1.14),('9650','2014-04-12','08:35:00',1.14),('9650','2014-04-12','08:40:00',1.19),('9650','2014-04-12','08:45:00',1.24),('9650','2014-04-12','08:50:00',1.18),('9650','2014-04-12','08:55:00',1.26),('9650','2014-04-12','09:00:00',1.59),('9650','2014-04-12','09:05:00',1.97),('9650','2014-04-12','09:10:00',2.24),('9650','2014-04-12','09:15:00',2.04),('9650','2014-04-12','09:20:00',2.2),('9650','2014-04-12','09:25:00',2.6),('9650','2014-04-12','09:30:00',2.72),('9650','2014-04-12','09:35:00',2.4),('9650','2014-04-12','09:40:00',2.98),('9650','2014-04-12','09:45:00',2.54),('9650','2014-04-12','09:50:00',2.1),('9650','2014-04-12','09:55:00',2.09),('9650','2014-04-12','10:00:00',3.28),('9650','2014-04-12','10:05:00',4.32),('9650','2014-04-12','10:10:00',3.25),('9650','2014-04-12','10:15:00',3.35),('9650','2014-04-12','10:20:00',3.92),('9650','2014-04-12','10:25:00',2.67),('9650','2014-04-12','10:30:00',3.72),('9650','2014-04-12','10:35:00',3.82),('9650','2014-04-12','10:40:00',3.81),('9650','2014-04-12','10:45:00',4.26),('9650','2014-04-12','10:50:00',4.45),('9650','2014-04-12','10:55:00',4.5),('9650','2014-04-12','11:00:00',4.58),('9650','2014-04-12','11:05:00',4.74),('9650','2014-04-12','11:10:00',4.86),('9650','2014-04-12','11:15:00',5.26),('9650','2014-04-12','11:20:00',4.61),('9650','2014-04-12','11:25:00',4.4),('9650','2014-04-12','11:30:00',3),('9650','2014-04-12','11:35:00',3.5),('9650','2014-04-12','11:40:00',5.71),('9650','2014-04-12','11:45:00',5.63),('9650','2014-04-12','11:50:00',5.94),('9650','2014-04-12','11:55:00',4.24),('9650','2014-04-12','12:00:00',3.58),('9650','2014-04-12','12:05:00',2.84),('9650','2014-04-12','12:10:00',2.51),('9650','2014-04-12','12:15:00',2.32),('9650','2014-04-12','12:20:00',2.04),('9650','2014-04-12','12:25:00',1.45),('9650','2014-04-12','12:30:00',1.02),('9650','2014-04-12','12:50:00',1.12),('9650','2014-04-12','12:55:00',1.2),('9650','2014-04-12','13:00:00',1.29),('9650','2014-04-12','13:05:00',2.37),('9650','2014-04-12','13:10:00',3.42),('9650','2014-04-12','13:15:00',3.34),('9650','2014-04-12','13:20:00',4.23),('9650','2014-04-12','13:25:00',4.49),('9650','2014-04-12','13:30:00',7.31),('9650','2014-04-12','13:35:00',6.55),('9650','2014-04-12','13:40:00',6.37),('9650','2014-04-12','13:45:00',3.43),('9650','2014-04-12','13:50:00',5.04),('9650','2014-04-12','13:55:00',4.64),('9650','2014-04-12','14:00:00',7.03),('9650','2014-04-12','14:05:00',6.97),('9650','2014-04-12','14:10:00',7.12),('9650','2014-04-12','14:15:00',6.98),('9650','2014-04-12','14:20:00',3.54),('9650','2014-04-12','14:25:00',2.82),('9650','2014-04-12','14:30:00',2.95),('9650','2014-04-12','14:35:00',2.91),('9650','2014-04-12','14:40:00',2.51),('9650','2014-04-12','14:45:00',3.36),('9650','2014-04-12','14:50:00',7.08),('9650','2014-04-12','14:55:00',5.09),('9650','2014-04-12','15:00:00',5.93),('9650','2014-04-12','15:05:00',6.68),('9650','2014-04-12','15:10:00',7),('9650','2014-04-12','15:15:00',6.06),('9650','2014-04-12','15:20:00',5.97),('9650','2014-04-12','15:25:00',6.35),('9650','2014-04-12','15:30:00',6.08),('9650','2014-04-12','15:35:00',4.13),('9650','2014-04-12','15:40:00',2.57),('9650','2014-04-12','15:45:00',2.75),('9650','2014-04-12','15:50:00',3.27),('9650','2014-04-12','15:55:00',3.34),('9650','2014-04-12','16:00:00',6.48),('9650','2014-04-12','16:05:00',4.97),('9650','2014-04-12','16:10:00',2.24),('9650','2014-04-12','16:15:00',2.36),('9650','2014-04-12','16:20:00',2.6),('9650','2014-04-12','16:25:00',2.96),('9650','2014-04-12','16:30:00',2.37),('9650','2014-04-12','16:35:00',3.04),('9650','2014-04-12','16:40:00',5.18),('9650','2014-04-12','16:45:00',5.18),('9650','2014-04-12','16:50:00',3.7),('9650','2014-04-12','16:55:00',4.67),('9650','2014-04-12','17:00:00',4.73),('9650','2014-04-12','17:05:00',2.71),('9650','2014-04-12','17:10:00',1.9),('9650','2014-04-12','17:15:00',2.33),('9650','2014-04-12','17:20:00',3.58),('9650','2014-04-12','17:25:00',2.69),('9650','2014-04-12','17:30:00',1.6),('9650','2014-04-12','17:35:00',1.42),('9650','2014-04-12','17:40:00',1.41),('9650','2014-04-12','17:45:00',1.78),('9650','2014-04-12','17:50:00',2.14),('9650','2014-04-12','17:55:00',2.76),('9650','2014-04-12','18:00:00',2.4),('9650','2014-04-12','18:05:00',1.96),('9650','2014-04-12','18:10:00',1.02),('9650','2014-04-12','18:20:00',1.01),('9650','2014-04-12','18:25:00',1.06),('9650','2014-04-12','18:30:00',1.06),('9650','2013-09-09','08:15:00',1.03),('9650','2013-09-09','08:45:00',1.05),('9650','2013-09-09','08:55:00',1.19),('9650','2013-09-09','09:00:00',1.35),('9650','2013-09-09','09:05:00',1.64),('9650','2013-09-09','09:10:00',2.24),('9650','2013-09-09','09:15:00',2.08),('9650','2013-09-09','09:20:00',1.95),('9650','2013-09-09','09:25:00',1.97),('9650','2013-09-09','09:30:00',2.84),('9650','2013-09-09','09:35:00',3.25),('9650','2013-09-09','09:40:00',2.39),('9650','2013-09-09','09:45:00',2.15),('9650','2013-09-09','09:50:00',2.05),('9650','2013-09-09','09:55:00',1.83),('9650','2013-09-09','10:00:00',1.35),('9650','2013-09-09','10:05:00',1.23),('9650','2013-09-09','10:10:00',1.07),('9650','2013-09-09','10:15:00',1.09),('9650','2013-09-09','10:20:00',1.58),('9650','2013-09-09','10:25:00',1.74),('9650','2013-09-09','10:30:00',1.7),('9650','2013-09-09','10:35:00',1.91),('9650','2013-09-09','10:40:00',2.52),('9650','2013-09-09','10:45:00',3.2),('9650','2013-09-09','10:50:00',2.11),('9650','2013-09-09','10:55:00',2.26),('9650','2013-09-09','11:00:00',2.66),('9650','2013-09-09','11:05:00',2.44),('9650','2013-09-09','11:10:00',2.36),('9650','2013-09-09','11:15:00',2.08),('9650','2013-09-09','11:20:00',2.33),('9650','2013-09-09','11:25:00',2.44),('9650','2013-09-09','11:30:00',1.85),('9650','2013-09-09','11:35:00',1.31),('9650','2013-09-09','11:40:00',1.48),('9650','2013-09-09','11:45:00',2.11),('9650','2013-09-09','11:50:00',2.3),('9650','2013-09-09','11:55:00',2.85),('9650','2013-09-09','12:00:00',2.43),('9650','2013-09-09','12:05:00',1.82),('9650','2013-09-09','12:10:00',1.87),('9650','2013-09-09','12:15:00',1.92),('9650','2013-09-09','12:20:00',1.8),('9650','2013-09-09','12:25:00',1.62),('9650','2013-09-09','12:30:00',1.47),('9650','2013-09-09','12:35:00',1.35),('9650','2013-09-09','12:40:00',1.09),('9650','2013-09-09','12:45:00',1.02),('9650','2013-09-09','12:50:00',1.02),('9650','2013-09-09','12:55:00',1.1),('9650','2013-09-09','13:00:00',1.36),('9650','2013-09-09','13:05:00',1.17),('9650','2013-09-09','13:10:00',1.2),('9650','2013-09-09','13:15:00',1.69),('9650','2013-09-09','13:20:00',1.76),('9650','2013-09-09','13:25:00',2.04),('9650','2013-09-09','13:30:00',1.86),('9650','2013-09-09','13:35:00',2.02),('9650','2013-09-09','13:40:00',3.18),('9650','2013-09-09','13:45:00',4.65),('9650','2013-09-09','13:50:00',3.2),('9650','2013-09-09','13:55:00',2.71),('9650','2013-09-09','14:00:00',2.08),('9650','2013-09-09','14:05:00',2.37),('9650','2013-09-09','14:10:00',2.43),('9650','2013-09-09','14:15:00',2.85),('9650','2013-09-09','14:20:00',2.82),('9650','2013-09-09','14:25:00',3.82),('9650','2013-09-09','14:30:00',3.31),('9650','2013-09-09','14:35:00',2.52),('9650','2013-09-09','14:40:00',3.05),('9650','2013-09-09','14:45:00',3.23),('9650','2013-09-09','14:50:00',3.79),('9650','2013-09-09','14:55:00',3.26),('9650','2013-09-09','15:00:00',4.3),('9650','2013-09-09','15:05:00',4),('9650','2013-09-09','15:10:00',3.03),('9650','2013-09-09','15:15:00',2.81),('9650','2013-09-09','15:20:00',3.48),('9650','2013-09-09','15:25:00',3.12),('9650','2013-09-09','15:30:00',3.68),('9650','2013-09-09','15:35:00',3.07),('9650','2013-09-09','15:40:00',2.16),('9650','2013-09-09','15:45:00',1.81),('9650','2013-09-09','15:50:00',1.86),('9650','2013-09-09','15:55:00',1.8),('9650','2013-09-09','16:00:00',1.74),('9650','2013-09-09','16:05:00',1.9),('9650','2013-09-09','16:10:00',2.29),('9650','2013-09-09','16:15:00',2.59),('9650','2013-09-09','16:20:00',1.79),('9650','2013-09-09','16:25:00',1.65),('9650','2013-09-09','16:30:00',1.33),('9650','2013-09-09','16:45:00',1.25),('9650','2013-09-09','16:50:00',1.55),('9650','2013-09-09','16:55:00',1.51),('9650','2013-09-09','17:00:00',1.3),('9650','2013-09-09','17:05:00',1.13),('9650','2013-09-09','17:10:00',1.17),('9650','2013-09-09','17:15:00',1.46),('9650','2013-09-09','17:20:00',1.44),('9650','2013-09-09','17:25:00',1.39),('9650','2013-09-09','17:30:00',1.28),('9650','2013-09-09','17:35:00',1.03),('9650','2013-09-09','17:40:00',1.07),('9650','2013-09-09','17:45:00',1.29),('9650','2013-09-09','17:50:00',1.52),('9650','2013-09-09','17:55:00',1.19),('9650','2013-09-08','07:40:00',1.14),('9650','2013-09-08','07:45:00',1.24),('9650','2013-09-08','07:50:00',1.2),('9650','2013-09-08','07:55:00',1.11),('9650','2013-09-08','08:00:00',1.03),('9650','2013-09-08','08:40:00',1.21),('9650','2013-09-08','08:45:00',1.52),('9650','2013-09-08','08:50:00',1.63),('9650','2013-09-08','08:55:00',1.75),('9650','2013-09-08','09:00:00',1.84),('9650','2013-09-08','09:05:00',1.82),('9650','2013-09-08','09:10:00',1.65),('9650','2013-09-08','09:15:00',1.15),('9650','2013-09-08','09:20:00',1.11),('9650','2013-09-08','09:25:00',1.03),('9650','2013-09-08','09:30:00',1.16),('9650','2013-09-08','09:35:00',1.82),('9650','2013-09-08','09:40:00',1.67),('9650','2013-09-08','09:45:00',1.02),('9650','2013-09-08','09:50:00',1.12),('9650','2013-09-08','09:55:00',1.1),('9650','2013-09-08','10:00:00',2.07),('9650','2013-09-08','10:05:00',2.73),('9650','2013-09-08','10:10:00',2.75),('9650','2013-09-08','10:15:00',2.53),('9650','2013-09-08','10:20:00',2.47),('9650','2013-09-08','10:25:00',2.29),('9650','2013-09-08','10:30:00',2.38),('9650','2013-09-08','10:35:00',2.37),('9650','2013-09-08','10:40:00',2.55),('9650','2013-09-08','10:45:00',2.84),('9650','2013-09-08','10:50:00',3.51),('9650','2013-09-08','10:55:00',3.58),('9650','2013-09-08','11:00:00',4.02),('9650','2013-09-08','11:05:00',3.3),('9650','2013-09-08','11:10:00',3.14),('9650','2013-09-08','11:15:00',3.27),('9650','2013-09-08','11:20:00',3.54),('9650','2013-09-08','11:25:00',3.78),('9650','2013-09-08','11:30:00',3.14),('9650','2013-09-08','11:35:00',3.17),('9650','2013-09-08','11:40:00',4.52),('9650','2013-09-08','11:45:00',4.8),('9650','2013-09-08','11:50:00',5.09),('9650','2013-09-08','11:55:00',4.3),('9650','2013-09-08','12:00:00',4.69),('9650','2013-09-08','12:05:00',4.36),('9650','2013-09-08','12:10:00',4.37),('9650','2013-09-08','12:15:00',3.58),('9650','2013-09-08','12:20:00',2.44),('9650','2013-09-08','12:25:00',1.9),('9650','2013-09-08','12:30:00',1.73),('9650','2013-09-08','12:35:00',1.74),('9650','2013-09-08','12:40:00',2.39),('9650','2013-09-08','12:45:00',2.52),('9650','2013-09-08','12:50:00',2.06),('9650','2013-09-08','12:55:00',2.62),('9650','2013-09-08','13:00:00',2.59),('9650','2013-09-08','13:05:00',3.92),('9650','2013-09-08','13:10:00',3.7),('9650','2013-09-08','13:15:00',4.94),('9650','2013-09-08','13:20:00',4.49),('9650','2013-09-08','13:25:00',4.05),('9650','2013-09-08','13:30:00',4.88),('9650','2013-09-08','13:35:00',5.97),('9650','2013-09-08','13:40:00',4.89),('9650','2013-09-08','13:45:00',6),('9650','2013-09-08','13:50:00',5.94),('9650','2013-09-08','13:55:00',6.26),('9650','2013-09-08','14:00:00',5.73),('9650','2013-09-08','14:05:00',5.53),('9650','2013-09-08','14:10:00',5.73),('9650','2013-09-08','14:15:00',3.93),('9650','2013-09-08','14:20:00',3.38),('9650','2013-09-08','14:25:00',2.58),('9650','2013-09-08','14:30:00',3.28),('9650','2013-09-08','14:35:00',6.16),('9650','2013-09-08','14:40:00',6.29),('9650','2013-09-08','14:45:00',4.39),('9650','2013-09-08','14:50:00',5.77),('9650','2013-09-08','14:55:00',4.98),('9650','2013-09-08','15:00:00',4.4),('9650','2013-09-08','15:05:00',4.46),('9650','2013-09-08','15:10:00',4.43),('9650','2013-09-08','15:15:00',2.29),('9650','2013-09-08','15:20:00',3.69),('9650','2013-09-08','15:25:00',2.12),('9650','2013-09-08','15:30:00',5.34),('9650','2013-09-08','15:35:00',4.34),('9650','2013-09-08','15:40:00',3.98),('9650','2013-09-08','15:45:00',2.35),('9650','2013-09-08','15:50:00',2.39),('9650','2013-09-08','15:55:00',2.62),('9650','2013-09-08','16:00:00',3.04),('9650','2013-09-08','16:05:00',2.48),('9650','2013-09-08','16:10:00',3.13),('9650','2013-09-08','16:15:00',4.36),('9650','2013-09-08','16:20:00',3.39),('9650','2013-09-08','16:25:00',2.07),('9650','2013-09-08','16:30:00',2.06),('9650','2013-09-08','16:35:00',2.23),('9650','2013-09-08','16:40:00',2.52),('9650','2013-09-08','16:45:00',3.58),('9650','2013-09-08','16:50:00',1.47),('9650','2013-09-08','16:55:00',1.31),('9650','2013-09-08','17:00:00',1.88),('9650','2013-09-08','17:05:00',1.39),('9650','2013-09-08','17:10:00',1.53),('9650','2013-09-08','17:15:00',1.01),('9650','2013-09-08','17:40:00',1.1),('9650','2013-09-08','18:05:00',1.07),('9650','2013-09-08','18:10:00',1.71),('9650','2013-09-08','18:15:00',1.83),('9650','2013-09-08','18:20:00',1.36),('9650','2013-09-08','18:25:00',1.13),('9650','2013-09-08','18:30:00',1.34),('9650','2014-04-11','09:05:00',1.21),('9650','2014-04-11','09:10:00',1.58),('9650','2014-04-11','09:15:00',2.18),('9650','2014-04-11','09:20:00',2.94),('9650','2014-04-11','09:25:00',3.13),('9650','2014-04-11','09:30:00',2.64),('9650','2014-04-11','09:35:00',2.5),('9650','2014-04-11','09:40:00',2.26),('9650','2014-04-11','09:45:00',2.26),('9650','2014-04-11','09:50:00',2.43),('9650','2014-04-11','09:55:00',2.38),('9650','2014-04-11','10:00:00',2.38),('9650','2014-04-11','10:05:00',2.43),('9650','2014-04-11','10:10:00',2.6),('9650','2014-04-11','10:15:00',2.76),('9650','2014-04-11','10:20:00',2.89),('9650','2014-04-11','10:25:00',3.04),('9650','2014-04-11','10:30:00',3.13),('9650','2014-04-11','10:35:00',3.43),('9650','2014-04-11','10:40:00',3.26),('9650','2014-04-11','10:45:00',3.65),('9650','2014-04-11','10:50:00',3.6),('9650','2014-04-11','10:55:00',4.22),('9650','2014-04-11','11:00:00',4.15),('9650','2014-04-11','11:05:00',3.81),('9650','2014-04-11','11:10:00',3.94),('9650','2014-04-11','11:15:00',3.72),('9650','2014-04-11','11:20:00',5.26),('9650','2014-04-11','11:25:00',5.3),('9650','2014-04-11','11:30:00',5.16),('9650','2014-04-11','11:35:00',5.51),('9650','2014-04-11','11:40:00',5.37),('9650','2014-04-11','11:45:00',5.76),('9650','2014-04-11','11:50:00',3.78),('9650','2014-04-11','11:55:00',4.47),('9650','2014-04-11','12:00:00',4.53),('9650','2014-04-11','12:05:00',3.01),('9650','2014-04-11','12:10:00',3.02),('9650','2014-04-11','12:15:00',3.06),('9650','2014-04-11','12:20:00',4.05),('9650','2014-04-11','12:25:00',5.11),('9650','2014-04-11','12:30:00',4.42),('9650','2014-04-11','12:35:00',4.15),('9650','2014-04-11','12:40:00',4.39),('9650','2014-04-11','12:45:00',4.28),('9650','2014-04-11','12:50:00',3.21),('9650','2014-04-11','12:55:00',2.82),('9650','2014-04-11','13:00:00',3),('9650','2014-04-11','13:05:00',4.38),('9650','2014-04-11','13:10:00',5.16),('9650','2014-04-11','13:15:00',5.77),('9650','2014-04-11','13:20:00',6.83),('9650','2014-04-11','13:25:00',5.36),('9650','2014-04-11','13:30:00',5.01),('9650','2014-04-11','13:35:00',2.46),('9650','2014-04-11','13:40:00',2.56),('9650','2014-04-11','13:45:00',6.67),('9650','2014-04-11','13:50:00',4.73),('9650','2014-04-11','13:55:00',2.66),('9650','2014-04-11','14:00:00',6.06),('9650','2014-04-11','14:05:00',6.87),('9650','2014-04-11','14:10:00',6.65),('9650','2014-04-11','14:15:00',5.02),('9650','2014-04-11','14:20:00',5.49),('9650','2014-04-11','14:25:00',3.08),('9650','2014-04-11','14:30:00',5.03),('9650','2014-04-11','14:35:00',3.67),('9650','2014-04-11','14:40:00',2.5),('9650','2014-04-11','14:45:00',5.44),('9650','2014-04-11','14:50:00',7.76),('9650','2014-04-11','14:55:00',6.67),('9650','2014-04-11','15:00:00',4.76),('9650','2014-04-11','15:05:00',6.12),('9650','2014-04-11','15:10:00',6.26),('9650','2014-04-11','15:15:00',6.3),('9650','2014-04-11','15:20:00',5.1),('9650','2014-04-11','15:25:00',3.6),('9650','2014-04-11','15:30:00',3.96),('9650','2014-04-11','15:35:00',3.83),('9650','2014-04-11','15:40:00',4.92),('9650','2014-04-11','15:45:00',5.56),('9650','2014-04-11','15:50:00',6.42),('9650','2014-04-11','15:55:00',6.2),('9650','2014-04-11','16:00:00',6.13),('9650','2014-04-11','16:05:00',6.03),('9650','2014-04-11','16:10:00',5.88),('9650','2014-04-11','16:15:00',6.19),('9650','2014-04-11','16:20:00',6.29),('9650','2014-04-11','16:25:00',5.71),('9650','2014-04-11','16:30:00',5.46),('9650','2014-04-11','16:35:00',4.95),('9650','2014-04-11','16:40:00',4.47),('9650','2014-04-11','16:45:00',4.73),('9650','2014-04-11','16:50:00',3.29),('9650','2014-04-11','16:55:00',4.88),('9650','2014-04-11','17:00:00',4.77),('9650','2014-04-11','17:05:00',4.49),('9650','2014-04-11','17:10:00',4.49),('9650','2014-04-11','17:15:00',4.33),('9650','2014-04-11','17:20:00',3.53),('9650','2014-04-11','17:25:00',4.22),('9650','2014-04-11','17:30:00',4.14),('9650','2014-04-11','17:35:00',3.02),('9650','2014-04-11','17:40:00',4),('9650','2014-04-11','17:45:00',4.42),('9650','2014-04-11','17:50:00',4.14),('9650','2014-04-11','17:55:00',3.92),('9650','2014-04-11','18:00:00',2.92),('9650','2014-04-11','18:05:00',1.75),('9650','2014-04-11','18:10:00',1.32),('9650','2014-04-11','18:15:00',1.49),('9650','2014-04-11','18:20:00',1.12),('9650','2014-04-11','18:30:00',1.12),('9650','2014-04-11','18:40:00',1.28),('9650','2014-04-11','18:45:00',1.55),('9650','2014-04-11','18:50:00',1.65),('9650','2014-04-11','18:55:00',1.42),('9650','2013-09-07','08:35:00',1.14),('9650','2013-09-07','08:40:00',1.25),('9650','2013-09-07','08:45:00',1.24),('9650','2013-09-07','08:50:00',1.26),('9650','2013-09-07','08:55:00',1.35),('9650','2013-09-07','09:00:00',1.49),('9650','2013-09-07','09:05:00',1.62),('9650','2013-09-07','09:10:00',1.67),('9650','2013-09-07','09:15:00',1.64),('9650','2013-09-07','09:20:00',1.7),('9650','2013-09-07','09:25:00',1.59),('9650','2013-09-07','09:30:00',1.86),('9650','2013-09-07','09:35:00',1.96),('9650','2013-09-07','09:40:00',1.83),('9650','2013-09-07','09:45:00',2.08),('9650','2013-09-07','09:50:00',2.09),('9650','2013-09-07','09:55:00',2.24),('9650','2013-09-07','10:00:00',2.32),('9650','2013-09-07','10:05:00',2.47),('9650','2013-09-07','10:10:00',2.6),('9650','2013-09-07','10:15:00',2.65),('9650','2013-09-07','10:20:00',2.82),('9650','2013-09-07','10:25:00',2.93),('9650','2013-09-07','10:30:00',3.05),('9650','2013-09-07','10:35:00',3.13),('9650','2013-09-07','10:40:00',3.29),('9650','2013-09-07','10:45:00',3.39),('9650','2013-09-07','10:50:00',3.45),('9650','2013-09-07','10:55:00',3.46),('9650','2013-09-07','11:00:00',3.59),('9650','2013-09-07','11:05:00',3.69),('9650','2013-09-07','11:10:00',3.85),('9650','2013-09-07','11:15:00',3.94),('9650','2013-09-07','11:20:00',4.07),('9650','2013-09-07','11:25:00',4.12),('9650','2013-09-07','11:30:00',4.15),('9650','2013-09-07','11:35:00',4.22),('9650','2013-09-07','11:40:00',4.31),('9650','2013-09-07','11:45:00',4.44),('9650','2013-09-07','11:50:00',4.53),('9650','2013-09-07','11:55:00',4.49),('9650','2013-09-07','12:00:00',4.49),('9650','2013-09-07','12:05:00',4.44),('9650','2013-09-07','12:10:00',4.46),('9650','2013-09-07','12:15:00',4.81),('9650','2013-09-07','12:20:00',4.89),('9650','2013-09-07','12:25:00',4.98),('9650','2013-09-07','12:30:00',5.04),('9650','2013-09-07','12:35:00',4.99),('9650','2013-09-07','12:40:00',4.98),('9650','2013-09-07','12:45:00',5.17),('9650','2013-09-07','12:50:00',5.15),('9650','2013-09-07','12:55:00',5.33),('9650','2013-09-07','13:00:00',5.31),('9650','2013-09-07','13:05:00',5.46),('9650','2013-09-07','13:10:00',5.37),('9650','2013-09-07','13:15:00',5.43),('9650','2013-09-07','13:20:00',5.51),('9650','2013-09-07','13:25:00',5.08),('9650','2013-09-07','13:30:00',4.97),('9650','2013-09-07','13:35:00',4.84),('9650','2013-09-07','13:40:00',3.69),('9650','2013-09-07','13:45:00',3.28),('9650','2013-09-07','13:50:00',4.24),('9650','2013-09-07','13:55:00',4.38),('9650','2013-09-07','14:00:00',5.31),('9650','2013-09-07','14:05:00',5.32),('9650','2013-09-07','14:10:00',6.06),('9650','2013-09-07','14:15:00',5.34),('9650','2013-09-07','14:20:00',5.93),('9650','2013-09-07','14:25:00',6.44),('9650','2013-09-07','14:30:00',5.59),('9650','2013-09-07','14:35:00',5.94),('9650','2013-09-07','14:40:00',5.96),('9650','2013-09-07','14:45:00',5.86),('9650','2013-09-07','14:50:00',5.93),('9650','2013-09-07','14:55:00',5.83),('9650','2013-09-07','15:00:00',5.94),('9650','2013-09-07','15:05:00',4.81),('9650','2013-09-07','15:10:00',3.33),('9650','2013-09-07','15:15:00',4.39),('9650','2013-09-07','15:20:00',5.66),('9650','2013-09-07','15:25:00',5.61),('9650','2013-09-07','15:30:00',5.72),('9650','2013-09-07','15:35:00',5.64),('9650','2013-09-07','15:40:00',5.28),('9650','2013-09-07','15:45:00',5.36),('9650','2013-09-07','15:50:00',5.18),('9650','2013-09-07','15:55:00',4.25),('9650','2013-09-07','16:00:00',4.53),('9650','2013-09-07','16:05:00',4.55),('9650','2013-09-07','16:10:00',4.21),('9650','2013-09-07','16:15:00',4.64),('9650','2013-09-07','16:20:00',4.34),('9650','2013-09-07','16:25:00',4.26),('9650','2013-09-07','16:30:00',4.38),('9650','2013-09-07','16:35:00',4.1),('9650','2013-09-07','16:40:00',3.55),('9650','2013-09-07','16:45:00',2.56),('9650','2013-09-07','16:50:00',2.54),('9650','2013-09-07','16:55:00',2.26),('9650','2013-09-07','17:00:00',2.85),('9650','2013-09-07','17:05:00',4.04),('9650','2013-09-07','17:10:00',3.93),('9650','2013-09-07','17:15:00',3.66),('9650','2013-09-07','17:20:00',3.22),('9650','2013-09-07','17:25:00',3.34),('9650','2013-09-07','17:30:00',3.13),('9650','2013-09-07','17:35:00',1.71),('9650','2013-09-07','17:40:00',1.89),('9650','2013-09-07','17:45:00',2.71),('9650','2013-09-07','17:50:00',2.71),('9650','2013-09-07','17:55:00',2.56),('9650','2013-09-07','18:00:00',2.28),('9650','2013-09-07','18:05:00',2),('9650','2013-09-07','18:10:00',1.87),('9650','2013-09-07','18:15:00',1.62),('9650','2013-09-07','18:20:00',1.54),('9650','2013-09-07','18:25:00',1.43),('9650','2013-09-07','18:30:00',1.21),('9650','2013-09-06','09:05:00',1.06),('9650','2013-09-06','09:10:00',1.16),('9650','2013-09-06','09:15:00',1.28),('9650','2013-09-06','09:20:00',1.4),('9650','2013-09-06','09:25:00',1.53),('9650','2013-09-06','09:30:00',1.65),('9650','2013-09-06','09:35:00',1.78),('9650','2013-09-06','09:40:00',1.9),('9650','2013-09-06','09:45:00',2.01),('9650','2013-09-06','09:50:00',2.13),('9650','2013-09-06','09:55:00',2.25),('9650','2013-09-06','10:00:00',2.38),('9650','2013-09-06','10:05:00',2.5),('9650','2013-09-06','10:10:00',2.61),('9650','2013-09-06','10:15:00',2.74),('9650','2013-09-06','10:20:00',2.88),('9650','2013-09-06','10:25:00',2.96),('9650','2013-09-06','10:30:00',3.08),('9650','2013-09-06','10:35:00',3.2),('9650','2013-09-06','10:40:00',3.33),('9650','2013-09-06','10:45:00',3.44),('9650','2013-09-06','10:50:00',3.54),('9650','2013-09-06','10:55:00',3.63),('9650','2013-09-06','11:00:00',3.75),('9650','2013-09-06','11:05:00',3.85),('9650','2013-09-06','11:10:00',3.96),('9650','2013-09-06','11:15:00',4.05),('9650','2013-09-06','11:20:00',4.13),('9650','2013-09-06','11:25:00',4.2),('9650','2013-09-06','11:30:00',4.33),('9650','2013-09-06','11:35:00',4.42),('9650','2013-09-06','11:40:00',4.52),('9650','2013-09-06','11:45:00',4.62),('9650','2013-09-06','11:50:00',4.7),('9650','2013-09-06','11:55:00',4.76),('9650','2013-09-06','12:00:00',4.83),('9650','2013-09-06','12:05:00',4.92),('9650','2013-09-06','12:10:00',4.98),('9650','2013-09-06','12:15:00',5.04),('9650','2013-09-06','12:20:00',5.11),('9650','2013-09-06','12:25:00',5.14),('9650','2013-09-06','12:30:00',5.15),('9650','2013-09-06','12:35:00',5.23),('9650','2013-09-06','12:40:00',5.26),('9650','2013-09-06','12:45:00',5.31),('9650','2013-09-06','12:50:00',5.36),('9650','2013-09-06','12:55:00',5.46),('9650','2013-09-06','13:00:00',5.31),('9650','2013-09-06','13:05:00',5.54),('9650','2013-09-06','13:10:00',5.47),('9650','2013-09-06','13:15:00',5.6),('9650','2013-09-06','13:20:00',5.62),('9650','2013-09-06','13:25:00',5.68),('9650','2013-09-06','13:30:00',5.84),('9650','2013-09-06','13:35:00',5.85),('9650','2013-09-06','13:40:00',5.49),('9650','2013-09-06','13:45:00',5.58),('9650','2013-09-06','13:50:00',5.76),('9650','2013-09-06','13:55:00',5.76),('9650','2013-09-06','14:00:00',5.71),('9650','2013-09-06','14:05:00',5.76),('9650','2013-09-06','14:10:00',5.98),('9650','2013-09-06','14:15:00',5.94),('9650','2013-09-06','14:20:00',5.86),('9650','2013-09-06','14:25:00',5.77),('9650','2013-09-06','14:30:00',5.84),('9650','2013-09-06','14:35:00',5.97),('9650','2013-09-06','14:40:00',5.98),('9650','2013-09-06','14:45:00',5.95),('9650','2013-09-06','14:50:00',5.9),('9650','2013-09-06','14:55:00',5.92),('9650','2013-09-06','15:00:00',5.88),('9650','2013-09-06','15:05:00',5.75),('9650','2013-09-06','15:10:00',5.7),('9650','2013-09-06','15:15:00',5.69),('9650','2013-09-06','15:20:00',5.65),('9650','2013-09-06','15:25:00',5.65),('9650','2013-09-06','15:30:00',5.6),('9650','2013-09-06','15:35:00',5.53),('9650','2013-09-06','15:40:00',5.44),('9650','2013-09-06','15:45:00',5.35),('9650','2013-09-06','15:50:00',5.27),('9650','2013-09-06','15:55:00',4.95),('9650','2013-09-06','16:00:00',4.99),('9650','2013-09-06','16:05:00',4.94),('9650','2013-09-06','16:10:00',4.87),('9650','2013-09-06','16:15:00',4.77),('9650','2013-09-06','16:20:00',4.73),('9650','2013-09-06','16:25:00',4.6),('9650','2013-09-06','16:30:00',4.51),('9650','2013-09-06','16:35:00',4.42),('9650','2013-09-06','16:40:00',4.33),('9650','2013-09-06','16:45:00',4.2),('9650','2013-09-06','16:50:00',4.09),('9650','2013-09-06','16:55:00',4.03),('9650','2013-09-06','17:00:00',3.9),('9650','2013-09-06','17:05:00',3.79),('9650','2013-09-06','17:10:00',3.67),('9650','2013-09-06','17:15:00',3.59),('9650','2013-09-06','17:20:00',3.5),('9650','2013-09-06','17:25:00',3.39),('9650','2013-09-06','17:30:00',3.24),('9650','2013-09-06','17:35:00',3.21),('9650','2013-09-06','17:40:00',3.13),('9650','2013-09-06','17:45:00',3.01),('9650','2013-09-06','17:50:00',2.84),('9650','2013-09-06','17:55:00',2.72),('9650','2013-09-06','18:00:00',2.56),('9650','2013-09-06','18:05:00',2.42),('9650','2013-09-06','18:10:00',2.3),('9650','2013-09-06','18:15:00',2.2),('9650','2013-09-06','18:20:00',2.05),('9650','2013-09-06','18:25:00',1.92),('9650','2013-09-06','18:30:00',1.74),('9650','2013-09-06','18:35:00',1.6),('9650','2013-09-06','18:40:00',1.48),('9650','2013-09-06','18:45:00',1.33),('9650','2013-09-06','18:50:00',1.12),('9650','2013-09-05','09:05:00',1.07),('9650','2013-09-05','09:10:00',1.19),('9650','2013-09-05','09:15:00',1.31),('9650','2013-09-05','09:20:00',1.43),('9650','2013-09-05','09:25:00',1.55),('9650','2013-09-05','09:30:00',1.67),('9650','2013-09-05','09:35:00',1.81),('9650','2013-09-05','09:40:00',1.94),('9650','2013-09-05','09:45:00',2.06),('9650','2013-09-05','09:50:00',2.18),('9650','2013-09-05','09:55:00',2.3),('9650','2013-09-05','10:00:00',2.42),('9650','2013-09-05','10:05:00',2.54),('9650','2013-09-05','10:10:00',2.66),('9650','2013-09-05','10:15:00',2.77),('9650','2013-09-05','10:20:00',2.89),('9650','2013-09-05','10:25:00',3),('9650','2013-09-05','10:30:00',3.14),('9650','2013-09-05','10:35:00',3.26),('9650','2013-09-05','10:40:00',3.39),('9650','2013-09-05','10:45:00',3.51),('9650','2013-09-05','10:50:00',3.58),('9650','2013-09-05','10:55:00',3.7),('9650','2013-09-05','11:00:00',3.79),('9650','2013-09-05','11:05:00',3.95),('9650','2013-09-05','11:10:00',4.05),('9650','2013-09-05','11:15:00',4.14),('9650','2013-09-05','11:20:00',4.21),('9650','2013-09-05','11:25:00',4.3),('9650','2013-09-05','11:30:00',4.44),('9650','2013-09-05','11:35:00',4.52),('9650','2013-09-05','11:40:00',4.61),('9650','2013-09-05','11:45:00',4.68),('9650','2013-09-05','11:50:00',4.76),('9650','2013-09-05','11:55:00',4.83),('9650','2013-09-05','12:00:00',4.85),('9650','2013-09-05','12:05:00',4.89),('9650','2013-09-05','12:10:00',5.04),('9650','2013-09-05','12:15:00',5.11),('9650','2013-09-05','12:20:00',5.13),('9650','2013-09-05','12:25:00',5.24),('9650','2013-09-05','12:30:00',5.31),('9650','2013-09-05','12:35:00',5.45),('9650','2013-09-05','12:40:00',5.49),('9650','2013-09-05','12:45:00',5.48),('9650','2013-09-05','12:50:00',5.47),('9650','2013-09-05','12:55:00',5.54),('9650','2013-09-05','13:00:00',5.6),('9650','2013-09-05','13:05:00',5.65),('9650','2013-09-05','13:10:00',5.72),('9650','2013-09-05','13:15:00',5.76),('9650','2013-09-05','13:20:00',5.75),('9650','2013-09-05','13:25:00',5.72),('9650','2013-09-05','13:30:00',5.81),('9650','2013-09-05','13:35:00',5.82),('9650','2013-09-05','13:40:00',5.77),('9650','2013-09-05','13:45:00',5.81),('9650','2013-09-05','13:50:00',5.85),('9650','2013-09-05','13:55:00',5.85),('9650','2013-09-05','14:00:00',5.84),('9650','2013-09-05','14:05:00',5.81),('9650','2013-09-05','14:10:00',5.83),('9650','2013-09-05','14:15:00',5.85),('9650','2013-09-05','14:20:00',5.85),('9650','2013-09-05','14:25:00',5.84),('9650','2013-09-05','14:30:00',5.79),('9650','2013-09-05','14:35:00',5.5),('9650','2013-09-05','14:40:00',5.69),('9650','2013-09-05','14:45:00',5.76),('9650','2013-09-05','14:50:00',5.81),('9650','2013-09-05','14:55:00',5.89),('9650','2013-09-05','15:00:00',5.83),('9650','2013-09-05','15:05:00',5.63),('9650','2013-09-05','15:10:00',5.55),('9650','2013-09-05','15:15:00',5.43),('9650','2013-09-05','15:20:00',5.56),('9650','2013-09-05','15:25:00',5.45),('9650','2013-09-05','15:30:00',5.38),('9650','2013-09-05','15:35:00',5.33),('9650','2013-09-05','15:40:00',5.35),('9650','2013-09-05','15:45:00',5.33),('9650','2013-09-05','15:50:00',5.25),('9650','2013-09-05','15:55:00',5.08),('9650','2013-09-05','16:00:00',4.97),('9650','2013-09-05','16:05:00',4.91),('9650','2013-09-05','16:10:00',4.81),('9650','2013-09-05','16:15:00',4.79),('9650','2013-09-05','16:20:00',4.76),('9650','2013-09-05','16:25:00',4.71),('9650','2013-09-05','16:30:00',4.65),('9650','2013-09-05','16:35:00',4.54),('9650','2013-09-05','16:40:00',4.43),('9650','2013-09-05','16:45:00',4.24),('9650','2013-09-05','16:50:00',4.15),('9650','2013-09-05','16:55:00',4.04),('9650','2013-09-05','17:00:00',4.06),('9650','2013-09-05','17:05:00',3.87),('9650','2013-09-05','17:10:00',3.76),('9650','2013-09-05','17:15:00',3.71),('9650','2013-09-05','17:20:00',3.5),('9650','2013-09-05','17:25:00',3.41),('9650','2013-09-05','17:30:00',3.27),('9650','2013-09-05','17:35:00',3.19),('9650','2013-09-05','17:40:00',3.2),('9650','2013-09-05','17:45:00',3.01),('9650','2013-09-05','17:50:00',2.78),('9650','2013-09-05','17:55:00',2.62),('9650','2013-09-05','18:00:00',2.57),('9650','2013-09-05','18:05:00',2.47),('9650','2013-09-05','18:10:00',2.39),('9650','2013-09-05','18:15:00',2.2),('9650','2013-09-05','18:20:00',2.01),('9650','2013-09-05','18:25:00',1.83),('9650','2013-09-05','18:30:00',1.6),('9650','2013-09-05','18:35:00',1.46),('9650','2013-09-05','18:40:00',1.25),('9650','2013-09-04','09:05:00',1.1),('9650','2013-09-04','09:10:00',1.21),('9650','2013-09-04','09:15:00',1.34),('9650','2013-09-04','09:20:00',1.49),('9650','2013-09-04','09:25:00',1.62),('9650','2013-09-04','09:30:00',1.74),('9650','2013-09-04','09:35:00',1.87),('9650','2013-09-04','09:40:00',2),('9650','2013-09-04','09:45:00',2.14),('9650','2013-09-04','09:50:00',2.28),('9650','2013-09-04','09:55:00',2.41),('9650','2013-09-04','10:00:00',2.53),('9650','2013-09-04','10:05:00',2.66),('9650','2013-09-04','10:10:00',2.78),('9650','2013-09-04','10:15:00',2.92),('9650','2013-09-04','10:20:00',3.03),('9650','2013-09-04','10:25:00',3.16),('9650','2013-09-04','10:30:00',3.29),('9650','2013-09-04','10:35:00',3.4),('9650','2013-09-04','10:40:00',3.53),('9650','2013-09-04','10:45:00',3.63),('9650','2013-09-04','10:50:00',3.76),('9650','2013-09-04','10:55:00',3.85),('9650','2013-09-04','11:00:00',3.97),('9650','2013-09-04','11:05:00',4.06),('9650','2013-09-04','11:10:00',4.16),('9650','2013-09-04','11:15:00',4.26),('9650','2013-09-04','11:20:00',4.35),('9650','2013-09-04','11:25:00',4.41),('9650','2013-09-04','11:30:00',4.54),('9650','2013-09-04','11:35:00',4.63),('9650','2013-09-04','11:40:00',4.62),('9650','2013-09-04','11:45:00',4.66),('9650','2013-09-04','11:50:00',4.81),('9650','2013-09-04','11:55:00',4.96),('9650','2013-09-04','12:00:00',5),('9650','2013-09-04','12:05:00',5.06),('9650','2013-09-04','12:10:00',5.19),('9650','2013-09-04','12:15:00',5.25),('9650','2013-09-04','12:20:00',5.26),('9650','2013-09-04','12:25:00',5.33),('9650','2013-09-04','12:30:00',5.42),('9650','2013-09-04','12:35:00',5.47),('9650','2013-09-04','12:40:00',5.55),('9650','2013-09-04','12:45:00',5.61),('9650','2013-09-04','12:50:00',5.66),('9650','2013-09-04','12:55:00',5.71),('9650','2013-09-04','13:00:00',5.74),('9650','2013-09-04','13:05:00',5.77),('9650','2013-09-04','13:10:00',5.83),('9650','2013-09-04','13:15:00',5.86),('9650','2013-09-04','13:20:00',5.89),('9650','2013-09-04','13:25:00',5.94),('9650','2013-09-04','13:30:00',5.99),('9650','2013-09-04','13:35:00',6.03),('9650','2013-09-04','13:40:00',6.03),('9650','2013-09-04','13:45:00',6.02),('9650','2013-09-04','13:50:00',5.94),('9650','2013-09-04','13:55:00',5.97),('9650','2013-09-04','14:00:00',5.95),('9650','2013-09-04','14:05:00',5.99),('9650','2013-09-04','14:10:00',6.04),('9650','2013-09-04','14:15:00',6.02),('9650','2013-09-04','14:20:00',5.99),('9650','2013-09-04','14:25:00',5.93),('9650','2013-09-04','14:30:00',5.95),('9650','2013-09-04','14:35:00',5.92),('9650','2013-09-04','14:40:00',5.86),('9650','2013-09-04','14:45:00',5.92),('9650','2013-09-04','14:50:00',5.91),('9650','2013-09-04','14:55:00',5.95),('9650','2013-09-04','15:00:00',5.95),('9650','2013-09-04','15:05:00',5.85),('9650','2013-09-04','15:10:00',5.8),('9650','2013-09-04','15:15:00',5.78),('9650','2013-09-04','15:20:00',5.77),('9650','2013-09-04','15:25:00',5.67),('9650','2013-09-04','15:30:00',5.6),('9650','2013-09-04','15:35:00',5.57),('9650','2013-09-04','15:40:00',5.49),('9650','2013-09-04','15:45:00',5.43),('9650','2013-09-04','15:50:00',5.39),('9650','2013-09-04','15:55:00',5.34),('9650','2013-09-04','16:00:00',5.2),('9650','2013-09-04','16:05:00',5.18),('9650','2013-09-04','16:10:00',5.05),('9650','2013-09-04','16:15:00',5.1),('9650','2013-09-04','16:20:00',5),('9650','2013-09-04','16:25:00',4.9),('9650','2013-09-04','16:30:00',4.83),('9650','2013-09-04','16:35:00',4.82),('9650','2013-09-04','16:40:00',4.79),('9650','2013-09-04','16:45:00',4.72),('9650','2013-09-04','16:50:00',3.96),('9650','2013-09-04','16:55:00',3.21),('9650','2013-09-04','17:00:00',2.58),('9650','2013-09-04','17:05:00',2.81),('9650','2013-09-04','17:10:00',2.87),('9650','2013-09-04','17:15:00',2.58),('9650','2013-09-04','17:20:00',2.97),('9650','2013-09-04','17:25:00',2.98),('9650','2013-09-04','17:30:00',3),('9650','2013-09-04','17:35:00',3.27),('9650','2013-09-04','17:40:00',3.62),('9650','2013-09-04','17:45:00',3.28),('9650','2013-09-04','17:50:00',3.03),('9650','2013-09-04','17:55:00',2.65),('9650','2013-09-04','18:00:00',2.05),('9650','2013-09-04','18:05:00',1.76),('9650','2013-09-04','18:10:00',1.73),('9650','2013-09-04','18:15:00',1.66),('9650','2013-09-04','18:20:00',2.34),('9650','2013-09-04','18:25:00',1.94),('9650','2013-09-04','18:30:00',1.37),('9650','2013-09-04','18:35:00',1.56),('9650','2013-09-04','18:40:00',1.47),('9650','2013-09-04','18:45:00',1.35),('9650','2013-09-04','18:50:00',1.24),('9650','2013-09-04','18:55:00',1.24),('9650','2013-09-03','09:05:00',1.1),('9650','2013-09-03','09:10:00',1.22),('9650','2013-09-03','09:15:00',1.35),('9650','2013-09-03','09:20:00',1.5),('9650','2013-09-03','09:25:00',1.64),('9650','2013-09-03','09:30:00',1.77),('9650','2013-09-03','09:35:00',1.92),('9650','2013-09-03','09:40:00',2.06),('9650','2013-09-03','09:45:00',2.2),('9650','2013-09-03','09:50:00',2.33),('9650','2013-09-03','09:55:00',2.46),('9650','2013-09-03','10:00:00',2.6),('9650','2013-09-03','10:05:00',2.73),('9650','2013-09-03','10:10:00',2.84),('9650','2013-09-03','10:15:00',2.96),('9650','2013-09-03','10:20:00',3.11),('9650','2013-09-03','10:25:00',3.23),('9650','2013-09-03','10:30:00',3.35),('9650','2013-09-03','10:35:00',3.48),('9650','2013-09-03','10:40:00',3.6),('9650','2013-09-03','10:45:00',3.71),('9650','2013-09-03','10:50:00',3.83),('9650','2013-09-03','10:55:00',3.94),('9650','2013-09-03','11:00:00',4.06),('9650','2013-09-03','11:05:00',4.18),('9650','2013-09-03','11:10:00',4.28),('9650','2013-09-03','11:15:00',4.37),('9650','2013-09-03','11:20:00',4.48),('9650','2013-09-03','11:25:00',4.59),('9650','2013-09-03','11:30:00',4.67),('9650','2013-09-03','11:35:00',4.77),('9650','2013-09-03','11:40:00',4.87),('9650','2013-09-03','11:45:00',4.95),('9650','2013-09-03','11:50:00',5.05),('9650','2013-09-03','11:55:00',5.13),('9650','2013-09-03','12:00:00',5.21),('9650','2013-09-03','12:05:00',5.27),('9650','2013-09-03','12:10:00',5.37),('9650','2013-09-03','12:15:00',5.39),('9650','2013-09-03','12:20:00',5.46),('9650','2013-09-03','12:25:00',5.55),('9650','2013-09-03','12:30:00',5.62),('9650','2013-09-03','12:35:00',5.69),('9650','2013-09-03','12:40:00',5.76),('9650','2013-09-03','12:45:00',5.81),('9650','2013-09-03','12:50:00',5.81),('9650','2013-09-03','12:55:00',5.88),('9650','2013-09-03','13:00:00',5.93),('9650','2013-09-03','13:05:00',5.97),('9650','2013-09-03','13:10:00',6.03),('9650','2013-09-03','13:15:00',6.06),('9650','2013-09-03','13:20:00',6.09),('9650','2013-09-03','13:25:00',6.12),('9650','2013-09-03','13:30:00',6.14),('9650','2013-09-03','13:35:00',6.19),('9650','2013-09-03','13:40:00',6.22),('9650','2013-09-03','13:45:00',6.23),('9650','2013-09-03','13:50:00',6.23),('9650','2013-09-03','13:55:00',6.23),('9650','2013-09-03','14:00:00',6.25),('9650','2013-09-03','14:05:00',6.29),('9650','2013-09-03','14:10:00',6.32),('9650','2013-09-03','14:15:00',6.32),('9650','2013-09-03','14:20:00',6.25),('9650','2013-09-03','14:25:00',6.3),('9650','2013-09-03','14:30:00',6.31),('9650','2013-09-03','14:35:00',6.31),('9650','2013-09-03','14:40:00',6.3),('9650','2013-09-03','14:45:00',6.27),('9650','2013-09-03','14:50:00',6.3),('9650','2013-09-03','14:55:00',6.27),('9650','2013-09-03','15:00:00',6.2),('9650','2013-09-03','15:05:00',6.07),('9650','2013-09-03','15:10:00',6.04),('9650','2013-09-03','15:15:00',5.97),('9650','2013-09-03','15:20:00',5.97),('9650','2013-09-03','15:25:00',5.89),('9650','2013-09-03','15:30:00',5.85),('9650','2013-09-03','15:35:00',5.8),('9650','2013-09-03','15:40:00',5.77),('9650','2013-09-03','15:45:00',5.71),('9650','2013-09-03','15:50:00',5.62),('9650','2013-09-03','15:55:00',5.53),('9650','2013-09-03','16:00:00',5.38),('9650','2013-09-03','16:05:00',5.31),('9650','2013-09-03','16:10:00',5.25),('9650','2013-09-03','16:15:00',5.18),('9650','2013-09-03','16:20:00',5.11),('9650','2013-09-03','16:25:00',5.02),('9650','2013-09-03','16:30:00',4.91),('9650','2013-09-03','16:35:00',4.82),('9650','2013-09-03','16:40:00',4.73),('9650','2013-09-03','16:45:00',4.63),('9650','2013-09-03','16:50:00',4.47),('9650','2013-09-03','16:55:00',4.43),('9650','2013-09-03','17:00:00',4.36),('9650','2013-09-03','17:05:00',4.22),('9650','2013-09-03','17:10:00',4.12),('9650','2013-09-03','17:15:00',4.03),('9650','2013-09-03','17:20:00',3.92),('9650','2013-09-03','17:25:00',3.87),('9650','2013-09-03','17:30:00',3.77),('9650','2013-09-03','17:35:00',3.68),('9650','2013-09-03','17:40:00',3.55),('9650','2013-09-03','17:45:00',3.4),('9650','2013-09-03','17:50:00',3.26),('9650','2013-09-03','17:55:00',3.09),('9650','2013-09-03','18:00:00',2.91),('9650','2013-09-03','18:05:00',2.77),('9650','2013-09-03','18:10:00',2.62),('9650','2013-09-03','18:15:00',2.46),('9650','2013-09-03','18:20:00',2.29),('9650','2013-09-03','18:25:00',2.15),('9650','2013-09-03','18:30:00',2.01),('9650','2013-09-03','18:35:00',1.85),('9650','2013-09-03','18:40:00',1.68),('9650','2013-09-03','18:45:00',1.49),('9650','2013-09-03','18:50:00',1.28),('9650','2013-09-03','18:55:00',1.05),('9650','2013-09-02','08:55:00',1.05),('9650','2013-09-02','09:00:00',1.15),('9650','2013-09-02','09:05:00',1.24),('9650','2013-09-02','09:10:00',1.35),('9650','2013-09-02','09:15:00',1.46),('9650','2013-09-02','09:20:00',1.59),('9650','2013-09-02','09:25:00',1.73),('9650','2013-09-02','09:30:00',1.85),('9650','2013-09-02','09:35:00',1.97),('9650','2013-09-02','09:40:00',2.07),('9650','2013-09-02','09:45:00',2.2),('9650','2013-09-02','09:50:00',2.33),('9650','2013-09-02','09:55:00',2.44),('9650','2013-09-02','10:00:00',2.56),('9650','2013-09-02','10:05:00',2.67),('9650','2013-09-02','10:10:00',2.79),('9650','2013-09-02','10:15:00',2.91),('9650','2013-09-02','10:20:00',3.05),('9650','2013-09-02','10:25:00',3.16),('9650','2013-09-02','10:30:00',3.27),('9650','2013-09-02','10:35:00',3.4),('9650','2013-09-02','10:40:00',3.56),('9650','2013-09-02','10:45:00',3.68),('9650','2013-09-02','10:50:00',3.79),('9650','2013-09-02','10:55:00',3.88),('9650','2013-09-02','11:00:00',3.98),('9650','2013-09-02','11:05:00',4.08),('9650','2013-09-02','11:10:00',4.17),('9650','2013-09-02','11:15:00',4.27),('9650','2013-09-02','11:20:00',4.36),('9650','2013-09-02','11:25:00',4.47),('9650','2013-09-02','11:30:00',4.55),('9650','2013-09-02','11:35:00',4.64),('9650','2013-09-02','11:40:00',4.71),('9650','2013-09-02','11:45:00',4.78),('9650','2013-09-02','11:50:00',4.9),('9650','2013-09-02','11:55:00',4.99),('9650','2013-09-02','12:00:00',5.09),('9650','2013-09-02','12:05:00',5.15),('9650','2013-09-02','12:10:00',5.24),('9650','2013-09-02','12:15:00',5.32),('9650','2013-09-02','12:20:00',5.41),('9650','2013-09-02','12:25:00',5.45),('9650','2013-09-02','12:30:00',5.53),('9650','2013-09-02','12:35:00',5.59),('9650','2013-09-02','12:40:00',5.65),('9650','2013-09-02','12:45:00',5.71),('9650','2013-09-02','12:50:00',5.73),('9650','2013-09-02','12:55:00',5.79),('9650','2013-09-02','13:00:00',5.84),('9650','2013-09-02','13:05:00',5.86),('9650','2013-09-02','13:10:00',5.93),('9650','2013-09-02','13:15:00',5.94),('9650','2013-09-02','13:20:00',5.99),('9650','2013-09-02','13:25:00',6),('9650','2013-09-02','13:30:00',6.03),('9650','2013-09-02','13:35:00',6.06),('9650','2013-09-02','13:40:00',6.08),('9650','2013-09-02','13:45:00',6.1),('9650','2013-09-02','13:50:00',6.14),('9650','2013-09-02','13:55:00',6.16),('9650','2013-09-02','14:00:00',6.09),('9650','2013-09-02','14:05:00',6.05),('9650','2013-09-02','14:10:00',6.04),('9650','2013-09-02','14:15:00',6.11),('9650','2013-09-02','14:20:00',6.12),('9650','2013-09-02','14:25:00',6.12),('9650','2013-09-02','14:30:00',6.16),('9650','2013-09-02','14:35:00',6.17),('9650','2013-09-02','14:40:00',6.18),('9650','2013-09-02','14:45:00',6.14),('9650','2013-09-02','14:50:00',6.15),('9650','2013-09-02','14:55:00',6.13),('9650','2013-09-02','15:00:00',6.09),('9650','2013-09-02','15:05:00',5.94),('9650','2013-09-02','15:10:00',5.89),('9650','2013-09-02','15:15:00',5.88),('9650','2013-09-02','15:20:00',5.86),('9650','2013-09-02','15:25:00',5.79),('9650','2013-09-02','15:30:00',5.76),('9650','2013-09-02','15:35:00',5.68),('9650','2013-09-02','15:40:00',5.64),('9650','2013-09-02','15:45:00',5.52),('9650','2013-09-02','15:50:00',5.53),('9650','2013-09-02','15:55:00',5.4),('9650','2013-09-02','16:00:00',5.36),('9650','2013-09-02','16:05:00',5.32),('9650','2013-09-02','16:10:00',5.25),('9650','2013-09-02','16:15:00',5.13),('9650','2013-09-02','16:20:00',5.08),('9650','2013-09-02','16:25:00',5.03),('9650','2013-09-02','16:30:00',4.92),('9650','2013-09-02','16:35:00',4.81),('9650','2013-09-02','16:40:00',4.67),('9650','2013-09-02','16:45:00',4.62),('9650','2013-09-02','16:50:00',4.47),('9650','2013-09-02','16:55:00',4.45),('9650','2013-09-02','17:00:00',4.31),('9650','2013-09-02','17:05:00',4.19),('9650','2013-09-02','17:10:00',4.1),('9650','2013-09-02','17:15:00',3.99),('9650','2013-09-02','17:20:00',3.95),('9650','2013-09-02','17:25:00',3.88),('9650','2013-09-02','17:30:00',3.76),('9650','2013-09-02','17:35:00',3.7),('9650','2013-09-02','17:40:00',3.59),('9650','2013-09-02','17:45:00',3.49),('9650','2013-09-02','17:50:00',3.37),('9650','2013-09-02','17:55:00',3.15),('9650','2013-09-02','18:00:00',2.74),('9650','2013-09-02','18:05:00',2.54),('9650','2013-09-02','18:10:00',2.44),('9650','2013-09-02','18:15:00',2.4),('9650','2013-09-02','18:20:00',2.29),('9650','2013-09-02','18:25:00',2.15),('9650','2013-09-02','18:30:00',1.97),('9650','2013-09-02','18:35:00',1.82),('9650','2013-09-02','18:40:00',1.69),('9650','2013-09-02','18:45:00',1.5),('9650','2013-09-02','18:50:00',1.34),('9650','2013-09-02','18:55:00',1.11),('9650','2013-09-01','08:55:00',1.04),('9650','2013-09-01','09:00:00',1.12),('9650','2013-09-01','09:05:00',1.18),('9650','2013-09-01','09:10:00',1.23),('9650','2013-09-01','09:15:00',1.25),('9650','2013-09-01','09:20:00',1.52),('9650','2013-09-01','09:25:00',1.76),('9650','2013-09-01','09:30:00',1.88),('9650','2013-09-01','09:35:00',2.02),('9650','2013-09-01','09:40:00',2.15),('9650','2013-09-01','09:45:00',2.27),('9650','2013-09-01','09:50:00',2.4),('9650','2013-09-01','09:55:00',2.52),('9650','2013-09-01','10:00:00',2.64),('9650','2013-09-01','10:05:00',2.76),('9650','2013-09-01','10:10:00',2.88),('9650','2013-09-01','10:15:00',3.01),('9650','2013-09-01','10:20:00',3.14),('9650','2013-09-01','10:25:00',3.26),('9650','2013-09-01','10:30:00',3.38),('9650','2013-09-01','10:35:00',3.49),('9650','2013-09-01','10:40:00',3.6),('9650','2013-09-01','10:45:00',3.7),('9650','2013-09-01','10:50:00',3.82),('9650','2013-09-01','10:55:00',3.93),('9650','2013-09-01','11:00:00',4.04),('9650','2013-09-01','11:05:00',4.14),('9650','2013-09-01','11:10:00',4.26),('9650','2013-09-01','11:15:00',4.35),('9650','2013-09-01','11:20:00',4.45),('9650','2013-09-01','11:25:00',4.54),('9650','2013-09-01','11:30:00',4.62),('9650','2013-09-01','11:35:00',4.72),('9650','2013-09-01','11:40:00',4.8),('9650','2013-09-01','11:45:00',4.88),('9650','2013-09-01','11:50:00',4.98),('9650','2013-09-01','11:55:00',5.02),('9650','2013-09-01','12:00:00',5.08),('9650','2013-09-01','12:05:00',5.19),('9650','2013-09-01','12:10:00',5.27),('9650','2013-09-01','12:15:00',5.37),('9650','2013-09-01','12:20:00',5.41),('9650','2013-09-01','12:25:00',5.51),('9650','2013-09-01','12:30:00',5.49),('9650','2013-09-01','12:35:00',5.54),('9650','2013-09-01','12:40:00',5.59),('9650','2013-09-01','12:45:00',5.63),('9650','2013-09-01','12:50:00',5.73),('9650','2013-09-01','12:55:00',5.79),('9650','2013-09-01','13:00:00',5.85),('9650','2013-09-01','13:05:00',5.89),('9650','2013-09-01','13:10:00',5.93),('9650','2013-09-01','13:15:00',5.94),('9650','2013-09-01','13:20:00',5.9),('9650','2013-09-01','13:25:00',5.92),('9650','2013-09-01','13:30:00',5.91),('9650','2013-09-01','13:35:00',5.87),('9650','2013-09-01','13:40:00',5.93),('9650','2013-09-01','13:45:00',2.43),('9650','2013-09-01','13:50:00',1.1),('9650','2013-09-01','13:55:00',1.11),('9650','2013-09-01','14:00:00',4.69),('9650','2013-09-01','14:05:00',6.57),('9650','2013-09-01','14:10:00',6.41),('9650','2013-09-01','14:15:00',6.32),('9650','2013-09-01','14:20:00',6.3),('9650','2013-09-01','14:25:00',6.28),('9650','2013-09-01','14:30:00',6.17),('9650','2013-09-01','14:35:00',6.13),('9650','2013-09-01','14:40:00',6.16),('9650','2013-09-01','14:45:00',6.17),('9650','2013-09-01','14:50:00',5.27),('9650','2013-09-01','14:55:00',3.77),('9650','2013-09-01','15:00:00',3.79),('9650','2013-09-01','15:05:00',6.19),('9650','2013-09-01','15:10:00',6.05),('9650','2013-09-01','15:15:00',5.15),('9650','2013-09-01','15:20:00',1.34),('9650','2013-09-01','15:25:00',4.22),('9650','2013-09-01','15:30:00',4.85),('9650','2013-09-01','15:35:00',4.71),('9650','2013-09-01','15:40:00',4.89),('9650','2013-09-01','15:45:00',5.18),('9650','2013-09-01','15:50:00',5.6),('9650','2013-09-01','15:55:00',5.47),('9650','2013-09-01','16:00:00',5.42),('9650','2013-09-01','16:05:00',5.36),('9650','2013-09-01','16:10:00',5.32),('9650','2013-09-01','16:15:00',5.33),('9650','2013-09-01','16:20:00',5.25),('9650','2013-09-01','16:25:00',5.07),('9650','2013-09-01','16:30:00',5.01),('9650','2013-09-01','16:35:00',4.92),('9650','2013-09-01','16:40:00',4.71),('9650','2013-09-01','16:45:00',4.56),('9650','2013-09-01','16:50:00',4.39),('9650','2013-09-01','16:55:00',4.21),('9650','2013-09-01','17:00:00',4.14),('9650','2013-09-01','17:05:00',4),('9650','2013-09-01','17:10:00',3.96),('9650','2013-09-01','17:15:00',3.87),('9650','2013-09-01','17:20:00',3.79),('9650','2013-09-01','17:25:00',3.68),('9650','2013-09-01','17:30:00',3.57),('9650','2013-09-01','17:35:00',3.45),('9650','2013-09-01','17:40:00',3.41),('9650','2013-09-01','17:45:00',3.3),('9650','2013-09-01','17:50:00',3.15),('9650','2013-09-01','17:55:00',3.03),('9650','2013-09-01','18:00:00',2.93),('9650','2013-09-01','18:05:00',2.78),('9650','2013-09-01','18:10:00',2.6),('9650','2013-09-01','18:15:00',2.46),('9650','2013-09-01','18:20:00',2.31),('9650','2013-09-01','18:25:00',2.16),('9650','2013-09-01','18:30:00',1.99),('9650','2013-09-01','18:35:00',1.81),('9650','2013-09-01','18:40:00',1.6),('9650','2013-09-01','18:45:00',1.43),('9650','2013-09-01','18:50:00',1.23),('9650','2013-09-01','18:55:00',1.02),('9650','2013-08-31','08:55:00',1.06),('9650','2013-08-31','09:00:00',1.18),('9650','2013-08-31','09:05:00',1.29),('9650','2013-08-31','09:10:00',1.41),('9650','2013-08-31','09:15:00',1.52),('9650','2013-08-31','09:20:00',1.65),('9650','2013-08-31','09:25:00',1.79),('9650','2013-08-31','09:30:00',1.93),('9650','2013-08-31','09:35:00',2.06),('9650','2013-08-31','09:40:00',2.19),('9650','2013-08-31','09:45:00',2.31),('9650','2013-08-31','09:50:00',2.44),('9650','2013-08-31','09:55:00',2.55),('9650','2013-08-31','10:00:00',2.66),('9650','2013-08-31','10:05:00',2.77),('9650','2013-08-31','10:10:00',2.9),('9650','2013-08-31','10:15:00',3.01),('9650','2013-08-31','10:20:00',3.16),('9650','2013-08-31','10:25:00',3.29),('9650','2013-08-31','10:30:00',3.41),('9650','2013-08-31','10:35:00',3.46),('9650','2013-08-31','10:40:00',3.6),('9650','2013-08-31','10:45:00',3.72),('9650','2013-08-31','10:50:00',3.82),('9650','2013-08-31','10:55:00',3.93),('9650','2013-08-31','11:00:00',4.03),('9650','2013-08-31','11:05:00',4.15),('9650','2013-08-31','11:10:00',4.22),('9650','2013-08-31','11:15:00',4.31),('9650','2013-08-31','11:20:00',4.4),('9650','2013-08-31','11:25:00',4.49),('9650','2013-08-31','11:30:00',4.55),('9650','2013-08-31','11:35:00',4.66),('9650','2013-08-31','11:40:00',4.78),('9650','2013-08-31','11:45:00',4.89),('9650','2013-08-31','11:50:00',4.94),('9650','2013-08-31','11:55:00',5.03),('9650','2013-08-31','12:00:00',5.09),('9650','2013-08-31','12:05:00',5.03),('9650','2013-08-31','12:10:00',5.2),('9650','2013-08-31','12:15:00',5.3),('9650','2013-08-31','12:20:00',5.41),('9650','2013-08-31','12:25:00',5.32),('9650','2013-08-31','12:30:00',5.52),('9650','2013-08-31','12:35:00',5.57),('9650','2013-08-31','12:40:00',5.63),('9650','2013-08-31','12:45:00',5.61),('9650','2013-08-31','12:50:00',5.69),('9650','2013-08-31','12:55:00',5.74),('9650','2013-08-31','13:00:00',5.88),('9650','2013-08-31','13:05:00',5.84),('9650','2013-08-31','13:10:00',5.86),('9650','2013-08-31','13:15:00',5.49),('9650','2013-08-31','13:20:00',6.07),('9650','2013-08-31','13:25:00',6.06),('9650','2013-08-31','13:30:00',6.15),('9650','2013-08-31','13:35:00',6.12),('9650','2013-08-31','13:40:00',6.18),('9650','2013-08-31','13:45:00',5.91),('9650','2013-08-31','13:50:00',5.2),('9650','2013-08-31','13:55:00',5.42),('9650','2013-08-31','14:00:00',4.81),('9650','2013-08-31','14:05:00',4.79),('9650','2013-08-31','14:10:00',5.61),('9650','2013-08-31','14:15:00',5.72),('9650','2013-08-31','14:20:00',5.17),('9650','2013-08-31','14:25:00',5.21),('9650','2013-08-31','14:30:00',5.47),('9650','2013-08-31','14:35:00',5.39),('9650','2013-08-31','14:40:00',5.5),('9650','2013-08-31','14:45:00',5.65),('9650','2013-08-31','14:50:00',5.68),('9650','2013-08-31','14:55:00',5.5),('9650','2013-08-31','15:00:00',5.56),('9650','2013-08-31','15:05:00',5.48),('9650','2013-08-31','15:10:00',5.47),('9650','2013-08-31','15:15:00',5.41),('9650','2013-08-31','15:20:00',5.13),('9650','2013-08-31','15:25:00',4.55),('9650','2013-08-31','15:30:00',3.77),('9650','2013-08-31','15:35:00',4.26),('9650','2013-08-31','15:40:00',5),('9650','2013-08-31','15:45:00',4.59),('9650','2013-08-31','15:50:00',3.36),('9650','2013-08-31','15:55:00',3.89),('9650','2013-08-31','16:00:00',4.84),('9650','2013-08-31','16:05:00',5.1),('9650','2013-08-31','16:10:00',5.14),('9650','2013-08-31','16:15:00',5.01),('9650','2013-08-31','16:20:00',4.64),('9650','2013-08-31','16:25:00',4.81),('9650','2013-08-31','16:30:00',5.13),('9650','2013-08-31','16:35:00',4.94),('9650','2013-08-31','16:40:00',4.87),('9650','2013-08-31','16:45:00',4.44),('9650','2013-08-31','16:50:00',4.33),('9650','2013-08-31','16:55:00',3.83),('9650','2013-08-31','17:00:00',3.14),('9650','2013-08-31','17:05:00',3.35),('9650','2013-08-31','17:10:00',2.71),('9650','2013-08-31','17:15:00',2.82),('9650','2013-08-31','17:20:00',3.16),('9650','2013-08-31','17:25:00',3.04),('9650','2013-08-31','17:30:00',2.69),('9650','2013-08-31','17:35:00',2.77),('9650','2013-08-31','17:40:00',2.99),('9650','2013-08-31','17:45:00',2.44),('9650','2013-08-31','17:50:00',2.13),('9650','2013-08-31','17:55:00',2.09),('9650','2013-08-31','18:00:00',2.24),('9650','2013-08-31','18:05:00',2.33),('9650','2013-08-31','18:10:00',2.57),('9650','2013-08-31','18:15:00',2.47),('9650','2013-08-31','18:20:00',2.19),('9650','2013-08-31','18:25:00',2.28),('9650','2013-08-31','18:30:00',2.22),('9650','2013-08-31','18:35:00',1.87),('9650','2013-08-31','18:40:00',2.19),('9650','2013-08-31','18:45:00',2.02),('9650','2013-08-31','18:50:00',1.79),('9650','2013-08-31','18:55:00',1.56),('9650','2013-08-31','19:00:00',1.29),('9650','2013-08-30','08:50:00',1.14),('9650','2013-08-30','08:55:00',1.38),('9650','2013-08-30','09:00:00',1.49),('9650','2013-08-30','09:05:00',1.35),('9650','2013-08-30','09:10:00',1.11),('9650','2013-08-30','09:15:00',1.39),('9650','2013-08-30','09:20:00',1.6),('9650','2013-08-30','09:25:00',1.92),('9650','2013-08-30','09:30:00',2.09),('9650','2013-08-30','09:35:00',2.27),('9650','2013-08-30','09:40:00',2.39),('9650','2013-08-30','09:45:00',2.31),('9650','2013-08-30','09:50:00',2.38),('9650','2013-08-30','09:55:00',2.6),('9650','2013-08-30','10:00:00',2.83),('9650','2013-08-30','10:05:00',2.88),('9650','2013-08-30','10:10:00',3.06),('9650','2013-08-30','10:15:00',3.13),('9650','2013-08-30','10:20:00',3.24),('9650','2013-08-30','10:25:00',3.34),('9650','2013-08-30','10:30:00',3.48),('9650','2013-08-30','10:35:00',3.64),('9650','2013-08-30','10:40:00',3.69),('9650','2013-08-30','10:45:00',3.83),('9650','2013-08-30','10:50:00',3.99),('9650','2013-08-30','10:55:00',4.09),('9650','2013-08-30','11:00:00',4.24),('9650','2013-08-30','11:05:00',4.35),('9650','2013-08-30','11:10:00',4.44),('9650','2013-08-30','11:15:00',4.55),('9650','2013-08-30','11:20:00',4.66),('9650','2013-08-30','11:25:00',4.77),('9650','2013-08-30','11:30:00',4.86),('9650','2013-08-30','11:35:00',4.96),('9650','2013-08-30','11:40:00',5.07),('9650','2013-08-30','11:45:00',5.15),('9650','2013-08-30','11:50:00',5.24),('9650','2013-08-30','11:55:00',5.32),('9650','2013-08-30','12:00:00',5.01),('9650','2013-08-30','12:05:00',3.94),('9650','2013-08-30','12:10:00',4.69),('9650','2013-08-30','12:15:00',5.18),('9650','2013-08-30','12:20:00',5.57),('9650','2013-08-30','12:25:00',5.6),('9650','2013-08-30','12:30:00',5.65),('9650','2013-08-30','12:35:00',5.73),('9650','2013-08-30','12:40:00',5.74),('9650','2013-08-30','12:45:00',5.81),('9650','2013-08-30','12:50:00',5.84),('9650','2013-08-30','12:55:00',5.95),('9650','2013-08-30','13:00:00',6),('9650','2013-08-30','13:05:00',6.05),('9650','2013-08-30','13:10:00',6.03),('9650','2013-08-30','13:15:00',6.13),('9650','2013-08-30','13:20:00',6.14),('9650','2013-08-30','13:25:00',6.16),('9650','2013-08-30','13:30:00',6.22),('9650','2013-08-30','13:35:00',6.16),('9650','2013-08-30','13:40:00',6.22),('9650','2013-08-30','13:45:00',6.17),('9650','2013-08-30','13:50:00',6.29),('9650','2013-08-30','13:55:00',6.28),('9650','2013-08-30','14:00:00',6.31),('9650','2013-08-30','14:05:00',6.35),('9650','2013-08-30','14:10:00',6.31),('9650','2013-08-30','14:15:00',6.32),('9650','2013-08-30','14:20:00',6.27),('9650','2013-08-30','14:25:00',6.23),('9650','2013-08-30','14:30:00',6.24),('9650','2013-08-30','14:35:00',5.98),('9650','2013-08-30','14:40:00',6.05),('9650','2013-08-30','14:45:00',6.12),('9650','2013-08-30','14:50:00',6.16),('9650','2013-08-30','14:55:00',6.02),('9650','2013-08-30','15:00:00',6.02),('9650','2013-08-30','15:05:00',6.01),('9650','2013-08-30','15:10:00',5.97),('9650','2013-08-30','15:15:00',5.98),('9650','2013-08-30','15:20:00',5.83),('9650','2013-08-30','15:25:00',5.84),('9650','2013-08-30','15:30:00',5.84),('9650','2013-08-30','15:35:00',5.71),('9650','2013-08-30','15:40:00',5.71),('9650','2013-08-30','15:45:00',5.64),('9650','2013-08-30','15:50:00',5.55),('9650','2013-08-30','15:55:00',5.45),('9650','2013-08-30','16:00:00',5.41),('9650','2013-08-30','16:05:00',5.34),('9650','2013-08-30','16:10:00',5.33),('9650','2013-08-30','16:15:00',5.27),('9650','2013-08-30','16:20:00',5.27),('9650','2013-08-30','16:25:00',5.12),('9650','2013-08-30','16:30:00',4.99),('9650','2013-08-30','16:35:00',5.01),('9650','2013-08-30','16:40:00',4.92),('9650','2013-08-30','16:45:00',4.66),('9650','2013-08-30','16:50:00',4.53),('9650','2013-08-30','16:55:00',4.36),('9650','2013-08-30','17:00:00',4.29),('9650','2013-08-30','17:05:00',4.31),('9650','2013-08-30','17:10:00',4.22),('9650','2013-08-30','17:15:00',4.02),('9650','2013-08-30','17:20:00',3.95),('9650','2013-08-30','17:25:00',3.85),('9650','2013-08-30','17:30:00',3.75),('9650','2013-08-30','17:35:00',3.53),('9650','2013-08-30','17:40:00',3.54),('9650','2013-08-30','17:45:00',3.3),('9650','2013-08-30','17:50:00',3.15),('9650','2013-08-30','17:55:00',2.78),('9650','2013-08-30','18:00:00',1.59),('9650','2013-08-30','18:05:00',2.05),('9650','2013-08-30','18:10:00',1.85),('9650','2013-08-30','18:15:00',1.73),('9650','2013-08-30','18:20:00',1.83),('9650','2013-08-30','18:25:00',1.65),('9650','2013-08-29','08:15:00',1.02),('9650','2013-08-29','08:20:00',1.12),('9650','2013-08-29','08:25:00',1.17),('9650','2013-08-29','08:30:00',1.21),('9650','2013-08-29','08:35:00',1.42),('9650','2013-08-29','08:40:00',1.65),('9650','2013-08-29','08:45:00',1.59),('9650','2013-08-29','08:50:00',1.56),('9650','2013-08-29','08:55:00',1.66),('9650','2013-08-29','09:00:00',1.89),('9650','2013-08-29','09:05:00',2.07),('9650','2013-08-29','09:10:00',1.97),('9650','2013-08-29','09:15:00',1.83),('9650','2013-08-29','09:20:00',1.66),('9650','2013-08-29','09:25:00',1.75),('9650','2013-08-29','09:30:00',2.1),('9650','2013-08-29','09:35:00',2.3),('9650','2013-08-29','09:40:00',2.22),('9650','2013-08-29','09:45:00',2.27),('9650','2013-08-29','09:50:00',2.39),('9650','2013-08-29','09:55:00',2.57),('9650','2013-08-29','10:00:00',2.66),('9650','2013-08-29','10:05:00',2.71),('9650','2013-08-29','10:10:00',2.75),('9650','2013-08-29','10:15:00',2.92),('9650','2013-08-29','10:20:00',3),('9650','2013-08-29','10:25:00',2.86),('9650','2013-08-29','10:30:00',3.14),('9650','2013-08-29','10:35:00',3.09),('9650','2013-08-29','10:40:00',2.99),('9650','2013-08-29','10:45:00',2.97),('9650','2013-08-29','10:50:00',3.16),('9650','2013-08-29','10:55:00',3.03),('9650','2013-08-29','11:00:00',3.15),('9650','2013-08-29','11:05:00',3.27),('9650','2013-08-29','11:10:00',3.43),('9650','2013-08-29','11:15:00',3.49),('9650','2013-08-29','11:20:00',3.54),('9650','2013-08-29','11:25:00',3.55),('9650','2013-08-29','11:30:00',3.7),('9650','2013-08-29','11:35:00',3.53),('9650','2013-08-29','11:40:00',3.88),('9650','2013-08-29','11:45:00',3.85),('9650','2013-08-29','11:50:00',4.4),('9650','2013-08-29','11:55:00',3.94),('9650','2013-08-29','12:00:00',3.64),('9650','2013-08-29','12:05:00',3.25),('9650','2013-08-29','12:10:00',3.53),('9650','2013-08-29','12:15:00',3.84),('9650','2013-08-29','12:20:00',4.05),('9650','2013-08-29','12:25:00',4.55),('9650','2013-08-29','12:30:00',4.98),('9650','2013-08-29','12:35:00',4.77),('9650','2013-08-29','12:40:00',4.67),('9650','2013-08-29','12:45:00',4.88),('9650','2013-08-29','12:50:00',4.83),('9650','2013-08-29','12:55:00',4.58),('9650','2013-08-29','13:00:00',4.55),('9650','2013-08-29','13:05:00',4.62),('9650','2013-08-29','13:10:00',4.67),('9650','2013-08-29','13:15:00',4.56),('9650','2013-08-29','13:20:00',5.2),('9650','2013-08-29','13:25:00',6.01),('9650','2013-08-29','13:30:00',6.36),('9650','2013-08-29','13:35:00',5.87),('9650','2013-08-29','13:40:00',6.21),('9650','2013-08-29','13:45:00',5.6),('9650','2013-08-29','13:50:00',5.64),('9650','2013-08-29','13:55:00',6.2),('9650','2013-08-29','14:00:00',6.49),('9650','2013-08-29','14:05:00',6.22),('9650','2013-08-29','14:10:00',6.31),('9650','2013-08-29','14:15:00',6.21),('9650','2013-08-29','14:20:00',6.4),('9650','2013-08-29','14:25:00',6.38),('9650','2013-08-29','14:30:00',6.41),('9650','2013-08-29','14:35:00',6.55),('9650','2013-08-29','14:40:00',6.28),('9650','2013-08-29','14:45:00',5.03),('9650','2013-08-29','14:50:00',4.36),('9650','2013-08-29','14:55:00',4.98),('9650','2013-08-29','15:00:00',4.28),('9650','2013-08-29','15:05:00',3.93),('9650','2013-08-29','15:10:00',4.03),('9650','2013-08-29','15:15:00',5.06),('9650','2013-08-29','15:20:00',4.31),('9650','2013-08-29','15:25:00',3.89),('9650','2013-08-29','15:30:00',3.72),('9650','2013-08-29','15:35:00',3.05),('9650','2013-08-29','15:40:00',3.36),('9650','2013-08-29','15:45:00',3.95),('9650','2013-08-29','15:50:00',4.25),('9650','2013-08-29','15:55:00',4.19),('9650','2013-08-29','16:00:00',4),('9650','2013-08-29','16:05:00',3.51),('9650','2013-08-29','16:10:00',2.89),('9650','2013-08-29','16:15:00',2.66),('9650','2013-08-29','16:20:00',3.08),('9650','2013-08-29','16:25:00',3.04),('9650','2013-08-29','16:30:00',3.44),('9650','2013-08-29','16:35:00',2.48),('9650','2013-08-29','16:40:00',4.37),('9650','2013-08-29','16:45:00',4.96),('9650','2013-08-29','16:50:00',4.73),('9650','2013-08-29','16:55:00',3.17),('9650','2013-08-29','17:00:00',3.69),('9650','2013-08-29','17:05:00',2.64),('9650','2013-08-29','17:10:00',3.13),('9650','2013-08-29','17:15:00',2.96),('9650','2013-08-29','17:20:00',2.53),('9650','2013-08-29','17:25:00',2.69),('9650','2013-08-29','17:30:00',2.89),('9650','2013-08-29','17:35:00',3.04),('9650','2013-08-29','17:40:00',2.31),('9650','2013-08-29','17:45:00',3.17),('9650','2013-08-29','17:50:00',2.37),('9650','2013-08-29','17:55:00',2.94),('9650','2013-08-29','18:00:00',2.76),('9650','2013-08-29','18:05:00',1.37),('9650','2014-04-10','08:40:00',1.17),('9650','2014-04-10','08:45:00',1.2),('9650','2014-04-10','08:50:00',1.21),('9650','2014-04-10','08:55:00',1.25),('9650','2014-04-10','09:00:00',1.3),('9650','2014-04-10','09:05:00',1.38),('9650','2014-04-10','09:10:00',1.5),('9650','2014-04-10','09:15:00',1.62),('9650','2014-04-10','09:20:00',1.74),('9650','2014-04-10','09:25:00',1.87),('9650','2014-04-10','09:30:00',2.02),('9650','2014-04-10','09:35:00',2.16),('9650','2014-04-10','09:40:00',2.29),('9650','2014-04-10','09:45:00',2.41),('9650','2014-04-10','09:50:00',2.57),('9650','2014-04-10','09:55:00',2.69),('9650','2014-04-10','10:00:00',2.84),('9650','2014-04-10','10:05:00',3),('9650','2014-04-10','10:10:00',3.12),('9650','2014-04-10','10:15:00',3.25),('9650','2014-04-10','10:20:00',3.37),('9650','2014-04-10','10:25:00',3.51),('9650','2014-04-10','10:30:00',3.63),('9650','2014-04-10','10:35:00',3.76),('9650','2014-04-10','10:40:00',3.85),('9650','2014-04-10','10:45:00',4.01),('9650','2014-04-10','10:50:00',4.14),('9650','2014-04-10','10:55:00',4.25),('9650','2014-04-10','11:00:00',4.4),('9650','2014-04-10','11:05:00',4.5),('9650','2014-04-10','11:10:00',4.55),('9650','2014-04-10','11:15:00',4.65),('9650','2014-04-10','11:20:00',4.86),('9650','2014-04-10','11:25:00',5),('9650','2014-04-10','11:30:00',5.06),('9650','2014-04-10','11:35:00',5.16),('9650','2014-04-10','11:40:00',5.17),('9650','2014-04-10','11:45:00',5.38),('9650','2014-04-10','11:50:00',5.49),('9650','2014-04-10','11:55:00',5.79),('9650','2014-04-10','12:00:00',5.93),('9650','2014-04-10','12:05:00',5.81),('9650','2014-04-10','12:10:00',6.19),('9650','2014-04-10','12:15:00',5.15),('9650','2014-04-10','12:20:00',6.12),('9650','2014-04-10','12:25:00',6.23),('9650','2014-04-10','12:30:00',6.43),('9650','2014-04-10','12:35:00',6.62),('9650','2014-04-10','12:40:00',6.7),('9650','2014-04-10','12:45:00',5.64),('9650','2014-04-10','12:50:00',7.01),('9650','2014-04-10','12:55:00',6.83),('9650','2014-04-10','13:00:00',5.8),('9650','2014-04-10','13:05:00',4.82),('9650','2014-04-10','13:10:00',5.22),('9650','2014-04-10','13:15:00',5.69),('9650','2014-04-10','13:20:00',4.65),('9650','2014-04-10','13:25:00',5.55),('9650','2014-04-10','13:30:00',3.77),('9650','2014-04-10','13:35:00',5.28),('9650','2014-04-10','13:40:00',3.44),('9650','2014-04-10','13:45:00',7.17),('9650','2014-04-10','13:50:00',5.32),('9650','2014-04-10','13:55:00',6.74),('9650','2014-04-10','14:00:00',4.46),('9650','2014-04-10','14:05:00',6.94),('9650','2014-04-10','14:10:00',4.58),('9650','2014-04-10','14:15:00',5.43),('9650','2014-04-10','14:20:00',6.49),('9650','2014-04-10','14:25:00',4.23),('9650','2014-04-10','14:30:00',7.59),('9650','2014-04-10','14:35:00',7.75),('9650','2014-04-10','14:40:00',4.31),('9650','2014-04-10','14:45:00',6.13),('9650','2014-04-10','14:50:00',7.41),('9650','2014-04-10','14:55:00',4.62),('9650','2014-04-10','15:00:00',7.25),('9650','2014-04-10','15:05:00',7.38),('9650','2014-04-10','15:10:00',6.12),('9650','2014-04-10','15:15:00',6.73),('9650','2014-04-10','15:20:00',5.76),('9650','2014-04-10','15:25:00',6.89),('9650','2014-04-10','15:30:00',6.73),('9650','2014-04-10','15:35:00',5.21),('9650','2014-04-10','15:40:00',6.47),('9650','2014-04-10','15:45:00',6.27),('9650','2014-04-10','15:50:00',6.33),('9650','2014-04-10','15:55:00',6.3),('9650','2014-04-10','16:00:00',6.08),('9650','2014-04-10','16:05:00',5.94),('9650','2014-04-10','16:10:00',4.77),('9650','2014-04-10','16:15:00',5.24),('9650','2014-04-10','16:20:00',5.62),('9650','2014-04-10','16:25:00',5.63),('9650','2014-04-10','16:30:00',5.61),('9650','2014-04-10','16:35:00',4.96),('9650','2014-04-10','16:40:00',5.3),('9650','2014-04-10','16:45:00',5.35),('9650','2014-04-10','16:50:00',4.1),('9650','2014-04-10','16:55:00',3.88),('9650','2014-04-10','17:00:00',5.08),('9650','2014-04-10','17:05:00',4.63),('9650','2014-04-10','17:10:00',4.25),('9650','2014-04-10','17:15:00',4.25),('9650','2014-04-10','17:20:00',4.44),('9650','2014-04-10','17:25:00',4.36),('9650','2014-04-10','17:30:00',4.48),('9650','2014-04-10','17:35:00',4.36),('9650','2014-04-10','17:40:00',4.09),('9650','2014-04-10','17:45:00',3.82),('9650','2014-04-10','17:50:00',3.63),('9650','2014-04-10','17:55:00',3.5),('9650','2014-04-10','18:00:00',3.28),('9650','2014-04-10','18:05:00',3.17),('9650','2014-04-10','18:10:00',3.01),('9650','2014-04-10','18:15:00',2.92),('9650','2014-04-10','18:20:00',2.8),('9650','2014-04-10','18:25:00',2.61),('9650','2014-04-10','18:30:00',2.76),('9650','2014-04-10','18:35:00',2.51),('9650','2014-04-10','18:40:00',2.18),('9650','2014-04-10','18:45:00',1.94),('9650','2014-04-10','18:50:00',1.83),('9650','2014-04-10','18:55:00',1.65),('9650','2014-04-10','19:00:00',1.36),('9650','2013-08-28','08:30:00',1.27),('9650','2013-08-28','08:35:00',1.58),('9650','2013-08-28','08:40:00',1.61),('9650','2013-08-28','08:45:00',1.6),('9650','2013-08-28','08:50:00',1.8),('9650','2013-08-28','08:55:00',2.09),('9650','2013-08-28','09:00:00',2.15),('9650','2013-08-28','09:05:00',2.16),('9650','2013-08-28','09:10:00',2.17),('9650','2013-08-28','09:15:00',2.26),('9650','2013-08-28','09:20:00',2.28),('9650','2013-08-28','09:25:00',2.23),('9650','2013-08-28','09:30:00',2.31),('9650','2013-08-28','09:35:00',2.52),('9650','2013-08-28','09:40:00',2.59),('9650','2013-08-28','09:45:00',2.42),('9650','2013-08-28','09:50:00',2.4),('9650','2013-08-28','09:55:00',2.47),('9650','2013-08-28','10:00:00',2.56),('9650','2013-08-28','10:05:00',2.52),('9650','2013-08-28','10:10:00',2.5),('9650','2013-08-28','10:15:00',2.52),('9650','2013-08-28','10:20:00',2.57),('9650','2013-08-28','10:25:00',2.6),('9650','2013-08-28','10:30:00',2.65),('9650','2013-08-28','10:35:00',2.52),('9650','2013-08-28','10:40:00',2.33),('9650','2013-08-28','10:45:00',2.22),('9650','2013-08-28','10:50:00',2.27),('9650','2013-08-28','10:55:00',2.55),('9650','2013-08-28','11:00:00',2.67),('9650','2013-08-28','11:05:00',2.7),('9650','2013-08-28','11:10:00',3.64),('9650','2013-08-28','11:15:00',4.02),('9650','2013-08-28','11:20:00',3.82),('9650','2013-08-28','11:25:00',2.95),('9650','2013-08-28','11:30:00',2.56),('9650','2013-08-28','11:35:00',2.43),('9650','2013-08-28','11:40:00',2.8),('9650','2013-08-28','11:45:00',3.19),('9650','2013-08-28','11:50:00',3.28),('9650','2013-08-28','11:55:00',3.14),('9650','2013-08-28','12:00:00',3.03),('9650','2013-08-28','12:05:00',3.32),('9650','2013-08-28','12:10:00',3.84),('9650','2013-08-28','12:15:00',4.46),('9650','2013-08-28','12:20:00',4.07),('9650','2013-08-28','12:25:00',4.21),('9650','2013-08-28','12:30:00',4.2),('9650','2013-08-28','12:35:00',4.89),('9650','2013-08-28','12:40:00',6.86),('9650','2013-08-28','12:45:00',6.79),('9650','2013-08-28','12:50:00',4.51),('9650','2013-08-28','12:55:00',6.07),('9650','2013-08-28','13:00:00',4.52),('9650','2013-08-28','13:05:00',4.39),('9650','2013-08-28','13:10:00',4.26),('9650','2013-08-28','13:15:00',4.11),('9650','2013-08-28','13:20:00',3.96),('9650','2013-08-28','13:25:00',3.48),('9650','2013-08-28','13:30:00',3.24),('9650','2013-08-28','13:35:00',3.1),('9650','2013-08-28','13:40:00',2.99),('9650','2013-08-28','13:45:00',2.82),('9650','2013-08-28','13:50:00',2.77),('9650','2013-08-28','13:55:00',3.15),('9650','2013-08-28','14:00:00',3.94),('9650','2013-08-28','14:05:00',2.89),('9650','2013-08-28','14:10:00',2.62),('9650','2013-08-28','14:15:00',2.16),('9650','2013-08-28','14:20:00',1.76),('9650','2013-08-28','14:25:00',1.61),('9650','2013-08-28','14:30:00',1.59),('9650','2013-08-28','14:35:00',1.69),('9650','2013-08-28','14:40:00',1.79),('9650','2013-08-28','14:45:00',1.99),('9650','2013-08-28','14:50:00',2.29),('9650','2013-08-28','14:55:00',2.58),('9650','2013-08-28','15:00:00',2.78),('9650','2013-08-28','15:05:00',3.06),('9650','2013-08-28','15:10:00',2.43),('9650','2013-08-28','15:15:00',2.16),('9650','2013-08-28','15:20:00',2.44),('9650','2013-08-28','15:25:00',2.83),('9650','2013-08-28','15:30:00',4.53),('9650','2013-08-28','15:35:00',4.25),('9650','2013-08-28','15:40:00',4.07),('9650','2013-08-28','15:45:00',4.43),('9650','2013-08-28','15:50:00',5.51),('9650','2013-08-28','15:55:00',5.92),('9650','2013-08-28','16:00:00',5.49),('9650','2013-08-28','16:05:00',6.28),('9650','2013-08-28','16:10:00',6.02),('9650','2013-08-28','16:15:00',5.67),('9650','2013-08-28','16:20:00',5.54),('9650','2013-08-28','16:25:00',5.38),('9650','2013-08-28','16:30:00',5.29),('9650','2013-08-28','16:35:00',5.26),('9650','2013-08-28','16:40:00',5.17),('9650','2013-08-28','16:45:00',5.05),('9650','2013-08-28','16:50:00',4.92),('9650','2013-08-28','16:55:00',4.81),('9650','2013-08-28','17:00:00',4.7),('9650','2013-08-28','17:05:00',4.59),('9650','2013-08-28','17:10:00',4.49),('9650','2013-08-28','17:15:00',4.36),('9650','2013-08-28','17:20:00',4.27),('9650','2013-08-28','17:25:00',4.1),('9650','2013-08-28','17:30:00',4.08),('9650','2013-08-28','17:35:00',3.95),('9650','2013-08-28','17:40:00',3.81),('9650','2013-08-28','17:45:00',3.65),('9650','2013-08-28','17:50:00',3.53),('9650','2013-08-28','17:55:00',3.42),('9650','2013-08-28','18:00:00',3.22),('9650','2013-08-28','18:05:00',3.1),('9650','2013-08-28','18:10:00',2.97),('9650','2013-08-28','18:15:00',2.87),('9650','2013-08-28','18:20:00',2.75),('9650','2013-08-28','18:25:00',2.61),('9650','2013-08-28','18:30:00',2.43),('9650','2013-08-28','18:35:00',2.26),('9650','2013-08-28','18:40:00',2.07),('9650','2013-08-28','18:45:00',1.89),('9650','2013-08-28','18:50:00',1.71),('9650','2013-08-28','18:55:00',1.49),('9650','2013-08-28','19:00:00',1.29),('9650','2013-08-28','19:05:00',1.07),('9650','2013-08-27','08:40:00',1.21),('9650','2013-08-27','08:45:00',1.53),('9650','2013-08-27','08:50:00',1.38),('9650','2013-08-27','08:55:00',1.07),('9650','2013-08-27','09:00:00',1.53),('9650','2013-08-27','09:05:00',1.22),('9650','2013-08-27','09:10:00',1.36),('9650','2013-08-27','09:15:00',2.18),('9650','2013-08-27','09:20:00',1.77),('9650','2013-08-27','09:25:00',1.26),('9650','2013-08-27','09:30:00',1.5),('9650','2013-08-27','09:35:00',2.11),('9650','2013-08-27','09:40:00',2.29),('9650','2013-08-27','09:45:00',2.45),('9650','2013-08-27','09:50:00',2.59),('9650','2013-08-27','09:55:00',2.66),('9650','2013-08-27','10:00:00',2.8),('9650','2013-08-27','10:05:00',2.87),('9650','2013-08-27','10:10:00',3.12),('9650','2013-08-27','10:15:00',3.45),('9650','2013-08-27','10:20:00',3.75),('9650','2013-08-27','10:25:00',2.4),('9650','2013-08-27','10:30:00',3.05),('9650','2013-08-27','10:35:00',2.51),('9650','2013-08-27','10:40:00',3.06),('9650','2013-08-27','10:45:00',4.43),('9650','2013-08-27','10:50:00',3.9),('9650','2013-08-27','10:55:00',4.27),('9650','2013-08-27','11:00:00',1.89),('9650','2013-08-27','11:05:00',4.29),('9650','2013-08-27','11:10:00',2.95),('9650','2013-08-27','11:15:00',4.87),('9650','2013-08-27','11:20:00',5.23),('9650','2013-08-27','11:25:00',5.36),('9650','2013-08-27','11:30:00',5.54),('9650','2013-08-27','11:35:00',5.59),('9650','2013-08-27','11:40:00',5.85),('9650','2013-08-27','11:45:00',3.74),('9650','2013-08-27','11:50:00',4.71),('9650','2013-08-27','11:55:00',3.53),('9650','2013-08-27','12:00:00',3.96),('9650','2013-08-27','12:05:00',4.99),('9650','2013-08-27','12:10:00',5.59),('9650','2013-08-27','12:15:00',5.62),('9650','2013-08-27','12:20:00',6),('9650','2013-08-27','12:25:00',6.08),('9650','2013-08-27','12:30:00',6.08),('9650','2013-08-27','12:35:00',6.11),('9650','2013-08-27','12:40:00',6.21),('9650','2013-08-27','12:45:00',6.46),('9650','2013-08-27','12:50:00',6.36),('9650','2013-08-27','12:55:00',6.32),('9650','2013-08-27','13:00:00',6.52),('9650','2013-08-27','13:05:00',6.13),('9650','2013-08-27','13:10:00',6.76),('9650','2013-08-27','13:15:00',6.44),('9650','2013-08-27','13:20:00',6.53),('9650','2013-08-27','13:25:00',6.59),('9650','2013-08-27','13:30:00',6.55),('9650','2013-08-27','13:35:00',6.67),('9650','2013-08-27','13:40:00',5.42),('9650','2013-08-27','13:45:00',5.96),('9650','2013-08-27','13:50:00',6.88),('9650','2013-08-27','13:55:00',5.04),('9650','2013-08-27','14:00:00',6.72),('9650','2013-08-27','14:05:00',6.67),('9650','2013-08-27','14:10:00',6.81),('9650','2013-08-27','14:15:00',6.82),('9650','2013-08-27','14:20:00',6.78),('9650','2013-08-27','14:25:00',6.82),('9650','2013-08-27','14:30:00',5.32),('9650','2013-08-27','14:35:00',6.01),('9650','2013-08-27','14:40:00',7.1),('9650','2013-08-27','14:45:00',6.84),('9650','2013-08-27','14:50:00',6.77),('9650','2013-08-27','14:55:00',6.72),('9650','2013-08-27','15:00:00',6.66),('9650','2013-08-27','15:05:00',6.38),('9650','2013-08-27','15:10:00',6.85),('9650','2013-08-27','15:15:00',6.73),('9650','2013-08-27','15:20:00',6.71),('9650','2013-08-27','15:25:00',4.95),('9650','2013-08-27','15:30:00',4.56),('9650','2013-08-27','15:35:00',5.88),('9650','2013-08-27','15:40:00',2.76),('9650','2013-08-27','15:45:00',3.5),('9650','2013-08-27','15:50:00',3.17),('9650','2013-08-27','15:55:00',5.28),('9650','2013-08-27','16:00:00',6.48),('9650','2013-08-27','16:05:00',5.3),('9650','2013-08-27','16:10:00',4.54),('9650','2013-08-27','16:15:00',4.28),('9650','2013-08-27','16:20:00',3.96),('9650','2013-08-27','16:25:00',6.1),('9650','2013-08-27','16:30:00',5.78),('9650','2013-08-27','16:35:00',5.71),('9650','2013-08-27','16:40:00',5.62),('9650','2013-08-27','16:45:00',5.31),('9650','2013-08-27','16:50:00',5.11),('9650','2013-08-27','16:55:00',5.01),('9650','2013-08-27','17:00:00',4.99),('9650','2013-08-27','17:05:00',4.77),('9650','2013-08-27','17:10:00',3.68),('9650','2013-08-27','17:15:00',4.29),('9650','2013-08-27','17:20:00',2.33),('9650','2013-08-27','17:25:00',3.95),('9650','2013-08-27','17:30:00',2.25),('9650','2013-08-27','17:35:00',3.88),('9650','2013-08-27','17:40:00',4.17),('9650','2013-08-27','17:45:00',2.44),('9650','2013-08-27','17:50:00',1.09),('9650','2013-08-27','17:55:00',3.34),('9650','2013-08-27','18:00:00',1.07),('9650','2013-08-27','18:05:00',1.61),('9650','2013-08-27','18:10:00',1.95),('9650','2013-08-27','18:15:00',3.1),('9650','2013-08-27','18:20:00',1.62),('9650','2013-08-27','18:25:00',2.63),('9650','2013-08-27','18:45:00',1.11),('9650','2013-08-27','18:50:00',1.85),('9650','2013-08-27','18:55:00',1.23),('9650','2013-08-27','19:00:00',1.5),('9650','2013-08-27','19:05:00',1.2),('9650','2013-08-26','08:10:00',1.04),('9650','2013-08-26','08:15:00',1.11),('9650','2013-08-26','08:20:00',1.17),('9650','2013-08-26','08:25:00',1.21),('9650','2013-08-26','08:30:00',1.19),('9650','2013-08-26','08:35:00',1.06),('9650','2013-08-26','09:10:00',1.13),('9650','2013-08-26','09:15:00',1.18),('9650','2013-08-26','09:20:00',1.35),('9650','2013-08-26','09:25:00',1.76),('9650','2013-08-26','09:30:00',2.04),('9650','2013-08-26','09:35:00',1.39),('9650','2013-08-26','09:40:00',1.2),('9650','2013-08-26','09:45:00',1.25),('9650','2013-08-26','09:50:00',1.29),('9650','2013-08-26','09:55:00',1.58),('9650','2013-08-26','10:00:00',1.98),('9650','2013-08-26','10:05:00',2.36),('9650','2013-08-26','10:10:00',2.98),('9650','2013-08-26','10:15:00',3.08),('9650','2013-08-26','10:20:00',3.33),('9650','2013-08-26','10:25:00',3.43),('9650','2013-08-26','10:30:00',3.49),('9650','2013-08-26','10:35:00',3.65),('9650','2013-08-26','10:40:00',3.68),('9650','2013-08-26','10:45:00',3.82),('9650','2013-08-26','10:50:00',3.94),('9650','2013-08-26','10:55:00',4),('9650','2013-08-26','11:00:00',4.21),('9650','2013-08-26','11:05:00',4.29),('9650','2013-08-26','11:10:00',4.4),('9650','2013-08-26','11:15:00',4.42),('9650','2013-08-26','11:20:00',4.46),('9650','2013-08-26','11:25:00',4.56),('9650','2013-08-26','11:30:00',4.54),('9650','2013-08-26','11:35:00',4.78),('9650','2013-08-26','11:40:00',4.79),('9650','2013-08-26','11:45:00',6.18),('9650','2013-08-26','11:50:00',4.54),('9650','2013-08-26','11:55:00',5.9),('9650','2013-08-26','12:00:00',6.28),('9650','2013-08-26','12:05:00',5.59),('9650','2013-08-26','12:10:00',4.76),('9650','2013-08-26','12:15:00',5.5),('9650','2013-08-26','12:20:00',5.91),('9650','2013-08-26','12:25:00',5.79),('9650','2013-08-26','12:30:00',6.04),('9650','2013-08-26','12:35:00',6.41),('9650','2013-08-26','12:40:00',6.68),('9650','2013-08-26','12:45:00',4.73),('9650','2013-08-26','12:50:00',3.53),('9650','2013-08-26','12:55:00',3.45),('9650','2013-08-26','13:00:00',2.34),('9650','2013-08-26','13:05:00',2.71),('9650','2013-08-26','13:10:00',3.27),('9650','2013-08-26','13:15:00',2.93),('9650','2013-08-26','13:20:00',3.6),('9650','2013-08-26','13:25:00',3.81),('9650','2013-08-26','13:30:00',4.29),('9650','2013-08-26','13:35:00',3.46),('9650','2013-08-26','13:40:00',3.28),('9650','2013-08-26','13:45:00',4.59),('9650','2013-08-26','13:50:00',6.57),('9650','2013-08-26','13:55:00',5.65),('9650','2013-08-26','14:00:00',6.68),('9650','2013-08-26','14:05:00',3.78),('9650','2013-08-26','14:10:00',3.88),('9650','2013-08-26','14:15:00',5.65),('9650','2013-08-26','14:20:00',3.49),('9650','2013-08-26','14:25:00',2.32),('9650','2013-08-26','14:30:00',2.2),('9650','2013-08-26','14:35:00',2),('9650','2013-08-26','14:40:00',2.23),('9650','2013-08-26','14:45:00',2.26),('9650','2013-08-26','14:50:00',1.77),('9650','2013-08-26','14:55:00',1.43),('9650','2013-08-26','15:00:00',1.44),('9650','2013-08-26','15:05:00',1.33),('9650','2013-08-26','15:10:00',1.22),('9650','2013-08-26','15:15:00',1.32),('9650','2013-08-26','15:20:00',1.19),('9650','2013-08-26','15:55:00',2.44),('9650','2013-08-26','16:00:00',2.72),('9650','2013-08-26','16:05:00',2.97),('9650','2013-08-26','16:10:00',6.74),('9650','2013-08-26','16:15:00',5.67),('9650','2013-08-26','16:20:00',4.07),('9650','2013-08-26','16:25:00',4.24),('9650','2013-08-26','16:30:00',1.84),('9650','2013-08-26','16:35:00',2.37),('9650','2013-08-26','16:40:00',2.53),('9650','2013-08-26','16:45:00',4.11),('9650','2013-08-26','16:50:00',5.3),('9650','2013-08-26','16:55:00',3.48),('9650','2013-08-26','17:00:00',1.35),('9650','2013-08-26','17:05:00',2.34),('9650','2013-08-26','17:10:00',5.56),('9650','2013-08-26','17:15:00',2.5),('9650','2013-08-26','17:20:00',1.55),('9650','2013-08-26','17:25:00',1.56),('9650','2013-08-26','17:30:00',1.29),('9650','2013-08-26','17:35:00',1.67),('9650','2013-08-26','17:40:00',1.44),('9650','2013-08-26','17:45:00',3.02),('9650','2013-08-26','17:50:00',3.63),('9650','2013-08-26','17:55:00',3.6),('9650','2013-08-26','18:00:00',3.23),('9650','2013-08-26','18:05:00',2.53),('9650','2013-08-25','08:50:00',1.09),('9650','2013-08-25','08:55:00',1.2),('9650','2013-08-25','09:00:00',1.32),('9650','2013-08-25','09:05:00',1.43),('9650','2013-08-25','09:10:00',1.56),('9650','2013-08-25','09:15:00',1.7),('9650','2013-08-25','09:20:00',1.82),('9650','2013-08-25','09:25:00',1.96),('9650','2013-08-25','09:30:00',2.08),('9650','2013-08-25','09:35:00',2.2),('9650','2013-08-25','09:40:00',2.36),('9650','2013-08-25','09:45:00',2.48),('9650','2013-08-25','09:50:00',2.62),('9650','2013-08-25','09:55:00',2.7),('9650','2013-08-25','10:00:00',2.83),('9650','2013-08-25','10:05:00',2.95),('9650','2013-08-25','10:10:00',3.07),('9650','2013-08-25','10:15:00',3.17),('9650','2013-08-25','10:20:00',3.34),('9650','2013-08-25','10:25:00',3.49),('9650','2013-08-25','10:30:00',3.55),('9650','2013-08-25','10:35:00',3.67),('9650','2013-08-25','10:40:00',3.82),('9650','2013-08-25','10:45:00',3.95),('9650','2013-08-25','10:50:00',4.06),('9650','2013-08-25','10:55:00',4.15),('9650','2013-08-25','11:00:00',4.27),('9650','2013-08-25','11:05:00',4.33),('9650','2013-08-25','11:10:00',4.42),('9650','2013-08-25','11:15:00',4.54),('9650','2013-08-25','11:20:00',4.61),('9650','2013-08-25','11:25:00',4.72),('9650','2013-08-25','11:30:00',4.83),('9650','2013-08-25','11:35:00',4.92),('9650','2013-08-25','11:40:00',5.02),('9650','2013-08-25','11:45:00',5.08),('9650','2013-08-25','11:50:00',1.6),('9650','2013-08-25','11:55:00',3.08),('9650','2013-08-25','12:00:00',5.27),('9650','2013-08-25','12:05:00',5.35),('9650','2013-08-25','12:10:00',5.44),('9650','2013-08-25','12:15:00',5.49),('9650','2013-08-25','12:20:00',5.52),('9650','2013-08-25','12:25:00',5.57),('9650','2013-08-25','12:30:00',5.62),('9650','2013-08-25','12:35:00',5.76),('9650','2013-08-25','12:51:00',5.8),('9650','2013-08-25','12:55:00',6.08),('9650','2013-08-25','13:10:00',5.96),('9650','2013-08-25','13:15:00',5.68),('9650','2013-08-25','13:31:00',5.16),('9650','2013-08-25','13:35:00',5.99),('9650','2013-08-25','13:47:00',6.33),('9650','2013-08-25','13:50:00',6.3),('9650','2013-08-25','14:06:00',5.53),('9650','2013-08-25','14:10:00',7.26),('9650','2013-08-25','14:22:00',6.92),('9650','2013-08-25','14:25:00',6.3),('9650','2013-08-25','14:41:00',6.06),('9650','2013-08-25','14:45:00',3.91),('9650','2013-08-25','14:57:00',3.68),('9650','2013-08-25','15:00:00',3.15),('9650','2013-08-25','15:16:00',2.66),('9650','2013-08-25','15:20:00',1.25),('9650','2013-08-25','15:32:00',1.25),('9650','2013-08-25','15:35:00',1.85),('9650','2013-08-25','15:51:00',2.64),('9650','2013-08-25','15:55:00',2.85),('9650','2013-08-25','16:07:00',4.36),('9650','2013-08-25','16:10:00',5.66),('9650','2013-08-25','16:26:00',5.36),('9650','2013-08-25','16:30:00',5.07),('9650','2013-08-25','16:42:00',5.04),('9650','2013-08-25','16:45:00',4.86),('9650','2013-08-25','17:01:00',4.66),('9650','2013-08-25','17:05:00',4.06),('9650','2013-08-25','17:17:00',4.17),('9650','2013-08-25','17:20:00',2.27),('9650','2013-08-25','17:32:00',1.59),('9650','2013-08-25','17:35:00',2.14),('9650','2013-08-25','17:40:00',2.56),('9650','2013-08-25','17:45:00',2.99),('9650','2013-08-25','17:50:00',3.51),('9650','2013-08-25','17:55:00',3.47),('9650','2013-08-25','18:00:00',3.13),('9650','2013-08-25','18:05:00',2.84),('9650','2013-08-25','18:10:00',2.62),('9650','2013-08-25','18:15:00',2.42),('9650','2013-08-25','18:20:00',2.3),('9650','2013-08-25','18:25:00',2.16),('9650','2013-08-25','18:30:00',1.96),('9650','2013-08-25','18:35:00',1.86),('9650','2013-08-25','18:40:00',1.7),('9650','2013-08-25','18:45:00',1.53),('9650','2013-08-25','18:50:00',1.29),('9650','2013-08-25','18:55:00',1.12),('9650','2013-08-24','08:10:00',1.04),('9650','2013-08-24','08:35:00',1.05),('9650','2013-08-24','08:40:00',1.37),('9650','2013-08-24','08:45:00',1.75),('9650','2013-08-24','08:50:00',1.25),('9650','2013-08-24','09:05:00',1.01),('9650','2013-08-24','09:10:00',1.18),('9650','2013-08-24','09:15:00',1.23),('9650','2013-08-24','09:20:00',2.18),('9650','2013-08-24','09:25:00',2.31),('9650','2013-08-24','09:30:00',2.23),('9650','2013-08-24','09:35:00',1.76),('9650','2013-08-24','09:40:00',3.29),('9650','2013-08-24','09:45:00',4.1),('9650','2013-08-24','09:50:00',3.98),('9650','2013-08-24','09:55:00',4.05),('9650','2013-08-24','10:00:00',3.18),('9650','2013-08-24','10:05:00',2.06),('9650','2013-08-24','10:10:00',1.37),('9650','2013-08-24','10:15:00',1.07),('9650','2013-08-24','10:20:00',1.07),('9650','2013-08-24','14:55:00',1.09),('9650','2013-08-24','15:00:00',1.51),('9650','2013-08-24','15:05:00',1.87),('9650','2013-08-24','15:10:00',2.02),('9650','2013-08-24','15:15:00',2.3),('9650','2013-08-24','15:20:00',2.66),('9650','2013-08-24','15:25:00',2.81),('9650','2013-08-24','15:30:00',3.84),('9650','2013-08-24','15:35:00',6.02),('9650','2013-08-24','15:40:00',6.48),('9650','2013-08-24','15:45:00',6.76),('9650','2013-08-24','15:50:00',4.35),('9650','2013-08-24','15:55:00',4.69),('9650','2013-08-24','16:00:00',6.46),('9650','2013-08-24','16:05:00',6.15),('9650','2013-08-24','16:10:00',5.93),('9650','2013-08-24','16:15:00',5.78),('9650','2013-08-24','16:20:00',5.68),('9650','2013-08-24','16:25:00',5.64),('9650','2013-08-24','16:30:00',5.59),('9650','2013-08-24','16:35:00',5.43),('9650','2013-08-24','16:40:00',3.95),('9650','2013-08-24','16:45:00',2.64),('9650','2013-08-24','16:50:00',3.99),('9650','2013-08-24','16:55:00',3.77),('9650','2013-08-24','17:00:00',4.8),('9650','2013-08-24','17:05:00',5),('9650','2013-08-24','17:10:00',4.77),('9650','2013-08-24','17:15:00',4.44),('9650','2013-08-24','17:20:00',4.27),('9650','2013-08-24','17:25:00',4.16),('9650','2013-08-24','17:30:00',4.06),('9650','2013-08-24','17:35:00',3.61),('9650','2013-08-24','17:40:00',3.23),('9650','2013-08-24','17:45:00',3.85),('9650','2013-08-24','17:50:00',3.49),('9650','2013-08-24','17:55:00',2.88),('9650','2013-08-24','18:00:00',2.35),('9650','2013-08-24','18:05:00',2.14),('9650','2013-08-24','18:10:00',2.62),('9650','2013-08-24','18:15:00',2.84),('9650','2013-08-24','18:20:00',2.76),('9650','2013-08-24','18:25:00',2.54),('9650','2013-08-24','18:30:00',2.12),('9650','2013-08-24','18:35:00',1.64),('9650','2013-08-24','18:40:00',1.05),('9650','2013-08-24','18:55:00',1.19),('9650','2013-08-24','19:00:00',1.09),('9650','2013-08-24','19:05:00',1.05),('9650','2013-08-23','08:35:00',1.05),('9650','2013-08-23','08:40:00',1.2),('9650','2013-08-23','08:45:00',1.24),('9650','2013-08-23','08:50:00',1.23),('9650','2013-08-23','08:55:00',1.49),('9650','2013-08-23','09:00:00',1.67),('9650','2013-08-23','09:05:00',1.92),('9650','2013-08-23','09:10:00',1.85),('9650','2013-08-23','09:15:00',1.87),('9650','2013-08-23','09:20:00',1.46),('9650','2013-08-23','09:25:00',1.88),('9650','2013-08-23','09:30:00',2.11),('9650','2013-08-23','09:35:00',2.51),('9650','2013-08-23','09:40:00',2.11),('9650','2013-08-23','09:45:00',2.52),('9650','2013-08-23','09:50:00',2.19),('9650','2013-08-23','09:55:00',2.14),('9650','2013-08-23','10:00:00',2.76),('9650','2013-08-23','10:05:00',2.92),('9650','2013-08-23','10:10:00',3.09),('9650','2013-08-23','10:15:00',3.2),('9650','2013-08-23','10:20:00',3.34),('9650','2013-08-23','10:25:00',3.42),('9650','2013-08-23','10:30:00',3.51),('9650','2013-08-23','10:35:00',3.66),('9650','2013-08-23','10:40:00',3.76),('9650','2013-08-23','10:45:00',3.63),('9650','2013-08-23','10:50:00',2.23),('9650','2013-08-23','10:55:00',4.19),('9650','2013-08-23','11:00:00',4.22),('9650','2013-08-23','11:05:00',4.36),('9650','2013-08-23','11:10:00',4.49),('9650','2013-08-23','11:15:00',4.45),('9650','2013-08-23','11:20:00',4.56),('9650','2013-08-23','11:25:00',4.66),('9650','2013-08-23','11:30:00',4.77),('9650','2013-08-23','11:35:00',4.83),('9650','2013-08-23','11:40:00',4.96),('9650','2013-08-23','11:45:00',5.04),('9650','2013-08-23','11:50:00',5.08),('9650','2013-08-23','11:55:00',5.17),('9650','2013-08-23','12:00:00',5.24),('9650','2013-08-23','12:05:00',5.34),('9650','2013-08-23','12:10:00',5.45),('9650','2013-08-23','12:15:00',5.45),('9650','2013-08-23','12:20:00',5.55),('9650','2013-08-23','12:25:00',5.56),('9650','2013-08-23','12:30:00',5.63),('9650','2013-08-23','12:35:00',5.7),('9650','2013-08-23','12:40:00',5.73),('9650','2013-08-23','12:45:00',5.76),('9650','2013-08-23','12:50:00',5.85),('9650','2013-08-23','12:55:00',5.84),('9650','2013-08-23','13:00:00',5.82),('9650','2013-08-23','13:05:00',5.97),('9650','2013-08-23','13:10:00',6.03),('9650','2013-08-23','13:15:00',6.06),('9650','2013-08-23','13:20:00',6.14),('9650','2013-08-23','13:25:00',6.15),('9650','2013-08-23','13:30:00',6.23),('9650','2013-08-23','13:35:00',6.27),('9650','2013-08-23','13:40:00',6.26),('9650','2013-08-23','13:45:00',6.33),('9650','2013-08-23','13:50:00',6.34),('9650','2013-08-23','13:55:00',6.36),('9650','2013-08-23','14:00:00',6.37),('9650','2013-08-23','14:05:00',6.38),('9650','2013-08-23','14:10:00',6.37),('9650','2013-08-23','14:15:00',6.39),('9650','2013-08-23','14:20:00',6.4),('9650','2013-08-23','14:25:00',6.39),('9650','2013-08-23','14:30:00',6.43),('9650','2013-08-23','14:35:00',6.4),('9650','2013-08-23','14:40:00',6.39),('9650','2013-08-23','14:45:00',6.37),('9650','2013-08-23','14:50:00',6.35),('9650','2013-08-23','14:55:00',6.33),('9650','2013-08-23','15:00:00',6.24),('9650','2013-08-23','15:05:00',6.23),('9650','2013-08-23','15:10:00',6.18),('9650','2013-08-23','15:15:00',6.18),('9650','2013-08-23','15:20:00',6.13),('9650','2013-08-23','15:25:00',6.13),('9650','2013-08-23','15:30:00',6.1),('9650','2013-08-23','15:35:00',6.09),('9650','2013-08-23','15:40:00',5.98),('9650','2013-08-23','15:45:00',5.91),('9650','2013-08-23','15:50:00',5.86),('9650','2013-08-23','15:55:00',5.79),('9650','2013-08-23','16:00:00',5.73),('9650','2013-08-23','16:05:00',5.69),('9650','2013-08-23','16:10:00',5.62),('9650','2013-08-23','16:15:00',5.57),('9650','2013-08-23','16:20:00',5.52),('9650','2013-08-23','16:25:00',5.46),('9650','2013-08-23','16:30:00',5.37),('9650','2013-08-23','16:35:00',5.24),('9650','2013-08-23','16:40:00',5.14),('9650','2013-08-23','16:45:00',5.02),('9650','2013-08-23','16:50:00',4.92),('9650','2013-08-23','16:55:00',4.8),('9650','2013-08-23','17:00:00',4.71),('9650','2013-08-23','17:05:00',4.61),('9650','2013-08-23','17:10:00',4.52),('9650','2013-08-23','17:15:00',4.4),('9650','2013-08-23','17:20:00',4.31),('9650','2013-08-23','17:25:00',4.22),('9650','2013-08-23','17:30:00',4.11),('9650','2013-08-23','17:35:00',3.99),('9650','2013-08-23','17:40:00',3.91),('9650','2013-08-23','17:45:00',3.79),('9650','2013-08-23','17:50:00',3.67),('9650','2013-08-23','17:55:00',3.51),('9650','2013-08-23','18:00:00',3.35),('9650','2013-08-23','18:05:00',3.21),('9650','2013-08-23','18:10:00',3.08),('9650','2013-08-23','18:15:00',2.94),('9650','2013-08-23','18:20:00',2.8),('9650','2013-08-23','18:25:00',2.64),('9650','2013-08-23','18:30:00',2.48),('9650','2013-08-23','18:35:00',2.3),('9650','2013-08-23','18:40:00',2.12),('9650','2013-08-23','18:45:00',1.92),('9650','2013-08-23','18:50:00',1.72),('9650','2013-08-23','18:55:00',1.51),('9650','2013-08-23','19:00:00',1.34),('9650','2013-08-23','19:05:00',1.15),('9650','2013-08-22','08:30:00',1.01),('9650','2013-08-22','08:35:00',1.04),('9650','2013-08-22','08:40:00',1.11),('9650','2013-08-22','08:45:00',1.22),('9650','2013-08-22','08:50:00',1.3),('9650','2013-08-22','08:55:00',1.41),('9650','2013-08-22','09:00:00',1.52),('9650','2013-08-22','09:05:00',1.64),('9650','2013-08-22','09:10:00',1.72),('9650','2013-08-22','09:15:00',1.82),('9650','2013-08-22','09:20:00',1.94),('9650','2013-08-22','09:25:00',2.03),('9650','2013-08-22','09:30:00',2.14),('9650','2013-08-22','09:35:00',2.27),('9650','2013-08-22','09:40:00',2.35),('9650','2013-08-22','09:45:00',2.46),('9650','2013-08-22','09:50:00',2.55),('9650','2013-08-22','09:55:00',2.66),('9650','2013-08-22','10:00:00',2.74),('9650','2013-08-22','10:05:00',2.87),('9650','2013-08-22','10:10:00',2.97),('9650','2013-08-22','10:15:00',3.08),('9650','2013-08-22','10:20:00',3.17),('9650','2013-08-22','10:25:00',3.3),('9650','2013-08-22','10:30:00',3.42),('9650','2013-08-22','10:35:00',3.51),('9650','2013-08-22','10:40:00',3.59),('9650','2013-08-22','10:45:00',3.62),('9650','2013-08-22','10:50:00',3.81),('9650','2013-08-22','10:55:00',3.96),('9650','2013-08-22','11:00:00',4.12),('9650','2013-08-22','11:05:00',4.13),('9650','2013-08-22','11:10:00',1.88),('9650','2013-08-22','11:15:00',1.66),('9650','2013-08-22','11:20:00',2.67),('9650','2013-08-22','11:25:00',2.68),('9650','2013-08-22','11:30:00',3.83),('9650','2013-08-22','11:35:00',5.01),('9650','2013-08-22','11:40:00',5.05),('9650','2013-08-22','11:45:00',4.68),('9650','2013-08-22','11:50:00',5.21),('9650','2013-08-22','11:55:00',3.79),('9650','2013-08-22','12:00:00',2.73),('9650','2013-08-22','12:05:00',3.31),('9650','2013-08-22','12:10:00',5.32),('9650','2013-08-22','12:15:00',2.61),('9650','2013-08-22','12:20:00',1.57),('9650','2013-08-22','12:25:00',1.65),('9650','2013-08-22','12:30:00',1.64),('9650','2013-08-22','12:35:00',3.01),('9650','2013-08-22','12:40:00',2.18),('9650','2013-08-22','12:45:00',2.15),('9650','2013-08-22','12:50:00',2.29),('9650','2013-08-22','12:55:00',1.65),('9650','2013-08-22','13:00:00',1.85),('9650','2013-08-22','13:05:00',3.13),('9650','2013-08-22','13:10:00',1.95),('9650','2013-08-22','13:15:00',4.31),('9650','2013-08-22','13:20:00',4.11),('9650','2013-08-22','13:25:00',6.87),('9650','2013-08-22','13:30:00',6.7),('9650','2013-08-22','13:35:00',4.14),('9650','2013-08-22','13:40:00',6.18),('9650','2013-08-22','13:45:00',4.85),('9650','2013-08-22','13:50:00',4.06),('9650','2013-08-22','13:55:00',6.88),('9650','2013-08-22','14:00:00',6.91),('9650','2013-08-22','14:05:00',6.68),('9650','2013-08-22','14:10:00',6.52),('9650','2013-08-22','14:15:00',6.42),('9650','2013-08-22','14:20:00',6.37),('9650','2013-08-22','14:25:00',6.03),('9650','2013-08-22','14:30:00',5.86),('9650','2013-08-22','14:35:00',6.12),('9650','2013-08-22','14:40:00',6.27),('9650','2013-08-22','14:45:00',6.19),('9650','2013-08-22','14:50:00',6.26),('9650','2013-08-22','14:55:00',5.88),('9650','2013-08-22','15:00:00',6.08),('9650','2013-08-22','15:05:00',5.72),('9650','2013-08-22','15:10:00',6.24),('9650','2013-08-22','15:15:00',6),('9650','2013-08-22','15:20:00',5.97),('9650','2013-08-22','15:25:00',6.18),('9650','2013-08-22','15:30:00',6.38),('9650','2013-08-22','15:35:00',5.89),('9650','2013-08-22','15:40:00',5.92),('9650','2013-08-22','15:45:00',5.99),('9650','2013-08-22','15:50:00',5.47),('9650','2013-08-22','15:55:00',5.82),('9650','2013-08-22','16:00:00',5.55),('9650','2013-08-22','16:05:00',5.3),('9650','2013-08-22','16:10:00',4.94),('9650','2013-08-22','16:15:00',5.28),('9650','2013-08-22','16:20:00',5.74),('9650','2013-08-22','16:25:00',5.62),('9650','2013-08-22','16:30:00',5.46),('9650','2013-08-22','16:35:00',5.46),('9650','2013-08-22','16:40:00',5.39),('9650','2013-08-22','16:45:00',5.25),('9650','2013-08-22','16:50:00',5.18),('9650','2013-08-22','16:55:00',5),('9650','2013-08-22','17:00:00',4.8),('9650','2013-08-22','17:05:00',4.64),('9650','2013-08-22','17:10:00',4.52),('9650','2013-08-22','17:15:00',4.38),('9650','2013-08-22','17:20:00',4.28),('9650','2013-08-22','17:25:00',4.16),('9650','2013-08-22','17:30:00',3.96),('9650','2013-08-22','17:35:00',3.9),('9650','2013-08-22','17:40:00',3.75),('9650','2013-08-22','17:45:00',3.68),('9650','2013-08-22','17:50:00',3.55),('9650','2013-08-22','17:55:00',3.46),('9650','2013-08-22','18:00:00',3.24),('9650','2013-08-22','18:05:00',3.07),('9650','2013-08-22','18:10:00',2.65),('9650','2013-08-22','18:15:00',2.47),('9650','2013-08-22','18:20:00',2.78),('9650','2013-08-22','18:25:00',2.72),('9650','2013-08-22','18:30:00',2.57),('9650','2013-08-22','18:35:00',2.36),('9650','2013-08-22','18:40:00',2.2),('9650','2013-08-22','18:45:00',2.02),('9650','2013-08-22','18:50:00',1.87),('9650','2013-08-22','18:55:00',1.67),('9650','2013-08-22','19:00:00',1.46),('9650','2013-08-22','19:05:00',1.25),('9650','2013-08-21','08:35:00',1.04),('9650','2013-08-21','08:40:00',1.09),('9650','2013-08-21','08:45:00',1.14),('9650','2013-08-21','08:50:00',1.18),('9650','2013-08-21','08:55:00',1.22),('9650','2013-08-21','09:00:00',1.25),('9650','2013-08-21','09:05:00',1.78),('9650','2013-08-21','09:10:00',1.98),('9650','2013-08-21','09:15:00',2.09),('9650','2013-08-21','09:20:00',2.27),('9650','2013-08-21','09:25:00',2.35),('9650','2013-08-21','09:30:00',2.46),('9650','2013-08-21','09:35:00',1.65),('9650','2013-08-21','09:40:00',1.63),('9650','2013-08-21','09:45:00',2.45),('9650','2013-08-21','09:50:00',2.77),('9650','2013-08-21','09:55:00',2.53),('9650','2013-08-21','10:00:00',3.21),('9650','2013-08-21','10:05:00',3.35),('9650','2013-08-21','10:10:00',3.39),('9650','2013-08-21','10:15:00',3.37),('9650','2013-08-21','10:20:00',3.39),('9650','2013-08-21','10:25:00',3.48),('9650','2013-08-21','10:30:00',3.62),('9650','2013-08-21','10:35:00',3.71),('9650','2013-08-21','10:40:00',3.8),('9650','2013-08-21','10:45:00',3.89),('9650','2013-08-21','10:50:00',3.98),('9650','2013-08-21','10:55:00',4.09),('9650','2013-08-21','11:00:00',4.19),('9650','2013-08-21','11:05:00',4.28),('9650','2013-08-21','11:10:00',4.36),('9650','2013-08-21','11:15:00',4.43),('9650','2013-08-21','11:20:00',4.51),('9650','2013-08-21','11:25:00',4.59),('9650','2013-08-21','11:30:00',4.71),('9650','2013-08-21','11:35:00',4.8),('9650','2013-08-21','11:40:00',4.87),('9650','2013-08-21','11:45:00',4.95),('9650','2013-08-21','11:50:00',5.02),('9650','2013-08-21','11:55:00',5.1),('9650','2013-08-21','12:00:00',5.16),('9650','2013-08-21','12:05:00',5.23),('9650','2013-08-21','12:10:00',5.29),('9650','2013-08-21','12:15:00',5.33),('9650','2013-08-21','12:20:00',5.42),('9650','2013-08-21','12:25:00',5.45),('9650','2013-08-21','12:30:00',5.51),('9650','2013-08-21','12:35:00',5.54),('9650','2013-08-21','12:40:00',5.6),('9650','2013-08-21','12:45:00',5.65),('9650','2013-08-21','12:50:00',5.68),('9650','2013-08-21','12:55:00',5.69),('9650','2013-08-21','13:00:00',5.75),('9650','2013-08-21','13:05:00',5.69),('9650','2013-08-21','13:10:00',5.68),('9650','2013-08-21','13:15:00',5.71),('9650','2013-08-21','13:20:00',5.79),('9650','2013-08-21','13:25:00',5.91),('9650','2013-08-21','13:30:00',5.93),('9650','2013-08-21','13:35:00',5.91),('9650','2013-08-21','13:40:00',5.92),('9650','2013-08-21','13:45:00',6.03),('9650','2013-08-21','13:50:00',6.04),('9650','2013-08-21','13:55:00',6.04),('9650','2013-08-21','14:00:00',6.04),('9650','2013-08-21','14:05:00',6.08),('9650','2013-08-21','14:10:00',6.1),('9650','2013-08-21','14:15:00',6.16),('9650','2013-08-21','14:20:00',6.26),('9650','2013-08-21','14:25:00',6.33),('9650','2013-08-21','14:30:00',5.06),('9650','2013-08-21','14:35:00',6.21),('9650','2013-08-21','14:40:00',6.23),('9650','2013-08-21','14:45:00',5.94),('9650','2013-08-21','14:50:00',6.14),('9650','2013-08-21','14:55:00',6.14),('9650','2013-08-21','15:00:00',6.05),('9650','2013-08-21','15:05:00',6.02),('9650','2013-08-21','15:10:00',6.05),('9650','2013-08-21','15:15:00',5.9),('9650','2013-08-21','15:20:00',5.95),('9650','2013-08-21','15:25:00',5.94),('9650','2013-08-21','15:30:00',5.9),('9650','2013-08-21','15:35:00',5.8),('9650','2013-08-21','15:40:00',5.85),('9650','2013-08-21','15:45:00',5.81),('9650','2013-08-21','15:50:00',5.75),('9650','2013-08-21','15:55:00',5.64),('9650','2013-08-21','16:00:00',5.51),('9650','2013-08-21','16:05:00',5.37),('9650','2013-08-21','16:10:00',5.34),('9650','2013-08-21','16:15:00',5.3),('9650','2013-08-21','16:20:00',5.22),('9650','2013-08-21','16:25:00',5.18),('9650','2013-08-21','16:30:00',5.11),('9650','2013-08-21','16:35:00',4.99),('9650','2013-08-21','16:40:00',4.92),('9650','2013-08-21','16:45:00',4.82),('9650','2013-08-21','16:50:00',4.73),('9650','2013-08-21','16:55:00',4.67),('9650','2013-08-21','17:00:00',4.53),('9650','2013-08-21','17:05:00',4.36),('9650','2013-08-21','17:10:00',4.25),('9650','2013-08-21','17:15:00',4.08),('9650','2013-08-21','17:20:00',4),('9650','2013-08-21','17:25:00',3.94),('9650','2013-08-21','17:30:00',3.82),('9650','2013-08-21','17:35:00',3.74),('9650','2013-08-21','17:40:00',3.61),('9650','2013-08-21','17:45:00',3.47),('9650','2013-08-21','17:50:00',3.28),('9650','2013-08-21','17:55:00',3.19),('9650','2013-08-21','18:00:00',3.11),('9650','2013-08-21','18:05:00',2.93),('9650','2013-08-21','18:10:00',2.85),('9650','2013-08-21','18:15:00',2.83),('9650','2013-08-21','18:20:00',2.35),('9650','2013-08-21','18:25:00',1.82),('9650','2013-08-21','18:30:00',1.73),('9650','2013-08-21','18:35:00',1.56),('9650','2013-08-21','18:40:00',1.7),('9650','2013-08-21','18:45:00',1.6),('9650','2013-08-21','18:50:00',1.26),('9650','2013-08-21','18:55:00',1.14),('9650','2013-08-21','19:00:00',1.17),('9650','2013-08-21','19:05:00',1),('9650','2013-08-20','08:20:00',1.04),('9650','2013-08-20','08:25:00',1.18),('9650','2013-08-20','08:30:00',1.27),('9650','2013-08-20','08:35:00',1.41),('9650','2013-08-20','08:40:00',1.41),('9650','2013-08-20','08:45:00',1.38),('9650','2013-08-20','08:50:00',1.28),('9650','2013-08-20','08:55:00',1.28),('9650','2013-08-20','09:00:00',1.43),('9650','2013-08-20','09:05:00',2.03),('9650','2013-08-20','09:10:00',2.07),('9650','2013-08-20','09:15:00',2.79),('9650','2013-08-20','09:20:00',2.86),('9650','2013-08-20','09:25:00',1.8),('9650','2013-08-20','09:30:00',1.26),('9650','2013-08-20','09:35:00',1.36),('9650','2013-08-20','09:40:00',1.61),('9650','2013-08-20','09:45:00',1.85),('9650','2013-08-20','09:50:00',3.19),('9650','2013-08-20','09:55:00',4.49),('9650','2013-08-20','10:00:00',4.22),('9650','2013-08-20','10:05:00',3.35),('9650','2013-08-20','10:10:00',2.93),('9650','2013-08-20','10:15:00',2.8),('9650','2013-08-20','10:20:00',2.64),('9650','2013-08-20','10:25:00',2.17),('9650','2013-08-20','10:30:00',3.01),('9650','2013-08-20','10:35:00',3.82),('9650','2013-08-20','10:40:00',2.85),('9650','2013-08-20','10:45:00',2.72),('9650','2013-08-20','10:50:00',2.69),('9650','2013-08-20','10:55:00',2.39),('9650','2013-08-20','11:00:00',3.34),('9650','2013-08-20','11:05:00',2.67),('9650','2013-08-20','11:10:00',2.52),('9650','2013-08-20','11:15:00',3.15),('9650','2013-08-20','11:20:00',4.11),('9650','2013-08-20','11:25:00',3.58),('9650','2013-08-20','11:30:00',4.27),('9650','2013-08-20','11:35:00',5.86),('9650','2013-08-20','11:40:00',5.64),('9650','2013-08-20','11:45:00',5.58),('9650','2013-08-20','11:50:00',4.93),('9650','2013-08-20','11:55:00',5.19),('9650','2013-08-20','12:00:00',5.63),('9650','2013-08-20','12:05:00',5.65),('9650','2013-08-20','12:10:00',5.68),('9650','2013-08-20','12:15:00',5.78),('9650','2013-08-20','12:20:00',5.56),('9650','2013-08-20','12:25:00',3.95),('9650','2013-08-20','12:30:00',3.75),('9650','2013-08-20','12:35:00',3.14),('9650','2013-08-20','12:40:00',5.28),('9650','2013-08-20','12:45:00',5.99),('9650','2013-08-20','12:50:00',5.71),('9650','2013-08-20','12:55:00',5.6),('9650','2013-08-20','13:00:00',5.91),('9650','2013-08-20','13:05:00',5.97),('9650','2013-08-20','13:10:00',6.08),('9650','2013-08-20','13:15:00',6.22),('9650','2013-08-20','13:20:00',6.25),('9650','2013-08-20','13:25:00',6.33),('9650','2013-08-20','13:30:00',6.24),('9650','2013-08-20','13:35:00',6.26),('9650','2013-08-20','13:40:00',5.94),('9650','2013-08-20','13:45:00',6.26),('9650','2013-08-20','13:50:00',5.88),('9650','2013-08-20','13:55:00',5.96),('9650','2013-08-20','14:00:00',5.65),('9650','2013-08-20','14:05:00',6.07),('9650','2013-08-20','14:10:00',6.3),('9650','2013-08-20','14:15:00',5.26),('9650','2013-08-20','14:20:00',2.68),('9650','2013-08-20','14:25:00',3.78),('9650','2013-08-20','14:30:00',5.67),('9650','2013-08-20','14:35:00',5.87),('9650','2013-08-20','14:40:00',5.95),('9650','2013-08-20','14:45:00',5.92),('9650','2013-08-20','14:50:00',5.69),('9650','2013-08-20','14:55:00',5.82),('9650','2013-08-20','15:00:00',6.05),('9650','2013-08-20','15:05:00',6.02),('9650','2013-08-20','15:10:00',5.84),('9650','2013-08-20','15:15:00',5.8),('9650','2013-08-20','15:20:00',5.73),('9650','2013-08-20','15:25:00',5.55),('9650','2013-08-20','15:30:00',5.46),('9650','2013-08-20','15:35:00',5.22),('9650','2013-08-20','15:40:00',4.98),('9650','2013-08-20','15:45:00',5.07),('9650','2013-08-20','15:50:00',5.17),('9650','2013-08-20','15:55:00',5.11),('9650','2013-08-20','16:00:00',4.84),('9650','2013-08-20','16:05:00',4.58),('9650','2013-08-20','16:10:00',4.46),('9650','2013-08-20','16:15:00',4.6),('9650','2013-08-20','16:20:00',4.99),('9650','2013-08-20','16:25:00',4.92),('9650','2013-08-20','16:30:00',5.33),('9650','2013-08-20','16:35:00',5.28),('9650','2013-08-20','16:40:00',5.11),('9650','2013-08-20','16:45:00',5.02),('9650','2013-08-20','16:50:00',4.9),('9650','2013-08-20','16:55:00',4.8),('9650','2013-08-20','17:00:00',4.77),('9650','2013-08-20','17:05:00',4.73),('9650','2013-08-20','17:10:00',4.62),('9650','2013-08-20','17:15:00',4.56),('9650','2013-08-20','17:20:00',4.56),('9650','2013-08-20','17:25:00',4.45),('9650','2013-08-20','17:30:00',4.29),('9650','2013-08-20','17:35:00',4.23),('9650','2013-08-20','17:40:00',4.13),('9650','2013-08-20','17:45:00',4.02),('9650','2013-08-20','17:50:00',4.01),('9650','2013-08-20','17:55:00',3.89),('9650','2013-08-20','18:00:00',3.75),('9650','2013-08-20','18:05:00',3.58),('9650','2013-08-20','18:10:00',3.32),('9650','2013-08-20','18:15:00',3.14),('9650','2013-08-20','18:20:00',2.93),('9650','2013-08-20','18:25:00',2.76),('9650','2013-08-20','18:30:00',2.45),('9650','2013-08-20','18:35:00',1.99),('9650','2013-08-20','18:40:00',1.81),('9650','2013-08-20','18:45:00',1.85),('9650','2013-08-20','18:50:00',1.57),('9650','2013-08-20','18:55:00',1.52),('9650','2013-08-20','19:00:00',1.32),('9650','2013-08-20','19:05:00',1.14),('9650','2013-08-19','07:40:00',1),('9650','2013-08-19','07:45:00',1.01),('9650','2013-08-19','07:50:00',1.06),('9650','2013-08-19','07:55:00',1.12),('9650','2013-08-19','08:00:00',1.07),('9650','2013-08-19','08:05:00',1.02),('9650','2013-08-19','08:10:00',1.04),('9650','2013-08-19','08:15:00',1.08),('9650','2013-08-19','08:20:00',1.15),('9650','2013-08-19','08:25:00',1.15),('9650','2013-08-19','08:30:00',1.12),('9650','2013-08-19','08:35:00',1.12),('9650','2013-08-19','08:40:00',1.15),('9650','2013-08-19','08:45:00',1.29),('9650','2013-08-19','08:50:00',1.43),('9650','2013-08-19','08:55:00',1.57),('9650','2013-08-19','09:00:00',1.51),('9650','2013-08-19','09:05:00',1.37),('9650','2013-08-19','09:10:00',1.15),('9650','2013-08-19','09:15:00',1.22),('9650','2013-08-19','09:20:00',1.42),('9650','2013-08-19','09:25:00',2.09),('9650','2013-08-19','09:30:00',2.9),('9650','2013-08-19','09:35:00',3.41),('9650','2013-08-19','09:40:00',3.88),('9650','2013-08-19','09:45:00',3.15),('9650','2013-08-19','09:50:00',3.16),('9650','2013-08-19','09:55:00',4.25),('9650','2013-08-19','10:00:00',3.94),('9650','2013-08-19','10:05:00',1.93),('9650','2013-08-19','10:10:00',2.58),('9650','2013-08-19','10:15:00',3.63),('9650','2013-08-19','10:20:00',2.92),('9650','2013-08-19','10:25:00',1.65),('9650','2013-08-19','10:30:00',1.82),('9650','2013-08-19','10:35:00',1.84),('9650','2013-08-19','10:40:00',2.1),('9650','2013-08-19','10:45:00',4.01),('9650','2013-08-19','10:50:00',4),('9650','2013-08-19','10:55:00',2.9),('9650','2013-08-19','11:00:00',1.64),('9650','2013-08-19','11:05:00',1.37),('9650','2013-08-19','11:10:00',2.59),('9650','2013-08-19','11:15:00',5.22),('9650','2013-08-19','11:20:00',5.42),('9650','2013-08-19','11:25:00',4.35),('9650','2013-08-19','11:30:00',2.58),('9650','2013-08-19','11:35:00',5.54),('9650','2013-08-19','11:40:00',5.89),('9650','2013-08-19','11:45:00',5.99),('9650','2013-08-19','11:50:00',6.84),('9650','2013-08-19','11:55:00',5.43),('9650','2013-08-19','12:00:00',2.92),('9650','2013-08-19','12:05:00',2.88),('9650','2013-08-19','12:10:00',2.13),('9650','2013-08-19','12:15:00',1.31),('9650','2013-08-19','12:20:00',1.39),('9650','2013-08-19','12:25:00',1.92),('9650','2013-08-19','12:30:00',2.58),('9650','2013-08-19','12:35:00',2.96),('9650','2013-08-19','12:40:00',3.16),('9650','2013-08-19','12:45:00',3.13),('9650','2013-08-19','12:50:00',3.14),('9650','2013-08-19','12:55:00',3.28),('9650','2013-08-19','13:00:00',3.27),('9650','2013-08-19','13:05:00',2.95),('9650','2013-08-19','13:10:00',2.85),('9650','2013-08-19','13:15:00',2.86),('9650','2013-08-19','13:20:00',2.97),('9650','2013-08-19','13:25:00',3.1),('9650','2013-08-19','13:30:00',3.45),('9650','2013-08-19','13:35:00',4.62),('9650','2013-08-19','13:40:00',6.94),('9650','2013-08-19','13:45:00',5.76),('9650','2013-08-19','13:50:00',6.92),('9650','2013-08-19','13:55:00',6.75),('9650','2013-08-19','14:00:00',6.73),('9650','2013-08-19','14:05:00',6.7),('9650','2013-08-19','14:10:00',5.91),('9650','2013-08-19','14:15:00',6.58),('9650','2013-08-19','14:20:00',6.67),('9650','2013-08-19','14:25:00',5.67),('9650','2013-08-19','14:30:00',6.04),('9650','2013-08-19','14:35:00',7.21),('9650','2013-08-19','14:40:00',7.1),('9650','2013-08-19','14:45:00',6.67),('9650','2013-08-19','14:50:00',6.64),('9650','2013-08-19','14:55:00',6.74),('9650','2013-08-19','15:00:00',6.35),('9650','2013-08-19','15:05:00',7.07),('9650','2013-08-19','15:10:00',6.92),('9650','2013-08-19','15:15:00',6.93),('9650','2013-08-19','15:20:00',6.78),('9650','2013-08-19','15:25:00',6.77),('9650','2013-08-19','15:30:00',6.82),('9650','2013-08-19','15:35:00',6.81),('9650','2013-08-19','15:40:00',7.01),('9650','2013-08-19','15:45:00',7.21),('9650','2013-08-19','15:50:00',7.32),('9650','2013-08-19','15:55:00',7.47),('9650','2013-08-19','16:00:00',7.24),('9650','2013-08-19','16:05:00',7.16),('9650','2013-08-19','16:10:00',7.11),('9650','2013-08-19','16:15:00',7.12),('9650','2013-08-19','16:20:00',7.07),('9650','2013-08-19','16:25:00',6.92),('9650','2013-08-19','16:30:00',6.44),('9650','2013-08-19','16:35:00',6.45),('9650','2013-08-19','16:40:00',6.53),('9650','2013-08-19','16:45:00',6.32),('9650','2013-08-19','16:50:00',6.09),('9650','2013-08-19','16:55:00',5.75),('9650','2013-08-19','17:00:00',5.43),('9650','2013-08-19','17:05:00',5.26),('9650','2013-08-19','17:10:00',5.13),('9650','2013-08-19','17:15:00',4.9),('9650','2013-08-19','17:20:00',4.81),('9650','2013-08-19','17:25:00',4.68),('9650','2013-08-19','17:30:00',4.61),('9650','2013-08-19','17:35:00',4.56),('9650','2013-08-19','17:40:00',4.46),('9650','2013-08-19','17:45:00',4.31),('9650','2013-08-19','17:50:00',3.93),('9650','2013-08-19','17:55:00',3.74),('9650','2013-08-19','18:00:00',3.47),('9650','2013-08-19','18:05:00',3.51),('9650','2013-08-19','18:10:00',3.55),('9650','2013-08-19','18:15:00',3.51),('9650','2013-08-19','18:20:00',3.5),('9650','2013-08-19','18:25:00',3.38),('9650','2013-08-19','18:30:00',3.38),('9650','2013-08-19','18:35:00',3.11),('9650','2013-08-19','18:40:00',2.54),('9650','2013-08-19','18:45:00',2.69),('9650','2013-08-19','18:50:00',2.18),('9650','2013-08-19','18:55:00',2.53),('9650','2013-08-19','19:00:00',2.44),('9650','2013-08-19','19:05:00',2.05),('9650','2013-08-19','19:20:00',1.23),('9650','2014-04-09','09:00:00',1.11),('9650','2014-04-09','09:05:00',1.22),('9650','2014-04-09','09:10:00',1.3),('9650','2014-04-09','09:15:00',1.34),('9650','2014-04-09','09:20:00',1.47),('9650','2014-04-09','09:25:00',1.82),('9650','2014-04-09','09:30:00',2),('9650','2014-04-09','09:35:00',2.16),('9650','2014-04-09','09:40:00',2.3),('9650','2014-04-09','09:45:00',2.43),('9650','2014-04-09','09:50:00',2.59),('9650','2014-04-09','09:55:00',2.76),('9650','2014-04-09','10:00:00',2.9),('9650','2014-04-09','10:05:00',3.02),('9650','2014-04-09','10:10:00',3.2),('9650','2014-04-09','10:15:00',3.28),('9650','2014-04-09','10:20:00',3.44),('9650','2014-04-09','10:25:00',3.56),('9650','2014-04-09','10:30:00',3.67),('9650','2014-04-09','10:35:00',3.87),('9650','2014-04-09','10:40:00',4.02),('9650','2014-04-09','10:45:00',4.11),('9650','2014-04-09','10:50:00',4.13),('9650','2014-04-09','10:55:00',4.29),('9650','2014-04-09','11:00:00',4.37),('9650','2014-04-09','11:05:00',4.58),('9650','2014-04-09','11:10:00',4.52),('9650','2014-04-09','11:15:00',4.73),('9650','2014-04-09','11:20:00',4.92),('9650','2014-04-09','11:25:00',5.09),('9650','2014-04-09','11:30:00',5.18),('9650','2014-04-09','11:35:00',5.34),('9650','2014-04-09','11:40:00',5.2),('9650','2014-04-09','11:45:00',5.41),('9650','2014-04-09','11:50:00',5.28),('9650','2014-04-09','11:55:00',5.64),('9650','2014-04-09','12:00:00',5.6),('9650','2014-04-09','12:05:00',5.3),('9650','2014-04-09','12:10:00',5.57),('9650','2014-04-09','12:15:00',5.69),('9650','2014-04-09','12:20:00',5.81),('9650','2014-04-09','12:25:00',5.58),('9650','2014-04-09','12:30:00',5.77),('9650','2014-04-09','12:35:00',6.22),('9650','2014-04-09','12:40:00',5.92),('9650','2014-04-09','12:45:00',6.18),('9650','2014-04-09','12:50:00',6.04),('9650','2014-04-09','12:55:00',6.01),('9650','2014-04-09','13:00:00',6.08),('9650','2014-04-09','13:05:00',5.88),('9650','2014-04-09','13:10:00',6.11),('9650','2014-04-09','13:15:00',6.2),('9650','2014-04-09','13:20:00',5.88),('9650','2014-04-09','13:25:00',6.43),('9650','2014-04-09','13:30:00',6.46),('9650','2014-04-09','13:35:00',6.69),('9650','2014-04-09','13:40:00',6.46),('9650','2014-04-09','13:45:00',6.62),('9650','2014-04-09','13:50:00',6.75),('9650','2014-04-09','13:55:00',6.75),('9650','2014-04-09','14:00:00',6.76),('9650','2014-04-09','14:05:00',6.69),('9650','2014-04-09','14:10:00',6.72),('9650','2014-04-09','14:15:00',6.72),('9650','2014-04-09','14:20:00',6.82),('9650','2014-04-09','14:25:00',6.8),('9650','2014-04-09','14:30:00',6.74),('9650','2014-04-09','14:35:00',6.74),('9650','2014-04-09','14:40:00',6.7),('9650','2014-04-09','14:45:00',6.09),('9650','2014-04-09','14:50:00',6.8),('9650','2014-04-09','14:55:00',6.78),('9650','2014-04-09','15:00:00',6.79),('9650','2014-04-09','15:05:00',6.7),('9650','2014-04-09','15:10:00',6.56),('9650','2014-04-09','15:15:00',6.64),('9650','2014-04-09','15:20:00',6.55),('9650','2014-04-09','15:25:00',6.45),('9650','2014-04-09','15:30:00',5.93),('9650','2014-04-09','15:35:00',5.77),('9650','2014-04-09','15:40:00',5.92),('9650','2014-04-09','15:45:00',5.96),('9650','2014-04-09','15:50:00',6),('9650','2014-04-09','15:55:00',5.96),('9650','2014-04-09','16:00:00',5.76),('9650','2014-04-09','16:05:00',5.83),('9650','2014-04-09','16:10:00',5.88),('9650','2014-04-09','16:15:00',6.04),('9650','2014-04-09','16:20:00',5.79),('9650','2014-04-09','16:25:00',5.87),('9650','2014-04-09','16:30:00',5.85),('9650','2014-04-09','16:35:00',5.69),('9650','2014-04-09','16:40:00',5.66),('9650','2014-04-09','16:45:00',5.6),('9650','2014-04-09','16:50:00',5.26),('9650','2014-04-09','16:55:00',5.07),('9650','2014-04-09','17:00:00',4.98),('9650','2014-04-09','17:05:00',4.91),('9650','2014-04-09','17:10:00',4.67),('9650','2014-04-09','17:15:00',4.47),('9650','2014-04-09','17:20:00',4.49),('9650','2014-04-09','17:25:00',4.33),('9650','2014-04-09','17:30:00',4.26),('9650','2014-04-09','17:35:00',4.14),('9650','2014-04-09','17:40:00',3.96),('9650','2014-04-09','17:45:00',3.92),('9650','2014-04-09','17:50:00',3.8),('9650','2014-04-09','17:55:00',3.65),('9650','2014-04-09','18:00:00',3.47),('9650','2014-04-09','18:05:00',3.31),('9650','2014-04-09','18:10:00',3.18),('9650','2014-04-09','18:15:00',3),('9650','2014-04-09','18:20:00',2.87),('9650','2014-04-09','18:25:00',2.7),('9650','2014-04-09','18:30:00',2.54),('9650','2014-04-09','18:35:00',2.24),('9650','2014-04-09','18:40:00',2.05),('9650','2014-04-09','18:45:00',1.78),('9650','2014-04-09','18:50:00',1.22),('9650','2013-08-18','08:40:00',1.07),('9650','2013-08-18','08:45:00',1.17),('9650','2013-08-18','08:50:00',1.29),('9650','2013-08-18','08:55:00',1.42),('9650','2013-08-18','09:00:00',1.54),('9650','2013-08-18','09:05:00',1.67),('9650','2013-08-18','09:10:00',1.77),('9650','2013-08-18','09:15:00',1.87),('9650','2013-08-18','09:20:00',2),('9650','2013-08-18','09:25:00',2.15),('9650','2013-08-18','09:30:00',2.26),('9650','2013-08-18','09:35:00',2.39),('9650','2013-08-18','09:40:00',2.53),('9650','2013-08-18','09:45:00',2.65),('9650','2013-08-18','09:50:00',2.77),('9650','2013-08-18','09:55:00',2.9),('9650','2013-08-18','10:00:00',3.02),('9650','2013-08-18','10:05:00',3.15),('9650','2013-08-18','10:10:00',3.27),('9650','2013-08-18','10:15:00',3.37),('9650','2013-08-18','10:20:00',3.47),('9650','2013-08-18','10:25:00',3.59),('9650','2013-08-18','10:30:00',3.7),('9650','2013-08-18','10:35:00',3.81),('9650','2013-08-18','10:40:00',3.91),('9650','2013-08-18','10:45:00',4.03),('9650','2013-08-18','10:50:00',4.11),('9650','2013-08-18','10:55:00',4.2),('9650','2013-08-18','11:00:00',4.26),('9650','2013-08-18','11:05:00',4.39),('9650','2013-08-18','11:10:00',4.52),('9650','2013-08-18','11:15:00',4.6),('9650','2013-08-18','11:20:00',4.72),('9650','2013-08-18','11:25:00',4.76),('9650','2013-08-18','11:30:00',4.84),('9650','2013-08-18','11:35:00',4.95),('9650','2013-08-18','11:40:00',5),('9650','2013-08-18','11:45:00',5.06),('9650','2013-08-18','11:50:00',5.03),('9650','2013-08-18','11:55:00',5.07),('9650','2013-08-18','12:00:00',5.12),('9650','2013-08-18','12:05:00',5.31),('9650','2013-08-18','12:10:00',5.36),('9650','2013-08-18','12:15:00',5.48),('9650','2013-08-18','12:20:00',5.53),('9650','2013-08-18','12:25:00',5.6),('9650','2013-08-18','12:30:00',5.65),('9650','2013-08-18','12:35:00',5.72),('9650','2013-08-18','12:40:00',5.74),('9650','2013-08-18','12:45:00',5.83),('9650','2013-08-18','12:50:00',5.88),('9650','2013-08-18','12:55:00',6.03),('9650','2013-08-18','13:00:00',6.05),('9650','2013-08-18','13:05:00',6.12),('9650','2013-08-18','13:10:00',6.15),('9650','2013-08-18','13:15:00',6.2),('9650','2013-08-18','13:20:00',6.25),('9650','2013-08-18','13:25:00',6.24),('9650','2013-08-18','13:30:00',6.26),('9650','2013-08-18','13:35:00',6.31),('9650','2013-08-18','13:40:00',6.33),('9650','2013-08-18','13:45:00',6.36),('9650','2013-08-18','13:50:00',6.41),('9650','2013-08-18','13:55:00',6.45),('9650','2013-08-18','14:00:00',6.42),('9650','2013-08-18','14:05:00',6.44),('9650','2013-08-18','14:10:00',6.5),('9650','2013-08-18','14:15:00',6.48),('9650','2013-08-18','14:20:00',6.49),('9650','2013-08-18','14:25:00',6.46),('9650','2013-08-18','14:30:00',6.5),('9650','2013-08-18','14:35:00',6.51),('9650','2013-08-18','14:40:00',6.49),('9650','2013-08-18','14:45:00',6.53),('9650','2013-08-18','14:50:00',6.51),('9650','2013-08-18','14:55:00',6.49),('9650','2013-08-18','15:00:00',6.49),('9650','2013-08-18','15:05:00',6.48),('9650','2013-08-18','15:10:00',6.45),('9650','2013-08-18','15:15:00',6.42),('9650','2013-08-18','15:20:00',6.45),('9650','2013-08-18','15:25:00',6.35),('9650','2013-08-18','15:30:00',6.31),('9650','2013-08-18','15:35:00',6.34),('9650','2013-08-18','15:40:00',6.28),('9650','2013-08-18','15:45:00',6.22),('9650','2013-08-18','15:50:00',6.15),('9650','2013-08-18','15:55:00',6.07),('9650','2013-08-18','16:00:00',6.02),('9650','2013-08-18','16:05:00',6),('9650','2013-08-18','16:10:00',5.93),('9650','2013-08-18','16:15:00',5.89),('9650','2013-08-18','16:20:00',5.71),('9650','2013-08-18','16:25:00',5.68),('9650','2013-08-18','16:30:00',5.61),('9650','2013-08-18','16:35:00',5.56),('9650','2013-08-18','16:40:00',5.46),('9650','2013-08-18','16:45:00',5.41),('9650','2013-08-18','16:50:00',5.28),('9650','2013-08-18','16:55:00',5.21),('9650','2013-08-18','17:00:00',5.11),('9650','2013-08-18','17:05:00',5.02),('9650','2013-08-18','17:10:00',4.9),('9650','2013-08-18','17:15:00',4.81),('9650','2013-08-18','17:20:00',4.7),('9650','2013-08-18','17:25:00',4.6),('9650','2013-08-18','17:30:00',4.5),('9650','2013-08-18','17:35:00',4.42),('9650','2013-08-18','17:40:00',4.32),('9650','2013-08-18','17:45:00',4.2),('9650','2013-08-18','17:50:00',4.06),('9650','2013-08-18','17:55:00',3.91),('9650','2013-08-18','18:00:00',3.78),('9650','2013-08-18','18:05:00',3.65),('9650','2013-08-18','18:10:00',3.48),('9650','2013-08-18','18:15:00',3.35),('9650','2013-08-18','18:20:00',3.22),('9650','2013-08-18','18:25:00',3.05),('9650','2013-08-18','18:30:00',2.87),('9650','2013-08-18','18:35:00',2.72),('9650','2013-08-18','18:40:00',2.59),('9650','2013-08-18','18:45:00',2.39),('9650','2013-08-18','18:50:00',2.22),('9650','2013-08-18','18:55:00',1.98),('9650','2013-08-18','19:00:00',1.78),('9650','2013-08-18','19:05:00',1.6),('9650','2013-08-18','19:10:00',1.43),('9650','2013-08-18','19:15:00',1.23),('9650','2013-08-18','19:20:00',1.01),('9650','2013-08-17','08:40:00',1.05),('9650','2013-08-17','08:45:00',1.11),('9650','2013-08-17','08:50:00',1.15),('9650','2013-08-17','08:55:00',1.19),('9650','2013-08-17','09:00:00',1.23),('9650','2013-08-17','09:05:00',1.37),('9650','2013-08-17','09:10:00',1.81),('9650','2013-08-17','09:15:00',1.94),('9650','2013-08-17','09:20:00',2.08),('9650','2013-08-17','09:25:00',2.23),('9650','2013-08-17','09:30:00',2.36),('9650','2013-08-17','09:35:00',2.51),('9650','2013-08-17','09:40:00',2.65),('9650','2013-08-17','09:45:00',2.47),('9650','2013-08-17','09:50:00',2.77),('9650','2013-08-17','09:55:00',2.29),('9650','2013-08-17','10:00:00',3.02),('9650','2013-08-17','10:05:00',2.58),('9650','2013-08-17','10:10:00',3.16),('9650','2013-08-17','10:15:00',3.43),('9650','2013-08-17','10:20:00',3.54),('9650','2013-08-17','10:25:00',3.66),('9650','2013-08-17','10:30:00',3.76),('9650','2013-08-17','10:35:00',3.87),('9650','2013-08-17','10:40:00',3.96),('9650','2013-08-17','10:45:00',4.01),('9650','2013-08-17','10:50:00',4.12),('9650','2013-08-17','10:55:00',4.13),('9650','2013-08-17','11:00:00',4.28),('9650','2013-08-17','11:05:00',4.48),('9650','2013-08-17','11:10:00',4.54),('9650','2013-08-17','11:15:00',4.62),('9650','2013-08-17','11:20:00',4.68),('9650','2013-08-17','11:25:00',4.72),('9650','2013-08-17','11:30:00',4.84),('9650','2013-08-17','11:35:00',4.94),('9650','2013-08-17','11:40:00',5.04),('9650','2013-08-17','11:45:00',5.13),('9650','2013-08-17','11:50:00',5.18),('9650','2013-08-17','11:55:00',5.19),('9650','2013-08-17','12:00:00',5.36),('9650','2013-08-17','12:05:00',5.47),('9650','2013-08-17','12:10:00',5.42),('9650','2013-08-17','12:15:00',5.64),('9650','2013-08-17','12:20:00',5.77),('9650','2013-08-17','12:25:00',5.89),('9650','2013-08-17','12:30:00',3.44),('9650','2013-08-17','12:35:00',1.48),('9650','2013-08-17','12:40:00',1.41),('9650','2013-08-17','12:45:00',4.33),('9650','2013-08-17','12:50:00',3.59),('9650','2013-08-17','12:55:00',1.69),('9650','2013-08-17','13:00:00',3.63),('9650','2013-08-17','13:05:00',6.63),('9650','2013-08-17','13:10:00',6.43),('9650','2013-08-17','13:15:00',5.98),('9650','2013-08-17','13:20:00',6.41),('9650','2013-08-17','13:25:00',6.12),('9650','2013-08-17','13:30:00',6.27),('9650','2013-08-17','13:35:00',6.28),('9650','2013-08-17','13:40:00',6.36),('9650','2013-08-17','13:45:00',6.38),('9650','2013-08-17','13:50:00',6.32),('9650','2013-08-17','13:55:00',6.25),('9650','2013-08-17','14:00:00',6.5),('9650','2013-08-17','14:05:00',6.39),('9650','2013-08-17','14:10:00',6.42),('9650','2013-08-17','14:15:00',6.44),('9650','2013-08-17','14:20:00',6.46),('9650','2013-08-17','14:25:00',6.47),('9650','2013-08-17','14:30:00',6.52),('9650','2013-08-17','14:35:00',6.58),('9650','2013-08-17','14:40:00',6.56),('9650','2013-08-17','14:45:00',6.55),('9650','2013-08-17','14:50:00',6.54),('9650','2013-08-17','14:55:00',6.51),('9650','2013-08-17','15:00:00',6.55),('9650','2013-08-17','15:05:00',6.56),('9650','2013-08-17','15:10:00',6.5),('9650','2013-08-17','15:15:00',6.47),('9650','2013-08-17','15:20:00',6.42),('9650','2013-08-17','15:25:00',6.4),('9650','2013-08-17','15:30:00',6.36),('9650','2013-08-17','15:35:00',6.32),('9650','2013-08-17','15:40:00',6.31),('9650','2013-08-17','15:45:00',6.28),('9650','2013-08-17','15:50:00',6.18),('9650','2013-08-17','15:55:00',6.02),('9650','2013-08-17','16:00:00',5.98),('9650','2013-08-17','16:05:00',5.94),('9650','2013-08-17','16:10:00',5.9),('9650','2013-08-17','16:15:00',5.83),('9650','2013-08-17','16:20:00',5.74),('9650','2013-08-17','16:25:00',5.69),('9650','2013-08-17','16:30:00',5.63),('9650','2013-08-17','16:35:00',5.54),('9650','2013-08-17','16:40:00',5.48),('9650','2013-08-17','16:45:00',5.4),('9650','2013-08-17','16:50:00',5.32),('9650','2013-08-17','16:55:00',5.22),('9650','2013-08-17','17:00:00',5.14),('9650','2013-08-17','17:05:00',5.04),('9650','2013-08-17','17:10:00',4.96),('9650','2013-08-17','17:15:00',4.86),('9650','2013-08-17','17:20:00',4.78),('9650','2013-08-17','17:25:00',4.65),('9650','2013-08-17','17:30:00',4.56),('9650','2013-08-17','17:35:00',4.45),('9650','2013-08-17','17:40:00',4.34),('9650','2013-08-17','17:45:00',4.21),('9650','2013-08-17','17:50:00',4.08),('9650','2013-08-17','17:55:00',3.94),('9650','2013-08-17','18:00:00',3.79),('9650','2013-08-17','18:05:00',3.68),('9650','2013-08-17','18:10:00',3.54),('9650','2013-08-17','18:15:00',3.41),('9650','2013-08-17','18:20:00',3.25),('9650','2013-08-17','18:25:00',3.1),('9650','2013-08-17','18:30:00',2.93),('9650','2013-08-17','18:35:00',2.78),('9650','2013-08-17','18:40:00',2.61),('9650','2013-08-17','18:45:00',2.43),('9650','2013-08-17','18:50:00',2.28),('9650','2013-08-17','18:55:00',2.07),('9650','2013-08-17','19:00:00',1.87),('9650','2013-08-17','19:05:00',1.67),('9650','2013-08-17','19:10:00',1.47),('9650','2013-08-17','19:15:00',1.26),('9650','2013-08-17','19:20:00',1.04),('9650','2013-08-16','08:40:00',1.02),('9650','2013-08-16','08:45:00',1.16),('9650','2013-08-16','08:50:00',1.27),('9650','2013-08-16','08:55:00',1.4),('9650','2013-08-16','09:00:00',1.53),('9650','2013-08-16','09:05:00',1.66),('9650','2013-08-16','09:10:00',1.77),('9650','2013-08-16','09:15:00',1.89),('9650','2013-08-16','09:20:00',2.02),('9650','2013-08-16','09:25:00',2.18),('9650','2013-08-16','09:30:00',2.31),('9650','2013-08-16','09:35:00',2.44),('9650','2013-08-16','09:40:00',2.58),('9650','2013-08-16','09:45:00',2.69),('9650','2013-08-16','09:50:00',2.81),('9650','2013-08-16','09:55:00',2.93),('9650','2013-08-16','10:00:00',3.05),('9650','2013-08-16','10:05:00',3.19),('9650','2013-08-16','10:10:00',3.3),('9650','2013-08-16','10:15:00',3.41),('9650','2013-08-16','10:20:00',3.52),('9650','2013-08-16','10:25:00',3.65),('9650','2013-08-16','10:30:00',3.78),('9650','2013-08-16','10:35:00',3.87),('9650','2013-08-16','10:40:00',3.97),('9650','2013-08-16','10:45:00',4.08),('9650','2013-08-16','10:50:00',4.2),('9650','2013-08-16','10:55:00',4.29),('9650','2013-08-16','11:00:00',4.38),('9650','2013-08-16','11:05:00',4.44),('9650','2013-08-16','11:10:00',4.57),('9650','2013-08-16','11:15:00',4.64),('9650','2013-08-16','11:20:00',4.76),('9650','2013-08-16','11:25:00',4.84),('9650','2013-08-16','11:30:00',4.94),('9650','2013-08-16','11:35:00',4.98),('9650','2013-08-16','11:40:00',5.08),('9650','2013-08-16','11:45:00',5.18),('9650','2013-08-16','11:50:00',5.26),('9650','2013-08-16','11:55:00',5.14),('9650','2013-08-16','12:00:00',5.2),('9650','2013-08-16','12:05:00',5.45),('9650','2013-08-16','12:10:00',5.46),('9650','2013-08-16','12:15:00',5.45),('9650','2013-08-16','12:20:00',5.48),('9650','2013-08-16','12:25:00',5.7),('9650','2013-08-16','12:30:00',5.73),('9650','2013-08-16','12:35:00',5.71),('9650','2013-08-16','12:40:00',5.06),('9650','2013-08-16','12:45:00',5.91),('9650','2013-08-16','12:50:00',5.91),('9650','2013-08-16','12:55:00',5.98),('9650','2013-08-16','13:00:00',6.16),('9650','2013-08-16','13:05:00',6.07),('9650','2013-08-16','13:10:00',4.68),('9650','2013-08-16','13:15:00',5.62),('9650','2013-08-16','13:20:00',6.31),('9650','2013-08-16','13:25:00',6.5),('9650','2013-08-16','13:30:00',6.5),('9650','2013-08-16','13:35:00',6.55),('9650','2013-08-16','13:40:00',1.91),('9650','2013-08-16','13:45:00',4.72),('9650','2013-08-16','13:50:00',3.21),('9650','2013-08-16','13:55:00',3.46),('9650','2013-08-16','14:00:00',5.45),('9650','2013-08-16','14:05:00',6.51),('9650','2013-08-16','14:10:00',6.55),('9650','2013-08-16','14:15:00',6.49),('9650','2013-08-16','14:20:00',6.63),('9650','2013-08-16','14:25:00',6.48),('9650','2013-08-16','14:30:00',6.41),('9650','2013-08-16','14:35:00',6.46),('9650','2013-08-16','14:40:00',6.42),('9650','2013-08-16','14:45:00',6.41),('9650','2013-08-16','14:50:00',6.5),('9650','2013-08-16','14:55:00',6.4),('9650','2013-08-16','15:00:00',6.44),('9650','2013-08-16','15:05:00',6.41),('9650','2013-08-16','15:10:00',6.36),('9650','2013-08-16','15:15:00',6.28),('9650','2013-08-16','15:20:00',6.38),('9650','2013-08-16','15:25:00',6.32),('9650','2013-08-16','15:30:00',6.28),('9650','2013-08-16','15:35:00',6.33),('9650','2013-08-16','15:40:00',6.26),('9650','2013-08-16','15:45:00',6.24),('9650','2013-08-16','15:50:00',6.16),('9650','2013-08-16','15:55:00',6.07),('9650','2013-08-16','16:00:00',6.06),('9650','2013-08-16','16:05:00',5.96),('9650','2013-08-16','16:10:00',5.87),('9650','2013-08-16','16:15:00',5.85),('9650','2013-08-16','16:20:00',5.82),('9650','2013-08-16','16:25:00',5.76),('9650','2013-08-16','16:30:00',5.74),('9650','2013-08-16','16:35:00',5.7),('9650','2013-08-16','16:40:00',5.65),('9650','2013-08-16','16:45:00',5.45),('9650','2013-08-16','16:50:00',5.32),('9650','2013-08-16','16:55:00',5.32),('9650','2013-08-16','17:00:00',5.23),('9650','2013-08-16','17:05:00',5.06),('9650','2013-08-16','17:10:00',4.79),('9650','2013-08-16','17:15:00',4.38),('9650','2013-08-16','17:20:00',4.59),('9650','2013-08-16','17:25:00',4.76),('9650','2013-08-16','17:30:00',4.77),('9650','2013-08-16','17:35:00',4.67),('9650','2013-08-16','17:40:00',4.54),('9650','2013-08-16','17:45:00',4.43),('9650','2013-08-16','17:50:00',4.23),('9650','2013-08-16','17:55:00',4.1),('9650','2013-08-16','18:00:00',3.97),('9650','2013-08-16','18:05:00',3.8),('9650','2013-08-16','18:10:00',3.65),('9650','2013-08-16','18:15:00',3.52),('9650','2013-08-16','18:20:00',3.33),('9650','2013-08-16','18:25:00',3.22),('9650','2013-08-16','18:30:00',3.07),('9650','2013-08-16','18:35:00',2.88),('9650','2013-08-16','18:40:00',2.74),('9650','2013-08-16','18:45:00',2.6),('9650','2013-08-16','18:50:00',2.4),('9650','2013-08-16','18:55:00',2.2),('9650','2013-08-16','19:00:00',2),('9650','2013-08-16','19:05:00',1.82),('9650','2013-08-16','19:10:00',1.57),('9650','2013-08-16','19:15:00',1.44),('9650','2013-08-16','19:20:00',1.2),('9650','2013-08-16','19:25:00',1.03),('9650','2013-08-15','08:40:00',1.06),('9650','2013-08-15','08:45:00',1.2),('9650','2013-08-15','08:50:00',1.31),('9650','2013-08-15','08:55:00',1.45),('9650','2013-08-15','09:00:00',1.58),('9650','2013-08-15','09:05:00',1.71),('9650','2013-08-15','09:10:00',1.83),('9650','2013-08-15','09:15:00',1.96),('9650','2013-08-15','09:20:00',2.09),('9650','2013-08-15','09:25:00',2.23),('9650','2013-08-15','09:30:00',2.36),('9650','2013-08-15','09:35:00',2.51),('9650','2013-08-15','09:40:00',2.65),('9650','2013-08-15','09:45:00',2.78),('9650','2013-08-15','09:50:00',2.91),('9650','2013-08-15','09:55:00',3.03),('9650','2013-08-15','10:00:00',3.15),('9650','2013-08-15','10:05:00',3.28),('9650','2013-08-15','10:10:00',3.39),('9650','2013-08-15','10:15:00',3.51),('9650','2013-08-15','10:20:00',3.62),('9650','2013-08-15','10:25:00',3.74),('9650','2013-08-15','10:30:00',3.86),('9650','2013-08-15','10:35:00',3.96),('9650','2013-08-15','10:40:00',4.08),('9650','2013-08-15','10:45:00',4.19),('9650','2013-08-15','10:50:00',4.3),('9650','2013-08-15','10:55:00',4.41),('9650','2013-08-15','11:00:00',4.5),('9650','2013-08-15','11:05:00',4.61),('9650','2013-08-15','11:10:00',4.7),('9650','2013-08-15','11:15:00',4.81),('9650','2013-08-15','11:20:00',4.9),('9650','2013-08-15','11:25:00',4.97),('9650','2013-08-15','11:30:00',5.06),('9650','2013-08-15','11:35:00',5.16),('9650','2013-08-15','11:40:00',5.25),('9650','2013-08-15','11:45:00',5.3),('9650','2013-08-15','11:50:00',5.38),('9650','2013-08-15','11:55:00',5.44),('9650','2013-08-15','12:00:00',5.51),('9650','2013-08-15','12:05:00',5.62),('9650','2013-08-15','12:10:00',5.67),('9650','2013-08-15','12:15:00',5.71),('9650','2013-08-15','12:20:00',5.77),('9650','2013-08-15','12:25:00',5.85),('9650','2013-08-15','12:30:00',5.9),('9650','2013-08-15','12:35:00',5.96),('9650','2013-08-15','12:40:00',5.97),('9650','2013-08-15','12:45:00',5.86),('9650','2013-08-15','12:50:00',6.04),('9650','2013-08-15','12:55:00',6.08),('9650','2013-08-15','13:00:00',6.11),('9650','2013-08-15','13:05:00',6.13),('9650','2013-08-15','13:10:00',6.16),('9650','2013-08-15','13:15:00',6.2),('9650','2013-08-15','13:20:00',6.25),('9650','2013-08-15','13:25:00',6.3),('9650','2013-08-15','13:30:00',6.3),('9650','2013-08-15','13:35:00',6.32),('9650','2013-08-15','13:40:00',6.33),('9650','2013-08-15','13:45:00',6.34),('9650','2013-08-15','13:50:00',6.4),('9650','2013-08-15','13:55:00',6.41),('9650','2013-08-15','14:00:00',6.42),('9650','2013-08-15','14:05:00',6.43),('9650','2013-08-15','14:10:00',6.47),('9650','2013-08-15','14:15:00',6.45),('9650','2013-08-15','14:20:00',6.46),('9650','2013-08-15','14:25:00',6.45),('9650','2013-08-15','14:30:00',6.44),('9650','2013-08-15','14:35:00',6.41),('9650','2013-08-15','14:40:00',6.42),('9650','2013-08-15','14:45:00',6.43),('9650','2013-08-15','14:50:00',6.41),('9650','2013-08-15','14:55:00',6.37),('9650','2013-08-15','15:00:00',6.35),('9650','2013-08-15','15:05:00',6.28),('9650','2013-08-15','15:10:00',6.3),('9650','2013-08-15','15:15:00',6.25),('9650','2013-08-15','15:20:00',6.32),('9650','2013-08-15','15:25:00',6.31),('9650','2013-08-15','15:30:00',6.29),('9650','2013-08-15','15:35:00',6.26),('9650','2013-08-15','15:40:00',6.22),('9650','2013-08-15','15:45:00',6.19),('9650','2013-08-15','15:50:00',6.15),('9650','2013-08-15','15:55:00',6.11),('9650','2013-08-15','16:00:00',6.05),('9650','2013-08-15','16:05:00',5.97),('9650','2013-08-15','16:10:00',5.95),('9650','2013-08-15','16:15:00',5.89),('9650','2013-08-15','16:20:00',5.8),('9650','2013-08-15','16:25:00',5.74),('9650','2013-08-15','16:30:00',5.73),('9650','2013-08-15','16:35:00',5.67),('9650','2013-08-15','16:40:00',5.59),('9650','2013-08-15','16:45:00',5.56),('9650','2013-08-15','16:50:00',5.45),('9650','2013-08-15','16:55:00',5.37),('9650','2013-08-15','17:00:00',5.24),('9650','2013-08-15','17:05:00',5.15),('9650','2013-08-15','17:10:00',5.05),('9650','2013-08-15','17:15:00',4.93),('9650','2013-08-15','17:20:00',4.79),('9650','2013-08-15','17:25:00',4.68),('9650','2013-08-15','17:30:00',4.6),('9650','2013-08-15','17:35:00',4.52),('9650','2013-08-15','17:40:00',4.39),('9650','2013-08-15','17:45:00',4.28),('9650','2013-08-15','17:50:00',4.14),('9650','2013-08-15','17:55:00',3.98),('9650','2013-08-15','18:00:00',3.85),('9650','2013-08-15','18:05:00',3.72),('9650','2013-08-15','18:10:00',3.61),('9650','2013-08-15','18:15:00',3.48),('9650','2013-08-15','18:20:00',3.35),('9650','2013-08-15','18:25:00',3.2),('9650','2013-08-15','18:30:00',2.87),('9650','2013-08-15','18:35:00',1.99),('9650','2013-08-15','18:40:00',1.59),('9650','2013-08-15','18:45:00',1.22),('9650','2013-08-15','18:50:00',2.27),('9650','2013-08-15','18:55:00',2.15),('9650','2013-08-15','19:00:00',1.94),('9650','2013-08-15','19:05:00',1.61),('9650','2013-08-15','19:10:00',1.31),('9650','2013-08-14','08:35:00',1),('9650','2013-08-14','08:40:00',1.07),('9650','2013-08-14','08:45:00',1.13),('9650','2013-08-14','08:50:00',1.17),('9650','2013-08-14','08:55:00',1.2),('9650','2013-08-14','09:00:00',1.68),('9650','2013-08-14','09:05:00',1.79),('9650','2013-08-14','09:10:00',1.27),('9650','2013-08-14','09:15:00',1.69),('9650','2013-08-14','09:20:00',2.29),('9650','2013-08-14','09:25:00',2.28),('9650','2013-08-14','09:30:00',2.4),('9650','2013-08-14','09:35:00',2.54),('9650','2013-08-14','09:40:00',2.69),('9650','2013-08-14','09:45:00',2.81),('9650','2013-08-14','09:50:00',2.94),('9650','2013-08-14','09:55:00',3.07),('9650','2013-08-14','10:00:00',3.2),('9650','2013-08-14','10:05:00',3.31),('9650','2013-08-14','10:10:00',3.42),('9650','2013-08-14','10:15:00',3.55),('9650','2013-08-14','10:20:00',3.68),('9650','2013-08-14','10:25:00',3.79),('9650','2013-08-14','10:30:00',3.93),('9650','2013-08-14','10:35:00',4.03),('9650','2013-08-14','10:40:00',4.13),('9650','2013-08-14','10:45:00',4.24),('9650','2013-08-14','10:50:00',4.23),('9650','2013-08-14','10:55:00',3.86),('9650','2013-08-14','11:00:00',3.59),('9650','2013-08-14','11:05:00',3.65),('9650','2013-08-14','11:10:00',2.82),('9650','2013-08-14','11:15:00',3.08),('9650','2013-08-14','11:20:00',3.69),('9650','2013-08-14','11:25:00',4.15),('9650','2013-08-14','11:30:00',4.59),('9650','2013-08-14','11:35:00',5.18),('9650','2013-08-14','11:40:00',5.54),('9650','2013-08-14','11:45:00',5.71),('9650','2013-08-14','11:50:00',5.88),('9650','2013-08-14','11:55:00',5.9),('9650','2013-08-14','12:00:00',5.99),('9650','2013-08-14','12:05:00',5.97),('9650','2013-08-14','12:10:00',5.97),('9650','2013-08-14','12:15:00',5.98),('9650','2013-08-14','12:20:00',6.06),('9650','2013-08-14','12:25:00',6.11),('9650','2013-08-14','12:30:00',6.14),('9650','2013-08-14','12:35:00',6.2),('9650','2013-08-14','12:40:00',6.22),('9650','2013-08-14','12:45:00',6.18),('9650','2013-08-14','12:50:00',6.24),('9650','2013-08-14','12:55:00',5.95),('9650','2013-08-14','13:00:00',6.02),('9650','2013-08-14','13:05:00',6.15),('9650','2013-08-14','13:10:00',6.21),('9650','2013-08-14','13:15:00',6.09),('9650','2013-08-14','13:20:00',5.93),('9650','2013-08-14','13:25:00',6.19),('9650','2013-08-14','13:30:00',6.39),('9650','2013-08-14','13:35:00',6.49),('9650','2013-08-14','13:40:00',6.54),('9650','2013-08-14','13:45:00',6.52),('9650','2013-08-14','13:50:00',6.52),('9650','2013-08-14','13:55:00',6.43),('9650','2013-08-14','14:00:00',6.48),('9650','2013-08-14','14:05:00',6.55),('9650','2013-08-14','14:10:00',6.56),('9650','2013-08-14','14:15:00',6.55),('9650','2013-08-14','14:20:00',6.58),('9650','2013-08-14','14:25:00',6.49),('9650','2013-08-14','14:30:00',6.39),('9650','2013-08-14','14:35:00',6.51),('9650','2013-08-14','14:40:00',6.49),('9650','2013-08-14','14:45:00',6.48),('9650','2013-08-14','14:50:00',6.24),('9650','2013-08-14','14:55:00',6.41),('9650','2013-08-14','15:00:00',6.34),('9650','2013-08-14','15:05:00',6.38),('9650','2013-08-14','15:10:00',6.36),('9650','2013-08-14','15:15:00',6.35),('9650','2013-08-14','15:20:00',6.26),('9650','2013-08-14','15:25:00',6.28),('9650','2013-08-14','15:30:00',6.22),('9650','2013-08-14','15:35:00',6.18),('9650','2013-08-14','15:40:00',6.14),('9650','2013-08-14','15:45:00',6.08),('9650','2013-08-14','15:50:00',5.99),('9650','2013-08-14','15:55:00',5.91),('9650','2013-08-14','16:00:00',5.86),('9650','2013-08-14','16:05:00',5.89),('9650','2013-08-14','16:10:00',5.76),('9650','2013-08-14','16:15:00',5.66),('9650','2013-08-14','16:20:00',5.69),('9650','2013-08-14','16:25:00',5.65),('9650','2013-08-14','16:30:00',5.47),('9650','2013-08-14','16:35:00',5.3),('9650','2013-08-14','16:40:00',5.31),('9650','2013-08-14','16:45:00',5.24),('9650','2013-08-14','16:50:00',5.15),('9650','2013-08-14','16:55:00',5.08),('9650','2013-08-14','17:00:00',5),('9650','2013-08-14','17:05:00',4.92),('9650','2013-08-14','17:10:00',4.76),('9650','2013-08-14','17:15:00',4.45),('9650','2013-08-14','17:20:00',4.46),('9650','2013-08-14','17:25:00',4),('9650','2013-08-14','17:30:00',4.45),('9650','2013-08-14','17:35:00',4.33),('9650','2013-08-14','17:40:00',4.19),('9650','2013-08-14','17:45:00',4.05),('9650','2013-08-14','17:50:00',3.95),('9650','2013-08-14','17:55:00',3.86),('9650','2013-08-14','18:00:00',3.7),('9650','2013-08-14','18:05:00',3.51),('9650','2013-08-14','18:10:00',3.27),('9650','2013-08-14','18:15:00',3.22),('9650','2013-08-14','18:20:00',3.12),('9650','2013-08-14','18:25:00',2.94),('9650','2013-08-14','18:30:00',2.81),('9650','2013-08-14','18:35:00',2.72),('9650','2013-08-14','18:40:00',2.6),('9650','2013-08-14','18:45:00',2.07),('9650','2013-08-14','18:50:00',1.2),('9650','2013-08-14','18:55:00',1.48),('9650','2013-08-14','19:00:00',1.49),('9650','2013-08-14','19:05:00',1.39),('9650','2013-08-13','08:35:00',1.09),('9650','2013-08-13','08:40:00',1.33),('9650','2013-08-13','08:45:00',1.35),('9650','2013-08-13','08:50:00',1.46),('9650','2013-08-13','08:55:00',1.62),('9650','2013-08-13','09:00:00',1.87),('9650','2013-08-13','09:05:00',1.8),('9650','2013-08-13','09:10:00',2.18),('9650','2013-08-13','09:15:00',2.37),('9650','2013-08-13','09:20:00',2.32),('9650','2013-08-13','09:25:00',2.33),('9650','2013-08-13','09:30:00',2.85),('9650','2013-08-13','09:35:00',2.98),('9650','2013-08-13','09:40:00',1.82),('9650','2013-08-13','09:45:00',1.61),('9650','2013-08-13','09:50:00',2.19),('9650','2013-08-13','09:55:00',3.47),('9650','2013-08-13','10:00:00',3.62),('9650','2013-08-13','10:05:00',3.38),('9650','2013-08-13','10:10:00',3.21),('9650','2013-08-13','10:15:00',1.62),('9650','2013-08-13','10:20:00',2.96),('9650','2013-08-13','10:25:00',4.6),('9650','2013-08-13','10:30:00',4.9),('9650','2013-08-13','10:35:00',4.83),('9650','2013-08-13','10:40:00',4.53),('9650','2013-08-13','10:45:00',1.75),('9650','2013-08-13','10:50:00',1.7),('9650','2013-08-13','10:55:00',1.76),('9650','2013-08-13','11:00:00',2.2),('9650','2013-08-13','11:05:00',4.35),('9650','2013-08-13','11:10:00',4.35),('9650','2013-08-13','11:15:00',4.78),('9650','2013-08-13','11:20:00',3.27),('9650','2013-08-13','11:25:00',4.86),('9650','2013-08-13','11:30:00',6.03),('9650','2013-08-13','11:35:00',5.78),('9650','2013-08-13','11:40:00',4.06),('9650','2013-08-13','11:45:00',2.45),('9650','2013-08-13','11:50:00',4.43),('9650','2013-08-13','11:55:00',5.51),('9650','2013-08-13','12:00:00',5.51),('9650','2013-08-13','12:05:00',5.13),('9650','2013-08-13','12:10:00',4.64),('9650','2013-08-13','12:15:00',2.2),('9650','2013-08-13','12:20:00',1.92),('9650','2013-08-13','12:25:00',2.54),('9650','2013-08-13','12:30:00',2.15),('9650','2013-08-13','12:35:00',2.09),('9650','2013-08-13','12:40:00',2.35),('9650','2013-08-13','12:45:00',3.46),('9650','2013-08-13','12:50:00',3.74),('9650','2013-08-13','12:55:00',3.37),('9650','2013-08-13','13:00:00',3.94),('9650','2013-08-13','13:05:00',2.06),('9650','2013-08-13','13:10:00',1.82),('9650','2013-08-13','13:15:00',2.18),('9650','2013-08-13','13:20:00',2.03),('9650','2013-08-13','13:25:00',5.34),('9650','2013-08-13','13:30:00',5.38),('9650','2013-08-13','13:35:00',4.34),('9650','2013-08-13','13:40:00',5.98),('9650','2013-08-13','13:45:00',7.01),('9650','2013-08-13','13:50:00',7.09),('9650','2013-08-13','13:55:00',3.14),('9650','2013-08-13','14:00:00',7.58),('9650','2013-08-13','14:05:00',7.44),('9650','2013-08-13','14:10:00',6.23),('9650','2013-08-13','14:15:00',7.26),('9650','2013-08-13','14:20:00',6.13),('9650','2013-08-13','14:25:00',5.44),('9650','2013-08-13','14:30:00',6.64),('9650','2013-08-13','14:35:00',7.13),('9650','2013-08-13','14:40:00',6.83),('9650','2013-08-13','14:45:00',6.8),('9650','2013-08-13','14:50:00',6.76),('9650','2013-08-13','14:55:00',6.74),('9650','2013-08-13','15:00:00',6.56),('9650','2013-08-13','15:05:00',6.12),('9650','2013-08-13','15:10:00',6.42),('9650','2013-08-13','15:15:00',6.67),('9650','2013-08-13','15:20:00',6.59),('9650','2013-08-13','15:25:00',6.52),('9650','2013-08-13','15:30:00',6.39),('9650','2013-08-13','15:35:00',6.32),('9650','2013-08-13','15:40:00',6.38),('9650','2013-08-13','15:45:00',6.3),('9650','2013-08-13','15:50:00',6.25),('9650','2013-08-13','15:55:00',6.21),('9650','2013-08-13','16:00:00',6.13),('9650','2013-08-13','16:05:00',6.07),('9650','2013-08-13','16:10:00',6.08),('9650','2013-08-13','16:15:00',6.14),('9650','2013-08-13','16:20:00',6.07),('9650','2013-08-13','16:25:00',5.97),('9650','2013-08-13','16:30:00',5.91),('9650','2013-08-13','16:35:00',5.88),('9650','2013-08-13','16:40:00',5.82),('9650','2013-08-13','16:45:00',5.71),('9650','2013-08-13','16:50:00',5.59),('9650','2013-08-13','16:55:00',5.55),('9650','2013-08-13','17:00:00',5.38),('9650','2013-08-13','17:05:00',5.28),('9650','2013-08-13','17:10:00',5.18),('9650','2013-08-13','17:15:00',5.07),('9650','2013-08-13','17:20:00',4.95),('9650','2013-08-13','17:25:00',4.86),('9650','2013-08-13','17:30:00',4.67),('9650','2013-08-13','17:35:00',4.65),('9650','2013-08-13','17:40:00',4.57),('9650','2013-08-13','17:45:00',4.33),('9650','2013-08-13','17:50:00',4.29),('9650','2013-08-13','17:55:00',4.12),('9650','2013-08-13','18:00:00',3.96),('9650','2013-08-13','18:05:00',3.85),('9650','2013-08-13','18:10:00',3.62),('9650','2013-08-13','18:15:00',3.47),('9650','2013-08-13','18:20:00',3.41),('9650','2013-08-13','18:25:00',3.45),('9650','2013-08-13','18:30:00',3.28),('9650','2013-08-13','18:35:00',3.01),('9650','2013-08-13','18:40:00',2.79),('9650','2013-08-13','18:45:00',2.84),('9650','2013-08-13','18:50:00',2.8),('9650','2013-08-13','18:55:00',2.58),('9650','2013-08-13','19:00:00',2.36),('9650','2013-08-13','19:05:00',2.02),('9650','2013-08-13','19:10:00',1.68),('9650','2013-08-13','19:15:00',1.31),('9650','2013-08-13','19:20:00',1.03),('9650','2013-08-12','08:35:00',1.08),('9650','2013-08-12','08:40:00',1.16),('9650','2013-08-12','08:45:00',1.27),('9650','2013-08-12','08:50:00',1.42),('9650','2013-08-12','08:55:00',1.56),('9650','2013-08-12','09:00:00',1.69),('9650','2013-08-12','09:05:00',1.8),('9650','2013-08-12','09:10:00',1.94),('9650','2013-08-12','09:15:00',2.09),('9650','2013-08-12','09:20:00',2.22),('9650','2013-08-12','09:25:00',2.34),('9650','2013-08-12','09:30:00',2.47),('9650','2013-08-12','09:35:00',1.23),('9650','2013-08-12','09:40:00',2.67),('9650','2013-08-12','09:45:00',2.78),('9650','2013-08-12','09:50:00',2.28),('9650','2013-08-12','09:55:00',3),('9650','2013-08-12','10:00:00',3.3),('9650','2013-08-12','10:05:00',3.41),('9650','2013-08-12','10:10:00',3.47),('9650','2013-08-12','10:15:00',3.53),('9650','2013-08-12','10:20:00',3.7),('9650','2013-08-12','10:25:00',3.8),('9650','2013-08-12','10:30:00',3.89),('9650','2013-08-12','10:35:00',4.05),('9650','2013-08-12','10:40:00',4.03),('9650','2013-08-12','10:45:00',4.14),('9650','2013-08-12','10:50:00',4.34),('9650','2013-08-12','10:55:00',4.44),('9650','2013-08-12','11:00:00',4.55),('9650','2013-08-12','11:05:00',4.66),('9650','2013-08-12','11:10:00',4.71),('9650','2013-08-12','11:15:00',4.79),('9650','2013-08-12','11:20:00',4.9),('9650','2013-08-12','11:25:00',4.94),('9650','2013-08-12','11:30:00',5.05),('9650','2013-08-12','11:35:00',5.1),('9650','2013-08-12','11:40:00',5.2),('9650','2013-08-12','11:45:00',5.31),('9650','2013-08-12','11:50:00',5.41),('9650','2013-08-12','11:55:00',5.58),('9650','2013-08-12','12:00:00',5.59),('9650','2013-08-12','12:05:00',5.65),('9650','2013-08-12','12:10:00',5.79),('9650','2013-08-12','12:15:00',5.98),('9650','2013-08-12','12:20:00',6.14),('9650','2013-08-12','12:25:00',6.29),('9650','2013-08-12','12:30:00',6.39),('9650','2013-08-12','12:35:00',6.41),('9650','2013-08-12','12:40:00',2.93),('9650','2013-08-12','12:45:00',2.25),('9650','2013-08-12','12:50:00',3.81),('9650','2013-08-12','12:55:00',3.53),('9650','2013-08-12','13:00:00',2.03),('9650','2013-08-12','13:05:00',2.3),('9650','2013-08-12','13:10:00',5.94),('9650','2013-08-12','13:15:00',6.67),('9650','2013-08-12','13:20:00',6.8),('9650','2013-08-12','13:25:00',5.88),('9650','2013-08-12','13:30:00',7.05),('9650','2013-08-12','13:35:00',7.07),('9650','2013-08-12','13:40:00',6.17),('9650','2013-08-12','13:45:00',4.02),('9650','2013-08-12','13:50:00',2.26),('9650','2013-08-12','13:55:00',5.33),('9650','2013-08-12','14:00:00',6.34),('9650','2013-08-12','14:05:00',4.41),('9650','2013-08-12','14:10:00',7.3),('9650','2013-08-12','14:15:00',6.53),('9650','2013-08-12','14:20:00',6.68),('9650','2013-08-12','14:25:00',4.93),('9650','2013-08-12','14:30:00',7.03),('9650','2013-08-12','14:35:00',6.78),('9650','2013-08-12','14:40:00',4.94),('9650','2013-08-12','14:45:00',3.65),('9650','2013-08-12','14:50:00',6.72),('9650','2013-08-12','14:55:00',6.61),('9650','2013-08-12','15:00:00',6.75),('9650','2013-08-12','15:05:00',4.84),('9650','2013-08-12','15:10:00',6.65),('9650','2013-08-12','15:15:00',5.42),('9650','2013-08-12','15:20:00',6.11),('9650','2013-08-12','15:25:00',6.66),('9650','2013-08-12','15:30:00',6.22),('9650','2013-08-12','15:35:00',6.54),('9650','2013-08-12','15:40:00',6.42),('9650','2013-08-12','15:45:00',6.46),('9650','2013-08-12','15:50:00',6.3),('9650','2013-08-12','15:55:00',6.17),('9650','2013-08-12','16:00:00',6.22),('9650','2013-08-12','16:05:00',6.16),('9650','2013-08-12','16:10:00',6.08),('9650','2013-08-12','16:15:00',6.03),('9650','2013-08-12','16:20:00',5.99),('9650','2013-08-12','16:25:00',5.94),('9650','2013-08-12','16:30:00',5.86),('9650','2013-08-12','16:35:00',5.79),('9650','2013-08-12','16:40:00',5.67),('9650','2013-08-12','16:45:00',5.59),('9650','2013-08-12','16:50:00',5.56),('9650','2013-08-12','16:55:00',5.47),('9650','2013-08-12','17:00:00',5.4),('9650','2013-08-12','17:05:00',5.28),('9650','2013-08-12','17:10:00',5.2),('9650','2013-08-12','17:15:00',5.06),('9650','2013-08-12','17:20:00',4.96),('9650','2013-08-12','17:25:00',4.85),('9650','2013-08-12','17:30:00',4.72),('9650','2013-08-12','17:35:00',4.61),('9650','2013-08-12','17:40:00',4.54),('9650','2013-08-12','17:45:00',4.37),('9650','2013-08-12','17:50:00',4.29),('9650','2013-08-12','17:55:00',4.14),('9650','2013-08-12','18:00:00',3.97),('9650','2013-08-12','18:05:00',3.85),('9650','2013-08-12','18:10:00',3.69),('9650','2013-08-12','18:15:00',3.55),('9650','2013-08-12','18:20:00',3.44),('9650','2013-08-12','18:25:00',3.26),('9650','2013-08-12','18:30:00',3.09),('9650','2013-08-12','18:35:00',2.93),('9650','2013-08-12','18:40:00',2.76),('9650','2013-08-12','18:45:00',2.59),('9650','2013-08-12','18:50:00',2.44),('9650','2013-08-12','18:55:00',2.28),('9650','2013-08-12','19:00:00',2.06),('9650','2013-08-12','19:05:00',1.89),('9650','2013-08-12','19:10:00',1.71),('9650','2013-08-12','19:15:00',1.57),('9650','2013-08-12','19:20:00',1.37),('9650','2013-08-12','19:25:00',1.17),('9650','2013-08-11','08:30:00',1.01),('9650','2013-08-11','08:35:00',1.07),('9650','2013-08-11','08:40:00',1.12),('9650','2013-08-11','08:45:00',1.17),('9650','2013-08-11','08:50:00',1.19),('9650','2013-08-11','08:55:00',1.22),('9650','2013-08-11','09:00:00',1.65),('9650','2013-08-11','09:05:00',1.82),('9650','2013-08-11','09:10:00',1.94),('9650','2013-08-11','09:15:00',2.07),('9650','2013-08-11','09:20:00',2.2),('9650','2013-08-11','09:25:00',2.34),('9650','2013-08-11','09:30:00',2.46),('9650','2013-08-11','09:35:00',2.6),('9650','2013-08-11','09:40:00',2.73),('9650','2013-08-11','09:45:00',2.86),('9650','2013-08-11','09:50:00',2.96),('9650','2013-08-11','09:55:00',3.09),('9650','2013-08-11','10:00:00',3.2),('9650','2013-08-11','10:05:00',3.31),('9650','2013-08-11','10:10:00',3.42),('9650','2013-08-11','10:15:00',3.53),('9650','2013-08-11','10:20:00',3.66),('9650','2013-08-11','10:25:00',3.76),('9650','2013-08-11','10:30:00',3.84),('9650','2013-08-11','10:35:00',3.95),('9650','2013-08-11','10:40:00',4.07),('9650','2013-08-11','10:45:00',4.17),('9650','2013-08-11','10:50:00',4.25),('9650','2013-08-11','10:55:00',4.35),('9650','2013-08-11','11:00:00',4.46),('9650','2013-08-11','11:05:00',4.54),('9650','2013-08-11','11:10:00',4.65),('9650','2013-08-11','11:15:00',4.73),('9650','2013-08-11','11:20:00',4.82),('9650','2013-08-11','11:25:00',4.95),('9650','2013-08-11','11:30:00',5.07),('9650','2013-08-11','11:35:00',5.19),('9650','2013-08-11','11:40:00',5.28),('9650','2013-08-11','11:45:00',5.37),('9650','2013-08-11','11:50:00',5.52),('9650','2013-08-11','11:55:00',5.66),('9650','2013-08-11','12:00:00',5.77),('9650','2013-08-11','12:05:00',5.86),('9650','2013-08-11','12:10:00',5.89),('9650','2013-08-11','12:15:00',5.61),('9650','2013-08-11','12:20:00',2.76),('9650','2013-08-11','12:25:00',4.99),('9650','2013-08-11','12:30:00',2.05),('9650','2013-08-11','12:35:00',4.83),('9650','2013-08-11','12:40:00',4.62),('9650','2013-08-11','12:45:00',3.39),('9650','2013-08-11','12:50:00',1.93),('9650','2013-08-11','12:55:00',3),('9650','2013-08-11','13:00:00',1.45),('9650','2013-08-11','13:05:00',1.3),('9650','2013-08-11','13:10:00',1.44),('9650','2013-08-11','13:15:00',1.72),('9650','2013-08-11','13:20:00',2.09),('9650','2013-08-11','13:25:00',2.58),('9650','2013-08-11','13:30:00',2.34),('9650','2013-08-11','13:35:00',2.27),('9650','2013-08-11','13:40:00',2.01),('9650','2013-08-11','13:45:00',2.1),('9650','2013-08-11','13:50:00',7.17),('9650','2013-08-11','13:55:00',6.27),('9650','2013-08-11','14:00:00',3.51),('9650','2013-08-11','14:05:00',4.37),('9650','2013-08-11','14:10:00',3.64),('9650','2013-08-11','14:15:00',1.98),('9650','2013-08-11','14:20:00',1.67),('9650','2013-08-11','14:25:00',1.39),('9650','2013-08-11','14:30:00',1.59),('9650','2013-08-11','14:35:00',2.04),('9650','2013-08-11','14:40:00',2.69),('9650','2013-08-11','14:45:00',2.71),('9650','2013-08-11','14:50:00',2.98),('9650','2013-08-11','14:55:00',7.69),('9650','2013-08-11','15:00:00',7.68),('9650','2013-08-11','15:05:00',6.96),('9650','2013-08-11','15:10:00',5.62),('9650','2013-08-11','15:15:00',4.22),('9650','2013-08-11','15:20:00',6.1),('9650','2013-08-11','15:25:00',6.65),('9650','2013-08-11','15:30:00',6.65),('9650','2013-08-11','15:35:00',6.41),('9650','2013-08-11','15:40:00',6.46),('9650','2013-08-11','15:45:00',6.34),('9650','2013-08-11','15:50:00',6.35),('9650','2013-08-11','15:55:00',6.2),('9650','2013-08-11','16:00:00',6.13),('9650','2013-08-11','16:05:00',6.01),('9650','2013-08-11','16:10:00',5.94),('9650','2013-08-11','16:15:00',5.87),('9650','2013-08-11','16:20:00',5.85),('9650','2013-08-11','16:25:00',5.85),('9650','2013-08-11','16:30:00',5.73),('9650','2013-08-11','16:35:00',5.7),('9650','2013-08-11','16:40:00',4.93),('9650','2013-08-11','16:45:00',5.45),('9650','2013-08-11','16:50:00',5.21),('9650','2013-08-11','16:55:00',5.42),('9650','2013-08-11','17:00:00',5.28),('9650','2013-08-11','17:05:00',5.18),('9650','2013-08-11','17:10:00',5.07),('9650','2013-08-11','17:15:00',4.94),('9650','2013-08-11','17:20:00',4.84),('9650','2013-08-11','17:25:00',4.76),('9650','2013-08-11','17:30:00',4.63),('9650','2013-08-11','17:35:00',4.52),('9650','2013-08-11','17:40:00',4.4),('9650','2013-08-11','17:45:00',4.24),('9650','2013-08-11','17:50:00',4.14),('9650','2013-08-11','17:55:00',4.05),('9650','2013-08-11','18:00:00',3.93),('9650','2013-08-11','18:05:00',3.8),('9650','2013-08-11','18:10:00',3.65),('9650','2013-08-11','18:15:00',3.51),('9650','2013-08-11','18:20:00',3.39),('9650','2013-08-11','18:25:00',3.27),('9650','2013-08-11','18:30:00',3.13),('9650','2013-08-11','18:35:00',2.95),('9650','2013-08-11','18:40:00',2.81),('9650','2013-08-11','18:45:00',2.67),('9650','2013-08-11','18:50:00',2.51),('9650','2013-08-11','18:55:00',2.32),('9650','2013-08-11','19:00:00',2.14),('9650','2013-08-11','19:05:00',1.95),('9650','2013-08-11','19:10:00',1.75),('9650','2013-08-11','19:15:00',1.57),('9650','2013-08-11','19:20:00',1.39),('9650','2013-08-11','19:25:00',1.2),('9650','2013-08-11','19:30:00',1.02),('9650','2013-08-10','08:30:00',1.02),('9650','2013-08-10','08:35:00',1.1),('9650','2013-08-10','08:40:00',1.19),('9650','2013-08-10','08:45:00',1.3),('9650','2013-08-10','08:50:00',1.46),('9650','2013-08-10','08:55:00',1.61),('9650','2013-08-10','09:00:00',1.75),('9650','2013-08-10','09:05:00',1.86),('9650','2013-08-10','09:10:00',1.99),('9650','2013-08-10','09:15:00',2.11),('9650','2013-08-10','09:20:00',2.24),('9650','2013-08-10','09:25:00',2.4),('9650','2013-08-10','09:30:00',2.52),('9650','2013-08-10','09:35:00',2.65),('9650','2013-08-10','09:40:00',2.79),('9650','2013-08-10','09:45:00',2.93),('9650','2013-08-10','09:50:00',3.04),('9650','2013-08-10','09:55:00',3.16),('9650','2013-08-10','10:00:00',3.29),('9650','2013-08-10','10:05:00',3.42),('9650','2013-08-10','10:10:00',3.53),('9650','2013-08-10','10:15:00',3.67),('9650','2013-08-10','10:20:00',3.77),('9650','2013-08-10','10:25:00',3.88),('9650','2013-08-10','10:30:00',4.01),('9650','2013-08-10','10:35:00',4.09),('9650','2013-08-10','10:40:00',4.2),('9650','2013-08-10','10:45:00',4.31),('9650','2013-08-10','10:50:00',4.42),('9650','2013-08-10','10:55:00',4.52),('9650','2013-08-10','11:00:00',4.64),('9650','2013-08-10','11:05:00',4.74),('9650','2013-08-10','11:10:00',4.86),('9650','2013-08-10','11:15:00',4.91),('9650','2013-08-10','11:20:00',5),('9650','2013-08-10','11:25:00',5.09),('9650','2013-08-10','11:30:00',5.2),('9650','2013-08-10','11:35:00',5.26),('9650','2013-08-10','11:40:00',5.35),('9650','2013-08-10','11:45:00',5.42),('9650','2013-08-10','11:50:00',5.47),('9650','2013-08-10','11:55:00',5.57),('9650','2013-08-10','12:00:00',5.65),('9650','2013-08-10','12:05:00',5.7),('9650','2013-08-10','12:10:00',5.78),('9650','2013-08-10','12:15:00',5.84),('9650','2013-08-10','12:20:00',5.9),('9650','2013-08-10','12:25:00',5.96),('9650','2013-08-10','12:30:00',6.03),('9650','2013-08-10','12:35:00',6.09),('9650','2013-08-10','12:40:00',6.1),('9650','2013-08-10','12:45:00',6.15),('9650','2013-08-10','12:50:00',6.14),('9650','2013-08-10','12:55:00',6.21),('9650','2013-08-10','13:00:00',6.24),('9650','2013-08-10','13:05:00',6.3),('9650','2013-08-10','13:10:00',6.33),('9650','2013-08-10','13:15:00',6.31),('9650','2013-08-10','13:20:00',6.3),('9650','2013-08-10','13:25:00',6.38),('9650','2013-08-10','13:30:00',6.42),('9650','2013-08-10','13:35:00',6.47),('9650','2013-08-10','13:40:00',6.5),('9650','2013-08-10','13:45:00',6.52),('9650','2013-08-10','13:50:00',6.52),('9650','2013-08-10','13:55:00',6.52),('9650','2013-08-10','14:00:00',6.52),('9650','2013-08-10','14:05:00',6.58),('9650','2013-08-10','14:10:00',6.59),('9650','2013-08-10','14:15:00',6.59),('9650','2013-08-10','14:20:00',6.46),('9650','2013-08-10','14:25:00',6.52),('9650','2013-08-10','14:30:00',6.52),('9650','2013-08-10','14:35:00',6.36),('9650','2013-08-10','14:40:00',6.54),('9650','2013-08-10','14:45:00',6.63),('9650','2013-08-10','14:50:00',6.53),('9650','2013-08-10','14:55:00',6.44),('9650','2013-08-10','15:00:00',5.2),('9650','2013-08-10','15:05:00',6.05),('9650','2013-08-10','15:10:00',6.5),('9650','2013-08-10','15:15:00',6.41),('9650','2013-08-10','15:20:00',5.75),('9650','2013-08-10','15:25:00',6.34),('9650','2013-08-10','15:30:00',5.05),('9650','2013-08-10','15:35:00',6.11),('9650','2013-08-10','15:40:00',6.24),('9650','2013-08-10','15:45:00',6.21),('9650','2013-08-10','15:50:00',6.21),('9650','2013-08-10','15:55:00',6.22),('9650','2013-08-10','16:00:00',6.15),('9650','2013-08-10','16:05:00',6.11),('9650','2013-08-10','16:10:00',6.04),('9650','2013-08-10','16:15:00',5.99),('9650','2013-08-10','16:20:00',5.9),('9650','2013-08-10','16:25:00',5.82),('9650','2013-08-10','16:30:00',5.73),('9650','2013-08-10','16:35:00',5.71),('9650','2013-08-10','16:40:00',5.62),('9650','2013-08-10','16:45:00',5.53),('9650','2013-08-10','16:50:00',5.43),('9650','2013-08-10','16:55:00',5.35),('9650','2013-08-10','17:00:00',5.26),('9650','2013-08-10','17:05:00',5.12),('9650','2013-08-10','17:10:00',5.05),('9650','2013-08-10','17:15:00',4.97),('9650','2013-08-10','17:20:00',4.86),('9650','2013-08-10','17:25:00',4.75),('9650','2013-08-10','17:30:00',4.64),('9650','2013-08-10','17:35:00',4.51),('9650','2013-08-10','17:40:00',4.42),('9650','2013-08-10','17:45:00',4.2),('9650','2013-08-10','17:50:00',4.17),('9650','2013-08-10','17:55:00',4.03),('9650','2013-08-10','18:00:00',3.89),('9650','2013-08-10','18:05:00',3.76),('9650','2013-08-10','18:10:00',3.48),('9650','2013-08-10','18:15:00',3.37),('9650','2013-08-10','18:20:00',3.31),('9650','2013-08-10','18:25:00',3.17),('9650','2013-08-10','18:30:00',3.05),('9650','2013-08-10','18:35:00',2.88),('9650','2013-08-10','18:40:00',2.72),('9650','2013-08-10','18:45:00',2.53),('9650','2013-08-10','18:50:00',2.36),('9650','2013-08-10','18:55:00',2.2),('9650','2013-08-10','19:00:00',2),('9650','2013-08-10','19:05:00',1.81),('9650','2013-08-10','19:10:00',1.59),('9650','2013-08-10','19:15:00',1.41),('9650','2013-08-10','19:20:00',1.23),('9650','2013-08-10','19:25:00',1.06),('9650','2013-08-09','08:35:00',1.06),('9650','2013-08-09','08:40:00',1.16),('9650','2013-08-09','08:45:00',1.25),('9650','2013-08-09','08:50:00',1.43),('9650','2013-08-09','08:55:00',1.6),('9650','2013-08-09','09:00:00',1.74),('9650','2013-08-09','09:05:00',1.87),('9650','2013-08-09','09:10:00',1.99),('9650','2013-08-09','09:15:00',2.13),('9650','2013-08-09','09:20:00',2.26),('9650','2013-08-09','09:25:00',2.42),('9650','2013-08-09','09:30:00',2.56),('9650','2013-08-09','09:35:00',2.68),('9650','2013-08-09','09:40:00',2.83),('9650','2013-08-09','09:45:00',2.92),('9650','2013-08-09','09:50:00',3.08),('9650','2013-08-09','09:55:00',3.18),('9650','2013-08-09','10:00:00',3.31),('9650','2013-08-09','10:05:00',3.43),('9650','2013-08-09','10:10:00',3.21),('9650','2013-08-09','10:20:00',3.26),('9650','2013-08-09','10:25:00',3.88),('9650','2013-08-09','10:30:00',4.02),('9650','2013-08-09','10:35:00',4.13),('9650','2013-08-09','10:40:00',4.23),('9650','2013-08-09','10:45:00',4.36),('9650','2013-08-09','10:50:00',4.46),('9650','2013-08-09','10:55:00',4.61),('9650','2013-08-09','11:00:00',4.81),('9650','2013-08-09','11:05:00',4.89),('9650','2013-08-09','11:10:00',5.08),('9650','2013-08-09','11:15:00',4.9),('9650','2013-08-09','11:20:00',4.49),('9650','2013-08-09','11:25:00',3.66),('9650','2013-08-09','11:30:00',4.9),('9650','2013-08-09','11:35:00',4.98),('9650','2013-08-09','11:40:00',5.46),('9650','2013-08-09','11:45:00',5.53),('9650','2013-08-09','11:50:00',5.59),('9650','2013-08-09','11:55:00',5.68),('9650','2013-08-09','12:00:00',5.76),('9650','2013-08-09','12:05:00',5.83),('9650','2013-08-09','12:10:00',5.89),('9650','2013-08-09','12:15:00',5.95),('9650','2013-08-09','12:20:00',5.95),('9650','2013-08-09','12:25:00',6.07),('9650','2013-08-09','12:30:00',6.13),('9650','2013-08-09','12:35:00',6.19),('9650','2013-08-09','12:40:00',6.29),('9650','2013-08-09','12:45:00',6.46),('9650','2013-08-09','12:50:00',6.64),('9650','2013-08-09','12:55:00',6.57),('9650','2013-08-09','13:00:00',6.55),('9650','2013-08-09','13:05:00',6.51),('9650','2013-08-09','13:10:00',6.69),('9650','2013-08-09','13:15:00',6.98),('9650','2013-08-09','13:20:00',7.12),('9650','2013-08-09','13:25:00',7.31),('9650','2013-08-09','13:30:00',7.51),('9650','2013-08-09','13:35:00',5.09),('9650','2013-08-09','13:40:00',2.03),('9650','2013-08-09','13:45:00',1.21),('9650','2013-08-09','13:50:00',6.54),('9650','2013-08-09','13:55:00',7.1),('9650','2013-08-09','14:00:00',7.44),('9650','2013-08-09','14:05:00',6.78),('9650','2013-08-09','14:10:00',8.03),('9650','2013-08-09','14:15:00',7.88),('9650','2013-08-09','14:20:00',4.83),('9650','2013-08-09','14:25:00',2.22),('9650','2013-08-09','14:30:00',2.1),('9650','2013-08-09','14:35:00',1.85),('9650','2013-08-09','14:40:00',1.69),('9650','2013-08-09','14:45:00',1.64),('9650','2013-08-09','14:50:00',1.54),('9650','2013-08-09','14:55:00',1.57),('9650','2013-08-09','15:00:00',1.79),('9650','2013-08-09','15:05:00',1.87),('9650','2013-08-09','15:10:00',1.97),('9650','2013-08-09','15:15:00',2.18),('9650','2013-08-09','15:20:00',2.12),('9650','2013-08-09','15:25:00',1.82),('9650','2013-08-09','15:30:00',1.78),('9650','2013-08-09','15:35:00',2.29),('9650','2013-08-09','15:40:00',2.23),('9650','2013-08-09','15:45:00',2.55),('9650','2013-08-09','15:50:00',3.18),('9650','2013-08-09','15:55:00',3.61),('9650','2013-08-09','16:00:00',4.46),('9650','2013-08-09','16:05:00',8.13),('9650','2013-08-09','16:10:00',4.5),('9650','2013-08-09','16:15:00',4.19),('9650','2013-08-09','16:20:00',6.84),('9650','2013-08-09','16:25:00',2.18),('9650','2013-08-09','16:30:00',3.35),('9650','2013-08-09','16:35:00',4.58),('9650','2013-08-09','16:40:00',5.68),('9650','2013-08-09','16:45:00',6.23),('9650','2013-08-09','16:50:00',5.88),('9650','2013-08-09','16:55:00',5.65),('9650','2013-08-09','17:00:00',4.94),('9650','2013-08-09','17:05:00',3.36),('9650','2013-08-09','17:10:00',2.14),('9650','2013-08-09','17:15:00',2.22),('9650','2013-08-09','17:20:00',2.96),('9650','2013-08-09','17:25:00',3.19),('9650','2013-08-09','17:30:00',1.83),('9650','2013-08-09','17:50:00',1.09),('9650','2013-08-09','17:55:00',2.33),('9650','2013-08-09','18:00:00',2.16),('9650','2013-08-09','18:25:00',1.04),('9650','2013-08-09','19:30:00',1.02),('9650','2014-04-08','08:05:00',1.11),('9650','2014-04-08','08:10:00',1.02),('9650','2014-04-08','08:30:00',1.26),('9650','2014-04-08','08:55:00',1.31),('9650','2014-04-08','09:00:00',1.39),('9650','2014-04-08','09:05:00',1.4),('9650','2014-04-08','09:10:00',1.39),('9650','2014-04-08','09:15:00',1.36),('9650','2014-04-08','09:20:00',1.41),('9650','2014-04-08','09:25:00',1.57),('9650','2014-04-08','09:30:00',1.59),('9650','2014-04-08','09:35:00',1.27),('9650','2014-04-08','09:40:00',1.07),('9650','2014-04-08','09:45:00',1.2),('9650','2014-04-08','09:50:00',1.98),('9650','2014-04-08','09:55:00',2.74),('9650','2014-04-08','10:00:00',2.84),('9650','2014-04-08','10:05:00',2.96),('9650','2014-04-08','10:10:00',3.23),('9650','2014-04-08','10:15:00',3.46),('9650','2014-04-08','10:20:00',3.7),('9650','2014-04-08','10:25:00',3.79),('9650','2014-04-08','10:30:00',4.25),('9650','2014-04-08','10:35:00',3.3),('9650','2014-04-08','10:40:00',2.19),('9650','2014-04-08','10:45:00',2.26),('9650','2014-04-08','10:50:00',2.07),('9650','2014-04-08','10:55:00',3.29),('9650','2014-04-08','11:00:00',4.61),('9650','2014-04-08','11:05:00',5.55),('9650','2014-04-08','11:10:00',5.67),('9650','2014-04-08','11:15:00',5.88),('9650','2014-04-08','11:20:00',4.94),('9650','2014-04-08','11:25:00',1.94),('9650','2014-04-08','11:30:00',1.62),('9650','2014-04-08','11:35:00',4.55),('9650','2014-04-08','11:40:00',6.24),('9650','2014-04-08','11:45:00',4.09),('9650','2014-04-08','11:50:00',6.12),('9650','2014-04-08','11:55:00',6.56),('9650','2014-04-08','12:00:00',6.83),('9650','2014-04-08','12:05:00',5.5),('9650','2014-04-08','12:10:00',4.47),('9650','2014-04-08','12:15:00',2.83),('9650','2014-04-08','12:20:00',2.13),('9650','2014-04-08','12:25:00',1.66),('9650','2014-04-08','12:30:00',1.43),('9650','2014-04-08','12:35:00',1.29),('9650','2014-04-08','12:40:00',1.21),('9650','2014-04-08','12:45:00',1.06),('9650','2014-04-08','12:50:00',1.07),('9650','2014-04-08','12:55:00',1.04),('9650','2014-04-08','13:10:00',1.2),('9650','2014-04-08','13:15:00',1.82),('9650','2014-04-08','13:20:00',2.73),('9650','2014-04-08','13:25:00',2.53),('9650','2014-04-08','13:30:00',2.17),('9650','2014-04-08','13:35:00',2.18),('9650','2014-04-08','13:40:00',1.85),('9650','2014-04-08','13:45:00',1.62),('9650','2014-04-08','13:50:00',1.58),('9650','2014-04-08','13:55:00',1.49),('9650','2014-04-08','14:00:00',1.84),('9650','2014-04-08','14:05:00',2.58),('9650','2014-04-08','14:10:00',2.89),('9650','2014-04-08','14:15:00',2.82),('9650','2014-04-08','14:20:00',2.58),('9650','2014-04-08','14:25:00',2.53),('9650','2014-04-08','14:30:00',3.09),('9650','2014-04-08','14:35:00',4.1),('9650','2014-04-08','14:40:00',3.17),('9650','2014-04-08','14:45:00',3.45),('9650','2014-04-08','14:50:00',3.67),('9650','2014-04-08','14:55:00',4.8),('9650','2014-04-08','15:00:00',5.95),('9650','2014-04-08','15:05:00',7.77),('9650','2014-04-08','15:10:00',6.74),('9650','2014-04-08','15:15:00',7.27),('9650','2014-04-08','15:20:00',7.67),('9650','2014-04-08','15:25:00',5.64),('9650','2014-04-08','15:30:00',4.21),('9650','2014-04-08','15:35:00',3.44),('9650','2014-04-08','15:40:00',4.89),('9650','2014-04-08','15:45:00',3.41),('9650','2014-04-08','15:50:00',2.4),('9650','2014-04-08','15:55:00',2.11),('9650','2014-04-08','16:00:00',2.55),('9650','2014-04-08','16:05:00',4.41),('9650','2014-04-08','16:10:00',5.85),('9650','2014-04-08','16:15:00',5.75),('9650','2014-04-08','16:20:00',5.61),('9650','2014-04-08','16:25:00',5.62),('9650','2014-04-08','16:30:00',6.21),('9650','2014-04-08','16:35:00',4.32),('9650','2014-04-08','16:40:00',4.26),('9650','2014-04-08','16:45:00',3.85),('9650','2014-04-08','16:50:00',4.88),('9650','2014-04-08','16:55:00',2.92),('9650','2014-04-08','17:00:00',3.49),('9650','2014-04-08','17:05:00',5.36),('9650','2014-04-08','17:10:00',4.29),('9650','2014-04-08','17:15:00',4.13),('9650','2014-04-08','17:20:00',4.08),('9650','2014-04-08','17:25:00',4.05),('9650','2014-04-08','17:30:00',3.11),('9650','2014-04-08','17:35:00',1.31),('9650','2014-04-08','17:40:00',1.4),('9650','2014-04-08','17:45:00',2.45),('9650','2014-04-08','17:50:00',2.29),('9650','2014-04-08','17:55:00',2.28),('9650','2014-04-08','18:00:00',1.94),('9650','2014-04-08','18:05:00',1.22),('9650','2014-04-08','18:10:00',1.6),('9650','2014-04-08','18:15:00',1.13),('9650','2013-08-08','08:00:00',1.12),('9650','2013-08-08','08:05:00',1.35),('9650','2013-08-08','08:10:00',1.24),('9650','2013-08-08','08:15:00',1.26),('9650','2013-08-08','08:20:00',1.25),('9650','2013-08-08','08:25:00',1.08),('9650','2013-08-08','08:30:00',1.03),('9650','2013-08-08','08:35:00',1.06),('9650','2013-08-08','08:40:00',1.29),('9650','2013-08-08','08:45:00',1.55),('9650','2013-08-08','08:50:00',1.68),('9650','2013-08-08','08:55:00',1.78),('9650','2013-08-08','09:00:00',1.96),('9650','2013-08-08','09:05:00',2.21),('9650','2013-08-08','09:10:00',2.21),('9650','2013-08-08','09:15:00',2.59),('9650','2013-08-08','09:20:00',2.42),('9650','2013-08-08','09:25:00',2.3),('9650','2013-08-08','09:30:00',2.63),('9650','2013-08-08','09:35:00',2.7),('9650','2013-08-08','09:40:00',2.31),('9650','2013-08-08','09:45:00',2.88),('9650','2013-08-08','09:50:00',2.59),('9650','2013-08-08','09:55:00',1.77),('9650','2013-08-08','10:00:00',2.44),('9650','2013-08-08','10:05:00',2.14),('9650','2013-08-08','10:10:00',2.59),('9650','2013-08-08','10:15:00',3.36),('9650','2013-08-08','10:20:00',3.37),('9650','2013-08-08','10:25:00',3.53),('9650','2013-08-08','10:30:00',3.14),('9650','2013-08-08','10:35:00',3.52),('9650','2013-08-08','10:40:00',3.85),('9650','2013-08-08','10:45:00',3.94),('9650','2013-08-08','10:50:00',3.98),('9650','2013-08-08','10:55:00',4.19),('9650','2013-08-08','11:00:00',4.31),('9650','2013-08-08','11:05:00',4.37),('9650','2013-08-08','11:10:00',4.45),('9650','2013-08-08','11:15:00',4.6),('9650','2013-08-08','11:20:00',4.69),('9650','2013-08-08','11:25:00',4.73),('9650','2013-08-08','11:30:00',4.81),('9650','2013-08-08','11:35:00',4.81),('9650','2013-08-08','11:40:00',4.94),('9650','2013-08-08','11:45:00',5.02),('9650','2013-08-08','11:50:00',5.01),('9650','2013-08-08','11:55:00',5.15),('9650','2013-08-08','12:00:00',5.23),('9650','2013-08-08','12:05:00',5.31),('9650','2013-08-08','12:10:00',5.31),('9650','2013-08-08','12:15:00',5.47),('9650','2013-08-08','12:20:00',5.7),('9650','2013-08-08','12:25:00',4.69),('9650','2013-08-08','12:30:00',3.72),('9650','2013-08-08','12:35:00',4.35),('9650','2013-08-08','12:40:00',5.99),('9650','2013-08-08','12:45:00',4.5),('9650','2013-08-08','12:50:00',3.93),('9650','2013-08-08','12:55:00',4.91),('9650','2013-08-08','13:00:00',2.15),('9650','2013-08-08','13:05:00',1.56),('9650','2013-08-08','13:10:00',1.47),('9650','2013-08-08','13:15:00',1.87),('9650','2013-08-08','13:20:00',2.56),('9650','2013-08-08','13:25:00',3.76),('9650','2013-08-08','13:30:00',3.21),('9650','2013-08-08','13:35:00',2.59),('9650','2013-08-08','13:40:00',2.54),('9650','2013-08-08','13:45:00',2.39),('9650','2013-08-08','13:50:00',2.56),('9650','2013-08-08','13:55:00',2.3),('9650','2013-08-08','14:00:00',2.2),('9650','2013-08-08','14:05:00',2.18),('9650','2013-08-08','14:10:00',2.51),('9650','2013-08-08','14:15:00',1.73),('9650','2013-08-08','14:20:00',1.55),('9650','2013-08-08','14:25:00',1.7),('9650','2013-08-08','14:30:00',1.76),('9650','2013-08-08','14:35:00',1.49),('9650','2013-08-08','14:40:00',1.15),('9650','2013-08-08','15:05:00',2.01),('9650','2013-08-08','15:10:00',4.92),('9650','2013-08-08','15:15:00',4.72),('9650','2013-08-08','15:20:00',2.82),('9650','2013-08-08','15:25:00',2.19),('9650','2013-08-08','15:30:00',2.21),('9650','2013-08-08','15:35:00',3.8),('9650','2013-08-08','15:40:00',3),('9650','2013-08-08','15:45:00',5.38),('9650','2013-08-08','15:50:00',3.97),('9650','2013-08-08','15:55:00',3.51),('9650','2013-08-08','16:00:00',2.16),('9650','2013-08-08','16:05:00',1.41),('9650','2013-08-08','16:10:00',1.18),('9650','2013-08-08','16:15:00',1.24),('9650','2013-08-08','16:20:00',1.26),('9650','2013-08-08','16:25:00',1.37),('9650','2013-08-08','16:35:00',1),('9650','2013-08-08','16:40:00',1.08),('9650','2013-08-08','16:45:00',1.2),('9650','2013-08-08','16:50:00',2.65),('9650','2013-08-08','16:55:00',4.86),('9650','2013-08-08','17:00:00',2.86),('9650','2013-08-08','17:05:00',3.65),('9650','2013-08-08','17:10:00',1.96),('9650','2013-08-08','17:15:00',1.42),('9650','2013-08-08','17:20:00',1.26),('9650','2013-08-08','17:25:00',1.38),('9650','2013-08-08','17:30:00',1.56),('9650','2013-08-08','17:35:00',1.6),('9650','2013-08-08','17:40:00',1.59),('9650','2013-08-08','17:45:00',1.48),('9650','2013-08-08','17:50:00',1.12),('9650','2013-08-08','18:15:00',1.02),('9650','2013-08-08','18:55:00',1.11),('9650','2013-08-08','19:00:00',1.85),('9650','2013-08-08','19:05:00',2.43),('9650','2013-08-08','19:10:00',2.46),('9650','2013-08-08','19:15:00',2.33),('9650','2013-08-08','19:20:00',2.37),('9650','2013-08-08','19:25:00',2.23),('9650','2013-08-08','19:30:00',1.01),('9650','2013-08-07','08:30:00',1.05),('9650','2013-08-07','08:35:00',1.14),('9650','2013-08-07','08:40:00',1.23),('9650','2013-08-07','08:45:00',1.29),('9650','2013-08-07','08:50:00',1.44),('9650','2013-08-07','08:55:00',1.56),('9650','2013-08-07','09:00:00',1.7),('9650','2013-08-07','09:05:00',1.82),('9650','2013-08-07','09:10:00',1.92),('9650','2013-08-07','09:15:00',2.03),('9650','2013-08-07','09:20:00',2.17),('9650','2013-08-07','09:25:00',2.31),('9650','2013-08-07','09:30:00',2.42),('9650','2013-08-07','09:35:00',2.54),('9650','2013-08-07','09:40:00',2.67),('9650','2013-08-07','09:45:00',2.79),('9650','2013-08-07','09:50:00',2.89),('9650','2013-08-07','09:55:00',3),('9650','2013-08-07','10:00:00',3.1),('9650','2013-08-07','10:05:00',3.21),('9650','2013-08-07','10:10:00',3.32),('9650','2013-08-07','10:15:00',3.44),('9650','2013-08-07','10:20:00',3.54),('9650','2013-08-07','10:25:00',3.64),('9650','2013-08-07','10:30:00',3.74),('9650','2013-08-07','10:35:00',3.85),('9650','2013-08-07','10:40:00',3.93),('9650','2013-08-07','10:45:00',4.03),('9650','2013-08-07','10:50:00',4.13),('9650','2013-08-07','10:55:00',4.24),('9650','2013-08-07','11:00:00',4.33),('9650','2013-08-07','11:05:00',4.41),('9650','2013-08-07','11:10:00',4.48),('9650','2013-08-07','11:15:00',4.58),('9650','2013-08-07','11:20:00',4.62),('9650','2013-08-07','11:25:00',4.71),('9650','2013-08-07','11:30:00',4.78),('9650','2013-08-07','11:35:00',4.84),('9650','2013-08-07','11:40:00',4.92),('9650','2013-08-07','11:45:00',4.99),('9650','2013-08-07','11:50:00',5.04),('9650','2013-08-07','11:55:00',5.1),('9650','2013-08-07','12:00:00',5.19),('9650','2013-08-07','12:05:00',5.22),('9650','2013-08-07','12:10:00',5.3),('9650','2013-08-07','12:15:00',5.28),('9650','2013-08-07','12:20:00',5.34),('9650','2013-08-07','12:25:00',5.41),('9650','2013-08-07','12:30:00',5.32),('9650','2013-08-07','12:35:00',5.54),('9650','2013-08-07','12:40:00',5.74),('9650','2013-08-07','12:45:00',5.77),('9650','2013-08-07','12:50:00',5.81),('9650','2013-08-07','12:55:00',5.81),('9650','2013-08-07','13:00:00',5.85),('9650','2013-08-07','13:05:00',5.88),('9650','2013-08-07','13:10:00',5.95),('9650','2013-08-07','13:15:00',5.96),('9650','2013-08-07','13:20:00',6.06),('9650','2013-08-07','13:25:00',6.11),('9650','2013-08-07','13:30:00',6.12),('9650','2013-08-07','13:35:00',6.16),('9650','2013-08-07','13:40:00',6.12),('9650','2013-08-07','13:45:00',6.18),('9650','2013-08-07','13:50:00',6.23),('9650','2013-08-07','13:55:00',6.21),('9650','2013-08-07','14:00:00',6.26),('9650','2013-08-07','14:05:00',6.26),('9650','2013-08-07','14:10:00',6.23),('9650','2013-08-07','14:15:00',6.22),('9650','2013-08-07','14:20:00',6.23),('9650','2013-08-07','14:25:00',6.25),('9650','2013-08-07','14:30:00',6.28),('9650','2013-08-07','14:35:00',6.25),('9650','2013-08-07','14:40:00',6.2),('9650','2013-08-07','14:45:00',6.21),('9650','2013-08-07','14:50:00',6.22),('9650','2013-08-07','14:55:00',6.18),('9650','2013-08-07','15:00:00',6.16),('9650','2013-08-07','15:05:00',6.14),('9650','2013-08-07','15:10:00',6.13),('9650','2013-08-07','15:15:00',6.1),('9650','2013-08-07','15:20:00',6.04),('9650','2013-08-07','15:25:00',5.99),('9650','2013-08-07','15:30:00',5.93),('9650','2013-08-07','15:35:00',5.93),('9650','2013-08-07','15:40:00',5.92),('9650','2013-08-07','15:45:00',5.86),('9650','2013-08-07','15:50:00',5.8),('9650','2013-08-07','15:55:00',5.75),('9650','2013-08-07','16:00:00',5.73),('9650','2013-08-07','16:05:00',5.71),('9650','2013-08-07','16:10:00',5.67),('9650','2013-08-07','16:15:00',5.63),('9650','2013-08-07','16:20:00',5.62),('9650','2013-08-07','16:25:00',5.57),('9650','2013-08-07','16:30:00',5.52),('9650','2013-08-07','16:35:00',5.49),('9650','2013-08-07','16:40:00',5.36),('9650','2013-08-07','16:45:00',5.31),('9650','2013-08-07','16:50:00',5.2),('9650','2013-08-07','16:55:00',5.15),('9650','2013-08-07','17:00:00',4.99),('9650','2013-08-07','17:05:00',4.86),('9650','2013-08-07','17:10:00',4.77),('9650','2013-08-07','17:15:00',4.69),('9650','2013-08-07','17:20:00',4.58),('9650','2013-08-07','17:25:00',4.49),('9650','2013-08-07','17:30:00',4.38),('9650','2013-08-07','17:35:00',4.25),('9650','2013-08-07','17:40:00',4.18),('9650','2013-08-07','17:45:00',4.07),('9650','2013-08-07','17:50:00',3.96),('9650','2013-08-07','17:55:00',3.86),('9650','2013-08-07','18:00:00',3.76),('9650','2013-08-07','18:05:00',3.62),('9650','2013-08-07','18:10:00',3.49),('9650','2013-08-07','18:15:00',3.34),('9650','2013-08-07','18:20:00',3.2),('9650','2013-08-07','18:25:00',3.05),('9650','2013-08-07','18:30:00',2.89),('9650','2013-08-07','18:35:00',2.73),('9650','2013-08-07','18:40:00',2.57),('9650','2013-08-07','18:45:00',2.4),('9650','2013-08-07','18:50:00',2.24),('9650','2013-08-07','18:55:00',2.07),('9650','2013-08-07','19:00:00',1.9),('9650','2013-08-07','19:05:00',1.73),('9650','2013-08-07','19:10:00',1.58),('9650','2013-08-07','19:15:00',1.4),('9650','2013-08-07','19:20:00',1.22),('9650','2013-08-07','19:25:00',1.04),('9650','2013-08-06','08:30:00',1.06),('9650','2013-08-06','08:35:00',1.14),('9650','2013-08-06','08:40:00',1.25),('9650','2013-08-06','08:45:00',1.32),('9650','2013-08-06','08:50:00',1.48),('9650','2013-08-06','08:55:00',1.6),('9650','2013-08-06','09:00:00',1.73),('9650','2013-08-06','09:05:00',1.85),('9650','2013-08-06','09:10:00',1.96),('9650','2013-08-06','09:15:00',2.07),('9650','2013-08-06','09:20:00',2.19),('9650','2013-08-06','09:25:00',2.32),('9650','2013-08-06','09:30:00',2.44),('9650','2013-08-06','09:35:00',2.55),('9650','2013-08-06','09:40:00',2.71),('9650','2013-08-06','09:45:00',2.82),('9650','2013-08-06','09:50:00',2.94),('9650','2013-08-06','09:55:00',3.05),('9650','2013-08-06','10:00:00',3.13),('9650','2013-08-06','10:05:00',3.26),('9650','2013-08-06','10:10:00',3.35),('9650','2013-08-06','10:15:00',3.48),('9650','2013-08-06','10:20:00',3.62),('9650','2013-08-06','10:25:00',3.73),('9650','2013-08-06','10:30:00',3.84),('9650','2013-08-06','10:35:00',3.94),('9650','2013-08-06','10:40:00',4.01),('9650','2013-08-06','10:45:00',4.11),('9650','2013-08-06','10:50:00',4.2),('9650','2013-08-06','10:55:00',4.3),('9650','2013-08-06','11:00:00',4.38),('9650','2013-08-06','11:05:00',4.47),('9650','2013-08-06','11:10:00',4.54),('9650','2013-08-06','11:15:00',4.64),('9650','2013-08-06','11:20:00',4.67),('9650','2013-08-06','11:25:00',4.77),('9650','2013-08-06','11:30:00',4.84),('9650','2013-08-06','11:35:00',4.9),('9650','2013-08-06','11:40:00',4.97),('9650','2013-08-06','11:45:00',5.04),('9650','2013-08-06','11:50:00',5.12),('9650','2013-08-06','11:55:00',5.18),('9650','2013-08-06','12:00:00',5.26),('9650','2013-08-06','12:05:00',5.3),('9650','2013-08-06','12:10:00',5.37),('9650','2013-08-06','12:15:00',5.38),('9650','2013-08-06','12:20:00',5.39),('9650','2013-08-06','12:25:00',5.43),('9650','2013-08-06','12:30:00',5.49),('9650','2013-08-06','12:35:00',5.6),('9650','2013-08-06','12:40:00',5.61),('9650','2013-08-06','12:45:00',5.72),('9650','2013-08-06','12:50:00',5.79),('9650','2013-08-06','12:55:00',5.84),('9650','2013-08-06','13:00:00',5.84),('9650','2013-08-06','13:05:00',6.07),('9650','2013-08-06','13:10:00',6.04),('9650','2013-08-06','13:15:00',6.09),('9650','2013-08-06','13:20:00',5.97),('9650','2013-08-06','13:25:00',6.13),('9650','2013-08-06','13:30:00',6.1),('9650','2013-08-06','13:35:00',6.08),('9650','2013-08-06','13:40:00',6.25),('9650','2013-08-06','13:45:00',6.18),('9650','2013-08-06','13:50:00',6.24),('9650','2013-08-06','13:55:00',6.36),('9650','2013-08-06','14:00:00',6.31),('9650','2013-08-06','14:05:00',6.33),('9650','2013-08-06','14:10:00',6.27),('9650','2013-08-06','14:15:00',6.2),('9650','2013-08-06','14:20:00',6.12),('9650','2013-08-06','14:25:00',6.15),('9650','2013-08-06','14:30:00',6.1),('9650','2013-08-06','14:35:00',6.08),('9650','2013-08-06','14:40:00',6.18),('9650','2013-08-06','14:45:00',6.24),('9650','2013-08-06','14:50:00',6.32),('9650','2013-08-06','14:55:00',6.24),('9650','2013-08-06','15:00:00',6.3),('9650','2013-08-06','15:05:00',6.21),('9650','2013-08-06','15:10:00',6.17),('9650','2013-08-06','15:15:00',6.2),('9650','2013-08-06','15:20:00',6.24),('9650','2013-08-06','15:25:00',6.11),('9650','2013-08-06','15:30:00',6.12),('9650','2013-08-06','15:35:00',6.1),('9650','2013-08-06','15:40:00',6.08),('9650','2013-08-06','15:45:00',6.06),('9650','2013-08-06','15:50:00',5.97),('9650','2013-08-06','15:55:00',5.93),('9650','2013-08-06','16:00:00',5.78),('9650','2013-08-06','16:05:00',5.73),('9650','2013-08-06','16:10:00',5.65),('9650','2013-08-06','16:15:00',5.63),('9650','2013-08-06','16:20:00',5.59),('9650','2013-08-06','16:25:00',5.55),('9650','2013-08-06','16:30:00',5.51),('9650','2013-08-06','16:35:00',5.5),('9650','2013-08-06','16:40:00',5.43),('9650','2013-08-06','16:45:00',5.37),('9650','2013-08-06','16:50:00',5.32),('9650','2013-08-06','16:55:00',5.27),('9650','2013-08-06','17:00:00',5.2),('9650','2013-08-06','17:05:00',5.06),('9650','2013-08-06','17:10:00',4.93),('9650','2013-08-06','17:15:00',4.85),('9650','2013-08-06','17:20:00',4.79),('9650','2013-08-06','17:25:00',4.66),('9650','2013-08-06','17:30:00',4.48),('9650','2013-08-06','17:35:00',4.41),('9650','2013-08-06','17:40:00',4.27),('9650','2013-08-06','17:45:00',4.17),('9650','2013-08-06','17:50:00',4.05),('9650','2013-08-06','17:55:00',3.93),('9650','2013-08-06','18:00:00',3.83),('9650','2013-08-06','18:05:00',3.66),('9650','2013-08-06','18:10:00',3.46),('9650','2013-08-06','18:15:00',3.37),('9650','2013-08-06','18:20:00',3.21),('9650','2013-08-06','18:25:00',3.09),('9650','2013-08-06','18:30:00',2.99),('9650','2013-08-06','18:35:00',2.86),('9650','2013-08-06','18:40:00',2.7),('9650','2013-08-06','18:45:00',2.56),('9650','2013-08-06','18:50:00',2.4),('9650','2013-08-06','18:55:00',2.23),('9650','2013-08-06','19:00:00',2.04),('9650','2013-08-06','19:05:00',1.84),('9650','2013-08-06','19:10:00',1.64),('9650','2013-08-06','19:15:00',1.46),('9650','2013-08-06','19:20:00',1.27),('9650','2013-08-06','19:25:00',1.1),('9650','2013-08-05','08:25:00',1.02),('9650','2013-08-05','08:30:00',1.07),('9650','2013-08-05','08:35:00',1.11),('9650','2013-08-05','08:40:00',1.14),('9650','2013-08-05','08:45:00',1.17),('9650','2013-08-05','08:50:00',1.2),('9650','2013-08-05','08:55:00',1.22),('9650','2013-08-05','09:00:00',1.23),('9650','2013-08-05','09:05:00',1.49),('9650','2013-08-05','09:10:00',1.96),('9650','2013-08-05','09:15:00',2.07),('9650','2013-08-05','09:20:00',2.19),('9650','2013-08-05','09:25:00',2.33),('9650','2013-08-05','09:30:00',2.45),('9650','2013-08-05','09:35:00',2.56),('9650','2013-08-05','09:40:00',2.7),('9650','2013-08-05','09:45:00',2.84),('9650','2013-08-05','09:50:00',2.93),('9650','2013-08-05','09:55:00',3.05),('9650','2013-08-05','10:00:00',3.18),('9650','2013-08-05','10:05:00',3.28),('9650','2013-08-05','10:10:00',3.39),('9650','2013-08-05','10:15:00',3.49),('9650','2013-08-05','10:20:00',3.59),('9650','2013-08-05','10:25:00',3.69),('9650','2013-08-05','10:30:00',3.8),('9650','2013-08-05','10:35:00',3.91),('9650','2013-08-05','10:40:00',3.99),('9650','2013-08-05','10:45:00',4.09),('9650','2013-08-05','10:50:00',4.18),('9650','2013-08-05','10:55:00',4.27),('9650','2013-08-05','11:00:00',4.36),('9650','2013-08-05','11:05:00',4.48),('9650','2013-08-05','11:10:00',4.56),('9650','2013-08-05','11:15:00',4.61),('9650','2013-08-05','11:20:00',4.68),('9650','2013-08-05','11:25:00',4.75),('9650','2013-08-05','11:30:00',4.87),('9650','2013-08-05','11:35:00',4.93),('9650','2013-08-05','11:40:00',4.98),('9650','2013-08-05','11:45:00',5.09),('9650','2013-08-05','11:50:00',5.13),('9650','2013-08-05','11:55:00',5.21),('9650','2013-08-05','12:00:00',5.25),('9650','2013-08-05','12:05:00',5.32),('9650','2013-08-05','12:10:00',5.33),('9650','2013-08-05','12:15:00',5.36),('9650','2013-08-05','12:20:00',5.44),('9650','2013-08-05','12:25:00',5.52),('9650','2013-08-05','12:30:00',5.51),('9650','2013-08-05','12:35:00',5.6),('9650','2013-08-05','12:40:00',5.6),('9650','2013-08-05','12:45:00',5.75),('9650','2013-08-05','12:50:00',5.8),('9650','2013-08-05','12:55:00',5.83),('9650','2013-08-05','13:00:00',5.86),('9650','2013-08-05','13:05:00',5.9),('9650','2013-08-05','13:10:00',6),('9650','2013-08-05','13:15:00',6.07),('9650','2013-08-05','13:20:00',6.05),('9650','2013-08-05','13:25:00',6),('9650','2013-08-05','13:30:00',6.16),('9650','2013-08-05','13:35:00',6.21),('9650','2013-08-05','13:40:00',6.27),('9650','2013-08-05','13:45:00',6.29),('9650','2013-08-05','13:50:00',6.32),('9650','2013-08-05','13:55:00',6.33),('9650','2013-08-05','14:00:00',6.38),('9650','2013-08-05','14:05:00',6.43),('9650','2013-08-05','14:10:00',6.46),('9650','2013-08-05','14:15:00',6.53),('9650','2013-08-05','14:20:00',6.49),('9650','2013-08-05','14:25:00',6.53),('9650','2013-08-05','14:30:00',6.52),('9650','2013-08-05','14:35:00',6.48),('9650','2013-08-05','14:40:00',6.49),('9650','2013-08-05','14:45:00',6.48),('9650','2013-08-05','14:50:00',6.48),('9650','2013-08-05','14:55:00',6.5),('9650','2013-08-05','15:00:00',6.5),('9650','2013-08-05','15:05:00',6.48),('9650','2013-08-05','15:10:00',6.46),('9650','2013-08-05','15:15:00',6.46),('9650','2013-08-05','15:20:00',6.45),('9650','2013-08-05','15:25:00',6.42),('9650','2013-08-05','15:30:00',6.4),('9650','2013-08-05','15:35:00',6.35),('9650','2013-08-05','15:40:00',6.33),('9650','2013-08-05','15:45:00',6.25),('9650','2013-08-05','15:50:00',6.19),('9650','2013-08-05','15:55:00',6.09),('9650','2013-08-05','16:00:00',6.04),('9650','2013-08-05','16:05:00',5.97),('9650','2013-08-05','16:10:00',5.94),('9650','2013-08-05','16:15:00',5.91),('9650','2013-08-05','16:20:00',5.82),('9650','2013-08-05','16:25:00',5.76),('9650','2013-08-05','16:30:00',5.7),('9650','2013-08-05','16:35:00',5.61),('9650','2013-08-05','16:40:00',5.57),('9650','2013-08-05','16:45:00',5.48),('9650','2013-08-05','16:50:00',5.41),('9650','2013-08-05','16:55:00',5.34),('9650','2013-08-05','17:00:00',5.28),('9650','2013-08-05','17:05:00',5.2),('9650','2013-08-05','17:10:00',5.06),('9650','2013-08-05','17:15:00',4.96),('9650','2013-08-05','17:20:00',4.88),('9650','2013-08-05','17:25:00',4.79),('9650','2013-08-05','17:30:00',4.68),('9650','2013-08-05','17:35:00',4.57),('9650','2013-08-05','17:40:00',4.43),('9650','2013-08-05','17:45:00',4.31),('9650','2013-08-05','17:50:00',4.22),('9650','2013-08-05','17:55:00',4.08),('9650','2013-08-05','18:00:00',3.94),('9650','2013-08-05','18:05:00',3.83),('9650','2013-08-05','18:10:00',3.71),('9650','2013-08-05','18:15:00',3.57),('9650','2013-08-05','18:20:00',3.44),('9650','2013-08-05','18:25:00',3.29),('9650','2013-08-05','18:30:00',3.19),('9650','2013-08-05','18:35:00',3.05),('9650','2013-08-05','18:40:00',2.81),('9650','2013-08-05','18:45:00',2.67),('9650','2013-08-05','18:50:00',2.46),('9650','2013-08-05','18:55:00',2.26),('9650','2013-08-05','19:00:00',2.06),('9650','2013-08-05','19:05:00',1.86),('9650','2013-08-05','19:10:00',1.66),('9650','2013-08-05','19:15:00',1.49),('9650','2013-08-05','19:20:00',1.31),('9650','2013-08-05','19:25:00',1.13),('9650','2013-08-04','08:25:00',1.06),('9650','2013-08-04','08:30:00',1.14),('9650','2013-08-04','08:35:00',1.22),('9650','2013-08-04','08:40:00',1.34),('9650','2013-08-04','08:45:00',1.43),('9650','2013-08-04','08:50:00',1.56),('9650','2013-08-04','08:55:00',1.67),('9650','2013-08-04','09:00:00',1.81),('9650','2013-08-04','09:05:00',1.91),('9650','2013-08-04','09:10:00',2.01),('9650','2013-08-04','09:15:00',2.12),('9650','2013-08-04','09:20:00',2.24),('9650','2013-08-04','09:25:00',2.37),('9650','2013-08-04','09:30:00',2.51),('9650','2013-08-04','09:35:00',2.61),('9650','2013-08-04','09:40:00',2.73),('9650','2013-08-04','09:45:00',2.85),('9650','2013-08-04','09:50:00',2.97),('9650','2013-08-04','09:55:00',3.07),('9650','2013-08-04','10:00:00',3.19),('9650','2013-08-04','10:05:00',3.32),('9650','2013-08-04','10:10:00',3.43),('9650','2013-08-04','10:15:00',3.54),('9650','2013-08-04','10:20:00',3.65),('9650','2013-08-04','10:25:00',3.76),('9650','2013-08-04','10:30:00',3.85),('9650','2013-08-04','10:35:00',3.95),('9650','2013-08-04','10:40:00',4.07),('9650','2013-08-04','10:45:00',4.17),('9650','2013-08-04','10:50:00',4.28),('9650','2013-08-04','10:55:00',4.38),('9650','2013-08-04','11:00:00',4.45),('9650','2013-08-04','11:05:00',4.59),('9650','2013-08-04','11:10:00',4.64),('9650','2013-08-04','11:15:00',4.74),('9650','2013-08-04','11:20:00',4.84),('9650','2013-08-04','11:25:00',4.9),('9650','2013-08-04','11:30:00',4.99),('9650','2013-08-04','11:35:00',5.05),('9650','2013-08-04','11:40:00',5.18),('9650','2013-08-04','11:45:00',5.2),('9650','2013-08-04','11:50:00',5.3),('9650','2013-08-04','11:55:00',5.39),('9650','2013-08-04','12:00:00',5.46),('9650','2013-08-04','12:05:00',5.54),('9650','2013-08-04','12:10:00',5.43),('9650','2013-08-04','12:15:00',5.57),('9650','2013-08-04','12:20:00',5.64),('9650','2013-08-04','12:25:00',5.7),('9650','2013-08-04','12:30:00',5.72),('9650','2013-08-04','12:35:00',5.8),('9650','2013-08-04','12:40:00',5.85),('9650','2013-08-04','12:45:00',5.88),('9650','2013-08-04','12:50:00',5.96),('9650','2013-08-04','12:55:00',5.97),('9650','2013-08-04','13:00:00',6.04),('9650','2013-08-04','13:05:00',6.03),('9650','2013-08-04','13:10:00',6.06),('9650','2013-08-04','13:15:00',6.11),('9650','2013-08-04','13:20:00',6.07),('9650','2013-08-04','13:25:00',6.18),('9650','2013-08-04','13:30:00',6.21),('9650','2013-08-04','13:35:00',6.23),('9650','2013-08-04','13:40:00',6.29),('9650','2013-08-04','13:45:00',6.17),('9650','2013-08-04','13:50:00',6.28),('9650','2013-08-04','13:55:00',6.24),('9650','2013-08-04','14:00:00',6.27),('9650','2013-08-04','14:05:00',6.36),('9650','2013-08-04','14:10:00',6.34),('9650','2013-08-04','14:15:00',6.35),('9650','2013-08-04','14:20:00',6.31),('9650','2013-08-04','14:25:00',6.29),('9650','2013-08-04','14:30:00',6.29),('9650','2013-08-04','14:35:00',6.34),('9650','2013-08-04','14:40:00',6.37),('9650','2013-08-04','14:45:00',6.37),('9650','2013-08-04','14:50:00',6.34),('9650','2013-08-04','14:55:00',6.33),('9650','2013-08-04','15:00:00',6.34),('9650','2013-08-04','15:05:00',6.37),('9650','2013-08-04','15:10:00',6.35),('9650','2013-08-04','15:15:00',6.35),('9650','2013-08-04','15:20:00',6.33),('9650','2013-08-04','15:25:00',6.33),('9650','2013-08-04','15:30:00',6.32),('9650','2013-08-04','15:35:00',6.27),('9650','2013-08-04','15:40:00',6.24),('9650','2013-08-04','15:45:00',6.22),('9650','2013-08-04','15:50:00',6.16),('9650','2013-08-04','15:55:00',6.02),('9650','2013-08-04','16:00:00',6.03),('9650','2013-08-04','16:05:00',5.98),('9650','2013-08-04','16:10:00',5.95),('9650','2013-08-04','16:15:00',5.88),('9650','2013-08-04','16:20:00',5.79),('9650','2013-08-04','16:25:00',5.7),('9650','2013-08-04','16:30:00',5.64),('9650','2013-08-04','16:35:00',5.64),('9650','2013-08-04','16:40:00',5.55),('9650','2013-08-04','16:45:00',5.47),('9650','2013-08-04','16:50:00',5.38),('9650','2013-08-04','16:55:00',5.29),('9650','2013-08-04','17:00:00',5.21),('9650','2013-08-04','17:05:00',5.13),('9650','2013-08-04','17:10:00',4.99),('9650','2013-08-04','17:15:00',4.85),('9650','2013-08-04','17:20:00',4.74),('9650','2013-08-04','17:25:00',4.63),('9650','2013-08-04','17:30:00',4.52),('9650','2013-08-04','17:35:00',4.46),('9650','2013-08-04','17:40:00',4.38),('9650','2013-08-04','17:45:00',4.24),('9650','2013-08-04','17:50:00',4.09),('9650','2013-08-04','17:55:00',3.96),('9650','2013-08-04','18:00:00',3.82),('9650','2013-08-04','18:05:00',3.68),('9650','2013-08-04','18:10:00',3.5),('9650','2013-08-04','18:15:00',3.36),('9650','2013-08-04','18:20:00',3.21),('9650','2013-08-04','18:25:00',3.07),('9650','2013-08-04','18:30:00',2.96),('9650','2013-08-04','18:35:00',2.84),('9650','2013-08-04','18:40:00',2.68),('9650','2013-08-04','18:45:00',2.54),('9650','2013-08-04','18:50:00',2.39),('9650','2013-08-04','18:55:00',2.2),('9650','2013-08-04','19:00:00',2.01),('9650','2013-08-04','19:05:00',1.86),('9650','2013-08-04','19:10:00',1.67),('9650','2013-08-04','19:15:00',1.47),('9650','2013-08-04','19:20:00',1.24),('9650','2013-08-04','19:25:00',1.08),('9650','2013-08-03','08:30:00',1.02),('9650','2013-08-03','08:35:00',1.12),('9650','2013-08-03','08:40:00',1.28),('9650','2013-08-03','08:45:00',1.38),('9650','2013-08-03','08:50:00',1.54),('9650','2013-08-03','08:55:00',1.68),('9650','2013-08-03','09:00:00',1.8),('9650','2013-08-03','09:05:00',1.92),('9650','2013-08-03','09:10:00',2.03),('9650','2013-08-03','09:15:00',2.16),('9650','2013-08-03','09:20:00',2.27),('9650','2013-08-03','09:25:00',2.44),('9650','2013-08-03','09:30:00',2.58),('9650','2013-08-03','09:35:00',2.71),('9650','2013-08-03','09:40:00',2.85),('9650','2013-08-03','09:45:00',2.98),('9650','2013-08-03','09:50:00',3.12),('9650','2013-08-03','09:55:00',3.24),('9650','2013-08-03','10:00:00',3.35),('9650','2013-08-03','10:05:00',3.47),('9650','2013-08-03','10:10:00',3.59),('9650','2013-08-03','10:15:00',3.71),('9650','2013-08-03','10:20:00',3.82),('9650','2013-08-03','10:25:00',3.92),('9650','2013-08-03','10:30:00',4.04),('9650','2013-08-03','10:35:00',4.12),('9650','2013-08-03','10:40:00',4.21),('9650','2013-08-03','10:45:00',4.32),('9650','2013-08-03','10:50:00',4.4),('9650','2013-08-03','10:55:00',4.5),('9650','2013-08-03','11:00:00',4.59),('9650','2013-08-03','11:05:00',4.66),('9650','2013-08-03','11:10:00',4.74),('9650','2013-08-03','11:15:00',4.84),('9650','2013-08-03','11:20:00',4.91),('9650','2013-08-03','11:25:00',5.05),('9650','2013-08-03','11:30:00',5.11),('9650','2013-08-03','11:35:00',5.19),('9650','2013-08-03','11:40:00',5.25),('9650','2013-08-03','11:45:00',5.38),('9650','2013-08-03','11:50:00',5.41),('9650','2013-08-03','11:55:00',5.48),('9650','2013-08-03','12:00:00',5.59),('9650','2013-08-03','12:05:00',5.57),('9650','2013-08-03','12:10:00',5.66),('9650','2013-08-03','12:15:00',5.79),('9650','2013-08-03','12:20:00',5.79),('9650','2013-08-03','12:25:00',5.86),('9650','2013-08-03','12:30:00',5.9),('9650','2013-08-03','12:35:00',5.92),('9650','2013-08-03','12:40:00',6.06),('9650','2013-08-03','12:45:00',6.07),('9650','2013-08-03','12:50:00',6.14),('9650','2013-08-03','12:55:00',6.17),('9650','2013-08-03','13:00:00',6.13),('9650','2013-08-03','13:05:00',6.1),('9650','2013-08-03','13:10:00',6.19),('9650','2013-08-03','13:15:00',6.2),('9650','2013-08-03','13:20:00',6.25),('9650','2013-08-03','13:25:00',6.32),('9650','2013-08-03','13:30:00',6.34),('9650','2013-08-03','13:35:00',6.48),('9650','2013-08-03','13:40:00',6.54),('9650','2013-08-03','13:45:00',6.57),('9650','2013-08-03','13:50:00',6.62),('9650','2013-08-03','13:55:00',6.61),('9650','2013-08-03','14:00:00',6.68),('9650','2013-08-03','14:05:00',6.69),('9650','2013-08-03','14:10:00',6.68),('9650','2013-08-03','14:15:00',6.66),('9650','2013-08-03','14:20:00',6.65),('9650','2013-08-03','14:25:00',6.69),('9650','2013-08-03','14:30:00',6.67),('9650','2013-08-03','14:35:00',6.67),('9650','2013-08-03','14:40:00',6.66),('9650','2013-08-03','14:45:00',6.67),('9650','2013-08-03','14:50:00',6.67),('9650','2013-08-03','14:55:00',6.67),('9650','2013-08-03','15:00:00',6.6),('9650','2013-08-03','15:05:00',6.65),('9650','2013-08-03','15:10:00',6.62),('9650','2013-08-03','15:15:00',6.59),('9650','2013-08-03','15:20:00',6.57),('9650','2013-08-03','15:25:00',6.51),('9650','2013-08-03','15:30:00',6.39),('9650','2013-08-03','15:35:00',6.5),('9650','2013-08-03','15:40:00',6.44),('9650','2013-08-03','15:45:00',6.34),('9650','2013-08-03','15:50:00',6.24),('9650','2013-08-03','15:55:00',6.24),('9650','2013-08-03','16:00:00',6.06),('9650','2013-08-03','16:05:00',6.15),('9650','2013-08-03','16:10:00',6.12),('9650','2013-08-03','16:15:00',6.07),('9650','2013-08-03','16:20:00',6.04),('9650','2013-08-03','16:25:00',5.94),('9650','2013-08-03','16:30:00',5.85),('9650','2013-08-03','16:35:00',5.8),('9650','2013-08-03','16:40:00',5.73),('9650','2013-08-03','16:45:00',5.65),('9650','2013-08-03','16:50:00',5.48),('9650','2013-08-03','16:55:00',5.45),('9650','2013-08-03','17:00:00',5.45),('9650','2013-08-03','17:05:00',5.39),('9650','2013-08-03','17:10:00',5.26),('9650','2013-08-03','17:15:00',5.15),('9650','2013-08-03','17:20:00',5.04),('9650','2013-08-03','17:25:00',4.89),('9650','2013-08-03','17:30:00',4.79),('9650','2013-08-03','17:35:00',4.68),('9650','2013-08-03','17:40:00',4.55),('9650','2013-08-03','17:45:00',4.46),('9650','2013-08-03','17:50:00',4.36),('9650','2013-08-03','17:55:00',4.19),('9650','2013-08-03','18:00:00',4.07),('9650','2013-08-03','18:05:00',3.9),('9650','2013-08-03','18:10:00',3.77),('9650','2013-08-03','18:15:00',3.63),('9650','2013-08-03','18:20:00',3.52),('9650','2013-08-03','18:25:00',3.34),('9650','2013-08-03','18:30:00',3.19),('9650','2013-08-03','18:35:00',3.02),('9650','2013-08-03','18:40:00',2.82),('9650','2013-08-03','18:45:00',2.55),('9650','2013-08-03','18:50:00',2.46),('9650','2013-08-03','18:55:00',2.29),('9650','2013-08-03','19:00:00',2.1),('9650','2013-08-03','19:05:00',1.48),('9650','2013-08-03','19:10:00',1.62),('9650','2013-08-03','19:15:00',1.44),('9650','2013-08-03','19:20:00',1.35),('9650','2013-08-03','19:25:00',1.19),('9650','2013-08-02','08:30:00',1.02),('9650','2013-08-02','08:35:00',1.08),('9650','2013-08-02','08:40:00',1.13),('9650','2013-08-02','08:45:00',1.16),('9650','2013-08-02','08:50:00',1.2),('9650','2013-08-02','08:55:00',1.21),('9650','2013-08-02','09:00:00',1.23),('9650','2013-08-02','09:05:00',1.45),('9650','2013-08-02','09:10:00',2.03),('9650','2013-08-02','09:15:00',2.14),('9650','2013-08-02','09:20:00',2.27),('9650','2013-08-02','09:25:00',2.42),('9650','2013-08-02','09:30:00',2.56),('9650','2013-08-02','09:35:00',2.7),('9650','2013-08-02','09:40:00',2.82),('9650','2013-08-02','09:45:00',2.96),('9650','2013-08-02','09:50:00',3.09),('9650','2013-08-02','09:55:00',3.2),('9650','2013-08-02','10:00:00',3.33),('9650','2013-08-02','10:05:00',3.44),('9650','2013-08-02','10:10:00',3.55),('9650','2013-08-02','10:15:00',3.66),('9650','2013-08-02','10:20:00',3.81),('9650','2013-08-02','10:25:00',3.92),('9650','2013-08-02','10:30:00',4.04),('9650','2013-08-02','10:35:00',4.13),('9650','2013-08-02','10:40:00',4.21),('9650','2013-08-02','10:45:00',4.35),('9650','2013-08-02','10:50:00',4.44),('9650','2013-08-02','10:55:00',4.53),('9650','2013-08-02','11:00:00',4.63),('9650','2013-08-02','11:05:00',4.72),('9650','2013-08-02','11:10:00',4.82),('9650','2013-08-02','11:15:00',4.88),('9650','2013-08-02','11:20:00',4.95),('9650','2013-08-02','11:25:00',5.01),('9650','2013-08-02','11:30:00',5.14),('9650','2013-08-02','11:35:00',5.19),('9650','2013-08-02','11:40:00',5.25),('9650','2013-08-02','11:45:00',5.32),('9650','2013-08-02','11:50:00',5.36),('9650','2013-08-02','11:55:00',5.47),('9650','2013-08-02','12:00:00',5.55),('9650','2013-08-02','12:05:00',5.63),('9650','2013-08-02','12:10:00',5.61),('9650','2013-08-02','12:15:00',5.65),('9650','2013-08-02','12:20:00',5.74),('9650','2013-08-02','12:25:00',5.76),('9650','2013-08-02','12:30:00',5.8),('9650','2013-08-02','12:35:00',5.89),('9650','2013-08-02','12:40:00',5.89),('9650','2013-08-02','12:45:00',5.95),('9650','2013-08-02','12:50:00',5.96),('9650','2013-08-02','12:55:00',5.97),('9650','2013-08-02','13:00:00',6),('9650','2013-08-02','13:05:00',6.13),('9650','2013-08-02','13:10:00',6.11),('9650','2013-08-02','13:15:00',6.12),('9650','2013-08-02','13:20:00',6.06),('9650','2013-08-02','13:25:00',6.03),('9650','2013-08-02','13:30:00',6.06),('9650','2013-08-02','13:35:00',6.15),('9650','2013-08-02','13:40:00',6.31),('9650','2013-08-02','13:45:00',6.33),('9650','2013-08-02','13:50:00',6.26),('9650','2013-08-02','13:55:00',6.27),('9650','2013-08-02','14:00:00',6.33),('9650','2013-08-02','14:05:00',6.28),('9650','2013-08-02','14:10:00',6.32),('9650','2013-08-02','14:15:00',6.21),('9650','2013-08-02','14:20:00',6.31),('9650','2013-08-02','14:25:00',6.3),('9650','2013-08-02','14:30:00',6.37),('9650','2013-08-02','14:35:00',6.52),('9650','2013-08-02','14:40:00',6.57),('9650','2013-08-02','14:45:00',6.53),('9650','2013-08-02','14:50:00',6.59),('9650','2013-08-02','14:55:00',6.62),('9650','2013-08-02','15:00:00',6.57),('9650','2013-08-02','15:05:00',6.54),('9650','2013-08-02','15:10:00',6.52),('9650','2013-08-02','15:15:00',6.48),('9650','2013-08-02','15:20:00',6.42),('9650','2013-08-02','15:25:00',6.46),('9650','2013-08-02','15:30:00',6.48),('9650','2013-08-02','15:35:00',6.42),('9650','2013-08-02','15:40:00',6.39),('9650','2013-08-02','15:45:00',6.37),('9650','2013-08-02','15:50:00',6.36),('9650','2013-08-02','15:55:00',6.23),('9650','2013-08-02','16:00:00',6.17),('9650','2013-08-02','16:05:00',6),('9650','2013-08-02','16:10:00',5.96),('9650','2013-08-02','16:15:00',5.85),('9650','2013-08-02','16:20:00',5.81),('9650','2013-08-02','16:25:00',5.77),('9650','2013-08-02','16:30:00',5.75),('9650','2013-08-02','16:35:00',5.69),('9650','2013-08-02','16:40:00',5.63),('9650','2013-08-02','16:45:00',5.56),('9650','2013-08-02','16:50:00',5.54),('9650','2013-08-02','16:55:00',5.46),('9650','2013-08-02','17:00:00',5.38),('9650','2013-08-02','17:05:00',5.24),('9650','2013-08-02','17:10:00',5.15),('9650','2013-08-02','17:15:00',5.03),('9650','2013-08-02','17:20:00',4.94),('9650','2013-08-02','17:25:00',4.83),('9650','2013-08-02','17:30:00',4.77),('9650','2013-08-02','17:35:00',4.69),('9650','2013-08-02','17:40:00',4.56),('9650','2013-08-02','17:45:00',4.44),('9650','2013-08-02','17:50:00',4.33),('9650','2013-08-02','17:55:00',4.2),('9650','2013-08-02','18:00:00',4.09),('9650','2013-08-02','18:05:00',3.95),('9650','2013-08-02','18:10:00',3.83),('9650','2013-08-02','18:15:00',3.69),('9650','2013-08-02','18:20:00',3.58),('9650','2013-08-02','18:25:00',3.44),('9650','2013-08-02','18:30:00',3.32),('9650','2013-08-02','18:35:00',3.18),('9650','2013-08-02','18:40:00',3.03),('9650','2013-08-02','18:45:00',2.89),('9650','2013-08-02','18:50:00',2.72),('9650','2013-08-02','18:55:00',2.56),('9650','2013-08-02','19:00:00',2.4),('9650','2013-08-02','19:05:00',2.24),('9650','2013-08-02','19:10:00',2.05),('9650','2013-08-02','19:15:00',1.87),('9650','2013-08-02','19:20:00',1.72),('9650','2013-08-02','19:25:00',1.54),('9650','2013-08-02','19:30:00',1.36),('9650','2013-08-02','19:35:00',1.18),('9650','2013-08-01','08:30:00',1.03),('9650','2013-08-01','08:35:00',1.16),('9650','2013-08-01','08:40:00',1.31),('9650','2013-08-01','08:45:00',1.45),('9650','2013-08-01','08:50:00',1.53),('9650','2013-08-01','08:55:00',1.72),('9650','2013-08-01','09:00:00',1.85),('9650','2013-08-01','09:05:00',1.97),('9650','2013-08-01','09:10:00',2.1),('9650','2013-08-01','09:15:00',2.22),('9650','2013-08-01','09:20:00',2.35),('9650','2013-08-01','09:25:00',2.51),('9650','2013-08-01','09:30:00',2.64),('9650','2013-08-01','09:35:00',2.78),('9650','2013-08-01','09:40:00',2.9),('9650','2013-08-01','09:45:00',3.06),('9650','2013-08-01','09:50:00',3.16),('9650','2013-08-01','09:55:00',3.29),('9650','2013-08-01','10:00:00',3.43),('9650','2013-08-01','10:05:00',3.54),('9650','2013-08-01','10:10:00',3.65),('9650','2013-08-01','10:15:00',3.76),('9650','2013-08-01','10:20:00',3.86),('9650','2013-08-01','10:25:00',3.98),('9650','2013-08-01','10:30:00',4.09),('9650','2013-08-01','10:35:00',4.2),('9650','2013-08-01','10:40:00',4.31),('9650','2013-08-01','10:45:00',4.42),('9650','2013-08-01','10:50:00',4.51),('9650','2013-08-01','10:55:00',4.58),('9650','2013-08-01','11:00:00',4.7),('9650','2013-08-01','11:05:00',4.8),('9650','2013-08-01','11:10:00',4.89),('9650','2013-08-01','11:15:00',4.97),('9650','2013-08-01','11:20:00',5.07),('9650','2013-08-01','11:25:00',5.17),('9650','2013-08-01','11:30:00',5.27),('9650','2013-08-01','11:35:00',5.32),('9650','2013-08-01','11:40:00',5.39),('9650','2013-08-01','11:45:00',5.43),('9650','2013-08-01','11:50:00',5.39),('9650','2013-08-01','11:55:00',5.63),('9650','2013-08-01','12:00:00',5.7),('9650','2013-08-01','12:05:00',5.71),('9650','2013-08-01','12:10:00',5.79),('9650','2013-08-01','12:15:00',5.89),('9650','2013-08-01','12:20:00',5.94),('9650','2013-08-01','12:25:00',5.98),('9650','2013-08-01','12:30:00',6),('9650','2013-08-01','12:35:00',6.03),('9650','2013-08-01','12:40:00',6.06),('9650','2013-08-01','12:45:00',6.11),('9650','2013-08-01','12:50:00',6.16),('9650','2013-08-01','12:55:00',6.19),('9650','2013-08-01','13:00:00',6.21),('9650','2013-08-01','13:05:00',6.28),('9650','2013-08-01','13:10:00',6.35),('9650','2013-08-01','13:15:00',6.39),('9650','2013-08-01','13:20:00',6.38),('9650','2013-08-01','13:25:00',6.41),('9650','2013-08-01','13:30:00',6.41),('9650','2013-08-01','13:35:00',6.51),('9650','2013-08-01','13:40:00',6.56),('9650','2013-08-01','13:45:00',6.57),('9650','2013-08-01','13:50:00',6.59),('9650','2013-08-01','13:55:00',6.59),('9650','2013-08-01','14:00:00',6.63),('9650','2013-08-01','14:05:00',6.66),('9650','2013-08-01','14:10:00',6.6),('9650','2013-08-01','14:15:00',6.56),('9650','2013-08-01','14:20:00',6.54),('9650','2013-08-01','14:25:00',6.51),('9650','2013-08-01','14:30:00',6.58),('9650','2013-08-01','14:35:00',6.71),('9650','2013-08-01','14:40:00',6.72),('9650','2013-08-01','14:45:00',6.75),('9650','2013-08-01','14:50:00',6.71),('9650','2013-08-01','14:55:00',6.71),('9650','2013-08-01','15:00:00',6.67),('9650','2013-08-01','15:05:00',6.66),('9650','2013-08-01','15:10:00',6.6),('9650','2013-08-01','15:15:00',6.54),('9650','2013-08-01','15:20:00',6.58),('9650','2013-08-01','15:25:00',6.6),('9650','2013-08-01','15:30:00',6.55),('9650','2013-08-01','15:35:00',6.52),('9650','2013-08-01','15:40:00',6.44),('9650','2013-08-01','15:45:00',6.45),('9650','2013-08-01','15:50:00',6.37),('9650','2013-08-01','15:55:00',6.31),('9650','2013-08-01','16:00:00',6.3),('9650','2013-08-01','16:05:00',6.24),('9650','2013-08-01','16:10:00',6.15),('9650','2013-08-01','16:15:00',6.12),('9650','2013-08-01','16:20:00',6.06),('9650','2013-08-01','16:25:00',6),('9650','2013-08-01','16:30:00',5.97),('9650','2013-08-01','16:35:00',5.92),('9650','2013-08-01','16:40:00',5.84),('9650','2013-08-01','16:45:00',5.78),('9650','2013-08-01','16:50:00',5.7),('9650','2013-08-01','16:55:00',5.59),('9650','2013-08-01','17:00:00',5.46),('9650','2013-08-01','17:05:00',5.37),('9650','2013-08-01','17:10:00',5.3),('9650','2013-08-01','17:15:00',5.26),('9650','2013-08-01','17:20:00',5.15),('9650','2013-08-01','17:25:00',5.03),('9650','2013-08-01','17:30:00',4.87),('9650','2013-08-01','17:35:00',4.79),('9650','2013-08-01','17:40:00',4.72),('9650','2013-08-01','17:45:00',4.57),('9650','2013-08-01','17:50:00',4.41),('9650','2013-08-01','17:55:00',4.27),('9650','2013-08-01','18:00:00',4.15),('9650','2013-08-01','18:05:00',4.06),('9650','2013-08-01','18:10:00',3.96),('9650','2013-08-01','18:15:00',3.82),('9650','2013-08-01','18:20:00',3.69),('9650','2013-08-01','18:25:00',3.55),('9650','2013-08-01','18:30:00',3.41),('9650','2013-08-01','18:35:00',3.25),('9650','2013-08-01','18:40:00',3.05),('9650','2013-08-01','18:45:00',2.9),('9650','2013-08-01','18:50:00',2.75),('9650','2013-08-01','18:55:00',2.63),('9650','2013-08-01','19:00:00',2.47),('9650','2013-08-01','19:05:00',2.32),('9650','2013-08-01','19:10:00',2.14),('9650','2013-08-01','19:15:00',1.95),('9650','2013-08-01','19:20:00',1.8),('9650','2013-08-01','19:25:00',1.62),('9650','2013-08-01','19:30:00',1.39),('9650','2013-08-01','19:35:00',1.26),('9650','2013-08-01','19:40:00',1.08),('9650','2013-07-31','08:30:00',1.06),('9650','2013-07-31','08:35:00',1.15),('9650','2013-07-31','08:40:00',1.29),('9650','2013-07-31','08:45:00',1.45),('9650','2013-07-31','08:50:00',1.58),('9650','2013-07-31','08:55:00',1.75),('9650','2013-07-31','09:00:00',1.88),('9650','2013-07-31','09:05:00',2.01),('9650','2013-07-31','09:10:00',2.13),('9650','2013-07-31','09:15:00',2.25),('9650','2013-07-31','09:20:00',2.4),('9650','2013-07-31','09:25:00',2.56),('9650','2013-07-31','09:30:00',2.7),('9650','2013-07-31','09:35:00',2.86),('9650','2013-07-31','09:40:00',2.99),('9650','2013-07-31','09:45:00',3.14),('9650','2013-07-31','09:50:00',3.26),('9650','2013-07-31','09:55:00',3.4),('9650','2013-07-31','10:00:00',3.52),('9650','2013-07-31','10:05:00',3.63),('9650','2013-07-31','10:10:00',3.76),('9650','2013-07-31','10:15:00',3.86),('9650','2013-07-31','10:20:00',3.95),('9650','2013-07-31','10:25:00',4.08),('9650','2013-07-31','10:30:00',4.22),('9650','2013-07-31','10:35:00',4.32),('9650','2013-07-31','10:40:00',4.42),('9650','2013-07-31','10:45:00',4.52),('9650','2013-07-31','10:50:00',4.65),('9650','2013-07-31','10:55:00',4.74),('9650','2013-07-31','11:00:00',4.84),('9650','2013-07-31','11:05:00',4.95),('9650','2013-07-31','11:10:00',5.04),('9650','2013-07-31','11:15:00',5.12),('9650','2013-07-31','11:20:00',5.22),('9650','2013-07-31','11:25:00',5.29),('9650','2013-07-31','11:30:00',5.36),('9650','2013-07-31','11:35:00',5.45),('9650','2013-07-31','11:40:00',5.6),('9650','2013-07-31','11:45:00',5.68),('9650','2013-07-31','11:50:00',5.76),('9650','2013-07-31','11:55:00',5.83),('9650','2013-07-31','12:00:00',5.87),('9650','2013-07-31','12:05:00',5.95),('9650','2013-07-31','12:10:00',5.99),('9650','2013-07-31','12:15:00',6.06),('9650','2013-07-31','12:20:00',6.13),('9650','2013-07-31','12:25:00',6.21),('9650','2013-07-31','12:30:00',6.24),('9650','2013-07-31','12:35:00',6.3),('9650','2013-07-31','12:40:00',6.38),('9650','2013-07-31','12:45:00',6.43),('9650','2013-07-31','12:50:00',6.52),('9650','2013-07-31','12:55:00',6.55),('9650','2013-07-31','13:00:00',6.54),('9650','2013-07-31','13:05:00',6.55),('9650','2013-07-31','13:10:00',6.64),('9650','2013-07-31','13:15:00',6.22),('9650','2013-07-31','13:20:00',6.75),('9650','2013-07-31','13:25:00',6.76),('9650','2013-07-31','13:30:00',6.7),('9650','2013-07-31','13:35:00',6.84),('9650','2013-07-31','13:40:00',6.84),('9650','2013-07-31','13:45:00',7),('9650','2013-07-31','13:50:00',6.85),('9650','2013-07-31','13:55:00',6.7),('9650','2013-07-31','14:00:00',6.44),('9650','2013-07-31','14:05:00',6.93),('9650','2013-07-31','14:10:00',6.83),('9650','2013-07-31','14:15:00',6.73),('9650','2013-07-31','14:20:00',6.6),('9650','2013-07-31','14:25:00',6.81),('9650','2013-07-31','14:30:00',6.81),('9650','2013-07-31','14:35:00',5.58),('9650','2013-07-31','14:40:00',6.33),('9650','2013-07-31','14:45:00',6.96),('9650','2013-07-31','14:50:00',5.18),('9650','2013-07-31','14:55:00',6.9),('9650','2013-07-31','15:00:00',6.79),('9650','2013-07-31','15:05:00',6.84),('9650','2013-07-31','15:10:00',6.9),('9650','2013-07-31','15:15:00',6.69),('9650','2013-07-31','15:20:00',6.85),('9650','2013-07-31','15:25:00',6.8),('9650','2013-07-31','15:30:00',6.72),('9650','2013-07-31','15:35:00',6.78),('9650','2013-07-31','15:40:00',4.86),('9650','2013-07-31','15:45:00',6.66),('9650','2013-07-31','15:50:00',6.53),('9650','2013-07-31','15:55:00',6.51),('9650','2013-07-31','16:00:00',6.52),('9650','2013-07-31','16:05:00',6.48),('9650','2013-07-31','16:10:00',6.33),('9650','2013-07-31','16:15:00',6.22),('9650','2013-07-31','16:20:00',6.19),('9650','2013-07-31','16:25:00',6.16),('9650','2013-07-31','16:30:00',6.05),('9650','2013-07-31','16:35:00',6.03),('9650','2013-07-31','16:40:00',6),('9650','2013-07-31','16:45:00',5.91),('9650','2013-07-31','16:50:00',5.83),('9650','2013-07-31','16:55:00',5.74),('9650','2013-07-31','17:00:00',5.66),('9650','2013-07-31','17:05:00',5.56),('9650','2013-07-31','17:10:00',5.48),('9650','2013-07-31','17:15:00',5.37),('9650','2013-07-31','17:20:00',5.26),('9650','2013-07-31','17:25:00',5.1),('9650','2013-07-31','17:30:00',5.05),('9650','2013-07-31','17:35:00',4.95),('9650','2013-07-31','17:40:00',4.83),('9650','2013-07-31','17:45:00',4.74),('9650','2013-07-31','17:50:00',4.61),('9650','2013-07-31','17:55:00',4.54),('9650','2013-07-31','18:00:00',4.42),('9650','2013-07-31','18:05:00',4.29),('9650','2013-07-31','18:10:00',4.17),('9650','2013-07-31','18:15:00',4.04),('9650','2013-07-31','18:20:00',3.93),('9650','2013-07-31','18:25:00',3.79),('9650','2013-07-31','18:30:00',3.64),('9650','2013-07-31','18:35:00',3.5),('9650','2013-07-31','18:40:00',3.35),('9650','2013-07-31','18:45:00',3.18),('9650','2013-07-31','18:50:00',3.03),('9650','2013-07-31','18:55:00',2.87),('9650','2013-07-31','19:00:00',2.7),('9650','2013-07-31','19:05:00',2.52),('9650','2013-07-31','19:10:00',2.32),('9650','2013-07-31','19:15:00',2.15),('9650','2013-07-31','19:20:00',2),('9650','2013-07-31','19:25:00',1.81),('9650','2013-07-31','19:30:00',1.6),('9650','2013-07-31','19:35:00',1.41),('9650','2013-07-31','19:40:00',1.23),('9650','2013-07-31','19:45:00',1.05),('9650','2013-07-30','08:30:00',1.05),('9650','2013-07-30','08:35:00',1.12),('9650','2013-07-30','08:40:00',1.16),('9650','2013-07-30','08:45:00',1.19),('9650','2013-07-30','08:50:00',1.22),('9650','2013-07-30','08:55:00',1.3),('9650','2013-07-30','09:00:00',1.91),('9650','2013-07-30','09:05:00',2.04),('9650','2013-07-30','09:10:00',2.17),('9650','2013-07-30','09:15:00',2.29),('9650','2013-07-30','09:20:00',2.44),('9650','2013-07-30','09:25:00',2.6),('9650','2013-07-30','09:30:00',2.72),('9650','2013-07-30','09:35:00',2.9),('9650','2013-07-30','09:40:00',3.02),('9650','2013-07-30','09:45:00',3.17),('9650','2013-07-30','09:50:00',3.31),('9650','2013-07-30','09:55:00',3.44),('9650','2013-07-30','10:00:00',3.56),('9650','2013-07-30','10:05:00',3.69),('9650','2013-07-30','10:10:00',3.77),('9650','2013-07-30','10:15:00',3.91),('9650','2013-07-30','10:20:00',4.01),('9650','2013-07-30','10:25:00',4.1),('9650','2013-07-30','10:30:00',4.24),('9650','2013-07-30','10:35:00',4.36),('9650','2013-07-30','10:40:00',4.5),('9650','2013-07-30','10:45:00',4.62),('9650','2013-07-30','10:50:00',4.73),('9650','2013-07-30','10:55:00',4.83),('9650','2013-07-30','11:00:00',4.95),('9650','2013-07-30','11:05:00',5.03),('9650','2013-07-30','11:10:00',5.13),('9650','2013-07-30','11:15:00',5.25),('9650','2013-07-30','11:20:00',5.32),('9650','2013-07-30','11:25:00',5.42),('9650','2013-07-30','11:30:00',5.49),('9650','2013-07-30','11:35:00',5.59),('9650','2013-07-30','11:40:00',5.67),('9650','2013-07-30','11:45:00',5.79),('9650','2013-07-30','11:50:00',5.88),('9650','2013-07-30','11:55:00',5.95),('9650','2013-07-30','12:00:00',5.93),('9650','2013-07-30','12:05:00',6.04),('9650','2013-07-30','12:10:00',6.15),('9650','2013-07-30','12:15:00',6.3),('9650','2013-07-30','12:20:00',6.3),('9650','2013-07-30','12:25:00',6.48),('9650','2013-07-30','12:30:00',6.44),('9650','2013-07-30','12:35:00',6.46),('9650','2013-07-30','12:40:00',6.62),('9650','2013-07-30','12:45:00',6.24),('9650','2013-07-30','12:50:00',3.3),('9650','2013-07-30','12:55:00',6.92),('9650','2013-07-30','13:00:00',2.74),('9650','2013-07-30','13:05:00',5.85),('9650','2013-07-30','13:10:00',6.58),('9650','2013-07-30','13:15:00',6.99),('9650','2013-07-30','13:20:00',6.59),('9650','2013-07-30','13:25:00',6.75),('9650','2013-07-30','13:30:00',6.55),('9650','2013-07-30','13:35:00',6.96),('9650','2013-07-30','13:40:00',7.01),('9650','2013-07-30','13:45:00',7.15),('9650','2013-07-30','13:50:00',7.28),('9650','2013-07-30','13:55:00',4.15),('9650','2013-07-30','14:00:00',6.13),('9650','2013-07-30','14:05:00',7.24),('9650','2013-07-30','14:10:00',6.79),('9650','2013-07-30','14:15:00',6.39),('9650','2013-07-30','14:20:00',7.22),('9650','2013-07-30','14:25:00',6.74),('9650','2013-07-30','14:30:00',7.12),('9650','2013-07-30','14:35:00',7.04),('9650','2013-07-30','14:40:00',7.14),('9650','2013-07-30','14:45:00',7.02),('9650','2013-07-30','14:50:00',7.27),('9650','2013-07-30','14:55:00',4.8),('9650','2013-07-30','15:00:00',1.95),('9650','2013-07-30','15:05:00',6.54),('9650','2013-07-30','15:10:00',7.26),('9650','2013-07-30','15:15:00',5.6),('9650','2013-07-30','15:20:00',6.41),('9650','2013-07-30','15:25:00',7.01),('9650','2013-07-30','15:30:00',5.39),('9650','2013-07-30','15:35:00',6.23),('9650','2013-07-30','15:40:00',7.03),('9650','2013-07-30','15:45:00',6.45),('9650','2013-07-30','15:50:00',6.67),('9650','2013-07-30','15:55:00',6.54),('9650','2013-07-30','16:00:00',6.42),('9650','2013-07-30','16:05:00',6.44),('9650','2013-07-30','16:10:00',6.5),('9650','2013-07-30','16:15:00',6.34),('9650','2013-07-30','16:20:00',6.42),('9650','2013-07-30','16:25:00',6.47),('9650','2013-07-30','16:30:00',6.38),('9650','2013-07-30','16:35:00',6.06),('9650','2013-07-30','16:40:00',5.93),('9650','2013-07-30','16:45:00',5.84),('9650','2013-07-30','16:50:00',5.85),('9650','2013-07-30','16:55:00',5.77),('9650','2013-07-30','17:00:00',5.71),('9650','2013-07-30','17:05:00',5.61),('9650','2013-07-30','17:10:00',4.92),('9650','2013-07-30','17:15:00',5.39),('9650','2013-07-30','17:20:00',4.42),('9650','2013-07-30','17:25:00',5.17),('9650','2013-07-30','17:30:00',5),('9650','2013-07-30','17:35:00',4.66),('9650','2013-07-30','17:40:00',4.83),('9650','2013-07-30','17:45:00',4.67),('9650','2013-07-30','17:50:00',4.57),('9650','2013-07-30','17:55:00',4.44),('9650','2013-07-30','18:00:00',4.34),('9650','2013-07-30','18:05:00',4.24),('9650','2013-07-30','18:10:00',4.07),('9650','2013-07-30','18:15:00',4.03),('9650','2013-07-30','18:20:00',3.92),('9650','2013-07-30','18:25:00',3.85),('9650','2013-07-30','18:30:00',3.72),('9650','2013-07-30','18:35:00',3.6),('9650','2013-07-30','18:40:00',3.46),('9650','2013-07-30','18:45:00',3.31),('9650','2013-07-30','18:50:00',3.16),('9650','2013-07-30','18:55:00',3),('9650','2013-07-30','19:00:00',2.84),('9650','2013-07-30','19:05:00',2.67),('9650','2013-07-30','19:10:00',2.49),('9650','2013-07-30','19:15:00',2.29),('9650','2013-07-30','19:20:00',2.1),('9650','2013-07-30','19:25:00',1.9),('9650','2013-07-30','19:30:00',1.7),('9650','2013-07-30','19:35:00',1.46),('9650','2013-07-30','19:40:00',1.31),('9650','2013-07-30','19:45:00',1.08),('9650','2014-04-07','08:10:00',1.01),('9650','2014-04-07','08:15:00',1.01),('9650','2014-04-07','08:20:00',1.06),('9650','2014-04-07','08:55:00',1.07),('9650','2014-04-07','09:00:00',1.14),('9650','2014-04-07','09:05:00',1.27),('9650','2014-04-07','09:10:00',1.38),('9650','2014-04-07','09:15:00',1.49),('9650','2014-04-07','09:20:00',1.62),('9650','2014-04-07','09:25:00',1.76),('9650','2014-04-07','09:30:00',1.88),('9650','2014-04-07','09:35:00',2),('9650','2014-04-07','09:40:00',2.09),('9650','2014-04-07','09:45:00',2.21),('9650','2014-04-07','09:50:00',2.33),('9650','2014-04-07','09:55:00',2.44),('9650','2014-04-07','10:00:00',2.54),('9650','2014-04-07','10:05:00',2.59),('9650','2014-04-07','10:10:00',2.76),('9650','2014-04-07','10:15:00',3.01),('9650','2014-04-07','10:20:00',3.13),('9650','2014-04-07','10:25:00',3.25),('9650','2014-04-07','10:30:00',3.41),('9650','2014-04-07','10:35:00',3.51),('9650','2014-04-07','10:40:00',3.5),('9650','2014-04-07','10:45:00',3.7),('9650','2014-04-07','10:50:00',3.81),('9650','2014-04-07','10:55:00',3.92),('9650','2014-04-07','11:00:00',4.03),('9650','2014-04-07','11:05:00',4.16),('9650','2014-04-07','11:10:00',4.34),('9650','2014-04-07','11:15:00',3.94),('9650','2014-04-07','11:20:00',4.52),('9650','2014-04-07','11:25:00',4.58),('9650','2014-04-07','11:30:00',4.63),('9650','2014-04-07','11:35:00',4.52),('9650','2014-04-07','11:40:00',4.85),('9650','2014-04-07','11:45:00',4.94),('9650','2014-04-07','11:50:00',4.99),('9650','2014-04-07','11:55:00',5.14),('9650','2014-04-07','12:00:00',5.25),('9650','2014-04-07','12:05:00',5.16),('9650','2014-04-07','12:10:00',5.15),('9650','2014-04-07','12:15:00',4.85),('9650','2014-04-07','12:20:00',5.02),('9650','2014-04-07','12:25:00',5.08),('9650','2014-04-07','12:30:00',5.92),('9650','2014-04-07','12:35:00',5.98),('9650','2014-04-07','12:40:00',4.95),('9650','2014-04-07','12:45:00',4.01),('9650','2014-04-07','12:50:00',5.15),('9650','2014-04-07','12:55:00',5.88),('9650','2014-04-07','13:00:00',5.52),('9650','2014-04-07','13:05:00',5.89),('9650','2014-04-07','13:10:00',5.78),('9650','2014-04-07','13:15:00',6.22),('9650','2014-04-07','13:20:00',6.23),('9650','2014-04-07','13:25:00',6.32),('9650','2014-04-07','13:30:00',6.38),('9650','2014-04-07','13:35:00',6.44),('9650','2014-04-07','13:40:00',6.44),('9650','2014-04-07','13:45:00',6.33),('9650','2014-04-07','13:50:00',6.44),('9650','2014-04-07','13:55:00',6.54),('9650','2014-04-07','14:00:00',6.53),('9650','2014-04-07','14:05:00',6.52),('9650','2014-04-07','14:10:00',6.56),('9650','2014-04-07','14:15:00',6.51),('9650','2014-04-07','14:20:00',6.17),('9650','2014-04-07','14:25:00',6.16),('9650','2014-04-07','14:30:00',6.67),('9650','2014-04-07','14:35:00',6.36),('9650','2014-04-07','14:40:00',5.83),('9650','2014-04-07','14:45:00',5.7),('9650','2014-04-07','14:50:00',6.34),('9650','2014-04-07','14:55:00',6.64),('9650','2014-04-07','15:00:00',6.53),('9650','2014-04-07','15:05:00',6.34),('9650','2014-04-07','15:10:00',6.19),('9650','2014-04-07','15:15:00',6.24),('9650','2014-04-07','15:20:00',6.12),('9650','2014-04-07','15:25:00',6.03),('9650','2014-04-07','15:30:00',5.55),('9650','2014-04-07','15:35:00',5.98),('9650','2014-04-07','15:40:00',5.96),('9650','2014-04-07','15:45:00',5.68),('9650','2014-04-07','15:50:00',5.8),('9650','2014-04-07','15:55:00',5.75),('9650','2014-04-07','16:00:00',5.47),('9650','2014-04-07','16:05:00',5.38),('9650','2014-04-07','16:10:00',5.3),('9650','2014-04-07','16:15:00',5.04),('9650','2014-04-07','16:20:00',4.7),('9650','2014-04-07','16:25:00',5.15),('9650','2014-04-07','16:30:00',5.45),('9650','2014-04-07','16:35:00',5.25),('9650','2014-04-07','16:40:00',4.83),('9650','2014-04-07','16:45:00',4.58),('9650','2014-04-07','16:50:00',4.71),('9650','2014-04-07','16:55:00',4.39),('9650','2014-04-07','17:00:00',4.15),('9650','2014-04-07','17:05:00',4.37),('9650','2014-04-07','17:10:00',4.15),('9650','2014-04-07','17:15:00',4.05),('9650','2014-04-07','17:20:00',3.97),('9650','2014-04-07','17:25:00',3.62),('9650','2014-04-07','17:30:00',3.47),('9650','2014-04-07','17:35:00',3.23),('9650','2014-04-07','17:40:00',3.34),('9650','2014-04-07','17:45:00',3.27),('9650','2014-04-07','17:50:00',3.17),('9650','2014-04-07','17:55:00',2.89),('9650','2014-04-07','18:00:00',2.91),('9650','2014-04-07','18:05:00',2.87),('9650','2014-04-07','18:10:00',2.68),('9650','2014-04-07','18:15:00',2.59),('9650','2014-04-07','18:20:00',2.31),('9650','2014-04-07','18:25:00',1.86),('9650','2014-04-07','18:30:00',1.55),('9650','2014-04-07','18:35:00',1.35),('9650','2014-04-07','18:40:00',1.02),('9650','2013-07-29','07:25:00',1.08),('9650','2013-07-29','08:10:00',1.05),('9650','2013-07-29','08:15:00',1.15),('9650','2013-07-29','08:20:00',1.42),('9650','2013-07-29','08:25:00',1.31),('9650','2013-07-29','08:30:00',1.3),('9650','2013-07-29','08:35:00',1.34),('9650','2013-07-29','08:40:00',1.48),('9650','2013-07-29','08:45:00',1.58),('9650','2013-07-29','08:50:00',1.73),('9650','2013-07-29','08:55:00',1.91),('9650','2013-07-29','09:00:00',2.09),('9650','2013-07-29','09:05:00',2.19),('9650','2013-07-29','09:10:00',2.3),('9650','2013-07-29','09:15:00',2.57),('9650','2013-07-29','09:20:00',2.82),('9650','2013-07-29','09:25:00',2.85),('9650','2013-07-29','09:30:00',2.81),('9650','2013-07-29','09:35:00',3.08),('9650','2013-07-29','09:40:00',3.09),('9650','2013-07-29','09:45:00',2.8),('9650','2013-07-29','09:50:00',3.3),('9650','2013-07-29','09:55:00',3.69),('9650','2013-07-29','10:00:00',3.44),('9650','2013-07-29','10:05:00',2.79),('9650','2013-07-29','10:10:00',4.19),('9650','2013-07-29','10:15:00',4.22),('9650','2013-07-29','10:20:00',4.33),('9650','2013-07-29','10:25:00',4.59),('9650','2013-07-29','10:30:00',4.63),('9650','2013-07-29','10:35:00',4.65),('9650','2013-07-29','10:40:00',4.65),('9650','2013-07-29','10:45:00',4.79),('9650','2013-07-29','10:50:00',4.75),('9650','2013-07-29','10:55:00',4.36),('9650','2013-07-29','11:00:00',4.61),('9650','2013-07-29','11:05:00',5.12),('9650','2013-07-29','11:10:00',5.29),('9650','2013-07-29','11:15:00',4.73),('9650','2013-07-29','11:20:00',2),('9650','2013-07-29','11:25:00',1.03),('9650','2013-07-29','11:30:00',3.4),('9650','2013-07-29','11:35:00',5.6),('9650','2013-07-29','11:40:00',5.95),('9650','2013-07-29','11:45:00',5.85),('9650','2013-07-29','11:50:00',4.33),('9650','2013-07-29','11:55:00',5.71),('9650','2013-07-29','12:00:00',5.87),('9650','2013-07-29','12:05:00',6.07),('9650','2013-07-29','12:10:00',5.93),('9650','2013-07-29','12:15:00',6.02),('9650','2013-07-29','12:20:00',6.18),('9650','2013-07-29','12:25:00',6.25),('9650','2013-07-29','12:30:00',6.36),('9650','2013-07-29','12:35:00',5.6),('9650','2013-07-29','12:40:00',1.37),('9650','2013-07-29','12:45:00',4.13),('9650','2013-07-29','12:50:00',7.12),('9650','2013-07-29','12:55:00',7.24),('9650','2013-07-29','13:00:00',4.8),('9650','2013-07-29','13:05:00',4.69),('9650','2013-07-29','13:10:00',7.19),('9650','2013-07-29','13:15:00',4.35),('9650','2013-07-29','13:20:00',6.38),('9650','2013-07-29','13:25:00',7.14),('9650','2013-07-29','13:30:00',7.29),('9650','2013-07-29','13:35:00',7.16),('9650','2013-07-29','13:40:00',7.13),('9650','2013-07-29','13:45:00',7.04),('9650','2013-07-29','13:50:00',7.02),('9650','2013-07-29','13:55:00',7.02),('9650','2013-07-29','14:00:00',7.1),('9650','2013-07-29','14:05:00',4.11),('9650','2013-07-29','14:10:00',3.37),('9650','2013-07-29','14:15:00',6.57),('9650','2013-07-29','14:20:00',7.13),('9650','2013-07-29','14:25:00',7.03),('9650','2013-07-29','14:30:00',7.02),('9650','2013-07-29','14:35:00',7.01),('9650','2013-07-29','14:40:00',6.88),('9650','2013-07-29','14:45:00',6.15),('9650','2013-07-29','14:50:00',6.99),('9650','2013-07-29','14:55:00',6.76),('9650','2013-07-29','15:00:00',6.9),('9650','2013-07-29','15:05:00',6.77),('9650','2013-07-29','15:10:00',6.61),('9650','2013-07-29','15:15:00',6.59),('9650','2013-07-29','15:20:00',6.49),('9650','2013-07-29','15:25:00',6.53),('9650','2013-07-29','15:30:00',6.63),('9650','2013-07-29','15:35:00',6.53),('9650','2013-07-29','15:40:00',6.47),('9650','2013-07-29','15:45:00',6.47),('9650','2013-07-29','15:50:00',6.41),('9650','2013-07-29','15:55:00',6.33),('9650','2013-07-29','16:00:00',6.33),('9650','2013-07-29','16:05:00',6.26),('9650','2013-07-29','16:10:00',6.18),('9650','2013-07-29','16:15:00',6.14),('9650','2013-07-29','16:20:00',6.11),('9650','2013-07-29','16:25:00',6.05),('9650','2013-07-29','16:30:00',5.94),('9650','2013-07-29','16:35:00',5.92),('9650','2013-07-29','16:40:00',5.9),('9650','2013-07-29','16:45:00',5.81),('9650','2013-07-29','16:50:00',5.71),('9650','2013-07-29','16:55:00',5.65),('9650','2013-07-29','17:00:00',5.55),('9650','2013-07-29','17:05:00',5.49),('9650','2013-07-29','17:10:00',5.35),('9650','2013-07-29','17:15:00',5.28),('9650','2013-07-29','17:20:00',5.22),('9650','2013-07-29','17:25:00',5.15),('9650','2013-07-29','17:30:00',5.02),('9650','2013-07-29','17:35:00',4.87),('9650','2013-07-29','17:40:00',4.79),('9650','2013-07-29','17:45:00',4.67),('9650','2013-07-29','17:50:00',4.5),('9650','2013-07-29','17:55:00',4.32),('9650','2013-07-29','18:00:00',4.23),('9650','2013-07-29','18:05:00',4.1),('9650','2013-07-29','18:10:00',3.98),('9650','2013-07-29','18:15:00',3.84),('9650','2013-07-29','18:20:00',3.75),('9650','2013-07-29','18:25:00',3.63),('9650','2013-07-29','18:30:00',3.44),('9650','2013-07-29','18:35:00',3.23),('9650','2013-07-29','18:40:00',3.1),('9650','2013-07-29','18:45:00',2.95),('9650','2013-07-29','18:50:00',2.71),('9650','2013-07-29','18:55:00',2.52),('9650','2013-07-29','19:00:00',2.43),('9650','2013-07-29','19:05:00',2.28),('9650','2013-07-29','19:10:00',2.08),('9650','2013-07-29','19:15:00',1.87),('9650','2013-07-29','19:20:00',1.7),('9650','2013-07-29','19:25:00',1.52),('9650','2013-07-29','19:30:00',1.31),('9650','2013-07-29','19:35:00',1.1),('9650','2013-07-28','08:15:00',1.06),('9650','2013-07-28','08:20:00',1.13),('9650','2013-07-28','08:25:00',1.21),('9650','2013-07-28','08:30:00',1.28),('9650','2013-07-28','08:35:00',1.36),('9650','2013-07-28','08:40:00',1.45),('9650','2013-07-28','08:45:00',1.58),('9650','2013-07-28','08:50:00',1.66),('9650','2013-07-28','08:55:00',1.8),('9650','2013-07-28','09:00:00',1.94),('9650','2013-07-28','09:05:00',2.06),('9650','2013-07-28','09:10:00',2.14),('9650','2013-07-28','09:15:00',2.25),('9650','2013-07-28','09:20:00',2.38),('9650','2013-07-28','09:25:00',2.48),('9650','2013-07-28','09:30:00',2.58),('9650','2013-07-28','09:35:00',2.72),('9650','2013-07-28','09:40:00',2.86),('9650','2013-07-28','09:45:00',3.03),('9650','2013-07-28','09:50:00',3.16),('9650','2013-07-28','09:55:00',3.27),('9650','2013-07-28','10:00:00',3.4),('9650','2013-07-28','10:05:00',3.52),('9650','2013-07-28','10:10:00',3.64),('9650','2013-07-28','10:15:00',3.74),('9650','2013-07-28','10:20:00',3.87),('9650','2013-07-28','10:25:00',4),('9650','2013-07-28','10:30:00',4.06),('9650','2013-07-28','10:35:00',4.14),('9650','2013-07-28','10:40:00',4.25),('9650','2013-07-28','10:45:00',4.38),('9650','2013-07-28','10:50:00',4.45),('9650','2013-07-28','10:55:00',4.53),('9650','2013-07-28','11:00:00',4.64),('9650','2013-07-28','11:05:00',4.73),('9650','2013-07-28','11:10:00',4.85),('9650','2013-07-28','11:15:00',4.91),('9650','2013-07-28','11:20:00',5.02),('9650','2013-07-28','11:25:00',5.08),('9650','2013-07-28','11:30:00',5.12),('9650','2013-07-28','11:35:00',5.16),('9650','2013-07-28','11:40:00',5.21),('9650','2013-07-28','11:45:00',5.3),('9650','2013-07-28','11:50:00',5.35),('9650','2013-07-28','11:55:00',5.37),('9650','2013-07-28','12:00:00',5.45),('9650','2013-07-28','12:05:00',5.55),('9650','2013-07-28','12:10:00',5.67),('9650','2013-07-28','12:15:00',5.71),('9650','2013-07-28','12:20:00',5.78),('9650','2013-07-28','12:25:00',5.83),('9650','2013-07-28','12:30:00',5.89),('9650','2013-07-28','12:35:00',5.92),('9650','2013-07-28','12:40:00',5.99),('9650','2013-07-28','12:45:00',6.02),('9650','2013-07-28','12:50:00',6.08),('9650','2013-07-28','12:55:00',5.97),('9650','2013-07-28','13:00:00',6.15),('9650','2013-07-28','13:05:00',6.16),('9650','2013-07-28','13:10:00',6.25),('9650','2013-07-28','13:15:00',6.31),('9650','2013-07-28','13:20:00',6.45),('9650','2013-07-28','13:25:00',6.49),('9650','2013-07-28','13:30:00',6.56),('9650','2013-07-28','13:35:00',6.58),('9650','2013-07-28','13:40:00',6.61),('9650','2013-07-28','13:45:00',6.68),('9650','2013-07-28','13:50:00',6.71),('9650','2013-07-28','13:55:00',6.72),('9650','2013-07-28','14:00:00',6.73),('9650','2013-07-28','14:05:00',6.73),('9650','2013-07-28','14:10:00',6.75),('9650','2013-07-28','14:15:00',6.75),('9650','2013-07-28','14:20:00',6.74),('9650','2013-07-28','14:25:00',6.73),('9650','2013-07-28','14:30:00',6.76),('9650','2013-07-28','14:35:00',6.76),('9650','2013-07-28','14:40:00',6.75),('9650','2013-07-28','14:45:00',6.72),('9650','2013-07-28','14:50:00',6.69),('9650','2013-07-28','14:55:00',6.7),('9650','2013-07-28','15:00:00',6.69),('9650','2013-07-28','15:05:00',6.67),('9650','2013-07-28','15:10:00',6.68),('9650','2013-07-28','15:15:00',6.65),('9650','2013-07-28','15:20:00',6.63),('9650','2013-07-28','15:25:00',6.63),('9650','2013-07-28','15:30:00',6.62),('9650','2013-07-28','15:35:00',6.63),('9650','2013-07-28','15:40:00',6.79),('9650','2013-07-28','15:45:00',6.94),('9650','2013-07-28','15:50:00',5.55),('9650','2013-07-28','15:55:00',3.84),('9650','2013-07-28','16:00:00',3.61),('9650','2013-07-28','16:05:00',5.53),('9650','2013-07-28','16:10:00',5.87),('9650','2013-07-28','16:15:00',4.73),('9650','2013-07-28','16:20:00',5.18),('9650','2013-07-28','16:25:00',4.92),('9650','2013-07-28','16:30:00',6.31),('9650','2013-07-28','16:35:00',5.42),('9650','2013-07-28','16:40:00',5.1),('9650','2013-07-28','16:45:00',6.28),('9650','2013-07-28','16:50:00',5.74),('9650','2013-07-28','16:55:00',4.07),('9650','2013-07-28','17:00:00',3.04),('9650','2013-07-28','17:05:00',4.42),('9650','2013-07-28','17:10:00',3.08),('9650','2013-07-28','17:15:00',2.39),('9650','2013-07-28','17:20:00',4.98),('9650','2013-07-28','17:25:00',4.88),('9650','2013-07-28','17:30:00',3.18),('9650','2013-07-28','17:35:00',2.01),('9650','2013-07-28','17:40:00',2.83),('9650','2013-07-28','17:45:00',4.72),('9650','2013-07-28','17:50:00',4.41),('9650','2013-07-28','17:55:00',4.13),('9650','2013-07-28','18:00:00',2.98),('9650','2013-07-28','18:05:00',2.27),('9650','2013-07-28','18:10:00',3.53),('9650','2013-07-28','18:15:00',2.91),('9650','2013-07-28','18:20:00',3.51),('9650','2013-07-28','18:25:00',3.34),('9650','2013-07-28','18:30:00',3.26),('9650','2013-07-28','18:35:00',2.95),('9650','2013-07-28','18:40:00',2.16),('9650','2013-07-28','18:45:00',1.17),('9650','2013-07-28','18:50:00',2.01),('9650','2013-07-28','18:55:00',2),('9650','2013-07-28','19:00:00',2.66),('9650','2013-07-28','19:05:00',2.52),('9650','2013-07-28','19:10:00',1.71),('9650','2013-07-27','08:20:00',1.05),('9650','2013-07-27','08:25:00',1.09),('9650','2013-07-27','08:30:00',1.13),('9650','2013-07-27','08:35:00',1.17),('9650','2013-07-27','08:40:00',1.19),('9650','2013-07-27','08:45:00',1.21),('9650','2013-07-27','08:50:00',1.22),('9650','2013-07-27','08:55:00',1.25),('9650','2013-07-27','09:00:00',1.74),('9650','2013-07-27','09:05:00',2.07),('9650','2013-07-27','09:10:00',2.19),('9650','2013-07-27','09:15:00',2.3),('9650','2013-07-27','09:20:00',2.44),('9650','2013-07-27','09:25:00',2.58),('9650','2013-07-27','09:30:00',2.67),('9650','2013-07-27','09:35:00',2.77),('9650','2013-07-27','09:40:00',2.93),('9650','2013-07-27','09:45:00',3.03),('9650','2013-07-27','09:50:00',3.18),('9650','2013-07-27','09:55:00',3.3),('9650','2013-07-27','10:00:00',3.42),('9650','2013-07-27','10:05:00',3.55),('9650','2013-07-27','10:10:00',3.68),('9650','2013-07-27','10:15:00',3.8),('9650','2013-07-27','10:20:00',3.89),('9650','2013-07-27','10:25:00',3.98),('9650','2013-07-27','10:30:00',4.04),('9650','2013-07-27','10:35:00',4.19),('9650','2013-07-27','10:40:00',4.31),('9650','2013-07-27','10:45:00',4.41),('9650','2013-07-27','10:50:00',4.52),('9650','2013-07-27','10:55:00',4.58),('9650','2013-07-27','11:00:00',4.66),('9650','2013-07-27','11:05:00',4.79),('9650','2013-07-27','11:10:00',4.81),('9650','2013-07-27','11:15:00',4.89),('9650','2013-07-27','11:20:00',4.99),('9650','2013-07-27','11:25:00',5.05),('9650','2013-07-27','11:30:00',5.13),('9650','2013-07-27','11:35:00',5.15),('9650','2013-07-27','11:40:00',5.24),('9650','2013-07-27','11:45:00',5.35),('9650','2013-07-27','11:50:00',5.43),('9650','2013-07-27','11:55:00',5.46),('9650','2013-07-27','12:00:00',5.53),('9650','2013-07-27','12:05:00',5.59),('9650','2013-07-27','12:10:00',5.62),('9650','2013-07-27','12:15:00',5.52),('9650','2013-07-27','12:20:00',5.72),('9650','2013-07-27','12:25:00',5.75),('9650','2013-07-27','12:30:00',5.93),('9650','2013-07-27','12:35:00',5.97),('9650','2013-07-27','12:40:00',6.08),('9650','2013-07-27','12:45:00',5.92),('9650','2013-07-27','12:50:00',6.03),('9650','2013-07-27','12:55:00',6.03),('9650','2013-07-27','13:00:00',5.94),('9650','2013-07-27','13:05:00',6.11),('9650','2013-07-27','13:10:00',6.35),('9650','2013-07-27','13:15:00',6.08),('9650','2013-07-27','13:20:00',6.23),('9650','2013-07-27','13:25:00',6.35),('9650','2013-07-27','13:30:00',6.42),('9650','2013-07-27','13:35:00',6.57),('9650','2013-07-27','13:40:00',6.52),('9650','2013-07-27','13:45:00',6.73),('9650','2013-07-27','13:50:00',6.72),('9650','2013-07-27','13:55:00',6.67),('9650','2013-07-27','14:00:00',6.67),('9650','2013-07-27','14:05:00',6.69),('9650','2013-07-27','14:10:00',6.7),('9650','2013-07-27','14:15:00',6.69),('9650','2013-07-27','14:20:00',6.69),('9650','2013-07-27','14:25:00',6.68),('9650','2013-07-27','14:30:00',6.74),('9650','2013-07-27','14:35:00',6.69),('9650','2013-07-27','14:40:00',6.66),('9650','2013-07-27','14:45:00',6.7),('9650','2013-07-27','14:50:00',6.64),('9650','2013-07-27','14:55:00',6.65),('9650','2013-07-27','15:00:00',6.68),('9650','2013-07-27','15:05:00',6.69),('9650','2013-07-27','15:10:00',6.66),('9650','2013-07-27','15:15:00',6.54),('9650','2013-07-27','15:20:00',6.49),('9650','2013-07-27','15:25:00',6.53),('9650','2013-07-27','15:30:00',6.49),('9650','2013-07-27','15:35:00',6.46),('9650','2013-07-27','15:40:00',6.51),('9650','2013-07-27','15:45:00',6.38),('9650','2013-07-27','15:50:00',6.35),('9650','2013-07-27','15:55:00',6.3),('9650','2013-07-27','16:00:00',6.27),('9650','2013-07-27','16:05:00',6.24),('9650','2013-07-27','16:10:00',6.17),('9650','2013-07-27','16:15:00',6.18),('9650','2013-07-27','16:20:00',6.14),('9650','2013-07-27','16:25:00',6.11),('9650','2013-07-27','16:30:00',6.05),('9650','2013-07-27','16:35:00',5.97),('9650','2013-07-27','16:40:00',5.89),('9650','2013-07-27','16:45:00',5.84),('9650','2013-07-27','16:50:00',5.76),('9650','2013-07-27','16:55:00',5.7),('9650','2013-07-27','17:00:00',5.61),('9650','2013-07-27','17:05:00',5.52),('9650','2013-07-27','17:10:00',5.4),('9650','2013-07-27','17:15:00',5.35),('9650','2013-07-27','17:20:00',5.25),('9650','2013-07-27','17:25:00',5.13),('9650','2013-07-27','17:30:00',5),('9650','2013-07-27','17:35:00',4.91),('9650','2013-07-27','17:40:00',4.83),('9650','2013-07-27','17:45:00',4.75),('9650','2013-07-27','17:50:00',4.63),('9650','2013-07-27','17:55:00',4.49),('9650','2013-07-27','18:00:00',4.29),('9650','2013-07-27','18:05:00',4.19),('9650','2013-07-27','18:10:00',4.04),('9650','2013-07-27','18:15:00',3.95),('9650','2013-07-27','18:20:00',3.84),('9650','2013-07-27','18:25:00',3.71),('9650','2013-07-27','18:30:00',3.55),('9650','2013-07-27','18:35:00',3.38),('9650','2013-07-27','18:40:00',3.21),('9650','2013-07-27','18:45:00',3.02),('9650','2013-07-27','18:50:00',2.87),('9650','2013-07-27','18:55:00',2.69),('9650','2013-07-27','19:00:00',2.52),('9650','2013-07-27','19:05:00',2.34),('9650','2013-07-27','19:10:00',2.16),('9650','2013-07-27','19:15:00',1.97),('9650','2013-07-27','19:20:00',1.74),('9650','2013-07-27','19:25:00',1.55),('9650','2013-07-27','19:30:00',1.4),('9650','2013-07-27','19:35:00',1.21),('9650','2013-07-27','19:40:00',1.01),('9650','2013-07-26','08:15:00',1.05),('9650','2013-07-26','08:20:00',1.12),('9650','2013-07-26','08:25:00',1.2),('9650','2013-07-26','08:30:00',1.3),('9650','2013-07-26','08:35:00',1.4),('9650','2013-07-26','08:40:00',1.52),('9650','2013-07-26','08:45:00',1.62),('9650','2013-07-26','08:50:00',1.73),('9650','2013-07-26','08:55:00',1.88),('9650','2013-07-26','09:00:00',2.01),('9650','2013-07-26','09:05:00',2.12),('9650','2013-07-26','09:10:00',2.25),('9650','2013-07-26','09:15:00',2.35),('9650','2013-07-26','09:20:00',2.5),('9650','2013-07-26','09:25:00',2.61),('9650','2013-07-26','09:30:00',2.75),('9650','2013-07-26','09:35:00',2.88),('9650','2013-07-26','09:40:00',3),('9650','2013-07-26','09:45:00',3.15),('9650','2013-07-26','09:50:00',3.28),('9650','2013-07-26','09:55:00',3.39),('9650','2013-07-26','10:00:00',3.56),('9650','2013-07-26','10:05:00',3.66),('9650','2013-07-26','10:10:00',3.79),('9650','2013-07-26','10:15:00',3.86),('9650','2013-07-26','10:20:00',3.97),('9650','2013-07-26','10:25:00',4.05),('9650','2013-07-26','10:30:00',4.15),('9650','2013-07-26','10:35:00',4.3),('9650','2013-07-26','10:40:00',4.32),('9650','2013-07-26','10:45:00',4.46),('9650','2013-07-26','10:50:00',4.6),('9650','2013-07-26','10:55:00',4.66),('9650','2013-07-26','11:00:00',4.7),('9650','2013-07-26','11:05:00',4.81),('9650','2013-07-26','11:10:00',4.97),('9650','2013-07-26','11:15:00',5.13),('9650','2013-07-26','11:20:00',5.19),('9650','2013-07-26','11:25:00',5.24),('9650','2013-07-26','11:30:00',5.29),('9650','2013-07-26','11:35:00',5.33),('9650','2013-07-26','11:40:00',5.36),('9650','2013-07-26','11:45:00',5.46),('9650','2013-07-26','11:50:00',5.6),('9650','2013-07-26','11:55:00',5.65),('9650','2013-07-26','12:00:00',5.59),('9650','2013-07-26','12:05:00',5.7),('9650','2013-07-26','12:10:00',5.78),('9650','2013-07-26','12:15:00',5.82),('9650','2013-07-26','12:20:00',5.82),('9650','2013-07-26','12:25:00',5.81),('9650','2013-07-26','12:30:00',5.93),('9650','2013-07-26','12:35:00',5.82),('9650','2013-07-26','12:40:00',5.93),('9650','2013-07-26','12:45:00',5.9),('9650','2013-07-26','12:50:00',6.17),('9650','2013-07-26','12:55:00',6.39),('9650','2013-07-26','13:00:00',6.36),('9650','2013-07-26','13:05:00',2.25),('9650','2013-07-26','13:10:00',3.9),('9650','2013-07-26','13:15:00',6.23),('9650','2013-07-26','13:20:00',6.53),('9650','2013-07-26','13:25:00',6.48),('9650','2013-07-26','13:30:00',6.51),('9650','2013-07-26','13:35:00',6.5),('9650','2013-07-26','13:40:00',6.57),('9650','2013-07-26','13:45:00',6.47),('9650','2013-07-26','13:50:00',6.55),('9650','2013-07-26','13:55:00',6.66),('9650','2013-07-26','14:00:00',6.62),('9650','2013-07-26','14:05:00',6.76),('9650','2013-07-26','14:10:00',6.8),('9650','2013-07-26','14:15:00',6.7),('9650','2013-07-26','14:20:00',6.64),('9650','2013-07-26','14:25:00',6.68),('9650','2013-07-26','14:30:00',6.6),('9650','2013-07-26','14:35:00',6.66),('9650','2013-07-26','14:40:00',6.64),('9650','2013-07-26','14:45:00',6.58),('9650','2013-07-26','14:50:00',6.71),('9650','2013-07-26','14:55:00',6.72),('9650','2013-07-26','15:00:00',6.65),('9650','2013-07-26','15:05:00',6.63),('9650','2013-07-26','15:10:00',6.65),('9650','2013-07-26','15:15:00',6.68),('9650','2013-07-26','15:20:00',6.64),('9650','2013-07-26','15:25:00',6.61),('9650','2013-07-26','15:30:00',6.59),('9650','2013-07-26','15:35:00',6.6),('9650','2013-07-26','15:40:00',6.52),('9650','2013-07-26','15:45:00',6.49),('9650','2013-07-26','15:50:00',6.43),('9650','2013-07-26','15:55:00',6.35),('9650','2013-07-26','16:00:00',6.33),('9650','2013-07-26','16:05:00',6.29),('9650','2013-07-26','16:10:00',6.23),('9650','2013-07-26','16:15:00',6.17),('9650','2013-07-26','16:20:00',6.12),('9650','2013-07-26','16:25:00',6.07),('9650','2013-07-26','16:30:00',6.08),('9650','2013-07-26','16:35:00',5.98),('9650','2013-07-26','16:40:00',5.94),('9650','2013-07-26','16:45:00',5.85),('9650','2013-07-26','16:50:00',5.78),('9650','2013-07-26','16:55:00',5.68),('9650','2013-07-26','17:00:00',5.47),('9650','2013-07-26','17:05:00',5.48),('9650','2013-07-26','17:10:00',5.42),('9650','2013-07-26','17:15:00',5.31),('9650','2013-07-26','17:20:00',5.26),('9650','2013-07-26','17:25:00',5.14),('9650','2013-07-26','17:30:00',5.03),('9650','2013-07-26','17:35:00',4.94),('9650','2013-07-26','17:40:00',4.81),('9650','2013-07-26','17:45:00',4.72),('9650','2013-07-26','17:50:00',4.62),('9650','2013-07-26','17:55:00',4.52),('9650','2013-07-26','18:00:00',4.42),('9650','2013-07-26','18:05:00',4.3),('9650','2013-07-26','18:10:00',4.18),('9650','2013-07-26','18:15:00',4.03),('9650','2013-07-26','18:20:00',3.9),('9650','2013-07-26','18:25:00',3.78),('9650','2013-07-26','18:30:00',3.66),('9650','2013-07-26','18:35:00',3.52),('9650','2013-07-26','18:40:00',3.34),('9650','2013-07-26','18:45:00',3.2),('9650','2013-07-26','18:50:00',3.02),('9650','2013-07-26','18:55:00',2.81),('9650','2013-07-26','19:00:00',2.7),('9650','2013-07-26','19:05:00',2.53),('9650','2013-07-26','19:10:00',2.37),('9650','2013-07-26','19:15:00',2.16),('9650','2013-07-26','19:20:00',1.93),('9650','2013-07-26','19:25:00',1.71),('9650','2013-07-26','19:30:00',1.49),('9650','2013-07-26','19:35:00',1.3),('9650','2013-07-26','19:40:00',1.15),('9650','2013-07-26','19:45:00',1.05),('9650','2013-07-25','08:05:00',1.01),('9650','2013-07-25','08:10:00',1.09),('9650','2013-07-25','08:15:00',1.15),('9650','2013-07-25','08:20:00',1.19),('9650','2013-07-25','08:25:00',1.28),('9650','2013-07-25','08:30:00',1.39),('9650','2013-07-25','08:35:00',1.51),('9650','2013-07-25','08:40:00',1.54),('9650','2013-07-25','08:45:00',1.71),('9650','2013-07-25','08:50:00',1.8),('9650','2013-07-25','08:55:00',1.97),('9650','2013-07-25','09:00:00',2.08),('9650','2013-07-25','09:05:00',2.17),('9650','2013-07-25','09:10:00',2.26),('9650','2013-07-25','09:15:00',2.35),('9650','2013-07-25','09:20:00',2.46),('9650','2013-07-25','09:25:00',2.62),('9650','2013-07-25','09:30:00',2.68),('9650','2013-07-25','09:35:00',2.73),('9650','2013-07-25','09:40:00',2.95),('9650','2013-07-25','09:45:00',3.09),('9650','2013-07-25','09:50:00',3.2),('9650','2013-07-25','09:55:00',3.4),('9650','2013-07-25','10:00:00',3.55),('9650','2013-07-25','10:05:00',3.67),('9650','2013-07-25','10:10:00',3.71),('9650','2013-07-25','10:15:00',3.76),('9650','2013-07-25','10:20:00',3.9),('9650','2013-07-25','10:25:00',4.01),('9650','2013-07-25','10:30:00',4.05),('9650','2013-07-25','10:35:00',4.23),('9650','2013-07-25','10:40:00',4.33),('9650','2013-07-25','10:45:00',4.47),('9650','2013-07-25','10:50:00',4.58),('9650','2013-07-25','10:55:00',4.55),('9650','2013-07-25','11:00:00',4.71),('9650','2013-07-25','11:05:00',4.48),('9650','2013-07-25','11:10:00',4.69),('9650','2013-07-25','11:15:00',5.1),('9650','2013-07-25','11:20:00',5.23),('9650','2013-07-25','11:25:00',4.96),('9650','2013-07-25','11:30:00',5.09),('9650','2013-07-25','11:35:00',5.25),('9650','2013-07-25','11:40:00',5.46),('9650','2013-07-25','11:45:00',5.48),('9650','2013-07-25','11:50:00',5.69),('9650','2013-07-25','11:55:00',5.74),('9650','2013-07-25','12:00:00',5.55),('9650','2013-07-25','12:05:00',5.71),('9650','2013-07-25','12:10:00',4.73),('9650','2013-07-25','12:15:00',4.6),('9650','2013-07-25','12:20:00',6.24),('9650','2013-07-25','12:25:00',6.09),('9650','2013-07-25','12:30:00',6.28),('9650','2013-07-25','12:35:00',6.3),('9650','2013-07-25','12:40:00',6.62),('9650','2013-07-25','12:45:00',6.63),('9650','2013-07-25','12:50:00',6.69),('9650','2013-07-25','12:55:00',3.96),('9650','2013-07-25','13:00:00',1.97),('9650','2013-07-25','13:05:00',1.89),('9650','2013-07-25','13:10:00',2.26),('9650','2013-07-25','13:15:00',6.45),('9650','2013-07-25','13:20:00',3.42),('9650','2013-07-25','13:25:00',4.55),('9650','2013-07-25','13:30:00',5.24),('9650','2013-07-25','13:35:00',6.86),('9650','2013-07-25','13:40:00',7),('9650','2013-07-25','13:45:00',7.12),('9650','2013-07-25','13:50:00',7.07),('9650','2013-07-25','13:55:00',6.79),('9650','2013-07-25','14:00:00',7),('9650','2013-07-25','14:05:00',6.88),('9650','2013-07-25','14:10:00',6.84),('9650','2013-07-25','14:15:00',6.95),('9650','2013-07-25','14:20:00',6.8),('9650','2013-07-25','14:25:00',6.79),('9650','2013-07-25','14:30:00',6.78),('9650','2013-07-25','14:35:00',6.84),('9650','2013-07-25','14:40:00',6.81),('9650','2013-07-25','14:45:00',6.83),('9650','2013-07-25','14:50:00',6.82),('9650','2013-07-25','14:55:00',6.78),('9650','2013-07-25','15:00:00',6.84),('9650','2013-07-25','15:05:00',6.81),('9650','2013-07-25','15:10:00',6.71),('9650','2013-07-25','15:15:00',6.64),('9650','2013-07-25','15:20:00',6.62),('9650','2013-07-25','15:25:00',6.59),('9650','2013-07-25','15:30:00',6.59),('9650','2013-07-25','15:35:00',6.64),('9650','2013-07-25','15:40:00',6.61),('9650','2013-07-25','15:45:00',6.61),('9650','2013-07-25','15:50:00',6.52),('9650','2013-07-25','15:55:00',6.45),('9650','2013-07-25','16:00:00',6.4),('9650','2013-07-25','16:05:00',6.36),('9650','2013-07-25','16:10:00',6.26),('9650','2013-07-25','16:15:00',6.21),('9650','2013-07-25','16:20:00',6.19),('9650','2013-07-25','16:25:00',6.15),('9650','2013-07-25','16:30:00',6.1),('9650','2013-07-25','16:35:00',5.98),('9650','2013-07-25','16:40:00',5.98),('9650','2013-07-25','16:45:00',5.96),('9650','2013-07-25','16:50:00',5.87),('9650','2013-07-25','16:55:00',5.72),('9650','2013-07-25','17:00:00',5.66),('9650','2013-07-25','17:05:00',5.56),('9650','2013-07-25','17:10:00',5.49),('9650','2013-07-25','17:15:00',5.3),('9650','2013-07-25','17:20:00',5.21),('9650','2013-07-25','17:25:00',5.13),('9650','2013-07-25','17:30:00',4.97),('9650','2013-07-25','17:35:00',4.84),('9650','2013-07-25','17:40:00',4.75),('9650','2013-07-25','17:45:00',4.62),('9650','2013-07-25','17:50:00',4.39),('9650','2013-07-25','17:55:00',4.23),('9650','2013-07-25','18:00:00',4.02),('9650','2013-07-25','18:05:00',4.02),('9650','2013-07-25','18:10:00',3.87),('9650','2013-07-25','18:15:00',3.64),('9650','2013-07-25','18:20:00',3.53),('9650','2013-07-25','18:25:00',3.52),('9650','2013-07-25','18:30:00',3.36),('9650','2013-07-25','18:35:00',3.2),('9650','2013-07-25','18:40:00',3.01),('9650','2013-07-25','18:45:00',2.84),('9650','2013-07-25','18:50:00',2.73),('9650','2013-07-25','18:55:00',2.53),('9650','2013-07-25','19:00:00',2.37),('9650','2013-07-25','19:05:00',2.21),('9650','2013-07-25','19:10:00',2.03),('9650','2013-07-25','19:15:00',1.84),('9650','2013-07-25','19:20:00',1.64),('9650','2013-07-25','19:25:00',1.48),('9650','2013-07-25','19:30:00',1.34),('9650','2013-07-25','19:35:00',1.18),('9650','2013-07-25','19:40:00',1.01),('9650','2013-07-24','08:10:00',1.05),('9650','2013-07-24','08:15:00',1.1),('9650','2013-07-24','08:20:00',1.14),('9650','2013-07-24','08:25:00',1.18),('9650','2013-07-24','08:30:00',1.2),('9650','2013-07-24','08:35:00',1.24),('9650','2013-07-24','08:40:00',1.26),('9650','2013-07-24','08:45:00',1.29),('9650','2013-07-24','08:50:00',1.81),('9650','2013-07-24','08:55:00',2),('9650','2013-07-24','09:00:00',2.05),('9650','2013-07-24','09:05:00',2.21),('9650','2013-07-24','09:10:00',2.43),('9650','2013-07-24','09:15:00',2.68),('9650','2013-07-24','09:20:00',2.43),('9650','2013-07-24','09:25:00',1.45),('9650','2013-07-24','09:30:00',1.92),('9650','2013-07-24','09:35:00',2.68),('9650','2013-07-24','09:40:00',2.18),('9650','2013-07-24','09:45:00',1.82),('9650','2013-07-24','09:50:00',1.79),('9650','2013-07-24','09:55:00',1.26),('9650','2013-07-24','10:00:00',2.54),('9650','2013-07-24','10:05:00',3.71),('9650','2013-07-24','10:10:00',3.89),('9650','2013-07-24','10:15:00',4.04),('9650','2013-07-24','10:20:00',4.19),('9650','2013-07-24','10:25:00',3.64),('9650','2013-07-24','10:30:00',2.89),('9650','2013-07-24','10:35:00',2.18),('9650','2013-07-24','10:40:00',1.95),('9650','2013-07-24','10:45:00',2.65),('9650','2013-07-24','10:50:00',4.98),('9650','2013-07-24','10:55:00',4.76),('9650','2013-07-24','11:00:00',5.06),('9650','2013-07-24','11:05:00',5.35),('9650','2013-07-24','11:10:00',5.01),('9650','2013-07-24','11:15:00',5.27),('9650','2013-07-24','11:20:00',5.27),('9650','2013-07-24','11:25:00',5.79),('9650','2013-07-24','11:30:00',5.75),('9650','2013-07-24','11:35:00',4.74),('9650','2013-07-24','11:40:00',4.88),('9650','2013-07-24','11:45:00',5.21),('9650','2013-07-24','11:50:00',4.31),('9650','2013-07-24','11:55:00',4.67),('9650','2013-07-24','12:00:00',6.12),('9650','2013-07-24','12:05:00',3.1),('9650','2013-07-24','12:10:00',4.5),('9650','2013-07-24','12:15:00',3.99),('9650','2013-07-24','12:20:00',4.61),('9650','2013-07-24','12:25:00',4.04),('9650','2013-07-24','12:30:00',5.77),('9650','2013-07-24','12:35:00',3.96),('9650','2013-07-24','12:40:00',2.79),('9650','2013-07-24','12:45:00',4.18),('9650','2013-07-24','12:50:00',4.57),('9650','2013-07-24','12:55:00',5.27),('9650','2013-07-24','13:00:00',7.07),('9650','2013-07-24','13:05:00',6.97),('9650','2013-07-24','13:10:00',6.73),('9650','2013-07-24','13:15:00',7.02),('9650','2013-07-24','13:20:00',6.86),('9650','2013-07-24','13:25:00',6.82),('9650','2013-07-24','13:30:00',6.79),('9650','2013-07-24','13:35:00',6.76),('9650','2013-07-24','13:40:00',6.92),('9650','2013-07-24','13:45:00',6.94),('9650','2013-07-24','13:50:00',7.09),('9650','2013-07-24','13:55:00',7),('9650','2013-07-24','14:00:00',6.99),('9650','2013-07-24','14:05:00',6.84),('9650','2013-07-24','14:10:00',7.11),('9650','2013-07-24','14:15:00',7.16),('9650','2013-07-24','14:20:00',7.14),('9650','2013-07-24','14:25:00',7.09),('9650','2013-07-24','14:30:00',7.12),('9650','2013-07-24','14:35:00',7.08),('9650','2013-07-24','14:40:00',7.07),('9650','2013-07-24','14:45:00',7.06),('9650','2013-07-24','14:50:00',7.08),('9650','2013-07-24','14:55:00',7.06),('9650','2013-07-24','15:00:00',7.1),('9650','2013-07-24','15:05:00',7.04),('9650','2013-07-24','15:10:00',6.84),('9650','2013-07-24','15:15:00',6.99),('9650','2013-07-24','15:20:00',7),('9650','2013-07-24','15:25:00',6.94),('9650','2013-07-24','15:30:00',6.9),('9650','2013-07-24','15:35:00',6.91),('9650','2013-07-24','15:40:00',6.91),('9650','2013-07-24','15:45:00',6.87),('9650','2013-07-24','15:50:00',6.79),('9650','2013-07-24','15:55:00',6.75),('9650','2013-07-24','16:00:00',6.72),('9650','2013-07-24','16:05:00',6.58),('9650','2013-07-24','16:10:00',6.58),('9650','2013-07-24','16:15:00',6.55),('9650','2013-07-24','16:20:00',6.47),('9650','2013-07-24','16:25:00',6.39),('9650','2013-07-24','16:30:00',6.31),('9650','2013-07-24','16:35:00',6.22),('9650','2013-07-24','16:40:00',6.26),('9650','2013-07-24','16:45:00',6.18),('9650','2013-07-24','16:50:00',6),('9650','2013-07-24','16:55:00',6.03),('9650','2013-07-24','17:00:00',5.94),('9650','2013-07-24','17:05:00',5.86),('9650','2013-07-24','17:10:00',5.71),('9650','2013-07-24','17:15:00',5.64),('9650','2013-07-24','17:20:00',5.54),('9650','2013-07-24','17:25:00',5.46),('9650','2013-07-24','17:30:00',5.37),('9650','2013-07-24','17:35:00',5.28),('9650','2013-07-24','17:40:00',5.14),('9650','2013-07-24','17:45:00',4.99),('9650','2013-07-24','17:50:00',4.86),('9650','2013-07-24','17:55:00',4.76),('9650','2013-07-24','18:00:00',4.63),('9650','2013-07-24','18:05:00',4.49),('9650','2013-07-24','18:10:00',4.39),('9650','2013-07-24','18:15:00',4.14),('9650','2013-07-24','18:20:00',4),('9650','2013-07-24','18:25:00',3.74),('9650','2013-07-24','18:30:00',3.73),('9650','2013-07-24','18:35:00',3.59),('9650','2013-07-24','18:40:00',3.45),('9650','2013-07-24','18:45:00',3.22),('9650','2013-07-24','18:50:00',3),('9650','2013-07-24','18:55:00',2.79),('9650','2013-07-24','19:00:00',2.71),('9650','2013-07-24','19:05:00',2.49),('9650','2013-07-24','19:10:00',2.34),('9650','2013-07-24','19:15:00',2.17),('9650','2013-07-24','19:20:00',1.92),('9650','2013-07-24','19:25:00',1.68),('9650','2013-07-24','19:30:00',1.48),('9650','2013-07-24','19:35:00',1.33),('9650','2013-07-24','19:40:00',1.1),('9650','2013-07-23','07:40:00',1.09),('9650','2013-07-23','07:45:00',1.08),('9650','2013-07-23','07:50:00',1.28),('9650','2013-07-23','07:55:00',1.3),('9650','2013-07-23','08:00:00',1.3),('9650','2013-07-23','08:05:00',1.3),('9650','2013-07-23','08:10:00',1.25),('9650','2013-07-23','08:15:00',1.37),('9650','2013-07-23','08:20:00',1.67),('9650','2013-07-23','08:25:00',1.63),('9650','2013-07-23','08:30:00',1.57),('9650','2013-07-23','08:35:00',1.55),('9650','2013-07-23','08:40:00',1.43),('9650','2013-07-23','08:45:00',1.75),('9650','2013-07-23','08:50:00',2.11),('9650','2013-07-23','08:55:00',2.16),('9650','2013-07-23','09:00:00',2.64),('9650','2013-07-23','09:05:00',2.25),('9650','2013-07-23','09:10:00',2.87),('9650','2013-07-23','09:15:00',2.48),('9650','2013-07-23','09:20:00',2.45),('9650','2013-07-23','09:25:00',2.18),('9650','2013-07-23','09:30:00',2.67),('9650','2013-07-23','09:35:00',2.55),('9650','2013-07-23','09:40:00',2.93),('9650','2013-07-23','09:45:00',2.78),('9650','2013-07-23','09:50:00',2.29),('9650','2013-07-23','09:55:00',2.32),('9650','2013-07-23','10:00:00',1.41),('9650','2013-07-23','10:05:00',1.23),('9650','2013-07-23','10:10:00',1.4),('9650','2013-07-23','10:15:00',1.76),('9650','2013-07-23','10:20:00',2.65),('9650','2013-07-23','10:25:00',4.56),('9650','2013-07-23','10:30:00',4.61),('9650','2013-07-23','10:35:00',5.02),('9650','2013-07-23','10:40:00',4.94),('9650','2013-07-23','10:45:00',2.47),('9650','2013-07-23','10:50:00',3.47),('9650','2013-07-23','10:55:00',3.32),('9650','2013-07-23','11:00:00',4.47),('9650','2013-07-23','11:05:00',2.89),('9650','2013-07-23','11:10:00',3.67),('9650','2013-07-23','11:15:00',5.61),('9650','2013-07-23','11:20:00',5.42),('9650','2013-07-23','11:25:00',5.1),('9650','2013-07-23','11:30:00',5.8),('9650','2013-07-23','11:35:00',5.4),('9650','2013-07-23','11:40:00',5.85),('9650','2013-07-23','11:45:00',5.95),('9650','2013-07-23','11:50:00',6.02),('9650','2013-07-23','11:55:00',6.06),('9650','2013-07-23','12:00:00',6.31),('9650','2013-07-23','12:05:00',6.32),('9650','2013-07-23','12:10:00',6.63),('9650','2013-07-23','12:15:00',6.74),('9650','2013-07-23','12:20:00',4.28),('9650','2013-07-23','12:25:00',3.12),('9650','2013-07-23','12:30:00',7.09),('9650','2013-07-23','12:35:00',3.02),('9650','2013-07-23','12:40:00',2.17),('9650','2013-07-23','12:45:00',4.84),('9650','2013-07-23','12:50:00',5.74),('9650','2013-07-23','12:55:00',7.21),('9650','2013-07-23','13:00:00',7.02),('9650','2013-07-23','13:05:00',6.97),('9650','2013-07-23','13:10:00',5.82),('9650','2013-07-23','13:15:00',2.63),('9650','2013-07-23','13:20:00',3.24),('9650','2013-07-23','13:25:00',3.33),('9650','2013-07-23','13:30:00',7.26),('9650','2013-07-23','13:35:00',6.05),('9650','2013-07-23','13:40:00',2.71),('9650','2013-07-23','13:45:00',4.95),('9650','2013-07-23','13:50:00',7.5),('9650','2013-07-23','13:55:00',7.3),('9650','2013-07-23','14:00:00',6.61),('9650','2013-07-23','14:05:00',7.32),('9650','2013-07-23','14:10:00',7.42),('9650','2013-07-23','14:15:00',7.14),('9650','2013-07-23','14:20:00',6.68),('9650','2013-07-23','14:25:00',7.44),('9650','2013-07-23','14:30:00',7.32),('9650','2013-07-23','14:35:00',7.66),('9650','2013-07-23','14:40:00',7.15),('9650','2013-07-23','14:45:00',7.29),('9650','2013-07-23','14:50:00',7.21),('9650','2013-07-23','14:55:00',7.18),('9650','2013-07-23','15:00:00',7.05),('9650','2013-07-23','15:05:00',7.06),('9650','2013-07-23','15:10:00',7.04),('9650','2013-07-23','15:15:00',7.09),('9650','2013-07-23','15:20:00',7.09),('9650','2013-07-23','15:25:00',7.09),('9650','2013-07-23','15:30:00',6.67),('9650','2013-07-23','15:35:00',6.69),('9650','2013-07-23','15:40:00',6.95),('9650','2013-07-23','15:45:00',6.76),('9650','2013-07-23','15:50:00',6.68),('9650','2013-07-23','15:55:00',6.7),('9650','2013-07-23','16:00:00',6.68),('9650','2013-07-23','16:05:00',6.47),('9650','2013-07-23','16:10:00',6.46),('9650','2013-07-23','16:15:00',6.58),('9650','2013-07-23','16:20:00',6.6),('9650','2013-07-23','16:25:00',6.57),('9650','2013-07-23','16:30:00',6.49),('9650','2013-07-23','16:35:00',6.42),('9650','2013-07-23','16:40:00',6.39),('9650','2013-07-23','16:45:00',6.13),('9650','2013-07-23','16:50:00',6.2),('9650','2013-07-23','16:55:00',6.35),('9650','2013-07-23','17:00:00',6.28),('9650','2013-07-23','17:05:00',6.08),('9650','2013-07-23','17:10:00',5.32),('9650','2013-07-23','17:15:00',5.67),('9650','2013-07-23','17:20:00',5.62),('9650','2013-07-23','17:25:00',5.44),('9650','2013-07-23','17:30:00',5.36),('9650','2013-07-23','17:35:00',5.1),('9650','2013-07-23','17:40:00',4.98),('9650','2013-07-23','17:45:00',4.85),('9650','2013-07-23','17:50:00',4.68),('9650','2013-07-23','17:55:00',4.52),('9650','2013-07-23','18:00:00',4.4),('9650','2013-07-23','18:05:00',4.18),('9650','2013-07-23','18:10:00',4.08),('9650','2013-07-23','18:15:00',3.82),('9650','2013-07-23','18:20:00',3.74),('9650','2013-07-23','18:25:00',3.71),('9650','2013-07-23','18:30:00',3.65),('9650','2013-07-23','18:35:00',3.48),('9650','2013-07-23','18:40:00',3.32),('9650','2013-07-23','18:45:00',3),('9650','2013-07-23','18:50:00',2.84),('9650','2013-07-23','18:55:00',2.42),('9650','2013-07-23','19:00:00',2.03),('9650','2013-07-23','19:05:00',2.43),('9650','2013-07-23','19:10:00',2.08),('9650','2013-07-23','19:15:00',1.8),('9650','2013-07-23','19:20:00',1.96),('9650','2013-07-23','19:25:00',1.71),('9650','2013-07-23','19:30:00',1.37),('9650','2013-07-23','19:35:00',1.01),('9650','2013-07-23','19:40:00',1.15),('9650','2013-07-23','19:45:00',1.04),('9650','2013-07-22','08:10:00',1.03),('9650','2013-07-22','08:15:00',1.09),('9650','2013-07-22','08:20:00',1.16),('9650','2013-07-22','08:25:00',1.25),('9650','2013-07-22','08:30:00',1.35),('9650','2013-07-22','08:35:00',1.5),('9650','2013-07-22','08:40:00',1.63),('9650','2013-07-22','08:45:00',1.78),('9650','2013-07-22','08:50:00',1.92),('9650','2013-07-22','08:55:00',2.07),('9650','2013-07-22','09:00:00',2.19),('9650','2013-07-22','09:05:00',2.29),('9650','2013-07-22','09:10:00',2.4),('9650','2013-07-22','09:15:00',2.52),('9650','2013-07-22','09:20:00',2.6),('9650','2013-07-22','09:25:00',2.76),('9650','2013-07-22','09:30:00',2.88),('9650','2013-07-22','09:35:00',3.01),('9650','2013-07-22','09:40:00',3.14),('9650','2013-07-22','09:45:00',3.23),('9650','2013-07-22','09:50:00',3.34),('9650','2013-07-22','09:55:00',3.49),('9650','2013-07-22','10:00:00',3.61),('9650','2013-07-22','10:05:00',3.73),('9650','2013-07-22','10:10:00',3.83),('9650','2013-07-22','10:15:00',3.93),('9650','2013-07-22','10:20:00',4.04),('9650','2013-07-22','10:25:00',4.16),('9650','2013-07-22','10:30:00',4.34),('9650','2013-07-22','10:35:00',4.47),('9650','2013-07-22','10:40:00',4.6),('9650','2013-07-22','10:45:00',4.66),('9650','2013-07-22','10:50:00',4.76),('9650','2013-07-22','10:55:00',4.91),('9650','2013-07-22','11:00:00',4.97),('9650','2013-07-22','11:05:00',5.05),('9650','2013-07-22','11:10:00',5.16),('9650','2013-07-22','11:15:00',5.27),('9650','2013-07-22','11:20:00',5.43),('9650','2013-07-22','11:25:00',5.47),('9650','2013-07-22','11:30:00',5.61),('9650','2013-07-22','11:35:00',5.65),('9650','2013-07-22','11:40:00',5.8),('9650','2013-07-22','11:45:00',5.8),('9650','2013-07-22','11:50:00',5.83),('9650','2013-07-22','11:55:00',6.03),('9650','2013-07-22','12:00:00',6.1),('9650','2013-07-22','12:05:00',6.22),('9650','2013-07-22','12:10:00',6.35),('9650','2013-07-22','12:15:00',6.41),('9650','2013-07-22','12:20:00',6.29),('9650','2013-07-22','12:25:00',6.45),('9650','2013-07-22','12:30:00',6.48),('9650','2013-07-22','12:35:00',4.95),('9650','2013-07-22','12:40:00',2.22),('9650','2013-07-22','12:45:00',3.67),('9650','2013-07-22','12:50:00',2.63),('9650','2013-07-22','12:55:00',6.57),('9650','2013-07-22','13:00:00',2.27),('9650','2013-07-22','13:05:00',1.69),('9650','2013-07-22','13:10:00',1.55),('9650','2013-07-22','13:15:00',1.18),('9650','2013-07-22','13:20:00',1.15),('9650','2013-07-22','13:25:00',1.45),('9650','2013-07-22','13:30:00',3.35),('9650','2013-07-22','13:35:00',7.57),('9650','2013-07-22','13:40:00',4.1),('9650','2013-07-22','13:45:00',1.17),('9650','2013-07-22','13:50:00',1.49),('9650','2013-07-22','13:55:00',3.65),('9650','2013-07-22','14:00:00',7.1),('9650','2013-07-22','14:05:00',6.28),('9650','2013-07-22','14:10:00',2.09),('9650','2013-07-22','14:20:00',1.08),('9650','2013-07-22','14:25:00',2.77),('9650','2013-07-22','14:30:00',2.52),('9650','2013-07-22','14:35:00',2.09),('9650','2013-07-22','14:40:00',3.03),('9650','2013-07-22','14:45:00',7.23),('9650','2013-07-22','14:50:00',3.7),('9650','2013-07-22','14:55:00',6.97),('9650','2013-07-22','15:00:00',8.26),('9650','2013-07-22','15:05:00',7.08),('9650','2013-07-22','15:10:00',6.86),('9650','2013-07-22','15:15:00',7.15),('9650','2013-07-22','15:20:00',6.96),('9650','2013-07-22','15:25:00',6.97),('9650','2013-07-22','15:30:00',6.82),('9650','2013-07-22','15:35:00',6.94),('9650','2013-07-22','15:40:00',6.64),('9650','2013-07-22','15:45:00',6.58),('9650','2013-07-22','15:50:00',6.66),('9650','2013-07-22','15:55:00',6.63),('9650','2013-07-22','16:00:00',6.61),('9650','2013-07-22','16:05:00',6.49),('9650','2013-07-22','16:10:00',6.44),('9650','2013-07-22','16:15:00',6.35),('9650','2013-07-22','16:20:00',6.37),('9650','2013-07-22','16:25:00',6.25),('9650','2013-07-22','16:30:00',6.24),('9650','2013-07-22','16:35:00',6.12),('9650','2013-07-22','16:40:00',6.07),('9650','2013-07-22','16:45:00',5.95),('9650','2013-07-22','16:50:00',5.92),('9650','2013-07-22','16:55:00',5.88),('9650','2013-07-22','17:00:00',5.77),('9650','2013-07-22','17:05:00',5.69),('9650','2013-07-22','17:10:00',5.61),('9650','2013-07-22','17:15:00',5.55),('9650','2013-07-22','17:20:00',5.47),('9650','2013-07-22','17:25:00',5.39),('9650','2013-07-22','17:30:00',5.25),('9650','2013-07-22','17:35:00',5.17),('9650','2013-07-22','17:40:00',5.05),('9650','2013-07-22','17:45:00',4.9),('9650','2013-07-22','17:50:00',4.78),('9650','2013-07-22','17:55:00',4.7),('9650','2013-07-22','18:00:00',4.6),('9650','2013-07-22','18:05:00',4.46),('9650','2013-07-22','18:10:00',4.34),('9650','2013-07-22','18:15:00',4.23),('9650','2013-07-22','18:20:00',4.15),('9650','2013-07-22','18:25:00',4.03),('9650','2013-07-22','18:30:00',3.88),('9650','2013-07-22','18:35:00',3.72),('9650','2013-07-22','18:40:00',2.85),('9650','2013-07-22','18:45:00',2.41),('9650','2013-07-22','18:50:00',2.23),('9650','2013-07-22','18:55:00',2.79),('9650','2013-07-22','19:00:00',2.71),('9650','2013-07-22','19:05:00',2.48),('9650','2013-07-22','19:10:00',2.33),('9650','2013-07-22','19:15:00',2.19),('9650','2013-07-22','19:20:00',2.01),('9650','2013-07-22','19:25:00',1.82),('9650','2013-07-22','19:30:00',1.65),('9650','2013-07-22','19:35:00',1.45),('9650','2013-07-22','19:40:00',1.19),('9650','2013-07-21','08:05:00',1),('9650','2013-07-21','08:10:00',1.07),('9650','2013-07-21','08:15:00',1.13),('9650','2013-07-21','08:20:00',1.17),('9650','2013-07-21','08:25:00',1.19),('9650','2013-07-21','08:30:00',1.24),('9650','2013-07-21','08:35:00',1.39),('9650','2013-07-21','08:40:00',1.68),('9650','2013-07-21','08:45:00',1.84),('9650','2013-07-21','08:50:00',1.98),('9650','2013-07-21','08:55:00',2.09),('9650','2013-07-21','09:00:00',2.21),('9650','2013-07-21','09:05:00',2.33),('9650','2013-07-21','09:10:00',2.45),('9650','2013-07-21','09:15:00',2.56),('9650','2013-07-21','09:20:00',2.68),('9650','2013-07-21','09:25:00',2.83),('9650','2013-07-21','09:30:00',2.96),('9650','2013-07-21','09:35:00',3.08),('9650','2013-07-21','09:40:00',3.21),('9650','2013-07-21','09:45:00',3.35),('9650','2013-07-21','09:50:00',3.47),('9650','2013-07-21','09:55:00',3.62),('9650','2013-07-21','10:00:00',3.76),('9650','2013-07-21','10:05:00',3.87),('9650','2013-07-21','10:10:00',3.97),('9650','2013-07-21','10:15:00',4.08),('9650','2013-07-21','10:20:00',4.17),('9650','2013-07-21','10:25:00',4.28),('9650','2013-07-21','10:30:00',4.38),('9650','2013-07-21','10:35:00',4.52),('9650','2013-07-21','10:40:00',4.62),('9650','2013-07-21','10:45:00',4.73),('9650','2013-07-21','10:50:00',4.81),('9650','2013-07-21','10:55:00',4.9),('9650','2013-07-21','11:00:00',5),('9650','2013-07-21','11:05:00',5.08),('9650','2013-07-21','11:10:00',5.19),('9650','2013-07-21','11:15:00',5.28),('9650','2013-07-21','11:20:00',5.36),('9650','2013-07-21','11:25:00',5.41),('9650','2013-07-21','11:30:00',5.47),('9650','2013-07-21','11:35:00',5.54),('9650','2013-07-21','11:40:00',5.66),('9650','2013-07-21','11:45:00',5.73),('9650','2013-07-21','11:50:00',5.79),('9650','2013-07-21','11:55:00',5.86),('9650','2013-07-21','12:00:00',5.91),('9650','2013-07-21','12:05:00',5.92),('9650','2013-07-21','12:10:00',5.99),('9650','2013-07-21','12:15:00',6.09),('9650','2013-07-21','12:20:00',6.19),('9650','2013-07-21','12:25:00',6.21),('9650','2013-07-21','12:30:00',6.27),('9650','2013-07-21','12:35:00',6.33),('9650','2013-07-21','12:40:00',6.39),('9650','2013-07-21','12:45:00',6.4),('9650','2013-07-21','12:50:00',6.46),('9650','2013-07-21','12:55:00',6.49),('9650','2013-07-21','13:00:00',6.52),('9650','2013-07-21','13:05:00',6.58),('9650','2013-07-21','13:10:00',6.62),('9650','2013-07-21','13:15:00',6.62),('9650','2013-07-21','13:20:00',6.69),('9650','2013-07-21','13:25:00',6.83),('9650','2013-07-21','13:30:00',6.76),('9650','2013-07-21','13:35:00',6.8),('9650','2013-07-21','13:40:00',6.88),('9650','2013-07-21','13:45:00',6.97),('9650','2013-07-21','13:50:00',6.91),('9650','2013-07-21','13:55:00',6.88),('9650','2013-07-21','14:00:00',6.83),('9650','2013-07-21','14:05:00',6.84),('9650','2013-07-21','14:10:00',6.89),('9650','2013-07-21','14:15:00',6.9),('9650','2013-07-21','14:20:00',6.95),('9650','2013-07-21','14:25:00',7.01),('9650','2013-07-21','14:30:00',6.98),('9650','2013-07-21','14:35:00',6.88),('9650','2013-07-21','14:40:00',6.89),('9650','2013-07-21','14:45:00',6.95),('9650','2013-07-21','14:50:00',6.97),('9650','2013-07-21','14:55:00',6.86),('9650','2013-07-21','15:00:00',6.84),('9650','2013-07-21','15:05:00',6.86),('9650','2013-07-21','15:10:00',6.94),('9650','2013-07-21','15:15:00',6.93),('9650','2013-07-21','15:20:00',6.92),('9650','2013-07-21','15:25:00',6.86),('9650','2013-07-21','15:30:00',1.78),('9650','2013-07-21','15:35:00',1.37),('9650','2013-07-21','15:40:00',1.93),('9650','2013-07-21','15:45:00',6.6),('9650','2013-07-21','15:50:00',7.08),('9650','2013-07-21','15:55:00',7.4),('9650','2013-07-21','16:00:00',7.32),('9650','2013-07-21','16:05:00',7.1),('9650','2013-07-21','16:10:00',5.2),('9650','2013-07-21','16:15:00',6.58),('9650','2013-07-21','16:20:00',6.9),('9650','2013-07-21','16:25:00',6.65),('9650','2013-07-21','16:30:00',6.43),('9650','2013-07-21','16:35:00',6.34),('9650','2013-07-21','16:40:00',6.01),('9650','2013-07-21','16:45:00',5.92),('9650','2013-07-21','16:50:00',5.83),('9650','2013-07-21','16:55:00',5.82),('9650','2013-07-21','17:00:00',5.76),('9650','2013-07-21','17:05:00',5.71),('9650','2013-07-21','17:10:00',5.59),('9650','2013-07-21','17:15:00',5.48),('9650','2013-07-21','17:20:00',5.39),('9650','2013-07-21','17:25:00',5.11),('9650','2013-07-21','17:30:00',4.93),('9650','2013-07-21','17:35:00',5.05),('9650','2013-07-21','17:40:00',4.92),('9650','2013-07-21','17:45:00',4.49),('9650','2013-07-21','17:50:00',4.44),('9650','2013-07-21','17:55:00',4.4),('9650','2013-07-21','18:00:00',4.48),('9650','2013-07-21','18:05:00',4.31),('9650','2013-07-21','18:10:00',4.02),('9650','2013-07-21','18:15:00',3.77),('9650','2013-07-21','18:20:00',3.67),('9650','2013-07-21','18:25:00',3.63),('9650','2013-07-21','18:30:00',3.44),('9650','2013-07-21','18:35:00',3.3),('9650','2013-07-21','18:40:00',3.02),('9650','2013-07-21','18:45:00',2.91),('9650','2013-07-21','18:50:00',2.74),('9650','2013-07-21','18:55:00',2.52),('9650','2013-07-21','19:00:00',1.92),('9650','2013-07-21','19:05:00',2.26),('9650','2013-07-21','19:10:00',2.28),('9650','2013-07-21','19:15:00',2.02),('9650','2013-07-21','19:20:00',1.68),('9650','2013-07-21','19:25:00',1.54),('9650','2013-07-21','19:30:00',1.4),('9650','2013-07-21','19:35:00',1.28),('9650','2013-07-21','19:40:00',1.04),('9650','2013-07-20','08:05:00',1.06),('9650','2013-07-20','08:10:00',1.16),('9650','2013-07-20','08:15:00',1.22),('9650','2013-07-20','08:20:00',1.28),('9650','2013-07-20','08:25:00',1.37),('9650','2013-07-20','08:30:00',1.47),('9650','2013-07-20','08:35:00',1.58),('9650','2013-07-20','08:40:00',1.68),('9650','2013-07-20','08:45:00',1.83),('9650','2013-07-20','08:50:00',1.93),('9650','2013-07-20','08:55:00',2.07),('9650','2013-07-20','09:00:00',2.18),('9650','2013-07-20','09:05:00',2.29),('9650','2013-07-20','09:10:00',2.4),('9650','2013-07-20','09:15:00',2.5),('9650','2013-07-20','09:20:00',2.61),('9650','2013-07-20','09:25:00',2.75),('9650','2013-07-20','09:30:00',2.9),('9650','2013-07-20','09:35:00',3),('9650','2013-07-20','09:40:00',3.16),('9650','2013-07-20','09:45:00',3.27),('9650','2013-07-20','09:50:00',3.37),('9650','2013-07-20','09:55:00',3.51),('9650','2013-07-20','10:00:00',3.64),('9650','2013-07-20','10:05:00',3.78),('9650','2013-07-20','10:10:00',3.87),('9650','2013-07-20','10:15:00',3.97),('9650','2013-07-20','10:20:00',4.05),('9650','2013-07-20','10:25:00',4.17),('9650','2013-07-20','10:30:00',4.26),('9650','2013-07-20','10:35:00',4.36),('9650','2013-07-20','10:40:00',4.47),('9650','2013-07-20','10:45:00',4.62),('9650','2013-07-20','10:50:00',4.71),('9650','2013-07-20','10:55:00',4.77),('9650','2013-07-20','11:00:00',4.92),('9650','2013-07-20','11:05:00',4.97),('9650','2013-07-20','11:10:00',5.07),('9650','2013-07-20','11:15:00',5.14),('9650','2013-07-20','11:20:00',5.22),('9650','2013-07-20','11:25:00',5.37),('9650','2013-07-20','11:30:00',5.45),('9650','2013-07-20','11:35:00',5.55),('9650','2013-07-20','11:40:00',5.79),('9650','2013-07-20','11:45:00',5.87),('9650','2013-07-20','11:50:00',5.82),('9650','2013-07-20','11:55:00',5.87),('9650','2013-07-20','12:00:00',5.88),('9650','2013-07-20','12:05:00',5.98),('9650','2013-07-20','12:10:00',6.28),('9650','2013-07-20','12:15:00',6.52),('9650','2013-07-20','12:20:00',6.91),('9650','2013-07-20','12:25:00',7.42),('9650','2013-07-20','12:30:00',7.39),('9650','2013-07-20','12:35:00',7.73),('9650','2013-07-20','12:40:00',7.81),('9650','2013-07-20','12:45:00',7.31),('9650','2013-07-20','12:50:00',6.9),('9650','2013-07-20','12:55:00',8.12),('9650','2013-07-20','13:00:00',5.75),('9650','2013-07-20','13:05:00',7.42),('9650','2013-07-20','13:10:00',6.63),('9650','2013-07-20','13:15:00',6.06),('9650','2013-07-20','13:20:00',5.91),('9650','2013-07-20','13:25:00',5.88),('9650','2013-07-20','13:30:00',7.73),('9650','2013-07-20','13:35:00',7.55),('9650','2013-07-20','13:40:00',7.13),('9650','2013-07-20','13:45:00',7.23),('9650','2013-07-20','13:50:00',3.36),('9650','2013-07-20','13:55:00',1.85),('9650','2013-07-20','14:00:00',2.05),('9650','2013-07-20','14:05:00',2.24),('9650','2013-07-20','14:10:00',2.12),('9650','2013-07-20','14:15:00',2.07),('9650','2013-07-20','14:20:00',2.47),('9650','2013-07-20','14:25:00',2.76),('9650','2013-07-20','14:30:00',2.37),('9650','2013-07-20','14:35:00',2.42),('9650','2013-07-20','14:40:00',2.27),('9650','2013-07-20','14:45:00',2.61),('9650','2013-07-20','14:50:00',3.14),('9650','2013-07-20','14:55:00',3.05),('9650','2013-07-20','15:00:00',3.56),('9650','2013-07-20','15:05:00',3.05),('9650','2013-07-20','15:10:00',2.89),('9650','2013-07-20','15:15:00',7.06),('9650','2013-07-20','15:20:00',8.79),('9650','2013-07-20','15:25:00',3.07),('9650','2013-07-20','15:30:00',2.57),('9650','2013-07-20','15:35:00',2.96),('9650','2013-07-20','15:40:00',4.86),('9650','2013-07-20','15:45:00',5.89),('9650','2013-07-20','15:50:00',5.49),('9650','2013-07-20','15:55:00',3.77),('9650','2013-07-20','16:00:00',2.39),('9650','2013-07-20','16:05:00',1.75),('9650','2013-07-20','16:10:00',1.53),('9650','2013-07-20','16:15:00',1.37),('9650','2013-07-20','16:20:00',1.28),('9650','2013-07-20','16:25:00',1.32),('9650','2013-07-20','16:30:00',1.39),('9650','2013-07-20','16:35:00',1.53),('9650','2013-07-20','16:40:00',1.62),('9650','2013-07-20','16:45:00',1.66),('9650','2013-07-20','16:50:00',1.73),('9650','2013-07-20','16:55:00',1.92),('9650','2013-07-20','17:00:00',2.19),('9650','2013-07-20','17:05:00',2.47),('9650','2013-07-20','17:10:00',2.57),('9650','2013-07-20','17:15:00',2.02),('9650','2013-07-20','17:20:00',1.78),('9650','2013-07-20','17:25:00',1.61),('9650','2013-07-20','17:30:00',1.51),('9650','2013-07-20','17:35:00',1.46),('9650','2013-07-20','17:40:00',1.48),('9650','2013-07-20','17:45:00',1.47),('9650','2013-07-20','17:50:00',1.5),('9650','2013-07-20','17:55:00',1.52),('9650','2013-07-20','18:00:00',1.49),('9650','2013-07-20','18:05:00',1.38),('9650','2013-07-20','18:10:00',1.18),('9650','2013-07-20','18:15:00',1.02),('9650','2014-04-06','08:15:00',1.06),('9650','2014-04-06','08:20:00',1.18),('9650','2014-04-06','08:25:00',1.29),('9650','2014-04-06','08:30:00',1.44),('9650','2014-04-06','08:35:00',1.63),('9650','2014-04-06','08:40:00',1.73),('9650','2014-04-06','08:45:00',1.74),('9650','2014-04-06','08:50:00',1.75),('9650','2014-04-06','08:55:00',1.71),('9650','2014-04-06','09:00:00',1.71),('9650','2014-04-06','09:05:00',1.76),('9650','2014-04-06','09:10:00',1.9),('9650','2014-04-06','09:15:00',2.05),('9650','2014-04-06','09:20:00',1.88),('9650','2014-04-06','09:25:00',1.85),('9650','2014-04-06','09:30:00',1.86),('9650','2014-04-06','09:35:00',1.85),('9650','2014-04-06','09:40:00',1.94),('9650','2014-04-06','09:45:00',2.04),('9650','2014-04-06','09:50:00',2.13),('9650','2014-04-06','09:55:00',2.22),('9650','2014-04-06','10:00:00',2.22),('9650','2014-04-06','10:05:00',2.2),('9650','2014-04-06','10:10:00',2.26),('9650','2014-04-06','10:15:00',2.15),('9650','2014-04-06','10:20:00',2.17),('9650','2014-04-06','10:25:00',2.22),('9650','2014-04-06','10:30:00',2.26),('9650','2014-04-06','10:35:00',2.37),('9650','2014-04-06','10:40:00',2.45),('9650','2014-04-06','10:45:00',2.55),('9650','2014-04-06','10:50:00',2.67),('9650','2014-04-06','10:55:00',2.84),('9650','2014-04-06','11:00:00',3.01),('9650','2014-04-06','11:05:00',3.1),('9650','2014-04-06','11:10:00',3.41),('9650','2014-04-06','11:15:00',3.57),('9650','2014-04-06','11:20:00',3.59),('9650','2014-04-06','11:25:00',3.2),('9650','2014-04-06','11:30:00',3.25),('9650','2014-04-06','11:35:00',3.21),('9650','2014-04-06','11:40:00',3.13),('9650','2014-04-06','11:45:00',2.96),('9650','2014-04-06','11:50:00',2.81),('9650','2014-04-06','11:55:00',2.7),('9650','2014-04-06','12:00:00',2.94),('9650','2014-04-06','12:05:00',3.53),('9650','2014-04-06','12:10:00',3.8),('9650','2014-04-06','12:15:00',4.88),('9650','2014-04-06','12:20:00',5.82),('9650','2014-04-06','12:25:00',5.7),('9650','2014-04-06','12:30:00',3.36),('9650','2014-04-06','12:35:00',3.01),('9650','2014-04-06','12:40:00',3.86),('9650','2014-04-06','12:45:00',5.66),('9650','2014-04-06','12:50:00',5.89),('9650','2014-04-06','12:55:00',5.83),('9650','2014-04-06','13:00:00',5.94),('9650','2014-04-06','13:05:00',5.95),('9650','2014-04-06','13:10:00',5.94),('9650','2014-04-06','13:15:00',5.97),('9650','2014-04-06','13:20:00',6),('9650','2014-04-06','13:25:00',6.03),('9650','2014-04-06','13:30:00',6.08),('9650','2014-04-06','13:35:00',6.07),('9650','2014-04-06','13:40:00',6.07),('9650','2014-04-06','13:45:00',6.11),('9650','2014-04-06','13:50:00',6.15),('9650','2014-04-06','13:55:00',6.24),('9650','2014-04-06','14:00:00',6.28),('9650','2014-04-06','14:05:00',6.24),('9650','2014-04-06','14:10:00',6.24),('9650','2014-04-06','14:15:00',6.17),('9650','2014-04-06','14:20:00',6.21),('9650','2014-04-06','14:25:00',6.39),('9650','2014-04-06','14:30:00',6.39),('9650','2014-04-06','14:35:00',6.28),('9650','2014-04-06','14:40:00',6.23),('9650','2014-04-06','14:45:00',5.95),('9650','2014-04-06','14:50:00',6.28),('9650','2014-04-06','14:55:00',6.03),('9650','2014-04-06','15:00:00',4.9),('9650','2014-04-06','15:05:00',6.33),('9650','2014-04-06','15:10:00',6.07),('9650','2014-04-06','15:15:00',6.34),('9650','2014-04-06','15:20:00',6.55),('9650','2014-04-06','15:25:00',6.48),('9650','2014-04-06','15:30:00',5.97),('9650','2014-04-06','15:35:00',6.09),('9650','2014-04-06','15:40:00',6.06),('9650','2014-04-06','15:45:00',6.25),('9650','2014-04-06','15:50:00',6.52),('9650','2014-04-06','15:55:00',6.42),('9650','2014-04-06','16:00:00',4.85),('9650','2014-04-06','16:05:00',2.99),('9650','2014-04-06','16:10:00',5.53),('9650','2014-04-06','16:15:00',5.44),('9650','2014-04-06','16:20:00',5.14),('9650','2014-04-06','16:25:00',5.1),('9650','2014-04-06','16:30:00',4.8),('9650','2014-04-06','16:35:00',2.99),('9650','2014-04-06','16:40:00',2.27),('9650','2014-04-06','16:45:00',3.53),('9650','2014-04-06','16:50:00',4.77),('9650','2014-04-06','16:55:00',4.82),('9650','2014-04-06','17:00:00',5.1),('9650','2014-04-06','17:05:00',4.81),('9650','2014-04-06','17:10:00',3.79),('9650','2014-04-06','17:15:00',3.87),('9650','2014-04-06','17:20:00',2.39),('9650','2014-04-06','17:25:00',1.83),('9650','2014-04-06','17:30:00',1.42),('9650','2014-04-06','17:35:00',1.2),('9650','2014-04-06','17:45:00',1.97),('9650','2014-04-06','17:50:00',1.63),('9650','2014-04-06','17:55:00',2.86),('9650','2014-04-06','18:00:00',2.66),('9650','2014-04-06','18:05:00',2.51),('9650','2014-04-06','18:10:00',2.49),('9650','2014-04-06','18:15:00',2.4),('9650','2014-04-06','18:20:00',2.17),('9650','2014-04-06','18:25:00',1.98),('9650','2014-04-06','18:30:00',1.75),('9650','2014-04-06','18:35:00',1.52),('9650','2014-04-06','18:40:00',1.32),('9650','2014-04-06','18:45:00',1.18),('9650','2014-04-06','18:50:00',1),('9650','2013-07-19','08:10:00',1.06),('9650','2013-07-19','08:15:00',1.12),('9650','2013-07-19','08:20:00',1.16),('9650','2013-07-19','08:25:00',1.21),('9650','2013-07-19','08:30:00',1.24),('9650','2013-07-19','08:35:00',1.26),('9650','2013-07-19','08:40:00',1.35),('9650','2013-07-19','08:45:00',1.89),('9650','2013-07-19','08:50:00',2.04),('9650','2013-07-19','08:55:00',2.19),('9650','2013-07-19','09:00:00',2.31),('9650','2013-07-19','09:05:00',2.45),('9650','2013-07-19','09:10:00',2.65),('9650','2013-07-19','09:15:00',2.79),('9650','2013-07-19','09:20:00',2.86),('9650','2013-07-19','09:25:00',2.86),('9650','2013-07-19','09:30:00',2.92),('9650','2013-07-19','09:35:00',2.99),('9650','2013-07-19','09:40:00',3.05),('9650','2013-07-19','09:45:00',3.38),('9650','2013-07-19','09:50:00',3.36),('9650','2013-07-19','09:55:00',3.47),('9650','2013-07-19','10:00:00',3.72),('9650','2013-07-19','10:05:00',3.82),('9650','2013-07-19','10:10:00',3.97),('9650','2013-07-19','10:15:00',4.04),('9650','2013-07-19','10:20:00',4.15),('9650','2013-07-19','10:25:00',4.27),('9650','2013-07-19','10:30:00',4.37),('9650','2013-07-19','10:35:00',4.48),('9650','2013-07-19','10:40:00',4.59),('9650','2013-07-19','10:45:00',4.65),('9650','2013-07-19','10:50:00',4.74),('9650','2013-07-19','10:55:00',4.91),('9650','2013-07-19','11:00:00',5),('9650','2013-07-19','11:05:00',5.07),('9650','2013-07-19','11:10:00',5.16),('9650','2013-07-19','11:15:00',5.19),('9650','2013-07-19','11:20:00',5.18),('9650','2013-07-19','11:25:00',5.33),('9650','2013-07-19','11:30:00',5.42),('9650','2013-07-19','11:35:00',5.56),('9650','2013-07-19','11:40:00',5.62),('9650','2013-07-19','11:45:00',5.73),('9650','2013-07-19','11:50:00',5.74),('9650','2013-07-19','11:55:00',5.89),('9650','2013-07-19','12:00:00',6.02),('9650','2013-07-19','12:05:00',6.18),('9650','2013-07-19','12:10:00',6.32),('9650','2013-07-19','12:15:00',6.24),('9650','2013-07-19','12:20:00',6.18),('9650','2013-07-19','12:25:00',6.2),('9650','2013-07-19','12:30:00',6.25),('9650','2013-07-19','12:35:00',6.4),('9650','2013-07-19','12:40:00',6.46),('9650','2013-07-19','12:45:00',6.62),('9650','2013-07-19','12:50:00',6.67),('9650','2013-07-19','12:55:00',6.72),('9650','2013-07-19','13:00:00',6.97),('9650','2013-07-19','13:05:00',6.9),('9650','2013-07-19','13:10:00',4.8),('9650','2013-07-19','13:15:00',1.57),('9650','2013-07-19','13:20:00',3.65),('9650','2013-07-19','13:25:00',6.02),('9650','2013-07-19','13:30:00',7.46),('9650','2013-07-19','13:35:00',7.22),('9650','2013-07-19','13:40:00',7.42),('9650','2013-07-19','13:45:00',6.62),('9650','2013-07-19','13:50:00',2.4),('9650','2013-07-19','13:55:00',1.36),('9650','2013-07-19','14:00:00',4.04),('9650','2013-07-19','14:05:00',7.58),('9650','2013-07-19','14:10:00',7.55),('9650','2013-07-19','14:15:00',7.57),('9650','2013-07-19','14:20:00',7.37),('9650','2013-07-19','14:25:00',7.22),('9650','2013-07-19','14:30:00',7.11),('9650','2013-07-19','14:35:00',7.23),('9650','2013-07-19','14:40:00',7.23),('9650','2013-07-19','14:45:00',7.1),('9650','2013-07-19','14:50:00',4.4),('9650','2013-07-19','14:55:00',7.1),('9650','2013-07-19','15:00:00',7.45),('9650','2013-07-19','15:05:00',7.26),('9650','2013-07-19','15:10:00',7.15),('9650','2013-07-19','15:15:00',7.03),('9650','2013-07-19','15:20:00',6.89),('9650','2013-07-19','15:25:00',6.9),('9650','2013-07-19','15:30:00',6.88),('9650','2013-07-19','15:35:00',6.84),('9650','2013-07-19','15:40:00',6.83),('9650','2013-07-19','15:45:00',6.84),('9650','2013-07-19','15:50:00',6.83),('9650','2013-07-19','15:55:00',6.66),('9650','2013-07-19','16:00:00',6.54),('9650','2013-07-19','16:05:00',6.58),('9650','2013-07-19','16:10:00',6.48),('9650','2013-07-19','16:15:00',6.47),('9650','2013-07-19','16:20:00',6.46),('9650','2013-07-19','16:25:00',6.41),('9650','2013-07-19','16:30:00',6.29),('9650','2013-07-19','16:35:00',5.95),('9650','2013-07-19','16:40:00',6.18),('9650','2013-07-19','16:45:00',6.12),('9650','2013-07-19','16:50:00',6.02),('9650','2013-07-19','16:55:00',5.84),('9650','2013-07-19','17:00:00',5.75),('9650','2013-07-19','17:05:00',5.74),('9650','2013-07-19','17:10:00',5.61),('9650','2013-07-19','17:15:00',5.49),('9650','2013-07-19','17:20:00',5.41),('9650','2013-07-19','17:25:00',5.34),('9650','2013-07-19','17:30:00',5.24),('9650','2013-07-19','17:35:00',5.17),('9650','2013-07-19','17:40:00',5.08),('9650','2013-07-19','17:45:00',4.93),('9650','2013-07-19','17:50:00',4.8),('9650','2013-07-19','17:55:00',4.68),('9650','2013-07-19','18:00:00',4.56),('9650','2013-07-19','18:05:00',4.41),('9650','2013-07-19','18:10:00',4.29),('9650','2013-07-19','18:15:00',4.15),('9650','2013-07-19','18:20:00',4.03),('9650','2013-07-19','18:25:00',3.91),('9650','2013-07-19','18:30:00',3.75),('9650','2013-07-19','18:35:00',3.59),('9650','2013-07-19','18:40:00',3.45),('9650','2013-07-19','18:45:00',3.22),('9650','2013-07-19','18:50:00',3.04),('9650','2013-07-19','18:55:00',2.88),('9650','2013-07-19','19:00:00',2.73),('9650','2013-07-19','19:05:00',2.54),('9650','2013-07-19','19:10:00',2.37),('9650','2013-07-19','19:15:00',2.22),('9650','2013-07-19','19:20:00',2.05),('9650','2013-07-19','19:25:00',1.87),('9650','2013-07-19','19:30:00',1.67),('9650','2013-07-19','19:35:00',1.45),('9650','2013-07-19','19:40:00',1.24),('9650','2013-07-19','19:45:00',1.07),('9650','2013-07-18','08:00:00',1.01),('9650','2013-07-18','08:05:00',1.09),('9650','2013-07-18','08:10:00',1.17),('9650','2013-07-18','08:15:00',1.25),('9650','2013-07-18','08:20:00',1.33),('9650','2013-07-18','08:25:00',1.4),('9650','2013-07-18','08:30:00',1.49),('9650','2013-07-18','08:35:00',1.61),('9650','2013-07-18','08:40:00',1.73),('9650','2013-07-18','08:45:00',1.9),('9650','2013-07-18','08:50:00',2.02),('9650','2013-07-18','08:55:00',2.15),('9650','2013-07-18','09:00:00',2.24),('9650','2013-07-18','09:05:00',2.34),('9650','2013-07-18','09:10:00',2.46),('9650','2013-07-18','09:15:00',2.57),('9650','2013-07-18','09:20:00',2.66),('9650','2013-07-18','09:25:00',2.77),('9650','2013-07-18','09:30:00',2.89),('9650','2013-07-18','09:35:00',3.02),('9650','2013-07-18','09:40:00',3.17),('9650','2013-07-18','09:45:00',3.29),('9650','2013-07-18','09:50:00',3.36),('9650','2013-07-18','09:55:00',3.49),('9650','2013-07-18','10:00:00',3.62),('9650','2013-07-18','10:05:00',3.72),('9650','2013-07-18','10:10:00',3.84),('9650','2013-07-18','10:15:00',3.97),('9650','2013-07-18','10:20:00',3.99),('9650','2013-07-18','10:25:00',4.14),('9650','2013-07-18','10:30:00',4.05),('9650','2013-07-18','10:35:00',4.31),('9650','2013-07-18','10:40:00',4.42),('9650','2013-07-18','10:45:00',4.53),('9650','2013-07-18','10:50:00',4.58),('9650','2013-07-18','10:55:00',4.68),('9650','2013-07-18','11:00:00',4.75),('9650','2013-07-18','11:05:00',4.83),('9650','2013-07-18','11:10:00',4.96),('9650','2013-07-18','11:15:00',5.04),('9650','2013-07-18','11:20:00',5.18),('9650','2013-07-18','11:25:00',5.26),('9650','2013-07-18','11:30:00',5.29),('9650','2013-07-18','11:35:00',5.35),('9650','2013-07-18','11:40:00',5.55),('9650','2013-07-18','11:45:00',5.63),('9650','2013-07-18','11:50:00',5.56),('9650','2013-07-18','11:55:00',5.77),('9650','2013-07-18','12:00:00',5.35),('9650','2013-07-18','12:05:00',5.88),('9650','2013-07-18','12:10:00',5.9),('9650','2013-07-18','12:15:00',6.22),('9650','2013-07-18','12:20:00',6.27),('9650','2013-07-18','12:25:00',6.36),('9650','2013-07-18','12:30:00',6.28),('9650','2013-07-18','12:35:00',6.28),('9650','2013-07-18','12:40:00',6.18),('9650','2013-07-18','12:45:00',4.92),('9650','2013-07-18','12:50:00',5.63),('9650','2013-07-18','12:55:00',6.72),('9650','2013-07-18','13:00:00',6.76),('9650','2013-07-18','13:05:00',6.63),('9650','2013-07-18','13:10:00',6.05),('9650','2013-07-18','13:15:00',2.43),('9650','2013-07-18','13:20:00',2.92),('9650','2013-07-18','13:25:00',7.39),('9650','2013-07-18','13:30:00',7.26),('9650','2013-07-18','13:35:00',7.12),('9650','2013-07-18','13:40:00',7.08),('9650','2013-07-18','13:45:00',7.09),('9650','2013-07-18','13:50:00',7.2),('9650','2013-07-18','13:55:00',7.22),('9650','2013-07-18','14:00:00',7.21),('9650','2013-07-18','14:05:00',7.15),('9650','2013-07-18','14:10:00',6.12),('9650','2013-07-18','14:15:00',6.95),('9650','2013-07-18','14:20:00',7.4),('9650','2013-07-18','14:25:00',5.67),('9650','2013-07-18','14:30:00',7.48),('9650','2013-07-18','14:35:00',6.95),('9650','2013-07-18','14:40:00',5.8),('9650','2013-07-18','14:45:00',7.27),('9650','2013-07-18','14:50:00',7.01),('9650','2013-07-18','14:55:00',7.35),('9650','2013-07-18','15:00:00',7.07),('9650','2013-07-18','15:05:00',7.29),('9650','2013-07-18','15:10:00',7.17),('9650','2013-07-18','15:15:00',4.01),('9650','2013-07-18','15:20:00',5.69),('9650','2013-07-18','15:25:00',5.88),('9650','2013-07-18','15:30:00',7.49),('9650','2013-07-18','15:35:00',7.24),('9650','2013-07-18','15:40:00',7.23),('9650','2013-07-18','15:45:00',6.94),('9650','2013-07-18','15:50:00',6.96),('9650','2013-07-18','15:55:00',6.83),('9650','2013-07-18','16:00:00',6.72),('9650','2013-07-18','16:05:00',6.68),('9650','2013-07-18','16:10:00',6.69),('9650','2013-07-18','16:15:00',6.57),('9650','2013-07-18','16:20:00',6.5),('9650','2013-07-18','16:25:00',6.51),('9650','2013-07-18','16:30:00',6.5),('9650','2013-07-18','16:35:00',6.49),('9650','2013-07-18','16:40:00',6.42),('9650','2013-07-18','16:45:00',6.32),('9650','2013-07-18','16:50:00',6.29),('9650','2013-07-18','16:55:00',6.41),('9650','2013-07-18','17:00:00',4.98),('9650','2013-07-18','17:05:00',6.5),('9650','2013-07-18','17:10:00',5.9),('9650','2013-07-18','17:15:00',5.54),('9650','2013-07-18','17:20:00',5.2),('9650','2013-07-18','17:25:00',4.3),('9650','2013-07-18','17:30:00',5.05),('9650','2013-07-18','17:35:00',5.55),('9650','2013-07-18','17:40:00',3.8),('9650','2013-07-18','17:45:00',2.83),('9650','2013-07-18','17:50:00',2.01),('9650','2013-07-18','17:55:00',1.64),('9650','2013-07-18','18:00:00',1.44),('9650','2013-07-18','18:05:00',1.25),('9650','2013-07-18','18:10:00',1.12),('9650','2013-07-18','18:40:00',1.04),('9650','2013-07-18','18:45:00',1.02),('9650','2013-07-17','08:05:00',1.02),('9650','2013-07-17','08:10:00',1.07),('9650','2013-07-17','08:15:00',1.15),('9650','2013-07-17','08:20:00',1.27),('9650','2013-07-17','08:25:00',1.37),('9650','2013-07-17','08:30:00',1.48),('9650','2013-07-17','08:35:00',1.6),('9650','2013-07-17','08:40:00',1.72),('9650','2013-07-17','08:45:00',1.89),('9650','2013-07-17','08:50:00',2),('9650','2013-07-17','08:55:00',2.13),('9650','2013-07-17','09:00:00',2.24),('9650','2013-07-17','09:05:00',2.36),('9650','2013-07-17','09:10:00',2.47),('9650','2013-07-17','09:15:00',2.58),('9650','2013-07-17','09:20:00',2.69),('9650','2013-07-17','09:25:00',2.82),('9650','2013-07-17','09:30:00',2.99),('9650','2013-07-17','09:35:00',3.13),('9650','2013-07-17','09:40:00',3.28),('9650','2013-07-17','09:45:00',3.39),('9650','2013-07-17','09:50:00',3.52),('9650','2013-07-17','09:55:00',3.62),('9650','2013-07-17','10:00:00',3.76),('9650','2013-07-17','10:05:00',3.85),('9650','2013-07-17','10:10:00',4.01),('9650','2013-07-17','10:15:00',4.08),('9650','2013-07-17','10:20:00',4.16),('9650','2013-07-17','10:25:00',4.28),('9650','2013-07-17','10:30:00',4.38),('9650','2013-07-17','10:35:00',4.54),('9650','2013-07-17','10:40:00',4.7),('9650','2013-07-17','10:45:00',4.8),('9650','2013-07-17','10:50:00',4.91),('9650','2013-07-17','10:55:00',4.96),('9650','2013-07-17','11:00:00',5.03),('9650','2013-07-17','11:05:00',5.09),('9650','2013-07-17','11:10:00',5.18),('9650','2013-07-17','11:15:00',5.27),('9650','2013-07-17','11:20:00',5.36),('9650','2013-07-17','11:25:00',5.42),('9650','2013-07-17','11:30:00',5.53),('9650','2013-07-17','11:35:00',5.61),('9650','2013-07-17','11:40:00',5.68),('9650','2013-07-17','11:45:00',5.76),('9650','2013-07-17','11:50:00',5.79),('9650','2013-07-17','11:55:00',5.87),('9650','2013-07-17','12:00:00',5.88),('9650','2013-07-17','12:05:00',5.89),('9650','2013-07-17','12:10:00',5.81),('9650','2013-07-17','12:15:00',5.62),('9650','2013-07-17','12:20:00',5.75),('9650','2013-07-17','12:25:00',6.14),('9650','2013-07-17','12:30:00',6.46),('9650','2013-07-17','12:35:00',6.37),('9650','2013-07-17','12:40:00',6.46),('9650','2013-07-17','12:45:00',6.83),('9650','2013-07-17','12:50:00',6.68),('9650','2013-07-17','12:55:00',6.57),('9650','2013-07-17','13:00:00',6.47),('9650','2013-07-17','13:05:00',5.18),('9650','2013-07-17','13:10:00',5.93),('9650','2013-07-17','13:15:00',6.7),('9650','2013-07-17','13:20:00',6.78),('9650','2013-07-17','13:25:00',6.77),('9650','2013-07-17','13:30:00',6.39),('9650','2013-07-17','13:35:00',6.7),('9650','2013-07-17','13:40:00',6.96),('9650','2013-07-17','13:45:00',6.93),('9650','2013-07-17','13:50:00',6.94),('9650','2013-07-17','13:55:00',7.11),('9650','2013-07-17','14:00:00',7.03),('9650','2013-07-17','14:05:00',6.69),('9650','2013-07-17','14:10:00',7.02),('9650','2013-07-17','14:15:00',7.12),('9650','2013-07-17','14:20:00',7.08),('9650','2013-07-17','14:25:00',7.05),('9650','2013-07-17','14:30:00',6.94),('9650','2013-07-17','14:35:00',7.06),('9650','2013-07-17','14:40:00',7),('9650','2013-07-17','14:45:00',6.98),('9650','2013-07-17','14:50:00',6.94),('9650','2013-07-17','14:55:00',6.94),('9650','2013-07-17','15:00:00',6.98),('9650','2013-07-17','15:05:00',7.04),('9650','2013-07-17','15:10:00',6.92),('9650','2013-07-17','15:15:00',6.92),('9650','2013-07-17','15:20:00',7),('9650','2013-07-17','15:25:00',6.96),('9650','2013-07-17','15:30:00',6.88),('9650','2013-07-17','15:35:00',6.78),('9650','2013-07-17','15:40:00',6.84),('9650','2013-07-17','15:45:00',6.83),('9650','2013-07-17','15:50:00',6.74),('9650','2013-07-17','15:55:00',6.72),('9650','2013-07-17','16:00:00',6.61),('9650','2013-07-17','16:05:00',6.51),('9650','2013-07-17','16:10:00',6.47),('9650','2013-07-17','16:15:00',6.37),('9650','2013-07-17','16:20:00',6.34),('9650','2013-07-17','16:25:00',6.28),('9650','2013-07-17','16:30:00',6.2),('9650','2013-07-17','16:35:00',6.16),('9650','2013-07-17','16:40:00',6.07),('9650','2013-07-17','16:45:00',6.04),('9650','2013-07-17','16:50:00',5.92),('9650','2013-07-17','16:55:00',5.83),('9650','2013-07-17','17:00:00',5.73),('9650','2013-07-17','17:05:00',5.62),('9650','2013-07-17','17:10:00',5.44),('9650','2013-07-17','17:15:00',5.39),('9650','2013-07-17','17:20:00',5.32),('9650','2013-07-17','17:25:00',5.25),('9650','2013-07-17','17:30:00',5.07),('9650','2013-07-17','17:35:00',4.9),('9650','2013-07-17','17:40:00',4.47),('9650','2013-07-17','17:45:00',4.62),('9650','2013-07-17','17:50:00',4.45),('9650','2013-07-17','17:55:00',4.36),('9650','2013-07-17','18:00:00',4.12),('9650','2013-07-17','18:05:00',3.62),('9650','2013-07-17','18:10:00',3.73),('9650','2013-07-17','18:15:00',3.61),('9650','2013-07-17','18:20:00',3.48),('9650','2013-07-17','18:25:00',3.27),('9650','2013-07-17','18:30:00',1.83),('9650','2013-07-17','18:45:00',1.98),('9650','2013-07-17','18:50:00',1.28),('9650','2013-07-17','18:55:00',2.21),('9650','2013-07-17','19:00:00',2.47),('9650','2013-07-17','19:05:00',2.01),('9650','2013-07-17','19:10:00',1.14),('9650','2013-07-17','19:15:00',1.32),('9650','2013-07-17','19:20:00',1.74),('9650','2013-07-17','19:25:00',1.54),('9650','2013-07-17','19:30:00',1.38),('9650','2013-07-17','19:40:00',1.02),('9650','2013-07-16','08:05:00',1.05),('9650','2013-07-16','08:10:00',1.1),('9650','2013-07-16','08:15:00',1.15),('9650','2013-07-16','08:20:00',1.19),('9650','2013-07-16','08:25:00',1.22),('9650','2013-07-16','08:30:00',1.24),('9650','2013-07-16','08:35:00',1.26),('9650','2013-07-16','08:40:00',1.35),('9650','2013-07-16','08:45:00',1.95),('9650','2013-07-16','08:50:00',2.07),('9650','2013-07-16','08:55:00',2.2),('9650','2013-07-16','09:00:00',2.34),('9650','2013-07-16','09:05:00',2.44),('9650','2013-07-16','09:10:00',2.58),('9650','2013-07-16','09:15:00',2.7),('9650','2013-07-16','09:20:00',2.83),('9650','2013-07-16','09:25:00',2.97),('9650','2013-07-16','09:30:00',3.13),('9650','2013-07-16','09:35:00',3.24),('9650','2013-07-16','09:40:00',3.41),('9650','2013-07-16','09:45:00',3.56),('9650','2013-07-16','09:50:00',3.67),('9650','2013-07-16','09:55:00',3.77),('9650','2013-07-16','10:00:00',3.92),('9650','2013-07-16','10:05:00',4.04),('9650','2013-07-16','10:10:00',4.16),('9650','2013-07-16','10:15:00',4.23),('9650','2013-07-16','10:20:00',4.31),('9650','2013-07-16','10:25:00',4.43),('9650','2013-07-16','10:30:00',4.55),('9650','2013-07-16','10:35:00',4.67),('9650','2013-07-16','10:40:00',4.79),('9650','2013-07-16','10:45:00',4.9),('9650','2013-07-16','10:50:00',5.03),('9650','2013-07-16','10:55:00',5.08),('9650','2013-07-16','11:00:00',5.19),('9650','2013-07-16','11:05:00',5.32),('9650','2013-07-16','11:10:00',5.38),('9650','2013-07-16','11:15:00',5.47),('9650','2013-07-16','11:20:00',5.54),('9650','2013-07-16','11:25:00',5.64),('9650','2013-07-16','11:30:00',5.73),('9650','2013-07-16','11:35:00',5.79),('9650','2013-07-16','11:40:00',5.86),('9650','2013-07-16','11:45:00',5.94),('9650','2013-07-16','11:50:00',6.01),('9650','2013-07-16','11:55:00',6.09),('9650','2013-07-16','12:00:00',6.23),('9650','2013-07-16','12:05:00',6.26),('9650','2013-07-16','12:10:00',6.32),('9650','2013-07-16','12:15:00',6.39),('9650','2013-07-16','12:20:00',6.37),('9650','2013-07-16','12:25:00',6.4),('9650','2013-07-16','12:30:00',6.48),('9650','2013-07-16','12:35:00',6.5),('9650','2013-07-16','12:40:00',6.58),('9650','2013-07-16','12:45:00',6.59),('9650','2013-07-16','12:50:00',6.61),('9650','2013-07-16','12:55:00',6.71),('9650','2013-07-16','13:00:00',6.77),('9650','2013-07-16','13:05:00',6.79),('9650','2013-07-16','13:10:00',6.83),('9650','2013-07-16','13:15:00',6.86),('9650','2013-07-16','13:20:00',6.87),('9650','2013-07-16','13:25:00',6.82),('9650','2013-07-16','13:30:00',6.88),('9650','2013-07-16','13:35:00',6.91),('9650','2013-07-16','13:40:00',6.91),('9650','2013-07-16','13:45:00',7),('9650','2013-07-16','13:50:00',6.88),('9650','2013-07-16','13:55:00',6.98),('9650','2013-07-16','14:00:00',7.08),('9650','2013-07-16','14:05:00',7.12),('9650','2013-07-16','14:10:00',7.13),('9650','2013-07-16','14:15:00',7.18),('9650','2013-07-16','14:20:00',7.13),('9650','2013-07-16','14:25:00',7.1),('9650','2013-07-16','14:30:00',7.05),('9650','2013-07-16','14:35:00',6.97),('9650','2013-07-16','14:40:00',7.32),('9650','2013-07-16','14:45:00',7.25),('9650','2013-07-16','14:50:00',7),('9650','2013-07-16','14:55:00',7.02),('9650','2013-07-16','15:00:00',6.96),('9650','2013-07-16','15:05:00',6.8),('9650','2013-07-16','15:10:00',6.12),('9650','2013-07-16','15:15:00',7.2),('9650','2013-07-16','15:20:00',7.1),('9650','2013-07-16','15:25:00',7.03),('9650','2013-07-16','15:30:00',6.97),('9650','2013-07-16','15:35:00',7.01),('9650','2013-07-16','15:40:00',5.69),('9650','2013-07-16','15:45:00',6.44),('9650','2013-07-16','15:50:00',6.33),('9650','2013-07-16','15:55:00',6.84),('9650','2013-07-16','16:00:00',6.71),('9650','2013-07-16','16:05:00',6.66),('9650','2013-07-16','16:10:00',6.65),('9650','2013-07-16','16:15:00',6.53),('9650','2013-07-16','16:20:00',6.43),('9650','2013-07-16','16:25:00',6.32),('9650','2013-07-16','16:30:00',6.15),('9650','2013-07-16','16:35:00',6),('9650','2013-07-16','16:40:00',5.88),('9650','2013-07-16','16:45:00',6.05),('9650','2013-07-16','16:50:00',5.92),('9650','2013-07-16','16:55:00',5.8),('9650','2013-07-16','17:00:00',5.8),('9650','2013-07-16','17:05:00',5.69),('9650','2013-07-16','17:10:00',5.77),('9650','2013-07-16','17:15:00',5.57),('9650','2013-07-16','17:20:00',5.46),('9650','2013-07-16','17:25:00',5.29),('9650','2013-07-16','17:30:00',5.18),('9650','2013-07-16','17:35:00',5.12),('9650','2013-07-16','17:40:00',5),('9650','2013-07-16','17:45:00',4.88),('9650','2013-07-16','17:50:00',4.86),('9650','2013-07-16','17:55:00',4.67),('9650','2013-07-16','18:00:00',4.52),('9650','2013-07-16','18:05:00',4.48),('9650','2013-07-16','18:10:00',4.35),('9650','2013-07-16','18:15:00',4.24),('9650','2013-07-16','18:20:00',4.05),('9650','2013-07-16','18:25:00',3.91),('9650','2013-07-16','18:30:00',3.79),('9650','2013-07-16','18:35:00',3.64),('9650','2013-07-16','18:40:00',3.48),('9650','2013-07-16','18:45:00',3.28),('9650','2013-07-16','18:50:00',3.15),('9650','2013-07-16','18:55:00',2.97),('9650','2013-07-16','19:00:00',2.8),('9650','2013-07-16','19:05:00',2.65),('9650','2013-07-16','19:10:00',2.45),('9650','2013-07-16','19:15:00',2.27),('9650','2013-07-16','19:20:00',2.08),('9650','2013-07-16','19:25:00',1.92),('9650','2013-07-16','19:30:00',1.78),('9650','2013-07-16','19:35:00',1.58),('9650','2013-07-16','19:40:00',1.36),('9650','2013-07-16','19:45:00',1.16),('9650','2013-07-15','08:00:00',1.02),('9650','2013-07-15','08:05:00',1.1),('9650','2013-07-15','08:10:00',1.2),('9650','2013-07-15','08:15:00',1.28),('9650','2013-07-15','08:20:00',1.38),('9650','2013-07-15','08:25:00',1.47),('9650','2013-07-15','08:30:00',1.59),('9650','2013-07-15','08:35:00',1.69),('9650','2013-07-15','08:40:00',1.84),('9650','2013-07-15','08:45:00',1.97),('9650','2013-07-15','08:50:00',2.09),('9650','2013-07-15','08:55:00',2.23),('9650','2013-07-15','09:00:00',2.34),('9650','2013-07-15','09:05:00',2.44),('9650','2013-07-15','09:10:00',2.57),('9650','2013-07-15','09:15:00',2.67),('9650','2013-07-15','09:20:00',2.76),('9650','2013-07-15','09:25:00',2.89),('9650','2013-07-15','09:30:00',3.06),('9650','2013-07-15','09:35:00',3.2),('9650','2013-07-15','09:40:00',3.36),('9650','2013-07-15','09:45:00',3.47),('9650','2013-07-15','09:50:00',3.6),('9650','2013-07-15','09:55:00',3.71),('9650','2013-07-15','10:00:00',3.87),('9650','2013-07-15','10:05:00',4),('9650','2013-07-15','10:10:00',4.12),('9650','2013-07-15','10:15:00',4.2),('9650','2013-07-15','10:20:00',4.27),('9650','2013-07-15','10:25:00',4.4),('9650','2013-07-15','10:30:00',4.53),('9650','2013-07-15','10:35:00',4.62),('9650','2013-07-15','10:40:00',4.76),('9650','2013-07-15','10:45:00',4.85),('9650','2013-07-15','10:50:00',4.96),('9650','2013-07-15','10:55:00',5.04),('9650','2013-07-15','11:00:00',5.14),('9650','2013-07-15','11:05:00',5.24),('9650','2013-07-15','11:10:00',5.33),('9650','2013-07-15','11:15:00',5.42),('9650','2013-07-15','11:20:00',5.48),('9650','2013-07-15','11:25:00',5.58),('9650','2013-07-15','11:30:00',5.64),('9650','2013-07-15','11:35:00',5.73),('9650','2013-07-15','11:40:00',5.8),('9650','2013-07-15','11:45:00',5.9),('9650','2013-07-15','11:50:00',6.01),('9650','2013-07-15','11:55:00',6.09),('9650','2013-07-15','12:00:00',6.14),('9650','2013-07-15','12:05:00',6.21),('9650','2013-07-15','12:10:00',6.28),('9650','2013-07-15','12:15:00',6.34),('9650','2013-07-15','12:20:00',6.39),('9650','2013-07-15','12:25:00',6.41),('9650','2013-07-15','12:30:00',6.45),('9650','2013-07-15','12:35:00',6.47),('9650','2013-07-15','12:40:00',6.47),('9650','2013-07-15','12:45:00',6.53),('9650','2013-07-15','12:50:00',6.52),('9650','2013-07-15','12:55:00',6.59),('9650','2013-07-15','13:00:00',6.6),('9650','2013-07-15','13:05:00',6.7),('9650','2013-07-15','13:10:00',6.69),('9650','2013-07-15','13:15:00',6.79),('9650','2013-07-15','13:20:00',6.81),('9650','2013-07-15','13:25:00',6.87),('9650','2013-07-15','13:30:00',6.91),('9650','2013-07-15','13:35:00',6.9),('9650','2013-07-15','13:40:00',7.05),('9650','2013-07-15','13:45:00',7.23),('9650','2013-07-15','13:50:00',7.43),('9650','2013-07-15','13:55:00',6.09),('9650','2013-07-15','14:00:00',7.03),('9650','2013-07-15','14:05:00',7.06),('9650','2013-07-15','14:10:00',4.86),('9650','2013-07-15','14:15:00',6.9),('9650','2013-07-15','14:20:00',2.88),('9650','2013-07-15','14:25:00',6.05),('9650','2013-07-15','14:30:00',7.22),('9650','2013-07-15','14:35:00',7.19),('9650','2013-07-15','14:40:00',7.13),('9650','2013-07-15','14:45:00',7.05),('9650','2013-07-15','14:50:00',7.09),('9650','2013-07-15','14:55:00',7.1),('9650','2013-07-15','15:00:00',7.04),('9650','2013-07-15','15:05:00',7.02),('9650','2013-07-15','15:10:00',6.96),('9650','2013-07-15','15:15:00',6.94),('9650','2013-07-15','15:20:00',6.94),('9650','2013-07-15','15:25:00',6.95),('9650','2013-07-15','15:30:00',6.98),('9650','2013-07-15','15:35:00',6.78),('9650','2013-07-15','15:40:00',6.74),('9650','2013-07-15','15:45:00',3.7),('9650','2013-07-15','15:50:00',6.69),('9650','2013-07-15','15:55:00',6.71),('9650','2013-07-15','16:00:00',6.18),('9650','2013-07-15','16:05:00',2.81),('9650','2013-07-15','16:10:00',6.57),('9650','2013-07-15','16:15:00',5.61),('9650','2013-07-15','16:20:00',3.29),('9650','2013-07-15','16:25:00',2.27),('9650','2013-07-15','16:30:00',1.98),('9650','2013-07-15','16:35:00',1.52),('9650','2013-07-15','16:40:00',1.54),('9650','2013-07-15','16:45:00',2.45),('9650','2013-07-15','16:50:00',3.06),('9650','2013-07-15','16:55:00',3.32),('9650','2013-07-15','17:00:00',6.28),('9650','2013-07-15','17:05:00',6.39),('9650','2013-07-15','17:10:00',6),('9650','2013-07-15','17:15:00',5.82),('9650','2013-07-15','17:20:00',2.98),('9650','2013-07-15','17:25:00',4.09),('9650','2013-07-15','17:30:00',3.54),('9650','2013-07-15','17:35:00',4.83),('9650','2013-07-15','17:40:00',5.2),('9650','2013-07-15','17:45:00',5.31),('9650','2013-07-15','17:50:00',4.92),('9650','2013-07-15','17:55:00',3.27),('9650','2013-07-15','18:00:00',2.35),('9650','2013-07-15','18:05:00',3.49),('9650','2013-07-15','18:10:00',3.26),('9650','2013-07-15','18:15:00',4),('9650','2013-07-15','18:20:00',3.73),('9650','2013-07-15','18:25:00',3.72),('9650','2013-07-15','18:30:00',3.58),('9650','2013-07-15','18:35:00',3.37),('9650','2013-07-15','18:40:00',3.1),('9650','2013-07-15','18:45:00',2.91),('9650','2013-07-15','18:50:00',2.73),('9650','2013-07-15','18:55:00',2.53),('9650','2013-07-15','19:00:00',2.33),('9650','2013-07-15','19:05:00',2.16),('9650','2013-07-15','19:10:00',2.08),('9650','2013-07-15','19:15:00',1.68),('9650','2013-07-15','19:20:00',1.67),('9650','2013-07-15','19:25:00',1.38),('9650','2013-07-15','19:30:00',1.24),('9650','2013-07-15','19:35:00',1.15),('9650','2013-07-14','08:00:00',1.03),('9650','2013-07-14','08:05:00',1.1),('9650','2013-07-14','08:10:00',1.19),('9650','2013-07-14','08:15:00',1.29),('9650','2013-07-14','08:20:00',1.38),('9650','2013-07-14','08:25:00',1.47),('9650','2013-07-14','08:30:00',1.61),('9650','2013-07-14','08:35:00',1.71),('9650','2013-07-14','08:40:00',1.9),('9650','2013-07-14','08:45:00',2.05),('9650','2013-07-14','08:50:00',2.15),('9650','2013-07-14','08:55:00',2.29),('9650','2013-07-14','09:00:00',2.39),('9650','2013-07-14','09:05:00',2.5),('9650','2013-07-14','09:10:00',2.64),('9650','2013-07-14','09:15:00',2.74),('9650','2013-07-14','09:20:00',2.87),('9650','2013-07-14','09:25:00',2.98),('9650','2013-07-14','09:30:00',3.11),('9650','2013-07-14','09:35:00',3.25),('9650','2013-07-14','09:40:00',3.4),('9650','2013-07-14','09:45:00',3.55),('9650','2013-07-14','09:50:00',3.66),('9650','2013-07-14','09:55:00',3.77),('9650','2013-07-14','10:00:00',3.88),('9650','2013-07-14','10:05:00',4),('9650','2013-07-14','10:10:00',4.1),('9650','2013-07-14','10:15:00',4.21),('9650','2013-07-14','10:20:00',4.26),('9650','2013-07-14','10:25:00',4.39),('9650','2013-07-14','10:30:00',4.48),('9650','2013-07-14','10:35:00',4.55),('9650','2013-07-14','10:40:00',4.68),('9650','2013-07-14','10:45:00',4.79),('9650','2013-07-14','10:50:00',4.9),('9650','2013-07-14','10:55:00',5.02),('9650','2013-07-14','11:00:00',5.13),('9650','2013-07-14','11:05:00',5.23),('9650','2013-07-14','11:10:00',5.31),('9650','2013-07-14','11:15:00',5.39),('9650','2013-07-14','11:20:00',5.48),('9650','2013-07-14','11:25:00',5.6),('9650','2013-07-14','11:30:00',5.65),('9650','2013-07-14','11:35:00',5.75),('9650','2013-07-14','11:40:00',5.81),('9650','2013-07-14','11:45:00',5.93),('9650','2013-07-14','11:50:00',5.94),('9650','2013-07-14','11:55:00',6.04),('9650','2013-07-14','12:00:00',6.15),('9650','2013-07-14','12:05:00',6.16),('9650','2013-07-14','12:10:00',6.17),('9650','2013-07-14','12:15:00',6.24),('9650','2013-07-14','12:20:00',6.39),('9650','2013-07-14','12:25:00',6.41),('9650','2013-07-14','12:30:00',6.42),('9650','2013-07-14','12:35:00',6.47),('9650','2013-07-14','12:40:00',6.49),('9650','2013-07-14','12:45:00',6.53),('9650','2013-07-14','12:50:00',6.53),('9650','2013-07-14','12:55:00',6.59),('9650','2013-07-14','13:00:00',6.81),('9650','2013-07-14','13:05:00',4.69),('9650','2013-07-14','13:10:00',4.71),('9650','2013-07-14','13:15:00',7.05),('9650','2013-07-14','13:20:00',6.94),('9650','2013-07-14','13:25:00',7.23),('9650','2013-07-14','13:30:00',7.49),('9650','2013-07-14','13:35:00',7.46),('9650','2013-07-14','13:40:00',3.16),('9650','2013-07-14','13:45:00',3.63),('9650','2013-07-14','13:50:00',4.88),('9650','2013-07-14','13:55:00',6.22),('9650','2013-07-14','14:00:00',7.89),('9650','2013-07-14','14:05:00',7.81),('9650','2013-07-14','14:10:00',3.53),('9650','2013-07-14','14:15:00',1.63),('9650','2013-07-14','14:20:00',4.32),('9650','2013-07-14','14:25:00',7.85),('9650','2013-07-14','14:30:00',7.59),('9650','2013-07-14','14:35:00',7.51),('9650','2013-07-14','14:40:00',7.37),('9650','2013-07-14','14:45:00',7.38),('9650','2013-07-14','14:50:00',7.35),('9650','2013-07-14','14:55:00',7.38),('9650','2013-07-14','15:00:00',7.4),('9650','2013-07-14','15:05:00',7.23),('9650','2013-07-14','15:10:00',7.15),('9650','2013-07-14','15:15:00',7.04),('9650','2013-07-14','15:20:00',4.49),('9650','2013-07-14','15:25:00',2.32),('9650','2013-07-14','15:30:00',7.33),('9650','2013-07-14','15:35:00',7.26),('9650','2013-07-14','15:40:00',7.21),('9650','2013-07-14','15:45:00',6.95),('9650','2013-07-14','15:50:00',6.99),('9650','2013-07-14','15:55:00',6.82),('9650','2013-07-14','16:00:00',6.59),('9650','2013-07-14','16:05:00',6.62),('9650','2013-07-14','16:10:00',6.59),('9650','2013-07-14','16:15:00',6.45),('9650','2013-07-14','16:20:00',6.31),('9650','2013-07-14','16:25:00',6.19),('9650','2013-07-14','16:30:00',6.2),('9650','2013-07-14','16:35:00',6.2),('9650','2013-07-14','16:40:00',6.11),('9650','2013-07-14','16:45:00',6.02),('9650','2013-07-14','16:50:00',5.97),('9650','2013-07-14','16:55:00',5.93),('9650','2013-07-14','17:00:00',5.84),('9650','2013-07-14','17:05:00',5.77),('9650','2013-07-14','17:10:00',5.6),('9650','2013-07-14','17:15:00',5.54),('9650','2013-07-14','17:20:00',5.43),('9650','2013-07-14','17:25:00',5.35),('9650','2013-07-14','17:30:00',5.25),('9650','2013-07-14','17:35:00',5.09),('9650','2013-07-14','17:40:00',4.93),('9650','2013-07-14','17:45:00',4.76),('9650','2013-07-14','17:50:00',4.64),('9650','2013-07-14','17:55:00',4.49),('9650','2013-07-14','18:00:00',4.35),('9650','2013-07-14','18:05:00',4.24),('9650','2013-07-14','18:10:00',4.14),('9650','2013-07-14','18:15:00',3.98),('9650','2013-07-14','18:20:00',3.8),('9650','2013-07-14','18:25:00',3.68),('9650','2013-07-14','18:30:00',3.52),('9650','2013-07-14','18:35:00',3.34),('9650','2013-07-14','18:40:00',3.24),('9650','2013-07-14','18:45:00',3.11),('9650','2013-07-14','18:50:00',2.96),('9650','2013-07-14','18:55:00',2.78),('9650','2013-07-14','19:00:00',2.69),('9650','2013-07-14','19:05:00',2.53),('9650','2013-07-14','19:10:00',2.33),('9650','2013-07-14','19:15:00',2.12),('9650','2013-07-14','19:20:00',1.94),('9650','2013-07-14','19:25:00',1.74),('9650','2013-07-14','19:30:00',1.59),('9650','2013-07-14','19:35:00',1.4),('9650','2013-07-14','19:40:00',1.12),('9650','2013-07-13','07:40:00',1.12),('9650','2013-07-13','07:45:00',1.3),('9650','2013-07-13','07:50:00',1.57),('9650','2013-07-13','07:55:00',1.86),('9650','2013-07-13','08:00:00',1.83),('9650','2013-07-13','08:05:00',1.86),('9650','2013-07-13','08:10:00',2.01),('9650','2013-07-13','08:15:00',1.83),('9650','2013-07-13','08:20:00',2.38),('9650','2013-07-13','08:25:00',1.79),('9650','2013-07-13','08:30:00',1.47),('9650','2013-07-13','08:35:00',1.7),('9650','2013-07-13','08:40:00',1.57),('9650','2013-07-13','08:45:00',1.41),('9650','2013-07-13','08:50:00',1.5),('9650','2013-07-13','08:55:00',1.57),('9650','2013-07-13','09:00:00',1.66),('9650','2013-07-13','09:05:00',1.7),('9650','2013-07-13','09:10:00',2.01),('9650','2013-07-13','09:15:00',2.01),('9650','2013-07-13','09:20:00',1.94),('9650','2013-07-13','09:25:00',2.93),('9650','2013-07-13','09:30:00',3.31),('9650','2013-07-13','09:35:00',3.06),('9650','2013-07-13','09:40:00',2.67),('9650','2013-07-13','09:45:00',2.64),('9650','2013-07-13','09:50:00',2.56),('9650','2013-07-13','09:55:00',2.59),('9650','2013-07-13','10:00:00',2.51),('9650','2013-07-13','10:05:00',2.73),('9650','2013-07-13','10:10:00',2.39),('9650','2013-07-13','10:15:00',2.46),('9650','2013-07-13','10:20:00',3.5),('9650','2013-07-13','10:25:00',3.89),('9650','2013-07-13','10:30:00',3.74),('9650','2013-07-13','10:35:00',4.72),('9650','2013-07-13','10:40:00',4.57),('9650','2013-07-13','10:45:00',4),('9650','2013-07-13','10:50:00',5.44),('9650','2013-07-13','10:55:00',4.68),('9650','2013-07-13','11:00:00',4.02),('9650','2013-07-13','11:05:00',1.75),('9650','2013-07-13','11:10:00',2.08),('9650','2013-07-13','11:15:00',2.39),('9650','2013-07-13','11:20:00',3.37),('9650','2013-07-13','11:25:00',2.15),('9650','2013-07-13','11:30:00',2.14),('9650','2013-07-13','11:35:00',4.4),('9650','2013-07-13','11:40:00',6.01),('9650','2013-07-13','11:45:00',3.87),('9650','2013-07-13','11:50:00',4.27),('9650','2013-07-13','11:55:00',3.88),('9650','2013-07-13','12:00:00',4.14),('9650','2013-07-13','12:05:00',3.02),('9650','2013-07-13','12:10:00',2.78),('9650','2013-07-13','12:15:00',4.99),('9650','2013-07-13','12:20:00',6.08),('9650','2013-07-13','12:25:00',4.16),('9650','2013-07-13','12:30:00',7.23),('9650','2013-07-13','12:35:00',7.47),('9650','2013-07-13','12:40:00',7.54),('9650','2013-07-13','12:45:00',6.99),('9650','2013-07-13','12:50:00',7.26),('9650','2013-07-13','12:55:00',5.56),('9650','2013-07-13','13:00:00',5.04),('9650','2013-07-13','13:05:00',7.82),('9650','2013-07-13','13:10:00',7.53),('9650','2013-07-13','13:15:00',7.21),('9650','2013-07-13','13:20:00',7.17),('9650','2013-07-13','13:25:00',7.14),('9650','2013-07-13','13:30:00',7.26),('9650','2013-07-13','13:35:00',7.12),('9650','2013-07-13','13:40:00',7.19),('9650','2013-07-13','13:45:00',7.19),('9650','2013-07-13','13:50:00',7.36),('9650','2013-07-13','13:55:00',7.29),('9650','2013-07-13','14:00:00',7.33),('9650','2013-07-13','14:05:00',7.39),('9650','2013-07-13','14:10:00',7.42),('9650','2013-07-13','14:15:00',7.47),('9650','2013-07-13','14:20:00',7.47),('9650','2013-07-13','14:25:00',7.36),('9650','2013-07-13','14:30:00',7.39),('9650','2013-07-13','14:35:00',7.37),('9650','2013-07-13','14:40:00',7.31),('9650','2013-07-13','14:45:00',7.19),('9650','2013-07-13','14:50:00',7.14),('9650','2013-07-13','14:55:00',7.1),('9650','2013-07-13','15:00:00',7.12),('9650','2013-07-13','15:05:00',7.16),('9650','2013-07-13','15:10:00',7.12),('9650','2013-07-13','15:15:00',7.16),('9650','2013-07-13','15:20:00',7.08),('9650','2013-07-13','15:25:00',7.02),('9650','2013-07-13','15:30:00',7.03),('9650','2013-07-13','15:35:00',7.04),('9650','2013-07-13','15:40:00',6.94),('9650','2013-07-13','15:45:00',6.89),('9650','2013-07-13','15:50:00',6.85),('9650','2013-07-13','15:55:00',6.81),('9650','2013-07-13','16:00:00',6.66),('9650','2013-07-13','16:05:00',6.38),('9650','2013-07-13','16:10:00',6.7),('9650','2013-07-13','16:15:00',6.69),('9650','2013-07-13','16:20:00',6.56),('9650','2013-07-13','16:25:00',5.11),('9650','2013-07-13','16:30:00',5.29),('9650','2013-07-13','16:35:00',6.75),('9650','2013-07-13','16:40:00',6.38),('9650','2013-07-13','16:45:00',6.02),('9650','2013-07-13','16:50:00',5.39),('9650','2013-07-13','16:55:00',4.46),('9650','2013-07-13','17:00:00',5.98),('9650','2013-07-13','17:05:00',3.86),('9650','2013-07-13','17:10:00',5.3),('9650','2013-07-13','17:15:00',5.01),('9650','2013-07-13','17:20:00',3.29),('9650','2013-07-13','17:25:00',5.07),('9650','2013-07-13','17:30:00',6.01),('9650','2013-07-13','17:35:00',5.42),('9650','2013-07-13','17:40:00',3.26),('9650','2013-07-13','17:45:00',4.47),('9650','2013-07-13','17:50:00',4.29),('9650','2013-07-13','17:55:00',4.81),('9650','2013-07-13','18:00:00',2.59),('9650','2013-07-13','18:05:00',3.41),('9650','2013-07-13','18:10:00',2.15),('9650','2013-07-13','18:40:00',1.24),('9650','2013-07-13','18:45:00',1.45),('9650','2013-07-13','18:50:00',1.28),('9650','2013-07-13','18:55:00',1.09),('9650','2013-07-13','19:05:00',1.47),('9650','2013-07-13','19:10:00',2.08),('9650','2013-07-13','19:15:00',2.02),('9650','2013-07-13','19:20:00',2.47),('9650','2013-07-13','19:25:00',2.03),('9650','2013-07-13','19:30:00',1.21),('9650','2013-07-12','07:55:00',1.02),('9650','2013-07-12','08:00:00',1.1),('9650','2013-07-12','08:05:00',1.17),('9650','2013-07-12','08:10:00',1.25),('9650','2013-07-12','08:15:00',1.32),('9650','2013-07-12','08:20:00',1.41),('9650','2013-07-12','08:25:00',1.49),('9650','2013-07-12','08:30:00',1.61),('9650','2013-07-12','08:35:00',1.72),('9650','2013-07-12','08:40:00',1.88),('9650','2013-07-12','08:45:00',1.99),('9650','2013-07-12','08:50:00',2.09),('9650','2013-07-12','08:55:00',2.19),('9650','2013-07-12','09:00:00',2.32),('9650','2013-07-12','09:05:00',2.46),('9650','2013-07-12','09:10:00',2.56),('9650','2013-07-12','09:15:00',2.66),('9650','2013-07-12','09:20:00',2.72),('9650','2013-07-12','09:25:00',2.89),('9650','2013-07-12','09:30:00',3.06),('9650','2013-07-12','09:35:00',3.19),('9650','2013-07-12','09:40:00',3.36),('9650','2013-07-12','09:45:00',3.47),('9650','2013-07-12','09:50:00',3.57),('9650','2013-07-12','09:55:00',3.71),('9650','2013-07-12','10:00:00',3.82),('9650','2013-07-12','10:05:00',3.95),('9650','2013-07-12','10:10:00',4.04),('9650','2013-07-12','10:15:00',4.14),('9650','2013-07-12','10:20:00',4.3),('9650','2013-07-12','10:25:00',4.34),('9650','2013-07-12','10:30:00',3.88),('9650','2013-07-12','10:35:00',4.08),('9650','2013-07-12','10:40:00',4.8),('9650','2013-07-12','10:45:00',4.91),('9650','2013-07-12','10:50:00',4.43),('9650','2013-07-12','10:55:00',5.33),('9650','2013-07-12','11:00:00',5.69),('9650','2013-07-12','11:05:00',5.1),('9650','2013-07-12','11:10:00',5.36),('9650','2013-07-12','11:15:00',5.85),('9650','2013-07-12','11:20:00',4.99),('9650','2013-07-12','11:25:00',3.79),('9650','2013-07-12','11:30:00',6.2),('9650','2013-07-12','11:35:00',6.39),('9650','2013-07-12','11:40:00',4.97),('9650','2013-07-12','11:45:00',1.77),('9650','2013-07-12','11:50:00',5.55),('9650','2013-07-12','11:55:00',6.55),('9650','2013-07-12','12:00:00',1.83),('9650','2013-07-12','12:05:00',4.15),('9650','2013-07-12','12:10:00',6.94),('9650','2013-07-12','12:15:00',5.63),('9650','2013-07-12','12:20:00',6.91),('9650','2013-07-12','12:25:00',6.05),('9650','2013-07-12','12:30:00',5.97),('9650','2013-07-12','12:35:00',5.12),('9650','2013-07-12','12:40:00',6.89),('9650','2013-07-12','12:45:00',6.97),('9650','2013-07-12','12:50:00',3.55),('9650','2013-07-12','12:55:00',6.25),('9650','2013-07-12','13:00:00',7.24),('9650','2013-07-12','13:05:00',7.28),('9650','2013-07-12','13:10:00',5.95),('9650','2013-07-12','13:15:00',7.2),('9650','2013-07-12','13:20:00',7.15),('9650','2013-07-12','13:25:00',6.98),('9650','2013-07-12','13:30:00',7.01),('9650','2013-07-12','13:35:00',7.12),('9650','2013-07-12','13:40:00',7.15),('9650','2013-07-12','13:45:00',7.16),('9650','2013-07-12','13:50:00',7.24),('9650','2013-07-12','13:55:00',7.19),('9650','2013-07-12','14:00:00',7.21),('9650','2013-07-12','14:05:00',7.22),('9650','2013-07-12','14:10:00',7.25),('9650','2013-07-12','14:15:00',7.25),('9650','2013-07-12','14:20:00',7.28),('9650','2013-07-12','14:25:00',7.27),('9650','2013-07-12','14:30:00',7.3),('9650','2013-07-12','14:35:00',7.34),('9650','2013-07-12','14:40:00',7.34),('9650','2013-07-12','14:45:00',7.34),('9650','2013-07-12','14:50:00',7.33),('9650','2013-07-12','14:55:00',7.31),('9650','2013-07-12','15:00:00',7.3),('9650','2013-07-12','15:05:00',7.39),('9650','2013-07-12','15:10:00',7.34),('9650','2013-07-12','15:15:00',7.36),('9650','2013-07-12','15:20:00',7),('9650','2013-07-12','15:25:00',7.3),('9650','2013-07-12','15:30:00',7.16),('9650','2013-07-12','15:35:00',7.28),('9650','2013-07-12','15:40:00',7.24),('9650','2013-07-12','15:45:00',7.16),('9650','2013-07-12','15:50:00',7.06),('9650','2013-07-12','15:55:00',7.01),('9650','2013-07-12','16:00:00',6.92),('9650','2013-07-12','16:05:00',6.89),('9650','2013-07-12','16:10:00',6.83),('9650','2013-07-12','16:15:00',6.76),('9650','2013-07-12','16:20:00',6.75),('9650','2013-07-12','16:25:00',6.78),('9650','2013-07-12','16:30:00',6.72),('9650','2013-07-12','16:35:00',6.6),('9650','2013-07-12','16:40:00',6.52),('9650','2013-07-12','16:45:00',6.39),('9650','2013-07-12','16:50:00',6.3),('9650','2013-07-12','16:55:00',6.24),('9650','2013-07-12','17:00:00',6.1),('9650','2013-07-12','17:05:00',5.93),('9650','2013-07-12','17:10:00',5.94),('9650','2013-07-12','17:15:00',5.8),('9650','2013-07-12','17:20:00',5.49),('9650','2013-07-12','17:25:00',5.63),('9650','2013-07-12','17:30:00',5.36),('9650','2013-07-12','17:35:00',5.22),('9650','2013-07-12','17:40:00',5.14),('9650','2013-07-12','17:45:00',5.08),('9650','2013-07-12','17:50:00',4.89),('9650','2013-07-12','17:55:00',4.99),('9650','2013-07-12','18:00:00',4.62),('9650','2013-07-12','18:05:00',4.39),('9650','2013-07-12','18:10:00',4.49),('9650','2013-07-12','18:15:00',4.38),('9650','2013-07-12','18:20:00',4.24),('9650','2013-07-12','18:25:00',4.14),('9650','2013-07-12','18:30:00',4),('9650','2013-07-12','18:35:00',3.76),('9650','2013-07-12','18:40:00',2.6),('9650','2013-07-12','18:45:00',1.8),('9650','2013-07-12','18:50:00',2.84),('9650','2013-07-12','18:55:00',3.31),('9650','2013-07-12','19:00:00',3.28),('9650','2013-07-12','19:05:00',3.01),('9650','2013-07-12','19:10:00',2.72),('9650','2013-07-12','19:15:00',1.68),('9650','2013-07-12','19:20:00',1.46),('9650','2013-07-12','19:25:00',1.04),('9650','2013-07-12','19:40:00',1.12),('9650','2013-07-12','19:45:00',1.4),('9650','2013-07-12','19:50:00',1.18),('9650','2013-07-11','07:50:00',1.19),('9650','2013-07-11','08:05:00',1.26),('9650','2013-07-11','08:10:00',1.89),('9650','2013-07-11','08:15:00',1.8),('9650','2013-07-11','08:20:00',1.6),('9650','2013-07-11','08:25:00',1.2),('9650','2013-07-11','08:30:00',1.23),('9650','2013-07-11','08:35:00',1.64),('9650','2013-07-11','08:40:00',1.65),('9650','2013-07-11','08:45:00',1.69),('9650','2013-07-11','08:50:00',1.4),('9650','2013-07-11','08:55:00',1.1),('9650','2013-07-11','09:00:00',1.07),('9650','2013-07-11','09:05:00',1.42),('9650','2013-07-11','09:10:00',2.3),('9650','2013-07-11','09:15:00',2.74),('9650','2013-07-11','09:20:00',3.67),('9650','2013-07-11','09:25:00',3.21),('9650','2013-07-11','09:30:00',2.09),('9650','2013-07-11','09:35:00',2.84),('9650','2013-07-11','09:40:00',2.87),('9650','2013-07-11','09:45:00',3.42),('9650','2013-07-11','09:50:00',3.63),('9650','2013-07-11','09:55:00',3.86),('9650','2013-07-11','10:00:00',3.79),('9650','2013-07-11','10:05:00',3.66),('9650','2013-07-11','10:10:00',4.07),('9650','2013-07-11','10:15:00',3.12),('9650','2013-07-11','10:20:00',3.42),('9650','2013-07-11','10:25:00',3.56),('9650','2013-07-11','10:30:00',2.94),('9650','2013-07-11','10:35:00',1.34),('9650','2013-07-11','10:40:00',1.59),('9650','2013-07-11','10:45:00',2.01),('9650','2013-07-11','10:50:00',2.99),('9650','2013-07-11','10:55:00',6.03),('9650','2013-07-11','11:00:00',3),('9650','2013-07-11','11:05:00',1.86),('9650','2013-07-11','11:10:00',2.49),('9650','2013-07-11','11:15:00',4.77),('9650','2013-07-11','11:20:00',6.13),('9650','2013-07-11','11:25:00',5.84),('9650','2013-07-11','11:30:00',5.37),('9650','2013-07-11','11:35:00',5.13),('9650','2013-07-11','11:40:00',5.94),('9650','2013-07-11','11:45:00',3.04),('9650','2013-07-11','11:50:00',5.19),('9650','2013-07-11','11:55:00',6.42),('9650','2013-07-11','12:00:00',6.6),('9650','2013-07-11','12:05:00',4.35),('9650','2013-07-11','12:10:00',5.53),('9650','2013-07-11','12:15:00',7.23),('9650','2013-07-11','12:20:00',6.56),('9650','2013-07-11','12:25:00',7.07),('9650','2013-07-11','12:30:00',7.31),('9650','2013-07-11','12:35:00',6.33),('9650','2013-07-11','12:40:00',5.79),('9650','2013-07-11','12:45:00',7.18),('9650','2013-07-11','12:50:00',6.2),('9650','2013-07-11','12:55:00',5.21),('9650','2013-07-11','13:00:00',7.22),('9650','2013-07-11','13:05:00',6.69),('9650','2013-07-11','13:10:00',7.14),('9650','2013-07-11','13:15:00',7.12),('9650','2013-07-11','13:20:00',6.96),('9650','2013-07-11','13:25:00',6.69),('9650','2013-07-11','13:30:00',7.27),('9650','2013-07-11','13:35:00',7.25),('9650','2013-07-11','13:40:00',7.32),('9650','2013-07-11','13:45:00',4.81),('9650','2013-07-11','13:50:00',7.58),('9650','2013-07-11','13:55:00',7.5),('9650','2013-07-11','14:00:00',7.64),('9650','2013-07-11','14:05:00',7.37),('9650','2013-07-11','14:10:00',4.47),('9650','2013-07-11','14:15:00',7.88),('9650','2013-07-11','14:20:00',7.92),('9650','2013-07-11','14:25:00',7.77),('9650','2013-07-11','14:30:00',7.68),('9650','2013-07-11','14:35:00',7.35),('9650','2013-07-11','14:40:00',7.23),('9650','2013-07-11','14:45:00',7.23),('9650','2013-07-11','14:50:00',7.2),('9650','2013-07-11','14:55:00',7.19),('9650','2013-07-11','15:00:00',7.09),('9650','2013-07-11','15:05:00',7.19),('9650','2013-07-11','15:10:00',7.2),('9650','2013-07-11','15:15:00',7.15),('9650','2013-07-11','15:20:00',7.1),('9650','2013-07-11','15:25:00',7.17),('9650','2013-07-11','15:30:00',7.13),('9650','2013-07-11','15:35:00',7.02),('9650','2013-07-11','15:40:00',6.98),('9650','2013-07-11','15:45:00',7.04),('9650','2013-07-11','15:50:00',6.75),('9650','2013-07-11','15:55:00',6.79),('9650','2013-07-11','16:00:00',6.73),('9650','2013-07-11','16:05:00',6.57),('9650','2013-07-11','16:10:00',6.61),('9650','2013-07-11','16:15:00',6.6),('9650','2013-07-11','16:20:00',6.47),('9650','2013-07-11','16:25:00',6.4),('9650','2013-07-11','16:30:00',6.33),('9650','2013-07-11','16:35:00',6.34),('9650','2013-07-11','16:40:00',6.29),('9650','2013-07-11','16:45:00',6.29),('9650','2013-07-11','16:50:00',6.12),('9650','2013-07-11','16:55:00',6.03),('9650','2013-07-11','17:00:00',5.9),('9650','2013-07-11','17:05:00',5.83),('9650','2013-07-11','17:10:00',5.69),('9650','2013-07-11','17:15:00',5.59),('9650','2013-07-11','17:20:00',5.42),('9650','2013-07-11','17:25:00',5.31),('9650','2013-07-11','17:30:00',5.24),('9650','2013-07-11','17:35:00',5.18),('9650','2013-07-11','17:40:00',5.06),('9650','2013-07-11','17:45:00',4.91),('9650','2013-07-11','17:50:00',4.84),('9650','2013-07-11','17:55:00',4.74),('9650','2013-07-11','18:00:00',4.58),('9650','2013-07-11','18:05:00',4.4),('9650','2013-07-11','18:10:00',4.29),('9650','2013-07-11','18:15:00',4.14),('9650','2013-07-11','18:20:00',3.9),('9650','2013-07-11','18:25:00',3.81),('9650','2013-07-11','18:30:00',3.67),('9650','2013-07-11','18:35:00',3.57),('9650','2013-07-11','18:40:00',3.41),('9650','2013-07-11','18:45:00',3.22),('9650','2013-07-11','18:50:00',3.04),('9650','2013-07-11','18:55:00',2.86),('9650','2013-07-11','19:00:00',2.71),('9650','2013-07-11','19:05:00',2.54),('9650','2013-07-11','19:10:00',2.38),('9650','2013-07-11','19:15:00',2.16),('9650','2013-07-11','19:20:00',1.58),('9650','2013-07-11','19:25:00',1.11),('9650','2013-07-11','19:30:00',1.55),('9650','2013-07-11','19:35:00',1.04),('9650','2013-07-10','07:55:00',1.05),('9650','2013-07-10','08:00:00',1.13),('9650','2013-07-10','08:05:00',1.21),('9650','2013-07-10','08:10:00',1.28),('9650','2013-07-10','08:15:00',1.36),('9650','2013-07-10','08:20:00',1.45),('9650','2013-07-10','08:25:00',1.53),('9650','2013-07-10','08:30:00',1.65),('9650','2013-07-10','08:35:00',1.74),('9650','2013-07-10','08:40:00',1.95),('9650','2013-07-10','08:45:00',2.03),('9650','2013-07-10','08:50:00',2.12),('9650','2013-07-10','08:55:00',2.28),('9650','2013-07-10','09:00:00',2.29),('9650','2013-07-10','09:05:00',2.37),('9650','2013-07-10','09:10:00',2.61),('9650','2013-07-10','09:15:00',2.82),('9650','2013-07-10','09:20:00',2.76),('9650','2013-07-10','09:25:00',2.52),('9650','2013-07-10','09:30:00',2.03),('9650','2013-07-10','09:35:00',3.63),('9650','2013-07-10','09:40:00',3.55),('9650','2013-07-10','09:45:00',3.92),('9650','2013-07-10','09:50:00',4.16),('9650','2013-07-10','09:55:00',2.36),('9650','2013-07-10','10:00:00',2.82),('9650','2013-07-10','10:05:00',2.22),('9650','2013-07-10','10:10:00',3.78),('9650','2013-07-10','10:15:00',4.79),('9650','2013-07-10','10:20:00',4.47),('9650','2013-07-10','10:25:00',4.66),('9650','2013-07-10','10:30:00',4.47),('9650','2013-07-10','10:35:00',4.04),('9650','2013-07-10','10:40:00',2.36),('9650','2013-07-10','10:45:00',5.24),('9650','2013-07-10','10:50:00',5.54),('9650','2013-07-10','10:55:00',5.59),('9650','2013-07-10','11:00:00',5.71),('9650','2013-07-10','11:05:00',4.84),('9650','2013-07-10','11:10:00',6.08),('9650','2013-07-10','11:15:00',5.34),('9650','2013-07-10','11:20:00',6.42),('9650','2013-07-10','11:25:00',5.33),('9650','2013-07-10','11:30:00',5.77),('9650','2013-07-10','11:35:00',3.75),('9650','2013-07-10','11:40:00',4.96),('9650','2013-07-10','11:45:00',3.33),('9650','2013-07-10','11:50:00',4.64),('9650','2013-07-10','11:55:00',7.31),('9650','2013-07-10','12:00:00',4.11),('9650','2013-07-10','12:05:00',3.08),('9650','2013-07-10','12:10:00',2.15),('9650','2013-07-10','12:15:00',4.23),('9650','2013-07-10','12:20:00',7.21),('9650','2013-07-10','12:25:00',7.41),('9650','2013-07-10','12:30:00',7.37),('9650','2013-07-10','12:35:00',7.19),('9650','2013-07-10','12:40:00',7.31),('9650','2013-07-10','12:45:00',7.01),('9650','2013-07-10','12:50:00',7.11),('9650','2013-07-10','12:55:00',5.26),('9650','2013-07-10','13:00:00',7.27),('9650','2013-07-10','13:05:00',7.24),('9650','2013-07-10','13:10:00',7.23),('9650','2013-07-10','13:15:00',5.87),('9650','2013-07-10','13:20:00',6.68),('9650','2013-07-10','13:25:00',6.68),('9650','2013-07-10','13:30:00',6.34),('9650','2013-07-10','13:35:00',7.03),('9650','2013-07-10','13:40:00',7.35),('9650','2013-07-10','13:45:00',6.03),('9650','2013-07-10','13:50:00',4.11),('9650','2013-07-10','13:55:00',4.32),('9650','2013-07-10','14:00:00',7.36),('9650','2013-07-10','14:05:00',7.49),('9650','2013-07-10','14:10:00',6.83),('9650','2013-07-10','14:15:00',7.56),('9650','2013-07-10','14:20:00',7.14),('9650','2013-07-10','14:25:00',7.6),('9650','2013-07-10','14:30:00',7.54),('9650','2013-07-10','14:35:00',7.21),('9650','2013-07-10','14:40:00',6.93),('9650','2013-07-10','14:45:00',7.4),('9650','2013-07-10','14:50:00',7.22),('9650','2013-07-10','14:55:00',5.38),('9650','2013-07-10','15:00:00',5.2),('9650','2013-07-10','15:05:00',4.14),('9650','2013-07-10','15:10:00',6.57),('9650','2013-07-10','15:15:00',4.44),('9650','2013-07-10','15:20:00',5.85),('9650','2013-07-10','15:25:00',4.68),('9650','2013-07-10','15:30:00',7.56),('9650','2013-07-10','15:35:00',5.42),('9650','2013-07-10','15:40:00',7.22),('9650','2013-07-10','15:45:00',6.55),('9650','2013-07-10','15:50:00',5.27),('9650','2013-07-10','15:55:00',2.17),('9650','2013-07-10','16:00:00',7.18),('9650','2013-07-10','16:05:00',3.76),('9650','2013-07-10','16:10:00',7.46),('9650','2013-07-10','16:15:00',2.88),('9650','2013-07-10','16:20:00',6.94),('9650','2013-07-10','16:25:00',3.26),('9650','2013-07-10','16:30:00',5.01),('9650','2013-07-10','16:35:00',4.73),('9650','2013-07-10','16:40:00',6.12),('9650','2013-07-10','16:45:00',6.42),('9650','2013-07-10','16:50:00',6.46),('9650','2013-07-10','16:55:00',6.36),('9650','2013-07-10','17:00:00',4.31),('9650','2013-07-10','17:05:00',4.64),('9650','2013-07-10','17:10:00',5.56),('9650','2013-07-10','17:15:00',4.97),('9650','2013-07-10','17:20:00',4.81),('9650','2013-07-10','17:25:00',4.88),('9650','2013-07-10','17:30:00',5.63),('9650','2013-07-10','17:35:00',4.77),('9650','2013-07-10','17:40:00',5.07),('9650','2013-07-10','17:45:00',4.33),('9650','2013-07-10','17:50:00',4.74),('9650','2013-07-10','17:55:00',4.84),('9650','2013-07-10','18:00:00',4.87),('9650','2013-07-10','18:05:00',3.13),('9650','2013-07-10','18:10:00',4.67),('9650','2013-07-10','18:15:00',4.57),('9650','2013-07-10','18:20:00',3.16),('9650','2013-07-10','18:25:00',3.38),('9650','2013-07-10','18:30:00',3.39),('9650','2013-07-10','18:35:00',2.31),('9650','2013-07-10','18:40:00',2.35),('9650','2013-07-10','18:45:00',1.83),('9650','2013-07-10','18:50:00',1.26),('9650','2013-07-10','18:55:00',1.4),('9650','2013-07-10','19:00:00',2.02),('9650','2013-07-10','19:05:00',1.77),('9650','2013-07-10','19:10:00',1.98),('9650','2013-07-10','19:15:00',2.3),('9650','2013-07-10','19:20:00',2.06),('9650','2013-07-10','19:25:00',1.08),('9650','2013-07-10','19:30:00',1.46),('9650','2013-07-10','19:35:00',1.42),('9650','2014-05-02','08:10:00',1.23),('9650','2014-05-02','08:15:00',1.43),('9650','2014-05-02','08:20:00',1.37),('9650','2014-05-02','08:25:00',1.3),('9650','2014-05-02','08:30:00',1.46),('9650','2014-05-02','08:35:00',1.03),('9650','2014-05-02','08:45:00',1.55),('9650','2014-05-02','08:50:00',2.17),('9650','2014-05-02','08:55:00',2.92),('9650','2014-05-02','09:00:00',3.07),('9650','2014-05-02','09:05:00',2.26),('9650','2014-05-02','09:10:00',1.9),('9650','2014-05-02','09:15:00',3.15),('9650','2014-05-02','09:20:00',3.36),('9650','2014-05-02','09:25:00',2.91),('9650','2014-05-02','09:30:00',3.16),('9650','2014-05-02','09:35:00',4.21),('9650','2014-05-02','09:40:00',3.38),('9650','2014-05-02','09:45:00',3.43),('9650','2014-05-02','09:50:00',1.91),('9650','2014-05-02','09:55:00',4.14),('9650','2014-05-02','10:00:00',4.59),('9650','2014-05-02','10:05:00',4.69),('9650','2014-05-02','10:10:00',4.97),('9650','2014-05-02','10:15:00',5.65),('9650','2014-05-02','10:20:00',4.94),('9650','2014-05-02','10:25:00',4.44),('9650','2014-05-02','10:30:00',3.02),('9650','2014-05-02','10:35:00',1.79),('9650','2014-05-02','10:40:00',1.87),('9650','2014-05-02','10:45:00',2.05),('9650','2014-05-02','10:50:00',1.88),('9650','2014-05-02','10:55:00',2.19),('9650','2014-05-02','11:00:00',1.95),('9650','2014-05-02','11:05:00',5.59),('9650','2014-05-02','11:10:00',5.27),('9650','2014-05-02','11:15:00',7.68),('9650','2014-05-02','11:20:00',5.86),('9650','2014-05-02','11:25:00',5.75),('9650','2014-05-02','11:30:00',6.71),('9650','2014-05-02','11:35:00',4.5),('9650','2014-05-02','11:40:00',4.79),('9650','2014-05-02','11:45:00',4.29),('9650','2014-05-02','11:50:00',3.89),('9650','2014-05-02','11:55:00',3.98),('9650','2014-05-02','12:00:00',3.25),('9650','2014-05-02','12:05:00',2.69),('9650','2014-05-02','12:10:00',2.44),('9650','2014-05-02','12:15:00',2.29),('9650','2014-05-02','12:20:00',2.14),('9650','2014-05-02','12:25:00',2.2),('9650','2014-05-02','12:30:00',2.8),('9650','2014-05-02','12:35:00',3.6),('9650','2014-05-02','12:40:00',3.57),('9650','2014-05-02','12:45:00',3.63),('9650','2014-05-02','12:50:00',3.27),('9650','2014-05-02','12:55:00',3.2),('9650','2014-05-02','13:00:00',3.55),('9650','2014-05-02','13:05:00',4.1),('9650','2014-05-02','13:10:00',5.91),('9650','2014-05-02','13:15:00',5.09),('9650','2014-05-02','13:20:00',3.98),('9650','2014-05-02','13:25:00',5.18),('9650','2014-05-02','13:30:00',5.95),('9650','2014-05-02','13:35:00',4.49),('9650','2014-05-02','13:40:00',3.59),('9650','2014-05-02','13:45:00',3.39),('9650','2014-05-02','13:50:00',3.38),('9650','2014-05-02','13:55:00',3.4),('9650','2014-05-02','14:00:00',3.36),('9650','2014-05-02','14:05:00',3.42),('9650','2014-05-02','14:10:00',3.71),('9650','2014-05-02','14:15:00',4.23),('9650','2014-05-02','14:20:00',4.94),('9650','2014-05-02','14:25:00',6.36),('9650','2014-05-02','14:30:00',4.41),('9650','2014-05-02','14:35:00',2.89),('9650','2014-05-02','14:40:00',2.19),('9650','2014-05-02','14:45:00',1.36),('9650','2014-05-02','14:50:00',1.15),('9650','2014-05-02','14:55:00',3.73),('9650','2014-05-02','15:00:00',3.44),('9650','2014-05-02','15:05:00',1.86),('9650','2014-05-02','15:10:00',1.49),('9650','2014-05-02','15:15:00',1.06),('9650','2014-05-02','16:30:00',1.12),('9650','2014-05-02','16:35:00',1.22),('9650','2014-05-02','16:40:00',1.28),('9650','2014-05-02','16:45:00',1.32),('9650','2014-05-02','16:50:00',1.34),('9650','2014-05-02','16:55:00',1.37),('9650','2014-05-02','17:00:00',1.36),('9650','2014-05-02','17:05:00',1.61),('9650','2014-05-02','17:10:00',1.7),('9650','2014-05-02','17:15:00',1.71),('9650','2014-05-02','17:20:00',1.73),('9650','2014-05-02','17:25:00',1.77),('9650','2014-05-02','17:30:00',1.74),('9650','2014-05-02','17:35:00',1.71),('9650','2014-05-02','17:40:00',1.78),('9650','2014-05-02','17:45:00',1.94),('9650','2014-05-02','17:50:00',2.36),('9650','2014-05-02','17:55:00',2.45),('9650','2014-05-02','18:00:00',1.94),('9650','2014-05-02','18:05:00',1.7),('9650','2014-05-02','18:10:00',1.85),('9650','2014-05-02','18:15:00',1.71),('9650','2014-05-02','18:20:00',1.22),('9650','2014-05-02','18:25:00',1.62),('9650','2014-05-02','18:30:00',1.1),('9650','2014-05-02','18:40:00',1.29),('9650','2014-05-02','18:45:00',2.1),('9650','2014-05-02','18:50:00',1.34),('9650','2014-05-02','18:55:00',1.11),('9650','2014-05-02','19:05:00',1.06),('9650','2014-05-02','19:10:00',1.26),('9650','2014-04-05','09:10:00',1.15),('9650','2014-04-05','09:15:00',1.47),('9650','2014-04-05','09:20:00',1.45),('9650','2014-04-05','09:25:00',1.47),('9650','2014-04-05','09:30:00',1.61),('9650','2014-04-05','09:35:00',2.24),('9650','2014-04-05','09:40:00',2.62),('9650','2014-04-05','09:45:00',3.27),('9650','2014-04-05','09:50:00',3.8),('9650','2014-04-05','09:55:00',3.88),('9650','2014-04-05','10:00:00',3.48),('9650','2014-04-05','10:05:00',3.05),('9650','2014-04-05','10:10:00',2.84),('9650','2014-04-05','10:15:00',3.33),('9650','2014-04-05','10:20:00',2.57),('9650','2014-04-05','10:25:00',2.06),('9650','2014-04-05','10:30:00',2.17),('9650','2014-04-05','10:35:00',2.37),('9650','2014-04-05','10:40:00',2.5),('9650','2014-04-05','10:45:00',3.61),('9650','2014-04-05','10:50:00',4.24),('9650','2014-04-05','10:55:00',2.32),('9650','2014-04-05','11:00:00',3.22),('9650','2014-04-05','11:05:00',3.44),('9650','2014-04-05','11:10:00',5.24),('9650','2014-04-05','11:15:00',2.29),('9650','2014-04-05','11:20:00',5.23),('9650','2014-04-05','11:25:00',5.16),('9650','2014-04-05','11:30:00',5.63),('9650','2014-04-05','11:35:00',6.29),('9650','2014-04-05','11:40:00',6.18),('9650','2014-04-05','11:45:00',5.93),('9650','2014-04-05','11:50:00',5.69),('9650','2014-04-05','11:55:00',5.94),('9650','2014-04-05','12:00:00',6.1),('9650','2014-04-05','12:05:00',5.93),('9650','2014-04-05','12:10:00',5.92),('9650','2014-04-05','12:15:00',6.36),('9650','2014-04-05','12:20:00',4.88),('9650','2014-04-05','12:25:00',3.74),('9650','2014-04-05','12:30:00',3.33),('9650','2014-04-05','12:35:00',3.83),('9650','2014-04-05','12:40:00',2.6),('9650','2014-04-05','12:45:00',1.75),('9650','2014-04-05','12:50:00',2.19),('9650','2014-04-05','12:55:00',3.49),('9650','2014-04-05','13:00:00',6.55),('9650','2014-04-05','13:05:00',5.05),('9650','2014-04-05','13:10:00',6.7),('9650','2014-04-05','13:15:00',5.79),('9650','2014-04-05','13:20:00',4.5),('9650','2014-04-05','13:25:00',2),('9650','2014-04-05','13:30:00',6.11),('9650','2014-04-05','13:35:00',4.78),('9650','2014-04-05','13:40:00',1.92),('9650','2014-04-05','13:45:00',6.92),('9650','2014-04-05','13:50:00',7.15),('9650','2014-04-05','13:55:00',7.13),('9650','2014-04-05','14:00:00',6.9),('9650','2014-04-05','14:05:00',6.46),('9650','2014-04-05','14:10:00',7.03),('9650','2014-04-05','14:15:00',7.12),('9650','2014-04-05','14:20:00',3.95),('9650','2014-04-05','14:25:00',2.68),('9650','2014-04-05','14:30:00',1.84),('9650','2014-04-05','14:35:00',2.14),('9650','2014-04-05','14:40:00',3.91),('9650','2014-04-05','14:45:00',8.44),('9650','2014-04-05','14:50:00',6.39),('9650','2014-04-05','14:55:00',4.85),('9650','2014-04-05','15:00:00',3.67),('9650','2014-04-05','15:05:00',2.15),('9650','2014-04-05','15:10:00',5.84),('9650','2014-04-05','15:15:00',5.3),('9650','2014-04-05','15:20:00',4.24),('9650','2014-04-05','15:25:00',1.99),('9650','2014-04-05','15:30:00',1.77),('9650','2014-04-05','15:35:00',1.09),('9650','2014-04-05','15:40:00',1.21),('9650','2014-04-05','15:45:00',1.64),('9650','2014-04-05','15:50:00',2.76),('9650','2014-04-05','15:55:00',6.78),('9650','2014-04-05','16:00:00',6.27),('9650','2014-04-05','16:05:00',2.9),('9650','2014-04-05','16:15:00',2.05),('9650','2014-04-05','16:20:00',1.19),('9650','2014-04-05','16:25:00',1.67),('9650','2014-04-05','16:30:00',1.93),('9650','2014-04-05','16:35:00',2.94),('9650','2014-04-05','16:40:00',4.88),('9650','2014-04-05','16:45:00',6),('9650','2014-04-05','16:50:00',5.93),('9650','2014-04-05','16:55:00',4.49),('9650','2014-04-05','17:00:00',1.68),('9650','2014-04-05','17:05:00',1.42),('9650','2014-04-05','17:10:00',1.14),('9650','2014-04-05','17:15:00',1.1),('9650','2014-04-05','17:20:00',1.6),('9650','2014-04-05','17:25:00',4.09),('9650','2014-04-05','17:30:00',4.34),('9650','2014-04-05','17:35:00',2.93),('9650','2014-04-05','17:40:00',1.66),('9650','2014-04-05','17:45:00',2.67),('9650','2014-04-05','17:50:00',3.84),('9650','2014-04-05','17:55:00',3.5),('9650','2014-04-05','18:00:00',3.29),('9650','2014-04-05','18:05:00',3.08),('9650','2014-04-05','18:10:00',2.97),('9650','2014-04-05','18:15:00',2.92),('9650','2014-04-05','18:20:00',2.88),('9650','2014-04-05','18:25:00',2.63),('9650','2014-04-05','18:30:00',1.43),('9650','2014-04-05','18:35:00',1.67),('9650','2014-04-05','18:40:00',1.49),('9650','2014-04-05','18:45:00',1.34),('9650','2014-04-05','18:50:00',1.04),('9650','2013-07-09','07:25:00',1.12),('9650','2013-07-09','07:30:00',1.26),('9650','2013-07-09','07:35:00',1.42),('9650','2013-07-09','07:40:00',1.56),('9650','2013-07-09','07:45:00',1.65),('9650','2013-07-09','07:50:00',1.78),('9650','2013-07-09','07:55:00',1.92),('9650','2013-07-09','08:00:00',1.93),('9650','2013-07-09','08:05:00',1.74),('9650','2013-07-09','08:10:00',2.05),('9650','2013-07-09','08:15:00',2.08),('9650','2013-07-09','08:20:00',2.04),('9650','2013-07-09','08:25:00',2.32),('9650','2013-07-09','08:30:00',2.19),('9650','2013-07-09','08:35:00',2.07),('9650','2013-07-09','08:40:00',2.61),('9650','2013-07-09','08:45:00',2.48),('9650','2013-07-09','08:50:00',2.49),('9650','2013-07-09','08:55:00',2.46),('9650','2013-07-09','09:00:00',2.5),('9650','2013-07-09','09:05:00',2.71),('9650','2013-07-09','09:10:00',2.87),('9650','2013-07-09','09:15:00',3),('9650','2013-07-09','09:20:00',3.05),('9650','2013-07-09','09:25:00',2.12),('9650','2013-07-09','09:30:00',3.03),('9650','2013-07-09','09:35:00',3.33),('9650','2013-07-09','09:40:00',3.46),('9650','2013-07-09','09:45:00',3.57),('9650','2013-07-09','09:50:00',3.6),('9650','2013-07-09','09:55:00',2.94),('9650','2013-07-09','10:00:00',3.91),('9650','2013-07-09','10:05:00',4.03),('9650','2013-07-09','10:10:00',4.12),('9650','2013-07-09','10:15:00',4.22),('9650','2013-07-09','10:20:00',4.31),('9650','2013-07-09','10:25:00',4.47),('9650','2013-07-09','10:30:00',4.56),('9650','2013-07-09','10:35:00',4.68),('9650','2013-07-09','10:40:00',4.81),('9650','2013-07-09','10:45:00',4.92),('9650','2013-07-09','10:50:00',5.03),('9650','2013-07-09','10:55:00',5.09),('9650','2013-07-09','11:00:00',5.2),('9650','2013-07-09','11:05:00',5.25),('9650','2013-07-09','11:10:00',5.35),('9650','2013-07-09','11:15:00',5.45),('9650','2013-07-09','11:20:00',5.48),('9650','2013-07-09','11:25:00',5.56),('9650','2013-07-09','11:30:00',5.6),('9650','2013-07-09','11:35:00',5.71),('9650','2013-07-09','11:40:00',5.83),('9650','2013-07-09','11:45:00',5.91),('9650','2013-07-09','11:50:00',5.99),('9650','2013-07-09','11:55:00',6.06),('9650','2013-07-09','12:00:00',6.18),('9650','2013-07-09','12:05:00',6.24),('9650','2013-07-09','12:10:00',6.19),('9650','2013-07-09','12:15:00',6.27),('9650','2013-07-09','12:20:00',6.43),('9650','2013-07-09','12:25:00',6.54),('9650','2013-07-09','12:30:00',6.59),('9650','2013-07-09','12:35:00',6.59),('9650','2013-07-09','12:40:00',6.66),('9650','2013-07-09','12:45:00',6.69),('9650','2013-07-09','12:50:00',6.71),('9650','2013-07-09','12:55:00',6.63),('9650','2013-07-09','13:00:00',6.83),('9650','2013-07-09','13:05:00',6.84),('9650','2013-07-09','13:10:00',6.94),('9650','2013-07-09','13:15:00',6.92),('9650','2013-07-09','13:20:00',6.92),('9650','2013-07-09','13:25:00',6.99),('9650','2013-07-09','13:30:00',7),('9650','2013-07-09','13:35:00',7.03),('9650','2013-07-09','13:40:00',7.11),('9650','2013-07-09','13:45:00',7.12),('9650','2013-07-09','13:50:00',7.15),('9650','2013-07-09','13:55:00',7.14),('9650','2013-07-09','14:00:00',7.21),('9650','2013-07-09','14:05:00',7.27),('9650','2013-07-09','14:10:00',7.33),('9650','2013-07-09','14:15:00',7.29),('9650','2013-07-09','14:20:00',7.29),('9650','2013-07-09','14:25:00',7.3),('9650','2013-07-09','14:30:00',7.36),('9650','2013-07-09','14:35:00',7.37),('9650','2013-07-09','14:40:00',7.37),('9650','2013-07-09','14:45:00',7.3),('9650','2013-07-09','14:50:00',7.28),('9650','2013-07-09','14:55:00',7.31),('9650','2013-07-09','15:00:00',7.32),('9650','2013-07-09','15:05:00',7.3),('9650','2013-07-09','15:10:00',7.27),('9650','2013-07-09','15:15:00',7.27),('9650','2013-07-09','15:20:00',7.22),('9650','2013-07-09','15:25:00',7.21),('9650','2013-07-09','15:30:00',7.19),('9650','2013-07-09','15:35:00',7.16),('9650','2013-07-09','15:40:00',1.06),('9650','2013-07-09','15:45:00',3.2),('9650','2013-07-09','15:50:00',6.93),('9650','2013-07-09','15:55:00',6.94),('9650','2013-07-09','16:00:00',6.83),('9650','2013-07-09','16:05:00',6.82),('9650','2013-07-09','16:10:00',6.8),('9650','2013-07-09','16:15:00',6.71),('9650','2013-07-09','16:20:00',6.69),('9650','2013-07-09','16:25:00',6.58),('9650','2013-07-09','16:30:00',6.46),('9650','2013-07-09','16:35:00',6.28),('9650','2013-07-09','16:40:00',6.28),('9650','2013-07-09','16:45:00',6.34),('9650','2013-07-09','16:50:00',6.28),('9650','2013-07-09','16:55:00',6.35),('9650','2013-07-09','17:00:00',6.49),('9650','2013-07-09','17:05:00',5.49),('9650','2013-07-09','17:10:00',5.26),('9650','2013-07-09','17:15:00',3.66),('9650','2013-07-09','17:20:00',3.52),('9650','2013-07-09','17:25:00',1.88),('9650','2013-07-09','17:30:00',1.43),('9650','2013-07-09','17:35:00',5.09),('9650','2013-07-09','17:40:00',5.14),('9650','2013-07-09','17:45:00',4.49),('9650','2013-07-09','17:50:00',5.05),('9650','2013-07-09','17:55:00',4.62),('9650','2013-07-09','18:00:00',5.01),('9650','2013-07-09','18:05:00',3.91),('9650','2013-07-09','18:10:00',3.16),('9650','2013-07-09','18:15:00',1.71),('9650','2013-07-09','18:20:00',2.37),('9650','2013-07-09','18:25:00',1.77),('9650','2013-07-09','18:30:00',1.32),('9650','2013-07-09','18:35:00',1.15),('9650','2013-07-09','18:40:00',1.14),('9650','2013-07-09','18:55:00',1.26),('9650','2013-07-09','19:00:00',1.15),('9650','2013-07-09','19:05:00',2.97),('9650','2013-07-09','19:10:00',3.01),('9650','2013-07-09','19:15:00',2.82),('9650','2013-07-09','19:20:00',2.46),('9650','2013-07-09','19:25:00',2.12),('9650','2013-07-09','19:30:00',1.85),('9650','2013-07-09','19:35:00',1.59),('9650','2013-07-08','07:55:00',1.07),('9650','2013-07-08','08:00:00',1.13),('9650','2013-07-08','08:05:00',1.2),('9650','2013-07-08','08:10:00',1.28),('9650','2013-07-08','08:15:00',1.36),('9650','2013-07-08','08:20:00',1.45),('9650','2013-07-08','08:25:00',1.55),('9650','2013-07-08','08:30:00',1.69),('9650','2013-07-08','08:35:00',1.84),('9650','2013-07-08','08:40:00',1.98),('9650','2013-07-08','08:45:00',2.08),('9650','2013-07-08','08:50:00',2.2),('9650','2013-07-08','08:55:00',2.31),('9650','2013-07-08','09:00:00',2.43),('9650','2013-07-08','09:05:00',2.54),('9650','2013-07-08','09:10:00',2.64),('9650','2013-07-08','09:15:00',2.77),('9650','2013-07-08','09:20:00',2.88),('9650','2013-07-08','09:25:00',3),('9650','2013-07-08','09:30:00',3.13),('9650','2013-07-08','09:35:00',3.3),('9650','2013-07-08','09:40:00',3.47),('9650','2013-07-08','09:45:00',3.58),('9650','2013-07-08','09:50:00',3.7),('9650','2013-07-08','09:55:00',3.82),('9650','2013-07-08','10:00:00',3.68),('9650','2013-07-08','10:05:00',3.93),('9650','2013-07-08','10:10:00',4.13),('9650','2013-07-08','10:15:00',4.22),('9650','2013-07-08','10:20:00',4.26),('9650','2013-07-08','10:25:00',4.42),('9650','2013-07-08','10:30:00',4.53),('9650','2013-07-08','10:35:00',4.65),('9650','2013-07-08','10:40:00',4.78),('9650','2013-07-08','10:45:00',4.89),('9650','2013-07-08','10:50:00',5),('9650','2013-07-08','10:55:00',5.14),('9650','2013-07-08','11:00:00',5.26),('9650','2013-07-08','11:05:00',5.31),('9650','2013-07-08','11:10:00',5.35),('9650','2013-07-08','11:15:00',5.06),('9650','2013-07-08','11:20:00',5.33),('9650','2013-07-08','11:25:00',5.46),('9650','2013-07-08','11:30:00',3.08),('9650','2013-07-08','11:35:00',3.68),('9650','2013-07-08','11:40:00',4.38),('9650','2013-07-08','11:45:00',6.32),('9650','2013-07-08','11:50:00',6.57),('9650','2013-07-08','11:55:00',6.76),('9650','2013-07-08','12:00:00',6.74),('9650','2013-07-08','12:05:00',6.69),('9650','2013-07-08','12:10:00',6.57),('9650','2013-07-08','12:15:00',6.54),('9650','2013-07-08','12:20:00',6.47),('9650','2013-07-08','12:25:00',6.46),('9650','2013-07-08','12:30:00',6.43),('9650','2013-07-08','12:35:00',6.37),('9650','2013-07-08','12:40:00',6.48),('9650','2013-07-08','12:45:00',6.62),('9650','2013-07-08','12:50:00',6.71),('9650','2013-07-08','12:55:00',6.7),('9650','2013-07-08','13:00:00',6.75),('9650','2013-07-08','13:05:00',6.96),('9650','2013-07-08','13:10:00',7.02),('9650','2013-07-08','13:15:00',6.98),('9650','2013-07-08','13:20:00',6.81),('9650','2013-07-08','13:25:00',7.07),('9650','2013-07-08','13:30:00',7.32),('9650','2013-07-08','13:35:00',7.03),('9650','2013-07-08','13:40:00',6.89),('9650','2013-07-08','13:45:00',6.09),('9650','2013-07-08','13:50:00',5.33),('9650','2013-07-08','13:55:00',5.56),('9650','2013-07-08','14:00:00',5.7),('9650','2013-07-08','14:05:00',5.39),('9650','2013-07-08','14:10:00',6.06),('9650','2013-07-08','14:15:00',6.26),('9650','2013-07-08','14:20:00',4.35),('9650','2013-07-08','14:25:00',4.73),('9650','2013-07-08','14:30:00',2.59),('9650','2013-07-08','14:35:00',1.68),('9650','2013-07-08','14:40:00',1.5),('9650','2013-07-08','14:45:00',1.21),('9650','2013-07-07','07:40:00',1.33),('9650','2013-07-07','07:45:00',1.25),('9650','2013-07-07','07:50:00',1.05),('9650','2013-07-07','07:55:00',1.03),('9650','2013-07-07','08:00:00',1.12),('9650','2013-07-07','08:05:00',1.13),('9650','2013-07-07','08:10:00',1.26),('9650','2013-07-07','08:15:00',1.39),('9650','2013-07-07','08:20:00',1.48),('9650','2013-07-07','08:25:00',1.57),('9650','2013-07-07','08:30:00',1.76),('9650','2013-07-07','08:35:00',1.89),('9650','2013-07-07','08:40:00',2),('9650','2013-07-07','08:45:00',2.12),('9650','2013-07-07','08:50:00',2.23),('9650','2013-07-07','08:55:00',2.34),('9650','2013-07-07','09:00:00',2.45),('9650','2013-07-07','09:05:00',2.56),('9650','2013-07-07','09:10:00',2.63),('9650','2013-07-07','09:15:00',2.74),('9650','2013-07-07','09:20:00',2.81),('9650','2013-07-07','09:25:00',2.85),('9650','2013-07-07','09:30:00',3.03),('9650','2013-07-07','09:35:00',3.31),('9650','2013-07-07','09:40:00',3.46),('9650','2013-07-07','09:45:00',3.59),('9650','2013-07-07','09:50:00',3.65),('9650','2013-07-07','09:55:00',3.78),('9650','2013-07-07','10:00:00',3.95),('9650','2013-07-07','10:05:00',4.03),('9650','2013-07-07','10:10:00',4.1),('9650','2013-07-07','10:15:00',4.23),('9650','2013-07-07','10:20:00',4.33),('9650','2013-07-07','10:25:00',4.49),('9650','2013-07-07','10:30:00',4.6),('9650','2013-07-07','10:35:00',4.69),('9650','2013-07-07','10:40:00',4.75),('9650','2013-07-07','10:45:00',4.88),('9650','2013-07-07','10:50:00',4.99),('9650','2013-07-07','10:55:00',5.06),('9650','2013-07-07','11:00:00',5.13),('9650','2013-07-07','11:05:00',5.27),('9650','2013-07-07','11:10:00',5.4),('9650','2013-07-07','11:15:00',5.55),('9650','2013-07-07','11:20:00',5.63),('9650','2013-07-07','11:25:00',5.75),('9650','2013-07-07','11:30:00',5.86),('9650','2013-07-07','11:35:00',5.95),('9650','2013-07-07','11:40:00',5.66),('9650','2013-07-07','11:45:00',5.98),('9650','2013-07-07','11:50:00',6.11),('9650','2013-07-07','11:55:00',6.04),('9650','2013-07-07','12:00:00',6.06),('9650','2013-07-07','12:05:00',6.35),('9650','2013-07-07','12:10:00',6.48),('9650','2013-07-07','12:15:00',6.66),('9650','2013-07-07','12:20:00',6.81),('9650','2013-07-07','12:25:00',6.79),('9650','2013-07-07','12:30:00',5.98),('9650','2013-07-07','12:35:00',6.78),('9650','2013-07-07','12:40:00',6.69),('9650','2013-07-07','12:45:00',6.71),('9650','2013-07-07','12:50:00',6.67),('9650','2013-07-07','12:55:00',6.94),('9650','2013-07-07','13:00:00',7.24),('9650','2013-07-07','13:05:00',7.46),('9650','2013-07-07','13:10:00',7.44),('9650','2013-07-07','13:15:00',7.99),('9650','2013-07-07','13:20:00',4.85),('9650','2013-07-07','13:25:00',2.15),('9650','2013-07-07','13:30:00',1.05),('9650','2013-07-07','14:00:00',1.21),('9650','2013-07-07','14:05:00',1.48),('9650','2013-07-07','14:10:00',1.58),('9650','2013-07-07','14:15:00',1.59),('9650','2013-07-07','14:20:00',1.61),('9650','2013-07-07','14:25:00',1.7),('9650','2013-07-07','14:30:00',1.87),('9650','2013-07-07','14:35:00',2.24),('9650','2013-07-07','14:40:00',2.38),('9650','2013-07-07','14:45:00',2.28),('9650','2013-07-07','14:50:00',2.27),('9650','2013-07-07','14:55:00',2.26),('9650','2013-07-07','15:00:00',2.1),('9650','2013-07-07','15:05:00',1.92),('9650','2013-07-07','15:10:00',1.74),('9650','2013-07-07','15:15:00',1.5),('9650','2013-07-07','15:20:00',1.08),('9650','2013-07-07','17:25:00',1.35),('9650','2013-07-07','17:30:00',1.65),('9650','2013-07-07','17:35:00',1.83),('9650','2013-07-07','17:40:00',1.91),('9650','2013-07-07','17:45:00',1.92),('9650','2013-07-07','17:50:00',1.97),('9650','2013-07-07','17:55:00',1.92),('9650','2013-07-07','18:00:00',1.77),('9650','2013-07-07','18:05:00',1.56),('9650','2013-07-07','18:10:00',1.48),('9650','2013-07-07','18:15:00',1.6),('9650','2013-07-07','18:20:00',1.88),('9650','2013-07-07','18:25:00',2.04),('9650','2013-07-07','18:30:00',1.81),('9650','2013-07-07','18:35:00',1.93),('9650','2013-07-07','18:40:00',3.58),('9650','2013-07-07','18:45:00',3.78),('9650','2013-07-07','18:50:00',3.35),('9650','2013-07-07','18:55:00',2.82),('9650','2013-07-07','19:00:00',2.53),('9650','2013-07-07','19:05:00',1.94),('9650','2013-07-07','19:10:00',1.32),('9650','2013-07-07','19:15:00',1.26),('9650','2013-07-07','19:20:00',1.69),('9650','2013-07-07','19:25:00',1.31),('9650','2013-07-06','08:00:00',1.03),('9650','2013-07-06','08:05:00',1.11),('9650','2013-07-06','08:10:00',1.22),('9650','2013-07-06','08:15:00',1.28),('9650','2013-07-06','08:20:00',1.11),('9650','2013-07-06','08:25:00',1.25),('9650','2013-07-06','08:30:00',1.57),('9650','2013-07-06','08:35:00',1.94),('9650','2013-07-06','08:40:00',1.51),('9650','2013-07-06','08:50:00',1.86),('9650','2013-07-06','08:55:00',2.47),('9650','2013-07-06','09:00:00',2.55),('9650','2013-07-06','09:05:00',2.41),('9650','2013-07-06','09:10:00',2.58),('9650','2013-07-06','09:15:00',2.68),('9650','2013-07-06','09:20:00',1.92),('9650','2013-07-06','09:25:00',2.48),('9650','2013-07-06','09:30:00',3.39),('9650','2013-07-06','09:35:00',3.56),('9650','2013-07-06','09:40:00',3.5),('9650','2013-07-06','09:45:00',3.86),('9650','2013-07-06','09:50:00',3.97),('9650','2013-07-06','09:55:00',4.12),('9650','2013-07-06','10:00:00',4.24),('9650','2013-07-06','10:05:00',4.01),('9650','2013-07-06','10:10:00',4.13),('9650','2013-07-06','10:15:00',4.09),('9650','2013-07-06','10:20:00',4.09),('9650','2013-07-06','10:25:00',4.41),('9650','2013-07-06','10:30:00',3.97),('9650','2013-07-06','10:35:00',5.01),('9650','2013-07-06','10:40:00',4.73),('9650','2013-07-06','10:45:00',4.94),('9650','2013-07-06','10:50:00',5.23),('9650','2013-07-06','10:55:00',5.22),('9650','2013-07-06','11:00:00',5.31),('9650','2013-07-06','11:05:00',5.4),('9650','2013-07-06','11:10:00',5.57),('9650','2013-07-06','11:15:00',5.58),('9650','2013-07-06','11:20:00',5.24),('9650','2013-07-06','11:25:00',4.78),('9650','2013-07-06','11:30:00',4.92),('9650','2013-07-06','11:35:00',4.84),('9650','2013-07-06','11:40:00',5.08),('9650','2013-07-06','11:45:00',4.22),('9650','2013-07-06','11:50:00',4.4),('9650','2013-07-06','11:55:00',3.18),('9650','2013-07-06','12:00:00',3.4),('9650','2013-07-06','12:05:00',6.01),('9650','2013-07-06','12:10:00',6.28),('9650','2013-07-06','12:15:00',6.24),('9650','2013-07-06','12:20:00',6.52),('9650','2013-07-06','12:25:00',6.21),('9650','2013-07-06','12:30:00',6.14),('9650','2013-07-06','12:35:00',6.5),('9650','2013-07-06','12:40:00',6.81),('9650','2013-07-06','12:45:00',6.91),('9650','2013-07-06','12:50:00',6.66),('9650','2013-07-06','12:55:00',7.13),('9650','2013-07-06','13:00:00',6.93),('9650','2013-07-06','13:05:00',6.92),('9650','2013-07-06','13:10:00',7.1),('9650','2013-07-06','13:15:00',7.16),('9650','2013-07-06','13:20:00',7.13),('9650','2013-07-06','13:25:00',5.44),('9650','2013-07-06','13:30:00',6.83),('9650','2013-07-06','13:35:00',7.52),('9650','2013-07-06','13:40:00',6.98),('9650','2013-07-06','13:45:00',7.66),('9650','2013-07-06','13:50:00',8.12),('9650','2013-07-06','13:55:00',6.99),('9650','2013-07-06','14:00:00',4.87),('9650','2013-07-06','14:05:00',6.36),('9650','2013-07-06','14:10:00',4.12),('9650','2013-07-06','14:15:00',2.75),('9650','2013-07-06','14:20:00',2.38),('9650','2013-07-06','14:25:00',2.13),('9650','2013-07-06','14:30:00',2.02),('9650','2013-07-06','14:35:00',1.84),('9650','2013-07-06','14:40:00',1.67),('9650','2013-07-06','14:45:00',1.51),('9650','2013-07-06','14:50:00',1.44),('9650','2013-07-06','14:55:00',1.58),('9650','2013-07-06','15:00:00',1.88),('9650','2013-07-06','15:05:00',2.13),('9650','2013-07-06','15:10:00',1.61),('9650','2013-07-06','15:15:00',1.03),('9650','2013-07-06','15:20:00',1.13),('9650','2013-07-06','16:45:00',1.06),('9650','2013-07-06','16:50:00',1.29),('9650','2013-07-06','16:55:00',1.54),('9650','2013-07-06','17:00:00',1.75),('9650','2013-07-06','17:05:00',1.86),('9650','2013-07-06','17:10:00',1.98),('9650','2013-07-06','17:15:00',2.06),('9650','2013-07-06','17:20:00',2.13),('9650','2013-07-06','17:25:00',2.14),('9650','2013-07-06','17:30:00',2.1),('9650','2013-07-06','17:35:00',1.96),('9650','2013-07-06','17:40:00',1.84),('9650','2013-07-06','17:45:00',1.78),('9650','2013-07-06','17:50:00',1.76),('9650','2013-07-06','17:55:00',1.69),('9650','2013-07-06','18:00:00',1.58),('9650','2013-07-06','18:05:00',1.54),('9650','2013-07-06','18:10:00',1.46),('9650','2013-07-06','18:15:00',1.45),('9650','2013-07-06','18:20:00',1.45),('9650','2013-07-06','18:25:00',1.41),('9650','2013-07-06','18:30:00',1.34),('9650','2013-07-06','18:35:00',1.25),('9650','2013-07-06','18:40:00',1.15),('9650','2013-07-06','18:45:00',1.08),('9650','2013-07-06','18:50:00',1.09),('9650','2013-07-06','18:55:00',1.1),('9650','2013-07-06','19:00:00',1.04),('9650','2013-07-05','08:00:00',1.05),('9650','2013-07-05','08:05:00',1.11),('9650','2013-07-05','08:10:00',1.15),('9650','2013-07-05','08:15:00',1.19),('9650','2013-07-05','08:20:00',1.22),('9650','2013-07-05','08:25:00',1.25),('9650','2013-07-05','08:30:00',1.26),('9650','2013-07-05','08:35:00',1.37),('9650','2013-07-05','08:40:00',1.97),('9650','2013-07-05','08:45:00',2.09),('9650','2013-07-05','08:50:00',2.2),('9650','2013-07-05','08:55:00',2.32),('9650','2013-07-05','09:00:00',2.44),('9650','2013-07-05','09:05:00',2.55),('9650','2013-07-05','09:10:00',2.68),('9650','2013-07-05','09:15:00',2.79),('9650','2013-07-05','09:20:00',2.94),('9650','2013-07-05','09:25:00',3.05),('9650','2013-07-05','09:30:00',3.15),('9650','2013-07-05','09:35:00',3.32),('9650','2013-07-05','09:40:00',3.49),('9650','2013-07-05','09:45:00',3.6),('9650','2013-07-05','09:50:00',3.74),('9650','2013-07-05','09:55:00',3.88),('9650','2013-07-05','10:00:00',3.99),('9650','2013-07-05','10:05:00',4.09),('9650','2013-07-05','10:10:00',4.24),('9650','2013-07-05','10:15:00',4.31),('9650','2013-07-05','10:20:00',4.38),('9650','2013-07-05','10:25:00',4.53),('9650','2013-07-05','10:30:00',4.64),('9650','2013-07-05','10:35:00',4.73),('9650','2013-07-05','10:40:00',4.83),('9650','2013-07-05','10:45:00',4.97),('9650','2013-07-05','10:50:00',5.09),('9650','2013-07-05','10:55:00',5.21),('9650','2013-07-05','11:00:00',5.31),('9650','2013-07-05','11:05:00',5.36),('9650','2013-07-05','11:10:00',5.47),('9650','2013-07-05','11:15:00',5.52),('9650','2013-07-05','11:20:00',5.61),('9650','2013-07-05','11:25:00',5.73),('9650','2013-07-05','11:30:00',5.81),('9650','2013-07-05','11:35:00',5.86),('9650','2013-07-05','11:40:00',5.92),('9650','2013-07-05','11:45:00',6.02),('9650','2013-07-05','11:50:00',6.1),('9650','2013-07-05','11:55:00',6.11),('9650','2013-07-05','12:00:00',6.12),('9650','2013-07-05','12:05:00',6.17),('9650','2013-07-05','12:10:00',6.31),('9650','2013-07-05','12:15:00',6.36),('9650','2013-07-05','12:20:00',6.5),('9650','2013-07-05','12:25:00',6.52),('9650','2013-07-05','12:30:00',6.66),('9650','2013-07-05','12:35:00',6.68),('9650','2013-07-05','12:40:00',6.66),('9650','2013-07-05','12:45:00',6.74),('9650','2013-07-05','12:50:00',6.76),('9650','2013-07-05','12:55:00',6.81),('9650','2013-07-05','13:00:00',6.93),('9650','2013-07-05','13:05:00',6.98),('9650','2013-07-05','13:10:00',7.01),('9650','2013-07-05','13:15:00',7.05),('9650','2013-07-05','13:20:00',7.11),('9650','2013-07-05','13:25:00',7.08),('9650','2013-07-05','13:30:00',7.19),('9650','2013-07-05','13:35:00',7.02),('9650','2013-07-05','13:40:00',7.23),('9650','2013-07-05','13:45:00',7.23),('9650','2013-07-05','13:50:00',7.18),('9650','2013-07-05','13:55:00',7.19),('9650','2013-07-05','14:00:00',7.22),('9650','2013-07-05','14:05:00',7.3),('9650','2013-07-05','14:10:00',7.23),('9650','2013-07-05','14:15:00',7.3),('9650','2013-07-05','14:20:00',6.65),('9650','2013-07-05','14:25:00',7.35),('9650','2013-07-05','14:30:00',7.26),('9650','2013-07-05','14:35:00',7.33),('9650','2013-07-05','14:40:00',7.3),('9650','2013-07-05','14:45:00',7.28),('9650','2013-07-05','14:50:00',6.94),('9650','2013-07-05','14:55:00',4.12),('9650','2013-07-05','15:00:00',6.72),('9650','2013-07-05','15:05:00',7.6),('9650','2013-07-05','15:10:00',7.43),('9650','2013-07-05','15:15:00',7.33),('9650','2013-07-05','15:20:00',7.29),('9650','2013-07-05','15:25:00',7.31),('9650','2013-07-05','15:30:00',7.12),('9650','2013-07-05','15:35:00',3.42),('9650','2013-07-05','15:40:00',1.43),('9650','2013-07-05','16:40:00',1.23),('9650','2013-07-05','16:45:00',1.72),('9650','2013-07-05','16:50:00',2.85),('9650','2013-07-05','16:55:00',3.5),('9650','2013-07-05','17:00:00',2.18),('9650','2013-07-05','17:05:00',1.98),('9650','2013-07-05','17:10:00',2.05),('9650','2013-07-05','17:15:00',3.59),('9650','2013-07-05','17:20:00',2.09),('9650','2013-07-05','17:25:00',2.22),('9650','2013-07-05','17:30:00',2.3),('9650','2013-07-05','17:35:00',2.14),('9650','2013-07-05','17:40:00',1.71),('9650','2013-07-05','17:45:00',1.63),('9650','2013-07-05','17:50:00',1.43),('9650','2013-07-05','17:55:00',1.36),('9650','2013-07-05','18:00:00',1.23),('9650','2013-07-05','18:05:00',1.13),('9650','2013-07-05','18:10:00',1.1),('9650','2013-07-05','18:15:00',1.05),('9650','2013-07-05','18:20:00',1.03),('9650','2013-07-05','18:25:00',1),('9650','2013-07-05','19:15:00',1.96),('9650','2013-07-05','19:20:00',1.61),('9650','2013-07-05','19:25:00',1.1),('9650','2013-07-05','19:30:00',1.11),('9650','2013-07-05','19:35:00',1.16),('9650','2013-07-05','19:40:00',1.07),('9650','2013-07-04','07:50:00',1.04),('9650','2013-07-04','07:55:00',1.09),('9650','2013-07-04','08:00:00',1.18),('9650','2013-07-04','08:05:00',1.25),('9650','2013-07-04','08:10:00',1.33),('9650','2013-07-04','08:15:00',1.41),('9650','2013-07-04','08:20:00',1.49),('9650','2013-07-04','08:25:00',1.6),('9650','2013-07-04','08:30:00',1.77),('9650','2013-07-04','08:35:00',1.91),('9650','2013-07-04','08:40:00',2.04),('9650','2013-07-04','08:45:00',2.12),('9650','2013-07-04','08:50:00',2.25),('9650','2013-07-04','08:55:00',2.36),('9650','2013-07-04','09:00:00',2.48),('9650','2013-07-04','09:05:00',2.61),('9650','2013-07-04','09:10:00',2.72),('9650','2013-07-04','09:15:00',2.83),('9650','2013-07-04','09:20:00',2.95),('9650','2013-07-04','09:25:00',3.1),('9650','2013-07-04','09:30:00',3.24),('9650','2013-07-04','09:35:00',3.4),('9650','2013-07-04','09:40:00',3.56),('9650','2013-07-04','09:45:00',3.67),('9650','2013-07-04','09:50:00',3.77),('9650','2013-07-04','09:55:00',3.89),('9650','2013-07-04','10:00:00',4.01),('9650','2013-07-04','10:05:00',4.12),('9650','2013-07-04','10:10:00',4.24),('9650','2013-07-04','10:15:00',4.33),('9650','2013-07-04','10:20:00',4.41),('9650','2013-07-04','10:25:00',4.56),('9650','2013-07-04','10:30:00',4.68),('9650','2013-07-04','10:35:00',4.77),('9650','2013-07-04','10:40:00',4.86),('9650','2013-07-04','10:45:00',4.96),('9650','2013-07-04','10:50:00',5.06),('9650','2013-07-04','10:55:00',5.17),('9650','2013-07-04','11:00:00',5.26),('9650','2013-07-04','11:05:00',5.31),('9650','2013-07-04','11:10:00',5.41),('9650','2013-07-04','11:15:00',5.49),('9650','2013-07-04','11:20:00',5.59),('9650','2013-07-04','11:25:00',5.66),('9650','2013-07-04','11:30:00',5.8),('9650','2013-07-04','11:35:00',5.87),('9650','2013-07-04','11:40:00',5.93),('9650','2013-07-04','11:45:00',5.97),('9650','2013-07-04','11:50:00',6.07),('9650','2013-07-04','11:55:00',6.18),('9650','2013-07-04','12:00:00',6.23),('9650','2013-07-04','12:05:00',6.33),('9650','2013-07-04','12:10:00',6.37),('9650','2013-07-04','12:15:00',6.42),('9650','2013-07-04','12:20:00',6.6),('9650','2013-07-04','12:25:00',4.9),('9650','2013-07-04','12:30:00',6.44),('9650','2013-07-04','12:35:00',5.9),('9650','2013-07-04','12:40:00',6.72),('9650','2013-07-04','12:45:00',6.87),('9650','2013-07-04','12:50:00',6.91),('9650','2013-07-04','12:55:00',6.95),('9650','2013-07-04','13:00:00',5.99),('9650','2013-07-04','13:05:00',4.39),('9650','2013-07-04','13:10:00',7.17),('9650','2013-07-04','13:15:00',7.18),('9650','2013-07-04','13:20:00',4.86),('9650','2013-07-04','13:25:00',6.89),('9650','2013-07-04','13:30:00',7.36),('9650','2013-07-04','13:35:00',7.31),('9650','2013-07-04','13:40:00',7.2),('9650','2013-07-04','13:45:00',7.26),('9650','2013-07-04','13:50:00',7.2),('9650','2013-07-04','13:55:00',7.28),('9650','2013-07-04','14:00:00',7.34),('9650','2013-07-04','14:05:00',6.78),('9650','2013-07-04','14:10:00',6.38),('9650','2013-07-04','14:15:00',7.31),('9650','2013-07-04','14:20:00',7.18),('9650','2013-07-04','14:25:00',7.26),('9650','2013-07-04','14:30:00',7.18),('9650','2013-07-04','14:35:00',6.14),('9650','2013-07-04','14:40:00',7.32),('9650','2013-07-04','14:45:00',4.98),('9650','2013-07-04','14:50:00',6.53),('9650','2013-07-04','14:55:00',6.85),('9650','2013-07-04','15:00:00',7.12),('9650','2013-07-04','15:05:00',5.62),('9650','2013-07-04','15:10:00',7.49),('9650','2013-07-04','15:15:00',7.1),('9650','2013-07-04','15:20:00',5.67),('9650','2013-07-04','15:25:00',5.48),('9650','2013-07-04','15:30:00',6.38),('9650','2013-07-04','15:35:00',7.27),('9650','2013-07-04','15:40:00',7.06),('9650','2013-07-04','15:45:00',7.12),('9650','2013-07-04','15:50:00',7.04),('9650','2013-07-04','15:55:00',6.84),('9650','2013-07-04','16:00:00',6.75),('9650','2013-07-04','16:05:00',6.78),('9650','2013-07-04','16:10:00',6.68),('9650','2013-07-04','16:15:00',6.62),('9650','2013-07-04','16:20:00',6.64),('9650','2013-07-04','16:25:00',6.6),('9650','2013-07-04','16:30:00',6.5),('9650','2013-07-04','16:35:00',6.41),('9650','2013-07-04','16:40:00',6.33),('9650','2013-07-04','16:45:00',6.27),('9650','2013-07-04','16:50:00',6.11),('9650','2013-07-04','16:55:00',5.99),('9650','2013-07-04','17:00:00',5.94),('9650','2013-07-04','17:05:00',5.86),('9650','2013-07-04','17:10:00',5.86),('9650','2013-07-04','17:15:00',5.84),('9650','2013-07-04','17:20:00',5.72),('9650','2013-07-04','17:25:00',5.39),('9650','2013-07-04','17:30:00',5.47),('9650','2013-07-04','17:35:00',5.27),('9650','2013-07-04','17:40:00',5.06),('9650','2013-07-04','17:45:00',4.87),('9650','2013-07-04','17:50:00',4.73),('9650','2013-07-04','17:55:00',4.69),('9650','2013-07-04','18:00:00',4.72),('9650','2013-07-04','18:05:00',4.6),('9650','2013-07-04','18:10:00',4.11),('9650','2013-07-04','18:15:00',2.32),('9650','2013-07-04','18:20:00',3.48),('9650','2013-07-04','18:25:00',1.51),('9650','2013-07-04','18:30:00',2.92),('9650','2013-07-04','18:35:00',3.48),('9650','2013-07-04','18:40:00',3.44),('9650','2013-07-04','18:45:00',3.37),('9650','2013-07-04','18:50:00',3.21),('9650','2013-07-04','18:55:00',3.03),('9650','2013-07-04','19:00:00',2.88),('9650','2013-07-04','19:05:00',2.72),('9650','2013-07-04','19:10:00',2.57),('9650','2013-07-04','19:15:00',2.43),('9650','2013-07-04','19:20:00',2.27),('9650','2013-07-04','19:25:00',2.03),('9650','2013-07-04','19:30:00',1.45),('9650','2013-07-04','19:35:00',1.27),('9650','2013-07-03','08:45:00',1.02),('9650','2013-07-03','08:50:00',1.37),('9650','2013-07-03','08:55:00',1.63),('9650','2013-07-03','09:00:00',1.55),('9650','2013-07-03','09:05:00',1.26),('9650','2013-07-03','09:10:00',1.22),('9650','2013-07-03','09:15:00',1.26),('9650','2013-07-03','09:20:00',1.23),('9650','2013-07-03','09:25:00',1.34),('9650','2013-07-03','09:30:00',1.35),('9650','2013-07-03','09:35:00',1.25),('9650','2013-07-03','09:40:00',1.03),('9650','2013-07-03','10:10:00',1.03),('9650','2013-07-03','10:15:00',1.21),('9650','2013-07-03','10:20:00',1.32),('9650','2013-07-03','10:25:00',1.35),('9650','2013-07-03','10:30:00',1.38),('9650','2013-07-03','10:35:00',1.41),('9650','2013-07-03','10:40:00',1.3),('9650','2013-07-03','10:45:00',1.13),('9650','2013-07-03','10:50:00',1.05),('9650','2013-07-03','10:55:00',1.2),('9650','2013-07-03','11:00:00',1.44),('9650','2013-07-03','11:05:00',1.66),('9650','2013-07-03','11:10:00',1.95),('9650','2013-07-03','11:15:00',1.98),('9650','2013-07-03','11:20:00',1.89),('9650','2013-07-03','11:25:00',2),('9650','2013-07-03','11:30:00',2.17),('9650','2013-07-03','11:35:00',2.51),('9650','2013-07-03','11:40:00',2.85),('9650','2013-07-03','11:45:00',3.07),('9650','2013-07-03','11:50:00',3.12),('9650','2013-07-03','11:55:00',2.89),('9650','2013-07-03','12:00:00',2.79),('9650','2013-07-03','12:05:00',3.42),('9650','2013-07-03','12:10:00',4.37),('9650','2013-07-03','12:15:00',4.75),('9650','2013-07-03','12:20:00',4.24),('9650','2013-07-03','12:25:00',5.37),('9650','2013-07-03','12:30:00',4.55),('9650','2013-07-03','12:35:00',3.8),('9650','2013-07-03','12:40:00',2.67),('9650','2013-07-03','12:45:00',2.09),('9650','2013-07-03','12:50:00',1.64),('9650','2013-07-03','12:55:00',1.55),('9650','2013-07-03','13:00:00',1.75),('9650','2013-07-03','13:05:00',2.08),('9650','2013-07-03','13:10:00',2.76),('9650','2013-07-03','13:15:00',3.21),('9650','2013-07-03','13:20:00',3.35),('9650','2013-07-03','13:25:00',4.91),('9650','2013-07-03','13:30:00',3.74),('9650','2013-07-03','13:35:00',3.91),('9650','2013-07-03','13:40:00',4.61),('9650','2013-07-03','13:45:00',6.25),('9650','2013-07-03','13:50:00',7.61),('9650','2013-07-03','13:55:00',6.59),('9650','2013-07-03','14:00:00',4.6),('9650','2013-07-03','14:05:00',4.22),('9650','2013-07-03','14:10:00',3.98),('9650','2013-07-03','14:15:00',4.02),('9650','2013-07-03','14:20:00',4.1),('9650','2013-07-03','14:25:00',3.6),('9650','2013-07-03','14:30:00',3.64),('9650','2013-07-03','14:35:00',3.69),('9650','2013-07-03','14:40:00',5.14),('9650','2013-07-03','14:45:00',5.72),('9650','2013-07-03','14:50:00',4.47),('9650','2013-07-03','14:55:00',4.03),('9650','2013-07-03','15:00:00',3.68),('9650','2013-07-03','15:05:00',4.52),('9650','2013-07-03','15:10:00',6.14),('9650','2013-07-03','15:15:00',6.66),('9650','2013-07-03','15:20:00',6.63),('9650','2013-07-03','15:25:00',4.28),('9650','2013-07-03','15:30:00',5.01),('9650','2013-07-03','15:35:00',5.24),('9650','2013-07-03','15:40:00',4.76),('9650','2013-07-03','15:45:00',6.41),('9650','2013-07-03','15:50:00',4.09),('9650','2013-07-03','15:55:00',4.28),('9650','2013-07-03','16:00:00',4.43),('9650','2013-07-03','16:05:00',4.43),('9650','2013-07-03','16:10:00',3.63),('9650','2013-07-03','16:15:00',3.38),('9650','2013-07-03','16:20:00',3.6),('9650','2013-07-03','16:25:00',4.17),('9650','2013-07-03','16:30:00',4.62),('9650','2013-07-03','16:35:00',4.59),('9650','2013-07-03','16:40:00',3.21),('9650','2013-07-03','16:45:00',3.02),('9650','2013-07-03','16:50:00',2.92),('9650','2013-07-03','16:55:00',2.82),('9650','2013-07-03','17:00:00',2.48),('9650','2013-07-03','17:05:00',2.48),('9650','2013-07-03','17:10:00',4.17),('9650','2013-07-03','17:15:00',4.97),('9650','2013-07-03','17:20:00',4.32),('9650','2013-07-03','17:25:00',6.17),('9650','2013-07-03','17:30:00',6.27),('9650','2013-07-03','17:35:00',4.49),('9650','2013-07-03','17:40:00',5.82),('9650','2013-07-03','17:45:00',5.47),('9650','2013-07-03','17:50:00',5.39),('9650','2013-07-03','17:55:00',5.03),('9650','2013-07-03','18:00:00',5.24),('9650','2013-07-03','18:05:00',5.06),('9650','2013-07-03','18:10:00',4.81),('9650','2013-07-03','18:15:00',4.73),('9650','2013-07-03','18:20:00',4.31),('9650','2013-07-03','18:25:00',3.25),('9650','2013-07-03','18:30:00',1.95),('9650','2013-07-03','18:35:00',2.18),('9650','2013-07-03','18:40:00',1.12),('9650','2013-07-02','08:00:00',1.06),('9650','2013-07-02','08:05:00',1.13),('9650','2013-07-02','08:10:00',1.17),('9650','2013-07-02','08:15:00',1.22),('9650','2013-07-02','08:20:00',1.25),('9650','2013-07-02','08:25:00',1.34),('9650','2013-07-02','08:30:00',1.77),('9650','2013-07-02','08:35:00',1.9),('9650','2013-07-02','08:40:00',2.04),('9650','2013-07-02','08:45:00',2.15),('9650','2013-07-02','08:50:00',2.27),('9650','2013-07-02','08:55:00',2.38),('9650','2013-07-02','09:00:00',2.51),('9650','2013-07-02','09:05:00',2.63),('9650','2013-07-02','09:10:00',2.74),('9650','2013-07-02','09:15:00',2.84),('9650','2013-07-02','09:20:00',2.97),('9650','2013-07-02','09:25:00',3.12),('9650','2013-07-02','09:30:00',3.24),('9650','2013-07-02','09:35:00',3.44),('9650','2013-07-02','09:40:00',3.59),('9650','2013-07-02','09:45:00',3.71),('9650','2013-07-02','09:50:00',3.8),('9650','2013-07-02','09:55:00',3.92),('9650','2013-07-02','10:00:00',4.01),('9650','2013-07-02','10:05:00',4.12),('9650','2013-07-02','10:10:00',4.19),('9650','2013-07-02','10:15:00',4.34),('9650','2013-07-02','10:20:00',4.42),('9650','2013-07-02','10:25:00',4.48),('9650','2013-07-02','10:30:00',4.55),('9650','2013-07-02','10:35:00',4.79),('9650','2013-07-02','10:40:00',4.87),('9650','2013-07-02','10:45:00',4.99),('9650','2013-07-02','10:50:00',5.08),('9650','2013-07-02','10:55:00',5.17),('9650','2013-07-02','11:00:00',5.32),('9650','2013-07-02','11:05:00',5.39),('9650','2013-07-02','11:10:00',5.52),('9650','2013-07-02','11:15:00',5.67),('9650','2013-07-02','11:20:00',5.77),('9650','2013-07-02','11:25:00',5.77),('9650','2013-07-02','11:30:00',5.8),('9650','2013-07-02','11:35:00',5.88),('9650','2013-07-02','11:40:00',5.93),('9650','2013-07-02','11:45:00',6.19),('9650','2013-07-02','11:50:00',6.15),('9650','2013-07-02','11:55:00',6.27),('9650','2013-07-02','12:00:00',6.35),('9650','2013-07-02','12:05:00',6.37),('9650','2013-07-02','12:10:00',6.4),('9650','2013-07-02','12:15:00',6.43),('9650','2013-07-02','12:20:00',6.54),('9650','2013-07-02','12:25:00',6.59),('9650','2013-07-02','12:30:00',6.74),('9650','2013-07-02','12:35:00',6.82),('9650','2013-07-02','12:40:00',6.83),('9650','2013-07-02','12:45:00',6.94),('9650','2013-07-02','12:50:00',7.03),('9650','2013-07-02','12:55:00',7.1),('9650','2013-07-02','13:00:00',7.09),('9650','2013-07-02','13:05:00',7.1),('9650','2013-07-02','13:10:00',7.13),('9650','2013-07-02','13:15:00',7.21),('9650','2013-07-02','13:20:00',7.17),('9650','2013-07-02','13:25:00',7.22),('9650','2013-07-02','13:30:00',7.25),('9650','2013-07-02','13:35:00',7.28),('9650','2013-07-02','13:40:00',7.32),('9650','2013-07-02','13:45:00',7.36),('9650','2013-07-02','13:50:00',7.36),('9650','2013-07-02','13:55:00',7.37),('9650','2013-07-02','14:00:00',7.38),('9650','2013-07-02','14:05:00',7.43),('9650','2013-07-02','14:10:00',7.42),('9650','2013-07-02','14:15:00',7.41),('9650','2013-07-02','14:20:00',7.44),('9650','2013-07-02','14:25:00',7.44),('9650','2013-07-02','14:30:00',7.46),('9650','2013-07-02','14:35:00',7.49),('9650','2013-07-02','14:40:00',7.46),('9650','2013-07-02','14:45:00',7.47),('9650','2013-07-02','14:50:00',7.48),('9650','2013-07-02','14:55:00',7.44),('9650','2013-07-02','15:00:00',7.45),('9650','2013-07-02','15:05:00',7.42),('9650','2013-07-02','15:10:00',7.44),('9650','2013-07-02','15:15:00',7.43),('9650','2013-07-02','15:20:00',7.39),('9650','2013-07-02','15:25:00',7.38),('9650','2013-07-02','15:30:00',7.36),('9650','2013-07-02','15:35:00',7.31),('9650','2013-07-02','15:40:00',7.26),('9650','2013-07-02','15:45:00',7.23),('9650','2013-07-02','15:50:00',7.15),('9650','2013-07-02','15:55:00',7.08),('9650','2013-07-02','16:00:00',7.01),('9650','2013-07-02','16:05:00',7),('9650','2013-07-02','16:10:00',6.92),('9650','2013-07-02','16:15:00',6.87),('9650','2013-07-02','16:20:00',6.84),('9650','2013-07-02','16:25:00',6.77),('9650','2013-07-02','16:30:00',6.75),('9650','2013-07-02','16:35:00',6.66),('9650','2013-07-02','16:40:00',6.59),('9650','2013-07-02','16:45:00',6.47),('9650','2013-07-02','16:50:00',6.46),('9650','2013-07-02','16:55:00',6.41),('9650','2013-07-02','17:00:00',6.3),('9650','2013-07-02','17:05:00',6.23),('9650','2013-07-02','17:10:00',6.13),('9650','2013-07-02','17:15:00',6.02),('9650','2013-07-02','17:20:00',5.92),('9650','2013-07-02','17:25:00',5.82),('9650','2013-07-02','17:30:00',5.74),('9650','2013-07-02','17:35:00',5.67),('9650','2013-07-02','17:40:00',5.57),('9650','2013-07-02','17:45:00',5.48),('9650','2013-07-02','17:50:00',5.34),('9650','2013-07-02','17:55:00',5.24),('9650','2013-07-02','18:00:00',5.04),('9650','2013-07-02','18:05:00',4.93),('9650','2013-07-02','18:10:00',4.8),('9650','2013-07-02','18:15:00',4.78),('9650','2013-07-02','18:20:00',4.62),('9650','2013-07-02','18:25:00',4.51),('9650','2013-07-02','18:30:00',4.41),('9650','2013-07-02','18:35:00',4.28),('9650','2013-07-02','18:40:00',4.11),('9650','2013-07-02','18:45:00',3.99),('9650','2013-07-02','18:50:00',3.84),('9650','2013-07-02','18:55:00',3.65),('9650','2013-07-02','19:00:00',3.49),('9650','2013-07-02','19:05:00',3.3),('9650','2013-07-02','19:10:00',3.16),('9650','2013-07-02','19:15:00',3),('9650','2013-07-02','19:20:00',2.82),('9650','2013-07-02','19:25:00',2.64),('9650','2013-07-02','19:30:00',2.45),('9650','2013-07-02','19:35:00',2.28),('9650','2013-07-02','19:40:00',2.1),('9650','2013-07-02','19:45:00',1.94),('9650','2013-07-02','19:50:00',1.74),('9650','2013-07-02','19:55:00',1.59),('9650','2013-07-02','20:00:00',1.41),('9650','2013-07-02','20:05:00',1.21),('9650','2013-07-01','07:55:00',1.01),('9650','2013-07-01','08:00:00',1.1),('9650','2013-07-01','08:05:00',1.18),('9650','2013-07-01','08:10:00',1.27),('9650','2013-07-01','08:15:00',1.37),('9650','2013-07-01','08:20:00',1.48),('9650','2013-07-01','08:25:00',1.62),('9650','2013-07-01','08:30:00',1.81),('9650','2013-07-01','08:35:00',1.93),('9650','2013-07-01','08:40:00',2.04),('9650','2013-07-01','08:45:00',2.16),('9650','2013-07-01','08:50:00',2.29),('9650','2013-07-01','08:55:00',2.41),('9650','2013-07-01','09:00:00',2.53),('9650','2013-07-01','09:05:00',2.62),('9650','2013-07-01','09:10:00',2.75),('9650','2013-07-01','09:15:00',2.89),('9650','2013-07-01','09:20:00',3),('9650','2013-07-01','09:25:00',3.13),('9650','2013-07-01','09:30:00',3.25),('9650','2013-07-01','09:35:00',3.44),('9650','2013-07-01','09:40:00',3.59),('9650','2013-07-01','09:45:00',3.71),('9650','2013-07-01','09:50:00',3.83),('9650','2013-07-01','09:55:00',3.94),('9650','2013-07-01','10:00:00',4.06),('9650','2013-07-01','10:05:00',4.15),('9650','2013-07-01','10:10:00',4.27),('9650','2013-07-01','10:15:00',4.34),('9650','2013-07-01','10:20:00',4.43),('9650','2013-07-01','10:25:00',4.57),('9650','2013-07-01','10:30:00',4.65),('9650','2013-07-01','10:35:00',4.73),('9650','2013-07-01','10:40:00',4.84),('9650','2013-07-01','10:45:00',4.97),('9650','2013-07-01','10:50:00',5.08),('9650','2013-07-01','10:55:00',5.15),('9650','2013-07-01','11:00:00',5.21),('9650','2013-07-01','11:05:00',5.3),('9650','2013-07-01','11:10:00',5.37),('9650','2013-07-01','11:15:00',5.44),('9650','2013-07-01','11:20:00',5.56),('9650','2013-07-01','11:25:00',5.67),('9650','2013-07-01','11:30:00',5.7),('9650','2013-07-01','11:35:00',5.75),('9650','2013-07-01','11:40:00',5.82),('9650','2013-07-01','11:45:00',5.89),('9650','2013-07-01','11:50:00',5.99),('9650','2013-07-01','11:55:00',6.03),('9650','2013-07-01','12:00:00',5.99),('9650','2013-07-01','12:05:00',6.29),('9650','2013-07-01','12:10:00',6.33),('9650','2013-07-01','12:15:00',6.41),('9650','2013-07-01','12:20:00',6.32),('9650','2013-07-01','12:25:00',6.38),('9650','2013-07-01','12:30:00',6.39),('9650','2013-07-01','12:35:00',6.77),('9650','2013-07-01','12:40:00',7.01),('9650','2013-07-01','12:45:00',7.16),('9650','2013-07-01','12:50:00',7.4),('9650','2013-07-01','12:55:00',4.91),('9650','2013-07-01','13:00:00',4.52),('9650','2013-07-01','13:05:00',7.39),('9650','2013-07-01','13:10:00',6.49),('9650','2013-07-01','13:15:00',6.31),('9650','2013-07-01','13:20:00',7.09),('9650','2013-07-01','13:25:00',6.99),('9650','2013-07-01','13:30:00',7.05),('9650','2013-07-01','13:35:00',7.15),('9650','2013-07-01','13:40:00',6.99),('9650','2013-07-01','13:45:00',6.97),('9650','2013-07-01','13:50:00',6.96),('9650','2013-07-01','13:55:00',7.08),('9650','2013-07-01','14:00:00',7.1),('9650','2013-07-01','14:05:00',7.07),('9650','2013-07-01','14:10:00',7.15),('9650','2013-07-01','14:15:00',7.28),('9650','2013-07-01','14:20:00',7.27),('9650','2013-07-01','14:25:00',7.26),('9650','2013-07-01','14:30:00',7.25),('9650','2013-07-01','14:35:00',7.27),('9650','2013-07-01','14:40:00',7.28),('9650','2013-07-01','14:45:00',7.29),('9650','2013-07-01','14:50:00',7.17),('9650','2013-07-01','14:55:00',7.18),('9650','2013-07-01','15:00:00',7.24),('9650','2013-07-01','15:05:00',7.25),('9650','2013-07-01','15:10:00',7.22),('9650','2013-07-01','15:15:00',7.2),('9650','2013-07-01','15:20:00',7.19),('9650','2013-07-01','15:25:00',7.16),('9650','2013-07-01','15:30:00',7.18),('9650','2013-07-01','15:35:00',7.14),('9650','2013-07-01','15:40:00',7.13),('9650','2013-07-01','15:45:00',7.05),('9650','2013-07-01','15:50:00',7.01),('9650','2013-07-01','15:55:00',6.93),('9650','2013-07-01','16:00:00',6.86),('9650','2013-07-01','16:05:00',6.85),('9650','2013-07-01','16:10:00',6.79),('9650','2013-07-01','16:15:00',6.72),('9650','2013-07-01','16:20:00',6.64),('9650','2013-07-01','16:25:00',6.6),('9650','2013-07-01','16:30:00',6.51),('9650','2013-07-01','16:35:00',6.45),('9650','2013-07-01','16:40:00',6.38),('9650','2013-07-01','16:45:00',6.32),('9650','2013-07-01','16:50:00',6.21),('9650','2013-07-01','16:55:00',6.22),('9650','2013-07-01','17:00:00',6.14),('9650','2013-07-01','17:05:00',6.05),('9650','2013-07-01','17:10:00',5.92),('9650','2013-07-01','17:15:00',5.82),('9650','2013-07-01','17:20:00',5.72),('9650','2013-07-01','17:25:00',5.64),('9650','2013-07-01','17:30:00',5.55),('9650','2013-07-01','17:35:00',5.42),('9650','2013-07-01','17:40:00',5.27),('9650','2013-07-01','17:45:00',5.12),('9650','2013-07-01','17:50:00',4.99),('9650','2013-07-01','17:55:00',4.92),('9650','2013-07-01','18:00:00',4.76),('9650','2013-07-01','18:05:00',4.65),('9650','2013-07-01','18:10:00',4.54),('9650','2013-07-01','18:15:00',4.45),('9650','2013-07-01','18:20:00',4.34),('9650','2013-07-01','18:25:00',4.17),('9650','2013-07-01','18:30:00',4.03),('9650','2013-07-01','18:35:00',3.89),('9650','2013-07-01','18:40:00',3.75),('9650','2013-07-01','18:45:00',3.61),('9650','2013-07-01','18:50:00',3.49),('9650','2013-07-01','18:55:00',3.33),('9650','2013-07-01','19:00:00',3.2),('9650','2013-07-01','19:05:00',3.02),('9650','2013-07-01','19:10:00',2.87),('9650','2013-07-01','19:15:00',2.71),('9650','2013-07-01','19:20:00',2.54),('9650','2013-07-01','19:25:00',2.35),('9650','2013-07-01','19:30:00',2.13),('9650','2013-07-01','19:35:00',1.96),('9650','2013-07-01','19:40:00',1.78),('9650','2013-07-01','19:45:00',1.57),('9650','2013-07-01','19:50:00',1.37),('9650','2013-07-01','19:55:00',1.19),('9650','2013-07-01','20:00:00',1.01),('9650','2013-06-30','07:55:00',1.05),('9650','2013-06-30','08:00:00',1.14),('9650','2013-06-30','08:05:00',1.22),('9650','2013-06-30','08:10:00',1.33),('9650','2013-06-30','08:15:00',1.43),('9650','2013-06-30','08:20:00',1.54),('9650','2013-06-30','08:25:00',1.69),('9650','2013-06-30','08:30:00',1.86),('9650','2013-06-30','08:35:00',1.99),('9650','2013-06-30','08:40:00',2.12),('9650','2013-06-30','08:45:00',2.23),('9650','2013-06-30','08:50:00',2.36),('9650','2013-06-30','08:55:00',2.47),('9650','2013-06-30','09:00:00',2.58),('9650','2013-06-30','09:05:00',2.7),('9650','2013-06-30','09:10:00',2.83),('9650','2013-06-30','09:15:00',2.97),('9650','2013-06-30','09:20:00',3.11),('9650','2013-06-30','09:25:00',3.25),('9650','2013-06-30','09:30:00',3.39),('9650','2013-06-30','09:35:00',3.58),('9650','2013-06-30','09:40:00',3.73),('9650','2013-06-30','09:45:00',3.85),('9650','2013-06-30','09:50:00',3.96),('9650','2013-06-30','09:55:00',4.06),('9650','2013-06-30','10:00:00',4.13),('9650','2013-06-30','10:05:00',4.22),('9650','2013-06-30','10:10:00',4.37),('9650','2013-06-30','10:15:00',4.44),('9650','2013-06-30','10:20:00',4.55),('9650','2013-06-30','10:25:00',4.71),('9650','2013-06-30','10:30:00',4.85),('9650','2013-06-30','10:35:00',4.93),('9650','2013-06-30','10:40:00',5.08),('9650','2013-06-30','10:45:00',5.24),('9650','2013-06-30','10:50:00',5.34),('9650','2013-06-30','10:55:00',5.44),('9650','2013-06-30','11:00:00',5.5),('9650','2013-06-30','11:05:00',5.54),('9650','2013-06-30','11:10:00',5.69),('9650','2013-06-30','11:15:00',5.84),('9650','2013-06-30','11:20:00',5.95),('9650','2013-06-30','11:25:00',6.03),('9650','2013-06-30','11:30:00',6.01),('9650','2013-06-30','11:35:00',6.11),('9650','2013-06-30','11:40:00',6.22),('9650','2013-06-30','11:45:00',6.31),('9650','2013-06-30','11:50:00',6.39),('9650','2013-06-30','11:55:00',6.41),('9650','2013-06-30','12:00:00',6.48),('9650','2013-06-30','12:05:00',6.5),('9650','2013-06-30','12:10:00',6.53),('9650','2013-06-30','12:15:00',6.62),('9650','2013-06-30','12:20:00',6.72),('9650','2013-06-30','12:25:00',6.7),('9650','2013-06-30','12:30:00',6.72),('9650','2013-06-30','12:35:00',6.79),('9650','2013-06-30','12:40:00',6.82),('9650','2013-06-30','12:45:00',6.84),('9650','2013-06-30','12:50:00',6.93),('9650','2013-06-30','12:55:00',6.99),('9650','2013-06-30','13:00:00',6.88),('9650','2013-06-30','13:05:00',7.1),('9650','2013-06-30','13:10:00',7.09),('9650','2013-06-30','13:15:00',7.11),('9650','2013-06-30','13:20:00',7.17),('9650','2013-06-30','13:25:00',7.2),('9650','2013-06-30','13:30:00',7.26),('9650','2013-06-30','13:35:00',7.37),('9650','2013-06-30','13:40:00',7.35),('9650','2013-06-30','13:45:00',7.28),('9650','2013-06-30','13:50:00',7.27),('9650','2013-06-30','13:55:00',7.3),('9650','2013-06-30','14:00:00',7.28),('9650','2013-06-30','14:05:00',7.4),('9650','2013-06-30','14:10:00',7.44),('9650','2013-06-30','14:15:00',7.39),('9650','2013-06-30','14:20:00',7.38),('9650','2013-06-30','14:25:00',7.3),('9650','2013-06-30','14:30:00',7.33),('9650','2013-06-30','14:35:00',7.3),('9650','2013-06-30','14:40:00',7.29),('9650','2013-06-30','14:45:00',7.3),('9650','2013-06-30','14:50:00',7.27),('9650','2013-06-30','14:55:00',7.27),('9650','2013-06-30','15:00:00',7.23),('9650','2013-06-30','15:05:00',7.2),('9650','2013-06-30','15:10:00',7.23),('9650','2013-06-30','15:15:00',7.22),('9650','2013-06-30','15:20:00',7.19),('9650','2013-06-30','15:25:00',7.14),('9650','2013-06-30','15:30:00',7.1),('9650','2013-06-30','15:35:00',7.04),('9650','2013-06-30','15:40:00',6.95),('9650','2013-06-30','15:45:00',7.04),('9650','2013-06-30','15:50:00',6.94),('9650','2013-06-30','15:55:00',6.82),('9650','2013-06-30','16:00:00',6.8),('9650','2013-06-30','16:05:00',6.79),('9650','2013-06-30','16:10:00',6.71),('9650','2013-06-30','16:15:00',6.63),('9650','2013-06-30','16:20:00',6.51),('9650','2013-06-30','16:25:00',6.45),('9650','2013-06-30','16:30:00',6.36),('9650','2013-06-30','16:35:00',6.32),('9650','2013-06-30','16:40:00',6.3),('9650','2013-06-30','16:45:00',6.26),('9650','2013-06-30','16:50:00',6.16),('9650','2013-06-30','16:55:00',6.15),('9650','2013-06-30','17:00:00',6.07),('9650','2013-06-30','17:05:00',5.98),('9650','2013-06-30','17:10:00',5.94),('9650','2013-06-30','17:15:00',5.8),('9650','2013-06-30','17:20:00',5.66),('9650','2013-06-30','17:25:00',5.54),('9650','2013-06-30','17:30:00',5.42),('9650','2013-06-30','17:35:00',5.31),('9650','2013-06-30','17:40:00',5.22),('9650','2013-06-30','17:45:00',5.13),('9650','2013-06-30','17:50:00',5.07),('9650','2013-06-30','17:55:00',4.94),('9650','2013-06-30','18:00:00',4.41),('9650','2013-06-30','18:05:00',4.59),('9650','2013-06-30','18:10:00',4.47),('9650','2013-06-30','18:15:00',3.67),('9650','2013-06-30','18:20:00',3.89),('9650','2013-06-30','18:25:00',4.29),('9650','2013-06-30','18:30:00',4.13),('9650','2013-06-30','18:35:00',3.9),('9650','2013-06-30','18:40:00',3.56),('9650','2013-06-30','18:45:00',3.48),('9650','2013-06-30','18:50:00',3.28),('9650','2013-06-30','18:55:00',2.96),('9650','2013-06-30','19:00:00',2.86),('9650','2013-06-30','19:05:00',2.76),('9650','2013-06-30','19:10:00',2.61),('9650','2013-06-30','19:15:00',1.94),('9650','2013-06-30','19:20:00',2.31),('9650','2013-06-30','19:25:00',2.06),('9650','2013-06-30','19:30:00',1.76),('9650','2013-06-30','19:35:00',1.5),('9650','2013-06-30','19:40:00',1.37),('9650','2013-06-30','19:45:00',1.3),('9650','2013-06-30','19:50:00',1.28),('9650','2013-06-30','19:55:00',1.14),('9650','2014-04-04','08:35:00',1.05),('9650','2014-04-04','08:40:00',1.16),('9650','2014-04-04','08:45:00',1.08),('9650','2014-04-04','09:05:00',1.16),('9650','2014-04-04','09:10:00',1.26),('9650','2014-04-04','09:15:00',1.7),('9650','2014-04-04','09:20:00',2.29),('9650','2014-04-04','09:25:00',2.68),('9650','2014-04-04','09:30:00',3.72),('9650','2014-04-04','09:35:00',3.7),('9650','2014-04-04','09:40:00',3.75),('9650','2014-04-04','09:45:00',3.41),('9650','2014-04-04','09:50:00',2.22),('9650','2014-04-04','09:55:00',2.28),('9650','2014-04-04','10:00:00',2.45),('9650','2014-04-04','10:05:00',2.62),('9650','2014-04-04','10:10:00',3.13),('9650','2014-04-04','10:15:00',2.4),('9650','2014-04-04','10:20:00',2.95),('9650','2014-04-04','10:25:00',3.06),('9650','2014-04-04','10:30:00',2.85),('9650','2014-04-04','10:35:00',3.06),('9650','2014-04-04','10:40:00',3.5),('9650','2014-04-04','10:45:00',3.68),('9650','2014-04-04','10:50:00',3.03),('9650','2014-04-04','10:55:00',3.41),('9650','2014-04-04','11:00:00',3.98),('9650','2014-04-04','11:05:00',4.19),('9650','2014-04-04','11:10:00',4.82),('9650','2014-04-04','11:15:00',5.02),('9650','2014-04-04','11:20:00',5.42),('9650','2014-04-04','11:25:00',4.69),('9650','2014-04-04','11:30:00',3.24),('9650','2014-04-04','11:35:00',3.1),('9650','2014-04-04','11:40:00',4.17),('9650','2014-04-04','11:45:00',5.38),('9650','2014-04-04','11:50:00',5.67),('9650','2014-04-04','11:55:00',5.62),('9650','2014-04-04','12:00:00',5.34),('9650','2014-04-04','12:05:00',4.46),('9650','2014-04-04','12:10:00',4.32),('9650','2014-04-04','12:15:00',5.03),('9650','2014-04-04','12:20:00',4.8),('9650','2014-04-04','12:25:00',5.12),('9650','2014-04-04','12:30:00',4.2),('9650','2014-04-04','12:35:00',3.36),('9650','2014-04-04','12:40:00',5.11),('9650','2014-04-04','12:45:00',6.79),('9650','2014-04-04','12:50:00',6.79),('9650','2014-04-04','12:55:00',6.77),('9650','2014-04-04','13:00:00',5.58),('9650','2014-04-04','13:05:00',4.92),('9650','2014-04-04','13:10:00',4.75),('9650','2014-04-04','13:15:00',2.77),('9650','2014-04-04','13:20:00',5.16),('9650','2014-04-04','13:25:00',6.96),('9650','2014-04-04','13:30:00',6.63),('9650','2014-04-04','13:35:00',6.78),('9650','2014-04-04','13:40:00',5.33),('9650','2014-04-04','13:45:00',6.44),('9650','2014-04-04','13:50:00',7.12),('9650','2014-04-04','13:55:00',5.95),('9650','2014-04-04','14:00:00',6.26),('9650','2014-04-04','14:05:00',8.17),('9650','2014-04-04','14:10:00',4.96),('9650','2014-04-04','14:15:00',1.18),('9650','2014-04-04','14:20:00',1.43),('9650','2014-04-04','14:25:00',2.06),('9650','2014-04-04','14:30:00',2.92),('9650','2014-04-04','14:35:00',1.71),('9650','2014-04-04','14:40:00',1.32),('9650','2014-04-04','14:45:00',1.28),('9650','2014-04-04','14:50:00',1.77),('9650','2014-04-04','14:55:00',6.79),('9650','2014-04-04','15:00:00',7.18),('9650','2014-04-04','15:05:00',5.59),('9650','2014-04-04','15:10:00',5),('9650','2014-04-04','15:15:00',3.27),('9650','2014-04-04','15:20:00',6.79),('9650','2014-04-04','15:25:00',4.53),('9650','2014-04-04','15:30:00',2.65),('9650','2014-04-04','15:35:00',2.69),('9650','2014-04-04','15:40:00',3.36),('9650','2014-04-04','15:45:00',3.23),('9650','2014-04-04','15:50:00',4.3),('9650','2014-04-04','15:55:00',2.25),('9650','2014-04-04','16:00:00',2.24),('9650','2014-04-04','16:05:00',2.33),('9650','2014-04-04','16:10:00',2.19),('9650','2014-04-04','16:15:00',3.45),('9650','2014-04-04','16:20:00',6.83),('9650','2014-04-04','16:25:00',4.76),('9650','2014-04-04','16:30:00',3.79),('9650','2014-04-04','16:35:00',4.63),('9650','2014-04-04','16:40:00',2.83),('9650','2014-04-04','16:45:00',4.36),('9650','2014-04-04','16:50:00',2.87),('9650','2014-04-04','16:55:00',4.77),('9650','2014-04-04','17:00:00',3.1),('9650','2014-04-04','17:05:00',4.23),('9650','2014-04-04','17:10:00',3.62),('9650','2014-04-04','17:15:00',2.28),('9650','2014-04-04','17:20:00',2.6),('9650','2014-04-04','17:25:00',2.58),('9650','2014-04-04','17:30:00',2.69),('9650','2014-04-04','17:35:00',2.26),('9650','2014-04-04','17:40:00',2.12),('9650','2014-04-04','17:45:00',2.04),('9650','2014-04-04','17:50:00',2.73),('9650','2014-04-04','17:55:00',2.83),('9650','2014-04-04','18:00:00',2.67),('9650','2014-04-04','18:05:00',2.51),('9650','2014-04-04','18:10:00',2.48),('9650','2014-04-04','18:15:00',2.71),('9650','2014-04-04','18:20:00',2.6),('9650','2014-04-04','18:25:00',1.83),('9650','2014-04-04','18:30:00',1.06),('9650','2013-06-29','07:50:00',1.01),('9650','2013-06-29','07:55:00',1.09),('9650','2013-06-29','08:00:00',1.16),('9650','2013-06-29','08:05:00',1.24),('9650','2013-06-29','08:10:00',1.34),('9650','2013-06-29','08:15:00',1.44),('9650','2013-06-29','08:20:00',1.57),('9650','2013-06-29','08:25:00',1.75),('9650','2013-06-29','08:30:00',1.92),('9650','2013-06-29','08:35:00',2.05),('9650','2013-06-29','08:40:00',2.18),('9650','2013-06-29','08:45:00',2.29),('9650','2013-06-29','08:50:00',2.44),('9650','2013-06-29','08:55:00',2.55),('9650','2013-06-29','09:00:00',2.66),('9650','2013-06-29','09:05:00',2.8),('9650','2013-06-29','09:10:00',2.92),('9650','2013-06-29','09:15:00',3.03),('9650','2013-06-29','09:20:00',3.17),('9650','2013-06-29','09:25:00',3.3),('9650','2013-06-29','09:30:00',3.45),('9650','2013-06-29','09:35:00',3.65),('9650','2013-06-29','09:40:00',3.83),('9650','2013-06-29','09:45:00',3.94),('9650','2013-06-29','09:50:00',4.08),('9650','2013-06-29','09:55:00',4.18),('9650','2013-06-29','10:00:00',4.28),('9650','2013-06-29','10:05:00',4.39),('9650','2013-06-29','10:10:00',4.55),('9650','2013-06-29','10:15:00',4.6),('9650','2013-06-29','10:20:00',4.69),('9650','2013-06-29','10:25:00',4.87),('9650','2013-06-29','10:30:00',4.98),('9650','2013-06-29','10:35:00',5.1),('9650','2013-06-29','10:40:00',5.2),('9650','2013-06-29','10:45:00',5.33),('9650','2013-06-29','10:50:00',5.44),('9650','2013-06-29','10:55:00',5.51),('9650','2013-06-29','11:00:00',5.59),('9650','2013-06-29','11:05:00',5.68),('9650','2013-06-29','11:10:00',5.76),('9650','2013-06-29','11:15:00',5.84),('9650','2013-06-29','11:20:00',5.9),('9650','2013-06-29','11:25:00',6.02),('9650','2013-06-29','11:30:00',6.09),('9650','2013-06-29','11:35:00',6.13),('9650','2013-06-29','11:40:00',6.23),('9650','2013-06-29','11:45:00',6.32),('9650','2013-06-29','11:50:00',6.36),('9650','2013-06-29','11:55:00',6.42),('9650','2013-06-29','12:00:00',6.49),('9650','2013-06-29','12:05:00',6.55),('9650','2013-06-29','12:10:00',6.64),('9650','2013-06-29','12:15:00',6.75),('9650','2013-06-29','12:20:00',6.78),('9650','2013-06-29','12:25:00',6.81),('9650','2013-06-29','12:30:00',6.89),('9650','2013-06-29','12:35:00',6.98),('9650','2013-06-29','12:40:00',7.04),('9650','2013-06-29','12:45:00',7.03),('9650','2013-06-29','12:50:00',7.16),('9650','2013-06-29','12:55:00',7.27),('9650','2013-06-29','13:00:00',7.28),('9650','2013-06-29','13:05:00',7.24),('9650','2013-06-29','13:10:00',7.26),('9650','2013-06-29','13:15:00',7.41),('9650','2013-06-29','13:20:00',7.41),('9650','2013-06-29','13:25:00',7.48),('9650','2013-06-29','13:30:00',7.49),('9650','2013-06-29','13:35:00',7.52),('9650','2013-06-29','13:40:00',6.41),('9650','2013-06-29','13:45:00',7.67),('9650','2013-06-29','13:50:00',7.8),('9650','2013-06-29','13:55:00',7.4),('9650','2013-06-29','14:00:00',7.43),('9650','2013-06-29','14:05:00',7.77),('9650','2013-06-29','14:10:00',7.7),('9650','2013-06-29','14:15:00',7.54),('9650','2013-06-29','14:20:00',7.61),('9650','2013-06-29','14:25:00',7.6),('9650','2013-06-29','14:30:00',7.5),('9650','2013-06-29','14:35:00',7.44),('9650','2013-06-29','14:40:00',7.49),('9650','2013-06-29','14:45:00',7.58),('9650','2013-06-29','14:50:00',7.48),('9650','2013-06-29','14:55:00',7.48),('9650','2013-06-29','15:00:00',7.44),('9650','2013-06-29','15:05:00',7.37),('9650','2013-06-29','15:10:00',7.4),('9650','2013-06-29','15:15:00',7.39),('9650','2013-06-29','15:20:00',7.5),('9650','2013-06-29','15:25:00',7.43),('9650','2013-06-29','15:30:00',7.45),('9650','2013-06-29','15:35:00',7.47),('9650','2013-06-29','15:40:00',7.46),('9650','2013-06-29','15:45:00',7.4),('9650','2013-06-29','15:50:00',7.34),('9650','2013-06-29','15:55:00',7.22),('9650','2013-06-29','16:00:00',7.17),('9650','2013-06-29','16:05:00',7.08),('9650','2013-06-29','16:10:00',7.13),('9650','2013-06-29','16:15:00',7.05),('9650','2013-06-29','16:20:00',7.14),('9650','2013-06-29','16:25:00',7.18),('9650','2013-06-29','16:30:00',6.76),('9650','2013-06-29','16:35:00',6.82),('9650','2013-06-29','16:40:00',6.49),('9650','2013-06-29','16:45:00',6.51),('9650','2013-06-29','16:50:00',6.45),('9650','2013-06-29','16:55:00',6.33),('9650','2013-06-29','17:00:00',6.16),('9650','2013-06-29','17:05:00',6.04),('9650','2013-06-29','17:10:00',6.03),('9650','2013-06-29','17:15:00',5.88),('9650','2013-06-29','17:20:00',5.77),('9650','2013-06-29','17:25:00',5.64),('9650','2013-06-29','17:30:00',5.49),('9650','2013-06-29','17:35:00',5.37),('9650','2013-06-29','17:40:00',5.32),('9650','2013-06-29','17:45:00',5.14),('9650','2013-06-29','17:50:00',5.04),('9650','2013-06-29','17:55:00',4.89),('9650','2013-06-29','18:00:00',4.69),('9650','2013-06-29','18:05:00',4.5),('9650','2013-06-29','18:10:00',4.5),('9650','2013-06-29','18:15:00',4.4),('9650','2013-06-29','18:20:00',4.27),('9650','2013-06-29','18:25:00',4.13),('9650','2013-06-29','18:30:00',3.94),('9650','2013-06-29','18:35:00',3.8),('9650','2013-06-29','18:40:00',3.7),('9650','2013-06-29','18:45:00',3.52),('9650','2013-06-29','18:50:00',3.39),('9650','2013-06-29','18:55:00',3.3),('9650','2013-06-29','19:00:00',3.14),('9650','2013-06-29','19:05:00',2.97),('9650','2013-06-29','19:10:00',2.82),('9650','2013-06-29','19:15:00',2.61),('9650','2013-06-29','19:20:00',2.4),('9650','2013-06-29','19:25:00',2.19),('9650','2013-06-29','19:30:00',2.02),('9650','2013-06-29','19:35:00',1.82),('9650','2013-06-29','19:40:00',1.63),('9650','2013-06-29','19:45:00',1.43),('9650','2013-06-29','19:50:00',1.28),('9650','2013-06-29','19:55:00',1.1),('9650','2013-06-28','07:30:00',1.29),('9650','2013-06-28','07:35:00',1.53),('9650','2013-06-28','07:40:00',1.58),('9650','2013-06-28','07:45:00',1.57),('9650','2013-06-28','07:50:00',1.7),('9650','2013-06-28','07:55:00',1.95),('9650','2013-06-28','08:00:00',2.21),('9650','2013-06-28','08:05:00',2.37),('9650','2013-06-28','08:10:00',2.33),('9650','2013-06-28','08:15:00',2.01),('9650','2013-06-28','08:20:00',1.49),('9650','2013-06-28','08:25:00',1.95),('9650','2013-06-28','08:30:00',2.04),('9650','2013-06-28','08:35:00',2.15),('9650','2013-06-28','08:40:00',1.36),('9650','2013-06-28','08:45:00',2.11),('9650','2013-06-28','08:50:00',2.41),('9650','2013-06-28','08:55:00',2.53),('9650','2013-06-28','09:00:00',2.63),('9650','2013-06-28','09:05:00',2.75),('9650','2013-06-28','09:10:00',2.89),('9650','2013-06-28','09:15:00',3.01),('9650','2013-06-28','09:20:00',3.15),('9650','2013-06-28','09:25:00',3.24),('9650','2013-06-28','09:30:00',3.36),('9650','2013-06-28','09:35:00',3.56),('9650','2013-06-28','09:40:00',3.75),('9650','2013-06-28','09:45:00',3.89),('9650','2013-06-28','09:50:00',4),('9650','2013-06-28','09:55:00',4.12),('9650','2013-06-28','10:00:00',4.22),('9650','2013-06-28','10:05:00',4.32),('9650','2013-06-28','10:10:00',4.49),('9650','2013-06-28','10:15:00',4.56),('9650','2013-06-28','10:20:00',4.62),('9650','2013-06-28','10:25:00',4.81),('9650','2013-06-28','10:30:00',4.88),('9650','2013-06-28','10:35:00',5.03),('9650','2013-06-28','10:40:00',5.13),('9650','2013-06-28','10:45:00',5.14),('9650','2013-06-28','10:50:00',5.23),('9650','2013-06-28','10:55:00',5.64),('9650','2013-06-28','11:00:00',5.75),('9650','2013-06-28','11:05:00',5.88),('9650','2013-06-28','11:10:00',6.08),('9650','2013-06-28','11:15:00',6.31),('9650','2013-06-28','11:20:00',6.22),('9650','2013-06-28','11:25:00',6.89),('9650','2013-06-28','11:30:00',5.92),('9650','2013-06-28','11:35:00',4.29),('9650','2013-06-28','11:40:00',6.81),('9650','2013-06-28','11:45:00',6.65),('9650','2013-06-28','11:50:00',6.85),('9650','2013-06-28','11:55:00',6.33),('9650','2013-06-28','12:00:00',4.98),('9650','2013-06-28','12:05:00',6.59),('9650','2013-06-28','12:10:00',7.15),('9650','2013-06-28','12:15:00',7.04),('9650','2013-06-28','12:20:00',3.16),('9650','2013-06-28','12:25:00',6.85),('9650','2013-06-28','12:30:00',7.59),('9650','2013-06-28','12:35:00',7.28),('9650','2013-06-28','12:40:00',6.65),('9650','2013-06-28','12:45:00',8.17),('9650','2013-06-28','12:50:00',3.68),('9650','2013-06-28','12:55:00',7.66),('9650','2013-06-28','13:00:00',5.35),('9650','2013-06-28','13:05:00',6.79),('9650','2013-06-28','13:10:00',7.1),('9650','2013-06-28','13:15:00',6.67),('9650','2013-06-28','13:20:00',3.04),('9650','2013-06-28','13:25:00',5.81),('9650','2013-06-28','13:30:00',2.16),('9650','2013-06-28','13:35:00',1.61),('9650','2013-06-28','13:40:00',1.77),('9650','2013-06-28','13:45:00',2.92),('9650','2013-06-28','13:50:00',4.05),('9650','2013-06-28','13:55:00',5.79),('9650','2013-06-28','14:00:00',7.69),('9650','2013-06-28','14:05:00',8.51),('9650','2013-06-28','14:10:00',8.63),('9650','2013-06-28','14:15:00',8.63),('9650','2013-06-28','14:20:00',7.86),('9650','2013-06-28','14:25:00',8.61),('9650','2013-06-28','14:30:00',8.39),('9650','2013-06-28','14:35:00',8.29),('9650','2013-06-28','14:40:00',8.3),('9650','2013-06-28','14:45:00',8.46),('9650','2013-06-28','14:50:00',8.91),('9650','2013-06-28','14:55:00',4.21),('9650','2013-06-28','15:00:00',5.58),('9650','2013-06-28','15:05:00',9.16),('9650','2013-06-28','15:10:00',4.34),('9650','2013-06-28','15:15:00',3.63),('9650','2013-06-28','15:20:00',2.55),('9650','2013-06-28','15:25:00',1.87),('9650','2013-06-28','15:30:00',1.19),('9650','2013-06-28','15:35:00',1.1),('9650','2013-06-28','16:25:00',1.13),('9650','2013-06-28','16:30:00',1.28),('9650','2013-06-28','16:35:00',1.84),('9650','2013-06-28','16:40:00',2.51),('9650','2013-06-28','16:45:00',3.08),('9650','2013-06-28','16:50:00',5.4),('9650','2013-06-28','16:55:00',3.11),('9650','2013-06-28','17:00:00',2.48),('9650','2013-06-28','17:05:00',3.27),('9650','2013-06-28','17:10:00',2.49),('9650','2013-06-28','17:15:00',2.31),('9650','2013-06-28','17:20:00',2.75),('9650','2013-06-28','17:25:00',3.13),('9650','2013-06-28','17:30:00',5.84),('9650','2013-06-28','17:35:00',4.8),('9650','2013-06-28','17:40:00',1.96),('9650','2013-06-28','17:45:00',5.14),('9650','2013-06-28','17:50:00',5.35),('9650','2013-06-28','17:55:00',5.27),('9650','2013-06-28','18:00:00',5.04),('9650','2013-06-28','18:05:00',4.92),('9650','2013-06-28','18:10:00',3.18),('9650','2013-06-28','18:15:00',4.59),('9650','2013-06-28','18:20:00',4.44),('9650','2013-06-28','18:25:00',4.01),('9650','2013-06-28','18:30:00',1.27),('9650','2013-06-28','18:35:00',3.45),('9650','2013-06-28','18:40:00',3.53),('9650','2013-06-28','18:45:00',1.93),('9650','2013-06-28','19:00:00',1),('9650','2013-06-28','19:05:00',2.37),('9650','2013-06-28','19:10:00',3.03),('9650','2013-06-28','19:15:00',1.62),('9650','2013-06-28','19:20:00',1.14),('9650','2013-06-28','19:25:00',1.78),('9650','2013-06-28','19:30:00',1.17),('9650','2013-06-27','07:45:00',1),('9650','2013-06-27','07:50:00',1.06),('9650','2013-06-27','07:55:00',1.13),('9650','2013-06-27','08:00:00',1.16),('9650','2013-06-27','08:05:00',1.13),('9650','2013-06-27','08:10:00',1.2),('9650','2013-06-27','08:15:00',1.27),('9650','2013-06-27','08:20:00',1.52),('9650','2013-06-27','08:25:00',1.65),('9650','2013-06-27','08:30:00',1.88),('9650','2013-06-27','08:35:00',2.04),('9650','2013-06-27','08:40:00',2.15),('9650','2013-06-27','08:45:00',2.28),('9650','2013-06-27','08:50:00',2.42),('9650','2013-06-27','08:55:00',2.61),('9650','2013-06-27','09:00:00',2.68),('9650','2013-06-27','09:05:00',2.82),('9650','2013-06-27','09:10:00',2.53),('9650','2013-06-27','09:15:00',3.38),('9650','2013-06-27','09:20:00',1.57),('9650','2013-06-27','09:25:00',1.8),('9650','2013-06-27','09:30:00',2.7),('9650','2013-06-27','09:35:00',3.91),('9650','2013-06-27','09:40:00',4.21),('9650','2013-06-27','09:45:00',4.44),('9650','2013-06-27','09:50:00',4.6),('9650','2013-06-27','09:55:00',5.11),('9650','2013-06-27','10:00:00',1.63),('9650','2013-06-27','10:05:00',2.23),('9650','2013-06-27','10:10:00',5),('9650','2013-06-27','10:15:00',5.32),('9650','2013-06-27','10:20:00',3.18),('9650','2013-06-27','10:25:00',2.37),('9650','2013-06-27','10:30:00',3.84),('9650','2013-06-27','10:35:00',6.67),('9650','2013-06-27','10:40:00',5.72),('9650','2013-06-27','10:45:00',6.55),('9650','2013-06-27','10:50:00',3.04),('9650','2013-06-27','10:55:00',3.95),('9650','2013-06-27','11:00:00',4.43),('9650','2013-06-27','11:05:00',3.61),('9650','2013-06-27','11:10:00',2.86),('9650','2013-06-27','11:15:00',3.24),('9650','2013-06-27','11:20:00',2.17),('9650','2013-06-27','11:25:00',4.38),('9650','2013-06-27','11:30:00',6.88),('9650','2013-06-27','11:35:00',5.68),('9650','2013-06-27','11:40:00',6.57),('9650','2013-06-27','11:45:00',5.89),('9650','2013-06-27','11:50:00',7.6),('9650','2013-06-27','11:55:00',4.44),('9650','2013-06-27','12:00:00',3.92),('9650','2013-06-27','12:05:00',4.94),('9650','2013-06-27','12:10:00',7.84),('9650','2013-06-27','12:15:00',7.37),('9650','2013-06-27','12:20:00',7.18),('9650','2013-06-27','12:25:00',7.34),('9650','2013-06-27','12:30:00',6.9),('9650','2013-06-27','12:35:00',6.25),('9650','2013-06-27','12:40:00',4.23),('9650','2013-06-27','12:45:00',7.43),('9650','2013-06-27','12:50:00',7.52),('9650','2013-06-27','12:55:00',7.35),('9650','2013-06-27','13:00:00',7.46),('9650','2013-06-27','13:05:00',7.56),('9650','2013-06-27','13:10:00',7.76),('9650','2013-06-27','13:15:00',7.63),('9650','2013-06-27','13:20:00',5.46),('9650','2013-06-27','13:25:00',7.52),('9650','2013-06-27','13:30:00',7.62),('9650','2013-06-27','13:35:00',7.71),('9650','2013-06-27','13:40:00',6.97),('9650','2013-06-27','13:45:00',7.66),('9650','2013-06-27','13:50:00',7.49),('9650','2013-06-27','13:55:00',7.99),('9650','2013-06-27','14:00:00',7.06),('9650','2013-06-27','14:05:00',7.29),('9650','2013-06-27','14:10:00',6.77),('9650','2013-06-27','14:15:00',7.33),('9650','2013-06-27','14:20:00',8.39),('9650','2013-06-27','14:25:00',5.5),('9650','2013-06-27','14:30:00',6.33),('9650','2013-06-27','14:35:00',7.45),('9650','2013-06-27','14:40:00',6.7),('9650','2013-06-27','14:45:00',8.1),('9650','2013-06-27','14:50:00',7.95),('9650','2013-06-27','14:55:00',7.66),('9650','2013-06-27','15:00:00',7.04),('9650','2013-06-27','15:05:00',7.67),('9650','2013-06-27','15:10:00',7.84),('9650','2013-06-27','15:15:00',7.33),('9650','2013-06-27','15:20:00',8.01),('9650','2013-06-27','15:25:00',7.99),('9650','2013-06-27','15:30:00',4.1),('9650','2013-06-27','15:35:00',6.49),('9650','2013-06-27','15:40:00',4.09),('9650','2013-06-27','15:45:00',6.37),('9650','2013-06-27','15:50:00',8.07),('9650','2013-06-27','15:55:00',6.64),('9650','2013-06-27','16:00:00',7.74),('9650','2013-06-27','16:05:00',6.84),('9650','2013-06-27','16:10:00',3.67),('9650','2013-06-27','16:15:00',6.81),('9650','2013-06-27','16:20:00',7.27),('9650','2013-06-27','16:25:00',3.83),('9650','2013-06-27','16:30:00',5.36),('9650','2013-06-27','16:35:00',1.98),('9650','2013-06-27','16:40:00',3.89),('9650','2013-06-27','16:45:00',2.41),('9650','2013-06-27','16:50:00',6.69),('9650','2013-06-27','16:55:00',5.48),('9650','2013-06-27','17:00:00',6.58),('9650','2013-06-27','17:05:00',6.19),('9650','2013-06-27','17:10:00',6.14),('9650','2013-06-27','17:15:00',6.01),('9650','2013-06-27','17:20:00',5.79),('9650','2013-06-27','17:25:00',5.82),('9650','2013-06-27','17:30:00',5.23),('9650','2013-06-27','17:35:00',5.55),('9650','2013-06-27','17:40:00',5.36),('9650','2013-06-27','17:45:00',5.31),('9650','2013-06-27','17:50:00',5.24),('9650','2013-06-27','17:55:00',5.18),('9650','2013-06-27','18:00:00',5.08),('9650','2013-06-27','18:05:00',4.93),('9650','2013-06-27','18:10:00',4.76),('9650','2013-06-27','18:15:00',4.61),('9650','2013-06-27','18:20:00',4.54),('9650','2013-06-27','18:25:00',4.47),('9650','2013-06-27','18:30:00',4.03),('9650','2013-06-27','18:35:00',2.39),('9650','2013-06-27','18:40:00',3.77),('9650','2013-06-27','18:45:00',2.7),('9650','2013-06-27','18:50:00',3.58),('9650','2013-06-27','18:55:00',3.19),('9650','2013-06-27','19:00:00',3.12),('9650','2013-06-27','19:05:00',3.06),('9650','2013-06-27','19:10:00',2.9),('9650','2013-06-27','19:15:00',2.48),('9650','2013-06-27','19:20:00',2.61),('9650','2013-06-27','19:25:00',2.51),('9650','2013-06-27','19:30:00',2.31),('9650','2013-06-27','19:35:00',2.1),('9650','2013-06-27','19:40:00',1.92),('9650','2013-06-27','19:45:00',1.78),('9650','2013-06-27','19:50:00',1.47),('9650','2013-06-27','19:55:00',1.19),('9650','2013-06-27','20:00:00',1.01),('9650','2013-06-26','07:50:00',1),('9650','2013-06-26','07:55:00',1.09),('9650','2013-06-26','08:00:00',1.17),('9650','2013-06-26','08:05:00',1.28),('9650','2013-06-26','08:10:00',1.36),('9650','2013-06-26','08:15:00',1.46),('9650','2013-06-26','08:20:00',1.61),('9650','2013-06-26','08:25:00',1.77),('9650','2013-06-26','08:30:00',1.91),('9650','2013-06-26','08:35:00',2.02),('9650','2013-06-26','08:40:00',2.13),('9650','2013-06-26','08:45:00',2.26),('9650','2013-06-26','08:50:00',2.4),('9650','2013-06-26','08:55:00',2.55),('9650','2013-06-26','09:00:00',2.69),('9650','2013-06-26','09:05:00',2.78),('9650','2013-06-26','09:10:00',2.91),('9650','2013-06-26','09:15:00',3.01),('9650','2013-06-26','09:20:00',3.21),('9650','2013-06-26','09:25:00',3.32),('9650','2013-06-26','09:30:00',3.44),('9650','2013-06-26','09:35:00',3.68),('9650','2013-06-26','09:40:00',3.81),('9650','2013-06-26','09:45:00',3.87),('9650','2013-06-26','09:50:00',4.14),('9650','2013-06-26','09:55:00',3.92),('9650','2013-06-26','10:00:00',4.3),('9650','2013-06-26','10:05:00',4.06),('9650','2013-06-26','10:10:00',4.41),('9650','2013-06-26','10:15:00',3.5),('9650','2013-06-26','10:20:00',4.77),('9650','2013-06-26','10:25:00',4.87),('9650','2013-06-26','10:30:00',5.04),('9650','2013-06-26','10:35:00',5.4),('9650','2013-06-26','10:40:00',5.78),('9650','2013-06-26','10:45:00',5.79),('9650','2013-06-26','10:50:00',5.75),('9650','2013-06-26','10:55:00',6.03),('9650','2013-06-26','11:00:00',5.93),('9650','2013-06-26','11:05:00',6.05),('9650','2013-06-26','11:10:00',6.21),('9650','2013-06-26','11:15:00',5.63),('9650','2013-06-26','11:20:00',6.29),('9650','2013-06-26','11:25:00',6.46),('9650','2013-06-26','11:30:00',6.28),('9650','2013-06-26','11:35:00',6.54),('9650','2013-06-26','11:40:00',6.93),('9650','2013-06-26','11:45:00',7.01),('9650','2013-06-26','11:50:00',2.57),('9650','2013-06-26','11:55:00',2.24),('9650','2013-06-26','12:00:00',2.39),('9650','2013-06-26','12:05:00',2.23),('9650','2013-06-26','12:10:00',2.17),('9650','2013-06-26','12:15:00',1.9),('9650','2013-06-26','12:20:00',2.03),('9650','2013-06-26','12:25:00',2.92),('9650','2013-06-26','12:30:00',2.87),('9650','2013-06-26','12:35:00',5.14),('9650','2013-06-26','12:40:00',3.06),('9650','2013-06-26','12:45:00',2.72),('9650','2013-06-26','12:50:00',2.27),('9650','2013-06-26','12:55:00',2.04),('9650','2013-06-26','13:00:00',1.79),('9650','2013-06-26','13:05:00',2.04),('9650','2013-06-26','13:10:00',2.59),('9650','2013-06-26','13:15:00',4.42),('9650','2013-06-26','13:20:00',2.74),('9650','2013-06-26','13:25:00',2.94),('9650','2013-06-26','13:30:00',2.63),('9650','2013-06-26','13:35:00',2.54),('9650','2013-06-26','13:40:00',2.3),('9650','2013-06-26','13:45:00',2.33),('9650','2013-06-26','13:50:00',3.46),('9650','2013-06-26','13:55:00',2.34),('9650','2013-06-26','14:00:00',2.47),('9650','2013-06-26','14:05:00',2.37),('9650','2013-06-26','14:10:00',5.61),('9650','2013-06-26','14:15:00',3.26),('9650','2013-06-26','14:20:00',6.62),('9650','2013-06-26','14:25:00',8.29),('9650','2013-06-26','14:30:00',6.49),('9650','2013-06-26','14:35:00',3.66),('9650','2013-06-26','14:40:00',4.83),('9650','2013-06-26','14:45:00',2.93),('9650','2013-06-26','14:50:00',3.41),('9650','2013-06-26','14:55:00',7.46),('9650','2013-06-26','15:00:00',7.46),('9650','2013-06-26','15:05:00',7.34),('9650','2013-06-26','15:10:00',7.3),('9650','2013-06-26','15:15:00',7.22),('9650','2013-06-26','15:20:00',7.24),('9650','2013-06-26','15:25:00',7.3),('9650','2013-06-26','15:30:00',7.24),('9650','2013-06-26','15:35:00',7.23),('9650','2013-06-26','15:40:00',7.17),('9650','2013-06-26','15:45:00',7.12),('9650','2013-06-26','15:50:00',7.09),('9650','2013-06-26','15:55:00',6.76),('9650','2013-06-26','16:00:00',6.82),('9650','2013-06-26','16:05:00',6.75),('9650','2013-06-26','16:10:00',6.74),('9650','2013-06-26','16:15:00',6.68),('9650','2013-06-26','16:20:00',6.64),('9650','2013-06-26','16:25:00',6.58),('9650','2013-06-26','16:30:00',6.57),('9650','2013-06-26','16:35:00',6.13),('9650','2013-06-26','16:40:00',6.27),('9650','2013-06-26','16:45:00',6.37),('9650','2013-06-26','16:50:00',6.22),('9650','2013-06-26','16:55:00',6.12),('9650','2013-06-26','17:00:00',6.07),('9650','2013-06-26','17:05:00',5.95),('9650','2013-06-26','17:10:00',5.67),('9650','2013-06-26','17:15:00',5.51),('9650','2013-06-26','17:20:00',5.73),('9650','2013-06-26','17:25:00',5.64),('9650','2013-06-26','17:30:00',5.62),('9650','2013-06-26','17:35:00',5.49),('9650','2013-06-26','17:40:00',3.58),('9650','2013-06-26','17:45:00',2.51),('9650','2013-06-26','17:50:00',4.59),('9650','2013-06-26','17:55:00',4.83),('9650','2013-06-26','18:00:00',4.67),('9650','2013-06-26','18:05:00',4.45),('9650','2013-06-26','18:10:00',4.34),('9650','2013-06-26','18:15:00',4.16),('9650','2013-06-26','18:20:00',4.03),('9650','2013-06-26','18:25:00',4.07),('9650','2013-06-26','18:30:00',3.86),('9650','2013-06-26','18:35:00',3.65),('9650','2013-06-26','18:40:00',3.28),('9650','2013-06-26','18:45:00',3.22),('9650','2013-06-26','18:50:00',3.16),('9650','2013-06-26','18:55:00',3.07),('9650','2013-06-26','19:00:00',2.87),('9650','2013-06-26','19:05:00',2.67),('9650','2013-06-26','19:10:00',2.53),('9650','2013-06-26','19:15:00',2.36),('9650','2013-06-26','19:20:00',2.17),('9650','2013-06-26','19:25:00',1.25),('9650','2013-06-25','07:50:00',1.02),('9650','2013-06-25','07:55:00',1.08),('9650','2013-06-25','08:00:00',1.15),('9650','2013-06-25','08:05:00',1.26),('9650','2013-06-25','08:10:00',1.36),('9650','2013-06-25','08:15:00',1.48),('9650','2013-06-25','08:20:00',1.6),('9650','2013-06-25','08:25:00',1.78),('9650','2013-06-25','08:30:00',1.93),('9650','2013-06-25','08:35:00',2.05),('9650','2013-06-25','08:40:00',2.14),('9650','2013-06-25','08:45:00',2.27),('9650','2013-06-25','08:50:00',2.39),('9650','2013-06-25','08:55:00',2.5),('9650','2013-06-25','09:00:00',2.62),('9650','2013-06-25','09:05:00',2.75),('9650','2013-06-25','09:10:00',2.86),('9650','2013-06-25','09:15:00',2.96),('9650','2013-06-25','09:20:00',3.1),('9650','2013-06-25','09:25:00',3.26),('9650','2013-06-25','09:30:00',3.38),('9650','2013-06-25','09:35:00',3.57),('9650','2013-06-25','09:40:00',3.71),('9650','2013-06-25','09:45:00',3.85),('9650','2013-06-25','09:50:00',3.94),('9650','2013-06-25','09:55:00',4.02),('9650','2013-06-25','10:00:00',4.14),('9650','2013-06-25','10:05:00',4.27),('9650','2013-06-25','10:10:00',4.43),('9650','2013-06-25','10:15:00',4.54),('9650','2013-06-25','10:20:00',4.62),('9650','2013-06-25','10:25:00',4.73),('9650','2013-06-25','10:30:00',4.83),('9650','2013-06-25','10:35:00',4.93),('9650','2013-06-25','10:40:00',5.06),('9650','2013-06-25','10:45:00',5.21),('9650','2013-06-25','10:50:00',5.33),('9650','2013-06-25','10:55:00',5.42),('9650','2013-06-25','11:00:00',5.5),('9650','2013-06-25','11:05:00',5.61),('9650','2013-06-25','11:10:00',5.68),('9650','2013-06-25','11:15:00',5.78),('9650','2013-06-25','11:20:00',5.84),('9650','2013-06-25','11:25:00',5.92),('9650','2013-06-25','11:30:00',5.99),('9650','2013-06-25','11:35:00',6.06),('9650','2013-06-25','11:40:00',6.15),('9650','2013-06-25','11:45:00',6.18),('9650','2013-06-25','11:50:00',6.3),('9650','2013-06-25','11:55:00',6.43),('9650','2013-06-25','12:00:00',6.52),('9650','2013-06-25','12:05:00',6.61),('9650','2013-06-25','12:10:00',6.52),('9650','2013-06-25','12:15:00',6.6),('9650','2013-06-25','12:20:00',6.5),('9650','2013-06-25','12:25:00',6.6),('9650','2013-06-25','12:30:00',5.82),('9650','2013-06-25','12:35:00',6.24),('9650','2013-06-25','12:40:00',6.04),('9650','2013-06-25','12:45:00',4.1),('9650','2013-06-25','12:50:00',1.58),('9650','2013-06-25','12:55:00',1.93),('9650','2013-06-25','13:00:00',1.6),('9650','2013-06-25','13:05:00',1.77),('9650','2013-06-25','13:10:00',4.71),('9650','2013-06-25','13:15:00',7.9),('9650','2013-06-25','13:20:00',7.99),('9650','2013-06-25','13:25:00',7.7),('9650','2013-06-25','13:30:00',5.93),('9650','2013-06-25','13:35:00',1.74),('9650','2013-06-25','13:40:00',1.91),('9650','2013-06-25','13:45:00',3.58),('9650','2013-06-25','13:50:00',3.9),('9650','2013-06-25','13:55:00',2.87),('9650','2013-06-25','14:00:00',8.3),('9650','2013-06-25','14:05:00',7.5),('9650','2013-06-25','14:10:00',2.65),('9650','2013-06-25','14:15:00',6.6),('9650','2013-06-25','14:20:00',7.91),('9650','2013-06-25','14:25:00',6.13),('9650','2013-06-25','14:30:00',7.62),('9650','2013-06-25','14:35:00',7.44),('9650','2013-06-25','14:40:00',5.64),('9650','2013-06-25','14:45:00',4.41),('9650','2013-06-25','14:50:00',7.96),('9650','2013-06-25','14:55:00',7.86),('9650','2013-06-25','15:00:00',7.53),('9650','2013-06-25','15:05:00',7.49),('9650','2013-06-25','15:10:00',7.4),('9650','2013-06-25','15:15:00',7.37),('9650','2013-06-25','15:20:00',7.37),('9650','2013-06-25','15:25:00',7.29),('9650','2013-06-25','15:30:00',7.23),('9650','2013-06-25','15:35:00',7.35),('9650','2013-06-25','15:40:00',7.24),('9650','2013-06-25','15:45:00',7.18),('9650','2013-06-25','15:50:00',7.24),('9650','2013-06-25','15:55:00',7.07),('9650','2013-06-25','16:00:00',6.93),('9650','2013-06-25','16:05:00',6.94),('9650','2013-06-25','16:10:00',6.92),('9650','2013-06-25','16:15:00',6.84),('9650','2013-06-25','16:20:00',6.79),('9650','2013-06-25','16:25:00',6.69),('9650','2013-06-25','16:30:00',6.58),('9650','2013-06-25','16:35:00',6.5),('9650','2013-06-25','16:40:00',6.35),('9650','2013-06-25','16:45:00',6.36),('9650','2013-06-25','16:50:00',6.3),('9650','2013-06-25','16:55:00',6.23),('9650','2013-06-25','17:00:00',6.2),('9650','2013-06-25','17:05:00',6.14),('9650','2013-06-25','17:10:00',6),('9650','2013-06-25','17:15:00',5.83),('9650','2013-06-25','17:20:00',5.71),('9650','2013-06-25','17:25:00',5.61),('9650','2013-06-25','17:30:00',5.49),('9650','2013-06-25','17:35:00',5.41),('9650','2013-06-25','17:40:00',5.29),('9650','2013-06-25','17:45:00',5.19),('9650','2013-06-25','17:50:00',5.06),('9650','2013-06-25','17:55:00',4.99),('9650','2013-06-25','18:00:00',4.83),('9650','2013-06-25','18:05:00',4.77),('9650','2013-06-25','18:10:00',5.1),('9650','2013-06-25','18:15:00',3.04),('9650','2013-06-25','18:20:00',1.76),('9650','2013-06-25','18:25:00',1.65),('9650','2013-06-25','18:30:00',1.07),('9650','2013-06-25','19:00:00',2.01),('9650','2013-06-25','19:05:00',1.5),('9650','2013-06-25','19:10:00',1.54),('9650','2013-06-25','19:15:00',2.38),('9650','2013-06-25','19:20:00',2.08),('9650','2013-06-25','19:25:00',1.75),('9650','2013-06-25','19:30:00',1.21),('9650','2013-06-24','07:40:00',1.09),('9650','2013-06-24','07:45:00',1.18),('9650','2013-06-24','07:50:00',1.31),('9650','2013-06-24','07:55:00',1.18),('9650','2013-06-24','08:00:00',1.93),('9650','2013-06-24','08:05:00',1.54),('9650','2013-06-24','08:10:00',1.07),('9650','2013-06-24','08:15:00',1.06),('9650','2013-06-24','08:20:00',1.33),('9650','2013-06-24','08:25:00',1.89),('9650','2013-06-24','08:30:00',1.99),('9650','2013-06-24','08:35:00',2.1),('9650','2013-06-24','08:40:00',2.21),('9650','2013-06-24','08:45:00',2.33),('9650','2013-06-24','08:50:00',2.4),('9650','2013-06-24','08:55:00',2.55),('9650','2013-06-24','09:00:00',2.69),('9650','2013-06-24','09:05:00',2.81),('9650','2013-06-24','09:10:00',2.93),('9650','2013-06-24','09:15:00',3.1),('9650','2013-06-24','09:20:00',3.26),('9650','2013-06-24','09:25:00',3.34),('9650','2013-06-24','09:30:00',3.52),('9650','2013-06-24','09:35:00',3.77),('9650','2013-06-24','09:40:00',4.07),('9650','2013-06-24','09:45:00',2.84),('9650','2013-06-24','09:50:00',3.52),('9650','2013-06-24','09:55:00',3.22),('9650','2013-06-24','10:00:00',5.02),('9650','2013-06-24','10:05:00',5.26),('9650','2013-06-24','10:10:00',5.51),('9650','2013-06-24','10:15:00',5.55),('9650','2013-06-24','10:20:00',2.6),('9650','2013-06-24','10:25:00',4.96),('9650','2013-06-24','10:30:00',5.68),('9650','2013-06-24','10:35:00',5.69),('9650','2013-06-24','10:40:00',5.73),('9650','2013-06-24','10:45:00',5.71),('9650','2013-06-24','10:50:00',3.12),('9650','2013-06-24','10:55:00',1.73),('9650','2013-06-24','11:00:00',1.57),('9650','2013-06-24','11:05:00',2.76),('9650','2013-06-24','11:10:00',2.08),('9650','2013-06-24','11:15:00',1.67),('9650','2013-06-24','11:20:00',1.81),('9650','2013-06-24','11:25:00',1.93),('9650','2013-06-24','11:30:00',2.11),('9650','2013-06-24','11:35:00',5.21),('9650','2013-06-24','11:40:00',7.92),('9650','2013-06-24','11:45:00',7.54),('9650','2013-06-24','11:50:00',7.62),('9650','2013-06-24','11:55:00',4.71),('9650','2013-06-24','12:00:00',2.09),('9650','2013-06-24','12:05:00',1.94),('9650','2013-06-24','12:10:00',2.21),('9650','2013-06-24','12:15:00',2.16),('9650','2013-06-24','12:20:00',2.24),('9650','2013-06-24','12:25:00',2.13),('9650','2013-06-24','12:30:00',2.08),('9650','2013-06-24','12:35:00',2.43),('9650','2013-06-24','12:40:00',4.46),('9650','2013-06-24','12:45:00',6.43),('9650','2013-06-24','12:50:00',3.43),('9650','2013-06-24','12:55:00',2.87),('9650','2013-06-24','13:00:00',7.76),('9650','2013-06-24','13:05:00',7.08),('9650','2013-06-24','13:10:00',6.73),('9650','2013-06-24','13:15:00',7.91),('9650','2013-06-24','13:20:00',7.74),('9650','2013-06-24','13:25:00',7.68),('9650','2013-06-24','13:30:00',7.73),('9650','2013-06-24','13:35:00',7.88),('9650','2013-06-24','13:40:00',8.05),('9650','2013-06-24','13:45:00',7.81),('9650','2013-06-24','13:50:00',7.85),('9650','2013-06-24','13:55:00',5.29),('9650','2013-06-24','14:00:00',5.65),('9650','2013-06-24','14:05:00',7.81),('9650','2013-06-24','14:10:00',7.85),('9650','2013-06-24','14:15:00',7.97),('9650','2013-06-24','14:20:00',7.77),('9650','2013-06-24','14:25:00',7.58),('9650','2013-06-24','14:30:00',7.57),('9650','2013-06-24','14:35:00',7.56),('9650','2013-06-24','14:40:00',7.52),('9650','2013-06-24','14:45:00',7.61),('9650','2013-06-24','14:50:00',7.58),('9650','2013-06-24','14:55:00',7.56),('9650','2013-06-24','15:00:00',7.51),('9650','2013-06-24','15:05:00',7.48),('9650','2013-06-24','15:10:00',7.48),('9650','2013-06-24','15:15:00',7.42),('9650','2013-06-24','15:20:00',7.38),('9650','2013-06-24','15:25:00',7.3),('9650','2013-06-24','15:30:00',7.26),('9650','2013-06-24','15:35:00',7.25),('9650','2013-06-24','15:40:00',7.23),('9650','2013-06-24','15:45:00',7.18),('9650','2013-06-24','15:50:00',7.1),('9650','2013-06-24','15:55:00',7),('9650','2013-06-24','16:00:00',6.99),('9650','2013-06-24','16:05:00',6.9),('9650','2013-06-24','16:10:00',6.81),('9650','2013-06-24','16:15:00',6.79),('9650','2013-06-24','16:20:00',6.7),('9650','2013-06-24','16:25:00',6.64),('9650','2013-06-24','16:30:00',6.64),('9650','2013-06-24','16:35:00',6.52),('9650','2013-06-24','16:40:00',6.44),('9650','2013-06-24','16:45:00',6.35),('9650','2013-06-24','16:50:00',6.32),('9650','2013-06-24','16:55:00',6.24),('9650','2013-06-24','17:00:00',6.15),('9650','2013-06-24','17:05:00',6.08),('9650','2013-06-24','17:10:00',5.96),('9650','2013-06-24','17:15:00',5.88),('9650','2013-06-24','17:20:00',5.79),('9650','2013-06-24','17:25:00',5.66),('9650','2013-06-24','17:30:00',5.55),('9650','2013-06-24','17:35:00',5.45),('9650','2013-06-24','17:40:00',5.33),('9650','2013-06-24','17:45:00',5.18),('9650','2013-06-24','17:50:00',5.07),('9650','2013-06-24','17:55:00',4.98),('9650','2013-06-24','18:00:00',4.88),('9650','2013-06-24','18:05:00',4.71),('9650','2013-06-24','18:10:00',4.55),('9650','2013-06-24','18:15:00',4.45),('9650','2013-06-24','18:20:00',4.32),('9650','2013-06-24','18:25:00',4.16),('9650','2013-06-24','18:30:00',4.06),('9650','2013-06-24','18:35:00',3.94),('9650','2013-06-24','18:40:00',3.8),('9650','2013-06-24','18:45:00',3.63),('9650','2013-06-24','18:50:00',3.43),('9650','2013-06-24','18:55:00',3.28),('9650','2013-06-24','19:00:00',3.18),('9650','2013-06-24','19:05:00',3),('9650','2013-06-24','19:10:00',2.87),('9650','2013-06-24','19:15:00',2.69),('9650','2013-06-24','19:20:00',2.5),('9650','2013-06-24','19:25:00',2.34),('9650','2013-06-24','19:30:00',2.12),('9650','2013-06-24','19:35:00',1.92),('9650','2013-06-24','19:40:00',1.72),('9650','2013-06-24','19:45:00',1.53),('9650','2013-06-24','19:50:00',1.32),('9650','2013-06-24','19:55:00',1.1),('9650','2013-06-23','07:25:00',1.17),('9650','2013-06-23','07:50:00',1.17),('9650','2013-06-23','08:40:00',1.57),('9650','2013-06-23','08:45:00',2.5),('9650','2013-06-23','08:50:00',2.57),('9650','2013-06-23','08:55:00',2.81),('9650','2013-06-23','09:00:00',2.36),('9650','2013-06-23','09:05:00',2.81),('9650','2013-06-23','09:10:00',2.29),('9650','2013-06-23','09:15:00',2.9),('9650','2013-06-23','09:20:00',3.53),('9650','2013-06-23','09:25:00',3.97),('9650','2013-06-23','09:30:00',3.94),('9650','2013-06-23','09:35:00',2.59),('9650','2013-06-23','09:40:00',3.65),('9650','2013-06-23','09:45:00',4.55),('9650','2013-06-23','09:50:00',4.47),('9650','2013-06-23','09:55:00',4.31),('9650','2013-06-23','10:00:00',4.4),('9650','2013-06-23','10:05:00',4.56),('9650','2013-06-23','10:10:00',5),('9650','2013-06-23','10:15:00',4.18),('9650','2013-06-23','10:20:00',5.28),('9650','2013-06-23','10:25:00',5.86),('9650','2013-06-23','10:30:00',4.92),('9650','2013-06-23','10:35:00',6.18),('9650','2013-06-23','10:40:00',2.23),('9650','2013-06-23','10:45:00',2.52),('9650','2013-06-23','10:50:00',6.55),('9650','2013-06-23','10:55:00',4.62),('9650','2013-06-23','11:00:00',6.06),('9650','2013-06-23','11:05:00',6.27),('9650','2013-06-23','11:10:00',2.61),('9650','2013-06-23','11:15:00',5.39),('9650','2013-06-23','11:20:00',6.06),('9650','2013-06-23','11:25:00',2.66),('9650','2013-06-23','11:30:00',3.84),('9650','2013-06-23','11:35:00',2.5),('9650','2013-06-23','11:40:00',2.39),('9650','2013-06-23','11:45:00',4.37),('9650','2013-06-23','11:50:00',3.89),('9650','2013-06-23','11:55:00',6.59),('9650','2013-06-23','12:00:00',5.02),('9650','2013-06-23','12:05:00',5.7),('9650','2013-06-23','12:10:00',6.77),('9650','2013-06-23','12:15:00',4.38),('9650','2013-06-23','12:20:00',8.09),('9650','2013-06-23','12:25:00',6.74),('9650','2013-06-23','12:30:00',5.56),('9650','2013-06-23','12:35:00',7.5),('9650','2013-06-23','12:40:00',6.67),('9650','2013-06-23','12:45:00',5.49),('9650','2013-06-23','12:50:00',7.73),('9650','2013-06-23','12:55:00',7.86),('9650','2013-06-23','13:00:00',5.95),('9650','2013-06-23','13:05:00',8.21),('9650','2013-06-23','13:10:00',6.28),('9650','2013-06-23','13:15:00',5.99),('9650','2013-06-23','13:20:00',3.2),('9650','2013-06-23','13:25:00',6.69),('9650','2013-06-23','13:30:00',8.08),('9650','2013-06-23','13:35:00',5.51),('9650','2013-06-23','13:40:00',7.62),('9650','2013-06-23','13:45:00',8.01),('9650','2013-06-23','13:50:00',7.89),('9650','2013-06-23','13:55:00',7.84),('9650','2013-06-23','14:00:00',7.54),('9650','2013-06-23','14:05:00',7.87),('9650','2013-06-23','14:10:00',7.87),('9650','2013-06-23','14:15:00',7.9),('9650','2013-06-23','14:20:00',7.89),('9650','2013-06-23','14:25:00',7.95),('9650','2013-06-23','14:30:00',7.96),('9650','2013-06-23','14:35:00',8),('9650','2013-06-23','14:40:00',8.02),('9650','2013-06-23','14:45:00',8.22),('9650','2013-06-23','14:50:00',7.35),('9650','2013-06-23','14:55:00',5.77),('9650','2013-06-23','15:00:00',7.41),('9650','2013-06-23','15:05:00',4.29),('9650','2013-06-23','15:10:00',7.39),('9650','2013-06-23','15:15:00',7.98),('9650','2013-06-23','15:20:00',7.22),('9650','2013-06-23','15:25:00',4.79),('9650','2013-06-23','15:30:00',6.48),('9650','2013-06-23','15:35:00',4.29),('9650','2013-06-23','15:40:00',5.5),('9650','2013-06-23','15:45:00',6.14),('9650','2013-06-23','15:50:00',6.17),('9650','2013-06-23','15:55:00',7.29),('9650','2013-06-23','16:00:00',8.41),('9650','2013-06-23','16:05:00',7.56),('9650','2013-06-23','16:10:00',5.91),('9650','2013-06-23','16:15:00',8.04),('9650','2013-06-23','16:20:00',4.4),('9650','2013-06-23','16:25:00',5.62),('9650','2013-06-23','16:30:00',6.86),('9650','2013-06-23','16:35:00',6.53),('9650','2013-06-23','16:40:00',4.34),('9650','2013-06-23','16:45:00',4.65),('9650','2013-06-23','16:50:00',3.96),('9650','2013-06-23','16:55:00',2.56),('9650','2013-06-23','17:00:00',2.97),('9650','2013-06-23','17:05:00',5.55),('9650','2013-06-23','17:10:00',5.69),('9650','2013-06-23','17:15:00',6.77),('9650','2013-06-23','17:20:00',4.13),('9650','2013-06-23','17:25:00',5.74),('9650','2013-06-23','17:30:00',3.77),('9650','2013-06-23','17:35:00',1.89),('9650','2013-06-23','17:40:00',1.65),('9650','2013-06-23','17:45:00',1.87),('9650','2013-06-23','17:50:00',3.62),('9650','2013-06-23','17:55:00',2.84),('9650','2013-06-23','18:00:00',5.67),('9650','2013-06-23','18:05:00',4.79),('9650','2013-06-23','18:10:00',4.05),('9650','2013-06-23','18:15:00',4.83),('9650','2013-06-23','18:20:00',4.63),('9650','2013-06-23','18:25:00',4.37),('9650','2013-06-23','18:30:00',2.88),('9650','2013-06-23','18:35:00',4.22),('9650','2013-06-23','18:40:00',2.52),('9650','2013-06-23','18:45:00',3.95),('9650','2013-06-23','18:50:00',3.6),('9650','2013-06-23','18:55:00',3.42),('9650','2013-06-23','19:00:00',3.43),('9650','2013-06-23','19:05:00',3.22),('9650','2013-06-23','19:10:00',3.1),('9650','2013-06-23','19:15:00',2.78),('9650','2013-06-23','19:20:00',2.55),('9650','2013-06-23','19:25:00',2.44),('9650','2013-06-23','19:30:00',2.27),('9650','2013-06-23','19:35:00',2.08),('9650','2013-06-23','19:40:00',1.93),('9650','2013-06-23','19:45:00',1.67),('9650','2013-06-23','19:50:00',1.43),('9650','2013-06-23','19:55:00',1.16),('9650','2013-06-22','08:35:00',1.2),('9650','2013-06-22','08:40:00',1.32),('9650','2013-06-22','08:45:00',1.56),('9650','2013-06-22','08:50:00',1.95),('9650','2013-06-22','08:55:00',1.64),('9650','2013-06-22','09:00:00',2.55),('9650','2013-06-22','09:05:00',1.85),('9650','2013-06-22','09:20:00',1.96),('9650','2013-06-22','09:25:00',3.14),('9650','2013-06-22','09:30:00',3.41),('9650','2013-06-22','09:35:00',3.73),('9650','2013-06-22','09:40:00',4.57),('9650','2013-06-22','09:45:00',3.19),('9650','2013-06-22','09:50:00',1.68),('9650','2013-06-22','09:55:00',1.27),('9650','2013-06-22','10:00:00',3.13),('9650','2013-06-22','10:05:00',3.62),('9650','2013-06-22','10:10:00',1.6),('9650','2013-06-22','10:15:00',2.17),('9650','2013-06-22','10:20:00',2.02),('9650','2013-06-22','10:25:00',2.44),('9650','2013-06-22','10:30:00',4.61),('9650','2013-06-22','10:35:00',1.58),('9650','2013-06-22','10:40:00',4.25),('9650','2013-06-22','10:45:00',4.98),('9650','2013-06-22','10:50:00',4.88),('9650','2013-06-22','10:55:00',5.12),('9650','2013-06-22','11:00:00',5.38),('9650','2013-06-22','11:05:00',5.53),('9650','2013-06-22','11:10:00',5.68),('9650','2013-06-22','11:15:00',5.6),('9650','2013-06-22','11:20:00',5.62),('9650','2013-06-22','11:25:00',5.86),('9650','2013-06-22','11:30:00',5.77),('9650','2013-06-22','11:35:00',5.66),('9650','2013-06-22','11:40:00',5.96),('9650','2013-06-22','11:45:00',6.06),('9650','2013-06-22','11:50:00',6.06),('9650','2013-06-22','11:55:00',6.13),('9650','2013-06-22','12:00:00',6.18),('9650','2013-06-22','12:05:00',6.49),('9650','2013-06-22','12:10:00',6.46),('9650','2013-06-22','12:15:00',6.52),('9650','2013-06-22','12:20:00',6.6),('9650','2013-06-22','12:25:00',6.76),('9650','2013-06-22','12:30:00',6.77),('9650','2013-06-22','12:35:00',6.8),('9650','2013-06-22','12:40:00',6.88),('9650','2013-06-22','12:45:00',6.93),('9650','2013-06-22','12:50:00',6.97),('9650','2013-06-22','12:55:00',7),('9650','2013-06-22','13:00:00',7.07),('9650','2013-06-22','13:05:00',7.13),('9650','2013-06-22','13:10:00',7.16),('9650','2013-06-22','13:15:00',7.21),('9650','2013-06-22','13:20:00',7.24),('9650','2013-06-22','13:25:00',7.3),('9650','2013-06-22','13:30:00',7.33),('9650','2013-06-22','13:35:00',7.41),('9650','2013-06-22','13:40:00',7.39),('9650','2013-06-22','13:45:00',7.44),('9650','2013-06-22','13:50:00',7.48),('9650','2013-06-22','13:55:00',7.49),('9650','2013-06-22','14:00:00',7.5),('9650','2013-06-22','14:05:00',7.5),('9650','2013-06-22','14:10:00',7.49),('9650','2013-06-22','14:15:00',7.47),('9650','2013-06-22','14:20:00',7.49),('9650','2013-06-22','14:25:00',7.57),('9650','2013-06-22','14:30:00',7.55),('9650','2013-06-22','14:35:00',7.57),('9650','2013-06-22','14:40:00',7.56),('9650','2013-06-22','14:45:00',7.61),('9650','2013-06-22','14:50:00',7.58),('9650','2013-06-22','14:55:00',7.6),('9650','2013-06-22','15:00:00',7.59),('9650','2013-06-22','15:05:00',7.55),('9650','2013-06-22','15:10:00',7.52),('9650','2013-06-22','15:15:00',7.5),('9650','2013-06-22','15:20:00',7.49),('9650','2013-06-22','15:25:00',7.42),('9650','2013-06-22','15:30:00',7.39),('9650','2013-06-22','15:35:00',7.34),('9650','2013-06-22','15:40:00',7.29),('9650','2013-06-22','15:45:00',7.27),('9650','2013-06-22','15:50:00',7.21),('9650','2013-06-22','15:55:00',7.16),('9650','2013-06-22','16:00:00',7.12),('9650','2013-06-22','16:05:00',7.04),('9650','2013-06-22','16:10:00',7),('9650','2013-06-22','16:15:00',6.88),('9650','2013-06-22','16:20:00',6.76),('9650','2013-06-22','16:25:00',6.76),('9650','2013-06-22','16:30:00',6.7),('9650','2013-06-22','16:35:00',6.64),('9650','2013-06-22','16:40:00',6.61),('9650','2013-06-22','16:45:00',6.54),('9650','2013-06-22','16:50:00',6.46),('9650','2013-06-22','16:55:00',6.36),('9650','2013-06-22','17:00:00',6.31),('9650','2013-06-22','17:05:00',6.19),('9650','2013-06-22','17:10:00',6.14),('9650','2013-06-22','17:15:00',6.06),('9650','2013-06-22','17:20:00',5.73),('9650','2013-06-22','17:25:00',5.42),('9650','2013-06-22','17:30:00',5.75),('9650','2013-06-22','17:35:00',5.57),('9650','2013-06-22','17:40:00',5.55),('9650','2013-06-22','17:45:00',5.48),('9650','2013-06-22','17:50:00',5.41),('9650','2013-06-22','17:55:00',5.25),('9650','2013-06-22','18:00:00',5.16),('9650','2013-06-22','18:05:00',5.01),('9650','2013-06-22','18:10:00',4.91),('9650','2013-06-22','18:15:00',4.67),('9650','2013-06-22','18:20:00',4.63),('9650','2013-06-22','18:25:00',4.39),('9650','2013-06-22','18:30:00',4.34),('9650','2013-06-22','18:35:00',4.17),('9650','2013-06-22','18:40:00',4.07),('9650','2013-06-22','18:45:00',3.96),('9650','2013-06-22','18:50:00',3.83),('9650','2013-06-22','18:55:00',3.56),('9650','2013-06-22','19:00:00',3.38),('9650','2013-06-22','19:05:00',3.26),('9650','2013-06-22','19:10:00',3.18),('9650','2013-06-22','19:15:00',2.71),('9650','2013-06-22','19:20:00',2.26),('9650','2013-06-22','19:25:00',2.56),('9650','2013-06-22','19:30:00',2.03),('9650','2013-06-22','19:35:00',2.26),('9650','2013-06-22','19:40:00',2.11),('9650','2013-06-22','19:45:00',1.78),('9650','2013-06-22','19:50:00',1.01),('9650','2013-06-21','07:50:00',1.02),('9650','2013-06-21','07:55:00',1.11),('9650','2013-06-21','08:00:00',1.19),('9650','2013-06-21','08:05:00',1.27),('9650','2013-06-21','08:10:00',1.34),('9650','2013-06-21','08:15:00',1.43),('9650','2013-06-21','08:20:00',1.58),('9650','2013-06-21','08:25:00',1.73),('9650','2013-06-21','08:30:00',1.85),('9650','2013-06-21','08:35:00',1.98),('9650','2013-06-21','08:40:00',2.1),('9650','2013-06-21','08:45:00',2.21),('9650','2013-06-21','08:50:00',2.32),('9650','2013-06-21','08:55:00',2.42),('9650','2013-06-21','09:00:00',2.52),('9650','2013-06-21','09:05:00',2.63),('9650','2013-06-21','09:10:00',2.75),('9650','2013-06-21','09:15:00',2.85),('9650','2013-06-21','09:20:00',2.95),('9650','2013-06-21','09:25:00',3.04),('9650','2013-06-21','09:30:00',3.21),('9650','2013-06-21','09:35:00',3.38),('9650','2013-06-21','09:40:00',3.54),('9650','2013-06-21','09:45:00',3.62),('9650','2013-06-21','09:50:00',3.72),('9650','2013-06-21','09:55:00',3.85),('9650','2013-06-21','10:00:00',3.94),('9650','2013-06-21','10:05:00',4.07),('9650','2013-06-21','10:10:00',4.23),('9650','2013-06-21','10:15:00',4.29),('9650','2013-06-21','10:20:00',4.44),('9650','2013-06-21','10:25:00',4.56),('9650','2013-06-21','10:30:00',4.61),('9650','2013-06-21','10:35:00',4.69),('9650','2013-06-21','10:40:00',4.83),('9650','2013-06-21','10:45:00',4.98),('9650','2013-06-21','10:50:00',5.13),('9650','2013-06-21','10:55:00',5.2),('9650','2013-06-21','11:00:00',5.3),('9650','2013-06-21','11:05:00',5.4),('9650','2013-06-21','11:10:00',5.47),('9650','2013-06-21','11:15:00',5.57),('9650','2013-06-21','11:20:00',5.66),('9650','2013-06-21','11:25:00',5.71),('9650','2013-06-21','11:30:00',5.81),('9650','2013-06-21','11:35:00',5.89),('9650','2013-06-21','11:40:00',5.97),('9650','2013-06-21','11:45:00',6.04),('9650','2013-06-21','11:50:00',6.08),('9650','2013-06-21','11:55:00',6.11),('9650','2013-06-21','12:00:00',6.17),('9650','2013-06-21','12:05:00',6.12),('9650','2013-06-21','12:10:00',6.09),('9650','2013-06-21','12:15:00',6.42),('9650','2013-06-21','12:20:00',6.33),('9650','2013-06-21','12:25:00',6.45),('9650','2013-06-21','12:30:00',6.58),('9650','2013-06-21','12:35:00',6.62),('9650','2013-06-21','12:40:00',6.75),('9650','2013-06-21','12:45:00',6.64),('9650','2013-06-21','12:50:00',6.58),('9650','2013-06-21','12:55:00',6.61),('9650','2013-06-21','13:00:00',6.55),('9650','2013-06-21','13:05:00',6.64),('9650','2013-06-21','13:10:00',6.56),('9650','2013-06-21','13:15:00',6.47),('9650','2013-06-21','13:20:00',6.35),('9650','2013-06-21','13:25:00',6.93),('9650','2013-06-21','13:30:00',7.37),('9650','2013-06-21','13:35:00',7.46),('9650','2013-06-21','13:40:00',6.75),('9650','2013-06-21','13:45:00',7.17),('9650','2013-06-21','13:50:00',7.43),('9650','2013-06-21','13:55:00',5.53),('9650','2013-06-21','14:00:00',4.44),('9650','2013-06-21','14:05:00',8.11),('9650','2013-06-21','14:10:00',7.78),('9650','2013-06-21','14:15:00',7.86),('9650','2013-06-21','14:20:00',6.5),('9650','2013-06-21','14:25:00',7.77),('9650','2013-06-21','14:30:00',5.52),('9650','2013-06-21','14:35:00',4.25),('9650','2013-06-21','14:40:00',3.28),('9650','2013-06-21','14:45:00',4.04),('9650','2013-06-21','14:50:00',6.79),('9650','2013-06-21','14:55:00',7.66),('9650','2013-06-21','15:00:00',7.39),('9650','2013-06-21','15:05:00',5.88),('9650','2013-06-21','15:10:00',7.35),('9650','2013-06-21','15:15:00',7.78),('9650','2013-06-21','15:20:00',7.07),('9650','2013-06-21','15:25:00',6.38),('9650','2013-06-21','15:30:00',4.38),('9650','2013-06-21','15:35:00',3.62),('9650','2013-06-21','15:40:00',4.04),('9650','2013-06-21','15:45:00',5.31),('9650','2013-06-21','15:50:00',4.82),('9650','2013-06-21','15:55:00',4.68),('9650','2013-06-21','16:00:00',3.51),('9650','2013-06-21','16:05:00',2.29),('9650','2013-06-21','16:10:00',2.36),('9650','2013-06-21','16:15:00',3.07),('9650','2013-06-21','16:20:00',3.56),('9650','2013-06-21','16:25:00',2.4),('9650','2013-06-21','16:30:00',1.95),('9650','2013-06-21','16:35:00',1.7),('9650','2013-06-21','16:40:00',1.56),('9650','2013-06-21','16:45:00',1.51),('9650','2013-06-21','16:50:00',1.7),('9650','2013-06-21','16:55:00',2.44),('9650','2013-06-21','17:00:00',3.13),('9650','2013-06-21','17:05:00',2.92),('9650','2013-06-21','17:10:00',4.25),('9650','2013-06-21','17:15:00',6.41),('9650','2013-06-21','17:20:00',6.1),('9650','2013-06-21','17:25:00',6.2),('9650','2013-06-21','17:30:00',4.93),('9650','2013-06-21','17:35:00',4.32),('9650','2013-06-21','17:40:00',5.11),('9650','2013-06-21','17:45:00',5.18),('9650','2013-06-21','17:50:00',4.78),('9650','2013-06-21','17:55:00',4.84),('9650','2013-06-21','18:00:00',4.57),('9650','2013-06-21','18:05:00',3.8),('9650','2013-06-21','18:10:00',2.53),('9650','2013-06-21','18:15:00',2.73),('9650','2013-06-21','18:20:00',2.76),('9650','2013-06-21','18:25:00',1.4),('9650','2013-06-21','18:30:00',1.06),('9650','2013-06-21','18:35:00',1.42),('9650','2013-06-21','18:40:00',1.45),('9650','2013-06-21','18:45:00',1.06),('9650','2013-06-21','18:55:00',1.31),('9650','2013-06-21','19:00:00',1.95),('9650','2013-06-21','19:05:00',1.19),('9650','2013-06-21','19:10:00',1.52),('9650','2013-06-21','19:15:00',2.52),('9650','2013-06-21','19:20:00',2.42),('9650','2013-06-21','19:25:00',2.27),('9650','2013-06-21','19:30:00',1.17),('9650','2013-06-21','19:35:00',1.16),('9650','2013-06-21','19:40:00',1.24),('9650','2013-06-20','07:50:00',1.02),('9650','2013-06-20','07:55:00',1.08),('9650','2013-06-20','08:00:00',1.13),('9650','2013-06-20','08:05:00',1.16),('9650','2013-06-20','08:10:00',1.19),('9650','2013-06-20','08:15:00',1.22),('9650','2013-06-20','08:20:00',1.28),('9650','2013-06-20','08:25:00',1.72),('9650','2013-06-20','08:30:00',1.83),('9650','2013-06-20','08:35:00',1.94),('9650','2013-06-20','08:40:00',2.05),('9650','2013-06-20','08:45:00',2.17),('9650','2013-06-20','08:50:00',2.27),('9650','2013-06-20','08:55:00',2.38),('9650','2013-06-20','09:00:00',2.46),('9650','2013-06-20','09:05:00',2.55),('9650','2013-06-20','09:10:00',2.66),('9650','2013-06-20','09:15:00',2.75),('9650','2013-06-20','09:20:00',2.85),('9650','2013-06-20','09:25:00',2.97),('9650','2013-06-20','09:30:00',3.08),('9650','2013-06-20','09:35:00',3.24),('9650','2013-06-20','09:40:00',3.37),('9650','2013-06-20','09:45:00',3.5),('9650','2013-06-20','09:50:00',3.62),('9650','2013-06-20','09:55:00',3.7),('9650','2013-06-20','10:00:00',3.72),('9650','2013-06-20','10:05:00',3.89),('9650','2013-06-20','10:10:00',4.05),('9650','2013-06-20','10:15:00',4.09),('9650','2013-06-20','10:20:00',4.14),('9650','2013-06-20','10:25:00',4.27),('9650','2013-06-20','10:30:00',4.34),('9650','2013-06-20','10:35:00',4.44),('9650','2013-06-20','10:40:00',4.51),('9650','2013-06-20','10:45:00',4.7),('9650','2013-06-20','10:50:00',4.75),('9650','2013-06-20','10:55:00',4.8),('9650','2013-06-20','11:00:00',4.93),('9650','2013-06-20','11:05:00',5.05),('9650','2013-06-20','11:10:00',5.13),('9650','2013-06-20','11:15:00',5.23),('9650','2013-06-20','11:20:00',5.33),('9650','2013-06-20','11:25:00',5.44),('9650','2013-06-20','11:30:00',5.42),('9650','2013-06-20','11:35:00',5.54),('9650','2013-06-20','11:40:00',5.57),('9650','2013-06-20','11:45:00',5.65),('9650','2013-06-20','11:50:00',5.76),('9650','2013-06-20','11:55:00',5.79),('9650','2013-06-20','12:00:00',5.86),('9650','2013-06-20','12:05:00',5.86),('9650','2013-06-20','12:10:00',5.94),('9650','2013-06-20','12:15:00',5.94),('9650','2013-06-20','12:20:00',5.98),('9650','2013-06-20','12:25:00',6.04),('9650','2013-06-20','12:30:00',6.11),('9650','2013-06-20','12:35:00',6.04),('9650','2013-06-20','12:40:00',6.17),('9650','2013-06-20','12:45:00',6.29),('9650','2013-06-20','12:50:00',6.32),('9650','2013-06-20','12:55:00',6.26),('9650','2013-06-20','13:00:00',6.3),('9650','2013-06-20','13:05:00',6.3),('9650','2013-06-20','13:10:00',6.29),('9650','2013-06-20','13:15:00',6.35),('9650','2013-06-20','13:20:00',6.54),('9650','2013-06-20','13:25:00',6.64),('9650','2013-06-20','13:30:00',6.74),('9650','2013-06-20','13:35:00',6.71),('9650','2013-06-20','13:40:00',6.69),('9650','2013-06-20','13:45:00',6.82),('9650','2013-06-20','13:50:00',6.78),('9650','2013-06-20','13:55:00',6.77),('9650','2013-06-20','14:00:00',6.89),('9650','2013-06-20','14:05:00',6.91),('9650','2013-06-20','14:10:00',6.93),('9650','2013-06-20','14:15:00',6.94),('9650','2013-06-20','14:20:00',6.98),('9650','2013-06-20','14:25:00',7.05),('9650','2013-06-20','14:30:00',7.09),('9650','2013-06-20','14:35:00',7.07),('9650','2013-06-20','14:40:00',7.07),('9650','2013-06-20','14:45:00',7.09),('9650','2013-06-20','14:50:00',7.08),('9650','2013-06-20','14:55:00',7.09),('9650','2013-06-20','15:00:00',7.06),('9650','2013-06-20','15:05:00',7.03),('9650','2013-06-20','15:10:00',7.02),('9650','2013-06-20','15:15:00',7.04),('9650','2013-06-20','15:20:00',7.02),('9650','2013-06-20','15:25:00',6.97),('9650','2013-06-20','15:30:00',6.98),('9650','2013-06-20','15:35:00',6.95),('9650','2013-06-20','15:40:00',6.91),('9650','2013-06-20','15:45:00',6.87),('9650','2013-06-20','15:50:00',6.81),('9650','2013-06-20','15:55:00',6.73),('9650','2013-06-20','16:00:00',6.67),('9650','2013-06-20','16:05:00',6.64),('9650','2013-06-20','16:10:00',6.6),('9650','2013-06-20','16:15:00',6.54),('9650','2013-06-20','16:20:00',6.5),('9650','2013-06-20','16:25:00',6.46),('9650','2013-06-20','16:30:00',6.38),('9650','2013-06-20','16:35:00',6.31),('9650','2013-06-20','16:40:00',6.22),('9650','2013-06-20','16:45:00',6.18),('9650','2013-06-20','16:50:00',6.16),('9650','2013-06-20','16:55:00',6.07),('9650','2013-06-20','17:00:00',6.01),('9650','2013-06-20','17:05:00',5.94),('9650','2013-06-20','17:10:00',5.78),('9650','2013-06-20','17:15:00',5.71),('9650','2013-06-20','17:20:00',5.6),('9650','2013-06-20','17:25:00',5.52),('9650','2013-06-20','17:30:00',5.41),('9650','2013-06-20','17:35:00',5.34),('9650','2013-06-20','17:40:00',5.25),('9650','2013-06-20','17:45:00',5.12),('9650','2013-06-20','17:50:00',5.02),('9650','2013-06-20','17:55:00',4.9),('9650','2013-06-20','18:00:00',4.81),('9650','2013-06-20','18:05:00',4.69),('9650','2013-06-20','18:10:00',4.55),('9650','2013-06-20','18:15:00',4.42),('9650','2013-06-20','18:20:00',4.27),('9650','2013-06-20','18:25:00',4.16),('9650','2013-06-20','18:30:00',4.01),('9650','2013-06-20','18:35:00',3.86),('9650','2013-06-20','18:40:00',3.68),('9650','2013-06-20','18:45:00',3.54),('9650','2013-06-20','18:50:00',3.39),('9650','2013-06-20','18:55:00',3.23),('9650','2013-06-20','19:00:00',3.08),('9650','2013-06-20','19:05:00',2.94),('9650','2013-06-20','19:10:00',2.73),('9650','2013-06-20','19:15:00',2.5),('9650','2013-06-20','19:20:00',2.33),('9650','2013-06-20','19:25:00',2.21),('9650','2013-06-20','19:30:00',2.01),('9650','2013-06-20','19:35:00',1.81),('9650','2013-06-20','19:40:00',1.59),('9650','2013-06-20','19:45:00',1.3),('9650','2013-06-20','19:50:00',1),('9650','2014-04-03','08:40:00',1.13),('9650','2014-04-03','08:45:00',1.18),('9650','2014-04-03','08:50:00',1.26),('9650','2014-04-03','08:55:00',1.28),('9650','2014-04-03','09:00:00',1.26),('9650','2014-04-03','09:05:00',1.78),('9650','2014-04-03','09:10:00',2.25),('9650','2014-04-03','09:15:00',2.13),('9650','2014-04-03','09:20:00',1.61),('9650','2014-04-03','09:25:00',1.32),('9650','2014-04-03','09:30:00',1.29),('9650','2014-04-03','09:35:00',1.31),('9650','2014-04-03','09:40:00',1.26),('9650','2014-04-03','09:45:00',1.21),('9650','2014-04-03','09:50:00',1.12),('9650','2014-04-03','11:20:00',1.14),('9650','2014-04-03','12:45:00',1),('9650','2014-04-03','12:50:00',1.08),('9650','2014-04-03','13:05:00',1.13),('9650','2014-04-03','13:10:00',2.01),('9650','2014-04-03','13:15:00',1.67),('9650','2014-04-03','13:20:00',3.14),('9650','2014-04-03','13:25:00',3.79),('9650','2014-04-03','13:30:00',3.54),('9650','2014-04-03','13:35:00',4.18),('9650','2014-04-03','13:40:00',7.09),('9650','2014-04-03','13:45:00',5.25),('9650','2014-04-03','13:50:00',7.15),('9650','2014-04-03','13:55:00',3.59),('9650','2014-04-03','14:00:00',4.68),('9650','2014-04-03','14:05:00',7.98),('9650','2014-04-03','14:10:00',6.75),('9650','2014-04-03','14:15:00',5.96),('9650','2014-04-03','14:20:00',5.13),('9650','2014-04-03','14:25:00',6.29),('9650','2014-04-03','14:30:00',2.26),('9650','2014-04-03','14:35:00',3.82),('9650','2014-04-03','14:40:00',2.44),('9650','2014-04-03','14:45:00',2.47),('9650','2014-04-03','14:50:00',5.68),('9650','2014-04-03','14:55:00',6.54),('9650','2014-04-03','15:00:00',6.98),('9650','2014-04-03','15:05:00',7.15),('9650','2014-04-03','15:10:00',5.82),('9650','2014-04-03','15:15:00',6.1),('9650','2014-04-03','15:20:00',3.91),('9650','2014-04-03','15:25:00',3.11),('9650','2014-04-03','15:30:00',2.5),('9650','2014-04-03','15:35:00',2.93),('9650','2014-04-03','15:40:00',4.29),('9650','2014-04-03','15:45:00',3.47),('9650','2014-04-03','15:50:00',3.01),('9650','2014-04-03','15:55:00',5.81),('9650','2014-04-03','16:00:00',4.88),('9650','2014-04-03','16:05:00',3.84),('9650','2014-04-03','16:10:00',6.22),('9650','2014-04-03','16:15:00',3.08),('9650','2014-04-03','16:20:00',2.14),('9650','2014-04-03','16:25:00',1.99),('9650','2014-04-03','16:30:00',3.99),('9650','2014-04-03','16:35:00',2.98),('9650','2014-04-03','16:40:00',2.65),('9650','2014-04-03','16:45:00',5.04),('9650','2014-04-03','16:50:00',5.36),('9650','2014-04-03','16:55:00',4.51),('9650','2014-04-03','17:00:00',3.88),('9650','2014-04-03','17:05:00',3.93),('9650','2014-04-03','17:10:00',4.18),('9650','2014-04-03','17:15:00',3.35),('9650','2014-04-03','17:20:00',4.35),('9650','2014-04-03','17:25:00',3.47),('9650','2014-04-03','17:30:00',4.4),('9650','2014-04-03','17:35:00',3.62),('9650','2014-04-03','17:40:00',3.9),('9650','2014-04-03','17:45:00',3.99),('9650','2014-04-03','17:50:00',3.85),('9650','2014-04-03','17:55:00',3.48),('9650','2014-04-03','18:00:00',3.29),('9650','2014-04-03','18:05:00',3.1),('9650','2014-04-03','18:10:00',2.95),('9650','2014-04-03','18:15:00',2.8),('9650','2014-04-03','18:20:00',2.52),('9650','2014-04-03','18:25:00',1.42),('9650','2014-04-03','18:30:00',2.33),('9650','2014-04-03','18:35:00',2.11),('9650','2014-04-03','18:40:00',1.58),('9650','2014-04-03','18:45:00',1.28),('9650','2014-04-03','18:50:00',1.37),('9650','2014-04-03','18:55:00',1.1),('9650','2013-06-19','07:55:00',1.01),('9650','2013-06-19','08:00:00',1.1),('9650','2013-06-19','08:05:00',1.19),('9650','2013-06-19','08:10:00',1.29),('9650','2013-06-19','08:15:00',1.39),('9650','2013-06-19','08:20:00',1.54),('9650','2013-06-19','08:25:00',1.7),('9650','2013-06-19','08:30:00',1.82),('9650','2013-06-19','08:35:00',1.93),('9650','2013-06-19','08:40:00',2.03),('9650','2013-06-19','08:45:00',2.14),('9650','2013-06-19','08:50:00',2.26),('9650','2013-06-19','08:55:00',2.36),('9650','2013-06-19','09:00:00',2.46),('9650','2013-06-19','09:05:00',2.58),('9650','2013-06-19','09:10:00',2.7),('9650','2013-06-19','09:15:00',2.81),('9650','2013-06-19','09:20:00',2.92),('9650','2013-06-19','09:25:00',3.04),('9650','2013-06-19','09:30:00',3.15),('9650','2013-06-19','09:35:00',3.32),('9650','2013-06-19','09:40:00',3.46),('9650','2013-06-19','09:45:00',3.58),('9650','2013-06-19','09:50:00',3.71),('9650','2013-06-19','09:55:00',3.81),('9650','2013-06-19','10:00:00',3.89),('9650','2013-06-19','10:05:00',3.97),('9650','2013-06-19','10:10:00',4.16),('9650','2013-06-19','10:15:00',4.19),('9650','2013-06-19','10:20:00',4.34),('9650','2013-06-19','10:25:00',4.45),('9650','2013-06-19','10:30:00',4.57),('9650','2013-06-19','10:35:00',4.68),('9650','2013-06-19','10:40:00',4.79),('9650','2013-06-19','10:45:00',4.84),('9650','2013-06-19','10:50:00',4.92),('9650','2013-06-19','10:55:00',5),('9650','2013-06-19','11:00:00',5.11),('9650','2013-06-19','11:05:00',5.21),('9650','2013-06-19','11:10:00',5.33),('9650','2013-06-19','11:15:00',5.34),('9650','2013-06-19','11:20:00',5.38),('9650','2013-06-19','11:25:00',5.37),('9650','2013-06-19','11:30:00',5.42),('9650','2013-06-19','11:35:00',5.6),('9650','2013-06-19','11:40:00',5.7),('9650','2013-06-19','11:45:00',5.71),('9650','2013-06-19','11:50:00',5.64),('9650','2013-06-19','11:55:00',5.72),('9650','2013-06-19','12:00:00',5.66),('9650','2013-06-19','12:05:00',5.81),('9650','2013-06-19','12:10:00',5.74),('9650','2013-06-19','12:15:00',5.75),('9650','2013-06-19','12:20:00',5.94),('9650','2013-06-19','12:25:00',5.61),('9650','2013-06-19','12:30:00',6.27),('9650','2013-06-19','12:35:00',6.4),('9650','2013-06-19','12:40:00',6.31),('9650','2013-06-19','12:45:00',6.33),('9650','2013-06-19','12:50:00',6.18),('9650','2013-06-19','12:55:00',5.82),('9650','2013-06-19','13:00:00',6.58),('9650','2013-06-19','13:05:00',6.68),('9650','2013-06-19','13:10:00',6.12),('9650','2013-06-19','13:15:00',4.63),('9650','2013-06-19','13:20:00',6.32),('9650','2013-06-19','13:25:00',6.48),('9650','2013-06-19','13:30:00',6.77),('9650','2013-06-19','13:35:00',6.87),('9650','2013-06-19','13:40:00',6.87),('9650','2013-06-19','13:45:00',6.93),('9650','2013-06-19','13:50:00',6.98),('9650','2013-06-19','13:55:00',6.9),('9650','2013-06-19','14:00:00',7.06),('9650','2013-06-19','14:05:00',7.14),('9650','2013-06-19','14:10:00',7.08),('9650','2013-06-19','14:15:00',7.18),('9650','2013-06-19','14:20:00',7.2),('9650','2013-06-19','14:25:00',7.22),('9650','2013-06-19','14:30:00',7.3),('9650','2013-06-19','14:35:00',7.33),('9650','2013-06-19','14:40:00',7.3),('9650','2013-06-19','14:45:00',7.36),('9650','2013-06-19','14:50:00',7.35),('9650','2013-06-19','14:55:00',7.3),('9650','2013-06-19','15:00:00',7.24),('9650','2013-06-19','15:05:00',7.24),('9650','2013-06-19','15:10:00',7.22),('9650','2013-06-19','15:15:00',7.21),('9650','2013-06-19','15:20:00',7.18),('9650','2013-06-19','15:25:00',7.15),('9650','2013-06-19','15:30:00',7.11),('9650','2013-06-19','15:35:00',7.07),('9650','2013-06-19','15:40:00',7.04),('9650','2013-06-19','15:45:00',6.96),('9650','2013-06-19','15:50:00',6.91),('9650','2013-06-19','15:55:00',6.81),('9650','2013-06-19','16:00:00',6.8),('9650','2013-06-19','16:05:00',6.77),('9650','2013-06-19','16:10:00',6.74),('9650','2013-06-19','16:15:00',6.69),('9650','2013-06-19','16:20:00',6.62),('9650','2013-06-19','16:25:00',6.57),('9650','2013-06-19','16:30:00',6.5),('9650','2013-06-19','16:35:00',6.41),('9650','2013-06-19','16:40:00',6.32),('9650','2013-06-19','16:45:00',6.26),('9650','2013-06-19','16:50:00',6.17),('9650','2013-06-19','16:55:00',6.09),('9650','2013-06-19','17:00:00',6),('9650','2013-06-19','17:05:00',5.95),('9650','2013-06-19','17:10:00',5.86),('9650','2013-06-19','17:15:00',5.73),('9650','2013-06-19','17:20:00',5.62),('9650','2013-06-19','17:25:00',5.5),('9650','2013-06-19','17:30:00',5.42),('9650','2013-06-19','17:35:00',5.36),('9650','2013-06-19','17:40:00',5.29),('9650','2013-06-19','17:45:00',5.17),('9650','2013-06-19','17:50:00',5.05),('9650','2013-06-19','17:55:00',4.98),('9650','2013-06-19','18:00:00',4.87),('9650','2013-06-19','18:05:00',4.73),('9650','2013-06-19','18:10:00',4.64),('9650','2013-06-19','18:15:00',4.54),('9650','2013-06-19','18:20:00',4.41),('9650','2013-06-19','18:25:00',4.28),('9650','2013-06-19','18:30:00',4.15),('9650','2013-06-19','18:35:00',4),('9650','2013-06-19','18:40:00',3.82),('9650','2013-06-19','18:45:00',3.63),('9650','2013-06-19','18:50:00',3.45),('9650','2013-06-19','18:55:00',3.29),('9650','2013-06-19','19:00:00',3.1),('9650','2013-06-19','19:05:00',2.93),('9650','2013-06-19','19:10:00',2.78),('9650','2013-06-19','19:15:00',2.63),('9650','2013-06-19','19:20:00',2.42),('9650','2013-06-19','19:25:00',2.2),('9650','2013-06-19','19:30:00',2.02),('9650','2013-06-19','19:35:00',1.86),('9650','2013-06-19','19:40:00',1.73),('9650','2013-06-19','19:45:00',1.57),('9650','2013-06-19','19:50:00',1.39),('9650','2013-06-19','19:55:00',1.21),('9650','2013-06-19','20:00:00',1.01),('9650','2013-06-18','07:55:00',1.05),('9650','2013-06-18','08:00:00',1.13),('9650','2013-06-18','08:05:00',1.21),('9650','2013-06-18','08:10:00',1.3),('9650','2013-06-18','08:15:00',1.39),('9650','2013-06-18','08:20:00',1.54),('9650','2013-06-18','08:25:00',1.68),('9650','2013-06-18','08:30:00',1.79),('9650','2013-06-18','08:35:00',1.9),('9650','2013-06-18','08:40:00',2.01),('9650','2013-06-18','08:45:00',2.11),('9650','2013-06-18','08:50:00',2.22),('9650','2013-06-18','08:55:00',2.33),('9650','2013-06-18','09:00:00',2.44),('9650','2013-06-18','09:05:00',2.55),('9650','2013-06-18','09:10:00',2.66),('9650','2013-06-18','09:15:00',2.78),('9650','2013-06-18','09:20:00',2.91),('9650','2013-06-18','09:25:00',3.01),('9650','2013-06-18','09:30:00',3.15),('9650','2013-06-18','09:35:00',3.31),('9650','2013-06-18','09:40:00',3.44),('9650','2013-06-18','09:45:00',3.54),('9650','2013-06-18','09:50:00',3.65),('9650','2013-06-18','09:55:00',3.75),('9650','2013-06-18','10:00:00',3.85),('9650','2013-06-18','10:05:00',3.93),('9650','2013-06-18','10:10:00',4.08),('9650','2013-06-18','10:15:00',4.13),('9650','2013-06-18','10:20:00',4.23),('9650','2013-06-18','10:25:00',4.37),('9650','2013-06-18','10:30:00',4.45),('9650','2013-06-18','10:35:00',4.5),('9650','2013-06-18','10:40:00',4.6),('9650','2013-06-18','10:45:00',4.73),('9650','2013-06-18','10:50:00',4.8),('9650','2013-06-18','10:55:00',4.88),('9650','2013-06-18','11:00:00',4.94),('9650','2013-06-18','11:05:00',5.05),('9650','2013-06-18','11:10:00',5.13),('9650','2013-06-18','11:15:00',5.16),('9650','2013-06-18','11:20:00',5.2),('9650','2013-06-18','11:25:00',5.32),('9650','2013-06-18','11:30:00',5.36),('9650','2013-06-18','11:35:00',5.49),('9650','2013-06-18','11:40:00',5.47),('9650','2013-06-18','11:45:00',5.56),('9650','2013-06-18','11:50:00',5.6),('9650','2013-06-18','11:55:00',5.67),('9650','2013-06-18','12:00:00',5.81),('9650','2013-06-18','12:05:00',5.94),('9650','2013-06-18','12:10:00',5.87),('9650','2013-06-18','12:15:00',5.96),('9650','2013-06-18','12:20:00',6),('9650','2013-06-18','12:25:00',5.97),('9650','2013-06-18','12:30:00',6.07),('9650','2013-06-18','12:35:00',6.24),('9650','2013-06-18','12:40:00',6.29),('9650','2013-06-18','12:45:00',6.28),('9650','2013-06-18','12:50:00',6.39),('9650','2013-06-18','12:55:00',6.42),('9650','2013-06-18','13:00:00',6.48),('9650','2013-06-18','13:05:00',6.56),('9650','2013-06-18','13:10:00',6.56),('9650','2013-06-18','13:15:00',6.51),('9650','2013-06-18','13:20:00',6.65),('9650','2013-06-18','13:25:00',6.75),('9650','2013-06-18','13:30:00',6.71),('9650','2013-06-18','13:35:00',6.77),('9650','2013-06-18','13:40:00',6.78),('9650','2013-06-18','13:45:00',6.8),('9650','2013-06-18','13:50:00',6.85),('9650','2013-06-18','13:55:00',6.91),('9650','2013-06-18','14:00:00',6.95),('9650','2013-06-18','14:05:00',7.01),('9650','2013-06-18','14:10:00',6.99),('9650','2013-06-18','14:15:00',6.92),('9650','2013-06-18','14:20:00',6.93),('9650','2013-06-18','14:25:00',6.96),('9650','2013-06-18','14:30:00',6.91),('9650','2013-06-18','14:35:00',6.93),('9650','2013-06-18','14:40:00',6.87),('9650','2013-06-18','14:45:00',6.86),('9650','2013-06-18','14:50:00',6.85),('9650','2013-06-18','14:55:00',6.87),('9650','2013-06-18','15:00:00',6.87),('9650','2013-06-18','15:05:00',6.84),('9650','2013-06-18','15:10:00',6.82),('9650','2013-06-18','15:15:00',6.79),('9650','2013-06-18','15:20:00',6.82),('9650','2013-06-18','15:25:00',6.84),('9650','2013-06-18','15:30:00',6.79),('9650','2013-06-18','15:35:00',6.75),('9650','2013-06-18','15:40:00',6.7),('9650','2013-06-18','15:45:00',6.65),('9650','2013-06-18','15:50:00',6.56),('9650','2013-06-18','15:55:00',6.45),('9650','2013-06-18','16:00:00',6.42),('9650','2013-06-18','16:05:00',6.37),('9650','2013-06-18','16:10:00',6.33),('9650','2013-06-18','16:15:00',6.27),('9650','2013-06-18','16:20:00',6.23),('9650','2013-06-18','16:25:00',6.19),('9650','2013-06-18','16:30:00',6.13),('9650','2013-06-18','16:35:00',6.07),('9650','2013-06-18','16:40:00',6),('9650','2013-06-18','16:45:00',5.96),('9650','2013-06-18','16:50:00',5.93),('9650','2013-06-18','16:55:00',5.87),('9650','2013-06-18','17:00:00',5.81),('9650','2013-06-18','17:05:00',5.69),('9650','2013-06-18','17:10:00',5.59),('9650','2013-06-18','17:15:00',5.23),('9650','2013-06-18','17:20:00',5.54),('9650','2013-06-18','17:25:00',5.48),('9650','2013-06-18','17:30:00',5.38),('9650','2013-06-18','17:35:00',5.27),('9650','2013-06-18','17:40:00',5.18),('9650','2013-06-18','17:45:00',5.08),('9650','2013-06-18','17:50:00',4.92),('9650','2013-06-18','17:55:00',4.84),('9650','2013-06-18','18:00:00',4.74),('9650','2013-06-18','18:05:00',4.57),('9650','2013-06-18','18:10:00',4.4),('9650','2013-06-18','18:15:00',4.23),('9650','2013-06-18','18:20:00',4.11),('9650','2013-06-18','18:25:00',4),('9650','2013-06-18','18:30:00',3.8),('9650','2013-06-18','18:35:00',3.56),('9650','2013-06-18','18:40:00',3.17),('9650','2013-06-18','18:45:00',3.11),('9650','2013-06-18','18:50:00',3.05),('9650','2013-06-18','18:55:00',3.01),('9650','2013-06-18','19:00:00',2.91),('9650','2013-06-18','19:05:00',2.79),('9650','2013-06-18','19:10:00',2.65),('9650','2013-06-18','19:15:00',2.48),('9650','2013-06-18','19:20:00',2.36),('9650','2013-06-18','19:25:00',2.15),('9650','2013-06-18','19:30:00',1.93),('9650','2013-06-18','19:35:00',1.79),('9650','2013-06-18','19:40:00',1.61),('9650','2013-06-18','19:45:00',1.42),('9650','2013-06-18','19:50:00',1.19),('9650','2013-06-18','19:55:00',1.02),('9650','2013-06-17','07:55:00',1.04),('9650','2013-06-17','08:00:00',1.09),('9650','2013-06-17','08:05:00',1.12),('9650','2013-06-17','08:20:00',1.2),('9650','2013-06-17','08:25:00',1.23),('9650','2013-06-17','08:30:00',1.24),('9650','2013-06-17','08:35:00',1.25),('9650','2013-06-17','08:40:00',1.79),('9650','2013-06-17','08:45:00',2.1),('9650','2013-06-17','08:50:00',2.22),('9650','2013-06-17','08:55:00',2.32),('9650','2013-06-17','09:00:00',2.41),('9650','2013-06-17','09:05:00',2.52),('9650','2013-06-17','09:10:00',2.61),('9650','2013-06-17','09:15:00',2.73),('9650','2013-06-17','09:20:00',2.83),('9650','2013-06-17','09:25:00',2.96),('9650','2013-06-17','09:30:00',3.1),('9650','2013-06-17','09:35:00',3.28),('9650','2013-06-17','09:40:00',3.41),('9650','2013-06-17','09:45:00',3.51),('9650','2013-06-17','09:50:00',1.39),('9650','2013-06-17','09:55:00',2.64),('9650','2013-06-17','10:00:00',3.78),('9650','2013-06-17','10:05:00',3.89),('9650','2013-06-17','10:10:00',3.97),('9650','2013-06-17','10:15:00',4.07),('9650','2013-06-17','10:20:00',4.25),('9650','2013-06-17','10:25:00',4.32),('9650','2013-06-17','10:30:00',4.37),('9650','2013-06-17','10:35:00',4.49),('9650','2013-06-17','10:40:00',4.61),('9650','2013-06-17','10:45:00',4.7),('9650','2013-06-17','10:50:00',4.79),('9650','2013-06-17','10:55:00',4.89),('9650','2013-06-17','11:00:00',5.02),('9650','2013-06-17','11:05:00',5.08),('9650','2013-06-17','11:10:00',5.12),('9650','2013-06-17','11:15:00',5.2),('9650','2013-06-17','11:20:00',5.32),('9650','2013-06-17','11:25:00',5.3),('9650','2013-06-17','11:30:00',5.39),('9650','2013-06-17','11:35:00',5.45),('9650','2013-06-17','11:40:00',5.47),('9650','2013-06-17','11:45:00',5.53),('9650','2013-06-17','11:50:00',5.42),('9650','2013-06-17','11:55:00',5.61),('9650','2013-06-17','12:00:00',5.64),('9650','2013-06-17','12:05:00',5.65),('9650','2013-06-17','12:10:00',5.69),('9650','2013-06-17','12:15:00',5.62),('9650','2013-06-17','12:20:00',5.62),('9650','2013-06-17','12:25:00',5.73),('9650','2013-06-17','12:30:00',5.83),('9650','2013-06-17','12:35:00',5.93),('9650','2013-06-17','12:40:00',5.55),('9650','2013-06-17','12:45:00',2.46),('9650','2013-06-17','12:50:00',1.76),('9650','2013-06-17','12:55:00',6.63),('9650','2013-06-17','13:00:00',6.58),('9650','2013-06-17','13:05:00',2.91),('9650','2013-06-17','13:10:00',6.11),('9650','2013-06-17','13:15:00',6.7),('9650','2013-06-17','13:20:00',6.66),('9650','2013-06-17','13:25:00',5.32),('9650','2013-06-17','13:30:00',3.36),('9650','2013-06-17','13:35:00',6.69),('9650','2013-06-17','13:40:00',5.8),('9650','2013-06-17','13:45:00',5.02),('9650','2013-06-17','13:50:00',6.2),('9650','2013-06-17','13:55:00',7.25),('9650','2013-06-17','14:00:00',6.96),('9650','2013-06-17','14:05:00',6.99),('9650','2013-06-17','14:10:00',6.98),('9650','2013-06-17','14:15:00',7.12),('9650','2013-06-17','14:20:00',7.09),('9650','2013-06-17','14:25:00',7.04),('9650','2013-06-17','14:30:00',6.98),('9650','2013-06-17','14:35:00',7.19),('9650','2013-06-17','14:40:00',7.27),('9650','2013-06-17','14:45:00',7.31),('9650','2013-06-17','14:50:00',7.19),('9650','2013-06-17','14:55:00',7.19),('9650','2013-06-17','15:00:00',7.18),('9650','2013-06-17','15:05:00',7.09),('9650','2013-06-17','15:10:00',7.03),('9650','2013-06-17','15:15:00',6.92),('9650','2013-06-17','15:20:00',6.87),('9650','2013-06-17','15:25:00',6.87),('9650','2013-06-17','15:30:00',6.78),('9650','2013-06-17','15:35:00',6.81),('9650','2013-06-17','15:40:00',6.88),('9650','2013-06-17','15:45:00',6.83),('9650','2013-06-17','15:50:00',6.76),('9650','2013-06-17','15:55:00',6.72),('9650','2013-06-17','16:00:00',6.77),('9650','2013-06-17','16:05:00',6.75),('9650','2013-06-17','16:10:00',6.72),('9650','2013-06-17','16:15:00',6.69),('9650','2013-06-17','16:20:00',6.7),('9650','2013-06-17','16:25:00',6.52),('9650','2013-06-17','16:30:00',6.41),('9650','2013-06-17','16:35:00',6.08),('9650','2013-06-17','16:40:00',6.25),('9650','2013-06-17','16:45:00',6.07),('9650','2013-06-17','16:50:00',5.99),('9650','2013-06-17','16:55:00',5.91),('9650','2013-06-17','17:00:00',5.87),('9650','2013-06-17','17:05:00',5.77),('9650','2013-06-17','17:10:00',5.65),('9650','2013-06-17','17:15:00',5.56),('9650','2013-06-17','17:20:00',5.51),('9650','2013-06-17','17:25:00',5.42),('9650','2013-06-17','17:30:00',5.32),('9650','2013-06-17','17:35:00',5.19),('9650','2013-06-17','17:40:00',5.1),('9650','2013-06-17','17:45:00',5),('9650','2013-06-17','17:50:00',4.9),('9650','2013-06-17','17:55:00',4.8),('9650','2013-06-17','18:00:00',4.64),('9650','2013-06-17','18:05:00',4.51),('9650','2013-06-17','18:10:00',4.41),('9650','2013-06-17','18:15:00',4.29),('9650','2013-06-17','18:20:00',4.21),('9650','2013-06-17','18:25:00',4.07),('9650','2013-06-17','18:30:00',3.91),('9650','2013-06-17','18:35:00',3.79),('9650','2013-06-17','18:40:00',3.6),('9650','2013-06-17','18:45:00',3.49),('9650','2013-06-17','18:50:00',3.32),('9650','2013-06-17','18:55:00',3.14),('9650','2013-06-17','19:00:00',2.99),('9650','2013-06-17','19:05:00',2.83),('9650','2013-06-17','19:10:00',2.73),('9650','2013-06-17','19:15:00',2.54),('9650','2013-06-17','19:20:00',2.38),('9650','2013-06-17','19:25:00',2.21),('9650','2013-06-17','19:30:00',2.03),('9650','2013-06-17','19:35:00',1.85),('9650','2013-06-17','19:40:00',1.67),('9650','2013-06-17','19:45:00',1.49),('9650','2013-06-17','19:50:00',1.32),('9650','2013-06-17','19:55:00',1.16),('9650','2013-06-16','07:55:00',1.03),('9650','2013-06-16','08:00:00',1.13),('9650','2013-06-16','08:05:00',1.22),('9650','2013-06-16','08:10:00',1.31),('9650','2013-06-16','08:15:00',1.41),('9650','2013-06-16','08:20:00',1.57),('9650','2013-06-16','08:25:00',1.73),('9650','2013-06-16','08:30:00',1.84),('9650','2013-06-16','08:35:00',1.96),('9650','2013-06-16','08:40:00',2.05),('9650','2013-06-16','08:45:00',2.18),('9650','2013-06-16','08:50:00',2.28),('9650','2013-06-16','08:55:00',2.39),('9650','2013-06-16','09:00:00',2.51),('9650','2013-06-16','09:05:00',2.63),('9650','2013-06-16','09:10:00',2.74),('9650','2013-06-16','09:15:00',2.89),('9650','2013-06-16','09:20:00',3),('9650','2013-06-16','09:25:00',3.12),('9650','2013-06-16','09:30:00',3.26),('9650','2013-06-16','09:35:00',3.43),('9650','2013-06-16','09:40:00',3.56),('9650','2013-06-16','09:45:00',3.68),('9650','2013-06-16','09:50:00',3.79),('9650','2013-06-16','09:55:00',3.88),('9650','2013-06-16','10:00:00',3.97),('9650','2013-06-16','10:05:00',4.07),('9650','2013-06-16','10:10:00',4.21),('9650','2013-06-16','10:15:00',4.22),('9650','2013-06-16','10:20:00',4.34),('9650','2013-06-16','10:25:00',4.48),('9650','2013-06-16','10:30:00',4.57),('9650','2013-06-16','10:35:00',4.65),('9650','2013-06-16','10:40:00',4.76),('9650','2013-06-16','10:45:00',4.87),('9650','2013-06-16','10:50:00',4.98),('9650','2013-06-16','10:55:00',5.08),('9650','2013-06-16','11:00:00',5.14),('9650','2013-06-16','11:05:00',5.24),('9650','2013-06-16','11:10:00',5.29),('9650','2013-06-16','11:15:00',5.4),('9650','2013-06-16','11:20:00',5.46),('9650','2013-06-16','11:25:00',5.53),('9650','2013-06-16','11:30:00',5.57),('9650','2013-06-16','11:35:00',5.65),('9650','2013-06-16','11:40:00',5.73),('9650','2013-06-16','11:45:00',5.72),('9650','2013-06-16','11:50:00',5.76),('9650','2013-06-16','11:55:00',5.81),('9650','2013-06-16','12:00:00',5.85),('9650','2013-06-16','12:05:00',5.9),('9650','2013-06-16','12:10:00',5.97),('9650','2013-06-16','12:15:00',6.06),('9650','2013-06-16','12:20:00',6.12),('9650','2013-06-16','12:25:00',6.18),('9650','2013-06-16','12:30:00',6.12),('9650','2013-06-16','12:35:00',6.25),('9650','2013-06-16','12:40:00',6.28),('9650','2013-06-16','12:45:00',6.38),('9650','2013-06-16','12:50:00',6.44),('9650','2013-06-16','12:55:00',6.59),('9650','2013-06-16','13:00:00',6.73),('9650','2013-06-16','13:05:00',6.69),('9650','2013-06-16','13:10:00',6.66),('9650','2013-06-16','13:15:00',6.7),('9650','2013-06-16','13:20:00',6.75),('9650','2013-06-16','13:25:00',6.83),('9650','2013-06-16','13:30:00',6.82),('9650','2013-06-16','13:35:00',6.87),('9650','2013-06-16','13:40:00',6.87),('9650','2013-06-16','13:45:00',6.9),('9650','2013-06-16','13:50:00',6.93),('9650','2013-06-16','13:55:00',6.94),('9650','2013-06-16','14:00:00',6.93),('9650','2013-06-16','14:05:00',6.96),('9650','2013-06-16','14:10:00',6.99),('9650','2013-06-16','14:15:00',6.99),('9650','2013-06-16','14:20:00',7.03),('9650','2013-06-16','14:25:00',7.03),('9650','2013-06-16','14:30:00',6.99),('9650','2013-06-16','14:35:00',6.99),('9650','2013-06-16','14:40:00',7.01),('9650','2013-06-16','14:45:00',7.01),('9650','2013-06-16','14:50:00',7),('9650','2013-06-16','14:55:00',6.98),('9650','2013-06-16','15:00:00',6.97),('9650','2013-06-16','15:05:00',6.95),('9650','2013-06-16','15:10:00',6.93),('9650','2013-06-16','15:15:00',6.93),('9650','2013-06-16','15:20:00',6.94),('9650','2013-06-16','15:25:00',6.89),('9650','2013-06-16','15:30:00',6.83),('9650','2013-06-16','15:35:00',6.82),('9650','2013-06-16','15:40:00',6.79),('9650','2013-06-16','15:45:00',6.71),('9650','2013-06-16','15:50:00',6.62),('9650','2013-06-16','15:55:00',6.56),('9650','2013-06-16','16:00:00',6.56),('9650','2013-06-16','16:05:00',6.53),('9650','2013-06-16','16:10:00',6.48),('9650','2013-06-16','16:15:00',6.45),('9650','2013-06-16','16:20:00',6.41),('9650','2013-06-16','16:25:00',6.33),('9650','2013-06-16','16:30:00',6.25),('9650','2013-06-16','16:35:00',6.17),('9650','2013-06-16','16:40:00',6.13),('9650','2013-06-16','16:45:00',6.03),('9650','2013-06-16','16:50:00',6.01),('9650','2013-06-16','16:55:00',5.92),('9650','2013-06-16','17:00:00',5.86),('9650','2013-06-16','17:05:00',5.78),('9650','2013-06-16','17:10:00',5.68),('9650','2013-06-16','17:15:00',5.59),('9650','2013-06-16','17:20:00',5.53),('9650','2013-06-16','17:25:00',5.45),('9650','2013-06-16','17:30:00',5.39),('9650','2013-06-16','17:35:00',5.29),('9650','2013-06-16','17:40:00',5.19),('9650','2013-06-16','17:45:00',5.06),('9650','2013-06-16','17:50:00',4.96),('9650','2013-06-16','17:55:00',4.87),('9650','2013-06-16','18:00:00',4.74),('9650','2013-06-16','18:05:00',4.62),('9650','2013-06-16','18:10:00',4.51),('9650','2013-06-16','18:15:00',4.33),('9650','2013-06-16','18:20:00',4.24),('9650','2013-06-16','18:25:00',3.88),('9650','2013-06-16','18:30:00',3.95),('9650','2013-06-16','18:35:00',3.47),('9650','2013-06-16','18:40:00',3.57),('9650','2013-06-16','18:45:00',3.65),('9650','2013-06-16','18:50:00',3.54),('9650','2013-06-16','18:55:00',3.45),('9650','2013-06-16','19:00:00',3.3),('9650','2013-06-16','19:05:00',3.13),('9650','2013-06-16','19:10:00',2.94),('9650','2013-06-16','19:15:00',2.74),('9650','2013-06-16','19:20:00',2.52),('9650','2013-06-16','19:25:00',2.38),('9650','2013-06-16','19:30:00',2.2),('9650','2013-06-16','19:35:00',1.99),('9650','2013-06-16','19:40:00',1.84),('9650','2013-06-16','19:45:00',1.64),('9650','2013-06-16','19:50:00',1.43),('9650','2013-06-16','19:55:00',1.23),('9650','2013-06-16','20:00:00',1.06),('9650','2013-06-15','07:55:00',1.06),('9650','2013-06-15','08:00:00',1.14),('9650','2013-06-15','08:05:00',1.23),('9650','2013-06-15','08:10:00',1.32),('9650','2013-06-15','08:15:00',1.43),('9650','2013-06-15','08:20:00',1.57),('9650','2013-06-15','08:25:00',1.75),('9650','2013-06-15','08:30:00',1.87),('9650','2013-06-15','08:35:00',1.97),('9650','2013-06-15','08:40:00',2.1),('9650','2013-06-15','08:45:00',2.23),('9650','2013-06-15','08:50:00',2.34),('9650','2013-06-15','08:55:00',2.43),('9650','2013-06-15','09:00:00',2.54),('9650','2013-06-15','09:05:00',2.69),('9650','2013-06-15','09:10:00',2.8),('9650','2013-06-15','09:15:00',2.93),('9650','2013-06-15','09:20:00',3.06),('9650','2013-06-15','09:25:00',3.19),('9650','2013-06-15','09:30:00',3.31),('9650','2013-06-15','09:35:00',3.48),('9650','2013-06-15','09:40:00',3.62),('9650','2013-06-15','09:45:00',3.73),('9650','2013-06-15','09:50:00',3.81),('9650','2013-06-15','09:55:00',3.89),('9650','2013-06-15','10:00:00',3.97),('9650','2013-06-15','10:05:00',4.12),('9650','2013-06-15','10:10:00',4.27),('9650','2013-06-15','10:15:00',4.3),('9650','2013-06-15','10:20:00',4.43),('9650','2013-06-15','10:25:00',4.56),('9650','2013-06-15','10:30:00',4.62),('9650','2013-06-15','10:35:00',4.71),('9650','2013-06-15','10:40:00',4.85),('9650','2013-06-15','10:45:00',4.99),('9650','2013-06-15','10:50:00',5.07),('9650','2013-06-15','10:55:00',5.18),('9650','2013-06-15','11:00:00',5.28),('9650','2013-06-15','11:05:00',5.34),('9650','2013-06-15','11:10:00',5.45),('9650','2013-06-15','11:15:00',5.56),('9650','2013-06-15','11:20:00',5.64),('9650','2013-06-15','11:25:00',5.74),('9650','2013-06-15','11:30:00',5.81),('9650','2013-06-15','11:35:00',5.88),('9650','2013-06-15','11:40:00',5.95),('9650','2013-06-15','11:45:00',6.01),('9650','2013-06-15','11:50:00',6.12),('9650','2013-06-15','11:55:00',6.19),('9650','2013-06-15','12:00:00',6.2),('9650','2013-06-15','12:05:00',6.29),('9650','2013-06-15','12:10:00',6.32),('9650','2013-06-15','12:15:00',6.4),('9650','2013-06-15','12:20:00',6.46),('9650','2013-06-15','12:25:00',6.49),('9650','2013-06-15','12:30:00',6.51),('9650','2013-06-15','12:35:00',6.58),('9650','2013-06-15','12:40:00',6.59),('9650','2013-06-15','12:45:00',6.66),('9650','2013-06-15','12:50:00',6.65),('9650','2013-06-15','12:55:00',6.73),('9650','2013-06-15','13:00:00',6.81),('9650','2013-06-15','13:05:00',6.93),('9650','2013-06-15','13:10:00',7.02),('9650','2013-06-15','13:15:00',7.03),('9650','2013-06-15','13:20:00',7.01),('9650','2013-06-15','13:25:00',7.08),('9650','2013-06-15','13:30:00',7.07),('9650','2013-06-15','13:35:00',7.19),('9650','2013-06-15','13:40:00',7.2),('9650','2013-06-15','13:45:00',7.06),('9650','2013-06-15','13:50:00',7.28),('9650','2013-06-15','13:55:00',7.19),('9650','2013-06-15','14:00:00',7.23),('9650','2013-06-15','14:05:00',7.21),('9650','2013-06-15','14:10:00',7.24),('9650','2013-06-15','14:15:00',7.28),('9650','2013-06-15','14:20:00',7.34),('9650','2013-06-15','14:25:00',7.3),('9650','2013-06-15','14:30:00',7.28),('9650','2013-06-15','14:35:00',7.3),('9650','2013-06-15','14:40:00',7.29),('9650','2013-06-15','14:45:00',7.22),('9650','2013-06-15','14:50:00',7.21),('9650','2013-06-15','14:55:00',7.2),('9650','2013-06-15','15:00:00',7.22),('9650','2013-06-15','15:05:00',7.25),('9650','2013-06-15','15:10:00',7.15),('9650','2013-06-15','15:15:00',7.15),('9650','2013-06-15','15:20:00',7.12),('9650','2013-06-15','15:25:00',7.11),('9650','2013-06-15','15:30:00',7.11),('9650','2013-06-15','15:35:00',7.09),('9650','2013-06-15','15:40:00',6.89),('9650','2013-06-15','15:45:00',6.98),('9650','2013-06-15','15:50:00',6.91),('9650','2013-06-15','15:55:00',6.82),('9650','2013-06-15','16:00:00',6.76),('9650','2013-06-15','16:05:00',6.72),('9650','2013-06-15','16:10:00',6.68),('9650','2013-06-15','16:15:00',6.63),('9650','2013-06-15','16:20:00',6.56),('9650','2013-06-15','16:25:00',6.52),('9650','2013-06-15','16:30:00',6.46),('9650','2013-06-15','16:35:00',6.37),('9650','2013-06-15','16:40:00',6.31),('9650','2013-06-15','16:45:00',6.24),('9650','2013-06-15','16:50:00',6.14),('9650','2013-06-15','16:55:00',6.05),('9650','2013-06-15','17:00:00',6.03),('9650','2013-06-15','17:05:00',5.93),('9650','2013-06-15','17:10:00',5.8),('9650','2013-06-15','17:15:00',5.7),('9650','2013-06-15','17:20:00',5.6),('9650','2013-06-15','17:25:00',5.49),('9650','2013-06-15','17:30:00',5.41),('9650','2013-06-15','17:35:00',5.34),('9650','2013-06-15','17:40:00',5.19),('9650','2013-06-15','17:45:00',5.06),('9650','2013-06-15','17:50:00',4.95),('9650','2013-06-15','17:55:00',4.81),('9650','2013-06-15','18:00:00',4.73),('9650','2013-06-15','18:05:00',4.61),('9650','2013-06-15','18:10:00',4.5),('9650','2013-06-15','18:15:00',4.36),('9650','2013-06-15','18:20:00',4.21),('9650','2013-06-15','18:25:00',4.12),('9650','2013-06-15','18:30:00',3.98),('9650','2013-06-15','18:35:00',3.83),('9650','2013-06-15','18:40:00',3.7),('9650','2013-06-15','18:45:00',3.58),('9650','2013-06-15','18:50:00',3.41),('9650','2013-06-15','18:55:00',3.26),('9650','2013-06-15','19:00:00',3.12),('9650','2013-06-15','19:05:00',2.96),('9650','2013-06-15','19:10:00',2.8),('9650','2013-06-15','19:15:00',2.63),('9650','2013-06-15','19:20:00',2.45),('9650','2013-06-15','19:25:00',2.26),('9650','2013-06-15','19:30:00',2.07),('9650','2013-06-15','19:35:00',1.89),('9650','2013-06-15','19:40:00',1.71),('9650','2013-06-15','19:45:00',1.55),('9650','2013-06-15','19:50:00',1.34),('9650','2013-06-15','19:55:00',1.15),('9650','2013-06-14','07:50:00',1.06),('9650','2013-06-14','07:55:00',1.12),('9650','2013-06-14','08:00:00',1.15),('9650','2013-06-14','08:05:00',1.19),('9650','2013-06-14','08:10:00',1.22),('9650','2013-06-14','08:15:00',1.25),('9650','2013-06-14','08:20:00',1.28),('9650','2013-06-14','08:25:00',1.44),('9650','2013-06-14','08:30:00',1.95),('9650','2013-06-14','08:35:00',2.05),('9650','2013-06-14','08:40:00',2.08),('9650','2013-06-14','08:45:00',1.56),('9650','2013-06-14','08:50:00',2.15),('9650','2013-06-14','08:55:00',2.51),('9650','2013-06-14','09:00:00',2.61),('9650','2013-06-14','09:05:00',2.46),('9650','2013-06-14','09:10:00',2.7),('9650','2013-06-14','09:15:00',2.91),('9650','2013-06-14','09:25:00',2.88),('9650','2013-06-14','09:30:00',3.02),('9650','2013-06-14','09:35:00',3.19),('9650','2013-06-14','09:40:00',3.8),('9650','2013-06-14','09:45:00',3.69),('9650','2013-06-14','09:50:00',3.8),('9650','2013-06-14','09:55:00',3.62),('9650','2013-06-14','10:00:00',3.52),('9650','2013-06-14','10:05:00',4.22),('9650','2013-06-14','10:10:00',3.79),('9650','2013-06-14','10:15:00',4.05),('9650','2013-06-14','10:20:00',4.14),('9650','2013-06-14','10:25:00',4.18),('9650','2013-06-14','10:30:00',4.03),('9650','2013-06-14','10:35:00',4.65),('9650','2013-06-14','10:40:00',4.11),('9650','2013-06-14','10:45:00',5.1),('9650','2013-06-14','10:50:00',3.93),('9650','2013-06-14','10:55:00',3.59),('9650','2013-06-14','11:00:00',3.17),('9650','2013-06-14','11:05:00',3.32),('9650','2013-06-14','11:10:00',5.16),('9650','2013-06-14','11:15:00',4.72),('9650','2013-06-14','11:20:00',3),('9650','2013-06-14','11:25:00',3.47),('9650','2013-06-14','11:30:00',6.48),('9650','2013-06-14','11:35:00',6.2),('9650','2013-06-14','11:40:00',6.3),('9650','2013-06-14','11:45:00',4.56),('9650','2013-06-14','11:50:00',6.17),('9650','2013-06-14','11:55:00',6.42),('9650','2013-06-14','12:00:00',6.52),('9650','2013-06-14','12:05:00',6.45),('9650','2013-06-14','12:10:00',6.55),('9650','2013-06-14','12:15:00',6.61),('9650','2013-06-14','12:20:00',6.6),('9650','2013-06-14','12:25:00',6.62),('9650','2013-06-14','12:30:00',6.59),('9650','2013-06-14','12:35:00',6.7),('9650','2013-06-14','12:40:00',6.79),('9650','2013-06-14','12:45:00',6.79),('9650','2013-06-14','12:50:00',6.83),('9650','2013-06-14','12:55:00',6.91),('9650','2013-06-14','13:00:00',6.95),('9650','2013-06-14','13:05:00',6.97),('9650','2013-06-14','13:10:00',6.98),('9650','2013-06-14','13:15:00',7.09),('9650','2013-06-14','13:20:00',7.07),('9650','2013-06-14','13:25:00',7.08),('9650','2013-06-14','13:30:00',7.09),('9650','2013-06-14','13:35:00',7.11),('9650','2013-06-14','13:40:00',7.15),('9650','2013-06-14','13:45:00',7.17),('9650','2013-06-14','13:50:00',7.17),('9650','2013-06-14','13:55:00',7.2),('9650','2013-06-14','14:00:00',7.19),('9650','2013-06-14','14:05:00',7.2),('9650','2013-06-14','14:10:00',7.2),('9650','2013-06-14','14:15:00',7.22),('9650','2013-06-14','14:20:00',7.25),('9650','2013-06-14','14:25:00',7.21),('9650','2013-06-14','14:30:00',7.11),('9650','2013-06-14','14:35:00',7.03),('9650','2013-06-14','14:40:00',7.2),('9650','2013-06-14','14:45:00',7.12),('9650','2013-06-14','14:50:00',7.05),('9650','2013-06-14','14:55:00',7.11),('9650','2013-06-14','15:00:00',7.03),('9650','2013-06-14','15:05:00',7.06),('9650','2013-06-14','15:10:00',7.08),('9650','2013-06-14','15:15:00',7.08),('9650','2013-06-14','15:20:00',7.11),('9650','2013-06-14','15:25:00',7.09),('9650','2013-06-14','15:30:00',7.11),('9650','2013-06-14','15:35:00',7.06),('9650','2013-06-14','15:40:00',7),('9650','2013-06-14','15:45:00',6.93),('9650','2013-06-14','15:50:00',6.87),('9650','2013-06-14','15:55:00',6.83),('9650','2013-06-14','16:00:00',6.77),('9650','2013-06-14','16:05:00',6.72),('9650','2013-06-14','16:10:00',6.68),('9650','2013-06-14','16:15:00',6.61),('9650','2013-06-14','16:20:00',6.52),('9650','2013-06-14','16:25:00',6.46),('9650','2013-06-14','16:30:00',6.44),('9650','2013-06-14','16:35:00',6.37),('9650','2013-06-14','16:40:00',6.29),('9650','2013-06-14','16:45:00',6.24),('9650','2013-06-14','16:50:00',6.2),('9650','2013-06-14','16:55:00',6.13),('9650','2013-06-14','17:00:00',6.05),('9650','2013-06-14','17:05:00',5.92),('9650','2013-06-14','17:10:00',5.8),('9650','2013-06-14','17:15:00',5.7),('9650','2013-06-14','17:20:00',5.6),('9650','2013-06-14','17:25:00',5.51),('9650','2013-06-14','17:30:00',5.39),('9650','2013-06-14','17:35:00',5.26),('9650','2013-06-14','17:40:00',5.15),('9650','2013-06-14','17:45:00',4.99),('9650','2013-06-14','17:50:00',4.83),('9650','2013-06-14','17:55:00',4.75),('9650','2013-06-14','18:00:00',4.64),('9650','2013-06-14','18:05:00',4.5),('9650','2013-06-14','18:10:00',4.38),('9650','2013-06-14','18:15:00',4.2),('9650','2013-06-14','18:20:00',4.08),('9650','2013-06-14','18:25:00',3.95),('9650','2013-06-14','18:30:00',3.8),('9650','2013-06-14','18:35:00',3.69),('9650','2013-06-14','18:40:00',3.57),('9650','2013-06-14','18:45:00',3.35),('9650','2013-06-14','18:50:00',3.21),('9650','2013-06-14','18:55:00',3.09),('9650','2013-06-14','19:00:00',2.94),('9650','2013-06-14','19:05:00',2.8),('9650','2013-06-14','19:10:00',2.62),('9650','2013-06-14','19:15:00',2.46),('9650','2013-06-14','19:20:00',2.29),('9650','2013-06-14','19:25:00',2.13),('9650','2013-06-14','19:30:00',1.95),('9650','2013-06-14','19:35:00',1.75),('9650','2013-06-14','19:40:00',1.54),('9650','2013-06-14','19:45:00',1.35),('9650','2013-06-14','19:50:00',1.14),('9650','2013-06-13','07:55:00',1.02),('9650','2013-06-13','08:00:00',1.1),('9650','2013-06-13','08:05:00',1.21),('9650','2013-06-13','08:10:00',1.3),('9650','2013-06-13','08:15:00',1.43),('9650','2013-06-13','08:20:00',1.6),('9650','2013-06-13','08:25:00',1.77),('9650','2013-06-13','08:30:00',1.89),('9650','2013-06-13','08:35:00',2.03),('9650','2013-06-13','08:40:00',2.15),('9650','2013-06-13','08:45:00',2.28),('9650','2013-06-13','08:50:00',2.41),('9650','2013-06-13','08:55:00',2.52),('9650','2013-06-13','09:00:00',2.63),('9650','2013-06-13','09:05:00',2.77),('9650','2013-06-13','09:10:00',2.92),('9650','2013-06-13','09:15:00',3.04),('9650','2013-06-13','09:20:00',3.15),('9650','2013-06-13','09:25:00',3.27),('9650','2013-06-13','09:30:00',3.4),('9650','2013-06-13','09:35:00',3.62),('9650','2013-06-13','09:40:00',3.77),('9650','2013-06-13','09:45:00',3.9),('9650','2013-06-13','09:50:00',4.02),('9650','2013-06-13','09:55:00',4.13),('9650','2013-06-13','10:00:00',4.2),('9650','2013-06-13','10:05:00',4.28),('9650','2013-06-13','10:10:00',4.4),('9650','2013-06-13','10:15:00',4.48),('9650','2013-06-13','10:20:00',4.61),('9650','2013-06-13','10:25:00',4.73),('9650','2013-06-13','10:30:00',4.77),('9650','2013-06-13','10:35:00',5.04),('9650','2013-06-13','10:40:00',5.14),('9650','2013-06-13','10:45:00',5.26),('9650','2013-06-13','10:50:00',5.32),('9650','2013-06-13','10:55:00',5.34),('9650','2013-06-13','11:00:00',5.37),('9650','2013-06-13','11:05:00',5.46),('9650','2013-06-13','11:10:00',5.59),('9650','2013-06-13','11:15:00',5.74),('9650','2013-06-13','11:20:00',5.74),('9650','2013-06-13','11:25:00',5.67),('9650','2013-06-13','11:30:00',6),('9650','2013-06-13','11:35:00',6.05),('9650','2013-06-13','11:40:00',6.15),('9650','2013-06-13','11:45:00',6.23),('9650','2013-06-13','11:50:00',6.28),('9650','2013-06-13','11:55:00',6.32),('9650','2013-06-13','12:00:00',6.35),('9650','2013-06-13','12:05:00',6.36),('9650','2013-06-13','12:10:00',6.4),('9650','2013-06-13','12:15:00',6.43),('9650','2013-06-13','12:20:00',6.52),('9650','2013-06-13','12:25:00',6.53),('9650','2013-06-13','12:30:00',6.61),('9650','2013-06-13','12:35:00',6.57),('9650','2013-06-13','12:40:00',6.68),('9650','2013-06-13','12:45:00',6.81),('9650','2013-06-13','12:50:00',6.8),('9650','2013-06-13','12:55:00',6.71),('9650','2013-06-13','13:00:00',6.75),('9650','2013-06-13','13:05:00',6.91),('9650','2013-06-13','13:10:00',6.98),('9650','2013-06-13','13:15:00',7.21),('9650','2013-06-13','13:20:00',7.31),('9650','2013-06-13','13:25:00',7.06),('9650','2013-06-13','13:30:00',7.08),('9650','2013-06-13','13:35:00',7.1),('9650','2013-06-13','13:40:00',7.15),('9650','2013-06-13','13:45:00',7.13),('9650','2013-06-13','13:50:00',7.22),('9650','2013-06-13','13:55:00',7.18),('9650','2013-06-13','14:00:00',7.25),('9650','2013-06-13','14:05:00',7.34),('9650','2013-06-13','14:10:00',7.46),('9650','2013-06-13','14:15:00',7.38),('9650','2013-06-13','14:20:00',7.28),('9650','2013-06-13','14:25:00',7.24),('9650','2013-06-13','14:30:00',7.23),('9650','2013-06-13','14:35:00',7.27),('9650','2013-06-13','14:40:00',7.27),('9650','2013-06-13','14:45:00',7.2),('9650','2013-06-13','14:50:00',7.25),('9650','2013-06-13','14:55:00',7.28),('9650','2013-06-13','15:00:00',7.28),('9650','2013-06-13','15:05:00',7.3),('9650','2013-06-13','15:10:00',7.31),('9650','2013-06-13','15:15:00',7.23),('9650','2013-06-13','15:20:00',7.23),('9650','2013-06-13','15:25:00',7.23),('9650','2013-06-13','15:30:00',7.19),('9650','2013-06-13','15:35:00',7.17),('9650','2013-06-13','15:40:00',7.15),('9650','2013-06-13','15:45:00',7.09),('9650','2013-06-13','15:50:00',7.03),('9650','2013-06-13','15:55:00',6.93),('9650','2013-06-13','16:00:00',6.87),('9650','2013-06-13','16:05:00',6.82),('9650','2013-06-13','16:10:00',6.75),('9650','2013-06-13','16:15:00',6.69),('9650','2013-06-13','16:20:00',6.63),('9650','2013-06-13','16:25:00',6.56),('9650','2013-06-13','16:30:00',6.48),('9650','2013-06-13','16:35:00',6.41),('9650','2013-06-13','16:40:00',6.33),('9650','2013-06-13','16:45:00',6.31),('9650','2013-06-13','16:50:00',6.26),('9650','2013-06-13','16:55:00',6.14),('9650','2013-06-13','17:00:00',6.1),('9650','2013-06-13','17:05:00',5.86),('9650','2013-06-13','17:10:00',5.85),('9650','2013-06-13','17:15:00',5.86),('9650','2013-06-13','17:20:00',5.71),('9650','2013-06-13','17:25:00',5.57),('9650','2013-06-13','17:30:00',5.32),('9650','2013-06-13','17:35:00',5.35),('9650','2013-06-13','17:40:00',5.32),('9650','2013-06-13','17:45:00',5.22),('9650','2013-06-13','17:50:00',5.13),('9650','2013-06-13','17:55:00',4.99),('9650','2013-06-13','18:00:00',4.83),('9650','2013-06-13','18:05:00',4.74),('9650','2013-06-13','18:10:00',4.63),('9650','2013-06-13','18:15:00',4.51),('9650','2013-06-13','18:20:00',4.37),('9650','2013-06-13','18:25:00',4.22),('9650','2013-06-13','18:30:00',4.11),('9650','2013-06-13','18:35:00',4),('9650','2013-06-13','18:40:00',3.88),('9650','2013-06-13','18:45:00',3.75),('9650','2013-06-13','18:50:00',3.56),('9650','2013-06-13','18:55:00',3.4),('9650','2013-06-13','19:00:00',3.27),('9650','2013-06-13','19:05:00',3.13),('9650','2013-06-13','19:10:00',2.94),('9650','2013-06-13','19:15:00',2.75),('9650','2013-06-13','19:20:00',2.57),('9650','2013-06-13','19:25:00',2.38),('9650','2013-06-13','19:30:00',2.2),('9650','2013-06-13','19:35:00',2),('9650','2013-06-13','19:40:00',1.81),('9650','2013-06-13','19:45:00',1.59),('9650','2013-06-13','19:50:00',1.37),('9650','2013-06-13','19:55:00',1.2),('9650','2013-06-13','20:00:00',1.01),('9650','2013-06-12','07:55:00',1.03),('9650','2013-06-12','08:00:00',1.12),('9650','2013-06-12','08:05:00',1.17),('9650','2013-06-12','08:10:00',1.22),('9650','2013-06-12','08:15:00',1.25),('9650','2013-06-12','08:20:00',1.28),('9650','2013-06-12','08:25:00',1.54),('9650','2013-06-12','08:30:00',1.89),('9650','2013-06-12','08:35:00',2.04),('9650','2013-06-12','08:40:00',2.14),('9650','2013-06-12','08:45:00',2.27),('9650','2013-06-12','08:50:00',2.41),('9650','2013-06-12','08:55:00',2.51),('9650','2013-06-12','09:00:00',2.65),('9650','2013-06-12','09:05:00',2.79),('9650','2013-06-12','09:10:00',2.92),('9650','2013-06-12','09:15:00',3.08),('9650','2013-06-12','09:20:00',3.19),('9650','2013-06-12','09:25:00',3.33),('9650','2013-06-12','09:30:00',3.49),('9650','2013-06-12','09:35:00',3.68),('9650','2013-06-12','09:40:00',3.82),('9650','2013-06-12','09:45:00',3.94),('9650','2013-06-12','09:50:00',4.07),('9650','2013-06-12','09:55:00',4.17),('9650','2013-06-12','10:00:00',4.24),('9650','2013-06-12','10:05:00',4.38),('9650','2013-06-12','10:10:00',4.5),('9650','2013-06-12','10:15:00',4.56),('9650','2013-06-12','10:20:00',4.72),('9650','2013-06-12','10:25:00',4.84),('9650','2013-06-12','10:30:00',4.94),('9650','2013-06-12','10:35:00',5.07),('9650','2013-06-12','10:40:00',5.17),('9650','2013-06-12','10:45:00',5.34),('9650','2013-06-12','10:50:00',5.45),('9650','2013-06-12','10:55:00',5.55),('9650','2013-06-12','11:00:00',5.59),('9650','2013-06-12','11:05:00',5.66),('9650','2013-06-12','11:10:00',5.72),('9650','2013-06-12','11:15:00',5.8),('9650','2013-06-12','11:20:00',5.9),('9650','2013-06-12','11:25:00',5.99),('9650','2013-06-12','11:30:00',6.09),('9650','2013-06-12','11:35:00',6.18),('9650','2013-06-12','11:40:00',6.25),('9650','2013-06-12','11:45:00',6.34),('9650','2013-06-12','11:50:00',6.39),('9650','2013-06-12','11:55:00',6.44),('9650','2013-06-12','12:00:00',6.51),('9650','2013-06-12','12:05:00',6.62),('9650','2013-06-12','12:10:00',6.69),('9650','2013-06-12','12:15:00',6.73),('9650','2013-06-12','12:20:00',6.77),('9650','2013-06-12','12:25:00',6.82),('9650','2013-06-12','12:30:00',6.89),('9650','2013-06-12','12:35:00',6.91),('9650','2013-06-12','12:40:00',6.96),('9650','2013-06-12','12:45:00',6.97),('9650','2013-06-12','12:50:00',7.05),('9650','2013-06-12','12:55:00',7.07),('9650','2013-06-12','13:00:00',7.14),('9650','2013-06-12','13:05:00',7.18),('9650','2013-06-12','13:10:00',7.18),('9650','2013-06-12','13:15:00',7.21),('9650','2013-06-12','13:20:00',7.17),('9650','2013-06-12','13:25:00',7.25),('9650','2013-06-12','13:30:00',7.24),('9650','2013-06-12','13:35:00',7.31),('9650','2013-06-12','13:40:00',7.33),('9650','2013-06-12','13:45:00',7.29),('9650','2013-06-12','13:50:00',7.34),('9650','2013-06-12','13:55:00',7.35),('9650','2013-06-12','14:00:00',7.39),('9650','2013-06-12','14:05:00',7.39),('9650','2013-06-12','14:10:00',7.41),('9650','2013-06-12','14:15:00',7.41),('9650','2013-06-12','14:20:00',7.46),('9650','2013-06-12','14:25:00',7.51),('9650','2013-06-12','14:30:00',5.7),('9650','2013-06-12','14:35:00',5.53),('9650','2013-06-12','14:40:00',7.64),('9650','2013-06-12','14:45:00',7.51),('9650','2013-06-12','14:50:00',7.41),('9650','2013-06-12','14:55:00',7.35),('9650','2013-06-12','15:00:00',7.39),('9650','2013-06-12','15:05:00',7.38),('9650','2013-06-12','15:10:00',7.3),('9650','2013-06-12','15:15:00',7.3),('9650','2013-06-12','15:20:00',7.24),('9650','2013-06-12','15:25:00',7.23),('9650','2013-06-12','15:30:00',7.19),('9650','2013-06-12','15:35:00',7.15),('9650','2013-06-12','15:40:00',7.13),('9650','2013-06-12','15:45:00',7.09),('9650','2013-06-12','15:50:00',7.05),('9650','2013-06-12','15:55:00',6.99),('9650','2013-06-12','16:00:00',6.94),('9650','2013-06-12','16:05:00',6.84),('9650','2013-06-12','16:10:00',6.77),('9650','2013-06-12','16:15:00',6.71),('9650','2013-06-12','16:20:00',6.61),('9650','2013-06-12','16:25:00',6.53),('9650','2013-06-12','16:30:00',6.49),('9650','2013-06-12','16:35:00',6.43),('9650','2013-06-12','16:40:00',6.34),('9650','2013-06-12','16:45:00',6.26),('9650','2013-06-12','16:50:00',6.12),('9650','2013-06-12','16:55:00',6.06),('9650','2013-06-12','17:00:00',5.94),('9650','2013-06-12','17:05:00',5.91),('9650','2013-06-12','17:10:00',5.78),('9650','2013-06-12','17:15:00',5.67),('9650','2013-06-12','17:20:00',5.63),('9650','2013-06-12','17:25:00',5.57),('9650','2013-06-12','17:30:00',5.46),('9650','2013-06-12','17:35:00',5.37),('9650','2013-06-12','17:40:00',5.25),('9650','2013-06-12','17:45:00',5.13),('9650','2013-06-12','17:50:00',5.07),('9650','2013-06-12','17:55:00',4.93),('9650','2013-06-12','18:00:00',4.79),('9650','2013-06-12','18:05:00',4.65),('9650','2013-06-12','18:10:00',4.52),('9650','2013-06-12','18:15:00',4.45),('9650','2013-06-12','18:20:00',4.35),('9650','2013-06-12','18:25:00',4.22),('9650','2013-06-12','18:30:00',4.08),('9650','2013-06-12','18:35:00',3.91),('9650','2013-06-12','18:40:00',3.78),('9650','2013-06-12','18:45:00',3.63),('9650','2013-06-12','18:50:00',3.49),('9650','2013-06-12','18:55:00',3.33),('9650','2013-06-12','19:00:00',3.17),('9650','2013-06-12','19:05:00',3.01),('9650','2013-06-12','19:10:00',2.85),('9650','2013-06-12','19:15:00',2.68),('9650','2013-06-12','19:20:00',2.53),('9650','2013-06-12','19:25:00',2.33),('9650','2013-06-12','19:30:00',2.12),('9650','2013-06-12','19:35:00',1.95),('9650','2013-06-12','19:40:00',1.77),('9650','2013-06-12','19:45:00',1.56),('9650','2013-06-12','19:50:00',1.33),('9650','2013-06-12','19:55:00',1.15),('9650','2013-06-11','07:55:00',1.08),('9650','2013-06-11','08:00:00',1.16),('9650','2013-06-11','08:05:00',1.26),('9650','2013-06-11','08:10:00',1.35),('9650','2013-06-11','08:15:00',1.46),('9650','2013-06-11','08:20:00',1.65),('9650','2013-06-11','08:25:00',1.82),('9650','2013-06-11','08:30:00',1.95),('9650','2013-06-11','08:35:00',2.08),('9650','2013-06-11','08:40:00',2.19),('9650','2013-06-11','08:45:00',2.32),('9650','2013-06-11','08:50:00',2.45),('9650','2013-06-11','08:55:00',2.57),('9650','2013-06-11','09:00:00',2.69),('9650','2013-06-11','09:05:00',2.83),('9650','2013-06-11','09:10:00',2.98),('9650','2013-06-11','09:15:00',3.09),('9650','2013-06-11','09:20:00',3.21),('9650','2013-06-11','09:25:00',3.34),('9650','2013-06-11','09:30:00',3.51),('9650','2013-06-11','09:35:00',3.67),('9650','2013-06-11','09:40:00',3.81),('9650','2013-06-11','09:45:00',3.94),('9650','2013-06-11','09:50:00',4.06),('9650','2013-06-11','09:55:00',4.14),('9650','2013-06-11','10:00:00',4.24),('9650','2013-06-11','10:05:00',4.38),('9650','2013-06-11','10:10:00',4.5),('9650','2013-06-11','10:15:00',4.57),('9650','2013-06-11','10:20:00',4.77),('9650','2013-06-11','10:25:00',4.88),('9650','2013-06-11','10:30:00',4.96),('9650','2013-06-11','10:35:00',5.06),('9650','2013-06-11','10:40:00',5.14),('9650','2013-06-11','10:45:00',5.26),('9650','2013-06-11','10:50:00',5.41),('9650','2013-06-11','10:55:00',5.52),('9650','2013-06-11','11:00:00',5.63),('9650','2013-06-11','11:05:00',5.73),('9650','2013-06-11','11:10:00',5.83),('9650','2013-06-11','11:15:00',5.92),('9650','2013-06-11','11:20:00',5.99),('9650','2013-06-11','11:25:00',6.01),('9650','2013-06-11','11:30:00',6.11),('9650','2013-06-11','11:35:00',6.16),('9650','2013-06-11','11:40:00',6.24),('9650','2013-06-11','11:45:00',6.36),('9650','2013-06-11','11:50:00',6.38),('9650','2013-06-11','11:55:00',6.43),('9650','2013-06-11','12:00:00',6.59),('9650','2013-06-11','12:05:00',6.66),('9650','2013-06-11','12:10:00',6.71),('9650','2013-06-11','12:15:00',6.82),('9650','2013-06-11','12:20:00',7.1),('9650','2013-06-11','12:25:00',5.44),('9650','2013-06-11','12:30:00',4.79),('9650','2013-06-11','12:35:00',7.43),('9650','2013-06-11','12:40:00',3.45),('9650','2013-06-11','12:45:00',2.53),('9650','2013-06-11','12:50:00',3.2),('9650','2013-06-11','12:55:00',4.54),('9650','2013-06-11','13:00:00',6.68),('9650','2013-06-11','13:05:00',3.07),('9650','2013-06-11','13:10:00',7.39),('9650','2013-06-11','13:15:00',7.48),('9650','2013-06-11','13:20:00',7.46),('9650','2013-06-11','13:25:00',6.85),('9650','2013-06-11','13:30:00',6.89),('9650','2013-06-11','13:35:00',7.49),('9650','2013-06-11','13:40:00',7.59),('9650','2013-06-11','13:45:00',7.67),('9650','2013-06-11','13:50:00',7.52),('9650','2013-06-11','13:55:00',7.76),('9650','2013-06-11','14:00:00',6.72),('9650','2013-06-11','14:05:00',4.99),('9650','2013-06-11','14:10:00',2.81),('9650','2013-06-11','14:15:00',8.3),('9650','2013-06-11','14:20:00',4.38),('9650','2013-06-11','14:25:00',5.28),('9650','2013-06-11','14:30:00',7.96),('9650','2013-06-11','14:35:00',6.27),('9650','2013-06-11','14:40:00',6.2),('9650','2013-06-11','14:45:00',7.9),('9650','2013-06-11','14:50:00',7.87),('9650','2013-06-11','14:55:00',7.91),('9650','2013-06-11','15:00:00',7.79),('9650','2013-06-11','15:05:00',7.71),('9650','2013-06-11','15:10:00',7.61),('9650','2013-06-11','15:15:00',6.92),('9650','2013-06-11','15:20:00',7.62),('9650','2013-06-11','15:25:00',7.41),('9650','2013-06-11','15:30:00',7.38),('9650','2013-06-11','15:35:00',7.44),('9650','2013-06-11','15:40:00',7.45),('9650','2013-06-11','15:45:00',7.37),('9650','2013-06-11','15:50:00',7.23),('9650','2013-06-11','15:55:00',7.32),('9650','2013-06-11','16:00:00',7.39),('9650','2013-06-11','16:05:00',7.07),('9650','2013-06-11','16:10:00',7.1),('9650','2013-06-11','16:15:00',7.02),('9650','2013-06-11','16:20:00',6.89),('9650','2013-06-11','16:25:00',6.95),('9650','2013-06-11','16:30:00',6.37),('9650','2013-06-11','16:35:00',6.6),('9650','2013-06-11','16:40:00',6.81),('9650','2013-06-11','16:45:00',6.58),('9650','2013-06-11','16:50:00',6.64),('9650','2013-06-11','16:55:00',5.88),('9650','2013-06-11','17:00:00',6.23),('9650','2013-06-11','17:05:00',6.22),('9650','2013-06-11','17:10:00',6.1),('9650','2013-06-11','17:15:00',6.01),('9650','2013-06-11','17:20:00',5.85),('9650','2013-06-11','17:25:00',5.73),('9650','2013-06-11','17:30:00',5.67),('9650','2013-06-11','17:35:00',5.68),('9650','2013-06-11','17:40:00',5.65),('9650','2013-06-11','17:45:00',3.31),('9650','2013-06-11','17:50:00',1.07),('9650','2013-06-11','17:55:00',1.96),('9650','2013-06-11','18:00:00',1.75),('9650','2013-06-11','18:05:00',4.71),('9650','2013-06-11','18:10:00',4.79),('9650','2013-06-11','18:15:00',4.69),('9650','2013-06-11','18:20:00',4.49),('9650','2013-06-11','18:25:00',4.11),('9650','2013-06-11','18:30:00',4.02),('9650','2013-06-11','18:35:00',3.87),('9650','2013-06-11','18:40:00',3.72),('9650','2013-06-11','18:45:00',3.52),('9650','2013-06-11','18:50:00',3.39),('9650','2013-06-11','18:55:00',3.34),('9650','2013-06-11','19:00:00',3.25),('9650','2013-06-11','19:05:00',3.1),('9650','2013-06-11','19:10:00',1.18),('9650','2013-06-11','19:15:00',2.18),('9650','2013-06-11','19:20:00',2.5),('9650','2013-06-11','19:25:00',2.2),('9650','2013-06-11','19:30:00',2.04),('9650','2013-06-11','19:35:00',1.83),('9650','2013-06-11','19:40:00',1.66),('9650','2013-06-11','19:45:00',1.42),('9650','2013-06-11','19:50:00',1.13),('9650','2013-06-10','08:00:00',1.4),('9650','2013-06-10','08:05:00',1.54),('9650','2013-06-10','08:10:00',1.71),('9650','2013-06-10','08:15:00',1.42),('9650','2013-06-10','08:20:00',1.06),('9650','2013-06-10','08:25:00',2.17),('9650','2013-06-10','08:30:00',2.22),('9650','2013-06-10','08:35:00',2.45),('9650','2013-06-10','08:40:00',2.14),('9650','2013-06-10','08:45:00',2.36),('9650','2013-06-10','08:50:00',1.66),('9650','2013-06-10','08:55:00',1.15),('9650','2013-06-10','09:00:00',1.89),('9650','2013-06-10','09:05:00',2.87),('9650','2013-06-10','09:10:00',3.2),('9650','2013-06-10','09:15:00',3.45),('9650','2013-06-10','09:20:00',3.62),('9650','2013-06-10','09:25:00',2.38),('9650','2013-06-10','09:30:00',1.91),('9650','2013-06-10','09:35:00',1.14),('9650','2013-06-10','09:40:00',2.5),('9650','2013-06-10','09:45:00',4.28),('9650','2013-06-10','09:50:00',4.36),('9650','2013-06-10','09:55:00',4.32),('9650','2013-06-10','10:00:00',4.04),('9650','2013-06-10','10:05:00',2.73),('9650','2013-06-10','10:10:00',4.34),('9650','2013-06-10','10:15:00',4.89),('9650','2013-06-10','10:20:00',5.16),('9650','2013-06-10','10:25:00',5.25),('9650','2013-06-10','10:30:00',5.22),('9650','2013-06-10','10:35:00',5.3),('9650','2013-06-10','10:40:00',5.27),('9650','2013-06-10','10:45:00',4.82),('9650','2013-06-10','10:50:00',5.26),('9650','2013-06-10','10:55:00',1.4),('9650','2013-06-10','11:00:00',6.31),('9650','2013-06-10','11:05:00',3.89),('9650','2013-06-10','11:10:00',3.05),('9650','2013-06-10','11:15:00',6.42),('9650','2013-06-10','11:20:00',6.19),('9650','2013-06-10','11:25:00',6.25),('9650','2013-06-10','11:30:00',6.33),('9650','2013-06-10','11:35:00',6.37),('9650','2013-06-10','11:40:00',6.43),('9650','2013-06-10','11:45:00',6.55),('9650','2013-06-10','11:50:00',6.62),('9650','2013-06-10','11:55:00',6.69),('9650','2013-06-10','12:00:00',6.4),('9650','2013-06-10','12:05:00',6.82),('9650','2013-06-10','12:10:00',6.85),('9650','2013-06-10','12:15:00',6.92),('9650','2013-06-10','12:20:00',7.02),('9650','2013-06-10','12:25:00',7.02),('9650','2013-06-10','12:30:00',7.09),('9650','2013-06-10','12:35:00',7.15),('9650','2013-06-10','12:40:00',7.21),('9650','2013-06-10','12:45:00',7.27),('9650','2013-06-10','12:50:00',7.37),('9650','2013-06-10','12:55:00',7.38),('9650','2013-06-10','13:00:00',7.43),('9650','2013-06-10','13:05:00',7.48),('9650','2013-06-10','13:10:00',7.51),('9650','2013-06-10','13:15:00',7.58),('9650','2013-06-10','13:20:00',7.58),('9650','2013-06-10','13:25:00',7.64),('9650','2013-06-10','13:30:00',7.7),('9650','2013-06-10','13:35:00',7.71),('9650','2013-06-10','13:40:00',7.79),('9650','2013-06-10','13:45:00',7.83),('9650','2013-06-10','13:50:00',6.84),('9650','2013-06-10','13:55:00',7.87),('9650','2013-06-10','14:00:00',7.85),('9650','2013-06-10','14:05:00',7.73),('9650','2013-06-10','14:10:00',7.7),('9650','2013-06-10','14:15:00',7.72),('9650','2013-06-10','14:20:00',7.73),('9650','2013-06-10','14:25:00',7.73),('9650','2013-06-10','14:30:00',7.74),('9650','2013-06-10','14:35:00',7.71),('9650','2013-06-10','14:40:00',7.73),('9650','2013-06-10','14:45:00',7.72),('9650','2013-06-10','14:50:00',7.72),('9650','2013-06-10','14:55:00',7.68),('9650','2013-06-10','15:00:00',7.66),('9650','2013-06-10','15:05:00',7.65),('9650','2013-06-10','15:10:00',7.65),('9650','2013-06-10','15:15:00',7.57),('9650','2013-06-10','15:20:00',7.54),('9650','2013-06-10','15:25:00',7.47),('9650','2013-06-10','15:30:00',7.55),('9650','2013-06-10','15:35:00',7.58),('9650','2013-06-10','15:40:00',7.34),('9650','2013-06-10','15:45:00',7.75),('9650','2013-06-10','15:50:00',7.39),('9650','2013-06-10','15:55:00',7.36),('9650','2013-06-10','16:00:00',6.85),('9650','2013-06-10','16:05:00',7.26),('9650','2013-06-10','16:10:00',7.17),('9650','2013-06-10','16:15:00',7.07),('9650','2013-06-10','16:20:00',7.06),('9650','2013-06-10','16:25:00',7),('9650','2013-06-10','16:30:00',6.98),('9650','2013-06-10','16:35:00',6.95),('9650','2013-06-10','16:40:00',7.05),('9650','2013-06-10','16:45:00',7.32),('9650','2013-06-10','16:50:00',7.35),('9650','2013-06-10','16:55:00',7.13),('9650','2013-06-10','17:00:00',6.12),('9650','2013-06-10','17:05:00',3.83),('9650','2013-06-10','17:10:00',1.55),('9650','2013-06-10','17:15:00',1.21),('9650','2013-06-10','19:15:00',1.13),('9650','2013-06-10','19:20:00',1.04),('9650','2013-06-10','19:25:00',1.13),('9650','2013-06-10','19:30:00',2.64),('9650','2013-06-10','19:35:00',1.73),('9650','2014-04-02','08:25:00',1.05),('9650','2014-04-02','08:30:00',1.12),('9650','2014-04-02','08:35:00',1.17),('9650','2014-04-02','08:40:00',1.28),('9650','2014-04-02','08:45:00',1.4),('9650','2014-04-02','08:50:00',1.44),('9650','2014-04-02','08:55:00',1.55),('9650','2014-04-02','09:00:00',1.72),('9650','2014-04-02','09:05:00',1.9),('9650','2014-04-02','09:10:00',1.87),('9650','2014-04-02','09:15:00',1.79),('9650','2014-04-02','09:20:00',1.84),('9650','2014-04-02','09:25:00',1.95),('9650','2014-04-02','09:30:00',2.14),('9650','2014-04-02','09:35:00',2.4),('9650','2014-04-02','09:40:00',2.5),('9650','2014-04-02','09:45:00',2.48),('9650','2014-04-02','09:50:00',2.36),('9650','2014-04-02','09:55:00',2.39),('9650','2014-04-02','10:00:00',2.67),('9650','2014-04-02','10:05:00',2.95),('9650','2014-04-02','10:10:00',3.08),('9650','2014-04-02','10:15:00',3.51),('9650','2014-04-02','10:20:00',3.69),('9650','2014-04-02','10:25:00',3.45),('9650','2014-04-02','10:30:00',3.38),('9650','2014-04-02','10:35:00',3.73),('9650','2014-04-02','10:40:00',3.19),('9650','2014-04-02','10:45:00',3.48),('9650','2014-04-02','10:50:00',3.24),('9650','2014-04-02','10:55:00',3.41),('9650','2014-04-02','11:00:00',3.27),('9650','2014-04-02','11:05:00',2.88),('9650','2014-04-02','11:10:00',2.76),('9650','2014-04-02','11:15:00',2.64),('9650','2014-04-02','11:20:00',2.52),('9650','2014-04-02','11:25:00',2.35),('9650','2014-04-02','11:30:00',2.32),('9650','2014-04-02','11:35:00',2.48),('9650','2014-04-02','11:40:00',2.7),('9650','2014-04-02','11:45:00',3),('9650','2014-04-02','11:50:00',3.53),('9650','2014-04-02','11:55:00',3.87),('9650','2014-04-02','12:00:00',3.76),('9650','2014-04-02','12:05:00',3.78),('9650','2014-04-02','12:10:00',3.69),('9650','2014-04-02','12:15:00',3.64),('9650','2014-04-02','12:25:00',2.58),('9650','2014-04-02','12:30:00',5.66),('9650','2014-04-02','12:35:00',5.59),('9650','2014-04-02','12:40:00',6.37),('9650','2014-04-02','12:45:00',3.82),('9650','2014-04-02','12:50:00',4.47),('9650','2014-04-02','12:55:00',4.39),('9650','2014-04-02','13:00:00',4.26),('9650','2014-04-02','13:05:00',5.34),('9650','2014-04-02','13:10:00',4.11),('9650','2014-04-02','13:15:00',7.2),('9650','2014-04-02','13:20:00',4.33),('9650','2014-04-02','13:25:00',4.56),('9650','2014-04-02','13:30:00',4.35),('9650','2014-04-02','13:35:00',7.11),('9650','2014-04-02','13:40:00',6.35),('9650','2014-04-02','13:45:00',3.56),('9650','2014-04-02','13:50:00',3.58),('9650','2014-04-02','13:55:00',4.17),('9650','2014-04-02','14:00:00',5.82),('9650','2014-04-02','14:05:00',5.65),('9650','2014-04-02','14:10:00',4.47),('9650','2014-04-02','14:15:00',5.98),('9650','2014-04-02','14:20:00',6.14),('9650','2014-04-02','14:25:00',6.35),('9650','2014-04-02','14:30:00',6.5),('9650','2014-04-02','14:35:00',6.64),('9650','2014-04-02','14:40:00',6.46),('9650','2014-04-02','14:45:00',6.37),('9650','2014-04-02','14:50:00',6.29),('9650','2014-04-02','14:55:00',6.18),('9650','2014-04-02','15:00:00',6.13),('9650','2014-04-02','15:05:00',6.02),('9650','2014-04-02','15:10:00',5.84),('9650','2014-04-02','15:15:00',5.82),('9650','2014-04-02','15:20:00',5.88),('9650','2014-04-02','15:25:00',5.9),('9650','2014-04-02','15:30:00',5.86),('9650','2014-04-02','15:35:00',5.84),('9650','2014-04-02','15:40:00',5.83),('9650','2014-04-02','15:45:00',5.82),('9650','2014-04-02','15:50:00',5.72),('9650','2014-04-02','15:55:00',5.65),('9650','2014-04-02','16:00:00',5.59),('9650','2014-04-02','16:05:00',5.37),('9650','2014-04-02','16:10:00',5.42),('9650','2014-04-02','16:15:00',5.31),('9650','2014-04-02','16:20:00',5.3),('9650','2014-04-02','16:25:00',5.19),('9650','2014-04-02','16:30:00',5.08),('9650','2014-04-02','16:35:00',4.99),('9650','2014-04-02','16:40:00',4.89),('9650','2014-04-02','16:45:00',4.6),('9650','2014-04-02','16:50:00',3.5),('9650','2014-04-02','16:55:00',2.83),('9650','2014-04-02','17:00:00',2.26),('9650','2014-04-02','17:05:00',2.09),('9650','2014-04-02','17:10:00',1.91),('9650','2014-04-02','17:15:00',1.87),('9650','2014-04-02','17:20:00',2.04),('9650','2014-04-02','17:25:00',2.26),('9650','2014-04-02','17:30:00',2.23),('9650','2014-04-02','17:35:00',1.47),('9650','2014-04-02','17:40:00',1.32),('9650','2014-04-02','17:45:00',2.73),('9650','2014-04-02','17:50:00',3.56),('9650','2014-04-02','17:55:00',3.25),('9650','2014-04-02','18:00:00',3.02),('9650','2014-04-02','18:05:00',2.87),('9650','2014-04-02','18:10:00',2.73),('9650','2014-04-02','18:15:00',2.6),('9650','2014-04-02','18:20:00',2.37),('9650','2014-04-02','18:25:00',1.86),('9650','2014-04-02','18:30:00',1.16),('9650','2014-04-02','18:35:00',1.37),('9650','2014-04-02','18:40:00',1.44),('9650','2014-04-02','18:45:00',1.46),('9650','2014-04-02','18:50:00',1.34),('9650','2013-06-09','07:25:00',1.09),('9650','2013-06-09','07:30:00',1.31),('9650','2013-06-09','07:35:00',1.73),('9650','2013-06-09','07:40:00',1.33),('9650','2013-06-09','07:45:00',1.16),('9650','2013-06-09','07:50:00',1.21),('9650','2013-06-09','07:55:00',1.26),('9650','2013-06-09','08:00:00',1.66),('9650','2013-06-09','08:05:00',1.88),('9650','2013-06-09','08:10:00',2.3),('9650','2013-06-09','08:15:00',2.17),('9650','2013-06-09','08:20:00',2.23),('9650','2013-06-09','08:25:00',2.16),('9650','2013-06-09','08:30:00',1.79),('9650','2013-06-09','08:35:00',1.66),('9650','2013-06-09','08:40:00',1.9),('9650','2013-06-09','08:45:00',1.11),('9650','2013-06-09','08:50:00',1.24),('9650','2013-06-09','08:55:00',1.73),('9650','2013-06-09','09:00:00',1.8),('9650','2013-06-09','09:05:00',1.78),('9650','2013-06-09','09:10:00',2.14),('9650','2013-06-09','09:15:00',1.82),('9650','2013-06-09','09:20:00',2),('9650','2013-06-09','09:25:00',3.12),('9650','2013-06-09','09:30:00',3.01),('9650','2013-06-09','09:35:00',4.36),('9650','2013-06-09','09:40:00',3.72),('9650','2013-06-09','09:45:00',5.23),('9650','2013-06-09','09:50:00',3.15),('9650','2013-06-09','09:55:00',2.64),('9650','2013-06-09','10:00:00',3.43),('9650','2013-06-09','10:05:00',3.71),('9650','2013-06-09','10:10:00',4.07),('9650','2013-06-09','10:15:00',3.23),('9650','2013-06-09','10:20:00',3.11),('9650','2013-06-09','10:25:00',2.59),('9650','2013-06-09','10:30:00',2.58),('9650','2013-06-09','10:35:00',2.92),('9650','2013-06-09','10:40:00',2.73),('9650','2013-06-09','10:45:00',2.15),('9650','2013-06-09','10:50:00',3.01),('9650','2013-06-09','10:55:00',5.2),('9650','2013-06-09','11:00:00',4.33),('9650','2013-06-09','11:05:00',3.85),('9650','2013-06-09','11:10:00',5.06),('9650','2013-06-09','11:15:00',6.15),('9650','2013-06-09','11:20:00',6.45),('9650','2013-06-09','11:25:00',6.12),('9650','2013-06-09','11:30:00',6.01),('9650','2013-06-09','11:35:00',7.08),('9650','2013-06-09','11:40:00',4.52),('9650','2013-06-09','11:45:00',5.33),('9650','2013-06-09','11:50:00',3.24),('9650','2013-06-09','11:55:00',5.81),('9650','2013-06-09','12:00:00',6.77),('9650','2013-06-09','12:05:00',2.39),('9650','2013-06-09','12:10:00',7.36),('9650','2013-06-09','12:15:00',6.73),('9650','2013-06-09','12:20:00',7.32),('9650','2013-06-09','12:25:00',7.62),('9650','2013-06-09','12:30:00',7.64),('9650','2013-06-09','12:35:00',7.1),('9650','2013-06-09','12:40:00',5.4),('9650','2013-06-09','12:45:00',5.99),('9650','2013-06-09','12:50:00',4.87),('9650','2013-06-09','12:55:00',5.77),('9650','2013-06-09','13:00:00',8.86),('9650','2013-06-09','13:05:00',6.35),('9650','2013-06-09','13:10:00',3.68),('9650','2013-06-09','13:15:00',7.5),('9650','2013-06-09','13:20:00',5.47),('9650','2013-06-09','13:25:00',4.72),('9650','2013-06-09','13:30:00',4.01),('9650','2013-06-09','13:35:00',7.59),('9650','2013-06-09','13:40:00',7.21),('9650','2013-06-09','13:45:00',6.33),('9650','2013-06-09','13:50:00',6.41),('9650','2013-06-09','13:55:00',8.76),('9650','2013-06-09','14:00:00',7.95),('9650','2013-06-09','14:05:00',8.33),('9650','2013-06-09','14:10:00',6.97),('9650','2013-06-09','14:15:00',7.77),('9650','2013-06-09','14:20:00',7.92),('9650','2013-06-09','14:25:00',7.85),('9650','2013-06-09','14:30:00',7.69),('9650','2013-06-09','14:35:00',7.73),('9650','2013-06-09','14:40:00',6.76),('9650','2013-06-09','14:45:00',7.79),('9650','2013-06-09','14:50:00',7.7),('9650','2013-06-09','14:55:00',7.71),('9650','2013-06-09','15:00:00',7.71),('9650','2013-06-09','15:05:00',7.68),('9650','2013-06-09','15:10:00',7.65),('9650','2013-06-09','15:15:00',7.66),('9650','2013-06-09','15:20:00',7.65),('9650','2013-06-09','15:25:00',7.62),('9650','2013-06-09','15:30:00',7.59),('9650','2013-06-09','15:35:00',7.61),('9650','2013-06-09','15:40:00',7.61),('9650','2013-06-09','15:45:00',7.55),('9650','2013-06-09','15:50:00',7.45),('9650','2013-06-09','15:55:00',7.38),('9650','2013-06-09','16:00:00',7.3),('9650','2013-06-09','16:05:00',7.24),('9650','2013-06-09','16:10:00',7.19),('9650','2013-06-09','16:15:00',7.13),('9650','2013-06-09','16:20:00',7.03),('9650','2013-06-09','16:25:00',7.03),('9650','2013-06-09','16:30:00',6.9),('9650','2013-06-09','16:35:00',6.83),('9650','2013-06-09','16:40:00',6.75),('9650','2013-06-09','16:45:00',6.69),('9650','2013-06-09','16:50:00',6.62),('9650','2013-06-09','16:55:00',6.59),('9650','2013-06-09','17:00:00',6.52),('9650','2013-06-09','17:05:00',6.43),('9650','2013-06-09','17:10:00',6.34),('9650','2013-06-09','17:15:00',6.23),('9650','2013-06-09','17:20:00',6.17),('9650','2013-06-09','17:25:00',6.04),('9650','2013-06-09','17:30:00',5.92),('9650','2013-06-09','17:35:00',5.82),('9650','2013-06-09','17:40:00',5.67),('9650','2013-06-09','17:45:00',5.53),('9650','2013-06-09','17:50:00',5.43),('9650','2013-06-09','17:55:00',5.37),('9650','2013-06-09','18:00:00',5.23),('9650','2013-06-09','18:05:00',5.11),('9650','2013-06-09','18:10:00',5),('9650','2013-06-09','18:15:00',4.85),('9650','2013-06-09','18:20:00',4.76),('9650','2013-06-09','18:25:00',4.64),('9650','2013-06-09','18:30:00',4.48),('9650','2013-06-09','18:35:00',4.31),('9650','2013-06-09','18:40:00',4.16),('9650','2013-06-09','18:45:00',3.98),('9650','2013-06-09','18:50:00',3.88),('9650','2013-06-09','18:55:00',3.69),('9650','2013-06-09','19:00:00',3.56),('9650','2013-06-09','19:05:00',3.36),('9650','2013-06-09','19:10:00',3.16),('9650','2013-06-09','19:15:00',3.01),('9650','2013-06-09','19:20:00',2.82),('9650','2013-06-09','19:25:00',2.62),('9650','2013-06-09','19:30:00',2.4),('9650','2013-06-09','19:35:00',2.19),('9650','2013-06-09','19:40:00',2.01),('9650','2013-06-09','19:45:00',1.81),('9650','2013-06-09','19:50:00',1.6),('9650','2013-06-09','19:55:00',1.38),('9650','2013-06-09','20:00:00',1.19),('9650','2013-06-08','07:10:00',1.01),('9650','2013-06-08','07:25:00',1.18),('9650','2013-06-08','07:30:00',1.16),('9650','2013-06-08','07:35:00',1.74),('9650','2013-06-08','07:40:00',1.31),('9650','2013-06-08','07:50:00',1.05),('9650','2013-06-08','07:55:00',1.4),('9650','2013-06-08','08:00:00',1.35),('9650','2013-06-08','08:05:00',1.5),('9650','2013-06-08','08:10:00',1.7),('9650','2013-06-08','08:15:00',1.45),('9650','2013-06-08','08:20:00',1.52),('9650','2013-06-08','08:25:00',1.93),('9650','2013-06-08','08:30:00',2.06),('9650','2013-06-08','08:35:00',2.16),('9650','2013-06-08','08:40:00',2.24),('9650','2013-06-08','08:45:00',2.37),('9650','2013-06-08','08:50:00',2.48),('9650','2013-06-08','08:55:00',2.57),('9650','2013-06-08','09:00:00',2.66),('9650','2013-06-08','09:05:00',2.82),('9650','2013-06-08','09:10:00',2.93),('9650','2013-06-08','09:15:00',3.03),('9650','2013-06-08','09:20:00',3.13),('9650','2013-06-08','09:25:00',3.28),('9650','2013-06-08','09:30:00',3.51),('9650','2013-06-08','09:35:00',3.59),('9650','2013-06-08','09:40:00',3.63),('9650','2013-06-08','09:45:00',3.78),('9650','2013-06-08','09:50:00',3.92),('9650','2013-06-08','09:55:00',4.02),('9650','2013-06-08','10:00:00',4.11),('9650','2013-06-08','10:05:00',4.2),('9650','2013-06-08','10:10:00',4.36),('9650','2013-06-08','10:15:00',4.4),('9650','2013-06-08','10:20:00',4.51),('9650','2013-06-08','10:25:00',4.6),('9650','2013-06-08','10:30:00',4.83),('9650','2013-06-08','10:35:00',4.92),('9650','2013-06-08','10:40:00',5.06),('9650','2013-06-08','10:45:00',5.15),('9650','2013-06-08','10:50:00',5.25),('9650','2013-06-08','10:55:00',5.27),('9650','2013-06-08','11:00:00',5.36),('9650','2013-06-08','11:05:00',5.37),('9650','2013-06-08','11:10:00',5.5),('9650','2013-06-08','11:15:00',5.65),('9650','2013-06-08','11:20:00',5.71),('9650','2013-06-08','11:25:00',5.71),('9650','2013-06-08','11:30:00',5.77),('9650','2013-06-08','11:35:00',5.86),('9650','2013-06-08','11:40:00',5.99),('9650','2013-06-08','11:45:00',6.12),('9650','2013-06-08','11:50:00',6.13),('9650','2013-06-08','11:55:00',6.18),('9650','2013-06-08','12:00:00',6.24),('9650','2013-06-08','12:05:00',6.38),('9650','2013-06-08','12:10:00',5.56),('9650','2013-06-08','12:15:00',6.31),('9650','2013-06-08','12:20:00',6.51),('9650','2013-06-08','12:25:00',6.41),('9650','2013-06-08','12:30:00',6.65),('9650','2013-06-08','12:35:00',6.62),('9650','2013-06-08','12:40:00',6.71),('9650','2013-06-08','12:45:00',5.74),('9650','2013-06-08','12:50:00',6.88),('9650','2013-06-08','12:55:00',6.84),('9650','2013-06-08','13:00:00',6.29),('9650','2013-06-08','13:05:00',6.97),('9650','2013-06-08','13:10:00',4.04),('9650','2013-06-08','13:15:00',5.22),('9650','2013-06-08','13:20:00',5.81),('9650','2013-06-08','13:25:00',7.7),('9650','2013-06-08','13:30:00',7.39),('9650','2013-06-08','13:35:00',7.52),('9650','2013-06-08','13:40:00',7.85),('9650','2013-06-08','13:45:00',7.95),('9650','2013-06-08','13:50:00',8.33),('9650','2013-06-08','13:55:00',7.26),('9650','2013-06-08','14:00:00',6.96),('9650','2013-06-08','14:05:00',7.82),('9650','2013-06-08','14:10:00',7.61),('9650','2013-06-08','14:15:00',4.98),('9650','2013-06-08','14:20:00',3.22),('9650','2013-06-08','14:25:00',2.06),('9650','2013-06-08','14:30:00',2.73),('9650','2013-06-08','14:35:00',7.01),('9650','2013-06-08','14:40:00',7.03),('9650','2013-06-08','14:45:00',7.16),('9650','2013-06-08','14:50:00',7.63),('9650','2013-06-08','14:55:00',7.78),('9650','2013-06-08','15:00:00',7.67),('9650','2013-06-08','15:05:00',7.32),('9650','2013-06-08','15:10:00',7.45),('9650','2013-06-08','15:15:00',7.25),('9650','2013-06-08','15:20:00',7.34),('9650','2013-06-08','15:25:00',7.33),('9650','2013-06-08','15:30:00',6.84),('9650','2013-06-08','15:35:00',7.31),('9650','2013-06-08','15:40:00',5.74),('9650','2013-06-08','15:45:00',5.92),('9650','2013-06-08','15:50:00',6.81),('9650','2013-06-08','15:55:00',7.37),('9650','2013-06-08','16:00:00',4.44),('9650','2013-06-08','16:05:00',6.71),('9650','2013-06-08','16:10:00',6.66),('9650','2013-06-08','16:15:00',3.51),('9650','2013-06-08','16:20:00',3.11),('9650','2013-06-08','16:25:00',4.48),('9650','2013-06-08','16:30:00',2.61),('9650','2013-06-08','16:35:00',1.76),('9650','2013-06-08','16:40:00',1.7),('9650','2013-06-08','16:45:00',1.7),('9650','2013-06-08','16:50:00',1.68),('9650','2013-06-08','16:55:00',1.56),('9650','2013-06-08','17:00:00',1.68),('9650','2013-06-08','17:05:00',1.8),('9650','2013-06-08','17:10:00',1.77),('9650','2013-06-08','17:15:00',1.38),('9650','2013-06-08','17:20:00',1.48),('9650','2013-06-08','17:25:00',1.12),('9650','2013-06-08','17:35:00',1.1),('9650','2013-06-08','17:40:00',1.38),('9650','2013-06-08','17:45:00',1.31),('9650','2013-06-08','18:00:00',1.71),('9650','2013-06-08','18:05:00',1.84),('9650','2013-06-08','18:10:00',3.96),('9650','2013-06-08','18:15:00',3.05),('9650','2013-06-08','18:20:00',2.69),('9650','2013-06-08','18:25:00',1.16),('9650','2013-06-08','18:30:00',2.55),('9650','2013-06-08','18:35:00',1.62),('9650','2013-06-08','18:40:00',1.15),('9650','2013-06-08','18:45:00',1.85),('9650','2013-06-08','18:50:00',1.94),('9650','2013-06-08','18:55:00',1.44),('9650','2013-06-08','19:30:00',1),('9650','2013-06-07','07:50:00',1.01),('9650','2013-06-07','07:55:00',1.09),('9650','2013-06-07','08:00:00',1.17),('9650','2013-06-07','08:05:00',1.25),('9650','2013-06-07','08:10:00',1.36),('9650','2013-06-07','08:15:00',1.47),('9650','2013-06-07','08:20:00',1.62),('9650','2013-06-07','08:25:00',1.78),('9650','2013-06-07','08:30:00',1.88),('9650','2013-06-07','08:35:00',2.02),('9650','2013-06-07','08:40:00',2.15),('9650','2013-06-07','08:45:00',2.28),('9650','2013-06-07','08:50:00',2.4),('9650','2013-06-07','08:55:00',2.51),('9650','2013-06-07','09:00:00',2.61),('9650','2013-06-07','09:05:00',2.73),('9650','2013-06-07','09:10:00',2.84),('9650','2013-06-07','09:15:00',3.01),('9650','2013-06-07','09:20:00',3.11),('9650','2013-06-07','09:25:00',3.2),('9650','2013-06-07','09:30:00',3.44),('9650','2013-06-07','09:35:00',3.58),('9650','2013-06-07','09:40:00',3.71),('9650','2013-06-07','09:45:00',3.81),('9650','2013-06-07','09:50:00',3.98),('9650','2013-06-07','09:55:00',4.14),('9650','2013-06-07','10:00:00',4.16),('9650','2013-06-07','10:05:00',4.37),('9650','2013-06-07','10:10:00',4.54),('9650','2013-06-07','10:15:00',4.65),('9650','2013-06-07','10:20:00',4.7),('9650','2013-06-07','10:25:00',4.69),('9650','2013-06-07','10:30:00',4.56),('9650','2013-06-07','10:35:00',4.62),('9650','2013-06-07','10:40:00',5.3),('9650','2013-06-07','10:45:00',5.36),('9650','2013-06-07','10:50:00',5.86),('9650','2013-06-07','10:55:00',4.15),('9650','2013-06-07','11:00:00',2.57),('9650','2013-06-07','11:05:00',5.04),('9650','2013-06-07','11:10:00',4.66),('9650','2013-06-07','11:15:00',6.68),('9650','2013-06-07','11:20:00',6.91),('9650','2013-06-07','11:25:00',3.12),('9650','2013-06-07','11:30:00',1.86),('9650','2013-06-07','11:35:00',5.92),('9650','2013-06-07','11:40:00',6.81),('9650','2013-06-07','11:45:00',6.5),('9650','2013-06-07','11:50:00',4.78),('9650','2013-06-07','11:55:00',2.1),('9650','2013-06-07','12:00:00',6.83),('9650','2013-06-07','12:05:00',1.84),('9650','2013-06-07','12:10:00',4.92),('9650','2013-06-07','12:15:00',5.15),('9650','2013-06-07','12:20:00',2.32),('9650','2013-06-07','12:25:00',4.71),('9650','2013-06-07','12:30:00',2.2),('9650','2013-06-07','12:35:00',4.92),('9650','2013-06-07','12:40:00',7.09),('9650','2013-06-07','12:45:00',7.3),('9650','2013-06-07','12:50:00',7.38),('9650','2013-06-07','12:55:00',7.35),('9650','2013-06-07','13:00:00',7.43),('9650','2013-06-07','13:05:00',7.34),('9650','2013-06-07','13:10:00',5.72),('9650','2013-06-07','13:15:00',3.95),('9650','2013-06-07','13:20:00',7.73),('9650','2013-06-07','13:25:00',7.61),('9650','2013-06-07','13:30:00',7.69),('9650','2013-06-07','13:35:00',7.59),('9650','2013-06-07','13:40:00',7.53),('9650','2013-06-07','13:45:00',7.44),('9650','2013-06-07','13:50:00',7.48),('9650','2013-06-07','13:55:00',7.49),('9650','2013-06-07','14:00:00',7.53),('9650','2013-06-07','14:05:00',7.54),('9650','2013-06-07','14:10:00',7.57),('9650','2013-06-07','14:15:00',7.59),('9650','2013-06-07','14:20:00',7.59),('9650','2013-06-07','14:25:00',7.59),('9650','2013-06-07','14:30:00',7.56),('9650','2013-06-07','14:35:00',7.54),('9650','2013-06-07','14:40:00',7.62),('9650','2013-06-07','14:45:00',7.56),('9650','2013-06-07','14:50:00',7.64),('9650','2013-06-07','14:55:00',7.63),('9650','2013-06-07','15:00:00',7.66),('9650','2013-06-07','15:05:00',7.45),('9650','2013-06-07','15:10:00',6.88),('9650','2013-06-07','15:15:00',7.12),('9650','2013-06-07','15:20:00',7.59),('9650','2013-06-07','15:25:00',7.14),('9650','2013-06-07','15:30:00',7.26),('9650','2013-06-07','15:35:00',7.37),('9650','2013-06-07','15:40:00',7.31),('9650','2013-06-07','15:45:00',7.27),('9650','2013-06-07','15:50:00',7.56),('9650','2013-06-07','15:55:00',6.93),('9650','2013-06-07','16:00:00',7.2),('9650','2013-06-07','16:05:00',7.27),('9650','2013-06-07','16:10:00',7.3),('9650','2013-06-07','16:15:00',7.33),('9650','2013-06-07','16:20:00',7.18),('9650','2013-06-07','16:25:00',6.95),('9650','2013-06-07','16:30:00',6.7),('9650','2013-06-07','16:35:00',6.66),('9650','2013-06-07','16:40:00',6.62),('9650','2013-06-07','16:45:00',6.58),('9650','2013-06-07','16:50:00',5.64),('9650','2013-06-07','16:55:00',5.71),('9650','2013-06-07','17:00:00',6.42),('9650','2013-06-07','17:05:00',5.98),('9650','2013-06-07','17:10:00',6.74),('9650','2013-06-07','17:15:00',6.61),('9650','2013-06-07','17:20:00',6.37),('9650','2013-06-07','17:25:00',6.09),('9650','2013-06-07','17:30:00',4.44),('9650','2013-06-07','17:35:00',3.38),('9650','2013-06-07','17:40:00',5.19),('9650','2013-06-07','17:45:00',5.57),('9650','2013-06-07','17:50:00',5.01),('9650','2013-06-07','17:55:00',5.45),('9650','2013-06-07','18:00:00',4.46),('9650','2013-06-07','18:05:00',3.99),('9650','2013-06-07','18:10:00',3.35),('9650','2013-06-07','18:15:00',3.31),('9650','2013-06-07','18:20:00',3.29),('9650','2013-06-07','18:25:00',2.87),('9650','2013-06-07','18:30:00',1.66),('9650','2013-06-07','18:35:00',1.45),('9650','2013-06-07','18:40:00',1.07),('9650','2013-06-06','07:55:00',1.01),('9650','2013-06-06','08:00:00',1.1),('9650','2013-06-06','08:05:00',1.17),('9650','2013-06-06','08:10:00',1.22),('9650','2013-06-06','08:15:00',1.25),('9650','2013-06-06','08:20:00',1.27),('9650','2013-06-06','08:25:00',1.32),('9650','2013-06-06','08:30:00',1.88),('9650','2013-06-06','08:35:00',2.05),('9650','2013-06-06','08:40:00',2.17),('9650','2013-06-06','08:45:00',2.32),('9650','2013-06-06','08:50:00',2.44),('9650','2013-06-06','08:55:00',2.57),('9650','2013-06-06','09:00:00',2.7),('9650','2013-06-06','09:05:00',2.85),('9650','2013-06-06','09:10:00',2.98),('9650','2013-06-06','09:15:00',3.13),('9650','2013-06-06','09:20:00',3.26),('9650','2013-06-06','09:25:00',3.38),('9650','2013-06-06','09:30:00',3.59),('9650','2013-06-06','09:35:00',3.76),('9650','2013-06-06','09:40:00',3.9),('9650','2013-06-06','09:45:00',4.06),('9650','2013-06-06','09:50:00',4.16),('9650','2013-06-06','09:55:00',4.28),('9650','2013-06-06','10:00:00',4.37),('9650','2013-06-06','10:05:00',4.53),('9650','2013-06-06','10:10:00',4.61),('9650','2013-06-06','10:15:00',4.71),('9650','2013-06-06','10:20:00',4.88),('9650','2013-06-06','10:25:00',4.99),('9650','2013-06-06','10:30:00',5.08),('9650','2013-06-06','10:35:00',5.19),('9650','2013-06-06','10:40:00',5.31),('9650','2013-06-06','10:45:00',5.44),('9650','2013-06-06','10:50:00',5.53),('9650','2013-06-06','10:55:00',5.63),('9650','2013-06-06','11:00:00',5.75),('9650','2013-06-06','11:05:00',5.86),('9650','2013-06-06','11:10:00',5.96),('9650','2013-06-06','11:15:00',6.01),('9650','2013-06-06','11:20:00',6.08),('9650','2013-06-06','11:25:00',6.17),('9650','2013-06-06','11:30:00',6.27),('9650','2013-06-06','11:35:00',6.35),('9650','2013-06-06','11:40:00',6.43),('9650','2013-06-06','11:45:00',6.49),('9650','2013-06-06','11:50:00',6.55),('9650','2013-06-06','11:55:00',6.65),('9650','2013-06-06','12:00:00',6.69),('9650','2013-06-06','12:05:00',6.75),('9650','2013-06-06','12:10:00',6.82),('9650','2013-06-06','12:15:00',6.87),('9650','2013-06-06','12:20:00',6.93),('9650','2013-06-06','12:25:00',6.93),('9650','2013-06-06','12:30:00',6.98),('9650','2013-06-06','12:35:00',7.01),('9650','2013-06-06','12:40:00',7.07),('9650','2013-06-06','12:45:00',7.16),('9650','2013-06-06','12:50:00',7.16),('9650','2013-06-06','12:55:00',7.22),('9650','2013-06-06','13:00:00',7.28),('9650','2013-06-06','13:05:00',7.29),('9650','2013-06-06','13:10:00',7.28),('9650','2013-06-06','13:15:00',7.31),('9650','2013-06-06','13:20:00',7.35),('9650','2013-06-06','13:25:00',7.4),('9650','2013-06-06','13:30:00',7.43),('9650','2013-06-06','13:35:00',7.43),('9650','2013-06-06','13:40:00',7.39),('9650','2013-06-06','13:45:00',7.39),('9650','2013-06-06','13:50:00',7.4),('9650','2013-06-06','13:55:00',7.44),('9650','2013-06-06','14:00:00',7.44),('9650','2013-06-06','14:05:00',7.45),('9650','2013-06-06','14:10:00',7.43),('9650','2013-06-06','14:15:00',7.41),('9650','2013-06-06','14:20:00',7.39),('9650','2013-06-06','14:25:00',7.38),('9650','2013-06-06','14:30:00',7.39),('9650','2013-06-06','14:35:00',7.31),('9650','2013-06-06','14:40:00',7.4),('9650','2013-06-06','14:45:00',7.44),('9650','2013-06-06','14:50:00',7.48),('9650','2013-06-06','14:55:00',7.41),('9650','2013-06-06','15:00:00',7.4),('9650','2013-06-06','15:05:00',7.51),('9650','2013-06-06','15:10:00',7.49),('9650','2013-06-06','15:15:00',7.38),('9650','2013-06-06','15:20:00',7.33),('9650','2013-06-06','15:25:00',7.43),('9650','2013-06-06','15:30:00',7.41),('9650','2013-06-06','15:35:00',7.35),('9650','2013-06-06','15:40:00',7.27),('9650','2013-06-06','15:45:00',7.25),('9650','2013-06-06','15:50:00',7.13),('9650','2013-06-06','15:55:00',7.07),('9650','2013-06-06','16:00:00',7.07),('9650','2013-06-06','16:05:00',7.01),('9650','2013-06-06','16:10:00',6.73),('9650','2013-06-06','16:15:00',6.47),('9650','2013-06-06','16:20:00',6.56),('9650','2013-06-06','16:25:00',6.61),('9650','2013-06-06','16:30:00',6.76),('9650','2013-06-06','16:35:00',6.7),('9650','2013-06-06','16:40:00',6.59),('9650','2013-06-06','16:45:00',6.56),('9650','2013-06-06','16:50:00',6.5),('9650','2013-06-06','16:55:00',6.45),('9650','2013-06-06','17:00:00',6.35),('9650','2013-06-06','17:05:00',6.23),('9650','2013-06-06','17:10:00',6.14),('9650','2013-06-06','17:15:00',5.88),('9650','2013-06-06','17:20:00',5.72),('9650','2013-06-06','17:25:00',5.7),('9650','2013-06-06','17:30:00',5.64),('9650','2013-06-06','17:35:00',5.5),('9650','2013-06-06','17:40:00',5.41),('9650','2013-06-06','17:45:00',5.4),('9650','2013-06-06','17:50:00',5.39),('9650','2013-06-06','17:55:00',5.19),('9650','2013-06-06','18:00:00',4.93),('9650','2013-06-06','18:05:00',4.81),('9650','2013-06-06','18:10:00',4.64),('9650','2013-06-06','18:15:00',4.43),('9650','2013-06-06','18:20:00',4.23),('9650','2013-06-06','18:25:00',3.91),('9650','2013-06-06','18:30:00',3.84),('9650','2013-06-06','18:35:00',3.79),('9650','2013-06-06','18:40:00',3.64),('9650','2013-06-06','18:45:00',3.38),('9650','2013-06-06','18:50:00',3.22),('9650','2013-06-06','18:55:00',3.11),('9650','2013-06-06','19:00:00',3),('9650','2013-06-06','19:05:00',2.33),('9650','2013-06-06','19:15:00',1.59),('9650','2013-06-06','19:20:00',2.06),('9650','2013-06-06','19:25:00',1.77),('9650','2013-06-06','19:30:00',1.33),('9650','2013-06-06','19:40:00',1.24),('9650','2013-06-06','19:45:00',1.21),('9650','2013-06-05','07:00:00',1.12),('9650','2013-06-05','07:05:00',1.25),('9650','2013-06-05','07:10:00',1.22),('9650','2013-06-05','07:15:00',1.24),('9650','2013-06-05','07:50:00',1.1),('9650','2013-06-05','07:55:00',1.41),('9650','2013-06-05','08:00:00',1.49),('9650','2013-06-05','08:05:00',1.23),('9650','2013-06-05','08:10:00',1.51),('9650','2013-06-05','08:15:00',1.27),('9650','2013-06-05','08:20:00',1.48),('9650','2013-06-05','08:25:00',1.89),('9650','2013-06-05','08:30:00',2.02),('9650','2013-06-05','08:35:00',2.13),('9650','2013-06-05','08:40:00',2.25),('9650','2013-06-05','08:45:00',2.36),('9650','2013-06-05','08:50:00',2.49),('9650','2013-06-05','08:55:00',2.6),('9650','2013-06-05','09:00:00',2.74),('9650','2013-06-05','09:05:00',2.83),('9650','2013-06-05','09:10:00',2.99),('9650','2013-06-05','09:15:00',3.09),('9650','2013-06-05','09:20:00',3.25),('9650','2013-06-05','09:25:00',3.38),('9650','2013-06-05','09:30:00',3.59),('9650','2013-06-05','09:35:00',3.73),('9650','2013-06-05','09:40:00',3.86),('9650','2013-06-05','09:45:00',4.02),('9650','2013-06-05','09:50:00',4.11),('9650','2013-06-05','09:55:00',4.22),('9650','2013-06-05','10:00:00',4.28),('9650','2013-06-05','10:05:00',4.29),('9650','2013-06-05','10:10:00',4.31),('9650','2013-06-05','10:15:00',4.59),('9650','2013-06-05','10:20:00',4.79),('9650','2013-06-05','10:25:00',4.78),('9650','2013-06-05','10:30:00',4.98),('9650','2013-06-05','10:35:00',5.05),('9650','2013-06-05','10:40:00',5.26),('9650','2013-06-05','10:45:00',5.39),('9650','2013-06-05','10:50:00',5.51),('9650','2013-06-05','10:55:00',5.61),('9650','2013-06-05','11:00:00',5.71),('9650','2013-06-05','11:05:00',5.7),('9650','2013-06-05','11:10:00',5.81),('9650','2013-06-05','11:15:00',5.87),('9650','2013-06-05','11:20:00',5.81),('9650','2013-06-05','11:25:00',6.07),('9650','2013-06-05','11:30:00',6.18),('9650','2013-06-05','11:35:00',6.22),('9650','2013-06-05','11:40:00',6.25),('9650','2013-06-05','11:45:00',6.35),('9650','2013-06-05','11:50:00',6.51),('9650','2013-06-05','11:55:00',6.58),('9650','2013-06-05','12:00:00',6.61),('9650','2013-06-05','12:05:00',6.71),('9650','2013-06-05','12:10:00',6.71),('9650','2013-06-05','12:15:00',6.7),('9650','2013-06-05','12:20:00',6.7),('9650','2013-06-05','12:25:00',6.76),('9650','2013-06-05','12:30:00',6.8),('9650','2013-06-05','12:35:00',6.86),('9650','2013-06-05','12:40:00',6.88),('9650','2013-06-05','12:45:00',6.93),('9650','2013-06-05','12:50:00',7.12),('9650','2013-06-05','12:55:00',7.15),('9650','2013-06-05','13:00:00',7.13),('9650','2013-06-05','13:05:00',7.2),('9650','2013-06-05','13:10:00',7.32),('9650','2013-06-05','13:15:00',7.41),('9650','2013-06-05','13:20:00',7.44),('9650','2013-06-05','13:25:00',7.16),('9650','2013-06-05','13:30:00',7.65),('9650','2013-06-05','13:35:00',7.66),('9650','2013-06-05','13:40:00',2.94),('9650','2013-06-05','13:45:00',1.46),('9650','2013-06-05','13:50:00',4.21),('9650','2013-06-05','13:55:00',7.54),('9650','2013-06-05','14:00:00',7.66),('9650','2013-06-05','14:05:00',7.48),('9650','2013-06-05','14:10:00',7.73),('9650','2013-06-05','14:15:00',7.5),('9650','2013-06-05','14:20:00',4.84),('9650','2013-06-05','14:25:00',6.15),('9650','2013-06-05','14:30:00',7.37),('9650','2013-06-05','14:35:00',7.48),('9650','2013-06-05','14:40:00',7.65),('9650','2013-06-05','14:45:00',5.58),('9650','2013-06-05','14:50:00',7.96),('9650','2013-06-05','14:55:00',7.56),('9650','2013-06-05','15:00:00',7.1),('9650','2013-06-05','15:05:00',7.59),('9650','2013-06-05','15:10:00',7.52),('9650','2013-06-05','15:15:00',7.29),('9650','2013-06-05','15:20:00',7.33),('9650','2013-06-05','15:25:00',5.57),('9650','2013-06-05','15:30:00',7.03),('9650','2013-06-05','15:35:00',7.28),('9650','2013-06-05','15:40:00',6.99),('9650','2013-06-05','15:45:00',7.12),('9650','2013-06-05','15:50:00',6.98),('9650','2013-06-05','15:55:00',7),('9650','2013-06-05','16:00:00',6.87),('9650','2013-06-05','16:05:00',7.04),('9650','2013-06-05','16:10:00',6.83),('9650','2013-06-05','16:15:00',6.45),('9650','2013-06-05','16:20:00',6.5),('9650','2013-06-05','16:25:00',6.47),('9650','2013-06-05','16:30:00',6.43),('9650','2013-06-05','16:35:00',6.45),('9650','2013-06-05','16:40:00',6.4),('9650','2013-06-05','16:45:00',6.24),('9650','2013-06-05','16:50:00',6.11),('9650','2013-06-05','16:55:00',5.98),('9650','2013-06-05','17:00:00',5.85),('9650','2013-06-05','17:05:00',5.74),('9650','2013-06-05','17:10:00',5.73),('9650','2013-06-05','17:15:00',5.58),('9650','2013-06-05','17:20:00',5.44),('9650','2013-06-05','17:25:00',5.4),('9650','2013-06-05','17:30:00',5.4),('9650','2013-06-05','17:35:00',5.2),('9650','2013-06-05','17:40:00',5.06),('9650','2013-06-05','17:45:00',4.98),('9650','2013-06-05','17:50:00',4.85),('9650','2013-06-05','17:55:00',4.68),('9650','2013-06-05','18:00:00',4.61),('9650','2013-06-05','18:05:00',4.55),('9650','2013-06-05','18:10:00',4.37),('9650','2013-06-05','18:15:00',4.15),('9650','2013-06-05','18:20:00',3.99),('9650','2013-06-05','18:25:00',3.84),('9650','2013-06-05','18:30:00',3.7),('9650','2013-06-05','18:35:00',3.61),('9650','2013-06-05','18:40:00',3.48),('9650','2013-06-05','18:45:00',3.29),('9650','2013-06-05','18:50:00',3.12),('9650','2013-06-05','18:55:00',2.98),('9650','2013-06-05','19:00:00',2.79),('9650','2013-06-05','19:05:00',2.62),('9650','2013-06-05','19:10:00',2.44),('9650','2013-06-05','19:15:00',2.27),('9650','2013-06-05','19:20:00',2.11),('9650','2013-06-05','19:25:00',1.89),('9650','2013-06-05','19:30:00',1.67),('9650','2013-06-05','19:35:00',1.49),('9650','2013-06-05','19:40:00',1.32),('9650','2013-06-05','19:45:00',1.12),('9650','2013-06-04','07:50:00',1.6),('9650','2013-06-04','07:55:00',1.79),('9650','2013-06-04','08:00:00',1.72),('9650','2013-06-04','08:05:00',1.39),('9650','2013-06-04','08:10:00',1.36),('9650','2013-06-04','08:15:00',1.56),('9650','2013-06-04','08:20:00',1.66),('9650','2013-06-04','08:25:00',1.83),('9650','2013-06-04','08:30:00',1.98),('9650','2013-06-04','08:35:00',2.11),('9650','2013-06-04','08:40:00',2.21),('9650','2013-06-04','08:45:00',2.35),('9650','2013-06-04','08:50:00',2.47),('9650','2013-06-04','08:55:00',2.59),('9650','2013-06-04','09:00:00',2.83),('9650','2013-06-04','09:05:00',3.02),('9650','2013-06-04','09:10:00',2.91),('9650','2013-06-04','09:15:00',3.36),('9650','2013-06-04','09:20:00',3.86),('9650','2013-06-04','09:25:00',4.16),('9650','2013-06-04','09:30:00',4.25),('9650','2013-06-04','09:35:00',2.22),('9650','2013-06-04','09:40:00',1.94),('9650','2013-06-04','09:45:00',2.71),('9650','2013-06-04','09:50:00',2.02),('9650','2013-06-04','09:55:00',2.13),('9650','2013-06-04','10:00:00',5.38),('9650','2013-06-04','10:05:00',3.2),('9650','2013-06-04','10:10:00',3.96),('9650','2013-06-04','10:15:00',2.68),('9650','2013-06-04','10:20:00',2.37),('9650','2013-06-04','10:25:00',2.38),('9650','2013-06-04','10:30:00',2.3),('9650','2013-06-04','10:35:00',2.35),('9650','2013-06-04','10:40:00',2.55),('9650','2013-06-04','10:45:00',6.12),('9650','2013-06-04','10:50:00',6.1),('9650','2013-06-04','10:55:00',5.59),('9650','2013-06-04','11:00:00',6.06),('9650','2013-06-04','11:05:00',4.2),('9650','2013-06-04','11:10:00',2.26),('9650','2013-06-04','11:15:00',1.99),('9650','2013-06-04','11:20:00',1.87),('9650','2013-06-04','11:25:00',1.9),('9650','2013-06-04','11:30:00',2.16),('9650','2013-06-04','11:35:00',6.14),('9650','2013-06-04','11:40:00',7.51),('9650','2013-06-04','11:45:00',5.31),('9650','2013-06-04','11:50:00',2.69),('9650','2013-06-04','11:55:00',7.48),('9650','2013-06-04','12:00:00',7.76),('9650','2013-06-04','12:05:00',7.62),('9650','2013-06-04','12:10:00',7.68),('9650','2013-06-04','12:15:00',7.73),('9650','2013-06-04','12:20:00',8.11),('9650','2013-06-04','12:25:00',7.97),('9650','2013-06-04','12:30:00',8.28),('9650','2013-06-04','12:35:00',3.8),('9650','2013-06-04','12:40:00',7.89),('9650','2013-06-04','12:45:00',8.85),('9650','2013-06-04','12:50:00',4.52),('9650','2013-06-04','12:55:00',4.23),('9650','2013-06-04','13:00:00',7.7),('9650','2013-06-04','13:05:00',5.06),('9650','2013-06-04','13:10:00',7.14),('9650','2013-06-04','13:15:00',5.33),('9650','2013-06-04','13:20:00',4.86),('9650','2013-06-04','13:25:00',5.24),('9650','2013-06-04','13:30:00',6.72),('9650','2013-06-04','13:35:00',8.32),('9650','2013-06-04','13:40:00',7.94),('9650','2013-06-04','13:45:00',7.92),('9650','2013-06-04','13:50:00',7.84),('9650','2013-06-04','13:55:00',7.82),('9650','2013-06-04','14:00:00',7.81),('9650','2013-06-04','14:05:00',7.84),('9650','2013-06-04','14:10:00',7.44),('9650','2013-06-04','14:15:00',7.7),('9650','2013-06-04','14:20:00',7.76),('9650','2013-06-04','14:25:00',7.74),('9650','2013-06-04','14:30:00',7.3),('9650','2013-06-04','14:35:00',7.8),('9650','2013-06-04','14:40:00',7.76),('9650','2013-06-04','14:45:00',7.8),('9650','2013-06-04','14:50:00',7.81),('9650','2013-06-04','14:55:00',7.79),('9650','2013-06-04','15:00:00',7.66),('9650','2013-06-04','15:05:00',7.67),('9650','2013-06-04','15:10:00',7.59),('9650','2013-06-04','15:15:00',7.62),('9650','2013-06-04','15:20:00',7.61),('9650','2013-06-04','15:25:00',7.62),('9650','2013-06-04','15:30:00',7.7),('9650','2013-06-04','15:35:00',7.76),('9650','2013-06-04','15:40:00',7.63),('9650','2013-06-04','15:45:00',7.53),('9650','2013-06-04','15:50:00',7.4),('9650','2013-06-04','15:55:00',7.4),('9650','2013-06-04','16:00:00',7.35),('9650','2013-06-04','16:05:00',7.17),('9650','2013-06-04','16:10:00',6.87),('9650','2013-06-04','16:15:00',7.21),('9650','2013-06-04','16:20:00',7.1),('9650','2013-06-04','16:25:00',7.04),('9650','2013-06-04','16:30:00',6.94),('9650','2013-06-04','16:35:00',6.84),('9650','2013-06-04','16:40:00',6.78),('9650','2013-06-04','16:45:00',6.79),('9650','2013-06-04','16:50:00',6.69),('9650','2013-06-04','16:55:00',6.63),('9650','2013-06-04','17:00:00',3.59),('9650','2013-06-04','17:05:00',5.15),('9650','2013-06-04','17:10:00',2.82),('9650','2013-06-04','17:15:00',5.28),('9650','2013-06-04','17:20:00',4.79),('9650','2013-06-04','17:25:00',5.85),('9650','2013-06-04','17:30:00',4.77),('9650','2013-06-04','17:35:00',3.98),('9650','2013-06-04','17:40:00',4.97),('9650','2013-06-04','17:45:00',5.39),('9650','2013-06-04','17:50:00',5.18),('9650','2013-06-04','17:55:00',4.99),('9650','2013-06-04','18:00:00',4.63),('9650','2013-06-04','18:05:00',3.86),('9650','2013-06-04','18:10:00',3.03),('9650','2013-06-04','18:15:00',2.96),('9650','2013-06-04','18:20:00',1.55),('9650','2013-06-04','18:25:00',3.52),('9650','2013-06-04','18:30:00',4.04),('9650','2013-06-04','18:35:00',3.99),('9650','2013-06-04','18:40:00',2.87),('9650','2013-06-04','18:45:00',1.4),('9650','2013-06-04','18:50:00',1.43),('9650','2013-06-04','18:55:00',2.96),('9650','2013-06-04','19:00:00',2.54),('9650','2013-06-04','19:05:00',1.79),('9650','2013-06-04','19:10:00',2.45),('9650','2013-06-04','19:25:00',1.49),('9650','2013-06-04','19:30:00',1.55),('9650','2013-06-04','19:35:00',1.69),('9650','2013-06-04','19:40:00',1.53),('9650','2013-06-04','19:45:00',1.3),('9650','2013-06-04','19:50:00',1.08),('9650','2013-06-03','07:35:00',1.03),('9650','2013-06-03','07:40:00',1.19),('9650','2013-06-03','07:45:00',1.5),('9650','2013-06-03','07:50:00',1.71),('9650','2013-06-03','07:55:00',1.89),('9650','2013-06-03','08:00:00',2.21),('9650','2013-06-03','08:05:00',2.39),('9650','2013-06-03','08:10:00',2.37),('9650','2013-06-03','08:15:00',2.4),('9650','2013-06-03','08:20:00',2.39),('9650','2013-06-03','08:25:00',2.48),('9650','2013-06-03','08:30:00',2.94),('9650','2013-06-03','08:35:00',2.98),('9650','2013-06-03','08:40:00',2.98),('9650','2013-06-03','08:45:00',2.73),('9650','2013-06-03','08:50:00',2.4),('9650','2013-06-03','08:55:00',2.52),('9650','2013-06-03','09:00:00',2.66),('9650','2013-06-03','09:05:00',2.69),('9650','2013-06-03','09:10:00',3.5),('9650','2013-06-03','09:15:00',4.25),('9650','2013-06-03','09:20:00',4.56),('9650','2013-06-03','09:25:00',4.17),('9650','2013-06-03','09:30:00',4.65),('9650','2013-06-03','09:35:00',3.41),('9650','2013-06-03','09:40:00',2.8),('9650','2013-06-03','09:45:00',3.04),('9650','2013-06-03','09:50:00',3.11),('9650','2013-06-03','09:55:00',2.98),('9650','2013-06-03','10:00:00',3.5),('9650','2013-06-03','10:05:00',4.29),('9650','2013-06-03','10:10:00',4.1),('9650','2013-06-03','10:15:00',3.14),('9650','2013-06-03','10:20:00',3.23),('9650','2013-06-03','10:25:00',3.13),('9650','2013-06-03','10:30:00',2.96),('9650','2013-06-03','10:35:00',3.03),('9650','2013-06-03','10:40:00',3.3),('9650','2013-06-03','10:45:00',3.84),('9650','2013-06-03','10:50:00',5.13),('9650','2013-06-03','10:55:00',4.62),('9650','2013-06-03','11:00:00',3.67),('9650','2013-06-03','11:05:00',4.58),('9650','2013-06-03','11:10:00',5.93),('9650','2013-06-03','11:15:00',5.07),('9650','2013-06-03','11:20:00',3.77),('9650','2013-06-03','11:25:00',4.58),('9650','2013-06-03','11:30:00',5.51),('9650','2013-06-03','11:35:00',4.89),('9650','2013-06-03','11:40:00',5.16),('9650','2013-06-03','11:45:00',6.2),('9650','2013-06-03','11:50:00',7.6),('9650','2013-06-03','11:55:00',7),('9650','2013-06-03','12:00:00',4.16),('9650','2013-06-03','12:05:00',6.88),('9650','2013-06-03','12:10:00',4.32),('9650','2013-06-03','12:15:00',4.31),('9650','2013-06-03','12:20:00',3.12),('9650','2013-06-03','12:25:00',3.34),('9650','2013-06-03','12:30:00',5.15),('9650','2013-06-03','12:35:00',6.33),('9650','2013-06-03','12:40:00',4.06),('9650','2013-06-03','12:45:00',5.27),('9650','2013-06-03','12:50:00',4.14),('9650','2013-06-03','12:55:00',3.37),('9650','2013-06-03','13:00:00',3.04),('9650','2013-06-03','13:05:00',2.44),('9650','2013-06-03','13:10:00',2.41),('9650','2013-06-03','13:15:00',2.03),('9650','2013-06-03','13:20:00',2.14),('9650','2013-06-03','13:25:00',2.69),('9650','2013-06-03','13:30:00',3.53),('9650','2013-06-03','13:35:00',4.99),('9650','2013-06-03','13:40:00',6.54),('9650','2013-06-03','13:45:00',6.12),('9650','2013-06-03','13:50:00',6.09),('9650','2013-06-03','13:55:00',7),('9650','2013-06-03','14:00:00',3.95),('9650','2013-06-03','14:05:00',6.99),('9650','2013-06-03','14:10:00',8.21),('9650','2013-06-03','14:15:00',3.73),('9650','2013-06-03','14:20:00',8.43),('9650','2013-06-03','14:25:00',3.39),('9650','2013-06-03','14:30:00',2.21),('9650','2013-06-03','14:35:00',2.93),('9650','2013-06-03','14:40:00',4.7),('9650','2013-06-03','14:45:00',2.18),('9650','2013-06-03','14:50:00',2.26),('9650','2013-06-03','14:55:00',7.42),('9650','2013-06-03','15:00:00',8.92),('9650','2013-06-03','15:05:00',7.57),('9650','2013-06-03','15:10:00',2.69),('9650','2013-06-03','15:15:00',2.67),('9650','2013-06-03','15:20:00',2.05),('9650','2013-06-03','15:25:00',1.45),('9650','2013-06-03','17:15:00',1.59),('9650','2013-06-03','17:20:00',1.44),('9650','2013-06-03','17:25:00',1.14),('9650','2013-06-03','17:35:00',1.32),('9650','2013-06-03','17:40:00',2.4),('9650','2013-06-03','17:45:00',1.22),('9650','2013-06-03','17:50:00',1.15),('9650','2013-06-03','17:55:00',1.3),('9650','2013-06-03','18:00:00',1.42),('9650','2013-06-03','18:05:00',1.71),('9650','2013-06-03','18:10:00',1.72),('9650','2013-06-03','18:15:00',1.53),('9650','2013-06-03','18:20:00',1.4),('9650','2013-06-03','18:25:00',1.25),('9650','2013-06-03','18:30:00',1.29),('9650','2013-06-03','18:35:00',1.05),('9650','2013-06-03','18:40:00',1.99),('9650','2013-06-03','18:45:00',2.28),('9650','2013-06-03','18:50:00',1.74),('9650','2013-06-03','18:55:00',1.26),('9650','2013-06-03','19:00:00',1.1),('9650','2013-06-03','19:05:00',1.07),('9650','2013-06-02','07:45:00',1.04),('9650','2013-06-02','07:50:00',1.16),('9650','2013-06-02','07:55:00',1.22),('9650','2013-06-02','08:00:00',1.27),('9650','2013-06-02','08:05:00',1.31),('9650','2013-06-02','08:10:00',1.33),('9650','2013-06-02','08:15:00',1.38),('9650','2013-06-02','08:20:00',1.69),('9650','2013-06-02','08:25:00',1.86),('9650','2013-06-02','08:30:00',2.02),('9650','2013-06-02','08:35:00',2.17),('9650','2013-06-02','08:40:00',2.3),('9650','2013-06-02','08:45:00',2.42),('9650','2013-06-02','08:50:00',2.6),('9650','2013-06-02','08:55:00',2.75),('9650','2013-06-02','09:00:00',2.87),('9650','2013-06-02','09:05:00',3),('9650','2013-06-02','09:10:00',3.24),('9650','2013-06-02','09:15:00',3.57),('9650','2013-06-02','09:20:00',4.2),('9650','2013-06-02','09:25:00',3.79),('9650','2013-06-02','09:30:00',3.22),('9650','2013-06-02','09:35:00',2.84),('9650','2013-06-02','09:40:00',4.09),('9650','2013-06-02','09:45:00',4.89),('9650','2013-06-02','09:50:00',3.99),('9650','2013-06-02','09:55:00',5.94),('9650','2013-06-02','10:00:00',5.66),('9650','2013-06-02','10:05:00',6.17),('9650','2013-06-02','10:10:00',4.01),('9650','2013-06-02','10:15:00',2.16),('9650','2013-06-02','10:20:00',1.55),('9650','2013-06-02','10:25:00',1.51),('9650','2013-06-02','10:30:00',1.78),('9650','2013-06-02','10:35:00',1.98),('9650','2013-06-02','10:40:00',2.21),('9650','2013-06-02','10:45:00',3.06),('9650','2013-06-02','10:50:00',3.73),('9650','2013-06-02','10:55:00',4.79),('9650','2013-06-02','11:00:00',4.25),('9650','2013-06-02','11:05:00',3.68),('9650','2013-06-02','11:10:00',2.55),('9650','2013-06-02','11:15:00',2.21),('9650','2013-06-02','11:20:00',2.64),('9650','2013-06-02','11:25:00',2.56),('9650','2013-06-02','11:30:00',2.8),('9650','2013-06-02','11:35:00',2.3),('9650','2013-06-02','11:40:00',2.34),('9650','2013-06-02','11:45:00',3),('9650','2013-06-02','11:50:00',2.72),('9650','2013-06-02','11:55:00',2.77),('9650','2013-06-02','12:00:00',2.89),('9650','2013-06-02','12:05:00',2.69),('9650','2013-06-02','12:10:00',2.85),('9650','2013-06-02','12:15:00',3.06),('9650','2013-06-02','12:20:00',2.93),('9650','2013-06-02','12:25:00',2.24),('9650','2013-06-02','12:30:00',2.58),('9650','2013-06-02','12:35:00',4.97),('9650','2013-06-02','12:40:00',8.07),('9650','2013-06-02','12:45:00',5.01),('9650','2013-06-02','12:50:00',3.75),('9650','2013-06-02','12:55:00',6.69),('9650','2013-06-02','13:00:00',4.29),('9650','2013-06-02','13:05:00',3.73),('9650','2013-06-02','13:10:00',3.67),('9650','2013-06-02','13:15:00',7.91),('9650','2013-06-02','13:20:00',9.48),('9650','2013-06-02','13:25:00',9.05),('9650','2013-06-02','13:30:00',6.13),('9650','2013-06-02','13:35:00',8.5),('9650','2013-06-02','13:40:00',8.24),('9650','2013-06-02','13:45:00',6.73),('9650','2013-06-02','13:50:00',7.7),('9650','2013-06-02','13:55:00',3.3),('9650','2013-06-02','14:00:00',6.76),('9650','2013-06-02','14:05:00',6.01),('9650','2013-06-02','14:10:00',3.95),('9650','2013-06-02','14:15:00',4.94),('9650','2013-06-02','14:20:00',5.13),('9650','2013-06-02','14:25:00',5.48),('9650','2013-06-02','14:30:00',8.69),('9650','2013-06-02','14:35:00',8.59),('9650','2013-06-02','14:40:00',7),('9650','2013-06-02','14:45:00',4.81),('9650','2013-06-02','14:50:00',5.15),('9650','2013-06-02','14:55:00',6.18),('9650','2013-06-02','15:00:00',7.75),('9650','2013-06-02','15:05:00',7.76),('9650','2013-06-02','15:10:00',7.39),('9650','2013-06-02','15:15:00',8.66),('9650','2013-06-02','15:20:00',6.03),('9650','2013-06-02','15:25:00',7.6),('9650','2013-06-02','15:30:00',7.75),('9650','2013-06-02','15:35:00',7.67),('9650','2013-06-02','15:40:00',7.55),('9650','2013-06-02','15:45:00',7.45),('9650','2013-06-02','15:50:00',7.45),('9650','2013-06-02','15:55:00',7.43),('9650','2013-06-02','16:00:00',7.36),('9650','2013-06-02','16:05:00',7.33),('9650','2013-06-02','16:10:00',7.41),('9650','2013-06-02','16:15:00',7.22),('9650','2013-06-02','16:20:00',6.84),('9650','2013-06-02','16:25:00',7.04),('9650','2013-06-02','16:30:00',7.49),('9650','2013-06-02','16:35:00',7.11),('9650','2013-06-02','16:40:00',7.17),('9650','2013-06-02','16:45:00',6.03),('9650','2013-06-02','16:50:00',4.9),('9650','2013-06-02','16:55:00',4.06),('9650','2013-06-02','17:00:00',5.67),('9650','2013-06-02','17:05:00',6.64),('9650','2013-06-02','17:10:00',6.64),('9650','2013-06-02','17:15:00',5.28),('9650','2013-06-02','17:20:00',4.52),('9650','2013-06-02','17:25:00',3.11),('9650','2013-06-02','17:30:00',1.54),('9650','2013-06-02','17:35:00',1.21),('9650','2013-06-02','17:40:00',1.29),('9650','2013-06-02','17:45:00',1.08),('9650','2013-06-02','17:50:00',1.13),('9650','2013-06-02','17:55:00',1.14),('9650','2013-06-01','06:55:00',1.13),('9650','2013-06-01','07:00:00',1.05),('9650','2013-06-01','08:20:00',1.04),('9650','2013-06-01','08:25:00',1.44),('9650','2013-06-01','08:30:00',1.47),('9650','2013-06-01','08:35:00',1.58),('9650','2013-06-01','08:40:00',1.57),('9650','2013-06-01','08:45:00',1.81),('9650','2013-06-01','08:50:00',1.78),('9650','2013-06-01','08:55:00',1.62),('9650','2013-06-01','09:00:00',1.66),('9650','2013-06-01','09:05:00',1.8),('9650','2013-06-01','09:10:00',1.82),('9650','2013-06-01','09:15:00',1.73),('9650','2013-06-01','09:20:00',2.42),('9650','2013-06-01','09:25:00',3.85),('9650','2013-06-01','09:30:00',3.87),('9650','2013-06-01','09:35:00',3.91),('9650','2013-06-01','09:40:00',3.84),('9650','2013-06-01','09:45:00',4.12),('9650','2013-06-01','09:50:00',4.26),('9650','2013-06-01','09:55:00',4.42),('9650','2013-06-01','10:00:00',4.49),('9650','2013-06-01','10:05:00',4.63),('9650','2013-06-01','10:10:00',4.67),('9650','2013-06-01','10:15:00',4.81),('9650','2013-06-01','10:20:00',4.96),('9650','2013-06-01','10:25:00',4.82),('9650','2013-06-01','10:30:00',2.8),('9650','2013-06-01','10:35:00',4.2),('9650','2013-06-01','10:40:00',4.06),('9650','2013-06-01','10:45:00',4.57),('9650','2013-06-01','10:50:00',2.23),('9650','2013-06-01','10:55:00',6.58),('9650','2013-06-01','11:00:00',6.84),('9650','2013-06-01','11:05:00',7.25),('9650','2013-06-01','11:10:00',3.22),('9650','2013-06-01','11:15:00',4.43),('9650','2013-06-01','11:20:00',5.76),('9650','2013-06-01','11:25:00',6.17),('9650','2013-06-01','11:30:00',3.71),('9650','2013-06-01','11:35:00',2.99),('9650','2013-06-01','11:50:00',2.6),('9650','2013-06-01','11:55:00',6.82),('9650','2013-06-01','12:00:00',3.1),('9650','2013-06-01','12:05:00',2.53),('9650','2013-06-01','12:10:00',4.41),('9650','2013-06-01','12:15:00',6.09),('9650','2013-06-01','12:20:00',3.26),('9650','2013-06-01','12:25:00',5.38),('9650','2013-06-01','12:30:00',5.64),('9650','2013-06-01','12:35:00',7.01),('9650','2013-06-01','12:40:00',4.69),('9650','2013-06-01','12:45:00',6.89),('9650','2013-06-01','12:50:00',2.45),('9650','2013-06-01','12:55:00',6.58),('9650','2013-06-01','13:00:00',3.45),('9650','2013-06-01','13:05:00',2.69),('9650','2013-06-01','13:10:00',5.34),('9650','2013-06-01','13:15:00',8.16),('9650','2013-06-01','13:20:00',7.83),('9650','2013-06-01','13:25:00',7.7),('9650','2013-06-01','13:30:00',7.69),('9650','2013-06-01','13:35:00',7.69),('9650','2013-06-01','13:40:00',7.68),('9650','2013-06-01','13:45:00',7.71),('9650','2013-06-01','13:50:00',7.71),('9650','2013-06-01','13:55:00',7.75),('9650','2013-06-01','14:00:00',7.74),('9650','2013-06-01','14:05:00',7.77),('9650','2013-06-01','14:10:00',7.92),('9650','2013-06-01','14:15:00',7.84),('9650','2013-06-01','14:20:00',7.82),('9650','2013-06-01','14:25:00',7.81),('9650','2013-06-01','14:30:00',7.83),('9650','2013-06-01','14:35:00',7.83),('9650','2013-06-01','14:40:00',7.79),('9650','2013-06-01','14:45:00',7.79),('9650','2013-06-01','14:50:00',7.8),('9650','2013-06-01','14:55:00',7.71),('9650','2013-06-01','15:00:00',7.71),('9650','2013-06-01','15:05:00',7.69),('9650','2013-06-01','15:10:00',7.68),('9650','2013-06-01','15:15:00',7.72),('9650','2013-06-01','15:20:00',6.41),('9650','2013-06-01','15:25:00',6.36),('9650','2013-06-01','15:30:00',7.35),('9650','2013-06-01','15:35:00',5.09),('9650','2013-06-01','15:40:00',5.44),('9650','2013-06-01','15:45:00',6.82),('9650','2013-06-01','15:50:00',5.01),('9650','2013-06-01','15:55:00',6.94),('9650','2013-06-01','16:00:00',7.7),('9650','2013-06-01','16:05:00',6.69),('9650','2013-06-01','16:10:00',7.14),('9650','2013-06-01','16:15:00',7.29),('9650','2013-06-01','16:20:00',7.33),('9650','2013-06-01','16:25:00',7.19),('9650','2013-06-01','16:30:00',6.98),('9650','2013-06-01','16:35:00',6.93),('9650','2013-06-01','16:40:00',6.95),('9650','2013-06-01','16:45:00',5.97),('9650','2013-06-01','16:50:00',6.66),('9650','2013-06-01','16:55:00',6.56),('9650','2013-06-01','17:00:00',6),('9650','2013-06-01','17:05:00',5.96),('9650','2013-06-01','17:10:00',6.25),('9650','2013-06-01','17:15:00',6.19),('9650','2013-06-01','17:20:00',5.86),('9650','2013-06-01','17:25:00',5.87),('9650','2013-06-01','17:30:00',4.53),('9650','2013-06-01','17:35:00',4.09),('9650','2013-06-01','17:40:00',3),('9650','2013-06-01','17:45:00',2.65),('9650','2013-06-01','17:50:00',4.07),('9650','2013-06-01','17:55:00',1.92),('9650','2013-06-01','18:00:00',1.71),('9650','2013-06-01','18:05:00',1.19),('9650','2013-06-01','18:10:00',1.52),('9650','2013-06-01','18:15:00',1.55),('9650','2013-06-01','18:20:00',1.21),('9650','2013-06-01','18:25:00',1.24),('9650','2013-06-01','18:30:00',1.5),('9650','2013-06-01','18:35:00',1.3),('9650','2013-06-01','18:40:00',1.15),('9650','2013-06-01','18:45:00',1.04),('9650','2013-06-01','18:50:00',1.01),('9650','2013-06-01','19:15:00',1.54),('9650','2013-06-01','19:20:00',2.17),('9650','2013-06-01','19:25:00',1.94),('9650','2013-06-01','19:30:00',1.55),('9650','2013-06-01','19:35:00',1.16),('9650','2013-05-31','07:45:00',1.22),('9650','2013-05-31','07:50:00',1.5),('9650','2013-05-31','07:55:00',1.92),('9650','2013-05-31','08:00:00',1.2),('9650','2013-05-31','08:05:00',1.14),('9650','2013-05-31','08:10:00',1.35),('9650','2013-05-31','08:15:00',1.84),('9650','2013-05-31','08:20:00',1.52),('9650','2013-05-31','08:25:00',1.29),('9650','2013-05-31','08:30:00',1.89),('9650','2013-05-31','08:35:00',2.1),('9650','2013-05-31','08:40:00',1.44),('9650','2013-05-31','08:45:00',1.07),('9650','2013-05-31','08:50:00',1.43),('9650','2013-05-31','08:55:00',1.3),('9650','2013-05-31','09:00:00',1.63),('9650','2013-05-31','09:05:00',1.08),('9650','2013-05-31','09:40:00',1.16),('9650','2013-05-31','09:45:00',1.57),('9650','2013-05-31','09:50:00',1.63),('9650','2013-05-31','09:55:00',1.18),('9650','2013-05-31','10:00:00',1.12),('9650','2013-05-31','10:05:00',1.29),('9650','2013-05-31','10:10:00',1.21),('9650','2013-05-31','10:30:00',1.35),('9650','2013-05-31','10:35:00',2.25),('9650','2013-05-31','10:40:00',1.99),('9650','2013-05-31','10:45:00',1.7),('9650','2013-05-31','10:50:00',4.18),('9650','2013-05-31','10:55:00',4.23),('9650','2013-05-31','11:00:00',1.15),('9650','2013-05-31','11:45:00',1.03),('9650','2013-05-31','11:50:00',2.47),('9650','2013-05-31','11:55:00',3.11),('9650','2013-05-31','12:00:00',5.45),('9650','2013-05-31','12:05:00',4.87),('9650','2013-05-31','12:10:00',5.27),('9650','2013-05-31','12:15:00',2.28),('9650','2013-05-31','12:20:00',1.6),('9650','2013-05-31','12:25:00',2.04),('9650','2013-05-31','12:30:00',1.99),('9650','2013-05-31','12:35:00',1.54),('9650','2013-05-31','12:40:00',1.86),('9650','2013-05-31','12:45:00',3.17),('9650','2013-05-31','12:50:00',3.61),('9650','2013-05-31','12:55:00',3.73),('9650','2013-05-31','13:00:00',3.92),('9650','2013-05-31','13:05:00',4.06),('9650','2013-05-31','13:10:00',4.28),('9650','2013-05-31','13:15:00',4.52),('9650','2013-05-31','13:20:00',3.84),('9650','2013-05-31','13:25:00',3.34),('9650','2013-05-31','13:30:00',2.91),('9650','2013-05-31','13:35:00',2.29),('9650','2013-05-31','13:40:00',1.98),('9650','2013-05-31','13:45:00',2.07),('9650','2013-05-31','13:50:00',2.27),('9650','2013-05-31','13:55:00',2.62),('9650','2013-05-31','14:00:00',3.65),('9650','2013-05-31','14:05:00',4.3),('9650','2013-05-31','14:10:00',4.31),('9650','2013-05-31','14:15:00',4.55),('9650','2013-05-31','14:20:00',4.38),('9650','2013-05-31','14:25:00',3.02),('9650','2013-05-31','14:30:00',2.53),('9650','2013-05-31','14:35:00',2.53),('9650','2013-05-31','14:40:00',2.3),('9650','2013-05-31','14:45:00',2.1),('9650','2013-05-31','14:50:00',2.01),('9650','2013-05-31','14:55:00',1.61),('9650','2013-05-31','15:00:00',1.61),('9650','2013-05-31','15:05:00',1.52),('9650','2013-05-31','15:10:00',1.3),('9650','2013-05-31','15:15:00',1.43),('9650','2013-05-31','15:20:00',1.34),('9650','2013-05-31','15:25:00',1.07),('9650','2013-05-31','15:45:00',1.15),('9650','2013-05-31','15:50:00',1.1),('9650','2013-05-31','15:55:00',1.2),('9650','2013-05-31','16:00:00',1.26),('9650','2013-05-31','16:05:00',1.35),('9650','2013-05-31','16:10:00',1.21),('9650','2013-05-31','16:15:00',1.36),('9650','2013-05-31','16:20:00',1.46),('9650','2013-05-31','16:25:00',1.17),('9650','2013-05-31','16:30:00',1.44),('9650','2013-05-31','16:35:00',1.54),('9650','2013-05-31','16:40:00',1.69),('9650','2013-05-31','16:45:00',1.45),('9650','2013-05-31','16:50:00',1.34),('9650','2013-05-31','16:55:00',1.15),('9650','2013-05-31','18:30:00',1.46),('9650','2013-05-31','18:35:00',1.73),('9650','2013-05-31','18:40:00',1.3),('9650','2013-05-31','18:45:00',1.28),('9650','2013-05-31','18:50:00',1.25),('9650','2013-05-31','18:55:00',2.12),('9650','2013-05-31','19:00:00',4.56),('9650','2013-05-31','19:05:00',2.35),('9650','2013-05-31','19:45:00',1.66),('9650','2013-05-31','19:50:00',1.28),('9650','2014-04-01','08:35:00',1.11),('9650','2014-04-01','08:40:00',1.23),('9650','2014-04-01','08:45:00',1.24),('9650','2014-04-01','08:50:00',1.58),('9650','2014-04-01','08:55:00',1.67),('9650','2014-04-01','09:00:00',1.22),('9650','2014-04-01','09:05:00',1.01),('9650','2014-04-01','09:10:00',1.08),('9650','2014-04-01','09:15:00',1.24),('9650','2014-04-01','09:20:00',1.18),('9650','2014-04-01','09:25:00',1.07),('9650','2014-04-01','09:30:00',1.05),('9650','2014-04-01','09:35:00',1.28),('9650','2014-04-01','09:40:00',1.25),('9650','2014-04-01','09:45:00',1.17),('9650','2014-04-01','09:50:00',1.28),('9650','2014-04-01','09:55:00',2.77),('9650','2014-04-01','10:00:00',2.57),('9650','2014-04-01','10:05:00',3.1),('9650','2014-04-01','10:10:00',3.67),('9650','2014-04-01','10:15:00',4.14),('9650','2014-04-01','10:20:00',4.07),('9650','2014-04-01','10:25:00',3.34),('9650','2014-04-01','10:30:00',2.39),('9650','2014-04-01','10:35:00',1.87),('9650','2014-04-01','10:40:00',2.08),('9650','2014-04-01','10:45:00',2.02),('9650','2014-04-01','10:50:00',3.19),('9650','2014-04-01','10:55:00',4.52),('9650','2014-04-01','11:00:00',4.36),('9650','2014-04-01','11:05:00',3.22),('9650','2014-04-01','11:10:00',1.88),('9650','2014-04-01','11:15:00',3.79),('9650','2014-04-01','11:20:00',4.52),('9650','2014-04-01','11:25:00',5.56),('9650','2014-04-01','11:30:00',5.77),('9650','2014-04-01','11:35:00',2.37),('9650','2014-04-01','11:40:00',1.98),('9650','2014-04-01','11:45:00',3.5),('9650','2014-04-01','11:50:00',5.13),('9650','2014-04-01','11:55:00',5.91),('9650','2014-04-01','12:00:00',6.73),('9650','2014-04-01','12:05:00',4.1),('9650','2014-04-01','12:10:00',2.03),('9650','2014-04-01','12:15:00',5.46),('9650','2014-04-01','12:20:00',6.25),('9650','2014-04-01','12:25:00',2.97),('9650','2014-04-01','12:30:00',5.74),('9650','2014-04-01','12:35:00',6.99),('9650','2014-04-01','12:40:00',6.28),('9650','2014-04-01','12:45:00',5.19),('9650','2014-04-01','12:50:00',6.69),('9650','2014-04-01','12:55:00',4.19),('9650','2014-04-01','13:00:00',3.81),('9650','2014-04-01','13:05:00',5.56),('9650','2014-04-01','13:10:00',6.32),('9650','2014-04-01','13:15:00',6.49),('9650','2014-04-01','13:20:00',6.43),('9650','2014-04-01','13:25:00',6.16),('9650','2014-04-01','13:30:00',6.68),('9650','2014-04-01','13:35:00',6.76),('9650','2014-04-01','13:40:00',7),('9650','2014-04-01','13:45:00',6.6),('9650','2014-04-01','13:50:00',6.6),('9650','2014-04-01','13:55:00',6.81),('9650','2014-04-01','14:00:00',6.66),('9650','2014-04-01','14:05:00',6.62),('9650','2014-04-01','14:10:00',6.59),('9650','2014-04-01','14:15:00',6.65),('9650','2014-04-01','14:20:00',6.69),('9650','2014-04-01','14:25:00',6.76),('9650','2014-04-01','14:30:00',6.68),('9650','2014-04-01','14:35:00',6.5),('9650','2014-04-01','14:40:00',6.5),('9650','2014-04-01','14:45:00',6.7),('9650','2014-04-01','14:50:00',5.95),('9650','2014-04-01','14:55:00',6.05),('9650','2014-04-01','15:00:00',6.26),('9650','2014-04-01','15:05:00',6.4),('9650','2014-04-01','15:10:00',5.8),('9650','2014-04-01','15:15:00',5.95),('9650','2014-04-01','15:20:00',6.03),('9650','2014-04-01','15:25:00',5.97),('9650','2014-04-01','15:30:00',5.66),('9650','2014-04-01','15:35:00',5.56),('9650','2014-04-01','15:40:00',5.74),('9650','2014-04-01','15:45:00',5.9),('9650','2014-04-01','15:50:00',5.76),('9650','2014-04-01','15:55:00',5.08),('9650','2014-04-01','16:00:00',5.3),('9650','2014-04-01','16:05:00',5.23),('9650','2014-04-01','16:10:00',5.25),('9650','2014-04-01','16:15:00',5.19),('9650','2014-04-01','16:20:00',5.02),('9650','2014-04-01','16:25:00',4.99),('9650','2014-04-01','16:30:00',4.95),('9650','2014-04-01','16:35:00',4.9),('9650','2014-04-01','16:40:00',4.79),('9650','2014-04-01','16:45:00',4.6),('9650','2014-04-01','16:50:00',4.2),('9650','2014-04-01','16:55:00',4.21),('9650','2014-04-01','17:00:00',4.42),('9650','2014-04-01','17:05:00',4.04),('9650','2014-04-01','17:10:00',3.92),('9650','2014-04-01','17:15:00',3.53),('9650','2014-04-01','17:20:00',3.64),('9650','2014-04-01','17:25:00',3.5),('9650','2014-04-01','17:30:00',3.22),('9650','2014-04-01','17:35:00',3.29),('9650','2014-04-01','17:40:00',2.46),('9650','2014-04-01','17:45:00',2.64),('9650','2014-04-01','17:50:00',3.27),('9650','2014-04-01','17:55:00',2.84),('9650','2014-04-01','18:00:00',2.69),('9650','2014-04-01','18:05:00',1.76),('9650','2014-04-01','18:10:00',1.59),('9650','2014-04-01','18:15:00',1.55),('9650','2014-04-01','18:20:00',1.74),('9650','2014-04-01','18:25:00',1.63),('9650','2014-04-01','18:30:00',1.25),('9650','2013-05-30','07:50:00',1.08),('9650','2013-05-30','07:55:00',1.24),('9650','2013-05-30','08:00:00',1.31),('9650','2013-05-30','08:05:00',1.3),('9650','2013-05-30','08:10:00',1.32),('9650','2013-05-30','08:15:00',1.35),('9650','2013-05-30','08:20:00',1.5),('9650','2013-05-30','08:25:00',1.89),('9650','2013-05-30','08:30:00',1.94),('9650','2013-05-30','08:35:00',2.33),('9650','2013-05-30','08:40:00',2.1),('9650','2013-05-30','08:45:00',1.82),('9650','2013-05-30','08:50:00',3.34),('9650','2013-05-30','08:55:00',1.88),('9650','2013-05-30','09:00:00',1.35),('9650','2013-05-30','09:05:00',1.16),('9650','2013-05-30','09:10:00',1.5),('9650','2013-05-30','09:15:00',2.21),('9650','2013-05-30','09:20:00',1.51),('9650','2013-05-30','09:25:00',1.61),('9650','2013-05-30','09:30:00',2.21),('9650','2013-05-30','09:35:00',3.1),('9650','2013-05-30','09:40:00',3.34),('9650','2013-05-30','09:45:00',4.36),('9650','2013-05-30','09:50:00',4.83),('9650','2013-05-30','09:55:00',4.9),('9650','2013-05-30','10:00:00',5.11),('9650','2013-05-30','10:05:00',3.85),('9650','2013-05-30','10:10:00',2.69),('9650','2013-05-30','10:15:00',5.12),('9650','2013-05-30','10:20:00',5.2),('9650','2013-05-30','10:25:00',2.25),('9650','2013-05-30','10:30:00',3.57),('9650','2013-05-30','10:35:00',2.75),('9650','2013-05-30','10:40:00',6.24),('9650','2013-05-30','10:45:00',6.66),('9650','2013-05-30','10:50:00',3.13),('9650','2013-05-30','10:55:00',6.57),('9650','2013-05-30','11:00:00',2.5),('9650','2013-05-30','11:05:00',3.14),('9650','2013-05-30','11:10:00',8.2),('9650','2013-05-30','11:15:00',7.43),('9650','2013-05-30','11:20:00',2.28),('9650','2013-05-30','11:25:00',4.3),('9650','2013-05-30','11:30:00',5.75),('9650','2013-05-30','11:35:00',4.24),('9650','2013-05-30','11:40:00',1.55),('9650','2013-05-30','11:45:00',7.23),('9650','2013-05-30','11:50:00',6.17),('9650','2013-05-30','11:55:00',5.48),('9650','2013-05-30','12:00:00',2.93),('9650','2013-05-30','12:05:00',8.2),('9650','2013-05-30','12:10:00',6.58),('9650','2013-05-30','12:15:00',2.86),('9650','2013-05-30','12:20:00',3.16),('9650','2013-05-30','12:25:00',6.03),('9650','2013-05-30','12:30:00',3),('9650','2013-05-30','12:35:00',4.19),('9650','2013-05-30','12:40:00',7.75),('9650','2013-05-30','12:45:00',3.47),('9650','2013-05-30','12:50:00',1.72),('9650','2013-05-30','12:55:00',2.74),('9650','2013-05-30','13:00:00',9.04),('9650','2013-05-30','13:05:00',3.08),('9650','2013-05-30','13:10:00',1.29),('9650','2013-05-30','13:15:00',1.44),('9650','2013-05-30','13:20:00',2.33),('9650','2013-05-30','13:25:00',3.32),('9650','2013-05-30','13:30:00',5.94),('9650','2013-05-30','13:35:00',8.24),('9650','2013-05-30','13:40:00',4.71),('9650','2013-05-30','13:45:00',2.52),('9650','2013-05-30','13:50:00',1.34),('9650','2013-05-30','13:55:00',2.4),('9650','2013-05-30','14:00:00',3.58),('9650','2013-05-30','14:05:00',1.62),('9650','2013-05-30','14:10:00',1.12),('9650','2013-05-30','14:15:00',1.09),('9650','2013-05-30','14:20:00',1.41),('9650','2013-05-30','14:25:00',1.94),('9650','2013-05-30','14:30:00',1.68),('9650','2013-05-30','14:45:00',1.31),('9650','2013-05-30','14:50:00',1.6),('9650','2013-05-30','14:55:00',1.09),('9650','2013-05-30','15:00:00',1.91),('9650','2013-05-30','15:05:00',2.91),('9650','2013-05-30','15:10:00',3.52),('9650','2013-05-30','15:15:00',5.3),('9650','2013-05-30','15:20:00',9.65),('9650','2013-05-30','15:25:00',6.78),('9650','2013-05-30','15:30:00',4.75),('9650','2013-05-30','15:35:00',3.91),('9650','2013-05-30','15:40:00',3.23),('9650','2013-05-30','15:45:00',3.02),('9650','2013-05-30','15:50:00',4.58),('9650','2013-05-30','15:55:00',4.14),('9650','2013-05-30','16:00:00',2.79),('9650','2013-05-30','16:05:00',2.29),('9650','2013-05-30','16:10:00',1.65),('9650','2013-05-30','16:15:00',1.59),('9650','2013-05-30','16:20:00',1.89),('9650','2013-05-30','16:25:00',2.41),('9650','2013-05-30','16:30:00',2.09),('9650','2013-05-30','16:35:00',1.78),('9650','2013-05-30','16:40:00',2.07),('9650','2013-05-30','16:45:00',2.16),('9650','2013-05-30','16:50:00',1.48),('9650','2013-05-30','16:55:00',1.09),('9650','2013-05-30','17:00:00',1.08),('9650','2013-05-30','17:05:00',1.08),('9650','2013-05-30','17:10:00',1.04),('9650','2013-05-30','17:15:00',1.09),('9650','2013-05-30','17:20:00',1.17),('9650','2013-05-30','17:25:00',1.23),('9650','2013-05-30','17:30:00',1.22),('9650','2013-05-30','17:35:00',1.09),('9650','2013-05-30','17:40:00',1),('9650','2013-05-30','17:45:00',1.02),('9650','2013-05-30','19:05:00',1.15),('9650','2013-05-30','19:10:00',1.13),('9650','2013-05-29','07:40:00',1.05),('9650','2013-05-29','07:45:00',1.22),('9650','2013-05-29','07:50:00',1.4),('9650','2013-05-29','07:55:00',1.28),('9650','2013-05-29','08:00:00',1.22),('9650','2013-05-29','08:10:00',1.27),('9650','2013-05-29','08:15:00',1.37),('9650','2013-05-29','08:20:00',1.51),('9650','2013-05-29','08:25:00',1.74),('9650','2013-05-29','08:30:00',1.24),('9650','2013-05-29','08:35:00',1.07),('9650','2013-05-29','08:40:00',2.3),('9650','2013-05-29','08:45:00',2.41),('9650','2013-05-29','08:50:00',2.52),('9650','2013-05-29','08:55:00',2.66),('9650','2013-05-29','09:00:00',2.8),('9650','2013-05-29','09:05:00',2.73),('9650','2013-05-29','09:10:00',3.11),('9650','2013-05-29','09:15:00',3.3),('9650','2013-05-29','09:20:00',3.53),('9650','2013-05-29','09:25:00',3.77),('9650','2013-05-29','09:30:00',3.93),('9650','2013-05-29','09:35:00',4.07),('9650','2013-05-29','09:40:00',4.48),('9650','2013-05-29','09:45:00',3.97),('9650','2013-05-29','09:50:00',5.36),('9650','2013-05-29','09:55:00',3.16),('9650','2013-05-29','10:00:00',2.19),('9650','2013-05-29','10:05:00',2.86),('9650','2013-05-29','10:10:00',4.61),('9650','2013-05-29','10:15:00',3.16),('9650','2013-05-29','10:20:00',6.12),('9650','2013-05-29','10:25:00',1.92),('9650','2013-05-29','10:30:00',2.17),('9650','2013-05-29','10:35:00',2.25),('9650','2013-05-29','10:40:00',4.33),('9650','2013-05-29','10:45:00',6.31),('9650','2013-05-29','10:50:00',5.94),('9650','2013-05-29','10:55:00',4.4),('9650','2013-05-29','11:00:00',7.24),('9650','2013-05-29','11:05:00',7.22),('9650','2013-05-29','11:10:00',2.1),('9650','2013-05-29','11:15:00',3.02),('9650','2013-05-29','11:20:00',5.71),('9650','2013-05-29','11:25:00',2.95),('9650','2013-05-29','11:30:00',6.21),('9650','2013-05-29','11:35:00',7.82),('9650','2013-05-29','11:40:00',7.42),('9650','2013-05-29','11:45:00',6.81),('9650','2013-05-29','11:50:00',7.11),('9650','2013-05-29','11:55:00',1.88),('9650','2013-05-29','12:00:00',8.09),('9650','2013-05-29','12:05:00',8.5),('9650','2013-05-29','12:10:00',3.39),('9650','2013-05-29','12:15:00',8.35),('9650','2013-05-29','12:20:00',5.47),('9650','2013-05-29','12:25:00',7.44),('9650','2013-05-29','12:30:00',6.28),('9650','2013-05-29','12:35:00',5.06),('9650','2013-05-29','12:40:00',8.32),('9650','2013-05-29','12:45:00',4.66),('9650','2013-05-29','12:50:00',6.76),('9650','2013-05-29','12:55:00',8.36),('9650','2013-05-29','13:00:00',7.49),('9650','2013-05-29','13:05:00',7.17),('9650','2013-05-29','13:10:00',3.98),('9650','2013-05-29','13:15:00',4.56),('9650','2013-05-29','13:20:00',3.55),('9650','2013-05-29','13:25:00',3.06),('9650','2013-05-29','13:30:00',3.82),('9650','2013-05-29','13:35:00',3.41),('9650','2013-05-29','13:40:00',8.24),('9650','2013-05-29','13:45:00',8.91),('9650','2013-05-29','13:50:00',3),('9650','2013-05-29','13:55:00',2.97),('9650','2013-05-29','14:00:00',7.14),('9650','2013-05-29','14:05:00',9.37),('9650','2013-05-29','14:10:00',6.65),('9650','2013-05-29','14:15:00',8.62),('9650','2013-05-29','14:20:00',6.19),('9650','2013-05-29','14:25:00',8.09),('9650','2013-05-29','14:30:00',8.65),('9650','2013-05-29','14:35:00',7.21),('9650','2013-05-29','14:40:00',8.72),('9650','2013-05-29','14:45:00',8.82),('9650','2013-05-29','14:50:00',8.73),('9650','2013-05-29','14:55:00',8.31),('9650','2013-05-29','15:00:00',8.37),('9650','2013-05-29','15:05:00',6.28),('9650','2013-05-29','15:10:00',3.66),('9650','2013-05-29','15:15:00',8.22),('9650','2013-05-29','15:20:00',8.58),('9650','2013-05-29','15:25:00',8.3),('9650','2013-05-29','15:30:00',8.23),('9650','2013-05-29','15:35:00',7.89),('9650','2013-05-29','15:40:00',8.54),('9650','2013-05-29','15:45:00',8.68),('9650','2013-05-29','15:50:00',4.92),('9650','2013-05-29','15:55:00',7.01),('9650','2013-05-29','16:00:00',7.86),('9650','2013-05-29','16:05:00',8.57),('9650','2013-05-29','16:10:00',7.97),('9650','2013-05-29','16:15:00',7.75),('9650','2013-05-29','16:20:00',7.2),('9650','2013-05-29','16:25:00',5.06),('9650','2013-05-29','16:30:00',2.5),('9650','2013-05-29','16:35:00',4.41),('9650','2013-05-29','16:40:00',2.32),('9650','2013-05-29','16:45:00',5.95),('9650','2013-05-29','16:50:00',6.05),('9650','2013-05-29','16:55:00',4.99),('9650','2013-05-29','17:00:00',3.88),('9650','2013-05-29','17:05:00',4.18),('9650','2013-05-29','17:10:00',1.49),('9650','2013-05-29','17:15:00',1.79),('9650','2013-05-29','17:20:00',2.19),('9650','2013-05-29','17:25:00',1.84),('9650','2013-05-29','17:30:00',2),('9650','2013-05-29','17:35:00',1.17),('9650','2013-05-29','18:00:00',1.55),('9650','2013-05-29','18:05:00',2.05),('9650','2013-05-29','18:10:00',3.32),('9650','2013-05-29','18:15:00',2.06),('9650','2013-05-29','18:20:00',1.57),('9650','2013-05-29','18:25:00',1.68),('9650','2013-05-29','18:30:00',1.99),('9650','2013-05-29','18:35:00',3.59),('9650','2013-05-29','18:40:00',3.44),('9650','2013-05-29','18:45:00',3.78),('9650','2013-05-29','18:50:00',3.62),('9650','2013-05-29','18:55:00',1.44),('9650','2013-05-29','19:00:00',1.03),('9650','2013-05-28','08:00:00',1.07),('9650','2013-05-28','08:05:00',1.16),('9650','2013-05-28','08:10:00',1.3),('9650','2013-05-28','08:15:00',1.41),('9650','2013-05-28','08:20:00',1.54),('9650','2013-05-28','08:25:00',1.72),('9650','2013-05-28','08:30:00',1.88),('9650','2013-05-28','08:35:00',2.06),('9650','2013-05-28','08:40:00',2.18),('9650','2013-05-28','08:45:00',2.32),('9650','2013-05-28','08:50:00',2.45),('9650','2013-05-28','08:55:00',2.6),('9650','2013-05-28','09:00:00',2.72),('9650','2013-05-28','09:05:00',2.86),('9650','2013-05-28','09:10:00',3.01),('9650','2013-05-28','09:15:00',3.16),('9650','2013-05-28','09:20:00',3.29),('9650','2013-05-28','09:25:00',3.47),('9650','2013-05-28','09:30:00',3.62),('9650','2013-05-28','09:35:00',3.78),('9650','2013-05-28','09:40:00',3.93),('9650','2013-05-28','09:45:00',4.05),('9650','2013-05-28','09:50:00',4.2),('9650','2013-05-28','09:55:00',4.36),('9650','2013-05-28','10:00:00',4.45),('9650','2013-05-28','10:05:00',4.55),('9650','2013-05-28','10:10:00',4.62),('9650','2013-05-28','10:15:00',4.8),('9650','2013-05-28','10:20:00',4.95),('9650','2013-05-28','10:25:00',5.04),('9650','2013-05-28','10:30:00',5.18),('9650','2013-05-28','10:35:00',5.37),('9650','2013-05-28','10:40:00',5.46),('9650','2013-05-28','10:45:00',5.58),('9650','2013-05-28','10:50:00',5.71),('9650','2013-05-28','10:55:00',5.83),('9650','2013-05-28','11:00:00',5.91),('9650','2013-05-28','11:05:00',5.83),('9650','2013-05-28','11:10:00',5.96),('9650','2013-05-28','11:15:00',4.91),('9650','2013-05-28','11:20:00',6.83),('9650','2013-05-28','11:25:00',7.21),('9650','2013-05-28','11:30:00',6.82),('9650','2013-05-28','11:35:00',7.14),('9650','2013-05-28','11:40:00',5.97),('9650','2013-05-28','11:45:00',5.57),('9650','2013-05-28','11:50:00',5.52),('9650','2013-05-28','11:55:00',7.09),('9650','2013-05-28','12:00:00',5.56),('9650','2013-05-28','12:05:00',4.36),('9650','2013-05-28','12:10:00',7.44),('9650','2013-05-28','12:15:00',5.27),('9650','2013-05-28','12:20:00',7.45),('9650','2013-05-28','12:25:00',7.46),('9650','2013-05-28','12:30:00',7.37),('9650','2013-05-28','12:35:00',7.39),('9650','2013-05-28','12:40:00',6.18),('9650','2013-05-28','12:45:00',7.52),('9650','2013-05-28','12:50:00',7.17),('9650','2013-05-28','12:55:00',7.5),('9650','2013-05-28','13:00:00',7.67),('9650','2013-05-28','13:05:00',7.38),('9650','2013-05-28','13:10:00',6.61),('9650','2013-05-28','13:15:00',6.66),('9650','2013-05-28','13:20:00',6.46),('9650','2013-05-28','13:25:00',8.83),('9650','2013-05-28','13:30:00',8.45),('9650','2013-05-28','13:35:00',6.64),('9650','2013-05-28','13:40:00',8.29),('9650','2013-05-28','13:45:00',7.46),('9650','2013-05-28','13:50:00',7.13),('9650','2013-05-28','13:55:00',6.44),('9650','2013-05-28','14:00:00',8.11),('9650','2013-05-28','14:05:00',7.78),('9650','2013-05-28','14:10:00',7.71),('9650','2013-05-28','14:15:00',7.98),('9650','2013-05-28','14:20:00',8.07),('9650','2013-05-28','14:25:00',7.29),('9650','2013-05-28','14:30:00',8.03),('9650','2013-05-28','14:35:00',5.59),('9650','2013-05-28','14:40:00',8.47),('9650','2013-05-28','14:45:00',8.36),('9650','2013-05-28','14:50:00',7.37),('9650','2013-05-28','14:55:00',7.58),('9650','2013-05-28','15:00:00',8.4),('9650','2013-05-28','15:05:00',8),('9650','2013-05-28','15:10:00',6.66),('9650','2013-05-28','15:15:00',5.25),('9650','2013-05-28','15:20:00',6.73),('9650','2013-05-28','15:25:00',5.41),('9650','2013-05-28','15:30:00',6.13),('9650','2013-05-28','15:35:00',6.23),('9650','2013-05-28','15:40:00',4.8),('9650','2013-05-28','15:45:00',5.8),('9650','2013-05-28','15:50:00',5.67),('9650','2013-05-28','15:55:00',5.62),('9650','2013-05-28','16:00:00',5.19),('9650','2013-05-28','16:05:00',5.21),('9650','2013-05-28','16:10:00',4.53),('9650','2013-05-28','16:15:00',4.35),('9650','2013-05-28','16:20:00',4.28),('9650','2013-05-28','16:25:00',4.39),('9650','2013-05-28','16:30:00',3.62),('9650','2013-05-28','16:35:00',3.67),('9650','2013-05-28','16:40:00',4.45),('9650','2013-05-28','16:45:00',3.9),('9650','2013-05-28','16:50:00',2.94),('9650','2013-05-28','16:55:00',2.71),('9650','2013-05-28','17:00:00',2.44),('9650','2013-05-28','17:05:00',1.31),('9650','2013-05-28','17:25:00',1.06),('9650','2013-05-28','17:30:00',1.45),('9650','2013-05-28','17:35:00',2.35),('9650','2013-05-28','17:40:00',3.47),('9650','2013-05-28','17:45:00',2.19),('9650','2013-05-28','17:50:00',1.56),('9650','2013-05-28','17:55:00',1.29),('9650','2013-05-28','18:00:00',1.98),('9650','2013-05-28','18:05:00',2.72),('9650','2013-05-28','18:10:00',3.26),('9650','2013-05-28','18:15:00',5.77),('9650','2013-05-28','18:20:00',3.54),('9650','2013-05-28','18:25:00',1.28),('9650','2013-05-28','19:05:00',2.03),('9650','2013-05-28','19:10:00',1.96),('9650','2013-05-28','19:15:00',1.85),('9650','2013-05-28','19:20:00',1.42),('9650','2013-05-28','19:25:00',1.12),('9650','2013-05-27','07:20:00',1.11),('9650','2013-05-27','07:25:00',1.17),('9650','2013-05-27','07:30:00',1.15),('9650','2013-05-27','07:35:00',1.16),('9650','2013-05-27','07:40:00',1.25),('9650','2013-05-27','07:45:00',1.31),('9650','2013-05-27','07:50:00',1.34),('9650','2013-05-27','07:55:00',1.32),('9650','2013-05-27','08:00:00',1.47),('9650','2013-05-27','08:05:00',1.63),('9650','2013-05-27','08:10:00',1.76),('9650','2013-05-27','08:15:00',1.98),('9650','2013-05-27','08:20:00',2.13),('9650','2013-05-27','08:25:00',2),('9650','2013-05-27','08:30:00',2.32),('9650','2013-05-27','08:35:00',2.32),('9650','2013-05-27','08:40:00',2.26),('9650','2013-05-27','08:45:00',2.23),('9650','2013-05-27','08:50:00',2.42),('9650','2013-05-27','08:55:00',2.41),('9650','2013-05-27','09:00:00',2.58),('9650','2013-05-27','09:05:00',2.79),('9650','2013-05-27','09:10:00',2.6),('9650','2013-05-27','09:15:00',2.51),('9650','2013-05-27','09:20:00',2.73),('9650','2013-05-27','09:25:00',2.99),('9650','2013-05-27','09:30:00',3.21),('9650','2013-05-27','09:35:00',3.31),('9650','2013-05-27','09:40:00',3.27),('9650','2013-05-27','09:45:00',3.17),('9650','2013-05-27','09:50:00',3.31),('9650','2013-05-27','09:55:00',3.61),('9650','2013-05-27','10:00:00',3.49),('9650','2013-05-27','10:05:00',3.69),('9650','2013-05-27','10:10:00',4.01),('9650','2013-05-27','10:15:00',4.19),('9650','2013-05-27','10:20:00',4.4),('9650','2013-05-27','10:25:00',4.36),('9650','2013-05-27','10:30:00',4.68),('9650','2013-05-27','10:35:00',4.77),('9650','2013-05-27','10:40:00',4.47),('9650','2013-05-27','10:45:00',4.07),('9650','2013-05-27','10:50:00',4.54),('9650','2013-05-27','10:55:00',4),('9650','2013-05-27','11:00:00',4.05),('9650','2013-05-27','11:05:00',3.89),('9650','2013-05-27','11:10:00',4.1),('9650','2013-05-27','11:15:00',3.72),('9650','2013-05-27','11:20:00',3.71),('9650','2013-05-27','11:25:00',3.79),('9650','2013-05-27','11:30:00',6.18),('9650','2013-05-27','11:35:00',4.72),('9650','2013-05-27','11:40:00',6.19),('9650','2013-05-27','11:45:00',5.34),('9650','2013-05-27','11:50:00',2.03),('9650','2013-05-27','11:55:00',3.07),('9650','2013-05-27','12:00:00',2.78),('9650','2013-05-27','12:15:00',4.13),('9650','2013-05-27','12:20:00',4.17),('9650','2013-05-27','12:25:00',4.28),('9650','2013-05-27','12:30:00',4.72),('9650','2013-05-27','12:35:00',4.58),('9650','2013-05-27','12:40:00',4.72),('9650','2013-05-27','12:45:00',5.21),('9650','2013-05-27','12:50:00',4.7),('9650','2013-05-27','12:55:00',4.85),('9650','2013-05-27','13:00:00',4.92),('9650','2013-05-27','13:05:00',5.27),('9650','2013-05-27','13:10:00',5.51),('9650','2013-05-27','13:15:00',4.67),('9650','2013-05-27','13:20:00',5.76),('9650','2013-05-27','13:25:00',3.17),('9650','2013-05-27','13:30:00',3.71),('9650','2013-05-27','13:35:00',3.22),('9650','2013-05-27','13:40:00',3.66),('9650','2013-05-27','13:45:00',3.52),('9650','2013-05-27','13:50:00',4.59),('9650','2013-05-27','13:55:00',4.53),('9650','2013-05-27','14:00:00',4.74),('9650','2013-05-27','14:05:00',5),('9650','2013-05-27','14:10:00',7.45),('9650','2013-05-27','14:15:00',7.22),('9650','2013-05-27','14:20:00',4.63),('9650','2013-05-27','14:25:00',5.04),('9650','2013-05-27','14:30:00',6.09),('9650','2013-05-27','14:35:00',5.43),('9650','2013-05-27','14:40:00',6.07),('9650','2013-05-27','14:45:00',7.06),('9650','2013-05-27','14:50:00',5.44),('9650','2013-05-27','14:55:00',4.97),('9650','2013-05-27','15:00:00',4.63),('9650','2013-05-27','15:05:00',6.91),('9650','2013-05-27','15:10:00',3.14),('9650','2013-05-27','15:15:00',4.85),('9650','2013-05-27','15:20:00',5.97),('9650','2013-05-27','15:25:00',4.38),('9650','2013-05-27','15:30:00',2.79),('9650','2013-05-27','15:35:00',2.88),('9650','2013-05-27','15:40:00',5.19),('9650','2013-05-27','15:45:00',7.44),('9650','2013-05-27','15:50:00',6.2),('9650','2013-05-27','15:55:00',4.47),('9650','2013-05-27','16:00:00',3.29),('9650','2013-05-27','16:05:00',2.71),('9650','2013-05-27','16:10:00',2.89),('9650','2013-05-27','16:15:00',3.25),('9650','2013-05-27','16:20:00',5.2),('9650','2013-05-27','16:25:00',4.77),('9650','2013-05-27','16:30:00',5.52),('9650','2013-05-27','16:35:00',6.9),('9650','2013-05-27','16:40:00',6.44),('9650','2013-05-27','16:45:00',6.19),('9650','2013-05-27','16:50:00',6.09),('9650','2013-05-27','16:55:00',6),('9650','2013-05-27','17:00:00',5.95),('9650','2013-05-27','17:05:00',5.84),('9650','2013-05-27','17:10:00',5.69),('9650','2013-05-27','17:15:00',5.63),('9650','2013-05-27','17:20:00',5.5),('9650','2013-05-27','17:25:00',5.34),('9650','2013-05-27','17:30:00',5.24),('9650','2013-05-27','17:35:00',5.06),('9650','2013-05-27','17:40:00',4.75),('9650','2013-05-27','17:45:00',4.78),('9650','2013-05-27','17:50:00',4.68),('9650','2013-05-27','17:55:00',4.59),('9650','2013-05-27','18:00:00',4.6),('9650','2013-05-27','18:05:00',4.43),('9650','2013-05-27','18:10:00',2.31),('9650','2013-05-27','18:15:00',1.63),('9650','2013-05-27','18:20:00',1.07),('9650','2013-05-27','18:25:00',1.14),('9650','2013-05-27','18:30:00',2.39),('9650','2013-05-27','18:35:00',3.64),('9650','2013-05-27','18:40:00',3.48),('9650','2013-05-27','18:45:00',3.29),('9650','2013-05-27','18:50:00',3.12),('9650','2013-05-27','18:55:00',2.96),('9650','2013-05-27','19:00:00',2.77),('9650','2013-05-27','19:05:00',2.62),('9650','2013-05-27','19:10:00',2.43),('9650','2013-05-27','19:15:00',2.16),('9650','2013-05-27','19:20:00',1.92),('9650','2013-05-27','19:25:00',1.75),('9650','2013-05-27','19:35:00',1.05),('9650','2013-05-27','19:40:00',1.18),('9650','2013-05-27','19:45:00',1.03),('9650','2013-05-26','08:00:00',1.12),('9650','2013-05-26','08:05:00',1.48),('9650','2013-05-26','08:10:00',1.71),('9650','2013-05-26','08:15:00',1.79),('9650','2013-05-26','08:20:00',1.43),('9650','2013-05-26','08:25:00',1.62),('9650','2013-05-26','08:30:00',1.91),('9650','2013-05-26','08:35:00',2.13),('9650','2013-05-26','08:40:00',2.3),('9650','2013-05-26','08:45:00',2.71),('9650','2013-05-26','08:50:00',2.89),('9650','2013-05-26','09:10:00',2.24),('9650','2013-05-26','09:15:00',3.55),('9650','2013-05-26','09:20:00',2.22),('9650','2013-05-26','09:25:00',2.75),('9650','2013-05-26','09:30:00',3.67),('9650','2013-05-26','09:35:00',3.96),('9650','2013-05-26','09:40:00',4.1),('9650','2013-05-26','09:45:00',4.3),('9650','2013-05-26','09:50:00',4.01),('9650','2013-05-26','09:55:00',4.74),('9650','2013-05-26','10:00:00',4.85),('9650','2013-05-26','10:05:00',4.7),('9650','2013-05-26','10:10:00',5.01),('9650','2013-05-26','10:15:00',5.18),('9650','2013-05-26','10:20:00',3.06),('9650','2013-05-26','10:25:00',5.15),('9650','2013-05-26','10:30:00',3.26),('9650','2013-05-26','10:35:00',2.06),('9650','2013-05-26','10:40:00',5.86),('9650','2013-05-26','10:45:00',3.39),('9650','2013-05-26','10:50:00',3.92),('9650','2013-05-26','10:55:00',2.7),('9650','2013-05-26','11:00:00',6.63),('9650','2013-05-26','11:05:00',4.45),('9650','2013-05-26','11:10:00',6.11),('9650','2013-05-26','11:15:00',3.11),('9650','2013-05-26','11:20:00',5.8),('9650','2013-05-26','11:25:00',5.56),('9650','2013-05-26','11:30:00',4.22),('9650','2013-05-26','11:35:00',2.3),('9650','2013-05-26','11:40:00',7.62),('9650','2013-05-26','11:45:00',4.17),('9650','2013-05-26','11:50:00',3.01),('9650','2013-05-26','11:55:00',4.31),('9650','2013-05-26','12:00:00',8.45),('9650','2013-05-26','12:05:00',3.23),('9650','2013-05-26','12:10:00',7.94),('9650','2013-05-26','12:15:00',7.28),('9650','2013-05-26','12:20:00',9.1),('9650','2013-05-26','12:25:00',6.53),('9650','2013-05-26','12:30:00',7.73),('9650','2013-05-26','12:35:00',5.04),('9650','2013-05-26','12:40:00',8.59),('9650','2013-05-26','12:45:00',3.99),('9650','2013-05-26','12:50:00',7.96),('9650','2013-05-26','12:55:00',6.52),('9650','2013-05-26','13:00:00',3.51),('9650','2013-05-26','13:05:00',3.75),('9650','2013-05-26','13:10:00',8.28),('9650','2013-05-26','13:15:00',2.39),('9650','2013-05-26','13:20:00',7.75),('9650','2013-05-26','13:25:00',8.27),('9650','2013-05-26','13:30:00',8.31),('9650','2013-05-26','13:35:00',5),('9650','2013-05-26','13:40:00',8.83),('9650','2013-05-26','13:45:00',7.18),('9650','2013-05-26','13:50:00',8.32),('9650','2013-05-26','13:55:00',8.17),('9650','2013-05-26','14:00:00',7.86),('9650','2013-05-26','14:05:00',8.07),('9650','2013-05-26','14:10:00',6.85),('9650','2013-05-26','14:15:00',6.84),('9650','2013-05-26','14:20:00',4.74),('9650','2013-05-26','14:25:00',8.05),('9650','2013-05-26','14:30:00',6.76),('9650','2013-05-26','14:35:00',6.84),('9650','2013-05-26','14:40:00',4.84),('9650','2013-05-26','14:45:00',8.82),('9650','2013-05-26','14:50:00',8.37),('9650','2013-05-26','14:55:00',7.17),('9650','2013-05-26','15:00:00',5.35),('9650','2013-05-26','15:05:00',5.02),('9650','2013-05-26','15:10:00',8.23),('9650','2013-05-26','15:15:00',5.67),('9650','2013-05-26','15:20:00',6.88),('9650','2013-05-26','15:25:00',6.45),('9650','2013-05-26','15:30:00',7.36),('9650','2013-05-26','15:35:00',8.27),('9650','2013-05-26','15:40:00',6.63),('9650','2013-05-26','15:45:00',6.02),('9650','2013-05-26','15:50:00',7.43),('9650','2013-05-26','15:55:00',5.05),('9650','2013-05-26','16:00:00',6.22),('9650','2013-05-26','16:05:00',4.18),('9650','2013-05-26','16:10:00',4.55),('9650','2013-05-26','16:15:00',4.61),('9650','2013-05-26','16:20:00',7.81),('9650','2013-05-26','16:25:00',7.58),('9650','2013-05-26','16:30:00',7.27),('9650','2013-05-26','16:35:00',6.27),('9650','2013-05-26','16:40:00',2.86),('9650','2013-05-26','16:45:00',2.45),('9650','2013-05-26','16:50:00',2.42),('9650','2013-05-26','16:55:00',2.54),('9650','2013-05-26','17:00:00',2.71),('9650','2013-05-26','17:05:00',2.9),('9650','2013-05-26','17:10:00',3.85),('9650','2013-05-26','17:15:00',2.88),('9650','2013-05-26','17:20:00',2.43),('9650','2013-05-26','17:25:00',2.21),('9650','2013-05-26','17:30:00',2.16),('9650','2013-05-26','17:35:00',1.99),('9650','2013-05-26','17:40:00',1.85),('9650','2013-05-26','17:45:00',1.74),('9650','2013-05-26','17:50:00',1.66),('9650','2013-05-26','17:55:00',1.69),('9650','2013-05-26','18:00:00',1.64),('9650','2013-05-26','18:05:00',1.53),('9650','2013-05-26','18:10:00',1.72),('9650','2013-05-26','18:15:00',1.97),('9650','2013-05-26','18:20:00',3.08),('9650','2013-05-26','18:25:00',5.25),('9650','2013-05-26','18:30:00',4.09),('9650','2013-05-26','18:35:00',3.03),('9650','2013-05-26','18:40:00',2.24),('9650','2013-05-26','18:45:00',3.47),('9650','2013-05-26','18:50:00',2.3),('9650','2013-05-26','18:55:00',3.2),('9650','2013-05-26','19:00:00',3.61),('9650','2013-05-26','19:05:00',3.73),('9650','2013-05-26','19:10:00',3.5),('9650','2013-05-26','19:15:00',2.43),('9650','2013-05-26','19:20:00',2.06),('9650','2013-05-26','19:25:00',2.24),('9650','2013-05-26','19:30:00',2.39),('9650','2013-05-26','19:35:00',2.01),('9650','2013-05-26','19:40:00',1.7),('9650','2013-05-26','19:45:00',1.35),('9650','2013-05-25','07:20:00',1.12),('9650','2013-05-25','07:45:00',1.16),('9650','2013-05-25','07:50:00',2.24),('9650','2013-05-25','08:05:00',2.24),('9650','2013-05-25','08:10:00',1.88),('9650','2013-05-25','08:15:00',1.29),('9650','2013-05-25','08:20:00',1.73),('9650','2013-05-25','08:25:00',1.83),('9650','2013-05-25','08:30:00',2.47),('9650','2013-05-25','08:35:00',1.99),('9650','2013-05-25','08:40:00',2.49),('9650','2013-05-25','08:45:00',3.01),('9650','2013-05-25','08:50:00',3.62),('9650','2013-05-25','08:55:00',1.56),('9650','2013-05-25','09:00:00',2.81),('9650','2013-05-25','09:05:00',1.4),('9650','2013-05-25','09:10:00',3.41),('9650','2013-05-25','09:15:00',2.26),('9650','2013-05-25','09:20:00',1.44),('9650','2013-05-25','09:25:00',2.24),('9650','2013-05-25','09:30:00',1.5),('9650','2013-05-25','09:35:00',1.14),('9650','2013-05-25','09:40:00',1.93),('9650','2013-05-25','09:45:00',3.09),('9650','2013-05-25','09:50:00',1.22),('9650','2013-05-25','09:55:00',2),('9650','2013-05-25','10:00:00',1.86),('9650','2013-05-25','10:05:00',4.3),('9650','2013-05-25','10:10:00',5.53),('9650','2013-05-25','10:15:00',3.03),('9650','2013-05-25','10:20:00',3.85),('9650','2013-05-25','10:25:00',4.02),('9650','2013-05-25','10:30:00',5.3),('9650','2013-05-25','10:35:00',5.79),('9650','2013-05-25','10:40:00',5.71),('9650','2013-05-25','10:45:00',5.71),('9650','2013-05-25','10:50:00',6.02),('9650','2013-05-25','10:55:00',5.4),('9650','2013-05-25','11:00:00',6.16),('9650','2013-05-25','11:05:00',6.28),('9650','2013-05-25','11:10:00',6.35),('9650','2013-05-25','11:15:00',6.45),('9650','2013-05-25','11:20:00',6.58),('9650','2013-05-25','11:25:00',6.68),('9650','2013-05-25','11:30:00',6.81),('9650','2013-05-25','11:35:00',6.7),('9650','2013-05-25','11:40:00',6.46),('9650','2013-05-25','11:45:00',6.88),('9650','2013-05-25','11:50:00',7.18),('9650','2013-05-25','11:55:00',7.3),('9650','2013-05-25','12:00:00',7.3),('9650','2013-05-25','12:05:00',7.44),('9650','2013-05-25','12:10:00',7.11),('9650','2013-05-25','12:15:00',5.18),('9650','2013-05-25','12:20:00',7.03),('9650','2013-05-25','12:25:00',7.12),('9650','2013-05-25','12:30:00',8),('9650','2013-05-25','12:35:00',7.91),('9650','2013-05-25','12:40:00',7.2),('9650','2013-05-25','12:45:00',7.23),('9650','2013-05-25','12:50:00',7.92),('9650','2013-05-25','12:55:00',7.94),('9650','2013-05-25','13:00:00',7.35),('9650','2013-05-25','13:05:00',7.15),('9650','2013-05-25','13:10:00',8.25),('9650','2013-05-25','13:15:00',8.18),('9650','2013-05-25','13:20:00',8.17),('9650','2013-05-25','13:25:00',8.21),('9650','2013-05-25','13:30:00',8.4),('9650','2013-05-25','13:35:00',8.08),('9650','2013-05-25','13:40:00',8.17),('9650','2013-05-25','13:45:00',8.27),('9650','2013-05-25','13:50:00',8.29),('9650','2013-05-25','13:55:00',8.15),('9650','2013-05-25','14:00:00',8.24),('9650','2013-05-25','14:05:00',8.2),('9650','2013-05-25','14:10:00',8.18),('9650','2013-05-25','14:15:00',8.18),('9650','2013-05-25','14:20:00',8.22),('9650','2013-05-25','14:25:00',8.19),('9650','2013-05-25','14:30:00',8.21),('9650','2013-05-25','14:35:00',8.18),('9650','2013-05-25','14:40:00',8.19),('9650','2013-05-25','14:45:00',8.12),('9650','2013-05-25','14:50:00',8.15),('9650','2013-05-25','14:55:00',8.15),('9650','2013-05-25','15:00:00',8.08),('9650','2013-05-25','15:05:00',8.09),('9650','2013-05-25','15:10:00',8.07),('9650','2013-05-25','15:15:00',8.06),('9650','2013-05-25','15:20:00',8.05),('9650','2013-05-25','15:25:00',8.05),('9650','2013-05-25','15:30:00',8),('9650','2013-05-25','15:35:00',7.94),('9650','2013-05-25','15:40:00',7.87),('9650','2013-05-25','15:45:00',7.81),('9650','2013-05-25','15:50:00',7.74),('9650','2013-05-25','15:55:00',7.68),('9650','2013-05-25','16:00:00',7.65),('9650','2013-05-25','16:05:00',7.58),('9650','2013-05-25','16:10:00',7.55),('9650','2013-05-25','16:15:00',7.46),('9650','2013-05-25','16:20:00',7.4),('9650','2013-05-25','16:25:00',7.33),('9650','2013-05-25','16:30:00',7.26),('9650','2013-05-25','16:35:00',7.16),('9650','2013-05-25','16:40:00',7.07),('9650','2013-05-25','16:45:00',7),('9650','2013-05-25','16:50:00',6.9),('9650','2013-05-25','16:55:00',6.87),('9650','2013-05-25','17:00:00',6.75),('9650','2013-05-25','17:05:00',6.57),('9650','2013-05-25','17:10:00',6.39),('9650','2013-05-25','17:15:00',6.28),('9650','2013-05-25','17:20:00',6.28),('9650','2013-05-25','17:25:00',6.2),('9650','2013-05-25','17:30:00',6.07),('9650','2013-05-25','17:35:00',5.69),('9650','2013-05-25','17:40:00',5.76),('9650','2013-05-25','17:45:00',5.65),('9650','2013-05-25','17:50:00',5.55),('9650','2013-05-25','17:55:00',5.41),('9650','2013-05-25','18:00:00',5.31),('9650','2013-05-25','18:05:00',5.17),('9650','2013-05-25','18:10:00',5.03),('9650','2013-05-25','18:15:00',4.91),('9650','2013-05-25','18:20:00',4.76),('9650','2013-05-25','18:25:00',4.63),('9650','2013-05-25','18:30:00',4.45),('9650','2013-05-25','18:35:00',4.3),('9650','2013-05-25','18:40:00',4.07),('9650','2013-05-25','18:45:00',3.93),('9650','2013-05-25','18:50:00',3.81),('9650','2013-05-25','18:55:00',3.65),('9650','2013-05-25','19:00:00',3.44),('9650','2013-05-25','19:05:00',3.27),('9650','2013-05-25','19:10:00',3.1),('9650','2013-05-25','19:15:00',2.88),('9650','2013-05-25','19:20:00',2.68),('9650','2013-05-25','19:25:00',2.48),('9650','2013-05-25','19:30:00',2.26),('9650','2013-05-25','19:35:00',1.98),('9650','2013-05-25','19:40:00',1.81),('9650','2013-05-25','19:45:00',1.57),('9650','2013-05-25','19:50:00',1.27),('9650','2013-05-25','19:55:00',1.05),('9650','2013-05-24','07:35:00',1.61),('9650','2013-05-24','07:40:00',1.17),('9650','2013-05-24','07:55:00',1.49),('9650','2013-05-24','08:00:00',2.18),('9650','2013-05-24','08:05:00',2.31),('9650','2013-05-24','08:10:00',1.67),('9650','2013-05-24','08:15:00',1.04),('9650','2013-05-24','08:20:00',1.65),('9650','2013-05-24','08:25:00',2.51),('9650','2013-05-24','08:30:00',3.15),('9650','2013-05-24','08:35:00',2.01),('9650','2013-05-24','08:40:00',2.04),('9650','2013-05-24','08:45:00',1.77),('9650','2013-05-24','08:50:00',2.17),('9650','2013-05-24','08:55:00',1.88),('9650','2013-05-24','09:00:00',2.46),('9650','2013-05-24','09:05:00',3.28),('9650','2013-05-24','09:10:00',3.79),('9650','2013-05-24','09:15:00',4.64),('9650','2013-05-24','09:20:00',2.41),('9650','2013-05-24','09:25:00',2.49),('9650','2013-05-24','09:30:00',1.77),('9650','2013-05-24','09:35:00',3.3),('9650','2013-05-24','09:40:00',4.84),('9650','2013-05-24','09:45:00',3.78),('9650','2013-05-24','09:50:00',5.12),('9650','2013-05-24','09:55:00',3.27),('9650','2013-05-24','10:00:00',1.41),('9650','2013-05-24','10:05:00',1.29),('9650','2013-05-24','10:10:00',2.09),('9650','2013-05-24','10:15:00',1.84),('9650','2013-05-24','10:25:00',1.58),('9650','2013-05-24','10:30:00',1.52),('9650','2013-05-24','10:35:00',1.5),('9650','2013-05-24','10:40:00',2.52),('9650','2013-05-24','10:45:00',2.37),('9650','2013-05-24','10:50:00',2.34),('9650','2013-05-24','10:55:00',1.25),('9650','2013-05-24','11:00:00',1.88),('9650','2013-05-24','11:05:00',3.16),('9650','2013-05-24','11:10:00',7.07),('9650','2013-05-24','11:15:00',6.87),('9650','2013-05-24','11:20:00',4.75),('9650','2013-05-24','11:25:00',1.71),('9650','2013-05-24','11:35:00',3.19),('9650','2013-05-24','11:40:00',3.9),('9650','2013-05-24','11:45:00',4.25),('9650','2013-05-24','11:50:00',3.34),('9650','2013-05-24','11:55:00',3.44),('9650','2013-05-24','12:00:00',3.04),('9650','2013-05-24','12:05:00',2.6),('9650','2013-05-24','12:10:00',3.17),('9650','2013-05-24','12:15:00',2.3),('9650','2013-05-24','12:20:00',2.79),('9650','2013-05-24','12:25:00',3.53),('9650','2013-05-24','12:30:00',2.46),('9650','2013-05-24','12:35:00',2.91),('9650','2013-05-24','12:40:00',3.26),('9650','2013-05-24','12:45:00',3.17),('9650','2013-05-24','12:50:00',2.33),('9650','2013-05-24','12:55:00',3.46),('9650','2013-05-24','13:00:00',1.83),('9650','2013-05-24','13:05:00',2.98),('9650','2013-05-24','13:10:00',2.63),('9650','2013-05-24','13:15:00',3.47),('9650','2013-05-24','13:20:00',4.08),('9650','2013-05-24','13:25:00',6.88),('9650','2013-05-24','13:30:00',3.29),('9650','2013-05-24','13:35:00',2.57),('9650','2013-05-24','13:40:00',3.78),('9650','2013-05-24','13:45:00',3.34),('9650','2013-05-24','13:50:00',4.17),('9650','2013-05-24','13:55:00',6.86),('9650','2013-05-24','14:00:00',6.42),('9650','2013-05-24','14:05:00',7.18),('9650','2013-05-24','14:10:00',7.83),('9650','2013-05-24','14:15:00',7.1),('9650','2013-05-24','14:20:00',8.07),('9650','2013-05-24','14:25:00',5.14),('9650','2013-05-24','14:30:00',6),('9650','2013-05-24','14:35:00',4.68),('9650','2013-05-24','14:40:00',2.35),('9650','2013-05-24','14:45:00',5.65),('9650','2013-05-24','14:50:00',2.58),('9650','2013-05-24','14:55:00',3.13),('9650','2013-05-24','15:00:00',7.27),('9650','2013-05-24','15:05:00',5.12),('9650','2013-05-24','15:10:00',4.34),('9650','2013-05-24','15:15:00',4.38),('9650','2013-05-24','15:20:00',2.63),('9650','2013-05-24','15:25:00',4.76),('9650','2013-05-24','15:30:00',5.18),('9650','2013-05-24','15:35:00',8.94),('9650','2013-05-24','15:40:00',8.59),('9650','2013-05-24','15:45:00',7.6),('9650','2013-05-24','15:50:00',8.74),('9650','2013-05-24','15:55:00',8.91),('9650','2013-05-24','16:00:00',5.19),('9650','2013-05-24','16:05:00',3.95),('9650','2013-05-24','16:10:00',4.17),('9650','2013-05-24','16:15:00',3.74),('9650','2013-05-24','16:20:00',3.61),('9650','2013-05-24','16:25:00',3.56),('9650','2013-05-24','16:30:00',5.59),('9650','2013-05-24','16:35:00',7.21),('9650','2013-05-24','16:40:00',6.94),('9650','2013-05-24','16:45:00',5.38),('9650','2013-05-24','16:50:00',3.15),('9650','2013-05-24','16:55:00',1.85),('9650','2013-05-24','17:00:00',1.88),('9650','2013-05-24','17:05:00',3.88),('9650','2013-05-24','17:10:00',7.22),('9650','2013-05-24','17:15:00',5.6),('9650','2013-05-24','17:20:00',4.92),('9650','2013-05-24','17:25:00',2.8),('9650','2013-05-24','17:30:00',1.64),('9650','2013-05-24','17:35:00',3.37),('9650','2013-05-24','17:40:00',2),('9650','2013-05-24','17:45:00',2.32),('9650','2013-05-24','17:50:00',4.22),('9650','2013-05-24','17:55:00',1.73),('9650','2013-05-24','18:00:00',1.88),('9650','2013-05-24','18:05:00',1.59),('9650','2013-05-24','18:10:00',2.31),('9650','2013-05-24','18:15:00',1.57),('9650','2013-05-24','18:20:00',2.28),('9650','2013-05-24','18:35:00',1.07),('9650','2013-05-23','07:00:00',1.03),('9650','2013-05-23','07:40:00',1.09),('9650','2013-05-23','08:00:00',1.36),('9650','2013-05-23','08:05:00',1.77),('9650','2013-05-23','08:10:00',2.33),('9650','2013-05-23','08:15:00',2.19),('9650','2013-05-23','08:20:00',1.08),('9650','2013-05-23','08:25:00',1.34),('9650','2013-05-23','08:30:00',2.21),('9650','2013-05-23','08:35:00',1.89),('9650','2013-05-23','08:40:00',1.31),('9650','2013-05-23','08:45:00',2.47),('9650','2013-05-23','08:50:00',2.53),('9650','2013-05-23','08:55:00',2.74),('9650','2013-05-23','09:00:00',3.07),('9650','2013-05-23','09:05:00',3.75),('9650','2013-05-23','09:10:00',1.06),('9650','2013-05-23','09:15:00',1.37),('9650','2013-05-23','09:20:00',3.46),('9650','2013-05-23','09:25:00',2.39),('9650','2013-05-23','09:30:00',2.57),('9650','2013-05-23','09:35:00',1.18),('9650','2013-05-23','09:40:00',2.55),('9650','2013-05-23','09:45:00',1.8),('9650','2013-05-23','09:50:00',2.39),('9650','2013-05-23','09:55:00',4.08),('9650','2013-05-23','10:00:00',2.87),('9650','2013-05-23','10:05:00',1.45),('9650','2013-05-23','10:20:00',1.94),('9650','2013-05-23','10:25:00',3.88),('9650','2013-05-23','10:30:00',5.7),('9650','2013-05-23','10:35:00',5.5),('9650','2013-05-23','10:40:00',5.1),('9650','2013-05-23','10:45:00',5.45),('9650','2013-05-23','10:50:00',4.44),('9650','2013-05-23','10:55:00',6.8),('9650','2013-05-23','11:00:00',5.17),('9650','2013-05-23','11:05:00',4.87),('9650','2013-05-23','11:10:00',6.1),('9650','2013-05-23','11:15:00',5.16),('9650','2013-05-23','11:20:00',6.94),('9650','2013-05-23','11:25:00',7.02),('9650','2013-05-23','11:30:00',4.39),('9650','2013-05-23','11:35:00',2.49),('9650','2013-05-23','11:40:00',1.64),('9650','2013-05-23','11:45:00',4.38),('9650','2013-05-23','11:50:00',8.28),('9650','2013-05-23','11:55:00',5.55),('9650','2013-05-23','12:00:00',4.03),('9650','2013-05-23','12:05:00',4.94),('9650','2013-05-23','12:10:00',7.17),('9650','2013-05-23','12:15:00',4.55),('9650','2013-05-23','12:20:00',3.81),('9650','2013-05-23','12:25:00',6.92),('9650','2013-05-23','12:30:00',8.26),('9650','2013-05-23','12:35:00',3.93),('9650','2013-05-23','12:40:00',4.93),('9650','2013-05-23','12:45:00',6.52),('9650','2013-05-23','12:50:00',5.52),('9650','2013-05-23','12:55:00',4.52),('9650','2013-05-23','13:00:00',4.35),('9650','2013-05-23','13:05:00',3.62),('9650','2013-05-23','13:10:00',4.41),('9650','2013-05-23','13:15:00',5.32),('9650','2013-05-23','13:20:00',5.58),('9650','2013-05-23','13:25:00',4.21),('9650','2013-05-23','13:30:00',3.48),('9650','2013-05-23','13:35:00',5.03),('9650','2013-05-23','13:40:00',4.1),('9650','2013-05-23','13:45:00',1.99),('9650','2013-05-23','13:50:00',2.12),('9650','2013-05-23','13:55:00',4.4),('9650','2013-05-23','14:00:00',4.06),('9650','2013-05-23','14:05:00',3.8),('9650','2013-05-23','14:10:00',2.54),('9650','2013-05-23','14:15:00',7.06),('9650','2013-05-23','14:20:00',6.35),('9650','2013-05-23','14:25:00',6.07),('9650','2013-05-23','14:30:00',4.6),('9650','2013-05-23','14:35:00',6.29),('9650','2013-05-23','14:40:00',4.67),('9650','2013-05-23','14:45:00',5.71),('9650','2013-05-23','14:50:00',2.58),('9650','2013-05-23','14:55:00',3.13),('9650','2013-05-23','15:00:00',4.86),('9650','2013-05-23','15:05:00',6.69),('9650','2013-05-23','15:10:00',4.56),('9650','2013-05-23','15:15:00',6.85),('9650','2013-05-23','15:20:00',7.73),('9650','2013-05-23','15:25:00',6.69),('9650','2013-05-23','15:30:00',8.01),('9650','2013-05-23','15:35:00',7.21),('9650','2013-05-23','15:40:00',6.31),('9650','2013-05-23','15:45:00',7.39),('9650','2013-05-23','15:50:00',8.39),('9650','2013-05-23','15:55:00',9.07),('9650','2013-05-23','16:00:00',4.13),('9650','2013-05-23','16:05:00',3.99),('9650','2013-05-23','16:10:00',4.44),('9650','2013-05-23','16:15:00',5.68),('9650','2013-05-23','16:20:00',4.26),('9650','2013-05-23','16:25:00',6.03),('9650','2013-05-23','16:30:00',6.24),('9650','2013-05-23','16:35:00',3.13),('9650','2013-05-23','16:40:00',1.25),('9650','2013-05-23','16:45:00',1.28),('9650','2013-05-23','16:50:00',3.05),('9650','2013-05-23','16:55:00',3.76),('9650','2013-05-23','17:00:00',2.68),('9650','2013-05-23','17:05:00',1.92),('9650','2013-05-23','17:10:00',1.63),('9650','2013-05-23','17:15:00',1.65),('9650','2013-05-23','17:20:00',2.09),('9650','2013-05-23','17:25:00',2.17),('9650','2013-05-23','17:30:00',2.21),('9650','2013-05-23','17:35:00',2.19),('9650','2013-05-23','17:40:00',1.9),('9650','2013-05-23','17:45:00',1.6),('9650','2013-05-23','17:50:00',1.11),('9650','2013-05-23','18:10:00',1.01),('9650','2013-05-22','07:05:00',1.05),('9650','2013-05-22','07:10:00',1.62),('9650','2013-05-22','07:45:00',1.12),('9650','2013-05-22','07:50:00',1.5),('9650','2013-05-22','07:55:00',1.66),('9650','2013-05-22','08:00:00',1.89),('9650','2013-05-22','08:05:00',2.06),('9650','2013-05-22','08:10:00',1.51),('9650','2013-05-22','08:25:00',1.32),('9650','2013-05-22','08:30:00',2.21),('9650','2013-05-22','08:35:00',2.29),('9650','2013-05-22','08:40:00',2.72),('9650','2013-05-22','08:45:00',2.75),('9650','2013-05-22','08:50:00',1.43),('9650','2013-05-22','08:55:00',1.34),('9650','2013-05-22','09:00:00',3.65),('9650','2013-05-22','09:05:00',1.67),('9650','2013-05-22','09:15:00',1.67),('9650','2013-05-22','09:20:00',2.78),('9650','2013-05-22','09:25:00',3.98),('9650','2013-05-22','09:30:00',4.57),('9650','2013-05-22','09:35:00',3.82),('9650','2013-05-22','09:40:00',4.22),('9650','2013-05-22','09:45:00',2.9),('9650','2013-05-22','09:50:00',4.54),('9650','2013-05-22','09:55:00',2.71),('9650','2013-05-22','10:00:00',1.75),('9650','2013-05-22','10:05:00',4.7),('9650','2013-05-22','10:10:00',4.99),('9650','2013-05-22','10:15:00',5.55),('9650','2013-05-22','10:20:00',3.28),('9650','2013-05-22','10:25:00',5.13),('9650','2013-05-22','10:30:00',5.19),('9650','2013-05-22','10:35:00',5.34),('9650','2013-05-22','10:40:00',5.53),('9650','2013-05-22','10:45:00',5.95),('9650','2013-05-22','10:50:00',4.37),('9650','2013-05-22','10:55:00',6.22),('9650','2013-05-22','11:00:00',3.74),('9650','2013-05-22','11:05:00',6.05),('9650','2013-05-22','11:10:00',3.25),('9650','2013-05-22','11:15:00',4.05),('9650','2013-05-22','11:20:00',3.05),('9650','2013-05-22','11:25:00',4.16),('9650','2013-05-22','11:30:00',5.51),('9650','2013-05-22','11:35:00',5.58),('9650','2013-05-22','11:40:00',7.15),('9650','2013-05-22','11:45:00',3.88),('9650','2013-05-22','11:50:00',5.68),('9650','2013-05-22','11:55:00',6.81),('9650','2013-05-22','12:00:00',7.49),('9650','2013-05-22','12:05:00',7.5),('9650','2013-05-22','12:10:00',7.7),('9650','2013-05-22','12:15:00',5.39),('9650','2013-05-22','12:20:00',5.89),('9650','2013-05-22','12:25:00',7.02),('9650','2013-05-22','12:30:00',8.34),('9650','2013-05-22','12:35:00',2.94),('9650','2013-05-22','12:40:00',9.08),('9650','2013-05-22','12:45:00',5.87),('9650','2013-05-22','12:50:00',6.14),('9650','2013-05-22','12:55:00',8.68),('9650','2013-05-22','13:00:00',8.22),('9650','2013-05-22','13:05:00',5.76),('9650','2013-05-22','13:10:00',7.15),('9650','2013-05-22','13:15:00',6.84),('9650','2013-05-22','13:20:00',6.1),('9650','2013-05-22','13:25:00',7.5),('9650','2013-05-22','13:30:00',5.29),('9650','2013-05-22','13:35:00',4.65),('9650','2013-05-22','13:40:00',4.29),('9650','2013-05-22','13:45:00',5.61),('9650','2013-05-22','13:50:00',6.47),('9650','2013-05-22','13:55:00',8.01),('9650','2013-05-22','14:00:00',8.13),('9650','2013-05-22','14:05:00',8.5),('9650','2013-05-22','14:10:00',8.7),('9650','2013-05-22','14:15:00',6.52),('9650','2013-05-22','14:20:00',7.44),('9650','2013-05-22','14:25:00',5.37),('9650','2013-05-22','14:30:00',3.16),('9650','2013-05-22','14:35:00',9.13),('9650','2013-05-22','14:40:00',6.92),('9650','2013-05-22','14:45:00',3.43),('9650','2013-05-22','14:50:00',3.71),('9650','2013-05-22','14:55:00',5.92),('9650','2013-05-22','15:00:00',6.12),('9650','2013-05-22','15:05:00',6.14),('9650','2013-05-22','15:10:00',2.43),('9650','2013-05-22','15:15:00',3.32),('9650','2013-05-22','15:20:00',6.36),('9650','2013-05-22','15:25:00',2.67),('9650','2013-05-22','15:30:00',7.45),('9650','2013-05-22','15:35:00',6.35),('9650','2013-05-22','15:40:00',2.42),('9650','2013-05-22','15:45:00',5.24),('9650','2013-05-22','15:50:00',2.1),('9650','2013-05-22','15:55:00',3.49),('9650','2013-05-22','16:00:00',4.67),('9650','2013-05-22','16:05:00',8.08),('9650','2013-05-22','16:10:00',3.82),('9650','2013-05-22','16:15:00',5.8),('9650','2013-05-22','16:20:00',6.25),('9650','2013-05-22','16:25:00',5.75),('9650','2013-05-22','16:30:00',7.04),('9650','2013-05-22','16:35:00',3.75),('9650','2013-05-22','16:40:00',2.53),('9650','2013-05-22','16:45:00',3.87),('9650','2013-05-22','16:50:00',2.66),('9650','2013-05-22','16:55:00',1.15),('9650','2013-05-22','17:00:00',1.08),('9650','2013-05-22','17:05:00',2.26),('9650','2013-05-22','17:10:00',4.9),('9650','2013-05-22','17:15:00',4.12),('9650','2013-05-22','17:20:00',2.64),('9650','2013-05-22','17:25:00',2.09),('9650','2013-05-22','17:30:00',1.8),('9650','2013-05-22','17:35:00',3.35),('9650','2013-05-22','17:40:00',2.06),('9650','2013-05-22','17:45:00',1.83),('9650','2013-05-22','17:50:00',1.72),('9650','2013-05-22','17:55:00',2.79),('9650','2013-05-22','18:00:00',4.27),('9650','2013-05-22','18:05:00',6.03),('9650','2013-05-22','18:10:00',2),('9650','2013-05-22','18:35:00',1.15),('9650','2013-05-22','18:40:00',1.52),('9650','2013-05-22','18:45:00',2.95),('9650','2013-05-22','18:50:00',3.39),('9650','2013-05-22','18:55:00',2.1),('9650','2013-05-22','19:00:00',1.27),('9650','2013-05-21','07:25:00',1.04),('9650','2013-05-21','07:40:00',1.1),('9650','2013-05-21','07:45:00',1.22),('9650','2013-05-21','07:50:00',1.44),('9650','2013-05-21','07:55:00',1.5),('9650','2013-05-21','08:00:00',1.42),('9650','2013-05-21','08:05:00',1.61),('9650','2013-05-21','08:10:00',1.6),('9650','2013-05-21','08:15:00',2.3),('9650','2013-05-21','08:20:00',2.15),('9650','2013-05-21','08:25:00',2.19),('9650','2013-05-21','08:30:00',3.02),('9650','2013-05-21','08:35:00',3.49),('9650','2013-05-21','08:40:00',2.32),('9650','2013-05-21','08:45:00',2.21),('9650','2013-05-21','08:50:00',1.28),('9650','2013-05-21','09:10:00',1.16),('9650','2013-05-21','09:15:00',1.56),('9650','2013-05-21','09:20:00',1.64),('9650','2013-05-21','09:25:00',1.89),('9650','2013-05-21','09:30:00',3.76),('9650','2013-05-21','09:35:00',3.69),('9650','2013-05-21','09:40:00',3.7),('9650','2013-05-21','09:45:00',3.79),('9650','2013-05-21','09:50:00',3.91),('9650','2013-05-21','09:55:00',4.01),('9650','2013-05-21','10:00:00',4.14),('9650','2013-05-21','10:05:00',4.26),('9650','2013-05-21','10:10:00',4.34),('9650','2013-05-21','10:15:00',4.47),('9650','2013-05-21','10:20:00',4.37),('9650','2013-05-21','10:25:00',4.81),('9650','2013-05-21','10:30:00',4.91),('9650','2013-05-21','10:35:00',5.08),('9650','2013-05-21','10:40:00',5.49),('9650','2013-05-21','10:45:00',5.49),('9650','2013-05-21','10:50:00',5.32),('9650','2013-05-21','10:55:00',5.36),('9650','2013-05-21','11:00:00',5.52),('9650','2013-05-21','11:05:00',5.72),('9650','2013-05-21','11:10:00',4.55),('9650','2013-05-21','11:15:00',5.61),('9650','2013-05-21','11:20:00',5.94),('9650','2013-05-21','11:25:00',6.18),('9650','2013-05-21','11:30:00',4.74),('9650','2013-05-21','11:35:00',4.83),('9650','2013-05-21','11:40:00',4.55),('9650','2013-05-21','11:45:00',6.31),('9650','2013-05-21','11:50:00',4.24),('9650','2013-05-21','11:55:00',3.26),('9650','2013-05-21','12:00:00',4.91),('9650','2013-05-21','12:05:00',4.01),('9650','2013-05-21','12:10:00',3.99),('9650','2013-05-21','12:15:00',4.97),('9650','2013-05-21','12:20:00',6.33),('9650','2013-05-21','12:25:00',5.18),('9650','2013-05-21','12:30:00',3.72),('9650','2013-05-21','12:35:00',4.05),('9650','2013-05-21','12:40:00',2.99),('9650','2013-05-21','12:45:00',1.47),('9650','2013-05-21','13:00:00',1.17),('9650','2013-05-21','13:05:00',5.89),('9650','2013-05-21','13:10:00',4.24),('9650','2013-05-21','13:15:00',4.35),('9650','2013-05-21','13:20:00',5.34),('9650','2013-05-21','13:25:00',1.97),('9650','2013-05-21','13:30:00',2.96),('9650','2013-05-21','13:35:00',6.7),('9650','2013-05-21','13:40:00',5.28),('9650','2013-05-21','13:45:00',4.91),('9650','2013-05-21','13:50:00',3.34),('9650','2013-05-21','13:55:00',3.36),('9650','2013-05-21','14:00:00',5.05),('9650','2013-05-21','14:05:00',6.43),('9650','2013-05-21','14:10:00',7.72),('9650','2013-05-21','14:15:00',7.6),('9650','2013-05-21','14:20:00',7.41),('9650','2013-05-21','14:25:00',7.38),('9650','2013-05-21','14:30:00',7.35),('9650','2013-05-21','14:35:00',7.29),('9650','2013-05-21','14:40:00',7.32),('9650','2013-05-21','14:45:00',7.35),('9650','2013-05-21','14:50:00',7.35),('9650','2013-05-21','14:55:00',7.18),('9650','2013-05-21','15:00:00',7.28),('9650','2013-05-21','15:05:00',7.25),('9650','2013-05-21','15:10:00',7.18),('9650','2013-05-21','15:15:00',7.16),('9650','2013-05-21','15:20:00',6.34),('9650','2013-05-21','15:25:00',4.78),('9650','2013-05-21','15:30:00',4.04),('9650','2013-05-21','15:35:00',4.27),('9650','2013-05-21','15:40:00',6.34),('9650','2013-05-21','15:45:00',5.42),('9650','2013-05-21','15:50:00',6.79),('9650','2013-05-21','15:55:00',6.75),('9650','2013-05-21','16:00:00',6.71),('9650','2013-05-21','16:05:00',6.61),('9650','2013-05-21','16:10:00',6.5),('9650','2013-05-21','16:15:00',6.45),('9650','2013-05-21','16:20:00',6.38),('9650','2013-05-21','16:25:00',6.31),('9650','2013-05-21','16:30:00',6.18),('9650','2013-05-21','16:35:00',5.93),('9650','2013-05-21','16:40:00',6.02),('9650','2013-05-21','16:45:00',5.21),('9650','2013-05-21','16:50:00',2.97),('9650','2013-05-21','16:55:00',1.59),('9650','2013-05-21','17:00:00',1.4),('9650','2013-05-21','17:05:00',1.4),('9650','2013-05-21','17:10:00',1.64),('9650','2013-05-21','17:15:00',2.27),('9650','2013-05-21','17:20:00',2.6),('9650','2013-05-21','17:25:00',3.17),('9650','2013-05-21','17:30:00',2.71),('9650','2013-05-21','17:35:00',3.21),('9650','2013-05-21','17:40:00',1.67),('9650','2013-05-21','17:55:00',3.11),('9650','2013-05-21','18:00:00',3.99),('9650','2013-05-21','18:05:00',2.17),('9650','2013-05-21','18:10:00',1.2),('9650','2013-05-21','18:15:00',1.11),('9650','2013-05-21','18:20:00',1.05),('9650','2013-05-21','18:25:00',2.26),('9650','2013-05-21','18:30:00',1.19),('9650','2013-05-21','18:40:00',1.11),('9650','2013-05-21','18:45:00',1.27),('9650','2013-05-21','19:00:00',1.33),('9650','2013-05-21','19:05:00',1.53),('9650','2013-05-21','19:10:00',1.78),('9650','2013-05-21','19:15:00',1.8),('9650','2013-05-21','19:20:00',1.59),('9650','2013-05-21','19:25:00',1.27),('9650','2013-05-21','19:30:00',1.14),('9650','2013-05-21','19:35:00',1.03),('9650','2014-03-31','09:10:00',1.07),('9650','2014-03-31','09:15:00',1.17),('9650','2014-03-31','09:20:00',1.3),('9650','2014-03-31','09:25:00',1.44),('9650','2014-03-31','09:30:00',1.54),('9650','2014-03-31','09:35:00',1.66),('9650','2014-03-31','09:40:00',1.81),('9650','2014-03-31','09:45:00',1.95),('9650','2014-03-31','09:50:00',2.03),('9650','2014-03-31','09:55:00',2.25),('9650','2014-03-31','10:00:00',2.41),('9650','2014-03-31','10:05:00',2.52),('9650','2014-03-31','10:10:00',2.71),('9650','2014-03-31','10:15:00',2.95),('9650','2014-03-31','10:20:00',3.4),('9650','2014-03-31','10:25:00',3.73),('9650','2014-03-31','10:30:00',3.87),('9650','2014-03-31','10:35:00',3.49),('9650','2014-03-31','10:40:00',3.04),('9650','2014-03-31','10:45:00',2.32),('9650','2014-03-31','10:50:00',3.82),('9650','2014-03-31','10:55:00',3.83),('9650','2014-03-31','11:00:00',3.94),('9650','2014-03-31','11:05:00',4.07),('9650','2014-03-31','11:10:00',4.15),('9650','2014-03-31','11:15:00',4.24),('9650','2014-03-31','11:20:00',4.39),('9650','2014-03-31','11:25:00',4.55),('9650','2014-03-31','11:30:00',4.63),('9650','2014-03-31','11:35:00',4.75),('9650','2014-03-31','11:40:00',4.79),('9650','2014-03-31','11:45:00',4.96),('9650','2014-03-31','11:50:00',5.03),('9650','2014-03-31','11:55:00',5.11),('9650','2014-03-31','12:00:00',5.22),('9650','2014-03-31','12:05:00',5.33),('9650','2014-03-31','12:10:00',5.38),('9650','2014-03-31','12:15:00',5.48),('9650','2014-03-31','12:20:00',5.58),('9650','2014-03-31','12:25:00',5.67),('9650','2014-03-31','12:30:00',5.77),('9650','2014-03-31','12:35:00',5.85),('9650','2014-03-31','12:40:00',5.93),('9650','2014-03-31','12:45:00',6.01),('9650','2014-03-31','12:50:00',6.07),('9650','2014-03-31','12:55:00',6.13),('9650','2014-03-31','13:00:00',6.23),('9650','2014-03-31','13:05:00',5.77),('9650','2014-03-31','13:10:00',6.41),('9650','2014-03-31','13:15:00',5.6),('9650','2014-03-31','13:20:00',5.74),('9650','2014-03-31','13:25:00',6.4),('9650','2014-03-31','13:30:00',6.45),('9650','2014-03-31','13:35:00',6.55),('9650','2014-03-31','13:40:00',6.74),('9650','2014-03-31','13:45:00',6.68),('9650','2014-03-31','13:50:00',6.6),('9650','2014-03-31','13:55:00',6.67),('9650','2014-03-31','14:00:00',6.68),('9650','2014-03-31','14:05:00',6.74),('9650','2014-03-31','14:10:00',6.4),('9650','2014-03-31','14:15:00',5.38),('9650','2014-03-31','14:20:00',5.84),('9650','2014-03-31','14:25:00',6.73),('9650','2014-03-31','14:30:00',5.43),('9650','2014-03-31','14:35:00',6.98),('9650','2014-03-31','14:40:00',5.68),('9650','2014-03-31','14:45:00',7.4),('9650','2014-03-31','14:50:00',7.12),('9650','2014-03-31','14:55:00',5.59),('9650','2014-03-31','15:00:00',6.9),('9650','2014-03-31','15:05:00',6.39),('9650','2014-03-31','15:10:00',6.01),('9650','2014-03-31','15:15:00',5.65),('9650','2014-03-31','15:20:00',4.43),('9650','2014-03-31','15:25:00',5.73),('9650','2014-03-31','15:30:00',5.73),('9650','2014-03-31','15:35:00',5.01),('9650','2014-03-31','15:40:00',6.4),('9650','2014-03-31','15:45:00',4.84),('9650','2014-03-31','15:50:00',6.09),('9650','2014-03-31','15:55:00',5.59),('9650','2014-03-31','16:00:00',3.78),('9650','2014-03-31','16:05:00',5.1),('9650','2014-03-31','16:10:00',4.85),('9650','2014-03-31','16:15:00',3.97),('9650','2014-03-31','16:20:00',2.74),('9650','2014-03-31','16:25:00',4.04),('9650','2014-03-31','16:30:00',4.49),('9650','2014-03-31','16:35:00',5.43),('9650','2014-03-31','16:40:00',5.09),('9650','2014-03-31','16:45:00',2.78),('9650','2014-03-31','16:50:00',2.93),('9650','2014-03-31','16:55:00',3.84),('9650','2014-03-31','17:00:00',4.77),('9650','2014-03-31','17:05:00',4.34),('9650','2014-03-31','17:10:00',3.63),('9650','2014-03-31','17:15:00',4.19),('9650','2014-03-31','17:20:00',4.02),('9650','2014-03-31','17:25:00',3.73),('9650','2014-03-31','17:30:00',3.76),('9650','2014-03-31','17:35:00',3.68),('9650','2014-03-31','17:40:00',3.65),('9650','2014-03-31','17:45:00',3.26),('9650','2014-03-31','17:50:00',3.33),('9650','2014-03-31','17:55:00',3.11),('9650','2014-03-31','18:00:00',2.94),('9650','2014-03-31','18:05:00',2.84),('9650','2014-03-31','18:10:00',2.66),('9650','2014-03-31','18:15:00',2.51),('9650','2014-03-31','18:20:00',2.27),('9650','2014-03-31','18:25:00',1.71),('9650','2013-05-20','07:35:00',1.26),('9650','2013-05-20','07:40:00',1.56),('9650','2013-05-20','07:45:00',1.43),('9650','2013-05-20','07:50:00',1.24),('9650','2013-05-20','07:55:00',1.39),('9650','2013-05-20','08:00:00',1.32),('9650','2013-05-20','08:05:00',1.15),('9650','2013-05-20','08:10:00',1.85),('9650','2013-05-20','08:15:00',2.41),('9650','2013-05-20','08:20:00',2.29),('9650','2013-05-20','08:25:00',2.65),('9650','2013-05-20','08:30:00',2.12),('9650','2013-05-20','08:35:00',2.13),('9650','2013-05-20','08:40:00',2.45),('9650','2013-05-20','08:45:00',2.18),('9650','2013-05-20','08:50:00',2.32),('9650','2013-05-20','08:55:00',2.77),('9650','2013-05-20','09:00:00',2.48),('9650','2013-05-20','09:05:00',2.25),('9650','2013-05-20','09:10:00',2.41),('9650','2013-05-20','09:15:00',2.57),('9650','2013-05-20','09:20:00',3.33),('9650','2013-05-20','09:25:00',3.48),('9650','2013-05-20','09:30:00',3.04),('9650','2013-05-20','09:35:00',3.15),('9650','2013-05-20','09:40:00',3.24),('9650','2013-05-20','09:45:00',2.95),('9650','2013-05-20','09:50:00',2.92),('9650','2013-05-20','09:55:00',3.15),('9650','2013-05-20','10:00:00',3.28),('9650','2013-05-20','10:05:00',3.5),('9650','2013-05-20','10:10:00',3.78),('9650','2013-05-20','10:15:00',3.87),('9650','2013-05-20','10:20:00',3.4),('9650','2013-05-20','10:25:00',3.32),('9650','2013-05-20','10:30:00',3.16),('9650','2013-05-20','10:35:00',3.28),('9650','2013-05-20','10:40:00',3.5),('9650','2013-05-20','10:45:00',4.89),('9650','2013-05-20','10:50:00',3.68),('9650','2013-05-20','10:55:00',2.97),('9650','2013-05-20','11:00:00',3.38),('9650','2013-05-20','11:05:00',3.14),('9650','2013-05-20','11:10:00',4.51),('9650','2013-05-20','11:15:00',6.07),('9650','2013-05-20','11:20:00',5.42),('9650','2013-05-20','11:25:00',6.61),('9650','2013-05-20','11:30:00',4.65),('9650','2013-05-20','11:35:00',4.16),('9650','2013-05-20','11:40:00',4.55),('9650','2013-05-20','11:45:00',5.38),('9650','2013-05-20','11:50:00',4.49),('9650','2013-05-20','11:55:00',5.91),('9650','2013-05-20','12:00:00',5.36),('9650','2013-05-20','12:05:00',6.2),('9650','2013-05-20','12:10:00',4.56),('9650','2013-05-20','12:15:00',5.37),('9650','2013-05-20','12:20:00',4.23),('9650','2013-05-20','12:25:00',5.75),('9650','2013-05-20','12:30:00',6.91),('9650','2013-05-20','12:35:00',4.87),('9650','2013-05-20','12:40:00',7.16),('9650','2013-05-20','12:45:00',6.87),('9650','2013-05-20','12:50:00',4.69),('9650','2013-05-20','12:55:00',8.15),('9650','2013-05-20','13:00:00',7.13),('9650','2013-05-20','13:05:00',7.25),('9650','2013-05-20','13:10:00',4.59),('9650','2013-05-20','13:15:00',6.53),('9650','2013-05-20','13:20:00',5.26),('9650','2013-05-20','13:25:00',5.52),('9650','2013-05-20','13:30:00',5.07),('9650','2013-05-20','13:35:00',2.55),('9650','2013-05-20','13:40:00',1.61),('9650','2013-05-20','13:45:00',1.11),('9650','2013-05-20','14:05:00',1.85),('9650','2013-05-20','14:10:00',3.02),('9650','2013-05-20','14:15:00',3.67),('9650','2013-05-20','14:20:00',3.13),('9650','2013-05-20','14:25:00',4.74),('9650','2013-05-20','14:30:00',4.58),('9650','2013-05-20','14:35:00',3.71),('9650','2013-05-20','14:40:00',3.43),('9650','2013-05-20','14:45:00',2.86),('9650','2013-05-20','14:50:00',1.7),('9650','2013-05-20','14:55:00',1.27),('9650','2013-05-20','15:05:00',1),('9650','2013-05-20','15:10:00',1.18),('9650','2013-05-20','15:15:00',2.01),('9650','2013-05-20','15:20:00',2.82),('9650','2013-05-20','15:25:00',2.91),('9650','2013-05-20','15:30:00',4.55),('9650','2013-05-20','15:35:00',3.08),('9650','2013-05-20','15:40:00',2.51),('9650','2013-05-20','15:45:00',2.64),('9650','2013-05-20','15:50:00',2.32),('9650','2013-05-20','15:55:00',2.16),('9650','2013-05-20','16:00:00',2.07),('9650','2013-05-20','16:05:00',2.12),('9650','2013-05-20','16:10:00',2.4),('9650','2013-05-20','16:15:00',1.94),('9650','2013-05-20','16:20:00',1.62),('9650','2013-05-20','16:25:00',2.23),('9650','2013-05-20','16:30:00',3.47),('9650','2013-05-20','16:35:00',4.03),('9650','2013-05-20','16:40:00',3.62),('9650','2013-05-20','16:45:00',3.48),('9650','2013-05-20','16:50:00',2.05),('9650','2013-05-20','16:55:00',1.06),('9650','2013-05-20','17:00:00',1.14),('9650','2013-05-20','17:05:00',1.37),('9650','2013-05-20','17:10:00',1.17),('9650','2013-05-19','07:45:00',1),('9650','2013-05-19','07:55:00',1.08),('9650','2013-05-19','08:00:00',1.2),('9650','2013-05-19','08:05:00',1.22),('9650','2013-05-19','08:10:00',1.42),('9650','2013-05-19','08:15:00',1.66),('9650','2013-05-19','08:20:00',2.2),('9650','2013-05-19','08:25:00',1.14),('9650','2013-05-19','08:35:00',1.07),('9650','2013-05-19','08:40:00',1.18),('9650','2013-05-19','08:45:00',2.65),('9650','2013-05-19','08:50:00',3.78),('9650','2013-05-19','08:55:00',3.22),('9650','2013-05-19','09:00:00',3.43),('9650','2013-05-19','09:05:00',3.29),('9650','2013-05-19','09:10:00',4.15),('9650','2013-05-19','09:15:00',2.38),('9650','2013-05-19','09:20:00',2.69),('9650','2013-05-19','09:25:00',1.65),('9650','2013-05-19','09:30:00',1.19),('9650','2013-05-19','09:35:00',3.62),('9650','2013-05-19','09:40:00',1.28),('9650','2013-05-19','09:45:00',2.54),('9650','2013-05-19','09:50:00',3.37),('9650','2013-05-19','09:55:00',1.4),('9650','2013-05-19','10:00:00',1.73),('9650','2013-05-19','10:05:00',2.11),('9650','2013-05-19','10:10:00',3.04),('9650','2013-05-19','10:15:00',1.52),('9650','2013-05-19','10:20:00',1.26),('9650','2013-05-19','10:25:00',2.36),('9650','2013-05-19','10:30:00',4.25),('9650','2013-05-19','10:35:00',2.5),('9650','2013-05-19','10:40:00',2.01),('9650','2013-05-19','10:45:00',2.38),('9650','2013-05-19','10:50:00',2.87),('9650','2013-05-19','10:55:00',1.93),('9650','2013-05-19','11:00:00',5.7),('9650','2013-05-19','11:05:00',5.74),('9650','2013-05-19','11:10:00',7.68),('9650','2013-05-19','11:15:00',5.78),('9650','2013-05-19','11:20:00',4.16),('9650','2013-05-19','11:25:00',5.94),('9650','2013-05-19','11:30:00',5.04),('9650','2013-05-19','11:35:00',5.83),('9650','2013-05-19','11:40:00',2.47),('9650','2013-05-19','11:45:00',2.71),('9650','2013-05-19','11:50:00',1.76),('9650','2013-05-19','11:55:00',7.11),('9650','2013-05-19','12:00:00',3.62),('9650','2013-05-19','12:05:00',6.12),('9650','2013-05-19','12:10:00',4.04),('9650','2013-05-19','12:15:00',3.02),('9650','2013-05-19','12:20:00',7.22),('9650','2013-05-19','12:25:00',3.45),('9650','2013-05-19','12:30:00',4.07),('9650','2013-05-19','12:35:00',3.17),('9650','2013-05-19','12:40:00',7.49),('9650','2013-05-19','12:45:00',7.31),('9650','2013-05-19','12:50:00',2.02),('9650','2013-05-19','12:55:00',5.38),('9650','2013-05-19','13:00:00',4.79),('9650','2013-05-19','13:05:00',6.02),('9650','2013-05-19','13:10:00',3.4),('9650','2013-05-19','13:15:00',3.45),('9650','2013-05-19','13:20:00',6.48),('9650','2013-05-19','13:25:00',7.9),('9650','2013-05-19','13:30:00',2.7),('9650','2013-05-19','13:35:00',6.91),('9650','2013-05-19','13:40:00',3.43),('9650','2013-05-19','13:45:00',7.6),('9650','2013-05-19','13:50:00',6.35),('9650','2013-05-19','13:55:00',6.9),('9650','2013-05-19','14:00:00',8.13),('9650','2013-05-19','14:05:00',2.37),('9650','2013-05-19','14:10:00',4.4),('9650','2013-05-19','14:15:00',6.35),('9650','2013-05-19','14:20:00',4.58),('9650','2013-05-19','14:25:00',6.67),('9650','2013-05-19','14:30:00',8.18),('9650','2013-05-19','14:35:00',5.3),('9650','2013-05-19','14:40:00',2.38),('9650','2013-05-19','14:45:00',8.03),('9650','2013-05-19','14:50:00',7.18),('9650','2013-05-19','14:55:00',6.44),('9650','2013-05-19','15:00:00',4.91),('9650','2013-05-19','15:05:00',3.71),('9650','2013-05-19','15:10:00',8.65),('9650','2013-05-19','15:15:00',3.96),('9650','2013-05-19','15:20:00',7.27),('9650','2013-05-19','15:25:00',7.09),('9650','2013-05-19','15:30:00',7.11),('9650','2013-05-19','15:35:00',8.36),('9650','2013-05-19','15:40:00',5),('9650','2013-05-19','15:45:00',3.08),('9650','2013-05-19','15:50:00',5.54),('9650','2013-05-19','15:55:00',3.74),('9650','2013-05-19','16:00:00',4.34),('9650','2013-05-19','16:05:00',7.4),('9650','2013-05-19','16:10:00',7.31),('9650','2013-05-19','16:15:00',6.34),('9650','2013-05-19','16:20:00',7.25),('9650','2013-05-19','16:25:00',7.18),('9650','2013-05-19','16:30:00',6.93),('9650','2013-05-19','16:35:00',6.78),('9650','2013-05-19','16:40:00',6.74),('9650','2013-05-19','16:45:00',6.38),('9650','2013-05-19','16:50:00',6.42),('9650','2013-05-19','16:55:00',6.28),('9650','2013-05-19','17:00:00',6.21),('9650','2013-05-19','17:05:00',6.17),('9650','2013-05-19','17:10:00',4.66),('9650','2013-05-19','17:15:00',3.02),('9650','2013-05-19','17:20:00',5.02),('9650','2013-05-19','17:25:00',6.19),('9650','2013-05-19','17:30:00',6.24),('9650','2013-05-19','17:35:00',5.49),('9650','2013-05-19','17:40:00',5.28),('9650','2013-05-19','17:45:00',5.11),('9650','2013-05-19','17:50:00',5.02),('9650','2013-05-19','17:55:00',4.96),('9650','2013-05-19','18:00:00',4.83),('9650','2013-05-19','18:05:00',4.65),('9650','2013-05-19','18:10:00',3.55),('9650','2013-05-19','18:15:00',4.58),('9650','2013-05-19','18:20:00',4.21),('9650','2013-05-19','18:25:00',4),('9650','2013-05-19','18:30:00',3.84),('9650','2013-05-19','18:35:00',3.72),('9650','2013-05-19','18:40:00',3.32),('9650','2013-05-19','18:45:00',3.37),('9650','2013-05-19','18:50:00',3.02),('9650','2013-05-19','18:55:00',3.02),('9650','2013-05-19','19:00:00',2.87),('9650','2013-05-19','19:05:00',2.72),('9650','2013-05-19','19:10:00',2.55),('9650','2013-05-19','19:15:00',2.31),('9650','2013-05-19','19:20:00',2.06),('9650','2013-05-19','19:25:00',1.8),('9650','2013-05-19','19:30:00',1.57),('9650','2013-05-19','19:35:00',1.11),('9650','2013-05-18','08:00:00',1.05),('9650','2013-05-18','08:10:00',1.17),('9650','2013-05-18','08:15:00',1.22),('9650','2013-05-18','08:20:00',1.16),('9650','2013-05-18','08:25:00',1.11),('9650','2013-05-18','08:30:00',1.59),('9650','2013-05-18','08:35:00',1.91),('9650','2013-05-18','08:40:00',1.66),('9650','2013-05-18','08:45:00',1.85),('9650','2013-05-18','08:50:00',2.1),('9650','2013-05-18','08:55:00',2.3),('9650','2013-05-18','09:00:00',2.21),('9650','2013-05-18','09:05:00',2.08),('9650','2013-05-18','09:10:00',2.33),('9650','2013-05-18','09:15:00',2.35),('9650','2013-05-18','09:20:00',1.73),('9650','2013-05-18','09:30:00',1.28),('9650','2013-05-18','09:35:00',1.55),('9650','2013-05-18','09:40:00',2.04),('9650','2013-05-18','09:45:00',2.23),('9650','2013-05-18','09:50:00',1.55),('9650','2013-05-18','09:55:00',1.97),('9650','2013-05-18','10:00:00',2.52),('9650','2013-05-18','10:05:00',2.8),('9650','2013-05-18','10:10:00',3.79),('9650','2013-05-18','10:15:00',4.88),('9650','2013-05-18','10:20:00',4.46),('9650','2013-05-18','10:25:00',3.81),('9650','2013-05-18','10:30:00',4.71),('9650','2013-05-18','10:35:00',4.88),('9650','2013-05-18','10:40:00',5.4),('9650','2013-05-18','10:45:00',5.84),('9650','2013-05-18','10:50:00',5.31),('9650','2013-05-18','10:55:00',6.76),('9650','2013-05-18','11:00:00',4.91),('9650','2013-05-18','11:05:00',3.68),('9650','2013-05-18','11:10:00',3.97),('9650','2013-05-18','11:15:00',6.63),('9650','2013-05-18','11:20:00',6.44),('9650','2013-05-18','11:25:00',6.57),('9650','2013-05-18','11:30:00',6.56),('9650','2013-05-18','11:35:00',6.56),('9650','2013-05-18','11:40:00',6.65),('9650','2013-05-18','11:45:00',6.72),('9650','2013-05-18','11:50:00',6.79),('9650','2013-05-18','11:55:00',6.97),('9650','2013-05-18','12:00:00',7.05),('9650','2013-05-18','12:05:00',7.02),('9650','2013-05-18','12:10:00',7.01),('9650','2013-05-18','12:15:00',7.2),('9650','2013-05-18','12:20:00',7.9),('9650','2013-05-18','12:25:00',6.26),('9650','2013-05-18','12:30:00',5.26),('9650','2013-05-18','12:35:00',5.75),('9650','2013-05-18','12:40:00',7.01),('9650','2013-05-18','12:45:00',6.86),('9650','2013-05-18','12:50:00',5.16),('9650','2013-05-18','12:55:00',4.39),('9650','2013-05-18','13:00:00',6.77),('9650','2013-05-18','13:05:00',7.47),('9650','2013-05-18','13:10:00',6.07),('9650','2013-05-18','13:15:00',5.77),('9650','2013-05-18','13:20:00',6.86),('9650','2013-05-18','13:25:00',6.92),('9650','2013-05-18','13:30:00',7.7),('9650','2013-05-18','13:35:00',7.63),('9650','2013-05-18','13:40:00',7.73),('9650','2013-05-18','13:45:00',7.77),('9650','2013-05-18','13:50:00',7.81),('9650','2013-05-18','13:55:00',7.75),('9650','2013-05-18','14:00:00',7.82),('9650','2013-05-18','14:05:00',7.78),('9650','2013-05-18','14:10:00',7.87),('9650','2013-05-18','14:15:00',7.88),('9650','2013-05-18','14:20:00',7.84),('9650','2013-05-18','14:25:00',7.91),('9650','2013-05-18','14:30:00',7.91),('9650','2013-05-18','14:35:00',7.92),('9650','2013-05-18','14:40:00',7.94),('9650','2013-05-18','14:45:00',7.93),('9650','2013-05-18','14:50:00',7.88),('9650','2013-05-18','14:55:00',7.9),('9650','2013-05-18','15:00:00',7.87),('9650','2013-05-18','15:05:00',7.86),('9650','2013-05-18','15:10:00',7.76),('9650','2013-05-18','15:15:00',7.74),('9650','2013-05-18','15:20:00',7.72),('9650','2013-05-18','15:25:00',7.73),('9650','2013-05-18','15:30:00',7.72),('9650','2013-05-18','15:35:00',7.64),('9650','2013-05-18','15:40:00',7.55),('9650','2013-05-18','15:45:00',7.48),('9650','2013-05-18','15:50:00',7.41),('9650','2013-05-18','15:55:00',7.4),('9650','2013-05-18','16:00:00',7.41),('9650','2013-05-18','16:05:00',7.32),('9650','2013-05-18','16:10:00',7.25),('9650','2013-05-18','16:15:00',7.18),('9650','2013-05-18','16:20:00',7.06),('9650','2013-05-18','16:25:00',7.05),('9650','2013-05-18','16:30:00',6.94),('9650','2013-05-18','16:35:00',6.91),('9650','2013-05-18','16:40:00',6.87),('9650','2013-05-18','16:45:00',6.8),('9650','2013-05-18','16:50:00',6.71),('9650','2013-05-18','16:55:00',6.64),('9650','2013-05-18','17:00:00',6.55),('9650','2013-05-18','17:05:00',6.43),('9650','2013-05-18','17:10:00',6.31),('9650','2013-05-18','17:15:00',6.21),('9650','2013-05-18','17:20:00',6.12),('9650','2013-05-18','17:25:00',6.03),('9650','2013-05-18','17:30:00',5.89),('9650','2013-05-18','17:35:00',5.77),('9650','2013-05-18','17:40:00',5.49),('9650','2013-05-18','17:45:00',5.53),('9650','2013-05-18','17:50:00',5.43),('9650','2013-05-18','17:55:00',5.27),('9650','2013-05-18','18:00:00',5.16),('9650','2013-05-18','18:05:00',5.04),('9650','2013-05-18','18:10:00',4.93),('9650','2013-05-18','18:15:00',4.79),('9650','2013-05-18','18:20:00',4.64),('9650','2013-05-18','18:25:00',4.5),('9650','2013-05-18','18:30:00',4.33),('9650','2013-05-18','18:35:00',4.17),('9650','2013-05-18','18:40:00',4.03),('9650','2013-05-18','18:45:00',3.84),('9650','2013-05-18','18:50:00',3.63),('9650','2013-05-18','18:55:00',3.48),('9650','2013-05-18','19:00:00',3.31),('9650','2013-05-18','19:05:00',3.1);
INSERT INTO `solarlogmod` VALUES ('9650','2013-05-18','19:10:00',2.91),('9650','2013-05-18','19:15:00',2.7),('9650','2013-05-18','19:20:00',2.46),('9650','2013-05-18','19:25:00',2.28),('9650','2013-05-18','19:30:00',2.04),('9650','2013-05-18','19:35:00',1.84),('9650','2013-05-18','19:40:00',1.6),('9650','2013-05-18','19:45:00',1.34),('9650','2013-05-18','19:50:00',1.08),('9650','2013-05-17','07:45:00',1.09),('9650','2013-05-17','07:50:00',1.24),('9650','2013-05-17','07:55:00',1.69),('9650','2013-05-17','08:00:00',1.96),('9650','2013-05-17','08:05:00',2.07),('9650','2013-05-17','08:10:00',1.65),('9650','2013-05-17','08:15:00',1.59),('9650','2013-05-17','08:20:00',1.9),('9650','2013-05-17','08:25:00',2.61),('9650','2013-05-17','08:30:00',2.33),('9650','2013-05-17','08:35:00',2.15),('9650','2013-05-17','08:40:00',2.23),('9650','2013-05-17','08:45:00',2.19),('9650','2013-05-17','08:50:00',2.28),('9650','2013-05-17','08:55:00',2.41),('9650','2013-05-17','09:00:00',2.55),('9650','2013-05-17','09:05:00',2.61),('9650','2013-05-17','09:10:00',2.83),('9650','2013-05-17','09:15:00',3),('9650','2013-05-17','09:20:00',3.12),('9650','2013-05-17','09:25:00',3.23),('9650','2013-05-17','09:30:00',3.39),('9650','2013-05-17','09:35:00',3.54),('9650','2013-05-17','09:40:00',3.68),('9650','2013-05-17','09:45:00',3.83),('9650','2013-05-17','09:50:00',3.96),('9650','2013-05-17','09:55:00',4.09),('9650','2013-05-17','10:00:00',4.2),('9650','2013-05-17','10:05:00',4.32),('9650','2013-05-17','10:10:00',4.44),('9650','2013-05-17','10:15:00',4.52),('9650','2013-05-17','10:20:00',4.63),('9650','2013-05-17','10:25:00',4.76),('9650','2013-05-17','10:30:00',4.88),('9650','2013-05-17','10:35:00',4.98),('9650','2013-05-17','10:40:00',5.07),('9650','2013-05-17','10:45:00',5.19),('9650','2013-05-17','10:50:00',5.33),('9650','2013-05-17','10:55:00',5.25),('9650','2013-05-17','11:00:00',5.8),('9650','2013-05-17','11:05:00',5.3),('9650','2013-05-17','11:10:00',4.85),('9650','2013-05-17','11:15:00',6.13),('9650','2013-05-17','11:20:00',5.96),('9650','2013-05-17','11:25:00',6.43),('9650','2013-05-17','11:30:00',6.21),('9650','2013-05-17','11:35:00',5.96),('9650','2013-05-17','11:40:00',6.24),('9650','2013-05-17','11:45:00',6.2),('9650','2013-05-17','11:50:00',6.06),('9650','2013-05-17','11:55:00',5.95),('9650','2013-05-17','12:00:00',6.14),('9650','2013-05-17','12:05:00',6.48),('9650','2013-05-17','12:10:00',6.5),('9650','2013-05-17','12:15:00',6.58),('9650','2013-05-17','12:20:00',6.65),('9650','2013-05-17','12:25:00',6.82),('9650','2013-05-17','12:30:00',5.51),('9650','2013-05-17','12:35:00',6.87),('9650','2013-05-17','12:40:00',6.89),('9650','2013-05-17','12:45:00',6.48),('9650','2013-05-17','12:50:00',6.91),('9650','2013-05-17','12:55:00',6.98),('9650','2013-05-17','13:00:00',6.96),('9650','2013-05-17','13:05:00',6.97),('9650','2013-05-17','13:10:00',4.54),('9650','2013-05-17','13:20:00',6.11),('9650','2013-05-17','13:25:00',7.05),('9650','2013-05-17','13:30:00',7.13),('9650','2013-05-17','13:35:00',6.47),('9650','2013-05-17','13:40:00',6.83),('9650','2013-05-17','13:45:00',7.49),('9650','2013-05-17','13:50:00',6.55),('9650','2013-05-17','13:55:00',5.86),('9650','2013-05-17','14:00:00',5.29),('9650','2013-05-17','14:05:00',5.69),('9650','2013-05-17','14:10:00',8.05),('9650','2013-05-17','14:15:00',7.81),('9650','2013-05-17','14:20:00',7.74),('9650','2013-05-17','14:25:00',7.61),('9650','2013-05-17','14:30:00',7.61),('9650','2013-05-17','14:35:00',7.45),('9650','2013-05-17','14:40:00',7.93),('9650','2013-05-17','14:45:00',7.33),('9650','2013-05-17','14:50:00',7.38),('9650','2013-05-17','14:55:00',6.51),('9650','2013-05-17','15:00:00',6.86),('9650','2013-05-17','15:05:00',6.82),('9650','2013-05-17','15:10:00',6.75),('9650','2013-05-17','15:15:00',6.74),('9650','2013-05-17','15:20:00',6.66),('9650','2013-05-17','15:25:00',6.59),('9650','2013-05-17','15:30:00',6.57),('9650','2013-05-17','15:35:00',6.56),('9650','2013-05-17','15:40:00',6.46),('9650','2013-05-17','15:45:00',6.32),('9650','2013-05-17','15:50:00',6.27),('9650','2013-05-17','15:55:00',6.22),('9650','2013-05-17','16:00:00',6.14),('9650','2013-05-17','16:05:00',6.09),('9650','2013-05-17','16:10:00',6.01),('9650','2013-05-17','16:15:00',5.9),('9650','2013-05-17','16:20:00',5.85),('9650','2013-05-17','16:25:00',5.82),('9650','2013-05-17','16:30:00',5.72),('9650','2013-05-17','16:35:00',5.66),('9650','2013-05-17','16:40:00',5.62),('9650','2013-05-17','16:45:00',5.52),('9650','2013-05-17','16:50:00',5.38),('9650','2013-05-17','16:55:00',5.32),('9650','2013-05-17','17:00:00',5.18),('9650','2013-05-17','17:05:00',5.09),('9650','2013-05-17','17:10:00',5.04),('9650','2013-05-17','17:15:00',4.92),('9650','2013-05-17','17:20:00',4.81),('9650','2013-05-17','17:25:00',4.66),('9650','2013-05-17','17:30:00',4.54),('9650','2013-05-17','17:35:00',4.41),('9650','2013-05-17','17:40:00',4.3),('9650','2013-05-17','17:45:00',4.21),('9650','2013-05-17','17:50:00',4.09),('9650','2013-05-17','17:55:00',3.96),('9650','2013-05-17','18:00:00',3.81),('9650','2013-05-17','18:05:00',3.6),('9650','2013-05-17','18:10:00',3.47),('9650','2013-05-17','18:15:00',3.3),('9650','2013-05-17','18:20:00',3.11),('9650','2013-05-17','18:25:00',2.93),('9650','2013-05-17','18:30:00',2.79),('9650','2013-05-17','18:35:00',2.61),('9650','2013-05-17','18:40:00',2.44),('9650','2013-05-17','18:45:00',2.26),('9650','2013-05-17','18:50:00',2.06),('9650','2013-05-17','18:55:00',1.89),('9650','2013-05-17','19:00:00',1.71),('9650','2013-05-17','19:05:00',1.54),('9650','2013-05-17','19:10:00',1.36),('9650','2013-05-17','19:15:00',1.17),('9650','2013-05-16','07:40:00',1.06),('9650','2013-05-16','07:45:00',1.1),('9650','2013-05-16','07:50:00',1.31),('9650','2013-05-16','07:55:00',1.39),('9650','2013-05-16','08:00:00',1.57),('9650','2013-05-16','08:05:00',1.61),('9650','2013-05-16','08:10:00',1.65),('9650','2013-05-16','08:15:00',2.25),('9650','2013-05-16','08:20:00',3.03),('9650','2013-05-16','08:25:00',2.72),('9650','2013-05-16','08:30:00',1.47),('9650','2013-05-16','09:05:00',1.1),('9650','2013-05-16','09:10:00',1.3),('9650','2013-05-16','09:15:00',1.18),('9650','2013-05-16','09:20:00',1.55),('9650','2013-05-16','09:25:00',1.84),('9650','2013-05-16','10:15:00',1.27),('9650','2013-05-16','10:20:00',1.77),('9650','2013-05-16','10:25:00',2.36),('9650','2013-05-16','10:30:00',2.89),('9650','2013-05-16','10:35:00',2.2),('9650','2013-05-16','10:40:00',2.42),('9650','2013-05-16','10:45:00',2.67),('9650','2013-05-16','10:50:00',4.63),('9650','2013-05-16','10:55:00',5.14),('9650','2013-05-16','11:00:00',3.82),('9650','2013-05-16','11:05:00',3.44),('9650','2013-05-16','11:10:00',2.55),('9650','2013-05-16','11:15:00',3.42),('9650','2013-05-16','11:20:00',3.37),('9650','2013-05-16','11:25:00',2.99),('9650','2013-05-16','11:30:00',2.72),('9650','2013-05-16','11:35:00',3.49),('9650','2013-05-16','11:40:00',2.68),('9650','2013-05-16','11:45:00',4.11),('9650','2013-05-16','11:50:00',7.44),('9650','2013-05-16','11:55:00',5.65),('9650','2013-05-16','12:00:00',5.49),('9650','2013-05-16','12:05:00',5.49),('9650','2013-05-16','12:10:00',5.36),('9650','2013-05-16','12:15:00',3.78),('9650','2013-05-16','12:20:00',5.19),('9650','2013-05-16','12:25:00',4.99),('9650','2013-05-16','12:30:00',4.77),('9650','2013-05-16','12:35:00',4.98),('9650','2013-05-16','12:40:00',6.91),('9650','2013-05-16','12:45:00',8.03),('9650','2013-05-16','12:50:00',7.87),('9650','2013-05-16','12:55:00',7.73),('9650','2013-05-16','13:00:00',6.95),('9650','2013-05-16','13:05:00',7.49),('9650','2013-05-16','13:10:00',6.39),('9650','2013-05-16','13:15:00',7.56),('9650','2013-05-16','13:20:00',7.77),('9650','2013-05-16','13:25:00',7.46),('9650','2013-05-16','13:30:00',5.68),('9650','2013-05-16','13:35:00',8.01),('9650','2013-05-16','13:40:00',6.89),('9650','2013-05-16','13:45:00',7.54),('9650','2013-05-16','13:50:00',7.48),('9650','2013-05-16','13:55:00',8.63),('9650','2013-05-16','14:00:00',5.75),('9650','2013-05-16','14:05:00',5.61),('9650','2013-05-16','14:10:00',7.12),('9650','2013-05-16','14:15:00',7.2),('9650','2013-05-16','14:20:00',7.9),('9650','2013-05-16','14:25:00',6.9),('9650','2013-05-16','14:30:00',7.66),('9650','2013-05-16','14:35:00',7.55),('9650','2013-05-16','14:40:00',5.74),('9650','2013-05-16','14:45:00',5.69),('9650','2013-05-16','14:50:00',8.39),('9650','2013-05-16','14:55:00',4.39),('9650','2013-05-16','15:00:00',7.49),('9650','2013-05-16','15:05:00',5.92),('9650','2013-05-16','15:10:00',2.68),('9650','2013-05-16','15:15:00',6.87),('9650','2013-05-16','15:20:00',4.89),('9650','2013-05-16','15:25:00',3.83),('9650','2013-05-16','15:30:00',3.48),('9650','2013-05-16','15:35:00',6.17),('9650','2013-05-16','15:40:00',6.87),('9650','2013-05-16','15:45:00',2.63),('9650','2013-05-16','15:50:00',5.82),('9650','2013-05-16','15:55:00',7.8),('9650','2013-05-16','16:00:00',8.08),('9650','2013-05-16','16:05:00',2.81),('9650','2013-05-16','16:10:00',5.86),('9650','2013-05-16','16:15:00',6.6),('9650','2013-05-16','16:20:00',5.85),('9650','2013-05-16','16:25:00',7.06),('9650','2013-05-16','16:30:00',7.46),('9650','2013-05-16','16:35:00',7.01),('9650','2013-05-16','16:40:00',7.06),('9650','2013-05-16','16:45:00',6.85),('9650','2013-05-16','16:50:00',6.49),('9650','2013-05-16','16:55:00',6.32),('9650','2013-05-16','17:00:00',6.26),('9650','2013-05-16','17:05:00',6.08),('9650','2013-05-16','17:10:00',6.02),('9650','2013-05-16','17:15:00',5.95),('9650','2013-05-16','17:20:00',5.86),('9650','2013-05-16','17:25:00',5.72),('9650','2013-05-16','17:30:00',5.64),('9650','2013-05-16','17:35:00',5.51),('9650','2013-05-16','17:40:00',5.4),('9650','2013-05-16','17:45:00',5.21),('9650','2013-05-16','17:50:00',5.17),('9650','2013-05-16','17:55:00',5.01),('9650','2013-05-16','18:00:00',4.88),('9650','2013-05-16','18:05:00',4.81),('9650','2013-05-16','18:10:00',4.61),('9650','2013-05-16','18:15:00',4.43),('9650','2013-05-16','18:20:00',4.29),('9650','2013-05-16','18:25:00',4.17),('9650','2013-05-16','18:30:00',4.02),('9650','2013-05-16','18:35:00',3.92),('9650','2013-05-16','18:40:00',3.69),('9650','2013-05-16','18:45:00',3.51),('9650','2013-05-16','18:50:00',3.32),('9650','2013-05-16','18:55:00',3.21),('9650','2013-05-15','09:15:00',1.51),('9650','2013-05-15','09:20:00',1.89),('9650','2013-05-15','09:25:00',2.5),('9650','2013-05-15','09:30:00',2.41),('9650','2013-05-15','09:35:00',2.59),('9650','2013-05-15','09:40:00',2.82),('9650','2013-05-15','09:45:00',3.23),('9650','2013-05-15','09:50:00',2.18),('9650','2013-05-15','09:55:00',2),('9650','2013-05-15','10:00:00',2.31),('9650','2013-05-15','10:05:00',2.13),('9650','2013-05-15','10:10:00',2.04),('9650','2013-05-15','10:15:00',2.6),('9650','2013-05-15','10:20:00',3.36),('9650','2013-05-15','10:25:00',3.06),('9650','2013-05-15','10:30:00',3.12),('9650','2013-05-15','10:35:00',2.37),('9650','2013-05-15','10:40:00',2.47),('9650','2013-05-15','10:45:00',2.22),('9650','2013-05-15','10:50:00',2.43),('9650','2013-05-15','10:55:00',2.72),('9650','2013-05-15','11:00:00',5.89),('9650','2013-05-15','11:05:00',5.11),('9650','2013-05-15','11:10:00',5.02),('9650','2013-05-15','11:15:00',3.77),('9650','2013-05-15','11:20:00',2.19),('9650','2013-05-15','11:25:00',2.34),('9650','2013-05-15','11:30:00',2.72),('9650','2013-05-15','11:35:00',4.08),('9650','2013-05-15','11:40:00',6.33),('9650','2013-05-15','11:45:00',5.6),('9650','2013-05-15','11:50:00',5.71),('9650','2013-05-15','11:55:00',4.3),('9650','2013-05-15','12:00:00',3.28),('9650','2013-05-15','12:05:00',2.99),('9650','2013-05-15','12:10:00',3),('9650','2013-05-15','12:15:00',3.91),('9650','2013-05-15','12:20:00',3.53),('9650','2013-05-15','12:25:00',3.7),('9650','2013-05-15','12:30:00',5.47),('9650','2013-05-15','12:35:00',5.94),('9650','2013-05-15','12:40:00',7.29),('9650','2013-05-15','12:45:00',5.54),('9650','2013-05-15','12:50:00',4.26),('9650','2013-05-15','12:55:00',6.68),('9650','2013-05-15','13:00:00',6.85),('9650','2013-05-15','13:05:00',6.75),('9650','2013-05-15','13:10:00',6.85),('9650','2013-05-15','13:15:00',5.91),('9650','2013-05-15','13:20:00',5.38),('9650','2013-05-15','13:25:00',7.04),('9650','2013-05-15','13:30:00',6.94),('9650','2013-05-15','13:35:00',6.91),('9650','2013-05-15','13:40:00',6.85),('9650','2013-05-15','13:45:00',6.87),('9650','2013-05-15','13:50:00',6.92),('9650','2013-05-15','13:55:00',6.98),('9650','2013-05-15','14:00:00',6.94),('9650','2013-05-15','14:05:00',6.99),('9650','2013-05-15','14:10:00',6.95),('9650','2013-05-15','14:15:00',6.92),('9650','2013-05-15','14:20:00',6.9),('9650','2013-05-15','14:25:00',6.79),('9650','2013-05-15','14:30:00',6.87),('9650','2013-05-15','14:35:00',6.76),('9650','2013-05-15','14:40:00',6.76),('9650','2013-05-15','14:45:00',6.76),('9650','2013-05-15','14:50:00',6.32),('9650','2013-05-15','14:55:00',5.73),('9650','2013-05-15','15:00:00',6.72),('9650','2013-05-15','15:05:00',6.67),('9650','2013-05-15','15:10:00',6.58),('9650','2013-05-15','15:15:00',6.01),('9650','2013-05-15','15:20:00',6.41),('9650','2013-05-15','15:25:00',6.5),('9650','2013-05-15','15:30:00',6.4),('9650','2013-05-15','15:35:00',6.15),('9650','2013-05-15','15:40:00',6.35),('9650','2013-05-15','15:45:00',6.17),('9650','2013-05-15','15:50:00',6.14),('9650','2013-05-15','15:55:00',6.13),('9650','2013-05-15','16:00:00',6.1),('9650','2013-05-15','16:05:00',5.78),('9650','2013-05-15','16:10:00',5.9),('9650','2013-05-15','16:15:00',5.42),('9650','2013-05-15','16:20:00',5.84),('9650','2013-05-15','16:25:00',5.63),('9650','2013-05-15','16:30:00',5.63),('9650','2013-05-15','16:35:00',5.35),('9650','2013-05-15','16:40:00',3.23),('9650','2013-05-15','16:45:00',2.74),('9650','2013-05-15','16:50:00',3.87),('9650','2013-05-15','16:55:00',3.47),('9650','2013-05-15','17:00:00',3.36),('9650','2013-05-15','17:05:00',1.52),('9650','2013-05-15','17:10:00',1.58),('9650','2013-05-15','17:15:00',2.67),('9650','2013-05-15','17:20:00',3.09),('9650','2013-05-15','17:25:00',3.15),('9650','2013-05-15','17:30:00',3.95),('9650','2013-05-15','17:35:00',3.78),('9650','2013-05-15','17:40:00',3.1),('9650','2013-05-15','17:45:00',2.1),('9650','2013-05-15','17:50:00',1.24),('9650','2013-05-15','18:20:00',1.08),('9650','2013-05-15','18:25:00',1.29),('9650','2013-05-15','18:30:00',1.61),('9650','2013-05-15','18:35:00',1.96),('9650','2013-05-15','18:40:00',2.18),('9650','2013-05-15','18:45:00',2.29),('9650','2013-05-15','18:50:00',2.25),('9650','2013-05-15','18:55:00',2.35),('9650','2013-05-15','19:00:00',2.36),('9650','2013-05-15','19:05:00',2.11),('9650','2013-05-15','19:10:00',1.71),('9650','2013-05-15','19:15:00',1.4),('9650','2013-05-15','19:20:00',1.15),('9650','2013-05-14','07:50:00',1.05),('9650','2013-05-14','07:55:00',1.04),('9650','2013-05-14','08:00:00',1.01),('9650','2013-05-14','08:10:00',1.1),('9650','2013-05-14','08:15:00',1.21),('9650','2013-05-14','08:20:00',1.29),('9650','2013-05-14','08:25:00',1.37),('9650','2013-05-14','08:30:00',1.49),('9650','2013-05-14','08:35:00',1.69),('9650','2013-05-14','08:40:00',1.85),('9650','2013-05-14','08:45:00',2.04),('9650','2013-05-14','08:50:00',2.21),('9650','2013-05-14','08:55:00',2.37),('9650','2013-05-14','09:00:00',2.35),('9650','2013-05-14','09:05:00',2.6),('9650','2013-05-14','09:10:00',2.68),('9650','2013-05-14','09:15:00',2.81),('9650','2013-05-14','09:20:00',2.85),('9650','2013-05-14','09:25:00',2.99),('9650','2013-05-14','09:30:00',3.26),('9650','2013-05-14','09:35:00',3.4),('9650','2013-05-14','09:40:00',3.48),('9650','2013-05-14','09:45:00',3.61),('9650','2013-05-14','09:50:00',3.76),('9650','2013-05-14','09:55:00',3.85),('9650','2013-05-14','10:00:00',4),('9650','2013-05-14','10:05:00',4.11),('9650','2013-05-14','10:10:00',4.23),('9650','2013-05-14','10:15:00',4.21),('9650','2013-05-14','10:20:00',4.38),('9650','2013-05-14','10:25:00',4.65),('9650','2013-05-14','10:30:00',4.6),('9650','2013-05-14','10:35:00',4.82),('9650','2013-05-14','10:40:00',5.01),('9650','2013-05-14','10:45:00',5.13),('9650','2013-05-14','10:50:00',5.18),('9650','2013-05-14','10:55:00',5.05),('9650','2013-05-14','11:00:00',5.11),('9650','2013-05-14','11:05:00',5.42),('9650','2013-05-14','11:10:00',5.53),('9650','2013-05-14','11:15:00',5.63),('9650','2013-05-14','11:20:00',5.43),('9650','2013-05-14','11:25:00',5.82),('9650','2013-05-14','11:30:00',5.78),('9650','2013-05-14','11:35:00',5.79),('9650','2013-05-14','11:40:00',4.71),('9650','2013-05-14','11:45:00',4.37),('9650','2013-05-14','11:50:00',3.63),('9650','2013-05-14','11:55:00',2.8),('9650','2013-05-14','12:00:00',3.2),('9650','2013-05-14','12:05:00',5.1),('9650','2013-05-14','12:10:00',7.22),('9650','2013-05-14','12:15:00',7.06),('9650','2013-05-14','12:20:00',4.61),('9650','2013-05-14','12:25:00',6.13),('9650','2013-05-14','12:30:00',4.82),('9650','2013-05-14','12:35:00',5.61),('9650','2013-05-14','12:40:00',7.91),('9650','2013-05-14','12:45:00',4.33),('9650','2013-05-14','12:50:00',4.33),('9650','2013-05-14','12:55:00',4.75),('9650','2013-05-14','13:00:00',4.79),('9650','2013-05-14','13:05:00',5.82),('9650','2013-05-14','13:10:00',4.95),('9650','2013-05-14','13:15:00',4.47),('9650','2013-05-14','13:20:00',4.83),('9650','2013-05-14','13:25:00',4.83),('9650','2013-05-14','13:30:00',4.89),('9650','2013-05-14','13:35:00',4.27),('9650','2013-05-14','13:40:00',4.72),('9650','2013-05-14','13:45:00',4.39),('9650','2013-05-14','13:50:00',3.75),('9650','2013-05-14','13:55:00',3.8),('9650','2013-05-14','14:00:00',3.35),('9650','2013-05-14','14:05:00',3.07),('9650','2013-05-14','14:10:00',3.2),('9650','2013-05-14','14:15:00',3.16),('9650','2013-05-14','14:20:00',3.32),('9650','2013-05-14','14:25:00',3.06),('9650','2013-05-14','14:30:00',2.68),('9650','2013-05-14','14:35:00',2.59),('9650','2013-05-14','14:40:00',2.86),('9650','2013-05-14','14:45:00',2.6),('9650','2013-05-14','14:50:00',2.55),('9650','2013-05-14','14:55:00',2.58),('9650','2013-05-14','15:00:00',2.56),('9650','2013-05-14','15:05:00',1.99),('9650','2013-05-14','15:10:00',1.55),('9650','2013-05-14','15:15:00',1.47),('9650','2013-05-14','15:20:00',1.4),('9650','2013-05-14','15:25:00',1.35),('9650','2013-05-14','15:30:00',1.47),('9650','2013-05-14','15:35:00',1.43),('9650','2013-05-14','15:40:00',1.52),('9650','2013-05-14','15:45:00',1.94),('9650','2013-05-14','15:50:00',2.72),('9650','2013-05-14','15:55:00',3.54),('9650','2013-05-14','16:00:00',3.44),('9650','2013-05-14','16:05:00',3.3),('9650','2013-05-14','16:10:00',3.01),('9650','2013-05-14','16:15:00',2.68),('9650','2013-05-14','16:20:00',2.91),('9650','2013-05-14','16:25:00',2.94),('9650','2013-05-14','16:30:00',2.58),('9650','2013-05-14','16:35:00',2.41),('9650','2013-05-14','16:40:00',2.27),('9650','2013-05-14','16:45:00',2.17),('9650','2013-05-14','16:50:00',2.22),('9650','2013-05-14','16:55:00',2.59),('9650','2013-05-14','17:00:00',3.18),('9650','2013-05-14','17:05:00',3.9),('9650','2013-05-14','17:10:00',5.15),('9650','2013-05-14','17:15:00',6.42),('9650','2013-05-14','17:20:00',4.13),('9650','2013-05-14','17:25:00',1.98),('9650','2013-05-14','17:30:00',2.09),('9650','2013-05-14','17:35:00',1.72),('9650','2013-05-14','17:40:00',1.48),('9650','2013-05-14','17:45:00',1.56),('9650','2013-05-14','17:50:00',1.57),('9650','2013-05-14','17:55:00',1.51),('9650','2013-05-14','18:00:00',1.36),('9650','2013-05-14','18:05:00',1.08),('9650','2013-05-13','08:10:00',1.03),('9650','2013-05-13','08:15:00',1.12),('9650','2013-05-13','08:20:00',1.24),('9650','2013-05-13','08:25:00',1.34),('9650','2013-05-13','08:30:00',1.59),('9650','2013-05-13','08:35:00',1.74),('9650','2013-05-13','08:40:00',1.87),('9650','2013-05-13','08:45:00',2.03),('9650','2013-05-13','08:50:00',2.19),('9650','2013-05-13','08:55:00',2.32),('9650','2013-05-13','09:00:00',2.46),('9650','2013-05-13','09:05:00',2.59),('9650','2013-05-13','09:10:00',2.77),('9650','2013-05-13','09:15:00',2.94),('9650','2013-05-13','09:20:00',3.06),('9650','2013-05-13','09:25:00',3.23),('9650','2013-05-13','09:30:00',3.4),('9650','2013-05-13','09:35:00',3.54),('9650','2013-05-13','09:40:00',3.7),('9650','2013-05-13','09:45:00',3.82),('9650','2013-05-13','09:50:00',3.93),('9650','2013-05-13','09:55:00',4.08),('9650','2013-05-13','10:00:00',4.22),('9650','2013-05-13','10:05:00',4.35),('9650','2013-05-13','10:10:00',4.49),('9650','2013-05-13','10:15:00',4.57),('9650','2013-05-13','10:20:00',4.69),('9650','2013-05-13','10:25:00',4.81),('9650','2013-05-13','10:30:00',4.91),('9650','2013-05-13','10:35:00',5.04),('9650','2013-05-13','10:40:00',5.16),('9650','2013-05-13','10:45:00',5.27),('9650','2013-05-13','10:50:00',5.36),('9650','2013-05-13','10:55:00',5.46),('9650','2013-05-13','11:00:00',5.57),('9650','2013-05-13','11:05:00',5.65),('9650','2013-05-13','11:10:00',5.74),('9650','2013-05-13','11:15:00',5.82),('9650','2013-05-13','11:20:00',5.91),('9650','2013-05-13','11:25:00',6),('9650','2013-05-13','11:30:00',6.07),('9650','2013-05-13','11:35:00',6.13),('9650','2013-05-13','11:40:00',6.2),('9650','2013-05-13','11:45:00',6.29),('9650','2013-05-13','11:50:00',6.37),('9650','2013-05-13','11:55:00',6.45),('9650','2013-05-13','12:00:00',6.49),('9650','2013-05-13','12:05:00',6.51),('9650','2013-05-13','12:10:00',6.57),('9650','2013-05-13','12:15:00',6.64),('9650','2013-05-13','12:20:00',6.73),('9650','2013-05-13','12:25:00',6.78),('9650','2013-05-13','12:30:00',6.84),('9650','2013-05-13','12:35:00',6.89),('9650','2013-05-13','12:40:00',6.97),('9650','2013-05-13','12:45:00',7),('9650','2013-05-13','12:50:00',7.05),('9650','2013-05-13','12:55:00',7.1),('9650','2013-05-13','13:00:00',7.2),('9650','2013-05-13','13:05:00',7.21),('9650','2013-05-13','13:10:00',7.23),('9650','2013-05-13','13:15:00',7.26),('9650','2013-05-13','13:20:00',7.25),('9650','2013-05-13','13:25:00',7.29),('9650','2013-05-13','13:30:00',7.29),('9650','2013-05-13','13:35:00',7.27),('9650','2013-05-13','13:40:00',7.33),('9650','2013-05-13','13:45:00',7.35),('9650','2013-05-13','13:50:00',7.34),('9650','2013-05-13','13:55:00',7.37),('9650','2013-05-13','14:00:00',7.34),('9650','2013-05-13','14:05:00',7.31),('9650','2013-05-13','14:10:00',7.34),('9650','2013-05-13','14:15:00',7.34),('9650','2013-05-13','14:20:00',7.34),('9650','2013-05-13','14:25:00',7.38),('9650','2013-05-13','14:30:00',7.35),('9650','2013-05-13','14:35:00',7.28),('9650','2013-05-13','14:40:00',7.32),('9650','2013-05-13','14:45:00',7.43),('9650','2013-05-13','14:50:00',7.46),('9650','2013-05-13','14:55:00',7.47),('9650','2013-05-13','15:00:00',7.47),('9650','2013-05-13','15:05:00',7.51),('9650','2013-05-13','15:10:00',7.49),('9650','2013-05-13','15:15:00',7.47),('9650','2013-05-13','15:20:00',7.44),('9650','2013-05-13','15:25:00',7.4),('9650','2013-05-13','15:30:00',7.38),('9650','2013-05-13','15:35:00',7.35),('9650','2013-05-13','15:40:00',7.28),('9650','2013-05-13','15:45:00',7.19),('9650','2013-05-13','15:50:00',7.18),('9650','2013-05-13','15:55:00',7.11),('9650','2013-05-13','16:00:00',7.05),('9650','2013-05-13','16:05:00',6.97),('9650','2013-05-13','16:10:00',6.92),('9650','2013-05-13','16:15:00',6.84),('9650','2013-05-13','16:20:00',6.79),('9650','2013-05-13','16:25:00',6.75),('9650','2013-05-13','16:30:00',6.66),('9650','2013-05-13','16:35:00',6.59),('9650','2013-05-13','16:40:00',6.52),('9650','2013-05-13','16:45:00',6.39),('9650','2013-05-13','16:50:00',6.29),('9650','2013-05-13','16:55:00',6.22),('9650','2013-05-13','17:00:00',6.13),('9650','2013-05-13','17:05:00',6.01),('9650','2013-05-13','17:10:00',5.88),('9650','2013-05-13','17:15:00',5.79),('9650','2013-05-13','17:20:00',5.67),('9650','2013-05-13','17:25:00',5.59),('9650','2013-05-13','17:30:00',5.45),('9650','2013-05-13','17:35:00',5.28),('9650','2013-05-13','17:40:00',5.15),('9650','2013-05-13','17:45:00',5.03),('9650','2013-05-13','17:50:00',4.92),('9650','2013-05-13','17:55:00',4.8),('9650','2013-05-13','18:00:00',4.65),('9650','2013-05-13','18:05:00',4.51),('9650','2013-05-13','18:10:00',4.39),('9650','2013-05-13','18:15:00',4.24),('9650','2013-05-13','18:20:00',4.01),('9650','2013-05-13','18:25:00',3.95),('9650','2013-05-13','18:30:00',3.77),('9650','2013-05-13','18:35:00',3.67),('9650','2013-05-13','18:40:00',3.47),('9650','2013-05-13','18:45:00',3.32),('9650','2013-05-13','18:50:00',3.13),('9650','2013-05-13','18:55:00',2.97),('9650','2013-05-13','19:00:00',2.67),('9650','2013-05-13','19:05:00',2.6),('9650','2013-05-13','19:10:00',2.37),('9650','2013-05-13','19:15:00',2.12),('9650','2013-05-13','19:20:00',1.98),('9650','2013-05-13','19:25:00',1.7),('9650','2013-05-13','19:30:00',1.57),('9650','2013-05-13','19:35:00',1.29),('9650','2013-05-12','08:00:00',1.05),('9650','2013-05-12','08:05:00',1.07),('9650','2013-05-12','08:10:00',1.17),('9650','2013-05-12','08:15:00',1.24),('9650','2013-05-12','08:20:00',1.27),('9650','2013-05-12','08:25:00',1.3),('9650','2013-05-12','08:30:00',1.32),('9650','2013-05-12','08:35:00',1.5),('9650','2013-05-12','08:40:00',1.79),('9650','2013-05-12','08:45:00',1.97),('9650','2013-05-12','08:50:00',2.14),('9650','2013-05-12','08:55:00',2.26),('9650','2013-05-12','09:00:00',2.38),('9650','2013-05-12','09:05:00',2.53),('9650','2013-05-12','09:10:00',2.66),('9650','2013-05-12','09:15:00',2.8),('9650','2013-05-12','09:20:00',2.94),('9650','2013-05-12','09:25:00',3.1),('9650','2013-05-12','09:30:00',3.26),('9650','2013-05-12','09:35:00',3.4),('9650','2013-05-12','09:40:00',3.6),('9650','2013-05-12','09:45:00',3.82),('9650','2013-05-12','09:50:00',3.62),('9650','2013-05-12','09:55:00',4.31),('9650','2013-05-12','10:00:00',4.41),('9650','2013-05-12','10:05:00',4.57),('9650','2013-05-12','10:10:00',4.49),('9650','2013-05-12','10:15:00',4.7),('9650','2013-05-12','10:20:00',4.95),('9650','2013-05-12','10:25:00',5.07),('9650','2013-05-12','10:30:00',4.52),('9650','2013-05-12','10:35:00',1.86),('9650','2013-05-12','10:40:00',1.65),('9650','2013-05-12','10:45:00',1.56),('9650','2013-05-12','10:50:00',4.29),('9650','2013-05-12','10:55:00',3.9),('9650','2013-05-12','11:00:00',4.53),('9650','2013-05-12','11:05:00',5.44),('9650','2013-05-12','11:10:00',4.76),('9650','2013-05-12','11:15:00',2.75),('9650','2013-05-12','11:20:00',2.56),('9650','2013-05-12','11:25:00',2.84),('9650','2013-05-12','11:30:00',2.89),('9650','2013-05-12','11:35:00',4.02),('9650','2013-05-12','11:40:00',5.5),('9650','2013-05-12','11:45:00',4.16),('9650','2013-05-12','11:50:00',3.34),('9650','2013-05-12','11:55:00',3.07),('9650','2013-05-12','12:00:00',3.2),('9650','2013-05-12','12:05:00',3.18),('9650','2013-05-12','12:10:00',6.16),('9650','2013-05-12','12:15:00',3.91),('9650','2013-05-12','12:20:00',2.01),('9650','2013-05-12','12:25:00',1.94),('9650','2013-05-12','12:30:00',2.3),('9650','2013-05-12','12:35:00',8.39),('9650','2013-05-12','12:40:00',7.94),('9650','2013-05-12','12:45:00',5.48),('9650','2013-05-12','12:50:00',5.86),('9650','2013-05-12','12:55:00',4.41),('9650','2013-05-12','13:00:00',7.25),('9650','2013-05-12','13:05:00',7.78),('9650','2013-05-12','13:10:00',6.73),('9650','2013-05-12','13:15:00',5.5),('9650','2013-05-12','13:20:00',8.25),('9650','2013-05-12','13:25:00',8.04),('9650','2013-05-12','13:30:00',7.86),('9650','2013-05-12','13:35:00',8.37),('9650','2013-05-12','13:40:00',8.31),('9650','2013-05-12','13:45:00',6.22),('9650','2013-05-12','13:50:00',2.92),('9650','2013-05-12','13:55:00',3.45),('9650','2013-05-12','14:00:00',2.06),('9650','2013-05-12','14:05:00',6.56),('9650','2013-05-12','14:10:00',8.62),('9650','2013-05-12','14:15:00',8.39),('9650','2013-05-12','14:20:00',8.06),('9650','2013-05-12','14:25:00',8.03),('9650','2013-05-12','14:30:00',7.03),('9650','2013-05-12','14:35:00',3.15),('9650','2013-05-12','14:40:00',6.09),('9650','2013-05-12','14:45:00',4.3),('9650','2013-05-12','14:50:00',5.34),('9650','2013-05-12','14:55:00',8.62),('9650','2013-05-12','15:00:00',6.78),('9650','2013-05-12','15:05:00',5.11),('9650','2013-05-12','15:10:00',2.25),('9650','2013-05-12','15:15:00',1.84),('9650','2013-05-12','15:20:00',1.94),('9650','2013-05-12','15:25:00',1.46),('9650','2013-05-12','15:30:00',1.44),('9650','2013-05-12','15:35:00',1.36),('9650','2013-05-12','15:40:00',2.44),('9650','2013-05-12','15:45:00',1.48),('9650','2013-05-12','15:50:00',1.34),('9650','2013-05-12','15:55:00',1.19),('9650','2013-05-12','16:00:00',2.33),('9650','2013-05-12','16:05:00',3.7),('9650','2013-05-12','16:10:00',4.05),('9650','2013-05-12','16:15:00',2.43),('9650','2013-05-12','16:20:00',2.43),('9650','2013-05-12','16:25:00',2.49),('9650','2013-05-12','16:30:00',4.58),('9650','2013-05-12','16:35:00',2.26),('9650','2013-05-12','16:40:00',2.85),('9650','2013-05-12','16:45:00',4.98),('9650','2013-05-12','16:50:00',6.35),('9650','2013-05-12','16:55:00',6.74),('9650','2013-05-12','17:00:00',6.51),('9650','2013-05-12','17:05:00',6.52),('9650','2013-05-12','17:10:00',2.83),('9650','2013-05-12','17:15:00',6.02),('9650','2013-05-12','17:20:00',7.2),('9650','2013-05-12','17:25:00',6.86),('9650','2013-05-12','17:30:00',6.62),('9650','2013-05-12','17:35:00',6.23),('9650','2013-05-12','17:40:00',5.89),('9650','2013-05-12','17:45:00',5.7),('9650','2013-05-12','17:50:00',4.73),('9650','2013-05-12','17:55:00',2.96),('9650','2013-05-12','18:00:00',4.03),('9650','2013-05-12','18:05:00',2.24),('9650','2013-05-12','18:10:00',3.32),('9650','2013-05-12','18:15:00',3.69),('9650','2013-05-12','18:20:00',2.37),('9650','2013-05-11','08:00:00',1.1),('9650','2013-05-11','08:05:00',1.36),('9650','2013-05-11','08:10:00',1.7),('9650','2013-05-11','08:15:00',2.09),('9650','2013-05-11','08:20:00',2.01),('9650','2013-05-11','08:25:00',1.94),('9650','2013-05-11','08:30:00',1.54),('9650','2013-05-11','08:35:00',1.38),('9650','2013-05-11','08:40:00',1.48),('9650','2013-05-11','08:45:00',2.35),('9650','2013-05-11','08:50:00',1.95),('9650','2013-05-11','08:55:00',1.73),('9650','2013-05-11','09:00:00',1.93),('9650','2013-05-11','09:05:00',2.43),('9650','2013-05-11','09:10:00',2.05),('9650','2013-05-11','09:15:00',2.5),('9650','2013-05-11','09:20:00',3.76),('9650','2013-05-11','09:25:00',2.59),('9650','2013-05-11','09:30:00',1.96),('9650','2013-05-11','09:35:00',1.93),('9650','2013-05-11','09:40:00',1.85),('9650','2013-05-11','09:45:00',3.99),('9650','2013-05-11','09:50:00',4.8),('9650','2013-05-11','09:55:00',4.1),('9650','2013-05-11','10:00:00',4.69),('9650','2013-05-11','10:05:00',4.53),('9650','2013-05-11','10:10:00',4.38),('9650','2013-05-11','10:15:00',1.63),('9650','2013-05-11','10:20:00',1.68),('9650','2013-05-11','10:25:00',4.24),('9650','2013-05-11','10:30:00',2.12),('9650','2013-05-11','10:35:00',1.96),('9650','2013-05-11','10:40:00',2.44),('9650','2013-05-11','10:45:00',1.78),('9650','2013-05-11','10:50:00',4.07),('9650','2013-05-11','10:55:00',5.62),('9650','2013-05-11','11:00:00',5.55),('9650','2013-05-11','11:05:00',5.86),('9650','2013-05-11','11:10:00',6.48),('9650','2013-05-11','11:15:00',6.62),('9650','2013-05-11','11:20:00',6.61),('9650','2013-05-11','11:25:00',6.75),('9650','2013-05-11','11:30:00',6.74),('9650','2013-05-11','11:35:00',6.18),('9650','2013-05-11','11:40:00',5.68),('9650','2013-05-11','11:45:00',6.09),('9650','2013-05-11','11:50:00',3.28),('9650','2013-05-11','11:55:00',2.57),('9650','2013-05-11','12:00:00',4.33),('9650','2013-05-11','12:05:00',4.69),('9650','2013-05-11','12:10:00',3.64),('9650','2013-05-11','12:15:00',2.2),('9650','2013-05-11','12:20:00',1.97),('9650','2013-05-11','12:25:00',2.02),('9650','2013-05-11','12:30:00',4),('9650','2013-05-11','12:35:00',3.36),('9650','2013-05-11','12:40:00',4.76),('9650','2013-05-11','12:45:00',7.09),('9650','2013-05-11','12:50:00',6),('9650','2013-05-11','12:55:00',4.92),('9650','2013-05-11','13:00:00',2.35),('9650','2013-05-11','13:05:00',2.77),('9650','2013-05-11','13:10:00',7.1),('9650','2013-05-11','13:15:00',2.46),('9650','2013-05-11','13:20:00',5.61),('9650','2013-05-11','13:25:00',4.99),('9650','2013-05-11','13:30:00',7.64),('9650','2013-05-11','13:35:00',7.52),('9650','2013-05-11','13:40:00',5.76),('9650','2013-05-11','13:45:00',7.13),('9650','2013-05-11','13:50:00',6.93),('9650','2013-05-11','13:55:00',3.94),('9650','2013-05-11','14:00:00',4.87),('9650','2013-05-11','14:05:00',8),('9650','2013-05-11','14:10:00',8.87),('9650','2013-05-11','14:15:00',6.79),('9650','2013-05-11','14:20:00',8.29),('9650','2013-05-11','14:25:00',7.86),('9650','2013-05-11','14:30:00',7.94),('9650','2013-05-11','14:35:00',7.94),('9650','2013-05-11','14:40:00',7.84),('9650','2013-05-11','14:45:00',7.81),('9650','2013-05-11','14:50:00',7.98),('9650','2013-05-11','14:55:00',6.96),('9650','2013-05-11','15:00:00',7.7),('9650','2013-05-11','15:05:00',7.96),('9650','2013-05-11','15:10:00',7),('9650','2013-05-11','15:15:00',8.15),('9650','2013-05-11','15:20:00',4.05),('9650','2013-05-11','15:25:00',7.61),('9650','2013-05-11','15:30:00',7.39),('9650','2013-05-11','15:35:00',7.35),('9650','2013-05-11','15:40:00',7.28),('9650','2013-05-11','15:45:00',7.25),('9650','2013-05-11','15:50:00',7.08),('9650','2013-05-11','15:55:00',6.96),('9650','2013-05-11','16:00:00',6.88),('9650','2013-05-11','16:05:00',6.62),('9650','2013-05-11','16:10:00',6.78),('9650','2013-05-11','16:15:00',6.7),('9650','2013-05-11','16:20:00',6.73),('9650','2013-05-11','16:25:00',6.58),('9650','2013-05-11','16:30:00',6.59),('9650','2013-05-11','16:35:00',6.6),('9650','2013-05-11','16:40:00',6.77),('9650','2013-05-11','16:45:00',6.84),('9650','2013-05-11','16:50:00',6.23),('9650','2013-05-11','16:55:00',7.62),('9650','2013-05-11','17:00:00',7.44),('9650','2013-05-11','17:05:00',5.91),('9650','2013-05-11','17:10:00',7.28),('9650','2013-05-11','17:15:00',6.51),('9650','2013-05-11','17:20:00',6.64),('9650','2013-05-11','17:25:00',5.32),('9650','2013-05-11','17:30:00',4.38),('9650','2013-05-11','17:35:00',5.54),('9650','2013-05-11','17:40:00',3.95),('9650','2013-05-11','17:45:00',3.36),('9650','2013-05-11','17:50:00',3),('9650','2013-05-11','17:55:00',1.87),('9650','2013-05-11','18:00:00',3.82),('9650','2013-05-11','18:05:00',4.21),('9650','2013-05-11','18:10:00',4.4),('9650','2013-05-11','18:15:00',3.37),('9650','2013-05-11','18:20:00',2.02),('9650','2013-05-11','18:25:00',3.13),('9650','2013-05-11','18:30:00',2.47),('9650','2013-05-11','18:35:00',2.98),('9650','2013-05-11','18:40:00',1.87),('9650','2013-05-11','18:45:00',1.32),('9650','2013-05-11','18:50:00',1.33),('9650','2013-05-11','18:55:00',1.43),('9650','2013-05-11','19:00:00',2.12),('9650','2013-05-11','19:05:00',1.27),('9650','2013-05-11','19:10:00',1.78),('9650','2013-05-11','19:15:00',1.37),('9650','2013-05-11','19:20:00',1.06),('9650','2014-03-30','09:10:00',1.03),('9650','2014-03-30','09:15:00',1.15),('9650','2014-03-30','09:20:00',1.25),('9650','2014-03-30','09:25:00',1.38),('9650','2014-03-30','09:30:00',1.5),('9650','2014-03-30','09:35:00',1.63),('9650','2014-03-30','09:40:00',1.76),('9650','2014-03-30','09:45:00',1.9),('9650','2014-03-30','09:50:00',2.03),('9650','2014-03-30','09:55:00',2.15),('9650','2014-03-30','10:00:00',2.3),('9650','2014-03-30','10:05:00',2.45),('9650','2014-03-30','10:10:00',2.58),('9650','2014-03-30','10:15:00',2.68),('9650','2014-03-30','10:20:00',2.82),('9650','2014-03-30','10:25:00',2.96),('9650','2014-03-30','10:30:00',3.1),('9650','2014-03-30','10:35:00',3.22),('9650','2014-03-30','10:40:00',3.33),('9650','2014-03-30','10:45:00',3.47),('9650','2014-03-30','10:50:00',3.59),('9650','2014-03-30','10:55:00',3.7),('9650','2014-03-30','11:00:00',3.81),('9650','2014-03-30','11:05:00',3.92),('9650','2014-03-30','11:10:00',4.05),('9650','2014-03-30','11:15:00',4.14),('9650','2014-03-30','11:20:00',4.25),('9650','2014-03-30','11:25:00',4.34),('9650','2014-03-30','11:30:00',4.43),('9650','2014-03-30','11:35:00',4.55),('9650','2014-03-30','11:40:00',4.6),('9650','2014-03-30','11:45:00',4.73),('9650','2014-03-30','11:50:00',4.85),('9650','2014-03-30','11:55:00',4.97),('9650','2014-03-30','12:00:00',5.03),('9650','2014-03-30','12:05:00',5.06),('9650','2014-03-30','12:10:00',5.17),('9650','2014-03-30','12:15:00',5.27),('9650','2014-03-30','12:20:00',5.33),('9650','2014-03-30','12:25:00',5.38),('9650','2014-03-30','12:30:00',5.48),('9650','2014-03-30','12:35:00',5.59),('9650','2014-03-30','12:40:00',5.64),('9650','2014-03-30','12:45:00',5.64),('9650','2014-03-30','12:50:00',5.69),('9650','2014-03-30','12:55:00',5.71),('9650','2014-03-30','13:00:00',5.81),('9650','2014-03-30','13:05:00',5.91),('9650','2014-03-30','13:10:00',5.96),('9650','2014-03-30','13:15:00',6.02),('9650','2014-03-30','13:20:00',6.05),('9650','2014-03-30','13:25:00',6.06),('9650','2014-03-30','13:30:00',6.13),('9650','2014-03-30','13:35:00',6.17),('9650','2014-03-30','13:40:00',6.24),('9650','2014-03-30','13:45:00',6.29),('9650','2014-03-30','13:50:00',6.31),('9650','2014-03-30','13:55:00',6.32),('9650','2014-03-30','14:00:00',6.34),('9650','2014-03-30','14:05:00',6.35),('9650','2014-03-30','14:10:00',6.35),('9650','2014-03-30','14:15:00',6.37),('9650','2014-03-30','14:20:00',6.38),('9650','2014-03-30','14:25:00',6.41),('9650','2014-03-30','14:30:00',6.4),('9650','2014-03-30','14:35:00',6.39),('9650','2014-03-30','14:40:00',6.42),('9650','2014-03-30','14:45:00',6.43),('9650','2014-03-30','14:50:00',6.38),('9650','2014-03-30','14:55:00',6.37),('9650','2014-03-30','15:00:00',6.38),('9650','2014-03-30','15:05:00',6.24),('9650','2014-03-30','15:10:00',6.16),('9650','2014-03-30','15:15:00',6.07),('9650','2014-03-30','15:20:00',6.03),('9650','2014-03-30','15:25:00',5.99),('9650','2014-03-30','15:30:00',5.87),('9650','2014-03-30','15:35:00',5.83),('9650','2014-03-30','15:40:00',5.8),('9650','2014-03-30','15:45:00',5.75),('9650','2014-03-30','15:50:00',5.61),('9650','2014-03-30','15:55:00',5.46),('9650','2014-03-30','16:00:00',5.3),('9650','2014-03-30','16:05:00',5.21),('9650','2014-03-30','16:10:00',5.1),('9650','2014-03-30','16:15:00',5),('9650','2014-03-30','16:20:00',4.93),('9650','2014-03-30','16:25:00',4.82),('9650','2014-03-30','16:30:00',4.77),('9650','2014-03-30','16:35:00',4.65),('9650','2014-03-30','16:40:00',4.55),('9650','2014-03-30','16:45:00',4.43),('9650','2014-03-30','16:50:00',4.29),('9650','2014-03-30','16:55:00',4.3),('9650','2014-03-30','17:00:00',4.18),('9650','2014-03-30','17:05:00',4.07),('9650','2014-03-30','17:10:00',3.95),('9650','2014-03-30','17:15:00',3.82),('9650','2014-03-30','17:20:00',3.62),('9650','2014-03-30','17:25:00',3.52),('9650','2014-03-30','17:30:00',3.5),('9650','2014-03-30','17:35:00',3.46),('9650','2014-03-30','17:40:00',3.29),('9650','2014-03-30','17:45:00',3.22),('9650','2014-03-30','17:50:00',3.11),('9650','2014-03-30','17:55:00',2.94),('9650','2014-03-30','18:00:00',2.77),('9650','2014-03-30','18:05:00',2.58),('9650','2014-03-30','18:10:00',2.46),('9650','2014-03-30','18:15:00',2.39),('9650','2014-03-30','18:20:00',2.21),('9650','2014-03-30','18:25:00',2.02),('9650','2014-03-30','18:30:00',1.82),('9650','2014-03-30','18:35:00',1.71),('9650','2014-03-30','18:40:00',1.66),('9650','2014-03-30','18:45:00',1.44),('9650','2014-03-30','18:50:00',1.16),('9650','2013-05-10','07:50:00',1.07),('9650','2013-05-10','07:55:00',1.23),('9650','2013-05-10','08:00:00',1.21),('9650','2013-05-10','08:05:00',1.39),('9650','2013-05-10','08:10:00',1.34),('9650','2013-05-10','08:15:00',1.81),('9650','2013-05-10','08:20:00',1.81),('9650','2013-05-10','08:25:00',1.32),('9650','2013-05-10','08:30:00',1.3),('9650','2013-05-10','08:35:00',1.37),('9650','2013-05-10','08:40:00',1.03),('9650','2013-05-10','08:45:00',1),('9650','2013-05-10','08:50:00',1.2),('9650','2013-05-10','08:55:00',1.23),('9650','2013-05-10','09:00:00',1.34),('9650','2013-05-10','09:05:00',2.03),('9650','2013-05-10','09:10:00',1.98),('9650','2013-05-10','09:15:00',2.24),('9650','2013-05-10','09:20:00',2.53),('9650','2013-05-10','09:25:00',2.8),('9650','2013-05-10','09:30:00',3.48),('9650','2013-05-10','09:35:00',3.22),('9650','2013-05-10','09:40:00',2.14),('9650','2013-05-10','09:45:00',2.37),('9650','2013-05-10','09:50:00',2.34),('9650','2013-05-10','09:55:00',2.91),('9650','2013-05-10','10:00:00',3.85),('9650','2013-05-10','10:05:00',2.29),('9650','2013-05-10','10:10:00',1.48),('9650','2013-05-10','10:15:00',1.42),('9650','2013-05-10','10:20:00',2),('9650','2013-05-10','10:25:00',1.8),('9650','2013-05-10','10:30:00',2.3),('9650','2013-05-10','10:35:00',2.14),('9650','2013-05-10','10:40:00',1.7),('9650','2013-05-10','10:45:00',1.6),('9650','2013-05-10','10:50:00',2.15),('9650','2013-05-10','10:55:00',5.27),('9650','2013-05-10','11:00:00',6.47),('9650','2013-05-10','11:05:00',3.23),('9650','2013-05-10','11:10:00',2.15),('9650','2013-05-10','11:15:00',1.78),('9650','2013-05-10','11:20:00',1.62),('9650','2013-05-10','11:25:00',1.93),('9650','2013-05-10','11:30:00',3.69),('9650','2013-05-10','11:35:00',4.44),('9650','2013-05-10','11:40:00',3.62),('9650','2013-05-10','11:45:00',7.76),('9650','2013-05-10','11:50:00',2.94),('9650','2013-05-10','11:55:00',1.82),('9650','2013-05-10','12:00:00',2.8),('9650','2013-05-10','12:05:00',3.6),('9650','2013-05-10','12:10:00',2.52),('9650','2013-05-10','12:15:00',2.38),('9650','2013-05-10','12:20:00',4.38),('9650','2013-05-10','12:25:00',7.72),('9650','2013-05-10','12:30:00',4.21),('9650','2013-05-10','12:35:00',3.11),('9650','2013-05-10','12:40:00',3.13),('9650','2013-05-10','12:45:00',3.59),('9650','2013-05-10','12:50:00',2.77),('9650','2013-05-10','12:55:00',2.66),('9650','2013-05-10','13:00:00',2.75),('9650','2013-05-10','13:05:00',2.5),('9650','2013-05-10','13:10:00',1.82),('9650','2013-05-10','13:15:00',1.13),('9650','2013-05-10','13:20:00',1.25),('9650','2013-05-10','13:25:00',1.65),('9650','2013-05-10','13:30:00',1.96),('9650','2013-05-10','13:35:00',2.12),('9650','2013-05-10','13:40:00',1.39),('9650','2013-05-10','13:45:00',1.02),('9650','2013-05-10','13:50:00',1.81),('9650','2013-05-10','13:55:00',1.98),('9650','2013-05-10','14:00:00',3.38),('9650','2013-05-10','14:05:00',6.3),('9650','2013-05-10','14:10:00',5.07),('9650','2013-05-10','14:15:00',5.8),('9650','2013-05-10','14:20:00',8.09),('9650','2013-05-10','14:25:00',7.42),('9650','2013-05-10','14:30:00',3.96),('9650','2013-05-10','14:35:00',5.57),('9650','2013-05-10','14:40:00',5.7),('9650','2013-05-10','14:45:00',7.6),('9650','2013-05-10','14:50:00',8.51),('9650','2013-05-10','14:55:00',7.97),('9650','2013-05-10','15:00:00',7.58),('9650','2013-05-10','15:05:00',7.74),('9650','2013-05-10','15:10:00',7.67),('9650','2013-05-10','15:15:00',7.9),('9650','2013-05-10','15:20:00',7.67),('9650','2013-05-10','15:25:00',7.71),('9650','2013-05-10','15:30:00',7.71),('9650','2013-05-10','15:35:00',6.87),('9650','2013-05-10','15:40:00',7.72),('9650','2013-05-10','15:45:00',7.22),('9650','2013-05-10','15:50:00',6.63),('9650','2013-05-10','15:55:00',6.65),('9650','2013-05-10','16:00:00',5.76),('9650','2013-05-10','16:05:00',7.21),('9650','2013-05-10','16:10:00',5.92),('9650','2013-05-10','16:15:00',6.41),('9650','2013-05-10','16:20:00',7.1),('9650','2013-05-10','16:25:00',6.97),('9650','2013-05-10','16:30:00',6.38),('9650','2013-05-10','16:35:00',4.63),('9650','2013-05-10','16:40:00',6.18),('9650','2013-05-10','16:45:00',6.6),('9650','2013-05-10','16:50:00',6.42),('9650','2013-05-10','16:55:00',6.53),('9650','2013-05-10','17:00:00',6.39),('9650','2013-05-10','17:05:00',4.7),('9650','2013-05-10','17:10:00',5.96),('9650','2013-05-10','17:15:00',3.76),('9650','2013-05-10','17:20:00',5.12),('9650','2013-05-10','17:25:00',3.86),('9650','2013-05-10','17:30:00',5.33),('9650','2013-05-10','17:35:00',4.56),('9650','2013-05-10','17:40:00',4.77),('9650','2013-05-10','17:45:00',4.8),('9650','2013-05-10','17:50:00',2.49),('9650','2013-05-10','17:55:00',3.89),('9650','2013-05-10','18:00:00',2.23),('9650','2013-05-10','18:05:00',4.25),('9650','2013-05-10','18:10:00',5.26),('9650','2013-05-10','18:15:00',3.16),('9650','2013-05-10','18:20:00',2.7),('9650','2013-05-10','18:25:00',3.16),('9650','2013-05-10','18:30:00',3.52),('9650','2013-05-10','18:35:00',2.77),('9650','2013-05-10','18:40:00',3.21),('9650','2013-05-10','18:45:00',3.11),('9650','2013-05-10','18:50:00',3.05),('9650','2013-05-10','18:55:00',3.17),('9650','2013-05-10','19:00:00',2.59),('9650','2013-05-10','19:10:00',1.57),('9650','2013-05-09','07:40:00',1.03),('9650','2013-05-09','07:45:00',1.16),('9650','2013-05-09','07:50:00',1.28),('9650','2013-05-09','07:55:00',1.65),('9650','2013-05-09','08:00:00',1.75),('9650','2013-05-09','08:05:00',2.1),('9650','2013-05-09','08:10:00',2.2),('9650','2013-05-09','08:15:00',2.35),('9650','2013-05-09','08:20:00',2.19),('9650','2013-05-09','08:25:00',2.08),('9650','2013-05-09','08:30:00',1.98),('9650','2013-05-09','08:35:00',1.92),('9650','2013-05-09','09:00:00',1.5),('9650','2013-05-09','09:05:00',2.34),('9650','2013-05-09','09:10:00',2.74),('9650','2013-05-09','09:15:00',2.97),('9650','2013-05-09','09:20:00',2.84),('9650','2013-05-09','09:25:00',2.79),('9650','2013-05-09','09:30:00',2.76),('9650','2013-05-09','09:35:00',3.51),('9650','2013-05-09','09:40:00',3.22),('9650','2013-05-09','09:45:00',3.36),('9650','2013-05-09','09:50:00',2.96),('9650','2013-05-09','09:55:00',2.23),('9650','2013-05-09','10:00:00',2.38),('9650','2013-05-09','10:05:00',2.53),('9650','2013-05-09','10:10:00',2.67),('9650','2013-05-09','10:15:00',1.58),('9650','2013-05-09','10:20:00',3.11),('9650','2013-05-09','10:25:00',1.85),('9650','2013-05-09','10:30:00',2.03),('9650','2013-05-09','10:35:00',3.6),('9650','2013-05-09','10:40:00',5.52),('9650','2013-05-09','10:45:00',5.93),('9650','2013-05-09','10:50:00',4.73),('9650','2013-05-09','10:55:00',5.73),('9650','2013-05-09','11:00:00',5.71),('9650','2013-05-09','11:05:00',5.81),('9650','2013-05-09','11:10:00',5.79),('9650','2013-05-09','11:15:00',5.74),('9650','2013-05-09','11:20:00',6.6),('9650','2013-05-09','11:25:00',5.37),('9650','2013-05-09','11:30:00',5.51),('9650','2013-05-09','11:35:00',4.94),('9650','2013-05-09','11:40:00',4.7),('9650','2013-05-09','11:45:00',4.76),('9650','2013-05-09','11:50:00',5.54),('9650','2013-05-09','11:55:00',7.06),('9650','2013-05-09','12:00:00',5.21),('9650','2013-05-09','12:05:00',3.94),('9650','2013-05-09','12:10:00',3.59),('9650','2013-05-09','12:15:00',4.7),('9650','2013-05-09','12:20:00',5.4),('9650','2013-05-09','12:25:00',3.77),('9650','2013-05-09','12:30:00',3.75),('9650','2013-05-09','12:35:00',3.18),('9650','2013-05-09','12:40:00',5.63),('9650','2013-05-09','12:45:00',7.21),('9650','2013-05-09','12:50:00',5.83),('9650','2013-05-09','12:55:00',4.32),('9650','2013-05-09','13:00:00',6.96),('9650','2013-05-09','13:05:00',6.53),('9650','2013-05-09','13:10:00',8.12),('9650','2013-05-09','13:15:00',7.78),('9650','2013-05-09','13:20:00',5.3),('9650','2013-05-09','13:25:00',4.79),('9650','2013-05-09','13:30:00',5.9),('9650','2013-05-09','13:35:00',6.94),('9650','2013-05-09','13:40:00',6.93),('9650','2013-05-09','13:45:00',6.69),('9650','2013-05-09','13:50:00',4.11),('9650','2013-05-09','13:55:00',3.81),('9650','2013-05-09','14:00:00',3.5),('9650','2013-05-09','14:05:00',3.77),('9650','2013-05-09','14:10:00',4.49),('9650','2013-05-09','14:15:00',4.97),('9650','2013-05-09','14:20:00',4.67),('9650','2013-05-09','14:25:00',4.71),('9650','2013-05-09','14:30:00',4.7),('9650','2013-05-09','14:35:00',5.61),('9650','2013-05-09','14:40:00',4.82),('9650','2013-05-09','14:45:00',3.41),('9650','2013-05-09','14:50:00',2.6),('9650','2013-05-09','14:55:00',2.34),('9650','2013-05-09','15:00:00',2.35),('9650','2013-05-09','15:05:00',2.73),('9650','2013-05-09','15:10:00',3.8),('9650','2013-05-09','15:15:00',6.38),('9650','2013-05-09','15:20:00',4.68),('9650','2013-05-09','15:25:00',3.72),('9650','2013-05-09','15:30:00',3.66),('9650','2013-05-09','15:35:00',3.7),('9650','2013-05-09','15:40:00',3.86),('9650','2013-05-09','15:45:00',3.59),('9650','2013-05-09','15:50:00',3.27),('9650','2013-05-09','15:55:00',3.1),('9650','2013-05-09','16:00:00',3.04),('9650','2013-05-09','16:05:00',2.99),('9650','2013-05-09','16:10:00',2.91),('9650','2013-05-09','16:15:00',2.64),('9650','2013-05-09','16:20:00',2.43),('9650','2013-05-09','16:25:00',2.5),('9650','2013-05-09','16:30:00',2.73),('9650','2013-05-09','16:35:00',2.87),('9650','2013-05-09','16:40:00',2.68),('9650','2013-05-09','16:45:00',2.78),('9650','2013-05-09','16:50:00',2.57),('9650','2013-05-09','16:55:00',2.12),('9650','2013-05-09','17:00:00',1.84),('9650','2013-05-09','17:05:00',2),('9650','2013-05-09','17:10:00',2.83),('9650','2013-05-09','17:15:00',3.31),('9650','2013-05-09','17:20:00',4.75),('9650','2013-05-09','17:25:00',4.36),('9650','2013-05-09','17:30:00',4.11),('9650','2013-05-09','17:35:00',4.87),('9650','2013-05-09','17:40:00',2.78),('9650','2013-05-09','17:45:00',2.8),('9650','2013-05-09','17:50:00',2.38),('9650','2013-05-09','17:55:00',1.91),('9650','2013-05-09','18:00:00',1.86),('9650','2013-05-09','18:05:00',1.82),('9650','2013-05-09','18:10:00',1.63),('9650','2013-05-09','18:15:00',1.47),('9650','2013-05-09','18:20:00',1.46),('9650','2013-05-09','18:25:00',1.29),('9650','2013-05-08','08:15:00',1.07),('9650','2013-05-08','08:20:00',1.15),('9650','2013-05-08','08:25:00',1.26),('9650','2013-05-08','08:30:00',1.45),('9650','2013-05-08','08:35:00',1.57),('9650','2013-05-08','08:40:00',1.71),('9650','2013-05-08','08:45:00',1.85),('9650','2013-05-08','08:50:00',2),('9650','2013-05-08','08:55:00',2.12),('9650','2013-05-08','09:00:00',2.26),('9650','2013-05-08','09:05:00',2.38),('9650','2013-05-08','09:10:00',2.56),('9650','2013-05-08','09:15:00',2.72),('9650','2013-05-08','09:20:00',2.88),('9650','2013-05-08','09:25:00',3.02),('9650','2013-05-08','09:30:00',3.17),('9650','2013-05-08','09:35:00',3.35),('9650','2013-05-08','09:40:00',3.48),('9650','2013-05-08','09:45:00',3.61),('9650','2013-05-08','09:50:00',3.74),('9650','2013-05-08','09:55:00',3.86),('9650','2013-05-08','10:00:00',4.01),('9650','2013-05-08','10:05:00',4.13),('9650','2013-05-08','10:10:00',4.24),('9650','2013-05-08','10:15:00',4.37),('9650','2013-05-08','10:20:00',4.48),('9650','2013-05-08','10:25:00',4.6),('9650','2013-05-08','10:30:00',4.72),('9650','2013-05-08','10:35:00',4.82),('9650','2013-05-08','10:40:00',4.95),('9650','2013-05-08','10:45:00',5.06),('9650','2013-05-08','10:50:00',5.15),('9650','2013-05-08','10:55:00',5.26),('9650','2013-05-08','11:00:00',5.36),('9650','2013-05-08','11:05:00',5.45),('9650','2013-05-08','11:10:00',5.55),('9650','2013-05-08','11:15:00',5.65),('9650','2013-05-08','11:20:00',5.75),('9650','2013-05-08','11:25:00',5.83),('9650','2013-05-08','11:30:00',5.93),('9650','2013-05-08','11:35:00',5.98),('9650','2013-05-08','11:40:00',6.04),('9650','2013-05-08','11:45:00',6.15),('9650','2013-05-08','11:50:00',6.19),('9650','2013-05-08','11:55:00',6.28),('9650','2013-05-08','12:00:00',6.3),('9650','2013-05-08','12:05:00',6.35),('9650','2013-05-08','12:10:00',6.46),('9650','2013-05-08','12:15:00',6.61),('9650','2013-05-08','12:20:00',6.71),('9650','2013-05-08','12:25:00',6.74),('9650','2013-05-08','12:30:00',6.81),('9650','2013-05-08','12:35:00',6.88),('9650','2013-05-08','12:40:00',6.92),('9650','2013-05-08','12:45:00',7.01),('9650','2013-05-08','12:50:00',7.01),('9650','2013-05-08','12:55:00',7.05),('9650','2013-05-08','13:00:00',7.06),('9650','2013-05-08','13:05:00',7.03),('9650','2013-05-08','13:10:00',7.13),('9650','2013-05-08','13:15:00',7.2),('9650','2013-05-08','13:20:00',7.23),('9650','2013-05-08','13:25:00',7.22),('9650','2013-05-08','13:30:00',7.31),('9650','2013-05-08','13:35:00',7.37),('9650','2013-05-08','13:40:00',7.51),('9650','2013-05-08','13:45:00',7.4),('9650','2013-05-08','13:50:00',7.55),('9650','2013-05-08','13:55:00',7.74),('9650','2013-05-08','14:00:00',6.43),('9650','2013-05-08','14:05:00',6.22),('9650','2013-05-08','14:10:00',6.78),('9650','2013-05-08','14:15:00',8.2),('9650','2013-05-08','14:20:00',6.74),('9650','2013-05-08','14:25:00',6.27),('9650','2013-05-08','14:30:00',7.42),('9650','2013-05-08','14:35:00',7.42),('9650','2013-05-08','14:40:00',7.38),('9650','2013-05-08','14:45:00',7.4),('9650','2013-05-08','14:50:00',7.29),('9650','2013-05-08','14:55:00',7.44),('9650','2013-05-08','15:00:00',7.38),('9650','2013-05-08','15:05:00',7.36),('9650','2013-05-08','15:10:00',7.32),('9650','2013-05-08','15:15:00',7.35),('9650','2013-05-08','15:20:00',7.28),('9650','2013-05-08','15:25:00',7.25),('9650','2013-05-08','15:30:00',7.16),('9650','2013-05-08','15:35:00',7.15),('9650','2013-05-08','15:40:00',7.1),('9650','2013-05-08','15:45:00',7.05),('9650','2013-05-08','15:50:00',7.01),('9650','2013-05-08','15:55:00',6.92),('9650','2013-05-08','16:00:00',6.84),('9650','2013-05-08','16:05:00',6.85),('9650','2013-05-08','16:10:00',6.8),('9650','2013-05-08','16:15:00',6.67),('9650','2013-05-08','16:20:00',6.62),('9650','2013-05-08','16:25:00',6.5),('9650','2013-05-08','16:30:00',6.47),('9650','2013-05-08','16:35:00',6.4),('9650','2013-05-08','16:40:00',6.26),('9650','2013-05-08','16:45:00',6.11),('9650','2013-05-08','16:50:00',6.03),('9650','2013-05-08','16:55:00',5.97),('9650','2013-05-08','17:00:00',5.86),('9650','2013-05-08','17:05:00',5.74),('9650','2013-05-08','17:10:00',5.62),('9650','2013-05-08','17:15:00',5.5),('9650','2013-05-08','17:20:00',5.43),('9650','2013-05-08','17:25:00',5.32),('9650','2013-05-08','17:30:00',5.19),('9650','2013-05-08','17:35:00',5.04),('9650','2013-05-08','17:40:00',4.94),('9650','2013-05-08','17:45:00',4.8),('9650','2013-05-08','17:50:00',4.65),('9650','2013-05-08','17:55:00',4.55),('9650','2013-05-08','18:00:00',4.38),('9650','2013-05-08','18:05:00',4.25),('9650','2013-05-08','18:10:00',4.08),('9650','2013-05-08','18:15:00',3.95),('9650','2013-05-08','18:20:00',3.8),('9650','2013-05-08','18:25:00',3.62),('9650','2013-05-08','18:30:00',3.47),('9650','2013-05-08','18:35:00',3.33),('9650','2013-05-08','18:40:00',3.12),('9650','2013-05-08','18:45:00',2.96),('9650','2013-05-08','18:50:00',2.77),('9650','2013-05-08','18:55:00',2.59),('9650','2013-05-08','19:00:00',2.42),('9650','2013-05-08','19:05:00',2.21),('9650','2013-05-08','19:10:00',2.03),('9650','2013-05-08','19:15:00',1.8),('9650','2013-05-08','19:20:00',1.42),('9650','2013-05-08','19:25:00',1.1),('9650','2013-05-07','08:10:00',1.07),('9650','2013-05-07','08:15:00',1.16),('9650','2013-05-07','08:20:00',1.26),('9650','2013-05-07','08:25:00',1.35),('9650','2013-05-07','08:30:00',1.51),('9650','2013-05-07','08:35:00',1.66),('9650','2013-05-07','08:40:00',1.77),('9650','2013-05-07','08:45:00',1.91),('9650','2013-05-07','08:50:00',1.33),('9650','2013-05-07','08:55:00',1.68),('9650','2013-05-07','09:00:00',1.58),('9650','2013-05-07','09:05:00',2.72),('9650','2013-05-07','09:10:00',1.65),('9650','2013-05-07','09:30:00',1.19),('9650','2013-05-07','09:35:00',2.78),('9650','2013-05-07','09:40:00',4.65),('9650','2013-05-07','09:45:00',3.13),('9650','2013-05-07','09:50:00',3.24),('9650','2013-05-07','09:55:00',2.23),('9650','2013-05-07','10:00:00',2.12),('9650','2013-05-07','10:05:00',4.7),('9650','2013-05-07','10:10:00',4.21),('9650','2013-05-07','10:15:00',1.8),('9650','2013-05-07','10:20:00',1.84),('9650','2013-05-07','10:25:00',1.55),('9650','2013-05-07','10:30:00',1.55),('9650','2013-05-07','10:35:00',1.55),('9650','2013-05-07','10:40:00',1.52),('9650','2013-05-07','10:45:00',1.44),('9650','2013-05-07','10:50:00',1.39),('9650','2013-05-07','10:55:00',1.79),('9650','2013-05-07','11:00:00',3.51),('9650','2013-05-07','11:05:00',5.71),('9650','2013-05-07','11:10:00',6.77),('9650','2013-05-07','11:15:00',5.24),('9650','2013-05-07','11:20:00',5.25),('9650','2013-05-07','11:25:00',6.5),('9650','2013-05-07','11:30:00',6.8),('9650','2013-05-07','11:35:00',7.03),('9650','2013-05-07','11:40:00',6.2),('9650','2013-05-07','11:45:00',4.8),('9650','2013-05-07','11:50:00',3.92),('9650','2013-05-07','11:55:00',5),('9650','2013-05-07','12:00:00',5.73),('9650','2013-05-07','12:05:00',1.87),('9650','2013-05-07','12:10:00',1.63),('9650','2013-05-07','12:15:00',1.99),('9650','2013-05-07','12:20:00',3.6),('9650','2013-05-07','12:25:00',3.2),('9650','2013-05-07','12:30:00',3.12),('9650','2013-05-07','12:35:00',2.04),('9650','2013-05-07','12:40:00',2.02),('9650','2013-05-07','12:45:00',2.27),('9650','2013-05-07','12:50:00',3.78),('9650','2013-05-07','12:55:00',6.03),('9650','2013-05-07','13:00:00',5.37),('9650','2013-05-07','13:05:00',2.76),('9650','2013-05-07','13:10:00',7.68),('9650','2013-05-07','13:15:00',5.5),('9650','2013-05-07','13:20:00',1.95),('9650','2013-05-07','13:25:00',4.16),('9650','2013-05-07','13:30:00',1.7),('9650','2013-05-07','13:35:00',1.72),('9650','2013-05-07','13:40:00',4.29),('9650','2013-05-07','13:45:00',8.8),('9650','2013-05-07','13:50:00',7.74),('9650','2013-05-07','13:55:00',8.55),('9650','2013-05-07','14:00:00',6.91),('9650','2013-05-07','14:05:00',4.69),('9650','2013-05-07','14:10:00',3.12),('9650','2013-05-07','14:15:00',4.03),('9650','2013-05-07','14:20:00',5.46),('9650','2013-05-07','14:25:00',2.87),('9650','2013-05-07','14:30:00',6),('9650','2013-05-07','14:35:00',7.14),('9650','2013-05-07','14:40:00',8.71),('9650','2013-05-07','14:45:00',6.72),('9650','2013-05-07','14:50:00',8.21),('9650','2013-05-07','14:55:00',7.47),('9650','2013-05-07','15:00:00',7.69),('9650','2013-05-07','15:05:00',7.46),('9650','2013-05-07','15:10:00',7.56),('9650','2013-05-07','15:15:00',7.49),('9650','2013-05-07','15:20:00',7.36),('9650','2013-05-07','15:25:00',7.42),('9650','2013-05-07','15:30:00',7.35),('9650','2013-05-07','15:35:00',7.17),('9650','2013-05-07','15:40:00',7.08),('9650','2013-05-07','15:45:00',7.08),('9650','2013-05-07','15:50:00',7.07),('9650','2013-05-07','15:55:00',7.06),('9650','2013-05-07','16:00:00',7.09),('9650','2013-05-07','16:05:00',6.92),('9650','2013-05-07','16:10:00',6.9),('9650','2013-05-07','16:15:00',6.72),('9650','2013-05-07','16:20:00',6.66),('9650','2013-05-07','16:25:00',6.44),('9650','2013-05-07','16:30:00',6.69),('9650','2013-05-07','16:35:00',6.56),('9650','2013-05-07','16:40:00',4.98),('9650','2013-05-07','16:45:00',5.02),('9650','2013-05-07','16:50:00',4.25),('9650','2013-05-07','16:55:00',6),('9650','2013-05-07','17:00:00',5.18),('9650','2013-05-07','17:05:00',6.3),('9650','2013-05-07','17:10:00',5.9),('9650','2013-05-07','17:15:00',5.05),('9650','2013-05-07','17:20:00',5.15),('9650','2013-05-07','17:25:00',4.25),('9650','2013-05-07','17:30:00',5.83),('9650','2013-05-07','17:35:00',5.71),('9650','2013-05-07','17:40:00',5.73),('9650','2013-05-07','17:45:00',5.85),('9650','2013-05-07','17:50:00',5.84),('9650','2013-05-07','17:55:00',5.6),('9650','2013-05-07','18:00:00',2.54),('9650','2013-05-07','18:05:00',1.68),('9650','2013-05-07','18:10:00',2.26),('9650','2013-05-07','18:15:00',4.88),('9650','2013-05-07','18:20:00',4.67),('9650','2013-05-07','18:25:00',4.33),('9650','2013-05-07','18:30:00',3.7),('9650','2013-05-07','18:35:00',3.37),('9650','2013-05-07','18:40:00',1.8),('9650','2013-05-07','18:45:00',1.17),('9650','2013-05-07','18:50:00',1.17),('9650','2013-05-07','18:55:00',1.52),('9650','2013-05-07','19:00:00',2.49),('9650','2013-05-07','19:05:00',2.25),('9650','2013-05-07','19:10:00',2.05),('9650','2013-05-07','19:15:00',1.91),('9650','2013-05-07','19:20:00',1.65),('9650','2013-05-07','19:25:00',1.48),('9650','2013-05-07','19:30:00',1.21),('9650','2013-05-06','08:15:00',1.01),('9650','2013-05-06','08:20:00',1.11),('9650','2013-05-06','08:25:00',1.21),('9650','2013-05-06','08:30:00',1.24),('9650','2013-05-06','08:35:00',1.3),('9650','2013-05-06','08:40:00',1.59),('9650','2013-05-06','08:45:00',1.85),('9650','2013-05-06','08:50:00',2.13),('9650','2013-05-06','08:55:00',2.47),('9650','2013-05-06','09:00:00',2.1),('9650','2013-05-06','09:05:00',1.09),('9650','2013-05-06','09:10:00',1.11),('9650','2013-05-06','09:15:00',1.78),('9650','2013-05-06','09:20:00',1.26),('9650','2013-05-06','09:25:00',1.2),('9650','2013-05-06','09:30:00',1.85),('9650','2013-05-06','09:35:00',3.82),('9650','2013-05-06','09:40:00',2.89),('9650','2013-05-06','09:45:00',2.53),('9650','2013-05-06','09:50:00',2.45),('9650','2013-05-06','09:55:00',1.73),('9650','2013-05-06','10:00:00',1.47),('9650','2013-05-06','10:05:00',1.27),('9650','2013-05-06','10:25:00',1.1),('9650','2013-05-06','10:30:00',1.11),('9650','2013-05-06','10:35:00',1.19),('9650','2013-05-06','10:40:00',1.25),('9650','2013-05-06','10:45:00',1.2),('9650','2013-05-06','10:50:00',1.55),('9650','2013-05-06','10:55:00',2.14),('9650','2013-05-06','11:00:00',2.4),('9650','2013-05-06','11:05:00',2.49),('9650','2013-05-06','11:10:00',2.48),('9650','2013-05-06','11:15:00',2.41),('9650','2013-05-06','11:20:00',3.76),('9650','2013-05-06','11:25:00',3.17),('9650','2013-05-06','11:30:00',1.06),('9650','2013-05-06','11:45:00',1.05),('9650','2013-05-06','11:50:00',1.26),('9650','2013-05-06','11:55:00',1.74),('9650','2013-05-06','12:00:00',2.04),('9650','2013-05-06','12:05:00',5.2),('9650','2013-05-06','12:10:00',7.63),('9650','2013-05-06','12:15:00',3.39),('9650','2013-05-06','12:20:00',8.32),('9650','2013-05-06','12:25:00',6),('9650','2013-05-06','12:30:00',2.05),('9650','2013-05-06','12:35:00',1.58),('9650','2013-05-06','12:40:00',1.79),('9650','2013-05-06','12:45:00',1.36),('9650','2013-05-06','12:50:00',1.32),('9650','2013-05-06','12:55:00',1.28),('9650','2013-05-06','13:05:00',1.42),('9650','2013-05-06','13:10:00',1.98),('9650','2013-05-06','13:15:00',2.31),('9650','2013-05-06','13:20:00',2.86),('9650','2013-05-06','13:25:00',3.83),('9650','2013-05-06','13:30:00',6.31),('9650','2013-05-06','13:35:00',8.8),('9650','2013-05-06','13:40:00',8.18),('9650','2013-05-06','13:45:00',8.5),('9650','2013-05-06','13:50:00',8.07),('9650','2013-05-06','13:55:00',5.73),('9650','2013-05-06','14:00:00',8.49),('9650','2013-05-06','14:05:00',8.5),('9650','2013-05-06','14:10:00',8.14),('9650','2013-05-06','14:15:00',8.58),('9650','2013-05-06','14:20:00',5.18),('9650','2013-05-06','14:25:00',7.1),('9650','2013-05-06','14:30:00',5.14),('9650','2013-05-06','14:35:00',8.7),('9650','2013-05-06','14:40:00',8.09),('9650','2013-05-06','14:45:00',6.24),('9650','2013-05-06','14:50:00',6.68),('9650','2013-05-06','14:55:00',6.17),('9650','2013-05-06','15:00:00',7.74),('9650','2013-05-06','15:05:00',7.54),('9650','2013-05-06','15:10:00',7.37),('9650','2013-05-06','15:15:00',7.94),('9650','2013-05-06','15:20:00',7.82),('9650','2013-05-06','15:25:00',5.41),('9650','2013-05-06','15:30:00',4.9),('9650','2013-05-06','15:35:00',5.93),('9650','2013-05-06','15:40:00',6.12),('9650','2013-05-06','15:45:00',5.66),('9650','2013-05-06','15:50:00',3.61),('9650','2013-05-06','15:55:00',4.28),('9650','2013-05-06','16:00:00',7.47),('9650','2013-05-06','16:05:00',3.59),('9650','2013-05-06','16:10:00',2.63),('9650','2013-05-06','16:15:00',6.45),('9650','2013-05-06','16:20:00',8.53),('9650','2013-05-06','16:25:00',8.21),('9650','2013-05-06','16:30:00',7.81),('9650','2013-05-06','16:35:00',7.72),('9650','2013-05-06','16:40:00',7.52),('9650','2013-05-06','16:45:00',6.68),('9650','2013-05-06','16:50:00',6.66),('9650','2013-05-06','16:55:00',5.41),('9650','2013-05-06','17:00:00',5.84),('9650','2013-05-06','17:05:00',6.56),('9650','2013-05-06','17:10:00',2.77),('9650','2013-05-06','17:15:00',2.35),('9650','2013-05-06','17:20:00',2.3),('9650','2013-05-06','17:25:00',2.24),('9650','2013-05-06','17:30:00',2.04),('9650','2013-05-06','17:35:00',2.09),('9650','2013-05-06','17:40:00',1.74),('9650','2013-05-06','17:45:00',1.52),('9650','2013-05-06','17:50:00',1.28),('9650','2013-05-06','18:35:00',1.1),('9650','2013-05-06','18:40:00',1.57),('9650','2013-05-06','18:45:00',1.9),('9650','2013-05-06','18:50:00',1.92),('9650','2013-05-05','08:15:00',1.24),('9650','2013-05-05','08:20:00',1.37),('9650','2013-05-05','08:25:00',1.86),('9650','2013-05-05','08:30:00',2.02),('9650','2013-05-05','08:35:00',1.91),('9650','2013-05-05','08:40:00',1.77),('9650','2013-05-05','08:45:00',1.44),('9650','2013-05-05','08:50:00',2.08),('9650','2013-05-05','08:55:00',3.08),('9650','2013-05-05','09:00:00',3.24),('9650','2013-05-05','09:05:00',2.49),('9650','2013-05-05','09:10:00',2.23),('9650','2013-05-05','09:15:00',2.24),('9650','2013-05-05','09:20:00',2.29),('9650','2013-05-05','09:25:00',2.1),('9650','2013-05-05','09:30:00',1.81),('9650','2013-05-05','09:35:00',1.21),('9650','2013-05-05','09:50:00',1.31),('9650','2013-05-05','09:55:00',1.85),('9650','2013-05-05','10:00:00',2.89),('9650','2013-05-05','10:05:00',1.98),('9650','2013-05-05','10:10:00',1.86),('9650','2013-05-05','10:15:00',2.42),('9650','2013-05-05','10:20:00',3.66),('9650','2013-05-05','10:25:00',3.36),('9650','2013-05-05','10:30:00',3.37),('9650','2013-05-05','10:35:00',3.32),('9650','2013-05-05','10:40:00',3.18),('9650','2013-05-05','10:45:00',4.47),('9650','2013-05-05','10:50:00',4.16),('9650','2013-05-05','10:55:00',3.33),('9650','2013-05-05','11:00:00',3.11),('9650','2013-05-05','11:05:00',3.5),('9650','2013-05-05','11:10:00',3.43),('9650','2013-05-05','11:15:00',3.11),('9650','2013-05-05','11:20:00',3.6),('9650','2013-05-05','11:25:00',3.58),('9650','2013-05-05','11:30:00',2.33),('9650','2013-05-05','11:35:00',3.16),('9650','2013-05-05','11:40:00',3.78),('9650','2013-05-05','11:45:00',6.2),('9650','2013-05-05','11:50:00',3.93),('9650','2013-05-05','11:55:00',3.01),('9650','2013-05-05','12:00:00',3.11),('9650','2013-05-05','12:05:00',2.89),('9650','2013-05-05','12:10:00',4.82),('9650','2013-05-05','12:15:00',3.91),('9650','2013-05-05','12:20:00',3.92),('9650','2013-05-05','12:25:00',6.54),('9650','2013-05-05','12:30:00',5.41),('9650','2013-05-05','12:35:00',7.73),('9650','2013-05-05','12:40:00',4.14),('9650','2013-05-05','12:45:00',3.47),('9650','2013-05-05','12:50:00',4.7),('9650','2013-05-05','12:55:00',5.12),('9650','2013-05-05','13:00:00',3.52),('9650','2013-05-05','13:05:00',5.7),('9650','2013-05-05','13:10:00',6.9),('9650','2013-05-05','13:15:00',5.14),('9650','2013-05-05','13:20:00',7.36),('9650','2013-05-05','13:25:00',5.09),('9650','2013-05-05','13:30:00',5.85),('9650','2013-05-05','13:35:00',4.75),('9650','2013-05-05','13:40:00',6.1),('9650','2013-05-05','13:45:00',6.34),('9650','2013-05-05','13:50:00',8.27),('9650','2013-05-05','13:55:00',8),('9650','2013-05-05','14:00:00',6.59),('9650','2013-05-05','14:05:00',5.64),('9650','2013-05-05','14:10:00',6.33),('9650','2013-05-05','14:15:00',8.3),('9650','2013-05-05','14:20:00',8.43),('9650','2013-05-05','14:25:00',3.54),('9650','2013-05-05','14:30:00',7.66),('9650','2013-05-05','14:35:00',7.8),('9650','2013-05-05','14:40:00',5.95),('9650','2013-05-05','14:45:00',4.17),('9650','2013-05-05','14:50:00',5.79),('9650','2013-05-05','14:55:00',7.44),('9650','2013-05-05','15:00:00',5.51),('9650','2013-05-05','15:05:00',4.38),('9650','2013-05-05','15:10:00',4.97),('9650','2013-05-05','15:15:00',5.58),('9650','2013-05-05','15:20:00',3.86),('9650','2013-05-05','15:25:00',3.95),('9650','2013-05-05','15:30:00',4.73),('9650','2013-05-05','15:35:00',5.51),('9650','2013-05-05','15:40:00',2.77),('9650','2013-05-05','15:45:00',2.53),('9650','2013-05-05','15:50:00',3.81),('9650','2013-05-05','15:55:00',3.33),('9650','2013-05-05','16:00:00',2.96),('9650','2013-05-05','16:05:00',2.76),('9650','2013-05-05','16:10:00',2.83),('9650','2013-05-05','16:15:00',2.95),('9650','2013-05-05','16:20:00',5.31),('9650','2013-05-05','16:25:00',3.78),('9650','2013-05-05','16:30:00',6.88),('9650','2013-05-05','16:35:00',4.63),('9650','2013-05-05','16:40:00',5.79),('9650','2013-05-05','16:45:00',3.59),('9650','2013-05-05','16:50:00',6.3),('9650','2013-05-05','16:55:00',5.8),('9650','2013-05-05','17:00:00',1.56),('9650','2013-05-05','17:05:00',1),('9650','2013-05-05','17:15:00',2.71),('9650','2013-05-05','17:20:00',2.12),('9650','2013-05-05','17:25:00',1.64),('9650','2013-05-05','17:30:00',1.3),('9650','2013-05-05','17:35:00',4.66),('9650','2013-05-05','17:40:00',3.38),('9650','2013-05-05','17:45:00',2.19),('9650','2013-05-05','17:50:00',3.04),('9650','2013-05-05','17:55:00',2.99),('9650','2013-05-05','18:00:00',4.33),('9650','2013-05-05','18:05:00',5.06),('9650','2013-05-05','18:10:00',2.07),('9650','2013-05-05','18:15:00',3.05),('9650','2013-05-05','18:20:00',4.58),('9650','2013-05-05','18:25:00',4.13),('9650','2013-05-05','18:30:00',3.55),('9650','2013-05-05','18:35:00',1.04),('9650','2013-05-05','19:20:00',1.08),('9650','2013-05-05','19:25:00',1.26),('9650','2013-05-05','19:35:00',1.04),('9650','2013-05-04','08:05:00',1.03),('9650','2013-05-04','08:10:00',1.13),('9650','2013-05-04','08:15:00',1.21),('9650','2013-05-04','08:20:00',1.48),('9650','2013-05-04','08:25:00',2.31),('9650','2013-05-04','08:30:00',2.65),('9650','2013-05-04','08:35:00',2.52),('9650','2013-05-04','08:40:00',2.55),('9650','2013-05-04','08:45:00',2.3),('9650','2013-05-04','08:50:00',2),('9650','2013-05-04','08:55:00',2.01),('9650','2013-05-04','09:00:00',2.17),('9650','2013-05-04','09:05:00',2.13),('9650','2013-05-04','09:10:00',2.16),('9650','2013-05-04','09:15:00',2.19),('9650','2013-05-04','09:20:00',1.88),('9650','2013-05-04','09:25:00',2.25),('9650','2013-05-04','09:30:00',2.4),('9650','2013-05-04','09:35:00',2.12),('9650','2013-05-04','09:40:00',2.82),('9650','2013-05-04','09:45:00',3.84),('9650','2013-05-04','09:50:00',4.08),('9650','2013-05-04','09:55:00',4.3),('9650','2013-05-04','10:00:00',3.83),('9650','2013-05-04','10:05:00',3.77),('9650','2013-05-04','10:10:00',3.46),('9650','2013-05-04','10:15:00',3.87),('9650','2013-05-04','10:20:00',5.23),('9650','2013-05-04','10:25:00',3.12),('9650','2013-05-04','10:30:00',3.95),('9650','2013-05-04','10:35:00',4.29),('9650','2013-05-04','10:40:00',4.13),('9650','2013-05-04','10:45:00',4.1),('9650','2013-05-04','10:50:00',2.82),('9650','2013-05-04','10:55:00',2.42),('9650','2013-05-04','11:00:00',2.44),('9650','2013-05-04','11:05:00',2.79),('9650','2013-05-04','11:10:00',2.52),('9650','2013-05-04','11:15:00',2.74),('9650','2013-05-04','11:20:00',4.24),('9650','2013-05-04','11:25:00',5.57),('9650','2013-05-04','11:30:00',4.1),('9650','2013-05-04','11:35:00',5.57),('9650','2013-05-04','11:40:00',4.38),('9650','2013-05-04','11:45:00',4.29),('9650','2013-05-04','11:50:00',4.28),('9650','2013-05-04','11:55:00',5.5),('9650','2013-05-04','12:00:00',4.7),('9650','2013-05-04','12:05:00',4.47),('9650','2013-05-04','12:10:00',3.93),('9650','2013-05-04','12:15:00',5.27),('9650','2013-05-04','12:20:00',5.3),('9650','2013-05-04','12:25:00',6.78),('9650','2013-05-04','12:30:00',4.86),('9650','2013-05-04','12:35:00',6.75),('9650','2013-05-04','12:40:00',6.76),('9650','2013-05-04','12:45:00',7.32),('9650','2013-05-04','12:50:00',6.89),('9650','2013-05-04','12:55:00',7.46),('9650','2013-05-04','13:00:00',7.46),('9650','2013-05-04','13:05:00',7.19),('9650','2013-05-04','13:10:00',7.36),('9650','2013-05-04','13:15:00',6.56),('9650','2013-05-04','13:20:00',4.81),('9650','2013-05-04','13:25:00',3.5),('9650','2013-05-04','13:30:00',3.06),('9650','2013-05-04','13:35:00',7.79),('9650','2013-05-04','13:40:00',7.74),('9650','2013-05-04','13:45:00',7.55),('9650','2013-05-04','13:50:00',7.77),('9650','2013-05-04','13:55:00',7.87),('9650','2013-05-04','14:00:00',8.01),('9650','2013-05-04','14:05:00',7.66),('9650','2013-05-04','14:10:00',5.92),('9650','2013-05-04','14:15:00',6.49),('9650','2013-05-04','14:20:00',7.31),('9650','2013-05-04','14:25:00',7.05),('9650','2013-05-04','14:30:00',6.93),('9650','2013-05-04','14:35:00',6.93),('9650','2013-05-04','14:40:00',6.91),('9650','2013-05-04','14:45:00',6.89),('9650','2013-05-04','14:50:00',6.87),('9650','2013-05-04','14:55:00',6.86),('9650','2013-05-04','15:00:00',6.84),('9650','2013-05-04','15:05:00',6.77),('9650','2013-05-04','15:10:00',6.78),('9650','2013-05-04','15:15:00',6.74),('9650','2013-05-04','15:20:00',6.67),('9650','2013-05-04','15:25:00',6.72),('9650','2013-05-04','15:30:00',6.7),('9650','2013-05-04','15:35:00',6.7),('9650','2013-05-04','15:40:00',6.59),('9650','2013-05-04','15:45:00',6.51),('9650','2013-05-04','15:50:00',6.47),('9650','2013-05-04','15:55:00',6.4),('9650','2013-05-04','16:00:00',6.39),('9650','2013-05-04','16:05:00',6.32),('9650','2013-05-04','16:10:00',6.23),('9650','2013-05-04','16:15:00',6.17),('9650','2013-05-04','16:20:00',6.11),('9650','2013-05-04','16:25:00',6.05),('9650','2013-05-04','16:30:00',5.98),('9650','2013-05-04','16:35:00',5.86),('9650','2013-05-04','16:40:00',5.8),('9650','2013-05-04','16:45:00',5.71),('9650','2013-05-04','16:50:00',5.62),('9650','2013-05-04','16:55:00',5.51),('9650','2013-05-04','17:00:00',5.38),('9650','2013-05-04','17:05:00',5.27),('9650','2013-05-04','17:10:00',5.17),('9650','2013-05-04','17:15:00',5.08),('9650','2013-05-04','17:20:00',4.96),('9650','2013-05-04','17:25:00',4.79),('9650','2013-05-04','17:30:00',4.67),('9650','2013-05-04','17:35:00',4.53),('9650','2013-05-04','17:40:00',4.43),('9650','2013-05-04','17:45:00',4.32),('9650','2013-05-04','17:50:00',4.16),('9650','2013-05-04','17:55:00',3.98),('9650','2013-05-04','18:00:00',3.82),('9650','2013-05-04','18:05:00',3.69),('9650','2013-05-04','18:10:00',3.53),('9650','2013-05-04','18:15:00',3.37),('9650','2013-05-04','18:20:00',3.23),('9650','2013-05-04','18:25:00',3.05),('9650','2013-05-04','18:30:00',2.89),('9650','2013-05-04','18:35:00',2.78),('9650','2013-05-04','18:40:00',2.59),('9650','2013-05-04','18:45:00',2.39),('9650','2013-05-04','18:50:00',2.19),('9650','2013-05-04','18:55:00',2.01),('9650','2013-05-04','19:00:00',1.83),('9650','2013-05-04','19:05:00',1.63),('9650','2013-05-04','19:10:00',1.46),('9650','2013-05-04','19:15:00',1.27),('9650','2013-05-04','19:20:00',1.07),('9650','2013-05-03','08:10:00',1.06),('9650','2013-05-03','08:15:00',1.12),('9650','2013-05-03','08:20:00',1.19),('9650','2013-05-03','08:25:00',1.29),('9650','2013-05-03','08:30:00',1.38),('9650','2013-05-03','08:35:00',1.46),('9650','2013-05-03','08:40:00',1.58),('9650','2013-05-03','08:45:00',1.72),('9650','2013-05-03','08:50:00',1.83),('9650','2013-05-03','08:55:00',1.94),('9650','2013-05-03','09:00:00',2.07),('9650','2013-05-03','09:05:00',2.19),('9650','2013-05-03','09:10:00',2.34),('9650','2013-05-03','09:15:00',2.46),('9650','2013-05-03','09:20:00',2.61),('9650','2013-05-03','09:25:00',2.73),('9650','2013-05-03','09:30:00',2.82),('9650','2013-05-03','09:35:00',3),('9650','2013-05-03','09:40:00',3.15),('9650','2013-05-03','09:45:00',3.28),('9650','2013-05-03','09:50:00',3.41),('9650','2013-05-03','09:55:00',3.5),('9650','2013-05-03','10:00:00',3.68),('9650','2013-05-03','10:05:00',3.73),('9650','2013-05-03','10:10:00',3.91),('9650','2013-05-03','10:15:00',4.01),('9650','2013-05-03','10:20:00',4.13),('9650','2013-05-03','10:25:00',4.2),('9650','2013-05-03','10:30:00',4.3),('9650','2013-05-03','10:35:00',4.4),('9650','2013-05-03','10:40:00',4.45),('9650','2013-05-03','10:45:00',4.53),('9650','2013-05-03','10:50:00',4.49),('9650','2013-05-03','10:55:00',4.53),('9650','2013-05-03','11:00:00',4.58),('9650','2013-05-03','11:05:00',4.62),('9650','2013-05-03','11:10:00',4.42),('9650','2013-05-03','11:15:00',4.35),('9650','2013-05-03','11:20:00',4.82),('9650','2013-05-03','11:25:00',4.94),('9650','2013-05-03','11:30:00',4.82),('9650','2013-05-03','11:35:00',5),('9650','2013-05-03','11:40:00',4.89),('9650','2013-05-03','11:45:00',5.11),('9650','2013-05-03','11:50:00',5.13),('9650','2013-05-03','11:55:00',5.14),('9650','2013-05-03','12:00:00',5.14),('9650','2013-05-03','12:05:00',5.43),('9650','2013-05-03','12:10:00',5.49),('9650','2013-05-03','12:15:00',5.67),('9650','2013-05-03','12:20:00',5.8),('9650','2013-05-03','12:25:00',5.97),('9650','2013-05-03','12:30:00',5.99),('9650','2013-05-03','12:35:00',6.1),('9650','2013-05-03','12:40:00',6.08),('9650','2013-05-03','12:45:00',6.1),('9650','2013-05-03','12:50:00',5.83),('9650','2013-05-03','12:55:00',5.88),('9650','2013-05-03','13:00:00',5.85),('9650','2013-05-03','13:05:00',5.18),('9650','2013-05-03','13:10:00',5.8),('9650','2013-05-03','13:15:00',6.56),('9650','2013-05-03','13:20:00',6.64),('9650','2013-05-03','13:25:00',6.35),('9650','2013-05-03','13:30:00',6.54),('9650','2013-05-03','13:35:00',6.07),('9650','2013-05-03','13:40:00',6.36),('9650','2013-05-03','13:45:00',6.33),('9650','2013-05-03','13:50:00',5.53),('9650','2013-05-03','13:55:00',5.84),('9650','2013-05-03','14:00:00',6.32),('9650','2013-05-03','14:05:00',6.31),('9650','2013-05-03','14:10:00',6.08),('9650','2013-05-03','14:15:00',6.3),('9650','2013-05-03','14:20:00',6.31),('9650','2013-05-03','14:25:00',5.92),('9650','2013-05-03','14:30:00',6.27),('9650','2013-05-03','14:35:00',5.86),('9650','2013-05-03','14:40:00',6.23),('9650','2013-05-03','14:45:00',6.09),('9650','2013-05-03','14:50:00',5.94),('9650','2013-05-03','14:55:00',6.21),('9650','2013-05-03','15:00:00',6.36),('9650','2013-05-03','15:05:00',6.51),('9650','2013-05-03','15:10:00',6.17),('9650','2013-05-03','15:15:00',6.35),('9650','2013-05-03','15:20:00',6.38),('9650','2013-05-03','15:25:00',6.44),('9650','2013-05-03','15:30:00',6.43),('9650','2013-05-03','15:35:00',6.2),('9650','2013-05-03','15:40:00',6.38),('9650','2013-05-03','15:45:00',6.32),('9650','2013-05-03','15:50:00',6.25),('9650','2013-05-03','15:55:00',6.18),('9650','2013-05-03','16:00:00',6.14),('9650','2013-05-03','16:05:00',6.07),('9650','2013-05-03','16:10:00',5.99),('9650','2013-05-03','16:15:00',5.94),('9650','2013-05-03','16:20:00',5.89),('9650','2013-05-03','16:25:00',5.78),('9650','2013-05-03','16:30:00',5.7),('9650','2013-05-03','16:35:00',5.64),('9650','2013-05-03','16:40:00',5.56),('9650','2013-05-03','16:45:00',5.43),('9650','2013-05-03','16:50:00',5.33),('9650','2013-05-03','16:55:00',5.25),('9650','2013-05-03','17:00:00',5.14),('9650','2013-05-03','17:05:00',5.01),('9650','2013-05-03','17:10:00',3.89),('9650','2013-05-03','17:15:00',4.44),('9650','2013-05-03','17:20:00',4.83),('9650','2013-05-03','17:25:00',4.7),('9650','2013-05-03','17:30:00',4.47),('9650','2013-05-03','17:35:00',4.19),('9650','2013-05-03','17:40:00',4.01),('9650','2013-05-03','17:45:00',4.02),('9650','2013-05-03','17:50:00',4.07),('9650','2013-05-03','17:55:00',3.94),('9650','2013-05-03','18:00:00',3.84),('9650','2013-05-03','18:05:00',3.68),('9650','2013-05-03','18:10:00',3.17),('9650','2013-05-03','18:15:00',2.59),('9650','2013-05-03','18:20:00',2.17),('9650','2013-05-03','18:25:00',1.8),('9650','2013-05-03','18:30:00',1.41),('9650','2013-05-03','18:35:00',1.14),('9650','2013-05-03','18:40:00',1.05),('9650','2013-05-02','08:05:00',1.12),('9650','2013-05-02','08:10:00',1.23),('9650','2013-05-02','08:15:00',1.39),('9650','2013-05-02','08:20:00',1.42),('9650','2013-05-02','08:25:00',1.55),('9650','2013-05-02','08:30:00',1.63),('9650','2013-05-02','08:35:00',1.66),('9650','2013-05-02','08:40:00',1.74),('9650','2013-05-02','08:45:00',1.83),('9650','2013-05-02','08:50:00',1.85),('9650','2013-05-02','08:55:00',1.93),('9650','2013-05-02','09:00:00',2.11),('9650','2013-05-02','09:05:00',2.25),('9650','2013-05-02','09:10:00',2.35),('9650','2013-05-02','09:15:00',2.51),('9650','2013-05-02','09:20:00',2.59),('9650','2013-05-02','09:25:00',2.74),('9650','2013-05-02','09:30:00',2.9),('9650','2013-05-02','09:35:00',3.02),('9650','2013-05-02','09:40:00',3.16),('9650','2013-05-02','09:45:00',3.29),('9650','2013-05-02','09:50:00',3.39),('9650','2013-05-02','09:55:00',3.55),('9650','2013-05-02','10:00:00',3.69),('9650','2013-05-02','10:05:00',3.8),('9650','2013-05-02','10:10:00',3.93),('9650','2013-05-02','10:15:00',4.04),('9650','2013-05-02','10:20:00',4.18),('9650','2013-05-02','10:25:00',4.25),('9650','2013-05-02','10:30:00',4.37),('9650','2013-05-02','10:35:00',4.5),('9650','2013-05-02','10:40:00',4.62),('9650','2013-05-02','10:45:00',4.74),('9650','2013-05-02','10:50:00',4.84),('9650','2013-05-02','10:55:00',4.92),('9650','2013-05-02','11:00:00',5),('9650','2013-05-02','11:05:00',5.08),('9650','2013-05-02','11:10:00',5.19),('9650','2013-05-02','11:15:00',5.25),('9650','2013-05-02','11:20:00',5.35),('9650','2013-05-02','11:25:00',5.49),('9650','2013-05-02','11:30:00',5.55),('9650','2013-05-02','11:35:00',5.68),('9650','2013-05-02','11:40:00',5.77),('9650','2013-05-02','11:45:00',5.81),('9650','2013-05-02','11:50:00',5.88),('9650','2013-05-02','11:55:00',5.96),('9650','2013-05-02','12:00:00',6.01),('9650','2013-05-02','12:05:00',6.01),('9650','2013-05-02','12:10:00',6.12),('9650','2013-05-02','12:15:00',6.2),('9650','2013-05-02','12:20:00',6.28),('9650','2013-05-02','12:25:00',6.3),('9650','2013-05-02','12:30:00',6.36),('9650','2013-05-02','12:35:00',6.38),('9650','2013-05-02','12:40:00',6.42),('9650','2013-05-02','12:45:00',6.19),('9650','2013-05-02','12:50:00',6.61),('9650','2013-05-02','12:55:00',6.65),('9650','2013-05-02','13:00:00',6.64),('9650','2013-05-02','13:05:00',6.66),('9650','2013-05-02','13:10:00',6.7),('9650','2013-05-02','13:15:00',6.72),('9650','2013-05-02','13:20:00',6.74),('9650','2013-05-02','13:25:00',6.81),('9650','2013-05-02','13:30:00',6.82),('9650','2013-05-02','13:35:00',6.66),('9650','2013-05-02','13:40:00',6.55),('9650','2013-05-02','13:45:00',6.56),('9650','2013-05-02','13:50:00',6.6),('9650','2013-05-02','13:55:00',6.65),('9650','2013-05-02','14:00:00',6.6),('9650','2013-05-02','14:05:00',6.37),('9650','2013-05-02','14:10:00',6.5),('9650','2013-05-02','14:15:00',6.41),('9650','2013-05-02','14:20:00',6.69),('9650','2013-05-02','14:25:00',6.66),('9650','2013-05-02','14:30:00',6.61),('9650','2013-05-02','14:35:00',6.7),('9650','2013-05-02','14:40:00',6.59),('9650','2013-05-02','14:45:00',6.61),('9650','2013-05-02','14:50:00',6.53),('9650','2013-05-02','14:55:00',6.69),('9650','2013-05-02','15:00:00',6.77),('9650','2013-05-02','15:05:00',6.69),('9650','2013-05-02','15:10:00',6.73),('9650','2013-05-02','15:15:00',6.79),('9650','2013-05-02','15:20:00',6.75),('9650','2013-05-02','15:25:00',6.75),('9650','2013-05-02','15:30:00',6.73),('9650','2013-05-02','15:35:00',6.65),('9650','2013-05-02','15:40:00',6.59),('9650','2013-05-02','15:45:00',6.54),('9650','2013-05-02','15:50:00',6.45),('9650','2013-05-02','15:55:00',6.4),('9650','2013-05-02','16:00:00',6.41),('9650','2013-05-02','16:05:00',6.35),('9650','2013-05-02','16:10:00',6.29),('9650','2013-05-02','16:15:00',6.17),('9650','2013-05-02','16:20:00',5.92),('9650','2013-05-02','16:25:00',5.95),('9650','2013-05-02','16:30:00',6),('9650','2013-05-02','16:35:00',5.91),('9650','2013-05-02','16:40:00',5.81),('9650','2013-05-02','16:45:00',5.73),('9650','2013-05-02','16:50:00',5.62),('9650','2013-05-02','16:55:00',5.52),('9650','2013-05-02','17:00:00',5.38),('9650','2013-05-02','17:05:00',5.27),('9650','2013-05-02','17:10:00',5.12),('9650','2013-05-02','17:15:00',5),('9650','2013-05-02','17:20:00',4.79),('9650','2013-05-02','17:25:00',4.61),('9650','2013-05-02','17:30:00',4.45),('9650','2013-05-02','17:35:00',4.31),('9650','2013-05-02','17:40:00',4.15),('9650','2013-05-02','17:45:00',3.95),('9650','2013-05-02','17:50:00',3.82),('9650','2013-05-02','17:55:00',3.75),('9650','2013-05-02','18:00:00',3.69),('9650','2013-05-02','18:05:00',3.58),('9650','2013-05-02','18:10:00',3.41),('9650','2013-05-02','18:15:00',3.26),('9650','2013-05-02','18:20:00',3.11),('9650','2013-05-02','18:25:00',2.93),('9650','2013-05-02','18:30:00',2.75),('9650','2013-05-02','18:35:00',2.57),('9650','2013-05-02','18:40:00',2.41),('9650','2013-05-02','18:45:00',2.27),('9650','2013-05-02','18:50:00',2.11),('9650','2013-05-02','18:55:00',1.91),('9650','2013-05-02','19:00:00',1.68),('9650','2013-05-02','19:05:00',1.46),('9650','2013-05-02','19:10:00',1.26),('9650','2013-05-02','19:15:00',1.08),('9650','2013-05-01','08:35:00',1.15),('9650','2013-05-01','08:40:00',1.52),('9650','2013-05-01','08:45:00',1.35),('9650','2013-05-01','08:50:00',1.39),('9650','2013-05-01','08:55:00',1.9),('9650','2013-05-01','09:00:00',2.49),('9650','2013-05-01','09:05:00',2.03),('9650','2013-05-01','09:10:00',1.45),('9650','2013-05-01','09:15:00',1.45),('9650','2013-05-01','09:20:00',1.55),('9650','2013-05-01','09:25:00',2.67),('9650','2013-05-01','09:30:00',3.25),('9650','2013-05-01','09:35:00',2.99),('9650','2013-05-01','09:40:00',2.47),('9650','2013-05-01','09:45:00',3.83),('9650','2013-05-01','09:50:00',2.41),('9650','2013-05-01','09:55:00',1.93),('9650','2013-05-01','10:00:00',1.84),('9650','2013-05-01','10:05:00',2.4),('9650','2013-05-01','10:10:00',2.36),('9650','2013-05-01','10:15:00',2.39),('9650','2013-05-01','10:20:00',2.46),('9650','2013-05-01','10:25:00',2.82),('9650','2013-05-01','10:30:00',4.15),('9650','2013-05-01','10:35:00',3.74),('9650','2013-05-01','10:40:00',4.89),('9650','2013-05-01','10:45:00',4.44),('9650','2013-05-01','10:50:00',5.36),('9650','2013-05-01','10:55:00',5.63),('9650','2013-05-01','11:00:00',5.53),('9650','2013-05-01','11:05:00',5.36),('9650','2013-05-01','11:10:00',4.5),('9650','2013-05-01','11:15:00',4.26),('9650','2013-05-01','11:20:00',3.87),('9650','2013-05-01','11:25:00',5.57),('9650','2013-05-01','11:30:00',5.88),('9650','2013-05-01','11:35:00',5.73),('9650','2013-05-01','11:40:00',5.67),('9650','2013-05-01','11:45:00',5.7),('9650','2013-05-01','11:50:00',5.74),('9650','2013-05-01','11:55:00',5.82),('9650','2013-05-01','12:00:00',5.85),('9650','2013-05-01','12:05:00',5.91),('9650','2013-05-01','12:10:00',5.91),('9650','2013-05-01','12:15:00',6),('9650','2013-05-01','12:20:00',6.06),('9650','2013-05-01','12:25:00',6.13),('9650','2013-05-01','12:30:00',6.23),('9650','2013-05-01','12:35:00',6.32),('9650','2013-05-01','12:40:00',6.42),('9650','2013-05-01','12:45:00',6.48),('9650','2013-05-01','12:50:00',6.5),('9650','2013-05-01','12:55:00',6.6),('9650','2013-05-01','13:00:00',6.66),('9650','2013-05-01','13:05:00',6.74),('9650','2013-05-01','13:10:00',6.8),('9650','2013-05-01','13:15:00',6.85),('9650','2013-05-01','13:20:00',6.87),('9650','2013-05-01','13:25:00',6.88),('9650','2013-05-01','13:30:00',6.92),('9650','2013-05-01','13:35:00',6.93),('9650','2013-05-01','13:40:00',6.97),('9650','2013-05-01','13:45:00',6.97),('9650','2013-05-01','13:50:00',6.98),('9650','2013-05-01','13:55:00',6.99),('9650','2013-05-01','14:00:00',6.96),('9650','2013-05-01','14:05:00',6.95),('9650','2013-05-01','14:10:00',6.94),('9650','2013-05-01','14:15:00',6.97),('9650','2013-05-01','14:20:00',6.94),('9650','2013-05-01','14:25:00',6.94),('9650','2013-05-01','14:30:00',6.92),('9650','2013-05-01','14:35:00',6.9),('9650','2013-05-01','14:40:00',6.88),('9650','2013-05-01','14:45:00',6.9),('9650','2013-05-01','14:50:00',6.92),('9650','2013-05-01','14:55:00',6.88),('9650','2013-05-01','15:00:00',6.9),('9650','2013-05-01','15:05:00',6.81),('9650','2013-05-01','15:10:00',6.81),('9650','2013-05-01','15:15:00',6.75),('9650','2013-05-01','15:20:00',6.71),('9650','2013-05-01','15:25:00',6.64),('9650','2013-05-01','15:30:00',6.51),('9650','2013-05-01','15:35:00',6.47),('9650','2013-05-01','15:40:00',6.39),('9650','2013-05-01','15:45:00',6.34),('9650','2013-05-01','15:50:00',6.31),('9650','2013-05-01','15:55:00',6.26),('9650','2013-05-01','16:00:00',6.23),('9650','2013-05-01','16:05:00',6.18),('9650','2013-05-01','16:10:00',6.14),('9650','2013-05-01','16:15:00',6.07),('9650','2013-05-01','16:20:00',5.97),('9650','2013-05-01','16:25:00',5.94),('9650','2013-05-01','16:30:00',5.83),('9650','2013-05-01','16:35:00',5.75),('9650','2013-05-01','16:40:00',5.68),('9650','2013-05-01','16:45:00',5.6),('9650','2013-05-01','16:50:00',5.53),('9650','2013-05-01','16:55:00',5.43),('9650','2013-05-01','17:00:00',5.34),('9650','2013-05-01','17:05:00',5.25),('9650','2013-05-01','17:10:00',5.15),('9650','2013-05-01','17:15:00',5.06),('9650','2013-05-01','17:20:00',4.92),('9650','2013-05-01','17:25:00',4.81),('9650','2013-05-01','17:30:00',4.69),('9650','2013-05-01','17:35:00',4.55),('9650','2013-05-01','17:40:00',4.43),('9650','2013-05-01','17:45:00',4.25),('9650','2013-05-01','17:50:00',4.19),('9650','2013-05-01','17:55:00',4.02),('9650','2013-05-01','18:00:00',3.91),('9650','2013-05-01','18:05:00',3.76),('9650','2013-05-01','18:10:00',3.62),('9650','2013-05-01','18:15:00',3.46),('9650','2013-05-01','18:20:00',3.32),('9650','2013-05-01','18:25:00',3.16),('9650','2013-05-01','18:30:00',2.97),('9650','2013-05-01','18:35:00',2.84),('9650','2013-05-01','18:40:00',2.65),('9650','2013-05-01','18:45:00',2.48),('9650','2013-05-01','18:50:00',2.31),('9650','2013-05-01','18:55:00',2.07),('9650','2013-05-01','19:00:00',1.84),('9650','2013-05-01','19:05:00',1.64),('9650','2013-05-01','19:10:00',1.45),('9650','2013-05-01','19:15:00',1.23),('9650','2013-05-01','19:20:00',1.05),('9650','2014-03-29','08:30:00',1.03),('9650','2014-03-29','08:35:00',1.1),('9650','2014-03-29','08:40:00',1.15),('9650','2014-03-29','08:45:00',1.19),('9650','2014-03-29','08:50:00',1.23),('9650','2014-03-29','08:55:00',1.27),('9650','2014-03-29','09:00:00',1.3),('9650','2014-03-29','09:05:00',1.32),('9650','2014-03-29','09:10:00',1.31),('9650','2014-03-29','09:15:00',1.35),('9650','2014-03-29','09:20:00',1.7),('9650','2014-03-29','09:25:00',1.81),('9650','2014-03-29','09:30:00',1.97),('9650','2014-03-29','09:35:00',2.08),('9650','2014-03-29','09:40:00',2.18),('9650','2014-03-29','09:45:00',2.28),('9650','2014-03-29','09:50:00',2.39),('9650','2014-03-29','09:55:00',2.37),('9650','2014-03-29','10:00:00',2.47),('9650','2014-03-29','10:05:00',2.75),('9650','2014-03-29','10:10:00',2.8),('9650','2014-03-29','10:15:00',2.88),('9650','2014-03-29','10:20:00',2.92),('9650','2014-03-29','10:25:00',3.13),('9650','2014-03-29','10:30:00',3.27),('9650','2014-03-29','10:35:00',3.41),('9650','2014-03-29','10:40:00',3.53),('9650','2014-03-29','10:45:00',3.6),('9650','2014-03-29','10:50:00',3.66),('9650','2014-03-29','10:55:00',3.75),('9650','2014-03-29','11:00:00',3.79),('9650','2014-03-29','11:05:00',3.79),('9650','2014-03-29','11:10:00',3.86),('9650','2014-03-29','11:15:00',3.8),('9650','2014-03-29','11:20:00',3.81),('9650','2014-03-29','11:25:00',4.05),('9650','2014-03-29','11:30:00',4.34),('9650','2014-03-29','11:35:00',4.43),('9650','2014-03-29','11:40:00',4.65),('9650','2014-03-29','11:45:00',4.85),('9650','2014-03-29','11:50:00',4.97),('9650','2014-03-29','11:55:00',5.12),('9650','2014-03-29','12:00:00',5.19),('9650','2014-03-29','12:05:00',5.39),('9650','2014-03-29','12:10:00',5.55),('9650','2014-03-29','12:15:00',5.71),('9650','2014-03-29','12:20:00',5.58),('9650','2014-03-29','12:25:00',5.62),('9650','2014-03-29','12:30:00',5.24),('9650','2014-03-29','12:35:00',5.25),('9650','2014-03-29','12:40:00',5.54),('9650','2014-03-29','12:45:00',5.54),('9650','2014-03-29','12:50:00',5.61),('9650','2014-03-29','12:55:00',5.79),('9650','2014-03-29','13:00:00',5.91),('9650','2014-03-29','13:05:00',6.09),('9650','2014-03-29','13:10:00',6.08),('9650','2014-03-29','13:15:00',6.1),('9650','2014-03-29','13:20:00',6.13),('9650','2014-03-29','13:25:00',6.16),('9650','2014-03-29','13:30:00',6.23),('9650','2014-03-29','13:35:00',6.27),('9650','2014-03-29','13:40:00',6.31),('9650','2014-03-29','13:45:00',6.35),('9650','2014-03-29','13:50:00',6.34),('9650','2014-03-29','13:55:00',6.19),('9650','2014-03-29','14:00:00',6.18),('9650','2014-03-29','14:05:00',6.26),('9650','2014-03-29','14:10:00',6.04),('9650','2014-03-29','14:15:00',6.07),('9650','2014-03-29','14:20:00',6.37),('9650','2014-03-29','14:25:00',6.55),('9650','2014-03-29','14:30:00',6.68),('9650','2014-03-29','14:35:00',6.02),('9650','2014-03-29','14:40:00',5.83),('9650','2014-03-29','14:45:00',5.46),('9650','2014-03-29','14:50:00',4.32),('9650','2014-03-29','14:55:00',4.09),('9650','2014-03-29','15:00:00',2.81),('9650','2014-03-29','15:05:00',2.44),('9650','2014-03-29','15:10:00',2.65),('9650','2014-03-29','15:15:00',3.82),('9650','2014-03-29','15:20:00',5.09),('9650','2014-03-29','15:25:00',5.46),('9650','2014-03-29','15:30:00',5.62),('9650','2014-03-29','15:35:00',5.75),('9650','2014-03-29','15:40:00',5.59),('9650','2014-03-29','15:45:00',5.8),('9650','2014-03-29','15:50:00',5.62),('9650','2014-03-29','15:55:00',5.53),('9650','2014-03-29','16:00:00',4.94),('9650','2014-03-29','16:05:00',4.49),('9650','2014-03-29','16:10:00',4.44),('9650','2014-03-29','16:15:00',4.84),('9650','2014-03-29','16:20:00',5.11),('9650','2014-03-29','16:25:00',5.15),('9650','2014-03-29','16:30:00',4.99),('9650','2014-03-29','16:35:00',5.13),('9650','2014-03-29','16:40:00',4.82),('9650','2014-03-29','16:45:00',4.36),('9650','2014-03-29','16:50:00',3.83),('9650','2014-03-29','16:55:00',3.6),('9650','2014-03-29','17:00:00',3.89),('9650','2014-03-29','17:05:00',4.19),('9650','2014-03-29','17:10:00',4.38),('9650','2014-03-29','17:15:00',4.34),('9650','2014-03-29','17:20:00',4.18),('9650','2014-03-29','17:25:00',3.68),('9650','2014-03-29','17:30:00',3.82),('9650','2014-03-29','17:35:00',3.73),('9650','2014-03-29','17:40:00',3.43),('9650','2014-03-29','17:45:00',3.43),('9650','2014-03-29','17:50:00',3.01),('9650','2014-03-29','17:55:00',2.35),('9650','2014-03-29','18:00:00',1.91),('9650','2014-03-29','18:05:00',2.15),('9650','2014-03-29','18:10:00',2.34),('9650','2014-03-29','18:15:00',2.01),('9650','2014-03-29','18:20:00',1.52),('9650','2014-03-29','18:25:00',1.31),('9650','2014-03-29','18:30:00',1.17),('9650','2013-04-30','08:00:00',1.01),('9650','2013-04-30','08:05:00',1.06),('9650','2013-04-30','08:10:00',1.1),('9650','2013-04-30','08:15:00',1.15),('9650','2013-04-30','08:20:00',1.19),('9650','2013-04-30','08:25:00',1.22),('9650','2013-04-30','08:30:00',1.24),('9650','2013-04-30','08:35:00',1.42),('9650','2013-04-30','08:40:00',1.61),('9650','2013-04-30','08:45:00',1.73),('9650','2013-04-30','08:50:00',1.85),('9650','2013-04-30','08:55:00',1.95),('9650','2013-04-30','09:00:00',2.09),('9650','2013-04-30','09:05:00',2.24),('9650','2013-04-30','09:10:00',2.34),('9650','2013-04-30','09:15:00',2.47),('9650','2013-04-30','09:20:00',2.57),('9650','2013-04-30','09:25:00',2.68),('9650','2013-04-30','09:30:00',2.78),('9650','2013-04-30','09:35:00',2.9),('9650','2013-04-30','09:40:00',3.02),('9650','2013-04-30','09:45:00',3.14),('9650','2013-04-30','09:50:00',3.24),('9650','2013-04-30','09:55:00',3.35),('9650','2013-04-30','10:00:00',3.44),('9650','2013-04-30','10:05:00',3.51),('9650','2013-04-30','10:10:00',3.67),('9650','2013-04-30','10:15:00',3.81),('9650','2013-04-30','10:20:00',3.92),('9650','2013-04-30','10:25:00',4.01),('9650','2013-04-30','10:30:00',4.1),('9650','2013-04-30','10:35:00',4.16),('9650','2013-04-30','10:40:00',4.44),('9650','2013-04-30','10:45:00',4.6),('9650','2013-04-30','10:50:00',4.7),('9650','2013-04-30','10:55:00',4.78),('9650','2013-04-30','11:00:00',4.9),('9650','2013-04-30','11:05:00',4.96),('9650','2013-04-30','11:10:00',5.07),('9650','2013-04-30','11:15:00',4.72),('9650','2013-04-30','11:20:00',4.82),('9650','2013-04-30','11:25:00',4.81),('9650','2013-04-30','11:30:00',4.75),('9650','2013-04-30','11:35:00',4.94),('9650','2013-04-30','11:40:00',3.88),('9650','2013-04-30','11:45:00',3.82),('9650','2013-04-30','11:50:00',4.93),('9650','2013-04-30','11:55:00',5.79),('9650','2013-04-30','12:00:00',5.8),('9650','2013-04-30','12:05:00',5.8),('9650','2013-04-30','12:10:00',5.87),('9650','2013-04-30','12:15:00',5.83),('9650','2013-04-30','12:20:00',5.98),('9650','2013-04-30','12:25:00',6.07),('9650','2013-04-30','12:30:00',6.18),('9650','2013-04-30','12:35:00',6.32),('9650','2013-04-30','12:40:00',6.54),('9650','2013-04-30','12:45:00',6.05),('9650','2013-04-30','12:50:00',4.42),('9650','2013-04-30','12:55:00',2.56),('9650','2013-04-30','13:00:00',2.75),('9650','2013-04-30','13:05:00',3.11),('9650','2013-04-30','13:10:00',4.02),('9650','2013-04-30','13:15:00',7.02),('9650','2013-04-30','13:20:00',7.81),('9650','2013-04-30','13:25:00',6.56),('9650','2013-04-30','13:30:00',5.65),('9650','2013-04-30','13:35:00',6.44),('9650','2013-04-30','13:40:00',7.39),('9650','2013-04-30','13:45:00',7.43),('9650','2013-04-30','13:50:00',7.03),('9650','2013-04-30','13:55:00',6.84),('9650','2013-04-30','14:00:00',6.7),('9650','2013-04-30','14:05:00',6.61),('9650','2013-04-30','14:10:00',6.61),('9650','2013-04-30','14:15:00',5.75),('9650','2013-04-30','14:20:00',6.99),('9650','2013-04-30','14:25:00',7.07),('9650','2013-04-30','14:30:00',7.12),('9650','2013-04-30','14:35:00',6.8),('9650','2013-04-30','14:40:00',6.21),('9650','2013-04-30','14:45:00',6.37),('9650','2013-04-30','14:50:00',5.59),('9650','2013-04-30','14:55:00',5.09),('9650','2013-04-30','15:00:00',5.51),('9650','2013-04-30','15:05:00',6.31),('9650','2013-04-30','15:10:00',6.5),('9650','2013-04-30','15:15:00',6.24),('9650','2013-04-30','15:20:00',6.07),('9650','2013-04-30','15:25:00',6.14),('9650','2013-04-30','15:30:00',5.02),('9650','2013-04-30','15:35:00',4.43),('9650','2013-04-30','15:40:00',4.45),('9650','2013-04-30','15:45:00',4.36),('9650','2013-04-30','15:50:00',3.2),('9650','2013-04-30','15:55:00',3.16),('9650','2013-04-30','16:00:00',3.84),('9650','2013-04-30','16:05:00',3.72),('9650','2013-04-30','16:10:00',3.41),('9650','2013-04-30','16:15:00',3.16),('9650','2013-04-30','16:20:00',2.79),('9650','2013-04-30','16:25:00',2.21),('9650','2013-04-30','16:30:00',2),('9650','2013-04-30','16:35:00',2.08),('9650','2013-04-30','16:40:00',2.2),('9650','2013-04-30','16:45:00',2.06),('9650','2013-04-30','16:50:00',1.8),('9650','2013-04-30','16:55:00',1.65),('9650','2013-04-30','17:00:00',1.63),('9650','2013-04-30','17:05:00',1.63),('9650','2013-04-30','17:10:00',1.64),('9650','2013-04-30','17:15:00',1.61),('9650','2013-04-30','17:20:00',1.44),('9650','2013-04-30','17:25:00',1.21),('9650','2013-04-30','17:30:00',1.01),('9650','2013-04-29','08:25:00',1.02),('9650','2013-04-29','08:35:00',1.1),('9650','2013-04-29','08:40:00',1.5),('9650','2013-04-29','08:45:00',1.55),('9650','2013-04-29','08:50:00',1.74),('9650','2013-04-29','08:55:00',2.05),('9650','2013-04-29','09:00:00',2.11),('9650','2013-04-29','09:05:00',2.04),('9650','2013-04-29','09:10:00',2.7),('9650','2013-04-29','09:15:00',2.99),('9650','2013-04-29','09:20:00',3.19),('9650','2013-04-29','09:25:00',3.42),('9650','2013-04-29','09:30:00',3.35),('9650','2013-04-29','09:35:00',2.8),('9650','2013-04-29','09:40:00',2.14),('9650','2013-04-29','09:45:00',2.78),('9650','2013-04-29','09:50:00',3.36),('9650','2013-04-29','09:55:00',3.76),('9650','2013-04-29','10:00:00',4.42),('9650','2013-04-29','10:05:00',4.37),('9650','2013-04-29','10:10:00',3.91),('9650','2013-04-29','10:15:00',3.32),('9650','2013-04-29','10:20:00',3.17),('9650','2013-04-29','10:25:00',4.55),('9650','2013-04-29','10:30:00',3.45),('9650','2013-04-29','10:35:00',3.17),('9650','2013-04-29','10:40:00',2.89),('9650','2013-04-29','10:45:00',2.4),('9650','2013-04-29','10:50:00',2.59),('9650','2013-04-29','10:55:00',2.79),('9650','2013-04-29','11:00:00',2.91),('9650','2013-04-29','11:05:00',3.22),('9650','2013-04-29','11:10:00',3.25),('9650','2013-04-29','11:15:00',3.36),('9650','2013-04-29','11:20:00',3.82),('9650','2013-04-29','11:25:00',3.53),('9650','2013-04-29','11:30:00',3.57),('9650','2013-04-29','11:35:00',3.77),('9650','2013-04-29','11:40:00',3.46),('9650','2013-04-29','11:45:00',2.89),('9650','2013-04-29','11:50:00',2.89),('9650','2013-04-29','11:55:00',2.98),('9650','2013-04-29','12:00:00',3.08),('9650','2013-04-29','12:05:00',3.16),('9650','2013-04-29','12:10:00',3.05),('9650','2013-04-29','12:15:00',2.81),('9650','2013-04-29','12:20:00',2.61),('9650','2013-04-29','12:25:00',2.47),('9650','2013-04-29','12:30:00',2.51),('9650','2013-04-29','12:35:00',4.46),('9650','2013-04-29','12:40:00',6.91),('9650','2013-04-29','12:45:00',7.27),('9650','2013-04-29','12:50:00',6.9),('9650','2013-04-29','12:55:00',6.12),('9650','2013-04-29','13:00:00',6.66),('9650','2013-04-29','13:05:00',6.54),('9650','2013-04-29','13:10:00',6.59),('9650','2013-04-29','13:15:00',6.55),('9650','2013-04-29','13:20:00',6.52),('9650','2013-04-29','13:25:00',6.53),('9650','2013-04-29','13:30:00',6.54),('9650','2013-04-29','13:35:00',6.52),('9650','2013-04-29','13:40:00',6.53),('9650','2013-04-29','13:45:00',6.47),('9650','2013-04-29','13:50:00',6.48),('9650','2013-04-29','13:55:00',6.48),('9650','2013-04-29','14:00:00',6.46),('9650','2013-04-29','14:05:00',6.48),('9650','2013-04-29','14:10:00',6.48),('9650','2013-04-29','14:15:00',6.48),('9650','2013-04-29','14:20:00',6.45),('9650','2013-04-29','14:25:00',6.49),('9650','2013-04-29','14:30:00',6.49),('9650','2013-04-29','14:35:00',6.44),('9650','2013-04-29','14:40:00',6.42),('9650','2013-04-29','14:45:00',6.41),('9650','2013-04-29','14:50:00',6.35),('9650','2013-04-29','14:55:00',6.33),('9650','2013-04-29','15:00:00',6.28),('9650','2013-04-29','15:05:00',6.23),('9650','2013-04-29','15:10:00',6.2),('9650','2013-04-29','15:15:00',6.15),('9650','2013-04-29','15:20:00',6.11),('9650','2013-04-29','15:25:00',6),('9650','2013-04-29','15:30:00',5.99),('9650','2013-04-29','15:35:00',5.99),('9650','2013-04-29','15:40:00',5.91),('9650','2013-04-29','15:45:00',5.82),('9650','2013-04-29','15:50:00',5.72),('9650','2013-04-29','15:55:00',5.65),('9650','2013-04-29','16:00:00',5.57),('9650','2013-04-29','16:05:00',5.51),('9650','2013-04-29','16:10:00',5.44),('9650','2013-04-29','16:15:00',5.38),('9650','2013-04-29','16:20:00',5.29),('9650','2013-04-29','16:25:00',5.23),('9650','2013-04-29','16:30:00',5.16),('9650','2013-04-29','16:35:00',4.86),('9650','2013-04-29','16:40:00',4.18),('9650','2013-04-29','16:45:00',4.2),('9650','2013-04-29','16:50:00',3.94),('9650','2013-04-29','16:55:00',4.53),('9650','2013-04-29','17:00:00',4.31),('9650','2013-04-29','17:05:00',4.31),('9650','2013-04-29','17:10:00',3.61),('9650','2013-04-29','17:15:00',1.89),('9650','2013-04-29','17:20:00',3.3),('9650','2013-04-29','17:25:00',3.82),('9650','2013-04-29','17:30:00',3.66),('9650','2013-04-29','17:35:00',3.64),('9650','2013-04-29','17:40:00',3.48),('9650','2013-04-29','17:45:00',3.35),('9650','2013-04-29','17:50:00',3.19),('9650','2013-04-29','17:55:00',3.03),('9650','2013-04-29','18:00:00',2.89),('9650','2013-04-29','18:05:00',2.72),('9650','2013-04-29','18:10:00',2.58),('9650','2013-04-29','18:15:00',2.41),('9650','2013-04-29','18:20:00',2.24),('9650','2013-04-29','18:25:00',2.09),('9650','2013-04-29','18:30:00',1.92),('9650','2013-04-29','18:35:00',1.74),('9650','2013-04-29','18:40:00',1.57),('9650','2013-04-29','18:45:00',1.42),('9650','2013-04-29','18:50:00',1.28),('9650','2013-04-29','18:55:00',1.11),('9650','2013-04-28','07:45:00',1.03),('9650','2013-04-28','07:50:00',1.11),('9650','2013-04-28','07:55:00',1.2),('9650','2013-04-28','08:00:00',1.23),('9650','2013-04-28','08:05:00',1.22),('9650','2013-04-28','08:10:00',1.19),('9650','2013-04-28','08:15:00',1.22),('9650','2013-04-28','08:20:00',1.34),('9650','2013-04-28','08:25:00',1.65),('9650','2013-04-28','08:30:00',1.86),('9650','2013-04-28','08:35:00',2.06),('9650','2013-04-28','08:40:00',2.08),('9650','2013-04-28','08:45:00',2.1),('9650','2013-04-28','08:50:00',2.22),('9650','2013-04-28','08:55:00',2.24),('9650','2013-04-28','09:00:00',1.98),('9650','2013-04-28','09:05:00',2.56),('9650','2013-04-28','09:10:00',2.8),('9650','2013-04-28','09:15:00',2.93),('9650','2013-04-28','09:20:00',2.76),('9650','2013-04-28','09:25:00',2.76),('9650','2013-04-28','09:30:00',2.87),('9650','2013-04-28','09:35:00',3.07),('9650','2013-04-28','09:40:00',3.13),('9650','2013-04-28','09:45:00',3.23),('9650','2013-04-28','09:50:00',3.5),('9650','2013-04-28','09:55:00',3.36),('9650','2013-04-28','10:00:00',3.54),('9650','2013-04-28','10:05:00',3.54),('9650','2013-04-28','10:10:00',3.56),('9650','2013-04-28','10:15:00',2.96),('9650','2013-04-28','10:20:00',3.06),('9650','2013-04-28','10:25:00',3.6),('9650','2013-04-28','10:30:00',3.82),('9650','2013-04-28','10:35:00',4.34),('9650','2013-04-28','10:40:00',4.43),('9650','2013-04-28','10:45:00',4.56),('9650','2013-04-28','10:50:00',4.45),('9650','2013-04-28','10:55:00',4.21),('9650','2013-04-28','11:00:00',4.79),('9650','2013-04-28','11:05:00',4.55),('9650','2013-04-28','11:10:00',4.43),('9650','2013-04-28','11:15:00',4.23),('9650','2013-04-28','11:20:00',4.97),('9650','2013-04-28','11:25:00',5.09),('9650','2013-04-28','11:30:00',5.37),('9650','2013-04-28','11:35:00',5.13),('9650','2013-04-28','11:40:00',5.27),('9650','2013-04-28','11:45:00',4.97),('9650','2013-04-28','11:50:00',5.7),('9650','2013-04-28','11:55:00',5.65),('9650','2013-04-28','12:00:00',5.85),('9650','2013-04-28','12:05:00',5.81),('9650','2013-04-28','12:10:00',5.7),('9650','2013-04-28','12:15:00',5.86),('9650','2013-04-28','12:20:00',5.93),('9650','2013-04-28','12:25:00',5.8),('9650','2013-04-28','12:30:00',5.96),('9650','2013-04-28','12:35:00',6.06),('9650','2013-04-28','12:40:00',6.14),('9650','2013-04-28','12:45:00',6.26),('9650','2013-04-28','12:50:00',6.26),('9650','2013-04-28','12:55:00',6.29),('9650','2013-04-28','13:00:00',6.43),('9650','2013-04-28','13:05:00',6.33),('9650','2013-04-28','13:10:00',6.15),('9650','2013-04-28','13:15:00',5.56),('9650','2013-04-28','13:20:00',6.29),('9650','2013-04-28','13:25:00',6.46),('9650','2013-04-28','13:30:00',6.45),('9650','2013-04-28','13:35:00',6.28),('9650','2013-04-28','13:40:00',6.53),('9650','2013-04-28','13:45:00',6.53),('9650','2013-04-28','13:50:00',6.24),('9650','2013-04-28','13:55:00',7.07),('9650','2013-04-28','14:00:00',6.41),('9650','2013-04-28','14:05:00',6.3),('9650','2013-04-28','14:10:00',6.54),('9650','2013-04-28','14:15:00',6.77),('9650','2013-04-28','14:20:00',6.84),('9650','2013-04-28','14:25:00',6.56),('9650','2013-04-28','14:30:00',6.29),('9650','2013-04-28','14:35:00',6.26),('9650','2013-04-28','14:40:00',5.94),('9650','2013-04-28','14:45:00',6.48),('9650','2013-04-28','14:50:00',6.37),('9650','2013-04-28','14:55:00',6.45),('9650','2013-04-28','15:00:00',6.35),('9650','2013-04-28','15:05:00',6.64),('9650','2013-04-28','15:10:00',5.89),('9650','2013-04-28','15:15:00',5.85),('9650','2013-04-28','15:20:00',6.33),('9650','2013-04-28','15:25:00',6.59),('9650','2013-04-28','15:30:00',6.42),('9650','2013-04-28','15:35:00',5.56),('9650','2013-04-28','15:40:00',5.13),('9650','2013-04-28','15:45:00',5.04),('9650','2013-04-28','15:50:00',5.23),('9650','2013-04-28','15:55:00',5.57),('9650','2013-04-28','16:00:00',5.47),('9650','2013-04-28','16:05:00',5.9),('9650','2013-04-28','16:10:00',5.58),('9650','2013-04-28','16:15:00',6.66),('9650','2013-04-28','16:20:00',6.27),('9650','2013-04-28','16:25:00',4.87),('9650','2013-04-28','16:30:00',5.2),('9650','2013-04-28','16:35:00',5.29),('9650','2013-04-28','16:40:00',5.65),('9650','2013-04-28','16:45:00',5.74),('9650','2013-04-28','16:50:00',5.97),('9650','2013-04-28','16:55:00',6.26),('9650','2013-04-28','17:00:00',5.75),('9650','2013-04-28','17:05:00',4.99),('9650','2013-04-28','17:10:00',5.26),('9650','2013-04-28','17:15:00',4.48),('9650','2013-04-28','17:20:00',3.76),('9650','2013-04-28','17:25:00',3.56),('9650','2013-04-28','17:30:00',3.48),('9650','2013-04-28','17:35:00',3.23),('9650','2013-04-28','17:40:00',2.67),('9650','2013-04-28','17:45:00',2.41),('9650','2013-04-28','17:50:00',3.22),('9650','2013-04-28','17:55:00',3.82),('9650','2013-04-28','18:00:00',3.78),('9650','2013-04-28','18:05:00',4.39),('9650','2013-04-28','18:10:00',4.07),('9650','2013-04-28','18:15:00',3.93),('9650','2013-04-28','18:20:00',3.45),('9650','2013-04-28','18:25:00',3.53),('9650','2013-04-28','18:30:00',3.31),('9650','2013-04-28','18:35:00',2.51),('9650','2013-04-28','18:40:00',2.28),('9650','2013-04-28','18:45:00',1.81),('9650','2013-04-28','18:50:00',1.14),('9650','2013-04-27','08:20:00',1.08),('9650','2013-04-27','08:25:00',1.18),('9650','2013-04-27','08:30:00',1.24),('9650','2013-04-27','08:35:00',1.35),('9650','2013-04-27','08:40:00',1.47),('9650','2013-04-27','08:45:00',1.61),('9650','2013-04-27','08:50:00',1.72),('9650','2013-04-27','08:55:00',1.84),('9650','2013-04-27','09:00:00',1.97),('9650','2013-04-27','09:05:00',2.1),('9650','2013-04-27','09:10:00',2.21),('9650','2013-04-27','09:15:00',2.37),('9650','2013-04-27','09:20:00',2.51),('9650','2013-04-27','09:25:00',2.65),('9650','2013-04-27','09:30:00',2.8),('9650','2013-04-27','09:35:00',2.93),('9650','2013-04-27','09:40:00',3.06),('9650','2013-04-27','09:45:00',3.19),('9650','2013-04-27','09:50:00',3.34),('9650','2013-04-27','09:55:00',3.45),('9650','2013-04-27','10:00:00',3.58),('9650','2013-04-27','10:05:00',3.68),('9650','2013-04-27','10:10:00',3.81),('9650','2013-04-27','10:15:00',3.91),('9650','2013-04-27','10:20:00',4.04),('9650','2013-04-27','10:25:00',4.27),('9650','2013-04-27','10:30:00',4.25),('9650','2013-04-27','10:35:00',4.44),('9650','2013-04-27','10:40:00',4.09),('9650','2013-04-27','10:45:00',4.71),('9650','2013-04-27','10:50:00',4.79),('9650','2013-04-27','10:55:00',4.88),('9650','2013-04-27','11:00:00',5),('9650','2013-04-27','11:05:00',5.11),('9650','2013-04-27','11:10:00',5.25),('9650','2013-04-27','11:15:00',5.32),('9650','2013-04-27','11:20:00',5.38),('9650','2013-04-27','11:25:00',5.53),('9650','2013-04-27','11:30:00',5.56),('9650','2013-04-27','11:35:00',5.45),('9650','2013-04-27','11:40:00',5.65),('9650','2013-04-27','11:45:00',5.42),('9650','2013-04-27','11:50:00',5.55),('9650','2013-04-27','11:55:00',5.83),('9650','2013-04-27','12:00:00',5.22),('9650','2013-04-27','12:05:00',5.18),('9650','2013-04-27','12:10:00',5.77),('9650','2013-04-27','12:15:00',5.95),('9650','2013-04-27','12:20:00',5.61),('9650','2013-04-27','12:25:00',5.31),('9650','2013-04-27','12:30:00',5.1),('9650','2013-04-27','12:35:00',4.72),('9650','2013-04-27','12:40:00',4.82),('9650','2013-04-27','12:45:00',6.31),('9650','2013-04-27','12:50:00',6.37),('9650','2013-04-27','12:55:00',5.99),('9650','2013-04-27','13:00:00',6.25),('9650','2013-04-27','13:05:00',6.75),('9650','2013-04-27','13:10:00',6.67),('9650','2013-04-27','13:15:00',6.18),('9650','2013-04-27','13:20:00',6.31),('9650','2013-04-27','13:25:00',6.17),('9650','2013-04-27','13:30:00',6.64),('9650','2013-04-27','13:35:00',6.79),('9650','2013-04-27','13:40:00',5.62),('9650','2013-04-27','13:45:00',3.17),('9650','2013-04-27','13:50:00',3.04),('9650','2013-04-27','13:55:00',2.78),('9650','2013-04-27','14:00:00',5.19),('9650','2013-04-27','14:05:00',6.76),('9650','2013-04-27','14:10:00',6.92),('9650','2013-04-27','14:15:00',6.75),('9650','2013-04-27','14:20:00',5.88),('9650','2013-04-27','14:25:00',7.08),('9650','2013-04-27','14:30:00',6.66),('9650','2013-04-27','14:35:00',6.97),('9650','2013-04-27','14:40:00',6.9),('9650','2013-04-27','14:45:00',6.85),('9650','2013-04-27','14:50:00',6.77),('9650','2013-04-27','14:55:00',6.74),('9650','2013-04-27','15:00:00',6.71),('9650','2013-04-27','15:05:00',6.71),('9650','2013-04-27','15:10:00',6.71),('9650','2013-04-27','15:15:00',6.67),('9650','2013-04-27','15:20:00',6.62),('9650','2013-04-27','15:25:00',6.56),('9650','2013-04-27','15:30:00',6.52),('9650','2013-04-27','15:35:00',6.48),('9650','2013-04-27','15:40:00',6.43),('9650','2013-04-27','15:45:00',6.35),('9650','2013-04-27','15:50:00',6.3),('9650','2013-04-27','15:55:00',6.27),('9650','2013-04-27','16:00:00',6.22),('9650','2013-04-27','16:05:00',6.17),('9650','2013-04-27','16:10:00',6.12),('9650','2013-04-27','16:15:00',6.03),('9650','2013-04-27','16:20:00',5.95),('9650','2013-04-27','16:25:00',5.87),('9650','2013-04-27','16:30:00',5.79),('9650','2013-04-27','16:35:00',5.73),('9650','2013-04-27','16:40:00',5.62),('9650','2013-04-27','16:45:00',5.58),('9650','2013-04-27','16:50:00',5.49),('9650','2013-04-27','16:55:00',5.35),('9650','2013-04-27','17:00:00',5.23),('9650','2013-04-27','17:05:00',4.86),('9650','2013-04-27','17:10:00',4.75),('9650','2013-04-27','17:15:00',4.96),('9650','2013-04-27','17:20:00',4.78),('9650','2013-04-27','17:25:00',4.7),('9650','2013-04-27','17:30:00',4.08),('9650','2013-04-27','17:35:00',4.14),('9650','2013-04-27','17:40:00',3.93),('9650','2013-04-27','17:45:00',4.07),('9650','2013-04-27','17:50:00',3.92),('9650','2013-04-27','17:55:00',3.47),('9650','2013-04-27','18:00:00',3.52),('9650','2013-04-27','18:05:00',3.36),('9650','2013-04-27','18:10:00',2.13),('9650','2013-04-27','18:15:00',2.09),('9650','2013-04-27','18:20:00',2.82),('9650','2013-04-27','18:25:00',2.81),('9650','2013-04-27','18:30:00',2.19),('9650','2013-04-27','18:35:00',2.11),('9650','2013-04-27','18:40:00',2.06),('9650','2013-04-27','18:45:00',1.66),('9650','2013-04-27','18:50:00',1.65),('9650','2013-04-27','18:55:00',1.47),('9650','2013-04-27','19:00:00',1.32),('9650','2013-04-27','19:05:00',1.22),('9650','2013-04-27','19:10:00',1.14),('9650','2013-04-26','11:50:00',1.18),('9650','2013-04-26','11:55:00',1.23),('9650','2013-04-26','12:00:00',1.31),('9650','2013-04-26','12:05:00',1.28),('9650','2013-04-26','12:10:00',1.13),('9650','2013-04-26','12:15:00',1.04),('9650','2013-04-26','12:30:00',1.1),('9650','2013-04-26','12:35:00',1.2),('9650','2013-04-26','12:40:00',1.49),('9650','2013-04-26','12:45:00',1.6),('9650','2013-04-26','12:50:00',1.85),('9650','2013-04-26','12:55:00',2.38),('9650','2013-04-26','13:00:00',2.61),('9650','2013-04-26','13:05:00',1.98),('9650','2013-04-26','13:10:00',2.21),('9650','2013-04-26','13:15:00',2.76),('9650','2013-04-26','13:20:00',2.94),('9650','2013-04-26','13:25:00',2.1),('9650','2013-04-26','13:30:00',2.14),('9650','2013-04-26','13:35:00',2.68),('9650','2013-04-26','13:40:00',2.88),('9650','2013-04-26','13:45:00',2.01),('9650','2013-04-26','13:50:00',2.01),('9650','2013-04-26','13:55:00',1.39),('9650','2013-04-26','14:05:00',1.07),('9650','2013-04-26','14:25:00',2.03),('9650','2013-04-26','14:30:00',3.7),('9650','2013-04-26','14:35:00',3.34),('9650','2013-04-26','14:40:00',2.29),('9650','2013-04-26','14:45:00',2.05),('9650','2013-04-26','14:50:00',1.16),('9650','2013-04-26','14:55:00',1.4),('9650','2013-04-26','15:00:00',1.66),('9650','2013-04-26','15:05:00',2.82),('9650','2013-04-26','15:10:00',2.27),('9650','2013-04-26','15:15:00',1.71),('9650','2013-04-26','15:20:00',1.08),('9650','2013-04-26','15:50:00',1.54),('9650','2013-04-26','16:40:00',1.77),('9650','2013-04-26','16:45:00',2.47),('9650','2013-04-26','16:50:00',3.9),('9650','2013-04-26','16:55:00',4),('9650','2013-04-26','17:00:00',5.52),('9650','2013-04-26','17:05:00',3.26),('9650','2013-04-26','17:10:00',1.42),('9650','2013-04-26','17:15:00',1.02),('9650','2013-04-26','17:20:00',2),('9650','2013-04-26','17:25:00',1.08),('9650','2013-04-26','17:35:00',1.54),('9650','2013-04-26','17:40:00',2.46),('9650','2013-04-26','17:45:00',2.52),('9650','2013-04-26','17:50:00',1.09),('9650','2013-04-25','08:10:00',1.08),('9650','2013-04-25','08:15:00',1.14),('9650','2013-04-25','08:20:00',1.18),('9650','2013-04-25','08:25:00',1.23),('9650','2013-04-25','08:30:00',1.26),('9650','2013-04-25','08:35:00',1.37),('9650','2013-04-25','08:40:00',1.6),('9650','2013-04-25','08:45:00',1.71),('9650','2013-04-25','08:50:00',1.65),('9650','2013-04-25','08:55:00',1.61),('9650','2013-04-25','09:00:00',1.66),('9650','2013-04-25','09:05:00',2.11),('9650','2013-04-25','09:10:00',2.17),('9650','2013-04-25','09:15:00',1.77),('9650','2013-04-25','09:20:00',1.73),('9650','2013-04-25','09:25:00',2.08),('9650','2013-04-25','09:30:00',2.43),('9650','2013-04-25','09:35:00',2.18),('9650','2013-04-25','09:40:00',2.22),('9650','2013-04-25','09:45:00',2.84),('9650','2013-04-25','09:50:00',3.12),('9650','2013-04-25','09:55:00',2.25),('9650','2013-04-25','10:00:00',2.9),('9650','2013-04-25','10:05:00',3.57),('9650','2013-04-25','10:10:00',3.64),('9650','2013-04-25','10:15:00',3.97),('9650','2013-04-25','10:20:00',3.9),('9650','2013-04-25','10:25:00',3.85),('9650','2013-04-25','10:30:00',4.24),('9650','2013-04-25','10:35:00',4.56),('9650','2013-04-25','10:40:00',4.45),('9650','2013-04-25','10:45:00',4.51),('9650','2013-04-25','10:50:00',3.65),('9650','2013-04-25','10:55:00',2.57),('9650','2013-04-25','11:00:00',4.48),('9650','2013-04-25','11:05:00',4.57),('9650','2013-04-25','11:10:00',4.44),('9650','2013-04-25','11:15:00',4.35),('9650','2013-04-25','11:20:00',3.42),('9650','2013-04-25','11:25:00',4.31),('9650','2013-04-25','11:30:00',4.51),('9650','2013-04-25','11:35:00',5.2),('9650','2013-04-25','11:40:00',4.83),('9650','2013-04-25','11:45:00',4.82),('9650','2013-04-25','11:50:00',4.07),('9650','2013-04-25','11:55:00',4),('9650','2013-04-25','12:00:00',4.5),('9650','2013-04-25','12:05:00',4.37),('9650','2013-04-25','12:10:00',3.93),('9650','2013-04-25','12:15:00',4.66),('9650','2013-04-25','12:20:00',4.24),('9650','2013-04-25','12:25:00',3.1),('9650','2013-04-25','12:30:00',3.05),('9650','2013-04-25','12:35:00',3.83),('9650','2013-04-25','12:40:00',5.05),('9650','2013-04-25','12:45:00',4.95),('9650','2013-04-25','12:50:00',3.5),('9650','2013-04-25','12:55:00',3.17),('9650','2013-04-25','13:00:00',2.32),('9650','2013-04-25','13:05:00',2.24),('9650','2013-04-25','13:10:00',2.77),('9650','2013-04-25','13:15:00',4.08),('9650','2013-04-25','13:20:00',3.02),('9650','2013-04-25','13:25:00',3.56),('9650','2013-04-25','13:30:00',4.87),('9650','2013-04-25','13:35:00',4.1),('9650','2013-04-25','13:40:00',4.56),('9650','2013-04-25','13:45:00',3.77),('9650','2013-04-25','13:50:00',5.64),('9650','2013-04-25','13:55:00',4.07),('9650','2013-04-25','14:00:00',5.2),('9650','2013-04-25','14:05:00',6.3),('9650','2013-04-25','14:10:00',5.24),('9650','2013-04-25','14:15:00',5.49),('9650','2013-04-25','14:20:00',6.36),('9650','2013-04-25','14:25:00',6.81),('9650','2013-04-25','14:30:00',6.46),('9650','2013-04-25','14:35:00',4.65),('9650','2013-04-25','14:40:00',2.97),('9650','2013-04-25','14:45:00',2.71),('9650','2013-04-25','14:50:00',6.71),('9650','2013-04-25','14:55:00',7.26),('9650','2013-04-25','15:00:00',6.67),('9650','2013-04-25','15:05:00',3.96),('9650','2013-04-25','15:10:00',2.6),('9650','2013-04-25','15:15:00',3.78),('9650','2013-04-25','15:20:00',2.58),('9650','2013-04-25','15:25:00',2.81),('9650','2013-04-25','15:30:00',3.85),('9650','2013-04-25','15:35:00',3.4),('9650','2013-04-25','15:40:00',3.57),('9650','2013-04-25','15:45:00',4.11),('9650','2013-04-25','15:50:00',3.32),('9650','2013-04-25','15:55:00',1.88),('9650','2013-04-24','07:50:00',1.03),('9650','2013-04-24','07:55:00',1.14),('9650','2013-04-24','08:00:00',1.25),('9650','2013-04-24','08:05:00',1.38),('9650','2013-04-24','08:10:00',1.41),('9650','2013-04-24','08:15:00',1.5),('9650','2013-04-24','08:20:00',1.36),('9650','2013-04-24','08:25:00',1.32),('9650','2013-04-24','08:30:00',1.4),('9650','2013-04-24','08:35:00',1.52),('9650','2013-04-24','08:40:00',1.64),('9650','2013-04-24','08:45:00',1.93),('9650','2013-04-24','08:50:00',2.39),('9650','2013-04-24','08:55:00',2.56),('9650','2013-04-24','09:00:00',2.25),('9650','2013-04-24','09:05:00',1.9),('9650','2013-04-24','09:10:00',1.86),('9650','2013-04-24','09:15:00',1.71),('9650','2013-04-24','09:20:00',1.77),('9650','2013-04-24','09:25:00',1.88),('9650','2013-04-24','09:30:00',1.76),('9650','2013-04-24','09:35:00',1.95),('9650','2013-04-24','09:40:00',2.55),('9650','2013-04-24','09:45:00',3.04),('9650','2013-04-24','09:50:00',3.48),('9650','2013-04-24','09:55:00',3.58),('9650','2013-04-24','10:00:00',3.65),('9650','2013-04-24','10:05:00',3.49),('9650','2013-04-24','10:10:00',3.25),('9650','2013-04-24','10:15:00',3.44),('9650','2013-04-24','10:20:00',3.87),('9650','2013-04-24','10:25:00',4.07),('9650','2013-04-24','10:30:00',4.31),('9650','2013-04-24','10:35:00',4.39),('9650','2013-04-24','10:40:00',4.43),('9650','2013-04-24','10:45:00',4.24),('9650','2013-04-24','10:50:00',4.62),('9650','2013-04-24','10:55:00',4.59),('9650','2013-04-24','11:00:00',4.87),('9650','2013-04-24','11:05:00',4.92),('9650','2013-04-24','11:10:00',5.07),('9650','2013-04-24','11:15:00',5.17),('9650','2013-04-24','11:20:00',5.27),('9650','2013-04-24','11:25:00',5.34),('9650','2013-04-24','11:30:00',5.45),('9650','2013-04-24','11:35:00',5.46),('9650','2013-04-24','11:40:00',5.66),('9650','2013-04-24','11:45:00',5.74),('9650','2013-04-24','11:50:00',5.81),('9650','2013-04-24','11:55:00',5.79),('9650','2013-04-24','12:00:00',5.73),('9650','2013-04-24','12:05:00',5.81),('9650','2013-04-24','12:10:00',6),('9650','2013-04-24','12:15:00',6.1),('9650','2013-04-24','12:20:00',6.14),('9650','2013-04-24','12:25:00',6.14),('9650','2013-04-24','12:30:00',6.22),('9650','2013-04-24','12:35:00',6.3),('9650','2013-04-24','12:40:00',6.35),('9650','2013-04-24','12:45:00',6.41),('9650','2013-04-24','12:50:00',6.41),('9650','2013-04-24','12:55:00',6.5),('9650','2013-04-24','13:00:00',6.62),('9650','2013-04-24','13:05:00',6.8),('9650','2013-04-24','13:10:00',6.22),('9650','2013-04-24','13:15:00',6.5),('9650','2013-04-24','13:20:00',6.16),('9650','2013-04-24','13:25:00',6.03),('9650','2013-04-24','13:30:00',4.58),('9650','2013-04-24','13:35:00',4.49),('9650','2013-04-24','13:40:00',4.07),('9650','2013-04-24','13:45:00',3.83),('9650','2013-04-24','13:50:00',3.64),('9650','2013-04-24','13:55:00',3.96),('9650','2013-04-24','14:00:00',4.04),('9650','2013-04-24','14:05:00',3.75),('9650','2013-04-24','14:10:00',4.06),('9650','2013-04-24','14:15:00',4.32),('9650','2013-04-24','14:20:00',4.42),('9650','2013-04-24','14:25:00',4.63),('9650','2013-04-24','14:30:00',5.49),('9650','2013-04-24','14:35:00',6.12),('9650','2013-04-24','14:40:00',5.91),('9650','2013-04-24','14:45:00',6.1),('9650','2013-04-24','14:50:00',5.52),('9650','2013-04-24','14:55:00',5.79),('9650','2013-04-24','15:00:00',5.61),('9650','2013-04-24','15:05:00',5.1),('9650','2013-04-24','15:10:00',5.11),('9650','2013-04-24','15:15:00',5.87),('9650','2013-04-24','15:20:00',6.34),('9650','2013-04-24','15:25:00',6.57),('9650','2013-04-24','15:30:00',6.4),('9650','2013-04-24','15:35:00',6.07),('9650','2013-04-24','15:40:00',5.61),('9650','2013-04-24','15:45:00',5.4),('9650','2013-04-24','15:50:00',5.06),('9650','2013-04-24','15:55:00',4.85),('9650','2013-04-24','16:00:00',5.08),('9650','2013-04-24','16:05:00',4.23),('9650','2013-04-24','16:10:00',4.24),('9650','2013-04-24','16:15:00',4.17),('9650','2013-04-24','16:20:00',4.46),('9650','2013-04-24','16:25:00',3.89),('9650','2013-04-24','16:30:00',3.87),('9650','2013-04-24','16:35:00',4.66),('9650','2013-04-24','16:40:00',4.09),('9650','2013-04-24','16:45:00',4.27),('9650','2013-04-24','16:50:00',3.57),('9650','2013-04-24','16:55:00',3.85),('9650','2013-04-24','17:00:00',3.64),('9650','2013-04-24','17:05:00',4.67),('9650','2013-04-24','17:10:00',5.07),('9650','2013-04-24','17:15:00',4.69),('9650','2013-04-24','17:20:00',4.71),('9650','2013-04-24','17:25:00',3.91),('9650','2013-04-24','17:30:00',3.1),('9650','2013-04-24','17:35:00',2.96),('9650','2013-04-24','17:40:00',3.1),('9650','2013-04-24','17:45:00',2.62),('9650','2013-04-24','17:50:00',2.12),('9650','2013-04-24','17:55:00',1.83),('9650','2013-04-24','18:00:00',1.77),('9650','2013-04-24','18:05:00',1.64),('9650','2013-04-24','18:10:00',1.47),('9650','2013-04-24','18:15:00',1.3),('9650','2013-04-24','18:20:00',1.16),('9650','2013-04-24','18:25:00',1.03),('9650','2013-04-23','08:20:00',1.05),('9650','2013-04-23','08:25:00',1.13),('9650','2013-04-23','08:30:00',1.17),('9650','2013-04-23','08:35:00',1.2),('9650','2013-04-23','08:40:00',1.26),('9650','2013-04-23','08:45:00',1.35),('9650','2013-04-23','08:50:00',1.49),('9650','2013-04-23','08:55:00',1.63),('9650','2013-04-23','09:00:00',1.89),('9650','2013-04-23','09:05:00',2.16),('9650','2013-04-23','09:10:00',2.39),('9650','2013-04-23','09:15:00',2.53),('9650','2013-04-23','09:20:00',2.48),('9650','2013-04-23','09:25:00',3.02),('9650','2013-04-23','09:30:00',3.13),('9650','2013-04-23','09:35:00',3.38),('9650','2013-04-23','09:40:00',3.3),('9650','2013-04-23','09:45:00',3.23),('9650','2013-04-23','09:50:00',3.45),('9650','2013-04-23','09:55:00',3.73),('9650','2013-04-23','10:00:00',3.79),('9650','2013-04-23','10:05:00',3.93),('9650','2013-04-23','10:10:00',4.04),('9650','2013-04-23','10:15:00',4.03),('9650','2013-04-23','10:20:00',3.98),('9650','2013-04-23','10:25:00',3.98),('9650','2013-04-23','10:30:00',3.97),('9650','2013-04-23','10:35:00',4.03),('9650','2013-04-23','10:40:00',4.49),('9650','2013-04-23','10:45:00',4.57),('9650','2013-04-23','10:50:00',4.71),('9650','2013-04-23','10:55:00',4.89),('9650','2013-04-23','11:00:00',4.94),('9650','2013-04-23','11:05:00',4.89),('9650','2013-04-23','11:10:00',5.35),('9650','2013-04-23','11:15:00',5.47),('9650','2013-04-23','11:20:00',5.7),('9650','2013-04-23','11:25:00',5.78),('9650','2013-04-23','11:30:00',5.64),('9650','2013-04-23','11:35:00',5.18),('9650','2013-04-23','11:40:00',3.98),('9650','2013-04-23','11:45:00',4.09),('9650','2013-04-23','11:50:00',3.2),('9650','2013-04-23','11:55:00',4.56),('9650','2013-04-23','12:00:00',5.24),('9650','2013-04-23','12:05:00',3.73),('9650','2013-04-23','12:10:00',4.47),('9650','2013-04-23','12:15:00',6.07),('9650','2013-04-23','12:20:00',7.05),('9650','2013-04-23','12:25:00',6.07),('9650','2013-04-23','12:30:00',6.02),('9650','2013-04-23','12:35:00',6.26),('9650','2013-04-23','12:40:00',5.93),('9650','2013-04-23','12:45:00',6.22),('9650','2013-04-23','12:50:00',6.58),('9650','2013-04-23','12:55:00',6.39),('9650','2013-04-23','13:00:00',6.26),('9650','2013-04-23','13:05:00',5.55),('9650','2013-04-23','13:10:00',7.19),('9650','2013-04-23','13:15:00',6.66),('9650','2013-04-23','13:20:00',6.31),('9650','2013-04-23','13:25:00',6.65),('9650','2013-04-23','13:30:00',6.12),('9650','2013-04-23','13:35:00',6.41),('9650','2013-04-23','13:40:00',7.33),('9650','2013-04-23','13:45:00',6.16),('9650','2013-04-23','13:50:00',4.75),('9650','2013-04-23','13:55:00',7.12),('9650','2013-04-23','14:00:00',6.91),('9650','2013-04-23','14:05:00',4.99),('9650','2013-04-23','14:10:00',5.1),('9650','2013-04-23','14:15:00',7.03),('9650','2013-04-23','14:20:00',6.45),('9650','2013-04-23','14:25:00',6.65),('9650','2013-04-23','14:30:00',6.22),('9650','2013-04-23','14:35:00',5.67),('9650','2013-04-23','14:40:00',5.26),('9650','2013-04-23','14:45:00',5.28),('9650','2013-04-23','14:50:00',4.69),('9650','2013-04-23','14:55:00',4.15),('9650','2013-04-23','15:00:00',4.64),('9650','2013-04-23','15:05:00',4.19),('9650','2013-04-23','15:10:00',3.93),('9650','2013-04-23','15:15:00',4.14),('9650','2013-04-23','15:20:00',4.28),('9650','2013-04-23','15:25:00',3.61),('9650','2013-04-23','15:30:00',3.17),('9650','2013-04-23','15:35:00',3.08),('9650','2013-04-23','15:40:00',3.06),('9650','2013-04-23','15:45:00',3.08),('9650','2013-04-23','15:50:00',3.13),('9650','2013-04-23','15:55:00',4.03),('9650','2013-04-23','16:00:00',5.04),('9650','2013-04-23','16:05:00',5.39),('9650','2013-04-23','16:10:00',5.39),('9650','2013-04-23','16:15:00',5.04),('9650','2013-04-23','16:20:00',6.66),('9650','2013-04-23','16:25:00',4.92),('9650','2013-04-23','16:30:00',4.35),('9650','2013-04-23','16:35:00',3.85),('9650','2013-04-23','16:40:00',5.21),('9650','2013-04-23','16:45:00',5.37),('9650','2013-04-23','16:50:00',4.88),('9650','2013-04-23','16:55:00',5.95),('9650','2013-04-23','17:00:00',5.93),('9650','2013-04-23','17:05:00',5.73),('9650','2013-04-23','17:10:00',5.5),('9650','2013-04-23','17:15:00',4),('9650','2013-04-23','17:20:00',4.03),('9650','2013-04-23','17:25:00',3.57),('9650','2013-04-23','17:30:00',2.19),('9650','2013-04-23','17:35:00',1.74),('9650','2013-04-23','17:40:00',1.53),('9650','2013-04-23','17:45:00',2.1),('9650','2013-04-23','17:50:00',2.66),('9650','2013-04-23','17:55:00',3.72),('9650','2013-04-23','18:00:00',2.78),('9650','2013-04-23','18:05:00',3.02),('9650','2013-04-23','18:10:00',2.34),('9650','2013-04-23','18:15:00',1.55),('9650','2013-04-23','18:20:00',2.69),('9650','2013-04-23','18:25:00',2.52),('9650','2013-04-23','18:30:00',1.71),('9650','2013-04-23','18:35:00',1.22),('9650','2013-04-23','18:40:00',1.42),('9650','2013-04-23','18:45:00',1.13),('9650','2013-04-23','18:50:00',1.08),('9650','2013-04-22','08:25:00',1.02),('9650','2013-04-22','08:30:00',1.12),('9650','2013-04-22','08:35:00',1.22),('9650','2013-04-22','08:40:00',1.32),('9650','2013-04-22','08:45:00',1.42),('9650','2013-04-22','08:50:00',1.54),('9650','2013-04-22','08:55:00',1.67),('9650','2013-04-22','09:00:00',1.82),('9650','2013-04-22','09:05:00',1.95),('9650','2013-04-22','09:10:00',2.07),('9650','2013-04-22','09:15:00',2.24),('9650','2013-04-22','09:20:00',2.4),('9650','2013-04-22','09:25:00',2.57),('9650','2013-04-22','09:30:00',2.72),('9650','2013-04-22','09:35:00',2.87),('9650','2013-04-22','09:40:00',2.8),('9650','2013-04-22','09:45:00',2.81),('9650','2013-04-22','09:50:00',3.41),('9650','2013-04-22','09:55:00',3.51),('9650','2013-04-22','10:00:00',3.63),('9650','2013-04-22','10:05:00',3.73),('9650','2013-04-22','10:10:00',3.84),('9650','2013-04-22','10:15:00',3.95),('9650','2013-04-22','10:20:00',4.07),('9650','2013-04-22','10:25:00',4.21),('9650','2013-04-22','10:30:00',4.36),('9650','2013-04-22','10:35:00',4.47),('9650','2013-04-22','10:40:00',4.6),('9650','2013-04-22','10:45:00',4.63),('9650','2013-04-22','10:50:00',4.85),('9650','2013-04-22','10:55:00',4.98),('9650','2013-04-22','11:00:00',5.04),('9650','2013-04-22','11:05:00',5.13),('9650','2013-04-22','11:10:00',5.22),('9650','2013-04-22','11:15:00',5.33),('9650','2013-04-22','11:20:00',5.44),('9650','2013-04-22','11:25:00',5.53),('9650','2013-04-22','11:30:00',5.62),('9650','2013-04-22','11:35:00',5.72),('9650','2013-04-22','11:40:00',5.79),('9650','2013-04-22','11:45:00',5.87),('9650','2013-04-22','11:50:00',5.9),('9650','2013-04-22','11:55:00',5.96),('9650','2013-04-22','12:00:00',6.03),('9650','2013-04-22','12:05:00',6.07),('9650','2013-04-22','12:10:00',6.18),('9650','2013-04-22','12:15:00',6.19),('9650','2013-04-22','12:20:00',6.27),('9650','2013-04-22','12:25:00',6.35),('9650','2013-04-22','12:30:00',6.69),('9650','2013-04-22','12:35:00',7.19),('9650','2013-04-22','12:40:00',7.53),('9650','2013-04-22','12:45:00',6.22),('9650','2013-04-22','12:50:00',2.7),('9650','2013-04-22','12:55:00',7.87),('9650','2013-04-22','13:00:00',7.55),('9650','2013-04-22','13:05:00',6.24),('9650','2013-04-22','13:10:00',2.37),('9650','2013-04-22','13:15:00',5.18),('9650','2013-04-22','13:20:00',7.86),('9650','2013-04-22','13:25:00',7.4),('9650','2013-04-22','13:30:00',7.17),('9650','2013-04-22','13:35:00',7.49),('9650','2013-04-22','13:40:00',7.43),('9650','2013-04-22','13:45:00',5.14),('9650','2013-04-22','13:50:00',6.46),('9650','2013-04-22','13:55:00',7.28),('9650','2013-04-22','14:00:00',4.62),('9650','2013-04-22','14:05:00',7.86),('9650','2013-04-22','14:10:00',6.98),('9650','2013-04-22','14:15:00',6.8),('9650','2013-04-22','14:20:00',6.73),('9650','2013-04-22','14:25:00',6.23),('9650','2013-04-22','14:30:00',7.36),('9650','2013-04-22','14:35:00',7.19),('9650','2013-04-22','14:40:00',7.12),('9650','2013-04-22','14:45:00',6),('9650','2013-04-22','14:50:00',3.59),('9650','2013-04-22','14:55:00',3.91),('9650','2013-04-22','15:00:00',4.1),('9650','2013-04-22','15:05:00',4.43),('9650','2013-04-22','15:10:00',5.62),('9650','2013-04-22','15:15:00',5.52),('9650','2013-04-22','15:20:00',4.96),('9650','2013-04-22','15:25:00',4.57),('9650','2013-04-22','15:30:00',4.58),('9650','2013-04-22','15:35:00',4.26),('9650','2013-04-22','15:40:00',4.26),('9650','2013-04-22','15:45:00',4.51),('9650','2013-04-22','15:50:00',3.81),('9650','2013-04-22','15:55:00',3.08),('9650','2013-04-22','16:00:00',3.6),('9650','2013-04-22','16:05:00',4.22),('9650','2013-04-22','16:10:00',4.24),('9650','2013-04-22','16:15:00',4.08),('9650','2013-04-22','16:20:00',2.52),('9650','2013-04-22','16:25:00',2.61),('9650','2013-04-22','16:30:00',2.23),('9650','2013-04-22','16:35:00',2.07),('9650','2013-04-22','16:40:00',2.02),('9650','2013-04-22','16:45:00',2.29),('9650','2013-04-22','16:50:00',1.96),('9650','2013-04-22','16:55:00',2.03),('9650','2013-04-22','17:00:00',2.14),('9650','2013-04-22','17:05:00',2.22),('9650','2013-04-22','17:10:00',4.17),('9650','2013-04-22','17:15:00',2.6),('9650','2013-04-22','17:20:00',2.02),('9650','2013-04-22','17:25:00',3.83),('9650','2013-04-22','17:30:00',3.52),('9650','2013-04-22','17:35:00',2.54),('9650','2013-04-22','17:40:00',1.81),('9650','2013-04-22','17:45:00',1.94),('9650','2013-04-22','17:50:00',1.59),('9650','2013-04-22','17:55:00',1.31),('9650','2013-04-22','18:00:00',1.37),('9650','2013-04-22','18:05:00',1.44),('9650','2013-04-22','18:10:00',1.13),('9650','2013-04-22','18:15:00',1.19),('9650','2013-04-22','18:20:00',1.14),('9650','2013-04-22','18:25:00',1.47),('9650','2013-04-22','18:30:00',1.48),('9650','2013-04-22','18:35:00',1.13),('9650','2013-04-22','18:40:00',1.37),('9650','2013-04-22','18:50:00',1.03),('9650','2013-04-22','18:55:00',1.24),('9650','2013-04-22','19:00:00',1.1),('9650','2013-04-21','08:45:00',1.04),('9650','2013-04-21','09:00:00',1.28),('9650','2013-04-21','09:05:00',1.34),('9650','2013-04-21','09:10:00',1.44),('9650','2013-04-21','09:15:00',1.27),('9650','2013-04-21','09:20:00',1.22),('9650','2013-04-21','09:25:00',1.45),('9650','2013-04-21','09:30:00',2.11),('9650','2013-04-21','09:35:00',1.95),('9650','2013-04-21','09:40:00',1.56),('9650','2013-04-21','09:45:00',1.17),('9650','2013-04-21','10:35:00',2.48),('9650','2013-04-21','10:40:00',4.11),('9650','2013-04-21','10:45:00',6.21),('9650','2013-04-21','10:50:00',3.67),('9650','2013-04-21','10:55:00',3.97),('9650','2013-04-21','11:00:00',3.59),('9650','2013-04-21','11:05:00',3.04),('9650','2013-04-21','11:10:00',3.9),('9650','2013-04-21','11:15:00',2.37),('9650','2013-04-21','11:20:00',2.5),('9650','2013-04-21','11:25:00',3.23),('9650','2013-04-21','11:30:00',5.03),('9650','2013-04-21','11:35:00',5.89),('9650','2013-04-21','11:40:00',5.67),('9650','2013-04-21','11:45:00',3.43),('9650','2013-04-21','11:50:00',2.65),('9650','2013-04-21','11:55:00',5.48),('9650','2013-04-21','12:00:00',6.18),('9650','2013-04-21','12:05:00',5.83),('9650','2013-04-21','12:10:00',3.3),('9650','2013-04-21','12:15:00',4.39),('9650','2013-04-21','12:20:00',4.49),('9650','2013-04-21','12:25:00',3.38),('9650','2013-04-21','12:30:00',3.13),('9650','2013-04-21','12:35:00',3.3),('9650','2013-04-21','12:40:00',5.83),('9650','2013-04-21','12:45:00',5.61),('9650','2013-04-21','12:50:00',7.27),('9650','2013-04-21','12:55:00',7.35),('9650','2013-04-21','13:00:00',7.15),('9650','2013-04-21','13:05:00',5.77),('9650','2013-04-21','13:10:00',5.49),('9650','2013-04-21','13:15:00',6.22),('9650','2013-04-21','13:20:00',8.42),('9650','2013-04-21','13:25:00',5.76),('9650','2013-04-21','13:30:00',2.75),('9650','2013-04-21','13:35:00',3.96),('9650','2013-04-21','13:40:00',4.74),('9650','2013-04-21','13:45:00',2.92),('9650','2013-04-21','13:50:00',1.96),('9650','2013-04-21','13:55:00',4.39),('9650','2013-04-21','14:00:00',2.03),('9650','2013-04-21','14:05:00',4.01),('9650','2013-04-21','14:10:00',4.54),('9650','2013-04-21','14:15:00',7.39),('9650','2013-04-21','14:20:00',8.91),('9650','2013-04-21','14:25:00',5.12),('9650','2013-04-21','14:30:00',8.09),('9650','2013-04-21','14:35:00',4.2),('9650','2013-04-21','14:40:00',8.28),('9650','2013-04-21','14:45:00',7.14),('9650','2013-04-21','14:50:00',8.05),('9650','2013-04-21','14:55:00',6.75),('9650','2013-04-21','15:00:00',2.93),('9650','2013-04-21','15:05:00',3.22),('9650','2013-04-21','15:10:00',2.81),('9650','2013-04-21','15:15:00',2.11),('9650','2013-04-21','15:20:00',3.97),('9650','2013-04-21','15:25:00',7.79),('9650','2013-04-21','15:30:00',2.42),('9650','2013-04-21','15:35:00',2.77),('9650','2013-04-21','15:40:00',4.79),('9650','2013-04-21','15:45:00',7.36),('9650','2013-04-21','15:50:00',5.03),('9650','2013-04-21','15:55:00',2.59),('9650','2013-04-21','16:00:00',1.4),('9650','2013-04-21','16:05:00',1.44),('9650','2013-04-21','16:10:00',1.38),('9650','2013-04-21','16:15:00',1.26),('9650','2013-04-21','16:20:00',1.12),('9650','2013-04-21','16:35:00',1.04),('9650','2013-04-21','16:40:00',1.29),('9650','2013-04-21','16:45:00',2.03),('9650','2013-04-21','16:50:00',1.84),('9650','2013-04-21','16:55:00',1.19),('9650','2013-04-21','17:00:00',1.03),('9650','2013-04-21','17:05:00',1.02),('9650','2013-04-21','17:10:00',1.13),('9650','2013-04-21','17:25:00',1.17),('9650','2013-04-21','17:30:00',1.55),('9650','2013-04-21','17:35:00',1.64),('9650','2013-04-21','17:40:00',1.3),('9650','2013-04-21','18:05:00',1.29),('9650','2013-04-21','18:10:00',1.1),('9650','2013-04-21','18:15:00',1.05),('9650','2013-04-21','18:20:00',1.54),('9650','2013-04-21','18:25:00',1.71),('9650','2013-04-21','18:45:00',1.77),('9650','2013-04-21','18:50:00',2.57),('9650','2013-04-21','18:55:00',1.35),('9650','2013-04-21','19:00:00',2.12),('9650','2013-04-21','19:05:00',1.92),('9650','2013-04-21','19:10:00',1.62),('9650','2013-04-21','19:15:00',1.31),('9650','2013-04-21','19:20:00',1.05),('9650','2014-03-28','08:10:00',1.03),('9650','2014-03-28','08:15:00',1.13),('9650','2014-03-28','08:20:00',1.21),('9650','2014-03-28','08:25:00',1.33),('9650','2014-03-28','08:30:00',1.43),('9650','2014-03-28','08:35:00',1.55),('9650','2014-03-28','08:40:00',1.68),('9650','2014-03-28','08:45:00',1.8),('9650','2014-03-28','08:50:00',1.94),('9650','2014-03-28','08:55:00',2.07),('9650','2014-03-28','09:00:00',2.18),('9650','2014-03-28','09:05:00',2.32),('9650','2014-03-28','09:10:00',2.47),('9650','2014-03-28','09:15:00',2.62),('9650','2014-03-28','09:20:00',2.77),('9650','2014-03-28','09:25:00',2.89),('9650','2014-03-28','09:30:00',3.01),('9650','2014-03-28','09:35:00',3.12),('9650','2014-03-28','09:40:00',3.28),('9650','2014-03-28','09:45:00',3.38),('9650','2014-03-28','09:50:00',3.53),('9650','2014-03-28','09:55:00',3.67),('9650','2014-03-28','10:00:00',3.79),('9650','2014-03-28','10:05:00',3.88),('9650','2014-03-28','10:10:00',4.02),('9650','2014-03-28','10:15:00',4.16),('9650','2014-03-28','10:20:00',4.24),('9650','2014-03-28','10:25:00',4.35),('9650','2014-03-28','10:30:00',4.45),('9650','2014-03-28','10:35:00',4.51),('9650','2014-03-28','10:40:00',4.62),('9650','2014-03-28','10:45:00',4.68),('9650','2014-03-28','10:50:00',4.82),('9650','2014-03-28','10:55:00',4.95),('9650','2014-03-28','11:00:00',5.03),('9650','2014-03-28','11:05:00',5.1),('9650','2014-03-28','11:10:00',5.17),('9650','2014-03-28','11:15:00',5.26),('9650','2014-03-28','11:20:00',5.35),('9650','2014-03-28','11:25:00',5.42),('9650','2014-03-28','11:30:00',5.46),('9650','2014-03-28','11:35:00',5.52),('9650','2014-03-28','11:40:00',5.41),('9650','2014-03-28','11:45:00',5.74),('9650','2014-03-28','11:50:00',5.77),('9650','2014-03-28','11:55:00',5.81),('9650','2014-03-28','12:00:00',5.87),('9650','2014-03-28','12:05:00',5.96),('9650','2014-03-28','12:10:00',5.99),('9650','2014-03-28','12:15:00',6),('9650','2014-03-28','12:20:00',6.14),('9650','2014-03-28','12:25:00',6.2),('9650','2014-03-28','12:30:00',6.26),('9650','2014-03-28','12:35:00',6.23),('9650','2014-03-28','12:40:00',6.23),('9650','2014-03-28','12:45:00',6.32),('9650','2014-03-28','12:50:00',6.35),('9650','2014-03-28','12:55:00',6.33),('9650','2014-03-28','13:00:00',6.26),('9650','2014-03-28','13:05:00',6.4),('9650','2014-03-28','13:10:00',6.35),('9650','2014-03-28','13:15:00',6.36),('9650','2014-03-28','13:20:00',6.38),('9650','2014-03-28','13:25:00',6.31),('9650','2014-03-28','13:30:00',6.3),('9650','2014-03-28','13:35:00',6.22),('9650','2014-03-28','13:40:00',6.23),('9650','2014-03-28','13:45:00',6.17),('9650','2014-03-28','13:50:00',6.13),('9650','2014-03-28','13:55:00',6.16),('9650','2014-03-28','14:00:00',6.12),('9650','2014-03-28','14:05:00',6.03),('9650','2014-03-28','14:10:00',5.96),('9650','2014-03-28','14:15:00',5.8),('9650','2014-03-28','14:20:00',5.75),('9650','2014-03-28','14:25:00',5.2),('9650','2014-03-28','14:30:00',5.64),('9650','2014-03-28','14:35:00',5.4),('9650','2014-03-28','14:40:00',4.6),('9650','2014-03-28','14:45:00',5.33),('9650','2014-03-28','14:50:00',5.4),('9650','2014-03-28','14:55:00',5.35),('9650','2014-03-28','15:00:00',5.22),('9650','2014-03-28','15:05:00',5.03),('9650','2014-03-28','15:10:00',4.94),('9650','2014-03-28','15:15:00',4.93),('9650','2014-03-28','15:20:00',4.9),('9650','2014-03-28','15:25:00',4.71),('9650','2014-03-28','15:30:00',4.54),('9650','2014-03-28','15:35:00',4.39),('9650','2014-03-28','15:40:00',4.34),('9650','2014-03-28','15:45:00',4.29),('9650','2014-03-28','15:50:00',4.1),('9650','2014-03-28','15:55:00',4.09),('9650','2014-03-28','16:00:00',4.01),('9650','2014-03-28','16:05:00',3.9),('9650','2014-03-28','16:10:00',3.74),('9650','2014-03-28','16:15:00',3.62),('9650','2014-03-28','16:20:00',3.32),('9650','2014-03-28','16:25:00',3.39),('9650','2014-03-28','16:30:00',3.3),('9650','2014-03-28','16:35:00',3.07),('9650','2014-03-28','16:40:00',2.76),('9650','2014-03-28','16:45:00',2.24),('9650','2014-03-28','16:50:00',2.53),('9650','2014-03-28','16:55:00',2.65),('9650','2014-03-28','17:00:00',2.53),('9650','2014-03-28','17:05:00',2.36),('9650','2014-03-28','17:10:00',2.3),('9650','2014-03-28','17:15:00',2.14),('9650','2014-03-28','17:20:00',1.94),('9650','2014-03-28','17:25:00',1.74),('9650','2014-03-28','17:30:00',1.54),('9650','2014-03-28','17:35:00',1.3),('9650','2014-03-28','17:40:00',1.02),('9650','2013-04-20','07:55:00',1.07),('9650','2013-04-20','08:00:00',1.22),('9650','2013-04-20','08:05:00',1.4),('9650','2013-04-20','08:10:00',1.46),('9650','2013-04-20','08:15:00',1.51),('9650','2013-04-20','08:20:00',1.61),('9650','2013-04-20','08:25:00',1.92),('9650','2013-04-20','08:30:00',1.97),('9650','2013-04-20','08:35:00',2.06),('9650','2013-04-20','08:40:00',2.11),('9650','2013-04-20','08:45:00',1.91),('9650','2013-04-20','08:50:00',1.9),('9650','2013-04-20','08:55:00',2.33),('9650','2013-04-20','09:00:00',2.44),('9650','2013-04-20','09:05:00',2.7),('9650','2013-04-20','09:10:00',2.77),('9650','2013-04-20','09:15:00',2.49),('9650','2013-04-20','09:20:00',2.17),('9650','2013-04-20','09:25:00',2.68),('9650','2013-04-20','09:30:00',3.2),('9650','2013-04-20','09:35:00',3.34),('9650','2013-04-20','09:40:00',3.3),('9650','2013-04-20','09:45:00',3.9),('9650','2013-04-20','09:50:00',4.49),('9650','2013-04-20','09:55:00',5.28),('9650','2013-04-20','10:00:00',4.22),('9650','2013-04-20','10:05:00',2.87),('9650','2013-04-20','10:10:00',3.19),('9650','2013-04-20','10:15:00',2.55),('9650','2013-04-20','10:20:00',5.3),('9650','2013-04-20','10:25:00',3.85),('9650','2013-04-20','10:30:00',3.68),('9650','2013-04-20','10:35:00',2.67),('9650','2013-04-20','10:40:00',3.37),('9650','2013-04-20','10:45:00',3.55),('9650','2013-04-20','10:50:00',4.21),('9650','2013-04-20','10:55:00',3.39),('9650','2013-04-20','11:00:00',5.6),('9650','2013-04-20','11:05:00',4.77),('9650','2013-04-20','11:10:00',5.29),('9650','2013-04-20','11:15:00',4.21),('9650','2013-04-20','11:20:00',4.46),('9650','2013-04-20','11:25:00',4.47),('9650','2013-04-20','11:30:00',4.61),('9650','2013-04-20','11:35:00',4.48),('9650','2013-04-20','11:40:00',4.52),('9650','2013-04-20','11:45:00',5.11),('9650','2013-04-20','11:50:00',5.24),('9650','2013-04-20','11:55:00',5.09),('9650','2013-04-20','12:00:00',4.29),('9650','2013-04-20','12:05:00',4.4),('9650','2013-04-20','12:10:00',4.33),('9650','2013-04-20','12:15:00',4),('9650','2013-04-20','12:20:00',3.66),('9650','2013-04-20','12:25:00',3.61),('9650','2013-04-20','12:30:00',3.86),('9650','2013-04-20','12:35:00',3.99),('9650','2013-04-20','12:40:00',4.09),('9650','2013-04-20','12:45:00',4.04),('9650','2013-04-20','12:50:00',3.88),('9650','2013-04-20','12:55:00',3.73),('9650','2013-04-20','13:00:00',4.19),('9650','2013-04-20','13:05:00',4.77),('9650','2013-04-20','13:10:00',4.86),('9650','2013-04-20','13:15:00',4.4),('9650','2013-04-20','13:20:00',4.18),('9650','2013-04-20','13:25:00',4.13),('9650','2013-04-20','13:30:00',6.04),('9650','2013-04-20','13:35:00',6.23),('9650','2013-04-20','13:40:00',4.76),('9650','2013-04-20','13:45:00',5.42),('9650','2013-04-20','13:50:00',5.19),('9650','2013-04-20','13:55:00',7.31),('9650','2013-04-20','14:00:00',7.59),('9650','2013-04-20','14:05:00',8.01),('9650','2013-04-20','14:10:00',7.25),('9650','2013-04-20','14:15:00',7.62),('9650','2013-04-20','14:20:00',8.68),('9650','2013-04-20','14:25:00',7.85),('9650','2013-04-20','14:30:00',7.4),('9650','2013-04-20','14:35:00',8.41),('9650','2013-04-20','14:40:00',8.42),('9650','2013-04-20','14:45:00',6.59),('9650','2013-04-20','14:50:00',3.81),('9650','2013-04-20','14:55:00',3.77),('9650','2013-04-20','15:00:00',3.89),('9650','2013-04-20','15:05:00',7.08),('9650','2013-04-20','15:10:00',7.42),('9650','2013-04-20','15:15:00',5.51),('9650','2013-04-20','15:20:00',3.28),('9650','2013-04-20','15:25:00',3.57),('9650','2013-04-20','15:30:00',3.23),('9650','2013-04-20','15:35:00',2.8),('9650','2013-04-20','15:40:00',2.95),('9650','2013-04-20','15:45:00',2.42),('9650','2013-04-20','15:50:00',1.92),('9650','2013-04-20','15:55:00',1.65),('9650','2013-04-20','16:00:00',1.48),('9650','2013-04-20','16:05:00',1.33),('9650','2013-04-20','16:10:00',1.31),('9650','2013-04-20','16:15:00',1.27),('9650','2013-04-20','16:20:00',1.04),('9650','2013-04-20','16:40:00',1.03),('9650','2013-04-20','16:55:00',1.13),('9650','2013-04-20','17:00:00',1.45),('9650','2013-04-20','17:05:00',1.47),('9650','2013-04-20','17:10:00',1.36),('9650','2013-04-20','17:15:00',1.39),('9650','2013-04-20','17:20:00',1.19),('9650','2013-04-20','17:25:00',1.06),('9650','2013-04-19','08:00:00',1.03),('9650','2013-04-19','08:05:00',1.07),('9650','2013-04-19','08:10:00',1.06),('9650','2013-04-19','08:20:00',1.02),('9650','2013-04-19','08:25:00',1.12),('9650','2013-04-19','08:30:00',1.28),('9650','2013-04-19','08:35:00',1.45),('9650','2013-04-19','08:40:00',1.64),('9650','2013-04-19','08:45:00',1.75),('9650','2013-04-19','08:50:00',1.82),('9650','2013-04-19','08:55:00',1.87),('9650','2013-04-19','09:00:00',2.17),('9650','2013-04-19','09:05:00',2.33),('9650','2013-04-19','09:10:00',2.45),('9650','2013-04-19','09:15:00',2.65),('9650','2013-04-19','09:20:00',3.12),('9650','2013-04-19','09:25:00',2.94),('9650','2013-04-19','09:30:00',2.94),('9650','2013-04-19','09:35:00',2.38),('9650','2013-04-19','09:40:00',1.73),('9650','2013-04-19','09:45:00',1.82),('9650','2013-04-19','09:50:00',1.89),('9650','2013-04-19','09:55:00',1.23),('9650','2013-04-19','10:25:00',1.08),('9650','2013-04-19','10:30:00',1.15),('9650','2013-04-19','10:35:00',1.49),('9650','2013-04-19','10:40:00',2.29),('9650','2013-04-19','10:45:00',4.19),('9650','2013-04-19','10:50:00',3.32),('9650','2013-04-19','10:55:00',4.38),('9650','2013-04-19','11:00:00',5.2),('9650','2013-04-19','11:05:00',5.31),('9650','2013-04-19','11:10:00',5.93),('9650','2013-04-19','11:15:00',6.2),('9650','2013-04-19','11:20:00',3.66),('9650','2013-04-19','11:25:00',6.17),('9650','2013-04-19','11:30:00',6.56),('9650','2013-04-19','11:35:00',2.98),('9650','2013-04-19','11:40:00',2.37),('9650','2013-04-19','11:45:00',4.18),('9650','2013-04-19','11:50:00',7.09),('9650','2013-04-19','11:55:00',7.08),('9650','2013-04-19','12:00:00',7),('9650','2013-04-19','12:05:00',6.52),('9650','2013-04-19','12:10:00',6.81),('9650','2013-04-19','12:15:00',6.99),('9650','2013-04-19','12:20:00',6.81),('9650','2013-04-19','12:25:00',6.9),('9650','2013-04-19','12:30:00',5),('9650','2013-04-19','12:35:00',2.55),('9650','2013-04-19','12:40:00',5.48),('9650','2013-04-19','12:45:00',7.54),('9650','2013-04-19','12:50:00',3.37),('9650','2013-04-19','12:55:00',7.68),('9650','2013-04-19','13:00:00',3.31),('9650','2013-04-19','13:05:00',5.21),('9650','2013-04-19','13:10:00',4.67),('9650','2013-04-19','13:15:00',6.87),('9650','2013-04-19','13:20:00',7.54),('9650','2013-04-19','13:25:00',6.03),('9650','2013-04-19','13:30:00',3.52),('9650','2013-04-19','13:35:00',5.81),('9650','2013-04-19','13:40:00',6.12),('9650','2013-04-19','13:45:00',4.04),('9650','2013-04-19','13:50:00',3.07),('9650','2013-04-19','13:55:00',5.78),('9650','2013-04-19','14:00:00',4.97),('9650','2013-04-19','14:05:00',8.13),('9650','2013-04-19','14:10:00',7.67),('9650','2013-04-19','14:15:00',7.42),('9650','2013-04-19','14:20:00',7.08),('9650','2013-04-19','14:25:00',7.11),('9650','2013-04-19','14:30:00',6.94),('9650','2013-04-19','14:35:00',6.93),('9650','2013-04-19','14:40:00',6.96),('9650','2013-04-19','14:45:00',7.02),('9650','2013-04-19','14:50:00',6.98),('9650','2013-04-19','14:55:00',7.07),('9650','2013-04-19','15:00:00',7.06),('9650','2013-04-19','15:05:00',7.08),('9650','2013-04-19','15:10:00',4.06),('9650','2013-04-19','15:15:00',4.76),('9650','2013-04-19','15:20:00',5.4),('9650','2013-04-19','15:25:00',6.28),('9650','2013-04-19','15:30:00',3.14),('9650','2013-04-19','15:35:00',1.58),('9650','2013-04-19','15:40:00',1.5),('9650','2013-04-19','15:45:00',1.52),('9650','2013-04-19','15:50:00',1.44),('9650','2013-04-19','15:55:00',1.4),('9650','2013-04-19','16:00:00',1.65),('9650','2013-04-19','16:05:00',2.19),('9650','2013-04-19','16:10:00',3.34),('9650','2013-04-19','16:15:00',4.37),('9650','2013-04-19','16:20:00',4.26),('9650','2013-04-19','16:25:00',5.26),('9650','2013-04-19','16:30:00',5.92),('9650','2013-04-19','16:35:00',5.24),('9650','2013-04-19','16:40:00',6.26),('9650','2013-04-19','16:45:00',6.39),('9650','2013-04-19','16:50:00',5.85),('9650','2013-04-19','16:55:00',5.66),('9650','2013-04-19','17:00:00',5.49),('9650','2013-04-19','17:05:00',5.35),('9650','2013-04-19','17:10:00',5.26),('9650','2013-04-19','17:15:00',4.35),('9650','2013-04-19','17:20:00',4.99),('9650','2013-04-19','17:25:00',4.73),('9650','2013-04-19','17:30:00',5.07),('9650','2013-04-19','17:35:00',5.27),('9650','2013-04-19','17:40:00',4.89),('9650','2013-04-19','17:45:00',2.25),('9650','2013-04-19','17:50:00',2.49),('9650','2013-04-19','17:55:00',4.76),('9650','2013-04-19','18:00:00',3.2),('9650','2013-04-19','18:05:00',3.43),('9650','2013-04-19','18:10:00',4.11),('9650','2013-04-19','18:15:00',3.54),('9650','2013-04-19','18:20:00',2.61),('9650','2013-04-19','18:25:00',1.01),('9650','2013-04-19','18:35:00',1.14),('9650','2013-04-19','18:40:00',1.63),('9650','2013-04-18','08:25:00',1.11),('9650','2013-04-18','08:35:00',1.12),('9650','2013-04-18','08:40:00',1.21),('9650','2013-04-18','08:45:00',1.26),('9650','2013-04-18','08:50:00',1.3),('9650','2013-04-18','08:55:00',1.33),('9650','2013-04-18','09:00:00',1.34),('9650','2013-04-18','09:05:00',1.8),('9650','2013-04-18','09:10:00',1.93),('9650','2013-04-18','09:15:00',2.05),('9650','2013-04-18','09:20:00',2.22),('9650','2013-04-18','09:25:00',2.31),('9650','2013-04-18','09:30:00',2.47),('9650','2013-04-18','09:35:00',2.63),('9650','2013-04-18','09:40:00',2.69),('9650','2013-04-18','09:45:00',2.84),('9650','2013-04-18','09:50:00',2.91),('9650','2013-04-18','09:55:00',3.05),('9650','2013-04-18','10:00:00',3.16),('9650','2013-04-18','10:05:00',3.29),('9650','2013-04-18','10:10:00',3.4),('9650','2013-04-18','10:15:00',3.61),('9650','2013-04-18','10:20:00',3.65),('9650','2013-04-18','10:25:00',3.83),('9650','2013-04-18','10:30:00',3.85),('9650','2013-04-18','10:35:00',3.09),('9650','2013-04-18','10:40:00',4.19),('9650','2013-04-18','10:45:00',4.3),('9650','2013-04-18','10:50:00',4.35),('9650','2013-04-18','10:55:00',4.39),('9650','2013-04-18','11:00:00',4.5),('9650','2013-04-18','11:05:00',4.6),('9650','2013-04-18','11:10:00',4.68),('9650','2013-04-18','11:15:00',4.78),('9650','2013-04-18','11:20:00',4.9),('9650','2013-04-18','11:25:00',5),('9650','2013-04-18','11:30:00',5.03),('9650','2013-04-18','11:35:00',5.07),('9650','2013-04-18','11:40:00',5.26),('9650','2013-04-18','11:45:00',5.29),('9650','2013-04-18','11:50:00',5.38),('9650','2013-04-18','11:55:00',5.55),('9650','2013-04-18','12:00:00',5.62),('9650','2013-04-18','12:05:00',5.64),('9650','2013-04-18','12:10:00',5.67),('9650','2013-04-18','12:15:00',5.85),('9650','2013-04-18','12:20:00',5.75),('9650','2013-04-18','12:25:00',5.76),('9650','2013-04-18','12:30:00',6.05),('9650','2013-04-18','12:35:00',5.99),('9650','2013-04-18','12:40:00',6.12),('9650','2013-04-18','12:45:00',5.95),('9650','2013-04-18','12:50:00',6.06),('9650','2013-04-18','12:55:00',6.29),('9650','2013-04-18','13:00:00',6.26),('9650','2013-04-18','13:05:00',6.29),('9650','2013-04-18','13:10:00',6.37),('9650','2013-04-18','13:15:00',6.43),('9650','2013-04-18','13:20:00',6.37),('9650','2013-04-18','13:25:00',6.53),('9650','2013-04-18','13:30:00',6.57),('9650','2013-04-18','13:35:00',6.45),('9650','2013-04-18','13:40:00',6.62),('9650','2013-04-18','13:45:00',6.56),('9650','2013-04-18','13:50:00',6.46),('9650','2013-04-18','13:55:00',6.6),('9650','2013-04-18','14:00:00',6.57),('9650','2013-04-18','14:05:00',6.6),('9650','2013-04-18','14:10:00',6.61),('9650','2013-04-18','14:15:00',6.6),('9650','2013-04-18','14:20:00',6.6),('9650','2013-04-18','14:25:00',6.62),('9650','2013-04-18','14:30:00',6.59),('9650','2013-04-18','14:35:00',6.63),('9650','2013-04-18','14:40:00',6.57),('9650','2013-04-18','14:45:00',6.59),('9650','2013-04-18','14:50:00',6.59),('9650','2013-04-18','14:55:00',6.59),('9650','2013-04-18','15:00:00',6.54),('9650','2013-04-18','15:05:00',6.49),('9650','2013-04-18','15:10:00',6.45),('9650','2013-04-18','15:15:00',6.42),('9650','2013-04-18','15:20:00',6.32),('9650','2013-04-18','15:25:00',6.38),('9650','2013-04-18','15:30:00',6.29),('9650','2013-04-18','15:35:00',6.29),('9650','2013-04-18','15:40:00',6.23),('9650','2013-04-18','15:45:00',6.2),('9650','2013-04-18','15:50:00',6.08),('9650','2013-04-18','15:55:00',6.06),('9650','2013-04-18','16:00:00',5.97),('9650','2013-04-18','16:05:00',5.9),('9650','2013-04-18','16:10:00',5.81),('9650','2013-04-18','16:15:00',5.73),('9650','2013-04-18','16:20:00',5.66),('9650','2013-04-18','16:25:00',5.63),('9650','2013-04-18','16:30:00',5.51),('9650','2013-04-18','16:35:00',5.35),('9650','2013-04-18','16:40:00',5.24),('9650','2013-04-18','16:45:00',5.12),('9650','2013-04-18','16:50:00',4.97),('9650','2013-04-18','16:55:00',4.9),('9650','2013-04-18','17:00:00',4.77),('9650','2013-04-18','17:05:00',4.65),('9650','2013-04-18','17:10:00',4.49),('9650','2013-04-18','17:15:00',4.36),('9650','2013-04-18','17:20:00',4.26),('9650','2013-04-18','17:25:00',4.12),('9650','2013-04-18','17:30:00',4.02),('9650','2013-04-18','17:35:00',3.96),('9650','2013-04-18','17:40:00',3.82),('9650','2013-04-18','17:45:00',3.68),('9650','2013-04-18','17:50:00',3.38),('9650','2013-04-18','17:55:00',3.25),('9650','2013-04-18','18:00:00',3.12),('9650','2013-04-18','18:05:00',2.98),('9650','2013-04-18','18:10:00',2.79),('9650','2013-04-18','18:15:00',2.65),('9650','2013-04-18','18:20:00',2.52),('9650','2013-04-18','18:25:00',2.4),('9650','2013-04-18','18:30:00',2.26),('9650','2013-04-18','18:35:00',2.08),('9650','2013-04-18','18:40:00',1.92),('9650','2013-04-18','18:45:00',1.71),('9650','2013-04-18','18:50:00',1.48),('9650','2013-04-18','18:55:00',1.31),('9650','2013-04-18','19:00:00',1.16),('9650','2013-04-17','08:30:00',1.01),('9650','2013-04-17','08:35:00',1.08),('9650','2013-04-17','08:40:00',1.11),('9650','2013-04-17','08:45:00',1.16),('9650','2013-04-17','08:50:00',1.3),('9650','2013-04-17','08:55:00',1.47),('9650','2013-04-17','09:00:00',1.61),('9650','2013-04-17','09:05:00',1.75),('9650','2013-04-17','09:10:00',1.86),('9650','2013-04-17','09:15:00',1.93),('9650','2013-04-17','09:20:00',2.04),('9650','2013-04-17','09:25:00',2.06),('9650','2013-04-17','09:30:00',2.26),('9650','2013-04-17','09:35:00',2.49),('9650','2013-04-17','09:40:00',2.95),('9650','2013-04-17','09:45:00',2.87),('9650','2013-04-17','09:50:00',2.53),('9650','2013-04-17','09:55:00',2.46),('9650','2013-04-17','10:00:00',2.83),('9650','2013-04-17','10:05:00',3.19),('9650','2013-04-17','10:10:00',3.45),('9650','2013-04-17','10:15:00',3.76),('9650','2013-04-17','10:20:00',3.87),('9650','2013-04-17','10:25:00',3.9),('9650','2013-04-17','10:30:00',4.04),('9650','2013-04-17','10:35:00',4.1),('9650','2013-04-17','10:40:00',4.21),('9650','2013-04-17','10:45:00',4.38),('9650','2013-04-17','10:50:00',4.49),('9650','2013-04-17','10:55:00',4.58),('9650','2013-04-17','11:00:00',4.7),('9650','2013-04-17','11:05:00',4.81),('9650','2013-04-17','11:10:00',4.9),('9650','2013-04-17','11:15:00',5.01),('9650','2013-04-17','11:20:00',5.15),('9650','2013-04-17','11:25:00',5.19),('9650','2013-04-17','11:30:00',5.27),('9650','2013-04-17','11:35:00',5.36),('9650','2013-04-17','11:40:00',5.44),('9650','2013-04-17','11:45:00',5.4),('9650','2013-04-17','11:50:00',5.58),('9650','2013-04-17','11:55:00',5.67),('9650','2013-04-17','12:00:00',5.69),('9650','2013-04-17','12:05:00',5.85),('9650','2013-04-17','12:10:00',5.95),('9650','2013-04-17','12:15:00',5.98),('9650','2013-04-17','12:20:00',6.13),('9650','2013-04-17','12:25:00',6.15),('9650','2013-04-17','12:30:00',6.26),('9650','2013-04-17','12:35:00',6.3),('9650','2013-04-17','12:40:00',6.32),('9650','2013-04-17','12:45:00',6.44),('9650','2013-04-17','12:50:00',6.46),('9650','2013-04-17','12:55:00',6.53),('9650','2013-04-17','13:00:00',6.58),('9650','2013-04-17','13:05:00',6.63),('9650','2013-04-17','13:10:00',6.65),('9650','2013-04-17','13:15:00',6.71),('9650','2013-04-17','13:20:00',6.73),('9650','2013-04-17','13:25:00',6.79),('9650','2013-04-17','13:30:00',6.82),('9650','2013-04-17','13:35:00',6.88),('9650','2013-04-17','13:40:00',6.87),('9650','2013-04-17','13:45:00',6.91),('9650','2013-04-17','13:50:00',6.96),('9650','2013-04-17','13:55:00',6.97),('9650','2013-04-17','14:00:00',6.98),('9650','2013-04-17','14:05:00',7),('9650','2013-04-17','14:10:00',7),('9650','2013-04-17','14:15:00',7.03),('9650','2013-04-17','14:20:00',7.02),('9650','2013-04-17','14:25:00',7.02),('9650','2013-04-17','14:30:00',7.03),('9650','2013-04-17','14:35:00',7.02),('9650','2013-04-17','14:40:00',7),('9650','2013-04-17','14:45:00',6.98),('9650','2013-04-17','14:50:00',6.98),('9650','2013-04-17','14:55:00',6.95),('9650','2013-04-17','15:00:00',6.91),('9650','2013-04-17','15:05:00',6.9),('9650','2013-04-17','15:10:00',6.86),('9650','2013-04-17','15:15:00',6.84),('9650','2013-04-17','15:20:00',6.79),('9650','2013-04-17','15:25:00',6.73),('9650','2013-04-17','15:30:00',6.68),('9650','2013-04-17','15:35:00',6.65),('9650','2013-04-17','15:40:00',6.61),('9650','2013-04-17','15:45:00',6.54),('9650','2013-04-17','15:50:00',6.47),('9650','2013-04-17','15:55:00',6.34),('9650','2013-04-17','16:00:00',6.23),('9650','2013-04-17','16:05:00',6.2),('9650','2013-04-17','16:10:00',6.11),('9650','2013-04-17','16:15:00',6.01),('9650','2013-04-17','16:20:00',5.96),('9650','2013-04-17','16:25:00',5.83),('9650','2013-04-17','16:30:00',5.76),('9650','2013-04-17','16:35:00',5.62),('9650','2013-04-17','16:40:00',5.54),('9650','2013-04-17','16:45:00',5.45),('9650','2013-04-17','16:50:00',5.39),('9650','2013-04-17','16:55:00',5.24),('9650','2013-04-17','17:00:00',5.07),('9650','2013-04-17','17:05:00',4.86),('9650','2013-04-17','17:10:00',4.81),('9650','2013-04-17','17:15:00',4.75),('9650','2013-04-17','17:20:00',4.64),('9650','2013-04-17','17:25:00',4.51),('9650','2013-04-17','17:30:00',4.4),('9650','2013-04-17','17:35:00',4.34),('9650','2013-04-17','17:40:00',4.23),('9650','2013-04-17','17:45:00',4.1),('9650','2013-04-17','17:50:00',3.98),('9650','2013-04-17','17:55:00',3.79),('9650','2013-04-17','18:00:00',3.61),('9650','2013-04-17','18:05:00',3.43),('9650','2013-04-17','18:10:00',3.23),('9650','2013-04-17','18:15:00',3.05),('9650','2013-04-17','18:20:00',2.87),('9650','2013-04-17','18:25:00',2.64),('9650','2013-04-17','18:30:00',2.43),('9650','2013-04-17','18:35:00',2.25),('9650','2013-04-17','18:40:00',2.06),('9650','2013-04-17','18:45:00',1.78),('9650','2013-04-17','18:50:00',1.62),('9650','2013-04-17','18:55:00',1.51),('9650','2013-04-17','19:00:00',1.36),('9650','2013-04-17','19:05:00',1.14),('9650','2013-04-16','08:45:00',1.08),('9650','2013-04-16','08:50:00',1.2),('9650','2013-04-16','08:55:00',1.34),('9650','2013-04-16','09:00:00',1.47),('9650','2013-04-16','09:05:00',1.61),('9650','2013-04-16','09:10:00',1.75),('9650','2013-04-16','09:15:00',1.91),('9650','2013-04-16','09:20:00',2.05),('9650','2013-04-16','09:25:00',2.2),('9650','2013-04-16','09:30:00',2.36),('9650','2013-04-16','09:35:00',2.52),('9650','2013-04-16','09:40:00',2.68),('9650','2013-04-16','09:45:00',2.82),('9650','2013-04-16','09:50:00',2.96),('9650','2013-04-16','09:55:00',3.09),('9650','2013-04-16','10:00:00',3.22),('9650','2013-04-16','10:05:00',3.37),('9650','2013-04-16','10:10:00',3.49),('9650','2013-04-16','10:15:00',3.63),('9650','2013-04-16','10:20:00',3.77),('9650','2013-04-16','10:25:00',3.88),('9650','2013-04-16','10:30:00',4.01),('9650','2013-04-16','10:35:00',4.15),('9650','2013-04-16','10:40:00',4.29),('9650','2013-04-16','10:45:00',4.4),('9650','2013-04-16','10:50:00',4.49),('9650','2013-04-16','10:55:00',4.62),('9650','2013-04-16','11:00:00',4.75),('9650','2013-04-16','11:05:00',4.86),('9650','2013-04-16','11:10:00',4.99),('9650','2013-04-16','11:15:00',5.09),('9650','2013-04-16','11:20:00',5.18),('9650','2013-04-16','11:25:00',5.24),('9650','2013-04-16','11:30:00',5.32),('9650','2013-04-16','11:35:00',5.42),('9650','2013-04-16','11:40:00',5.5),('9650','2013-04-16','11:45:00',5.6),('9650','2013-04-16','11:50:00',5.69),('9650','2013-04-16','11:55:00',5.82),('9650','2013-04-16','12:00:00',5.88),('9650','2013-04-16','12:05:00',5.94),('9650','2013-04-16','12:10:00',5.99),('9650','2013-04-16','12:15:00',6.07),('9650','2013-04-16','12:20:00',6.14),('9650','2013-04-16','12:25:00',6.22),('9650','2013-04-16','12:30:00',6.3),('9650','2013-04-16','12:35:00',6.38),('9650','2013-04-16','12:40:00',6.45),('9650','2013-04-16','12:45:00',6.51),('9650','2013-04-16','12:50:00',6.55),('9650','2013-04-16','12:55:00',6.6),('9650','2013-04-16','13:00:00',6.62),('9650','2013-04-16','13:05:00',6.56),('9650','2013-04-16','13:10:00',6.58),('9650','2013-04-16','13:15:00',6.74),('9650','2013-04-16','13:20:00',6.82),('9650','2013-04-16','13:25:00',6.9),('9650','2013-04-16','13:30:00',6.88),('9650','2013-04-16','13:35:00',6.88),('9650','2013-04-16','13:40:00',6.97),('9650','2013-04-16','13:45:00',6.85),('9650','2013-04-16','13:50:00',6.72),('9650','2013-04-16','13:55:00',7.23),('9650','2013-04-16','14:00:00',6.88),('9650','2013-04-16','14:05:00',7.5),('9650','2013-04-16','14:10:00',7.55),('9650','2013-04-16','14:15:00',6.73),('9650','2013-04-16','14:20:00',6.7),('9650','2013-04-16','14:25:00',6.43),('9650','2013-04-16','14:30:00',6.93),('9650','2013-04-16','14:35:00',7.58),('9650','2013-04-16','14:40:00',6.8),('9650','2013-04-16','14:45:00',6.67),('9650','2013-04-16','14:50:00',7.53),('9650','2013-04-16','14:55:00',7.53),('9650','2013-04-16','15:00:00',7.53),('9650','2013-04-16','15:05:00',7.77),('9650','2013-04-16','15:10:00',8.04),('9650','2013-04-16','15:15:00',7.16),('9650','2013-04-16','15:20:00',4.34),('9650','2013-04-16','15:25:00',3.66),('9650','2013-04-16','15:30:00',6.38),('9650','2013-04-16','15:35:00',7.01),('9650','2013-04-16','15:40:00',7.12),('9650','2013-04-16','15:45:00',7.04),('9650','2013-04-16','15:50:00',7.03),('9650','2013-04-16','15:55:00',6.82),('9650','2013-04-16','16:00:00',6.52),('9650','2013-04-16','16:05:00',4.72),('9650','2013-04-16','16:10:00',6.4),('9650','2013-04-16','16:15:00',6.37),('9650','2013-04-16','16:20:00',6.21),('9650','2013-04-16','16:25:00',6.08),('9650','2013-04-16','16:30:00',5.97),('9650','2013-04-16','16:35:00',5.97),('9650','2013-04-16','16:40:00',5.25),('9650','2013-04-16','16:45:00',5.77),('9650','2013-04-16','16:50:00',5.53),('9650','2013-04-16','16:55:00',5.35),('9650','2013-04-16','17:00:00',5.21),('9650','2013-04-16','17:05:00',5.06),('9650','2013-04-16','17:10:00',4.91),('9650','2013-04-16','17:15:00',4.77),('9650','2013-04-16','17:20:00',4.67),('9650','2013-04-16','17:25:00',4.56),('9650','2013-04-16','17:30:00',4.45),('9650','2013-04-16','17:35:00',4.35),('9650','2013-04-16','17:40:00',4.3),('9650','2013-04-16','17:45:00',4.16),('9650','2013-04-16','17:50:00',3.97),('9650','2013-04-16','17:55:00',3.77),('9650','2013-04-16','18:00:00',3.62),('9650','2013-04-16','18:05:00',3.48),('9650','2013-04-16','18:10:00',3.32),('9650','2013-04-16','18:15:00',3.19),('9650','2013-04-16','18:20:00',3),('9650','2013-04-16','18:25:00',2.84),('9650','2013-04-16','18:30:00',2.6),('9650','2013-04-16','18:35:00',2.47),('9650','2013-04-16','18:40:00',2.28),('9650','2013-04-16','18:45:00',2.11),('9650','2013-04-16','18:50:00',1.91),('9650','2013-04-16','18:55:00',1.71),('9650','2013-04-16','19:00:00',1.49),('9650','2013-04-16','19:05:00',1.28),('9650','2013-04-16','19:10:00',1.05),('9650','2013-04-15','08:25:00',1.14),('9650','2013-04-15','08:30:00',1.19),('9650','2013-04-15','08:35:00',1.2),('9650','2013-04-15','08:40:00',1.23),('9650','2013-04-15','08:45:00',1.28),('9650','2013-04-15','08:50:00',1.56),('9650','2013-04-15','08:55:00',1.46),('9650','2013-04-15','09:00:00',1.21),('9650','2013-04-15','09:10:00',1.39),('9650','2013-04-15','09:15:00',1.93),('9650','2013-04-15','09:20:00',1.63),('9650','2013-04-15','09:25:00',1.89),('9650','2013-04-15','09:30:00',2.46),('9650','2013-04-15','09:35:00',2.36),('9650','2013-04-15','09:40:00',2.34),('9650','2013-04-15','09:45:00',2.49),('9650','2013-04-15','09:50:00',2.42),('9650','2013-04-15','09:55:00',2.38),('9650','2013-04-15','10:00:00',2.3),('9650','2013-04-15','10:05:00',2.32),('9650','2013-04-15','10:10:00',2.49),('9650','2013-04-15','10:15:00',2.63),('9650','2013-04-15','10:20:00',2.74),('9650','2013-04-15','10:25:00',2.8),('9650','2013-04-15','10:30:00',2.82),('9650','2013-04-15','10:35:00',2.87),('9650','2013-04-15','10:40:00',2.85),('9650','2013-04-15','10:45:00',2.76),('9650','2013-04-15','10:50:00',2.8),('9650','2013-04-15','10:55:00',2.98),('9650','2013-04-15','11:00:00',3.18),('9650','2013-04-15','11:05:00',3.28),('9650','2013-04-15','11:10:00',3.27),('9650','2013-04-15','11:15:00',3.34),('9650','2013-04-15','11:20:00',3.42),('9650','2013-04-15','11:25:00',3.38),('9650','2013-04-15','11:30:00',3.23),('9650','2013-04-15','11:35:00',3.12),('9650','2013-04-15','11:40:00',3.42),('9650','2013-04-15','11:45:00',3.88),('9650','2013-04-15','11:50:00',4.1),('9650','2013-04-15','11:55:00',4.18),('9650','2013-04-15','12:00:00',4.16),('9650','2013-04-15','12:05:00',4.58),('9650','2013-04-15','12:10:00',4.58),('9650','2013-04-15','12:15:00',4.69),('9650','2013-04-15','12:20:00',4.96),('9650','2013-04-15','12:25:00',4.74),('9650','2013-04-15','12:30:00',3.93),('9650','2013-04-15','12:35:00',5.97),('9650','2013-04-15','12:40:00',6.27),('9650','2013-04-15','12:45:00',5.42),('9650','2013-04-15','12:50:00',4.53),('9650','2013-04-15','12:55:00',6.1),('9650','2013-04-15','13:00:00',6.37),('9650','2013-04-15','13:05:00',6.44),('9650','2013-04-15','13:10:00',6.43),('9650','2013-04-15','13:15:00',6.52),('9650','2013-04-15','13:20:00',6.62),('9650','2013-04-15','13:25:00',6.69),('9650','2013-04-15','13:30:00',6.69),('9650','2013-04-15','13:35:00',6.66),('9650','2013-04-15','13:40:00',6.7),('9650','2013-04-15','13:45:00',6.52),('9650','2013-04-15','13:50:00',6.64),('9650','2013-04-15','13:55:00',6.49),('9650','2013-04-15','14:00:00',6.63),('9650','2013-04-15','14:05:00',6.76),('9650','2013-04-15','14:10:00',6.82),('9650','2013-04-15','14:15:00',6.92),('9650','2013-04-15','14:20:00',6.89),('9650','2013-04-15','14:25:00',6.18),('9650','2013-04-15','14:30:00',5.97),('9650','2013-04-15','14:35:00',5.17),('9650','2013-04-15','14:40:00',6.53),('9650','2013-04-15','14:45:00',6.75),('9650','2013-04-15','14:50:00',6.52),('9650','2013-04-15','14:55:00',6.55),('9650','2013-04-15','15:00:00',6.75),('9650','2013-04-15','15:05:00',6.77),('9650','2013-04-15','15:10:00',6.8),('9650','2013-04-15','15:15:00',6.68),('9650','2013-04-15','15:20:00',6.57),('9650','2013-04-15','15:25:00',6.15),('9650','2013-04-15','15:30:00',6.04),('9650','2013-04-15','15:35:00',6.37),('9650','2013-04-15','15:40:00',6.35),('9650','2013-04-15','15:45:00',6.3),('9650','2013-04-15','15:50:00',6.25),('9650','2013-04-15','15:55:00',6.22),('9650','2013-04-15','16:00:00',6.04),('9650','2013-04-15','16:05:00',6.04),('9650','2013-04-15','16:10:00',5.94),('9650','2013-04-15','16:15:00',5.69),('9650','2013-04-15','16:20:00',5.86),('9650','2013-04-15','16:25:00',5.74),('9650','2013-04-15','16:30:00',5.69),('9650','2013-04-15','16:35:00',5.63),('9650','2013-04-15','16:40:00',5.85),('9650','2013-04-15','16:45:00',5.97),('9650','2013-04-15','16:50:00',5.5),('9650','2013-04-15','16:55:00',4.72),('9650','2013-04-15','17:00:00',4.78),('9650','2013-04-15','17:05:00',4.98),('9650','2013-04-15','17:10:00',5.03),('9650','2013-04-15','17:15:00',5.01),('9650','2013-04-15','17:20:00',4.88),('9650','2013-04-15','17:25:00',4.87),('9650','2013-04-15','17:30:00',4.42),('9650','2013-04-15','17:35:00',4.66),('9650','2013-04-15','17:40:00',4.45),('9650','2013-04-15','17:45:00',4.2),('9650','2013-04-15','17:50:00',3.92),('9650','2013-04-15','17:55:00',3.54),('9650','2013-04-15','18:00:00',2.19),('9650','2013-04-15','18:05:00',2.7),('9650','2013-04-15','18:10:00',2.72),('9650','2013-04-15','18:15:00',2.67),('9650','2013-04-15','18:20:00',2.29),('9650','2013-04-15','18:25:00',2.15),('9650','2013-04-15','18:30:00',2.06),('9650','2013-04-15','18:35:00',1.94),('9650','2013-04-15','18:40:00',1.81),('9650','2013-04-15','18:45:00',1.68),('9650','2013-04-15','18:50:00',1.46),('9650','2013-04-15','18:55:00',1.32),('9650','2013-04-14','08:50:00',1.1),('9650','2013-04-14','08:55:00',1.22),('9650','2013-04-14','09:00:00',1.36),('9650','2013-04-14','09:05:00',1.49),('9650','2013-04-14','09:10:00',1.64),('9650','2013-04-14','09:15:00',1.8),('9650','2013-04-14','09:20:00',1.95),('9650','2013-04-14','09:25:00',2.1),('9650','2013-04-14','09:30:00',2.26),('9650','2013-04-14','09:35:00',2.42),('9650','2013-04-14','09:40:00',2.56),('9650','2013-04-14','09:45:00',2.7),('9650','2013-04-14','09:50:00',2.85),('9650','2013-04-14','09:55:00',3.01),('9650','2013-04-14','10:00:00',3.14),('9650','2013-04-14','10:05:00',3.27),('9650','2013-04-14','10:10:00',3.4),('9650','2013-04-14','10:15:00',3.53),('9650','2013-04-14','10:20:00',3.69),('9650','2013-04-14','10:25:00',3.78),('9650','2013-04-14','10:30:00',3.92),('9650','2013-04-14','10:35:00',4.06),('9650','2013-04-14','10:40:00',4.17),('9650','2013-04-14','10:45:00',4.31),('9650','2013-04-14','10:50:00',4.42),('9650','2013-04-14','10:55:00',4.55),('9650','2013-04-14','11:00:00',4.65),('9650','2013-04-14','11:05:00',4.77),('9650','2013-04-14','11:10:00',4.87),('9650','2013-04-14','11:15:00',4.98),('9650','2013-04-14','11:20:00',5.07),('9650','2013-04-14','11:25:00',5.18),('9650','2013-04-14','11:30:00',5.28),('9650','2013-04-14','11:35:00',5.37),('9650','2013-04-14','11:40:00',5.48),('9650','2013-04-14','11:45:00',5.59),('9650','2013-04-14','11:50:00',5.65),('9650','2013-04-14','11:55:00',5.73),('9650','2013-04-14','12:00:00',5.81),('9650','2013-04-14','12:05:00',5.91),('9650','2013-04-14','12:10:00',5.98),('9650','2013-04-14','12:15:00',5.99),('9650','2013-04-14','12:20:00',6.05),('9650','2013-04-14','12:25:00',6.11),('9650','2013-04-14','12:30:00',6.14),('9650','2013-04-14','12:35:00',6.19),('9650','2013-04-14','12:40:00',6.28),('9650','2013-04-14','12:45:00',6.31),('9650','2013-04-14','12:50:00',6.32),('9650','2013-04-14','12:55:00',6.35),('9650','2013-04-14','13:00:00',6.43),('9650','2013-04-14','13:05:00',6.49),('9650','2013-04-14','13:10:00',6.55),('9650','2013-04-14','13:15:00',6.58),('9650','2013-04-14','13:20:00',6.62),('9650','2013-04-14','13:25:00',6.69),('9650','2013-04-14','13:30:00',6.72),('9650','2013-04-14','13:35:00',6.72),('9650','2013-04-14','13:40:00',6.69),('9650','2013-04-14','13:45:00',6.71),('9650','2013-04-14','13:50:00',6.81),('9650','2013-04-14','13:55:00',6.87),('9650','2013-04-14','14:00:00',6.91),('9650','2013-04-14','14:05:00',6.95),('9650','2013-04-14','14:10:00',6.99),('9650','2013-04-14','14:15:00',6.97),('9650','2013-04-14','14:20:00',6.99),('9650','2013-04-14','14:25:00',6.99),('9650','2013-04-14','14:30:00',6.97),('9650','2013-04-14','14:35:00',6.98),('9650','2013-04-14','14:40:00',7.01),('9650','2013-04-14','14:45:00',6.99),('9650','2013-04-14','14:50:00',6.99),('9650','2013-04-14','14:55:00',6.98),('9650','2013-04-14','15:00:00',6.92),('9650','2013-04-14','15:05:00',6.91),('9650','2013-04-14','15:10:00',6.89),('9650','2013-04-14','15:15:00',6.87),('9650','2013-04-14','15:20:00',6.81),('9650','2013-04-14','15:25:00',6.77),('9650','2013-04-14','15:30:00',6.73),('9650','2013-04-14','15:35:00',6.67),('9650','2013-04-14','15:40:00',6.61),('9650','2013-04-14','15:45:00',6.51),('9650','2013-04-14','15:50:00',6.42),('9650','2013-04-14','15:55:00',6.38),('9650','2013-04-14','16:00:00',6.32),('9650','2013-04-14','16:05:00',6.21),('9650','2013-04-14','16:10:00',6.13),('9650','2013-04-14','16:15:00',6.05),('9650','2013-04-14','16:20:00',5.96),('9650','2013-04-14','16:25:00',5.84),('9650','2013-04-14','16:30:00',5.55),('9650','2013-04-14','16:35:00',5.67),('9650','2013-04-14','16:40:00',5.63),('9650','2013-04-14','16:45:00',5.57),('9650','2013-04-14','16:50:00',5.41),('9650','2013-04-14','16:55:00',5.23),('9650','2013-04-14','17:00:00',5.13),('9650','2013-04-14','17:05:00',4.98),('9650','2013-04-14','17:10:00',4.85),('9650','2013-04-14','17:15:00',4.74),('9650','2013-04-14','17:20:00',4.61),('9650','2013-04-14','17:25:00',4.57),('9650','2013-04-14','17:30:00',4.46),('9650','2013-04-14','17:35:00',4.25),('9650','2013-04-14','17:40:00',4.16),('9650','2013-04-14','17:45:00',4.07),('9650','2013-04-14','17:50:00',3.92),('9650','2013-04-14','17:55:00',3.79),('9650','2013-04-14','18:00:00',3.65),('9650','2013-04-14','18:05:00',3.47),('9650','2013-04-14','18:10:00',3.34),('9650','2013-04-14','18:15:00',3.17),('9650','2013-04-14','18:20:00',3),('9650','2013-04-14','18:25:00',2.82),('9650','2013-04-14','18:30:00',2.67),('9650','2013-04-14','18:35:00',2.49),('9650','2013-04-14','18:40:00',2.32),('9650','2013-04-14','18:45:00',2.12),('9650','2013-04-14','18:50:00',1.91),('9650','2013-04-14','18:55:00',1.71),('9650','2013-04-14','19:00:00',1.49),('9650','2013-04-14','19:05:00',1.27),('9650','2013-04-14','19:10:00',1.02),('9650','2013-04-13','08:45:00',1.08),('9650','2013-04-13','08:50:00',1.2),('9650','2013-04-13','08:55:00',1.33),('9650','2013-04-13','09:00:00',1.42),('9650','2013-04-13','09:05:00',1.54),('9650','2013-04-13','09:10:00',1.7),('9650','2013-04-13','09:15:00',1.84),('9650','2013-04-13','09:20:00',2.01),('9650','2013-04-13','09:25:00',2.09),('9650','2013-04-13','09:30:00',2.23),('9650','2013-04-13','09:35:00',2.39),('9650','2013-04-13','09:40:00',2.55),('9650','2013-04-13','09:45:00',2.71),('9650','2013-04-13','09:50:00',2.84),('9650','2013-04-13','09:55:00',2.97),('9650','2013-04-13','10:00:00',3.12),('9650','2013-04-13','10:05:00',3.24),('9650','2013-04-13','10:10:00',3.36),('9650','2013-04-13','10:15:00',3.5),('9650','2013-04-13','10:20:00',3.63),('9650','2013-04-13','10:25:00',3.73),('9650','2013-04-13','10:30:00',3.84),('9650','2013-04-13','10:35:00',3.97),('9650','2013-04-13','10:40:00',4.08),('9650','2013-04-13','10:45:00',4.22),('9650','2013-04-13','10:50:00',4.29),('9650','2013-04-13','10:55:00',4.45),('9650','2013-04-13','11:00:00',4.54),('9650','2013-04-13','11:05:00',4.67),('9650','2013-04-13','11:10:00',4.78),('9650','2013-04-13','11:15:00',4.91),('9650','2013-04-13','11:20:00',5.01),('9650','2013-04-13','11:25:00',5.1),('9650','2013-04-13','11:30:00',5.17),('9650','2013-04-13','11:35:00',5.23),('9650','2013-04-13','11:40:00',5.37),('9650','2013-04-13','11:45:00',5.47),('9650','2013-04-13','11:50:00',5.53),('9650','2013-04-13','11:55:00',5.6),('9650','2013-04-13','12:00:00',5.7),('9650','2013-04-13','12:05:00',5.75),('9650','2013-04-13','12:10:00',5.82),('9650','2013-04-13','12:15:00',5.93),('9650','2013-04-13','12:20:00',6.01),('9650','2013-04-13','12:25:00',6.05),('9650','2013-04-13','12:30:00',6.04),('9650','2013-04-13','12:35:00',6.1),('9650','2013-04-13','12:40:00',5.41),('9650','2013-04-13','12:45:00',6.12),('9650','2013-04-13','12:50:00',6.44),('9650','2013-04-13','12:55:00',6.55),('9650','2013-04-13','13:00:00',5.62),('9650','2013-04-13','13:05:00',6.47),('9650','2013-04-13','13:10:00',6.66),('9650','2013-04-13','13:15:00',5.19),('9650','2013-04-13','13:20:00',6.81),('9650','2013-04-13','13:25:00',6.74),('9650','2013-04-13','13:30:00',6.83),('9650','2013-04-13','13:35:00',6.78),('9650','2013-04-13','13:40:00',6.78),('9650','2013-04-13','13:45:00',6.78),('9650','2013-04-13','13:50:00',6.72),('9650','2013-04-13','13:55:00',6.71),('9650','2013-04-13','14:00:00',6.71),('9650','2013-04-13','14:05:00',6.81),('9650','2013-04-13','14:10:00',6.8),('9650','2013-04-13','14:15:00',6.82),('9650','2013-04-13','14:20:00',6.8),('9650','2013-04-13','14:25:00',6.83),('9650','2013-04-13','14:30:00',6.88),('9650','2013-04-13','14:35:00',7.03),('9650','2013-04-13','14:40:00',7.08),('9650','2013-04-13','14:45:00',7.33),('9650','2013-04-13','14:50:00',7.46),('9650','2013-04-13','14:55:00',7.2),('9650','2013-04-13','15:00:00',7.04),('9650','2013-04-13','15:05:00',7.01),('9650','2013-04-13','15:10:00',7.01),('9650','2013-04-13','15:15:00',5.79),('9650','2013-04-13','15:20:00',6.71),('9650','2013-04-13','15:25:00',6.38),('9650','2013-04-13','15:30:00',5.03),('9650','2013-04-13','15:35:00',6.74),('9650','2013-04-13','15:40:00',6.77),('9650','2013-04-13','15:45:00',6.72),('9650','2013-04-13','15:50:00',6.5),('9650','2013-04-13','15:55:00',6.18),('9650','2013-04-13','16:00:00',5.2),('9650','2013-04-13','16:05:00',5.92),('9650','2013-04-13','16:10:00',5.85),('9650','2013-04-13','16:15:00',5.76),('9650','2013-04-13','16:20:00',5.64),('9650','2013-04-13','16:25:00',5.69),('9650','2013-04-13','16:30:00',5.61),('9650','2013-04-13','16:35:00',5.47),('9650','2013-04-13','16:40:00',5.39),('9650','2013-04-13','16:45:00',5.24),('9650','2013-04-13','16:50:00',5.16),('9650','2013-04-13','16:55:00',4.99),('9650','2013-04-13','17:00:00',4.8),('9650','2013-04-13','17:05:00',4.72),('9650','2013-04-13','17:10:00',4.62),('9650','2013-04-13','17:15:00',4.49),('9650','2013-04-13','17:20:00',4.34),('9650','2013-04-13','17:25:00',4.16),('9650','2013-04-13','17:30:00',4.2),('9650','2013-04-13','17:35:00',4.11),('9650','2013-04-13','17:40:00',3.95),('9650','2013-04-13','17:45:00',3.84),('9650','2013-04-13','17:50:00',3.69),('9650','2013-04-13','17:55:00',3.55),('9650','2013-04-13','18:00:00',3.4),('9650','2013-04-13','18:05:00',3.27),('9650','2013-04-13','18:10:00',3.1),('9650','2013-04-13','18:15:00',2.97),('9650','2013-04-13','18:20:00',2.83),('9650','2013-04-13','18:25:00',2.65),('9650','2013-04-13','18:30:00',2.48),('9650','2013-04-13','18:35:00',2.27),('9650','2013-04-13','18:40:00',2.11),('9650','2013-04-13','18:45:00',1.88),('9650','2013-04-13','18:50:00',1.7),('9650','2013-04-13','18:55:00',1.5),('9650','2013-04-13','19:00:00',1.28),('9650','2013-04-13','19:05:00',1.08),('9650','2013-04-12','08:20:00',1.09),('9650','2013-04-12','08:40:00',1.03),('9650','2013-04-12','08:45:00',1.12),('9650','2013-04-12','08:50:00',1.73),('9650','2013-04-12','08:55:00',1.9),('9650','2013-04-12','09:00:00',1.55),('9650','2013-04-12','09:05:00',1.9),('9650','2013-04-12','09:10:00',1.77),('9650','2013-04-12','09:15:00',1.34),('9650','2013-04-12','09:20:00',1.38),('9650','2013-04-12','09:25:00',1.5),('9650','2013-04-12','09:30:00',2.11),('9650','2013-04-12','09:35:00',2.18),('9650','2013-04-12','09:40:00',2.08),('9650','2013-04-12','09:45:00',2.49),('9650','2013-04-12','09:50:00',2.61),('9650','2013-04-12','09:55:00',2.79),('9650','2013-04-12','10:00:00',2.95),('9650','2013-04-12','10:05:00',3.19),('9650','2013-04-12','10:10:00',3.46),('9650','2013-04-12','10:15:00',2.99),('9650','2013-04-12','10:20:00',2.67),('9650','2013-04-12','10:25:00',3.91),('9650','2013-04-12','10:30:00',3.81),('9650','2013-04-12','10:35:00',3.14),('9650','2013-04-12','10:40:00',4.35),('9650','2013-04-12','10:45:00',3.2),('9650','2013-04-12','10:50:00',3.67),('9650','2013-04-12','10:55:00',3.93),('9650','2013-04-12','11:00:00',2.08),('9650','2013-04-12','11:05:00',4.82),('9650','2013-04-12','11:10:00',5.12),('9650','2013-04-12','11:15:00',5.6),('9650','2013-04-12','11:20:00',4.56),('9650','2013-04-12','11:30:00',1.53),('9650','2013-04-12','11:35:00',5.6),('9650','2013-04-12','11:40:00',5.58),('9650','2013-04-12','11:45:00',5.33),('9650','2013-04-12','11:50:00',3.19),('9650','2013-04-12','11:55:00',5.84),('9650','2013-04-12','12:00:00',6.14),('9650','2013-04-12','12:05:00',5.96),('9650','2013-04-12','12:10:00',6.09),('9650','2013-04-12','12:15:00',5.76),('9650','2013-04-12','12:20:00',5.94),('9650','2013-04-12','12:25:00',6.29),('9650','2013-04-12','12:30:00',6.27),('9650','2013-04-12','12:35:00',6.19),('9650','2013-04-12','12:40:00',6.16),('9650','2013-04-12','12:45:00',6.24),('9650','2013-04-12','12:50:00',6.05),('9650','2013-04-12','12:55:00',6.07),('9650','2013-04-12','13:00:00',6.17),('9650','2013-04-12','13:05:00',6.37),('9650','2013-04-12','13:10:00',6.68),('9650','2013-04-12','13:15:00',6.51),('9650','2013-04-12','13:20:00',6.55),('9650','2013-04-12','13:25:00',6.58),('9650','2013-04-12','13:30:00',5.89),('9650','2013-04-12','13:35:00',3.8),('9650','2013-04-12','13:40:00',5.33),('9650','2013-04-12','13:45:00',5.51),('9650','2013-04-12','13:50:00',3.13),('9650','2013-04-12','13:55:00',3.02),('9650','2013-04-12','14:00:00',3.42),('9650','2013-04-12','14:05:00',4),('9650','2013-04-12','14:10:00',3.47),('9650','2013-04-12','14:15:00',4.95),('9650','2013-04-12','14:20:00',6.02),('9650','2013-04-12','14:25:00',6.14),('9650','2013-04-12','14:30:00',6.19),('9650','2013-04-12','14:35:00',6.35),('9650','2013-04-12','14:40:00',6.17),('9650','2013-04-12','14:45:00',6.4),('9650','2013-04-12','14:50:00',6.14),('9650','2013-04-12','14:55:00',6.33),('9650','2013-04-12','15:00:00',5.77),('9650','2013-04-12','15:05:00',4.58),('9650','2013-04-12','15:10:00',5.57),('9650','2013-04-12','15:15:00',5.18),('9650','2013-04-12','15:20:00',5.06),('9650','2013-04-12','15:25:00',4.74),('9650','2013-04-12','15:30:00',4.87),('9650','2013-04-12','15:35:00',4.77),('9650','2013-04-12','15:40:00',5.04),('9650','2013-04-12','15:45:00',5.14),('9650','2013-04-12','15:50:00',4.98),('9650','2013-04-12','15:55:00',4.92),('9650','2013-04-12','16:00:00',4.74),('9650','2013-04-12','16:05:00',4.57),('9650','2013-04-12','16:10:00',4.38),('9650','2013-04-12','16:15:00',4.58),('9650','2013-04-12','16:20:00',4.37),('9650','2013-04-12','16:25:00',4.19),('9650','2013-04-12','16:30:00',4.18),('9650','2013-04-12','16:35:00',3.86),('9650','2013-04-12','16:40:00',3.57),('9650','2013-04-12','16:45:00',3.35),('9650','2013-04-12','16:50:00',3.42),('9650','2013-04-12','16:55:00',2.78),('9650','2013-04-12','17:00:00',2.23),('9650','2013-04-12','17:05:00',2.14),('9650','2013-04-12','17:10:00',3.25),('9650','2013-04-12','17:15:00',3.93),('9650','2013-04-12','17:20:00',3.53),('9650','2013-04-12','17:25:00',4.22),('9650','2013-04-12','17:30:00',3.75),('9650','2013-04-12','17:35:00',3.79),('9650','2013-04-12','17:40:00',3.78),('9650','2013-04-12','17:45:00',3.58),('9650','2013-04-12','17:50:00',3.25),('9650','2013-04-12','17:55:00',3.58),('9650','2013-04-12','18:00:00',2.82),('9650','2013-04-12','18:05:00',2.94),('9650','2013-04-12','18:10:00',2.67),('9650','2013-04-12','18:15:00',2.81),('9650','2013-04-12','18:20:00',2.88),('9650','2013-04-12','18:25:00',2.74),('9650','2013-04-12','18:30:00',2.62),('9650','2013-04-12','18:35:00',2.33),('9650','2013-04-12','18:40:00',2.07),('9650','2013-04-12','18:45:00',1.83),('9650','2013-04-12','18:50:00',1.55),('9650','2013-04-12','18:55:00',1.33),('9650','2013-04-12','19:00:00',1.11),('9650','2013-04-11','08:10:00',1.27),('9650','2013-04-11','08:15:00',1.28),('9650','2013-04-11','08:20:00',1.29),('9650','2013-04-11','08:25:00',1.14),('9650','2013-04-11','08:30:00',1.27),('9650','2013-04-11','08:35:00',1.31),('9650','2013-04-11','08:40:00',1.2),('9650','2013-04-11','08:45:00',1.39),('9650','2013-04-11','08:50:00',1.82),('9650','2013-04-11','08:55:00',1.97),('9650','2013-04-11','09:00:00',2.12),('9650','2013-04-11','09:05:00',1.75),('9650','2013-04-11','09:10:00',1.67),('9650','2013-04-11','09:15:00',2.44),('9650','2013-04-11','09:20:00',2.89),('9650','2013-04-11','09:25:00',2.38),('9650','2013-04-11','09:30:00',1.95),('9650','2013-04-11','09:35:00',2.06),('9650','2013-04-11','09:40:00',2.03),('9650','2013-04-11','09:45:00',2.15),('9650','2013-04-11','09:50:00',1.55),('9650','2013-04-11','09:55:00',1.59),('9650','2013-04-11','10:00:00',1.52),('9650','2013-04-11','10:05:00',1.75),('9650','2013-04-11','10:10:00',1.55),('9650','2013-04-11','10:15:00',1.62),('9650','2013-04-11','10:20:00',3.7),('9650','2013-04-11','10:25:00',3.15),('9650','2013-04-11','10:30:00',2.33),('9650','2013-04-11','10:35:00',4.05),('9650','2013-04-11','10:40:00',5.47),('9650','2013-04-11','10:45:00',5.81),('9650','2013-04-11','10:50:00',4.97),('9650','2013-04-11','10:55:00',2.9),('9650','2013-04-11','11:00:00',2.09),('9650','2013-04-11','11:05:00',3.02),('9650','2013-04-11','11:10:00',2.4),('9650','2013-04-11','11:15:00',5.42),('9650','2013-04-11','11:20:00',6.15),('9650','2013-04-11','11:25:00',6.02),('9650','2013-04-11','11:30:00',6.42),('9650','2013-04-11','11:35:00',4.39),('9650','2013-04-11','11:40:00',2.61),('9650','2013-04-11','11:45:00',2.77),('9650','2013-04-11','11:50:00',2.69),('9650','2013-04-11','11:55:00',5.72),('9650','2013-04-11','12:00:00',6.08),('9650','2013-04-11','12:05:00',5.96),('9650','2013-04-11','12:10:00',5.67),('9650','2013-04-11','12:15:00',5.94),('9650','2013-04-11','12:20:00',6.08),('9650','2013-04-11','12:25:00',5.92),('9650','2013-04-11','12:30:00',5.95),('9650','2013-04-11','12:35:00',6.04),('9650','2013-04-11','12:40:00',5.84),('9650','2013-04-11','12:45:00',6.09),('9650','2013-04-11','12:50:00',4.55),('9650','2013-04-11','12:55:00',5.87),('9650','2013-04-11','13:00:00',6.28),('9650','2013-04-11','13:05:00',6.32),('9650','2013-04-11','13:10:00',6.4),('9650','2013-04-11','13:15:00',6.46),('9650','2013-04-11','13:20:00',6.49),('9650','2013-04-11','13:25:00',6.53),('9650','2013-04-11','13:30:00',6.54),('9650','2013-04-11','13:35:00',6.65),('9650','2013-04-11','13:40:00',6.53),('9650','2013-04-11','13:45:00',6.6),('9650','2013-04-11','13:50:00',6.61),('9650','2013-04-11','13:55:00',6.66),('9650','2013-04-11','14:00:00',6.74),('9650','2013-04-11','14:05:00',6.72),('9650','2013-04-11','14:10:00',6.72),('9650','2013-04-11','14:15:00',6.67),('9650','2013-04-11','14:20:00',6.69),('9650','2013-04-11','14:25:00',6.71),('9650','2013-04-11','14:30:00',6.72),('9650','2013-04-11','14:35:00',6.66),('9650','2013-04-11','14:40:00',6.63),('9650','2013-04-11','14:45:00',6.62),('9650','2013-04-11','14:50:00',6.6),('9650','2013-04-11','14:55:00',6.58),('9650','2013-04-11','15:00:00',6.55),('9650','2013-04-11','15:05:00',6.47),('9650','2013-04-11','15:10:00',6.4),('9650','2013-04-11','15:15:00',6.39),('9650','2013-04-11','15:20:00',6.37),('9650','2013-04-11','15:25:00',6.29),('9650','2013-04-11','15:30:00',6.29),('9650','2013-04-11','15:35:00',6.24),('9650','2013-04-11','15:40:00',6.17),('9650','2013-04-11','15:45:00',6.08),('9650','2013-04-11','15:50:00',6.04),('9650','2013-04-11','15:55:00',5.96),('9650','2013-04-11','16:00:00',5.86),('9650','2013-04-11','16:05:00',5.8),('9650','2013-04-11','16:10:00',5.84),('9650','2013-04-11','16:15:00',5.27),('9650','2013-04-11','16:20:00',5.52),('9650','2013-04-11','16:25:00',5.62),('9650','2013-04-11','16:30:00',3.36),('9650','2013-04-11','16:35:00',2.5),('9650','2013-04-11','16:40:00',3.41),('9650','2013-04-11','16:45:00',5.24),('9650','2013-04-11','16:50:00',4.96),('9650','2013-04-11','16:55:00',4.86),('9650','2013-04-11','17:00:00',4.7),('9650','2013-04-11','17:05:00',4.62),('9650','2013-04-11','17:10:00',4.42),('9650','2013-04-11','17:15:00',4.37),('9650','2013-04-11','17:20:00',4.26),('9650','2013-04-11','17:25:00',4.19),('9650','2013-04-11','17:30:00',4.14),('9650','2013-04-11','17:35:00',4.01),('9650','2013-04-11','17:40:00',3.81),('9650','2013-04-11','17:45:00',3.6),('9650','2013-04-11','17:50:00',3.57),('9650','2013-04-11','17:55:00',3.45),('9650','2013-04-11','18:00:00',3.28),('9650','2013-04-11','18:05:00',3.13),('9650','2013-04-11','18:10:00',2.88),('9650','2013-04-11','18:15:00',2.6),('9650','2013-04-11','18:20:00',2.48),('9650','2013-04-11','18:25:00',2.04),('9650','2013-04-11','18:30:00',1.91),('9650','2013-04-11','18:35:00',1.89),('9650','2013-04-11','18:45:00',1.22),('9650','2013-04-11','18:50:00',1.22),('9650','2014-03-27','08:20:00',1.07),('9650','2014-03-27','08:25:00',1.18),('9650','2014-03-27','08:30:00',1.29),('9650','2014-03-27','08:35:00',1.44),('9650','2014-03-27','08:40:00',1.59),('9650','2014-03-27','08:45:00',1.74),('9650','2014-03-27','08:50:00',1.92),('9650','2014-03-27','08:55:00',2.11),('9650','2014-03-27','09:00:00',2.3),('9650','2014-03-27','09:05:00',2.56),('9650','2014-03-27','09:10:00',2.87),('9650','2014-03-27','09:15:00',3.01),('9650','2014-03-27','09:20:00',2.92),('9650','2014-03-27','09:25:00',3.6),('9650','2014-03-27','09:30:00',3.81),('9650','2014-03-27','09:35:00',3.49),('9650','2014-03-27','09:40:00',2.2),('9650','2014-03-27','09:45:00',2.02),('9650','2014-03-27','09:50:00',2.66),('9650','2014-03-27','09:55:00',3.91),('9650','2014-03-27','10:00:00',4),('9650','2014-03-27','10:05:00',4.1),('9650','2014-03-27','10:10:00',3.83),('9650','2014-03-27','10:15:00',2.9),('9650','2014-03-27','10:20:00',2.91),('9650','2014-03-27','10:25:00',4.19),('9650','2014-03-27','10:30:00',4.53),('9650','2014-03-27','10:35:00',4.48),('9650','2014-03-27','10:40:00',4.27),('9650','2014-03-27','10:45:00',3.35),('9650','2014-03-27','10:50:00',5.06),('9650','2014-03-27','10:55:00',5.11),('9650','2014-03-27','11:00:00',5.18),('9650','2014-03-27','11:05:00',5.03),('9650','2014-03-27','11:10:00',4.11),('9650','2014-03-27','11:15:00',3.56),('9650','2014-03-27','11:20:00',2.63),('9650','2014-03-27','11:25:00',3.26),('9650','2014-03-27','11:30:00',3.5),('9650','2014-03-27','11:35:00',2.54),('9650','2014-03-27','11:40:00',2.37),('9650','2014-03-27','11:45:00',4.97),('9650','2014-03-27','11:50:00',3.29),('9650','2014-03-27','11:55:00',2.62),('9650','2014-03-27','12:00:00',2.99),('9650','2014-03-27','12:05:00',6.65),('9650','2014-03-27','12:10:00',6.77),('9650','2014-03-27','12:15:00',7.23),('9650','2014-03-27','12:20:00',7.14),('9650','2014-03-27','12:25:00',1.93),('9650','2014-03-27','12:30:00',1.5),('9650','2014-03-27','12:35:00',5.01),('9650','2014-03-27','12:40:00',6.59),('9650','2014-03-27','12:45:00',6.74),('9650','2014-03-27','12:50:00',7.02),('9650','2014-03-27','12:55:00',7.49),('9650','2014-03-27','13:00:00',8.01),('9650','2014-03-27','13:05:00',4),('9650','2014-03-27','13:10:00',2.87),('9650','2014-03-27','13:15:00',2.84),('9650','2014-03-27','13:20:00',5.84),('9650','2014-03-27','13:25:00',3.06),('9650','2014-03-27','13:30:00',2.4),('9650','2014-03-27','13:35:00',6.65),('9650','2014-03-27','13:40:00',7.24),('9650','2014-03-27','13:45:00',6.82),('9650','2014-03-27','13:50:00',6.57),('9650','2014-03-27','13:55:00',6.35),('9650','2014-03-27','14:00:00',6.5),('9650','2014-03-27','14:05:00',6.29),('9650','2014-03-27','14:10:00',6.11),('9650','2014-03-27','14:15:00',6.05),('9650','2014-03-27','14:20:00',6.03),('9650','2014-03-27','14:25:00',6.02),('9650','2014-03-27','14:30:00',6.01),('9650','2014-03-27','14:35:00',6),('9650','2014-03-27','14:40:00',5.98),('9650','2014-03-27','14:45:00',5.88),('9650','2014-03-27','14:50:00',5.63),('9650','2014-03-27','14:55:00',5.58),('9650','2014-03-27','15:00:00',5.58),('9650','2014-03-27','15:05:00',5.45),('9650','2014-03-27','15:10:00',5.36),('9650','2014-03-27','15:15:00',5.3),('9650','2014-03-27','15:20:00',5.22),('9650','2014-03-27','15:25:00',5.1),('9650','2014-03-27','15:30:00',4.99),('9650','2014-03-27','15:35:00',4.93),('9650','2014-03-27','15:40:00',4.85),('9650','2014-03-27','15:45:00',4.82),('9650','2014-03-27','15:50:00',4.81),('9650','2014-03-27','15:55:00',4.24),('9650','2014-03-27','16:00:00',5.02),('9650','2014-03-27','16:05:00',5.11),('9650','2014-03-27','16:10:00',4.98),('9650','2014-03-27','16:15:00',4.81),('9650','2014-03-27','16:20:00',4.21),('9650','2014-03-27','16:25:00',3.87),('9650','2014-03-27','16:30:00',3.85),('9650','2014-03-27','16:35:00',2.38),('9650','2014-03-27','16:40:00',2.39),('9650','2014-03-27','16:45:00',2.67),('9650','2014-03-27','16:50:00',3.02),('9650','2014-03-27','16:55:00',1.52),('9650','2014-03-27','17:00:00',2.32),('9650','2014-03-27','17:05:00',2.51),('9650','2014-03-27','17:10:00',2.72),('9650','2014-03-27','17:15:00',2.78),('9650','2014-03-27','17:20:00',2.83),('9650','2014-03-27','17:25:00',1.4),('9650','2014-03-27','17:35:00',1.46),('9650','2014-03-27','17:40:00',1.37),('9650','2014-03-27','17:45:00',1.61),('9650','2014-03-27','17:50:00',1.35),('9650','2013-04-10','08:50:00',1.03),('9650','2013-04-10','08:55:00',1.15),('9650','2013-04-10','09:00:00',1.23),('9650','2013-04-10','09:05:00',1.31),('9650','2013-04-10','09:10:00',1.47),('9650','2013-04-10','09:15:00',1.62),('9650','2013-04-10','09:20:00',1.75),('9650','2013-04-10','09:25:00',1.85),('9650','2013-04-10','09:30:00',2.02),('9650','2013-04-10','09:35:00',2.17),('9650','2013-04-10','09:40:00',1.96),('9650','2013-04-10','09:45:00',2.64),('9650','2013-04-10','09:50:00',2.03),('9650','2013-04-10','09:55:00',1.52),('9650','2013-04-10','10:00:00',1.67),('9650','2013-04-10','10:05:00',2.31),('9650','2013-04-10','10:10:00',1.8),('9650','2013-04-10','10:15:00',3.31),('9650','2013-04-10','10:20:00',3.5),('9650','2013-04-10','10:25:00',3.92),('9650','2013-04-10','10:30:00',4.18),('9650','2013-04-10','10:35:00',4.58),('9650','2013-04-10','10:40:00',4.76),('9650','2013-04-10','10:45:00',4.13),('9650','2013-04-10','10:50:00',1.49),('9650','2013-04-10','11:00:00',1.2),('9650','2013-04-10','11:05:00',4.83),('9650','2013-04-10','11:10:00',4.86),('9650','2013-04-10','11:15:00',5.09),('9650','2013-04-10','11:20:00',3),('9650','2013-04-10','11:25:00',3),('9650','2013-04-10','11:30:00',6.2),('9650','2013-04-10','11:35:00',4.95),('9650','2013-04-10','11:40:00',2),('9650','2013-04-10','11:45:00',1.83),('9650','2013-04-10','11:50:00',3.69),('9650','2013-04-10','11:55:00',6.69),('9650','2013-04-10','12:00:00',6.84),('9650','2013-04-10','12:05:00',6.43),('9650','2013-04-10','12:10:00',6.59),('9650','2013-04-10','12:15:00',6.43),('9650','2013-04-10','12:20:00',4.31),('9650','2013-04-10','12:25:00',6.31),('9650','2013-04-10','12:30:00',5.65),('9650','2013-04-10','12:35:00',6.22),('9650','2013-04-10','12:40:00',5.35),('9650','2013-04-10','12:45:00',3.31),('9650','2013-04-10','12:50:00',6.62),('9650','2013-04-10','12:55:00',6.69),('9650','2013-04-10','13:00:00',6.98),('9650','2013-04-10','13:05:00',6.94),('9650','2013-04-10','13:10:00',6.51),('9650','2013-04-10','13:15:00',6.16),('9650','2013-04-10','13:20:00',5.67),('9650','2013-04-10','13:25:00',6.65),('9650','2013-04-10','13:30:00',6.6),('9650','2013-04-10','13:35:00',6.73),('9650','2013-04-10','13:40:00',6.67),('9650','2013-04-10','13:45:00',6.58),('9650','2013-04-10','13:50:00',6.62),('9650','2013-04-10','13:55:00',6.67),('9650','2013-04-10','14:00:00',6.76),('9650','2013-04-10','14:05:00',6.77),('9650','2013-04-10','14:10:00',6.89),('9650','2013-04-10','14:15:00',6.84),('9650','2013-04-10','14:20:00',6.83),('9650','2013-04-10','14:25:00',6.74),('9650','2013-04-10','14:30:00',6.71),('9650','2013-04-10','14:35:00',6.8),('9650','2013-04-10','14:40:00',6.89),('9650','2013-04-10','14:45:00',6.75),('9650','2013-04-10','14:50:00',6.64),('9650','2013-04-10','14:55:00',6.67),('9650','2013-04-10','15:00:00',6.53),('9650','2013-04-10','15:05:00',6.43),('9650','2013-04-10','15:10:00',6.47),('9650','2013-04-10','15:15:00',6.37),('9650','2013-04-10','15:20:00',6.4),('9650','2013-04-10','15:25:00',6.37),('9650','2013-04-10','15:30:00',6.33),('9650','2013-04-10','15:35:00',6.23),('9650','2013-04-10','15:40:00',6.14),('9650','2013-04-10','15:45:00',6.07),('9650','2013-04-10','15:50:00',6.03),('9650','2013-04-10','15:55:00',5.95),('9650','2013-04-10','16:00:00',5.91),('9650','2013-04-10','16:05:00',5.81),('9650','2013-04-10','16:10:00',5.73),('9650','2013-04-10','16:15:00',5.68),('9650','2013-04-10','16:20:00',5.64),('9650','2013-04-10','16:25:00',5.56),('9650','2013-04-10','16:30:00',5.49),('9650','2013-04-10','16:35:00',5.38),('9650','2013-04-10','16:40:00',5.24),('9650','2013-04-10','16:45:00',5.14),('9650','2013-04-10','16:50:00',5.04),('9650','2013-04-10','16:55:00',4.93),('9650','2013-04-10','17:00:00',4.77),('9650','2013-04-10','17:05:00',4.64),('9650','2013-04-10','17:10:00',4.52),('9650','2013-04-10','17:15:00',4.4),('9650','2013-04-10','17:20:00',4.3),('9650','2013-04-10','17:25:00',4.21),('9650','2013-04-10','17:30:00',4.14),('9650','2013-04-10','17:35:00',4.07),('9650','2013-04-10','17:40:00',3.87),('9650','2013-04-10','17:45:00',3.81),('9650','2013-04-10','17:50:00',3.77),('9650','2013-04-10','17:55:00',3.52),('9650','2013-04-10','18:00:00',3.33),('9650','2013-04-10','18:05:00',3.03),('9650','2013-04-10','18:10:00',2.72),('9650','2013-04-10','18:15:00',2.89),('9650','2013-04-10','18:20:00',2.88),('9650','2013-04-10','18:25:00',2.77),('9650','2013-04-10','18:30:00',2.46),('9650','2013-04-10','18:35:00',2.35),('9650','2013-04-10','18:40:00',2.04),('9650','2013-04-10','18:45:00',1.71),('9650','2013-04-09','08:55:00',1.2),('9650','2013-04-09','09:00:00',1.33),('9650','2013-04-09','09:05:00',1.55),('9650','2013-04-09','09:10:00',1.7),('9650','2013-04-09','09:15:00',1.78),('9650','2013-04-09','09:20:00',1.78),('9650','2013-04-09','09:25:00',1.82),('9650','2013-04-09','09:30:00',2.04),('9650','2013-04-09','09:35:00',2.13),('9650','2013-04-09','09:40:00',2.3),('9650','2013-04-09','09:45:00',2.4),('9650','2013-04-09','09:50:00',2.58),('9650','2013-04-09','09:55:00',2.76),('9650','2013-04-09','10:00:00',2.85),('9650','2013-04-09','10:05:00',3.03),('9650','2013-04-09','10:10:00',3.25),('9650','2013-04-09','10:15:00',3.42),('9650','2013-04-09','10:20:00',3.54),('9650','2013-04-09','10:25:00',3.66),('9650','2013-04-09','10:30:00',3.76),('9650','2013-04-09','10:35:00',3.87),('9650','2013-04-09','10:40:00',3.98),('9650','2013-04-09','10:45:00',4.22),('9650','2013-04-09','10:50:00',4.08),('9650','2013-04-09','10:55:00',4.03),('9650','2013-04-09','11:00:00',4.21),('9650','2013-04-09','11:05:00',4.22),('9650','2013-04-09','11:10:00',4.41),('9650','2013-04-09','11:15:00',4.39),('9650','2013-04-09','11:20:00',4.62),('9650','2013-04-09','11:25:00',4.86),('9650','2013-04-09','11:30:00',4.94),('9650','2013-04-09','11:35:00',5.11),('9650','2013-04-09','11:40:00',5.22),('9650','2013-04-09','11:45:00',5.11),('9650','2013-04-09','11:50:00',5.43),('9650','2013-04-09','11:55:00',5.53),('9650','2013-04-09','12:00:00',5.69),('9650','2013-04-09','12:05:00',5.89),('9650','2013-04-09','12:10:00',6),('9650','2013-04-09','12:15:00',6.12),('9650','2013-04-09','12:20:00',6.22),('9650','2013-04-09','12:25:00',6.35),('9650','2013-04-09','12:30:00',6.45),('9650','2013-04-09','12:35:00',5.92),('9650','2013-04-09','12:40:00',6.32),('9650','2013-04-09','12:45:00',6.36),('9650','2013-04-09','12:50:00',6.58),('9650','2013-04-09','12:55:00',6.62),('9650','2013-04-09','13:00:00',5.38),('9650','2013-04-09','13:05:00',5.36),('9650','2013-04-09','13:10:00',3.49),('9650','2013-04-09','13:15:00',5.27),('9650','2013-04-09','13:20:00',7.5),('9650','2013-04-09','13:25:00',5.2),('9650','2013-04-09','13:30:00',6.84),('9650','2013-04-09','13:35:00',6.66),('9650','2013-04-09','13:40:00',5.21),('9650','2013-04-09','13:45:00',3.13),('9650','2013-04-09','13:50:00',7.44),('9650','2013-04-09','13:55:00',4.61),('9650','2013-04-09','14:00:00',7.24),('9650','2013-04-09','14:05:00',7),('9650','2013-04-09','14:10:00',7.02),('9650','2013-04-09','14:15:00',6.91),('9650','2013-04-09','14:20:00',6.91),('9650','2013-04-09','14:25:00',6.98),('9650','2013-04-09','14:30:00',7),('9650','2013-04-09','14:35:00',6.7),('9650','2013-04-09','14:40:00',6.95),('9650','2013-04-09','14:45:00',7.11),('9650','2013-04-09','14:50:00',7.11),('9650','2013-04-09','14:55:00',6.94),('9650','2013-04-09','15:00:00',7.03),('9650','2013-04-09','15:05:00',6.81),('9650','2013-04-09','15:10:00',5.05),('9650','2013-04-09','15:15:00',6.73),('9650','2013-04-09','15:20:00',7),('9650','2013-04-09','15:25:00',6.51),('9650','2013-04-09','15:30:00',6.35),('9650','2013-04-09','15:35:00',5.9),('9650','2013-04-09','15:40:00',6.1),('9650','2013-04-09','15:45:00',6.25),('9650','2013-04-09','15:50:00',6.33),('9650','2013-04-09','15:55:00',5.98),('9650','2013-04-09','16:00:00',4.88),('9650','2013-04-09','16:05:00',5.75),('9650','2013-04-09','16:10:00',5.9),('9650','2013-04-09','16:15:00',5.84),('9650','2013-04-09','16:20:00',4.82),('9650','2013-04-09','16:25:00',5.47),('9650','2013-04-09','16:30:00',5.12),('9650','2013-04-09','16:35:00',3.62),('9650','2013-04-09','16:40:00',4.82),('9650','2013-04-09','16:45:00',5.31),('9650','2013-04-09','16:50:00',3.74),('9650','2013-04-09','16:55:00',4.64),('9650','2013-04-09','17:00:00',4.99),('9650','2013-04-09','17:05:00',3.49),('9650','2013-04-09','17:10:00',3.68),('9650','2013-04-09','17:15:00',4.25),('9650','2013-04-09','17:20:00',4.46),('9650','2013-04-09','17:25:00',3.84),('9650','2013-04-09','17:30:00',4.11),('9650','2013-04-09','17:35:00',3.39),('9650','2013-04-09','17:40:00',3.02),('9650','2013-04-09','17:45:00',3.88),('9650','2013-04-09','17:50:00',2.69),('9650','2013-04-09','17:55:00',3.53),('9650','2013-04-09','18:00:00',2.62),('9650','2013-04-09','18:05:00',2.62),('9650','2013-04-09','18:10:00',2.41),('9650','2013-04-09','18:15:00',2),('9650','2013-04-09','18:20:00',1.14),('9650','2013-04-08','08:20:00',1.1),('9650','2013-04-08','08:25:00',1.12),('9650','2013-04-08','08:30:00',1.12),('9650','2013-04-08','08:35:00',1.02),('9650','2013-04-08','09:00:00',1.04),('9650','2013-04-08','09:05:00',1.45),('9650','2013-04-08','09:10:00',1.62),('9650','2013-04-08','09:15:00',1.7),('9650','2013-04-08','09:20:00',1.52),('9650','2013-04-08','09:25:00',1.67),('9650','2013-04-08','09:30:00',1.58),('9650','2013-04-08','09:35:00',1.09),('9650','2013-04-08','09:40:00',1.24),('9650','2013-04-08','09:45:00',1.88),('9650','2013-04-08','09:50:00',2.75),('9650','2013-04-08','09:55:00',3.74),('9650','2013-04-08','10:00:00',2.37),('9650','2013-04-08','10:05:00',1.71),('9650','2013-04-08','10:10:00',2.63),('9650','2013-04-08','10:15:00',3.16),('9650','2013-04-08','10:20:00',2.23),('9650','2013-04-08','10:25:00',1.06),('9650','2013-04-08','10:30:00',1.51),('9650','2013-04-08','10:35:00',3.37),('9650','2013-04-08','10:40:00',3.68),('9650','2013-04-08','10:45:00',5.38),('9650','2013-04-08','10:50:00',4.67),('9650','2013-04-08','10:55:00',4.56),('9650','2013-04-08','11:00:00',4.65),('9650','2013-04-08','11:05:00',4.54),('9650','2013-04-08','11:10:00',4.99),('9650','2013-04-08','11:15:00',1.48),('9650','2013-04-08','11:20:00',1.89),('9650','2013-04-08','11:25:00',3.96),('9650','2013-04-08','11:30:00',5.89),('9650','2013-04-08','11:35:00',3.37),('9650','2013-04-08','11:40:00',2.25),('9650','2013-04-08','11:45:00',4.36),('9650','2013-04-08','11:50:00',6.32),('9650','2013-04-08','11:55:00',4.51),('9650','2013-04-08','12:00:00',6.45),('9650','2013-04-08','12:05:00',6.37),('9650','2013-04-08','12:10:00',6.47),('9650','2013-04-08','12:15:00',6.52),('9650','2013-04-08','12:20:00',5.56),('9650','2013-04-08','12:25:00',6.2),('9650','2013-04-08','12:30:00',6.41),('9650','2013-04-08','12:35:00',6.42),('9650','2013-04-08','12:40:00',6.4),('9650','2013-04-08','12:45:00',6.6),('9650','2013-04-08','12:50:00',6.94),('9650','2013-04-08','12:55:00',6.35),('9650','2013-04-08','13:00:00',6.77),('9650','2013-04-08','13:05:00',7.03),('9650','2013-04-08','13:10:00',7.6),('9650','2013-04-08','13:15:00',6.4),('9650','2013-04-08','13:20:00',4.15),('9650','2013-04-08','13:25:00',6.61),('9650','2013-04-08','13:30:00',2.91),('9650','2013-04-08','13:35:00',2.84),('9650','2013-04-08','13:40:00',3.56),('9650','2013-04-08','13:45:00',3.3),('9650','2013-04-08','13:50:00',7.15),('9650','2013-04-08','13:55:00',7.06),('9650','2013-04-08','14:00:00',6.59),('9650','2013-04-08','14:05:00',5.56),('9650','2013-04-08','14:10:00',4.94),('9650','2013-04-08','14:15:00',6.4),('9650','2013-04-08','14:20:00',3.71),('9650','2013-04-08','14:25:00',4.74),('9650','2013-04-08','14:30:00',4.94),('9650','2013-04-08','14:35:00',6.44),('9650','2013-04-08','14:40:00',6.43),('9650','2013-04-08','14:45:00',6.24),('9650','2013-04-08','14:50:00',5.51),('9650','2013-04-08','14:55:00',4.49),('9650','2013-04-08','15:00:00',6.74),('9650','2013-04-08','15:05:00',6.4),('9650','2013-04-08','15:10:00',6.46),('9650','2013-04-08','15:15:00',4.91),('9650','2013-04-08','15:20:00',6.91),('9650','2013-04-08','15:25:00',6.89),('9650','2013-04-08','15:30:00',3.65),('9650','2013-04-08','15:35:00',6.93),('9650','2013-04-08','15:40:00',6.6),('9650','2013-04-08','15:45:00',5.77),('9650','2013-04-08','15:50:00',6.56),('9650','2013-04-08','15:55:00',5.29),('9650','2013-04-08','16:00:00',4.83),('9650','2013-04-08','16:05:00',4.93),('9650','2013-04-08','16:10:00',3.88),('9650','2013-04-08','16:15:00',3.83),('9650','2013-04-08','16:20:00',1.24),('9650','2013-04-08','16:25:00',2.27),('9650','2013-04-08','16:30:00',1.94),('9650','2013-04-08','16:35:00',2.27),('9650','2013-04-08','16:40:00',2.24),('9650','2013-04-08','16:45:00',1.82),('9650','2013-04-08','16:50:00',5.56),('9650','2013-04-08','16:55:00',4.55),('9650','2013-04-08','17:00:00',1.48),('9650','2013-04-08','17:05:00',1.28),('9650','2013-04-08','17:10:00',1.17),('9650','2013-04-08','17:15:00',2.24),('9650','2013-04-08','17:20:00',2.57),('9650','2013-04-08','17:25:00',1.9),('9650','2013-04-08','17:30:00',2.66),('9650','2013-04-08','17:35:00',2.06),('9650','2013-04-08','17:40:00',2.14),('9650','2013-04-08','17:45:00',1.48),('9650','2013-04-08','17:50:00',1.18),('9650','2013-04-08','17:55:00',1.08),('9650','2013-04-08','18:00:00',1.2),('9650','2013-04-08','18:05:00',1.23),('9650','2013-04-08','18:10:00',1.22),('9650','2013-04-08','18:15:00',2.07),('9650','2013-04-08','18:20:00',2.27),('9650','2013-04-07','08:20:00',1.1),('9650','2013-04-07','08:25:00',1.08),('9650','2013-04-07','08:30:00',1.15),('9650','2013-04-07','08:35:00',1.06),('9650','2013-04-07','08:40:00',1.12),('9650','2013-04-07','08:45:00',1.11),('9650','2013-04-07','08:50:00',1.3),('9650','2013-04-07','08:55:00',1.21),('9650','2013-04-07','09:00:00',1.49),('9650','2013-04-07','09:05:00',1.32),('9650','2013-04-07','09:10:00',1.38),('9650','2013-04-07','09:15:00',1.71),('9650','2013-04-07','09:20:00',2.07),('9650','2013-04-07','09:25:00',2.11),('9650','2013-04-07','09:30:00',2.14),('9650','2013-04-07','09:35:00',2.4),('9650','2013-04-07','09:40:00',2.58),('9650','2013-04-07','09:45:00',2.75),('9650','2013-04-07','09:50:00',1.75),('9650','2013-04-07','09:55:00',1.8),('9650','2013-04-07','10:00:00',2.79),('9650','2013-04-07','10:05:00',3.1),('9650','2013-04-07','10:10:00',3.11),('9650','2013-04-07','10:15:00',3.22),('9650','2013-04-07','10:20:00',3.29),('9650','2013-04-07','10:25:00',3.39),('9650','2013-04-07','10:30:00',3.55),('9650','2013-04-07','10:35:00',3.45),('9650','2013-04-07','10:40:00',3.93),('9650','2013-04-07','10:45:00',4.28),('9650','2013-04-07','10:50:00',4.41),('9650','2013-04-07','10:55:00',4.4),('9650','2013-04-07','11:00:00',4.77),('9650','2013-04-07','11:05:00',4.31),('9650','2013-04-07','11:10:00',4.24),('9650','2013-04-07','11:15:00',4),('9650','2013-04-07','11:20:00',3.56),('9650','2013-04-07','11:25:00',3.2),('9650','2013-04-07','11:30:00',3.62),('9650','2013-04-07','11:35:00',4.53),('9650','2013-04-07','11:40:00',4.8),('9650','2013-04-07','11:45:00',4.36),('9650','2013-04-07','11:50:00',4.09),('9650','2013-04-07','11:55:00',3.8),('9650','2013-04-07','12:00:00',3.65),('9650','2013-04-07','12:05:00',3.55),('9650','2013-04-07','12:10:00',3.79),('9650','2013-04-07','12:15:00',4.31),('9650','2013-04-07','12:20:00',4.33),('9650','2013-04-07','12:25:00',4.25),('9650','2013-04-07','12:30:00',4.76),('9650','2013-04-07','12:35:00',4.26),('9650','2013-04-07','12:40:00',4.12),('9650','2013-04-07','12:45:00',5.75),('9650','2013-04-07','12:50:00',4.3),('9650','2013-04-07','12:55:00',3.22),('9650','2013-04-07','13:00:00',2.99),('9650','2013-04-07','13:05:00',4.12),('9650','2013-04-07','13:10:00',4.5),('9650','2013-04-07','13:15:00',5.05),('9650','2013-04-07','13:20:00',5.9),('9650','2013-04-07','13:25:00',5.26),('9650','2013-04-07','13:30:00',4.55),('9650','2013-04-07','13:35:00',3.8),('9650','2013-04-07','13:40:00',4.24),('9650','2013-04-07','13:45:00',5.04),('9650','2013-04-07','13:50:00',4.92),('9650','2013-04-07','13:55:00',6.5),('9650','2013-04-07','14:00:00',6.17),('9650','2013-04-07','14:05:00',5.5),('9650','2013-04-07','14:10:00',5.62),('9650','2013-04-07','14:15:00',6.44),('9650','2013-04-07','14:20:00',5.67),('9650','2013-04-07','14:25:00',6.79),('9650','2013-04-07','14:30:00',6.6),('9650','2013-04-07','14:35:00',6.16),('9650','2013-04-07','14:40:00',6.26),('9650','2013-04-07','14:45:00',6.53),('9650','2013-04-07','14:50:00',6.41),('9650','2013-04-07','14:55:00',6.79),('9650','2013-04-07','15:00:00',5.08),('9650','2013-04-07','15:05:00',4.99),('9650','2013-04-07','15:10:00',5.12),('9650','2013-04-07','15:15:00',5.16),('9650','2013-04-07','15:20:00',5.26),('9650','2013-04-07','15:25:00',6.25),('9650','2013-04-07','15:30:00',6.52),('9650','2013-04-07','15:35:00',6.33),('9650','2013-04-07','15:40:00',6.19),('9650','2013-04-07','15:45:00',6.16),('9650','2013-04-07','15:50:00',6.06),('9650','2013-04-07','15:55:00',5.96),('9650','2013-04-07','16:00:00',5.66),('9650','2013-04-07','16:05:00',5.55),('9650','2013-04-07','16:10:00',5.31),('9650','2013-04-07','16:15:00',5.59),('9650','2013-04-07','16:20:00',5.71),('9650','2013-04-07','16:25:00',5.52),('9650','2013-04-07','16:30:00',5.42),('9650','2013-04-07','16:35:00',5.29),('9650','2013-04-07','16:40:00',5.07),('9650','2013-04-07','16:45:00',4.95),('9650','2013-04-07','16:50:00',4.93),('9650','2013-04-07','16:55:00',4.83),('9650','2013-04-07','17:00:00',4.8),('9650','2013-04-07','17:05:00',4.68),('9650','2013-04-07','17:10:00',4.46),('9650','2013-04-07','17:15:00',4.34),('9650','2013-04-07','17:20:00',4.16),('9650','2013-04-07','17:25:00',4.33),('9650','2013-04-07','17:30:00',4.09),('9650','2013-04-07','17:35:00',3.93),('9650','2013-04-07','17:40:00',3.63),('9650','2013-04-07','17:45:00',3.47),('9650','2013-04-07','17:50:00',2.94),('9650','2013-04-07','17:55:00',2.61),('9650','2013-04-07','18:00:00',2.9),('9650','2013-04-07','18:05:00',1.87),('9650','2013-04-07','18:10:00',1.47),('9650','2013-04-07','18:15:00',2.34),('9650','2013-04-07','18:20:00',3.42),('9650','2013-04-07','18:25:00',3.03),('9650','2013-04-07','18:30:00',1.98),('9650','2013-04-07','18:40:00',1.14),('9650','2013-04-06','08:55:00',1),('9650','2013-04-06','09:00:00',1.09),('9650','2013-04-06','09:05:00',1.17),('9650','2013-04-06','09:10:00',1.25),('9650','2013-04-06','09:15:00',1.28),('9650','2013-04-06','09:20:00',1.32),('9650','2013-04-06','09:25:00',1.52),('9650','2013-04-06','09:30:00',1.54),('9650','2013-04-06','09:35:00',1.54),('9650','2013-04-06','09:40:00',1.55),('9650','2013-04-06','09:45:00',1.73),('9650','2013-04-06','09:50:00',2.08),('9650','2013-04-06','09:55:00',2.26),('9650','2013-04-06','10:00:00',2.64),('9650','2013-04-06','10:05:00',2.87),('9650','2013-04-06','10:10:00',2.93),('9650','2013-04-06','10:15:00',3.04),('9650','2013-04-06','10:20:00',3.14),('9650','2013-04-06','10:25:00',3.3),('9650','2013-04-06','10:30:00',2.92),('9650','2013-04-06','10:35:00',3.11),('9650','2013-04-06','10:40:00',3.29),('9650','2013-04-06','10:45:00',3.24),('9650','2013-04-06','10:50:00',3.23),('9650','2013-04-06','10:55:00',2.95),('9650','2013-04-06','11:00:00',2.81),('9650','2013-04-06','11:05:00',2.61),('9650','2013-04-06','11:10:00',2.84),('9650','2013-04-06','11:15:00',3.79),('9650','2013-04-06','11:20:00',4.77),('9650','2013-04-06','11:25:00',5.1),('9650','2013-04-06','11:30:00',5.2),('9650','2013-04-06','11:35:00',4.9),('9650','2013-04-06','11:40:00',4.52),('9650','2013-04-06','11:45:00',3.73),('9650','2013-04-06','11:50:00',3.43),('9650','2013-04-06','11:55:00',3.61),('9650','2013-04-06','12:00:00',3.74),('9650','2013-04-06','12:05:00',3.8),('9650','2013-04-06','12:10:00',4.11),('9650','2013-04-06','12:15:00',4.06),('9650','2013-04-06','12:20:00',4.34),('9650','2013-04-06','12:25:00',4.84),('9650','2013-04-06','12:30:00',4.47),('9650','2013-04-06','12:35:00',4.53),('9650','2013-04-06','12:40:00',4.54),('9650','2013-04-06','12:45:00',3.91),('9650','2013-04-06','12:50:00',4.19),('9650','2013-04-06','12:55:00',4.18),('9650','2013-04-06','13:00:00',5.07),('9650','2013-04-06','13:05:00',5.61),('9650','2013-04-06','13:10:00',5.35),('9650','2013-04-06','13:15:00',4.92),('9650','2013-04-06','13:20:00',4.7),('9650','2013-04-06','13:25:00',5.29),('9650','2013-04-06','13:30:00',4.82),('9650','2013-04-06','13:35:00',4.95),('9650','2013-04-06','13:40:00',5.51),('9650','2013-04-06','13:45:00',5.33),('9650','2013-04-06','13:50:00',4.68),('9650','2013-04-06','13:55:00',4.84),('9650','2013-04-06','14:00:00',5.95),('9650','2013-04-06','14:05:00',5.63),('9650','2013-04-06','14:10:00',3.38),('9650','2013-04-06','14:15:00',4.44),('9650','2013-04-06','14:20:00',4.18),('9650','2013-04-06','14:25:00',3.65),('9650','2013-04-06','14:30:00',2.91),('9650','2013-04-06','14:35:00',3.28),('9650','2013-04-06','14:40:00',3.8),('9650','2013-04-06','14:45:00',3.53),('9650','2013-04-06','14:50:00',3.7),('9650','2013-04-06','14:55:00',4.35),('9650','2013-04-06','15:00:00',3.15),('9650','2013-04-06','15:05:00',4.28),('9650','2013-04-06','15:10:00',3.71),('9650','2013-04-06','15:15:00',5.18),('9650','2013-04-06','15:20:00',5.29),('9650','2013-04-06','15:25:00',5.48),('9650','2013-04-06','15:30:00',5.43),('9650','2013-04-06','15:35:00',5.12),('9650','2013-04-06','15:40:00',4.48),('9650','2013-04-06','15:45:00',4.76),('9650','2013-04-06','15:50:00',4.84),('9650','2013-04-06','15:55:00',4.26),('9650','2013-04-06','16:00:00',4.39),('9650','2013-04-06','16:05:00',3.83),('9650','2013-04-06','16:10:00',3.39),('9650','2013-04-06','16:15:00',2.95),('9650','2013-04-06','16:20:00',2.88),('9650','2013-04-06','16:25:00',2.47),('9650','2013-04-06','16:30:00',2.71),('9650','2013-04-06','16:35:00',3.61),('9650','2013-04-06','16:40:00',3.42),('9650','2013-04-06','16:45:00',4.04),('9650','2013-04-06','16:50:00',4.46),('9650','2013-04-06','16:55:00',4.43),('9650','2013-04-06','17:00:00',4.18),('9650','2013-04-06','17:05:00',3.52),('9650','2013-04-06','17:10:00',2.87),('9650','2013-04-06','17:15:00',1.83),('9650','2013-04-06','17:20:00',3.41),('9650','2013-04-06','17:25:00',4.2),('9650','2013-04-06','17:30:00',3.86),('9650','2013-04-06','17:35:00',3.85),('9650','2013-04-06','17:40:00',3.97),('9650','2013-04-06','17:45:00',3.81),('9650','2013-04-06','17:50:00',3.63),('9650','2013-04-06','17:55:00',3.05),('9650','2013-04-06','18:00:00',2.11),('9650','2013-04-06','18:05:00',1.38),('9650','2013-04-06','18:10:00',1.44),('9650','2013-04-05','09:00:00',1.06),('9650','2013-04-05','09:05:00',1.16),('9650','2013-04-05','09:10:00',1.29),('9650','2013-04-05','09:15:00',1.42),('9650','2013-04-05','09:20:00',1.56),('9650','2013-04-05','09:25:00',1.68),('9650','2013-04-05','09:30:00',1.8),('9650','2013-04-05','09:35:00',1.9),('9650','2013-04-05','09:40:00',2.06),('9650','2013-04-05','09:45:00',2.19),('9650','2013-04-05','09:50:00',2.35),('9650','2013-04-05','09:55:00',2.45),('9650','2013-04-05','10:00:00',2.59),('9650','2013-04-05','10:05:00',2.71),('9650','2013-04-05','10:10:00',2.81),('9650','2013-04-05','10:15:00',2.98),('9650','2013-04-05','10:20:00',3.08),('9650','2013-04-05','10:25:00',3.2),('9650','2013-04-05','10:30:00',3.33),('9650','2013-04-05','10:35:00',3.42),('9650','2013-04-05','10:40:00',3.56),('9650','2013-04-05','10:45:00',3.71),('9650','2013-04-05','10:50:00',3.81),('9650','2013-04-05','10:55:00',3.94),('9650','2013-04-05','11:00:00',4.07),('9650','2013-04-05','11:05:00',4.18),('9650','2013-04-05','11:10:00',4.29),('9650','2013-04-05','11:15:00',4.4),('9650','2013-04-05','11:20:00',4.55),('9650','2013-04-05','11:25:00',4.64),('9650','2013-04-05','11:30:00',4.73),('9650','2013-04-05','11:35:00',4.82),('9650','2013-04-05','11:40:00',4.91),('9650','2013-04-05','11:45:00',4.97),('9650','2013-04-05','11:50:00',5.12),('9650','2013-04-05','11:55:00',5.18),('9650','2013-04-05','12:00:00',5.26),('9650','2013-04-05','12:05:00',5.36),('9650','2013-04-05','12:10:00',5.42),('9650','2013-04-05','12:15:00',5.52),('9650','2013-04-05','12:20:00',5.6),('9650','2013-04-05','12:25:00',5.76),('9650','2013-04-05','12:30:00',5.82),('9650','2013-04-05','12:35:00',5.88),('9650','2013-04-05','12:40:00',5.94),('9650','2013-04-05','12:45:00',6.1),('9650','2013-04-05','12:50:00',6.21),('9650','2013-04-05','12:55:00',6.39),('9650','2013-04-05','13:00:00',5.24),('9650','2013-04-05','13:05:00',6.42),('9650','2013-04-05','13:10:00',6.21),('9650','2013-04-05','13:15:00',6.78),('9650','2013-04-05','13:20:00',5.33),('9650','2013-04-05','13:25:00',2.52),('9650','2013-04-05','13:30:00',7.26),('9650','2013-04-05','13:35:00',7.28),('9650','2013-04-05','13:40:00',2.29),('9650','2013-04-05','13:45:00',5.25),('9650','2013-04-05','13:50:00',6.84),('9650','2013-04-05','13:55:00',7.64),('9650','2013-04-05','14:00:00',7.26),('9650','2013-04-05','14:05:00',6.61),('9650','2013-04-05','14:10:00',7.03),('9650','2013-04-05','14:15:00',4.1),('9650','2013-04-05','14:20:00',4.27),('9650','2013-04-05','14:25:00',1.47),('9650','2013-04-05','14:30:00',6.81),('9650','2013-04-05','14:35:00',6.94),('9650','2013-04-05','14:40:00',5.56),('9650','2013-04-05','14:45:00',5.45),('9650','2013-04-05','14:50:00',6.69),('9650','2013-04-05','14:55:00',6.78),('9650','2013-04-05','15:00:00',6.59),('9650','2013-04-05','15:05:00',6.25),('9650','2013-04-05','15:10:00',6.21),('9650','2013-04-05','15:15:00',6.15),('9650','2013-04-05','15:20:00',6.13),('9650','2013-04-05','15:25:00',6.08),('9650','2013-04-05','15:30:00',5.83),('9650','2013-04-05','15:35:00',5.88),('9650','2013-04-05','15:40:00',5.88),('9650','2013-04-05','15:45:00',5.19),('9650','2013-04-05','15:50:00',5.3),('9650','2013-04-05','15:55:00',5.54),('9650','2013-04-05','16:00:00',5.09),('9650','2013-04-05','16:05:00',5.59),('9650','2013-04-05','16:10:00',5.5),('9650','2013-04-05','16:15:00',4.88),('9650','2013-04-05','16:20:00',4.11),('9650','2013-04-05','16:25:00',3.63),('9650','2013-04-05','16:30:00',4.53),('9650','2013-04-05','16:35:00',4.2),('9650','2013-04-05','16:40:00',3.41),('9650','2013-04-05','16:45:00',4.62),('9650','2013-04-05','16:50:00',4.39),('9650','2013-04-05','16:55:00',3.98),('9650','2013-04-05','17:00:00',3.99),('9650','2013-04-05','17:05:00',3.49),('9650','2013-04-05','17:10:00',3.14),('9650','2013-04-05','17:15:00',2.34),('9650','2013-04-05','17:20:00',1.99),('9650','2013-04-05','17:25:00',2.03),('9650','2013-04-05','17:30:00',2.01),('9650','2013-04-05','17:35:00',1.69),('9650','2013-04-05','17:40:00',1.62),('9650','2013-04-05','17:45:00',1.55),('9650','2013-04-05','17:50:00',1.54),('9650','2013-04-05','17:55:00',1.4),('9650','2013-04-05','18:00:00',1.21),('9650','2013-04-05','18:05:00',1.09),('9650','2013-04-04','08:15:00',1.16),('9650','2013-04-04','08:20:00',1.39),('9650','2013-04-04','08:25:00',1.08),('9650','2013-04-04','08:55:00',1.01),('9650','2013-04-04','09:00:00',1.19),('9650','2013-04-04','09:05:00',2.32),('9650','2013-04-04','09:10:00',1.43),('9650','2013-04-04','09:15:00',2.1),('9650','2013-04-04','09:20:00',2.48),('9650','2013-04-04','09:25:00',1.7),('9650','2013-04-04','09:30:00',1.37),('9650','2013-04-04','09:35:00',1.61),('9650','2013-04-04','09:40:00',2.92),('9650','2013-04-04','09:45:00',2.47),('9650','2013-04-04','09:50:00',1.98),('9650','2013-04-04','09:55:00',1.61),('9650','2013-04-04','10:00:00',2.24),('9650','2013-04-04','10:05:00',1.79),('9650','2013-04-04','10:10:00',2.92),('9650','2013-04-04','10:15:00',3.43),('9650','2013-04-04','10:20:00',1.6),('9650','2013-04-04','10:25:00',2.66),('9650','2013-04-04','10:30:00',2.06),('9650','2013-04-04','10:35:00',1.95),('9650','2013-04-04','10:40:00',4.61),('9650','2013-04-04','10:45:00',2.36),('9650','2013-04-04','10:50:00',3.34),('9650','2013-04-04','10:55:00',3.21),('9650','2013-04-04','11:00:00',3.37),('9650','2013-04-04','11:05:00',3.7),('9650','2013-04-04','11:10:00',4.71),('9650','2013-04-04','11:15:00',4.71),('9650','2013-04-04','11:20:00',3.63),('9650','2013-04-04','11:25:00',4.35),('9650','2013-04-04','11:30:00',4.69),('9650','2013-04-04','11:35:00',5.88),('9650','2013-04-04','11:40:00',5.34),('9650','2013-04-04','11:45:00',4.69),('9650','2013-04-04','11:50:00',5.53),('9650','2013-04-04','11:55:00',5.7),('9650','2013-04-04','12:00:00',5.91),('9650','2013-04-04','12:05:00',4.37),('9650','2013-04-04','12:10:00',3.01),('9650','2013-04-04','12:15:00',5.26),('9650','2013-04-04','12:20:00',2.61),('9650','2013-04-04','12:25:00',3.67),('9650','2013-04-04','12:30:00',2.2),('9650','2013-04-04','12:35:00',2.39),('9650','2013-04-04','12:40:00',3.14),('9650','2013-04-04','12:45:00',5.55),('9650','2013-04-04','12:50:00',6.27),('9650','2013-04-04','12:55:00',5.48),('9650','2013-04-04','13:00:00',4.81),('9650','2013-04-04','13:05:00',4.76),('9650','2013-04-04','13:10:00',5.24),('9650','2013-04-04','13:15:00',6.55),('9650','2013-04-04','13:20:00',5.73),('9650','2013-04-04','13:25:00',5.86),('9650','2013-04-04','13:30:00',5.6),('9650','2013-04-04','13:35:00',5.52),('9650','2013-04-04','13:40:00',5.5),('9650','2013-04-04','13:45:00',5.52),('9650','2013-04-04','13:50:00',7.15),('9650','2013-04-04','13:55:00',6.06),('9650','2013-04-04','14:00:00',5.37),('9650','2013-04-04','14:05:00',7.7),('9650','2013-04-04','14:10:00',7.16),('9650','2013-04-04','14:15:00',6.53),('9650','2013-04-04','14:20:00',7.15),('9650','2013-04-04','14:25:00',7.02),('9650','2013-04-04','14:30:00',6.91),('9650','2013-04-04','14:35:00',6.36),('9650','2013-04-04','14:40:00',5.98),('9650','2013-04-04','14:45:00',5.76),('9650','2013-04-04','14:50:00',4.4),('9650','2013-04-04','14:55:00',7.71),('9650','2013-04-04','15:00:00',6.86),('9650','2013-04-04','15:05:00',7.01),('9650','2013-04-04','15:10:00',4.75),('9650','2013-04-04','15:15:00',2.83),('9650','2013-04-04','15:20:00',3.06),('9650','2013-04-04','15:25:00',3.49),('9650','2013-04-04','15:30:00',2.77),('9650','2013-04-04','15:35:00',2.16),('9650','2013-04-04','15:40:00',1.9),('9650','2013-04-04','15:45:00',2.38),('9650','2013-04-04','15:50:00',3.06),('9650','2013-04-04','15:55:00',2.9),('9650','2013-04-04','16:00:00',3.07),('9650','2013-04-04','16:05:00',2.88),('9650','2013-04-04','16:10:00',3.03),('9650','2013-04-04','16:15:00',3.67),('9650','2013-04-04','16:20:00',3.26),('9650','2013-04-04','16:25:00',2.86),('9650','2013-04-04','16:30:00',2.8),('9650','2013-04-04','16:35:00',3.84),('9650','2013-04-04','16:40:00',2.91),('9650','2013-04-04','16:45:00',3.95),('9650','2013-04-04','16:50:00',5.69),('9650','2013-04-04','16:55:00',2.71),('9650','2013-04-04','17:00:00',2.46),('9650','2013-04-04','17:05:00',1.97),('9650','2013-04-04','17:10:00',5.44),('9650','2013-04-04','17:15:00',4.98),('9650','2013-04-04','17:20:00',4.54),('9650','2013-04-04','17:25:00',4.8),('9650','2013-04-04','17:30:00',3.58),('9650','2013-04-04','17:35:00',4.2),('9650','2013-04-04','17:40:00',3.54),('9650','2013-04-04','17:45:00',1.01),('9650','2013-04-04','17:50:00',2.8),('9650','2013-04-04','17:55:00',4.22),('9650','2013-04-04','18:00:00',2.65),('9650','2013-04-04','18:10:00',1.09),('9650','2013-04-04','18:15:00',2.76),('9650','2013-04-04','18:20:00',2.91),('9650','2013-04-04','18:25:00',1.55),('9650','2013-04-04','18:30:00',2),('9650','2013-04-04','18:35:00',1.79),('9650','2013-04-04','18:40:00',1.95),('9650','2013-04-04','18:45:00',1.73),('9650','2013-04-04','18:50:00',1.47),('9650','2013-04-04','18:55:00',1.05),('9650','2013-04-03','08:20:00',1.01),('9650','2013-04-03','08:25:00',1.1),('9650','2013-04-03','08:30:00',1.19),('9650','2013-04-03','08:35:00',1.5),('9650','2013-04-03','08:40:00',1.31),('9650','2013-04-03','08:45:00',1.31),('9650','2013-04-03','08:50:00',1.33),('9650','2013-04-03','08:55:00',1.8),('9650','2013-04-03','09:00:00',2.11),('9650','2013-04-03','09:05:00',1.87),('9650','2013-04-03','09:10:00',1.87),('9650','2013-04-03','09:15:00',1.96),('9650','2013-04-03','09:20:00',1.85),('9650','2013-04-03','09:25:00',1.69),('9650','2013-04-03','09:30:00',2.12),('9650','2013-04-03','09:35:00',3.07),('9650','2013-04-03','09:40:00',2.98),('9650','2013-04-03','09:45:00',2.64),('9650','2013-04-03','09:50:00',1.83),('9650','2013-04-03','09:55:00',2.11),('9650','2013-04-03','10:00:00',2.69),('9650','2013-04-03','10:05:00',3.27),('9650','2013-04-03','10:10:00',2.94),('9650','2013-04-03','10:15:00',2.47),('9650','2013-04-03','10:20:00',2.69),('9650','2013-04-03','10:25:00',4.44),('9650','2013-04-03','10:30:00',3.99),('9650','2013-04-03','10:35:00',2.92),('9650','2013-04-03','10:40:00',4.93),('9650','2013-04-03','10:45:00',3.07),('9650','2013-04-03','10:50:00',3.42),('9650','2013-04-03','10:55:00',5.19),('9650','2013-04-03','11:00:00',3.36),('9650','2013-04-03','11:05:00',2.06),('9650','2013-04-03','11:10:00',1.96),('9650','2013-04-03','11:15:00',2.65),('9650','2013-04-03','11:20:00',2.31),('9650','2013-04-03','11:25:00',1.87),('9650','2013-04-03','11:30:00',2.02),('9650','2013-04-03','11:35:00',2.83),('9650','2013-04-03','11:40:00',4.33),('9650','2013-04-03','11:45:00',5),('9650','2013-04-03','11:50:00',5.63),('9650','2013-04-03','11:55:00',5.64),('9650','2013-04-03','12:00:00',5.36),('9650','2013-04-03','12:05:00',5.84),('9650','2013-04-03','12:10:00',5.87),('9650','2013-04-03','12:15:00',5.68),('9650','2013-04-03','12:20:00',5),('9650','2013-04-03','12:25:00',3.66),('9650','2013-04-03','12:30:00',3.76),('9650','2013-04-03','12:35:00',4.69),('9650','2013-04-03','12:40:00',5.35),('9650','2013-04-03','12:45:00',5.29),('9650','2013-04-03','12:50:00',6.31),('9650','2013-04-03','12:55:00',5.84),('9650','2013-04-03','13:00:00',5.87),('9650','2013-04-03','13:05:00',5.84),('9650','2013-04-03','13:10:00',6.07),('9650','2013-04-03','13:15:00',6.29),('9650','2013-04-03','13:20:00',6.16),('9650','2013-04-03','13:25:00',6.44),('9650','2013-04-03','13:30:00',6.18),('9650','2013-04-03','13:35:00',5.68),('9650','2013-04-03','13:40:00',4.8),('9650','2013-04-03','13:45:00',5.26),('9650','2013-04-03','13:50:00',5.26),('9650','2013-04-03','13:55:00',4.16),('9650','2013-04-03','14:00:00',4.52),('9650','2013-04-03','14:05:00',5.94),('9650','2013-04-03','14:10:00',6.5),('9650','2013-04-03','14:15:00',6.39),('9650','2013-04-03','14:20:00',6.37),('9650','2013-04-03','14:25:00',6.24),('9650','2013-04-03','14:30:00',6.18),('9650','2013-04-03','14:35:00',6.21),('9650','2013-04-03','14:40:00',6.32),('9650','2013-04-03','14:45:00',6.24),('9650','2013-04-03','14:50:00',6.19),('9650','2013-04-03','14:55:00',6.2),('9650','2013-04-03','15:00:00',6.17),('9650','2013-04-03','15:05:00',5.94),('9650','2013-04-03','15:10:00',5.65),('9650','2013-04-03','15:15:00',5.69),('9650','2013-04-03','15:20:00',5.8),('9650','2013-04-03','15:25:00',5.89),('9650','2013-04-03','15:30:00',5.85),('9650','2013-04-03','15:35:00',5.75),('9650','2013-04-03','15:40:00',5.66),('9650','2013-04-03','15:45:00',5.58),('9650','2013-04-03','15:50:00',5.36),('9650','2013-04-03','15:55:00',5.33),('9650','2013-04-03','16:00:00',5.15),('9650','2013-04-03','16:05:00',4.98),('9650','2013-04-03','16:10:00',4.77),('9650','2013-04-03','16:15:00',4.55),('9650','2013-04-03','16:20:00',4.39),('9650','2013-04-03','16:25:00',4.19),('9650','2013-04-03','16:30:00',3.55),('9650','2013-04-03','16:35:00',3.56),('9650','2013-04-03','16:40:00',3.73),('9650','2013-04-03','16:45:00',3.32),('9650','2013-04-03','16:50:00',2.9),('9650','2013-04-03','16:55:00',3.57),('9650','2013-04-03','17:00:00',3.34),('9650','2013-04-03','17:05:00',3.37),('9650','2013-04-03','17:10:00',3.2),('9650','2013-04-03','17:15:00',2.77),('9650','2013-04-03','17:20:00',1.92),('9650','2013-04-03','17:25:00',2.04),('9650','2013-04-03','17:30:00',1.43),('9650','2013-04-03','17:35:00',1.37),('9650','2013-04-03','17:40:00',1.61),('9650','2013-04-03','17:45:00',1.48),('9650','2013-04-03','17:50:00',1.96),('9650','2013-04-03','17:55:00',2.59),('9650','2013-04-03','18:00:00',2.07),('9650','2013-04-03','18:05:00',2),('9650','2013-04-02','09:05:00',1.12),('9650','2013-04-02','09:10:00',1.18),('9650','2013-04-02','09:15:00',1.49),('9650','2013-04-02','09:20:00',1.15),('9650','2013-04-02','09:25:00',1.96),('9650','2013-04-02','09:30:00',2.12),('9650','2013-04-02','09:35:00',1.81),('9650','2013-04-02','09:40:00',2.25),('9650','2013-04-02','09:45:00',2.29),('9650','2013-04-02','09:50:00',2.18),('9650','2013-04-02','09:55:00',2.8),('9650','2013-04-02','10:00:00',2.72),('9650','2013-04-02','10:05:00',1.83),('9650','2013-04-02','10:10:00',1.76),('9650','2013-04-02','10:15:00',2.17),('9650','2013-04-02','10:20:00',3.89),('9650','2013-04-02','10:25:00',4.01),('9650','2013-04-02','10:30:00',4.24),('9650','2013-04-02','10:35:00',3.54),('9650','2013-04-02','10:40:00',2.63),('9650','2013-04-02','10:45:00',2.07),('9650','2013-04-02','10:50:00',2.44),('9650','2013-04-02','10:55:00',2.5),('9650','2013-04-02','11:00:00',5.36),('9650','2013-04-02','11:05:00',4.27),('9650','2013-04-02','11:10:00',2.99),('9650','2013-04-02','11:15:00',5.61),('9650','2013-04-02','11:20:00',5.23),('9650','2013-04-02','11:25:00',3.22),('9650','2013-04-02','11:30:00',2.91),('9650','2013-04-02','11:35:00',3.96),('9650','2013-04-02','11:40:00',2.63),('9650','2013-04-02','11:45:00',2.9),('9650','2013-04-02','11:50:00',5.78),('9650','2013-04-02','11:55:00',3.79),('9650','2013-04-02','12:00:00',5.18),('9650','2013-04-02','12:05:00',5.83),('9650','2013-04-02','12:10:00',3.69),('9650','2013-04-02','12:15:00',4.02),('9650','2013-04-02','12:20:00',5.39),('9650','2013-04-02','12:25:00',6.73),('9650','2013-04-02','12:30:00',6.11),('9650','2013-04-02','12:35:00',5.95),('9650','2013-04-02','12:40:00',6.56),('9650','2013-04-02','12:45:00',6.66),('9650','2013-04-02','12:50:00',6.96),('9650','2013-04-02','12:55:00',3.95),('9650','2013-04-02','13:05:00',6.19),('9650','2013-04-02','13:10:00',5.38),('9650','2013-04-02','13:15:00',7.7),('9650','2013-04-02','13:20:00',5.45),('9650','2013-04-02','13:25:00',5.43),('9650','2013-04-02','13:30:00',5.84),('9650','2013-04-02','13:35:00',7.54),('9650','2013-04-02','13:40:00',5.7),('9650','2013-04-02','13:45:00',5.22),('9650','2013-04-02','13:50:00',6.01),('9650','2013-04-02','13:55:00',3.62),('9650','2013-04-02','14:00:00',7.09),('9650','2013-04-02','14:05:00',8.14),('9650','2013-04-02','14:10:00',6.78),('9650','2013-04-02','14:15:00',3.32),('9650','2013-04-02','14:20:00',5.18),('9650','2013-04-02','14:25:00',6.07),('9650','2013-04-02','14:30:00',7.09),('9650','2013-04-02','14:35:00',7.13),('9650','2013-04-02','14:40:00',3.77),('9650','2013-04-02','14:45:00',4.87),('9650','2013-04-02','14:50:00',5.62),('9650','2013-04-02','14:55:00',6.3),('9650','2013-04-02','15:00:00',5.61),('9650','2013-04-02','15:05:00',6.36),('9650','2013-04-02','15:10:00',6.6),('9650','2013-04-02','15:15:00',7.65),('9650','2013-04-02','15:20:00',5.67),('9650','2013-04-02','15:25:00',7.05),('9650','2013-04-02','15:30:00',4.04),('9650','2013-04-02','15:35:00',4.88),('9650','2013-04-02','15:40:00',5.68),('9650','2013-04-02','15:45:00',5.74),('9650','2013-04-02','15:50:00',6.98),('9650','2013-04-02','15:55:00',6.6),('9650','2013-04-02','16:00:00',6.21),('9650','2013-04-02','16:05:00',6.18),('9650','2013-04-02','16:10:00',5.78),('9650','2013-04-02','16:15:00',5.87),('9650','2013-04-02','16:20:00',5.74),('9650','2013-04-02','16:25:00',5.64),('9650','2013-04-02','16:30:00',5.6),('9650','2013-04-02','16:35:00',4.8),('9650','2013-04-02','16:40:00',5.27),('9650','2013-04-02','16:45:00',5.14),('9650','2013-04-02','16:50:00',5),('9650','2013-04-02','16:55:00',4.95),('9650','2013-04-02','17:00:00',4.9),('9650','2013-04-02','17:05:00',4.79),('9650','2013-04-02','17:10:00',4.61),('9650','2013-04-02','17:15:00',4.53),('9650','2013-04-02','17:20:00',4.37),('9650','2013-04-02','17:25:00',4.17),('9650','2013-04-02','17:30:00',4.13),('9650','2013-04-02','17:35:00',4.04),('9650','2013-04-02','17:40:00',3.93),('9650','2013-04-02','17:45:00',3.81),('9650','2013-04-02','17:50:00',3.69),('9650','2013-04-02','17:55:00',3.52),('9650','2013-04-02','18:00:00',3.36),('9650','2013-04-02','18:05:00',3.18),('9650','2013-04-02','18:10:00',2.97),('9650','2013-04-02','18:15:00',2.89),('9650','2013-04-02','18:20:00',2.73),('9650','2013-04-02','18:25:00',2.5),('9650','2013-04-02','18:30:00',2.4),('9650','2013-04-02','18:35:00',2.21),('9650','2013-04-02','18:40:00',2.02),('9650','2013-04-02','18:45:00',1.75),('9650','2013-04-02','18:50:00',1.48),('9650','2013-04-01','08:40:00',1.34),('9650','2013-04-01','08:45:00',1.67),('9650','2013-04-01','08:50:00',1.24),('9650','2013-04-01','09:10:00',1.11),('9650','2013-04-01','09:15:00',1.14),('9650','2013-04-01','09:20:00',1.26),('9650','2013-04-01','09:30:00',1.35),('9650','2013-04-01','09:35:00',2.23),('9650','2013-04-01','09:40:00',2.28),('9650','2013-04-01','09:45:00',2.46),('9650','2013-04-01','09:50:00',2.25),('9650','2013-04-01','09:55:00',2.11),('9650','2013-04-01','10:00:00',2.01),('9650','2013-04-01','10:05:00',1.72),('9650','2013-04-01','10:10:00',1.65),('9650','2013-04-01','10:15:00',2.18),('9650','2013-04-01','10:20:00',2.41),('9650','2013-04-01','10:25:00',2.21),('9650','2013-04-01','10:30:00',1.59),('9650','2013-04-01','10:35:00',3.56),('9650','2013-04-01','10:40:00',2.71),('9650','2013-04-01','10:45:00',2.9),('9650','2013-04-01','10:50:00',4.37),('9650','2013-04-01','10:55:00',1.81),('9650','2013-04-01','11:00:00',1.86),('9650','2013-04-01','11:05:00',3.91),('9650','2013-04-01','11:10:00',2.64),('9650','2013-04-01','11:15:00',1.98),('9650','2013-04-01','11:20:00',1.76),('9650','2013-04-01','11:25:00',2.04),('9650','2013-04-01','11:30:00',2.17),('9650','2013-04-01','11:35:00',2.04),('9650','2013-04-01','11:40:00',1.6),('9650','2013-04-01','11:45:00',3.68),('9650','2013-04-01','11:50:00',3.58),('9650','2013-04-01','11:55:00',1.94),('9650','2013-04-01','12:00:00',1.65),('9650','2013-04-01','12:05:00',5.09),('9650','2013-04-01','12:10:00',3.18),('9650','2013-04-01','12:15:00',3.24),('9650','2013-04-01','12:30:00',1.59),('9650','2013-04-01','12:35:00',3.06),('9650','2013-04-01','12:40:00',3.29),('9650','2013-04-01','12:45:00',3.61),('9650','2013-04-01','12:50:00',3.71),('9650','2013-04-01','12:55:00',3.76),('9650','2013-04-01','13:00:00',3.95),('9650','2013-04-01','13:05:00',4.47),('9650','2013-04-01','13:10:00',5.43),('9650','2013-04-01','13:15:00',4.31),('9650','2013-04-01','13:20:00',3.48),('9650','2013-04-01','13:25:00',5.51),('9650','2013-04-01','13:30:00',4.3),('9650','2013-04-01','13:35:00',3.36),('9650','2013-04-01','13:40:00',5),('9650','2013-04-01','13:45:00',4.59),('9650','2013-04-01','13:50:00',3.81),('9650','2013-04-01','13:55:00',3.27),('9650','2013-04-01','14:00:00',4.47),('9650','2013-04-01','14:05:00',3.49),('9650','2013-04-01','14:10:00',4.17),('9650','2013-04-01','14:15:00',3.95),('9650','2013-04-01','14:20:00',7.05),('9650','2013-04-01','14:25:00',6.95),('9650','2013-04-01','14:30:00',4.22),('9650','2013-04-01','14:35:00',3.1),('9650','2013-04-01','14:40:00',4.27),('9650','2013-04-01','14:45:00',4.64),('9650','2013-04-01','14:50:00',3.48),('9650','2013-04-01','14:55:00',3.02),('9650','2013-04-01','15:00:00',2.69),('9650','2013-04-01','15:05:00',1.43),('9650','2013-04-01','15:10:00',1.05),('9650','2013-04-01','15:15:00',1.13),('9650','2013-04-01','15:20:00',1.65),('9650','2013-04-01','15:35:00',1.37),('9650','2013-04-01','15:40:00',1.55),('9650','2013-04-01','15:45:00',2.08),('9650','2013-04-01','15:50:00',1.16),('9650','2013-04-01','15:55:00',1.23),('9650','2013-04-01','16:00:00',1.8),('9650','2013-04-01','16:05:00',2.07),('9650','2013-04-01','16:10:00',1.59),('9650','2013-04-01','16:15:00',1.86),('9650','2013-04-01','16:20:00',1.82),('9650','2013-04-01','16:25:00',1.55),('9650','2013-04-01','16:30:00',1.64),('9650','2013-04-01','16:35:00',1.63),('9650','2013-04-01','16:40:00',1.47),('9650','2013-04-01','16:45:00',1.51),('9650','2013-04-01','16:55:00',1.11),('9650','2013-04-01','17:00:00',1.34),('9650','2013-04-01','17:05:00',1.43),('9650','2013-04-01','17:40:00',1.79),('9650','2013-04-01','17:45:00',1.9),('9650','2014-05-01','08:00:00',1.28),('9650','2014-05-01','08:05:00',1.36),('9650','2014-05-01','08:10:00',1.33),('9650','2014-05-01','08:15:00',2.32),('9650','2014-05-01','08:20:00',2.6),('9650','2014-05-01','08:25:00',1.83),('9650','2014-05-01','08:30:00',1.04),('9650','2014-05-01','08:40:00',1.38),('9650','2014-05-01','08:45:00',2.05),('9650','2014-05-01','08:50:00',2.21),('9650','2014-05-01','09:05:00',1.21),('9650','2014-05-01','09:10:00',1.58),('9650','2014-05-01','09:15:00',2.16),('9650','2014-05-01','09:20:00',2.52),('9650','2014-05-01','09:25:00',2.78),('9650','2014-05-01','09:30:00',3.04),('9650','2014-05-01','09:35:00',2.88),('9650','2014-05-01','09:40:00',2.73),('9650','2014-05-01','09:45:00',2.86),('9650','2014-05-01','09:50:00',2.7),('9650','2014-05-01','09:55:00',2.6),('9650','2014-05-01','10:00:00',3.18),('9650','2014-05-01','10:05:00',3.39),('9650','2014-05-01','10:10:00',3.06),('9650','2014-05-01','10:15:00',2.67),('9650','2014-05-01','10:20:00',2.48),('9650','2014-05-01','10:25:00',2.11),('9650','2014-05-01','10:30:00',1.59),('9650','2014-05-01','10:35:00',1.62),('9650','2014-05-01','10:40:00',1.79),('9650','2014-05-01','10:45:00',2.21),('9650','2014-05-01','10:50:00',1.86),('9650','2014-05-01','10:55:00',1.37),('9650','2014-05-01','12:25:00',1.57),('9650','2014-05-01','12:30:00',1.98),('9650','2014-05-01','12:35:00',2.17),('9650','2014-05-01','12:40:00',2.14),('9650','2014-05-01','12:45:00',2.66),('9650','2014-05-01','12:50:00',3.45),('9650','2014-05-01','12:55:00',2.61),('9650','2014-05-01','13:00:00',2.88),('9650','2014-05-01','13:05:00',3.17),('9650','2014-05-01','13:10:00',3.32),('9650','2014-05-01','13:15:00',3.94),('9650','2014-05-01','13:20:00',5.16),('9650','2014-05-01','13:25:00',6.02),('9650','2014-05-01','13:30:00',5.1),('9650','2014-05-01','13:35:00',4.59),('9650','2014-05-01','13:40:00',4.8),('9650','2014-05-01','13:45:00',3.72),('9650','2014-05-01','13:50:00',3.03),('9650','2014-05-01','13:55:00',2.53),('9650','2014-05-01','14:00:00',2.68),('9650','2014-05-01','14:05:00',3.66),('9650','2014-05-01','14:10:00',1.88),('9650','2014-05-01','14:25:00',1.19),('9650','2014-05-01','14:30:00',1.88),('9650','2014-05-01','14:35:00',2.78),('9650','2014-05-01','14:40:00',5.37),('9650','2014-05-01','14:45:00',2.76),('9650','2014-05-01','14:50:00',2.36),('9650','2014-05-01','14:55:00',3.35),('9650','2014-05-01','15:00:00',4.48),('9650','2014-05-01','15:05:00',3.41),('9650','2014-05-01','15:10:00',6.74),('9650','2014-05-01','15:15:00',5.31),('9650','2014-05-01','15:20:00',4.41),('9650','2014-05-01','15:25:00',3.15),('9650','2014-05-01','15:30:00',2.32),('9650','2014-05-01','15:35:00',5.33),('9650','2014-05-01','15:40:00',6.75),('9650','2014-05-01','15:45:00',2.17),('9650','2014-05-01','15:50:00',1.48),('9650','2014-05-01','15:55:00',1.53),('9650','2014-05-01','16:00:00',2.44),('9650','2014-05-01','16:05:00',3.29),('9650','2014-05-01','16:10:00',2.03),('9650','2014-05-01','16:15:00',2.47),('9650','2014-05-01','16:20:00',4.28),('9650','2014-05-01','16:25:00',1.03),('9650','2014-05-01','16:55:00',1.2),('9650','2014-05-01','17:05:00',1.25),('9650','2014-05-01','17:10:00',1),('9650','2014-05-01','17:15:00',1.52),('9650','2014-05-01','17:20:00',1.8),('9650','2014-05-01','17:25:00',2.22),('9650','2014-05-01','17:30:00',1.64),('9650','2014-05-01','17:35:00',1.36),('9650','2014-05-01','17:40:00',1.13),('9650','2014-03-26','07:45:00',1.2),('9650','2014-03-26','07:50:00',1.27),('9650','2014-03-26','07:55:00',1.54),('9650','2014-03-26','08:00:00',2.04),('9650','2014-03-26','08:05:00',2.39),('9650','2014-03-26','08:10:00',1.33),('9650','2014-03-26','09:10:00',1.34),('9650','2014-03-26','09:15:00',1.7),('9650','2014-03-26','09:20:00',1.6),('9650','2014-03-26','09:25:00',1.48),('9650','2014-03-26','09:30:00',1.31),('9650','2014-03-26','09:55:00',1.12),('9650','2014-03-26','10:00:00',1.46),('9650','2014-03-26','10:05:00',1.86),('9650','2014-03-26','10:10:00',2.17),('9650','2014-03-26','10:15:00',2.14),('9650','2014-03-26','10:20:00',2.93),('9650','2014-03-26','10:25:00',3.42),('9650','2014-03-26','10:30:00',3.21),('9650','2014-03-26','10:35:00',2.92),('9650','2014-03-26','10:40:00',3.19),('9650','2014-03-26','10:45:00',1.79),('9650','2014-03-26','10:50:00',1.42),('9650','2014-03-26','10:55:00',1.33),('9650','2014-03-26','11:00:00',1.25),('9650','2014-03-26','11:05:00',1.15),('9650','2014-03-26','11:10:00',4.58),('9650','2014-03-26','11:15:00',3.74),('9650','2014-03-26','11:25:00',1.18),('9650','2014-03-26','11:50:00',1.96),('9650','2014-03-26','11:55:00',2.38),('9650','2014-03-26','12:00:00',2.03),('9650','2014-03-26','12:05:00',1.66),('9650','2014-03-26','12:10:00',1.99),('9650','2014-03-26','12:15:00',1.53),('9650','2014-03-26','12:20:00',1.73),('9650','2014-03-26','12:25:00',1.03),('9650','2014-03-26','12:55:00',1.23),('9650','2014-03-26','13:00:00',1.63),('9650','2014-03-26','13:05:00',2.01),('9650','2014-03-26','13:10:00',2.69),('9650','2014-03-26','13:15:00',3.7),('9650','2014-03-26','13:20:00',4.13),('9650','2014-03-26','13:25:00',4.25),('9650','2014-03-26','13:30:00',3.68),('9650','2014-03-26','13:35:00',3.3),('9650','2014-03-26','13:40:00',3.15),('9650','2014-03-26','13:45:00',2.85),('9650','2014-03-26','13:50:00',3.59),('9650','2014-03-26','13:55:00',4.73),('9650','2014-03-26','14:00:00',3.48),('9650','2014-03-26','14:05:00',2.01),('9650','2014-03-26','14:10:00',1.13),('9650','2014-03-26','14:15:00',4.08),('9650','2014-03-26','14:20:00',6.49),('9650','2014-03-26','14:25:00',6.36),('9650','2014-03-26','14:30:00',6.31),('9650','2014-03-26','14:35:00',3.89),('9650','2014-03-26','14:40:00',3.35),('9650','2014-03-26','14:45:00',3.06),('9650','2014-03-26','14:50:00',4.15),('9650','2014-03-26','14:55:00',3.11),('9650','2014-03-26','15:00:00',6.76),('9650','2014-03-26','15:05:00',2.97),('9650','2014-03-26','15:20:00',1.43),('9650','2014-03-26','15:25:00',4.32),('9650','2014-03-26','15:30:00',5),('9650','2014-03-26','15:35:00',4.51),('9650','2014-03-26','15:40:00',2.1),('9650','2014-03-26','15:45:00',1.08),('9650','2014-03-26','15:50:00',1.41),('9650','2014-03-26','15:55:00',1.47),('9650','2014-03-26','16:00:00',1.47),('9650','2014-03-26','16:05:00',1.69),('9650','2014-03-26','16:10:00',2),('9650','2014-03-26','16:15:00',1.77),('9650','2014-03-26','16:20:00',1.51),('9650','2014-03-26','16:25:00',1.89),('9650','2014-03-26','16:30:00',2.43),('9650','2014-03-26','16:35:00',1.63),('9650','2014-03-26','16:40:00',1.76),('9650','2014-03-26','16:45:00',1.94),('9650','2014-03-26','16:50:00',1.13),('9650','2014-03-26','16:55:00',1.91),('9650','2014-03-26','17:00:00',1.87),('9650','2014-03-26','17:05:00',1.66),('9650','2014-03-26','17:10:00',1.02),('9650','2013-03-31','08:40:00',1.11),('9650','2013-03-31','08:45:00',1.1),('9650','2013-03-31','08:50:00',1.07),('9650','2013-03-31','09:05:00',1.1),('9650','2013-03-31','09:10:00',1.3),('9650','2013-03-31','09:15:00',1.31),('9650','2013-03-31','09:20:00',1.37),('9650','2013-03-31','09:25:00',1.74),('9650','2013-03-31','09:30:00',2.01),('9650','2013-03-31','09:35:00',1.83),('9650','2013-03-31','09:40:00',1.82),('9650','2013-03-31','09:45:00',2.34),('9650','2013-03-31','09:50:00',2.58),('9650','2013-03-31','09:55:00',2.54),('9650','2013-03-31','10:00:00',2.83),('9650','2013-03-31','10:05:00',2.99),('9650','2013-03-31','10:10:00',2.68),('9650','2013-03-31','10:15:00',3.29),('9650','2013-03-31','10:20:00',2.76),('9650','2013-03-31','10:25:00',3.5),('9650','2013-03-31','10:30:00',3.05),('9650','2013-03-31','10:35:00',2.2),('9650','2013-03-31','10:40:00',2.65),('9650','2013-03-31','10:45:00',4.44),('9650','2013-03-31','10:50:00',2.68),('9650','2013-03-31','10:55:00',2.92),('9650','2013-03-31','11:00:00',1.99),('9650','2013-03-31','11:05:00',2.34),('9650','2013-03-31','11:10:00',3.79),('9650','2013-03-31','11:15:00',4.14),('9650','2013-03-31','11:20:00',4.96),('9650','2013-03-31','11:25:00',3.02),('9650','2013-03-31','11:30:00',2.54),('9650','2013-03-31','11:35:00',2.96),('9650','2013-03-31','11:40:00',4.48),('9650','2013-03-31','11:45:00',4.47),('9650','2013-03-31','11:50:00',3.8),('9650','2013-03-31','11:55:00',3.46),('9650','2013-03-31','12:00:00',4.27),('9650','2013-03-31','12:05:00',2.95),('9650','2013-03-31','12:10:00',3.78),('9650','2013-03-31','12:15:00',3.21),('9650','2013-03-31','12:20:00',2.71),('9650','2013-03-31','12:25:00',3.03),('9650','2013-03-31','12:30:00',4.19),('9650','2013-03-31','12:35:00',3.88),('9650','2013-03-31','12:40:00',4.01),('9650','2013-03-31','12:45:00',4.48),('9650','2013-03-31','12:50:00',4.75),('9650','2013-03-31','12:55:00',5.06),('9650','2013-03-31','13:00:00',5.01),('9650','2013-03-31','13:05:00',5.33),('9650','2013-03-31','13:10:00',4.79),('9650','2013-03-31','13:15:00',4.95),('9650','2013-03-31','13:20:00',4.75),('9650','2013-03-31','13:25:00',4.46),('9650','2013-03-31','13:30:00',4.91),('9650','2013-03-31','13:35:00',4.43),('9650','2013-03-31','13:40:00',5.72),('9650','2013-03-31','13:45:00',6.2),('9650','2013-03-31','13:50:00',6.9),('9650','2013-03-31','13:55:00',6.8),('9650','2013-03-31','14:00:00',4.1),('9650','2013-03-31','14:05:00',3.25),('9650','2013-03-31','14:10:00',4.05),('9650','2013-03-31','14:15:00',4.5),('9650','2013-03-31','14:20:00',4.76),('9650','2013-03-31','14:25:00',7.12),('9650','2013-03-31','14:30:00',4.52),('9650','2013-03-31','14:35:00',3.75),('9650','2013-03-31','14:40:00',3.29),('9650','2013-03-31','14:45:00',3.39),('9650','2013-03-31','14:50:00',3.67),('9650','2013-03-31','14:55:00',3.9),('9650','2013-03-31','15:00:00',3.51),('9650','2013-03-31','15:05:00',3.49),('9650','2013-03-31','15:10:00',3.61),('9650','2013-03-31','15:15:00',3.87),('9650','2013-03-31','15:20:00',3.98),('9650','2013-03-31','15:25:00',4.05),('9650','2013-03-31','15:30:00',3.61),('9650','2013-03-31','15:35:00',4.6),('9650','2013-03-31','15:40:00',4.28),('9650','2013-03-31','15:45:00',4.42),('9650','2013-03-31','15:50:00',5),('9650','2013-03-31','15:55:00',3.75),('9650','2013-03-31','16:00:00',3.5),('9650','2013-03-31','16:05:00',2.85),('9650','2013-03-31','16:10:00',2.39),('9650','2013-03-31','16:15:00',1.9),('9650','2013-03-31','16:20:00',1.83),('9650','2013-03-31','16:25:00',1.72),('9650','2013-03-31','16:30:00',1.39),('9650','2013-03-31','16:35:00',1.44),('9650','2013-03-31','16:40:00',1.23),('9650','2013-03-31','16:45:00',1.01),('9650','2013-03-30','08:30:00',1.48),('9650','2013-03-30','08:35:00',1.25),('9650','2013-03-30','08:40:00',1.25),('9650','2013-03-30','08:45:00',1.3),('9650','2013-03-30','08:50:00',1.27),('9650','2013-03-30','08:55:00',1.56),('9650','2013-03-30','09:00:00',1.61),('9650','2013-03-30','09:05:00',1.53),('9650','2013-03-30','09:10:00',1.67),('9650','2013-03-30','09:15:00',1.89),('9650','2013-03-30','09:20:00',2.46),('9650','2013-03-30','09:25:00',2.52),('9650','2013-03-30','09:30:00',2.1),('9650','2013-03-30','09:35:00',2.34),('9650','2013-03-30','09:40:00',1.88),('9650','2013-03-30','09:45:00',2.6),('9650','2013-03-30','09:50:00',2.12),('9650','2013-03-30','09:55:00',2.69),('9650','2013-03-30','10:00:00',2.59),('9650','2013-03-30','10:15:00',1.69),('9650','2013-03-30','10:20:00',3.18),('9650','2013-03-30','10:25:00',3.37),('9650','2013-03-30','10:30:00',3.89),('9650','2013-03-30','10:35:00',3.71),('9650','2013-03-30','10:40:00',1.51),('9650','2013-03-30','10:45:00',2.05),('9650','2013-03-30','10:50:00',3.1),('9650','2013-03-30','10:55:00',1.6),('9650','2013-03-30','11:00:00',1.38),('9650','2013-03-30','11:05:00',1.37),('9650','2013-03-30','11:10:00',2.26),('9650','2013-03-30','11:15:00',2.13),('9650','2013-03-30','11:20:00',1.97),('9650','2013-03-30','11:25:00',2.76),('9650','2013-03-30','11:30:00',2.28),('9650','2013-03-30','11:35:00',2.82),('9650','2013-03-30','11:40:00',2.72),('9650','2013-03-30','11:45:00',2.49),('9650','2013-03-30','11:50:00',2.7),('9650','2013-03-30','11:55:00',2.92),('9650','2013-03-30','12:00:00',2.72),('9650','2013-03-30','12:05:00',2.48),('9650','2013-03-30','12:10:00',2.21),('9650','2013-03-30','12:15:00',2.32),('9650','2013-03-30','12:20:00',2.13),('9650','2013-03-30','12:25:00',2.54),('9650','2013-03-30','12:30:00',3.19),('9650','2013-03-30','12:35:00',4.88),('9650','2013-03-30','12:40:00',5.18),('9650','2013-03-30','12:45:00',3.04),('9650','2013-03-30','12:50:00',3.1),('9650','2013-03-30','12:55:00',3.43),('9650','2013-03-30','13:00:00',4.15),('9650','2013-03-30','13:05:00',3.19),('9650','2013-03-30','13:10:00',4.87),('9650','2013-03-30','13:15:00',4.91),('9650','2013-03-30','13:20:00',5.88),('9650','2013-03-30','13:25:00',3.87),('9650','2013-03-30','13:30:00',1.5),('9650','2013-03-30','13:35:00',1.22),('9650','2013-03-30','13:40:00',2.61),('9650','2013-03-30','13:45:00',3.14),('9650','2013-03-30','13:50:00',3.65),('9650','2013-03-30','13:55:00',2.66),('9650','2013-03-30','14:00:00',3),('9650','2013-03-30','14:05:00',5.01),('9650','2013-03-30','14:10:00',4.1),('9650','2013-03-30','14:15:00',4.87),('9650','2013-03-30','14:20:00',2.74),('9650','2013-03-30','14:25:00',2.79),('9650','2013-03-30','14:30:00',4.49),('9650','2013-03-30','14:35:00',7.5),('9650','2013-03-30','14:40:00',7.69),('9650','2013-03-30','14:45:00',5.68),('9650','2013-03-30','14:50:00',5.51),('9650','2013-03-30','14:55:00',5.11),('9650','2013-03-30','15:00:00',5.41),('9650','2013-03-30','15:05:00',3.65),('9650','2013-03-30','15:10:00',5.61),('9650','2013-03-30','15:15:00',5.47),('9650','2013-03-30','15:20:00',7.14),('9650','2013-03-30','15:25:00',4.51),('9650','2013-03-30','15:30:00',4.29),('9650','2013-03-30','15:35:00',6.17),('9650','2013-03-30','15:40:00',7.35),('9650','2013-03-30','15:45:00',5.08),('9650','2013-03-30','15:50:00',1.79),('9650','2013-03-30','15:55:00',1.49),('9650','2013-03-30','16:00:00',5.03),('9650','2013-03-30','16:05:00',1.94),('9650','2013-03-30','16:10:00',2.64),('9650','2013-03-30','16:15:00',4.06),('9650','2013-03-30','16:20:00',3.1),('9650','2013-03-30','16:25:00',2.27),('9650','2013-03-30','16:30:00',1.87),('9650','2013-03-30','16:35:00',2.05),('9650','2013-03-30','16:40:00',2.31),('9650','2013-03-30','16:45:00',1.88),('9650','2013-03-30','16:50:00',1.65),('9650','2013-03-30','16:55:00',1.48),('9650','2013-03-30','17:00:00',2.22),('9650','2013-03-30','17:05:00',2.89),('9650','2013-03-30','17:10:00',2.3),('9650','2013-03-30','17:15:00',1.49),('9650','2013-03-30','17:20:00',1.95),('9650','2013-03-30','17:25:00',2.15),('9650','2013-03-30','17:30:00',2.43),('9650','2013-03-30','17:35:00',2.24),('9650','2013-03-30','17:40:00',1.77),('9650','2013-03-30','17:45:00',1.91),('9650','2013-03-30','17:50:00',2.09),('9650','2013-03-30','17:55:00',3.61),('9650','2013-03-30','18:00:00',2.07),('9650','2013-03-30','18:15:00',3.51),('9650','2013-03-30','18:20:00',2.38),('9650','2013-03-30','18:50:00',1.2),('9650','2013-03-29','07:50:00',1.02),('9650','2013-03-29','07:55:00',1.37),('9650','2013-03-29','08:00:00',1.21),('9650','2013-03-29','08:05:00',1.12),('9650','2013-03-29','08:10:00',1.2),('9650','2013-03-29','08:15:00',1.47),('9650','2013-03-29','08:20:00',1.41),('9650','2013-03-29','08:25:00',1.61),('9650','2013-03-29','08:30:00',1.74),('9650','2013-03-29','08:35:00',2.04),('9650','2013-03-29','08:40:00',1.91),('9650','2013-03-29','08:45:00',1.42),('9650','2013-03-29','08:50:00',1.55),('9650','2013-03-29','08:55:00',1.25),('9650','2013-03-29','09:00:00',1.5),('9650','2013-03-29','09:05:00',2.69),('9650','2013-03-29','09:10:00',2.87),('9650','2013-03-29','09:16:00',2.94),('9650','2013-03-29','09:20:00',4.98),('9650','2013-03-29','09:25:00',2.91),('9650','2013-03-29','09:30:00',2.12),('9650','2013-03-29','09:35:00',2.29),('9650','2013-03-29','09:40:00',2.32),('9650','2013-03-29','09:45:00',2.15),('9650','2013-03-29','09:50:00',1.55),('9650','2013-03-29','09:55:00',2.02),('9650','2013-03-29','10:00:00',3.04),('9650','2013-03-29','10:05:00',3),('9650','2013-03-29','10:10:00',3.3),('9650','2013-03-29','10:15:00',3),('9650','2013-03-29','10:20:00',2.65),('9650','2013-03-29','10:25:00',2.65),('9650','2013-03-29','10:30:00',3),('9650','2013-03-29','10:35:00',3.47),('9650','2013-03-29','10:40:00',3.96),('9650','2013-03-29','10:45:00',5.06),('9650','2013-03-29','10:50:00',4.69),('9650','2013-03-29','10:55:00',3.67),('9650','2013-03-29','11:00:00',5.05),('9650','2013-03-29','11:05:00',6.09),('9650','2013-03-29','11:10:00',6.61),('9650','2013-03-29','11:15:00',5.4),('9650','2013-03-29','11:20:00',7.17),('9650','2013-03-29','11:25:00',6.61),('9650','2013-03-29','11:30:00',4.19),('9650','2013-03-29','11:35:00',4.74),('9650','2013-03-29','11:40:00',4.46),('9650','2013-03-29','11:45:00',5.3),('9650','2013-03-29','11:50:00',6.08),('9650','2013-03-29','11:55:00',6.79),('9650','2013-03-29','12:00:00',6.36),('9650','2013-03-29','12:05:00',4.25),('9650','2013-03-29','12:10:00',3.52),('9650','2013-03-29','12:15:00',3.4),('9650','2013-03-29','12:20:00',3.19),('9650','2013-03-29','12:25:00',1.92),('9650','2013-03-29','12:30:00',1.71),('9650','2013-03-29','12:35:00',1.7),('9650','2013-03-29','12:45:00',1.22),('9650','2013-03-29','12:50:00',1.17),('9650','2013-03-29','13:05:00',1.03),('9650','2013-03-29','13:10:00',3.03),('9650','2013-03-29','13:15:00',6.49),('9650','2013-03-29','13:20:00',4.2),('9650','2013-03-29','13:25:00',3.34),('9650','2013-03-29','13:30:00',1.87),('9650','2013-03-29','13:35:00',1.26),('9650','2013-03-29','13:40:00',1.64),('9650','2013-03-29','13:45:00',3.56),('9650','2013-03-29','13:50:00',7.34),('9650','2013-03-29','13:55:00',3.02),('9650','2013-03-29','14:00:00',3.8),('9650','2013-03-29','14:05:00',3.5),('9650','2013-03-29','14:10:00',1.92),('9650','2013-03-29','14:15:00',1.67),('9650','2013-03-29','14:20:00',3.2),('9650','2013-03-29','14:25:00',2.36),('9650','2013-03-29','14:30:00',3.38),('9650','2013-03-29','14:35:00',3.62),('9650','2013-03-29','14:40:00',2.14),('9650','2013-03-29','14:45:00',1.79),('9650','2013-03-29','14:50:00',2.49),('9650','2013-03-29','14:55:00',1.59),('9650','2013-03-29','15:00:00',1.2),('9650','2013-03-29','15:20:00',1.5),('9650','2013-03-29','15:25:00',1.72),('9650','2013-03-29','15:30:00',1.5),('9650','2013-03-29','15:35:00',1.1),('9650','2013-03-29','15:40:00',1.31),('9650','2013-03-29','15:45:00',1.19),('9650','2013-03-29','15:50:00',1.27),('9650','2013-03-29','15:55:00',1.08),('9650','2013-03-28','07:55:00',1.17),('9650','2013-03-28','08:00:00',1.34),('9650','2013-03-28','08:05:00',1.15),('9650','2013-03-28','08:10:00',1.17),('9650','2013-03-28','08:15:00',1.12),('9650','2013-03-28','08:20:00',1.21),('9650','2013-03-28','08:25:00',1.33),('9650','2013-03-28','08:30:00',1.47),('9650','2013-03-28','08:35:00',1.64),('9650','2013-03-28','08:40:00',1.78),('9650','2013-03-28','08:45:00',1.85),('9650','2013-03-28','08:50:00',1.96),('9650','2013-03-28','08:55:00',1.89),('9650','2013-03-28','09:00:00',2.03),('9650','2013-03-28','09:05:00',2.35),('9650','2013-03-28','09:10:00',2.43),('9650','2013-03-28','09:15:00',2.9),('9650','2013-03-28','09:20:00',3.15),('9650','2013-03-28','09:25:00',3.08),('9650','2013-03-28','09:30:00',3.85),('9650','2013-03-28','09:35:00',4.02),('9650','2013-03-28','09:40:00',4.15),('9650','2013-03-28','09:45:00',3.68),('9650','2013-03-28','09:50:00',3.95),('9650','2013-03-28','09:55:00',4.1),('9650','2013-03-28','10:00:00',4.24),('9650','2013-03-28','10:05:00',4.22),('9650','2013-03-28','10:10:00',3.74),('9650','2013-03-28','10:15:00',4.44),('9650','2013-03-28','10:20:00',4.22),('9650','2013-03-28','10:25:00',4.03),('9650','2013-03-28','10:30:00',4.38),('9650','2013-03-28','10:35:00',3.42),('9650','2013-03-28','10:40:00',4.65),('9650','2013-03-28','10:45:00',4.17),('9650','2013-03-28','10:50:00',4.02),('9650','2013-03-28','10:55:00',4.56),('9650','2013-03-28','11:00:00',5.37),('9650','2013-03-28','11:05:00',5.32),('9650','2013-03-28','11:10:00',4.87),('9650','2013-03-28','11:15:00',2.5),('9650','2013-03-28','11:20:00',5.14),('9650','2013-03-28','11:25:00',6.25),('9650','2013-03-28','11:30:00',5.99),('9650','2013-03-28','11:35:00',5.76),('9650','2013-03-28','11:40:00',5.84),('9650','2013-03-28','11:45:00',5.91),('9650','2013-03-28','11:50:00',6.06),('9650','2013-03-28','11:55:00',6.12),('9650','2013-03-28','12:00:00',6.18),('9650','2013-03-28','12:05:00',6.37),('9650','2013-03-28','12:10:00',6.36),('9650','2013-03-28','12:15:00',5.91),('9650','2013-03-28','12:20:00',6.42),('9650','2013-03-28','12:25:00',6.08),('9650','2013-03-28','12:30:00',5.96),('9650','2013-03-28','12:35:00',6.23),('9650','2013-03-28','12:40:00',6.24),('9650','2013-03-28','12:45:00',5.61),('9650','2013-03-28','12:50:00',6.47),('9650','2013-03-28','12:55:00',5.45),('9650','2013-03-28','13:00:00',6.5),('9650','2013-03-28','13:05:00',5.54),('9650','2013-03-28','13:10:00',6.38),('9650','2013-03-28','13:15:00',5.55),('9650','2013-03-28','13:20:00',5.66),('9650','2013-03-28','13:25:00',6.81),('9650','2013-03-28','13:30:00',6.28),('9650','2013-03-28','13:35:00',5.75),('9650','2013-03-28','13:40:00',5.71),('9650','2013-03-28','13:45:00',6.04),('9650','2013-03-28','13:50:00',5.72),('9650','2013-03-28','13:55:00',6),('9650','2013-03-28','14:00:00',6.37),('9650','2013-03-28','14:05:00',5.15),('9650','2013-03-28','14:10:00',4.25),('9650','2013-03-28','14:15:00',4.23),('9650','2013-03-28','14:20:00',4.24),('9650','2013-03-28','14:25:00',4.37),('9650','2013-03-28','14:30:00',3.74),('9650','2013-03-28','14:35:00',3.7),('9650','2013-03-28','14:40:00',3.59),('9650','2013-03-28','14:45:00',3.31),('9650','2013-03-28','14:50:00',3.2),('9650','2013-03-28','14:55:00',3.1),('9650','2013-03-28','15:00:00',2.78),('9650','2013-03-28','15:05:00',2.83),('9650','2013-03-28','15:10:00',2.69),('9650','2013-03-28','15:15:00',2.66),('9650','2013-03-28','15:20:00',2.47),('9650','2013-03-28','15:25:00',2.21),('9650','2013-03-28','15:30:00',2.05),('9650','2013-03-28','15:35:00',1.95),('9650','2013-03-28','15:40:00',1.88),('9650','2013-03-28','15:45:00',1.86),('9650','2013-03-28','15:50:00',2.07),('9650','2013-03-28','15:55:00',2.42),('9650','2013-03-28','16:00:00',3.13),('9650','2013-03-28','16:05:00',2.92),('9650','2013-03-28','16:10:00',2.06),('9650','2013-03-28','16:15:00',1.86),('9650','2013-03-28','16:20:00',1.7),('9650','2013-03-28','16:25:00',2),('9650','2013-03-28','16:30:00',2.2),('9650','2013-03-28','16:35:00',2.38),('9650','2013-03-28','16:40:00',4.51),('9650','2013-03-28','16:45:00',3.64),('9650','2013-03-28','16:50:00',2.5),('9650','2013-03-28','16:55:00',2.03),('9650','2013-03-28','17:00:00',2.66),('9650','2013-03-28','17:05:00',1.98),('9650','2013-03-28','17:10:00',1.3),('9650','2013-03-28','17:15:00',1.35),('9650','2013-03-28','17:20:00',2.69),('9650','2013-03-28','17:25:00',2.78),('9650','2013-03-28','17:30:00',2.29),('9650','2013-03-28','17:35:00',1.68),('9650','2013-03-27','08:50:00',1.01),('9650','2013-03-27','08:55:00',1.16),('9650','2013-03-27','09:00:00',1.14),('9650','2013-03-27','09:05:00',1.45),('9650','2013-03-27','09:10:00',2.38),('9650','2013-03-27','09:15:00',3.76),('9650','2013-03-27','09:20:00',2.51),('9650','2013-03-27','09:25:00',2.54),('9650','2013-03-27','09:30:00',2.01),('9650','2013-03-27','09:35:00',1.74),('9650','2013-03-27','09:40:00',1.57),('9650','2013-03-27','09:45:00',1.87),('9650','2013-03-27','09:50:00',1.84),('9650','2013-03-27','09:55:00',1.78),('9650','2013-03-27','10:00:00',1.96),('9650','2013-03-27','10:05:00',1.71),('9650','2013-03-27','10:10:00',1.23),('9650','2013-03-27','10:15:00',1.17),('9650','2013-03-27','10:25:00',1.05),('9650','2013-03-27','10:30:00',1.09),('9650','2013-03-27','10:35:00',1.02),('9650','2013-03-27','10:55:00',1.07),('9650','2013-03-27','11:00:00',1.68),('9650','2013-03-27','11:05:00',1.24),('9650','2013-03-27','11:10:00',1.11),('9650','2013-03-27','11:25:00',1.04),('9650','2013-03-27','11:30:00',1.45),('9650','2013-03-27','11:35:00',1.87),('9650','2013-03-27','11:40:00',2.68),('9650','2013-03-27','11:45:00',2.11),('9650','2013-03-27','11:50:00',1.87),('9650','2013-03-27','11:55:00',3.62),('9650','2013-03-27','12:00:00',2.43),('9650','2013-03-27','12:05:00',1.6),('9650','2013-03-27','12:10:00',1.64),('9650','2013-03-27','12:15:00',2.01),('9650','2013-03-27','12:20:00',1.78),('9650','2013-03-27','12:25:00',1.45),('9650','2013-03-27','12:30:00',1.99),('9650','2013-03-27','12:35:00',1.56),('9650','2013-03-27','12:40:00',2.31),('9650','2013-03-27','12:45:00',2.9),('9650','2013-03-27','12:50:00',4.99),('9650','2013-03-27','12:55:00',5.69),('9650','2013-03-27','13:00:00',5.73),('9650','2013-03-27','13:05:00',8.11),('9650','2013-03-27','13:10:00',6.41),('9650','2013-03-27','13:15:00',6.23),('9650','2013-03-27','13:20:00',4.37),('9650','2013-03-27','13:25:00',3.81),('9650','2013-03-27','13:30:00',4.89),('9650','2013-03-27','13:35:00',5.07),('9650','2013-03-27','13:40:00',4.33),('9650','2013-03-27','13:45:00',4.4),('9650','2013-03-27','13:50:00',5.22),('9650','2013-03-27','13:55:00',2.93),('9650','2013-03-27','14:00:00',3.16),('9650','2013-03-27','14:05:00',3.94),('9650','2013-03-27','14:10:00',2.31),('9650','2013-03-27','14:15:00',2.4),('9650','2013-03-27','14:20:00',2.9),('9650','2013-03-27','14:25:00',2.55),('9650','2013-03-27','14:30:00',3.92),('9650','2013-03-27','14:35:00',2.86),('9650','2013-03-27','14:40:00',1.86),('9650','2013-03-27','14:45:00',1.93),('9650','2013-03-27','14:50:00',1.73),('9650','2013-03-27','14:55:00',1.49),('9650','2013-03-27','15:00:00',2.12),('9650','2013-03-27','15:05:00',2.43),('9650','2013-03-27','15:10:00',4.7),('9650','2013-03-27','15:15:00',3.49),('9650','2013-03-27','15:20:00',3.55),('9650','2013-03-27','15:25:00',1.93),('9650','2013-03-27','15:30:00',2.52),('9650','2013-03-27','15:35:00',4.11),('9650','2013-03-27','15:40:00',3.23),('9650','2013-03-27','15:45:00',3.95),('9650','2013-03-27','15:50:00',2.74),('9650','2013-03-27','15:55:00',5.35),('9650','2013-03-27','16:00:00',2.33),('9650','2013-03-27','16:05:00',1.78),('9650','2013-03-27','16:10:00',3.3),('9650','2013-03-27','16:15:00',1.12),('9650','2013-03-27','16:25:00',1.1),('9650','2013-03-27','16:30:00',1.45),('9650','2013-03-27','16:35:00',3.71),('9650','2013-03-27','16:40:00',2.47),('9650','2013-03-27','16:45:00',2.44),('9650','2013-03-27','16:50:00',1.4),('9650','2013-03-27','16:55:00',1.72),('9650','2013-03-27','17:00:00',3.59),('9650','2013-03-27','17:05:00',3.25),('9650','2013-03-27','17:10:00',3.01),('9650','2013-03-27','17:15:00',2.67),('9650','2013-03-27','17:20:00',2.34),('9650','2013-03-27','17:25:00',1.93),('9650','2013-03-27','17:30:00',1.31),('9650','2013-03-27','17:35:00',1),('9650','2013-03-26','07:55:00',1.76),('9650','2013-03-26','08:00:00',1.79),('9650','2013-03-26','08:05:00',1.7),('9650','2013-03-26','08:10:00',1.73),('9650','2013-03-26','08:15:00',1.94),('9650','2013-03-26','08:20:00',1.77),('9650','2013-03-26','08:25:00',1.81),('9650','2013-03-26','08:30:00',2.01),('9650','2013-03-26','08:35:00',1.92),('9650','2013-03-26','08:40:00',1.69),('9650','2013-03-26','08:45:00',1.6),('9650','2013-03-26','08:50:00',2.1),('9650','2013-03-26','08:55:00',1.96),('9650','2013-03-26','09:00:00',2.13),('9650','2013-03-26','09:05:00',1.67),('9650','2013-03-26','09:10:00',1.05),('9650','2013-03-26','09:15:00',2.01),('9650','2013-03-26','09:20:00',2.01),('9650','2013-03-26','09:25:00',1.41),('9650','2013-03-26','09:30:00',1.29),('9650','2013-03-26','09:35:00',1.18),('9650','2013-03-26','09:40:00',1.52),('9650','2013-03-26','09:45:00',2.34),('9650','2013-03-26','09:50:00',2.69),('9650','2013-03-26','09:55:00',2.25),('9650','2013-03-26','10:00:00',2.01),('9650','2013-03-26','10:05:00',1.37),('9650','2013-03-26','10:10:00',1.97),('9650','2013-03-26','10:15:00',2.67),('9650','2013-03-26','10:20:00',2.23),('9650','2013-03-26','10:25:00',3.02),('9650','2013-03-26','10:30:00',3.72),('9650','2013-03-26','10:35:00',3.22),('9650','2013-03-26','10:40:00',3.67),('9650','2013-03-26','10:45:00',3.51),('9650','2013-03-26','10:50:00',3.79),('9650','2013-03-26','10:55:00',3.53),('9650','2013-03-26','11:00:00',3.11),('9650','2013-03-26','11:05:00',2.75),('9650','2013-03-26','11:10:00',2.87),('9650','2013-03-26','11:15:00',3.04),('9650','2013-03-26','11:20:00',3.1),('9650','2013-03-26','11:25:00',2.87),('9650','2013-03-26','11:30:00',3.19),('9650','2013-03-26','11:35:00',3.07),('9650','2013-03-26','11:40:00',2.83),('9650','2013-03-26','11:45:00',3.03),('9650','2013-03-26','11:50:00',2.94),('9650','2013-03-26','11:55:00',4.28),('9650','2013-03-26','12:00:00',4.4),('9650','2013-03-26','12:05:00',4.13),('9650','2013-03-26','12:10:00',3.62),('9650','2013-03-26','12:15:00',2.8),('9650','2013-03-26','12:20:00',3.01),('9650','2013-03-26','12:25:00',2.82),('9650','2013-03-26','12:30:00',6.11),('9650','2013-03-26','12:35:00',7.5),('9650','2013-03-26','12:40:00',6.14),('9650','2013-03-26','12:45:00',6.57),('9650','2013-03-26','12:50:00',5.09),('9650','2013-03-26','12:55:00',3.01),('9650','2013-03-26','13:00:00',2.6),('9650','2013-03-26','13:05:00',2.69),('9650','2013-03-26','13:10:00',3.77),('9650','2013-03-26','13:15:00',2.9),('9650','2013-03-26','13:20:00',2.24),('9650','2013-03-26','13:25:00',2.37),('9650','2013-03-26','13:30:00',2.95),('9650','2013-03-26','13:35:00',3.81),('9650','2013-03-26','13:40:00',2.92),('9650','2013-03-26','13:45:00',3.46),('9650','2013-03-26','13:50:00',3.91),('9650','2013-03-26','13:55:00',3.45),('9650','2013-03-26','14:00:00',3),('9650','2013-03-26','14:05:00',2.65),('9650','2013-03-26','14:10:00',2.74),('9650','2013-03-26','14:15:00',3.13),('9650','2013-03-26','14:20:00',3.87),('9650','2013-03-26','14:25:00',3.08),('9650','2013-03-26','14:30:00',2.59),('9650','2013-03-26','14:35:00',3.02),('9650','2013-03-26','14:40:00',4.34),('9650','2013-03-26','14:45:00',3.93),('9650','2013-03-26','14:50:00',2.92),('9650','2013-03-26','14:55:00',2.18),('9650','2013-03-26','15:00:00',1.84),('9650','2013-03-26','15:05:00',2.37),('9650','2013-03-26','15:10:00',2.43),('9650','2013-03-26','15:15:00',1.83),('9650','2013-03-26','15:20:00',1.82),('9650','2013-03-26','15:25:00',1.9),('9650','2013-03-26','15:30:00',1.68),('9650','2013-03-26','15:35:00',1.52),('9650','2013-03-26','15:40:00',1.32),('9650','2013-03-26','15:55:00',1.05),('9650','2013-03-26','16:00:00',1.15),('9650','2013-03-26','16:05:00',1.44),('9650','2013-03-26','16:10:00',1.64),('9650','2013-03-26','16:15:00',1.56),('9650','2013-03-26','16:20:00',1.53),('9650','2013-03-26','16:25:00',1.64),('9650','2013-03-26','16:30:00',1.65),('9650','2013-03-26','16:35:00',1.69),('9650','2013-03-26','16:40:00',2.08),('9650','2013-03-26','16:45:00',2.51),('9650','2013-03-26','16:50:00',2.17),('9650','2013-03-26','16:55:00',2.63),('9650','2013-03-26','17:00:00',2.73),('9650','2013-03-26','17:05:00',3.55),('9650','2013-03-26','17:10:00',2.78),('9650','2013-03-26','17:15:00',1.79),('9650','2013-03-25','07:40:00',1.19),('9650','2013-03-25','07:45:00',1.41),('9650','2013-03-25','07:50:00',1.7),('9650','2013-03-25','07:55:00',1.52),('9650','2013-03-25','08:00:00',1.16),('9650','2013-03-25','08:10:00',1.09),('9650','2013-03-25','08:15:00',1.16),('9650','2013-03-25','08:20:00',1.16),('9650','2013-03-25','08:25:00',1.2),('9650','2013-03-25','08:30:00',1.65),('9650','2013-03-25','08:35:00',2.19),('9650','2013-03-25','08:40:00',2.33),('9650','2013-03-25','08:45:00',1.38),('9650','2013-03-25','08:50:00',1.24),('9650','2013-03-25','08:55:00',1.17),('9650','2013-03-25','09:00:00',1.08),('9650','2013-03-25','09:05:00',1.37),('9650','2013-03-25','09:10:00',1.93),('9650','2013-03-25','09:15:00',2.63),('9650','2013-03-25','09:20:00',1.7),('9650','2013-03-25','09:25:00',1.06),('9650','2013-03-25','09:50:00',2.01),('9650','2013-03-25','09:55:00',3.77),('9650','2013-03-25','10:00:00',1.92),('9650','2013-03-25','10:10:00',1.09),('9650','2013-03-25','10:40:00',1.02),('9650','2013-03-25','10:45:00',1.04),('9650','2013-03-25','10:50:00',1.55),('9650','2013-03-25','10:55:00',1.72),('9650','2013-03-25','11:00:00',2.07),('9650','2013-03-25','11:05:00',1.9),('9650','2013-03-25','11:10:00',3.63),('9650','2013-03-25','11:15:00',2.47),('9650','2013-03-25','11:20:00',2.54),('9650','2013-03-25','11:25:00',1.36),('9650','2013-03-25','11:45:00',1.68),('9650','2013-03-25','11:50:00',3.38),('9650','2013-03-25','11:55:00',1.81),('9650','2013-03-25','12:00:00',2.35),('9650','2013-03-25','12:05:00',2.19),('9650','2013-03-25','12:10:00',2.45),('9650','2013-03-25','12:15:00',2.59),('9650','2013-03-25','12:20:00',2.83),('9650','2013-03-25','12:25:00',3.91),('9650','2013-03-25','12:30:00',3.44),('9650','2013-03-25','12:35:00',5.02),('9650','2013-03-25','12:40:00',3.02),('9650','2013-03-25','12:45:00',4.26),('9650','2013-03-25','12:50:00',3.06),('9650','2013-03-25','12:55:00',1.93),('9650','2013-03-25','13:00:00',3.04),('9650','2013-03-25','13:05:00',4.17),('9650','2013-03-25','13:10:00',4.42),('9650','2013-03-25','13:15:00',3.14),('9650','2013-03-25','13:20:00',3.22),('9650','2013-03-25','13:25:00',3.7),('9650','2013-03-25','13:30:00',2.89),('9650','2013-03-25','13:35:00',3.68),('9650','2013-03-25','13:40:00',4.04),('9650','2013-03-25','13:45:00',3.6),('9650','2013-03-25','13:50:00',3.06),('9650','2013-03-25','13:55:00',2.77),('9650','2013-03-25','14:00:00',2.73),('9650','2013-03-25','14:05:00',2.72),('9650','2013-03-25','14:10:00',2.9),('9650','2013-03-25','14:15:00',2.66),('9650','2013-03-25','14:20:00',2.23),('9650','2013-03-25','14:25:00',2.08),('9650','2013-03-25','14:30:00',1.69),('9650','2013-03-25','14:35:00',1.56),('9650','2013-03-25','14:40:00',1.61),('9650','2013-03-25','14:45:00',1.66),('9650','2013-03-25','14:50:00',1.52),('9650','2013-03-25','14:55:00',1.49),('9650','2013-03-25','15:00:00',1.46),('9650','2013-03-25','15:05:00',1.57),('9650','2013-03-25','15:10:00',1.52),('9650','2013-03-25','15:15:00',1.36),('9650','2013-03-25','15:20:00',1.48),('9650','2013-03-25','15:25:00',1.47),('9650','2013-03-25','15:30:00',1.61),('9650','2013-03-25','15:35:00',1.72),('9650','2013-03-25','15:40:00',1.43),('9650','2013-03-24','08:15:00',1.34),('9650','2013-03-24','08:20:00',1.47),('9650','2013-03-24','08:25:00',1.59),('9650','2013-03-24','08:30:00',1.55),('9650','2013-03-24','08:40:00',1.26),('9650','2013-03-24','08:45:00',1.4),('9650','2013-03-24','08:50:00',1.65),('9650','2013-03-24','08:55:00',2.06),('9650','2013-03-24','09:00:00',1.91),('9650','2013-03-24','09:05:00',1.9),('9650','2013-03-24','09:10:00',2.17),('9650','2013-03-24','09:15:00',1.87),('9650','2013-03-24','09:20:00',3.2),('9650','2013-03-24','09:25:00',3.57),('9650','2013-03-24','09:30:00',2.45),('9650','2013-03-24','09:35:00',1.84),('9650','2013-03-24','09:40:00',1.31),('9650','2013-03-24','09:45:00',1.58),('9650','2013-03-24','09:50:00',5.46),('9650','2013-03-24','09:55:00',4.84),('9650','2013-03-24','10:00:00',1.97),('9650','2013-03-24','10:05:00',1.73),('9650','2013-03-24','10:10:00',1.99),('9650','2013-03-24','10:15:00',1.77),('9650','2013-03-24','10:20:00',2.4),('9650','2013-03-24','10:25:00',3.66),('9650','2013-03-24','10:30:00',3.36),('9650','2013-03-24','10:35:00',2.58),('9650','2013-03-24','10:40:00',2.75),('9650','2013-03-24','10:45:00',4.16),('9650','2013-03-24','10:50:00',4.42),('9650','2013-03-24','10:55:00',4.93),('9650','2013-03-24','11:00:00',3.89),('9650','2013-03-24','11:05:00',3.48),('9650','2013-03-24','11:10:00',3.75),('9650','2013-03-24','11:15:00',4.08),('9650','2013-03-24','11:20:00',6.18),('9650','2013-03-24','11:25:00',5.69),('9650','2013-03-24','11:30:00',7.01),('9650','2013-03-24','11:35:00',4.72),('9650','2013-03-24','11:40:00',2.19),('9650','2013-03-24','11:45:00',2.66),('9650','2013-03-24','11:50:00',2.98),('9650','2013-03-24','11:55:00',5.25),('9650','2013-03-24','12:00:00',6.08),('9650','2013-03-24','12:05:00',7.14),('9650','2013-03-24','12:10:00',6.33),('9650','2013-03-24','12:15:00',5.59),('9650','2013-03-24','12:20:00',4.71),('9650','2013-03-24','12:25:00',6.53),('9650','2013-03-24','12:30:00',5.28),('9650','2013-03-24','12:35:00',4.76),('9650','2013-03-24','12:40:00',4.28),('9650','2013-03-24','12:45:00',3.99),('9650','2013-03-24','12:50:00',4.64),('9650','2013-03-24','12:55:00',5.35),('9650','2013-03-24','13:00:00',5.26),('9650','2013-03-24','13:05:00',7.66),('9650','2013-03-24','13:10:00',7.33),('9650','2013-03-24','13:15:00',7.45),('9650','2013-03-24','13:20:00',6.55),('9650','2013-03-24','13:25:00',2.89),('9650','2013-03-24','13:30:00',3.3),('9650','2013-03-24','13:35:00',1.96),('9650','2013-03-24','13:40:00',2.1),('9650','2013-03-24','13:45:00',3.92),('9650','2013-03-24','13:50:00',3.45),('9650','2013-03-24','13:55:00',3.24),('9650','2013-03-24','14:00:00',1.66),('9650','2013-03-24','14:05:00',2.15),('9650','2013-03-24','14:10:00',5.96),('9650','2013-03-24','14:15:00',3.09),('9650','2013-03-24','14:20:00',3.98),('9650','2013-03-24','14:25:00',6.32),('9650','2013-03-24','14:30:00',4.39),('9650','2013-03-24','14:35:00',3.21),('9650','2013-03-24','14:40:00',2.44),('9650','2013-03-24','14:45:00',3.68),('9650','2013-03-24','14:50:00',3.09),('9650','2013-03-24','14:55:00',5.3),('9650','2013-03-24','15:00:00',5.17),('9650','2013-03-24','15:05:00',4.85),('9650','2013-03-24','15:10:00',5.65),('9650','2013-03-24','15:15:00',4.48),('9650','2013-03-24','15:20:00',3.86),('9650','2013-03-24','15:25:00',5.08),('9650','2013-03-24','15:30:00',5.03),('9650','2013-03-24','15:35:00',3.81),('9650','2013-03-24','15:40:00',5.61),('9650','2013-03-24','15:45:00',4.36),('9650','2013-03-24','15:50:00',2.51),('9650','2013-03-24','15:55:00',3.45),('9650','2013-03-24','16:00:00',4.44),('9650','2013-03-24','16:05:00',1.93),('9650','2013-03-24','16:10:00',2.74),('9650','2013-03-24','16:15:00',1.79),('9650','2013-03-24','16:20:00',1.38),('9650','2013-03-24','16:25:00',1),('9650','2013-03-24','16:30:00',2.88),('9650','2013-03-24','16:35:00',4.54),('9650','2013-03-24','16:40:00',3.96),('9650','2013-03-24','16:45:00',2.04),('9650','2013-03-24','16:50:00',1.55),('9650','2013-03-23','08:15:00',1.05),('9650','2013-03-23','08:20:00',1.13),('9650','2013-03-23','08:25:00',1.22),('9650','2013-03-23','08:30:00',1.27),('9650','2013-03-23','08:35:00',1.32),('9650','2013-03-23','08:40:00',1.39),('9650','2013-03-23','08:45:00',1.62),('9650','2013-03-23','08:50:00',1.72),('9650','2013-03-23','08:55:00',1.85),('9650','2013-03-23','09:00:00',1.97),('9650','2013-03-23','09:05:00',2.11),('9650','2013-03-23','09:10:00',2.25),('9650','2013-03-23','09:15:00',2.37),('9650','2013-03-23','09:20:00',2.5),('9650','2013-03-23','09:25:00',2.64),('9650','2013-03-23','09:30:00',2.76),('9650','2013-03-23','09:35:00',2.88),('9650','2013-03-23','09:40:00',3.01),('9650','2013-03-23','09:45:00',3.14),('9650','2013-03-23','09:50:00',3.26),('9650','2013-03-23','09:55:00',3.37),('9650','2013-03-23','10:00:00',3.51),('9650','2013-03-23','10:05:00',3.63),('9650','2013-03-23','10:10:00',3.75),('9650','2013-03-23','10:15:00',3.84),('9650','2013-03-23','10:20:00',3.95),('9650','2013-03-23','10:25:00',4.07),('9650','2013-03-23','10:30:00',4.17),('9650','2013-03-23','10:35:00',4.25),('9650','2013-03-23','10:40:00',4.35),('9650','2013-03-23','10:45:00',4.45),('9650','2013-03-23','10:50:00',4.53),('9650','2013-03-23','10:55:00',4.62),('9650','2013-03-23','11:00:00',4.7),('9650','2013-03-23','11:05:00',4.81),('9650','2013-03-23','11:10:00',4.88),('9650','2013-03-23','11:15:00',4.94),('9650','2013-03-23','11:20:00',5.03),('9650','2013-03-23','11:25:00',5.09),('9650','2013-03-23','11:30:00',5.15),('9650','2013-03-23','11:35:00',5.22),('9650','2013-03-23','11:40:00',5.3),('9650','2013-03-23','11:45:00',5.33),('9650','2013-03-23','11:50:00',5.4),('9650','2013-03-23','11:55:00',5.41),('9650','2013-03-23','12:00:00',5.47),('9650','2013-03-23','12:05:00',5.57),('9650','2013-03-23','12:10:00',5.66),('9650','2013-03-23','12:15:00',5.7),('9650','2013-03-23','12:20:00',5.8),('9650','2013-03-23','12:25:00',5.84),('9650','2013-03-23','12:30:00',5.9),('9650','2013-03-23','12:35:00',5.93),('9650','2013-03-23','12:40:00',5.95),('9650','2013-03-23','12:45:00',6.01),('9650','2013-03-23','12:50:00',6),('9650','2013-03-23','12:55:00',6.02),('9650','2013-03-23','13:00:00',6.02),('9650','2013-03-23','13:05:00',6.05),('9650','2013-03-23','13:10:00',6.08),('9650','2013-03-23','13:15:00',6.09),('9650','2013-03-23','13:20:00',6.13),('9650','2013-03-23','13:25:00',6.01),('9650','2013-03-23','13:30:00',6.11),('9650','2013-03-23','13:35:00',6.1),('9650','2013-03-23','13:40:00',6.11),('9650','2013-03-23','13:45:00',6.12),('9650','2013-03-23','13:50:00',6.08),('9650','2013-03-23','13:55:00',5.97),('9650','2013-03-23','14:00:00',5.91),('9650','2013-03-23','14:05:00',5.88),('9650','2013-03-23','14:10:00',5.72),('9650','2013-03-23','14:15:00',5.64),('9650','2013-03-23','14:20:00',5.55),('9650','2013-03-23','14:25:00',5.44),('9650','2013-03-23','14:30:00',5.38),('9650','2013-03-23','14:35:00',5.24),('9650','2013-03-23','14:40:00',5.21),('9650','2013-03-23','14:45:00',5.18),('9650','2013-03-23','14:50:00',4.93),('9650','2013-03-23','14:55:00',4.89),('9650','2013-03-23','15:00:00',4.67),('9650','2013-03-23','15:05:00',4.54),('9650','2013-03-23','15:10:00',4.27),('9650','2013-03-23','15:15:00',4.66),('9650','2013-03-23','15:20:00',4.66),('9650','2013-03-23','15:25:00',4.38),('9650','2013-03-23','15:30:00',4.04),('9650','2013-03-23','15:35:00',3.98),('9650','2013-03-23','15:40:00',3.98),('9650','2013-03-23','15:45:00',3.42),('9650','2013-03-23','15:50:00',2.33),('9650','2013-03-23','15:55:00',2.29),('9650','2013-03-23','16:00:00',2.24),('9650','2013-03-23','16:05:00',2.71),('9650','2013-03-23','16:10:00',1.99),('9650','2013-03-23','16:15:00',2.91),('9650','2013-03-23','16:20:00',2.36),('9650','2013-03-23','16:25:00',2.05),('9650','2013-03-23','16:30:00',2.44),('9650','2013-03-23','16:35:00',2.08),('9650','2013-03-23','16:40:00',1.66),('9650','2013-03-23','16:45:00',1.62),('9650','2013-03-23','16:50:00',1.25),('9650','2013-03-22','08:20:00',1.01),('9650','2013-03-22','08:25:00',1.11),('9650','2013-03-22','08:30:00',1.2),('9650','2013-03-22','08:35:00',1.32),('9650','2013-03-22','08:40:00',1.47),('9650','2013-03-22','08:45:00',1.59),('9650','2013-03-22','08:50:00',1.71),('9650','2013-03-22','08:55:00',1.9),('9650','2013-03-22','09:00:00',2.04),('9650','2013-03-22','09:05:00',2.18),('9650','2013-03-22','09:10:00',2.28),('9650','2013-03-22','09:15:00',2.41),('9650','2013-03-22','09:20:00',2.52),('9650','2013-03-22','09:25:00',2.69),('9650','2013-03-22','09:30:00',2.86),('9650','2013-03-22','09:35:00',2.96),('9650','2013-03-22','09:40:00',2.96),('9650','2013-03-22','09:45:00',3.19),('9650','2013-03-22','09:50:00',3.31),('9650','2013-03-22','09:55:00',3.51),('9650','2013-03-22','10:00:00',3.6),('9650','2013-03-22','10:05:00',3.38),('9650','2013-03-22','10:10:00',3.46),('9650','2013-03-22','10:15:00',3.98),('9650','2013-03-22','10:20:00',4.09),('9650','2013-03-22','10:25:00',4.15),('9650','2013-03-22','10:30:00',4.43),('9650','2013-03-22','10:35:00',4.58),('9650','2013-03-22','10:40:00',4.64),('9650','2013-03-22','10:45:00',4.66),('9650','2013-03-22','10:50:00',4.75),('9650','2013-03-22','10:55:00',4.64),('9650','2013-03-22','11:00:00',4.61),('9650','2013-03-22','11:05:00',4.4),('9650','2013-03-22','11:10:00',3.88),('9650','2013-03-22','11:15:00',4.38),('9650','2013-03-22','11:20:00',4.65),('9650','2013-03-22','11:25:00',4.86),('9650','2013-03-22','11:30:00',4.91),('9650','2013-03-22','11:35:00',5.26),('9650','2013-03-22','11:40:00',5.31),('9650','2013-03-22','11:45:00',5.35),('9650','2013-03-22','11:50:00',5.17),('9650','2013-03-22','11:55:00',5.44),('9650','2013-03-22','12:00:00',5.59),('9650','2013-03-22','12:05:00',5.56),('9650','2013-03-22','12:10:00',5.61),('9650','2013-03-22','12:15:00',5.91),('9650','2013-03-22','12:20:00',5.99),('9650','2013-03-22','12:25:00',5.88),('9650','2013-03-22','12:30:00',6.01),('9650','2013-03-22','12:35:00',5.92),('9650','2013-03-22','12:40:00',5.78),('9650','2013-03-22','12:45:00',5.98),('9650','2013-03-22','12:50:00',6.09),('9650','2013-03-22','12:55:00',5.96),('9650','2013-03-22','13:00:00',4.87),('9650','2013-03-22','13:05:00',6.08),('9650','2013-03-22','13:10:00',6.14),('9650','2013-03-22','13:15:00',5.96),('9650','2013-03-22','13:20:00',6.2),('9650','2013-03-22','13:25:00',5.81),('9650','2013-03-22','13:30:00',5.67),('9650','2013-03-22','13:35:00',5.94),('9650','2013-03-22','13:40:00',6.04),('9650','2013-03-22','13:45:00',6.01),('9650','2013-03-22','13:50:00',6.16),('9650','2013-03-22','13:55:00',5.9),('9650','2013-03-22','14:00:00',5.86),('9650','2013-03-22','14:05:00',5.75),('9650','2013-03-22','14:10:00',5.62),('9650','2013-03-22','14:15:00',5.45),('9650','2013-03-22','14:20:00',5.55),('9650','2013-03-22','14:25:00',5.54),('9650','2013-03-22','14:30:00',5.59),('9650','2013-03-22','14:35:00',5.5),('9650','2013-03-22','14:40:00',5.37),('9650','2013-03-22','14:45:00',5.08),('9650','2013-03-22','14:50:00',5),('9650','2013-03-22','14:55:00',4.96),('9650','2013-03-22','15:00:00',4.81),('9650','2013-03-22','15:05:00',4.52),('9650','2013-03-22','15:10:00',4.77),('9650','2013-03-22','15:15:00',4.54),('9650','2013-03-22','15:20:00',4.62),('9650','2013-03-22','15:25:00',4.59),('9650','2013-03-22','15:30:00',4.18),('9650','2013-03-22','15:35:00',4.17),('9650','2013-03-22','15:40:00',4.03),('9650','2013-03-22','15:45:00',3.78),('9650','2013-03-22','15:50:00',3.61),('9650','2013-03-22','15:55:00',3.64),('9650','2013-03-22','16:00:00',3.45),('9650','2013-03-22','16:05:00',3.17),('9650','2013-03-22','16:10:00',3.99),('9650','2013-03-22','16:15:00',3.62),('9650','2013-03-22','16:20:00',3.08),('9650','2013-03-22','16:25:00',3.24),('9650','2013-03-22','16:30:00',2.55),('9650','2013-03-22','16:35:00',2.91),('9650','2013-03-22','16:40:00',2.52),('9650','2013-03-22','16:45:00',2.57),('9650','2013-03-22','16:50:00',2.17),('9650','2013-03-22','16:55:00',2.21),('9650','2013-03-22','17:00:00',2.7),('9650','2013-03-22','17:05:00',2.87),('9650','2013-03-22','17:10:00',2.55),('9650','2013-03-22','17:15:00',2.13),('9650','2013-03-22','17:20:00',1.99),('9650','2013-03-22','17:25:00',1.87),('9650','2013-03-22','17:30:00',1.63),('9650','2013-03-22','17:35:00',1.19),('9650','2013-03-22','17:40:00',1.24),('9650','2014-03-25','08:15:00',1.05),('9650','2014-03-25','08:20:00',1.59),('9650','2014-03-25','08:25:00',1.78),('9650','2014-03-25','08:30:00',1.78),('9650','2014-03-25','08:35:00',1.54),('9650','2014-03-25','08:40:00',1.75),('9650','2014-03-25','08:45:00',1.88),('9650','2014-03-25','08:50:00',2.14),('9650','2014-03-25','08:55:00',1.86),('9650','2014-03-25','09:00:00',2),('9650','2014-03-25','09:05:00',1.9),('9650','2014-03-25','09:10:00',2.13),('9650','2014-03-25','09:15:00',1.77),('9650','2014-03-25','09:20:00',1.3),('9650','2014-03-25','09:25:00',1.77),('9650','2014-03-25','09:30:00',2.96),('9650','2014-03-25','09:35:00',3.06),('9650','2014-03-25','09:50:00',3.13),('9650','2014-03-25','09:55:00',3.6),('9650','2014-03-25','10:00:00',3.98),('9650','2014-03-25','10:05:00',3.48),('9650','2014-03-25','10:10:00',4.91),('9650','2014-03-25','10:15:00',4.89),('9650','2014-03-25','10:20:00',2.75),('9650','2014-03-25','10:25:00',4.93),('9650','2014-03-25','10:30:00',4.2),('9650','2014-03-25','10:35:00',2.55),('9650','2014-03-25','10:40:00',1.39),('9650','2014-03-25','10:45:00',2.77),('9650','2014-03-25','10:50:00',3.92),('9650','2014-03-25','10:55:00',6.8),('9650','2014-03-25','11:00:00',5.58),('9650','2014-03-25','11:05:00',1.88),('9650','2014-03-25','11:10:00',5.81),('9650','2014-03-25','11:15:00',6.91),('9650','2014-03-25','11:20:00',3.63),('9650','2014-03-25','11:25:00',2.17),('9650','2014-03-25','11:30:00',2.79),('9650','2014-03-25','11:35:00',2.92),('9650','2014-03-25','11:40:00',3.3),('9650','2014-03-25','11:45:00',4.95),('9650','2014-03-25','11:50:00',5.75),('9650','2014-03-25','11:55:00',7.42),('9650','2014-03-25','12:00:00',7.29),('9650','2014-03-25','12:05:00',6.36),('9650','2014-03-25','12:10:00',6.14),('9650','2014-03-25','12:15:00',2.71),('9650','2014-03-25','12:20:00',3.19),('9650','2014-03-25','12:25:00',3.02),('9650','2014-03-25','12:30:00',2.97),('9650','2014-03-25','12:35:00',2.86),('9650','2014-03-25','12:40:00',3.59),('9650','2014-03-25','12:45:00',3.75),('9650','2014-03-25','12:50:00',2.88),('9650','2014-03-25','12:55:00',2.2),('9650','2014-03-25','13:00:00',2.4),('9650','2014-03-25','13:05:00',2.13),('9650','2014-03-25','13:10:00',1.95),('9650','2014-03-25','13:15:00',1.43),('9650','2014-03-25','13:20:00',3.55),('9650','2014-03-25','13:25:00',7.52),('9650','2014-03-25','13:30:00',6.24),('9650','2014-03-25','13:35:00',3.66),('9650','2014-03-25','13:40:00',2.12),('9650','2014-03-25','13:45:00',1.71),('9650','2014-03-25','13:50:00',1.7),('9650','2014-03-25','13:55:00',2.24),('9650','2014-03-25','14:00:00',4.09),('9650','2014-03-25','14:05:00',7.11),('9650','2014-03-25','14:10:00',7.08),('9650','2014-03-25','14:15:00',2.47),('9650','2014-03-25','14:20:00',1.68),('9650','2014-03-25','14:25:00',1.4),('9650','2014-03-25','14:30:00',1.26),('9650','2014-03-25','14:35:00',1.1),('9650','2014-03-25','14:40:00',1.17),('9650','2014-03-25','14:45:00',3.74),('9650','2014-03-25','14:50:00',5.48),('9650','2014-03-25','14:55:00',5.95),('9650','2014-03-25','15:00:00',5.38),('9650','2014-03-25','15:05:00',5.39),('9650','2014-03-25','15:10:00',5.48),('9650','2014-03-25','15:15:00',5.6),('9650','2014-03-25','15:20:00',4.96),('9650','2014-03-25','15:25:00',5.32),('9650','2014-03-25','15:30:00',5.47),('9650','2014-03-25','15:35:00',5.29),('9650','2014-03-25','15:40:00',4.24),('9650','2014-03-25','15:45:00',4.28),('9650','2014-03-25','15:50:00',3.64),('9650','2014-03-25','15:55:00',3.02),('9650','2014-03-25','16:00:00',2.33),('9650','2014-03-25','16:05:00',2.44),('9650','2014-03-25','16:10:00',2.82),('9650','2014-03-25','16:15:00',2.96),('9650','2014-03-25','16:20:00',2.03),('9650','2014-03-25','16:25:00',1.61),('9650','2014-03-25','16:30:00',1.28),('9650','2014-03-25','16:35:00',1.25),('9650','2013-03-21','08:30:00',1.1),('9650','2013-03-21','08:35:00',1.22),('9650','2013-03-21','08:40:00',1.33),('9650','2013-03-21','08:45:00',1.45),('9650','2013-03-21','08:50:00',1.58),('9650','2013-03-21','08:55:00',1.71),('9650','2013-03-21','09:00:00',1.83),('9650','2013-03-21','09:05:00',1.97),('9650','2013-03-21','09:10:00',2.12),('9650','2013-03-21','09:15:00',2.26),('9650','2013-03-21','09:20:00',2.36),('9650','2013-03-21','09:25:00',2.51),('9650','2013-03-21','09:30:00',2.66),('9650','2013-03-21','09:35:00',2.81),('9650','2013-03-21','09:40:00',2.92),('9650','2013-03-21','09:45:00',3.09),('9650','2013-03-21','09:50:00',3.2),('9650','2013-03-21','09:55:00',3.33),('9650','2013-03-21','10:00:00',3.48),('9650','2013-03-21','10:05:00',3.63),('9650','2013-03-21','10:10:00',3.71),('9650','2013-03-21','10:15:00',3.8),('9650','2013-03-21','10:20:00',3.91),('9650','2013-03-21','10:25:00',4.11),('9650','2013-03-21','10:30:00',4.24),('9650','2013-03-21','10:35:00',4.33),('9650','2013-03-21','10:40:00',4.43),('9650','2013-03-21','10:45:00',4.52),('9650','2013-03-21','10:50:00',4.65),('9650','2013-03-21','10:55:00',4.75),('9650','2013-03-21','11:00:00',4.83),('9650','2013-03-21','11:05:00',4.94),('9650','2013-03-21','11:10:00',5.02),('9650','2013-03-21','11:15:00',5.1),('9650','2013-03-21','11:20:00',5.17),('9650','2013-03-21','11:25:00',5.22),('9650','2013-03-21','11:30:00',5.37),('9650','2013-03-21','11:35:00',5.38),('9650','2013-03-21','11:40:00',5.51),('9650','2013-03-21','11:45:00',5.6),('9650','2013-03-21','11:50:00',5.66),('9650','2013-03-21','11:55:00',5.72),('9650','2013-03-21','12:00:00',5.8),('9650','2013-03-21','12:05:00',5.86),('9650','2013-03-21','12:10:00',5.89),('9650','2013-03-21','12:15:00',5.91),('9650','2013-03-21','12:20:00',5.99),('9650','2013-03-21','12:25:00',6.04),('9650','2013-03-21','12:30:00',6.1),('9650','2013-03-21','12:35:00',6.17),('9650','2013-03-21','12:40:00',6.22),('9650','2013-03-21','12:45:00',6.25),('9650','2013-03-21','12:50:00',6.17),('9650','2013-03-21','12:55:00',6.04),('9650','2013-03-21','13:00:00',6.34),('9650','2013-03-21','13:05:00',6.26),('9650','2013-03-21','13:10:00',6.46),('9650','2013-03-21','13:15:00',6.38),('9650','2013-03-21','13:20:00',6.36),('9650','2013-03-21','13:25:00',5.99),('9650','2013-03-21','13:30:00',5.91),('9650','2013-03-21','13:35:00',6.28),('9650','2013-03-21','13:40:00',5.44),('9650','2013-03-21','13:45:00',5.7),('9650','2013-03-21','13:50:00',6.39),('9650','2013-03-21','13:55:00',6.18),('9650','2013-03-21','14:00:00',6.12),('9650','2013-03-21','14:05:00',6.15),('9650','2013-03-21','14:10:00',6.08),('9650','2013-03-21','14:15:00',5.98),('9650','2013-03-21','14:20:00',5.86),('9650','2013-03-21','14:25:00',5.79),('9650','2013-03-21','14:30:00',5.74),('9650','2013-03-21','14:35:00',5.6),('9650','2013-03-21','14:40:00',5.44),('9650','2013-03-21','14:45:00',5.35),('9650','2013-03-21','14:50:00',5.37),('9650','2013-03-21','14:55:00',5.24),('9650','2013-03-21','15:00:00',5.16),('9650','2013-03-21','15:05:00',5.04),('9650','2013-03-21','15:10:00',4.56),('9650','2013-03-21','15:15:00',3.86),('9650','2013-03-21','15:20:00',3.71),('9650','2013-03-21','15:25:00',3.93),('9650','2013-03-21','15:30:00',3.63),('9650','2013-03-21','15:35:00',4.18),('9650','2013-03-21','15:40:00',4),('9650','2013-03-21','15:45:00',3.53),('9650','2013-03-21','15:50:00',3.97),('9650','2013-03-21','15:55:00',3.6),('9650','2013-03-21','16:00:00',2.7),('9650','2013-03-21','16:05:00',2.9),('9650','2013-03-21','16:10:00',3.35),('9650','2013-03-21','16:15:00',3.99),('9650','2013-03-21','16:20:00',3.21),('9650','2013-03-21','16:25:00',3.34),('9650','2013-03-21','16:30:00',3.72),('9650','2013-03-21','16:35:00',3.79),('9650','2013-03-21','16:40:00',3.74),('9650','2013-03-21','16:45:00',3.52),('9650','2013-03-21','16:50:00',3.39),('9650','2013-03-21','16:55:00',3.28),('9650','2013-03-21','17:00:00',3.07),('9650','2013-03-21','17:05:00',2.87),('9650','2013-03-21','17:10:00',2.66),('9650','2013-03-21','17:15:00',2.46),('9650','2013-03-21','17:20:00',2.31),('9650','2013-03-21','17:25:00',1.27),('9650','2013-03-21','17:30:00',1.55),('9650','2013-03-21','17:35:00',1.5),('9650','2013-03-21','17:40:00',1.27),('9650','2013-03-20','08:25:00',1.17),('9650','2013-03-20','08:30:00',1.02),('9650','2013-03-20','08:35:00',1.24),('9650','2013-03-20','08:40:00',1.67),('9650','2013-03-20','08:45:00',1.61),('9650','2013-03-20','08:50:00',1.54),('9650','2013-03-20','08:55:00',1.71),('9650','2013-03-20','09:00:00',1.97),('9650','2013-03-20','09:05:00',2.5),('9650','2013-03-20','09:10:00',2.92),('9650','2013-03-20','09:15:00',2.26),('9650','2013-03-20','09:20:00',2.04),('9650','2013-03-20','09:25:00',1.93),('9650','2013-03-20','09:30:00',2.05),('9650','2013-03-20','09:35:00',2.85),('9650','2013-03-20','09:40:00',2.93),('9650','2013-03-20','09:45:00',3.15),('9650','2013-03-20','09:50:00',3.27),('9650','2013-03-20','09:55:00',3.41),('9650','2013-03-20','10:00:00',3.55),('9650','2013-03-20','10:05:00',3.69),('9650','2013-03-20','10:10:00',3.8),('9650','2013-03-20','10:15:00',3.95),('9650','2013-03-20','10:20:00',4.06),('9650','2013-03-20','10:25:00',4.16),('9650','2013-03-20','10:30:00',4.31),('9650','2013-03-20','10:35:00',4.44),('9650','2013-03-20','10:40:00',4.54),('9650','2013-03-20','10:45:00',4.6),('9650','2013-03-20','10:50:00',4.72),('9650','2013-03-20','10:55:00',4.21),('9650','2013-03-20','11:00:00',4.91),('9650','2013-03-20','11:05:00',5.07),('9650','2013-03-20','11:10:00',5.13),('9650','2013-03-20','11:15:00',5.25),('9650','2013-03-20','11:20:00',5.33),('9650','2013-03-20','11:25:00',5.47),('9650','2013-03-20','11:30:00',5.54),('9650','2013-03-20','11:35:00',5.64),('9650','2013-03-20','11:40:00',5.69),('9650','2013-03-20','11:45:00',5.79),('9650','2013-03-20','11:50:00',5.85),('9650','2013-03-20','11:55:00',5.94),('9650','2013-03-20','12:00:00',5.99),('9650','2013-03-20','12:05:00',6.08),('9650','2013-03-20','12:10:00',6.11),('9650','2013-03-20','12:15:00',6.16),('9650','2013-03-20','12:20:00',6.21),('9650','2013-03-20','12:25:00',6.28),('9650','2013-03-20','12:30:00',6.32),('9650','2013-03-20','12:35:00',6.36),('9650','2013-03-20','12:40:00',6.4),('9650','2013-03-20','12:45:00',6.4),('9650','2013-03-20','12:50:00',6.42),('9650','2013-03-20','12:55:00',6.48),('9650','2013-03-20','13:00:00',6.48),('9650','2013-03-20','13:05:00',6.45),('9650','2013-03-20','13:10:00',6.41),('9650','2013-03-20','13:15:00',6.46),('9650','2013-03-20','13:20:00',6.44),('9650','2013-03-20','13:25:00',6.44),('9650','2013-03-20','13:30:00',6.46),('9650','2013-03-20','13:35:00',6.47),('9650','2013-03-20','13:40:00',6.49),('9650','2013-03-20','13:45:00',6.4),('9650','2013-03-20','13:50:00',6.35),('9650','2013-03-20','13:55:00',6.25),('9650','2013-03-20','14:00:00',6.14),('9650','2013-03-20','14:05:00',6.08),('9650','2013-03-20','14:10:00',6.07),('9650','2013-03-20','14:15:00',5.99),('9650','2013-03-20','14:20:00',5.84),('9650','2013-03-20','14:25:00',5.77),('9650','2013-03-20','14:30:00',5.58),('9650','2013-03-20','14:35:00',5.52),('9650','2013-03-20','14:40:00',5.48),('9650','2013-03-20','14:45:00',5.43),('9650','2013-03-20','14:50:00',5.38),('9650','2013-03-20','14:55:00',5.26),('9650','2013-03-20','15:00:00',5.16),('9650','2013-03-20','15:05:00',5),('9650','2013-03-20','15:10:00',4.92),('9650','2013-03-20','15:15:00',4.91),('9650','2013-03-20','15:20:00',4.84),('9650','2013-03-20','15:25:00',4.75),('9650','2013-03-20','15:30:00',4.64),('9650','2013-03-20','15:35:00',4.56),('9650','2013-03-20','15:40:00',4.44),('9650','2013-03-20','15:45:00',4.31),('9650','2013-03-20','15:50:00',4.22),('9650','2013-03-20','15:55:00',4.13),('9650','2013-03-20','16:00:00',4.1),('9650','2013-03-20','16:05:00',4.05),('9650','2013-03-20','16:10:00',3.89),('9650','2013-03-20','16:15:00',3.77),('9650','2013-03-20','16:20:00',3.64),('9650','2013-03-20','16:25:00',3.51),('9650','2013-03-20','16:30:00',3.48),('9650','2013-03-20','16:35:00',3.37),('9650','2013-03-20','16:40:00',3.21),('9650','2013-03-20','16:45:00',3.17),('9650','2013-03-20','16:50:00',3.02),('9650','2013-03-20','16:55:00',2.89),('9650','2013-03-20','17:00:00',2.74),('9650','2013-03-20','17:05:00',2.65),('9650','2013-03-20','17:10:00',2.56),('9650','2013-03-20','17:15:00',2.37),('9650','2013-03-20','17:20:00',2.23),('9650','2013-03-20','17:25:00',2.03),('9650','2013-03-20','17:30:00',1.8),('9650','2013-03-20','17:35:00',1.58),('9650','2013-03-20','17:40:00',1.31),('9650','2013-03-19','08:00:00',1.07),('9650','2013-03-19','08:25:00',1.03),('9650','2013-03-19','08:30:00',1.2),('9650','2013-03-19','08:35:00',1.35),('9650','2013-03-19','08:40:00',1.34),('9650','2013-03-19','08:45:00',1.42),('9650','2013-03-19','08:50:00',1.7),('9650','2013-03-19','08:55:00',1.77),('9650','2013-03-19','09:00:00',1.98),('9650','2013-03-19','09:05:00',2.84),('9650','2013-03-19','09:10:00',2.62),('9650','2013-03-19','09:15:00',2.47),('9650','2013-03-19','09:20:00',2.79),('9650','2013-03-19','09:25:00',2.66),('9650','2013-03-19','09:30:00',2.79),('9650','2013-03-19','09:35:00',2.68),('9650','2013-03-19','09:40:00',2.91),('9650','2013-03-19','09:45:00',3.05),('9650','2013-03-19','09:50:00',3.18),('9650','2013-03-19','09:55:00',3.27),('9650','2013-03-19','10:00:00',3.49),('9650','2013-03-19','10:05:00',3.48),('9650','2013-03-19','10:10:00',3.19),('9650','2013-03-19','10:15:00',3.64),('9650','2013-03-19','10:20:00',3.12),('9650','2013-03-19','10:25:00',3.16),('9650','2013-03-19','10:30:00',3.64),('9650','2013-03-19','10:35:00',4.84),('9650','2013-03-19','10:40:00',3.95),('9650','2013-03-19','10:45:00',3.82),('9650','2013-03-19','10:50:00',4.16),('9650','2013-03-19','10:55:00',3.92),('9650','2013-03-19','11:00:00',4.34),('9650','2013-03-19','11:05:00',4.9),('9650','2013-03-19','11:10:00',3.6),('9650','2013-03-19','11:15:00',3.45),('9650','2013-03-19','11:20:00',3.94),('9650','2013-03-19','11:25:00',3.83),('9650','2013-03-19','11:30:00',3.76),('9650','2013-03-19','11:35:00',4.12),('9650','2013-03-19','11:40:00',3.41),('9650','2013-03-19','11:45:00',3.38),('9650','2013-03-19','11:50:00',3.38),('9650','2013-03-19','11:55:00',3.69),('9650','2013-03-19','12:00:00',3.63),('9650','2013-03-19','12:05:00',3.96),('9650','2013-03-19','12:10:00',3.38),('9650','2013-03-19','12:15:00',2.96),('9650','2013-03-19','12:20:00',2.74),('9650','2013-03-19','12:25:00',2.32),('9650','2013-03-19','12:30:00',1.89),('9650','2013-03-19','12:35:00',2.35),('9650','2013-03-19','12:40:00',1.73),('9650','2013-03-19','12:45:00',1.76),('9650','2013-03-19','12:50:00',2.55),('9650','2013-03-19','12:55:00',3.02),('9650','2013-03-19','13:00:00',3.23),('9650','2013-03-19','13:05:00',2.42),('9650','2013-03-19','13:10:00',2.5),('9650','2013-03-19','13:15:00',2.06),('9650','2013-03-19','13:20:00',2.21),('9650','2013-03-19','13:25:00',2.39),('9650','2013-03-19','13:30:00',2.63),('9650','2013-03-19','13:35:00',2.5),('9650','2013-03-19','13:40:00',3.11),('9650','2013-03-19','13:45:00',3.6),('9650','2013-03-19','13:50:00',3.03),('9650','2013-03-19','13:55:00',2.86),('9650','2013-03-19','14:00:00',2.84),('9650','2013-03-19','14:05:00',2.42),('9650','2013-03-19','14:10:00',2.26),('9650','2013-03-19','14:15:00',3.01),('9650','2013-03-19','14:20:00',3.78),('9650','2013-03-19','14:25:00',3.56),('9650','2013-03-19','14:30:00',3.14),('9650','2013-03-19','14:35:00',2.53),('9650','2013-03-19','14:40:00',1.99),('9650','2013-03-19','14:45:00',1.94),('9650','2013-03-19','14:50:00',1.56),('9650','2013-03-19','14:55:00',1.21),('9650','2013-03-19','15:00:00',1.36),('9650','2013-03-19','15:05:00',1.27),('9650','2013-03-19','15:10:00',1.14),('9650','2013-03-19','15:30:00',1.08),('9650','2013-03-18','08:40:00',1.12),('9650','2013-03-18','08:45:00',1.3),('9650','2013-03-18','08:50:00',1.41),('9650','2013-03-18','08:55:00',1.51),('9650','2013-03-18','09:00:00',1.65),('9650','2013-03-18','09:05:00',1.79),('9650','2013-03-18','09:10:00',1.95),('9650','2013-03-18','09:15:00',2.1),('9650','2013-03-18','09:20:00',1.68),('9650','2013-03-18','09:25:00',2.2),('9650','2013-03-18','09:30:00',2.52),('9650','2013-03-18','09:35:00',2.59),('9650','2013-03-18','09:40:00',2.84),('9650','2013-03-18','09:45:00',2.96),('9650','2013-03-18','09:50:00',2.87),('9650','2013-03-18','09:55:00',3.14),('9650','2013-03-18','10:00:00',2.91),('9650','2013-03-18','10:05:00',3.23),('9650','2013-03-18','10:10:00',3.56),('9650','2013-03-18','10:15:00',3.71),('9650','2013-03-18','10:20:00',3.87),('9650','2013-03-18','10:25:00',3.65),('9650','2013-03-18','10:30:00',4.07),('9650','2013-03-18','10:35:00',4.21),('9650','2013-03-18','10:40:00',4.31),('9650','2013-03-18','10:45:00',4.47),('9650','2013-03-18','10:50:00',4.31),('9650','2013-03-18','10:55:00',4.74),('9650','2013-03-18','11:00:00',4.8),('9650','2013-03-18','11:05:00',4.9),('9650','2013-03-18','11:10:00',4.82),('9650','2013-03-18','11:15:00',5.1),('9650','2013-03-18','11:20:00',5.14),('9650','2013-03-18','11:25:00',5.17),('9650','2013-03-18','11:30:00',5.23),('9650','2013-03-18','11:35:00',3.27),('9650','2013-03-18','11:40:00',5.01),('9650','2013-03-18','11:45:00',5.12),('9650','2013-03-18','11:50:00',5.85),('9650','2013-03-18','11:55:00',5.82),('9650','2013-03-18','12:00:00',5.79),('9650','2013-03-18','12:05:00',5.76),('9650','2013-03-18','12:10:00',5.83),('9650','2013-03-18','12:15:00',5.59),('9650','2013-03-18','12:20:00',5.97),('9650','2013-03-18','12:25:00',6),('9650','2013-03-18','12:30:00',5.93),('9650','2013-03-18','12:35:00',6.1),('9650','2013-03-18','12:40:00',6.17),('9650','2013-03-18','12:45:00',6.17),('9650','2013-03-18','12:50:00',6.21),('9650','2013-03-18','12:55:00',6.22),('9650','2013-03-18','13:00:00',6.22),('9650','2013-03-18','13:05:00',6.17),('9650','2013-03-18','13:10:00',6.19),('9650','2013-03-18','13:15:00',6.18),('9650','2013-03-18','13:20:00',6.21),('9650','2013-03-18','13:25:00',6.22),('9650','2013-03-18','13:30:00',6.18),('9650','2013-03-18','13:35:00',6.12),('9650','2013-03-18','13:40:00',6.01),('9650','2013-03-18','13:45:00',6.11),('9650','2013-03-18','13:50:00',6.13),('9650','2013-03-18','13:55:00',6.03),('9650','2013-03-18','14:00:00',5.97),('9650','2013-03-18','14:05:00',5.96),('9650','2013-03-18','14:10:00',5.91),('9650','2013-03-18','14:15:00',5.7),('9650','2013-03-18','14:20:00',5.61),('9650','2013-03-18','14:25:00',5.58),('9650','2013-03-18','14:30:00',5.46),('9650','2013-03-18','14:35:00',5.4),('9650','2013-03-18','14:40:00',5.34),('9650','2013-03-18','14:45:00',5.3),('9650','2013-03-18','14:50:00',5.14),('9650','2013-03-18','14:55:00',4.98),('9650','2013-03-18','15:00:00',4.83),('9650','2013-03-18','15:05:00',4.67),('9650','2013-03-18','15:10:00',4.65),('9650','2013-03-18','15:15:00',4.67),('9650','2013-03-18','15:20:00',4.65),('9650','2013-03-18','15:25:00',4.53),('9650','2013-03-18','15:30:00',4.28),('9650','2013-03-18','15:35:00',4.18),('9650','2013-03-18','15:40:00',4.27),('9650','2013-03-18','15:45:00',4.22),('9650','2013-03-18','15:50:00',4.14),('9650','2013-03-18','15:55:00',4.08),('9650','2013-03-18','16:00:00',4.02),('9650','2013-03-18','16:05:00',3.93),('9650','2013-03-18','16:10:00',3.81),('9650','2013-03-18','16:15:00',3.67),('9650','2013-03-18','16:20:00',3.53),('9650','2013-03-18','16:25:00',3.43),('9650','2013-03-18','16:30:00',3.43),('9650','2013-03-18','16:35:00',3.36),('9650','2013-03-18','16:40:00',3.23),('9650','2013-03-18','16:45:00',2.66),('9650','2013-03-18','16:50:00',2.13),('9650','2013-03-18','16:55:00',2.38),('9650','2013-03-18','17:00:00',1.94),('9650','2013-03-18','17:05:00',1.85),('9650','2013-03-18','17:10:00',1.82),('9650','2013-03-18','17:15:00',2.32),('9650','2013-03-18','17:20:00',2.13),('9650','2013-03-18','17:25:00',1.8),('9650','2013-03-18','17:30:00',1.43),('9650','2013-03-18','17:35:00',1.39),('9650','2013-03-17','08:20:00',1.02),('9650','2013-03-17','08:25:00',1.13),('9650','2013-03-17','08:30:00',1.23),('9650','2013-03-17','08:35:00',1.17),('9650','2013-03-17','08:40:00',1.17),('9650','2013-03-17','08:45:00',1.6),('9650','2013-03-17','08:50:00',1.39),('9650','2013-03-17','08:55:00',1.2),('9650','2013-03-17','09:35:00',1),('9650','2013-03-17','09:40:00',1.14),('9650','2013-03-17','09:45:00',1.22),('9650','2013-03-17','09:50:00',1.29),('9650','2013-03-17','09:55:00',1.79),('9650','2013-03-17','10:00:00',2.14),('9650','2013-03-17','10:05:00',2.41),('9650','2013-03-17','10:10:00',2.43),('9650','2013-03-17','10:15:00',2.19),('9650','2013-03-17','10:20:00',2.47),('9650','2013-03-17','10:25:00',2.82),('9650','2013-03-17','10:30:00',2.88),('9650','2013-03-17','10:35:00',2.57),('9650','2013-03-17','10:40:00',2.49),('9650','2013-03-17','10:45:00',2.59),('9650','2013-03-17','10:50:00',2.44),('9650','2013-03-17','10:55:00',2.05),('9650','2013-03-17','11:00:00',2.26),('9650','2013-03-17','11:05:00',2.52),('9650','2013-03-17','11:10:00',2.8),('9650','2013-03-17','11:15:00',3.03),('9650','2013-03-17','11:20:00',3.1),('9650','2013-03-17','11:25:00',3.21),('9650','2013-03-17','11:30:00',3.79),('9650','2013-03-17','11:35:00',3.34),('9650','2013-03-17','11:40:00',3.02),('9650','2013-03-17','11:45:00',2.61),('9650','2013-03-17','11:50:00',2.16),('9650','2013-03-17','11:55:00',2.54),('9650','2013-03-17','12:00:00',2.69),('9650','2013-03-17','12:05:00',4.43),('9650','2013-03-17','12:10:00',4.17),('9650','2013-03-17','12:15:00',4.82),('9650','2013-03-17','12:20:00',4.56),('9650','2013-03-17','12:25:00',3.36),('9650','2013-03-17','12:30:00',4.89),('9650','2013-03-17','12:35:00',5.98),('9650','2013-03-17','12:40:00',4.66),('9650','2013-03-17','12:45:00',4.35),('9650','2013-03-17','12:50:00',5.89),('9650','2013-03-17','12:55:00',6.26),('9650','2013-03-17','13:00:00',5.39),('9650','2013-03-17','13:05:00',2.7),('9650','2013-03-17','13:10:00',2.02),('9650','2013-03-17','13:15:00',1.56),('9650','2013-03-17','13:20:00',2.01),('9650','2013-03-17','13:25:00',3.41),('9650','2013-03-17','13:30:00',2.33),('9650','2013-03-17','13:35:00',2.06),('9650','2013-03-17','13:40:00',3.41),('9650','2013-03-17','13:45:00',3.12),('9650','2013-03-17','13:50:00',2.94),('9650','2013-03-17','13:55:00',2.58),('9650','2013-03-17','14:00:00',2.94),('9650','2013-03-17','14:05:00',4.42),('9650','2013-03-17','14:10:00',4.04),('9650','2013-03-17','14:15:00',2.1),('9650','2013-03-17','14:20:00',2.01),('9650','2013-03-17','14:25:00',2.7),('9650','2013-03-17','14:30:00',1.42),('9650','2013-03-17','14:35:00',1.96),('9650','2013-03-17','14:40:00',2.04),('9650','2013-03-17','14:45:00',1.75),('9650','2013-03-17','14:55:00',1.59),('9650','2013-03-17','15:00:00',1.87),('9650','2013-03-17','15:05:00',1.58),('9650','2013-03-17','15:10:00',1.14),('9650','2013-03-17','15:15:00',1.51),('9650','2013-03-17','15:20:00',1.1),('9650','2013-03-17','15:25:00',1.06),('9650','2013-03-17','15:30:00',1.01),('9650','2013-03-16','07:55:00',1.05),('9650','2013-03-16','08:00:00',1.09),('9650','2013-03-16','08:05:00',1.2),('9650','2013-03-16','08:10:00',1.35),('9650','2013-03-16','08:15:00',1.47),('9650','2013-03-16','08:20:00',1.57),('9650','2013-03-16','08:25:00',1.9),('9650','2013-03-16','08:30:00',1.9),('9650','2013-03-16','08:35:00',1.71),('9650','2013-03-16','08:40:00',1.76),('9650','2013-03-16','08:45:00',2),('9650','2013-03-16','08:50:00',2.03),('9650','2013-03-16','08:55:00',2.01),('9650','2013-03-16','09:00:00',2),('9650','2013-03-16','09:05:00',2.28),('9650','2013-03-16','09:10:00',2.57),('9650','2013-03-16','09:15:00',2.64),('9650','2013-03-16','09:20:00',2.42),('9650','2013-03-16','09:25:00',2.19),('9650','2013-03-16','09:30:00',2.39),('9650','2013-03-16','09:35:00',2.6),('9650','2013-03-16','09:40:00',2.57),('9650','2013-03-16','09:45:00',2.65),('9650','2013-03-16','09:50:00',2.9),('9650','2013-03-16','09:55:00',3.01),('9650','2013-03-16','10:00:00',3.27),('9650','2013-03-16','10:05:00',2.89),('9650','2013-03-16','10:10:00',2.91),('9650','2013-03-16','10:15:00',3.12),('9650','2013-03-16','10:20:00',3.16),('9650','2013-03-16','10:25:00',3.28),('9650','2013-03-16','10:30:00',3.24),('9650','2013-03-16','10:35:00',3.16),('9650','2013-03-16','10:40:00',3.02),('9650','2013-03-16','10:45:00',3.18),('9650','2013-03-16','10:50:00',2.98),('9650','2013-03-16','10:55:00',2.77),('9650','2013-03-16','11:00:00',2.74),('9650','2013-03-16','11:05:00',2.38),('9650','2013-03-16','11:10:00',2.35),('9650','2013-03-16','11:15:00',2.65),('9650','2013-03-16','11:20:00',3.02),('9650','2013-03-16','11:25:00',3.04),('9650','2013-03-16','11:30:00',2.73),('9650','2013-03-16','11:35:00',2.73),('9650','2013-03-16','11:40:00',2.63),('9650','2013-03-16','11:45:00',2.4),('9650','2013-03-16','11:50:00',2.21),('9650','2013-03-16','11:55:00',1.98),('9650','2013-03-16','12:00:00',1.87),('9650','2013-03-16','12:05:00',1.93),('9650','2013-03-16','12:10:00',2.5),('9650','2013-03-16','12:15:00',3.38),('9650','2013-03-16','12:20:00',4.07),('9650','2013-03-16','12:25:00',5.48),('9650','2013-03-16','12:30:00',5.62),('9650','2013-03-16','12:35:00',4.17),('9650','2013-03-16','12:40:00',4.46),('9650','2013-03-16','12:45:00',4.12),('9650','2013-03-16','12:50:00',3.66),('9650','2013-03-16','12:55:00',3.05),('9650','2013-03-16','13:00:00',3.54),('9650','2013-03-16','13:05:00',3.81),('9650','2013-03-16','13:10:00',4.23),('9650','2013-03-16','13:15:00',4.11),('9650','2013-03-16','13:20:00',3.44),('9650','2013-03-16','13:25:00',3.17),('9650','2013-03-16','13:30:00',4.66),('9650','2013-03-16','13:35:00',4.75),('9650','2013-03-16','13:40:00',3.48),('9650','2013-03-16','13:45:00',3.14),('9650','2013-03-16','13:50:00',2.56),('9650','2013-03-16','13:55:00',3.86),('9650','2013-03-16','14:00:00',3.67),('9650','2013-03-16','14:05:00',3.8),('9650','2013-03-16','14:10:00',4.43),('9650','2013-03-16','14:15:00',4.56),('9650','2013-03-16','14:20:00',4.88),('9650','2013-03-16','14:25:00',4.23),('9650','2013-03-16','14:30:00',4.02),('9650','2013-03-16','14:35:00',3.44),('9650','2013-03-16','14:40:00',2.6),('9650','2013-03-16','14:45:00',2.34),('9650','2013-03-16','14:50:00',2.04),('9650','2013-03-16','14:55:00',2.23),('9650','2013-03-16','15:00:00',2.88),('9650','2013-03-16','15:05:00',3.02),('9650','2013-03-16','15:10:00',3.98),('9650','2013-03-16','15:15:00',3.84),('9650','2013-03-16','15:20:00',4.46),('9650','2013-03-16','15:25:00',3.76),('9650','2013-03-16','15:30:00',2.51),('9650','2013-03-16','15:35:00',2.97),('9650','2013-03-16','15:40:00',2.92),('9650','2013-03-16','15:45:00',2.5),('9650','2013-03-16','15:50:00',1.53),('9650','2013-03-16','15:55:00',1.55),('9650','2013-03-16','16:00:00',1.21),('9650','2013-03-16','16:15:00',1.05),('9650','2013-03-16','16:20:00',1.12),('9650','2013-03-16','16:40:00',1.63),('9650','2013-03-16','16:45:00',2.61),('9650','2013-03-15','08:10:00',1.01),('9650','2013-03-15','08:15:00',1.14),('9650','2013-03-15','08:20:00',1.09),('9650','2013-03-15','08:35:00',1.07),('9650','2013-03-15','08:40:00',1.22),('9650','2013-03-15','08:45:00',1.28),('9650','2013-03-15','08:50:00',1.45),('9650','2013-03-15','08:55:00',1.72),('9650','2013-03-15','09:00:00',1.7),('9650','2013-03-15','09:05:00',1.79),('9650','2013-03-15','09:10:00',1.72),('9650','2013-03-15','09:15:00',2.02),('9650','2013-03-15','09:20:00',2.05),('9650','2013-03-15','09:25:00',1.49),('9650','2013-03-15','09:30:00',2.22),('9650','2013-03-15','09:35:00',2.79),('9650','2013-03-15','09:40:00',2.56),('9650','2013-03-15','09:45:00',2.84),('9650','2013-03-15','09:50:00',3.15),('9650','2013-03-15','09:55:00',3.44),('9650','2013-03-15','10:00:00',2.93),('9650','2013-03-15','10:05:00',2.44),('9650','2013-03-15','10:10:00',3.23),('9650','2013-03-15','10:15:00',2.74),('9650','2013-03-15','10:20:00',2.53),('9650','2013-03-15','10:25:00',3.19),('9650','2013-03-15','10:30:00',2.47),('9650','2013-03-15','10:35:00',3.36),('9650','2013-03-15','10:40:00',4.29),('9650','2013-03-15','10:45:00',4.41),('9650','2013-03-15','10:50:00',4.53),('9650','2013-03-15','10:55:00',4.59),('9650','2013-03-15','11:00:00',4.73),('9650','2013-03-15','11:05:00',4.81),('9650','2013-03-15','11:10:00',4.91),('9650','2013-03-15','11:15:00',4.98),('9650','2013-03-15','11:20:00',5.09),('9650','2013-03-15','11:25:00',5.18),('9650','2013-03-15','11:30:00',5.29),('9650','2013-03-15','11:35:00',5.34),('9650','2013-03-15','11:40:00',5.42),('9650','2013-03-15','11:45:00',5.51),('9650','2013-03-15','11:50:00',5.59),('9650','2013-03-15','11:55:00',5.64),('9650','2013-03-15','12:00:00',5.7),('9650','2013-03-15','12:05:00',5.74),('9650','2013-03-15','12:10:00',5.78),('9650','2013-03-15','12:15:00',5.87),('9650','2013-03-15','12:20:00',5.93),('9650','2013-03-15','12:25:00',5.99),('9650','2013-03-15','12:30:00',6.04),('9650','2013-03-15','12:35:00',6.05),('9650','2013-03-15','12:40:00',6.07),('9650','2013-03-15','12:45:00',6.12),('9650','2013-03-15','12:50:00',6.15),('9650','2013-03-15','12:55:00',6.17),('9650','2013-03-15','13:00:00',6.11),('9650','2013-03-15','13:05:00',6.13),('9650','2013-03-15','13:10:00',6.02),('9650','2013-03-15','13:15:00',6.07),('9650','2013-03-15','13:20:00',6.29),('9650','2013-03-15','13:25:00',2.35),('9650','2013-03-15','13:30:00',1.9),('9650','2013-03-15','13:35:00',3.28),('9650','2013-03-15','13:40:00',5.8),('9650','2013-03-15','13:45:00',5.65),('9650','2013-03-15','13:50:00',4.93),('9650','2013-03-15','13:55:00',2.91),('9650','2013-03-15','14:00:00',5.48),('9650','2013-03-15','14:05:00',5.88),('9650','2013-03-15','14:10:00',1.8),('9650','2013-03-15','14:15:00',5.64),('9650','2013-03-15','14:20:00',2.4),('9650','2013-03-15','14:25:00',1.81),('9650','2013-03-15','14:30:00',5.23),('9650','2013-03-15','14:35:00',5.29),('9650','2013-03-15','14:40:00',3.96),('9650','2013-03-15','14:45:00',1.94),('9650','2013-03-15','14:50:00',1.17),('9650','2013-03-15','14:55:00',1.14),('9650','2013-03-15','15:00:00',1.02),('9650','2013-03-15','15:05:00',1.01),('9650','2013-03-15','15:20:00',1.06),('9650','2013-03-15','15:25:00',1.06),('9650','2013-03-15','15:30:00',1.04),('9650','2013-03-15','15:35:00',1.25),('9650','2013-03-15','15:40:00',1.69),('9650','2013-03-15','15:45:00',1.7),('9650','2013-03-15','15:50:00',1.04),('9650','2013-03-15','16:00:00',3.27),('9650','2013-03-15','16:05:00',4.01),('9650','2013-03-15','16:10:00',3.87),('9650','2013-03-15','16:15:00',3.77),('9650','2013-03-15','16:20:00',2.03),('9650','2013-03-15','16:25:00',1.25),('9650','2013-03-15','16:30:00',1.32),('9650','2013-03-15','16:35:00',1.42),('9650','2013-03-15','16:40:00',1.34),('9650','2013-03-15','16:45:00',1.66),('9650','2013-03-15','16:50:00',2.12),('9650','2013-03-15','16:55:00',2.82),('9650','2013-03-15','17:00:00',2.65),('9650','2013-03-15','17:05:00',2.55),('9650','2013-03-15','17:10:00',2.29),('9650','2013-03-15','17:15:00',2.17),('9650','2013-03-15','17:20:00',2.01),('9650','2013-03-15','17:25:00',1.77),('9650','2013-03-15','17:30:00',1.5),('9650','2013-03-15','17:35:00',1.14),('9650','2013-03-14','10:00:00',1.14),('9650','2013-03-14','10:05:00',1.15),('9650','2013-03-14','10:10:00',1.13),('9650','2013-03-14','10:15:00',1.25),('9650','2013-03-14','10:20:00',1.19),('9650','2013-03-14','10:25:00',1.29),('9650','2013-03-14','10:30:00',1.69),('9650','2013-03-14','10:35:00',1.95),('9650','2013-03-14','10:40:00',2.21),('9650','2013-03-14','10:45:00',2.54),('9650','2013-03-14','10:50:00',2.6),('9650','2013-03-14','10:55:00',2.76),('9650','2013-03-14','11:00:00',2.7),('9650','2013-03-14','11:05:00',2.33),('9650','2013-03-14','11:10:00',2.3),('9650','2013-03-14','11:15:00',1.92),('9650','2013-03-14','11:20:00',2.22),('9650','2013-03-14','11:25:00',2.7),('9650','2013-03-14','11:30:00',3),('9650','2013-03-14','11:35:00',3.69),('9650','2013-03-14','11:40:00',4.11),('9650','2013-03-14','11:45:00',3.79),('9650','2013-03-14','11:50:00',3.53),('9650','2013-03-14','11:55:00',3.67),('9650','2013-03-14','12:00:00',3.33),('9650','2013-03-14','12:05:00',3.23),('9650','2013-03-14','12:10:00',3.56),('9650','2013-03-14','12:15:00',3.19),('9650','2013-03-14','12:20:00',3.13),('9650','2013-03-14','12:25:00',3.31),('9650','2013-03-14','12:30:00',3.42),('9650','2013-03-14','12:35:00',3.76),('9650','2013-03-14','12:40:00',3.21),('9650','2013-03-14','12:45:00',2.63),('9650','2013-03-14','12:50:00',2.48),('9650','2013-03-14','12:55:00',2.43),('9650','2013-03-14','13:00:00',2.3),('9650','2013-03-14','13:05:00',2.15),('9650','2013-03-14','13:10:00',2.3),('9650','2013-03-14','13:15:00',2.55),('9650','2013-03-14','13:20:00',2.75),('9650','2013-03-14','13:25:00',3.04),('9650','2013-03-14','13:30:00',2.85),('9650','2013-03-14','13:35:00',2.62),('9650','2013-03-14','13:40:00',2.67),('9650','2013-03-14','13:45:00',2.81),('9650','2013-03-14','13:50:00',2.28),('9650','2013-03-14','13:55:00',1.97),('9650','2013-03-14','14:00:00',1.83),('9650','2013-03-14','14:05:00',1.57),('9650','2013-03-14','14:10:00',1.32),('9650','2013-03-14','14:15:00',1.19),('9650','2013-03-14','14:20:00',1.07),('9650','2013-03-14','14:40:00',1.09),('9650','2013-03-14','14:45:00',1.42),('9650','2013-03-14','14:50:00',1.9),('9650','2013-03-14','14:55:00',2.15),('9650','2013-03-14','15:00:00',2.24),('9650','2013-03-14','15:05:00',2.12),('9650','2013-03-14','15:10:00',2.13),('9650','2013-03-14','15:15:00',2.29),('9650','2013-03-14','15:20:00',2.38),('9650','2013-03-14','15:25:00',2.57),('9650','2013-03-14','15:30:00',2.17),('9650','2013-03-14','15:35:00',1.82),('9650','2013-03-14','15:40:00',1.55),('9650','2013-03-14','15:45:00',1.6),('9650','2013-03-14','15:50:00',1.53),('9650','2013-03-14','15:55:00',1.48),('9650','2013-03-14','16:00:00',1.66),('9650','2013-03-14','16:05:00',1.36),('9650','2013-03-14','16:10:00',1.2),('9650','2013-03-14','16:15:00',1.25),('9650','2013-03-14','17:10:00',1.08),('9650','2013-03-14','17:15:00',2.08),('9650','2013-03-14','17:20:00',2.03),('9650','2013-03-14','17:25:00',1.72),('9650','2013-03-14','17:30:00',1.27),('9650','2013-03-13','08:20:00',1.12),('9650','2013-03-13','08:25:00',1.27),('9650','2013-03-13','08:30:00',1.06),('9650','2013-03-13','11:25:00',1.1),('9650','2013-03-13','11:30:00',1.29),('9650','2013-03-13','11:35:00',1.15),('9650','2013-03-13','11:40:00',1.33),('9650','2013-03-13','11:45:00',1.37),('9650','2013-03-13','11:50:00',1.33),('9650','2013-03-13','11:55:00',1.31),('9650','2013-03-13','12:00:00',1.2),('9650','2013-03-13','12:05:00',1.08),('9650','2013-03-13','12:10:00',1.04),('9650','2013-03-13','12:15:00',1.08),('9650','2013-03-13','12:20:00',1.17),('9650','2013-03-13','12:25:00',1.28),('9650','2013-03-13','12:30:00',1.35),('9650','2013-03-13','12:35:00',1.35),('9650','2013-03-13','12:40:00',1.48),('9650','2013-03-13','12:45:00',1.6),('9650','2013-03-13','12:50:00',1.53),('9650','2013-03-13','12:55:00',1.56),('9650','2013-03-13','13:00:00',1.51),('9650','2013-03-13','13:05:00',1.73),('9650','2013-03-13','13:10:00',2.03),('9650','2013-03-13','13:15:00',2.04),('9650','2013-03-13','13:20:00',2.03),('9650','2013-03-13','13:25:00',2.01),('9650','2013-03-13','13:30:00',2.11),('9650','2013-03-13','13:35:00',2.28),('9650','2013-03-13','13:40:00',2.01),('9650','2013-03-13','13:45:00',2.32),('9650','2013-03-13','13:50:00',2.96),('9650','2013-03-13','13:55:00',3.34),('9650','2013-03-13','14:00:00',3.08),('9650','2013-03-13','14:05:00',3.38),('9650','2013-03-13','14:10:00',2.65),('9650','2013-03-13','14:15:00',2.26),('9650','2013-03-13','14:20:00',2.14),('9650','2013-03-13','14:25:00',2.12),('9650','2013-03-13','14:30:00',1.82),('9650','2013-03-13','14:35:00',1.36),('9650','2013-03-13','14:40:00',1.03),('9650','2013-03-13','14:55:00',1.02),('9650','2013-03-13','15:00:00',1.07),('9650','2013-03-13','15:05:00',1.51),('9650','2013-03-13','15:10:00',2.24),('9650','2013-03-13','15:15:00',2.25),('9650','2013-03-13','15:20:00',2.1),('9650','2013-03-13','15:25:00',2.23),('9650','2013-03-13','15:30:00',2.17),('9650','2013-03-13','15:35:00',1.68),('9650','2013-03-13','15:40:00',1.21),('9650','2013-03-13','16:30:00',1.05),('9650','2013-03-12','08:10:00',1.11),('9650','2013-03-12','08:25:00',1.05),('9650','2013-03-12','08:40:00',1.2),('9650','2013-03-12','08:45:00',1.31),('9650','2013-03-12','08:50:00',1.84),('9650','2013-03-12','08:55:00',1.71),('9650','2013-03-12','09:00:00',1.31),('9650','2013-03-12','09:05:00',1.4),('9650','2013-03-12','09:10:00',1.79),('9650','2013-03-12','09:15:00',1.47),('9650','2013-03-12','09:20:00',1.6),('9650','2013-03-12','09:25:00',1.61),('9650','2013-03-12','09:30:00',1.56),('9650','2013-03-12','09:35:00',1.41),('9650','2013-03-12','09:40:00',1.41),('9650','2013-03-12','09:45:00',1.74),('9650','2013-03-12','09:50:00',1.4),('9650','2013-03-12','10:00:00',1.15),('9650','2013-03-12','10:05:00',1.85),('9650','2013-03-12','10:10:00',1.93),('9650','2013-03-12','10:15:00',3.2),('9650','2013-03-12','10:20:00',2.46),('9650','2013-03-12','10:25:00',3.44),('9650','2013-03-12','10:30:00',4.42),('9650','2013-03-12','10:35:00',4.97),('9650','2013-03-12','10:40:00',4.08),('9650','2013-03-12','10:45:00',2.62),('9650','2013-03-12','10:50:00',2.13),('9650','2013-03-12','10:55:00',1.75),('9650','2013-03-12','11:00:00',1.86),('9650','2013-03-12','11:05:00',1.54),('9650','2013-03-12','11:10:00',2.11),('9650','2013-03-12','11:15:00',1.9),('9650','2013-03-12','11:20:00',1.58),('9650','2013-03-12','11:25:00',1.35),('9650','2013-03-12','11:30:00',2.05),('9650','2013-03-12','11:35:00',2.19),('9650','2013-03-12','11:40:00',2.24),('9650','2013-03-12','11:45:00',2.56),('9650','2013-03-12','11:50:00',2.26),('9650','2013-03-12','11:55:00',1.71),('9650','2013-03-12','12:30:00',1.26),('9650','2013-03-12','12:35:00',1.52),('9650','2013-03-12','12:40:00',1.64),('9650','2013-03-12','12:45:00',1.97),('9650','2013-03-12','12:50:00',2.28),('9650','2013-03-12','12:55:00',2.09),('9650','2013-03-12','13:00:00',2.03),('9650','2013-03-12','13:05:00',1.99),('9650','2013-03-12','13:10:00',1.85),('9650','2013-03-12','13:15:00',1.57),('9650','2013-03-12','13:20:00',1.32),('9650','2013-03-12','13:25:00',1.26),('9650','2013-03-12','13:30:00',1.45),('9650','2013-03-12','13:35:00',1.9),('9650','2013-03-12','13:40:00',1.71),('9650','2013-03-12','13:45:00',1.58),('9650','2013-03-12','13:50:00',1.26),('9650','2013-03-12','13:55:00',1.17),('9650','2013-03-12','14:00:00',1.01),('9650','2013-03-12','14:35:00',1.02),('9650','2013-03-12','14:45:00',1.12),('9650','2013-03-12','14:50:00',1.27),('9650','2013-03-12','14:55:00',1.14),('9650','2013-03-12','15:00:00',1.22),('9650','2013-03-12','15:05:00',1.29),('9650','2013-03-12','15:10:00',1.41),('9650','2013-03-12','15:15:00',1.07),('9650','2014-03-24','07:25:00',1.04),('9650','2014-03-24','07:30:00',1.11),('9650','2014-03-24','07:35:00',1.1),('9650','2014-03-24','07:40:00',1.15),('9650','2014-03-24','07:45:00',1.3),('9650','2014-03-24','07:50:00',1.46),('9650','2014-03-24','07:55:00',1.53),('9650','2014-03-24','08:00:00',1.6),('9650','2014-03-24','08:05:00',1.69),('9650','2014-03-24','08:10:00',1.79),('9650','2014-03-24','08:15:00',1.89),('9650','2014-03-24','08:20:00',1.85),('9650','2014-03-24','08:25:00',1.81),('9650','2014-03-24','08:30:00',1.74),('9650','2014-03-24','08:35:00',1.79),('9650','2014-03-24','08:40:00',2),('9650','2014-03-24','08:45:00',2.37),('9650','2014-03-24','08:50:00',2.46),('9650','2014-03-24','08:55:00',2.55),('9650','2014-03-24','09:00:00',2.41),('9650','2014-03-24','09:05:00',2.45),('9650','2014-03-24','09:10:00',2.4),('9650','2014-03-24','09:15:00',2.89),('9650','2014-03-24','09:20:00',3.21),('9650','2014-03-24','09:25:00',3.04),('9650','2014-03-24','09:30:00',2.89),('9650','2014-03-24','09:35:00',2.78),('9650','2014-03-24','09:40:00',2.78),('9650','2014-03-24','09:45:00',2.67),('9650','2014-03-24','09:50:00',2.72),('9650','2014-03-24','09:55:00',2.9),('9650','2014-03-24','10:00:00',3.16),('9650','2014-03-24','10:05:00',3.25),('9650','2014-03-24','10:10:00',3.37),('9650','2014-03-24','10:15:00',3.66),('9650','2014-03-24','10:20:00',3.58),('9650','2014-03-24','10:25:00',3.61),('9650','2014-03-24','10:30:00',4.05),('9650','2014-03-24','10:35:00',3.67),('9650','2014-03-24','10:40:00',3.27),('9650','2014-03-24','10:45:00',3.13),('9650','2014-03-24','10:50:00',3.07),('9650','2014-03-24','10:55:00',3.13),('9650','2014-03-24','11:00:00',3.33),('9650','2014-03-24','11:05:00',3.68),('9650','2014-03-24','11:10:00',4),('9650','2014-03-24','11:15:00',4.46),('9650','2014-03-24','11:20:00',4.55),('9650','2014-03-24','11:25:00',3.97),('9650','2014-03-24','11:30:00',4.52),('9650','2014-03-24','11:35:00',3.82),('9650','2014-03-24','11:40:00',4.09),('9650','2014-03-24','11:45:00',3.22),('9650','2014-03-24','11:50:00',3.82),('9650','2014-03-24','11:55:00',2.98),('9650','2014-03-24','12:00:00',2.08),('9650','2014-03-24','12:05:00',1.38),('9650','2014-03-24','12:10:00',1.33),('9650','2014-03-24','12:15:00',1.56),('9650','2014-03-24','12:20:00',2.01),('9650','2014-03-24','12:25:00',2.26),('9650','2014-03-24','12:30:00',1.83),('9650','2014-03-24','12:35:00',1.54),('9650','2014-03-24','12:40:00',1.61),('9650','2014-03-24','12:45:00',1.52),('9650','2014-03-24','13:30:00',1.06),('9650','2014-03-24','13:35:00',1.47),('9650','2014-03-24','13:40:00',1.45),('9650','2014-03-24','13:45:00',1.26),('9650','2014-03-24','13:50:00',1.29),('9650','2014-03-24','13:55:00',1.3),('9650','2014-03-24','14:00:00',1.26),('9650','2014-03-24','14:05:00',1.33),('9650','2014-03-24','14:10:00',1.43),('9650','2014-03-24','14:15:00',1.52),('9650','2014-03-24','14:20:00',1.16),('9650','2014-03-24','14:35:00',1.13),('9650','2014-03-24','14:40:00',1.17),('9650','2014-03-24','14:45:00',1.23),('9650','2014-03-24','14:50:00',1.04),('9650','2014-03-24','15:15:00',1.1),('9650','2014-03-24','15:20:00',1.15),('9650','2013-03-11','08:45:00',1.54),('9650','2013-03-11','08:50:00',1.21),('9650','2013-03-11','09:05:00',1.37),('9650','2013-03-11','09:10:00',1.48),('9650','2013-03-11','09:15:00',1.62),('9650','2013-03-11','09:20:00',1.76),('9650','2013-03-11','09:25:00',1.86),('9650','2013-03-11','09:30:00',2.09),('9650','2013-03-11','09:35:00',2.18),('9650','2013-03-11','09:40:00',2.28),('9650','2013-03-11','09:45:00',2.07),('9650','2013-03-11','09:50:00',2.07),('9650','2013-03-11','09:55:00',2.96),('9650','2013-03-11','10:00:00',3.09),('9650','2013-03-11','10:05:00',3.38),('9650','2013-03-11','10:10:00',3.05),('9650','2013-03-11','10:15:00',2.83),('9650','2013-03-11','10:20:00',1.71),('9650','2013-03-11','10:25:00',3.15),('9650','2013-03-11','10:30:00',2.44),('9650','2013-03-11','10:35:00',2.64),('9650','2013-03-11','10:40:00',3.03),('9650','2013-03-11','10:45:00',1.87),('9650','2013-03-11','10:50:00',4.35),('9650','2013-03-11','10:55:00',4.22),('9650','2013-03-11','11:00:00',4.86),('9650','2013-03-11','11:05:00',5.27),('9650','2013-03-11','11:10:00',4.66),('9650','2013-03-11','11:15:00',4.68),('9650','2013-03-11','11:20:00',5.81),('9650','2013-03-11','11:25:00',2.43),('9650','2013-03-11','11:30:00',2.98),('9650','2013-03-11','11:35:00',3.41),('9650','2013-03-11','11:40:00',3.54),('9650','2013-03-11','11:45:00',3.88),('9650','2013-03-11','11:50:00',4.33),('9650','2013-03-11','11:55:00',4.61),('9650','2013-03-11','12:00:00',1.57),('9650','2013-03-11','12:05:00',1.51),('9650','2013-03-11','12:10:00',6.31),('9650','2013-03-11','12:15:00',3.71),('9650','2013-03-11','12:20:00',3.5),('9650','2013-03-11','12:25:00',4.52),('9650','2013-03-11','12:30:00',7.65),('9650','2013-03-11','12:35:00',4.05),('9650','2013-03-11','12:40:00',5.73),('9650','2013-03-11','12:45:00',1.98),('9650','2013-03-11','12:50:00',2.99),('9650','2013-03-11','12:55:00',4.46),('9650','2013-03-11','13:00:00',5.88),('9650','2013-03-11','13:05:00',3.82),('9650','2013-03-11','13:10:00',4.07),('9650','2013-03-11','13:15:00',3.19),('9650','2013-03-11','13:20:00',4.69),('9650','2013-03-11','13:25:00',3.3),('9650','2013-03-11','13:30:00',2.74),('9650','2013-03-11','13:35:00',3.05),('9650','2013-03-11','13:40:00',2.93),('9650','2013-03-11','13:45:00',2.26),('9650','2013-03-11','13:50:00',2.17),('9650','2013-03-11','13:55:00',2.84),('9650','2013-03-11','14:00:00',3.86),('9650','2013-03-11','14:05:00',4.53),('9650','2013-03-11','14:10:00',2.86),('9650','2013-03-11','14:15:00',2.3),('9650','2013-03-11','14:20:00',1.76),('9650','2013-03-11','14:25:00',1.05),('9650','2013-03-11','14:35:00',1.04),('9650','2013-03-11','15:00:00',1.77),('9650','2013-03-11','15:05:00',1.07),('9650','2013-03-11','15:10:00',1.77),('9650','2013-03-11','15:15:00',1.74),('9650','2013-03-11','15:20:00',1.82),('9650','2013-03-11','15:25:00',1.63),('9650','2013-03-11','15:30:00',1.04),('9650','2013-03-10','07:40:00',1.03),('9650','2013-03-10','08:50:00',1.03),('9650','2013-03-10','08:55:00',1.12),('9650','2013-03-10','09:00:00',1.19),('9650','2013-03-10','09:05:00',1.3),('9650','2013-03-10','09:10:00',1.43),('9650','2013-03-10','09:15:00',1.58),('9650','2013-03-10','09:20:00',1.62),('9650','2013-03-10','09:25:00',1.44),('9650','2013-03-10','09:30:00',1.22),('9650','2013-03-10','09:45:00',1.78),('9650','2013-03-10','09:50:00',1.31),('9650','2013-03-10','09:55:00',1.32),('9650','2013-03-10','10:00:00',1.39),('9650','2013-03-10','10:05:00',1.63),('9650','2013-03-10','10:10:00',1.95),('9650','2013-03-10','10:15:00',2.06),('9650','2013-03-10','10:20:00',2.3),('9650','2013-03-10','10:25:00',2.46),('9650','2013-03-10','10:30:00',2.33),('9650','2013-03-10','10:35:00',2.63),('9650','2013-03-10','10:40:00',3.34),('9650','2013-03-10','10:45:00',3.46),('9650','2013-03-10','10:50:00',4.36),('9650','2013-03-10','10:55:00',2.84),('9650','2013-03-10','11:00:00',2.61),('9650','2013-03-10','11:05:00',2.15),('9650','2013-03-10','11:10:00',2.39),('9650','2013-03-10','11:15:00',2.54),('9650','2013-03-10','11:20:00',2.27),('9650','2013-03-10','11:25:00',2.06),('9650','2013-03-10','11:30:00',3.41),('9650','2013-03-10','11:35:00',3.51),('9650','2013-03-10','11:40:00',3.18),('9650','2013-03-10','11:45:00',4),('9650','2013-03-10','11:50:00',3.66),('9650','2013-03-10','11:55:00',3.38),('9650','2013-03-10','12:00:00',3.02),('9650','2013-03-10','12:05:00',3),('9650','2013-03-10','12:10:00',3.49),('9650','2013-03-10','12:15:00',1.35),('9650','2013-03-10','12:20:00',1.42),('9650','2013-03-10','12:25:00',1.63),('9650','2013-03-10','12:30:00',1.91),('9650','2013-03-10','12:35:00',2.51),('9650','2013-03-10','12:40:00',1.96),('9650','2013-03-10','12:45:00',2.15),('9650','2013-03-10','12:50:00',3.61),('9650','2013-03-10','12:55:00',4.93),('9650','2013-03-10','13:00:00',3.28),('9650','2013-03-10','13:05:00',2.88),('9650','2013-03-10','13:10:00',4.78),('9650','2013-03-10','13:15:00',5.01),('9650','2013-03-10','13:20:00',6.03),('9650','2013-03-10','13:25:00',5.4),('9650','2013-03-10','13:30:00',5.48),('9650','2013-03-10','13:35:00',5.96),('9650','2013-03-10','13:40:00',4.69),('9650','2013-03-10','13:45:00',5.85),('9650','2013-03-10','13:50:00',5.5),('9650','2013-03-10','13:55:00',2.78),('9650','2013-03-10','14:00:00',1.6),('9650','2013-03-10','14:05:00',1.36),('9650','2013-03-10','14:10:00',1.38),('9650','2013-03-10','14:15:00',1.33),('9650','2013-03-10','14:20:00',2.15),('9650','2013-03-10','14:25:00',2.94),('9650','2013-03-10','14:30:00',2.1),('9650','2013-03-10','14:35:00',1.75),('9650','2013-03-10','14:40:00',2.83),('9650','2013-03-10','14:45:00',1.51),('9650','2013-03-10','14:50:00',1.19),('9650','2013-03-10','15:15:00',1.1),('9650','2013-03-10','15:20:00',1.18),('9650','2013-03-10','15:25:00',2),('9650','2013-03-10','15:30:00',4.19),('9650','2013-03-10','15:35:00',2.09),('9650','2013-03-10','15:40:00',2.68),('9650','2013-03-10','15:45:00',4.48),('9650','2013-03-10','15:50:00',3.7),('9650','2013-03-10','15:55:00',3.39),('9650','2013-03-10','16:00:00',3.4),('9650','2013-03-10','16:05:00',2.69),('9650','2013-03-10','16:10:00',2.82),('9650','2013-03-10','16:15:00',2.35),('9650','2013-03-10','16:20:00',2.76),('9650','2013-03-10','16:25:00',2.56),('9650','2013-03-10','16:30:00',3.1),('9650','2013-03-10','16:35:00',2.45),('9650','2013-03-10','16:40:00',2.58),('9650','2013-03-10','16:45:00',3.05),('9650','2013-03-10','16:50:00',2.06),('9650','2013-03-10','17:05:00',1.42),('9650','2013-03-10','17:10:00',1.18),('9650','2013-03-10','17:15:00',1.32),('9650','2013-03-10','17:20:00',1.43),('9650','2013-03-10','17:25:00',1.05),('9650','2013-03-09','08:55:00',1.06),('9650','2013-03-09','09:00:00',1.17),('9650','2013-03-09','09:05:00',1.26),('9650','2013-03-09','09:10:00',1.33),('9650','2013-03-09','09:15:00',1.42),('9650','2013-03-09','09:20:00',1.67),('9650','2013-03-09','09:25:00',1.82),('9650','2013-03-09','09:30:00',1.96),('9650','2013-03-09','09:35:00',2.12),('9650','2013-03-09','09:40:00',2.37),('9650','2013-03-09','09:45:00',2.5),('9650','2013-03-09','09:50:00',2.78),('9650','2013-03-09','09:55:00',2.64),('9650','2013-03-09','10:00:00',3.27),('9650','2013-03-09','10:05:00',1.89),('9650','2013-03-09','10:10:00',3.02),('9650','2013-03-09','10:15:00',2.53),('9650','2013-03-09','10:20:00',2.4),('9650','2013-03-09','10:25:00',3.68),('9650','2013-03-09','10:30:00',2.89),('9650','2013-03-09','10:35:00',3.01),('9650','2013-03-09','10:40:00',3.48),('9650','2013-03-09','10:45:00',3.75),('9650','2013-03-09','10:50:00',2.4),('9650','2013-03-09','10:55:00',2.1),('9650','2013-03-09','11:00:00',2.52),('9650','2013-03-09','11:05:00',3.44),('9650','2013-03-09','11:10:00',2.83),('9650','2013-03-09','11:15:00',2.37),('9650','2013-03-09','11:20:00',2.67),('9650','2013-03-09','11:25:00',4.1),('9650','2013-03-09','11:30:00',3.12),('9650','2013-03-09','11:35:00',3.73),('9650','2013-03-09','11:40:00',2.1),('9650','2013-03-09','11:45:00',2.19),('9650','2013-03-09','11:50:00',5.35),('9650','2013-03-09','11:55:00',5.35),('9650','2013-03-09','12:00:00',5.38),('9650','2013-03-09','12:05:00',5.17),('9650','2013-03-09','12:10:00',5.41),('9650','2013-03-09','12:15:00',3.7),('9650','2013-03-09','12:20:00',5.78),('9650','2013-03-09','12:25:00',4.8),('9650','2013-03-09','12:30:00',3.84),('9650','2013-03-09','12:35:00',4.44),('9650','2013-03-09','12:40:00',5.67),('9650','2013-03-09','12:45:00',6.13),('9650','2013-03-09','12:50:00',6.24),('9650','2013-03-09','12:55:00',5.93),('9650','2013-03-09','13:00:00',5.72),('9650','2013-03-09','13:05:00',5.54),('9650','2013-03-09','13:10:00',5.23),('9650','2013-03-09','13:15:00',5.5),('9650','2013-03-09','13:20:00',5.67),('9650','2013-03-09','13:25:00',5.42),('9650','2013-03-09','13:30:00',5.21),('9650','2013-03-09','13:35:00',5.25),('9650','2013-03-09','13:40:00',3.47),('9650','2013-03-09','13:45:00',3.76),('9650','2013-03-09','13:50:00',3.23),('9650','2013-03-09','13:55:00',3.04),('9650','2013-03-09','14:00:00',2.58),('9650','2013-03-09','14:05:00',3.45),('9650','2013-03-09','14:10:00',3.55),('9650','2013-03-09','14:15:00',4.92),('9650','2013-03-09','14:20:00',4.95),('9650','2013-03-09','14:25:00',3.01),('9650','2013-03-09','14:30:00',4.29),('9650','2013-03-09','14:35:00',5.21),('9650','2013-03-09','14:40:00',4.67),('9650','2013-03-09','14:45:00',2.9),('9650','2013-03-09','14:50:00',2.92),('9650','2013-03-09','14:55:00',2.54),('9650','2013-03-09','15:00:00',1.93),('9650','2013-03-09','15:05:00',2.33),('9650','2013-03-09','15:10:00',2.3),('9650','2013-03-09','15:15:00',1.55),('9650','2013-03-09','15:20:00',1.55),('9650','2013-03-09','15:35:00',1.03),('9650','2013-03-09','15:40:00',1.03),('9650','2013-03-09','15:45:00',1.05),('9650','2013-03-09','15:50:00',1.56),('9650','2013-03-09','15:55:00',1.25),('9650','2013-03-08','08:50:00',1.12),('9650','2013-03-08','08:55:00',1.25),('9650','2013-03-08','09:00:00',1.3),('9650','2013-03-08','09:05:00',1.11),('9650','2013-03-08','09:15:00',1.36),('9650','2013-03-08','09:20:00',1.1),('9650','2013-03-08','09:25:00',1.67),('9650','2013-03-08','09:30:00',2.4),('9650','2013-03-08','09:35:00',2.86),('9650','2013-03-08','09:40:00',2.78),('9650','2013-03-08','09:45:00',3.63),('9650','2013-03-08','09:50:00',2.23),('9650','2013-03-08','09:55:00',3.34),('9650','2013-03-08','10:00:00',1.47),('9650','2013-03-08','10:05:00',1.71),('9650','2013-03-08','10:10:00',1.62),('9650','2013-03-08','10:15:00',2.12),('9650','2013-03-08','10:20:00',1.74),('9650','2013-03-08','10:25:00',1.61),('9650','2013-03-08','10:30:00',1.65),('9650','2013-03-08','10:35:00',2.2),('9650','2013-03-08','10:40:00',2.39),('9650','2013-03-08','10:45:00',3.51),('9650','2013-03-08','10:50:00',4.21),('9650','2013-03-08','10:55:00',3.42),('9650','2013-03-08','11:00:00',3.93),('9650','2013-03-08','11:05:00',4.44),('9650','2013-03-08','11:10:00',4.62),('9650','2013-03-08','11:15:00',4.68),('9650','2013-03-08','11:20:00',4.79),('9650','2013-03-08','11:25:00',3.99),('9650','2013-03-08','11:30:00',4.63),('9650','2013-03-08','11:35:00',4.79),('9650','2013-03-08','11:40:00',4.91),('9650','2013-03-08','11:45:00',4.97),('9650','2013-03-08','11:50:00',4.95),('9650','2013-03-08','11:55:00',4.77),('9650','2013-03-08','12:00:00',3.52),('9650','2013-03-08','12:05:00',2.33),('9650','2013-03-08','12:10:00',2.29),('9650','2013-03-08','12:15:00',1.92),('9650','2013-03-08','12:20:00',2.71),('9650','2013-03-08','12:25:00',2.79),('9650','2013-03-08','12:30:00',2.34),('9650','2013-03-08','12:35:00',2.79),('9650','2013-03-08','12:40:00',2.62),('9650','2013-03-08','12:45:00',3.47),('9650','2013-03-08','12:50:00',3.02),('9650','2013-03-08','12:55:00',5.17),('9650','2013-03-08','13:00:00',5.7),('9650','2013-03-08','13:05:00',5.42),('9650','2013-03-08','13:10:00',5.51),('9650','2013-03-08','13:15:00',6.02),('9650','2013-03-08','13:20:00',4.81),('9650','2013-03-08','13:25:00',3.36),('9650','2013-03-08','13:30:00',5.93),('9650','2013-03-08','13:35:00',5.61),('9650','2013-03-08','13:40:00',5.61),('9650','2013-03-08','13:45:00',5.55),('9650','2013-03-08','13:50:00',4.7),('9650','2013-03-08','13:55:00',1.61),('9650','2013-03-08','14:00:00',1.67),('9650','2013-03-08','14:05:00',2.43),('9650','2013-03-08','14:10:00',5.33),('9650','2013-03-08','14:15:00',5.23),('9650','2013-03-08','14:20:00',5.08),('9650','2013-03-08','14:25:00',4.94),('9650','2013-03-08','14:30:00',4.71),('9650','2013-03-08','14:35:00',4.61),('9650','2013-03-08','14:40:00',4.56),('9650','2013-03-08','14:45:00',4.44),('9650','2013-03-08','14:50:00',4.41),('9650','2013-03-08','14:55:00',4.41),('9650','2013-03-08','15:00:00',4.15),('9650','2013-03-08','15:05:00',4.06),('9650','2013-03-08','15:10:00',4.05),('9650','2013-03-08','15:15:00',3.94),('9650','2013-03-08','15:20:00',3.84),('9650','2013-03-08','15:25:00',3.78),('9650','2013-03-08','15:30:00',3.66),('9650','2013-03-08','15:35:00',3.64),('9650','2013-03-08','15:40:00',3.64),('9650','2013-03-08','15:45:00',3.71),('9650','2013-03-08','15:50:00',3.63),('9650','2013-03-08','15:55:00',3.34),('9650','2013-03-08','16:00:00',3.09),('9650','2013-03-08','16:05:00',3.17),('9650','2013-03-08','16:10:00',2.72),('9650','2013-03-08','16:15:00',3.13),('9650','2013-03-08','16:20:00',2.58),('9650','2013-03-08','16:25:00',3.1),('9650','2013-03-08','16:30:00',2.82),('9650','2013-03-08','16:35:00',2.46),('9650','2013-03-08','16:40:00',2.28),('9650','2013-03-08','16:45:00',1.68),('9650','2013-03-08','16:50:00',1.59),('9650','2013-03-07','08:15:00',1.09),('9650','2013-03-07','08:25:00',1.16),('9650','2013-03-07','08:30:00',2),('9650','2013-03-07','08:35:00',2.41),('9650','2013-03-07','08:40:00',1.4),('9650','2013-03-07','08:45:00',1.11),('9650','2013-03-07','08:50:00',1.68),('9650','2013-03-07','08:55:00',1.38),('9650','2013-03-07','09:00:00',1.19),('9650','2013-03-07','09:10:00',1),('9650','2013-03-07','09:15:00',1.36),('9650','2013-03-07','09:20:00',1.35),('9650','2013-03-07','09:25:00',1.31),('9650','2013-03-07','09:30:00',2),('9650','2013-03-07','09:35:00',2.41),('9650','2013-03-07','09:40:00',1.57),('9650','2013-03-07','09:45:00',1.69),('9650','2013-03-07','09:50:00',2.02),('9650','2013-03-07','09:55:00',1.72),('9650','2013-03-07','10:00:00',1.53),('9650','2013-03-07','10:05:00',1.96),('9650','2013-03-07','10:10:00',2.44),('9650','2013-03-07','10:15:00',2.67),('9650','2013-03-07','10:20:00',2.29),('9650','2013-03-07','10:25:00',2.33),('9650','2013-03-07','10:30:00',2.83),('9650','2013-03-07','10:35:00',3.46),('9650','2013-03-07','10:40:00',2.37),('9650','2013-03-07','10:45:00',1.83),('9650','2013-03-07','10:50:00',2.35),('9650','2013-03-07','10:55:00',2.15),('9650','2013-03-07','11:00:00',2.03),('9650','2013-03-07','11:05:00',1.4),('9650','2013-03-07','11:10:00',1.07),('9650','2013-03-07','11:35:00',2.53),('9650','2013-03-07','11:40:00',3.38),('9650','2013-03-07','11:45:00',2.79),('9650','2013-03-07','11:50:00',2.43),('9650','2013-03-07','11:55:00',2.89),('9650','2013-03-07','12:00:00',3.5),('9650','2013-03-07','12:05:00',2.47),('9650','2013-03-07','12:10:00',1.97),('9650','2013-03-07','12:15:00',1.64),('9650','2013-03-07','12:20:00',2.31),('9650','2013-03-07','12:25:00',2.08),('9650','2013-03-07','12:30:00',1.85),('9650','2013-03-07','12:35:00',2.87),('9650','2013-03-07','12:40:00',3.36),('9650','2013-03-07','12:45:00',3.52),('9650','2013-03-07','12:50:00',4.16),('9650','2013-03-07','12:55:00',3.66),('9650','2013-03-07','13:00:00',3.55),('9650','2013-03-07','13:05:00',3.49),('9650','2013-03-07','13:10:00',2.45),('9650','2013-03-07','13:15:00',2.04),('9650','2013-03-07','13:20:00',1.96),('9650','2013-03-07','13:25:00',2.6),('9650','2013-03-07','13:30:00',3.54),('9650','2013-03-07','13:35:00',2.52),('9650','2013-03-07','13:40:00',2.23),('9650','2013-03-07','13:45:00',1.36),('9650','2013-03-07','13:50:00',1.13),('9650','2013-03-07','13:55:00',1.58),('9650','2013-03-07','14:00:00',1.08),('9650','2013-03-07','16:55:00',1.11),('9650','2013-03-07','17:05:00',1.28),('9650','2013-03-07','17:10:00',2.68),('9650','2013-03-07','17:15:00',2.01),('9650','2013-03-07','17:20:00',1.29),('9650','2013-03-06','08:35:00',1.13),('9650','2013-03-06','08:40:00',1.54),('9650','2013-03-06','08:45:00',1.59),('9650','2013-03-06','08:50:00',1.82),('9650','2013-03-06','08:55:00',1.51),('9650','2013-03-06','09:00:00',1.47),('9650','2013-03-06','09:05:00',1.53),('9650','2013-03-06','09:15:00',1.24),('9650','2013-03-06','09:20:00',1.45),('9650','2013-03-06','09:55:00',1.15),('9650','2013-03-06','10:25:00',1.15),('9650','2013-03-06','10:30:00',1.59),('9650','2013-03-06','10:50:00',1.9),('9650','2013-03-06','10:55:00',2.19),('9650','2013-03-06','11:00:00',2.07),('9650','2013-03-06','11:05:00',2.55),('9650','2013-03-06','11:10:00',1.84),('9650','2013-03-06','11:15:00',1.38),('9650','2013-03-06','11:20:00',1.09),('9650','2013-03-06','11:25:00',1.33),('9650','2013-03-06','11:30:00',2.89),('9650','2013-03-06','11:35:00',3.91),('9650','2013-03-06','11:40:00',3.75),('9650','2013-03-06','11:45:00',3.87),('9650','2013-03-06','11:50:00',5.08),('9650','2013-03-06','11:55:00',2.69),('9650','2013-03-06','12:00:00',2.21),('9650','2013-03-06','12:05:00',1.92),('9650','2013-03-06','12:10:00',1.03),('9650','2013-03-06','12:25:00',1.64),('9650','2013-03-06','12:30:00',1.69),('9650','2013-03-06','12:35:00',1.06),('9650','2013-03-06','12:40:00',2.18),('9650','2013-03-06','12:45:00',3.24),('9650','2013-03-06','12:50:00',2.98),('9650','2013-03-06','12:55:00',2.65),('9650','2013-03-06','13:00:00',3.05),('9650','2013-03-06','13:05:00',3.32),('9650','2013-03-06','13:10:00',2.92),('9650','2013-03-06','13:15:00',3.15),('9650','2013-03-06','13:20:00',3.79),('9650','2013-03-06','13:25:00',3.32),('9650','2013-03-06','13:30:00',2.8),('9650','2013-03-06','13:35:00',2.66),('9650','2013-03-06','13:40:00',1.51),('9650','2013-03-06','13:55:00',1.32),('9650','2013-03-06','14:00:00',1.32),('9650','2013-03-06','14:05:00',1.69),('9650','2013-03-06','14:10:00',1.86),('9650','2013-03-06','14:15:00',1.41),('9650','2013-03-06','14:20:00',1.39),('9650','2013-03-06','14:25:00',1.43),('9650','2013-03-06','14:45:00',1.36),('9650','2013-03-06','15:20:00',1.17),('9650','2013-03-06','15:25:00',1.56),('9650','2013-03-06','15:30:00',1.24),('9650','2013-03-06','15:35:00',1.53),('9650','2013-03-06','15:40:00',1.67),('9650','2013-03-06','15:45:00',1.19),('9650','2013-03-06','15:55:00',1.04),('9650','2013-03-06','16:05:00',1.17),('9650','2013-03-06','16:10:00',1.11),('9650','2013-03-06','16:15:00',1.05),('9650','2013-03-06','16:20:00',1.13),('9650','2013-03-06','16:35:00',1.08),('9650','2013-03-06','16:40:00',1.73),('9650','2013-03-06','16:45:00',1.21),('9650','2013-03-04','08:25:00',1.02),('9650','2013-03-04','08:30:00',1.2),('9650','2013-03-04','08:35:00',1.26),('9650','2013-03-04','08:40:00',1.43),('9650','2013-03-04','08:45:00',1.48),('9650','2013-03-04','08:50:00',1.7),('9650','2013-03-04','08:55:00',1.9),('9650','2013-03-04','09:00:00',2.1),('9650','2013-03-04','09:05:00',2.25),('9650','2013-03-04','09:10:00',2.19),('9650','2013-03-04','09:15:00',2.21),('9650','2013-03-04','09:20:00',2.29),('9650','2013-03-04','09:25:00',2.27),('9650','2013-03-04','09:30:00',2.37),('9650','2013-03-04','09:35:00',2.52),('9650','2013-03-04','09:40:00',2.64),('9650','2013-03-04','09:45:00',2.68),('9650','2013-03-04','09:50:00',2.6),('9650','2013-03-04','09:55:00',2.49),('9650','2013-03-04','10:00:00',2.36),('9650','2013-03-04','10:05:00',2.51),('9650','2013-03-04','10:10:00',2.66),('9650','2013-03-04','10:15:00',2.8),('9650','2013-03-04','10:20:00',2.92),('9650','2013-03-04','10:25:00',2.73),('9650','2013-03-04','10:30:00',2.62),('9650','2013-03-04','10:35:00',2.89),('9650','2013-03-04','10:40:00',2.97),('9650','2013-03-04','10:45:00',3.14),('9650','2013-03-04','10:50:00',3.35),('9650','2013-03-04','10:55:00',3.4),('9650','2013-03-04','11:00:00',3.21),('9650','2013-03-04','11:05:00',3.43),('9650','2013-03-04','11:10:00',3.59),('9650','2013-03-04','11:15:00',3.65),('9650','2013-03-04','11:20:00',3.64),('9650','2013-03-04','11:25:00',3.61),('9650','2013-03-04','11:30:00',3.78),('9650','2013-03-04','11:35:00',4.12),('9650','2013-03-04','11:40:00',4.39),('9650','2013-03-04','11:45:00',4.23),('9650','2013-03-04','11:50:00',4.22),('9650','2013-03-04','11:55:00',4.26),('9650','2013-03-04','12:00:00',4.36),('9650','2013-03-04','12:05:00',4.55),('9650','2013-03-04','12:10:00',4.76),('9650','2013-03-04','12:15:00',3.87),('9650','2013-03-04','12:20:00',4.39),('9650','2013-03-04','12:25:00',4.47),('9650','2013-03-04','12:30:00',3.84),('9650','2013-03-04','12:35:00',3.75),('9650','2013-03-04','12:40:00',3.84),('9650','2013-03-04','12:45:00',4.09),('9650','2013-03-04','12:50:00',3.64),('9650','2013-03-04','12:55:00',3.35),('9650','2013-03-04','13:00:00',2.9),('9650','2013-03-04','13:05:00',2.81),('9650','2013-03-04','13:10:00',2.97),('9650','2013-03-04','13:15:00',3.18),('9650','2013-03-04','13:20:00',3.03),('9650','2013-03-04','13:25:00',2.76),('9650','2013-03-04','13:30:00',2.54),('9650','2013-03-04','13:35:00',2.41),('9650','2013-03-04','13:40:00',2.28),('9650','2013-03-04','13:45:00',2.08),('9650','2013-03-04','13:50:00',1.9),('9650','2013-03-04','13:55:00',1.83),('9650','2013-03-04','14:00:00',1.85),('9650','2013-03-04','14:05:00',1.89),('9650','2013-03-04','14:10:00',1.95),('9650','2013-03-04','14:15:00',1.8),('9650','2013-03-04','14:20:00',1.71),('9650','2013-03-04','14:25:00',1.73),('9650','2013-03-04','14:30:00',1.69),('9650','2013-03-04','14:35:00',1.71),('9650','2013-03-04','14:40:00',1.75),('9650','2013-03-04','14:45:00',1.79),('9650','2013-03-04','14:50:00',1.74),('9650','2013-03-04','14:55:00',1.59),('9650','2013-03-04','15:00:00',1.44),('9650','2013-03-04','15:05:00',1.35),('9650','2013-03-04','15:10:00',1.11),('9650','2013-03-04','15:20:00',1.08),('9650','2013-03-04','15:25:00',1.22),('9650','2013-03-04','15:30:00',1.31),('9650','2013-03-04','15:35:00',1.33),('9650','2013-03-04','15:40:00',1.53),('9650','2013-03-04','15:45:00',2.09),('9650','2013-03-04','15:50:00',2.06),('9650','2013-03-04','15:55:00',1.71),('9650','2013-03-04','16:00:00',1.53),('9650','2013-03-04','16:05:00',1.36),('9650','2013-03-04','16:10:00',1.12),('9650','2013-03-03','09:00:00',1.02),('9650','2013-03-03','09:05:00',1.13),('9650','2013-03-03','09:10:00',1.25),('9650','2013-03-03','09:15:00',1.35),('9650','2013-03-03','09:20:00',1.46),('9650','2013-03-03','09:25:00',1.59),('9650','2013-03-03','09:30:00',1.7),('9650','2013-03-03','09:35:00',1.8),('9650','2013-03-03','09:40:00',1.93),('9650','2013-03-03','09:45:00',2.02),('9650','2013-03-03','09:50:00',2.16),('9650','2013-03-03','09:55:00',2.26),('9650','2013-03-03','10:00:00',2.39),('9650','2013-03-03','10:05:00',2.54),('9650','2013-03-03','10:10:00',2.64),('9650','2013-03-03','10:15:00',2.8),('9650','2013-03-03','10:20:00',2.93),('9650','2013-03-03','10:25:00',3.02),('9650','2013-03-03','10:30:00',3.12),('9650','2013-03-03','10:35:00',3.25),('9650','2013-03-03','10:40:00',3.34),('9650','2013-03-03','10:45:00',3.43),('9650','2013-03-03','10:50:00',3.52),('9650','2013-03-03','10:55:00',3.58),('9650','2013-03-03','11:00:00',3.7),('9650','2013-03-03','11:05:00',3.81),('9650','2013-03-03','11:10:00',3.9),('9650','2013-03-03','11:15:00',4.02),('9650','2013-03-03','11:20:00',4.09),('9650','2013-03-03','11:25:00',4.18),('9650','2013-03-03','11:30:00',4.27),('9650','2013-03-03','11:35:00',4.3),('9650','2013-03-03','11:40:00',4.35),('9650','2013-03-03','11:45:00',4.42),('9650','2013-03-03','11:50:00',4.47),('9650','2013-03-03','11:55:00',4.55),('9650','2013-03-03','12:00:00',4.63),('9650','2013-03-03','12:05:00',4.69),('9650','2013-03-03','12:10:00',4.8),('9650','2013-03-03','12:15:00',4.89),('9650','2013-03-03','12:20:00',4.89),('9650','2013-03-03','12:25:00',4.96),('9650','2013-03-03','12:30:00',4.95),('9650','2013-03-03','12:35:00',5.01),('9650','2013-03-03','12:40:00',5.06),('9650','2013-03-03','12:45:00',5.07),('9650','2013-03-03','12:50:00',5.1),('9650','2013-03-03','12:55:00',5.05),('9650','2013-03-03','13:00:00',5),('9650','2013-03-03','13:05:00',5),('9650','2013-03-03','13:10:00',5),('9650','2013-03-03','13:15:00',4.92),('9650','2013-03-03','13:20:00',4.8),('9650','2013-03-03','13:25:00',4.65),('9650','2013-03-03','13:30:00',4.19),('9650','2013-03-03','13:35:00',5.13),('9650','2013-03-03','13:40:00',4.79),('9650','2013-03-03','13:45:00',4.48),('9650','2013-03-03','13:50:00',4.61),('9650','2013-03-03','13:55:00',4.7),('9650','2013-03-03','14:00:00',4.72),('9650','2013-03-03','14:05:00',4.62),('9650','2013-03-03','14:10:00',4.37),('9650','2013-03-03','14:15:00',4.23),('9650','2013-03-03','14:20:00',4.36),('9650','2013-03-03','14:25:00',4.21),('9650','2013-03-03','14:30:00',4.11),('9650','2013-03-03','14:35:00',3.37),('9650','2013-03-03','14:40:00',4.08),('9650','2013-03-03','14:45:00',3.98),('9650','2013-03-03','14:50:00',3.85),('9650','2013-03-03','14:55:00',3.7),('9650','2013-03-03','15:00:00',3.73),('9650','2013-03-03','15:05:00',3.57),('9650','2013-03-03','15:10:00',3.52),('9650','2013-03-03','15:15:00',3.4),('9650','2013-03-03','15:20:00',3.31),('9650','2013-03-03','15:25:00',3.24),('9650','2013-03-03','15:30:00',3.25),('9650','2013-03-03','15:35:00',3.18),('9650','2013-03-03','15:40:00',3.1),('9650','2013-03-03','15:45:00',3.05),('9650','2013-03-03','15:50:00',2.99),('9650','2013-03-03','15:55:00',2.95),('9650','2013-03-03','16:00:00',2.9),('9650','2013-03-03','16:05:00',2.77),('9650','2013-03-03','16:10:00',2.67),('9650','2013-03-03','16:15:00',2.55),('9650','2013-03-03','16:20:00',2.48),('9650','2013-03-03','16:25:00',2.45),('9650','2013-03-03','16:30:00',2.35),('9650','2013-03-03','16:35:00',2.22),('9650','2013-03-03','16:40:00',2.12),('9650','2013-03-03','16:45:00',1.99),('9650','2013-03-03','16:50:00',1.9),('9650','2013-03-03','16:55:00',1.75),('9650','2013-03-03','17:00:00',1.55),('9650','2013-03-03','17:05:00',1.33),('9650','2013-03-03','17:10:00',1.14),('9650','2013-03-02','09:10:00',1.01),('9650','2013-03-02','09:15:00',1.12),('9650','2013-03-02','09:20:00',1.23),('9650','2013-03-02','09:25:00',1.32),('9650','2013-03-02','09:30:00',1.38),('9650','2013-03-02','09:35:00',1.61),('9650','2013-03-02','09:40:00',1.76),('9650','2013-03-02','09:45:00',1.9),('9650','2013-03-02','09:50:00',2.05),('9650','2013-03-02','09:55:00',2.18),('9650','2013-03-02','10:00:00',2.33),('9650','2013-03-02','10:05:00',2.45),('9650','2013-03-02','10:10:00',2.59),('9650','2013-03-02','10:15:00',2.73),('9650','2013-03-02','10:20:00',2.86),('9650','2013-03-02','10:25:00',3),('9650','2013-03-02','10:30:00',3.1),('9650','2013-03-02','10:35:00',3.22),('9650','2013-03-02','10:40:00',3.35),('9650','2013-03-02','10:45:00',3.46),('9650','2013-03-02','10:50:00',3.56),('9650','2013-03-02','10:55:00',3.67),('9650','2013-03-02','11:00:00',3.78),('9650','2013-03-02','11:05:00',3.87),('9650','2013-03-02','11:10:00',3.97),('9650','2013-03-02','11:15:00',4.05),('9650','2013-03-02','11:20:00',4.15),('9650','2013-03-02','11:25:00',4.23),('9650','2013-03-02','11:30:00',4.32),('9650','2013-03-02','11:35:00',4.41),('9650','2013-03-02','11:40:00',4.45),('9650','2013-03-02','11:45:00',4.55),('9650','2013-03-02','11:50:00',4.61),('9650','2013-03-02','11:55:00',4.7),('9650','2013-03-02','12:00:00',4.78),('9650','2013-03-02','12:05:00',4.81),('9650','2013-03-02','12:10:00',4.87),('9650','2013-03-02','12:15:00',4.93),('9650','2013-03-02','12:20:00',4.97),('9650','2013-03-02','12:25:00',5.02),('9650','2013-03-02','12:30:00',5.09),('9650','2013-03-02','12:35:00',5.11),('9650','2013-03-02','12:40:00',5.14),('9650','2013-03-02','12:45:00',5.21),('9650','2013-03-02','12:50:00',5.23),('9650','2013-03-02','12:55:00',5.25),('9650','2013-03-02','13:00:00',5.23),('9650','2013-03-02','13:05:00',5.22),('9650','2013-03-02','13:10:00',5.16),('9650','2013-03-02','13:15:00',5.1),('9650','2013-03-02','13:20:00',4.96),('9650','2013-03-02','13:25:00',4.92),('9650','2013-03-02','13:30:00',4.93),('9650','2013-03-02','13:35:00',4.9),('9650','2013-03-02','13:40:00',4.91),('9650','2013-03-02','13:45:00',4.88),('9650','2013-03-02','13:50:00',4.83),('9650','2013-03-02','13:55:00',4.8),('9650','2013-03-02','14:00:00',4.82),('9650','2013-03-02','14:05:00',4.86),('9650','2013-03-02','14:10:00',4.71),('9650','2013-03-02','14:15:00',4.62),('9650','2013-03-02','14:20:00',4.6),('9650','2013-03-02','14:25:00',4.58),('9650','2013-03-02','14:30:00',4.42),('9650','2013-03-02','14:35:00',4.38),('9650','2013-03-02','14:40:00',4.33),('9650','2013-03-02','14:45:00',4.25),('9650','2013-03-02','14:50:00',4.15),('9650','2013-03-02','14:55:00',4.05),('9650','2013-03-02','15:00:00',3.94),('9650','2013-03-02','15:05:00',3.73),('9650','2013-03-02','15:10:00',3.58),('9650','2013-03-02','15:15:00',3.61),('9650','2013-03-02','15:20:00',3.58),('9650','2013-03-02','15:25:00',3.51),('9650','2013-03-02','15:30:00',3.47),('9650','2013-03-02','15:40:00',1.36),('9650','2013-03-02','15:45:00',3.29),('9650','2013-03-02','15:50:00',3.29),('9650','2013-03-02','15:55:00',3.22),('9650','2013-03-02','16:00:00',3.12),('9650','2013-03-02','16:05:00',3.03),('9650','2013-03-02','16:10:00',2.96),('9650','2013-03-02','16:15:00',2.8),('9650','2013-03-02','16:20:00',2.71),('9650','2013-03-02','16:25:00',2.62),('9650','2013-03-02','16:30:00',2.52),('9650','2013-03-02','16:35:00',2.4),('9650','2013-03-02','16:40:00',2.33),('9650','2013-03-02','16:45:00',2.21),('9650','2013-03-02','16:50:00',2.07),('9650','2013-03-02','16:55:00',1.89),('9650','2013-03-02','17:00:00',1.7),('9650','2013-03-02','17:05:00',1.49),('9650','2013-03-02','17:10:00',1.25),('9650','2014-03-23','07:45:00',1.59),('9650','2014-03-23','07:50:00',1.3),('9650','2014-03-23','07:55:00',1.44),('9650','2014-03-23','08:35:00',1.3),('9650','2014-03-23','08:40:00',1.43),('9650','2014-03-23','08:45:00',1.04),('9650','2014-03-23','08:50:00',1.27),('9650','2014-03-23','08:55:00',2.11),('9650','2014-03-23','09:00:00',2.26),('9650','2014-03-23','09:05:00',1.53),('9650','2014-03-23','09:10:00',1.02),('9650','2014-03-23','09:15:00',1.12),('9650','2014-03-23','09:20:00',1.75),('9650','2014-03-23','09:25:00',1.34),('9650','2014-03-23','09:30:00',1.82),('9650','2014-03-23','09:35:00',1.4),('9650','2014-03-23','09:40:00',1.95),('9650','2014-03-23','09:45:00',1.78),('9650','2014-03-23','09:50:00',1.82),('9650','2014-03-23','09:55:00',1.13),('9650','2014-03-23','10:00:00',2.52),('9650','2014-03-23','10:05:00',3.01),('9650','2014-03-23','10:10:00',4.25),('9650','2014-03-23','10:15:00',3.58),('9650','2014-03-23','10:20:00',1.62),('9650','2014-03-23','10:25:00',1.44),('9650','2014-03-23','10:30:00',1.38),('9650','2014-03-23','10:35:00',2.12),('9650','2014-03-23','10:40:00',1.78),('9650','2014-03-23','10:45:00',2.62),('9650','2014-03-23','10:50:00',5.79),('9650','2014-03-23','10:55:00',4.77),('9650','2014-03-23','11:00:00',2.53),('9650','2014-03-23','11:05:00',3.3),('9650','2014-03-23','11:10:00',4.03),('9650','2014-03-23','11:15:00',4.63),('9650','2014-03-23','11:20:00',3.86),('9650','2014-03-23','11:25:00',4.73),('9650','2014-03-23','11:30:00',5.57),('9650','2014-03-23','11:35:00',2.65),('9650','2014-03-23','11:40:00',1.31),('9650','2014-03-23','11:45:00',1.07),('9650','2014-03-23','11:50:00',1.11),('9650','2014-03-23','11:55:00',1.29),('9650','2014-03-23','12:00:00',1.08),('9650','2014-03-23','12:20:00',1.02),('9650','2014-03-23','12:25:00',1.23),('9650','2014-03-23','12:30:00',2.08),('9650','2014-03-23','12:35:00',3.45),('9650','2014-03-23','12:40:00',3.44),('9650','2014-03-23','12:45:00',3),('9650','2014-03-23','12:50:00',2.63),('9650','2014-03-23','12:55:00',2.55),('9650','2014-03-23','13:00:00',2.59),('9650','2014-03-23','13:05:00',2.57),('9650','2014-03-23','13:10:00',2.22),('9650','2014-03-23','13:15:00',1.97),('9650','2014-03-23','13:20:00',1.99),('9650','2014-03-23','13:25:00',2.24),('9650','2014-03-23','13:30:00',2.5),('9650','2014-03-23','13:35:00',2.11),('9650','2014-03-23','13:40:00',1.41),('9650','2014-03-23','13:45:00',2),('9650','2014-03-23','13:50:00',2.39),('9650','2014-03-23','13:55:00',2.38),('9650','2014-03-23','14:00:00',2.09),('9650','2014-03-23','14:05:00',1.95),('9650','2014-03-23','14:10:00',2.31),('9650','2014-03-23','14:15:00',2.95),('9650','2014-03-23','14:20:00',3.8),('9650','2014-03-23','14:25:00',3.71),('9650','2014-03-23','14:30:00',3.4),('9650','2014-03-23','14:35:00',4.08),('9650','2014-03-23','14:40:00',5.29),('9650','2014-03-23','14:45:00',5.94),('9650','2014-03-23','14:50:00',5.96),('9650','2014-03-23','14:55:00',5.12),('9650','2014-03-23','15:00:00',4.53),('9650','2014-03-23','15:05:00',3.93),('9650','2014-03-23','15:10:00',3.59),('9650','2014-03-23','15:15:00',2.64),('9650','2014-03-23','15:20:00',3.01),('9650','2014-03-23','15:25:00',2.79),('9650','2014-03-23','15:30:00',2.99),('9650','2014-03-23','15:45:00',2.13),('9650','2014-03-23','15:50:00',2.47),('9650','2014-03-23','15:55:00',2.86),('9650','2014-03-23','16:00:00',4.8),('9650','2014-03-23','16:05:00',2.44),('9650','2014-03-23','16:10:00',1.9),('9650','2014-03-23','16:15:00',1.37),('9650','2014-03-23','17:40:00',1.24),('9650','2014-03-23','17:45:00',1.26),('9650','2014-03-23','17:50:00',1.01),('9650','2013-03-01','08:55:00',1.04),('9650','2013-03-01','09:00:00',1.12),('9650','2013-03-01','09:05:00',1.02),('9650','2013-03-01','09:40:00',1.09),('9650','2013-03-01','09:45:00',1.31),('9650','2013-03-01','09:50:00',1.39),('9650','2013-03-01','09:55:00',1.25),('9650','2013-03-01','10:00:00',1.12),('9650','2013-03-01','10:05:00',1.14),('9650','2013-03-01','10:10:00',1.05),('9650','2013-03-01','10:15:00',1.1),('9650','2013-03-01','10:20:00',1.3),('9650','2013-03-01','10:25:00',1.44),('9650','2013-03-01','10:30:00',1.58),('9650','2013-03-01','10:35:00',1.69),('9650','2013-03-01','10:40:00',1.8),('9650','2013-03-01','10:45:00',1.81),('9650','2013-03-01','10:50:00',1.96),('9650','2013-03-01','10:55:00',2.02),('9650','2013-03-01','11:00:00',2.12),('9650','2013-03-01','11:05:00',2.27),('9650','2013-03-01','11:10:00',2.3),('9650','2013-03-01','11:15:00',2.68),('9650','2013-03-01','11:20:00',2.4),('9650','2013-03-01','11:25:00',2.18),('9650','2013-03-01','11:30:00',2.04),('9650','2013-03-01','11:35:00',2.08),('9650','2013-03-01','11:40:00',2.37),('9650','2013-03-01','11:45:00',2.16),('9650','2013-03-01','11:50:00',2.19),('9650','2013-03-01','11:55:00',2.06),('9650','2013-03-01','12:00:00',2.01),('9650','2013-03-01','12:05:00',2.27),('9650','2013-03-01','12:10:00',2.22),('9650','2013-03-01','12:15:00',2.28),('9650','2013-03-01','12:20:00',2.17),('9650','2013-03-01','12:25:00',2.24),('9650','2013-03-01','12:30:00',2.42),('9650','2013-03-01','12:35:00',2.59),('9650','2013-03-01','12:40:00',3.06),('9650','2013-03-01','12:45:00',2.7),('9650','2013-03-01','12:50:00',2.46),('9650','2013-03-01','12:55:00',2.7),('9650','2013-03-01','13:00:00',2.52),('9650','2013-03-01','13:05:00',2.17),('9650','2013-03-01','13:10:00',1.78),('9650','2013-03-01','13:15:00',1.63),('9650','2013-03-01','13:20:00',1.59),('9650','2013-03-01','13:25:00',1.6),('9650','2013-03-01','13:30:00',1.81),('9650','2013-03-01','13:35:00',1.86),('9650','2013-03-01','13:40:00',1.96),('9650','2013-03-01','13:45:00',2.11),('9650','2013-03-01','13:50:00',2.03),('9650','2013-03-01','13:55:00',2.11),('9650','2013-03-01','14:00:00',2.32),('9650','2013-03-01','14:05:00',2.25),('9650','2013-03-01','14:10:00',1.94),('9650','2013-03-01','14:15:00',1.73),('9650','2013-03-01','14:20:00',1.65),('9650','2013-03-01','14:25:00',1.33),('9650','2013-03-01','14:30:00',1.01),('9650','2013-03-01','14:50:00',1.21),('9650','2013-03-01','14:55:00',1.33),('9650','2013-03-01','15:00:00',1.3),('9650','2013-03-01','15:05:00',1.49),('9650','2013-03-01','15:10:00',1.48),('9650','2013-03-01','15:15:00',1.41),('9650','2013-03-01','15:20:00',1.35),('9650','2013-03-01','15:25:00',1.29),('9650','2013-03-01','15:30:00',1.43),('9650','2013-03-01','15:35:00',1.37),('9650','2013-03-01','15:40:00',1.29),('9650','2013-03-01','15:45:00',1.49),('9650','2013-03-01','15:50:00',1.32),('9650','2013-03-01','15:55:00',1.29),('9650','2013-03-01','16:00:00',1.12),('9650','2013-02-28','08:15:00',1.04),('9650','2013-02-28','08:20:00',1.1),('9650','2013-02-28','08:25:00',1.15),('9650','2013-02-28','08:30:00',1.21),('9650','2013-02-28','08:35:00',1.28),('9650','2013-02-28','08:40:00',1.33),('9650','2013-02-28','08:45:00',1.41),('9650','2013-02-28','08:50:00',1.44),('9650','2013-02-28','08:55:00',1.5),('9650','2013-02-28','09:00:00',1.54),('9650','2013-02-28','09:05:00',1.6),('9650','2013-02-28','09:10:00',1.62),('9650','2013-02-28','09:15:00',1.66),('9650','2013-02-28','09:20:00',1.72),('9650','2013-02-28','09:25:00',1.77),('9650','2013-02-28','09:30:00',1.86),('9650','2013-02-28','09:35:00',1.87),('9650','2013-02-28','09:40:00',2.02),('9650','2013-02-28','09:45:00',2.18),('9650','2013-02-28','09:50:00',2.25),('9650','2013-02-28','09:55:00',2.34),('9650','2013-02-28','10:00:00',2.49),('9650','2013-02-28','10:05:00',2.6),('9650','2013-02-28','10:10:00',2.68),('9650','2013-02-28','10:15:00',2.53),('9650','2013-02-28','10:20:00',2.61),('9650','2013-02-28','10:25:00',2.81),('9650','2013-02-28','10:30:00',3.15),('9650','2013-02-28','10:35:00',3.34),('9650','2013-02-28','10:40:00',3.14),('9650','2013-02-28','10:45:00',3.07),('9650','2013-02-28','10:50:00',3.03),('9650','2013-02-28','10:55:00',2.97),('9650','2013-02-28','11:00:00',2.76),('9650','2013-02-28','11:05:00',2.58),('9650','2013-02-28','11:10:00',2.57),('9650','2013-02-28','11:15:00',2.78),('9650','2013-02-28','11:20:00',2.89),('9650','2013-02-28','11:25:00',2.89),('9650','2013-02-28','11:30:00',2.94),('9650','2013-02-28','11:35:00',2.96),('9650','2013-02-28','11:40:00',2.87),('9650','2013-02-28','11:45:00',2.78),('9650','2013-02-28','11:50:00',2.76),('9650','2013-02-28','11:55:00',2.66),('9650','2013-02-28','12:00:00',2.55),('9650','2013-02-28','12:05:00',2.43),('9650','2013-02-28','12:10:00',2.28),('9650','2013-02-28','12:15:00',2.1),('9650','2013-02-28','12:20:00',2.01),('9650','2013-02-28','12:25:00',2),('9650','2013-02-28','12:30:00',2.07),('9650','2013-02-28','12:35:00',2.06),('9650','2013-02-28','12:40:00',1.98),('9650','2013-02-28','12:45:00',1.98),('9650','2013-02-28','12:50:00',2.05),('9650','2013-02-28','12:55:00',2.16),('9650','2013-02-28','13:00:00',2.27),('9650','2013-02-28','13:05:00',2.28),('9650','2013-02-28','13:10:00',2.37),('9650','2013-02-28','13:15:00',2.52),('9650','2013-02-28','13:20:00',2.69),('9650','2013-02-28','13:25:00',2.92),('9650','2013-02-28','13:30:00',2.84),('9650','2013-02-28','13:35:00',2.64),('9650','2013-02-28','13:40:00',2.52),('9650','2013-02-28','13:45:00',2.5),('9650','2013-02-28','13:50:00',2.49),('9650','2013-02-28','13:55:00',2.4),('9650','2013-02-28','14:00:00',2.34),('9650','2013-02-28','14:05:00',2.24),('9650','2013-02-28','14:10:00',2.11),('9650','2013-02-28','14:15:00',2),('9650','2013-02-28','14:20:00',1.93),('9650','2013-02-28','14:25:00',1.94),('9650','2013-02-28','14:30:00',1.99),('9650','2013-02-28','14:35:00',1.97),('9650','2013-02-28','14:40:00',1.88),('9650','2013-02-28','14:45:00',1.77),('9650','2013-02-28','14:50:00',1.68),('9650','2013-02-28','14:55:00',1.66),('9650','2013-02-28','15:00:00',1.68),('9650','2013-02-28','15:05:00',1.64),('9650','2013-02-28','15:10:00',1.51),('9650','2013-02-28','15:15:00',1.38),('9650','2013-02-28','15:20:00',1.3),('9650','2013-02-28','15:25:00',1.18),('9650','2013-02-28','15:30:00',1.05),('9650','2013-02-28','15:35:00',1.05),('9650','2013-02-28','15:40:00',1.15),('9650','2013-02-28','15:45:00',1.13),('9650','2013-02-28','15:50:00',1.05),('9650','2013-02-28','15:55:00',1.01),('9650','2013-02-28','16:00:00',1.01),('9650','2013-02-28','16:05:00',1.01),('9650','2013-02-27','09:00:00',1.01),('9650','2013-02-27','09:05:00',1.1),('9650','2013-02-27','09:10:00',1.18),('9650','2013-02-27','09:15:00',1.27),('9650','2013-02-27','09:20:00',1.39),('9650','2013-02-27','09:25:00',1.5),('9650','2013-02-27','09:30:00',1.6),('9650','2013-02-27','09:35:00',1.71),('9650','2013-02-27','09:40:00',1.82),('9650','2013-02-27','09:45:00',1.94),('9650','2013-02-27','09:50:00',1.9),('9650','2013-02-27','09:55:00',2.07),('9650','2013-02-27','10:00:00',2.21),('9650','2013-02-27','10:05:00',2.34),('9650','2013-02-27','10:10:00',2.44),('9650','2013-02-27','10:15:00',2.54),('9650','2013-02-27','10:20:00',2.69),('9650','2013-02-27','10:25:00',2.79),('9650','2013-02-27','10:30:00',2.82),('9650','2013-02-27','10:35:00',2.96),('9650','2013-02-27','10:40:00',3.08),('9650','2013-02-27','10:45:00',3.19),('9650','2013-02-27','10:50:00',3.31),('9650','2013-02-27','10:55:00',3.37),('9650','2013-02-27','11:00:00',3.51),('9650','2013-02-27','11:05:00',3.63),('9650','2013-02-27','11:10:00',3.75),('9650','2013-02-27','11:15:00',3.81),('9650','2013-02-27','11:20:00',3.89),('9650','2013-02-27','11:25:00',4.1),('9650','2013-02-27','11:30:00',4.06),('9650','2013-02-27','11:35:00',4.15),('9650','2013-02-27','11:40:00',4.12),('9650','2013-02-27','11:45:00',4.04),('9650','2013-02-27','11:50:00',4.21),('9650','2013-02-27','11:55:00',4.25),('9650','2013-02-27','12:00:00',4.33),('9650','2013-02-27','12:05:00',4.25),('9650','2013-02-27','12:10:00',4.34),('9650','2013-02-27','12:15:00',4.58),('9650','2013-02-27','12:20:00',4.74),('9650','2013-02-27','12:25:00',4.7),('9650','2013-02-27','12:30:00',4.83),('9650','2013-02-27','12:35:00',4.83),('9650','2013-02-27','12:40:00',4.84),('9650','2013-02-27','12:45:00',4.8),('9650','2013-02-27','12:50:00',4.81),('9650','2013-02-27','12:55:00',4.89),('9650','2013-02-27','13:00:00',4.69),('9650','2013-02-27','13:05:00',4.88),('9650','2013-02-27','13:10:00',4.78),('9650','2013-02-27','13:15:00',4.77),('9650','2013-02-27','13:20:00',2.9),('9650','2013-02-27','13:25:00',3.23),('9650','2013-02-27','13:30:00',3.39),('9650','2013-02-27','13:35:00',4.85),('9650','2013-02-27','13:40:00',4.82),('9650','2013-02-27','13:45:00',4.84),('9650','2013-02-27','13:50:00',4.77),('9650','2013-02-27','13:55:00',4.9),('9650','2013-02-27','14:00:00',5.23),('9650','2013-02-27','14:05:00',5.08),('9650','2013-02-27','14:10:00',4.93),('9650','2013-02-27','14:15:00',4.66),('9650','2013-02-27','14:20:00',4.45),('9650','2013-02-27','14:25:00',4.31),('9650','2013-02-27','14:30:00',4.06),('9650','2013-02-27','14:35:00',3.81),('9650','2013-02-27','14:40:00',3.95),('9650','2013-02-27','14:45:00',3.88),('9650','2013-02-27','14:50:00',3.82),('9650','2013-02-27','14:55:00',3.63),('9650','2013-02-27','15:00:00',3.71),('9650','2013-02-27','15:05:00',3.48),('9650','2013-02-27','15:10:00',3.36),('9650','2013-02-27','15:15:00',3.32),('9650','2013-02-27','15:20:00',3.36),('9650','2013-02-27','15:25:00',3.11),('9650','2013-02-27','15:30:00',2.94),('9650','2013-02-27','15:35:00',2.87),('9650','2013-02-27','15:40:00',2.8),('9650','2013-02-27','15:45:00',2.82),('9650','2013-02-27','15:50:00',2.78),('9650','2013-02-27','15:55:00',2.69),('9650','2013-02-27','16:00:00',2.61),('9650','2013-02-27','16:05:00',2.47),('9650','2013-02-27','16:10:00',2.36),('9650','2013-02-27','16:15:00',2.25),('9650','2013-02-27','16:20:00',2.16),('9650','2013-02-27','16:25:00',2.08),('9650','2013-02-27','16:30:00',1.92),('9650','2013-02-27','16:35:00',1.91),('9650','2013-02-27','16:40:00',1.8),('9650','2013-02-27','16:45:00',1.68),('9650','2013-02-27','16:50:00',1.54),('9650','2013-02-27','16:55:00',1.35),('9650','2013-02-27','17:00:00',1.06),('9650','2013-02-26','09:10:00',1.06),('9650','2013-02-26','09:15:00',1.14),('9650','2013-02-26','09:20:00',1.24),('9650','2013-02-26','09:25:00',1.33),('9650','2013-02-26','09:30:00',1.43),('9650','2013-02-26','09:35:00',1.54),('9650','2013-02-26','09:40:00',1.65),('9650','2013-02-26','09:45:00',1.76),('9650','2013-02-26','09:50:00',1.86),('9650','2013-02-26','09:55:00',1.95),('9650','2013-02-26','10:00:00',2.09),('9650','2013-02-26','10:05:00',2.2),('9650','2013-02-26','10:10:00',2.3),('9650','2013-02-26','10:15:00',2.45),('9650','2013-02-26','10:20:00',2.58),('9650','2013-02-26','10:25:00',2.68),('9650','2013-02-26','10:30:00',2.8),('9650','2013-02-26','10:35:00',2.87),('9650','2013-02-26','10:40:00',2.95),('9650','2013-02-26','10:45:00',3.11),('9650','2013-02-26','10:50:00',3.21),('9650','2013-02-26','10:55:00',3.29),('9650','2013-02-26','11:00:00',3.43),('9650','2013-02-26','11:05:00',3.48),('9650','2013-02-26','11:10:00',3.51),('9650','2013-02-26','11:15:00',3.35),('9650','2013-02-26','11:20:00',3.44),('9650','2013-02-26','11:25:00',3.31),('9650','2013-02-26','11:30:00',1.37),('9650','2013-02-26','11:35:00',1.2),('9650','2013-02-26','11:40:00',1.35),('9650','2013-02-26','11:50:00',3.21),('9650','2013-02-26','11:55:00',3.67),('9650','2013-02-26','12:00:00',4.65),('9650','2013-02-26','12:05:00',4.58),('9650','2013-02-26','12:10:00',1.77),('9650','2013-02-26','12:15:00',4.55),('9650','2013-02-26','12:20:00',5),('9650','2013-02-26','12:25:00',4.91),('9650','2013-02-26','12:30:00',4.82),('9650','2013-02-26','12:35:00',4.91),('9650','2013-02-26','12:40:00',4.95),('9650','2013-02-26','12:45:00',4.97),('9650','2013-02-26','12:50:00',4.94),('9650','2013-02-26','12:55:00',4.97),('9650','2013-02-26','13:00:00',5.05),('9650','2013-02-26','13:05:00',5.02),('9650','2013-02-26','13:10:00',4.69),('9650','2013-02-26','13:15:00',4.8),('9650','2013-02-26','13:20:00',4.99),('9650','2013-02-26','13:25:00',5),('9650','2013-02-26','13:30:00',4.97),('9650','2013-02-26','13:35:00',4.82),('9650','2013-02-26','13:40:00',4.89),('9650','2013-02-26','13:45:00',4.86),('9650','2013-02-26','13:50:00',4.74),('9650','2013-02-26','13:55:00',4.75),('9650','2013-02-26','14:00:00',4.61),('9650','2013-02-26','14:05:00',4.45),('9650','2013-02-26','14:10:00',4.13),('9650','2013-02-26','14:15:00',3.63),('9650','2013-02-26','14:20:00',4.14),('9650','2013-02-26','14:25:00',1.85),('9650','2013-02-26','14:30:00',3.97),('9650','2013-02-26','14:35:00',4.2),('9650','2013-02-26','14:40:00',4.15),('9650','2013-02-26','14:45:00',4.07),('9650','2013-02-26','14:50:00',3.81),('9650','2013-02-26','14:55:00',3.62),('9650','2013-02-26','15:00:00',3.87),('9650','2013-02-26','15:05:00',3.74),('9650','2013-02-26','15:10:00',3.36),('9650','2013-02-26','15:15:00',3.04),('9650','2013-02-26','15:20:00',3.04),('9650','2013-02-26','15:25:00',3.22),('9650','2013-02-26','15:30:00',3.15),('9650','2013-02-26','15:35:00',3.13),('9650','2013-02-26','15:40:00',3.06),('9650','2013-02-26','15:45:00',3.01),('9650','2013-02-26','15:50:00',2.93),('9650','2013-02-26','15:55:00',2.91),('9650','2013-02-26','16:00:00',2.8),('9650','2013-02-26','16:05:00',2.69),('9650','2013-02-26','16:10:00',2.6),('9650','2013-02-26','16:15:00',2.46),('9650','2013-02-26','16:20:00',2.4),('9650','2013-02-26','16:25:00',2.28),('9650','2013-02-26','16:30:00',2.13),('9650','2013-02-26','16:35:00',2.01),('9650','2013-02-26','16:40:00',1.88),('9650','2013-02-26','16:45:00',1.74),('9650','2013-02-26','16:50:00',1.58),('9650','2013-02-26','16:55:00',1.31),('9650','2013-02-26','17:00:00',1.03),('9650','2013-02-25','08:50:00',1.04),('9650','2013-02-25','08:55:00',1.18),('9650','2013-02-25','09:00:00',1.27),('9650','2013-02-25','09:05:00',1.31),('9650','2013-02-25','09:10:00',1.35),('9650','2013-02-25','09:15:00',1.52),('9650','2013-02-25','09:20:00',1.62),('9650','2013-02-25','09:25:00',1.7),('9650','2013-02-25','09:30:00',1.85),('9650','2013-02-25','09:35:00',2.07),('9650','2013-02-25','09:40:00',2.16),('9650','2013-02-25','09:45:00',2.13),('9650','2013-02-25','09:50:00',2.11),('9650','2013-02-25','09:55:00',2.22),('9650','2013-02-25','10:00:00',2.12),('9650','2013-02-25','10:05:00',2),('9650','2013-02-25','10:10:00',2.19),('9650','2013-02-25','10:15:00',2.41),('9650','2013-02-25','10:20:00',2.96),('9650','2013-02-25','10:25:00',3.23),('9650','2013-02-25','10:30:00',3.29),('9650','2013-02-25','10:35:00',3.25),('9650','2013-02-25','10:40:00',2.7),('9650','2013-02-25','10:45:00',2.2),('9650','2013-02-25','10:50:00',2.56),('9650','2013-02-25','10:55:00',2.59),('9650','2013-02-25','11:00:00',2.97),('9650','2013-02-25','11:05:00',2.99),('9650','2013-02-25','11:10:00',2.93),('9650','2013-02-25','11:15:00',2.74),('9650','2013-02-25','11:20:00',2.77),('9650','2013-02-25','11:25:00',2.59),('9650','2013-02-25','11:30:00',2.52),('9650','2013-02-25','11:35:00',2.34),('9650','2013-02-25','11:40:00',2.31),('9650','2013-02-25','11:45:00',2.31),('9650','2013-02-25','11:50:00',2.47),('9650','2013-02-25','11:55:00',2.55),('9650','2013-02-25','12:00:00',2.49),('9650','2013-02-25','12:05:00',2.54),('9650','2013-02-25','12:10:00',2.7),('9650','2013-02-25','12:15:00',2.53),('9650','2013-02-25','12:20:00',2.62),('9650','2013-02-25','12:25:00',2.45),('9650','2013-02-25','12:30:00',2.45),('9650','2013-02-25','12:35:00',2.27),('9650','2013-02-25','12:40:00',2.12),('9650','2013-02-25','12:45:00',1.92),('9650','2013-02-25','12:50:00',1.78),('9650','2013-02-25','12:55:00',1.9),('9650','2013-02-25','13:00:00',1.97),('9650','2013-02-25','13:05:00',1.75),('9650','2013-02-25','13:10:00',1.6),('9650','2013-02-25','13:15:00',1.7),('9650','2013-02-25','13:20:00',1.75),('9650','2013-02-25','13:25:00',1.8),('9650','2013-02-25','13:30:00',1.84),('9650','2013-02-25','13:35:00',1.84),('9650','2013-02-25','13:40:00',1.84),('9650','2013-02-25','13:45:00',1.7),('9650','2013-02-25','13:50:00',1.52),('9650','2013-02-25','13:55:00',1.45),('9650','2013-02-25','14:00:00',1.35),('9650','2013-02-25','14:05:00',1.23),('9650','2013-02-25','14:10:00',1.16),('9650','2013-02-25','14:15:00',1.14),('9650','2013-02-24','08:35:00',1.02),('9650','2013-02-24','08:40:00',1.1),('9650','2013-02-24','08:45:00',1.25),('9650','2013-02-24','08:50:00',1.2),('9650','2013-02-24','08:55:00',1.24),('9650','2013-02-24','09:00:00',1.29),('9650','2013-02-24','09:05:00',1.27),('9650','2013-02-24','09:10:00',1.51),('9650','2013-02-24','09:15:00',1.53),('9650','2013-02-24','09:20:00',1.74),('9650','2013-02-24','09:25:00',2.2),('9650','2013-02-24','09:30:00',2.43),('9650','2013-02-24','09:35:00',2.39),('9650','2013-02-24','09:40:00',1.88),('9650','2013-02-24','09:45:00',1.48),('9650','2013-02-24','09:50:00',1.2),('9650','2013-02-24','10:40:00',1.49),('9650','2013-02-24','10:45:00',2.66),('9650','2013-02-24','10:50:00',4.09),('9650','2013-02-24','10:55:00',5.05),('9650','2013-02-24','11:00:00',4.46),('9650','2013-02-24','11:05:00',2.58),('9650','2013-02-24','11:10:00',2.42),('9650','2013-02-24','11:15:00',2.76),('9650','2013-02-24','11:20:00',1.52),('9650','2013-02-24','11:25:00',1.52),('9650','2013-02-24','11:30:00',1.84),('9650','2013-02-24','11:35:00',1.95),('9650','2013-02-24','11:40:00',2.25),('9650','2013-02-24','11:45:00',2.72),('9650','2013-02-24','11:50:00',3.84),('9650','2013-02-24','11:55:00',5.94),('9650','2013-02-24','12:00:00',4.21),('9650','2013-02-24','12:05:00',3.48),('9650','2013-02-24','12:10:00',3.02),('9650','2013-02-24','12:15:00',3.16),('9650','2013-02-24','12:20:00',5.25),('9650','2013-02-24','12:25:00',5.79),('9650','2013-02-24','12:30:00',4.81),('9650','2013-02-24','12:35:00',3.85),('9650','2013-02-24','12:40:00',5.01),('9650','2013-02-24','12:45:00',5.42),('9650','2013-02-24','12:50:00',5.14),('9650','2013-02-24','12:55:00',5.17),('9650','2013-02-24','13:00:00',3.55),('9650','2013-02-24','13:05:00',3.79),('9650','2013-02-24','13:10:00',2.52),('9650','2013-02-24','13:15:00',3.72),('9650','2013-02-24','13:20:00',2.84),('9650','2013-02-24','13:25:00',2.56),('9650','2013-02-24','13:30:00',2.84),('9650','2013-02-24','13:35:00',2.57),('9650','2013-02-24','13:40:00',2.09),('9650','2013-02-24','13:45:00',1.78),('9650','2013-02-24','13:50:00',1.61),('9650','2013-02-24','13:55:00',1.51),('9650','2013-02-24','14:00:00',1.38),('9650','2013-02-24','14:05:00',1.02),('9650','2013-02-24','14:35:00',1.11),('9650','2013-02-24','14:40:00',1.4),('9650','2013-02-24','14:45:00',1.35),('9650','2013-02-24','14:50:00',1.37),('9650','2013-02-24','14:55:00',1.37),('9650','2013-02-24','15:00:00',1.35),('9650','2013-02-24','15:05:00',1.43),('9650','2013-02-24','15:10:00',1.4),('9650','2013-02-24','15:15:00',1.32),('9650','2013-02-24','15:20:00',1.2),('9650','2013-02-24','15:55:00',1.07),('9650','2013-02-24','16:00:00',1.16),('9650','2013-02-24','16:05:00',1.1),('9650','2013-02-24','16:30:00',1.12),('9650','2013-02-24','16:35:00',1.35),('9650','2013-02-24','16:40:00',1.29),('9650','2013-02-24','16:45:00',1.27),('9650','2013-02-24','16:50:00',1.22),('9650','2013-02-24','16:55:00',1.51),('9650','2013-02-24','17:00:00',1.21),('9650','2013-02-23','08:20:00',1.15),('9650','2013-02-23','08:25:00',1.21),('9650','2013-02-23','08:45:00',1.24),('9650','2013-02-23','08:50:00',1.46),('9650','2013-02-23','08:55:00',1.35),('9650','2013-02-23','09:00:00',1.14),('9650','2013-02-23','10:30:00',1.07),('9650','2013-02-23','10:35:00',1.21),('9650','2013-02-23','10:40:00',1.48),('9650','2013-02-23','10:45:00',1.71),('9650','2013-02-23','10:50:00',2.35),('9650','2013-02-23','10:55:00',2.32),('9650','2013-02-23','11:00:00',1.88),('9650','2013-02-23','11:05:00',1.74),('9650','2013-02-23','11:10:00',1.49),('9650','2013-02-23','11:15:00',1.59),('9650','2013-02-23','11:20:00',1.55),('9650','2013-02-23','11:25:00',1.65),('9650','2013-02-23','11:30:00',1.73),('9650','2013-02-23','11:35:00',1.48),('9650','2013-02-23','11:40:00',1.6),('9650','2013-02-23','11:45:00',1.67),('9650','2013-02-23','11:50:00',1.65),('9650','2013-02-23','11:55:00',1.6),('9650','2013-02-23','12:00:00',1.45),('9650','2013-02-23','12:05:00',1.4),('9650','2013-02-23','12:10:00',1.14),('9650','2013-02-23','12:30:00',1.25),('9650','2013-02-23','12:35:00',1.75),('9650','2013-02-23','12:40:00',2.06),('9650','2013-02-23','12:45:00',2.17),('9650','2013-02-23','12:50:00',1.72),('9650','2013-02-23','12:55:00',1.64),('9650','2013-02-23','13:00:00',2.06),('9650','2013-02-23','13:05:00',2.52),('9650','2013-02-23','13:10:00',2.51),('9650','2013-02-23','13:15:00',2.3),('9650','2013-02-23','13:20:00',2.5),('9650','2013-02-23','13:25:00',1.62),('9650','2013-02-23','13:30:00',1.89),('9650','2013-02-23','13:35:00',2.33),('9650','2013-02-23','13:40:00',1.86),('9650','2013-02-23','13:45:00',2.11),('9650','2013-02-23','13:50:00',1.86),('9650','2013-02-23','13:55:00',1.82),('9650','2013-02-23','14:00:00',1.97),('9650','2013-02-23','14:05:00',2.89),('9650','2013-02-23','14:10:00',2.46),('9650','2013-02-23','14:15:00',1.91),('9650','2013-02-23','14:20:00',1.74),('9650','2013-02-23','14:25:00',1.7),('9650','2013-02-23','14:30:00',2.07),('9650','2013-02-23','14:35:00',2.06),('9650','2013-02-23','14:40:00',1.3),('9650','2013-02-23','14:45:00',1.33),('9650','2013-02-23','14:50:00',1.2),('9650','2013-02-23','14:55:00',1.14),('9650','2013-02-23','15:00:00',1.19),('9650','2013-02-23','15:05:00',1.5),('9650','2013-02-23','15:10:00',3.96),('9650','2013-02-23','15:15:00',1.65),('9650','2013-02-23','15:20:00',2.23),('9650','2013-02-23','15:25:00',2.75),('9650','2013-02-23','15:30:00',2.6),('9650','2013-02-23','15:35:00',2.28),('9650','2013-02-23','15:40:00',2.02),('9650','2013-02-23','15:45:00',2.47),('9650','2013-02-23','15:50:00',1.47),('9650','2013-02-23','15:55:00',2.76),('9650','2013-02-23','16:00:00',3.28),('9650','2013-02-23','16:05:00',1.86),('9650','2013-02-23','16:20:00',1.1),('9650','2013-02-23','16:25:00',1.11),('9650','2013-02-23','16:35:00',1.07),('9650','2013-02-23','16:40:00',1.89),('9650','2013-02-23','16:45:00',1.04),('9650','2013-02-22','08:15:00',1.19),('9650','2013-02-22','08:20:00',1.25),('9650','2013-02-22','08:25:00',1.17),('9650','2013-02-22','08:30:00',1.08),('9650','2013-02-22','08:45:00',1.02),('9650','2013-02-22','08:50:00',1.46),('9650','2013-02-22','08:55:00',1.64),('9650','2013-02-22','09:00:00',1.83),('9650','2013-02-22','09:05:00',1.94),('9650','2013-02-22','09:10:00',1.67),('9650','2013-02-22','09:15:00',1.4),('9650','2013-02-22','09:20:00',1.07),('9650','2013-02-22','09:30:00',1.02),('9650','2013-02-22','09:35:00',1.35),('9650','2013-02-22','09:40:00',1.6),('9650','2013-02-22','09:45:00',2.17),('9650','2013-02-22','09:50:00',2.33),('9650','2013-02-22','09:55:00',2.31),('9650','2013-02-22','10:00:00',1.84),('9650','2013-02-22','10:05:00',1.78),('9650','2013-02-22','10:10:00',1.58),('9650','2013-02-22','10:15:00',1.22),('9650','2013-02-22','10:20:00',1.39),('9650','2013-02-22','10:25:00',1.9),('9650','2013-02-22','10:30:00',1.86),('9650','2013-02-22','10:35:00',1.7),('9650','2013-02-22','10:40:00',1.51),('9650','2013-02-22','10:45:00',1.49),('9650','2013-02-22','10:50:00',1.78),('9650','2013-02-22','10:55:00',1.27),('9650','2013-02-22','11:00:00',1.01),('9650','2013-02-22','11:05:00',1.15),('9650','2013-02-22','11:10:00',1.12),('9650','2013-02-22','11:15:00',1.07),('9650','2013-02-22','11:20:00',1.31),('9650','2013-02-22','11:25:00',1.19),('9650','2013-02-22','11:30:00',1.17),('9650','2013-02-22','11:35:00',1.59),('9650','2013-02-22','11:40:00',1.51),('9650','2013-02-22','11:45:00',1.39),('9650','2013-02-22','11:50:00',1.19),('9650','2013-02-22','11:55:00',1.04),('9650','2013-02-22','12:05:00',1.26),('9650','2013-02-22','12:10:00',1.21),('9650','2013-02-22','12:20:00',1.03),('9650','2013-02-22','13:55:00',1.58),('9650','2013-02-22','14:00:00',1.67),('9650','2013-02-22','14:05:00',2.93),('9650','2013-02-22','14:10:00',1.93),('9650','2013-02-22','14:45:00',1.31),('9650','2013-02-22','14:50:00',1.22),('9650','2013-02-22','15:10:00',1.01),('9650','2013-02-21','09:35:00',1.38),('9650','2013-02-21','09:40:00',1.41),('9650','2013-02-21','09:50:00',1.08),('9650','2013-02-21','10:15:00',1.08),('9650','2013-02-21','11:35:00',1.13),('9650','2013-02-21','11:40:00',1.1),('9650','2013-02-21','12:00:00',1.21),('9650','2013-02-21','12:05:00',1.05),('9650','2013-02-21','12:45:00',1.14),('9650','2013-02-21','12:50:00',1.55),('9650','2013-02-21','12:55:00',1.79),('9650','2013-02-21','13:00:00',1.31),('9650','2013-02-21','14:10:00',1.3),('9650','2013-02-21','14:15:00',1.72),('9650','2013-02-21','14:20:00',1.7),('9650','2013-02-21','14:30:00',1.43),('9650','2013-02-21','14:35:00',2.26),('9650','2013-02-21','14:40:00',2.46),('9650','2013-02-21','14:45:00',1.81),('9650','2013-02-21','14:50:00',1.65),('9650','2013-02-21','14:55:00',2.22),('9650','2013-02-21','15:00:00',1.36),('9650','2013-02-21','15:50:00',1.52),('9650','2013-02-21','15:55:00',1.3),('9650','2013-02-21','16:00:00',1.26),('9650','2013-02-21','16:15:00',1.22),('9650','2013-02-21','16:20:00',2.09),('9650','2013-02-21','16:25:00',2.53),('9650','2013-02-21','16:30:00',2.19),('9650','2013-02-21','16:35:00',1.07),('9650','2013-02-20','09:40:00',1.01),('9650','2013-02-20','09:45:00',1.32),('9650','2013-02-20','09:50:00',1.39),('9650','2013-02-20','09:55:00',1.4),('9650','2013-02-20','10:00:00',1.32),('9650','2013-02-20','10:05:00',1.34),('9650','2013-02-20','10:10:00',1.39),('9650','2013-02-20','10:15:00',1.33),('9650','2013-02-20','10:20:00',1.34),('9650','2013-02-20','10:25:00',1.32),('9650','2013-02-20','10:30:00',1.35),('9650','2013-02-20','10:35:00',1.39),('9650','2013-02-20','10:40:00',1.4),('9650','2013-02-20','10:45:00',1.3),('9650','2013-02-20','10:50:00',1.31),('9650','2013-02-20','10:55:00',1.32),('9650','2013-02-20','11:00:00',1.17),('9650','2013-02-20','11:05:00',1.12),('9650','2013-02-20','11:10:00',1.14),('9650','2013-02-20','11:15:00',1.2),('9650','2013-02-20','11:20:00',1.32),('9650','2013-02-20','11:25:00',1.55),('9650','2013-02-20','11:30:00',1.74),('9650','2013-02-20','11:35:00',1.81),('9650','2013-02-20','11:40:00',1.8),('9650','2013-02-20','11:45:00',1.88),('9650','2013-02-20','11:50:00',2.07),('9650','2013-02-20','11:55:00',2.09),('9650','2013-02-20','12:00:00',2.04),('9650','2013-02-20','12:05:00',2.09),('9650','2013-02-20','12:10:00',2.15),('9650','2013-02-20','12:15:00',2.25),('9650','2013-02-20','12:20:00',2.38),('9650','2013-02-20','12:25:00',2.29),('9650','2013-02-20','12:30:00',2.15),('9650','2013-02-20','12:35:00',2.09),('9650','2013-02-20','12:40:00',2.06),('9650','2013-02-20','12:45:00',2.09),('9650','2013-02-20','12:50:00',2.08),('9650','2013-02-20','12:55:00',2.21),('9650','2013-02-20','13:00:00',2.2),('9650','2013-02-20','13:05:00',2.06),('9650','2013-02-20','13:10:00',2),('9650','2013-02-20','13:15:00',2.08),('9650','2013-02-20','13:20:00',2.2),('9650','2013-02-20','13:25:00',2.26),('9650','2013-02-20','13:30:00',2.26),('9650','2013-02-20','13:35:00',2.24),('9650','2013-02-20','13:40:00',2.14),('9650','2013-02-20','13:45:00',2.04),('9650','2013-02-20','13:50:00',2.07),('9650','2013-02-20','13:55:00',2.04),('9650','2013-02-20','14:00:00',2.06),('9650','2013-02-20','14:05:00',1.96),('9650','2013-02-20','14:10:00',1.81),('9650','2013-02-20','14:15:00',1.56),('9650','2013-02-20','14:20:00',1.4),('9650','2013-02-20','14:25:00',1.4),('9650','2013-02-20','14:30:00',1.51),('9650','2013-02-20','14:35:00',1.53),('9650','2013-02-20','14:40:00',1.49),('9650','2013-02-20','14:45:00',1.46),('9650','2013-02-20','14:50:00',1.38),('9650','2013-02-20','14:55:00',1.23),('9650','2013-02-20','15:00:00',1.12),('9650','2013-02-20','15:05:00',1.04),('9650','2013-02-20','15:10:00',1.09),('9650','2013-02-20','15:15:00',1.07),('9650','2013-02-20','15:35:00',1.04),('9650','2013-02-20','15:40:00',1.1),('9650','2013-02-20','15:45:00',1.19),('9650','2013-02-20','15:50:00',1.28),('9650','2013-02-20','15:55:00',1.43),('9650','2013-02-20','16:00:00',1.71),('9650','2013-02-20','16:05:00',1.77),('9650','2013-02-20','16:10:00',1.46),('9650','2013-02-20','16:15:00',1.59),('9650','2013-02-20','16:20:00',2.44),('9650','2013-02-20','16:25:00',2.71),('9650','2013-02-20','16:30:00',2.46),('9650','2013-02-20','16:35:00',2.08),('9650','2013-02-20','16:40:00',1.73),('9650','2013-02-20','16:45:00',1.33),('9650','2013-02-20','16:50:00',1.07),('9650','2014-03-22','08:05:00',1.12),('9650','2014-03-22','08:10:00',1.15),('9650','2014-03-22','08:15:00',1.12),('9650','2014-03-22','08:20:00',1.19),('9650','2014-03-22','08:25:00',1.25),('9650','2014-03-22','08:30:00',1.36),('9650','2014-03-22','08:35:00',1.54),('9650','2014-03-22','08:40:00',1.26),('9650','2014-03-22','08:45:00',1.21),('9650','2014-03-22','08:50:00',1.34),('9650','2014-03-22','08:55:00',1.69),('9650','2014-03-22','09:00:00',1.36),('9650','2014-03-22','09:05:00',1.9),('9650','2014-03-22','09:10:00',2.82),('9650','2014-03-22','09:15:00',3.06),('9650','2014-03-22','09:20:00',2.52),('9650','2014-03-22','09:25:00',1.79),('9650','2014-03-22','09:30:00',2.16),('9650','2014-03-22','09:35:00',2.36),('9650','2014-03-22','09:40:00',1.98),('9650','2014-03-22','09:45:00',1.61),('9650','2014-03-22','09:50:00',1.47),('9650','2014-03-22','09:55:00',1.38),('9650','2014-03-22','10:00:00',1.27),('9650','2014-03-22','10:05:00',1.23),('9650','2014-03-22','10:10:00',1.32),('9650','2014-03-22','10:20:00',1.22),('9650','2014-03-22','10:25:00',2),('9650','2014-03-22','10:30:00',1.49),('9650','2014-03-22','10:35:00',1.14),('9650','2014-03-22','10:40:00',1.98),('9650','2014-03-22','10:45:00',1.85),('9650','2014-03-22','10:50:00',2.01),('9650','2014-03-22','10:55:00',2.74),('9650','2014-03-22','11:00:00',2.02),('9650','2014-03-22','11:05:00',1.71),('9650','2014-03-22','11:10:00',2.08),('9650','2014-03-22','11:15:00',1.27),('9650','2014-03-22','11:20:00',1.36),('9650','2014-03-22','11:25:00',1.84),('9650','2014-03-22','11:30:00',1.46),('9650','2014-03-22','11:35:00',2.51),('9650','2014-03-22','11:40:00',5.34),('9650','2014-03-22','11:45:00',1.53),('9650','2014-03-22','11:55:00',1.42),('9650','2014-03-22','12:00:00',1.58),('9650','2014-03-22','12:05:00',1),('9650','2014-03-22','12:30:00',1.05),('9650','2014-03-22','12:35:00',1.16),('9650','2014-03-22','13:15:00',1),('9650','2014-03-22','13:35:00',1.04),('9650','2014-03-22','13:40:00',1.9),('9650','2014-03-22','13:45:00',4.01),('9650','2014-03-22','13:50:00',2.69),('9650','2014-03-22','13:55:00',2.28),('9650','2014-03-22','14:00:00',1.68),('9650','2014-03-22','14:15:00',1.05),('9650','2014-03-22','14:50:00',1.33),('9650','2014-03-22','14:55:00',1.45),('9650','2014-03-22','15:00:00',1.2),('9650','2014-03-22','15:05:00',1.59),('9650','2014-03-22','15:10:00',2.24),('9650','2014-03-22','15:15:00',2.56),('9650','2014-03-22','15:20:00',2.75),('9650','2014-03-22','15:25:00',3.37),('9650','2014-03-22','15:30:00',2.05),('9650','2014-03-22','15:35:00',1.55),('9650','2014-03-22','15:40:00',1.85),('9650','2013-02-19','09:10:00',1.17),('9650','2013-02-19','09:15:00',1.29),('9650','2013-02-19','09:20:00',1.16),('9650','2013-02-19','09:25:00',1.41),('9650','2013-02-19','09:30:00',1.18),('9650','2013-02-19','09:35:00',1.29),('9650','2013-02-19','09:40:00',1.41),('9650','2013-02-19','09:45:00',1.71),('9650','2013-02-19','09:50:00',1.87),('9650','2013-02-19','09:55:00',1.8),('9650','2013-02-19','10:00:00',1.4),('9650','2013-02-19','10:05:00',2.18),('9650','2013-02-19','10:10:00',2.29),('9650','2013-02-19','10:15:00',1.76),('9650','2013-02-19','10:20:00',1.42),('9650','2013-02-19','10:25:00',1.38),('9650','2013-02-19','10:30:00',1.1),('9650','2013-02-19','10:35:00',1.12),('9650','2013-02-19','10:40:00',1.43),('9650','2013-02-19','10:45:00',2.29),('9650','2013-02-19','10:50:00',3.68),('9650','2013-02-19','10:55:00',2.03),('9650','2013-02-19','11:00:00',1.26),('9650','2013-02-19','11:05:00',2.61),('9650','2013-02-19','11:10:00',4.4),('9650','2013-02-19','11:15:00',3.55),('9650','2013-02-19','11:20:00',3.58),('9650','2013-02-19','11:25:00',2.85),('9650','2013-02-19','11:30:00',1.89),('9650','2013-02-19','11:35:00',4.59),('9650','2013-02-19','11:40:00',5.29),('9650','2013-02-19','11:45:00',5.1),('9650','2013-02-19','11:50:00',4.5),('9650','2013-02-19','11:55:00',4.94),('9650','2013-02-19','12:00:00',2.9),('9650','2013-02-19','12:05:00',1.61),('9650','2013-02-19','12:10:00',3.43),('9650','2013-02-19','12:15:00',4.94),('9650','2013-02-19','12:20:00',2.67),('9650','2013-02-19','12:25:00',5.12),('9650','2013-02-19','12:30:00',5.98),('9650','2013-02-19','12:35:00',3.64),('9650','2013-02-19','12:40:00',1.57),('9650','2013-02-19','12:45:00',1.77),('9650','2013-02-19','12:50:00',1.86),('9650','2013-02-19','12:55:00',2.3),('9650','2013-02-19','13:00:00',5.23),('9650','2013-02-19','13:05:00',3.46),('9650','2013-02-19','13:10:00',5.55),('9650','2013-02-19','13:15:00',4.58),('9650','2013-02-19','13:20:00',2.24),('9650','2013-02-19','13:25:00',2.39),('9650','2013-02-19','13:30:00',3.31),('9650','2013-02-19','13:45:00',2.12),('9650','2013-02-19','13:50:00',1.98),('9650','2013-02-19','13:55:00',2.5),('9650','2013-02-19','14:00:00',2.55),('9650','2013-02-19','14:05:00',1.61),('9650','2013-02-19','14:10:00',1.59),('9650','2013-02-19','14:15:00',1.44),('9650','2013-02-19','14:20:00',1.15),('9650','2013-02-19','14:30:00',1.47),('9650','2013-02-19','14:35:00',1.6),('9650','2013-02-19','14:40:00',2.19),('9650','2013-02-19','14:45:00',1.79),('9650','2013-02-19','14:50:00',1.61),('9650','2013-02-19','14:55:00',1.53),('9650','2013-02-19','15:00:00',1.46),('9650','2013-02-19','15:05:00',1.93),('9650','2013-02-19','15:10:00',3.21),('9650','2013-02-19','15:15:00',3.98),('9650','2013-02-19','15:20:00',3.6),('9650','2013-02-19','15:25:00',3.6),('9650','2013-02-19','15:30:00',2.86),('9650','2013-02-19','15:35:00',1.5),('9650','2013-02-19','15:40:00',1.06),('9650','2013-02-19','15:45:00',1.1),('9650','2013-02-19','15:50:00',1.37),('9650','2013-02-19','15:55:00',1.54),('9650','2013-02-19','16:00:00',1.58),('9650','2013-02-19','16:05:00',3.06),('9650','2013-02-19','16:10:00',3.16),('9650','2013-02-19','16:15:00',2.98),('9650','2013-02-19','16:20:00',2.75),('9650','2013-02-19','16:25:00',2.36),('9650','2013-02-19','16:30:00',1.86),('9650','2013-02-19','16:35:00',1.49),('9650','2013-02-19','16:40:00',1.24),('9650','2013-02-19','16:45:00',1.08),('9650','2013-02-18','09:30:00',1.03),('9650','2013-02-18','09:35:00',1.13),('9650','2013-02-18','09:40:00',1.23),('9650','2013-02-18','09:45:00',1.35),('9650','2013-02-18','09:50:00',1.44),('9650','2013-02-18','09:55:00',1.55),('9650','2013-02-18','10:00:00',1.65),('9650','2013-02-18','10:05:00',1.77),('9650','2013-02-18','10:10:00',1.89),('9650','2013-02-18','10:15:00',2.01),('9650','2013-02-18','10:20:00',2.12),('9650','2013-02-18','10:25:00',2.24),('9650','2013-02-18','10:30:00',2.37),('9650','2013-02-18','10:35:00',2.5),('9650','2013-02-18','10:40:00',2.61),('9650','2013-02-18','10:45:00',2.71),('9650','2013-02-18','10:50:00',2.83),('9650','2013-02-18','10:55:00',2.93),('9650','2013-02-18','11:00:00',3.03),('9650','2013-02-18','11:05:00',3.1),('9650','2013-02-18','11:10:00',3.21),('9650','2013-02-18','11:15:00',3.35),('9650','2013-02-18','11:20:00',3.42),('9650','2013-02-18','11:25:00',3.51),('9650','2013-02-18','11:30:00',3.59),('9650','2013-02-18','11:35:00',3.64),('9650','2013-02-18','11:40:00',3.68),('9650','2013-02-18','11:45:00',3.83),('9650','2013-02-18','11:50:00',3.88),('9650','2013-02-18','11:55:00',3.95),('9650','2013-02-18','12:00:00',4.01),('9650','2013-02-18','12:05:00',4.06),('9650','2013-02-18','12:10:00',4.1),('9650','2013-02-18','12:15:00',4.16),('9650','2013-02-18','12:20:00',4.21),('9650','2013-02-18','12:25:00',4.19),('9650','2013-02-18','12:30:00',4.25),('9650','2013-02-18','12:35:00',4.36),('9650','2013-02-18','12:40:00',4.41),('9650','2013-02-18','12:45:00',4.43),('9650','2013-02-18','12:50:00',4.51),('9650','2013-02-18','12:55:00',4.54),('9650','2013-02-18','13:00:00',4.6),('9650','2013-02-18','13:05:00',4.64),('9650','2013-02-18','13:10:00',4.66),('9650','2013-02-18','13:15:00',4.7),('9650','2013-02-18','13:20:00',4.65),('9650','2013-02-18','13:25:00',4.56),('9650','2013-02-18','13:30:00',4.47),('9650','2013-02-18','13:35:00',4.36),('9650','2013-02-18','13:40:00',4.3),('9650','2013-02-18','13:45:00',4.26),('9650','2013-02-18','13:50:00',4.26),('9650','2013-02-18','13:55:00',4.27),('9650','2013-02-18','14:00:00',4.19),('9650','2013-02-18','14:05:00',4.12),('9650','2013-02-18','14:10:00',4.11),('9650','2013-02-18','14:15:00',4.01),('9650','2013-02-18','14:20:00',3.79),('9650','2013-02-18','14:25:00',3.74),('9650','2013-02-18','14:30:00',3.79),('9650','2013-02-18','14:35:00',3.72),('9650','2013-02-18','14:40:00',3.62),('9650','2013-02-18','14:45:00',3.53),('9650','2013-02-18','14:50:00',3.49),('9650','2013-02-18','14:55:00',3.43),('9650','2013-02-18','15:00:00',3.38),('9650','2013-02-18','15:05:00',3.21),('9650','2013-02-18','15:10:00',2.57),('9650','2013-02-18','15:25:00',1.11),('9650','2013-02-18','15:30:00',2.66),('9650','2013-02-18','15:35:00',2.62),('9650','2013-02-18','15:40:00',2.67),('9650','2013-02-18','15:45:00',2.64),('9650','2013-02-18','15:50:00',2.57),('9650','2013-02-18','15:55:00',2.52),('9650','2013-02-18','16:00:00',2.41),('9650','2013-02-18','16:05:00',2.34),('9650','2013-02-18','16:10:00',2.25),('9650','2013-02-18','16:15:00',2.15),('9650','2013-02-18','16:20:00',2.03),('9650','2013-02-18','16:25:00',1.91),('9650','2013-02-18','16:30:00',1.81),('9650','2013-02-18','16:35:00',1.63),('9650','2013-02-18','16:40:00',1.38),('9650','2013-02-18','16:45:00',1.17),('9650','2013-02-17','09:20:00',1.18),('9650','2013-02-17','09:25:00',1.4),('9650','2013-02-17','09:30:00',1.52),('9650','2013-02-17','09:35:00',1.78),('9650','2013-02-17','09:40:00',1.47),('9650','2013-02-17','09:45:00',1.1),('9650','2013-02-17','09:50:00',1.75),('9650','2013-02-17','09:55:00',1.35),('9650','2013-02-17','10:00:00',1.24),('9650','2013-02-17','10:05:00',1.46),('9650','2013-02-17','10:10:00',1.06),('9650','2013-02-17','10:35:00',1.14),('9650','2013-02-17','10:40:00',1.25),('9650','2013-02-17','10:45:00',1.23),('9650','2013-02-17','10:50:00',1.08),('9650','2013-02-17','10:55:00',1.46),('9650','2013-02-17','11:00:00',1.93),('9650','2013-02-17','11:05:00',1.99),('9650','2013-02-17','11:10:00',2.18),('9650','2013-02-17','11:15:00',2.06),('9650','2013-02-17','11:20:00',2.5),('9650','2013-02-17','11:25:00',2.57),('9650','2013-02-17','11:30:00',2.42),('9650','2013-02-17','11:35:00',2.49),('9650','2013-02-17','11:40:00',2.41),('9650','2013-02-17','11:45:00',2.2),('9650','2013-02-17','11:50:00',2.35),('9650','2013-02-17','11:55:00',2.9),('9650','2013-02-17','12:00:00',3.04),('9650','2013-02-17','12:05:00',2.77),('9650','2013-02-17','12:10:00',2.55),('9650','2013-02-17','12:15:00',2.5),('9650','2013-02-17','12:20:00',2.47),('9650','2013-02-17','12:25:00',2.49),('9650','2013-02-17','12:30:00',2.32),('9650','2013-02-17','12:35:00',2.2),('9650','2013-02-17','12:40:00',2.3),('9650','2013-02-17','12:45:00',2.7),('9650','2013-02-17','12:50:00',2.66),('9650','2013-02-17','12:55:00',2.47),('9650','2013-02-17','13:00:00',2.46),('9650','2013-02-17','13:05:00',2.55),('9650','2013-02-17','13:10:00',2.48),('9650','2013-02-17','13:15:00',3.02),('9650','2013-02-17','13:20:00',2.51),('9650','2013-02-17','13:25:00',2.91),('9650','2013-02-17','13:30:00',2.62),('9650','2013-02-17','13:35:00',2.22),('9650','2013-02-17','13:40:00',2.22),('9650','2013-02-17','13:45:00',2.11),('9650','2013-02-17','13:50:00',2.12),('9650','2013-02-17','13:55:00',2.58),('9650','2013-02-17','14:00:00',2.61),('9650','2013-02-17','14:05:00',2.42),('9650','2013-02-17','14:10:00',2.15),('9650','2013-02-17','14:15:00',1.9),('9650','2013-02-17','14:20:00',2.04),('9650','2013-02-17','14:25:00',1.39),('9650','2013-02-17','14:30:00',1.02),('9650','2013-02-17','14:35:00',1.03),('9650','2013-02-17','14:40:00',1.1),('9650','2013-02-17','14:45:00',1.09),('9650','2013-02-17','15:00:00',1.04),('9650','2013-02-17','15:05:00',1.18),('9650','2013-02-17','15:10:00',1.02),('9650','2013-02-17','15:35:00',1.09),('9650','2013-02-17','15:40:00',1.09),('9650','2013-02-16','09:35:00',1.06),('9650','2013-02-16','09:40:00',1.15),('9650','2013-02-16','09:45:00',1.25),('9650','2013-02-16','09:50:00',1.35),('9650','2013-02-16','09:55:00',1.46),('9650','2013-02-16','10:00:00',1.56),('9650','2013-02-16','10:05:00',1.67),('9650','2013-02-16','10:10:00',1.81),('9650','2013-02-16','10:15:00',1.91),('9650','2013-02-16','10:20:00',2),('9650','2013-02-16','10:25:00',2.12),('9650','2013-02-16','10:30:00',2.23),('9650','2013-02-16','10:35:00',2.34),('9650','2013-02-16','10:40:00',2.48),('9650','2013-02-16','10:45:00',2.59),('9650','2013-02-16','10:50:00',2.67),('9650','2013-02-16','10:55:00',2.79),('9650','2013-02-16','11:00:00',2.86),('9650','2013-02-16','11:05:00',2.97),('9650','2013-02-16','11:10:00',3.06),('9650','2013-02-16','11:15:00',3.15),('9650','2013-02-16','11:20:00',3.25),('9650','2013-02-16','11:25:00',3.34),('9650','2013-02-16','11:30:00',3.39),('9650','2013-02-16','11:35:00',3.47),('9650','2013-02-16','11:40:00',3.57),('9650','2013-02-16','11:45:00',3.68),('9650','2013-02-16','11:50:00',3.76),('9650','2013-02-16','11:55:00',3.84),('9650','2013-02-16','12:00:00',3.91),('9650','2013-02-16','12:05:00',3.99),('9650','2013-02-16','12:10:00',4.04),('9650','2013-02-16','12:15:00',4.07),('9650','2013-02-16','12:20:00',4.12),('9650','2013-02-16','12:25:00',4.14),('9650','2013-02-16','12:30:00',4.17),('9650','2013-02-16','12:35:00',4.18),('9650','2013-02-16','12:40:00',4.22),('9650','2013-02-16','12:45:00',4.22),('9650','2013-02-16','12:50:00',4.29),('9650','2013-02-16','12:55:00',4.33),('9650','2013-02-16','13:00:00',4.38),('9650','2013-02-16','13:05:00',4.42),('9650','2013-02-16','13:10:00',4.26),('9650','2013-02-16','13:15:00',3.9),('9650','2013-02-16','13:20:00',1.09),('9650','2013-02-16','13:25:00',2.72),('9650','2013-02-16','13:30:00',4.29),('9650','2013-02-16','13:35:00',2),('9650','2013-02-16','13:40:00',4),('9650','2013-02-16','13:45:00',3.71),('9650','2013-02-16','13:50:00',3.86),('9650','2013-02-16','13:55:00',3.1),('9650','2013-02-16','14:00:00',1.08),('9650','2013-02-16','14:05:00',1.26),('9650','2013-02-16','14:10:00',4.02),('9650','2013-02-16','14:15:00',3.34),('9650','2013-02-16','14:20:00',1.98),('9650','2013-02-16','14:25:00',2.56),('9650','2013-02-16','14:30:00',3.8),('9650','2013-02-16','14:35:00',3.8),('9650','2013-02-16','14:40:00',2.05),('9650','2013-02-16','14:45:00',1.1),('9650','2013-02-16','14:50:00',1.17),('9650','2013-02-16','14:55:00',1.26),('9650','2013-02-16','15:00:00',2.93),('9650','2013-02-16','15:05:00',3.4),('9650','2013-02-16','15:10:00',3.62),('9650','2013-02-16','15:15:00',3.51),('9650','2013-02-16','15:20:00',3.41),('9650','2013-02-16','15:25:00',3.12),('9650','2013-02-16','15:30:00',2.87),('9650','2013-02-16','15:35:00',2.92),('9650','2013-02-16','15:40:00',2.96),('9650','2013-02-16','15:45:00',2.8),('9650','2013-02-16','15:50:00',2.73),('9650','2013-02-16','15:55:00',2.64),('9650','2013-02-16','16:00:00',2.5),('9650','2013-02-16','16:05:00',2.37),('9650','2013-02-16','16:15:00',1.04),('9650','2013-02-16','16:20:00',1.8),('9650','2013-02-16','16:25:00',2.29),('9650','2013-02-16','16:30:00',2.18),('9650','2013-02-16','16:35:00',1.53),('9650','2013-02-15','09:35:00',1.09),('9650','2013-02-15','09:40:00',1.15),('9650','2013-02-15','09:45:00',1.21),('9650','2013-02-15','09:50:00',1.34),('9650','2013-02-15','09:55:00',1.42),('9650','2013-02-15','10:00:00',1.52),('9650','2013-02-15','10:05:00',1.62),('9650','2013-02-15','10:10:00',1.76),('9650','2013-02-15','10:15:00',1.87),('9650','2013-02-15','10:20:00',1.99),('9650','2013-02-15','10:25:00',2.13),('9650','2013-02-15','10:30:00',2.22),('9650','2013-02-15','10:35:00',2.35),('9650','2013-02-15','10:40:00',2.4),('9650','2013-02-15','10:45:00',2.72),('9650','2013-02-15','10:50:00',2.66),('9650','2013-02-15','10:55:00',2.75),('9650','2013-02-15','11:00:00',2.91),('9650','2013-02-15','11:05:00',2.88),('9650','2013-02-15','11:10:00',2.91),('9650','2013-02-15','11:15:00',2.9),('9650','2013-02-15','11:20:00',3.15),('9650','2013-02-15','11:25:00',3),('9650','2013-02-15','11:30:00',3.4),('9650','2013-02-15','11:35:00',3.49),('9650','2013-02-15','11:40:00',3.56),('9650','2013-02-15','11:45:00',3.65),('9650','2013-02-15','11:50:00',3.75),('9650','2013-02-15','11:55:00',3.82),('9650','2013-02-15','12:00:00',3.87),('9650','2013-02-15','12:05:00',3.94),('9650','2013-02-15','12:10:00',3.98),('9650','2013-02-15','12:15:00',4.03),('9650','2013-02-15','12:20:00',4.08),('9650','2013-02-15','12:25:00',4.13),('9650','2013-02-15','12:30:00',4.19),('9650','2013-02-15','12:35:00',4.26),('9650','2013-02-15','12:40:00',4.28),('9650','2013-02-15','12:45:00',4.35),('9650','2013-02-15','12:50:00',4.41),('9650','2013-02-15','12:55:00',4.4),('9650','2013-02-15','13:00:00',4.44),('9650','2013-02-15','13:05:00',4.45),('9650','2013-02-15','13:10:00',4.47),('9650','2013-02-15','13:15:00',4.5),('9650','2013-02-15','13:20:00',4.39),('9650','2013-02-15','13:25:00',4.39),('9650','2013-02-15','13:30:00',4.34),('9650','2013-02-15','13:35:00',4.27),('9650','2013-02-15','13:40:00',4.2),('9650','2013-02-15','13:45:00',4.18),('9650','2013-02-15','13:50:00',4.27),('9650','2013-02-15','13:55:00',4.14),('9650','2013-02-15','14:00:00',4.14),('9650','2013-02-15','14:05:00',4.11),('9650','2013-02-15','14:10:00',3.98),('9650','2013-02-15','14:15:00',4.1),('9650','2013-02-15','14:20:00',3.81),('9650','2013-02-15','14:25:00',1.63),('9650','2013-02-15','14:30:00',1.42),('9650','2013-02-15','14:35:00',1.45),('9650','2013-02-15','14:40:00',1.47),('9650','2013-02-15','14:45:00',1.65),('9650','2013-02-15','14:50:00',1.63),('9650','2013-02-15','14:55:00',1.77),('9650','2013-02-15','15:00:00',1.36),('9650','2013-02-15','15:05:00',1.41),('9650','2013-02-15','15:10:00',1.49),('9650','2013-02-15','15:15:00',1.71),('9650','2013-02-15','15:20:00',1.91),('9650','2013-02-15','15:25:00',1.97),('9650','2013-02-15','15:30:00',3.36),('9650','2013-02-15','15:35:00',3.38),('9650','2013-02-15','15:40:00',3.2),('9650','2013-02-15','15:45:00',3.3),('9650','2013-02-15','15:50:00',3.37),('9650','2013-02-15','15:55:00',2.57),('9650','2013-02-15','16:00:00',1.8),('9650','2013-02-15','16:05:00',2.66),('9650','2013-02-15','16:10:00',1.6),('9650','2013-02-15','16:15:00',1.12),('9650','2013-02-15','16:20:00',1.42),('9650','2013-02-15','16:25:00',1.11),('9650','2013-02-14','09:10:00',1.02),('9650','2013-02-14','09:15:00',1.31),('9650','2013-02-14','09:20:00',1.85),('9650','2013-02-14','09:25:00',1.94),('9650','2013-02-14','09:30:00',1.35),('9650','2013-02-14','09:35:00',1.16),('9650','2013-02-14','09:40:00',1.09),('9650','2013-02-14','09:45:00',1.09),('9650','2013-02-14','09:50:00',1.22),('9650','2013-02-14','09:55:00',1.5),('9650','2013-02-14','10:00:00',1.86),('9650','2013-02-14','10:05:00',1.89),('9650','2013-02-14','10:10:00',1.69),('9650','2013-02-14','10:15:00',1.7),('9650','2013-02-14','10:20:00',1.94),('9650','2013-02-14','10:25:00',2.26),('9650','2013-02-14','10:30:00',2.06),('9650','2013-02-14','10:35:00',2.75),('9650','2013-02-14','10:40:00',2.79),('9650','2013-02-14','10:45:00',3.05),('9650','2013-02-14','10:50:00',3),('9650','2013-02-14','10:55:00',2.3),('9650','2013-02-14','11:00:00',2.28),('9650','2013-02-14','11:05:00',2.33),('9650','2013-02-14','11:10:00',2.24),('9650','2013-02-14','11:15:00',2.9),('9650','2013-02-14','11:20:00',3.27),('9650','2013-02-14','11:25:00',3.32),('9650','2013-02-14','11:30:00',3.44),('9650','2013-02-14','11:35:00',2.83),('9650','2013-02-14','11:40:00',2.14),('9650','2013-02-14','11:45:00',2.74),('9650','2013-02-14','11:50:00',4.47),('9650','2013-02-14','11:55:00',3.91),('9650','2013-02-14','12:00:00',3.6),('9650','2013-02-14','12:05:00',3.41),('9650','2013-02-14','12:10:00',3.53),('9650','2013-02-14','12:15:00',3.96),('9650','2013-02-14','12:20:00',4.68),('9650','2013-02-14','12:25:00',4.25),('9650','2013-02-14','12:30:00',4.35),('9650','2013-02-14','12:35:00',4.34),('9650','2013-02-14','12:40:00',4.3),('9650','2013-02-14','12:45:00',4.35),('9650','2013-02-14','12:50:00',4.35),('9650','2013-02-14','12:55:00',4.42),('9650','2013-02-14','13:00:00',4.41),('9650','2013-02-14','13:05:00',4.43),('9650','2013-02-14','13:10:00',4.54),('9650','2013-02-14','13:15:00',4.59),('9650','2013-02-14','13:20:00',4.3),('9650','2013-02-14','13:25:00',4.1),('9650','2013-02-14','13:30:00',3.16),('9650','2013-02-14','13:35:00',3.34),('9650','2013-02-14','13:40:00',4.29),('9650','2013-02-14','13:45:00',3.45),('9650','2013-02-14','13:50:00',3.4),('9650','2013-02-14','13:55:00',3.62),('9650','2013-02-14','14:00:00',2.91),('9650','2013-02-14','14:05:00',4.46),('9650','2013-02-14','14:10:00',5.03),('9650','2013-02-14','14:15:00',3.25),('9650','2013-02-14','14:20:00',3.39),('9650','2013-02-14','14:25:00',2.59),('9650','2013-02-14','14:30:00',2.39),('9650','2013-02-14','14:35:00',3.61),('9650','2013-02-14','14:40:00',3.92),('9650','2013-02-14','14:45:00',3.06),('9650','2013-02-14','14:50:00',1.97),('9650','2013-02-14','14:55:00',1.89),('9650','2013-02-14','15:00:00',2.66),('9650','2013-02-14','15:05:00',1.91),('9650','2013-02-14','15:10:00',2.05),('9650','2013-02-14','15:15:00',2.33),('9650','2013-02-14','15:20:00',1.91),('9650','2013-02-14','15:25:00',2.31),('9650','2013-02-14','15:30:00',2.48),('9650','2013-02-14','15:35:00',2.1),('9650','2013-02-14','15:40:00',2.12),('9650','2013-02-14','15:45:00',1.99),('9650','2013-02-14','15:50:00',1.54),('9650','2013-02-14','15:55:00',1.42),('9650','2013-02-14','16:00:00',1.33),('9650','2013-02-14','16:05:00',1.26),('9650','2013-02-14','16:10:00',1.15),('9650','2013-02-14','16:15:00',1.02),('9650','2013-02-13','09:50:00',1.07),('9650','2013-02-13','09:55:00',1.17),('9650','2013-02-13','10:00:00',1.3),('9650','2013-02-13','10:05:00',1.43),('9650','2013-02-13','10:10:00',1.55),('9650','2013-02-13','10:15:00',1.68),('9650','2013-02-13','10:20:00',1.81),('9650','2013-02-13','10:25:00',1.93),('9650','2013-02-13','10:30:00',2.05),('9650','2013-02-13','10:35:00',2.18),('9650','2013-02-13','10:40:00',2.29),('9650','2013-02-13','10:45:00',2.42),('9650','2013-02-13','10:50:00',2.56),('9650','2013-02-13','10:55:00',2.67),('9650','2013-02-13','11:00:00',2.78),('9650','2013-02-13','11:05:00',2.87),('9650','2013-02-13','11:10:00',2.98),('9650','2013-02-13','11:15:00',3.07),('9650','2013-02-13','11:20:00',3.16),('9650','2013-02-13','11:25:00',3.26),('9650','2013-02-13','11:30:00',3.36),('9650','2013-02-13','11:35:00',3.43),('9650','2013-02-13','11:40:00',3.53),('9650','2013-02-13','11:45:00',3.6),('9650','2013-02-13','11:50:00',3.67),('9650','2013-02-13','11:55:00',3.77),('9650','2013-02-13','12:00:00',3.83),('9650','2013-02-13','12:05:00',3.9),('9650','2013-02-13','12:10:00',3.94),('9650','2013-02-13','12:15:00',4.01),('9650','2013-02-13','12:20:00',4.05),('9650','2013-02-13','12:25:00',4.11),('9650','2013-02-13','12:30:00',4.16),('9650','2013-02-13','12:35:00',4.22),('9650','2013-02-13','12:40:00',4.26),('9650','2013-02-13','12:45:00',4.29),('9650','2013-02-13','12:50:00',4.31),('9650','2013-02-13','12:55:00',4.35),('9650','2013-02-13','13:00:00',4.38),('9650','2013-02-13','13:05:00',4.41),('9650','2013-02-13','13:10:00',4.43),('9650','2013-02-13','13:15:00',4.47),('9650','2013-02-13','13:20:00',4.43),('9650','2013-02-13','13:25:00',4.38),('9650','2013-02-13','13:30:00',4.36),('9650','2013-02-13','13:35:00',4.26),('9650','2013-02-13','13:40:00',4.13),('9650','2013-02-13','13:45:00',4.09),('9650','2013-02-13','13:50:00',4.04),('9650','2013-02-13','13:55:00',4.01),('9650','2013-02-13','14:00:00',4.02),('9650','2013-02-13','14:05:00',4.01),('9650','2013-02-13','14:10:00',3.98),('9650','2013-02-13','14:15:00',3.93),('9650','2013-02-13','14:20:00',3.85),('9650','2013-02-13','14:25:00',3.72),('9650','2013-02-13','14:30:00',3.65),('9650','2013-02-13','14:35:00',3.61),('9650','2013-02-13','14:40:00',3.53),('9650','2013-02-13','14:45:00',3.42),('9650','2013-02-13','14:50:00',3.38),('9650','2013-02-13','14:55:00',3.33),('9650','2013-02-13','15:00:00',3.24),('9650','2013-02-13','15:05:00',3.1),('9650','2013-02-13','15:10:00',2.93),('9650','2013-02-13','15:15:00',2.84),('9650','2013-02-13','15:20:00',2.74),('9650','2013-02-13','15:25:00',2.66),('9650','2013-02-13','15:30:00',2.68),('9650','2013-02-13','15:35:00',2.53),('9650','2013-02-13','15:40:00',2.48),('9650','2013-02-13','15:45:00',2.43),('9650','2013-02-13','15:50:00',2.42),('9650','2013-02-13','15:55:00',2.32),('9650','2013-02-13','16:00:00',2.22),('9650','2013-02-13','16:05:00',2.13),('9650','2013-02-13','16:10:00',2.02),('9650','2013-02-13','16:15:00',1.96),('9650','2013-02-13','16:20:00',1.85),('9650','2013-02-13','16:25:00',1.72),('9650','2013-02-13','16:30:00',1.53),('9650','2013-02-13','16:35:00',1.37),('9650','2013-02-13','16:40:00',1.11),('9650','2013-02-12','08:40:00',1.01),('9650','2013-02-12','08:45:00',1.1),('9650','2013-02-12','08:50:00',1.16),('9650','2013-02-12','08:55:00',1.23),('9650','2013-02-12','09:00:00',1.29),('9650','2013-02-12','09:05:00',1.34),('9650','2013-02-12','09:10:00',1.34),('9650','2013-02-12','09:15:00',1.32),('9650','2013-02-12','09:20:00',1.32),('9650','2013-02-12','09:25:00',1.34),('9650','2013-02-12','09:30:00',1.32),('9650','2013-02-12','09:35:00',1.44),('9650','2013-02-12','09:40:00',1.51),('9650','2013-02-12','09:45:00',1.6),('9650','2013-02-12','09:50:00',1.67),('9650','2013-02-12','09:55:00',1.67),('9650','2013-02-12','10:00:00',1.71),('9650','2013-02-12','10:05:00',1.83),('9650','2013-02-12','10:10:00',1.98),('9650','2013-02-12','10:15:00',2.1),('9650','2013-02-12','10:20:00',2.25),('9650','2013-02-12','10:25:00',2.38),('9650','2013-02-12','10:30:00',2.57),('9650','2013-02-12','10:35:00',2.69),('9650','2013-02-12','10:40:00',2.76),('9650','2013-02-12','10:45:00',2.98),('9650','2013-02-12','10:50:00',3.17),('9650','2013-02-12','10:55:00',3.26),('9650','2013-02-12','11:00:00',3.32),('9650','2013-02-12','11:05:00',3.47),('9650','2013-02-12','11:10:00',3.38),('9650','2013-02-12','11:15:00',3.52),('9650','2013-02-12','11:20:00',3.6),('9650','2013-02-12','11:25:00',3.28),('9650','2013-02-12','11:30:00',3.72),('9650','2013-02-12','11:35:00',2.5),('9650','2013-02-12','11:40:00',2.39),('9650','2013-02-12','11:45:00',2.13),('9650','2013-02-12','11:50:00',2.79),('9650','2013-02-12','11:55:00',2.15),('9650','2013-02-12','12:00:00',1.82),('9650','2013-02-12','12:05:00',2.19),('9650','2013-02-12','12:10:00',3.27),('9650','2013-02-12','12:15:00',2.99),('9650','2013-02-12','12:20:00',3.58),('9650','2013-02-12','12:25:00',2.9),('9650','2013-02-12','12:30:00',1.73),('9650','2013-02-12','12:35:00',2.23),('9650','2013-02-12','12:40:00',1.66),('9650','2013-02-12','12:45:00',3.29),('9650','2013-02-12','12:50:00',3.67),('9650','2013-02-12','12:55:00',3.53),('9650','2013-02-12','13:00:00',3.58),('9650','2013-02-12','13:05:00',2.65),('9650','2013-02-12','13:10:00',3.85),('9650','2013-02-12','13:15:00',2.82),('9650','2013-02-12','13:20:00',4.68),('9650','2013-02-12','13:25:00',4.7),('9650','2013-02-12','13:30:00',4.77),('9650','2013-02-12','13:35:00',4.77),('9650','2013-02-12','13:40:00',4.41),('9650','2013-02-12','13:45:00',3.87),('9650','2013-02-12','13:50:00',3.63),('9650','2013-02-12','13:55:00',3.76),('9650','2013-02-12','14:00:00',4.07),('9650','2013-02-12','14:05:00',4.43),('9650','2013-02-12','14:10:00',4.01),('9650','2013-02-12','14:15:00',3.85),('9650','2013-02-12','14:20:00',3.75),('9650','2013-02-12','14:25:00',3.33),('9650','2013-02-12','14:30:00',3.63),('9650','2013-02-12','14:35:00',3.68),('9650','2013-02-12','14:40:00',3.66),('9650','2013-02-12','14:45:00',3.37),('9650','2013-02-12','14:50:00',3.45),('9650','2013-02-12','14:55:00',3.34),('9650','2013-02-12','15:00:00',3.25),('9650','2013-02-12','15:05:00',3.06),('9650','2013-02-12','15:10:00',2.88),('9650','2013-02-12','15:15:00',2.79),('9650','2013-02-12','15:20:00',2.73),('9650','2013-02-12','15:25:00',2.74),('9650','2013-02-12','15:30:00',2.61),('9650','2013-02-12','15:35:00',2.58),('9650','2013-02-12','15:40:00',2.56),('9650','2013-02-12','15:45:00',2.5),('9650','2013-02-12','15:50:00',2.38),('9650','2013-02-12','15:55:00',2.32),('9650','2013-02-12','16:00:00',2.25),('9650','2013-02-12','16:05:00',2.14),('9650','2013-02-12','16:10:00',2.08),('9650','2013-02-12','16:15:00',2),('9650','2013-02-12','16:20:00',1.86),('9650','2013-02-12','16:25:00',1.67),('9650','2013-02-12','16:30:00',1.53),('9650','2013-02-12','16:35:00',1.37),('9650','2013-02-12','16:40:00',1.12),('9650','2013-02-10','09:30:00',1.16),('9650','2013-02-10','09:35:00',1.15),('9650','2013-02-10','10:10:00',1.08),('9650','2013-02-10','10:15:00',1.48),('9650','2013-02-10','10:20:00',1.82),('9650','2013-02-10','10:25:00',1.87),('9650','2013-02-10','10:30:00',1.73),('9650','2013-02-10','10:35:00',2.08),('9650','2013-02-10','10:40:00',1.9),('9650','2013-02-10','10:45:00',1.45),('9650','2013-02-10','10:50:00',1.18),('9650','2013-02-10','10:55:00',1.05),('9650','2013-02-10','11:00:00',1.48),('9650','2013-02-10','11:05:00',1.75),('9650','2013-02-10','11:10:00',2.13),('9650','2013-02-10','11:15:00',2.4),('9650','2013-02-10','11:20:00',1.94),('9650','2013-02-10','11:25:00',1.38),('9650','2013-02-10','11:40:00',1.3),('9650','2013-02-10','11:45:00',2.09),('9650','2013-02-10','11:50:00',1.59),('9650','2013-02-10','12:40:00',1.32),('9650','2013-02-10','12:45:00',2.11),('9650','2013-02-10','12:50:00',1.15),('9650','2013-02-10','12:55:00',1.13),('9650','2013-02-10','13:55:00',1.5),('9650','2013-02-10','14:00:00',1.73),('9650','2013-02-10','14:05:00',1.83),('9650','2013-02-10','14:10:00',2.09),('9650','2013-02-10','14:15:00',1.69),('9650','2013-02-10','14:20:00',1.71),('9650','2013-02-10','14:25:00',2.46),('9650','2013-02-10','14:30:00',3.34),('9650','2013-02-10','14:35:00',1.93),('9650','2013-02-10','14:40:00',2.86),('9650','2013-02-10','14:45:00',2.37),('9650','2013-02-10','14:50:00',1.59),('9650','2013-02-10','14:55:00',1.25),('9650','2013-02-10','15:00:00',1.05),('9650','2013-02-10','15:05:00',1.34),('9650','2013-02-10','15:10:00',1.63),('9650','2013-02-10','15:15:00',1.1),('9650','2013-02-10','15:20:00',1.26),('9650','2013-02-10','15:25:00',1.19),('9650','2013-02-10','15:30:00',1.03),('9650','2013-02-10','15:35:00',1.12),('9650','2013-02-10','15:40:00',1.04),('9650','2013-02-10','15:45:00',1.24),('9650','2013-02-10','15:50:00',1.19),('9650','2014-03-21','07:35:00',1.05),('9650','2014-03-21','07:40:00',1.33),('9650','2014-03-21','07:45:00',1.32),('9650','2014-03-21','07:50:00',1.22),('9650','2014-03-21','08:20:00',1.16),('9650','2014-03-21','08:25:00',1.27),('9650','2014-03-21','08:30:00',1.34),('9650','2014-03-21','08:35:00',1.3),('9650','2014-03-21','08:40:00',2.04),('9650','2014-03-21','08:45:00',2.06),('9650','2014-03-21','08:50:00',1.98),('9650','2014-03-21','08:55:00',2.18),('9650','2014-03-21','09:00:00',2.41),('9650','2014-03-21','09:05:00',2.04),('9650','2014-03-21','09:10:00',2.18),('9650','2014-03-21','09:15:00',1.99),('9650','2014-03-21','09:20:00',2.09),('9650','2014-03-21','09:25:00',2.31),('9650','2014-03-21','09:30:00',2.67),('9650','2014-03-21','09:35:00',1.74),('9650','2014-03-21','09:40:00',2.25),('9650','2014-03-21','09:45:00',2.89),('9650','2014-03-21','09:50:00',3.04),('9650','2014-03-21','09:55:00',3.18),('9650','2014-03-21','10:00:00',3.57),('9650','2014-03-21','10:05:00',3.3),('9650','2014-03-21','10:10:00',3.05),('9650','2014-03-21','10:15:00',2.79),('9650','2014-03-21','10:20:00',1.86),('9650','2014-03-21','10:25:00',1.58),('9650','2014-03-21','10:30:00',1.7),('9650','2014-03-21','10:35:00',2.46),('9650','2014-03-21','10:40:00',3.14),('9650','2014-03-21','10:45:00',3.99),('9650','2014-03-21','10:50:00',3.3),('9650','2014-03-21','10:55:00',2.22),('9650','2014-03-21','11:00:00',1.92),('9650','2014-03-21','11:05:00',1.86),('9650','2014-03-21','11:10:00',2.29),('9650','2014-03-21','11:15:00',2.9),('9650','2014-03-21','11:20:00',5.35),('9650','2014-03-21','11:25:00',6.03),('9650','2014-03-21','11:30:00',4.91),('9650','2014-03-21','11:35:00',2.62),('9650','2014-03-21','11:40:00',4.52),('9650','2014-03-21','11:45:00',2.4),('9650','2014-03-21','11:50:00',4.5),('9650','2014-03-21','11:55:00',6.15),('9650','2014-03-21','12:00:00',3.12),('9650','2014-03-21','12:05:00',2.43),('9650','2014-03-21','12:10:00',2.16),('9650','2014-03-21','12:15:00',4.07),('9650','2014-03-21','12:20:00',5.35),('9650','2014-03-21','12:25:00',3.68),('9650','2014-03-21','12:30:00',3.14),('9650','2014-03-21','12:35:00',3.41),('9650','2014-03-21','12:40:00',5.44),('9650','2014-03-21','12:45:00',5.65),('9650','2014-03-21','12:50:00',3.99),('9650','2014-03-21','12:55:00',3.21),('9650','2014-03-21','13:00:00',2.53),('9650','2014-03-21','13:05:00',4.61),('9650','2014-03-21','13:10:00',5.94),('9650','2014-03-21','13:15:00',4.36),('9650','2014-03-21','13:20:00',5.69),('9650','2014-03-21','13:25:00',5.41),('9650','2014-03-21','13:30:00',3.89),('9650','2014-03-21','13:35:00',4.84),('9650','2014-03-21','13:40:00',5.5),('9650','2014-03-21','13:45:00',5.81),('9650','2014-03-21','13:50:00',5.02),('9650','2014-03-21','13:55:00',3.62),('9650','2014-03-21','14:00:00',5.01),('9650','2014-03-21','14:05:00',3.8),('9650','2014-03-21','14:10:00',5.21),('9650','2014-03-21','14:15:00',4.1),('9650','2014-03-21','14:20:00',5.36),('9650','2014-03-21','14:25:00',5.16),('9650','2014-03-21','14:30:00',5.17),('9650','2014-03-21','14:35:00',5.11),('9650','2014-03-21','14:40:00',5.01),('9650','2014-03-21','14:45:00',4.82),('9650','2014-03-21','14:50:00',4.71),('9650','2014-03-21','14:55:00',4.57),('9650','2014-03-21','15:00:00',4.35),('9650','2014-03-21','15:05:00',4.48),('9650','2014-03-21','15:10:00',4.2),('9650','2014-03-21','15:15:00',4.37),('9650','2014-03-21','15:20:00',4.35),('9650','2014-03-21','15:25:00',3.49),('9650','2014-03-21','15:30:00',2.45),('9650','2014-03-21','15:35:00',4.04),('9650','2014-03-21','15:40:00',4.63),('9650','2014-03-21','15:45:00',4.65),('9650','2014-03-21','15:50:00',4.84),('9650','2014-03-21','15:55:00',4.37),('9650','2014-03-21','16:00:00',4.09),('9650','2014-03-21','16:05:00',3.69),('9650','2014-03-21','16:10:00',3.45),('9650','2014-03-21','16:15:00',3.06),('9650','2014-03-21','16:20:00',2.82),('9650','2014-03-21','16:25:00',2.87),('9650','2014-03-21','16:30:00',1.75),('9650','2014-03-21','16:35:00',1.05),('9650','2014-03-21','16:40:00',1.14),('9650','2014-03-21','16:45:00',1.21),('9650','2014-03-21','16:50:00',1.72),('9650','2014-03-21','16:55:00',1.91),('9650','2014-03-21','17:00:00',2.08),('9650','2014-03-21','17:05:00',1.31),('9650','2014-03-21','17:30:00',1.05),('9650','2013-02-09','09:15:00',1),('9650','2013-02-09','10:00:00',1.15),('9650','2013-02-09','10:05:00',1.31),('9650','2013-02-09','10:10:00',1.39),('9650','2013-02-09','10:15:00',1.55),('9650','2013-02-09','10:20:00',1.67),('9650','2013-02-09','10:25:00',1.8),('9650','2013-02-09','10:30:00',1.94),('9650','2013-02-09','10:35:00',2.05),('9650','2013-02-09','10:40:00',2.16),('9650','2013-02-09','10:45:00',2.25),('9650','2013-02-09','10:50:00',2.37),('9650','2013-02-09','10:55:00',2.5),('9650','2013-02-09','11:00:00',2.62),('9650','2013-02-09','11:05:00',2.71),('9650','2013-02-09','11:10:00',2.81),('9650','2013-02-09','11:15:00',2.9),('9650','2013-02-09','11:20:00',2.99),('9650','2013-02-09','11:25:00',3.07),('9650','2013-02-09','11:30:00',3.16),('9650','2013-02-09','11:35:00',3.25),('9650','2013-02-09','11:40:00',3.34),('9650','2013-02-09','11:45:00',3.43),('9650','2013-02-09','11:50:00',3.51),('9650','2013-02-09','11:55:00',3.58),('9650','2013-02-09','12:00:00',3.69),('9650','2013-02-09','12:05:00',3.72),('9650','2013-02-09','12:10:00',3.79),('9650','2013-02-09','12:15:00',3.88),('9650','2013-02-09','12:20:00',3.93),('9650','2013-02-09','12:25:00',3.99),('9650','2013-02-09','12:30:00',4.03),('9650','2013-02-09','12:35:00',4.09),('9650','2013-02-09','12:40:00',4.11),('9650','2013-02-09','12:45:00',4.14),('9650','2013-02-09','12:50:00',4.17),('9650','2013-02-09','12:55:00',4.23),('9650','2013-02-09','13:00:00',4.24),('9650','2013-02-09','13:05:00',4.21),('9650','2013-02-09','13:10:00',4.25),('9650','2013-02-09','13:15:00',4.25),('9650','2013-02-09','13:20:00',4.27),('9650','2013-02-09','13:25:00',4.28),('9650','2013-02-09','13:30:00',4.18),('9650','2013-02-09','13:35:00',4.1),('9650','2013-02-09','13:40:00',3.98),('9650','2013-02-09','13:45:00',3.83),('9650','2013-02-09','13:50:00',3.88),('9650','2013-02-09','13:55:00',3.84),('9650','2013-02-09','14:00:00',3.77),('9650','2013-02-09','14:05:00',3.75),('9650','2013-02-09','14:10:00',3.73),('9650','2013-02-09','14:15:00',3.71),('9650','2013-02-09','14:20:00',3.72),('9650','2013-02-09','14:25:00',3.61),('9650','2013-02-09','14:30:00',3.53),('9650','2013-02-09','14:35:00',3.23),('9650','2013-02-09','14:40:00',3.44),('9650','2013-02-09','14:45:00',3.32),('9650','2013-02-09','14:50:00',3.24),('9650','2013-02-09','14:55:00',2.81),('9650','2013-02-09','15:00:00',2),('9650','2013-02-09','15:05:00',2.4),('9650','2013-02-09','15:10:00',2.8),('9650','2013-02-09','15:15:00',2.27),('9650','2013-02-09','15:20:00',2.73),('9650','2013-02-09','15:25:00',3.16),('9650','2013-02-09','15:30:00',2.51),('9650','2013-02-09','15:35:00',2.24),('9650','2013-02-09','15:40:00',1.81),('9650','2013-02-09','15:45:00',1.02),('9650','2013-02-09','16:20:00',1.02),('9650','2013-02-09','16:25:00',1.52),('9650','2013-02-09','16:30:00',1.41),('9650','2013-02-09','16:35:00',1.36),('9650','2013-02-08','09:15:00',1.03),('9650','2013-02-08','09:20:00',1.02),('9650','2013-02-08','09:25:00',1.19),('9650','2013-02-08','09:30:00',1.42),('9650','2013-02-08','09:35:00',1.41),('9650','2013-02-08','09:40:00',1.15),('9650','2013-02-08','10:30:00',1.01),('9650','2013-02-08','10:35:00',1.1),('9650','2013-02-08','10:40:00',1.25),('9650','2013-02-08','10:45:00',1.45),('9650','2013-02-08','10:50:00',1.65),('9650','2013-02-08','10:55:00',1.79),('9650','2013-02-08','11:00:00',1.91),('9650','2013-02-08','11:05:00',1.98),('9650','2013-02-08','11:10:00',2.04),('9650','2013-02-08','11:15:00',2.12),('9650','2013-02-08','11:20:00',2.17),('9650','2013-02-08','11:25:00',2.17),('9650','2013-02-08','11:30:00',2.19),('9650','2013-02-08','11:35:00',2.14),('9650','2013-02-08','11:40:00',2.09),('9650','2013-02-08','11:45:00',2.1),('9650','2013-02-08','11:50:00',2.08),('9650','2013-02-08','11:55:00',2.03),('9650','2013-02-08','12:00:00',2.06),('9650','2013-02-08','12:05:00',2.07),('9650','2013-02-08','12:10:00',2.01),('9650','2013-02-08','12:15:00',1.99),('9650','2013-02-08','12:20:00',2.01),('9650','2013-02-08','12:25:00',2.03),('9650','2013-02-08','12:30:00',2.08),('9650','2013-02-08','12:35:00',2.18),('9650','2013-02-08','12:40:00',2.22),('9650','2013-02-08','12:45:00',2.23),('9650','2013-02-08','12:50:00',2.26),('9650','2013-02-08','12:55:00',2.24),('9650','2013-02-08','13:00:00',2.38),('9650','2013-02-08','13:05:00',2.66),('9650','2013-02-08','13:10:00',2.89),('9650','2013-02-08','13:15:00',3.05),('9650','2013-02-08','13:20:00',3.31),('9650','2013-02-08','13:25:00',3.41),('9650','2013-02-08','13:30:00',3.69),('9650','2013-02-08','13:35:00',3.75),('9650','2013-02-08','13:40:00',3.75),('9650','2013-02-08','13:45:00',3.97),('9650','2013-02-08','13:50:00',4.12),('9650','2013-02-08','13:55:00',4.21),('9650','2013-02-08','14:00:00',4.02),('9650','2013-02-08','14:05:00',3.73),('9650','2013-02-08','14:15:00',1.2),('9650','2013-02-08','14:20:00',4.57),('9650','2013-02-08','14:25:00',4.57),('9650','2013-02-08','14:30:00',4.03),('9650','2013-02-08','14:35:00',3.68),('9650','2013-02-08','14:40:00',3.39),('9650','2013-02-08','14:45:00',3.22),('9650','2013-02-08','14:50:00',3.12),('9650','2013-02-08','14:55:00',3.12),('9650','2013-02-08','15:00:00',3.01),('9650','2013-02-08','15:05:00',2.87),('9650','2013-02-08','15:10:00',2.63),('9650','2013-02-08','15:15:00',2.56),('9650','2013-02-08','15:20:00',2.5),('9650','2013-02-08','15:25:00',2.24),('9650','2013-02-08','15:30:00',2.36),('9650','2013-02-08','15:35:00',2.32),('9650','2013-02-08','15:40:00',2.25),('9650','2013-02-08','15:45:00',2.12),('9650','2013-02-08','15:50:00',2.12),('9650','2013-02-08','15:55:00',1.67),('9650','2013-02-08','16:20:00',1.28),('9650','2013-02-08','16:25:00',1.26),('9650','2013-02-08','16:30:00',1.15),('9650','2013-02-08','16:35:00',1.01),('9650','2013-02-07','09:20:00',1.08),('9650','2013-02-07','09:25:00',1.16),('9650','2013-02-07','09:30:00',1.16),('9650','2013-02-07','09:35:00',1.44),('9650','2013-02-07','09:40:00',1.49),('9650','2013-02-07','09:45:00',1.33),('9650','2013-02-07','09:50:00',1.26),('9650','2013-02-07','09:55:00',1.34),('9650','2013-02-07','10:00:00',1.42),('9650','2013-02-07','10:05:00',1.74),('9650','2013-02-07','10:10:00',1.8),('9650','2013-02-07','10:15:00',1.96),('9650','2013-02-07','10:20:00',2.11),('9650','2013-02-07','10:25:00',1.97),('9650','2013-02-07','10:30:00',2.12),('9650','2013-02-07','10:35:00',1.19),('9650','2013-02-07','10:40:00',1.73),('9650','2013-02-07','10:45:00',2.55),('9650','2013-02-07','10:50:00',2.7),('9650','2013-02-07','10:55:00',2.71),('9650','2013-02-07','11:00:00',2.67),('9650','2013-02-07','11:05:00',2.68),('9650','2013-02-07','11:10:00',2.77),('9650','2013-02-07','11:15:00',2.84),('9650','2013-02-07','11:20:00',2.94),('9650','2013-02-07','11:25:00',3.02),('9650','2013-02-07','11:30:00',3.1),('9650','2013-02-07','11:35:00',3.18),('9650','2013-02-07','11:40:00',3.26),('9650','2013-02-07','11:45:00',3.34),('9650','2013-02-07','11:50:00',3.41),('9650','2013-02-07','11:55:00',3.48),('9650','2013-02-07','12:00:00',3.56),('9650','2013-02-07','12:05:00',3.62),('9650','2013-02-07','12:10:00',3.69),('9650','2013-02-07','12:15:00',3.78),('9650','2013-02-07','12:20:00',3.86),('9650','2013-02-07','12:25:00',3.96),('9650','2013-02-07','12:30:00',3.98),('9650','2013-02-07','12:35:00',4.06),('9650','2013-02-07','12:40:00',4.27),('9650','2013-02-07','12:45:00',4.97),('9650','2013-02-07','12:50:00',2.94),('9650','2013-02-07','12:55:00',3.2),('9650','2013-02-07','13:00:00',3.04),('9650','2013-02-07','13:05:00',2.71),('9650','2013-02-07','13:10:00',2.98),('9650','2013-02-07','13:15:00',2.93),('9650','2013-02-07','13:20:00',3.13),('9650','2013-02-07','13:25:00',2.91),('9650','2013-02-07','13:30:00',2.89),('9650','2013-02-07','13:35:00',3.7),('9650','2013-02-07','13:40:00',2.92),('9650','2013-02-07','13:45:00',2.33),('9650','2013-02-07','13:50:00',2.41),('9650','2013-02-07','13:55:00',2.53),('9650','2013-02-07','14:00:00',2.37),('9650','2013-02-07','14:05:00',2.39),('9650','2013-02-07','14:10:00',2.23),('9650','2013-02-07','14:15:00',2.09),('9650','2013-02-07','14:20:00',2.18),('9650','2013-02-07','14:25:00',2.71),('9650','2013-02-07','14:30:00',3.9),('9650','2013-02-07','14:35:00',3.3),('9650','2013-02-07','14:40:00',5.11),('9650','2013-02-07','14:45:00',3.83),('9650','2013-02-07','14:50:00',3.4),('9650','2013-02-07','14:55:00',3.88),('9650','2013-02-07','15:00:00',3.82),('9650','2013-02-07','15:05:00',4.13),('9650','2013-02-07','15:10:00',3.73),('9650','2013-02-07','15:15:00',3.08),('9650','2013-02-07','15:20:00',2.27),('9650','2013-02-07','15:25:00',2.59),('9650','2013-02-07','15:30:00',2.51),('9650','2013-02-07','15:35:00',2.43),('9650','2013-02-07','15:40:00',2.4),('9650','2013-02-07','15:45:00',2.33),('9650','2013-02-07','15:50:00',2.25),('9650','2013-02-07','15:55:00',2.12),('9650','2013-02-07','16:00:00',2),('9650','2013-02-07','16:05:00',1.89),('9650','2013-02-07','16:10:00',1.85),('9650','2013-02-07','16:15:00',1.49),('9650','2013-02-06','09:35:00',1.02),('9650','2013-02-06','09:40:00',1.06),('9650','2013-02-06','09:45:00',1.16),('9650','2013-02-06','09:50:00',1.18),('9650','2013-02-06','10:35:00',1.37),('9650','2013-02-06','10:40:00',1.49),('9650','2013-02-06','10:45:00',1.37),('9650','2013-02-06','10:50:00',1.12),('9650','2013-02-06','10:55:00',1.62),('9650','2013-02-06','11:00:00',2.22),('9650','2013-02-06','11:05:00',1.69),('9650','2013-02-06','11:10:00',1.41),('9650','2013-02-06','12:20:00',1.72),('9650','2013-02-06','12:25:00',3.68),('9650','2013-02-06','12:30:00',2.84),('9650','2013-02-06','12:35:00',1.54),('9650','2013-02-06','12:40:00',1.09),('9650','2013-02-06','12:45:00',1.39),('9650','2013-02-06','12:50:00',1.58),('9650','2013-02-06','12:55:00',1.21),('9650','2013-02-06','13:00:00',1.04),('9650','2013-02-06','13:05:00',1.18),('9650','2013-02-06','13:10:00',1.36),('9650','2013-02-06','13:15:00',2.79),('9650','2013-02-06','13:20:00',2.33),('9650','2013-02-06','13:25:00',2.28),('9650','2013-02-06','13:30:00',1.74),('9650','2013-02-06','13:35:00',1.46),('9650','2013-02-06','13:40:00',1.63),('9650','2013-02-06','13:45:00',1.66),('9650','2013-02-06','13:50:00',1.75),('9650','2013-02-06','13:55:00',1.99),('9650','2013-02-06','14:00:00',2.37),('9650','2013-02-06','14:05:00',3.18),('9650','2013-02-06','14:10:00',4.66),('9650','2013-02-06','14:15:00',4.23),('9650','2013-02-06','14:20:00',3.74),('9650','2013-02-06','14:25:00',1.96),('9650','2013-02-06','14:30:00',1.71),('9650','2013-02-06','14:35:00',2.92),('9650','2013-02-06','14:40:00',3.06),('9650','2013-02-06','14:45:00',2.85),('9650','2013-02-06','14:50:00',1.99),('9650','2013-02-06','14:55:00',2.34),('9650','2013-02-06','15:00:00',3.08),('9650','2013-02-06','15:05:00',3.63),('9650','2013-02-06','15:10:00',3.58),('9650','2013-02-06','15:15:00',2.74),('9650','2013-02-06','15:20:00',1.63),('9650','2013-02-06','15:25:00',1.96),('9650','2013-02-06','15:30:00',1.2),('9650','2013-02-06','15:35:00',1.4),('9650','2013-02-06','15:40:00',1.17),('9650','2013-02-06','15:50:00',1.1),('9650','2013-02-06','15:55:00',1),('9650','2013-02-05','08:40:00',1.03),('9650','2013-02-05','08:45:00',1.05),('9650','2013-02-05','08:50:00',1.18),('9650','2013-02-05','08:55:00',1.22),('9650','2013-02-05','09:00:00',1.28),('9650','2013-02-05','09:05:00',1.21),('9650','2013-02-05','09:10:00',1.24),('9650','2013-02-05','09:15:00',1.33),('9650','2013-02-05','09:20:00',1.52),('9650','2013-02-05','09:25:00',1.6),('9650','2013-02-05','09:30:00',1.72),('9650','2013-02-05','09:35:00',1.66),('9650','2013-02-05','09:40:00',1.78),('9650','2013-02-05','09:45:00',1.77),('9650','2013-02-05','09:50:00',1.82),('9650','2013-02-05','09:55:00',1.93),('9650','2013-02-05','10:00:00',1.91),('9650','2013-02-05','10:05:00',2.03),('9650','2013-02-05','10:10:00',1.99),('9650','2013-02-05','10:15:00',1.96),('9650','2013-02-05','10:20:00',1.9),('9650','2013-02-05','10:25:00',2.08),('9650','2013-02-05','10:30:00',2.03),('9650','2013-02-05','10:35:00',2.29),('9650','2013-02-05','10:40:00',1.86),('9650','2013-02-05','10:45:00',1.76),('9650','2013-02-05','10:50:00',2.38),('9650','2013-02-05','10:55:00',2.71),('9650','2013-02-05','11:00:00',2.51),('9650','2013-02-05','11:05:00',2.29),('9650','2013-02-05','11:10:00',2.42),('9650','2013-02-05','11:15:00',2.31),('9650','2013-02-05','11:20:00',2.56),('9650','2013-02-05','11:25:00',3.48),('9650','2013-02-05','11:30:00',2.32),('9650','2013-02-05','11:35:00',2.28),('9650','2013-02-05','11:40:00',2.6),('9650','2013-02-05','11:45:00',2.66),('9650','2013-02-05','11:50:00',2.78),('9650','2013-02-05','11:55:00',2.64),('9650','2013-02-05','12:00:00',2.31),('9650','2013-02-05','12:05:00',1.79),('9650','2013-02-05','12:10:00',1.41),('9650','2013-02-05','12:15:00',2.05),('9650','2013-02-05','12:20:00',1.94),('9650','2013-02-05','12:25:00',1.84),('9650','2013-02-05','12:30:00',1.59),('9650','2013-02-05','12:35:00',1.41),('9650','2013-02-05','12:40:00',1.27),('9650','2013-02-05','12:45:00',1.3),('9650','2013-02-05','12:50:00',1.28),('9650','2013-02-05','12:55:00',1.26),('9650','2013-02-05','13:00:00',1.13),('9650','2013-02-05','13:05:00',1.19),('9650','2013-02-05','13:10:00',1.36),('9650','2013-02-05','13:15:00',1.62),('9650','2013-02-05','13:20:00',1.79),('9650','2013-02-05','13:25:00',2.03),('9650','2013-02-05','13:30:00',2.33),('9650','2013-02-05','13:35:00',2.44),('9650','2013-02-05','13:40:00',2.03),('9650','2013-02-05','13:45:00',2.08),('9650','2013-02-05','13:50:00',2.71),('9650','2013-02-05','13:55:00',2.21),('9650','2013-02-05','14:00:00',2.39),('9650','2013-02-05','14:05:00',2.21),('9650','2013-02-05','14:10:00',1.2),('9650','2013-02-05','14:30:00',2.82),('9650','2013-02-05','14:35:00',3.28),('9650','2013-02-05','14:40:00',2.29),('9650','2013-02-05','14:45:00',1.02),('9650','2013-02-05','15:20:00',1.02),('9650','2013-02-05','15:25:00',1.62),('9650','2013-02-05','15:45:00',1.01),('9650','2013-02-05','15:50:00',1.26),('9650','2013-02-04','10:00:00',1.01),('9650','2013-02-04','10:05:00',1.09),('9650','2013-02-04','10:10:00',1.11),('9650','2013-02-04','10:15:00',1.14),('9650','2013-02-04','10:20:00',1.42),('9650','2013-02-04','10:25:00',1.53),('9650','2013-02-04','10:30:00',1.62),('9650','2013-02-04','10:35:00',1.71),('9650','2013-02-04','10:40:00',1.8),('9650','2013-02-04','10:45:00',1.97),('9650','2013-02-04','10:50:00',2.07),('9650','2013-02-04','10:55:00',2.18),('9650','2013-02-04','11:00:00',2.29),('9650','2013-02-04','11:05:00',2.39),('9650','2013-02-04','11:10:00',2.53),('9650','2013-02-04','11:15:00',2.62),('9650','2013-02-04','11:20:00',2.65),('9650','2013-02-04','11:25:00',2.84),('9650','2013-02-04','11:30:00',2.91),('9650','2013-02-04','11:35:00',2.83),('9650','2013-02-04','11:40:00',2.84),('9650','2013-02-04','11:45:00',3.09),('9650','2013-02-04','11:50:00',2.47),('9650','2013-02-04','11:55:00',2.2),('9650','2013-02-04','12:00:00',1.77),('9650','2013-02-04','12:05:00',2.15),('9650','2013-02-04','12:10:00',2.26),('9650','2013-02-04','12:15:00',2.35),('9650','2013-02-04','12:20:00',2.08),('9650','2013-02-04','12:25:00',2.09),('9650','2013-02-04','12:30:00',2.01),('9650','2013-02-04','12:35:00',2.61),('9650','2013-02-04','12:40:00',3.04),('9650','2013-02-04','12:45:00',3.4),('9650','2013-02-04','12:50:00',3.05),('9650','2013-02-04','12:55:00',1.52),('9650','2013-02-04','13:00:00',1.23),('9650','2013-02-04','13:05:00',1.34),('9650','2013-02-04','13:10:00',1.88),('9650','2013-02-04','13:15:00',2.32),('9650','2013-02-04','13:20:00',2.32),('9650','2013-02-04','13:25:00',2.32),('9650','2013-02-04','13:30:00',2.16),('9650','2013-02-04','13:35:00',1.72),('9650','2013-02-04','13:40:00',1.9),('9650','2013-02-04','13:45:00',2.38),('9650','2013-02-04','13:50:00',2.41),('9650','2013-02-04','13:55:00',2.11),('9650','2013-02-04','14:00:00',2.17),('9650','2013-02-04','14:05:00',2.1),('9650','2013-02-04','14:10:00',1.67),('9650','2013-02-04','14:15:00',1.9),('9650','2013-02-04','14:20:00',2.18),('9650','2013-02-04','14:25:00',2.86),('9650','2013-02-04','14:30:00',2.91),('9650','2013-02-04','14:35:00',2.34),('9650','2013-02-04','14:40:00',2.47),('9650','2013-02-04','14:45:00',1.77),('9650','2013-02-04','14:50:00',1.48),('9650','2013-02-04','14:55:00',1.23),('9650','2013-02-04','15:00:00',1.28),('9650','2013-02-04','15:05:00',1.67),('9650','2013-02-04','15:10:00',1.17),('9650','2013-02-04','15:15:00',1.01),('9650','2013-02-03','10:05:00',1.07),('9650','2013-02-03','10:10:00',1.22),('9650','2013-02-03','10:15:00',1.36),('9650','2013-02-03','10:20:00',1.36),('9650','2013-02-03','10:25:00',1.52),('9650','2013-02-03','10:30:00',1.52),('9650','2013-02-03','10:35:00',1.48),('9650','2013-02-03','10:40:00',1.61),('9650','2013-02-03','10:45:00',1.9),('9650','2013-02-03','10:50:00',2.05),('9650','2013-02-03','10:55:00',2.13),('9650','2013-02-03','11:00:00',2.22),('9650','2013-02-03','11:05:00',2.36),('9650','2013-02-03','11:10:00',2.48),('9650','2013-02-03','11:15:00',2.58),('9650','2013-02-03','11:20:00',2.69),('9650','2013-02-03','11:25:00',2.77),('9650','2013-02-03','11:30:00',2.85),('9650','2013-02-03','11:35:00',2.94),('9650','2013-02-03','11:40:00',3.02),('9650','2013-02-03','11:45:00',3.1),('9650','2013-02-03','11:50:00',3.18),('9650','2013-02-03','11:55:00',3.25),('9650','2013-02-03','12:00:00',3.33),('9650','2013-02-03','12:05:00',3.38),('9650','2013-02-03','12:10:00',3.45),('9650','2013-02-03','12:15:00',3.51),('9650','2013-02-03','12:20:00',3.56),('9650','2013-02-03','12:25:00',3.62),('9650','2013-02-03','12:30:00',3.66),('9650','2013-02-03','12:35:00',3.69),('9650','2013-02-03','12:40:00',3.73),('9650','2013-02-03','12:45:00',3.78),('9650','2013-02-03','12:50:00',3.83),('9650','2013-02-03','12:55:00',3.88),('9650','2013-02-03','13:00:00',3.92),('9650','2013-02-03','13:05:00',3.94),('9650','2013-02-03','13:10:00',3.95),('9650','2013-02-03','13:15:00',3.97),('9650','2013-02-03','13:20:00',3.98),('9650','2013-02-03','13:25:00',3.99),('9650','2013-02-03','13:30:00',3.97),('9650','2013-02-03','13:35:00',3.89),('9650','2013-02-03','13:40:00',3.77),('9650','2013-02-03','13:45:00',3.73),('9650','2013-02-03','13:50:00',3.61),('9650','2013-02-03','13:55:00',3.58),('9650','2013-02-03','14:00:00',3.51),('9650','2013-02-03','14:05:00',3.48),('9650','2013-02-03','14:10:00',3.47),('9650','2013-02-03','14:15:00',3.43),('9650','2013-02-03','14:20:00',3.43),('9650','2013-02-03','14:25:00',3.41),('9650','2013-02-03','14:30:00',3.22),('9650','2013-02-03','14:35:00',3.16),('9650','2013-02-03','14:40:00',3.11),('9650','2013-02-03','14:45:00',3.06),('9650','2013-02-03','14:50:00',2.91),('9650','2013-02-03','14:55:00',2.88),('9650','2013-02-03','15:00:00',2.76),('9650','2013-02-03','15:05:00',2.62),('9650','2013-02-03','15:10:00',2.43),('9650','2013-02-03','15:15:00',2.37),('9650','2013-02-03','15:20:00',2.36),('9650','2013-02-03','15:25:00',2.26),('9650','2013-02-03','15:30:00',2.25),('9650','2013-02-03','15:35:00',2.2),('9650','2013-02-03','15:40:00',2.15),('9650','2013-02-03','15:45:00',2.03),('9650','2013-02-03','15:50:00',1.94),('9650','2013-02-03','15:55:00',1.87),('9650','2013-02-03','16:00:00',1.78),('9650','2013-02-03','16:05:00',1.73),('9650','2013-02-03','16:10:00',1.61),('9650','2013-02-03','16:15:00',1.43),('9650','2013-02-03','16:20:00',1.32),('9650','2013-02-02','09:15:00',1.09),('9650','2013-02-02','09:20:00',1.49),('9650','2013-02-02','09:25:00',1.95),('9650','2013-02-02','09:30:00',1.54),('9650','2013-02-02','09:35:00',1.32),('9650','2013-02-02','09:40:00',1.59),('9650','2013-02-02','09:45:00',1.86),('9650','2013-02-02','09:50:00',2.06),('9650','2013-02-02','09:55:00',2.04),('9650','2013-02-02','10:00:00',1.69),('9650','2013-02-02','10:05:00',1.03),('9650','2013-02-02','10:20:00',1.55),('9650','2013-02-02','10:25:00',1.05),('9650','2013-02-02','11:15:00',1.08),('9650','2013-02-02','11:20:00',2.21),('9650','2013-02-02','11:25:00',1.45),('9650','2013-02-02','11:45:00',1.47),('9650','2013-02-02','11:50:00',1.97),('9650','2013-02-02','11:55:00',2.51),('9650','2013-02-02','12:00:00',2.32),('9650','2013-02-02','12:05:00',2.32),('9650','2013-02-02','12:10:00',2.34),('9650','2013-02-02','12:15:00',1.72),('9650','2013-02-02','12:20:00',1.35),('9650','2013-02-02','12:30:00',1.01),('9650','2013-02-01','10:15:00',1.68),('9650','2013-02-01','10:20:00',1.64),('9650','2013-02-01','10:25:00',1.68),('9650','2013-02-01','10:30:00',1.73),('9650','2013-02-01','10:35:00',1.84),('9650','2013-02-01','10:40:00',1.97),('9650','2013-02-01','10:45:00',2.08),('9650','2013-02-01','10:50:00',1.9),('9650','2013-02-01','10:55:00',2.31),('9650','2013-02-01','11:00:00',2.42),('9650','2013-02-01','11:05:00',2.28),('9650','2013-02-01','11:10:00',2.44),('9650','2013-02-01','11:15:00',2.39),('9650','2013-02-01','11:20:00',2.44),('9650','2013-02-01','11:25:00',2.85),('9650','2013-02-01','11:30:00',2.83),('9650','2013-02-01','11:35:00',2.78),('9650','2013-02-01','11:40:00',2.78),('9650','2013-02-01','11:45:00',2.1),('9650','2013-02-01','11:50:00',1.85),('9650','2013-02-01','11:55:00',1.94),('9650','2013-02-01','12:00:00',1.49),('9650','2013-02-01','12:05:00',1.1),('9650','2013-02-01','12:50:00',1.29),('9650','2013-02-01','12:55:00',2.94),('9650','2013-02-01','13:00:00',2.28),('9650','2013-02-01','13:05:00',2.43),('9650','2013-02-01','13:10:00',3.09),('9650','2013-02-01','13:15:00',3.1),('9650','2013-02-01','13:20:00',2.66),('9650','2013-02-01','13:25:00',2.69),('9650','2013-02-01','13:30:00',2.25),('9650','2013-02-01','13:35:00',3.19),('9650','2013-02-01','13:40:00',3.89),('9650','2013-02-01','13:45:00',3.17),('9650','2013-02-01','13:50:00',2.92),('9650','2013-02-01','13:55:00',1.61),('9650','2013-01-31','09:30:00',1.18),('9650','2013-01-31','09:35:00',1.45),('9650','2013-01-31','09:40:00',1.63),('9650','2013-01-31','09:45:00',1.33),('9650','2013-01-31','09:50:00',1.53),('9650','2013-01-31','09:55:00',1.72),('9650','2013-01-31','10:00:00',1.46),('9650','2013-01-31','10:05:00',1.34),('9650','2013-01-31','10:15:00',1.24),('9650','2013-01-31','10:20:00',1.33),('9650','2013-01-31','10:25:00',1.57),('9650','2013-01-31','10:30:00',1.6),('9650','2013-01-31','10:35:00',1.31),('9650','2013-01-31','10:40:00',1.26),('9650','2013-01-31','10:45:00',1.52),('9650','2013-01-31','10:50:00',3.25),('9650','2013-01-31','10:55:00',2.75),('9650','2013-01-31','11:00:00',2.82),('9650','2013-01-31','11:05:00',2.69),('9650','2013-01-31','11:10:00',2.06),('9650','2013-01-31','11:15:00',1.87),('9650','2013-01-31','11:20:00',2.48),('9650','2013-01-31','11:25:00',1.18),('9650','2013-01-31','11:30:00',2.08),('9650','2013-01-31','11:35:00',2.57),('9650','2013-01-31','11:40:00',2.35),('9650','2013-01-31','11:45:00',2.32),('9650','2013-01-31','11:50:00',2.14),('9650','2013-01-31','11:55:00',1.73),('9650','2013-01-31','12:00:00',2.15),('9650','2013-01-31','12:05:00',2.89),('9650','2013-01-31','12:10:00',2.66),('9650','2013-01-31','12:15:00',3.66),('9650','2013-01-31','12:20:00',4.24),('9650','2013-01-31','12:25:00',2.65),('9650','2013-01-31','12:30:00',3.01),('9650','2013-01-31','12:35:00',4.02),('9650','2013-01-31','12:40:00',4.01),('9650','2013-01-31','12:45:00',3.69),('9650','2013-01-31','12:50:00',4.01),('9650','2013-01-31','12:55:00',2.5),('9650','2013-01-31','13:00:00',2.45),('9650','2013-01-31','13:05:00',3.78),('9650','2013-01-31','13:10:00',3.89),('9650','2013-01-31','13:15:00',3.75),('9650','2013-01-31','13:20:00',3.96),('9650','2013-01-31','13:25:00',3.15),('9650','2013-01-31','13:30:00',4.04),('9650','2013-01-31','13:35:00',3.03),('9650','2013-01-31','13:40:00',3.15),('9650','2013-01-31','13:45:00',1.82),('9650','2013-01-31','13:50:00',1.9),('9650','2013-01-31','13:55:00',1.68),('9650','2013-01-31','14:00:00',1.62),('9650','2013-01-31','14:05:00',1.69),('9650','2013-01-31','14:10:00',3.81),('9650','2013-01-31','14:15:00',4.15),('9650','2013-01-31','14:20:00',3.22),('9650','2013-01-31','14:25:00',3.15),('9650','2013-01-31','14:30:00',3.1),('9650','2013-01-31','14:35:00',3.08),('9650','2013-01-31','14:40:00',2.32),('9650','2013-01-31','14:50:00',1.2),('9650','2013-01-31','14:55:00',1.33),('9650','2013-01-31','15:00:00',1.77),('9650','2013-01-31','15:05:00',2.45),('9650','2013-01-31','15:10:00',2.37),('9650','2013-01-31','15:15:00',2.13),('9650','2013-01-31','15:20:00',2.11),('9650','2013-01-31','15:25:00',1.84),('9650','2013-01-31','15:30:00',1.1),('9650','2013-01-31','15:40:00',1.06),('9650','2013-01-31','15:45:00',1.11),('9650','2013-01-31','15:50:00',1.65),('9650','2013-01-31','15:55:00',1.56),('9650','2014-03-20','08:30:00',1.09),('9650','2014-03-20','08:35:00',1.17),('9650','2014-03-20','08:40:00',1.27),('9650','2014-03-20','08:45:00',1.36),('9650','2014-03-20','08:50:00',1.47),('9650','2014-03-20','08:55:00',1.59),('9650','2014-03-20','09:00:00',1.71),('9650','2014-03-20','09:05:00',1.81),('9650','2014-03-20','09:10:00',1.94),('9650','2014-03-20','09:15:00',2.07),('9650','2014-03-20','09:20:00',2.21),('9650','2014-03-20','09:25:00',2.23),('9650','2014-03-20','09:30:00',2.44),('9650','2014-03-20','09:35:00',2.53),('9650','2014-03-20','09:40:00',2.69),('9650','2014-03-20','09:45:00',2.77),('9650','2014-03-20','09:50:00',2.86),('9650','2014-03-20','09:55:00',3.03),('9650','2014-03-20','10:00:00',3.14),('9650','2014-03-20','10:05:00',3.25),('9650','2014-03-20','10:10:00',3.37),('9650','2014-03-20','10:15:00',3.48),('9650','2014-03-20','10:20:00',3.57),('9650','2014-03-20','10:25:00',3.67),('9650','2014-03-20','10:30:00',3.74),('9650','2014-03-20','10:35:00',3.91),('9650','2014-03-20','10:40:00',3.96),('9650','2014-03-20','10:45:00',4.01),('9650','2014-03-20','10:50:00',4.07),('9650','2014-03-20','10:55:00',4.14),('9650','2014-03-20','11:00:00',4.26),('9650','2014-03-20','11:05:00',4.35),('9650','2014-03-20','11:10:00',4.41),('9650','2014-03-20','11:15:00',4.53),('9650','2014-03-20','11:20:00',4.69),('9650','2014-03-20','11:25:00',4.85),('9650','2014-03-20','11:30:00',3.51),('9650','2014-03-20','11:35:00',3.16),('9650','2014-03-20','11:40:00',5.07),('9650','2014-03-20','11:45:00',5.36),('9650','2014-03-20','11:50:00',5.68),('9650','2014-03-20','11:55:00',5.61),('9650','2014-03-20','12:00:00',3.65),('9650','2014-03-20','12:05:00',4.66),('9650','2014-03-20','12:10:00',5.42),('9650','2014-03-20','12:15:00',5.53),('9650','2014-03-20','12:20:00',5.5),('9650','2014-03-20','12:25:00',5.5),('9650','2014-03-20','12:30:00',5.53),('9650','2014-03-20','12:35:00',5.52),('9650','2014-03-20','12:40:00',5.53),('9650','2014-03-20','12:45:00',5.59),('9650','2014-03-20','12:50:00',5.59),('9650','2014-03-20','12:55:00',5.59),('9650','2014-03-20','13:00:00',5.67),('9650','2014-03-20','13:05:00',5.67),('9650','2014-03-20','13:10:00',5.63),('9650','2014-03-20','13:15:00',5.64),('9650','2014-03-20','13:20:00',5.63),('9650','2014-03-20','13:25:00',5.61),('9650','2014-03-20','13:30:00',5.61),('9650','2014-03-20','13:35:00',5.62),('9650','2014-03-20','13:40:00',5.59),('9650','2014-03-20','13:45:00',5.59),('9650','2014-03-20','13:50:00',5.54),('9650','2014-03-20','13:55:00',5.39),('9650','2014-03-20','14:00:00',5.44),('9650','2014-03-20','14:05:00',5.44),('9650','2014-03-20','14:10:00',5.38),('9650','2014-03-20','14:15:00',5.32),('9650','2014-03-20','14:20:00',5.22),('9650','2014-03-20','14:25:00',5.17),('9650','2014-03-20','14:30:00',4.91),('9650','2014-03-20','14:35:00',4.8),('9650','2014-03-20','14:40:00',4.88),('9650','2014-03-20','14:45:00',4.72),('9650','2014-03-20','14:50:00',3.88),('9650','2014-03-20','14:55:00',1.88),('9650','2014-03-20','15:00:00',1.47),('9650','2014-03-20','15:05:00',2.77),('9650','2014-03-20','15:10:00',4.91),('9650','2014-03-20','15:15:00',5.26),('9650','2014-03-20','15:20:00',4.65),('9650','2014-03-20','15:25:00',4.95),('9650','2014-03-20','15:30:00',4.93),('9650','2014-03-20','15:35:00',4.61),('9650','2014-03-20','15:40:00',4.71),('9650','2014-03-20','15:45:00',4.68),('9650','2014-03-20','15:50:00',4.58),('9650','2014-03-20','15:55:00',4.51),('9650','2014-03-20','16:00:00',4.31),('9650','2014-03-20','16:05:00',4.08),('9650','2014-03-20','16:10:00',3.86),('9650','2014-03-20','16:15:00',3.54),('9650','2014-03-20','16:20:00',3.37),('9650','2014-03-20','16:25:00',3.23),('9650','2014-03-20','16:30:00',3.16),('9650','2014-03-20','16:35:00',3.02),('9650','2014-03-20','16:40:00',2.9),('9650','2014-03-20','16:45:00',2.78),('9650','2014-03-20','16:50:00',2.62),('9650','2014-03-20','16:55:00',2.46),('9650','2014-03-20','17:00:00',2.17),('9650','2014-03-20','17:05:00',2.09),('9650','2014-03-20','17:10:00',1.91),('9650','2014-03-20','17:15:00',1.68),('9650','2014-03-20','17:20:00',1.54),('9650','2014-03-20','17:25:00',1.37),('9650','2014-03-20','17:30:00',1.18),('9650','2013-01-30','09:10:00',1.1),('9650','2013-01-30','09:20:00',1.03),('9650','2013-01-30','09:25:00',1.07),('9650','2013-01-30','09:30:00',1.03),('9650','2013-01-30','10:15:00',1.03),('9650','2013-01-30','10:20:00',1.1),('9650','2013-01-30','10:25:00',1.32),('9650','2013-01-30','10:30:00',1.59),('9650','2013-01-30','10:35:00',1.84),('9650','2013-01-30','10:40:00',2.07),('9650','2013-01-30','10:45:00',2.42),('9650','2013-01-30','10:50:00',2.58),('9650','2013-01-30','10:55:00',2.61),('9650','2013-01-30','11:00:00',2.34),('9650','2013-01-30','11:05:00',1.59),('9650','2013-01-30','11:10:00',2.56),('9650','2013-01-30','11:15:00',3.07),('9650','2013-01-30','11:20:00',3.3),('9650','2013-01-30','11:25:00',3.18),('9650','2013-01-30','11:30:00',2.84),('9650','2013-01-30','11:35:00',2.8),('9650','2013-01-30','11:40:00',2.72),('9650','2013-01-30','11:45:00',2.75),('9650','2013-01-30','11:50:00',2.86),('9650','2013-01-30','11:55:00',2.93),('9650','2013-01-30','12:00:00',2.98),('9650','2013-01-30','12:05:00',3.16),('9650','2013-01-30','12:10:00',3.14),('9650','2013-01-30','12:15:00',3.19),('9650','2013-01-30','12:20:00',3.31),('9650','2013-01-30','12:25:00',3.23),('9650','2013-01-30','12:30:00',3.27),('9650','2013-01-30','12:35:00',3.35),('9650','2013-01-30','12:40:00',3.36),('9650','2013-01-30','12:45:00',3.37),('9650','2013-01-30','12:50:00',3.43),('9650','2013-01-30','12:55:00',3.46),('9650','2013-01-30','13:00:00',3.49),('9650','2013-01-30','13:05:00',3.52),('9650','2013-01-30','13:10:00',3.48),('9650','2013-01-30','13:15:00',3.35),('9650','2013-01-30','13:20:00',3.49),('9650','2013-01-30','13:25:00',3.47),('9650','2013-01-30','13:30:00',3.48),('9650','2013-01-30','13:35:00',3.4),('9650','2013-01-30','13:40:00',3.32),('9650','2013-01-30','13:45:00',3.34),('9650','2013-01-30','13:50:00',3.45),('9650','2013-01-30','13:55:00',3.26),('9650','2013-01-30','14:00:00',3.13),('9650','2013-01-30','14:05:00',3.04),('9650','2013-01-30','14:10:00',2.99),('9650','2013-01-30','14:15:00',3.02),('9650','2013-01-30','14:20:00',2.99),('9650','2013-01-30','14:25:00',2.98),('9650','2013-01-30','14:30:00',2.82),('9650','2013-01-30','14:35:00',2.73),('9650','2013-01-30','14:40:00',2.72),('9650','2013-01-30','14:45:00',2.67),('9650','2013-01-30','14:50:00',2.6),('9650','2013-01-30','14:55:00',2.42),('9650','2013-01-30','15:00:00',2.31),('9650','2013-01-30','15:05:00',2.21),('9650','2013-01-30','15:10:00',2.13),('9650','2013-01-30','15:15:00',2.11),('9650','2013-01-30','15:20:00',2.08),('9650','2013-01-30','15:25:00',1.93),('9650','2013-01-30','15:30:00',1.9),('9650','2013-01-30','15:35:00',1.93),('9650','2013-01-30','15:40:00',1.82),('9650','2013-01-30','15:45:00',1.68),('9650','2013-01-30','15:50:00',1.59),('9650','2013-01-30','15:55:00',1.51),('9650','2013-01-30','16:00:00',1.3),('9650','2013-01-30','16:05:00',1.1),('9650','2013-01-30','16:10:00',1.28),('9650','2013-01-30','16:15:00',1.08),('9650','2013-01-29','09:25:00',1.08),('9650','2013-01-29','09:30:00',1.22),('9650','2013-01-29','09:35:00',1.25),('9650','2013-01-29','09:40:00',1.17),('9650','2013-01-29','10:00:00',1.68),('9650','2013-01-29','10:05:00',1.91),('9650','2013-01-29','10:10:00',1.94),('9650','2013-01-29','10:15:00',1.65),('9650','2013-01-29','10:20:00',1.94),('9650','2013-01-29','10:25:00',2.12),('9650','2013-01-29','10:30:00',2.06),('9650','2013-01-29','10:35:00',1.77),('9650','2013-01-29','10:40:00',1.54),('9650','2013-01-29','10:45:00',1.57),('9650','2013-01-29','10:50:00',1.85),('9650','2013-01-29','10:55:00',1.81),('9650','2013-01-29','11:00:00',2.02),('9650','2013-01-29','11:05:00',2.04),('9650','2013-01-29','11:10:00',2.14),('9650','2013-01-29','11:15:00',2.23),('9650','2013-01-29','11:20:00',2.34),('9650','2013-01-29','11:25:00',2.48),('9650','2013-01-29','11:30:00',2.51),('9650','2013-01-29','11:35:00',2.58),('9650','2013-01-29','11:40:00',2.32),('9650','2013-01-29','11:45:00',2.8),('9650','2013-01-29','11:50:00',2.68),('9650','2013-01-29','11:55:00',2.9),('9650','2013-01-29','12:00:00',3.19),('9650','2013-01-29','12:05:00',2.54),('9650','2013-01-29','12:10:00',1.83),('9650','2013-01-29','12:15:00',2.58),('9650','2013-01-29','12:20:00',2.12),('9650','2013-01-29','12:25:00',1.45),('9650','2013-01-29','12:30:00',1.43),('9650','2013-01-29','12:35:00',1.89),('9650','2013-01-29','12:40:00',1.81),('9650','2013-01-29','12:45:00',2.23),('9650','2013-01-29','12:50:00',4.33),('9650','2013-01-29','12:55:00',4.36),('9650','2013-01-29','13:00:00',4.36),('9650','2013-01-29','13:05:00',4.37),('9650','2013-01-29','13:10:00',3.99),('9650','2013-01-29','13:15:00',4.08),('9650','2013-01-29','13:20:00',3.96),('9650','2013-01-29','13:25:00',4.06),('9650','2013-01-29','13:30:00',4.09),('9650','2013-01-29','13:35:00',2.88),('9650','2013-01-29','13:40:00',3.21),('9650','2013-01-29','13:45:00',3.05),('9650','2013-01-29','13:50:00',4.02),('9650','2013-01-29','13:55:00',3.89),('9650','2013-01-29','14:00:00',4.01),('9650','2013-01-29','14:05:00',3.99),('9650','2013-01-29','14:10:00',2.61),('9650','2013-01-29','14:15:00',2.23),('9650','2013-01-29','14:20:00',2.71),('9650','2013-01-29','14:25:00',3.54),('9650','2013-01-29','14:30:00',3.34),('9650','2013-01-29','14:35:00',3.26),('9650','2013-01-29','14:40:00',3.47),('9650','2013-01-29','14:45:00',2.61),('9650','2013-01-29','14:50:00',1.59),('9650','2013-01-29','14:55:00',1.63),('9650','2013-01-29','15:00:00',1.87),('9650','2013-01-29','15:05:00',1.87),('9650','2013-01-29','15:10:00',1.52),('9650','2013-01-29','15:15:00',1.27),('9650','2013-01-29','15:20:00',1.11),('9650','2013-01-29','15:25:00',1.01),('9650','2013-01-29','15:30:00',1.01),('9650','2013-01-28','10:20:00',1.02),('9650','2013-01-28','10:25:00',1.14),('9650','2013-01-28','10:30:00',1.21),('9650','2013-01-28','10:35:00',1.35),('9650','2013-01-28','10:40:00',1.48),('9650','2013-01-28','10:45:00',1.58),('9650','2013-01-28','10:50:00',1.71),('9650','2013-01-28','10:55:00',1.87),('9650','2013-01-28','11:00:00',1.97),('9650','2013-01-28','11:05:00',2.07),('9650','2013-01-28','11:10:00',2.15),('9650','2013-01-28','11:15:00',2.27),('9650','2013-01-28','11:20:00',2.37),('9650','2013-01-28','11:25:00',2.41),('9650','2013-01-28','11:30:00',2.45),('9650','2013-01-28','11:35:00',2.62),('9650','2013-01-28','11:40:00',2.69),('9650','2013-01-28','11:45:00',2.76),('9650','2013-01-28','11:50:00',2.83),('9650','2013-01-28','11:55:00',2.89),('9650','2013-01-28','12:00:00',2.92),('9650','2013-01-28','12:05:00',2.97),('9650','2013-01-28','12:10:00',3.1),('9650','2013-01-28','12:15:00',3.11),('9650','2013-01-28','12:20:00',3.17),('9650','2013-01-28','12:25:00',3.24),('9650','2013-01-28','12:30:00',3.29),('9650','2013-01-28','12:35:00',3.27),('9650','2013-01-28','12:40:00',3.35),('9650','2013-01-28','12:45:00',3.31),('9650','2013-01-28','12:50:00',3.31),('9650','2013-01-28','12:55:00',3.45),('9650','2013-01-28','13:00:00',3.47),('9650','2013-01-28','13:05:00',3.48),('9650','2013-01-28','13:10:00',3.46),('9650','2013-01-28','13:15:00',3.49),('9650','2013-01-28','13:20:00',3.44),('9650','2013-01-28','13:25:00',3.51),('9650','2013-01-28','13:30:00',3.53),('9650','2013-01-28','13:35:00',3.48),('9650','2013-01-28','13:40:00',3.33),('9650','2013-01-28','13:45:00',3.31),('9650','2013-01-28','13:50:00',3.25),('9650','2013-01-28','13:55:00',3.17),('9650','2013-01-28','14:00:00',3.09),('9650','2013-01-28','14:05:00',3.04),('9650','2013-01-28','14:10:00',3),('9650','2013-01-28','14:15:00',2.88),('9650','2013-01-28','14:20:00',2.58),('9650','2013-01-28','14:25:00',3),('9650','2013-01-28','14:30:00',2.88),('9650','2013-01-28','14:35:00',2.76),('9650','2013-01-28','14:40:00',2.76),('9650','2013-01-28','14:45:00',2.69),('9650','2013-01-28','14:50:00',2.6),('9650','2013-01-28','14:55:00',2.49),('9650','2013-01-28','15:00:00',2.34),('9650','2013-01-28','15:05:00',2.17),('9650','2013-01-28','15:10:00',2.1),('9650','2013-01-28','15:15:00',2.03),('9650','2013-01-28','15:20:00',1.93),('9650','2013-01-28','15:25:00',1.89),('9650','2013-01-28','15:30:00',1.83),('9650','2013-01-28','15:35:00',1.76),('9650','2013-01-28','15:40:00',1.7),('9650','2013-01-28','15:45:00',1.58),('9650','2013-01-28','15:50:00',1.5),('9650','2013-01-28','15:55:00',1.43),('9650','2013-01-28','16:00:00',1.42),('9650','2013-01-28','16:05:00',1.37),('9650','2013-01-28','16:10:00',1.27),('9650','2013-01-28','16:15:00',1.08),('9650','2013-01-27','10:55:00',1.15),('9650','2013-01-27','11:00:00',1.34),('9650','2013-01-27','11:05:00',1.52),('9650','2013-01-27','11:10:00',1.58),('9650','2013-01-27','11:15:00',1.32),('9650','2013-01-27','11:20:00',1.33),('9650','2013-01-27','11:25:00',1.26),('9650','2013-01-27','11:30:00',1.12),('9650','2013-01-27','11:35:00',1.01),('9650','2013-01-27','11:45:00',1.01),('9650','2013-01-27','12:30:00',1.05),('9650','2013-01-27','12:35:00',1.22),('9650','2013-01-27','12:40:00',1.54),('9650','2013-01-27','12:45:00',1.9),('9650','2013-01-27','12:50:00',2.17),('9650','2013-01-27','12:55:00',2.07),('9650','2013-01-27','13:00:00',1.91),('9650','2013-01-27','13:05:00',1.9),('9650','2013-01-27','13:10:00',1.76),('9650','2013-01-27','13:15:00',1.69),('9650','2013-01-27','13:20:00',1.67),('9650','2013-01-27','13:25:00',1.67),('9650','2013-01-27','13:30:00',1.62),('9650','2013-01-27','13:35:00',1.5),('9650','2013-01-27','13:40:00',1.38),('9650','2013-01-27','13:45:00',1.29),('9650','2013-01-27','13:50:00',1.18),('9650','2013-01-27','13:55:00',1.17),('9650','2013-01-27','14:00:00',1.24),('9650','2013-01-27','14:05:00',1.27),('9650','2013-01-27','14:10:00',1.23),('9650','2013-01-27','14:15:00',1.13),('9650','2013-01-27','14:20:00',1.03),('9650','2013-01-26','10:20:00',1.01),('9650','2013-01-26','10:25:00',1.1),('9650','2013-01-26','10:30:00',1.2),('9650','2013-01-26','10:35:00',1.29),('9650','2013-01-26','10:40:00',1.38),('9650','2013-01-26','10:45:00',1.51),('9650','2013-01-26','10:50:00',1.65),('9650','2013-01-26','10:55:00',1.8),('9650','2013-01-26','11:00:00',1.91),('9650','2013-01-26','11:05:00',1.98),('9650','2013-01-26','11:10:00',2.08),('9650','2013-01-26','11:15:00',2.17),('9650','2013-01-26','11:20:00',2.26),('9650','2013-01-26','11:25:00',2.36),('9650','2013-01-26','11:30:00',2.44),('9650','2013-01-26','11:35:00',2.5),('9650','2013-01-26','11:40:00',2.59),('9650','2013-01-26','11:45:00',2.66),('9650','2013-01-26','11:50:00',2.74),('9650','2013-01-26','11:55:00',2.81),('9650','2013-01-26','12:00:00',2.87),('9650','2013-01-26','12:05:00',2.94),('9650','2013-01-26','12:10:00',3),('9650','2013-01-26','12:15:00',3.05),('9650','2013-01-26','12:20:00',3.1),('9650','2013-01-26','12:25:00',3.15),('9650','2013-01-26','12:30:00',3.18),('9650','2013-01-26','12:35:00',3.21),('9650','2013-01-26','12:40:00',3.22),('9650','2013-01-26','12:45:00',3.31),('9650','2013-01-26','12:50:00',3.36),('9650','2013-01-26','12:55:00',3.42),('9650','2013-01-26','13:00:00',3.42),('9650','2013-01-26','13:05:00',3.47),('9650','2013-01-26','13:10:00',3.51),('9650','2013-01-26','13:15:00',3.5),('9650','2013-01-26','13:20:00',3.48),('9650','2013-01-26','13:25:00',3.42),('9650','2013-01-26','13:30:00',3.39),('9650','2013-01-26','13:35:00',3.33),('9650','2013-01-26','13:40:00',3.25),('9650','2013-01-26','13:45:00',3.25),('9650','2013-01-26','13:50:00',3.11),('9650','2013-01-26','13:55:00',3.01),('9650','2013-01-26','14:00:00',2.96),('9650','2013-01-26','14:05:00',2.94),('9650','2013-01-26','14:10:00',2.93),('9650','2013-01-26','14:15:00',2.91),('9650','2013-01-26','14:20:00',2.84),('9650','2013-01-26','14:25:00',2.77),('9650','2013-01-26','14:30:00',2.68),('9650','2013-01-26','14:35:00',2.55),('9650','2013-01-26','14:40:00',2.53),('9650','2013-01-26','14:45:00',2.54),('9650','2013-01-26','14:50:00',2.47),('9650','2013-01-26','14:55:00',2.41),('9650','2013-01-26','15:00:00',2.32),('9650','2013-01-26','15:05:00',2.09),('9650','2013-01-26','15:10:00',1.9),('9650','2013-01-26','15:15:00',1.9),('9650','2013-01-26','15:20:00',1.81),('9650','2013-01-26','15:25:00',1.76),('9650','2013-01-26','15:30:00',1.67),('9650','2013-01-26','15:35:00',1.59),('9650','2013-01-26','15:40:00',1.5),('9650','2013-01-26','15:45:00',1.43),('9650','2013-01-26','15:50:00',1.32),('9650','2013-01-26','15:55:00',1.32),('9650','2013-01-26','16:00:00',1.29),('9650','2013-01-26','16:05:00',1.24),('9650','2013-01-26','16:10:00',1.03),('9650','2013-01-25','09:00:00',1.01),('9650','2013-01-25','09:05:00',1.08),('9650','2013-01-25','09:10:00',1.15),('9650','2013-01-25','09:15:00',1.15),('9650','2013-01-25','09:20:00',1.23),('9650','2013-01-25','09:25:00',1.24),('9650','2013-01-25','09:30:00',1.2),('9650','2013-01-25','09:35:00',1.22),('9650','2013-01-25','09:45:00',1.11),('9650','2013-01-25','09:50:00',1.53),('9650','2013-01-25','09:55:00',1.45),('9650','2013-01-25','10:00:00',1.28),('9650','2013-01-25','10:05:00',1.24),('9650','2013-01-25','10:10:00',1.29),('9650','2013-01-25','10:15:00',1.61),('9650','2013-01-25','10:20:00',1.67),('9650','2013-01-25','10:25:00',1.73),('9650','2013-01-25','10:30:00',1.22),('9650','2013-01-25','10:35:00',1.33),('9650','2013-01-25','10:40:00',1.52),('9650','2013-01-25','10:45:00',1.61),('9650','2013-01-25','10:50:00',1.81),('9650','2013-01-25','10:55:00',1.56),('9650','2013-01-25','11:00:00',1.41),('9650','2013-01-25','11:05:00',1.79),('9650','2013-01-25','11:10:00',1.58),('9650','2013-01-25','11:15:00',1.58),('9650','2013-01-25','11:20:00',1.54),('9650','2013-01-25','11:25:00',1.77),('9650','2013-01-25','11:30:00',1.75),('9650','2013-01-25','11:35:00',1.58),('9650','2013-01-25','11:40:00',1.64),('9650','2013-01-25','11:45:00',1.54),('9650','2013-01-25','11:50:00',1.63),('9650','2013-01-25','11:55:00',1.49),('9650','2013-01-25','12:00:00',1.29),('9650','2013-01-25','12:05:00',1.31),('9650','2013-01-25','12:10:00',1.33),('9650','2013-01-25','12:15:00',1.38),('9650','2013-01-25','12:20:00',1.42),('9650','2013-01-25','12:25:00',1.65),('9650','2013-01-25','12:30:00',1.5),('9650','2013-01-25','12:35:00',1.5),('9650','2013-01-25','12:40:00',1.42),('9650','2013-01-25','12:45:00',1.46),('9650','2013-01-25','12:50:00',1.45),('9650','2013-01-25','12:55:00',1.04),('9650','2013-01-25','13:05:00',1.2),('9650','2013-01-25','13:10:00',1.04),('9650','2013-01-25','13:35:00',1.19),('9650','2013-01-25','13:40:00',1.25),('9650','2013-01-25','13:45:00',1.17),('9650','2013-01-25','13:50:00',1.06),('9650','2013-01-25','13:55:00',1.01),('9650','2013-01-25','14:25:00',1.06),('9650','2013-01-25','14:30:00',1.02),('9650','2013-01-24','10:25:00',1.04),('9650','2013-01-24','10:30:00',1.02),('9650','2013-01-24','10:40:00',1.34),('9650','2013-01-24','10:45:00',1.43),('9650','2013-01-24','10:50:00',1.27),('9650','2013-01-24','10:55:00',1.81),('9650','2013-01-24','11:00:00',1),('9650','2013-01-24','11:05:00',1.08),('9650','2013-01-24','11:10:00',1.94),('9650','2013-01-24','11:15:00',2.17),('9650','2013-01-24','11:20:00',2.25),('9650','2013-01-24','11:25:00',2.33),('9650','2013-01-24','11:30:00',2.44),('9650','2013-01-24','11:35:00',2.56),('9650','2013-01-24','11:40:00',2.62),('9650','2013-01-24','11:45:00',2.68),('9650','2013-01-24','11:50:00',2.77),('9650','2013-01-24','11:55:00',2.82),('9650','2013-01-24','12:00:00',2.85),('9650','2013-01-24','12:05:00',2.88),('9650','2013-01-24','12:10:00',2.98),('9650','2013-01-24','12:15:00',3.04),('9650','2013-01-24','12:20:00',3.1),('9650','2013-01-24','12:25:00',3.12),('9650','2013-01-24','12:30:00',3.04),('9650','2013-01-24','12:35:00',2.72),('9650','2013-01-24','12:40:00',2.98),('9650','2013-01-24','12:45:00',3.24),('9650','2013-01-24','12:50:00',3.2),('9650','2013-01-24','12:55:00',3.27),('9650','2013-01-24','13:00:00',3.3),('9650','2013-01-24','13:05:00',3.27),('9650','2013-01-24','13:10:00',3.28),('9650','2013-01-24','13:15:00',3.35),('9650','2013-01-24','13:20:00',3.4),('9650','2013-01-24','13:25:00',3.48),('9650','2013-01-24','13:30:00',3.6),('9650','2013-01-24','13:35:00',3.58),('9650','2013-01-24','13:40:00',3.44),('9650','2013-01-24','13:55:00',3.04),('9650','2013-01-24','14:00:00',2.99),('9650','2013-01-24','14:05:00',2.86),('9650','2013-01-24','14:10:00',2.76),('9650','2013-01-24','14:15:00',2.6),('9650','2013-01-24','14:20:00',2.52),('9650','2013-01-24','14:25:00',2.56),('9650','2013-01-24','14:30:00',2.46),('9650','2013-01-24','14:35:00',2.32),('9650','2013-01-24','14:40:00',2.33),('9650','2013-01-24','14:45:00',2.24),('9650','2013-01-24','14:50:00',2.22),('9650','2013-01-24','14:55:00',2.18),('9650','2013-01-24','15:00:00',1.94),('9650','2013-01-24','15:05:00',1.76),('9650','2013-01-24','15:10:00',1.66),('9650','2013-01-24','15:15:00',1.64),('9650','2013-01-24','15:20:00',1.64),('9650','2013-01-24','15:25:00',1.62),('9650','2013-01-24','15:30:00',1.63),('9650','2013-01-24','15:35:00',1.67),('9650','2013-01-24','15:40:00',1.65),('9650','2013-01-24','15:45:00',1.69),('9650','2013-01-24','15:50:00',1.68),('9650','2013-01-24','15:55:00',1.53),('9650','2013-01-24','16:00:00',1.11),('9650','2013-01-23','09:15:00',1.01),('9650','2013-01-23','09:20:00',1.13),('9650','2013-01-23','09:25:00',1.13),('9650','2013-01-23','09:30:00',1.07),('9650','2013-01-23','10:25:00',1),('9650','2013-01-23','10:30:00',1.03),('9650','2013-01-23','10:35:00',1.11),('9650','2013-01-23','10:40:00',1.24),('9650','2013-01-23','10:45:00',1.3),('9650','2013-01-23','10:50:00',1.4),('9650','2013-01-23','10:55:00',1.45),('9650','2013-01-23','11:00:00',1),('9650','2013-01-23','12:35:00',1.21),('9650','2013-01-23','12:40:00',1.38),('9650','2013-01-23','12:45:00',1.69),('9650','2013-01-23','12:50:00',1.74),('9650','2013-01-23','12:55:00',1.7),('9650','2013-01-23','13:00:00',1.63),('9650','2013-01-23','13:05:00',1.59),('9650','2013-01-23','13:10:00',1.54),('9650','2013-01-23','13:15:00',1.49),('9650','2013-01-23','13:20:00',1.45),('9650','2013-01-23','13:25:00',1.47),('9650','2013-01-23','13:30:00',1.49),('9650','2013-01-23','13:35:00',1.46),('9650','2013-01-23','13:40:00',1.47),('9650','2013-01-23','13:45:00',1.49),('9650','2013-01-23','13:50:00',1.56),('9650','2013-01-23','13:55:00',1.69),('9650','2013-01-23','14:00:00',2.02),('9650','2013-01-23','14:05:00',1.96),('9650','2013-01-23','14:10:00',1.91),('9650','2013-01-23','14:15:00',2.11),('9650','2013-01-23','14:20:00',3.07),('9650','2013-01-23','14:25:00',4.38),('9650','2013-01-23','14:30:00',3.71),('9650','2013-01-23','14:35:00',2.71),('9650','2013-01-23','14:40:00',2.18),('9650','2013-01-23','14:45:00',2.61),('9650','2013-01-23','14:50:00',2.67),('9650','2013-01-23','14:55:00',2.64),('9650','2013-01-23','15:00:00',1.89),('9650','2013-01-23','15:05:00',1.46),('9650','2013-01-23','15:10:00',1.1),('9650','2013-01-23','15:15:00',1.15),('9650','2013-01-23','15:20:00',1.58),('9650','2013-01-23','15:25:00',1.57),('9650','2013-01-23','15:30:00',1.62),('9650','2013-01-23','15:35:00',1.42),('9650','2013-01-23','15:45:00',1.2),('9650','2013-01-23','15:50:00',1.19),('9650','2013-01-23','15:55:00',1.09),('9650','2013-01-23','16:00:00',1.03),('9650','2013-01-22','09:50:00',1.21),('9650','2013-01-22','09:55:00',1.51),('9650','2013-01-22','10:00:00',1.39),('9650','2013-01-22','10:05:00',1.21),('9650','2013-01-22','10:10:00',1.07),('9650','2013-01-22','10:15:00',1.32),('9650','2013-01-22','10:20:00',1.3),('9650','2013-01-22','10:25:00',1.65),('9650','2013-01-22','10:30:00',2.44),('9650','2013-01-22','10:35:00',2.58),('9650','2013-01-22','10:40:00',2.22),('9650','2013-01-22','10:45:00',2.1),('9650','2013-01-22','10:50:00',2.62),('9650','2013-01-22','10:55:00',1.98),('9650','2013-01-22','11:00:00',1.24),('9650','2013-01-21','08:55:00',1.05),('9650','2013-01-21','09:00:00',1.74),('9650','2013-01-21','09:40:00',1.23),('9650','2013-01-21','09:45:00',1.7),('9650','2013-01-21','10:10:00',1.28),('9650','2013-01-21','10:15:00',1.12),('9650','2013-01-21','10:20:00',1.27),('9650','2013-01-21','10:25:00',1.3),('9650','2013-01-21','10:30:00',1.37),('9650','2013-01-21','10:35:00',1.78),('9650','2013-01-21','10:40:00',2.53),('9650','2013-01-21','10:45:00',2.58),('9650','2013-01-21','10:50:00',2.14),('9650','2013-01-21','10:55:00',1.66),('9650','2013-01-21','11:00:00',1.16),('9650','2013-01-21','11:05:00',1.33),('9650','2013-01-21','11:10:00',1.49),('9650','2013-01-21','11:15:00',1.69),('9650','2013-01-21','11:20:00',1.69),('9650','2013-01-21','11:25:00',1.46),('9650','2013-01-21','11:30:00',1.34),('9650','2013-01-21','11:35:00',1.23),('9650','2013-01-21','11:45:00',1.96),('9650','2013-01-21','11:50:00',2.31),('9650','2013-01-21','11:55:00',1.39),('9650','2013-01-21','12:00:00',1.3),('9650','2013-01-21','12:05:00',1.26),('9650','2013-01-21','12:10:00',3.13),('9650','2013-01-21','12:15:00',2.82),('9650','2013-01-21','12:20:00',2.38),('9650','2013-01-21','12:25:00',2.88),('9650','2013-01-21','12:30:00',1.59),('9650','2013-01-21','12:35:00',1.55),('9650','2013-01-21','12:40:00',3.58),('9650','2013-01-21','12:45:00',1.56),('9650','2013-01-21','12:50:00',1.9),('9650','2013-01-21','12:55:00',1.59),('9650','2013-01-21','13:00:00',3.6),('9650','2013-01-21','13:05:00',4.2),('9650','2013-01-21','13:10:00',2.98),('9650','2013-01-21','13:15:00',1.86),('9650','2013-01-21','13:20:00',2.96),('9650','2013-01-21','13:25:00',1.29),('9650','2013-01-21','13:30:00',1.15),('9650','2013-01-21','13:40:00',1.66),('9650','2013-01-21','13:45:00',1.91),('9650','2013-01-21','13:50:00',1.8),('9650','2013-01-21','13:55:00',1.02),('9650','2013-01-21','14:00:00',1.31),('9650','2013-01-21','14:05:00',1.27),('9650','2013-01-21','14:10:00',2.04),('9650','2013-01-21','14:15:00',1.87),('9650','2013-01-21','14:20:00',1.56),('9650','2013-01-21','14:25:00',2.44),('9650','2013-01-21','14:35:00',2.05),('9650','2013-01-21','14:40:00',1.8),('9650','2013-01-21','14:45:00',2.41),('9650','2013-01-21','14:50:00',1.66),('9650','2013-01-21','15:00:00',1.05),('9650','2013-01-21','15:05:00',1.05),('9650','2014-03-19','08:25:00',1.03),('9650','2014-03-19','08:30:00',1.1),('9650','2014-03-19','08:35:00',1.17),('9650','2014-03-19','08:40:00',1.24),('9650','2014-03-19','08:45:00',1.29),('9650','2014-03-19','08:50:00',1.49),('9650','2014-03-19','08:55:00',1.61),('9650','2014-03-19','09:00:00',1.72),('9650','2014-03-19','09:05:00',1.85),('9650','2014-03-19','09:10:00',1.99),('9650','2014-03-19','09:15:00',2.09),('9650','2014-03-19','09:20:00',2.22),('9650','2014-03-19','09:25:00',2.31),('9650','2014-03-19','09:30:00',2.42),('9650','2014-03-19','09:35:00',2.55),('9650','2014-03-19','09:40:00',2.63),('9650','2014-03-19','09:45:00',2.72),('9650','2014-03-19','09:50:00',2.78),('9650','2014-03-19','09:55:00',2.91),('9650','2014-03-19','10:00:00',3.11),('9650','2014-03-19','10:05:00',3.27),('9650','2014-03-19','10:10:00',3.38),('9650','2014-03-19','10:15:00',3.41),('9650','2014-03-19','10:20:00',3.51),('9650','2014-03-19','10:25:00',3.62),('9650','2014-03-19','10:30:00',3.7),('9650','2014-03-19','10:35:00',3.67),('9650','2014-03-19','10:40:00',3.63),('9650','2014-03-19','10:45:00',3.75),('9650','2014-03-19','10:50:00',4.04),('9650','2014-03-19','10:55:00',4.36),('9650','2014-03-19','11:00:00',4.49),('9650','2014-03-19','11:05:00',4.49),('9650','2014-03-19','11:10:00',4.53),('9650','2014-03-19','11:15:00',4.35),('9650','2014-03-19','11:20:00',4.62),('9650','2014-03-19','11:25:00',4.71),('9650','2014-03-19','11:30:00',4.88),('9650','2014-03-19','11:35:00',5.08),('9650','2014-03-19','11:40:00',5.01),('9650','2014-03-19','11:45:00',5.07),('9650','2014-03-19','11:50:00',5.18),('9650','2014-03-19','11:55:00',4.83),('9650','2014-03-19','12:00:00',4.58),('9650','2014-03-19','12:05:00',5.03),('9650','2014-03-19','12:10:00',5.29),('9650','2014-03-19','12:15:00',5.4),('9650','2014-03-19','12:20:00',5.25),('9650','2014-03-19','12:25:00',5.03),('9650','2014-03-19','12:30:00',5.28),('9650','2014-03-19','12:35:00',5.42),('9650','2014-03-19','12:40:00',5.43),('9650','2014-03-19','12:45:00',5.63),('9650','2014-03-19','12:50:00',5.64),('9650','2014-03-19','12:55:00',5.63),('9650','2014-03-19','13:00:00',5.59),('9650','2014-03-19','13:05:00',5.55),('9650','2014-03-19','13:10:00',5.47),('9650','2014-03-19','13:15:00',5.39),('9650','2014-03-19','13:20:00',5.48),('9650','2014-03-19','13:25:00',5.37),('9650','2014-03-19','13:30:00',5.47),('9650','2014-03-19','13:35:00',5.33),('9650','2014-03-19','13:40:00',5.11),('9650','2014-03-19','13:45:00',4.84),('9650','2014-03-19','13:50:00',4.76),('9650','2014-03-19','13:55:00',4.43),('9650','2014-03-19','14:00:00',4.57),('9650','2014-03-19','14:05:00',4.99),('9650','2014-03-19','14:10:00',4.92),('9650','2014-03-19','14:15:00',4.59),('9650','2014-03-19','14:20:00',4.55),('9650','2014-03-19','14:25:00',4.62),('9650','2014-03-19','14:30:00',3.89),('9650','2014-03-19','14:35:00',3.58),('9650','2014-03-19','14:40:00',4.18),('9650','2014-03-19','14:45:00',4.05),('9650','2014-03-19','14:50:00',3.8),('9650','2014-03-19','14:55:00',3.71),('9650','2014-03-19','15:00:00',3.38),('9650','2014-03-19','15:05:00',3.38),('9650','2014-03-19','15:10:00',3.51),('9650','2014-03-19','15:15:00',3.38),('9650','2014-03-19','15:20:00',3.65),('9650','2014-03-19','15:25:00',3.31),('9650','2014-03-19','15:30:00',3.17),('9650','2014-03-19','15:35:00',3.08),('9650','2014-03-19','15:40:00',2.85),('9650','2014-03-19','15:45:00',2.96),('9650','2014-03-19','15:50:00',2.64),('9650','2014-03-19','15:55:00',2.44),('9650','2014-03-19','16:00:00',2.14),('9650','2014-03-19','16:05:00',1.96),('9650','2014-03-19','16:10:00',2),('9650','2014-03-19','16:15:00',1.95),('9650','2014-03-19','16:20:00',2.07),('9650','2014-03-19','16:25:00',2.17),('9650','2014-03-19','16:30:00',2.07),('9650','2014-03-19','16:35:00',1.94),('9650','2014-03-19','16:40:00',1.81),('9650','2014-03-19','16:45:00',1.28),('9650','2014-03-19','16:50:00',1.05),('9650','2013-01-20','10:10:00',1.14),('9650','2013-01-20','10:15:00',1.2),('9650','2013-01-20','10:20:00',1.06),('9650','2013-01-20','10:25:00',1.14),('9650','2013-01-20','10:30:00',1.11),('9650','2013-01-20','10:45:00',1.06),('9650','2013-01-20','10:50:00',1.06),('9650','2013-01-20','10:55:00',1.22),('9650','2013-01-20','11:00:00',1.5),('9650','2013-01-20','11:05:00',1.4),('9650','2013-01-20','11:10:00',1.77),('9650','2013-01-20','11:15:00',1.85),('9650','2013-01-20','11:20:00',1.69),('9650','2013-01-20','11:25:00',1.59),('9650','2013-01-20','11:30:00',1.3),('9650','2013-01-20','11:40:00',1.26),('9650','2013-01-20','11:45:00',1.41),('9650','2013-01-20','11:50:00',2.2),('9650','2013-01-20','11:55:00',3.16),('9650','2013-01-20','12:00:00',2.63),('9650','2013-01-20','12:05:00',2.71),('9650','2013-01-20','12:10:00',3.08),('9650','2013-01-20','12:15:00',2.24),('9650','2013-01-20','12:20:00',1.33),('9650','2013-01-20','12:25:00',2.25),('9650','2013-01-20','12:30:00',1.1),('9650','2013-01-20','12:35:00',1.44),('9650','2013-01-20','12:40:00',1.65),('9650','2013-01-20','12:45:00',1.29),('9650','2013-01-20','12:50:00',1.86),('9650','2013-01-20','12:55:00',1.22),('9650','2013-01-20','13:00:00',1.54),('9650','2013-01-20','13:05:00',2.86),('9650','2013-01-20','13:10:00',2.32),('9650','2013-01-20','13:15:00',1.53),('9650','2013-01-20','13:20:00',1.51),('9650','2013-01-20','13:25:00',1.53),('9650','2013-01-20','13:30:00',4.18),('9650','2013-01-20','13:35:00',4.08),('9650','2013-01-20','13:40:00',3.24),('9650','2013-01-20','13:45:00',1.33),('9650','2013-01-20','13:50:00',2.69),('9650','2013-01-20','13:55:00',3.76),('9650','2013-01-20','14:00:00',3.19),('9650','2013-01-20','14:05:00',3.59),('9650','2013-01-20','14:10:00',3.2),('9650','2013-01-20','14:15:00',2.28),('9650','2013-01-20','14:20:00',3.13),('9650','2013-01-20','14:25:00',3.12),('9650','2013-01-20','14:30:00',1.96),('9650','2013-01-20','14:35:00',1.16),('9650','2013-01-20','14:40:00',1.01),('9650','2013-01-19','10:40:00',1.12),('9650','2013-01-19','10:45:00',1.31),('9650','2013-01-19','10:50:00',1.5),('9650','2013-01-19','10:55:00',1.53),('9650','2013-01-19','11:00:00',1.68),('9650','2013-01-19','11:05:00',1.88),('9650','2013-01-19','11:10:00',1.97),('9650','2013-01-19','11:15:00',2.4),('9650','2013-01-19','11:20:00',2.04),('9650','2013-01-19','11:25:00',2.4),('9650','2013-01-19','11:30:00',2.93),('9650','2013-01-19','11:35:00',2.52),('9650','2013-01-19','11:40:00',1.73),('9650','2013-01-19','11:45:00',1.63),('9650','2013-01-19','11:50:00',1.26),('9650','2013-01-19','12:00:00',1.01),('9650','2013-01-19','12:10:00',1.17),('9650','2013-01-19','12:15:00',1.44),('9650','2013-01-19','12:20:00',1.57),('9650','2013-01-19','12:25:00',1.64),('9650','2013-01-19','12:30:00',1.49),('9650','2013-01-19','12:35:00',1.36),('9650','2013-01-19','12:40:00',1.28),('9650','2013-01-19','12:45:00',1.24),('9650','2013-01-19','12:50:00',1.23),('9650','2013-01-19','12:55:00',1.2),('9650','2013-01-19','13:00:00',1.14),('9650','2013-01-19','13:05:00',1.08),('9650','2013-01-19','13:10:00',1.11),('9650','2013-01-19','13:15:00',1.24),('9650','2013-01-19','13:20:00',1.27),('9650','2013-01-19','13:25:00',1.26),('9650','2013-01-19','13:30:00',1.19),('9650','2013-01-19','13:35:00',1.31),('9650','2013-01-19','13:40:00',1.53),('9650','2013-01-19','13:45:00',1.51),('9650','2013-01-19','13:50:00',1.45),('9650','2013-01-19','13:55:00',1.28),('9650','2013-01-19','14:00:00',1.13),('9650','2013-01-19','14:15:00',1.01),('9650','2013-01-19','14:20:00',1.2),('9650','2013-01-19','14:25:00',1.07),('9650','2013-01-18','09:10:00',1.07),('9650','2013-01-18','09:15:00',1.17),('9650','2013-01-18','09:20:00',1.17),('9650','2013-01-18','09:25:00',1.18),('9650','2013-01-18','09:30:00',1.17),('9650','2013-01-18','09:35:00',1.1),('9650','2013-01-18','09:40:00',1.03),('9650','2013-01-18','09:45:00',1.34),('9650','2013-01-18','09:50:00',1.52),('9650','2013-01-18','09:55:00',1.94),('9650','2013-01-18','10:00:00',2.05),('9650','2013-01-18','10:05:00',1.65),('9650','2013-01-18','10:10:00',1.19),('9650','2013-01-18','10:35:00',1.59),('9650','2013-01-18','10:40:00',1.69),('9650','2013-01-18','10:45:00',2.06),('9650','2013-01-18','10:50:00',1.98),('9650','2013-01-18','10:55:00',1.16),('9650','2013-01-18','11:10:00',1.49),('9650','2013-01-18','11:15:00',1.61),('9650','2013-01-18','11:20:00',1.95),('9650','2013-01-18','11:25:00',1.92),('9650','2013-01-18','11:30:00',1.56),('9650','2013-01-18','11:35:00',1.1),('9650','2013-01-18','11:45:00',1.13),('9650','2013-01-18','11:50:00',1.25),('9650','2013-01-18','11:55:00',1.19),('9650','2013-01-18','12:05:00',1.01),('9650','2013-01-18','12:10:00',1.15),('9650','2013-01-18','12:15:00',1.21),('9650','2013-01-18','12:20:00',1.11),('9650','2013-01-18','14:35:00',1.05),('9650','2013-01-17','08:45:00',1),('9650','2013-01-17','10:05:00',1.1),('9650','2013-01-17','10:10:00',1.4),('9650','2013-01-17','10:15:00',2.07),('9650','2013-01-17','10:20:00',2.07),('9650','2013-01-17','10:25:00',1.88),('9650','2013-01-17','10:30:00',1.82),('9650','2013-01-17','10:35:00',1.61),('9650','2013-01-17','10:40:00',1.37),('9650','2013-01-17','10:45:00',1.33),('9650','2013-01-17','10:50:00',1.38),('9650','2013-01-17','10:55:00',1.43),('9650','2013-01-17','11:00:00',1.5),('9650','2013-01-17','11:05:00',1.58),('9650','2013-01-17','11:10:00',1.52),('9650','2013-01-17','11:15:00',1.52),('9650','2013-01-17','11:20:00',1.36),('9650','2013-01-17','11:25:00',1.51),('9650','2013-01-17','11:30:00',1.86),('9650','2013-01-17','11:35:00',2.01),('9650','2013-01-17','11:40:00',1.88),('9650','2013-01-17','11:45:00',1.6),('9650','2013-01-17','11:50:00',1.39),('9650','2013-01-17','11:55:00',1.49),('9650','2013-01-17','12:00:00',1.6),('9650','2013-01-17','12:05:00',1.63),('9650','2013-01-17','12:10:00',1.83),('9650','2013-01-17','12:15:00',1.85),('9650','2013-01-17','12:20:00',1.84),('9650','2013-01-17','12:25:00',1.88),('9650','2013-01-17','12:30:00',1.88),('9650','2013-01-17','12:35:00',2.1),('9650','2013-01-17','12:40:00',2.22),('9650','2013-01-17','12:45:00',2.39),('9650','2013-01-17','12:50:00',2.99),('9650','2013-01-17','12:55:00',3.22),('9650','2013-01-17','13:00:00',3.75),('9650','2013-01-17','13:05:00',3.58),('9650','2013-01-17','13:10:00',3.3),('9650','2013-01-17','13:15:00',3.67),('9650','2013-01-17','13:20:00',3),('9650','2013-01-17','13:25:00',2.49),('9650','2013-01-17','13:30:00',2.29),('9650','2013-01-17','13:35:00',2.16),('9650','2013-01-17','13:40:00',2.32),('9650','2013-01-17','13:45:00',3.69),('9650','2013-01-17','13:50:00',4.14),('9650','2013-01-17','13:55:00',4.09),('9650','2013-01-17','14:00:00',3.76),('9650','2013-01-17','14:05:00',3.72),('9650','2013-01-17','14:10:00',2.69),('9650','2013-01-17','14:15:00',3.3),('9650','2013-01-17','14:20:00',2.51),('9650','2013-01-17','14:25:00',2.6),('9650','2013-01-17','14:30:00',1.93),('9650','2013-01-17','14:35:00',1.66),('9650','2013-01-17','14:40:00',1.53),('9650','2013-01-17','14:45:00',1.56),('9650','2013-01-17','14:50:00',1.61),('9650','2013-01-17','14:55:00',1.48),('9650','2013-01-17','15:00:00',1.32),('9650','2013-01-17','15:05:00',1.35),('9650','2013-01-17','15:10:00',1.29),('9650','2013-01-17','15:15:00',1.36),('9650','2013-01-17','15:20:00',1.21),('9650','2013-01-17','15:25:00',1.23),('9650','2013-01-17','15:30:00',1.13),('9650','2013-01-17','15:35:00',1),('9650','2013-01-17','15:50:00',1.05),('9650','2013-01-17','15:55:00',1.05),('9650','2013-01-16','09:10:00',1.15),('9650','2013-01-16','09:15:00',1.15),('9650','2013-01-16','09:20:00',1.07),('9650','2013-01-16','09:30:00',1.02),('9650','2013-01-16','09:35:00',1.09),('9650','2013-01-16','09:40:00',1.24),('9650','2013-01-16','09:45:00',1.32),('9650','2013-01-16','09:50:00',1.36),('9650','2013-01-16','09:55:00',1.37),('9650','2013-01-16','10:00:00',1.4),('9650','2013-01-16','10:05:00',1.51),('9650','2013-01-16','10:10:00',1.67),('9650','2013-01-16','10:15:00',1.77),('9650','2013-01-16','10:20:00',1.7),('9650','2013-01-16','10:25:00',1.82),('9650','2013-01-16','10:30:00',1.9),('9650','2013-01-16','10:35:00',1.9),('9650','2013-01-16','10:40:00',2),('9650','2013-01-16','10:45:00',2.03),('9650','2013-01-16','10:50:00',1.95),('9650','2013-01-16','10:55:00',2.11),('9650','2013-01-16','11:00:00',2.05),('9650','2013-01-16','11:05:00',2.02),('9650','2013-01-16','11:10:00',2.17),('9650','2013-01-16','11:15:00',2.11),('9650','2013-01-16','11:20:00',2.07),('9650','2013-01-16','11:25:00',1.81),('9650','2013-01-16','11:30:00',1.67),('9650','2013-01-16','11:35:00',1.79),('9650','2013-01-16','11:40:00',1.87),('9650','2013-01-16','11:45:00',1.75),('9650','2013-01-16','11:50:00',1.87),('9650','2013-01-16','11:55:00',2),('9650','2013-01-16','12:00:00',2.21),('9650','2013-01-16','12:05:00',2.24),('9650','2013-01-16','12:10:00',2.36),('9650','2013-01-16','12:15:00',2.53),('9650','2013-01-16','12:20:00',2.45),('9650','2013-01-16','12:25:00',2.25),('9650','2013-01-16','12:30:00',2.03),('9650','2013-01-16','12:35:00',2.36),('9650','2013-01-16','12:40:00',2.47),('9650','2013-01-16','12:45:00',2.12),('9650','2013-01-16','12:50:00',1.53),('9650','2013-01-16','12:55:00',1.57),('9650','2013-01-16','13:00:00',2.15),('9650','2013-01-16','13:05:00',2.11),('9650','2013-01-16','13:10:00',1.66),('9650','2013-01-16','13:15:00',2.09),('9650','2013-01-16','13:20:00',2.12),('9650','2013-01-16','13:25:00',1.81),('9650','2013-01-16','13:30:00',1.68),('9650','2013-01-16','13:35:00',2.28),('9650','2013-01-16','13:40:00',2.32),('9650','2013-01-16','13:45:00',2.18),('9650','2013-01-16','13:50:00',2.19),('9650','2013-01-16','13:55:00',1.44),('9650','2013-01-16','14:00:00',2.03),('9650','2013-01-16','14:05:00',1.6),('9650','2013-01-16','14:10:00',1.34),('9650','2013-01-16','14:20:00',1.22),('9650','2013-01-16','14:25:00',1.49),('9650','2013-01-16','14:30:00',1.92),('9650','2013-01-16','14:35:00',2.55),('9650','2013-01-16','14:40:00',1.09),('9650','2013-01-16','14:55:00',1.25),('9650','2013-01-16','15:00:00',1.25),('9650','2013-01-15','10:00:00',1.18),('9650','2013-01-15','10:35:00',1.49),('9650','2013-01-15','10:40:00',1.16),('9650','2013-01-15','10:45:00',1.2),('9650','2013-01-15','10:55:00',1.58),('9650','2013-01-15','11:00:00',1.24),('9650','2013-01-15','11:05:00',1.27),('9650','2013-01-15','11:25:00',1.88),('9650','2013-01-15','12:00:00',2.51),('9650','2013-01-15','12:05:00',2.13),('9650','2013-01-15','12:10:00',2.51),('9650','2013-01-15','12:15:00',3.83),('9650','2013-01-15','12:20:00',3.24),('9650','2013-01-15','12:25:00',1.27),('9650','2013-01-15','13:05:00',2.95),('9650','2013-01-15','13:10:00',4.77),('9650','2013-01-15','13:15:00',5.11),('9650','2013-01-15','13:20:00',3.44),('9650','2013-01-15','13:25:00',2.37),('9650','2013-01-15','13:30:00',1.04),('9650','2013-01-15','13:55:00',3.53),('9650','2013-01-15','14:00:00',2.44),('9650','2013-01-15','14:05:00',1.78),('9650','2013-01-15','15:05:00',1.42),('9650','2013-01-15','15:10:00',1.26),('9650','2013-01-14','09:55:00',1.2),('9650','2013-01-14','10:00:00',1.54),('9650','2013-01-14','10:05:00',1.2),('9650','2013-01-14','10:10:00',1.57),('9650','2013-01-14','10:15:00',1.25),('9650','2013-01-14','10:20:00',1.14),('9650','2013-01-14','10:25:00',1.26),('9650','2013-01-14','10:35:00',1.03),('9650','2013-01-14','10:40:00',1.24),('9650','2013-01-14','10:45:00',1.33),('9650','2013-01-14','10:50:00',1.7),('9650','2013-01-14','10:55:00',1.89),('9650','2013-01-14','11:00:00',1.95),('9650','2013-01-14','11:05:00',2.06),('9650','2013-01-14','11:10:00',2.12),('9650','2013-01-14','11:15:00',1.96),('9650','2013-01-14','11:20:00',1.98),('9650','2013-01-14','11:25:00',2.05),('9650','2013-01-14','11:30:00',2.07),('9650','2013-01-14','11:35:00',2.03),('9650','2013-01-14','11:40:00',1.93),('9650','2013-01-14','11:45:00',1.86),('9650','2013-01-14','11:50:00',1.81),('9650','2013-01-14','11:55:00',1.93),('9650','2013-01-14','12:00:00',1.84),('9650','2013-01-14','12:05:00',1.74),('9650','2013-01-14','12:10:00',1.67),('9650','2013-01-14','12:15:00',1.82),('9650','2013-01-14','12:20:00',2.04),('9650','2013-01-14','12:25:00',2.06),('9650','2013-01-14','12:30:00',2),('9650','2013-01-14','12:35:00',2.01),('9650','2013-01-14','12:40:00',2.18),('9650','2013-01-14','12:45:00',2.22),('9650','2013-01-14','12:50:00',2.22),('9650','2013-01-14','12:55:00',1.96),('9650','2013-01-14','13:00:00',1.7),('9650','2013-01-14','13:05:00',1.78),('9650','2013-01-14','13:10:00',1.81),('9650','2013-01-14','13:15:00',1.86),('9650','2013-01-14','13:20:00',1.88),('9650','2013-01-14','13:25:00',1.82),('9650','2013-01-14','13:30:00',1.96),('9650','2013-01-14','13:35:00',2.02),('9650','2013-01-14','13:40:00',2.22),('9650','2013-01-14','13:45:00',2.01),('9650','2013-01-14','13:50:00',1.91),('9650','2013-01-14','13:55:00',2.12),('9650','2013-01-14','14:00:00',3.19),('9650','2013-01-14','14:05:00',3.07),('9650','2013-01-14','14:10:00',2.36),('9650','2013-01-14','14:15:00',3.6),('9650','2013-01-14','14:20:00',3.8),('9650','2013-01-14','14:25:00',2.72),('9650','2013-01-14','14:30:00',2.91),('9650','2013-01-14','14:35:00',2.34),('9650','2013-01-14','14:40:00',1.74),('9650','2013-01-14','14:45:00',2.24),('9650','2013-01-14','14:50:00',2.06),('9650','2013-01-14','14:55:00',2.24),('9650','2013-01-14','15:00:00',2),('9650','2013-01-14','15:05:00',1.7),('9650','2013-01-14','15:10:00',1.38),('9650','2013-01-14','15:15:00',1.31),('9650','2013-01-14','15:20:00',1.25),('9650','2013-01-14','15:25:00',1.21),('9650','2013-01-14','15:30:00',1.21),('9650','2013-01-14','15:35:00',1.11),('9650','2013-01-14','15:40:00',1.04),('9650','2013-01-14','15:45:00',1.03),('9650','2013-01-14','15:50:00',1.03),('9650','2013-01-14','15:55:00',1.04),('9650','2013-01-14','16:00:00',1.12),('9650','2013-01-14','16:05:00',1.14),('9650','2013-01-14','16:10:00',1.07),('9650','2013-01-13','11:25:00',1.09),('9650','2013-01-13','12:20:00',1.16),('9650','2013-01-13','12:25:00',1.42),('9650','2013-01-13','12:30:00',1.46),('9650','2013-01-13','12:35:00',1.37),('9650','2013-01-13','12:40:00',1.61),('9650','2013-01-13','12:45:00',1.73),('9650','2013-01-13','12:50:00',1.9),('9650','2013-01-13','12:55:00',1.92),('9650','2013-01-13','13:00:00',2),('9650','2013-01-13','13:05:00',1.89),('9650','2013-01-13','13:10:00',1.51),('9650','2013-01-13','13:15:00',1.37),('9650','2013-01-13','13:35:00',1.16),('9650','2013-01-13','15:15:00',1.79),('9650','2013-01-13','15:20:00',1.48),('9650','2013-01-13','15:25:00',1.46),('9650','2013-01-12','09:15:00',1.24),('9650','2013-01-12','09:20:00',1.33),('9650','2013-01-12','09:25:00',1.23),('9650','2013-01-12','09:30:00',1.27),('9650','2013-01-12','09:35:00',1.2),('9650','2013-01-12','09:50:00',1.06),('9650','2013-01-12','10:05:00',1.17),('9650','2013-01-12','10:10:00',1.38),('9650','2013-01-12','10:15:00',1.25),('9650','2013-01-12','10:20:00',1.17),('9650','2013-01-12','10:25:00',1.39),('9650','2013-01-12','10:30:00',1.82),('9650','2013-01-12','10:35:00',1.45),('9650','2013-01-12','10:40:00',1.08),('9650','2013-01-12','12:20:00',1.03),('9650','2013-01-11','10:45:00',1.03),('9650','2013-01-11','10:50:00',1.1),('9650','2013-01-11','10:55:00',1.18),('9650','2013-01-11','11:00:00',1.29),('9650','2013-01-11','11:05:00',1.42),('9650','2013-01-11','11:10:00',1.53),('9650','2013-01-11','11:15:00',1.62),('9650','2013-01-11','11:20:00',1.71),('9650','2013-01-11','11:25:00',1.81),('9650','2013-01-11','11:30:00',1.89),('9650','2013-01-11','11:35:00',1.94),('9650','2013-01-11','11:40:00',2.03),('9650','2013-01-11','11:45:00',2.12),('9650','2013-01-11','11:50:00',2.19),('9650','2013-01-11','11:55:00',2.24),('9650','2013-01-11','12:00:00',2.3),('9650','2013-01-11','12:05:00',2.34),('9650','2013-01-11','12:10:00',2.35),('9650','2013-01-11','12:15:00',2.39),('9650','2013-01-11','12:20:00',2.48),('9650','2013-01-11','12:25:00',2.48),('9650','2013-01-11','12:30:00',2.51),('9650','2013-01-11','12:35:00',2.6),('9650','2013-01-11','12:40:00',1.84),('9650','2013-01-11','12:45:00',1.52),('9650','2013-01-11','12:50:00',2.47),('9650','2013-01-11','13:00:00',1.79),('9650','2013-01-11','13:05:00',2.75),('9650','2013-01-11','13:10:00',2.12),('9650','2013-01-11','13:15:00',1.58),('9650','2013-01-11','13:20:00',1.27),('9650','2013-01-11','13:25:00',2.42),('9650','2013-01-11','13:30:00',2.81),('9650','2013-01-11','13:35:00',1.81),('9650','2013-01-11','13:40:00',1.06),('9650','2013-01-11','13:45:00',1.8),('9650','2013-01-11','13:50:00',2.62),('9650','2013-01-11','13:55:00',3.34),('9650','2013-01-11','14:00:00',2.37),('9650','2013-01-11','14:05:00',2.66),('9650','2013-01-11','14:10:00',2.1),('9650','2013-01-11','14:15:00',2.1),('9650','2013-01-11','14:20:00',2.24),('9650','2013-01-11','14:25:00',2.24),('9650','2013-01-11','14:30:00',2.14),('9650','2013-01-11','14:35:00',2.06),('9650','2013-01-11','14:40:00',2.03),('9650','2013-01-11','14:45:00',1.98),('9650','2013-01-11','14:50:00',1.9),('9650','2013-01-11','14:55:00',1.82),('9650','2013-01-11','15:00:00',1.59),('9650','2013-01-11','15:05:00',1.34),('9650','2013-01-11','15:10:00',1.18),('9650','2013-01-11','15:15:00',1.17),('9650','2013-01-11','15:20:00',1.14),('9650','2013-01-11','15:25:00',1.11),('9650','2014-03-18','08:25:00',1.02),('9650','2014-03-18','08:30:00',1.11),('9650','2014-03-18','08:35:00',1.23),('9650','2014-03-18','08:40:00',1.39),('9650','2014-03-18','08:45:00',1.54),('9650','2014-03-18','08:50:00',1.61),('9650','2014-03-18','08:55:00',1.67),('9650','2014-03-18','09:00:00',1.71),('9650','2014-03-18','09:05:00',1.97),('9650','2014-03-18','09:10:00',2.15),('9650','2014-03-18','09:15:00',2.37),('9650','2014-03-18','09:20:00',2.33),('9650','2014-03-18','09:25:00',3.01),('9650','2014-03-18','09:30:00',3.52),('9650','2014-03-18','09:35:00',3.37),('9650','2014-03-18','09:40:00',3.63),('9650','2014-03-18','09:45:00',3.3),('9650','2014-03-18','09:50:00',3.14),('9650','2014-03-18','09:55:00',2.98),('9650','2014-03-18','10:00:00',2.19),('9650','2014-03-18','10:05:00',1.76),('9650','2014-03-18','10:10:00',1.56),('9650','2014-03-18','10:15:00',1.49),('9650','2014-03-18','10:20:00',1.65),('9650','2014-03-18','10:25:00',1.81),('9650','2014-03-18','10:30:00',2.18),('9650','2014-03-18','10:35:00',3.29),('9650','2014-03-18','10:40:00',2.95),('9650','2014-03-18','10:45:00',2.54),('9650','2014-03-18','10:50:00',2.64),('9650','2014-03-18','10:55:00',2.6),('9650','2014-03-18','11:00:00',4.21),('9650','2014-03-18','11:05:00',5.38),('9650','2014-03-18','11:10:00',2.98),('9650','2014-03-18','11:15:00',2.84),('9650','2014-03-18','11:20:00',2.71),('9650','2014-03-18','11:25:00',2.91),('9650','2014-03-18','11:30:00',2.76),('9650','2014-03-18','11:35:00',3.21),('9650','2014-03-18','11:40:00',2.96),('9650','2014-03-18','11:45:00',2.91),('9650','2014-03-18','11:50:00',3.4),('9650','2014-03-18','11:55:00',2.83),('9650','2014-03-18','12:00:00',4.96),('9650','2014-03-18','12:05:00',6.22),('9650','2014-03-18','12:10:00',6.23),('9650','2014-03-18','12:15:00',6.19),('9650','2014-03-18','12:20:00',6.41),('9650','2014-03-18','12:25:00',5.36),('9650','2014-03-18','12:30:00',5.44),('9650','2014-03-18','12:35:00',5.79),('9650','2014-03-18','12:40:00',5.78),('9650','2014-03-18','12:45:00',5.6),('9650','2014-03-18','12:50:00',5.44),('9650','2014-03-18','12:55:00',5.61),('9650','2014-03-18','13:00:00',5.59),('9650','2014-03-18','13:05:00',5.42),('9650','2014-03-18','13:10:00',5.61),('9650','2014-03-18','13:15:00',5.37),('9650','2014-03-18','13:20:00',4.45),('9650','2014-03-18','13:25:00',4.84),('9650','2014-03-18','13:30:00',5.55),('9650','2014-03-18','13:35:00',5.66),('9650','2014-03-18','13:40:00',5.49),('9650','2014-03-18','13:45:00',5.51),('9650','2014-03-18','13:50:00',5.26),('9650','2014-03-18','13:55:00',5.45),('9650','2014-03-18','14:00:00',5.35),('9650','2014-03-18','14:05:00',5.38),('9650','2014-03-18','14:10:00',5.38),('9650','2014-03-18','14:15:00',5.09),('9650','2014-03-18','14:20:00',4.98),('9650','2014-03-18','14:25:00',4.93),('9650','2014-03-18','14:30:00',4.76),('9650','2014-03-18','14:35:00',4.88),('9650','2014-03-18','14:40:00',4.86),('9650','2014-03-18','14:45:00',4.79),('9650','2014-03-18','14:50:00',4.61),('9650','2014-03-18','14:55:00',4.54),('9650','2014-03-18','15:00:00',4.31),('9650','2014-03-18','15:05:00',4.19),('9650','2014-03-18','15:10:00',4.21),('9650','2014-03-18','15:15:00',4.24),('9650','2014-03-18','15:20:00',4.14),('9650','2014-03-18','15:25:00',4.1),('9650','2014-03-18','15:30:00',3.86),('9650','2014-03-18','15:35:00',3.72),('9650','2014-03-18','15:40:00',3.79),('9650','2014-03-18','15:45:00',3.8),('9650','2014-03-18','15:50:00',3.71),('9650','2014-03-18','15:55:00',3.71),('9650','2014-03-18','16:00:00',3.57),('9650','2014-03-18','16:05:00',3.52),('9650','2014-03-18','16:10:00',3.42),('9650','2014-03-18','16:15:00',3.25),('9650','2014-03-18','16:20:00',3.1),('9650','2014-03-18','16:25:00',2.91),('9650','2014-03-18','16:30:00',2.88),('9650','2014-03-18','16:35:00',2.69),('9650','2014-03-18','16:40:00',2.54),('9650','2014-03-18','16:45:00',2.49),('9650','2014-03-18','16:50:00',2.15),('9650','2014-03-18','16:55:00',2.06),('9650','2014-03-18','17:00:00',1.63),('9650','2014-03-18','17:05:00',1.38),('9650','2014-03-18','17:10:00',1.29),('9650','2014-03-18','17:15:00',1.44),('9650','2014-03-18','17:20:00',1.37),('9650','2014-03-18','17:25:00',1.26),('9650','2013-01-10','10:05:00',1.32),('9650','2013-01-10','10:10:00',1.34),('9650','2013-01-10','10:15:00',1.53),('9650','2013-01-10','10:20:00',1.36),('9650','2013-01-10','10:45:00',1.01),('9650','2013-01-10','10:50:00',1.09),('9650','2013-01-10','10:55:00',1.19),('9650','2013-01-10','11:00:00',1.29),('9650','2013-01-10','11:05:00',1.4),('9650','2013-01-10','11:10:00',1.53),('9650','2013-01-10','11:15:00',1.64),('9650','2013-01-10','11:20:00',1.72),('9650','2013-01-10','11:25:00',1.53),('9650','2013-01-10','11:30:00',1.67),('9650','2013-01-10','11:35:00',1.83),('9650','2013-01-10','11:40:00',1.73),('9650','2013-01-10','11:45:00',2.05),('9650','2013-01-10','11:50:00',2.07),('9650','2013-01-10','11:55:00',1.94),('9650','2013-01-10','12:00:00',1.7),('9650','2013-01-10','12:05:00',1.25),('9650','2013-01-10','12:20:00',1.06),('9650','2013-01-10','12:55:00',2.32),('9650','2013-01-10','13:00:00',2.03),('9650','2013-01-10','13:10:00',1.75),('9650','2013-01-10','13:15:00',1.68),('9650','2013-01-10','13:20:00',1.4),('9650','2013-01-10','13:25:00',1.16),('9650','2013-01-10','13:30:00',1.74),('9650','2013-01-10','13:35:00',3.47),('9650','2013-01-10','13:40:00',2.28),('9650','2013-01-10','13:45:00',1.84),('9650','2013-01-10','14:20:00',2.16),('9650','2013-01-10','14:25:00',1.83),('9650','2013-01-10','14:30:00',1.26),('9650','2013-01-10','14:35:00',1.35),('9650','2013-01-10','14:40:00',1.27),('9650','2013-01-10','14:45:00',2.17),('9650','2013-01-10','14:50:00',2.33),('9650','2013-01-10','14:55:00',1.79),('9650','2013-01-10','15:00:00',1.91),('9650','2013-01-10','15:05:00',1.65),('9650','2013-01-10','15:45:00',1.09),('9650','2013-01-09','11:25:00',1.32),('9650','2013-01-09','11:30:00',1.77),('9650','2013-01-09','11:35:00',1.48),('9650','2013-01-09','11:50:00',1.4),('9650','2013-01-09','11:55:00',1.95),('9650','2013-01-09','12:00:00',1.98),('9650','2013-01-09','12:05:00',1.96),('9650','2013-01-09','12:10:00',1.73),('9650','2013-01-09','12:15:00',1.48),('9650','2013-01-09','12:20:00',1.13),('9650','2013-01-09','12:40:00',1.03),('9650','2013-01-09','12:45:00',1.03),('9650','2013-01-09','13:15:00',1.17),('9650','2013-01-09','13:20:00',1),('9650','2013-01-09','13:45:00',1.12),('9650','2013-01-09','13:55:00',1.1),('9650','2013-01-09','14:00:00',1.25),('9650','2013-01-09','14:05:00',1.05),('9650','2013-01-08','09:50:00',1.01),('9650','2013-01-08','09:55:00',1.09),('9650','2013-01-08','10:00:00',1.14),('9650','2013-01-08','10:05:00',1.12),('9650','2013-01-08','10:10:00',1.05),('9650','2013-01-08','10:15:00',1.03),('9650','2013-01-08','10:25:00',1.14),('9650','2013-01-08','10:30:00',1.28),('9650','2013-01-08','10:35:00',1.3),('9650','2013-01-08','10:40:00',1.31),('9650','2013-01-08','10:45:00',1.44),('9650','2013-01-08','10:50:00',1.57),('9650','2013-01-08','10:55:00',1.64),('9650','2013-01-08','11:00:00',1.41),('9650','2013-01-08','11:05:00',1.61),('9650','2013-01-08','11:10:00',1.87),('9650','2013-01-08','11:15:00',2),('9650','2013-01-08','11:20:00',1.74),('9650','2013-01-08','11:25:00',1.74),('9650','2013-01-08','11:30:00',1.76),('9650','2013-01-08','11:35:00',1.82),('9650','2013-01-08','11:40:00',1.8),('9650','2013-01-08','11:45:00',1.75),('9650','2013-01-08','11:50:00',1.84),('9650','2013-01-08','11:55:00',2.02),('9650','2013-01-08','12:00:00',1.74),('9650','2013-01-08','12:05:00',1.82),('9650','2013-01-08','12:10:00',1.85),('9650','2013-01-08','12:15:00',1.8),('9650','2013-01-08','12:20:00',1.81),('9650','2013-01-08','12:25:00',1.65),('9650','2013-01-08','12:30:00',1.64),('9650','2013-01-08','12:35:00',1.74),('9650','2013-01-08','12:40:00',1.72),('9650','2013-01-08','12:45:00',1.7),('9650','2013-01-08','12:50:00',1.79),('9650','2013-01-08','12:55:00',1.91),('9650','2013-01-08','13:00:00',1.95),('9650','2013-01-08','13:05:00',1.91),('9650','2013-01-08','13:10:00',2.3),('9650','2013-01-08','13:15:00',2.07),('9650','2013-01-08','13:20:00',1.61),('9650','2013-01-08','13:25:00',1.45),('9650','2013-01-08','13:30:00',1.39),('9650','2013-01-08','13:35:00',1.44),('9650','2013-01-08','13:40:00',1.5),('9650','2013-01-08','13:45:00',1.5),('9650','2013-01-08','13:50:00',1.34),('9650','2013-01-08','13:55:00',1.31),('9650','2013-01-08','14:00:00',1.4),('9650','2013-01-08','14:05:00',1.3),('9650','2013-01-08','14:10:00',1.23),('9650','2013-01-08','14:15:00',1.12),('9650','2013-01-08','14:20:00',1.02),('9650','2013-01-07','09:45:00',1.01),('9650','2013-01-07','09:50:00',1.15),('9650','2013-01-07','09:55:00',1.19),('9650','2013-01-07','10:00:00',1.16),('9650','2013-01-07','10:05:00',1.11),('9650','2013-01-07','10:10:00',1.03),('9650','2013-01-07','10:40:00',1),('9650','2013-01-07','10:45:00',1.04),('9650','2013-01-07','10:50:00',1.09),('9650','2013-01-07','10:55:00',1.13),('9650','2013-01-07','11:00:00',1.19),('9650','2013-01-07','11:05:00',1.32),('9650','2013-01-07','11:10:00',1.46),('9650','2013-01-07','11:15:00',1.6),('9650','2013-01-07','11:20:00',1.69),('9650','2013-01-07','11:25:00',1.81),('9650','2013-01-07','11:30:00',1.93),('9650','2013-01-07','11:35:00',2.04),('9650','2013-01-07','11:40:00',2.18),('9650','2013-01-07','11:45:00',2.72),('9650','2013-01-07','11:50:00',2.41),('9650','2013-01-07','11:55:00',2.24),('9650','2013-01-07','12:00:00',2.24),('9650','2013-01-07','12:05:00',2.23),('9650','2013-01-07','12:10:00',2.41),('9650','2013-01-07','12:15:00',2.33),('9650','2013-01-07','12:20:00',2.08),('9650','2013-01-07','12:25:00',1.99),('9650','2013-01-07','12:30:00',1.91),('9650','2013-01-07','12:35:00',1.81),('9650','2013-01-07','12:40:00',2.12),('9650','2013-01-07','12:45:00',2.35),('9650','2013-01-07','12:50:00',2.47),('9650','2013-01-07','12:55:00',1.81),('9650','2013-01-07','13:00:00',1.22),('9650','2013-01-07','13:05:00',1.3),('9650','2013-01-07','13:10:00',1.23),('9650','2013-01-07','13:15:00',1.19),('9650','2013-01-07','13:20:00',1.44),('9650','2013-01-07','13:25:00',1.5),('9650','2013-01-07','13:30:00',1.24),('9650','2013-01-07','13:35:00',1.35),('9650','2013-01-07','13:40:00',1.53),('9650','2013-01-07','13:45:00',1.83),('9650','2013-01-07','13:50:00',2.3),('9650','2013-01-07','13:55:00',3.1),('9650','2013-01-07','14:00:00',1.96),('9650','2013-01-07','14:05:00',1.98),('9650','2013-01-07','14:10:00',1.35),('9650','2013-01-07','14:15:00',1.4),('9650','2013-01-07','14:20:00',1.23),('9650','2013-01-07','14:25:00',1.39),('9650','2013-01-07','14:30:00',1.52),('9650','2013-01-07','14:35:00',1.53),('9650','2013-01-07','14:40:00',1.7),('9650','2013-01-07','14:45:00',1.19),('9650','2013-01-07','14:55:00',1.03),('9650','2013-01-07','15:05:00',1.1),('9650','2013-01-07','15:10:00',1.11),('9650','2013-01-07','15:15:00',1.3),('9650','2013-01-07','15:20:00',1.06),('9650','2013-01-07','15:35:00',1.14),('9650','2013-01-07','15:40:00',1.03),('9650','2013-01-06','10:45:00',1.07),('9650','2013-01-06','10:50:00',1.09),('9650','2013-01-06','10:55:00',1.18),('9650','2013-01-06','11:00:00',1.25),('9650','2013-01-06','11:05:00',1.34),('9650','2013-01-06','11:10:00',1.44),('9650','2013-01-06','11:15:00',1.58),('9650','2013-01-06','11:20:00',1.66),('9650','2013-01-06','11:25:00',1.75),('9650','2013-01-06','11:30:00',1.81),('9650','2013-01-06','11:35:00',1.88),('9650','2013-01-06','11:40:00',1.95),('9650','2013-01-06','11:45:00',2.02),('9650','2013-01-06','11:50:00',2.07),('9650','2013-01-06','11:55:00',2.11),('9650','2013-01-06','12:00:00',2.19),('9650','2013-01-06','12:05:00',2.23),('9650','2013-01-06','12:10:00',2.27),('9650','2013-01-06','12:15:00',2.32),('9650','2013-01-06','12:20:00',2.37),('9650','2013-01-06','12:25:00',2.42),('9650','2013-01-06','12:30:00',2.44),('9650','2013-01-06','12:35:00',2.48),('9650','2013-01-06','12:40:00',2.52),('9650','2013-01-06','12:45:00',2.53),('9650','2013-01-06','12:50:00',2.55),('9650','2013-01-06','12:55:00',2.56),('9650','2013-01-06','13:00:00',2.55),('9650','2013-01-06','13:05:00',2.59),('9650','2013-01-06','13:10:00',2.57),('9650','2013-01-06','13:15:00',2.57),('9650','2013-01-06','13:20:00',2.56),('9650','2013-01-06','13:25:00',2.58),('9650','2013-01-06','13:30:00',2.59),('9650','2013-01-06','13:35:00',2.55),('9650','2013-01-06','13:40:00',2.51),('9650','2013-01-06','13:45:00',2.45),('9650','2013-01-06','13:50:00',2.41),('9650','2013-01-06','13:55:00',2.33),('9650','2013-01-06','14:00:00',2.28),('9650','2013-01-06','14:05:00',2.22),('9650','2013-01-06','14:10:00',2.19),('9650','2013-01-06','14:15:00',2.16),('9650','2013-01-06','14:20:00',2.12),('9650','2013-01-06','14:25:00',2.07),('9650','2013-01-06','14:30:00',2),('9650','2013-01-06','14:35:00',1.9),('9650','2013-01-06','14:40:00',1.88),('9650','2013-01-06','14:45:00',1.78),('9650','2013-01-06','14:50:00',1.75),('9650','2013-01-06','14:55:00',1.58),('9650','2013-01-06','15:00:00',1.36),('9650','2013-01-06','15:05:00',1.19),('9650','2013-01-06','15:10:00',1.08),('9650','2013-01-05','10:55:00',1.06),('9650','2013-01-05','11:00:00',1.19),('9650','2013-01-05','11:05:00',1.28),('9650','2013-01-05','11:10:00',1.38),('9650','2013-01-05','11:15:00',1.52),('9650','2013-01-05','11:20:00',1.61),('9650','2013-01-05','11:25:00',1.7),('9650','2013-01-05','11:30:00',1.8),('9650','2013-01-05','11:35:00',1.86),('9650','2013-01-05','11:40:00',1.94),('9650','2013-01-05','11:45:00',2.01),('9650','2013-01-05','11:50:00',2.05),('9650','2013-01-05','11:55:00',2.11),('9650','2013-01-05','12:00:00',2.17),('9650','2013-01-05','12:05:00',2.22),('9650','2013-01-05','12:10:00',2.27),('9650','2013-01-05','12:15:00',2.29),('9650','2013-01-05','12:20:00',2.33),('9650','2013-01-05','12:25:00',2.37),('9650','2013-01-05','12:30:00',2.4),('9650','2013-01-05','12:35:00',2.39),('9650','2013-01-05','12:40:00',2.4),('9650','2013-01-05','12:45:00',2.49),('9650','2013-01-05','12:50:00',2.55),('9650','2013-01-05','12:55:00',2.58),('9650','2013-01-05','13:00:00',2.6),('9650','2013-01-05','13:05:00',2.6),('9650','2013-01-05','13:10:00',2.62),('9650','2013-01-05','13:15:00',2.62),('9650','2013-01-05','13:20:00',2.63),('9650','2013-01-05','13:25:00',2.62),('9650','2013-01-05','13:30:00',2.65),('9650','2013-01-05','13:35:00',2.62),('9650','2013-01-05','13:40:00',2.58),('9650','2013-01-05','13:45:00',2.54),('9650','2013-01-05','13:50:00',2.49),('9650','2013-01-05','13:55:00',2.4),('9650','2013-01-05','14:00:00',2.38),('9650','2013-01-05','14:05:00',2.41),('9650','2013-01-05','14:10:00',2.24),('9650','2013-01-05','14:15:00',2.23),('9650','2013-01-05','14:20:00',2.17),('9650','2013-01-05','14:25:00',2.02),('9650','2013-01-05','14:30:00',2.01),('9650','2013-01-05','14:35:00',1.9),('9650','2013-01-05','14:40:00',1.86),('9650','2013-01-05','14:45:00',1.76),('9650','2013-01-05','14:50:00',1.68),('9650','2013-01-05','14:55:00',1.58),('9650','2013-01-05','15:00:00',1.35),('9650','2013-01-05','15:05:00',1.16),('9650','2013-01-05','15:10:00',1.08),('9650','2013-01-05','15:15:00',1.04),('9650','2013-01-04','09:40:00',1.09),('9650','2013-01-04','09:45:00',1.11),('9650','2013-01-04','09:50:00',1.15),('9650','2013-01-04','09:55:00',1.24),('9650','2013-01-04','10:00:00',1.34),('9650','2013-01-04','10:05:00',1.35),('9650','2013-01-04','10:10:00',1.31),('9650','2013-01-04','10:15:00',1.33),('9650','2013-01-04','10:20:00',1.33),('9650','2013-01-04','10:25:00',1.28),('9650','2013-01-04','10:30:00',1.3),('9650','2013-01-04','10:35:00',1.38),('9650','2013-01-04','10:40:00',1.39),('9650','2013-01-04','10:45:00',1.32),('9650','2013-01-04','10:50:00',1.32),('9650','2013-01-04','10:55:00',1.72),('9650','2013-01-04','11:00:00',1.54),('9650','2013-01-04','11:05:00',1.64),('9650','2013-01-04','11:10:00',1.59),('9650','2013-01-04','11:15:00',1.41),('9650','2013-01-04','11:20:00',1.86),('9650','2013-01-04','11:25:00',2.08),('9650','2013-01-04','11:30:00',2.24),('9650','2013-01-04','11:35:00',2.28),('9650','2013-01-04','11:40:00',2.29),('9650','2013-01-04','11:45:00',2.44),('9650','2013-01-04','11:50:00',2.32),('9650','2013-01-04','11:55:00',2.19),('9650','2013-01-04','12:00:00',2.09),('9650','2013-01-04','12:05:00',2.06),('9650','2013-01-04','12:10:00',2.12),('9650','2013-01-04','12:15:00',2.2),('9650','2013-01-04','12:20:00',2.03),('9650','2013-01-04','12:25:00',1.77),('9650','2013-01-04','12:30:00',1.7),('9650','2013-01-04','12:35:00',2.08),('9650','2013-01-04','12:40:00',2.67),('9650','2013-01-04','12:45:00',3.01),('9650','2013-01-04','12:50:00',2.18),('9650','2013-01-04','12:55:00',1.92),('9650','2013-01-04','13:00:00',1.99),('9650','2013-01-04','13:05:00',1.92),('9650','2013-01-04','13:10:00',1.82),('9650','2013-01-04','13:15:00',1.55),('9650','2013-01-04','13:20:00',1.44),('9650','2013-01-04','13:25:00',1.62),('9650','2013-01-04','13:30:00',2.58),('9650','2013-01-04','13:35:00',2.13),('9650','2013-01-04','13:40:00',1.67),('9650','2013-01-04','13:45:00',1.47),('9650','2013-01-04','13:50:00',1.58),('9650','2013-01-04','13:55:00',1.83),('9650','2013-01-04','14:00:00',1.67),('9650','2013-01-04','14:05:00',2.39),('9650','2013-01-04','14:10:00',2.14),('9650','2013-01-04','14:15:00',1.82),('9650','2013-01-04','14:20:00',1.52),('9650','2013-01-04','14:25:00',1.08),('9650','2013-01-04','14:30:00',1.71),('9650','2013-01-04','14:35:00',1.67),('9650','2013-01-04','14:40:00',1.78),('9650','2013-01-04','14:45:00',1.95),('9650','2013-01-04','14:50:00',1.3),('9650','2013-01-04','14:55:00',1.15),('9650','2013-01-04','15:00:00',1.76),('9650','2013-01-04','15:05:00',1.36),('9650','2013-01-03','10:05:00',1),('9650','2013-01-03','10:35:00',1.07),('9650','2013-01-03','10:40:00',1.19),('9650','2013-01-03','10:45:00',1.34),('9650','2013-01-03','10:50:00',1.61),('9650','2013-01-03','10:55:00',1.9),('9650','2013-01-03','11:00:00',2.08),('9650','2013-01-03','11:05:00',1.9),('9650','2013-01-03','11:10:00',1.6),('9650','2013-01-03','11:15:00',1.5),('9650','2013-01-03','11:20:00',1.39),('9650','2013-01-03','11:25:00',1.17),('9650','2013-01-03','11:30:00',1.03),('9650','2013-01-03','11:35:00',1.13),('9650','2013-01-03','11:40:00',1.03),('9650','2013-01-03','11:45:00',1.4),('9650','2013-01-03','11:50:00',2.28),('9650','2013-01-03','11:55:00',2.94),('9650','2013-01-03','12:00:00',3.24),('9650','2013-01-03','12:05:00',2.88),('9650','2013-01-03','12:10:00',2.38),('9650','2013-01-03','12:15:00',1.72),('9650','2013-01-03','12:20:00',1.37),('9650','2013-01-03','12:25:00',1.37),('9650','2013-01-03','12:30:00',2.03),('9650','2013-01-03','12:35:00',1.75),('9650','2013-01-03','12:40:00',2.61),('9650','2013-01-03','12:45:00',2.7),('9650','2013-01-03','12:50:00',2.79),('9650','2013-01-03','12:55:00',2.76),('9650','2013-01-03','13:00:00',2.72),('9650','2013-01-03','13:05:00',2.58),('9650','2013-01-03','13:10:00',2.01),('9650','2013-01-03','13:15:00',2.29),('9650','2013-01-03','13:20:00',2.53),('9650','2013-01-03','13:25:00',2.47),('9650','2013-01-03','13:30:00',2.46),('9650','2013-01-03','13:35:00',2.47),('9650','2013-01-03','13:40:00',2.43),('9650','2013-01-03','13:45:00',2.4),('9650','2013-01-03','13:50:00',2.32),('9650','2013-01-03','13:55:00',2.27),('9650','2013-01-03','14:00:00',2.17),('9650','2013-01-03','14:05:00',2.12),('9650','2013-01-03','14:10:00',2.11),('9650','2013-01-03','14:15:00',2.09),('9650','2013-01-03','14:20:00',2.03),('9650','2013-01-03','14:25:00',1.97),('9650','2013-01-03','14:30:00',1.93),('9650','2013-01-03','14:35:00',1.82),('9650','2013-01-03','14:40:00',1.72),('9650','2013-01-03','14:45:00',1.66),('9650','2013-01-03','14:50:00',1.62),('9650','2013-01-03','14:55:00',1.46),('9650','2013-01-03','15:00:00',1.25),('9650','2013-01-03','15:05:00',1.12),('9650','2013-01-02','09:55:00',1.09),('9650','2013-01-02','10:00:00',1.18),('9650','2013-01-02','10:05:00',1.28),('9650','2013-01-02','10:10:00',1.31),('9650','2013-01-02','10:15:00',1.5),('9650','2013-01-02','10:20:00',1.61),('9650','2013-01-02','10:25:00',1.72),('9650','2013-01-02','10:30:00',1.73),('9650','2013-01-02','10:35:00',1.71),('9650','2013-01-02','10:40:00',1.73),('9650','2013-01-02','10:45:00',1.76),('9650','2013-01-02','10:50:00',1.83),('9650','2013-01-02','10:55:00',1.8),('9650','2013-01-02','11:00:00',1.88),('9650','2013-01-02','11:05:00',1.76),('9650','2013-01-02','11:10:00',1.69),('9650','2013-01-02','11:15:00',1.58),('9650','2013-01-02','11:20:00',1.38),('9650','2013-01-02','11:25:00',1.07),('9650','2013-01-02','11:30:00',1.05),('9650','2013-01-02','11:35:00',1.03),('9650','2013-01-02','11:40:00',1.99),('9650','2013-01-02','11:45:00',2.02),('9650','2013-01-02','11:50:00',2.06),('9650','2013-01-02','11:55:00',2.1),('9650','2013-01-02','12:00:00',2.13),('9650','2013-01-02','12:05:00',2.18),('9650','2013-01-02','12:10:00',2.23),('9650','2013-01-02','12:15:00',2.27),('9650','2013-01-02','12:20:00',2.31),('9650','2013-01-02','12:25:00',2.35),('9650','2013-01-02','12:30:00',2.38),('9650','2013-01-02','12:35:00',2.42),('9650','2013-01-02','12:40:00',2.45),('9650','2013-01-02','12:45:00',2.47),('9650','2013-01-02','12:50:00',2.48),('9650','2013-01-02','12:55:00',2.51),('9650','2013-01-02','13:00:00',2.53),('9650','2013-01-02','13:05:00',2.53),('9650','2013-01-02','13:10:00',2.55),('9650','2013-01-02','13:15:00',2.55),('9650','2013-01-02','13:20:00',2.56),('9650','2013-01-02','13:25:00',2.56),('9650','2013-01-02','13:30:00',2.54),('9650','2013-01-02','13:35:00',2.53),('9650','2013-01-02','13:40:00',2.49),('9650','2013-01-02','13:45:00',2.45),('9650','2013-01-02','13:50:00',2.41),('9650','2013-01-02','13:55:00',2.34),('9650','2013-01-02','14:00:00',2.23),('9650','2013-01-02','14:05:00',2.21),('9650','2013-01-02','14:10:00',2.17),('9650','2013-01-02','14:15:00',2.16),('9650','2013-01-02','14:20:00',2.12),('9650','2013-01-02','14:25:00',2.05),('9650','2013-01-02','14:30:00',1.97),('9650','2013-01-02','14:35:00',1.92),('9650','2013-01-02','14:40:00',1.87),('9650','2013-01-02','14:45:00',1.77),('9650','2013-01-02','14:50:00',1.7),('9650','2013-01-02','14:55:00',1.54),('9650','2013-01-02','15:00:00',1.33),('9650','2013-01-02','15:05:00',1.22),('9650','2013-01-02','15:10:00',1.13),('9650','2013-01-02','15:15:00',1.06),('9650','2013-01-01','10:00:00',1.07),('9650','2013-01-01','10:05:00',1.02),('9650','2013-01-01','11:10:00',1.1),('9650','2013-01-01','13:40:00',1.44),('9650','2013-01-01','13:45:00',1.52),('9650','2013-01-01','13:50:00',1.33),('9650','2013-01-01','13:55:00',1.25),('9650','2013-01-01','14:00:00',1.2),('9650','2014-03-17','07:55:00',1.14),('9650','2014-03-17','08:00:00',1.05),('9650','2014-03-17','08:05:00',1.04),('9650','2014-03-17','08:10:00',1.13),('9650','2014-03-17','08:15:00',1.19),('9650','2014-03-17','08:20:00',1.52),('9650','2014-03-17','08:25:00',1.46),('9650','2014-03-17','08:30:00',1.42),('9650','2014-03-17','08:40:00',1.06),('9650','2014-03-17','08:45:00',1.13),('9650','2014-03-17','08:50:00',1.74),('9650','2014-03-17','08:55:00',2.48),('9650','2014-03-17','09:00:00',2.39),('9650','2014-03-17','09:05:00',2.49),('9650','2014-03-17','09:10:00',2.11),('9650','2014-03-17','09:15:00',2.71),('9650','2014-03-17','09:20:00',2.91),('9650','2014-03-17','09:25:00',2.21),('9650','2014-03-17','09:30:00',2.24),('9650','2014-03-17','09:35:00',2.73),('9650','2014-03-17','09:40:00',2.01),('9650','2014-03-17','09:45:00',2.19),('9650','2014-03-17','09:50:00',2.29),('9650','2014-03-17','09:55:00',2.25),('9650','2014-03-17','10:00:00',2.82),('9650','2014-03-17','10:05:00',3.25),('9650','2014-03-17','10:10:00',3.98),('9650','2014-03-17','10:15:00',3.68),('9650','2014-03-17','10:20:00',3.88),('9650','2014-03-17','10:25:00',2.79),('9650','2014-03-17','10:30:00',3.55),('9650','2014-03-17','10:35:00',5.01),('9650','2014-03-17','10:40:00',3.5),('9650','2014-03-17','10:45:00',4.58),('9650','2014-03-17','10:50:00',4.93),('9650','2014-03-17','10:55:00',5.19),('9650','2014-03-17','11:00:00',3.48),('9650','2014-03-17','11:05:00',3.18),('9650','2014-03-17','11:10:00',2.37),('9650','2014-03-17','11:15:00',2.7),('9650','2014-03-17','11:20:00',4.51),('9650','2014-03-17','11:25:00',4.96),('9650','2014-03-17','11:30:00',4.67),('9650','2014-03-17','11:35:00',5.44),('9650','2014-03-17','11:40:00',4.26),('9650','2014-03-17','11:45:00',4.6),('9650','2014-03-17','11:50:00',3.79),('9650','2014-03-17','11:55:00',3.01),('9650','2014-03-17','12:00:00',2.92),('9650','2014-03-17','12:05:00',4.46),('9650','2014-03-17','12:10:00',4.54),('9650','2014-03-17','12:15:00',5.45),('9650','2014-03-17','12:20:00',2.35),('9650','2014-03-17','12:25:00',1.88),('9650','2014-03-17','12:30:00',2.23),('9650','2014-03-17','12:35:00',3.72),('9650','2014-03-17','12:40:00',2.14),('9650','2014-03-17','12:45:00',6.18),('9650','2014-03-17','12:50:00',4.44),('9650','2014-03-17','12:55:00',5.47),('9650','2014-03-17','13:00:00',5.88),('9650','2014-03-17','13:05:00',5.89),('9650','2014-03-17','13:10:00',5.79),('9650','2014-03-17','13:15:00',5.66),('9650','2014-03-17','13:20:00',5.7),('9650','2014-03-17','13:25:00',4.95),('9650','2014-03-17','13:30:00',5.43),('9650','2014-03-17','13:35:00',5.51),('9650','2014-03-17','13:40:00',5.53),('9650','2014-03-17','13:45:00',5.47),('9650','2014-03-17','13:50:00',5.44),('9650','2014-03-17','13:55:00',5.53),('9650','2014-03-17','14:00:00',5.34),('9650','2014-03-17','14:05:00',5.28),('9650','2014-03-17','14:10:00',5.31),('9650','2014-03-17','14:15:00',5.18),('9650','2014-03-17','14:20:00',5.14),('9650','2014-03-17','14:25:00',5.04),('9650','2014-03-17','14:30:00',4.95),('9650','2014-03-17','14:35:00',4.92),('9650','2014-03-17','14:40:00',4.82),('9650','2014-03-17','14:45:00',4.69),('9650','2014-03-17','14:50:00',4.66),('9650','2014-03-17','14:55:00',4.51),('9650','2014-03-17','15:00:00',4.28),('9650','2014-03-17','15:05:00',4.25),('9650','2014-03-17','15:10:00',4.19),('9650','2014-03-17','15:15:00',4.27),('9650','2014-03-17','15:20:00',4.22),('9650','2014-03-17','15:25:00',4.02),('9650','2014-03-17','15:30:00',3.92),('9650','2014-03-17','15:35:00',3.83),('9650','2014-03-17','15:40:00',3.8),('9650','2014-03-17','15:45:00',3.79),('9650','2014-03-17','15:50:00',3.63),('9650','2014-03-17','15:55:00',3.64),('9650','2014-03-17','16:00:00',3.58),('9650','2014-03-17','16:05:00',3.5),('9650','2014-03-17','16:10:00',3.39),('9650','2014-03-17','16:15:00',3.23),('9650','2014-03-17','16:20:00',3.04),('9650','2014-03-17','16:25:00',3.01),('9650','2014-03-17','16:30:00',2.98),('9650','2014-03-17','16:35:00',2.85),('9650','2014-03-17','16:40:00',2.75),('9650','2014-03-17','16:45:00',2.5),('9650','2014-03-17','16:50:00',2.43),('9650','2014-03-17','16:55:00',2.25),('9650','2014-03-17','17:00:00',2.24),('9650','2014-03-17','17:05:00',2.11),('9650','2014-03-17','17:10:00',1.89),('9650','2014-03-17','17:15:00',1.69),('9650','2014-03-17','17:20:00',1.48),('9650','2014-03-17','17:25:00',1.34),('9650','2014-03-17','17:30:00',1.14),('9650','2012-12-31','10:40:00',1),('9650','2012-12-31','10:45:00',1.3),('9650','2012-12-31','10:50:00',1.72),('9650','2012-12-31','10:55:00',1.35),('9650','2012-12-31','11:05:00',1.42),('9650','2012-12-31','11:10:00',1.54),('9650','2012-12-31','11:15:00',1.48),('9650','2012-12-31','11:20:00',1.52),('9650','2012-12-31','11:25:00',2.15),('9650','2012-12-31','11:30:00',2.78),('9650','2012-12-31','11:35:00',1.93),('9650','2012-12-31','11:40:00',1.82),('9650','2012-12-31','11:45:00',2.06),('9650','2012-12-31','11:50:00',2.05),('9650','2012-12-31','11:55:00',1.93),('9650','2012-12-31','12:00:00',1.85),('9650','2012-12-31','12:05:00',1.75),('9650','2012-12-31','12:10:00',1.98),('9650','2012-12-31','12:15:00',1.86),('9650','2012-12-31','12:20:00',2.02),('9650','2012-12-31','12:25:00',1.86),('9650','2012-12-31','12:30:00',1.58),('9650','2012-12-31','12:35:00',1.52),('9650','2012-12-31','12:40:00',1.75),('9650','2012-12-31','12:45:00',2.06),('9650','2012-12-31','12:50:00',1.91),('9650','2012-12-31','12:55:00',1.81),('9650','2012-12-31','13:00:00',1.63),('9650','2012-12-31','13:05:00',1.58),('9650','2012-12-31','13:10:00',1.31),('9650','2012-12-31','13:15:00',1.35),('9650','2012-12-31','13:20:00',1.37),('9650','2012-12-31','13:25:00',1.16),('9650','2012-12-31','13:30:00',1.02),('9650','2012-12-30','10:50:00',1.05),('9650','2012-12-30','10:55:00',1.14),('9650','2012-12-30','11:00:00',1.24),('9650','2012-12-30','11:05:00',1.31),('9650','2012-12-30','11:10:00',1.36),('9650','2012-12-30','11:15:00',1.54),('9650','2012-12-30','11:20:00',1.66),('9650','2012-12-30','11:25:00',1.76),('9650','2012-12-30','11:30:00',1.84),('9650','2012-12-30','11:35:00',1.9),('9650','2012-12-30','11:40:00',1.98),('9650','2012-12-30','11:45:00',2.05),('9650','2012-12-30','11:50:00',2.1),('9650','2012-12-30','11:55:00',2.16),('9650','2012-12-30','12:00:00',2.19),('9650','2012-12-30','12:05:00',2.27),('9650','2012-12-30','12:10:00',2.31),('9650','2012-12-30','12:15:00',2.36),('9650','2012-12-30','12:20:00',2.4),('9650','2012-12-30','12:25:00',2.43),('9650','2012-12-30','12:30:00',2.46),('9650','2012-12-30','12:35:00',2.49),('9650','2012-12-30','12:40:00',2.52),('9650','2012-12-30','12:45:00',2.56),('9650','2012-12-30','12:50:00',2.58),('9650','2012-12-30','12:55:00',2.58),('9650','2012-12-30','13:00:00',2.59),('9650','2012-12-30','13:05:00',2.61),('9650','2012-12-30','13:10:00',2.62),('9650','2012-12-30','13:15:00',2.63),('9650','2012-12-30','13:20:00',2.64),('9650','2012-12-30','13:25:00',2.62),('9650','2012-12-30','13:30:00',2.62),('9650','2012-12-30','13:35:00',2.61),('9650','2012-12-30','13:40:00',2.54),('9650','2012-12-30','13:45:00',2.5),('9650','2012-12-30','13:50:00',2.43),('9650','2012-12-30','13:55:00',2.35),('9650','2012-12-30','14:00:00',2.25),('9650','2012-12-30','14:05:00',2.2),('9650','2012-12-30','14:10:00',2.2),('9650','2012-12-30','14:15:00',2.16),('9650','2012-12-30','14:20:00',2.09),('9650','2012-12-30','14:25:00',2.05),('9650','2012-12-30','14:30:00',1.95),('9650','2012-12-30','14:35:00',1.87),('9650','2012-12-30','14:40:00',1.8),('9650','2012-12-30','14:45:00',1.73),('9650','2012-12-30','14:50:00',1.69),('9650','2012-12-30','14:55:00',1.43),('9650','2012-12-30','15:00:00',1.24),('9650','2012-12-30','15:05:00',1.12),('9650','2012-12-30','15:10:00',1.06),('9650','2012-12-29','10:55:00',1.05),('9650','2012-12-29','11:00:00',1.15),('9650','2012-12-29','11:05:00',1.24),('9650','2012-12-29','11:10:00',1.34),('9650','2012-12-29','11:15:00',1.48),('9650','2012-12-29','11:20:00',1.57),('9650','2012-12-29','11:25:00',1.68),('9650','2012-12-29','11:30:00',1.78),('9650','2012-12-29','11:35:00',1.84),('9650','2012-12-29','11:40:00',1.9),('9650','2012-12-29','11:45:00',1.98),('9650','2012-12-29','11:50:00',2.04),('9650','2012-12-29','11:55:00',2.1),('9650','2012-12-29','12:00:00',2.15),('9650','2012-12-29','12:05:00',2.19),('9650','2012-12-29','12:10:00',2.24),('9650','2012-12-29','12:15:00',2.29),('9650','2012-12-29','12:20:00',2.34),('9650','2012-12-29','12:25:00',2.35),('9650','2012-12-29','12:30:00',2.37),('9650','2012-12-29','12:35:00',2.41),('9650','2012-12-29','12:40:00',2.44),('9650','2012-12-29','12:45:00',2.44),('9650','2012-12-29','12:50:00',2.44),('9650','2012-12-29','12:55:00',2.49),('9650','2012-12-29','13:00:00',2.55),('9650','2012-12-29','13:05:00',2.58),('9650','2012-12-29','13:10:00',2.57),('9650','2012-12-29','13:15:00',2.59),('9650','2012-12-29','13:20:00',2.59),('9650','2012-12-29','13:25:00',2.59),('9650','2012-12-29','13:30:00',2.6),('9650','2012-12-29','13:35:00',2.56),('9650','2012-12-29','13:40:00',2.52),('9650','2012-12-29','13:45:00',2.49),('9650','2012-12-29','13:50:00',2.45),('9650','2012-12-29','13:55:00',2.36),('9650','2012-12-29','14:00:00',2.27),('9650','2012-12-29','14:05:00',2.22),('9650','2012-12-29','14:10:00',2.2),('9650','2012-12-29','14:15:00',2.17),('9650','2012-12-29','14:20:00',2.1),('9650','2012-12-29','14:25:00',2.02),('9650','2012-12-29','14:30:00',1.92),('9650','2012-12-29','14:35:00',1.89),('9650','2012-12-29','14:40:00',1.76),('9650','2012-12-29','14:45:00',1.69),('9650','2012-12-29','14:50:00',1.65),('9650','2012-12-29','14:55:00',1.39),('9650','2012-12-29','15:00:00',1.19),('9650','2012-12-29','15:05:00',1.1),('9650','2012-12-29','15:10:00',1.03),('9650','2012-12-28','10:55:00',1.03),('9650','2012-12-28','11:00:00',1.14),('9650','2012-12-28','11:05:00',1.21),('9650','2012-12-28','11:10:00',1.33),('9650','2012-12-28','11:15:00',1.46),('9650','2012-12-28','11:20:00',1.57),('9650','2012-12-28','11:25:00',1.67),('9650','2012-12-28','11:30:00',1.75),('9650','2012-12-28','11:35:00',1.84),('9650','2012-12-28','11:40:00',1.89),('9650','2012-12-28','11:45:00',1.96),('9650','2012-12-28','11:50:00',2.03),('9650','2012-12-28','11:55:00',2.08),('9650','2012-12-28','12:00:00',2.15),('9650','2012-12-28','12:05:00',2.2),('9650','2012-12-28','12:10:00',2.26),('9650','2012-12-28','12:15:00',2.29),('9650','2012-12-28','12:20:00',2.31),('9650','2012-12-28','12:25:00',2.35),('9650','2012-12-28','12:30:00',2.38),('9650','2012-12-28','12:35:00',2.44),('9650','2012-12-28','12:40:00',2.49),('9650','2012-12-28','12:45:00',2.49),('9650','2012-12-28','12:50:00',2.5),('9650','2012-12-28','12:55:00',2.54),('9650','2012-12-28','13:00:00',2.58),('9650','2012-12-28','13:05:00',2.6),('9650','2012-12-28','13:10:00',2.6),('9650','2012-12-28','13:15:00',2.61),('9650','2012-12-28','13:20:00',2.61),('9650','2012-12-28','13:25:00',2.61),('9650','2012-12-28','13:30:00',2.59),('9650','2012-12-28','13:35:00',2.57),('9650','2012-12-28','13:40:00',2.53),('9650','2012-12-28','13:45:00',2.5),('9650','2012-12-28','13:50:00',2.46),('9650','2012-12-28','13:55:00',2.36),('9650','2012-12-28','14:00:00',2.26),('9650','2012-12-28','14:05:00',2.22),('9650','2012-12-28','14:10:00',2.2),('9650','2012-12-28','14:15:00',2.18),('9650','2012-12-28','14:20:00',2.11),('9650','2012-12-28','14:25:00',2.07),('9650','2012-12-28','14:30:00',1.93),('9650','2012-12-28','14:35:00',1.91),('9650','2012-12-28','14:40:00',1.77),('9650','2012-12-28','14:45:00',1.74),('9650','2012-12-28','14:50:00',1.67),('9650','2012-12-28','14:55:00',1.38),('9650','2012-12-28','15:00:00',1.2),('9650','2012-12-28','15:05:00',1.12),('9650','2012-12-28','15:10:00',1.04),('9650','2012-12-27','10:55:00',1.08),('9650','2012-12-27','11:00:00',1.18),('9650','2012-12-27','11:05:00',1.25),('9650','2012-12-27','11:10:00',1.32),('9650','2012-12-27','11:15:00',1.47),('9650','2012-12-27','11:20:00',1.48),('9650','2012-12-27','11:25:00',1.67),('9650','2012-12-27','11:30:00',1.76),('9650','2012-12-27','11:35:00',1.85),('9650','2012-12-27','11:40:00',1.9),('9650','2012-12-27','11:45:00',2),('9650','2012-12-27','11:50:00',1.83),('9650','2012-12-27','11:55:00',2.06),('9650','2012-12-27','12:00:00',2.05),('9650','2012-12-27','12:05:00',2.01),('9650','2012-12-27','12:10:00',2.19),('9650','2012-12-27','12:15:00',2.21),('9650','2012-12-27','12:20:00',2.25),('9650','2012-12-27','12:25:00',2.27),('9650','2012-12-27','12:30:00',2.34),('9650','2012-12-27','12:35:00',2.34),('9650','2012-12-27','12:40:00',2.38),('9650','2012-12-27','12:45:00',2.4),('9650','2012-12-27','12:50:00',2.44),('9650','2012-12-27','12:55:00',2.27),('9650','2012-12-27','13:00:00',2.48),('9650','2012-12-27','13:05:00',2.48),('9650','2012-12-27','13:10:00',2.49),('9650','2012-12-27','13:15:00',2.49),('9650','2012-12-27','13:20:00',2.48),('9650','2012-12-27','13:25:00',2.51),('9650','2012-12-27','13:30:00',2.5),('9650','2012-12-27','13:35:00',2.48),('9650','2012-12-27','13:40:00',2.39),('9650','2012-12-27','13:45:00',2.35),('9650','2012-12-27','13:50:00',2.32),('9650','2012-12-27','13:55:00',2.16),('9650','2012-12-27','14:00:00',2.05),('9650','2012-12-27','14:05:00',1.95),('9650','2012-12-27','14:10:00',2.02),('9650','2012-12-27','14:15:00',2.02),('9650','2012-12-27','14:20:00',1.96),('9650','2012-12-27','14:25:00',1.88),('9650','2012-12-27','14:30:00',1.65),('9650','2012-12-27','14:35:00',1.16),('9650','2012-12-27','14:40:00',1.59),('9650','2012-12-27','14:45:00',1.65),('9650','2012-12-27','14:50:00',1.58),('9650','2012-12-27','14:55:00',1.32),('9650','2012-12-27','15:00:00',1.2),('9650','2012-12-27','15:05:00',1.11),('9650','2012-12-27','15:10:00',1.04),('9650','2012-12-26','09:50:00',1),('9650','2012-12-26','10:05:00',1.19),('9650','2012-12-26','10:10:00',1.02),('9650','2012-12-26','10:45:00',1.02),('9650','2012-12-26','10:50:00',1.08),('9650','2012-12-26','10:55:00',1.17),('9650','2012-12-26','11:00:00',1.23),('9650','2012-12-26','11:05:00',1.41),('9650','2012-12-26','11:10:00',1.53),('9650','2012-12-26','11:50:00',1.56),('9650','2012-12-26','11:55:00',2.07),('9650','2012-12-26','12:00:00',2.25),('9650','2012-12-26','12:05:00',2.58),('9650','2012-12-26','12:10:00',2.82),('9650','2012-12-26','12:15:00',1.39),('9650','2012-12-26','12:20:00',1.58),('9650','2012-12-26','12:25:00',2.15),('9650','2012-12-26','12:30:00',2.3),('9650','2012-12-26','12:35:00',2.35),('9650','2012-12-26','12:40:00',2.49),('9650','2012-12-26','12:45:00',2.89),('9650','2012-12-26','12:50:00',2.32),('9650','2012-12-26','12:55:00',2.57),('9650','2012-12-26','13:00:00',2.6),('9650','2012-12-26','13:05:00',2.7),('9650','2012-12-26','13:10:00',2.61),('9650','2012-12-26','13:15:00',2.85),('9650','2012-12-26','13:20:00',2.68),('9650','2012-12-26','13:25:00',2.79),('9650','2012-12-26','13:30:00',2.6),('9650','2012-12-26','13:40:00',1.36),('9650','2012-12-26','14:00:00',1.87),('9650','2012-12-26','14:05:00',2.37),('9650','2012-12-26','14:10:00',2.51),('9650','2012-12-26','14:15:00',2.17),('9650','2012-12-26','14:20:00',1.97),('9650','2012-12-26','14:25:00',1.87),('9650','2012-12-26','14:30:00',1.85),('9650','2012-12-26','14:35:00',1.85),('9650','2012-12-26','14:40:00',1.69),('9650','2012-12-26','14:45:00',1.07),('9650','2012-12-26','14:55:00',1.27),('9650','2012-12-26','15:00:00',1.4),('9650','2012-12-26','15:05:00',1.11),('9650','2012-12-25','10:50:00',1.04),('9650','2012-12-25','10:55:00',1.14),('9650','2012-12-25','11:00:00',1.19),('9650','2012-12-25','11:05:00',1.23),('9650','2012-12-25','11:10:00',1.29),('9650','2012-12-25','11:15:00',1.33),('9650','2012-12-25','11:20:00',1.48),('9650','2012-12-25','11:25:00',1.67),('9650','2012-12-25','11:30:00',1.74),('9650','2012-12-25','11:35:00',1.81),('9650','2012-12-25','11:40:00',1.89),('9650','2012-12-25','11:45:00',1.96),('9650','2012-12-25','11:50:00',2.06),('9650','2012-12-25','11:55:00',2.16),('9650','2012-12-25','12:00:00',2.26),('9650','2012-12-25','12:05:00',2.34),('9650','2012-12-25','12:10:00',2.37),('9650','2012-12-25','12:15:00',2.39),('9650','2012-12-25','12:20:00',2.42),('9650','2012-12-25','12:25:00',2.49),('9650','2012-12-25','12:30:00',2.49),('9650','2012-12-25','12:35:00',2.53),('9650','2012-12-25','12:40:00',2.6),('9650','2012-12-25','12:45:00',2.55),('9650','2012-12-25','12:50:00',2.52),('9650','2012-12-25','12:55:00',2.22),('9650','2012-12-25','13:00:00',2.74),('9650','2012-12-25','13:05:00',2.08),('9650','2012-12-25','13:10:00',2.85),('9650','2012-12-25','13:15:00',2.82),('9650','2012-12-25','13:20:00',3.07),('9650','2012-12-25','13:25:00',3.11),('9650','2012-12-25','13:30:00',3.46),('9650','2012-12-25','13:35:00',3.47),('9650','2012-12-25','13:40:00',3.46),('9650','2012-12-25','13:45:00',3.46),('9650','2012-12-25','13:50:00',3.11),('9650','2012-12-25','13:55:00',2.76),('9650','2012-12-25','14:00:00',2.6),('9650','2012-12-25','14:05:00',2.8),('9650','2012-12-25','14:10:00',1.55),('9650','2012-12-24','10:05:00',1.02),('9650','2012-12-24','10:10:00',1.13),('9650','2012-12-24','10:15:00',1.15),('9650','2012-12-24','10:20:00',1.23),('9650','2012-12-24','10:25:00',1.27),('9650','2012-12-24','10:30:00',1.3),('9650','2012-12-24','10:35:00',1.26),('9650','2012-12-24','10:40:00',1.22),('9650','2012-12-24','10:45:00',1.22),('9650','2012-12-24','10:50:00',1.22),('9650','2012-12-24','10:55:00',1.23),('9650','2012-12-24','11:00:00',1.28),('9650','2012-12-24','11:05:00',1.33),('9650','2012-12-24','11:10:00',1.4),('9650','2012-12-24','11:15:00',1.36),('9650','2012-12-24','11:20:00',1.43),('9650','2012-12-24','11:25:00',1.58),('9650','2012-12-24','11:30:00',1.53),('9650','2012-12-24','11:35:00',1.5),('9650','2012-12-24','11:40:00',1.41),('9650','2012-12-24','11:45:00',1.48),('9650','2012-12-24','11:50:00',1.48),('9650','2012-12-24','11:55:00',1.57),('9650','2012-12-24','12:00:00',1.61),('9650','2012-12-24','12:05:00',1.42),('9650','2012-12-24','12:10:00',1.35),('9650','2012-12-24','12:15:00',1.37),('9650','2012-12-24','12:20:00',1.44),('9650','2012-12-24','12:25:00',1.43),('9650','2012-12-24','12:30:00',1.33),('9650','2012-12-24','12:35:00',1.27),('9650','2012-12-24','12:40:00',1.28),('9650','2012-12-24','12:45:00',1.17),('9650','2012-12-24','12:50:00',1.26),('9650','2012-12-24','12:55:00',1.28),('9650','2012-12-24','13:00:00',1.29),('9650','2012-12-24','13:05:00',1.43),('9650','2012-12-24','13:10:00',1.52),('9650','2012-12-24','13:15:00',1.59),('9650','2012-12-24','13:20:00',1.61),('9650','2012-12-24','13:25:00',1.49),('9650','2012-12-24','13:30:00',1.3),('9650','2012-12-24','13:35:00',1.13),('9650','2012-12-24','13:40:00',1.11),('9650','2012-12-24','14:50:00',1.22),('9650','2012-12-24','14:55:00',1.15),('9650','2012-12-24','15:00:00',1.14),('9650','2012-12-24','15:10:00',1.02),('9650','2012-12-24','15:15:00',1.05),('9650','2012-12-23','11:15:00',1.04),('9650','2012-12-23','11:20:00',1.06),('9650','2012-12-23','11:25:00',1.04),('9650','2012-12-23','11:30:00',1.14),('9650','2012-12-23','11:35:00',1.18),('9650','2012-12-23','11:40:00',1.14),('9650','2012-12-23','11:45:00',1.06),('9650','2012-12-23','11:55:00',1.02),('9650','2012-12-23','12:00:00',1.15),('9650','2012-12-23','12:05:00',1.29),('9650','2012-12-23','12:10:00',1.42),('9650','2012-12-23','12:15:00',1.35),('9650','2012-12-23','12:20:00',1.31),('9650','2012-12-23','12:25:00',1.35),('9650','2012-12-23','12:40:00',1.09),('9650','2012-12-23','12:45:00',1.19),('9650','2012-12-23','12:50:00',1.11),('9650','2012-12-23','12:55:00',1.08),('9650','2012-12-23','13:00:00',1.04),('9650','2012-12-22','10:45:00',1.06),('9650','2012-12-22','10:50:00',1.1),('9650','2012-12-22','10:55:00',1.12),('9650','2012-12-22','11:00:00',1.26),('9650','2012-12-22','11:05:00',1.36),('9650','2012-12-22','11:10:00',1.43),('9650','2012-12-22','11:15:00',1.55),('9650','2012-12-22','11:20:00',1.68),('9650','2012-12-22','11:25:00',1.61),('9650','2012-12-22','11:30:00',1.79),('9650','2012-12-22','11:35:00',1.97),('9650','2012-12-22','11:40:00',2.05),('9650','2012-12-22','11:45:00',2.11),('9650','2012-12-22','11:50:00',2.24),('9650','2012-12-22','11:55:00',2.16),('9650','2012-12-22','12:00:00',2.12),('9650','2012-12-22','12:05:00',2.21),('9650','2012-12-22','12:10:00',2.28),('9650','2012-12-22','12:15:00',1.91),('9650','2012-12-22','12:20:00',1.91),('9650','2012-12-22','12:25:00',1.47),('9650','2012-12-22','12:30:00',1.66),('9650','2012-12-22','12:35:00',1.57),('9650','2012-12-22','12:40:00',1.84),('9650','2012-12-22','12:45:00',1.36),('9650','2012-12-22','12:50:00',1.82),('9650','2012-12-22','12:55:00',2.5),('9650','2012-12-22','13:00:00',2.72),('9650','2012-12-22','13:05:00',2.42),('9650','2012-12-22','13:10:00',2.72),('9650','2012-12-22','13:15:00',2.03),('9650','2012-12-22','13:20:00',1.9),('9650','2012-12-22','13:25:00',1.72),('9650','2012-12-22','13:30:00',1.56),('9650','2012-12-22','13:35:00',1.58),('9650','2012-12-22','13:40:00',1.82),('9650','2012-12-22','13:45:00',1.89),('9650','2012-12-22','13:50:00',1.9),('9650','2012-12-22','13:55:00',1.8),('9650','2012-12-22','14:00:00',2.38),('9650','2012-12-22','14:05:00',2.15),('9650','2012-12-22','14:10:00',1.99),('9650','2012-12-22','14:15:00',2.05),('9650','2012-12-22','14:20:00',1.61),('9650','2012-12-22','14:25:00',1.32),('9650','2012-12-22','14:30:00',1.25),('9650','2012-12-22','14:35:00',1.57),('9650','2012-12-22','14:40:00',1.7),('9650','2012-12-22','14:45:00',1.74),('9650','2012-12-22','14:50:00',1.27),('9650','2014-04-30','08:25:00',1.07),('9650','2014-04-30','08:30:00',1.15),('9650','2014-04-30','08:35:00',1.26),('9650','2014-04-30','08:40:00',1.44),('9650','2014-04-30','08:45:00',1.7),('9650','2014-04-30','08:50:00',2.06),('9650','2014-04-30','08:55:00',2.86),('9650','2014-04-30','09:00:00',2.4),('9650','2014-04-30','09:05:00',1.68),('9650','2014-04-30','09:10:00',2.37),('9650','2014-04-30','09:15:00',2.3),('9650','2014-04-30','09:20:00',2.12),('9650','2014-04-30','09:25:00',3.18),('9650','2014-04-30','09:30:00',3.2),('9650','2014-04-30','09:35:00',3.33),('9650','2014-04-30','09:40:00',3.71),('9650','2014-04-30','09:45:00',2.92),('9650','2014-04-30','09:50:00',3.23),('9650','2014-04-30','09:55:00',3.02),('9650','2014-04-30','10:00:00',2.74),('9650','2014-04-30','10:05:00',2.49),('9650','2014-04-30','10:10:00',4.86),('9650','2014-04-30','10:15:00',3.42),('9650','2014-04-30','10:20:00',2.36),('9650','2014-04-30','10:25:00',2.25),('9650','2014-04-30','10:30:00',4.3),('9650','2014-04-30','10:35:00',5.45),('9650','2014-04-30','10:40:00',3.64),('9650','2014-04-30','10:45:00',5.35),('9650','2014-04-30','10:50:00',5.57),('9650','2014-04-30','10:55:00',6.22),('9650','2014-04-30','11:00:00',5.4),('9650','2014-04-30','11:05:00',5.5),('9650','2014-04-30','11:10:00',4.18),('9650','2014-04-30','11:15:00',1.52),('9650','2014-04-30','11:20:00',3.72),('9650','2014-04-30','11:25:00',6.68),('9650','2014-04-30','11:30:00',6.49),('9650','2014-04-30','11:35:00',6.78),('9650','2014-04-30','11:40:00',5.47),('9650','2014-04-30','11:45:00',1.99),('9650','2014-04-30','11:50:00',6.69),('9650','2014-04-30','11:55:00',5.52),('9650','2014-04-30','12:00:00',1.72),('9650','2014-04-30','12:05:00',6.28),('9650','2014-04-30','12:10:00',5.89),('9650','2014-04-30','12:15:00',7.13),('9650','2014-04-30','12:20:00',6.23),('9650','2014-04-30','12:25:00',7.34),('9650','2014-04-30','12:30:00',7.38),('9650','2014-04-30','12:35:00',7.32),('9650','2014-04-30','12:40:00',7.59),('9650','2014-04-30','12:45:00',4.73),('9650','2014-04-30','12:50:00',4.76),('9650','2014-04-30','12:55:00',7.94),('9650','2014-04-30','13:00:00',8.12),('9650','2014-04-30','13:05:00',7.72),('9650','2014-04-30','13:10:00',7.86),('9650','2014-04-30','13:15:00',6.8),('9650','2014-04-30','13:20:00',7.91),('9650','2014-04-30','13:25:00',3.31),('9650','2014-04-30','13:30:00',5.47),('9650','2014-04-30','13:35:00',7.8),('9650','2014-04-30','13:40:00',8.08),('9650','2014-04-30','13:45:00',8.23),('9650','2014-04-30','13:50:00',8.69),('9650','2014-04-30','13:55:00',8.24),('9650','2014-04-30','14:00:00',7.87),('9650','2014-04-30','14:05:00',7.9),('9650','2014-04-30','14:10:00',7.62),('9650','2014-04-30','14:15:00',7.6),('9650','2014-04-30','14:20:00',7.46),('9650','2014-04-30','14:25:00',7.58),('9650','2014-04-30','14:30:00',7.29),('9650','2014-04-30','14:35:00',7.21),('9650','2014-04-30','14:40:00',7.51),('9650','2014-04-30','14:45:00',7.94),('9650','2014-04-30','14:50:00',7.92),('9650','2014-04-30','14:55:00',7.56),('9650','2014-04-30','15:00:00',8.04),('9650','2014-04-30','15:05:00',7.95),('9650','2014-04-30','15:10:00',6.64),('9650','2014-04-30','15:15:00',7.37),('9650','2014-04-30','15:20:00',7.47),('9650','2014-04-30','15:25:00',7.36),('9650','2014-04-30','15:30:00',7.19),('9650','2014-04-30','15:35:00',7.14),('9650','2014-04-30','15:40:00',7.08),('9650','2014-04-30','15:45:00',6.8),('9650','2014-04-30','15:50:00',7.02),('9650','2014-04-30','15:55:00',6.83),('9650','2014-04-30','16:00:00',6.81),('9650','2014-04-30','16:05:00',6.89),('9650','2014-04-30','16:10:00',6.59),('9650','2014-04-30','16:15:00',6.61),('9650','2014-04-30','16:20:00',6.13),('9650','2014-04-30','16:25:00',5.75),('9650','2014-04-30','16:30:00',6.16),('9650','2014-04-30','16:35:00',6.29),('9650','2014-04-30','16:40:00',6),('9650','2014-04-30','16:45:00',5.08),('9650','2014-04-30','16:50:00',4.73),('9650','2014-04-30','16:55:00',5.08),('9650','2014-04-30','17:00:00',5.35),('9650','2014-04-30','17:05:00',5.24),('9650','2014-04-30','17:10:00',5.74),('9650','2014-04-30','17:15:00',5.45),('9650','2014-04-30','17:20:00',5.34),('9650','2014-04-30','17:25:00',5.23),('9650','2014-04-30','17:30:00',5.1),('9650','2014-04-30','17:35:00',4.99),('9650','2014-04-30','17:40:00',4.87),('9650','2014-04-30','17:45:00',4.76),('9650','2014-04-30','17:50:00',4.6),('9650','2014-04-30','17:55:00',4.49),('9650','2014-04-30','18:00:00',4.48),('9650','2014-04-30','18:05:00',4.25),('9650','2014-04-30','18:10:00',3.9),('9650','2014-04-30','18:15:00',3.83),('9650','2014-04-30','18:20:00',3.72),('9650','2014-04-30','18:25:00',3.57),('9650','2014-04-30','18:30:00',3.41),('9650','2014-04-30','18:35:00',3.01),('9650','2014-04-30','18:40:00',2.99),('9650','2014-04-30','18:45:00',2.82),('9650','2014-04-30','18:50:00',2.63),('9650','2014-04-30','18:55:00',2.47),('9650','2014-04-30','19:00:00',2.2),('9650','2014-04-30','19:05:00',1.98),('9650','2014-04-30','19:10:00',1.79),('9650','2014-04-30','19:15:00',1.56),('9650','2014-04-30','19:20:00',1.36),('9650','2014-04-30','19:25:00',1.17),('9650','2012-12-21','09:30:00',1.01),('9650','2012-12-21','09:35:00',1.08),('9650','2012-12-21','09:40:00',1.04),('9650','2012-12-21','09:50:00',1.06),('9650','2012-12-21','09:55:00',1.13),('9650','2012-12-21','10:00:00',1.17),('9650','2012-12-21','10:05:00',1.2),('9650','2012-12-21','10:10:00',1.22),('9650','2012-12-21','10:15:00',1.19),('9650','2012-12-21','10:20:00',1.21),('9650','2012-12-21','10:25:00',1.4),('9650','2012-12-21','10:30:00',1.47),('9650','2012-12-21','10:35:00',1.56),('9650','2012-12-21','10:40:00',1.53),('9650','2012-12-21','10:45:00',1.51),('9650','2012-12-21','10:50:00',1.49),('9650','2012-12-21','10:55:00',1.55),('9650','2012-12-21','11:00:00',1.12),('9650','2012-12-21','11:20:00',1.03),('9650','2012-12-21','11:30:00',1.07),('9650','2012-12-21','11:35:00',1.43),('9650','2012-12-21','11:40:00',2.3),('9650','2012-12-21','11:45:00',2.08),('9650','2012-12-21','11:50:00',2.3),('9650','2012-12-21','11:55:00',1.86),('9650','2012-12-21','12:00:00',1.91),('9650','2012-12-21','12:05:00',1.09),('9650','2012-12-21','12:10:00',1.2),('9650','2012-12-21','12:15:00',1.23),('9650','2012-12-21','12:20:00',1.04),('9650','2012-12-21','12:25:00',1.05),('9650','2012-12-21','12:30:00',1.19),('9650','2012-12-21','12:35:00',1.3),('9650','2012-12-21','12:40:00',1.91),('9650','2012-12-21','12:45:00',3.22),('9650','2012-12-21','12:50:00',3.16),('9650','2012-12-21','12:55:00',2.88),('9650','2012-12-21','13:00:00',3.29),('9650','2012-12-21','13:05:00',3.16),('9650','2012-12-21','13:10:00',3.6),('9650','2012-12-21','13:15:00',3.81),('9650','2012-12-21','13:20:00',3.76),('9650','2012-12-21','13:25:00',3.63),('9650','2012-12-21','13:30:00',3.27),('9650','2012-12-21','13:35:00',3.37),('9650','2012-12-21','13:40:00',2.15),('9650','2012-12-21','13:45:00',1.36),('9650','2012-12-21','13:50:00',1.58),('9650','2012-12-21','13:55:00',1.48),('9650','2012-12-21','14:00:00',1.77),('9650','2012-12-21','14:05:00',1.61),('9650','2012-12-21','14:10:00',1.91),('9650','2012-12-21','14:15:00',1.97),('9650','2012-12-21','14:20:00',1.47),('9650','2012-12-21','14:55:00',1.05),('9650','2012-12-21','15:00:00',1.33),('9650','2014-03-15','08:10:00',1.02),('9650','2014-03-15','08:15:00',1.04),('9650','2014-03-15','08:20:00',1.09),('9650','2014-03-15','08:25:00',1.13),('9650','2014-03-15','08:30:00',1.18),('9650','2014-03-15','08:35:00',1.24),('9650','2014-03-15','08:40:00',1.33),('9650','2014-03-15','08:45:00',1.44),('9650','2014-03-15','08:50:00',1.54),('9650','2014-03-15','08:55:00',1.6),('9650','2014-03-15','09:00:00',1.61),('9650','2014-03-15','09:05:00',1.69),('9650','2014-03-15','09:10:00',1.85),('9650','2014-03-15','09:15:00',2.03),('9650','2014-03-15','09:20:00',2.13),('9650','2014-03-15','09:25:00',2.16),('9650','2014-03-15','09:30:00',2.23),('9650','2014-03-15','09:35:00',2.31),('9650','2014-03-15','09:40:00',2.33),('9650','2014-03-15','09:45:00',2.5),('9650','2014-03-15','09:50:00',2.64),('9650','2014-03-15','09:55:00',2.7),('9650','2014-03-15','10:00:00',2.84),('9650','2014-03-15','10:05:00',2.91),('9650','2014-03-15','10:10:00',3.04),('9650','2014-03-15','10:15:00',3.18),('9650','2014-03-15','10:20:00',3.24),('9650','2014-03-15','10:25:00',3.37),('9650','2014-03-15','10:30:00',3.43),('9650','2014-03-15','10:35:00',3.5),('9650','2014-03-15','10:40:00',3.61),('9650','2014-03-15','10:45:00',2.85),('9650','2014-03-15','10:50:00',3.51),('9650','2014-03-15','10:55:00',3.82),('9650','2014-03-15','11:00:00',4.05),('9650','2014-03-15','11:05:00',4.16),('9650','2014-03-15','11:10:00',4.28),('9650','2014-03-15','11:15:00',4.33),('9650','2014-03-15','11:20:00',4.37),('9650','2014-03-15','11:25:00',4.44),('9650','2014-03-15','11:30:00',4.54),('9650','2014-03-15','11:35:00',4.64),('9650','2014-03-15','11:40:00',4.74),('9650','2014-03-15','11:45:00',4.75),('9650','2014-03-15','11:50:00',4.74),('9650','2014-03-15','11:55:00',4.71),('9650','2014-03-15','12:00:00',4.67),('9650','2014-03-15','12:05:00',4.88),('9650','2014-03-15','12:10:00',4.9),('9650','2014-03-15','12:15:00',4.83),('9650','2014-03-15','12:20:00',4.8),('9650','2014-03-15','12:25:00',4.92),('9650','2014-03-15','12:30:00',5.05),('9650','2014-03-15','12:35:00',5.14),('9650','2014-03-15','12:40:00',5.17),('9650','2014-03-15','12:45:00',5.15),('9650','2014-03-15','12:50:00',5.18),('9650','2014-03-15','12:55:00',5.19),('9650','2014-03-15','13:00:00',5.09),('9650','2014-03-15','13:05:00',5.25),('9650','2014-03-15','13:10:00',5.05),('9650','2014-03-15','13:15:00',5.11),('9650','2014-03-15','13:20:00',5.03),('9650','2014-03-15','13:25:00',5.01),('9650','2014-03-15','13:30:00',5.16),('9650','2014-03-15','13:35:00',5.06),('9650','2014-03-15','13:40:00',5.2),('9650','2014-03-15','13:45:00',5.19),('9650','2014-03-15','13:50:00',5.16),('9650','2014-03-15','13:55:00',5.13),('9650','2014-03-15','14:00:00',4.84),('9650','2014-03-15','14:05:00',4.75),('9650','2014-03-15','14:10:00',4.74),('9650','2014-03-15','14:15:00',4.66),('9650','2014-03-15','14:20:00',4.68),('9650','2014-03-15','14:25:00',4.66),('9650','2014-03-15','14:30:00',4.63),('9650','2014-03-15','14:35:00',4.49),('9650','2014-03-15','14:40:00',4.44),('9650','2014-03-15','14:45:00',4.39),('9650','2014-03-15','14:50:00',4.13),('9650','2014-03-15','14:55:00',4.14),('9650','2014-03-15','15:00:00',4.26),('9650','2014-03-15','15:05:00',4.04),('9650','2014-03-15','15:10:00',3.74),('9650','2014-03-15','15:15:00',3.69),('9650','2014-03-15','15:20:00',3.2),('9650','2014-03-15','15:25:00',3.6),('9650','2014-03-15','15:30:00',3.35),('9650','2014-03-15','15:35:00',3.16),('9650','2014-03-15','15:40:00',2.51),('9650','2014-03-15','15:45:00',2.49),('9650','2014-03-15','15:50:00',2.81),('9650','2014-03-15','15:55:00',2.65),('9650','2014-03-15','16:00:00',2.33),('9650','2014-03-15','16:05:00',2.85),('9650','2014-03-15','16:10:00',2.98),('9650','2014-03-15','16:15:00',3),('9650','2014-03-15','16:20:00',2.75),('9650','2014-03-15','16:25:00',2.77),('9650','2014-03-15','16:30:00',2.82),('9650','2014-03-15','16:35:00',2.6),('9650','2014-03-15','16:40:00',2.31),('9650','2014-03-15','16:45:00',2.09),('9650','2014-03-15','16:50:00',1.98),('9650','2014-03-15','16:55:00',1.68),('9650','2014-03-15','17:00:00',1.36),('9650','2014-03-15','17:05:00',1.36),('9650','2014-03-15','17:10:00',1.19),('9650','2014-03-14','08:20:00',1.06),('9650','2014-03-14','08:25:00',1.11),('9650','2014-03-14','08:30:00',1.18),('9650','2014-03-14','08:35:00',1.26),('9650','2014-03-14','08:40:00',1.34),('9650','2014-03-14','08:45:00',1.42),('9650','2014-03-14','08:50:00',1.51),('9650','2014-03-14','08:55:00',1.59),('9650','2014-03-14','09:00:00',1.66),('9650','2014-03-14','09:05:00',1.75),('9650','2014-03-14','09:10:00',1.85),('9650','2014-03-14','09:15:00',1.94),('9650','2014-03-14','09:20:00',2.05),('9650','2014-03-14','09:25:00',2.14),('9650','2014-03-14','09:30:00',2.24),('9650','2014-03-14','09:35:00',2.32),('9650','2014-03-14','09:40:00',2.43),('9650','2014-03-14','09:45:00',2.51),('9650','2014-03-14','09:50:00',2.6),('9650','2014-03-14','09:55:00',2.69),('9650','2014-03-14','10:00:00',2.79),('9650','2014-03-14','10:05:00',2.88),('9650','2014-03-14','10:10:00',2.99),('9650','2014-03-14','10:15:00',3.11),('9650','2014-03-14','10:20:00',3.23),('9650','2014-03-14','10:25:00',3.3),('9650','2014-03-14','10:30:00',3.38),('9650','2014-03-14','10:35:00',3.45),('9650','2014-03-14','10:40:00',3.53),('9650','2014-03-14','10:45:00',3.68),('9650','2014-03-14','10:50:00',3.69),('9650','2014-03-14','10:55:00',3.77),('9650','2014-03-14','11:00:00',3.87),('9650','2014-03-14','11:05:00',3.96),('9650','2014-03-14','11:10:00',4.02),('9650','2014-03-14','11:15:00',4.15),('9650','2014-03-14','11:20:00',4.28),('9650','2014-03-14','11:25:00',4.43),('9650','2014-03-14','11:30:00',4.4),('9650','2014-03-14','11:35:00',4.49),('9650','2014-03-14','11:40:00',4.54),('9650','2014-03-14','11:45:00',4.72),('9650','2014-03-14','11:50:00',4.62),('9650','2014-03-14','11:55:00',4.63),('9650','2014-03-14','12:00:00',4.69),('9650','2014-03-14','12:05:00',4.73),('9650','2014-03-14','12:10:00',4.86),('9650','2014-03-14','12:15:00',4.97),('9650','2014-03-14','12:20:00',4.91),('9650','2014-03-14','12:25:00',5.02),('9650','2014-03-14','12:30:00',5.11),('9650','2014-03-14','12:35:00',5.2),('9650','2014-03-14','12:40:00',5.17),('9650','2014-03-14','12:45:00',5.18),('9650','2014-03-14','12:50:00',5.27),('9650','2014-03-14','12:55:00',5.21),('9650','2014-03-14','13:00:00',5.26),('9650','2014-03-14','13:05:00',5.26),('9650','2014-03-14','13:10:00',5.21),('9650','2014-03-14','13:15:00',5.22),('9650','2014-03-14','13:20:00',5.23),('9650','2014-03-14','13:25:00',5.25),('9650','2014-03-14','13:30:00',5.25),('9650','2014-03-14','13:35:00',5.28),('9650','2014-03-14','13:40:00',5.25),('9650','2014-03-14','13:45:00',5.23),('9650','2014-03-14','13:50:00',5.16),('9650','2014-03-14','13:55:00',5.12),('9650','2014-03-14','14:00:00',5.01),('9650','2014-03-14','14:05:00',5.01),('9650','2014-03-14','14:10:00',5),('9650','2014-03-14','14:15:00',4.94),('9650','2014-03-14','14:20:00',4.87),('9650','2014-03-14','14:25:00',4.78),('9650','2014-03-14','14:30:00',4.67),('9650','2014-03-14','14:35:00',4.57),('9650','2014-03-14','14:40:00',4.51),('9650','2014-03-14','14:45:00',4.42),('9650','2014-03-14','14:50:00',4.3),('9650','2014-03-14','14:55:00',4.25),('9650','2014-03-14','15:00:00',4.12),('9650','2014-03-14','15:05:00',4),('9650','2014-03-14','15:10:00',3.93),('9650','2014-03-14','15:15:00',3.92),('9650','2014-03-14','15:20:00',3.8),('9650','2014-03-14','15:25:00',3.75),('9650','2014-03-14','15:30:00',3.69),('9650','2014-03-14','15:35:00',3.57),('9650','2014-03-14','15:40:00',3.51),('9650','2014-03-14','15:45:00',3.48),('9650','2014-03-14','15:50:00',3.41),('9650','2014-03-14','15:55:00',3.3),('9650','2014-03-14','16:00:00',3.21),('9650','2014-03-14','16:05:00',3),('9650','2014-03-14','16:10:00',2.91),('9650','2014-03-14','16:15:00',2.73),('9650','2014-03-14','16:20:00',2.66),('9650','2014-03-14','16:25:00',2.46),('9650','2014-03-14','16:30:00',2.42),('9650','2014-03-14','16:35:00',2.27),('9650','2014-03-14','16:40:00',2.13),('9650','2014-03-14','16:45:00',2.02),('9650','2014-03-14','16:50:00',1.82),('9650','2014-03-14','16:55:00',1.71),('9650','2014-03-14','17:00:00',1.58),('9650','2014-03-14','17:05:00',1.47),('9650','2014-03-14','17:10:00',1.32),('9650','2014-03-14','17:15:00',1.17),('9650','2014-03-14','17:20:00',1.01),('9650','2014-03-13','07:50:00',1.01),('9650','2014-03-13','07:55:00',1.09),('9650','2014-03-13','08:00:00',1.16),('9650','2014-03-13','08:05:00',1.22),('9650','2014-03-13','08:10:00',1.26),('9650','2014-03-13','08:15:00',1.3),('9650','2014-03-13','08:20:00',1.33),('9650','2014-03-13','08:25:00',1.46),('9650','2014-03-13','08:30:00',1.58),('9650','2014-03-13','08:35:00',1.62),('9650','2014-03-13','08:40:00',1.62),('9650','2014-03-13','08:45:00',1.56),('9650','2014-03-13','08:50:00',1.56),('9650','2014-03-13','08:55:00',1.63),('9650','2014-03-13','09:00:00',1.74),('9650','2014-03-13','09:05:00',1.91),('9650','2014-03-13','09:10:00',2.07),('9650','2014-03-13','09:15:00',2.14),('9650','2014-03-13','09:20:00',2.13),('9650','2014-03-13','09:25:00',2.16),('9650','2014-03-13','09:30:00',2.15),('9650','2014-03-13','09:35:00',2.36),('9650','2014-03-13','09:40:00',2.74),('9650','2014-03-13','09:45:00',3.07),('9650','2014-03-13','09:50:00',3.49),('9650','2014-03-13','09:55:00',3.64),('9650','2014-03-13','10:00:00',3.75),('9650','2014-03-13','10:05:00',3.74),('9650','2014-03-13','10:10:00',3.66),('9650','2014-03-13','10:15:00',3.57),('9650','2014-03-13','10:20:00',3.53),('9650','2014-03-13','10:25:00',3.43),('9650','2014-03-13','10:30:00',3.46),('9650','2014-03-13','10:35:00',3.64),('9650','2014-03-13','10:40:00',3.82),('9650','2014-03-13','10:45:00',3.38),('9650','2014-03-13','10:50:00',2.33),('9650','2014-03-13','10:55:00',3.11),('9650','2014-03-13','11:00:00',3.93),('9650','2014-03-13','11:05:00',4.25),('9650','2014-03-13','11:10:00',4.68),('9650','2014-03-13','11:15:00',4.8),('9650','2014-03-13','11:20:00',4.7),('9650','2014-03-13','11:25:00',4.59),('9650','2014-03-13','11:30:00',4.61),('9650','2014-03-13','11:35:00',4.69),('9650','2014-03-13','11:40:00',4.68),('9650','2014-03-13','11:45:00',4.82),('9650','2014-03-13','11:50:00',4.94),('9650','2014-03-13','11:55:00',5.08),('9650','2014-03-13','12:00:00',5.14),('9650','2014-03-13','12:05:00',5.1),('9650','2014-03-13','12:10:00',4.86),('9650','2014-03-13','12:15:00',4.66),('9650','2014-03-13','12:20:00',3.94),('9650','2014-03-13','12:25:00',3.44),('9650','2014-03-13','12:30:00',3.22),('9650','2014-03-13','12:35:00',2.67),('9650','2014-03-13','12:40:00',3.25),('9650','2014-03-13','12:45:00',3.44),('9650','2014-03-13','12:50:00',4.39),('9650','2014-03-13','12:55:00',4.65),('9650','2014-03-13','13:00:00',3.12),('9650','2014-03-13','13:05:00',2.87),('9650','2014-03-13','13:20:00',3.86),('9650','2014-03-13','13:25:00',4.02),('9650','2014-03-13','13:30:00',3.7),('9650','2014-03-13','13:35:00',3.3),('9650','2014-03-13','13:40:00',3.25),('9650','2014-03-13','13:45:00',3.37),('9650','2014-03-13','13:50:00',3.4),('9650','2014-03-13','13:55:00',3.34),('9650','2014-03-13','14:00:00',3.86),('9650','2014-03-13','14:05:00',4.24),('9650','2014-03-13','14:10:00',4.21),('9650','2014-03-13','14:15:00',4.59),('9650','2014-03-13','14:20:00',4.62),('9650','2014-03-13','14:25:00',4.36),('9650','2014-03-13','14:30:00',4.21),('9650','2014-03-13','14:35:00',4),('9650','2014-03-13','14:40:00',3.36),('9650','2014-03-13','14:45:00',2.8),('9650','2014-03-13','14:50:00',2.57),('9650','2014-03-13','14:55:00',2.4),('9650','2014-03-13','15:00:00',2.21),('9650','2014-03-13','15:05:00',2.19),('9650','2014-03-13','15:10:00',2.08),('9650','2014-03-13','15:15:00',2.04),('9650','2014-03-13','15:20:00',2.16),('9650','2014-03-13','15:25:00',2.35),('9650','2014-03-13','15:30:00',2.58),('9650','2014-03-13','15:35:00',2.81),('9650','2014-03-13','15:40:00',2.6),('9650','2014-03-13','15:45:00',2.25),('9650','2014-03-13','15:50:00',1.99),('9650','2014-03-13','15:55:00',2.05),('9650','2014-03-13','16:00:00',1.94),('9650','2014-03-13','16:05:00',1.92),('9650','2014-03-13','16:10:00',1.63),('9650','2014-03-13','16:15:00',1.42),('9650','2014-03-13','16:20:00',1.25),('9650','2014-03-13','16:25:00',1.14),('9650','2014-03-13','16:30:00',1.09),('9650','2014-03-13','16:35:00',1.03),('9650','2014-03-12','08:45:00',1.02),('9650','2014-03-12','08:50:00',1.11),('9650','2014-03-12','08:55:00',1.21),('9650','2014-03-12','09:00:00',1.31),('9650','2014-03-12','09:05:00',1.43),('9650','2014-03-12','09:10:00',1.55),('9650','2014-03-12','09:15:00',1.67),('9650','2014-03-12','09:20:00',1.78),('9650','2014-03-12','09:25:00',1.91),('9650','2014-03-12','09:30:00',2.04),('9650','2014-03-12','09:35:00',2.17),('9650','2014-03-12','09:40:00',2.31),('9650','2014-03-12','09:45:00',2.44),('9650','2014-03-12','09:50:00',2.57),('9650','2014-03-12','09:55:00',2.7),('9650','2014-03-12','10:00:00',2.83),('9650','2014-03-12','10:05:00',2.95),('9650','2014-03-12','10:10:00',3.07),('9650','2014-03-12','10:15:00',3.2),('9650','2014-03-12','10:20:00',3.3),('9650','2014-03-12','10:25:00',3.4),('9650','2014-03-12','10:30:00',3.53),('9650','2014-03-12','10:35:00',3.63),('9650','2014-03-12','10:40:00',3.75),('9650','2014-03-12','10:45:00',3.84),('9650','2014-03-12','10:50:00',3.94),('9650','2014-03-12','10:55:00',4.05),('9650','2014-03-12','11:00:00',4.14),('9650','2014-03-12','11:05:00',4.22),('9650','2014-03-12','11:10:00',4.3),('9650','2014-03-12','11:15:00',4.41),('9650','2014-03-12','11:20:00',4.52),('9650','2014-03-12','11:25:00',4.6),('9650','2014-03-12','11:30:00',4.62),('9650','2014-03-12','11:35:00',4.7),('9650','2014-03-12','11:40:00',4.77),('9650','2014-03-12','11:45:00',4.83),('9650','2014-03-12','11:50:00',4.92),('9650','2014-03-12','11:55:00',4.99),('9650','2014-03-12','12:00:00',5.09),('9650','2014-03-12','12:05:00',5.13),('9650','2014-03-12','12:10:00',5.11),('9650','2014-03-12','12:15:00',5.16),('9650','2014-03-12','12:20:00',5.17),('9650','2014-03-12','12:25:00',5.19),('9650','2014-03-12','12:30:00',5.24),('9650','2014-03-12','12:35:00',5.28),('9650','2014-03-12','12:40:00',5.28),('9650','2014-03-12','12:45:00',5.32),('9650','2014-03-12','12:50:00',5.31),('9650','2014-03-12','12:55:00',5.34),('9650','2014-03-12','13:00:00',5.33),('9650','2014-03-12','13:05:00',5.28),('9650','2014-03-12','13:10:00',5.18),('9650','2014-03-12','13:15:00',5.23),('9650','2014-03-12','13:20:00',5.26),('9650','2014-03-12','13:25:00',5.2),('9650','2014-03-12','13:30:00',5.19),('9650','2014-03-12','13:35:00',5.18),('9650','2014-03-12','13:40:00',5.15),('9650','2014-03-12','13:45:00',5.16),('9650','2014-03-12','13:50:00',5.13),('9650','2014-03-12','13:55:00',5.08),('9650','2014-03-12','14:00:00',4.98),('9650','2014-03-12','14:05:00',4.78),('9650','2014-03-12','14:10:00',4.74),('9650','2014-03-12','14:15:00',4.78),('9650','2014-03-12','14:20:00',4.69),('9650','2014-03-12','14:25:00',4.61),('9650','2014-03-12','14:30:00',4.49),('9650','2014-03-12','14:35:00',4.41),('9650','2014-03-12','14:40:00',4.24),('9650','2014-03-12','14:45:00',4.18),('9650','2014-03-12','14:50:00',4.18),('9650','2014-03-12','14:55:00',4.13),('9650','2014-03-12','15:00:00',3.95),('9650','2014-03-12','15:05:00',3.82),('9650','2014-03-12','15:10:00',3.85),('9650','2014-03-12','15:15:00',3.85),('9650','2014-03-12','15:20:00',3.74),('9650','2014-03-12','15:25:00',3.66),('9650','2014-03-12','15:30:00',3.52),('9650','2014-03-12','15:35:00',3.51),('9650','2014-03-12','15:40:00',3.48),('9650','2014-03-12','15:45:00',3.39),('9650','2014-03-12','15:50:00',3.39),('9650','2014-03-12','15:55:00',3.28),('9650','2014-03-12','16:00:00',3.17),('9650','2014-03-12','16:05:00',3.03),('9650','2014-03-12','16:10:00',2.9),('9650','2014-03-12','16:15:00',2.77),('9650','2014-03-12','16:20:00',2.71),('9650','2014-03-12','16:25:00',2.65),('9650','2014-03-12','16:30:00',2.56),('9650','2014-03-12','16:35:00',2.45),('9650','2014-03-12','16:40:00',2.3),('9650','2014-03-12','16:45:00',2.18),('9650','2014-03-12','16:50:00',2.07),('9650','2014-03-12','16:55:00',1.92),('9650','2014-03-12','17:00:00',1.79),('9650','2014-03-12','17:05:00',1.65),('9650','2014-03-12','17:10:00',1.51),('9650','2014-03-12','17:15:00',1.37),('9650','2014-03-12','17:20:00',1.23),('9650','2014-04-29','08:25:00',1.08),('9650','2014-04-29','08:30:00',1.19),('9650','2014-04-29','08:35:00',1.3),('9650','2014-04-29','08:40:00',1.44),('9650','2014-04-29','08:45:00',1.57),('9650','2014-04-29','08:50:00',1.76),('9650','2014-04-29','08:55:00',2.02),('9650','2014-04-29','09:00:00',2.35),('9650','2014-04-29','09:05:00',2.53),('9650','2014-04-29','09:10:00',2.92),('9650','2014-04-29','09:15:00',2.42),('9650','2014-04-29','09:20:00',2.18),('9650','2014-04-29','09:25:00',2.5),('9650','2014-04-29','09:30:00',1.73),('9650','2014-04-29','09:35:00',3.14),('9650','2014-04-29','09:40:00',3.38),('9650','2014-04-29','09:45:00',2.88),('9650','2014-04-29','09:50:00',2.08),('9650','2014-04-29','09:55:00',3.41),('9650','2014-04-29','10:00:00',4.41),('9650','2014-04-29','10:05:00',2.96),('9650','2014-04-29','10:10:00',3.4),('9650','2014-04-29','10:15:00',3.93),('9650','2014-04-29','10:20:00',2.74),('9650','2014-04-29','10:25:00',2.69),('9650','2014-04-29','10:30:00',3.03),('9650','2014-04-29','10:35:00',3.39),('9650','2014-04-29','10:40:00',3.35),('9650','2014-04-29','10:45:00',2.71),('9650','2014-04-29','10:50:00',2.93),('9650','2014-04-29','10:55:00',5.66),('9650','2014-04-29','11:00:00',5.78),('9650','2014-04-29','11:05:00',4.95),('9650','2014-04-29','11:10:00',4.64),('9650','2014-04-29','11:15:00',3.65),('9650','2014-04-29','11:20:00',3.21),('9650','2014-04-29','11:25:00',3.88),('9650','2014-04-29','11:30:00',3.47),('9650','2014-04-29','11:35:00',5.18),('9650','2014-04-29','11:40:00',5.02),('9650','2014-04-29','11:45:00',4.18),('9650','2014-04-29','11:50:00',5.92),('9650','2014-04-29','11:55:00',5.43),('9650','2014-04-29','12:00:00',5),('9650','2014-04-29','12:05:00',2.45),('9650','2014-04-29','12:10:00',2.33),('9650','2014-04-29','12:15:00',3.15),('9650','2014-04-29','12:20:00',2.93),('9650','2014-04-29','12:25:00',2.52),('9650','2014-04-29','12:30:00',3.16),('9650','2014-04-29','12:35:00',2.66),('9650','2014-04-29','12:40:00',2.35),('9650','2014-04-29','12:45:00',2.33),('9650','2014-04-29','13:00:00',5.46),('9650','2014-04-29','13:05:00',3.88),('9650','2014-04-29','13:10:00',6.67),('9650','2014-04-29','13:15:00',3.36),('9650','2014-04-29','13:20:00',3.75),('9650','2014-04-29','13:25:00',5.3),('9650','2014-04-29','13:30:00',3.42),('9650','2014-04-29','13:35:00',3.66),('9650','2014-04-29','13:40:00',6.26),('9650','2014-04-29','13:45:00',5.74),('9650','2014-04-29','13:50:00',4.77),('9650','2014-04-29','13:55:00',6.99),('9650','2014-04-29','14:00:00',3.7),('9650','2014-04-29','14:05:00',3.31),('9650','2014-04-29','14:10:00',2.91),('9650','2014-04-29','14:15:00',3.39),('9650','2014-04-29','14:20:00',5.75),('9650','2014-04-29','14:25:00',6.67),('9650','2014-04-29','14:30:00',7.38),('9650','2014-04-29','14:35:00',6.42),('9650','2014-04-29','14:40:00',3.62),('9650','2014-04-29','14:45:00',2.45),('9650','2014-04-29','14:50:00',3.08),('9650','2014-04-29','14:55:00',3.33),('9650','2014-04-29','15:00:00',2.75),('9650','2014-04-29','15:15:00',1.9),('9650','2014-04-29','15:20:00',2.33),('9650','2014-04-29','15:25:00',2.62),('9650','2014-04-29','15:30:00',3.1),('9650','2014-04-29','15:35:00',6.39),('9650','2014-04-29','15:40:00',8.58),('9650','2014-04-29','15:45:00',6.88),('9650','2014-04-29','15:50:00',8.29),('9650','2014-04-29','15:55:00',5.32),('9650','2014-04-29','16:00:00',2.9),('9650','2014-04-29','16:05:00',4.26),('9650','2014-04-29','16:10:00',3.87),('9650','2014-04-29','16:15:00',6.13),('9650','2014-04-29','16:20:00',3.25),('9650','2014-04-29','16:25:00',3.7),('9650','2014-04-29','16:30:00',4),('9650','2014-04-29','16:35:00',2.4),('9650','2014-04-29','16:40:00',5.09),('9650','2014-04-29','16:45:00',3.21),('9650','2014-04-29','16:50:00',5.09),('9650','2014-04-29','16:55:00',6.02),('9650','2014-04-29','17:00:00',4.15),('9650','2014-04-29','17:05:00',4.34),('9650','2014-04-29','17:10:00',2.07),('9650','2014-04-29','17:15:00',2.17),('9650','2014-04-29','17:20:00',2.25),('9650','2014-04-29','17:25:00',1.36),('9650','2014-04-29','17:30:00',1.44),('9650','2014-04-29','17:35:00',1.97),('9650','2014-04-29','17:40:00',2.04),('9650','2014-04-29','17:45:00',1.39),('9650','2014-04-29','17:50:00',1.57),('9650','2014-04-29','17:55:00',1.43),('9650','2014-04-29','18:00:00',1.01),('9650','2014-04-29','18:35:00',1.2),('9650','2014-04-29','18:40:00',1.09),('9650','2014-04-29','18:45:00',1.14),('9650','2014-04-28','09:40:00',1),('9650','2014-04-28','09:45:00',1.42),('9650','2014-04-28','09:50:00',1.78),('9650','2014-04-28','09:55:00',1.86),('9650','2014-04-28','10:00:00',1.75),('9650','2014-04-28','10:05:00',2.73),('9650','2014-04-28','10:10:00',4.5),('9650','2014-04-28','10:15:00',3.76),('9650','2014-04-28','10:20:00',3.29),('9650','2014-04-28','10:25:00',4.48),('9650','2014-04-28','10:30:00',4.63),('9650','2014-04-28','10:35:00',4.85),('9650','2014-04-28','10:40:00',4.97),('9650','2014-04-28','10:45:00',5.09),('9650','2014-04-28','10:50:00',5.25),('9650','2014-04-28','10:55:00',4.98),('9650','2014-04-28','11:00:00',5.25),('9650','2014-04-28','11:05:00',5.29),('9650','2014-04-28','11:10:00',5.33),('9650','2014-04-28','11:15:00',6.72),('9650','2014-04-28','11:20:00',5.33),('9650','2014-04-28','11:25:00',5),('9650','2014-04-28','11:30:00',4.47),('9650','2014-04-28','11:35:00',4.25),('9650','2014-04-28','11:40:00',6.06),('9650','2014-04-28','11:45:00',3.31),('9650','2014-04-28','11:50:00',1.95),('9650','2014-04-28','11:55:00',1.93),('9650','2014-04-28','12:00:00',2.54),('9650','2014-04-28','12:05:00',2.91),('9650','2014-04-28','12:10:00',2.94),('9650','2014-04-28','12:15:00',2.74),('9650','2014-04-28','12:20:00',3.76),('9650','2014-04-28','12:25:00',3.91),('9650','2014-04-28','12:30:00',2.57),('9650','2014-04-28','12:35:00',3.09),('9650','2014-04-28','12:40:00',3.76),('9650','2014-04-28','12:45:00',3.81),('9650','2014-04-28','12:50:00',5.99),('9650','2014-04-28','12:55:00',2.91),('9650','2014-04-28','13:00:00',3.89),('9650','2014-04-28','13:05:00',3.46),('9650','2014-04-28','13:10:00',3.58),('9650','2014-04-28','13:15:00',3.93),('9650','2014-04-28','13:20:00',6.35),('9650','2014-04-28','13:25:00',4.66),('9650','2014-04-28','13:30:00',6.66),('9650','2014-04-28','13:35:00',2.79),('9650','2014-04-28','13:40:00',2.81),('9650','2014-04-28','13:45:00',4.43),('9650','2014-04-28','13:50:00',3.92),('9650','2014-04-28','13:55:00',1.59),('9650','2014-04-28','14:40:00',1.04),('9650','2014-04-28','15:00:00',1.18),('9650','2014-04-28','15:05:00',1.57),('9650','2014-04-28','15:10:00',1.3),('9650','2014-04-28','15:25:00',1.19),('9650','2014-04-28','15:30:00',1.28),('9650','2014-04-28','15:35:00',1.28),('9650','2014-04-28','16:05:00',1.12),('9650','2014-04-28','16:10:00',1.24),('9650','2014-04-28','16:15:00',1.41),('9650','2014-04-28','16:20:00',1.67),('9650','2014-04-28','16:25:00',1.76),('9650','2014-04-28','16:30:00',1.46),('9650','2014-04-28','16:35:00',1.24),('9650','2014-04-28','16:40:00',1.13),('9650','2014-04-28','16:45:00',1.11),('9650','2014-04-28','16:50:00',1.17),('9650','2014-04-28','16:55:00',1.29),('9650','2014-04-28','17:00:00',1.66),('9650','2014-04-28','17:05:00',2.22),('9650','2014-04-28','17:10:00',2.02),('9650','2014-04-28','17:15:00',1.65),('9650','2014-04-28','17:20:00',2.88),('9650','2014-04-28','17:25:00',2.13),('9650','2014-04-28','17:30:00',4.3),('9650','2014-04-28','17:35:00',3.6),('9650','2014-04-28','17:40:00',5.39),('9650','2014-04-28','17:45:00',5.24),('9650','2014-04-28','17:50:00',1.39),('9650','2014-04-28','17:55:00',1.01),('9650','2014-04-28','18:00:00',1.14),('9650','2014-04-28','18:05:00',1.22),('9650','2014-04-27','07:50:00',1),('9650','2014-04-27','07:55:00',1.09),('9650','2014-04-27','08:00:00',1.11),('9650','2014-04-27','08:20:00',1.33),('9650','2014-04-27','08:25:00',1.97),('9650','2014-04-27','08:30:00',1.75),('9650','2014-04-27','08:35:00',1.76),('9650','2014-04-27','08:40:00',1.84),('9650','2014-04-27','08:45:00',1.77),('9650','2014-04-27','08:50:00',1.73),('9650','2014-04-27','08:55:00',1.7),('9650','2014-04-27','09:00:00',1.41),('9650','2014-04-27','09:05:00',1.64),('9650','2014-04-27','09:10:00',2.58),('9650','2014-04-27','09:15:00',2.68),('9650','2014-04-27','09:20:00',2.18),('9650','2014-04-27','09:25:00',2.36),('9650','2014-04-27','09:30:00',2.97),('9650','2014-04-27','09:35:00',2.86),('9650','2014-04-27','09:40:00',2.78),('9650','2014-04-27','09:45:00',2.61),('9650','2014-04-27','09:50:00',2.63),('9650','2014-04-27','09:55:00',2.16),('9650','2014-04-27','10:00:00',3.26),('9650','2014-04-27','10:05:00',3.82),('9650','2014-04-27','10:10:00',3.69),('9650','2014-04-27','10:15:00',3.19),('9650','2014-04-27','10:20:00',2.69),('9650','2014-04-27','10:25:00',1.56),('9650','2014-04-27','10:35:00',1.09),('9650','2014-04-27','10:40:00',1.95),('9650','2014-04-27','10:45:00',2.91),('9650','2014-04-27','10:50:00',3.46),('9650','2014-04-27','10:55:00',3.01),('9650','2014-04-27','11:00:00',3.29),('9650','2014-04-27','11:05:00',4.05),('9650','2014-04-27','11:10:00',4.39),('9650','2014-04-27','11:15:00',4.31),('9650','2014-04-27','11:20:00',3.82),('9650','2014-04-27','11:25:00',3.13),('9650','2014-04-27','11:30:00',3.24),('9650','2014-04-27','11:35:00',2.87),('9650','2014-04-27','11:40:00',2.76),('9650','2014-04-27','11:45:00',3.09),('9650','2014-04-27','11:50:00',3.53),('9650','2014-04-27','11:55:00',3.58),('9650','2014-04-27','12:00:00',3.16),('9650','2014-04-27','12:05:00',2.66),('9650','2014-04-27','12:10:00',3.46),('9650','2014-04-27','12:15:00',4.94),('9650','2014-04-27','12:20:00',4.92),('9650','2014-04-27','12:25:00',4.8),('9650','2014-04-27','12:30:00',4.74),('9650','2014-04-27','12:35:00',4.27),('9650','2014-04-27','12:40:00',3.72),('9650','2014-04-27','12:45:00',3.45),('9650','2014-04-27','12:50:00',4.01),('9650','2014-04-27','12:55:00',4.03),('9650','2014-04-27','13:00:00',4.14),('9650','2014-04-27','13:05:00',5.46),('9650','2014-04-27','13:10:00',5.41),('9650','2014-04-27','13:15:00',3.91),('9650','2014-04-27','13:20:00',4.34),('9650','2014-04-27','13:25:00',5.59),('9650','2014-04-27','13:30:00',8.7),('9650','2014-04-27','13:35:00',6.24),('9650','2014-04-27','13:40:00',5.84),('9650','2014-04-27','13:45:00',6.72),('9650','2014-04-27','13:50:00',7.98),('9650','2014-04-27','13:55:00',5.76),('9650','2014-04-27','14:00:00',3.6),('9650','2014-04-27','14:05:00',6.43),('9650','2014-04-27','14:10:00',6.96),('9650','2014-04-27','14:15:00',4.4),('9650','2014-04-27','14:20:00',7.17),('9650','2014-04-27','14:25:00',5.46),('9650','2014-04-27','14:30:00',5.45),('9650','2014-04-27','14:35:00',4.68),('9650','2014-04-27','14:40:00',7.59),('9650','2014-04-27','14:45:00',5.91),('9650','2014-04-27','14:50:00',5.91),('9650','2014-04-27','14:55:00',7.68),('9650','2014-04-27','15:00:00',5.58),('9650','2014-04-27','15:05:00',5.76),('9650','2014-04-27','15:10:00',4.1),('9650','2014-04-27','15:15:00',4.48),('9650','2014-04-27','15:20:00',3.84),('9650','2014-04-27','15:25:00',2.45),('9650','2014-04-27','15:30:00',4.03),('9650','2014-04-27','15:35:00',5.83),('9650','2014-04-27','15:40:00',4.06),('9650','2014-04-27','15:45:00',5.89),('9650','2014-04-27','15:50:00',5.8),('9650','2014-04-27','15:55:00',3),('9650','2014-04-27','16:00:00',5.02),('9650','2014-04-27','16:05:00',5.08),('9650','2014-04-27','16:10:00',7.98),('9650','2014-04-27','16:15:00',4.99),('9650','2014-04-27','16:20:00',3.8),('9650','2014-04-27','16:25:00',3.98),('9650','2014-04-27','16:30:00',5.81),('9650','2014-04-27','16:35:00',6.84),('9650','2014-04-27','16:40:00',1.47),('9650','2014-04-27','16:45:00',1.25),('9650','2014-04-27','16:50:00',1.91),('9650','2014-04-27','16:55:00',3.8),('9650','2014-04-27','17:00:00',1.73),('9650','2014-04-27','17:05:00',1.04),('9650','2014-04-27','17:15:00',1),('9650','2014-04-27','17:20:00',1.67),('9650','2014-04-27','17:25:00',1.84),('9650','2014-04-27','17:30:00',1.59),('9650','2014-04-27','17:35:00',2.34),('9650','2014-04-27','17:40:00',3.25),('9650','2014-04-27','17:45:00',1.62),('9650','2014-04-27','17:50:00',1.42),('9650','2014-04-27','17:55:00',1.25),('9650','2014-04-27','18:10:00',1.23),('9650','2014-04-27','18:15:00',1.28),('9650','2014-04-27','18:25:00',1.04),('9650','2014-04-27','18:30:00',1),('9650','2014-04-27','18:35:00',1.12),('9650','2014-04-27','18:40:00',1.1),('9650','2014-04-26','08:50:00',1.41),('9650','2014-04-26','09:10:00',1.12),('9650','2014-04-26','09:15:00',1.63),('9650','2014-04-26','09:20:00',1.76),('9650','2014-04-26','09:25:00',1.41),('9650','2014-04-26','09:30:00',1.18),('9650','2014-04-26','09:40:00',1.09),('9650','2014-04-26','09:45:00',1.22),('9650','2014-04-26','09:50:00',1.03),('9650','2014-04-26','09:55:00',1.32),('9650','2014-04-26','10:00:00',1.93),('9650','2014-04-26','10:05:00',2.1),('9650','2014-04-26','10:10:00',2.1),('9650','2014-04-26','10:15:00',2.03),('9650','2014-04-26','10:20:00',2.14),('9650','2014-04-26','10:25:00',1.93),('9650','2014-04-26','10:30:00',1.1),('9650','2014-04-26','10:55:00',1.2),('9650','2014-04-26','11:00:00',1.83),('9650','2014-04-26','11:05:00',2.07),('9650','2014-04-26','11:10:00',1.93),('9650','2014-04-26','11:15:00',1.89),('9650','2014-04-26','11:20:00',1.46),('9650','2014-04-26','11:25:00',1.06),('9650','2014-04-26','11:30:00',1.4),('9650','2014-04-26','11:35:00',2.3),('9650','2014-04-26','11:40:00',2.58),('9650','2014-04-26','11:45:00',5.11),('9650','2014-04-26','11:50:00',4.47),('9650','2014-04-26','11:55:00',4.4),('9650','2014-04-26','12:00:00',4.21),('9650','2014-04-26','12:05:00',4.72),('9650','2014-04-26','12:10:00',5.04),('9650','2014-04-26','12:15:00',5.18),('9650','2014-04-26','12:20:00',4.78),('9650','2014-04-26','12:25:00',4.68),('9650','2014-04-26','12:30:00',4.3),('9650','2014-04-26','12:35:00',4.51),('9650','2014-04-26','12:40:00',4.1),('9650','2014-04-26','12:45:00',4.38),('9650','2014-04-26','12:50:00',3.71),('9650','2014-04-26','12:55:00',3.22),('9650','2014-04-26','13:00:00',4.18),('9650','2014-04-26','13:05:00',3.82),('9650','2014-04-26','13:10:00',3.3),('9650','2014-04-26','13:15:00',3.44),('9650','2014-04-26','13:20:00',4.26),('9650','2014-04-26','13:25:00',3.88),('9650','2014-04-26','13:30:00',3.6),('9650','2014-04-26','13:35:00',3.21),('9650','2014-04-26','13:40:00',2.91),('9650','2014-04-26','13:45:00',3.02),('9650','2014-04-26','13:50:00',3),('9650','2014-04-26','13:55:00',2.83),('9650','2014-04-26','14:00:00',3.41),('9650','2014-04-26','14:05:00',3.89),('9650','2014-04-26','14:10:00',2.81),('9650','2014-04-26','14:15:00',2.61),('9650','2014-04-26','14:20:00',3.18),('9650','2014-04-26','14:25:00',3.95),('9650','2014-04-26','14:30:00',4.08),('9650','2014-04-26','14:35:00',4.07),('9650','2014-04-26','14:40:00',4.25),('9650','2014-04-26','14:45:00',3.66),('9650','2014-04-26','14:50:00',3.43),('9650','2014-04-26','14:55:00',3.66),('9650','2014-04-26','15:00:00',3.97),('9650','2014-04-26','15:05:00',5.86),('9650','2014-04-26','15:10:00',7.75),('9650','2014-04-26','15:15:00',5.12),('9650','2014-04-26','15:20:00',3.25),('9650','2014-04-26','15:25:00',1.97),('9650','2014-04-26','15:30:00',1.6),('9650','2014-04-26','15:35:00',1.82),('9650','2014-04-26','15:40:00',1.91),('9650','2014-04-26','15:45:00',1.56),('9650','2014-04-26','15:50:00',1.58),('9650','2014-04-26','15:55:00',1.11),('fridge1','2014-07-11','08:10:00',58.91),('fridge2','2014-07-11','00:10:00',64.93),('fridge3','2014-07-11','00:20:00',62.18),('fridge4','2014-07-11','00:30:00',64.28),('fridge5','2014-07-11','00:40:00',66.57),('fridge6','2014-07-11','00:50:00',66.37),('fridge7','2014-07-11','01:00:00',66.13),('fridge8','2014-07-11','01:10:00',66.89),('fridge9','2014-07-11','01:20:00',65.72),('fridge10','2014-07-11','01:30:00',68.56),('fridge11','2014-07-11','01:40:00',64.87),('fridge12','2014-07-11','01:50:00',67.01),('fridge13','2014-07-11','02:00:00',69.7),('fridge14','2014-07-11','02:10:00',62.21),('fridge15','2014-07-11','02:20:00',62.89),('fridge16','2014-07-11','02:30:00',62.41),('fridge17','2014-07-11','02:40:00',61.64),('fridge18','2014-07-11','02:50:00',63.36),('fridge19','2014-07-11','03:00:00',64.7),('fridge20','2014-07-11','03:10:00',60),('fridge21','2014-07-11','03:20:00',60.44),('fridge22','2014-07-11','03:30:00',61.82),('fridge23','2014-07-11','03:40:00',62.61),('fridge24','2014-07-11','03:50:00',60.52),('fridge25','2014-07-11','04:00:00',61.63),('fridge26','2014-07-11','04:10:00',60.11),('fridge27','2014-07-11','04:20:00',61.13),('fridge28','2014-07-11','04:30:00',60.59),('fridge29','2014-07-11','04:40:00',60.21),('fridge30','2014-07-11','04:50:00',61.55),('fridge31','2014-07-11','05:00:00',62.12),('fridge32','2014-07-11','05:10:00',60.17),('fridge33','2014-07-11','05:20:00',60.08),('fridge34','2014-07-11','05:30:00',59.59),('fridge35','2014-07-11','05:40:00',60.65),('fridge36','2014-07-11','05:50:00',60.9),('fridge37','2014-07-11','06:00:00',59.18),('fridge38','2014-07-11','06:10:00',59.18),('fridge39','2014-07-11','06:20:00',59.58),('fridge40','2014-07-11','06:30:00',60.37),('fridge41','2014-07-11','06:40:00',60),('fridge42','2014-07-11','06:50:00',62.62),('fridge43','2014-07-11','07:00:00',62.72),('fridge44','2014-07-11','07:10:00',60.52),('fridge45','2014-07-11','07:20:00',61.86),('fridge46','2014-07-11','07:30:00',59.82),('fridge47','2014-07-11','07:40:00',61.28),('fridge48','2014-07-11','07:50:00',62),('fridge49','2014-07-11','08:00:00',61.96),('fridge50','2014-07-11','08:10:00',58.91),('fridge51','2014-07-11','08:20:00',63.12),('fridge52','2014-07-11','08:30:00',63.72),('fridge53','2014-07-11','08:40:00',59.34),('fridge54','2014-07-11','08:50:00',60.55),('fridge55','2014-07-11','09:00:00',61.52),('fridge56','2014-07-11','09:10:00',61.07),('fridge57','2014-07-11','09:20:00',61.49),('fridge58','2014-07-11','09:30:00',62.7),('fridge59','2014-07-11','09:40:00',62.07),('fridge60','2014-07-11','09:50:00',60.63),('fridge61','2014-07-11','10:00:00',61.92),('fridge62','2014-07-11','10:10:00',61.29),('fridge63','2014-07-11','10:20:00',60.63),('fridge64','2014-07-11','10:30:00',63.01),('fridge65','2014-07-11','10:40:00',64.38),('fridge66','2014-07-11','10:50:00',62.11),('fridge67','2014-07-11','11:00:00',61.52),('fridge68','2014-07-11','11:10:00',61.93),('fridge69','2014-07-11','11:20:00',62.91),('fridge70','2014-07-11','11:30:00',63.12),('fridge71','2014-07-11','11:40:00',62.34),('fridge72','2014-07-11','11:50:00',65.61),('fridge73','2014-07-11','12:00:00',65.28),('fridge74','2014-07-11','12:10:00',65.63),('fridge75','2014-07-11','12:20:00',65.81),('fridge76','2014-07-11','12:30:00',67.1),('fridge77','2014-07-11','12:40:00',67.59),('fridge78','2014-07-11','12:50:00',65.38),('fridge79','2014-07-11','13:00:00',67.32),('fridge80','2014-07-11','13:10:00',66.18),('fridge81','2014-07-11','13:20:00',66.51),('fridge82','2014-07-11','13:30:00',68.78),('fridge83','2014-07-11','13:40:00',70.13),('fridge84','2014-07-11','13:50:00',69.4),('fridge85','2014-07-11','14:00:00',64.03),('fridge86','2014-07-11','14:10:00',65.43),('fridge87','2014-07-11','14:20:00',68.95),('fridge88','2014-07-11','14:30:00',67.74),('fridge89','2014-07-11','14:40:00',67.41),('fridge90','2014-07-11','14:50:00',66),('fridge91','2014-07-11','15:00:00',65.95),('fridge92','2014-07-11','15:10:00',64.96),('fridge93','2014-07-11','15:20:00',64.36),('fridge94','2014-07-11','15:30:00',66.78),('fridge95','2014-07-11','15:40:00',66.22),('fridge96','2014-07-11','15:50:00',65.79),('fridge97','2014-07-11','16:00:00',67.17),('fridge98','2014-07-11','16:10:00',66.56),('fridge99','2014-07-11','16:20:00',66.38),('fridge100','2014-07-11','16:30:00',63.98),('fridge101','2014-07-11','16:40:00',62.58),('fridge102','2014-07-11','16:50:00',63.81),('fridge103','2014-07-11','17:00:00',64.02),('fridge104','2014-07-11','17:10:00',64.02),('fridge105','2014-07-11','17:20:00',66),('fridge106','2014-07-11','17:30:00',67.04),('fridge107','2014-07-11','17:40:00',65.87),('fridge108','2014-07-11','17:50:00',68.32),('fridge109','2014-07-11','18:00:00',66.93),('fridge110','2014-07-11','18:10:00',65.08),('fridge111','2014-07-11','18:20:00',66.02),('fridge112','2014-07-11','18:30:00',67.47),('fridge113','2014-07-11','18:40:00',64.81),('fridge114','2014-07-11','18:50:00',66.58),('fridge115','2014-07-11','19:00:00',66.58),('fridge116','2014-07-11','19:10:00',68.46),('fridge117','2014-07-11','19:20:00',68.71),('fridge118','2014-07-11','19:30:00',70.4),('fridge119','2014-07-11','19:40:00',70.64),('fridge120','2014-07-11','19:50:00',70.72),('fridge121','2014-07-11','20:00:00',70.02),('fridge122','2014-07-11','20:10:00',68.9),('fridge123','2014-07-11','20:20:00',70.59),('fridge124','2014-07-11','20:30:00',71.84),('fridge125','2014-07-11','20:40:00',70.62),('fridge126','2014-07-11','20:50:00',67.87),('fridge127','2014-07-11','21:00:00',71.12),('fridge128','2014-07-11','21:10:00',71.62),('fridge129','2014-07-11','21:20:00',70.56),('fridge130','2014-07-11','21:30:00',69.17),('fridge131','2014-07-11','21:40:00',69.61),('fridge132','2014-07-11','21:50:00',68.07),('fridge133','2014-07-11','22:00:00',67.12),('fridge134','2014-07-11','22:10:00',68.09),('fridge135','2014-07-11','22:20:00',68.07),('fridge136','2014-07-11','22:30:00',67.99),('fridge137','2014-07-11','22:40:00',65.9),('fridge138','2014-07-11','22:50:00',69.42),('fridge139','2014-07-11','23:00:00',68.22),('fridge140','2014-07-11','23:10:00',66.81),('fridge141','2014-07-11','23:20:00',64.64),('fridge142','2014-07-11','23:30:00',62.88),('fridge143','2014-07-11','23:40:00',67.22),('fridge144','2014-07-11','23:50:00',68.56),('fridge2','2014-07-11','00:10:00',64.93),('fridge3','2014-07-11','00:20:00',62.18),('fridge4','2014-07-11','00:30:00',64.28),('fridge5','2014-07-11','00:40:00',66.57),('fridge6','2014-07-11','00:50:00',66.37),('fridge7','2014-07-11','01:00:00',66.13),('fridge8','2014-07-11','01:10:00',66.89),('fridge9','2014-07-11','01:20:00',65.72),('fridge10','2014-07-11','01:30:00',68.56),('fridge11','2014-07-11','01:40:00',64.87),('fridge12','2014-07-11','01:50:00',67.01),('fridge13','2014-07-11','02:00:00',69.7),('fridge14','2014-07-11','02:10:00',62.21),('fridge15','2014-07-11','02:20:00',62.89),('fridge16','2014-07-11','02:30:00',62.41),('fridge17','2014-07-11','02:40:00',61.64),('fridge18','2014-07-11','02:50:00',63.36),('fridge19','2014-07-11','03:00:00',64.7),('fridge20','2014-07-11','03:10:00',60),('fridge21','2014-07-11','03:20:00',60.44),('fridge22','2014-07-11','03:30:00',61.82),('fridge23','2014-07-11','03:40:00',62.61),('fridge24','2014-07-11','03:50:00',60.52),('fridge25','2014-07-11','04:00:00',61.63),('fridge26','2014-07-11','04:10:00',60.11),('fridge27','2014-07-11','04:20:00',61.13),('fridge28','2014-07-11','04:30:00',60.59),('fridge29','2014-07-11','04:40:00',60.21),('fridge30','2014-07-11','04:50:00',61.55),('fridge31','2014-07-11','05:00:00',62.12),('fridge32','2014-07-11','05:10:00',60.17),('fridge33','2014-07-11','05:20:00',60.08),('fridge34','2014-07-11','05:30:00',59.59),('fridge35','2014-07-11','05:40:00',60.65),('fridge36','2014-07-11','05:50:00',60.9),('fridge37','2014-07-11','06:00:00',59.18),('fridge38','2014-07-11','06:10:00',59.18),('fridge39','2014-07-11','06:20:00',59.58),('fridge40','2014-07-11','06:30:00',60.37),('fridge41','2014-07-11','06:40:00',60),('fridge42','2014-07-11','06:50:00',62.62),('fridge43','2014-07-11','07:00:00',62.72),('fridge44','2014-07-11','07:10:00',60.52),('fridge45','2014-07-11','07:20:00',61.86),('fridge46','2014-07-11','07:30:00',59.82),('fridge47','2014-07-11','07:40:00',61.28),('fridge48','2014-07-11','07:50:00',62),('fridge49','2014-07-11','08:00:00',61.96),('fridge50','2014-07-11','08:10:00',58.91),('fridge51','2014-07-11','08:20:00',63.12),('fridge52','2014-07-11','08:30:00',63.72),('fridge53','2014-07-11','08:40:00',59.34),('fridge54','2014-07-11','08:50:00',60.55),('fridge55','2014-07-11','09:00:00',61.52),('fridge56','2014-07-11','09:10:00',61.07),('fridge57','2014-07-11','09:20:00',61.49),('fridge58','2014-07-11','09:30:00',62.7),('fridge59','2014-07-11','09:40:00',62.07),('fridge60','2014-07-11','09:50:00',60.63),('fridge61','2014-07-11','10:00:00',61.92),('fridge62','2014-07-11','10:10:00',61.29),('fridge63','2014-07-11','10:20:00',60.63),('fridge64','2014-07-11','10:30:00',63.01),('fridge65','2014-07-11','10:40:00',64.38),('fridge66','2014-07-11','10:50:00',62.11),('fridge67','2014-07-11','11:00:00',61.52),('fridge68','2014-07-11','11:10:00',61.93),('fridge69','2014-07-11','11:20:00',62.91),('fridge70','2014-07-11','11:30:00',63.12),('fridge71','2014-07-11','11:40:00',62.34),('fridge72','2014-07-11','11:50:00',65.61),('fridge73','2014-07-11','12:00:00',65.28),('fridge74','2014-07-11','12:10:00',65.63),('fridge75','2014-07-11','12:20:00',65.81),('fridge76','2014-07-11','12:30:00',67.1),('fridge77','2014-07-11','12:40:00',67.59),('fridge78','2014-07-11','12:50:00',65.38),('fridge79','2014-07-11','13:00:00',67.32),('fridge80','2014-07-11','13:10:00',66.18),('fridge81','2014-07-11','13:20:00',66.51),('fridge82','2014-07-11','13:30:00',68.78),('fridge83','2014-07-11','13:40:00',70.13),('fridge84','2014-07-11','13:50:00',69.4),('fridge85','2014-07-11','14:00:00',64.03),('fridge86','2014-07-11','14:10:00',65.43),('fridge87','2014-07-11','14:20:00',68.95),('fridge88','2014-07-11','14:30:00',67.74),('fridge89','2014-07-11','14:40:00',67.41),('fridge90','2014-07-11','14:50:00',66),('fridge91','2014-07-11','15:00:00',65.95),('fridge92','2014-07-11','15:10:00',64.96),('fridge93','2014-07-11','15:20:00',64.36),('fridge94','2014-07-11','15:30:00',66.78),('fridge95','2014-07-11','15:40:00',66.22),('fridge96','2014-07-11','15:50:00',65.79),('fridge97','2014-07-11','16:00:00',67.17),('fridge98','2014-07-11','16:10:00',66.56),('fridge99','2014-07-11','16:20:00',66.38),('fridge100','2014-07-11','16:30:00',63.98),('fridge101','2014-07-11','16:40:00',62.58),('fridge102','2014-07-11','16:50:00',63.81),('fridge103','2014-07-11','17:00:00',64.02),('fridge104','2014-07-11','17:10:00',64.02),('fridge105','2014-07-11','17:20:00',66),('fridge106','2014-07-11','17:30:00',67.04),('fridge107','2014-07-11','17:40:00',65.87),('fridge108','2014-07-11','17:50:00',68.32),('fridge109','2014-07-11','18:00:00',66.93),('fridge110','2014-07-11','18:10:00',65.08),('fridge111','2014-07-11','18:20:00',66.02),('fridge112','2014-07-11','18:30:00',67.47),('fridge113','2014-07-11','18:40:00',64.81),('fridge114','2014-07-11','18:50:00',66.58),('fridge115','2014-07-11','19:00:00',66.58),('fridge116','2014-07-11','19:10:00',68.46),('fridge117','2014-07-11','19:20:00',68.71),('fridge118','2014-07-11','19:30:00',70.4),('fridge119','2014-07-11','19:40:00',70.64),('fridge120','2014-07-11','19:50:00',70.72),('fridge121','2014-07-11','20:00:00',70.02),('fridge122','2014-07-11','20:10:00',68.9),('fridge123','2014-07-11','20:20:00',70.59),('fridge124','2014-07-11','20:30:00',71.84),('fridge125','2014-07-11','20:40:00',70.62),('fridge126','2014-07-11','20:50:00',67.87),('fridge127','2014-07-11','21:00:00',71.12),('fridge128','2014-07-11','21:10:00',71.62),('fridge129','2014-07-11','21:20:00',70.56),('fridge130','2014-07-11','21:30:00',69.17),('fridge131','2014-07-11','21:40:00',69.61),('fridge132','2014-07-11','21:50:00',68.07),('fridge133','2014-07-11','22:00:00',67.12),('fridge134','2014-07-11','22:10:00',68.09),('fridge135','2014-07-11','22:20:00',68.07),('fridge136','2014-07-11','22:30:00',67.99),('fridge137','2014-07-11','22:40:00',65.9),('fridge138','2014-07-11','22:50:00',69.42),('fridge139','2014-07-11','23:00:00',68.22),('fridge140','2014-07-11','23:10:00',66.81),('fridge141','2014-07-11','23:20:00',64.64),('fridge142','2014-07-11','23:30:00',62.88),('fridge143','2014-07-11','23:40:00',67.22),('fridge144','2014-07-11','23:50:00',68.56),('fridge2','2014-07-11','00:10:00',64.93),('fridge3','2014-07-11','00:20:00',62.18),('fridge4','2014-07-11','00:30:00',64.28),('fridge5','2014-07-11','00:40:00',66.57),('fridge6','2014-07-11','00:50:00',66.37),('fridge7','2014-07-11','01:00:00',66.13),('fridge8','2014-07-11','01:10:00',66.89),('fridge9','2014-07-11','01:20:00',65.72),('fridge10','2014-07-11','01:30:00',68.56),('fridge11','2014-07-11','01:40:00',64.87),('fridge12','2014-07-11','01:50:00',67.01),('fridge13','2014-07-11','02:00:00',69.7),('fridge14','2014-07-11','02:10:00',62.21),('fridge15','2014-07-11','02:20:00',62.89),('fridge16','2014-07-11','02:30:00',62.41),('fridge17','2014-07-11','02:40:00',61.64),('fridge18','2014-07-11','02:50:00',63.36),('fridge19','2014-07-11','03:00:00',64.7),('fridge20','2014-07-11','03:10:00',60),('fridge21','2014-07-11','03:20:00',60.44),('fridge22','2014-07-11','03:30:00',61.82),('fridge23','2014-07-11','03:40:00',62.61),('fridge24','2014-07-11','03:50:00',60.52),('fridge25','2014-07-11','04:00:00',61.63),('fridge26','2014-07-11','04:10:00',60.11),('fridge27','2014-07-11','04:20:00',61.13),('fridge28','2014-07-11','04:30:00',60.59),('fridge29','2014-07-11','04:40:00',60.21),('fridge30','2014-07-11','04:50:00',61.55),('fridge31','2014-07-11','05:00:00',62.12),('fridge32','2014-07-11','05:10:00',60.17),('fridge33','2014-07-11','05:20:00',60.08),('fridge34','2014-07-11','05:30:00',59.59),('fridge35','2014-07-11','05:40:00',60.65),('fridge36','2014-07-11','05:50:00',60.9),('fridge37','2014-07-11','06:00:00',59.18),('fridge38','2014-07-11','06:10:00',59.18),('fridge39','2014-07-11','06:20:00',59.58),('fridge40','2014-07-11','06:30:00',60.37),('fridge41','2014-07-11','06:40:00',60),('fridge42','2014-07-11','06:50:00',62.62),('fridge43','2014-07-11','07:00:00',62.72),('fridge44','2014-07-11','07:10:00',60.52),('fridge45','2014-07-11','07:20:00',61.86),('fridge46','2014-07-11','07:30:00',59.82),('fridge47','2014-07-11','07:40:00',61.28),('fridge48','2014-07-11','07:50:00',62),('fridge49','2014-07-11','08:00:00',61.96),('fridge50','2014-07-11','08:10:00',58.91),('fridge51','2014-07-11','08:20:00',63.12),('fridge52','2014-07-11','08:30:00',63.72),('fridge53','2014-07-11','08:40:00',59.34),('fridge54','2014-07-11','08:50:00',60.55),('fridge55','2014-07-11','09:00:00',61.52),('fridge56','2014-07-11','09:10:00',61.07),('fridge57','2014-07-11','09:20:00',61.49),('fridge58','2014-07-11','09:30:00',62.7),('fridge59','2014-07-11','09:40:00',62.07),('fridge60','2014-07-11','09:50:00',60.63),('fridge61','2014-07-11','10:00:00',61.92),('fridge62','2014-07-11','10:10:00',61.29),('fridge63','2014-07-11','10:20:00',60.63),('fridge64','2014-07-11','10:30:00',63.01),('fridge65','2014-07-11','10:40:00',64.38),('fridge66','2014-07-11','10:50:00',62.11),('fridge67','2014-07-11','11:00:00',61.52),('fridge68','2014-07-11','11:10:00',61.93),('fridge69','2014-07-11','11:20:00',62.91),('fridge70','2014-07-11','11:30:00',63.12),('fridge71','2014-07-11','11:40:00',62.34),('fridge72','2014-07-11','11:50:00',65.61),('fridge73','2014-07-11','12:00:00',65.28),('fridge74','2014-07-11','12:10:00',65.63),('fridge75','2014-07-11','12:20:00',65.81),('fridge76','2014-07-11','12:30:00',67.1),('fridge77','2014-07-11','12:40:00',67.59),('fridge78','2014-07-11','12:50:00',65.38),('fridge79','2014-07-11','13:00:00',67.32),('fridge80','2014-07-11','13:10:00',66.18),('fridge81','2014-07-11','13:20:00',66.51),('fridge82','2014-07-11','13:30:00',68.78),('fridge83','2014-07-11','13:40:00',70.13),('fridge84','2014-07-11','13:50:00',69.4),('fridge85','2014-07-11','14:00:00',64.03),('fridge86','2014-07-11','14:10:00',65.43),('fridge87','2014-07-11','14:20:00',68.95),('fridge88','2014-07-11','14:30:00',67.74),('fridge89','2014-07-11','14:40:00',67.41),('fridge90','2014-07-11','14:50:00',66),('fridge91','2014-07-11','15:00:00',65.95),('fridge92','2014-07-11','15:10:00',64.96),('fridge93','2014-07-11','15:20:00',64.36),('fridge94','2014-07-11','15:30:00',66.78),('fridge95','2014-07-11','15:40:00',66.22),('fridge96','2014-07-11','15:50:00',65.79),('fridge97','2014-07-11','16:00:00',67.17),('fridge98','2014-07-11','16:10:00',66.56),('fridge99','2014-07-11','16:20:00',66.38),('fridge100','2014-07-11','16:30:00',63.98),('fridge101','2014-07-11','16:40:00',62.58),('fridge102','2014-07-11','16:50:00',63.81),('fridge103','2014-07-11','17:00:00',64.02),('fridge104','2014-07-11','17:10:00',64.02),('fridge105','2014-07-11','17:20:00',66),('fridge106','2014-07-11','17:30:00',67.04),('fridge107','2014-07-11','17:40:00',65.87),('fridge108','2014-07-11','17:50:00',68.32),('fridge109','2014-07-11','18:00:00',66.93),('fridge110','2014-07-11','18:10:00',65.08),('fridge111','2014-07-11','18:20:00',66.02),('fridge112','2014-07-11','18:30:00',67.47),('fridge113','2014-07-11','18:40:00',64.81),('fridge114','2014-07-11','18:50:00',66.58),('fridge115','2014-07-11','19:00:00',66.58),('fridge116','2014-07-11','19:10:00',68.46),('fridge117','2014-07-11','19:20:00',68.71),('fridge118','2014-07-11','19:30:00',70.4),('fridge119','2014-07-11','19:40:00',70.64),('fridge120','2014-07-11','19:50:00',70.72),('fridge121','2014-07-11','20:00:00',70.02),('fridge122','2014-07-11','20:10:00',68.9),('fridge123','2014-07-11','20:20:00',70.59),('fridge124','2014-07-11','20:30:00',71.84),('fridge125','2014-07-11','20:40:00',70.62),('fridge126','2014-07-11','20:50:00',67.87),('fridge127','2014-07-11','21:00:00',71.12),('fridge128','2014-07-11','21:10:00',71.62),('fridge129','2014-07-11','21:20:00',70.56),('fridge130','2014-07-11','21:30:00',69.17),('fridge131','2014-07-11','21:40:00',69.61),('fridge132','2014-07-11','21:50:00',68.07),('fridge133','2014-07-11','22:00:00',67.12),('fridge134','2014-07-11','22:10:00',68.09),('fridge135','2014-07-11','22:20:00',68.07),('fridge136','2014-07-11','22:30:00',67.99),('fridge137','2014-07-11','22:40:00',65.9),('fridge138','2014-07-11','22:50:00',69.42),('fridge139','2014-07-11','23:00:00',68.22),('fridge140','2014-07-11','23:10:00',66.81),('fridge141','2014-07-11','23:20:00',64.64),('fridge142','2014-07-11','23:30:00',62.88),('fridge143','2014-07-11','23:40:00',67.22),('fridge144','2014-07-11','23:50:00',68.56),('fridge2','2014-07-11','00:10:00',64.93),('fridge3','2014-07-11','00:20:00',62.18),('fridge4','2014-07-11','00:30:00',64.28),('fridge5','2014-07-11','00:40:00',66.57),('fridge6','2014-07-11','00:50:00',66.37),('fridge7','2014-07-11','01:00:00',66.13),('fridge8','2014-07-11','01:10:00',66.89),('fridge9','2014-07-11','01:20:00',65.72),('fridge10','2014-07-11','01:30:00',68.56),('fridge11','2014-07-11','01:40:00',64.87),('fridge12','2014-07-11','01:50:00',67.01),('fridge13','2014-07-11','02:00:00',69.7),('fridge14','2014-07-11','02:10:00',62.21),('fridge15','2014-07-11','02:20:00',62.89),('fridge16','2014-07-11','02:30:00',62.41),('fridge17','2014-07-11','02:40:00',61.64),('fridge18','2014-07-11','02:50:00',63.36),('fridge19','2014-07-11','03:00:00',64.7),('fridge20','2014-07-11','03:10:00',60),('fridge21','2014-07-11','03:20:00',60.44),('fridge22','2014-07-11','03:30:00',61.82),('fridge23','2014-07-11','03:40:00',62.61),('fridge24','2014-07-11','03:50:00',60.52),('fridge25','2014-07-11','04:00:00',61.63),('fridge26','2014-07-11','04:10:00',60.11),('fridge27','2014-07-11','04:20:00',61.13),('fridge28','2014-07-11','04:30:00',60.59),('fridge29','2014-07-11','04:40:00',60.21),('fridge30','2014-07-11','04:50:00',61.55),('fridge31','2014-07-11','05:00:00',62.12),('fridge32','2014-07-11','05:10:00',60.17),('fridge33','2014-07-11','05:20:00',60.08),('fridge34','2014-07-11','05:30:00',59.59),('fridge35','2014-07-11','05:40:00',60.65),('fridge36','2014-07-11','05:50:00',60.9),('fridge37','2014-07-11','06:00:00',59.18),('fridge38','2014-07-11','06:10:00',59.18),('fridge39','2014-07-11','06:20:00',59.58),('fridge40','2014-07-11','06:30:00',60.37),('fridge41','2014-07-11','06:40:00',60),('fridge42','2014-07-11','06:50:00',62.62),('fridge43','2014-07-11','07:00:00',62.72),('fridge44','2014-07-11','07:10:00',60.52),('fridge45','2014-07-11','07:20:00',61.86),('fridge46','2014-07-11','07:30:00',59.82),('fridge47','2014-07-11','07:40:00',61.28),('fridge48','2014-07-11','07:50:00',62),('fridge49','2014-07-11','08:00:00',61.96),('fridge50','2014-07-11','08:10:00',58.91),('fridge51','2014-07-11','08:20:00',63.12),('fridge52','2014-07-11','08:30:00',63.72),('fridge53','2014-07-11','08:40:00',59.34),('fridge54','2014-07-11','08:50:00',60.55),('fridge55','2014-07-11','09:00:00',61.52),('fridge56','2014-07-11','09:10:00',61.07),('fridge57','2014-07-11','09:20:00',61.49),('fridge58','2014-07-11','09:30:00',62.7),('fridge59','2014-07-11','09:40:00',62.07),('fridge60','2014-07-11','09:50:00',60.63),('fridge61','2014-07-11','10:00:00',61.92),('fridge62','2014-07-11','10:10:00',61.29),('fridge63','2014-07-11','10:20:00',60.63),('fridge64','2014-07-11','10:30:00',63.01),('fridge65','2014-07-11','10:40:00',64.38),('fridge66','2014-07-11','10:50:00',62.11),('fridge67','2014-07-11','11:00:00',61.52),('fridge68','2014-07-11','11:10:00',61.93),('fridge69','2014-07-11','11:20:00',62.91),('fridge70','2014-07-11','11:30:00',63.12),('fridge71','2014-07-11','11:40:00',62.34),('fridge72','2014-07-11','11:50:00',65.61),('fridge73','2014-07-11','12:00:00',65.28),('fridge74','2014-07-11','12:10:00',65.63),('fridge75','2014-07-11','12:20:00',65.81),('fridge76','2014-07-11','12:30:00',67.1),('fridge77','2014-07-11','12:40:00',67.59),('fridge78','2014-07-11','12:50:00',65.38),('fridge79','2014-07-11','13:00:00',67.32),('fridge80','2014-07-11','13:10:00',66.18),('fridge81','2014-07-11','13:20:00',66.51),('fridge82','2014-07-11','13:30:00',68.78),('fridge83','2014-07-11','13:40:00',70.13),('fridge84','2014-07-11','13:50:00',69.4),('fridge85','2014-07-11','14:00:00',64.03),('fridge86','2014-07-11','14:10:00',65.43),('fridge87','2014-07-11','14:20:00',68.95),('fridge88','2014-07-11','14:30:00',67.74),('fridge89','2014-07-11','14:40:00',67.41),('fridge90','2014-07-11','14:50:00',66),('fridge91','2014-07-11','15:00:00',65.95),('fridge92','2014-07-11','15:10:00',64.96),('fridge93','2014-07-11','15:20:00',64.36),('fridge94','2014-07-11','15:30:00',66.78),('fridge95','2014-07-11','15:40:00',66.22),('fridge96','2014-07-11','15:50:00',65.79),('fridge97','2014-07-11','16:00:00',67.17),('fridge98','2014-07-11','16:10:00',66.56),('fridge99','2014-07-11','16:20:00',66.38),('fridge100','2014-07-11','16:30:00',63.98),('fridge101','2014-07-11','16:40:00',62.58),('fridge102','2014-07-11','16:50:00',63.81),('fridge103','2014-07-11','17:00:00',64.02),('fridge104','2014-07-11','17:10:00',64.02),('fridge105','2014-07-11','17:20:00',66),('fridge106','2014-07-11','17:30:00',67.04),('fridge107','2014-07-11','17:40:00',65.87),('fridge108','2014-07-11','17:50:00',68.32),('fridge109','2014-07-11','18:00:00',66.93),('fridge110','2014-07-11','18:10:00',65.08),('fridge111','2014-07-11','18:20:00',66.02),('fridge112','2014-07-11','18:30:00',67.47),('fridge113','2014-07-11','18:40:00',64.81),('fridge114','2014-07-11','18:50:00',66.58),('fridge115','2014-07-11','19:00:00',66.58),('fridge116','2014-07-11','19:10:00',68.46),('fridge117','2014-07-11','19:20:00',68.71),('fridge118','2014-07-11','19:30:00',70.4),('fridge119','2014-07-11','19:40:00',70.64),('fridge120','2014-07-11','19:50:00',70.72),('fridge121','2014-07-11','20:00:00',70.02),('fridge122','2014-07-11','20:10:00',68.9),('fridge123','2014-07-11','20:20:00',70.59),('fridge124','2014-07-11','20:30:00',71.84),('fridge125','2014-07-11','20:40:00',70.62),('fridge126','2014-07-11','20:50:00',67.87),('fridge127','2014-07-11','21:00:00',71.12),('fridge128','2014-07-11','21:10:00',71.62),('fridge129','2014-07-11','21:20:00',70.56),('fridge130','2014-07-11','21:30:00',69.17),('fridge131','2014-07-11','21:40:00',69.61),('fridge132','2014-07-11','21:50:00',68.07),('fridge133','2014-07-11','22:00:00',67.12),('fridge134','2014-07-11','22:10:00',68.09),('fridge135','2014-07-11','22:20:00',68.07),('fridge136','2014-07-11','22:30:00',67.99),('fridge137','2014-07-11','22:40:00',65.9),('fridge138','2014-07-11','22:50:00',69.42),('fridge139','2014-07-11','23:00:00',68.22),('fridge140','2014-07-11','23:10:00',66.81),('fridge141','2014-07-11','23:20:00',64.64),('fridge142','2014-07-11','23:30:00',62.88),('fridge143','2014-07-11','23:40:00',67.22),('fridge144','2014-07-11','23:50:00',68.56),('fridge1','2014-07-11','08:00:00',61.96),('fridge1','2014-07-11','07:50:00',62),('fridge1','2014-07-11','07:40:00',61.28),('fridge1','2014-07-11','07:30:00',59.82),('fridge1','2014-07-11','07:20:00',61.86),('fridge1','2014-07-11','07:10:00',60.52),('fridge1','2014-07-11','07:00:00',62.72),('fridge1','2014-07-11','06:50:00',62.62),('fridge1','2014-07-11','06:40:00',60),('fridge1','2014-07-11','06:30:00',60.37),('fridge1','2014-07-11','06:20:00',59.58),('fridge1','2014-07-11','06:10:00',59.18),('fridge1','2014-07-11','06:00:00',59.18),('fridge1','2014-07-11','05:50:00',60.9),('fridge1','2014-07-11','05:40:00',60.65),('fridge1','2014-07-11','05:30:00',59.59),('fridge1','2014-07-11','05:20:00',60.08),('fridge1','2014-07-11','05:10:00',60.17),('fridge1','2014-07-11','05:00:00',62.12),('fridge1','2014-07-11','04:50:00',61.55),('fridge1','2014-07-11','04:40:00',60.21),('fridge1','2014-07-11','04:30:00',60.59),('fridge1','2014-07-11','04:20:00',61.13),('fridge1','2014-07-11','04:10:00',60.11),('fridge1','2014-07-11','04:00:00',61.63),('fridge1','2014-07-11','03:50:00',60.52),('fridge1','2014-07-11','03:40:00',62.61),('fridge1','2014-07-11','03:30:00',61.82),('fridge1','2014-07-11','03:20:00',60.44),('fridge1','2014-07-11','03:10:00',60),('fridge1','2014-07-11','03:00:00',64.7),('fridge1','2014-07-11','02:50:00',63.36),('fridge1','2014-07-11','02:40:00',61.64),('fridge1','2014-07-11','02:30:00',62.41),('fridge1','2014-07-11','02:20:00',62.89),('fridge1','2014-07-11','02:10:00',62.21),('fridge1','2014-07-11','02:00:00',69.7),('fridge1','2014-07-11','01:50:00',67.01),('fridge1','2014-07-11','01:40:00',64.87),('fridge1','2014-07-11','01:30:00',68.56),('fridge1','2014-07-11','01:20:00',65.72),('fridge1','2014-07-11','01:10:00',66.89),('fridge1','2014-07-11','01:00:00',66.13),('fridge1','2014-07-11','00:50:00',66.37),('fridge1','2014-07-11','00:40:00',66.57),('fridge1','2014-07-11','00:30:00',64.28),('fridge1','2014-07-11','00:20:00',62.18),('fridge1','2014-07-11','00:10:00',64.93),('fridge1','2014-07-11','00:00:00',67.52),('fridge1','2014-07-11','08:20:00',63.12),('fridge1','2014-07-11','08:30:00',63.72),('fridge1','2014-07-11','08:40:00',59.34),('fridge1','2014-07-11','08:50:00',60.55),('fridge1','2014-07-11','09:00:00',61.52),('fridge1','2014-07-11','09:10:00',61.07),('fridge1','2014-07-11','09:20:00',61.49),('fridge1','2014-07-11','09:30:00',62.7),('fridge1','2014-07-11','09:40:00',62.07),('fridge1','2014-07-11','09:50:00',60.63),('fridge1','2014-07-11','10:00:00',61.92),('fridge1','2014-07-11','10:10:00',61.29),('fridge1','2014-07-11','10:20:00',60.63),('fridge1','2014-07-11','10:30:00',63.01),('fridge1','2014-07-11','10:40:00',64.38),('fridge1','2014-07-11','10:50:00',62.11),('fridge1','2014-07-11','11:00:00',61.52),('fridge1','2014-07-11','11:10:00',61.93),('fridge1','2014-07-11','11:20:00',62.91),('fridge1','2014-07-11','11:30:00',63.12),('fridge1','2014-07-11','11:40:00',62.34),('fridge1','2014-07-11','11:50:00',65.61),('fridge1','2014-07-11','12:00:00',65.28),('fridge1','2014-07-11','12:10:00',65.63),('fridge1','2014-07-11','12:20:00',65.81),('fridge1','2014-07-11','12:30:00',67.1),('fridge1','2014-07-11','12:40:00',67.59),('fridge1','2014-07-11','12:50:00',65.38),('fridge1','2014-07-11','13:00:00',67.32),('fridge1','2014-07-11','13:10:00',66.18),('fridge1','2014-07-11','13:20:00',66.51),('fridge1','2014-07-11','13:30:00',68.78),('fridge1','2014-07-11','13:40:00',70.13),('fridge1','2014-07-11','13:50:00',69.4),('fridge1','2014-07-11','14:00:00',64.03),('fridge1','2014-07-11','14:10:00',65.43),('fridge1','2014-07-11','14:20:00',68.95),('fridge1','2014-07-11','14:30:00',67.74),('fridge1','2014-07-11','14:40:00',67.41),('fridge1','2014-07-11','14:50:00',66),('fridge1','2014-07-11','15:00:00',65.95),('fridge1','2014-07-11','15:10:00',64.96),('fridge1','2014-07-11','15:20:00',64.36),('fridge1','2014-07-11','15:30:00',66.78),('fridge1','2014-07-11','15:40:00',66.22),('fridge1','2014-07-11','15:50:00',65.79),('fridge1','2014-07-11','16:00:00',67.17),('fridge1','2014-07-11','16:10:00',66.56),('fridge1','2014-07-11','16:20:00',66.38),('fridge1','2014-07-11','16:30:00',63.98),('fridge1','2014-07-11','16:40:00',62.58),('fridge1','2014-07-11','16:50:00',63.81),('fridge1','2014-07-11','17:00:00',64.02),('fridge1','2014-07-11','17:10:00',64.02),('fridge1','2014-07-11','17:20:00',66),('fridge1','2014-07-11','17:30:00',67.04),('fridge1','2014-07-11','17:40:00',65.87),('fridge1','2014-07-11','17:50:00',68.32),('fridge1','2014-07-11','18:00:00',66.93),('fridge1','2014-07-11','18:10:00',65.08),('fridge1','2014-07-11','18:20:00',66.02),('fridge1','2014-07-11','18:30:00',67.47),('fridge1','2014-07-11','18:40:00',64.81),('fridge1','2014-07-11','18:50:00',66.58),('fridge1','2014-07-11','19:00:00',66.58),('fridge1','2014-07-11','19:10:00',68.46),('fridge1','2014-07-11','19:20:00',68.71),('fridge1','2014-07-11','19:30:00',70.4),('fridge1','2014-07-11','19:40:00',70.64),('fridge1','2014-07-11','19:50:00',70.72),('fridge1','2014-07-11','20:00:00',70.02),('fridge1','2014-07-11','20:10:00',68.9),('fridge1','2014-07-11','20:20:00',70.59),('fridge1','2014-07-11','20:30:00',71.84),('fridge1','2014-07-11','20:40:00',70.62),('fridge1','2014-07-11','20:50:00',67.87),('fridge1','2014-07-11','21:00:00',71.12),('fridge1','2014-07-11','21:10:00',71.62),('fridge1','2014-07-11','21:20:00',70.56),('fridge1','2014-07-11','21:30:00',69.17),('fridge1','2014-07-11','21:40:00',69.61),('fridge1','2014-07-11','21:50:00',68.07),('fridge1','2014-07-11','22:00:00',67.12),('fridge1','2014-07-11','22:10:00',68.09),('fridge1','2014-07-11','22:20:00',68.07),('fridge1','2014-07-11','22:30:00',67.99),('fridge1','2014-07-11','22:40:00',65.9),('fridge1','2014-07-11','22:50:00',69.42),('fridge1','2014-07-11','23:00:00',68.22),('fridge1','2014-07-11','23:10:00',66.81),('fridge1','2014-07-11','23:20:00',64.64),('fridge1','2014-07-11','23:30:00',62.88),('fridge1','2014-07-11','23:40:00',67.22),('fridge1','2014-07-11','23:50:00',68.56),('boiler1','2014-07-11','23:50:00',228),('boiler1','2014-07-11','23:40:00',219),('boiler1','2014-07-11','23:30:00',233),('boiler1','2014-07-11','23:20:00',252),('boiler1','2014-07-11','23:10:00',223),('boiler1','2014-07-11','23:00:00',240),('boiler1','2014-07-11','22:50:00',242),('boiler1','2014-07-11','22:40:00',262),('boiler1','2014-07-11','22:30:00',274),('boiler1','2014-07-11','22:20:00',267),('boiler1','2014-07-11','22:10:00',273),('boiler1','2014-07-11','22:00:00',262),('boiler1','2014-07-11','21:50:00',285),('boiler1','2014-07-11','21:40:00',302),('boiler1','2014-07-11','21:30:00',303),('boiler1','2014-07-11','21:20:00',315),('boiler1','2014-07-11','21:10:00',312),('boiler1','2014-07-11','21:00:00',322),('boiler1','2014-07-11','20:50:00',320),('boiler1','2014-07-11','20:40:00',337),('boiler1','2014-07-11','20:30:00',333),('boiler1','2014-07-11','20:20:00',352),('boiler1','2014-07-11','20:10:00',337),('boiler1','2014-07-11','20:00:00',284),('boiler1','2014-07-11','19:50:00',280),('boiler1','2014-07-11','19:40:00',255),('boiler1','2014-07-11','19:30:00',250),('boiler1','2014-07-11','19:20:00',255),('boiler1','2014-07-11','19:10:00',249),('boiler1','2014-07-11','19:00:00',245),('boiler1','2014-07-11','18:50:00',236),('boiler1','2014-07-11','18:40:00',241),('boiler1','2014-07-11','18:30:00',218),('boiler1','2014-07-11','18:20:00',225),('boiler1','2014-07-11','18:10:00',211),('boiler1','2014-07-11','18:00:00',240),('boiler1','2014-07-11','17:50:00',248),('boiler1','2014-07-11','17:40:00',169),('boiler1','2014-07-11','17:30:00',182),('boiler1','2014-07-11','17:20:00',170),('boiler1','2014-07-11','17:10:00',173),('boiler1','2014-07-11','17:00:00',181),('boiler1','2014-07-11','16:50:00',161),('boiler1','2014-07-11','16:40:00',148),('boiler1','2014-07-11','16:30:00',166),('boiler1','2014-07-11','16:20:00',153),('boiler1','2014-07-11','16:10:00',155),('boiler1','2014-07-11','16:00:00',146),('boiler1','2014-07-11','15:50:00',137),('boiler1','2014-07-11','15:40:00',146),('boiler1','2014-07-11','15:30:00',129),('boiler1','2014-07-11','15:20:00',128),('boiler1','2014-07-11','15:10:00',124),('boiler1','2014-07-11','15:00:00',149),('boiler1','2014-07-11','14:50:00',149),('boiler1','2014-07-11','14:40:00',156),('boiler1','2014-07-11','14:30:00',139),('boiler1','2014-07-11','14:20:00',147),('boiler1','2014-07-11','14:10:00',155),('boiler1','2014-07-11','14:00:00',151),('boiler1','2014-07-11','13:50:00',180),('boiler1','2014-07-11','13:40:00',178),('boiler1','2014-07-11','13:30:00',186),('boiler1','2014-07-11','13:20:00',179),('boiler1','2014-07-11','13:10:00',178),('boiler1','2014-07-11','13:00:00',191),('boiler1','2014-07-11','12:50:00',195),('boiler1','2014-07-11','12:40:00',193),('boiler1','2014-07-11','12:30:00',201),('boiler1','2014-07-11','12:20:00',207),('boiler1','2014-07-11','12:10:00',232),('boiler1','2014-07-11','12:00:00',206),('boiler1','2014-07-11','11:50:00',183),('boiler1','2014-07-11','11:40:00',197),('boiler1','2014-07-11','11:30:00',199),('boiler1','2014-07-11','11:20:00',227),('boiler1','2014-07-11','11:10:00',216),('boiler1','2014-07-11','11:00:00',211),('boiler1','2014-07-11','10:50:00',223),('boiler1','2014-07-11','10:40:00',201),('boiler1','2014-07-11','10:30:00',220),('boiler1','2014-07-11','10:20:00',226),('boiler1','2014-07-11','10:10:00',233),('boiler1','2014-07-11','10:00:00',260),('boiler1','2014-07-11','09:50:00',272),('boiler1','2014-07-11','09:40:00',289),('boiler1','2014-07-11','09:30:00',307),('boiler1','2014-07-11','09:20:00',335),('boiler1','2014-07-11','09:10:00',337),('boiler1','2014-07-11','09:00:00',361),('boiler1','2014-07-11','08:50:00',386),('boiler1','2014-07-11','08:40:00',380),('boiler1','2014-07-11','08:30:00',381),('boiler1','2014-07-11','08:20:00',367),('boiler1','2014-07-11','08:10:00',362),('boiler1','2014-07-11','08:00:00',299),('boiler1','2014-07-11','07:50:00',280),('boiler1','2014-07-11','07:40:00',239),('boiler1','2014-07-11','07:30:00',269),('boiler1','2014-07-11','07:20:00',246),('boiler1','2014-07-11','07:10:00',222),('boiler1','2014-07-11','07:00:00',190),('boiler1','2014-07-11','06:50:00',150),('boiler1','2014-07-11','06:40:00',148),('boiler1','2014-07-11','06:30:00',127),('boiler1','2014-07-11','06:20:00',121),('boiler1','2014-07-11','06:10:00',124),('boiler1','2014-07-11','06:00:00',125),('boiler1','2014-07-11','05:50:00',116),('boiler1','2014-07-11','05:40:00',72),('boiler1','2014-07-11','05:30:00',92),('boiler1','2014-07-11','05:20:00',64),('boiler1','2014-07-11','05:10:00',51),('boiler1','2014-07-11','05:00:00',60),('boiler1','2014-07-11','04:50:00',59),('boiler1','2014-07-11','04:40:00',53),('boiler1','2014-07-11','04:30:00',62),('boiler1','2014-07-11','04:20:00',54),('boiler1','2014-07-11','04:10:00',64),('boiler1','2014-07-11','04:00:00',61),('boiler1','2014-07-11','03:50:00',58),('boiler1','2014-07-11','03:40:00',62),('boiler1','2014-07-11','03:30:00',73),('boiler1','2014-07-11','03:20:00',70),('boiler1','2014-07-11','03:10:00',65),('boiler1','2014-07-11','03:00:00',75),('boiler1','2014-07-11','02:50:00',92),('boiler1','2014-07-11','02:40:00',89),('boiler1','2014-07-11','02:30:00',93),('boiler1','2014-07-11','02:20:00',84),('boiler1','2014-07-11','02:10:00',76),('boiler1','2014-07-11','02:00:00',85),('boiler1','2014-07-11','01:50:00',74),('boiler1','2014-07-11','01:40:00',90),('boiler1','2014-07-11','01:30:00',79),('boiler1','2014-07-11','01:20:00',105),('boiler1','2014-07-11','01:10:00',102),('boiler1','2014-07-11','01:00:00',111),('boiler1','2014-07-11','00:50:00',113),('boiler1','2014-07-11','00:40:00',144),('boiler1','2014-07-11','00:30:00',140),('boiler1','2014-07-11','00:20:00',163),('boiler1','2014-07-11','00:10:00',197),('boiler1','2014-07-11','00:00:00',203),('freezer1','2014-07-11','23:50:00',56.58),('freezer1','2014-07-11','23:40:00',59.27),('freezer1','2014-07-11','23:30:00',56.54),('freezer1','2014-07-11','23:20:00',56.09),('freezer1','2014-07-11','23:10:00',54.67),('freezer1','2014-07-11','23:00:00',55.9),('freezer1','2014-07-11','22:50:00',57.85),('freezer1','2014-07-11','22:40:00',60.56),('freezer1','2014-07-11','22:30:00',56.8),('freezer1','2014-07-11','22:20:00',57.54),('freezer1','2014-07-11','22:10:00',57.99),('freezer1','2014-07-11','22:00:00',56.13),('freezer1','2014-07-11','21:50:00',58.2),('freezer1','2014-07-11','21:40:00',57.35),('freezer1','2014-07-11','21:30:00',57.24),('freezer1','2014-07-11','21:20:00',58.54),('freezer1','2014-07-11','21:10:00',59.73),('freezer1','2014-07-11','21:00:00',57.86),('freezer1','2014-07-11','20:50:00',58.81),('freezer1','2014-07-11','20:40:00',59.48),('freezer1','2014-07-11','20:30:00',59.29),('freezer1','2014-07-11','20:20:00',57.8),('freezer1','2014-07-11','20:10:00',58.54),('freezer1','2014-07-11','20:00:00',56.58),('freezer1','2014-07-11','19:50:00',55.95),('freezer1','2014-07-11','19:40:00',57.53),('freezer1','2014-07-11','19:30:00',59.72),('freezer1','2014-07-11','19:20:00',58.66),('freezer1','2014-07-11','19:10:00',59.8),('freezer1','2014-07-11','19:00:00',59.4),('freezer1','2014-07-11','18:50:00',59.27),('freezer1','2014-07-11','18:40:00',56.93),('freezer1','2014-07-11','18:30:00',59.58),('freezer1','2014-07-11','18:20:00',56.93),('freezer1','2014-07-11','18:10:00',57.39),('freezer1','2014-07-11','18:00:00',57.85),('freezer1','2014-07-11','17:50:00',59.14),('freezer1','2014-07-11','17:40:00',60.43),('freezer1','2014-07-11','17:30:00',59.46),('freezer1','2014-07-11','17:20:00',56.68),('freezer1','2014-07-11','17:10:00',58),('freezer1','2014-07-11','17:00:00',59.85),('freezer1','2014-07-11','16:50:00',56.84),('freezer1','2014-07-11','16:40:00',55.96),('freezer1','2014-07-11','16:30:00',57.36),('freezer1','2014-07-11','16:20:00',58.95),('freezer1','2014-07-11','16:10:00',58.76),('freezer1','2014-07-11','16:00:00',57.38),('freezer1','2014-07-11','15:50:00',57.13),('freezer1','2014-07-11','15:40:00',55.16),('freezer1','2014-07-11','15:30:00',61.38),('freezer1','2014-07-11','15:20:00',60.54),('freezer1','2014-07-11','15:10:00',59.55),('freezer1','2014-07-11','15:00:00',58.01),('freezer1','2014-07-11','14:50:00',55.05),('freezer1','2014-07-11','14:40:00',55.8),('freezer1','2014-07-11','14:30:00',56.13),('freezer1','2014-07-11','14:20:00',58.1),('freezer1','2014-07-11','14:10:00',56.81),('freezer1','2014-07-11','14:00:00',59.73),('freezer1','2014-07-11','13:50:00',58.69),('freezer1','2014-07-11','13:40:00',57.45),('freezer1','2014-07-11','13:30:00',56.63),('freezer1','2014-07-11','13:20:00',58.26),('freezer1','2014-07-11','13:10:00',58.5),('freezer1','2014-07-11','13:00:00',57.72),('freezer1','2014-07-11','12:50:00',59.22),('freezer1','2014-07-11','12:40:00',58.79),('freezer1','2014-07-11','12:30:00',58.55),('freezer1','2014-07-11','12:20:00',63.42),('freezer1','2014-07-11','12:10:00',55.67),('freezer1','2014-07-11','12:00:00',58.57),('freezer1','2014-07-11','11:50:00',58.98),('freezer1','2014-07-11','11:40:00',56.1),('freezer1','2014-07-11','11:30:00',54.7),('freezer1','2014-07-11','11:20:00',56.07),('freezer1','2014-07-11','11:10:00',56.71),('freezer1','2014-07-11','11:00:00',60.15),('freezer1','2014-07-11','10:50:00',56.81),('freezer1','2014-07-11','10:40:00',53.55),('freezer1','2014-07-11','10:30:00',56.55),('freezer1','2014-07-11','10:20:00',56.83),('freezer1','2014-07-11','10:10:00',56.88),('freezer1','2014-07-11','10:00:00',53.67),('freezer1','2014-07-11','09:50:00',53.83),('freezer1','2014-07-11','09:40:00',55.17),('freezer1','2014-07-11','09:30:00',53.11),('freezer1','2014-07-11','09:20:00',54.72),('freezer1','2014-07-11','09:10:00',55.75),('freezer1','2014-07-11','09:00:00',56.73),('freezer1','2014-07-11','08:50:00',58.45),('freezer1','2014-07-11','08:40:00',55.38),('freezer1','2014-07-11','08:30:00',54.38),('freezer1','2014-07-11','08:20:00',53.37),('freezer1','2014-07-11','08:10:00',55.89),('freezer1','2014-07-11','08:00:00',55.3),('freezer1','2014-07-11','07:50:00',53.12),('freezer1','2014-07-11','07:40:00',53.9),('freezer1','2014-07-11','07:30:00',54.91),('freezer1','2014-07-11','07:20:00',55.67),('freezer1','2014-07-11','07:10:00',57.43),('freezer1','2014-07-11','07:00:00',55.13),('freezer1','2014-07-11','06:50:00',53.9),('freezer1','2014-07-11','06:40:00',53.11),('freezer1','2014-07-11','06:30:00',54.8),('freezer1','2014-07-11','06:20:00',54.5),('freezer1','2014-07-11','06:10:00',55.87),('freezer1','2014-07-11','06:00:00',55.72),('freezer1','2014-07-11','05:50:00',53.81),('freezer1','2014-07-11','05:40:00',52.06),('freezer1','2014-07-11','05:30:00',54.52),('freezer1','2014-07-11','05:20:00',57.09),('freezer1','2014-07-11','05:10:00',55.35),('freezer1','2014-07-11','05:00:00',55.22),('freezer1','2014-07-11','04:50:00',57.61),('freezer1','2014-07-11','04:40:00',55.09),('freezer1','2014-07-11','04:30:00',55.2),('freezer1','2014-07-11','04:20:00',56.79),('freezer1','2014-07-11','04:10:00',53.82),('freezer1','2014-07-11','04:00:00',62.35),('freezer1','2014-07-11','03:50:00',57.1),('freezer1','2014-07-11','03:40:00',56.94),('freezer1','2014-07-11','03:30:00',53.67),('freezer1','2014-07-11','03:20:00',52.99),('freezer1','2014-07-11','03:10:00',57.78),('freezer1','2014-07-11','03:00:00',55.94),('freezer1','2014-07-11','02:50:00',58.83),('freezer1','2014-07-11','02:40:00',55.33),('freezer1','2014-07-11','02:30:00',54.83),('freezer1','2014-07-11','02:20:00',56),('freezer1','2014-07-11','02:10:00',57.52),('freezer1','2014-07-11','02:00:00',57),('freezer1','2014-07-11','01:50:00',56.82),('freezer1','2014-07-11','01:40:00',61.71),('freezer1','2014-07-11','01:30:00',55.16),('freezer1','2014-07-11','01:20:00',58),('freezer1','2014-07-11','01:10:00',58),('freezer1','2014-07-11','01:00:00',55.56),('freezer1','2014-07-11','00:50:00',55.12),('freezer1','2014-07-11','00:40:00',57.23),('freezer1','2014-07-11','00:30:00',56.85),('freezer1','2014-07-11','00:20:00',57.88),('freezer1','2014-07-11','00:10:00',57.31),('freezer1','2014-07-11','00:00:00',58.04),('TV1','2014-07-11','00:00:00',16.65),('TV1','2014-07-11','00:10:00',15.39),('TV1','2014-07-11','00:20:00',14.48),('TV1','2014-07-11','00:30:00',13.21),('TV1','2014-07-11','00:40:00',11.93),('TV1','2014-07-11','00:50:00',10.89),('TV1','2014-07-11','01:00:00',9.6),('TV1','2014-07-11','01:10:00',8.71),('TV1','2014-07-11','01:20:00',8.49),('TV1','2014-07-11','01:30:00',7.93),('TV1','2014-07-11','01:40:00',7.08),('TV1','2014-07-11','01:50:00',6.61),('TV1','2014-07-11','02:00:00',6.39),('TV1','2014-07-11','02:10:00',6.25),('TV1','2014-07-11','02:20:00',6.19),('TV1','2014-07-11','02:30:00',5.98),('TV1','2014-07-11','02:40:00',5.83),('TV1','2014-07-11','02:50:00',5.64),('TV1','2014-07-11','03:00:00',5.62),('TV1','2014-07-11','03:10:00',5.44),('TV1','2014-07-11','03:20:00',5.28),('TV1','2014-07-11','03:30:00',5.18),('TV1','2014-07-11','03:40:00',5.03),('TV1','2014-07-11','03:50:00',5.01),('TV1','2014-07-11','04:00:00',4.91),('TV1','2014-07-11','04:10:00',4.86),('TV1','2014-07-11','04:20:00',4.74),('TV1','2014-07-11','04:30:00',4.74),('TV1','2014-07-11','04:40:00',4.66),('TV1','2014-07-11','04:50:00',4.65),('TV1','2014-07-11','05:00:00',4.74),('TV1','2014-07-11','05:10:00',4.71),('TV1','2014-07-11','05:20:00',4.72),('TV1','2014-07-11','05:30:00',4.78),('TV1','2014-07-11','05:40:00',4.7),('TV1','2014-07-11','05:50:00',4.89),('TV1','2014-07-11','06:00:00',5.15),('TV1','2014-07-11','06:10:00',5.47),('TV1','2014-07-11','06:20:00',5.82),('TV1','2014-07-11','06:30:00',6.13),('TV1','2014-07-11','06:40:00',6.49),('TV1','2014-07-11','06:50:00',7.09),('TV1','2014-07-11','07:00:00',7.7),('TV1','2014-07-11','07:10:00',8.87),('TV1','2014-07-11','07:20:00',9.59),('TV1','2014-07-11','07:30:00',10.01),('TV1','2014-07-11','07:40:00',9.92),('TV1','2014-07-11','07:50:00',9.9),('TV1','2014-07-11','08:00:00',10.59),('TV1','2014-07-11','08:10:00',10.43),('TV1','2014-07-11','08:20:00',9.97),('TV1','2014-07-11','08:30:00',9.89),('TV1','2014-07-11','08:40:00',9.71),('TV1','2014-07-11','08:50:00',9.46),('TV1','2014-07-11','09:00:00',9.11),('TV1','2014-07-11','09:10:00',8.49),('TV1','2014-07-11','09:20:00',7.92),('TV1','2014-07-11','09:30:00',7.76),('TV1','2014-07-11','09:40:00',7.87),('TV1','2014-07-11','09:50:00',7.89),('TV1','2014-07-11','10:00:00',7.96),('TV1','2014-07-11','10:10:00',7.98),('TV1','2014-07-11','10:20:00',8.07),('TV1','2014-07-11','10:30:00',8.15),('TV1','2014-07-11','10:40:00',8.13),('TV1','2014-07-11','10:50:00',8.21),('TV1','2014-07-11','11:00:00',8.29),('TV1','2014-07-11','11:10:00',8.46),('TV1','2014-07-11','11:20:00',8.66),('TV1','2014-07-11','11:30:00',9.1),('TV1','2014-07-11','11:40:00',9.79),('TV1','2014-07-11','11:50:00',10.42),('TV1','2014-07-11','12:00:00',11.36),('TV1','2014-07-11','12:10:00',12.41),('TV1','2014-07-11','12:20:00',13.58),('TV1','2014-07-11','12:30:00',14.82),('TV1','2014-07-11','12:40:00',15.67),('TV1','2014-07-11','12:50:00',17.18),('TV1','2014-07-11','13:00:00',18.81),('TV1','2014-07-11','13:10:00',19.76),('TV1','2014-07-11','13:20:00',20.36),('TV1','2014-07-11','13:30:00',21.08),('TV1','2014-07-11','13:40:00',21.68),('TV1','2014-07-11','13:50:00',21.5),('TV1','2014-07-11','14:00:00',21.51),('TV1','2014-07-11','14:10:00',20.75),('TV1','2014-07-11','14:20:00',20.5),('TV1','2014-07-11','14:30:00',19.9),('TV1','2014-07-11','14:40:00',18.78),('TV1','2014-07-11','14:50:00',17.64),('TV1','2014-07-11','15:00:00',17),('TV1','2014-07-11','15:10:00',16.45),('TV1','2014-07-11','15:20:00',15.82),('TV1','2014-07-11','15:30:00',15.52),('TV1','2014-07-11','15:40:00',15.22),('TV1','2014-07-11','15:50:00',14.87),('TV1','2014-07-11','16:00:00',14.7),('TV1','2014-07-11','16:10:00',14.62),('TV1','2014-07-11','16:20:00',14.69),('TV1','2014-07-11','16:30:00',14.41),('TV1','2014-07-11','16:40:00',14.56),('TV1','2014-07-11','16:50:00',14.44),('TV1','2014-07-11','17:00:00',14.67),('TV1','2014-07-11','17:10:00',14.76),('TV1','2014-07-11','17:20:00',14.71),('TV1','2014-07-11','17:30:00',14.21),('TV1','2014-07-11','17:40:00',14.07),('TV1','2014-07-11','17:50:00',13.94),('TV1','2014-07-11','18:00:00',14.37),('TV1','2014-07-11','18:10:00',14.75),('TV1','2014-07-11','18:20:00',15.11),('TV1','2014-07-11','18:30:00',15.58),('TV1','2014-07-11','18:40:00',16.1),('TV1','2014-07-11','18:50:00',16.63),('TV1','2014-07-11','19:00:00',18.17),('TV1','2014-07-11','19:10:00',19.45),('TV1','2014-07-11','19:20:00',20.87),('TV1','2014-07-11','19:30:00',22.22),('TV1','2014-07-11','19:40:00',23.53),('TV1','2014-07-11','19:50:00',24.3),('TV1','2014-07-11','20:00:00',26.06),('TV1','2014-07-11','20:10:00',26.95),('TV1','2014-07-11','20:20:00',27.7),('TV1','2014-07-11','20:30:00',28.45),('TV1','2014-07-11','20:40:00',29.1),('TV1','2014-07-11','20:50:00',29.71),('TV1','2014-07-11','21:00:00',29.57),('TV1','2014-07-11','21:10:00',30.3),('TV1','2014-07-11','21:20:00',30.66),('TV1','2014-07-11','21:30:00',30.67),('TV1','2014-07-11','21:40:00',30.66),('TV1','2014-07-11','21:50:00',30.7),('TV1','2014-07-11','22:00:00',30.5),('TV1','2014-07-11','22:10:00',30.39),('TV1','2014-07-11','22:20:00',29.83),('TV1','2014-07-11','22:30:00',29.33),('TV1','2014-07-11','22:40:00',28.46),('TV1','2014-07-11','22:50:00',27.45),('TV1','2014-07-11','23:00:00',26.52),('TV1','2014-07-11','23:10:00',25.18),('TV1','2014-07-11','23:20:00',23.23),('TV1','2014-07-11','23:30:00',21.57),('TV1','2014-07-11','23:40:00',19.88),('TV1','2014-07-11','23:50:00',18.14),('video1','2014-07-11','00:00:00',8.14),('video1','2014-07-11','00:10:00',8.21),('video1','2014-07-11','00:20:00',7.86),('video1','2014-07-11','00:30:00',7.98),('video1','2014-07-11','00:40:00',7.9),('video1','2014-07-11','00:50:00',7.51),('video1','2014-07-11','01:00:00',7.55),('video1','2014-07-11','01:10:00',7.75),('video1','2014-07-11','01:20:00',7.69),('video1','2014-07-11','01:30:00',7.92),('video1','2014-07-11','01:40:00',7.85),('video1','2014-07-11','01:50:00',7.67),('video1','2014-07-11','02:00:00',7.7),('video1','2014-07-11','02:10:00',7.79),('video1','2014-07-11','02:20:00',7.58),('video1','2014-07-11','02:30:00',7.72),('video1','2014-07-11','02:40:00',7.73),('video1','2014-07-11','02:50:00',7.56),('video1','2014-07-11','03:00:00',7.75),('video1','2014-07-11','03:10:00',7.45),('video1','2014-07-11','03:20:00',7.79),('video1','2014-07-11','03:30:00',7.64),('video1','2014-07-11','03:40:00',7.39),('video1','2014-07-11','03:50:00',7.67),('video1','2014-07-11','04:00:00',7.68),('video1','2014-07-11','04:10:00',7.43),('video1','2014-07-11','04:20:00',7.68),('video1','2014-07-11','04:30:00',7.65),('video1','2014-07-11','04:40:00',7.53),('video1','2014-07-11','04:50:00',7.61),('video1','2014-07-11','05:00:00',7.47),('video1','2014-07-11','05:10:00',7.58),('video1','2014-07-11','05:20:00',7.52),('video1','2014-07-11','05:30:00',7.55),('video1','2014-07-11','05:40:00',7.59),('video1','2014-07-11','05:50:00',7.69),('video1','2014-07-11','06:00:00',7.33),('video1','2014-07-11','06:10:00',7.68),('video1','2014-07-11','06:20:00',7.5),('video1','2014-07-11','06:30:00',7.49),('video1','2014-07-11','06:40:00',7.71),('video1','2014-07-11','06:50:00',7.49),('video1','2014-07-11','07:00:00',7.3),('video1','2014-07-11','07:10:00',7.51),('video1','2014-07-11','07:20:00',7.66),('video1','2014-07-11','07:30:00',7.45),('video1','2014-07-11','07:40:00',7.43),('video1','2014-07-11','07:50:00',7.41),('video1','2014-07-11','08:00:00',7.48),('video1','2014-07-11','08:10:00',7.43),('video1','2014-07-11','08:20:00',7.6),('video1','2014-07-11','08:30:00',7.56),('video1','2014-07-11','08:40:00',7.51),('video1','2014-07-11','08:50:00',7.45),('video1','2014-07-11','09:00:00',7.72),('video1','2014-07-11','09:10:00',7.43),('video1','2014-07-11','09:20:00',7.4),('video1','2014-07-11','09:30:00',7.83),('video1','2014-07-11','09:40:00',7.65),('video1','2014-07-11','09:50:00',7.77),('video1','2014-07-11','10:00:00',7.73),('video1','2014-07-11','10:10:00',7.99),('video1','2014-07-11','10:20:00',7.79),('video1','2014-07-11','10:30:00',7.87),('video1','2014-07-11','10:40:00',7.81),('video1','2014-07-11','10:50:00',7.85),('video1','2014-07-11','11:00:00',7.72),('video1','2014-07-11','11:10:00',7.77),('video1','2014-07-11','11:20:00',7.93),('video1','2014-07-11','11:30:00',7.73),('video1','2014-07-11','11:40:00',7.97),('video1','2014-07-11','11:50:00',7.84),('video1','2014-07-11','12:00:00',8.1),('video1','2014-07-11','12:10:00',8),('video1','2014-07-11','12:20:00',8.3),('video1','2014-07-11','12:30:00',8.29),('video1','2014-07-11','12:40:00',8.37),('video1','2014-07-11','12:50:00',8.32),('video1','2014-07-11','13:00:00',8.26),('video1','2014-07-11','13:10:00',8.34),('video1','2014-07-11','13:20:00',8.32),('video1','2014-07-11','13:30:00',8.34),('video1','2014-07-11','13:40:00',8.5),('video1','2014-07-11','13:50:00',8.6),('video1','2014-07-11','14:00:00',8.51),('video1','2014-07-11','14:10:00',8.5),('video1','2014-07-11','14:20:00',8.51),('video1','2014-07-11','14:30:00',8.4),('video1','2014-07-11','14:40:00',8.24),('video1','2014-07-11','14:50:00',8.06),('video1','2014-07-11','15:00:00',8.14),('video1','2014-07-11','15:10:00',8.17),('video1','2014-07-11','15:20:00',8.13),('video1','2014-07-11','15:30:00',8.17),('video1','2014-07-11','15:40:00',8),('video1','2014-07-11','15:50:00',8.08),('video1','2014-07-11','16:00:00',8.19),('video1','2014-07-11','16:10:00',8.13),('video1','2014-07-11','16:20:00',8.07),('video1','2014-07-11','16:30:00',8.11),('video1','2014-07-11','16:40:00',8.15),('video1','2014-07-11','16:50:00',8.06),('video1','2014-07-11','17:00:00',8.23),('video1','2014-07-11','17:10:00',8.08),('video1','2014-07-11','17:20:00',8.2),('video1','2014-07-11','17:30:00',8.19),('video1','2014-07-11','17:40:00',7.87),('video1','2014-07-11','17:50:00',8.23),('video1','2014-07-11','18:00:00',8.14),('video1','2014-07-11','18:10:00',8.22),('video1','2014-07-11','18:20:00',8.11),('video1','2014-07-11','18:30:00',8.53),('video1','2014-07-11','18:40:00',8.52),('video1','2014-07-11','18:50:00',8.18),('video1','2014-07-11','19:00:00',8.15),('video1','2014-07-11','19:10:00',7.98),('video1','2014-07-11','19:20:00',8.27),('video1','2014-07-11','19:30:00',8.4),('video1','2014-07-11','19:40:00',8.36),('video1','2014-07-11','19:50:00',8.32),('video1','2014-07-11','20:00:00',8.79),('video1','2014-07-11','20:10:00',8.55),('video1','2014-07-11','20:20:00',8.66),('video1','2014-07-11','20:30:00',8.56),('video1','2014-07-11','20:40:00',8.75),('video1','2014-07-11','20:50:00',9.01),('video1','2014-07-11','21:00:00',8.88),('video1','2014-07-11','21:10:00',8.72),('video1','2014-07-11','21:20:00',8.91),('video1','2014-07-11','21:30:00',8.75),('video1','2014-07-11','21:40:00',8.87),('video1','2014-07-11','21:50:00',8.81),('video1','2014-07-11','22:00:00',8.71),('video1','2014-07-11','22:10:00',8.84),('video1','2014-07-11','22:20:00',8.82),('video1','2014-07-11','22:30:00',8.64),('video1','2014-07-11','22:40:00',8.61),('video1','2014-07-11','22:50:00',8.7),('video1','2014-07-11','23:00:00',8.67),('video1','2014-07-11','23:10:00',8.6),('video1','2014-07-11','23:20:00',8.35),('video1','2014-07-11','23:30:00',8.39),('video1','2014-07-11','23:40:00',8.39),('video1','2014-07-11','23:50:00',8.16),('PC1','2014-07-11','00:00:00',11.84),('PC1','2014-07-11','00:10:00',11.41),('PC1','2014-07-11','00:20:00',11.2),('PC1','2014-07-11','00:30:00',10.8),('PC1','2014-07-11','00:40:00',10.6),('PC1','2014-07-11','00:50:00',9.51),('PC1','2014-07-11','01:00:00',8.7),('PC1','2014-07-11','01:10:00',9.09),('PC1','2014-07-11','01:20:00',8.42),('PC1','2014-07-11','01:30:00',7.58),('PC1','2014-07-11','01:40:00',6.28),('PC1','2014-07-11','01:50:00',6.59),('PC1','2014-07-11','02:00:00',6.37),('PC1','2014-07-11','02:10:00',5.96),('PC1','2014-07-11','02:20:00',5.72),('PC1','2014-07-11','02:30:00',5.56),('PC1','2014-07-11','02:40:00',5.09),('PC1','2014-07-11','02:50:00',5),('PC1','2014-07-11','03:00:00',4.96),('PC1','2014-07-11','03:10:00',4.95),('PC1','2014-07-11','03:20:00',4.72),('PC1','2014-07-11','03:30:00',4.78),('PC1','2014-07-11','03:40:00',4.7),('PC1','2014-07-11','03:50:00',4.76),('PC1','2014-07-11','04:00:00',4.78),('PC1','2014-07-11','04:10:00',4.73),('PC1','2014-07-11','04:20:00',4.78),('PC1','2014-07-11','04:30:00',4.79),('PC1','2014-07-11','04:40:00',4.67),('PC1','2014-07-11','04:50:00',4.82),('PC1','2014-07-11','05:00:00',4.73),('PC1','2014-07-11','05:10:00',4.78),('PC1','2014-07-11','05:20:00',4.79),('PC1','2014-07-11','05:30:00',4.71),('PC1','2014-07-11','05:40:00',4.84),('PC1','2014-07-11','05:50:00',4.7),('PC1','2014-07-11','06:00:00',4.83),('PC1','2014-07-11','06:10:00',4.87),('PC1','2014-07-11','06:20:00',4.84),('PC1','2014-07-11','06:30:00',5.25),('PC1','2014-07-11','06:40:00',5.36),('PC1','2014-07-11','06:50:00',5.53),('PC1','2014-07-11','07:00:00',5.93),('PC1','2014-07-11','07:10:00',6.3),('PC1','2014-07-11','07:20:00',6.43),('PC1','2014-07-11','07:30:00',6.69),('PC1','2014-07-11','07:40:00',6.9),('PC1','2014-07-11','07:50:00',7),('PC1','2014-07-11','08:00:00',7.61),('PC1','2014-07-11','08:10:00',7.95),('PC1','2014-07-11','08:20:00',8.03),('PC1','2014-07-11','08:30:00',8.34),('PC1','2014-07-11','08:40:00',8.64),('PC1','2014-07-11','08:50:00',8.69),('PC1','2014-07-11','09:00:00',8.93),('PC1','2014-07-11','09:10:00',9.81),('PC1','2014-07-11','09:20:00',10.49),('PC1','2014-07-11','09:30:00',10.93),('PC1','2014-07-11','09:40:00',11.26),('PC1','2014-07-11','09:50:00',11.38),('PC1','2014-07-11','10:00:00',11.47),('PC1','2014-07-11','10:10:00',12.05),('PC1','2014-07-11','10:20:00',12.87),('PC1','2014-07-11','10:30:00',13.82),('PC1','2014-07-11','10:40:00',14.08),('PC1','2014-07-11','10:50:00',13.96),('PC1','2014-07-11','11:00:00',14),('PC1','2014-07-11','11:10:00',15.18),('PC1','2014-07-11','11:20:00',15.71),('PC1','2014-07-11','11:30:00',16),('PC1','2014-07-11','11:40:00',16.56),('PC1','2014-07-11','11:50:00',17.43),('PC1','2014-07-11','12:00:00',17.64),('PC1','2014-07-11','12:10:00',18.31),('PC1','2014-07-11','12:20:00',17.84),('PC1','2014-07-11','12:30:00',18.24),('PC1','2014-07-11','12:40:00',17.37),('PC1','2014-07-11','12:50:00',16.98),('PC1','2014-07-11','13:00:00',17.9),('PC1','2014-07-11','13:10:00',16.59),('PC1','2014-07-11','13:20:00',16.46),('PC1','2014-07-11','13:30:00',17.63),('PC1','2014-07-11','13:40:00',17.17),('PC1','2014-07-11','13:50:00',16.14),('PC1','2014-07-11','14:00:00',16.5),('PC1','2014-07-11','14:10:00',17.81),('PC1','2014-07-11','14:20:00',18.21),('PC1','2014-07-11','14:30:00',19.63),('PC1','2014-07-11','14:40:00',21.25),('PC1','2014-07-11','14:50:00',21.56),('PC1','2014-07-11','15:00:00',21.8),('PC1','2014-07-11','15:10:00',21.45),('PC1','2014-07-11','15:20:00',21.72),('PC1','2014-07-11','15:30:00',21.74),('PC1','2014-07-11','15:40:00',21.51),('PC1','2014-07-11','15:50:00',21.75),('PC1','2014-07-11','16:00:00',21.11),('PC1','2014-07-11','16:10:00',20.64),('PC1','2014-07-11','16:20:00',20.37),('PC1','2014-07-11','16:30:00',20.34),('PC1','2014-07-11','16:40:00',20.48),('PC1','2014-07-11','16:50:00',21.24),('PC1','2014-07-11','17:00:00',21.62),('PC1','2014-07-11','17:10:00',21.2),('PC1','2014-07-11','17:20:00',21.73),('PC1','2014-07-11','17:30:00',22.01),('PC1','2014-07-11','17:40:00',21.98),('PC1','2014-07-11','17:50:00',22.5),('PC1','2014-07-11','18:00:00',22.54),('PC1','2014-07-11','18:10:00',22.33),('PC1','2014-07-11','18:20:00',22.85),('PC1','2014-07-11','18:30:00',23.73),('PC1','2014-07-11','18:40:00',24.54),('PC1','2014-07-11','18:50:00',26.17),('PC1','2014-07-11','19:00:00',26.71),('PC1','2014-07-11','19:10:00',25.88),('PC1','2014-07-11','19:20:00',25.69),('PC1','2014-07-11','19:30:00',25.55),('PC1','2014-07-11','19:40:00',24.44),('PC1','2014-07-11','19:50:00',24.34),('PC1','2014-07-11','20:00:00',24.27),('PC1','2014-07-11','20:10:00',23.47),('PC1','2014-07-11','20:20:00',22.37),('PC1','2014-07-11','20:30:00',20.9),('PC1','2014-07-11','20:40:00',20.16),('PC1','2014-07-11','20:50:00',20.23),('PC1','2014-07-11','21:00:00',20.36),('PC1','2014-07-11','21:10:00',20.55),('PC1','2014-07-11','21:20:00',20.94),('PC1','2014-07-11','21:30:00',21.6),('PC1','2014-07-11','21:40:00',21.88),('PC1','2014-07-11','21:50:00',23.06),('PC1','2014-07-11','22:00:00',22.54),('PC1','2014-07-11','22:10:00',21.96),('PC1','2014-07-11','22:20:00',21.31),('PC1','2014-07-11','22:30:00',20.9),('PC1','2014-07-11','22:40:00',20.22),('PC1','2014-07-11','22:50:00',18.95),('PC1','2014-07-11','23:00:00',18.06),('PC1','2014-07-11','23:10:00',17.02),('PC1','2014-07-11','23:20:00',16.46),('PC1','2014-07-11','23:30:00',15.07),('PC1','2014-07-11','23:40:00',13.48),('PC1','2014-07-11','23:50:00',12.71),('washm1','2014-07-11','00:00:00',1.92),('washm1','2014-07-11','00:10:00',1.08),('washm1','2014-07-11','00:20:00',1.07),('washm1','2014-07-11','00:30:00',0.71),('washm1','2014-07-11','00:40:00',0.66),('washm1','2014-07-11','00:50:00',0.51),('washm1','2014-07-11','01:00:00',0.46),('washm1','2014-07-11','01:10:00',0.35),('washm1','2014-07-11','01:20:00',0.19),('washm1','2014-07-11','01:30:00',0),('washm1','2014-07-11','01:40:00',0.43),('washm1','2014-07-11','01:50:00',0.12),('washm1','2014-07-11','02:00:00',0),('washm1','2014-07-11','02:10:00',0),('washm1','2014-07-11','02:20:00',0.01),('washm1','2014-07-11','02:30:00',0),('washm1','2014-07-11','02:40:00',0),('washm1','2014-07-11','02:50:00',0),('washm1','2014-07-11','03:00:00',0),('washm1','2014-07-11','03:10:00',0.69),('washm1','2014-07-11','03:20:00',1.84),('washm1','2014-07-11','03:30:00',0.43),('washm1','2014-07-11','03:40:00',0.68),('washm1','2014-07-11','03:50:00',1.04),('washm1','2014-07-11','04:00:00',0.16),('washm1','2014-07-11','04:10:00',0.16),('washm1','2014-07-11','04:20:00',0.15),('washm1','2014-07-11','04:30:00',0.15),('washm1','2014-07-11','04:40:00',0.13),('washm1','2014-07-11','04:50:00',0.12),('washm1','2014-07-11','05:00:00',0.11),('washm1','2014-07-11','05:10:00',1.09),('washm1','2014-07-11','05:20:00',0.79),('washm1','2014-07-11','05:30:00',1.2),('washm1','2014-07-11','05:40:00',3.26),('washm1','2014-07-11','05:50:00',4.04),('washm1','2014-07-11','06:00:00',3.77),('washm1','2014-07-11','06:10:00',4.99),('washm1','2014-07-11','06:20:00',4.08),('washm1','2014-07-11','06:30:00',2.71),('washm1','2014-07-11','06:40:00',1.97),('washm1','2014-07-11','06:50:00',5.37),('washm1','2014-07-11','07:00:00',5.72),('washm1','2014-07-11','07:10:00',8.12),('washm1','2014-07-11','07:20:00',12.77),('washm1','2014-07-11','07:30:00',29.45),('washm1','2014-07-11','07:40:00',35.41),('washm1','2014-07-11','07:50:00',37.5),('washm1','2014-07-11','08:00:00',45.45),('washm1','2014-07-11','08:10:00',51.74),('washm1','2014-07-11','08:20:00',67.05),('washm1','2014-07-11','08:30:00',67.33),('washm1','2014-07-11','08:40:00',63.34),('washm1','2014-07-11','08:50:00',67.96),('washm1','2014-07-11','09:00:00',80.88),('washm1','2014-07-11','09:10:00',76.41),('washm1','2014-07-11','09:20:00',84.58),('washm1','2014-07-11','09:30:00',91.88),('washm1','2014-07-11','09:40:00',82.35),('washm1','2014-07-11','09:50:00',87.75),('washm1','2014-07-11','10:00:00',82.52),('washm1','2014-07-11','10:10:00',77.5),('washm1','2014-07-11','10:20:00',78.3),('washm1','2014-07-11','10:30:00',77.08),('washm1','2014-07-11','10:40:00',68.23),('washm1','2014-07-11','10:50:00',63.23),('washm1','2014-07-11','11:00:00',61.84),('washm1','2014-07-11','11:10:00',60.87),('washm1','2014-07-11','11:20:00',62.26),('washm1','2014-07-11','11:30:00',56.47),('washm1','2014-07-11','11:40:00',58.22),('washm1','2014-07-11','11:50:00',51.33),('washm1','2014-07-11','12:00:00',47.05),('washm1','2014-07-11','12:10:00',57.83),('washm1','2014-07-11','12:20:00',56.89),('washm1','2014-07-11','12:30:00',45.72),('washm1','2014-07-11','12:40:00',56.88),('washm1','2014-07-11','12:50:00',45.67),('washm1','2014-07-11','13:00:00',42.88),('washm1','2014-07-11','13:10:00',34.09),('washm1','2014-07-11','13:20:00',35.55),('washm1','2014-07-11','13:30:00',43.15),('washm1','2014-07-11','13:40:00',43.34),('washm1','2014-07-11','13:50:00',29.15),('washm1','2014-07-11','14:00:00',27.83),('washm1','2014-07-11','14:10:00',28.26),('washm1','2014-07-11','14:20:00',29.58),('washm1','2014-07-11','14:30:00',33.97),('washm1','2014-07-11','14:40:00',47.84),('washm1','2014-07-11','14:50:00',46.21),('washm1','2014-07-11','15:00:00',39.33),('washm1','2014-07-11','15:10:00',41.74),('washm1','2014-07-11','15:20:00',44.1),('washm1','2014-07-11','15:30:00',38.13),('washm1','2014-07-11','15:40:00',33.17),('washm1','2014-07-11','15:50:00',26.21),('washm1','2014-07-11','16:00:00',36.55),('washm1','2014-07-11','16:10:00',34.43),('washm1','2014-07-11','16:20:00',32.54),('washm1','2014-07-11','16:30:00',30.3),('washm1','2014-07-11','16:40:00',28.47),('washm1','2014-07-11','16:50:00',29.1),('washm1','2014-07-11','17:00:00',25.35),('washm1','2014-07-11','17:10:00',28.89),('washm1','2014-07-11','17:20:00',29.75),('washm1','2014-07-11','17:30:00',36.01),('washm1','2014-07-11','17:40:00',31.14),('washm1','2014-07-11','17:50:00',29.78),('washm1','2014-07-11','18:00:00',40.49),('washm1','2014-07-11','18:10:00',29.67),('washm1','2014-07-11','18:20:00',27.77),('washm1','2014-07-11','18:30:00',31.88),('washm1','2014-07-11','18:40:00',33.94),('washm1','2014-07-11','18:50:00',22.74),('washm1','2014-07-11','19:00:00',27.98),('washm1','2014-07-11','19:10:00',24.7),('washm1','2014-07-11','19:20:00',31.19),('washm1','2014-07-11','19:30:00',30.16),('washm1','2014-07-11','19:40:00',37.85),('washm1','2014-07-11','19:50:00',28.87),('washm1','2014-07-11','20:00:00',30.38),('washm1','2014-07-11','20:10:00',25.44),('washm1','2014-07-11','20:20:00',20.78),('washm1','2014-07-11','20:30:00',22.2),('washm1','2014-07-11','20:40:00',24.08),('washm1','2014-07-11','20:50:00',22.32),('washm1','2014-07-11','21:00:00',27.41),('washm1','2014-07-11','21:10:00',22.7),('washm1','2014-07-11','21:20:00',25.93),('washm1','2014-07-11','21:30:00',21.75),('washm1','2014-07-11','21:40:00',20.15),('washm1','2014-07-11','21:50:00',24.4),('washm1','2014-07-11','22:00:00',20.15),('washm1','2014-07-11','22:10:00',20.77),('washm1','2014-07-11','22:20:00',15.27),('washm1','2014-07-11','22:30:00',15.04),('washm1','2014-07-11','22:40:00',10.17),('washm1','2014-07-11','22:50:00',9.65),('washm1','2014-07-11','23:00:00',12.58),('washm1','2014-07-11','23:10:00',12.84),('washm1','2014-07-11','23:20:00',9.2),('washm1','2014-07-11','23:30:00',5.74),('washm1','2014-07-11','23:40:00',3.4),('washm1','2014-07-11','23:50:00',3.88),('washm1','2014-07-13','00:00:00',4.66),('washm1','2014-07-13','00:10:00',4.8),('washm1','2014-07-13','00:20:00',1.61),('washm1','2014-07-13','00:30:00',1.16),('washm1','2014-07-13','00:40:00',0.68),('washm1','2014-07-13','00:50:00',2.66),('washm1','2014-07-13','01:00:00',5.97),('washm1','2014-07-13','01:10:00',4.15),('washm1','2014-07-13','01:20:00',0.28),('washm1','2014-07-13','01:30:00',0.96),('washm1','2014-07-13','01:40:00',5.38),('washm1','2014-07-13','01:50:00',5.5),('washm1','2014-07-13','02:00:00',0.67),('washm1','2014-07-13','02:10:00',0.76),('washm1','2014-07-13','02:20:00',0.67),('washm1','2014-07-13','02:30:00',1.21),('washm1','2014-07-13','02:40:00',0.12),('washm1','2014-07-13','02:50:00',0),('washm1','2014-07-13','03:00:00',0),('washm1','2014-07-13','03:10:00',0),('washm1','2014-07-13','03:20:00',0),('washm1','2014-07-13','03:30:00',0),('washm1','2014-07-13','03:40:00',0),('washm1','2014-07-13','03:50:00',0),('washm1','2014-07-13','04:00:00',0),('washm1','2014-07-13','04:10:00',0),('washm1','2014-07-13','04:20:00',0),('washm1','2014-07-13','04:30:00',0),('washm1','2014-07-13','04:40:00',0),('washm1','2014-07-13','04:50:00',0),('washm1','2014-07-13','05:00:00',0),('washm1','2014-07-13','05:10:00',0),('washm1','2014-07-13','05:20:00',0.48),('washm1','2014-07-13','05:30:00',2.69),('washm1','2014-07-13','05:40:00',2.87),('washm1','2014-07-13','05:50:00',3.34),('washm1','2014-07-13','06:00:00',1.31),('washm1','2014-07-13','06:10:00',0.2),('washm1','2014-07-13','06:20:00',1.25),('washm1','2014-07-13','06:30:00',5.12),('washm1','2014-07-13','06:40:00',5.16),('washm1','2014-07-13','06:50:00',5.48),('washm1','2014-07-13','07:00:00',3.67),('washm1','2014-07-13','07:10:00',3.07),('washm1','2014-07-13','07:20:00',4.25),('washm1','2014-07-13','07:30:00',3.74),('washm1','2014-07-13','07:40:00',3.98),('washm1','2014-07-13','07:50:00',13.6),('washm1','2014-07-13','08:00:00',7.42),('washm1','2014-07-13','08:10:00',20.66),('washm1','2014-07-13','08:20:00',32.78),('washm1','2014-07-13','08:30:00',48.56),('washm1','2014-07-13','08:40:00',64.53),('washm1','2014-07-13','08:50:00',65.04),('washm1','2014-07-13','09:00:00',59.46),('washm1','2014-07-13','09:10:00',56.64),('washm1','2014-07-13','09:20:00',74.34),('washm1','2014-07-13','09:30:00',86.91),('washm1','2014-07-13','09:40:00',85.82),('washm1','2014-07-13','09:50:00',77.85),('washm1','2014-07-13','10:00:00',80.6),('washm1','2014-07-13','10:10:00',78.88),('washm1','2014-07-13','10:20:00',76.18),('washm1','2014-07-13','10:30:00',76.47),('washm1','2014-07-13','10:40:00',78.29),('washm1','2014-07-13','10:50:00',85.14),('washm1','2014-07-13','11:00:00',78.05),('washm1','2014-07-13','11:10:00',80.78),('washm1','2014-07-13','11:20:00',91.13),('washm1','2014-07-13','11:30:00',93.87),('washm1','2014-07-13','11:40:00',94.6),('washm1','2014-07-13','11:50:00',82.69),('washm1','2014-07-13','12:00:00',83.23),('washm1','2014-07-13','12:10:00',70.59),('washm1','2014-07-13','12:20:00',72.94),('washm1','2014-07-13','12:30:00',75.04),('washm1','2014-07-13','12:40:00',61.65),('washm1','2014-07-13','12:50:00',56.56),('washm1','2014-07-13','13:00:00',56.35),('washm1','2014-07-13','13:10:00',51.24),('washm1','2014-07-13','13:20:00',46.31),('washm1','2014-07-13','13:30:00',62.57),('washm1','2014-07-13','13:40:00',49.76),('washm1','2014-07-13','13:50:00',34.65),('washm1','2014-07-13','14:00:00',37.87),('washm1','2014-07-13','14:10:00',48.08),('washm1','2014-07-13','14:20:00',51.36),('washm1','2014-07-13','14:30:00',41.39),('washm1','2014-07-13','14:40:00',22.77),('washm1','2014-07-13','14:50:00',42.17),('washm1','2014-07-13','15:00:00',48.89),('washm1','2014-07-13','15:10:00',48.46),('washm1','2014-07-13','15:20:00',55.22),('washm1','2014-07-13','15:30:00',57.57),('washm1','2014-07-13','15:40:00',52.29),('washm1','2014-07-13','15:50:00',45.07),('washm1','2014-07-13','16:00:00',47.77),('washm1','2014-07-13','16:10:00',45.55),('washm1','2014-07-13','16:20:00',46),('washm1','2014-07-13','16:30:00',40.47),('washm1','2014-07-13','16:40:00',29.56),('washm1','2014-07-13','16:50:00',25.59),('washm1','2014-07-13','17:00:00',22.81),('washm1','2014-07-13','17:10:00',21.34),('washm1','2014-07-13','17:20:00',26.25),('washm1','2014-07-13','17:30:00',35.3),('washm1','2014-07-13','17:40:00',41.78),('washm1','2014-07-13','17:50:00',45.43),('washm1','2014-07-13','18:00:00',47.51),('washm1','2014-07-13','18:10:00',54.86),('washm1','2014-07-13','18:20:00',56.01),('washm1','2014-07-13','18:30:00',38.79),('washm1','2014-07-13','18:40:00',37.81),('washm1','2014-07-13','18:50:00',39),('washm1','2014-07-13','19:00:00',39.57),('washm1','2014-07-13','19:10:00',43.75),('washm1','2014-07-13','19:20:00',37.2),('washm1','2014-07-13','19:30:00',47.13),('washm1','2014-07-13','19:40:00',42.61),('washm1','2014-07-13','19:50:00',42.87),('washm1','2014-07-13','20:00:00',30.26),('washm1','2014-07-13','20:10:00',26.17),('washm1','2014-07-13','20:20:00',14.17),('washm1','2014-07-13','20:30:00',25.67),('washm1','2014-07-13','20:40:00',23.79),('washm1','2014-07-13','20:50:00',23.8),('washm1','2014-07-13','21:00:00',17.95),('washm1','2014-07-13','21:10:00',18.39),('washm1','2014-07-13','21:20:00',20.79),('washm1','2014-07-13','21:30:00',15.08),('washm1','2014-07-13','21:40:00',14.35),('washm1','2014-07-13','21:50:00',20.09),('washm1','2014-07-13','22:00:00',23.44),('washm1','2014-07-13','22:10:00',16.76),('washm1','2014-07-13','22:20:00',19.79),('washm1','2014-07-13','22:30:00',17.54),('washm1','2014-07-13','22:40:00',10.57),('washm1','2014-07-13','22:50:00',9.98),('washm1','2014-07-13','23:00:00',9.96),('washm1','2014-07-13','23:10:00',7.55),('washm1','2014-07-13','23:20:00',5.16),('washm1','2014-07-13','23:30:00',3.57),('washm1','2014-07-13','23:40:00',4.83),('washm1','2014-07-13','23:50:00',1.69),('dw3','2014-07-13','00:00:00',12.99),('dw3','2014-07-13','00:10:00',44.69),('dw3','2014-07-13','00:20:00',39.78),('dw3','2014-07-13','00:30:00',15.68),('dw3','2014-07-13','00:40:00',31.42),('dw3','2014-07-13','00:50:00',59.77),('dw3','2014-07-13','01:00:00',35.53),('dw3','2014-07-13','01:10:00',14.59),('dw3','2014-07-13','01:20:00',13.72),('dw3','2014-07-13','01:30:00',5.84),('dw3','2014-07-13','01:40:00',0.49),('dw3','2014-07-13','01:50:00',3.64),('dw3','2014-07-13','02:00:00',6.45),('dw3','2014-07-13','02:10:00',0.51),('dw3','2014-07-13','02:20:00',0.5),('dw3','2014-07-13','02:30:00',0.08),('dw3','2014-07-13','02:40:00',0.06),('dw3','2014-07-13','02:50:00',0.19),('dw3','2014-07-13','03:00:00',0.21),('dw3','2014-07-13','03:10:00',0.04),('dw3','2014-07-13','03:20:00',0.13),('dw3','2014-07-13','03:30:00',0.04),('dw3','2014-07-13','03:40:00',0.13),('dw3','2014-07-13','03:50:00',0.08),('dw3','2014-07-13','04:00:00',0.08),('dw3','2014-07-13','04:10:00',0.08),('dw3','2014-07-13','04:20:00',0.1),('dw3','2014-07-13','04:30:00',0.08),('dw3','2014-07-13','04:40:00',0.08),('dw3','2014-07-13','04:50:00',0.08),('dw3','2014-07-13','05:00:00',0.08),('dw3','2014-07-13','05:10:00',0.06),('dw3','2014-07-13','05:20:00',0.08),('dw3','2014-07-13','05:30:00',0.13),('dw3','2014-07-13','05:40:00',0.04),('dw3','2014-07-13','05:50:00',0.1),('dw3','2014-07-13','06:00:00',0.08),('dw3','2014-07-13','06:10:00',0.08),('dw3','2014-07-13','06:20:00',0.08),('dw3','2014-07-13','06:30:00',0.23),('dw3','2014-07-13','06:40:00',4.95),('dw3','2014-07-13','06:50:00',10.08),('dw3','2014-07-13','07:00:00',5.23),('dw3','2014-07-13','07:10:00',4.1),('dw3','2014-07-13','07:20:00',4.08),('dw3','2014-07-13','07:30:00',9.04),('dw3','2014-07-13','07:40:00',22.27),('dw3','2014-07-13','07:50:00',11.91),('dw3','2014-07-13','08:00:00',24.77),('dw3','2014-07-13','08:10:00',41.52),('dw3','2014-07-13','08:20:00',23.97),('dw3','2014-07-13','08:30:00',30.15),('dw3','2014-07-13','08:40:00',29.86),('dw3','2014-07-13','08:50:00',19.79),('dw3','2014-07-13','09:00:00',31.12),('dw3','2014-07-13','09:10:00',41.21),('dw3','2014-07-13','09:20:00',39.85),('dw3','2014-07-13','09:30:00',25.6),('dw3','2014-07-13','09:40:00',8.27),('dw3','2014-07-13','09:50:00',29.33),('dw3','2014-07-13','10:00:00',43.84),('dw3','2014-07-13','10:10:00',23.03),('dw3','2014-07-13','10:20:00',29.83),('dw3','2014-07-13','10:30:00',21.98),('dw3','2014-07-13','10:40:00',14.17),('dw3','2014-07-13','10:50:00',20.8),('dw3','2014-07-13','11:00:00',29.88),('dw3','2014-07-13','11:10:00',48.44),('dw3','2014-07-13','11:20:00',48.18),('dw3','2014-07-13','11:30:00',43.44),('dw3','2014-07-13','11:40:00',36.19),('dw3','2014-07-13','11:50:00',49.69),('dw3','2014-07-13','12:00:00',44.52),('dw3','2014-07-13','12:10:00',36.81),('dw3','2014-07-13','12:20:00',34.66),('dw3','2014-07-13','12:30:00',55.05),('dw3','2014-07-13','12:40:00',53.55),('dw3','2014-07-13','12:50:00',39.36),('dw3','2014-07-13','13:00:00',35.01),('dw3','2014-07-13','13:10:00',54.35),('dw3','2014-07-13','13:20:00',48.03),('dw3','2014-07-13','13:30:00',59.51),('dw3','2014-07-13','13:40:00',59.97),('dw3','2014-07-13','13:50:00',102.22),('dw3','2014-07-13','14:00:00',124.84),('dw3','2014-07-13','14:10:00',136.11),('dw3','2014-07-13','14:20:00',148),('dw3','2014-07-13','14:30:00',188.05),('dw3','2014-07-13','14:40:00',216.55),('dw3','2014-07-13','14:50:00',228),('dw3','2014-07-13','15:00:00',192.69),('dw3','2014-07-13','15:10:00',162.67),('dw3','2014-07-13','15:20:00',209.73),('dw3','2014-07-13','15:30:00',197.03),('dw3','2014-07-13','15:40:00',121.01),('dw3','2014-07-13','15:50:00',104.82),('dw3','2014-07-13','16:00:00',98.35),('dw3','2014-07-13','16:10:00',76.25),('dw3','2014-07-13','16:20:00',72.95),('dw3','2014-07-13','16:30:00',90.07),('dw3','2014-07-13','16:40:00',59.53),('dw3','2014-07-13','16:50:00',50.89),('dw3','2014-07-13','17:00:00',32.99),('dw3','2014-07-13','17:10:00',25.44),('dw3','2014-07-13','17:20:00',53.8),('dw3','2014-07-13','17:30:00',48.74),('dw3','2014-07-13','17:40:00',30.69),('dw3','2014-07-13','17:50:00',39.65),('dw3','2014-07-13','18:00:00',25.64),('dw3','2014-07-13','18:10:00',24.25),('dw3','2014-07-13','18:20:00',10.58),('dw3','2014-07-13','18:30:00',21.54),('dw3','2014-07-13','18:40:00',24),('dw3','2014-07-13','18:50:00',22.6),('dw3','2014-07-13','19:00:00',32.39),('dw3','2014-07-13','19:10:00',20.47),('dw3','2014-07-13','19:20:00',21.34),('dw3','2014-07-13','19:30:00',30.76),('dw3','2014-07-13','19:40:00',37.74),('dw3','2014-07-13','19:50:00',45.37),('dw3','2014-07-13','20:00:00',54.8),('dw3','2014-07-13','20:10:00',52.82),('dw3','2014-07-13','20:20:00',58.54),('dw3','2014-07-13','20:30:00',60.3),('dw3','2014-07-13','20:40:00',83.9),('dw3','2014-07-13','20:50:00',96.74),('dw3','2014-07-13','21:00:00',105.94),('dw3','2014-07-13','21:10:00',104.02),('dw3','2014-07-13','21:20:00',116.85),('dw3','2014-07-13','21:30:00',136.53),('dw3','2014-07-13','21:40:00',168.31),('dw3','2014-07-13','21:50:00',143.85),('dw3','2014-07-13','22:00:00',143.66),('dw3','2014-07-13','22:10:00',95.91),('dw3','2014-07-13','22:20:00',75.65),('dw3','2014-07-13','22:30:00',101.28),('dw3','2014-07-13','22:40:00',92.32),('dw3','2014-07-13','22:50:00',70.52),('dw3','2014-07-13','23:00:00',58.19),('dw3','2014-07-13','23:10:00',55.02),('dw3','2014-07-13','23:20:00',53.09),('dw3','2014-07-13','23:30:00',45.34),('dw3','2014-07-13','23:40:00',58.16),('dw3','2014-07-13','23:50:00',44.28),('dw3','2014-07-11','00:00:00',26.33),('dw3','2014-07-11','00:10:00',32.02),('dw3','2014-07-11','00:20:00',35.1),('dw3','2014-07-11','00:30:00',36.87),('dw3','2014-07-11','00:40:00',34.68),('dw3','2014-07-11','00:50:00',30.13),('dw3','2014-07-11','01:00:00',14.98),('dw3','2014-07-11','01:10:00',17.67),('dw3','2014-07-11','01:20:00',4.93),('dw3','2014-07-11','01:30:00',3.25),('dw3','2014-07-11','01:40:00',1.61),('dw3','2014-07-11','01:50:00',7.77),('dw3','2014-07-11','02:00:00',15.26),('dw3','2014-07-11','02:10:00',9.09),('dw3','2014-07-11','02:20:00',0.71),('dw3','2014-07-11','02:30:00',1.13),('dw3','2014-07-11','02:40:00',2.19),('dw3','2014-07-11','02:50:00',0.25),('dw3','2014-07-11','03:00:00',0.09),('dw3','2014-07-11','03:10:00',0.04),('dw3','2014-07-11','03:20:00',0.05),('dw3','2014-07-11','03:30:00',0.06),('dw3','2014-07-11','03:40:00',0.06),('dw3','2014-07-11','03:50:00',0.04),('dw3','2014-07-11','04:00:00',0.06),('dw3','2014-07-11','04:10:00',0.03),('dw3','2014-07-11','04:20:00',0.07),('dw3','2014-07-11','04:30:00',0.03),('dw3','2014-07-11','04:40:00',0.08),('dw3','2014-07-11','04:50:00',0.03),('dw3','2014-07-11','05:00:00',0.06),('dw3','2014-07-11','05:10:00',0.05),('dw3','2014-07-11','05:20:00',0.06),('dw3','2014-07-11','05:30:00',0.03),('dw3','2014-07-11','05:40:00',0.08),('dw3','2014-07-11','05:50:00',0.03),('dw3','2014-07-11','06:00:00',0.05),('dw3','2014-07-11','06:10:00',1.31),('dw3','2014-07-11','06:20:00',6.73),('dw3','2014-07-11','06:30:00',14.08),('dw3','2014-07-11','06:40:00',14.11),('dw3','2014-07-11','06:50:00',10.81),('dw3','2014-07-11','07:00:00',18.56),('dw3','2014-07-11','07:10:00',25.8),('dw3','2014-07-11','07:20:00',25.19),('dw3','2014-07-11','07:30:00',33.68),('dw3','2014-07-11','07:40:00',43.64),('dw3','2014-07-11','07:50:00',50.68),('dw3','2014-07-11','08:00:00',43.32),('dw3','2014-07-11','08:10:00',42),('dw3','2014-07-11','08:20:00',49.41),('dw3','2014-07-11','08:30:00',51.42),('dw3','2014-07-11','08:40:00',41.33),('dw3','2014-07-11','08:50:00',46.99),('dw3','2014-07-11','09:00:00',61.79),('dw3','2014-07-11','09:10:00',53.97),('dw3','2014-07-11','09:20:00',58.12),('dw3','2014-07-11','09:30:00',59.4),('dw3','2014-07-11','09:40:00',86.91),('dw3','2014-07-11','09:50:00',65.77),('dw3','2014-07-11','10:00:00',55.5),('dw3','2014-07-11','10:10:00',49.61),('dw3','2014-07-11','10:20:00',73.55),('dw3','2014-07-11','10:30:00',75.82),('dw3','2014-07-11','10:40:00',73.34),('dw3','2014-07-11','10:50:00',67.47),('dw3','2014-07-11','11:00:00',36.02),('dw3','2014-07-11','11:10:00',17.99),('dw3','2014-07-11','11:20:00',43.14),('dw3','2014-07-11','11:30:00',46.59),('dw3','2014-07-11','11:40:00',16.3),('dw3','2014-07-11','11:50:00',21.64),('dw3','2014-07-11','12:00:00',40.92),('dw3','2014-07-11','12:10:00',30.72),('dw3','2014-07-11','12:20:00',20.81),('dw3','2014-07-11','12:30:00',4.66),('dw3','2014-07-11','12:40:00',19.03),('dw3','2014-07-11','12:50:00',14.4),('dw3','2014-07-11','13:00:00',8.91),('dw3','2014-07-11','13:10:00',13.85),('dw3','2014-07-11','13:20:00',25.22),('dw3','2014-07-11','13:30:00',30.9),('dw3','2014-07-11','13:40:00',37.65),('dw3','2014-07-11','13:50:00',46),('dw3','2014-07-11','14:00:00',85.57),('dw3','2014-07-11','14:10:00',95.39),('dw3','2014-07-11','14:20:00',96.61),('dw3','2014-07-11','14:30:00',85.64),('dw3','2014-07-11','14:40:00',96.28),('dw3','2014-07-11','14:50:00',113.52),('dw3','2014-07-11','15:00:00',117.16),('dw3','2014-07-11','15:10:00',101.58),('dw3','2014-07-11','15:20:00',106.45),('dw3','2014-07-11','15:30:00',97.83),('dw3','2014-07-11','15:40:00',96.93),('dw3','2014-07-11','15:50:00',96.7),('dw3','2014-07-11','16:00:00',92.4),('dw3','2014-07-11','16:10:00',88.73),('dw3','2014-07-11','16:20:00',83.24),('dw3','2014-07-11','16:30:00',62.06),('dw3','2014-07-11','16:40:00',58.41),('dw3','2014-07-11','16:50:00',50.53),('dw3','2014-07-11','17:00:00',27.64),('dw3','2014-07-11','17:10:00',36.77),('dw3','2014-07-11','17:20:00',36.23),('dw3','2014-07-11','17:30:00',37.24),('dw3','2014-07-11','17:40:00',29.65),('dw3','2014-07-11','17:50:00',14.15),('dw3','2014-07-11','18:00:00',16.45),('dw3','2014-07-11','18:10:00',15.51),('dw3','2014-07-11','18:20:00',12.64),('dw3','2014-07-11','18:30:00',6.79),('dw3','2014-07-11','18:40:00',7.78),('dw3','2014-07-11','18:50:00',17.7),('dw3','2014-07-11','19:00:00',14.78),('dw3','2014-07-11','19:10:00',8.15),('dw3','2014-07-11','19:20:00',17.63),('dw3','2014-07-11','19:30:00',9.3),('dw3','2014-07-11','19:40:00',6.12),('dw3','2014-07-11','19:50:00',29.17),('dw3','2014-07-11','20:00:00',45.49),('dw3','2014-07-11','20:10:00',46.4),('dw3','2014-07-11','20:20:00',62.39),('dw3','2014-07-11','20:30:00',82.6),('dw3','2014-07-11','20:40:00',109.86),('dw3','2014-07-11','20:50:00',111.85),('dw3','2014-07-11','21:00:00',130.51),('dw3','2014-07-11','21:10:00',130.47),('dw3','2014-07-11','21:20:00',151.67),('dw3','2014-07-11','21:30:00',202.34),('dw3','2014-07-11','21:40:00',180.29),('dw3','2014-07-11','21:50:00',163.91),('dw3','2014-07-11','22:00:00',179.39),('dw3','2014-07-11','22:10:00',183.24),('dw3','2014-07-11','22:20:00',170.16),('dw3','2014-07-11','22:30:00',124.33),('dw3','2014-07-11','22:40:00',111.82),('dw3','2014-07-11','22:50:00',78.87),('dw3','2014-07-11','23:00:00',69.86),('dw3','2014-07-11','23:10:00',53.28),('dw3','2014-07-11','23:20:00',49.97),('dw3','2014-07-11','23:30:00',41.94),('dw3','2014-07-11','23:40:00',61.29),('dw3','2014-07-11','23:50:00',43.71),('bulb1','2014-07-11','00:00:00',77.44),('bulb1','2014-07-11','00:10:00',78.98),('bulb1','2014-07-11','00:20:00',72.42),('bulb1','2014-07-11','00:30:00',73.93),('bulb1','2014-07-11','00:40:00',75.5),('bulb1','2014-07-11','00:50:00',67.37),('bulb1','2014-07-11','01:00:00',57.68),('bulb1','2014-07-11','01:10:00',50.45),('bulb1','2014-07-11','01:20:00',49),('bulb1','2014-07-11','01:30:00',49.43),('bulb1','2014-07-11','01:40:00',44.08),('bulb1','2014-07-11','01:50:00',46.52),('bulb1','2014-07-11','02:00:00',46.23),('bulb1','2014-07-11','02:10:00',44.71),('bulb1','2014-07-11','02:20:00',44.73),('bulb1','2014-07-11','02:30:00',44.45),('bulb1','2014-07-11','02:40:00',40.32),('bulb1','2014-07-11','02:50:00',35.36),('bulb1','2014-07-11','03:00:00',32.83),('bulb1','2014-07-11','03:10:00',31.09),('bulb1','2014-07-11','03:20:00',27.05),('bulb1','2014-07-11','03:30:00',26.88),('bulb1','2014-07-11','03:40:00',29.01),('bulb1','2014-07-11','03:50:00',21.59),('bulb1','2014-07-11','04:00:00',19.23),('bulb1','2014-07-11','04:10:00',20.23),('bulb1','2014-07-11','04:20:00',19.6),('bulb1','2014-07-11','04:30:00',14.81),('bulb1','2014-07-11','04:40:00',16.78),('bulb1','2014-07-11','04:50:00',15.93),('bulb1','2014-07-11','05:00:00',16.02),('bulb1','2014-07-11','05:10:00',14.19),('bulb1','2014-07-11','05:20:00',12.95),('bulb1','2014-07-11','05:30:00',8.91),('bulb1','2014-07-11','05:40:00',7.26),('bulb1','2014-07-11','05:50:00',8.91),('bulb1','2014-07-11','06:00:00',10.36),('bulb1','2014-07-11','06:10:00',14.91),('bulb1','2014-07-11','06:20:00',17.75),('bulb1','2014-07-11','06:30:00',18.39),('bulb1','2014-07-11','06:40:00',18.16),('bulb1','2014-07-11','06:50:00',17.36),('bulb1','2014-07-11','07:00:00',21.15),('bulb1','2014-07-11','07:10:00',21.48),('bulb1','2014-07-11','07:20:00',18.45),('bulb1','2014-07-11','07:30:00',20.7),('bulb1','2014-07-11','07:40:00',23.45),('bulb1','2014-07-11','07:50:00',22.27),('bulb1','2014-07-11','08:00:00',22.53),('bulb1','2014-07-11','08:10:00',20.99),('bulb1','2014-07-11','08:20:00',17.21),('bulb1','2014-07-11','08:30:00',14.53),('bulb1','2014-07-11','08:40:00',15.47),('bulb1','2014-07-11','08:50:00',16.14),('bulb1','2014-07-11','09:00:00',17.54),('bulb1','2014-07-11','09:10:00',18.07),('bulb1','2014-07-11','09:20:00',18.41),('bulb1','2014-07-11','09:30:00',22.37),('bulb1','2014-07-11','09:40:00',25.34),('bulb1','2014-07-11','09:50:00',27.91),('bulb1','2014-07-11','10:00:00',21.86),('bulb1','2014-07-11','10:10:00',21.77),('bulb1','2014-07-11','10:20:00',23.7),('bulb1','2014-07-11','10:30:00',25.36),('bulb1','2014-07-11','10:40:00',25.71),('bulb1','2014-07-11','10:50:00',24.8),('bulb1','2014-07-11','11:00:00',31.38),('bulb1','2014-07-11','11:10:00',36.71),('bulb1','2014-07-11','11:20:00',34.28),('bulb1','2014-07-11','11:30:00',33.63),('bulb1','2014-07-11','11:40:00',36.42),('bulb1','2014-07-11','11:50:00',37.73),('bulb1','2014-07-11','12:00:00',31.6),('bulb1','2014-07-11','12:10:00',33.09),('bulb1','2014-07-11','12:20:00',42.87),('bulb1','2014-07-11','12:30:00',43.58),('bulb1','2014-07-11','12:40:00',42.9),('bulb1','2014-07-11','12:50:00',41.75),('bulb1','2014-07-11','13:00:00',36.39),('bulb1','2014-07-11','13:10:00',35.91),('bulb1','2014-07-11','13:20:00',36.39),('bulb1','2014-07-11','13:30:00',33.9),('bulb1','2014-07-11','13:40:00',26.17),('bulb1','2014-07-11','13:50:00',20.12),('bulb1','2014-07-11','14:00:00',18.42),('bulb1','2014-07-11','14:10:00',20.92),('bulb1','2014-07-11','14:20:00',22.95),('bulb1','2014-07-11','14:30:00',25.08),('bulb1','2014-07-11','14:40:00',23.5),('bulb1','2014-07-11','14:50:00',23.93),('bulb1','2014-07-11','15:00:00',22.98),('bulb1','2014-07-11','15:10:00',22.22),('bulb1','2014-07-11','15:20:00',20.91),('bulb1','2014-07-11','15:30:00',20.84),('bulb1','2014-07-11','15:40:00',21.79),('bulb1','2014-07-11','15:50:00',21.3),('bulb1','2014-07-11','16:00:00',23.69),('bulb1','2014-07-11','16:10:00',25.15),('bulb1','2014-07-11','16:20:00',25.28),('bulb1','2014-07-11','16:30:00',27.01),('bulb1','2014-07-11','16:40:00',29.33),('bulb1','2014-07-11','16:50:00',33.47),('bulb1','2014-07-11','17:00:00',34.85),('bulb1','2014-07-11','17:10:00',33.95),('bulb1','2014-07-11','17:20:00',33.3),('bulb1','2014-07-11','17:30:00',32.15),('bulb1','2014-07-11','17:40:00',33.31),('bulb1','2014-07-11','17:50:00',33.79),('bulb1','2014-07-11','18:00:00',37.2),('bulb1','2014-07-11','18:10:00',41.74),('bulb1','2014-07-11','18:20:00',39.27),('bulb1','2014-07-11','18:30:00',42.53),('bulb1','2014-07-11','18:40:00',45.54),('bulb1','2014-07-11','18:50:00',44.39),('bulb1','2014-07-11','19:00:00',44.52),('bulb1','2014-07-11','19:10:00',43.25),('bulb1','2014-07-11','19:20:00',45.7),('bulb1','2014-07-11','19:30:00',47.67),('bulb1','2014-07-11','19:40:00',49),('bulb1','2014-07-11','19:50:00',54.71),('bulb1','2014-07-11','20:00:00',55.86),('bulb1','2014-07-11','20:10:00',56.22),('bulb1','2014-07-11','20:20:00',67.63),('bulb1','2014-07-11','20:30:00',71.96),('bulb1','2014-07-11','20:40:00',74.91),('bulb1','2014-07-11','20:50:00',75.64),('bulb1','2014-07-11','21:00:00',83.51),('bulb1','2014-07-11','21:10:00',87.71),('bulb1','2014-07-11','21:20:00',87.01),('bulb1','2014-07-11','21:30:00',86.79),('bulb1','2014-07-11','21:40:00',88.03),('bulb1','2014-07-11','21:50:00',93.19),('bulb1','2014-07-11','22:00:00',89.9),('bulb1','2014-07-11','22:10:00',93.71),('bulb1','2014-07-11','22:20:00',96.86),('bulb1','2014-07-11','22:30:00',100.85),('bulb1','2014-07-11','22:40:00',92.61),('bulb1','2014-07-11','22:50:00',93.46),('bulb1','2014-07-11','23:00:00',89.53),('bulb1','2014-07-11','23:10:00',88.5),('bulb1','2014-07-11','23:20:00',87.76),('bulb1','2014-07-11','23:30:00',85.02),('bulb1','2014-07-11','23:40:00',82.22),('bulb1','2014-07-11','23:50:00',78.82),('bulb1','2014-03-21','23:50:00',90.71),('bulb1','2014-03-21','23:40:00',93.78),('bulb1','2014-03-21','23:30:00',93.53),('bulb1','2014-03-21','23:20:00',93.1),('bulb1','2014-03-21','23:10:00',94.78),('bulb1','2014-03-21','23:00:00',100.81),('bulb1','2014-03-21','22:50:00',102.24),('bulb1','2014-03-21','22:40:00',99.54),('bulb1','2014-03-21','22:30:00',101.29),('bulb1','2014-03-21','22:20:00',109.7),('bulb1','2014-03-21','22:10:00',106.45),('bulb1','2014-03-21','22:00:00',108.46),('bulb1','2014-03-21','21:50:00',111.44),('bulb1','2014-03-21','21:40:00',117.66),('bulb1','2014-03-21','21:30:00',105.64),('bulb1','2014-03-21','21:20:00',105.94),('bulb1','2014-03-21','21:10:00',106.72),('bulb1','2014-03-21','21:00:00',111),('bulb1','2014-03-21','20:50:00',110.37),('bulb1','2014-03-21','20:40:00',108.55),('bulb1','2014-03-21','20:30:00',108.29),('bulb1','2014-03-21','20:20:00',97.57),('bulb1','2014-03-21','20:10:00',93.38),('bulb1','2014-03-21','20:00:00',86.49),('bulb1','2014-03-21','19:50:00',86.99),('bulb1','2014-03-21','19:40:00',81.72),('bulb1','2014-03-21','19:30:00',79.55),('bulb1','2014-03-21','19:20:00',71.9),('bulb1','2014-03-21','19:10:00',68.42),('bulb1','2014-03-21','19:00:00',68.11),('bulb1','2014-03-21','18:50:00',62.8),('bulb1','2014-03-21','18:40:00',61.76),('bulb1','2014-03-21','18:30:00',59.85),('bulb1','2014-03-21','18:20:00',51.5),('bulb1','2014-03-21','18:10:00',44.96),('bulb1','2014-03-21','18:00:00',42.18),('bulb1','2014-03-21','17:50:00',39.43),('bulb1','2014-03-21','17:40:00',38.31),('bulb1','2014-03-21','17:30:00',38.57),('bulb1','2014-03-21','17:20:00',40.4),('bulb1','2014-03-21','17:10:00',34.72),('bulb1','2014-03-21','17:00:00',36.08),('bulb1','2014-03-21','16:50:00',38.62),('bulb1','2014-03-21','16:40:00',34.62),('bulb1','2014-03-21','16:30:00',33.89),('bulb1','2014-03-21','16:20:00',38.86),('bulb1','2014-03-21','16:10:00',42.11),('bulb1','2014-03-21','16:00:00',41.48),('bulb1','2014-03-21','15:50:00',40.52),('bulb1','2014-03-21','15:40:00',41.82),('bulb1','2014-03-21','15:30:00',40.6),('bulb1','2014-03-21','15:20:00',42.2),('bulb1','2014-03-21','15:10:00',38.72),('bulb1','2014-03-21','15:00:00',41.07),('bulb1','2014-03-21','14:50:00',40.74),('bulb1','2014-03-21','14:40:00',43.75),('bulb1','2014-03-21','14:30:00',40.09),('bulb1','2014-03-21','14:20:00',43.91),('bulb1','2014-03-21','14:10:00',46.1),('bulb1','2014-03-21','14:00:00',38.42),('bulb1','2014-03-21','13:50:00',35.47),('bulb1','2014-03-21','13:40:00',38.53),('bulb1','2014-03-21','13:30:00',42.32),('bulb1','2014-03-21','13:20:00',37.49),('bulb1','2014-03-21','13:10:00',37.43),('bulb1','2014-03-21','13:00:00',36.82),('bulb1','2014-03-21','12:50:00',44.46),('bulb1','2014-03-21','12:40:00',39.5),('bulb1','2014-03-21','12:30:00',37.43),('bulb1','2014-03-21','12:20:00',40.2),('bulb1','2014-03-21','12:10:00',40.02),('bulb1','2014-03-21','12:00:00',48.93),('bulb1','2014-03-21','11:50:00',46.82),('bulb1','2014-03-21','11:40:00',48.51),('bulb1','2014-03-21','11:30:00',50.39),('bulb1','2014-03-21','11:20:00',51.01),('bulb1','2014-03-21','11:10:00',45.78),('bulb1','2014-03-21','11:00:00',43.94),('bulb1','2014-03-21','10:50:00',40.41),('bulb1','2014-03-21','10:40:00',40.34),('bulb1','2014-03-21','10:30:00',41.05),('bulb1','2014-03-21','10:20:00',38.56),('bulb1','2014-03-21','10:10:00',37.64),('bulb1','2014-03-21','10:00:00',39.89),('bulb1','2014-03-21','09:50:00',43.71),('bulb1','2014-03-21','09:40:00',45.36),('bulb1','2014-03-21','09:30:00',45.22),('bulb1','2014-03-21','09:20:00',42.54),('bulb1','2014-03-21','09:10:00',37.42),('bulb1','2014-03-21','09:00:00',35.89),('bulb1','2014-03-21','08:50:00',35.08),('bulb1','2014-03-21','08:40:00',33.96),('bulb1','2014-03-21','08:30:00',34.11),('bulb1','2014-03-21','08:20:00',33.12),('bulb1','2014-03-21','08:10:00',34.42),('bulb1','2014-03-21','08:00:00',32.87),('bulb1','2014-03-21','07:50:00',30.87),('bulb1','2014-03-21','07:40:00',30.32),('bulb1','2014-03-21','07:30:00',28.64),('bulb1','2014-03-21','07:20:00',28.09),('bulb1','2014-03-21','07:10:00',25.61),('bulb1','2014-03-21','07:00:00',22.08),('bulb1','2014-03-21','06:50:00',20.96),('bulb1','2014-03-21','06:40:00',15.11),('bulb1','2014-03-21','06:30:00',15.77),('bulb1','2014-03-21','06:20:00',19.44),('bulb1','2014-03-21','06:10:00',15.16),('bulb1','2014-03-21','06:00:00',12.53),('bulb1','2014-03-21','05:50:00',11.85),('bulb1','2014-03-21','05:40:00',9),('bulb1','2014-03-21','05:30:00',9.49),('bulb1','2014-03-21','05:20:00',11.14),('bulb1','2014-03-21','05:10:00',14.22),('bulb1','2014-03-21','05:00:00',14.75),('bulb1','2014-03-21','04:50:00',16.53),('bulb1','2014-03-21','04:40:00',17.99),('bulb1','2014-03-21','04:30:00',17.63),('bulb1','2014-03-21','04:20:00',18.17),('bulb1','2014-03-21','04:10:00',19.4),('bulb1','2014-03-21','04:00:00',21.85),('bulb1','2014-03-21','03:50:00',24.56),('bulb1','2014-03-21','03:40:00',26.49),('bulb1','2014-03-21','03:30:00',28.13),('bulb1','2014-03-21','03:20:00',27.7),('bulb1','2014-03-21','03:10:00',33.56),('bulb1','2014-03-21','03:00:00',35.48),('bulb1','2014-03-21','02:50:00',35.97),('bulb1','2014-03-21','02:40:00',35.78),('bulb1','2014-03-21','02:30:00',39.41),('bulb1','2014-03-21','02:20:00',44.62),('bulb1','2014-03-21','02:10:00',45.53),('bulb1','2014-03-21','02:00:00',46.45),('bulb1','2014-03-21','01:50:00',49.44),('bulb1','2014-03-21','01:40:00',51.42),('bulb1','2014-03-21','01:30:00',55.9),('bulb1','2014-03-21','01:20:00',58.55),('bulb1','2014-03-21','01:10:00',62.97),('bulb1','2014-03-21','01:00:00',68.74),('bulb1','2014-03-21','00:50:00',71.89),('bulb1','2014-03-21','00:40:00',81.17),('bulb1','2014-03-21','00:30:00',85.71),('bulb1','2014-03-21','00:20:00',85.39),('bulb1','2014-03-21','00:10:00',87.92),('bulb1','2014-03-21','00:00:00',87.86),('bulb1','2014-12-21','00:00:00',45.14),('bulb1','2014-12-21','00:10:00',40.08),('bulb1','2014-12-21','00:20:00',36.47),('bulb1','2014-12-21','00:30:00',34.53),('bulb1','2014-12-21','00:40:00',35.12),('bulb1','2014-12-21','00:50:00',35.04),('bulb1','2014-12-21','01:00:00',32.46),('bulb1','2014-12-21','01:10:00',31.06),('bulb1','2014-12-21','01:20:00',31.24),('bulb1','2014-12-21','01:30:00',30.82),('bulb1','2014-12-21','01:40:00',31.1),('bulb1','2014-12-21','01:50:00',30.22),('bulb1','2014-12-21','02:00:00',26.85),('bulb1','2014-12-21','02:10:00',21.75),('bulb1','2014-12-21','02:20:00',17.33),('bulb1','2014-12-21','02:30:00',15.45),('bulb1','2014-12-21','02:40:00',13.26),('bulb1','2014-12-21','02:50:00',12.38),('bulb1','2014-12-21','03:00:00',12.87),('bulb1','2014-12-21','03:10:00',12.85),('bulb1','2014-12-21','03:20:00',9.88),('bulb1','2014-12-21','03:30:00',9.61),('bulb1','2014-12-21','03:40:00',9.47),('bulb1','2014-12-21','03:50:00',8.43),('bulb1','2014-12-21','04:00:00',9.25),('bulb1','2014-12-21','04:10:00',7.99),('bulb1','2014-12-21','04:20:00',8.41),('bulb1','2014-12-21','04:30:00',8.34),('bulb1','2014-12-21','04:40:00',8.44),('bulb1','2014-12-21','04:50:00',9.2),('bulb1','2014-12-21','05:00:00',9.91),('bulb1','2014-12-21','05:10:00',9.15),('bulb1','2014-12-21','05:20:00',9.34),('bulb1','2014-12-21','05:30:00',10.32),('bulb1','2014-12-21','05:40:00',10.49),('bulb1','2014-12-21','05:50:00',9.24),('bulb1','2014-12-21','06:00:00',13.95),('bulb1','2014-12-21','06:10:00',17.34),('bulb1','2014-12-21','06:20:00',19.77),('bulb1','2014-12-21','06:30:00',20.49),('bulb1','2014-12-21','06:40:00',23.69),('bulb1','2014-12-21','06:50:00',29.26),('bulb1','2014-12-21','07:00:00',35.06),('bulb1','2014-12-21','07:10:00',39.65),('bulb1','2014-12-21','07:20:00',40.76),('bulb1','2014-12-21','07:30:00',37.7),('bulb1','2014-12-21','07:40:00',33.87),('bulb1','2014-12-21','07:50:00',33.9),('bulb1','2014-12-21','08:00:00',34.22),('bulb1','2014-12-21','08:10:00',32.03),('bulb1','2014-12-21','08:20:00',31.26),('bulb1','2014-12-21','08:30:00',32.16),('bulb1','2014-12-21','08:40:00',33.91),('bulb1','2014-12-21','08:50:00',42.35),('bulb1','2014-12-21','09:00:00',47.67),('bulb1','2014-12-21','09:10:00',48.21),('bulb1','2014-12-21','09:20:00',52.07),('bulb1','2014-12-21','09:30:00',50.58),('bulb1','2014-12-21','09:40:00',47.48),('bulb1','2014-12-21','09:50:00',41.26),('bulb1','2014-12-21','10:00:00',41.51),('bulb1','2014-12-21','10:10:00',40.27),('bulb1','2014-12-21','10:20:00',41.09),('bulb1','2014-12-21','10:30:00',44.2),('bulb1','2014-12-21','10:40:00',45.6),('bulb1','2014-12-21','10:50:00',44.63),('bulb1','2014-12-21','11:00:00',45.43),('bulb1','2014-12-21','11:10:00',46.07),('bulb1','2014-12-21','11:20:00',42),('bulb1','2014-12-21','11:30:00',39.74),('bulb1','2014-12-21','11:40:00',40.24),('bulb1','2014-12-21','11:50:00',45.3),('bulb1','2014-12-21','12:00:00',41.6),('bulb1','2014-12-21','12:10:00',40.44),('bulb1','2014-12-21','12:20:00',40.45),('bulb1','2014-12-21','12:30:00',37.09),('bulb1','2014-12-21','12:40:00',37.64),('bulb1','2014-12-21','12:50:00',37.36),('bulb1','2014-12-21','13:00:00',39.65),('bulb1','2014-12-21','13:10:00',43.4),('bulb1','2014-12-21','13:20:00',45.39),('bulb1','2014-12-21','13:30:00',46.42),('bulb1','2014-12-21','13:40:00',48.48),('bulb1','2014-12-21','13:50:00',49.91),('bulb1','2014-12-21','14:00:00',51.09),('bulb1','2014-12-21','14:10:00',53.57),('bulb1','2014-12-21','14:20:00',49.17),('bulb1','2014-12-21','14:30:00',47.75),('bulb1','2014-12-21','14:40:00',45.02),('bulb1','2014-12-21','14:50:00',46.02),('bulb1','2014-12-21','15:00:00',48.44),('bulb1','2014-12-21','15:10:00',51.88),('bulb1','2014-12-21','15:20:00',51.24),('bulb1','2014-12-21','15:30:00',54.36),('bulb1','2014-12-21','15:40:00',54.61),('bulb1','2014-12-21','15:50:00',55.31),('bulb1','2014-12-21','16:00:00',55.88),('bulb1','2014-12-21','16:10:00',54.99),('bulb1','2014-12-21','16:20:00',58.4),('bulb1','2014-12-21','16:30:00',62.42),('bulb1','2014-12-21','16:40:00',66.02),('bulb1','2014-12-21','16:50:00',72.17),('bulb1','2014-12-21','17:00:00',76.29),('bulb1','2014-12-21','17:10:00',84.92),('bulb1','2014-12-21','17:20:00',91.45),('bulb1','2014-12-21','17:30:00',94.92),('bulb1','2014-12-21','17:40:00',95.77),('bulb1','2014-12-21','17:50:00',99.48),('bulb1','2014-12-21','18:00:00',103.36),('bulb1','2014-12-21','18:10:00',109.96),('bulb1','2014-12-21','18:20:00',110.29),('bulb1','2014-12-21','18:30:00',112.99),('bulb1','2014-12-21','18:40:00',116.59),('bulb1','2014-12-21','18:50:00',119.54),('bulb1','2014-12-21','19:00:00',114.05),('bulb1','2014-12-21','19:10:00',113.09),('bulb1','2014-12-21','19:20:00',109.81),('bulb1','2014-12-21','19:30:00',109.23),('bulb1','2014-12-21','19:40:00',109.64),('bulb1','2014-12-21','19:50:00',107.44),('bulb1','2014-12-21','20:00:00',105.74),('bulb1','2014-12-21','20:10:00',112.29),('bulb1','2014-12-21','20:20:00',112.9),('bulb1','2014-12-21','20:30:00',111.55),('bulb1','2014-12-21','20:40:00',108.12),('bulb1','2014-12-21','20:50:00',102.95),('bulb1','2014-12-21','21:00:00',101.33),('bulb1','2014-12-21','21:10:00',103.88),('bulb1','2014-12-21','21:20:00',106.92),('bulb1','2014-12-21','21:30:00',108.48),('bulb1','2014-12-21','21:40:00',106.09),('bulb1','2014-12-21','21:50:00',102.46),('bulb1','2014-12-21','22:00:00',105.23),('bulb1','2014-12-21','22:10:00',105.26),('bulb1','2014-12-21','22:20:00',99.42),('bulb1','2014-12-21','22:30:00',91.87),('bulb1','2014-12-21','22:40:00',88.74),('bulb1','2014-12-21','22:50:00',82.22),('bulb1','2014-12-21','23:00:00',75.07),('bulb1','2014-12-21','23:10:00',75.64),('bulb1','2014-12-21','23:20:00',67.15),('bulb1','2014-12-21','23:30:00',61.83),('bulb1','2014-12-21','23:40:00',54.25),('bulb1','2014-12-21','23:50:00',48.86),('dw4','2014-07-11','15:30:00',0),('dw4','2014-07-11','15:31:00',0.1),('dw4','2014-07-11','15:32:00',0.3),('dw4','2014-07-11','15:33:00',0.2),('dw4','2014-07-11','15:34:00',0.2),('dw4','2014-07-11','15:35:00',0.3),('dw4','2014-07-11','15:36:00',0.3),('dw4','2014-07-11','15:37:00',0.1),('dw4','2014-07-11','15:38:00',0.2),('dw4','2014-07-11','15:39:00',0.2),('dw4','2014-07-11','15:40:00',0.1),('dw4','2014-07-11','15:41:00',0),('dw4','2014-07-11','15:42:00',0.1),('dw4','2014-07-11','15:43:00',1.2),('dw4','2014-07-11','15:44:00',1.1),('dw4','2014-07-11','15:45:00',0.9),('dw4','2014-07-11','15:46:00',1.2),('dw4','2014-07-11','15:47:00',1.1),('dw4','2014-07-11','15:48:00',1.1),('dw4','2014-07-11','15:49:00',0.9),('dw4','2014-07-11','15:50:00',1.1),('dw4','2014-07-11','15:51:00',1.1),('dw4','2014-07-11','15:52:00',0.4),('dw4','2014-07-11','15:53:00',0.2),('dw4','2014-07-11','15:54:00',0.2),('dw4','2014-07-11','15:55:00',0.2),('dw4','2014-07-11','15:56:00',0.2),('dw4','2014-07-11','15:57:00',0.2),('dw4','2014-07-11','15:58:00',0.2),('dw4','2014-07-11','15:59:00',0.2),('dw4','2014-07-11','16:00:00',0.2),('dw4','2014-07-11','16:01:00',0.2),('dw4','2014-07-11','16:02:00',0.2),('dw4','2014-07-11','16:03:00',0.2),('dw4','2014-07-11','16:04:00',0.2),('dw4','2014-07-11','16:05:00',0.2),('dw4','2014-07-11','16:06:00',0.2),('dw4','2014-07-11','16:07:00',0.2),('dw4','2014-07-11','16:08:00',0.2),('dw4','2014-07-11','16:09:00',0.2),('dw4','2014-07-11','16:10:00',0.2),('dw4','2014-07-11','16:11:00',0.2),('dw4','2014-07-11','16:12:00',0.2),('dw4','2014-07-11','16:13:00',0.2),('dw4','2014-07-11','16:14:00',0.2),('dw4','2014-07-11','16:15:00',0.2),('dw4','2014-07-11','16:16:00',0.2),('dw4','2014-07-11','16:17:00',0.3),('dw4','2014-07-11','16:18:00',0.2),('dw4','2014-07-11','16:19:00',0),('dw4','2014-07-11','16:20:00',0.1),('dw4','2014-07-11','16:21:00',0),('dw4','2014-07-11','16:22:00',0),('dw4','2014-07-11','16:23:00',1),('dw4','2014-07-11','16:24:00',1.1),('dw4','2014-07-11','16:25:00',1.1),('dw4','2014-07-11','16:26:00',1.1),('dw4','2014-07-11','16:27:00',1.1),('dw4','2014-07-11','16:28:00',1.1),('dw4','2014-07-11','16:29:00',1.1),('dw4','2014-07-11','16:30:00',1.1),('dw4','2014-07-11','16:31:00',1.1),('dw4','2014-07-11','16:32:00',1.1),('dw4','2014-07-11','16:33:00',1.1),('dw4','2014-07-11','16:34:00',1.1),('dw4','2014-07-11','16:35:00',0.7),('dw4','2014-07-11','16:36:00',0.3),('dw4','2014-07-11','16:37:00',0.3),('dw4','2014-07-11','16:38:00',0.3),('dw4','2014-07-11','16:39:00',0.3),('dw4','2014-07-11','16:40:00',0.2),('dw4','2014-07-11','16:41:00',0.2),('dw4','2014-07-11','16:42:00',0.2),('dw4','2014-07-11','16:43:00',0.2),('dw4','2014-07-11','16:44:00',0.2),('dw4','2014-07-11','16:45:00',0.2),('dw4','2014-07-11','16:46:00',0),('dw4','2014-07-11','16:47:00',0),('dw4','2014-07-11','16:48:00',0),('dw4','2014-07-11','16:49:00',0),('wm4','2014-07-11','15:36:00',0.51),('dw4','2014-07-11','16:51:00',0),('dw4','2014-07-11','16:52:00',0),('dw4','2014-07-11','16:53:00',0.8),('dw4','2014-07-11','16:54:00',0.6),('dw4','2014-07-11','16:55:00',0.6),('dw4','2014-07-11','16:56:00',0.6),('dw4','2014-07-11','16:57:00',0.6),('dw4','2014-07-11','16:58:00',0.6),('dw4','2014-07-11','16:59:00',0),('dw4','2014-07-11','17:00:00',0.6),('dw4','2014-07-11','17:01:00',0.6),('dw4','2014-07-11','17:02:00',0.6),('dw4','2014-07-11','17:03:00',0.6),('dw4','2014-07-11','17:04:00',0.6),('wm4','2014-07-11','15:32:00',0.38),('dw4','2014-07-11','17:06:00',0),('dw4','2014-07-11','17:07:00',0.3),('dw4','2014-07-11','17:08:00',0.6),('dw4','2014-07-11','17:09:00',0.6),('dw4','2014-07-11','17:10:00',0.6),('dw4','2014-07-11','17:11:00',0.3),('dw4','2014-07-11','17:12:00',0),('dw4','2014-07-11','17:13:00',0),('dw4','2014-07-11','17:14:00',0),('dw4','2014-07-11','17:15:00',0),('dw4','2014-07-11','17:16:00',0),('dw4','2014-07-11','17:17:00',0),('dw4','2014-07-11','17:18:00',0),('dw4','2014-07-11','17:19:00',0),('dw4','2014-07-11','00:00:00',0),('dw4','2014-07-11','00:05:00',0),('dw4','2014-07-11','00:10:00',0),('dw4','2014-07-11','00:15:00',0),('dw4','2014-07-11','00:20:00',0),('dw4','2014-07-11','00:25:00',0),('dw4','2014-07-11','00:30:00',0),('dw4','2014-07-11','00:35:00',0),('dw4','2014-07-11','00:40:00',0),('dw4','2014-07-11','00:45:00',0),('dw4','2014-07-11','00:50:00',0),('dw4','2014-07-11','00:55:00',0),('dw4','2014-07-11','01:00:00',0),('dw4','2014-07-11','01:05:00',0),('dw4','2014-07-11','01:10:00',0),('dw4','2014-07-11','01:15:00',0),('dw4','2014-07-11','01:20:00',0),('dw4','2014-07-11','01:25:00',0),('dw4','2014-07-11','01:30:00',0),('dw4','2014-07-11','01:35:00',0),('dw4','2014-07-11','01:40:00',0),('dw4','2014-07-11','01:45:00',0),('dw4','2014-07-11','01:50:00',0),('dw4','2014-07-11','01:55:00',0),('dw4','2014-07-11','02:00:00',0),('dw4','2014-07-11','02:05:00',0),('dw4','2014-07-11','02:10:00',0),('dw4','2014-07-11','02:15:00',0),('dw4','2014-07-11','02:20:00',0),('dw4','2014-07-11','02:25:00',0),('dw4','2014-07-11','02:30:00',0),('dw4','2014-07-11','02:35:00',0),('dw4','2014-07-11','02:40:00',0),('dw4','2014-07-11','02:45:00',0),('dw4','2014-07-11','02:50:00',0),('dw4','2014-07-11','02:55:00',0),('dw4','2014-07-11','03:00:00',0),('dw4','2014-07-11','03:05:00',0),('dw4','2014-07-11','03:10:00',0),('dw4','2014-07-11','03:15:00',0),('dw4','2014-07-11','03:20:00',0),('dw4','2014-07-11','03:25:00',0),('dw4','2014-07-11','03:30:00',0),('dw4','2014-07-11','03:35:00',0),('dw4','2014-07-11','03:40:00',0),('dw4','2014-07-11','03:45:00',0),('dw4','2014-07-11','03:50:00',0),('dw4','2014-07-11','03:55:00',0),('dw4','2014-07-11','04:00:00',0),('dw4','2014-07-11','04:05:00',0),('dw4','2014-07-11','04:10:00',0),('dw4','2014-07-11','04:15:00',0),('dw4','2014-07-11','04:20:00',0),('dw4','2014-07-11','04:25:00',0),('dw4','2014-07-11','04:30:00',0),('dw4','2014-07-11','04:35:00',0),('dw4','2014-07-11','04:40:00',0),('dw4','2014-07-11','04:45:00',0),('dw4','2014-07-11','04:50:00',0),('dw4','2014-07-11','04:55:00',0),('dw4','2014-07-11','05:00:00',0),('dw4','2014-07-11','05:05:00',0),('dw4','2014-07-11','05:10:00',0),('dw4','2014-07-11','05:15:00',0),('dw4','2014-07-11','05:20:00',0),('dw4','2014-07-11','05:25:00',0),('dw4','2014-07-11','05:30:00',0),('dw4','2014-07-11','05:35:00',0),('dw4','2014-07-11','05:40:00',0),('dw4','2014-07-11','05:45:00',0),('dw4','2014-07-11','05:50:00',0),('dw4','2014-07-11','05:55:00',0),('dw4','2014-07-11','06:00:00',0),('dw4','2014-07-11','06:05:00',0),('dw4','2014-07-11','06:10:00',0),('dw4','2014-07-11','06:15:00',0),('dw4','2014-07-11','06:20:00',0),('dw4','2014-07-11','06:25:00',0),('dw4','2014-07-11','06:30:00',0),('dw4','2014-07-11','06:35:00',0),('dw4','2014-07-11','06:40:00',0),('dw4','2014-07-11','06:45:00',0),('dw4','2014-07-11','06:50:00',0),('dw4','2014-07-11','06:55:00',0),('dw4','2014-07-11','07:00:00',0),('dw4','2014-07-11','07:05:00',0),('dw4','2014-07-11','07:10:00',0),('dw4','2014-07-11','07:15:00',0),('dw4','2014-07-11','07:20:00',0),('dw4','2014-07-11','07:25:00',0),('dw4','2014-07-11','07:30:00',0),('dw4','2014-07-11','07:35:00',0),('dw4','2014-07-11','07:40:00',0),('dw4','2014-07-11','07:45:00',0),('dw4','2014-07-11','07:50:00',0),('dw4','2014-07-11','07:55:00',0),('dw4','2014-07-11','08:00:00',0),('dw4','2014-07-11','08:05:00',0),('dw4','2014-07-11','08:10:00',0),('dw4','2014-07-11','08:15:00',0),('dw4','2014-07-11','08:20:00',0),('dw4','2014-07-11','08:25:00',0),('dw4','2014-07-11','08:30:00',0),('dw4','2014-07-11','08:35:00',0),('dw4','2014-07-11','08:40:00',0),('dw4','2014-07-11','08:45:00',0),('dw4','2014-07-11','08:50:00',0),('dw4','2014-07-11','08:55:00',0),('dw4','2014-07-11','09:00:00',0),('dw4','2014-07-11','09:05:00',0),('dw4','2014-07-11','09:10:00',0),('dw4','2014-07-11','09:15:00',0),('dw4','2014-07-11','09:20:00',0),('dw4','2014-07-11','09:25:00',0),('dw4','2014-07-11','09:30:00',0),('dw4','2014-07-11','09:35:00',0),('dw4','2014-07-11','09:40:00',0),('dw4','2014-07-11','09:45:00',0),('dw4','2014-07-11','09:50:00',0),('dw4','2014-07-11','09:55:00',0),('dw4','2014-07-11','10:00:00',0),('dw4','2014-07-11','10:05:00',0),('dw4','2014-07-11','10:10:00',0),('dw4','2014-07-11','10:15:00',0),('dw4','2014-07-11','10:20:00',0),('dw4','2014-07-11','10:25:00',0),('dw4','2014-07-11','10:30:00',0),('dw4','2014-07-11','10:35:00',0),('dw4','2014-07-11','10:40:00',0),('dw4','2014-07-11','10:45:00',0),('dw4','2014-07-11','10:50:00',0),('dw4','2014-07-11','10:55:00',0),('dw4','2014-07-11','11:00:00',0),('dw4','2014-07-11','11:05:00',0),('dw4','2014-07-11','11:10:00',0),('dw4','2014-07-11','11:15:00',0),('dw4','2014-07-11','11:20:00',0),('dw4','2014-07-11','11:25:00',0),('dw4','2014-07-11','11:30:00',0),('dw4','2014-07-11','11:35:00',0),('dw4','2014-07-11','11:40:00',0),('dw4','2014-07-11','11:45:00',0),('dw4','2014-07-11','11:50:00',0),('dw4','2014-07-11','11:55:00',0),('dw4','2014-07-11','12:00:00',0),('dw4','2014-07-11','12:05:00',0),('dw4','2014-07-11','12:10:00',0),('dw4','2014-07-11','12:15:00',0),('dw4','2014-07-11','12:20:00',0),('dw4','2014-07-11','12:25:00',0),('dw4','2014-07-11','12:30:00',0),('dw4','2014-07-11','12:35:00',0),('dw4','2014-07-11','12:40:00',0),('dw4','2014-07-11','12:45:00',0),('dw4','2014-07-11','12:50:00',0),('dw4','2014-07-11','12:55:00',0),('dw4','2014-07-11','13:00:00',0),('dw4','2014-07-11','13:05:00',0),('dw4','2014-07-11','13:10:00',0),('dw4','2014-07-11','13:15:00',0),('dw4','2014-07-11','13:20:00',0),('dw4','2014-07-11','13:25:00',0),('dw4','2014-07-11','13:30:00',0),('dw4','2014-07-11','13:35:00',0),('dw4','2014-07-11','13:40:00',0),('dw4','2014-07-11','13:45:00',0),('dw4','2014-07-11','13:50:00',0),('dw4','2014-07-11','13:55:00',0),('dw4','2014-07-11','14:00:00',0),('dw4','2014-07-11','14:05:00',0),('dw4','2014-07-11','14:10:00',0),('dw4','2014-07-11','14:15:00',0),('dw4','2014-07-11','14:20:00',0),('dw4','2014-07-11','14:25:00',0),('dw4','2014-07-11','14:30:00',0),('dw4','2014-07-11','14:35:00',0),('dw4','2014-07-11','14:40:00',0),('dw4','2014-07-11','14:45:00',0),('dw4','2014-07-11','14:50:00',0),('dw4','2014-07-11','14:55:00',0),('dw4','2014-07-11','15:00:00',0),('dw4','2014-07-11','15:05:00',0),('dw4','2014-07-11','15:10:00',0),('dw4','2014-07-11','15:15:00',0),('dw4','2014-07-11','15:20:00',0),('dw4','2014-07-11','15:25:00',0),('dw4','2014-07-11','15:30:00',0),('wm4','2014-07-11','15:51:00',0.65),('wm4','2014-07-11','15:50:00',0.45),('wm4','2014-07-11','15:49:00',0),('wm4','2014-07-11','15:48:00',0.13),('wm4','2014-07-11','15:47:00',0.55),('wm4','2014-07-11','15:46:00',0.53),('wm4','2014-07-11','15:45:00',0.44),('wm4','2014-07-11','15:44:00',0.44),('wm4','2014-07-11','15:43:00',0.45),('wm4','2014-07-11','15:42:00',0.5),('wm4','2014-07-11','15:41:00',0.51),('wm4','2014-07-11','15:40:00',0.51),('wm4','2014-07-11','15:39:00',0.51),('wm4','2014-07-11','15:38:00',0.51),('wm4','2014-07-11','15:37:00',0.51),('wm4','2014-07-11','15:35:00',0.51),('wm4','2014-07-11','15:34:00',0.51),('wm4','2014-07-11','15:33:00',0.52),('wm4','2014-07-11','15:31:00',0.01),('wm4','2014-07-11','15:30:00',0.01),('dw4','2014-07-11','17:15:00',0),('dw4','2014-07-11','17:20:00',0),('dw4','2014-07-11','17:25:00',0),('dw4','2014-07-11','17:30:00',0),('dw4','2014-07-11','17:35:00',0),('dw4','2014-07-11','17:40:00',0),('dw4','2014-07-11','17:45:00',0),('dw4','2014-07-11','17:50:00',0),('dw4','2014-07-11','17:55:00',0),('dw4','2014-07-11','18:00:00',0),('dw4','2014-07-11','18:05:00',0),('dw4','2014-07-11','18:10:00',0),('dw4','2014-07-11','18:15:00',0),('dw4','2014-07-11','18:20:00',0),('dw4','2014-07-11','18:25:00',0),('dw4','2014-07-11','18:30:00',0),('dw4','2014-07-11','18:35:00',0),('dw4','2014-07-11','18:40:00',0),('dw4','2014-07-11','18:45:00',0),('dw4','2014-07-11','18:50:00',0),('dw4','2014-07-11','18:55:00',0),('dw4','2014-07-11','19:00:00',0),('dw4','2014-07-11','19:05:00',0),('dw4','2014-07-11','19:10:00',0),('dw4','2014-07-11','19:15:00',0),('dw4','2014-07-11','19:20:00',0),('dw4','2014-07-11','19:25:00',0),('dw4','2014-07-11','19:30:00',0),('dw4','2014-07-11','19:35:00',0),('dw4','2014-07-11','19:40:00',0),('dw4','2014-07-11','19:45:00',0),('dw4','2014-07-11','19:50:00',0),('dw4','2014-07-11','19:55:00',0),('dw4','2014-07-11','20:00:00',0),('dw4','2014-07-11','20:05:00',0),('dw4','2014-07-11','20:10:00',0),('dw4','2014-07-11','20:15:00',0),('dw4','2014-07-11','20:20:00',0),('dw4','2014-07-11','20:25:00',0),('dw4','2014-07-11','20:30:00',0),('dw4','2014-07-11','20:35:00',0),('dw4','2014-07-11','20:40:00',0),('dw4','2014-07-11','20:45:00',0),('dw4','2014-07-11','20:50:00',0),('dw4','2014-07-11','20:55:00',0),('dw4','2014-07-11','21:00:00',0),('dw4','2014-07-11','21:05:00',0),('dw4','2014-07-11','21:10:00',0),('dw4','2014-07-11','21:15:00',0),('dw4','2014-07-11','21:20:00',0),('dw4','2014-07-11','21:25:00',0),('dw4','2014-07-11','21:30:00',0),('dw4','2014-07-11','21:35:00',0),('dw4','2014-07-11','21:40:00',0),('dw4','2014-07-11','21:45:00',0),('dw4','2014-07-11','21:50:00',0),('dw4','2014-07-11','21:55:00',0),('dw4','2014-07-11','22:00:00',0),('dw4','2014-07-11','22:05:00',0),('dw4','2014-07-11','22:10:00',0),('dw4','2014-07-11','22:15:00',0),('dw4','2014-07-11','22:20:00',0),('dw4','2014-07-11','22:25:00',0),('dw4','2014-07-11','22:30:00',0),('dw4','2014-07-11','22:35:00',0),('dw4','2014-07-11','22:40:00',0),('dw4','2014-07-11','22:45:00',0),('dw4','2014-07-11','22:50:00',0),('dw4','2014-07-11','22:55:00',0),('dw4','2014-07-11','23:00:00',0),('dw4','2014-07-11','23:05:00',0),('dw4','2014-07-11','23:10:00',0),('dw4','2014-07-11','23:15:00',0),('dw4','2014-07-11','23:20:00',0),('dw4','2014-07-11','23:25:00',0),('dw4','2014-07-11','23:30:00',0),('dw4','2014-07-11','23:35:00',0),('dw4','2014-07-11','23:40:00',0),('dw4','2014-07-11','23:45:00',0),('dw4','2014-07-11','23:50:00',0),('dw4','2014-07-11','23:55:00',0),('dw4','2014-07-11','00:00:00',0),('dw4','2014-07-11','00:05:00',0),('dw4','2014-07-11','00:10:00',0),('dw4','2014-07-11','00:15:00',0),('dw4','2014-07-11','00:20:00',0),('dw4','2014-07-11','00:25:00',0),('dw4','2014-07-11','00:30:00',0),('dw4','2014-07-11','00:35:00',0),('dw4','2014-07-11','00:40:00',0),('dw4','2014-07-11','00:45:00',0),('dw4','2014-07-11','00:50:00',0),('dw4','2014-07-11','00:55:00',0),('dw4','2014-07-11','01:00:00',0),('dw4','2014-07-11','01:05:00',0),('dw4','2014-07-11','01:10:00',0),('dw4','2014-07-11','01:15:00',0),('dw4','2014-07-11','01:20:00',0),('dw4','2014-07-11','01:25:00',0),('dw4','2014-07-11','01:30:00',0),('dw4','2014-07-11','01:35:00',0),('dw4','2014-07-11','01:40:00',0),('dw4','2014-07-11','01:45:00',0),('dw4','2014-07-11','01:50:00',0),('dw4','2014-07-11','01:55:00',0),('dw4','2014-07-11','02:00:00',0),('dw4','2014-07-11','02:05:00',0),('dw4','2014-07-11','02:10:00',0),('dw4','2014-07-11','02:15:00',0),('dw4','2014-07-11','02:20:00',0),('dw4','2014-07-11','02:25:00',0),('dw4','2014-07-11','02:30:00',0),('dw4','2014-07-11','02:35:00',0),('dw4','2014-07-11','02:40:00',0),('dw4','2014-07-11','02:45:00',0),('dw4','2014-07-11','02:50:00',0),('dw4','2014-07-11','02:55:00',0),('dw4','2014-07-11','03:00:00',0),('dw4','2014-07-11','03:05:00',0),('dw4','2014-07-11','03:10:00',0),('dw4','2014-07-11','03:15:00',0),('dw4','2014-07-11','03:20:00',0),('dw4','2014-07-11','03:25:00',0),('dw4','2014-07-11','03:30:00',0),('dw4','2014-07-11','03:35:00',0),('dw4','2014-07-11','03:40:00',0),('dw4','2014-07-11','03:45:00',0),('dw4','2014-07-11','03:50:00',0),('dw4','2014-07-11','03:55:00',0),('dw4','2014-07-11','04:00:00',0),('dw4','2014-07-11','04:05:00',0),('dw4','2014-07-11','04:10:00',0),('dw4','2014-07-11','04:15:00',0),('dw4','2014-07-11','04:20:00',0),('dw4','2014-07-11','04:25:00',0),('dw4','2014-07-11','04:30:00',0),('dw4','2014-07-11','04:35:00',0),('dw4','2014-07-11','04:40:00',0),('dw4','2014-07-11','04:45:00',0),('dw4','2014-07-11','04:50:00',0),('dw4','2014-07-11','04:55:00',0),('dw4','2014-07-11','05:00:00',0),('dw4','2014-07-11','05:05:00',0),('dw4','2014-07-11','05:10:00',0),('dw4','2014-07-11','05:15:00',0),('dw4','2014-07-11','05:20:00',0),('dw4','2014-07-11','05:25:00',0),('dw4','2014-07-11','05:30:00',0),('dw4','2014-07-11','05:35:00',0),('dw4','2014-07-11','05:40:00',0),('dw4','2014-07-11','05:45:00',0),('dw4','2014-07-11','05:50:00',0),('dw4','2014-07-11','05:55:00',0),('dw4','2014-07-11','06:00:00',0),('dw4','2014-07-11','06:05:00',0),('dw4','2014-07-11','06:10:00',0),('dw4','2014-07-11','06:15:00',0),('dw4','2014-07-11','06:20:00',0),('dw4','2014-07-11','06:25:00',0),('dw4','2014-07-11','06:30:00',0),('dw4','2014-07-11','06:35:00',0),('dw4','2014-07-11','06:40:00',0),('dw4','2014-07-11','06:45:00',0),('dw4','2014-07-11','06:50:00',0),('dw4','2014-07-11','06:55:00',0),('dw4','2014-07-11','07:00:00',0),('dw4','2014-07-11','07:05:00',0),('dw4','2014-07-11','07:10:00',0),('dw4','2014-07-11','07:15:00',0),('dw4','2014-07-11','07:20:00',0),('dw4','2014-07-11','07:25:00',0),('dw4','2014-07-11','07:30:00',0),('dw4','2014-07-11','07:35:00',0),('dw4','2014-07-11','07:40:00',0),('dw4','2014-07-11','07:45:00',0),('dw4','2014-07-11','07:50:00',0),('dw4','2014-07-11','07:55:00',0),('dw4','2014-07-11','08:00:00',0),('dw4','2014-07-11','08:05:00',0),('dw4','2014-07-11','08:10:00',0),('dw4','2014-07-11','08:15:00',0),('dw4','2014-07-11','08:20:00',0),('dw4','2014-07-11','08:25:00',0),('dw4','2014-07-11','08:30:00',0),('dw4','2014-07-11','08:35:00',0),('dw4','2014-07-11','08:40:00',0),('dw4','2014-07-11','08:45:00',0),('dw4','2014-07-11','08:50:00',0),('dw4','2014-07-11','08:55:00',0),('dw4','2014-07-11','09:00:00',0),('dw4','2014-07-11','09:05:00',0),('dw4','2014-07-11','09:10:00',0),('dw4','2014-07-11','09:15:00',0),('dw4','2014-07-11','09:20:00',0),('dw4','2014-07-11','09:25:00',0),('dw4','2014-07-11','09:30:00',0),('dw4','2014-07-11','09:35:00',0),('dw4','2014-07-11','09:40:00',0),('dw4','2014-07-11','09:45:00',0),('dw4','2014-07-11','09:50:00',0),('dw4','2014-07-11','09:55:00',0),('dw4','2014-07-11','10:00:00',0),('dw4','2014-07-11','10:05:00',0),('dw4','2014-07-11','10:10:00',0),('dw4','2014-07-11','10:15:00',0),('dw4','2014-07-11','10:20:00',0),('dw4','2014-07-11','10:25:00',0),('dw4','2014-07-11','10:30:00',0),('dw4','2014-07-11','10:35:00',0),('dw4','2014-07-11','10:40:00',0),('dw4','2014-07-11','10:45:00',0),('dw4','2014-07-11','10:50:00',0),('dw4','2014-07-11','10:55:00',0),('dw4','2014-07-11','11:00:00',0),('dw4','2014-07-11','11:05:00',0),('dw4','2014-07-11','11:10:00',0),('dw4','2014-07-11','11:15:00',0),('dw4','2014-07-11','11:20:00',0),('dw4','2014-07-11','11:25:00',0),('dw4','2014-07-11','11:30:00',0),('dw4','2014-07-11','11:35:00',0),('dw4','2014-07-11','11:40:00',0),('dw4','2014-07-11','11:45:00',0),('dw4','2014-07-11','11:50:00',0),('dw4','2014-07-11','11:55:00',0),('dw4','2014-07-11','12:00:00',0),('dw4','2014-07-11','12:05:00',0),('dw4','2014-07-11','12:10:00',0),('dw4','2014-07-11','12:15:00',0),('dw4','2014-07-11','12:20:00',0),('dw4','2014-07-11','12:25:00',0),('dw4','2014-07-11','12:30:00',0),('dw4','2014-07-11','12:35:00',0),('dw4','2014-07-11','12:40:00',0),('dw4','2014-07-11','12:45:00',0),('dw4','2014-07-11','12:50:00',0),('dw4','2014-07-11','12:55:00',0),('dw4','2014-07-11','13:00:00',0),('dw4','2014-07-11','13:05:00',0),('dw4','2014-07-11','13:10:00',0),('dw4','2014-07-11','13:15:00',0),('dw4','2014-07-11','13:20:00',0),('dw4','2014-07-11','13:25:00',0),('dw4','2014-07-11','13:30:00',0),('dw4','2014-07-11','13:35:00',0),('dw4','2014-07-11','13:40:00',0),('dw4','2014-07-11','13:45:00',0),('dw4','2014-07-11','13:50:00',0),('dw4','2014-07-11','13:55:00',0),('dw4','2014-07-11','14:00:00',0),('dw4','2014-07-11','14:05:00',0),('dw4','2014-07-11','14:10:00',0),('dw4','2014-07-11','14:15:00',0),('dw4','2014-07-11','14:20:00',0),('dw4','2014-07-11','14:25:00',0),('dw4','2014-07-11','14:30:00',0),('dw4','2014-07-11','14:35:00',0),('dw4','2014-07-11','14:40:00',0),('dw4','2014-07-11','14:45:00',0),('dw4','2014-07-11','14:50:00',0),('dw4','2014-07-11','14:55:00',0),('dw4','2014-07-11','15:00:00',0),('dw4','2014-07-11','15:05:00',0),('dw4','2014-07-11','15:10:00',0),('dw4','2014-07-11','15:15:00',0),('dw4','2014-07-11','15:20:00',0),('dw4','2014-07-11','15:25:00',0),('dw4','2014-07-11','17:20:00',0),('dw4','2014-07-11','17:25:00',0),('dw4','2014-07-11','17:30:00',0),('dw4','2014-07-11','17:35:00',0),('dw4','2014-07-11','17:40:00',0),('dw4','2014-07-11','17:45:00',0),('dw4','2014-07-11','17:50:00',0),('dw4','2014-07-11','17:55:00',0),('dw4','2014-07-11','18:00:00',0),('dw4','2014-07-11','18:05:00',0),('dw4','2014-07-11','18:10:00',0),('dw4','2014-07-11','18:15:00',0),('dw4','2014-07-11','18:20:00',0),('dw4','2014-07-11','18:25:00',0),('dw4','2014-07-11','18:30:00',0),('dw4','2014-07-11','18:35:00',0),('dw4','2014-07-11','18:40:00',0),('dw4','2014-07-11','18:45:00',0),('dw4','2014-07-11','18:50:00',0),('dw4','2014-07-11','18:55:00',0),('dw4','2014-07-11','19:00:00',0),('dw4','2014-07-11','19:05:00',0),('dw4','2014-07-11','19:10:00',0),('dw4','2014-07-11','19:15:00',0),('dw4','2014-07-11','19:20:00',0),('dw4','2014-07-11','19:25:00',0),('dw4','2014-07-11','19:30:00',0),('dw4','2014-07-11','19:35:00',0),('dw4','2014-07-11','19:40:00',0),('dw4','2014-07-11','19:45:00',0),('dw4','2014-07-11','19:50:00',0),('dw4','2014-07-11','19:55:00',0),('dw4','2014-07-11','20:00:00',0),('dw4','2014-07-11','20:05:00',0),('dw4','2014-07-11','20:10:00',0),('dw4','2014-07-11','20:15:00',0),('dw4','2014-07-11','20:20:00',0),('dw4','2014-07-11','20:25:00',0),('dw4','2014-07-11','20:30:00',0),('dw4','2014-07-11','20:35:00',0),('dw4','2014-07-11','20:40:00',0),('dw4','2014-07-11','20:45:00',0),('dw4','2014-07-11','20:50:00',0),('dw4','2014-07-11','20:55:00',0),('dw4','2014-07-11','21:00:00',0),('dw4','2014-07-11','21:05:00',0),('dw4','2014-07-11','21:10:00',0),('dw4','2014-07-11','21:15:00',0),('dw4','2014-07-11','21:20:00',0),('dw4','2014-07-11','21:25:00',0),('dw4','2014-07-11','21:30:00',0),('dw4','2014-07-11','21:35:00',0),('dw4','2014-07-11','21:40:00',0),('dw4','2014-07-11','21:45:00',0),('dw4','2014-07-11','21:50:00',0),('dw4','2014-07-11','21:55:00',0),('dw4','2014-07-11','22:00:00',0),('dw4','2014-07-11','22:05:00',0),('dw4','2014-07-11','22:10:00',0),('dw4','2014-07-11','22:15:00',0),('dw4','2014-07-11','22:20:00',0),('dw4','2014-07-11','22:25:00',0),('dw4','2014-07-11','22:30:00',0),('dw4','2014-07-11','22:35:00',0),('dw4','2014-07-11','22:40:00',0),('dw4','2014-07-11','22:45:00',0),('dw4','2014-07-11','22:50:00',0),('dw4','2014-07-11','22:55:00',0),('dw4','2014-07-11','23:00:00',0),('dw4','2014-07-11','23:05:00',0),('dw4','2014-07-11','23:10:00',0),('dw4','2014-07-11','23:15:00',0),('dw4','2014-07-11','23:20:00',0),('dw4','2014-07-11','23:25:00',0),('dw4','2014-07-11','23:30:00',0),('dw4','2014-07-11','23:35:00',0),('dw4','2014-07-11','23:40:00',0),('dw4','2014-07-11','23:45:00',0),('dw4','2014-07-11','23:50:00',0),('dw4','2014-07-11','23:55:00',0),('wm4','2014-07-11','15:52:00',0.57),('wm4','2014-07-11','15:53:00',0.51),('wm4','2014-07-11','15:54:00',0.47),('wm4','2014-07-11','15:55:00',0.44),('wm4','2014-07-11','15:56:00',0.43),('wm4','2014-07-11','15:57:00',0.43),('wm4','2014-07-11','15:58:00',0.5),('wm4','2014-07-11','15:59:00',0.52),('wm4','2014-07-11','16:00:00',0.52),('wm4','2014-07-11','16:01:00',0.52),('wm4','2014-07-11','16:02:00',0.52),('wm4','2014-07-11','16:03:00',0.52),('wm4','2014-07-11','16:04:00',0.16),('wm4','2014-07-11','00:00:00',0),('wm4','2014-07-11','00:05:00',0),('wm4','2014-07-11','00:10:00',0),('wm4','2014-07-11','00:15:00',0),('wm4','2014-07-11','00:20:00',0),('wm4','2014-07-11','00:25:00',0),('wm4','2014-07-11','00:30:00',0),('wm4','2014-07-11','00:35:00',0),('wm4','2014-07-11','00:40:00',0),('wm4','2014-07-11','00:45:00',0),('wm4','2014-07-11','00:50:00',0),('wm4','2014-07-11','00:55:00',0),('wm4','2014-07-11','01:00:00',0),('wm4','2014-07-11','01:05:00',0),('wm4','2014-07-11','01:10:00',0),('wm4','2014-07-11','01:15:00',0),('wm4','2014-07-11','01:20:00',0),('wm4','2014-07-11','01:25:00',0),('wm4','2014-07-11','01:30:00',0),('wm4','2014-07-11','01:35:00',0),('wm4','2014-07-11','01:40:00',0),('wm4','2014-07-11','01:45:00',0),('wm4','2014-07-11','01:50:00',0),('wm4','2014-07-11','01:55:00',0),('wm4','2014-07-11','02:00:00',0),('wm4','2014-07-11','02:05:00',0),('wm4','2014-07-11','02:10:00',0),('wm4','2014-07-11','02:15:00',0),('wm4','2014-07-11','02:20:00',0),('wm4','2014-07-11','02:25:00',0),('wm4','2014-07-11','02:30:00',0),('wm4','2014-07-11','02:35:00',0),('wm4','2014-07-11','02:40:00',0),('wm4','2014-07-11','02:45:00',0),('wm4','2014-07-11','02:50:00',0),('wm4','2014-07-11','02:55:00',0),('wm4','2014-07-11','03:00:00',0),('wm4','2014-07-11','03:05:00',0),('wm4','2014-07-11','03:10:00',0),('wm4','2014-07-11','03:15:00',0),('wm4','2014-07-11','03:20:00',0),('wm4','2014-07-11','03:25:00',0),('wm4','2014-07-11','03:30:00',0),('wm4','2014-07-11','03:35:00',0),('wm4','2014-07-11','03:40:00',0),('wm4','2014-07-11','03:45:00',0),('wm4','2014-07-11','03:50:00',0),('wm4','2014-07-11','03:55:00',0),('wm4','2014-07-11','04:00:00',0),('wm4','2014-07-11','04:05:00',0),('wm4','2014-07-11','04:10:00',0),('wm4','2014-07-11','04:15:00',0),('wm4','2014-07-11','04:20:00',0),('wm4','2014-07-11','04:25:00',0),('wm4','2014-07-11','04:30:00',0),('wm4','2014-07-11','04:35:00',0),('wm4','2014-07-11','04:40:00',0),('wm4','2014-07-11','04:45:00',0),('wm4','2014-07-11','04:50:00',0),('wm4','2014-07-11','04:55:00',0),('wm4','2014-07-11','05:00:00',0),('wm4','2014-07-11','05:05:00',0),('wm4','2014-07-11','05:10:00',0),('wm4','2014-07-11','05:15:00',0),('wm4','2014-07-11','05:20:00',0),('wm4','2014-07-11','05:25:00',0),('wm4','2014-07-11','05:30:00',0),('wm4','2014-07-11','05:35:00',0),('wm4','2014-07-11','05:40:00',0),('wm4','2014-07-11','05:45:00',0),('wm4','2014-07-11','05:50:00',0),('wm4','2014-07-11','05:55:00',0),('wm4','2014-07-11','06:00:00',0),('wm4','2014-07-11','06:05:00',0),('wm4','2014-07-11','06:10:00',0),('wm4','2014-07-11','06:15:00',0),('wm4','2014-07-11','06:20:00',0),('wm4','2014-07-11','06:25:00',0),('wm4','2014-07-11','06:30:00',0),('wm4','2014-07-11','06:35:00',0),('wm4','2014-07-11','06:40:00',0),('wm4','2014-07-11','06:45:00',0),('wm4','2014-07-11','06:50:00',0),('wm4','2014-07-11','06:55:00',0),('wm4','2014-07-11','07:00:00',0),('wm4','2014-07-11','07:05:00',0),('wm4','2014-07-11','07:10:00',0),('wm4','2014-07-11','07:15:00',0),('wm4','2014-07-11','07:20:00',0),('wm4','2014-07-11','07:25:00',0),('wm4','2014-07-11','07:30:00',0),('wm4','2014-07-11','07:35:00',0),('wm4','2014-07-11','07:40:00',0),('wm4','2014-07-11','07:45:00',0),('wm4','2014-07-11','07:50:00',0),('wm4','2014-07-11','07:55:00',0),('wm4','2014-07-11','08:00:00',0),('wm4','2014-07-11','08:05:00',0),('wm4','2014-07-11','08:10:00',0),('wm4','2014-07-11','08:15:00',0),('wm4','2014-07-11','08:20:00',0),('wm4','2014-07-11','08:25:00',0),('wm4','2014-07-11','08:30:00',0),('wm4','2014-07-11','08:35:00',0),('wm4','2014-07-11','08:40:00',0),('wm4','2014-07-11','08:45:00',0),('wm4','2014-07-11','08:50:00',0),('wm4','2014-07-11','08:55:00',0),('wm4','2014-07-11','09:00:00',0),('wm4','2014-07-11','09:05:00',0),('wm4','2014-07-11','09:10:00',0),('wm4','2014-07-11','09:15:00',0),('wm4','2014-07-11','09:20:00',0),('wm4','2014-07-11','09:25:00',0),('wm4','2014-07-11','09:30:00',0),('wm4','2014-07-11','09:35:00',0),('wm4','2014-07-11','09:40:00',0),('wm4','2014-07-11','09:45:00',0),('wm4','2014-07-11','09:50:00',0),('wm4','2014-07-11','09:55:00',0),('wm4','2014-07-11','10:00:00',0),('wm4','2014-07-11','10:05:00',0),('wm4','2014-07-11','10:10:00',0),('wm4','2014-07-11','10:15:00',0),('wm4','2014-07-11','10:20:00',0),('wm4','2014-07-11','10:25:00',0),('wm4','2014-07-11','10:30:00',0),('wm4','2014-07-11','10:35:00',0),('wm4','2014-07-11','10:40:00',0),('wm4','2014-07-11','10:45:00',0),('wm4','2014-07-11','10:50:00',0),('wm4','2014-07-11','10:55:00',0),('wm4','2014-07-11','11:00:00',0),('wm4','2014-07-11','11:05:00',0),('wm4','2014-07-11','11:10:00',0),('wm4','2014-07-11','11:15:00',0),('wm4','2014-07-11','11:20:00',0),('wm4','2014-07-11','11:25:00',0),('wm4','2014-07-11','11:30:00',0),('wm4','2014-07-11','11:35:00',0),('wm4','2014-07-11','11:40:00',0),('wm4','2014-07-11','11:45:00',0),('wm4','2014-07-11','11:50:00',0),('wm4','2014-07-11','11:55:00',0),('wm4','2014-07-11','12:00:00',0),('wm4','2014-07-11','12:05:00',0),('wm4','2014-07-11','12:10:00',0),('wm4','2014-07-11','12:15:00',0),('wm4','2014-07-11','12:20:00',0),('wm4','2014-07-11','12:25:00',0),('wm4','2014-07-11','12:30:00',0),('wm4','2014-07-11','12:35:00',0),('wm4','2014-07-11','12:40:00',0),('wm4','2014-07-11','12:45:00',0),('wm4','2014-07-11','12:50:00',0),('wm4','2014-07-11','12:55:00',0),('wm4','2014-07-11','13:00:00',0),('wm4','2014-07-11','13:05:00',0),('wm4','2014-07-11','13:10:00',0),('wm4','2014-07-11','13:15:00',0),('wm4','2014-07-11','13:20:00',0),('wm4','2014-07-11','13:25:00',0),('wm4','2014-07-11','13:30:00',0),('wm4','2014-07-11','13:35:00',0),('wm4','2014-07-11','13:40:00',0),('wm4','2014-07-11','13:45:00',0),('wm4','2014-07-11','13:50:00',0),('wm4','2014-07-11','13:55:00',0),('wm4','2014-07-11','14:00:00',0),('wm4','2014-07-11','14:05:00',0),('wm4','2014-07-11','14:10:00',0),('wm4','2014-07-11','14:15:00',0),('wm4','2014-07-11','14:20:00',0),('wm4','2014-07-11','14:25:00',0),('wm4','2014-07-11','14:30:00',0),('wm4','2014-07-11','14:35:00',0),('wm4','2014-07-11','14:40:00',0),('wm4','2014-07-11','14:45:00',0),('wm4','2014-07-11','14:50:00',0),('wm4','2014-07-11','14:55:00',0),('wm4','2014-07-11','15:00:00',0),('wm4','2014-07-11','15:05:00',0),('wm4','2014-07-11','15:10:00',0),('wm4','2014-07-11','15:15:00',0),('wm4','2014-07-11','15:20:00',0),('wm4','2014-07-11','15:25:00',0),('wm4','2014-07-11','16:05:00',0),('wm4','2014-07-11','16:10:00',0),('wm4','2014-07-11','16:15:00',0),('wm4','2014-07-11','16:20:00',0),('wm4','2014-07-11','16:25:00',0),('wm4','2014-07-11','16:30:00',0),('wm4','2014-07-11','16:35:00',0),('wm4','2014-07-11','16:40:00',0),('wm4','2014-07-11','16:45:00',0),('wm4','2014-07-11','16:50:00',0),('wm4','2014-07-11','16:55:00',0),('wm4','2014-07-11','17:00:00',0),('wm4','2014-07-11','17:05:00',0),('wm4','2014-07-11','17:10:00',0),('wm4','2014-07-11','17:15:00',0),('wm4','2014-07-11','17:20:00',0),('wm4','2014-07-11','17:25:00',0),('wm4','2014-07-11','17:30:00',0),('wm4','2014-07-11','17:35:00',0),('wm4','2014-07-11','17:40:00',0),('wm4','2014-07-11','17:45:00',0),('wm4','2014-07-11','17:50:00',0),('wm4','2014-07-11','17:55:00',0),('wm4','2014-07-11','18:00:00',0),('wm4','2014-07-11','18:05:00',0),('wm4','2014-07-11','18:10:00',0),('wm4','2014-07-11','18:15:00',0),('wm4','2014-07-11','18:20:00',0),('wm4','2014-07-11','18:25:00',0),('wm4','2014-07-11','18:30:00',0),('wm4','2014-07-11','18:35:00',0),('wm4','2014-07-11','18:40:00',0),('wm4','2014-07-11','18:45:00',0),('wm4','2014-07-11','18:50:00',0),('wm4','2014-07-11','18:55:00',0),('wm4','2014-07-11','19:00:00',0),('wm4','2014-07-11','19:05:00',0),('wm4','2014-07-11','19:10:00',0),('wm4','2014-07-11','19:15:00',0),('wm4','2014-07-11','19:20:00',0),('wm4','2014-07-11','19:25:00',0),('wm4','2014-07-11','19:30:00',0),('wm4','2014-07-11','19:35:00',0),('wm4','2014-07-11','19:40:00',0),('wm4','2014-07-11','19:45:00',0),('wm4','2014-07-11','19:50:00',0),('wm4','2014-07-11','19:55:00',0),('wm4','2014-07-11','20:00:00',0),('wm4','2014-07-11','20:05:00',0),('wm4','2014-07-11','20:10:00',0),('wm4','2014-07-11','20:15:00',0),('wm4','2014-07-11','20:20:00',0),('wm4','2014-07-11','20:25:00',0),('wm4','2014-07-11','20:30:00',0),('wm4','2014-07-11','20:35:00',0),('wm4','2014-07-11','20:40:00',0),('wm4','2014-07-11','20:45:00',0),('wm4','2014-07-11','20:50:00',0),('wm4','2014-07-11','20:55:00',0),('wm4','2014-07-11','21:00:00',0),('wm4','2014-07-11','21:05:00',0),('wm4','2014-07-11','21:10:00',0),('wm4','2014-07-11','21:15:00',0),('wm4','2014-07-11','21:20:00',0),('wm4','2014-07-11','21:25:00',0),('wm4','2014-07-11','21:30:00',0),('wm4','2014-07-11','21:35:00',0),('wm4','2014-07-11','21:40:00',0),('wm4','2014-07-11','21:45:00',0),('wm4','2014-07-11','21:50:00',0),('wm4','2014-07-11','21:55:00',0),('wm4','2014-07-11','22:00:00',0),('wm4','2014-07-11','22:05:00',0),('wm4','2014-07-11','22:10:00',0),('wm4','2014-07-11','22:15:00',0),('wm4','2014-07-11','22:20:00',0),('wm4','2014-07-11','22:25:00',0),('wm4','2014-07-11','22:30:00',0),('wm4','2014-07-11','22:35:00',0),('wm4','2014-07-11','22:40:00',0),('wm4','2014-07-11','22:45:00',0),('wm4','2014-07-11','22:50:00',0),('wm4','2014-07-11','22:55:00',0),('wm4','2014-07-11','23:00:00',0),('wm4','2014-07-11','23:05:00',0),('wm4','2014-07-11','23:10:00',0),('wm4','2014-07-11','23:15:00',0),('wm4','2014-07-11','23:20:00',0),('wm4','2014-07-11','23:25:00',0),('wm4','2014-07-11','23:30:00',0),('wm4','2014-07-11','23:35:00',0),('wm4','2014-07-11','23:40:00',0),('wm4','2014-07-11','23:45:00',0),('wm4','2014-07-11','23:50:00',0),('wm4','2014-07-11','23:55:00',0),('dw4','2014-07-11','16:50:00',0),('dw4','2014-07-11','17:05:00',0),('HTR16ABSRW','2014-07-11','20:00:00',142.6),('HTR16ABSRW','2014-07-11','20:01:00',137.7),('HTR16ABSRW','2014-07-11','20:02:00',134.7),('HTR16ABSRW','2014-07-11','20:03:00',133.8),('HTR16ABSRW','2014-07-11','20:04:00',132.8),('HTR16ABSRW','2014-07-11','20:05:00',132.6),('HTR16ABSRW','2014-07-11','20:06:00',132),('HTR16ABSRW','2014-07-11','20:07:00',74.9),('HTR16ABSRW','2014-07-11','20:08:00',-0.2),('HTR16ABSRW','2014-07-11','20:09:00',-0.2),('HTR16ABSRW','2014-07-11','20:10:00',-0.2),('HTR16ABSRW','2014-07-11','20:11:00',2),('HTR16ABSRW','2014-07-11','20:12:00',-0.2),('HTR16ABSRW','2014-07-11','20:13:00',6.4),('HTR16ABSRW','2014-07-11','20:14:00',-0.2),('HTR16ABSRW','2014-07-11','20:15:00',-0.2),('HTR16ABSRW','2014-07-11','20:16:00',8),('HTR16ABSRW','2014-07-11','20:17:00',145.6),('HTR16ABSRW','2014-07-11','20:18:00',140.3),('HTR16ABSRW','2014-07-11','20:19:00',136.9),('HTR16ABSRW','2014-07-11','20:20:00',135.4),('HTR16ABSRW','2014-07-11','20:21:00',134.5),('HTR16ABSRW','2014-07-11','20:22:00',133.4),('HTR16ABSRW','2014-07-11','20:23:00',132.5),('HTR16ABSRW','2014-07-11','20:24:00',131.9),('HTR16ABSRW','2014-07-11','20:25:00',131.1),('HTR16ABSRW','2014-07-11','20:26:00',130.7),('HTR16ABSRW','2014-07-11','20:27:00',32.8),('HTR16ABSRW','2014-07-11','20:28:00',-0.2),('HTR16ABSRW','2014-07-11','20:29:00',-0.2),('HTR16ABSRW','2014-07-11','20:30:00',-0.2),('HTR16ABSRW','2014-07-11','20:31:00',-0.2),('HTR16ABSRW','2014-07-11','20:32:00',-0.2),('HTR16ABSRW','2014-07-11','20:33:00',-0.2),('HTR16ABSRW','2014-07-11','20:34:00',-0.2),('HTR16ABSRW','2014-07-11','20:35:00',-0.2),('HTR16ABSRW','2014-07-11','20:36:00',-0.2),('HTR16ABSRW','2014-07-11','20:37:00',-0.2),('HTR16ABSRW','2014-07-11','20:38:00',-0.2),('HTR16ABSRW','2014-07-11','20:39:00',-0.2),('HTR16ABSRW','2014-07-11','20:40:00',-0.2),('HTR16ABSRW','2014-07-11','20:41:00',14.7),('HTR16ABSRW','2014-07-11','20:42:00',145.1),('HTR16ABSRW','2014-07-11','20:43:00',139.4),('HTR16ABSRW','2014-07-11','20:44:00',136.3),('HTR16ABSRW','2014-07-11','20:45:00',134.9),('HTR16ABSRW','2014-07-11','20:46:00',133.9),('HTR16ABSRW','2014-07-11','20:47:00',132.6),('HTR16ABSRW','2014-07-11','20:48:00',131.9),('HTR16ABSRW','2014-07-11','20:49:00',131.2),('HTR16ABSRW','2014-07-11','20:50:00',130.5),('HTR16ABSRW','2014-07-11','20:51:00',65.3),('HTR16ABSRW','2014-07-11','20:52:00',-0.2),('HTR16ABSRW','2014-07-11','20:53:00',2.5),('HTR16ABSRW','2014-07-11','20:54:00',-0.2),('HTR16ABSRW','2014-07-11','20:55:00',-0.2),('HTR16ABSRW','2014-07-11','20:56:00',-0.2),('HTR16ABSRW','2014-07-11','20:57:00',-0.2),('HTR16ABSRW','2014-07-11','20:58:00',-0.2),('HTR16ABSRW','2014-07-11','20:59:00',-0.2),('HTR16ABSRW','2014-07-11','21:00:00',-0.2),('HTR16ABSRW','2014-07-11','21:01:00',-0.2),('HTR16ABSRW','2014-07-11','21:02:00',-0.2),('HTR16ABSRW','2014-07-11','21:03:00',-0.2),('HTR16ABSRW','2014-07-11','21:04:00',72.2),('HTR16ABSRW','2014-07-11','21:05:00',143.5),('HTR16ABSRW','2014-07-11','21:06:00',141.9),('HTR16ABSRW','2014-07-11','21:07:00',136.2),('HTR16ABSRW','2014-07-11','21:08:00',140.5),('HTR16ABSRW','2014-07-11','21:09:00',139.7),('HTR16ABSRW','2014-07-11','21:10:00',135.9),('HTR16ABSRW','2014-07-11','21:11:00',135.5),('HTR16ABSRW','2014-07-11','21:12:00',134.6),('HTR16ABSRW','2014-07-11','21:13:00',133.7),('HTR16ABSRW','2014-07-11','21:14:00',132.8),('HTR16ABSRW','2014-07-11','21:15:00',131.8),('HTR16ABSRW','2014-07-11','21:16:00',131.2),('HTR16ABSRW','2014-07-11','21:17:00',83.8),('HTR16ABSRW','2014-07-11','21:18:00',-0.2),('HTR16ABSRW','2014-07-11','21:19:00',-0.2),('HTR16ABSRW','2014-07-11','21:20:00',-0.2),('HTR16ABSRW','2014-07-11','21:21:00',-0.2),('HTR16ABSRW','2014-07-11','21:22:00',-0.2),('HTR16ABSRW','2014-07-11','21:23:00',-0.2),('HTR16ABSRW','2014-07-11','21:24:00',-0.2),('HTR16ABSRW','2014-07-11','21:25:00',-0.2),('HTR16ABSRW','2014-07-11','21:26:00',-0.2),('HTR16ABSRW','2014-07-11','21:27:00',-0.2),('HTR16ABSRW','2014-07-11','21:28:00',-0.2),('HTR16ABSRW','2014-07-11','21:29:00',-0.2),('HTR16ABSRW','2014-07-11','21:30:00',-0.2),('HTR16ABSRW','2014-07-11','21:31:00',-0.2),('HTR16ABSRW','2014-07-11','21:32:00',92.6),('HTR16ABSRW','2014-07-11','21:33:00',143.7),('HTR16ABSRW','2014-07-11','21:34:00',137.8),('HTR16ABSRW','2014-07-11','21:35:00',135.2),('HTR16ABSRW','2014-07-11','21:36:00',134.2),('HTR16ABSRW','2014-07-11','21:37:00',133.1),('HTR16ABSRW','2014-07-11','21:38:00',136.9),('HTR16ABSRW','2014-07-11','21:39:00',150.8),('HTR16ABSRW','2014-07-11','21:40:00',134.1),('HTR16ABSRW','2014-07-11','21:41:00',134.9),('HTR16ABSRW','2014-07-11','21:42:00',133.5),('HTR16ABSRW','2014-07-11','21:43:00',132.8),('HTR16ABSRW','2014-07-11','21:44:00',132.2),('HTR16ABSRW','2014-07-11','21:45:00',131.2),('HTR16ABSRW','2014-07-11','21:46:00',130.5),('HTR16ABSRW','2014-07-11','21:47:00',17.3),('HTR16ABSRW','2014-07-11','21:48:00',22.4),('HTR16ABSRW','2014-07-11','21:49:00',-0.2),('HTR16ABSRW','2014-07-11','21:50:00',-0.2),('HTR16ABSRW','2014-07-11','21:51:00',5.1),('HTR16ABSRW','2014-07-11','21:52:00',-0.2),('HTR16ABSRW','2014-07-11','21:53:00',62.4),('HTR16ABSRW','2014-07-11','21:54:00',142.1),('HTR16ABSRW','2014-07-11','21:55:00',136.8),('HTR16ABSRW','2014-07-11','21:56:00',134.8),('HTR16ABSRW','2014-07-11','21:57:00',134.4),('HTR16ABSRW','2014-07-11','21:58:00',133.7),('HTR16ABSRW','2014-07-11','21:59:00',132.8),('HTR16ABSRW','2014-07-11','22:00:00',132),('HTR16ABSRW','2014-07-11','22:01:00',131.2),('HTR16ABSRW','2014-07-11','22:02:00',225.9),('HTR16ABSRW','2014-07-11','22:03:00',369.8),('HTR16ABSRW','2014-07-11','22:04:00',367.4),('HTR16ABSRW','2014-07-11','22:05:00',365.9),('HTR16ABSRW','2014-07-11','22:06:00',362.6),('HTR16ABSRW','2014-07-11','22:07:00',363.9),('HTR16ABSRW','2014-07-11','22:08:00',364),('HTR16ABSRW','2014-07-11','22:09:00',363.6),('HTR16ABSRW','2014-07-11','22:10:00',364.2),('HTR16ABSRW','2014-07-11','22:11:00',364.3),('HTR16ABSRW','2014-07-11','22:12:00',365.8),('HTR16ABSRW','2014-07-11','22:13:00',367),('HTR16ABSRW','2014-07-11','22:14:00',367.3),('HTR16ABSRW','2014-07-11','22:15:00',366.5),('HTR16ABSRW','2014-07-11','22:16:00',367),('HTR16ABSRW','2014-07-11','22:17:00',367),('HTR16ABSRW','2014-07-11','22:18:00',366.5),('HTR16ABSRW','2014-07-11','22:19:00',365.3),('HTR16ABSRW','2014-07-11','22:20:00',363.9),('HTR16ABSRW','2014-07-11','22:21:00',363.5),('HTR16ABSRW','2014-07-11','22:22:00',362.6),('HTR16ABSRW','2014-07-11','22:23:00',363.8),('HTR16ABSRW','2014-07-11','22:24:00',49.4),('HTR16ABSRW','2014-07-11','22:25:00',0.1),('HTR16ABSRW','2014-07-11','22:26:00',0.1),('HTR16ABSRW','2014-07-11','22:27:00',0.1),('HTR16ABSRW','2014-07-11','22:28:00',0.1),('HTR16ABSRW','2014-07-11','22:29:00',0.1),('HTR16ABSRW','2014-07-11','22:30:00',0.1),('HTR16ABSRW','2014-07-11','22:31:00',0.1),('HTR16ABSRW','2014-07-11','22:32:00',0.1),('HTR16ABSRW','2014-07-11','22:33:00',0.1),('HTR16ABSRW','2014-07-11','22:34:00',0.1),('HTR16ABSRW','2014-07-11','22:35:00',0.1),('HTR16ABSRW','2014-07-11','22:36:00',0.1),('HTR16ABSRW','2014-07-11','22:37:00',190.7),('HTR16ABSRW','2014-07-11','22:38:00',166.2),('HTR16ABSRW','2014-07-11','22:39:00',168.3),('HTR16ABSRW','2014-07-11','22:40:00',168.4),('HTR16ABSRW','2014-07-11','22:41:00',164.1),('HTR16ABSRW','2014-07-11','22:42:00',162.1),('HTR16ABSRW','2014-07-11','22:43:00',160.8),('HTR16ABSRW','2014-07-11','22:44:00',160),('HTR16ABSRW','2014-07-11','22:45:00',159.4),('HTR16ABSRW','2014-07-11','22:46:00',158.4),('HTR16ABSRW','2014-07-11','22:47:00',158),('HTR16ABSRW','2014-07-11','22:48:00',158.1),('HTR16ABSRW','2014-07-11','22:49:00',159.5),('HTR16ABSRW','2014-07-11','22:50:00',158.4),('HTR16ABSRW','2014-07-11','22:51:00',156.6),('HTR16ABSRW','2014-07-11','22:52:00',154.5),('HTR16ABSRW','2014-07-11','22:53:00',153),('HTR16ABSRW','2014-07-11','22:54:00',151.4),('HTR16ABSRW','2014-07-11','22:55:00',150.2),('HTR16ABSRW','2014-07-11','22:56:00',149.2),('HTR16ABSRW','2014-07-11','22:57:00',148.2),('HTR16ABSRW','2014-07-11','22:58:00',146.5),('HTR16ABSRW','2014-07-11','22:59:00',145.2),('HTR16ABSRW','2014-07-11','23:00:00',145.4),('HTR16ABSRW','2014-07-11','23:01:00',143.7),('HTR16ABSRW','2014-07-11','23:02:00',21.6),('HTR16ABSRW','2014-07-11','23:03:00',-0.2),('HTR16ABSRW','2014-07-11','23:04:00',-0.2),('HTR16ABSRW','2014-07-11','23:05:00',-0.2),('HTR16ABSRW','2014-07-11','23:06:00',-0.2),('HTR16ABSRW','2014-07-11','23:07:00',-0.2),('HTR16ABSRW','2014-07-11','23:08:00',-0.2),('HTR16ABSRW','2014-07-11','23:09:00',-0.2),('HTR16ABSRW','2014-07-11','23:10:00',-0.2),('HTR16ABSRW','2014-07-11','23:11:00',-0.2),('HTR16ABSRW','2014-07-11','23:12:00',-0.2),('HTR16ABSRW','2014-07-11','23:13:00',-0.2),('HTR16ABSRW','2014-07-11','23:14:00',142.9),('HTR16ABSRW','2014-07-11','23:15:00',146.5),('HTR16ABSRW','2014-07-11','23:16:00',145.5),('HTR16ABSRW','2014-07-11','23:17:00',145.4),('HTR16ABSRW','2014-07-11','23:18:00',143.4),('HTR16ABSRW','2014-07-11','23:19:00',143),('HTR16ABSRW','2014-07-11','23:20:00',140.7),('HTR16ABSRW','2014-07-11','23:21:00',140.7),('HTR16ABSRW','2014-07-11','23:22:00',139.9),('HTR16ABSRW','2014-07-11','23:23:00',138),('HTR16ABSRW','2014-07-11','23:24:00',11.5),('HTR16ABSRW','2014-07-11','23:25:00',-0.2),('HTR16ABSRW','2014-07-11','23:26:00',-0.2),('HTR16ABSRW','2014-07-11','23:27:00',-0.2),('HTR16ABSRW','2014-07-11','23:28:00',-0.2),('HTR16ABSRW','2014-07-11','23:29:00',-0.2),('HTR16ABSRW','2014-07-11','23:30:00',-0.2),('HTR16ABSRW','2014-07-11','23:31:00',-0.2),('HTR16ABSRW','2014-07-11','23:32:00',-0.2),('HTR16ABSRW','2014-07-11','23:33:00',-0.2),('HTR16ABSRW','2014-07-11','23:34:00',-0.2),('HTR16ABSRW','2014-07-11','23:35:00',-0.2),('HTR16ABSRW','2014-07-11','23:36:00',-0.2),('HTR16ABSRW','2014-07-11','23:37:00',152.9),('HTR16ABSRW','2014-07-11','23:38:00',145.5),('HTR16ABSRW','2014-07-11','23:39:00',143.8),('HTR16ABSRW','2014-07-11','23:40:00',143.5),('HTR16ABSRW','2014-07-11','23:41:00',141.6),('HTR16ABSRW','2014-07-11','23:42:00',140.5),('HTR16ABSRW','2014-07-11','23:43:00',139.1),('HTR16ABSRW','2014-07-11','23:44:00',138.3),('HTR16ABSRW','2014-07-11','23:45:00',122.9),('HTR16ABSRW','2014-07-11','23:46:00',-0.2),('HTR16ABSRW','2014-07-11','23:47:00',-0.2),('HTR16ABSRW','2014-07-11','23:48:00',-0.2),('HTR16ABSRW','2014-07-11','23:49:00',-0.2),('HTR16ABSRW','2014-07-11','23:50:00',-0.2),('HTR16ABSRW','2014-07-11','23:51:00',-0.2),('HTR16ABSRW','2014-07-11','23:52:00',-0.2),('HTR16ABSRW','2014-07-11','23:53:00',-0.2),('HTR16ABSRW','2014-07-11','23:54:00',-0.2),('HTR16ABSRW','2014-07-11','23:55:00',-0.2),('HTR16ABSRW','2014-07-11','23:56:00',-0.2),('HTR16ABSRW','2014-07-11','23:57:00',-0.2),('HTR16ABSRW','2014-07-11','23:58:00',-0.2),('HTR16ABSRW','2014-07-11','23:59:00',-0.2),('HTR16ABSRW','2014-07-11','00:00:00',-0.2),('HTR16ABSRW','2014-07-11','00:01:00',-0.2),('HTR16ABSRW','2014-07-11','00:02:00',-0.2),('HTR16ABSRW','2014-07-11','00:03:00',-0.2),('HTR16ABSRW','2014-07-11','00:04:00',-0.2),('HTR16ABSRW','2014-07-11','00:05:00',-0.2),('HTR16ABSRW','2014-07-11','00:06:00',-0.2),('HTR16ABSRW','2014-07-11','00:07:00',-0.2),('HTR16ABSRW','2014-07-11','00:08:00',-0.2),('HTR16ABSRW','2014-07-11','00:09:00',-0.2),('HTR16ABSRW','2014-07-11','00:10:00',-0.2),('HTR16ABSRW','2014-07-11','00:11:00',59),('HTR16ABSRW','2014-07-11','00:12:00',146.4),('HTR16ABSRW','2014-07-11','00:13:00',138.9),('HTR16ABSRW','2014-07-11','00:14:00',137.8),('HTR16ABSRW','2014-07-11','00:15:00',136.4),('HTR16ABSRW','2014-07-11','00:16:00',135),('HTR16ABSRW','2014-07-11','00:17:00',134.2),('HTR16ABSRW','2014-07-11','00:18:00',133),('HTR16ABSRW','2014-07-11','00:19:00',49.3),('HTR16ABSRW','2014-07-11','00:20:00',-0.2),('HTR16ABSRW','2014-07-11','00:21:00',-0.2),('HTR16ABSRW','2014-07-11','00:22:00',-0.2),('HTR16ABSRW','2014-07-11','00:23:00',-0.2),('HTR16ABSRW','2014-07-11','00:24:00',-0.2),('HTR16ABSRW','2014-07-11','00:25:00',-0.2),('HTR16ABSRW','2014-07-11','00:26:00',-0.2),('HTR16ABSRW','2014-07-11','00:27:00',-0.2),('HTR16ABSRW','2014-07-11','00:28:00',-0.2),('HTR16ABSRW','2014-07-11','00:29:00',-0.2),('HTR16ABSRW','2014-07-11','00:30:00',-0.2),('HTR16ABSRW','2014-07-11','00:31:00',-0.2),('HTR16ABSRW','2014-07-11','00:32:00',-0.2),('HTR16ABSRW','2014-07-11','00:33:00',-0.2),('HTR16ABSRW','2014-07-11','00:34:00',-0.2),('HTR16ABSRW','2014-07-11','00:35:00',48.3),('HTR16ABSRW','2014-07-11','00:36:00',146.3),('HTR16ABSRW','2014-07-11','00:37:00',139.1),('HTR16ABSRW','2014-07-11','00:38:00',138.2),('HTR16ABSRW','2014-07-11','00:39:00',136.9),('HTR16ABSRW','2014-07-11','00:40:00',135.1),('HTR16ABSRW','2014-07-11','00:41:00',134.4),('HTR16ABSRW','2014-07-11','00:42:00',133.1),('HTR16ABSRW','2014-07-11','00:43:00',48.1),('HTR16ABSRW','2014-07-11','00:44:00',-0.2),('HTR16ABSRW','2014-07-11','00:45:00',-0.2),('HTR16ABSRW','2014-07-11','00:46:00',-0.2),('HTR16ABSRW','2014-07-11','00:47:00',-0.2),('HTR16ABSRW','2014-07-11','00:48:00',-0.2),('HTR16ABSRW','2014-07-11','00:49:00',-0.2),('HTR16ABSRW','2014-07-11','00:50:00',-0.2),('HTR16ABSRW','2014-07-11','00:51:00',-0.2),('HTR16ABSRW','2014-07-11','00:52:00',-0.2),('HTR16ABSRW','2014-07-11','00:53:00',-0.2),('HTR16ABSRW','2014-07-11','00:54:00',-0.2),('HTR16ABSRW','2014-07-11','00:55:00',-0.2),('HTR16ABSRW','2014-07-11','00:56:00',-0.2),('HTR16ABSRW','2014-07-11','00:57:00',-0.2),('HTR16ABSRW','2014-07-11','00:58:00',-0.2),('HTR16ABSRW','2014-07-11','00:59:00',41.9),('HTR16ABSRW','2014-07-11','01:00:00',145.4),('HTR16ABSRW','2014-07-11','01:01:00',138.2),('HTR16ABSRW','2014-07-11','01:02:00',136.7),('HTR16ABSRW','2014-07-11','01:03:00',136.2),('HTR16ABSRW','2014-07-11','01:04:00',134.6),('HTR16ABSRW','2014-07-11','01:05:00',133.8),('HTR16ABSRW','2014-07-11','01:06:00',132.7),('HTR16ABSRW','2014-07-11','01:07:00',59.5),('HTR16ABSRW','2014-07-11','01:08:00',-0.2),('HTR16ABSRW','2014-07-11','01:09:00',-0.2),('HTR16ABSRW','2014-07-11','01:10:00',-0.2),('HTR16ABSRW','2014-07-11','01:11:00',-0.2),('HTR16ABSRW','2014-07-11','01:12:00',-0.2),('HTR16ABSRW','2014-07-11','01:13:00',-0.2),('HTR16ABSRW','2014-07-11','01:14:00',-0.2),('HTR16ABSRW','2014-07-11','01:15:00',-0.2),('HTR16ABSRW','2014-07-11','01:16:00',-0.2),('HTR16ABSRW','2014-07-11','01:17:00',-0.2),('HTR16ABSRW','2014-07-11','01:18:00',-0.2),('HTR16ABSRW','2014-07-11','01:19:00',-0.2),('HTR16ABSRW','2014-07-11','01:20:00',-0.2),('HTR16ABSRW','2014-07-11','01:21:00',-0.2),('HTR16ABSRW','2014-07-11','01:22:00',-0.2),('HTR16ABSRW','2014-07-11','01:23:00',8.9),('HTR16ABSRW','2014-07-11','01:24:00',146.7),('HTR16ABSRW','2014-07-11','01:25:00',140.1),('HTR16ABSRW','2014-07-11','01:26:00',137.6),('HTR16ABSRW','2014-07-11','01:27:00',136.8),('HTR16ABSRW','2014-07-11','01:28:00',135.5),('HTR16ABSRW','2014-07-11','01:29:00',134.4),('HTR16ABSRW','2014-07-11','01:30:00',133.5),('HTR16ABSRW','2014-07-11','01:31:00',70.5),('HTR16ABSRW','2014-07-11','01:32:00',-0.2),('HTR16ABSRW','2014-07-11','01:33:00',-0.2),('HTR16ABSRW','2014-07-11','01:34:00',-0.2),('HTR16ABSRW','2014-07-11','01:35:00',-0.2),('HTR16ABSRW','2014-07-11','01:36:00',-0.2),('HTR16ABSRW','2014-07-11','01:37:00',-0.2),('HTR16ABSRW','2014-07-11','01:38:00',-0.2),('HTR16ABSRW','2014-07-11','01:39:00',-0.2),('HTR16ABSRW','2014-07-11','01:40:00',-0.2),('HTR16ABSRW','2014-07-11','01:41:00',-0.2),('HTR16ABSRW','2014-07-11','01:42:00',-0.2),('HTR16ABSRW','2014-07-11','01:43:00',-0.2),('HTR16ABSRW','2014-07-11','01:44:00',-0.2),('HTR16ABSRW','2014-07-11','01:45:00',-0.2),('HTR16ABSRW','2014-07-11','01:46:00',-0.2),('HTR16ABSRW','2014-07-11','01:47:00',-0.2),('HTR16ABSRW','2014-07-11','01:48:00',132.1),('HTR16ABSRW','2014-07-11','01:49:00',142.2),('HTR16ABSRW','2014-07-11','01:50:00',138.1),('HTR16ABSRW','2014-07-11','01:51:00',137.4),('HTR16ABSRW','2014-07-11','01:52:00',136.2),('HTR16ABSRW','2014-07-11','01:53:00',134.7),('HTR16ABSRW','2014-07-11','01:54:00',134),('HTR16ABSRW','2014-07-11','01:55:00',91.7),('HTR16ABSRW','2014-07-11','01:56:00',-0.2),('HTR16ABSRW','2014-07-11','01:57:00',-0.2),('HTR16ABSRW','2014-07-11','01:58:00',-0.2),('HTR16ABSRW','2014-07-11','01:59:00',-0.2),('HTR16ABSRW','2014-07-11','02:00:00',-0.2),('HTR16ABSRW','2014-07-11','02:01:00',-0.2),('HTR16ABSRW','2014-07-11','02:02:00',-0.2),('HTR16ABSRW','2014-07-11','02:03:00',-0.2),('HTR16ABSRW','2014-07-11','02:04:00',-0.2),('HTR16ABSRW','2014-07-11','02:05:00',-0.2),('HTR16ABSRW','2014-07-11','02:06:00',-0.2),('HTR16ABSRW','2014-07-11','02:07:00',-0.2),('HTR16ABSRW','2014-07-11','02:08:00',-0.2),('HTR16ABSRW','2014-07-11','02:09:00',-0.2),('HTR16ABSRW','2014-07-11','02:10:00',-0.2),('HTR16ABSRW','2014-07-11','02:11:00',-0.2),('HTR16ABSRW','2014-07-11','02:12:00',70.8),('HTR16ABSRW','2014-07-11','02:13:00',144.1),('HTR16ABSRW','2014-07-11','02:14:00',138.4),('HTR16ABSRW','2014-07-11','02:15:00',137),('HTR16ABSRW','2014-07-11','02:16:00',136.2),('HTR16ABSRW','2014-07-11','02:17:00',134.9),('HTR16ABSRW','2014-07-11','02:18:00',134.1),('HTR16ABSRW','2014-07-11','02:19:00',132.4),('HTR16ABSRW','2014-07-11','02:20:00',2.1),('HTR16ABSRW','2014-07-11','02:21:00',-0.2),('HTR16ABSRW','2014-07-11','02:22:00',-0.2),('HTR16ABSRW','2014-07-11','02:23:00',-0.2),('HTR16ABSRW','2014-07-11','02:24:00',-0.2),('HTR16ABSRW','2014-07-11','02:25:00',-0.2),('HTR16ABSRW','2014-07-11','02:26:00',-0.2),('HTR16ABSRW','2014-07-11','02:27:00',-0.2),('HTR16ABSRW','2014-07-11','02:28:00',-0.2),('HTR16ABSRW','2014-07-11','02:29:00',-0.2),('HTR16ABSRW','2014-07-11','02:30:00',-0.2),('HTR16ABSRW','2014-07-11','02:31:00',-0.2),('HTR16ABSRW','2014-07-11','02:32:00',-0.2),('HTR16ABSRW','2014-07-11','02:33:00',-0.2),('HTR16ABSRW','2014-07-11','02:34:00',-0.2),('HTR16ABSRW','2014-07-11','02:35:00',-0.2),('HTR16ABSRW','2014-07-11','02:36:00',-0.2),('HTR16ABSRW','2014-07-11','02:37:00',152),('HTR16ABSRW','2014-07-11','02:38:00',139.6),('HTR16ABSRW','2014-07-11','02:39:00',137.2),('HTR16ABSRW','2014-07-11','02:40:00',136.2),('HTR16ABSRW','2014-07-11','02:41:00',134.6),('HTR16ABSRW','2014-07-11','02:42:00',133.9),('HTR16ABSRW','2014-07-11','02:43:00',132.4),('HTR16ABSRW','2014-07-11','02:44:00',74.5),('HTR16ABSRW','2014-07-11','02:45:00',-0.2),('HTR16ABSRW','2014-07-11','02:46:00',-0.2),('HTR16ABSRW','2014-07-11','02:47:00',-0.2),('HTR16ABSRW','2014-07-11','02:48:00',-0.2),('HTR16ABSRW','2014-07-11','02:49:00',-0.2),('HTR16ABSRW','2014-07-11','02:50:00',-0.2),('HTR16ABSRW','2014-07-11','02:51:00',-0.2),('HTR16ABSRW','2014-07-11','02:52:00',-0.2),('HTR16ABSRW','2014-07-11','02:53:00',-0.2),('HTR16ABSRW','2014-07-11','02:54:00',-0.2),('HTR16ABSRW','2014-07-11','02:55:00',-0.2),('HTR16ABSRW','2014-07-11','02:56:00',-0.2),('HTR16ABSRW','2014-07-11','02:57:00',-0.2),('HTR16ABSRW','2014-07-11','02:58:00',-0.2),('HTR16ABSRW','2014-07-11','02:59:00',-0.2),('HTR16ABSRW','2014-07-11','03:00:00',-0.2),('HTR16ABSRW','2014-07-11','03:01:00',54.5),('HTR16ABSRW','2014-07-11','03:02:00',144.9),('HTR16ABSRW','2014-07-11','03:03:00',138.2),('HTR16ABSRW','2014-07-11','03:04:00',136.5),('HTR16ABSRW','2014-07-11','03:05:00',135.4),('HTR16ABSRW','2014-07-11','03:06:00',133.9),('HTR16ABSRW','2014-07-11','03:07:00',133.6),('HTR16ABSRW','2014-07-11','03:08:00',131.8),('HTR16ABSRW','2014-07-11','03:09:00',33),('HTR16ABSRW','2014-07-11','03:10:00',-0.2),('HTR16ABSRW','2014-07-11','03:11:00',-0.2),('HTR16ABSRW','2014-07-11','03:12:00',-0.2),('HTR16ABSRW','2014-07-11','03:13:00',-0.2),('HTR16ABSRW','2014-07-11','03:14:00',-0.2),('HTR16ABSRW','2014-07-11','03:15:00',-0.2),('HTR16ABSRW','2014-07-11','03:16:00',-0.2),('HTR16ABSRW','2014-07-11','03:17:00',-0.2),('HTR16ABSRW','2014-07-11','03:18:00',-0.2),('HTR16ABSRW','2014-07-11','03:19:00',-0.2),('HTR16ABSRW','2014-07-11','03:20:00',-0.2),('HTR16ABSRW','2014-07-11','03:21:00',-0.2),('HTR16ABSRW','2014-07-11','03:22:00',-0.2),('HTR16ABSRW','2014-07-11','03:23:00',-0.2),('HTR16ABSRW','2014-07-11','03:24:00',-0.2),('HTR16ABSRW','2014-07-11','03:25:00',-0.2),('HTR16ABSRW','2014-07-11','03:26:00',82.4),('HTR16ABSRW','2014-07-11','03:27:00',143.7),('HTR16ABSRW','2014-07-11','03:28:00',137.6),('HTR16ABSRW','2014-07-11','03:29:00',136.7),('HTR16ABSRW','2014-07-11','03:30:00',135.8),('HTR16ABSRW','2014-07-11','03:31:00',134.1),('HTR16ABSRW','2014-07-11','03:32:00',133.5),('HTR16ABSRW','2014-07-11','03:33:00',114.8),('HTR16ABSRW','2014-07-11','03:34:00',-0.2),('HTR16ABSRW','2014-07-11','03:35:00',-0.2),('HTR16ABSRW','2014-07-11','03:36:00',-0.2),('HTR16ABSRW','2014-07-11','03:37:00',-0.2),('HTR16ABSRW','2014-07-11','03:38:00',-0.2),('HTR16ABSRW','2014-07-11','03:39:00',-0.2),('HTR16ABSRW','2014-07-11','03:40:00',-0.2),('HTR16ABSRW','2014-07-11','03:41:00',-0.2),('HTR16ABSRW','2014-07-11','03:42:00',-0.2),('HTR16ABSRW','2014-07-11','03:43:00',-0.2),('HTR16ABSRW','2014-07-11','03:44:00',-0.2),('HTR16ABSRW','2014-07-11','03:45:00',-0.2),('HTR16ABSRW','2014-07-11','03:46:00',-0.2),('HTR16ABSRW','2014-07-11','03:47:00',-0.2),('HTR16ABSRW','2014-07-11','03:48:00',-0.2),('HTR16ABSRW','2014-07-11','03:49:00',-0.2),('HTR16ABSRW','2014-07-11','03:50:00',-0.2),('HTR16ABSRW','2014-07-11','03:51:00',111.4),('HTR16ABSRW','2014-07-11','03:52:00',141.8),('HTR16ABSRW','2014-07-11','03:53:00',137.7),('HTR16ABSRW','2014-07-11','03:54:00',137),('HTR16ABSRW','2014-07-11','03:55:00',135.5),('HTR16ABSRW','2014-07-11','03:56:00',134.4),('HTR16ABSRW','2014-07-11','03:57:00',133.7),('HTR16ABSRW','2014-07-11','03:58:00',83.8),('HTR16ABSRW','2014-07-11','03:59:00',-0.2),('HTR16ABSRW','2014-07-11','04:00:00',142.6),('HTR16ABSRW','2014-07-11','04:01:00',137.7),('HTR16ABSRW','2014-07-11','04:02:00',134.7),('HTR16ABSRW','2014-07-11','04:03:00',133.8),('HTR16ABSRW','2014-07-11','04:04:00',132.8),('HTR16ABSRW','2014-07-11','04:05:00',132.6),('HTR16ABSRW','2014-07-11','04:06:00',132),('HTR16ABSRW','2014-07-11','04:07:00',74.9),('HTR16ABSRW','2014-07-11','04:08:00',-0.2),('HTR16ABSRW','2014-07-11','04:09:00',-0.2),('HTR16ABSRW','2014-07-11','04:10:00',-0.2),('HTR16ABSRW','2014-07-11','04:11:00',2),('HTR16ABSRW','2014-07-11','04:12:00',-0.2),('HTR16ABSRW','2014-07-11','04:13:00',6.4),('HTR16ABSRW','2014-07-11','04:14:00',-0.2),('HTR16ABSRW','2014-07-11','04:15:00',-0.2),('HTR16ABSRW','2014-07-11','04:16:00',8),('HTR16ABSRW','2014-07-11','04:17:00',145.6),('HTR16ABSRW','2014-07-11','04:18:00',140.3),('HTR16ABSRW','2014-07-11','04:19:00',136.9),('HTR16ABSRW','2014-07-11','04:20:00',135.4),('HTR16ABSRW','2014-07-11','04:21:00',134.5),('HTR16ABSRW','2014-07-11','04:22:00',133.4),('HTR16ABSRW','2014-07-11','04:23:00',132.5),('HTR16ABSRW','2014-07-11','04:24:00',131.9),('HTR16ABSRW','2014-07-11','04:25:00',131.1),('HTR16ABSRW','2014-07-11','04:26:00',130.7),('HTR16ABSRW','2014-07-11','04:27:00',32.8),('HTR16ABSRW','2014-07-11','04:28:00',-0.2),('HTR16ABSRW','2014-07-11','04:29:00',-0.2),('HTR16ABSRW','2014-07-11','04:30:00',-0.2),('HTR16ABSRW','2014-07-11','04:31:00',-0.2),('HTR16ABSRW','2014-07-11','04:32:00',-0.2),('HTR16ABSRW','2014-07-11','04:33:00',-0.2),('HTR16ABSRW','2014-07-11','04:34:00',-0.2),('HTR16ABSRW','2014-07-11','04:35:00',-0.2),('HTR16ABSRW','2014-07-11','04:36:00',-0.2),('HTR16ABSRW','2014-07-11','04:37:00',-0.2),('HTR16ABSRW','2014-07-11','04:38:00',-0.2),('HTR16ABSRW','2014-07-11','04:39:00',-0.2),('HTR16ABSRW','2014-07-11','04:40:00',-0.2),('HTR16ABSRW','2014-07-11','04:41:00',14.7),('HTR16ABSRW','2014-07-11','04:42:00',145.1),('HTR16ABSRW','2014-07-11','04:43:00',139.4),('HTR16ABSRW','2014-07-11','04:44:00',136.3),('HTR16ABSRW','2014-07-11','04:45:00',134.9),('HTR16ABSRW','2014-07-11','04:46:00',133.9),('HTR16ABSRW','2014-07-11','04:47:00',132.6),('HTR16ABSRW','2014-07-11','04:48:00',131.9),('HTR16ABSRW','2014-07-11','04:49:00',131.2),('HTR16ABSRW','2014-07-11','04:50:00',130.5),('HTR16ABSRW','2014-07-11','04:51:00',65.3),('HTR16ABSRW','2014-07-11','04:52:00',-0.2),('HTR16ABSRW','2014-07-11','04:53:00',2.5),('HTR16ABSRW','2014-07-11','04:54:00',-0.2),('HTR16ABSRW','2014-07-11','04:55:00',-0.2),('HTR16ABSRW','2014-07-11','04:56:00',-0.2),('HTR16ABSRW','2014-07-11','04:57:00',-0.2),('HTR16ABSRW','2014-07-11','04:58:00',-0.2),('HTR16ABSRW','2014-07-11','04:59:00',-0.2),('HTR16ABSRW','2014-07-11','05:00:00',-0.2),('HTR16ABSRW','2014-07-11','05:01:00',-0.2),('HTR16ABSRW','2014-07-11','05:02:00',-0.2),('HTR16ABSRW','2014-07-11','05:03:00',-0.2),('HTR16ABSRW','2014-07-11','05:04:00',72.2),('HTR16ABSRW','2014-07-11','05:05:00',143.5),('HTR16ABSRW','2014-07-11','05:06:00',141.9),('HTR16ABSRW','2014-07-11','05:07:00',136.2),('HTR16ABSRW','2014-07-11','05:08:00',140.5),('HTR16ABSRW','2014-07-11','05:09:00',139.7),('HTR16ABSRW','2014-07-11','05:10:00',135.9),('HTR16ABSRW','2014-07-11','05:11:00',135.5),('HTR16ABSRW','2014-07-11','05:12:00',134.6),('HTR16ABSRW','2014-07-11','05:13:00',133.7),('HTR16ABSRW','2014-07-11','05:14:00',132.8),('HTR16ABSRW','2014-07-11','05:15:00',131.8),('HTR16ABSRW','2014-07-11','05:16:00',131.2),('HTR16ABSRW','2014-07-11','05:17:00',83.8),('HTR16ABSRW','2014-07-11','05:18:00',-0.2),('HTR16ABSRW','2014-07-11','05:19:00',-0.2),('HTR16ABSRW','2014-07-11','05:20:00',-0.2),('HTR16ABSRW','2014-07-11','05:21:00',-0.2),('HTR16ABSRW','2014-07-11','05:22:00',-0.2),('HTR16ABSRW','2014-07-11','05:23:00',-0.2),('HTR16ABSRW','2014-07-11','05:24:00',-0.2),('HTR16ABSRW','2014-07-11','05:25:00',-0.2),('HTR16ABSRW','2014-07-11','05:26:00',-0.2),('HTR16ABSRW','2014-07-11','05:27:00',-0.2),('HTR16ABSRW','2014-07-11','05:28:00',-0.2),('HTR16ABSRW','2014-07-11','05:29:00',-0.2),('HTR16ABSRW','2014-07-11','05:30:00',-0.2),('HTR16ABSRW','2014-07-11','05:31:00',-0.2),('HTR16ABSRW','2014-07-11','05:32:00',92.6),('HTR16ABSRW','2014-07-11','05:33:00',143.7),('HTR16ABSRW','2014-07-11','05:34:00',137.8),('HTR16ABSRW','2014-07-11','05:35:00',135.2),('HTR16ABSRW','2014-07-11','05:36:00',134.2),('HTR16ABSRW','2014-07-11','05:37:00',133.1),('HTR16ABSRW','2014-07-11','05:38:00',136.9),('HTR16ABSRW','2014-07-11','05:39:00',150.8),('HTR16ABSRW','2014-07-11','05:40:00',134.1),('HTR16ABSRW','2014-07-11','05:41:00',134.9),('HTR16ABSRW','2014-07-11','05:42:00',133.5),('HTR16ABSRW','2014-07-11','05:43:00',132.8),('HTR16ABSRW','2014-07-11','05:44:00',132.2),('HTR16ABSRW','2014-07-11','05:45:00',131.2),('HTR16ABSRW','2014-07-11','05:46:00',130.5),('HTR16ABSRW','2014-07-11','05:47:00',17.3),('HTR16ABSRW','2014-07-11','05:48:00',22.4),('HTR16ABSRW','2014-07-11','05:49:00',-0.2),('HTR16ABSRW','2014-07-11','05:50:00',-0.2),('HTR16ABSRW','2014-07-11','05:51:00',5.1),('HTR16ABSRW','2014-07-11','05:52:00',-0.2),('HTR16ABSRW','2014-07-11','05:53:00',62.4),('HTR16ABSRW','2014-07-11','05:54:00',142.1),('HTR16ABSRW','2014-07-11','05:55:00',136.8),('HTR16ABSRW','2014-07-11','05:56:00',134.8),('HTR16ABSRW','2014-07-11','05:57:00',134.4),('HTR16ABSRW','2014-07-11','05:58:00',133.7),('HTR16ABSRW','2014-07-11','05:59:00',132.8),('HTR16ABSRW','2014-07-11','06:00:00',132),('HTR16ABSRW','2014-07-11','06:01:00',131.2),('HTR16ABSRW','2014-07-11','06:02:00',225.9),('HTR16ABSRW','2014-07-11','06:03:00',369.8),('HTR16ABSRW','2014-07-11','06:04:00',367.4),('HTR16ABSRW','2014-07-11','06:05:00',365.9),('HTR16ABSRW','2014-07-11','06:06:00',362.6),('HTR16ABSRW','2014-07-11','06:07:00',363.9),('HTR16ABSRW','2014-07-11','06:08:00',364),('HTR16ABSRW','2014-07-11','06:09:00',363.6),('HTR16ABSRW','2014-07-11','06:10:00',364.2),('HTR16ABSRW','2014-07-11','06:11:00',364.3),('HTR16ABSRW','2014-07-11','06:12:00',365.8),('HTR16ABSRW','2014-07-11','06:13:00',367),('HTR16ABSRW','2014-07-11','06:14:00',367.3),('HTR16ABSRW','2014-07-11','06:15:00',366.5),('HTR16ABSRW','2014-07-11','06:16:00',367),('HTR16ABSRW','2014-07-11','06:17:00',367),('HTR16ABSRW','2014-07-11','06:18:00',366.5),('HTR16ABSRW','2014-07-11','06:19:00',365.3),('HTR16ABSRW','2014-07-11','06:20:00',363.9),('HTR16ABSRW','2014-07-11','06:21:00',363.5),('HTR16ABSRW','2014-07-11','06:22:00',362.6),('HTR16ABSRW','2014-07-11','06:23:00',363.8),('HTR16ABSRW','2014-07-11','06:24:00',49.4),('HTR16ABSRW','2014-07-11','06:25:00',0.1),('HTR16ABSRW','2014-07-11','06:26:00',0.1),('HTR16ABSRW','2014-07-11','06:27:00',0.1),('HTR16ABSRW','2014-07-11','06:28:00',0.1),('HTR16ABSRW','2014-07-11','06:29:00',0.1),('HTR16ABSRW','2014-07-11','06:30:00',0.1),('HTR16ABSRW','2014-07-11','06:31:00',0.1),('HTR16ABSRW','2014-07-11','06:32:00',0.1),('HTR16ABSRW','2014-07-11','06:33:00',0.1),('HTR16ABSRW','2014-07-11','06:34:00',0.1),('HTR16ABSRW','2014-07-11','06:35:00',0.1),('HTR16ABSRW','2014-07-11','06:36:00',0.1),('HTR16ABSRW','2014-07-11','06:37:00',190.7),('HTR16ABSRW','2014-07-11','06:38:00',166.2),('HTR16ABSRW','2014-07-11','06:39:00',168.3),('HTR16ABSRW','2014-07-11','06:40:00',168.4),('HTR16ABSRW','2014-07-11','06:41:00',164.1),('HTR16ABSRW','2014-07-11','06:42:00',162.1),('HTR16ABSRW','2014-07-11','06:43:00',160.8),('HTR16ABSRW','2014-07-11','06:44:00',160),('HTR16ABSRW','2014-07-11','06:45:00',159.4),('HTR16ABSRW','2014-07-11','06:46:00',158.4),('HTR16ABSRW','2014-07-11','06:47:00',158),('HTR16ABSRW','2014-07-11','06:48:00',158.1),('HTR16ABSRW','2014-07-11','06:49:00',159.5),('HTR16ABSRW','2014-07-11','06:50:00',158.4),('HTR16ABSRW','2014-07-11','06:51:00',156.6),('HTR16ABSRW','2014-07-11','06:52:00',154.5),('HTR16ABSRW','2014-07-11','06:53:00',153),('HTR16ABSRW','2014-07-11','06:54:00',151.4),('HTR16ABSRW','2014-07-11','06:55:00',150.2),('HTR16ABSRW','2014-07-11','06:56:00',149.2),('HTR16ABSRW','2014-07-11','06:57:00',148.2),('HTR16ABSRW','2014-07-11','06:58:00',146.5),('HTR16ABSRW','2014-07-11','06:59:00',145.2),('HTR16ABSRW','2014-07-11','07:00:00',145.4),('HTR16ABSRW','2014-07-11','07:01:00',143.7),('HTR16ABSRW','2014-07-11','07:02:00',21.6),('HTR16ABSRW','2014-07-11','07:03:00',-0.2),('HTR16ABSRW','2014-07-11','07:04:00',-0.2),('HTR16ABSRW','2014-07-11','07:05:00',-0.2),('HTR16ABSRW','2014-07-11','07:06:00',-0.2),('HTR16ABSRW','2014-07-11','07:07:00',-0.2),('HTR16ABSRW','2014-07-11','07:08:00',-0.2),('HTR16ABSRW','2014-07-11','07:09:00',-0.2),('HTR16ABSRW','2014-07-11','07:10:00',-0.2),('HTR16ABSRW','2014-07-11','07:11:00',-0.2),('HTR16ABSRW','2014-07-11','07:12:00',-0.2),('HTR16ABSRW','2014-07-11','07:13:00',-0.2),('HTR16ABSRW','2014-07-11','07:14:00',142.9),('HTR16ABSRW','2014-07-11','07:15:00',146.5),('HTR16ABSRW','2014-07-11','07:16:00',145.5),('HTR16ABSRW','2014-07-11','07:17:00',145.4),('HTR16ABSRW','2014-07-11','07:18:00',143.4),('HTR16ABSRW','2014-07-11','07:19:00',143),('HTR16ABSRW','2014-07-11','07:20:00',140.7),('HTR16ABSRW','2014-07-11','07:21:00',140.7),('HTR16ABSRW','2014-07-11','07:22:00',139.9),('HTR16ABSRW','2014-07-11','07:23:00',138),('HTR16ABSRW','2014-07-11','07:24:00',11.5),('HTR16ABSRW','2014-07-11','07:25:00',-0.2),('HTR16ABSRW','2014-07-11','07:26:00',-0.2),('HTR16ABSRW','2014-07-11','07:27:00',-0.2),('HTR16ABSRW','2014-07-11','07:28:00',-0.2),('HTR16ABSRW','2014-07-11','07:29:00',-0.2),('HTR16ABSRW','2014-07-11','07:30:00',-0.2),('HTR16ABSRW','2014-07-11','07:31:00',-0.2),('HTR16ABSRW','2014-07-11','07:32:00',-0.2),('HTR16ABSRW','2014-07-11','07:33:00',-0.2),('HTR16ABSRW','2014-07-11','07:34:00',-0.2),('HTR16ABSRW','2014-07-11','07:35:00',-0.2),('HTR16ABSRW','2014-07-11','07:36:00',-0.2),('HTR16ABSRW','2014-07-11','07:37:00',152.9),('HTR16ABSRW','2014-07-11','07:38:00',145.5),('HTR16ABSRW','2014-07-11','07:39:00',143.8),('HTR16ABSRW','2014-07-11','07:40:00',143.5),('HTR16ABSRW','2014-07-11','07:41:00',141.6),('HTR16ABSRW','2014-07-11','07:42:00',140.5),('HTR16ABSRW','2014-07-11','07:43:00',139.1),('HTR16ABSRW','2014-07-11','07:44:00',138.3),('HTR16ABSRW','2014-07-11','07:45:00',122.9),('HTR16ABSRW','2014-07-11','07:46:00',-0.2),('HTR16ABSRW','2014-07-11','07:47:00',-0.2),('HTR16ABSRW','2014-07-11','07:48:00',-0.2),('HTR16ABSRW','2014-07-11','07:49:00',-0.2),('HTR16ABSRW','2014-07-11','07:50:00',-0.2),('HTR16ABSRW','2014-07-11','07:51:00',-0.2),('HTR16ABSRW','2014-07-11','07:52:00',-0.2),('HTR16ABSRW','2014-07-11','07:53:00',-0.2),('HTR16ABSRW','2014-07-11','07:54:00',-0.2),('HTR16ABSRW','2014-07-11','07:55:00',-0.2),('HTR16ABSRW','2014-07-11','07:56:00',-0.2),('HTR16ABSRW','2014-07-11','07:57:00',-0.2),('HTR16ABSRW','2014-07-11','07:58:00',-0.2),('HTR16ABSRW','2014-07-11','07:59:00',-0.2),('HTR16ABSRW','2014-07-11','08:00:00',-0.2),('HTR16ABSRW','2014-07-11','08:01:00',-0.2),('HTR16ABSRW','2014-07-11','08:02:00',-0.2),('HTR16ABSRW','2014-07-11','08:03:00',-0.2),('HTR16ABSRW','2014-07-11','08:04:00',-0.2),('HTR16ABSRW','2014-07-11','08:05:00',-0.2),('HTR16ABSRW','2014-07-11','08:06:00',-0.2),('HTR16ABSRW','2014-07-11','08:07:00',-0.2),('HTR16ABSRW','2014-07-11','08:08:00',-0.2),('HTR16ABSRW','2014-07-11','08:09:00',-0.2),('HTR16ABSRW','2014-07-11','08:10:00',-0.2),('HTR16ABSRW','2014-07-11','08:11:00',59),('HTR16ABSRW','2014-07-11','08:12:00',146.4),('HTR16ABSRW','2014-07-11','08:13:00',138.9),('HTR16ABSRW','2014-07-11','08:14:00',137.8),('HTR16ABSRW','2014-07-11','08:15:00',136.4),('HTR16ABSRW','2014-07-11','08:16:00',135),('HTR16ABSRW','2014-07-11','08:17:00',134.2),('HTR16ABSRW','2014-07-11','08:18:00',133),('HTR16ABSRW','2014-07-11','08:19:00',49.3),('HTR16ABSRW','2014-07-11','08:20:00',-0.2),('HTR16ABSRW','2014-07-11','08:21:00',-0.2),('HTR16ABSRW','2014-07-11','08:22:00',-0.2),('HTR16ABSRW','2014-07-11','08:23:00',-0.2),('HTR16ABSRW','2014-07-11','08:24:00',-0.2),('HTR16ABSRW','2014-07-11','08:25:00',-0.2),('HTR16ABSRW','2014-07-11','08:26:00',-0.2),('HTR16ABSRW','2014-07-11','08:27:00',-0.2),('HTR16ABSRW','2014-07-11','08:28:00',-0.2),('HTR16ABSRW','2014-07-11','08:29:00',-0.2),('HTR16ABSRW','2014-07-11','08:30:00',-0.2),('HTR16ABSRW','2014-07-11','08:31:00',-0.2),('HTR16ABSRW','2014-07-11','08:32:00',-0.2),('HTR16ABSRW','2014-07-11','08:33:00',-0.2),('HTR16ABSRW','2014-07-11','08:34:00',-0.2),('HTR16ABSRW','2014-07-11','08:35:00',48.3),('HTR16ABSRW','2014-07-11','08:36:00',146.3),('HTR16ABSRW','2014-07-11','08:37:00',139.1),('HTR16ABSRW','2014-07-11','08:38:00',138.2),('HTR16ABSRW','2014-07-11','08:39:00',136.9),('HTR16ABSRW','2014-07-11','08:40:00',135.1),('HTR16ABSRW','2014-07-11','08:41:00',134.4),('HTR16ABSRW','2014-07-11','08:42:00',133.1),('HTR16ABSRW','2014-07-11','08:43:00',48.1),('HTR16ABSRW','2014-07-11','08:44:00',-0.2),('HTR16ABSRW','2014-07-11','08:45:00',-0.2),('HTR16ABSRW','2014-07-11','08:46:00',-0.2),('HTR16ABSRW','2014-07-11','08:47:00',-0.2),('HTR16ABSRW','2014-07-11','08:48:00',-0.2),('HTR16ABSRW','2014-07-11','08:49:00',-0.2),('HTR16ABSRW','2014-07-11','08:50:00',-0.2),('HTR16ABSRW','2014-07-11','08:51:00',-0.2),('HTR16ABSRW','2014-07-11','08:52:00',-0.2),('HTR16ABSRW','2014-07-11','08:53:00',-0.2),('HTR16ABSRW','2014-07-11','08:54:00',-0.2),('HTR16ABSRW','2014-07-11','08:55:00',-0.2),('HTR16ABSRW','2014-07-11','08:56:00',-0.2),('HTR16ABSRW','2014-07-11','08:57:00',-0.2),('HTR16ABSRW','2014-07-11','08:58:00',-0.2),('HTR16ABSRW','2014-07-11','08:59:00',41.9),('HTR16ABSRW','2014-07-11','09:00:00',145.4),('HTR16ABSRW','2014-07-11','09:01:00',138.2),('HTR16ABSRW','2014-07-11','09:02:00',136.7),('HTR16ABSRW','2014-07-11','09:03:00',136.2),('HTR16ABSRW','2014-07-11','09:04:00',134.6),('HTR16ABSRW','2014-07-11','09:05:00',133.8),('HTR16ABSRW','2014-07-11','09:06:00',132.7),('HTR16ABSRW','2014-07-11','09:07:00',59.5),('HTR16ABSRW','2014-07-11','09:08:00',-0.2),('HTR16ABSRW','2014-07-11','09:09:00',-0.2),('HTR16ABSRW','2014-07-11','09:10:00',-0.2),('HTR16ABSRW','2014-07-11','09:11:00',-0.2),('HTR16ABSRW','2014-07-11','09:12:00',-0.2),('HTR16ABSRW','2014-07-11','09:13:00',-0.2),('HTR16ABSRW','2014-07-11','09:14:00',-0.2),('HTR16ABSRW','2014-07-11','09:15:00',-0.2),('HTR16ABSRW','2014-07-11','09:16:00',-0.2),('HTR16ABSRW','2014-07-11','09:17:00',-0.2),('HTR16ABSRW','2014-07-11','09:18:00',-0.2),('HTR16ABSRW','2014-07-11','09:19:00',-0.2),('HTR16ABSRW','2014-07-11','09:20:00',-0.2),('HTR16ABSRW','2014-07-11','09:21:00',-0.2),('HTR16ABSRW','2014-07-11','09:22:00',-0.2),('HTR16ABSRW','2014-07-11','09:23:00',8.9),('HTR16ABSRW','2014-07-11','09:24:00',146.7),('HTR16ABSRW','2014-07-11','09:25:00',140.1),('HTR16ABSRW','2014-07-11','09:26:00',137.6),('HTR16ABSRW','2014-07-11','09:27:00',136.8),('HTR16ABSRW','2014-07-11','09:28:00',135.5),('HTR16ABSRW','2014-07-11','09:29:00',134.4),('HTR16ABSRW','2014-07-11','09:30:00',133.5),('HTR16ABSRW','2014-07-11','09:31:00',70.5),('HTR16ABSRW','2014-07-11','09:32:00',-0.2),('HTR16ABSRW','2014-07-11','09:33:00',-0.2),('HTR16ABSRW','2014-07-11','09:34:00',-0.2),('HTR16ABSRW','2014-07-11','09:35:00',-0.2),('HTR16ABSRW','2014-07-11','09:36:00',-0.2),('HTR16ABSRW','2014-07-11','09:37:00',-0.2),('HTR16ABSRW','2014-07-11','09:38:00',-0.2),('HTR16ABSRW','2014-07-11','09:39:00',-0.2),('HTR16ABSRW','2014-07-11','09:40:00',-0.2),('HTR16ABSRW','2014-07-11','09:41:00',-0.2),('HTR16ABSRW','2014-07-11','09:42:00',-0.2),('HTR16ABSRW','2014-07-11','09:43:00',-0.2),('HTR16ABSRW','2014-07-11','09:44:00',-0.2),('HTR16ABSRW','2014-07-11','09:45:00',-0.2),('HTR16ABSRW','2014-07-11','09:46:00',-0.2),('HTR16ABSRW','2014-07-11','09:47:00',-0.2),('HTR16ABSRW','2014-07-11','09:48:00',132.1),('HTR16ABSRW','2014-07-11','09:49:00',142.2),('HTR16ABSRW','2014-07-11','09:50:00',138.1),('HTR16ABSRW','2014-07-11','09:51:00',137.4),('HTR16ABSRW','2014-07-11','09:52:00',136.2),('HTR16ABSRW','2014-07-11','09:53:00',134.7),('HTR16ABSRW','2014-07-11','09:54:00',134),('HTR16ABSRW','2014-07-11','09:55:00',91.7),('HTR16ABSRW','2014-07-11','09:56:00',-0.2),('HTR16ABSRW','2014-07-11','09:57:00',-0.2),('HTR16ABSRW','2014-07-11','09:58:00',-0.2),('HTR16ABSRW','2014-07-11','09:59:00',-0.2),('HTR16ABSRW','2014-07-11','10:00:00',-0.2),('HTR16ABSRW','2014-07-11','10:01:00',-0.2),('HTR16ABSRW','2014-07-11','10:02:00',-0.2),('HTR16ABSRW','2014-07-11','10:03:00',-0.2),('HTR16ABSRW','2014-07-11','10:04:00',-0.2),('HTR16ABSRW','2014-07-11','10:05:00',-0.2),('HTR16ABSRW','2014-07-11','10:06:00',-0.2),('HTR16ABSRW','2014-07-11','10:07:00',-0.2),('HTR16ABSRW','2014-07-11','10:08:00',-0.2),('HTR16ABSRW','2014-07-11','10:09:00',-0.2),('HTR16ABSRW','2014-07-11','10:10:00',-0.2),('HTR16ABSRW','2014-07-11','10:11:00',-0.2),('HTR16ABSRW','2014-07-11','10:12:00',70.8),('HTR16ABSRW','2014-07-11','10:13:00',144.1),('HTR16ABSRW','2014-07-11','10:14:00',138.4),('HTR16ABSRW','2014-07-11','10:15:00',137),('HTR16ABSRW','2014-07-11','10:16:00',136.2),('HTR16ABSRW','2014-07-11','10:17:00',134.9),('HTR16ABSRW','2014-07-11','10:18:00',134.1),('HTR16ABSRW','2014-07-11','10:19:00',132.4),('HTR16ABSRW','2014-07-11','10:20:00',2.1),('HTR16ABSRW','2014-07-11','10:21:00',-0.2),('HTR16ABSRW','2014-07-11','10:22:00',-0.2),('HTR16ABSRW','2014-07-11','10:23:00',-0.2),('HTR16ABSRW','2014-07-11','10:24:00',-0.2),('HTR16ABSRW','2014-07-11','10:25:00',-0.2),('HTR16ABSRW','2014-07-11','10:26:00',-0.2),('HTR16ABSRW','2014-07-11','10:27:00',-0.2),('HTR16ABSRW','2014-07-11','10:28:00',-0.2),('HTR16ABSRW','2014-07-11','10:29:00',-0.2),('HTR16ABSRW','2014-07-11','10:30:00',-0.2),('HTR16ABSRW','2014-07-11','10:31:00',-0.2),('HTR16ABSRW','2014-07-11','10:32:00',-0.2),('HTR16ABSRW','2014-07-11','10:33:00',-0.2),('HTR16ABSRW','2014-07-11','10:34:00',-0.2),('HTR16ABSRW','2014-07-11','10:35:00',-0.2),('HTR16ABSRW','2014-07-11','10:36:00',-0.2),('HTR16ABSRW','2014-07-11','10:37:00',152),('HTR16ABSRW','2014-07-11','10:38:00',139.6),('HTR16ABSRW','2014-07-11','10:39:00',137.2),('HTR16ABSRW','2014-07-11','10:40:00',136.2),('HTR16ABSRW','2014-07-11','10:41:00',134.6),('HTR16ABSRW','2014-07-11','10:42:00',133.9),('HTR16ABSRW','2014-07-11','10:43:00',132.4),('HTR16ABSRW','2014-07-11','10:44:00',74.5),('HTR16ABSRW','2014-07-11','10:45:00',-0.2),('HTR16ABSRW','2014-07-11','10:46:00',-0.2),('HTR16ABSRW','2014-07-11','10:47:00',-0.2),('HTR16ABSRW','2014-07-11','10:48:00',-0.2),('HTR16ABSRW','2014-07-11','10:49:00',-0.2),('HTR16ABSRW','2014-07-11','10:50:00',-0.2),('HTR16ABSRW','2014-07-11','10:51:00',-0.2),('HTR16ABSRW','2014-07-11','10:52:00',-0.2),('HTR16ABSRW','2014-07-11','10:53:00',-0.2),('HTR16ABSRW','2014-07-11','10:54:00',-0.2),('HTR16ABSRW','2014-07-11','10:55:00',-0.2),('HTR16ABSRW','2014-07-11','10:56:00',-0.2),('HTR16ABSRW','2014-07-11','10:57:00',-0.2),('HTR16ABSRW','2014-07-11','10:58:00',-0.2),('HTR16ABSRW','2014-07-11','10:59:00',-0.2),('HTR16ABSRW','2014-07-11','11:00:00',-0.2),('HTR16ABSRW','2014-07-11','11:01:00',54.5),('HTR16ABSRW','2014-07-11','11:02:00',144.9),('HTR16ABSRW','2014-07-11','11:03:00',138.2),('HTR16ABSRW','2014-07-11','11:04:00',136.5),('HTR16ABSRW','2014-07-11','11:05:00',135.4),('HTR16ABSRW','2014-07-11','11:06:00',133.9),('HTR16ABSRW','2014-07-11','11:07:00',133.6),('HTR16ABSRW','2014-07-11','11:08:00',131.8),('HTR16ABSRW','2014-07-11','11:09:00',33),('HTR16ABSRW','2014-07-11','11:10:00',-0.2),('HTR16ABSRW','2014-07-11','11:11:00',-0.2),('HTR16ABSRW','2014-07-11','11:12:00',-0.2),('HTR16ABSRW','2014-07-11','11:13:00',-0.2),('HTR16ABSRW','2014-07-11','11:14:00',-0.2),('HTR16ABSRW','2014-07-11','11:15:00',-0.2),('HTR16ABSRW','2014-07-11','11:16:00',-0.2),('HTR16ABSRW','2014-07-11','11:17:00',-0.2),('HTR16ABSRW','2014-07-11','11:18:00',-0.2),('HTR16ABSRW','2014-07-11','11:19:00',-0.2),('HTR16ABSRW','2014-07-11','11:20:00',-0.2),('HTR16ABSRW','2014-07-11','11:21:00',-0.2),('HTR16ABSRW','2014-07-11','11:22:00',-0.2),('HTR16ABSRW','2014-07-11','11:23:00',-0.2),('HTR16ABSRW','2014-07-11','11:24:00',-0.2),('HTR16ABSRW','2014-07-11','11:25:00',-0.2),('HTR16ABSRW','2014-07-11','11:26:00',82.4),('HTR16ABSRW','2014-07-11','11:27:00',143.7),('HTR16ABSRW','2014-07-11','11:28:00',137.6),('HTR16ABSRW','2014-07-11','11:29:00',136.7),('HTR16ABSRW','2014-07-11','11:30:00',135.8),('HTR16ABSRW','2014-07-11','11:31:00',134.1),('HTR16ABSRW','2014-07-11','11:32:00',133.5),('HTR16ABSRW','2014-07-11','11:33:00',114.8),('HTR16ABSRW','2014-07-11','11:34:00',-0.2),('HTR16ABSRW','2014-07-11','11:35:00',-0.2),('HTR16ABSRW','2014-07-11','11:36:00',-0.2),('HTR16ABSRW','2014-07-11','11:37:00',-0.2),('HTR16ABSRW','2014-07-11','11:38:00',-0.2),('HTR16ABSRW','2014-07-11','11:39:00',-0.2),('HTR16ABSRW','2014-07-11','11:40:00',-0.2),('HTR16ABSRW','2014-07-11','11:41:00',-0.2),('HTR16ABSRW','2014-07-11','11:42:00',-0.2),('HTR16ABSRW','2014-07-11','11:43:00',-0.2),('HTR16ABSRW','2014-07-11','11:44:00',-0.2),('HTR16ABSRW','2014-07-11','11:45:00',-0.2),('HTR16ABSRW','2014-07-11','11:46:00',-0.2),('HTR16ABSRW','2014-07-11','11:47:00',-0.2),('HTR16ABSRW','2014-07-11','11:48:00',-0.2),('HTR16ABSRW','2014-07-11','11:49:00',-0.2),('HTR16ABSRW','2014-07-11','11:50:00',-0.2),('HTR16ABSRW','2014-07-11','11:51:00',111.4),('HTR16ABSRW','2014-07-11','11:52:00',141.8),('HTR16ABSRW','2014-07-11','11:53:00',137.7),('HTR16ABSRW','2014-07-11','11:54:00',137),('HTR16ABSRW','2014-07-11','11:55:00',135.5),('HTR16ABSRW','2014-07-11','11:56:00',134.4),('HTR16ABSRW','2014-07-11','11:57:00',133.7),('HTR16ABSRW','2014-07-11','11:58:00',83.8),('HTR16ABSRW','2014-07-11','11:59:00',-0.2),('HTR16ABSRW','2014-07-11','12:00:00',142.6),('HTR16ABSRW','2014-07-11','12:01:00',137.7),('HTR16ABSRW','2014-07-11','12:02:00',134.7),('HTR16ABSRW','2014-07-11','12:03:00',133.8),('HTR16ABSRW','2014-07-11','12:04:00',132.8),('HTR16ABSRW','2014-07-11','12:05:00',132.6),('HTR16ABSRW','2014-07-11','12:06:00',132),('HTR16ABSRW','2014-07-11','12:07:00',74.9),('HTR16ABSRW','2014-07-11','12:08:00',-0.2),('HTR16ABSRW','2014-07-11','12:09:00',-0.2),('HTR16ABSRW','2014-07-11','12:10:00',-0.2),('HTR16ABSRW','2014-07-11','12:11:00',2),('HTR16ABSRW','2014-07-11','12:12:00',-0.2),('HTR16ABSRW','2014-07-11','12:13:00',6.4),('HTR16ABSRW','2014-07-11','12:14:00',-0.2),('HTR16ABSRW','2014-07-11','12:15:00',-0.2),('HTR16ABSRW','2014-07-11','12:16:00',8),('HTR16ABSRW','2014-07-11','12:17:00',145.6),('HTR16ABSRW','2014-07-11','12:18:00',140.3),('HTR16ABSRW','2014-07-11','12:19:00',136.9),('HTR16ABSRW','2014-07-11','12:20:00',135.4),('HTR16ABSRW','2014-07-11','12:21:00',134.5),('HTR16ABSRW','2014-07-11','12:22:00',133.4),('HTR16ABSRW','2014-07-11','12:23:00',132.5),('HTR16ABSRW','2014-07-11','12:24:00',131.9),('HTR16ABSRW','2014-07-11','12:25:00',131.1),('HTR16ABSRW','2014-07-11','12:26:00',130.7),('HTR16ABSRW','2014-07-11','12:27:00',32.8),('HTR16ABSRW','2014-07-11','12:28:00',-0.2),('HTR16ABSRW','2014-07-11','12:29:00',-0.2),('HTR16ABSRW','2014-07-11','12:30:00',-0.2),('HTR16ABSRW','2014-07-11','12:31:00',-0.2),('HTR16ABSRW','2014-07-11','12:32:00',-0.2),('HTR16ABSRW','2014-07-11','12:33:00',-0.2),('HTR16ABSRW','2014-07-11','12:34:00',-0.2),('HTR16ABSRW','2014-07-11','12:35:00',-0.2),('HTR16ABSRW','2014-07-11','12:36:00',-0.2),('HTR16ABSRW','2014-07-11','12:37:00',-0.2),('HTR16ABSRW','2014-07-11','12:38:00',-0.2),('HTR16ABSRW','2014-07-11','12:39:00',-0.2),('HTR16ABSRW','2014-07-11','12:40:00',-0.2),('HTR16ABSRW','2014-07-11','12:41:00',14.7),('HTR16ABSRW','2014-07-11','12:42:00',145.1),('HTR16ABSRW','2014-07-11','12:43:00',139.4),('HTR16ABSRW','2014-07-11','12:44:00',136.3),('HTR16ABSRW','2014-07-11','12:45:00',134.9),('HTR16ABSRW','2014-07-11','12:46:00',133.9),('HTR16ABSRW','2014-07-11','12:47:00',132.6),('HTR16ABSRW','2014-07-11','12:48:00',131.9),('HTR16ABSRW','2014-07-11','12:49:00',131.2),('HTR16ABSRW','2014-07-11','12:50:00',130.5),('HTR16ABSRW','2014-07-11','12:51:00',65.3),('HTR16ABSRW','2014-07-11','12:52:00',-0.2),('HTR16ABSRW','2014-07-11','12:53:00',2.5),('HTR16ABSRW','2014-07-11','12:54:00',-0.2),('HTR16ABSRW','2014-07-11','12:55:00',-0.2),('HTR16ABSRW','2014-07-11','12:56:00',-0.2),('HTR16ABSRW','2014-07-11','12:57:00',-0.2),('HTR16ABSRW','2014-07-11','12:58:00',-0.2),('HTR16ABSRW','2014-07-11','12:59:00',-0.2),('HTR16ABSRW','2014-07-11','13:00:00',-0.2),('HTR16ABSRW','2014-07-11','13:01:00',-0.2),('HTR16ABSRW','2014-07-11','13:02:00',-0.2),('HTR16ABSRW','2014-07-11','13:03:00',-0.2),('HTR16ABSRW','2014-07-11','13:04:00',72.2),('HTR16ABSRW','2014-07-11','13:05:00',143.5),('HTR16ABSRW','2014-07-11','13:06:00',141.9),('HTR16ABSRW','2014-07-11','13:07:00',136.2),('HTR16ABSRW','2014-07-11','13:08:00',140.5),('HTR16ABSRW','2014-07-11','13:09:00',139.7),('HTR16ABSRW','2014-07-11','13:10:00',135.9),('HTR16ABSRW','2014-07-11','13:11:00',135.5),('HTR16ABSRW','2014-07-11','13:12:00',134.6),('HTR16ABSRW','2014-07-11','13:13:00',133.7),('HTR16ABSRW','2014-07-11','13:14:00',132.8),('HTR16ABSRW','2014-07-11','13:15:00',131.8),('HTR16ABSRW','2014-07-11','13:16:00',131.2),('HTR16ABSRW','2014-07-11','13:17:00',83.8),('HTR16ABSRW','2014-07-11','13:18:00',-0.2),('HTR16ABSRW','2014-07-11','13:19:00',-0.2),('HTR16ABSRW','2014-07-11','13:20:00',-0.2),('HTR16ABSRW','2014-07-11','13:21:00',-0.2),('HTR16ABSRW','2014-07-11','13:22:00',-0.2),('HTR16ABSRW','2014-07-11','13:23:00',-0.2),('HTR16ABSRW','2014-07-11','13:24:00',-0.2),('HTR16ABSRW','2014-07-11','13:25:00',-0.2),('HTR16ABSRW','2014-07-11','13:26:00',-0.2),('HTR16ABSRW','2014-07-11','13:27:00',-0.2),('HTR16ABSRW','2014-07-11','13:28:00',-0.2),('HTR16ABSRW','2014-07-11','13:29:00',-0.2),('HTR16ABSRW','2014-07-11','13:30:00',-0.2),('HTR16ABSRW','2014-07-11','13:31:00',-0.2),('HTR16ABSRW','2014-07-11','13:32:00',92.6),('HTR16ABSRW','2014-07-11','13:33:00',143.7),('HTR16ABSRW','2014-07-11','13:34:00',137.8),('HTR16ABSRW','2014-07-11','13:35:00',135.2),('HTR16ABSRW','2014-07-11','13:36:00',134.2),('HTR16ABSRW','2014-07-11','13:37:00',133.1),('HTR16ABSRW','2014-07-11','13:38:00',136.9),('HTR16ABSRW','2014-07-11','13:39:00',150.8),('HTR16ABSRW','2014-07-11','13:40:00',134.1),('HTR16ABSRW','2014-07-11','13:41:00',134.9),('HTR16ABSRW','2014-07-11','13:42:00',133.5),('HTR16ABSRW','2014-07-11','13:43:00',132.8),('HTR16ABSRW','2014-07-11','13:44:00',132.2),('HTR16ABSRW','2014-07-11','13:45:00',131.2),('HTR16ABSRW','2014-07-11','13:46:00',130.5),('HTR16ABSRW','2014-07-11','13:47:00',17.3),('HTR16ABSRW','2014-07-11','13:48:00',22.4),('HTR16ABSRW','2014-07-11','13:49:00',-0.2),('HTR16ABSRW','2014-07-11','13:50:00',-0.2),('HTR16ABSRW','2014-07-11','13:51:00',5.1),('HTR16ABSRW','2014-07-11','13:52:00',-0.2),('HTR16ABSRW','2014-07-11','13:53:00',62.4),('HTR16ABSRW','2014-07-11','13:54:00',142.1),('HTR16ABSRW','2014-07-11','13:55:00',136.8),('HTR16ABSRW','2014-07-11','13:56:00',134.8),('HTR16ABSRW','2014-07-11','13:57:00',134.4),('HTR16ABSRW','2014-07-11','13:58:00',133.7),('HTR16ABSRW','2014-07-11','13:59:00',132.8),('HTR16ABSRW','2014-07-11','14:00:00',132),('HTR16ABSRW','2014-07-11','14:01:00',131.2),('HTR16ABSRW','2014-07-11','14:02:00',225.9),('HTR16ABSRW','2014-07-11','14:03:00',369.8),('HTR16ABSRW','2014-07-11','14:04:00',367.4),('HTR16ABSRW','2014-07-11','14:05:00',365.9),('HTR16ABSRW','2014-07-11','14:06:00',362.6),('HTR16ABSRW','2014-07-11','14:07:00',363.9),('HTR16ABSRW','2014-07-11','14:08:00',364),('HTR16ABSRW','2014-07-11','14:09:00',363.6),('HTR16ABSRW','2014-07-11','14:10:00',364.2),('HTR16ABSRW','2014-07-11','14:11:00',364.3),('HTR16ABSRW','2014-07-11','14:12:00',365.8),('HTR16ABSRW','2014-07-11','14:13:00',367),('HTR16ABSRW','2014-07-11','14:14:00',367.3),('HTR16ABSRW','2014-07-11','14:15:00',366.5),('HTR16ABSRW','2014-07-11','14:16:00',367),('HTR16ABSRW','2014-07-11','14:17:00',367),('HTR16ABSRW','2014-07-11','14:18:00',366.5),('HTR16ABSRW','2014-07-11','14:19:00',365.3),('HTR16ABSRW','2014-07-11','14:20:00',363.9),('HTR16ABSRW','2014-07-11','14:21:00',363.5),('HTR16ABSRW','2014-07-11','14:22:00',362.6),('HTR16ABSRW','2014-07-11','14:23:00',363.8),('HTR16ABSRW','2014-07-11','14:24:00',49.4),('HTR16ABSRW','2014-07-11','14:25:00',0.1),('HTR16ABSRW','2014-07-11','14:26:00',0.1),('HTR16ABSRW','2014-07-11','14:27:00',0.1),('HTR16ABSRW','2014-07-11','14:28:00',0.1),('HTR16ABSRW','2014-07-11','14:29:00',0.1),('HTR16ABSRW','2014-07-11','14:30:00',0.1),('HTR16ABSRW','2014-07-11','14:31:00',0.1),('HTR16ABSRW','2014-07-11','14:32:00',0.1),('HTR16ABSRW','2014-07-11','14:33:00',0.1),('HTR16ABSRW','2014-07-11','14:34:00',0.1),('HTR16ABSRW','2014-07-11','14:35:00',0.1),('HTR16ABSRW','2014-07-11','14:36:00',0.1),('HTR16ABSRW','2014-07-11','14:37:00',190.7),('HTR16ABSRW','2014-07-11','14:38:00',166.2),('HTR16ABSRW','2014-07-11','14:39:00',168.3),('HTR16ABSRW','2014-07-11','14:40:00',168.4),('HTR16ABSRW','2014-07-11','14:41:00',164.1),('HTR16ABSRW','2014-07-11','14:42:00',162.1),('HTR16ABSRW','2014-07-11','14:43:00',160.8),('HTR16ABSRW','2014-07-11','14:44:00',160),('HTR16ABSRW','2014-07-11','14:45:00',159.4),('HTR16ABSRW','2014-07-11','14:46:00',158.4),('HTR16ABSRW','2014-07-11','14:47:00',158),('HTR16ABSRW','2014-07-11','14:48:00',158.1),('HTR16ABSRW','2014-07-11','14:49:00',159.5),('HTR16ABSRW','2014-07-11','14:50:00',158.4),('HTR16ABSRW','2014-07-11','14:51:00',156.6),('HTR16ABSRW','2014-07-11','14:52:00',154.5),('HTR16ABSRW','2014-07-11','14:53:00',153),('HTR16ABSRW','2014-07-11','14:54:00',151.4),('HTR16ABSRW','2014-07-11','14:55:00',150.2),('HTR16ABSRW','2014-07-11','14:56:00',149.2),('HTR16ABSRW','2014-07-11','14:57:00',148.2),('HTR16ABSRW','2014-07-11','14:58:00',146.5),('HTR16ABSRW','2014-07-11','14:59:00',145.2),('HTR16ABSRW','2014-07-11','15:00:00',145.4),('HTR16ABSRW','2014-07-11','15:01:00',143.7),('HTR16ABSRW','2014-07-11','15:02:00',21.6),('HTR16ABSRW','2014-07-11','15:03:00',-0.2),('HTR16ABSRW','2014-07-11','15:04:00',-0.2),('HTR16ABSRW','2014-07-11','15:05:00',-0.2),('HTR16ABSRW','2014-07-11','15:06:00',-0.2),('HTR16ABSRW','2014-07-11','15:07:00',-0.2),('HTR16ABSRW','2014-07-11','15:08:00',-0.2),('HTR16ABSRW','2014-07-11','15:09:00',-0.2),('HTR16ABSRW','2014-07-11','15:10:00',-0.2),('HTR16ABSRW','2014-07-11','15:11:00',-0.2),('HTR16ABSRW','2014-07-11','15:12:00',-0.2),('HTR16ABSRW','2014-07-11','15:13:00',-0.2),('HTR16ABSRW','2014-07-11','15:14:00',142.9),('HTR16ABSRW','2014-07-11','15:15:00',146.5),('HTR16ABSRW','2014-07-11','15:16:00',145.5),('HTR16ABSRW','2014-07-11','15:17:00',145.4),('HTR16ABSRW','2014-07-11','15:18:00',143.4),('HTR16ABSRW','2014-07-11','15:19:00',143),('HTR16ABSRW','2014-07-11','15:20:00',140.7),('HTR16ABSRW','2014-07-11','15:21:00',140.7),('HTR16ABSRW','2014-07-11','15:22:00',139.9),('HTR16ABSRW','2014-07-11','15:23:00',138),('HTR16ABSRW','2014-07-11','15:24:00',11.5),('HTR16ABSRW','2014-07-11','15:25:00',-0.2),('HTR16ABSRW','2014-07-11','15:26:00',-0.2),('HTR16ABSRW','2014-07-11','15:27:00',-0.2),('HTR16ABSRW','2014-07-11','15:28:00',-0.2),('HTR16ABSRW','2014-07-11','15:29:00',-0.2),('HTR16ABSRW','2014-07-11','15:30:00',-0.2),('HTR16ABSRW','2014-07-11','15:31:00',-0.2),('HTR16ABSRW','2014-07-11','15:32:00',-0.2),('HTR16ABSRW','2014-07-11','15:33:00',-0.2),('HTR16ABSRW','2014-07-11','15:34:00',-0.2),('HTR16ABSRW','2014-07-11','15:35:00',-0.2),('HTR16ABSRW','2014-07-11','15:36:00',-0.2),('HTR16ABSRW','2014-07-11','15:37:00',152.9),('HTR16ABSRW','2014-07-11','15:38:00',145.5),('HTR16ABSRW','2014-07-11','15:39:00',143.8),('HTR16ABSRW','2014-07-11','15:40:00',143.5),('HTR16ABSRW','2014-07-11','15:41:00',141.6),('HTR16ABSRW','2014-07-11','15:42:00',140.5),('HTR16ABSRW','2014-07-11','15:43:00',139.1),('HTR16ABSRW','2014-07-11','15:44:00',138.3),('HTR16ABSRW','2014-07-11','15:45:00',122.9),('HTR16ABSRW','2014-07-11','15:46:00',-0.2),('HTR16ABSRW','2014-07-11','15:47:00',-0.2),('HTR16ABSRW','2014-07-11','15:48:00',-0.2),('HTR16ABSRW','2014-07-11','15:49:00',-0.2),('HTR16ABSRW','2014-07-11','15:50:00',-0.2),('HTR16ABSRW','2014-07-11','15:51:00',-0.2),('HTR16ABSRW','2014-07-11','15:52:00',-0.2),('HTR16ABSRW','2014-07-11','15:53:00',-0.2),('HTR16ABSRW','2014-07-11','15:54:00',-0.2),('HTR16ABSRW','2014-07-11','15:55:00',-0.2),('HTR16ABSRW','2014-07-11','15:56:00',-0.2),('HTR16ABSRW','2014-07-11','15:57:00',-0.2),('HTR16ABSRW','2014-07-11','15:58:00',-0.2),('HTR16ABSRW','2014-07-11','15:59:00',-0.2),('HTR16ABSRW','2014-07-11','16:00:00',-0.2),('HTR16ABSRW','2014-07-11','16:01:00',-0.2),('HTR16ABSRW','2014-07-11','16:02:00',-0.2),('HTR16ABSRW','2014-07-11','16:03:00',-0.2),('HTR16ABSRW','2014-07-11','16:04:00',-0.2),('HTR16ABSRW','2014-07-11','16:05:00',-0.2),('HTR16ABSRW','2014-07-11','16:06:00',-0.2),('HTR16ABSRW','2014-07-11','16:07:00',-0.2),('HTR16ABSRW','2014-07-11','16:08:00',-0.2),('HTR16ABSRW','2014-07-11','16:09:00',-0.2),('HTR16ABSRW','2014-07-11','16:10:00',-0.2),('HTR16ABSRW','2014-07-11','16:11:00',59),('HTR16ABSRW','2014-07-11','16:12:00',146.4),('HTR16ABSRW','2014-07-11','16:13:00',138.9),('HTR16ABSRW','2014-07-11','16:14:00',137.8),('HTR16ABSRW','2014-07-11','16:15:00',136.4),('HTR16ABSRW','2014-07-11','16:16:00',135),('HTR16ABSRW','2014-07-11','16:17:00',134.2),('HTR16ABSRW','2014-07-11','16:18:00',133),('HTR16ABSRW','2014-07-11','16:19:00',49.3),('HTR16ABSRW','2014-07-11','16:20:00',-0.2),('HTR16ABSRW','2014-07-11','16:21:00',-0.2),('HTR16ABSRW','2014-07-11','16:22:00',-0.2),('HTR16ABSRW','2014-07-11','16:23:00',-0.2),('HTR16ABSRW','2014-07-11','16:24:00',-0.2),('HTR16ABSRW','2014-07-11','16:25:00',-0.2),('HTR16ABSRW','2014-07-11','16:26:00',-0.2),('HTR16ABSRW','2014-07-11','16:27:00',-0.2),('HTR16ABSRW','2014-07-11','16:28:00',-0.2),('HTR16ABSRW','2014-07-11','16:29:00',-0.2),('HTR16ABSRW','2014-07-11','16:30:00',-0.2),('HTR16ABSRW','2014-07-11','16:31:00',-0.2),('HTR16ABSRW','2014-07-11','16:32:00',-0.2),('HTR16ABSRW','2014-07-11','16:33:00',-0.2),('HTR16ABSRW','2014-07-11','16:34:00',-0.2),('HTR16ABSRW','2014-07-11','16:35:00',48.3),('HTR16ABSRW','2014-07-11','16:36:00',146.3),('HTR16ABSRW','2014-07-11','16:37:00',139.1),('HTR16ABSRW','2014-07-11','16:38:00',138.2),('HTR16ABSRW','2014-07-11','16:39:00',136.9),('HTR16ABSRW','2014-07-11','16:40:00',135.1),('HTR16ABSRW','2014-07-11','16:41:00',134.4),('HTR16ABSRW','2014-07-11','16:42:00',133.1),('HTR16ABSRW','2014-07-11','16:43:00',48.1),('HTR16ABSRW','2014-07-11','16:44:00',-0.2),('HTR16ABSRW','2014-07-11','16:45:00',-0.2),('HTR16ABSRW','2014-07-11','16:46:00',-0.2),('HTR16ABSRW','2014-07-11','16:47:00',-0.2),('HTR16ABSRW','2014-07-11','16:48:00',-0.2),('HTR16ABSRW','2014-07-11','16:49:00',-0.2),('HTR16ABSRW','2014-07-11','16:50:00',-0.2),('HTR16ABSRW','2014-07-11','16:51:00',-0.2),('HTR16ABSRW','2014-07-11','16:52:00',-0.2),('HTR16ABSRW','2014-07-11','16:53:00',-0.2),('HTR16ABSRW','2014-07-11','16:54:00',-0.2),('HTR16ABSRW','2014-07-11','16:55:00',-0.2),('HTR16ABSRW','2014-07-11','16:56:00',-0.2),('HTR16ABSRW','2014-07-11','16:57:00',-0.2),('HTR16ABSRW','2014-07-11','16:58:00',-0.2),('HTR16ABSRW','2014-07-11','16:59:00',41.9),('HTR16ABSRW','2014-07-11','17:00:00',145.4),('HTR16ABSRW','2014-07-11','17:01:00',138.2),('HTR16ABSRW','2014-07-11','17:02:00',136.7),('HTR16ABSRW','2014-07-11','17:03:00',136.2),('HTR16ABSRW','2014-07-11','17:04:00',134.6),('HTR16ABSRW','2014-07-11','17:05:00',133.8),('HTR16ABSRW','2014-07-11','17:06:00',132.7),('HTR16ABSRW','2014-07-11','17:07:00',59.5),('HTR16ABSRW','2014-07-11','17:08:00',-0.2),('HTR16ABSRW','2014-07-11','17:09:00',-0.2),('HTR16ABSRW','2014-07-11','17:10:00',-0.2),('HTR16ABSRW','2014-07-11','17:11:00',-0.2),('HTR16ABSRW','2014-07-11','17:12:00',-0.2),('HTR16ABSRW','2014-07-11','17:13:00',-0.2),('HTR16ABSRW','2014-07-11','17:14:00',-0.2),('HTR16ABSRW','2014-07-11','17:15:00',-0.2),('HTR16ABSRW','2014-07-11','17:16:00',-0.2),('HTR16ABSRW','2014-07-11','17:17:00',-0.2),('HTR16ABSRW','2014-07-11','17:18:00',-0.2),('HTR16ABSRW','2014-07-11','17:19:00',-0.2),('HTR16ABSRW','2014-07-11','17:20:00',-0.2),('HTR16ABSRW','2014-07-11','17:21:00',-0.2),('HTR16ABSRW','2014-07-11','17:22:00',-0.2),('HTR16ABSRW','2014-07-11','17:23:00',8.9),('HTR16ABSRW','2014-07-11','17:24:00',146.7),('HTR16ABSRW','2014-07-11','17:25:00',140.1),('HTR16ABSRW','2014-07-11','17:26:00',137.6),('HTR16ABSRW','2014-07-11','17:27:00',136.8),('HTR16ABSRW','2014-07-11','17:28:00',135.5),('HTR16ABSRW','2014-07-11','17:29:00',134.4),('HTR16ABSRW','2014-07-11','17:30:00',133.5),('HTR16ABSRW','2014-07-11','17:31:00',70.5),('HTR16ABSRW','2014-07-11','17:32:00',-0.2),('HTR16ABSRW','2014-07-11','17:33:00',-0.2),('HTR16ABSRW','2014-07-11','17:34:00',-0.2),('HTR16ABSRW','2014-07-11','17:35:00',-0.2),('HTR16ABSRW','2014-07-11','17:36:00',-0.2),('HTR16ABSRW','2014-07-11','17:37:00',-0.2),('HTR16ABSRW','2014-07-11','17:38:00',-0.2),('HTR16ABSRW','2014-07-11','17:39:00',-0.2),('HTR16ABSRW','2014-07-11','17:40:00',-0.2),('HTR16ABSRW','2014-07-11','17:41:00',-0.2),('HTR16ABSRW','2014-07-11','17:42:00',-0.2),('HTR16ABSRW','2014-07-11','17:43:00',-0.2),('HTR16ABSRW','2014-07-11','17:44:00',-0.2),('HTR16ABSRW','2014-07-11','17:45:00',-0.2),('HTR16ABSRW','2014-07-11','17:46:00',-0.2),('HTR16ABSRW','2014-07-11','17:47:00',-0.2),('HTR16ABSRW','2014-07-11','17:48:00',132.1),('HTR16ABSRW','2014-07-11','17:49:00',142.2),('HTR16ABSRW','2014-07-11','17:50:00',138.1),('HTR16ABSRW','2014-07-11','17:51:00',137.4),('HTR16ABSRW','2014-07-11','17:52:00',136.2),('HTR16ABSRW','2014-07-11','17:53:00',134.7),('HTR16ABSRW','2014-07-11','17:54:00',134),('HTR16ABSRW','2014-07-11','17:55:00',91.7),('HTR16ABSRW','2014-07-11','17:56:00',-0.2),('HTR16ABSRW','2014-07-11','17:57:00',-0.2),('HTR16ABSRW','2014-07-11','17:58:00',-0.2),('HTR16ABSRW','2014-07-11','17:59:00',-0.2),('HTR16ABSRW','2014-07-11','18:00:00',-0.2),('HTR16ABSRW','2014-07-11','18:01:00',-0.2),('HTR16ABSRW','2014-07-11','18:02:00',-0.2),('HTR16ABSRW','2014-07-11','18:03:00',-0.2),('HTR16ABSRW','2014-07-11','18:04:00',-0.2),('HTR16ABSRW','2014-07-11','18:05:00',-0.2),('HTR16ABSRW','2014-07-11','18:06:00',-0.2),('HTR16ABSRW','2014-07-11','18:07:00',-0.2),('HTR16ABSRW','2014-07-11','18:08:00',-0.2),('HTR16ABSRW','2014-07-11','18:09:00',-0.2),('HTR16ABSRW','2014-07-11','18:10:00',-0.2),('HTR16ABSRW','2014-07-11','18:11:00',-0.2),('HTR16ABSRW','2014-07-11','18:12:00',70.8),('HTR16ABSRW','2014-07-11','18:13:00',144.1),('HTR16ABSRW','2014-07-11','18:14:00',138.4),('HTR16ABSRW','2014-07-11','18:15:00',137),('HTR16ABSRW','2014-07-11','18:16:00',136.2),('HTR16ABSRW','2014-07-11','18:17:00',134.9),('HTR16ABSRW','2014-07-11','18:18:00',134.1),('HTR16ABSRW','2014-07-11','18:19:00',132.4),('HTR16ABSRW','2014-07-11','18:20:00',2.1),('HTR16ABSRW','2014-07-11','18:21:00',-0.2),('HTR16ABSRW','2014-07-11','18:22:00',-0.2),('HTR16ABSRW','2014-07-11','18:23:00',-0.2),('HTR16ABSRW','2014-07-11','18:24:00',-0.2),('HTR16ABSRW','2014-07-11','18:25:00',-0.2),('HTR16ABSRW','2014-07-11','18:26:00',-0.2),('HTR16ABSRW','2014-07-11','18:27:00',-0.2),('HTR16ABSRW','2014-07-11','18:28:00',-0.2),('HTR16ABSRW','2014-07-11','18:29:00',-0.2),('HTR16ABSRW','2014-07-11','18:30:00',-0.2),('HTR16ABSRW','2014-07-11','18:31:00',-0.2),('HTR16ABSRW','2014-07-11','18:32:00',-0.2),('HTR16ABSRW','2014-07-11','18:33:00',-0.2),('HTR16ABSRW','2014-07-11','18:34:00',-0.2),('HTR16ABSRW','2014-07-11','18:35:00',-0.2),('HTR16ABSRW','2014-07-11','18:36:00',-0.2),('HTR16ABSRW','2014-07-11','18:37:00',152),('HTR16ABSRW','2014-07-11','18:38:00',139.6),('HTR16ABSRW','2014-07-11','18:39:00',137.2),('HTR16ABSRW','2014-07-11','18:40:00',136.2),('HTR16ABSRW','2014-07-11','18:41:00',134.6),('HTR16ABSRW','2014-07-11','18:42:00',133.9),('HTR16ABSRW','2014-07-11','18:43:00',132.4),('HTR16ABSRW','2014-07-11','18:44:00',74.5),('HTR16ABSRW','2014-07-11','18:45:00',-0.2),('HTR16ABSRW','2014-07-11','18:46:00',-0.2),('HTR16ABSRW','2014-07-11','18:47:00',-0.2),('HTR16ABSRW','2014-07-11','18:48:00',-0.2),('HTR16ABSRW','2014-07-11','18:49:00',-0.2),('HTR16ABSRW','2014-07-11','18:50:00',-0.2),('HTR16ABSRW','2014-07-11','18:51:00',-0.2),('HTR16ABSRW','2014-07-11','18:52:00',-0.2),('HTR16ABSRW','2014-07-11','18:53:00',-0.2),('HTR16ABSRW','2014-07-11','18:54:00',-0.2),('HTR16ABSRW','2014-07-11','18:55:00',-0.2),('HTR16ABSRW','2014-07-11','18:56:00',-0.2),('HTR16ABSRW','2014-07-11','18:57:00',-0.2),('HTR16ABSRW','2014-07-11','18:58:00',-0.2),('HTR16ABSRW','2014-07-11','18:59:00',-0.2),('HTR16ABSRW','2014-07-11','19:00:00',-0.2),('HTR16ABSRW','2014-07-11','19:01:00',54.5),('HTR16ABSRW','2014-07-11','19:02:00',144.9),('HTR16ABSRW','2014-07-11','19:03:00',138.2),('HTR16ABSRW','2014-07-11','19:04:00',136.5),('HTR16ABSRW','2014-07-11','19:05:00',135.4),('HTR16ABSRW','2014-07-11','19:06:00',133.9),('HTR16ABSRW','2014-07-11','19:07:00',133.6),('HTR16ABSRW','2014-07-11','19:08:00',131.8),('HTR16ABSRW','2014-07-11','19:09:00',33),('HTR16ABSRW','2014-07-11','19:10:00',-0.2),('HTR16ABSRW','2014-07-11','19:11:00',-0.2),('HTR16ABSRW','2014-07-11','19:12:00',-0.2),('HTR16ABSRW','2014-07-11','19:13:00',-0.2),('HTR16ABSRW','2014-07-11','19:14:00',-0.2),('HTR16ABSRW','2014-07-11','19:15:00',-0.2),('HTR16ABSRW','2014-07-11','19:16:00',-0.2),('HTR16ABSRW','2014-07-11','19:17:00',-0.2),('HTR16ABSRW','2014-07-11','19:18:00',-0.2),('HTR16ABSRW','2014-07-11','19:19:00',-0.2),('HTR16ABSRW','2014-07-11','19:20:00',-0.2),('HTR16ABSRW','2014-07-11','19:21:00',-0.2),('HTR16ABSRW','2014-07-11','19:22:00',-0.2),('HTR16ABSRW','2014-07-11','19:23:00',-0.2),('HTR16ABSRW','2014-07-11','19:24:00',-0.2),('HTR16ABSRW','2014-07-11','19:25:00',-0.2),('HTR16ABSRW','2014-07-11','19:26:00',82.4),('HTR16ABSRW','2014-07-11','19:27:00',143.7),('HTR16ABSRW','2014-07-11','19:28:00',137.6),('HTR16ABSRW','2014-07-11','19:29:00',136.7),('HTR16ABSRW','2014-07-11','19:30:00',135.8),('HTR16ABSRW','2014-07-11','19:31:00',134.1),('HTR16ABSRW','2014-07-11','19:32:00',133.5),('HTR16ABSRW','2014-07-11','19:33:00',114.8),('HTR16ABSRW','2014-07-11','19:34:00',-0.2),('HTR16ABSRW','2014-07-11','19:35:00',-0.2),('HTR16ABSRW','2014-07-11','19:36:00',-0.2),('HTR16ABSRW','2014-07-11','19:37:00',-0.2),('HTR16ABSRW','2014-07-11','19:38:00',-0.2),('HTR16ABSRW','2014-07-11','19:39:00',-0.2),('HTR16ABSRW','2014-07-11','19:40:00',-0.2),('HTR16ABSRW','2014-07-11','19:41:00',-0.2),('HTR16ABSRW','2014-07-11','19:42:00',-0.2),('HTR16ABSRW','2014-07-11','19:43:00',-0.2),('HTR16ABSRW','2014-07-11','19:44:00',-0.2),('HTR16ABSRW','2014-07-11','19:45:00',-0.2),('HTR16ABSRW','2014-07-11','19:46:00',-0.2),('HTR16ABSRW','2014-07-11','19:47:00',-0.2),('HTR16ABSRW','2014-07-11','19:48:00',-0.2),('HTR16ABSRW','2014-07-11','19:49:00',-0.2),('HTR16ABSRW','2014-07-11','19:50:00',-0.2),('HTR16ABSRW','2014-07-11','19:51:00',111.4),('HTR16ABSRW','2014-07-11','19:52:00',141.8),('HTR16ABSRW','2014-07-11','19:53:00',137.7),('HTR16ABSRW','2014-07-11','19:54:00',137),('HTR16ABSRW','2014-07-11','19:55:00',135.5),('HTR16ABSRW','2014-07-11','19:56:00',134.4),('HTR16ABSRW','2014-07-11','19:57:00',133.7),('HTR16ABSRW','2014-07-11','19:58:00',83.8),('HTR16ABSRW','2014-07-11','19:59:00',-0.2);
/*!40000 ALTER TABLE `solarlogmod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `template_info`
--

DROP TABLE IF EXISTS `template_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `template_info` (
  `id` int(11) NOT NULL,
  `parameter` varchar(45) NOT NULL,
  `value` varchar(45) DEFAULT NULL,
  `template_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_template_id_idx` (`template_id`),
  CONSTRAINT `fk_template_id` FOREIGN KEY (`template_id`) REFERENCES `templates` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `template_info`
--

LOCK TABLES `template_info` WRITE;
/*!40000 ALTER TABLE `template_info` DISABLE KEYS */;
INSERT INTO `template_info` VALUES (0,'kwp','3',15),(1,'location','IT - 81030 Succivo',15),(2,'orientation','90°',15),(3,'inverter_manufacturer','Power-One',15),(4,'module_manufacturer','Qcell',15),(5,'inveter_type','3000 OUTD-S',15),(6,'module_type','Wp. 250 (poly)',15),(7,'module_numbers','12',15),(8,'manufacturer','Kenmore',42),(9,'manufacturer','Kenmore',43),(10,'sampling_period','1sec',42),(11,'sampling_period','60sec',43),(12,'manufacturer','GEWSM2420D3WW-Regular',73),(13,'manufacturer','LGWM2016CW-Regular',74),(14,'manufacturer','GEWSM2420D3WW-PermPress',75),(15,'manufacturer','GEWSM2420D3WW-Timed',76),(16,'manufacturer','LGWM2016CW-PermPress',78),(17,'manufacturer','LGWM2016CW-Delicates',79),(18,'executionType','single_run',74),(19,'executionType','single_run',78),(20,'executionType','single_run',79),(21,'manufacturer','Bryant 697CN030B_AirCond',81),(22,'manufacturer','LG LW1212ER _AirCond',82),(23,'manufacturer','E52-50R-045DV_waterheater',83),(24,'manufacturer','Kenmore 790.91312013_ovenSmall',84),(25,'manufacturer','Kenmore 790.91312013_ovenLarge',85),(26,'manufacturer','Kenmore 790.91312013_ovenBake',86);
/*!40000 ALTER TABLE `template_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `templates`
--

DROP TABLE IF EXISTS `templates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `templates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `type` int(11) DEFAULT NULL,
  `datatype` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_trial_id_1_idx` (`type`),
  CONSTRAINT `fk_trial_id_1` FOREIGN KEY (`type`) REFERENCES `device_type` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=88 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `templates`
--

LOCK TABLES `templates` WRITE;
/*!40000 ALTER TABLE `templates` DISABLE KEYS */;
INSERT INTO `templates` VALUES (1,'10318',3,NULL),(2,'11288',3,NULL),(3,'12374',3,NULL),(4,'12664',3,NULL),(5,'1444',3,NULL),(6,'14598',3,NULL),(7,'15087',3,NULL),(8,'15128',3,NULL),(9,'15529',3,NULL),(10,'15844',3,NULL),(11,'16100',3,NULL),(12,'16273',3,NULL),(13,'325',3,NULL),(14,'3355',3,NULL),(15,'5815',3,NULL),(16,'5819',3,NULL),(17,'6449',3,NULL),(18,'7643',3,NULL),(19,'8348',3,NULL),(20,'8537',3,NULL),(21,'8784',3,NULL),(22,'8902',3,NULL),(23,'8975',3,NULL),(24,'8998',3,NULL),(25,'9303',3,NULL),(26,'9650',3,NULL),(27,'CS14',3,'hist'),(28,'CS1',3,'hist'),(29,'CS15',3,'hist'),(30,'CS6',3,'hist'),(31,'CS16',3,'hist'),(32,'CS2',3,'hist'),(33,'CS17',3,'hist'),(34,'CS18',3,'hist'),(35,'CS19',3,'hist'),(36,'CS3',3,'hist'),(37,'CS20',3,'hist'),(38,'CS9',3,'hist'),(39,'CS7',3,'hist'),(40,'CS4',3,'hist'),(41,'CS5',3,'hist'),(42,'dw1',5,'samples'),(43,'virginia d',5,'samples'),(44,'CS14',4,'hist'),(45,'CS1',4,'hist'),(46,'CS15',4,'hist'),(47,'CS6',4,'hist'),(48,'CS16',4,'hist'),(49,'CS2',4,'hist'),(50,'CS17',4,'hist'),(51,'CS18',4,'hist'),(52,'CS19',4,'hist'),(53,'CS3',4,'hist'),(54,'CS20',4,'hist'),(55,'CS9',4,'hist'),(56,'CS7',4,'hist'),(57,'CS4',4,'hist'),(58,'CS5',4,'hist'),(59,'simplebulb',2,NULL),(60,'fridge1',6,'periodic'),(61,'freezer1',7,NULL),(62,'boiler1',8,NULL),(63,'TV1',9,NULL),(64,'video1',10,NULL),(65,'PC1',11,NULL),(66,'washm1',12,NULL),(69,'dw3',5,'dish_hist'),(70,'bulb1',2,NULL),(71,'dw4',5,'virgin'),(72,'wm4',12,'virgin'),(73,'GEWSM2420D3WW-Regular',16,'SAMPLES'),(74,'LGWM2016CW-Regular',12,'SAMPLES'),(75,'GEWSM2420D3WW-PermPress',16,'SAMPLES'),(76,'GEWSM2420D3WW-Timed',16,'SAMPLES'),(78,'LGWM2016CW-PermPress',12,'SAMPLES'),(79,'LGWM2016CW-Delicates',12,'SAMPLES'),(80,'HTR16ABSRW',6,'virgin'),(81,'Bryant 697CN030B_AirCond',18,'SAMPLES'),(82,'LG LW1212ER _AirCond',18,'SAMPLES'),(83,'E52-50R-045DV_waterheater',19,'SAMPLES'),(84,'Kenmore 790.91312013_ovenSmall',20,'SAMPLES'),(85,'Kenmore 790.91312013_ovenLarge',20,'SAMPLES'),(86,'Kenmore 790.91312013_ovenBake',20,'SAMPLES'),(87,'zero',21,'zero');
/*!40000 ALTER TABLE `templates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `trial_consume`
--

DROP TABLE IF EXISTS `trial_consume`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `trial_consume` (
  `user_id` varchar(30) NOT NULL,
  `zone` varchar(2) NOT NULL,
  `month` varchar(15) NOT NULL,
  `power` float NOT NULL,
  PRIMARY KEY (`user_id`,`zone`,`month`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `trial_consume`
--

LOCK TABLES `trial_consume` WRITE;
/*!40000 ALTER TABLE `trial_consume` DISABLE KEYS */;
INSERT INTO `trial_consume` VALUES ('amaldi','F1','april',7.68595),('amaldi','F1','august',4.30992),('amaldi','F1','december',10.3967),('amaldi','F1','february',12.0136),('amaldi','F1','january',11.2652),('amaldi','F1','july',6.89328),('amaldi','F1','june',7.35909),('amaldi','F1','march',10.4026),('amaldi','F1','may',8.32411),('amaldi','F1','november',11.2727),('amaldi','F1','october',4.42292),('amaldi','F1','september',7.45887),('amaldi','F2','april',5.83908),('amaldi','F2','august',4.47368),('amaldi','F2','december',8.22414),('amaldi','F2','february',7.43902),('amaldi','F2','january',7.28804),('amaldi','F2','july',5.60335),('amaldi','F2','june',6.17222),('amaldi','F2','march',6.91351),('amaldi','F2','may',6.20112),('amaldi','F2','november',9.27027),('amaldi','F2','october',3.06145),('amaldi','F2','september',6.09467),('amaldi','F3','april',3.13152),('amaldi','F3','august',2.57307),('amaldi','F3','december',4.89124),('amaldi','F3','february',11.5005),('amaldi','F3','january',8.9666),('amaldi','F3','july',3.25678),('amaldi','F3','june',3.36326),('amaldi','F3','march',2.71869),('amaldi','F3','may',2.59959),('amaldi','F3','november',3.78606),('amaldi','F3','october',1.51307),('amaldi','F3','september',3.2958),('andreozzi','F1','april',7.84711),('andreozzi','F1','august',4.40083),('andreozzi','F1','december',10.6198),('andreozzi','F1','february',12.2636),('andreozzi','F1','january',11.5),('andreozzi','F1','july',7.03953),('andreozzi','F1','june',7.50909),('andreozzi','F1','march',10.619),('andreozzi','F1','may',8.49802),('andreozzi','F1','november',11.5065),('andreozzi','F1','october',4.51779),('andreozzi','F1','september',7.61472),('andreozzi','F2','april',5.62069),('andreozzi','F2','august',4.31053),('andreozzi','F2','december',7.97126),('andreozzi','F2','february',7.16463),('andreozzi','F2','january',7.0163),('andreozzi','F2','july',5.39665),('andreozzi','F2','june',5.94444),('andreozzi','F2','march',6.65946),('andreozzi','F2','may',5.97207),('andreozzi','F2','november',8.92973),('andreozzi','F2','october',2.94972),('andreozzi','F2','september',5.86982),('andreozzi','F3','april',5.10708),('andreozzi','F3','august',4.74825),('andreozzi','F3','december',7.39274),('andreozzi','F3','february',5.10897),('andreozzi','F3','january',5.37771),('andreozzi','F3','july',5.25871),('andreozzi','F3','june',5.04225),('andreozzi','F3','march',4.70558),('andreozzi','F3','may',4.86382),('andreozzi','F3','november',7.07084),('andreozzi','F3','october',2.44315),('andreozzi','F3','september',5.02347),('bachelet','F1','april',19.219),('bachelet','F1','august',10.7769),('bachelet','F1','december',25.9959),('bachelet','F1','february',30.0409),('bachelet','F1','january',28.1629),('bachelet','F1','july',17.2411),('bachelet','F1','june',18.3955),('bachelet','F1','march',26.0087),('bachelet','F1','may',20.8103),('bachelet','F1','november',28.1818),('bachelet','F1','october',11.0632),('bachelet','F1','september',18.6494),('bachelet','F2','april',5.83908),('bachelet','F2','august',4.47368),('bachelet','F2','december',8.22414),('bachelet','F2','february',7.43902),('bachelet','F2','january',7.28804),('bachelet','F2','july',5.60335),('bachelet','F2','june',6.17222),('bachelet','F2','march',6.91351),('bachelet','F2','may',6.20112),('bachelet','F2','november',9.27027),('bachelet','F2','october',3.06145),('bachelet','F2','september',6.09467),('bachelet','F3','april',5.10708),('bachelet','F3','august',4.74825),('bachelet','F3','december',7.39274),('bachelet','F3','february',5.10897),('bachelet','F3','january',5.37771),('bachelet','F3','july',5.25871),('bachelet','F3','june',5.04225),('bachelet','F3','march',4.70558),('bachelet','F3','may',4.86382),('bachelet','F3','november',7.07084),('bachelet','F3','october',2.44315),('bachelet','F3','september',5.02347),('buonarroti','F1','april',8.80579),('buonarroti','F1','august',4.93802),('buonarroti','F1','december',11.9132),('buonarroti','F1','february',13.7682),('buonarroti','F1','january',12.9053),('buonarroti','F1','july',7.90514),('buonarroti','F1','june',8.43182),('buonarroti','F1','march',11.9177),('buonarroti','F1','may',9.53755),('buonarroti','F1','november',12.9134),('buonarroti','F1','october',5.07115),('buonarroti','F1','september',8.54545),('buonarroti','F2','april',6.27011),('buonarroti','F2','august',4.80526),('buonarroti','F2','december',8.83333),('buonarroti','F2','february',7.9939),('buonarroti','F2','january',7.82609),('buonarroti','F2','july',6.02235),('buonarroti','F2','june',6.62778),('buonarroti','F2','march',7.42703),('buonarroti','F2','may',6.6648),('buonarroti','F2','november',9.95676),('buonarroti','F2','october',3.28492),('buonarroti','F2','september',6.54438),('buonarroti','F3','april',5.82208),('buonarroti','F3','august',5.41281),('buonarroti','F3','december',8.42791),('buonarroti','F3','february',5.82193),('buonarroti','F3','january',6.12896),('buonarroti','F3','july',5.9939),('buonarroti','F3','june',5.74648),('buonarroti','F3','march',5.3621),('buonarroti','F3','may',5.54444),('buonarroti','F3','november',8.05931),('buonarroti','F3','october',2.78346),('buonarroti','F3','september',5.7277),('conte','F1','april',9.60744),('conte','F1','august',5.38843),('conte','F1','december',12.9959),('conte','F1','february',15.0182),('conte','F1','january',14.0795),('conte','F1','july',8.62055),('conte','F1','june',9.19545),('conte','F1','march',13.0043),('conte','F1','may',10.4032),('conte','F1','november',14.0909),('conte','F1','october',5.52964),('conte','F1','september',9.32468),('conte','F2','april',6.45402),('conte','F2','august',4.97368),('conte','F2','december',9.13793),('conte','F2','february',8.26829),('conte','F2','january',8.09783),('conte','F2','july',6.22905),('conte','F2','june',6.86111),('conte','F2','march',7.68649),('conte','F2','may',6.89385),('conte','F2','november',10.3027),('conte','F2','october',3.40223),('conte','F2','september',6.77515),('conte','F3','april',5.92422),('conte','F3','august',5.50912),('conte','F3','december',8.57448),('conte','F3','february',5.92627),('conte','F3','january',6.23539),('conte','F3','july',6.09984),('conte','F3','june',5.84664),('conte','F3','march',5.45677),('conte','F3','may',5.64075),('conte','F3','november',8.20099),('conte','F3','october',2.83161),('conte','F3','september',5.82786),('ferraris','F1','april',7.68595),('ferraris','F1','august',4.30992),('ferraris','F1','december',10.3967),('ferraris','F1','february',12.0136),('ferraris','F1','january',11.2652),('ferraris','F1','july',6.89328),('ferraris','F1','june',7.35909),('ferraris','F1','march',10.4026),('ferraris','F1','may',8.32411),('ferraris','F1','november',11.2727),('ferraris','F1','october',4.42292),('ferraris','F1','september',7.45887),('ferraris','F2','april',5.72989),('ferraris','F2','august',4.38947),('ferraris','F2','december',8.06897),('ferraris','F2','february',7.30488),('ferraris','F2','january',7.15217),('ferraris','F2','july',5.50279),('ferraris','F2','june',6.05556),('ferraris','F2','march',6.78919),('ferraris','F2','may',6.08939),('ferraris','F2','november',9.0973),('ferraris','F2','october',3),('ferraris','F2','september',5.98225),('ferraris','F3','april',5.10708),('ferraris','F3','august',4.74825),('ferraris','F3','december',7.39274),('ferraris','F3','february',5.10897),('ferraris','F3','january',5.37771),('ferraris','F3','july',5.25871),('ferraris','F3','june',5.04225),('ferraris','F3','march',4.70558),('ferraris','F3','may',4.86382),('ferraris','F3','november',7.07084),('ferraris','F3','october',2.44315),('ferraris','F3','september',5.02347),('garofalo','F1','april',23.781),('garofalo','F1','august',11.3967),('garofalo','F1','december',27.905),('garofalo','F1','february',32.6045),('garofalo','F1','january',30.4962),('garofalo','F1','july',17.3043),('garofalo','F1','june',20.6136),('garofalo','F1','march',28.9481),('garofalo','F1','may',24.083),('garofalo','F1','november',32.1732),('garofalo','F1','october',29.83),('garofalo','F1','september',24.8009),('garofalo','F2','april',5.83908),('garofalo','F2','august',4.47368),('garofalo','F2','december',8.22414),('garofalo','F2','february',7.43902),('garofalo','F2','january',7.28804),('garofalo','F2','july',5.60335),('garofalo','F2','june',6.17222),('garofalo','F2','march',6.91351),('garofalo','F2','may',6.20112),('garofalo','F2','november',9.27027),('garofalo','F2','october',3.06145),('garofalo','F2','september',6.09467),('garofalo','F3','april',5.10708),('garofalo','F3','august',4.74825),('garofalo','F3','december',7.39274),('garofalo','F3','february',5.10897),('garofalo','F3','january',5.37771),('garofalo','F3','july',5.25871),('garofalo','F3','june',5.04225),('garofalo','F3','march',4.70558),('garofalo','F3','may',4.86382),('garofalo','F3','november',7.07084),('garofalo','F3','october',2.44315),('garofalo','F3','september',5.02347),('giordani','F1','april',7.84711),('giordani','F1','august',4.40083),('giordani','F1','december',10.6157),('giordani','F1','february',12.2636),('giordani','F1','january',11.5),('giordani','F1','july',7.03953),('giordani','F1','june',7.50909),('giordani','F1','march',10.619),('giordani','F1','may',8.49802),('giordani','F1','november',11.5065),('giordani','F1','october',4.51779),('giordani','F1','september',7.61472),('giordani','F2','april',5.72989),('giordani','F2','august',4.38947),('giordani','F2','december',8.06897),('giordani','F2','february',7.30488),('giordani','F2','january',7.15217),('giordani','F2','july',5.50279),('giordani','F2','june',6.05556),('giordani','F2','march',6.78919),('giordani','F2','may',6.08939),('giordani','F2','november',9.0973),('giordani','F2','october',3),('giordani','F2','september',5.98225),('giordani','F3','april',5.20923),('giordani','F3','august',4.84456),('giordani','F3','december',7.53931),('giordani','F3','february',5.20983),('giordani','F3','january',5.48414),('giordani','F3','july',5.36144),('giordani','F3','june',5.14241),('giordani','F3','march',4.79719),('giordani','F3','may',4.96014),('giordani','F3','november',7.20923),('giordani','F3','october',2.49131),('giordani','F3','september',5.12363),('leonardodavinci','F1','april',4.80165),('leonardodavinci','F1','august',2.69421),('leonardodavinci','F1','december',6.49587),('leonardodavinci','F1','february',7.50909),('leonardodavinci','F1','january',7.03788),('leonardodavinci','F1','july',4.3083),('leonardodavinci','F1','june',4.59545),('leonardodavinci','F1','march',6.50216),('leonardodavinci','F1','may',5.20158),('leonardodavinci','F1','november',7.04329),('leonardodavinci','F1','october',2.76285),('leonardodavinci','F1','september',4.66234),('leonardodavinci','F2','april',3.24138),('leonardodavinci','F2','august',2.48421),('leonardodavinci','F2','december',4.56897),('leonardodavinci','F2','february',4.13415),('leonardodavinci','F2','january',4.04891),('leonardodavinci','F2','july',3.11173),('leonardodavinci','F2','june',3.42778),('leonardodavinci','F2','march',3.84324),('leonardodavinci','F2','may',3.44693),('leonardodavinci','F2','november',5.15135),('leonardodavinci','F2','october',1.69832),('leonardodavinci','F2','september',3.38462),('leonardodavinci','F3','april',3.06425),('leonardodavinci','F3','august',2.84766),('leonardodavinci','F3','december',4.43381),('leonardodavinci','F3','february',3.06399),('leonardodavinci','F3','january',3.22412),('leonardodavinci','F3','july',3.15266),('leonardodavinci','F3','june',3.02347),('leonardodavinci','F3','march',2.82152),('leonardodavinci','F3','may',2.91829),('leonardodavinci','F3','november',4.24053),('leonardodavinci','F3','october',1.46396),('leonardodavinci','F3','september',3.01408),('manzoni','F1','april',7.77686),('manzoni','F1','august',6.50826),('manzoni','F1','december',10.9504),('manzoni','F1','february',12.5182),('manzoni','F1','january',11.7348),('manzoni','F1','july',7.34783),('manzoni','F1','june',9.35455),('manzoni','F1','march',10.8355),('manzoni','F1','may',8.13043),('manzoni','F1','november',13.7532),('manzoni','F1','october',4.01186),('manzoni','F1','september',8.25974),('manzoni','F2','april',17.8218),('manzoni','F2','august',15.5737),('manzoni','F2','december',27.8333),('manzoni','F2','february',17.9146),('manzoni','F2','january',18.6739),('manzoni','F2','july',18.3017),('manzoni','F2','june',17.9),('manzoni','F2','march',16.6595),('manzoni','F2','may',16.933),('manzoni','F2','november',23.2),('manzoni','F2','october',8.50279),('manzoni','F2','september',19),('manzoni','F3','april',5.20923),('manzoni','F3','august',4.84456),('manzoni','F3','december',7.53931),('manzoni','F3','february',5.20983),('manzoni','F3','january',5.48414),('manzoni','F3','july',5.36144),('manzoni','F3','june',5.14241),('manzoni','F3','march',4.79719),('manzoni','F3','may',4.96014),('manzoni','F3','november',7.20923),('manzoni','F3','october',2.49131),('manzoni','F3','september',5.12363),('pavese','F1','april',7.68595),('pavese','F1','august',4.30992),('pavese','F1','december',10.3967),('pavese','F1','february',12.0136),('pavese','F1','january',11.2652),('pavese','F1','july',6.89328),('pavese','F1','june',7.35909),('pavese','F1','march',10.4026),('pavese','F1','may',8.32411),('pavese','F1','november',11.2727),('pavese','F1','october',4.42292),('pavese','F1','september',7.45887),('pavese','F2','april',5.83908),('pavese','F2','august',4.47368),('pavese','F2','december',8.22414),('pavese','F2','february',7.43902),('pavese','F2','january',7.28804),('pavese','F2','july',5.60335),('pavese','F2','june',6.17222),('pavese','F2','march',6.91351),('pavese','F2','may',6.20112),('pavese','F2','november',9.27027),('pavese','F2','october',3.06145),('pavese','F2','september',6.09467),('pavese','F3','april',5.10708),('pavese','F3','august',4.74825),('pavese','F3','december',7.39274),('pavese','F3','february',5.10897),('pavese','F3','january',5.37771),('pavese','F3','july',5.25871),('pavese','F3','june',5.04225),('pavese','F3','march',4.70558),('pavese','F3','may',4.86382),('pavese','F3','november',7.07084),('pavese','F3','october',2.44315),('pavese','F3','september',5.02347),('piscina','F1','april',89.843),('piscina','F1','august',88.9711),('piscina','F1','december',106.921),('piscina','F1','february',107.105),('piscina','F1','january',100.394),('piscina','F1','july',34.9289),('piscina','F1','june',72.9682),('piscina','F1','march',102.961),('piscina','F1','may',70.1621),('piscina','F1','november',94.0476),('piscina','F1','october',75.004),('piscina','F1','september',93.2078),('piscina','F2','april',95.5977),('piscina','F2','august',88.0421),('piscina','F2','december',103.178),('piscina','F2','february',105.988),('piscina','F2','january',101.011),('piscina','F2','july',38.3575),('piscina','F2','june',80.7667),('piscina','F2','march',97.3838),('piscina','F2','may',78.1452),('piscina','F2','november',91.7405),('piscina','F2','october',82.8212),('piscina','F2','september',98.9822),('piscina','F3','april',36.4086),('piscina','F3','august',37.6938),('piscina','F3','december',38.231),('piscina','F3','february',35.6898),('piscina','F3','january',33.1646),('piscina','F3','july',15.4711),('piscina','F3','june',29.7277),('piscina','F3','march',29.0854),('piscina','F3','may',31.7481),('piscina','F3','november',39.0445),('piscina','F3','october',38.0117),('piscina','F3','september',36.748),('quercia','F1','april',23.781),('quercia','F1','august',11.3967),('quercia','F1','december',27.905),('quercia','F1','february',32.6045),('quercia','F1','january',30.4962),('quercia','F1','july',17.3043),('quercia','F1','june',20.6136),('quercia','F1','march',28.9481),('quercia','F1','may',24.083),('quercia','F1','november',32.1732),('quercia','F1','october',29.83),('quercia','F1','september',24.8009),('quercia','F2','april',5.83908),('quercia','F2','august',4.47368),('quercia','F2','december',8.22414),('quercia','F2','february',7.43902),('quercia','F2','january',7.28804),('quercia','F2','july',5.60335),('quercia','F2','june',6.17222),('quercia','F2','march',6.91351),('quercia','F2','may',6.20112),('quercia','F2','november',9.27027),('quercia','F2','october',3.06145),('quercia','F2','september',6.09467),('quercia','F3','april',5.10708),('quercia','F3','august',4.74825),('quercia','F3','december',7.39274),('quercia','F3','february',5.10897),('quercia','F3','january',5.37771),('quercia','F3','july',5.25871),('quercia','F3','june',5.04225),('quercia','F3','march',4.70558),('quercia','F3','may',4.86382),('quercia','F3','november',7.07084),('quercia','F3','october',2.44315),('quercia','F3','september',5.02347),('terradilavoro','F1','april',12.8099),('terradilavoro','F1','august',7.18595),('terradilavoro','F1','december',17.3306),('terradilavoro','F1','february',20.0273),('terradilavoro','F1','january',18.7727),('terradilavoro','F1','july',11.4941),('terradilavoro','F1','june',12.2636),('terradilavoro','F1','march',17.3377),('terradilavoro','F1','may',13.8735),('terradilavoro','F1','november',18.7879),('terradilavoro','F1','october',7.37549),('terradilavoro','F1','september',12.4329),('terradilavoro','F2','april',8.97701),('terradilavoro','F2','august',6.87895),('terradilavoro','F2','december',12.6379),('terradilavoro','F2','february',11.439),('terradilavoro','F2','january',11.2011),('terradilavoro','F2','july',8.61452),('terradilavoro','F2','june',9.48889),('terradilavoro','F2','march',10.6324),('terradilavoro','F2','may',9.53631),('terradilavoro','F2','november',14.2486),('terradilavoro','F2','october',4.70391),('terradilavoro','F2','september',9.36686),('terradilavoro','F3','april',8.37562),('terradilavoro','F3','august',7.78854),('terradilavoro','F3','december',12.1258),('terradilavoro','F3','february',8.37816),('terradilavoro','F3','january',8.81782),('terradilavoro','F3','july',8.62325),('terradilavoro','F3','june',8.26917),('terradilavoro','F3','march',7.71642),('terradilavoro','F3','may',7.97795),('terradilavoro','F3','november',11.5947),('terradilavoro','F3','october',4.00663),('terradilavoro','F3','september',8.241),('ugofoscolo','F1','april',8.89669),('ugofoscolo','F1','august',4.9876),('ugofoscolo','F1','december',12.0331),('ugofoscolo','F1','february',13.9091),('ugofoscolo','F1','january',13.0379),('ugofoscolo','F1','july',7.98024),('ugofoscolo','F1','june',8.51364),('ugofoscolo','F1','march',12.039),('ugofoscolo','F1','may',9.63241),('ugofoscolo','F1','november',13.0433),('ugofoscolo','F1','october',5.12253),('ugofoscolo','F1','september',8.63203),('ugofoscolo','F2','april',6.00575),('ugofoscolo','F2','august',4.60526),('ugofoscolo','F2','december',8.45977),('ugofoscolo','F2','february',7.65854),('ugofoscolo','F2','january',7.5),('ugofoscolo','F2','july',5.76536),('ugofoscolo','F2','june',6.35),('ugofoscolo','F2','march',7.11351),('ugofoscolo','F2','may',6.37989),('ugofoscolo','F2','november',9.54054),('ugofoscolo','F2','october',3.14525),('ugofoscolo','F2','september',6.27219),('ugofoscolo','F3','april',5.67381),('ugofoscolo','F3','august',5.27476),('ugofoscolo','F3','december',8.82488),('ugofoscolo','F3','february',5.67586),('ugofoscolo','F3','january',5.97245),('ugofoscolo','F3','july',5.84301),('ugofoscolo','F3','june',5.6025),('ugofoscolo','F3','march',5.22775),('ugofoscolo','F3','may',5.40318),('ugofoscolo','F3','november',7.85502),('ugofoscolo','F3','october',2.71283),('ugofoscolo','F3','september',5.58059);
/*!40000 ALTER TABLE `trial_consume` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `trial_identity`
--

DROP TABLE IF EXISTS `trial_identity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `trial_identity` (
  `user_id` varchar(30) NOT NULL,
  `user_code` varchar(10) NOT NULL,
  PRIMARY KEY (`user_code`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `trial_identity`
--

LOCK TABLES `trial_identity` WRITE;
/*!40000 ALTER TABLE `trial_identity` DISABLE KEYS */;
INSERT INTO `trial_identity` VALUES ('amaldi','CS14'),('andreozzi','CS1'),('bachelet','CS15'),('buonarroti','CS6'),('conte','CS16'),('ferraris','CS2'),('garofalo','CS17'),('giordani','CS18'),('leonardodavinci','CS19'),('manzoni','CS3'),('pavese','CS20'),('piscina','CS9'),('quercia','CS7'),('terradilavoro','CS4'),('ugofoscolo','CS5');
/*!40000 ALTER TABLE `trial_identity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `idusers` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(45) NOT NULL,
  `password` varchar(45) NOT NULL,
  PRIMARY KEY (`idusers`),
  UNIQUE KEY `username_UNIQUE` (`username`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (1,'1','user1'),(2,'2','due'),(3,'3','tre');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2014-11-13 20:42:27
